;* --------------------------------------------------------------------*/
;*    Copyright (c) 1992-1998 by Manuel Serrano. All rights reserved.  */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \   /  '                               */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome. Send them to                                          */
;*        Manuel Serrano -- Manuel.Serrano@unice.fr                    */
;*-------------------------------------------------------------------- */
;*=====================================================================*/
;*    serrano/prgm/project/cigloo/Write/version.scm                    */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Sun Mar 12 14:03:51 1995                          */
;*    Last change :  Fri Dec  1 10:11:31 1995 (serrano)                */
;*    -------------------------------------------------------------    */
;*    La version de Bigloo.                                            */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    Le module                                                        */
;*---------------------------------------------------------------------*/
(module write_version 
   (import engine_param
	   tools_speek)
   (export (version)
	   (short-version)))

;*---------------------------------------------------------------------*/
;*    short-version ...                                                */
;*---------------------------------------------------------------------*/
(define (short-version)
   (print *cigloo-name* (if (char? *cigloo-level*)
			    (let ((s " (level 0)"))
			       (string-set! s 8 *cigloo-level*)
			       s)
			    "")))

;*---------------------------------------------------------------------*/
;*    version ...                                                      */
;*---------------------------------------------------------------------*/
(define (version)
   (display-to-column "" 79 #\-)
   (newline)
   (cat (string-append *cigloo-name* (if (char? *cigloo-level*)
					(let ((s " (level 0)"))
					   (string-set! s 8 *cigloo-level*)
					   s)
					""))
	"a `C->Bigloo' translator"
	(if (char=? (string-ref *cigloo-date* 0) #\space)
	    (substring *cigloo-date* 1 (string-length *cigloo-date*))
	    *cigloo-date*)
	*cigloo-author*
	"email:"
	*cigloo-email*)
   (display-to-column "" 79 #\-)
   (newline)
   (newline))

;*---------------------------------------------------------------------*/
;*    cat ...                                                          */
;*---------------------------------------------------------------------*/
(define (cat . l)
   (let loop ((l     l)
	      (cat '("   (\"`-/\")_.-'\"``-._"
		     "    . . `; -._    )-;-,_`)"
		     "    v   '  _  )`-.\\  ``-'"
		     "  _.- _..-_/ / ((.'"
		     "((,.-'   ((,/"
		     "")))
      (cond
	 ((null? l)
	  (if (null? cat)
	      'done
	      (begin
		 (display-to-column "" 53 #\space)
		 (print (car cat))
		 (loop '() (cdr cat)))))
	 ((null? cat)
	  (print (car l))
	  (loop (cdr l) '()))
	 (else
	  (display-to-column (car l) 53 #\space)
	  (print (car cat))
	  (loop (cdr l) (cdr cat))))))

;*---------------------------------------------------------------------*/
;*    display-to-column ...                                            */
;*---------------------------------------------------------------------*/
(define (display-to-column string column char)
   (display string)
   (let loop ((l (+fx 1 (string-length string))))
      (if (=fx l column)
	  'done
	  (begin
	     (write-char char)
	     (loop (+fx l 1))))))   
      
