/*===========================================================================*/
/*   (Ast/alphatize.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern local_t make_local_sexit_184_ast_local(obj_t, type_t, sexit_t);
static obj_t __location__189_ast_alphatize = BUNSPEC;
extern obj_t let_fun_218_ast_node;
static obj_t get_location_95_ast_alphatize(obj_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fun_ast_var;
extern obj_t closure_ast_node;
extern obj_t _alphatize_ast_alphatize(obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_ast_alphatize();
extern obj_t module_initialization_70_ast_alphatize(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_apply(long, char *);
extern obj_t module_initialization_70_ast_app(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t sexit_ast_var;
static obj_t toplevel_init_63_ast_alphatize();
static obj_t cnst_init_137_ast_alphatize();
extern node_t make_app_node_80_ast_app(obj_t, obj_t, var_t, obj_t);
static obj_t _do_alphatize_43_ast_alphatize(obj_t, obj_t);
static obj_t require_initialization_114_ast_alphatize = BUNSPEC;
extern obj_t var_ast_node;
static obj_t _do_alphatize_default1377_176_ast_alphatize(obj_t, obj_t);
static obj_t library_modules_init_112_ast_alphatize();
extern obj_t sfun_ast_var;
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t variable_ast_var;
extern obj_t cast_ast_node;
extern node_t known_app_ly__node_26_ast_apply(obj_t, obj_t, node_t, node_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern long class_num_218___object(obj_t);
static node_t do_alphatize_default1377_128_ast_alphatize(node_t);
extern local_t make_local_sfun_184_ast_local(obj_t, type_t, sfun_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static node_t do_alphatize_126_ast_alphatize(node_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t kwote_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t use_variable__4_ast_sexp(variable_t, obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
extern bool_t correct_arity_app__187_ast_app(variable_t, obj_t);
extern node_t alphatize_ast_alphatize(obj_t, obj_t, obj_t, node_t);
extern obj_t app_ast_node;
static obj_t __cnst[4];

DEFINE_STRING(string1990_ast_alphatize, string1990_ast_alphatize2001, "No method for this object", 25);
DEFINE_STATIC_GENERIC(do_alphatize_env_178_ast_alphatize, _do_alphatize_43_ast_alphatize2002, _do_alphatize_43_ast_alphatize, 0L, 1);
DEFINE_STATIC_PROCEDURE(do_alphatize_default1377_env_80_ast_alphatize, _do_alphatize_default1377_176_ast_alphatize2003, _do_alphatize_default1377_176_ast_alphatize, 0L, 1);
DEFINE_STRING(string1991_ast_alphatize, string1991_ast_alphatize2004, "alphatize", 9);
DEFINE_STRING(string1995_ast_alphatize, string1995_ast_alphatize2005, "SET! VALUE DO-ALPHATIZE-DEFAULT1377 LOCATION ", 45);
DEFINE_STRING(string1994_ast_alphatize, string1994_ast_alphatize2006, "wrong number of argument(s)", 27);
DEFINE_STRING(string1992_ast_alphatize, string1992_ast_alphatize2007, "Illegal alphatization", 21);
DEFINE_STRING(string1993_ast_alphatize, string1993_ast_alphatize2008, "Illegal application", 19);
DEFINE_EXPORT_PROCEDURE(alphatize_env_10_ast_alphatize, _alphatize_ast_alphatize2009, _alphatize_ast_alphatize, 0L, 4);

obj_t 
module_initialization_70_ast_alphatize(long checksum_2520, char *from_2521)
{
   if (CBOOL(require_initialization_114_ast_alphatize))
     {
	require_initialization_114_ast_alphatize = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_alphatize();
	cnst_init_137_ast_alphatize();
	imported_modules_init_94_ast_alphatize();
	toplevel_init_63_ast_alphatize();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_alphatize()
{
   module_initialization_70___object(((long) 0), "AST_ALPHATIZE");
   module_initialization_70___reader(((long) 0), "AST_ALPHATIZE");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_ALPHATIZE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_alphatize()
{
   {
      obj_t cnst_port_138_2512;
      cnst_port_138_2512 = open_input_string(string1995_ast_alphatize);
      {
	 long i_2513;
	 i_2513 = ((long) 3);
       loop_2514:
	 {
	    bool_t test1996_2515;
	    test1996_2515 = (i_2513 == ((long) -1));
	    if (test1996_2515)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1997_2516;
		    {
		       obj_t list1998_2517;
		       {
			  obj_t arg1999_2518;
			  arg1999_2518 = BNIL;
			  list1998_2517 = MAKE_PAIR(cnst_port_138_2512, arg1999_2518);
		       }
		       arg1997_2516 = read___reader(list1998_2517);
		    }
		    CNST_TABLE_SET(i_2513, arg1997_2516);
		 }
		 {
		    int aux_2519;
		    {
		       long aux_2538;
		       aux_2538 = (i_2513 - ((long) 1));
		       aux_2519 = (int) (aux_2538);
		    }
		    {
		       long i_2541;
		       i_2541 = (long) (aux_2519);
		       i_2513 = i_2541;
		       goto loop_2514;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_alphatize()
{
   __location__189_ast_alphatize = BFALSE;
   add_generic__110___object(do_alphatize_env_178_ast_alphatize, do_alphatize_default1377_env_80_ast_alphatize);
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, var_ast_node, ((long) 1));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, closure_ast_node, ((long) 2));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, kwote_ast_node, ((long) 3));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, app_ast_node, ((long) 5));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, app_ly_162_ast_node, ((long) 6));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, funcall_ast_node, ((long) 7));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, pragma_ast_node, ((long) 8));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, cast_ast_node, ((long) 9));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, setq_ast_node, ((long) 10));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, conditional_ast_node, ((long) 11));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, fail_ast_node, ((long) 12));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, select_ast_node, ((long) 13));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, make_box_202_ast_node, ((long) 14));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, box_ref_242_ast_node, ((long) 15));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, box_set__221_ast_node, ((long) 16));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, let_fun_218_ast_node, ((long) 17));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, let_var_6_ast_node, ((long) 18));
   add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, set_ex_it_116_ast_node, ((long) 19));
   {
      long aux_2564;
      aux_2564 = add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, jump_ex_it_184_ast_node, ((long) 20));
      return BINT(aux_2564);
   }
}


node_t 
alphatize_ast_alphatize(obj_t what__148_11, obj_t by__251_12, obj_t loc_13, node_t node_14)
{
   {
      obj_t ll1272_685;
      obj_t ll1273_686;
      ll1272_685 = what__148_11;
      ll1273_686 = by__251_12;
    lname1283_687:
      if (NULLP(ll1272_685))
	{
	   ((bool_t) 1);
	}
      else
	{
	   {
	      obj_t by_690;
	      by_690 = CAR(ll1273_686);
	      {
		 obj_t res1952_1520;
		 {
		    variable_t obj_1518;
		    {
		       obj_t aux_2570;
		       aux_2570 = CAR(ll1272_685);
		       obj_1518 = (variable_t) (aux_2570);
		    }
		    {
		       obj_t x_2509;
		       x_2509 = ((((variable_t) CREF(obj_1518))->fast_alpha_7) = ((obj_t) by_690), BUNSPEC);
		       res1952_1520 = BUNSPEC;
		    }
		 }
		 res1952_1520;
	      }
	   }
	   {
	      obj_t ll1273_2576;
	      obj_t ll1272_2574;
	      ll1272_2574 = CDR(ll1272_685);
	      ll1273_2576 = CDR(ll1273_686);
	      ll1273_686 = ll1273_2576;
	      ll1272_685 = ll1272_2574;
	      goto lname1283_687;
	   }
	}
   }
   __location__189_ast_alphatize = loc_13;
   {
      node_t res_693;
      res_693 = do_alphatize_126_ast_alphatize(node_14);
      {
	 obj_t l1284_694;
	 l1284_694 = what__148_11;
       lname1285_695:
	 if (PAIRP(l1284_694))
	   {
	      {
		 obj_t res1953_1527;
		 {
		    variable_t obj_1525;
		    {
		       obj_t aux_2581;
		       aux_2581 = CAR(l1284_694);
		       obj_1525 = (variable_t) (aux_2581);
		    }
		    {
		       obj_t x_2510;
		       x_2510 = ((((variable_t) CREF(obj_1525))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
		       res1953_1527 = BUNSPEC;
		    }
		 }
		 res1953_1527;
	      }
	      {
		 obj_t l1284_2585;
		 l1284_2585 = CDR(l1284_694);
		 l1284_694 = l1284_2585;
		 goto lname1285_695;
	      }
	   }
	 else
	   {
	      ((bool_t) 1);
	   }
      }
      return res_693;
   }
}


obj_t 
_alphatize_ast_alphatize(obj_t env_2503, obj_t what__148_2504, obj_t by__251_2505, obj_t loc_2506, obj_t node_2507)
{
   {
      node_t aux_2587;
      aux_2587 = alphatize_ast_alphatize(what__148_2504, by__251_2505, loc_2506, (node_t) (node_2507));
      return (obj_t) (aux_2587);
   }
}


obj_t 
get_location_95_ast_alphatize(obj_t node_15)
{
   {
      bool_t test_2591;
      {
	 obj_t arg1446_700;
	 {
	    node_t obj_1529;
	    obj_1529 = (node_t) (node_15);
	    arg1446_700 = (((node_t) CREF(obj_1529))->loc);
	 }
	 if (STRUCTP(arg1446_700))
	   {
	      obj_t aux_2598;
	      obj_t aux_2596;
	      aux_2598 = CNST_TABLE_REF(((long) 0));
	      aux_2596 = STRUCT_KEY(arg1446_700);
	      test_2591 = (aux_2596 == aux_2598);
	   }
	 else
	   {
	      test_2591 = ((bool_t) 0);
	   }
      }
      if (test_2591)
	{
	   node_t obj_1538;
	   obj_1538 = (node_t) (node_15);
	   return (((node_t) CREF(obj_1538))->loc);
	}
      else
	{
	   return __location__189_ast_alphatize;
	}
   }
}


node_t 
do_alphatize_default1377_128_ast_alphatize(node_t node_17)
{
   FAILURE(CNST_TABLE_REF(((long) 1)), string1990_ast_alphatize, (obj_t) (node_17));
}


obj_t 
_do_alphatize_default1377_176_ast_alphatize(obj_t env_2501, obj_t node_2502)
{
   {
      node_t aux_2606;
      aux_2606 = do_alphatize_default1377_128_ast_alphatize((node_t) (node_2502));
      return (obj_t) (aux_2606);
   }
}


node_t 
do_alphatize_126_ast_alphatize(node_t node_16)
{
   {
      obj_t method1555_1017;
      obj_t class1560_1018;
      {
	 obj_t arg1563_1015;
	 obj_t arg1564_1016;
	 {
	    object_t obj_1544;
	    obj_1544 = (object_t) (node_16);
	    {
	       obj_t pre_method_105_1545;
	       pre_method_105_1545 = PROCEDURE_REF(do_alphatize_env_178_ast_alphatize, ((long) 2));
	       if (INTEGERP(pre_method_105_1545))
		 {
		    PROCEDURE_SET(do_alphatize_env_178_ast_alphatize, ((long) 2), BUNSPEC);
		    arg1563_1015 = pre_method_105_1545;
		 }
	       else
		 {
		    long obj_class_num_177_1550;
		    obj_class_num_177_1550 = TYPE(obj_1544);
		    {
		       obj_t arg1183_1551;
		       arg1183_1551 = PROCEDURE_REF(do_alphatize_env_178_ast_alphatize, ((long) 1));
		       {
			  long arg1184_1555;
			  {
			     long arg1186_1556;
			     arg1186_1556 = OBJECT_TYPE;
			     arg1184_1555 = (obj_class_num_177_1550 - arg1186_1556);
			  }
			  arg1563_1015 = VECTOR_REF(arg1183_1551, arg1184_1555);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1561;
	    object_1561 = (object_t) (node_16);
	    {
	       long arg1187_1562;
	       {
		  long arg1188_1563;
		  long arg1189_1564;
		  arg1188_1563 = TYPE(object_1561);
		  arg1189_1564 = OBJECT_TYPE;
		  arg1187_1562 = (arg1188_1563 - arg1189_1564);
	       }
	       {
		  obj_t vector_1568;
		  vector_1568 = __classes__134___object;
		  arg1564_1016 = VECTOR_REF(vector_1568, arg1187_1562);
	       }
	    }
	 }
	 {
	    obj_t aux_2625;
	    method1555_1017 = arg1563_1015;
	    class1560_1018 = arg1564_1016;
	    {
	       if (INTEGERP(method1555_1017))
		 {
		    switch ((long) CINT(method1555_1017))
		      {
		      case ((long) 0):
			 {
			    atom_t node_1024;
			    node_1024 = (atom_t) (node_16);
			    {
			       obj_t arg1567_1026;
			       type_t arg1568_1027;
			       obj_t arg1570_1028;
			       arg1567_1026 = get_location_95_ast_alphatize((obj_t) (node_1024));
			       arg1568_1027 = (((atom_t) CREF(node_1024))->type);
			       arg1570_1028 = (((atom_t) CREF(node_1024))->value);
			       {
				  atom_t res1954_1582;
				  {
				     atom_t new1122_1575;
				     new1122_1575 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
				     {
					long arg1513_1576;
					arg1513_1576 = class_num_218___object(atom_ast_node);
					{
					   obj_t obj_1580;
					   obj_1580 = (obj_t) (new1122_1575);
					   (((obj_t) CREF(obj_1580))->header = MAKE_HEADER(arg1513_1576, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_2637;
					aux_2637 = (object_t) (new1122_1575);
					OBJECT_WIDENING_SET(aux_2637, BFALSE);
				     }
				     ((((atom_t) CREF(new1122_1575))->loc) = ((obj_t) arg1567_1026), BUNSPEC);
				     ((((atom_t) CREF(new1122_1575))->type) = ((type_t) arg1568_1027), BUNSPEC);
				     ((((atom_t) CREF(new1122_1575))->value) = ((obj_t) arg1570_1028), BUNSPEC);
				     res1954_1582 = new1122_1575;
				  }
				  aux_2625 = (obj_t) (res1954_1582);
			       }
			    }
			 }
			 break;
		      case ((long) 1):
			 {
			    var_t node_1029;
			    node_1029 = (var_t) (node_16);
			    {
			       variable_t var_1030;
			       var_1030 = (((var_t) CREF(node_1029))->variable);
			       {
				  obj_t alpha_1031;
				  alpha_1031 = (((variable_t) CREF(var_1030))->fast_alpha_7);
				  {
				     if ((alpha_1031 == BUNSPEC))
				       {
					  {
					     obj_t aux_2649;
					     {
						node_t obj_1587;
						obj_1587 = (node_t) (node_1029);
						aux_2649 = (((node_t) CREF(obj_1587))->loc);
					     }
					     use_variable__4_ast_sexp(var_1030, aux_2649, CNST_TABLE_REF(((long) 2)));
					  }
					  {
					     obj_t arg1574_1036;
					     type_t arg1575_1037;
					     variable_t arg1576_1038;
					     arg1574_1036 = get_location_95_ast_alphatize((obj_t) (node_1029));
					     arg1575_1037 = (((var_t) CREF(node_1029))->type);
					     arg1576_1038 = (((var_t) CREF(node_1029))->variable);
					     {
						var_t res1955_1600;
						{
						   var_t new1128_1593;
						   new1128_1593 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
						   {
						      long arg1510_1594;
						      arg1510_1594 = class_num_218___object(var_ast_node);
						      {
							 obj_t obj_1598;
							 obj_1598 = (obj_t) (new1128_1593);
							 (((obj_t) CREF(obj_1598))->header = MAKE_HEADER(arg1510_1594, 0), BUNSPEC);
						      }
						   }
						   {
						      object_t aux_2662;
						      aux_2662 = (object_t) (new1128_1593);
						      OBJECT_WIDENING_SET(aux_2662, BFALSE);
						   }
						   ((((var_t) CREF(new1128_1593))->loc) = ((obj_t) arg1574_1036), BUNSPEC);
						   ((((var_t) CREF(new1128_1593))->type) = ((type_t) arg1575_1037), BUNSPEC);
						   ((((var_t) CREF(new1128_1593))->variable) = ((variable_t) arg1576_1038), BUNSPEC);
						   res1955_1600 = new1128_1593;
						}
						aux_2625 = (obj_t) (res1955_1600);
					     }
					  }
				       }
				     else
				       {
					  bool_t test1577_1039;
					  test1577_1039 = is_a__118___object(alpha_1031, variable_ast_var);
					  if (test1577_1039)
					    {
					       {
						  obj_t aux_2671;
						  {
						     node_t obj_1602;
						     obj_1602 = (node_t) (node_1029);
						     aux_2671 = (((node_t) CREF(obj_1602))->loc);
						  }
						  use_variable__4_ast_sexp((variable_t) (alpha_1031), aux_2671, CNST_TABLE_REF(((long) 2)));
					       }
					       {
						  bool_t test1580_1042;
						  {
						     obj_t aux_2677;
						     {
							value_t aux_2678;
							{
							   variable_t obj_1603;
							   obj_1603 = (variable_t) (alpha_1031);
							   aux_2678 = (((variable_t) CREF(obj_1603))->value);
							}
							aux_2677 = (obj_t) (aux_2678);
						     }
						     test1580_1042 = is_a__118___object(aux_2677, fun_ast_var);
						  }
						  if (test1580_1042)
						    {
						       obj_t arg1582_1043;
						       type_t arg1583_1044;
						       arg1582_1043 = get_location_95_ast_alphatize((obj_t) (node_1029));
						       {
							  variable_t obj_1605;
							  obj_1605 = (variable_t) (alpha_1031);
							  arg1583_1044 = (((variable_t) CREF(obj_1605))->type);
						       }
						       {
							  closure_t res1956_1616;
							  {
							     variable_t variable_1608;
							     variable_1608 = (variable_t) (alpha_1031);
							     {
								closure_t new1134_1609;
								new1134_1609 = ((closure_t) BREF(GC_MALLOC(sizeof(struct closure))));
								{
								   long arg1507_1610;
								   arg1507_1610 = class_num_218___object(closure_ast_node);
								   {
								      obj_t obj_1614;
								      obj_1614 = (obj_t) (new1134_1609);
								      (((obj_t) CREF(obj_1614))->header = MAKE_HEADER(arg1507_1610, 0), BUNSPEC);
								   }
								}
								{
								   object_t aux_2693;
								   aux_2693 = (object_t) (new1134_1609);
								   OBJECT_WIDENING_SET(aux_2693, BFALSE);
								}
								((((closure_t) CREF(new1134_1609))->loc) = ((obj_t) arg1582_1043), BUNSPEC);
								((((closure_t) CREF(new1134_1609))->type) = ((type_t) arg1583_1044), BUNSPEC);
								((((closure_t) CREF(new1134_1609))->variable) = ((variable_t) variable_1608), BUNSPEC);
								res1956_1616 = new1134_1609;
							     }
							  }
							  aux_2625 = (obj_t) (res1956_1616);
						       }
						    }
						  else
						    {
						       obj_t arg1584_1046;
						       type_t arg1585_1047;
						       arg1584_1046 = get_location_95_ast_alphatize((obj_t) (node_1029));
						       arg1585_1047 = (((var_t) CREF(node_1029))->type);
						       {
							  var_t res1957_1628;
							  {
							     variable_t variable_1620;
							     variable_1620 = (variable_t) (alpha_1031);
							     {
								var_t new1128_1621;
								new1128_1621 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
								{
								   long arg1510_1622;
								   arg1510_1622 = class_num_218___object(var_ast_node);
								   {
								      obj_t obj_1626;
								      obj_1626 = (obj_t) (new1128_1621);
								      (((obj_t) CREF(obj_1626))->header = MAKE_HEADER(arg1510_1622, 0), BUNSPEC);
								   }
								}
								{
								   object_t aux_2708;
								   aux_2708 = (object_t) (new1128_1621);
								   OBJECT_WIDENING_SET(aux_2708, BFALSE);
								}
								((((var_t) CREF(new1128_1621))->loc) = ((obj_t) arg1584_1046), BUNSPEC);
								((((var_t) CREF(new1128_1621))->type) = ((type_t) arg1585_1047), BUNSPEC);
								((((var_t) CREF(new1128_1621))->variable) = ((variable_t) variable_1620), BUNSPEC);
								res1957_1628 = new1128_1621;
							     }
							  }
							  aux_2625 = (obj_t) (res1957_1628);
						       }
						    }
					       }
					    }
					  else
					    {
					       bool_t test1588_1049;
					       test1588_1049 = is_a__118___object(alpha_1031, atom_ast_node);
					       if (test1588_1049)
						 {
						    {
						       atom_t duplicated1289_1050;
						       duplicated1289_1050 = (atom_t) (alpha_1031);
						       {
							  obj_t arg1589_1051;
							  type_t arg1590_1052;
							  obj_t arg1591_1053;
							  arg1589_1051 = (((atom_t) CREF(duplicated1289_1050))->loc);
							  arg1590_1052 = (((atom_t) CREF(duplicated1289_1050))->type);
							  arg1591_1053 = (((atom_t) CREF(duplicated1289_1050))->value);
							  {
							     atom_t res1958_1643;
							     {
								atom_t new1122_1636;
								new1122_1636 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
								{
								   long arg1513_1637;
								   arg1513_1637 = class_num_218___object(atom_ast_node);
								   {
								      obj_t obj_1641;
								      obj_1641 = (obj_t) (new1122_1636);
								      (((obj_t) CREF(obj_1641))->header = MAKE_HEADER(arg1513_1637, 0), BUNSPEC);
								   }
								}
								{
								   object_t aux_2725;
								   aux_2725 = (object_t) (new1122_1636);
								   OBJECT_WIDENING_SET(aux_2725, BFALSE);
								}
								((((atom_t) CREF(new1122_1636))->loc) = ((obj_t) arg1589_1051), BUNSPEC);
								((((atom_t) CREF(new1122_1636))->type) = ((type_t) arg1590_1052), BUNSPEC);
								((((atom_t) CREF(new1122_1636))->value) = ((obj_t) arg1591_1053), BUNSPEC);
								res1958_1643 = new1122_1636;
							     }
							     aux_2625 = (obj_t) (res1958_1643);
							  }
						       }
						    }
						 }
					       else
						 {
						    {
						       obj_t arg1595_1056;
						       arg1595_1056 = shape_tools_shape((obj_t) (node_1029));
						       aux_2625 = internal_error_43_tools_error(string1991_ast_alphatize, string1992_ast_alphatize, arg1595_1056);
						    }
						 }
					    }
				       }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 2):
			 {
			    closure_t node_1057;
			    node_1057 = (closure_t) (node_16);
			    {
			       variable_t var_1058;
			       {
				  var_t obj_1644;
				  obj_1644 = (var_t) (node_1057);
				  var_1058 = (((var_t) CREF(obj_1644))->variable);
			       }
			       {
				  obj_t alpha_1059;
				  alpha_1059 = (((variable_t) CREF(var_1058))->fast_alpha_7);
				  {
				     if ((alpha_1059 == BUNSPEC))
				       {
					  {
					     obj_t aux_2741;
					     {
						node_t obj_1648;
						obj_1648 = (node_t) (node_1057);
						aux_2741 = (((node_t) CREF(obj_1648))->loc);
					     }
					     use_variable__4_ast_sexp(var_1058, aux_2741, CNST_TABLE_REF(((long) 2)));
					  }
					  {
					     obj_t arg1601_1064;
					     type_t arg1603_1065;
					     variable_t arg1604_1066;
					     arg1601_1064 = get_location_95_ast_alphatize((obj_t) (node_1057));
					     arg1603_1065 = (((closure_t) CREF(node_1057))->type);
					     arg1604_1066 = (((closure_t) CREF(node_1057))->variable);
					     {
						closure_t res1959_1661;
						{
						   closure_t new1134_1654;
						   new1134_1654 = ((closure_t) BREF(GC_MALLOC(sizeof(struct closure))));
						   {
						      long arg1507_1655;
						      arg1507_1655 = class_num_218___object(closure_ast_node);
						      {
							 obj_t obj_1659;
							 obj_1659 = (obj_t) (new1134_1654);
							 (((obj_t) CREF(obj_1659))->header = MAKE_HEADER(arg1507_1655, 0), BUNSPEC);
						      }
						   }
						   {
						      object_t aux_2754;
						      aux_2754 = (object_t) (new1134_1654);
						      OBJECT_WIDENING_SET(aux_2754, BFALSE);
						   }
						   ((((closure_t) CREF(new1134_1654))->loc) = ((obj_t) arg1601_1064), BUNSPEC);
						   ((((closure_t) CREF(new1134_1654))->type) = ((type_t) arg1603_1065), BUNSPEC);
						   ((((closure_t) CREF(new1134_1654))->variable) = ((variable_t) arg1604_1066), BUNSPEC);
						   res1959_1661 = new1134_1654;
						}
						aux_2625 = (obj_t) (res1959_1661);
					     }
					  }
				       }
				     else
				       {
					  bool_t test1605_1067;
					  test1605_1067 = is_a__118___object(alpha_1059, variable_ast_var);
					  if (test1605_1067)
					    {
					       {
						  obj_t aux_2763;
						  {
						     node_t obj_1663;
						     obj_1663 = (node_t) (node_1057);
						     aux_2763 = (((node_t) CREF(obj_1663))->loc);
						  }
						  use_variable__4_ast_sexp((variable_t) (alpha_1059), aux_2763, CNST_TABLE_REF(((long) 2)));
					       }
					       {
						  obj_t arg1609_1071;
						  type_t arg1611_1072;
						  arg1609_1071 = get_location_95_ast_alphatize((obj_t) (node_1057));
						  arg1611_1072 = (((closure_t) CREF(node_1057))->type);
						  {
						     closure_t res1960_1675;
						     {
							variable_t variable_1667;
							variable_1667 = (variable_t) (alpha_1059);
							{
							   closure_t new1134_1668;
							   new1134_1668 = ((closure_t) BREF(GC_MALLOC(sizeof(struct closure))));
							   {
							      long arg1507_1669;
							      arg1507_1669 = class_num_218___object(closure_ast_node);
							      {
								 obj_t obj_1673;
								 obj_1673 = (obj_t) (new1134_1668);
								 (((obj_t) CREF(obj_1673))->header = MAKE_HEADER(arg1507_1669, 0), BUNSPEC);
							      }
							   }
							   {
							      object_t aux_2777;
							      aux_2777 = (object_t) (new1134_1668);
							      OBJECT_WIDENING_SET(aux_2777, BFALSE);
							   }
							   ((((closure_t) CREF(new1134_1668))->loc) = ((obj_t) arg1609_1071), BUNSPEC);
							   ((((closure_t) CREF(new1134_1668))->type) = ((type_t) arg1611_1072), BUNSPEC);
							   ((((closure_t) CREF(new1134_1668))->variable) = ((variable_t) variable_1667), BUNSPEC);
							   res1960_1675 = new1134_1668;
							}
						     }
						     aux_2625 = (obj_t) (res1960_1675);
						  }
					       }
					    }
					  else
					    {
					       {
						  obj_t arg1617_1075;
						  arg1617_1075 = shape_tools_shape((obj_t) (node_1057));
						  aux_2625 = internal_error_43_tools_error(string1991_ast_alphatize, string1992_ast_alphatize, arg1617_1075);
					       }
					    }
				       }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 3):
			 {
			    kwote_t node_1076;
			    node_1076 = (kwote_t) (node_16);
			    {
			       obj_t arg1618_1078;
			       type_t arg1619_1079;
			       obj_t arg1620_1080;
			       arg1618_1078 = get_location_95_ast_alphatize((obj_t) (node_1076));
			       arg1619_1079 = (((kwote_t) CREF(node_1076))->type);
			       arg1620_1080 = (((kwote_t) CREF(node_1076))->value);
			       {
				  kwote_t res1961_1688;
				  {
				     kwote_t new1140_1681;
				     new1140_1681 = ((kwote_t) BREF(GC_MALLOC(sizeof(struct kwote))));
				     {
					long arg1505_1682;
					arg1505_1682 = class_num_218___object(kwote_ast_node);
					{
					   obj_t obj_1686;
					   obj_1686 = (obj_t) (new1140_1681);
					   (((obj_t) CREF(obj_1686))->header = MAKE_HEADER(arg1505_1682, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_2796;
					aux_2796 = (object_t) (new1140_1681);
					OBJECT_WIDENING_SET(aux_2796, BFALSE);
				     }
				     ((((kwote_t) CREF(new1140_1681))->loc) = ((obj_t) arg1618_1078), BUNSPEC);
				     ((((kwote_t) CREF(new1140_1681))->type) = ((type_t) arg1619_1079), BUNSPEC);
				     ((((kwote_t) CREF(new1140_1681))->value) = ((obj_t) arg1620_1080), BUNSPEC);
				     res1961_1688 = new1140_1681;
				  }
				  aux_2625 = (obj_t) (res1961_1688);
			       }
			    }
			 }
			 break;
		      case ((long) 4):
			 {
			    sequence_t node_1081;
			    node_1081 = (sequence_t) (node_16);
			    {
			       obj_t arg1621_1083;
			       type_t arg1623_1084;
			       obj_t arg1624_1085;
			       obj_t arg1626_1086;
			       arg1621_1083 = get_location_95_ast_alphatize((obj_t) (node_1081));
			       arg1623_1084 = (((sequence_t) CREF(node_1081))->type);
			       arg1624_1085 = (((sequence_t) CREF(node_1081))->side_effect__165);
			       {
				  obj_t l1294_1087;
				  l1294_1087 = (((sequence_t) CREF(node_1081))->nodes);
				  if (NULLP(l1294_1087))
				    {
				       arg1626_1086 = BNIL;
				    }
				  else
				    {
				       obj_t head1296_1089;
				       {
					  node_t arg1638_1100;
					  {
					     node_t aux_2811;
					     {
						obj_t aux_2812;
						aux_2812 = CAR(l1294_1087);
						aux_2811 = (node_t) (aux_2812);
					     }
					     arg1638_1100 = do_alphatize_126_ast_alphatize(aux_2811);
					  }
					  {
					     obj_t aux_2816;
					     aux_2816 = (obj_t) (arg1638_1100);
					     head1296_1089 = MAKE_PAIR(aux_2816, BNIL);
					  }
				       }
				       {
					  obj_t l1294_1090;
					  obj_t tail1297_1091;
					  l1294_1090 = CDR(l1294_1087);
					  tail1297_1091 = head1296_1089;
					lname1295_1092:
					  if (NULLP(l1294_1090))
					    {
					       arg1626_1086 = head1296_1089;
					    }
					  else
					    {
					       obj_t new_tail1298_25_1095;
					       {
						  node_t arg1632_1097;
						  {
						     node_t aux_2821;
						     {
							obj_t aux_2822;
							aux_2822 = CAR(l1294_1090);
							aux_2821 = (node_t) (aux_2822);
						     }
						     arg1632_1097 = do_alphatize_126_ast_alphatize(aux_2821);
						  }
						  {
						     obj_t aux_2826;
						     aux_2826 = (obj_t) (arg1632_1097);
						     new_tail1298_25_1095 = MAKE_PAIR(aux_2826, BNIL);
						  }
					       }
					       SET_CDR(tail1297_1091, new_tail1298_25_1095);
					       {
						  obj_t tail1297_2832;
						  obj_t l1294_2830;
						  l1294_2830 = CDR(l1294_1090);
						  tail1297_2832 = new_tail1298_25_1095;
						  tail1297_1091 = tail1297_2832;
						  l1294_1090 = l1294_2830;
						  goto lname1295_1092;
					       }
					    }
				       }
				    }
			       }
			       {
				  sequence_t res1962_1716;
				  {
				     sequence_t new1145_1708;
				     new1145_1708 = ((sequence_t) BREF(GC_MALLOC(sizeof(struct sequence))));
				     {
					long arg1500_1709;
					arg1500_1709 = class_num_218___object(sequence_ast_node);
					{
					   obj_t obj_1714;
					   obj_1714 = (obj_t) (new1145_1708);
					   (((obj_t) CREF(obj_1714))->header = MAKE_HEADER(arg1500_1709, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_2838;
					aux_2838 = (object_t) (new1145_1708);
					OBJECT_WIDENING_SET(aux_2838, BFALSE);
				     }
				     ((((sequence_t) CREF(new1145_1708))->loc) = ((obj_t) arg1621_1083), BUNSPEC);
				     ((((sequence_t) CREF(new1145_1708))->type) = ((type_t) arg1623_1084), BUNSPEC);
				     ((((sequence_t) CREF(new1145_1708))->side_effect__165) = ((obj_t) arg1624_1085), BUNSPEC);
				     ((((sequence_t) CREF(new1145_1708))->nodes) = ((obj_t) arg1626_1086), BUNSPEC);
				     res1962_1716 = new1145_1708;
				  }
				  aux_2625 = (obj_t) (res1962_1716);
			       }
			    }
			 }
			 break;
		      case ((long) 5):
			 {
			    app_t node_1103;
			    node_1103 = (app_t) (node_16);
			    {
			       obj_t arg1643_1105;
			       type_t arg1644_1106;
			       obj_t arg1645_1107;
			       obj_t arg1646_1108;
			       obj_t arg1647_1109;
			       obj_t arg1648_1110;
			       arg1643_1105 = get_location_95_ast_alphatize((obj_t) (node_1103));
			       arg1644_1106 = (((app_t) CREF(node_1103))->type);
			       arg1645_1107 = (((app_t) CREF(node_1103))->side_effect__165);
			       {
				  node_t var_1111;
				  {
				     node_t aux_2851;
				     {
					var_t aux_2852;
					aux_2852 = (((app_t) CREF(node_1103))->fun);
					aux_2851 = (node_t) (aux_2852);
				     }
				     var_1111 = do_alphatize_126_ast_alphatize(aux_2851);
				  }
				  {
				     bool_t test1649_1112;
				     test1649_1112 = is_a__118___object((obj_t) (var_1111), closure_ast_node);
				     if (test1649_1112)
				       {
					  var_t duplicated1300_1113;
					  duplicated1300_1113 = (var_t) (var_1111);
					  {
					     obj_t arg1650_1114;
					     type_t arg1651_1115;
					     variable_t arg1652_1116;
					     arg1650_1114 = (((var_t) CREF(duplicated1300_1113))->loc);
					     arg1651_1115 = (((var_t) CREF(duplicated1300_1113))->type);
					     arg1652_1116 = (((var_t) CREF(duplicated1300_1113))->variable);
					     {
						var_t res1963_1734;
						{
						   var_t new1128_1727;
						   new1128_1727 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
						   {
						      long arg1510_1728;
						      arg1510_1728 = class_num_218___object(var_ast_node);
						      {
							 obj_t obj_1732;
							 obj_1732 = (obj_t) (new1128_1727);
							 (((obj_t) CREF(obj_1732))->header = MAKE_HEADER(arg1510_1728, 0), BUNSPEC);
						      }
						   }
						   {
						      object_t aux_2867;
						      aux_2867 = (object_t) (new1128_1727);
						      OBJECT_WIDENING_SET(aux_2867, BFALSE);
						   }
						   ((((var_t) CREF(new1128_1727))->loc) = ((obj_t) arg1650_1114), BUNSPEC);
						   ((((var_t) CREF(new1128_1727))->type) = ((type_t) arg1651_1115), BUNSPEC);
						   ((((var_t) CREF(new1128_1727))->variable) = ((variable_t) arg1652_1116), BUNSPEC);
						   res1963_1734 = new1128_1727;
						}
						arg1646_1108 = (obj_t) (res1963_1734);
					     }
					  }
				       }
				     else
				       {
					  arg1646_1108 = (obj_t) (var_1111);
				       }
				  }
			       }
			       {
				  obj_t l1301_1118;
				  l1301_1118 = (((app_t) CREF(node_1103))->args);
				  if (NULLP(l1301_1118))
				    {
				       arg1647_1109 = BNIL;
				    }
				  else
				    {
				       obj_t head1305_1120;
				       {
					  node_t arg1664_1131;
					  {
					     node_t aux_2878;
					     {
						obj_t aux_2879;
						aux_2879 = CAR(l1301_1118);
						aux_2878 = (node_t) (aux_2879);
					     }
					     arg1664_1131 = do_alphatize_126_ast_alphatize(aux_2878);
					  }
					  {
					     obj_t aux_2883;
					     aux_2883 = (obj_t) (arg1664_1131);
					     head1305_1120 = MAKE_PAIR(aux_2883, BNIL);
					  }
				       }
				       {
					  obj_t l1301_1121;
					  obj_t tail1306_1122;
					  l1301_1121 = CDR(l1301_1118);
					  tail1306_1122 = head1305_1120;
					lname1304_1123:
					  if (NULLP(l1301_1121))
					    {
					       arg1647_1109 = head1305_1120;
					    }
					  else
					    {
					       obj_t new_tail1307_25_1126;
					       {
						  node_t arg1659_1128;
						  {
						     node_t aux_2888;
						     {
							obj_t aux_2889;
							aux_2889 = CAR(l1301_1121);
							aux_2888 = (node_t) (aux_2889);
						     }
						     arg1659_1128 = do_alphatize_126_ast_alphatize(aux_2888);
						  }
						  {
						     obj_t aux_2893;
						     aux_2893 = (obj_t) (arg1659_1128);
						     new_tail1307_25_1126 = MAKE_PAIR(aux_2893, BNIL);
						  }
					       }
					       SET_CDR(tail1306_1122, new_tail1307_25_1126);
					       {
						  obj_t tail1306_2899;
						  obj_t l1301_2897;
						  l1301_2897 = CDR(l1301_1121);
						  tail1306_2899 = new_tail1307_25_1126;
						  tail1306_1122 = tail1306_2899;
						  l1301_1121 = l1301_2897;
						  goto lname1304_1123;
					       }
					    }
				       }
				    }
			       }
			       arg1648_1110 = (((app_t) CREF(node_1103))->stack_info_255);
			       {
				  app_t res1964_1765;
				  {
				     var_t fun_1752;
				     fun_1752 = (var_t) (arg1646_1108);
				     {
					app_t new1151_1755;
					new1151_1755 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
					{
					   long arg1498_1756;
					   arg1498_1756 = class_num_218___object(app_ast_node);
					   {
					      obj_t obj_1763;
					      obj_1763 = (obj_t) (new1151_1755);
					      (((obj_t) CREF(obj_1763))->header = MAKE_HEADER(arg1498_1756, 0), BUNSPEC);
					   }
					}
					{
					   object_t aux_2907;
					   aux_2907 = (object_t) (new1151_1755);
					   OBJECT_WIDENING_SET(aux_2907, BFALSE);
					}
					((((app_t) CREF(new1151_1755))->loc) = ((obj_t) arg1643_1105), BUNSPEC);
					((((app_t) CREF(new1151_1755))->type) = ((type_t) arg1644_1106), BUNSPEC);
					((((app_t) CREF(new1151_1755))->side_effect__165) = ((obj_t) arg1645_1107), BUNSPEC);
					((((app_t) CREF(new1151_1755))->fun) = ((var_t) fun_1752), BUNSPEC);
					((((app_t) CREF(new1151_1755))->args) = ((obj_t) arg1647_1109), BUNSPEC);
					((((app_t) CREF(new1151_1755))->stack_info_255) = ((obj_t) arg1648_1110), BUNSPEC);
					res1964_1765 = new1151_1755;
				     }
				  }
				  aux_2625 = (obj_t) (res1964_1765);
			       }
			    }
			 }
			 break;
		      case ((long) 6):
			 {
			    app_ly_162_t node_1134;
			    node_1134 = (app_ly_162_t) (node_16);
			    {
			       node_t fun_1135;
			       node_t arg_1136;
			       fun_1135 = do_alphatize_126_ast_alphatize((((app_ly_162_t) CREF(node_1134))->fun));
			       arg_1136 = do_alphatize_126_ast_alphatize((((app_ly_162_t) CREF(node_1134))->arg));
			       {
				  bool_t test1668_1137;
				  test1668_1137 = is_a__118___object((obj_t) (fun_1135), closure_ast_node);
				  if (test1668_1137)
				    {
				       obj_t arg1671_1139;
				       var_t arg1673_1140;
				       obj_t arg1674_1141;
				       arg1671_1139 = get_location_95_ast_alphatize((obj_t) (node_1134));
				       {
					  var_t duplicated1308_1142;
					  duplicated1308_1142 = (var_t) (fun_1135);
					  {
					     obj_t arg1677_1143;
					     type_t arg1678_1144;
					     variable_t arg1679_1145;
					     arg1677_1143 = (((var_t) CREF(duplicated1308_1142))->loc);
					     arg1678_1144 = (((var_t) CREF(duplicated1308_1142))->type);
					     arg1679_1145 = (((var_t) CREF(duplicated1308_1142))->variable);
					     {
						var_t res1965_1782;
						{
						   var_t new1128_1775;
						   new1128_1775 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
						   {
						      long arg1510_1776;
						      arg1510_1776 = class_num_218___object(var_ast_node);
						      {
							 obj_t obj_1780;
							 obj_1780 = (obj_t) (new1128_1775);
							 (((obj_t) CREF(obj_1780))->header = MAKE_HEADER(arg1510_1776, 0), BUNSPEC);
						      }
						   }
						   {
						      object_t aux_2935;
						      aux_2935 = (object_t) (new1128_1775);
						      OBJECT_WIDENING_SET(aux_2935, BFALSE);
						   }
						   ((((var_t) CREF(new1128_1775))->loc) = ((obj_t) arg1677_1143), BUNSPEC);
						   ((((var_t) CREF(new1128_1775))->type) = ((type_t) arg1678_1144), BUNSPEC);
						   ((((var_t) CREF(new1128_1775))->variable) = ((variable_t) arg1679_1145), BUNSPEC);
						   res1965_1782 = new1128_1775;
						}
						arg1673_1140 = res1965_1782;
					     }
					  }
				       }
				       arg1674_1141 = CNST_TABLE_REF(((long) 2));
				       {
					  node_t aux_2942;
					  aux_2942 = known_app_ly__node_26_ast_apply(BNIL, arg1671_1139, (node_t) (arg1673_1140), arg_1136, arg1674_1141);
					  aux_2625 = (obj_t) (aux_2942);
				       }
				    }
				  else
				    {
				       obj_t arg1680_1147;
				       type_t arg1681_1148;
				       arg1680_1147 = get_location_95_ast_alphatize((obj_t) (node_1134));
				       arg1681_1148 = (((app_ly_162_t) CREF(node_1134))->type);
				       {
					  app_ly_162_t res1966_1796;
					  {
					     app_ly_162_t new1160_1788;
					     new1160_1788 = ((app_ly_162_t) BREF(GC_MALLOC(sizeof(struct app_ly_162))));
					     {
						long arg1496_1789;
						arg1496_1789 = class_num_218___object(app_ly_162_ast_node);
						{
						   obj_t obj_1794;
						   obj_1794 = (obj_t) (new1160_1788);
						   (((obj_t) CREF(obj_1794))->header = MAKE_HEADER(arg1496_1789, 0), BUNSPEC);
						}
					     }
					     {
						object_t aux_2953;
						aux_2953 = (object_t) (new1160_1788);
						OBJECT_WIDENING_SET(aux_2953, BFALSE);
					     }
					     ((((app_ly_162_t) CREF(new1160_1788))->loc) = ((obj_t) arg1680_1147), BUNSPEC);
					     ((((app_ly_162_t) CREF(new1160_1788))->type) = ((type_t) arg1681_1148), BUNSPEC);
					     ((((app_ly_162_t) CREF(new1160_1788))->fun) = ((node_t) fun_1135), BUNSPEC);
					     ((((app_ly_162_t) CREF(new1160_1788))->arg) = ((node_t) arg_1136), BUNSPEC);
					     res1966_1796 = new1160_1788;
					  }
					  aux_2625 = (obj_t) (res1966_1796);
				       }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 7):
			 {
			    funcall_t node_1151;
			    node_1151 = (funcall_t) (node_16);
			    {
			       node_t fun_1152;
			       obj_t args_1153;
			       fun_1152 = do_alphatize_126_ast_alphatize((((funcall_t) CREF(node_1151))->fun));
			       {
				  obj_t l1310_1176;
				  l1310_1176 = (((funcall_t) CREF(node_1151))->args);
				  if (NULLP(l1310_1176))
				    {
				       args_1153 = BNIL;
				    }
				  else
				    {
				       obj_t head1312_1178;
				       {
					  node_t arg1715_1189;
					  {
					     node_t aux_2967;
					     {
						obj_t aux_2968;
						aux_2968 = CAR(l1310_1176);
						aux_2967 = (node_t) (aux_2968);
					     }
					     arg1715_1189 = do_alphatize_126_ast_alphatize(aux_2967);
					  }
					  {
					     obj_t aux_2972;
					     aux_2972 = (obj_t) (arg1715_1189);
					     head1312_1178 = MAKE_PAIR(aux_2972, BNIL);
					  }
				       }
				       {
					  obj_t l1310_1179;
					  obj_t tail1313_1180;
					  l1310_1179 = CDR(l1310_1176);
					  tail1313_1180 = head1312_1178;
					lname1311_1181:
					  if (NULLP(l1310_1179))
					    {
					       args_1153 = head1312_1178;
					    }
					  else
					    {
					       obj_t new_tail1314_39_1184;
					       {
						  node_t arg1711_1186;
						  {
						     node_t aux_2977;
						     {
							obj_t aux_2978;
							aux_2978 = CAR(l1310_1179);
							aux_2977 = (node_t) (aux_2978);
						     }
						     arg1711_1186 = do_alphatize_126_ast_alphatize(aux_2977);
						  }
						  {
						     obj_t aux_2982;
						     aux_2982 = (obj_t) (arg1711_1186);
						     new_tail1314_39_1184 = MAKE_PAIR(aux_2982, BNIL);
						  }
					       }
					       SET_CDR(tail1313_1180, new_tail1314_39_1184);
					       {
						  obj_t tail1313_2988;
						  obj_t l1310_2986;
						  l1310_2986 = CDR(l1310_1179);
						  tail1313_2988 = new_tail1314_39_1184;
						  tail1313_1180 = tail1313_2988;
						  l1310_1179 = l1310_2986;
						  goto lname1311_1181;
					       }
					    }
				       }
				    }
			       }
			       {
				  bool_t test1685_1154;
				  test1685_1154 = is_a__118___object((obj_t) (fun_1152), closure_ast_node);
				  if (test1685_1154)
				    {
				       bool_t test1686_1155;
				       {
					  variable_t aux_2993;
					  {
					     var_t obj_1812;
					     obj_1812 = (var_t) (fun_1152);
					     aux_2993 = (((var_t) CREF(obj_1812))->variable);
					  }
					  test1686_1155 = correct_arity_app__187_ast_app(aux_2993, CDR(args_1153));
				       }
				       if (test1686_1155)
					 {
					    obj_t arg1688_1157;
					    var_t arg1689_1158;
					    obj_t arg1690_1159;
					    arg1688_1157 = get_location_95_ast_alphatize((obj_t) (node_1151));
					    {
					       var_t duplicated1315_1160;
					       duplicated1315_1160 = (var_t) (fun_1152);
					       {
						  obj_t arg1691_1161;
						  type_t arg1693_1162;
						  variable_t arg1694_1163;
						  arg1691_1161 = (((var_t) CREF(duplicated1315_1160))->loc);
						  arg1693_1162 = (((var_t) CREF(duplicated1315_1160))->type);
						  arg1694_1163 = (((var_t) CREF(duplicated1315_1160))->variable);
						  {
						     var_t res1967_1827;
						     {
							var_t new1128_1820;
							new1128_1820 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
							{
							   long arg1510_1821;
							   arg1510_1821 = class_num_218___object(var_ast_node);
							   {
							      obj_t obj_1825;
							      obj_1825 = (obj_t) (new1128_1820);
							      (((obj_t) CREF(obj_1825))->header = MAKE_HEADER(arg1510_1821, 0), BUNSPEC);
							   }
							}
							{
							   object_t aux_3009;
							   aux_3009 = (object_t) (new1128_1820);
							   OBJECT_WIDENING_SET(aux_3009, BFALSE);
							}
							((((var_t) CREF(new1128_1820))->loc) = ((obj_t) arg1691_1161), BUNSPEC);
							((((var_t) CREF(new1128_1820))->type) = ((type_t) arg1693_1162), BUNSPEC);
							((((var_t) CREF(new1128_1820))->variable) = ((variable_t) arg1694_1163), BUNSPEC);
							res1967_1827 = new1128_1820;
						     }
						     arg1689_1158 = res1967_1827;
						  }
					       }
					    }
					    arg1690_1159 = CDR(args_1153);
					    {
					       node_t aux_3016;
					       aux_3016 = make_app_node_80_ast_app(BNIL, arg1688_1157, arg1689_1158, arg1690_1159);
					       aux_2625 = (obj_t) (aux_3016);
					    }
					 }
				       else
					 {
					    obj_t arg1695_1164;
					    obj_t arg1698_1167;
					    arg1695_1164 = get_location_95_ast_alphatize((obj_t) (node_1151));
					    arg1698_1167 = shape_tools_shape((obj_t) (node_1151));
					    aux_2625 = user_error_location_137_tools_error(arg1695_1164, string1993_ast_alphatize, string1994_ast_alphatize, arg1698_1167, BNIL);
					 }
				    }
				  else
				    {
				       obj_t arg1703_1172;
				       type_t arg1704_1173;
				       obj_t arg1705_1174;
				       arg1703_1172 = get_location_95_ast_alphatize((obj_t) (node_1151));
				       arg1704_1173 = (((funcall_t) CREF(node_1151))->type);
				       arg1705_1174 = (((funcall_t) CREF(node_1151))->strength);
				       {
					  funcall_t res1968_1845;
					  {
					     funcall_t new1167_1836;
					     new1167_1836 = ((funcall_t) BREF(GC_MALLOC(sizeof(struct funcall))));
					     {
						long arg1493_1837;
						arg1493_1837 = class_num_218___object(funcall_ast_node);
						{
						   obj_t obj_1843;
						   obj_1843 = (obj_t) (new1167_1836);
						   (((obj_t) CREF(obj_1843))->header = MAKE_HEADER(arg1493_1837, 0), BUNSPEC);
						}
					     }
					     {
						object_t aux_3032;
						aux_3032 = (object_t) (new1167_1836);
						OBJECT_WIDENING_SET(aux_3032, BFALSE);
					     }
					     ((((funcall_t) CREF(new1167_1836))->loc) = ((obj_t) arg1703_1172), BUNSPEC);
					     ((((funcall_t) CREF(new1167_1836))->type) = ((type_t) arg1704_1173), BUNSPEC);
					     ((((funcall_t) CREF(new1167_1836))->fun) = ((node_t) fun_1152), BUNSPEC);
					     ((((funcall_t) CREF(new1167_1836))->args) = ((obj_t) args_1153), BUNSPEC);
					     ((((funcall_t) CREF(new1167_1836))->strength) = ((obj_t) arg1705_1174), BUNSPEC);
					     res1968_1845 = new1167_1836;
					  }
					  aux_2625 = (obj_t) (res1968_1845);
				       }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 8):
			 {
			    pragma_t node_1192;
			    node_1192 = (pragma_t) (node_16);
			    {
			       obj_t arg1718_1194;
			       type_t arg1719_1195;
			       obj_t arg1720_1196;
			       obj_t arg1721_1197;
			       obj_t arg1722_1198;
			       arg1718_1194 = get_location_95_ast_alphatize((obj_t) (node_1192));
			       arg1719_1195 = (((pragma_t) CREF(node_1192))->type);
			       arg1720_1196 = (((pragma_t) CREF(node_1192))->side_effect__165);
			       arg1721_1197 = (((pragma_t) CREF(node_1192))->format);
			       {
				  obj_t l1318_1199;
				  l1318_1199 = (((pragma_t) CREF(node_1192))->args);
				  if (NULLP(l1318_1199))
				    {
				       arg1722_1198 = BNIL;
				    }
				  else
				    {
				       obj_t head1320_1201;
				       {
					  node_t arg1734_1212;
					  {
					     node_t aux_3050;
					     {
						obj_t aux_3051;
						aux_3051 = CAR(l1318_1199);
						aux_3050 = (node_t) (aux_3051);
					     }
					     arg1734_1212 = do_alphatize_126_ast_alphatize(aux_3050);
					  }
					  {
					     obj_t aux_3055;
					     aux_3055 = (obj_t) (arg1734_1212);
					     head1320_1201 = MAKE_PAIR(aux_3055, BNIL);
					  }
				       }
				       {
					  obj_t l1318_1202;
					  obj_t tail1321_1203;
					  l1318_1202 = CDR(l1318_1199);
					  tail1321_1203 = head1320_1201;
					lname1319_1204:
					  if (NULLP(l1318_1202))
					    {
					       arg1722_1198 = head1320_1201;
					    }
					  else
					    {
					       obj_t new_tail1322_103_1207;
					       {
						  node_t arg1731_1209;
						  {
						     node_t aux_3060;
						     {
							obj_t aux_3061;
							aux_3061 = CAR(l1318_1202);
							aux_3060 = (node_t) (aux_3061);
						     }
						     arg1731_1209 = do_alphatize_126_ast_alphatize(aux_3060);
						  }
						  {
						     obj_t aux_3065;
						     aux_3065 = (obj_t) (arg1731_1209);
						     new_tail1322_103_1207 = MAKE_PAIR(aux_3065, BNIL);
						  }
					       }
					       SET_CDR(tail1321_1203, new_tail1322_103_1207);
					       {
						  obj_t tail1321_3071;
						  obj_t l1318_3069;
						  l1318_3069 = CDR(l1318_1202);
						  tail1321_3071 = new_tail1322_103_1207;
						  tail1321_1203 = tail1321_3071;
						  l1318_1202 = l1318_3069;
						  goto lname1319_1204;
					       }
					    }
				       }
				    }
			       }
			       {
				  pragma_t res1969_1876;
				  {
				     pragma_t new1175_1867;
				     new1175_1867 = ((pragma_t) BREF(GC_MALLOC(sizeof(struct pragma))));
				     {
					long arg1489_1868;
					arg1489_1868 = class_num_218___object(pragma_ast_node);
					{
					   obj_t obj_1874;
					   obj_1874 = (obj_t) (new1175_1867);
					   (((obj_t) CREF(obj_1874))->header = MAKE_HEADER(arg1489_1868, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_3077;
					aux_3077 = (object_t) (new1175_1867);
					OBJECT_WIDENING_SET(aux_3077, BFALSE);
				     }
				     ((((pragma_t) CREF(new1175_1867))->loc) = ((obj_t) arg1718_1194), BUNSPEC);
				     ((((pragma_t) CREF(new1175_1867))->type) = ((type_t) arg1719_1195), BUNSPEC);
				     ((((pragma_t) CREF(new1175_1867))->side_effect__165) = ((obj_t) arg1720_1196), BUNSPEC);
				     ((((pragma_t) CREF(new1175_1867))->format) = ((obj_t) arg1721_1197), BUNSPEC);
				     ((((pragma_t) CREF(new1175_1867))->args) = ((obj_t) arg1722_1198), BUNSPEC);
				     res1969_1876 = new1175_1867;
				  }
				  aux_2625 = (obj_t) (res1969_1876);
			       }
			    }
			 }
			 break;
		      case ((long) 9):
			 {
			    cast_t node_1215;
			    node_1215 = (cast_t) (node_16);
			    {
			       obj_t arg1737_1217;
			       type_t arg1738_1218;
			       node_t arg1740_1219;
			       arg1737_1217 = get_location_95_ast_alphatize((obj_t) (node_1215));
			       arg1738_1218 = (((cast_t) CREF(node_1215))->type);
			       arg1740_1219 = do_alphatize_126_ast_alphatize((((cast_t) CREF(node_1215))->arg));
			       {
				  cast_t res1970_1889;
				  {
				     cast_t new1182_1882;
				     new1182_1882 = ((cast_t) BREF(GC_MALLOC(sizeof(struct cast))));
				     {
					long arg1486_1883;
					arg1486_1883 = class_num_218___object(cast_ast_node);
					{
					   obj_t obj_1887;
					   obj_1887 = (obj_t) (new1182_1882);
					   (((obj_t) CREF(obj_1887))->header = MAKE_HEADER(arg1486_1883, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_3096;
					aux_3096 = (object_t) (new1182_1882);
					OBJECT_WIDENING_SET(aux_3096, BFALSE);
				     }
				     ((((cast_t) CREF(new1182_1882))->loc) = ((obj_t) arg1737_1217), BUNSPEC);
				     ((((cast_t) CREF(new1182_1882))->type) = ((type_t) arg1738_1218), BUNSPEC);
				     ((((cast_t) CREF(new1182_1882))->arg) = ((node_t) arg1740_1219), BUNSPEC);
				     res1970_1889 = new1182_1882;
				  }
				  aux_2625 = (obj_t) (res1970_1889);
			       }
			    }
			 }
			 break;
		      case ((long) 10):
			 {
			    setq_t node_1221;
			    node_1221 = (setq_t) (node_16);
			    {
			       var_t v_1222;
			       v_1222 = (((setq_t) CREF(node_1221))->var);
			       {
				  variable_t var_1223;
				  var_1223 = (((var_t) CREF(v_1222))->variable);
				  {
				     obj_t alpha_1224;
				     alpha_1224 = (((variable_t) CREF(var_1223))->fast_alpha_7);
				     {
					if ((alpha_1224 == BUNSPEC))
					  {
					     {
						obj_t aux_3109;
						{
						   node_t obj_1895;
						   obj_1895 = (node_t) (node_1221);
						   aux_3109 = (((node_t) CREF(obj_1895))->loc);
						}
						use_variable__4_ast_sexp(var_1223, aux_3109, CNST_TABLE_REF(((long) 3)));
					     }
					     {
						obj_t arg1746_1229;
						type_t arg1747_1230;
						var_t arg1748_1231;
						node_t arg1749_1232;
						arg1746_1229 = get_location_95_ast_alphatize((obj_t) (node_1221));
						arg1747_1230 = (((setq_t) CREF(node_1221))->type);
						{
						   obj_t arg1751_1234;
						   type_t arg1753_1235;
						   variable_t arg1754_1236;
						   arg1751_1234 = get_location_95_ast_alphatize((obj_t) (node_1221));
						   arg1753_1235 = (((var_t) CREF(v_1222))->type);
						   arg1754_1236 = (((var_t) CREF(v_1222))->variable);
						   {
						      var_t res1971_1909;
						      {
							 var_t new1128_1902;
							 new1128_1902 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
							 {
							    long arg1510_1903;
							    arg1510_1903 = class_num_218___object(var_ast_node);
							    {
							       obj_t obj_1907;
							       obj_1907 = (obj_t) (new1128_1902);
							       (((obj_t) CREF(obj_1907))->header = MAKE_HEADER(arg1510_1903, 0), BUNSPEC);
							    }
							 }
							 {
							    object_t aux_3125;
							    aux_3125 = (object_t) (new1128_1902);
							    OBJECT_WIDENING_SET(aux_3125, BFALSE);
							 }
							 ((((var_t) CREF(new1128_1902))->loc) = ((obj_t) arg1751_1234), BUNSPEC);
							 ((((var_t) CREF(new1128_1902))->type) = ((type_t) arg1753_1235), BUNSPEC);
							 ((((var_t) CREF(new1128_1902))->variable) = ((variable_t) arg1754_1236), BUNSPEC);
							 res1971_1909 = new1128_1902;
						      }
						      arg1748_1231 = res1971_1909;
						   }
						}
						arg1749_1232 = do_alphatize_126_ast_alphatize((((setq_t) CREF(node_1221))->value));
						{
						   setq_t res1972_1923;
						   {
						      setq_t new1188_1915;
						      new1188_1915 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
						      {
							 long arg1484_1916;
							 arg1484_1916 = class_num_218___object(setq_ast_node);
							 {
							    obj_t obj_1921;
							    obj_1921 = (obj_t) (new1188_1915);
							    (((obj_t) CREF(obj_1921))->header = MAKE_HEADER(arg1484_1916, 0), BUNSPEC);
							 }
						      }
						      {
							 object_t aux_3137;
							 aux_3137 = (object_t) (new1188_1915);
							 OBJECT_WIDENING_SET(aux_3137, BFALSE);
						      }
						      ((((setq_t) CREF(new1188_1915))->loc) = ((obj_t) arg1746_1229), BUNSPEC);
						      ((((setq_t) CREF(new1188_1915))->type) = ((type_t) arg1747_1230), BUNSPEC);
						      ((((setq_t) CREF(new1188_1915))->var) = ((var_t) arg1748_1231), BUNSPEC);
						      ((((setq_t) CREF(new1188_1915))->value) = ((node_t) arg1749_1232), BUNSPEC);
						      res1972_1923 = new1188_1915;
						   }
						   aux_2625 = (obj_t) (res1972_1923);
						}
					     }
					  }
					else
					  {
					     bool_t test1756_1238;
					     test1756_1238 = is_a__118___object(alpha_1224, variable_ast_var);
					     if (test1756_1238)
					       {
						  {
						     obj_t aux_3147;
						     {
							node_t obj_1925;
							obj_1925 = (node_t) (node_1221);
							aux_3147 = (((node_t) CREF(obj_1925))->loc);
						     }
						     use_variable__4_ast_sexp((variable_t) (alpha_1224), aux_3147, CNST_TABLE_REF(((long) 3)));
						  }
						  {
						     obj_t arg1761_1242;
						     type_t arg1762_1243;
						     var_t arg1763_1244;
						     node_t arg1764_1245;
						     arg1761_1242 = get_location_95_ast_alphatize((obj_t) (node_1221));
						     arg1762_1243 = (((setq_t) CREF(node_1221))->type);
						     {
							obj_t arg1766_1247;
							type_t arg1767_1248;
							arg1766_1247 = get_location_95_ast_alphatize((obj_t) (node_1221));
							arg1767_1248 = (((var_t) CREF(v_1222))->type);
							{
							   var_t res1973_1938;
							   {
							      variable_t variable_1930;
							      variable_1930 = (variable_t) (alpha_1224);
							      {
								 var_t new1128_1931;
								 new1128_1931 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
								 {
								    long arg1510_1932;
								    arg1510_1932 = class_num_218___object(var_ast_node);
								    {
								       obj_t obj_1936;
								       obj_1936 = (obj_t) (new1128_1931);
								       (((obj_t) CREF(obj_1936))->header = MAKE_HEADER(arg1510_1932, 0), BUNSPEC);
								    }
								 }
								 {
								    object_t aux_3164;
								    aux_3164 = (object_t) (new1128_1931);
								    OBJECT_WIDENING_SET(aux_3164, BFALSE);
								 }
								 ((((var_t) CREF(new1128_1931))->loc) = ((obj_t) arg1766_1247), BUNSPEC);
								 ((((var_t) CREF(new1128_1931))->type) = ((type_t) arg1767_1248), BUNSPEC);
								 ((((var_t) CREF(new1128_1931))->variable) = ((variable_t) variable_1930), BUNSPEC);
								 res1973_1938 = new1128_1931;
							      }
							   }
							   arg1763_1244 = res1973_1938;
							}
						     }
						     arg1764_1245 = do_alphatize_126_ast_alphatize((((setq_t) CREF(node_1221))->value));
						     {
							setq_t res1974_1952;
							{
							   setq_t new1188_1944;
							   new1188_1944 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
							   {
							      long arg1484_1945;
							      arg1484_1945 = class_num_218___object(setq_ast_node);
							      {
								 obj_t obj_1950;
								 obj_1950 = (obj_t) (new1188_1944);
								 (((obj_t) CREF(obj_1950))->header = MAKE_HEADER(arg1484_1945, 0), BUNSPEC);
							      }
							   }
							   {
							      object_t aux_3176;
							      aux_3176 = (object_t) (new1188_1944);
							      OBJECT_WIDENING_SET(aux_3176, BFALSE);
							   }
							   ((((setq_t) CREF(new1188_1944))->loc) = ((obj_t) arg1761_1242), BUNSPEC);
							   ((((setq_t) CREF(new1188_1944))->type) = ((type_t) arg1762_1243), BUNSPEC);
							   ((((setq_t) CREF(new1188_1944))->var) = ((var_t) arg1763_1244), BUNSPEC);
							   ((((setq_t) CREF(new1188_1944))->value) = ((node_t) arg1764_1245), BUNSPEC);
							   res1974_1952 = new1188_1944;
							}
							aux_2625 = (obj_t) (res1974_1952);
						     }
						  }
					       }
					     else
					       {
						  {
						     obj_t arg1772_1252;
						     arg1772_1252 = shape_tools_shape((obj_t) (node_1221));
						     aux_2625 = internal_error_43_tools_error(string1991_ast_alphatize, string1992_ast_alphatize, arg1772_1252);
						  }
					       }
					  }
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 11):
			 {
			    conditional_t node_1253;
			    node_1253 = (conditional_t) (node_16);
			    {
			       obj_t arg1773_1255;
			       type_t arg1774_1256;
			       obj_t arg1775_1257;
			       node_t arg1776_1258;
			       node_t arg1777_1259;
			       node_t arg1778_1260;
			       arg1773_1255 = get_location_95_ast_alphatize((obj_t) (node_1253));
			       arg1774_1256 = (((conditional_t) CREF(node_1253))->type);
			       arg1775_1257 = (((conditional_t) CREF(node_1253))->side_effect__165);
			       arg1776_1258 = do_alphatize_126_ast_alphatize((((conditional_t) CREF(node_1253))->test));
			       arg1777_1259 = do_alphatize_126_ast_alphatize((((conditional_t) CREF(node_1253))->true));
			       arg1778_1260 = do_alphatize_126_ast_alphatize((((conditional_t) CREF(node_1253))->false));
			       {
				  conditional_t res1975_1974;
				  {
				     conditional_t new1195_1964;
				     new1195_1964 = ((conditional_t) BREF(GC_MALLOC(sizeof(struct conditional))));
				     {
					long arg1480_1965;
					arg1480_1965 = class_num_218___object(conditional_ast_node);
					{
					   obj_t obj_1972;
					   obj_1972 = (obj_t) (new1195_1964);
					   (((obj_t) CREF(obj_1972))->header = MAKE_HEADER(arg1480_1965, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_3202;
					aux_3202 = (object_t) (new1195_1964);
					OBJECT_WIDENING_SET(aux_3202, BFALSE);
				     }
				     ((((conditional_t) CREF(new1195_1964))->loc) = ((obj_t) arg1773_1255), BUNSPEC);
				     ((((conditional_t) CREF(new1195_1964))->type) = ((type_t) arg1774_1256), BUNSPEC);
				     ((((conditional_t) CREF(new1195_1964))->side_effect__165) = ((obj_t) arg1775_1257), BUNSPEC);
				     ((((conditional_t) CREF(new1195_1964))->test) = ((node_t) arg1776_1258), BUNSPEC);
				     ((((conditional_t) CREF(new1195_1964))->true) = ((node_t) arg1777_1259), BUNSPEC);
				     ((((conditional_t) CREF(new1195_1964))->false) = ((node_t) arg1778_1260), BUNSPEC);
				     res1975_1974 = new1195_1964;
				  }
				  aux_2625 = (obj_t) (res1975_1974);
			       }
			    }
			 }
			 break;
		      case ((long) 12):
			 {
			    fail_t node_1264;
			    node_1264 = (fail_t) (node_16);
			    {
			       obj_t arg1783_1266;
			       type_t arg1784_1267;
			       node_t arg1785_1268;
			       node_t arg1786_1269;
			       node_t arg1788_1270;
			       arg1783_1266 = get_location_95_ast_alphatize((obj_t) (node_1264));
			       arg1784_1267 = (((fail_t) CREF(node_1264))->type);
			       arg1785_1268 = do_alphatize_126_ast_alphatize((((fail_t) CREF(node_1264))->proc));
			       arg1786_1269 = do_alphatize_126_ast_alphatize((((fail_t) CREF(node_1264))->msg));
			       arg1788_1270 = do_alphatize_126_ast_alphatize((((fail_t) CREF(node_1264))->obj));
			       {
				  fail_t res1976_1993;
				  {
				     fail_t new1204_1984;
				     new1204_1984 = ((fail_t) BREF(GC_MALLOC(sizeof(struct fail))));
				     {
					long arg1477_1985;
					arg1477_1985 = class_num_218___object(fail_ast_node);
					{
					   obj_t obj_1991;
					   obj_1991 = (obj_t) (new1204_1984);
					   (((obj_t) CREF(obj_1991))->header = MAKE_HEADER(arg1477_1985, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_3226;
					aux_3226 = (object_t) (new1204_1984);
					OBJECT_WIDENING_SET(aux_3226, BFALSE);
				     }
				     ((((fail_t) CREF(new1204_1984))->loc) = ((obj_t) arg1783_1266), BUNSPEC);
				     ((((fail_t) CREF(new1204_1984))->type) = ((type_t) arg1784_1267), BUNSPEC);
				     ((((fail_t) CREF(new1204_1984))->proc) = ((node_t) arg1785_1268), BUNSPEC);
				     ((((fail_t) CREF(new1204_1984))->msg) = ((node_t) arg1786_1269), BUNSPEC);
				     ((((fail_t) CREF(new1204_1984))->obj) = ((node_t) arg1788_1270), BUNSPEC);
				     res1976_1993 = new1204_1984;
				  }
				  aux_2625 = (obj_t) (res1976_1993);
			       }
			    }
			 }
			 break;
		      case ((long) 13):
			 {
			    select_t node_1274;
			    node_1274 = (select_t) (node_16);
			    {
			       obj_t arg1793_1276;
			       type_t arg1795_1277;
			       obj_t arg1796_1278;
			       node_t arg1798_1279;
			       obj_t arg1799_1280;
			       type_t arg1800_1281;
			       arg1793_1276 = get_location_95_ast_alphatize((obj_t) (node_1274));
			       arg1795_1277 = (((select_t) CREF(node_1274))->type);
			       arg1796_1278 = (((select_t) CREF(node_1274))->side_effect__165);
			       arg1798_1279 = do_alphatize_126_ast_alphatize((((select_t) CREF(node_1274))->test));
			       {
				  obj_t l1331_1283;
				  l1331_1283 = (((select_t) CREF(node_1274))->clauses);
				  if (NULLP(l1331_1283))
				    {
				       arg1799_1280 = BNIL;
				    }
				  else
				    {
				       obj_t head1334_1285;
				       head1334_1285 = MAKE_PAIR(BNIL, BNIL);
				       {
					  obj_t l1331_1286;
					  obj_t tail1335_1287;
					  l1331_1286 = l1331_1283;
					  tail1335_1287 = head1334_1285;
					lname1333_1288:
					  if (NULLP(l1331_1286))
					    {
					       arg1799_1280 = CDR(head1334_1285);
					    }
					  else
					    {
					       obj_t new_tail1336_226_1290;
					       {
						  obj_t arg1805_1292;
						  {
						     obj_t clause_1294;
						     clause_1294 = CAR(l1331_1286);
						     {
							obj_t arg1807_1295;
							node_t arg1808_1296;
							arg1807_1295 = CAR(clause_1294);
							{
							   node_t aux_3251;
							   {
							      obj_t aux_3252;
							      aux_3252 = CDR(clause_1294);
							      aux_3251 = (node_t) (aux_3252);
							   }
							   arg1808_1296 = do_alphatize_126_ast_alphatize(aux_3251);
							}
							{
							   obj_t aux_3256;
							   aux_3256 = (obj_t) (arg1808_1296);
							   arg1805_1292 = MAKE_PAIR(arg1807_1295, aux_3256);
							}
						     }
						  }
						  new_tail1336_226_1290 = MAKE_PAIR(arg1805_1292, BNIL);
					       }
					       SET_CDR(tail1335_1287, new_tail1336_226_1290);
					       {
						  obj_t tail1335_3263;
						  obj_t l1331_3261;
						  l1331_3261 = CDR(l1331_1286);
						  tail1335_3263 = new_tail1336_226_1290;
						  tail1335_1287 = tail1335_3263;
						  l1331_1286 = l1331_3261;
						  goto lname1333_1288;
					       }
					    }
				       }
				    }
			       }
			       arg1800_1281 = (((select_t) CREF(node_1274))->item_type_130);
			       {
				  select_t res1977_2030;
				  {
				     select_t new1212_2020;
				     new1212_2020 = ((select_t) BREF(GC_MALLOC(sizeof(struct select))));
				     {
					long arg1474_2021;
					arg1474_2021 = class_num_218___object(select_ast_node);
					{
					   obj_t obj_2028;
					   obj_2028 = (obj_t) (new1212_2020);
					   (((obj_t) CREF(obj_2028))->header = MAKE_HEADER(arg1474_2021, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_3269;
					aux_3269 = (object_t) (new1212_2020);
					OBJECT_WIDENING_SET(aux_3269, BFALSE);
				     }
				     ((((select_t) CREF(new1212_2020))->loc) = ((obj_t) arg1793_1276), BUNSPEC);
				     ((((select_t) CREF(new1212_2020))->type) = ((type_t) arg1795_1277), BUNSPEC);
				     ((((select_t) CREF(new1212_2020))->side_effect__165) = ((obj_t) arg1796_1278), BUNSPEC);
				     ((((select_t) CREF(new1212_2020))->test) = ((node_t) arg1798_1279), BUNSPEC);
				     ((((select_t) CREF(new1212_2020))->clauses) = ((obj_t) arg1799_1280), BUNSPEC);
				     ((((select_t) CREF(new1212_2020))->item_type_130) = ((type_t) arg1800_1281), BUNSPEC);
				     res1977_2030 = new1212_2020;
				  }
				  aux_2625 = (obj_t) (res1977_2030);
			       }
			    }
			 }
			 break;
		      case ((long) 14):
			 {
			    make_box_202_t node_1300;
			    node_1300 = (make_box_202_t) (node_16);
			    {
			       obj_t arg1812_1302;
			       type_t arg1813_1303;
			       obj_t arg1814_1304;
			       node_t arg1819_1305;
			       arg1812_1302 = get_location_95_ast_alphatize((obj_t) (node_1300));
			       arg1813_1303 = (((make_box_202_t) CREF(node_1300))->type);
			       arg1814_1304 = (((make_box_202_t) CREF(node_1300))->side_effect__165);
			       arg1819_1305 = do_alphatize_126_ast_alphatize((((make_box_202_t) CREF(node_1300))->value));
			       {
				  make_box_202_t res1978_2046;
				  {
				     make_box_202_t new1252_2038;
				     new1252_2038 = ((make_box_202_t) BREF(GC_MALLOC(sizeof(struct make_box_202))));
				     {
					long arg1458_2039;
					arg1458_2039 = class_num_218___object(make_box_202_ast_node);
					{
					   obj_t obj_2044;
					   obj_2044 = (obj_t) (new1252_2038);
					   (((obj_t) CREF(obj_2044))->header = MAKE_HEADER(arg1458_2039, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_3290;
					aux_3290 = (object_t) (new1252_2038);
					OBJECT_WIDENING_SET(aux_3290, BFALSE);
				     }
				     ((((make_box_202_t) CREF(new1252_2038))->loc) = ((obj_t) arg1812_1302), BUNSPEC);
				     ((((make_box_202_t) CREF(new1252_2038))->type) = ((type_t) arg1813_1303), BUNSPEC);
				     ((((make_box_202_t) CREF(new1252_2038))->side_effect__165) = ((obj_t) arg1814_1304), BUNSPEC);
				     ((((make_box_202_t) CREF(new1252_2038))->value) = ((node_t) arg1819_1305), BUNSPEC);
				     res1978_2046 = new1252_2038;
				  }
				  aux_2625 = (obj_t) (res1978_2046);
			       }
			    }
			 }
			 break;
		      case ((long) 15):
			 {
			    box_ref_242_t node_1307;
			    node_1307 = (box_ref_242_t) (node_16);
			    {
			       obj_t arg1821_1309;
			       type_t arg1822_1310;
			       obj_t arg1823_1311;
			       node_t arg1824_1312;
			       arg1821_1309 = get_location_95_ast_alphatize((obj_t) (node_1307));
			       arg1822_1310 = (((box_ref_242_t) CREF(node_1307))->type);
			       arg1823_1311 = (((box_ref_242_t) CREF(node_1307))->side_effect__165);
			       {
				  node_t aux_3303;
				  {
				     var_t aux_3304;
				     aux_3304 = (((box_ref_242_t) CREF(node_1307))->var);
				     aux_3303 = (node_t) (aux_3304);
				  }
				  arg1824_1312 = do_alphatize_126_ast_alphatize(aux_3303);
			       }
			       {
				  box_ref_242_t res1979_2062;
				  {
				     var_t var_2053;
				     var_2053 = (var_t) (arg1824_1312);
				     {
					box_ref_242_t new1259_2054;
					new1259_2054 = ((box_ref_242_t) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
					{
					   long arg1454_2055;
					   arg1454_2055 = class_num_218___object(box_ref_242_ast_node);
					   {
					      obj_t obj_2060;
					      obj_2060 = (obj_t) (new1259_2054);
					      (((obj_t) CREF(obj_2060))->header = MAKE_HEADER(arg1454_2055, 0), BUNSPEC);
					   }
					}
					{
					   object_t aux_3313;
					   aux_3313 = (object_t) (new1259_2054);
					   OBJECT_WIDENING_SET(aux_3313, BFALSE);
					}
					((((box_ref_242_t) CREF(new1259_2054))->loc) = ((obj_t) arg1821_1309), BUNSPEC);
					((((box_ref_242_t) CREF(new1259_2054))->type) = ((type_t) arg1822_1310), BUNSPEC);
					((((box_ref_242_t) CREF(new1259_2054))->side_effect__165) = ((obj_t) arg1823_1311), BUNSPEC);
					((((box_ref_242_t) CREF(new1259_2054))->var) = ((var_t) var_2053), BUNSPEC);
					res1979_2062 = new1259_2054;
				     }
				  }
				  aux_2625 = (obj_t) (res1979_2062);
			       }
			    }
			 }
			 break;
		      case ((long) 16):
			 {
			    box_set__221_t node_1314;
			    node_1314 = (box_set__221_t) (node_16);
			    {
			       obj_t arg1826_1316;
			       type_t arg1827_1317;
			       node_t arg1828_1318;
			       node_t arg1829_1319;
			       arg1826_1316 = get_location_95_ast_alphatize((obj_t) (node_1314));
			       arg1827_1317 = (((box_set__221_t) CREF(node_1314))->type);
			       {
				  node_t aux_3325;
				  {
				     var_t aux_3326;
				     aux_3326 = (((box_set__221_t) CREF(node_1314))->var);
				     aux_3325 = (node_t) (aux_3326);
				  }
				  arg1828_1318 = do_alphatize_126_ast_alphatize(aux_3325);
			       }
			       arg1829_1319 = do_alphatize_126_ast_alphatize((((box_set__221_t) CREF(node_1314))->value));
			       {
				  box_set__221_t res1980_2078;
				  {
				     var_t var_2068;
				     var_2068 = (var_t) (arg1828_1318);
				     {
					box_set__221_t new1266_2070;
					new1266_2070 = ((box_set__221_t) BREF(GC_MALLOC(sizeof(struct box_set__221))));
					{
					   long arg1452_2071;
					   arg1452_2071 = class_num_218___object(box_set__221_ast_node);
					   {
					      obj_t obj_2076;
					      obj_2076 = (obj_t) (new1266_2070);
					      (((obj_t) CREF(obj_2076))->header = MAKE_HEADER(arg1452_2071, 0), BUNSPEC);
					   }
					}
					{
					   object_t aux_3337;
					   aux_3337 = (object_t) (new1266_2070);
					   OBJECT_WIDENING_SET(aux_3337, BFALSE);
					}
					((((box_set__221_t) CREF(new1266_2070))->loc) = ((obj_t) arg1826_1316), BUNSPEC);
					((((box_set__221_t) CREF(new1266_2070))->type) = ((type_t) arg1827_1317), BUNSPEC);
					((((box_set__221_t) CREF(new1266_2070))->var) = ((var_t) var_2068), BUNSPEC);
					((((box_set__221_t) CREF(new1266_2070))->value) = ((node_t) arg1829_1319), BUNSPEC);
					res1980_2078 = new1266_2070;
				     }
				  }
				  aux_2625 = (obj_t) (res1980_2078);
			       }
			    }
			 }
			 break;
		      case ((long) 17):
			 {
			    let_fun_218_t node_1322;
			    node_1322 = (let_fun_218_t) (node_16);
			    {
			       obj_t old_locals_255_1323;
			       old_locals_255_1323 = (((let_fun_218_t) CREF(node_1322))->locals);
			       {
				  obj_t new_locals_179_1324;
				  if (NULLP(old_locals_255_1323))
				    {
				       new_locals_179_1324 = BNIL;
				    }
				  else
				    {
				       obj_t head1342_1377;
				       head1342_1377 = MAKE_PAIR(BNIL, BNIL);
				       {
					  obj_t l1340_1378;
					  obj_t tail1343_1379;
					  l1340_1378 = old_locals_255_1323;
					  tail1343_1379 = head1342_1377;
					lname1341_1380:
					  if (NULLP(l1340_1378))
					    {
					       new_locals_179_1324 = CDR(head1342_1377);
					    }
					  else
					    {
					       obj_t new_tail1344_24_1382;
					       {
						  local_t arg1870_1384;
						  {
						     obj_t l_1386;
						     l_1386 = CAR(l1340_1378);
						     {
							sfun_t aux_3360;
							type_t aux_3357;
							obj_t aux_3354;
							{
							   value_t aux_3361;
							   {
							      local_t obj_2088;
							      obj_2088 = (local_t) (l_1386);
							      aux_3361 = (((local_t) CREF(obj_2088))->value);
							   }
							   aux_3360 = (sfun_t) (aux_3361);
							}
							{
							   local_t obj_2087;
							   obj_2087 = (local_t) (l_1386);
							   aux_3357 = (((local_t) CREF(obj_2087))->type);
							}
							{
							   local_t obj_2086;
							   obj_2086 = (local_t) (l_1386);
							   aux_3354 = (((local_t) CREF(obj_2086))->id);
							}
							arg1870_1384 = make_local_sfun_184_ast_local(aux_3354, aux_3357, aux_3360);
						     }
						  }
						  {
						     obj_t aux_3366;
						     aux_3366 = (obj_t) (arg1870_1384);
						     new_tail1344_24_1382 = MAKE_PAIR(aux_3366, BNIL);
						  }
					       }
					       SET_CDR(tail1343_1379, new_tail1344_24_1382);
					       {
						  obj_t tail1343_3372;
						  obj_t l1340_3370;
						  l1340_3370 = CDR(l1340_1378);
						  tail1343_3372 = new_tail1344_24_1382;
						  tail1343_1379 = tail1343_3372;
						  l1340_1378 = l1340_3370;
						  goto lname1341_1380;
					       }
					    }
				       }
				    }
				  {
				     {
					obj_t ll1345_1325;
					obj_t ll1346_1326;
					ll1345_1325 = old_locals_255_1323;
					ll1346_1326 = new_locals_179_1324;
				      lname1347_1327:
					if (NULLP(ll1345_1325))
					  {
					     ((bool_t) 1);
					  }
					else
					  {
					     {
						obj_t new_1330;
						new_1330 = CAR(ll1346_1326);
						{
						   value_t old_sfun_249_1331;
						   {
						      local_t obj_2097;
						      {
							 obj_t aux_3376;
							 aux_3376 = CAR(ll1345_1325);
							 obj_2097 = (local_t) (aux_3376);
						      }
						      old_sfun_249_1331 = (((local_t) CREF(obj_2097))->value);
						   }
						   {
						      obj_t old_args_130_1332;
						      {
							 sfun_t obj_2098;
							 obj_2098 = (sfun_t) (old_sfun_249_1331);
							 old_args_130_1332 = (((sfun_t) CREF(obj_2098))->args);
						      }
						      {
							 obj_t new_args_235_1333;
							 if (NULLP(old_args_130_1332))
							   {
							      new_args_235_1333 = BNIL;
							   }
							 else
							   {
							      obj_t head1350_1352;
							      head1350_1352 = MAKE_PAIR(BNIL, BNIL);
							      {
								 obj_t l1348_1353;
								 obj_t tail1351_1354;
								 l1348_1353 = old_args_130_1332;
								 tail1351_1354 = head1350_1352;
							       lname1349_1355:
								 if (NULLP(l1348_1353))
								   {
								      new_args_235_1333 = CDR(head1350_1352);
								   }
								 else
								   {
								      obj_t new_tail1352_186_1357;
								      {
									 local_t arg1848_1359;
									 {
									    obj_t l_1361;
									    l_1361 = CAR(l1348_1353);
									    {
									       type_t aux_3392;
									       obj_t aux_3389;
									       {
										  local_t obj_2106;
										  obj_2106 = (local_t) (l_1361);
										  aux_3392 = (((local_t) CREF(obj_2106))->type);
									       }
									       {
										  local_t obj_2105;
										  obj_2105 = (local_t) (l_1361);
										  aux_3389 = (((local_t) CREF(obj_2105))->id);
									       }
									       arg1848_1359 = make_local_svar_140_ast_local(aux_3389, aux_3392);
									    }
									 }
									 {
									    obj_t aux_3396;
									    aux_3396 = (obj_t) (arg1848_1359);
									    new_tail1352_186_1357 = MAKE_PAIR(aux_3396, BNIL);
									 }
								      }
								      SET_CDR(tail1351_1354, new_tail1352_186_1357);
								      {
									 obj_t tail1351_3402;
									 obj_t l1348_3400;
									 l1348_3400 = CDR(l1348_1353);
									 tail1351_3402 = new_tail1352_186_1357;
									 tail1351_1354 = tail1351_3402;
									 l1348_1353 = l1348_3400;
									 goto lname1349_1355;
								      }
								   }
							      }
							   }
							 {
							    node_t new_body_215_1335;
							    {
							       node_t aux_3403;
							       {
								  obj_t aux_3408;
								  {
								     sfun_t obj_2112;
								     obj_2112 = (sfun_t) (old_sfun_249_1331);
								     aux_3408 = (((sfun_t) CREF(obj_2112))->body);
								  }
								  aux_3403 = (node_t) (aux_3408);
							       }
							       new_body_215_1335 = alphatize_ast_alphatize(append_2_18___r4_pairs_and_lists_6_3(old_locals_255_1323, old_args_130_1332), append_2_18___r4_pairs_and_lists_6_3(new_locals_179_1324, new_args_235_1333), get_location_95_ast_alphatize((obj_t) (node_1322)), aux_3403);
							    }
							    {
							       sfun_t new_sfun_134_1336;
							       {
								  sfun_t duplicated1353_1337;
								  duplicated1353_1337 = (sfun_t) (old_sfun_249_1331);
								  {
								     long arg1833_1338;
								     obj_t arg1834_1339;
								     obj_t arg1835_1340;
								     obj_t arg1836_1341;
								     bool_t arg1837_1342;
								     obj_t arg1838_1343;
								     obj_t arg1839_1344;
								     obj_t arg1840_1345;
								     obj_t arg1841_1346;
								     arg1833_1338 = (((sfun_t) CREF(duplicated1353_1337))->arity);
								     arg1834_1339 = (((sfun_t) CREF(duplicated1353_1337))->side_effect__165);
								     arg1835_1340 = (((sfun_t) CREF(duplicated1353_1337))->predicate_of_78);
								     arg1836_1341 = (((sfun_t) CREF(duplicated1353_1337))->stack_allocator_172);
								     arg1837_1342 = (((sfun_t) CREF(duplicated1353_1337))->top__138);
								     arg1838_1343 = (((sfun_t) CREF(duplicated1353_1337))->the_closure_238);
								     arg1839_1344 = (((sfun_t) CREF(duplicated1353_1337))->property);
								     arg1840_1345 = (((sfun_t) CREF(duplicated1353_1337))->class);
								     arg1841_1346 = (((sfun_t) CREF(duplicated1353_1337))->dsssl_keywords_243);
								     {
									sfun_t res1981_2148;
									{
									   obj_t body_2130;
									   body_2130 = (obj_t) (new_body_215_1335);
									   {
									      sfun_t new1068_2133;
									      new1068_2133 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
									      {
										 long arg1538_2134;
										 arg1538_2134 = class_num_218___object(sfun_ast_var);
										 {
										    obj_t obj_2146;
										    obj_2146 = (obj_t) (new1068_2133);
										    (((obj_t) CREF(obj_2146))->header = MAKE_HEADER(arg1538_2134, 0), BUNSPEC);
										 }
									      }
									      {
										 object_t aux_3428;
										 aux_3428 = (object_t) (new1068_2133);
										 OBJECT_WIDENING_SET(aux_3428, BFALSE);
									      }
									      ((((sfun_t) CREF(new1068_2133))->arity) = ((long) arg1833_1338), BUNSPEC);
									      ((((sfun_t) CREF(new1068_2133))->side_effect__165) = ((obj_t) arg1834_1339), BUNSPEC);
									      ((((sfun_t) CREF(new1068_2133))->predicate_of_78) = ((obj_t) arg1835_1340), BUNSPEC);
									      ((((sfun_t) CREF(new1068_2133))->stack_allocator_172) = ((obj_t) arg1836_1341), BUNSPEC);
									      ((((sfun_t) CREF(new1068_2133))->top__138) = ((bool_t) arg1837_1342), BUNSPEC);
									      ((((sfun_t) CREF(new1068_2133))->the_closure_238) = ((obj_t) arg1838_1343), BUNSPEC);
									      ((((sfun_t) CREF(new1068_2133))->property) = ((obj_t) arg1839_1344), BUNSPEC);
									      ((((sfun_t) CREF(new1068_2133))->args) = ((obj_t) new_args_235_1333), BUNSPEC);
									      ((((sfun_t) CREF(new1068_2133))->body) = ((obj_t) body_2130), BUNSPEC);
									      ((((sfun_t) CREF(new1068_2133))->class) = ((obj_t) arg1840_1345), BUNSPEC);
									      ((((sfun_t) CREF(new1068_2133))->dsssl_keywords_243) = ((obj_t) arg1841_1346), BUNSPEC);
									      res1981_2148 = new1068_2133;
									   }
									}
									new_sfun_134_1336 = res1981_2148;
								     }
								  }
							       }
							       {
								  {
								     obj_t res1982_2151;
								     {
									local_t obj_2149;
									value_t val1052_2150;
									obj_2149 = (local_t) (new_1330);
									val1052_2150 = (value_t) (new_sfun_134_1336);
									{
									   obj_t x_2511;
									   x_2511 = ((((local_t) CREF(obj_2149))->value) = ((value_t) val1052_2150), BUNSPEC);
									   res1982_2151 = BUNSPEC;
									}
								     }
								     res1982_2151;
								  }
							       }
							    }
							 }
						      }
						   }
						}
					     }
					     {
						obj_t ll1346_3447;
						obj_t ll1345_3445;
						ll1345_3445 = CDR(ll1345_1325);
						ll1346_3447 = CDR(ll1346_1326);
						ll1346_1326 = ll1346_3447;
						ll1345_1325 = ll1345_3445;
						goto lname1347_1327;
					     }
					  }
				     }
				     {
					obj_t arg1859_1369;
					type_t arg1860_1370;
					obj_t arg1861_1371;
					node_t arg1862_1372;
					arg1859_1369 = get_location_95_ast_alphatize((obj_t) (node_1322));
					arg1860_1370 = (((let_fun_218_t) CREF(node_1322))->type);
					arg1861_1371 = (((let_fun_218_t) CREF(node_1322))->side_effect__165);
					arg1862_1372 = alphatize_ast_alphatize(old_locals_255_1323, new_locals_179_1324, get_location_95_ast_alphatize((obj_t) (node_1322)), (((let_fun_218_t) CREF(node_1322))->body));
					{
					   let_fun_218_t res1983_2171;
					   {
					      let_fun_218_t new1221_2162;
					      new1221_2162 = ((let_fun_218_t) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
					      {
						 long arg1471_2163;
						 arg1471_2163 = class_num_218___object(let_fun_218_ast_node);
						 {
						    obj_t obj_2169;
						    obj_2169 = (obj_t) (new1221_2162);
						    (((obj_t) CREF(obj_2169))->header = MAKE_HEADER(arg1471_2163, 0), BUNSPEC);
						 }
					      }
					      {
						 object_t aux_3461;
						 aux_3461 = (object_t) (new1221_2162);
						 OBJECT_WIDENING_SET(aux_3461, BFALSE);
					      }
					      ((((let_fun_218_t) CREF(new1221_2162))->loc) = ((obj_t) arg1859_1369), BUNSPEC);
					      ((((let_fun_218_t) CREF(new1221_2162))->type) = ((type_t) arg1860_1370), BUNSPEC);
					      ((((let_fun_218_t) CREF(new1221_2162))->side_effect__165) = ((obj_t) arg1861_1371), BUNSPEC);
					      ((((let_fun_218_t) CREF(new1221_2162))->locals) = ((obj_t) new_locals_179_1324), BUNSPEC);
					      ((((let_fun_218_t) CREF(new1221_2162))->body) = ((node_t) arg1862_1372), BUNSPEC);
					      res1983_2171 = new1221_2162;
					   }
					   aux_2625 = (obj_t) (res1983_2171);
					}
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 18):
			 {
			    let_var_6_t node_1392;
			    node_1392 = (let_var_6_t) (node_16);
			    {
			       obj_t old_locals_255_1393;
			       {
				  obj_t l1355_1440;
				  l1355_1440 = (((let_var_6_t) CREF(node_1392))->bindings);
				  if (NULLP(l1355_1440))
				    {
				       old_locals_255_1393 = BNIL;
				    }
				  else
				    {
				       obj_t head1357_1442;
				       {
					  obj_t aux_3474;
					  {
					     obj_t aux_3475;
					     aux_3475 = CAR(l1355_1440);
					     aux_3474 = CAR(aux_3475);
					  }
					  head1357_1442 = MAKE_PAIR(aux_3474, BNIL);
				       }
				       {
					  obj_t l1355_1443;
					  obj_t tail1358_1444;
					  l1355_1443 = CDR(l1355_1440);
					  tail1358_1444 = head1357_1442;
					lname1356_1445:
					  if (NULLP(l1355_1443))
					    {
					       old_locals_255_1393 = head1357_1442;
					    }
					  else
					    {
					       obj_t new_tail1359_148_1448;
					       {
						  obj_t aux_3481;
						  {
						     obj_t aux_3482;
						     aux_3482 = CAR(l1355_1443);
						     aux_3481 = CAR(aux_3482);
						  }
						  new_tail1359_148_1448 = MAKE_PAIR(aux_3481, BNIL);
					       }
					       SET_CDR(tail1358_1444, new_tail1359_148_1448);
					       {
						  obj_t tail1358_3489;
						  obj_t l1355_3487;
						  l1355_3487 = CDR(l1355_1443);
						  tail1358_3489 = new_tail1359_148_1448;
						  tail1358_1444 = tail1358_3489;
						  l1355_1443 = l1355_3487;
						  goto lname1356_1445;
					       }
					    }
				       }
				    }
			       }
			       {
				  obj_t new_locals_179_1394;
				  if (NULLP(old_locals_255_1393))
				    {
				       new_locals_179_1394 = BNIL;
				    }
				  else
				    {
				       obj_t head1363_1426;
				       head1363_1426 = MAKE_PAIR(BNIL, BNIL);
				       {
					  obj_t l1360_1427;
					  obj_t tail1364_1428;
					  l1360_1427 = old_locals_255_1393;
					  tail1364_1428 = head1363_1426;
					lname1362_1429:
					  if (NULLP(l1360_1427))
					    {
					       new_locals_179_1394 = CDR(head1363_1426);
					    }
					  else
					    {
					       obj_t new_tail1365_107_1431;
					       {
						  local_t arg1900_1433;
						  {
						     obj_t l_1435;
						     l_1435 = CAR(l1360_1427);
						     {
							type_t aux_3501;
							obj_t aux_3498;
							{
							   local_t obj_2194;
							   obj_2194 = (local_t) (l_1435);
							   aux_3501 = (((local_t) CREF(obj_2194))->type);
							}
							{
							   local_t obj_2193;
							   obj_2193 = (local_t) (l_1435);
							   aux_3498 = (((local_t) CREF(obj_2193))->id);
							}
							arg1900_1433 = make_local_svar_140_ast_local(aux_3498, aux_3501);
						     }
						  }
						  {
						     obj_t aux_3505;
						     aux_3505 = (obj_t) (arg1900_1433);
						     new_tail1365_107_1431 = MAKE_PAIR(aux_3505, BNIL);
						  }
					       }
					       SET_CDR(tail1364_1428, new_tail1365_107_1431);
					       {
						  obj_t tail1364_3511;
						  obj_t l1360_3509;
						  l1360_3509 = CDR(l1360_1427);
						  tail1364_3511 = new_tail1365_107_1431;
						  tail1364_1428 = tail1364_3511;
						  l1360_1427 = l1360_3509;
						  goto lname1362_1429;
					       }
					    }
				       }
				    }
				  {
				     obj_t new_bindings_102_1395;
				     {
					obj_t ll1366_1404;
					ll1366_1404 = (((let_var_6_t) CREF(node_1392))->bindings);
					if (NULLP(ll1366_1404))
					  {
					     new_bindings_102_1395 = BNIL;
					  }
					else
					  {
					     obj_t head1368_1407;
					     head1368_1407 = MAKE_PAIR(BNIL, BNIL);
					     {
						obj_t ll1366_1408;
						obj_t ll1367_1409;
						obj_t tail1369_1410;
						ll1366_1408 = ll1366_1404;
						ll1367_1409 = new_locals_179_1394;
						tail1369_1410 = head1368_1407;
					      lname1371_1411:
						if (NULLP(ll1366_1408))
						  {
						     new_bindings_102_1395 = CDR(head1368_1407);
						  }
						else
						  {
						     obj_t new_tail1370_188_1413;
						     {
							obj_t arg1891_1416;
							{
							   obj_t new_local_166_1419;
							   new_local_166_1419 = CAR(ll1367_1409);
							   {
							      node_t arg1893_1420;
							      {
								 node_t aux_3520;
								 {
								    obj_t aux_3521;
								    {
								       obj_t aux_3522;
								       aux_3522 = CAR(ll1366_1408);
								       aux_3521 = CDR(aux_3522);
								    }
								    aux_3520 = (node_t) (aux_3521);
								 }
								 arg1893_1420 = do_alphatize_126_ast_alphatize(aux_3520);
							      }
							      {
								 obj_t aux_3527;
								 aux_3527 = (obj_t) (arg1893_1420);
								 arg1891_1416 = MAKE_PAIR(new_local_166_1419, aux_3527);
							      }
							   }
							}
							new_tail1370_188_1413 = MAKE_PAIR(arg1891_1416, BNIL);
						     }
						     SET_CDR(tail1369_1410, new_tail1370_188_1413);
						     {
							obj_t tail1369_3536;
							obj_t ll1367_3534;
							obj_t ll1366_3532;
							ll1366_3532 = CDR(ll1366_1408);
							ll1367_3534 = CDR(ll1367_1409);
							tail1369_3536 = new_tail1370_188_1413;
							tail1369_1410 = tail1369_3536;
							ll1367_1409 = ll1367_3534;
							ll1366_1408 = ll1366_3532;
							goto lname1371_1411;
						     }
						  }
					     }
					  }
				     }
				     {
					{
					   obj_t arg1879_1397;
					   type_t arg1880_1398;
					   obj_t arg1881_1399;
					   node_t arg1882_1400;
					   bool_t arg1883_1401;
					   arg1879_1397 = get_location_95_ast_alphatize((obj_t) (node_1392));
					   arg1880_1398 = (((let_var_6_t) CREF(node_1392))->type);
					   arg1881_1399 = (((let_var_6_t) CREF(node_1392))->side_effect__165);
					   arg1882_1400 = alphatize_ast_alphatize(old_locals_255_1393, new_locals_179_1394, get_location_95_ast_alphatize((obj_t) (node_1392)), (((let_var_6_t) CREF(node_1392))->body));
					   arg1883_1401 = (((let_var_6_t) CREF(node_1392))->removable__42);
					   {
					      let_var_6_t res1984_2237;
					      {
						 let_var_6_t new1229_2227;
						 new1229_2227 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
						 {
						    long arg1468_2228;
						    arg1468_2228 = class_num_218___object(let_var_6_ast_node);
						    {
						       obj_t obj_2235;
						       obj_2235 = (obj_t) (new1229_2227);
						       (((obj_t) CREF(obj_2235))->header = MAKE_HEADER(arg1468_2228, 0), BUNSPEC);
						    }
						 }
						 {
						    object_t aux_3550;
						    aux_3550 = (object_t) (new1229_2227);
						    OBJECT_WIDENING_SET(aux_3550, BFALSE);
						 }
						 ((((let_var_6_t) CREF(new1229_2227))->loc) = ((obj_t) arg1879_1397), BUNSPEC);
						 ((((let_var_6_t) CREF(new1229_2227))->type) = ((type_t) arg1880_1398), BUNSPEC);
						 ((((let_var_6_t) CREF(new1229_2227))->side_effect__165) = ((obj_t) arg1881_1399), BUNSPEC);
						 ((((let_var_6_t) CREF(new1229_2227))->bindings) = ((obj_t) new_bindings_102_1395), BUNSPEC);
						 ((((let_var_6_t) CREF(new1229_2227))->body) = ((node_t) arg1882_1400), BUNSPEC);
						 ((((let_var_6_t) CREF(new1229_2227))->removable__42) = ((bool_t) arg1883_1401), BUNSPEC);
						 res1984_2237 = new1229_2227;
					      }
					      aux_2625 = (obj_t) (res1984_2237);
					   }
					}
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 19):
			 {
			    set_ex_it_116_t node_1456;
			    node_1456 = (set_ex_it_116_t) (node_16);
			    {
			       variable_t old_var_137_1457;
			       {
				  var_t arg1939_1483;
				  arg1939_1483 = (((set_ex_it_116_t) CREF(node_1456))->var);
				  old_var_137_1457 = (((var_t) CREF(arg1939_1483))->variable);
			       }
			       {
				  value_t old_exit_224_1458;
				  {
				     local_t obj_2240;
				     obj_2240 = (local_t) (old_var_137_1457);
				     old_exit_224_1458 = (((local_t) CREF(obj_2240))->value);
				  }
				  {
				     obj_t alpha_hdlg_201_1460;
				     {
					variable_t obj_2242;
					{
					   obj_t aux_3565;
					   {
					      sexit_t obj_2241;
					      obj_2241 = (sexit_t) (old_exit_224_1458);
					      aux_3565 = (((sexit_t) CREF(obj_2241))->handler);
					   }
					   obj_2242 = (variable_t) (aux_3565);
					}
					alpha_hdlg_201_1460 = (((variable_t) CREF(obj_2242))->fast_alpha_7);
				     }
				     {
					local_t new_var_21_1461;
					{
					   obj_t arg1935_1478;
					   type_t arg1936_1479;
					   sexit_t arg1937_1480;
					   {
					      local_t obj_2243;
					      obj_2243 = (local_t) (old_var_137_1457);
					      arg1935_1478 = (((local_t) CREF(obj_2243))->id);
					   }
					   {
					      local_t obj_2244;
					      obj_2244 = (local_t) (old_var_137_1457);
					      arg1936_1479 = (((local_t) CREF(obj_2244))->type);
					   }
					   {
					      sexit_t duplicated1373_1481;
					      duplicated1373_1481 = (sexit_t) (old_exit_224_1458);
					      {
						 bool_t arg1938_1482;
						 arg1938_1482 = (((sexit_t) CREF(duplicated1373_1481))->detached__120);
						 {
						    sexit_t res1985_2254;
						    {
						       sexit_t new1105_2248;
						       new1105_2248 = ((sexit_t) BREF(GC_MALLOC(sizeof(struct sexit))));
						       {
							  long arg1523_2249;
							  arg1523_2249 = class_num_218___object(sexit_ast_var);
							  {
							     obj_t obj_2252;
							     obj_2252 = (obj_t) (new1105_2248);
							     (((obj_t) CREF(obj_2252))->header = MAKE_HEADER(arg1523_2249, 0), BUNSPEC);
							  }
						       }
						       {
							  object_t aux_3580;
							  aux_3580 = (object_t) (new1105_2248);
							  OBJECT_WIDENING_SET(aux_3580, BFALSE);
						       }
						       ((((sexit_t) CREF(new1105_2248))->handler) = ((obj_t) alpha_hdlg_201_1460), BUNSPEC);
						       ((((sexit_t) CREF(new1105_2248))->detached__120) = ((bool_t) arg1938_1482), BUNSPEC);
						       res1985_2254 = new1105_2248;
						    }
						    arg1937_1480 = res1985_2254;
						 }
					      }
					   }
					   new_var_21_1461 = make_local_sexit_184_ast_local(arg1935_1478, arg1936_1479, arg1937_1480);
					}
					{
					   node_t old_body_129_1462;
					   old_body_129_1462 = (((set_ex_it_116_t) CREF(node_1456))->body);
					   {
					      {
						 obj_t arg1918_1464;
						 type_t arg1921_1465;
						 var_t arg1922_1466;
						 node_t arg1923_1467;
						 arg1918_1464 = get_location_95_ast_alphatize((obj_t) (node_1456));
						 arg1921_1465 = (((set_ex_it_116_t) CREF(node_1456))->type);
						 {
						    var_t duplicated1375_1468;
						    duplicated1375_1468 = (((set_ex_it_116_t) CREF(node_1456))->var);
						    {
						       obj_t arg1925_1469;
						       type_t arg1926_1470;
						       arg1925_1469 = get_location_95_ast_alphatize((obj_t) (node_1456));
						       arg1926_1470 = (((var_t) CREF(duplicated1375_1468))->type);
						       {
							  var_t res1986_2269;
							  {
							     variable_t variable_2261;
							     variable_2261 = (variable_t) (new_var_21_1461);
							     {
								var_t new1128_2262;
								new1128_2262 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
								{
								   long arg1510_2263;
								   arg1510_2263 = class_num_218___object(var_ast_node);
								   {
								      obj_t obj_2267;
								      obj_2267 = (obj_t) (new1128_2262);
								      (((obj_t) CREF(obj_2267))->header = MAKE_HEADER(arg1510_2263, 0), BUNSPEC);
								   }
								}
								{
								   object_t aux_3599;
								   aux_3599 = (object_t) (new1128_2262);
								   OBJECT_WIDENING_SET(aux_3599, BFALSE);
								}
								((((var_t) CREF(new1128_2262))->loc) = ((obj_t) arg1925_1469), BUNSPEC);
								((((var_t) CREF(new1128_2262))->type) = ((type_t) arg1926_1470), BUNSPEC);
								((((var_t) CREF(new1128_2262))->variable) = ((variable_t) variable_2261), BUNSPEC);
								res1986_2269 = new1128_2262;
							     }
							  }
							  arg1922_1466 = res1986_2269;
						       }
						    }
						 }
						 {
						    obj_t arg1927_1471;
						    obj_t arg1928_1472;
						    obj_t arg1929_1473;
						    {
						       obj_t list1930_1474;
						       {
							  obj_t aux_3605;
							  aux_3605 = (obj_t) (old_var_137_1457);
							  list1930_1474 = MAKE_PAIR(aux_3605, BNIL);
						       }
						       arg1927_1471 = list1930_1474;
						    }
						    {
						       obj_t list1932_1476;
						       {
							  obj_t aux_3608;
							  aux_3608 = (obj_t) (new_var_21_1461);
							  list1932_1476 = MAKE_PAIR(aux_3608, BNIL);
						       }
						       arg1928_1472 = list1932_1476;
						    }
						    arg1929_1473 = get_location_95_ast_alphatize((obj_t) (node_1456));
						    arg1923_1467 = alphatize_ast_alphatize(arg1927_1471, arg1928_1472, arg1929_1473, old_body_129_1462);
						 }
						 {
						    set_ex_it_116_t res1987_2284;
						    {
						       set_ex_it_116_t new1238_2276;
						       new1238_2276 = ((set_ex_it_116_t) BREF(GC_MALLOC(sizeof(struct set_ex_it_116))));
						       {
							  long arg1466_2277;
							  arg1466_2277 = class_num_218___object(set_ex_it_116_ast_node);
							  {
							     obj_t obj_2282;
							     obj_2282 = (obj_t) (new1238_2276);
							     (((obj_t) CREF(obj_2282))->header = MAKE_HEADER(arg1466_2277, 0), BUNSPEC);
							  }
						       }
						       {
							  object_t aux_3618;
							  aux_3618 = (object_t) (new1238_2276);
							  OBJECT_WIDENING_SET(aux_3618, BFALSE);
						       }
						       ((((set_ex_it_116_t) CREF(new1238_2276))->loc) = ((obj_t) arg1918_1464), BUNSPEC);
						       ((((set_ex_it_116_t) CREF(new1238_2276))->type) = ((type_t) arg1921_1465), BUNSPEC);
						       ((((set_ex_it_116_t) CREF(new1238_2276))->var) = ((var_t) arg1922_1466), BUNSPEC);
						       ((((set_ex_it_116_t) CREF(new1238_2276))->body) = ((node_t) arg1923_1467), BUNSPEC);
						       res1987_2284 = new1238_2276;
						    }
						    aux_2625 = (obj_t) (res1987_2284);
						 }
					      }
					   }
					}
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 20):
			 {
			    jump_ex_it_184_t node_1484;
			    node_1484 = (jump_ex_it_184_t) (node_16);
			    {
			       obj_t arg1940_1486;
			       type_t arg1941_1487;
			       node_t arg1942_1488;
			       node_t arg1943_1489;
			       arg1940_1486 = get_location_95_ast_alphatize((obj_t) (node_1484));
			       arg1941_1487 = (((jump_ex_it_184_t) CREF(node_1484))->type);
			       arg1942_1488 = do_alphatize_126_ast_alphatize((((jump_ex_it_184_t) CREF(node_1484))->exit));
			       arg1943_1489 = do_alphatize_126_ast_alphatize((((jump_ex_it_184_t) CREF(node_1484))->value));
			       {
				  jump_ex_it_184_t res1988_2300;
				  {
				     jump_ex_it_184_t new1245_2292;
				     new1245_2292 = ((jump_ex_it_184_t) BREF(GC_MALLOC(sizeof(struct jump_ex_it_184))));
				     {
					long arg1463_2293;
					arg1463_2293 = class_num_218___object(jump_ex_it_184_ast_node);
					{
					   obj_t obj_2298;
					   obj_2298 = (obj_t) (new1245_2292);
					   (((obj_t) CREF(obj_2298))->header = MAKE_HEADER(arg1463_2293, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_3638;
					aux_3638 = (object_t) (new1245_2292);
					OBJECT_WIDENING_SET(aux_3638, BFALSE);
				     }
				     ((((jump_ex_it_184_t) CREF(new1245_2292))->loc) = ((obj_t) arg1940_1486), BUNSPEC);
				     ((((jump_ex_it_184_t) CREF(new1245_2292))->type) = ((type_t) arg1941_1487), BUNSPEC);
				     ((((jump_ex_it_184_t) CREF(new1245_2292))->exit) = ((node_t) arg1942_1488), BUNSPEC);
				     ((((jump_ex_it_184_t) CREF(new1245_2292))->value) = ((node_t) arg1943_1489), BUNSPEC);
				     res1988_2300 = new1245_2292;
				  }
				  aux_2625 = (obj_t) (res1988_2300);
			       }
			    }
			 }
			 break;
		      default:
		       case_else1561_67_1021:
			 if (PROCEDUREP(method1555_1017))
			   {
			      aux_2625 = PROCEDURE_ENTRY(method1555_1017) (method1555_1017, (obj_t) (node_16), BEOA);
			   }
			 else
			   {
			      obj_t fun1449_703;
			      fun1449_703 = PROCEDURE_REF(do_alphatize_env_178_ast_alphatize, ((long) 0));
			      aux_2625 = PROCEDURE_ENTRY(fun1449_703) (fun1449_703, (obj_t) (node_16), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1561_67_1021;
		 }
	    }
	    return (node_t) (aux_2625);
	 }
      }
   }
}


obj_t 
_do_alphatize_43_ast_alphatize(obj_t env_2499, obj_t node_2500)
{
   {
      node_t aux_3658;
      aux_3658 = do_alphatize_126_ast_alphatize((node_t) (node_2500));
      return (obj_t) (aux_3658);
   }
}


obj_t 
imported_modules_init_94_ast_alphatize()
{
   module_initialization_70_type_type(((long) 0), "AST_ALPHATIZE");
   module_initialization_70_ast_var(((long) 0), "AST_ALPHATIZE");
   module_initialization_70_ast_node(((long) 0), "AST_ALPHATIZE");
   module_initialization_70_tools_error(((long) 0), "AST_ALPHATIZE");
   module_initialization_70_tools_shape(((long) 0), "AST_ALPHATIZE");
   module_initialization_70_type_cache(((long) 0), "AST_ALPHATIZE");
   module_initialization_70_ast_sexp(((long) 0), "AST_ALPHATIZE");
   module_initialization_70_ast_local(((long) 0), "AST_ALPHATIZE");
   module_initialization_70_ast_apply(((long) 0), "AST_ALPHATIZE");
   return module_initialization_70_ast_app(((long) 0), "AST_ALPHATIZE");
}
