/*===========================================================================*/
/*   (Ast/app.scm)                                                           */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t _application__node_41_ast_app(obj_t, obj_t, obj_t, obj_t, obj_t);
static node_t make_va_app_node_0_ast_app(long, obj_t, obj_t, var_t, obj_t);
extern obj_t fun_ast_var;
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_ast_app();
extern obj_t module_initialization_70_ast_app(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t cnst_init_137_ast_app();
extern node_t make_app_node_80_ast_app(obj_t, obj_t, var_t, obj_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static long check_user_app_174_ast_app(node_t, obj_t);
static obj_t require_initialization_114_ast_app = BUNSPEC;
extern obj_t var_ast_node;
static obj_t make_fx_app_node_213_ast_app(obj_t, var_t, obj_t);
static obj_t library_modules_init_112_ast_app();
extern node_t application__node_43_ast_app(obj_t, obj_t, obj_t, obj_t);
extern obj_t _make_app_node_45_ast_app(obj_t, obj_t, obj_t, obj_t, obj_t);
extern char *number__string_214___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t make_args_list_220_ast_app(obj_t);
extern long class_num_218___object(obj_t);
static node_t wrong_number_of_arguments_4_ast_app(obj_t, obj_t, node_t, obj_t);
extern node_t error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern long list_length(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _____74_type_cache;
static obj_t make_the_app_69_ast_app(obj_t, obj_t, obj_t);
extern obj_t _correct_arity_app__125_ast_app(obj_t, obj_t, obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern bool_t correct_arity_app__187_ast_app(variable_t, obj_t);
extern bool_t __fx_134___r4_numbers_6_5_fixnum(long, long);
extern obj_t app_ast_node;
static obj_t __cnst[12];

DEFINE_EXPORT_PROCEDURE(make_app_node_env_134_ast_app, _make_app_node_45_ast_app1681, _make_app_node_45_ast_app, 0L, 4);
DEFINE_STRING(string1669_ast_app, string1669_ast_app1682, " arg(s) expected, ", 18);
DEFINE_STRING(string1670_ast_app, string1670_ast_app1683, " or more arg(s) expected, ", 26);
DEFINE_STRING(string1673_ast_app, string1673_ast_app1684, "FOREIGN C-CONS LIST \077\077\077 ARG (LAMBDA L L) LET FUN VALUE (QUOTE ()) APP @ ", 72);
DEFINE_STRING(string1671_ast_app, string1671_ast_app1685, " provided", 9);
DEFINE_EXPORT_PROCEDURE(correct_arity_app__env_151_ast_app, _correct_arity_app__125_ast_app1686, _correct_arity_app__125_ast_app, 0L, 2);
DEFINE_STRING(string1672_ast_app, string1672_ast_app1687, "Illegal application: ", 21);
DEFINE_EXPORT_PROCEDURE(application__node_env_37_ast_app, _application__node_41_ast_app1688, _application__node_41_ast_app, 0L, 4);

obj_t 
module_initialization_70_ast_app(long checksum_1455, char *from_1456)
{
   if (CBOOL(require_initialization_114_ast_app))
     {
	require_initialization_114_ast_app = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_app();
	cnst_init_137_ast_app();
	imported_modules_init_94_ast_app();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_app()
{
   module_initialization_70___object(((long) 0), "AST_APP");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_APP");
   module_initialization_70___r4_numbers_6_5(((long) 0), "AST_APP");
   module_initialization_70___reader(((long) 0), "AST_APP");
   module_initialization_70___r4_symbols_6_4(((long) 0), "AST_APP");
   module_initialization_70___r4_strings_6_7(((long) 0), "AST_APP");
   module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "AST_APP");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_app()
{
   {
      obj_t cnst_port_138_1447;
      cnst_port_138_1447 = open_input_string(string1673_ast_app);
      {
	 long i_1448;
	 i_1448 = ((long) 11);
       loop_1449:
	 {
	    bool_t test1674_1450;
	    test1674_1450 = (i_1448 == ((long) -1));
	    if (test1674_1450)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1677_1451;
		    {
		       obj_t list1678_1452;
		       {
			  obj_t arg1679_1453;
			  arg1679_1453 = BNIL;
			  list1678_1452 = MAKE_PAIR(cnst_port_138_1447, arg1679_1453);
		       }
		       arg1677_1451 = read___reader(list1678_1452);
		    }
		    CNST_TABLE_SET(i_1448, arg1677_1451);
		 }
		 {
		    int aux_1454;
		    {
		       long aux_1476;
		       aux_1476 = (i_1448 - ((long) 1));
		       aux_1454 = (int) (aux_1476);
		    }
		    {
		       long i_1479;
		       i_1479 = (long) (aux_1454);
		       i_1448 = i_1479;
		       goto loop_1449;
		    }
		 }
	      }
	 }
      }
   }
}


bool_t 
correct_arity_app__187_ast_app(variable_t var_1, obj_t args_2)
{
   {
      long nb_args_51_655;
      nb_args_51_655 = list_length(args_2);
      {
	 long arity_656;
	 {
	    fun_t obj_1227;
	    {
	       value_t aux_1482;
	       aux_1482 = (((variable_t) CREF(var_1))->value);
	       obj_1227 = (fun_t) (aux_1482);
	    }
	    arity_656 = (((fun_t) CREF(obj_1227))->arity);
	 }
	 {
	    if ((arity_656 == ((long) -1)))
	      {
		 return ((bool_t) 1);
	      }
	    else
	      {
		 if ((arity_656 >= ((long) 0)))
		   {
		      return __fx_134___r4_numbers_6_5_fixnum(arity_656, nb_args_51_655);
		   }
		 else
		   {
		      {
			 long aux_1491;
			 {
			    long aux_1494;
			    long aux_1492;
			    aux_1494 = (nb_args_51_655 + ((long) 1));
			    aux_1492 = NEG(arity_656);
			    aux_1491 = (aux_1492 - aux_1494);
			 }
			 return (aux_1491 <= ((long) 0));
		      }
		   }
	      }
	 }
      }
   }
}


obj_t 
_correct_arity_app__125_ast_app(obj_t env_1431, obj_t var_1432, obj_t args_1433)
{
   {
      bool_t aux_1498;
      aux_1498 = correct_arity_app__187_ast_app((variable_t) (var_1432), args_1433);
      return BBOOL(aux_1498);
   }
}


node_t 
application__node_43_ast_app(obj_t exp_3, obj_t stack_4, obj_t loc_5, obj_t site_6)
{
   {
      obj_t exp_753;
      {
	 obj_t loc_664;
	 loc_664 = find_location_loc_243_tools_location(exp_3, loc_5);
	 {
	    obj_t err_nb_106_665;
	    err_nb_106_665 = __nb_error_on_pass__70_tools_error;
	    {
	       node_t fun_666;
	       fun_666 = sexp__node_235_ast_sexp(CAR(exp_3), stack_4, loc_664, CNST_TABLE_REF(((long) 1)));
	       {
		  bool_t fun_err__19_667;
		  {
		     long n1_1240;
		     long n2_1241;
		     n1_1240 = (long) CINT(__nb_error_on_pass__70_tools_error);
		     n2_1241 = (long) CINT(err_nb_106_665);
		     fun_err__19_667 = (n1_1240 > n2_1241);
		  }
		  {
		     {
			bool_t test1297_668;
			{
			   bool_t test_1509;
			   exp_753 = exp_3;
			   {
			      obj_t exp_755;
			      exp_755 = exp_753;
			    loop_756:
			      if (NULLP(exp_755))
				{
				   test_1509 = ((bool_t) 1);
				}
			      else
				{
				   {
				      obj_t e_104_34_761;
				      e_104_34_761 = CAR(exp_755);
				      if (PAIRP(e_104_34_761))
					{
					   obj_t cdr_108_37_763;
					   cdr_108_37_763 = CDR(e_104_34_761);
					   {
					      bool_t test_1516;
					      {
						 obj_t aux_1519;
						 obj_t aux_1517;
						 aux_1519 = CNST_TABLE_REF(((long) 0));
						 aux_1517 = CAR(e_104_34_761);
						 test_1516 = (aux_1517 == aux_1519);
					      }
					      if (test_1516)
						{
						   if (PAIRP(cdr_108_37_763))
						     {
							obj_t cdr_110_67_766;
							cdr_110_67_766 = CDR(cdr_108_37_763);
							{
							   bool_t test_1525;
							   {
							      obj_t aux_1526;
							      aux_1526 = CAR(cdr_108_37_763);
							      test_1525 = SYMBOLP(aux_1526);
							   }
							   if (test_1525)
							     {
								if (PAIRP(cdr_110_67_766))
								  {
								     bool_t test_1531;
								     {
									obj_t aux_1532;
									aux_1532 = CAR(cdr_110_67_766);
									test_1531 = SYMBOLP(aux_1532);
								     }
								     if (test_1531)
								       {
									  bool_t test_1535;
									  {
									     obj_t aux_1536;
									     aux_1536 = CDR(cdr_110_67_766);
									     test_1535 = (aux_1536 == BNIL);
									  }
									  if (test_1535)
									    {
									       {
										  obj_t exp_1539;
										  exp_1539 = CDR(exp_755);
										  exp_755 = exp_1539;
										  goto loop_756;
									       }
									    }
									  else
									    {
									     tag_103_156_760:
									       {
										  bool_t _ortest_1272_779;
										  _ortest_1272_779 = is_a__118___object(CAR(exp_755), atom_ast_node);
										  if (_ortest_1272_779)
										    {
										       test_1509 = _ortest_1272_779;
										    }
										  else
										    {
										       test_1509 = is_a__118___object(CAR(exp_755), var_ast_node);
										    }
									       }
									    }
								       }
								     else
								       {
									  goto tag_103_156_760;
								       }
								  }
								else
								  {
								     goto tag_103_156_760;
								  }
							     }
							   else
							     {
								goto tag_103_156_760;
							     }
							}
						     }
						   else
						     {
							goto tag_103_156_760;
						     }
						}
					      else
						{
						   goto tag_103_156_760;
						}
					   }
					}
				      else
					{
					   {
					      obj_t exp_1546;
					      exp_1546 = CDR(exp_755);
					      exp_755 = exp_1546;
					      goto loop_756;
					   }
					}
				   }
				}
			   }
			   if (test_1509)
			     {
				test1297_668 = is_a__118___object((obj_t) (fun_666), var_ast_node);
			     }
			   else
			     {
				test1297_668 = ((bool_t) 0);
			     }
			}
			if (test1297_668)
			  {
			     obj_t args_669;
			     args_669 = CDR(exp_3);
			     {
				long delta_670;
				delta_670 = check_user_app_174_ast_app(fun_666, args_669);
				{
				   {
				      bool_t test1298_671;
				      test1298_671 = is_a__118___object((obj_t) (fun_666), var_ast_node);
				      if (test1298_671)
					{
					   if ((delta_670 == ((long) 0)))
					     {
						return make_app_node_80_ast_app(stack_4, loc_664, (var_t) (fun_666), args_669);
					     }
					   else
					     {
						return wrong_number_of_arguments_4_ast_app(exp_3, loc_664, fun_666, args_669);
					     }
					}
				      else
					{
					   return sexp__node_235_ast_sexp(CNST_TABLE_REF(((long) 2)), stack_4, loc_664, CNST_TABLE_REF(((long) 3)));
					}
				   }
				}
			     }
			  }
			else
			  {
			     obj_t old_args_130_675;
			     obj_t new_args_235_676;
			     obj_t bindings_677;
			     old_args_130_675 = CDR(exp_3);
			     new_args_235_676 = BNIL;
			     bindings_677 = BNIL;
			   loop_678:
			     if (NULLP(old_args_130_675))
			       {
				  {
				     obj_t old_fun_147_683;
				     old_fun_147_683 = CAR(exp_3);
				     {
					bool_t test1310_685;
					test1310_685 = is_a__118___object((obj_t) (fun_666), var_ast_node);
					if (test1310_685)
					  {
					     obj_t arg1311_686;
					     arg1311_686 = make_the_app_69_ast_app(new_args_235_676, bindings_677, old_fun_147_683);
					     return sexp__node_235_ast_sexp(arg1311_686, stack_4, loc_664, site_6);
					  }
					else
					  {
					     obj_t new_fun_115_687;
					     new_fun_115_687 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 4)), BEOA);
					     {
						obj_t arg1312_688;
						{
						   obj_t arg1313_689;
						   obj_t arg1314_690;
						   obj_t arg1315_691;
						   arg1313_689 = CNST_TABLE_REF(((long) 5));
						   {
						      obj_t arg1321_697;
						      {
							 obj_t arg1327_701;
							 if (fun_err__19_667)
							   {
							      arg1327_701 = CNST_TABLE_REF(((long) 6));
							   }
							 else
							   {
							      arg1327_701 = old_fun_147_683;
							   }
							 {
							    obj_t list1329_703;
							    {
							       obj_t arg1331_704;
							       arg1331_704 = MAKE_PAIR(BNIL, BNIL);
							       list1329_703 = MAKE_PAIR(arg1327_701, arg1331_704);
							    }
							    arg1321_697 = cons__138___r4_pairs_and_lists_6_3(new_fun_115_687, list1329_703);
							 }
						      }
						      {
							 obj_t list1323_699;
							 list1323_699 = MAKE_PAIR(BNIL, BNIL);
							 arg1314_690 = cons__138___r4_pairs_and_lists_6_3(arg1321_697, list1323_699);
						      }
						   }
						   arg1315_691 = make_the_app_69_ast_app(new_args_235_676, bindings_677, new_fun_115_687);
						   {
						      obj_t list1317_693;
						      {
							 obj_t arg1318_694;
							 {
							    obj_t arg1319_695;
							    arg1319_695 = MAKE_PAIR(BNIL, BNIL);
							    arg1318_694 = MAKE_PAIR(arg1315_691, arg1319_695);
							 }
							 list1317_693 = MAKE_PAIR(arg1314_690, arg1318_694);
						      }
						      arg1312_688 = cons__138___r4_pairs_and_lists_6_3(arg1313_689, list1317_693);
						   }
						}
						return sexp__node_235_ast_sexp(arg1312_688, stack_4, loc_664, site_6);
					     }
					  }
				     }
				  }
			       }
			     else
			       {
				  bool_t test_1589;
				  {
				     bool_t test_1590;
				     {
					obj_t aux_1591;
					aux_1591 = CAR(old_args_130_675);
					test_1590 = SYMBOLP(aux_1591);
				     }
				     if (test_1590)
				       {
					  test_1589 = ((bool_t) 1);
				       }
				     else
				       {
					  obj_t aux_1594;
					  aux_1594 = CAR(old_args_130_675);
					  test_1589 = CNSTP(aux_1594);
				       }
				  }
				  if (test_1589)
				    {
				       {
					  obj_t arg1369_734;
					  obj_t arg1370_735;
					  arg1369_734 = CDR(old_args_130_675);
					  {
					     obj_t aux_1598;
					     aux_1598 = CAR(old_args_130_675);
					     arg1370_735 = MAKE_PAIR(aux_1598, new_args_235_676);
					  }
					  {
					     obj_t new_args_235_1602;
					     obj_t old_args_130_1601;
					     old_args_130_1601 = arg1369_734;
					     new_args_235_1602 = arg1370_735;
					     new_args_235_676 = new_args_235_1602;
					     old_args_130_675 = old_args_130_1601;
					     goto loop_678;
					  }
				       }
				    }
				  else
				    {
				       {
					  obj_t new_arg_128_737;
					  new_arg_128_737 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 7)), BEOA);
					  {
					     obj_t arg1376_738;
					     obj_t arg1379_739;
					     obj_t arg1380_740;
					     arg1376_738 = CDR(old_args_130_675);
					     arg1379_739 = MAKE_PAIR(new_arg_128_737, new_args_235_676);
					     {
						obj_t arg1381_741;
						{
						   obj_t list1383_743;
						   {
						      obj_t arg1385_744;
						      {
							 obj_t aux_1608;
							 aux_1608 = CAR(old_args_130_675);
							 arg1385_744 = MAKE_PAIR(aux_1608, BNIL);
						      }
						      list1383_743 = MAKE_PAIR(new_arg_128_737, arg1385_744);
						   }
						   arg1381_741 = list1383_743;
						}
						arg1380_740 = MAKE_PAIR(arg1381_741, bindings_677);
					     }
					     {
						obj_t bindings_1615;
						obj_t new_args_235_1614;
						obj_t old_args_130_1613;
						old_args_130_1613 = arg1376_738;
						new_args_235_1614 = arg1379_739;
						bindings_1615 = arg1380_740;
						bindings_677 = bindings_1615;
						new_args_235_676 = new_args_235_1614;
						old_args_130_675 = old_args_130_1613;
						goto loop_678;
					     }
					  }
				       }
				    }
			       }
			  }
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
make_the_app_69_ast_app(obj_t new_args_235_1445, obj_t bindings_1444, obj_t fun_707)
{
   if (PAIRP(bindings_1444))
     {
	obj_t arg1337_710;
	obj_t arg1339_711;
	obj_t arg1340_712;
	arg1337_710 = CNST_TABLE_REF(((long) 5));
	arg1339_711 = reverse__39___r4_pairs_and_lists_6_3(bindings_1444);
	{
	   obj_t arg1349_718;
	   {
	      obj_t arg1353_721;
	      obj_t arg1355_722;
	      arg1353_721 = reverse__39___r4_pairs_and_lists_6_3(new_args_235_1445);
	      arg1355_722 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
	      arg1349_718 = append_2_18___r4_pairs_and_lists_6_3(arg1353_721, arg1355_722);
	   }
	   {
	      obj_t list1350_719;
	      list1350_719 = MAKE_PAIR(arg1349_718, BNIL);
	      arg1340_712 = cons__138___r4_pairs_and_lists_6_3(fun_707, list1350_719);
	   }
	}
	{
	   obj_t list1343_714;
	   {
	      obj_t arg1345_715;
	      {
		 obj_t arg1346_716;
		 arg1346_716 = MAKE_PAIR(BNIL, BNIL);
		 arg1345_715 = MAKE_PAIR(arg1340_712, arg1346_716);
	      }
	      list1343_714 = MAKE_PAIR(arg1339_711, arg1345_715);
	   }
	   return cons__138___r4_pairs_and_lists_6_3(arg1337_710, list1343_714);
	}
     }
   else
     {
	obj_t arg1358_725;
	{
	   obj_t arg1363_728;
	   obj_t arg1364_729;
	   arg1363_728 = reverse__39___r4_pairs_and_lists_6_3(new_args_235_1445);
	   arg1364_729 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
	   arg1358_725 = append_2_18___r4_pairs_and_lists_6_3(arg1363_728, arg1364_729);
	}
	{
	   obj_t list1359_726;
	   list1359_726 = MAKE_PAIR(arg1358_725, BNIL);
	   return cons__138___r4_pairs_and_lists_6_3(fun_707, list1359_726);
	}
     }
}


obj_t 
_application__node_41_ast_app(obj_t env_1434, obj_t exp_1435, obj_t stack_1436, obj_t loc_1437, obj_t site_1438)
{
   {
      node_t aux_1635;
      aux_1635 = application__node_43_ast_app(exp_1435, stack_1436, loc_1437, site_1438);
      return (obj_t) (aux_1635);
   }
}


node_t 
wrong_number_of_arguments_4_ast_app(obj_t exp_7, obj_t loc_8, node_t fun_9, obj_t args_10)
{
   {
      variable_t var_783;
      {
	 var_t obj_1290;
	 obj_1290 = (var_t) (fun_9);
	 var_783 = (((var_t) CREF(obj_1290))->variable);
      }
      {
	 value_t fun_784;
	 fun_784 = (((variable_t) CREF(var_783))->value);
	 {
	    long nb_args_51_785;
	    nb_args_51_785 = list_length(args_10);
	    {
	       long arity_786;
	       {
		  bool_t test1458_808;
		  test1458_808 = is_a__118___object((obj_t) (fun_784), fun_ast_var);
		  if (test1458_808)
		    {
		       {
			  fun_t obj_1293;
			  obj_1293 = (fun_t) (fun_784);
			  arity_786 = (((fun_t) CREF(obj_1293))->arity);
		       }
		    }
		  else
		    {
		       arity_786 = ((long) -1);
		    }
	       }
	       {
		  obj_t expect_787;
		  if ((arity_786 >= ((long) 0)))
		    {
		       {
			  obj_t aux_1649;
			  {
			     char *aux_1650;
			     aux_1650 = number__string_214___r4_numbers_6_5(BINT(arity_786), BNIL);
			     aux_1649 = string_to_bstring(aux_1650);
			  }
			  expect_787 = string_append(aux_1649, string1669_ast_app);
		       }
		    }
		  else
		    {
		       {
			  obj_t aux_1655;
			  {
			     char *aux_1656;
			     {
				obj_t aux_1657;
				{
				   long aux_1658;
				   {
				      long aux_1659;
				      aux_1659 = (arity_786 + ((long) 1));
				      aux_1658 = NEG(aux_1659);
				   }
				   aux_1657 = BINT(aux_1658);
				}
				aux_1656 = number__string_214___r4_numbers_6_5(aux_1657, BNIL);
			     }
			     aux_1655 = string_to_bstring(aux_1656);
			  }
			  expect_787 = string_append(aux_1655, string1670_ast_app);
		       }
		    }
		  {
		     obj_t provide_788;
		     {
			obj_t aux_1666;
			{
			   char *aux_1667;
			   aux_1667 = number__string_214___r4_numbers_6_5(BINT(nb_args_51_785), BNIL);
			   aux_1666 = string_to_bstring(aux_1667);
			}
			provide_788 = string_append(aux_1666, string1671_ast_app);
		     }
		     {
			{
			   obj_t arg1427_789;
			   {
			      obj_t list1428_790;
			      {
				 obj_t arg1432_792;
				 {
				    obj_t arg1440_793;
				    arg1440_793 = MAKE_PAIR(provide_788, BNIL);
				    arg1432_792 = MAKE_PAIR(expect_787, arg1440_793);
				 }
				 list1428_790 = MAKE_PAIR(string1672_ast_app, arg1432_792);
			      }
			      arg1427_789 = string_append_106___r4_strings_6_7(list1428_790);
			   }
			   return error_sexp__node_157_ast_sexp(arg1427_789, exp_7, loc_8);
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


node_t 
make_app_node_80_ast_app(obj_t stack_11, obj_t loc_12, var_t var_13, obj_t args_14)
{
   {
      value_t fun_809;
      {
	 variable_t arg1477_831;
	 arg1477_831 = (((var_t) CREF(var_13))->variable);
	 fun_809 = (((variable_t) CREF(arg1477_831))->value);
      }
      {
	 bool_t test1459_810;
	 {
	    bool_t test1472_828;
	    test1472_828 = is_a__118___object((obj_t) (fun_809), fun_ast_var);
	    if (test1472_828)
	      {
		 long aux_1682;
		 {
		    fun_t obj_1302;
		    obj_1302 = (fun_t) (fun_809);
		    aux_1682 = (((fun_t) CREF(obj_1302))->arity);
		 }
		 test1459_810 = (aux_1682 >= ((long) 0));
	      }
	    else
	      {
		 test1459_810 = ((bool_t) 1);
	      }
	 }
	 if (test1459_810)
	   {
	      obj_t args_811;
	      if (NULLP(args_14))
		{
		   args_811 = BNIL;
		}
	      else
		{
		   obj_t head1284_814;
		   head1284_814 = MAKE_PAIR(BNIL, BNIL);
		   {
		      obj_t l1273_815;
		      obj_t tail1285_816;
		      l1273_815 = args_14;
		      tail1285_816 = head1284_814;
		    lname1283_817:
		      if (NULLP(l1273_815))
			{
			   args_811 = CDR(head1284_814);
			}
		      else
			{
			   obj_t new_tail1286_4_819;
			   {
			      node_t arg1465_821;
			      arg1465_821 = sexp__node_235_ast_sexp(CAR(l1273_815), stack_11, loc_12, CNST_TABLE_REF(((long) 3)));
			      {
				 obj_t aux_1696;
				 aux_1696 = (obj_t) (arg1465_821);
				 new_tail1286_4_819 = MAKE_PAIR(aux_1696, BNIL);
			      }
			   }
			   SET_CDR(tail1285_816, new_tail1286_4_819);
			   {
			      obj_t tail1285_1702;
			      obj_t l1273_1700;
			      l1273_1700 = CDR(l1273_815);
			      tail1285_1702 = new_tail1286_4_819;
			      tail1285_816 = tail1285_1702;
			      l1273_815 = l1273_1700;
			      goto lname1283_817;
			   }
			}
		   }
		}
	      {
		 obj_t aux_1703;
		 aux_1703 = make_fx_app_node_213_ast_app(loc_12, var_13, args_811);
		 return (node_t) (aux_1703);
	      }
	   }
	 else
	   {
	      long aux_1706;
	      {
		 fun_t obj_1316;
		 obj_1316 = (fun_t) (fun_809);
		 aux_1706 = (((fun_t) CREF(obj_1316))->arity);
	      }
	      return make_va_app_node_0_ast_app(aux_1706, stack_11, loc_12, var_13, args_14);
	   }
      }
   }
}


obj_t 
_make_app_node_45_ast_app(obj_t env_1439, obj_t stack_1440, obj_t loc_1441, obj_t var_1442, obj_t args_1443)
{
   {
      node_t aux_1710;
      aux_1710 = make_app_node_80_ast_app(stack_1440, loc_1441, (var_t) (var_1442), args_1443);
      return (obj_t) (aux_1710);
   }
}


obj_t 
make_fx_app_node_213_ast_app(obj_t loc_15, var_t var_16, obj_t args_17)
{
   {
      variable_t v_832;
      v_832 = (((var_t) CREF(var_16))->variable);
      {
	 bool_t test1478_833;
	 {
	    obj_t aux_1715;
	    {
	       value_t aux_1716;
	       aux_1716 = (((variable_t) CREF(v_832))->value);
	       aux_1715 = (obj_t) (aux_1716);
	    }
	    test1478_833 = is_a__118___object(aux_1715, fun_ast_var);
	 }
	 if (test1478_833)
	   {
	      type_t arg1480_834;
	      var_t arg1481_835;
	      arg1480_834 = (((variable_t) CREF(v_832))->type);
	      {
		 bool_t test1482_836;
		 test1482_836 = is_a__118___object((obj_t) (var_16), closure_ast_node);
		 if (test1482_836)
		   {
		      obj_t arg1484_838;
		      type_t arg1485_839;
		      variable_t arg1486_840;
		      arg1484_838 = (((var_t) CREF(var_16))->loc);
		      arg1485_839 = (((var_t) CREF(var_16))->type);
		      arg1486_840 = (((var_t) CREF(var_16))->variable);
		      {
			 var_t res1665_1335;
			 {
			    var_t new1128_1328;
			    new1128_1328 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
			    {
			       long arg1621_1329;
			       arg1621_1329 = class_num_218___object(var_ast_node);
			       {
				  obj_t obj_1333;
				  obj_1333 = (obj_t) (new1128_1328);
				  (((obj_t) CREF(obj_1333))->header = MAKE_HEADER(arg1621_1329, 0), BUNSPEC);
			       }
			    }
			    {
			       object_t aux_1732;
			       aux_1732 = (object_t) (new1128_1328);
			       OBJECT_WIDENING_SET(aux_1732, BFALSE);
			    }
			    ((((var_t) CREF(new1128_1328))->loc) = ((obj_t) arg1484_838), BUNSPEC);
			    ((((var_t) CREF(new1128_1328))->type) = ((type_t) arg1485_839), BUNSPEC);
			    ((((var_t) CREF(new1128_1328))->variable) = ((variable_t) arg1486_840), BUNSPEC);
			    res1665_1335 = new1128_1328;
			 }
			 arg1481_835 = res1665_1335;
		      }
		   }
		 else
		   {
		      arg1481_835 = var_16;
		   }
	      }
	      {
		 app_t res1666_1352;
		 {
		    app_t new1151_1342;
		    new1151_1342 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
		    {
		       long arg1609_1343;
		       arg1609_1343 = class_num_218___object(app_ast_node);
		       {
			  obj_t obj_1350;
			  obj_1350 = (obj_t) (new1151_1342);
			  (((obj_t) CREF(obj_1350))->header = MAKE_HEADER(arg1609_1343, 0), BUNSPEC);
		       }
		    }
		    {
		       object_t aux_1742;
		       aux_1742 = (object_t) (new1151_1342);
		       OBJECT_WIDENING_SET(aux_1742, BFALSE);
		    }
		    ((((app_t) CREF(new1151_1342))->loc) = ((obj_t) loc_15), BUNSPEC);
		    ((((app_t) CREF(new1151_1342))->type) = ((type_t) arg1480_834), BUNSPEC);
		    ((((app_t) CREF(new1151_1342))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		    ((((app_t) CREF(new1151_1342))->fun) = ((var_t) arg1481_835), BUNSPEC);
		    ((((app_t) CREF(new1151_1342))->args) = ((obj_t) args_17), BUNSPEC);
		    ((((app_t) CREF(new1151_1342))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
		    res1666_1352 = new1151_1342;
		 }
		 return (obj_t) (res1666_1352);
	      }
	   }
	 else
	   {
	      obj_t arg1487_841;
	      obj_t arg1489_842;
	      {
		 obj_t aux_1752;
		 aux_1752 = (obj_t) (var_16);
		 arg1487_841 = MAKE_PAIR(aux_1752, args_17);
	      }
	      arg1489_842 = CNST_TABLE_REF(((long) 8));
	      {
		 funcall_t res1667_1369;
		 {
		    type_t type_1356;
		    node_t fun_1357;
		    type_1356 = (type_t) (_____74_type_cache);
		    fun_1357 = (node_t) (var_16);
		    {
		       funcall_t new1167_1360;
		       new1167_1360 = ((funcall_t) BREF(GC_MALLOC(sizeof(struct funcall))));
		       {
			  long arg1604_1361;
			  arg1604_1361 = class_num_218___object(funcall_ast_node);
			  {
			     obj_t obj_1367;
			     obj_1367 = (obj_t) (new1167_1360);
			     (((obj_t) CREF(obj_1367))->header = MAKE_HEADER(arg1604_1361, 0), BUNSPEC);
			  }
		       }
		       {
			  object_t aux_1762;
			  aux_1762 = (object_t) (new1167_1360);
			  OBJECT_WIDENING_SET(aux_1762, BFALSE);
		       }
		       ((((funcall_t) CREF(new1167_1360))->loc) = ((obj_t) loc_15), BUNSPEC);
		       ((((funcall_t) CREF(new1167_1360))->type) = ((type_t) type_1356), BUNSPEC);
		       ((((funcall_t) CREF(new1167_1360))->fun) = ((node_t) fun_1357), BUNSPEC);
		       ((((funcall_t) CREF(new1167_1360))->args) = ((obj_t) arg1487_841), BUNSPEC);
		       ((((funcall_t) CREF(new1167_1360))->strength) = ((obj_t) arg1489_842), BUNSPEC);
		       res1667_1369 = new1167_1360;
		    }
		 }
		 return (obj_t) (res1667_1369);
	      }
	   }
      }
   }
}


node_t 
make_va_app_node_0_ast_app(long arity_18, obj_t stack_19, obj_t loc_20, var_t var_21, obj_t args_22)
{
   {
      obj_t old_args_130_845;
      long arity_846;
      obj_t f_args_123_847;
      old_args_130_845 = args_22;
      arity_846 = arity_18;
      f_args_123_847 = BNIL;
    loop_848:
      if ((arity_846 == ((long) -1)))
	{
	   obj_t l_arg_48_851;
	   l_arg_48_851 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 9)), BEOA);
	   {
	      obj_t l_exp_15_852;
	      {
		 obj_t arg1499_859;
		 obj_t arg1500_860;
		 arg1499_859 = CNST_TABLE_REF(((long) 5));
		 {
		    obj_t arg1509_866;
		    {
		       obj_t arg1514_870;
		       arg1514_870 = make_args_list_220_ast_app(old_args_130_845);
		       {
			  obj_t list1518_872;
			  {
			     obj_t arg1520_873;
			     arg1520_873 = MAKE_PAIR(BNIL, BNIL);
			     list1518_872 = MAKE_PAIR(arg1514_870, arg1520_873);
			  }
			  arg1509_866 = cons__138___r4_pairs_and_lists_6_3(l_arg_48_851, list1518_872);
		       }
		    }
		    {
		       obj_t list1511_868;
		       list1511_868 = MAKE_PAIR(BNIL, BNIL);
		       arg1500_860 = cons__138___r4_pairs_and_lists_6_3(arg1509_866, list1511_868);
		    }
		 }
		 {
		    obj_t list1502_862;
		    {
		       obj_t arg1505_863;
		       {
			  obj_t arg1506_864;
			  arg1506_864 = MAKE_PAIR(BNIL, BNIL);
			  arg1505_863 = MAKE_PAIR(l_arg_48_851, arg1506_864);
		       }
		       list1502_862 = MAKE_PAIR(arg1500_860, arg1505_863);
		    }
		    l_exp_15_852 = cons__138___r4_pairs_and_lists_6_3(arg1499_859, list1502_862);
		 }
	      }
	      {
		 node_t l_node_207_853;
		 l_node_207_853 = sexp__node_235_ast_sexp(l_exp_15_852, stack_19, loc_20, CNST_TABLE_REF(((long) 3)));
		 {
		    obj_t app_855;
		    {
		       obj_t arg1496_856;
		       {
			  obj_t arg1497_857;
			  {
			     obj_t aux_1789;
			     {
				node_t aux_1790;
				{
				   let_var_6_t obj_1372;
				   obj_1372 = (let_var_6_t) (l_node_207_853);
				   aux_1790 = (((let_var_6_t) CREF(obj_1372))->body);
				}
				aux_1789 = (obj_t) (aux_1790);
			     }
			     arg1497_857 = MAKE_PAIR(aux_1789, f_args_123_847);
			  }
			  arg1496_856 = reverse__39___r4_pairs_and_lists_6_3(arg1497_857);
		       }
		       app_855 = make_fx_app_node_213_ast_app(loc_20, var_21, arg1496_856);
		    }
		    {
		       {
			  obj_t res1668_1377;
			  {
			     let_var_6_t obj_1375;
			     node_t val1234_1376;
			     obj_1375 = (let_var_6_t) (l_node_207_853);
			     val1234_1376 = (node_t) (app_855);
			     {
				obj_t x_1446;
				x_1446 = ((((let_var_6_t) CREF(obj_1375))->body) = ((node_t) val1234_1376), BUNSPEC);
				res1668_1377 = BUNSPEC;
			     }
			  }
			  res1668_1377;
		       }
		       return l_node_207_853;
		    }
		 }
	      }
	   }
	}
      else
	{
	   obj_t arg1524_876;
	   long arg1526_877;
	   obj_t arg1529_878;
	   arg1524_876 = CDR(old_args_130_845);
	   arg1526_877 = (arity_846 + ((long) 1));
	   {
	      node_t arg1531_879;
	      arg1531_879 = sexp__node_235_ast_sexp(CAR(old_args_130_845), stack_19, loc_20, CNST_TABLE_REF(((long) 3)));
	      {
		 obj_t aux_1805;
		 aux_1805 = (obj_t) (arg1531_879);
		 arg1529_878 = MAKE_PAIR(aux_1805, f_args_123_847);
	      }
	   }
	   {
	      obj_t f_args_123_1810;
	      long arity_1809;
	      obj_t old_args_130_1808;
	      old_args_130_1808 = arg1524_876;
	      arity_1809 = arg1526_877;
	      f_args_123_1810 = arg1529_878;
	      f_args_123_847 = f_args_123_1810;
	      arity_846 = arity_1809;
	      old_args_130_845 = old_args_130_1808;
	      goto loop_848;
	   }
	}
   }
}


obj_t 
make_args_list_220_ast_app(obj_t args_882)
{
   if (NULLP(args_882))
     {
	return CNST_TABLE_REF(((long) 2));
     }
   else
     {
	obj_t arg1537_885;
	obj_t arg1538_886;
	obj_t arg1539_887;
	{
	   obj_t arg1549_893;
	   obj_t arg1550_894;
	   obj_t arg1551_895;
	   arg1549_893 = CNST_TABLE_REF(((long) 0));
	   arg1550_894 = CNST_TABLE_REF(((long) 10));
	   arg1551_895 = CNST_TABLE_REF(((long) 11));
	   {
	      obj_t list1553_897;
	      {
		 obj_t arg1554_898;
		 {
		    obj_t arg1555_899;
		    arg1555_899 = MAKE_PAIR(BNIL, BNIL);
		    arg1554_898 = MAKE_PAIR(arg1551_895, arg1555_899);
		 }
		 list1553_897 = MAKE_PAIR(arg1550_894, arg1554_898);
	      }
	      arg1537_885 = cons__138___r4_pairs_and_lists_6_3(arg1549_893, list1553_897);
	   }
	}
	arg1538_886 = CAR(args_882);
	arg1539_887 = make_args_list_220_ast_app(CDR(args_882));
	{
	   obj_t list1541_889;
	   {
	      obj_t arg1542_890;
	      {
		 obj_t arg1543_891;
		 arg1543_891 = MAKE_PAIR(BNIL, BNIL);
		 arg1542_890 = MAKE_PAIR(arg1539_887, arg1543_891);
	      }
	      list1541_889 = MAKE_PAIR(arg1538_886, arg1542_890);
	   }
	   return cons__138___r4_pairs_and_lists_6_3(arg1537_885, list1541_889);
	}
     }
}


long 
check_user_app_174_ast_app(node_t fun_23, obj_t args_24)
{
   {
      bool_t test1560_903;
      test1560_903 = is_a__118___object((obj_t) (fun_23), var_ast_node);
      if (test1560_903)
	{
	   variable_t var_904;
	   {
	      var_t obj_1388;
	      obj_1388 = (var_t) (fun_23);
	      var_904 = (((var_t) CREF(obj_1388))->variable);
	   }
	   {
	      value_t fun_905;
	      fun_905 = (((variable_t) CREF(var_904))->value);
	      {
		 long nb_args_51_906;
		 nb_args_51_906 = list_length(args_24);
		 {
		    long arity_907;
		    {
		       bool_t test1568_915;
		       test1568_915 = is_a__118___object((obj_t) (fun_905), fun_ast_var);
		       if (test1568_915)
			 {
			    {
			       fun_t obj_1391;
			       obj_1391 = (fun_t) (fun_905);
			       arity_907 = (((fun_t) CREF(obj_1391))->arity);
			    }
			 }
		       else
			 {
			    arity_907 = ((long) -1);
			 }
		    }
		    {
		       if ((arity_907 == ((long) -1)))
			 {
			    return ((long) 0);
			 }
		       else
			 {
			    if ((arity_907 >= ((long) 0)))
			      {
				 return (arity_907 - nb_args_51_906);
			      }
			    else
			      {
				 {
				    bool_t test_1845;
				    {
				       long aux_1846;
				       {
					  long aux_1849;
					  long aux_1847;
					  aux_1849 = (nb_args_51_906 + ((long) 1));
					  aux_1847 = NEG(arity_907);
					  aux_1846 = (aux_1847 - aux_1849);
				       }
				       test_1845 = (aux_1846 <= ((long) 0));
				    }
				    if (test_1845)
				      {
					 return ((long) 0);
				      }
				    else
				      {
					 return ((long) 1);
				      }
				 }
			      }
			 }
		    }
		 }
	      }
	   }
	}
      else
	{
	   return ((long) 0);
	}
   }
}


obj_t 
imported_modules_init_94_ast_app()
{
   module_initialization_70_type_type(((long) 0), "AST_APP");
   module_initialization_70_ast_var(((long) 0), "AST_APP");
   module_initialization_70_ast_node(((long) 0), "AST_APP");
   module_initialization_70_tools_error(((long) 0), "AST_APP");
   module_initialization_70_tools_location(((long) 0), "AST_APP");
   module_initialization_70_tools_shape(((long) 0), "AST_APP");
   module_initialization_70_type_cache(((long) 0), "AST_APP");
   return module_initialization_70_ast_sexp(((long) 0), "AST_APP");
}
