/*===========================================================================*/
/*   (Ast/apply.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t _applycation__node_33_ast_apply(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t type_type_type;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fun_ast_var;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static let_var_6_t fx_known_app_ly__node_158_ast_apply(obj_t, obj_t, node_t, node_t, obj_t, obj_t);
static obj_t imported_modules_init_94_ast_apply();
extern obj_t _known_app_ly__node_80_ast_apply(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_ast_apply(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_app(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t toplevel_init_63_ast_apply();
static obj_t cnst_init_137_ast_apply();
extern obj_t cfun_ast_var;
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t require_initialization_114_ast_apply = BUNSPEC;
extern obj_t var_ast_node;
static obj_t library_modules_init_112_ast_apply();
extern obj_t sfun_ast_var;
extern node_t application__node_43_ast_app(obj_t, obj_t, obj_t, obj_t);
extern node_t known_app_ly__node_26_ast_apply(obj_t, obj_t, node_t, node_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t make_fun_frame_37_ast_apply(fun_t);
static let_var_6_t va_known_app_ly__node_104_ast_apply(obj_t, obj_t, node_t, node_t, obj_t, obj_t);
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
static obj_t _make_fun_frame_157_ast_apply(obj_t, obj_t);
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t app_ly_162_ast_node;
static obj_t loop1776_ast_apply(obj_t, node_t, obj_t, type_t, obj_t, obj_t, local_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern node_t error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
static obj_t loop_ast_apply(node_t, obj_t, type_t, obj_t, obj_t, local_t, obj_t, obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t make_fun_frame_default1294_241_ast_apply(fun_t);
extern obj_t __unsafe_arity__240_engine_param;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _____74_type_cache;
extern node_t applycation__node_122_ast_apply(obj_t, obj_t, obj_t, obj_t);
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
static obj_t _make_fun_frame_default1294_50_ast_apply(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t __cnst[14];

DEFINE_STRING(string1779_ast_apply, string1779_ast_apply1787, "Too many arguments provided", 27);
DEFINE_STRING(string1781_ast_apply, string1781_ast_apply1788, "SET! BEGIN CAR QUOTE FAILURE CDR NULL? IF WRITE RUNNER AUX MAKE-FUN-FRAME-DEFAULT1294 VALUE APPLY ", 98);
DEFINE_STRING(string1777_ast_apply, string1777_ast_apply1789, "Illegal `apply' form", 20);
DEFINE_EXPORT_PROCEDURE(known_app_ly__node_env_252_ast_apply, _known_app_ly__node_80_ast_apply1790, _known_app_ly__node_80_ast_apply, 0L, 5);
DEFINE_STATIC_GENERIC(make_fun_frame_env_121_ast_apply, _make_fun_frame_157_ast_apply1791, _make_fun_frame_157_ast_apply, 0L, 1);
DEFINE_STRING(string1778_ast_apply, string1778_ast_apply1792, "No method for this object", 25);
DEFINE_EXPORT_PROCEDURE(applycation__node_env_238_ast_apply, _applycation__node_33_ast_apply1793, _applycation__node_33_ast_apply, 0L, 4);
DEFINE_STATIC_PROCEDURE(make_fun_frame_default1294_env_180_ast_apply, _make_fun_frame_default1294_50_ast_apply1794, _make_fun_frame_default1294_50_ast_apply, 0L, 1);
DEFINE_STRING(string1780_ast_apply, string1780_ast_apply1795, "apply", 5);

obj_t 
module_initialization_70_ast_apply(long checksum_1734, char *from_1735)
{
   if (CBOOL(require_initialization_114_ast_apply))
     {
	require_initialization_114_ast_apply = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_apply();
	cnst_init_137_ast_apply();
	imported_modules_init_94_ast_apply();
	toplevel_init_63_ast_apply();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_apply()
{
   module_initialization_70___object(((long) 0), "AST_APPLY");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_APPLY");
   module_initialization_70___reader(((long) 0), "AST_APPLY");
   module_initialization_70___r4_symbols_6_4(((long) 0), "AST_APPLY");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_apply()
{
   {
      obj_t cnst_port_138_1726;
      cnst_port_138_1726 = open_input_string(string1781_ast_apply);
      {
	 long i_1727;
	 i_1727 = ((long) 13);
       loop_1728:
	 {
	    bool_t test1782_1729;
	    test1782_1729 = (i_1727 == ((long) -1));
	    if (test1782_1729)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1783_1730;
		    {
		       obj_t list1784_1731;
		       {
			  obj_t arg1785_1732;
			  arg1785_1732 = BNIL;
			  list1784_1731 = MAKE_PAIR(cnst_port_138_1726, arg1785_1732);
		       }
		       arg1783_1730 = read___reader(list1784_1731);
		    }
		    CNST_TABLE_SET(i_1727, arg1783_1730);
		 }
		 {
		    int aux_1733;
		    {
		       long aux_1753;
		       aux_1753 = (i_1727 - ((long) 1));
		       aux_1733 = (int) (aux_1753);
		    }
		    {
		       long i_1756;
		       i_1756 = (long) (aux_1733);
		       i_1727 = i_1756;
		       goto loop_1728;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_apply()
{
   add_generic__110___object(make_fun_frame_env_121_ast_apply, make_fun_frame_default1294_env_180_ast_apply);
   add_inlined_method__244___object(make_fun_frame_env_121_ast_apply, sfun_ast_var, ((long) 0));
   {
      long aux_1760;
      aux_1760 = add_inlined_method__244___object(make_fun_frame_env_121_ast_apply, cfun_ast_var, ((long) 1));
      return BINT(aux_1760);
   }
}


node_t 
applycation__node_122_ast_apply(obj_t exp_1, obj_t stack_2, obj_t loc_3, obj_t site_4)
{
   {
      obj_t proc_661;
      obj_t arg_662;
      if (PAIRP(exp_1))
	{
	   obj_t cdr_109_69_667;
	   cdr_109_69_667 = CDR(exp_1);
	   {
	      bool_t test_1766;
	      {
		 obj_t aux_1769;
		 obj_t aux_1767;
		 aux_1769 = CNST_TABLE_REF(((long) 0));
		 aux_1767 = CAR(exp_1);
		 test_1766 = (aux_1767 == aux_1769);
	      }
	      if (test_1766)
		{
		   if (PAIRP(cdr_109_69_667))
		     {
			obj_t cdr_113_28_670;
			cdr_113_28_670 = CDR(cdr_109_69_667);
			if (PAIRP(cdr_113_28_670))
			  {
			     bool_t test_1777;
			     {
				obj_t aux_1778;
				aux_1778 = CDR(cdr_113_28_670);
				test_1777 = (aux_1778 == BNIL);
			     }
			     if (test_1777)
			       {
				  obj_t aux_1781;
				  proc_661 = CAR(cdr_109_69_667);
				  arg_662 = CAR(cdr_113_28_670);
				  {
				     obj_t loc_679;
				     loc_679 = find_location_loc_243_tools_location(exp_1, loc_3);
				     {
					node_t proc_680;
					{
					   obj_t arg1319_688;
					   obj_t arg1320_689;
					   arg1319_688 = find_location_loc_243_tools_location(proc_661, loc_679);
					   arg1320_689 = CNST_TABLE_REF(((long) 0));
					   proc_680 = sexp__node_235_ast_sexp(proc_661, stack_2, arg1319_688, arg1320_689);
					}
					{
					   node_t arg_681;
					   {
					      obj_t arg1316_686;
					      obj_t arg1318_687;
					      arg1316_686 = find_location_loc_243_tools_location(arg_662, loc_679);
					      arg1318_687 = CNST_TABLE_REF(((long) 1));
					      arg_681 = sexp__node_235_ast_sexp(arg_662, stack_2, arg1316_686, arg1318_687);
					   }
					   {
					      {
						 bool_t test1312_682;
						 {
						    bool_t test1313_683;
						    test1313_683 = is_a__118___object((obj_t) (proc_680), var_ast_node);
						    if (test1313_683)
						      {
							 obj_t aux_1792;
							 {
							    value_t aux_1793;
							    {
							       variable_t arg1315_685;
							       {
								  var_t obj_1295;
								  obj_1295 = (var_t) (proc_680);
								  arg1315_685 = (((var_t) CREF(obj_1295))->variable);
							       }
							       aux_1793 = (((variable_t) CREF(arg1315_685))->value);
							    }
							    aux_1792 = (obj_t) (aux_1793);
							 }
							 test1312_682 = is_a__118___object(aux_1792, fun_ast_var);
						      }
						    else
						      {
							 test1312_682 = ((bool_t) 0);
						      }
						 }
						 if (test1312_682)
						   {
						      node_t aux_1800;
						      aux_1800 = known_app_ly__node_26_ast_apply(stack_2, loc_679, proc_680, arg_681, site_4);
						      aux_1781 = (obj_t) (aux_1800);
						   }
						 else
						   {
						      app_ly_162_t res1757_1310;
						      {
							 type_t type_1299;
							 type_1299 = (type_t) (_____74_type_cache);
							 {
							    app_ly_162_t new1160_1302;
							    new1160_1302 = ((app_ly_162_t) BREF(GC_MALLOC(sizeof(struct app_ly_162))));
							    {
							       long arg1651_1303;
							       arg1651_1303 = class_num_218___object(app_ly_162_ast_node);
							       {
								  obj_t obj_1308;
								  obj_1308 = (obj_t) (new1160_1302);
								  (((obj_t) CREF(obj_1308))->header = MAKE_HEADER(arg1651_1303, 0), BUNSPEC);
							       }
							    }
							    {
							       object_t aux_1808;
							       aux_1808 = (object_t) (new1160_1302);
							       OBJECT_WIDENING_SET(aux_1808, BFALSE);
							    }
							    ((((app_ly_162_t) CREF(new1160_1302))->loc) = ((obj_t) loc_679), BUNSPEC);
							    ((((app_ly_162_t) CREF(new1160_1302))->type) = ((type_t) type_1299), BUNSPEC);
							    ((((app_ly_162_t) CREF(new1160_1302))->fun) = ((node_t) proc_680), BUNSPEC);
							    ((((app_ly_162_t) CREF(new1160_1302))->arg) = ((node_t) arg_681), BUNSPEC);
							    res1757_1310 = new1160_1302;
							 }
						      }
						      aux_1781 = (obj_t) (res1757_1310);
						   }
					      }
					   }
					}
				     }
				  }
				  return (node_t) (aux_1781);
			       }
			     else
			       {
				tag_102_241_664:
				  {
				     obj_t arg1322_691;
				     arg1322_691 = find_location_loc_243_tools_location(exp_1, loc_3);
				     return error_sexp__node_157_ast_sexp(string1777_ast_apply, exp_1, arg1322_691);
				  }
			       }
			  }
			else
			  {
			     goto tag_102_241_664;
			  }
		     }
		   else
		     {
			goto tag_102_241_664;
		     }
		}
	      else
		{
		   goto tag_102_241_664;
		}
	   }
	}
      else
	{
	   goto tag_102_241_664;
	}
   }
}


obj_t 
_applycation__node_33_ast_apply(obj_t env_1698, obj_t exp_1699, obj_t stack_1700, obj_t loc_1701, obj_t site_1702)
{
   {
      node_t aux_1821;
      aux_1821 = applycation__node_122_ast_apply(exp_1699, stack_1700, loc_1701, site_1702);
      return (obj_t) (aux_1821);
   }
}


obj_t 
make_fun_frame_default1294_241_ast_apply(fun_t fun_6)
{
   FAILURE(CNST_TABLE_REF(((long) 2)), string1778_ast_apply, (obj_t) (fun_6));
}


obj_t 
_make_fun_frame_default1294_50_ast_apply(obj_t env_1696, obj_t fun_1697)
{
   return make_fun_frame_default1294_241_ast_apply((fun_t) (fun_1697));
}


obj_t 
make_fun_frame_37_ast_apply(fun_t fun_5)
{
   {
      obj_t method1705_1228;
      obj_t class1710_1229;
      {
	 obj_t arg1714_1226;
	 obj_t arg1715_1227;
	 {
	    object_t obj_1316;
	    obj_1316 = (object_t) (fun_5);
	    {
	       obj_t pre_method_105_1317;
	       pre_method_105_1317 = PROCEDURE_REF(make_fun_frame_env_121_ast_apply, ((long) 2));
	       if (INTEGERP(pre_method_105_1317))
		 {
		    PROCEDURE_SET(make_fun_frame_env_121_ast_apply, ((long) 2), BUNSPEC);
		    arg1714_1226 = pre_method_105_1317;
		 }
	       else
		 {
		    long obj_class_num_177_1322;
		    obj_class_num_177_1322 = TYPE(obj_1316);
		    {
		       obj_t arg1183_1323;
		       arg1183_1323 = PROCEDURE_REF(make_fun_frame_env_121_ast_apply, ((long) 1));
		       {
			  long arg1184_1327;
			  {
			     long arg1186_1328;
			     arg1186_1328 = OBJECT_TYPE;
			     arg1184_1327 = (obj_class_num_177_1322 - arg1186_1328);
			  }
			  arg1714_1226 = VECTOR_REF(arg1183_1323, arg1184_1327);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1333;
	    object_1333 = (object_t) (fun_5);
	    {
	       long arg1187_1334;
	       {
		  long arg1188_1335;
		  long arg1189_1336;
		  arg1188_1335 = TYPE(object_1333);
		  arg1189_1336 = OBJECT_TYPE;
		  arg1187_1334 = (arg1188_1335 - arg1189_1336);
	       }
	       {
		  obj_t vector_1340;
		  vector_1340 = __classes__134___object;
		  arg1715_1227 = VECTOR_REF(vector_1340, arg1187_1334);
	       }
	    }
	 }
	 method1705_1228 = arg1714_1226;
	 class1710_1229 = arg1715_1227;
	 {
	    if (INTEGERP(method1705_1228))
	      {
		 switch ((long) CINT(method1705_1228))
		   {
		   case ((long) 0):
		      {
			 sfun_t fun_1235;
			 fun_1235 = (sfun_t) (fun_5);
			 {
			    long arity_1236;
			    arity_1236 = (((sfun_t) CREF(fun_1235))->arity);
			    {
			       obj_t formals_1237;
			       obj_t locals_1238;
			       formals_1237 = (((sfun_t) CREF(fun_1235))->args);
			       locals_1238 = BNIL;
			     loop_1239:
			       if (NULLP(formals_1237))
				 {
				    return reverse__39___r4_pairs_and_lists_6_3(locals_1238);
				 }
			       else
				 {
				    bool_t test_1851;
				    {
				       bool_t test_1852;
				       {
					  obj_t aux_1853;
					  aux_1853 = CDR(formals_1237);
					  test_1852 = NULLP(aux_1853);
				       }
				       if (test_1852)
					 {
					    test_1851 = (arity_1236 < ((long) 0));
					 }
				       else
					 {
					    test_1851 = ((bool_t) 0);
					 }
				    }
				    if (test_1851)
				      {
					 return reverse__39___r4_pairs_and_lists_6_3(locals_1238);
				      }
				    else
				      {
					 {
					    obj_t arg1722_1244;
					    obj_t arg1724_1245;
					    arg1722_1244 = CDR(formals_1237);
					    {
					       local_t arg1725_1246;
					       {
						  obj_t arg1730_1247;
						  obj_t arg1731_1248;
						  arg1730_1247 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 3)), BEOA);
						  {
						     bool_t test1733_1250;
						     test1733_1250 = is_a__118___object(CAR(formals_1237), type_type_type);
						     if (test1733_1250)
						       {
							  arg1731_1248 = CAR(formals_1237);
						       }
						     else
						       {
							  local_t obj_1354;
							  {
							     obj_t aux_1866;
							     aux_1866 = CAR(formals_1237);
							     obj_1354 = (local_t) (aux_1866);
							  }
							  {
							     type_t aux_1869;
							     aux_1869 = (((local_t) CREF(obj_1354))->type);
							     arg1731_1248 = (obj_t) (aux_1869);
							  }
						       }
						  }
						  arg1725_1246 = make_local_svar_140_ast_local(arg1730_1247, (type_t) (arg1731_1248));
					       }
					       {
						  obj_t aux_1874;
						  aux_1874 = (obj_t) (arg1725_1246);
						  arg1724_1245 = MAKE_PAIR(aux_1874, locals_1238);
					       }
					    }
					    {
					       obj_t locals_1878;
					       obj_t formals_1877;
					       formals_1877 = arg1722_1244;
					       locals_1878 = arg1724_1245;
					       locals_1238 = locals_1878;
					       formals_1237 = formals_1877;
					       goto loop_1239;
					    }
					 }
				      }
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 1):
		      {
			 cfun_t fun_1255;
			 fun_1255 = (cfun_t) (fun_5);
			 {
			    long arity_1256;
			    arity_1256 = (((cfun_t) CREF(fun_1255))->arity);
			    {
			       obj_t types_1257;
			       obj_t locals_1258;
			       types_1257 = (((cfun_t) CREF(fun_1255))->args_type_205);
			       locals_1258 = BNIL;
			     loop_1259:
			       if (NULLP(types_1257))
				 {
				    return reverse__39___r4_pairs_and_lists_6_3(locals_1258);
				 }
			       else
				 {
				    bool_t test_1885;
				    {
				       bool_t test_1886;
				       {
					  obj_t aux_1887;
					  aux_1887 = CDR(types_1257);
					  test_1886 = NULLP(aux_1887);
				       }
				       if (test_1886)
					 {
					    test_1885 = (arity_1256 < ((long) 0));
					 }
				       else
					 {
					    test_1885 = ((bool_t) 0);
					 }
				    }
				    if (test_1885)
				      {
					 return reverse__39___r4_pairs_and_lists_6_3(locals_1258);
				      }
				    else
				      {
					 {
					    obj_t arg1743_1264;
					    obj_t arg1745_1265;
					    arg1743_1264 = CDR(types_1257);
					    {
					       local_t arg1746_1266;
					       {
						  obj_t arg1747_1267;
						  arg1747_1267 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 3)), BEOA);
						  {
						     type_t aux_1896;
						     {
							obj_t aux_1897;
							aux_1897 = CAR(types_1257);
							aux_1896 = (type_t) (aux_1897);
						     }
						     arg1746_1266 = make_local_svar_140_ast_local(arg1747_1267, aux_1896);
						  }
					       }
					       {
						  obj_t aux_1901;
						  aux_1901 = (obj_t) (arg1746_1266);
						  arg1745_1265 = MAKE_PAIR(aux_1901, locals_1258);
					       }
					    }
					    {
					       obj_t locals_1905;
					       obj_t types_1904;
					       types_1904 = arg1743_1264;
					       locals_1905 = arg1745_1265;
					       locals_1258 = locals_1905;
					       types_1257 = types_1904;
					       goto loop_1259;
					    }
					 }
				      }
				 }
			    }
			 }
		      }
		      break;
		   default:
		    case_else1711_134_1232:
		      if (PROCEDUREP(method1705_1228))
			{
			   return PROCEDURE_ENTRY(method1705_1228) (method1705_1228, (obj_t) (fun_5), BEOA);
			}
		      else
			{
			   obj_t fun1328_694;
			   fun1328_694 = PROCEDURE_REF(make_fun_frame_env_121_ast_apply, ((long) 0));
			   return PROCEDURE_ENTRY(fun1328_694) (fun1328_694, (obj_t) (fun_5), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1711_134_1232;
	      }
	 }
      }
   }
}


obj_t 
_make_fun_frame_157_ast_apply(obj_t env_1694, obj_t fun_1695)
{
   return make_fun_frame_37_ast_apply((fun_t) (fun_1695));
}


node_t 
known_app_ly__node_26_ast_apply(obj_t stack_9, obj_t loc_10, node_t proc_11, node_t arg_12, obj_t site_13)
{
   {
      value_t fun_695;
      {
	 variable_t arg1331_700;
	 {
	    var_t obj_1370;
	    obj_1370 = (var_t) (proc_11);
	    arg1331_700 = (((var_t) CREF(obj_1370))->variable);
	 }
	 fun_695 = (((variable_t) CREF(arg1331_700))->value);
      }
      {
	 long arity_696;
	 {
	    fun_t obj_1372;
	    obj_1372 = (fun_t) (fun_695);
	    arity_696 = (((fun_t) CREF(obj_1372))->arity);
	 }
	 {
	    obj_t frame_697;
	    frame_697 = make_fun_frame_37_ast_apply((fun_t) (fun_695));
	    {
	       if ((arity_696 > ((long) 0)))
		 {
		    {
		       let_var_6_t aux_1929;
		       aux_1929 = fx_known_app_ly__node_158_ast_apply(stack_9, loc_10, proc_11, arg_12, frame_697, site_13);
		       return (node_t) (aux_1929);
		    }
		 }
	       else
		 {
		    if ((arity_696 == ((long) 0)))
		      {
			 {
			    obj_t arg1332_1383;
			    {
			       obj_t list1333_1384;
			       {
				  obj_t aux_1934;
				  aux_1934 = (obj_t) (proc_11);
				  list1333_1384 = MAKE_PAIR(aux_1934, BNIL);
			       }
			       arg1332_1383 = list1333_1384;
			    }
			    return sexp__node_235_ast_sexp(arg1332_1383, stack_9, loc_10, site_13);
			 }
		      }
		    else
		      {
			 {
			    let_var_6_t aux_1938;
			    aux_1938 = va_known_app_ly__node_104_ast_apply(stack_9, loc_10, proc_11, arg_12, frame_697, site_13);
			    return (node_t) (aux_1938);
			 }
		      }
		 }
	    }
	 }
      }
   }
}


obj_t 
_known_app_ly__node_80_ast_apply(obj_t env_1703, obj_t stack_1704, obj_t loc_1705, obj_t proc_1706, obj_t arg_1707, obj_t site_1708)
{
   {
      node_t aux_1941;
      aux_1941 = known_app_ly__node_26_ast_apply(stack_1704, loc_1705, (node_t) (proc_1706), (node_t) (arg_1707), site_1708);
      return (obj_t) (aux_1941);
   }
}


let_var_6_t 
fx_known_app_ly__node_158_ast_apply(obj_t stack_20, obj_t loc_21, node_t proc_22, node_t arg_23, obj_t frame_24, obj_t site_25)
{
   {
      local_t runner_704;
      type_t type_705;
      {
	 obj_t arg1509_826;
	 arg1509_826 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 4)), BEOA);
	 runner_704 = make_local_svar_140_ast_local(arg1509_826, (type_t) (_____74_type_cache));
      }
      type_705 = (((node_t) CREF(proc_22))->type);
      {
	 obj_t arg1337_706;
	 arg1337_706 = CNST_TABLE_REF(((long) 5));
	 {
	    obj_t res1759_1394;
	    {
	       obj_t x_1724;
	       x_1724 = ((((local_t) CREF(runner_704))->access) = ((obj_t) arg1337_706), BUNSPEC);
	       res1759_1394 = BUNSPEC;
	    }
	    res1759_1394;
	 }
      }
      {
	 obj_t arg1339_707;
	 obj_t arg1340_708;
	 {
	    obj_t arg1342_709;
	    {
	       obj_t aux_1956;
	       obj_t aux_1954;
	       aux_1956 = (obj_t) (arg_23);
	       aux_1954 = (obj_t) (runner_704);
	       arg1342_709 = MAKE_PAIR(aux_1954, aux_1956);
	    }
	    {
	       obj_t list1343_710;
	       list1343_710 = MAKE_PAIR(arg1342_709, BNIL);
	       arg1339_707 = list1343_710;
	    }
	 }
	 arg1340_708 = loop1776_ast_apply(site_25, proc_22, frame_24, type_705, stack_20, loc_21, runner_704, frame_24);
	 {
	    let_var_6_t res1766_1512;
	    {
	       node_t body_1500;
	       body_1500 = (node_t) (arg1340_708);
	       {
		  let_var_6_t new1229_1502;
		  new1229_1502 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
		  {
		     long arg1624_1503;
		     arg1624_1503 = class_num_218___object(let_var_6_ast_node);
		     {
			obj_t obj_1510;
			obj_1510 = (obj_t) (new1229_1502);
			(((obj_t) CREF(obj_1510))->header = MAKE_HEADER(arg1624_1503, 0), BUNSPEC);
		     }
		  }
		  {
		     object_t aux_1966;
		     aux_1966 = (object_t) (new1229_1502);
		     OBJECT_WIDENING_SET(aux_1966, BFALSE);
		  }
		  ((((let_var_6_t) CREF(new1229_1502))->loc) = ((obj_t) loc_21), BUNSPEC);
		  ((((let_var_6_t) CREF(new1229_1502))->type) = ((type_t) type_705), BUNSPEC);
		  ((((let_var_6_t) CREF(new1229_1502))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		  ((((let_var_6_t) CREF(new1229_1502))->bindings) = ((obj_t) arg1339_707), BUNSPEC);
		  ((((let_var_6_t) CREF(new1229_1502))->body) = ((node_t) body_1500), BUNSPEC);
		  ((((let_var_6_t) CREF(new1229_1502))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		  res1766_1512 = new1229_1502;
	       }
	    }
	    return res1766_1512;
	 }
      }
   }
}


obj_t 
loop1776_ast_apply(obj_t site_1723, node_t proc_1722, obj_t frame_1721, type_t type_1720, obj_t stack_1719, obj_t loc_1718, local_t runner_1717, obj_t locals_712)
{
   if (NULLP(locals_712))
     {
	node_t app_715;
	{
	   obj_t arg1412_756;
	   obj_t arg1414_757;
	   {
	      obj_t arg1415_758;
	      {
		 obj_t arg1418_761;
		 obj_t arg1420_762;
		 if (NULLP(frame_1721))
		   {
		      arg1418_761 = BNIL;
		   }
		 else
		   {
		      obj_t head1284_765;
		      head1284_765 = MAKE_PAIR(BNIL, BNIL);
		      {
			 obj_t l1272_766;
			 obj_t tail1285_767;
			 l1272_766 = frame_1721;
			 tail1285_767 = head1284_765;
		       lname1283_768:
			 if (NULLP(l1272_766))
			   {
			      arg1418_761 = CDR(head1284_765);
			   }
			 else
			   {
			      obj_t new_tail1286_4_770;
			      {
				 var_t arg1426_772;
				 {
				    obj_t local_774;
				    local_774 = CAR(l1272_766);
				    {
				       type_t arg1428_775;
				       {
					  local_t obj_1405;
					  obj_1405 = (local_t) (local_774);
					  arg1428_775 = (((local_t) CREF(obj_1405))->type);
				       }
				       {
					  var_t res1760_1416;
					  {
					     variable_t variable_1408;
					     variable_1408 = (variable_t) (local_774);
					     {
						var_t new1128_1409;
						new1128_1409 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
						{
						   long arg1664_1410;
						   arg1664_1410 = class_num_218___object(var_ast_node);
						   {
						      obj_t obj_1414;
						      obj_1414 = (obj_t) (new1128_1409);
						      (((obj_t) CREF(obj_1414))->header = MAKE_HEADER(arg1664_1410, 0), BUNSPEC);
						   }
						}
						{
						   object_t aux_1991;
						   aux_1991 = (object_t) (new1128_1409);
						   OBJECT_WIDENING_SET(aux_1991, BFALSE);
						}
						((((var_t) CREF(new1128_1409))->loc) = ((obj_t) loc_1718), BUNSPEC);
						((((var_t) CREF(new1128_1409))->type) = ((type_t) arg1428_775), BUNSPEC);
						((((var_t) CREF(new1128_1409))->variable) = ((variable_t) variable_1408), BUNSPEC);
						res1760_1416 = new1128_1409;
					     }
					  }
					  arg1426_772 = res1760_1416;
				       }
				    }
				 }
				 {
				    obj_t aux_1997;
				    aux_1997 = (obj_t) (arg1426_772);
				    new_tail1286_4_770 = MAKE_PAIR(aux_1997, BNIL);
				 }
			      }
			      SET_CDR(tail1285_767, new_tail1286_4_770);
			      {
				 obj_t tail1285_2003;
				 obj_t l1272_2001;
				 l1272_2001 = CDR(l1272_766);
				 tail1285_2003 = new_tail1286_4_770;
				 tail1285_767 = tail1285_2003;
				 l1272_766 = l1272_2001;
				 goto lname1283_768;
			      }
			   }
		      }
		   }
		 arg1420_762 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
		 arg1415_758 = append_2_18___r4_pairs_and_lists_6_3(arg1418_761, arg1420_762);
	      }
	      {
		 obj_t list1416_759;
		 list1416_759 = MAKE_PAIR(arg1415_758, BNIL);
		 arg1412_756 = cons__138___r4_pairs_and_lists_6_3((obj_t) (proc_1722), list1416_759);
	      }
	   }
	   arg1414_757 = CNST_TABLE_REF(((long) 1));
	   app_715 = application__node_43_ast_app(arg1412_756, stack_1719, loc_1718, arg1414_757);
	}
	if (CBOOL(__unsafe_arity__240_engine_param))
	  {
	     return (obj_t) (app_715);
	  }
	else
	  {
	     obj_t arg1347_716;
	     {
		obj_t arg1349_717;
		obj_t arg1350_718;
		obj_t arg1352_719;
		arg1349_717 = CNST_TABLE_REF(((long) 6));
		{
		   obj_t arg1359_726;
		   obj_t arg1361_727;
		   arg1359_726 = CNST_TABLE_REF(((long) 7));
		   {
		      obj_t arg1369_732;
		      var_t arg1370_733;
		      arg1369_732 = CNST_TABLE_REF(((long) 8));
		      {
			 type_t arg1380_738;
			 arg1380_738 = (((local_t) CREF(runner_1717))->type);
			 {
			    var_t res1761_1433;
			    {
			       variable_t variable_1425;
			       variable_1425 = (variable_t) (runner_1717);
			       {
				  var_t new1128_1426;
				  new1128_1426 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				  {
				     long arg1664_1427;
				     arg1664_1427 = class_num_218___object(var_ast_node);
				     {
					obj_t obj_1431;
					obj_1431 = (obj_t) (new1128_1426);
					(((obj_t) CREF(obj_1431))->header = MAKE_HEADER(arg1664_1427, 0), BUNSPEC);
				     }
				  }
				  {
				     object_t aux_2023;
				     aux_2023 = (object_t) (new1128_1426);
				     OBJECT_WIDENING_SET(aux_2023, BFALSE);
				  }
				  ((((var_t) CREF(new1128_1426))->loc) = ((obj_t) loc_1718), BUNSPEC);
				  ((((var_t) CREF(new1128_1426))->type) = ((type_t) arg1380_738), BUNSPEC);
				  ((((var_t) CREF(new1128_1426))->variable) = ((variable_t) variable_1425), BUNSPEC);
				  res1761_1433 = new1128_1426;
			       }
			    }
			    arg1370_733 = res1761_1433;
			 }
		      }
		      {
			 obj_t list1373_735;
			 {
			    obj_t arg1376_736;
			    arg1376_736 = MAKE_PAIR(BNIL, BNIL);
			    {
			       obj_t aux_2030;
			       aux_2030 = (obj_t) (arg1370_733);
			       list1373_735 = MAKE_PAIR(aux_2030, arg1376_736);
			    }
			 }
			 arg1361_727 = cons__138___r4_pairs_and_lists_6_3(arg1369_732, list1373_735);
		      }
		   }
		   {
		      obj_t list1364_729;
		      {
			 obj_t arg1366_730;
			 arg1366_730 = MAKE_PAIR(BNIL, BNIL);
			 list1364_729 = MAKE_PAIR(arg1361_727, arg1366_730);
		      }
		      arg1350_718 = cons__138___r4_pairs_and_lists_6_3(arg1359_726, list1364_729);
		   }
		}
		{
		   obj_t arg1381_739;
		   obj_t arg1388_742;
		   arg1381_739 = CNST_TABLE_REF(((long) 9));
		   {
		      obj_t arg1403_749;
		      obj_t arg1404_750;
		      arg1403_749 = CNST_TABLE_REF(((long) 10));
		      {
			 obj_t aux_2039;
			 {
			    variable_t aux_2040;
			    {
			       var_t obj_1434;
			       obj_1434 = (var_t) (proc_1722);
			       aux_2040 = (((var_t) CREF(obj_1434))->variable);
			    }
			    aux_2039 = (obj_t) (aux_2040);
			 }
			 arg1404_750 = shape_tools_shape(aux_2039);
		      }
		      {
			 obj_t list1407_752;
			 {
			    obj_t arg1408_753;
			    arg1408_753 = MAKE_PAIR(BNIL, BNIL);
			    list1407_752 = MAKE_PAIR(arg1404_750, arg1408_753);
			 }
			 arg1388_742 = cons__138___r4_pairs_and_lists_6_3(arg1403_749, list1407_752);
		      }
		   }
		   {
		      obj_t list1391_744;
		      {
			 obj_t arg1396_745;
			 {
			    obj_t arg1398_746;
			    {
			       obj_t arg1400_747;
			       arg1400_747 = MAKE_PAIR(BNIL, BNIL);
			       arg1398_746 = MAKE_PAIR(arg1388_742, arg1400_747);
			    }
			    arg1396_745 = MAKE_PAIR(string1779_ast_apply, arg1398_746);
			 }
			 list1391_744 = MAKE_PAIR(string1780_ast_apply, arg1396_745);
		      }
		      arg1352_719 = cons__138___r4_pairs_and_lists_6_3(arg1381_739, list1391_744);
		   }
		}
		{
		   obj_t list1354_721;
		   {
		      obj_t arg1355_722;
		      {
			 obj_t arg1356_723;
			 {
			    obj_t arg1357_724;
			    arg1357_724 = MAKE_PAIR(BNIL, BNIL);
			    arg1356_723 = MAKE_PAIR(arg1352_719, arg1357_724);
			 }
			 {
			    obj_t aux_2055;
			    aux_2055 = (obj_t) (app_715);
			    arg1355_722 = MAKE_PAIR(aux_2055, arg1356_723);
			 }
		      }
		      list1354_721 = MAKE_PAIR(arg1350_718, arg1355_722);
		   }
		   arg1347_716 = cons__138___r4_pairs_and_lists_6_3(arg1349_717, list1354_721);
		}
	     }
	     {
		node_t aux_2060;
		aux_2060 = sexp__node_235_ast_sexp(arg1347_716, stack_1719, loc_1718, site_1723);
		return (obj_t) (aux_2060);
	     }
	  }
     }
   else
     {
	obj_t arg1444_780;
	obj_t arg1445_781;
	{
	   obj_t arg1446_782;
	   {
	      obj_t arg1449_785;
	      node_t arg1450_786;
	      arg1449_785 = CAR(locals_712);
	      {
		 obj_t arg1452_787;
		 obj_t arg1453_788;
		 {
		    obj_t arg1454_789;
		    var_t arg1457_790;
		    arg1454_789 = CNST_TABLE_REF(((long) 11));
		    {
		       type_t arg1465_795;
		       arg1465_795 = (((local_t) CREF(runner_1717))->type);
		       {
			  var_t res1762_1447;
			  {
			     variable_t variable_1439;
			     variable_1439 = (variable_t) (runner_1717);
			     {
				var_t new1128_1440;
				new1128_1440 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				{
				   long arg1664_1441;
				   arg1664_1441 = class_num_218___object(var_ast_node);
				   {
				      obj_t obj_1445;
				      obj_1445 = (obj_t) (new1128_1440);
				      (((obj_t) CREF(obj_1445))->header = MAKE_HEADER(arg1664_1441, 0), BUNSPEC);
				   }
				}
				{
				   object_t aux_2071;
				   aux_2071 = (object_t) (new1128_1440);
				   OBJECT_WIDENING_SET(aux_2071, BFALSE);
				}
				((((var_t) CREF(new1128_1440))->loc) = ((obj_t) loc_1718), BUNSPEC);
				((((var_t) CREF(new1128_1440))->type) = ((type_t) arg1465_795), BUNSPEC);
				((((var_t) CREF(new1128_1440))->variable) = ((variable_t) variable_1439), BUNSPEC);
				res1762_1447 = new1128_1440;
			     }
			  }
			  arg1457_790 = res1762_1447;
		       }
		    }
		    {
		       obj_t list1459_792;
		       {
			  obj_t arg1461_793;
			  arg1461_793 = MAKE_PAIR(BNIL, BNIL);
			  {
			     obj_t aux_2078;
			     aux_2078 = (obj_t) (arg1457_790);
			     list1459_792 = MAKE_PAIR(aux_2078, arg1461_793);
			  }
		       }
		       arg1452_787 = cons__138___r4_pairs_and_lists_6_3(arg1454_789, list1459_792);
		    }
		 }
		 arg1453_788 = CNST_TABLE_REF(((long) 1));
		 arg1450_786 = sexp__node_235_ast_sexp(arg1452_787, stack_1719, loc_1718, arg1453_788);
	      }
	      {
		 obj_t aux_2084;
		 aux_2084 = (obj_t) (arg1450_786);
		 arg1446_782 = MAKE_PAIR(arg1449_785, aux_2084);
	      }
	   }
	   {
	      obj_t list1447_783;
	      list1447_783 = MAKE_PAIR(arg1446_782, BNIL);
	      arg1444_780 = list1447_783;
	   }
	}
	{
	   bool_t test_2088;
	   {
	      obj_t aux_2089;
	      aux_2089 = CDR(locals_712);
	      test_2088 = NULLP(aux_2089);
	   }
	   if (test_2088)
	     {
		arg1445_781 = loop1776_ast_apply(site_1723, proc_1722, frame_1721, type_1720, stack_1719, loc_1718, runner_1717, CDR(locals_712));
	     }
	   else
	     {
		obj_t arg1468_798;
		obj_t arg1470_799;
		{
		   obj_t arg1471_800;
		   obj_t arg1472_801;
		   obj_t arg1474_802;
		   arg1471_800 = CNST_TABLE_REF(((long) 12));
		   {
		      obj_t arg1484_808;
		      var_t arg1485_809;
		      obj_t arg1486_810;
		      arg1484_808 = CNST_TABLE_REF(((long) 13));
		      {
			 type_t arg1494_816;
			 arg1494_816 = (((local_t) CREF(runner_1717))->type);
			 {
			    var_t res1763_1465;
			    {
			       variable_t variable_1457;
			       variable_1457 = (variable_t) (runner_1717);
			       {
				  var_t new1128_1458;
				  new1128_1458 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				  {
				     long arg1664_1459;
				     arg1664_1459 = class_num_218___object(var_ast_node);
				     {
					obj_t obj_1463;
					obj_1463 = (obj_t) (new1128_1458);
					(((obj_t) CREF(obj_1463))->header = MAKE_HEADER(arg1664_1459, 0), BUNSPEC);
				     }
				  }
				  {
				     object_t aux_2102;
				     aux_2102 = (object_t) (new1128_1458);
				     OBJECT_WIDENING_SET(aux_2102, BFALSE);
				  }
				  ((((var_t) CREF(new1128_1458))->loc) = ((obj_t) loc_1718), BUNSPEC);
				  ((((var_t) CREF(new1128_1458))->type) = ((type_t) arg1494_816), BUNSPEC);
				  ((((var_t) CREF(new1128_1458))->variable) = ((variable_t) variable_1457), BUNSPEC);
				  res1763_1465 = new1128_1458;
			       }
			    }
			    arg1485_809 = res1763_1465;
			 }
		      }
		      {
			 obj_t arg1496_817;
			 var_t arg1497_818;
			 arg1496_817 = CNST_TABLE_REF(((long) 8));
			 {
			    type_t arg1505_823;
			    arg1505_823 = (((local_t) CREF(runner_1717))->type);
			    {
			       var_t res1764_1477;
			       {
				  variable_t variable_1469;
				  variable_1469 = (variable_t) (runner_1717);
				  {
				     var_t new1128_1470;
				     new1128_1470 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				     {
					long arg1664_1471;
					arg1664_1471 = class_num_218___object(var_ast_node);
					{
					   obj_t obj_1475;
					   obj_1475 = (obj_t) (new1128_1470);
					   (((obj_t) CREF(obj_1475))->header = MAKE_HEADER(arg1664_1471, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_2115;
					aux_2115 = (object_t) (new1128_1470);
					OBJECT_WIDENING_SET(aux_2115, BFALSE);
				     }
				     ((((var_t) CREF(new1128_1470))->loc) = ((obj_t) loc_1718), BUNSPEC);
				     ((((var_t) CREF(new1128_1470))->type) = ((type_t) arg1505_823), BUNSPEC);
				     ((((var_t) CREF(new1128_1470))->variable) = ((variable_t) variable_1469), BUNSPEC);
				     res1764_1477 = new1128_1470;
				  }
			       }
			       arg1497_818 = res1764_1477;
			    }
			 }
			 {
			    obj_t list1499_820;
			    {
			       obj_t arg1500_821;
			       arg1500_821 = MAKE_PAIR(BNIL, BNIL);
			       {
				  obj_t aux_2122;
				  aux_2122 = (obj_t) (arg1497_818);
				  list1499_820 = MAKE_PAIR(aux_2122, arg1500_821);
			       }
			    }
			    arg1486_810 = cons__138___r4_pairs_and_lists_6_3(arg1496_817, list1499_820);
			 }
		      }
		      {
			 obj_t list1488_812;
			 {
			    obj_t arg1489_813;
			    {
			       obj_t arg1490_814;
			       arg1490_814 = MAKE_PAIR(BNIL, BNIL);
			       arg1489_813 = MAKE_PAIR(arg1486_810, arg1490_814);
			    }
			    {
			       obj_t aux_2128;
			       aux_2128 = (obj_t) (arg1485_809);
			       list1488_812 = MAKE_PAIR(aux_2128, arg1489_813);
			    }
			 }
			 arg1472_801 = cons__138___r4_pairs_and_lists_6_3(arg1484_808, list1488_812);
		      }
		   }
		   arg1474_802 = loop1776_ast_apply(site_1723, proc_1722, frame_1721, type_1720, stack_1719, loc_1718, runner_1717, CDR(locals_712));
		   {
		      obj_t list1477_804;
		      {
			 obj_t arg1478_805;
			 {
			    obj_t arg1480_806;
			    arg1480_806 = MAKE_PAIR(BNIL, BNIL);
			    arg1478_805 = MAKE_PAIR(arg1474_802, arg1480_806);
			 }
			 list1477_804 = MAKE_PAIR(arg1472_801, arg1478_805);
		      }
		      arg1468_798 = cons__138___r4_pairs_and_lists_6_3(arg1471_800, list1477_804);
		   }
		}
		arg1470_799 = CNST_TABLE_REF(((long) 1));
		{
		   node_t aux_2139;
		   aux_2139 = sexp__node_235_ast_sexp(arg1468_798, stack_1719, loc_1718, arg1470_799);
		   arg1445_781 = (obj_t) (aux_2139);
		}
	     }
	}
	{
	   let_var_6_t res1765_1495;
	   {
	      node_t body_1483;
	      body_1483 = (node_t) (arg1445_781);
	      {
		 let_var_6_t new1229_1485;
		 new1229_1485 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
		 {
		    long arg1624_1486;
		    arg1624_1486 = class_num_218___object(let_var_6_ast_node);
		    {
		       obj_t obj_1493;
		       obj_1493 = (obj_t) (new1229_1485);
		       (((obj_t) CREF(obj_1493))->header = MAKE_HEADER(arg1624_1486, 0), BUNSPEC);
		    }
		 }
		 {
		    object_t aux_2147;
		    aux_2147 = (object_t) (new1229_1485);
		    OBJECT_WIDENING_SET(aux_2147, BFALSE);
		 }
		 ((((let_var_6_t) CREF(new1229_1485))->loc) = ((obj_t) loc_1718), BUNSPEC);
		 ((((let_var_6_t) CREF(new1229_1485))->type) = ((type_t) type_1720), BUNSPEC);
		 ((((let_var_6_t) CREF(new1229_1485))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		 ((((let_var_6_t) CREF(new1229_1485))->bindings) = ((obj_t) arg1444_780), BUNSPEC);
		 ((((let_var_6_t) CREF(new1229_1485))->body) = ((node_t) body_1483), BUNSPEC);
		 ((((let_var_6_t) CREF(new1229_1485))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		 res1765_1495 = new1229_1485;
	      }
	   }
	   return (obj_t) (res1765_1495);
	}
     }
}


let_var_6_t 
va_known_app_ly__node_104_ast_apply(obj_t stack_26, obj_t loc_27, node_t proc_28, node_t arg_29, obj_t frame_30, obj_t site_31)
{
   {
      obj_t frame_1716;
      frame_1716 = MAKE_CELL(frame_30);
      {
	 local_t runner_828;
	 type_t type_829;
	 {
	    obj_t arg1605_913;
	    arg1605_913 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 4)), BEOA);
	    runner_828 = make_local_svar_140_ast_local(arg1605_913, (type_t) (_____74_type_cache));
	 }
	 type_829 = (((node_t) CREF(proc_28))->type);
	 {
	    bool_t test1511_830;
	    {
	       obj_t obj_1514;
	       obj_1514 = CELL_REF(frame_1716);
	       test1511_830 = PAIRP(obj_1514);
	    }
	    if (test1511_830)
	      {
		 obj_t arg1513_831;
		 arg1513_831 = CNST_TABLE_REF(((long) 5));
		 {
		    obj_t res1767_1517;
		    {
		       obj_t x_1725;
		       x_1725 = ((((local_t) CREF(runner_828))->access) = ((obj_t) arg1513_831), BUNSPEC);
		       res1767_1517 = BUNSPEC;
		    }
		    res1767_1517;
		 }
	      }
	    else
	      {
		 BUNSPEC;
	      }
	 }
	 {
	    obj_t arg1514_832;
	    obj_t arg1517_833;
	    {
	       obj_t arg1518_834;
	       {
		  obj_t aux_2169;
		  obj_t aux_2167;
		  aux_2169 = (obj_t) (arg_29);
		  aux_2167 = (obj_t) (runner_828);
		  arg1518_834 = MAKE_PAIR(aux_2167, aux_2169);
	       }
	       {
		  obj_t list1519_835;
		  list1519_835 = MAKE_PAIR(arg1518_834, BNIL);
		  arg1514_832 = list1519_835;
	       }
	    }
	    arg1517_833 = loop_ast_apply(proc_28, frame_1716, type_829, stack_26, loc_27, runner_828, CELL_REF(frame_1716), BNIL);
	    {
	       let_var_6_t res1775_1658;
	       {
		  node_t body_1646;
		  body_1646 = (node_t) (arg1517_833);
		  {
		     let_var_6_t new1229_1648;
		     new1229_1648 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
		     {
			long arg1624_1649;
			arg1624_1649 = class_num_218___object(let_var_6_ast_node);
			{
			   obj_t obj_1656;
			   obj_1656 = (obj_t) (new1229_1648);
			   (((obj_t) CREF(obj_1656))->header = MAKE_HEADER(arg1624_1649, 0), BUNSPEC);
			}
		     }
		     {
			object_t aux_2179;
			aux_2179 = (object_t) (new1229_1648);
			OBJECT_WIDENING_SET(aux_2179, BFALSE);
		     }
		     ((((let_var_6_t) CREF(new1229_1648))->loc) = ((obj_t) loc_27), BUNSPEC);
		     ((((let_var_6_t) CREF(new1229_1648))->type) = ((type_t) type_829), BUNSPEC);
		     ((((let_var_6_t) CREF(new1229_1648))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		     ((((let_var_6_t) CREF(new1229_1648))->bindings) = ((obj_t) arg1514_832), BUNSPEC);
		     ((((let_var_6_t) CREF(new1229_1648))->body) = ((node_t) body_1646), BUNSPEC);
		     ((((let_var_6_t) CREF(new1229_1648))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		     res1775_1658 = new1229_1648;
		  }
	       }
	       return res1775_1658;
	    }
	 }
      }
   }
}


obj_t 
loop_ast_apply(node_t proc_1714, obj_t frame_1713, type_t type_1712, obj_t stack_1711, obj_t loc_1710, local_t runner_1709, obj_t locals_837, obj_t old_838)
{
   if (NULLP(locals_837))
     {
	if (NULLP(old_838))
	  {
	     obj_t aux_1715;
	     {
		obj_t list1525_843;
		{
		   obj_t aux_2192;
		   aux_2192 = (obj_t) (runner_1709);
		   list1525_843 = MAKE_PAIR(aux_2192, BNIL);
		}
		aux_1715 = list1525_843;
	     }
	     CELL_SET(frame_1713, aux_1715);
	  }
	else
	  {
	     obj_t arg1529_845;
	     {
		obj_t aux_2195;
		aux_2195 = (obj_t) (runner_1709);
		arg1529_845 = MAKE_PAIR(aux_2195, BNIL);
	     }
	     SET_CDR(old_838, arg1529_845);
	  }
	{
	   type_t arg1532_847;
	   var_t arg1534_848;
	   obj_t arg1535_849;
	   {
	      variable_t arg1536_850;
	      {
		 var_t obj_1528;
		 obj_1528 = (var_t) (proc_1714);
		 arg1536_850 = (((var_t) CREF(obj_1528))->variable);
	      }
	      arg1532_847 = (((variable_t) CREF(arg1536_850))->type);
	   }
	   {
	      var_t duplicated1287_851;
	      duplicated1287_851 = (var_t) (proc_1714);
	      {
		 obj_t arg1537_852;
		 type_t arg1538_853;
		 variable_t arg1539_854;
		 arg1537_852 = (((var_t) CREF(duplicated1287_851))->loc);
		 arg1538_853 = (((var_t) CREF(duplicated1287_851))->type);
		 arg1539_854 = (((var_t) CREF(duplicated1287_851))->variable);
		 {
		    var_t res1768_1543;
		    {
		       var_t new1128_1536;
		       new1128_1536 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
		       {
			  long arg1664_1537;
			  arg1664_1537 = class_num_218___object(var_ast_node);
			  {
			     obj_t obj_1541;
			     obj_1541 = (obj_t) (new1128_1536);
			     (((obj_t) CREF(obj_1541))->header = MAKE_HEADER(arg1664_1537, 0), BUNSPEC);
			  }
		       }
		       {
			  object_t aux_2210;
			  aux_2210 = (object_t) (new1128_1536);
			  OBJECT_WIDENING_SET(aux_2210, BFALSE);
		       }
		       ((((var_t) CREF(new1128_1536))->loc) = ((obj_t) arg1537_852), BUNSPEC);
		       ((((var_t) CREF(new1128_1536))->type) = ((type_t) arg1538_853), BUNSPEC);
		       ((((var_t) CREF(new1128_1536))->variable) = ((variable_t) arg1539_854), BUNSPEC);
		       res1768_1543 = new1128_1536;
		    }
		    arg1534_848 = res1768_1543;
		 }
	      }
	   }
	   {
	      obj_t l1288_855;
	      l1288_855 = CELL_REF(frame_1713);
	      if (NULLP(l1288_855))
		{
		   arg1535_849 = BNIL;
		}
	      else
		{
		   obj_t head1291_857;
		   head1291_857 = MAKE_PAIR(BNIL, BNIL);
		   {
		      obj_t l1288_858;
		      obj_t tail1292_859;
		      l1288_858 = l1288_855;
		      tail1292_859 = head1291_857;
		    lname1290_860:
		      if (NULLP(l1288_858))
			{
			   arg1535_849 = CDR(head1291_857);
			}
		      else
			{
			   obj_t new_tail1293_138_862;
			   {
			      var_t arg1543_864;
			      {
				 obj_t local_866;
				 local_866 = CAR(l1288_858);
				 {
				    type_t arg1549_867;
				    {
				       local_t obj_1550;
				       obj_1550 = (local_t) (local_866);
				       arg1549_867 = (((local_t) CREF(obj_1550))->type);
				    }
				    {
				       var_t res1769_1561;
				       {
					  variable_t variable_1553;
					  variable_1553 = (variable_t) (local_866);
					  {
					     var_t new1128_1554;
					     new1128_1554 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
					     {
						long arg1664_1555;
						arg1664_1555 = class_num_218___object(var_ast_node);
						{
						   obj_t obj_1559;
						   obj_1559 = (obj_t) (new1128_1554);
						   (((obj_t) CREF(obj_1559))->header = MAKE_HEADER(arg1664_1555, 0), BUNSPEC);
						}
					     }
					     {
						object_t aux_2230;
						aux_2230 = (object_t) (new1128_1554);
						OBJECT_WIDENING_SET(aux_2230, BFALSE);
					     }
					     ((((var_t) CREF(new1128_1554))->loc) = ((obj_t) loc_1710), BUNSPEC);
					     ((((var_t) CREF(new1128_1554))->type) = ((type_t) arg1549_867), BUNSPEC);
					     ((((var_t) CREF(new1128_1554))->variable) = ((variable_t) variable_1553), BUNSPEC);
					     res1769_1561 = new1128_1554;
					  }
				       }
				       arg1543_864 = res1769_1561;
				    }
				 }
			      }
			      {
				 obj_t aux_2236;
				 aux_2236 = (obj_t) (arg1543_864);
				 new_tail1293_138_862 = MAKE_PAIR(aux_2236, BNIL);
			      }
			   }
			   SET_CDR(tail1292_859, new_tail1293_138_862);
			   {
			      obj_t tail1292_2242;
			      obj_t l1288_2240;
			      l1288_2240 = CDR(l1288_858);
			      tail1292_2242 = new_tail1293_138_862;
			      tail1292_859 = tail1292_2242;
			      l1288_858 = l1288_2240;
			      goto lname1290_860;
			   }
			}
		   }
		}
	   }
	   {
	      app_t res1770_1583;
	      {
		 app_t new1151_1573;
		 new1151_1573 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
		 {
		    long arg1653_1574;
		    arg1653_1574 = class_num_218___object(app_ast_node);
		    {
		       obj_t obj_1581;
		       obj_1581 = (obj_t) (new1151_1573);
		       (((obj_t) CREF(obj_1581))->header = MAKE_HEADER(arg1653_1574, 0), BUNSPEC);
		    }
		 }
		 {
		    object_t aux_2247;
		    aux_2247 = (object_t) (new1151_1573);
		    OBJECT_WIDENING_SET(aux_2247, BFALSE);
		 }
		 ((((app_t) CREF(new1151_1573))->loc) = ((obj_t) loc_1710), BUNSPEC);
		 ((((app_t) CREF(new1151_1573))->type) = ((type_t) arg1532_847), BUNSPEC);
		 ((((app_t) CREF(new1151_1573))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		 ((((app_t) CREF(new1151_1573))->fun) = ((var_t) arg1534_848), BUNSPEC);
		 ((((app_t) CREF(new1151_1573))->args) = ((obj_t) arg1535_849), BUNSPEC);
		 ((((app_t) CREF(new1151_1573))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
		 res1770_1583 = new1151_1573;
	      }
	      return (obj_t) (res1770_1583);
	   }
	}
     }
   else
     {
	obj_t arg1552_870;
	node_t arg1553_871;
	{
	   obj_t arg1554_872;
	   {
	      obj_t arg1559_875;
	      node_t arg1560_876;
	      arg1559_875 = CAR(locals_837);
	      {
		 obj_t arg1561_877;
		 obj_t arg1562_878;
		 {
		    obj_t arg1563_879;
		    var_t arg1564_880;
		    arg1563_879 = CNST_TABLE_REF(((long) 11));
		    {
		       type_t arg1570_885;
		       arg1570_885 = (((local_t) CREF(runner_1709))->type);
		       {
			  var_t res1771_1596;
			  {
			     variable_t variable_1588;
			     variable_1588 = (variable_t) (runner_1709);
			     {
				var_t new1128_1589;
				new1128_1589 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				{
				   long arg1664_1590;
				   arg1664_1590 = class_num_218___object(var_ast_node);
				   {
				      obj_t obj_1594;
				      obj_1594 = (obj_t) (new1128_1589);
				      (((obj_t) CREF(obj_1594))->header = MAKE_HEADER(arg1664_1590, 0), BUNSPEC);
				   }
				}
				{
				   object_t aux_2265;
				   aux_2265 = (object_t) (new1128_1589);
				   OBJECT_WIDENING_SET(aux_2265, BFALSE);
				}
				((((var_t) CREF(new1128_1589))->loc) = ((obj_t) loc_1710), BUNSPEC);
				((((var_t) CREF(new1128_1589))->type) = ((type_t) arg1570_885), BUNSPEC);
				((((var_t) CREF(new1128_1589))->variable) = ((variable_t) variable_1588), BUNSPEC);
				res1771_1596 = new1128_1589;
			     }
			  }
			  arg1564_880 = res1771_1596;
		       }
		    }
		    {
		       obj_t list1566_882;
		       {
			  obj_t arg1567_883;
			  arg1567_883 = MAKE_PAIR(BNIL, BNIL);
			  {
			     obj_t aux_2272;
			     aux_2272 = (obj_t) (arg1564_880);
			     list1566_882 = MAKE_PAIR(aux_2272, arg1567_883);
			  }
		       }
		       arg1561_877 = cons__138___r4_pairs_and_lists_6_3(arg1563_879, list1566_882);
		    }
		 }
		 arg1562_878 = CNST_TABLE_REF(((long) 1));
		 arg1560_876 = sexp__node_235_ast_sexp(arg1561_877, stack_1711, loc_1710, arg1562_878);
	      }
	      {
		 obj_t aux_2278;
		 aux_2278 = (obj_t) (arg1560_876);
		 arg1554_872 = MAKE_PAIR(arg1559_875, aux_2278);
	      }
	   }
	   {
	      obj_t list1555_873;
	      list1555_873 = MAKE_PAIR(arg1554_872, BNIL);
	      arg1552_870 = list1555_873;
	   }
	}
	{
	   obj_t arg1571_886;
	   obj_t arg1572_887;
	   {
	      obj_t arg1573_888;
	      obj_t arg1574_889;
	      obj_t arg1575_890;
	      arg1573_888 = CNST_TABLE_REF(((long) 12));
	      {
		 obj_t arg1583_896;
		 var_t arg1584_897;
		 obj_t arg1585_898;
		 arg1583_896 = CNST_TABLE_REF(((long) 13));
		 {
		    type_t arg1592_904;
		    arg1592_904 = (((local_t) CREF(runner_1709))->type);
		    {
		       var_t res1772_1611;
		       {
			  variable_t variable_1603;
			  variable_1603 = (variable_t) (runner_1709);
			  {
			     var_t new1128_1604;
			     new1128_1604 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
			     {
				long arg1664_1605;
				arg1664_1605 = class_num_218___object(var_ast_node);
				{
				   obj_t obj_1609;
				   obj_1609 = (obj_t) (new1128_1604);
				   (((obj_t) CREF(obj_1609))->header = MAKE_HEADER(arg1664_1605, 0), BUNSPEC);
				}
			     }
			     {
				object_t aux_2290;
				aux_2290 = (object_t) (new1128_1604);
				OBJECT_WIDENING_SET(aux_2290, BFALSE);
			     }
			     ((((var_t) CREF(new1128_1604))->loc) = ((obj_t) loc_1710), BUNSPEC);
			     ((((var_t) CREF(new1128_1604))->type) = ((type_t) arg1592_904), BUNSPEC);
			     ((((var_t) CREF(new1128_1604))->variable) = ((variable_t) variable_1603), BUNSPEC);
			     res1772_1611 = new1128_1604;
			  }
		       }
		       arg1584_897 = res1772_1611;
		    }
		 }
		 {
		    obj_t arg1593_905;
		    var_t arg1595_906;
		    arg1593_905 = CNST_TABLE_REF(((long) 8));
		    {
		       type_t arg1603_911;
		       arg1603_911 = (((local_t) CREF(runner_1709))->type);
		       {
			  var_t res1773_1623;
			  {
			     variable_t variable_1615;
			     variable_1615 = (variable_t) (runner_1709);
			     {
				var_t new1128_1616;
				new1128_1616 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				{
				   long arg1664_1617;
				   arg1664_1617 = class_num_218___object(var_ast_node);
				   {
				      obj_t obj_1621;
				      obj_1621 = (obj_t) (new1128_1616);
				      (((obj_t) CREF(obj_1621))->header = MAKE_HEADER(arg1664_1617, 0), BUNSPEC);
				   }
				}
				{
				   object_t aux_2303;
				   aux_2303 = (object_t) (new1128_1616);
				   OBJECT_WIDENING_SET(aux_2303, BFALSE);
				}
				((((var_t) CREF(new1128_1616))->loc) = ((obj_t) loc_1710), BUNSPEC);
				((((var_t) CREF(new1128_1616))->type) = ((type_t) arg1603_911), BUNSPEC);
				((((var_t) CREF(new1128_1616))->variable) = ((variable_t) variable_1615), BUNSPEC);
				res1773_1623 = new1128_1616;
			     }
			  }
			  arg1595_906 = res1773_1623;
		       }
		    }
		    {
		       obj_t list1597_908;
		       {
			  obj_t arg1600_909;
			  arg1600_909 = MAKE_PAIR(BNIL, BNIL);
			  {
			     obj_t aux_2310;
			     aux_2310 = (obj_t) (arg1595_906);
			     list1597_908 = MAKE_PAIR(aux_2310, arg1600_909);
			  }
		       }
		       arg1585_898 = cons__138___r4_pairs_and_lists_6_3(arg1593_905, list1597_908);
		    }
		 }
		 {
		    obj_t list1588_900;
		    {
		       obj_t arg1589_901;
		       {
			  obj_t arg1590_902;
			  arg1590_902 = MAKE_PAIR(BNIL, BNIL);
			  arg1589_901 = MAKE_PAIR(arg1585_898, arg1590_902);
		       }
		       {
			  obj_t aux_2316;
			  aux_2316 = (obj_t) (arg1584_897);
			  list1588_900 = MAKE_PAIR(aux_2316, arg1589_901);
		       }
		    }
		    arg1574_889 = cons__138___r4_pairs_and_lists_6_3(arg1583_896, list1588_900);
		 }
	      }
	      arg1575_890 = loop_ast_apply(proc_1714, frame_1713, type_1712, stack_1711, loc_1710, runner_1709, CDR(locals_837), locals_837);
	      {
		 obj_t list1577_892;
		 {
		    obj_t arg1578_893;
		    {
		       obj_t arg1579_894;
		       arg1579_894 = MAKE_PAIR(BNIL, BNIL);
		       arg1578_893 = MAKE_PAIR(arg1575_890, arg1579_894);
		    }
		    list1577_892 = MAKE_PAIR(arg1574_889, arg1578_893);
		 }
		 arg1571_886 = cons__138___r4_pairs_and_lists_6_3(arg1573_888, list1577_892);
	      }
	   }
	   arg1572_887 = CNST_TABLE_REF(((long) 1));
	   arg1553_871 = sexp__node_235_ast_sexp(arg1571_886, stack_1711, loc_1710, arg1572_887);
	}
	{
	   let_var_6_t res1774_1641;
	   {
	      let_var_6_t new1229_1631;
	      new1229_1631 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
	      {
		 long arg1624_1632;
		 arg1624_1632 = class_num_218___object(let_var_6_ast_node);
		 {
		    obj_t obj_1639;
		    obj_1639 = (obj_t) (new1229_1631);
		    (((obj_t) CREF(obj_1639))->header = MAKE_HEADER(arg1624_1632, 0), BUNSPEC);
		 }
	      }
	      {
		 object_t aux_2332;
		 aux_2332 = (object_t) (new1229_1631);
		 OBJECT_WIDENING_SET(aux_2332, BFALSE);
	      }
	      ((((let_var_6_t) CREF(new1229_1631))->loc) = ((obj_t) loc_1710), BUNSPEC);
	      ((((let_var_6_t) CREF(new1229_1631))->type) = ((type_t) type_1712), BUNSPEC);
	      ((((let_var_6_t) CREF(new1229_1631))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
	      ((((let_var_6_t) CREF(new1229_1631))->bindings) = ((obj_t) arg1552_870), BUNSPEC);
	      ((((let_var_6_t) CREF(new1229_1631))->body) = ((node_t) arg1553_871), BUNSPEC);
	      ((((let_var_6_t) CREF(new1229_1631))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
	      res1774_1641 = new1229_1631;
	   }
	   return (obj_t) (res1774_1641);
	}
     }
}


obj_t 
imported_modules_init_94_ast_apply()
{
   module_initialization_70_type_type(((long) 0), "AST_APPLY");
   module_initialization_70_ast_var(((long) 0), "AST_APPLY");
   module_initialization_70_ast_node(((long) 0), "AST_APPLY");
   module_initialization_70_engine_param(((long) 0), "AST_APPLY");
   module_initialization_70_tools_error(((long) 0), "AST_APPLY");
   module_initialization_70_tools_location(((long) 0), "AST_APPLY");
   module_initialization_70_tools_shape(((long) 0), "AST_APPLY");
   module_initialization_70_type_cache(((long) 0), "AST_APPLY");
   module_initialization_70_ast_sexp(((long) 0), "AST_APPLY");
   module_initialization_70_ast_local(((long) 0), "AST_APPLY");
   return module_initialization_70_ast_app(((long) 0), "AST_APPLY");
}
