/*===========================================================================*/
/*   (Ast/build.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t inline_methods__72_object_inline();
extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t _build_ast_150_ast_build(obj_t, obj_t);
extern obj_t _build_ast_sans_remove_171_ast_build(obj_t, obj_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
extern obj_t append___r4_pairs_and_lists_6_3(obj_t);
static obj_t imported_modules_init_94_ast_build();
extern obj_t module_initialization_70_ast_build(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_unit(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_find_gdefs_13(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_object_inline(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t cnst_init_137_ast_build();
extern obj_t build_ast_sans_remove_93_ast_build(obj_t);
extern obj_t unit__defs_135_ast_unit(obj_t);
static obj_t require_initialization_114_ast_build = BUNSPEC;
static obj_t library_modules_init_112_ast_build();
extern obj_t build_ast_197_ast_build(obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t enter_function_81_tools_error(obj_t);
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t find_location_120_tools_location(obj_t);
extern obj_t current_error_port;
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t __current_pass__25_engine_pass;
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
static global_t sfun_def__ast_191_ast_build(global_t);
extern obj_t check_to_be_define_14_ast_find_gdefs_13();
extern obj_t leave_function_170_tools_error();
static obj_t __cnst[3];

DEFINE_STRING(string1502_ast_build, string1502_ast_build1513, "   . ", 5);
DEFINE_STRING(string1503_ast_build, string1503_ast_build1514, "failure during prelude hook", 27);
DEFINE_EXPORT_PROCEDURE(build_ast_sans_remove_env_209_ast_build, _build_ast_sans_remove_171_ast_build1515, _build_ast_sans_remove_171_ast_build, 0L, 1);
DEFINE_STRING(string1506_ast_build, string1506_ast_build1516, "failure during postlude hook", 28);
DEFINE_STRING(string1505_ast_build, string1505_ast_build1517, " error", 6);
DEFINE_EXPORT_PROCEDURE(build_ast_env_244_ast_build, _build_ast_150_ast_build1518, _build_ast_150_ast_build, 0L, 1);
DEFINE_STRING(string1501_ast_build, string1501_ast_build1519, "Ast", 3);
DEFINE_STRING(string1504_ast_build, string1504_ast_build1520, " occured, ending ...", 20);
DEFINE_STRING(string1507_ast_build, string1507_ast_build1521, "VALUE PASS-STARTED AST ", 23);

obj_t 
module_initialization_70_ast_build(long checksum_1099, char *from_1100)
{
   if (CBOOL(require_initialization_114_ast_build))
     {
	require_initialization_114_ast_build = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_build();
	cnst_init_137_ast_build();
	imported_modules_init_94_ast_build();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_build()
{
   module_initialization_70___r4_output_6_10_3(((long) 0), "AST_BUILD");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_BUILD");
   module_initialization_70___reader(((long) 0), "AST_BUILD");
   module_initialization_70___r4_numbers_6_5(((long) 0), "AST_BUILD");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_build()
{
   {
      obj_t cnst_port_138_1091;
      cnst_port_138_1091 = open_input_string(string1507_ast_build);
      {
	 long i_1092;
	 i_1092 = ((long) 2);
       loop_1093:
	 {
	    bool_t test1508_1094;
	    test1508_1094 = (i_1092 == ((long) -1));
	    if (test1508_1094)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1509_1095;
		    {
		       obj_t list1510_1096;
		       {
			  obj_t arg1511_1097;
			  arg1511_1097 = BNIL;
			  list1510_1096 = MAKE_PAIR(cnst_port_138_1091, arg1511_1097);
		       }
		       arg1509_1095 = read___reader(list1510_1096);
		    }
		    CNST_TABLE_SET(i_1092, arg1509_1095);
		 }
		 {
		    int aux_1098;
		    {
		       long aux_1117;
		       aux_1117 = (i_1092 - ((long) 1));
		       aux_1098 = (int) (aux_1117);
		    }
		    {
		       long i_1120;
		       i_1120 = (long) (aux_1098);
		       i_1092 = i_1120;
		       goto loop_1093;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
build_ast_197_ast_build(obj_t units_1)
{
   {
      obj_t arg1295_1035;
      obj_t arg1296_1036;
      arg1295_1035 = CNST_TABLE_REF(((long) 0));
      arg1296_1036 = build_ast_sans_remove_93_ast_build(units_1);
      return remove_var_123_ast_remove(arg1295_1035, arg1296_1036);
   }
}


obj_t 
_build_ast_150_ast_build(obj_t env_1086, obj_t units_1087)
{
   return build_ast_197_ast_build(units_1087);
}


obj_t 
build_ast_sans_remove_93_ast_build(obj_t units_2)
{
   {
      obj_t list1297_635;
      {
	 obj_t arg1299_637;
	 {
	    obj_t arg1303_639;
	    {
	       obj_t aux_1126;
	       aux_1126 = BCHAR(((unsigned char) '\n'));
	       arg1303_639 = MAKE_PAIR(aux_1126, BNIL);
	    }
	    arg1299_637 = MAKE_PAIR(string1501_ast_build, arg1303_639);
	 }
	 list1297_635 = MAKE_PAIR(string1502_ast_build, arg1299_637);
      }
      verbose_tools_speek(BINT(((long) 1)), list1297_635);
   }
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   __current_pass__25_engine_pass = string1501_ast_build;
   {
      obj_t hooks_641;
      obj_t hnames_642;
      hooks_641 = BNIL;
      hnames_642 = BNIL;
    loop_643:
      if (NULLP(hooks_641))
	{
	   CNST_TABLE_REF(((long) 1));
	}
      else
	{
	   bool_t test1311_648;
	   {
	      obj_t fun1317_654;
	      fun1317_654 = CAR(hooks_641);
	      {
		 obj_t aux_1138;
		 aux_1138 = PROCEDURE_ENTRY(fun1317_654) (fun1317_654, BEOA);
		 test1311_648 = CBOOL(aux_1138);
	      }
	   }
	   if (test1311_648)
	     {
		{
		   obj_t hnames_1145;
		   obj_t hooks_1143;
		   hooks_1143 = CDR(hooks_641);
		   hnames_1145 = CDR(hnames_642);
		   hnames_642 = hnames_1145;
		   hooks_641 = hooks_1143;
		   goto loop_643;
		}
	     }
	   else
	     {
		internal_error_43_tools_error(string1501_ast_build, string1503_ast_build, CAR(hnames_642));
	     }
	}
   }
   {
      obj_t defs_655;
      {
	 obj_t runner1371_715;
	 if (NULLP(units_2))
	   {
	      runner1371_715 = BNIL;
	   }
	 else
	   {
	      obj_t head1284_701;
	      {
		 obj_t arg1367_712;
		 arg1367_712 = unit__defs_135_ast_unit(CAR(units_2));
		 head1284_701 = MAKE_PAIR(arg1367_712, BNIL);
	      }
	      {
		 obj_t l1272_702;
		 obj_t tail1285_703;
		 l1272_702 = CDR(units_2);
		 tail1285_703 = head1284_701;
	       lname1283_704:
		 if (NULLP(l1272_702))
		   {
		      runner1371_715 = head1284_701;
		   }
		 else
		   {
		      obj_t new_tail1286_4_707;
		      {
			 obj_t arg1363_709;
			 arg1363_709 = unit__defs_135_ast_unit(CAR(l1272_702));
			 new_tail1286_4_707 = MAKE_PAIR(arg1363_709, BNIL);
		      }
		      SET_CDR(tail1285_703, new_tail1286_4_707);
		      {
			 obj_t tail1285_1162;
			 obj_t l1272_1160;
			 l1272_1160 = CDR(l1272_702);
			 tail1285_1162 = new_tail1286_4_707;
			 tail1285_703 = tail1285_1162;
			 l1272_702 = l1272_1160;
			 goto lname1283_704;
		      }
		   }
	      }
	   }
	 defs_655 = append___r4_pairs_and_lists_6_3(runner1371_715);
      }
      check_to_be_define_14_ast_find_gdefs_13();
      {
	 obj_t ast_656;
	 if (NULLP(defs_655))
	   {
	      ast_656 = BNIL;
	   }
	 else
	   {
	      obj_t head1291_685;
	      {
		 global_t arg1353_696;
		 {
		    global_t aux_1168;
		    {
		       obj_t aux_1169;
		       aux_1169 = CAR(defs_655);
		       aux_1168 = (global_t) (aux_1169);
		    }
		    arg1353_696 = sfun_def__ast_191_ast_build(aux_1168);
		 }
		 {
		    obj_t aux_1173;
		    aux_1173 = (obj_t) (arg1353_696);
		    head1291_685 = MAKE_PAIR(aux_1173, BNIL);
		 }
	      }
	      {
		 obj_t l1287_686;
		 obj_t tail1292_687;
		 l1287_686 = CDR(defs_655);
		 tail1292_687 = head1291_685;
	       lname1290_688:
		 if (NULLP(l1287_686))
		   {
		      ast_656 = head1291_685;
		   }
		 else
		   {
		      obj_t new_tail1293_138_691;
		      {
			 global_t arg1349_693;
			 {
			    global_t aux_1178;
			    {
			       obj_t aux_1179;
			       aux_1179 = CAR(l1287_686);
			       aux_1178 = (global_t) (aux_1179);
			    }
			    arg1349_693 = sfun_def__ast_191_ast_build(aux_1178);
			 }
			 {
			    obj_t aux_1183;
			    aux_1183 = (obj_t) (arg1349_693);
			    new_tail1293_138_691 = MAKE_PAIR(aux_1183, BNIL);
			 }
		      }
		      SET_CDR(tail1292_687, new_tail1293_138_691);
		      {
			 obj_t tail1292_1189;
			 obj_t l1287_1187;
			 l1287_1187 = CDR(l1287_686);
			 tail1292_1189 = new_tail1293_138_691;
			 tail1292_687 = tail1292_1189;
			 l1287_686 = l1287_1187;
			 goto lname1290_688;
		      }
		   }
	      }
	   }
	 inline_methods__72_object_inline();
	 {
	    bool_t test1318_658;
	    {
	       long n1_1067;
	       n1_1067 = (long) CINT(__nb_error_on_pass__70_tools_error);
	       test1318_658 = (n1_1067 > ((long) 0));
	    }
	    if (test1318_658)
	      {
		 {
		    char *arg1321_661;
		    {
		       bool_t test1330_668;
		       {
			  bool_t test1331_669;
			  {
			     obj_t obj_1069;
			     obj_1069 = __nb_error_on_pass__70_tools_error;
			     test1331_669 = INTEGERP(obj_1069);
			  }
			  if (test1331_669)
			    {
			       test1330_668 = _2__206___r4_numbers_6_5(__nb_error_on_pass__70_tools_error, BINT(((long) 1)));
			    }
			  else
			    {
			       test1330_668 = ((bool_t) 0);
			    }
		       }
		       if (test1330_668)
			 {
			    arg1321_661 = "s";
			 }
		       else
			 {
			    arg1321_661 = "";
			 }
		    }
		    {
		       obj_t list1323_663;
		       {
			  obj_t arg1325_664;
			  {
			     obj_t arg1327_665;
			     {
				obj_t arg1328_666;
				arg1328_666 = MAKE_PAIR(string1504_ast_build, BNIL);
				{
				   obj_t aux_1201;
				   aux_1201 = string_to_bstring(arg1321_661);
				   arg1327_665 = MAKE_PAIR(aux_1201, arg1328_666);
				}
			     }
			     arg1325_664 = MAKE_PAIR(string1505_ast_build, arg1327_665);
			  }
			  list1323_663 = MAKE_PAIR(__nb_error_on_pass__70_tools_error, arg1325_664);
		       }
		       fprint___r4_output_6_10_3(current_error_port, list1323_663);
		    }
		 }
		 {
		    obj_t res1499_1071;
		    exit(((long) -1));
		    res1499_1071 = BINT(((long) -1));
		    return res1499_1071;
		 }
	      }
	    else
	      {
		 obj_t hooks_670;
		 obj_t hnames_671;
		 hooks_670 = BNIL;
		 hnames_671 = BNIL;
	       loop_672:
		 if (NULLP(hooks_670))
		   {
		      return ast_656;
		   }
		 else
		   {
		      bool_t test1336_677;
		      {
			 obj_t fun1343_682;
			 fun1343_682 = CAR(hooks_670);
			 {
			    obj_t aux_1212;
			    aux_1212 = PROCEDURE_ENTRY(fun1343_682) (fun1343_682, BEOA);
			    test1336_677 = CBOOL(aux_1212);
			 }
		      }
		      if (test1336_677)
			{
			   {
			      obj_t hnames_1219;
			      obj_t hooks_1217;
			      hooks_1217 = CDR(hooks_670);
			      hnames_1219 = CDR(hnames_671);
			      hnames_671 = hnames_1219;
			      hooks_670 = hooks_1217;
			      goto loop_672;
			   }
			}
		      else
			{
			   return internal_error_43_tools_error(__current_pass__25_engine_pass, string1506_ast_build, CAR(hnames_671));
			}
		   }
	      }
	 }
      }
   }
}


obj_t 
_build_ast_sans_remove_171_ast_build(obj_t env_1088, obj_t units_1089)
{
   return build_ast_sans_remove_93_ast_build(units_1089);
}


global_t 
sfun_def__ast_191_ast_build(global_t def_3)
{
   enter_function_81_tools_error((((global_t) CREF(def_3))->id));
   {
      value_t sfun_717;
      sfun_717 = (((global_t) CREF(def_3))->value);
      {
	 obj_t sfun_args_174_718;
	 {
	    sfun_t obj_1080;
	    obj_1080 = (sfun_t) (sfun_717);
	    sfun_args_174_718 = (((sfun_t) CREF(obj_1080))->args);
	 }
	 {
	    obj_t sfun_body_exp_131_719;
	    {
	       sfun_t obj_1081;
	       obj_1081 = (sfun_t) (sfun_717);
	       sfun_body_exp_131_719 = (((sfun_t) CREF(obj_1081))->body);
	    }
	    {
	       obj_t def_loc_185_720;
	       def_loc_185_720 = find_location_120_tools_location((((global_t) CREF(def_3))->src));
	       {
		  node_t body_721;
		  {
		     obj_t arg1376_722;
		     obj_t arg1379_723;
		     arg1376_722 = find_location_loc_243_tools_location(sfun_body_exp_131_719, def_loc_185_720);
		     arg1379_723 = CNST_TABLE_REF(((long) 2));
		     body_721 = sexp__node_235_ast_sexp(sfun_body_exp_131_719, sfun_args_174_718, arg1376_722, arg1379_723);
		  }
		  {
		     {
			obj_t res1500_1085;
			{
			   sfun_t obj_1083;
			   obj_t val1077_1084;
			   obj_1083 = (sfun_t) (sfun_717);
			   val1077_1084 = (obj_t) (body_721);
			   {
			      obj_t x_1090;
			      x_1090 = ((((sfun_t) CREF(obj_1083))->body) = ((obj_t) val1077_1084), BUNSPEC);
			      res1500_1085 = BUNSPEC;
			   }
			}
			res1500_1085;
		     }
		     leave_function_170_tools_error();
		     return def_3;
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
imported_modules_init_94_ast_build()
{
   module_initialization_70_tools_speek(((long) 0), "AST_BUILD");
   module_initialization_70_tools_error(((long) 0), "AST_BUILD");
   module_initialization_70_engine_pass(((long) 0), "AST_BUILD");
   module_initialization_70_type_type(((long) 0), "AST_BUILD");
   module_initialization_70_ast_var(((long) 0), "AST_BUILD");
   module_initialization_70_ast_node(((long) 0), "AST_BUILD");
   module_initialization_70_ast_unit(((long) 0), "AST_BUILD");
   module_initialization_70_ast_sexp(((long) 0), "AST_BUILD");
   module_initialization_70_ast_env(((long) 0), "AST_BUILD");
   module_initialization_70_ast_find_gdefs_13(((long) 0), "AST_BUILD");
   module_initialization_70_ast_remove(((long) 0), "AST_BUILD");
   module_initialization_70_ast_local(((long) 0), "AST_BUILD");
   module_initialization_70_object_inline(((long) 0), "AST_BUILD");
   module_initialization_70_tools_args(((long) 0), "AST_BUILD");
   module_initialization_70_tools_progn(((long) 0), "AST_BUILD");
   module_initialization_70_tools_location(((long) 0), "AST_BUILD");
   return module_initialization_70_tools_shape(((long) 0), "AST_BUILD");
}
