/*===========================================================================*/
/*   (Ast/dump.scm)                                                          */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t let_fun_218_ast_node;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t closure_ast_node;
extern obj_t args_list__args__33_tools_args(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_ast_dump();
extern obj_t module_initialization_70_ast_dump(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t toplevel_init_63_ast_dump();
static obj_t cnst_init_137_ast_dump();
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t require_initialization_114_ast_dump = BUNSPEC;
extern obj_t node__sexp_247_ast_dump(node_t);
extern obj_t var_ast_node;
static obj_t library_modules_init_112_ast_dump();
extern obj_t cast_ast_node;
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern obj_t __type_shape___78_engine_param;
static obj_t node__sexp_default1328_181_ast_dump(node_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t setq_ast_node;
extern obj_t _node__sexp_17_ast_dump(obj_t, obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t _4dots_tools_misc;
extern obj_t set_ex_it_116_ast_node;
extern obj_t kwote_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
static obj_t _node__sexp_default1328_33_ast_dump(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t create_struct(obj_t, long);
extern obj_t app_ast_node;
static obj_t __cnst[26];

DEFINE_STRING(string1901_ast_dump, string1901_ast_dump1908, "BOX-SET! BOX-REF MAKE-BOX JUMP-EXIT SET-EXIT LET LABELS CASE FAILURE IF SET! CAST FREE-PRAGMA PRAGMA FUNCALL FUNCALL-EL ELIGHT FUNCALL-L LIGHT APPLY BEGIN QUOTE A-TVECTOR FUNCTION (QUOTE ()) NODE->SEXP-DEFAULT1328 ", 214);
DEFINE_STRING(string1900_ast_dump, string1900_ast_dump1909, "No method for this object", 25);
DEFINE_STATIC_PROCEDURE(node__sexp_default1328_env_60_ast_dump, _node__sexp_default1328_33_ast_dump1910, _node__sexp_default1328_33_ast_dump, 0L, 1);
DEFINE_EXPORT_GENERIC(node__sexp_env_62_ast_dump, _node__sexp_17_ast_dump1911, _node__sexp_17_ast_dump, 0L, 1);

obj_t 
module_initialization_70_ast_dump(long checksum_1652, char *from_1653)
{
   if (CBOOL(require_initialization_114_ast_dump))
     {
	require_initialization_114_ast_dump = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_dump();
	cnst_init_137_ast_dump();
	imported_modules_init_94_ast_dump();
	toplevel_init_63_ast_dump();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_dump()
{
   module_initialization_70___object(((long) 0), "AST_DUMP");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_DUMP");
   module_initialization_70___reader(((long) 0), "AST_DUMP");
   module_initialization_70___r4_symbols_6_4(((long) 0), "AST_DUMP");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_dump()
{
   {
      obj_t cnst_port_138_1644;
      cnst_port_138_1644 = open_input_string(string1901_ast_dump);
      {
	 long i_1645;
	 i_1645 = ((long) 25);
       loop_1646:
	 {
	    bool_t test1902_1647;
	    test1902_1647 = (i_1645 == ((long) -1));
	    if (test1902_1647)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1904_1648;
		    {
		       obj_t list1905_1649;
		       {
			  obj_t arg1906_1650;
			  arg1906_1650 = BNIL;
			  list1905_1649 = MAKE_PAIR(cnst_port_138_1644, arg1906_1650);
		       }
		       arg1904_1648 = read___reader(list1905_1649);
		    }
		    CNST_TABLE_SET(i_1645, arg1904_1648);
		 }
		 {
		    int aux_1651;
		    {
		       long aux_1671;
		       aux_1671 = (i_1645 - ((long) 1));
		       aux_1651 = (int) (aux_1671);
		    }
		    {
		       long i_1674;
		       i_1674 = (long) (aux_1651);
		       i_1645 = i_1674;
		       goto loop_1646;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_dump()
{
   add_generic__110___object(node__sexp_env_62_ast_dump, node__sexp_default1328_env_60_ast_dump);
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, var_ast_node, ((long) 1));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, closure_ast_node, ((long) 2));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, kwote_ast_node, ((long) 3));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, app_ast_node, ((long) 5));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, app_ly_162_ast_node, ((long) 6));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, funcall_ast_node, ((long) 7));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, pragma_ast_node, ((long) 8));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, cast_ast_node, ((long) 9));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, setq_ast_node, ((long) 10));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, conditional_ast_node, ((long) 11));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, fail_ast_node, ((long) 12));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, select_ast_node, ((long) 13));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, let_fun_218_ast_node, ((long) 14));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, let_var_6_ast_node, ((long) 15));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, set_ex_it_116_ast_node, ((long) 16));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, jump_ex_it_184_ast_node, ((long) 17));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, make_box_202_ast_node, ((long) 18));
   add_inlined_method__244___object(node__sexp_env_62_ast_dump, box_ref_242_ast_node, ((long) 19));
   {
      long aux_1697;
      aux_1697 = add_inlined_method__244___object(node__sexp_env_62_ast_dump, box_set__221_ast_node, ((long) 20));
      return BINT(aux_1697);
   }
}


obj_t 
node__sexp_default1328_181_ast_dump(node_t node_12)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1900_ast_dump, (obj_t) (node_12));
}


obj_t 
_node__sexp_default1328_33_ast_dump(obj_t env_1641, obj_t node_1642)
{
   return node__sexp_default1328_181_ast_dump((node_t) (node_1642));
}


obj_t 
node__sexp_247_ast_dump(node_t node_11)
{
   {
      obj_t method1508_996;
      obj_t class1513_997;
      {
	 obj_t arg1517_994;
	 obj_t arg1518_995;
	 {
	    object_t obj_1431;
	    obj_1431 = (object_t) (node_11);
	    {
	       obj_t pre_method_105_1432;
	       pre_method_105_1432 = PROCEDURE_REF(node__sexp_env_62_ast_dump, ((long) 2));
	       if (INTEGERP(pre_method_105_1432))
		 {
		    PROCEDURE_SET(node__sexp_env_62_ast_dump, ((long) 2), BUNSPEC);
		    arg1517_994 = pre_method_105_1432;
		 }
	       else
		 {
		    long obj_class_num_177_1437;
		    obj_class_num_177_1437 = TYPE(obj_1431);
		    {
		       obj_t arg1183_1438;
		       arg1183_1438 = PROCEDURE_REF(node__sexp_env_62_ast_dump, ((long) 1));
		       {
			  long arg1184_1442;
			  {
			     long arg1186_1443;
			     arg1186_1443 = OBJECT_TYPE;
			     arg1184_1442 = (obj_class_num_177_1437 - arg1186_1443);
			  }
			  arg1517_994 = VECTOR_REF(arg1183_1438, arg1184_1442);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1448;
	    object_1448 = (object_t) (node_11);
	    {
	       long arg1187_1449;
	       {
		  long arg1188_1450;
		  long arg1189_1451;
		  arg1188_1450 = TYPE(object_1448);
		  arg1189_1451 = OBJECT_TYPE;
		  arg1187_1449 = (arg1188_1450 - arg1189_1451);
	       }
	       {
		  obj_t vector_1455;
		  vector_1455 = __classes__134___object;
		  arg1518_995 = VECTOR_REF(vector_1455, arg1187_1449);
	       }
	    }
	 }
	 method1508_996 = arg1517_994;
	 class1513_997 = arg1518_995;
	 {
	    if (INTEGERP(method1508_996))
	      {
		 switch ((long) CINT(method1508_996))
		   {
		   case ((long) 0):
		      {
			 atom_t node_1003;
			 node_1003 = (atom_t) (node_11);
			 {
			    bool_t test_1723;
			    {
			       obj_t aux_1724;
			       aux_1724 = (((atom_t) CREF(node_1003))->value);
			       test_1723 = NULLP(aux_1724);
			    }
			    if (test_1723)
			      {
				 return CNST_TABLE_REF(((long) 1));
			      }
			    else
			      {
				 return (((atom_t) CREF(node_1003))->value);
			      }
			 }
		      }
		      break;
		   case ((long) 1):
		      {
			 var_t node_1006;
			 node_1006 = (var_t) (node_11);
			 {
			    obj_t aux_1730;
			    {
			       variable_t aux_1731;
			       aux_1731 = (((var_t) CREF(node_1006))->variable);
			       aux_1730 = (obj_t) (aux_1731);
			    }
			    return shape_tools_shape(aux_1730);
			 }
		      }
		      break;
		   case ((long) 2):
		      {
			 closure_t node_1008;
			 node_1008 = (closure_t) (node_11);
			 {
			    obj_t arg1524_1009;
			    obj_t arg1526_1010;
			    arg1524_1009 = CNST_TABLE_REF(((long) 2));
			    {
			       obj_t aux_1737;
			       {
				  variable_t aux_1738;
				  aux_1738 = (((closure_t) CREF(node_1008))->variable);
				  aux_1737 = (obj_t) (aux_1738);
			       }
			       arg1526_1010 = shape_tools_shape(aux_1737);
			    }
			    {
			       obj_t list1530_1012;
			       {
				  obj_t arg1531_1013;
				  arg1531_1013 = MAKE_PAIR(BNIL, BNIL);
				  list1530_1012 = MAKE_PAIR(arg1526_1010, arg1531_1013);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1524_1009, list1530_1012);
			    }
			 }
		      }
		      break;
		   case ((long) 3):
		      {
			 kwote_t node_1016;
			 node_1016 = (kwote_t) (node_11);
			 {
			    obj_t value_1017;
			    value_1017 = (((kwote_t) CREF(node_1016))->value);
			    {
			       bool_t test_1747;
			       if (STRUCTP(value_1017))
				 {
				    obj_t aux_1752;
				    obj_t aux_1750;
				    aux_1752 = CNST_TABLE_REF(((long) 3));
				    aux_1750 = STRUCT_KEY(value_1017);
				    test_1747 = (aux_1750 == aux_1752);
				 }
			       else
				 {
				    test_1747 = ((bool_t) 0);
				 }
			       if (test_1747)
				 {
				    obj_t arg1536_1019;
				    obj_t arg1537_1020;
				    arg1536_1019 = CNST_TABLE_REF(((long) 4));
				    {
				       obj_t arg1542_1025;
				       obj_t arg1543_1026;
				       arg1542_1025 = shape_tools_shape(STRUCT_REF(value_1017, ((long) 0)));
				       arg1543_1026 = STRUCT_REF(value_1017, ((long) 1));
				       {
					  obj_t new_1479;
					  {
					     obj_t aux_1759;
					     aux_1759 = CNST_TABLE_REF(((long) 3));
					     new_1479 = create_struct(aux_1759, ((long) 2));
					  }
					  STRUCT_SET(new_1479, ((long) 1), arg1543_1026);
					  STRUCT_SET(new_1479, ((long) 0), arg1542_1025);
					  arg1537_1020 = new_1479;
				       }
				    }
				    {
				       obj_t list1539_1022;
				       {
					  obj_t arg1540_1023;
					  arg1540_1023 = MAKE_PAIR(BNIL, BNIL);
					  list1539_1022 = MAKE_PAIR(arg1537_1020, arg1540_1023);
				       }
				       return cons__138___r4_pairs_and_lists_6_3(arg1536_1019, list1539_1022);
				    }
				 }
			       else
				 {
				    obj_t arg1549_1028;
				    arg1549_1028 = CNST_TABLE_REF(((long) 4));
				    {
				       obj_t list1551_1030;
				       {
					  obj_t arg1552_1031;
					  arg1552_1031 = MAKE_PAIR(BNIL, BNIL);
					  list1551_1030 = MAKE_PAIR(value_1017, arg1552_1031);
				       }
				       return cons__138___r4_pairs_and_lists_6_3(arg1549_1028, list1551_1030);
				    }
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 4):
		      {
			 sequence_t node_1033;
			 node_1033 = (sequence_t) (node_11);
			 {
			    obj_t arg1554_1034;
			    obj_t arg1555_1035;
			    arg1554_1034 = CNST_TABLE_REF(((long) 5));
			    {
			       obj_t arg1559_1038;
			       obj_t arg1560_1039;
			       {
				  obj_t l1272_1040;
				  l1272_1040 = (((sequence_t) CREF(node_1033))->nodes);
				  if (NULLP(l1272_1040))
				    {
				       arg1559_1038 = BNIL;
				    }
				  else
				    {
				       obj_t head1284_1042;
				       {
					  obj_t arg1568_1053;
					  {
					     node_t aux_1776;
					     {
						obj_t aux_1777;
						aux_1777 = CAR(l1272_1040);
						aux_1776 = (node_t) (aux_1777);
					     }
					     arg1568_1053 = node__sexp_247_ast_dump(aux_1776);
					  }
					  head1284_1042 = MAKE_PAIR(arg1568_1053, BNIL);
				       }
				       {
					  obj_t l1272_1043;
					  obj_t tail1285_1044;
					  l1272_1043 = CDR(l1272_1040);
					  tail1285_1044 = head1284_1042;
					lname1283_1045:
					  if (NULLP(l1272_1043))
					    {
					       arg1559_1038 = head1284_1042;
					    }
					  else
					    {
					       obj_t new_tail1286_4_1048;
					       {
						  obj_t arg1565_1050;
						  {
						     node_t aux_1784;
						     {
							obj_t aux_1785;
							aux_1785 = CAR(l1272_1043);
							aux_1784 = (node_t) (aux_1785);
						     }
						     arg1565_1050 = node__sexp_247_ast_dump(aux_1784);
						  }
						  new_tail1286_4_1048 = MAKE_PAIR(arg1565_1050, BNIL);
					       }
					       SET_CDR(tail1285_1044, new_tail1286_4_1048);
					       {
						  obj_t tail1285_1793;
						  obj_t l1272_1791;
						  l1272_1791 = CDR(l1272_1043);
						  tail1285_1793 = new_tail1286_4_1048;
						  tail1285_1044 = tail1285_1793;
						  l1272_1043 = l1272_1791;
						  goto lname1283_1045;
					       }
					    }
				       }
				    }
			       }
			       arg1560_1039 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
			       arg1555_1035 = append_2_18___r4_pairs_and_lists_6_3(arg1559_1038, arg1560_1039);
			    }
			    {
			       obj_t list1556_1036;
			       list1556_1036 = MAKE_PAIR(arg1555_1035, BNIL);
			       return cons__138___r4_pairs_and_lists_6_3(arg1554_1034, list1556_1036);
			    }
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 app_t node_1058;
			 node_1058 = (app_t) (node_11);
			 {
			    obj_t arg1574_1059;
			    obj_t arg1575_1060;
			    {
			       node_t aux_1800;
			       {
				  var_t aux_1801;
				  aux_1801 = (((app_t) CREF(node_1058))->fun);
				  aux_1800 = (node_t) (aux_1801);
			       }
			       arg1574_1059 = node__sexp_247_ast_dump(aux_1800);
			    }
			    {
			       obj_t arg1579_1064;
			       obj_t arg1582_1065;
			       {
				  obj_t l1287_1066;
				  l1287_1066 = (((app_t) CREF(node_1058))->args);
				  if (NULLP(l1287_1066))
				    {
				       arg1579_1064 = BNIL;
				    }
				  else
				    {
				       obj_t head1291_1068;
				       {
					  obj_t arg1591_1079;
					  {
					     node_t aux_1808;
					     {
						obj_t aux_1809;
						aux_1809 = CAR(l1287_1066);
						aux_1808 = (node_t) (aux_1809);
					     }
					     arg1591_1079 = node__sexp_247_ast_dump(aux_1808);
					  }
					  head1291_1068 = MAKE_PAIR(arg1591_1079, BNIL);
				       }
				       {
					  obj_t l1287_1069;
					  obj_t tail1292_1070;
					  l1287_1069 = CDR(l1287_1066);
					  tail1292_1070 = head1291_1068;
					lname1290_1071:
					  if (NULLP(l1287_1069))
					    {
					       arg1579_1064 = head1291_1068;
					    }
					  else
					    {
					       obj_t new_tail1293_138_1074;
					       {
						  obj_t arg1588_1076;
						  {
						     node_t aux_1816;
						     {
							obj_t aux_1817;
							aux_1817 = CAR(l1287_1069);
							aux_1816 = (node_t) (aux_1817);
						     }
						     arg1588_1076 = node__sexp_247_ast_dump(aux_1816);
						  }
						  new_tail1293_138_1074 = MAKE_PAIR(arg1588_1076, BNIL);
					       }
					       SET_CDR(tail1292_1070, new_tail1293_138_1074);
					       {
						  obj_t tail1292_1825;
						  obj_t l1287_1823;
						  l1287_1823 = CDR(l1287_1069);
						  tail1292_1825 = new_tail1293_138_1074;
						  tail1292_1070 = tail1292_1825;
						  l1287_1069 = l1287_1823;
						  goto lname1290_1071;
					       }
					    }
				       }
				    }
			       }
			       arg1582_1065 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
			       arg1575_1060 = append_2_18___r4_pairs_and_lists_6_3(arg1579_1064, arg1582_1065);
			    }
			    {
			       obj_t list1576_1061;
			       list1576_1061 = MAKE_PAIR(arg1575_1060, BNIL);
			       return cons__138___r4_pairs_and_lists_6_3(arg1574_1059, list1576_1061);
			    }
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 app_ly_162_t node_1084;
			 node_1084 = (app_ly_162_t) (node_11);
			 {
			    obj_t arg1597_1085;
			    obj_t arg1600_1086;
			    obj_t arg1601_1087;
			    arg1597_1085 = CNST_TABLE_REF(((long) 6));
			    arg1600_1086 = node__sexp_247_ast_dump((((app_ly_162_t) CREF(node_1084))->fun));
			    arg1601_1087 = node__sexp_247_ast_dump((((app_ly_162_t) CREF(node_1084))->arg));
			    {
			       obj_t list1604_1089;
			       {
				  obj_t arg1605_1090;
				  {
				     obj_t arg1606_1091;
				     arg1606_1091 = MAKE_PAIR(BNIL, BNIL);
				     arg1605_1090 = MAKE_PAIR(arg1601_1087, arg1606_1091);
				  }
				  list1604_1089 = MAKE_PAIR(arg1600_1086, arg1605_1090);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1597_1085, list1604_1089);
			    }
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 funcall_t node_1095;
			 node_1095 = (funcall_t) (node_11);
			 {
			    obj_t arg1614_1096;
			    obj_t arg1616_1097;
			    obj_t arg1617_1098;
			    {
			       obj_t case_value_58_1102;
			       case_value_58_1102 = (((funcall_t) CREF(node_1095))->strength);
			       {
				  bool_t test_1843;
				  {
				     obj_t aux_1844;
				     aux_1844 = CNST_TABLE_REF(((long) 7));
				     test_1843 = (case_value_58_1102 == aux_1844);
				  }
				  if (test_1843)
				    {
				       arg1614_1096 = CNST_TABLE_REF(((long) 8));
				    }
				  else
				    {
				       bool_t test_1848;
				       {
					  obj_t aux_1849;
					  aux_1849 = CNST_TABLE_REF(((long) 9));
					  test_1848 = (case_value_58_1102 == aux_1849);
				       }
				       if (test_1848)
					 {
					    arg1614_1096 = CNST_TABLE_REF(((long) 10));
					 }
				       else
					 {
					    arg1614_1096 = CNST_TABLE_REF(((long) 11));
					 }
				    }
			       }
			    }
			    arg1616_1097 = node__sexp_247_ast_dump((((funcall_t) CREF(node_1095))->fun));
			    {
			       obj_t arg1627_1108;
			       obj_t arg1628_1109;
			       {
				  obj_t l1294_1110;
				  l1294_1110 = (((funcall_t) CREF(node_1095))->args);
				  if (NULLP(l1294_1110))
				    {
				       arg1627_1108 = BNIL;
				    }
				  else
				    {
				       obj_t head1296_1112;
				       {
					  obj_t arg1641_1123;
					  {
					     node_t aux_1859;
					     {
						obj_t aux_1860;
						aux_1860 = CAR(l1294_1110);
						aux_1859 = (node_t) (aux_1860);
					     }
					     arg1641_1123 = node__sexp_247_ast_dump(aux_1859);
					  }
					  head1296_1112 = MAKE_PAIR(arg1641_1123, BNIL);
				       }
				       {
					  obj_t l1294_1113;
					  obj_t tail1297_1114;
					  l1294_1113 = CDR(l1294_1110);
					  tail1297_1114 = head1296_1112;
					lname1295_1115:
					  if (NULLP(l1294_1113))
					    {
					       arg1627_1108 = head1296_1112;
					    }
					  else
					    {
					       obj_t new_tail1298_25_1118;
					       {
						  obj_t arg1634_1120;
						  {
						     node_t aux_1867;
						     {
							obj_t aux_1868;
							aux_1868 = CAR(l1294_1113);
							aux_1867 = (node_t) (aux_1868);
						     }
						     arg1634_1120 = node__sexp_247_ast_dump(aux_1867);
						  }
						  new_tail1298_25_1118 = MAKE_PAIR(arg1634_1120, BNIL);
					       }
					       SET_CDR(tail1297_1114, new_tail1298_25_1118);
					       {
						  obj_t tail1297_1876;
						  obj_t l1294_1874;
						  l1294_1874 = CDR(l1294_1113);
						  tail1297_1876 = new_tail1298_25_1118;
						  tail1297_1114 = tail1297_1876;
						  l1294_1113 = l1294_1874;
						  goto lname1295_1115;
					       }
					    }
				       }
				    }
			       }
			       arg1628_1109 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
			       arg1617_1098 = append_2_18___r4_pairs_and_lists_6_3(arg1627_1108, arg1628_1109);
			    }
			    {
			       obj_t list1618_1099;
			       {
				  obj_t arg1619_1100;
				  arg1619_1100 = MAKE_PAIR(arg1617_1098, BNIL);
				  list1618_1099 = MAKE_PAIR(arg1616_1097, arg1619_1100);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1614_1096, list1618_1099);
			    }
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 pragma_t node_1128;
			 node_1128 = (pragma_t) (node_11);
			 {
			    obj_t p_1129;
			    {
			       bool_t test_1884;
			       {
				  obj_t aux_1885;
				  aux_1885 = (((pragma_t) CREF(node_1128))->side_effect__165);
				  test_1884 = CBOOL(aux_1885);
			       }
			       if (test_1884)
				 {
				    p_1129 = CNST_TABLE_REF(((long) 12));
				 }
			       else
				 {
				    p_1129 = CNST_TABLE_REF(((long) 13));
				 }
			    }
			    {
			       obj_t arg1646_1130;
			       obj_t arg1647_1131;
			       obj_t arg1648_1132;
			       if (CBOOL(__type_shape___78_engine_param))
				 {
				    obj_t list1653_1137;
				    {
				       obj_t arg1654_1138;
				       {
					  obj_t arg1655_1139;
					  {
					     obj_t aux_1892;
					     {
						type_t arg1657_1141;
						{
						   node_t obj_1541;
						   obj_1541 = (node_t) (node_1128);
						   arg1657_1141 = (((node_t) CREF(obj_1541))->type);
						}
						aux_1892 = (((type_t) CREF(arg1657_1141))->id);
					     }
					     arg1655_1139 = MAKE_PAIR(aux_1892, BNIL);
					  }
					  arg1654_1138 = MAKE_PAIR(_4dots_tools_misc, arg1655_1139);
				       }
				       list1653_1137 = MAKE_PAIR(p_1129, arg1654_1138);
				    }
				    arg1646_1130 = symbol_append_197___r4_symbols_6_4(list1653_1137);
				 }
			       else
				 {
				    arg1646_1130 = p_1129;
				 }
			       arg1647_1131 = (((pragma_t) CREF(node_1128))->format);
			       {
				  obj_t arg1659_1142;
				  obj_t arg1661_1143;
				  {
				     obj_t l1299_1144;
				     l1299_1144 = (((pragma_t) CREF(node_1128))->args);
				     if (NULLP(l1299_1144))
				       {
					  arg1659_1142 = BNIL;
				       }
				     else
				       {
					  obj_t head1302_1146;
					  {
					     obj_t arg1671_1157;
					     {
						node_t aux_1904;
						{
						   obj_t aux_1905;
						   aux_1905 = CAR(l1299_1144);
						   aux_1904 = (node_t) (aux_1905);
						}
						arg1671_1157 = node__sexp_247_ast_dump(aux_1904);
					     }
					     head1302_1146 = MAKE_PAIR(arg1671_1157, BNIL);
					  }
					  {
					     obj_t l1299_1147;
					     obj_t tail1303_1148;
					     l1299_1147 = CDR(l1299_1144);
					     tail1303_1148 = head1302_1146;
					   lname1301_1149:
					     if (NULLP(l1299_1147))
					       {
						  arg1659_1142 = head1302_1146;
					       }
					     else
					       {
						  obj_t new_tail1304_1_1152;
						  {
						     obj_t arg1667_1154;
						     {
							node_t aux_1912;
							{
							   obj_t aux_1913;
							   aux_1913 = CAR(l1299_1147);
							   aux_1912 = (node_t) (aux_1913);
							}
							arg1667_1154 = node__sexp_247_ast_dump(aux_1912);
						     }
						     new_tail1304_1_1152 = MAKE_PAIR(arg1667_1154, BNIL);
						  }
						  SET_CDR(tail1303_1148, new_tail1304_1_1152);
						  {
						     obj_t tail1303_1921;
						     obj_t l1299_1919;
						     l1299_1919 = CDR(l1299_1147);
						     tail1303_1921 = new_tail1304_1_1152;
						     tail1303_1148 = tail1303_1921;
						     l1299_1147 = l1299_1919;
						     goto lname1301_1149;
						  }
					       }
					  }
				       }
				  }
				  arg1661_1143 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
				  arg1648_1132 = append_2_18___r4_pairs_and_lists_6_3(arg1659_1142, arg1661_1143);
			       }
			       {
				  obj_t list1649_1133;
				  {
				     obj_t arg1650_1134;
				     arg1650_1134 = MAKE_PAIR(arg1648_1132, BNIL);
				     list1649_1133 = MAKE_PAIR(arg1647_1131, arg1650_1134);
				  }
				  return cons__138___r4_pairs_and_lists_6_3(arg1646_1130, list1649_1133);
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 cast_t node_1163;
			 node_1163 = (cast_t) (node_11);
			 {
			    obj_t arg1680_1165;
			    obj_t arg1681_1166;
			    {
			       obj_t arg1687_1171;
			       arg1687_1171 = CNST_TABLE_REF(((long) 14));
			       {
				  obj_t list1689_1173;
				  {
				     obj_t arg1690_1174;
				     {
					obj_t arg1691_1175;
					{
					   obj_t aux_1930;
					   {
					      type_t arg1694_1177;
					      arg1694_1177 = (((cast_t) CREF(node_1163))->type);
					      aux_1930 = (((type_t) CREF(arg1694_1177))->id);
					   }
					   arg1691_1175 = MAKE_PAIR(aux_1930, BNIL);
					}
					arg1690_1174 = MAKE_PAIR(_4dots_tools_misc, arg1691_1175);
				     }
				     list1689_1173 = MAKE_PAIR(arg1687_1171, arg1690_1174);
				  }
				  arg1680_1165 = symbol_append_197___r4_symbols_6_4(list1689_1173);
			       }
			    }
			    arg1681_1166 = node__sexp_247_ast_dump((((cast_t) CREF(node_1163))->arg));
			    {
			       obj_t list1683_1168;
			       {
				  obj_t arg1684_1169;
				  arg1684_1169 = MAKE_PAIR(BNIL, BNIL);
				  list1683_1168 = MAKE_PAIR(arg1681_1166, arg1684_1169);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1680_1165, list1683_1168);
			    }
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 setq_t node_1179;
			 node_1179 = (setq_t) (node_11);
			 {
			    obj_t arg1696_1180;
			    obj_t arg1697_1181;
			    obj_t arg1698_1182;
			    arg1696_1180 = CNST_TABLE_REF(((long) 15));
			    {
			       node_t aux_1944;
			       {
				  var_t aux_1945;
				  aux_1945 = (((setq_t) CREF(node_1179))->var);
				  aux_1944 = (node_t) (aux_1945);
			       }
			       arg1697_1181 = node__sexp_247_ast_dump(aux_1944);
			    }
			    arg1698_1182 = node__sexp_247_ast_dump((((setq_t) CREF(node_1179))->value));
			    {
			       obj_t list1700_1184;
			       {
				  obj_t arg1701_1185;
				  {
				     obj_t arg1702_1186;
				     arg1702_1186 = MAKE_PAIR(BNIL, BNIL);
				     arg1701_1185 = MAKE_PAIR(arg1698_1182, arg1702_1186);
				  }
				  list1700_1184 = MAKE_PAIR(arg1697_1181, arg1701_1185);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1696_1180, list1700_1184);
			    }
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 conditional_t node_1190;
			 node_1190 = (conditional_t) (node_11);
			 {
			    obj_t arg1706_1191;
			    obj_t arg1707_1192;
			    obj_t arg1708_1193;
			    obj_t arg1709_1194;
			    arg1706_1191 = CNST_TABLE_REF(((long) 16));
			    arg1707_1192 = node__sexp_247_ast_dump((((conditional_t) CREF(node_1190))->test));
			    arg1708_1193 = node__sexp_247_ast_dump((((conditional_t) CREF(node_1190))->true));
			    arg1709_1194 = node__sexp_247_ast_dump((((conditional_t) CREF(node_1190))->false));
			    {
			       obj_t list1711_1196;
			       {
				  obj_t arg1712_1197;
				  {
				     obj_t arg1714_1198;
				     {
					obj_t arg1715_1199;
					arg1715_1199 = MAKE_PAIR(BNIL, BNIL);
					arg1714_1198 = MAKE_PAIR(arg1709_1194, arg1715_1199);
				     }
				     arg1712_1197 = MAKE_PAIR(arg1708_1193, arg1714_1198);
				  }
				  list1711_1196 = MAKE_PAIR(arg1707_1192, arg1712_1197);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1706_1191, list1711_1196);
			    }
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 fail_t node_1204;
			 node_1204 = (fail_t) (node_11);
			 {
			    obj_t arg1720_1205;
			    obj_t arg1721_1206;
			    obj_t arg1722_1207;
			    obj_t arg1724_1208;
			    arg1720_1205 = CNST_TABLE_REF(((long) 17));
			    arg1721_1206 = node__sexp_247_ast_dump((((fail_t) CREF(node_1204))->proc));
			    arg1722_1207 = node__sexp_247_ast_dump((((fail_t) CREF(node_1204))->msg));
			    arg1724_1208 = node__sexp_247_ast_dump((((fail_t) CREF(node_1204))->obj));
			    {
			       obj_t list1726_1210;
			       {
				  obj_t arg1730_1211;
				  {
				     obj_t arg1731_1212;
				     {
					obj_t arg1732_1213;
					arg1732_1213 = MAKE_PAIR(BNIL, BNIL);
					arg1731_1212 = MAKE_PAIR(arg1724_1208, arg1732_1213);
				     }
				     arg1730_1211 = MAKE_PAIR(arg1722_1207, arg1731_1212);
				  }
				  list1726_1210 = MAKE_PAIR(arg1721_1206, arg1730_1211);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1720_1205, list1726_1210);
			    }
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 select_t node_1218;
			 node_1218 = (select_t) (node_11);
			 {
			    obj_t arg1737_1219;
			    obj_t arg1738_1220;
			    obj_t arg1740_1221;
			    arg1737_1219 = CNST_TABLE_REF(((long) 18));
			    arg1738_1220 = node__sexp_247_ast_dump((((select_t) CREF(node_1218))->test));
			    {
			       obj_t arg1746_1226;
			       obj_t arg1747_1227;
			       {
				  obj_t l1306_1228;
				  l1306_1228 = (((select_t) CREF(node_1218))->clauses);
				  if (NULLP(l1306_1228))
				    {
				       arg1746_1226 = BNIL;
				    }
				  else
				    {
				       obj_t head1308_1230;
				       head1308_1230 = MAKE_PAIR(BNIL, BNIL);
				       {
					  obj_t l1306_1231;
					  obj_t tail1309_1232;
					  l1306_1231 = l1306_1228;
					  tail1309_1232 = head1308_1230;
					lname1307_1233:
					  if (NULLP(l1306_1231))
					    {
					       arg1746_1226 = CDR(head1308_1230);
					    }
					  else
					    {
					       obj_t new_tail1310_63_1235;
					       {
						  obj_t arg1753_1237;
						  {
						     obj_t clause_1239;
						     clause_1239 = CAR(l1306_1231);
						     {
							obj_t arg1755_1240;
							obj_t arg1756_1241;
							arg1755_1240 = CAR(clause_1239);
							{
							   node_t aux_1994;
							   {
							      obj_t aux_1995;
							      aux_1995 = CDR(clause_1239);
							      aux_1994 = (node_t) (aux_1995);
							   }
							   arg1756_1241 = node__sexp_247_ast_dump(aux_1994);
							}
							{
							   obj_t list1759_1243;
							   {
							      obj_t arg1761_1244;
							      arg1761_1244 = MAKE_PAIR(BNIL, BNIL);
							      list1759_1243 = MAKE_PAIR(arg1756_1241, arg1761_1244);
							   }
							   arg1753_1237 = cons__138___r4_pairs_and_lists_6_3(arg1755_1240, list1759_1243);
							}
						     }
						  }
						  new_tail1310_63_1235 = MAKE_PAIR(arg1753_1237, BNIL);
					       }
					       SET_CDR(tail1309_1232, new_tail1310_63_1235);
					       {
						  obj_t tail1309_2006;
						  obj_t l1306_2004;
						  l1306_2004 = CDR(l1306_1231);
						  tail1309_2006 = new_tail1310_63_1235;
						  tail1309_1232 = tail1309_2006;
						  l1306_1231 = l1306_2004;
						  goto lname1307_1233;
					       }
					    }
				       }
				    }
			       }
			       arg1747_1227 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
			       arg1740_1221 = append_2_18___r4_pairs_and_lists_6_3(arg1746_1226, arg1747_1227);
			    }
			    {
			       obj_t list1741_1222;
			       {
				  obj_t arg1742_1223;
				  arg1742_1223 = MAKE_PAIR(arg1740_1221, BNIL);
				  list1741_1222 = MAKE_PAIR(arg1738_1220, arg1742_1223);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1737_1219, list1741_1222);
			    }
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 let_fun_218_t node_1251;
			 node_1251 = (let_fun_218_t) (node_11);
			 {
			    obj_t arg1769_1252;
			    obj_t arg1770_1253;
			    obj_t arg1771_1254;
			    arg1769_1252 = CNST_TABLE_REF(((long) 19));
			    {
			       obj_t l1311_1260;
			       l1311_1260 = (((let_fun_218_t) CREF(node_1251))->locals);
			       if (NULLP(l1311_1260))
				 {
				    arg1770_1253 = BNIL;
				 }
			       else
				 {
				    obj_t head1315_1262;
				    head1315_1262 = MAKE_PAIR(BNIL, BNIL);
				    {
				       obj_t l1311_1263;
				       obj_t tail1316_1264;
				       l1311_1263 = l1311_1260;
				       tail1316_1264 = head1315_1262;
				     lname1314_1265:
				       if (NULLP(l1311_1263))
					 {
					    arg1770_1253 = CDR(head1315_1262);
					 }
				       else
					 {
					    obj_t new_tail1317_184_1267;
					    {
					       obj_t arg1780_1269;
					       {
						  obj_t fun_1271;
						  fun_1271 = CAR(l1311_1263);
						  {
						     obj_t arg1783_1272;
						     obj_t arg1784_1273;
						     obj_t arg1785_1274;
						     arg1783_1272 = shape_tools_shape(fun_1271);
						     {
							obj_t arg1792_1280;
							long arg1793_1281;
							{
							   obj_t l1318_1282;
							   {
							      sfun_t obj_1591;
							      {
								 value_t aux_2023;
								 {
								    local_t obj_1590;
								    obj_1590 = (local_t) (fun_1271);
								    aux_2023 = (((local_t) CREF(obj_1590))->value);
								 }
								 obj_1591 = (sfun_t) (aux_2023);
							      }
							      l1318_1282 = (((sfun_t) CREF(obj_1591))->args);
							   }
							   if (NULLP(l1318_1282))
							     {
								arg1792_1280 = BNIL;
							     }
							   else
							     {
								obj_t head1320_1284;
								{
								   obj_t arg1802_1295;
								   arg1802_1295 = shape_tools_shape(CAR(l1318_1282));
								   head1320_1284 = MAKE_PAIR(arg1802_1295, BNIL);
								}
								{
								   obj_t l1318_1285;
								   obj_t tail1321_1286;
								   l1318_1285 = CDR(l1318_1282);
								   tail1321_1286 = head1320_1284;
								 lname1319_1287:
								   if (NULLP(l1318_1285))
								     {
									arg1792_1280 = head1320_1284;
								     }
								   else
								     {
									obj_t new_tail1322_103_1290;
									{
									   obj_t arg1799_1292;
									   arg1799_1292 = shape_tools_shape(CAR(l1318_1285));
									   new_tail1322_103_1290 = MAKE_PAIR(arg1799_1292, BNIL);
									}
									SET_CDR(tail1321_1286, new_tail1322_103_1290);
									{
									   obj_t tail1321_2041;
									   obj_t l1318_2039;
									   l1318_2039 = CDR(l1318_1285);
									   tail1321_2041 = new_tail1322_103_1290;
									   tail1321_1286 = tail1321_2041;
									   l1318_1285 = l1318_2039;
									   goto lname1319_1287;
									}
								     }
								}
							     }
							}
							{
							   sfun_t obj_1605;
							   {
							      value_t aux_2043;
							      {
								 local_t obj_1604;
								 obj_1604 = (local_t) (fun_1271);
								 aux_2043 = (((local_t) CREF(obj_1604))->value);
							      }
							      obj_1605 = (sfun_t) (aux_2043);
							   }
							   arg1793_1281 = (((sfun_t) CREF(obj_1605))->arity);
							}
							arg1784_1273 = args_list__args__33_tools_args(arg1792_1280, BINT(arg1793_1281));
						     }
						     {
							node_t aux_2050;
							{
							   obj_t aux_2051;
							   {
							      sfun_t obj_1607;
							      {
								 value_t aux_2052;
								 {
								    local_t obj_1606;
								    obj_1606 = (local_t) (fun_1271);
								    aux_2052 = (((local_t) CREF(obj_1606))->value);
								 }
								 obj_1607 = (sfun_t) (aux_2052);
							      }
							      aux_2051 = (((sfun_t) CREF(obj_1607))->body);
							   }
							   aux_2050 = (node_t) (aux_2051);
							}
							arg1785_1274 = node__sexp_247_ast_dump(aux_2050);
						     }
						     {
							obj_t list1787_1276;
							{
							   obj_t arg1788_1277;
							   {
							      obj_t arg1789_1278;
							      arg1789_1278 = MAKE_PAIR(BNIL, BNIL);
							      arg1788_1277 = MAKE_PAIR(arg1785_1274, arg1789_1278);
							   }
							   list1787_1276 = MAKE_PAIR(arg1784_1273, arg1788_1277);
							}
							arg1780_1269 = cons__138___r4_pairs_and_lists_6_3(arg1783_1272, list1787_1276);
						     }
						  }
					       }
					       new_tail1317_184_1267 = MAKE_PAIR(arg1780_1269, BNIL);
					    }
					    SET_CDR(tail1316_1264, new_tail1317_184_1267);
					    {
					       obj_t tail1316_2067;
					       obj_t l1311_2065;
					       l1311_2065 = CDR(l1311_1263);
					       tail1316_2067 = new_tail1317_184_1267;
					       tail1316_1264 = tail1316_2067;
					       l1311_1263 = l1311_2065;
					       goto lname1314_1265;
					    }
					 }
				    }
				 }
			    }
			    arg1771_1254 = node__sexp_247_ast_dump((((let_fun_218_t) CREF(node_1251))->body));
			    {
			       obj_t list1773_1256;
			       {
				  obj_t arg1774_1257;
				  {
				     obj_t arg1775_1258;
				     arg1775_1258 = MAKE_PAIR(BNIL, BNIL);
				     arg1774_1257 = MAKE_PAIR(arg1771_1254, arg1775_1258);
				  }
				  list1773_1256 = MAKE_PAIR(arg1770_1253, arg1774_1257);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1769_1252, list1773_1256);
			    }
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 let_var_6_t node_1305;
			 node_1305 = (let_var_6_t) (node_11);
			 {
			    obj_t arg1813_1306;
			    obj_t arg1814_1307;
			    obj_t arg1819_1308;
			    arg1813_1306 = CNST_TABLE_REF(((long) 20));
			    {
			       obj_t l1323_1314;
			       l1323_1314 = (((let_var_6_t) CREF(node_1305))->bindings);
			       if (NULLP(l1323_1314))
				 {
				    arg1814_1307 = BNIL;
				 }
			       else
				 {
				    obj_t head1325_1316;
				    head1325_1316 = MAKE_PAIR(BNIL, BNIL);
				    {
				       obj_t l1323_1317;
				       obj_t tail1326_1318;
				       l1323_1317 = l1323_1314;
				       tail1326_1318 = head1325_1316;
				     lname1324_1319:
				       if (NULLP(l1323_1317))
					 {
					    arg1814_1307 = CDR(head1325_1316);
					 }
				       else
					 {
					    obj_t new_tail1327_78_1321;
					    {
					       obj_t arg1828_1323;
					       {
						  obj_t b_1325;
						  b_1325 = CAR(l1323_1317);
						  {
						     obj_t arg1830_1326;
						     obj_t arg1831_1327;
						     arg1830_1326 = shape_tools_shape(CAR(b_1325));
						     {
							node_t aux_2086;
							{
							   obj_t aux_2087;
							   aux_2087 = CDR(b_1325);
							   aux_2086 = (node_t) (aux_2087);
							}
							arg1831_1327 = node__sexp_247_ast_dump(aux_2086);
						     }
						     {
							obj_t list1833_1329;
							{
							   obj_t arg1834_1330;
							   arg1834_1330 = MAKE_PAIR(BNIL, BNIL);
							   list1833_1329 = MAKE_PAIR(arg1831_1327, arg1834_1330);
							}
							arg1828_1323 = cons__138___r4_pairs_and_lists_6_3(arg1830_1326, list1833_1329);
						     }
						  }
					       }
					       new_tail1327_78_1321 = MAKE_PAIR(arg1828_1323, BNIL);
					    }
					    SET_CDR(tail1326_1318, new_tail1327_78_1321);
					    {
					       obj_t tail1326_2098;
					       obj_t l1323_2096;
					       l1323_2096 = CDR(l1323_1317);
					       tail1326_2098 = new_tail1327_78_1321;
					       tail1326_1318 = tail1326_2098;
					       l1323_1317 = l1323_2096;
					       goto lname1324_1319;
					    }
					 }
				    }
				 }
			    }
			    arg1819_1308 = node__sexp_247_ast_dump((((let_var_6_t) CREF(node_1305))->body));
			    {
			       obj_t list1821_1310;
			       {
				  obj_t arg1822_1311;
				  {
				     obj_t arg1823_1312;
				     arg1823_1312 = MAKE_PAIR(BNIL, BNIL);
				     arg1822_1311 = MAKE_PAIR(arg1819_1308, arg1823_1312);
				  }
				  list1821_1310 = MAKE_PAIR(arg1814_1307, arg1822_1311);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1813_1306, list1821_1310);
			    }
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 set_ex_it_116_t node_1337;
			 node_1337 = (set_ex_it_116_t) (node_11);
			 {
			    obj_t arg1841_1338;
			    obj_t arg1842_1339;
			    obj_t arg1843_1340;
			    arg1841_1338 = CNST_TABLE_REF(((long) 21));
			    {
			       node_t aux_2107;
			       {
				  var_t aux_2108;
				  aux_2108 = (((set_ex_it_116_t) CREF(node_1337))->var);
				  aux_2107 = (node_t) (aux_2108);
			       }
			       arg1842_1339 = node__sexp_247_ast_dump(aux_2107);
			    }
			    arg1843_1340 = node__sexp_247_ast_dump((((set_ex_it_116_t) CREF(node_1337))->body));
			    {
			       obj_t list1845_1342;
			       {
				  obj_t arg1846_1343;
				  {
				     obj_t arg1847_1344;
				     arg1847_1344 = MAKE_PAIR(BNIL, BNIL);
				     arg1846_1343 = MAKE_PAIR(arg1843_1340, arg1847_1344);
				  }
				  list1845_1342 = MAKE_PAIR(arg1842_1339, arg1846_1343);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1841_1338, list1845_1342);
			    }
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 jump_ex_it_184_t node_1348;
			 node_1348 = (jump_ex_it_184_t) (node_11);
			 {
			    obj_t arg1853_1349;
			    obj_t arg1855_1350;
			    obj_t arg1856_1351;
			    arg1853_1349 = CNST_TABLE_REF(((long) 22));
			    arg1855_1350 = node__sexp_247_ast_dump((((jump_ex_it_184_t) CREF(node_1348))->exit));
			    arg1856_1351 = node__sexp_247_ast_dump((((jump_ex_it_184_t) CREF(node_1348))->value));
			    {
			       obj_t list1858_1353;
			       {
				  obj_t arg1859_1354;
				  {
				     obj_t arg1860_1355;
				     arg1860_1355 = MAKE_PAIR(BNIL, BNIL);
				     arg1859_1354 = MAKE_PAIR(arg1856_1351, arg1860_1355);
				  }
				  list1858_1353 = MAKE_PAIR(arg1855_1350, arg1859_1354);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1853_1349, list1858_1353);
			    }
			 }
		      }
		      break;
		   case ((long) 18):
		      {
			 make_box_202_t node_1359;
			 node_1359 = (make_box_202_t) (node_11);
			 {
			    obj_t arg1864_1360;
			    obj_t arg1865_1361;
			    arg1864_1360 = CNST_TABLE_REF(((long) 23));
			    arg1865_1361 = node__sexp_247_ast_dump((((make_box_202_t) CREF(node_1359))->value));
			    {
			       obj_t list1867_1363;
			       {
				  obj_t arg1870_1364;
				  arg1870_1364 = MAKE_PAIR(BNIL, BNIL);
				  list1867_1363 = MAKE_PAIR(arg1865_1361, arg1870_1364);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1864_1360, list1867_1363);
			    }
			 }
		      }
		      break;
		   case ((long) 19):
		      {
			 box_ref_242_t node_1367;
			 node_1367 = (box_ref_242_t) (node_11);
			 {
			    obj_t arg1874_1368;
			    obj_t arg1875_1369;
			    arg1874_1368 = CNST_TABLE_REF(((long) 24));
			    {
			       node_t aux_2137;
			       {
				  var_t aux_2138;
				  aux_2138 = (((box_ref_242_t) CREF(node_1367))->var);
				  aux_2137 = (node_t) (aux_2138);
			       }
			       arg1875_1369 = node__sexp_247_ast_dump(aux_2137);
			    }
			    {
			       obj_t list1877_1371;
			       {
				  obj_t arg1879_1372;
				  arg1879_1372 = MAKE_PAIR(BNIL, BNIL);
				  list1877_1371 = MAKE_PAIR(arg1875_1369, arg1879_1372);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1874_1368, list1877_1371);
			    }
			 }
		      }
		      break;
		   case ((long) 20):
		      {
			 box_set__221_t node_1375;
			 node_1375 = (box_set__221_t) (node_11);
			 {
			    obj_t arg1882_1376;
			    obj_t arg1883_1377;
			    obj_t arg1884_1378;
			    arg1882_1376 = CNST_TABLE_REF(((long) 25));
			    {
			       node_t aux_2147;
			       {
				  var_t aux_2148;
				  aux_2148 = (((box_set__221_t) CREF(node_1375))->var);
				  aux_2147 = (node_t) (aux_2148);
			       }
			       arg1883_1377 = node__sexp_247_ast_dump(aux_2147);
			    }
			    arg1884_1378 = node__sexp_247_ast_dump((((box_set__221_t) CREF(node_1375))->value));
			    {
			       obj_t list1886_1380;
			       {
				  obj_t arg1887_1381;
				  {
				     obj_t arg1889_1382;
				     arg1889_1382 = MAKE_PAIR(BNIL, BNIL);
				     arg1887_1381 = MAKE_PAIR(arg1884_1378, arg1889_1382);
				  }
				  list1886_1380 = MAKE_PAIR(arg1883_1377, arg1887_1381);
			       }
			       return cons__138___r4_pairs_and_lists_6_3(arg1882_1376, list1886_1380);
			    }
			 }
		      }
		      break;
		   default:
		    case_else1514_18_1000:
		      if (PROCEDUREP(method1508_996))
			{
			   return PROCEDURE_ENTRY(method1508_996) (method1508_996, (obj_t) (node_11), BEOA);
			}
		      else
			{
			   obj_t fun1391_682;
			   fun1391_682 = PROCEDURE_REF(node__sexp_env_62_ast_dump, ((long) 0));
			   return PROCEDURE_ENTRY(fun1391_682) (fun1391_682, (obj_t) (node_11), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1514_18_1000;
	      }
	 }
      }
   }
}


obj_t 
_node__sexp_17_ast_dump(obj_t env_1639, obj_t node_1640)
{
   return node__sexp_247_ast_dump((node_t) (node_1640));
}


obj_t 
imported_modules_init_94_ast_dump()
{
   module_initialization_70_type_type(((long) 0), "AST_DUMP");
   module_initialization_70_ast_var(((long) 0), "AST_DUMP");
   module_initialization_70_ast_node(((long) 0), "AST_DUMP");
   module_initialization_70_tools_shape(((long) 0), "AST_DUMP");
   module_initialization_70_tools_args(((long) 0), "AST_DUMP");
   module_initialization_70_tools_misc(((long) 0), "AST_DUMP");
   return module_initialization_70_engine_param(((long) 0), "AST_DUMP");
}
