/*===========================================================================*/
/*   (Ast/exit.scm)                                                          */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern local_t make_local_sexit_184_ast_local(obj_t, type_t, sexit_t);
extern let_fun_218_t set_exit__node_102_ast_exit(obj_t, obj_t, obj_t, obj_t);
extern obj_t _jump_exit__node_209_ast_exit(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t normalize_progn_143_tools_progn(obj_t);
extern obj_t _set_exit__node_33_ast_exit(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_ast_exit();
extern obj_t module_initialization_70_ast_exit(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t sexit_ast_var;
static obj_t cnst_init_137_ast_exit();
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t require_initialization_114_ast_exit = BUNSPEC;
extern obj_t var_ast_node;
static obj_t library_modules_init_112_ast_exit();
extern obj_t read___reader(obj_t);
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern jump_ex_it_184_t jump_exit__node_34_ast_exit(obj_t, obj_t, obj_t, obj_t);
extern obj_t jump_ex_it_184_ast_node;
extern node_t error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
extern obj_t __exit__255_type_cache;
extern obj_t set_ex_it_116_ast_node;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _____74_type_cache;
static obj_t __cnst[4];

DEFINE_EXPORT_PROCEDURE(set_exit__node_env_153_ast_exit, _set_exit__node_33_ast_exit1469, _set_exit__node_33_ast_exit, 0L, 4);
DEFINE_STRING(string1462_ast_exit, string1462_ast_exit1470, "Illegal `jump-exit' form", 24);
DEFINE_EXPORT_PROCEDURE(jump_exit__node_env_70_ast_exit, _jump_exit__node_209_ast_exit1471, _jump_exit__node_209_ast_exit, 0L, 4);
DEFINE_STRING(string1461_ast_exit, string1461_ast_exit1472, "Illegal `set-exit' form", 23);
DEFINE_STRING(string1463_ast_exit, string1463_ast_exit1473, "SNIFUN VALUE LABELS HANDLING-FUNCTION ", 38);

obj_t 
module_initialization_70_ast_exit(long checksum_1158, char *from_1159)
{
   if (CBOOL(require_initialization_114_ast_exit))
     {
	require_initialization_114_ast_exit = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_exit();
	cnst_init_137_ast_exit();
	imported_modules_init_94_ast_exit();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_exit()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_EXIT");
   module_initialization_70___reader(((long) 0), "AST_EXIT");
   module_initialization_70___object(((long) 0), "AST_EXIT");
   module_initialization_70___r4_symbols_6_4(((long) 0), "AST_EXIT");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_exit()
{
   {
      obj_t cnst_port_138_1150;
      cnst_port_138_1150 = open_input_string(string1463_ast_exit);
      {
	 long i_1151;
	 i_1151 = ((long) 3);
       loop_1152:
	 {
	    bool_t test1464_1153;
	    test1464_1153 = (i_1151 == ((long) -1));
	    if (test1464_1153)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1465_1154;
		    {
		       obj_t list1466_1155;
		       {
			  obj_t arg1467_1156;
			  arg1467_1156 = BNIL;
			  list1466_1155 = MAKE_PAIR(cnst_port_138_1150, arg1467_1156);
		       }
		       arg1465_1154 = read___reader(list1466_1155);
		    }
		    CNST_TABLE_SET(i_1151, arg1465_1154);
		 }
		 {
		    int aux_1157;
		    {
		       long aux_1176;
		       aux_1176 = (i_1151 - ((long) 1));
		       aux_1157 = (int) (aux_1176);
		    }
		    {
		       long i_1179;
		       i_1179 = (long) (aux_1157);
		       i_1151 = i_1179;
		       goto loop_1152;
		    }
		 }
	      }
	 }
      }
   }
}


let_fun_218_t 
set_exit__node_102_ast_exit(obj_t exp_1, obj_t stack_2, obj_t loc_3, obj_t site_4)
{
   {
      obj_t loc_639;
      loc_639 = find_location_loc_243_tools_location(exp_1, loc_3);
      {
	 obj_t exit_640;
	 obj_t body_641;
	 if (PAIRP(exp_1))
	   {
	      obj_t cdr_128_145_646;
	      cdr_128_145_646 = CDR(exp_1);
	      if (PAIRP(cdr_128_145_646))
		{
		   obj_t car_131_9_648;
		   car_131_9_648 = CAR(cdr_128_145_646);
		   if (PAIRP(car_131_9_648))
		     {
			bool_t test_1190;
			{
			   obj_t aux_1191;
			   aux_1191 = CDR(car_131_9_648);
			   test_1190 = (aux_1191 == BNIL);
			}
			if (test_1190)
			  {
			     node_t aux_1194;
			     exit_640 = CAR(car_131_9_648);
			     body_641 = CDR(cdr_128_145_646);
			     {
				obj_t hdlg_name_179_655;
				hdlg_name_179_655 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 0)), BEOA);
				{
				   obj_t hdlg_sexp_42_656;
				   {
				      obj_t arg1296_670;
				      obj_t arg1297_671;
				      obj_t arg1298_672;
				      arg1296_670 = CNST_TABLE_REF(((long) 1));
				      {
					 obj_t arg1308_678;
					 {
					    obj_t list1315_684;
					    {
					       obj_t arg1316_685;
					       {
						  obj_t arg1318_686;
						  arg1318_686 = MAKE_PAIR(BNIL, BNIL);
						  arg1316_685 = MAKE_PAIR(BUNSPEC, arg1318_686);
					       }
					       list1315_684 = MAKE_PAIR(BNIL, arg1316_685);
					    }
					    arg1308_678 = cons__138___r4_pairs_and_lists_6_3(hdlg_name_179_655, list1315_684);
					 }
					 {
					    obj_t list1311_680;
					    list1311_680 = MAKE_PAIR(BNIL, BNIL);
					    arg1297_671 = cons__138___r4_pairs_and_lists_6_3(arg1308_678, list1311_680);
					 }
				      }
				      {
					 obj_t list1321_689;
					 list1321_689 = MAKE_PAIR(BNIL, BNIL);
					 arg1298_672 = cons__138___r4_pairs_and_lists_6_3(hdlg_name_179_655, list1321_689);
				      }
				      {
					 obj_t list1300_674;
					 {
					    obj_t arg1303_675;
					    {
					       obj_t arg1305_676;
					       arg1305_676 = MAKE_PAIR(BNIL, BNIL);
					       arg1303_675 = MAKE_PAIR(arg1298_672, arg1305_676);
					    }
					    list1300_674 = MAKE_PAIR(arg1297_671, arg1303_675);
					 }
					 hdlg_sexp_42_656 = cons__138___r4_pairs_and_lists_6_3(arg1296_670, list1300_674);
				      }
				   }
				   {
				      node_t hdlg_node_132_657;
				      hdlg_node_132_657 = sexp__node_235_ast_sexp(hdlg_sexp_42_656, stack_2, loc_639, site_4);
				      {
					 obj_t hdlg_fun_73_658;
					 {
					    obj_t aux_1212;
					    {
					       let_fun_218_t obj_1033;
					       obj_1033 = (let_fun_218_t) (hdlg_node_132_657);
					       aux_1212 = (((let_fun_218_t) CREF(obj_1033))->locals);
					    }
					    hdlg_fun_73_658 = CAR(aux_1212);
					 }
					 {
					    local_t exit_659;
					    {
					       sexit_t arg1325_1037;
					       {
						  sexit_t res1454_1046;
						  {
						     sexit_t new1105_1040;
						     new1105_1040 = ((sexit_t) BREF(GC_MALLOC(sizeof(struct sexit))));
						     {
							long arg1415_1041;
							arg1415_1041 = class_num_218___object(sexit_ast_var);
							{
							   obj_t obj_1044;
							   obj_1044 = (obj_t) (new1105_1040);
							   (((obj_t) CREF(obj_1044))->header = MAKE_HEADER(arg1415_1041, 0), BUNSPEC);
							}
						     }
						     {
							object_t aux_1220;
							aux_1220 = (object_t) (new1105_1040);
							OBJECT_WIDENING_SET(aux_1220, BFALSE);
						     }
						     ((((sexit_t) CREF(new1105_1040))->handler) = ((obj_t) hdlg_fun_73_658), BUNSPEC);
						     ((((sexit_t) CREF(new1105_1040))->detached__120) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						     res1454_1046 = new1105_1040;
						  }
						  arg1325_1037 = res1454_1046;
					       }
					       exit_659 = make_local_sexit_184_ast_local(exit_640, (type_t) (__exit__255_type_cache), arg1325_1037);
					    }
					    {
					       node_t body_660;
					       {
						  obj_t arg1287_666;
						  obj_t arg1290_667;
						  obj_t arg1293_668;
						  arg1287_666 = normalize_progn_143_tools_progn(body_641);
						  {
						     obj_t aux_1228;
						     aux_1228 = (obj_t) (exit_659);
						     arg1290_667 = MAKE_PAIR(aux_1228, stack_2);
						  }
						  arg1293_668 = CNST_TABLE_REF(((long) 2));
						  body_660 = sexp__node_235_ast_sexp(arg1287_666, arg1290_667, loc_639, arg1293_668);
					       }
					       {
						  set_ex_it_116_t exit_body_148_661;
						  {
						     var_t arg1286_665;
						     {
							var_t res1455_1059;
							{
							   type_t type_1050;
							   variable_t variable_1051;
							   type_1050 = (type_t) (__exit__255_type_cache);
							   variable_1051 = (variable_t) (exit_659);
							   {
							      var_t new1128_1052;
							      new1128_1052 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
							      {
								 long arg1403_1053;
								 arg1403_1053 = class_num_218___object(var_ast_node);
								 {
								    obj_t obj_1057;
								    obj_1057 = (obj_t) (new1128_1052);
								    (((obj_t) CREF(obj_1057))->header = MAKE_HEADER(arg1403_1053, 0), BUNSPEC);
								 }
							      }
							      {
								 object_t aux_1239;
								 aux_1239 = (object_t) (new1128_1052);
								 OBJECT_WIDENING_SET(aux_1239, BFALSE);
							      }
							      ((((var_t) CREF(new1128_1052))->loc) = ((obj_t) loc_639), BUNSPEC);
							      ((((var_t) CREF(new1128_1052))->type) = ((type_t) type_1050), BUNSPEC);
							      ((((var_t) CREF(new1128_1052))->variable) = ((variable_t) variable_1051), BUNSPEC);
							      res1455_1059 = new1128_1052;
							   }
							}
							arg1286_665 = res1455_1059;
						     }
						     {
							set_ex_it_116_t res1456_1072;
							{
							   type_t type_1061;
							   type_1061 = (type_t) (_____74_type_cache);
							   {
							      set_ex_it_116_t new1238_1064;
							      new1238_1064 = ((set_ex_it_116_t) BREF(GC_MALLOC(sizeof(struct set_ex_it_116))));
							      {
								 long arg1349_1065;
								 arg1349_1065 = class_num_218___object(set_ex_it_116_ast_node);
								 {
								    obj_t obj_1070;
								    obj_1070 = (obj_t) (new1238_1064);
								    (((obj_t) CREF(obj_1070))->header = MAKE_HEADER(arg1349_1065, 0), BUNSPEC);
								 }
							      }
							      {
								 object_t aux_1250;
								 aux_1250 = (object_t) (new1238_1064);
								 OBJECT_WIDENING_SET(aux_1250, BFALSE);
							      }
							      ((((set_ex_it_116_t) CREF(new1238_1064))->loc) = ((obj_t) loc_639), BUNSPEC);
							      ((((set_ex_it_116_t) CREF(new1238_1064))->type) = ((type_t) type_1061), BUNSPEC);
							      ((((set_ex_it_116_t) CREF(new1238_1064))->var) = ((var_t) arg1286_665), BUNSPEC);
							      ((((set_ex_it_116_t) CREF(new1238_1064))->body) = ((node_t) body_660), BUNSPEC);
							      res1456_1072 = new1238_1064;
							   }
							}
							exit_body_148_661 = res1456_1072;
						     }
						  }
						  {
						     {
							obj_t arg1283_663;
							arg1283_663 = CNST_TABLE_REF(((long) 3));
							{
							   obj_t res1457_1076;
							   {
							      sfun_t obj_1074;
							      {
								 value_t aux_1258;
								 {
								    local_t obj_1073;
								    obj_1073 = (local_t) (hdlg_fun_73_658);
								    aux_1258 = (((local_t) CREF(obj_1073))->value);
								 }
								 obj_1074 = (sfun_t) (aux_1258);
							      }
							      {
								 obj_t x_1148;
								 x_1148 = ((((sfun_t) CREF(obj_1074))->class) = ((obj_t) arg1283_663), BUNSPEC);
								 res1457_1076 = BUNSPEC;
							      }
							   }
							   res1457_1076;
							}
						     }
						     {
							obj_t res1458_1080;
							{
							   sfun_t obj_1078;
							   obj_t val1077_1079;
							   {
							      value_t aux_1263;
							      {
								 local_t obj_1077;
								 obj_1077 = (local_t) (hdlg_fun_73_658);
								 aux_1263 = (((local_t) CREF(obj_1077))->value);
							      }
							      obj_1078 = (sfun_t) (aux_1263);
							   }
							   val1077_1079 = (obj_t) (exit_body_148_661);
							   {
							      obj_t x_1149;
							      x_1149 = ((((sfun_t) CREF(obj_1078))->body) = ((obj_t) val1077_1079), BUNSPEC);
							      res1458_1080 = BUNSPEC;
							   }
							}
							res1458_1080;
						     }
						     aux_1194 = hdlg_node_132_657;
						  }
					       }
					    }
					 }
				      }
				   }
				}
			     }
			     return (let_fun_218_t) (aux_1194);
			  }
			else
			  {
			     node_t aux_1272;
			   tag_121_151_643:
			     aux_1272 = error_sexp__node_157_ast_sexp(string1461_ast_exit, exp_1, loc_639);
			     return (let_fun_218_t) (aux_1272);
			  }
		     }
		   else
		     {
			node_t aux_1275;
			goto tag_121_151_643;
			return (let_fun_218_t) (aux_1275);
		     }
		}
	      else
		{
		   node_t aux_1277;
		   goto tag_121_151_643;
		   return (let_fun_218_t) (aux_1277);
		}
	   }
	 else
	   {
	      node_t aux_1279;
	      goto tag_121_151_643;
	      return (let_fun_218_t) (aux_1279);
	   }
      }
   }
}


obj_t 
_set_exit__node_33_ast_exit(obj_t env_1138, obj_t exp_1139, obj_t stack_1140, obj_t loc_1141, obj_t site_1142)
{
   {
      let_fun_218_t aux_1281;
      aux_1281 = set_exit__node_102_ast_exit(exp_1139, stack_1140, loc_1141, site_1142);
      return (obj_t) (aux_1281);
   }
}


jump_ex_it_184_t 
jump_exit__node_34_ast_exit(obj_t exp_5, obj_t stack_6, obj_t loc_7, obj_t site_8)
{
   {
      obj_t loc_697;
      loc_697 = find_location_loc_243_tools_location(exp_5, loc_7);
      {
	 obj_t exit_698;
	 obj_t value_699;
	 if (PAIRP(exp_5))
	   {
	      obj_t cdr_146_167_704;
	      cdr_146_167_704 = CDR(exp_5);
	      if (PAIRP(cdr_146_167_704))
		{
		   exit_698 = CAR(cdr_146_167_704);
		   value_699 = CDR(cdr_146_167_704);
		   {
		      node_t value_708;
		      node_t exit_709;
		      {
			 obj_t arg1331_710;
			 obj_t arg1332_711;
			 arg1331_710 = normalize_progn_143_tools_progn(value_699);
			 arg1332_711 = CNST_TABLE_REF(((long) 2));
			 value_708 = sexp__node_235_ast_sexp(arg1331_710, stack_6, loc_697, arg1332_711);
		      }
		      exit_709 = sexp__node_235_ast_sexp(exit_698, stack_6, loc_697, CNST_TABLE_REF(((long) 2)));
		      {
			 jump_ex_it_184_t res1460_1108;
			 {
			    type_t type_1097;
			    type_1097 = (type_t) (_____74_type_cache);
			    {
			       jump_ex_it_184_t new1245_1100;
			       new1245_1100 = ((jump_ex_it_184_t) BREF(GC_MALLOC(sizeof(struct jump_ex_it_184))));
			       {
				  long arg1346_1101;
				  arg1346_1101 = class_num_218___object(jump_ex_it_184_ast_node);
				  {
				     obj_t obj_1106;
				     obj_1106 = (obj_t) (new1245_1100);
				     (((obj_t) CREF(obj_1106))->header = MAKE_HEADER(arg1346_1101, 0), BUNSPEC);
				  }
			       }
			       {
				  object_t aux_1300;
				  aux_1300 = (object_t) (new1245_1100);
				  OBJECT_WIDENING_SET(aux_1300, BFALSE);
			       }
			       ((((jump_ex_it_184_t) CREF(new1245_1100))->loc) = ((obj_t) loc_697), BUNSPEC);
			       ((((jump_ex_it_184_t) CREF(new1245_1100))->type) = ((type_t) type_1097), BUNSPEC);
			       ((((jump_ex_it_184_t) CREF(new1245_1100))->exit) = ((node_t) exit_709), BUNSPEC);
			       ((((jump_ex_it_184_t) CREF(new1245_1100))->value) = ((node_t) value_708), BUNSPEC);
			       res1460_1108 = new1245_1100;
			    }
			 }
			 return res1460_1108;
		      }
		   }
		}
	      else
		{
		   node_t aux_1309;
		 tag_139_224_701:
		   aux_1309 = error_sexp__node_157_ast_sexp(string1462_ast_exit, exp_5, loc_697);
		   return (jump_ex_it_184_t) (aux_1309);
		}
	   }
	 else
	   {
	      node_t aux_1312;
	      goto tag_139_224_701;
	      return (jump_ex_it_184_t) (aux_1312);
	   }
      }
   }
}


obj_t 
_jump_exit__node_209_ast_exit(obj_t env_1143, obj_t exp_1144, obj_t stack_1145, obj_t loc_1146, obj_t site_1147)
{
   {
      jump_ex_it_184_t aux_1314;
      aux_1314 = jump_exit__node_34_ast_exit(exp_1144, stack_1145, loc_1146, site_1147);
      return (obj_t) (aux_1314);
   }
}


obj_t 
imported_modules_init_94_ast_exit()
{
   module_initialization_70_type_type(((long) 0), "AST_EXIT");
   module_initialization_70_ast_var(((long) 0), "AST_EXIT");
   module_initialization_70_ast_node(((long) 0), "AST_EXIT");
   module_initialization_70_tools_trace(((long) 0), "AST_EXIT");
   module_initialization_70_ast_sexp(((long) 0), "AST_EXIT");
   module_initialization_70_ast_local(((long) 0), "AST_EXIT");
   module_initialization_70_type_cache(((long) 0), "AST_EXIT");
   module_initialization_70_tools_progn(((long) 0), "AST_EXIT");
   return module_initialization_70_tools_location(((long) 0), "AST_EXIT");
}
