/*===========================================================================*/
/*   (Ast/find-gdefs.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;


extern obj_t putprop__88___r4_symbols_6_4(obj_t, obj_t, obj_t);
extern obj_t dsssl_named_constant__188_tools_dsssl(obj_t);
extern obj_t find_global_defs_64_ast_find_gdefs_13(obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t scan_ast_find_gdefs_13(obj_t, obj_t, obj_t);
extern obj_t remprop__243___r4_symbols_6_4(obj_t, obj_t);
static obj_t imported_modules_init_94_ast_find_gdefs_13();
extern obj_t module_initialization_70_ast_find_gdefs_13(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_dsssl(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t toplevel_init_63_ast_find_gdefs_13();
static bool_t find_mutations__75_ast_find_gdefs_13(obj_t, obj_t);
static obj_t cnst_init_137_ast_find_gdefs_13();
extern obj_t __module__166_module_module;
static obj_t defs__list_164_ast_find_gdefs_13();
static obj_t require_initialization_114_ast_find_gdefs_13 = BUNSPEC;
static obj_t library_modules_init_112_ast_find_gdefs_13();
extern obj_t _find_global_defs_146_ast_find_gdefs_13(obj_t, obj_t);
static obj_t define_global1830_146_ast_find_gdefs_13(obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t __gdefs_list__201_ast_find_gdefs_13 = BUNSPEC;
extern obj_t id_of_id_112_ast_ident(obj_t);
static obj_t push_args_50_ast_find_gdefs_13(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern int arity_tools_args(obj_t);
extern obj_t _check_to_be_define_117_ast_find_gdefs_13(obj_t);
static obj_t __to_be_define__145_ast_find_gdefs_13 = BUNSPEC;
extern obj_t _to_be_define__252_ast_find_gdefs_13(obj_t, obj_t);
static obj_t arg13591828_ast_find_gdefs_13(obj_t, obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t __gdef_key__233_ast_find_gdefs_13 = BUNSPEC;
static obj_t loop_ast_find_gdefs_13(obj_t, obj_t, obj_t);
extern obj_t dsssl_default_formal_243_tools_dsssl(obj_t);
extern obj_t to_be_define__131_ast_find_gdefs_13(global_t);
static obj_t find_1_mutations__59_ast_find_gdefs_13(obj_t, obj_t);
extern obj_t getprop___r4_symbols_6_4(obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
static obj_t arg13571829_ast_find_gdefs_13(obj_t, obj_t, obj_t);
extern obj_t check_to_be_define_14_ast_find_gdefs_13();
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t arg13611827_ast_find_gdefs_13(obj_t, obj_t, obj_t);
extern obj_t dsssl_defaulted_formal__174_tools_dsssl(obj_t);
static obj_t bind_global_def__22_ast_find_gdefs_13(obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
static obj_t __all_defined_id__238_ast_find_gdefs_13 = BUNSPEC;
static obj_t __cnst[25];

DEFINE_STRING(string1843_ast_find_gdefs_13, string1843_ast_find_gdefs_131849, "IF CASE APPLY BIND-EXIT LAMBDA LABELS LETREC LET SET! ASSERT FREE-PRAGMA PRAGMA QUOTE WRITE @ NOTHING DONE DEFINE-METHOD DEFINE-GENERIC DEFINE-INLINE DEFINE BEGIN READ DEF FIND-GDEFS ", 183);
DEFINE_STATIC_PROCEDURE(proc1834_ast_find_gdefs_13, arg13591828_ast_find_gdefs_131850, arg13591828_ast_find_gdefs_13, 0L, 2);
DEFINE_STRING(string1841_ast_find_gdefs_13, string1841_ast_find_gdefs_131851, "Can't use both DSSSL named constant", 35);
DEFINE_STATIC_PROCEDURE(proc1832_ast_find_gdefs_13, arg13571829_ast_find_gdefs_131852, arg13571829_ast_find_gdefs_13, 0L, 2);
DEFINE_STRING(string1835_ast_find_gdefs_13, string1835_ast_find_gdefs_131853, "Illegal duplicated definition", 29);
DEFINE_STRING(string1839_ast_find_gdefs_13, string1839_ast_find_gdefs_131854, "symbol or named constant expected", 33);
DEFINE_EXPORT_PROCEDURE(to_be_define__env_91_ast_find_gdefs_13, _to_be_define__252_ast_find_gdefs_131855, _to_be_define__252_ast_find_gdefs_13, 0L, 1);
DEFINE_STRING(string1836_ast_find_gdefs_13, string1836_ast_find_gdefs_131856, "Illegal `define-inline' form", 28);
DEFINE_STRING(string1837_ast_find_gdefs_13, string1837_ast_find_gdefs_131857, "Illegal `define-generic' form", 29);
DEFINE_STRING(string1842_ast_find_gdefs_13, string1842_ast_find_gdefs_131858, "and `.' notation", 16);
DEFINE_STRING(string1831_ast_find_gdefs_13, string1831_ast_find_gdefs_131859, "Can't find global definition", 28);
DEFINE_STATIC_PROCEDURE(proc1833_ast_find_gdefs_13, arg13611827_ast_find_gdefs_131860, arg13611827_ast_find_gdefs_13, 0L, 2);
DEFINE_EXPORT_PROCEDURE(find_global_defs_env_41_ast_find_gdefs_13, _find_global_defs_146_ast_find_gdefs_131861, _find_global_defs_146_ast_find_gdefs_13, 0L, 1);
DEFINE_STRING(string1838_ast_find_gdefs_13, string1838_ast_find_gdefs_131862, "Illegal formal parameter", 24);
DEFINE_STRING(string1840_ast_find_gdefs_13, string1840_ast_find_gdefs_131863, "symbol expected", 15);
DEFINE_EXPORT_PROCEDURE(check_to_be_define_env_225_ast_find_gdefs_13, _check_to_be_define_117_ast_find_gdefs_131864, _check_to_be_define_117_ast_find_gdefs_13, 0L, 0);

obj_t 
module_initialization_70_ast_find_gdefs_13(long checksum_2076, char *from_2077)
{
   if (CBOOL(require_initialization_114_ast_find_gdefs_13))
     {
	require_initialization_114_ast_find_gdefs_13 = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_find_gdefs_13();
	cnst_init_137_ast_find_gdefs_13();
	imported_modules_init_94_ast_find_gdefs_13();
	toplevel_init_63_ast_find_gdefs_13();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_find_gdefs_13()
{
   module_initialization_70___r4_symbols_6_4(((long) 0), "AST_FIND-GDEFS");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_FIND-GDEFS");
   module_initialization_70___reader(((long) 0), "AST_FIND-GDEFS");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_find_gdefs_13()
{
   {
      obj_t cnst_port_138_2068;
      cnst_port_138_2068 = open_input_string(string1843_ast_find_gdefs_13);
      {
	 long i_2069;
	 i_2069 = ((long) 24);
       loop_2070:
	 {
	    bool_t test1844_2071;
	    test1844_2071 = (i_2069 == ((long) -1));
	    if (test1844_2071)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1845_2072;
		    {
		       obj_t list1846_2073;
		       {
			  obj_t arg1847_2074;
			  arg1847_2074 = BNIL;
			  list1846_2073 = MAKE_PAIR(cnst_port_138_2068, arg1847_2074);
		       }
		       arg1845_2072 = read___reader(list1846_2073);
		    }
		    CNST_TABLE_SET(i_2069, arg1845_2072);
		 }
		 {
		    int aux_2075;
		    {
		       long aux_2094;
		       aux_2094 = (i_2069 - ((long) 1));
		       aux_2075 = (int) (aux_2094);
		    }
		    {
		       long i_2097;
		       i_2097 = (long) (aux_2075);
		       i_2069 = i_2097;
		       goto loop_2070;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_find_gdefs_13()
{
   __to_be_define__145_ast_find_gdefs_13 = BNIL;
   __gdef_key__233_ast_find_gdefs_13 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 0)), BEOA);
   __gdefs_list__201_ast_find_gdefs_13 = BNIL;
   return (__all_defined_id__238_ast_find_gdefs_13 = BNIL,
      BUNSPEC);
}


obj_t 
to_be_define__131_ast_find_gdefs_13(global_t global_15)
{
   {
      obj_t obj2_1550;
      obj2_1550 = __to_be_define__145_ast_find_gdefs_13;
      {
	 obj_t aux_2102;
	 aux_2102 = (obj_t) (global_15);
	 return (__to_be_define__145_ast_find_gdefs_13 = MAKE_PAIR(aux_2102, obj2_1550),
	    BUNSPEC);
      }
   }
}


obj_t 
_to_be_define__252_ast_find_gdefs_13(obj_t env_2041, obj_t global_2042)
{
   return to_be_define__131_ast_find_gdefs_13((global_t) (global_2042));
}


obj_t 
check_to_be_define_14_ast_find_gdefs_13()
{
   {
      obj_t l1276_684;
      l1276_684 = __to_be_define__145_ast_find_gdefs_13;
    lname1283_685:
      if (PAIRP(l1276_684))
	{
	   {
	      obj_t global_687;
	      global_687 = CAR(l1276_684);
	      {
		 obj_t def_688;
		 {
		    obj_t aux_2110;
		    {
		       global_t obj_1553;
		       obj_1553 = (global_t) (global_687);
		       aux_2110 = (((global_t) CREF(obj_1553))->id);
		    }
		    def_688 = getprop___r4_symbols_6_4(aux_2110, __gdef_key__233_ast_find_gdefs_13);
		 }
		 {
		    bool_t test_2114;
		    if (STRUCTP(def_688))
		      {
			 obj_t aux_2119;
			 obj_t aux_2117;
			 aux_2119 = CNST_TABLE_REF(((long) 1));
			 aux_2117 = STRUCT_KEY(def_688);
			 test_2114 = (aux_2117 == aux_2119);
		      }
		    else
		      {
			 test_2114 = ((bool_t) 0);
		      }
		    if (test_2114)
		      {
			 BUNSPEC;
		      }
		    else
		      {
			 obj_t arg1327_690;
			 obj_t arg1329_692;
			 arg1327_690 = shape_tools_shape(global_687);
			 {
			    obj_t aux_2123;
			    {
			       global_t obj_1562;
			       obj_1562 = (global_t) (global_687);
			       aux_2123 = (((global_t) CREF(obj_1562))->src);
			    }
			    arg1329_692 = shape_tools_shape(aux_2123);
			 }
			 {
			    obj_t list1332_694;
			    list1332_694 = MAKE_PAIR(BNIL, BNIL);
			    user_error_151_tools_error(arg1327_690, string1831_ast_find_gdefs_13, arg1329_692, list1332_694);
			 }
		      }
		 }
	      }
	   }
	   {
	      obj_t l1276_2129;
	      l1276_2129 = CDR(l1276_684);
	      l1276_684 = l1276_2129;
	      goto lname1283_685;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      obj_t l1284_699;
      l1284_699 = __all_defined_id__238_ast_find_gdefs_13;
    lname1285_700:
      if (PAIRP(l1284_699))
	{
	   remprop__243___r4_symbols_6_4(CAR(l1284_699), __gdef_key__233_ast_find_gdefs_13);
	   {
	      obj_t l1284_2135;
	      l1284_2135 = CDR(l1284_699);
	      l1284_699 = l1284_2135;
	      goto lname1285_700;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   __all_defined_id__238_ast_find_gdefs_13 = BNIL;
   return (__to_be_define__145_ast_find_gdefs_13 = BNIL,
      BUNSPEC);
}


obj_t 
_check_to_be_define_117_ast_find_gdefs_13(obj_t env_2043)
{
   return check_to_be_define_14_ast_find_gdefs_13();
}


obj_t 
bind_global_def__22_ast_find_gdefs_13(obj_t id_17, obj_t arity_18)
{
   {
      obj_t def_704;
      {
	 obj_t arg1343_705;
	 arg1343_705 = CNST_TABLE_REF(((long) 2));
	 {
	    obj_t new_1570;
	    {
	       obj_t aux_2139;
	       aux_2139 = CNST_TABLE_REF(((long) 1));
	       new_1570 = create_struct(aux_2139, ((long) 3));
	    }
	    STRUCT_SET(new_1570, ((long) 2), arity_18);
	    STRUCT_SET(new_1570, ((long) 1), arg1343_705);
	    STRUCT_SET(new_1570, ((long) 0), id_17);
	    def_704 = new_1570;
	 }
      }
      {
	 obj_t obj2_1589;
	 obj2_1589 = __gdefs_list__201_ast_find_gdefs_13;
	 __gdefs_list__201_ast_find_gdefs_13 = MAKE_PAIR(def_704, obj2_1589);
      }
      {
	 obj_t obj2_1591;
	 obj2_1591 = __all_defined_id__238_ast_find_gdefs_13;
	 __all_defined_id__238_ast_find_gdefs_13 = MAKE_PAIR(id_17, obj2_1591);
      }
      return putprop__88___r4_symbols_6_4(id_17, __gdef_key__233_ast_find_gdefs_13, def_704);
   }
}


obj_t 
defs__list_164_ast_find_gdefs_13()
{
   {
      obj_t defs_706;
      obj_t res_707;
      defs_706 = __gdefs_list__201_ast_find_gdefs_13;
      res_707 = BNIL;
    loop_708:
      if (NULLP(defs_706))
	{
	   __gdefs_list__201_ast_find_gdefs_13 = BNIL;
	   return res_707;
	}
      else
	{
	   obj_t def_711;
	   def_711 = CAR(defs_706);
	   {
	      obj_t arg1347_712;
	      obj_t arg1349_713;
	      arg1347_712 = CDR(defs_706);
	      {
		 obj_t arg1350_714;
		 {
		    obj_t arg1352_715;
		    obj_t arg1353_716;
		    arg1352_715 = STRUCT_REF(def_711, ((long) 0));
		    {
		       obj_t aux_2155;
		       obj_t aux_2153;
		       aux_2155 = STRUCT_REF(def_711, ((long) 2));
		       aux_2153 = STRUCT_REF(def_711, ((long) 1));
		       arg1353_716 = MAKE_PAIR(aux_2153, aux_2155);
		    }
		    arg1350_714 = MAKE_PAIR(arg1352_715, arg1353_716);
		 }
		 arg1349_713 = MAKE_PAIR(arg1350_714, res_707);
	      }
	      {
		 obj_t res_2161;
		 obj_t defs_2160;
		 defs_2160 = arg1347_712;
		 res_2161 = arg1349_713;
		 res_707 = res_2161;
		 defs_706 = defs_2160;
		 goto loop_708;
	      }
	   }
	}
   }
}


obj_t 
find_global_defs_64_ast_find_gdefs_13(obj_t sexp__30_19)
{
   {
      obj_t define_global_125_2047;
      define_global_125_2047 = make_fx_procedure(define_global1830_146_ast_find_gdefs_13, ((long) 2), ((long) 1));
      PROCEDURE_SET(define_global_125_2047, ((long) 0), sexp__30_19);
      __gdefs_list__201_ast_find_gdefs_13 = BNIL;
      {
	 obj_t arg1357_2046;
	 arg1357_2046 = proc1832_ast_find_gdefs_13;
	 scan_ast_find_gdefs_13(sexp__30_19, define_global_125_2047, arg1357_2046);
      }
      {
	 obj_t arg1361_2044;
	 obj_t arg1359_2045;
	 arg1361_2044 = proc1833_ast_find_gdefs_13;
	 arg1359_2045 = proc1834_ast_find_gdefs_13;
	 scan_ast_find_gdefs_13(sexp__30_19, arg1359_2045, arg1361_2044);
      }
      return defs__list_164_ast_find_gdefs_13();
   }
}


obj_t 
loop_ast_find_gdefs_13(obj_t action_define_41_2064, obj_t action_body_250_2063, obj_t sexp__30_742)
{
 loop_ast_find_gdefs_13:
   if (PAIRP(sexp__30_742))
     {
	obj_t sexp_745;
	sexp_745 = CAR(sexp__30_742);
	{
	   obj_t var_756;
	   obj_t exp_757;
	   if (PAIRP(sexp_745))
	     {
		bool_t test_2172;
		{
		   obj_t aux_2175;
		   obj_t aux_2173;
		   aux_2175 = CNST_TABLE_REF(((long) 3));
		   aux_2173 = CAR(sexp_745);
		   test_2172 = (aux_2173 == aux_2175);
		}
		if (test_2172)
		  {
		     loop_ast_find_gdefs_13(action_define_41_2064, action_body_250_2063, CDR(sexp_745));
		     {
			obj_t sexp__30_2180;
			sexp__30_2180 = CDR(sexp__30_742);
			sexp__30_742 = sexp__30_2180;
			goto loop_ast_find_gdefs_13;
		     }
		  }
		else
		  {
		     obj_t cdr_146_167_764;
		     cdr_146_167_764 = CDR(sexp_745);
		     {
			bool_t test_2183;
			{
			   obj_t aux_2186;
			   obj_t aux_2184;
			   aux_2186 = CNST_TABLE_REF(((long) 4));
			   aux_2184 = CAR(sexp_745);
			   test_2183 = (aux_2184 == aux_2186);
			}
			if (test_2183)
			  {
			     if (PAIRP(cdr_146_167_764))
			       {
				  obj_t car_150_99_767;
				  car_150_99_767 = CAR(cdr_146_167_764);
				  if (PAIRP(car_150_99_767))
				    {
				       obj_t arg1376_769;
				       obj_t arg1379_770;
				       obj_t arg1380_771;
				       arg1376_769 = CAR(car_150_99_767);
				       arg1379_770 = CDR(car_150_99_767);
				       arg1380_771 = CDR(cdr_146_167_764);
				       {
					  int arg1426_1635;
					  arg1426_1635 = arity_tools_args(arg1379_770);
					  PROCEDURE_ENTRY(action_define_41_2064) (action_define_41_2064, arg1376_769, BINT(arg1426_1635), BEOA);
				       }
				       PROCEDURE_ENTRY(action_body_250_2063) (action_body_250_2063, arg1379_770, arg1380_771, BEOA);
				       {
					  obj_t sexp__30_2203;
					  sexp__30_2203 = CDR(sexp__30_742);
					  sexp__30_742 = sexp__30_2203;
					  goto loop_ast_find_gdefs_13;
				       }
				    }
				  else
				    {
				       var_756 = CAR(cdr_146_167_764);
				       exp_757 = CDR(cdr_146_167_764);
				       PROCEDURE_ENTRY(action_define_41_2064) (action_define_41_2064, var_756, BFALSE, BEOA);
				       PROCEDURE_ENTRY(action_body_250_2063) (action_body_250_2063, BNIL, exp_757, BEOA);
				       {
					  obj_t sexp__30_2209;
					  sexp__30_2209 = CDR(sexp__30_742);
					  sexp__30_742 = sexp__30_2209;
					  goto loop_ast_find_gdefs_13;
				       }
				    }
			       }
			     else
			       {
				tag_125_98_759:
				  {
				     obj_t arg1441_816;
				     {
					obj_t list1442_817;
					list1442_817 = MAKE_PAIR(sexp_745, BNIL);
					arg1441_816 = list1442_817;
				     }
				     PROCEDURE_ENTRY(action_body_250_2063) (action_body_250_2063, BNIL, arg1441_816, BEOA);
				  }
				  {
				     obj_t sexp__30_2216;
				     sexp__30_2216 = CDR(sexp__30_742);
				     sexp__30_742 = sexp__30_2216;
				     goto loop_ast_find_gdefs_13;
				  }
			       }
			  }
			else
			  {
			     bool_t test_2218;
			     {
				obj_t aux_2221;
				obj_t aux_2219;
				aux_2221 = CNST_TABLE_REF(((long) 5));
				aux_2219 = CAR(sexp_745);
				test_2218 = (aux_2219 == aux_2221);
			     }
			     if (test_2218)
			       {
				  if (PAIRP(cdr_146_167_764))
				    {
				       obj_t car_219_238_778;
				       car_219_238_778 = CAR(cdr_146_167_764);
				       if (PAIRP(car_219_238_778))
					 {
					    obj_t arg1388_780;
					    obj_t arg1390_781;
					    obj_t arg1391_782;
					    arg1388_780 = CAR(car_219_238_778);
					    arg1390_781 = CDR(car_219_238_778);
					    arg1391_782 = CDR(cdr_146_167_764);
					    {
					       int arg1426_1654;
					       arg1426_1654 = arity_tools_args(arg1390_781);
					       PROCEDURE_ENTRY(action_define_41_2064) (action_define_41_2064, arg1388_780, BINT(arg1426_1654), BEOA);
					    }
					    PROCEDURE_ENTRY(action_body_250_2063) (action_body_250_2063, arg1390_781, arg1391_782, BEOA);
					    {
					       obj_t sexp__30_2238;
					       sexp__30_2238 = CDR(sexp__30_742);
					       sexp__30_742 = sexp__30_2238;
					       goto loop_ast_find_gdefs_13;
					    }
					 }
				       else
					 {
					    goto tag_125_98_759;
					 }
				    }
				  else
				    {
				       goto tag_125_98_759;
				    }
			       }
			     else
			       {
				  bool_t test_2240;
				  {
				     obj_t aux_2243;
				     obj_t aux_2241;
				     aux_2243 = CNST_TABLE_REF(((long) 6));
				     aux_2241 = CAR(sexp_745);
				     test_2240 = (aux_2241 == aux_2243);
				  }
				  if (test_2240)
				    {
				       if (PAIRP(cdr_146_167_764))
					 {
					    obj_t car_262_98_786;
					    car_262_98_786 = CAR(cdr_146_167_764);
					    if (PAIRP(car_262_98_786))
					      {
						 obj_t arg1396_788;
						 obj_t arg1398_789;
						 obj_t arg1400_790;
						 arg1396_788 = CAR(car_262_98_786);
						 arg1398_789 = CDR(car_262_98_786);
						 arg1400_790 = CDR(cdr_146_167_764);
						 {
						    int arg1426_1670;
						    arg1426_1670 = arity_tools_args(arg1398_789);
						    PROCEDURE_ENTRY(action_define_41_2064) (action_define_41_2064, arg1396_788, BINT(arg1426_1670), BEOA);
						 }
						 PROCEDURE_ENTRY(action_body_250_2063) (action_body_250_2063, arg1398_789, arg1400_790, BEOA);
						 {
						    obj_t sexp__30_2260;
						    sexp__30_2260 = CDR(sexp__30_742);
						    sexp__30_742 = sexp__30_2260;
						    goto loop_ast_find_gdefs_13;
						 }
					      }
					    else
					      {
						 goto tag_125_98_759;
					      }
					 }
				       else
					 {
					    goto tag_125_98_759;
					 }
				    }
				  else
				    {
				       bool_t test_2262;
				       {
					  obj_t aux_2265;
					  obj_t aux_2263;
					  aux_2265 = CNST_TABLE_REF(((long) 7));
					  aux_2263 = CAR(sexp_745);
					  test_2262 = (aux_2263 == aux_2265);
				       }
				       if (test_2262)
					 {
					    if (PAIRP(cdr_146_167_764))
					      {
						 obj_t car_302_55_794;
						 car_302_55_794 = CAR(cdr_146_167_764);
						 if (PAIRP(car_302_55_794))
						   {
						      PROCEDURE_ENTRY(action_body_250_2063) (action_body_250_2063, CDR(car_302_55_794), CDR(cdr_146_167_764), BEOA);
						      {
							 obj_t sexp__30_2277;
							 sexp__30_2277 = CDR(sexp__30_742);
							 sexp__30_742 = sexp__30_2277;
							 goto loop_ast_find_gdefs_13;
						      }
						   }
						 else
						   {
						      goto tag_125_98_759;
						   }
					      }
					    else
					      {
						 goto tag_125_98_759;
					      }
					 }
				       else
					 {
					    goto tag_125_98_759;
					 }
				    }
			       }
			  }
		     }
		  }
	     }
	   else
	     {
		goto tag_125_98_759;
	     }
	}
     }
   else
     {
	return CNST_TABLE_REF(((long) 8));
     }
}


obj_t 
scan_ast_find_gdefs_13(obj_t sexp__30_738, obj_t action_define_41_739, obj_t action_body_250_740)
{
   return loop_ast_find_gdefs_13(action_define_41_739, action_body_250_740, sexp__30_738);
}


obj_t 
_find_global_defs_146_ast_find_gdefs_13(obj_t env_2048, obj_t sexp__30_2049)
{
   return find_global_defs_64_ast_find_gdefs_13(sexp__30_2049);
}


obj_t 
arg13611827_ast_find_gdefs_13(obj_t env_2050, obj_t args_2051, obj_t exp_2052)
{
   {
      obj_t args_731;
      obj_t exp_732;
      {
	 bool_t aux_2282;
	 args_731 = args_2051;
	 exp_732 = exp_2052;
	 {
	    obj_t arg1366_1610;
	    arg1366_1610 = push_args_50_ast_find_gdefs_13(args_731, BNIL);
	    aux_2282 = find_mutations__75_ast_find_gdefs_13(exp_732, arg1366_1610);
	 }
	 return BBOOL(aux_2282);
      }
   }
}


obj_t 
arg13591828_ast_find_gdefs_13(obj_t env_2053, obj_t x_2054, obj_t y_2055)
{
   {
      obj_t x_728;
      obj_t y_729;
      x_728 = x_2054;
      y_729 = y_2055;
      return CNST_TABLE_REF(((long) 9));
   }
}


obj_t 
arg13571829_ast_find_gdefs_13(obj_t env_2056, obj_t args_2057, obj_t exp_2058)
{
   {
      obj_t args_722;
      obj_t exp_723;
      args_722 = args_2057;
      exp_723 = exp_2058;
      return CNST_TABLE_REF(((long) 9));
   }
}


obj_t 
define_global1830_146_ast_find_gdefs_13(obj_t env_2059, obj_t var_2061, obj_t arity_2062)
{
   {
      obj_t sexp__30_2060;
      sexp__30_2060 = PROCEDURE_REF(env_2059, ((long) 0));
      {
	 obj_t var_820;
	 obj_t arity_821;
	 var_820 = var_2061;
	 arity_821 = arity_2062;
	 {
	    obj_t pre_id_183_823;
	    if (PAIRP(var_820))
	      {
		 obj_t cdr_109_69_828;
		 cdr_109_69_828 = CDR(var_820);
		 {
		    bool_t test_2292;
		    {
		       obj_t aux_2295;
		       obj_t aux_2293;
		       aux_2295 = CNST_TABLE_REF(((long) 10));
		       aux_2293 = CAR(var_820);
		       test_2292 = (aux_2293 == aux_2295);
		    }
		    if (test_2292)
		      {
			 if (PAIRP(cdr_109_69_828))
			   {
			      obj_t cdr_112_210_831;
			      cdr_112_210_831 = CDR(cdr_109_69_828);
			      if (PAIRP(cdr_112_210_831))
				{
				   bool_t test_2303;
				   {
				      obj_t aux_2304;
				      aux_2304 = CDR(cdr_112_210_831);
				      test_2303 = (aux_2304 == BNIL);
				   }
				   if (test_2303)
				     {
					pre_id_183_823 = CAR(cdr_109_69_828);
				      tag_101_79_824:
					{
					   obj_t id_839;
					   id_839 = id_of_id_112_ast_ident(pre_id_183_823);
					   {
					      obj_t old_def_101_840;
					      old_def_101_840 = getprop___r4_symbols_6_4(id_839, __gdef_key__233_ast_find_gdefs_13);
					      {
						 {
						    bool_t test_2309;
						    if (STRUCTP(old_def_101_840))
						      {
							 obj_t aux_2314;
							 obj_t aux_2312;
							 aux_2314 = CNST_TABLE_REF(((long) 1));
							 aux_2312 = STRUCT_KEY(old_def_101_840);
							 test_2309 = (aux_2312 == aux_2314);
						      }
						    else
						      {
							 test_2309 = ((bool_t) 0);
						      }
						    if (test_2309)
						      {
							 obj_t list1464_844;
							 list1464_844 = MAKE_PAIR(BNIL, BNIL);
							 return user_error_151_tools_error(var_820, string1835_ast_find_gdefs_13, sexp__30_2060, list1464_844);
						      }
						    else
						      {
							 return bind_global_def__22_ast_find_gdefs_13(id_839, arity_821);
						      }
						 }
					      }
					   }
					}
				     }
				   else
				     {
					obj_t pre_id_183_2321;
					pre_id_183_2321 = var_820;
					pre_id_183_823 = pre_id_183_2321;
					goto tag_101_79_824;
				     }
				}
			      else
				{
				   obj_t pre_id_183_2322;
				   pre_id_183_2322 = var_820;
				   pre_id_183_823 = pre_id_183_2322;
				   goto tag_101_79_824;
				}
			   }
			 else
			   {
			      obj_t pre_id_183_2323;
			      pre_id_183_2323 = var_820;
			      pre_id_183_823 = pre_id_183_2323;
			      goto tag_101_79_824;
			   }
		      }
		    else
		      {
			 obj_t pre_id_183_2324;
			 pre_id_183_2324 = var_820;
			 pre_id_183_823 = pre_id_183_2324;
			 goto tag_101_79_824;
		      }
		 }
	      }
	    else
	      {
		 obj_t pre_id_183_2325;
		 pre_id_183_2325 = var_820;
		 pre_id_183_823 = pre_id_183_2325;
		 goto tag_101_79_824;
	      }
	 }
      }
   }
}


bool_t 
find_mutations__75_ast_find_gdefs_13(obj_t exp__153_20, obj_t stack_21)
{
   {
      obj_t l1286_848;
      l1286_848 = exp__153_20;
    lname1287_849:
      if (PAIRP(l1286_848))
	{
	   find_1_mutations__59_ast_find_gdefs_13(CAR(l1286_848), stack_21);
	   {
	      obj_t l1286_2330;
	      l1286_2330 = CDR(l1286_848);
	      l1286_848 = l1286_2330;
	      goto lname1287_849;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
find_1_mutations__59_ast_find_gdefs_13(obj_t exp_22, obj_t stack_23)
{
 find_1_mutations__59_ast_find_gdefs_13:
   {
      obj_t val_888;
      obj_t clauses_889;
      obj_t bindings_876;
      obj_t exp_877;
      obj_t bindings_873;
      obj_t exp_874;
      obj_t bindings_870;
      obj_t exp_871;
      obj_t id_866;
      obj_t module_867;
      obj_t val_868;
      obj_t id_863;
      obj_t val_864;
      if (PAIRP(exp_22))
	{
	   obj_t cdr_407_115_908;
	   cdr_407_115_908 = CDR(exp_22);
	   {
	      bool_t test_2335;
	      {
		 obj_t aux_2338;
		 obj_t aux_2336;
		 aux_2338 = CNST_TABLE_REF(((long) 12));
		 aux_2336 = CAR(exp_22);
		 test_2335 = (aux_2336 == aux_2338);
	      }
	      if (test_2335)
		{
		   if (PAIRP(cdr_407_115_908))
		     {
			bool_t test_2343;
			{
			   obj_t aux_2344;
			   aux_2344 = CDR(cdr_407_115_908);
			   test_2343 = (aux_2344 == BNIL);
			}
			if (test_2343)
			  {
			     return CNST_TABLE_REF(((long) 8));
			  }
			else
			  {
			     bool_t aux_2348;
			     aux_2348 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
			     return BBOOL(aux_2348);
			  }
		     }
		   else
		     {
			bool_t aux_2351;
			aux_2351 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
			return BBOOL(aux_2351);
		     }
		}
	      else
		{
		   bool_t test_2354;
		   {
		      obj_t aux_2357;
		      obj_t aux_2355;
		      aux_2357 = CNST_TABLE_REF(((long) 13));
		      aux_2355 = CAR(exp_22);
		      test_2354 = (aux_2355 == aux_2357);
		   }
		   if (test_2354)
		     {
			if (PAIRP(cdr_407_115_908))
			  {
			     bool_t test_2362;
			     {
				obj_t aux_2363;
				aux_2363 = CDR(cdr_407_115_908);
				test_2362 = (aux_2363 == BNIL);
			     }
			     if (test_2362)
			       {
				  return CNST_TABLE_REF(((long) 8));
			       }
			     else
			       {
				  bool_t aux_2367;
				  aux_2367 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
				  return BBOOL(aux_2367);
			       }
			  }
			else
			  {
			     bool_t aux_2370;
			     aux_2370 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
			     return BBOOL(aux_2370);
			  }
		     }
		   else
		     {
			bool_t test_2373;
			{
			   obj_t aux_2376;
			   obj_t aux_2374;
			   aux_2376 = CNST_TABLE_REF(((long) 14));
			   aux_2374 = CAR(exp_22);
			   test_2373 = (aux_2374 == aux_2376);
			}
			if (test_2373)
			  {
			     if (PAIRP(cdr_407_115_908))
			       {
				  bool_t test_2381;
				  {
				     obj_t aux_2382;
				     aux_2382 = CDR(cdr_407_115_908);
				     test_2381 = (aux_2382 == BNIL);
				  }
				  if (test_2381)
				    {
				       return CNST_TABLE_REF(((long) 8));
				    }
				  else
				    {
				       bool_t aux_2386;
				       aux_2386 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
				       return BBOOL(aux_2386);
				    }
			       }
			     else
			       {
				  bool_t aux_2389;
				  aux_2389 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
				  return BBOOL(aux_2389);
			       }
			  }
			else
			  {
			     bool_t test_2392;
			     {
				obj_t aux_2395;
				obj_t aux_2393;
				aux_2395 = CNST_TABLE_REF(((long) 15));
				aux_2393 = CAR(exp_22);
				test_2392 = (aux_2393 == aux_2395);
			     }
			     if (test_2392)
			       {
				  if (PAIRP(cdr_407_115_908))
				    {
				       obj_t cdr_1502_154_929;
				       cdr_1502_154_929 = CDR(cdr_407_115_908);
				       if (PAIRP(cdr_1502_154_929))
					 {
					    bool_t aux_2403;
					    aux_2403 = find_mutations__75_ast_find_gdefs_13(CDR(cdr_1502_154_929), stack_23);
					    return BBOOL(aux_2403);
					 }
				       else
					 {
					    bool_t aux_2407;
					    aux_2407 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
					    return BBOOL(aux_2407);
					 }
				    }
				  else
				    {
				       bool_t aux_2410;
				       aux_2410 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
				       return BBOOL(aux_2410);
				    }
			       }
			     else
			       {
				  bool_t test_2413;
				  {
				     obj_t aux_2416;
				     obj_t aux_2414;
				     aux_2416 = CNST_TABLE_REF(((long) 3));
				     aux_2414 = CAR(exp_22);
				     test_2413 = (aux_2414 == aux_2416);
				  }
				  if (test_2413)
				    {
				       bool_t aux_2419;
				       aux_2419 = find_mutations__75_ast_find_gdefs_13(cdr_407_115_908, stack_23);
				       return BBOOL(aux_2419);
				    }
				  else
				    {
				       bool_t test_2422;
				       {
					  obj_t aux_2425;
					  obj_t aux_2423;
					  aux_2425 = CNST_TABLE_REF(((long) 16));
					  aux_2423 = CAR(exp_22);
					  test_2422 = (aux_2423 == aux_2425);
				       }
				       if (test_2422)
					 {
					    if (PAIRP(cdr_407_115_908))
					      {
						 obj_t car_1833_68_938;
						 car_1833_68_938 = CAR(cdr_407_115_908);
						 if (SYMBOLP(car_1833_68_938))
						   {
						      id_863 = car_1833_68_938;
						      val_864 = CDR(cdr_407_115_908);
						      find_mutations__75_ast_find_gdefs_13(val_864, stack_23);
						      {
							 bool_t test_2434;
							 {
							    obj_t aux_2435;
							    aux_2435 = memq___r4_pairs_and_lists_6_3(id_863, stack_23);
							    test_2434 = CBOOL(aux_2435);
							 }
							 if (test_2434)
							   {
							      return BUNSPEC;
							   }
							 else
							   {
							      obj_t def_1065;
							      def_1065 = getprop___r4_symbols_6_4(id_863, __gdef_key__233_ast_find_gdefs_13);
							      {
								 bool_t test_2439;
								 if (STRUCTP(def_1065))
								   {
								      obj_t aux_2444;
								      obj_t aux_2442;
								      aux_2444 = CNST_TABLE_REF(((long) 1));
								      aux_2442 = STRUCT_KEY(def_1065);
								      test_2439 = (aux_2442 == aux_2444);
								   }
								 else
								   {
								      test_2439 = ((bool_t) 0);
								   }
								 if (test_2439)
								   {
								      obj_t x_2066;
								      {
									 obj_t aux_2447;
									 aux_2447 = CNST_TABLE_REF(((long) 11));
									 x_2066 = STRUCT_SET(def_1065, ((long) 1), aux_2447);
								      }
								      return BUNSPEC;
								   }
								 else
								   {
								      return BUNSPEC;
								   }
							      }
							   }
						      }
						   }
						 else
						   {
						      obj_t car_1859_223_942;
						      car_1859_223_942 = CAR(cdr_407_115_908);
						      if (PAIRP(car_1859_223_942))
							{
							   obj_t cdr_1864_106_944;
							   cdr_1864_106_944 = CDR(car_1859_223_942);
							   {
							      bool_t test_2455;
							      {
								 obj_t aux_2458;
								 obj_t aux_2456;
								 aux_2458 = CNST_TABLE_REF(((long) 10));
								 aux_2456 = CAR(car_1859_223_942);
								 test_2455 = (aux_2456 == aux_2458);
							      }
							      if (test_2455)
								{
								   if (PAIRP(cdr_1864_106_944))
								     {
									obj_t car_1867_8_947;
									obj_t cdr_1868_3_948;
									car_1867_8_947 = CAR(cdr_1864_106_944);
									cdr_1868_3_948 = CDR(cdr_1864_106_944);
									if (SYMBOLP(car_1867_8_947))
									  {
									     if (PAIRP(cdr_1868_3_948))
									       {
										  obj_t car_1873_232_951;
										  car_1873_232_951 = CAR(cdr_1868_3_948);
										  if (SYMBOLP(car_1873_232_951))
										    {
										       bool_t test_2472;
										       {
											  obj_t aux_2473;
											  aux_2473 = CDR(cdr_1868_3_948);
											  test_2472 = (aux_2473 == BNIL);
										       }
										       if (test_2472)
											 {
											    id_866 = car_1867_8_947;
											    module_867 = car_1873_232_951;
											    val_868 = CDR(cdr_407_115_908);
											    find_mutations__75_ast_find_gdefs_13(val_868, stack_23);
											    {
											       bool_t test1624_1068;
											       {
												  obj_t obj2_1930;
												  obj2_1930 = __module__166_module_module;
												  test1624_1068 = (module_867 == obj2_1930);
											       }
											       if (test1624_1068)
												 {
												    obj_t def_1069;
												    def_1069 = getprop___r4_symbols_6_4(id_866, __gdef_key__233_ast_find_gdefs_13);
												    {
												       bool_t test_2480;
												       if (STRUCTP(def_1069))
													 {
													    obj_t aux_2485;
													    obj_t aux_2483;
													    aux_2485 = CNST_TABLE_REF(((long) 1));
													    aux_2483 = STRUCT_KEY(def_1069);
													    test_2480 = (aux_2483 == aux_2485);
													 }
												       else
													 {
													    test_2480 = ((bool_t) 0);
													 }
												       if (test_2480)
													 {
													    obj_t x_2067;
													    {
													       obj_t aux_2488;
													       aux_2488 = CNST_TABLE_REF(((long) 11));
													       x_2067 = STRUCT_SET(def_1069, ((long) 1), aux_2488);
													    }
													    return BUNSPEC;
													 }
												       else
													 {
													    return BUNSPEC;
													 }
												    }
												 }
											       else
												 {
												    return BUNSPEC;
												 }
											    }
											 }
										       else
											 {
											    bool_t aux_2492;
											    aux_2492 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
											    return BBOOL(aux_2492);
											 }
										    }
										  else
										    {
										       bool_t aux_2495;
										       aux_2495 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
										       return BBOOL(aux_2495);
										    }
									       }
									     else
									       {
										  bool_t aux_2498;
										  aux_2498 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
										  return BBOOL(aux_2498);
									       }
									  }
									else
									  {
									     bool_t aux_2501;
									     aux_2501 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
									     return BBOOL(aux_2501);
									  }
								     }
								   else
								     {
									bool_t aux_2504;
									aux_2504 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
									return BBOOL(aux_2504);
								     }
								}
							      else
								{
								   bool_t aux_2507;
								   aux_2507 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
								   return BBOOL(aux_2507);
								}
							   }
							}
						      else
							{
							   bool_t aux_2510;
							   aux_2510 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
							   return BBOOL(aux_2510);
							}
						   }
					      }
					    else
					      {
						 bool_t aux_2513;
						 aux_2513 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
						 return BBOOL(aux_2513);
					      }
					 }
				       else
					 {
					    bool_t test_2516;
					    {
					       obj_t aux_2519;
					       obj_t aux_2517;
					       aux_2519 = CNST_TABLE_REF(((long) 17));
					       aux_2517 = CAR(exp_22);
					       test_2516 = (aux_2517 == aux_2519);
					    }
					    if (test_2516)
					      {
						 if (PAIRP(cdr_407_115_908))
						   {
						      bool_t aux_2524;
						      bindings_870 = CAR(cdr_407_115_908);
						      exp_871 = CDR(cdr_407_115_908);
						      {
							 obj_t new_stack_37_1072;
							 {
							    obj_t stack_1079;
							    obj_t bindings_1080;
							    stack_1079 = stack_23;
							    bindings_1080 = bindings_870;
							  loop_1081:
							    if (NULLP(bindings_1080))
							      {
								 new_stack_37_1072 = stack_1079;
							      }
							    else
							      {
								 bool_t test_2527;
								 {
								    obj_t aux_2528;
								    aux_2528 = CAR(bindings_1080);
								    test_2527 = PAIRP(aux_2528);
								 }
								 if (test_2527)
								   {
								      {
									 obj_t arg1634_1084;
									 obj_t arg1637_1085;
									 {
									    obj_t arg1638_1086;
									    {
									       obj_t aux_2531;
									       {
										  obj_t aux_2532;
										  aux_2532 = CAR(bindings_1080);
										  aux_2531 = CAR(aux_2532);
									       }
									       arg1638_1086 = id_of_id_112_ast_ident(aux_2531);
									    }
									    arg1634_1084 = MAKE_PAIR(arg1638_1086, stack_1079);
									 }
									 arg1637_1085 = CDR(bindings_1080);
									 {
									    obj_t bindings_2539;
									    obj_t stack_2538;
									    stack_2538 = arg1634_1084;
									    bindings_2539 = arg1637_1085;
									    bindings_1080 = bindings_2539;
									    stack_1079 = stack_2538;
									    goto loop_1081;
									 }
								      }
								   }
								 else
								   {
								      {
									 obj_t arg1643_1089;
									 obj_t arg1644_1090;
									 {
									    obj_t arg1645_1091;
									    arg1645_1091 = id_of_id_112_ast_ident(CAR(bindings_1080));
									    arg1643_1089 = MAKE_PAIR(arg1645_1091, stack_1079);
									 }
									 arg1644_1090 = CDR(bindings_1080);
									 {
									    obj_t bindings_2545;
									    obj_t stack_2544;
									    stack_2544 = arg1643_1089;
									    bindings_2545 = arg1644_1090;
									    bindings_1080 = bindings_2545;
									    stack_1079 = stack_2544;
									    goto loop_1081;
									 }
								      }
								   }
							      }
							 }
							 find_mutations__75_ast_find_gdefs_13(exp_871, new_stack_37_1072);
							 {
							    obj_t l1288_1073;
							    l1288_1073 = bindings_870;
							  lname1290_1074:
							    if (PAIRP(l1288_1073))
							      {
								 {
								    obj_t aux_2549;
								    {
								       obj_t aux_2550;
								       aux_2550 = CAR(l1288_1073);
								       aux_2549 = CDR(aux_2550);
								    }
								    find_mutations__75_ast_find_gdefs_13(aux_2549, stack_23);
								 }
								 {
								    obj_t l1288_2554;
								    l1288_2554 = CDR(l1288_1073);
								    l1288_1073 = l1288_2554;
								    goto lname1290_1074;
								 }
							      }
							    else
							      {
								 aux_2524 = ((bool_t) 1);
							      }
							 }
						      }
						      return BBOOL(aux_2524);
						   }
						 else
						   {
						      bool_t aux_2559;
						      aux_2559 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
						      return BBOOL(aux_2559);
						   }
					      }
					    else
					      {
						 bool_t test_2562;
						 {
						    obj_t aux_2565;
						    obj_t aux_2563;
						    aux_2565 = CNST_TABLE_REF(((long) 18));
						    aux_2563 = CAR(exp_22);
						    test_2562 = (aux_2563 == aux_2565);
						 }
						 if (test_2562)
						   {
						      if (PAIRP(cdr_407_115_908))
							{
							   bool_t aux_2570;
							   bindings_873 = CAR(cdr_407_115_908);
							   exp_874 = CDR(cdr_407_115_908);
							   {
							      obj_t new_stack_37_1094;
							      {
								 obj_t stack_1101;
								 obj_t bindings_1102;
								 stack_1101 = stack_23;
								 bindings_1102 = bindings_873;
							       loop_1103:
								 if (NULLP(bindings_1102))
								   {
								      new_stack_37_1094 = stack_1101;
								   }
								 else
								   {
								      bool_t test_2573;
								      {
									 obj_t aux_2574;
									 aux_2574 = CAR(bindings_1102);
									 test_2573 = PAIRP(aux_2574);
								      }
								      if (test_2573)
									{
									   {
									      obj_t arg1654_1106;
									      obj_t arg1655_1107;
									      {
										 obj_t arg1656_1108;
										 {
										    obj_t aux_2577;
										    {
										       obj_t aux_2578;
										       aux_2578 = CAR(bindings_1102);
										       aux_2577 = CAR(aux_2578);
										    }
										    arg1656_1108 = id_of_id_112_ast_ident(aux_2577);
										 }
										 arg1654_1106 = MAKE_PAIR(arg1656_1108, stack_1101);
									      }
									      arg1655_1107 = CDR(bindings_1102);
									      {
										 obj_t bindings_2585;
										 obj_t stack_2584;
										 stack_2584 = arg1654_1106;
										 bindings_2585 = arg1655_1107;
										 bindings_1102 = bindings_2585;
										 stack_1101 = stack_2584;
										 goto loop_1103;
									      }
									   }
									}
								      else
									{
									   {
									      obj_t arg1661_1111;
									      obj_t arg1663_1112;
									      {
										 obj_t arg1664_1113;
										 arg1664_1113 = id_of_id_112_ast_ident(CAR(bindings_1102));
										 arg1661_1111 = MAKE_PAIR(arg1664_1113, stack_1101);
									      }
									      arg1663_1112 = CDR(bindings_1102);
									      {
										 obj_t bindings_2591;
										 obj_t stack_2590;
										 stack_2590 = arg1661_1111;
										 bindings_2591 = arg1663_1112;
										 bindings_1102 = bindings_2591;
										 stack_1101 = stack_2590;
										 goto loop_1103;
									      }
									   }
									}
								   }
							      }
							      find_mutations__75_ast_find_gdefs_13(exp_874, new_stack_37_1094);
							      {
								 obj_t l1291_1095;
								 l1291_1095 = bindings_873;
							       lname1292_1096:
								 if (PAIRP(l1291_1095))
								   {
								      {
									 obj_t aux_2595;
									 {
									    obj_t aux_2596;
									    aux_2596 = CAR(l1291_1095);
									    aux_2595 = CDR(aux_2596);
									 }
									 find_mutations__75_ast_find_gdefs_13(aux_2595, new_stack_37_1094);
								      }
								      {
									 obj_t l1291_2600;
									 l1291_2600 = CDR(l1291_1095);
									 l1291_1095 = l1291_2600;
									 goto lname1292_1096;
								      }
								   }
								 else
								   {
								      aux_2570 = ((bool_t) 1);
								   }
							      }
							   }
							   return BBOOL(aux_2570);
							}
						      else
							{
							   bool_t aux_2605;
							   aux_2605 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
							   return BBOOL(aux_2605);
							}
						   }
						 else
						   {
						      bool_t test_2608;
						      {
							 obj_t aux_2611;
							 obj_t aux_2609;
							 aux_2611 = CNST_TABLE_REF(((long) 19));
							 aux_2609 = CAR(exp_22);
							 test_2608 = (aux_2609 == aux_2611);
						      }
						      if (test_2608)
							{
							   if (PAIRP(cdr_407_115_908))
							     {
								bool_t aux_2616;
								bindings_876 = CAR(cdr_407_115_908);
								exp_877 = CDR(cdr_407_115_908);
								{
								   obj_t new_stack_37_1116;
								   {
								      obj_t arg1677_1125;
								      if (NULLP(bindings_876))
									{
									   arg1677_1125 = BNIL;
									}
								      else
									{
									   obj_t head1295_1128;
									   {
									      obj_t aux_2619;
									      {
										 obj_t aux_2620;
										 aux_2620 = CAR(bindings_876);
										 aux_2619 = CAR(aux_2620);
									      }
									      head1295_1128 = MAKE_PAIR(aux_2619, BNIL);
									   }
									   {
									      obj_t l1293_1129;
									      obj_t tail1296_1130;
									      l1293_1129 = CDR(bindings_876);
									      tail1296_1130 = head1295_1128;
									    lname1294_1131:
									      if (NULLP(l1293_1129))
										{
										   arg1677_1125 = head1295_1128;
										}
									      else
										{
										   obj_t new_tail1297_27_1134;
										   {
										      obj_t aux_2626;
										      {
											 obj_t aux_2627;
											 aux_2627 = CAR(l1293_1129);
											 aux_2626 = CAR(aux_2627);
										      }
										      new_tail1297_27_1134 = MAKE_PAIR(aux_2626, BNIL);
										   }
										   SET_CDR(tail1296_1130, new_tail1297_27_1134);
										   {
										      obj_t tail1296_2634;
										      obj_t l1293_2632;
										      l1293_2632 = CDR(l1293_1129);
										      tail1296_2634 = new_tail1297_27_1134;
										      tail1296_1130 = tail1296_2634;
										      l1293_1129 = l1293_2632;
										      goto lname1294_1131;
										   }
										}
									   }
									}
								      new_stack_37_1116 = push_args_50_ast_find_gdefs_13(arg1677_1125, stack_23);
								   }
								   find_mutations__75_ast_find_gdefs_13(exp_877, new_stack_37_1116);
								   {
								      obj_t l1298_1117;
								      l1298_1117 = bindings_876;
								    lname1301_1118:
								      if (PAIRP(l1298_1117))
									{
									   {
									      obj_t b_1120;
									      b_1120 = CAR(l1298_1117);
									      {
										 obj_t arg1669_1121;
										 obj_t arg1671_1122;
										 {
										    obj_t aux_2641;
										    aux_2641 = CDR(b_1120);
										    arg1669_1121 = CDR(aux_2641);
										 }
										 {
										    obj_t aux_2644;
										    {
										       obj_t aux_2645;
										       aux_2645 = CDR(b_1120);
										       aux_2644 = CAR(aux_2645);
										    }
										    arg1671_1122 = push_args_50_ast_find_gdefs_13(aux_2644, new_stack_37_1116);
										 }
										 find_mutations__75_ast_find_gdefs_13(arg1669_1121, arg1671_1122);
									      }
									   }
									   {
									      obj_t l1298_2650;
									      l1298_2650 = CDR(l1298_1117);
									      l1298_1117 = l1298_2650;
									      goto lname1301_1118;
									   }
									}
								      else
									{
									   aux_2616 = ((bool_t) 1);
									}
								   }
								}
								return BBOOL(aux_2616);
							     }
							   else
							     {
								bool_t aux_2655;
								aux_2655 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
								return BBOOL(aux_2655);
							     }
							}
						      else
							{
							   bool_t test_2658;
							   {
							      obj_t aux_2661;
							      obj_t aux_2659;
							      aux_2661 = CNST_TABLE_REF(((long) 20));
							      aux_2659 = CAR(exp_22);
							      test_2658 = (aux_2659 == aux_2661);
							   }
							   if (test_2658)
							     {
								if (PAIRP(cdr_407_115_908))
								  {
								     obj_t arg1529_978;
								     arg1529_978 = CDR(cdr_407_115_908);
								     {
									obj_t arg1690_1819;
									arg1690_1819 = push_args_50_ast_find_gdefs_13(CAR(cdr_407_115_908), stack_23);
									{
									   bool_t aux_2669;
									   aux_2669 = find_mutations__75_ast_find_gdefs_13(arg1529_978, arg1690_1819);
									   return BBOOL(aux_2669);
									}
								     }
								  }
								else
								  {
								     bool_t aux_2672;
								     aux_2672 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
								     return BBOOL(aux_2672);
								  }
							     }
							   else
							     {
								bool_t test_2675;
								{
								   obj_t aux_2678;
								   obj_t aux_2676;
								   aux_2678 = CNST_TABLE_REF(((long) 21));
								   aux_2676 = CAR(exp_22);
								   test_2675 = (aux_2676 == aux_2678);
								}
								if (test_2675)
								  {
								     if (PAIRP(cdr_407_115_908))
								       {
									  obj_t arg1534_983;
									  arg1534_983 = CDR(cdr_407_115_908);
									  {
									     obj_t arg1691_1829;
									     {
										obj_t arg1693_1830;
										arg1693_1830 = id_of_id_112_ast_ident(CAR(cdr_407_115_908));
										arg1691_1829 = MAKE_PAIR(arg1693_1830, stack_23);
									     }
									     {
										bool_t aux_2687;
										aux_2687 = find_mutations__75_ast_find_gdefs_13(arg1534_983, arg1691_1829);
										return BBOOL(aux_2687);
									     }
									  }
								       }
								     else
								       {
									  bool_t aux_2690;
									  aux_2690 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
									  return BBOOL(aux_2690);
								       }
								  }
								else
								  {
								     bool_t test_2693;
								     {
									obj_t aux_2696;
									obj_t aux_2694;
									aux_2696 = CNST_TABLE_REF(((long) 22));
									aux_2694 = CAR(exp_22);
									test_2693 = (aux_2694 == aux_2696);
								     }
								     if (test_2693)
								       {
									  if (PAIRP(cdr_407_115_908))
									    {
									       obj_t cdr_3184_231_987;
									       cdr_3184_231_987 = CDR(cdr_407_115_908);
									       if (PAIRP(cdr_3184_231_987))
										 {
										    bool_t test_2704;
										    {
										       obj_t aux_2705;
										       aux_2705 = CDR(cdr_3184_231_987);
										       test_2704 = (aux_2705 == BNIL);
										    }
										    if (test_2704)
										      {
											 obj_t arg1540_991;
											 arg1540_991 = CAR(cdr_3184_231_987);
											 find_1_mutations__59_ast_find_gdefs_13(CAR(cdr_407_115_908), stack_23);
											 {
											    obj_t exp_2711;
											    exp_2711 = arg1540_991;
											    exp_22 = exp_2711;
											    goto find_1_mutations__59_ast_find_gdefs_13;
											 }
										      }
										    else
										      {
											 bool_t aux_2712;
											 aux_2712 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
											 return BBOOL(aux_2712);
										      }
										 }
									       else
										 {
										    bool_t aux_2715;
										    aux_2715 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
										    return BBOOL(aux_2715);
										 }
									    }
									  else
									    {
									       bool_t aux_2718;
									       aux_2718 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
									       return BBOOL(aux_2718);
									    }
								       }
								     else
								       {
									  bool_t test_2721;
									  {
									     obj_t aux_2724;
									     obj_t aux_2722;
									     aux_2724 = CNST_TABLE_REF(((long) 23));
									     aux_2722 = CAR(exp_22);
									     test_2721 = (aux_2722 == aux_2724);
									  }
									  if (test_2721)
									    {
									       if (PAIRP(cdr_407_115_908))
										 {
										    obj_t cdr_3308_137_997;
										    cdr_3308_137_997 = CDR(cdr_407_115_908);
										    if (PAIRP(cdr_3308_137_997))
										      {
											 bool_t test_2732;
											 {
											    obj_t aux_2733;
											    aux_2733 = CDR(cdr_3308_137_997);
											    test_2732 = (aux_2733 == BNIL);
											 }
											 if (test_2732)
											   {
											      bool_t aux_2736;
											      val_888 = CAR(cdr_407_115_908);
											      clauses_889 = CAR(cdr_3308_137_997);
											      find_mutations__75_ast_find_gdefs_13(val_888, stack_23);
											      {
												 obj_t l1302_1145;
												 l1302_1145 = clauses_889;
											       lname1304_1146:
												 if (PAIRP(l1302_1145))
												   {
												      {
													 obj_t aux_2740;
													 {
													    obj_t aux_2741;
													    aux_2741 = CAR(l1302_1145);
													    aux_2740 = CDR(aux_2741);
													 }
													 find_mutations__75_ast_find_gdefs_13(aux_2740, stack_23);
												      }
												      {
													 obj_t l1302_2745;
													 l1302_2745 = CDR(l1302_1145);
													 l1302_1145 = l1302_2745;
													 goto lname1304_1146;
												      }
												   }
												 else
												   {
												      aux_2736 = ((bool_t) 1);
												   }
											      }
											      return BBOOL(aux_2736);
											   }
											 else
											   {
											      bool_t aux_2750;
											      aux_2750 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
											      return BBOOL(aux_2750);
											   }
										      }
										    else
										      {
											 bool_t aux_2753;
											 aux_2753 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
											 return BBOOL(aux_2753);
										      }
										 }
									       else
										 {
										    bool_t aux_2756;
										    aux_2756 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
										    return BBOOL(aux_2756);
										 }
									    }
									  else
									    {
									       bool_t test_2759;
									       {
										  obj_t aux_2762;
										  obj_t aux_2760;
										  aux_2762 = CNST_TABLE_REF(((long) 24));
										  aux_2760 = CAR(exp_22);
										  test_2759 = (aux_2760 == aux_2762);
									       }
									       if (test_2759)
										 {
										    bool_t aux_2765;
										    aux_2765 = find_mutations__75_ast_find_gdefs_13(cdr_407_115_908, stack_23);
										    return BBOOL(aux_2765);
										 }
									       else
										 {
										    bool_t test_2768;
										    {
										       obj_t aux_2771;
										       obj_t aux_2769;
										       aux_2771 = CNST_TABLE_REF(((long) 4));
										       aux_2769 = CAR(exp_22);
										       test_2768 = (aux_2769 == aux_2771);
										    }
										    if (test_2768)
										      {
											 if (PAIRP(cdr_407_115_908))
											   {
											      obj_t arg1559_1010;
											      arg1559_1010 = CDR(cdr_407_115_908);
											      {
												 obj_t arg1697_1873;
												 {
												    obj_t aux_2777;
												    aux_2777 = CAR(cdr_407_115_908);
												    arg1697_1873 = MAKE_PAIR(aux_2777, stack_23);
												 }
												 {
												    bool_t aux_2780;
												    aux_2780 = find_mutations__75_ast_find_gdefs_13(arg1559_1010, arg1697_1873);
												    return BBOOL(aux_2780);
												 }
											      }
											   }
											 else
											   {
											      bool_t aux_2783;
											      aux_2783 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
											      return BBOOL(aux_2783);
											   }
										      }
										    else
										      {
											 bool_t test_2786;
											 {
											    obj_t aux_2789;
											    obj_t aux_2787;
											    aux_2789 = CNST_TABLE_REF(((long) 5));
											    aux_2787 = CAR(exp_22);
											    test_2786 = (aux_2787 == aux_2789);
											 }
											 if (test_2786)
											   {
											      if (PAIRP(cdr_407_115_908))
												{
												   obj_t arg1562_1014;
												   arg1562_1014 = CAR(cdr_407_115_908);
												   {
												      obj_t list1700_1887;
												      list1700_1887 = MAKE_PAIR(BNIL, BNIL);
												      return user_error_151_tools_error(arg1562_1014, string1836_ast_find_gdefs_13, exp_22, list1700_1887);
												   }
												}
											      else
												{
												   bool_t aux_2797;
												   aux_2797 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
												   return BBOOL(aux_2797);
												}
											   }
											 else
											   {
											      bool_t test_2800;
											      {
												 obj_t aux_2803;
												 obj_t aux_2801;
												 aux_2803 = CNST_TABLE_REF(((long) 6));
												 aux_2801 = CAR(exp_22);
												 test_2800 = (aux_2801 == aux_2803);
											      }
											      if (test_2800)
												{
												   if (PAIRP(cdr_407_115_908))
												     {
													obj_t arg1566_1019;
													arg1566_1019 = CAR(cdr_407_115_908);
													{
													   obj_t list1704_1900;
													   list1704_1900 = MAKE_PAIR(BNIL, BNIL);
													   return user_error_151_tools_error(arg1566_1019, string1837_ast_find_gdefs_13, exp_22, list1704_1900);
													}
												     }
												   else
												     {
													bool_t aux_2811;
													aux_2811 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
													return BBOOL(aux_2811);
												     }
												}
											      else
												{
												   bool_t test_2814;
												   {
												      obj_t aux_2817;
												      obj_t aux_2815;
												      aux_2817 = CNST_TABLE_REF(((long) 7));
												      aux_2815 = CAR(exp_22);
												      test_2814 = (aux_2815 == aux_2817);
												   }
												   if (test_2814)
												     {
													if (PAIRP(cdr_407_115_908))
													  {
													     obj_t car_3483_242_1024;
													     car_3483_242_1024 = CAR(cdr_407_115_908);
													     if (PAIRP(car_3483_242_1024))
													       {
														  obj_t arg1572_1027;
														  arg1572_1027 = CDR(cdr_407_115_908);
														  {
														     obj_t arg1706_1913;
														     arg1706_1913 = push_args_50_ast_find_gdefs_13(CDR(car_3483_242_1024), stack_23);
														     {
															bool_t aux_2828;
															aux_2828 = find_mutations__75_ast_find_gdefs_13(arg1572_1027, arg1706_1913);
															return BBOOL(aux_2828);
														     }
														  }
													       }
													     else
													       {
														  bool_t aux_2831;
														  aux_2831 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
														  return BBOOL(aux_2831);
													       }
													  }
													else
													  {
													     bool_t aux_2834;
													     aux_2834 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
													     return BBOOL(aux_2834);
													  }
												     }
												   else
												     {
													bool_t aux_2837;
													aux_2837 = find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
													return BBOOL(aux_2837);
												     }
												}
											   }
										      }
										 }
									    }
								       }
								  }
							     }
							}
						   }
					      }
					 }
				    }
			       }
			  }
		     }
		}
	   }
	}
      else
	{
	   return CNST_TABLE_REF(((long) 8));
	}
   }
}


obj_t 
push_args_50_ast_find_gdefs_13(obj_t expr_24, obj_t list_25)
{
   {
      obj_t expr_1161;
      obj_t list_1162;
      bool_t dsssl_1163;
      expr_1161 = expr_24;
      list_1162 = list_25;
      dsssl_1163 = ((bool_t) 0);
    loop_1164:
      if (NULLP(expr_1161))
	{
	   return list_1162;
	}
      else
	{
	   if (PAIRP(expr_1161))
	     {
		bool_t test_2845;
		{
		   obj_t aux_2846;
		   aux_2846 = CAR(expr_1161);
		   test_2845 = SYMBOLP(aux_2846);
		}
		if (test_2845)
		  {
		     {
			obj_t arg1710_1168;
			obj_t arg1711_1169;
			arg1710_1168 = CDR(expr_1161);
			{
			   obj_t arg1712_1170;
			   arg1712_1170 = id_of_id_112_ast_ident(CAR(expr_1161));
			   arg1711_1169 = MAKE_PAIR(arg1712_1170, list_1162);
			}
			{
			   obj_t list_2854;
			   obj_t expr_2853;
			   expr_2853 = arg1710_1168;
			   list_2854 = arg1711_1169;
			   list_1162 = list_2854;
			   expr_1161 = expr_2853;
			   goto loop_1164;
			}
		     }
		  }
		else
		  {
		     {
			bool_t test1715_1172;
			{
			   obj_t aux_2855;
			   aux_2855 = dsssl_named_constant__188_tools_dsssl(CAR(expr_1161));
			   test1715_1172 = CBOOL(aux_2855);
			}
			if (test1715_1172)
			  {
			     {
				bool_t dsssl_2862;
				obj_t expr_2860;
				expr_2860 = CDR(expr_1161);
				dsssl_2862 = ((bool_t) 1);
				dsssl_1163 = dsssl_2862;
				expr_1161 = expr_2860;
				goto loop_1164;
			     }
			  }
			else
			  {
			     if (dsssl_1163)
			       {
				  bool_t test1717_1174;
				  {
				     obj_t aux_2864;
				     aux_2864 = dsssl_defaulted_formal__174_tools_dsssl(CAR(expr_1161));
				     test1717_1174 = CBOOL(aux_2864);
				  }
				  if (test1717_1174)
				    {
				       {
					  obj_t arg1718_1175;
					  obj_t arg1719_1176;
					  arg1718_1175 = CDR(expr_1161);
					  {
					     obj_t arg1720_1177;
					     {
						obj_t arg1721_1178;
						arg1721_1178 = dsssl_default_formal_243_tools_dsssl(CAR(expr_1161));
						arg1720_1177 = id_of_id_112_ast_ident(arg1721_1178);
					     }
					     arg1719_1176 = MAKE_PAIR(arg1720_1177, list_1162);
					  }
					  {
					     bool_t dsssl_2876;
					     obj_t list_2875;
					     obj_t expr_2874;
					     expr_2874 = arg1718_1175;
					     list_2875 = arg1719_1176;
					     dsssl_2876 = ((bool_t) 1);
					     dsssl_1163 = dsssl_2876;
					     list_1162 = list_2875;
					     expr_1161 = expr_2874;
					     goto loop_1164;
					  }
				       }
				    }
				  else
				    {
				       return user_error_151_tools_error(expr_1161, string1838_ast_find_gdefs_13, string1839_ast_find_gdefs_13, BNIL);
				    }
			       }
			     else
			       {
				  return user_error_151_tools_error(expr_1161, string1838_ast_find_gdefs_13, string1840_ast_find_gdefs_13, BNIL);
			       }
			  }
		     }
		  }
	     }
	   else
	     {
		if (dsssl_1163)
		  {
		     return user_error_151_tools_error(expr_1161, string1841_ast_find_gdefs_13, string1842_ast_find_gdefs_13, BNIL);
		  }
		else
		  {
		     if (SYMBOLP(expr_1161))
		       {
			  {
			     obj_t arg1734_1187;
			     arg1734_1187 = id_of_id_112_ast_ident(expr_1161);
			     return MAKE_PAIR(arg1734_1187, list_1162);
			  }
		       }
		     else
		       {
			  return user_error_151_tools_error(expr_1161, string1838_ast_find_gdefs_13, string1840_ast_find_gdefs_13, BNIL);
		       }
		  }
	     }
	}
   }
}


obj_t 
imported_modules_init_94_ast_find_gdefs_13()
{
   module_initialization_70_type_type(((long) 0), "AST_FIND-GDEFS");
   module_initialization_70_ast_var(((long) 0), "AST_FIND-GDEFS");
   module_initialization_70_ast_node(((long) 0), "AST_FIND-GDEFS");
   module_initialization_70_ast_ident(((long) 0), "AST_FIND-GDEFS");
   module_initialization_70_tools_shape(((long) 0), "AST_FIND-GDEFS");
   module_initialization_70_tools_error(((long) 0), "AST_FIND-GDEFS");
   module_initialization_70_tools_dsssl(((long) 0), "AST_FIND-GDEFS");
   module_initialization_70_tools_args(((long) 0), "AST_FIND-GDEFS");
   module_initialization_70_engine_param(((long) 0), "AST_FIND-GDEFS");
   return module_initialization_70_module_module(((long) 0), "AST_FIND-GDEFS");
}
