/*===========================================================================*/
/*   (Ast/glo-decl.scm)                                                      */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


extern obj_t dsssl_named_constant__188_tools_dsssl(obj_t);
extern global_t declare_global_sfun__255_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _declare_global_cfun__89_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern type_t use_foreign_type__12_type_env(obj_t);
extern global_t declare_global_cvar__13_ast_glo_decl_237(obj_t, obj_t, obj_t, bool_t, obj_t);
extern obj_t scnst_ast_var;
extern obj_t args___args_list_50_tools_args(obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t imported_modules_init_94_ast_glo_decl_237();
extern obj_t module_initialization_70_ast_glo_decl_237(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_dsssl(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t cnst_init_137_ast_glo_decl_237();
extern obj_t cfun_ast_var;
extern obj_t dsssl_formals_encoding_15_tools_dsssl(obj_t);
extern obj_t _declare_global_svar__33_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_ast_glo_decl_237 = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_ast_glo_decl_237();
extern obj_t sfun_ast_var;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t);
extern obj_t open_input_string(obj_t);
extern int arity_tools_args(obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t _declare_global_sfun__169_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _declare_global_scnst__34_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t svar_ast_var;
extern obj_t cvar_ast_var;
extern obj_t _declare_global_cvar__232_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern global_t bind_global__138_ast_env(obj_t, obj_t, value_t, obj_t, obj_t);
extern global_t declare_global_scnst__70_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _____74_type_cache;
extern global_t declare_global_svar__200_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t);
extern global_t declare_global_cfun__81_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, bool_t, bool_t, obj_t);
extern obj_t __obj__252_type_cache;
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern type_t type_of_id_183_ast_ident(obj_t);
static obj_t __cnst[9];

DEFINE_STRING(string1350_ast_glo_decl_237, string1350_ast_glo_decl_2371357, "Illegal type for global variable", 32);
DEFINE_STRING(string1351_ast_glo_decl_237, string1351_ast_glo_decl_2371358, "FOREIGN A-CNST WRITE READ (EXPORT IMPORT) BIGLOO SGFUN STATIC AST ", 66);
DEFINE_STRING(string1348_ast_glo_decl_237, string1348_ast_glo_decl_2371359, "Illegal nary argument type", 26);
DEFINE_STRING(string1346_ast_glo_decl_237, string1346_ast_glo_decl_2371360, " ", 1);
DEFINE_STRING(string1347_ast_glo_decl_237, string1347_ast_glo_decl_2371361, "declare-global-sfun!: ", 22);
DEFINE_STRING(string1349_ast_glo_decl_237, string1349_ast_glo_decl_2371362, "   declare-global-sfun!: (instantiate ", 38);
DEFINE_EXPORT_PROCEDURE(declare_global_cvar__env_34_ast_glo_decl_237, _declare_global_cvar__232_ast_glo_decl_2371363, _declare_global_cvar__232_ast_glo_decl_237, 0L, 5);
DEFINE_EXPORT_PROCEDURE(declare_global_scnst__env_79_ast_glo_decl_237, _declare_global_scnst__34_ast_glo_decl_2371364, _declare_global_scnst__34_ast_glo_decl_237, 0L, 5);
DEFINE_EXPORT_PROCEDURE(declare_global_svar__env_68_ast_glo_decl_237, _declare_global_svar__33_ast_glo_decl_2371365, _declare_global_svar__33_ast_glo_decl_237, 0L, 4);
DEFINE_EXPORT_PROCEDURE(declare_global_cfun__env_226_ast_glo_decl_237, _declare_global_cfun__89_ast_glo_decl_2371366, _declare_global_cfun__89_ast_glo_decl_237, 0L, 7);
DEFINE_EXPORT_PROCEDURE(declare_global_sfun__env_194_ast_glo_decl_237, _declare_global_sfun__169_ast_glo_decl_2371367, _declare_global_sfun__169_ast_glo_decl_237, 0L, 6);

obj_t 
module_initialization_70_ast_glo_decl_237(long checksum_822, char *from_823)
{
   if (CBOOL(require_initialization_114_ast_glo_decl_237))
     {
	require_initialization_114_ast_glo_decl_237 = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_glo_decl_237();
	cnst_init_137_ast_glo_decl_237();
	imported_modules_init_94_ast_glo_decl_237();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_glo_decl_237()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_GLO-DECL");
   module_initialization_70___reader(((long) 0), "AST_GLO-DECL");
   module_initialization_70___object(((long) 0), "AST_GLO-DECL");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_glo_decl_237()
{
   {
      obj_t cnst_port_138_814;
      cnst_port_138_814 = open_input_string(string1351_ast_glo_decl_237);
      {
	 long i_815;
	 i_815 = ((long) 8);
       loop_816:
	 {
	    bool_t test1352_817;
	    test1352_817 = (i_815 == ((long) -1));
	    if (test1352_817)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1353_818;
		    {
		       obj_t list1354_819;
		       {
			  obj_t arg1355_820;
			  arg1355_820 = BNIL;
			  list1354_819 = MAKE_PAIR(cnst_port_138_814, arg1355_820);
		       }
		       arg1353_818 = read___reader(list1354_819);
		    }
		    CNST_TABLE_SET(i_815, arg1353_818);
		 }
		 {
		    int aux_821;
		    {
		       long aux_839;
		       aux_839 = (i_815 - ((long) 1));
		       aux_821 = (int) (aux_839);
		    }
		    {
		       long i_842;
		       i_842 = (long) (aux_821);
		       i_815 = i_842;
		       goto loop_816;
		    }
		 }
	      }
	 }
      }
   }
}


global_t 
declare_global_sfun__255_ast_glo_decl_237(obj_t id_1, obj_t args_2, obj_t module_3, obj_t import_4, obj_t class_5, obj_t src_exp_176_6)
{
   {
      bool_t test1117_306;
      {
	 obj_t aux_844;
	 aux_844 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
	 test1117_306 = CBOOL(aux_844);
      }
      if (test1117_306)
	{
	   obj_t arg1145_308;
	   obj_t arg1149_310;
	   arg1145_308 = shape_tools_shape(id_1);
	   arg1149_310 = shape_tools_shape(args_2);
	   {
	      obj_t list1150_311;
	      {
		 obj_t arg1153_312;
		 {
		    obj_t arg1154_313;
		    {
		       obj_t arg1161_314;
		       {
			  obj_t arg1164_315;
			  {
			     obj_t aux_852;
			     aux_852 = BCHAR(((unsigned char) '\n'));
			     arg1164_315 = MAKE_PAIR(aux_852, BNIL);
			  }
			  arg1161_314 = MAKE_PAIR(arg1149_310, arg1164_315);
		       }
		       arg1154_313 = MAKE_PAIR(string1346_ast_glo_decl_237, arg1161_314);
		    }
		    arg1153_312 = MAKE_PAIR(arg1145_308, arg1154_313);
		 }
		 list1150_311 = MAKE_PAIR(string1347_ast_glo_decl_237, arg1153_312);
	      }
	      print_trace_107_tools_trace(list1150_311);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      int arity_319;
      arity_319 = arity_tools_args(args_2);
      {
	 obj_t args_320;
	 args_320 = args___args_list_50_tools_args(args_2);
	 {
	    bool_t export__13_321;
	    {
	       bool_t test_862;
	       {
		  obj_t aux_863;
		  aux_863 = CNST_TABLE_REF(((long) 1));
		  test_862 = (import_4 == aux_863);
	       }
	       if (test_862)
		 {
		    export__13_321 = ((bool_t) 0);
		 }
	       else
		 {
		    export__13_321 = ((bool_t) 1);
		 }
	    }
	    {
	       obj_t keywords_322;
	       keywords_322 = BNIL;
	       {
		  obj_t args_type_205_323;
		  {
		     obj_t args_348;
		     obj_t res_349;
		     bool_t sgfun__91_350;
		     args_348 = args_320;
		     res_349 = BNIL;
		     {
			obj_t aux_907;
			aux_907 = CNST_TABLE_REF(((long) 2));
			sgfun__91_350 = (class_5 == aux_907);
		     }
		   loop_351:
		     if (NULLP(args_348))
		       {
			  {
			     bool_t test_868;
			     {
				long aux_869;
				aux_869 = (long) (arity_319);
				test_868 = (aux_869 >= ((long) 0));
			     }
			     if (test_868)
			       {
				  args_type_205_323 = reverse__39___r4_pairs_and_lists_6_3(res_349);
			       }
			     else
			       {
				  obj_t type_357;
				  type_357 = CAR(res_349);
				  {
				     bool_t test1232_358;
				     {
					obj_t obj2_567;
					obj2_567 = __obj__252_type_cache;
					test1232_358 = (type_357 == obj2_567);
				     }
				     if (test1232_358)
				       {
					  args_type_205_323 = reverse__39___r4_pairs_and_lists_6_3(res_349);
				       }
				     else
				       {
					  bool_t test1233_359;
					  {
					     obj_t obj2_569;
					     obj2_569 = _____74_type_cache;
					     test1233_359 = (type_357 == obj2_569);
					  }
					  if (test1233_359)
					    {
					       {
						  obj_t arg1234_360;
						  {
						     obj_t obj1_571;
						     obj1_571 = __obj__252_type_cache;
						     {
							obj_t aux_879;
							aux_879 = CDR(res_349);
							arg1234_360 = MAKE_PAIR(obj1_571, aux_879);
						     }
						  }
						  args_type_205_323 = reverse__39___r4_pairs_and_lists_6_3(arg1234_360);
					       }
					    }
					  else
					    {
					       {
						  obj_t arg1237_363;
						  arg1237_363 = shape_tools_shape(type_357);
						  args_type_205_323 = user_error_151_tools_error(id_1, string1348_ast_glo_decl_237, arg1237_363, BNIL);
					       }
					    }
				       }
				  }
			       }
			  }
		       }
		     else
		       {
			  bool_t test1239_365;
			  {
			     obj_t aux_885;
			     aux_885 = dsssl_named_constant__188_tools_dsssl(CAR(args_348));
			     test1239_365 = CBOOL(aux_885);
			  }
			  if (test1239_365)
			    {
			       keywords_322 = dsssl_formals_encoding_15_tools_dsssl(args_348);
			       {
				  obj_t arg1240_366;
				  {
				     obj_t obj1_574;
				     obj1_574 = __obj__252_type_cache;
				     arg1240_366 = MAKE_PAIR(obj1_574, res_349);
				  }
				  args_type_205_323 = reverse__39___r4_pairs_and_lists_6_3(arg1240_366);
			       }
			    }
			  else
			    {
			       {
				  obj_t type_367;
				  {
				     type_t t_370;
				     t_370 = type_of_id_183_ast_ident(CAR(args_348));
				     {
					bool_t test1243_371;
					{
					   bool_t test1244_372;
					   {
					      obj_t obj2_578;
					      obj2_578 = _____74_type_cache;
					      {
						 obj_t aux_895;
						 aux_895 = (obj_t) (t_370);
						 test1244_372 = (aux_895 == obj2_578);
					      }
					   }
					   if (test1244_372)
					     {
						if (export__13_321)
						  {
						     test1243_371 = export__13_321;
						  }
						else
						  {
						     test1243_371 = sgfun__91_350;
						  }
					     }
					   else
					     {
						test1243_371 = ((bool_t) 0);
					     }
					}
					if (test1243_371)
					  {
					     type_367 = __obj__252_type_cache;
					  }
					else
					  {
					     type_367 = (obj_t) (t_370);
					  }
				     }
				  }
				  {
				     obj_t arg1241_368;
				     obj_t arg1242_369;
				     arg1241_368 = CDR(args_348);
				     arg1242_369 = MAKE_PAIR(type_367, res_349);
				     {
					bool_t sgfun__91_906;
					obj_t res_905;
					obj_t args_904;
					args_904 = arg1241_368;
					res_905 = arg1242_369;
					sgfun__91_906 = ((bool_t) 0);
					sgfun__91_350 = sgfun__91_906;
					res_349 = res_905;
					args_348 = args_904;
					goto loop_351;
				     }
				  }
			       }
			    }
		       }
		  }
		  {
		     obj_t id_type_89_324;
		     id_type_89_324 = parse_id_241_ast_ident(id_1);
		     {
			obj_t type_res_48_325;
			type_res_48_325 = CDR(id_type_89_324);
			{
			   obj_t id_326;
			   id_326 = CAR(id_type_89_324);
			   {
			      sfun_t sfun_327;
			      {
				 sfun_t res1328_610;
				 {
				    long arity_584;
				    obj_t predicate_of_78_586;
				    obj_t stack_allocator_172_587;
				    obj_t dsssl_keywords_243_594;
				    arity_584 = (long) (arity_319);
				    predicate_of_78_586 = BFALSE;
				    stack_allocator_172_587 = BFALSE;
				    dsssl_keywords_243_594 = keywords_322;
				    {
				       sfun_t new1068_595;
				       new1068_595 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
				       {
					  long arg1312_596;
					  arg1312_596 = class_num_218___object(sfun_ast_var);
					  {
					     obj_t obj_608;
					     obj_608 = (obj_t) (new1068_595);
					     (((obj_t) CREF(obj_608))->header = MAKE_HEADER(arg1312_596, 0), BUNSPEC);
					  }
				       }
				       {
					  object_t aux_918;
					  aux_918 = (object_t) (new1068_595);
					  OBJECT_WIDENING_SET(aux_918, predicate_of_78_586);
				       }
				       ((((sfun_t) CREF(new1068_595))->arity) = ((long) arity_584), BUNSPEC);
				       ((((sfun_t) CREF(new1068_595))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
				       ((((sfun_t) CREF(new1068_595))->predicate_of_78) = ((obj_t) predicate_of_78_586), BUNSPEC);
				       ((((sfun_t) CREF(new1068_595))->stack_allocator_172) = ((obj_t) stack_allocator_172_587), BUNSPEC);
				       ((((sfun_t) CREF(new1068_595))->top__138) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				       ((((sfun_t) CREF(new1068_595))->the_closure_238) = ((obj_t) BUNSPEC), BUNSPEC);
				       ((((sfun_t) CREF(new1068_595))->property) = ((obj_t) BNIL), BUNSPEC);
				       ((((sfun_t) CREF(new1068_595))->args) = ((obj_t) args_type_205_323), BUNSPEC);
				       ((((sfun_t) CREF(new1068_595))->body) = ((obj_t) BUNSPEC), BUNSPEC);
				       ((((sfun_t) CREF(new1068_595))->class) = ((obj_t) class_5), BUNSPEC);
				       ((((sfun_t) CREF(new1068_595))->dsssl_keywords_243) = ((obj_t) dsssl_keywords_243_594), BUNSPEC);
				       res1328_610 = new1068_595;
				    }
				 }
				 sfun_327 = res1328_610;
			      }
			      {
				 global_t global_328;
				 global_328 = bind_global__138_ast_env(id_326, module_3, (value_t) (sfun_327), import_4, src_exp_176_6);
				 {
				    {
				       bool_t test1183_329;
				       {
					  obj_t aux_934;
					  aux_934 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
					  test1183_329 = CBOOL(aux_934);
				       }
				       if (test1183_329)
					 {
					    obj_t arg1197_331;
					    obj_t arg1200_333;
					    obj_t arg1204_335;
					    arg1197_331 = shape_tools_shape(BINT(arity_319));
					    arg1200_333 = shape_tools_shape(args_type_205_323);
					    arg1204_335 = shape_tools_shape(class_5);
					    {
					       obj_t list1205_336;
					       {
						  obj_t arg1207_337;
						  {
						     obj_t arg1208_338;
						     {
							obj_t arg1209_339;
							{
							   obj_t arg1210_340;
							   {
							      obj_t arg1212_341;
							      {
								 obj_t arg1213_342;
								 {
								    obj_t aux_944;
								    aux_944 = BCHAR(((unsigned char) '\n'));
								    arg1213_342 = MAKE_PAIR(aux_944, BNIL);
								 }
								 arg1212_341 = MAKE_PAIR(arg1204_335, arg1213_342);
							      }
							      arg1210_340 = MAKE_PAIR(string1346_ast_glo_decl_237, arg1212_341);
							   }
							   arg1209_339 = MAKE_PAIR(arg1200_333, arg1210_340);
							}
							arg1208_338 = MAKE_PAIR(string1346_ast_glo_decl_237, arg1209_339);
						     }
						     arg1207_337 = MAKE_PAIR(arg1197_331, arg1208_338);
						  }
						  list1205_336 = MAKE_PAIR(string1349_ast_glo_decl_237, arg1207_337);
					       }
					       print_trace_107_tools_trace(list1205_336);
					    }
					 }
				       else
					 {
					    BUNSPEC;
					 }
				    }
				    {
				       bool_t test1219_346;
				       {
					  obj_t obj2_612;
					  obj2_612 = _____74_type_cache;
					  test1219_346 = (type_res_48_325 == obj2_612);
				       }
				       if (test1219_346)
					 {
					    if (export__13_321)
					      {
						 {
						    obj_t res1329_615;
						    {
						       type_t val1037_614;
						       val1037_614 = (type_t) (__obj__252_type_cache);
						       {
							  obj_t x_801;
							  x_801 = ((((global_t) CREF(global_328))->type) = ((type_t) val1037_614), BUNSPEC);
							  res1329_615 = BUNSPEC;
						       }
						    }
						    res1329_615;
						 }
					      }
					    else
					      {
						 {
						    obj_t res1330_618;
						    {
						       type_t val1037_617;
						       val1037_617 = (type_t) (type_res_48_325);
						       {
							  obj_t x_802;
							  x_802 = ((((global_t) CREF(global_328))->type) = ((type_t) val1037_617), BUNSPEC);
							  res1330_618 = BUNSPEC;
						       }
						    }
						    res1330_618;
						 }
					      }
					 }
				       else
					 {
					    {
					       obj_t res1331_621;
					       {
						  type_t val1037_620;
						  val1037_620 = (type_t) (type_res_48_325);
						  {
						     obj_t x_803;
						     x_803 = ((((global_t) CREF(global_328))->type) = ((type_t) val1037_620), BUNSPEC);
						     res1331_621 = BUNSPEC;
						  }
					       }
					       res1331_621;
					    }
					 }
				    }
				    return global_328;
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_declare_global_sfun__169_ast_glo_decl_237(obj_t env_769, obj_t id_770, obj_t args_771, obj_t module_772, obj_t import_773, obj_t class_774, obj_t src_exp_176_775)
{
   {
      global_t aux_963;
      aux_963 = declare_global_sfun__255_ast_glo_decl_237(id_770, args_771, module_772, import_773, class_774, src_exp_176_775);
      return (obj_t) (aux_963);
   }
}


global_t 
declare_global_svar__200_ast_glo_decl_237(obj_t id_7, obj_t module_8, obj_t import_9, obj_t src_exp_176_10)
{
   {
      obj_t id_type_89_378;
      id_type_89_378 = parse_id_241_ast_ident(id_7);
      {
	 obj_t type_379;
	 {
	    obj_t type_386;
	    type_386 = CDR(id_type_89_378);
	    {
	       bool_t test_968;
	       {
		  obj_t aux_972;
		  obj_t aux_969;
		  aux_972 = CNST_TABLE_REF(((long) 3));
		  {
		     type_t obj_623;
		     obj_623 = (type_t) (type_386);
		     aux_969 = (((type_t) CREF(obj_623))->class);
		  }
		  test_968 = (aux_969 == aux_972);
	       }
	       if (test_968)
		 {
		    bool_t test1257_388;
		    {
		       bool_t test1258_389;
		       {
			  obj_t obj2_627;
			  obj2_627 = _____74_type_cache;
			  test1258_389 = (type_386 == obj2_627);
		       }
		       if (test1258_389)
			 {
			    obj_t aux_977;
			    aux_977 = memq___r4_pairs_and_lists_6_3(import_9, CNST_TABLE_REF(((long) 4)));
			    test1257_388 = CBOOL(aux_977);
			 }
		       else
			 {
			    test1257_388 = ((bool_t) 0);
			 }
		    }
		    if (test1257_388)
		      {
			 type_379 = __obj__252_type_cache;
		      }
		    else
		      {
			 type_379 = type_386;
		      }
		 }
	       else
		 {
		    {
		       obj_t arg1261_392;
		       arg1261_392 = shape_tools_shape(type_386);
		       {
			  obj_t list1262_393;
			  list1262_393 = MAKE_PAIR(_____74_type_cache, BNIL);
			  type_379 = user_error_151_tools_error(id_7, string1350_ast_glo_decl_237, arg1261_392, list1262_393);
		       }
		    }
		 }
	    }
	 }
	 {
	    obj_t id_380;
	    id_380 = CAR(id_type_89_378);
	    {
	       svar_t svar_381;
	       {
		  svar_t res1332_633;
		  {
		     svar_t new1092_629;
		     new1092_629 = ((svar_t) BREF(GC_MALLOC(sizeof(struct svar))));
		     {
			long arg1307_630;
			arg1307_630 = class_num_218___object(svar_ast_var);
			{
			   obj_t obj_631;
			   obj_631 = (obj_t) (new1092_629);
			   (((obj_t) CREF(obj_631))->header = MAKE_HEADER(arg1307_630, 0), BUNSPEC);
			}
		     }
		     {
			object_t aux_990;
			aux_990 = (object_t) (new1092_629);
			OBJECT_WIDENING_SET(aux_990, BFALSE);
		     }
		     {
			res1332_633 = new1092_629;
		     }
		  }
		  svar_381 = res1332_633;
	       }
	       {
		  global_t global_382;
		  global_382 = bind_global__138_ast_env(id_380, module_8, (value_t) (svar_381), import_9, src_exp_176_10);
		  {
		     {
			obj_t res1333_636;
			{
			   type_t val1037_635;
			   val1037_635 = (type_t) (type_379);
			   {
			      obj_t x_804;
			      x_804 = ((((global_t) CREF(global_382))->type) = ((type_t) val1037_635), BUNSPEC);
			      res1333_636 = BUNSPEC;
			   }
			}
			res1333_636;
		     }
		     {
			obj_t arg1251_383;
			{
			   bool_t test_997;
			   {
			      obj_t aux_998;
			      aux_998 = CNST_TABLE_REF(((long) 1));
			      test_997 = (import_9 == aux_998);
			   }
			   if (test_997)
			     {
				arg1251_383 = CNST_TABLE_REF(((long) 5));
			     }
			   else
			     {
				arg1251_383 = CNST_TABLE_REF(((long) 6));
			     }
			}
			{
			   obj_t res1334_641;
			   {
			      obj_t x_805;
			      x_805 = ((((global_t) CREF(global_382))->access) = ((obj_t) arg1251_383), BUNSPEC);
			      res1334_641 = BUNSPEC;
			   }
			   res1334_641;
			}
		     }
		     return global_382;
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_declare_global_svar__33_ast_glo_decl_237(obj_t env_776, obj_t id_777, obj_t module_778, obj_t import_779, obj_t src_exp_176_780)
{
   {
      global_t aux_1004;
      aux_1004 = declare_global_svar__200_ast_glo_decl_237(id_777, module_778, import_779, src_exp_176_780);
      return (obj_t) (aux_1004);
   }
}


global_t 
declare_global_scnst__70_ast_glo_decl_237(obj_t id_11, obj_t module_12, obj_t import_13, obj_t node_14, obj_t class_15)
{
   {
      obj_t id_type_89_397;
      id_type_89_397 = parse_id_241_ast_ident(id_11);
      {
	 obj_t type_398;
	 {
	    obj_t type_404;
	    type_404 = CDR(id_type_89_397);
	    {
	       bool_t test1271_405;
	       {
		  obj_t obj2_644;
		  obj2_644 = _____74_type_cache;
		  test1271_405 = (type_404 == obj2_644);
	       }
	       if (test1271_405)
		 {
		    {
		       obj_t arg1273_407;
		       arg1273_407 = shape_tools_shape(type_404);
		       type_398 = internal_error_43_tools_error(id_11, string1350_ast_glo_decl_237, arg1273_407);
		    }
		 }
	       else
		 {
		    type_398 = type_404;
		 }
	    }
	 }
	 {
	    obj_t id_399;
	    id_399 = CAR(id_type_89_397);
	    {
	       scnst_t scnst_400;
	       {
		  scnst_t res1335_654;
		  {
		     scnst_t new1096_648;
		     new1096_648 = ((scnst_t) BREF(GC_MALLOC(sizeof(struct scnst))));
		     {
			long arg1303_649;
			arg1303_649 = class_num_218___object(scnst_ast_var);
			{
			   obj_t obj_652;
			   obj_652 = (obj_t) (new1096_648);
			   (((obj_t) CREF(obj_652))->header = MAKE_HEADER(arg1303_649, 0), BUNSPEC);
			}
		     }
		     {
			object_t aux_1018;
			aux_1018 = (object_t) (new1096_648);
			OBJECT_WIDENING_SET(aux_1018, BFALSE);
		     }
		     ((((scnst_t) CREF(new1096_648))->node) = ((obj_t) node_14), BUNSPEC);
		     ((((scnst_t) CREF(new1096_648))->class) = ((obj_t) class_15), BUNSPEC);
		     res1335_654 = new1096_648;
		  }
		  scnst_400 = res1335_654;
	       }
	       {
		  global_t global_401;
		  global_401 = bind_global__138_ast_env(id_399, module_12, (value_t) (scnst_400), import_13, CNST_TABLE_REF(((long) 7)));
		  {
		     {
			obj_t res1336_657;
			{
			   type_t val1037_656;
			   val1037_656 = (type_t) (type_398);
			   {
			      obj_t x_806;
			      x_806 = ((((global_t) CREF(global_401))->type) = ((type_t) val1037_656), BUNSPEC);
			      res1336_657 = BUNSPEC;
			   }
			}
			res1336_657;
		     }
		     {
			obj_t arg1268_402;
			arg1268_402 = CNST_TABLE_REF(((long) 5));
			{
			   obj_t res1337_660;
			   {
			      obj_t x_807;
			      x_807 = ((((global_t) CREF(global_401))->access) = ((obj_t) arg1268_402), BUNSPEC);
			      res1337_660 = BUNSPEC;
			   }
			   res1337_660;
			}
		     }
		     return global_401;
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_declare_global_scnst__34_ast_glo_decl_237(obj_t env_781, obj_t id_782, obj_t module_783, obj_t import_784, obj_t node_785, obj_t class_786)
{
   {
      global_t aux_1030;
      aux_1030 = declare_global_scnst__70_ast_glo_decl_237(id_782, module_783, import_784, node_785, class_786);
      return (obj_t) (aux_1030);
   }
}


global_t 
declare_global_cfun__81_ast_glo_decl_237(obj_t id_16, obj_t name_17, obj_t tres_id_18_18, obj_t targs_id_78_19, bool_t infix__163_20, bool_t macro__33_21, obj_t src_exp_176_22)
{
   {
      int arity_408;
      arity_408 = arity_tools_args(targs_id_78_19);
      {
	 type_t type_res_48_409;
	 type_res_48_409 = use_foreign_type__12_type_env(tres_id_18_18);
	 {
	    obj_t type_args_244_410;
	    {
	       obj_t l1111_415;
	       l1111_415 = args___args_list_50_tools_args(targs_id_78_19);
	       if (NULLP(l1111_415))
		 {
		    type_args_244_410 = BNIL;
		 }
	       else
		 {
		    obj_t head1114_417;
		    {
		       type_t arg1286_428;
		       arg1286_428 = use_foreign_type__12_type_env(CAR(l1111_415));
		       {
			  obj_t aux_1040;
			  aux_1040 = (obj_t) (arg1286_428);
			  head1114_417 = MAKE_PAIR(aux_1040, BNIL);
		       }
		    }
		    {
		       obj_t l1111_418;
		       obj_t tail1115_419;
		       l1111_418 = CDR(l1111_415);
		       tail1115_419 = head1114_417;
		     lname1113_420:
		       if (NULLP(l1111_418))
			 {
			    type_args_244_410 = head1114_417;
			 }
		       else
			 {
			    obj_t new_tail1116_88_423;
			    {
			       type_t arg1282_425;
			       arg1282_425 = use_foreign_type__12_type_env(CAR(l1111_418));
			       {
				  obj_t aux_1047;
				  aux_1047 = (obj_t) (arg1282_425);
				  new_tail1116_88_423 = MAKE_PAIR(aux_1047, BNIL);
			       }
			    }
			    SET_CDR(tail1115_419, new_tail1116_88_423);
			    {
			       obj_t tail1115_1053;
			       obj_t l1111_1051;
			       l1111_1051 = CDR(l1111_418);
			       tail1115_1053 = new_tail1116_88_423;
			       tail1115_419 = tail1115_1053;
			       l1111_418 = l1111_1051;
			       goto lname1113_420;
			    }
			 }
		    }
		 }
	    }
	    {
	       cfun_t cfun_411;
	       {
		  cfun_t res1338_695;
		  {
		     long arity_673;
		     obj_t predicate_of_78_675;
		     obj_t stack_allocator_172_676;
		     arity_673 = (long) (arity_408);
		     predicate_of_78_675 = BFALSE;
		     stack_allocator_172_676 = BFALSE;
		     {
			cfun_t new1082_682;
			new1082_682 = ((cfun_t) BREF(GC_MALLOC(sizeof(struct cfun))));
			{
			   long arg1310_683;
			   arg1310_683 = class_num_218___object(cfun_ast_var);
			   {
			      obj_t obj_693;
			      obj_693 = (obj_t) (new1082_682);
			      (((obj_t) CREF(obj_693))->header = MAKE_HEADER(arg1310_683, 0), BUNSPEC);
			   }
			}
			{
			   object_t aux_1060;
			   aux_1060 = (object_t) (new1082_682);
			   OBJECT_WIDENING_SET(aux_1060, predicate_of_78_675);
			}
			((((cfun_t) CREF(new1082_682))->arity) = ((long) arity_673), BUNSPEC);
			((((cfun_t) CREF(new1082_682))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			((((cfun_t) CREF(new1082_682))->predicate_of_78) = ((obj_t) predicate_of_78_675), BUNSPEC);
			((((cfun_t) CREF(new1082_682))->stack_allocator_172) = ((obj_t) stack_allocator_172_676), BUNSPEC);
			((((cfun_t) CREF(new1082_682))->top__138) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			((((cfun_t) CREF(new1082_682))->the_closure_238) = ((obj_t) BUNSPEC), BUNSPEC);
			((((cfun_t) CREF(new1082_682))->args_type_205) = ((obj_t) type_args_244_410), BUNSPEC);
			((((cfun_t) CREF(new1082_682))->macro__33) = ((bool_t) macro__33_21), BUNSPEC);
			((((cfun_t) CREF(new1082_682))->infix__163) = ((bool_t) infix__163_20), BUNSPEC);
			res1338_695 = new1082_682;
		     }
		  }
		  cfun_411 = res1338_695;
	       }
	       {
		  global_t global_412;
		  global_412 = bind_global__138_ast_env(id_16, CNST_TABLE_REF(((long) 8)), (value_t) (cfun_411), CNST_TABLE_REF(((long) 8)), src_exp_176_22);
		  {
		     {
			obj_t res1339_698;
			{
			   obj_t x_808;
			   x_808 = ((((global_t) CREF(global_412))->name) = ((obj_t) name_17), BUNSPEC);
			   res1339_698 = BUNSPEC;
			}
			res1339_698;
		     }
		     {
			obj_t res1340_701;
			{
			   obj_t x_809;
			   x_809 = ((((global_t) CREF(global_412))->type) = ((type_t) type_res_48_409), BUNSPEC);
			   res1340_701 = BUNSPEC;
			}
			res1340_701;
		     }
		     {
			obj_t res1341_704;
			{
			   obj_t x_810;
			   x_810 = ((((global_t) CREF(global_412))->evaluable__248) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			   res1341_704 = BUNSPEC;
			}
			res1341_704;
		     }
		     return global_412;
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_declare_global_cfun__89_ast_glo_decl_237(obj_t env_787, obj_t id_788, obj_t name_789, obj_t tres_id_18_790, obj_t targs_id_78_791, obj_t infix__163_792, obj_t macro__33_793, obj_t src_exp_176_794)
{
   {
      global_t aux_1079;
      aux_1079 = declare_global_cfun__81_ast_glo_decl_237(id_788, name_789, tres_id_18_790, targs_id_78_791, CBOOL(infix__163_792), CBOOL(macro__33_793), src_exp_176_794);
      return (obj_t) (aux_1079);
   }
}


global_t 
declare_global_cvar__13_ast_glo_decl_237(obj_t id_23, obj_t name_24, obj_t type_id_229_25, bool_t macro__33_26, obj_t src_exp_176_27)
{
   {
      type_t type_705;
      type_705 = use_foreign_type__12_type_env(type_id_229_25);
      {
	 cvar_t cvar_706;
	 {
	    cvar_t res1342_716;
	    {
	       cvar_t new1101_711;
	       new1101_711 = ((cvar_t) BREF(GC_MALLOC(sizeof(struct cvar))));
	       {
		  long arg1299_712;
		  arg1299_712 = class_num_218___object(cvar_ast_var);
		  {
		     obj_t obj_714;
		     obj_714 = (obj_t) (new1101_711);
		     (((obj_t) CREF(obj_714))->header = MAKE_HEADER(arg1299_712, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_1089;
		  aux_1089 = (object_t) (new1101_711);
		  OBJECT_WIDENING_SET(aux_1089, BFALSE);
	       }
	       ((((cvar_t) CREF(new1101_711))->macro__33) = ((bool_t) macro__33_26), BUNSPEC);
	       res1342_716 = new1101_711;
	    }
	    cvar_706 = res1342_716;
	 }
	 {
	    global_t global_707;
	    global_707 = bind_global__138_ast_env(id_23, CNST_TABLE_REF(((long) 8)), (value_t) (cvar_706), CNST_TABLE_REF(((long) 8)), src_exp_176_27);
	    {
	       {
		  obj_t res1343_719;
		  {
		     obj_t x_811;
		     x_811 = ((((global_t) CREF(global_707))->name) = ((obj_t) name_24), BUNSPEC);
		     res1343_719 = BUNSPEC;
		  }
		  res1343_719;
	       }
	       {
		  obj_t res1344_722;
		  {
		     obj_t x_812;
		     x_812 = ((((global_t) CREF(global_707))->type) = ((type_t) type_705), BUNSPEC);
		     res1344_722 = BUNSPEC;
		  }
		  res1344_722;
	       }
	       {
		  obj_t res1345_725;
		  {
		     obj_t x_813;
		     x_813 = ((((global_t) CREF(global_707))->evaluable__248) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		     res1345_725 = BUNSPEC;
		  }
		  res1345_725;
	       }
	       return global_707;
	    }
	 }
      }
   }
}


obj_t 
_declare_global_cvar__232_ast_glo_decl_237(obj_t env_795, obj_t id_796, obj_t name_797, obj_t type_id_229_798, obj_t macro__33_799, obj_t src_exp_176_800)
{
   {
      global_t aux_1100;
      aux_1100 = declare_global_cvar__13_ast_glo_decl_237(id_796, name_797, type_id_229_798, CBOOL(macro__33_799), src_exp_176_800);
      return (obj_t) (aux_1100);
   }
}


obj_t 
imported_modules_init_94_ast_glo_decl_237()
{
   module_initialization_70_tools_trace(((long) 0), "AST_GLO-DECL");
   module_initialization_70_tools_error(((long) 0), "AST_GLO-DECL");
   module_initialization_70_tools_args(((long) 0), "AST_GLO-DECL");
   module_initialization_70_tools_shape(((long) 0), "AST_GLO-DECL");
   module_initialization_70_tools_dsssl(((long) 0), "AST_GLO-DECL");
   module_initialization_70_type_type(((long) 0), "AST_GLO-DECL");
   module_initialization_70_type_cache(((long) 0), "AST_GLO-DECL");
   module_initialization_70_ast_var(((long) 0), "AST_GLO-DECL");
   module_initialization_70_ast_env(((long) 0), "AST_GLO-DECL");
   module_initialization_70_ast_ident(((long) 0), "AST_GLO-DECL");
   return module_initialization_70_type_env(((long) 0), "AST_GLO-DECL");
}
