/*===========================================================================*/
/*   (Ast/glo-def.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;


extern global_t declare_global_sfun__255_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t type_type_type;
extern global_t def_global_sfun__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _def_global_sfun__109_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern bool_t type_subclass__90_object_class(type_t, type_t);
extern obj_t class_object_class;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_ast_glo_def_117();
static global_t mismatch_error_84_ast_glo_def_117(global_t, obj_t, obj_t);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_glo_decl_237(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_dsssl(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_equivalence_6_2(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t cnst_init_137_ast_glo_def_117();
extern obj_t remove_var_from__148_ast_remove(obj_t, variable_t);
extern obj_t dsssl_formals_encoding_15_tools_dsssl(obj_t);
static bool_t compatible_type__151_ast_glo_def_117(bool_t, type_t, type_t);
static obj_t require_initialization_114_ast_glo_def_117 = BUNSPEC;
extern obj_t _def_global_scnst__222_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_ast_glo_def_117();
extern bool_t equal__25___r4_equivalence_6_2(obj_t, obj_t);
extern obj_t sfun_ast_var;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t id_of_id_112_ast_ident(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t enter_function_81_tools_error(obj_t);
extern int arity_tools_args(obj_t);
extern global_t def_global_svar__184_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
extern global_t def_global_scnst__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern bool_t check_method_definition_71_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
extern obj_t svar_ast_var;
extern obj_t _def_global_svar__252_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t local_ast_var;
extern global_t declare_global_scnst__70_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t);
extern long list_length(obj_t);
extern obj_t _____74_type_cache;
extern obj_t string_append_106___r4_strings_6_7(obj_t);
static global_t check_sfun_definition_109_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern global_t declare_global_svar__200_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t);
extern obj_t __obj__252_type_cache;
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t _check_method_definition_40_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t);
extern type_t type_of_id_183_ast_ident(obj_t);
static global_t check_svar_definition_92_ast_glo_def_117(obj_t, obj_t, obj_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern obj_t leave_function_170_tools_error();
static obj_t __cnst[5];

DEFINE_STRING(string1680_ast_glo_def_117, string1680_ast_glo_def_1171693, "(incompatible formal type)", 26);
DEFINE_EXPORT_PROCEDURE(def_global_svar__env_161_ast_glo_def_117, _def_global_svar__252_ast_glo_def_1171694, _def_global_svar__252_ast_glo_def_117, 0L, 4);
DEFINE_STRING(string1686_ast_glo_def_117, string1686_ast_glo_def_1171695, "Prototype and definition don't match", 36);
DEFINE_STRING(string1685_ast_glo_def_117, string1685_ast_glo_def_1171696, "(incompatible variable type)", 28);
DEFINE_STRING(string1687_ast_glo_def_117, string1687_ast_glo_def_1171697, "BIGLOO NOW SGFUN STATIC AST ", 28);
DEFINE_STRING(string1681_ast_glo_def_117, string1681_ast_glo_def_1171698, "(incompatible Dsssl prototype)", 30);
DEFINE_STRING(string1682_ast_glo_def_117, string1682_ast_glo_def_1171699, "(incompatible function type result)", 35);
DEFINE_STRING(string1676_ast_glo_def_117, string1676_ast_glo_def_1171700, "def-global-sfun!: ", 18);
DEFINE_STRING(string1677_ast_glo_def_117, string1677_ast_glo_def_1171701, "check-method-definition", 23);
DEFINE_STRING(string1675_ast_glo_def_117, string1675_ast_glo_def_1171702, " ", 1);
DEFINE_EXPORT_PROCEDURE(def_global_scnst__env_209_ast_glo_def_117, _def_global_scnst__222_ast_glo_def_1171703, _def_global_scnst__222_ast_glo_def_117, 0L, 4);
DEFINE_STRING(string1684_ast_glo_def_117, string1684_ast_glo_def_1171704, "Illegal type for global variable", 32);
DEFINE_STRING(string1679_ast_glo_def_117, string1679_ast_glo_def_1171705, "check-sfun-definition: ", 23);
DEFINE_STRING(string1678_ast_glo_def_117, string1678_ast_glo_def_1171706, "unexpected generic arg", 22);
DEFINE_EXPORT_PROCEDURE(def_global_sfun__env_209_ast_glo_def_117, _def_global_sfun__109_ast_glo_def_1171707, _def_global_sfun__109_ast_glo_def_117, 0L, 8);
DEFINE_STRING(string1683_ast_glo_def_117, string1683_ast_glo_def_1171708, "(arity differs)", 15);
DEFINE_EXPORT_PROCEDURE(check_method_definition_env_136_ast_glo_def_117, _check_method_definition_40_ast_glo_def_1171709, _check_method_definition_40_ast_glo_def_117, 0L, 4);

obj_t 
module_initialization_70_ast_glo_def_117(long checksum_1538, char *from_1539)
{
   if (CBOOL(require_initialization_114_ast_glo_def_117))
     {
	require_initialization_114_ast_glo_def_117 = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_glo_def_117();
	cnst_init_137_ast_glo_def_117();
	imported_modules_init_94_ast_glo_def_117();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_glo_def_117()
{
   module_initialization_70___object(((long) 0), "AST_GLO-DEF");
   module_initialization_70___r4_equivalence_6_2(((long) 0), "AST_GLO-DEF");
   module_initialization_70___reader(((long) 0), "AST_GLO-DEF");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_GLO-DEF");
   module_initialization_70___r4_strings_6_7(((long) 0), "AST_GLO-DEF");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_glo_def_117()
{
   {
      obj_t cnst_port_138_1530;
      cnst_port_138_1530 = open_input_string(string1687_ast_glo_def_117);
      {
	 long i_1531;
	 i_1531 = ((long) 4);
       loop_1532:
	 {
	    bool_t test1688_1533;
	    test1688_1533 = (i_1531 == ((long) -1));
	    if (test1688_1533)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1689_1534;
		    {
		       obj_t list1690_1535;
		       {
			  obj_t arg1691_1536;
			  arg1691_1536 = BNIL;
			  list1690_1535 = MAKE_PAIR(cnst_port_138_1530, arg1691_1536);
		       }
		       arg1689_1534 = read___reader(list1690_1535);
		    }
		    CNST_TABLE_SET(i_1531, arg1689_1534);
		 }
		 {
		    int aux_1537;
		    {
		       long aux_1557;
		       aux_1557 = (i_1531 - ((long) 1));
		       aux_1537 = (int) (aux_1557);
		    }
		    {
		       long i_1560;
		       i_1560 = (long) (aux_1537);
		       i_1531 = i_1560;
		       goto loop_1532;
		    }
		 }
	      }
	 }
      }
   }
}


global_t 
def_global_sfun__93_ast_glo_def_117(obj_t id_1, obj_t args_2, obj_t locals_3, obj_t module_4, obj_t class_5, obj_t src_exp_176_6, obj_t rem_7, obj_t node_8)
{
   {
      bool_t test1318_736;
      {
	 obj_t aux_1562;
	 aux_1562 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
	 test1318_736 = CBOOL(aux_1562);
      }
      if (test1318_736)
	{
	   obj_t arg1320_738;
	   obj_t arg1322_740;
	   obj_t arg1325_742;
	   arg1320_738 = shape_tools_shape(id_1);
	   arg1322_740 = shape_tools_shape(args_2);
	   arg1325_742 = shape_tools_shape(locals_3);
	   {
	      obj_t list1326_743;
	      {
		 obj_t arg1327_744;
		 {
		    obj_t arg1328_745;
		    {
		       obj_t arg1329_746;
		       {
			  obj_t arg1331_747;
			  {
			     obj_t arg1332_748;
			     {
				obj_t arg1333_749;
				{
				   obj_t aux_1571;
				   aux_1571 = BCHAR(((unsigned char) '\n'));
				   arg1333_749 = MAKE_PAIR(aux_1571, BNIL);
				}
				arg1332_748 = MAKE_PAIR(arg1325_742, arg1333_749);
			     }
			     arg1331_747 = MAKE_PAIR(string1675_ast_glo_def_117, arg1332_748);
			  }
			  arg1329_746 = MAKE_PAIR(arg1322_740, arg1331_747);
		       }
		       arg1328_745 = MAKE_PAIR(string1675_ast_glo_def_117, arg1329_746);
		    }
		    arg1327_744 = MAKE_PAIR(arg1320_738, arg1328_745);
		 }
		 list1326_743 = MAKE_PAIR(string1676_ast_glo_def_117, arg1327_744);
	      }
	      print_trace_107_tools_trace(list1326_743);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   enter_function_81_tools_error(id_1);
   {
      obj_t id_type_89_753;
      id_type_89_753 = parse_id_241_ast_ident(id_1);
      {
	 obj_t type_res_48_754;
	 type_res_48_754 = CDR(id_type_89_753);
	 {
	    obj_t id_755;
	    id_755 = CAR(id_type_89_753);
	    {
	       obj_t old_global_82_756;
	       {
		  obj_t list1373_796;
		  list1373_796 = MAKE_PAIR(module_4, BNIL);
		  old_global_82_756 = find_global_223_ast_env(id_755, list1373_796);
	       }
	       {
		  global_t global_757;
		  {
		     bool_t test1371_794;
		     test1371_794 = is_a__118___object(old_global_82_756, global_ast_var);
		     if (test1371_794)
		       {
			  global_757 = check_sfun_definition_109_ast_glo_def_117(old_global_82_756, type_res_48_754, args_2, locals_3, class_5, src_exp_176_6);
		       }
		     else
		       {
			  global_757 = declare_global_sfun__255_ast_glo_decl_237(id_755, args_2, module_4, CNST_TABLE_REF(((long) 1)), class_5, src_exp_176_6);
		       }
		  }
		  {
		     {
			variable_t var_1315;
			type_t new_type_21_1316;
			var_1315 = (variable_t) (global_757);
			new_type_21_1316 = (type_t) (type_res_48_754);
			{
			   bool_t test1519_1318;
			   {
			      obj_t obj2_1321;
			      obj2_1321 = _____74_type_cache;
			      {
				 obj_t aux_1594;
				 {
				    type_t aux_1595;
				    aux_1595 = (((variable_t) CREF(var_1315))->type);
				    aux_1594 = (obj_t) (aux_1595);
				 }
				 test1519_1318 = (aux_1594 == obj2_1321);
			      }
			   }
			   if (test1519_1318)
			     {
				obj_t res1668_1324;
				{
				   obj_t x_1524;
				   x_1524 = ((((variable_t) CREF(var_1315))->type) = ((type_t) new_type_21_1316), BUNSPEC);
				   res1668_1324 = BUNSPEC;
				}
				res1668_1324;
			     }
			   else
			     {
				BUNSPEC;
			     }
			}
		     }
		     {
			bool_t test_1601;
			{
			   long aux_1604;
			   long aux_1602;
			   {
			      obj_t aux_1605;
			      {
				 sfun_t obj_1326;
				 {
				    value_t aux_1606;
				    aux_1606 = (((global_t) CREF(global_757))->value);
				    obj_1326 = (sfun_t) (aux_1606);
				 }
				 aux_1605 = (((sfun_t) CREF(obj_1326))->args);
			      }
			      aux_1604 = list_length(aux_1605);
			   }
			   aux_1602 = list_length(locals_3);
			   test_1601 = (aux_1602 == aux_1604);
			}
			if (test_1601)
			  {
			     obj_t types_759;
			     {
				obj_t l1291_768;
				{
				   sfun_t obj_1330;
				   {
				      value_t aux_1612;
				      aux_1612 = (((global_t) CREF(global_757))->value);
				      obj_1330 = (sfun_t) (aux_1612);
				   }
				   l1291_768 = (((sfun_t) CREF(obj_1330))->args);
				}
				if (NULLP(l1291_768))
				  {
				     types_759 = BNIL;
				  }
				else
				  {
				     obj_t head1293_770;
				     head1293_770 = MAKE_PAIR(BNIL, BNIL);
				     {
					obj_t l1291_771;
					obj_t tail1294_772;
					l1291_771 = l1291_768;
					tail1294_772 = head1293_770;
				      lname1292_773:
					if (NULLP(l1291_771))
					  {
					     types_759 = CDR(head1293_770);
					  }
					else
					  {
					     obj_t new_tail1295_140_775;
					     {
						obj_t arg1350_777;
						{
						   obj_t a_779;
						   a_779 = CAR(l1291_771);
						   {
						      bool_t test1353_780;
						      test1353_780 = is_a__118___object(a_779, local_ast_var);
						      if (test1353_780)
							{
							   {
							      local_t obj_1338;
							      obj_1338 = (local_t) (a_779);
							      {
								 type_t aux_1626;
								 aux_1626 = (((local_t) CREF(obj_1338))->type);
								 arg1350_777 = (obj_t) (aux_1626);
							      }
							   }
							}
						      else
							{
							   bool_t test1354_781;
							   test1354_781 = is_a__118___object(a_779, type_type_type);
							   if (test1354_781)
							     {
								arg1350_777 = a_779;
							     }
							   else
							     {
								{
								   obj_t arg1357_784;
								   arg1357_784 = shape_tools_shape(a_779);
								   arg1350_777 = internal_error_43_tools_error(string1677_ast_glo_def_117, string1678_ast_glo_def_117, arg1357_784);
								}
							     }
							}
						   }
						}
						new_tail1295_140_775 = MAKE_PAIR(arg1350_777, BNIL);
					     }
					     SET_CDR(tail1294_772, new_tail1295_140_775);
					     {
						obj_t tail1294_1637;
						obj_t l1291_1635;
						l1291_1635 = CDR(l1291_771);
						tail1294_1637 = new_tail1295_140_775;
						tail1294_772 = tail1294_1637;
						l1291_771 = l1291_1635;
						goto lname1292_773;
					     }
					  }
				     }
				  }
			     }
			     {
				obj_t ll1296_760;
				obj_t ll1297_761;
				{
				   bool_t aux_1638;
				   ll1296_760 = locals_3;
				   ll1297_761 = types_759;
				 lname1298_762:
				   if (NULLP(ll1296_760))
				     {
					aux_1638 = ((bool_t) 1);
				     }
				   else
				     {
					{
					   variable_t var_1348;
					   type_t new_type_21_1349;
					   {
					      obj_t aux_1641;
					      aux_1641 = CAR(ll1296_760);
					      var_1348 = (variable_t) (aux_1641);
					   }
					   {
					      obj_t aux_1644;
					      aux_1644 = CAR(ll1297_761);
					      new_type_21_1349 = (type_t) (aux_1644);
					   }
					   {
					      bool_t test1519_1351;
					      {
						 obj_t obj2_1354;
						 obj2_1354 = _____74_type_cache;
						 {
						    obj_t aux_1647;
						    {
						       type_t aux_1648;
						       aux_1648 = (((variable_t) CREF(var_1348))->type);
						       aux_1647 = (obj_t) (aux_1648);
						    }
						    test1519_1351 = (aux_1647 == obj2_1354);
						 }
					      }
					      if (test1519_1351)
						{
						   obj_t res1669_1357;
						   {
						      obj_t x_1525;
						      x_1525 = ((((variable_t) CREF(var_1348))->type) = ((type_t) new_type_21_1349), BUNSPEC);
						      res1669_1357 = BUNSPEC;
						   }
						   res1669_1357;
						}
					      else
						{
						   BUNSPEC;
						}
					   }
					}
					{
					   obj_t ll1297_1656;
					   obj_t ll1296_1654;
					   ll1296_1654 = CDR(ll1296_760);
					   ll1297_1656 = CDR(ll1297_761);
					   ll1297_761 = ll1297_1656;
					   ll1296_760 = ll1296_1654;
					   goto lname1298_762;
					}
				     }
				   BBOOL(aux_1638);
				}
			     }
			  }
			else
			  {
			     BUNSPEC;
			  }
		     }
		     remove_var_from__148_ast_remove(rem_7, (variable_t) (global_757));
		     {
			obj_t res1670_1363;
			{
			   sfun_t obj_1361;
			   {
			      value_t aux_1661;
			      aux_1661 = (((global_t) CREF(global_757))->value);
			      obj_1361 = (sfun_t) (aux_1661);
			   }
			   {
			      obj_t x_1526;
			      x_1526 = ((((sfun_t) CREF(obj_1361))->body) = ((obj_t) node_8), BUNSPEC);
			      res1670_1363 = BUNSPEC;
			   }
			}
			res1670_1363;
		     }
		     {
			obj_t res1671_1367;
			{
			   sfun_t obj_1365;
			   {
			      value_t aux_1665;
			      aux_1665 = (((global_t) CREF(global_757))->value);
			      obj_1365 = (sfun_t) (aux_1665);
			   }
			   {
			      obj_t x_1527;
			      x_1527 = ((((sfun_t) CREF(obj_1365))->args) = ((obj_t) locals_3), BUNSPEC);
			      res1671_1367 = BUNSPEC;
			   }
			}
			res1671_1367;
		     }
		     leave_function_170_tools_error();
		     return global_757;
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_def_global_sfun__109_ast_glo_def_117(obj_t env_1500, obj_t id_1501, obj_t args_1502, obj_t locals_1503, obj_t module_1504, obj_t class_1505, obj_t src_exp_176_1506, obj_t rem_1507, obj_t node_1508)
{
   {
      global_t aux_1670;
      aux_1670 = def_global_sfun__93_ast_glo_def_117(id_1501, args_1502, locals_1503, module_1504, class_1505, src_exp_176_1506, rem_1507, node_1508);
      return (obj_t) (aux_1670);
   }
}


global_t 
check_sfun_definition_109_ast_glo_def_117(obj_t old_9, obj_t type_res_48_10, obj_t args_11, obj_t locals_12, obj_t class_13, obj_t src_exp_176_14)
{
   {
      bool_t test1377_798;
      {
	 obj_t aux_1673;
	 aux_1673 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
	 test1377_798 = CBOOL(aux_1673);
      }
      if (test1377_798)
	{
	   obj_t arg1380_800;
	   obj_t arg1382_802;
	   obj_t arg1388_804;
	   arg1380_800 = shape_tools_shape(old_9);
	   arg1382_802 = shape_tools_shape(args_11);
	   arg1388_804 = shape_tools_shape(locals_12);
	   {
	      obj_t list1389_805;
	      {
		 obj_t arg1390_806;
		 {
		    obj_t arg1391_807;
		    {
		       obj_t arg1396_808;
		       {
			  obj_t arg1398_809;
			  {
			     obj_t arg1400_810;
			     {
				obj_t arg1402_811;
				{
				   obj_t aux_1682;
				   aux_1682 = BCHAR(((unsigned char) '\n'));
				   arg1402_811 = MAKE_PAIR(aux_1682, BNIL);
				}
				arg1400_810 = MAKE_PAIR(arg1388_804, arg1402_811);
			     }
			     arg1398_809 = MAKE_PAIR(string1675_ast_glo_def_117, arg1400_810);
			  }
			  arg1396_808 = MAKE_PAIR(arg1382_802, arg1398_809);
		       }
		       arg1391_807 = MAKE_PAIR(string1675_ast_glo_def_117, arg1396_808);
		    }
		    arg1390_806 = MAKE_PAIR(arg1380_800, arg1391_807);
		 }
		 list1389_805 = MAKE_PAIR(string1679_ast_glo_def_117, arg1390_806);
	      }
	      print_trace_107_tools_trace(list1389_805);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      value_t old_value_175_815;
      {
	 global_t obj_1368;
	 obj_1368 = (global_t) (old_9);
	 old_value_175_815 = (((global_t) CREF(obj_1368))->value);
      }
      {
	 bool_t test1407_816;
	 test1407_816 = is_a__118___object((obj_t) (old_value_175_815), sfun_ast_var);
	 if (test1407_816)
	   {
	      bool_t test_1697;
	      {
		 obj_t aux_1698;
		 {
		    sfun_t obj_1370;
		    obj_1370 = (sfun_t) (old_value_175_815);
		    aux_1698 = (((sfun_t) CREF(obj_1370))->class);
		 }
		 test_1697 = (aux_1698 == class_13);
	      }
	      if (test_1697)
		{
		   bool_t test1409_818;
		   {
		      long arg1470_872;
		      int arg1471_873;
		      {
			 sfun_t obj_1373;
			 obj_1373 = (sfun_t) (old_value_175_815);
			 arg1470_872 = (((sfun_t) CREF(obj_1373))->arity);
		      }
		      arg1471_873 = arity_tools_args(args_11);
		      {
			 long aux_1705;
			 aux_1705 = (long) (arg1471_873);
			 test1409_818 = (arg1470_872 == aux_1705);
		      }
		   }
		   if (test1409_818)
		     {
			bool_t test1410_819;
			{
			   type_t aux_1713;
			   bool_t aux_1709;
			   {
			      global_t obj_1378;
			      obj_1378 = (global_t) (old_9);
			      aux_1713 = (((global_t) CREF(obj_1378))->type);
			   }
			   {
			      obj_t aux_1710;
			      aux_1710 = CNST_TABLE_REF(((long) 2));
			      aux_1709 = (aux_1710 == class_13);
			   }
			   test1410_819 = compatible_type__151_ast_glo_def_117(aux_1709, (type_t) (type_res_48_10), aux_1713);
			}
			if (test1410_819)
			  {
			     bool_t test1411_820;
			     {
				obj_t arg1453_861;
				obj_t arg1454_862;
				{
				   sfun_t obj_1379;
				   obj_1379 = (sfun_t) (old_value_175_815);
				   arg1453_861 = (((sfun_t) CREF(obj_1379))->dsssl_keywords_243);
				}
				arg1454_862 = dsssl_formals_encoding_15_tools_dsssl(args_11);
				test1411_820 = equal__25___r4_equivalence_6_2(arg1453_861, arg1454_862);
			     }
			     if (test1411_820)
			       {
				  obj_t _ortest_1299_821;
				  {
				     obj_t locals_822;
				     obj_t types_823;
				     bool_t sub__142_824;
				     {
					obj_t arg1412_826;
					bool_t arg1414_827;
					{
					   obj_t l1300_828;
					   {
					      sfun_t obj_1380;
					      obj_1380 = (sfun_t) (old_value_175_815);
					      l1300_828 = (((sfun_t) CREF(obj_1380))->args);
					   }
					   if (NULLP(l1300_828))
					     {
						arg1412_826 = BNIL;
					     }
					   else
					     {
						obj_t head1302_830;
						head1302_830 = MAKE_PAIR(BNIL, BNIL);
						{
						   obj_t l1300_831;
						   obj_t tail1303_832;
						   l1300_831 = l1300_828;
						   tail1303_832 = head1302_830;
						 lname1301_833:
						   if (NULLP(l1300_831))
						     {
							arg1412_826 = CDR(head1302_830);
						     }
						   else
						     {
							obj_t new_tail1304_1_835;
							{
							   obj_t arg1418_837;
							   {
							      obj_t a_839;
							      a_839 = CAR(l1300_831);
							      {
								 bool_t test1421_840;
								 test1421_840 = is_a__118___object(a_839, local_ast_var);
								 if (test1421_840)
								   {
								      {
									 local_t obj_1388;
									 obj_1388 = (local_t) (a_839);
									 {
									    type_t aux_1736;
									    aux_1736 = (((local_t) CREF(obj_1388))->type);
									    arg1418_837 = (obj_t) (aux_1736);
									 }
								      }
								   }
								 else
								   {
								      bool_t test1422_841;
								      test1422_841 = is_a__118___object(a_839, type_type_type);
								      if (test1422_841)
									{
									   arg1418_837 = a_839;
									}
								      else
									{
									   {
									      obj_t arg1427_844;
									      arg1427_844 = shape_tools_shape(a_839);
									      arg1418_837 = internal_error_43_tools_error(string1677_ast_glo_def_117, string1678_ast_glo_def_117, arg1427_844);
									   }
									}
								   }
							      }
							   }
							   new_tail1304_1_835 = MAKE_PAIR(arg1418_837, BNIL);
							}
							SET_CDR(tail1303_832, new_tail1304_1_835);
							{
							   obj_t tail1303_1747;
							   obj_t l1300_1745;
							   l1300_1745 = CDR(l1300_831);
							   tail1303_1747 = new_tail1304_1_835;
							   tail1303_832 = tail1303_1747;
							   l1300_831 = l1300_1745;
							   goto lname1301_833;
							}
						     }
						}
					     }
					}
					{
					   obj_t aux_1748;
					   aux_1748 = CNST_TABLE_REF(((long) 2));
					   arg1414_827 = (aux_1748 == class_13);
					}
					locals_822 = locals_12;
					types_823 = arg1412_826;
					sub__142_824 = arg1414_827;
				      loop_825:
					if (NULLP(locals_822))
					  {
					     {
						obj_t res1672_1400;
						{
						   global_t obj_1398;
						   obj_1398 = (global_t) (old_9);
						   {
						      obj_t x_1528;
						      x_1528 = ((((global_t) CREF(obj_1398))->src) = ((obj_t) src_exp_176_14), BUNSPEC);
						      res1672_1400 = BUNSPEC;
						   }
						}
						res1672_1400;
					     }
					     _ortest_1299_821 = old_9;
					  }
					else
					  {
					     bool_t test1434_849;
					     {
						type_t aux_1760;
						type_t aux_1755;
						{
						   obj_t aux_1761;
						   aux_1761 = CAR(types_823);
						   aux_1760 = (type_t) (aux_1761);
						}
						{
						   local_t obj_1402;
						   {
						      obj_t aux_1756;
						      aux_1756 = CAR(locals_822);
						      obj_1402 = (local_t) (aux_1756);
						   }
						   aux_1755 = (((local_t) CREF(obj_1402))->type);
						}
						test1434_849 = compatible_type__151_ast_glo_def_117(sub__142_824, aux_1755, aux_1760);
					     }
					     if (test1434_849)
					       {
						  {
						     bool_t sub__142_1770;
						     obj_t types_1768;
						     obj_t locals_1766;
						     locals_1766 = CDR(locals_822);
						     types_1768 = CDR(types_823);
						     sub__142_1770 = ((bool_t) 0);
						     sub__142_824 = sub__142_1770;
						     types_823 = types_1768;
						     locals_822 = locals_1766;
						     goto loop_825;
						  }
					       }
					     else
					       {
						  {
						     obj_t list1442_852;
						     list1442_852 = MAKE_PAIR(string1680_ast_glo_def_117, BNIL);
						     {
							global_t aux_1772;
							aux_1772 = mismatch_error_84_ast_glo_def_117((global_t) (old_9), src_exp_176_14, list1442_852);
							_ortest_1299_821 = (obj_t) (aux_1772);
						     }
						  }
					       }
					  }
				     }
				  }
				  if (CBOOL(_ortest_1299_821))
				    {
				       return (global_t) (_ortest_1299_821);
				    }
				  else
				    {
				       return (global_t) (old_9);
				    }
			       }
			     else
			       {
				  {
				     obj_t list1449_858;
				     list1449_858 = MAKE_PAIR(string1681_ast_glo_def_117, BNIL);
				     return mismatch_error_84_ast_glo_def_117((global_t) (old_9), src_exp_176_14, list1449_858);
				  }
			       }
			  }
			else
			  {
			     {
				obj_t list1455_863;
				list1455_863 = MAKE_PAIR(string1682_ast_glo_def_117, BNIL);
				return mismatch_error_84_ast_glo_def_117((global_t) (old_9), src_exp_176_14, list1455_863);
			     }
			  }
		     }
		   else
		     {
			{
			   obj_t list1466_869;
			   list1466_869 = MAKE_PAIR(string1683_ast_glo_def_117, BNIL);
			   return mismatch_error_84_ast_glo_def_117((global_t) (old_9), src_exp_176_14, list1466_869);
			}
		     }
		}
	      else
		{
		   return mismatch_error_84_ast_glo_def_117((global_t) (old_9), src_exp_176_14, BNIL);
		}
	   }
	 else
	   {
	      return mismatch_error_84_ast_glo_def_117((global_t) (old_9), src_exp_176_14, BNIL);
	   }
      }
   }
}


global_t 
def_global_scnst__93_ast_glo_def_117(obj_t id_15, obj_t module_16, obj_t node_17, obj_t class_18)
{
   enter_function_81_tools_error(id_15);
   {
      obj_t id_type_89_877;
      id_type_89_877 = parse_id_241_ast_ident(id_15);
      {
	 obj_t id_id_127_878;
	 id_id_127_878 = CAR(id_type_89_877);
	 {
	    obj_t old_global_82_879;
	    {
	       obj_t list1478_883;
	       list1478_883 = MAKE_PAIR(module_16, BNIL);
	       old_global_82_879 = find_global_223_ast_env(id_id_127_878, list1478_883);
	    }
	    {
	       global_t global_880;
	       global_880 = declare_global_scnst__70_ast_glo_decl_237(id_15, module_16, CNST_TABLE_REF(((long) 1)), node_17, class_18);
	       {
		  remove_var_from__148_ast_remove(CNST_TABLE_REF(((long) 3)), (variable_t) (global_880));
		  leave_function_170_tools_error();
		  return global_880;
	       }
	    }
	 }
      }
   }
}


obj_t 
_def_global_scnst__222_ast_glo_def_117(obj_t env_1509, obj_t id_1510, obj_t module_1511, obj_t node_1512, obj_t class_1513)
{
   {
      global_t aux_1804;
      aux_1804 = def_global_scnst__93_ast_glo_def_117(id_1510, module_1511, node_1512, class_1513);
      return (obj_t) (aux_1804);
   }
}


global_t 
def_global_svar__184_ast_glo_def_117(obj_t id_19, obj_t module_20, obj_t src_exp_176_21, obj_t rem_22)
{
   {
      obj_t id_type_89_885;
      id_type_89_885 = parse_id_241_ast_ident(id_19);
      {
	 obj_t id_id_127_886;
	 id_id_127_886 = CAR(id_type_89_885);
	 {
	    obj_t old_global_82_887;
	    {
	       obj_t list1492_901;
	       list1492_901 = MAKE_PAIR(module_20, BNIL);
	       old_global_82_887 = find_global_223_ast_env(id_id_127_886, list1492_901);
	    }
	    {
	       obj_t import_888;
	       {
		  bool_t test1491_900;
		  test1491_900 = is_a__118___object(old_global_82_887, global_ast_var);
		  if (test1491_900)
		    {
		       global_t obj_1409;
		       obj_1409 = (global_t) (old_global_82_887);
		       import_888 = (((global_t) CREF(obj_1409))->import);
		    }
		  else
		    {
		       import_888 = CNST_TABLE_REF(((long) 1));
		    }
	       }
	       {
		  obj_t type_889;
		  {
		     obj_t type_893;
		     type_893 = CDR(id_type_89_885);
		     {
			bool_t test_1817;
			{
			   obj_t aux_1821;
			   obj_t aux_1818;
			   aux_1821 = CNST_TABLE_REF(((long) 4));
			   {
			      type_t obj_1411;
			      obj_1411 = (type_t) (type_893);
			      aux_1818 = (((type_t) CREF(obj_1411))->class);
			   }
			   test_1817 = (aux_1818 == aux_1821);
			}
			if (test_1817)
			  {
			     type_889 = type_893;
			  }
			else
			  {
			     obj_t arg1487_896;
			     arg1487_896 = shape_tools_shape(type_893);
			     type_889 = user_error_151_tools_error(id_id_127_886, string1684_ast_glo_def_117, arg1487_896, BNIL);
			  }
		     }
		  }
		  {
		     global_t global_890;
		     {
			bool_t test1481_891;
			test1481_891 = is_a__118___object(old_global_82_887, global_ast_var);
			if (test1481_891)
			  {
			     global_890 = check_svar_definition_92_ast_glo_def_117(old_global_82_887, type_889, src_exp_176_21);
			  }
			else
			  {
			     global_890 = declare_global_svar__200_ast_glo_decl_237(id_19, module_20, CNST_TABLE_REF(((long) 1)), src_exp_176_21);
			  }
		     }
		     {
			{
			   variable_t var_1415;
			   type_t new_type_21_1416;
			   var_1415 = (variable_t) (global_890);
			   new_type_21_1416 = (type_t) (type_889);
			   {
			      bool_t test1519_1418;
			      {
				 obj_t obj2_1421;
				 obj2_1421 = _____74_type_cache;
				 {
				    obj_t aux_1833;
				    {
				       type_t aux_1834;
				       aux_1834 = (((variable_t) CREF(var_1415))->type);
				       aux_1833 = (obj_t) (aux_1834);
				    }
				    test1519_1418 = (aux_1833 == obj2_1421);
				 }
			      }
			      if (test1519_1418)
				{
				   obj_t res1673_1424;
				   {
				      obj_t x_1529;
				      x_1529 = ((((variable_t) CREF(var_1415))->type) = ((type_t) new_type_21_1416), BUNSPEC);
				      res1673_1424 = BUNSPEC;
				   }
				   res1673_1424;
				}
			      else
				{
				   BUNSPEC;
				}
			   }
			}
			remove_var_from__148_ast_remove(rem_22, (variable_t) (global_890));
			return global_890;
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_def_global_svar__252_ast_glo_def_117(obj_t env_1514, obj_t id_1515, obj_t module_1516, obj_t src_exp_176_1517, obj_t rem_1518)
{
   {
      global_t aux_1842;
      aux_1842 = def_global_svar__184_ast_glo_def_117(id_1515, module_1516, src_exp_176_1517, rem_1518);
      return (obj_t) (aux_1842);
   }
}


global_t 
check_svar_definition_92_ast_glo_def_117(obj_t old_23, obj_t type_24, obj_t src_exp_176_25)
{
   {
      bool_t test1494_904;
      {
	 obj_t aux_1845;
	 {
	    value_t aux_1846;
	    {
	       global_t obj_1425;
	       obj_1425 = (global_t) (old_23);
	       aux_1846 = (((global_t) CREF(obj_1425))->value);
	    }
	    aux_1845 = (obj_t) (aux_1846);
	 }
	 test1494_904 = is_a__118___object(aux_1845, svar_ast_var);
      }
      if (test1494_904)
	{
	   bool_t test1495_905;
	   {
	      type_t aux_1852;
	      {
		 global_t obj_1427;
		 obj_1427 = (global_t) (old_23);
		 aux_1852 = (((global_t) CREF(obj_1427))->type);
	      }
	      test1495_905 = compatible_type__151_ast_glo_def_117(((bool_t) 0), (type_t) (type_24), aux_1852);
	   }
	   if (test1495_905)
	     {
		return (global_t) (old_23);
	     }
	   else
	     {
		{
		   obj_t list1496_906;
		   list1496_906 = MAKE_PAIR(string1685_ast_glo_def_117, BNIL);
		   return mismatch_error_84_ast_glo_def_117((global_t) (old_23), src_exp_176_25, list1496_906);
		}
	     }
	}
      else
	{
	   return mismatch_error_84_ast_glo_def_117((global_t) (old_23), src_exp_176_25, BNIL);
	}
   }
}


bool_t 
compatible_type__151_ast_glo_def_117(bool_t sub__142_26, type_t new_27, type_t old_28)
{
   {
      bool_t _ortest_1305_911;
      {
	 obj_t obj2_1429;
	 obj2_1429 = _____74_type_cache;
	 {
	    obj_t aux_1864;
	    aux_1864 = (obj_t) (new_27);
	    _ortest_1305_911 = (aux_1864 == obj2_1429);
	 }
      }
      if (_ortest_1305_911)
	{
	   return _ortest_1305_911;
	}
      else
	{
	   bool_t _ortest_1306_912;
	   {
	      obj_t aux_1870;
	      obj_t aux_1868;
	      aux_1870 = (obj_t) (new_27);
	      aux_1868 = (obj_t) (old_28);
	      _ortest_1306_912 = (aux_1868 == aux_1870);
	   }
	   if (_ortest_1306_912)
	     {
		return _ortest_1306_912;
	     }
	   else
	     {
		if (sub__142_26)
		  {
		     bool_t _ortest_1308_914;
		     _ortest_1308_914 = type_subclass__90_object_class(new_27, old_28);
		     if (_ortest_1308_914)
		       {
			  return _ortest_1308_914;
		       }
		     else
		       {
			  bool_t _andtest_1309_915;
			  _andtest_1309_915 = is_a__118___object((obj_t) (new_27), class_object_class);
			  if (_andtest_1309_915)
			    {
			       obj_t obj2_1434;
			       obj2_1434 = __obj__252_type_cache;
			       {
				  obj_t aux_1880;
				  aux_1880 = (obj_t) (old_28);
				  return (aux_1880 == obj2_1434);
			       }
			    }
			  else
			    {
			       return ((bool_t) 0);
			    }
		       }
		  }
		else
		  {
		     return ((bool_t) 0);
		  }
	     }
	}
   }
}


global_t 
mismatch_error_84_ast_glo_def_117(global_t global_29, obj_t src_exp_176_30, obj_t add_msg_187_31)
{
   {
      obj_t arg1501_917;
      obj_t arg1505_918;
      if (PAIRP(add_msg_187_31))
	{
	   obj_t list1511_924;
	   {
	      obj_t arg1513_925;
	      {
		 obj_t arg1514_926;
		 {
		    obj_t aux_1885;
		    aux_1885 = CAR(add_msg_187_31);
		    arg1514_926 = MAKE_PAIR(aux_1885, BNIL);
		 }
		 arg1513_925 = MAKE_PAIR(string1675_ast_glo_def_117, arg1514_926);
	      }
	      list1511_924 = MAKE_PAIR(string1686_ast_glo_def_117, arg1513_925);
	   }
	   arg1501_917 = string_append_106___r4_strings_6_7(list1511_924);
	}
      else
	{
	   arg1501_917 = string1686_ast_glo_def_117;
	}
      arg1505_918 = shape_tools_shape((((global_t) CREF(global_29))->src));
      {
	 obj_t list1506_919;
	 {
	    obj_t aux_1893;
	    aux_1893 = (obj_t) (global_29);
	    list1506_919 = MAKE_PAIR(aux_1893, BNIL);
	 }
	 {
	    obj_t aux_1896;
	    aux_1896 = user_error_151_tools_error(arg1501_917, arg1505_918, src_exp_176_30, list1506_919);
	    return (global_t) (aux_1896);
	 }
      }
   }
}


bool_t 
check_method_definition_71_ast_glo_def_117(obj_t id_34, obj_t args_35, obj_t locals_36, obj_t src_37)
{
   {
      type_t type_res_48_931;
      obj_t method_id_209_932;
      obj_t generic_933;
      type_res_48_931 = type_of_id_183_ast_ident(id_34);
      method_id_209_932 = id_of_id_112_ast_ident(id_34);
      generic_933 = find_global_223_ast_env(id_34, BNIL);
      {
	 bool_t test1520_934;
	 test1520_934 = is_a__118___object(generic_933, global_ast_var);
	 if (test1520_934)
	   {
	      value_t generic_value_252_935;
	      {
		 global_t obj_1447;
		 obj_1447 = (global_t) (generic_933);
		 generic_value_252_935 = (((global_t) CREF(obj_1447))->value);
	      }
	      {
		 bool_t test1521_936;
		 test1521_936 = is_a__118___object((obj_t) (generic_value_252_935), sfun_ast_var);
		 if (test1521_936)
		   {
		      bool_t test_1909;
		      {
			 obj_t aux_1913;
			 obj_t aux_1910;
			 aux_1913 = CNST_TABLE_REF(((long) 2));
			 {
			    sfun_t obj_1449;
			    obj_1449 = (sfun_t) (generic_value_252_935);
			    aux_1910 = (((sfun_t) CREF(obj_1449))->class);
			 }
			 test_1909 = (aux_1910 == aux_1913);
		      }
		      if (test_1909)
			{
			   bool_t test1523_938;
			   {
			      long arg1561_982;
			      int arg1562_983;
			      {
				 sfun_t obj_1452;
				 obj_1452 = (sfun_t) (generic_value_252_935);
				 arg1561_982 = (((sfun_t) CREF(obj_1452))->arity);
			      }
			      arg1562_983 = arity_tools_args(args_35);
			      {
				 long aux_1919;
				 aux_1919 = (long) (arg1562_983);
				 test1523_938 = (arg1561_982 == aux_1919);
			      }
			   }
			   if (test1523_938)
			     {
				bool_t test1524_939;
				{
				   type_t aux_1923;
				   {
				      global_t obj_1455;
				      obj_1455 = (global_t) (generic_933);
				      aux_1923 = (((global_t) CREF(obj_1455))->type);
				   }
				   test1524_939 = compatible_type__151_ast_glo_def_117(((bool_t) 1), type_res_48_931, aux_1923);
				}
				if (test1524_939)
				  {
				     bool_t _ortest_1310_940;
				     {
					obj_t locals_941;
					obj_t types_942;
					bool_t sub__142_943;
					{
					   obj_t arg1526_945;
					   {
					      obj_t l1311_946;
					      {
						 sfun_t obj_1456;
						 obj_1456 = (sfun_t) (generic_value_252_935);
						 l1311_946 = (((sfun_t) CREF(obj_1456))->args);
					      }
					      if (NULLP(l1311_946))
						{
						   arg1526_945 = BNIL;
						}
					      else
						{
						   obj_t head1315_948;
						   head1315_948 = MAKE_PAIR(BNIL, BNIL);
						   {
						      obj_t l1311_949;
						      obj_t tail1316_950;
						      l1311_949 = l1311_946;
						      tail1316_950 = head1315_948;
						    lname1314_951:
						      if (NULLP(l1311_949))
							{
							   arg1526_945 = CDR(head1315_948);
							}
						      else
							{
							   obj_t new_tail1317_184_953;
							   {
							      obj_t arg1531_955;
							      {
								 obj_t a_957;
								 a_957 = CAR(l1311_949);
								 {
								    bool_t test1533_958;
								    test1533_958 = is_a__118___object(a_957, local_ast_var);
								    if (test1533_958)
								      {
									 {
									    local_t obj_1464;
									    obj_1464 = (local_t) (a_957);
									    {
									       type_t aux_1940;
									       aux_1940 = (((local_t) CREF(obj_1464))->type);
									       arg1531_955 = (obj_t) (aux_1940);
									    }
									 }
								      }
								    else
								      {
									 bool_t test1534_959;
									 test1534_959 = is_a__118___object(a_957, type_type_type);
									 if (test1534_959)
									   {
									      arg1531_955 = a_957;
									   }
									 else
									   {
									      {
										 obj_t arg1537_962;
										 arg1537_962 = shape_tools_shape(a_957);
										 arg1531_955 = internal_error_43_tools_error(string1677_ast_glo_def_117, string1678_ast_glo_def_117, arg1537_962);
									      }
									   }
								      }
								 }
							      }
							      new_tail1317_184_953 = MAKE_PAIR(arg1531_955, BNIL);
							   }
							   SET_CDR(tail1316_950, new_tail1317_184_953);
							   {
							      obj_t tail1316_1951;
							      obj_t l1311_1949;
							      l1311_1949 = CDR(l1311_949);
							      tail1316_1951 = new_tail1317_184_953;
							      tail1316_950 = tail1316_1951;
							      l1311_949 = l1311_1949;
							      goto lname1314_951;
							   }
							}
						   }
						}
					   }
					   locals_941 = locals_36;
					   types_942 = arg1526_945;
					   sub__142_943 = ((bool_t) 1);
					 loop_944:
					   if (NULLP(locals_941))
					     {
						_ortest_1310_940 = ((bool_t) 1);
					     }
					   else
					     {
						bool_t test1541_966;
						{
						   type_t aux_1959;
						   type_t aux_1954;
						   {
						      obj_t aux_1960;
						      aux_1960 = CAR(types_942);
						      aux_1959 = (type_t) (aux_1960);
						   }
						   {
						      local_t obj_1473;
						      {
							 obj_t aux_1955;
							 aux_1955 = CAR(locals_941);
							 obj_1473 = (local_t) (aux_1955);
						      }
						      aux_1954 = (((local_t) CREF(obj_1473))->type);
						   }
						   test1541_966 = compatible_type__151_ast_glo_def_117(sub__142_943, aux_1954, aux_1959);
						}
						if (test1541_966)
						  {
						     {
							bool_t sub__142_1969;
							obj_t types_1967;
							obj_t locals_1965;
							locals_1965 = CDR(locals_941);
							types_1967 = CDR(types_942);
							sub__142_1969 = ((bool_t) 0);
							sub__142_943 = sub__142_1969;
							types_942 = types_1967;
							locals_941 = locals_1965;
							goto loop_944;
						     }
						  }
						else
						  {
						     {
							obj_t list1544_969;
							list1544_969 = MAKE_PAIR(string1680_ast_glo_def_117, BNIL);
							mismatch_error_84_ast_glo_def_117((global_t) (generic_933), src_37, list1544_969);
						     }
						     _ortest_1310_940 = ((bool_t) 0);
						  }
					     }
					}
				     }
				     if (_ortest_1310_940)
				       {
					  return _ortest_1310_940;
				       }
				     else
				       {
					  return ((bool_t) 1);
				       }
				  }
				else
				  {
				     {
					obj_t list1553_975;
					list1553_975 = MAKE_PAIR(string1682_ast_glo_def_117, BNIL);
					mismatch_error_84_ast_glo_def_117((global_t) (generic_933), src_37, list1553_975);
				     }
				     return ((bool_t) 0);
				  }
			     }
			   else
			     {
				{
				   obj_t list1558_979;
				   list1558_979 = MAKE_PAIR(string1683_ast_glo_def_117, BNIL);
				   mismatch_error_84_ast_glo_def_117((global_t) (generic_933), src_37, list1558_979);
				}
				return ((bool_t) 0);
			     }
			}
		      else
			{
			   mismatch_error_84_ast_glo_def_117((global_t) (generic_933), src_37, BNIL);
			   return ((bool_t) 0);
			}
		   }
		 else
		   {
		      mismatch_error_84_ast_glo_def_117((global_t) (generic_933), src_37, BNIL);
		      return ((bool_t) 0);
		   }
	      }
	   }
	 else
	   {
	      return ((bool_t) 1);
	   }
      }
   }
}


obj_t 
_check_method_definition_40_ast_glo_def_117(obj_t env_1519, obj_t id_1520, obj_t args_1521, obj_t locals_1522, obj_t src_1523)
{
   {
      bool_t aux_1984;
      aux_1984 = check_method_definition_71_ast_glo_def_117(id_1520, args_1521, locals_1522, src_1523);
      return BBOOL(aux_1984);
   }
}


obj_t 
imported_modules_init_94_ast_glo_def_117()
{
   module_initialization_70_tools_trace(((long) 0), "AST_GLO-DEF");
   module_initialization_70_type_type(((long) 0), "AST_GLO-DEF");
   module_initialization_70_ast_var(((long) 0), "AST_GLO-DEF");
   module_initialization_70_ast_node(((long) 0), "AST_GLO-DEF");
   module_initialization_70_ast_env(((long) 0), "AST_GLO-DEF");
   module_initialization_70_ast_ident(((long) 0), "AST_GLO-DEF");
   module_initialization_70_ast_glo_decl_237(((long) 0), "AST_GLO-DEF");
   module_initialization_70_ast_remove(((long) 0), "AST_GLO-DEF");
   module_initialization_70_type_env(((long) 0), "AST_GLO-DEF");
   module_initialization_70_type_cache(((long) 0), "AST_GLO-DEF");
   module_initialization_70_tools_args(((long) 0), "AST_GLO-DEF");
   module_initialization_70_tools_error(((long) 0), "AST_GLO-DEF");
   module_initialization_70_tools_shape(((long) 0), "AST_GLO-DEF");
   module_initialization_70_tools_dsssl(((long) 0), "AST_GLO-DEF");
   return module_initialization_70_object_class(((long) 0), "AST_GLO-DEF");
}
