/*===========================================================================*/
/*   (Ast/labels.scm)                                                        */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t let_fun_218_ast_node;
extern obj_t _user_error_251_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t normalize_progn_143_tools_progn(obj_t);
extern obj_t last_pair_93___r4_pairs_and_lists_6_3(obj_t);
extern obj_t dsssl_args___args_list_201_tools_dsssl(obj_t);
static obj_t imported_modules_init_94_ast_labels();
extern obj_t module_initialization_70_ast_labels(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_dsssl(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___dsssl(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t make_dsssl_function_prelude_58___dsssl(obj_t, obj_t, obj_t, obj_t);
static obj_t cnst_init_137_ast_labels();
extern obj_t _labels__node_87_ast_labels(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_ast_labels = BUNSPEC;
static obj_t labels_binding_77_ast_labels(obj_t, obj_t, obj_t, obj_t);
static obj_t library_modules_init_112_ast_labels();
extern obj_t sfun_ast_var;
extern obj_t read___reader(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t);
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t enter_function_81_tools_error(obj_t);
extern int arity_tools_args(obj_t);
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern long class_num_218___object(obj_t);
static obj_t allocate_sfuns_248_ast_labels(obj_t, obj_t);
extern local_t make_local_sfun_184_ast_local(obj_t, type_t, sfun_t);
extern node_t error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _____74_type_cache;
extern obj_t __obj__252_type_cache;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
extern let_fun_218_t labels__node_197_ast_labels(obj_t, obj_t, obj_t, obj_t);
extern obj_t leave_function_170_tools_error();
static obj_t __cnst[2];

DEFINE_STRING(string1502_ast_labels, string1502_ast_labels1513, "Illegal `labels' expression", 27);
DEFINE_STRING(string1503_ast_labels, string1503_ast_labels1514, "Illegal formal type", 19);
DEFINE_STRING(string1506_ast_labels, string1506_ast_labels1515, "VALUE PLAIN ", 12);
DEFINE_STRING(string1505_ast_labels, string1505_ast_labels1516, "Illegal `labels' form", 21);
extern obj_t user_error_env_101_tools_error;
DEFINE_EXPORT_PROCEDURE(labels__node_env_244_ast_labels, _labels__node_87_ast_labels1517, _labels__node_87_ast_labels, 0L, 4);
DEFINE_STRING(string1504_ast_labels, string1504_ast_labels1518, "Illegal `binding' form", 22);

obj_t 
module_initialization_70_ast_labels(long checksum_1229, char *from_1230)
{
   if (CBOOL(require_initialization_114_ast_labels))
     {
	require_initialization_114_ast_labels = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_labels();
	cnst_init_137_ast_labels();
	imported_modules_init_94_ast_labels();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_labels()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_LABELS");
   module_initialization_70___dsssl(((long) 0), "AST_LABELS");
   module_initialization_70___reader(((long) 0), "AST_LABELS");
   module_initialization_70___object(((long) 0), "AST_LABELS");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_labels()
{
   {
      obj_t cnst_port_138_1221;
      cnst_port_138_1221 = open_input_string(string1506_ast_labels);
      {
	 long i_1222;
	 i_1222 = ((long) 1);
       loop_1223:
	 {
	    bool_t test1507_1224;
	    test1507_1224 = (i_1222 == ((long) -1));
	    if (test1507_1224)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1509_1225;
		    {
		       obj_t list1510_1226;
		       {
			  obj_t arg1511_1227;
			  arg1511_1227 = BNIL;
			  list1510_1226 = MAKE_PAIR(cnst_port_138_1221, arg1511_1227);
		       }
		       arg1509_1225 = read___reader(list1510_1226);
		    }
		    CNST_TABLE_SET(i_1222, arg1509_1225);
		 }
		 {
		    int aux_1228;
		    {
		       long aux_1247;
		       aux_1247 = (i_1222 - ((long) 1));
		       aux_1228 = (int) (aux_1247);
		    }
		    {
		       long i_1250;
		       i_1250 = (long) (aux_1228);
		       i_1222 = i_1250;
		       goto loop_1223;
		    }
		 }
	      }
	 }
      }
   }
}


let_fun_218_t 
labels__node_197_ast_labels(obj_t exp_1, obj_t stack_2, obj_t loc_3, obj_t site_4)
{
   {
      obj_t loc_640;
      loc_640 = find_location_loc_243_tools_location(exp_1, loc_3);
      {
	 obj_t bindings_641;
	 obj_t body_642;
	 if (PAIRP(exp_1))
	   {
	      obj_t cdr_128_145_647;
	      cdr_128_145_647 = CDR(exp_1);
	      if (PAIRP(cdr_128_145_647))
		{
		   obj_t car_131_9_649;
		   car_131_9_649 = CAR(cdr_128_145_647);
		   if (PAIRP(car_131_9_649))
		     {
			bindings_641 = car_131_9_649;
			body_642 = CDR(cdr_128_145_647);
			{
			   obj_t locals_652;
			   locals_652 = allocate_sfuns_248_ast_labels(bindings_641, loc_640);
			   {
			      obj_t new_stack_37_653;
			      new_stack_37_653 = append_2_18___r4_pairs_and_lists_6_3(locals_652, stack_2);
			      {
				 node_t body_654;
				 {
				    obj_t arg1305_665;
				    arg1305_665 = normalize_progn_143_tools_progn(body_642);
				    body_654 = sexp__node_235_ast_sexp(arg1305_665, new_stack_37_653, loc_640, site_4);
				 }
				 {
				    obj_t loc_655;
				    loc_655 = find_location_loc_243_tools_location(exp_1, loc_640);
				    {
				       {
					  obj_t ll1272_656;
					  obj_t ll1273_657;
					  ll1272_656 = locals_652;
					  ll1273_657 = bindings_641;
					lname1283_658:
					  if (NULLP(ll1272_656))
					    {
					       ((bool_t) 1);
					    }
					  else
					    {
					       labels_binding_77_ast_labels(CAR(ll1272_656), CAR(ll1273_657), new_stack_37_653, loc_655);
					       {
						  obj_t ll1273_1273;
						  obj_t ll1272_1271;
						  ll1272_1271 = CDR(ll1272_656);
						  ll1273_1273 = CDR(ll1273_657);
						  ll1273_657 = ll1273_1273;
						  ll1272_656 = ll1272_1271;
						  goto lname1283_658;
					       }
					    }
				       }
				       {
					  type_t arg1303_664;
					  arg1303_664 = (((node_t) CREF(body_654))->type);
					  {
					     let_fun_218_t res1495_1095;
					     {
						let_fun_218_t new1221_1086;
						new1221_1086 = ((let_fun_218_t) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
						{
						   long arg1403_1087;
						   arg1403_1087 = class_num_218___object(let_fun_218_ast_node);
						   {
						      obj_t obj_1093;
						      obj_1093 = (obj_t) (new1221_1086);
						      (((obj_t) CREF(obj_1093))->header = MAKE_HEADER(arg1403_1087, 0), BUNSPEC);
						   }
						}
						{
						   object_t aux_1280;
						   aux_1280 = (object_t) (new1221_1086);
						   OBJECT_WIDENING_SET(aux_1280, BFALSE);
						}
						((((let_fun_218_t) CREF(new1221_1086))->loc) = ((obj_t) loc_655), BUNSPEC);
						((((let_fun_218_t) CREF(new1221_1086))->type) = ((type_t) arg1303_664), BUNSPEC);
						((((let_fun_218_t) CREF(new1221_1086))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
						((((let_fun_218_t) CREF(new1221_1086))->locals) = ((obj_t) locals_652), BUNSPEC);
						((((let_fun_218_t) CREF(new1221_1086))->body) = ((node_t) body_654), BUNSPEC);
						res1495_1095 = new1221_1086;
					     }
					     return res1495_1095;
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		   else
		     {
			node_t aux_1289;
		      tag_121_151_644:
			aux_1289 = error_sexp__node_157_ast_sexp(string1502_ast_labels, exp_1, loc_640);
			return (let_fun_218_t) (aux_1289);
		     }
		}
	      else
		{
		   node_t aux_1292;
		   goto tag_121_151_644;
		   return (let_fun_218_t) (aux_1292);
		}
	   }
	 else
	   {
	      node_t aux_1294;
	      goto tag_121_151_644;
	      return (let_fun_218_t) (aux_1294);
	   }
      }
   }
}


obj_t 
_labels__node_87_ast_labels(obj_t env_1210, obj_t exp_1211, obj_t stack_1212, obj_t loc_1213, obj_t site_1214)
{
   {
      let_fun_218_t aux_1296;
      aux_1296 = labels__node_197_ast_labels(exp_1211, stack_1212, loc_1213, site_1214);
      return (obj_t) (aux_1296);
   }
}


obj_t 
allocate_sfuns_248_ast_labels(obj_t bindings_5, obj_t loc_6)
{
   {
      obj_t bindings_666;
      obj_t res_667;
      bindings_666 = bindings_5;
      res_667 = BNIL;
    loop_668:
      if (NULLP(bindings_666))
	{
	   return reverse__39___r4_pairs_and_lists_6_3(res_667);
	}
      else
	{
	   obj_t fun_671;
	   obj_t args_672;
	   {
	      obj_t e_139_15_675;
	      e_139_15_675 = CAR(bindings_666);
	      if (PAIRP(e_139_15_675))
		{
		   obj_t car_144_227_677;
		   obj_t cdr_145_238_678;
		   car_144_227_677 = CAR(e_139_15_675);
		   cdr_145_238_678 = CDR(e_139_15_675);
		   if (SYMBOLP(car_144_227_677))
		     {
			if (PAIRP(cdr_145_238_678))
			  {
			     fun_671 = car_144_227_677;
			     args_672 = CAR(cdr_145_238_678);
			     {
				obj_t id_type_89_682;
				id_type_89_682 = parse_id_241_ast_ident(fun_671);
				{
				   obj_t id_683;
				   id_683 = CAR(id_type_89_682);
				   {
				      obj_t type_684;
				      type_684 = CDR(id_type_89_682);
				      {
					 int arity_685;
					 arity_685 = arity_tools_args(args_672);
					 {
					    obj_t formals_686;
					    {
					       obj_t l1284_720;
					       l1284_720 = dsssl_args___args_list_201_tools_dsssl(args_672);
					       if (NULLP(l1284_720))
						 {
						    formals_686 = BNIL;
						 }
					       else
						 {
						    obj_t head1286_722;
						    {
						       obj_t arg1347_733;
						       arg1347_733 = parse_id_241_ast_ident(CAR(l1284_720));
						       head1286_722 = MAKE_PAIR(arg1347_733, BNIL);
						    }
						    {
						       obj_t l1284_723;
						       obj_t tail1287_724;
						       l1284_723 = CDR(l1284_720);
						       tail1287_724 = head1286_722;
						     lname1285_725:
						       if (NULLP(l1284_723))
							 {
							    formals_686 = head1286_722;
							 }
						       else
							 {
							    obj_t new_tail1288_50_728;
							    {
							       obj_t arg1343_730;
							       arg1343_730 = parse_id_241_ast_ident(CAR(l1284_723));
							       new_tail1288_50_728 = MAKE_PAIR(arg1343_730, BNIL);
							    }
							    SET_CDR(tail1287_724, new_tail1288_50_728);
							    {
							       obj_t tail1287_1329;
							       obj_t l1284_1327;
							       l1284_1327 = CDR(l1284_723);
							       tail1287_1329 = new_tail1288_50_728;
							       tail1287_724 = tail1287_1329;
							       l1284_723 = l1284_1327;
							       goto lname1285_725;
							    }
							 }
						    }
						 }
					    }
					    {
					       {
						  bool_t test1313_687;
						  {
						     bool_t test_1331;
						     {
							long aux_1332;
							aux_1332 = (long) (arity_685);
							test_1331 = (aux_1332 >= ((long) 0));
						     }
						     if (test_1331)
						       {
							  test1313_687 = ((bool_t) 1);
						       }
						     else
						       {
							  obj_t larg_715;
							  {
							     obj_t aux_1335;
							     aux_1335 = last_pair_93___r4_pairs_and_lists_6_3(formals_686);
							     larg_715 = CAR(aux_1335);
							  }
							  {
							     obj_t type_716;
							     type_716 = CDR(larg_715);
							     {
								{
								   bool_t test1335_717;
								   {
								      obj_t obj2_1123;
								      obj2_1123 = __obj__252_type_cache;
								      test1335_717 = (type_716 == obj2_1123);
								   }
								   if (test1335_717)
								     {
									test1313_687 = ((bool_t) 1);
								     }
								   else
								     {
									bool_t test1336_718;
									{
									   obj_t obj2_1125;
									   obj2_1125 = _____74_type_cache;
									   test1336_718 = (type_716 == obj2_1125);
									}
									if (test1336_718)
									  {
									     {
										obj_t obj_1127;
										obj_1127 = __obj__252_type_cache;
										SET_CDR(larg_715, obj_1127);
									     }
									     test1313_687 = ((bool_t) 1);
									  }
									else
									  {
									     test1313_687 = ((bool_t) 0);
									  }
								     }
								}
							     }
							  }
						       }
						  }
						  if (test1313_687)
						    {
						       obj_t args_688;
						       if (NULLP(formals_686))
							 {
							    args_688 = BNIL;
							 }
						       else
							 {
							    obj_t head1291_698;
							    head1291_698 = MAKE_PAIR(BNIL, BNIL);
							    {
							       obj_t l1289_699;
							       obj_t tail1292_700;
							       l1289_699 = formals_686;
							       tail1292_700 = head1291_698;
							     lname1290_701:
							       if (NULLP(l1289_699))
								 {
								    args_688 = CDR(head1291_698);
								 }
							       else
								 {
								    obj_t new_tail1293_138_703;
								    {
								       local_t arg1323_705;
								       {
									  obj_t f_707;
									  f_707 = CAR(l1289_699);
									  {
									     type_t aux_1352;
									     {
										obj_t aux_1354;
										aux_1354 = CDR(f_707);
										aux_1352 = (type_t) (aux_1354);
									     }
									     arg1323_705 = make_local_svar_140_ast_local(CAR(f_707), aux_1352);
									  }
								       }
								       {
									  obj_t aux_1358;
									  aux_1358 = (obj_t) (arg1323_705);
									  new_tail1293_138_703 = MAKE_PAIR(aux_1358, BNIL);
								       }
								    }
								    SET_CDR(tail1292_700, new_tail1293_138_703);
								    {
								       obj_t tail1292_1364;
								       obj_t l1289_1362;
								       l1289_1362 = CDR(l1289_699);
								       tail1292_1364 = new_tail1293_138_703;
								       tail1292_700 = tail1292_1364;
								       l1289_699 = l1289_1362;
								       goto lname1290_701;
								    }
								 }
							    }
							 }
						       {
							  sfun_t sfun_689;
							  {
							     obj_t arg1318_694;
							     arg1318_694 = CNST_TABLE_REF(((long) 0));
							     {
								sfun_t res1496_1167;
								{
								   long arity_1141;
								   obj_t predicate_of_78_1143;
								   obj_t stack_allocator_172_1144;
								   arity_1141 = (long) (arity_685);
								   predicate_of_78_1143 = BFALSE;
								   stack_allocator_172_1144 = BFALSE;
								   {
								      sfun_t new1068_1152;
								      new1068_1152 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
								      {
									 long arg1476_1153;
									 arg1476_1153 = class_num_218___object(sfun_ast_var);
									 {
									    obj_t obj_1165;
									    obj_1165 = (obj_t) (new1068_1152);
									    (((obj_t) CREF(obj_1165))->header = MAKE_HEADER(arg1476_1153, 0), BUNSPEC);
									 }
								      }
								      {
									 object_t aux_1371;
									 aux_1371 = (object_t) (new1068_1152);
									 OBJECT_WIDENING_SET(aux_1371, predicate_of_78_1143);
								      }
								      ((((sfun_t) CREF(new1068_1152))->arity) = ((long) arity_1141), BUNSPEC);
								      ((((sfun_t) CREF(new1068_1152))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
								      ((((sfun_t) CREF(new1068_1152))->predicate_of_78) = ((obj_t) predicate_of_78_1143), BUNSPEC);
								      ((((sfun_t) CREF(new1068_1152))->stack_allocator_172) = ((obj_t) stack_allocator_172_1144), BUNSPEC);
								      ((((sfun_t) CREF(new1068_1152))->top__138) = ((bool_t) ((bool_t) 1)), BUNSPEC);
								      ((((sfun_t) CREF(new1068_1152))->the_closure_238) = ((obj_t) BUNSPEC), BUNSPEC);
								      ((((sfun_t) CREF(new1068_1152))->property) = ((obj_t) BNIL), BUNSPEC);
								      ((((sfun_t) CREF(new1068_1152))->args) = ((obj_t) args_688), BUNSPEC);
								      ((((sfun_t) CREF(new1068_1152))->body) = ((obj_t) BUNSPEC), BUNSPEC);
								      ((((sfun_t) CREF(new1068_1152))->class) = ((obj_t) arg1318_694), BUNSPEC);
								      ((((sfun_t) CREF(new1068_1152))->dsssl_keywords_243) = ((obj_t) BNIL), BUNSPEC);
								      res1496_1167 = new1068_1152;
								   }
								}
								sfun_689 = res1496_1167;
							     }
							  }
							  {
							     local_t fun_690;
							     fun_690 = make_local_sfun_184_ast_local(id_683, (type_t) (type_684), sfun_689);
							     {
								{
								   obj_t arg1314_691;
								   obj_t arg1315_692;
								   arg1314_691 = CDR(bindings_666);
								   {
								      obj_t aux_1388;
								      aux_1388 = (obj_t) (fun_690);
								      arg1315_692 = MAKE_PAIR(aux_1388, res_667);
								   }
								   {
								      obj_t res_1392;
								      obj_t bindings_1391;
								      bindings_1391 = arg1314_691;
								      res_1392 = arg1315_692;
								      res_667 = res_1392;
								      bindings_666 = bindings_1391;
								      goto loop_668;
								   }
								}
							     }
							  }
						       }
						    }
						  else
						    {
						       error_sexp__node_157_ast_sexp(string1503_ast_labels, CAR(bindings_666), loc_6);
						       return BNIL;
						    }
					       }
					    }
					 }
				      }
				   }
				}
			     }
			  }
			else
			  {
			   tag_138_212_674:
			     error_sexp__node_157_ast_sexp(string1504_ast_labels, CAR(bindings_666), loc_6);
			     return BNIL;
			  }
		     }
		   else
		     {
			goto tag_138_212_674;
		     }
		}
	      else
		{
		   goto tag_138_212_674;
		}
	   }
	}
   }
}


obj_t 
labels_binding_77_ast_labels(obj_t local_7, obj_t binding_8, obj_t stack_9, obj_t loc_10)
{
   {
      obj_t args_738;
      obj_t body_739;
      if (PAIRP(binding_8))
	{
	   obj_t cdr_161_14_744;
	   cdr_161_14_744 = CDR(binding_8);
	   if (PAIRP(cdr_161_14_744))
	     {
		args_738 = CAR(cdr_161_14_744);
		body_739 = CDR(cdr_161_14_744);
		{
		   obj_t aux_1403;
		   {
		      local_t obj_1178;
		      obj_1178 = (local_t) (local_7);
		      aux_1403 = (((local_t) CREF(obj_1178))->id);
		   }
		   enter_function_81_tools_error(aux_1403);
		}
		{
		   node_t body_749;
		   {
		      obj_t arg1361_751;
		      obj_t arg1363_752;
		      obj_t arg1364_753;
		      obj_t arg1366_754;
		      {
			 obj_t arg1367_755;
			 obj_t arg1369_756;
			 {
			    local_t obj_1179;
			    obj_1179 = (local_t) (local_7);
			    arg1367_755 = (((local_t) CREF(obj_1179))->id);
			 }
			 arg1369_756 = normalize_progn_143_tools_progn(body_739);
			 arg1361_751 = make_dsssl_function_prelude_58___dsssl(arg1367_755, args_738, arg1369_756, user_error_env_101_tools_error);
		      }
		      {
			 obj_t aux_1411;
			 {
			    sfun_t obj_1181;
			    {
			       value_t aux_1412;
			       {
				  local_t obj_1180;
				  obj_1180 = (local_t) (local_7);
				  aux_1412 = (((local_t) CREF(obj_1180))->value);
			       }
			       obj_1181 = (sfun_t) (aux_1412);
			    }
			    aux_1411 = (((sfun_t) CREF(obj_1181))->args);
			 }
			 arg1363_752 = append_2_18___r4_pairs_and_lists_6_3(aux_1411, stack_9);
		      }
		      arg1364_753 = find_location_loc_243_tools_location(binding_8, loc_10);
		      arg1366_754 = CNST_TABLE_REF(((long) 1));
		      body_749 = sexp__node_235_ast_sexp(arg1361_751, arg1363_752, arg1364_753, arg1366_754);
		   }
		   {
		      obj_t res1497_1185;
		      {
			 sfun_t obj_1183;
			 obj_t val1077_1184;
			 {
			    value_t aux_1421;
			    {
			       local_t obj_1182;
			       obj_1182 = (local_t) (local_7);
			       aux_1421 = (((local_t) CREF(obj_1182))->value);
			    }
			    obj_1183 = (sfun_t) (aux_1421);
			 }
			 val1077_1184 = (obj_t) (body_749);
			 {
			    obj_t x_1220;
			    x_1220 = ((((sfun_t) CREF(obj_1183))->body) = ((obj_t) val1077_1184), BUNSPEC);
			    res1497_1185 = BUNSPEC;
			 }
		      }
		      res1497_1185;
		   }
		   return leave_function_170_tools_error();
		}
	     }
	   else
	     {
		node_t aux_1430;
	      tag_154_0_741:
		aux_1430 = error_sexp__node_157_ast_sexp(string1505_ast_labels, binding_8, loc_10);
		return (obj_t) (aux_1430);
	     }
	}
      else
	{
	   node_t aux_1433;
	   goto tag_154_0_741;
	   return (obj_t) (aux_1433);
	}
   }
}


obj_t 
imported_modules_init_94_ast_labels()
{
   module_initialization_70_type_type(((long) 0), "AST_LABELS");
   module_initialization_70_ast_var(((long) 0), "AST_LABELS");
   module_initialization_70_ast_node(((long) 0), "AST_LABELS");
   module_initialization_70_tools_trace(((long) 0), "AST_LABELS");
   module_initialization_70_tools_error(((long) 0), "AST_LABELS");
   module_initialization_70_tools_progn(((long) 0), "AST_LABELS");
   module_initialization_70_tools_args(((long) 0), "AST_LABELS");
   module_initialization_70_tools_location(((long) 0), "AST_LABELS");
   module_initialization_70_tools_dsssl(((long) 0), "AST_LABELS");
   module_initialization_70_type_cache(((long) 0), "AST_LABELS");
   module_initialization_70_ast_sexp(((long) 0), "AST_LABELS");
   module_initialization_70_ast_ident(((long) 0), "AST_LABELS");
   return module_initialization_70_ast_local(((long) 0), "AST_LABELS");
}
