/*===========================================================================*/
/*   (Ast/let.scm)                                                           */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


static let_fun_218_t let__labels_169_ast_let(obj_t, node_t, obj_t);
extern obj_t __procedure__226_type_cache;
extern obj_t let_fun_218_ast_node;
extern local_t clone_local_230_ast_local(local_t, value_t);
extern obj_t sequence_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
static let_var_6_t make_generic_let_111_ast_let(obj_t, obj_t, obj_t, obj_t);
extern obj_t normalize_progn_143_tools_progn(obj_t);
static obj_t imported_modules_init_94_ast_let();
extern obj_t module_initialization_70_ast_let(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_substitute(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern node_t let__node_121_ast_let(obj_t, obj_t, obj_t, obj_t);
static obj_t cnst_init_137_ast_let();
static obj_t make_smart_generic_let_237_ast_let(obj_t, let_var_6_t, obj_t);
static obj_t require_initialization_114_ast_let = BUNSPEC;
extern obj_t var_ast_node;
static obj_t library_modules_init_112_ast_let();
extern node_t substitute__30_ast_substitute(obj_t, obj_t, node_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t);
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t __unspec__87_type_cache;
extern long class_num_218___object(obj_t);
extern node_t error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _____74_type_cache;
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t use_variable__4_ast_sexp(variable_t, obj_t, obj_t);
extern obj_t __obj__252_type_cache;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
static let_var_6_t let_or_letrec_20_ast_let(obj_t, let_var_6_t);
extern obj_t _let__node_205_ast_let(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[4];

DEFINE_STRING(string1635_ast_let, string1635_ast_let1643, "SET! WRITE LET VALUE ", 21);
DEFINE_STRING(string1633_ast_let, string1633_ast_let1644, "' form", 6);
DEFINE_EXPORT_PROCEDURE(let__node_env_100_ast_let, _let__node_205_ast_let1645, _let__node_205_ast_let, 0L, 4);
DEFINE_STRING(string1634_ast_let, string1634_ast_let1646, "Illegal form `", 14);

obj_t 
module_initialization_70_ast_let(long checksum_1572, char *from_1573)
{
   if (CBOOL(require_initialization_114_ast_let))
     {
	require_initialization_114_ast_let = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_let();
	cnst_init_137_ast_let();
	imported_modules_init_94_ast_let();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_let()
{
   module_initialization_70___object(((long) 0), "AST_LET");
   module_initialization_70___reader(((long) 0), "AST_LET");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_LET");
   module_initialization_70___r4_strings_6_7(((long) 0), "AST_LET");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_let()
{
   {
      obj_t cnst_port_138_1564;
      cnst_port_138_1564 = open_input_string(string1635_ast_let);
      {
	 long i_1565;
	 i_1565 = ((long) 3);
       loop_1566:
	 {
	    bool_t test1636_1567;
	    test1636_1567 = (i_1565 == ((long) -1));
	    if (test1636_1567)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1637_1568;
		    {
		       obj_t list1638_1569;
		       {
			  obj_t arg1641_1570;
			  arg1641_1570 = BNIL;
			  list1638_1569 = MAKE_PAIR(cnst_port_138_1564, arg1641_1570);
		       }
		       arg1637_1568 = read___reader(list1638_1569);
		    }
		    CNST_TABLE_SET(i_1565, arg1637_1568);
		 }
		 {
		    int aux_1571;
		    {
		       long aux_1590;
		       aux_1590 = (i_1565 - ((long) 1));
		       aux_1571 = (int) (aux_1590);
		    }
		    {
		       long i_1593;
		       i_1593 = (long) (aux_1571);
		       i_1565 = i_1593;
		       goto loop_1566;
		    }
		 }
	      }
	 }
      }
   }
}


node_t 
let__node_121_ast_let(obj_t exp_1, obj_t stack_2, obj_t loc_3, obj_t site_4)
{
   {
      obj_t loc_646;
      loc_646 = find_location_loc_243_tools_location(exp_1, loc_3);
      {
	 obj_t bindings_649;
	 obj_t body_647;
	 if (PAIRP(exp_1))
	   {
	      obj_t cdr_128_145_654;
	      cdr_128_145_654 = CDR(exp_1);
	      if (PAIRP(cdr_128_145_654))
		{
		   bool_t test_1601;
		   {
		      obj_t aux_1602;
		      aux_1602 = CAR(cdr_128_145_654);
		      test_1601 = (aux_1602 == BNIL);
		   }
		   if (test_1601)
		     {
			let_var_6_t aux_1605;
			body_647 = CDR(cdr_128_145_654);
			{
			   node_t body_662;
			   {
			      obj_t arg1316_665;
			      arg1316_665 = normalize_progn_143_tools_progn(body_647);
			      body_662 = sexp__node_235_ast_sexp(arg1316_665, stack_2, loc_646, site_4);
			   }
			   {
			      type_t arg1314_663;
			      arg1314_663 = (((node_t) CREF(body_662))->type);
			      {
				 let_var_6_t res1620_1235;
				 {
				    let_var_6_t new1229_1225;
				    new1229_1225 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
				    {
				       long arg1542_1226;
				       arg1542_1226 = class_num_218___object(let_var_6_ast_node);
				       {
					  obj_t obj_1233;
					  obj_1233 = (obj_t) (new1229_1225);
					  (((obj_t) CREF(obj_1233))->header = MAKE_HEADER(arg1542_1226, 0), BUNSPEC);
				       }
				    }
				    {
				       object_t aux_1613;
				       aux_1613 = (object_t) (new1229_1225);
				       OBJECT_WIDENING_SET(aux_1613, BFALSE);
				    }
				    ((((let_var_6_t) CREF(new1229_1225))->loc) = ((obj_t) loc_646), BUNSPEC);
				    ((((let_var_6_t) CREF(new1229_1225))->type) = ((type_t) arg1314_663), BUNSPEC);
				    ((((let_var_6_t) CREF(new1229_1225))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
				    ((((let_var_6_t) CREF(new1229_1225))->bindings) = ((obj_t) BNIL), BUNSPEC);
				    ((((let_var_6_t) CREF(new1229_1225))->body) = ((node_t) body_662), BUNSPEC);
				    ((((let_var_6_t) CREF(new1229_1225))->removable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				    res1620_1235 = new1229_1225;
				 }
				 aux_1605 = res1620_1235;
			      }
			   }
			}
			return (node_t) (aux_1605);
		     }
		   else
		     {
			obj_t aux_1624;
			bindings_649 = CAR(cdr_128_145_654);
			{
			   bool_t test_1625;
			   {
			      bool_t test_1626;
			      if (PAIRP(bindings_649))
				{
				   test_1626 = ((bool_t) 1);
				}
			      else
				{
				   test_1626 = NULLP(bindings_649);
				}
			      if (test_1626)
				{
				   obj_t bindings_679;
				   bindings_679 = bindings_649;
				 loop_680:
				   if (NULLP(bindings_679))
				     {
					test_1625 = ((bool_t) 0);
				     }
				   else
				     {
					obj_t binding_682;
					binding_682 = CAR(bindings_679);
					{
					   if (PAIRP(binding_682))
					     {
						obj_t cdr_149_75_687;
						cdr_149_75_687 = CDR(binding_682);
						if (PAIRP(cdr_149_75_687))
						  {
						     bool_t test_1638;
						     {
							obj_t aux_1639;
							aux_1639 = CDR(cdr_149_75_687);
							test_1638 = (aux_1639 == BNIL);
						     }
						     if (test_1638)
						       {
							  {
							     obj_t bindings_1642;
							     bindings_1642 = CDR(bindings_679);
							     bindings_679 = bindings_1642;
							     goto loop_680;
							  }
						       }
						     else
						       {
							  test_1625 = ((bool_t) 1);
						       }
						  }
						else
						  {
						     test_1625 = ((bool_t) 1);
						  }
					     }
					   else
					     {
						test_1625 = ((bool_t) 1);
					     }
					}
				     }
				}
			      else
				{
				   test_1625 = ((bool_t) 1);
				}
			   }
			   if (test_1625)
			     {
				obj_t arg1318_667;
				{
				   obj_t arg1320_669;
				   {
				      obj_t aux_1644;
				      aux_1644 = CAR(exp_1);
				      arg1320_669 = SYMBOL_TO_STRING(aux_1644);
				   }
				   {
				      obj_t list1322_671;
				      {
					 obj_t arg1323_672;
					 {
					    obj_t arg1325_673;
					    arg1325_673 = MAKE_PAIR(string1633_ast_let, BNIL);
					    arg1323_672 = MAKE_PAIR(arg1320_669, arg1325_673);
					 }
					 list1322_671 = MAKE_PAIR(string1634_ast_let, arg1323_672);
				      }
				      arg1318_667 = string_append_106___r4_strings_6_7(list1322_671);
				   }
				}
				{
				   node_t aux_1651;
				   aux_1651 = error_sexp__node_157_ast_sexp(arg1318_667, exp_1, loc_646);
				   aux_1624 = (obj_t) (aux_1651);
				}
			     }
			   else
			     {
				obj_t arg1329_676;
				let_var_6_t arg1331_677;
				arg1329_676 = CAR(exp_1);
				arg1331_677 = make_generic_let_111_ast_let(exp_1, stack_2, loc_646, site_4);
				aux_1624 = make_smart_generic_let_237_ast_let(arg1329_676, arg1331_677, site_4);
			     }
			}
			return (node_t) (aux_1624);
		     }
		}
	      else
		{
		 tag_122_225_651:
		   {
		      obj_t arg1342_694;
		      {
			 obj_t arg1345_696;
			 {
			    obj_t aux_1659;
			    aux_1659 = CAR(exp_1);
			    arg1345_696 = SYMBOL_TO_STRING(aux_1659);
			 }
			 {
			    obj_t list1347_698;
			    {
			       obj_t arg1349_699;
			       {
				  obj_t arg1350_700;
				  arg1350_700 = MAKE_PAIR(string1633_ast_let, BNIL);
				  arg1349_699 = MAKE_PAIR(arg1345_696, arg1350_700);
			       }
			       list1347_698 = MAKE_PAIR(string1634_ast_let, arg1349_699);
			    }
			    arg1342_694 = string_append_106___r4_strings_6_7(list1347_698);
			 }
		      }
		      return error_sexp__node_157_ast_sexp(arg1342_694, exp_1, loc_646);
		   }
		}
	   }
	 else
	   {
	      goto tag_122_225_651;
	   }
      }
   }
}


obj_t 
_let__node_205_ast_let(obj_t env_1553, obj_t exp_1554, obj_t stack_1555, obj_t loc_1556, obj_t site_1557)
{
   {
      node_t aux_1667;
      aux_1667 = let__node_121_ast_let(exp_1554, stack_1555, loc_1556, site_1557);
      return (obj_t) (aux_1667);
   }
}


let_var_6_t 
make_generic_let_111_ast_let(obj_t exp_5, obj_t stack_6, obj_t loc_7, obj_t site_8)
{
   {
      obj_t bindings_703;
      {
	 obj_t aux_1670;
	 aux_1670 = CDR(exp_5);
	 bindings_703 = CAR(aux_1670);
      }
      {
	 obj_t body_704;
	 {
	    obj_t aux_1673;
	    {
	       obj_t aux_1674;
	       aux_1674 = CDR(exp_5);
	       aux_1673 = CDR(aux_1674);
	    }
	    body_704 = normalize_progn_143_tools_progn(aux_1673);
	 }
	 {
	    obj_t frame_705;
	    if (NULLP(bindings_703))
	      {
		 frame_705 = BNIL;
	      }
	    else
	      {
		 obj_t head1284_739;
		 head1284_739 = MAKE_PAIR(BNIL, BNIL);
		 {
		    obj_t l1272_740;
		    obj_t tail1285_741;
		    l1272_740 = bindings_703;
		    tail1285_741 = head1284_739;
		  lname1283_742:
		    if (NULLP(l1272_740))
		      {
			 frame_705 = CDR(head1284_739);
		      }
		    else
		      {
			 obj_t new_tail1286_4_744;
			 {
			    local_t arg1385_746;
			    {
			       obj_t var_id_112_749;
			       {
				  obj_t aux_1684;
				  {
				     obj_t aux_1685;
				     aux_1685 = CAR(l1272_740);
				     aux_1684 = CAR(aux_1685);
				  }
				  var_id_112_749 = parse_id_241_ast_ident(aux_1684);
			       }
			       {
				  {
				     type_t aux_1689;
				     {
					obj_t aux_1691;
					aux_1691 = CDR(var_id_112_749);
					aux_1689 = (type_t) (aux_1691);
				     }
				     arg1385_746 = make_local_svar_140_ast_local(CAR(var_id_112_749), aux_1689);
				  }
			       }
			    }
			    {
			       obj_t aux_1695;
			       aux_1695 = (obj_t) (arg1385_746);
			       new_tail1286_4_744 = MAKE_PAIR(aux_1695, BNIL);
			    }
			 }
			 SET_CDR(tail1285_741, new_tail1286_4_744);
			 {
			    obj_t tail1285_1701;
			    obj_t l1272_1699;
			    l1272_1699 = CDR(l1272_740);
			    tail1285_1701 = new_tail1286_4_744;
			    tail1285_741 = tail1285_1701;
			    l1272_740 = l1272_1699;
			    goto lname1283_742;
			 }
		      }
		 }
	      }
	    {
	       obj_t new_stack_37_706;
	       new_stack_37_706 = append_2_18___r4_pairs_and_lists_6_3(frame_705, stack_6);
	       {
		  {
		     node_t body_707;
		     body_707 = sexp__node_235_ast_sexp(body_704, new_stack_37_706, loc_7, CNST_TABLE_REF(((long) 0)));
		     {
			obj_t bstack_708;
			{
			   bool_t test_1705;
			   {
			      obj_t aux_1708;
			      obj_t aux_1706;
			      aux_1708 = CNST_TABLE_REF(((long) 1));
			      aux_1706 = CAR(exp_5);
			      test_1705 = (aux_1706 == aux_1708);
			   }
			   if (test_1705)
			     {
				bstack_708 = stack_6;
			     }
			   else
			     {
				bstack_708 = new_stack_37_706;
			     }
			}
			{
			   obj_t bindings_709;
			   if (NULLP(bindings_703))
			     {
				bindings_709 = BNIL;
			     }
			   else
			     {
				obj_t head1289_713;
				head1289_713 = MAKE_PAIR(BNIL, BNIL);
				{
				   obj_t ll1287_714;
				   obj_t ll1288_715;
				   obj_t tail1290_716;
				   ll1287_714 = bindings_703;
				   ll1288_715 = frame_705;
				   tail1290_716 = head1289_713;
				 lname1292_717:
				   if (NULLP(ll1287_714))
				     {
					bindings_709 = CDR(head1289_713);
				     }
				   else
				     {
					obj_t new_tail1291_125_719;
					{
					   obj_t arg1358_722;
					   {
					      obj_t binding_724;
					      obj_t var_725;
					      binding_724 = CAR(ll1287_714);
					      var_725 = CAR(ll1288_715);
					      {
						 node_t arg1361_726;
						 {
						    obj_t arg1363_727;
						    obj_t arg1364_728;
						    obj_t arg1366_729;
						    arg1363_727 = normalize_progn_143_tools_progn(CDR(binding_724));
						    arg1364_728 = find_location_loc_243_tools_location(binding_724, loc_7);
						    arg1366_729 = CNST_TABLE_REF(((long) 0));
						    arg1361_726 = sexp__node_235_ast_sexp(arg1363_727, bstack_708, arg1364_728, arg1366_729);
						 }
						 {
						    obj_t aux_1724;
						    aux_1724 = (obj_t) (arg1361_726);
						    arg1358_722 = MAKE_PAIR(var_725, aux_1724);
						 }
					      }
					   }
					   new_tail1291_125_719 = MAKE_PAIR(arg1358_722, BNIL);
					}
					SET_CDR(tail1290_716, new_tail1291_125_719);
					{
					   obj_t tail1290_1733;
					   obj_t ll1288_1731;
					   obj_t ll1287_1729;
					   ll1287_1729 = CDR(ll1287_714);
					   ll1288_1731 = CDR(ll1288_715);
					   tail1290_1733 = new_tail1291_125_719;
					   tail1290_716 = tail1290_1733;
					   ll1288_715 = ll1288_1731;
					   ll1287_714 = ll1287_1729;
					   goto lname1292_717;
					}
				     }
				}
			     }
			   {
			      {
				 let_var_6_t res1621_1309;
				 {
				    type_t type_1294;
				    type_1294 = (type_t) (_____74_type_cache);
				    {
				       let_var_6_t new1229_1299;
				       new1229_1299 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
				       {
					  long arg1542_1300;
					  arg1542_1300 = class_num_218___object(let_var_6_ast_node);
					  {
					     obj_t obj_1307;
					     obj_1307 = (obj_t) (new1229_1299);
					     (((obj_t) CREF(obj_1307))->header = MAKE_HEADER(arg1542_1300, 0), BUNSPEC);
					  }
				       }
				       {
					  object_t aux_1739;
					  aux_1739 = (object_t) (new1229_1299);
					  OBJECT_WIDENING_SET(aux_1739, BFALSE);
				       }
				       ((((let_var_6_t) CREF(new1229_1299))->loc) = ((obj_t) loc_7), BUNSPEC);
				       ((((let_var_6_t) CREF(new1229_1299))->type) = ((type_t) type_1294), BUNSPEC);
				       ((((let_var_6_t) CREF(new1229_1299))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
				       ((((let_var_6_t) CREF(new1229_1299))->bindings) = ((obj_t) bindings_709), BUNSPEC);
				       ((((let_var_6_t) CREF(new1229_1299))->body) = ((node_t) body_707), BUNSPEC);
				       ((((let_var_6_t) CREF(new1229_1299))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				       res1621_1309 = new1229_1299;
				    }
				 }
				 return res1621_1309;
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
make_smart_generic_let_237_ast_let(obj_t let_letrec_14_9, let_var_6_t node_let_193_10, obj_t site_11)
{
   {
      obj_t bindings_756;
      obj_t fun_757;
      obj_t value_758;
      bindings_756 = (((let_var_6_t) CREF(node_let_193_10))->bindings);
      fun_757 = BNIL;
      value_758 = BNIL;
    loop_759:
      if (NULLP(bindings_756))
	{
	   if (NULLP(fun_757))
	     {
		{
		   let_var_6_t aux_1752;
		   aux_1752 = let_or_letrec_20_ast_let(let_letrec_14_9, node_let_193_10);
		   return (obj_t) (aux_1752);
		}
	     }
	   else
	     {
		if (NULLP(value_758))
		  {
		     {
			let_fun_218_t aux_1757;
			aux_1757 = let__labels_169_ast_let(fun_757, (((let_var_6_t) CREF(node_let_193_10))->body), site_11);
			return (obj_t) (aux_1757);
		     }
		  }
		else
		  {
		     {
			obj_t arg1410_767;
			arg1410_767 = reverse__39___r4_pairs_and_lists_6_3(value_758);
			{
			   obj_t res1622_1317;
			   {
			      obj_t x_1558;
			      x_1558 = ((((let_var_6_t) CREF(node_let_193_10))->bindings) = ((obj_t) arg1410_767), BUNSPEC);
			      res1622_1317 = BUNSPEC;
			   }
			   res1622_1317;
			}
		     }
		     {
			let_var_6_t let_768;
			let_768 = let_or_letrec_20_ast_let(let_letrec_14_9, node_let_193_10);
			{
			   let_fun_218_t arg1411_769;
			   arg1411_769 = let__labels_169_ast_let(fun_757, (((let_var_6_t) CREF(let_768))->body), site_11);
			   {
			      obj_t res1623_1321;
			      {
				 node_t val1234_1320;
				 val1234_1320 = (node_t) (arg1411_769);
				 {
				    obj_t x_1559;
				    x_1559 = ((((let_var_6_t) CREF(let_768))->body) = ((node_t) val1234_1320), BUNSPEC);
				    res1623_1321 = BUNSPEC;
				 }
			      }
			      res1623_1321;
			   }
			}
			return (obj_t) (let_768);
		     }
		  }
	     }
	}
      else
	{
	   obj_t binding_771;
	   binding_771 = CAR(bindings_756);
	   {
	      obj_t var_772;
	      var_772 = CAR(binding_771);
	      {
		 obj_t sexp_773;
		 sexp_773 = CDR(binding_771);
		 {
		    {
		       bool_t test1413_774;
		       test1413_774 = is_a__118___object(sexp_773, let_fun_218_ast_node);
		       if (test1413_774)
			 {
			    obj_t locals_775;
			    {
			       let_fun_218_t obj_1326;
			       obj_1326 = (let_fun_218_t) (sexp_773);
			       locals_775 = (((let_fun_218_t) CREF(obj_1326))->locals);
			    }
			    {
			       node_t body_776;
			       {
				  let_fun_218_t obj_1327;
				  obj_1327 = (let_fun_218_t) (sexp_773);
				  body_776 = (((let_fun_218_t) CREF(obj_1327))->body);
			       }
			       {
				  {
				     bool_t test_1778;
				     if (NULLP(locals_775))
				       {
					  test_1778 = ((bool_t) 1);
				       }
				     else
				       {
					  bool_t test_1781;
					  {
					     obj_t aux_1782;
					     aux_1782 = CDR(locals_775);
					     test_1781 = NULLP(aux_1782);
					  }
					  if (test_1781)
					    {
					       test_1778 = ((bool_t) 0);
					    }
					  else
					    {
					       test_1778 = ((bool_t) 1);
					    }
				       }
				     if (test_1778)
				       {
					  obj_t arg1415_778;
					  obj_t arg1416_779;
					  arg1415_778 = CDR(bindings_756);
					  arg1416_779 = MAKE_PAIR(binding_771, value_758);
					  {
					     obj_t value_1788;
					     obj_t bindings_1787;
					     bindings_1787 = arg1415_778;
					     value_1788 = arg1416_779;
					     value_758 = value_1788;
					     bindings_756 = bindings_1787;
					     goto loop_759;
					  }
				       }
				     else
				       {
					  bool_t test1418_781;
					  test1418_781 = is_a__118___object((obj_t) (body_776), var_ast_node);
					  if (test1418_781)
					    {
					       bool_t test1419_784;
					       {
						  bool_t test_1792;
						  {
						     obj_t aux_1798;
						     obj_t aux_1793;
						     aux_1798 = CAR(locals_775);
						     {
							variable_t aux_1794;
							{
							   var_t obj_1336;
							   obj_1336 = (var_t) (body_776);
							   aux_1794 = (((var_t) CREF(obj_1336))->variable);
							}
							aux_1793 = (obj_t) (aux_1794);
						     }
						     test_1792 = (aux_1793 == aux_1798);
						  }
						  if (test_1792)
						    {
						       bool_t test_1801;
						       {
							  obj_t aux_1805;
							  obj_t aux_1802;
							  aux_1805 = CNST_TABLE_REF(((long) 2));
							  {
							     local_t obj_1340;
							     obj_1340 = (local_t) (var_772);
							     aux_1802 = (((local_t) CREF(obj_1340))->access);
							  }
							  test_1801 = (aux_1802 == aux_1805);
						       }
						       if (test_1801)
							 {
							    test1419_784 = ((bool_t) 1);
							 }
						       else
							 {
							    bool_t test1431_793;
							    {
							       bool_t test1432_794;
							       {
								  obj_t obj2_1345;
								  obj2_1345 = __procedure__226_type_cache;
								  {
								     obj_t aux_1808;
								     {
									type_t aux_1809;
									{
									   local_t obj_1343;
									   obj_1343 = (local_t) (var_772);
									   aux_1809 = (((local_t) CREF(obj_1343))->type);
									}
									aux_1808 = (obj_t) (aux_1809);
								     }
								     test1432_794 = (aux_1808 == obj2_1345);
								  }
							       }
							       if (test1432_794)
								 {
								    test1431_793 = ((bool_t) 1);
								 }
							       else
								 {
								    bool_t test1433_795;
								    {
								       obj_t obj2_1348;
								       obj2_1348 = _____74_type_cache;
								       {
									  obj_t aux_1815;
									  {
									     type_t aux_1816;
									     {
										local_t obj_1346;
										obj_1346 = (local_t) (var_772);
										aux_1816 = (((local_t) CREF(obj_1346))->type);
									     }
									     aux_1815 = (obj_t) (aux_1816);
									  }
									  test1433_795 = (aux_1815 == obj2_1348);
								       }
								    }
								    if (test1433_795)
								      {
									 test1431_793 = ((bool_t) 1);
								      }
								    else
								      {
									 obj_t obj2_1351;
									 obj2_1351 = __obj__252_type_cache;
									 {
									    obj_t aux_1822;
									    {
									       type_t aux_1823;
									       {
										  local_t obj_1349;
										  obj_1349 = (local_t) (var_772);
										  aux_1823 = (((local_t) CREF(obj_1349))->type);
									       }
									       aux_1822 = (obj_t) (aux_1823);
									    }
									    test1431_793 = (aux_1822 == obj2_1351);
									 }
								      }
								 }
							    }
							    if (test1431_793)
							      {
								 test1419_784 = ((bool_t) 0);
							      }
							    else
							      {
								 test1419_784 = ((bool_t) 1);
							      }
							 }
						    }
						  else
						    {
						       test1419_784 = ((bool_t) 1);
						    }
					       }
					       if (test1419_784)
						 {
						    obj_t arg1420_785;
						    obj_t arg1421_786;
						    arg1420_785 = CDR(bindings_756);
						    arg1421_786 = MAKE_PAIR(binding_771, value_758);
						    {
						       obj_t value_1833;
						       obj_t bindings_1832;
						       bindings_1832 = arg1420_785;
						       value_1833 = arg1421_786;
						       value_758 = value_1833;
						       bindings_756 = bindings_1832;
						       goto loop_759;
						    }
						 }
					       else
						 {
						    obj_t arg1426_788;
						    obj_t arg1427_789;
						    arg1426_788 = CDR(bindings_756);
						    arg1427_789 = MAKE_PAIR(binding_771, fun_757);
						    {
						       obj_t fun_1837;
						       obj_t bindings_1836;
						       bindings_1836 = arg1426_788;
						       fun_1837 = arg1427_789;
						       fun_757 = fun_1837;
						       bindings_756 = bindings_1836;
						       goto loop_759;
						    }
						 }
					    }
					  else
					    {
					       obj_t arg1447_801;
					       obj_t arg1448_802;
					       arg1447_801 = CDR(bindings_756);
					       arg1448_802 = MAKE_PAIR(binding_771, value_758);
					       {
						  obj_t value_1841;
						  obj_t bindings_1840;
						  bindings_1840 = arg1447_801;
						  value_1841 = arg1448_802;
						  value_758 = value_1841;
						  bindings_756 = bindings_1840;
						  goto loop_759;
					       }
					    }
				       }
				  }
			       }
			    }
			 }
		       else
			 {
			    obj_t arg1453_807;
			    obj_t arg1454_808;
			    arg1453_807 = CDR(bindings_756);
			    arg1454_808 = MAKE_PAIR(binding_771, value_758);
			    {
			       obj_t value_1845;
			       obj_t bindings_1844;
			       bindings_1844 = arg1453_807;
			       value_1845 = arg1454_808;
			       value_758 = value_1845;
			       bindings_756 = bindings_1844;
			       goto loop_759;
			    }
			 }
		    }
		 }
	      }
	   }
	}
   }
}


let_var_6_t 
let_or_letrec_20_ast_let(obj_t let_letrec_14_12, let_var_6_t node_let_193_13)
{
   {
      bool_t test_1847;
      {
	 obj_t aux_1848;
	 aux_1848 = CNST_TABLE_REF(((long) 1));
	 test_1847 = (let_letrec_14_12 == aux_1848);
      }
      if (test_1847)
	{
	   return node_let_193_13;
	}
      else
	{
	   obj_t bindings_811;
	   bindings_811 = (((let_var_6_t) CREF(node_let_193_13))->bindings);
	   {
	      node_t body_812;
	      body_812 = (((let_var_6_t) CREF(node_let_193_13))->body);
	      {
		 obj_t seq_813;
		 {
		    bool_t test1475_833;
		    test1475_833 = is_a__118___object((obj_t) (body_812), sequence_ast_node);
		    if (test1475_833)
		      {
			 seq_813 = (obj_t) (body_812);
		      }
		    else
		      {
			 obj_t arg1476_834;
			 obj_t arg1477_835;
			 arg1476_834 = (((node_t) CREF(body_812))->loc);
			 {
			    obj_t list1478_836;
			    {
			       obj_t aux_1858;
			       aux_1858 = (obj_t) (body_812);
			       list1478_836 = MAKE_PAIR(aux_1858, BNIL);
			    }
			    arg1477_835 = list1478_836;
			 }
			 {
			    sequence_t res1624_1387;
			    {
			       type_t type_1376;
			       type_1376 = (type_t) (_____74_type_cache);
			       {
				  sequence_t new1145_1379;
				  new1145_1379 = ((sequence_t) BREF(GC_MALLOC(sizeof(struct sequence))));
				  {
				     long arg1571_1380;
				     arg1571_1380 = class_num_218___object(sequence_ast_node);
				     {
					obj_t obj_1385;
					obj_1385 = (obj_t) (new1145_1379);
					(((obj_t) CREF(obj_1385))->header = MAKE_HEADER(arg1571_1380, 0), BUNSPEC);
				     }
				  }
				  {
				     object_t aux_1866;
				     aux_1866 = (object_t) (new1145_1379);
				     OBJECT_WIDENING_SET(aux_1866, BFALSE);
				  }
				  ((((sequence_t) CREF(new1145_1379))->loc) = ((obj_t) arg1476_834), BUNSPEC);
				  ((((sequence_t) CREF(new1145_1379))->type) = ((type_t) type_1376), BUNSPEC);
				  ((((sequence_t) CREF(new1145_1379))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
				  ((((sequence_t) CREF(new1145_1379))->nodes) = ((obj_t) arg1477_835), BUNSPEC);
				  res1624_1387 = new1145_1379;
			       }
			    }
			    seq_813 = (obj_t) (res1624_1387);
			 }
		      }
		 }
		 {
		    {
		       obj_t res1625_1390;
		       {
			  node_t val1234_1389;
			  val1234_1389 = (node_t) (seq_813);
			  {
			     obj_t x_1560;
			     x_1560 = ((((let_var_6_t) CREF(node_let_193_13))->body) = ((node_t) val1234_1389), BUNSPEC);
			     res1625_1390 = BUNSPEC;
			  }
		       }
		       res1625_1390;
		    }
		    {
		       obj_t bindings_814;
		       obj_t nsequence_815;
		       bindings_814 = bindings_811;
		       {
			  sequence_t obj_1391;
			  obj_1391 = (sequence_t) (seq_813);
			  nsequence_815 = (((sequence_t) CREF(obj_1391))->nodes);
		       }
		     loop_816:
		       if (NULLP(bindings_814))
			 {
			    {
			       sequence_t arg1463_819;
			       {
				  obj_t arg1465_820;
				  {
				     node_t obj_1393;
				     obj_1393 = (node_t) (seq_813);
				     arg1465_820 = (((node_t) CREF(obj_1393))->loc);
				  }
				  {
				     sequence_t res1626_1406;
				     {
					type_t type_1395;
					type_1395 = (type_t) (_____74_type_cache);
					{
					   sequence_t new1145_1398;
					   new1145_1398 = ((sequence_t) BREF(GC_MALLOC(sizeof(struct sequence))));
					   {
					      long arg1571_1399;
					      arg1571_1399 = class_num_218___object(sequence_ast_node);
					      {
						 obj_t obj_1404;
						 obj_1404 = (obj_t) (new1145_1398);
						 (((obj_t) CREF(obj_1404))->header = MAKE_HEADER(arg1571_1399, 0), BUNSPEC);
					      }
					   }
					   {
					      object_t aux_1885;
					      aux_1885 = (object_t) (new1145_1398);
					      OBJECT_WIDENING_SET(aux_1885, BFALSE);
					   }
					   ((((sequence_t) CREF(new1145_1398))->loc) = ((obj_t) arg1465_820), BUNSPEC);
					   ((((sequence_t) CREF(new1145_1398))->type) = ((type_t) type_1395), BUNSPEC);
					   ((((sequence_t) CREF(new1145_1398))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
					   ((((sequence_t) CREF(new1145_1398))->nodes) = ((obj_t) nsequence_815), BUNSPEC);
					   res1626_1406 = new1145_1398;
					}
				     }
				     arg1463_819 = res1626_1406;
				  }
			       }
			       {
				  obj_t res1627_1409;
				  {
				     node_t val1234_1408;
				     val1234_1408 = (node_t) (arg1463_819);
				     {
					obj_t x_1561;
					x_1561 = ((((let_var_6_t) CREF(node_let_193_13))->body) = ((node_t) val1234_1408), BUNSPEC);
					res1627_1409 = BUNSPEC;
				     }
				  }
				  res1627_1409;
			       }
			    }
			    return node_let_193_13;
			 }
		       else
			 {
			    obj_t binding_821;
			    binding_821 = CAR(bindings_814);
			    {
			       obj_t var_822;
			       var_822 = CAR(binding_821);
			       {
				  obj_t val_823;
				  val_823 = CDR(binding_821);
				  {
				     obj_t loc_824;
				     {
					node_t obj_1413;
					obj_1413 = (node_t) (val_823);
					loc_824 = (((node_t) CREF(obj_1413))->loc);
				     }
				     {
					{
					   setq_t init_825;
					   {
					      var_t arg1474_832;
					      {
						 var_t res1628_1424;
						 {
						    type_t type_1415;
						    variable_t variable_1416;
						    type_1415 = (type_t) (_____74_type_cache);
						    variable_1416 = (variable_t) (var_822);
						    {
						       var_t new1128_1417;
						       new1128_1417 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
						       {
							  long arg1577_1418;
							  arg1577_1418 = class_num_218___object(var_ast_node);
							  {
							     obj_t obj_1422;
							     obj_1422 = (obj_t) (new1128_1417);
							     (((obj_t) CREF(obj_1422))->header = MAKE_HEADER(arg1577_1418, 0), BUNSPEC);
							  }
						       }
						       {
							  object_t aux_1905;
							  aux_1905 = (object_t) (new1128_1417);
							  OBJECT_WIDENING_SET(aux_1905, BFALSE);
						       }
						       ((((var_t) CREF(new1128_1417))->loc) = ((obj_t) loc_824), BUNSPEC);
						       ((((var_t) CREF(new1128_1417))->type) = ((type_t) type_1415), BUNSPEC);
						       ((((var_t) CREF(new1128_1417))->variable) = ((variable_t) variable_1416), BUNSPEC);
						       res1628_1424 = new1128_1417;
						    }
						 }
						 arg1474_832 = res1628_1424;
					      }
					      {
						 setq_t res1629_1437;
						 {
						    type_t type_1426;
						    node_t value_1428;
						    type_1426 = (type_t) (__unspec__87_type_cache);
						    value_1428 = (node_t) (val_823);
						    {
						       setq_t new1188_1429;
						       new1188_1429 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
						       {
							  long arg1557_1430;
							  arg1557_1430 = class_num_218___object(setq_ast_node);
							  {
							     obj_t obj_1435;
							     obj_1435 = (obj_t) (new1188_1429);
							     (((obj_t) CREF(obj_1435))->header = MAKE_HEADER(arg1557_1430, 0), BUNSPEC);
							  }
						       }
						       {
							  object_t aux_1917;
							  aux_1917 = (object_t) (new1188_1429);
							  OBJECT_WIDENING_SET(aux_1917, BFALSE);
						       }
						       ((((setq_t) CREF(new1188_1429))->loc) = ((obj_t) loc_824), BUNSPEC);
						       ((((setq_t) CREF(new1188_1429))->type) = ((type_t) type_1426), BUNSPEC);
						       ((((setq_t) CREF(new1188_1429))->var) = ((var_t) arg1474_832), BUNSPEC);
						       ((((setq_t) CREF(new1188_1429))->value) = ((node_t) value_1428), BUNSPEC);
						       res1629_1437 = new1188_1429;
						    }
						 }
						 init_825 = res1629_1437;
					      }
					   }
					   use_variable__4_ast_sexp((variable_t) (var_822), loc_824, CNST_TABLE_REF(((long) 3)));
					   {
					      node_t arg1467_827;
					      arg1467_827 = sexp__node_235_ast_sexp(BUNSPEC, BNIL, loc_824, CNST_TABLE_REF(((long) 0)));
					      {
						 obj_t aux_1929;
						 aux_1929 = (obj_t) (arg1467_827);
						 SET_CDR(binding_821, aux_1929);
					      }
					   }
					   {
					      obj_t arg1471_830;
					      obj_t arg1472_831;
					      arg1471_830 = CDR(bindings_814);
					      {
						 obj_t aux_1933;
						 aux_1933 = (obj_t) (init_825);
						 arg1472_831 = MAKE_PAIR(aux_1933, nsequence_815);
					      }
					      {
						 obj_t nsequence_1937;
						 obj_t bindings_1936;
						 bindings_1936 = arg1471_830;
						 nsequence_1937 = arg1472_831;
						 nsequence_815 = nsequence_1937;
						 bindings_814 = bindings_1936;
						 goto loop_816;
					      }
					   }
					}
				     }
				  }
			       }
			    }
			 }
		    }
		 }
	      }
	   }
	}
   }
}


let_fun_218_t 
let__labels_169_ast_let(obj_t value_bindings_254_14, node_t node_15, obj_t site_16)
{
   {
      obj_t old_funs_44_839;
      obj_t new_funs_1_840;
      if (NULLP(value_bindings_254_14))
	{
	   old_funs_44_839 = BNIL;
	}
      else
	{
	   obj_t head1295_864;
	   {
	      obj_t aux_1942;
	      {
		 obj_t aux_1943;
		 aux_1943 = CAR(value_bindings_254_14);
		 aux_1942 = CAR(aux_1943);
	      }
	      head1295_864 = MAKE_PAIR(aux_1942, BNIL);
	   }
	   {
	      obj_t l1293_865;
	      obj_t tail1296_866;
	      l1293_865 = CDR(value_bindings_254_14);
	      tail1296_866 = head1295_864;
	    lname1294_867:
	      if (NULLP(l1293_865))
		{
		   old_funs_44_839 = head1295_864;
		}
	      else
		{
		   obj_t new_tail1297_27_870;
		   {
		      obj_t aux_1949;
		      {
			 obj_t aux_1950;
			 aux_1950 = CAR(l1293_865);
			 aux_1949 = CAR(aux_1950);
		      }
		      new_tail1297_27_870 = MAKE_PAIR(aux_1949, BNIL);
		   }
		   SET_CDR(tail1296_866, new_tail1297_27_870);
		   {
		      obj_t tail1296_1957;
		      obj_t l1293_1955;
		      l1293_1955 = CDR(l1293_865);
		      tail1296_1957 = new_tail1297_27_870;
		      tail1296_866 = tail1296_1957;
		      l1293_865 = l1293_1955;
		      goto lname1294_867;
		   }
		}
	   }
	}
      if (NULLP(value_bindings_254_14))
	{
	   new_funs_1_840 = BNIL;
	}
      else
	{
	   obj_t head1302_880;
	   head1302_880 = MAKE_PAIR(BNIL, BNIL);
	   {
	      obj_t l1298_881;
	      obj_t tail1303_882;
	      l1298_881 = value_bindings_254_14;
	      tail1303_882 = head1302_880;
	    lname1301_883:
	      if (NULLP(l1298_881))
		{
		   new_funs_1_840 = CDR(head1302_880);
		}
	      else
		{
		   obj_t new_tail1304_1_885;
		   {
		      local_t arg1517_887;
		      {
			 obj_t binding_889;
			 binding_889 = CAR(l1298_881);
			 {
			    obj_t aux_892;
			    {
			       obj_t aux_1966;
			       {
				  let_fun_218_t obj_1465;
				  {
				     obj_t aux_1967;
				     aux_1967 = CDR(binding_889);
				     obj_1465 = (let_fun_218_t) (aux_1967);
				  }
				  aux_1966 = (((let_fun_218_t) CREF(obj_1465))->locals);
			       }
			       aux_892 = CAR(aux_1966);
			    }
			    {
			       local_t new_893;
			       {
				  value_t aux_1976;
				  local_t aux_1972;
				  {
				     local_t obj_1467;
				     obj_1467 = (local_t) (aux_892);
				     aux_1976 = (((local_t) CREF(obj_1467))->value);
				  }
				  {
				     obj_t aux_1973;
				     aux_1973 = CAR(binding_889);
				     aux_1972 = (local_t) (aux_1973);
				  }
				  new_893 = clone_local_230_ast_local(aux_1972, aux_1976);
			       }
			       {
				  {
				     type_t arg1520_894;
				     {
					local_t obj_1468;
					obj_1468 = (local_t) (aux_892);
					arg1520_894 = (((local_t) CREF(obj_1468))->type);
				     }
				     {
					obj_t res1630_1471;
					{
					   obj_t x_1562;
					   x_1562 = ((((local_t) CREF(new_893))->type) = ((type_t) arg1520_894), BUNSPEC);
					   res1630_1471 = BUNSPEC;
					}
					res1630_1471;
				     }
				  }
				  arg1517_887 = new_893;
			       }
			    }
			 }
		      }
		      {
			 obj_t aux_1983;
			 aux_1983 = (obj_t) (arg1517_887);
			 new_tail1304_1_885 = MAKE_PAIR(aux_1983, BNIL);
		      }
		   }
		   SET_CDR(tail1303_882, new_tail1304_1_885);
		   {
		      obj_t tail1303_1989;
		      obj_t l1298_1987;
		      l1298_1987 = CDR(l1298_881);
		      tail1303_1989 = new_tail1304_1_885;
		      tail1303_882 = tail1303_1989;
		      l1298_881 = l1298_1987;
		      goto lname1301_883;
		   }
		}
	   }
	}
      {
	 obj_t vbindings_841;
	 obj_t nvars_842;
	 vbindings_841 = value_bindings_254_14;
	 nvars_842 = new_funs_1_840;
       loop_843:
	 if (NULLP(vbindings_841))
	   {
	      node_t body_845;
	      body_845 = substitute__30_ast_substitute(old_funs_44_839, new_funs_1_840, node_15, site_16);
	      {
		 obj_t arg1484_846;
		 type_t arg1485_847;
		 obj_t arg1486_848;
		 arg1484_846 = (((node_t) CREF(node_15))->loc);
		 arg1485_847 = (((node_t) CREF(node_15))->type);
		 arg1486_848 = reverse__39___r4_pairs_and_lists_6_3(new_funs_1_840);
		 {
		    let_fun_218_t res1631_1494;
		    {
		       let_fun_218_t new1221_1485;
		       new1221_1485 = ((let_fun_218_t) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
		       {
			  long arg1547_1486;
			  arg1547_1486 = class_num_218___object(let_fun_218_ast_node);
			  {
			     obj_t obj_1492;
			     obj_1492 = (obj_t) (new1221_1485);
			     (((obj_t) CREF(obj_1492))->header = MAKE_HEADER(arg1547_1486, 0), BUNSPEC);
			  }
		       }
		       {
			  object_t aux_2000;
			  aux_2000 = (object_t) (new1221_1485);
			  OBJECT_WIDENING_SET(aux_2000, BFALSE);
		       }
		       ((((let_fun_218_t) CREF(new1221_1485))->loc) = ((obj_t) arg1484_846), BUNSPEC);
		       ((((let_fun_218_t) CREF(new1221_1485))->type) = ((type_t) arg1485_847), BUNSPEC);
		       ((((let_fun_218_t) CREF(new1221_1485))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		       ((((let_fun_218_t) CREF(new1221_1485))->locals) = ((obj_t) arg1486_848), BUNSPEC);
		       ((((let_fun_218_t) CREF(new1221_1485))->body) = ((node_t) body_845), BUNSPEC);
		       res1631_1494 = new1221_1485;
		    }
		    return res1631_1494;
		 }
	      }
	   }
	 else
	   {
	      obj_t nvar_850;
	      nvar_850 = CAR(nvars_842);
	      {
		 value_t sfun_851;
		 {
		    local_t obj_1497;
		    obj_1497 = (local_t) (nvar_850);
		    sfun_851 = (((local_t) CREF(obj_1497))->value);
		 }
		 {
		    obj_t body_852;
		    {
		       sfun_t obj_1498;
		       obj_1498 = (sfun_t) (sfun_851);
		       body_852 = (((sfun_t) CREF(obj_1498))->body);
		    }
		    {
		       {
			  node_t arg1487_855;
			  {
			     obj_t arg1489_856;
			     obj_t arg1490_857;
			     obj_t arg1493_858;
			     {
				obj_t aux_2013;
				{
				   obj_t aux_2014;
				   {
				      let_fun_218_t obj_1500;
				      {
					 obj_t aux_2015;
					 {
					    obj_t aux_2016;
					    aux_2016 = CAR(vbindings_841);
					    aux_2015 = CDR(aux_2016);
					 }
					 obj_1500 = (let_fun_218_t) (aux_2015);
				      }
				      aux_2014 = (((let_fun_218_t) CREF(obj_1500))->locals);
				   }
				   aux_2013 = CAR(aux_2014);
				}
				arg1489_856 = MAKE_PAIR(aux_2013, old_funs_44_839);
			     }
			     arg1490_857 = MAKE_PAIR(nvar_850, new_funs_1_840);
			     arg1493_858 = CNST_TABLE_REF(((long) 0));
			     arg1487_855 = substitute__30_ast_substitute(arg1489_856, arg1490_857, (node_t) (body_852), arg1493_858);
			  }
			  {
			     obj_t res1632_1508;
			     {
				sfun_t obj_1506;
				obj_t val1077_1507;
				obj_1506 = (sfun_t) (sfun_851);
				val1077_1507 = (obj_t) (arg1487_855);
				{
				   obj_t x_1563;
				   x_1563 = ((((sfun_t) CREF(obj_1506))->body) = ((obj_t) val1077_1507), BUNSPEC);
				   res1632_1508 = BUNSPEC;
				}
			     }
			     res1632_1508;
			  }
		       }
		       {
			  obj_t nvars_2032;
			  obj_t vbindings_2030;
			  vbindings_2030 = CDR(vbindings_841);
			  nvars_2032 = CDR(nvars_842);
			  nvars_842 = nvars_2032;
			  vbindings_841 = vbindings_2030;
			  goto loop_843;
		       }
		    }
		 }
	      }
	   }
      }
   }
}


obj_t 
imported_modules_init_94_ast_let()
{
   module_initialization_70_type_type(((long) 0), "AST_LET");
   module_initialization_70_ast_var(((long) 0), "AST_LET");
   module_initialization_70_ast_node(((long) 0), "AST_LET");
   module_initialization_70_tools_trace(((long) 0), "AST_LET");
   module_initialization_70_type_cache(((long) 0), "AST_LET");
   module_initialization_70_tools_progn(((long) 0), "AST_LET");
   module_initialization_70_tools_shape(((long) 0), "AST_LET");
   module_initialization_70_tools_location(((long) 0), "AST_LET");
   module_initialization_70_ast_ident(((long) 0), "AST_LET");
   module_initialization_70_ast_sexp(((long) 0), "AST_LET");
   module_initialization_70_ast_local(((long) 0), "AST_LET");
   return module_initialization_70_ast_substitute(((long) 0), "AST_LET");
}
