/*===========================================================================*/
/*   (Ast/local.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


extern local_t make_local_sexit_184_ast_local(obj_t, type_t, sexit_t);
extern local_t clone_local_230_ast_local(local_t, value_t);
static obj_t imported_modules_init_94_ast_local();
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t toplevel_init_63_ast_local();
static obj_t cnst_init_137_ast_local();
static obj_t require_initialization_114_ast_local = BUNSPEC;
static obj_t library_modules_init_112_ast_local();
static local_t make_new_local_222_ast_local(obj_t, type_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t _make_local_svar_141_ast_local(obj_t, obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t _make_local_sfun_99_ast_local(obj_t, obj_t, obj_t, obj_t);
extern local_t make_local_sfun_184_ast_local(obj_t, type_t, sfun_t);
static long __local_key__223_ast_local;
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern obj_t svar_ast_var;
extern obj_t id__name_228_ast_ident(obj_t);
extern obj_t _make_local_sexit_250_ast_local(obj_t, obj_t, obj_t, obj_t);
extern obj_t local_ast_var;
static long get_new_key_51_ast_local();
extern obj_t _clone_local_106_ast_local(obj_t, obj_t, obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
static obj_t __cnst[2];

DEFINE_STRING(string1262_ast_local, string1262_ast_local1269, "NOW READ ", 9);
DEFINE_EXPORT_PROCEDURE(make_local_sexit_env_161_ast_local, _make_local_sexit_250_ast_local1270, _make_local_sexit_250_ast_local, 0L, 3);
DEFINE_STRING(string1261_ast_local, string1261_ast_local1271, "_", 1);
DEFINE_EXPORT_PROCEDURE(make_local_svar_env_143_ast_local, _make_local_svar_141_ast_local1272, _make_local_svar_141_ast_local, 0L, 2);
DEFINE_EXPORT_PROCEDURE(clone_local_env_253_ast_local, _clone_local_106_ast_local1273, _clone_local_106_ast_local, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_local_sfun_env_161_ast_local, _make_local_sfun_99_ast_local1274, _make_local_sfun_99_ast_local, 0L, 3);

obj_t 
module_initialization_70_ast_local(long checksum_547, char *from_548)
{
   if (CBOOL(require_initialization_114_ast_local))
     {
	require_initialization_114_ast_local = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_local();
	cnst_init_137_ast_local();
	imported_modules_init_94_ast_local();
	toplevel_init_63_ast_local();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_local()
{
   module_initialization_70___reader(((long) 0), "AST_LOCAL");
   module_initialization_70___object(((long) 0), "AST_LOCAL");
   module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "AST_LOCAL");
   module_initialization_70___r4_strings_6_7(((long) 0), "AST_LOCAL");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_local()
{
   {
      obj_t cnst_port_138_539;
      cnst_port_138_539 = open_input_string(string1262_ast_local);
      {
	 long i_540;
	 i_540 = ((long) 1);
       loop_541:
	 {
	    bool_t test1263_542;
	    test1263_542 = (i_540 == ((long) -1));
	    if (test1263_542)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1265_543;
		    {
		       obj_t list1266_544;
		       {
			  obj_t arg1267_545;
			  arg1267_545 = BNIL;
			  list1266_544 = MAKE_PAIR(cnst_port_138_539, arg1267_545);
		       }
		       arg1265_543 = read___reader(list1266_544);
		    }
		    CNST_TABLE_SET(i_540, arg1265_543);
		 }
		 {
		    int aux_546;
		    {
		       long aux_566;
		       aux_566 = (i_540 - ((long) 1));
		       aux_546 = (int) (aux_566);
		    }
		    {
		       long i_569;
		       i_569 = (long) (aux_546);
		       i_540 = i_569;
		       goto loop_541;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_local()
{
   return (__local_key__223_ast_local = ((long) 0),
      BUNSPEC);
}


long 
get_new_key_51_ast_local()
{
   {
      long z1_447;
      z1_447 = __local_key__223_ast_local;
      __local_key__223_ast_local = (z1_447 + ((long) 1));
   }
   return __local_key__223_ast_local;
}


local_t 
make_new_local_222_ast_local(obj_t id_1, type_t type_2, obj_t value_3)
{
   {
      long key_292;
      key_292 = get_new_key_51_ast_local();
      {
	 obj_t arg1144_293;
	 obj_t arg1145_294;
	 obj_t arg1148_295;
	 {
	    obj_t arg1153_297;
	    char *arg1161_299;
	    arg1153_297 = id__name_228_ast_ident(id_1);
	    arg1161_299 = integer__string_135___r4_numbers_6_5_fixnum(key_292, BNIL);
	    {
	       obj_t list1162_300;
	       {
		  obj_t arg1164_301;
		  {
		     obj_t arg1166_302;
		     {
			obj_t aux_575;
			aux_575 = string_to_bstring(arg1161_299);
			arg1166_302 = MAKE_PAIR(aux_575, BNIL);
		     }
		     arg1164_301 = MAKE_PAIR(string1261_ast_local, arg1166_302);
		  }
		  list1162_300 = MAKE_PAIR(arg1153_297, arg1164_301);
	       }
	       arg1144_293 = string_append_106___r4_strings_6_7(list1162_300);
	    }
	 }
	 arg1145_294 = CNST_TABLE_REF(((long) 0));
	 arg1148_295 = CNST_TABLE_REF(((long) 1));
	 {
	    local_t res1258_471;
	    {
	       value_t value_452;
	       value_452 = (value_t) (value_3);
	       {
		  local_t new1048_458;
		  new1048_458 = ((local_t) BREF(GC_MALLOC(sizeof(struct local))));
		  {
		     long arg1245_459;
		     arg1245_459 = class_num_218___object(local_ast_var);
		     {
			obj_t obj_469;
			obj_469 = (obj_t) (new1048_458);
			(((obj_t) CREF(obj_469))->header = MAKE_HEADER(arg1245_459, 0), BUNSPEC);
		     }
		  }
		  {
		     object_t aux_588;
		     aux_588 = (object_t) (new1048_458);
		     OBJECT_WIDENING_SET(aux_588, BFALSE);
		  }
		  ((((local_t) CREF(new1048_458))->id) = ((obj_t) id_1), BUNSPEC);
		  ((((local_t) CREF(new1048_458))->name) = ((obj_t) arg1144_293), BUNSPEC);
		  ((((local_t) CREF(new1048_458))->type) = ((type_t) type_2), BUNSPEC);
		  ((((local_t) CREF(new1048_458))->value) = ((value_t) value_452), BUNSPEC);
		  ((((local_t) CREF(new1048_458))->access) = ((obj_t) arg1145_294), BUNSPEC);
		  ((((local_t) CREF(new1048_458))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
		  ((((local_t) CREF(new1048_458))->removable) = ((obj_t) arg1148_295), BUNSPEC);
		  ((((local_t) CREF(new1048_458))->occurrence) = ((long) ((long) 0)), BUNSPEC);
		  ((((local_t) CREF(new1048_458))->key) = ((long) key_292), BUNSPEC);
		  res1258_471 = new1048_458;
	       }
	    }
	    return res1258_471;
	 }
      }
   }
}


local_t 
clone_local_230_ast_local(local_t local_4, value_t value_5)
{
   {
      long key_305;
      key_305 = get_new_key_51_ast_local();
      {
	 obj_t arg1195_308;
	 obj_t arg1197_309;
	 type_t arg1199_310;
	 obj_t arg1200_311;
	 obj_t arg1203_312;
	 obj_t arg1204_313;
	 long arg1205_314;
	 arg1195_308 = (((local_t) CREF(local_4))->id);
	 {
	    obj_t arg1207_315;
	    char *arg1209_317;
	    arg1207_315 = id__name_228_ast_ident((((local_t) CREF(local_4))->id));
	    arg1209_317 = integer__string_135___r4_numbers_6_5_fixnum(key_305, BNIL);
	    {
	       obj_t list1210_318;
	       {
		  obj_t arg1212_319;
		  {
		     obj_t arg1213_320;
		     {
			obj_t aux_605;
			aux_605 = string_to_bstring(arg1209_317);
			arg1213_320 = MAKE_PAIR(aux_605, BNIL);
		     }
		     arg1212_319 = MAKE_PAIR(string1261_ast_local, arg1213_320);
		  }
		  list1210_318 = MAKE_PAIR(arg1207_315, arg1212_319);
	       }
	       arg1197_309 = string_append_106___r4_strings_6_7(list1210_318);
	    }
	 }
	 arg1199_310 = (((local_t) CREF(local_4))->type);
	 arg1200_311 = (((local_t) CREF(local_4))->access);
	 arg1203_312 = (((local_t) CREF(local_4))->fast_alpha_7);
	 arg1204_313 = (((local_t) CREF(local_4))->removable);
	 arg1205_314 = (((local_t) CREF(local_4))->occurrence);
	 {
	    local_t res1259_501;
	    {
	       local_t new1048_488;
	       new1048_488 = ((local_t) BREF(GC_MALLOC(sizeof(struct local))));
	       {
		  long arg1245_489;
		  arg1245_489 = class_num_218___object(local_ast_var);
		  {
		     obj_t obj_499;
		     obj_499 = (obj_t) (new1048_488);
		     (((obj_t) CREF(obj_499))->header = MAKE_HEADER(arg1245_489, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_620;
		  aux_620 = (object_t) (new1048_488);
		  OBJECT_WIDENING_SET(aux_620, BFALSE);
	       }
	       ((((local_t) CREF(new1048_488))->id) = ((obj_t) arg1195_308), BUNSPEC);
	       ((((local_t) CREF(new1048_488))->name) = ((obj_t) arg1197_309), BUNSPEC);
	       ((((local_t) CREF(new1048_488))->type) = ((type_t) arg1199_310), BUNSPEC);
	       ((((local_t) CREF(new1048_488))->value) = ((value_t) value_5), BUNSPEC);
	       ((((local_t) CREF(new1048_488))->access) = ((obj_t) arg1200_311), BUNSPEC);
	       ((((local_t) CREF(new1048_488))->fast_alpha_7) = ((obj_t) arg1203_312), BUNSPEC);
	       ((((local_t) CREF(new1048_488))->removable) = ((obj_t) arg1204_313), BUNSPEC);
	       ((((local_t) CREF(new1048_488))->occurrence) = ((long) arg1205_314), BUNSPEC);
	       ((((local_t) CREF(new1048_488))->key) = ((long) key_305), BUNSPEC);
	       res1259_501 = new1048_488;
	    }
	    return res1259_501;
	 }
      }
   }
}


obj_t 
_clone_local_106_ast_local(obj_t env_525, obj_t local_526, obj_t value_527)
{
   {
      local_t aux_632;
      aux_632 = clone_local_230_ast_local((local_t) (local_526), (value_t) (value_527));
      return (obj_t) (aux_632);
   }
}


local_t 
make_local_svar_140_ast_local(obj_t id_6, type_t type_7)
{
   {
      svar_t arg1219_502;
      {
	 svar_t res1260_507;
	 {
	    svar_t new1092_503;
	    new1092_503 = ((svar_t) BREF(GC_MALLOC(sizeof(struct svar))));
	    {
	       long arg1234_504;
	       arg1234_504 = class_num_218___object(svar_ast_var);
	       {
		  obj_t obj_505;
		  obj_505 = (obj_t) (new1092_503);
		  (((obj_t) CREF(obj_505))->header = MAKE_HEADER(arg1234_504, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_641;
	       aux_641 = (object_t) (new1092_503);
	       OBJECT_WIDENING_SET(aux_641, BFALSE);
	    }
	    {
	       res1260_507 = new1092_503;
	    }
	 }
	 arg1219_502 = res1260_507;
      }
      return make_new_local_222_ast_local(id_6, type_7, (obj_t) (arg1219_502));
   }
}


obj_t 
_make_local_svar_141_ast_local(obj_t env_528, obj_t id_529, obj_t type_530)
{
   {
      local_t aux_646;
      aux_646 = make_local_svar_140_ast_local(id_529, (type_t) (type_530));
      return (obj_t) (aux_646);
   }
}


local_t 
make_local_sexit_184_ast_local(obj_t id_8, type_t type_9, sexit_t sexit_10)
{
   return make_new_local_222_ast_local(id_8, type_9, (obj_t) (sexit_10));
}


obj_t 
_make_local_sexit_250_ast_local(obj_t env_531, obj_t id_532, obj_t type_533, obj_t sexit_534)
{
   {
      local_t aux_652;
      aux_652 = make_local_sexit_184_ast_local(id_532, (type_t) (type_533), (sexit_t) (sexit_534));
      return (obj_t) (aux_652);
   }
}


local_t 
make_local_sfun_184_ast_local(obj_t id_11, type_t type_12, sfun_t sfun_13)
{
   return make_new_local_222_ast_local(id_11, type_12, (obj_t) (sfun_13));
}


obj_t 
_make_local_sfun_99_ast_local(obj_t env_535, obj_t id_536, obj_t type_537, obj_t sfun_538)
{
   {
      local_t aux_659;
      aux_659 = make_local_sfun_184_ast_local(id_536, (type_t) (type_537), (sfun_t) (sfun_538));
      return (obj_t) (aux_659);
   }
}


obj_t 
imported_modules_init_94_ast_local()
{
   module_initialization_70_type_type(((long) 0), "AST_LOCAL");
   module_initialization_70_ast_var(((long) 0), "AST_LOCAL");
   return module_initialization_70_ast_ident(((long) 0), "AST_LOCAL");
}
