/*===========================================================================*/
/*   (Ast/lvtype.scm)                                                        */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t lvtype_node__58_ast_lvtype(node_t);
extern obj_t let_fun_218_ast_node;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t closure_ast_node;
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_ast_lvtype();
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_ast_lvtype();
static obj_t _lvtype_node__default1299_155_ast_lvtype(obj_t, obj_t);
static obj_t cnst_init_137_ast_lvtype();
static obj_t lvtype_node__default1299_40_ast_lvtype(node_t);
static obj_t require_initialization_114_ast_lvtype = BUNSPEC;
extern obj_t var_ast_node;
static obj_t library_modules_init_112_ast_lvtype();
extern obj_t cast_ast_node;
static obj_t set_variable_type__9_ast_lvtype(variable_t, type_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t _lvtype_node__190_ast_lvtype(obj_t, obj_t);
static bool_t lvtype_node___164_ast_lvtype(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern type_t typeof_coerce_typeof(node_t);
extern obj_t kwote_ast_node;
extern obj_t _____74_type_cache;
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t __obj__252_type_cache;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t app_ast_node;
static obj_t __cnst[1];

DEFINE_STRING(string1542_ast_lvtype, string1542_ast_lvtype1551, "No method for this object", 25);
DEFINE_STRING(string1543_ast_lvtype, string1543_ast_lvtype1552, "lvtype-node!", 12);
DEFINE_STRING(string1545_ast_lvtype, string1545_ast_lvtype1553, "LVTYPE-NODE!-DEFAULT1299 ", 25);
DEFINE_EXPORT_GENERIC(lvtype_node__env_81_ast_lvtype, _lvtype_node__190_ast_lvtype1554, _lvtype_node__190_ast_lvtype, 0L, 1);
DEFINE_STATIC_PROCEDURE(lvtype_node__default1299_env_170_ast_lvtype, _lvtype_node__default1299_155_ast_lvtype1555, _lvtype_node__default1299_155_ast_lvtype, 0L, 1);
DEFINE_STRING(string1544_ast_lvtype, string1544_ast_lvtype1556, "Unexpected closure", 18);

obj_t 
module_initialization_70_ast_lvtype(long checksum_1190, char *from_1191)
{
   if (CBOOL(require_initialization_114_ast_lvtype))
     {
	require_initialization_114_ast_lvtype = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_lvtype();
	cnst_init_137_ast_lvtype();
	imported_modules_init_94_ast_lvtype();
	toplevel_init_63_ast_lvtype();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_lvtype()
{
   module_initialization_70___object(((long) 0), "AST_LVTYPE");
   module_initialization_70___reader(((long) 0), "AST_LVTYPE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_lvtype()
{
   {
      obj_t cnst_port_138_1182;
      cnst_port_138_1182 = open_input_string(string1545_ast_lvtype);
      {
	 long i_1183;
	 i_1183 = ((long) 0);
       loop_1184:
	 {
	    bool_t test1546_1185;
	    test1546_1185 = (i_1183 == ((long) -1));
	    if (test1546_1185)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1547_1186;
		    {
		       obj_t list1548_1187;
		       {
			  obj_t arg1549_1188;
			  arg1549_1188 = BNIL;
			  list1548_1187 = MAKE_PAIR(cnst_port_138_1182, arg1549_1188);
		       }
		       arg1547_1186 = read___reader(list1548_1187);
		    }
		    CNST_TABLE_SET(i_1183, arg1547_1186);
		 }
		 {
		    int aux_1189;
		    {
		       long aux_1207;
		       aux_1207 = (i_1183 - ((long) 1));
		       aux_1189 = (int) (aux_1207);
		    }
		    {
		       long i_1210;
		       i_1210 = (long) (aux_1189);
		       i_1183 = i_1210;
		       goto loop_1184;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_lvtype()
{
   add_generic__110___object(lvtype_node__env_81_ast_lvtype, lvtype_node__default1299_env_170_ast_lvtype);
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, var_ast_node, ((long) 2));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, app_ast_node, ((long) 5));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, app_ly_162_ast_node, ((long) 6));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, funcall_ast_node, ((long) 7));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, pragma_ast_node, ((long) 8));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, cast_ast_node, ((long) 9));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, setq_ast_node, ((long) 10));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, conditional_ast_node, ((long) 11));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, fail_ast_node, ((long) 12));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, select_ast_node, ((long) 13));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, let_fun_218_ast_node, ((long) 14));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, let_var_6_ast_node, ((long) 15));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, set_ex_it_116_ast_node, ((long) 16));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, jump_ex_it_184_ast_node, ((long) 17));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, make_box_202_ast_node, ((long) 18));
   add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, box_set__221_ast_node, ((long) 19));
   {
      long aux_1233;
      aux_1233 = add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, box_ref_242_ast_node, ((long) 20));
      return BINT(aux_1233);
   }
}


obj_t 
lvtype_node__default1299_40_ast_lvtype(node_t node_2)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1542_ast_lvtype, (obj_t) (node_2));
}


obj_t 
_lvtype_node__default1299_155_ast_lvtype(obj_t env_1179, obj_t node_1180)
{
   return lvtype_node__default1299_40_ast_lvtype((node_t) (node_1180));
}


obj_t 
lvtype_node__58_ast_lvtype(node_t node_1)
{
 lvtype_node__58_ast_lvtype:
   {
      obj_t method1455_981;
      obj_t class1460_982;
      {
	 obj_t arg1463_979;
	 obj_t arg1465_980;
	 {
	    object_t obj_1094;
	    obj_1094 = (object_t) (node_1);
	    {
	       obj_t pre_method_105_1095;
	       pre_method_105_1095 = PROCEDURE_REF(lvtype_node__env_81_ast_lvtype, ((long) 2));
	       if (INTEGERP(pre_method_105_1095))
		 {
		    PROCEDURE_SET(lvtype_node__env_81_ast_lvtype, ((long) 2), BUNSPEC);
		    arg1463_979 = pre_method_105_1095;
		 }
	       else
		 {
		    long obj_class_num_177_1100;
		    obj_class_num_177_1100 = TYPE(obj_1094);
		    {
		       obj_t arg1183_1101;
		       arg1183_1101 = PROCEDURE_REF(lvtype_node__env_81_ast_lvtype, ((long) 1));
		       {
			  long arg1184_1105;
			  {
			     long arg1186_1106;
			     arg1186_1106 = OBJECT_TYPE;
			     arg1184_1105 = (obj_class_num_177_1100 - arg1186_1106);
			  }
			  arg1463_979 = VECTOR_REF(arg1183_1101, arg1184_1105);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1111;
	    object_1111 = (object_t) (node_1);
	    {
	       long arg1187_1112;
	       {
		  long arg1188_1113;
		  long arg1189_1114;
		  arg1188_1113 = TYPE(object_1111);
		  arg1189_1114 = OBJECT_TYPE;
		  arg1187_1112 = (arg1188_1113 - arg1189_1114);
	       }
	       {
		  obj_t vector_1118;
		  vector_1118 = __classes__134___object;
		  arg1465_980 = VECTOR_REF(vector_1118, arg1187_1112);
	       }
	    }
	 }
	 method1455_981 = arg1463_979;
	 class1460_982 = arg1465_980;
	 {
	    if (INTEGERP(method1455_981))
	      {
		 switch ((long) CINT(method1455_981))
		   {
		   case ((long) 0):
		      return BUNSPEC;
		      break;
		   case ((long) 1):
		      return BUNSPEC;
		      break;
		   case ((long) 2):
		      return BUNSPEC;
		      break;
		   case ((long) 3):
		      {
			 obj_t arg1471_994;
			 {
			    obj_t aux_1258;
			    {
			       closure_t aux_1259;
			       aux_1259 = (closure_t) (node_1);
			       aux_1258 = (obj_t) (aux_1259);
			    }
			    arg1471_994 = shape_tools_shape(aux_1258);
			 }
			 return internal_error_43_tools_error(string1543_ast_lvtype, string1544_ast_lvtype, arg1471_994);
		      }
		      break;
		   case ((long) 4):
		      {
			 sequence_t node_995;
			 node_995 = (sequence_t) (node_1);
			 {
			    bool_t aux_1265;
			    aux_1265 = lvtype_node___164_ast_lvtype((((sequence_t) CREF(node_995))->nodes));
			    return BBOOL(aux_1265);
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 app_t node_998;
			 node_998 = (app_t) (node_1);
			 {
			    bool_t aux_1270;
			    aux_1270 = lvtype_node___164_ast_lvtype((((app_t) CREF(node_998))->args));
			    return BBOOL(aux_1270);
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 app_ly_162_t node_1001;
			 node_1001 = (app_ly_162_t) (node_1);
			 lvtype_node__58_ast_lvtype((((app_ly_162_t) CREF(node_1001))->fun));
			 {
			    node_t node_1277;
			    node_1277 = (((app_ly_162_t) CREF(node_1001))->arg);
			    node_1 = node_1277;
			    goto lvtype_node__58_ast_lvtype;
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 funcall_t node_1005;
			 node_1005 = (funcall_t) (node_1);
			 lvtype_node__58_ast_lvtype((((funcall_t) CREF(node_1005))->fun));
			 {
			    bool_t aux_1282;
			    aux_1282 = lvtype_node___164_ast_lvtype((((funcall_t) CREF(node_1005))->args));
			    return BBOOL(aux_1282);
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 pragma_t node_1009;
			 node_1009 = (pragma_t) (node_1);
			 {
			    bool_t aux_1287;
			    aux_1287 = lvtype_node___164_ast_lvtype((((pragma_t) CREF(node_1009))->args));
			    return BBOOL(aux_1287);
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 cast_t node_1012;
			 node_1012 = (cast_t) (node_1);
			 {
			    node_t node_1292;
			    node_1292 = (((cast_t) CREF(node_1012))->arg);
			    node_1 = node_1292;
			    goto lvtype_node__58_ast_lvtype;
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 setq_t node_1015;
			 node_1015 = (setq_t) (node_1);
			 lvtype_node__58_ast_lvtype((((setq_t) CREF(node_1015))->value));
			 {
			    node_t node_1297;
			    {
			       var_t aux_1298;
			       aux_1298 = (((setq_t) CREF(node_1015))->var);
			       node_1297 = (node_t) (aux_1298);
			    }
			    node_1 = node_1297;
			    goto lvtype_node__58_ast_lvtype;
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 conditional_t node_1019;
			 node_1019 = (conditional_t) (node_1);
			 lvtype_node__58_ast_lvtype((((conditional_t) CREF(node_1019))->test));
			 lvtype_node__58_ast_lvtype((((conditional_t) CREF(node_1019))->true));
			 {
			    node_t node_1306;
			    node_1306 = (((conditional_t) CREF(node_1019))->false);
			    node_1 = node_1306;
			    goto lvtype_node__58_ast_lvtype;
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 fail_t node_1024;
			 node_1024 = (fail_t) (node_1);
			 lvtype_node__58_ast_lvtype((((fail_t) CREF(node_1024))->proc));
			 lvtype_node__58_ast_lvtype((((fail_t) CREF(node_1024))->msg));
			 {
			    node_t node_1313;
			    node_1313 = (((fail_t) CREF(node_1024))->obj);
			    node_1 = node_1313;
			    goto lvtype_node__58_ast_lvtype;
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 select_t node_1029;
			 node_1029 = (select_t) (node_1);
			 lvtype_node__58_ast_lvtype((((select_t) CREF(node_1029))->test));
			 {
			    obj_t l1282_1032;
			    {
			       bool_t aux_1318;
			       l1282_1032 = (((select_t) CREF(node_1029))->clauses);
			     lname1283_1033:
			       if (PAIRP(l1282_1032))
				 {
				    {
				       node_t aux_1321;
				       {
					  obj_t aux_1322;
					  {
					     obj_t aux_1323;
					     aux_1323 = CAR(l1282_1032);
					     aux_1322 = CDR(aux_1323);
					  }
					  aux_1321 = (node_t) (aux_1322);
				       }
				       lvtype_node__58_ast_lvtype(aux_1321);
				    }
				    {
				       obj_t l1282_1328;
				       l1282_1328 = CDR(l1282_1032);
				       l1282_1032 = l1282_1328;
				       goto lname1283_1033;
				    }
				 }
			       else
				 {
				    aux_1318 = ((bool_t) 1);
				 }
			       return BBOOL(aux_1318);
			    }
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 let_fun_218_t node_1039;
			 node_1039 = (let_fun_218_t) (node_1);
			 {
			    obj_t l1285_1041;
			    l1285_1041 = (((let_fun_218_t) CREF(node_1039))->locals);
			  lname1287_1042:
			    if (PAIRP(l1285_1041))
			      {
				 {
				    node_t aux_1335;
				    {
				       obj_t aux_1336;
				       {
					  sfun_t obj_1146;
					  {
					     value_t aux_1337;
					     {
						local_t obj_1145;
						{
						   obj_t aux_1338;
						   aux_1338 = CAR(l1285_1041);
						   obj_1145 = (local_t) (aux_1338);
						}
						aux_1337 = (((local_t) CREF(obj_1145))->value);
					     }
					     obj_1146 = (sfun_t) (aux_1337);
					  }
					  aux_1336 = (((sfun_t) CREF(obj_1146))->body);
				       }
				       aux_1335 = (node_t) (aux_1336);
				    }
				    lvtype_node__58_ast_lvtype(aux_1335);
				 }
				 {
				    obj_t l1285_1346;
				    l1285_1346 = CDR(l1285_1041);
				    l1285_1041 = l1285_1346;
				    goto lname1287_1042;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    node_t node_1349;
			    node_1349 = (((let_fun_218_t) CREF(node_1039))->body);
			    node_1 = node_1349;
			    goto lvtype_node__58_ast_lvtype;
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 let_var_6_t node_1050;
			 node_1050 = (let_var_6_t) (node_1);
			 {
			    obj_t l1289_1052;
			    l1289_1052 = (((let_var_6_t) CREF(node_1050))->bindings);
			  lname1290_1053:
			    if (PAIRP(l1289_1052))
			      {
				 {
				    obj_t binding_1056;
				    binding_1056 = CAR(l1289_1052);
				    {
				       obj_t var_1057;
				       obj_t val_1058;
				       var_1057 = CAR(binding_1056);
				       val_1058 = CDR(binding_1056);
				       lvtype_node__58_ast_lvtype((node_t) (val_1058));
				       {
					  type_t arg1517_1059;
					  arg1517_1059 = typeof_coerce_typeof((node_t) (val_1058));
					  set_variable_type__9_ast_lvtype((variable_t) (var_1057), arg1517_1059);
				       }
				    }
				 }
				 {
				    obj_t l1289_1363;
				    l1289_1363 = CDR(l1289_1052);
				    l1289_1052 = l1289_1363;
				    goto lname1290_1053;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    node_t node_1366;
			    node_1366 = (((let_var_6_t) CREF(node_1050))->body);
			    node_1 = node_1366;
			    goto lvtype_node__58_ast_lvtype;
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 set_ex_it_116_t node_1062;
			 node_1062 = (set_ex_it_116_t) (node_1);
			 lvtype_node__58_ast_lvtype((((set_ex_it_116_t) CREF(node_1062))->body));
			 {
			    node_t node_1371;
			    {
			       var_t aux_1372;
			       aux_1372 = (((set_ex_it_116_t) CREF(node_1062))->var);
			       node_1371 = (node_t) (aux_1372);
			    }
			    node_1 = node_1371;
			    goto lvtype_node__58_ast_lvtype;
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 jump_ex_it_184_t node_1066;
			 node_1066 = (jump_ex_it_184_t) (node_1);
			 lvtype_node__58_ast_lvtype((((jump_ex_it_184_t) CREF(node_1066))->exit));
			 {
			    node_t node_1378;
			    node_1378 = (((jump_ex_it_184_t) CREF(node_1066))->value);
			    node_1 = node_1378;
			    goto lvtype_node__58_ast_lvtype;
			 }
		      }
		      break;
		   case ((long) 18):
		      {
			 make_box_202_t node_1070;
			 node_1070 = (make_box_202_t) (node_1);
			 {
			    node_t node_1381;
			    node_1381 = (((make_box_202_t) CREF(node_1070))->value);
			    node_1 = node_1381;
			    goto lvtype_node__58_ast_lvtype;
			 }
		      }
		      break;
		   case ((long) 19):
		      {
			 box_set__221_t node_1073;
			 node_1073 = (box_set__221_t) (node_1);
			 {
			    node_t aux_1384;
			    {
			       var_t aux_1385;
			       aux_1385 = (((box_set__221_t) CREF(node_1073))->var);
			       aux_1384 = (node_t) (aux_1385);
			    }
			    lvtype_node__58_ast_lvtype(aux_1384);
			 }
			 {
			    node_t node_1389;
			    node_1389 = (((box_set__221_t) CREF(node_1073))->value);
			    node_1 = node_1389;
			    goto lvtype_node__58_ast_lvtype;
			 }
		      }
		      break;
		   case ((long) 20):
		      {
			 box_ref_242_t node_1077;
			 node_1077 = (box_ref_242_t) (node_1);
			 {
			    node_t node_1392;
			    {
			       var_t aux_1393;
			       aux_1393 = (((box_ref_242_t) CREF(node_1077))->var);
			       node_1392 = (node_t) (aux_1393);
			    }
			    node_1 = node_1392;
			    goto lvtype_node__58_ast_lvtype;
			 }
		      }
		      break;
		   default:
		    case_else1461_222_985:
		      if (PROCEDUREP(method1455_981))
			{
			   return PROCEDURE_ENTRY(method1455_981) (method1455_981, (obj_t) (node_1), BEOA);
			}
		      else
			{
			   obj_t fun1328_658;
			   fun1328_658 = PROCEDURE_REF(lvtype_node__env_81_ast_lvtype, ((long) 0));
			   return PROCEDURE_ENTRY(fun1328_658) (fun1328_658, (obj_t) (node_1), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1461_222_985;
	      }
	 }
      }
   }
}


obj_t 
_lvtype_node__190_ast_lvtype(obj_t env_1177, obj_t node_1178)
{
   return lvtype_node__58_ast_lvtype((node_t) (node_1178));
}


bool_t 
lvtype_node___164_ast_lvtype(obj_t node__221_24)
{
   {
      obj_t l1296_659;
      l1296_659 = node__221_24;
    lname1298_660:
      if (PAIRP(l1296_659))
	{
	   {
	      node_t aux_1411;
	      {
		 obj_t aux_1412;
		 aux_1412 = CAR(l1296_659);
		 aux_1411 = (node_t) (aux_1412);
	      }
	      lvtype_node__58_ast_lvtype(aux_1411);
	   }
	   {
	      obj_t l1296_1416;
	      l1296_1416 = CDR(l1296_659);
	      l1296_659 = l1296_1416;
	      goto lname1298_660;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
set_variable_type__9_ast_lvtype(variable_t variable_25, type_t type_26)
{
   {
      obj_t ntype_664;
      {
	 bool_t test1334_667;
	 {
	    obj_t obj2_1170;
	    obj2_1170 = _____74_type_cache;
	    {
	       obj_t aux_1418;
	       aux_1418 = (obj_t) (type_26);
	       test1334_667 = (aux_1418 == obj2_1170);
	    }
	 }
	 if (test1334_667)
	   {
	      ntype_664 = __obj__252_type_cache;
	   }
	 else
	   {
	      ntype_664 = (obj_t) (type_26);
	   }
      }
      {
	 bool_t test1333_666;
	 {
	    obj_t obj2_1173;
	    obj2_1173 = _____74_type_cache;
	    {
	       obj_t aux_1423;
	       {
		  type_t aux_1424;
		  aux_1424 = (((variable_t) CREF(variable_25))->type);
		  aux_1423 = (obj_t) (aux_1424);
	       }
	       test1333_666 = (aux_1423 == obj2_1173);
	    }
	 }
	 if (test1333_666)
	   {
	      obj_t res1541_1176;
	      {
		 type_t val1026_1175;
		 val1026_1175 = (type_t) (ntype_664);
		 {
		    obj_t x_1181;
		    x_1181 = ((((variable_t) CREF(variable_25))->type) = ((type_t) val1026_1175), BUNSPEC);
		    res1541_1176 = BUNSPEC;
		 }
	      }
	      return res1541_1176;
	   }
	 else
	   {
	      return BUNSPEC;
	   }
      }
   }
}


obj_t 
imported_modules_init_94_ast_lvtype()
{
   module_initialization_70_type_type(((long) 0), "AST_LVTYPE");
   module_initialization_70_type_cache(((long) 0), "AST_LVTYPE");
   module_initialization_70_tools_shape(((long) 0), "AST_LVTYPE");
   module_initialization_70_tools_error(((long) 0), "AST_LVTYPE");
   module_initialization_70_coerce_typeof(((long) 0), "AST_LVTYPE");
   module_initialization_70_ast_var(((long) 0), "AST_LVTYPE");
   return module_initialization_70_ast_node(((long) 0), "AST_LVTYPE");
}
