/*===========================================================================*/
/*   (Ast/node.scm)                                                          */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


static obj_t _allocate_pragma_246_ast_node(obj_t);
static obj_t struct_object__object_setq2332_160_ast_node(obj_t, obj_t, obj_t);
static kwote_t allocate_kwote_110_ast_node();
static obj_t _allocate_set_ex_it_70_ast_node(obj_t);
static box_set__221_t allocate_box_set__237_ast_node();
static obj_t struct_object__object_select2338_203_ast_node(obj_t, obj_t, obj_t);
static obj_t struct_object__object_var2314_179_ast_node(obj_t, obj_t, obj_t);
static obj_t struct_object__object_node_effect2310_4_ast_node(obj_t, obj_t, obj_t);
static obj_t struct_object__object_jump_ex_it2346_32_ast_node(obj_t, obj_t, obj_t);
static obj_t struct_object__object_app_ly2324_236_ast_node(obj_t, obj_t, obj_t);
obj_t let_fun_218_ast_node = BUNSPEC;
static obj_t object__struct_funcall2327_159_ast_node(obj_t, obj_t);
static obj_t struct_object__object_sequence2320_161_ast_node(obj_t, obj_t, obj_t);
static obj_t _allocate_select_101_ast_node(obj_t);
static obj_t struct_object__object_cast2330_240_ast_node(obj_t, obj_t, obj_t);
static obj_t struct_object__object_conditional2334_217_ast_node(obj_t, obj_t, obj_t);
static obj_t object__struct_app2323_235_ast_node(obj_t, obj_t);
static obj_t object__struct_box_set_2353_31_ast_node(obj_t, obj_t);
obj_t sequence_ast_node = BUNSPEC;
static select_t allocate_select_194_ast_node();
static closure_t allocate_closure_237_ast_node();
static obj_t object__struct_setq2333_166_ast_node(obj_t, obj_t);
static obj_t _allocate_cast_146_ast_node(obj_t);
obj_t closure_ast_node = BUNSPEC;
static obj_t object__struct_select2339_32_ast_node(obj_t, obj_t);
static node_t allocate_node_189_ast_node();
extern obj_t _struct_object__object_6___object(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_ast_node();
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t _allocate_conditional_184_ast_node(obj_t);
static obj_t toplevel_init_63_ast_node();
static obj_t cnst_init_137_ast_node();
static obj_t _allocate_app_ly_138_ast_node(obj_t);
static obj_t _allocate_box_ref_230_ast_node(obj_t);
static obj_t _allocate_let_var_179_ast_node(obj_t);
static obj_t struct_object__object_kwote2318_170_ast_node(obj_t, obj_t, obj_t);
static app_ly_162_t allocate_app_ly_30_ast_node();
static sequence_t allocate_sequence_235_ast_node();
static obj_t object__struct_box_ref2351_133_ast_node(obj_t, obj_t);
obj_t node_effect_213_ast_node = BUNSPEC;
static obj_t object__struct_kwote2319_84_ast_node(obj_t, obj_t);
static make_box_202_t allocate_make_box_201_ast_node();
static node_effect_213_t allocate_node_effect_98_ast_node();
static obj_t _allocate_jump_ex_it_189_ast_node(obj_t);
static obj_t object__struct_pragma2329_229_ast_node(obj_t, obj_t);
static obj_t struct_object__object_let_fun2340_202_ast_node(obj_t, obj_t, obj_t);
static obj_t object__struct_jump_ex_it2347_58_ast_node(obj_t, obj_t);
static obj_t object__struct_set_ex_it2345_218_ast_node(obj_t, obj_t);
static var_t allocate_var_186_ast_node();
static funcall_t allocate_funcall_80_ast_node();
static obj_t require_initialization_114_ast_node = BUNSPEC;
static obj_t struct_object__object_pragma2328_3_ast_node(obj_t, obj_t, obj_t);
obj_t var_ast_node = BUNSPEC;
static conditional_t allocate_conditional_174_ast_node();
static obj_t library_modules_init_112_ast_node();
static obj_t _allocate_node_effect_20_ast_node(obj_t);
static obj_t _allocate_atom_130_ast_node(obj_t);
static setq_t allocate_setq_54_ast_node();
static obj_t _allocate_fail_214_ast_node(obj_t);
static obj_t _allocate_node_227_ast_node(obj_t);
static obj_t struct_object__object_atom2312_22_ast_node(obj_t, obj_t, obj_t);
static fail_t allocate_fail_46_ast_node();
obj_t cast_ast_node = BUNSPEC;
static obj_t _allocate_funcall_93_ast_node(obj_t);
static obj_t object__struct_let_var2343_55_ast_node(obj_t, obj_t);
static obj_t struct_object__object_fail2336_138_ast_node(obj_t, obj_t, obj_t);
obj_t conditional_ast_node = BUNSPEC;
extern obj_t read___reader(obj_t);
static obj_t object__struct_var2315_201_ast_node(obj_t, obj_t);
static obj_t struct_object__object_closure2316_120_ast_node(obj_t, obj_t, obj_t);
obj_t box_set__221_ast_node = BUNSPEC;
static obj_t struct_object__object_set_ex_it2344_88_ast_node(obj_t, obj_t, obj_t);
static obj_t object__struct_make_box2349_125_ast_node(obj_t, obj_t);
obj_t select_ast_node = BUNSPEC;
static box_ref_242_t allocate_box_ref_100_ast_node();
static obj_t object__struct_cast2331_252_ast_node(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
obj_t let_var_6_ast_node = BUNSPEC;
static obj_t struct_object__object_make_box2348_248_ast_node(obj_t, obj_t, obj_t);
static jump_ex_it_184_t allocate_jump_ex_it_22_ast_node();
static cast_t allocate_cast_68_ast_node();
static obj_t struct_object__object_let_var2342_149_ast_node(obj_t, obj_t, obj_t);
obj_t pragma_ast_node = BUNSPEC;
static obj_t object__struct_let_fun2341_47_ast_node(obj_t, obj_t);
static obj_t object__struct_atom2313_17_ast_node(obj_t, obj_t);
extern long class_num_218___object(obj_t);
static obj_t _allocate_setq_253_ast_node(obj_t);
static obj_t struct_object__object_app2322_88_ast_node(obj_t, obj_t, obj_t);
obj_t app_ly_162_ast_node = BUNSPEC;
static obj_t object__struct_conditional2335_2_ast_node(obj_t, obj_t);
obj_t jump_ex_it_184_ast_node = BUNSPEC;
extern obj_t object___object;
static obj_t struct_object__object_funcall2326_94_ast_node(obj_t, obj_t, obj_t);
obj_t setq_ast_node = BUNSPEC;
static obj_t _allocate_kwote_245_ast_node(obj_t);
static obj_t object__struct_app_ly2325_233_ast_node(obj_t, obj_t);
static obj_t struct_object__object_box_ref2350_106_ast_node(obj_t, obj_t, obj_t);
obj_t fail_ast_node = BUNSPEC;
static obj_t object_init_111_ast_node();
static obj_t object__struct_closure2317_164_ast_node(obj_t, obj_t);
obj_t set_ex_it_116_ast_node = BUNSPEC;
static app_t allocate_app_15_ast_node();
static let_var_6_t allocate_let_var_32_ast_node();
static pragma_t allocate_pragma_110_ast_node();
static obj_t _allocate_make_box_168_ast_node(obj_t);
obj_t kwote_ast_node = BUNSPEC;
static obj_t _allocate_closure_68_ast_node(obj_t);
static obj_t object__struct_fail2337_193_ast_node(obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
obj_t node_ast_node = BUNSPEC;
static obj_t _allocate_let_fun_123_ast_node(obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
static obj_t _allocate_var_93_ast_node(obj_t);
obj_t box_ref_242_ast_node = BUNSPEC;
static obj_t struct_object__object_box_set_2352_66_ast_node(obj_t, obj_t, obj_t);
static obj_t object__struct_node_effect2311_124_ast_node(obj_t, obj_t);
extern obj_t _object__struct_74___object(obj_t, obj_t);
static obj_t _allocate_sequence_156_ast_node(obj_t);
static set_ex_it_116_t allocate_set_ex_it_57_ast_node();
static let_fun_218_t allocate_let_fun_35_ast_node();
obj_t funcall_ast_node = BUNSPEC;
obj_t atom_ast_node = BUNSPEC;
obj_t make_box_202_ast_node = BUNSPEC;
static atom_t allocate_atom_199_ast_node();
static obj_t _allocate_box_set__43_ast_node(obj_t);
static obj_t object__struct_node2309_44_ast_node(obj_t, obj_t);
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t);
static obj_t struct_object__object_node2308_118_ast_node(obj_t, obj_t, obj_t);
static obj_t _allocate_app_162_ast_node(obj_t);
obj_t app_ast_node = BUNSPEC;
static obj_t object__struct_sequence2321_37_ast_node(obj_t, obj_t);
static obj_t __cnst[23];

DEFINE_STATIC_PROCEDURE(proc2369_ast_node, object__struct_let_fun2341_47_ast_node2409, object__struct_let_fun2341_47_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2367_ast_node, object__struct_let_var2343_55_ast_node2410, object__struct_let_var2343_55_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_make_box_env_148_ast_node, _allocate_make_box_168_ast_node2411, _allocate_make_box_168_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2399_ast_node, object__struct_node_effect2311_124_ast_node2412, object__struct_node_effect2311_124_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2374_ast_node, struct_object__object_fail2336_138_ast_node2413, struct_object__object_fail2336_138_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_box_ref_env_189_ast_node, _allocate_box_ref_230_ast_node2414, _allocate_box_ref_230_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2368_ast_node, struct_object__object_let_var2342_149_ast_node2415, struct_object__object_let_var2342_149_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_setq_env_19_ast_node, _allocate_setq_253_ast_node2416, _allocate_setq_253_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2364_ast_node, struct_object__object_jump_ex_it2346_32_ast_node2417, struct_object__object_jump_ex_it2346_32_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_conditional_env_156_ast_node, _allocate_conditional_184_ast_node2418, _allocate_conditional_184_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2398_ast_node, struct_object__object_atom2312_22_ast_node2419, struct_object__object_atom2312_22_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2375_ast_node, object__struct_conditional2335_2_ast_node2420, object__struct_conditional2335_2_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2362_ast_node, struct_object__object_make_box2348_248_ast_node2421, struct_object__object_make_box2348_248_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_let_fun_env_44_ast_node, _allocate_let_fun_123_ast_node2422, _allocate_let_fun_123_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_set_ex_it_env_240_ast_node, _allocate_set_ex_it_70_ast_node2423, _allocate_set_ex_it_70_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2389_ast_node, object__struct_sequence2321_37_ast_node2424, object__struct_sequence2321_37_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_app_ly_env_193_ast_node, _allocate_app_ly_138_ast_node2425, _allocate_app_ly_138_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2393_ast_node, object__struct_closure2317_164_ast_node2426, object__struct_closure2317_164_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2366_ast_node, struct_object__object_set_ex_it2344_88_ast_node2427, struct_object__object_set_ex_it2344_88_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_box_set__env_30_ast_node, _allocate_box_set__43_ast_node2428, _allocate_box_set__43_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_kwote_env_128_ast_node, _allocate_kwote_245_ast_node2429, _allocate_kwote_245_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2384_ast_node, struct_object__object_funcall2326_94_ast_node2430, struct_object__object_funcall2326_94_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_sequence_env_201_ast_node, _allocate_sequence_156_ast_node2431, _allocate_sequence_156_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2392_ast_node, struct_object__object_kwote2318_170_ast_node2432, struct_object__object_kwote2318_170_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2382_ast_node, struct_object__object_pragma2328_3_ast_node2433, struct_object__object_pragma2328_3_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_node_effect_env_65_ast_node, _allocate_node_effect_20_ast_node2434, _allocate_node_effect_20_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_atom_env_206_ast_node, _allocate_atom_130_ast_node2435, _allocate_atom_130_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2402_ast_node, struct_object__object_node2308_118_ast_node2436, struct_object__object_node2308_118_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_var_env_196_ast_node, _allocate_var_93_ast_node2437, _allocate_var_93_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2391_ast_node, object__struct_kwote2319_84_ast_node2438, object__struct_kwote2319_84_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2359_ast_node, object__struct_box_ref2351_133_ast_node2439, object__struct_box_ref2351_133_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2394_ast_node, struct_object__object_closure2316_120_ast_node2440, struct_object__object_closure2316_120_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2379_ast_node, object__struct_cast2331_252_ast_node2441, object__struct_cast2331_252_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2397_ast_node, object__struct_atom2313_17_ast_node2442, object__struct_atom2313_17_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_app_env_27_ast_node, _allocate_app_162_ast_node2443, _allocate_app_162_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2377_ast_node, object__struct_setq2333_166_ast_node2444, object__struct_setq2333_166_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2376_ast_node, struct_object__object_conditional2334_217_ast_node2445, struct_object__object_conditional2334_217_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2371_ast_node, object__struct_select2339_32_ast_node2446, object__struct_select2339_32_ast_node, 0L, 1);
DEFINE_STRING(string2403_ast_node, string2403_ast_node2447, "BOX-SET! BOX-REF MAKE-BOX JUMP-EX-IT SET-EX-IT LET-VAR LET-FUN SELECT FAIL CONDITIONAL SETQ CAST PRAGMA FUNCALL APP-LY APP SEQUENCE KWOTE CLOSURE VAR ATOM NODE/EFFECT NODE ", 172);
DEFINE_STATIC_PROCEDURE(proc2360_ast_node, struct_object__object_box_ref2350_106_ast_node2448, struct_object__object_box_ref2350_106_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_fail_env_28_ast_node, _allocate_fail_214_ast_node2449, _allocate_fail_214_ast_node, 0L, 0);
extern obj_t struct_object__object_env_209___object;
DEFINE_STATIC_PROCEDURE(proc2396_ast_node, struct_object__object_var2314_179_ast_node2450, struct_object__object_var2314_179_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2357_ast_node, object__struct_box_set_2353_31_ast_node2451, object__struct_box_set_2353_31_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2361_ast_node, object__struct_make_box2349_125_ast_node2452, object__struct_make_box2349_125_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2358_ast_node, struct_object__object_box_set_2352_66_ast_node2453, struct_object__object_box_set_2352_66_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2388_ast_node, struct_object__object_app2322_88_ast_node2454, struct_object__object_app2322_88_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_pragma_env_128_ast_node, _allocate_pragma_246_ast_node2455, _allocate_pragma_246_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_jump_ex_it_env_98_ast_node, _allocate_jump_ex_it_189_ast_node2456, _allocate_jump_ex_it_189_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2373_ast_node, object__struct_fail2337_193_ast_node2457, object__struct_fail2337_193_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_select_env_246_ast_node, _allocate_select_101_ast_node2458, _allocate_select_101_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2383_ast_node, object__struct_funcall2327_159_ast_node2459, object__struct_funcall2327_159_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2372_ast_node, struct_object__object_select2338_203_ast_node2460, struct_object__object_select2338_203_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_cast_env_179_ast_node, _allocate_cast_146_ast_node2461, _allocate_cast_146_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2387_ast_node, object__struct_app2323_235_ast_node2462, object__struct_app2323_235_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2370_ast_node, struct_object__object_let_fun2340_202_ast_node2463, struct_object__object_let_fun2340_202_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2378_ast_node, struct_object__object_setq2332_160_ast_node2464, struct_object__object_setq2332_160_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2395_ast_node, object__struct_var2315_201_ast_node2465, object__struct_var2315_201_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2365_ast_node, object__struct_set_ex_it2345_218_ast_node2466, object__struct_set_ex_it2345_218_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2400_ast_node, struct_object__object_node_effect2310_4_ast_node2467, struct_object__object_node_effect2310_4_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2385_ast_node, object__struct_app_ly2325_233_ast_node2468, object__struct_app_ly2325_233_ast_node, 0L, 1);
extern obj_t object__struct_env_210___object;
DEFINE_STATIC_PROCEDURE(proc2386_ast_node, struct_object__object_app_ly2324_236_ast_node2469, struct_object__object_app_ly2324_236_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2363_ast_node, object__struct_jump_ex_it2347_58_ast_node2470, object__struct_jump_ex_it2347_58_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2401_ast_node, object__struct_node2309_44_ast_node2471, object__struct_node2309_44_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2380_ast_node, struct_object__object_cast2330_240_ast_node2472, struct_object__object_cast2330_240_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2390_ast_node, struct_object__object_sequence2320_161_ast_node2473, struct_object__object_sequence2320_161_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_node_env_214_ast_node, _allocate_node_227_ast_node2474, _allocate_node_227_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_let_var_env_250_ast_node, _allocate_let_var_179_ast_node2475, _allocate_let_var_179_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_funcall_env_134_ast_node, _allocate_funcall_93_ast_node2476, _allocate_funcall_93_ast_node, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2381_ast_node, object__struct_pragma2329_229_ast_node2477, object__struct_pragma2329_229_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_closure_env_30_ast_node, _allocate_closure_68_ast_node2478, _allocate_closure_68_ast_node, 0L, 0);

obj_t 
module_initialization_70_ast_node(long checksum_2737, char *from_2738)
{
   if (CBOOL(require_initialization_114_ast_node))
     {
	require_initialization_114_ast_node = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_node();
	cnst_init_137_ast_node();
	object_init_111_ast_node();
	imported_modules_init_94_ast_node();
	toplevel_init_63_ast_node();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_node()
{
   module_initialization_70___reader(((long) 0), "AST_NODE");
   module_initialization_70___object(((long) 0), "AST_NODE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_node()
{
   {
      obj_t cnst_port_138_2729;
      cnst_port_138_2729 = open_input_string(string2403_ast_node);
      {
	 long i_2730;
	 i_2730 = ((long) 22);
       loop_2731:
	 {
	    bool_t test2404_2732;
	    test2404_2732 = (i_2730 == ((long) -1));
	    if (test2404_2732)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2405_2733;
		    {
		       obj_t list2406_2734;
		       {
			  obj_t arg2407_2735;
			  arg2407_2735 = BNIL;
			  list2406_2734 = MAKE_PAIR(cnst_port_138_2729, arg2407_2735);
		       }
		       arg2405_2733 = read___reader(list2406_2734);
		    }
		    CNST_TABLE_SET(i_2730, arg2405_2733);
		 }
		 {
		    int aux_2736;
		    {
		       long aux_2755;
		       aux_2755 = (i_2730 - ((long) 1));
		       aux_2736 = (int) (aux_2755);
		    }
		    {
		       long i_2758;
		       i_2758 = (long) (aux_2736);
		       i_2730 = i_2758;
		       goto loop_2731;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_node()
{
   return BUNSPEC;
}


obj_t 
object_init_111_ast_node()
{
   {
      obj_t arg1775_700;
      arg1775_700 = object___object;
      node_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 0)), arg1775_700, allocate_node_env_214_ast_node, ((long) 5636), BUNSPEC);
   }
   {
      obj_t arg1779_704;
      arg1779_704 = node_ast_node;
      node_effect_213_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 1)), arg1779_704, allocate_node_effect_env_65_ast_node, ((long) 39433), BUNSPEC);
   }
   {
      obj_t arg1784_708;
      arg1784_708 = node_ast_node;
      atom_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 2)), arg1784_708, allocate_atom_env_206_ast_node, ((long) 52295), BUNSPEC);
   }
   {
      obj_t arg1789_712;
      arg1789_712 = node_ast_node;
      var_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 3)), arg1789_712, allocate_var_env_196_ast_node, ((long) 5910), BUNSPEC);
   }
   {
      obj_t arg1795_716;
      arg1795_716 = var_ast_node;
      closure_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 4)), arg1795_716, allocate_closure_env_30_ast_node, ((long) 55002), BUNSPEC);
   }
   {
      obj_t arg1800_720;
      arg1800_720 = node_ast_node;
      kwote_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 5)), arg1800_720, allocate_kwote_env_128_ast_node, ((long) 61740), BUNSPEC);
   }
   {
      obj_t arg1805_724;
      arg1805_724 = node_effect_213_ast_node;
      sequence_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 6)), arg1805_724, allocate_sequence_env_201_ast_node, ((long) 26192), BUNSPEC);
   }
   {
      obj_t arg1809_728;
      arg1809_728 = node_effect_213_ast_node;
      app_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 7)), arg1809_728, allocate_app_env_27_ast_node, ((long) 11924), BUNSPEC);
   }
   {
      obj_t arg1813_732;
      arg1813_732 = node_ast_node;
      app_ly_162_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 8)), arg1813_732, allocate_app_ly_env_193_ast_node, ((long) 20725), BUNSPEC);
   }
   {
      obj_t arg1821_736;
      arg1821_736 = node_ast_node;
      funcall_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 9)), arg1821_736, allocate_funcall_env_134_ast_node, ((long) 16240), BUNSPEC);
   }
   {
      obj_t arg1825_740;
      arg1825_740 = node_effect_213_ast_node;
      pragma_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 10)), arg1825_740, allocate_pragma_env_128_ast_node, ((long) 21941), BUNSPEC);
   }
   {
      obj_t arg1829_744;
      arg1829_744 = node_ast_node;
      cast_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 11)), arg1829_744, allocate_cast_env_179_ast_node, ((long) 18414), BUNSPEC);
   }
   {
      obj_t arg1833_748;
      arg1833_748 = node_ast_node;
      setq_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 12)), arg1833_748, allocate_setq_env_19_ast_node, ((long) 3599), BUNSPEC);
   }
   {
      obj_t arg1837_752;
      arg1837_752 = node_effect_213_ast_node;
      conditional_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 13)), arg1837_752, allocate_conditional_env_156_ast_node, ((long) 52700), BUNSPEC);
   }
   {
      obj_t arg1841_756;
      arg1841_756 = node_ast_node;
      fail_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 14)), arg1841_756, allocate_fail_env_28_ast_node, ((long) 3019), BUNSPEC);
   }
   {
      obj_t arg1845_760;
      arg1845_760 = node_effect_213_ast_node;
      select_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 15)), arg1845_760, allocate_select_env_246_ast_node, ((long) 19910), BUNSPEC);
   }
   {
      obj_t arg1849_764;
      arg1849_764 = node_effect_213_ast_node;
      let_fun_218_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 16)), arg1849_764, allocate_let_fun_env_44_ast_node, ((long) 17357), BUNSPEC);
   }
   {
      obj_t arg1856_768;
      arg1856_768 = node_effect_213_ast_node;
      let_var_6_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 17)), arg1856_768, allocate_let_var_env_250_ast_node, ((long) 44486), BUNSPEC);
   }
   {
      obj_t arg1860_772;
      arg1860_772 = node_ast_node;
      set_ex_it_116_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 18)), arg1860_772, allocate_set_ex_it_env_240_ast_node, ((long) 43874), BUNSPEC);
   }
   {
      obj_t arg1864_776;
      arg1864_776 = node_ast_node;
      jump_ex_it_184_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 19)), arg1864_776, allocate_jump_ex_it_env_98_ast_node, ((long) 56654), BUNSPEC);
   }
   {
      obj_t arg1870_780;
      arg1870_780 = node_effect_213_ast_node;
      make_box_202_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 20)), arg1870_780, allocate_make_box_env_148_ast_node, ((long) 53115), BUNSPEC);
   }
   {
      obj_t arg1875_784;
      arg1875_784 = node_effect_213_ast_node;
      box_ref_242_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 21)), arg1875_784, allocate_box_ref_env_189_ast_node, ((long) 36511), BUNSPEC);
   }
   {
      obj_t arg1880_788;
      arg1880_788 = node_ast_node;
      box_set__221_ast_node = add_class__117___object(CNST_TABLE_REF(((long) 22)), arg1880_788, allocate_box_set__env_30_ast_node, ((long) 12649), BUNSPEC);
   }
   {
      obj_t object__struct_box_set__198_2585;
      object__struct_box_set__198_2585 = proc2357_ast_node;
      add_method__1___object(object__struct_env_210___object, box_set__221_ast_node, object__struct_box_set__198_2585);
   }
   {
      obj_t struct_object__object_box_set__45_2584;
      struct_object__object_box_set__45_2584 = proc2358_ast_node;
      add_method__1___object(struct_object__object_env_209___object, box_set__221_ast_node, struct_object__object_box_set__45_2584);
   }
   {
      obj_t object__struct_box_ref_94_2583;
      object__struct_box_ref_94_2583 = proc2359_ast_node;
      add_method__1___object(object__struct_env_210___object, box_ref_242_ast_node, object__struct_box_ref_94_2583);
   }
   {
      obj_t struct_object__object_box_ref_217_2582;
      struct_object__object_box_ref_217_2582 = proc2360_ast_node;
      add_method__1___object(struct_object__object_env_209___object, box_ref_242_ast_node, struct_object__object_box_ref_217_2582);
   }
   {
      obj_t object__struct_make_box_59_2581;
      object__struct_make_box_59_2581 = proc2361_ast_node;
      add_method__1___object(object__struct_env_210___object, make_box_202_ast_node, object__struct_make_box_59_2581);
   }
   {
      obj_t struct_object__object_make_box_39_2580;
      struct_object__object_make_box_39_2580 = proc2362_ast_node;
      add_method__1___object(struct_object__object_env_209___object, make_box_202_ast_node, struct_object__object_make_box_39_2580);
   }
   {
      obj_t object__struct_jump_ex_it_205_2579;
      object__struct_jump_ex_it_205_2579 = proc2363_ast_node;
      add_method__1___object(object__struct_env_210___object, jump_ex_it_184_ast_node, object__struct_jump_ex_it_205_2579);
   }
   {
      obj_t struct_object__object_jump_ex_it_246_2578;
      struct_object__object_jump_ex_it_246_2578 = proc2364_ast_node;
      add_method__1___object(struct_object__object_env_209___object, jump_ex_it_184_ast_node, struct_object__object_jump_ex_it_246_2578);
   }
   {
      obj_t object__struct_set_ex_it_235_2577;
      object__struct_set_ex_it_235_2577 = proc2365_ast_node;
      add_method__1___object(object__struct_env_210___object, set_ex_it_116_ast_node, object__struct_set_ex_it_235_2577);
   }
   {
      obj_t struct_object__object_set_ex_it_208_2576;
      struct_object__object_set_ex_it_208_2576 = proc2366_ast_node;
      add_method__1___object(struct_object__object_env_209___object, set_ex_it_116_ast_node, struct_object__object_set_ex_it_208_2576);
   }
   {
      obj_t object__struct_let_var_26_2575;
      object__struct_let_var_26_2575 = proc2367_ast_node;
      add_method__1___object(object__struct_env_210___object, let_var_6_ast_node, object__struct_let_var_26_2575);
   }
   {
      obj_t struct_object__object_let_var_153_2574;
      struct_object__object_let_var_153_2574 = proc2368_ast_node;
      add_method__1___object(struct_object__object_env_209___object, let_var_6_ast_node, struct_object__object_let_var_153_2574);
   }
   {
      obj_t object__struct_let_fun_125_2573;
      object__struct_let_fun_125_2573 = proc2369_ast_node;
      add_method__1___object(object__struct_env_210___object, let_fun_218_ast_node, object__struct_let_fun_125_2573);
   }
   {
      obj_t struct_object__object_let_fun_200_2572;
      struct_object__object_let_fun_200_2572 = proc2370_ast_node;
      add_method__1___object(struct_object__object_env_209___object, let_fun_218_ast_node, struct_object__object_let_fun_200_2572);
   }
   {
      obj_t object__struct_select_180_2571;
      object__struct_select_180_2571 = proc2371_ast_node;
      add_method__1___object(object__struct_env_210___object, select_ast_node, object__struct_select_180_2571);
   }
   {
      obj_t struct_object__object_select_156_2570;
      struct_object__object_select_156_2570 = proc2372_ast_node;
      add_method__1___object(struct_object__object_env_209___object, select_ast_node, struct_object__object_select_156_2570);
   }
   {
      obj_t object__struct_fail_140_2569;
      object__struct_fail_140_2569 = proc2373_ast_node;
      add_method__1___object(object__struct_env_210___object, fail_ast_node, object__struct_fail_140_2569);
   }
   {
      obj_t struct_object__object_fail_96_2568;
      struct_object__object_fail_96_2568 = proc2374_ast_node;
      add_method__1___object(struct_object__object_env_209___object, fail_ast_node, struct_object__object_fail_96_2568);
   }
   {
      obj_t object__struct_conditional_60_2567;
      object__struct_conditional_60_2567 = proc2375_ast_node;
      add_method__1___object(object__struct_env_210___object, conditional_ast_node, object__struct_conditional_60_2567);
   }
   {
      obj_t struct_object__object_conditional_24_2566;
      struct_object__object_conditional_24_2566 = proc2376_ast_node;
      add_method__1___object(struct_object__object_env_209___object, conditional_ast_node, struct_object__object_conditional_24_2566);
   }
   {
      obj_t object__struct_setq_205_2565;
      object__struct_setq_205_2565 = proc2377_ast_node;
      add_method__1___object(object__struct_env_210___object, setq_ast_node, object__struct_setq_205_2565);
   }
   {
      obj_t struct_object__object_setq_124_2564;
      struct_object__object_setq_124_2564 = proc2378_ast_node;
      add_method__1___object(struct_object__object_env_209___object, setq_ast_node, struct_object__object_setq_124_2564);
   }
   {
      obj_t object__struct_cast_161_2563;
      object__struct_cast_161_2563 = proc2379_ast_node;
      add_method__1___object(object__struct_env_210___object, cast_ast_node, object__struct_cast_161_2563);
   }
   {
      obj_t struct_object__object_cast_16_2562;
      struct_object__object_cast_16_2562 = proc2380_ast_node;
      add_method__1___object(struct_object__object_env_209___object, cast_ast_node, struct_object__object_cast_16_2562);
   }
   {
      obj_t object__struct_pragma_207_2561;
      object__struct_pragma_207_2561 = proc2381_ast_node;
      add_method__1___object(object__struct_env_210___object, pragma_ast_node, object__struct_pragma_207_2561);
   }
   {
      obj_t struct_object__object_pragma_2_2560;
      struct_object__object_pragma_2_2560 = proc2382_ast_node;
      add_method__1___object(struct_object__object_env_209___object, pragma_ast_node, struct_object__object_pragma_2_2560);
   }
   {
      obj_t object__struct_funcall_68_2559;
      object__struct_funcall_68_2559 = proc2383_ast_node;
      add_method__1___object(object__struct_env_210___object, funcall_ast_node, object__struct_funcall_68_2559);
   }
   {
      obj_t struct_object__object_funcall_136_2558;
      struct_object__object_funcall_136_2558 = proc2384_ast_node;
      add_method__1___object(struct_object__object_env_209___object, funcall_ast_node, struct_object__object_funcall_136_2558);
   }
   {
      obj_t object__struct_app_ly_240_2557;
      object__struct_app_ly_240_2557 = proc2385_ast_node;
      add_method__1___object(object__struct_env_210___object, app_ly_162_ast_node, object__struct_app_ly_240_2557);
   }
   {
      obj_t struct_object__object_app_ly_165_2556;
      struct_object__object_app_ly_165_2556 = proc2386_ast_node;
      add_method__1___object(struct_object__object_env_209___object, app_ly_162_ast_node, struct_object__object_app_ly_165_2556);
   }
   {
      obj_t object__struct_app_142_2555;
      object__struct_app_142_2555 = proc2387_ast_node;
      add_method__1___object(object__struct_env_210___object, app_ast_node, object__struct_app_142_2555);
   }
   {
      obj_t struct_object__object_app_63_2554;
      struct_object__object_app_63_2554 = proc2388_ast_node;
      add_method__1___object(struct_object__object_env_209___object, app_ast_node, struct_object__object_app_63_2554);
   }
   {
      obj_t object__struct_sequence_112_2553;
      object__struct_sequence_112_2553 = proc2389_ast_node;
      add_method__1___object(object__struct_env_210___object, sequence_ast_node, object__struct_sequence_112_2553);
   }
   {
      obj_t struct_object__object_sequence_200_2552;
      struct_object__object_sequence_200_2552 = proc2390_ast_node;
      add_method__1___object(struct_object__object_env_209___object, sequence_ast_node, struct_object__object_sequence_200_2552);
   }
   {
      obj_t object__struct_kwote_66_2551;
      object__struct_kwote_66_2551 = proc2391_ast_node;
      add_method__1___object(object__struct_env_210___object, kwote_ast_node, object__struct_kwote_66_2551);
   }
   {
      obj_t struct_object__object_kwote_75_2550;
      struct_object__object_kwote_75_2550 = proc2392_ast_node;
      add_method__1___object(struct_object__object_env_209___object, kwote_ast_node, struct_object__object_kwote_75_2550);
   }
   {
      obj_t object__struct_closure_29_2549;
      object__struct_closure_29_2549 = proc2393_ast_node;
      add_method__1___object(object__struct_env_210___object, closure_ast_node, object__struct_closure_29_2549);
   }
   {
      obj_t struct_object__object_closure_48_2548;
      struct_object__object_closure_48_2548 = proc2394_ast_node;
      add_method__1___object(struct_object__object_env_209___object, closure_ast_node, struct_object__object_closure_48_2548);
   }
   {
      obj_t object__struct_var_159_2547;
      object__struct_var_159_2547 = proc2395_ast_node;
      add_method__1___object(object__struct_env_210___object, var_ast_node, object__struct_var_159_2547);
   }
   {
      obj_t struct_object__object_var_138_2546;
      struct_object__object_var_138_2546 = proc2396_ast_node;
      add_method__1___object(struct_object__object_env_209___object, var_ast_node, struct_object__object_var_138_2546);
   }
   {
      obj_t object__struct_atom_114_2545;
      object__struct_atom_114_2545 = proc2397_ast_node;
      add_method__1___object(object__struct_env_210___object, atom_ast_node, object__struct_atom_114_2545);
   }
   {
      obj_t struct_object__object_atom_177_2544;
      struct_object__object_atom_177_2544 = proc2398_ast_node;
      add_method__1___object(struct_object__object_env_209___object, atom_ast_node, struct_object__object_atom_177_2544);
   }
   {
      obj_t object__struct_node_effect_233_2543;
      object__struct_node_effect_233_2543 = proc2399_ast_node;
      add_method__1___object(object__struct_env_210___object, node_effect_213_ast_node, object__struct_node_effect_233_2543);
   }
   {
      obj_t struct_object__object_node_effect_227_2542;
      struct_object__object_node_effect_227_2542 = proc2400_ast_node;
      add_method__1___object(struct_object__object_env_209___object, node_effect_213_ast_node, struct_object__object_node_effect_227_2542);
   }
   {
      obj_t object__struct_node_0_2541;
      object__struct_node_0_2541 = proc2401_ast_node;
      add_method__1___object(object__struct_env_210___object, node_ast_node, object__struct_node_0_2541);
   }
   {
      obj_t struct_object__object_node_196_2540;
      struct_object__object_node_196_2540 = proc2402_ast_node;
      return add_method__1___object(struct_object__object_env_209___object, node_ast_node, struct_object__object_node_196_2540);
   }
}


obj_t 
struct_object__object_node2308_118_ast_node(obj_t env_2586, obj_t o_2587, obj_t s_2588)
{
   {
      node_t o_1415;
      obj_t s_1416;
      {
	 node_t aux_2852;
	 o_1415 = (node_t) (o_2587);
	 s_1416 = s_2588;
	 {
	    obj_t aux_2855;
	    object_t aux_2853;
	    aux_2855 = STRUCT_REF(s_1416, ((long) 0));
	    aux_2853 = (object_t) (o_1415);
	    OBJECT_WIDENING_SET(aux_2853, aux_2855);
	 }
	 {
	    obj_t v1120_1420;
	    v1120_1420 = STRUCT_REF(s_1416, ((long) 1));
	    ((((node_t) CREF(o_1415))->loc) = ((obj_t) v1120_1420), BUNSPEC);
	 }
	 {
	    type_t v1124_1421;
	    {
	       obj_t aux_2860;
	       aux_2860 = STRUCT_REF(s_1416, ((long) 2));
	       v1124_1421 = (type_t) (aux_2860);
	    }
	    ((((node_t) CREF(o_1415))->type) = ((type_t) v1124_1421), BUNSPEC);
	 }
	 aux_2852 = o_1415;
	 return (obj_t) (aux_2852);
      }
   }
}


obj_t 
object__struct_node2309_44_ast_node(obj_t env_2589, obj_t obj1116_2590)
{
   {
      node_t obj1116_1403;
      obj1116_1403 = (node_t) (obj1116_2590);
      {
	 obj_t res1117_1406;
	 {
	    obj_t aux_2866;
	    aux_2866 = CNST_TABLE_REF(((long) 0));
	    res1117_1406 = make_struct(aux_2866, ((long) 3), BUNSPEC);
	 }
	 STRUCT_SET(res1117_1406, ((long) 0), BFALSE);
	 {
	    obj_t aux_2870;
	    aux_2870 = (((node_t) CREF(obj1116_1403))->loc);
	    STRUCT_SET(res1117_1406, ((long) 1), aux_2870);
	 }
	 {
	    obj_t aux_2873;
	    {
	       type_t aux_2874;
	       aux_2874 = (((node_t) CREF(obj1116_1403))->type);
	       aux_2873 = (obj_t) (aux_2874);
	    }
	    STRUCT_SET(res1117_1406, ((long) 2), aux_2873);
	 }
	 return res1117_1406;
      }
   }
}


obj_t 
struct_object__object_node_effect2310_4_ast_node(obj_t env_2591, obj_t o_2592, obj_t s_2593)
{
   {
      node_effect_213_t o_1393;
      obj_t s_1394;
      {
	 node_effect_213_t aux_2879;
	 o_1393 = (node_effect_213_t) (o_2592);
	 s_1394 = s_2593;
	 {
	    obj_t aux_2882;
	    object_t aux_2880;
	    aux_2882 = STRUCT_REF(s_1394, ((long) 0));
	    aux_2880 = (object_t) (o_1393);
	    OBJECT_WIDENING_SET(aux_2880, aux_2882);
	 }
	 {
	    obj_t v1136_1398;
	    v1136_1398 = STRUCT_REF(s_1394, ((long) 1));
	    ((((node_effect_213_t) CREF(o_1393))->loc) = ((obj_t) v1136_1398), BUNSPEC);
	 }
	 {
	    type_t v1140_1399;
	    {
	       obj_t aux_2887;
	       aux_2887 = STRUCT_REF(s_1394, ((long) 2));
	       v1140_1399 = (type_t) (aux_2887);
	    }
	    ((((node_effect_213_t) CREF(o_1393))->type) = ((type_t) v1140_1399), BUNSPEC);
	 }
	 {
	    obj_t v1144_1400;
	    v1144_1400 = STRUCT_REF(s_1394, ((long) 3));
	    ((((node_effect_213_t) CREF(o_1393))->side_effect__165) = ((obj_t) v1144_1400), BUNSPEC);
	 }
	 aux_2879 = o_1393;
	 return (obj_t) (aux_2879);
      }
   }
}


obj_t 
object__struct_node_effect2311_124_ast_node(obj_t env_2594, obj_t obj1132_2595)
{
   {
      node_effect_213_t obj1132_1379;
      obj1132_1379 = (node_effect_213_t) (obj1132_2595);
      {
	 obj_t res1133_1382;
	 {
	    obj_t aux_2895;
	    aux_2895 = CNST_TABLE_REF(((long) 1));
	    res1133_1382 = make_struct(aux_2895, ((long) 4), BUNSPEC);
	 }
	 STRUCT_SET(res1133_1382, ((long) 0), BFALSE);
	 {
	    obj_t aux_2899;
	    aux_2899 = (((node_effect_213_t) CREF(obj1132_1379))->loc);
	    STRUCT_SET(res1133_1382, ((long) 1), aux_2899);
	 }
	 {
	    obj_t aux_2902;
	    {
	       type_t aux_2903;
	       aux_2903 = (((node_effect_213_t) CREF(obj1132_1379))->type);
	       aux_2902 = (obj_t) (aux_2903);
	    }
	    STRUCT_SET(res1133_1382, ((long) 2), aux_2902);
	 }
	 {
	    obj_t aux_2907;
	    aux_2907 = (((node_effect_213_t) CREF(obj1132_1379))->side_effect__165);
	    STRUCT_SET(res1133_1382, ((long) 3), aux_2907);
	 }
	 return res1133_1382;
      }
   }
}


obj_t 
struct_object__object_atom2312_22_ast_node(obj_t env_2596, obj_t o_2597, obj_t s_2598)
{
   {
      atom_t o_1369;
      obj_t s_1370;
      {
	 atom_t aux_2911;
	 o_1369 = (atom_t) (o_2597);
	 s_1370 = s_2598;
	 {
	    obj_t aux_2914;
	    object_t aux_2912;
	    aux_2914 = STRUCT_REF(s_1370, ((long) 0));
	    aux_2912 = (object_t) (o_1369);
	    OBJECT_WIDENING_SET(aux_2912, aux_2914);
	 }
	 {
	    obj_t v1156_1374;
	    v1156_1374 = STRUCT_REF(s_1370, ((long) 1));
	    ((((atom_t) CREF(o_1369))->loc) = ((obj_t) v1156_1374), BUNSPEC);
	 }
	 {
	    type_t v1160_1375;
	    {
	       obj_t aux_2919;
	       aux_2919 = STRUCT_REF(s_1370, ((long) 2));
	       v1160_1375 = (type_t) (aux_2919);
	    }
	    ((((atom_t) CREF(o_1369))->type) = ((type_t) v1160_1375), BUNSPEC);
	 }
	 {
	    obj_t v1164_1376;
	    v1164_1376 = STRUCT_REF(s_1370, ((long) 3));
	    ((((atom_t) CREF(o_1369))->value) = ((obj_t) v1164_1376), BUNSPEC);
	 }
	 aux_2911 = o_1369;
	 return (obj_t) (aux_2911);
      }
   }
}


obj_t 
object__struct_atom2313_17_ast_node(obj_t env_2599, obj_t obj1152_2600)
{
   {
      atom_t obj1152_1355;
      obj1152_1355 = (atom_t) (obj1152_2600);
      {
	 obj_t res1153_1358;
	 {
	    obj_t aux_2927;
	    aux_2927 = CNST_TABLE_REF(((long) 2));
	    res1153_1358 = make_struct(aux_2927, ((long) 4), BUNSPEC);
	 }
	 STRUCT_SET(res1153_1358, ((long) 0), BFALSE);
	 {
	    obj_t aux_2931;
	    aux_2931 = (((atom_t) CREF(obj1152_1355))->loc);
	    STRUCT_SET(res1153_1358, ((long) 1), aux_2931);
	 }
	 {
	    obj_t aux_2934;
	    {
	       type_t aux_2935;
	       aux_2935 = (((atom_t) CREF(obj1152_1355))->type);
	       aux_2934 = (obj_t) (aux_2935);
	    }
	    STRUCT_SET(res1153_1358, ((long) 2), aux_2934);
	 }
	 {
	    obj_t aux_2939;
	    aux_2939 = (((atom_t) CREF(obj1152_1355))->value);
	    STRUCT_SET(res1153_1358, ((long) 3), aux_2939);
	 }
	 return res1153_1358;
      }
   }
}


obj_t 
struct_object__object_var2314_179_ast_node(obj_t env_2601, obj_t o_2602, obj_t s_2603)
{
   {
      var_t o_1345;
      obj_t s_1346;
      {
	 var_t aux_2943;
	 o_1345 = (var_t) (o_2602);
	 s_1346 = s_2603;
	 {
	    obj_t aux_2946;
	    object_t aux_2944;
	    aux_2946 = STRUCT_REF(s_1346, ((long) 0));
	    aux_2944 = (object_t) (o_1345);
	    OBJECT_WIDENING_SET(aux_2944, aux_2946);
	 }
	 {
	    obj_t v1176_1350;
	    v1176_1350 = STRUCT_REF(s_1346, ((long) 1));
	    ((((var_t) CREF(o_1345))->loc) = ((obj_t) v1176_1350), BUNSPEC);
	 }
	 {
	    type_t v1180_1351;
	    {
	       obj_t aux_2951;
	       aux_2951 = STRUCT_REF(s_1346, ((long) 2));
	       v1180_1351 = (type_t) (aux_2951);
	    }
	    ((((var_t) CREF(o_1345))->type) = ((type_t) v1180_1351), BUNSPEC);
	 }
	 {
	    variable_t v1184_1352;
	    {
	       obj_t aux_2955;
	       aux_2955 = STRUCT_REF(s_1346, ((long) 3));
	       v1184_1352 = (variable_t) (aux_2955);
	    }
	    ((((var_t) CREF(o_1345))->variable) = ((variable_t) v1184_1352), BUNSPEC);
	 }
	 aux_2943 = o_1345;
	 return (obj_t) (aux_2943);
      }
   }
}


obj_t 
object__struct_var2315_201_ast_node(obj_t env_2604, obj_t obj1172_2605)
{
   {
      var_t obj1172_1331;
      obj1172_1331 = (var_t) (obj1172_2605);
      {
	 obj_t res1173_1334;
	 {
	    obj_t aux_2961;
	    aux_2961 = CNST_TABLE_REF(((long) 3));
	    res1173_1334 = make_struct(aux_2961, ((long) 4), BUNSPEC);
	 }
	 STRUCT_SET(res1173_1334, ((long) 0), BFALSE);
	 {
	    obj_t aux_2965;
	    aux_2965 = (((var_t) CREF(obj1172_1331))->loc);
	    STRUCT_SET(res1173_1334, ((long) 1), aux_2965);
	 }
	 {
	    obj_t aux_2968;
	    {
	       type_t aux_2969;
	       aux_2969 = (((var_t) CREF(obj1172_1331))->type);
	       aux_2968 = (obj_t) (aux_2969);
	    }
	    STRUCT_SET(res1173_1334, ((long) 2), aux_2968);
	 }
	 {
	    obj_t aux_2973;
	    {
	       variable_t aux_2974;
	       aux_2974 = (((var_t) CREF(obj1172_1331))->variable);
	       aux_2973 = (obj_t) (aux_2974);
	    }
	    STRUCT_SET(res1173_1334, ((long) 3), aux_2973);
	 }
	 return res1173_1334;
      }
   }
}


obj_t 
struct_object__object_closure2316_120_ast_node(obj_t env_2606, obj_t o_2607, obj_t s_2608)
{
   {
      closure_t o_1321;
      obj_t s_1322;
      {
	 closure_t aux_2979;
	 o_1321 = (closure_t) (o_2607);
	 s_1322 = s_2608;
	 {
	    obj_t aux_2982;
	    object_t aux_2980;
	    aux_2982 = STRUCT_REF(s_1322, ((long) 0));
	    aux_2980 = (object_t) (o_1321);
	    OBJECT_WIDENING_SET(aux_2980, aux_2982);
	 }
	 {
	    obj_t v1196_1326;
	    v1196_1326 = STRUCT_REF(s_1322, ((long) 1));
	    ((((closure_t) CREF(o_1321))->loc) = ((obj_t) v1196_1326), BUNSPEC);
	 }
	 {
	    type_t v1200_1327;
	    {
	       obj_t aux_2987;
	       aux_2987 = STRUCT_REF(s_1322, ((long) 2));
	       v1200_1327 = (type_t) (aux_2987);
	    }
	    ((((closure_t) CREF(o_1321))->type) = ((type_t) v1200_1327), BUNSPEC);
	 }
	 {
	    variable_t v1204_1328;
	    {
	       obj_t aux_2991;
	       aux_2991 = STRUCT_REF(s_1322, ((long) 3));
	       v1204_1328 = (variable_t) (aux_2991);
	    }
	    ((((closure_t) CREF(o_1321))->variable) = ((variable_t) v1204_1328), BUNSPEC);
	 }
	 aux_2979 = o_1321;
	 return (obj_t) (aux_2979);
      }
   }
}


obj_t 
object__struct_closure2317_164_ast_node(obj_t env_2609, obj_t obj1192_2610)
{
   {
      closure_t obj1192_1307;
      obj1192_1307 = (closure_t) (obj1192_2610);
      {
	 obj_t res1193_1310;
	 {
	    obj_t aux_2997;
	    aux_2997 = CNST_TABLE_REF(((long) 4));
	    res1193_1310 = make_struct(aux_2997, ((long) 4), BUNSPEC);
	 }
	 STRUCT_SET(res1193_1310, ((long) 0), BFALSE);
	 {
	    obj_t aux_3001;
	    aux_3001 = (((closure_t) CREF(obj1192_1307))->loc);
	    STRUCT_SET(res1193_1310, ((long) 1), aux_3001);
	 }
	 {
	    obj_t aux_3004;
	    {
	       type_t aux_3005;
	       aux_3005 = (((closure_t) CREF(obj1192_1307))->type);
	       aux_3004 = (obj_t) (aux_3005);
	    }
	    STRUCT_SET(res1193_1310, ((long) 2), aux_3004);
	 }
	 {
	    obj_t aux_3009;
	    {
	       variable_t aux_3010;
	       aux_3010 = (((closure_t) CREF(obj1192_1307))->variable);
	       aux_3009 = (obj_t) (aux_3010);
	    }
	    STRUCT_SET(res1193_1310, ((long) 3), aux_3009);
	 }
	 return res1193_1310;
      }
   }
}


obj_t 
struct_object__object_kwote2318_170_ast_node(obj_t env_2611, obj_t o_2612, obj_t s_2613)
{
   {
      kwote_t o_1297;
      obj_t s_1298;
      {
	 kwote_t aux_3015;
	 o_1297 = (kwote_t) (o_2612);
	 s_1298 = s_2613;
	 {
	    obj_t aux_3018;
	    object_t aux_3016;
	    aux_3018 = STRUCT_REF(s_1298, ((long) 0));
	    aux_3016 = (object_t) (o_1297);
	    OBJECT_WIDENING_SET(aux_3016, aux_3018);
	 }
	 {
	    obj_t v1216_1302;
	    v1216_1302 = STRUCT_REF(s_1298, ((long) 1));
	    ((((kwote_t) CREF(o_1297))->loc) = ((obj_t) v1216_1302), BUNSPEC);
	 }
	 {
	    type_t v1222_1303;
	    {
	       obj_t aux_3023;
	       aux_3023 = STRUCT_REF(s_1298, ((long) 2));
	       v1222_1303 = (type_t) (aux_3023);
	    }
	    ((((kwote_t) CREF(o_1297))->type) = ((type_t) v1222_1303), BUNSPEC);
	 }
	 {
	    obj_t v1227_1304;
	    v1227_1304 = STRUCT_REF(s_1298, ((long) 3));
	    ((((kwote_t) CREF(o_1297))->value) = ((obj_t) v1227_1304), BUNSPEC);
	 }
	 aux_3015 = o_1297;
	 return (obj_t) (aux_3015);
      }
   }
}


obj_t 
object__struct_kwote2319_84_ast_node(obj_t env_2614, obj_t obj1212_2615)
{
   {
      kwote_t obj1212_1283;
      obj1212_1283 = (kwote_t) (obj1212_2615);
      {
	 obj_t res1213_1286;
	 {
	    obj_t aux_3031;
	    aux_3031 = CNST_TABLE_REF(((long) 5));
	    res1213_1286 = make_struct(aux_3031, ((long) 4), BUNSPEC);
	 }
	 STRUCT_SET(res1213_1286, ((long) 0), BFALSE);
	 {
	    obj_t aux_3035;
	    aux_3035 = (((kwote_t) CREF(obj1212_1283))->loc);
	    STRUCT_SET(res1213_1286, ((long) 1), aux_3035);
	 }
	 {
	    obj_t aux_3038;
	    {
	       type_t aux_3039;
	       aux_3039 = (((kwote_t) CREF(obj1212_1283))->type);
	       aux_3038 = (obj_t) (aux_3039);
	    }
	    STRUCT_SET(res1213_1286, ((long) 2), aux_3038);
	 }
	 {
	    obj_t aux_3043;
	    aux_3043 = (((kwote_t) CREF(obj1212_1283))->value);
	    STRUCT_SET(res1213_1286, ((long) 3), aux_3043);
	 }
	 return res1213_1286;
      }
   }
}


obj_t 
struct_object__object_sequence2320_161_ast_node(obj_t env_2616, obj_t o_2617, obj_t s_2618)
{
   {
      sequence_t o_1272;
      obj_t s_1273;
      {
	 sequence_t aux_3047;
	 o_1272 = (sequence_t) (o_2617);
	 s_1273 = s_2618;
	 {
	    obj_t aux_3050;
	    object_t aux_3048;
	    aux_3050 = STRUCT_REF(s_1273, ((long) 0));
	    aux_3048 = (object_t) (o_1272);
	    OBJECT_WIDENING_SET(aux_3048, aux_3050);
	 }
	 {
	    obj_t v1239_1277;
	    v1239_1277 = STRUCT_REF(s_1273, ((long) 1));
	    ((((sequence_t) CREF(o_1272))->loc) = ((obj_t) v1239_1277), BUNSPEC);
	 }
	 {
	    type_t v1244_1278;
	    {
	       obj_t aux_3055;
	       aux_3055 = STRUCT_REF(s_1273, ((long) 2));
	       v1244_1278 = (type_t) (aux_3055);
	    }
	    ((((sequence_t) CREF(o_1272))->type) = ((type_t) v1244_1278), BUNSPEC);
	 }
	 {
	    obj_t v1248_1279;
	    v1248_1279 = STRUCT_REF(s_1273, ((long) 3));
	    ((((sequence_t) CREF(o_1272))->side_effect__165) = ((obj_t) v1248_1279), BUNSPEC);
	 }
	 {
	    obj_t v1252_1280;
	    v1252_1280 = STRUCT_REF(s_1273, ((long) 4));
	    ((((sequence_t) CREF(o_1272))->nodes) = ((obj_t) v1252_1280), BUNSPEC);
	 }
	 aux_3047 = o_1272;
	 return (obj_t) (aux_3047);
      }
   }
}


obj_t 
object__struct_sequence2321_37_ast_node(obj_t env_2619, obj_t obj1235_2620)
{
   {
      sequence_t obj1235_1256;
      obj1235_1256 = (sequence_t) (obj1235_2620);
      {
	 obj_t res1236_1259;
	 {
	    obj_t aux_3065;
	    aux_3065 = CNST_TABLE_REF(((long) 6));
	    res1236_1259 = make_struct(aux_3065, ((long) 5), BUNSPEC);
	 }
	 STRUCT_SET(res1236_1259, ((long) 0), BFALSE);
	 {
	    obj_t aux_3069;
	    aux_3069 = (((sequence_t) CREF(obj1235_1256))->loc);
	    STRUCT_SET(res1236_1259, ((long) 1), aux_3069);
	 }
	 {
	    obj_t aux_3072;
	    {
	       type_t aux_3073;
	       aux_3073 = (((sequence_t) CREF(obj1235_1256))->type);
	       aux_3072 = (obj_t) (aux_3073);
	    }
	    STRUCT_SET(res1236_1259, ((long) 2), aux_3072);
	 }
	 {
	    obj_t aux_3077;
	    aux_3077 = (((sequence_t) CREF(obj1235_1256))->side_effect__165);
	    STRUCT_SET(res1236_1259, ((long) 3), aux_3077);
	 }
	 {
	    obj_t aux_3080;
	    aux_3080 = (((sequence_t) CREF(obj1235_1256))->nodes);
	    STRUCT_SET(res1236_1259, ((long) 4), aux_3080);
	 }
	 return res1236_1259;
      }
   }
}


obj_t 
struct_object__object_app2322_88_ast_node(obj_t env_2621, obj_t o_2622, obj_t s_2623)
{
   {
      app_t o_1243;
      obj_t s_1244;
      {
	 app_t aux_3084;
	 o_1243 = (app_t) (o_2622);
	 s_1244 = s_2623;
	 {
	    obj_t aux_3087;
	    object_t aux_3085;
	    aux_3087 = STRUCT_REF(s_1244, ((long) 0));
	    aux_3085 = (object_t) (o_1243);
	    OBJECT_WIDENING_SET(aux_3085, aux_3087);
	 }
	 {
	    obj_t v1267_1248;
	    v1267_1248 = STRUCT_REF(s_1244, ((long) 1));
	    ((((app_t) CREF(o_1243))->loc) = ((obj_t) v1267_1248), BUNSPEC);
	 }
	 {
	    type_t v1271_1249;
	    {
	       obj_t aux_3092;
	       aux_3092 = STRUCT_REF(s_1244, ((long) 2));
	       v1271_1249 = (type_t) (aux_3092);
	    }
	    ((((app_t) CREF(o_1243))->type) = ((type_t) v1271_1249), BUNSPEC);
	 }
	 {
	    obj_t v1275_1250;
	    v1275_1250 = STRUCT_REF(s_1244, ((long) 3));
	    ((((app_t) CREF(o_1243))->side_effect__165) = ((obj_t) v1275_1250), BUNSPEC);
	 }
	 {
	    var_t v1279_1251;
	    {
	       obj_t aux_3098;
	       aux_3098 = STRUCT_REF(s_1244, ((long) 4));
	       v1279_1251 = (var_t) (aux_3098);
	    }
	    ((((app_t) CREF(o_1243))->fun) = ((var_t) v1279_1251), BUNSPEC);
	 }
	 {
	    obj_t v1283_1252;
	    v1283_1252 = STRUCT_REF(s_1244, ((long) 5));
	    ((((app_t) CREF(o_1243))->args) = ((obj_t) v1283_1252), BUNSPEC);
	 }
	 {
	    obj_t v1287_1253;
	    v1287_1253 = STRUCT_REF(s_1244, ((long) 6));
	    ((((app_t) CREF(o_1243))->stack_info_255) = ((obj_t) v1287_1253), BUNSPEC);
	 }
	 aux_3084 = o_1243;
	 return (obj_t) (aux_3084);
      }
   }
}


obj_t 
object__struct_app2323_235_ast_node(obj_t env_2624, obj_t obj1263_2625)
{
   {
      app_t obj1263_1223;
      obj1263_1223 = (app_t) (obj1263_2625);
      {
	 obj_t res1264_1226;
	 {
	    obj_t aux_3108;
	    aux_3108 = CNST_TABLE_REF(((long) 7));
	    res1264_1226 = make_struct(aux_3108, ((long) 7), BUNSPEC);
	 }
	 STRUCT_SET(res1264_1226, ((long) 0), BFALSE);
	 {
	    obj_t aux_3112;
	    aux_3112 = (((app_t) CREF(obj1263_1223))->loc);
	    STRUCT_SET(res1264_1226, ((long) 1), aux_3112);
	 }
	 {
	    obj_t aux_3115;
	    {
	       type_t aux_3116;
	       aux_3116 = (((app_t) CREF(obj1263_1223))->type);
	       aux_3115 = (obj_t) (aux_3116);
	    }
	    STRUCT_SET(res1264_1226, ((long) 2), aux_3115);
	 }
	 {
	    obj_t aux_3120;
	    aux_3120 = (((app_t) CREF(obj1263_1223))->side_effect__165);
	    STRUCT_SET(res1264_1226, ((long) 3), aux_3120);
	 }
	 {
	    obj_t aux_3123;
	    {
	       var_t aux_3124;
	       aux_3124 = (((app_t) CREF(obj1263_1223))->fun);
	       aux_3123 = (obj_t) (aux_3124);
	    }
	    STRUCT_SET(res1264_1226, ((long) 4), aux_3123);
	 }
	 {
	    obj_t aux_3128;
	    aux_3128 = (((app_t) CREF(obj1263_1223))->args);
	    STRUCT_SET(res1264_1226, ((long) 5), aux_3128);
	 }
	 {
	    obj_t aux_3131;
	    aux_3131 = (((app_t) CREF(obj1263_1223))->stack_info_255);
	    STRUCT_SET(res1264_1226, ((long) 6), aux_3131);
	 }
	 return res1264_1226;
      }
   }
}


obj_t 
struct_object__object_app_ly2324_236_ast_node(obj_t env_2626, obj_t o_2627, obj_t s_2628)
{
   {
      app_ly_162_t o_1212;
      obj_t s_1213;
      {
	 app_ly_162_t aux_3135;
	 o_1212 = (app_ly_162_t) (o_2627);
	 s_1213 = s_2628;
	 {
	    obj_t aux_3138;
	    object_t aux_3136;
	    aux_3138 = STRUCT_REF(s_1213, ((long) 0));
	    aux_3136 = (object_t) (o_1212);
	    OBJECT_WIDENING_SET(aux_3136, aux_3138);
	 }
	 {
	    obj_t v1300_1217;
	    v1300_1217 = STRUCT_REF(s_1213, ((long) 1));
	    ((((app_ly_162_t) CREF(o_1212))->loc) = ((obj_t) v1300_1217), BUNSPEC);
	 }
	 {
	    type_t v1304_1218;
	    {
	       obj_t aux_3143;
	       aux_3143 = STRUCT_REF(s_1213, ((long) 2));
	       v1304_1218 = (type_t) (aux_3143);
	    }
	    ((((app_ly_162_t) CREF(o_1212))->type) = ((type_t) v1304_1218), BUNSPEC);
	 }
	 {
	    node_t v1308_1219;
	    {
	       obj_t aux_3147;
	       aux_3147 = STRUCT_REF(s_1213, ((long) 3));
	       v1308_1219 = (node_t) (aux_3147);
	    }
	    ((((app_ly_162_t) CREF(o_1212))->fun) = ((node_t) v1308_1219), BUNSPEC);
	 }
	 {
	    node_t v1312_1220;
	    {
	       obj_t aux_3151;
	       aux_3151 = STRUCT_REF(s_1213, ((long) 4));
	       v1312_1220 = (node_t) (aux_3151);
	    }
	    ((((app_ly_162_t) CREF(o_1212))->arg) = ((node_t) v1312_1220), BUNSPEC);
	 }
	 aux_3135 = o_1212;
	 return (obj_t) (aux_3135);
      }
   }
}


obj_t 
object__struct_app_ly2325_233_ast_node(obj_t env_2629, obj_t obj1296_2630)
{
   {
      app_ly_162_t obj1296_1196;
      obj1296_1196 = (app_ly_162_t) (obj1296_2630);
      {
	 obj_t res1297_1199;
	 {
	    obj_t aux_3157;
	    aux_3157 = CNST_TABLE_REF(((long) 8));
	    res1297_1199 = make_struct(aux_3157, ((long) 5), BUNSPEC);
	 }
	 STRUCT_SET(res1297_1199, ((long) 0), BFALSE);
	 {
	    obj_t aux_3161;
	    aux_3161 = (((app_ly_162_t) CREF(obj1296_1196))->loc);
	    STRUCT_SET(res1297_1199, ((long) 1), aux_3161);
	 }
	 {
	    obj_t aux_3164;
	    {
	       type_t aux_3165;
	       aux_3165 = (((app_ly_162_t) CREF(obj1296_1196))->type);
	       aux_3164 = (obj_t) (aux_3165);
	    }
	    STRUCT_SET(res1297_1199, ((long) 2), aux_3164);
	 }
	 {
	    obj_t aux_3169;
	    {
	       node_t aux_3170;
	       aux_3170 = (((app_ly_162_t) CREF(obj1296_1196))->fun);
	       aux_3169 = (obj_t) (aux_3170);
	    }
	    STRUCT_SET(res1297_1199, ((long) 3), aux_3169);
	 }
	 {
	    obj_t aux_3174;
	    {
	       node_t aux_3175;
	       aux_3175 = (((app_ly_162_t) CREF(obj1296_1196))->arg);
	       aux_3174 = (obj_t) (aux_3175);
	    }
	    STRUCT_SET(res1297_1199, ((long) 4), aux_3174);
	 }
	 return res1297_1199;
      }
   }
}


obj_t 
struct_object__object_funcall2326_94_ast_node(obj_t env_2631, obj_t o_2632, obj_t s_2633)
{
   {
      funcall_t o_1184;
      obj_t s_1185;
      {
	 funcall_t aux_3180;
	 o_1184 = (funcall_t) (o_2632);
	 s_1185 = s_2633;
	 {
	    obj_t aux_3183;
	    object_t aux_3181;
	    aux_3183 = STRUCT_REF(s_1185, ((long) 0));
	    aux_3181 = (object_t) (o_1184);
	    OBJECT_WIDENING_SET(aux_3181, aux_3183);
	 }
	 {
	    obj_t v1327_1189;
	    v1327_1189 = STRUCT_REF(s_1185, ((long) 1));
	    ((((funcall_t) CREF(o_1184))->loc) = ((obj_t) v1327_1189), BUNSPEC);
	 }
	 {
	    type_t v1331_1190;
	    {
	       obj_t aux_3188;
	       aux_3188 = STRUCT_REF(s_1185, ((long) 2));
	       v1331_1190 = (type_t) (aux_3188);
	    }
	    ((((funcall_t) CREF(o_1184))->type) = ((type_t) v1331_1190), BUNSPEC);
	 }
	 {
	    node_t v1335_1191;
	    {
	       obj_t aux_3192;
	       aux_3192 = STRUCT_REF(s_1185, ((long) 3));
	       v1335_1191 = (node_t) (aux_3192);
	    }
	    ((((funcall_t) CREF(o_1184))->fun) = ((node_t) v1335_1191), BUNSPEC);
	 }
	 {
	    obj_t v1339_1192;
	    v1339_1192 = STRUCT_REF(s_1185, ((long) 4));
	    ((((funcall_t) CREF(o_1184))->args) = ((obj_t) v1339_1192), BUNSPEC);
	 }
	 {
	    obj_t v1343_1193;
	    v1343_1193 = STRUCT_REF(s_1185, ((long) 5));
	    ((((funcall_t) CREF(o_1184))->strength) = ((obj_t) v1343_1193), BUNSPEC);
	 }
	 aux_3180 = o_1184;
	 return (obj_t) (aux_3180);
      }
   }
}


obj_t 
object__struct_funcall2327_159_ast_node(obj_t env_2634, obj_t obj1322_2635)
{
   {
      funcall_t obj1322_1166;
      obj1322_1166 = (funcall_t) (obj1322_2635);
      {
	 obj_t res1323_1169;
	 {
	    obj_t aux_3202;
	    aux_3202 = CNST_TABLE_REF(((long) 9));
	    res1323_1169 = make_struct(aux_3202, ((long) 6), BUNSPEC);
	 }
	 STRUCT_SET(res1323_1169, ((long) 0), BFALSE);
	 {
	    obj_t aux_3206;
	    aux_3206 = (((funcall_t) CREF(obj1322_1166))->loc);
	    STRUCT_SET(res1323_1169, ((long) 1), aux_3206);
	 }
	 {
	    obj_t aux_3209;
	    {
	       type_t aux_3210;
	       aux_3210 = (((funcall_t) CREF(obj1322_1166))->type);
	       aux_3209 = (obj_t) (aux_3210);
	    }
	    STRUCT_SET(res1323_1169, ((long) 2), aux_3209);
	 }
	 {
	    obj_t aux_3214;
	    {
	       node_t aux_3215;
	       aux_3215 = (((funcall_t) CREF(obj1322_1166))->fun);
	       aux_3214 = (obj_t) (aux_3215);
	    }
	    STRUCT_SET(res1323_1169, ((long) 3), aux_3214);
	 }
	 {
	    obj_t aux_3219;
	    aux_3219 = (((funcall_t) CREF(obj1322_1166))->args);
	    STRUCT_SET(res1323_1169, ((long) 4), aux_3219);
	 }
	 {
	    obj_t aux_3222;
	    aux_3222 = (((funcall_t) CREF(obj1322_1166))->strength);
	    STRUCT_SET(res1323_1169, ((long) 5), aux_3222);
	 }
	 return res1323_1169;
      }
   }
}


obj_t 
struct_object__object_pragma2328_3_ast_node(obj_t env_2636, obj_t o_2637, obj_t s_2638)
{
   {
      pragma_t o_1154;
      obj_t s_1155;
      {
	 pragma_t aux_3226;
	 o_1154 = (pragma_t) (o_2637);
	 s_1155 = s_2638;
	 {
	    obj_t aux_3229;
	    object_t aux_3227;
	    aux_3229 = STRUCT_REF(s_1155, ((long) 0));
	    aux_3227 = (object_t) (o_1154);
	    OBJECT_WIDENING_SET(aux_3227, aux_3229);
	 }
	 {
	    obj_t v1356_1159;
	    v1356_1159 = STRUCT_REF(s_1155, ((long) 1));
	    ((((pragma_t) CREF(o_1154))->loc) = ((obj_t) v1356_1159), BUNSPEC);
	 }
	 {
	    type_t v1360_1160;
	    {
	       obj_t aux_3234;
	       aux_3234 = STRUCT_REF(s_1155, ((long) 2));
	       v1360_1160 = (type_t) (aux_3234);
	    }
	    ((((pragma_t) CREF(o_1154))->type) = ((type_t) v1360_1160), BUNSPEC);
	 }
	 {
	    obj_t v1364_1161;
	    v1364_1161 = STRUCT_REF(s_1155, ((long) 3));
	    ((((pragma_t) CREF(o_1154))->side_effect__165) = ((obj_t) v1364_1161), BUNSPEC);
	 }
	 {
	    obj_t v1368_1162;
	    v1368_1162 = STRUCT_REF(s_1155, ((long) 4));
	    ((((pragma_t) CREF(o_1154))->format) = ((obj_t) v1368_1162), BUNSPEC);
	 }
	 {
	    obj_t v1372_1163;
	    v1372_1163 = STRUCT_REF(s_1155, ((long) 5));
	    ((((pragma_t) CREF(o_1154))->args) = ((obj_t) v1372_1163), BUNSPEC);
	 }
	 aux_3226 = o_1154;
	 return (obj_t) (aux_3226);
      }
   }
}


obj_t 
object__struct_pragma2329_229_ast_node(obj_t env_2639, obj_t obj1352_2640)
{
   {
      pragma_t obj1352_1136;
      obj1352_1136 = (pragma_t) (obj1352_2640);
      {
	 obj_t res1353_1139;
	 {
	    obj_t aux_3246;
	    aux_3246 = CNST_TABLE_REF(((long) 10));
	    res1353_1139 = make_struct(aux_3246, ((long) 6), BUNSPEC);
	 }
	 STRUCT_SET(res1353_1139, ((long) 0), BFALSE);
	 {
	    obj_t aux_3250;
	    aux_3250 = (((pragma_t) CREF(obj1352_1136))->loc);
	    STRUCT_SET(res1353_1139, ((long) 1), aux_3250);
	 }
	 {
	    obj_t aux_3253;
	    {
	       type_t aux_3254;
	       aux_3254 = (((pragma_t) CREF(obj1352_1136))->type);
	       aux_3253 = (obj_t) (aux_3254);
	    }
	    STRUCT_SET(res1353_1139, ((long) 2), aux_3253);
	 }
	 {
	    obj_t aux_3258;
	    aux_3258 = (((pragma_t) CREF(obj1352_1136))->side_effect__165);
	    STRUCT_SET(res1353_1139, ((long) 3), aux_3258);
	 }
	 {
	    obj_t aux_3261;
	    aux_3261 = (((pragma_t) CREF(obj1352_1136))->format);
	    STRUCT_SET(res1353_1139, ((long) 4), aux_3261);
	 }
	 {
	    obj_t aux_3264;
	    aux_3264 = (((pragma_t) CREF(obj1352_1136))->args);
	    STRUCT_SET(res1353_1139, ((long) 5), aux_3264);
	 }
	 return res1353_1139;
      }
   }
}


obj_t 
struct_object__object_cast2330_240_ast_node(obj_t env_2641, obj_t o_2642, obj_t s_2643)
{
   {
      cast_t o_1126;
      obj_t s_1127;
      {
	 cast_t aux_3268;
	 o_1126 = (cast_t) (o_2642);
	 s_1127 = s_2643;
	 {
	    obj_t aux_3271;
	    object_t aux_3269;
	    aux_3271 = STRUCT_REF(s_1127, ((long) 0));
	    aux_3269 = (object_t) (o_1126);
	    OBJECT_WIDENING_SET(aux_3269, aux_3271);
	 }
	 {
	    obj_t v1384_1131;
	    v1384_1131 = STRUCT_REF(s_1127, ((long) 1));
	    ((((cast_t) CREF(o_1126))->loc) = ((obj_t) v1384_1131), BUNSPEC);
	 }
	 {
	    type_t v1388_1132;
	    {
	       obj_t aux_3276;
	       aux_3276 = STRUCT_REF(s_1127, ((long) 2));
	       v1388_1132 = (type_t) (aux_3276);
	    }
	    ((((cast_t) CREF(o_1126))->type) = ((type_t) v1388_1132), BUNSPEC);
	 }
	 {
	    node_t v1392_1133;
	    {
	       obj_t aux_3280;
	       aux_3280 = STRUCT_REF(s_1127, ((long) 3));
	       v1392_1133 = (node_t) (aux_3280);
	    }
	    ((((cast_t) CREF(o_1126))->arg) = ((node_t) v1392_1133), BUNSPEC);
	 }
	 aux_3268 = o_1126;
	 return (obj_t) (aux_3268);
      }
   }
}


obj_t 
object__struct_cast2331_252_ast_node(obj_t env_2644, obj_t obj1380_2645)
{
   {
      cast_t obj1380_1112;
      obj1380_1112 = (cast_t) (obj1380_2645);
      {
	 obj_t res1381_1115;
	 {
	    obj_t aux_3286;
	    aux_3286 = CNST_TABLE_REF(((long) 11));
	    res1381_1115 = make_struct(aux_3286, ((long) 4), BUNSPEC);
	 }
	 STRUCT_SET(res1381_1115, ((long) 0), BFALSE);
	 {
	    obj_t aux_3290;
	    aux_3290 = (((cast_t) CREF(obj1380_1112))->loc);
	    STRUCT_SET(res1381_1115, ((long) 1), aux_3290);
	 }
	 {
	    obj_t aux_3293;
	    {
	       type_t aux_3294;
	       aux_3294 = (((cast_t) CREF(obj1380_1112))->type);
	       aux_3293 = (obj_t) (aux_3294);
	    }
	    STRUCT_SET(res1381_1115, ((long) 2), aux_3293);
	 }
	 {
	    obj_t aux_3298;
	    {
	       node_t aux_3299;
	       aux_3299 = (((cast_t) CREF(obj1380_1112))->arg);
	       aux_3298 = (obj_t) (aux_3299);
	    }
	    STRUCT_SET(res1381_1115, ((long) 3), aux_3298);
	 }
	 return res1381_1115;
      }
   }
}


obj_t 
struct_object__object_setq2332_160_ast_node(obj_t env_2646, obj_t o_2647, obj_t s_2648)
{
   {
      setq_t o_1101;
      obj_t s_1102;
      {
	 setq_t aux_3304;
	 o_1101 = (setq_t) (o_2647);
	 s_1102 = s_2648;
	 {
	    obj_t aux_3307;
	    object_t aux_3305;
	    aux_3307 = STRUCT_REF(s_1102, ((long) 0));
	    aux_3305 = (object_t) (o_1101);
	    OBJECT_WIDENING_SET(aux_3305, aux_3307);
	 }
	 {
	    obj_t v1406_1106;
	    v1406_1106 = STRUCT_REF(s_1102, ((long) 1));
	    ((((setq_t) CREF(o_1101))->loc) = ((obj_t) v1406_1106), BUNSPEC);
	 }
	 {
	    type_t v1410_1107;
	    {
	       obj_t aux_3312;
	       aux_3312 = STRUCT_REF(s_1102, ((long) 2));
	       v1410_1107 = (type_t) (aux_3312);
	    }
	    ((((setq_t) CREF(o_1101))->type) = ((type_t) v1410_1107), BUNSPEC);
	 }
	 {
	    var_t v1414_1108;
	    {
	       obj_t aux_3316;
	       aux_3316 = STRUCT_REF(s_1102, ((long) 3));
	       v1414_1108 = (var_t) (aux_3316);
	    }
	    ((((setq_t) CREF(o_1101))->var) = ((var_t) v1414_1108), BUNSPEC);
	 }
	 {
	    node_t v1418_1109;
	    {
	       obj_t aux_3320;
	       aux_3320 = STRUCT_REF(s_1102, ((long) 4));
	       v1418_1109 = (node_t) (aux_3320);
	    }
	    ((((setq_t) CREF(o_1101))->value) = ((node_t) v1418_1109), BUNSPEC);
	 }
	 aux_3304 = o_1101;
	 return (obj_t) (aux_3304);
      }
   }
}


obj_t 
object__struct_setq2333_166_ast_node(obj_t env_2649, obj_t obj1402_2650)
{
   {
      setq_t obj1402_1085;
      obj1402_1085 = (setq_t) (obj1402_2650);
      {
	 obj_t res1403_1088;
	 {
	    obj_t aux_3326;
	    aux_3326 = CNST_TABLE_REF(((long) 12));
	    res1403_1088 = make_struct(aux_3326, ((long) 5), BUNSPEC);
	 }
	 STRUCT_SET(res1403_1088, ((long) 0), BFALSE);
	 {
	    obj_t aux_3330;
	    aux_3330 = (((setq_t) CREF(obj1402_1085))->loc);
	    STRUCT_SET(res1403_1088, ((long) 1), aux_3330);
	 }
	 {
	    obj_t aux_3333;
	    {
	       type_t aux_3334;
	       aux_3334 = (((setq_t) CREF(obj1402_1085))->type);
	       aux_3333 = (obj_t) (aux_3334);
	    }
	    STRUCT_SET(res1403_1088, ((long) 2), aux_3333);
	 }
	 {
	    obj_t aux_3338;
	    {
	       var_t aux_3339;
	       aux_3339 = (((setq_t) CREF(obj1402_1085))->var);
	       aux_3338 = (obj_t) (aux_3339);
	    }
	    STRUCT_SET(res1403_1088, ((long) 3), aux_3338);
	 }
	 {
	    obj_t aux_3343;
	    {
	       node_t aux_3344;
	       aux_3344 = (((setq_t) CREF(obj1402_1085))->value);
	       aux_3343 = (obj_t) (aux_3344);
	    }
	    STRUCT_SET(res1403_1088, ((long) 4), aux_3343);
	 }
	 return res1403_1088;
      }
   }
}


obj_t 
struct_object__object_conditional2334_217_ast_node(obj_t env_2651, obj_t o_2652, obj_t s_2653)
{
   {
      conditional_t o_1072;
      obj_t s_1073;
      {
	 conditional_t aux_3349;
	 o_1072 = (conditional_t) (o_2652);
	 s_1073 = s_2653;
	 {
	    obj_t aux_3352;
	    object_t aux_3350;
	    aux_3352 = STRUCT_REF(s_1073, ((long) 0));
	    aux_3350 = (object_t) (o_1072);
	    OBJECT_WIDENING_SET(aux_3350, aux_3352);
	 }
	 {
	    obj_t v1434_1077;
	    v1434_1077 = STRUCT_REF(s_1073, ((long) 1));
	    ((((conditional_t) CREF(o_1072))->loc) = ((obj_t) v1434_1077), BUNSPEC);
	 }
	 {
	    type_t v1438_1078;
	    {
	       obj_t aux_3357;
	       aux_3357 = STRUCT_REF(s_1073, ((long) 2));
	       v1438_1078 = (type_t) (aux_3357);
	    }
	    ((((conditional_t) CREF(o_1072))->type) = ((type_t) v1438_1078), BUNSPEC);
	 }
	 {
	    obj_t v1442_1079;
	    v1442_1079 = STRUCT_REF(s_1073, ((long) 3));
	    ((((conditional_t) CREF(o_1072))->side_effect__165) = ((obj_t) v1442_1079), BUNSPEC);
	 }
	 {
	    node_t v1449_1080;
	    {
	       obj_t aux_3363;
	       aux_3363 = STRUCT_REF(s_1073, ((long) 4));
	       v1449_1080 = (node_t) (aux_3363);
	    }
	    ((((conditional_t) CREF(o_1072))->test) = ((node_t) v1449_1080), BUNSPEC);
	 }
	 {
	    node_t v1453_1081;
	    {
	       obj_t aux_3367;
	       aux_3367 = STRUCT_REF(s_1073, ((long) 5));
	       v1453_1081 = (node_t) (aux_3367);
	    }
	    ((((conditional_t) CREF(o_1072))->true) = ((node_t) v1453_1081), BUNSPEC);
	 }
	 {
	    node_t v1457_1082;
	    {
	       obj_t aux_3371;
	       aux_3371 = STRUCT_REF(s_1073, ((long) 6));
	       v1457_1082 = (node_t) (aux_3371);
	    }
	    ((((conditional_t) CREF(o_1072))->false) = ((node_t) v1457_1082), BUNSPEC);
	 }
	 aux_3349 = o_1072;
	 return (obj_t) (aux_3349);
      }
   }
}


obj_t 
object__struct_conditional2335_2_ast_node(obj_t env_2654, obj_t obj1430_2655)
{
   {
      conditional_t obj1430_1052;
      obj1430_1052 = (conditional_t) (obj1430_2655);
      {
	 obj_t res1431_1055;
	 {
	    obj_t aux_3377;
	    aux_3377 = CNST_TABLE_REF(((long) 13));
	    res1431_1055 = make_struct(aux_3377, ((long) 7), BUNSPEC);
	 }
	 STRUCT_SET(res1431_1055, ((long) 0), BFALSE);
	 {
	    obj_t aux_3381;
	    aux_3381 = (((conditional_t) CREF(obj1430_1052))->loc);
	    STRUCT_SET(res1431_1055, ((long) 1), aux_3381);
	 }
	 {
	    obj_t aux_3384;
	    {
	       type_t aux_3385;
	       aux_3385 = (((conditional_t) CREF(obj1430_1052))->type);
	       aux_3384 = (obj_t) (aux_3385);
	    }
	    STRUCT_SET(res1431_1055, ((long) 2), aux_3384);
	 }
	 {
	    obj_t aux_3389;
	    aux_3389 = (((conditional_t) CREF(obj1430_1052))->side_effect__165);
	    STRUCT_SET(res1431_1055, ((long) 3), aux_3389);
	 }
	 {
	    obj_t aux_3392;
	    {
	       node_t aux_3393;
	       aux_3393 = (((conditional_t) CREF(obj1430_1052))->test);
	       aux_3392 = (obj_t) (aux_3393);
	    }
	    STRUCT_SET(res1431_1055, ((long) 4), aux_3392);
	 }
	 {
	    obj_t aux_3397;
	    {
	       node_t aux_3398;
	       aux_3398 = (((conditional_t) CREF(obj1430_1052))->true);
	       aux_3397 = (obj_t) (aux_3398);
	    }
	    STRUCT_SET(res1431_1055, ((long) 5), aux_3397);
	 }
	 {
	    obj_t aux_3402;
	    {
	       node_t aux_3403;
	       aux_3403 = (((conditional_t) CREF(obj1430_1052))->false);
	       aux_3402 = (obj_t) (aux_3403);
	    }
	    STRUCT_SET(res1431_1055, ((long) 6), aux_3402);
	 }
	 return res1431_1055;
      }
   }
}


obj_t 
struct_object__object_fail2336_138_ast_node(obj_t env_2656, obj_t o_2657, obj_t s_2658)
{
   {
      fail_t o_1040;
      obj_t s_1041;
      {
	 fail_t aux_3408;
	 o_1040 = (fail_t) (o_2657);
	 s_1041 = s_2658;
	 {
	    obj_t aux_3411;
	    object_t aux_3409;
	    aux_3411 = STRUCT_REF(s_1041, ((long) 0));
	    aux_3409 = (object_t) (o_1040);
	    OBJECT_WIDENING_SET(aux_3409, aux_3411);
	 }
	 {
	    obj_t v1473_1045;
	    v1473_1045 = STRUCT_REF(s_1041, ((long) 1));
	    ((((fail_t) CREF(o_1040))->loc) = ((obj_t) v1473_1045), BUNSPEC);
	 }
	 {
	    type_t v1477_1046;
	    {
	       obj_t aux_3416;
	       aux_3416 = STRUCT_REF(s_1041, ((long) 2));
	       v1477_1046 = (type_t) (aux_3416);
	    }
	    ((((fail_t) CREF(o_1040))->type) = ((type_t) v1477_1046), BUNSPEC);
	 }
	 {
	    node_t v1481_1047;
	    {
	       obj_t aux_3420;
	       aux_3420 = STRUCT_REF(s_1041, ((long) 3));
	       v1481_1047 = (node_t) (aux_3420);
	    }
	    ((((fail_t) CREF(o_1040))->proc) = ((node_t) v1481_1047), BUNSPEC);
	 }
	 {
	    node_t v1485_1048;
	    {
	       obj_t aux_3424;
	       aux_3424 = STRUCT_REF(s_1041, ((long) 4));
	       v1485_1048 = (node_t) (aux_3424);
	    }
	    ((((fail_t) CREF(o_1040))->msg) = ((node_t) v1485_1048), BUNSPEC);
	 }
	 {
	    node_t v1489_1049;
	    {
	       obj_t aux_3428;
	       aux_3428 = STRUCT_REF(s_1041, ((long) 5));
	       v1489_1049 = (node_t) (aux_3428);
	    }
	    ((((fail_t) CREF(o_1040))->obj) = ((node_t) v1489_1049), BUNSPEC);
	 }
	 aux_3408 = o_1040;
	 return (obj_t) (aux_3408);
      }
   }
}


obj_t 
object__struct_fail2337_193_ast_node(obj_t env_2659, obj_t obj1467_2660)
{
   {
      fail_t obj1467_1022;
      obj1467_1022 = (fail_t) (obj1467_2660);
      {
	 obj_t res1468_1025;
	 {
	    obj_t aux_3434;
	    aux_3434 = CNST_TABLE_REF(((long) 14));
	    res1468_1025 = make_struct(aux_3434, ((long) 6), BUNSPEC);
	 }
	 STRUCT_SET(res1468_1025, ((long) 0), BFALSE);
	 {
	    obj_t aux_3438;
	    aux_3438 = (((fail_t) CREF(obj1467_1022))->loc);
	    STRUCT_SET(res1468_1025, ((long) 1), aux_3438);
	 }
	 {
	    obj_t aux_3441;
	    {
	       type_t aux_3442;
	       aux_3442 = (((fail_t) CREF(obj1467_1022))->type);
	       aux_3441 = (obj_t) (aux_3442);
	    }
	    STRUCT_SET(res1468_1025, ((long) 2), aux_3441);
	 }
	 {
	    obj_t aux_3446;
	    {
	       node_t aux_3447;
	       aux_3447 = (((fail_t) CREF(obj1467_1022))->proc);
	       aux_3446 = (obj_t) (aux_3447);
	    }
	    STRUCT_SET(res1468_1025, ((long) 3), aux_3446);
	 }
	 {
	    obj_t aux_3451;
	    {
	       node_t aux_3452;
	       aux_3452 = (((fail_t) CREF(obj1467_1022))->msg);
	       aux_3451 = (obj_t) (aux_3452);
	    }
	    STRUCT_SET(res1468_1025, ((long) 4), aux_3451);
	 }
	 {
	    obj_t aux_3456;
	    {
	       node_t aux_3457;
	       aux_3457 = (((fail_t) CREF(obj1467_1022))->obj);
	       aux_3456 = (obj_t) (aux_3457);
	    }
	    STRUCT_SET(res1468_1025, ((long) 5), aux_3456);
	 }
	 return res1468_1025;
      }
   }
}


obj_t 
struct_object__object_select2338_203_ast_node(obj_t env_2661, obj_t o_2662, obj_t s_2663)
{
   {
      select_t o_1009;
      obj_t s_1010;
      {
	 select_t aux_3462;
	 o_1009 = (select_t) (o_2662);
	 s_1010 = s_2663;
	 {
	    obj_t aux_3465;
	    object_t aux_3463;
	    aux_3465 = STRUCT_REF(s_1010, ((long) 0));
	    aux_3463 = (object_t) (o_1009);
	    OBJECT_WIDENING_SET(aux_3463, aux_3465);
	 }
	 {
	    obj_t v1502_1014;
	    v1502_1014 = STRUCT_REF(s_1010, ((long) 1));
	    ((((select_t) CREF(o_1009))->loc) = ((obj_t) v1502_1014), BUNSPEC);
	 }
	 {
	    type_t v1508_1015;
	    {
	       obj_t aux_3470;
	       aux_3470 = STRUCT_REF(s_1010, ((long) 2));
	       v1508_1015 = (type_t) (aux_3470);
	    }
	    ((((select_t) CREF(o_1009))->type) = ((type_t) v1508_1015), BUNSPEC);
	 }
	 {
	    obj_t v1512_1016;
	    v1512_1016 = STRUCT_REF(s_1010, ((long) 3));
	    ((((select_t) CREF(o_1009))->side_effect__165) = ((obj_t) v1512_1016), BUNSPEC);
	 }
	 {
	    node_t v1516_1017;
	    {
	       obj_t aux_3476;
	       aux_3476 = STRUCT_REF(s_1010, ((long) 4));
	       v1516_1017 = (node_t) (aux_3476);
	    }
	    ((((select_t) CREF(o_1009))->test) = ((node_t) v1516_1017), BUNSPEC);
	 }
	 {
	    obj_t v1520_1018;
	    v1520_1018 = STRUCT_REF(s_1010, ((long) 5));
	    ((((select_t) CREF(o_1009))->clauses) = ((obj_t) v1520_1018), BUNSPEC);
	 }
	 {
	    type_t v1525_1019;
	    {
	       obj_t aux_3482;
	       aux_3482 = STRUCT_REF(s_1010, ((long) 6));
	       v1525_1019 = (type_t) (aux_3482);
	    }
	    ((((select_t) CREF(o_1009))->item_type_130) = ((type_t) v1525_1019), BUNSPEC);
	 }
	 aux_3462 = o_1009;
	 return (obj_t) (aux_3462);
      }
   }
}


obj_t 
object__struct_select2339_32_ast_node(obj_t env_2664, obj_t obj1498_2665)
{
   {
      select_t obj1498_989;
      obj1498_989 = (select_t) (obj1498_2665);
      {
	 obj_t res1499_992;
	 {
	    obj_t aux_3488;
	    aux_3488 = CNST_TABLE_REF(((long) 15));
	    res1499_992 = make_struct(aux_3488, ((long) 7), BUNSPEC);
	 }
	 STRUCT_SET(res1499_992, ((long) 0), BFALSE);
	 {
	    obj_t aux_3492;
	    aux_3492 = (((select_t) CREF(obj1498_989))->loc);
	    STRUCT_SET(res1499_992, ((long) 1), aux_3492);
	 }
	 {
	    obj_t aux_3495;
	    {
	       type_t aux_3496;
	       aux_3496 = (((select_t) CREF(obj1498_989))->type);
	       aux_3495 = (obj_t) (aux_3496);
	    }
	    STRUCT_SET(res1499_992, ((long) 2), aux_3495);
	 }
	 {
	    obj_t aux_3500;
	    aux_3500 = (((select_t) CREF(obj1498_989))->side_effect__165);
	    STRUCT_SET(res1499_992, ((long) 3), aux_3500);
	 }
	 {
	    obj_t aux_3503;
	    {
	       node_t aux_3504;
	       aux_3504 = (((select_t) CREF(obj1498_989))->test);
	       aux_3503 = (obj_t) (aux_3504);
	    }
	    STRUCT_SET(res1499_992, ((long) 4), aux_3503);
	 }
	 {
	    obj_t aux_3508;
	    aux_3508 = (((select_t) CREF(obj1498_989))->clauses);
	    STRUCT_SET(res1499_992, ((long) 5), aux_3508);
	 }
	 {
	    obj_t aux_3511;
	    {
	       type_t aux_3512;
	       aux_3512 = (((select_t) CREF(obj1498_989))->item_type_130);
	       aux_3511 = (obj_t) (aux_3512);
	    }
	    STRUCT_SET(res1499_992, ((long) 6), aux_3511);
	 }
	 return res1499_992;
      }
   }
}


obj_t 
struct_object__object_let_fun2340_202_ast_node(obj_t env_2666, obj_t o_2667, obj_t s_2668)
{
   {
      let_fun_218_t o_977;
      obj_t s_978;
      {
	 let_fun_218_t aux_3517;
	 o_977 = (let_fun_218_t) (o_2667);
	 s_978 = s_2668;
	 {
	    obj_t aux_3520;
	    object_t aux_3518;
	    aux_3520 = STRUCT_REF(s_978, ((long) 0));
	    aux_3518 = (object_t) (o_977);
	    OBJECT_WIDENING_SET(aux_3518, aux_3520);
	 }
	 {
	    obj_t v1539_982;
	    v1539_982 = STRUCT_REF(s_978, ((long) 1));
	    ((((let_fun_218_t) CREF(o_977))->loc) = ((obj_t) v1539_982), BUNSPEC);
	 }
	 {
	    type_t v1543_983;
	    {
	       obj_t aux_3525;
	       aux_3525 = STRUCT_REF(s_978, ((long) 2));
	       v1543_983 = (type_t) (aux_3525);
	    }
	    ((((let_fun_218_t) CREF(o_977))->type) = ((type_t) v1543_983), BUNSPEC);
	 }
	 {
	    obj_t v1547_984;
	    v1547_984 = STRUCT_REF(s_978, ((long) 3));
	    ((((let_fun_218_t) CREF(o_977))->side_effect__165) = ((obj_t) v1547_984), BUNSPEC);
	 }
	 {
	    obj_t v1552_985;
	    v1552_985 = STRUCT_REF(s_978, ((long) 4));
	    ((((let_fun_218_t) CREF(o_977))->locals) = ((obj_t) v1552_985), BUNSPEC);
	 }
	 {
	    node_t v1556_986;
	    {
	       obj_t aux_3533;
	       aux_3533 = STRUCT_REF(s_978, ((long) 5));
	       v1556_986 = (node_t) (aux_3533);
	    }
	    ((((let_fun_218_t) CREF(o_977))->body) = ((node_t) v1556_986), BUNSPEC);
	 }
	 aux_3517 = o_977;
	 return (obj_t) (aux_3517);
      }
   }
}


obj_t 
object__struct_let_fun2341_47_ast_node(obj_t env_2669, obj_t obj1535_2670)
{
   {
      let_fun_218_t obj1535_959;
      obj1535_959 = (let_fun_218_t) (obj1535_2670);
      {
	 obj_t res1536_962;
	 {
	    obj_t aux_3539;
	    aux_3539 = CNST_TABLE_REF(((long) 16));
	    res1536_962 = make_struct(aux_3539, ((long) 6), BUNSPEC);
	 }
	 STRUCT_SET(res1536_962, ((long) 0), BFALSE);
	 {
	    obj_t aux_3543;
	    aux_3543 = (((let_fun_218_t) CREF(obj1535_959))->loc);
	    STRUCT_SET(res1536_962, ((long) 1), aux_3543);
	 }
	 {
	    obj_t aux_3546;
	    {
	       type_t aux_3547;
	       aux_3547 = (((let_fun_218_t) CREF(obj1535_959))->type);
	       aux_3546 = (obj_t) (aux_3547);
	    }
	    STRUCT_SET(res1536_962, ((long) 2), aux_3546);
	 }
	 {
	    obj_t aux_3551;
	    aux_3551 = (((let_fun_218_t) CREF(obj1535_959))->side_effect__165);
	    STRUCT_SET(res1536_962, ((long) 3), aux_3551);
	 }
	 {
	    obj_t aux_3554;
	    aux_3554 = (((let_fun_218_t) CREF(obj1535_959))->locals);
	    STRUCT_SET(res1536_962, ((long) 4), aux_3554);
	 }
	 {
	    obj_t aux_3557;
	    {
	       node_t aux_3558;
	       aux_3558 = (((let_fun_218_t) CREF(obj1535_959))->body);
	       aux_3557 = (obj_t) (aux_3558);
	    }
	    STRUCT_SET(res1536_962, ((long) 5), aux_3557);
	 }
	 return res1536_962;
      }
   }
}


obj_t 
struct_object__object_let_var2342_149_ast_node(obj_t env_2671, obj_t o_2672, obj_t s_2673)
{
   {
      let_var_6_t o_946;
      obj_t s_947;
      {
	 let_var_6_t aux_3563;
	 o_946 = (let_var_6_t) (o_2672);
	 s_947 = s_2673;
	 {
	    obj_t aux_3566;
	    object_t aux_3564;
	    aux_3566 = STRUCT_REF(s_947, ((long) 0));
	    aux_3564 = (object_t) (o_946);
	    OBJECT_WIDENING_SET(aux_3564, aux_3566);
	 }
	 {
	    obj_t v1571_951;
	    v1571_951 = STRUCT_REF(s_947, ((long) 1));
	    ((((let_var_6_t) CREF(o_946))->loc) = ((obj_t) v1571_951), BUNSPEC);
	 }
	 {
	    type_t v1576_952;
	    {
	       obj_t aux_3571;
	       aux_3571 = STRUCT_REF(s_947, ((long) 2));
	       v1576_952 = (type_t) (aux_3571);
	    }
	    ((((let_var_6_t) CREF(o_946))->type) = ((type_t) v1576_952), BUNSPEC);
	 }
	 {
	    obj_t v1583_953;
	    v1583_953 = STRUCT_REF(s_947, ((long) 3));
	    ((((let_var_6_t) CREF(o_946))->side_effect__165) = ((obj_t) v1583_953), BUNSPEC);
	 }
	 {
	    obj_t v1587_954;
	    v1587_954 = STRUCT_REF(s_947, ((long) 4));
	    ((((let_var_6_t) CREF(o_946))->bindings) = ((obj_t) v1587_954), BUNSPEC);
	 }
	 {
	    node_t v1591_955;
	    {
	       obj_t aux_3579;
	       aux_3579 = STRUCT_REF(s_947, ((long) 5));
	       v1591_955 = (node_t) (aux_3579);
	    }
	    ((((let_var_6_t) CREF(o_946))->body) = ((node_t) v1591_955), BUNSPEC);
	 }
	 {
	    bool_t v1596_956;
	    {
	       obj_t aux_3583;
	       aux_3583 = STRUCT_REF(s_947, ((long) 6));
	       v1596_956 = CBOOL(aux_3583);
	    }
	    ((((let_var_6_t) CREF(o_946))->removable__42) = ((bool_t) v1596_956), BUNSPEC);
	 }
	 aux_3563 = o_946;
	 return (obj_t) (aux_3563);
      }
   }
}


obj_t 
object__struct_let_var2343_55_ast_node(obj_t env_2674, obj_t obj1567_2675)
{
   {
      let_var_6_t obj1567_926;
      obj1567_926 = (let_var_6_t) (obj1567_2675);
      {
	 obj_t res1568_929;
	 {
	    obj_t aux_3589;
	    aux_3589 = CNST_TABLE_REF(((long) 17));
	    res1568_929 = make_struct(aux_3589, ((long) 7), BUNSPEC);
	 }
	 STRUCT_SET(res1568_929, ((long) 0), BFALSE);
	 {
	    obj_t aux_3593;
	    aux_3593 = (((let_var_6_t) CREF(obj1567_926))->loc);
	    STRUCT_SET(res1568_929, ((long) 1), aux_3593);
	 }
	 {
	    obj_t aux_3596;
	    {
	       type_t aux_3597;
	       aux_3597 = (((let_var_6_t) CREF(obj1567_926))->type);
	       aux_3596 = (obj_t) (aux_3597);
	    }
	    STRUCT_SET(res1568_929, ((long) 2), aux_3596);
	 }
	 {
	    obj_t aux_3601;
	    aux_3601 = (((let_var_6_t) CREF(obj1567_926))->side_effect__165);
	    STRUCT_SET(res1568_929, ((long) 3), aux_3601);
	 }
	 {
	    obj_t aux_3604;
	    aux_3604 = (((let_var_6_t) CREF(obj1567_926))->bindings);
	    STRUCT_SET(res1568_929, ((long) 4), aux_3604);
	 }
	 {
	    obj_t aux_3607;
	    {
	       node_t aux_3608;
	       aux_3608 = (((let_var_6_t) CREF(obj1567_926))->body);
	       aux_3607 = (obj_t) (aux_3608);
	    }
	    STRUCT_SET(res1568_929, ((long) 5), aux_3607);
	 }
	 {
	    obj_t aux_3612;
	    {
	       bool_t aux_3613;
	       aux_3613 = (((let_var_6_t) CREF(obj1567_926))->removable__42);
	       aux_3612 = BBOOL(aux_3613);
	    }
	    STRUCT_SET(res1568_929, ((long) 6), aux_3612);
	 }
	 return res1568_929;
      }
   }
}


obj_t 
struct_object__object_set_ex_it2344_88_ast_node(obj_t env_2676, obj_t o_2677, obj_t s_2678)
{
   {
      set_ex_it_116_t o_915;
      obj_t s_916;
      {
	 set_ex_it_116_t aux_3618;
	 o_915 = (set_ex_it_116_t) (o_2677);
	 s_916 = s_2678;
	 {
	    obj_t aux_3621;
	    object_t aux_3619;
	    aux_3621 = STRUCT_REF(s_916, ((long) 0));
	    aux_3619 = (object_t) (o_915);
	    OBJECT_WIDENING_SET(aux_3619, aux_3621);
	 }
	 {
	    obj_t v1611_920;
	    v1611_920 = STRUCT_REF(s_916, ((long) 1));
	    ((((set_ex_it_116_t) CREF(o_915))->loc) = ((obj_t) v1611_920), BUNSPEC);
	 }
	 {
	    type_t v1615_921;
	    {
	       obj_t aux_3626;
	       aux_3626 = STRUCT_REF(s_916, ((long) 2));
	       v1615_921 = (type_t) (aux_3626);
	    }
	    ((((set_ex_it_116_t) CREF(o_915))->type) = ((type_t) v1615_921), BUNSPEC);
	 }
	 {
	    var_t v1619_922;
	    {
	       obj_t aux_3630;
	       aux_3630 = STRUCT_REF(s_916, ((long) 3));
	       v1619_922 = (var_t) (aux_3630);
	    }
	    ((((set_ex_it_116_t) CREF(o_915))->var) = ((var_t) v1619_922), BUNSPEC);
	 }
	 {
	    node_t v1623_923;
	    {
	       obj_t aux_3634;
	       aux_3634 = STRUCT_REF(s_916, ((long) 4));
	       v1623_923 = (node_t) (aux_3634);
	    }
	    ((((set_ex_it_116_t) CREF(o_915))->body) = ((node_t) v1623_923), BUNSPEC);
	 }
	 aux_3618 = o_915;
	 return (obj_t) (aux_3618);
      }
   }
}


obj_t 
object__struct_set_ex_it2345_218_ast_node(obj_t env_2679, obj_t obj1606_2680)
{
   {
      set_ex_it_116_t obj1606_899;
      obj1606_899 = (set_ex_it_116_t) (obj1606_2680);
      {
	 obj_t res1607_902;
	 {
	    obj_t aux_3640;
	    aux_3640 = CNST_TABLE_REF(((long) 18));
	    res1607_902 = make_struct(aux_3640, ((long) 5), BUNSPEC);
	 }
	 STRUCT_SET(res1607_902, ((long) 0), BFALSE);
	 {
	    obj_t aux_3644;
	    aux_3644 = (((set_ex_it_116_t) CREF(obj1606_899))->loc);
	    STRUCT_SET(res1607_902, ((long) 1), aux_3644);
	 }
	 {
	    obj_t aux_3647;
	    {
	       type_t aux_3648;
	       aux_3648 = (((set_ex_it_116_t) CREF(obj1606_899))->type);
	       aux_3647 = (obj_t) (aux_3648);
	    }
	    STRUCT_SET(res1607_902, ((long) 2), aux_3647);
	 }
	 {
	    obj_t aux_3652;
	    {
	       var_t aux_3653;
	       aux_3653 = (((set_ex_it_116_t) CREF(obj1606_899))->var);
	       aux_3652 = (obj_t) (aux_3653);
	    }
	    STRUCT_SET(res1607_902, ((long) 3), aux_3652);
	 }
	 {
	    obj_t aux_3657;
	    {
	       node_t aux_3658;
	       aux_3658 = (((set_ex_it_116_t) CREF(obj1606_899))->body);
	       aux_3657 = (obj_t) (aux_3658);
	    }
	    STRUCT_SET(res1607_902, ((long) 4), aux_3657);
	 }
	 return res1607_902;
      }
   }
}


obj_t 
struct_object__object_jump_ex_it2346_32_ast_node(obj_t env_2681, obj_t o_2682, obj_t s_2683)
{
   {
      jump_ex_it_184_t o_888;
      obj_t s_889;
      {
	 jump_ex_it_184_t aux_3663;
	 o_888 = (jump_ex_it_184_t) (o_2682);
	 s_889 = s_2683;
	 {
	    obj_t aux_3666;
	    object_t aux_3664;
	    aux_3666 = STRUCT_REF(s_889, ((long) 0));
	    aux_3664 = (object_t) (o_888);
	    OBJECT_WIDENING_SET(aux_3664, aux_3666);
	 }
	 {
	    obj_t v1636_893;
	    v1636_893 = STRUCT_REF(s_889, ((long) 1));
	    ((((jump_ex_it_184_t) CREF(o_888))->loc) = ((obj_t) v1636_893), BUNSPEC);
	 }
	 {
	    type_t v1640_894;
	    {
	       obj_t aux_3671;
	       aux_3671 = STRUCT_REF(s_889, ((long) 2));
	       v1640_894 = (type_t) (aux_3671);
	    }
	    ((((jump_ex_it_184_t) CREF(o_888))->type) = ((type_t) v1640_894), BUNSPEC);
	 }
	 {
	    node_t v1644_895;
	    {
	       obj_t aux_3675;
	       aux_3675 = STRUCT_REF(s_889, ((long) 3));
	       v1644_895 = (node_t) (aux_3675);
	    }
	    ((((jump_ex_it_184_t) CREF(o_888))->exit) = ((node_t) v1644_895), BUNSPEC);
	 }
	 {
	    node_t v1648_896;
	    {
	       obj_t aux_3679;
	       aux_3679 = STRUCT_REF(s_889, ((long) 4));
	       v1648_896 = (node_t) (aux_3679);
	    }
	    ((((jump_ex_it_184_t) CREF(o_888))->value) = ((node_t) v1648_896), BUNSPEC);
	 }
	 aux_3663 = o_888;
	 return (obj_t) (aux_3663);
      }
   }
}


obj_t 
object__struct_jump_ex_it2347_58_ast_node(obj_t env_2684, obj_t obj1632_2685)
{
   {
      jump_ex_it_184_t obj1632_872;
      obj1632_872 = (jump_ex_it_184_t) (obj1632_2685);
      {
	 obj_t res1633_875;
	 {
	    obj_t aux_3685;
	    aux_3685 = CNST_TABLE_REF(((long) 19));
	    res1633_875 = make_struct(aux_3685, ((long) 5), BUNSPEC);
	 }
	 STRUCT_SET(res1633_875, ((long) 0), BFALSE);
	 {
	    obj_t aux_3689;
	    aux_3689 = (((jump_ex_it_184_t) CREF(obj1632_872))->loc);
	    STRUCT_SET(res1633_875, ((long) 1), aux_3689);
	 }
	 {
	    obj_t aux_3692;
	    {
	       type_t aux_3693;
	       aux_3693 = (((jump_ex_it_184_t) CREF(obj1632_872))->type);
	       aux_3692 = (obj_t) (aux_3693);
	    }
	    STRUCT_SET(res1633_875, ((long) 2), aux_3692);
	 }
	 {
	    obj_t aux_3697;
	    {
	       node_t aux_3698;
	       aux_3698 = (((jump_ex_it_184_t) CREF(obj1632_872))->exit);
	       aux_3697 = (obj_t) (aux_3698);
	    }
	    STRUCT_SET(res1633_875, ((long) 3), aux_3697);
	 }
	 {
	    obj_t aux_3702;
	    {
	       node_t aux_3703;
	       aux_3703 = (((jump_ex_it_184_t) CREF(obj1632_872))->value);
	       aux_3702 = (obj_t) (aux_3703);
	    }
	    STRUCT_SET(res1633_875, ((long) 4), aux_3702);
	 }
	 return res1633_875;
      }
   }
}


obj_t 
struct_object__object_make_box2348_248_ast_node(obj_t env_2686, obj_t o_2687, obj_t s_2688)
{
   {
      make_box_202_t o_861;
      obj_t s_862;
      {
	 make_box_202_t aux_3708;
	 o_861 = (make_box_202_t) (o_2687);
	 s_862 = s_2688;
	 {
	    obj_t aux_3711;
	    object_t aux_3709;
	    aux_3711 = STRUCT_REF(s_862, ((long) 0));
	    aux_3709 = (object_t) (o_861);
	    OBJECT_WIDENING_SET(aux_3709, aux_3711);
	 }
	 {
	    obj_t v1662_866;
	    v1662_866 = STRUCT_REF(s_862, ((long) 1));
	    ((((make_box_202_t) CREF(o_861))->loc) = ((obj_t) v1662_866), BUNSPEC);
	 }
	 {
	    type_t v1666_867;
	    {
	       obj_t aux_3716;
	       aux_3716 = STRUCT_REF(s_862, ((long) 2));
	       v1666_867 = (type_t) (aux_3716);
	    }
	    ((((make_box_202_t) CREF(o_861))->type) = ((type_t) v1666_867), BUNSPEC);
	 }
	 {
	    obj_t v1670_868;
	    v1670_868 = STRUCT_REF(s_862, ((long) 3));
	    ((((make_box_202_t) CREF(o_861))->side_effect__165) = ((obj_t) v1670_868), BUNSPEC);
	 }
	 {
	    node_t v1674_869;
	    {
	       obj_t aux_3722;
	       aux_3722 = STRUCT_REF(s_862, ((long) 4));
	       v1674_869 = (node_t) (aux_3722);
	    }
	    ((((make_box_202_t) CREF(o_861))->value) = ((node_t) v1674_869), BUNSPEC);
	 }
	 aux_3708 = o_861;
	 return (obj_t) (aux_3708);
      }
   }
}


obj_t 
object__struct_make_box2349_125_ast_node(obj_t env_2689, obj_t obj1658_2690)
{
   {
      make_box_202_t obj1658_845;
      obj1658_845 = (make_box_202_t) (obj1658_2690);
      {
	 obj_t res1659_848;
	 {
	    obj_t aux_3728;
	    aux_3728 = CNST_TABLE_REF(((long) 20));
	    res1659_848 = make_struct(aux_3728, ((long) 5), BUNSPEC);
	 }
	 STRUCT_SET(res1659_848, ((long) 0), BFALSE);
	 {
	    obj_t aux_3732;
	    aux_3732 = (((make_box_202_t) CREF(obj1658_845))->loc);
	    STRUCT_SET(res1659_848, ((long) 1), aux_3732);
	 }
	 {
	    obj_t aux_3735;
	    {
	       type_t aux_3736;
	       aux_3736 = (((make_box_202_t) CREF(obj1658_845))->type);
	       aux_3735 = (obj_t) (aux_3736);
	    }
	    STRUCT_SET(res1659_848, ((long) 2), aux_3735);
	 }
	 {
	    obj_t aux_3740;
	    aux_3740 = (((make_box_202_t) CREF(obj1658_845))->side_effect__165);
	    STRUCT_SET(res1659_848, ((long) 3), aux_3740);
	 }
	 {
	    obj_t aux_3743;
	    {
	       node_t aux_3744;
	       aux_3744 = (((make_box_202_t) CREF(obj1658_845))->value);
	       aux_3743 = (obj_t) (aux_3744);
	    }
	    STRUCT_SET(res1659_848, ((long) 4), aux_3743);
	 }
	 return res1659_848;
      }
   }
}


obj_t 
struct_object__object_box_ref2350_106_ast_node(obj_t env_2691, obj_t o_2692, obj_t s_2693)
{
   {
      box_ref_242_t o_834;
      obj_t s_835;
      {
	 box_ref_242_t aux_3749;
	 o_834 = (box_ref_242_t) (o_2692);
	 s_835 = s_2693;
	 {
	    obj_t aux_3752;
	    object_t aux_3750;
	    aux_3752 = STRUCT_REF(s_835, ((long) 0));
	    aux_3750 = (object_t) (o_834);
	    OBJECT_WIDENING_SET(aux_3750, aux_3752);
	 }
	 {
	    obj_t v1688_839;
	    v1688_839 = STRUCT_REF(s_835, ((long) 1));
	    ((((box_ref_242_t) CREF(o_834))->loc) = ((obj_t) v1688_839), BUNSPEC);
	 }
	 {
	    type_t v1693_840;
	    {
	       obj_t aux_3757;
	       aux_3757 = STRUCT_REF(s_835, ((long) 2));
	       v1693_840 = (type_t) (aux_3757);
	    }
	    ((((box_ref_242_t) CREF(o_834))->type) = ((type_t) v1693_840), BUNSPEC);
	 }
	 {
	    obj_t v1697_841;
	    v1697_841 = STRUCT_REF(s_835, ((long) 3));
	    ((((box_ref_242_t) CREF(o_834))->side_effect__165) = ((obj_t) v1697_841), BUNSPEC);
	 }
	 {
	    var_t v1701_842;
	    {
	       obj_t aux_3763;
	       aux_3763 = STRUCT_REF(s_835, ((long) 4));
	       v1701_842 = (var_t) (aux_3763);
	    }
	    ((((box_ref_242_t) CREF(o_834))->var) = ((var_t) v1701_842), BUNSPEC);
	 }
	 aux_3749 = o_834;
	 return (obj_t) (aux_3749);
      }
   }
}


obj_t 
object__struct_box_ref2351_133_ast_node(obj_t env_2694, obj_t obj1683_2695)
{
   {
      box_ref_242_t obj1683_818;
      obj1683_818 = (box_ref_242_t) (obj1683_2695);
      {
	 obj_t res1684_821;
	 {
	    obj_t aux_3769;
	    aux_3769 = CNST_TABLE_REF(((long) 21));
	    res1684_821 = make_struct(aux_3769, ((long) 5), BUNSPEC);
	 }
	 STRUCT_SET(res1684_821, ((long) 0), BFALSE);
	 {
	    obj_t aux_3773;
	    aux_3773 = (((box_ref_242_t) CREF(obj1683_818))->loc);
	    STRUCT_SET(res1684_821, ((long) 1), aux_3773);
	 }
	 {
	    obj_t aux_3776;
	    {
	       type_t aux_3777;
	       aux_3777 = (((box_ref_242_t) CREF(obj1683_818))->type);
	       aux_3776 = (obj_t) (aux_3777);
	    }
	    STRUCT_SET(res1684_821, ((long) 2), aux_3776);
	 }
	 {
	    obj_t aux_3781;
	    aux_3781 = (((box_ref_242_t) CREF(obj1683_818))->side_effect__165);
	    STRUCT_SET(res1684_821, ((long) 3), aux_3781);
	 }
	 {
	    obj_t aux_3784;
	    {
	       var_t aux_3785;
	       aux_3785 = (((box_ref_242_t) CREF(obj1683_818))->var);
	       aux_3784 = (obj_t) (aux_3785);
	    }
	    STRUCT_SET(res1684_821, ((long) 4), aux_3784);
	 }
	 return res1684_821;
      }
   }
}


obj_t 
struct_object__object_box_set_2352_66_ast_node(obj_t env_2696, obj_t o_2697, obj_t s_2698)
{
   {
      box_set__221_t o_807;
      obj_t s_808;
      {
	 box_set__221_t aux_3790;
	 o_807 = (box_set__221_t) (o_2697);
	 s_808 = s_2698;
	 {
	    obj_t aux_3793;
	    object_t aux_3791;
	    aux_3793 = STRUCT_REF(s_808, ((long) 0));
	    aux_3791 = (object_t) (o_807);
	    OBJECT_WIDENING_SET(aux_3791, aux_3793);
	 }
	 {
	    obj_t v1714_812;
	    v1714_812 = STRUCT_REF(s_808, ((long) 1));
	    ((((box_set__221_t) CREF(o_807))->loc) = ((obj_t) v1714_812), BUNSPEC);
	 }
	 {
	    type_t v1718_813;
	    {
	       obj_t aux_3798;
	       aux_3798 = STRUCT_REF(s_808, ((long) 2));
	       v1718_813 = (type_t) (aux_3798);
	    }
	    ((((box_set__221_t) CREF(o_807))->type) = ((type_t) v1718_813), BUNSPEC);
	 }
	 {
	    var_t v1722_814;
	    {
	       obj_t aux_3802;
	       aux_3802 = STRUCT_REF(s_808, ((long) 3));
	       v1722_814 = (var_t) (aux_3802);
	    }
	    ((((box_set__221_t) CREF(o_807))->var) = ((var_t) v1722_814), BUNSPEC);
	 }
	 {
	    node_t v1726_815;
	    {
	       obj_t aux_3806;
	       aux_3806 = STRUCT_REF(s_808, ((long) 4));
	       v1726_815 = (node_t) (aux_3806);
	    }
	    ((((box_set__221_t) CREF(o_807))->value) = ((node_t) v1726_815), BUNSPEC);
	 }
	 aux_3790 = o_807;
	 return (obj_t) (aux_3790);
      }
   }
}


obj_t 
object__struct_box_set_2353_31_ast_node(obj_t env_2699, obj_t obj1710_2700)
{
   {
      box_set__221_t obj1710_791;
      obj1710_791 = (box_set__221_t) (obj1710_2700);
      {
	 obj_t res1711_794;
	 {
	    obj_t aux_3812;
	    aux_3812 = CNST_TABLE_REF(((long) 22));
	    res1711_794 = make_struct(aux_3812, ((long) 5), BUNSPEC);
	 }
	 STRUCT_SET(res1711_794, ((long) 0), BFALSE);
	 {
	    obj_t aux_3816;
	    aux_3816 = (((box_set__221_t) CREF(obj1710_791))->loc);
	    STRUCT_SET(res1711_794, ((long) 1), aux_3816);
	 }
	 {
	    obj_t aux_3819;
	    {
	       type_t aux_3820;
	       aux_3820 = (((box_set__221_t) CREF(obj1710_791))->type);
	       aux_3819 = (obj_t) (aux_3820);
	    }
	    STRUCT_SET(res1711_794, ((long) 2), aux_3819);
	 }
	 {
	    obj_t aux_3824;
	    {
	       var_t aux_3825;
	       aux_3825 = (((box_set__221_t) CREF(obj1710_791))->var);
	       aux_3824 = (obj_t) (aux_3825);
	    }
	    STRUCT_SET(res1711_794, ((long) 3), aux_3824);
	 }
	 {
	    obj_t aux_3829;
	    {
	       node_t aux_3830;
	       aux_3830 = (((box_set__221_t) CREF(obj1710_791))->value);
	       aux_3829 = (obj_t) (aux_3830);
	    }
	    STRUCT_SET(res1711_794, ((long) 4), aux_3829);
	 }
	 return res1711_794;
      }
   }
}


box_set__221_t 
allocate_box_set__237_ast_node()
{
   {
      box_set__221_t new1709_1424;
      new1709_1424 = ((box_set__221_t) BREF(GC_MALLOC(sizeof(struct box_set__221))));
      {
	 long arg2225_1425;
	 arg2225_1425 = class_num_218___object(box_set__221_ast_node);
	 {
	    obj_t obj_2494;
	    obj_2494 = (obj_t) (new1709_1424);
	    (((obj_t) CREF(obj_2494))->header = MAKE_HEADER(arg2225_1425, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3839;
	 aux_3839 = (object_t) (new1709_1424);
	 OBJECT_WIDENING_SET(aux_3839, BFALSE);
      }
      return new1709_1424;
   }
}


obj_t 
_allocate_box_set__43_ast_node(obj_t env_2723)
{
   {
      box_set__221_t aux_3842;
      aux_3842 = allocate_box_set__237_ast_node();
      return (obj_t) (aux_3842);
   }
}


box_ref_242_t 
allocate_box_ref_100_ast_node()
{
   {
      box_ref_242_t new1682_1432;
      new1682_1432 = ((box_ref_242_t) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
      {
	 long arg2227_1433;
	 arg2227_1433 = class_num_218___object(box_ref_242_ast_node);
	 {
	    obj_t obj_2496;
	    obj_2496 = (obj_t) (new1682_1432);
	    (((obj_t) CREF(obj_2496))->header = MAKE_HEADER(arg2227_1433, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3849;
	 aux_3849 = (object_t) (new1682_1432);
	 OBJECT_WIDENING_SET(aux_3849, BFALSE);
      }
      return new1682_1432;
   }
}


obj_t 
_allocate_box_ref_230_ast_node(obj_t env_2722)
{
   {
      box_ref_242_t aux_3852;
      aux_3852 = allocate_box_ref_100_ast_node();
      return (obj_t) (aux_3852);
   }
}


make_box_202_t 
allocate_make_box_201_ast_node()
{
   {
      make_box_202_t new1657_1440;
      new1657_1440 = ((make_box_202_t) BREF(GC_MALLOC(sizeof(struct make_box_202))));
      {
	 long arg2229_1441;
	 arg2229_1441 = class_num_218___object(make_box_202_ast_node);
	 {
	    obj_t obj_2498;
	    obj_2498 = (obj_t) (new1657_1440);
	    (((obj_t) CREF(obj_2498))->header = MAKE_HEADER(arg2229_1441, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3859;
	 aux_3859 = (object_t) (new1657_1440);
	 OBJECT_WIDENING_SET(aux_3859, BFALSE);
      }
      return new1657_1440;
   }
}


obj_t 
_allocate_make_box_168_ast_node(obj_t env_2721)
{
   {
      make_box_202_t aux_3862;
      aux_3862 = allocate_make_box_201_ast_node();
      return (obj_t) (aux_3862);
   }
}


jump_ex_it_184_t 
allocate_jump_ex_it_22_ast_node()
{
   {
      jump_ex_it_184_t new1631_1448;
      new1631_1448 = ((jump_ex_it_184_t) BREF(GC_MALLOC(sizeof(struct jump_ex_it_184))));
      {
	 long arg2231_1449;
	 arg2231_1449 = class_num_218___object(jump_ex_it_184_ast_node);
	 {
	    obj_t obj_2500;
	    obj_2500 = (obj_t) (new1631_1448);
	    (((obj_t) CREF(obj_2500))->header = MAKE_HEADER(arg2231_1449, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3869;
	 aux_3869 = (object_t) (new1631_1448);
	 OBJECT_WIDENING_SET(aux_3869, BFALSE);
      }
      return new1631_1448;
   }
}


obj_t 
_allocate_jump_ex_it_189_ast_node(obj_t env_2720)
{
   {
      jump_ex_it_184_t aux_3872;
      aux_3872 = allocate_jump_ex_it_22_ast_node();
      return (obj_t) (aux_3872);
   }
}


set_ex_it_116_t 
allocate_set_ex_it_57_ast_node()
{
   {
      set_ex_it_116_t new1605_1456;
      new1605_1456 = ((set_ex_it_116_t) BREF(GC_MALLOC(sizeof(struct set_ex_it_116))));
      {
	 long arg2233_1457;
	 arg2233_1457 = class_num_218___object(set_ex_it_116_ast_node);
	 {
	    obj_t obj_2502;
	    obj_2502 = (obj_t) (new1605_1456);
	    (((obj_t) CREF(obj_2502))->header = MAKE_HEADER(arg2233_1457, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3879;
	 aux_3879 = (object_t) (new1605_1456);
	 OBJECT_WIDENING_SET(aux_3879, BFALSE);
      }
      return new1605_1456;
   }
}


obj_t 
_allocate_set_ex_it_70_ast_node(obj_t env_2719)
{
   {
      set_ex_it_116_t aux_3882;
      aux_3882 = allocate_set_ex_it_57_ast_node();
      return (obj_t) (aux_3882);
   }
}


let_var_6_t 
allocate_let_var_32_ast_node()
{
   {
      let_var_6_t new1566_1464;
      new1566_1464 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
      {
	 long arg2235_1465;
	 arg2235_1465 = class_num_218___object(let_var_6_ast_node);
	 {
	    obj_t obj_2504;
	    obj_2504 = (obj_t) (new1566_1464);
	    (((obj_t) CREF(obj_2504))->header = MAKE_HEADER(arg2235_1465, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3889;
	 aux_3889 = (object_t) (new1566_1464);
	 OBJECT_WIDENING_SET(aux_3889, BFALSE);
      }
      return new1566_1464;
   }
}


obj_t 
_allocate_let_var_179_ast_node(obj_t env_2718)
{
   {
      let_var_6_t aux_3892;
      aux_3892 = allocate_let_var_32_ast_node();
      return (obj_t) (aux_3892);
   }
}


let_fun_218_t 
allocate_let_fun_35_ast_node()
{
   {
      let_fun_218_t new1534_1474;
      new1534_1474 = ((let_fun_218_t) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
      {
	 long arg2242_1475;
	 arg2242_1475 = class_num_218___object(let_fun_218_ast_node);
	 {
	    obj_t obj_2506;
	    obj_2506 = (obj_t) (new1534_1474);
	    (((obj_t) CREF(obj_2506))->header = MAKE_HEADER(arg2242_1475, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3899;
	 aux_3899 = (object_t) (new1534_1474);
	 OBJECT_WIDENING_SET(aux_3899, BFALSE);
      }
      return new1534_1474;
   }
}


obj_t 
_allocate_let_fun_123_ast_node(obj_t env_2717)
{
   {
      let_fun_218_t aux_3902;
      aux_3902 = allocate_let_fun_35_ast_node();
      return (obj_t) (aux_3902);
   }
}


select_t 
allocate_select_194_ast_node()
{
   {
      select_t new1497_1483;
      new1497_1483 = ((select_t) BREF(GC_MALLOC(sizeof(struct select))));
      {
	 long arg2244_1484;
	 arg2244_1484 = class_num_218___object(select_ast_node);
	 {
	    obj_t obj_2508;
	    obj_2508 = (obj_t) (new1497_1483);
	    (((obj_t) CREF(obj_2508))->header = MAKE_HEADER(arg2244_1484, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3909;
	 aux_3909 = (object_t) (new1497_1483);
	 OBJECT_WIDENING_SET(aux_3909, BFALSE);
      }
      return new1497_1483;
   }
}


obj_t 
_allocate_select_101_ast_node(obj_t env_2716)
{
   {
      select_t aux_3912;
      aux_3912 = allocate_select_194_ast_node();
      return (obj_t) (aux_3912);
   }
}


fail_t 
allocate_fail_46_ast_node()
{
   {
      fail_t new1466_1493;
      new1466_1493 = ((fail_t) BREF(GC_MALLOC(sizeof(struct fail))));
      {
	 long arg2246_1494;
	 arg2246_1494 = class_num_218___object(fail_ast_node);
	 {
	    obj_t obj_2510;
	    obj_2510 = (obj_t) (new1466_1493);
	    (((obj_t) CREF(obj_2510))->header = MAKE_HEADER(arg2246_1494, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3919;
	 aux_3919 = (object_t) (new1466_1493);
	 OBJECT_WIDENING_SET(aux_3919, BFALSE);
      }
      return new1466_1493;
   }
}


obj_t 
_allocate_fail_214_ast_node(obj_t env_2715)
{
   {
      fail_t aux_3922;
      aux_3922 = allocate_fail_46_ast_node();
      return (obj_t) (aux_3922);
   }
}


conditional_t 
allocate_conditional_174_ast_node()
{
   {
      conditional_t new1429_1502;
      new1429_1502 = ((conditional_t) BREF(GC_MALLOC(sizeof(struct conditional))));
      {
	 long arg2248_1503;
	 arg2248_1503 = class_num_218___object(conditional_ast_node);
	 {
	    obj_t obj_2512;
	    obj_2512 = (obj_t) (new1429_1502);
	    (((obj_t) CREF(obj_2512))->header = MAKE_HEADER(arg2248_1503, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3929;
	 aux_3929 = (object_t) (new1429_1502);
	 OBJECT_WIDENING_SET(aux_3929, BFALSE);
      }
      return new1429_1502;
   }
}


obj_t 
_allocate_conditional_184_ast_node(obj_t env_2714)
{
   {
      conditional_t aux_3932;
      aux_3932 = allocate_conditional_174_ast_node();
      return (obj_t) (aux_3932);
   }
}


setq_t 
allocate_setq_54_ast_node()
{
   {
      setq_t new1401_1512;
      new1401_1512 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
      {
	 long arg2250_1513;
	 arg2250_1513 = class_num_218___object(setq_ast_node);
	 {
	    obj_t obj_2514;
	    obj_2514 = (obj_t) (new1401_1512);
	    (((obj_t) CREF(obj_2514))->header = MAKE_HEADER(arg2250_1513, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3939;
	 aux_3939 = (object_t) (new1401_1512);
	 OBJECT_WIDENING_SET(aux_3939, BFALSE);
      }
      return new1401_1512;
   }
}


obj_t 
_allocate_setq_253_ast_node(obj_t env_2713)
{
   {
      setq_t aux_3942;
      aux_3942 = allocate_setq_54_ast_node();
      return (obj_t) (aux_3942);
   }
}


cast_t 
allocate_cast_68_ast_node()
{
   {
      cast_t new1379_1520;
      new1379_1520 = ((cast_t) BREF(GC_MALLOC(sizeof(struct cast))));
      {
	 long arg2252_1521;
	 arg2252_1521 = class_num_218___object(cast_ast_node);
	 {
	    obj_t obj_2516;
	    obj_2516 = (obj_t) (new1379_1520);
	    (((obj_t) CREF(obj_2516))->header = MAKE_HEADER(arg2252_1521, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3949;
	 aux_3949 = (object_t) (new1379_1520);
	 OBJECT_WIDENING_SET(aux_3949, BFALSE);
      }
      return new1379_1520;
   }
}


obj_t 
_allocate_cast_146_ast_node(obj_t env_2712)
{
   {
      cast_t aux_3952;
      aux_3952 = allocate_cast_68_ast_node();
      return (obj_t) (aux_3952);
   }
}


pragma_t 
allocate_pragma_110_ast_node()
{
   {
      pragma_t new1351_1527;
      new1351_1527 = ((pragma_t) BREF(GC_MALLOC(sizeof(struct pragma))));
      {
	 long arg2255_1528;
	 arg2255_1528 = class_num_218___object(pragma_ast_node);
	 {
	    obj_t obj_2518;
	    obj_2518 = (obj_t) (new1351_1527);
	    (((obj_t) CREF(obj_2518))->header = MAKE_HEADER(arg2255_1528, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3959;
	 aux_3959 = (object_t) (new1351_1527);
	 OBJECT_WIDENING_SET(aux_3959, BFALSE);
      }
      return new1351_1527;
   }
}


obj_t 
_allocate_pragma_246_ast_node(obj_t env_2711)
{
   {
      pragma_t aux_3962;
      aux_3962 = allocate_pragma_110_ast_node();
      return (obj_t) (aux_3962);
   }
}


funcall_t 
allocate_funcall_80_ast_node()
{
   {
      funcall_t new1321_1536;
      new1321_1536 = ((funcall_t) BREF(GC_MALLOC(sizeof(struct funcall))));
      {
	 long arg2257_1537;
	 arg2257_1537 = class_num_218___object(funcall_ast_node);
	 {
	    obj_t obj_2520;
	    obj_2520 = (obj_t) (new1321_1536);
	    (((obj_t) CREF(obj_2520))->header = MAKE_HEADER(arg2257_1537, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3969;
	 aux_3969 = (object_t) (new1321_1536);
	 OBJECT_WIDENING_SET(aux_3969, BFALSE);
      }
      return new1321_1536;
   }
}


obj_t 
_allocate_funcall_93_ast_node(obj_t env_2710)
{
   {
      funcall_t aux_3972;
      aux_3972 = allocate_funcall_80_ast_node();
      return (obj_t) (aux_3972);
   }
}


app_ly_162_t 
allocate_app_ly_30_ast_node()
{
   {
      app_ly_162_t new1295_1545;
      new1295_1545 = ((app_ly_162_t) BREF(GC_MALLOC(sizeof(struct app_ly_162))));
      {
	 long arg2259_1546;
	 arg2259_1546 = class_num_218___object(app_ly_162_ast_node);
	 {
	    obj_t obj_2522;
	    obj_2522 = (obj_t) (new1295_1545);
	    (((obj_t) CREF(obj_2522))->header = MAKE_HEADER(arg2259_1546, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3979;
	 aux_3979 = (object_t) (new1295_1545);
	 OBJECT_WIDENING_SET(aux_3979, BFALSE);
      }
      return new1295_1545;
   }
}


obj_t 
_allocate_app_ly_138_ast_node(obj_t env_2709)
{
   {
      app_ly_162_t aux_3982;
      aux_3982 = allocate_app_ly_30_ast_node();
      return (obj_t) (aux_3982);
   }
}


app_t 
allocate_app_15_ast_node()
{
   {
      app_t new1262_1553;
      new1262_1553 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2261_1554;
	 arg2261_1554 = class_num_218___object(app_ast_node);
	 {
	    obj_t obj_2524;
	    obj_2524 = (obj_t) (new1262_1553);
	    (((obj_t) CREF(obj_2524))->header = MAKE_HEADER(arg2261_1554, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3989;
	 aux_3989 = (object_t) (new1262_1553);
	 OBJECT_WIDENING_SET(aux_3989, BFALSE);
      }
      return new1262_1553;
   }
}


obj_t 
_allocate_app_162_ast_node(obj_t env_2708)
{
   {
      app_t aux_3992;
      aux_3992 = allocate_app_15_ast_node();
      return (obj_t) (aux_3992);
   }
}


sequence_t 
allocate_sequence_235_ast_node()
{
   {
      sequence_t new1234_1563;
      new1234_1563 = ((sequence_t) BREF(GC_MALLOC(sizeof(struct sequence))));
      {
	 long arg2263_1564;
	 arg2263_1564 = class_num_218___object(sequence_ast_node);
	 {
	    obj_t obj_2526;
	    obj_2526 = (obj_t) (new1234_1563);
	    (((obj_t) CREF(obj_2526))->header = MAKE_HEADER(arg2263_1564, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3999;
	 aux_3999 = (object_t) (new1234_1563);
	 OBJECT_WIDENING_SET(aux_3999, BFALSE);
      }
      return new1234_1563;
   }
}


obj_t 
_allocate_sequence_156_ast_node(obj_t env_2707)
{
   {
      sequence_t aux_4002;
      aux_4002 = allocate_sequence_235_ast_node();
      return (obj_t) (aux_4002);
   }
}


kwote_t 
allocate_kwote_110_ast_node()
{
   {
      kwote_t new1211_1571;
      new1211_1571 = ((kwote_t) BREF(GC_MALLOC(sizeof(struct kwote))));
      {
	 long arg2265_1572;
	 arg2265_1572 = class_num_218___object(kwote_ast_node);
	 {
	    obj_t obj_2528;
	    obj_2528 = (obj_t) (new1211_1571);
	    (((obj_t) CREF(obj_2528))->header = MAKE_HEADER(arg2265_1572, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4009;
	 aux_4009 = (object_t) (new1211_1571);
	 OBJECT_WIDENING_SET(aux_4009, BFALSE);
      }
      return new1211_1571;
   }
}


obj_t 
_allocate_kwote_245_ast_node(obj_t env_2706)
{
   {
      kwote_t aux_4012;
      aux_4012 = allocate_kwote_110_ast_node();
      return (obj_t) (aux_4012);
   }
}


closure_t 
allocate_closure_237_ast_node()
{
   {
      closure_t new1191_1578;
      new1191_1578 = ((closure_t) BREF(GC_MALLOC(sizeof(struct closure))));
      {
	 long arg2267_1579;
	 arg2267_1579 = class_num_218___object(closure_ast_node);
	 {
	    obj_t obj_2530;
	    obj_2530 = (obj_t) (new1191_1578);
	    (((obj_t) CREF(obj_2530))->header = MAKE_HEADER(arg2267_1579, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4019;
	 aux_4019 = (object_t) (new1191_1578);
	 OBJECT_WIDENING_SET(aux_4019, BFALSE);
      }
      return new1191_1578;
   }
}


obj_t 
_allocate_closure_68_ast_node(obj_t env_2705)
{
   {
      closure_t aux_4022;
      aux_4022 = allocate_closure_237_ast_node();
      return (obj_t) (aux_4022);
   }
}


var_t 
allocate_var_186_ast_node()
{
   {
      var_t new1171_1585;
      new1171_1585 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
      {
	 long arg2270_1586;
	 arg2270_1586 = class_num_218___object(var_ast_node);
	 {
	    obj_t obj_2532;
	    obj_2532 = (obj_t) (new1171_1585);
	    (((obj_t) CREF(obj_2532))->header = MAKE_HEADER(arg2270_1586, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4029;
	 aux_4029 = (object_t) (new1171_1585);
	 OBJECT_WIDENING_SET(aux_4029, BFALSE);
      }
      return new1171_1585;
   }
}


obj_t 
_allocate_var_93_ast_node(obj_t env_2704)
{
   {
      var_t aux_4032;
      aux_4032 = allocate_var_186_ast_node();
      return (obj_t) (aux_4032);
   }
}


atom_t 
allocate_atom_199_ast_node()
{
   {
      atom_t new1151_1592;
      new1151_1592 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
      {
	 long arg2272_1593;
	 arg2272_1593 = class_num_218___object(atom_ast_node);
	 {
	    obj_t obj_2534;
	    obj_2534 = (obj_t) (new1151_1592);
	    (((obj_t) CREF(obj_2534))->header = MAKE_HEADER(arg2272_1593, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4039;
	 aux_4039 = (object_t) (new1151_1592);
	 OBJECT_WIDENING_SET(aux_4039, BFALSE);
      }
      return new1151_1592;
   }
}


obj_t 
_allocate_atom_130_ast_node(obj_t env_2703)
{
   {
      atom_t aux_4042;
      aux_4042 = allocate_atom_199_ast_node();
      return (obj_t) (aux_4042);
   }
}


node_effect_213_t 
allocate_node_effect_98_ast_node()
{
   {
      node_effect_213_t new1131_1599;
      new1131_1599 = ((node_effect_213_t) BREF(GC_MALLOC(sizeof(struct node_effect_213))));
      {
	 long arg2274_1600;
	 arg2274_1600 = class_num_218___object(node_effect_213_ast_node);
	 {
	    obj_t obj_2536;
	    obj_2536 = (obj_t) (new1131_1599);
	    (((obj_t) CREF(obj_2536))->header = MAKE_HEADER(arg2274_1600, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4049;
	 aux_4049 = (object_t) (new1131_1599);
	 OBJECT_WIDENING_SET(aux_4049, BFALSE);
      }
      return new1131_1599;
   }
}


obj_t 
_allocate_node_effect_20_ast_node(obj_t env_2702)
{
   {
      node_effect_213_t aux_4052;
      aux_4052 = allocate_node_effect_98_ast_node();
      return (obj_t) (aux_4052);
   }
}


node_t 
allocate_node_189_ast_node()
{
   {
      node_t new1114_1606;
      new1114_1606 = ((node_t) BREF(GC_MALLOC(sizeof(struct node))));
      {
	 long arg2281_1607;
	 arg2281_1607 = class_num_218___object(node_ast_node);
	 {
	    obj_t obj_2538;
	    obj_2538 = (obj_t) (new1114_1606);
	    (((obj_t) CREF(obj_2538))->header = MAKE_HEADER(arg2281_1607, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4059;
	 aux_4059 = (object_t) (new1114_1606);
	 OBJECT_WIDENING_SET(aux_4059, BFALSE);
      }
      return new1114_1606;
   }
}


obj_t 
_allocate_node_227_ast_node(obj_t env_2701)
{
   {
      node_t aux_4062;
      aux_4062 = allocate_node_189_ast_node();
      return (obj_t) (aux_4062);
   }
}


obj_t 
imported_modules_init_94_ast_node()
{
   module_initialization_70_type_type(((long) 0), "AST_NODE");
   return module_initialization_70_ast_var(((long) 0), "AST_NODE");
}
