/*===========================================================================*/
/*   (Ast/occur.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t let_fun_218_ast_node;
extern obj_t scnst_ast_var;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_ast_occur();
extern obj_t module_initialization_70_ast_occur(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_ast_occur();
static obj_t cnst_init_137_ast_occur();
extern obj_t _occur_var_46_ast_occur(obj_t, obj_t);
static obj_t arg13311576_ast_occur(obj_t, obj_t);
extern obj_t _occur_node_in__96_ast_occur(obj_t, obj_t, obj_t);
static obj_t require_initialization_114_ast_occur = BUNSPEC;
static obj_t occur_node__default1310_20_ast_occur(node_t);
extern obj_t var_ast_node;
static obj_t library_modules_init_112_ast_occur();
static obj_t _occur_node__default1310_201_ast_occur(obj_t, obj_t);
extern obj_t cast_ast_node;
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
static obj_t occur_node__249_ast_occur(node_t);
static obj_t __global__68_ast_occur = BUNSPEC;
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t setq_ast_node;
extern obj_t for_each_global__88_ast_env(obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t occur_var_108_ast_occur(obj_t);
static bool_t occur_node___69_ast_occur(obj_t);
extern obj_t node_ast_node;
extern obj_t box_ref_242_ast_node;
static obj_t _occur_node__166_ast_occur(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t app_ast_node;
extern obj_t occur_node_in__115_ast_occur(node_t, global_t);
static obj_t __cnst[1];

DEFINE_EXPORT_PROCEDURE(occur_node_in__env_172_ast_occur, _occur_node_in__96_ast_occur1586, _occur_node_in__96_ast_occur, 0L, 2);
DEFINE_STATIC_GENERIC(occur_node__env_215_ast_occur, _occur_node__166_ast_occur1587, _occur_node__166_ast_occur, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1577_ast_occur, arg13311576_ast_occur1588, arg13311576_ast_occur, 0L, 1);
DEFINE_STATIC_PROCEDURE(occur_node__default1310_env_49_ast_occur, _occur_node__default1310_201_ast_occur1589, _occur_node__default1310_201_ast_occur, 0L, 1);
DEFINE_STRING(string1578_ast_occur, string1578_ast_occur1590, "DONE ", 5);
DEFINE_EXPORT_PROCEDURE(occur_var_env_26_ast_occur, _occur_var_46_ast_occur1591, _occur_var_46_ast_occur, 0L, 1);

obj_t 
module_initialization_70_ast_occur(long checksum_1261, char *from_1262)
{
   if (CBOOL(require_initialization_114_ast_occur))
     {
	require_initialization_114_ast_occur = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_occur();
	cnst_init_137_ast_occur();
	imported_modules_init_94_ast_occur();
	toplevel_init_63_ast_occur();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_occur()
{
   module_initialization_70___object(((long) 0), "AST_OCCUR");
   module_initialization_70___reader(((long) 0), "AST_OCCUR");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_occur()
{
   {
      obj_t cnst_port_138_1253;
      cnst_port_138_1253 = open_input_string(string1578_ast_occur);
      {
	 long i_1254;
	 i_1254 = ((long) 0);
       loop_1255:
	 {
	    bool_t test1579_1256;
	    test1579_1256 = (i_1254 == ((long) -1));
	    if (test1579_1256)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1582_1257;
		    {
		       obj_t list1583_1258;
		       {
			  obj_t arg1584_1259;
			  arg1584_1259 = BNIL;
			  list1583_1258 = MAKE_PAIR(cnst_port_138_1253, arg1584_1259);
		       }
		       arg1582_1257 = read___reader(list1583_1258);
		    }
		    CNST_TABLE_SET(i_1254, arg1582_1257);
		 }
		 {
		    int aux_1260;
		    {
		       long aux_1278;
		       aux_1278 = (i_1254 - ((long) 1));
		       aux_1260 = (int) (aux_1278);
		    }
		    {
		       long i_1281;
		       i_1281 = (long) (aux_1260);
		       i_1254 = i_1281;
		       goto loop_1255;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_occur()
{
   __global__68_ast_occur = BUNSPEC;
   add_generic__110___object(occur_node__env_215_ast_occur, occur_node__default1310_env_49_ast_occur);
   add_inlined_method__244___object(occur_node__env_215_ast_occur, var_ast_node, ((long) 0));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, sequence_ast_node, ((long) 1));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, app_ast_node, ((long) 2));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, app_ly_162_ast_node, ((long) 3));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, funcall_ast_node, ((long) 4));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, pragma_ast_node, ((long) 5));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, cast_ast_node, ((long) 6));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, setq_ast_node, ((long) 7));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, conditional_ast_node, ((long) 8));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, fail_ast_node, ((long) 9));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, select_ast_node, ((long) 10));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, let_fun_218_ast_node, ((long) 11));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, let_var_6_ast_node, ((long) 12));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, set_ex_it_116_ast_node, ((long) 13));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, jump_ex_it_184_ast_node, ((long) 14));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, make_box_202_ast_node, ((long) 15));
   add_inlined_method__244___object(occur_node__env_215_ast_occur, box_ref_242_ast_node, ((long) 16));
   {
      long aux_1301;
      aux_1301 = add_inlined_method__244___object(occur_node__env_215_ast_occur, box_set__221_ast_node, ((long) 17));
      return BINT(aux_1301);
   }
}


obj_t 
occur_var_108_ast_occur(obj_t globals_1)
{
   {
      obj_t arg1331_1238;
      arg1331_1238 = proc1577_ast_occur;
      for_each_global__88_ast_env(arg1331_1238);
   }
   {
      obj_t l1272_658;
      {
	 bool_t aux_1305;
	 l1272_658 = globals_1;
       lname1283_659:
	 if (PAIRP(l1272_658))
	   {
	      {
		 obj_t global_661;
		 global_661 = CAR(l1272_658);
		 {
		    global_t aux_1309;
		    aux_1309 = (global_t) (global_661);
		    __global__68_ast_occur = (obj_t) (aux_1309);
		 }
		 {
		    node_t aux_1312;
		    {
		       obj_t aux_1313;
		       {
			  sfun_t obj_1114;
			  {
			     value_t aux_1314;
			     {
				global_t obj_1113;
				obj_1113 = (global_t) (global_661);
				aux_1314 = (((global_t) CREF(obj_1113))->value);
			     }
			     obj_1114 = (sfun_t) (aux_1314);
			  }
			  aux_1313 = (((sfun_t) CREF(obj_1114))->body);
		       }
		       aux_1312 = (node_t) (aux_1313);
		    }
		    occur_node__249_ast_occur(aux_1312);
		 }
	      }
	      {
		 obj_t l1272_1321;
		 l1272_1321 = CDR(l1272_658);
		 l1272_658 = l1272_1321;
		 goto lname1283_659;
	      }
	   }
	 else
	   {
	      aux_1305 = ((bool_t) 1);
	   }
	 return BBOOL(aux_1305);
      }
   }
}


obj_t 
_occur_var_46_ast_occur(obj_t env_1239, obj_t globals_1240)
{
   return occur_var_108_ast_occur(globals_1240);
}


obj_t 
arg13311576_ast_occur(obj_t env_1241, obj_t global_1242)
{
   {
      obj_t global_655;
      global_655 = global_1242;
      {
	 obj_t res1568_1110;
	 {
	    global_t obj_1108;
	    obj_1108 = (global_t) (global_655);
	    {
	       obj_t x_1246;
	       x_1246 = ((((global_t) CREF(obj_1108))->occurrence) = ((long) ((long) 0)), BUNSPEC);
	       res1568_1110 = BUNSPEC;
	    }
	 }
	 return res1568_1110;
      }
   }
}


obj_t 
occur_node_in__115_ast_occur(node_t node_2, global_t global_3)
{
   __global__68_ast_occur = (obj_t) (global_3);
   return occur_node__249_ast_occur(node_2);
}


obj_t 
_occur_node_in__96_ast_occur(obj_t env_1243, obj_t node_1244, obj_t global_1245)
{
   return occur_node_in__115_ast_occur((node_t) (node_1244), (global_t) (global_1245));
}


obj_t 
occur_node__default1310_20_ast_occur(node_t node_5)
{
   return CNST_TABLE_REF(((long) 0));
}


obj_t 
_occur_node__default1310_201_ast_occur(obj_t env_1236, obj_t node_1237)
{
   return occur_node__default1310_20_ast_occur((node_t) (node_1237));
}


obj_t 
occur_node__249_ast_occur(node_t node_4)
{
 occur_node__249_ast_occur:
   {
      obj_t method1467_984;
      obj_t class1472_985;
      {
	 obj_t arg1476_982;
	 obj_t arg1477_983;
	 {
	    object_t obj_1118;
	    obj_1118 = (object_t) (node_4);
	    {
	       obj_t pre_method_105_1119;
	       pre_method_105_1119 = PROCEDURE_REF(occur_node__env_215_ast_occur, ((long) 2));
	       if (INTEGERP(pre_method_105_1119))
		 {
		    PROCEDURE_SET(occur_node__env_215_ast_occur, ((long) 2), BUNSPEC);
		    arg1476_982 = pre_method_105_1119;
		 }
	       else
		 {
		    long obj_class_num_177_1124;
		    obj_class_num_177_1124 = TYPE(obj_1118);
		    {
		       obj_t arg1183_1125;
		       arg1183_1125 = PROCEDURE_REF(occur_node__env_215_ast_occur, ((long) 1));
		       {
			  long arg1184_1129;
			  {
			     long arg1186_1130;
			     arg1186_1130 = OBJECT_TYPE;
			     arg1184_1129 = (obj_class_num_177_1124 - arg1186_1130);
			  }
			  arg1476_982 = VECTOR_REF(arg1183_1125, arg1184_1129);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1135;
	    object_1135 = (object_t) (node_4);
	    {
	       long arg1187_1136;
	       {
		  long arg1188_1137;
		  long arg1189_1138;
		  arg1188_1137 = TYPE(object_1135);
		  arg1189_1138 = OBJECT_TYPE;
		  arg1187_1136 = (arg1188_1137 - arg1189_1138);
	       }
	       {
		  obj_t vector_1142;
		  vector_1142 = __classes__134___object;
		  arg1477_983 = VECTOR_REF(vector_1142, arg1187_1136);
	       }
	    }
	 }
	 method1467_984 = arg1476_982;
	 class1472_985 = arg1477_983;
	 {
	    if (INTEGERP(method1467_984))
	      {
		 switch ((long) CINT(method1467_984))
		   {
		   case ((long) 0):
		      {
			 var_t node_991;
			 node_991 = (var_t) (node_4);
			 {
			    variable_t v_992;
			    v_992 = (((var_t) CREF(node_991))->variable);
			    {
			       value_t value_993;
			       value_993 = (((variable_t) CREF(v_992))->value);
			       {
				  bool_t test1480_994;
				  {
				     bool_t test1482_996;
				     test1482_996 = is_a__118___object((obj_t) (value_993), scnst_ast_var);
				     if (test1482_996)
				       {
					  obj_t aux_1358;
					  {
					     scnst_t obj_1147;
					     obj_1147 = (scnst_t) (value_993);
					     aux_1358 = (((scnst_t) CREF(obj_1147))->node);
					  }
					  test1480_994 = is_a__118___object(aux_1358, node_ast_node);
				       }
				     else
				       {
					  test1480_994 = ((bool_t) 0);
				       }
				  }
				  if (test1480_994)
				    {
				       node_t aux_1363;
				       {
					  obj_t aux_1364;
					  {
					     scnst_t obj_1149;
					     obj_1149 = (scnst_t) (value_993);
					     aux_1364 = (((scnst_t) CREF(obj_1149))->node);
					  }
					  aux_1363 = (node_t) (aux_1364);
				       }
				       occur_node__249_ast_occur(aux_1363);
				    }
				  else
				    {
				       BUNSPEC;
				    }
			       }
			    }
			    {
			       bool_t test1485_998;
			       {
				  obj_t obj2_1151;
				  obj2_1151 = __global__68_ast_occur;
				  {
				     obj_t aux_1369;
				     aux_1369 = (obj_t) (v_992);
				     test1485_998 = (aux_1369 == obj2_1151);
				  }
			       }
			       if (test1485_998)
				 {
				    return BUNSPEC;
				 }
			       else
				 {
				    long arg1486_999;
				    {
				       long aux_1373;
				       aux_1373 = (((variable_t) CREF(v_992))->occurrence);
				       arg1486_999 = (aux_1373 + ((long) 1));
				    }
				    {
				       obj_t res1569_1157;
				       {
					  obj_t x_1247;
					  x_1247 = ((((variable_t) CREF(v_992))->occurrence) = ((long) arg1486_999), BUNSPEC);
					  res1569_1157 = BUNSPEC;
				       }
				       return res1569_1157;
				    }
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 1):
		      {
			 sequence_t node_1002;
			 node_1002 = (sequence_t) (node_4);
			 {
			    bool_t aux_1378;
			    aux_1378 = occur_node___69_ast_occur((((sequence_t) CREF(node_1002))->nodes));
			    return BBOOL(aux_1378);
			 }
		      }
		      break;
		   case ((long) 2):
		      {
			 app_t node_1004;
			 node_1004 = (app_t) (node_4);
			 {
			    node_t aux_1383;
			    {
			       var_t aux_1384;
			       aux_1384 = (((app_t) CREF(node_1004))->fun);
			       aux_1383 = (node_t) (aux_1384);
			    }
			    occur_node__249_ast_occur(aux_1383);
			 }
			 {
			    bool_t aux_1388;
			    aux_1388 = occur_node___69_ast_occur((((app_t) CREF(node_1004))->args));
			    return BBOOL(aux_1388);
			 }
		      }
		      break;
		   case ((long) 3):
		      {
			 app_ly_162_t node_1008;
			 node_1008 = (app_ly_162_t) (node_4);
			 occur_node__249_ast_occur((((app_ly_162_t) CREF(node_1008))->fun));
			 {
			    node_t node_1395;
			    node_1395 = (((app_ly_162_t) CREF(node_1008))->arg);
			    node_4 = node_1395;
			    goto occur_node__249_ast_occur;
			 }
		      }
		      break;
		   case ((long) 4):
		      {
			 funcall_t node_1012;
			 node_1012 = (funcall_t) (node_4);
			 occur_node__249_ast_occur((((funcall_t) CREF(node_1012))->fun));
			 {
			    bool_t aux_1400;
			    aux_1400 = occur_node___69_ast_occur((((funcall_t) CREF(node_1012))->args));
			    return BBOOL(aux_1400);
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 pragma_t node_1016;
			 node_1016 = (pragma_t) (node_4);
			 {
			    bool_t aux_1405;
			    aux_1405 = occur_node___69_ast_occur((((pragma_t) CREF(node_1016))->args));
			    return BBOOL(aux_1405);
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 cast_t node_1018;
			 node_1018 = (cast_t) (node_4);
			 {
			    node_t node_1410;
			    node_1410 = (((cast_t) CREF(node_1018))->arg);
			    node_4 = node_1410;
			    goto occur_node__249_ast_occur;
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 setq_t node_1020;
			 node_1020 = (setq_t) (node_4);
			 {
			    node_t aux_1413;
			    {
			       var_t aux_1414;
			       aux_1414 = (((setq_t) CREF(node_1020))->var);
			       aux_1413 = (node_t) (aux_1414);
			    }
			    occur_node__249_ast_occur(aux_1413);
			 }
			 {
			    node_t node_1418;
			    node_1418 = (((setq_t) CREF(node_1020))->value);
			    node_4 = node_1418;
			    goto occur_node__249_ast_occur;
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 conditional_t node_1024;
			 node_1024 = (conditional_t) (node_4);
			 occur_node__249_ast_occur((((conditional_t) CREF(node_1024))->test));
			 occur_node__249_ast_occur((((conditional_t) CREF(node_1024))->true));
			 {
			    node_t node_1425;
			    node_1425 = (((conditional_t) CREF(node_1024))->false);
			    node_4 = node_1425;
			    goto occur_node__249_ast_occur;
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 fail_t node_1029;
			 node_1029 = (fail_t) (node_4);
			 occur_node__249_ast_occur((((fail_t) CREF(node_1029))->proc));
			 occur_node__249_ast_occur((((fail_t) CREF(node_1029))->msg));
			 {
			    node_t node_1432;
			    node_1432 = (((fail_t) CREF(node_1029))->obj);
			    node_4 = node_1432;
			    goto occur_node__249_ast_occur;
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 select_t node_1034;
			 node_1034 = (select_t) (node_4);
			 occur_node__249_ast_occur((((select_t) CREF(node_1034))->test));
			 {
			    obj_t l1291_1037;
			    {
			       bool_t aux_1437;
			       l1291_1037 = (((select_t) CREF(node_1034))->clauses);
			     lname1292_1038:
			       if (PAIRP(l1291_1037))
				 {
				    {
				       node_t aux_1440;
				       {
					  obj_t aux_1441;
					  {
					     obj_t aux_1442;
					     aux_1442 = CAR(l1291_1037);
					     aux_1441 = CDR(aux_1442);
					  }
					  aux_1440 = (node_t) (aux_1441);
				       }
				       occur_node__249_ast_occur(aux_1440);
				    }
				    {
				       obj_t l1291_1447;
				       l1291_1447 = CDR(l1291_1037);
				       l1291_1037 = l1291_1447;
				       goto lname1292_1038;
				    }
				 }
			       else
				 {
				    aux_1437 = ((bool_t) 1);
				 }
			       return BBOOL(aux_1437);
			    }
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 let_fun_218_t node_1044;
			 node_1044 = (let_fun_218_t) (node_4);
			 {
			    obj_t l1294_1046;
			    l1294_1046 = (((let_fun_218_t) CREF(node_1044))->locals);
			  lname1295_1047:
			    if (PAIRP(l1294_1046))
			      {
				 {
				    obj_t local_1050;
				    local_1050 = CAR(l1294_1046);
				    {
				       obj_t res1570_1186;
				       {
					  local_t obj_1184;
					  obj_1184 = (local_t) (local_1050);
					  {
					     obj_t x_1248;
					     x_1248 = ((((local_t) CREF(obj_1184))->occurrence) = ((long) ((long) 0)), BUNSPEC);
					     res1570_1186 = BUNSPEC;
					  }
				       }
				       res1570_1186;
				    }
				    {
				       obj_t l1296_1051;
				       {
					  sfun_t obj_1188;
					  {
					     value_t aux_1465;
					     {
						local_t obj_1187;
						obj_1187 = (local_t) (local_1050);
						aux_1465 = (((local_t) CREF(obj_1187))->value);
					     }
					     obj_1188 = (sfun_t) (aux_1465);
					  }
					  l1296_1051 = (((sfun_t) CREF(obj_1188))->args);
				       }
				     lname1298_1052:
				       if (PAIRP(l1296_1051))
					 {
					    {
					       obj_t res1571_1193;
					       {
						  local_t obj_1191;
						  {
						     obj_t aux_1459;
						     aux_1459 = CAR(l1296_1051);
						     obj_1191 = (local_t) (aux_1459);
						  }
						  {
						     obj_t x_1249;
						     x_1249 = ((((local_t) CREF(obj_1191))->occurrence) = ((long) ((long) 1)), BUNSPEC);
						     res1571_1193 = BUNSPEC;
						  }
					       }
					       res1571_1193;
					    }
					    {
					       obj_t l1296_1463;
					       l1296_1463 = CDR(l1296_1051);
					       l1296_1051 = l1296_1463;
					       goto lname1298_1052;
					    }
					 }
				       else
					 {
					    ((bool_t) 1);
					 }
				    }
				 }
				 {
				    obj_t l1294_1470;
				    l1294_1470 = CDR(l1294_1046);
				    l1294_1046 = l1294_1470;
				    goto lname1295_1047;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    obj_t l1299_1059;
			    l1299_1059 = (((let_fun_218_t) CREF(node_1044))->locals);
			  lname1301_1060:
			    if (PAIRP(l1299_1059))
			      {
				 {
				    obj_t local_1063;
				    local_1063 = CAR(l1299_1059);
				    {
				       long old_1064;
				       {
					  local_t obj_1199;
					  obj_1199 = (local_t) (local_1063);
					  old_1064 = (((local_t) CREF(obj_1199))->occurrence);
				       }
				       {
					  node_t aux_1478;
					  {
					     obj_t aux_1479;
					     {
						sfun_t obj_1201;
						{
						   value_t aux_1480;
						   {
						      local_t obj_1200;
						      obj_1200 = (local_t) (local_1063);
						      aux_1480 = (((local_t) CREF(obj_1200))->value);
						   }
						   obj_1201 = (sfun_t) (aux_1480);
						}
						aux_1479 = (((sfun_t) CREF(obj_1201))->body);
					     }
					     aux_1478 = (node_t) (aux_1479);
					  }
					  occur_node__249_ast_occur(aux_1478);
				       }
				       {
					  obj_t res1572_1204;
					  {
					     local_t obj_1202;
					     obj_1202 = (local_t) (local_1063);
					     {
						obj_t x_1250;
						x_1250 = ((((local_t) CREF(obj_1202))->occurrence) = ((long) old_1064), BUNSPEC);
						res1572_1204 = BUNSPEC;
					     }
					  }
					  res1572_1204;
				       }
				    }
				 }
				 {
				    obj_t l1299_1489;
				    l1299_1489 = CDR(l1299_1059);
				    l1299_1059 = l1299_1489;
				    goto lname1301_1060;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    node_t node_1492;
			    node_1492 = (((let_fun_218_t) CREF(node_1044))->body);
			    node_4 = node_1492;
			    goto occur_node__249_ast_occur;
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 let_var_6_t node_1069;
			 node_1069 = (let_var_6_t) (node_4);
			 {
			    obj_t l1303_1071;
			    l1303_1071 = (((let_var_6_t) CREF(node_1069))->bindings);
			  lname1304_1072:
			    if (PAIRP(l1303_1071))
			      {
				 {
				    obj_t binding_1075;
				    binding_1075 = CAR(l1303_1071);
				    {
				       obj_t res1573_1213;
				       {
					  local_t obj_1211;
					  {
					     obj_t aux_1498;
					     aux_1498 = CAR(binding_1075);
					     obj_1211 = (local_t) (aux_1498);
					  }
					  {
					     obj_t x_1251;
					     x_1251 = ((((local_t) CREF(obj_1211))->occurrence) = ((long) ((long) 0)), BUNSPEC);
					     res1573_1213 = BUNSPEC;
					  }
				       }
				       res1573_1213;
				    }
				    {
				       node_t aux_1502;
				       {
					  obj_t aux_1503;
					  aux_1503 = CDR(binding_1075);
					  aux_1502 = (node_t) (aux_1503);
				       }
				       occur_node__249_ast_occur(aux_1502);
				    }
				 }
				 {
				    obj_t l1303_1507;
				    l1303_1507 = CDR(l1303_1071);
				    l1303_1071 = l1303_1507;
				    goto lname1304_1072;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    node_t node_1510;
			    node_1510 = (((let_var_6_t) CREF(node_1069))->body);
			    node_4 = node_1510;
			    goto occur_node__249_ast_occur;
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 set_ex_it_116_t node_1081;
			 node_1081 = (set_ex_it_116_t) (node_4);
			 {
			    obj_t res1574_1221;
			    {
			       local_t obj_1219;
			       {
				  variable_t aux_1513;
				  {
				     var_t arg1553_1085;
				     arg1553_1085 = (((set_ex_it_116_t) CREF(node_1081))->var);
				     aux_1513 = (((var_t) CREF(arg1553_1085))->variable);
				  }
				  obj_1219 = (local_t) (aux_1513);
			       }
			       {
				  obj_t x_1252;
				  x_1252 = ((((local_t) CREF(obj_1219))->occurrence) = ((long) ((long) 0)), BUNSPEC);
				  res1574_1221 = BUNSPEC;
			       }
			    }
			    res1574_1221;
			 }
			 {
			    node_t node_1518;
			    node_1518 = (((set_ex_it_116_t) CREF(node_1081))->body);
			    node_4 = node_1518;
			    goto occur_node__249_ast_occur;
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 jump_ex_it_184_t node_1087;
			 node_1087 = (jump_ex_it_184_t) (node_4);
			 occur_node__249_ast_occur((((jump_ex_it_184_t) CREF(node_1087))->exit));
			 {
			    node_t node_1523;
			    node_1523 = (((jump_ex_it_184_t) CREF(node_1087))->value);
			    node_4 = node_1523;
			    goto occur_node__249_ast_occur;
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 make_box_202_t node_1091;
			 node_1091 = (make_box_202_t) (node_4);
			 {
			    node_t node_1526;
			    node_1526 = (((make_box_202_t) CREF(node_1091))->value);
			    node_4 = node_1526;
			    goto occur_node__249_ast_occur;
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 box_ref_242_t node_1093;
			 node_1093 = (box_ref_242_t) (node_4);
			 {
			    node_t node_1529;
			    {
			       var_t aux_1530;
			       aux_1530 = (((box_ref_242_t) CREF(node_1093))->var);
			       node_1529 = (node_t) (aux_1530);
			    }
			    node_4 = node_1529;
			    goto occur_node__249_ast_occur;
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 box_set__221_t node_1095;
			 node_1095 = (box_set__221_t) (node_4);
			 {
			    node_t aux_1534;
			    {
			       var_t aux_1535;
			       aux_1535 = (((box_set__221_t) CREF(node_1095))->var);
			       aux_1534 = (node_t) (aux_1535);
			    }
			    occur_node__249_ast_occur(aux_1534);
			 }
			 {
			    node_t node_1539;
			    node_1539 = (((box_set__221_t) CREF(node_1095))->value);
			    node_4 = node_1539;
			    goto occur_node__249_ast_occur;
			 }
		      }
		      break;
		   default:
		    case_else1473_108_988:
		      if (PROCEDUREP(method1467_984))
			{
			   return PROCEDURE_ENTRY(method1467_984) (method1467_984, (obj_t) (node_4), BEOA);
			}
		      else
			{
			   obj_t fun1341_665;
			   fun1341_665 = PROCEDURE_REF(occur_node__env_215_ast_occur, ((long) 0));
			   return PROCEDURE_ENTRY(fun1341_665) (fun1341_665, (obj_t) (node_4), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1473_108_988;
	      }
	 }
      }
   }
}


obj_t 
_occur_node__166_ast_occur(obj_t env_1234, obj_t node_1235)
{
   return occur_node__249_ast_occur((node_t) (node_1235));
}


bool_t 
occur_node___69_ast_occur(obj_t node__221_24)
{
   {
      obj_t l1308_666;
      l1308_666 = node__221_24;
    lname1309_667:
      if (PAIRP(l1308_666))
	{
	   {
	      node_t aux_1556;
	      {
		 obj_t aux_1557;
		 aux_1557 = CAR(l1308_666);
		 aux_1556 = (node_t) (aux_1557);
	      }
	      occur_node__249_ast_occur(aux_1556);
	   }
	   {
	      obj_t l1308_1561;
	      l1308_1561 = CDR(l1308_666);
	      l1308_666 = l1308_1561;
	      goto lname1309_667;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
imported_modules_init_94_ast_occur()
{
   module_initialization_70_type_type(((long) 0), "AST_OCCUR");
   module_initialization_70_ast_var(((long) 0), "AST_OCCUR");
   module_initialization_70_ast_node(((long) 0), "AST_OCCUR");
   module_initialization_70_tools_error(((long) 0), "AST_OCCUR");
   module_initialization_70_tools_shape(((long) 0), "AST_OCCUR");
   module_initialization_70_ast_sexp(((long) 0), "AST_OCCUR");
   module_initialization_70_ast_env(((long) 0), "AST_OCCUR");
   return module_initialization_70_ast_local(((long) 0), "AST_OCCUR");
}
