/*===========================================================================*/
/*   (Ast/pragma.scm)                                                        */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t string__number_104___r4_numbers_6_5(obj_t, obj_t);
static obj_t imported_modules_init_94_ast_pragma();
extern obj_t module_initialization_70_ast_pragma(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_input_6_10_2(long, char *);
static obj_t cnst_init_137_ast_pragma();
static obj_t get_max_index_90_ast_pragma(obj_t);
extern obj_t __about_to_read__202___r4_input_6_10_2;
static obj_t lambda13171462_ast_pragma(obj_t, obj_t);
static obj_t require_initialization_114_ast_pragma = BUNSPEC;
static obj_t library_modules_init_112_ast_pragma();
extern obj_t read___reader(obj_t);
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t pragma_ast_node;
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern long class_num_218___object(obj_t);
extern node_t pragma_type__node_160_ast_pragma(bool_t, type_t, obj_t, obj_t, obj_t, obj_t);
extern node_t error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
extern obj_t _pragma_type__node_93_ast_pragma(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern long list_length(obj_t);
extern obj_t input_port_get_string(obj_t);
extern bool_t input_port_fill_buffer(obj_t);
extern obj_t c_substring(obj_t, long, long);
static obj_t __cnst[1];

DEFINE_STRING(string1466_ast_pragma, string1466_ast_pragma1474, "regular-grammar", 15);
DEFINE_EXPORT_PROCEDURE(pragma_type__node_env_157_ast_pragma, _pragma_type__node_93_ast_pragma1475, _pragma_type__node_93_ast_pragma, 0L, 6);
DEFINE_STRING(string1467_ast_pragma, string1467_ast_pragma1476, "token too large", 15);
DEFINE_STRING(string1464_ast_pragma, string1464_ast_pragma1477, "Illegal `pragma' form", 21);
DEFINE_STATIC_PROCEDURE(proc1465_ast_pragma, lambda13171462_ast_pragma1478, lambda13171462_ast_pragma, 0L, 1);
DEFINE_STRING(string1468_ast_pragma, string1468_ast_pragma1479, "VALUE ", 6);
DEFINE_STRING(string1463_ast_pragma, string1463_ast_pragma1480, "Wrong number of arguments in `pragma' form", 42);

obj_t 
module_initialization_70_ast_pragma(long checksum_1152, char *from_1153)
{
   if (CBOOL(require_initialization_114_ast_pragma))
     {
	require_initialization_114_ast_pragma = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_pragma();
	cnst_init_137_ast_pragma();
	imported_modules_init_94_ast_pragma();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_pragma()
{
   module_initialization_70___r4_numbers_6_5(((long) 0), "AST_PRAGMA");
   module_initialization_70___r4_input_6_10_2(((long) 0), "AST_PRAGMA");
   module_initialization_70___reader(((long) 0), "AST_PRAGMA");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_PRAGMA");
   module_initialization_70___object(((long) 0), "AST_PRAGMA");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_pragma()
{
   {
      obj_t cnst_port_138_1144;
      cnst_port_138_1144 = open_input_string(string1468_ast_pragma);
      {
	 long i_1145;
	 i_1145 = ((long) 0);
       loop_1146:
	 {
	    bool_t test1469_1147;
	    test1469_1147 = (i_1145 == ((long) -1));
	    if (test1469_1147)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1470_1148;
		    {
		       obj_t list1471_1149;
		       {
			  obj_t arg1472_1150;
			  arg1472_1150 = BNIL;
			  list1471_1149 = MAKE_PAIR(cnst_port_138_1144, arg1472_1150);
		       }
		       arg1470_1148 = read___reader(list1471_1149);
		    }
		    CNST_TABLE_SET(i_1145, arg1470_1148);
		 }
		 {
		    int aux_1151;
		    {
		       long aux_1171;
		       aux_1171 = (i_1145 - ((long) 1));
		       aux_1151 = (int) (aux_1171);
		    }
		    {
		       long i_1174;
		       i_1174 = (long) (aux_1151);
		       i_1145 = i_1174;
		       goto loop_1146;
		    }
		 }
	      }
	 }
      }
   }
}


node_t 
pragma_type__node_160_ast_pragma(bool_t free_1, type_t type_2, obj_t exp_3, obj_t stack_4, obj_t loc_5, obj_t site_6)
{
   {
      obj_t format_637;
      obj_t values_638;
      if (PAIRP(exp_3))
	{
	   obj_t cdr_109_69_643;
	   cdr_109_69_643 = CDR(exp_3);
	   if (PAIRP(cdr_109_69_643))
	     {
		obj_t car_112_152_645;
		car_112_152_645 = CAR(cdr_109_69_643);
		if (STRINGP(car_112_152_645))
		  {
		     obj_t aux_1184;
		     format_637 = car_112_152_645;
		     values_638 = CDR(cdr_109_69_643);
		     {
			obj_t max_index_167_648;
			obj_t loc_649;
			max_index_167_648 = get_max_index_90_ast_pragma(format_637);
			loc_649 = find_location_loc_243_tools_location(exp_3, loc_5);
			{
			   bool_t test_1187;
			   {
			      long aux_1190;
			      long aux_1188;
			      aux_1190 = list_length(values_638);
			      aux_1188 = (long) CINT(max_index_167_648);
			      test_1187 = (aux_1188 == aux_1190);
			   }
			   if (test_1187)
			     {
				obj_t exps_651;
				obj_t nodes_652;
				{
				   pragma_t aux_1193;
				   exps_651 = values_638;
				   nodes_652 = BNIL;
				 loop_653:
				   if (NULLP(exps_651))
				     {
					bool_t arg1293_656;
					obj_t arg1295_657;
					if (free_1)
					  {
					     arg1293_656 = ((bool_t) 0);
					  }
					else
					  {
					     arg1293_656 = ((bool_t) 1);
					  }
					arg1295_657 = reverse__39___r4_pairs_and_lists_6_3(nodes_652);
					{
					   pragma_t res1454_1065;
					   {
					      obj_t side_effect__165_1053;
					      side_effect__165_1053 = BBOOL(arg1293_656);
					      {
						 pragma_t new1175_1056;
						 new1175_1056 = ((pragma_t) BREF(GC_MALLOC(sizeof(struct pragma))));
						 {
						    long arg1372_1057;
						    arg1372_1057 = class_num_218___object(pragma_ast_node);
						    {
						       obj_t obj_1063;
						       obj_1063 = (obj_t) (new1175_1056);
						       (((obj_t) CREF(obj_1063))->header = MAKE_HEADER(arg1372_1057, 0), BUNSPEC);
						    }
						 }
						 {
						    object_t aux_1203;
						    aux_1203 = (object_t) (new1175_1056);
						    OBJECT_WIDENING_SET(aux_1203, BFALSE);
						 }
						 ((((pragma_t) CREF(new1175_1056))->loc) = ((obj_t) loc_649), BUNSPEC);
						 ((((pragma_t) CREF(new1175_1056))->type) = ((type_t) type_2), BUNSPEC);
						 ((((pragma_t) CREF(new1175_1056))->side_effect__165) = ((obj_t) side_effect__165_1053), BUNSPEC);
						 ((((pragma_t) CREF(new1175_1056))->format) = ((obj_t) format_637), BUNSPEC);
						 ((((pragma_t) CREF(new1175_1056))->args) = ((obj_t) arg1295_657), BUNSPEC);
						 res1454_1065 = new1175_1056;
					      }
					   }
					   aux_1193 = res1454_1065;
					}
				     }
				   else
				     {
					obj_t arg1296_658;
					obj_t arg1297_659;
					arg1296_658 = CDR(exps_651);
					{
					   node_t arg1298_660;
					   {
					      obj_t arg1299_661;
					      obj_t arg1300_662;
					      obj_t arg1303_663;
					      arg1299_661 = CAR(exps_651);
					      arg1300_662 = find_location_loc_243_tools_location(CAR(exps_651), loc_649);
					      arg1303_663 = CNST_TABLE_REF(((long) 0));
					      arg1298_660 = sexp__node_235_ast_sexp(arg1299_661, stack_4, arg1300_662, arg1303_663);
					   }
					   {
					      obj_t aux_1217;
					      aux_1217 = (obj_t) (arg1298_660);
					      arg1297_659 = MAKE_PAIR(aux_1217, nodes_652);
					   }
					}
					{
					   obj_t nodes_1221;
					   obj_t exps_1220;
					   exps_1220 = arg1296_658;
					   nodes_1221 = arg1297_659;
					   nodes_652 = nodes_1221;
					   exps_651 = exps_1220;
					   goto loop_653;
					}
				     }
				   aux_1184 = (obj_t) (aux_1193);
				}
			     }
			   else
			     {
				node_t aux_1223;
				aux_1223 = error_sexp__node_157_ast_sexp(string1463_ast_pragma, exp_3, loc_649);
				aux_1184 = (obj_t) (aux_1223);
			     }
			}
		     }
		     return (node_t) (aux_1184);
		  }
		else
		  {
		   tag_102_241_640:
		     return error_sexp__node_157_ast_sexp(string1464_ast_pragma, exp_3, loc_5);
		  }
	     }
	   else
	     {
		goto tag_102_241_640;
	     }
	}
      else
	{
	   goto tag_102_241_640;
	}
   }
}


obj_t 
_pragma_type__node_93_ast_pragma(obj_t env_1133, obj_t free_1134, obj_t type_1135, obj_t exp_1136, obj_t stack_1137, obj_t loc_1138, obj_t site_1139)
{
   {
      node_t aux_1229;
      aux_1229 = pragma_type__node_160_ast_pragma(CBOOL(free_1134), (type_t) (type_1135), exp_1136, stack_1137, loc_1138, site_1139);
      return (obj_t) (aux_1229);
   }
}


obj_t 
get_max_index_90_ast_pragma(obj_t format_7)
{
   {
      obj_t parser_666;
      obj_t port_667;
      {
	 obj_t lambda1317_1140;
	 lambda1317_1140 = proc1465_ast_pragma;
	 parser_666 = lambda1317_1140;
      }
      port_667 = open_input_string(format_7);
      {
	 obj_t exp_668;
	 obj_t max_669;
	 {
	    obj_t arg1308_671;
	    arg1308_671 = PROCEDURE_ENTRY(parser_666) (parser_666, port_667, BEOA);
	    exp_668 = arg1308_671;
	    max_669 = BINT(((long) 0));
	  loop_670:
	    {
	       bool_t test1311_673;
	       test1311_673 = EOF_OBJECTP(exp_668);
	       if (test1311_673)
		 {
		    return max_669;
		 }
	       else
		 {
		    if (CHARP(exp_668))
		      {
			 {
			    obj_t arg1313_675;
			    arg1313_675 = PROCEDURE_ENTRY(parser_666) (parser_666, port_667, BEOA);
			    {
			       obj_t exp_1243;
			       exp_1243 = arg1313_675;
			       exp_668 = exp_1243;
			       goto loop_670;
			    }
			 }
		      }
		    else
		      {
			 {
			    obj_t arg1314_676;
			    arg1314_676 = PROCEDURE_ENTRY(parser_666) (parser_666, port_667, BEOA);
			    {
			       obj_t max_1247;
			       obj_t exp_1246;
			       exp_1246 = arg1314_676;
			       {
				  bool_t test_1248;
				  {
				     long aux_1251;
				     long aux_1249;
				     aux_1251 = (long) CINT(max_669);
				     aux_1249 = (long) CINT(exp_668);
				     test_1248 = (aux_1249 > aux_1251);
				  }
				  if (test_1248)
				    {
				       max_1247 = exp_668;
				    }
				  else
				    {
				       max_1247 = max_669;
				    }
			       }
			       max_669 = max_1247;
			       exp_668 = exp_1246;
			       goto loop_670;
			    }
			 }
		      }
		 }
	    }
	 }
      }
   }
}


obj_t 
lambda13171462_ast_pragma(obj_t env_1141, obj_t input_port_219_1142)
{
   {
      obj_t input_port_219_680;
      input_port_219_680 = input_port_219_1142;
      {
	 long rule_692;
       ignore_694:
	 INPUT_PORT_RESET_ANNEXE(input_port_219_680);
	 {
	    long rule_720;
	    rule_692 = ((long) 0);
	    {
	       long mr_702;
	       long mr_700;
	       long mr_698;
	       long mr_696;
	       mr_696 = rule_692;
	     state_0_697:
	       {
		  int aux1273_705;
		  aux1273_705 = INPUT_PORT_READ_CHAR(input_port_219_680);
		  switch ((long) (aux1273_705))
		    {
		    case ((long) 254):
		    case ((long) 253):
		    case ((long) 252):
		    case ((long) 251):
		    case ((long) 250):
		    case ((long) 249):
		    case ((long) 248):
		    case ((long) 247):
		    case ((long) 246):
		    case ((long) 245):
		    case ((long) 244):
		    case ((long) 243):
		    case ((long) 242):
		    case ((long) 241):
		    case ((long) 240):
		    case ((long) 239):
		    case ((long) 238):
		    case ((long) 237):
		    case ((long) 236):
		    case ((long) 235):
		    case ((long) 234):
		    case ((long) 233):
		    case ((long) 232):
		    case ((long) 231):
		    case ((long) 230):
		    case ((long) 229):
		    case ((long) 228):
		    case ((long) 227):
		    case ((long) 226):
		    case ((long) 225):
		    case ((long) 224):
		    case ((long) 223):
		    case ((long) 222):
		    case ((long) 221):
		    case ((long) 220):
		    case ((long) 219):
		    case ((long) 218):
		    case ((long) 217):
		    case ((long) 216):
		    case ((long) 215):
		    case ((long) 214):
		    case ((long) 213):
		    case ((long) 212):
		    case ((long) 211):
		    case ((long) 210):
		    case ((long) 209):
		    case ((long) 208):
		    case ((long) 207):
		    case ((long) 206):
		    case ((long) 205):
		    case ((long) 204):
		    case ((long) 203):
		    case ((long) 202):
		    case ((long) 201):
		    case ((long) 200):
		    case ((long) 199):
		    case ((long) 198):
		    case ((long) 197):
		    case ((long) 196):
		    case ((long) 195):
		    case ((long) 194):
		    case ((long) 193):
		    case ((long) 192):
		    case ((long) 191):
		    case ((long) 190):
		    case ((long) 189):
		    case ((long) 188):
		    case ((long) 187):
		    case ((long) 186):
		    case ((long) 185):
		    case ((long) 184):
		    case ((long) 183):
		    case ((long) 182):
		    case ((long) 181):
		    case ((long) 180):
		    case ((long) 179):
		    case ((long) 178):
		    case ((long) 177):
		    case ((long) 176):
		    case ((long) 175):
		    case ((long) 174):
		    case ((long) 173):
		    case ((long) 172):
		    case ((long) 171):
		    case ((long) 170):
		    case ((long) 169):
		    case ((long) 168):
		    case ((long) 167):
		    case ((long) 166):
		    case ((long) 165):
		    case ((long) 164):
		    case ((long) 163):
		    case ((long) 162):
		    case ((long) 161):
		    case ((long) 160):
		    case ((long) 159):
		    case ((long) 158):
		    case ((long) 157):
		    case ((long) 156):
		    case ((long) 155):
		    case ((long) 154):
		    case ((long) 153):
		    case ((long) 152):
		    case ((long) 151):
		    case ((long) 150):
		    case ((long) 149):
		    case ((long) 148):
		    case ((long) 147):
		    case ((long) 146):
		    case ((long) 145):
		    case ((long) 144):
		    case ((long) 143):
		    case ((long) 142):
		    case ((long) 141):
		    case ((long) 140):
		    case ((long) 139):
		    case ((long) 138):
		    case ((long) 137):
		    case ((long) 136):
		    case ((long) 135):
		    case ((long) 134):
		    case ((long) 133):
		    case ((long) 132):
		    case ((long) 131):
		    case ((long) 130):
		    case ((long) 129):
		    case ((long) 128):
		    case ((long) 127):
		    case ((long) 126):
		    case ((long) 125):
		    case ((long) 124):
		    case ((long) 123):
		    case ((long) 122):
		    case ((long) 121):
		    case ((long) 120):
		    case ((long) 119):
		    case ((long) 118):
		    case ((long) 117):
		    case ((long) 116):
		    case ((long) 115):
		    case ((long) 114):
		    case ((long) 113):
		    case ((long) 112):
		    case ((long) 111):
		    case ((long) 110):
		    case ((long) 109):
		    case ((long) 108):
		    case ((long) 107):
		    case ((long) 106):
		    case ((long) 105):
		    case ((long) 104):
		    case ((long) 103):
		    case ((long) 102):
		    case ((long) 101):
		    case ((long) 100):
		    case ((long) 99):
		    case ((long) 98):
		    case ((long) 97):
		    case ((long) 96):
		    case ((long) 95):
		    case ((long) 94):
		    case ((long) 93):
		    case ((long) 92):
		    case ((long) 91):
		    case ((long) 90):
		    case ((long) 89):
		    case ((long) 88):
		    case ((long) 87):
		    case ((long) 86):
		    case ((long) 85):
		    case ((long) 84):
		    case ((long) 83):
		    case ((long) 82):
		    case ((long) 81):
		    case ((long) 80):
		    case ((long) 79):
		    case ((long) 78):
		    case ((long) 77):
		    case ((long) 76):
		    case ((long) 75):
		    case ((long) 74):
		    case ((long) 73):
		    case ((long) 72):
		    case ((long) 71):
		    case ((long) 70):
		    case ((long) 69):
		    case ((long) 68):
		    case ((long) 67):
		    case ((long) 66):
		    case ((long) 65):
		    case ((long) 64):
		    case ((long) 63):
		    case ((long) 62):
		    case ((long) 61):
		    case ((long) 60):
		    case ((long) 59):
		    case ((long) 58):
		    case ((long) 57):
		    case ((long) 56):
		    case ((long) 55):
		    case ((long) 54):
		    case ((long) 53):
		    case ((long) 52):
		    case ((long) 51):
		    case ((long) 50):
		    case ((long) 49):
		    case ((long) 48):
		    case ((long) 47):
		    case ((long) 46):
		    case ((long) 45):
		    case ((long) 44):
		    case ((long) 43):
		    case ((long) 42):
		    case ((long) 41):
		    case ((long) 40):
		    case ((long) 39):
		    case ((long) 38):
		    case ((long) 37):
		    case ((long) 35):
		    case ((long) 34):
		    case ((long) 33):
		    case ((long) 32):
		    case ((long) 31):
		    case ((long) 30):
		    case ((long) 29):
		    case ((long) 28):
		    case ((long) 27):
		    case ((long) 26):
		    case ((long) 25):
		    case ((long) 24):
		    case ((long) 23):
		    case ((long) 22):
		    case ((long) 21):
		    case ((long) 20):
		    case ((long) 19):
		    case ((long) 18):
		    case ((long) 17):
		    case ((long) 16):
		    case ((long) 15):
		    case ((long) 14):
		    case ((long) 13):
		    case ((long) 12):
		    case ((long) 11):
		    case ((long) 10):
		    case ((long) 9):
		    case ((long) 8):
		    case ((long) 7):
		    case ((long) 6):
		    case ((long) 5):
		    case ((long) 4):
		    case ((long) 3):
		    case ((long) 2):
		    case ((long) 1):
		       INPUT_PORT_REMEMBER_REF(input_port_219_680);
		       mr_698 = ((long) 2);
		     state_1_699:
		       {
			  int aux1275_709;
			  aux1275_709 = INPUT_PORT_READ_CHAR(input_port_219_680);
			  switch ((long) (aux1275_709))
			    {
			    case ((long) 254):
			    case ((long) 253):
			    case ((long) 252):
			    case ((long) 251):
			    case ((long) 250):
			    case ((long) 249):
			    case ((long) 248):
			    case ((long) 247):
			    case ((long) 246):
			    case ((long) 245):
			    case ((long) 244):
			    case ((long) 243):
			    case ((long) 242):
			    case ((long) 241):
			    case ((long) 240):
			    case ((long) 239):
			    case ((long) 238):
			    case ((long) 237):
			    case ((long) 236):
			    case ((long) 235):
			    case ((long) 234):
			    case ((long) 233):
			    case ((long) 232):
			    case ((long) 231):
			    case ((long) 230):
			    case ((long) 229):
			    case ((long) 228):
			    case ((long) 227):
			    case ((long) 226):
			    case ((long) 225):
			    case ((long) 224):
			    case ((long) 223):
			    case ((long) 222):
			    case ((long) 221):
			    case ((long) 220):
			    case ((long) 219):
			    case ((long) 218):
			    case ((long) 217):
			    case ((long) 216):
			    case ((long) 215):
			    case ((long) 214):
			    case ((long) 213):
			    case ((long) 212):
			    case ((long) 211):
			    case ((long) 210):
			    case ((long) 209):
			    case ((long) 208):
			    case ((long) 207):
			    case ((long) 206):
			    case ((long) 205):
			    case ((long) 204):
			    case ((long) 203):
			    case ((long) 202):
			    case ((long) 201):
			    case ((long) 200):
			    case ((long) 199):
			    case ((long) 198):
			    case ((long) 197):
			    case ((long) 196):
			    case ((long) 195):
			    case ((long) 194):
			    case ((long) 193):
			    case ((long) 192):
			    case ((long) 191):
			    case ((long) 190):
			    case ((long) 189):
			    case ((long) 188):
			    case ((long) 187):
			    case ((long) 186):
			    case ((long) 185):
			    case ((long) 184):
			    case ((long) 183):
			    case ((long) 182):
			    case ((long) 181):
			    case ((long) 180):
			    case ((long) 179):
			    case ((long) 178):
			    case ((long) 177):
			    case ((long) 176):
			    case ((long) 175):
			    case ((long) 174):
			    case ((long) 173):
			    case ((long) 172):
			    case ((long) 171):
			    case ((long) 170):
			    case ((long) 169):
			    case ((long) 168):
			    case ((long) 167):
			    case ((long) 166):
			    case ((long) 165):
			    case ((long) 164):
			    case ((long) 163):
			    case ((long) 162):
			    case ((long) 161):
			    case ((long) 160):
			    case ((long) 159):
			    case ((long) 158):
			    case ((long) 157):
			    case ((long) 156):
			    case ((long) 155):
			    case ((long) 154):
			    case ((long) 153):
			    case ((long) 152):
			    case ((long) 151):
			    case ((long) 150):
			    case ((long) 149):
			    case ((long) 148):
			    case ((long) 147):
			    case ((long) 146):
			    case ((long) 145):
			    case ((long) 144):
			    case ((long) 143):
			    case ((long) 142):
			    case ((long) 141):
			    case ((long) 140):
			    case ((long) 139):
			    case ((long) 138):
			    case ((long) 137):
			    case ((long) 136):
			    case ((long) 135):
			    case ((long) 134):
			    case ((long) 133):
			    case ((long) 132):
			    case ((long) 131):
			    case ((long) 130):
			    case ((long) 129):
			    case ((long) 128):
			    case ((long) 127):
			    case ((long) 126):
			    case ((long) 125):
			    case ((long) 124):
			    case ((long) 123):
			    case ((long) 122):
			    case ((long) 121):
			    case ((long) 120):
			    case ((long) 119):
			    case ((long) 118):
			    case ((long) 117):
			    case ((long) 116):
			    case ((long) 115):
			    case ((long) 114):
			    case ((long) 113):
			    case ((long) 112):
			    case ((long) 111):
			    case ((long) 110):
			    case ((long) 109):
			    case ((long) 108):
			    case ((long) 107):
			    case ((long) 106):
			    case ((long) 105):
			    case ((long) 104):
			    case ((long) 103):
			    case ((long) 102):
			    case ((long) 101):
			    case ((long) 100):
			    case ((long) 99):
			    case ((long) 98):
			    case ((long) 97):
			    case ((long) 96):
			    case ((long) 95):
			    case ((long) 94):
			    case ((long) 93):
			    case ((long) 92):
			    case ((long) 91):
			    case ((long) 90):
			    case ((long) 89):
			    case ((long) 88):
			    case ((long) 87):
			    case ((long) 86):
			    case ((long) 85):
			    case ((long) 84):
			    case ((long) 83):
			    case ((long) 82):
			    case ((long) 81):
			    case ((long) 80):
			    case ((long) 79):
			    case ((long) 78):
			    case ((long) 77):
			    case ((long) 76):
			    case ((long) 75):
			    case ((long) 74):
			    case ((long) 73):
			    case ((long) 72):
			    case ((long) 71):
			    case ((long) 70):
			    case ((long) 69):
			    case ((long) 68):
			    case ((long) 67):
			    case ((long) 66):
			    case ((long) 65):
			    case ((long) 64):
			    case ((long) 63):
			    case ((long) 62):
			    case ((long) 61):
			    case ((long) 60):
			    case ((long) 59):
			    case ((long) 58):
			    case ((long) 57):
			    case ((long) 56):
			    case ((long) 55):
			    case ((long) 54):
			    case ((long) 53):
			    case ((long) 52):
			    case ((long) 51):
			    case ((long) 50):
			    case ((long) 49):
			    case ((long) 48):
			    case ((long) 47):
			    case ((long) 46):
			    case ((long) 45):
			    case ((long) 44):
			    case ((long) 43):
			    case ((long) 42):
			    case ((long) 41):
			    case ((long) 40):
			    case ((long) 39):
			    case ((long) 38):
			    case ((long) 37):
			    case ((long) 35):
			    case ((long) 34):
			    case ((long) 33):
			    case ((long) 32):
			    case ((long) 31):
			    case ((long) 30):
			    case ((long) 29):
			    case ((long) 28):
			    case ((long) 27):
			    case ((long) 26):
			    case ((long) 25):
			    case ((long) 24):
			    case ((long) 23):
			    case ((long) 22):
			    case ((long) 21):
			    case ((long) 20):
			    case ((long) 19):
			    case ((long) 18):
			    case ((long) 17):
			    case ((long) 16):
			    case ((long) 15):
			    case ((long) 14):
			    case ((long) 13):
			    case ((long) 12):
			    case ((long) 11):
			    case ((long) 10):
			    case ((long) 9):
			    case ((long) 8):
			    case ((long) 7):
			    case ((long) 6):
			    case ((long) 5):
			    case ((long) 4):
			    case ((long) 3):
			    case ((long) 2):
			    case ((long) 1):
			       INPUT_PORT_REMEMBER_REF(input_port_219_680);
			       {
				  long mr_1260;
				  mr_1260 = ((long) 2);
				  mr_698 = mr_1260;
				  goto state_1_699;
			       }
			       break;
			    case ((long) 0):
			       {
				  bool_t test1322_711;
				  {
				     bool_t res1457_1086;
				     {
					bool_t test1148_1084;
					{
					   obj_t obj_1085;
					   obj_1085 = __about_to_read__202___r4_input_6_10_2;
					   test1148_1084 = PROCEDUREP(obj_1085);
					}
					if (test1148_1084)
					  {
					     PROCEDURE_ENTRY(__about_to_read__202___r4_input_6_10_2) (__about_to_read__202___r4_input_6_10_2, input_port_219_680, BEOA);
					  }
					else
					  {
					     BUNSPEC;
					  }
				     }
				     res1457_1086 = input_port_fill_buffer(input_port_219_680);
				     test1322_711 = res1457_1086;
				  }
				  if (test1322_711)
				    {
				       goto state_1_699;
				    }
				  else
				    {
				       rule_720 = mr_698;
				    }
			       }
			       break;
			    default:
			       rule_720 = mr_698;
			    }
		       }
		       break;
		    case ((long) 36):
		       mr_700 = mr_696;
		     state_2_701:
		       {
			  int aux1277_713;
			  aux1277_713 = INPUT_PORT_READ_CHAR(input_port_219_680);
			  switch ((long) (aux1277_713))
			    {
			    case ((long) 48):
			    case ((long) 49):
			    case ((long) 50):
			    case ((long) 51):
			    case ((long) 52):
			    case ((long) 53):
			    case ((long) 54):
			    case ((long) 55):
			    case ((long) 56):
			    case ((long) 57):
			       INPUT_PORT_REMEMBER_REF(input_port_219_680);
			       mr_702 = ((long) 1);
			     state_3_703:
			       {
				  int aux1279_717;
				  aux1279_717 = INPUT_PORT_READ_CHAR(input_port_219_680);
				  switch ((long) (aux1279_717))
				    {
				    case ((long) 48):
				    case ((long) 49):
				    case ((long) 50):
				    case ((long) 51):
				    case ((long) 52):
				    case ((long) 53):
				    case ((long) 54):
				    case ((long) 55):
				    case ((long) 56):
				    case ((long) 57):
				       INPUT_PORT_REMEMBER_REF(input_port_219_680);
				       {
					  long mr_1273;
					  mr_1273 = ((long) 1);
					  mr_702 = mr_1273;
					  goto state_3_703;
				       }
				       break;
				    case ((long) 0):
				       {
					  bool_t test1326_719;
					  {
					     bool_t res1459_1098;
					     {
						bool_t test1148_1096;
						{
						   obj_t obj_1097;
						   obj_1097 = __about_to_read__202___r4_input_6_10_2;
						   test1148_1096 = PROCEDUREP(obj_1097);
						}
						if (test1148_1096)
						  {
						     PROCEDURE_ENTRY(__about_to_read__202___r4_input_6_10_2) (__about_to_read__202___r4_input_6_10_2, input_port_219_680, BEOA);
						  }
						else
						  {
						     BUNSPEC;
						  }
					     }
					     res1459_1098 = input_port_fill_buffer(input_port_219_680);
					     test1326_719 = res1459_1098;
					  }
					  if (test1326_719)
					    {
					       goto state_3_703;
					    }
					  else
					    {
					       rule_720 = mr_702;
					    }
				       }
				       break;
				    default:
				       rule_720 = mr_702;
				    }
			       }
			       break;
			    case ((long) 0):
			       {
				  bool_t test1324_715;
				  {
				     bool_t res1458_1092;
				     {
					bool_t test1148_1090;
					{
					   obj_t obj_1091;
					   obj_1091 = __about_to_read__202___r4_input_6_10_2;
					   test1148_1090 = PROCEDUREP(obj_1091);
					}
					if (test1148_1090)
					  {
					     PROCEDURE_ENTRY(__about_to_read__202___r4_input_6_10_2) (__about_to_read__202___r4_input_6_10_2, input_port_219_680, BEOA);
					  }
					else
					  {
					     BUNSPEC;
					  }
				     }
				     res1458_1092 = input_port_fill_buffer(input_port_219_680);
				     test1324_715 = res1458_1092;
				  }
				  if (test1324_715)
				    {
				       goto state_2_701;
				    }
				  else
				    {
				       rule_720 = mr_700;
				    }
			       }
			       break;
			    default:
			       rule_720 = mr_700;
			    }
		       }
		       break;
		    case ((long) 0):
		       {
			  bool_t test1320_707;
			  {
			     bool_t res1456_1080;
			     {
				bool_t test1148_1078;
				{
				   obj_t obj_1079;
				   obj_1079 = __about_to_read__202___r4_input_6_10_2;
				   test1148_1078 = PROCEDUREP(obj_1079);
				}
				if (test1148_1078)
				  {
				     PROCEDURE_ENTRY(__about_to_read__202___r4_input_6_10_2) (__about_to_read__202___r4_input_6_10_2, input_port_219_680, BEOA);
				  }
				else
				  {
				     BUNSPEC;
				  }
			     }
			     res1456_1080 = input_port_fill_buffer(input_port_219_680);
			     test1320_707 = res1456_1080;
			  }
			  if (test1320_707)
			    {
			       goto state_0_697;
			    }
			  else
			    {
			       rule_720 = mr_696;
			    }
		       }
		       break;
		    default:
		       rule_720 = mr_696;
		    }
	       }
	    }
	    INPUT_PORT_AJUST_CURSOR(input_port_219_680);
	    {
	       switch (rule_720)
		 {
		 case ((long) 2):
		    goto ignore_694;
		    break;
		 case ((long) 1):
		    {
		       obj_t str_724;
		       {
			  obj_t res1460_1102;
			  res1460_1102 = input_port_get_string(input_port_219_680);
			  str_724 = res1460_1102;
		       }
		       {
			  long len_725;
			  len_725 = INPUT_PORT_GET_LENGTH(input_port_219_680);
			  {
			     {
				obj_t arg1328_726;
				arg1328_726 = c_substring(str_724, ((long) 1), len_725);
				return string__number_104___r4_numbers_6_5(arg1328_726, BNIL);
			     }
			  }
		       }
		    }
		    break;
		 default:
		    {
		       bool_t test1330_728;
		       test1330_728 = INPUT_PORT_TOKEN_TOO_LARGEP(input_port_219_680);
		       if (test1330_728)
			 {
			    FAILURE(string1466_ast_pragma, string1467_ast_pragma, BUNSPEC);
			 }
		       else
			 {
			    BUNSPEC;
			 }
		    }
		    return INPUT_PORT_STEAL_CHAR(input_port_219_680);
		 }
	    }
	 }
      }
   }
}


obj_t 
imported_modules_init_94_ast_pragma()
{
   module_initialization_70_type_type(((long) 0), "AST_PRAGMA");
   module_initialization_70_ast_var(((long) 0), "AST_PRAGMA");
   module_initialization_70_ast_node(((long) 0), "AST_PRAGMA");
   module_initialization_70_tools_error(((long) 0), "AST_PRAGMA");
   module_initialization_70_tools_location(((long) 0), "AST_PRAGMA");
   return module_initialization_70_ast_sexp(((long) 0), "AST_PRAGMA");
}
