/*===========================================================================*/
/*   (Ast/remove.scm)                                                        */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t let_fun_218_ast_node;
static node_t node_remove__default1286_168_ast_remove(node_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t _node_remove__224_ast_remove(obj_t, obj_t);
static obj_t imported_modules_init_94_ast_remove();
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_ast_occur(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t toplevel_init_63_ast_remove();
static obj_t cnst_init_137_ast_remove();
extern obj_t remove_var_from__148_ast_remove(obj_t, variable_t);
static obj_t require_initialization_114_ast_remove = BUNSPEC;
extern obj_t var_ast_node;
static obj_t library_modules_init_112_ast_remove();
extern obj_t _remove_var_from__39_ast_remove(obj_t, obj_t, obj_t);
extern obj_t cast_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
static node_t node_remove__162_ast_remove(node_t);
extern obj_t _remove_var_213_ast_remove(obj_t, obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t occur_var_108_ast_occur(obj_t);
extern obj_t kwote_ast_node;
extern bool_t side_effect__165_effect_effect(node_t);
static obj_t node_remove___45_ast_remove(obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
static obj_t _node_remove__default1286_107_ast_remove(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t __cnst[6];

DEFINE_STRING(string1696_ast_remove, string1696_ast_remove1705, "        ", 8);
DEFINE_STATIC_PROCEDURE(node_remove__default1286_env_132_ast_remove, _node_remove__default1286_107_ast_remove1706, _node_remove__default1286_107_ast_remove, 0L, 1);
DEFINE_STATIC_GENERIC(node_remove__env_197_ast_remove, _node_remove__224_ast_remove1707, _node_remove__224_ast_remove, 0L, 1);
DEFINE_EXPORT_PROCEDURE(remove_var_env_229_ast_remove, _remove_var_213_ast_remove1708, _remove_var_213_ast_remove, 0L, 2);
DEFINE_STRING(string1695_ast_remove, string1695_ast_remove1709, " removed", 8);
DEFINE_STRING(string1694_ast_remove, string1694_ast_remove1710, "         removing ", 18);
DEFINE_STRING(string1698_ast_remove, string1698_ast_remove1711, "DONE NODE-REMOVE!-DEFAULT1286 NO-REMOVE EXPORT OK NOW ", 54);
DEFINE_STRING(string1691_ast_remove, string1691_ast_remove1712, "/", 1);
DEFINE_STRING(string1697_ast_remove, string1697_ast_remove1713, "No method for this object", 25);
DEFINE_EXPORT_PROCEDURE(remove_var_from__env_82_ast_remove, _remove_var_from__39_ast_remove1714, _remove_var_from__39_ast_remove, 0L, 2);
DEFINE_STRING(string1692_ast_remove, string1692_ast_remove1715, "remove-var-from!", 16);
DEFINE_STRING(string1693_ast_remove, string1693_ast_remove1716, "already removable variable", 26);

obj_t 
module_initialization_70_ast_remove(long checksum_1496, char *from_1497)
{
   if (CBOOL(require_initialization_114_ast_remove))
     {
	require_initialization_114_ast_remove = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_remove();
	cnst_init_137_ast_remove();
	imported_modules_init_94_ast_remove();
	toplevel_init_63_ast_remove();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_remove()
{
   module_initialization_70___object(((long) 0), "AST_REMOVE");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_REMOVE");
   module_initialization_70___reader(((long) 0), "AST_REMOVE");
   module_initialization_70___r4_strings_6_7(((long) 0), "AST_REMOVE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_remove()
{
   {
      obj_t cnst_port_138_1488;
      cnst_port_138_1488 = open_input_string(string1698_ast_remove);
      {
	 long i_1489;
	 i_1489 = ((long) 5);
       loop_1490:
	 {
	    bool_t test1699_1491;
	    test1699_1491 = (i_1489 == ((long) -1));
	    if (test1699_1491)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1701_1492;
		    {
		       obj_t list1702_1493;
		       {
			  obj_t arg1703_1494;
			  arg1703_1494 = BNIL;
			  list1702_1493 = MAKE_PAIR(cnst_port_138_1488, arg1703_1494);
		       }
		       arg1701_1492 = read___reader(list1702_1493);
		    }
		    CNST_TABLE_SET(i_1489, arg1701_1492);
		 }
		 {
		    int aux_1495;
		    {
		       long aux_1515;
		       aux_1515 = (i_1489 - ((long) 1));
		       aux_1495 = (int) (aux_1515);
		    }
		    {
		       long i_1518;
		       i_1518 = (long) (aux_1495);
		       i_1489 = i_1518;
		       goto loop_1490;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_remove()
{
   add_generic__110___object(node_remove__env_197_ast_remove, node_remove__default1286_env_132_ast_remove);
   add_inlined_method__244___object(node_remove__env_197_ast_remove, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, var_ast_node, ((long) 1));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, kwote_ast_node, ((long) 2));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, sequence_ast_node, ((long) 3));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, app_ast_node, ((long) 4));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, setq_ast_node, ((long) 9));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, conditional_ast_node, ((long) 10));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, fail_ast_node, ((long) 11));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, select_ast_node, ((long) 12));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, make_box_202_ast_node, ((long) 13));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, box_ref_242_ast_node, ((long) 14));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, box_set__221_ast_node, ((long) 15));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, let_fun_218_ast_node, ((long) 16));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, let_var_6_ast_node, ((long) 17));
   add_inlined_method__244___object(node_remove__env_197_ast_remove, set_ex_it_116_ast_node, ((long) 18));
   {
      long aux_1540;
      aux_1540 = add_inlined_method__244___object(node_remove__env_197_ast_remove, jump_ex_it_184_ast_node, ((long) 19));
      return BINT(aux_1540);
   }
}


obj_t 
remove_var_from__148_ast_remove(obj_t pass_1, variable_t var_2)
{
   {
      obj_t old_657;
      old_657 = (((variable_t) CREF(var_2))->removable);
      {
	 bool_t test_1544;
	 {
	    obj_t aux_1545;
	    aux_1545 = CNST_TABLE_REF(((long) 0));
	    test_1544 = (old_657 == aux_1545);
	 }
	 if (test_1544)
	   {
	      {
		 obj_t res1659_1200;
		 {
		    global_t obj_1198;
		    obj_1198 = (global_t) (var_2);
		    {
		       obj_t x_1457;
		       x_1457 = ((((global_t) CREF(obj_1198))->removable) = ((obj_t) pass_1), BUNSPEC);
		       res1659_1200 = BUNSPEC;
		    }
		 }
		 return res1659_1200;
	      }
	   }
	 else
	   {
	      if ((old_657 == pass_1))
		{
		   return CNST_TABLE_REF(((long) 1));
		}
	      else
		{
		   bool_t test_1553;
		   {
		      obj_t aux_1554;
		      aux_1554 = CNST_TABLE_REF(((long) 0));
		      test_1553 = (pass_1 == aux_1554);
		   }
		   if (test_1553)
		     {
			return CNST_TABLE_REF(((long) 1));
		     }
		   else
		     {
			{
			   obj_t arg1312_663;
			   {
			      obj_t arg1313_664;
			      obj_t arg1315_666;
			      arg1313_664 = SYMBOL_TO_STRING(old_657);
			      arg1315_666 = SYMBOL_TO_STRING(pass_1);
			      {
				 obj_t list1316_667;
				 {
				    obj_t arg1318_668;
				    {
				       obj_t arg1319_669;
				       arg1319_669 = MAKE_PAIR(arg1315_666, BNIL);
				       arg1318_668 = MAKE_PAIR(string1691_ast_remove, arg1319_669);
				    }
				    list1316_667 = MAKE_PAIR(arg1313_664, arg1318_668);
				 }
				 arg1312_663 = string_append_106___r4_strings_6_7(list1316_667);
			      }
			   }
			   return internal_error_43_tools_error(string1692_ast_remove, string1693_ast_remove, arg1312_663);
			}
		     }
		}
	   }
      }
   }
}


obj_t 
_remove_var_from__39_ast_remove(obj_t env_1451, obj_t pass_1452, obj_t var_1453)
{
   return remove_var_from__148_ast_remove(pass_1452, (variable_t) (var_1453));
}


obj_t 
remove_var_123_ast_remove(obj_t pass_3, obj_t globals_4)
{
   occur_var_108_ast_occur(globals_4);
   {
      obj_t globals_673;
      obj_t res_674;
      globals_673 = globals_4;
      res_674 = BNIL;
    loop_675:
      if (NULLP(globals_673))
	{
	   return reverse__39___r4_pairs_and_lists_6_3(res_674);
	}
      else
	{
	   obj_t global_678;
	   global_678 = CAR(globals_673);
	   {
	      bool_t test_1572;
	      {
		 obj_t aux_1576;
		 obj_t aux_1573;
		 aux_1576 = CNST_TABLE_REF(((long) 2));
		 {
		    global_t obj_1209;
		    obj_1209 = (global_t) (global_678);
		    aux_1573 = (((global_t) CREF(obj_1209))->import);
		 }
		 test_1572 = (aux_1573 == aux_1576);
	      }
	      if (test_1572)
		{
		   {
		      value_t sfun_680;
		      {
			 global_t obj_1212;
			 obj_1212 = (global_t) (global_678);
			 sfun_680 = (((global_t) CREF(obj_1212))->value);
		      }
		      {
			 node_t arg1327_681;
			 {
			    node_t aux_1581;
			    {
			       obj_t aux_1582;
			       {
				  sfun_t obj_1213;
				  obj_1213 = (sfun_t) (sfun_680);
				  aux_1582 = (((sfun_t) CREF(obj_1213))->body);
			       }
			       aux_1581 = (node_t) (aux_1582);
			    }
			    arg1327_681 = node_remove__162_ast_remove(aux_1581);
			 }
			 {
			    obj_t res1660_1216;
			    {
			       sfun_t obj_1214;
			       obj_t val1077_1215;
			       obj_1214 = (sfun_t) (sfun_680);
			       val1077_1215 = (obj_t) (arg1327_681);
			       {
				  obj_t x_1458;
				  x_1458 = ((((sfun_t) CREF(obj_1214))->body) = ((obj_t) val1077_1215), BUNSPEC);
				  res1660_1216 = BUNSPEC;
			       }
			    }
			    res1660_1216;
			 }
		      }
		   }
		   {
		      obj_t arg1329_683;
		      obj_t arg1331_684;
		      arg1329_683 = CDR(globals_673);
		      arg1331_684 = MAKE_PAIR(global_678, res_674);
		      {
			 obj_t res_1593;
			 obj_t globals_1592;
			 globals_1592 = arg1329_683;
			 res_1593 = arg1331_684;
			 res_674 = res_1593;
			 globals_673 = globals_1592;
			 goto loop_675;
		      }
		   }
		}
	      else
		{
		   bool_t test_1594;
		   {
		      bool_t test_1595;
		      {
			 obj_t aux_1596;
			 {
			    global_t obj_1220;
			    obj_1220 = (global_t) (global_678);
			    aux_1596 = (((global_t) CREF(obj_1220))->removable);
			 }
			 test_1595 = (aux_1596 == pass_3);
		      }
		      if (test_1595)
			{
			   test_1594 = ((bool_t) 1);
			}
		      else
			{
			   obj_t aux_1600;
			   {
			      obj_t aux_1601;
			      {
				 global_t obj_1223;
				 obj_1223 = (global_t) (global_678);
				 aux_1601 = (((global_t) CREF(obj_1223))->removable);
			      }
			      aux_1600 = memq___r4_pairs_and_lists_6_3(aux_1601, pass_3);
			   }
			   test_1594 = CBOOL(aux_1600);
			}
		   }
		   if (test_1594)
		     {
			{
			   bool_t test_1606;
			   {
			      long aux_1607;
			      {
				 global_t obj_1224;
				 obj_1224 = (global_t) (global_678);
				 aux_1607 = (((global_t) CREF(obj_1224))->occurrence);
			      }
			      test_1606 = (aux_1607 <= ((long) 0));
			   }
			   if (test_1606)
			     {
				{
				   obj_t arg1339_689;
				   arg1339_689 = shape_tools_shape(global_678);
				   {
				      obj_t list1340_690;
				      {
					 obj_t arg1342_691;
					 {
					    obj_t arg1343_692;
					    {
					       obj_t aux_1612;
					       aux_1612 = BCHAR(((unsigned char) '\n'));
					       arg1343_692 = MAKE_PAIR(aux_1612, BNIL);
					    }
					    arg1342_691 = MAKE_PAIR(arg1339_689, arg1343_692);
					 }
					 list1340_690 = MAKE_PAIR(string1694_ast_remove, arg1342_691);
				      }
				      verbose_tools_speek(BINT(((long) 3)), list1340_690);
				   }
				}
				{
				   obj_t globals_1619;
				   globals_1619 = CDR(globals_673);
				   globals_673 = globals_1619;
				   goto loop_675;
				}
			     }
			   else
			     {
				value_t sfun_695;
				{
				   global_t obj_1228;
				   obj_1228 = (global_t) (global_678);
				   sfun_695 = (((global_t) CREF(obj_1228))->value);
				}
				{
				   obj_t arg1347_696;
				   arg1347_696 = CNST_TABLE_REF(((long) 0));
				   {
				      obj_t res1661_1231;
				      {
					 global_t obj_1229;
					 obj_1229 = (global_t) (global_678);
					 {
					    obj_t x_1459;
					    x_1459 = ((((global_t) CREF(obj_1229))->removable) = ((obj_t) arg1347_696), BUNSPEC);
					    res1661_1231 = BUNSPEC;
					 }
				      }
				      res1661_1231;
				   }
				}
				{
				   node_t arg1349_697;
				   {
				      node_t aux_1626;
				      {
					 obj_t aux_1627;
					 {
					    sfun_t obj_1232;
					    obj_1232 = (sfun_t) (sfun_695);
					    aux_1627 = (((sfun_t) CREF(obj_1232))->body);
					 }
					 aux_1626 = (node_t) (aux_1627);
				      }
				      arg1349_697 = node_remove__162_ast_remove(aux_1626);
				   }
				   {
				      obj_t res1662_1235;
				      {
					 sfun_t obj_1233;
					 obj_t val1077_1234;
					 obj_1233 = (sfun_t) (sfun_695);
					 val1077_1234 = (obj_t) (arg1349_697);
					 {
					    obj_t x_1460;
					    x_1460 = ((((sfun_t) CREF(obj_1233))->body) = ((obj_t) val1077_1234), BUNSPEC);
					    res1662_1235 = BUNSPEC;
					 }
				      }
				      res1662_1235;
				   }
				}
				{
				   obj_t arg1352_699;
				   obj_t arg1353_700;
				   arg1352_699 = CDR(globals_673);
				   arg1353_700 = MAKE_PAIR(global_678, res_674);
				   {
				      obj_t res_1638;
				      obj_t globals_1637;
				      globals_1637 = arg1352_699;
				      res_1638 = arg1353_700;
				      res_674 = res_1638;
				      globals_673 = globals_1637;
				      goto loop_675;
				   }
				}
			     }
			}
		     }
		   else
		     {
			bool_t test_1639;
			{
			   bool_t test_1640;
			   {
			      long aux_1641;
			      {
				 global_t obj_1239;
				 obj_1239 = (global_t) (global_678);
				 aux_1641 = (((global_t) CREF(obj_1239))->occurrence);
			      }
			      test_1640 = (aux_1641 <= ((long) 0));
			   }
			   if (test_1640)
			     {
				bool_t test_1645;
				{
				   obj_t aux_1649;
				   obj_t aux_1646;
				   aux_1649 = CNST_TABLE_REF(((long) 0));
				   {
				      global_t obj_1242;
				      obj_1242 = (global_t) (global_678);
				      aux_1646 = (((global_t) CREF(obj_1242))->removable);
				   }
				   test_1645 = (aux_1646 == aux_1649);
				}
				if (test_1645)
				  {
				     bool_t test_1652;
				     {
					obj_t aux_1653;
					aux_1653 = CNST_TABLE_REF(((long) 3));
					test_1652 = (pass_3 == aux_1653);
				     }
				     if (test_1652)
				       {
					  test_1639 = ((bool_t) 0);
				       }
				     else
				       {
					  test_1639 = ((bool_t) 1);
				       }
				  }
				else
				  {
				     test_1639 = ((bool_t) 0);
				  }
			     }
			   else
			     {
				test_1639 = ((bool_t) 0);
			     }
			}
			if (test_1639)
			  {
			     {
				obj_t arg1361_706;
				arg1361_706 = shape_tools_shape(global_678);
				{
				   obj_t list1364_708;
				   {
				      obj_t arg1366_709;
				      {
					 obj_t arg1367_710;
					 {
					    obj_t arg1369_711;
					    {
					       obj_t aux_1657;
					       aux_1657 = BCHAR(((unsigned char) '\n'));
					       arg1369_711 = MAKE_PAIR(aux_1657, BNIL);
					    }
					    arg1367_710 = MAKE_PAIR(string1695_ast_remove, arg1369_711);
					 }
					 arg1366_709 = MAKE_PAIR(arg1361_706, arg1367_710);
				      }
				      list1364_708 = MAKE_PAIR(string1696_ast_remove, arg1366_709);
				   }
				   verbose_tools_speek(BINT(((long) 3)), list1364_708);
				}
			     }
			     {
				obj_t globals_1665;
				globals_1665 = CDR(globals_673);
				globals_673 = globals_1665;
				goto loop_675;
			     }
			  }
			else
			  {
			     {
				value_t sfun_714;
				{
				   global_t obj_1248;
				   obj_1248 = (global_t) (global_678);
				   sfun_714 = (((global_t) CREF(obj_1248))->value);
				}
				{
				   node_t arg1376_715;
				   {
				      node_t aux_1669;
				      {
					 obj_t aux_1670;
					 {
					    sfun_t obj_1249;
					    obj_1249 = (sfun_t) (sfun_714);
					    aux_1670 = (((sfun_t) CREF(obj_1249))->body);
					 }
					 aux_1669 = (node_t) (aux_1670);
				      }
				      arg1376_715 = node_remove__162_ast_remove(aux_1669);
				   }
				   {
				      obj_t res1663_1252;
				      {
					 sfun_t obj_1250;
					 obj_t val1077_1251;
					 obj_1250 = (sfun_t) (sfun_714);
					 val1077_1251 = (obj_t) (arg1376_715);
					 {
					    obj_t x_1461;
					    x_1461 = ((((sfun_t) CREF(obj_1250))->body) = ((obj_t) val1077_1251), BUNSPEC);
					    res1663_1252 = BUNSPEC;
					 }
				      }
				      res1663_1252;
				   }
				}
				{
				   obj_t arg1380_717;
				   obj_t arg1381_718;
				   arg1380_717 = CDR(globals_673);
				   arg1381_718 = MAKE_PAIR(global_678, res_674);
				   {
				      obj_t res_1681;
				      obj_t globals_1680;
				      globals_1680 = arg1380_717;
				      res_1681 = arg1381_718;
				      res_674 = res_1681;
				      globals_673 = globals_1680;
				      goto loop_675;
				   }
				}
			     }
			  }
		     }
		}
	   }
	}
   }
}


obj_t 
_remove_var_213_ast_remove(obj_t env_1454, obj_t pass_1455, obj_t globals_1456)
{
   return remove_var_123_ast_remove(pass_1455, globals_1456);
}


node_t 
node_remove__default1286_168_ast_remove(node_t node_6)
{
   FAILURE(CNST_TABLE_REF(((long) 4)), string1697_ast_remove, (obj_t) (node_6));
}


obj_t 
_node_remove__default1286_107_ast_remove(obj_t env_1449, obj_t node_1450)
{
   {
      node_t aux_1686;
      aux_1686 = node_remove__default1286_168_ast_remove((node_t) (node_1450));
      return (obj_t) (aux_1686);
   }
}


node_t 
node_remove__162_ast_remove(node_t node_5)
{
   {
      obj_t method1525_1052;
      obj_t class1530_1053;
      {
	 obj_t arg1534_1050;
	 obj_t arg1535_1051;
	 {
	    object_t obj_1261;
	    obj_1261 = (object_t) (node_5);
	    {
	       obj_t pre_method_105_1262;
	       pre_method_105_1262 = PROCEDURE_REF(node_remove__env_197_ast_remove, ((long) 2));
	       if (INTEGERP(pre_method_105_1262))
		 {
		    PROCEDURE_SET(node_remove__env_197_ast_remove, ((long) 2), BUNSPEC);
		    arg1534_1050 = pre_method_105_1262;
		 }
	       else
		 {
		    long obj_class_num_177_1267;
		    obj_class_num_177_1267 = TYPE(obj_1261);
		    {
		       obj_t arg1183_1268;
		       arg1183_1268 = PROCEDURE_REF(node_remove__env_197_ast_remove, ((long) 1));
		       {
			  long arg1184_1272;
			  {
			     long arg1186_1273;
			     arg1186_1273 = OBJECT_TYPE;
			     arg1184_1272 = (obj_class_num_177_1267 - arg1186_1273);
			  }
			  arg1534_1050 = VECTOR_REF(arg1183_1268, arg1184_1272);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1278;
	    object_1278 = (object_t) (node_5);
	    {
	       long arg1187_1279;
	       {
		  long arg1188_1280;
		  long arg1189_1281;
		  arg1188_1280 = TYPE(object_1278);
		  arg1189_1281 = OBJECT_TYPE;
		  arg1187_1279 = (arg1188_1280 - arg1189_1281);
	       }
	       {
		  obj_t vector_1285;
		  vector_1285 = __classes__134___object;
		  arg1535_1051 = VECTOR_REF(vector_1285, arg1187_1279);
	       }
	    }
	 }
	 {
	    obj_t aux_1705;
	    method1525_1052 = arg1534_1050;
	    class1530_1053 = arg1535_1051;
	    {
	       if (INTEGERP(method1525_1052))
		 {
		    switch ((long) CINT(method1525_1052))
		      {
		      case ((long) 0):
			 {
			    atom_t aux_1708;
			    aux_1708 = (atom_t) (node_5);
			    aux_1705 = (obj_t) (aux_1708);
			 }
			 break;
		      case ((long) 1):
			 {
			    var_t aux_1711;
			    aux_1711 = (var_t) (node_5);
			    aux_1705 = (obj_t) (aux_1711);
			 }
			 break;
		      case ((long) 2):
			 {
			    kwote_t aux_1714;
			    aux_1714 = (kwote_t) (node_5);
			    aux_1705 = (obj_t) (aux_1714);
			 }
			 break;
		      case ((long) 3):
			 {
			    sequence_t node_1062;
			    node_1062 = (sequence_t) (node_5);
			    node_remove___45_ast_remove((((sequence_t) CREF(node_1062))->nodes));
			    aux_1705 = (obj_t) (node_1062);
			 }
			 break;
		      case ((long) 4):
			 {
			    app_t node_1064;
			    node_1064 = (app_t) (node_5);
			    {
			       node_t arg1539_1065;
			       {
				  node_t aux_1722;
				  {
				     var_t aux_1723;
				     aux_1723 = (((app_t) CREF(node_1064))->fun);
				     aux_1722 = (node_t) (aux_1723);
				  }
				  arg1539_1065 = node_remove__162_ast_remove(aux_1722);
			       }
			       {
				  obj_t res1664_1291;
				  {
				     var_t val1155_1290;
				     val1155_1290 = (var_t) (arg1539_1065);
				     {
					obj_t x_1462;
					x_1462 = ((((app_t) CREF(node_1064))->fun) = ((var_t) val1155_1290), BUNSPEC);
					res1664_1291 = BUNSPEC;
				     }
				  }
				  res1664_1291;
			       }
			    }
			    node_remove___45_ast_remove((((app_t) CREF(node_1064))->args));
			    aux_1705 = (obj_t) (node_1064);
			 }
			 break;
		      case ((long) 5):
			 {
			    app_ly_162_t node_1068;
			    node_1068 = (app_ly_162_t) (node_5);
			    {
			       node_t arg1542_1069;
			       arg1542_1069 = node_remove__162_ast_remove((((app_ly_162_t) CREF(node_1068))->fun));
			       {
				  obj_t res1665_1296;
				  {
				     obj_t x_1463;
				     x_1463 = ((((app_ly_162_t) CREF(node_1068))->fun) = ((node_t) arg1542_1069), BUNSPEC);
				     res1665_1296 = BUNSPEC;
				  }
				  res1665_1296;
			       }
			    }
			    {
			       node_t arg1547_1071;
			       arg1547_1071 = node_remove__162_ast_remove((((app_ly_162_t) CREF(node_1068))->arg));
			       {
				  obj_t res1666_1300;
				  {
				     obj_t x_1464;
				     x_1464 = ((((app_ly_162_t) CREF(node_1068))->arg) = ((node_t) arg1547_1071), BUNSPEC);
				     res1666_1300 = BUNSPEC;
				  }
				  res1666_1300;
			       }
			    }
			    aux_1705 = (obj_t) (node_1068);
			 }
			 break;
		      case ((long) 6):
			 {
			    funcall_t node_1073;
			    node_1073 = (funcall_t) (node_5);
			    {
			       node_t arg1550_1074;
			       arg1550_1074 = node_remove__162_ast_remove((((funcall_t) CREF(node_1073))->fun));
			       {
				  obj_t res1667_1304;
				  {
				     obj_t x_1465;
				     x_1465 = ((((funcall_t) CREF(node_1073))->fun) = ((node_t) arg1550_1074), BUNSPEC);
				     res1667_1304 = BUNSPEC;
				  }
				  res1667_1304;
			       }
			    }
			    node_remove___45_ast_remove((((funcall_t) CREF(node_1073))->args));
			    aux_1705 = (obj_t) (node_1073);
			 }
			 break;
		      case ((long) 7):
			 {
			    pragma_t node_1077;
			    node_1077 = (pragma_t) (node_5);
			    node_remove___45_ast_remove((((pragma_t) CREF(node_1077))->args));
			    aux_1705 = (obj_t) (node_1077);
			 }
			 break;
		      case ((long) 8):
			 {
			    cast_t node_1079;
			    node_1079 = (cast_t) (node_5);
			    node_remove__162_ast_remove((((cast_t) CREF(node_1079))->arg));
			    aux_1705 = (obj_t) (node_1079);
			 }
			 break;
		      case ((long) 9):
			 {
			    setq_t node_1081;
			    node_1081 = (setq_t) (node_5);
			    {
			       node_t arg1555_1082;
			       arg1555_1082 = node_remove__162_ast_remove((((setq_t) CREF(node_1081))->value));
			       {
				  obj_t res1668_1311;
				  {
				     obj_t x_1466;
				     x_1466 = ((((setq_t) CREF(node_1081))->value) = ((node_t) arg1555_1082), BUNSPEC);
				     res1668_1311 = BUNSPEC;
				  }
				  res1668_1311;
			       }
			    }
			    aux_1705 = (obj_t) (node_1081);
			 }
			 break;
		      case ((long) 10):
			 {
			    conditional_t node_1084;
			    node_1084 = (conditional_t) (node_5);
			    {
			       node_t arg1559_1085;
			       arg1559_1085 = node_remove__162_ast_remove((((conditional_t) CREF(node_1084))->test));
			       {
				  obj_t res1669_1315;
				  {
				     obj_t x_1467;
				     x_1467 = ((((conditional_t) CREF(node_1084))->test) = ((node_t) arg1559_1085), BUNSPEC);
				     res1669_1315 = BUNSPEC;
				  }
				  res1669_1315;
			       }
			    }
			    {
			       node_t arg1561_1087;
			       arg1561_1087 = node_remove__162_ast_remove((((conditional_t) CREF(node_1084))->true));
			       {
				  obj_t res1670_1319;
				  {
				     obj_t x_1468;
				     x_1468 = ((((conditional_t) CREF(node_1084))->true) = ((node_t) arg1561_1087), BUNSPEC);
				     res1670_1319 = BUNSPEC;
				  }
				  res1670_1319;
			       }
			    }
			    {
			       node_t arg1563_1089;
			       arg1563_1089 = node_remove__162_ast_remove((((conditional_t) CREF(node_1084))->false));
			       {
				  obj_t res1671_1323;
				  {
				     obj_t x_1469;
				     x_1469 = ((((conditional_t) CREF(node_1084))->false) = ((node_t) arg1563_1089), BUNSPEC);
				     res1671_1323 = BUNSPEC;
				  }
				  res1671_1323;
			       }
			    }
			    aux_1705 = (obj_t) (node_1084);
			 }
			 break;
		      case ((long) 11):
			 {
			    fail_t node_1091;
			    node_1091 = (fail_t) (node_5);
			    {
			       node_t arg1565_1092;
			       arg1565_1092 = node_remove__162_ast_remove((((fail_t) CREF(node_1091))->proc));
			       {
				  obj_t res1672_1327;
				  {
				     obj_t x_1470;
				     x_1470 = ((((fail_t) CREF(node_1091))->proc) = ((node_t) arg1565_1092), BUNSPEC);
				     res1672_1327 = BUNSPEC;
				  }
				  res1672_1327;
			       }
			    }
			    {
			       node_t arg1567_1094;
			       arg1567_1094 = node_remove__162_ast_remove((((fail_t) CREF(node_1091))->msg));
			       {
				  obj_t res1673_1331;
				  {
				     obj_t x_1471;
				     x_1471 = ((((fail_t) CREF(node_1091))->msg) = ((node_t) arg1567_1094), BUNSPEC);
				     res1673_1331 = BUNSPEC;
				  }
				  res1673_1331;
			       }
			    }
			    {
			       node_t arg1570_1096;
			       arg1570_1096 = node_remove__162_ast_remove((((fail_t) CREF(node_1091))->obj));
			       {
				  obj_t res1674_1335;
				  {
				     obj_t x_1472;
				     x_1472 = ((((fail_t) CREF(node_1091))->obj) = ((node_t) arg1570_1096), BUNSPEC);
				     res1674_1335 = BUNSPEC;
				  }
				  res1674_1335;
			       }
			    }
			    aux_1705 = (obj_t) (node_1091);
			 }
			 break;
		      case ((long) 12):
			 {
			    select_t node_1098;
			    node_1098 = (select_t) (node_5);
			    {
			       node_t arg1572_1099;
			       arg1572_1099 = node_remove__162_ast_remove((((select_t) CREF(node_1098))->test));
			       {
				  obj_t res1675_1339;
				  {
				     obj_t x_1473;
				     x_1473 = ((((select_t) CREF(node_1098))->test) = ((node_t) arg1572_1099), BUNSPEC);
				     res1675_1339 = BUNSPEC;
				  }
				  res1675_1339;
			       }
			    }
			    {
			       obj_t l1272_1101;
			       l1272_1101 = (((select_t) CREF(node_1098))->clauses);
			     lname1283_1102:
			       if (PAIRP(l1272_1101))
				 {
				    {
				       obj_t clause_1105;
				       clause_1105 = CAR(l1272_1101);
				       {
					  node_t arg1576_1106;
					  {
					     node_t aux_1789;
					     {
						obj_t aux_1790;
						aux_1790 = CDR(clause_1105);
						aux_1789 = (node_t) (aux_1790);
					     }
					     arg1576_1106 = node_remove__162_ast_remove(aux_1789);
					  }
					  {
					     obj_t aux_1794;
					     aux_1794 = (obj_t) (arg1576_1106);
					     SET_CDR(clause_1105, aux_1794);
					  }
				       }
				    }
				    {
				       obj_t l1272_1797;
				       l1272_1797 = CDR(l1272_1101);
				       l1272_1101 = l1272_1797;
				       goto lname1283_1102;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_1705 = (obj_t) (node_1098);
			 }
			 break;
		      case ((long) 13):
			 {
			    make_box_202_t node_1109;
			    node_1109 = (make_box_202_t) (node_5);
			    {
			       node_t arg1579_1110;
			       arg1579_1110 = node_remove__162_ast_remove((((make_box_202_t) CREF(node_1109))->value));
			       {
				  obj_t res1676_1350;
				  {
				     obj_t x_1474;
				     x_1474 = ((((make_box_202_t) CREF(node_1109))->value) = ((node_t) arg1579_1110), BUNSPEC);
				     res1676_1350 = BUNSPEC;
				  }
				  res1676_1350;
			       }
			    }
			    aux_1705 = (obj_t) (node_1109);
			 }
			 break;
		      case ((long) 14):
			 {
			    box_ref_242_t node_1112;
			    node_1112 = (box_ref_242_t) (node_5);
			    {
			       node_t arg1583_1113;
			       {
				  node_t aux_1807;
				  {
				     var_t aux_1808;
				     aux_1808 = (((box_ref_242_t) CREF(node_1112))->var);
				     aux_1807 = (node_t) (aux_1808);
				  }
				  arg1583_1113 = node_remove__162_ast_remove(aux_1807);
			       }
			       {
				  obj_t res1677_1354;
				  {
				     var_t val1263_1353;
				     val1263_1353 = (var_t) (arg1583_1113);
				     {
					obj_t x_1475;
					x_1475 = ((((box_ref_242_t) CREF(node_1112))->var) = ((var_t) val1263_1353), BUNSPEC);
					res1677_1354 = BUNSPEC;
				     }
				  }
				  res1677_1354;
			       }
			    }
			    aux_1705 = (obj_t) (node_1112);
			 }
			 break;
		      case ((long) 15):
			 {
			    box_set__221_t node_1115;
			    node_1115 = (box_set__221_t) (node_5);
			    {
			       node_t arg1585_1116;
			       {
				  node_t aux_1816;
				  {
				     var_t aux_1817;
				     aux_1817 = (((box_set__221_t) CREF(node_1115))->var);
				     aux_1816 = (node_t) (aux_1817);
				  }
				  arg1585_1116 = node_remove__162_ast_remove(aux_1816);
			       }
			       {
				  obj_t res1678_1358;
				  {
				     var_t val1269_1357;
				     val1269_1357 = (var_t) (arg1585_1116);
				     {
					obj_t x_1476;
					x_1476 = ((((box_set__221_t) CREF(node_1115))->var) = ((var_t) val1269_1357), BUNSPEC);
					res1678_1358 = BUNSPEC;
				     }
				  }
				  res1678_1358;
			       }
			    }
			    {
			       node_t arg1588_1118;
			       arg1588_1118 = node_remove__162_ast_remove((((box_set__221_t) CREF(node_1115))->value));
			       {
				  obj_t res1679_1362;
				  {
				     obj_t x_1477;
				     x_1477 = ((((box_set__221_t) CREF(node_1115))->value) = ((node_t) arg1588_1118), BUNSPEC);
				     res1679_1362 = BUNSPEC;
				  }
				  res1679_1362;
			       }
			    }
			    aux_1705 = (obj_t) (node_1115);
			 }
			 break;
		      case ((long) 16):
			 {
			    let_fun_218_t node_1120;
			    node_1120 = (let_fun_218_t) (node_5);
			    {
			       node_t arg1590_1122;
			       arg1590_1122 = node_remove__162_ast_remove((((let_fun_218_t) CREF(node_1120))->body));
			       {
				  obj_t res1680_1366;
				  {
				     obj_t x_1478;
				     x_1478 = ((((let_fun_218_t) CREF(node_1120))->body) = ((node_t) arg1590_1122), BUNSPEC);
				     res1680_1366 = BUNSPEC;
				  }
				  res1680_1366;
			       }
			    }
			    {
			       obj_t old_locals_255_1124;
			       obj_t new_locals_179_1125;
			       old_locals_255_1124 = (((let_fun_218_t) CREF(node_1120))->locals);
			       new_locals_179_1125 = BNIL;
			     loop_1126:
			       if (NULLP(old_locals_255_1124))
				 {
				    if (NULLP(new_locals_179_1125))
				      {
					 node_t aux_1835;
					 aux_1835 = (((let_fun_218_t) CREF(node_1120))->body);
					 aux_1705 = (obj_t) (aux_1835);
				      }
				    else
				      {
					 {
					    obj_t arg1596_1131;
					    arg1596_1131 = reverse__39___r4_pairs_and_lists_6_3(new_locals_179_1125);
					    {
					       obj_t res1681_1373;
					       {
						  obj_t x_1479;
						  x_1479 = ((((let_fun_218_t) CREF(node_1120))->locals) = ((obj_t) arg1596_1131), BUNSPEC);
						  res1681_1373 = BUNSPEC;
					       }
					       res1681_1373;
					    }
					 }
					 aux_1705 = (obj_t) (node_1120);
				      }
				 }
			       else
				 {
				    obj_t local_1132;
				    local_1132 = CAR(old_locals_255_1124);
				    {
				       bool_t test_1842;
				       {
					  long aux_1843;
					  {
					     local_t obj_1375;
					     obj_1375 = (local_t) (local_1132);
					     aux_1843 = (((local_t) CREF(obj_1375))->occurrence);
					  }
					  test_1842 = (aux_1843 <= ((long) 0));
				       }
				       if (test_1842)
					 {
					    obj_t old_locals_255_1847;
					    old_locals_255_1847 = CDR(old_locals_255_1124);
					    old_locals_255_1124 = old_locals_255_1847;
					    goto loop_1126;
					 }
				       else
					 {
					    value_t sfun_1135;
					    {
					       local_t obj_1379;
					       obj_1379 = (local_t) (local_1132);
					       sfun_1135 = (((local_t) CREF(obj_1379))->value);
					    }
					    {
					       node_t arg1601_1136;
					       {
						  node_t aux_1851;
						  {
						     obj_t aux_1852;
						     {
							sfun_t obj_1380;
							obj_1380 = (sfun_t) (sfun_1135);
							aux_1852 = (((sfun_t) CREF(obj_1380))->body);
						     }
						     aux_1851 = (node_t) (aux_1852);
						  }
						  arg1601_1136 = node_remove__162_ast_remove(aux_1851);
					       }
					       {
						  obj_t res1682_1383;
						  {
						     sfun_t obj_1381;
						     obj_t val1077_1382;
						     obj_1381 = (sfun_t) (sfun_1135);
						     val1077_1382 = (obj_t) (arg1601_1136);
						     {
							obj_t x_1480;
							x_1480 = ((((sfun_t) CREF(obj_1381))->body) = ((obj_t) val1077_1382), BUNSPEC);
							res1682_1383 = BUNSPEC;
						     }
						  }
						  res1682_1383;
					       }
					    }
					    {
					       obj_t arg1604_1138;
					       obj_t arg1605_1139;
					       arg1604_1138 = CDR(old_locals_255_1124);
					       arg1605_1139 = MAKE_PAIR(local_1132, new_locals_179_1125);
					       {
						  obj_t new_locals_179_1863;
						  obj_t old_locals_255_1862;
						  old_locals_255_1862 = arg1604_1138;
						  new_locals_179_1863 = arg1605_1139;
						  new_locals_179_1125 = new_locals_179_1863;
						  old_locals_255_1124 = old_locals_255_1862;
						  goto loop_1126;
					       }
					    }
					 }
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 17):
			 {
			    let_var_6_t node_1142;
			    node_1142 = (let_var_6_t) (node_5);
			    {
			       node_t arg1609_1144;
			       arg1609_1144 = node_remove__162_ast_remove((((let_var_6_t) CREF(node_1142))->body));
			       {
				  obj_t res1683_1390;
				  {
				     obj_t x_1481;
				     x_1481 = ((((let_var_6_t) CREF(node_1142))->body) = ((node_t) arg1609_1144), BUNSPEC);
				     res1683_1390 = BUNSPEC;
				  }
				  res1683_1390;
			       }
			    }
			    {
			       obj_t old_bindings_65_1146;
			       obj_t new_bindings_102_1147;
			       old_bindings_65_1146 = (((let_var_6_t) CREF(node_1142))->bindings);
			       new_bindings_102_1147 = BNIL;
			     loop_1148:
			       if (NULLP(old_bindings_65_1146))
				 {
				    if (NULLP(new_bindings_102_1147))
				      {
					 if ((((let_var_6_t) CREF(node_1142))->removable__42))
					   {
					      node_t aux_1875;
					      aux_1875 = (((let_var_6_t) CREF(node_1142))->body);
					      aux_1705 = (obj_t) (aux_1875);
					   }
					 else
					   {
					      {
						 obj_t res1684_1398;
						 {
						    obj_t x_1482;
						    x_1482 = ((((let_var_6_t) CREF(node_1142))->bindings) = ((obj_t) BNIL), BUNSPEC);
						    res1684_1398 = BUNSPEC;
						 }
						 res1684_1398;
					      }
					      aux_1705 = (obj_t) (node_1142);
					   }
				      }
				    else
				      {
					 {
					    obj_t arg1621_1155;
					    arg1621_1155 = reverse__39___r4_pairs_and_lists_6_3(new_bindings_102_1147);
					    {
					       obj_t res1685_1401;
					       {
						  obj_t x_1483;
						  x_1483 = ((((let_var_6_t) CREF(node_1142))->bindings) = ((obj_t) arg1621_1155), BUNSPEC);
						  res1685_1401 = BUNSPEC;
					       }
					       res1685_1401;
					    }
					 }
					 aux_1705 = (obj_t) (node_1142);
				      }
				 }
			       else
				 {
				    obj_t binding_1156;
				    binding_1156 = CAR(old_bindings_65_1146);
				    {
				       obj_t var_1157;
				       var_1157 = CAR(binding_1156);
				       {
					  node_t val_1158;
					  {
					     node_t aux_1885;
					     {
						obj_t aux_1886;
						aux_1886 = CDR(binding_1156);
						aux_1885 = (node_t) (aux_1886);
					     }
					     val_1158 = node_remove__162_ast_remove(aux_1885);
					  }
					  {
					     {
						bool_t test1622_1159;
						{
						   bool_t test_1890;
						   {
						      long aux_1891;
						      {
							 local_t obj_1405;
							 obj_1405 = (local_t) (var_1157);
							 aux_1891 = (((local_t) CREF(obj_1405))->occurrence);
						      }
						      test_1890 = (aux_1891 <= ((long) 0));
						   }
						   if (test_1890)
						     {
							bool_t test1634_1169;
							test1634_1169 = side_effect__165_effect_effect(val_1158);
							if (test1634_1169)
							  {
							     test1622_1159 = ((bool_t) 0);
							  }
							else
							  {
							     test1622_1159 = ((bool_t) 1);
							  }
						     }
						   else
						     {
							test1622_1159 = ((bool_t) 0);
						     }
						}
						if (test1622_1159)
						  {
						     {
							bool_t test1623_1160;
							test1623_1160 = is_a__118___object((obj_t) (val_1158), var_ast_node);
							if (test1623_1160)
							  {
							     variable_t v_1161;
							     {
								var_t obj_1409;
								obj_1409 = (var_t) (val_1158);
								v_1161 = (((var_t) CREF(obj_1409))->variable);
							     }
							     {
								long arg1624_1162;
								{
								   long aux_1903;
								   aux_1903 = (((variable_t) CREF(v_1161))->occurrence);
								   arg1624_1162 = (aux_1903 - ((long) 1));
								}
								{
								   obj_t res1686_1415;
								   {
								      obj_t x_1484;
								      x_1484 = ((((variable_t) CREF(v_1161))->occurrence) = ((long) arg1624_1162), BUNSPEC);
								      res1686_1415 = BUNSPEC;
								   }
								   res1686_1415;
								}
							     }
							  }
							else
							  {
							     BUNSPEC;
							  }
						     }
						     {
							obj_t old_bindings_65_1907;
							old_bindings_65_1907 = CDR(old_bindings_65_1146);
							old_bindings_65_1146 = old_bindings_65_1907;
							goto loop_1148;
						     }
						  }
						else
						  {
						     {
							obj_t aux_1909;
							aux_1909 = (obj_t) (val_1158);
							SET_CDR(binding_1156, aux_1909);
						     }
						     {
							obj_t arg1630_1166;
							obj_t arg1632_1167;
							arg1630_1166 = CDR(old_bindings_65_1146);
							arg1632_1167 = MAKE_PAIR(binding_1156, new_bindings_102_1147);
							{
							   obj_t new_bindings_102_1915;
							   obj_t old_bindings_65_1914;
							   old_bindings_65_1914 = arg1630_1166;
							   new_bindings_102_1915 = arg1632_1167;
							   new_bindings_102_1147 = new_bindings_102_1915;
							   old_bindings_65_1146 = old_bindings_65_1914;
							   goto loop_1148;
							}
						     }
						  }
					     }
					  }
				       }
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 18):
			 {
			    set_ex_it_116_t node_1173;
			    node_1173 = (set_ex_it_116_t) (node_5);
			    {
			       node_t arg1642_1174;
			       arg1642_1174 = node_remove__162_ast_remove((((set_ex_it_116_t) CREF(node_1173))->body));
			       {
				  obj_t res1687_1425;
				  {
				     obj_t x_1485;
				     x_1485 = ((((set_ex_it_116_t) CREF(node_1173))->body) = ((node_t) arg1642_1174), BUNSPEC);
				     res1687_1425 = BUNSPEC;
				  }
				  res1687_1425;
			       }
			    }
			    {
			       bool_t test_1921;
			       {
				  long aux_1922;
				  {
				     local_t obj_1428;
				     {
					variable_t aux_1923;
					{
					   var_t arg1648_1180;
					   arg1648_1180 = (((set_ex_it_116_t) CREF(node_1173))->var);
					   aux_1923 = (((var_t) CREF(arg1648_1180))->variable);
					}
					obj_1428 = (local_t) (aux_1923);
				     }
				     aux_1922 = (((local_t) CREF(obj_1428))->occurrence);
				  }
				  test_1921 = (aux_1922 <= ((long) 0));
			       }
			       if (test_1921)
				 {
				    node_t aux_1929;
				    aux_1929 = (((set_ex_it_116_t) CREF(node_1173))->body);
				    aux_1705 = (obj_t) (aux_1929);
				 }
			       else
				 {
				    aux_1705 = (obj_t) (node_1173);
				 }
			    }
			 }
			 break;
		      case ((long) 19):
			 {
			    jump_ex_it_184_t node_1181;
			    node_1181 = (jump_ex_it_184_t) (node_5);
			    {
			       node_t arg1650_1182;
			       arg1650_1182 = node_remove__162_ast_remove((((jump_ex_it_184_t) CREF(node_1181))->exit));
			       {
				  obj_t res1688_1435;
				  {
				     obj_t x_1486;
				     x_1486 = ((((jump_ex_it_184_t) CREF(node_1181))->exit) = ((node_t) arg1650_1182), BUNSPEC);
				     res1688_1435 = BUNSPEC;
				  }
				  res1688_1435;
			       }
			    }
			    {
			       node_t arg1652_1184;
			       arg1652_1184 = node_remove__162_ast_remove((((jump_ex_it_184_t) CREF(node_1181))->value));
			       {
				  obj_t res1689_1439;
				  {
				     obj_t x_1487;
				     x_1487 = ((((jump_ex_it_184_t) CREF(node_1181))->value) = ((node_t) arg1652_1184), BUNSPEC);
				     res1689_1439 = BUNSPEC;
				  }
				  res1689_1439;
			       }
			    }
			    aux_1705 = (obj_t) (node_1181);
			 }
			 break;
		      default:
		       case_else1531_132_1056:
			 if (PROCEDUREP(method1525_1052))
			   {
			      aux_1705 = PROCEDURE_ENTRY(method1525_1052) (method1525_1052, (obj_t) (node_5), BEOA);
			   }
			 else
			   {
			      obj_t fun1407_734;
			      fun1407_734 = PROCEDURE_REF(node_remove__env_197_ast_remove, ((long) 0));
			      aux_1705 = PROCEDURE_ENTRY(fun1407_734) (fun1407_734, (obj_t) (node_5), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1531_132_1056;
		 }
	    }
	    return (node_t) (aux_1705);
	 }
      }
   }
}


obj_t 
_node_remove__224_ast_remove(obj_t env_1447, obj_t node_1448)
{
   {
      node_t aux_1953;
      aux_1953 = node_remove__162_ast_remove((node_t) (node_1448));
      return (obj_t) (aux_1953);
   }
}


obj_t 
node_remove___45_ast_remove(obj_t node__221_27)
{
 node_remove___45_ast_remove:
   if (NULLP(node__221_27))
     {
	return CNST_TABLE_REF(((long) 5));
     }
   else
     {
	{
	   node_t arg1410_736;
	   {
	      node_t aux_1960;
	      {
		 obj_t aux_1961;
		 aux_1961 = CAR(node__221_27);
		 aux_1960 = (node_t) (aux_1961);
	      }
	      arg1410_736 = node_remove__162_ast_remove(aux_1960);
	   }
	   {
	      obj_t aux_1965;
	      aux_1965 = (obj_t) (arg1410_736);
	      SET_CAR(node__221_27, aux_1965);
	   }
	}
	{
	   obj_t node__221_1968;
	   node__221_1968 = CDR(node__221_27);
	   node__221_27 = node__221_1968;
	   goto node_remove___45_ast_remove;
	}
     }
}


obj_t 
imported_modules_init_94_ast_remove()
{
   module_initialization_70_type_type(((long) 0), "AST_REMOVE");
   module_initialization_70_ast_var(((long) 0), "AST_REMOVE");
   module_initialization_70_ast_node(((long) 0), "AST_REMOVE");
   module_initialization_70_tools_error(((long) 0), "AST_REMOVE");
   module_initialization_70_tools_speek(((long) 0), "AST_REMOVE");
   module_initialization_70_tools_shape(((long) 0), "AST_REMOVE");
   module_initialization_70_effect_effect(((long) 0), "AST_REMOVE");
   return module_initialization_70_ast_occur(((long) 0), "AST_REMOVE");
}
