/*===========================================================================*/
/*   (Ast/sexp.scm)                                                          */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t dsssl_named_constant__188_tools_dsssl(obj_t);
static obj_t liip_ast_sexp(obj_t);
extern let_fun_218_t set_exit__node_102_ast_exit(obj_t, obj_t, obj_t, obj_t);
extern obj_t sequence_ast_node;
extern obj_t global_ast_var;
extern obj_t fun_ast_var;
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t replace__160_tools_misc(obj_t, obj_t);
extern obj_t normalize_progn_143_tools_progn(obj_t);
extern obj_t __magic__144_type_cache;
static obj_t imported_modules_init_94_ast_sexp();
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_tools_dsssl(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_typeof(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_build(long, char *);
extern obj_t module_initialization_70_ast_pragma(long, char *);
extern obj_t module_initialization_70_ast_labels(long, char *);
extern obj_t module_initialization_70_ast_let(long, char *);
extern obj_t module_initialization_70_ast_exit(long, char *);
extern obj_t module_initialization_70_ast_app(long, char *);
extern obj_t module_initialization_70_ast_apply(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___dsssl(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern node_t let__node_121_ast_let(obj_t, obj_t, obj_t, obj_t);
static obj_t toplevel_init_63_ast_sexp();
extern obj_t make_dsssl_function_prelude_58___dsssl(obj_t, obj_t, obj_t, obj_t);
static obj_t cnst_init_137_ast_sexp();
static obj_t __cache_stack__44_ast_sexp = BUNSPEC;
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t __cache_res__50_ast_sexp = BUNSPEC;
extern obj_t _use_variable__22_ast_sexp(obj_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_ast_sexp = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
extern obj_t __bnil__15_type_cache;
extern node_t define_primop__node_141_ast_sexp(global_t);
static obj_t library_modules_init_112_ast_sexp();
extern obj_t _error_sexp__node_111_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t _top_level_sexp__node_248_ast_sexp(obj_t, obj_t, obj_t);
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern node_t application__node_43_ast_app(obj_t, obj_t, obj_t, obj_t);
extern obj_t _define_primop_ref__node_178_ast_sexp(obj_t, obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t);
extern obj_t select_ast_node;
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t __unspec__87_type_cache;
static obj_t sexp___node_160_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern jump_ex_it_184_t jump_exit__node_34_ast_exit(obj_t, obj_t, obj_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t dsssl_find_first_formal_237_tools_dsssl(obj_t);
extern node_t pragma_type__node_160_ast_pragma(bool_t, type_t, obj_t, obj_t, obj_t, obj_t);
static obj_t lookup_ast_sexp(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern node_t error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
static obj_t loop_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t _define_primop__node_41_ast_sexp(obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t fail_ast_node;
extern obj_t _4dots_tools_misc;
static obj_t arg17382065_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t local_ast_var;
extern obj_t kwote_ast_node;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _location__node_156_ast_sexp(obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _____74_type_cache;
extern obj_t node_ast_node;
extern obj_t _sexp__node_67_ast_sexp(obj_t, obj_t, obj_t, obj_t, obj_t);
extern node_t applycation__node_122_ast_apply(obj_t, obj_t, obj_t, obj_t);
extern obj_t use_variable__4_ast_sexp(variable_t, obj_t, obj_t);
extern node_t define_primop_ref__node_164_ast_sexp(global_t, node_t);
extern node_t location__node_25_ast_sexp(global_t);
extern obj_t atom_ast_node;
extern obj_t current_function_76_tools_error();
extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern let_fun_218_t labels__node_197_ast_labels(obj_t, obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t __sites__81_ast_sexp = BUNSPEC;
extern type_t typeof_atom_134_type_typeof(obj_t);
extern node_t top_level_sexp__node_204_ast_sexp(obj_t, obj_t);
static obj_t __cache_name__178_ast_sexp = BUNSPEC;
static obj_t __cnst[32];

DEFINE_STRING(string2082_ast_sexp, string2082_ast_sexp2090, "Illegal empty sequence", 22);
DEFINE_STRING(string2083_ast_sexp, string2083_ast_sexp2091, "Illegal mutation", 16);
DEFINE_EXPORT_PROCEDURE(top_level_sexp__node_env_236_ast_sexp, _top_level_sexp__node_248_ast_sexp2092, _top_level_sexp__node_248_ast_sexp, 0L, 2);
DEFINE_STRING(string2071_ast_sexp, string2071_ast_sexp2093, "illegal `define' expression", 27);
DEFINE_STRING(string2077_ast_sexp, string2077_ast_sexp2094, "Unbound variable", 16);
DEFINE_STRING(string2075_ast_sexp, string2075_ast_sexp2095, "Illegal `quote' expression", 26);
DEFINE_STRING(string2081_ast_sexp, string2081_ast_sexp2096, "Illegal formal argument", 23);
DEFINE_STRING(string2080_ast_sexp, string2080_ast_sexp2097, "wrong number of argument", 24);
DEFINE_STRING(string2078_ast_sexp, string2078_ast_sexp2098, "Illegal atom", 12);
DEFINE_STRING(string2079_ast_sexp, string2079_ast_sexp2099, "Illegal `()' expression", 23);
DEFINE_EXPORT_PROCEDURE(use_variable__env_235_ast_sexp, _use_variable__22_ast_sexp2100, _use_variable__22_ast_sexp, 0L, 3);
DEFINE_EXPORT_PROCEDURE(sexp__node_env_201_ast_sexp, _sexp__node_67_ast_sexp2101, _sexp__node_67_ast_sexp, 0L, 4);
DEFINE_EXPORT_PROCEDURE(location__node_env_47_ast_sexp, _location__node_156_ast_sexp2102, _location__node_156_ast_sexp, 0L, 1);
DEFINE_STRING(string2084_ast_sexp, string2084_ast_sexp2103, "(@ __EVMEANING_ADDRESS FOREIGN) DEFINE-PRIMOP! DEFINE-PRIMOP-REF! WRITE CONS (QUOTE ()) APPLY JUMP-EXIT SET-EXIT CASE FAILURE LETREC DEFINE BEGIN QUOTE @ APP EVAL NOT IF ::BOOL TEST SET! LET ELSE LABELS LAMBDA FREE-PRAGMA PRAGMA AST VALUE (VALUE APPLY APP SET!) ", 262);
DEFINE_STRING(string2069_ast_sexp, string2069_ast_sexp2104, "Illegal `failure' form", 22);
DEFINE_EXPORT_PROCEDURE(define_primop__node_env_232_ast_sexp, _define_primop__node_41_ast_sexp2105, _define_primop__node_41_ast_sexp, 0L, 1);
DEFINE_EXPORT_PROCEDURE(error_sexp__node_env_24_ast_sexp, _error_sexp__node_111_ast_sexp2106, _error_sexp__node_111_ast_sexp, 0L, 3);
DEFINE_STRING(string2068_ast_sexp, string2068_ast_sexp2107, "Illegal `case' form", 19);
DEFINE_STRING(string2073_ast_sexp, string2073_ast_sexp2108, "illegal `set!' expression", 25);
DEFINE_STRING(string2066_ast_sexp, string2066_ast_sexp2109, "sexp->node: ", 12);
DEFINE_STRING(string2076_ast_sexp, string2076_ast_sexp2110, "Illegal `@' expression", 22);
DEFINE_EXPORT_PROCEDURE(define_primop_ref__node_env_208_ast_sexp, _define_primop_ref__node_178_ast_sexp2111, _define_primop_ref__node_178_ast_sexp, 0L, 2);
DEFINE_STRING(string2074_ast_sexp, string2074_ast_sexp2112, "Illegal `if' form", 17);
DEFINE_STRING(string2070_ast_sexp, string2070_ast_sexp2113, "Illegal `define' form", 21);
DEFINE_STRING(string2072_ast_sexp, string2072_ast_sexp2114, "Illegal `set!' form", 19);
DEFINE_STRING(string2067_ast_sexp, string2067_ast_sexp2115, "Illegal `lambda' form", 21);

obj_t 
module_initialization_70_ast_sexp(long checksum_2503, char *from_2504)
{
   if (CBOOL(require_initialization_114_ast_sexp))
     {
	require_initialization_114_ast_sexp = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_sexp();
	cnst_init_137_ast_sexp();
	imported_modules_init_94_ast_sexp();
	toplevel_init_63_ast_sexp();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_sexp()
{
   module_initialization_70___object(((long) 0), "AST_SEXP");
   module_initialization_70___dsssl(((long) 0), "AST_SEXP");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_SEXP");
   module_initialization_70___reader(((long) 0), "AST_SEXP");
   module_initialization_70___r4_symbols_6_4(((long) 0), "AST_SEXP");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_sexp()
{
   {
      obj_t cnst_port_138_2495;
      cnst_port_138_2495 = open_input_string(string2084_ast_sexp);
      {
	 long i_2496;
	 i_2496 = ((long) 31);
       loop_2497:
	 {
	    bool_t test2085_2498;
	    test2085_2498 = (i_2496 == ((long) -1));
	    if (test2085_2498)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2086_2499;
		    {
		       obj_t list2087_2500;
		       {
			  obj_t arg2088_2501;
			  arg2088_2501 = BNIL;
			  list2087_2500 = MAKE_PAIR(cnst_port_138_2495, arg2088_2501);
		       }
		       arg2086_2499 = read___reader(list2087_2500);
		    }
		    CNST_TABLE_SET(i_2496, arg2086_2499);
		 }
		 {
		    int aux_2502;
		    {
		       long aux_2523;
		       aux_2523 = (i_2496 - ((long) 1));
		       aux_2502 = (int) (aux_2523);
		    }
		    {
		       long i_2526;
		       i_2526 = (long) (aux_2502);
		       i_2496 = i_2526;
		       goto loop_2497;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_sexp()
{
   __sites__81_ast_sexp = CNST_TABLE_REF(((long) 0));
   __cache_name__178_ast_sexp = BFALSE;
   __cache_stack__44_ast_sexp = BFALSE;
   return (__cache_res__50_ast_sexp = BFALSE,
      BUNSPEC);
}


node_t 
top_level_sexp__node_204_ast_sexp(obj_t exp_1, obj_t loc_2)
{
   return sexp__node_235_ast_sexp(exp_1, BNIL, loc_2, CNST_TABLE_REF(((long) 1)));
}


obj_t 
_top_level_sexp__node_248_ast_sexp(obj_t env_2462, obj_t exp_2463, obj_t loc_2464)
{
   {
      node_t aux_2531;
      aux_2531 = top_level_sexp__node_204_ast_sexp(exp_2463, loc_2464);
      return (obj_t) (aux_2531);
   }
}


node_t 
sexp__node_235_ast_sexp(obj_t exp_3, obj_t stack_4, obj_t loc_5, obj_t site_6)
{
 sexp__node_235_ast_sexp:
   {
      bool_t test1274_654;
      {
	 obj_t aux_2534;
	 aux_2534 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 2)), BINT(((long) 2)));
	 test1274_654 = CBOOL(aux_2534);
      }
      if (test1274_654)
	{
	   obj_t list1275_655;
	   {
	      obj_t arg1278_657;
	      {
		 obj_t arg1279_658;
		 {
		    obj_t aux_2540;
		    aux_2540 = BCHAR(((unsigned char) '\n'));
		    arg1279_658 = MAKE_PAIR(aux_2540, BNIL);
		 }
		 arg1278_657 = MAKE_PAIR(exp_3, arg1279_658);
	      }
	      list1275_655 = MAKE_PAIR(string2066_ast_sexp, arg1278_657);
	   }
	   print_trace_107_tools_trace(list1275_655);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t atom_664;
      obj_t body_668;
      obj_t body_673;
      obj_t args_674;
      obj_t vars_678;
      obj_t body_679;
      obj_t args_680;
      if ((exp_3 == BNIL))
	{
	   return error_sexp__node_157_ast_sexp(string2079_ast_sexp, exp_3, loc_5);
	}
      else
	{
	   bool_t test1285_693;
	   test1285_693 = is_a__118___object(exp_3, node_ast_node);
	   if (test1285_693)
	     {
		return (node_t) (exp_3);
	     }
	   else
	     {
		if (PAIRP(exp_3))
		  {
		     bool_t test_2554;
		     {
			obj_t aux_2557;
			obj_t aux_2555;
			aux_2557 = CNST_TABLE_REF(((long) 16));
			aux_2555 = CAR(exp_3);
			test_2554 = (aux_2555 == aux_2557);
		     }
		     if (test_2554)
		       {
			  obj_t aux_2560;
			  {
			     obj_t loc_837;
			     loc_837 = find_location_loc_243_tools_location(exp_3, loc_5);
			     {
				obj_t name_838;
				obj_t module_839;
				if (PAIRP(exp_3))
				  {
				     obj_t cdr_352_26_844;
				     cdr_352_26_844 = CDR(exp_3);
				     {
					bool_t test_2565;
					{
					   obj_t aux_2568;
					   obj_t aux_2566;
					   aux_2568 = CNST_TABLE_REF(((long) 16));
					   aux_2566 = CAR(exp_3);
					   test_2565 = (aux_2566 == aux_2568);
					}
					if (test_2565)
					  {
					     if (PAIRP(cdr_352_26_844))
					       {
						  obj_t car_355_218_847;
						  obj_t cdr_356_4_848;
						  car_355_218_847 = CAR(cdr_352_26_844);
						  cdr_356_4_848 = CDR(cdr_352_26_844);
						  if (SYMBOLP(car_355_218_847))
						    {
						       if (PAIRP(cdr_356_4_848))
							 {
							    obj_t car_361_52_851;
							    car_361_52_851 = CAR(cdr_356_4_848);
							    if (SYMBOLP(car_361_52_851))
							      {
								 bool_t test_2582;
								 {
								    obj_t aux_2583;
								    aux_2583 = CDR(cdr_356_4_848);
								    test_2582 = (aux_2583 == BNIL);
								 }
								 if (test_2582)
								   {
								      name_838 = car_355_218_847;
								      module_839 = car_361_52_851;
								      {
									 obj_t global_858;
									 {
									    obj_t list1500_875;
									    list1500_875 = MAKE_PAIR(module_839, BNIL);
									    global_858 = find_global_223_ast_env(name_838, list1500_875);
									 }
									 {
									    bool_t test1481_859;
									    test1481_859 = is_a__118___object(global_858, global_ast_var);
									    if (test1481_859)
									      {
										 bool_t test_2590;
										 {
										    obj_t aux_2594;
										    obj_t aux_2591;
										    aux_2594 = CNST_TABLE_REF(((long) 14));
										    {
										       global_t obj_1939;
										       obj_1939 = (global_t) (global_858);
										       aux_2591 = (((global_t) CREF(obj_1939))->import);
										    }
										    test_2590 = (aux_2591 == aux_2594);
										 }
										 if (test_2590)
										   {
										      {
											 obj_t arg1484_861;
											 {
											    obj_t arg1485_862;
											    arg1485_862 = CNST_TABLE_REF(((long) 14));
											    {
											       obj_t list1487_864;
											       {
												  obj_t arg1489_865;
												  arg1489_865 = MAKE_PAIR(BNIL, BNIL);
												  list1487_864 = MAKE_PAIR(atom_ast_node, arg1489_865);
											       }
											       arg1484_861 = cons__138___r4_pairs_and_lists_6_3(arg1485_862, list1487_864);
											    }
											 }
											 {
											    node_t aux_2601;
											    aux_2601 = sexp__node_235_ast_sexp(arg1484_861, stack_4, loc_837, site_6);
											    aux_2560 = (obj_t) (aux_2601);
											 }
										      }
										   }
										 else
										   {
										      use_variable__4_ast_sexp((variable_t) (global_858), loc_837, site_6);
										      {
											 bool_t test1491_867;
											 {
											    bool_t test_2606;
											    {
											       obj_t aux_2607;
											       aux_2607 = CNST_TABLE_REF(((long) 15));
											       test_2606 = (site_6 == aux_2607);
											    }
											    if (test_2606)
											      {
												 test1491_867 = ((bool_t) 0);
											      }
											    else
											      {
												 obj_t aux_2610;
												 {
												    value_t aux_2611;
												    {
												       global_t obj_1944;
												       obj_1944 = (global_t) (global_858);
												       aux_2611 = (((global_t) CREF(obj_1944))->value);
												    }
												    aux_2610 = (obj_t) (aux_2611);
												 }
												 test1491_867 = is_a__118___object(aux_2610, fun_ast_var);
											      }
											 }
											 if (test1491_867)
											   {
											      type_t arg1493_868;
											      {
												 global_t obj_1946;
												 obj_1946 = (global_t) (global_858);
												 arg1493_868 = (((global_t) CREF(obj_1946))->type);
											      }
											      {
												 closure_t res2049_1957;
												 {
												    variable_t variable_1949;
												    variable_1949 = (variable_t) (global_858);
												    {
												       closure_t new1134_1950;
												       new1134_1950 = ((closure_t) BREF(GC_MALLOC(sizeof(struct closure))));
												       {
													  long arg2004_1951;
													  arg2004_1951 = class_num_218___object(closure_ast_node);
													  {
													     obj_t obj_1955;
													     obj_1955 = (obj_t) (new1134_1950);
													     (((obj_t) CREF(obj_1955))->header = MAKE_HEADER(arg2004_1951, 0), BUNSPEC);
													  }
												       }
												       {
													  object_t aux_2624;
													  aux_2624 = (object_t) (new1134_1950);
													  OBJECT_WIDENING_SET(aux_2624, BFALSE);
												       }
												       ((((closure_t) CREF(new1134_1950))->loc) = ((obj_t) loc_837), BUNSPEC);
												       ((((closure_t) CREF(new1134_1950))->type) = ((type_t) arg1493_868), BUNSPEC);
												       ((((closure_t) CREF(new1134_1950))->variable) = ((variable_t) variable_1949), BUNSPEC);
												       res2049_1957 = new1134_1950;
												    }
												 }
												 aux_2560 = (obj_t) (res2049_1957);
											      }
											   }
											 else
											   {
											      type_t arg1494_869;
											      {
												 global_t obj_1958;
												 obj_1958 = (global_t) (global_858);
												 arg1494_869 = (((global_t) CREF(obj_1958))->type);
											      }
											      {
												 var_t res2050_1969;
												 {
												    variable_t variable_1961;
												    variable_1961 = (variable_t) (global_858);
												    {
												       var_t new1128_1962;
												       new1128_1962 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
												       {
													  long arg2006_1963;
													  arg2006_1963 = class_num_218___object(var_ast_node);
													  {
													     obj_t obj_1967;
													     obj_1967 = (obj_t) (new1128_1962);
													     (((obj_t) CREF(obj_1967))->header = MAKE_HEADER(arg2006_1963, 0), BUNSPEC);
													  }
												       }
												       {
													  object_t aux_2638;
													  aux_2638 = (object_t) (new1128_1962);
													  OBJECT_WIDENING_SET(aux_2638, BFALSE);
												       }
												       ((((var_t) CREF(new1128_1962))->loc) = ((obj_t) loc_837), BUNSPEC);
												       ((((var_t) CREF(new1128_1962))->type) = ((type_t) arg1494_869), BUNSPEC);
												       ((((var_t) CREF(new1128_1962))->variable) = ((variable_t) variable_1961), BUNSPEC);
												       res2050_1969 = new1128_1962;
												    }
												 }
												 aux_2560 = (obj_t) (res2050_1969);
											      }
											   }
										      }
										   }
									      }
									    else
									      {
										 {
										    node_t aux_2645;
										    aux_2645 = error_sexp__node_157_ast_sexp(string2077_ast_sexp, exp_3, loc_837);
										    aux_2560 = (obj_t) (aux_2645);
										 }
									      }
									 }
								      }
								   }
								 else
								   {
								      node_t aux_2648;
								    tag_345_225_841:
								      aux_2648 = error_sexp__node_157_ast_sexp(string2076_ast_sexp, exp_3, loc_837);
								      aux_2560 = (obj_t) (aux_2648);
								   }
							      }
							    else
							      {
								 node_t aux_2651;
								 goto tag_345_225_841;
								 aux_2560 = (obj_t) (aux_2651);
							      }
							 }
						       else
							 {
							    node_t aux_2653;
							    goto tag_345_225_841;
							    aux_2560 = (obj_t) (aux_2653);
							 }
						    }
						  else
						    {
						       node_t aux_2655;
						       goto tag_345_225_841;
						       aux_2560 = (obj_t) (aux_2655);
						    }
					       }
					     else
					       {
						  node_t aux_2657;
						  goto tag_345_225_841;
						  aux_2560 = (obj_t) (aux_2657);
					       }
					  }
					else
					  {
					     node_t aux_2659;
					     goto tag_345_225_841;
					     aux_2560 = (obj_t) (aux_2659);
					  }
				     }
				  }
				else
				  {
				     node_t aux_2661;
				     goto tag_345_225_841;
				     aux_2560 = (obj_t) (aux_2661);
				  }
			     }
			  }
			  return (node_t) (aux_2560);
		       }
		     else
		       {
			  bool_t test_2664;
			  {
			     obj_t aux_2667;
			     obj_t aux_2665;
			     aux_2667 = CNST_TABLE_REF(((long) 17));
			     aux_2665 = CAR(exp_3);
			     test_2664 = (aux_2665 == aux_2667);
			  }
			  if (test_2664)
			    {
			       obj_t aux_2670;
			       {
				  obj_t value_877;
				  if (PAIRP(exp_3))
				    {
				       obj_t cdr_372_212_882;
				       cdr_372_212_882 = CDR(exp_3);
				       if (PAIRP(cdr_372_212_882))
					 {
					    bool_t test_2676;
					    {
					       obj_t aux_2677;
					       aux_2677 = CDR(cdr_372_212_882);
					       test_2676 = (aux_2677 == BNIL);
					    }
					    if (test_2676)
					      {
						 value_877 = CAR(cdr_372_212_882);
						 {
						    obj_t loc_888;
						    loc_888 = find_location_loc_243_tools_location(exp_3, loc_5);
						    if (NULLP(value_877))
						      {
							 {
							    atom_t res2051_1988;
							    {
							       type_t type_1979;
							       type_1979 = (type_t) (__bnil__15_type_cache);
							       {
								  atom_t new1122_1981;
								  new1122_1981 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
								  {
								     long arg2008_1982;
								     arg2008_1982 = class_num_218___object(atom_ast_node);
								     {
									obj_t obj_1986;
									obj_1986 = (obj_t) (new1122_1981);
									(((obj_t) CREF(obj_1986))->header = MAKE_HEADER(arg2008_1982, 0), BUNSPEC);
								     }
								  }
								  {
								     object_t aux_2688;
								     aux_2688 = (object_t) (new1122_1981);
								     OBJECT_WIDENING_SET(aux_2688, BFALSE);
								  }
								  ((((atom_t) CREF(new1122_1981))->loc) = ((obj_t) loc_888), BUNSPEC);
								  ((((atom_t) CREF(new1122_1981))->type) = ((type_t) type_1979), BUNSPEC);
								  ((((atom_t) CREF(new1122_1981))->value) = ((obj_t) BNIL), BUNSPEC);
								  res2051_1988 = new1122_1981;
							       }
							    }
							    aux_2670 = (obj_t) (res2051_1988);
							 }
						      }
						    else
						      {
							 bool_t test_2695;
							 if (PAIRP(value_877))
							   {
							      test_2695 = ((bool_t) 1);
							   }
							 else
							   {
							      if (VECTORP(value_877))
								{
								   test_2695 = ((bool_t) 1);
								}
							      else
								{
								   if (STRUCTP(value_877))
								     {
									test_2695 = ((bool_t) 1);
								     }
								   else
								     {
									if (SYMBOLP(value_877))
									  {
									     test_2695 = ((bool_t) 1);
									  }
									else
									  {
									     test_2695 = KEYWORDP(value_877);
									  }
								     }
								}
							   }
							 if (test_2695)
							   {
							      {
								 kwote_t res2052_2004;
								 {
								    type_t type_1995;
								    type_1995 = (type_t) (_____74_type_cache);
								    {
								       kwote_t new1140_1997;
								       new1140_1997 = ((kwote_t) BREF(GC_MALLOC(sizeof(struct kwote))));
								       {
									  long arg2002_1998;
									  arg2002_1998 = class_num_218___object(kwote_ast_node);
									  {
									     obj_t obj_2002;
									     obj_2002 = (obj_t) (new1140_1997);
									     (((obj_t) CREF(obj_2002))->header = MAKE_HEADER(arg2002_1998, 0), BUNSPEC);
									  }
								       }
								       {
									  object_t aux_2710;
									  aux_2710 = (object_t) (new1140_1997);
									  OBJECT_WIDENING_SET(aux_2710, BFALSE);
								       }
								       ((((kwote_t) CREF(new1140_1997))->loc) = ((obj_t) loc_888), BUNSPEC);
								       ((((kwote_t) CREF(new1140_1997))->type) = ((type_t) type_1995), BUNSPEC);
								       ((((kwote_t) CREF(new1140_1997))->value) = ((obj_t) value_877), BUNSPEC);
								       res2052_2004 = new1140_1997;
								    }
								 }
								 aux_2670 = (obj_t) (res2052_2004);
							      }
							   }
							 else
							   {
							      bool_t test_2717;
							      {
								 bool_t test1512_893;
								 test1512_893 = INTEGERP(value_877);
								 if (test1512_893)
								   {
								      test_2717 = ((bool_t) 1);
								   }
								 else
								   {
								      bool_t test_2720;
								      if (test1512_893)
									{
									   test_2720 = ((bool_t) 1);
									}
								      else
									{
									   test_2720 = REALP(value_877);
									}
								      if (test_2720)
									{
									   test_2717 = ((bool_t) 1);
									}
								      else
									{
									   if (STRINGP(value_877))
									     {
										test_2717 = ((bool_t) 1);
									     }
									   else
									     {
										if (CNSTP(value_877))
										  {
										     test_2717 = ((bool_t) 1);
										  }
										else
										  {
										     if (CHARP(value_877))
										       {
											  test_2717 = ((bool_t) 1);
										       }
										     else
										       {
											  test_2717 = BOOLEANP(value_877);
										       }
										  }
									     }
									}
								   }
							      }
							      if (test_2717)
								{
								   {
								      node_t aux_2730;
								      aux_2730 = sexp__node_235_ast_sexp(value_877, stack_4, loc_888, site_6);
								      aux_2670 = (obj_t) (aux_2730);
								   }
								}
							      else
								{
								   {
								      node_t aux_2733;
								      aux_2733 = error_sexp__node_157_ast_sexp(string2075_ast_sexp, exp_3, loc_888);
								      aux_2670 = (obj_t) (aux_2733);
								   }
								}
							   }
						      }
						 }
					      }
					    else
					      {
						 node_t aux_2737;
					       tag_367_40_879:
						 aux_2737 = error_sexp__node_157_ast_sexp(string2075_ast_sexp, exp_3, loc_5);
						 aux_2670 = (obj_t) (aux_2737);
					      }
					 }
				       else
					 {
					    node_t aux_2740;
					    goto tag_367_40_879;
					    aux_2670 = (obj_t) (aux_2740);
					 }
				    }
				  else
				    {
				       node_t aux_2742;
				       goto tag_367_40_879;
				       aux_2670 = (obj_t) (aux_2742);
				    }
			       }
			       return (node_t) (aux_2670);
			    }
			  else
			    {
			       bool_t test_2745;
			       {
				  obj_t aux_2748;
				  obj_t aux_2746;
				  aux_2748 = CNST_TABLE_REF(((long) 18));
				  aux_2746 = CAR(exp_3);
				  test_2745 = (aux_2746 == aux_2748);
			       }
			       if (test_2745)
				 {
				    sequence_t aux_2751;
				    body_668 = CDR(exp_3);
				    {
				       obj_t body_902;
				       if (NULLP(body_668))
					 {
					    obj_t list1522_906;
					    list1522_906 = MAKE_PAIR(BUNSPEC, BNIL);
					    body_902 = list1522_906;
					 }
				       else
					 {
					    body_902 = body_668;
					 }
				       {
					  obj_t loc_903;
					  loc_903 = find_location_loc_243_tools_location(exp_3, loc_5);
					  {
					     obj_t nodes_904;
					     nodes_904 = sexp___node_160_ast_sexp(body_902, stack_4, loc_903, site_6);
					     {
						{
						   sequence_t res2054_2027;
						   {
						      type_t type_2016;
						      type_2016 = (type_t) (_____74_type_cache);
						      {
							 sequence_t new1145_2019;
							 new1145_2019 = ((sequence_t) BREF(GC_MALLOC(sizeof(struct sequence))));
							 {
							    long arg2000_2020;
							    arg2000_2020 = class_num_218___object(sequence_ast_node);
							    {
							       obj_t obj_2025;
							       obj_2025 = (obj_t) (new1145_2019);
							       (((obj_t) CREF(obj_2025))->header = MAKE_HEADER(arg2000_2020, 0), BUNSPEC);
							    }
							 }
							 {
							    object_t aux_2762;
							    aux_2762 = (object_t) (new1145_2019);
							    OBJECT_WIDENING_SET(aux_2762, BFALSE);
							 }
							 ((((sequence_t) CREF(new1145_2019))->loc) = ((obj_t) loc_903), BUNSPEC);
							 ((((sequence_t) CREF(new1145_2019))->type) = ((type_t) type_2016), BUNSPEC);
							 ((((sequence_t) CREF(new1145_2019))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
							 ((((sequence_t) CREF(new1145_2019))->nodes) = ((obj_t) nodes_904), BUNSPEC);
							 res2054_2027 = new1145_2019;
						      }
						   }
						   aux_2751 = res2054_2027;
						}
					     }
					  }
				       }
				    }
				    return (node_t) (aux_2751);
				 }
			       else
				 {
				    bool_t test_2771;
				    {
				       obj_t aux_2774;
				       obj_t aux_2772;
				       aux_2774 = CNST_TABLE_REF(((long) 12));
				       aux_2772 = CAR(exp_3);
				       test_2771 = (aux_2772 == aux_2774);
				    }
				    if (test_2771)
				      {
					 obj_t aux_2777;
					 {
					    obj_t si_908;
					    obj_t alors_909;
					    obj_t sinon_910;
					    obj_t si_912;
					    obj_t alors_913;
					    if (PAIRP(exp_3))
					      {
						 obj_t cdr_388_242_918;
						 cdr_388_242_918 = CDR(exp_3);
						 if (PAIRP(cdr_388_242_918))
						   {
						      obj_t cdr_393_75_920;
						      cdr_393_75_920 = CDR(cdr_388_242_918);
						      if (PAIRP(cdr_393_75_920))
							{
							   obj_t cdr_398_147_922;
							   cdr_398_147_922 = CDR(cdr_393_75_920);
							   if (PAIRP(cdr_398_147_922))
							     {
								bool_t test_2789;
								{
								   obj_t aux_2790;
								   aux_2790 = CDR(cdr_398_147_922);
								   test_2789 = (aux_2790 == BNIL);
								}
								if (test_2789)
								  {
								     si_908 = CAR(cdr_388_242_918);
								     alors_909 = CAR(cdr_393_75_920);
								     sinon_910 = CAR(cdr_398_147_922);
								     {
									obj_t si_937;
									if (PAIRP(si_908))
									  {
									     obj_t cdr_453_73_942;
									     cdr_453_73_942 = CDR(si_908);
									     {
										bool_t test_2796;
										{
										   obj_t aux_2799;
										   obj_t aux_2797;
										   aux_2799 = CNST_TABLE_REF(((long) 12));
										   aux_2797 = CAR(si_908);
										   test_2796 = (aux_2797 == aux_2799);
										}
										if (test_2796)
										  {
										     if (PAIRP(cdr_453_73_942))
										       {
											  obj_t cdr_456_36_945;
											  cdr_456_36_945 = CDR(cdr_453_73_942);
											  if (PAIRP(cdr_456_36_945))
											    {
											       obj_t cdr_459_197_947;
											       cdr_459_197_947 = CDR(cdr_456_36_945);
											       {
												  bool_t test_2808;
												  {
												     obj_t aux_2809;
												     aux_2809 = CAR(cdr_456_36_945);
												     test_2808 = (aux_2809 == BFALSE);
												  }
												  if (test_2808)
												    {
												       if (PAIRP(cdr_459_197_947))
													 {
													    bool_t test_2814;
													    {
													       obj_t aux_2815;
													       aux_2815 = CAR(cdr_459_197_947);
													       test_2814 = (aux_2815 == BTRUE);
													    }
													    if (test_2814)
													      {
														 bool_t test_2818;
														 {
														    obj_t aux_2819;
														    aux_2819 = CDR(cdr_459_197_947);
														    test_2818 = (aux_2819 == BNIL);
														 }
														 if (test_2818)
														   {
														      node_t aux_2822;
														      si_937 = CAR(cdr_453_73_942);
														    tag_445_246_938:
														      {
															 obj_t aux_2823;
															 aux_2823 = CDR(exp_3);
															 SET_CAR(aux_2823, si_937);
														      }
														      {
															 obj_t aux_2826;
															 {
															    obj_t aux_2827;
															    aux_2827 = CDR(exp_3);
															    aux_2826 = CDR(aux_2827);
															 }
															 SET_CAR(aux_2826, sinon_910);
														      }
														      {
															 obj_t aux_2831;
															 {
															    obj_t aux_2832;
															    {
															       obj_t aux_2833;
															       aux_2833 = CDR(exp_3);
															       aux_2832 = CDR(aux_2833);
															    }
															    aux_2831 = CDR(aux_2832);
															 }
															 SET_CAR(aux_2831, alors_909);
														      }
														      aux_2822 = sexp__node_235_ast_sexp(exp_3, stack_4, loc_5, site_6);
														      aux_2777 = (obj_t) (aux_2822);
														   }
														 else
														   {
														    tag_446_179_939:
														      {
															 bool_t test1569_973;
															 if (SYMBOLP(si_908))
															   {
															      test1569_973 = ((bool_t) 1);
															   }
															 else
															   {
															      test1569_973 = is_a__118___object(si_908, atom_ast_node);
															   }
															 if (test1569_973)
															   {
															      obj_t loc_974;
															      loc_974 = find_location_loc_243_tools_location(exp_3, loc_5);
															      {
																 obj_t l_si_138_975;
																 l_si_138_975 = find_location_loc_243_tools_location(si_908, loc_974);
																 {
																    obj_t l_alors_128_976;
																    l_alors_128_976 = find_location_loc_243_tools_location(alors_909, loc_974);
																    {
																       obj_t l_sinon_85_977;
																       l_sinon_85_977 = find_location_loc_243_tools_location(sinon_910, loc_974);
																       {
																	  node_t si_978;
																	  si_978 = sexp__node_235_ast_sexp(si_908, stack_4, l_si_138_975, CNST_TABLE_REF(((long) 1)));
																	  {
																	     node_t alors_979;
																	     alors_979 = sexp__node_235_ast_sexp(alors_909, stack_4, l_alors_128_976, CNST_TABLE_REF(((long) 1)));
																	     {
																		node_t sinon_980;
																		sinon_980 = sexp__node_235_ast_sexp(sinon_910, stack_4, l_sinon_85_977, CNST_TABLE_REF(((long) 1)));
																		{
																		   {
																		      conditional_t res2055_2112;
																		      {
																			 type_t type_2097;
																			 type_2097 = (type_t) (_____74_type_cache);
																			 {
																			    conditional_t new1195_2102;
																			    new1195_2102 = ((conditional_t) BREF(GC_MALLOC(sizeof(struct conditional))));
																			    {
																			       long arg1984_2103;
																			       arg1984_2103 = class_num_218___object(conditional_ast_node);
																			       {
																				  obj_t obj_2110;
																				  obj_2110 = (obj_t) (new1195_2102);
																				  (((obj_t) CREF(obj_2110))->header = MAKE_HEADER(arg1984_2103, 0), BUNSPEC);
																			       }
																			    }
																			    {
																			       object_t aux_2860;
																			       aux_2860 = (object_t) (new1195_2102);
																			       OBJECT_WIDENING_SET(aux_2860, BFALSE);
																			    }
																			    ((((conditional_t) CREF(new1195_2102))->loc) = ((obj_t) loc_974), BUNSPEC);
																			    ((((conditional_t) CREF(new1195_2102))->type) = ((type_t) type_2097), BUNSPEC);
																			    ((((conditional_t) CREF(new1195_2102))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
																			    ((((conditional_t) CREF(new1195_2102))->test) = ((node_t) si_978), BUNSPEC);
																			    ((((conditional_t) CREF(new1195_2102))->true) = ((node_t) alors_979), BUNSPEC);
																			    ((((conditional_t) CREF(new1195_2102))->false) = ((node_t) sinon_980), BUNSPEC);
																			    res2055_2112 = new1195_2102;
																			 }
																		      }
																		      aux_2777 = (obj_t) (res2055_2112);
																		   }
																		}
																	     }
																	  }
																       }
																    }
																 }
															      }
															   }
															 else
															   {
															      obj_t test_984;
															      test_984 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 10)), BEOA);
															      {
																 obj_t arg1573_985;
																 {
																    obj_t arg1574_986;
																    obj_t arg1575_987;
																    obj_t arg1576_988;
																    arg1574_986 = CNST_TABLE_REF(((long) 8));
																    {
																       obj_t arg1584_994;
																       {
																	  obj_t arg1588_998;
																	  {
																	     obj_t list1594_1004;
																	     {
																		obj_t arg1595_1005;
																		{
																		   obj_t aux_2874;
																		   aux_2874 = CNST_TABLE_REF(((long) 11));
																		   arg1595_1005 = MAKE_PAIR(aux_2874, BNIL);
																		}
																		list1594_1004 = MAKE_PAIR(test_984, arg1595_1005);
																	     }
																	     arg1588_998 = symbol_append_197___r4_symbols_6_4(list1594_1004);
																	  }
																	  {
																	     obj_t list1590_1000;
																	     {
																		obj_t arg1591_1001;
																		arg1591_1001 = MAKE_PAIR(BNIL, BNIL);
																		list1590_1000 = MAKE_PAIR(si_908, arg1591_1001);
																	     }
																	     arg1584_994 = cons__138___r4_pairs_and_lists_6_3(arg1588_998, list1590_1000);
																	  }
																       }
																       {
																	  obj_t list1586_996;
																	  list1586_996 = MAKE_PAIR(BNIL, BNIL);
																	  arg1575_987 = cons__138___r4_pairs_and_lists_6_3(arg1584_994, list1586_996);
																       }
																    }
																    {
																       obj_t arg1597_1007;
																       arg1597_1007 = CNST_TABLE_REF(((long) 12));
																       {
																	  obj_t list1601_1009;
																	  {
																	     obj_t arg1603_1010;
																	     {
																		obj_t arg1604_1011;
																		{
																		   obj_t arg1605_1012;
																		   arg1605_1012 = MAKE_PAIR(BNIL, BNIL);
																		   arg1604_1011 = MAKE_PAIR(sinon_910, arg1605_1012);
																		}
																		arg1603_1010 = MAKE_PAIR(alors_909, arg1604_1011);
																	     }
																	     list1601_1009 = MAKE_PAIR(test_984, arg1603_1010);
																	  }
																	  arg1576_988 = cons__138___r4_pairs_and_lists_6_3(arg1597_1007, list1601_1009);
																       }
																    }
																    {
																       obj_t list1578_990;
																       {
																	  obj_t arg1579_991;
																	  {
																	     obj_t arg1582_992;
																	     arg1582_992 = MAKE_PAIR(BNIL, BNIL);
																	     arg1579_991 = MAKE_PAIR(arg1576_988, arg1582_992);
																	  }
																	  list1578_990 = MAKE_PAIR(arg1575_987, arg1579_991);
																       }
																       arg1573_985 = cons__138___r4_pairs_and_lists_6_3(arg1574_986, list1578_990);
																    }
																 }
																 replace__160_tools_misc(exp_3, arg1573_985);
															      }
															      {
																 node_t aux_2895;
																 aux_2895 = sexp__node_235_ast_sexp(exp_3, stack_4, loc_5, site_6);
																 aux_2777 = (obj_t) (aux_2895);
															      }
															   }
														      }
														   }
													      }
													    else
													      {
														 goto tag_446_179_939;
													      }
													 }
												       else
													 {
													    goto tag_446_179_939;
													 }
												    }
												  else
												    {
												       goto tag_446_179_939;
												    }
											       }
											    }
											  else
											    {
											       goto tag_446_179_939;
											    }
										       }
										     else
										       {
											  goto tag_446_179_939;
										       }
										  }
										else
										  {
										     bool_t test_2898;
										     {
											obj_t aux_2901;
											obj_t aux_2899;
											aux_2901 = CNST_TABLE_REF(((long) 13));
											aux_2899 = CAR(si_908);
											test_2898 = (aux_2899 == aux_2901);
										     }
										     if (test_2898)
										       {
											  if (PAIRP(cdr_453_73_942))
											    {
											       bool_t test_2906;
											       {
												  obj_t aux_2907;
												  aux_2907 = CDR(cdr_453_73_942);
												  test_2906 = (aux_2907 == BNIL);
											       }
											       if (test_2906)
												 {
												    node_t aux_2910;
												    {
												       obj_t si_2911;
												       si_2911 = CAR(cdr_453_73_942);
												       si_937 = si_2911;
												       goto tag_445_246_938;
												    }
												    aux_2777 = (obj_t) (aux_2910);
												 }
											       else
												 {
												    goto tag_446_179_939;
												 }
											    }
											  else
											    {
											       goto tag_446_179_939;
											    }
										       }
										     else
										       {
											  goto tag_446_179_939;
										       }
										  }
									     }
									  }
									else
									  {
									     goto tag_446_179_939;
									  }
								     }
								  }
								else
								  {
								     node_t aux_2917;
								   tag_379_81_915:
								     aux_2917 = error_sexp__node_157_ast_sexp(string2074_ast_sexp, exp_3, loc_5);
								     aux_2777 = (obj_t) (aux_2917);
								  }
							     }
							   else
							     {
								obj_t cdr_423_232_931;
								cdr_423_232_931 = CDR(cdr_388_242_918);
								{
								   bool_t test_2921;
								   {
								      obj_t aux_2922;
								      aux_2922 = CDR(cdr_423_232_931);
								      test_2921 = (aux_2922 == BNIL);
								   }
								   if (test_2921)
								     {
									node_t aux_2925;
									si_912 = CAR(cdr_388_242_918);
									alors_913 = CAR(cdr_423_232_931);
									{
									   obj_t arg1611_1016;
									   obj_t arg1614_1017;
									   {
									      obj_t aux_2926;
									      aux_2926 = CDR(exp_3);
									      arg1611_1016 = CDR(aux_2926);
									   }
									   {
									      obj_t list1615_1018;
									      list1615_1018 = MAKE_PAIR(BUNSPEC, BNIL);
									      arg1614_1017 = list1615_1018;
									   }
									   SET_CDR(arg1611_1016, arg1614_1017);
									}
									aux_2925 = sexp__node_235_ast_sexp(exp_3, stack_4, loc_5, site_6);
									aux_2777 = (obj_t) (aux_2925);
								     }
								   else
								     {
									node_t aux_2935;
									goto tag_379_81_915;
									aux_2777 = (obj_t) (aux_2935);
								     }
								}
							     }
							}
						      else
							{
							   node_t aux_2937;
							   goto tag_379_81_915;
							   aux_2777 = (obj_t) (aux_2937);
							}
						   }
						 else
						   {
						      node_t aux_2939;
						      goto tag_379_81_915;
						      aux_2777 = (obj_t) (aux_2939);
						   }
					      }
					    else
					      {
						 node_t aux_2941;
						 goto tag_379_81_915;
						 aux_2777 = (obj_t) (aux_2941);
					      }
					 }
					 return (node_t) (aux_2777);
				      }
				    else
				      {
					 bool_t test_2944;
					 {
					    obj_t aux_2947;
					    obj_t aux_2945;
					    aux_2947 = CNST_TABLE_REF(((long) 9));
					    aux_2945 = CAR(exp_3);
					    test_2944 = (aux_2945 == aux_2947);
					 }
					 if (test_2944)
					   {
					      obj_t aux_2950;
					      {
						 obj_t var_1020;
						 obj_t val_1021;
						 if (PAIRP(exp_3))
						   {
						      obj_t cdr_484_240_1026;
						      cdr_484_240_1026 = CDR(exp_3);
						      if (PAIRP(cdr_484_240_1026))
							{
							   obj_t cdr_488_93_1028;
							   cdr_488_93_1028 = CDR(cdr_484_240_1026);
							   if (PAIRP(cdr_488_93_1028))
							     {
								bool_t test_2959;
								{
								   obj_t aux_2960;
								   aux_2960 = CDR(cdr_488_93_1028);
								   test_2959 = (aux_2960 == BNIL);
								}
								if (test_2959)
								  {
								     var_1020 = CAR(cdr_484_240_1026);
								     val_1021 = CAR(cdr_488_93_1028);
								     {
									obj_t loc_1035;
									loc_1035 = find_location_loc_243_tools_location(exp_3, loc_5);
									{
									   obj_t val_loc_228_1036;
									   val_loc_228_1036 = find_location_loc_243_tools_location(val_1021, loc_1035);
									   {
									      node_t val_1037;
									      val_1037 = sexp__node_235_ast_sexp(val_1021, stack_4, val_loc_228_1036, CNST_TABLE_REF(((long) 1)));
									      {
										 {
										    node_t ast_1038;
										    ast_1038 = sexp__node_235_ast_sexp(var_1020, stack_4, loc_1035, CNST_TABLE_REF(((long) 9)));
										    {
										       bool_t test1627_1039;
										       test1627_1039 = is_a__118___object((obj_t) (ast_1038), var_ast_node);
										       if (test1627_1039)
											 {
											    setq_t res2056_2143;
											    {
											       type_t type_2132;
											       var_t var_2133;
											       type_2132 = (type_t) (__unspec__87_type_cache);
											       var_2133 = (var_t) (ast_1038);
											       {
												  setq_t new1188_2135;
												  new1188_2135 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
												  {
												     long arg1986_2136;
												     arg1986_2136 = class_num_218___object(setq_ast_node);
												     {
													obj_t obj_2141;
													obj_2141 = (obj_t) (new1188_2135);
													(((obj_t) CREF(obj_2141))->header = MAKE_HEADER(arg1986_2136, 0), BUNSPEC);
												     }
												  }
												  {
												     object_t aux_2978;
												     aux_2978 = (object_t) (new1188_2135);
												     OBJECT_WIDENING_SET(aux_2978, BFALSE);
												  }
												  ((((setq_t) CREF(new1188_2135))->loc) = ((obj_t) loc_1035), BUNSPEC);
												  ((((setq_t) CREF(new1188_2135))->type) = ((type_t) type_2132), BUNSPEC);
												  ((((setq_t) CREF(new1188_2135))->var) = ((var_t) var_2133), BUNSPEC);
												  ((((setq_t) CREF(new1188_2135))->value) = ((node_t) val_1037), BUNSPEC);
												  res2056_2143 = new1188_2135;
											       }
											    }
											    aux_2950 = (obj_t) (res2056_2143);
											 }
										       else
											 {
											    node_t aux_2986;
											    aux_2986 = error_sexp__node_157_ast_sexp(string2073_ast_sexp, exp_3, loc_1035);
											    aux_2950 = (obj_t) (aux_2986);
											 }
										    }
										 }
									      }
									   }
									}
								     }
								  }
								else
								  {
								     node_t aux_2991;
								   tag_477_142_1023:
								     {
									obj_t arg1634_1043;
									arg1634_1043 = find_location_loc_243_tools_location(exp_3, loc_5);
									aux_2991 = error_sexp__node_157_ast_sexp(string2072_ast_sexp, exp_3, arg1634_1043);
								     }
								     aux_2950 = (obj_t) (aux_2991);
								  }
							     }
							   else
							     {
								node_t aux_2995;
								goto tag_477_142_1023;
								aux_2950 = (obj_t) (aux_2995);
							     }
							}
						      else
							{
							   node_t aux_2997;
							   goto tag_477_142_1023;
							   aux_2950 = (obj_t) (aux_2997);
							}
						   }
						 else
						   {
						      node_t aux_2999;
						      goto tag_477_142_1023;
						      aux_2950 = (obj_t) (aux_2999);
						   }
					      }
					      return (node_t) (aux_2950);
					   }
					 else
					   {
					      bool_t test_3002;
					      {
						 obj_t aux_3005;
						 obj_t aux_3003;
						 aux_3005 = CNST_TABLE_REF(((long) 19));
						 aux_3003 = CAR(exp_3);
						 test_3002 = (aux_3003 == aux_3005);
					      }
					      if (test_3002)
						{
						   obj_t aux_3008;
						   {
						      obj_t var_1044;
						      obj_t val_1045;
						      if (PAIRP(exp_3))
							{
							   obj_t cdr_502_28_1050;
							   cdr_502_28_1050 = CDR(exp_3);
							   if (PAIRP(cdr_502_28_1050))
							     {
								obj_t cdr_506_2_1052;
								cdr_506_2_1052 = CDR(cdr_502_28_1050);
								if (PAIRP(cdr_506_2_1052))
								  {
								     bool_t test_3017;
								     {
									obj_t aux_3018;
									aux_3018 = CDR(cdr_506_2_1052);
									test_3017 = (aux_3018 == BNIL);
								     }
								     if (test_3017)
								       {
									  var_1044 = CAR(cdr_502_28_1050);
									  val_1045 = CAR(cdr_506_2_1052);
									  {
									     obj_t loc_1059;
									     loc_1059 = find_location_loc_243_tools_location(exp_3, loc_5);
									     {
										obj_t val_loc_228_1060;
										val_loc_228_1060 = find_location_loc_243_tools_location(val_1045, loc_1059);
										{
										   node_t val_1061;
										   val_1061 = sexp__node_235_ast_sexp(val_1045, stack_4, val_loc_228_1060, CNST_TABLE_REF(((long) 1)));
										   {
										      {
											 node_t ast_1062;
											 ast_1062 = sexp__node_235_ast_sexp(var_1044, stack_4, loc_1059, CNST_TABLE_REF(((long) 1)));
											 {
											    bool_t test1645_1063;
											    {
											       bool_t test1647_1065;
											       test1647_1065 = is_a__118___object((obj_t) (ast_1062), var_ast_node);
											       if (test1647_1065)
												 {
												    obj_t aux_3030;
												    {
												       variable_t aux_3031;
												       {
													  var_t obj_2155;
													  obj_2155 = (var_t) (ast_1062);
													  aux_3031 = (((var_t) CREF(obj_2155))->variable);
												       }
												       aux_3030 = (obj_t) (aux_3031);
												    }
												    test1645_1063 = is_a__118___object(aux_3030, global_ast_var);
												 }
											       else
												 {
												    test1645_1063 = ((bool_t) 0);
												 }
											    }
											    if (test1645_1063)
											      {
												 {
												    obj_t res2057_2160;
												    {
												       global_t obj_2158;
												       obj_t val1045_2159;
												       {
													  variable_t aux_3037;
													  {
													     var_t obj_2157;
													     obj_2157 = (var_t) (ast_1062);
													     aux_3037 = (((var_t) CREF(obj_2157))->variable);
													  }
													  obj_2158 = (global_t) (aux_3037);
												       }
												       val1045_2159 = (obj_t) (val_1061);
												       {
													  obj_t x_2493;
													  x_2493 = ((((global_t) CREF(obj_2158))->src) = ((obj_t) val1045_2159), BUNSPEC);
													  res2057_2160 = BUNSPEC;
												       }
												    }
												    res2057_2160;
												 }
												 {
												    setq_t res2058_2173;
												    {
												       type_t type_2162;
												       var_t var_2163;
												       type_2162 = (type_t) (__unspec__87_type_cache);
												       var_2163 = (var_t) (ast_1062);
												       {
													  setq_t new1188_2165;
													  new1188_2165 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
													  {
													     long arg1986_2166;
													     arg1986_2166 = class_num_218___object(setq_ast_node);
													     {
														obj_t obj_2171;
														obj_2171 = (obj_t) (new1188_2165);
														(((obj_t) CREF(obj_2171))->header = MAKE_HEADER(arg1986_2166, 0), BUNSPEC);
													     }
													  }
													  {
													     object_t aux_3049;
													     aux_3049 = (object_t) (new1188_2165);
													     OBJECT_WIDENING_SET(aux_3049, BFALSE);
													  }
													  ((((setq_t) CREF(new1188_2165))->loc) = ((obj_t) loc_1059), BUNSPEC);
													  ((((setq_t) CREF(new1188_2165))->type) = ((type_t) type_2162), BUNSPEC);
													  ((((setq_t) CREF(new1188_2165))->var) = ((var_t) var_2163), BUNSPEC);
													  ((((setq_t) CREF(new1188_2165))->value) = ((node_t) val_1061), BUNSPEC);
													  res2058_2173 = new1188_2165;
												       }
												    }
												    aux_3008 = (obj_t) (res2058_2173);
												 }
											      }
											    else
											      {
												 node_t aux_3057;
												 aux_3057 = error_sexp__node_157_ast_sexp(string2071_ast_sexp, exp_3, loc_1059);
												 aux_3008 = (obj_t) (aux_3057);
											      }
											 }
										      }
										   }
										}
									     }
									  }
								       }
								     else
								       {
									  node_t aux_3062;
									tag_495_173_1047:
									  {
									     obj_t arg1653_1070;
									     arg1653_1070 = find_location_loc_243_tools_location(exp_3, loc_5);
									     aux_3062 = error_sexp__node_157_ast_sexp(string2070_ast_sexp, exp_3, arg1653_1070);
									  }
									  aux_3008 = (obj_t) (aux_3062);
								       }
								  }
								else
								  {
								     node_t aux_3066;
								     goto tag_495_173_1047;
								     aux_3008 = (obj_t) (aux_3066);
								  }
							     }
							   else
							     {
								node_t aux_3068;
								goto tag_495_173_1047;
								aux_3008 = (obj_t) (aux_3068);
							     }
							}
						      else
							{
							   node_t aux_3070;
							   goto tag_495_173_1047;
							   aux_3008 = (obj_t) (aux_3070);
							}
						   }
						   return (node_t) (aux_3008);
						}
					      else
						{
						   obj_t car_196_45_702;
						   car_196_45_702 = CAR(exp_3);
						   if (PAIRP(car_196_45_702))
						     {
							obj_t car_199_165_704;
							obj_t cdr_200_91_705;
							car_199_165_704 = CAR(car_196_45_702);
							cdr_200_91_705 = CDR(car_196_45_702);
							{
							   {
							      bool_t test_3078;
							      {
								 obj_t aux_3079;
								 aux_3079 = CNST_TABLE_REF(((long) 8));
								 test_3078 = (car_199_165_704 == aux_3079);
							      }
							      if (test_3078)
								{
								 kap_201_205_706:
								   if (PAIRP(cdr_200_91_705))
								     {
									obj_t cdr_204_81_723;
									cdr_204_81_723 = CDR(cdr_200_91_705);
									if (PAIRP(cdr_204_81_723))
									  {
									     bool_t test_3087;
									     {
										obj_t aux_3088;
										aux_3088 = CDR(cdr_204_81_723);
										test_3087 = (aux_3088 == BNIL);
									     }
									     if (test_3087)
									       {
										  body_673 = CAR(cdr_204_81_723);
										  args_674 = CDR(exp_3);
										  {
										     obj_t let_part_60_1071;
										     let_part_60_1071 = CAR(exp_3);
										     {
											obj_t arg1654_1072;
											obj_t arg1655_1073;
											{
											   obj_t aux_3092;
											   aux_3092 = CDR(let_part_60_1071);
											   arg1654_1072 = CDR(aux_3092);
											}
											{
											   obj_t arg1656_1074;
											   {
											      obj_t arg1661_1077;
											      arg1661_1077 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
											      arg1656_1074 = append_2_18___r4_pairs_and_lists_6_3(args_674, arg1661_1077);
											   }
											   {
											      obj_t list1657_1075;
											      list1657_1075 = MAKE_PAIR(arg1656_1074, BNIL);
											      arg1655_1073 = cons__138___r4_pairs_and_lists_6_3(body_673, list1657_1075);
											   }
											}
											SET_CAR(arg1654_1072, arg1655_1073);
										     }
										     {
											obj_t exp_3100;
											exp_3100 = let_part_60_1071;
											exp_3 = exp_3100;
											goto sexp__node_235_ast_sexp;
										     }
										  }
									       }
									     else
									       {
										  obj_t car_225_42_728;
										  car_225_42_728 = CAR(exp_3);
										  {
										     obj_t cdr_230_49_729;
										     cdr_230_49_729 = CDR(car_225_42_728);
										     {
											bool_t test_3105;
											{
											   obj_t aux_3108;
											   obj_t aux_3106;
											   aux_3108 = CNST_TABLE_REF(((long) 5));
											   aux_3106 = CAR(car_225_42_728);
											   test_3105 = (aux_3106 == aux_3108);
											}
											if (test_3105)
											  {
											     vars_678 = CAR(cdr_230_49_729);
											     body_679 = CDR(cdr_230_49_729);
											     args_680 = CDR(exp_3);
											   tag_132_226_681:
											     {
												obj_t loc_1082;
												loc_1082 = find_location_loc_243_tools_location(exp_3, loc_5);
												{
												   obj_t arg1668_1083;
												   {
												      obj_t arg1669_1084;
												      obj_t arg1671_1085;
												      obj_t arg1673_1086;
												      arg1669_1084 = CNST_TABLE_REF(((long) 8));
												      arg1671_1085 = loop_ast_sexp(exp_3, loc_1082, vars_678, args_680);
												      {
													 obj_t arg1736_1146;
													 obj_t arg1737_1147;
													 {
													    obj_t arg1740_1149;
													    arg1740_1149 = current_function_76_tools_error();
													    arg1736_1146 = shape_tools_shape(arg1740_1149);
													 }
													 arg1737_1147 = normalize_progn_143_tools_progn(body_679);
													 {
													    obj_t arg1738_2465;
													    arg1738_2465 = make_fx_procedure(arg17382065_ast_sexp, ((long) 3), ((long) 1));
													    PROCEDURE_SET(arg1738_2465, ((long) 0), loc_1082);
													    arg1673_1086 = make_dsssl_function_prelude_58___dsssl(arg1736_1146, vars_678, arg1737_1147, arg1738_2465);
													 }
												      }
												      {
													 obj_t list1675_1088;
													 {
													    obj_t arg1677_1089;
													    {
													       obj_t arg1678_1090;
													       arg1678_1090 = MAKE_PAIR(BNIL, BNIL);
													       arg1677_1089 = MAKE_PAIR(arg1673_1086, arg1678_1090);
													    }
													    list1675_1088 = MAKE_PAIR(arg1671_1085, arg1677_1089);
													 }
													 arg1668_1083 = cons__138___r4_pairs_and_lists_6_3(arg1669_1084, list1675_1088);
												      }
												   }
												   {
												      obj_t loc_3125;
												      obj_t exp_3124;
												      exp_3124 = arg1668_1083;
												      loc_3125 = loc_1082;
												      loc_5 = loc_3125;
												      exp_3 = exp_3124;
												      goto sexp__node_235_ast_sexp;
												   }
												}
											     }
											  }
											else
											  {
											   tag_141_241_690:
											     {
												obj_t caller_1258;
												caller_1258 = CAR(exp_3);
												if (SYMBOLP(caller_1258))
												  {
												     obj_t pid_1260;
												     pid_1260 = parse_id_241_ast_ident(caller_1258);
												     {
													obj_t id_1261;
													id_1261 = CAR(pid_1260);
													{
													   obj_t type_1262;
													   type_1262 = CDR(pid_1260);
													   {
													      {
														 bool_t test_3135;
														 {
														    obj_t aux_3136;
														    aux_3136 = CNST_TABLE_REF(((long) 3));
														    test_3135 = (id_1261 == aux_3136);
														 }
														 if (test_3135)
														   {
														      return pragma_type__node_160_ast_pragma(((bool_t) 0), (type_t) (type_1262), exp_3, stack_4, loc_5, site_6);
														   }
														 else
														   {
														      bool_t test_3141;
														      {
															 obj_t aux_3142;
															 aux_3142 = CNST_TABLE_REF(((long) 4));
															 test_3141 = (id_1261 == aux_3142);
														      }
														      if (test_3141)
															{
															   return pragma_type__node_160_ast_pragma(((bool_t) 1), (type_t) (type_1262), exp_3, stack_4, loc_5, site_6);
															}
														      else
															{
															   bool_t test_3147;
															   {
															      obj_t aux_3148;
															      aux_3148 = CNST_TABLE_REF(((long) 5));
															      test_3147 = (id_1261 == aux_3148);
															   }
															   if (test_3147)
															     {
																obj_t args_1267;
																obj_t body_1268;
																if (PAIRP(exp_3))
																  {
																     obj_t cdr_576_84_1273;
																     cdr_576_84_1273 = CDR(exp_3);
																     if (PAIRP(cdr_576_84_1273))
																       {
																	  args_1267 = CAR(cdr_576_84_1273);
																	  body_1268 = CDR(cdr_576_84_1273);
																	  {
																	     obj_t loc_1277;
																	     loc_1277 = find_location_loc_243_tools_location(exp_3, loc_5);
																	     {
																		obj_t fun_1278;
																		fun_1278 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 5)), BEOA);
																		{
																		   obj_t tfun_1279;
																		   {
																		      obj_t list1850_1299;
																		      {
																			 obj_t arg1852_1300;
																			 {
																			    obj_t arg1853_1301;
																			    {
																			       obj_t aux_3160;
																			       {
																				  type_t obj_2286;
																				  obj_2286 = (type_t) (type_1262);
																				  aux_3160 = (((type_t) CREF(obj_2286))->id);
																			       }
																			       arg1853_1301 = MAKE_PAIR(aux_3160, BNIL);
																			    }
																			    arg1852_1300 = MAKE_PAIR(_4dots_tools_misc, arg1853_1301);
																			 }
																			 list1850_1299 = MAKE_PAIR(fun_1278, arg1852_1300);
																		      }
																		      tfun_1279 = symbol_append_197___r4_symbols_6_4(list1850_1299);
																		   }
																		   {
																		      {
																			 obj_t arg1831_1280;
																			 {
																			    obj_t arg1832_1281;
																			    obj_t arg1833_1282;
																			    arg1832_1281 = CNST_TABLE_REF(((long) 6));
																			    {
																			       obj_t arg1839_1288;
																			       {
																				  obj_t arg1843_1292;
																				  arg1843_1292 = normalize_progn_143_tools_progn(body_1268);
																				  {
																				     obj_t list1845_1294;
																				     {
																					obj_t arg1846_1295;
																					{
																					   obj_t arg1847_1296;
																					   arg1847_1296 = MAKE_PAIR(BNIL, BNIL);
																					   arg1846_1295 = MAKE_PAIR(arg1843_1292, arg1847_1296);
																					}
																					list1845_1294 = MAKE_PAIR(args_1267, arg1846_1295);
																				     }
																				     arg1839_1288 = cons__138___r4_pairs_and_lists_6_3(tfun_1279, list1845_1294);
																				  }
																			       }
																			       {
																				  obj_t list1841_1290;
																				  list1841_1290 = MAKE_PAIR(BNIL, BNIL);
																				  arg1833_1282 = cons__138___r4_pairs_and_lists_6_3(arg1839_1288, list1841_1290);
																			       }
																			    }
																			    {
																			       obj_t list1835_1284;
																			       {
																				  obj_t arg1836_1285;
																				  {
																				     obj_t arg1837_1286;
																				     arg1837_1286 = MAKE_PAIR(BNIL, BNIL);
																				     arg1836_1285 = MAKE_PAIR(fun_1278, arg1837_1286);
																				  }
																				  list1835_1284 = MAKE_PAIR(arg1833_1282, arg1836_1285);
																			       }
																			       arg1831_1280 = cons__138___r4_pairs_and_lists_6_3(arg1832_1281, list1835_1284);
																			    }
																			 }
																			 {
																			    obj_t loc_3180;
																			    obj_t exp_3179;
																			    exp_3179 = arg1831_1280;
																			    loc_3180 = loc_1277;
																			    loc_5 = loc_3180;
																			    exp_3 = exp_3179;
																			    goto sexp__node_235_ast_sexp;
																			 }
																		      }
																		   }
																		}
																	     }
																	  }
																       }
																     else
																       {
																	tag_569_3_1270:
																	  {
																	     obj_t arg1858_1305;
																	     arg1858_1305 = find_location_loc_243_tools_location(exp_3, loc_5);
																	     return error_sexp__node_157_ast_sexp(string2067_ast_sexp, exp_3, arg1858_1305);
																	  }
																       }
																  }
																else
																  {
																     goto tag_569_3_1270;
																  }
															     }
															   else
															     {
																return application__node_43_ast_app(exp_3, stack_4, loc_5, site_6);
															     }
															}
														   }
													      }
													   }
													}
												     }
												  }
												else
												  {
												     return application__node_43_ast_app(exp_3, stack_4, loc_5, site_6);
												  }
											     }
											  }
										     }
										  }
									       }
									  }
									else
									  {
									     obj_t car_253_251_738;
									     car_253_251_738 = CAR(exp_3);
									     {
										obj_t cdr_258_124_739;
										cdr_258_124_739 = CDR(car_253_251_738);
										{
										   bool_t test_3189;
										   {
										      obj_t aux_3192;
										      obj_t aux_3190;
										      aux_3192 = CNST_TABLE_REF(((long) 5));
										      aux_3190 = CAR(car_253_251_738);
										      test_3189 = (aux_3190 == aux_3192);
										   }
										   if (test_3189)
										     {
											obj_t args_3199;
											obj_t body_3197;
											obj_t vars_3195;
											vars_3195 = CAR(cdr_258_124_739);
											body_3197 = CDR(cdr_258_124_739);
											args_3199 = CDR(exp_3);
											args_680 = args_3199;
											body_679 = body_3197;
											vars_678 = vars_3195;
											goto tag_132_226_681;
										     }
										   else
										     {
											goto tag_141_241_690;
										     }
										}
									     }
									  }
								     }
								   else
								     {
									goto tag_141_241_690;
								     }
								}
							      else
								{
								   bool_t test_3201;
								   {
								      obj_t aux_3202;
								      aux_3202 = CNST_TABLE_REF(((long) 20));
								      test_3201 = (car_199_165_704 == aux_3202);
								   }
								   if (test_3201)
								     {
									goto kap_201_205_706;
								     }
								   else
								     {
									bool_t test_3205;
									{
									   obj_t aux_3206;
									   aux_3206 = CNST_TABLE_REF(((long) 6));
									   test_3205 = (car_199_165_704 == aux_3206);
									}
									if (test_3205)
									  {
									     goto kap_201_205_706;
									  }
									else
									  {
									     obj_t cdr_302_164_711;
									     cdr_302_164_711 = CDR(car_196_45_702);
									     {
										bool_t test_3210;
										{
										   obj_t aux_3213;
										   obj_t aux_3211;
										   aux_3213 = CNST_TABLE_REF(((long) 5));
										   aux_3211 = CAR(car_196_45_702);
										   test_3210 = (aux_3211 == aux_3213);
										}
										if (test_3210)
										  {
										     if (PAIRP(cdr_302_164_711))
										       {
											  obj_t args_3222;
											  obj_t body_3220;
											  obj_t vars_3218;
											  vars_3218 = CAR(cdr_302_164_711);
											  body_3220 = CDR(cdr_302_164_711);
											  args_3222 = CDR(exp_3);
											  args_680 = args_3222;
											  body_679 = body_3220;
											  vars_678 = vars_3218;
											  goto tag_132_226_681;
										       }
										     else
										       {
											  goto tag_141_241_690;
										       }
										  }
										else
										  {
										     goto tag_141_241_690;
										  }
									     }
									  }
								     }
								}
							   }
							}
						     }
						   else
						     {
							bool_t test_3224;
							{
							   obj_t aux_3225;
							   aux_3225 = CNST_TABLE_REF(((long) 8));
							   test_3224 = (car_196_45_702 == aux_3225);
							}
							if (test_3224)
							  {
							   tag_130_214_676:
							     return let__node_121_ast_let(exp_3, stack_4, loc_5, CNST_TABLE_REF(((long) 1)));
							  }
							else
							  {
							     bool_t test_3230;
							     {
								obj_t aux_3231;
								aux_3231 = CNST_TABLE_REF(((long) 20));
								test_3230 = (car_196_45_702 == aux_3231);
							     }
							     if (test_3230)
							       {
								  goto tag_130_214_676;
							       }
							     else
							       {
								  bool_t test_3234;
								  {
								     obj_t aux_3235;
								     aux_3235 = CNST_TABLE_REF(((long) 6));
								     test_3234 = (car_196_45_702 == aux_3235);
								  }
								  if (test_3234)
								    {
								       let_fun_218_t aux_3238;
								       aux_3238 = labels__node_197_ast_labels(exp_3, stack_4, loc_5, CNST_TABLE_REF(((long) 1)));
								       return (node_t) (aux_3238);
								    }
								  else
								    {
								       bool_t test_3242;
								       {
									  obj_t aux_3243;
									  aux_3243 = CNST_TABLE_REF(((long) 5));
									  test_3242 = (car_196_45_702 == aux_3243);
								       }
								       if (test_3242)
									 {
									    {
									       obj_t args_1156;
									       obj_t body_1157;
									       if (PAIRP(exp_3))
										 {
										    obj_t cdr_520_55_1162;
										    cdr_520_55_1162 = CDR(exp_3);
										    if (PAIRP(cdr_520_55_1162))
										      {
											 args_1156 = CAR(cdr_520_55_1162);
											 body_1157 = CDR(cdr_520_55_1162);
											 {
											    obj_t loc_1166;
											    obj_t fun_1167;
											    loc_1166 = find_location_loc_243_tools_location(exp_3, loc_5);
											    fun_1167 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 5)), BEOA);
											    {
											       obj_t arg1747_1168;
											       {
												  obj_t arg1748_1169;
												  obj_t arg1749_1170;
												  arg1748_1169 = CNST_TABLE_REF(((long) 6));
												  {
												     obj_t arg1756_1176;
												     {
													obj_t arg1762_1180;
													arg1762_1180 = normalize_progn_143_tools_progn(body_1157);
													{
													   obj_t list1764_1182;
													   {
													      obj_t arg1766_1183;
													      {
														 obj_t arg1767_1184;
														 arg1767_1184 = MAKE_PAIR(BNIL, BNIL);
														 arg1766_1183 = MAKE_PAIR(arg1762_1180, arg1767_1184);
													      }
													      list1764_1182 = MAKE_PAIR(args_1156, arg1766_1183);
													   }
													   arg1756_1176 = cons__138___r4_pairs_and_lists_6_3(fun_1167, list1764_1182);
													}
												     }
												     {
													obj_t list1759_1178;
													list1759_1178 = MAKE_PAIR(BNIL, BNIL);
													arg1749_1170 = cons__138___r4_pairs_and_lists_6_3(arg1756_1176, list1759_1178);
												     }
												  }
												  {
												     obj_t list1752_1172;
												     {
													obj_t arg1753_1173;
													{
													   obj_t arg1754_1174;
													   arg1754_1174 = MAKE_PAIR(BNIL, BNIL);
													   arg1753_1173 = MAKE_PAIR(fun_1167, arg1754_1174);
													}
													list1752_1172 = MAKE_PAIR(arg1749_1170, arg1753_1173);
												     }
												     arg1747_1168 = cons__138___r4_pairs_and_lists_6_3(arg1748_1169, list1752_1172);
												  }
											       }
											       {
												  obj_t loc_3268;
												  obj_t exp_3267;
												  exp_3267 = arg1747_1168;
												  loc_3268 = loc_1166;
												  loc_5 = loc_3268;
												  exp_3 = exp_3267;
												  goto sexp__node_235_ast_sexp;
											       }
											    }
											 }
										      }
										    else
										      {
										       tag_513_88_1159:
											 {
											    obj_t arg1772_1188;
											    arg1772_1188 = find_location_loc_243_tools_location(exp_3, loc_5);
											    return error_sexp__node_157_ast_sexp(string2067_ast_sexp, exp_3, arg1772_1188);
											 }
										      }
										 }
									       else
										 {
										    goto tag_513_88_1159;
										 }
									    }
									 }
								       else
									 {
									    bool_t test_3273;
									    {
									       obj_t aux_3274;
									       aux_3274 = CNST_TABLE_REF(((long) 3));
									       test_3273 = (car_196_45_702 == aux_3274);
									    }
									    if (test_3273)
									      {
										 return pragma_type__node_160_ast_pragma(((bool_t) 0), (type_t) (__unspec__87_type_cache), exp_3, stack_4, loc_5, site_6);
									      }
									    else
									      {
										 bool_t test_3279;
										 {
										    obj_t aux_3280;
										    aux_3280 = CNST_TABLE_REF(((long) 4));
										    test_3279 = (car_196_45_702 == aux_3280);
										 }
										 if (test_3279)
										   {
										      return pragma_type__node_160_ast_pragma(((bool_t) 1), (type_t) (__unspec__87_type_cache), exp_3, stack_4, loc_5, site_6);
										   }
										 else
										   {
										      bool_t test_3285;
										      {
											 obj_t aux_3286;
											 aux_3286 = CNST_TABLE_REF(((long) 21));
											 test_3285 = (car_196_45_702 == aux_3286);
										      }
										      if (test_3285)
											{
											   obj_t aux_3289;
											   {
											      obj_t proc_1189;
											      obj_t msg_1190;
											      obj_t obj_1191;
											      if (PAIRP(exp_3))
												{
												   obj_t cdr_537_243_1196;
												   cdr_537_243_1196 = CDR(exp_3);
												   if (PAIRP(cdr_537_243_1196))
												     {
													obj_t cdr_542_204_1198;
													cdr_542_204_1198 = CDR(cdr_537_243_1196);
													if (PAIRP(cdr_542_204_1198))
													  {
													     obj_t cdr_547_94_1200;
													     cdr_547_94_1200 = CDR(cdr_542_204_1198);
													     if (PAIRP(cdr_547_94_1200))
													       {
														  bool_t test_3301;
														  {
														     obj_t aux_3302;
														     aux_3302 = CDR(cdr_547_94_1200);
														     test_3301 = (aux_3302 == BNIL);
														  }
														  if (test_3301)
														    {
														       fail_t aux_3305;
														       proc_1189 = CAR(cdr_537_243_1196);
														       msg_1190 = CAR(cdr_542_204_1198);
														       obj_1191 = CAR(cdr_547_94_1200);
														       {
															  obj_t loc_1208;
															  loc_1208 = find_location_loc_243_tools_location(exp_3, loc_5);
															  {
															     obj_t loc_proc_248_1209;
															     loc_proc_248_1209 = find_location_loc_243_tools_location(proc_1189, loc_1208);
															     {
																obj_t loc_msg_36_1210;
																loc_msg_36_1210 = find_location_loc_243_tools_location(msg_1190, loc_1208);
																{
																   obj_t loc_obj_88_1211;
																   loc_obj_88_1211 = find_location_loc_243_tools_location(obj_1191, loc_1208);
																   {
																      node_t proc_1212;
																      proc_1212 = sexp__node_235_ast_sexp(proc_1189, stack_4, loc_proc_248_1209, CNST_TABLE_REF(((long) 1)));
																      {
																	 node_t msg_1213;
																	 msg_1213 = sexp__node_235_ast_sexp(msg_1190, stack_4, loc_msg_36_1210, CNST_TABLE_REF(((long) 1)));
																	 {
																	    node_t obj_1214;
																	    obj_1214 = sexp__node_235_ast_sexp(obj_1191, stack_4, loc_obj_88_1211, CNST_TABLE_REF(((long) 1)));
																	    {
																	       {
																		  fail_t res2059_2234;
																		  {
																		     type_t type_2221;
																		     type_2221 = (type_t) (__magic__144_type_cache);
																		     {
																			fail_t new1204_2225;
																			new1204_2225 = ((fail_t) BREF(GC_MALLOC(sizeof(struct fail))));
																			{
																			   long arg1982_2226;
																			   arg1982_2226 = class_num_218___object(fail_ast_node);
																			   {
																			      obj_t obj_2232;
																			      obj_2232 = (obj_t) (new1204_2225);
																			      (((obj_t) CREF(obj_2232))->header = MAKE_HEADER(arg1982_2226, 0), BUNSPEC);
																			   }
																			}
																			{
																			   object_t aux_3321;
																			   aux_3321 = (object_t) (new1204_2225);
																			   OBJECT_WIDENING_SET(aux_3321, BFALSE);
																			}
																			((((fail_t) CREF(new1204_2225))->loc) = ((obj_t) loc_1208), BUNSPEC);
																			((((fail_t) CREF(new1204_2225))->type) = ((type_t) type_2221), BUNSPEC);
																			((((fail_t) CREF(new1204_2225))->proc) = ((node_t) proc_1212), BUNSPEC);
																			((((fail_t) CREF(new1204_2225))->msg) = ((node_t) msg_1213), BUNSPEC);
																			((((fail_t) CREF(new1204_2225))->obj) = ((node_t) obj_1214), BUNSPEC);
																			res2059_2234 = new1204_2225;
																		     }
																		  }
																		  aux_3305 = res2059_2234;
																	       }
																	    }
																	 }
																      }
																   }
																}
															     }
															  }
														       }
														       aux_3289 = (obj_t) (aux_3305);
														    }
														  else
														    {
														       node_t aux_3333;
														     tag_528_229_1193:
														       {
															  obj_t arg1789_1219;
															  arg1789_1219 = find_location_loc_243_tools_location(exp_3, loc_5);
															  aux_3333 = error_sexp__node_157_ast_sexp(string2069_ast_sexp, exp_3, arg1789_1219);
														       }
														       aux_3289 = (obj_t) (aux_3333);
														    }
													       }
													     else
													       {
														  node_t aux_3337;
														  goto tag_528_229_1193;
														  aux_3289 = (obj_t) (aux_3337);
													       }
													  }
													else
													  {
													     node_t aux_3339;
													     goto tag_528_229_1193;
													     aux_3289 = (obj_t) (aux_3339);
													  }
												     }
												   else
												     {
													node_t aux_3341;
													goto tag_528_229_1193;
													aux_3289 = (obj_t) (aux_3341);
												     }
												}
											      else
												{
												   node_t aux_3343;
												   goto tag_528_229_1193;
												   aux_3289 = (obj_t) (aux_3343);
												}
											   }
											   return (node_t) (aux_3289);
											}
										      else
											{
											   bool_t test_3346;
											   {
											      obj_t aux_3347;
											      aux_3347 = CNST_TABLE_REF(((long) 22));
											      test_3346 = (car_196_45_702 == aux_3347);
											   }
											   if (test_3346)
											     {
												obj_t aux_3350;
												{
												   obj_t test_1220;
												   obj_t clauses_1221;
												   if (PAIRP(exp_3))
												     {
													obj_t cdr_561_35_1226;
													cdr_561_35_1226 = CDR(exp_3);
													if (PAIRP(cdr_561_35_1226))
													  {
													     test_1220 = CAR(cdr_561_35_1226);
													     clauses_1221 = CDR(cdr_561_35_1226);
													     {
														obj_t loc_1230;
														loc_1230 = find_location_loc_243_tools_location(exp_3, loc_5);
														{
														   node_t test_1231;
														   {
														      obj_t arg1819_1254;
														      obj_t arg1820_1255;
														      arg1819_1254 = find_location_loc_243_tools_location(test_1220, loc_1230);
														      arg1820_1255 = CNST_TABLE_REF(((long) 1));
														      test_1231 = sexp__node_235_ast_sexp(test_1220, stack_4, arg1819_1254, arg1820_1255);
														   }
														   {
														      {
															 obj_t cls_1232;
															 cls_1232 = clauses_1221;
														       loop_1233:
															 if (NULLP(cls_1232))
															   {
															      type_t arg1795_1235;
															      {
																 obj_t aux_3362;
																 {
																    obj_t aux_3363;
																    {
																       obj_t aux_3364;
																       aux_3364 = CAR(clauses_1221);
																       aux_3363 = CAR(aux_3364);
																    }
																    aux_3362 = CAR(aux_3363);
																 }
																 arg1795_1235 = typeof_atom_134_type_typeof(aux_3362);
															      }
															      {
																 select_t res2060_2260;
																 {
																    type_t type_2245;
																    type_2245 = (type_t) (_____74_type_cache);
																    {
																       select_t new1212_2250;
																       new1212_2250 = ((select_t) BREF(GC_MALLOC(sizeof(struct select))));
																       {
																	  long arg1980_2251;
																	  arg1980_2251 = class_num_218___object(select_ast_node);
																	  {
																	     obj_t obj_2258;
																	     obj_2258 = (obj_t) (new1212_2250);
																	     (((obj_t) CREF(obj_2258))->header = MAKE_HEADER(arg1980_2251, 0), BUNSPEC);
																	  }
																       }
																       {
																	  object_t aux_3374;
																	  aux_3374 = (object_t) (new1212_2250);
																	  OBJECT_WIDENING_SET(aux_3374, BFALSE);
																       }
																       ((((select_t) CREF(new1212_2250))->loc) = ((obj_t) loc_1230), BUNSPEC);
																       ((((select_t) CREF(new1212_2250))->type) = ((type_t) type_2245), BUNSPEC);
																       ((((select_t) CREF(new1212_2250))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
																       ((((select_t) CREF(new1212_2250))->test) = ((node_t) test_1231), BUNSPEC);
																       ((((select_t) CREF(new1212_2250))->clauses) = ((obj_t) clauses_1221), BUNSPEC);
																       ((((select_t) CREF(new1212_2250))->item_type_130) = ((type_t) arg1795_1235), BUNSPEC);
																       res2060_2260 = new1212_2250;
																    }
																 }
																 aux_3350 = (obj_t) (res2060_2260);
															      }
															   }
															 else
															   {
															      obj_t clause_1239;
															      clause_1239 = CAR(cls_1232);
															      {
																 node_t arg1800_1240;
																 {
																    obj_t arg1801_1241;
																    obj_t arg1802_1242;
																    obj_t arg1804_1243;
																    arg1801_1241 = normalize_progn_143_tools_progn(CDR(clause_1239));
																    arg1802_1242 = find_location_loc_243_tools_location(clause_1239, loc_1230);
																    arg1804_1243 = CNST_TABLE_REF(((long) 1));
																    arg1800_1240 = sexp__node_235_ast_sexp(arg1801_1241, stack_4, arg1802_1242, arg1804_1243);
																 }
																 {
																    obj_t aux_3390;
																    aux_3390 = (obj_t) (arg1800_1240);
																    SET_CDR(clause_1239, aux_3390);
																 }
															      }
															      {
																 bool_t test_3393;
																 {
																    bool_t test_3394;
																    {
																       obj_t aux_3397;
																       obj_t aux_3395;
																       aux_3397 = CNST_TABLE_REF(((long) 7));
																       aux_3395 = CAR(clause_1239);
																       test_3394 = (aux_3395 == aux_3397);
																    }
																    if (test_3394)
																      {
																	 bool_t test_3400;
																	 {
																	    obj_t aux_3401;
																	    aux_3401 = CDR(cls_1232);
																	    test_3400 = NULLP(aux_3401);
																	 }
																	 if (test_3400)
																	   {
																	      test_3393 = ((bool_t) 0);
																	   }
																	 else
																	   {
																	      test_3393 = ((bool_t) 1);
																	   }
																      }
																    else
																      {
																	 test_3393 = ((bool_t) 0);
																      }
																 }
																 if (test_3393)
																   {
																      obj_t arg1808_1247;
																      arg1808_1247 = find_location_loc_243_tools_location(exp_3, loc_1230);
																      {
																	 node_t aux_3405;
																	 aux_3405 = error_sexp__node_157_ast_sexp(string2068_ast_sexp, arg1808_1247, exp_3);
																	 aux_3350 = (obj_t) (aux_3405);
																      }
																   }
																 else
																   {
																      obj_t cls_3408;
																      cls_3408 = CDR(cls_1232);
																      cls_1232 = cls_3408;
																      goto loop_1233;
																   }
															      }
															   }
														      }
														   }
														}
													     }
													  }
													else
													  {
													     node_t aux_3412;
													   tag_554_132_1223:
													     {
														obj_t arg1822_1257;
														arg1822_1257 = find_location_loc_243_tools_location(exp_3, loc_5);
														aux_3412 = error_sexp__node_157_ast_sexp(string2068_ast_sexp, arg1822_1257, exp_3);
													     }
													     aux_3350 = (obj_t) (aux_3412);
													  }
												     }
												   else
												     {
													node_t aux_3416;
													goto tag_554_132_1223;
													aux_3350 = (obj_t) (aux_3416);
												     }
												}
												return (node_t) (aux_3350);
											     }
											   else
											     {
												bool_t test_3419;
												{
												   obj_t aux_3420;
												   aux_3420 = CNST_TABLE_REF(((long) 23));
												   test_3419 = (car_196_45_702 == aux_3420);
												}
												if (test_3419)
												  {
												     let_fun_218_t aux_3423;
												     aux_3423 = set_exit__node_102_ast_exit(exp_3, stack_4, loc_5, site_6);
												     return (node_t) (aux_3423);
												  }
												else
												  {
												     bool_t test_3426;
												     {
													obj_t aux_3427;
													aux_3427 = CNST_TABLE_REF(((long) 24));
													test_3426 = (car_196_45_702 == aux_3427);
												     }
												     if (test_3426)
												       {
													  jump_ex_it_184_t aux_3430;
													  aux_3430 = jump_exit__node_34_ast_exit(exp_3, stack_4, loc_5, site_6);
													  return (node_t) (aux_3430);
												       }
												     else
												       {
													  bool_t test_3433;
													  {
													     obj_t aux_3434;
													     aux_3434 = CNST_TABLE_REF(((long) 25));
													     test_3433 = (car_196_45_702 == aux_3434);
													  }
													  if (test_3433)
													    {
													       return applycation__node_122_ast_apply(exp_3, stack_4, loc_5, site_6);
													    }
													  else
													    {
													       goto tag_141_241_690;
													    }
												       }
												  }
											     }
											}
										   }
									      }
									 }
								    }
							       }
							  }
						     }
						}
					   }
				      }
				 }
			    }
		       }
		  }
		else
		  {
		     obj_t aux_3438;
		     atom_664 = exp_3;
		     if (SYMBOLP(atom_664))
		       {
			  bool_t test1408_792;
			  {
			     obj_t aux_3441;
			     aux_3441 = lookup_ast_sexp(atom_664, stack_4);
			     test1408_792 = CBOOL(aux_3441);
			  }
			  if (test1408_792)
			    {
			       {
				  obj_t local_793;
				  local_793 = lookup_ast_sexp(atom_664, stack_4);
				  {
				     obj_t var_794;
				     {
					bool_t test1409_795;
					{
					   bool_t test_3446;
					   {
					      obj_t aux_3447;
					      aux_3447 = CNST_TABLE_REF(((long) 15));
					      test_3446 = (site_6 == aux_3447);
					   }
					   if (test_3446)
					     {
						test1409_795 = ((bool_t) 0);
					     }
					   else
					     {
						obj_t aux_3450;
						{
						   value_t aux_3451;
						   {
						      local_t obj_1821;
						      obj_1821 = (local_t) (local_793);
						      aux_3451 = (((local_t) CREF(obj_1821))->value);
						   }
						   aux_3450 = (obj_t) (aux_3451);
						}
						test1409_795 = is_a__118___object(aux_3450, fun_ast_var);
					     }
					}
					if (test1409_795)
					  {
					     type_t arg1410_796;
					     {
						local_t obj_1823;
						obj_1823 = (local_t) (local_793);
						arg1410_796 = (((local_t) CREF(obj_1823))->type);
					     }
					     {
						closure_t res2042_1834;
						{
						   variable_t variable_1826;
						   variable_1826 = (variable_t) (local_793);
						   {
						      closure_t new1134_1827;
						      new1134_1827 = ((closure_t) BREF(GC_MALLOC(sizeof(struct closure))));
						      {
							 long arg2004_1828;
							 arg2004_1828 = class_num_218___object(closure_ast_node);
							 {
							    obj_t obj_1832;
							    obj_1832 = (obj_t) (new1134_1827);
							    (((obj_t) CREF(obj_1832))->header = MAKE_HEADER(arg2004_1828, 0), BUNSPEC);
							 }
						      }
						      {
							 object_t aux_3464;
							 aux_3464 = (object_t) (new1134_1827);
							 OBJECT_WIDENING_SET(aux_3464, BFALSE);
						      }
						      ((((closure_t) CREF(new1134_1827))->loc) = ((obj_t) loc_5), BUNSPEC);
						      ((((closure_t) CREF(new1134_1827))->type) = ((type_t) arg1410_796), BUNSPEC);
						      ((((closure_t) CREF(new1134_1827))->variable) = ((variable_t) variable_1826), BUNSPEC);
						      res2042_1834 = new1134_1827;
						   }
						}
						var_794 = (obj_t) (res2042_1834);
					     }
					  }
					else
					  {
					     type_t arg1411_797;
					     {
						local_t obj_1835;
						obj_1835 = (local_t) (local_793);
						arg1411_797 = (((local_t) CREF(obj_1835))->type);
					     }
					     {
						var_t res2043_1846;
						{
						   variable_t variable_1838;
						   variable_1838 = (variable_t) (local_793);
						   {
						      var_t new1128_1839;
						      new1128_1839 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
						      {
							 long arg2006_1840;
							 arg2006_1840 = class_num_218___object(var_ast_node);
							 {
							    obj_t obj_1844;
							    obj_1844 = (obj_t) (new1128_1839);
							    (((obj_t) CREF(obj_1844))->header = MAKE_HEADER(arg2006_1840, 0), BUNSPEC);
							 }
						      }
						      {
							 object_t aux_3478;
							 aux_3478 = (object_t) (new1128_1839);
							 OBJECT_WIDENING_SET(aux_3478, BFALSE);
						      }
						      ((((var_t) CREF(new1128_1839))->loc) = ((obj_t) loc_5), BUNSPEC);
						      ((((var_t) CREF(new1128_1839))->type) = ((type_t) arg1411_797), BUNSPEC);
						      ((((var_t) CREF(new1128_1839))->variable) = ((variable_t) variable_1838), BUNSPEC);
						      res2043_1846 = new1128_1839;
						   }
						}
						var_794 = (obj_t) (res2043_1846);
					     }
					  }
				     }
				     {
					use_variable__4_ast_sexp((variable_t) (local_793), loc_5, site_6);
					aux_3438 = var_794;
				     }
				  }
			       }
			    }
			  else
			    {
			       {
				  obj_t global_801;
				  global_801 = find_global_223_ast_env(atom_664, BNIL);
				  {
				     bool_t test1416_802;
				     test1416_802 = is_a__118___object(global_801, global_ast_var);
				     if (test1416_802)
				       {
					  bool_t test_3490;
					  {
					     obj_t aux_3494;
					     obj_t aux_3491;
					     aux_3494 = CNST_TABLE_REF(((long) 14));
					     {
						global_t obj_1848;
						obj_1848 = (global_t) (global_801);
						aux_3491 = (((global_t) CREF(obj_1848))->import);
					     }
					     test_3490 = (aux_3491 == aux_3494);
					  }
					  if (test_3490)
					    {
					       {
						  obj_t arg1418_804;
						  {
						     obj_t arg1420_805;
						     obj_t arg1421_806;
						     arg1420_805 = CNST_TABLE_REF(((long) 14));
						     {
							obj_t arg1428_811;
							arg1428_811 = CNST_TABLE_REF(((long) 17));
							{
							   obj_t list1432_813;
							   {
							      obj_t arg1440_814;
							      arg1440_814 = MAKE_PAIR(BNIL, BNIL);
							      list1432_813 = MAKE_PAIR(atom_664, arg1440_814);
							   }
							   arg1421_806 = cons__138___r4_pairs_and_lists_6_3(arg1428_811, list1432_813);
							}
						     }
						     {
							obj_t list1425_808;
							{
							   obj_t arg1426_809;
							   arg1426_809 = MAKE_PAIR(BNIL, BNIL);
							   list1425_808 = MAKE_PAIR(arg1421_806, arg1426_809);
							}
							arg1418_804 = cons__138___r4_pairs_and_lists_6_3(arg1420_805, list1425_808);
						     }
						  }
						  {
						     node_t aux_3505;
						     aux_3505 = sexp__node_235_ast_sexp(arg1418_804, stack_4, loc_5, site_6);
						     aux_3438 = (obj_t) (aux_3505);
						  }
					       }
					    }
					  else
					    {
					       use_variable__4_ast_sexp((variable_t) (global_801), loc_5, site_6);
					       {
						  bool_t test1442_816;
						  {
						     bool_t test_3510;
						     {
							obj_t aux_3511;
							aux_3511 = CNST_TABLE_REF(((long) 15));
							test_3510 = (site_6 == aux_3511);
						     }
						     if (test_3510)
						       {
							  test1442_816 = ((bool_t) 0);
						       }
						     else
						       {
							  obj_t aux_3514;
							  {
							     value_t aux_3515;
							     {
								global_t obj_1853;
								obj_1853 = (global_t) (global_801);
								aux_3515 = (((global_t) CREF(obj_1853))->value);
							     }
							     aux_3514 = (obj_t) (aux_3515);
							  }
							  test1442_816 = is_a__118___object(aux_3514, fun_ast_var);
						       }
						  }
						  if (test1442_816)
						    {
						       type_t arg1444_817;
						       {
							  global_t obj_1855;
							  obj_1855 = (global_t) (global_801);
							  arg1444_817 = (((global_t) CREF(obj_1855))->type);
						       }
						       {
							  closure_t res2044_1866;
							  {
							     variable_t variable_1858;
							     variable_1858 = (variable_t) (global_801);
							     {
								closure_t new1134_1859;
								new1134_1859 = ((closure_t) BREF(GC_MALLOC(sizeof(struct closure))));
								{
								   long arg2004_1860;
								   arg2004_1860 = class_num_218___object(closure_ast_node);
								   {
								      obj_t obj_1864;
								      obj_1864 = (obj_t) (new1134_1859);
								      (((obj_t) CREF(obj_1864))->header = MAKE_HEADER(arg2004_1860, 0), BUNSPEC);
								   }
								}
								{
								   object_t aux_3528;
								   aux_3528 = (object_t) (new1134_1859);
								   OBJECT_WIDENING_SET(aux_3528, BFALSE);
								}
								((((closure_t) CREF(new1134_1859))->loc) = ((obj_t) loc_5), BUNSPEC);
								((((closure_t) CREF(new1134_1859))->type) = ((type_t) arg1444_817), BUNSPEC);
								((((closure_t) CREF(new1134_1859))->variable) = ((variable_t) variable_1858), BUNSPEC);
								res2044_1866 = new1134_1859;
							     }
							  }
							  aux_3438 = (obj_t) (res2044_1866);
						       }
						    }
						  else
						    {
						       type_t arg1445_818;
						       {
							  global_t obj_1867;
							  obj_1867 = (global_t) (global_801);
							  arg1445_818 = (((global_t) CREF(obj_1867))->type);
						       }
						       {
							  var_t res2045_1878;
							  {
							     variable_t variable_1870;
							     variable_1870 = (variable_t) (global_801);
							     {
								var_t new1128_1871;
								new1128_1871 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
								{
								   long arg2006_1872;
								   arg2006_1872 = class_num_218___object(var_ast_node);
								   {
								      obj_t obj_1876;
								      obj_1876 = (obj_t) (new1128_1871);
								      (((obj_t) CREF(obj_1876))->header = MAKE_HEADER(arg2006_1872, 0), BUNSPEC);
								   }
								}
								{
								   object_t aux_3542;
								   aux_3542 = (object_t) (new1128_1871);
								   OBJECT_WIDENING_SET(aux_3542, BFALSE);
								}
								((((var_t) CREF(new1128_1871))->loc) = ((obj_t) loc_5), BUNSPEC);
								((((var_t) CREF(new1128_1871))->type) = ((type_t) arg1445_818), BUNSPEC);
								((((var_t) CREF(new1128_1871))->variable) = ((variable_t) variable_1870), BUNSPEC);
								res2045_1878 = new1128_1871;
							     }
							  }
							  aux_3438 = (obj_t) (res2045_1878);
						       }
						    }
					       }
					    }
				       }
				     else
				       {
					  {
					     node_t aux_3549;
					     aux_3549 = error_sexp__node_157_ast_sexp(string2077_ast_sexp, exp_3, loc_5);
					     aux_3438 = (obj_t) (aux_3549);
					  }
				       }
				  }
			       }
			    }
		       }
		     else
		       {
			  {
			     bool_t test1452_825;
			     {
				bool_t test1468_836;
				test1468_836 = is_a__118___object(atom_664, local_ast_var);
				if (test1468_836)
				  {
				     test1452_825 = ((bool_t) 1);
				  }
				else
				  {
				     test1452_825 = is_a__118___object(atom_664, global_ast_var);
				  }
			     }
			     if (test1452_825)
			       {
				  use_variable__4_ast_sexp((variable_t) (atom_664), loc_5, site_6);
				  {
				     bool_t test1453_826;
				     {
					bool_t test_3558;
					{
					   obj_t aux_3559;
					   aux_3559 = CNST_TABLE_REF(((long) 15));
					   test_3558 = (site_6 == aux_3559);
					}
					if (test_3558)
					  {
					     test1453_826 = ((bool_t) 0);
					  }
					else
					  {
					     obj_t aux_3562;
					     {
						value_t aux_3563;
						{
						   variable_t obj_1883;
						   obj_1883 = (variable_t) (atom_664);
						   aux_3563 = (((variable_t) CREF(obj_1883))->value);
						}
						aux_3562 = (obj_t) (aux_3563);
					     }
					     test1453_826 = is_a__118___object(aux_3562, fun_ast_var);
					  }
				     }
				     if (test1453_826)
				       {
					  type_t arg1454_827;
					  {
					     variable_t obj_1885;
					     obj_1885 = (variable_t) (atom_664);
					     arg1454_827 = (((variable_t) CREF(obj_1885))->type);
					  }
					  {
					     closure_t res2046_1896;
					     {
						variable_t variable_1888;
						variable_1888 = (variable_t) (atom_664);
						{
						   closure_t new1134_1889;
						   new1134_1889 = ((closure_t) BREF(GC_MALLOC(sizeof(struct closure))));
						   {
						      long arg2004_1890;
						      arg2004_1890 = class_num_218___object(closure_ast_node);
						      {
							 obj_t obj_1894;
							 obj_1894 = (obj_t) (new1134_1889);
							 (((obj_t) CREF(obj_1894))->header = MAKE_HEADER(arg2004_1890, 0), BUNSPEC);
						      }
						   }
						   {
						      object_t aux_3576;
						      aux_3576 = (object_t) (new1134_1889);
						      OBJECT_WIDENING_SET(aux_3576, BFALSE);
						   }
						   ((((closure_t) CREF(new1134_1889))->loc) = ((obj_t) loc_5), BUNSPEC);
						   ((((closure_t) CREF(new1134_1889))->type) = ((type_t) arg1454_827), BUNSPEC);
						   ((((closure_t) CREF(new1134_1889))->variable) = ((variable_t) variable_1888), BUNSPEC);
						   res2046_1896 = new1134_1889;
						}
					     }
					     aux_3438 = (obj_t) (res2046_1896);
					  }
				       }
				     else
				       {
					  type_t arg1457_828;
					  {
					     variable_t obj_1897;
					     obj_1897 = (variable_t) (atom_664);
					     arg1457_828 = (((variable_t) CREF(obj_1897))->type);
					  }
					  {
					     var_t res2047_1908;
					     {
						variable_t variable_1900;
						variable_1900 = (variable_t) (atom_664);
						{
						   var_t new1128_1901;
						   new1128_1901 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
						   {
						      long arg2006_1902;
						      arg2006_1902 = class_num_218___object(var_ast_node);
						      {
							 obj_t obj_1906;
							 obj_1906 = (obj_t) (new1128_1901);
							 (((obj_t) CREF(obj_1906))->header = MAKE_HEADER(arg2006_1902, 0), BUNSPEC);
						      }
						   }
						   {
						      object_t aux_3590;
						      aux_3590 = (object_t) (new1128_1901);
						      OBJECT_WIDENING_SET(aux_3590, BFALSE);
						   }
						   ((((var_t) CREF(new1128_1901))->loc) = ((obj_t) loc_5), BUNSPEC);
						   ((((var_t) CREF(new1128_1901))->type) = ((type_t) arg1457_828), BUNSPEC);
						   ((((var_t) CREF(new1128_1901))->variable) = ((variable_t) variable_1900), BUNSPEC);
						   res2047_1908 = new1128_1901;
						}
					     }
					     aux_3438 = (obj_t) (res2047_1908);
					  }
				       }
				  }
			       }
			     else
			       {
				  bool_t test1464_832;
				  if (STRUCTP(atom_664))
				    {
				       test1464_832 = ((bool_t) 1);
				    }
				  else
				    {
				       if (VECTORP(atom_664))
					 {
					    test1464_832 = ((bool_t) 1);
					 }
				       else
					 {
					    test1464_832 = (POINTERP(atom_664) && (TYPE(atom_664) >= OBJECT_TYPE));
					 }
				    }
				  if (test1464_832)
				    {
				       {
					  node_t aux_3603;
					  aux_3603 = error_sexp__node_157_ast_sexp(string2078_ast_sexp, exp_3, loc_5);
					  aux_3438 = (obj_t) (aux_3603);
				       }
				    }
				  else
				    {
				       {
					  type_t arg1465_833;
					  arg1465_833 = typeof_atom_134_type_typeof(atom_664);
					  {
					     atom_t res2048_1922;
					     {
						atom_t new1122_1915;
						new1122_1915 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
						{
						   long arg2008_1916;
						   arg2008_1916 = class_num_218___object(atom_ast_node);
						   {
						      obj_t obj_1920;
						      obj_1920 = (obj_t) (new1122_1915);
						      (((obj_t) CREF(obj_1920))->header = MAKE_HEADER(arg2008_1916, 0), BUNSPEC);
						   }
						}
						{
						   object_t aux_3611;
						   aux_3611 = (object_t) (new1122_1915);
						   OBJECT_WIDENING_SET(aux_3611, BFALSE);
						}
						((((atom_t) CREF(new1122_1915))->loc) = ((obj_t) loc_5), BUNSPEC);
						((((atom_t) CREF(new1122_1915))->type) = ((type_t) arg1465_833), BUNSPEC);
						((((atom_t) CREF(new1122_1915))->value) = ((obj_t) atom_664), BUNSPEC);
						res2048_1922 = new1122_1915;
					     }
					     aux_3438 = (obj_t) (res2048_1922);
					  }
				       }
				    }
			       }
			  }
		       }
		     return (node_t) (aux_3438);
		  }
	     }
	}
   }
}


obj_t 
liip_ast_sexp(obj_t args_1134)
{
   if (NULLP(args_1134))
     {
	return CNST_TABLE_REF(((long) 26));
     }
   else
     {
	obj_t arg1722_1137;
	obj_t arg1724_1138;
	obj_t arg1725_1139;
	arg1722_1137 = CNST_TABLE_REF(((long) 27));
	arg1724_1138 = CAR(args_1134);
	arg1725_1139 = liip_ast_sexp(CDR(args_1134));
	{
	   obj_t list1731_1141;
	   {
	      obj_t arg1732_1142;
	      {
		 obj_t arg1733_1143;
		 arg1733_1143 = MAKE_PAIR(BNIL, BNIL);
		 arg1732_1142 = MAKE_PAIR(arg1725_1139, arg1733_1143);
	      }
	      list1731_1141 = MAKE_PAIR(arg1724_1138, arg1732_1142);
	   }
	   return cons__138___r4_pairs_and_lists_6_3(arg1722_1137, list1731_1141);
	}
     }
}


obj_t 
loop_ast_sexp(obj_t exp_2492, obj_t loc_2491, obj_t vars_1092, obj_t args_1093)
{
 loop_ast_sexp:
   if (NULLP(vars_1092))
     {
	if (NULLP(args_1093))
	  {
	     return BNIL;
	  }
	else
	  {
	     obj_t arg1682_1097;
	     {
		obj_t arg1686_1100;
		arg1686_1100 = current_function_76_tools_error();
		arg1682_1097 = shape_tools_shape(arg1686_1100);
	     }
	     return user_error_location_137_tools_error(loc_2491, arg1682_1097, string2080_ast_sexp, exp_2492, BNIL);
	  }
     }
   else
     {
	if (PAIRP(vars_1092))
	  {
	     bool_t test1688_1102;
	     {
		obj_t aux_3639;
		aux_3639 = dsssl_named_constant__188_tools_dsssl(CAR(vars_1092));
		test1688_1102 = CBOOL(aux_3639);
	     }
	     if (test1688_1102)
	       {
		  {
		     obj_t arg_1103;
		     arg_1103 = dsssl_find_first_formal_237_tools_dsssl(CDR(vars_1092));
		     if (CBOOL(arg_1103))
		       {
			  obj_t vars_3648;
			  vars_3648 = arg_1103;
			  vars_1092 = vars_3648;
			  goto loop_ast_sexp;
		       }
		     else
		       {
			  obj_t vars_3649;
			  vars_3649 = BNIL;
			  vars_1092 = vars_3649;
			  goto loop_ast_sexp;
		       }
		  }
	       }
	     else
	       {
		  bool_t test_3650;
		  {
		     obj_t aux_3651;
		     aux_3651 = CAR(vars_1092);
		     test_3650 = SYMBOLP(aux_3651);
		  }
		  if (test_3650)
		    {
		       if (NULLP(args_1093))
			 {
			    {
			       obj_t arg1693_1108;
			       {
				  obj_t arg1696_1111;
				  arg1696_1111 = current_function_76_tools_error();
				  arg1693_1108 = shape_tools_shape(arg1696_1111);
			       }
			       return user_error_location_137_tools_error(loc_2491, arg1693_1108, string2080_ast_sexp, exp_2492, BNIL);
			    }
			 }
		       else
			 {
			    {
			       obj_t arg1697_1112;
			       obj_t arg1698_1113;
			       {
				  obj_t arg1699_1114;
				  arg1699_1114 = CAR(vars_1092);
				  {
				     obj_t list1702_1116;
				     {
					obj_t arg1703_1117;
					{
					   obj_t aux_3660;
					   aux_3660 = CAR(args_1093);
					   arg1703_1117 = MAKE_PAIR(aux_3660, BNIL);
					}
					list1702_1116 = MAKE_PAIR(arg1699_1114, arg1703_1117);
				     }
				     arg1697_1112 = list1702_1116;
				  }
			       }
			       arg1698_1113 = loop_ast_sexp(exp_2492, loc_2491, CDR(vars_1092), CDR(args_1093));
			       return MAKE_PAIR(arg1697_1112, arg1698_1113);
			    }
			 }
		    }
		  else
		    {
		       {
			  obj_t arg1707_1121;
			  {
			     obj_t arg1710_1124;
			     arg1710_1124 = current_function_76_tools_error();
			     arg1707_1121 = shape_tools_shape(arg1710_1124);
			  }
			  return user_error_location_137_tools_error(loc_2491, arg1707_1121, string2081_ast_sexp, exp_2492, BNIL);
		       }
		    }
	       }
	  }
	else
	  {
	     {
		obj_t arg1714_1127;
		{
		   obj_t arg1717_1130;
		   arg1717_1130 = liip_ast_sexp(args_1093);
		   {
		      obj_t list1718_1131;
		      {
			 obj_t arg1719_1132;
			 arg1719_1132 = MAKE_PAIR(arg1717_1130, BNIL);
			 list1718_1131 = MAKE_PAIR(vars_1092, arg1719_1132);
		      }
		      arg1714_1127 = list1718_1131;
		   }
		}
		{
		   obj_t list1715_1128;
		   list1715_1128 = MAKE_PAIR(arg1714_1127, BNIL);
		   return list1715_1128;
		}
	     }
	  }
     }
}


obj_t 
_sexp__node_67_ast_sexp(obj_t env_2466, obj_t exp_2467, obj_t stack_2468, obj_t loc_2469, obj_t site_2470)
{
   {
      node_t aux_3675;
      aux_3675 = sexp__node_235_ast_sexp(exp_2467, stack_2468, loc_2469, site_2470);
      return (obj_t) (aux_3675);
   }
}


obj_t 
arg17382065_ast_sexp(obj_t env_2471, obj_t obj_2473, obj_t proc_2474, obj_t msg_2475)
{
   {
      obj_t loc_2472;
      loc_2472 = PROCEDURE_REF(env_2471, ((long) 0));
      {
	 obj_t obj_1150;
	 obj_t proc_1151;
	 obj_t msg_1152;
	 obj_1150 = obj_2473;
	 proc_1151 = proc_2474;
	 msg_1152 = msg_2475;
	 return user_error_location_137_tools_error(loc_2472, obj_1150, proc_1151, msg_1152, BNIL);
      }
   }
}


obj_t 
sexp___node_160_ast_sexp(obj_t exp__153_7, obj_t stack_8, obj_t loc_9, obj_t site_10)
{
   {
      obj_t exps_1309;
      obj_t res_1310;
      exps_1309 = exp__153_7;
      res_1310 = BNIL;
    loop_1311:
      if (NULLP(exps_1309))
	{
	   {
	      node_t aux_3682;
	      aux_3682 = error_sexp__node_157_ast_sexp(string2082_ast_sexp, exps_1309, loc_9);
	      return (obj_t) (aux_3682);
	   }
	}
      else
	{
	   bool_t test_3685;
	   {
	      obj_t aux_3686;
	      aux_3686 = CDR(exps_1309);
	      test_3685 = NULLP(aux_3686);
	   }
	   if (test_3685)
	     {
		{
		   obj_t loc_1315;
		   loc_1315 = find_location_loc_243_tools_location(CAR(exps_1309), loc_9);
		   {
		      obj_t arg1865_1316;
		      {
			 node_t arg1866_1317;
			 arg1866_1317 = sexp__node_235_ast_sexp(CAR(exps_1309), stack_8, loc_1315, site_10);
			 {
			    obj_t aux_3693;
			    aux_3693 = (obj_t) (arg1866_1317);
			    arg1865_1316 = MAKE_PAIR(aux_3693, res_1310);
			 }
		      }
		      return reverse__39___r4_pairs_and_lists_6_3(arg1865_1316);
		   }
		}
	     }
	   else
	     {
		{
		   obj_t loc_1320;
		   loc_1320 = find_location_loc_243_tools_location(CAR(exps_1309), loc_9);
		   {
		      obj_t arg1871_1321;
		      obj_t arg1872_1322;
		      arg1871_1321 = CDR(exps_1309);
		      {
			 node_t arg1874_1323;
			 arg1874_1323 = sexp__node_235_ast_sexp(CAR(exps_1309), stack_8, loc_1320, CNST_TABLE_REF(((long) 1)));
			 {
			    obj_t aux_3703;
			    aux_3703 = (obj_t) (arg1874_1323);
			    arg1872_1322 = MAKE_PAIR(aux_3703, res_1310);
			 }
		      }
		      {
			 obj_t res_3707;
			 obj_t exps_3706;
			 exps_3706 = arg1871_1321;
			 res_3707 = arg1872_1322;
			 res_1310 = res_3707;
			 exps_1309 = exps_3706;
			 goto loop_1311;
		      }
		   }
		}
	     }
	}
   }
}


obj_t 
lookup_ast_sexp(obj_t name_11, obj_t stack_12)
{
   {
      bool_t test1880_1328;
      {
	 bool_t test1886_1336;
	 {
	    obj_t obj2_2300;
	    obj2_2300 = __cache_name__178_ast_sexp;
	    test1886_1336 = (name_11 == obj2_2300);
	 }
	 if (test1886_1336)
	   {
	      obj_t obj2_2302;
	      obj2_2302 = __cache_stack__44_ast_sexp;
	      test1880_1328 = (stack_12 == obj2_2302);
	   }
	 else
	   {
	      test1880_1328 = ((bool_t) 0);
	   }
      }
      if (test1880_1328)
	{
	   return __cache_res__50_ast_sexp;
	}
      else
	{
	   __cache_name__178_ast_sexp = name_11;
	   __cache_stack__44_ast_sexp = stack_12;
	   {
	      obj_t stack_1329;
	      stack_1329 = stack_12;
	    loop_1330:
	      if (NULLP(stack_1329))
		{
		   __cache_res__50_ast_sexp = BFALSE;
		   return BFALSE;
		}
	      else
		{
		   bool_t test_3714;
		   {
		      obj_t aux_3715;
		      {
			 local_t obj_2305;
			 {
			    obj_t aux_3716;
			    aux_3716 = CAR(stack_1329);
			    obj_2305 = (local_t) (aux_3716);
			 }
			 aux_3715 = (((local_t) CREF(obj_2305))->id);
		      }
		      test_3714 = (aux_3715 == name_11);
		   }
		   if (test_3714)
		     {
			__cache_res__50_ast_sexp = CAR(stack_1329);
			return CAR(stack_1329);
		     }
		   else
		     {
			{
			   obj_t stack_3723;
			   stack_3723 = CDR(stack_1329);
			   stack_1329 = stack_3723;
			   goto loop_1330;
			}
		     }
		}
	   }
	}
   }
}


obj_t 
use_variable__4_ast_sexp(variable_t var_13, obj_t loc_14, obj_t site_15)
{
   {
      bool_t test_3725;
      {
	 obj_t aux_3726;
	 aux_3726 = CNST_TABLE_REF(((long) 9));
	 test_3725 = (site_15 == aux_3726);
      }
      if (test_3725)
	{
	   obj_t arg1889_1338;
	   arg1889_1338 = CNST_TABLE_REF(((long) 28));
	   {
	      obj_t res2061_2315;
	      {
		 obj_t x_2494;
		 x_2494 = ((((variable_t) CREF(var_13))->access) = ((obj_t) arg1889_1338), BUNSPEC);
		 res2061_2315 = BUNSPEC;
	      }
	      res2061_2315;
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test1891_1341;
      {
	 bool_t test_3731;
	 {
	    obj_t aux_3732;
	    aux_3732 = CNST_TABLE_REF(((long) 9));
	    test_3731 = (site_15 == aux_3732);
	 }
	 if (test_3731)
	   {
	      obj_t aux_3735;
	      {
		 value_t aux_3736;
		 aux_3736 = (((variable_t) CREF(var_13))->value);
		 aux_3735 = (obj_t) (aux_3736);
	      }
	      test1891_1341 = is_a__118___object(aux_3735, fun_ast_var);
	   }
	 else
	   {
	      test1891_1341 = ((bool_t) 0);
	   }
      }
      if (test1891_1341)
	{
	   obj_t arg1893_1343;
	   arg1893_1343 = shape_tools_shape((obj_t) (var_13));
	   {
	      node_t aux_3743;
	      aux_3743 = error_sexp__node_157_ast_sexp(string2083_ast_sexp, arg1893_1343, loc_14);
	      return (obj_t) (aux_3743);
	   }
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_use_variable__22_ast_sexp(obj_t env_2476, obj_t var_2477, obj_t loc_2478, obj_t site_2479)
{
   return use_variable__4_ast_sexp((variable_t) (var_2477), loc_2478, site_2479);
}


node_t 
error_sexp__node_157_ast_sexp(obj_t msg_16, obj_t exp_17, obj_t loc_18)
{
   {
      obj_t arg1896_1346;
      node_t arg1897_1347;
      {
	 obj_t arg1900_1350;
	 arg1900_1350 = current_function_76_tools_error();
	 arg1896_1346 = shape_tools_shape(arg1900_1350);
      }
      arg1897_1347 = sexp__node_235_ast_sexp(CNST_TABLE_REF(((long) 26)), BNIL, loc_18, CNST_TABLE_REF(((long) 1)));
      {
	 obj_t list1898_1348;
	 {
	    obj_t aux_3753;
	    aux_3753 = (obj_t) (arg1897_1347);
	    list1898_1348 = MAKE_PAIR(aux_3753, BNIL);
	 }
	 {
	    obj_t aux_3756;
	    aux_3756 = user_error_location_137_tools_error(loc_18, arg1896_1346, msg_16, exp_17, list1898_1348);
	    return (node_t) (aux_3756);
	 }
      }
   }
}


obj_t 
_error_sexp__node_111_ast_sexp(obj_t env_2480, obj_t msg_2481, obj_t exp_2482, obj_t loc_2483)
{
   {
      node_t aux_3759;
      aux_3759 = error_sexp__node_157_ast_sexp(msg_2481, exp_2482, loc_2483);
      return (obj_t) (aux_3759);
   }
}


node_t 
define_primop_ref__node_164_ast_sexp(global_t global_19, node_t ref_20)
{
   {
      node_t fun_1354;
      fun_1354 = sexp__node_235_ast_sexp(CNST_TABLE_REF(((long) 29)), BNIL, BFALSE, CNST_TABLE_REF(((long) 15)));
      {
	 bool_t test1905_1355;
	 test1905_1355 = is_a__118___object((obj_t) (fun_1354), var_ast_node);
	 if (test1905_1355)
	   {
	      obj_t arg1906_1356;
	      {
		 node_t arg1907_1357;
		 {
		    obj_t arg1912_1361;
		    obj_t arg1914_1363;
		    {
		       obj_t arg1915_1364;
		       obj_t arg1916_1365;
		       arg1915_1364 = CNST_TABLE_REF(((long) 17));
		       arg1916_1365 = (((global_t) CREF(global_19))->id);
		       {
			  obj_t list1918_1367;
			  {
			     obj_t arg1921_1368;
			     arg1921_1368 = MAKE_PAIR(BNIL, BNIL);
			     list1918_1367 = MAKE_PAIR(arg1916_1365, arg1921_1368);
			  }
			  arg1912_1361 = cons__138___r4_pairs_and_lists_6_3(arg1915_1364, list1918_1367);
		       }
		    }
		    arg1914_1363 = CNST_TABLE_REF(((long) 1));
		    arg1907_1357 = sexp__node_235_ast_sexp(arg1912_1361, BNIL, BFALSE, arg1914_1363);
		 }
		 {
		    obj_t list1908_1358;
		    {
		       obj_t arg1909_1359;
		       {
			  obj_t aux_3775;
			  aux_3775 = (obj_t) (ref_20);
			  arg1909_1359 = MAKE_PAIR(aux_3775, BNIL);
		       }
		       {
			  obj_t aux_3778;
			  aux_3778 = (obj_t) (arg1907_1357);
			  list1908_1358 = MAKE_PAIR(aux_3778, arg1909_1359);
		       }
		    }
		    arg1906_1356 = list1908_1358;
		 }
	      }
	      {
		 app_t res2062_2339;
		 {
		    obj_t loc_2323;
		    type_t type_2324;
		    var_t fun_2326;
		    loc_2323 = BFALSE;
		    type_2324 = (type_t) (_____74_type_cache);
		    fun_2326 = (var_t) (fun_1354);
		    {
		       app_t new1151_2329;
		       new1151_2329 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
		       {
			  long arg1998_2330;
			  arg1998_2330 = class_num_218___object(app_ast_node);
			  {
			     obj_t obj_2337;
			     obj_2337 = (obj_t) (new1151_2329);
			     (((obj_t) CREF(obj_2337))->header = MAKE_HEADER(arg1998_2330, 0), BUNSPEC);
			  }
		       }
		       {
			  object_t aux_3787;
			  aux_3787 = (object_t) (new1151_2329);
			  OBJECT_WIDENING_SET(aux_3787, loc_2323);
		       }
		       ((((app_t) CREF(new1151_2329))->loc) = ((obj_t) loc_2323), BUNSPEC);
		       ((((app_t) CREF(new1151_2329))->type) = ((type_t) type_2324), BUNSPEC);
		       ((((app_t) CREF(new1151_2329))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		       ((((app_t) CREF(new1151_2329))->fun) = ((var_t) fun_2326), BUNSPEC);
		       ((((app_t) CREF(new1151_2329))->args) = ((obj_t) arg1906_1356), BUNSPEC);
		       ((((app_t) CREF(new1151_2329))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
		       res2062_2339 = new1151_2329;
		    }
		 }
		 return (node_t) (res2062_2339);
	      }
	   }
	 else
	   {
	      return fun_1354;
	   }
      }
   }
}


obj_t 
_define_primop_ref__node_178_ast_sexp(obj_t env_2484, obj_t global_2485, obj_t ref_2486)
{
   {
      node_t aux_3797;
      aux_3797 = define_primop_ref__node_164_ast_sexp((global_t) (global_2485), (node_t) (ref_2486));
      return (obj_t) (aux_3797);
   }
}


node_t 
define_primop__node_141_ast_sexp(global_t global_21)
{
   use_variable__4_ast_sexp((variable_t) (global_21), BFALSE, CNST_TABLE_REF(((long) 1)));
   {
      node_t fun_1374;
      fun_1374 = sexp__node_235_ast_sexp(CNST_TABLE_REF(((long) 30)), BNIL, BFALSE, CNST_TABLE_REF(((long) 15)));
      {
	 bool_t test1928_1375;
	 test1928_1375 = is_a__118___object((obj_t) (fun_1374), var_ast_node);
	 if (test1928_1375)
	   {
	      obj_t arg1929_1376;
	      {
		 node_t arg1931_1377;
		 node_t arg1932_1378;
		 {
		    obj_t arg1936_1382;
		    obj_t arg1938_1384;
		    {
		       obj_t arg1939_1385;
		       obj_t arg1940_1386;
		       arg1939_1385 = CNST_TABLE_REF(((long) 17));
		       arg1940_1386 = (((global_t) CREF(global_21))->id);
		       {
			  obj_t list1942_1388;
			  {
			     obj_t arg1943_1389;
			     arg1943_1389 = MAKE_PAIR(BNIL, BNIL);
			     list1942_1388 = MAKE_PAIR(arg1940_1386, arg1943_1389);
			  }
			  arg1936_1382 = cons__138___r4_pairs_and_lists_6_3(arg1939_1385, list1942_1388);
		       }
		    }
		    arg1938_1384 = CNST_TABLE_REF(((long) 1));
		    arg1931_1377 = sexp__node_235_ast_sexp(arg1936_1382, BNIL, BFALSE, arg1938_1384);
		 }
		 arg1932_1378 = sexp__node_235_ast_sexp((obj_t) (global_21), BNIL, BFALSE, CNST_TABLE_REF(((long) 1)));
		 {
		    obj_t list1933_1379;
		    {
		       obj_t arg1934_1380;
		       {
			  obj_t aux_3821;
			  aux_3821 = (obj_t) (arg1932_1378);
			  arg1934_1380 = MAKE_PAIR(aux_3821, BNIL);
		       }
		       {
			  obj_t aux_3824;
			  aux_3824 = (obj_t) (arg1931_1377);
			  list1933_1379 = MAKE_PAIR(aux_3824, arg1934_1380);
		       }
		    }
		    arg1929_1376 = list1933_1379;
		 }
	      }
	      {
		 app_t res2063_2359;
		 {
		    obj_t loc_2343;
		    type_t type_2344;
		    var_t fun_2346;
		    loc_2343 = BFALSE;
		    type_2344 = (type_t) (_____74_type_cache);
		    fun_2346 = (var_t) (fun_1374);
		    {
		       app_t new1151_2349;
		       new1151_2349 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
		       {
			  long arg1998_2350;
			  arg1998_2350 = class_num_218___object(app_ast_node);
			  {
			     obj_t obj_2357;
			     obj_2357 = (obj_t) (new1151_2349);
			     (((obj_t) CREF(obj_2357))->header = MAKE_HEADER(arg1998_2350, 0), BUNSPEC);
			  }
		       }
		       {
			  object_t aux_3833;
			  aux_3833 = (object_t) (new1151_2349);
			  OBJECT_WIDENING_SET(aux_3833, loc_2343);
		       }
		       ((((app_t) CREF(new1151_2349))->loc) = ((obj_t) loc_2343), BUNSPEC);
		       ((((app_t) CREF(new1151_2349))->type) = ((type_t) type_2344), BUNSPEC);
		       ((((app_t) CREF(new1151_2349))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		       ((((app_t) CREF(new1151_2349))->fun) = ((var_t) fun_2346), BUNSPEC);
		       ((((app_t) CREF(new1151_2349))->args) = ((obj_t) arg1929_1376), BUNSPEC);
		       ((((app_t) CREF(new1151_2349))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
		       res2063_2359 = new1151_2349;
		    }
		 }
		 return (node_t) (res2063_2359);
	      }
	   }
	 else
	   {
	      return fun_1374;
	   }
      }
   }
}


obj_t 
_define_primop__node_41_ast_sexp(obj_t env_2487, obj_t global_2488)
{
   {
      node_t aux_3843;
      aux_3843 = define_primop__node_141_ast_sexp((global_t) (global_2488));
      return (obj_t) (aux_3843);
   }
}


node_t 
location__node_25_ast_sexp(global_t global_22)
{
   use_variable__4_ast_sexp((variable_t) (global_22), BFALSE, CNST_TABLE_REF(((long) 1)));
   {
      node_t fun_1397;
      fun_1397 = sexp__node_235_ast_sexp(CNST_TABLE_REF(((long) 31)), BNIL, BFALSE, CNST_TABLE_REF(((long) 15)));
      {
	 bool_t test1952_1398;
	 test1952_1398 = is_a__118___object((obj_t) (fun_1397), var_ast_node);
	 if (test1952_1398)
	   {
	      obj_t arg1953_1399;
	      {
		 node_t arg1954_1400;
		 arg1954_1400 = sexp__node_235_ast_sexp((obj_t) (global_22), BNIL, BFALSE, CNST_TABLE_REF(((long) 1)));
		 {
		    obj_t list1955_1401;
		    {
		       obj_t aux_3859;
		       aux_3859 = (obj_t) (arg1954_1400);
		       list1955_1401 = MAKE_PAIR(aux_3859, BNIL);
		    }
		    arg1953_1399 = list1955_1401;
		 }
	      }
	      {
		 app_t res2064_2378;
		 {
		    obj_t loc_2362;
		    type_t type_2363;
		    var_t fun_2365;
		    loc_2362 = BFALSE;
		    type_2363 = (type_t) (_____74_type_cache);
		    fun_2365 = (var_t) (fun_1397);
		    {
		       app_t new1151_2368;
		       new1151_2368 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
		       {
			  long arg1998_2369;
			  arg1998_2369 = class_num_218___object(app_ast_node);
			  {
			     obj_t obj_2376;
			     obj_2376 = (obj_t) (new1151_2368);
			     (((obj_t) CREF(obj_2376))->header = MAKE_HEADER(arg1998_2369, 0), BUNSPEC);
			  }
		       }
		       {
			  object_t aux_3868;
			  aux_3868 = (object_t) (new1151_2368);
			  OBJECT_WIDENING_SET(aux_3868, loc_2362);
		       }
		       ((((app_t) CREF(new1151_2368))->loc) = ((obj_t) loc_2362), BUNSPEC);
		       ((((app_t) CREF(new1151_2368))->type) = ((type_t) type_2363), BUNSPEC);
		       ((((app_t) CREF(new1151_2368))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		       ((((app_t) CREF(new1151_2368))->fun) = ((var_t) fun_2365), BUNSPEC);
		       ((((app_t) CREF(new1151_2368))->args) = ((obj_t) arg1953_1399), BUNSPEC);
		       ((((app_t) CREF(new1151_2368))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
		       res2064_2378 = new1151_2368;
		    }
		 }
		 return (node_t) (res2064_2378);
	      }
	   }
	 else
	   {
	      return fun_1397;
	   }
      }
   }
}


obj_t 
_location__node_156_ast_sexp(obj_t env_2489, obj_t global_2490)
{
   {
      node_t aux_3878;
      aux_3878 = location__node_25_ast_sexp((global_t) (global_2490));
      return (obj_t) (aux_3878);
   }
}


obj_t 
imported_modules_init_94_ast_sexp()
{
   module_initialization_70_tools_trace(((long) 0), "AST_SEXP");
   module_initialization_70_tools_error(((long) 0), "AST_SEXP");
   module_initialization_70_tools_shape(((long) 0), "AST_SEXP");
   module_initialization_70_tools_progn(((long) 0), "AST_SEXP");
   module_initialization_70_tools_location(((long) 0), "AST_SEXP");
   module_initialization_70_tools_misc(((long) 0), "AST_SEXP");
   module_initialization_70_tools_dsssl(((long) 0), "AST_SEXP");
   module_initialization_70_type_type(((long) 0), "AST_SEXP");
   module_initialization_70_type_env(((long) 0), "AST_SEXP");
   module_initialization_70_type_cache(((long) 0), "AST_SEXP");
   module_initialization_70_type_typeof(((long) 0), "AST_SEXP");
   module_initialization_70_ast_ident(((long) 0), "AST_SEXP");
   module_initialization_70_ast_env(((long) 0), "AST_SEXP");
   module_initialization_70_ast_var(((long) 0), "AST_SEXP");
   module_initialization_70_ast_node(((long) 0), "AST_SEXP");
   module_initialization_70_ast_build(((long) 0), "AST_SEXP");
   module_initialization_70_ast_pragma(((long) 0), "AST_SEXP");
   module_initialization_70_ast_labels(((long) 0), "AST_SEXP");
   module_initialization_70_ast_let(((long) 0), "AST_SEXP");
   module_initialization_70_ast_exit(((long) 0), "AST_SEXP");
   module_initialization_70_ast_app(((long) 0), "AST_SEXP");
   return module_initialization_70_ast_apply(((long) 0), "AST_SEXP");
}
