/*===========================================================================*/
/*   (Ast/shrinkify.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t shrinkify__187_ast_shrinkify(obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t _shrink_variable__default1312_219_ast_shrinkify(obj_t, obj_t);
static obj_t _shrink_node__default1313_221_ast_shrinkify(obj_t, obj_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_ast_shrinkify();
extern obj_t module_initialization_70_ast_shrinkify(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_ast_shrinkify();
static obj_t shrink_variable__default1312_234_ast_shrinkify(variable_t);
static obj_t cnst_init_137_ast_shrinkify();
static obj_t shrink_variable__88_ast_shrinkify(variable_t);
static obj_t require_initialization_114_ast_shrinkify = BUNSPEC;
extern obj_t var_ast_node;
static obj_t library_modules_init_112_ast_shrinkify();
static bool_t shrink_node___235_ast_shrinkify(obj_t);
extern obj_t cast_ast_node;
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t _shrinkify__38_ast_shrinkify(obj_t, obj_t);
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
static obj_t shrink_node__default1313_63_ast_shrinkify(node_t);
extern obj_t class_super_145___object(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t setq_ast_node;
extern obj_t for_each_global__88_ast_env(obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
static obj_t _shrink_variable__92_ast_shrinkify(obj_t, obj_t);
extern obj_t set_ex_it_116_ast_node;
static obj_t shrink_node__211_ast_shrinkify(node_t);
extern obj_t kwote_ast_node;
static obj_t _shrink_node__49_ast_shrinkify(obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t app_ast_node;
static obj_t __cnst[1];

DEFINE_STRING(string1630_ast_shrinkify, string1630_ast_shrinkify1636, "SHRINK-NODE!-DEFAULT1313 ", 25);
DEFINE_EXPORT_PROCEDURE(shrinkify__env_151_ast_shrinkify, _shrinkify__38_ast_shrinkify1637, _shrinkify__38_ast_shrinkify, 0L, 1);
DEFINE_STATIC_GENERIC(shrink_variable__env_168_ast_shrinkify, _shrink_variable__92_ast_shrinkify1638, _shrink_variable__92_ast_shrinkify, 0L, 1);
DEFINE_STATIC_GENERIC(shrink_node__env_219_ast_shrinkify, _shrink_node__49_ast_shrinkify1639, _shrink_node__49_ast_shrinkify, 0L, 1);
DEFINE_STATIC_PROCEDURE(shrink_variable__default1312_env_144_ast_shrinkify, _shrink_variable__default1312_219_ast_shrinkify1640, _shrink_variable__default1312_219_ast_shrinkify, 0L, 1);
DEFINE_STRING(string1629_ast_shrinkify, string1629_ast_shrinkify1641, "No method for this object", 25);
DEFINE_STATIC_PROCEDURE(shrink_node__default1313_env_111_ast_shrinkify, _shrink_node__default1313_221_ast_shrinkify1642, _shrink_node__default1313_221_ast_shrinkify, 0L, 1);

obj_t 
module_initialization_70_ast_shrinkify(long checksum_1419, char *from_1420)
{
   if (CBOOL(require_initialization_114_ast_shrinkify))
     {
	require_initialization_114_ast_shrinkify = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_shrinkify();
	cnst_init_137_ast_shrinkify();
	imported_modules_init_94_ast_shrinkify();
	toplevel_init_63_ast_shrinkify();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_shrinkify()
{
   module_initialization_70___object(((long) 0), "AST_SHRINKIFY");
   module_initialization_70___reader(((long) 0), "AST_SHRINKIFY");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_shrinkify()
{
   {
      obj_t cnst_port_138_1411;
      cnst_port_138_1411 = open_input_string(string1630_ast_shrinkify);
      {
	 long i_1412;
	 i_1412 = ((long) 0);
       loop_1413:
	 {
	    bool_t test1631_1414;
	    test1631_1414 = (i_1412 == ((long) -1));
	    if (test1631_1414)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1632_1415;
		    {
		       obj_t list1633_1416;
		       {
			  obj_t arg1634_1417;
			  arg1634_1417 = BNIL;
			  list1633_1416 = MAKE_PAIR(cnst_port_138_1411, arg1634_1417);
		       }
		       arg1632_1415 = read___reader(list1633_1416);
		    }
		    CNST_TABLE_SET(i_1412, arg1632_1415);
		 }
		 {
		    int aux_1418;
		    {
		       long aux_1436;
		       aux_1436 = (i_1412 - ((long) 1));
		       aux_1418 = (int) (aux_1436);
		    }
		    {
		       long i_1439;
		       i_1439 = (long) (aux_1418);
		       i_1412 = i_1439;
		       goto loop_1413;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_shrinkify()
{
   add_generic__110___object(shrink_variable__env_168_ast_shrinkify, shrink_variable__default1312_env_144_ast_shrinkify);
   add_generic__110___object(shrink_node__env_219_ast_shrinkify, shrink_node__default1313_env_111_ast_shrinkify);
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, var_ast_node, ((long) 1));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, kwote_ast_node, ((long) 2));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, sequence_ast_node, ((long) 3));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, app_ast_node, ((long) 4));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, setq_ast_node, ((long) 9));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, conditional_ast_node, ((long) 10));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, fail_ast_node, ((long) 11));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, select_ast_node, ((long) 12));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, make_box_202_ast_node, ((long) 13));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, box_ref_242_ast_node, ((long) 14));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, box_set__221_ast_node, ((long) 15));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, let_fun_218_ast_node, ((long) 16));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, let_var_6_ast_node, ((long) 17));
   add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, set_ex_it_116_ast_node, ((long) 18));
   {
      long aux_1462;
      aux_1462 = add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, jump_ex_it_184_ast_node, ((long) 19));
      return BINT(aux_1462);
   }
}


obj_t 
shrinkify__187_ast_shrinkify(obj_t globals_1)
{
   for_each_global__88_ast_env(shrink_variable__env_168_ast_shrinkify);
   {
      obj_t l1272_656;
      l1272_656 = globals_1;
    lname1283_657:
      if (PAIRP(l1272_656))
	{
	   {
	      obj_t global_659;
	      global_659 = CAR(l1272_656);
	      {
		 obj_t l1284_661;
		 {
		    sfun_t obj_1153;
		    {
		       value_t aux_1478;
		       {
			  global_t obj_1152;
			  obj_1152 = (global_t) (global_659);
			  aux_1478 = (((global_t) CREF(obj_1152))->value);
		       }
		       obj_1153 = (sfun_t) (aux_1478);
		    }
		    l1284_661 = (((sfun_t) CREF(obj_1153))->args);
		 }
	       lname1285_662:
		 if (PAIRP(l1284_661))
		   {
		      {
			 variable_t aux_1471;
			 {
			    obj_t aux_1472;
			    aux_1472 = CAR(l1284_661);
			    aux_1471 = (variable_t) (aux_1472);
			 }
			 shrink_variable__88_ast_shrinkify(aux_1471);
		      }
		      {
			 obj_t l1284_1476;
			 l1284_1476 = CDR(l1284_661);
			 l1284_661 = l1284_1476;
			 goto lname1285_662;
		      }
		   }
		 else
		   {
		      ((bool_t) 1);
		   }
	      }
	      {
		 node_t aux_1483;
		 {
		    obj_t aux_1484;
		    {
		       sfun_t obj_1158;
		       {
			  value_t aux_1485;
			  {
			     global_t obj_1157;
			     obj_1157 = (global_t) (global_659);
			     aux_1485 = (((global_t) CREF(obj_1157))->value);
			  }
			  obj_1158 = (sfun_t) (aux_1485);
		       }
		       aux_1484 = (((sfun_t) CREF(obj_1158))->body);
		    }
		    aux_1483 = (node_t) (aux_1484);
		 }
		 shrink_node__211_ast_shrinkify(aux_1483);
	      }
	   }
	   {
	      obj_t l1272_1492;
	      l1272_1492 = CDR(l1272_656);
	      l1272_656 = l1272_1492;
	      goto lname1283_657;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   return globals_1;
}


obj_t 
_shrinkify__38_ast_shrinkify(obj_t env_1408, obj_t globals_1409)
{
   return shrinkify__187_ast_shrinkify(globals_1409);
}


obj_t 
shrink_variable__default1312_234_ast_shrinkify(variable_t variable_3)
{
   {
      bool_t test_1495;
      {
	 bool_t test_1496;
	 {
	    obj_t aux_1497;
	    {
	       object_t aux_1498;
	       aux_1498 = (object_t) (variable_3);
	       aux_1497 = OBJECT_WIDENING(aux_1498);
	    }
	    test_1496 = CBOOL(aux_1497);
	 }
	 if (test_1496)
	   {
	      test_1495 = ((bool_t) 1);
	   }
	 else
	   {
	      test_1495 = ((bool_t) 0);
	   }
      }
      if (test_1495)
	{
	   {
	      long arg1347_672;
	      {
		 obj_t arg1349_673;
		 {
		    obj_t arg1350_674;
		    {
		       object_t object_1163;
		       object_1163 = (object_t) (variable_3);
		       {
			  long arg1187_1164;
			  {
			     long arg1188_1165;
			     long arg1189_1166;
			     arg1188_1165 = TYPE(object_1163);
			     arg1189_1166 = OBJECT_TYPE;
			     arg1187_1164 = (arg1188_1165 - arg1189_1166);
			  }
			  {
			     obj_t vector_1170;
			     vector_1170 = __classes__134___object;
			     arg1350_674 = VECTOR_REF(vector_1170, arg1187_1164);
			  }
		       }
		    }
		    arg1349_673 = class_super_145___object(arg1350_674);
		 }
		 arg1347_672 = class_num_218___object(arg1349_673);
	      }
	      {
		 obj_t obj_1172;
		 obj_1172 = (obj_t) (variable_3);
		 (((obj_t) CREF(obj_1172))->header = MAKE_HEADER(arg1347_672, 0), BUNSPEC);
	      }
	   }
	   {
	      object_t aux_1511;
	      aux_1511 = (object_t) (variable_3);
	      OBJECT_WIDENING_SET(aux_1511, BFALSE);
	   }
	   (obj_t) (variable_3);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test_1515;
      {
	 bool_t test_1516;
	 {
	    obj_t aux_1517;
	    {
	       object_t aux_1518;
	       {
		  value_t aux_1519;
		  aux_1519 = (((variable_t) CREF(variable_3))->value);
		  aux_1518 = (object_t) (aux_1519);
	       }
	       aux_1517 = OBJECT_WIDENING(aux_1518);
	    }
	    test_1516 = CBOOL(aux_1517);
	 }
	 if (test_1516)
	   {
	      test_1515 = ((bool_t) 1);
	   }
	 else
	   {
	      test_1515 = ((bool_t) 0);
	   }
      }
      if (test_1515)
	{
	   value_t o1287_676;
	   o1287_676 = (((variable_t) CREF(variable_3))->value);
	   {
	      long arg1352_677;
	      {
		 obj_t arg1353_678;
		 {
		    obj_t arg1355_679;
		    {
		       object_t object_1179;
		       object_1179 = (object_t) (o1287_676);
		       {
			  long arg1187_1180;
			  {
			     long arg1188_1181;
			     long arg1189_1182;
			     arg1188_1181 = TYPE(object_1179);
			     arg1189_1182 = OBJECT_TYPE;
			     arg1187_1180 = (arg1188_1181 - arg1189_1182);
			  }
			  {
			     obj_t vector_1186;
			     vector_1186 = __classes__134___object;
			     arg1355_679 = VECTOR_REF(vector_1186, arg1187_1180);
			  }
		       }
		    }
		    arg1353_678 = class_super_145___object(arg1355_679);
		 }
		 arg1352_677 = class_num_218___object(arg1353_678);
	      }
	      {
		 obj_t obj_1188;
		 obj_1188 = (obj_t) (o1287_676);
		 (((obj_t) CREF(obj_1188))->header = MAKE_HEADER(arg1352_677, 0), BUNSPEC);
	      }
	   }
	   {
	      object_t aux_1534;
	      aux_1534 = (object_t) (o1287_676);
	      OBJECT_WIDENING_SET(aux_1534, BFALSE);
	   }
	   return (obj_t) (o1287_676);
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_shrink_variable__default1312_219_ast_shrinkify(obj_t env_1402, obj_t variable_1403)
{
   return shrink_variable__default1312_234_ast_shrinkify((variable_t) (variable_1403));
}


obj_t 
shrink_variable__88_ast_shrinkify(variable_t variable_2)
{
   {
      obj_t method1599_1136;
      obj_t class1605_1137;
      {
	 obj_t arg1606_1134;
	 obj_t arg1608_1135;
	 {
	    object_t obj_1190;
	    obj_1190 = (object_t) (variable_2);
	    {
	       obj_t pre_method_105_1191;
	       pre_method_105_1191 = PROCEDURE_REF(shrink_variable__env_168_ast_shrinkify, ((long) 2));
	       if (INTEGERP(pre_method_105_1191))
		 {
		    PROCEDURE_SET(shrink_variable__env_168_ast_shrinkify, ((long) 2), BUNSPEC);
		    arg1606_1134 = pre_method_105_1191;
		 }
	       else
		 {
		    long obj_class_num_177_1196;
		    obj_class_num_177_1196 = TYPE(obj_1190);
		    {
		       obj_t arg1183_1197;
		       arg1183_1197 = PROCEDURE_REF(shrink_variable__env_168_ast_shrinkify, ((long) 1));
		       {
			  long arg1184_1201;
			  {
			     long arg1186_1202;
			     arg1186_1202 = OBJECT_TYPE;
			     arg1184_1201 = (obj_class_num_177_1196 - arg1186_1202);
			  }
			  arg1606_1134 = VECTOR_REF(arg1183_1197, arg1184_1201);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1207;
	    object_1207 = (object_t) (variable_2);
	    {
	       long arg1187_1208;
	       {
		  long arg1188_1209;
		  long arg1189_1210;
		  arg1188_1209 = TYPE(object_1207);
		  arg1189_1210 = OBJECT_TYPE;
		  arg1187_1208 = (arg1188_1209 - arg1189_1210);
	       }
	       {
		  obj_t vector_1214;
		  vector_1214 = __classes__134___object;
		  arg1608_1135 = VECTOR_REF(vector_1214, arg1187_1208);
	       }
	    }
	 }
	 method1599_1136 = arg1606_1134;
	 class1605_1137 = arg1608_1135;
	 if (PROCEDUREP(method1599_1136))
	   {
	      return PROCEDURE_ENTRY(method1599_1136) (method1599_1136, (obj_t) (variable_2), BEOA);
	   }
	 else
	   {
	      obj_t fun1357_681;
	      fun1357_681 = PROCEDURE_REF(shrink_variable__env_168_ast_shrinkify, ((long) 0));
	      return PROCEDURE_ENTRY(fun1357_681) (fun1357_681, (obj_t) (variable_2), BEOA);
	   }
      }
   }
}


obj_t 
_shrink_variable__92_ast_shrinkify(obj_t env_1400, obj_t variable_1401)
{
   return shrink_variable__88_ast_shrinkify((variable_t) (variable_1401));
}


obj_t 
shrink_node__default1313_63_ast_shrinkify(node_t node_5)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1629_ast_shrinkify, (obj_t) (node_5));
}


obj_t 
_shrink_node__default1313_221_ast_shrinkify(obj_t env_1406, obj_t node_1407)
{
   return shrink_node__default1313_63_ast_shrinkify((node_t) (node_1407));
}


obj_t 
shrink_node__211_ast_shrinkify(node_t node_4)
{
   {
      obj_t method1487_1003;
      obj_t class1492_1004;
      {
	 obj_t arg1496_1001;
	 obj_t arg1497_1002;
	 {
	    object_t obj_1223;
	    obj_1223 = (object_t) (node_4);
	    {
	       obj_t pre_method_105_1224;
	       pre_method_105_1224 = PROCEDURE_REF(shrink_node__env_219_ast_shrinkify, ((long) 2));
	       if (INTEGERP(pre_method_105_1224))
		 {
		    PROCEDURE_SET(shrink_node__env_219_ast_shrinkify, ((long) 2), BUNSPEC);
		    arg1496_1001 = pre_method_105_1224;
		 }
	       else
		 {
		    long obj_class_num_177_1229;
		    obj_class_num_177_1229 = TYPE(obj_1223);
		    {
		       obj_t arg1183_1230;
		       arg1183_1230 = PROCEDURE_REF(shrink_node__env_219_ast_shrinkify, ((long) 1));
		       {
			  long arg1184_1234;
			  {
			     long arg1186_1235;
			     arg1186_1235 = OBJECT_TYPE;
			     arg1184_1234 = (obj_class_num_177_1229 - arg1186_1235);
			  }
			  arg1496_1001 = VECTOR_REF(arg1183_1230, arg1184_1234);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1240;
	    object_1240 = (object_t) (node_4);
	    {
	       long arg1187_1241;
	       {
		  long arg1188_1242;
		  long arg1189_1243;
		  arg1188_1242 = TYPE(object_1240);
		  arg1189_1243 = OBJECT_TYPE;
		  arg1187_1241 = (arg1188_1242 - arg1189_1243);
	       }
	       {
		  obj_t vector_1247;
		  vector_1247 = __classes__134___object;
		  arg1497_1002 = VECTOR_REF(vector_1247, arg1187_1241);
	       }
	    }
	 }
	 {
	    obj_t x_1410;
	    method1487_1003 = arg1496_1001;
	    class1492_1004 = arg1497_1002;
	    {
	       if (INTEGERP(method1487_1003))
		 {
		    switch ((long) CINT(method1487_1003))
		      {
		      case ((long) 0):
			 x_1410 = BUNSPEC;
			 break;
		      case ((long) 1):
			 x_1410 = BUNSPEC;
			 break;
		      case ((long) 2):
			 x_1410 = BUNSPEC;
			 break;
		      case ((long) 3):
			 {
			    sequence_t node_1013;
			    node_1013 = (sequence_t) (node_4);
			    shrink_node___235_ast_shrinkify((((sequence_t) CREF(node_1013))->nodes));
			    x_1410 = BUNSPEC;
			 }
			 break;
		      case ((long) 4):
			 {
			    app_t node_1015;
			    node_1015 = (app_t) (node_4);
			    {
			       bool_t test_1592;
			       {
				  bool_t test_1593;
				  {
				     obj_t aux_1594;
				     {
					object_t aux_1595;
					aux_1595 = (object_t) (node_1015);
					aux_1594 = OBJECT_WIDENING(aux_1595);
				     }
				     test_1593 = CBOOL(aux_1594);
				  }
				  if (test_1593)
				    {
				       test_1592 = ((bool_t) 1);
				    }
				  else
				    {
				       test_1592 = ((bool_t) 0);
				    }
			       }
			       if (test_1592)
				 {
				    {
				       long arg1505_1018;
				       {
					  obj_t arg1506_1019;
					  {
					     obj_t arg1507_1020;
					     {
						object_t object_1253;
						object_1253 = (object_t) (node_1015);
						{
						   long arg1187_1254;
						   {
						      long arg1188_1255;
						      long arg1189_1256;
						      arg1188_1255 = TYPE(object_1253);
						      arg1189_1256 = OBJECT_TYPE;
						      arg1187_1254 = (arg1188_1255 - arg1189_1256);
						   }
						   {
						      obj_t vector_1260;
						      vector_1260 = __classes__134___object;
						      arg1507_1020 = VECTOR_REF(vector_1260, arg1187_1254);
						   }
						}
					     }
					     arg1506_1019 = class_super_145___object(arg1507_1020);
					  }
					  arg1505_1018 = class_num_218___object(arg1506_1019);
				       }
				       {
					  obj_t obj_1262;
					  obj_1262 = (obj_t) (node_1015);
					  (((obj_t) CREF(obj_1262))->header = MAKE_HEADER(arg1505_1018, 0), BUNSPEC);
				       }
				    }
				    {
				       object_t aux_1608;
				       aux_1608 = (object_t) (node_1015);
				       OBJECT_WIDENING_SET(aux_1608, BFALSE);
				    }
				    (obj_t) (node_1015);
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       node_t aux_1612;
			       {
				  var_t aux_1613;
				  aux_1613 = (((app_t) CREF(node_1015))->fun);
				  aux_1612 = (node_t) (aux_1613);
			       }
			       shrink_node__211_ast_shrinkify(aux_1612);
			    }
			    shrink_node___235_ast_shrinkify((((app_t) CREF(node_1015))->args));
			    x_1410 = BUNSPEC;
			 }
			 break;
		      case ((long) 5):
			 {
			    app_ly_162_t node_1023;
			    node_1023 = (app_ly_162_t) (node_4);
			    {
			       bool_t test_1620;
			       {
				  bool_t test_1621;
				  {
				     obj_t aux_1622;
				     {
					object_t aux_1623;
					aux_1623 = (object_t) (node_1023);
					aux_1622 = OBJECT_WIDENING(aux_1623);
				     }
				     test_1621 = CBOOL(aux_1622);
				  }
				  if (test_1621)
				    {
				       test_1620 = ((bool_t) 1);
				    }
				  else
				    {
				       test_1620 = ((bool_t) 0);
				    }
			       }
			       if (test_1620)
				 {
				    {
				       long arg1513_1026;
				       {
					  obj_t arg1514_1027;
					  {
					     obj_t arg1517_1028;
					     {
						object_t object_1269;
						object_1269 = (object_t) (node_1023);
						{
						   long arg1187_1270;
						   {
						      long arg1188_1271;
						      long arg1189_1272;
						      arg1188_1271 = TYPE(object_1269);
						      arg1189_1272 = OBJECT_TYPE;
						      arg1187_1270 = (arg1188_1271 - arg1189_1272);
						   }
						   {
						      obj_t vector_1276;
						      vector_1276 = __classes__134___object;
						      arg1517_1028 = VECTOR_REF(vector_1276, arg1187_1270);
						   }
						}
					     }
					     arg1514_1027 = class_super_145___object(arg1517_1028);
					  }
					  arg1513_1026 = class_num_218___object(arg1514_1027);
				       }
				       {
					  obj_t obj_1278;
					  obj_1278 = (obj_t) (node_1023);
					  (((obj_t) CREF(obj_1278))->header = MAKE_HEADER(arg1513_1026, 0), BUNSPEC);
				       }
				    }
				    {
				       object_t aux_1636;
				       aux_1636 = (object_t) (node_1023);
				       OBJECT_WIDENING_SET(aux_1636, BFALSE);
				    }
				    (obj_t) (node_1023);
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    shrink_node__211_ast_shrinkify((((app_ly_162_t) CREF(node_1023))->fun));
			    shrink_node__211_ast_shrinkify((((app_ly_162_t) CREF(node_1023))->arg));
			    x_1410 = BUNSPEC;
			 }
			 break;
		      case ((long) 6):
			 {
			    funcall_t node_1031;
			    node_1031 = (funcall_t) (node_4);
			    {
			       bool_t test_1645;
			       {
				  bool_t test_1646;
				  {
				     obj_t aux_1647;
				     {
					object_t aux_1648;
					aux_1648 = (object_t) (node_1031);
					aux_1647 = OBJECT_WIDENING(aux_1648);
				     }
				     test_1646 = CBOOL(aux_1647);
				  }
				  if (test_1646)
				    {
				       test_1645 = ((bool_t) 1);
				    }
				  else
				    {
				       test_1645 = ((bool_t) 0);
				    }
			       }
			       if (test_1645)
				 {
				    {
				       long arg1522_1034;
				       {
					  obj_t arg1523_1035;
					  {
					     obj_t arg1524_1036;
					     {
						object_t object_1285;
						object_1285 = (object_t) (node_1031);
						{
						   long arg1187_1286;
						   {
						      long arg1188_1287;
						      long arg1189_1288;
						      arg1188_1287 = TYPE(object_1285);
						      arg1189_1288 = OBJECT_TYPE;
						      arg1187_1286 = (arg1188_1287 - arg1189_1288);
						   }
						   {
						      obj_t vector_1292;
						      vector_1292 = __classes__134___object;
						      arg1524_1036 = VECTOR_REF(vector_1292, arg1187_1286);
						   }
						}
					     }
					     arg1523_1035 = class_super_145___object(arg1524_1036);
					  }
					  arg1522_1034 = class_num_218___object(arg1523_1035);
				       }
				       {
					  obj_t obj_1294;
					  obj_1294 = (obj_t) (node_1031);
					  (((obj_t) CREF(obj_1294))->header = MAKE_HEADER(arg1522_1034, 0), BUNSPEC);
				       }
				    }
				    {
				       object_t aux_1661;
				       aux_1661 = (object_t) (node_1031);
				       OBJECT_WIDENING_SET(aux_1661, BFALSE);
				    }
				    (obj_t) (node_1031);
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    shrink_node__211_ast_shrinkify((((funcall_t) CREF(node_1031))->fun));
			    shrink_node___235_ast_shrinkify((((funcall_t) CREF(node_1031))->args));
			    x_1410 = BUNSPEC;
			 }
			 break;
		      case ((long) 7):
			 {
			    pragma_t node_1039;
			    node_1039 = (pragma_t) (node_4);
			    {
			       bool_t test_1670;
			       {
				  bool_t test_1671;
				  {
				     obj_t aux_1672;
				     {
					object_t aux_1673;
					aux_1673 = (object_t) (node_1039);
					aux_1672 = OBJECT_WIDENING(aux_1673);
				     }
				     test_1671 = CBOOL(aux_1672);
				  }
				  if (test_1671)
				    {
				       test_1670 = ((bool_t) 1);
				    }
				  else
				    {
				       test_1670 = ((bool_t) 0);
				    }
			       }
			       if (test_1670)
				 {
				    {
				       long arg1531_1042;
				       {
					  obj_t arg1532_1043;
					  {
					     obj_t arg1534_1044;
					     {
						object_t object_1301;
						object_1301 = (object_t) (node_1039);
						{
						   long arg1187_1302;
						   {
						      long arg1188_1303;
						      long arg1189_1304;
						      arg1188_1303 = TYPE(object_1301);
						      arg1189_1304 = OBJECT_TYPE;
						      arg1187_1302 = (arg1188_1303 - arg1189_1304);
						   }
						   {
						      obj_t vector_1308;
						      vector_1308 = __classes__134___object;
						      arg1534_1044 = VECTOR_REF(vector_1308, arg1187_1302);
						   }
						}
					     }
					     arg1532_1043 = class_super_145___object(arg1534_1044);
					  }
					  arg1531_1042 = class_num_218___object(arg1532_1043);
				       }
				       {
					  obj_t obj_1310;
					  obj_1310 = (obj_t) (node_1039);
					  (((obj_t) CREF(obj_1310))->header = MAKE_HEADER(arg1531_1042, 0), BUNSPEC);
				       }
				    }
				    {
				       object_t aux_1686;
				       aux_1686 = (object_t) (node_1039);
				       OBJECT_WIDENING_SET(aux_1686, BFALSE);
				    }
				    (obj_t) (node_1039);
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    shrink_node___235_ast_shrinkify((((pragma_t) CREF(node_1039))->args));
			    x_1410 = (obj_t) (node_1039);
			 }
			 break;
		      case ((long) 8):
			 {
			    cast_t node_1046;
			    node_1046 = (cast_t) (node_4);
			    shrink_node__211_ast_shrinkify((((cast_t) CREF(node_1046))->arg));
			    x_1410 = (obj_t) (node_1046);
			 }
			 break;
		      case ((long) 9):
			 {
			    setq_t node_1048;
			    node_1048 = (setq_t) (node_4);
			    shrink_node__211_ast_shrinkify((((setq_t) CREF(node_1048))->value));
			    x_1410 = BUNSPEC;
			 }
			 break;
		      case ((long) 10):
			 {
			    conditional_t node_1050;
			    node_1050 = (conditional_t) (node_4);
			    shrink_node__211_ast_shrinkify((((conditional_t) CREF(node_1050))->test));
			    shrink_node__211_ast_shrinkify((((conditional_t) CREF(node_1050))->true));
			    shrink_node__211_ast_shrinkify((((conditional_t) CREF(node_1050))->false));
			    x_1410 = BUNSPEC;
			 }
			 break;
		      case ((long) 11):
			 {
			    fail_t node_1054;
			    node_1054 = (fail_t) (node_4);
			    shrink_node__211_ast_shrinkify((((fail_t) CREF(node_1054))->proc));
			    shrink_node__211_ast_shrinkify((((fail_t) CREF(node_1054))->msg));
			    shrink_node__211_ast_shrinkify((((fail_t) CREF(node_1054))->obj));
			    x_1410 = BUNSPEC;
			 }
			 break;
		      case ((long) 12):
			 {
			    select_t node_1058;
			    node_1058 = (select_t) (node_4);
			    shrink_node__211_ast_shrinkify((((select_t) CREF(node_1058))->test));
			    {
			       obj_t l1292_1060;
			       l1292_1060 = (((select_t) CREF(node_1058))->clauses);
			     lname1293_1061:
			       if (PAIRP(l1292_1060))
				 {
				    {
				       node_t aux_1719;
				       {
					  obj_t aux_1720;
					  {
					     obj_t aux_1721;
					     aux_1721 = CAR(l1292_1060);
					     aux_1720 = CDR(aux_1721);
					  }
					  aux_1719 = (node_t) (aux_1720);
				       }
				       shrink_node__211_ast_shrinkify(aux_1719);
				    }
				    {
				       obj_t l1292_1726;
				       l1292_1726 = CDR(l1292_1060);
				       l1292_1060 = l1292_1726;
				       goto lname1293_1061;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    x_1410 = BUNSPEC;
			 }
			 break;
		      case ((long) 13):
			 {
			    make_box_202_t node_1067;
			    node_1067 = (make_box_202_t) (node_4);
			    {
			       bool_t test_1730;
			       {
				  bool_t test_1731;
				  {
				     obj_t aux_1732;
				     {
					object_t aux_1733;
					aux_1733 = (object_t) (node_1067);
					aux_1732 = OBJECT_WIDENING(aux_1733);
				     }
				     test_1731 = CBOOL(aux_1732);
				  }
				  if (test_1731)
				    {
				       test_1730 = ((bool_t) 1);
				    }
				  else
				    {
				       test_1730 = ((bool_t) 0);
				    }
			       }
			       if (test_1730)
				 {
				    {
				       long arg1554_1070;
				       {
					  obj_t arg1555_1071;
					  {
					     obj_t arg1557_1072;
					     {
						object_t object_1330;
						object_1330 = (object_t) (node_1067);
						{
						   long arg1187_1331;
						   {
						      long arg1188_1332;
						      long arg1189_1333;
						      arg1188_1332 = TYPE(object_1330);
						      arg1189_1333 = OBJECT_TYPE;
						      arg1187_1331 = (arg1188_1332 - arg1189_1333);
						   }
						   {
						      obj_t vector_1337;
						      vector_1337 = __classes__134___object;
						      arg1557_1072 = VECTOR_REF(vector_1337, arg1187_1331);
						   }
						}
					     }
					     arg1555_1071 = class_super_145___object(arg1557_1072);
					  }
					  arg1554_1070 = class_num_218___object(arg1555_1071);
				       }
				       {
					  obj_t obj_1339;
					  obj_1339 = (obj_t) (node_1067);
					  (((obj_t) CREF(obj_1339))->header = MAKE_HEADER(arg1554_1070, 0), BUNSPEC);
				       }
				    }
				    {
				       object_t aux_1746;
				       aux_1746 = (object_t) (node_1067);
				       OBJECT_WIDENING_SET(aux_1746, BFALSE);
				    }
				    (obj_t) (node_1067);
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    shrink_node__211_ast_shrinkify((((make_box_202_t) CREF(node_1067))->value));
			    x_1410 = BUNSPEC;
			 }
			 break;
		      case ((long) 14):
			 {
			    box_ref_242_t node_1074;
			    node_1074 = (box_ref_242_t) (node_4);
			    {
			       bool_t test_1753;
			       {
				  bool_t test_1754;
				  {
				     obj_t aux_1755;
				     {
					object_t aux_1756;
					aux_1756 = (object_t) (node_1074);
					aux_1755 = OBJECT_WIDENING(aux_1756);
				     }
				     test_1754 = CBOOL(aux_1755);
				  }
				  if (test_1754)
				    {
				       test_1753 = ((bool_t) 1);
				    }
				  else
				    {
				       test_1753 = ((bool_t) 0);
				    }
			       }
			       if (test_1753)
				 {
				    {
				       long arg1561_1077;
				       {
					  obj_t arg1562_1078;
					  {
					     obj_t arg1563_1079;
					     {
						object_t object_1345;
						object_1345 = (object_t) (node_1074);
						{
						   long arg1187_1346;
						   {
						      long arg1188_1347;
						      long arg1189_1348;
						      arg1188_1347 = TYPE(object_1345);
						      arg1189_1348 = OBJECT_TYPE;
						      arg1187_1346 = (arg1188_1347 - arg1189_1348);
						   }
						   {
						      obj_t vector_1352;
						      vector_1352 = __classes__134___object;
						      arg1563_1079 = VECTOR_REF(vector_1352, arg1187_1346);
						   }
						}
					     }
					     arg1562_1078 = class_super_145___object(arg1563_1079);
					  }
					  arg1561_1077 = class_num_218___object(arg1562_1078);
				       }
				       {
					  obj_t obj_1354;
					  obj_1354 = (obj_t) (node_1074);
					  (((obj_t) CREF(obj_1354))->header = MAKE_HEADER(arg1561_1077, 0), BUNSPEC);
				       }
				    }
				    {
				       object_t aux_1769;
				       aux_1769 = (object_t) (node_1074);
				       OBJECT_WIDENING_SET(aux_1769, BFALSE);
				    }
				    (obj_t) (node_1074);
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       node_t aux_1773;
			       {
				  var_t aux_1774;
				  aux_1774 = (((box_ref_242_t) CREF(node_1074))->var);
				  aux_1773 = (node_t) (aux_1774);
			       }
			       shrink_node__211_ast_shrinkify(aux_1773);
			    }
			    x_1410 = BUNSPEC;
			 }
			 break;
		      case ((long) 15):
			 {
			    box_set__221_t node_1081;
			    node_1081 = (box_set__221_t) (node_4);
			    {
			       bool_t test_1779;
			       {
				  bool_t test_1780;
				  {
				     obj_t aux_1781;
				     {
					object_t aux_1782;
					aux_1782 = (object_t) (node_1081);
					aux_1781 = OBJECT_WIDENING(aux_1782);
				     }
				     test_1780 = CBOOL(aux_1781);
				  }
				  if (test_1780)
				    {
				       test_1779 = ((bool_t) 1);
				    }
				  else
				    {
				       test_1779 = ((bool_t) 0);
				    }
			       }
			       if (test_1779)
				 {
				    {
				       long arg1566_1084;
				       {
					  obj_t arg1567_1085;
					  {
					     obj_t arg1568_1086;
					     {
						object_t object_1360;
						object_1360 = (object_t) (node_1081);
						{
						   long arg1187_1361;
						   {
						      long arg1188_1362;
						      long arg1189_1363;
						      arg1188_1362 = TYPE(object_1360);
						      arg1189_1363 = OBJECT_TYPE;
						      arg1187_1361 = (arg1188_1362 - arg1189_1363);
						   }
						   {
						      obj_t vector_1367;
						      vector_1367 = __classes__134___object;
						      arg1568_1086 = VECTOR_REF(vector_1367, arg1187_1361);
						   }
						}
					     }
					     arg1567_1085 = class_super_145___object(arg1568_1086);
					  }
					  arg1566_1084 = class_num_218___object(arg1567_1085);
				       }
				       {
					  obj_t obj_1369;
					  obj_1369 = (obj_t) (node_1081);
					  (((obj_t) CREF(obj_1369))->header = MAKE_HEADER(arg1566_1084, 0), BUNSPEC);
				       }
				    }
				    {
				       object_t aux_1795;
				       aux_1795 = (object_t) (node_1081);
				       OBJECT_WIDENING_SET(aux_1795, BFALSE);
				    }
				    (obj_t) (node_1081);
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       node_t aux_1799;
			       {
				  var_t aux_1800;
				  aux_1800 = (((box_set__221_t) CREF(node_1081))->var);
				  aux_1799 = (node_t) (aux_1800);
			       }
			       shrink_node__211_ast_shrinkify(aux_1799);
			    }
			    shrink_node__211_ast_shrinkify((((box_set__221_t) CREF(node_1081))->value));
			    x_1410 = BUNSPEC;
			 }
			 break;
		      case ((long) 16):
			 {
			    let_fun_218_t node_1089;
			    node_1089 = (let_fun_218_t) (node_4);
			    shrink_node__211_ast_shrinkify((((let_fun_218_t) CREF(node_1089))->body));
			    {
			       obj_t l1298_1092;
			       l1298_1092 = (((let_fun_218_t) CREF(node_1089))->locals);
			     lname1301_1093:
			       if (PAIRP(l1298_1092))
				 {
				    {
				       obj_t local_1096;
				       local_1096 = CAR(l1298_1092);
				       {
					  value_t sfun_1097;
					  {
					     local_t obj_1377;
					     obj_1377 = (local_t) (local_1096);
					     sfun_1097 = (((local_t) CREF(obj_1377))->value);
					  }
					  shrink_variable__88_ast_shrinkify((variable_t) (local_1096));
					  {
					     obj_t l1302_1098;
					     {
						sfun_t obj_1378;
						obj_1378 = (sfun_t) (sfun_1097);
						l1302_1098 = (((sfun_t) CREF(obj_1378))->args);
					     }
					   lname1304_1099:
					     if (PAIRP(l1302_1098))
					       {
						  {
						     variable_t aux_1818;
						     {
							obj_t aux_1819;
							aux_1819 = CAR(l1302_1098);
							aux_1818 = (variable_t) (aux_1819);
						     }
						     shrink_variable__88_ast_shrinkify(aux_1818);
						  }
						  {
						     obj_t l1302_1823;
						     l1302_1823 = CDR(l1302_1098);
						     l1302_1098 = l1302_1823;
						     goto lname1304_1099;
						  }
					       }
					     else
					       {
						  ((bool_t) 1);
					       }
					  }
					  {
					     node_t aux_1827;
					     {
						obj_t aux_1828;
						{
						   sfun_t obj_1382;
						   obj_1382 = (sfun_t) (sfun_1097);
						   aux_1828 = (((sfun_t) CREF(obj_1382))->body);
						}
						aux_1827 = (node_t) (aux_1828);
					     }
					     shrink_node__211_ast_shrinkify(aux_1827);
					  }
				       }
				    }
				    {
				       obj_t l1298_1833;
				       l1298_1833 = CDR(l1298_1092);
				       l1298_1092 = l1298_1833;
				       goto lname1301_1093;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    x_1410 = BUNSPEC;
			 }
			 break;
		      case ((long) 17):
			 {
			    let_var_6_t node_1106;
			    node_1106 = (let_var_6_t) (node_4);
			    shrink_node__211_ast_shrinkify((((let_var_6_t) CREF(node_1106))->body));
			    {
			       obj_t l1306_1109;
			       l1306_1109 = (((let_var_6_t) CREF(node_1106))->bindings);
			     lname1307_1110:
			       if (PAIRP(l1306_1109))
				 {
				    {
				       obj_t binding_1113;
				       binding_1113 = CAR(l1306_1109);
				       {
					  variable_t aux_1842;
					  {
					     obj_t aux_1843;
					     aux_1843 = CAR(binding_1113);
					     aux_1842 = (variable_t) (aux_1843);
					  }
					  shrink_variable__88_ast_shrinkify(aux_1842);
				       }
				       {
					  node_t aux_1847;
					  {
					     obj_t aux_1848;
					     aux_1848 = CDR(binding_1113);
					     aux_1847 = (node_t) (aux_1848);
					  }
					  shrink_node__211_ast_shrinkify(aux_1847);
				       }
				    }
				    {
				       obj_t l1306_1852;
				       l1306_1852 = CDR(l1306_1109);
				       l1306_1109 = l1306_1852;
				       goto lname1307_1110;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    x_1410 = BUNSPEC;
			 }
			 break;
		      case ((long) 18):
			 {
			    set_ex_it_116_t node_1117;
			    node_1117 = (set_ex_it_116_t) (node_4);
			    {
			       node_t aux_1856;
			       {
				  var_t aux_1857;
				  aux_1857 = (((set_ex_it_116_t) CREF(node_1117))->var);
				  aux_1856 = (node_t) (aux_1857);
			       }
			       shrink_node__211_ast_shrinkify(aux_1856);
			    }
			    shrink_node__211_ast_shrinkify((((set_ex_it_116_t) CREF(node_1117))->body));
			    x_1410 = BUNSPEC;
			 }
			 break;
		      case ((long) 19):
			 {
			    jump_ex_it_184_t node_1121;
			    node_1121 = (jump_ex_it_184_t) (node_4);
			    shrink_node__211_ast_shrinkify((((jump_ex_it_184_t) CREF(node_1121))->exit));
			    shrink_node__211_ast_shrinkify((((jump_ex_it_184_t) CREF(node_1121))->value));
			    x_1410 = BUNSPEC;
			 }
			 break;
		      default:
		       case_else1493_190_1007:
			 if (PROCEDUREP(method1487_1003))
			   {
			      x_1410 = PROCEDURE_ENTRY(method1487_1003) (method1487_1003, (obj_t) (node_4), BEOA);
			   }
			 else
			   {
			      obj_t fun1360_684;
			      fun1360_684 = PROCEDURE_REF(shrink_node__env_219_ast_shrinkify, ((long) 0));
			      x_1410 = PROCEDURE_ENTRY(fun1360_684) (fun1360_684, (obj_t) (node_4), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1493_190_1007;
		 }
	    }
	    return BUNSPEC;
	 }
      }
   }
}


obj_t 
_shrink_node__49_ast_shrinkify(obj_t env_1404, obj_t node_1405)
{
   return shrink_node__211_ast_shrinkify((node_t) (node_1405));
}


bool_t 
shrink_node___235_ast_shrinkify(obj_t node__221_26)
{
   {
      obj_t l1309_685;
      l1309_685 = node__221_26;
    lname1311_686:
      if (PAIRP(l1309_685))
	{
	   {
	      node_t aux_1883;
	      {
		 obj_t aux_1884;
		 aux_1884 = CAR(l1309_685);
		 aux_1883 = (node_t) (aux_1884);
	      }
	      shrink_node__211_ast_shrinkify(aux_1883);
	   }
	   {
	      obj_t l1309_1888;
	      l1309_1888 = CDR(l1309_685);
	      l1309_685 = l1309_1888;
	      goto lname1311_686;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
imported_modules_init_94_ast_shrinkify()
{
   module_initialization_70_type_type(((long) 0), "AST_SHRINKIFY");
   module_initialization_70_ast_var(((long) 0), "AST_SHRINKIFY");
   module_initialization_70_ast_node(((long) 0), "AST_SHRINKIFY");
   return module_initialization_70_ast_env(((long) 0), "AST_SHRINKIFY");
}
