/*===========================================================================*/
/*   (Ast/substitute.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


static obj_t _do_substitute__221_ast_substitute(obj_t, obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fun_ast_var;
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_ast_substitute();
extern obj_t module_initialization_70_ast_substitute(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_ast_apply(long, char *);
extern obj_t module_initialization_70_ast_app(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_ast_substitute();
static obj_t cnst_init_137_ast_substitute();
static obj_t do_substitute___56_ast_substitute(obj_t, obj_t);
extern node_t make_app_node_80_ast_app(obj_t, obj_t, var_t, obj_t);
static obj_t require_initialization_114_ast_substitute = BUNSPEC;
extern obj_t var_ast_node;
static obj_t library_modules_init_112_ast_substitute();
static obj_t _do_substitute__default1308_120_ast_substitute(obj_t, obj_t, obj_t);
static node_t do_substitute__77_ast_substitute(node_t, obj_t);
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t variable_ast_var;
extern obj_t cast_ast_node;
extern node_t known_app_ly__node_26_ast_apply(obj_t, obj_t, node_t, node_t, obj_t);
extern obj_t conditional_ast_node;
extern node_t substitute__30_ast_substitute(obj_t, obj_t, node_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern long class_num_218___object(obj_t);
static node_t do_substitute__default1308_48_ast_substitute(node_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t _substitute__229_ast_substitute(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t kwote_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t use_variable__4_ast_sexp(variable_t, obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern bool_t correct_arity_app__187_ast_app(variable_t, obj_t);
extern obj_t app_ast_node;
static obj_t __cnst[6];

DEFINE_STATIC_GENERIC(do_substitute__env_169_ast_substitute, _do_substitute__221_ast_substitute1706, _do_substitute__221_ast_substitute, 0L, 2);
DEFINE_STRING(string1696_ast_substitute, string1696_ast_substitute1707, "duplicate", 9);
DEFINE_STRING(string1695_ast_substitute, string1695_ast_substitute1708, "No method for this object", 25);
DEFINE_STRING(string1699_ast_substitute, string1699_ast_substitute1709, "wrong number of argument(s)", 27);
DEFINE_STRING(string1698_ast_substitute, string1698_ast_substitute1710, "Illegal application", 19);
DEFINE_STRING(string1697_ast_substitute, string1697_ast_substitute1711, "Illegal substitution", 20);
DEFINE_STRING(string1700_ast_substitute, string1700_ast_substitute1712, "DONE SET! APPLY VALUE APP DO-SUBSTITUTE!-DEFAULT1308 ", 53);
DEFINE_STATIC_PROCEDURE(do_substitute__default1308_env_164_ast_substitute, _do_substitute__default1308_120_ast_substitute1713, _do_substitute__default1308_120_ast_substitute, 0L, 2);
DEFINE_EXPORT_PROCEDURE(substitute__env_193_ast_substitute, _substitute__229_ast_substitute1714, _substitute__229_ast_substitute, 0L, 4);

obj_t 
module_initialization_70_ast_substitute(long checksum_1545, char *from_1546)
{
   if (CBOOL(require_initialization_114_ast_substitute))
     {
	require_initialization_114_ast_substitute = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_substitute();
	cnst_init_137_ast_substitute();
	imported_modules_init_94_ast_substitute();
	toplevel_init_63_ast_substitute();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_substitute()
{
   module_initialization_70___object(((long) 0), "AST_SUBSTITUTE");
   module_initialization_70___reader(((long) 0), "AST_SUBSTITUTE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_substitute()
{
   {
      obj_t cnst_port_138_1537;
      cnst_port_138_1537 = open_input_string(string1700_ast_substitute);
      {
	 long i_1538;
	 i_1538 = ((long) 5);
       loop_1539:
	 {
	    bool_t test1701_1540;
	    test1701_1540 = (i_1538 == ((long) -1));
	    if (test1701_1540)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1702_1541;
		    {
		       obj_t list1703_1542;
		       {
			  obj_t arg1704_1543;
			  arg1704_1543 = BNIL;
			  list1703_1542 = MAKE_PAIR(cnst_port_138_1537, arg1704_1543);
		       }
		       arg1702_1541 = read___reader(list1703_1542);
		    }
		    CNST_TABLE_SET(i_1538, arg1702_1541);
		 }
		 {
		    int aux_1544;
		    {
		       long aux_1562;
		       aux_1562 = (i_1538 - ((long) 1));
		       aux_1544 = (int) (aux_1562);
		    }
		    {
		       long i_1565;
		       i_1565 = (long) (aux_1544);
		       i_1538 = i_1565;
		       goto loop_1539;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_substitute()
{
   add_generic__110___object(do_substitute__env_169_ast_substitute, do_substitute__default1308_env_164_ast_substitute);
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, var_ast_node, ((long) 1));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, kwote_ast_node, ((long) 2));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, sequence_ast_node, ((long) 3));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, app_ast_node, ((long) 4));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, setq_ast_node, ((long) 9));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, conditional_ast_node, ((long) 10));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, fail_ast_node, ((long) 11));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, select_ast_node, ((long) 12));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, let_fun_218_ast_node, ((long) 13));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, let_var_6_ast_node, ((long) 14));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, set_ex_it_116_ast_node, ((long) 15));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, jump_ex_it_184_ast_node, ((long) 16));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, make_box_202_ast_node, ((long) 17));
   add_inlined_method__244___object(do_substitute__env_169_ast_substitute, box_ref_242_ast_node, ((long) 18));
   {
      long aux_1587;
      aux_1587 = add_inlined_method__244___object(do_substitute__env_169_ast_substitute, box_set__221_ast_node, ((long) 19));
      return BINT(aux_1587);
   }
}


node_t 
substitute__30_ast_substitute(obj_t what__148_1, obj_t by__251_2, node_t node_3, obj_t site_4)
{
   {
      obj_t ll1272_680;
      obj_t ll1273_681;
      ll1272_680 = what__148_1;
      ll1273_681 = by__251_2;
    lname1283_682:
      if (NULLP(ll1272_680))
	{
	   ((bool_t) 1);
	}
      else
	{
	   {
	      obj_t by_685;
	      by_685 = CAR(ll1273_681);
	      {
		 obj_t res1665_1239;
		 {
		    variable_t obj_1237;
		    {
		       obj_t aux_1593;
		       aux_1593 = CAR(ll1272_680);
		       obj_1237 = (variable_t) (aux_1593);
		    }
		    {
		       obj_t x_1511;
		       x_1511 = ((((variable_t) CREF(obj_1237))->fast_alpha_7) = ((obj_t) by_685), BUNSPEC);
		       res1665_1239 = BUNSPEC;
		    }
		 }
		 res1665_1239;
	      }
	   }
	   {
	      obj_t ll1273_1599;
	      obj_t ll1272_1597;
	      ll1272_1597 = CDR(ll1272_680);
	      ll1273_1599 = CDR(ll1273_681);
	      ll1273_681 = ll1273_1599;
	      ll1272_680 = ll1272_1597;
	      goto lname1283_682;
	   }
	}
   }
   {
      node_t res_688;
      res_688 = do_substitute__77_ast_substitute(node_3, site_4);
      {
	 obj_t l1284_689;
	 l1284_689 = what__148_1;
       lname1285_690:
	 if (PAIRP(l1284_689))
	   {
	      {
		 obj_t res1666_1246;
		 {
		    variable_t obj_1244;
		    {
		       obj_t aux_1604;
		       aux_1604 = CAR(l1284_689);
		       obj_1244 = (variable_t) (aux_1604);
		    }
		    {
		       obj_t x_1512;
		       x_1512 = ((((variable_t) CREF(obj_1244))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
		       res1666_1246 = BUNSPEC;
		    }
		 }
		 res1666_1246;
	      }
	      {
		 obj_t l1284_1608;
		 l1284_1608 = CDR(l1284_689);
		 l1284_689 = l1284_1608;
		 goto lname1285_690;
	      }
	   }
	 else
	   {
	      ((bool_t) 1);
	   }
      }
      return res_688;
   }
}


obj_t 
_substitute__229_ast_substitute(obj_t env_1506, obj_t what__148_1507, obj_t by__251_1508, obj_t node_1509, obj_t site_1510)
{
   {
      node_t aux_1610;
      aux_1610 = substitute__30_ast_substitute(what__148_1507, by__251_1508, (node_t) (node_1509), site_1510);
      return (obj_t) (aux_1610);
   }
}


node_t 
do_substitute__default1308_48_ast_substitute(node_t node_7, obj_t site_8)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1695_ast_substitute, (obj_t) (node_7));
}


obj_t 
_do_substitute__default1308_120_ast_substitute(obj_t env_1503, obj_t node_1504, obj_t site_1505)
{
   {
      node_t aux_1617;
      aux_1617 = do_substitute__default1308_48_ast_substitute((node_t) (node_1504), site_1505);
      return (obj_t) (aux_1617);
   }
}


node_t 
do_substitute__77_ast_substitute(node_t node_5, obj_t site_6)
{
   {
      obj_t method1475_1019;
      obj_t class1480_1020;
      {
	 obj_t arg1484_1017;
	 obj_t arg1485_1018;
	 {
	    object_t obj_1253;
	    obj_1253 = (object_t) (node_5);
	    {
	       obj_t pre_method_105_1254;
	       pre_method_105_1254 = PROCEDURE_REF(do_substitute__env_169_ast_substitute, ((long) 2));
	       if (INTEGERP(pre_method_105_1254))
		 {
		    PROCEDURE_SET(do_substitute__env_169_ast_substitute, ((long) 2), BUNSPEC);
		    arg1484_1017 = pre_method_105_1254;
		 }
	       else
		 {
		    long obj_class_num_177_1259;
		    obj_class_num_177_1259 = TYPE(obj_1253);
		    {
		       obj_t arg1183_1260;
		       arg1183_1260 = PROCEDURE_REF(do_substitute__env_169_ast_substitute, ((long) 1));
		       {
			  long arg1184_1264;
			  {
			     long arg1186_1265;
			     arg1186_1265 = OBJECT_TYPE;
			     arg1184_1264 = (obj_class_num_177_1259 - arg1186_1265);
			  }
			  arg1484_1017 = VECTOR_REF(arg1183_1260, arg1184_1264);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1270;
	    object_1270 = (object_t) (node_5);
	    {
	       long arg1187_1271;
	       {
		  long arg1188_1272;
		  long arg1189_1273;
		  arg1188_1272 = TYPE(object_1270);
		  arg1189_1273 = OBJECT_TYPE;
		  arg1187_1271 = (arg1188_1272 - arg1189_1273);
	       }
	       {
		  obj_t vector_1277;
		  vector_1277 = __classes__134___object;
		  arg1485_1018 = VECTOR_REF(vector_1277, arg1187_1271);
	       }
	    }
	 }
	 {
	    obj_t aux_1636;
	    method1475_1019 = arg1484_1017;
	    class1480_1020 = arg1485_1018;
	    {
	       if (INTEGERP(method1475_1019))
		 {
		    switch ((long) CINT(method1475_1019))
		      {
		      case ((long) 0):
			 {
			    atom_t aux_1639;
			    aux_1639 = (atom_t) (node_5);
			    aux_1636 = (obj_t) (aux_1639);
			 }
			 break;
		      case ((long) 1):
			 {
			    var_t node_1028;
			    node_1028 = (var_t) (node_5);
			    {
			       variable_t var_1030;
			       var_1030 = (((var_t) CREF(node_1028))->variable);
			       {
				  {
				     obj_t alpha_1032;
				     alpha_1032 = (((variable_t) CREF(var_1030))->fast_alpha_7);
				   loop_1033:
				     if ((alpha_1032 == BUNSPEC))
				       {
					  aux_1636 = (obj_t) (node_1028);
				       }
				     else
				       {
					  bool_t test1489_1035;
					  test1489_1035 = is_a__118___object(alpha_1032, var_ast_node);
					  if (test1489_1035)
					    {
					       {
						  obj_t alpha_1649;
						  {
						     variable_t aux_1650;
						     {
							var_t obj_1284;
							obj_1284 = (var_t) (alpha_1032);
							aux_1650 = (((var_t) CREF(obj_1284))->variable);
						     }
						     alpha_1649 = (obj_t) (aux_1650);
						  }
						  alpha_1032 = alpha_1649;
						  goto loop_1033;
					       }
					    }
					  else
					    {
					       bool_t test1491_1037;
					       test1491_1037 = is_a__118___object(alpha_1032, variable_ast_var);
					       if (test1491_1037)
						 {
						    {
						       obj_t aux_1656;
						       {
							  node_t obj_1286;
							  obj_1286 = (node_t) (node_1028);
							  aux_1656 = (((node_t) CREF(obj_1286))->loc);
						       }
						       use_variable__4_ast_sexp((variable_t) (alpha_1032), aux_1656, site_6);
						    }
						    {
						       bool_t test1494_1039;
						       {
							  bool_t test1500_1044;
							  {
							     obj_t aux_1661;
							     {
								value_t aux_1662;
								{
								   variable_t obj_1287;
								   obj_1287 = (variable_t) (alpha_1032);
								   aux_1662 = (((variable_t) CREF(obj_1287))->value);
								}
								aux_1661 = (obj_t) (aux_1662);
							     }
							     test1500_1044 = is_a__118___object(aux_1661, fun_ast_var);
							  }
							  if (test1500_1044)
							    {
							       bool_t test_1668;
							       {
								  obj_t aux_1669;
								  aux_1669 = CNST_TABLE_REF(((long) 1));
								  test_1668 = (site_6 == aux_1669);
							       }
							       if (test_1668)
								 {
								    test1494_1039 = ((bool_t) 0);
								 }
							       else
								 {
								    test1494_1039 = ((bool_t) 1);
								 }
							    }
							  else
							    {
							       test1494_1039 = ((bool_t) 0);
							    }
						       }
						       if (test1494_1039)
							 {
							    obj_t arg1496_1040;
							    type_t arg1497_1041;
							    {
							       node_t obj_1291;
							       obj_1291 = (node_t) (node_1028);
							       arg1496_1040 = (((node_t) CREF(obj_1291))->loc);
							    }
							    {
							       node_t obj_1292;
							       obj_1292 = (node_t) (node_1028);
							       arg1497_1041 = (((node_t) CREF(obj_1292))->type);
							    }
							    {
							       closure_t res1667_1303;
							       {
								  variable_t variable_1295;
								  variable_1295 = (variable_t) (alpha_1032);
								  {
								     closure_t new1134_1296;
								     new1134_1296 = ((closure_t) BREF(GC_MALLOC(sizeof(struct closure))));
								     {
									long arg1418_1297;
									arg1418_1297 = class_num_218___object(closure_ast_node);
									{
									   obj_t obj_1301;
									   obj_1301 = (obj_t) (new1134_1296);
									   (((obj_t) CREF(obj_1301))->header = MAKE_HEADER(arg1418_1297, 0), BUNSPEC);
									}
								     }
								     {
									object_t aux_1682;
									aux_1682 = (object_t) (new1134_1296);
									OBJECT_WIDENING_SET(aux_1682, BFALSE);
								     }
								     ((((closure_t) CREF(new1134_1296))->loc) = ((obj_t) arg1496_1040), BUNSPEC);
								     ((((closure_t) CREF(new1134_1296))->type) = ((type_t) arg1497_1041), BUNSPEC);
								     ((((closure_t) CREF(new1134_1296))->variable) = ((variable_t) variable_1295), BUNSPEC);
								     res1667_1303 = new1134_1296;
								  }
							       }
							       aux_1636 = (obj_t) (res1667_1303);
							    }
							 }
						       else
							 {
							    obj_t arg1498_1042;
							    type_t arg1499_1043;
							    {
							       node_t obj_1304;
							       obj_1304 = (node_t) (node_1028);
							       arg1498_1042 = (((node_t) CREF(obj_1304))->loc);
							    }
							    {
							       node_t obj_1305;
							       obj_1305 = (node_t) (node_1028);
							       arg1499_1043 = (((node_t) CREF(obj_1305))->type);
							    }
							    {
							       var_t res1668_1316;
							       {
								  variable_t variable_1308;
								  variable_1308 = (variable_t) (alpha_1032);
								  {
								     var_t new1128_1309;
								     new1128_1309 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
								     {
									long arg1421_1310;
									arg1421_1310 = class_num_218___object(var_ast_node);
									{
									   obj_t obj_1314;
									   obj_1314 = (obj_t) (new1128_1309);
									   (((obj_t) CREF(obj_1314))->header = MAKE_HEADER(arg1421_1310, 0), BUNSPEC);
									}
								     }
								     {
									object_t aux_1698;
									aux_1698 = (object_t) (new1128_1309);
									OBJECT_WIDENING_SET(aux_1698, BFALSE);
								     }
								     ((((var_t) CREF(new1128_1309))->loc) = ((obj_t) arg1498_1042), BUNSPEC);
								     ((((var_t) CREF(new1128_1309))->type) = ((type_t) arg1499_1043), BUNSPEC);
								     ((((var_t) CREF(new1128_1309))->variable) = ((variable_t) variable_1308), BUNSPEC);
								     res1668_1316 = new1128_1309;
								  }
							       }
							       aux_1636 = (obj_t) (res1668_1316);
							    }
							 }
						    }
						 }
					       else
						 {
						    bool_t test1507_1048;
						    test1507_1048 = is_a__118___object(alpha_1032, atom_ast_node);
						    if (test1507_1048)
						      {
							 aux_1636 = alpha_1032;
						      }
						    else
						      {
							 {
							    obj_t arg1511_1051;
							    arg1511_1051 = shape_tools_shape((obj_t) (node_1028));
							    aux_1636 = internal_error_43_tools_error(string1696_ast_substitute, string1697_ast_substitute, arg1511_1051);
							 }
						      }
						 }
					    }
				       }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 2):
			 {
			    kwote_t aux_1711;
			    aux_1711 = (kwote_t) (node_5);
			    aux_1636 = (obj_t) (aux_1711);
			 }
			 break;
		      case ((long) 3):
			 {
			    sequence_t node_1054;
			    node_1054 = (sequence_t) (node_5);
			    do_substitute___56_ast_substitute((((sequence_t) CREF(node_1054))->nodes), site_6);
			    aux_1636 = (obj_t) (node_1054);
			 }
			 break;
		      case ((long) 4):
			 {
			    app_t node_1057;
			    node_1057 = (app_t) (node_5);
			    {
			       node_t arg1514_1059;
			       {
				  node_t aux_1719;
				  {
				     var_t aux_1720;
				     aux_1720 = (((app_t) CREF(node_1057))->fun);
				     aux_1719 = (node_t) (aux_1720);
				  }
				  arg1514_1059 = do_substitute__77_ast_substitute(aux_1719, CNST_TABLE_REF(((long) 1)));
			       }
			       {
				  obj_t res1669_1322;
				  {
				     var_t val1155_1321;
				     val1155_1321 = (var_t) (arg1514_1059);
				     {
					obj_t x_1513;
					x_1513 = ((((app_t) CREF(node_1057))->fun) = ((var_t) val1155_1321), BUNSPEC);
					res1669_1322 = BUNSPEC;
				     }
				  }
				  res1669_1322;
			       }
			    }
			    do_substitute___56_ast_substitute((((app_t) CREF(node_1057))->args), CNST_TABLE_REF(((long) 2)));
			    aux_1636 = (obj_t) (node_1057);
			 }
			 break;
		      case ((long) 5):
			 {
			    app_ly_162_t node_1064;
			    node_1064 = (app_ly_162_t) (node_5);
			    {
			       node_t nfun_1067;
			       node_t narg_1068;
			       nfun_1067 = do_substitute__77_ast_substitute((((app_ly_162_t) CREF(node_1064))->fun), CNST_TABLE_REF(((long) 3)));
			       narg_1068 = do_substitute__77_ast_substitute((((app_ly_162_t) CREF(node_1064))->arg), CNST_TABLE_REF(((long) 2)));
			       {
				  bool_t test1523_1069;
				  test1523_1069 = is_a__118___object((obj_t) (nfun_1067), closure_ast_node);
				  if (test1523_1069)
				    {
				       obj_t arg1526_1071;
				       var_t arg1529_1072;
				       arg1526_1071 = (((app_ly_162_t) CREF(node_1064))->loc);
				       {
					  var_t duplicated1287_1073;
					  duplicated1287_1073 = (var_t) (nfun_1067);
					  {
					     obj_t arg1531_1074;
					     type_t arg1532_1075;
					     variable_t arg1534_1076;
					     arg1531_1074 = (((var_t) CREF(duplicated1287_1073))->loc);
					     arg1532_1075 = (((var_t) CREF(duplicated1287_1073))->type);
					     arg1534_1076 = (((var_t) CREF(duplicated1287_1073))->variable);
					     {
						var_t res1670_1341;
						{
						   var_t new1128_1334;
						   new1128_1334 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
						   {
						      long arg1421_1335;
						      arg1421_1335 = class_num_218___object(var_ast_node);
						      {
							 obj_t obj_1339;
							 obj_1339 = (obj_t) (new1128_1334);
							 (((obj_t) CREF(obj_1339))->header = MAKE_HEADER(arg1421_1335, 0), BUNSPEC);
						      }
						   }
						   {
						      object_t aux_1750;
						      aux_1750 = (object_t) (new1128_1334);
						      OBJECT_WIDENING_SET(aux_1750, BFALSE);
						   }
						   ((((var_t) CREF(new1128_1334))->loc) = ((obj_t) arg1531_1074), BUNSPEC);
						   ((((var_t) CREF(new1128_1334))->type) = ((type_t) arg1532_1075), BUNSPEC);
						   ((((var_t) CREF(new1128_1334))->variable) = ((variable_t) arg1534_1076), BUNSPEC);
						   res1670_1341 = new1128_1334;
						}
						arg1529_1072 = res1670_1341;
					     }
					  }
				       }
				       {
					  node_t aux_1756;
					  aux_1756 = known_app_ly__node_26_ast_apply(BNIL, arg1526_1071, (node_t) (arg1529_1072), narg_1068, site_6);
					  aux_1636 = (obj_t) (aux_1756);
				       }
				    }
				  else
				    {
				       {
					  obj_t res1671_1344;
					  {
					     obj_t x_1514;
					     x_1514 = ((((app_ly_162_t) CREF(node_1064))->fun) = ((node_t) nfun_1067), BUNSPEC);
					     res1671_1344 = BUNSPEC;
					  }
					  res1671_1344;
				       }
				       {
					  obj_t res1672_1347;
					  {
					     obj_t x_1515;
					     x_1515 = ((((app_ly_162_t) CREF(node_1064))->arg) = ((node_t) narg_1068), BUNSPEC);
					     res1672_1347 = BUNSPEC;
					  }
					  res1672_1347;
				       }
				       aux_1636 = (obj_t) (node_1064);
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 6):
			 {
			    funcall_t node_1081;
			    node_1081 = (funcall_t) (node_5);
			    {
			       node_t nfun_1084;
			       obj_t nargs_1085;
			       nfun_1084 = do_substitute__77_ast_substitute((((funcall_t) CREF(node_1081))->fun), CNST_TABLE_REF(((long) 2)));
			       {
				  obj_t l1289_1104;
				  l1289_1104 = (((funcall_t) CREF(node_1081))->args);
				  if (NULLP(l1289_1104))
				    {
				       nargs_1085 = BNIL;
				    }
				  else
				    {
				       obj_t head1291_1106;
				       head1291_1106 = MAKE_PAIR(BNIL, BNIL);
				       {
					  obj_t l1289_1107;
					  obj_t tail1292_1108;
					  l1289_1107 = l1289_1104;
					  tail1292_1108 = head1291_1106;
					lname1290_1109:
					  if (NULLP(l1289_1107))
					    {
					       nargs_1085 = CDR(head1291_1106);
					    }
					  else
					    {
					       obj_t new_tail1293_138_1111;
					       {
						  node_t arg1565_1113;
						  {
						     node_t aux_1774;
						     {
							obj_t aux_1775;
							aux_1775 = CAR(l1289_1107);
							aux_1774 = (node_t) (aux_1775);
						     }
						     arg1565_1113 = do_substitute__77_ast_substitute(aux_1774, CNST_TABLE_REF(((long) 2)));
						  }
						  {
						     obj_t aux_1780;
						     aux_1780 = (obj_t) (arg1565_1113);
						     new_tail1293_138_1111 = MAKE_PAIR(aux_1780, BNIL);
						  }
					       }
					       SET_CDR(tail1292_1108, new_tail1293_138_1111);
					       {
						  obj_t tail1292_1786;
						  obj_t l1289_1784;
						  l1289_1784 = CDR(l1289_1107);
						  tail1292_1786 = new_tail1293_138_1111;
						  tail1292_1108 = tail1292_1786;
						  l1289_1107 = l1289_1784;
						  goto lname1290_1109;
					       }
					    }
				       }
				    }
			       }
			       {
				  bool_t test1539_1086;
				  {
				     bool_t test1555_1098;
				     test1555_1098 = is_a__118___object((obj_t) (nfun_1084), closure_ast_node);
				     if (test1555_1098)
				       {
					  test1539_1086 = ((bool_t) 1);
				       }
				     else
				       {
					  bool_t _andtest_1294_1099;
					  _andtest_1294_1099 = is_a__118___object((obj_t) (nfun_1084), var_ast_node);
					  if (_andtest_1294_1099)
					    {
					       obj_t aux_1793;
					       {
						  value_t aux_1794;
						  {
						     variable_t arg1559_1101;
						     {
							var_t obj_1363;
							obj_1363 = (var_t) (nfun_1084);
							arg1559_1101 = (((var_t) CREF(obj_1363))->variable);
						     }
						     aux_1794 = (((variable_t) CREF(arg1559_1101))->value);
						  }
						  aux_1793 = (obj_t) (aux_1794);
					       }
					       test1539_1086 = is_a__118___object(aux_1793, fun_ast_var);
					    }
					  else
					    {
					       test1539_1086 = ((bool_t) 0);
					    }
				       }
				  }
				  if (test1539_1086)
				    {
				       bool_t test1540_1087;
				       {
					  variable_t aux_1801;
					  {
					     var_t obj_1366;
					     obj_1366 = (var_t) (nfun_1084);
					     aux_1801 = (((var_t) CREF(obj_1366))->variable);
					  }
					  test1540_1087 = correct_arity_app__187_ast_app(aux_1801, CDR(nargs_1085));
				       }
				       if (test1540_1087)
					 {
					    node_t aux_1807;
					    aux_1807 = make_app_node_80_ast_app(BNIL, (((funcall_t) CREF(node_1081))->loc), (var_t) (nfun_1084), CDR(nargs_1085));
					    aux_1636 = (obj_t) (aux_1807);
					 }
				       else
					 {
					    obj_t arg1547_1091;
					    obj_t arg1551_1094;
					    arg1547_1091 = (((funcall_t) CREF(node_1081))->loc);
					    arg1551_1094 = shape_tools_shape((obj_t) (node_1081));
					    aux_1636 = user_error_location_137_tools_error(arg1547_1091, string1698_ast_substitute, string1699_ast_substitute, arg1551_1094, BNIL);
					 }
				    }
				  else
				    {
				       {
					  obj_t res1673_1373;
					  {
					     obj_t x_1516;
					     x_1516 = ((((funcall_t) CREF(node_1081))->fun) = ((node_t) nfun_1084), BUNSPEC);
					     res1673_1373 = BUNSPEC;
					  }
					  res1673_1373;
				       }
				       {
					  obj_t res1674_1376;
					  {
					     obj_t x_1517;
					     x_1517 = ((((funcall_t) CREF(node_1081))->args) = ((obj_t) nargs_1085), BUNSPEC);
					     res1674_1376 = BUNSPEC;
					  }
					  res1674_1376;
				       }
				       aux_1636 = (obj_t) (node_1081);
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 7):
			 {
			    pragma_t node_1119;
			    node_1119 = (pragma_t) (node_5);
			    do_substitute___56_ast_substitute((((pragma_t) CREF(node_1119))->args), site_6);
			    aux_1636 = (obj_t) (node_1119);
			 }
			 break;
		      case ((long) 8):
			 {
			    cast_t node_1122;
			    node_1122 = (cast_t) (node_5);
			    do_substitute__77_ast_substitute((((cast_t) CREF(node_1122))->arg), site_6);
			    aux_1636 = (obj_t) (node_1122);
			 }
			 break;
		      case ((long) 9):
			 {
			    setq_t node_1125;
			    node_1125 = (setq_t) (node_5);
			    {
			       node_t arg1573_1128;
			       {
				  node_t aux_1829;
				  {
				     var_t aux_1830;
				     aux_1830 = (((setq_t) CREF(node_1125))->var);
				     aux_1829 = (node_t) (aux_1830);
				  }
				  arg1573_1128 = do_substitute__77_ast_substitute(aux_1829, CNST_TABLE_REF(((long) 4)));
			       }
			       {
				  obj_t res1675_1382;
				  {
				     var_t val1191_1381;
				     val1191_1381 = (var_t) (arg1573_1128);
				     {
					obj_t x_1518;
					x_1518 = ((((setq_t) CREF(node_1125))->var) = ((var_t) val1191_1381), BUNSPEC);
					res1675_1382 = BUNSPEC;
				     }
				  }
				  res1675_1382;
			       }
			    }
			    {
			       node_t arg1576_1131;
			       arg1576_1131 = do_substitute__77_ast_substitute((((setq_t) CREF(node_1125))->value), site_6);
			       {
				  obj_t res1676_1386;
				  {
				     obj_t x_1519;
				     x_1519 = ((((setq_t) CREF(node_1125))->value) = ((node_t) arg1576_1131), BUNSPEC);
				     res1676_1386 = BUNSPEC;
				  }
				  res1676_1386;
			       }
			    }
			    aux_1636 = (obj_t) (node_1125);
			 }
			 break;
		      case ((long) 10):
			 {
			    conditional_t node_1133;
			    node_1133 = (conditional_t) (node_5);
			    {
			       node_t arg1578_1136;
			       arg1578_1136 = do_substitute__77_ast_substitute((((conditional_t) CREF(node_1133))->test), CNST_TABLE_REF(((long) 2)));
			       {
				  obj_t res1677_1390;
				  {
				     obj_t x_1520;
				     x_1520 = ((((conditional_t) CREF(node_1133))->test) = ((node_t) arg1578_1136), BUNSPEC);
				     res1677_1390 = BUNSPEC;
				  }
				  res1677_1390;
			       }
			    }
			    {
			       node_t arg1583_1139;
			       arg1583_1139 = do_substitute__77_ast_substitute((((conditional_t) CREF(node_1133))->true), site_6);
			       {
				  obj_t res1678_1394;
				  {
				     obj_t x_1521;
				     x_1521 = ((((conditional_t) CREF(node_1133))->true) = ((node_t) arg1583_1139), BUNSPEC);
				     res1678_1394 = BUNSPEC;
				  }
				  res1678_1394;
			       }
			    }
			    {
			       node_t arg1585_1141;
			       arg1585_1141 = do_substitute__77_ast_substitute((((conditional_t) CREF(node_1133))->false), site_6);
			       {
				  obj_t res1679_1398;
				  {
				     obj_t x_1522;
				     x_1522 = ((((conditional_t) CREF(node_1133))->false) = ((node_t) arg1585_1141), BUNSPEC);
				     res1679_1398 = BUNSPEC;
				  }
				  res1679_1398;
			       }
			    }
			    aux_1636 = (obj_t) (node_1133);
			 }
			 break;
		      case ((long) 11):
			 {
			    fail_t node_1143;
			    node_1143 = (fail_t) (node_5);
			    {
			       node_t arg1588_1146;
			       arg1588_1146 = do_substitute__77_ast_substitute((((fail_t) CREF(node_1143))->proc), CNST_TABLE_REF(((long) 2)));
			       {
				  obj_t res1680_1402;
				  {
				     obj_t x_1523;
				     x_1523 = ((((fail_t) CREF(node_1143))->proc) = ((node_t) arg1588_1146), BUNSPEC);
				     res1680_1402 = BUNSPEC;
				  }
				  res1680_1402;
			       }
			    }
			    {
			       node_t arg1591_1149;
			       arg1591_1149 = do_substitute__77_ast_substitute((((fail_t) CREF(node_1143))->msg), CNST_TABLE_REF(((long) 2)));
			       {
				  obj_t res1681_1406;
				  {
				     obj_t x_1524;
				     x_1524 = ((((fail_t) CREF(node_1143))->msg) = ((node_t) arg1591_1149), BUNSPEC);
				     res1681_1406 = BUNSPEC;
				  }
				  res1681_1406;
			       }
			    }
			    {
			       node_t arg1595_1152;
			       arg1595_1152 = do_substitute__77_ast_substitute((((fail_t) CREF(node_1143))->obj), CNST_TABLE_REF(((long) 2)));
			       {
				  obj_t res1682_1410;
				  {
				     obj_t x_1525;
				     x_1525 = ((((fail_t) CREF(node_1143))->obj) = ((node_t) arg1595_1152), BUNSPEC);
				     res1682_1410 = BUNSPEC;
				  }
				  res1682_1410;
			       }
			    }
			    aux_1636 = (obj_t) (node_1143);
			 }
			 break;
		      case ((long) 12):
			 {
			    select_t node_1155;
			    node_1155 = (select_t) (node_5);
			    {
			       node_t arg1600_1157;
			       arg1600_1157 = do_substitute__77_ast_substitute((((select_t) CREF(node_1155))->test), CNST_TABLE_REF(((long) 2)));
			       {
				  obj_t res1683_1414;
				  {
				     obj_t x_1526;
				     x_1526 = ((((select_t) CREF(node_1155))->test) = ((node_t) arg1600_1157), BUNSPEC);
				     res1683_1414 = BUNSPEC;
				  }
				  res1683_1414;
			       }
			    }
			    {
			       obj_t l1298_1160;
			       l1298_1160 = (((select_t) CREF(node_1155))->clauses);
			     lname1301_1161:
			       if (PAIRP(l1298_1160))
				 {
				    {
				       obj_t clause_1164;
				       clause_1164 = CAR(l1298_1160);
				       {
					  node_t arg1606_1165;
					  {
					     node_t aux_1875;
					     {
						obj_t aux_1876;
						aux_1876 = CDR(clause_1164);
						aux_1875 = (node_t) (aux_1876);
					     }
					     arg1606_1165 = do_substitute__77_ast_substitute(aux_1875, site_6);
					  }
					  {
					     obj_t aux_1880;
					     aux_1880 = (obj_t) (arg1606_1165);
					     SET_CDR(clause_1164, aux_1880);
					  }
				       }
				    }
				    {
				       obj_t l1298_1883;
				       l1298_1883 = CDR(l1298_1160);
				       l1298_1160 = l1298_1883;
				       goto lname1301_1161;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_1636 = (obj_t) (node_1155);
			 }
			 break;
		      case ((long) 13):
			 {
			    let_fun_218_t node_1168;
			    node_1168 = (let_fun_218_t) (node_5);
			    {
			       obj_t l1302_1170;
			       l1302_1170 = (((let_fun_218_t) CREF(node_1168))->locals);
			     lname1304_1171:
			       if (PAIRP(l1302_1170))
				 {
				    {
				       value_t fun_1175;
				       {
					  local_t obj_1425;
					  {
					     obj_t aux_1890;
					     aux_1890 = CAR(l1302_1170);
					     obj_1425 = (local_t) (aux_1890);
					  }
					  fun_1175 = (((local_t) CREF(obj_1425))->value);
				       }
				       {
					  node_t arg1614_1176;
					  {
					     node_t aux_1894;
					     {
						obj_t aux_1895;
						{
						   sfun_t obj_1426;
						   obj_1426 = (sfun_t) (fun_1175);
						   aux_1895 = (((sfun_t) CREF(obj_1426))->body);
						}
						aux_1894 = (node_t) (aux_1895);
					     }
					     arg1614_1176 = do_substitute__77_ast_substitute(aux_1894, CNST_TABLE_REF(((long) 2)));
					  }
					  {
					     obj_t res1684_1429;
					     {
						sfun_t obj_1427;
						obj_t val1077_1428;
						obj_1427 = (sfun_t) (fun_1175);
						val1077_1428 = (obj_t) (arg1614_1176);
						{
						   obj_t x_1527;
						   x_1527 = ((((sfun_t) CREF(obj_1427))->body) = ((obj_t) val1077_1428), BUNSPEC);
						   res1684_1429 = BUNSPEC;
						}
					     }
					     res1684_1429;
					  }
				       }
				    }
				    {
				       obj_t l1302_1904;
				       l1302_1904 = CDR(l1302_1170);
				       l1302_1170 = l1302_1904;
				       goto lname1304_1171;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1619_1180;
			       arg1619_1180 = do_substitute__77_ast_substitute((((let_fun_218_t) CREF(node_1168))->body), site_6);
			       {
				  obj_t res1685_1434;
				  {
				     obj_t x_1528;
				     x_1528 = ((((let_fun_218_t) CREF(node_1168))->body) = ((node_t) arg1619_1180), BUNSPEC);
				     res1685_1434 = BUNSPEC;
				  }
				  res1685_1434;
			       }
			    }
			    aux_1636 = (obj_t) (node_1168);
			 }
			 break;
		      case ((long) 14):
			 {
			    let_var_6_t node_1182;
			    node_1182 = (let_var_6_t) (node_5);
			    {
			       obj_t l1305_1184;
			       l1305_1184 = (((let_var_6_t) CREF(node_1182))->bindings);
			     lname1307_1185:
			       if (PAIRP(l1305_1184))
				 {
				    {
				       obj_t binding_1188;
				       binding_1188 = CAR(l1305_1184);
				       {
					  node_t arg1623_1189;
					  {
					     node_t aux_1915;
					     {
						obj_t aux_1916;
						aux_1916 = CDR(binding_1188);
						aux_1915 = (node_t) (aux_1916);
					     }
					     arg1623_1189 = do_substitute__77_ast_substitute(aux_1915, CNST_TABLE_REF(((long) 2)));
					  }
					  {
					     obj_t aux_1921;
					     aux_1921 = (obj_t) (arg1623_1189);
					     SET_CDR(binding_1188, aux_1921);
					  }
				       }
				    }
				    {
				       obj_t l1305_1924;
				       l1305_1924 = CDR(l1305_1184);
				       l1305_1184 = l1305_1924;
				       goto lname1307_1185;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1628_1193;
			       arg1628_1193 = do_substitute__77_ast_substitute((((let_var_6_t) CREF(node_1182))->body), site_6);
			       {
				  obj_t res1686_1445;
				  {
				     obj_t x_1529;
				     x_1529 = ((((let_var_6_t) CREF(node_1182))->body) = ((node_t) arg1628_1193), BUNSPEC);
				     res1686_1445 = BUNSPEC;
				  }
				  res1686_1445;
			       }
			    }
			    aux_1636 = (obj_t) (node_1182);
			 }
			 break;
		      case ((long) 15):
			 {
			    set_ex_it_116_t node_1195;
			    node_1195 = (set_ex_it_116_t) (node_5);
			    {
			       node_t arg1632_1197;
			       arg1632_1197 = do_substitute__77_ast_substitute((((set_ex_it_116_t) CREF(node_1195))->body), site_6);
			       {
				  obj_t res1687_1449;
				  {
				     obj_t x_1530;
				     x_1530 = ((((set_ex_it_116_t) CREF(node_1195))->body) = ((node_t) arg1632_1197), BUNSPEC);
				     res1687_1449 = BUNSPEC;
				  }
				  res1687_1449;
			       }
			    }
			    aux_1636 = (obj_t) (node_1195);
			 }
			 break;
		      case ((long) 16):
			 {
			    jump_ex_it_184_t node_1199;
			    node_1199 = (jump_ex_it_184_t) (node_5);
			    {
			       node_t arg1637_1201;
			       arg1637_1201 = do_substitute__77_ast_substitute((((jump_ex_it_184_t) CREF(node_1199))->exit), CNST_TABLE_REF(((long) 1)));
			       {
				  obj_t res1688_1453;
				  {
				     obj_t x_1531;
				     x_1531 = ((((jump_ex_it_184_t) CREF(node_1199))->exit) = ((node_t) arg1637_1201), BUNSPEC);
				     res1688_1453 = BUNSPEC;
				  }
				  res1688_1453;
			       }
			    }
			    {
			       node_t arg1642_1204;
			       arg1642_1204 = do_substitute__77_ast_substitute((((jump_ex_it_184_t) CREF(node_1199))->value), CNST_TABLE_REF(((long) 2)));
			       {
				  obj_t res1689_1457;
				  {
				     obj_t x_1532;
				     x_1532 = ((((jump_ex_it_184_t) CREF(node_1199))->value) = ((node_t) arg1642_1204), BUNSPEC);
				     res1689_1457 = BUNSPEC;
				  }
				  res1689_1457;
			       }
			    }
			    aux_1636 = (obj_t) (node_1199);
			 }
			 break;
		      case ((long) 17):
			 {
			    make_box_202_t node_1207;
			    node_1207 = (make_box_202_t) (node_5);
			    {
			       node_t arg1645_1209;
			       arg1645_1209 = do_substitute__77_ast_substitute((((make_box_202_t) CREF(node_1207))->value), CNST_TABLE_REF(((long) 2)));
			       {
				  obj_t res1690_1461;
				  {
				     obj_t x_1533;
				     x_1533 = ((((make_box_202_t) CREF(node_1207))->value) = ((node_t) arg1645_1209), BUNSPEC);
				     res1690_1461 = BUNSPEC;
				  }
				  res1690_1461;
			       }
			    }
			    aux_1636 = (obj_t) (node_1207);
			 }
			 break;
		      case ((long) 18):
			 {
			    box_ref_242_t node_1212;
			    node_1212 = (box_ref_242_t) (node_5);
			    {
			       node_t arg1648_1214;
			       {
				  node_t aux_1953;
				  {
				     var_t aux_1954;
				     aux_1954 = (((box_ref_242_t) CREF(node_1212))->var);
				     aux_1953 = (node_t) (aux_1954);
				  }
				  arg1648_1214 = do_substitute__77_ast_substitute(aux_1953, CNST_TABLE_REF(((long) 2)));
			       }
			       {
				  obj_t res1691_1465;
				  {
				     var_t val1263_1464;
				     val1263_1464 = (var_t) (arg1648_1214);
				     {
					obj_t x_1534;
					x_1534 = ((((box_ref_242_t) CREF(node_1212))->var) = ((var_t) val1263_1464), BUNSPEC);
					res1691_1465 = BUNSPEC;
				     }
				  }
				  res1691_1465;
			       }
			    }
			    aux_1636 = (obj_t) (node_1212);
			 }
			 break;
		      case ((long) 19):
			 {
			    box_set__221_t node_1217;
			    node_1217 = (box_set__221_t) (node_5);
			    {
			       node_t arg1652_1219;
			       {
				  node_t aux_1963;
				  {
				     var_t aux_1964;
				     aux_1964 = (((box_set__221_t) CREF(node_1217))->var);
				     aux_1963 = (node_t) (aux_1964);
				  }
				  arg1652_1219 = do_substitute__77_ast_substitute(aux_1963, CNST_TABLE_REF(((long) 2)));
			       }
			       {
				  obj_t res1692_1469;
				  {
				     var_t val1269_1468;
				     val1269_1468 = (var_t) (arg1652_1219);
				     {
					obj_t x_1535;
					x_1535 = ((((box_set__221_t) CREF(node_1217))->var) = ((var_t) val1269_1468), BUNSPEC);
					res1692_1469 = BUNSPEC;
				     }
				  }
				  res1692_1469;
			       }
			    }
			    {
			       node_t arg1655_1222;
			       arg1655_1222 = do_substitute__77_ast_substitute((((box_set__221_t) CREF(node_1217))->value), CNST_TABLE_REF(((long) 2)));
			       {
				  obj_t res1693_1473;
				  {
				     obj_t x_1536;
				     x_1536 = ((((box_set__221_t) CREF(node_1217))->value) = ((node_t) arg1655_1222), BUNSPEC);
				     res1693_1473 = BUNSPEC;
				  }
				  res1693_1473;
			       }
			    }
			    aux_1636 = (obj_t) (node_1217);
			 }
			 break;
		      default:
		       case_else1481_6_1023:
			 if (PROCEDUREP(method1475_1019))
			   {
			      aux_1636 = PROCEDURE_ENTRY(method1475_1019) (method1475_1019, (obj_t) (node_5), site_6, BEOA);
			   }
			 else
			   {
			      obj_t fun1341_696;
			      fun1341_696 = PROCEDURE_REF(do_substitute__env_169_ast_substitute, ((long) 0));
			      aux_1636 = PROCEDURE_ENTRY(fun1341_696) (fun1341_696, (obj_t) (node_5), site_6, BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1481_6_1023;
		 }
	    }
	    return (node_t) (aux_1636);
	 }
      }
   }
}


obj_t 
_do_substitute__221_ast_substitute(obj_t env_1500, obj_t node_1501, obj_t site_1502)
{
   {
      node_t aux_1988;
      aux_1988 = do_substitute__77_ast_substitute((node_t) (node_1501), site_1502);
      return (obj_t) (aux_1988);
   }
}


obj_t 
do_substitute___56_ast_substitute(obj_t node__221_49, obj_t site_50)
{
 do_substitute___56_ast_substitute:
   if (NULLP(node__221_49))
     {
	return CNST_TABLE_REF(((long) 5));
     }
   else
     {
	bool_t test_1995;
	{
	   obj_t aux_1996;
	   aux_1996 = CDR(node__221_49);
	   test_1995 = NULLP(aux_1996);
	}
	if (test_1995)
	  {
	     {
		node_t arg1345_699;
		{
		   node_t aux_1999;
		   {
		      obj_t aux_2000;
		      aux_2000 = CAR(node__221_49);
		      aux_1999 = (node_t) (aux_2000);
		   }
		   arg1345_699 = do_substitute__77_ast_substitute(aux_1999, site_50);
		}
		{
		   obj_t aux_2004;
		   aux_2004 = (obj_t) (arg1345_699);
		   SET_CAR(node__221_49, aux_2004);
		}
	     }
	     return CNST_TABLE_REF(((long) 5));
	  }
	else
	  {
	     {
		node_t arg1347_701;
		{
		   node_t aux_2008;
		   {
		      obj_t aux_2009;
		      aux_2009 = CAR(node__221_49);
		      aux_2008 = (node_t) (aux_2009);
		   }
		   arg1347_701 = do_substitute__77_ast_substitute(aux_2008, CNST_TABLE_REF(((long) 2)));
		}
		{
		   obj_t aux_2014;
		   aux_2014 = (obj_t) (arg1347_701);
		   SET_CAR(node__221_49, aux_2014);
		}
	     }
	     {
		obj_t node__221_2017;
		node__221_2017 = CDR(node__221_49);
		node__221_49 = node__221_2017;
		goto do_substitute___56_ast_substitute;
	     }
	  }
     }
}


obj_t 
imported_modules_init_94_ast_substitute()
{
   module_initialization_70_tools_trace(((long) 0), "AST_SUBSTITUTE");
   module_initialization_70_type_type(((long) 0), "AST_SUBSTITUTE");
   module_initialization_70_type_cache(((long) 0), "AST_SUBSTITUTE");
   module_initialization_70_ast_var(((long) 0), "AST_SUBSTITUTE");
   module_initialization_70_ast_node(((long) 0), "AST_SUBSTITUTE");
   module_initialization_70_tools_shape(((long) 0), "AST_SUBSTITUTE");
   module_initialization_70_tools_error(((long) 0), "AST_SUBSTITUTE");
   module_initialization_70_ast_apply(((long) 0), "AST_SUBSTITUTE");
   module_initialization_70_ast_app(((long) 0), "AST_SUBSTITUTE");
   return module_initialization_70_ast_sexp(((long) 0), "AST_SUBSTITUTE");
}
