/*===========================================================================*/
/*   (Ast/unit.scm)                                                          */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;


extern obj_t dsssl_named_constant__188_tools_dsssl(obj_t);
extern obj_t make_n_proto_123_tools_args(obj_t);
extern global_t def_global_sfun__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t make_sfun_definition_61_ast_unit(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t find_global_defs_64_ast_find_gdefs_13(obj_t);
extern obj_t global_ast_var;
extern obj_t args___args_list_50_tools_args(obj_t);
extern obj_t fun_ast_var;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t _user_error_251_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t replace__160_tools_misc(obj_t, obj_t);
extern obj_t normalize_progn_143_tools_progn(obj_t);
extern obj_t last_pair_93___r4_pairs_and_lists_6_3(obj_t);
static obj_t imported_modules_init_94_ast_unit();
extern obj_t module_initialization_70_ast_unit(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_ast_find_gdefs_13(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_object_generic(long, char *);
extern obj_t module_initialization_70_object_method(long, char *);
extern obj_t module_initialization_70_object_inline(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_dsssl(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___dsssl(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t toplevel_init_63_ast_unit();
extern obj_t make_dsssl_function_prelude_58___dsssl(obj_t, obj_t, obj_t, obj_t);
static obj_t cnst_init_137_ast_unit();
static obj_t get_global_arity_252_ast_unit(obj_t, obj_t, obj_t);
static obj_t toplevel__ast_219_ast_unit(obj_t, obj_t);
extern obj_t __compiler_debug__134_engine_param;
extern obj_t __module__166_module_module;
extern obj_t unit__defs_135_ast_unit(obj_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t unit_initializers_25_ast_unit();
extern obj_t unit_init_calls_56_ast_unit();
static obj_t make_sgfun_definition_102_ast_unit(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __unit_list__71_ast_unit = BUNSPEC;
static obj_t require_initialization_114_ast_unit = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_ast_unit();
extern obj_t add_generic_for_method_inlining__147_object_inline(obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t _unit__defs_170_ast_unit(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t _unit_sexp__add__174_ast_unit(obj_t, obj_t, obj_t);
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t id_of_id_112_ast_ident(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t check_id_6_ast_ident(obj_t, obj_t);
static obj_t make_sgfun_default_250_ast_unit(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern global_t def_global_svar__184_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t declare_unit__164_ast_unit(obj_t, long);
extern obj_t unit_sexp__add__71_ast_unit(obj_t, obj_t);
static obj_t make_method_definition_178_ast_unit(obj_t, obj_t, obj_t, obj_t);
extern obj_t find_location_120_tools_location(obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t dsssl_find_first_formal_237_tools_dsssl(obj_t);
extern node_t error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
extern obj_t make_generic_body_233_object_generic(obj_t, obj_t, obj_t, obj_t);
extern obj_t _unit_initializers_20_ast_unit(obj_t);
extern obj_t string_downcase__42___r4_strings_6_7(obj_t);
static obj_t toplevel___ast_181_ast_unit(obj_t, obj_t);
extern bool_t check_method_definition_71_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
static obj_t make_svar_definition_154_ast_unit(obj_t, obj_t);
extern obj_t _4dots_tools_misc;
static obj_t unit_initializer_id_235_ast_unit(obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _____74_type_cache;
static obj_t eta_expanse_111_ast_unit(obj_t, obj_t);
extern obj_t __obj__252_type_cache;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
extern obj_t _unit_init_calls_204_ast_unit(obj_t);
static obj_t normalize_progn_error_20_ast_unit(obj_t, obj_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern obj_t make_method_body_103_object_method(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[25];

DEFINE_STRING(string2254_ast_unit, string2254_ast_unit2267, "Illegal '() expression", 22);
DEFINE_STRING(string2261_ast_unit, string2261_ast_unit2268, "ADD-GENERIC! SGFUN -DEFAULT QUOTE ERROR NOW CONS* APPLY DEFINE-METHOD DEFINE-GENERIC SIFUN DEFINE-INLINE DEFINE BEGIN LAMBDA SFUN READ @ -INIT CGEN SNIFUN ::OBJ AST *DEBUG* SET! ", 178);
DEFINE_STRING(string2256_ast_unit, string2256_ast_unit2269, "make-sgfun-default: ", 20);
DEFINE_EXPORT_PROCEDURE(unit__defs_env_18_ast_unit, _unit__defs_170_ast_unit2270, _unit__defs_170_ast_unit, 0L, 1);
DEFINE_STRING(string2257_ast_unit, string2257_ast_unit2271, "No method for this object", 25);
DEFINE_STRING(string2255_ast_unit, string2255_ast_unit2272, " ", 1);
DEFINE_EXPORT_PROCEDURE(unit_initializers_env_47_ast_unit, _unit_initializers_20_ast_unit2273, _unit_initializers_20_ast_unit, 0L, 0);
DEFINE_STRING(string2253_ast_unit, string2253_ast_unit2274, "unit->defs: ", 12);
DEFINE_STRING(string2251_ast_unit, string2251_ast_unit2275, "]", 1);
DEFINE_STRING(string2252_ast_unit, string2252_ast_unit2276, "      [", 7);
DEFINE_STRING(string2259_ast_unit, string2259_ast_unit2277, "make-sgfun-definition: ", 23);
DEFINE_STRING(string2258_ast_unit, string2258_ast_unit2278, "  le body: ", 11);
extern obj_t user_error_env_101_tools_error;
DEFINE_STRING(string2260_ast_unit, string2260_ast_unit2279, "  body: ", 8);
DEFINE_EXPORT_PROCEDURE(unit_init_calls_env_88_ast_unit, _unit_init_calls_204_ast_unit2280, _unit_init_calls_204_ast_unit, 0L, 0);
DEFINE_EXPORT_PROCEDURE(unit_sexp__add__env_136_ast_unit, _unit_sexp__add__174_ast_unit2281, _unit_sexp__add__174_ast_unit, 0L, 2);

obj_t 
module_initialization_70_ast_unit(long checksum_2632, char *from_2633)
{
   if (CBOOL(require_initialization_114_ast_unit))
     {
	require_initialization_114_ast_unit = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_unit();
	cnst_init_137_ast_unit();
	imported_modules_init_94_ast_unit();
	toplevel_init_63_ast_unit();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_unit()
{
   module_initialization_70___object(((long) 0), "AST_UNIT");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_UNIT");
   module_initialization_70___dsssl(((long) 0), "AST_UNIT");
   module_initialization_70___reader(((long) 0), "AST_UNIT");
   module_initialization_70___r4_symbols_6_4(((long) 0), "AST_UNIT");
   module_initialization_70___r4_strings_6_7(((long) 0), "AST_UNIT");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_unit()
{
   {
      obj_t cnst_port_138_2624;
      cnst_port_138_2624 = open_input_string(string2261_ast_unit);
      {
	 long i_2625;
	 i_2625 = ((long) 24);
       loop_2626:
	 {
	    bool_t test2262_2627;
	    test2262_2627 = (i_2625 == ((long) -1));
	    if (test2262_2627)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2263_2628;
		    {
		       obj_t list2264_2629;
		       {
			  obj_t arg2265_2630;
			  arg2265_2630 = BNIL;
			  list2264_2629 = MAKE_PAIR(cnst_port_138_2624, arg2265_2630);
		       }
		       arg2263_2628 = read___reader(list2264_2629);
		    }
		    CNST_TABLE_SET(i_2625, arg2263_2628);
		 }
		 {
		    int aux_2631;
		    {
		       long aux_2653;
		       aux_2653 = (i_2625 - ((long) 1));
		       aux_2631 = (int) (aux_2653);
		    }
		    {
		       long i_2656;
		       i_2656 = (long) (aux_2631);
		       i_2625 = i_2656;
		       goto loop_2626;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_unit()
{
   return (__unit_list__71_ast_unit = BNIL,
      BUNSPEC);
}


obj_t 
unit_sexp__add__71_ast_unit(obj_t unit_19, obj_t sexp_20)
{
   {
      obj_t sexp_717;
      {
	 bool_t test1323_722;
	 {
	    bool_t test1334_731;
	    {
	       obj_t obj_1979;
	       obj_1979 = __compiler_debug__134_engine_param;
	       test1334_731 = INTEGERP(obj_1979);
	    }
	    if (test1334_731)
	      {
		 long n1_1980;
		 n1_1980 = (long) CINT(__compiler_debug__134_engine_param);
		 test1323_722 = (n1_1980 >= ((long) 3));
	      }
	    else
	      {
		 test1323_722 = ((bool_t) 0);
	      }
	 }
	 if (test1323_722)
	   {
	      obj_t arg1325_723;
	      {
		 obj_t arg1327_724;
		 obj_t arg1328_725;
		 arg1327_724 = CNST_TABLE_REF(((long) 0));
		 arg1328_725 = CNST_TABLE_REF(((long) 1));
		 {
		    obj_t list1330_727;
		    {
		       obj_t arg1331_728;
		       {
			  obj_t arg1332_729;
			  arg1332_729 = MAKE_PAIR(BNIL, BNIL);
			  arg1331_728 = MAKE_PAIR(__compiler_debug__134_engine_param, arg1332_729);
		       }
		       list1330_727 = MAKE_PAIR(arg1328_725, arg1331_728);
		    }
		    arg1325_723 = cons__138___r4_pairs_and_lists_6_3(arg1327_724, list1330_727);
		 }
	      }
	      sexp_717 = MAKE_PAIR(arg1325_723, sexp_20);
	   }
	 else
	   {
	      sexp_717 = sexp_20;
	   }
      }
      {
	 bool_t test_2670;
	 {
	    obj_t aux_2671;
	    aux_2671 = STRUCT_REF(unit_19, ((long) 2));
	    test_2670 = NULLP(aux_2671);
	 }
	 if (test_2670)
	   {
	      return STRUCT_SET(unit_19, ((long) 2), sexp_717);
	   }
	 else
	   {
	      obj_t aux_2675;
	      aux_2675 = last_pair_93___r4_pairs_and_lists_6_3(STRUCT_REF(unit_19, ((long) 2)));
	      return SET_CDR(aux_2675, sexp_717);
	   }
      }
   }
}


obj_t 
_unit_sexp__add__174_ast_unit(obj_t env_2610, obj_t unit_2611, obj_t sexp_2612)
{
   return unit_sexp__add__71_ast_unit(unit_2611, sexp_2612);
}


obj_t 
unit__defs_135_ast_unit(obj_t unit_21)
{
   {
      obj_t arg1340_734;
      {
	 obj_t arg1350_741;
	 {
	    obj_t aux_2680;
	    aux_2680 = STRUCT_REF(unit_21, ((long) 0));
	    arg1350_741 = SYMBOL_TO_STRING(aux_2680);
	 }
	 arg1340_734 = string_downcase__42___r4_strings_6_7(arg1350_741);
      }
      {
	 obj_t list1343_736;
	 {
	    obj_t arg1345_737;
	    {
	       obj_t arg1346_738;
	       {
		  obj_t arg1347_739;
		  {
		     obj_t aux_2684;
		     aux_2684 = BCHAR(((unsigned char) '\n'));
		     arg1347_739 = MAKE_PAIR(aux_2684, BNIL);
		  }
		  arg1346_738 = MAKE_PAIR(string2251_ast_unit, arg1347_739);
	       }
	       arg1345_737 = MAKE_PAIR(arg1340_734, arg1346_738);
	    }
	    list1343_736 = MAKE_PAIR(string2252_ast_unit, arg1345_737);
	 }
	 verbose_tools_speek(BINT(((long) 2)), list1343_736);
      }
   }
   {
      bool_t test1353_743;
      {
	 obj_t aux_2692;
	 aux_2692 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 2)), BINT(((long) 0)));
	 test1353_743 = CBOOL(aux_2692);
      }
      if (test1353_743)
	{
	   obj_t list1354_744;
	   {
	      obj_t arg1356_746;
	      {
		 obj_t arg1357_747;
		 {
		    obj_t aux_2698;
		    aux_2698 = BCHAR(((unsigned char) '\n'));
		    arg1357_747 = MAKE_PAIR(aux_2698, BNIL);
		 }
		 arg1356_746 = MAKE_PAIR(unit_21, arg1357_747);
	      }
	      list1354_744 = MAKE_PAIR(string2253_ast_unit, arg1356_746);
	   }
	   print_trace_107_tools_trace(list1354_744);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t id_751;
      obj_t weight_752;
      obj_t sexp__30_753;
      id_751 = STRUCT_REF(unit_21, ((long) 0));
      weight_752 = STRUCT_REF(unit_21, ((long) 1));
      sexp__30_753 = STRUCT_REF(unit_21, ((long) 2));
      {
	 obj_t aexp__171_754;
	 obj_t init__202_755;
	 obj_t def__173_756;
	 {
	    obj_t arg1363_758;
	    if (PROCEDUREP(sexp__30_753))
	      {
		 arg1363_758 = PROCEDURE_ENTRY(sexp__30_753) (sexp__30_753, BEOA);
	      }
	    else
	      {
		 obj_t arg1369_762;
		 arg1369_762 = find_global_defs_64_ast_find_gdefs_13(sexp__30_753);
		 arg1363_758 = toplevel___ast_181_ast_unit(sexp__30_753, arg1369_762);
	      }
	    aexp__171_754 = arg1363_758;
	    init__202_755 = BNIL;
	    def__173_756 = BNIL;
	  loop_757:
	    if (NULLP(aexp__171_754))
	      {
		 if (PAIRP(init__202_755))
		   {
		      global_t init_765;
		      {
			 obj_t arg1376_767;
			 obj_t arg1381_770;
			 obj_t arg1382_771;
			 obj_t arg1385_772;
			 {
			    obj_t arg1388_773;
			    obj_t arg1390_774;
			    arg1388_773 = unit_initializer_id_235_ast_unit(id_751);
			    arg1390_774 = CNST_TABLE_REF(((long) 3));
			    {
			       obj_t list1391_775;
			       {
				  obj_t arg1396_776;
				  arg1396_776 = MAKE_PAIR(arg1390_774, BNIL);
				  list1391_775 = MAKE_PAIR(arg1388_773, arg1396_776);
			       }
			       arg1376_767 = symbol_append_197___r4_symbols_6_4(list1391_775);
			    }
			 }
			 arg1381_770 = CNST_TABLE_REF(((long) 4));
			 arg1382_771 = CNST_TABLE_REF(((long) 5));
			 {
			    obj_t arg1400_778;
			    arg1400_778 = reverse__39___r4_pairs_and_lists_6_3(init__202_755);
			    arg1385_772 = normalize_progn_143_tools_progn(arg1400_778);
			 }
			 init_765 = def_global_sfun__93_ast_glo_def_117(arg1376_767, BNIL, BNIL, __module__166_module_module, arg1381_770, BFALSE, arg1382_771, arg1385_772);
		      }
		      declare_unit__164_ast_unit(id_751, (long) CINT(weight_752));
		      {
			 obj_t res2246_2017;
			 {
			    obj_t x_2623;
			    x_2623 = ((((global_t) CREF(init_765))->evaluable__248) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			    res2246_2017 = BUNSPEC;
			 }
			 res2246_2017;
		      }
		      {
			 obj_t arg1372_766;
			 arg1372_766 = reverse__39___r4_pairs_and_lists_6_3(def__173_756);
			 {
			    obj_t aux_2731;
			    aux_2731 = (obj_t) (init_765);
			    return MAKE_PAIR(aux_2731, arg1372_766);
			 }
		      }
		   }
		 else
		   {
		      return reverse__39___r4_pairs_and_lists_6_3(def__173_756);
		   }
	      }
	    else
	      {
		 bool_t test1401_779;
		 test1401_779 = is_a__118___object(CAR(aexp__171_754), global_ast_var);
		 if (test1401_779)
		   {
		      obj_t arg1402_780;
		      obj_t arg1403_781;
		      arg1402_780 = CDR(aexp__171_754);
		      {
			 obj_t aux_2739;
			 aux_2739 = CAR(aexp__171_754);
			 arg1403_781 = MAKE_PAIR(aux_2739, def__173_756);
		      }
		      {
			 obj_t def__173_2743;
			 obj_t aexp__171_2742;
			 aexp__171_2742 = arg1402_780;
			 def__173_2743 = arg1403_781;
			 def__173_756 = def__173_2743;
			 aexp__171_754 = aexp__171_2742;
			 goto loop_757;
		      }
		   }
		 else
		   {
		      obj_t arg1406_783;
		      obj_t arg1408_784;
		      arg1406_783 = CDR(aexp__171_754);
		      {
			 obj_t aux_2745;
			 aux_2745 = CAR(aexp__171_754);
			 arg1408_784 = MAKE_PAIR(aux_2745, init__202_755);
		      }
		      {
			 obj_t init__202_2749;
			 obj_t aexp__171_2748;
			 aexp__171_2748 = arg1406_783;
			 init__202_2749 = arg1408_784;
			 init__202_755 = init__202_2749;
			 aexp__171_754 = aexp__171_2748;
			 goto loop_757;
		      }
		   }
	      }
	 }
      }
   }
}


obj_t 
_unit__defs_170_ast_unit(obj_t env_2613, obj_t unit_2614)
{
   return unit__defs_135_ast_unit(unit_2614);
}


obj_t 
declare_unit__164_ast_unit(obj_t id_22, long weight_23)
{
   {
      bool_t test1412_787;
      {
	 bool_t test1442_805;
	 {
	    obj_t obj_2030;
	    obj_2030 = __unit_list__71_ast_unit;
	    test1442_805 = NULLP(obj_2030);
	 }
	 if (test1442_805)
	   {
	      test1412_787 = ((bool_t) 1);
	   }
	 else
	   {
	      obj_t arg1444_806;
	      {
		 obj_t arg1445_807;
		 {
		    obj_t pair_2031;
		    pair_2031 = __unit_list__71_ast_unit;
		    arg1445_807 = CAR(pair_2031);
		 }
		 arg1444_806 = CDR(arg1445_807);
	      }
	      {
		 long aux_2755;
		 aux_2755 = (long) CINT(arg1444_806);
		 test1412_787 = (weight_23 < aux_2755);
	      }
	   }
      }
      if (test1412_787)
	{
	   obj_t arg1414_788;
	   {
	      obj_t aux_2759;
	      aux_2759 = BINT(weight_23);
	      arg1414_788 = MAKE_PAIR(id_22, aux_2759);
	   }
	   {
	      obj_t obj2_2038;
	      obj2_2038 = __unit_list__71_ast_unit;
	      return (__unit_list__71_ast_unit = MAKE_PAIR(arg1414_788, obj2_2038),
		 BUNSPEC);
	   }
	}
      else
	{
	   obj_t ulist_789;
	   ulist_789 = __unit_list__71_ast_unit;
	 loop_790:
	   {
	      bool_t test_2763;
	      {
		 long aux_2764;
		 {
		    obj_t aux_2765;
		    {
		       obj_t aux_2766;
		       aux_2766 = CAR(ulist_789);
		       aux_2765 = CDR(aux_2766);
		    }
		    aux_2764 = (long) CINT(aux_2765);
		 }
		 test_2763 = (weight_23 < aux_2764);
	      }
	      if (test_2763)
		{
		   {
		      obj_t arg1416_792;
		      {
			 obj_t aux_2773;
			 obj_t aux_2771;
			 aux_2773 = CDR(ulist_789);
			 aux_2771 = CAR(ulist_789);
			 arg1416_792 = MAKE_PAIR(aux_2771, aux_2773);
		      }
		      SET_CDR(ulist_789, arg1416_792);
		   }
		   {
		      obj_t arg1420_795;
		      {
			 obj_t aux_2777;
			 aux_2777 = BINT(weight_23);
			 arg1420_795 = MAKE_PAIR(id_22, aux_2777);
		      }
		      return SET_CAR(ulist_789, arg1420_795);
		   }
		}
	      else
		{
		   bool_t test_2781;
		   {
		      obj_t aux_2782;
		      aux_2782 = CDR(ulist_789);
		      test_2781 = NULLP(aux_2782);
		   }
		   if (test_2781)
		     {
			{
			   obj_t arg1424_797;
			   {
			      obj_t arg1426_798;
			      {
				 obj_t aux_2785;
				 aux_2785 = BINT(weight_23);
				 arg1426_798 = MAKE_PAIR(id_22, aux_2785);
			      }
			      {
				 obj_t list1427_799;
				 list1427_799 = MAKE_PAIR(arg1426_798, BNIL);
				 arg1424_797 = list1427_799;
			      }
			   }
			   return SET_CDR(ulist_789, arg1424_797);
			}
		     }
		   else
		     {
			{
			   obj_t ulist_2790;
			   ulist_2790 = CDR(ulist_789);
			   ulist_789 = ulist_2790;
			   goto loop_790;
			}
		     }
		}
	   }
	}
   }
}


obj_t 
unit_initializer_id_235_ast_unit(obj_t id_24)
{
   {
      obj_t list1447_809;
      {
	 obj_t arg1448_810;
	 {
	    obj_t aux_2792;
	    aux_2792 = CNST_TABLE_REF(((long) 6));
	    arg1448_810 = MAKE_PAIR(aux_2792, BNIL);
	 }
	 list1447_809 = MAKE_PAIR(id_24, arg1448_810);
      }
      return symbol_append_197___r4_symbols_6_4(list1447_809);
   }
}


obj_t 
unit_initializers_25_ast_unit()
{
   {
      obj_t l1276_812;
      l1276_812 = __unit_list__71_ast_unit;
      if (NULLP(l1276_812))
	{
	   return BNIL;
	}
      else
	{
	   obj_t head1284_814;
	   head1284_814 = MAKE_PAIR(BNIL, BNIL);
	   {
	      obj_t l1276_815;
	      obj_t tail1285_816;
	      l1276_815 = l1276_812;
	      tail1285_816 = head1284_814;
	    lname1283_817:
	      if (NULLP(l1276_815))
		{
		   return CDR(head1284_814);
		}
	      else
		{
		   obj_t new_tail1286_4_819;
		   {
		      obj_t arg1453_821;
		      {
			 obj_t arg1457_824;
			 {
			    obj_t aux_2803;
			    {
			       obj_t aux_2804;
			       aux_2804 = CAR(l1276_815);
			       aux_2803 = CAR(aux_2804);
			    }
			    arg1457_824 = unit_initializer_id_235_ast_unit(aux_2803);
			 }
			 {
			    obj_t list1458_825;
			    list1458_825 = MAKE_PAIR(__module__166_module_module, BNIL);
			    arg1453_821 = find_global_223_ast_env(arg1457_824, list1458_825);
			 }
		      }
		      new_tail1286_4_819 = MAKE_PAIR(arg1453_821, BNIL);
		   }
		   SET_CDR(tail1285_816, new_tail1286_4_819);
		   {
		      obj_t tail1285_2814;
		      obj_t l1276_2812;
		      l1276_2812 = CDR(l1276_815);
		      tail1285_2814 = new_tail1286_4_819;
		      tail1285_816 = tail1285_2814;
		      l1276_815 = l1276_2812;
		      goto lname1283_817;
		   }
		}
	   }
	}
   }
}


obj_t 
_unit_initializers_20_ast_unit(obj_t env_2615)
{
   return unit_initializers_25_ast_unit();
}


obj_t 
unit_init_calls_56_ast_unit()
{
   {
      obj_t l1287_830;
      l1287_830 = __unit_list__71_ast_unit;
      if (NULLP(l1287_830))
	{
	   return BNIL;
	}
      else
	{
	   obj_t head1291_832;
	   head1291_832 = MAKE_PAIR(BNIL, BNIL);
	   {
	      obj_t l1287_833;
	      obj_t tail1292_834;
	      l1287_833 = l1287_830;
	      tail1292_834 = head1291_832;
	    lname1290_835:
	      if (NULLP(l1287_833))
		{
		   return CDR(head1291_832);
		}
	      else
		{
		   obj_t new_tail1293_138_837;
		   {
		      obj_t arg1471_839;
		      {
			 obj_t arg1474_842;
			 {
			    obj_t arg1480_846;
			    obj_t arg1481_847;
			    arg1480_846 = CNST_TABLE_REF(((long) 7));
			    {
			       obj_t aux_2823;
			       {
				  obj_t aux_2824;
				  aux_2824 = CAR(l1287_833);
				  aux_2823 = CAR(aux_2824);
			       }
			       arg1481_847 = unit_initializer_id_235_ast_unit(aux_2823);
			    }
			    {
			       obj_t list1485_849;
			       {
				  obj_t arg1486_850;
				  {
				     obj_t arg1487_851;
				     arg1487_851 = MAKE_PAIR(BNIL, BNIL);
				     arg1486_850 = MAKE_PAIR(__module__166_module_module, arg1487_851);
				  }
				  list1485_849 = MAKE_PAIR(arg1481_847, arg1486_850);
			       }
			       arg1474_842 = cons__138___r4_pairs_and_lists_6_3(arg1480_846, list1485_849);
			    }
			 }
			 {
			    obj_t list1477_844;
			    list1477_844 = MAKE_PAIR(BNIL, BNIL);
			    arg1471_839 = cons__138___r4_pairs_and_lists_6_3(arg1474_842, list1477_844);
			 }
		      }
		      new_tail1293_138_837 = MAKE_PAIR(arg1471_839, BNIL);
		   }
		   SET_CDR(tail1292_834, new_tail1293_138_837);
		   {
		      obj_t tail1292_2838;
		      obj_t l1287_2836;
		      l1287_2836 = CDR(l1287_833);
		      tail1292_2838 = new_tail1293_138_837;
		      tail1292_834 = tail1292_2838;
		      l1287_833 = l1287_2836;
		      goto lname1290_835;
		   }
		}
	   }
	}
   }
}


obj_t 
_unit_init_calls_204_ast_unit(obj_t env_2616)
{
   return unit_init_calls_56_ast_unit();
}


obj_t 
toplevel___ast_181_ast_unit(obj_t sexp__30_25, obj_t gdefs_26)
{
   {
      obj_t sexp__30_856;
      obj_t aexp__171_857;
      sexp__30_856 = sexp__30_25;
      aexp__171_857 = BNIL;
    loop_858:
      if (NULLP(sexp__30_856))
	{
	   return reverse__39___r4_pairs_and_lists_6_3(aexp__171_857);
	}
      else
	{
	   obj_t arg1498_861;
	   obj_t arg1499_862;
	   arg1498_861 = CDR(sexp__30_856);
	   {
	      obj_t arg1500_863;
	      arg1500_863 = toplevel__ast_219_ast_unit(CAR(sexp__30_856), gdefs_26);
	      arg1499_862 = append_2_18___r4_pairs_and_lists_6_3(arg1500_863, aexp__171_857);
	   }
	   {
	      obj_t aexp__171_2848;
	      obj_t sexp__30_2847;
	      sexp__30_2847 = arg1498_861;
	      aexp__171_2848 = arg1499_862;
	      aexp__171_857 = aexp__171_2848;
	      sexp__30_856 = sexp__30_2847;
	      goto loop_858;
	   }
	}
   }
}


obj_t 
toplevel__ast_219_ast_unit(obj_t sexp_27, obj_t gdefs_28)
{
 toplevel__ast_219_ast_unit:
   {
      obj_t var_881;
      obj_t var2_882;
      obj_t module_883;
      obj_t var_878;
      obj_t var2_879;
      obj_t var_871;
      obj_t args_872;
      obj_t exp_873;
      obj_t var_867;
      obj_t args_868;
      obj_t exp_869;
      if (PAIRP(sexp_27))
	{
	   bool_t test_2851;
	   {
	      obj_t aux_2854;
	      obj_t aux_2852;
	      aux_2854 = CNST_TABLE_REF(((long) 11));
	      aux_2852 = CAR(sexp_27);
	      test_2851 = (aux_2852 == aux_2854);
	   }
	   if (test_2851)
	     {
		obj_t arg1740_2094;
		arg1740_2094 = toplevel___ast_181_ast_unit(CDR(sexp_27), gdefs_28);
		return reverse__39___r4_pairs_and_lists_6_3(arg1740_2094);
	     }
	   else
	     {
		obj_t cdr_155_78_915;
		cdr_155_78_915 = CDR(sexp_27);
		{
		   bool_t test_2861;
		   {
		      obj_t aux_2864;
		      obj_t aux_2862;
		      aux_2864 = CNST_TABLE_REF(((long) 12));
		      aux_2862 = CAR(sexp_27);
		      test_2861 = (aux_2862 == aux_2864);
		   }
		   if (test_2861)
		     {
			if (PAIRP(cdr_155_78_915))
			  {
			     obj_t car_159_8_918;
			     car_159_8_918 = CAR(cdr_155_78_915);
			     if (PAIRP(car_159_8_918))
			       {
				  var_867 = CAR(car_159_8_918);
				  args_868 = CDR(car_159_8_918);
				  exp_869 = CDR(cdr_155_78_915);
				  {
				     obj_t id_1184;
				     id_1184 = id_of_id_112_ast_ident(var_867);
				     {
					obj_t def_1185;
					def_1185 = assq___r4_pairs_and_lists_6_3(id_1184, gdefs_28);
					{
					   obj_t global_1186;
					   {
					      obj_t list1772_1215;
					      list1772_1215 = MAKE_PAIR(__module__166_module_module, BNIL);
					      global_1186 = find_global_223_ast_env(id_1184, list1772_1215);
					   }
					   {
					      {
						 bool_t test1741_1187;
						 if (PAIRP(def_1185))
						   {
						      bool_t test_2878;
						      {
							 obj_t aux_2883;
							 obj_t aux_2879;
							 aux_2883 = CNST_TABLE_REF(((long) 8));
							 {
							    obj_t aux_2880;
							    aux_2880 = CDR(def_1185);
							    aux_2879 = CAR(aux_2880);
							 }
							 test_2878 = (aux_2879 == aux_2883);
						      }
						      if (test_2878)
							{
							   bool_t _ortest_1295_1208;
							   {
							      bool_t test1768_1211;
							      test1768_1211 = is_a__118___object(global_1186, global_ast_var);
							      if (test1768_1211)
								{
								   _ortest_1295_1208 = ((bool_t) 0);
								}
							      else
								{
								   _ortest_1295_1208 = ((bool_t) 1);
								}
							   }
							   if (_ortest_1295_1208)
							     {
								test1741_1187 = _ortest_1295_1208;
							     }
							   else
							     {
								obj_t aux_2892;
								obj_t aux_2889;
								aux_2892 = CNST_TABLE_REF(((long) 8));
								{
								   global_t obj_2469;
								   obj_2469 = (global_t) (global_1186);
								   aux_2889 = (((global_t) CREF(obj_2469))->access);
								}
								test1741_1187 = (aux_2889 == aux_2892);
							     }
							}
						      else
							{
							   test1741_1187 = ((bool_t) 0);
							}
						   }
						 else
						   {
						      test1741_1187 = ((bool_t) 1);
						   }
						 if (test1741_1187)
						   {
						      obj_t arg1742_1188;
						      obj_t arg1743_1189;
						      arg1742_1188 = normalize_progn_error_20_ast_unit(exp_869, sexp_27);
						      arg1743_1189 = CNST_TABLE_REF(((long) 9));
						      return make_sfun_definition_61_ast_unit(var_867, __module__166_module_module, args_868, arg1742_1188, sexp_27, arg1743_1189);
						   }
						 else
						   {
						      obj_t new_sexp_159_1190;
						      {
							 obj_t arg1745_1191;
							 obj_t arg1746_1192;
							 arg1745_1191 = CNST_TABLE_REF(((long) 0));
							 {
							    obj_t arg1754_1198;
							    obj_t arg1755_1199;
							    arg1754_1198 = CNST_TABLE_REF(((long) 10));
							    {
							       obj_t arg1761_1203;
							       arg1761_1203 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
							       arg1755_1199 = append_2_18___r4_pairs_and_lists_6_3(exp_869, arg1761_1203);
							    }
							    {
							       obj_t list1756_1200;
							       {
								  obj_t arg1758_1201;
								  arg1758_1201 = MAKE_PAIR(arg1755_1199, BNIL);
								  list1756_1200 = MAKE_PAIR(args_868, arg1758_1201);
							       }
							       arg1746_1192 = cons__138___r4_pairs_and_lists_6_3(arg1754_1198, list1756_1200);
							    }
							 }
							 {
							    obj_t list1748_1194;
							    {
							       obj_t arg1749_1195;
							       {
								  obj_t arg1751_1196;
								  arg1751_1196 = MAKE_PAIR(BNIL, BNIL);
								  arg1749_1195 = MAKE_PAIR(arg1746_1192, arg1751_1196);
							       }
							       list1748_1194 = MAKE_PAIR(var_867, arg1749_1195);
							    }
							    new_sexp_159_1190 = cons__138___r4_pairs_and_lists_6_3(arg1745_1191, list1748_1194);
							 }
						      }
						      replace__160_tools_misc(sexp_27, new_sexp_159_1190);
						      return make_svar_definition_154_ast_unit(var_867, sexp_27);
						   }
					      }
					   }
					}
				     }
				  }
			       }
			     else
			       {
				  obj_t cdr_183_92_924;
				  cdr_183_92_924 = CDR(cdr_155_78_915);
				  if (PAIRP(cdr_183_92_924))
				    {
				       obj_t car_187_173_926;
				       car_187_173_926 = CAR(cdr_183_92_924);
				       if (PAIRP(car_187_173_926))
					 {
					    obj_t cdr_192_117_928;
					    cdr_192_117_928 = CDR(car_187_173_926);
					    {
					       bool_t test_2922;
					       {
						  obj_t aux_2925;
						  obj_t aux_2923;
						  aux_2925 = CNST_TABLE_REF(((long) 10));
						  aux_2923 = CAR(car_187_173_926);
						  test_2922 = (aux_2923 == aux_2925);
					       }
					       if (test_2922)
						 {
						    if (PAIRP(cdr_192_117_928))
						      {
							 bool_t test_2930;
							 {
							    obj_t aux_2931;
							    aux_2931 = CDR(cdr_183_92_924);
							    test_2930 = (aux_2931 == BNIL);
							 }
							 if (test_2930)
							   {
							      var_871 = CAR(cdr_155_78_915);
							      args_872 = CAR(cdr_192_117_928);
							      exp_873 = CDR(cdr_192_117_928);
							      {
								 obj_t id_1217;
								 id_1217 = id_of_id_112_ast_ident(var_871);
								 {
								    obj_t def_1218;
								    def_1218 = assq___r4_pairs_and_lists_6_3(id_1217, gdefs_28);
								    {
								       obj_t global_1219;
								       {
									  obj_t list1785_1231;
									  list1785_1231 = MAKE_PAIR(__module__166_module_module, BNIL);
									  global_1219 = find_global_223_ast_env(id_1217, list1785_1231);
								       }
								       {
									  {
									     bool_t test1774_1220;
									     {
										bool_t test_2938;
										{
										   obj_t aux_2943;
										   obj_t aux_2939;
										   aux_2943 = CNST_TABLE_REF(((long) 8));
										   {
										      obj_t aux_2940;
										      aux_2940 = CDR(def_1218);
										      aux_2939 = CAR(aux_2940);
										   }
										   test_2938 = (aux_2939 == aux_2943);
										}
										if (test_2938)
										  {
										     bool_t _ortest_1296_1224;
										     {
											bool_t test1780_1227;
											test1780_1227 = is_a__118___object(global_1219, global_ast_var);
											if (test1780_1227)
											  {
											     _ortest_1296_1224 = ((bool_t) 0);
											  }
											else
											  {
											     _ortest_1296_1224 = ((bool_t) 1);
											  }
										     }
										     if (_ortest_1296_1224)
										       {
											  test1774_1220 = _ortest_1296_1224;
										       }
										     else
										       {
											  obj_t aux_2952;
											  obj_t aux_2949;
											  aux_2952 = CNST_TABLE_REF(((long) 8));
											  {
											     global_t obj_2477;
											     obj_2477 = (global_t) (global_1219);
											     aux_2949 = (((global_t) CREF(obj_2477))->access);
											  }
											  test1774_1220 = (aux_2949 == aux_2952);
										       }
										  }
										else
										  {
										     test1774_1220 = ((bool_t) 0);
										  }
									     }
									     if (test1774_1220)
									       {
										  obj_t arg1775_1221;
										  obj_t arg1776_1222;
										  arg1775_1221 = normalize_progn_error_20_ast_unit(exp_873, sexp_27);
										  arg1776_1222 = CNST_TABLE_REF(((long) 9));
										  return make_sfun_definition_61_ast_unit(var_871, __module__166_module_module, args_872, arg1775_1221, sexp_27, arg1776_1222);
									       }
									     else
									       {
										  return make_svar_definition_154_ast_unit(var_871, sexp_27);
									       }
									  }
								       }
								    }
								 }
							      }
							   }
							 else
							   {
							      return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
							   }
						      }
						    else
						      {
							 obj_t cdr_265_143_941;
							 cdr_265_143_941 = CDR(cdr_155_78_915);
							 {
							    obj_t car_269_91_942;
							    car_269_91_942 = CAR(cdr_265_143_941);
							    if (SYMBOLP(car_269_91_942))
							      {
								 bool_t test_2969;
								 {
								    obj_t aux_2970;
								    aux_2970 = CDR(cdr_265_143_941);
								    test_2969 = (aux_2970 == BNIL);
								 }
								 if (test_2969)
								   {
								      var_878 = CAR(cdr_155_78_915);
								      var2_879 = car_269_91_942;
								    tag_124_21_880:
								      {
									 obj_t def_1234;
									 {
									    obj_t arg1795_1242;
									    arg1795_1242 = id_of_id_112_ast_ident(var_878);
									    def_1234 = assq___r4_pairs_and_lists_6_3(arg1795_1242, gdefs_28);
									 }
									 {
									    bool_t test_2975;
									    {
									       obj_t aux_2980;
									       obj_t aux_2976;
									       aux_2980 = CNST_TABLE_REF(((long) 8));
									       {
										  obj_t aux_2977;
										  aux_2977 = CDR(def_1234);
										  aux_2976 = CAR(aux_2977);
									       }
									       test_2975 = (aux_2976 == aux_2980);
									    }
									    if (test_2975)
									      {
										 obj_t arity_1236;
										 arity_1236 = get_global_arity_252_ast_unit(var2_879, BFALSE, gdefs_28);
										 if (INTEGERP(arity_1236))
										   {
										      obj_t def_1238;
										      def_1238 = eta_expanse_111_ast_unit(sexp_27, arity_1236);
										      {
											 obj_t sexp_2987;
											 sexp_2987 = def_1238;
											 sexp_27 = sexp_2987;
											 goto toplevel__ast_219_ast_unit;
										      }
										   }
										 else
										   {
										      return make_svar_definition_154_ast_unit(var_878, sexp_27);
										   }
									      }
									    else
									      {
										 return make_svar_definition_154_ast_unit(var_878, sexp_27);
									      }
									 }
								      }
								   }
								 else
								   {
								      return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
								   }
							      }
							    else
							      {
								 return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
							      }
							 }
						      }
						 }
					       else
						 {
						    obj_t cdr_341_125_955;
						    cdr_341_125_955 = CDR(cdr_155_78_915);
						    {
						       obj_t car_345_114_956;
						       car_345_114_956 = CAR(cdr_341_125_955);
						       {
							  obj_t cdr_349_110_957;
							  cdr_349_110_957 = CDR(car_345_114_956);
							  {
							     bool_t test_2998;
							     {
								obj_t aux_3001;
								obj_t aux_2999;
								aux_3001 = CNST_TABLE_REF(((long) 11));
								aux_2999 = CAR(car_345_114_956);
								test_2998 = (aux_2999 == aux_3001);
							     }
							     if (test_2998)
							       {
								  if (PAIRP(cdr_349_110_957))
								    {
								       bool_t test_3006;
								       {
									  obj_t aux_3007;
									  aux_3007 = CDR(cdr_349_110_957);
									  test_3006 = (aux_3007 == BNIL);
								       }
								       if (test_3006)
									 {
									    bool_t test_3010;
									    {
									       obj_t aux_3011;
									       aux_3011 = CDR(cdr_341_125_955);
									       test_3010 = (aux_3011 == BNIL);
									    }
									    if (test_3010)
									      {
										 {
										    obj_t aux_3016;
										    obj_t aux_3014;
										    aux_3016 = CAR(cdr_349_110_957);
										    aux_3014 = CDR(cdr_155_78_915);
										    SET_CAR(aux_3014, aux_3016);
										 }
										 {
										    goto toplevel__ast_219_ast_unit;
										 }
									      }
									    else
									      {
										 return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
									      }
									 }
								       else
									 {
									    obj_t cdr_402_67_970;
									    cdr_402_67_970 = CDR(cdr_155_78_915);
									    {
									       obj_t car_406_252_971;
									       car_406_252_971 = CAR(cdr_402_67_970);
									       if (SYMBOLP(car_406_252_971))
										 {
										    bool_t test_3025;
										    {
										       obj_t aux_3026;
										       aux_3026 = CDR(cdr_402_67_970);
										       test_3025 = (aux_3026 == BNIL);
										    }
										    if (test_3025)
										      {
											 obj_t var2_3031;
											 obj_t var_3029;
											 var_3029 = CAR(cdr_155_78_915);
											 var2_3031 = car_406_252_971;
											 var2_879 = var2_3031;
											 var_878 = var_3029;
											 goto tag_124_21_880;
										      }
										    else
										      {
											 return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
										      }
										 }
									       else
										 {
										    return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
										 }
									    }
									 }
								    }
								  else
								    {
								       obj_t cdr_477_100_986;
								       cdr_477_100_986 = CDR(cdr_155_78_915);
								       {
									  obj_t car_481_225_987;
									  car_481_225_987 = CAR(cdr_477_100_986);
									  if (SYMBOLP(car_481_225_987))
									    {
									       bool_t test_3040;
									       {
										  obj_t aux_3041;
										  aux_3041 = CDR(cdr_477_100_986);
										  test_3040 = (aux_3041 == BNIL);
									       }
									       if (test_3040)
										 {
										    obj_t var2_3046;
										    obj_t var_3044;
										    var_3044 = CAR(cdr_155_78_915);
										    var2_3046 = car_481_225_987;
										    var2_879 = var2_3046;
										    var_878 = var_3044;
										    goto tag_124_21_880;
										 }
									       else
										 {
										    return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
										 }
									    }
									  else
									    {
									       return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
									    }
								       }
								    }
							       }
							     else
							       {
								  obj_t cdr_552_174_1000;
								  cdr_552_174_1000 = CDR(cdr_155_78_915);
								  {
								     obj_t car_556_168_1001;
								     car_556_168_1001 = CAR(cdr_552_174_1000);
								     if (SYMBOLP(car_556_168_1001))
								       {
									  bool_t test_3055;
									  {
									     obj_t aux_3056;
									     aux_3056 = CDR(cdr_552_174_1000);
									     test_3055 = (aux_3056 == BNIL);
									  }
									  if (test_3055)
									    {
									       obj_t var2_3061;
									       obj_t var_3059;
									       var_3059 = CAR(cdr_155_78_915);
									       var2_3061 = car_556_168_1001;
									       var2_879 = var2_3061;
									       var_878 = var_3059;
									       goto tag_124_21_880;
									    }
									  else
									    {
									       return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
									    }
								       }
								     else
								       {
									  obj_t cdr_603_240_1011;
									  cdr_603_240_1011 = CDR(cdr_155_78_915);
									  {
									     obj_t car_608_29_1012;
									     car_608_29_1012 = CAR(cdr_603_240_1011);
									     {
										obj_t cdr_613_171_1013;
										cdr_613_171_1013 = CDR(car_608_29_1012);
										{
										   bool_t test_3067;
										   {
										      obj_t aux_3070;
										      obj_t aux_3068;
										      aux_3070 = CNST_TABLE_REF(((long) 7));
										      aux_3068 = CAR(car_608_29_1012);
										      test_3067 = (aux_3068 == aux_3070);
										   }
										   if (test_3067)
										     {
											if (PAIRP(cdr_613_171_1013))
											  {
											     obj_t car_616_229_1016;
											     obj_t cdr_617_239_1017;
											     car_616_229_1016 = CAR(cdr_613_171_1013);
											     cdr_617_239_1017 = CDR(cdr_613_171_1013);
											     if (SYMBOLP(car_616_229_1016))
											       {
												  if (PAIRP(cdr_617_239_1017))
												    {
												       obj_t car_622_221_1020;
												       car_622_221_1020 = CAR(cdr_617_239_1017);
												       if (SYMBOLP(car_622_221_1020))
													 {
													    bool_t test_3084;
													    {
													       obj_t aux_3085;
													       aux_3085 = CDR(cdr_617_239_1017);
													       test_3084 = (aux_3085 == BNIL);
													    }
													    if (test_3084)
													      {
														 bool_t test_3088;
														 {
														    obj_t aux_3089;
														    aux_3089 = CDR(cdr_603_240_1011);
														    test_3088 = (aux_3089 == BNIL);
														 }
														 if (test_3088)
														   {
														      var_881 = CAR(cdr_155_78_915);
														      var2_882 = car_616_229_1016;
														      module_883 = car_622_221_1020;
														      {
															 obj_t def_1243;
															 {
															    obj_t arg1801_1251;
															    arg1801_1251 = id_of_id_112_ast_ident(var_881);
															    def_1243 = assq___r4_pairs_and_lists_6_3(arg1801_1251, gdefs_28);
															 }
															 {
															    bool_t test_3094;
															    {
															       obj_t aux_3099;
															       obj_t aux_3095;
															       aux_3099 = CNST_TABLE_REF(((long) 8));
															       {
																  obj_t aux_3096;
																  aux_3096 = CDR(def_1243);
																  aux_3095 = CAR(aux_3096);
															       }
															       test_3094 = (aux_3095 == aux_3099);
															    }
															    if (test_3094)
															      {
																 obj_t arity_1245;
																 arity_1245 = get_global_arity_252_ast_unit(var2_882, module_883, gdefs_28);
																 if (INTEGERP(arity_1245))
																   {
																      obj_t def_1247;
																      def_1247 = eta_expanse_111_ast_unit(sexp_27, arity_1245);
																      {
																	 obj_t sexp_3106;
																	 sexp_3106 = def_1247;
																	 sexp_27 = sexp_3106;
																	 goto toplevel__ast_219_ast_unit;
																      }
																   }
																 else
																   {
																      return make_svar_definition_154_ast_unit(var_881, sexp_27);
																   }
															      }
															    else
															      {
																 return make_svar_definition_154_ast_unit(var_881, sexp_27);
															      }
															 }
														      }
														   }
														 else
														   {
														      return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
														   }
													      }
													    else
													      {
														 return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
													      }
													 }
												       else
													 {
													    return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
													 }
												    }
												  else
												    {
												       return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
												    }
											       }
											     else
											       {
												  return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
											       }
											  }
											else
											  {
											     return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
											  }
										     }
										   else
										     {
											return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
										     }
										}
									     }
									  }
								       }
								  }
							       }
							  }
						       }
						    }
						 }
					    }
					 }
				       else
					 {
					    obj_t cdr_769_143_1057;
					    cdr_769_143_1057 = CDR(cdr_155_78_915);
					    {
					       obj_t car_773_37_1058;
					       car_773_37_1058 = CAR(cdr_769_143_1057);
					       if (SYMBOLP(car_773_37_1058))
						 {
						    bool_t test_3128;
						    {
						       obj_t aux_3129;
						       aux_3129 = CDR(cdr_769_143_1057);
						       test_3128 = (aux_3129 == BNIL);
						    }
						    if (test_3128)
						      {
							 obj_t var2_3134;
							 obj_t var_3132;
							 var_3132 = CAR(cdr_155_78_915);
							 var2_3134 = car_773_37_1058;
							 var2_879 = var2_3134;
							 var_878 = var_3132;
							 goto tag_124_21_880;
						      }
						    else
						      {
							 return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
						      }
						 }
					       else
						 {
						    return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
						 }
					    }
					 }
				    }
				  else
				    {
				       return make_svar_definition_154_ast_unit(CAR(cdr_155_78_915), sexp_27);
				    }
			       }
			  }
			else
			  {
			   tag_132_226_910:
			     {
				obj_t list1808_1257;
				list1808_1257 = MAKE_PAIR(sexp_27, BNIL);
				return list1808_1257;
			     }
			  }
		     }
		   else
		     {
			bool_t test_3142;
			{
			   obj_t aux_3145;
			   obj_t aux_3143;
			   aux_3145 = CNST_TABLE_REF(((long) 13));
			   aux_3143 = CAR(sexp_27);
			   test_3142 = (aux_3143 == aux_3145);
			}
			if (test_3142)
			  {
			     if (PAIRP(cdr_155_78_915))
			       {
				  obj_t car_998_185_1076;
				  car_998_185_1076 = CAR(cdr_155_78_915);
				  if (PAIRP(car_998_185_1076))
				    {
				       obj_t car_1003_57_1078;
				       car_1003_57_1078 = CAR(car_998_185_1076);
				       if (PAIRP(car_1003_57_1078))
					 {
					    obj_t cdr_1008_223_1080;
					    cdr_1008_223_1080 = CDR(car_1003_57_1078);
					    {
					       bool_t test_3157;
					       {
						  obj_t aux_3160;
						  obj_t aux_3158;
						  aux_3160 = CNST_TABLE_REF(((long) 7));
						  aux_3158 = CAR(car_1003_57_1078);
						  test_3157 = (aux_3158 == aux_3160);
					       }
					       if (test_3157)
						 {
						    if (PAIRP(cdr_1008_223_1080))
						      {
							 obj_t cdr_1012_92_1083;
							 cdr_1012_92_1083 = CDR(cdr_1008_223_1080);
							 if (PAIRP(cdr_1012_92_1083))
							   {
							      bool_t test_3168;
							      {
								 obj_t aux_3169;
								 aux_3169 = CDR(cdr_1012_92_1083);
								 test_3168 = (aux_3169 == BNIL);
							      }
							      if (test_3168)
								{
								   obj_t arg1653_1086;
								   obj_t arg1654_1087;
								   obj_t arg1655_1088;
								   arg1653_1086 = CAR(cdr_1008_223_1080);
								   arg1654_1087 = CAR(cdr_1012_92_1083);
								   arg1655_1088 = CDR(car_998_185_1076);
								   {
								      obj_t arg1802_2329;
								      obj_t arg1804_2330;
								      arg1802_2329 = normalize_progn_error_20_ast_unit(CDR(cdr_155_78_915), sexp_27);
								      arg1804_2330 = CNST_TABLE_REF(((long) 14));
								      return make_sfun_definition_61_ast_unit(arg1653_1086, arg1654_1087, arg1655_1088, arg1802_2329, sexp_27, arg1804_2330);
								   }
								}
							      else
								{
								   obj_t car_1032_68_1091;
								   car_1032_68_1091 = CAR(cdr_155_78_915);
								   {
								      obj_t arg1657_1092;
								      obj_t arg1659_1093;
								      arg1657_1092 = CAR(car_1032_68_1091);
								      arg1659_1093 = CDR(car_1032_68_1091);
								      {
									 obj_t arg1805_2339;
									 obj_t arg1806_2340;
									 arg1805_2339 = normalize_progn_error_20_ast_unit(CDR(cdr_155_78_915), sexp_27);
									 arg1806_2340 = CNST_TABLE_REF(((long) 14));
									 return make_sfun_definition_61_ast_unit(arg1657_1092, __module__166_module_module, arg1659_1093, arg1805_2339, sexp_27, arg1806_2340);
								      }
								   }
								}
							   }
							 else
							   {
							      obj_t car_1053_234_1098;
							      car_1053_234_1098 = CAR(cdr_155_78_915);
							      {
								 obj_t arg1665_1099;
								 obj_t arg1667_1100;
								 arg1665_1099 = CAR(car_1053_234_1098);
								 arg1667_1100 = CDR(car_1053_234_1098);
								 {
								    obj_t arg1805_2349;
								    obj_t arg1806_2350;
								    arg1805_2349 = normalize_progn_error_20_ast_unit(CDR(cdr_155_78_915), sexp_27);
								    arg1806_2350 = CNST_TABLE_REF(((long) 14));
								    return make_sfun_definition_61_ast_unit(arg1665_1099, __module__166_module_module, arg1667_1100, arg1805_2349, sexp_27, arg1806_2350);
								 }
							      }
							   }
						      }
						    else
						      {
							 obj_t car_1074_91_1103;
							 car_1074_91_1103 = CAR(cdr_155_78_915);
							 {
							    obj_t arg1669_1104;
							    obj_t arg1671_1105;
							    arg1669_1104 = CAR(car_1074_91_1103);
							    arg1671_1105 = CDR(car_1074_91_1103);
							    {
							       obj_t arg1805_2359;
							       obj_t arg1806_2360;
							       arg1805_2359 = normalize_progn_error_20_ast_unit(CDR(cdr_155_78_915), sexp_27);
							       arg1806_2360 = CNST_TABLE_REF(((long) 14));
							       return make_sfun_definition_61_ast_unit(arg1669_1104, __module__166_module_module, arg1671_1105, arg1805_2359, sexp_27, arg1806_2360);
							    }
							 }
						      }
						 }
					       else
						 {
						    obj_t car_1095_7_1108;
						    car_1095_7_1108 = CAR(cdr_155_78_915);
						    {
						       obj_t arg1674_1109;
						       obj_t arg1677_1110;
						       arg1674_1109 = CAR(car_1095_7_1108);
						       arg1677_1110 = CDR(car_1095_7_1108);
						       {
							  obj_t arg1805_2369;
							  obj_t arg1806_2370;
							  arg1805_2369 = normalize_progn_error_20_ast_unit(CDR(cdr_155_78_915), sexp_27);
							  arg1806_2370 = CNST_TABLE_REF(((long) 14));
							  return make_sfun_definition_61_ast_unit(arg1674_1109, __module__166_module_module, arg1677_1110, arg1805_2369, sexp_27, arg1806_2370);
						       }
						    }
						 }
					    }
					 }
				       else
					 {
					    obj_t car_1116_227_1115;
					    car_1116_227_1115 = CAR(cdr_155_78_915);
					    {
					       obj_t arg1681_1116;
					       obj_t arg1682_1117;
					       arg1681_1116 = CAR(car_1116_227_1115);
					       arg1682_1117 = CDR(car_1116_227_1115);
					       {
						  obj_t arg1805_2379;
						  obj_t arg1806_2380;
						  arg1805_2379 = normalize_progn_error_20_ast_unit(CDR(cdr_155_78_915), sexp_27);
						  arg1806_2380 = CNST_TABLE_REF(((long) 14));
						  return make_sfun_definition_61_ast_unit(arg1681_1116, __module__166_module_module, arg1682_1117, arg1805_2379, sexp_27, arg1806_2380);
					       }
					    }
					 }
				    }
				  else
				    {
				       goto tag_132_226_910;
				    }
			       }
			     else
			       {
				  goto tag_132_226_910;
			       }
			  }
			else
			  {
			     bool_t test_3214;
			     {
				obj_t aux_3217;
				obj_t aux_3215;
				aux_3217 = CNST_TABLE_REF(((long) 15));
				aux_3215 = CAR(sexp_27);
				test_3214 = (aux_3215 == aux_3217);
			     }
			     if (test_3214)
			       {
				  if (PAIRP(cdr_155_78_915))
				    {
				       obj_t car_1200_96_1122;
				       car_1200_96_1122 = CAR(cdr_155_78_915);
				       if (PAIRP(car_1200_96_1122))
					 {
					    obj_t car_1205_114_1124;
					    car_1205_114_1124 = CAR(car_1200_96_1122);
					    if (PAIRP(car_1205_114_1124))
					      {
						 obj_t cdr_1210_110_1126;
						 cdr_1210_110_1126 = CDR(car_1205_114_1124);
						 {
						    bool_t test_3229;
						    {
						       obj_t aux_3232;
						       obj_t aux_3230;
						       aux_3232 = CNST_TABLE_REF(((long) 7));
						       aux_3230 = CAR(car_1205_114_1124);
						       test_3229 = (aux_3230 == aux_3232);
						    }
						    if (test_3229)
						      {
							 if (PAIRP(cdr_1210_110_1126))
							   {
							      obj_t cdr_1214_132_1129;
							      cdr_1214_132_1129 = CDR(cdr_1210_110_1126);
							      if (PAIRP(cdr_1214_132_1129))
								{
								   bool_t test_3240;
								   {
								      obj_t aux_3241;
								      aux_3241 = CDR(cdr_1214_132_1129);
								      test_3240 = (aux_3241 == BNIL);
								   }
								   if (test_3240)
								     {
									return make_sgfun_definition_102_ast_unit(CAR(cdr_1210_110_1126), CAR(cdr_1214_132_1129), CDR(car_1200_96_1122), CDR(cdr_155_78_915), sexp_27, gdefs_28);
								     }
								   else
								     {
									obj_t car_1233_213_1137;
									car_1233_213_1137 = CAR(cdr_155_78_915);
									return make_sgfun_definition_102_ast_unit(CAR(car_1233_213_1137), __module__166_module_module, CDR(car_1233_213_1137), CDR(cdr_155_78_915), sexp_27, gdefs_28);
								     }
								}
							      else
								{
								   obj_t car_1253_248_1144;
								   car_1253_248_1144 = CAR(cdr_155_78_915);
								   return make_sgfun_definition_102_ast_unit(CAR(car_1253_248_1144), __module__166_module_module, CDR(car_1253_248_1144), CDR(cdr_155_78_915), sexp_27, gdefs_28);
								}
							   }
							 else
							   {
							      obj_t car_1273_172_1149;
							      car_1273_172_1149 = CAR(cdr_155_78_915);
							      return make_sgfun_definition_102_ast_unit(CAR(car_1273_172_1149), __module__166_module_module, CDR(car_1273_172_1149), CDR(cdr_155_78_915), sexp_27, gdefs_28);
							   }
						      }
						    else
						      {
							 obj_t car_1293_155_1154;
							 car_1293_155_1154 = CAR(cdr_155_78_915);
							 return make_sgfun_definition_102_ast_unit(CAR(car_1293_155_1154), __module__166_module_module, CDR(car_1293_155_1154), CDR(cdr_155_78_915), sexp_27, gdefs_28);
						      }
						 }
					      }
					    else
					      {
						 obj_t car_1313_238_1161;
						 car_1313_238_1161 = CAR(cdr_155_78_915);
						 return make_sgfun_definition_102_ast_unit(CAR(car_1313_238_1161), __module__166_module_module, CDR(car_1313_238_1161), CDR(cdr_155_78_915), sexp_27, gdefs_28);
					      }
					 }
				       else
					 {
					    goto tag_132_226_910;
					 }
				    }
				  else
				    {
				       goto tag_132_226_910;
				    }
			       }
			     else
			       {
				  bool_t test_3274;
				  {
				     obj_t aux_3277;
				     obj_t aux_3275;
				     aux_3277 = CNST_TABLE_REF(((long) 16));
				     aux_3275 = CAR(sexp_27);
				     test_3274 = (aux_3275 == aux_3277);
				  }
				  if (test_3274)
				    {
				       if (PAIRP(cdr_155_78_915))
					 {
					    obj_t car_1363_7_1168;
					    car_1363_7_1168 = CAR(cdr_155_78_915);
					    if (PAIRP(car_1363_7_1168))
					      {
						 obj_t arg1721_1170;
						 obj_t arg1722_1171;
						 arg1721_1170 = CAR(car_1363_7_1168);
						 arg1722_1171 = CDR(car_1363_7_1168);
						 {
						    obj_t arg1807_2461;
						    arg1807_2461 = normalize_progn_error_20_ast_unit(CDR(cdr_155_78_915), sexp_27);
						    return make_method_definition_178_ast_unit(arg1721_1170, arg1722_1171, arg1807_2461, sexp_27);
						 }
					      }
					    else
					      {
						 goto tag_132_226_910;
					      }
					 }
				       else
					 {
					    goto tag_132_226_910;
					 }
				    }
				  else
				    {
				       goto tag_132_226_910;
				    }
			       }
			  }
		     }
		}
	     }
	}
      else
	{
	   goto tag_132_226_910;
	}
   }
}


obj_t 
normalize_progn_error_20_ast_unit(obj_t exp_29, obj_t src_30)
{
   if (NULLP(exp_29))
     {
	obj_t arg1812_1261;
	arg1812_1261 = find_location_120_tools_location(src_30);
	{
	   node_t aux_3293;
	   aux_3293 = error_sexp__node_157_ast_sexp(string2254_ast_unit, src_30, arg1812_1261);
	   return (obj_t) (aux_3293);
	}
     }
   else
     {
	return normalize_progn_143_tools_progn(exp_29);
     }
}


obj_t 
get_global_arity_252_ast_unit(obj_t id_31, obj_t module_32, obj_t gdefs_33)
{
   {
      obj_t global_1262;
      if (SYMBOLP(module_32))
	{
	   obj_t list1822_1268;
	   list1822_1268 = MAKE_PAIR(module_32, BNIL);
	   global_1262 = find_global_223_ast_env(id_31, list1822_1268);
	}
      else
	{
	   global_1262 = find_global_223_ast_env(id_31, BNIL);
	}
      {
	 bool_t test1813_1263;
	 test1813_1263 = is_a__118___object(global_1262, global_ast_var);
	 if (test1813_1263)
	   {
	      bool_t test1814_1264;
	      {
		 obj_t aux_3304;
		 {
		    value_t aux_3305;
		    {
		       global_t obj_2506;
		       obj_2506 = (global_t) (global_1262);
		       aux_3305 = (((global_t) CREF(obj_2506))->value);
		    }
		    aux_3304 = (obj_t) (aux_3305);
		 }
		 test1814_1264 = is_a__118___object(aux_3304, fun_ast_var);
	      }
	      if (test1814_1264)
		{
		   fun_t obj_2509;
		   {
		      value_t aux_3311;
		      {
			 global_t obj_2508;
			 obj_2508 = (global_t) (global_1262);
			 aux_3311 = (((global_t) CREF(obj_2508))->value);
		      }
		      obj_2509 = (fun_t) (aux_3311);
		   }
		   {
		      long aux_3315;
		      aux_3315 = (((fun_t) CREF(obj_2509))->arity);
		      return BINT(aux_3315);
		   }
		}
	      else
		{
		   return BFALSE;
		}
	   }
	 else
	   {
	      return BFALSE;
	   }
      }
   }
}


obj_t 
eta_expanse_111_ast_unit(obj_t sexp_34, obj_t arity_35)
{
   {
      obj_t args_1271;
      args_1271 = make_n_proto_123_tools_args(arity_35);
      {
	 obj_t var_1299;
	 obj_t id2_1300;
	 if (PAIRP(sexp_34))
	   {
	      obj_t cdr_1463_5_1283;
	      cdr_1463_5_1283 = CDR(sexp_34);
	      {
		 bool_t test_3322;
		 {
		    obj_t aux_3325;
		    obj_t aux_3323;
		    aux_3325 = CNST_TABLE_REF(((long) 12));
		    aux_3323 = CAR(sexp_34);
		    test_3322 = (aux_3323 == aux_3325);
		 }
		 if (test_3322)
		   {
		      if (PAIRP(cdr_1463_5_1283))
			{
			   obj_t cdr_1467_193_1286;
			   cdr_1467_193_1286 = CDR(cdr_1463_5_1283);
			   if (PAIRP(cdr_1467_193_1286))
			     {
				bool_t test_3333;
				{
				   obj_t aux_3334;
				   aux_3334 = CDR(cdr_1467_193_1286);
				   test_3333 = (aux_3334 == BNIL);
				}
				if (test_3333)
				  {
				     obj_t arg1830_1289;
				     arg1830_1289 = CAR(cdr_1463_5_1283);
				     {
					obj_t id2_2525;
					id2_2525 = id_of_id_112_ast_ident(CAR(cdr_1467_193_1286));
					{
					   obj_t arg1836_2526;
					   var_1299 = arg1830_1289;
					   id2_1300 = id2_2525;
					   {
					      bool_t test_3340;
					      {
						 long aux_3341;
						 aux_3341 = (long) CINT(arity_35);
						 test_3340 = (aux_3341 >= ((long) 0));
					      }
					      if (test_3340)
						{
						   {
						      obj_t arg1840_1303;
						      obj_t arg1841_1304;
						      obj_t arg1842_1305;
						      arg1840_1303 = CNST_TABLE_REF(((long) 12));
						      arg1841_1304 = MAKE_PAIR(var_1299, args_1271);
						      {
							 obj_t arg1848_1311;
							 {
							    obj_t arg1853_1314;
							    arg1853_1314 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
							    arg1848_1311 = append_2_18___r4_pairs_and_lists_6_3(args_1271, arg1853_1314);
							 }
							 {
							    obj_t list1849_1312;
							    list1849_1312 = MAKE_PAIR(arg1848_1311, BNIL);
							    arg1842_1305 = cons__138___r4_pairs_and_lists_6_3(id2_1300, list1849_1312);
							 }
						      }
						      {
							 obj_t list1844_1307;
							 {
							    obj_t arg1845_1308;
							    {
							       obj_t arg1846_1309;
							       arg1846_1309 = MAKE_PAIR(BNIL, BNIL);
							       arg1845_1308 = MAKE_PAIR(arg1842_1305, arg1846_1309);
							    }
							    list1844_1307 = MAKE_PAIR(arg1841_1304, arg1845_1308);
							 }
							 arg1836_2526 = cons__138___r4_pairs_and_lists_6_3(arg1840_1303, list1844_1307);
						      }
						   }
						}
					      else
						{
						   bool_t test_3354;
						   {
						      long aux_3355;
						      aux_3355 = (long) CINT(arity_35);
						      test_3354 = (aux_3355 == ((long) -1));
						   }
						   if (test_3354)
						     {
							{
							   obj_t arg1858_1318;
							   obj_t arg1859_1319;
							   obj_t arg1860_1320;
							   arg1858_1318 = CNST_TABLE_REF(((long) 12));
							   arg1859_1319 = MAKE_PAIR(var_1299, args_1271);
							   {
							      obj_t arg1866_1326;
							      arg1866_1326 = CNST_TABLE_REF(((long) 17));
							      {
								 obj_t list1868_1328;
								 {
								    obj_t arg1870_1329;
								    {
								       obj_t arg1871_1330;
								       arg1871_1330 = MAKE_PAIR(BNIL, BNIL);
								       arg1870_1329 = MAKE_PAIR(args_1271, arg1871_1330);
								    }
								    list1868_1328 = MAKE_PAIR(id2_1300, arg1870_1329);
								 }
								 arg1860_1320 = cons__138___r4_pairs_and_lists_6_3(arg1866_1326, list1868_1328);
							      }
							   }
							   {
							      obj_t list1862_1322;
							      {
								 obj_t arg1863_1323;
								 {
								    obj_t arg1864_1324;
								    arg1864_1324 = MAKE_PAIR(BNIL, BNIL);
								    arg1863_1323 = MAKE_PAIR(arg1860_1320, arg1864_1324);
								 }
								 list1862_1322 = MAKE_PAIR(arg1859_1319, arg1863_1323);
							      }
							      arg1836_2526 = cons__138___r4_pairs_and_lists_6_3(arg1858_1318, list1862_1322);
							   }
							}
						     }
						   else
						     {
							{
							   obj_t arg1874_1332;
							   obj_t arg1875_1333;
							   obj_t arg1876_1334;
							   arg1874_1332 = CNST_TABLE_REF(((long) 12));
							   arg1875_1333 = MAKE_PAIR(var_1299, args_1271);
							   {
							      obj_t arg1882_1340;
							      obj_t arg1883_1341;
							      arg1882_1340 = CNST_TABLE_REF(((long) 17));
							      {
								 obj_t arg1890_1347;
								 obj_t arg1891_1348;
								 arg1890_1347 = CNST_TABLE_REF(((long) 18));
								 {
								    obj_t arg1894_1351;
								    obj_t arg1895_1352;
								    arg1894_1351 = args___args_list_50_tools_args(args_1271);
								    arg1895_1352 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
								    arg1891_1348 = append_2_18___r4_pairs_and_lists_6_3(arg1894_1351, arg1895_1352);
								 }
								 {
								    obj_t list1892_1349;
								    list1892_1349 = MAKE_PAIR(arg1891_1348, BNIL);
								    arg1883_1341 = cons__138___r4_pairs_and_lists_6_3(arg1890_1347, list1892_1349);
								 }
							      }
							      {
								 obj_t list1885_1343;
								 {
								    obj_t arg1886_1344;
								    {
								       obj_t arg1887_1345;
								       arg1887_1345 = MAKE_PAIR(BNIL, BNIL);
								       arg1886_1344 = MAKE_PAIR(arg1883_1341, arg1887_1345);
								    }
								    list1885_1343 = MAKE_PAIR(id2_1300, arg1886_1344);
								 }
								 arg1876_1334 = cons__138___r4_pairs_and_lists_6_3(arg1882_1340, list1885_1343);
							      }
							   }
							   {
							      obj_t list1878_1336;
							      {
								 obj_t arg1879_1337;
								 {
								    obj_t arg1880_1338;
								    arg1880_1338 = MAKE_PAIR(BNIL, BNIL);
								    arg1879_1337 = MAKE_PAIR(arg1876_1334, arg1880_1338);
								 }
								 list1878_1336 = MAKE_PAIR(arg1875_1333, arg1879_1337);
							      }
							      arg1836_2526 = cons__138___r4_pairs_and_lists_6_3(arg1874_1332, list1878_1336);
							   }
							}
						     }
						}
					   }
					   return replace__160_tools_misc(sexp_34, arg1836_2526);
					}
				     }
				  }
				else
				  {
				     return BFALSE;
				  }
			     }
			   else
			     {
				return BFALSE;
			     }
			}
		      else
			{
			   return BFALSE;
			}
		   }
		 else
		   {
		      return BFALSE;
		   }
	      }
	   }
	 else
	   {
	      return BFALSE;
	   }
      }
   }
}


obj_t 
make_sfun_definition_61_ast_unit(obj_t id_36, obj_t module_37, obj_t args_38, obj_t body_39, obj_t src_40, obj_t class_41)
{
   {
      obj_t locals_1435;
      {
	 obj_t args_1441;
	 obj_t res_1442;
	 args_1441 = args_38;
	 res_1442 = BNIL;
       loop_1443:
	 if (NULLP(args_1441))
	   {
	      locals_1435 = reverse__39___r4_pairs_and_lists_6_3(res_1442);
	   }
	 else
	   {
	      if (PAIRP(args_1441))
		{
		   bool_t test1990_1447;
		   {
		      obj_t aux_3392;
		      aux_3392 = dsssl_named_constant__188_tools_dsssl(CAR(args_1441));
		      test1990_1447 = CBOOL(aux_3392);
		   }
		   if (test1990_1447)
		     {
			{
			   obj_t arg_1448;
			   arg_1448 = dsssl_find_first_formal_237_tools_dsssl(args_1441);
			   if (CBOOL(arg_1448))
			     {
				obj_t arg1992_1449;
				{
				   local_t arg1993_1450;
				   arg1993_1450 = make_local_svar_140_ast_local(arg_1448, (type_t) (__obj__252_type_cache));
				   {
				      obj_t aux_3402;
				      aux_3402 = (obj_t) (arg1993_1450);
				      arg1992_1449 = MAKE_PAIR(aux_3402, res_1442);
				   }
				}
				locals_1435 = reverse__39___r4_pairs_and_lists_6_3(arg1992_1449);
			     }
			   else
			     {
				locals_1435 = reverse__39___r4_pairs_and_lists_6_3(res_1442);
			     }
			}
		     }
		   else
		     {
			{
			   obj_t pid_1451;
			   {
			      obj_t arg1998_1457;
			      arg1998_1457 = parse_id_241_ast_ident(CAR(args_1441));
			      pid_1451 = check_id_6_ast_ident(arg1998_1457, src_40);
			   }
			   {
			      {
				 obj_t arg1995_1454;
				 obj_t arg1996_1455;
				 arg1995_1454 = CDR(args_1441);
				 {
				    local_t arg1997_1456;
				    {
				       type_t aux_3411;
				       {
					  obj_t aux_3413;
					  aux_3413 = CDR(pid_1451);
					  aux_3411 = (type_t) (aux_3413);
				       }
				       arg1997_1456 = make_local_svar_140_ast_local(CAR(pid_1451), aux_3411);
				    }
				    {
				       obj_t aux_3417;
				       aux_3417 = (obj_t) (arg1997_1456);
				       arg1996_1455 = MAKE_PAIR(aux_3417, res_1442);
				    }
				 }
				 {
				    obj_t res_3421;
				    obj_t args_3420;
				    args_3420 = arg1995_1454;
				    res_3421 = arg1996_1455;
				    res_1442 = res_3421;
				    args_1441 = args_3420;
				    goto loop_1443;
				 }
			      }
			   }
			}
		     }
		}
	      else
		{
		   {
		      obj_t pid_1460;
		      {
			 obj_t arg2003_1465;
			 arg2003_1465 = parse_id_241_ast_ident(args_1441);
			 pid_1460 = check_id_6_ast_ident(arg2003_1465, src_40);
		      }
		      {
			 {
			    obj_t arg2001_1463;
			    {
			       local_t arg2002_1464;
			       {
				  type_t aux_3424;
				  {
				     obj_t aux_3426;
				     aux_3426 = CDR(pid_1460);
				     aux_3424 = (type_t) (aux_3426);
				  }
				  arg2002_1464 = make_local_svar_140_ast_local(CAR(pid_1460), aux_3424);
			       }
			       {
				  obj_t aux_3430;
				  aux_3430 = (obj_t) (arg2002_1464);
				  arg2001_1463 = MAKE_PAIR(aux_3430, res_1442);
			       }
			    }
			    locals_1435 = reverse__39___r4_pairs_and_lists_6_3(arg2001_1463);
			 }
		      }
		   }
		}
	   }
      }
      {
	 obj_t body_1436;
	 body_1436 = make_dsssl_function_prelude_58___dsssl(id_36, args_38, body_39, user_error_env_101_tools_error);
	 {
	    {
	       global_t arg1983_1437;
	       arg1983_1437 = def_global_sfun__93_ast_glo_def_117(id_36, args_38, locals_1435, module_37, class_41, src_40, CNST_TABLE_REF(((long) 19)), body_1436);
	       {
		  obj_t list1984_1438;
		  {
		     obj_t aux_3437;
		     aux_3437 = (obj_t) (arg1983_1437);
		     list1984_1438 = MAKE_PAIR(aux_3437, BNIL);
		  }
		  return list1984_1438;
	       }
	    }
	 }
      }
   }
}


obj_t 
make_svar_definition_154_ast_unit(obj_t id_42, obj_t src_43)
{
   def_global_svar__184_ast_glo_def_117(id_42, __module__166_module_module, src_43, CNST_TABLE_REF(((long) 19)));
   {
      obj_t arg2005_1467;
      obj_t arg2006_1468;
      arg2005_1467 = CDR(src_43);
      {
	 obj_t arg2007_1469;
	 {
	    obj_t arg2008_1470;
	    arg2008_1470 = parse_id_241_ast_ident(id_42);
	    arg2007_1469 = check_id_6_ast_ident(arg2008_1470, src_43);
	 }
	 arg2006_1468 = CAR(arg2007_1469);
      }
      SET_CAR(arg2005_1467, arg2006_1468);
   }
   {
      obj_t list2009_1471;
      list2009_1471 = MAKE_PAIR(src_43, BNIL);
      return list2009_1471;
   }
}


obj_t 
make_sgfun_default_250_ast_unit(obj_t name_44, obj_t type_45, obj_t args_46, obj_t body_47, obj_t src_48, obj_t gdefs_49)
{
   {
      bool_t test2013_1473;
      {
	 obj_t aux_3448;
	 aux_3448 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 2)), BINT(((long) 0)));
	 test2013_1473 = CBOOL(aux_3448);
      }
      if (test2013_1473)
	{
	   obj_t list2014_1474;
	   {
	      obj_t arg2016_1476;
	      {
		 obj_t arg2017_1477;
		 {
		    obj_t arg2019_1479;
		    {
		       obj_t arg2020_1480;
		       {
			  obj_t arg2023_1482;
			  {
			     obj_t arg2025_1483;
			     {
				obj_t aux_3454;
				aux_3454 = BCHAR(((unsigned char) '\n'));
				arg2025_1483 = MAKE_PAIR(aux_3454, BNIL);
			     }
			     arg2023_1482 = MAKE_PAIR(body_47, arg2025_1483);
			  }
			  arg2020_1480 = MAKE_PAIR(string2255_ast_unit, arg2023_1482);
		       }
		       arg2019_1479 = MAKE_PAIR(args_46, arg2020_1480);
		    }
		    arg2017_1477 = MAKE_PAIR(string2255_ast_unit, arg2019_1479);
		 }
		 arg2016_1476 = MAKE_PAIR(name_44, arg2017_1477);
	      }
	      list2014_1474 = MAKE_PAIR(string2256_ast_unit, arg2016_1476);
	   }
	   print_trace_107_tools_trace(list2014_1474);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t default_tid_30_1488;
      {
	 bool_t test2067_1523;
	 {
	    obj_t obj2_2571;
	    obj2_2571 = _____74_type_cache;
	    test2067_1523 = (type_45 == obj2_2571);
	 }
	 if (test2067_1523)
	   {
	      default_tid_30_1488 = name_44;
	   }
	 else
	   {
	      obj_t list2069_1525;
	      {
		 obj_t arg2070_1526;
		 {
		    obj_t arg2071_1527;
		    {
		       obj_t aux_3466;
		       {
			  type_t obj_2572;
			  obj_2572 = (type_t) (type_45);
			  aux_3466 = (((type_t) CREF(obj_2572))->id);
		       }
		       arg2071_1527 = MAKE_PAIR(aux_3466, BNIL);
		    }
		    arg2070_1526 = MAKE_PAIR(_4dots_tools_misc, arg2071_1527);
		 }
		 list2069_1525 = MAKE_PAIR(name_44, arg2070_1526);
	      }
	      default_tid_30_1488 = symbol_append_197___r4_symbols_6_4(list2069_1525);
	   }
      }
      {
	 obj_t default_body_201_1489;
	 if (PAIRP(body_47))
	   {
	      default_body_201_1489 = normalize_progn_143_tools_progn(body_47);
	   }
	 else
	   {
	      obj_t arg2048_1507;
	      obj_t arg2050_1508;
	      obj_t arg2052_1510;
	      arg2048_1507 = CNST_TABLE_REF(((long) 20));
	      {
		 obj_t arg2059_1517;
		 arg2059_1517 = CNST_TABLE_REF(((long) 21));
		 {
		    obj_t list2061_1519;
		    {
		       obj_t arg2062_1520;
		       arg2062_1520 = MAKE_PAIR(BNIL, BNIL);
		       list2061_1519 = MAKE_PAIR(name_44, arg2062_1520);
		    }
		    arg2050_1508 = cons__138___r4_pairs_and_lists_6_3(arg2059_1517, list2061_1519);
		 }
	      }
	      arg2052_1510 = id_of_id_112_ast_ident(CAR(args_46));
	      {
		 obj_t list2054_1512;
		 {
		    obj_t arg2055_1513;
		    {
		       obj_t arg2056_1514;
		       {
			  obj_t arg2057_1515;
			  arg2057_1515 = MAKE_PAIR(BNIL, BNIL);
			  arg2056_1514 = MAKE_PAIR(arg2052_1510, arg2057_1515);
		       }
		       arg2055_1513 = MAKE_PAIR(string2257_ast_unit, arg2056_1514);
		    }
		    list2054_1512 = MAKE_PAIR(arg2050_1508, arg2055_1513);
		 }
		 default_body_201_1489 = cons__138___r4_pairs_and_lists_6_3(arg2048_1507, list2054_1512);
	      }
	   }
	 {
	    {
	       bool_t test2029_1490;
	       {
		  obj_t aux_3488;
		  aux_3488 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 2)), BINT(((long) 2)));
		  test2029_1490 = CBOOL(aux_3488);
	       }
	       if (test2029_1490)
		 {
		    obj_t list2030_1491;
		    {
		       obj_t arg2032_1493;
		       {
			  obj_t arg2033_1494;
			  {
			     obj_t aux_3494;
			     aux_3494 = BCHAR(((unsigned char) '\n'));
			     arg2033_1494 = MAKE_PAIR(aux_3494, BNIL);
			  }
			  arg2032_1493 = MAKE_PAIR(default_body_201_1489, arg2033_1494);
		       }
		       list2030_1491 = MAKE_PAIR(string2258_ast_unit, arg2032_1493);
		    }
		    print_trace_107_tools_trace(list2030_1491);
		 }
	       else
		 {
		    BUNSPEC;
		 }
	    }
	    {
	       obj_t arg2037_1498;
	       {
		  obj_t arg2039_1499;
		  obj_t arg2040_1500;
		  arg2039_1499 = CNST_TABLE_REF(((long) 12));
		  arg2040_1500 = MAKE_PAIR(default_tid_30_1488, args_46);
		  {
		     obj_t list2042_1502;
		     {
			obj_t arg2043_1503;
			{
			   obj_t arg2045_1504;
			   arg2045_1504 = MAKE_PAIR(BNIL, BNIL);
			   arg2043_1503 = MAKE_PAIR(default_body_201_1489, arg2045_1504);
			}
			list2042_1502 = MAKE_PAIR(arg2040_1500, arg2043_1503);
		     }
		     arg2037_1498 = cons__138___r4_pairs_and_lists_6_3(arg2039_1499, list2042_1502);
		  }
	       }
	       return toplevel__ast_219_ast_unit(arg2037_1498, gdefs_49);
	    }
	 }
      }
   }
}


obj_t 
make_sgfun_definition_102_ast_unit(obj_t id_50, obj_t module_51, obj_t args_52, obj_t body_53, obj_t src_54, obj_t gdefs_55)
{
   {
      bool_t test2073_1529;
      {
	 obj_t aux_3507;
	 aux_3507 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 2)), BINT(((long) 0)));
	 test2073_1529 = CBOOL(aux_3507);
      }
      if (test2073_1529)
	{
	   obj_t list2074_1530;
	   {
	      obj_t arg2077_1532;
	      {
		 obj_t arg2078_1533;
		 {
		    obj_t arg2080_1535;
		    {
		       obj_t arg2081_1536;
		       {
			  obj_t arg2084_1538;
			  {
			     obj_t arg2085_1539;
			     {
				obj_t arg2087_1541;
				{
				   obj_t arg2088_1542;
				   {
				      obj_t aux_3513;
				      aux_3513 = BCHAR(((unsigned char) '\n'));
				      arg2088_1542 = MAKE_PAIR(aux_3513, BNIL);
				   }
				   arg2087_1541 = MAKE_PAIR(body_53, arg2088_1542);
				}
				arg2085_1539 = MAKE_PAIR(string2255_ast_unit, arg2087_1541);
			     }
			     arg2084_1538 = MAKE_PAIR(args_52, arg2085_1539);
			  }
			  arg2081_1536 = MAKE_PAIR(string2255_ast_unit, arg2084_1538);
		       }
		       arg2080_1535 = MAKE_PAIR(module_51, arg2081_1536);
		    }
		    arg2078_1533 = MAKE_PAIR(string2255_ast_unit, arg2080_1535);
		 }
		 arg2077_1532 = MAKE_PAIR(id_50, arg2078_1533);
	      }
	      list2074_1530 = MAKE_PAIR(string2259_ast_unit, arg2077_1532);
	   }
	   print_trace_107_tools_trace(list2074_1530);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t locals_1546;
      {
	 obj_t args_1597;
	 obj_t res_1598;
	 args_1597 = args_52;
	 res_1598 = BNIL;
       loop_1599:
	 if (NULLP(args_1597))
	   {
	      locals_1546 = reverse__39___r4_pairs_and_lists_6_3(res_1598);
	   }
	 else
	   {
	      if (PAIRP(args_1597))
		{
		   {
		      obj_t pid_1603;
		      {
			 obj_t arg2144_1609;
			 arg2144_1609 = parse_id_241_ast_ident(CAR(args_1597));
			 pid_1603 = check_id_6_ast_ident(arg2144_1609, src_54);
		      }
		      {
			 {
			    obj_t arg2141_1606;
			    obj_t arg2142_1607;
			    arg2141_1606 = CDR(args_1597);
			    {
			       local_t arg2143_1608;
			       {
				  type_t aux_3534;
				  {
				     obj_t aux_3536;
				     aux_3536 = CDR(pid_1603);
				     aux_3534 = (type_t) (aux_3536);
				  }
				  arg2143_1608 = make_local_svar_140_ast_local(CAR(pid_1603), aux_3534);
			       }
			       {
				  obj_t aux_3540;
				  aux_3540 = (obj_t) (arg2143_1608);
				  arg2142_1607 = MAKE_PAIR(aux_3540, res_1598);
			       }
			    }
			    {
			       obj_t res_3544;
			       obj_t args_3543;
			       args_3543 = arg2141_1606;
			       res_3544 = arg2142_1607;
			       res_1598 = res_3544;
			       args_1597 = args_3543;
			       goto loop_1599;
			    }
			 }
		      }
		   }
		}
	      else
		{
		   {
		      obj_t pid_1611;
		      {
			 obj_t arg2149_1616;
			 arg2149_1616 = parse_id_241_ast_ident(args_1597);
			 pid_1611 = check_id_6_ast_ident(arg2149_1616, src_54);
		      }
		      {
			 {
			    obj_t arg2146_1614;
			    {
			       local_t arg2148_1615;
			       {
				  type_t aux_3547;
				  {
				     obj_t aux_3549;
				     aux_3549 = CDR(pid_1611);
				     aux_3547 = (type_t) (aux_3549);
				  }
				  arg2148_1615 = make_local_svar_140_ast_local(CAR(pid_1611), aux_3547);
			       }
			       {
				  obj_t aux_3553;
				  aux_3553 = (obj_t) (arg2148_1615);
				  arg2146_1614 = MAKE_PAIR(aux_3553, res_1598);
			       }
			    }
			    locals_1546 = reverse__39___r4_pairs_and_lists_6_3(arg2146_1614);
			 }
		      }
		   }
		}
	   }
      }
      {
	 obj_t pid_1547;
	 {
	    obj_t arg2136_1596;
	    arg2136_1596 = parse_id_241_ast_ident(id_50);
	    pid_1547 = check_id_6_ast_ident(arg2136_1596, src_54);
	 }
	 {
	    obj_t name_1548;
	    name_1548 = CAR(pid_1547);
	    {
	       obj_t type_1549;
	       type_1549 = CDR(pid_1547);
	       {
		  obj_t dname_1550;
		  {
		     obj_t arg2131_1591;
		     {
			obj_t list2133_1593;
			{
			   obj_t arg2134_1594;
			   {
			      obj_t aux_3561;
			      aux_3561 = CNST_TABLE_REF(((long) 22));
			      arg2134_1594 = MAKE_PAIR(aux_3561, BNIL);
			   }
			   list2133_1593 = MAKE_PAIR(name_1548, arg2134_1594);
			}
			arg2131_1591 = symbol_append_197___r4_symbols_6_4(list2133_1593);
		     }
		     dname_1550 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, arg2131_1591, BEOA);
		  }
		  {
		     obj_t default_199_1551;
		     {
			bool_t test2130_1590;
			{
			   obj_t obj2_2592;
			   obj2_2592 = __module__166_module_module;
			   test2130_1590 = (module_51 == obj2_2592);
			}
			if (test2130_1590)
			  {
			     default_199_1551 = make_sgfun_default_250_ast_unit(dname_1550, type_1549, args_52, body_53, src_54, gdefs_55);
			  }
			else
			  {
			     default_199_1551 = BNIL;
			  }
		     }
		     {
			obj_t body_1552;
			body_1552 = make_generic_body_233_object_generic(id_50, locals_1546, args_52, src_54);
			{
			   global_t generic_1553;
			   generic_1553 = def_global_sfun__93_ast_glo_def_117(id_50, args_52, locals_1546, module_51, CNST_TABLE_REF(((long) 23)), src_54, CNST_TABLE_REF(((long) 19)), body_1552);
			   {
			      {
				 bool_t test2093_1554;
				 {
				    obj_t aux_3575;
				    aux_3575 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 2)), BINT(((long) 2)));
				    test2093_1554 = CBOOL(aux_3575);
				 }
				 if (test2093_1554)
				   {
				      obj_t list2094_1555;
				      {
					 obj_t arg2096_1557;
					 {
					    obj_t arg2097_1558;
					    {
					       obj_t aux_3581;
					       aux_3581 = BCHAR(((unsigned char) '\n'));
					       arg2097_1558 = MAKE_PAIR(aux_3581, BNIL);
					    }
					    arg2096_1557 = MAKE_PAIR(body_1552, arg2097_1558);
					 }
					 list2094_1555 = MAKE_PAIR(string2260_ast_unit, arg2096_1557);
				      }
				      print_trace_107_tools_trace(list2094_1555);
				   }
				 else
				   {
				      BUNSPEC;
				   }
			      }
			      add_generic_for_method_inlining__147_object_inline((obj_t) (generic_1553));
			      {
				 obj_t arg2101_1562;
				 {
				    obj_t arg2102_1563;
				    {
				       obj_t arg2103_1564;
				       {
					  obj_t arg2106_1567;
					  obj_t arg2107_1568;
					  obj_t arg2108_1569;
					  arg2106_1567 = CNST_TABLE_REF(((long) 24));
					  {
					     obj_t arg2114_1575;
					     obj_t arg2115_1576;
					     arg2114_1575 = CNST_TABLE_REF(((long) 7));
					     arg2115_1576 = (((global_t) CREF(generic_1553))->id);
					     {
						obj_t list2118_1578;
						{
						   obj_t arg2119_1579;
						   {
						      obj_t arg2120_1580;
						      arg2120_1580 = MAKE_PAIR(BNIL, BNIL);
						      arg2119_1579 = MAKE_PAIR(module_51, arg2120_1580);
						   }
						   list2118_1578 = MAKE_PAIR(arg2115_1576, arg2119_1579);
						}
						arg2107_1568 = cons__138___r4_pairs_and_lists_6_3(arg2114_1575, list2118_1578);
					     }
					  }
					  {
					     obj_t arg2122_1582;
					     arg2122_1582 = CNST_TABLE_REF(((long) 7));
					     {
						obj_t list2124_1584;
						{
						   obj_t arg2125_1585;
						   {
						      obj_t arg2126_1586;
						      arg2126_1586 = MAKE_PAIR(BNIL, BNIL);
						      arg2125_1585 = MAKE_PAIR(__module__166_module_module, arg2126_1586);
						   }
						   list2124_1584 = MAKE_PAIR(dname_1550, arg2125_1585);
						}
						arg2108_1569 = cons__138___r4_pairs_and_lists_6_3(arg2122_1582, list2124_1584);
					     }
					  }
					  {
					     obj_t list2110_1571;
					     {
						obj_t arg2111_1572;
						{
						   obj_t arg2112_1573;
						   arg2112_1573 = MAKE_PAIR(BNIL, BNIL);
						   arg2111_1572 = MAKE_PAIR(arg2108_1569, arg2112_1573);
						}
						list2110_1571 = MAKE_PAIR(arg2107_1568, arg2111_1572);
					     }
					     arg2103_1564 = cons__138___r4_pairs_and_lists_6_3(arg2106_1567, list2110_1571);
					  }
				       }
				       {
					  obj_t list2104_1565;
					  list2104_1565 = MAKE_PAIR(arg2103_1564, BNIL);
					  arg2102_1563 = list2104_1565;
				       }
				    }
				    arg2101_1562 = append_2_18___r4_pairs_and_lists_6_3(arg2102_1563, default_199_1551);
				 }
				 {
				    obj_t aux_3607;
				    aux_3607 = (obj_t) (generic_1553);
				    return MAKE_PAIR(aux_3607, arg2101_1562);
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
make_method_definition_178_ast_unit(obj_t id_56, obj_t args_57, obj_t body_58, obj_t src_59)
{
   {
      obj_t locals_1617;
      {
	 obj_t args_1621;
	 obj_t res_1622;
	 args_1621 = args_57;
	 res_1622 = BNIL;
       loop_1623:
	 if (NULLP(args_1621))
	   {
	      locals_1617 = reverse__39___r4_pairs_and_lists_6_3(res_1622);
	   }
	 else
	   {
	      if (PAIRP(args_1621))
		{
		   {
		      obj_t pid_1627;
		      {
			 obj_t arg2162_1633;
			 arg2162_1633 = parse_id_241_ast_ident(CAR(args_1621));
			 pid_1627 = check_id_6_ast_ident(arg2162_1633, src_59);
		      }
		      {
			 {
			    obj_t arg2156_1630;
			    obj_t arg2160_1631;
			    arg2156_1630 = CDR(args_1621);
			    {
			       local_t arg2161_1632;
			       {
				  type_t aux_3619;
				  {
				     obj_t aux_3621;
				     aux_3621 = CDR(pid_1627);
				     aux_3619 = (type_t) (aux_3621);
				  }
				  arg2161_1632 = make_local_svar_140_ast_local(CAR(pid_1627), aux_3619);
			       }
			       {
				  obj_t aux_3625;
				  aux_3625 = (obj_t) (arg2161_1632);
				  arg2160_1631 = MAKE_PAIR(aux_3625, res_1622);
			       }
			    }
			    {
			       obj_t res_3629;
			       obj_t args_3628;
			       args_3628 = arg2156_1630;
			       res_3629 = arg2160_1631;
			       res_1622 = res_3629;
			       args_1621 = args_3628;
			       goto loop_1623;
			    }
			 }
		      }
		   }
		}
	      else
		{
		   {
		      obj_t pid_1635;
		      {
			 obj_t arg2166_1640;
			 arg2166_1640 = parse_id_241_ast_ident(args_1621);
			 pid_1635 = check_id_6_ast_ident(arg2166_1640, src_59);
		      }
		      {
			 {
			    obj_t arg2164_1638;
			    {
			       local_t arg2165_1639;
			       {
				  type_t aux_3632;
				  {
				     obj_t aux_3634;
				     aux_3634 = CDR(pid_1635);
				     aux_3632 = (type_t) (aux_3634);
				  }
				  arg2165_1639 = make_local_svar_140_ast_local(CAR(pid_1635), aux_3632);
			       }
			       {
				  obj_t aux_3638;
				  aux_3638 = (obj_t) (arg2165_1639);
				  arg2164_1638 = MAKE_PAIR(aux_3638, res_1622);
			       }
			    }
			    locals_1617 = reverse__39___r4_pairs_and_lists_6_3(arg2164_1638);
			 }
		      }
		   }
		}
	   }
      }
      {
	 bool_t test2150_1618;
	 test2150_1618 = check_method_definition_71_ast_glo_def_117(id_56, args_57, locals_1617, src_59);
	 if (test2150_1618)
	   {
	      return make_method_body_103_object_method(id_56, args_57, locals_1617, body_58, src_59);
	   }
	 else
	   {
	      obj_t list2151_1619;
	      list2151_1619 = MAKE_PAIR(BUNSPEC, BNIL);
	      return list2151_1619;
	   }
      }
   }
}


obj_t 
imported_modules_init_94_ast_unit()
{
   module_initialization_70_type_type(((long) 0), "AST_UNIT");
   module_initialization_70_ast_var(((long) 0), "AST_UNIT");
   module_initialization_70_ast_node(((long) 0), "AST_UNIT");
   module_initialization_70_tools_trace(((long) 0), "AST_UNIT");
   module_initialization_70_ast_find_gdefs_13(((long) 0), "AST_UNIT");
   module_initialization_70_ast_glo_def_117(((long) 0), "AST_UNIT");
   module_initialization_70_ast_ident(((long) 0), "AST_UNIT");
   module_initialization_70_ast_env(((long) 0), "AST_UNIT");
   module_initialization_70_ast_local(((long) 0), "AST_UNIT");
   module_initialization_70_ast_sexp(((long) 0), "AST_UNIT");
   module_initialization_70_object_generic(((long) 0), "AST_UNIT");
   module_initialization_70_object_method(((long) 0), "AST_UNIT");
   module_initialization_70_object_inline(((long) 0), "AST_UNIT");
   module_initialization_70_tools_progn(((long) 0), "AST_UNIT");
   module_initialization_70_tools_args(((long) 0), "AST_UNIT");
   module_initialization_70_tools_misc(((long) 0), "AST_UNIT");
   module_initialization_70_tools_speek(((long) 0), "AST_UNIT");
   module_initialization_70_tools_shape(((long) 0), "AST_UNIT");
   module_initialization_70_tools_location(((long) 0), "AST_UNIT");
   module_initialization_70_tools_error(((long) 0), "AST_UNIT");
   module_initialization_70_tools_dsssl(((long) 0), "AST_UNIT");
   module_initialization_70_engine_param(((long) 0), "AST_UNIT");
   module_initialization_70_module_module(((long) 0), "AST_UNIT");
   return module_initialization_70_type_cache(((long) 0), "AST_UNIT");
}
