/*===========================================================================*/
/*   (Ast/var.scm)                                                           */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


static variable_t allocate_variable_244_ast_var();
static sfun_t allocate_sfun_135_ast_var();
static obj_t struct_object__object_sfun1760_141_ast_var(obj_t, obj_t, obj_t);
static local_t allocate_local_177_ast_var();
static obj_t struct_object__object_local1756_181_ast_var(obj_t, obj_t, obj_t);
static obj_t object__struct_local1757_54_ast_var(obj_t, obj_t);
static obj_t _allocate_sfun_141_ast_var(obj_t);
static obj_t _allocate_cvar_101_ast_var(obj_t);
static obj_t object__struct_cvar1769_129_ast_var(obj_t, obj_t);
obj_t scnst_ast_var = BUNSPEC;
obj_t global_ast_var = BUNSPEC;
static value_t allocate_value_190_ast_var();
obj_t fun_ast_var = BUNSPEC;
static obj_t object__struct_sfun1761_29_ast_var(obj_t, obj_t);
extern obj_t _struct_object__object_6___object(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_ast_var();
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t _allocate_cfun_27_ast_var(obj_t);
obj_t sexit_ast_var = BUNSPEC;
static obj_t toplevel_init_63_ast_var();
static obj_t cnst_init_137_ast_var();
static obj_t object__struct_svar1765_105_ast_var(obj_t, obj_t);
static obj_t struct_object__object_cfun1762_41_ast_var(obj_t, obj_t, obj_t);
static fun_t allocate_fun_149_ast_var();
obj_t cfun_ast_var = BUNSPEC;
static obj_t object__struct_value1751_95_ast_var(obj_t, obj_t);
static obj_t object__struct_global1755_167_ast_var(obj_t, obj_t);
static obj_t struct_object__object_sexit1770_154_ast_var(obj_t, obj_t, obj_t);
static obj_t require_initialization_114_ast_var = BUNSPEC;
static sexit_t allocate_sexit_47_ast_var();
static obj_t library_modules_init_112_ast_var();
static obj_t object__struct_sexit1771_236_ast_var(obj_t, obj_t);
static obj_t _allocate_svar_73_ast_var(obj_t);
obj_t sfun_ast_var = BUNSPEC;
obj_t variable_ast_var = BUNSPEC;
extern obj_t read___reader(obj_t);
static obj_t object__struct_fun1759_24_ast_var(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
static obj_t _allocate_fun_230_ast_var(obj_t);
static scnst_t allocate_scnst_81_ast_var();
static obj_t object__struct_variable1753_249_ast_var(obj_t, obj_t);
static obj_t struct_object__object_variable1752_45_ast_var(obj_t, obj_t, obj_t);
extern long class_num_218___object(obj_t);
static obj_t struct_object__object_cvar1768_108_ast_var(obj_t, obj_t, obj_t);
static obj_t object__struct_cfun1763_72_ast_var(obj_t, obj_t);
static obj_t struct_object__object_scnst1766_40_ast_var(obj_t, obj_t, obj_t);
extern obj_t object___object;
static obj_t _allocate_sexit_130_ast_var(obj_t);
static obj_t _allocate_local_35_ast_var(obj_t);
static obj_t _allocate_global_232_ast_var(obj_t);
static obj_t _allocate_variable_137_ast_var(obj_t);
obj_t svar_ast_var = BUNSPEC;
obj_t cvar_ast_var = BUNSPEC;
static obj_t struct_object__object_fun1758_255_ast_var(obj_t, obj_t, obj_t);
obj_t value_ast_var = BUNSPEC;
static obj_t _allocate_value_13_ast_var(obj_t);
static obj_t object_init_111_ast_var();
obj_t local_ast_var = BUNSPEC;
static obj_t _allocate_scnst_4_ast_var(obj_t);
static obj_t struct_object__object_svar1764_229_ast_var(obj_t, obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static obj_t struct_object__object_global1754_72_ast_var(obj_t, obj_t, obj_t);
static svar_t allocate_svar_218_ast_var();
static cfun_t allocate_cfun_23_ast_var();
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t _object__struct_74___object(obj_t, obj_t);
static obj_t object__struct_scnst1767_121_ast_var(obj_t, obj_t);
static obj_t struct_object__object_value1750_104_ast_var(obj_t, obj_t, obj_t);
static cvar_t allocate_cvar_254_ast_var();
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t);
static global_t allocate_global_222_ast_var();
static obj_t __cnst[11];

DEFINE_STATIC_PROCEDURE(proc1793_ast_var, object__struct_variable1753_249_ast_var1803, object__struct_variable1753_249_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_local_env_7_ast_var, _allocate_local_35_ast_var1804, _allocate_local_35_ast_var, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1792_ast_var, struct_object__object_global1754_72_ast_var1805, struct_object__object_global1754_72_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1783_ast_var, object__struct_cfun1763_72_ast_var1806, object__struct_cfun1763_72_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1790_ast_var, struct_object__object_local1756_181_ast_var1807, struct_object__object_local1756_181_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1785_ast_var, object__struct_sfun1761_29_ast_var1808, object__struct_sfun1761_29_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1781_ast_var, object__struct_svar1765_105_ast_var1809, object__struct_svar1765_105_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_svar_env_12_ast_var, _allocate_svar_73_ast_var1810, _allocate_svar_73_ast_var, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1796_ast_var, struct_object__object_value1750_104_ast_var1811, struct_object__object_value1750_104_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1776_ast_var, struct_object__object_sexit1770_154_ast_var1812, struct_object__object_sexit1770_154_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1787_ast_var, object__struct_fun1759_24_ast_var1813, object__struct_fun1759_24_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_fun_env_191_ast_var, _allocate_fun_230_ast_var1814, _allocate_fun_230_ast_var, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1778_ast_var, struct_object__object_cvar1768_108_ast_var1815, struct_object__object_cvar1768_108_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1789_ast_var, object__struct_local1757_54_ast_var1816, object__struct_local1757_54_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_cfun_env_241_ast_var, _allocate_cfun_27_ast_var1817, _allocate_cfun_27_ast_var, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1782_ast_var, struct_object__object_svar1764_229_ast_var1818, struct_object__object_svar1764_229_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_variable_env_212_ast_var, _allocate_variable_137_ast_var1819, _allocate_variable_137_ast_var, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_sfun_env_18_ast_var, _allocate_sfun_141_ast_var1820, _allocate_sfun_141_ast_var, 0L, 0);
extern obj_t struct_object__object_env_209___object;
DEFINE_STATIC_PROCEDURE(proc1794_ast_var, struct_object__object_variable1752_45_ast_var1821, struct_object__object_variable1752_45_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1786_ast_var, struct_object__object_sfun1760_141_ast_var1822, struct_object__object_sfun1760_141_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1777_ast_var, object__struct_cvar1769_129_ast_var1823, object__struct_cvar1769_129_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1791_ast_var, object__struct_global1755_167_ast_var1824, object__struct_global1755_167_ast_var, 0L, 1);
DEFINE_STRING(string1797_ast_var, string1797_ast_var1825, "SEXIT CVAR SCNST SVAR CFUN SFUN FUN LOCAL GLOBAL VARIABLE VALUE ", 64);
DEFINE_STATIC_PROCEDURE(proc1795_ast_var, object__struct_value1751_95_ast_var1826, object__struct_value1751_95_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_value_env_188_ast_var, _allocate_value_13_ast_var1827, _allocate_value_13_ast_var, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_scnst_env_226_ast_var, _allocate_scnst_4_ast_var1828, _allocate_scnst_4_ast_var, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1788_ast_var, struct_object__object_fun1758_255_ast_var1829, struct_object__object_fun1758_255_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1779_ast_var, object__struct_scnst1767_121_ast_var1830, object__struct_scnst1767_121_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1780_ast_var, struct_object__object_scnst1766_40_ast_var1831, struct_object__object_scnst1766_40_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_sexit_env_61_ast_var, _allocate_sexit_130_ast_var1832, _allocate_sexit_130_ast_var, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1775_ast_var, object__struct_sexit1771_236_ast_var1833, object__struct_sexit1771_236_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1784_ast_var, struct_object__object_cfun1762_41_ast_var1834, struct_object__object_cfun1762_41_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_cvar_env_85_ast_var, _allocate_cvar_101_ast_var1835, _allocate_cvar_101_ast_var, 0L, 0);
extern obj_t object__struct_env_210___object;
DEFINE_STATIC_PROCEDURE(allocate_global_env_97_ast_var, _allocate_global_232_ast_var1836, _allocate_global_232_ast_var, 0L, 0);

obj_t 
module_initialization_70_ast_var(long checksum_1414, char *from_1415)
{
   if (CBOOL(require_initialization_114_ast_var))
     {
	require_initialization_114_ast_var = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_var();
	cnst_init_137_ast_var();
	object_init_111_ast_var();
	imported_modules_init_94_ast_var();
	toplevel_init_63_ast_var();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_var()
{
   module_initialization_70___reader(((long) 0), "AST_VAR");
   module_initialization_70___object(((long) 0), "AST_VAR");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_var()
{
   {
      obj_t cnst_port_138_1406;
      cnst_port_138_1406 = open_input_string(string1797_ast_var);
      {
	 long i_1407;
	 i_1407 = ((long) 10);
       loop_1408:
	 {
	    bool_t test1798_1409;
	    test1798_1409 = (i_1407 == ((long) -1));
	    if (test1798_1409)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1799_1410;
		    {
		       obj_t list1800_1411;
		       {
			  obj_t arg1801_1412;
			  arg1801_1412 = BNIL;
			  list1800_1411 = MAKE_PAIR(cnst_port_138_1406, arg1801_1412);
		       }
		       arg1799_1410 = read___reader(list1800_1411);
		    }
		    CNST_TABLE_SET(i_1407, arg1799_1410);
		 }
		 {
		    int aux_1413;
		    {
		       long aux_1432;
		       aux_1432 = (i_1407 - ((long) 1));
		       aux_1413 = (int) (aux_1432);
		    }
		    {
		       long i_1435;
		       i_1435 = (long) (aux_1413);
		       i_1407 = i_1435;
		       goto loop_1408;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_var()
{
   return BUNSPEC;
}


obj_t 
object_init_111_ast_var()
{
   {
      obj_t arg1414_313;
      arg1414_313 = object___object;
      value_ast_var = add_class__117___object(CNST_TABLE_REF(((long) 0)), arg1414_313, allocate_value_env_188_ast_var, ((long) 15873), BUNSPEC);
   }
   {
      obj_t arg1418_317;
      arg1418_317 = object___object;
      variable_ast_var = add_class__117___object(CNST_TABLE_REF(((long) 1)), arg1418_317, allocate_variable_env_212_ast_var, ((long) 16026), BUNSPEC);
   }
   {
      obj_t arg1426_321;
      arg1426_321 = variable_ast_var;
      global_ast_var = add_class__117___object(CNST_TABLE_REF(((long) 2)), arg1426_321, allocate_global_env_97_ast_var, ((long) 18552), BUNSPEC);
   }
   {
      obj_t arg1432_325;
      arg1432_325 = variable_ast_var;
      local_ast_var = add_class__117___object(CNST_TABLE_REF(((long) 3)), arg1432_325, allocate_local_env_7_ast_var, ((long) 62149), BUNSPEC);
   }
   {
      obj_t arg1445_329;
      arg1445_329 = value_ast_var;
      fun_ast_var = add_class__117___object(CNST_TABLE_REF(((long) 4)), arg1445_329, allocate_fun_env_191_ast_var, ((long) 55079), BUNSPEC);
   }
   {
      obj_t arg1449_333;
      arg1449_333 = fun_ast_var;
      sfun_ast_var = add_class__117___object(CNST_TABLE_REF(((long) 5)), arg1449_333, allocate_sfun_env_18_ast_var, ((long) 48042), BUNSPEC);
   }
   {
      obj_t arg1454_337;
      arg1454_337 = fun_ast_var;
      cfun_ast_var = add_class__117___object(CNST_TABLE_REF(((long) 6)), arg1454_337, allocate_cfun_env_241_ast_var, ((long) 16357), BUNSPEC);
   }
   {
      obj_t arg1463_341;
      arg1463_341 = value_ast_var;
      svar_ast_var = add_class__117___object(CNST_TABLE_REF(((long) 7)), arg1463_341, allocate_svar_env_12_ast_var, ((long) 17795), BUNSPEC);
   }
   {
      obj_t arg1468_345;
      arg1468_345 = value_ast_var;
      scnst_ast_var = add_class__117___object(CNST_TABLE_REF(((long) 8)), arg1468_345, allocate_scnst_env_226_ast_var, ((long) 7373), BUNSPEC);
   }
   {
      obj_t arg1474_349;
      arg1474_349 = value_ast_var;
      cvar_ast_var = add_class__117___object(CNST_TABLE_REF(((long) 9)), arg1474_349, allocate_cvar_env_85_ast_var, ((long) 30605), BUNSPEC);
   }
   {
      obj_t arg1480_353;
      arg1480_353 = value_ast_var;
      sexit_ast_var = add_class__117___object(CNST_TABLE_REF(((long) 10)), arg1480_353, allocate_sexit_env_61_ast_var, ((long) 44867), BUNSPEC);
   }
   {
      obj_t object__struct_sexit_213_1334;
      object__struct_sexit_213_1334 = proc1775_ast_var;
      add_method__1___object(object__struct_env_210___object, sexit_ast_var, object__struct_sexit_213_1334);
   }
   {
      obj_t struct_object__object_sexit_101_1333;
      struct_object__object_sexit_101_1333 = proc1776_ast_var;
      add_method__1___object(struct_object__object_env_209___object, sexit_ast_var, struct_object__object_sexit_101_1333);
   }
   {
      obj_t object__struct_cvar_12_1332;
      object__struct_cvar_12_1332 = proc1777_ast_var;
      add_method__1___object(object__struct_env_210___object, cvar_ast_var, object__struct_cvar_12_1332);
   }
   {
      obj_t struct_object__object_cvar_183_1331;
      struct_object__object_cvar_183_1331 = proc1778_ast_var;
      add_method__1___object(struct_object__object_env_209___object, cvar_ast_var, struct_object__object_cvar_183_1331);
   }
   {
      obj_t object__struct_scnst_111_1330;
      object__struct_scnst_111_1330 = proc1779_ast_var;
      add_method__1___object(object__struct_env_210___object, scnst_ast_var, object__struct_scnst_111_1330);
   }
   {
      obj_t struct_object__object_scnst_43_1329;
      struct_object__object_scnst_43_1329 = proc1780_ast_var;
      add_method__1___object(struct_object__object_env_209___object, scnst_ast_var, struct_object__object_scnst_43_1329);
   }
   {
      obj_t object__struct_svar_233_1328;
      object__struct_svar_233_1328 = proc1781_ast_var;
      add_method__1___object(object__struct_env_210___object, svar_ast_var, object__struct_svar_233_1328);
   }
   {
      obj_t struct_object__object_svar_1_1327;
      struct_object__object_svar_1_1327 = proc1782_ast_var;
      add_method__1___object(struct_object__object_env_209___object, svar_ast_var, struct_object__object_svar_1_1327);
   }
   {
      obj_t object__struct_cfun_117_1326;
      object__struct_cfun_117_1326 = proc1783_ast_var;
      add_method__1___object(object__struct_env_210___object, cfun_ast_var, object__struct_cfun_117_1326);
   }
   {
      obj_t struct_object__object_cfun_108_1325;
      struct_object__object_cfun_108_1325 = proc1784_ast_var;
      add_method__1___object(struct_object__object_env_209___object, cfun_ast_var, struct_object__object_cfun_108_1325);
   }
   {
      obj_t object__struct_sfun_209_1324;
      object__struct_sfun_209_1324 = proc1785_ast_var;
      add_method__1___object(object__struct_env_210___object, sfun_ast_var, object__struct_sfun_209_1324);
   }
   {
      obj_t struct_object__object_sfun_10_1323;
      struct_object__object_sfun_10_1323 = proc1786_ast_var;
      add_method__1___object(struct_object__object_env_209___object, sfun_ast_var, struct_object__object_sfun_10_1323);
   }
   {
      obj_t object__struct_fun_194_1322;
      object__struct_fun_194_1322 = proc1787_ast_var;
      add_method__1___object(object__struct_env_210___object, fun_ast_var, object__struct_fun_194_1322);
   }
   {
      obj_t struct_object__object_fun_34_1321;
      struct_object__object_fun_34_1321 = proc1788_ast_var;
      add_method__1___object(struct_object__object_env_209___object, fun_ast_var, struct_object__object_fun_34_1321);
   }
   {
      obj_t object__struct_local_56_1320;
      object__struct_local_56_1320 = proc1789_ast_var;
      add_method__1___object(object__struct_env_210___object, local_ast_var, object__struct_local_56_1320);
   }
   {
      obj_t struct_object__object_local_234_1319;
      struct_object__object_local_234_1319 = proc1790_ast_var;
      add_method__1___object(struct_object__object_env_209___object, local_ast_var, struct_object__object_local_234_1319);
   }
   {
      obj_t object__struct_global_193_1318;
      object__struct_global_193_1318 = proc1791_ast_var;
      add_method__1___object(object__struct_env_210___object, global_ast_var, object__struct_global_193_1318);
   }
   {
      obj_t struct_object__object_global_249_1317;
      struct_object__object_global_249_1317 = proc1792_ast_var;
      add_method__1___object(struct_object__object_env_209___object, global_ast_var, struct_object__object_global_249_1317);
   }
   {
      obj_t object__struct_variable_84_1316;
      object__struct_variable_84_1316 = proc1793_ast_var;
      add_method__1___object(object__struct_env_210___object, variable_ast_var, object__struct_variable_84_1316);
   }
   {
      obj_t struct_object__object_variable_106_1315;
      struct_object__object_variable_106_1315 = proc1794_ast_var;
      add_method__1___object(struct_object__object_env_209___object, variable_ast_var, struct_object__object_variable_106_1315);
   }
   {
      obj_t object__struct_value_130_1314;
      object__struct_value_130_1314 = proc1795_ast_var;
      add_method__1___object(object__struct_env_210___object, value_ast_var, object__struct_value_130_1314);
   }
   {
      obj_t struct_object__object_value_20_1313;
      struct_object__object_value_20_1313 = proc1796_ast_var;
      return add_method__1___object(struct_object__object_env_209___object, value_ast_var, struct_object__object_value_20_1313);
   }
}


obj_t 
struct_object__object_value1750_104_ast_var(obj_t env_1335, obj_t o_1336, obj_t s_1337)
{
   {
      value_t o_700;
      obj_t s_701;
      {
	 value_t aux_1481;
	 o_700 = (value_t) (o_1336);
	 s_701 = s_1337;
	 {
	    obj_t aux_1484;
	    object_t aux_1482;
	    aux_1484 = STRUCT_REF(s_701, ((long) 0));
	    aux_1482 = (object_t) (o_700);
	    OBJECT_WIDENING_SET(aux_1482, aux_1484);
	 }
	 aux_1481 = o_700;
	 return (obj_t) (aux_1481);
      }
   }
}


obj_t 
object__struct_value1751_95_ast_var(obj_t env_1338, obj_t obj1022_1339)
{
   {
      value_t obj1022_692;
      obj1022_692 = (value_t) (obj1022_1339);
      {
	 obj_t res1023_695;
	 {
	    obj_t aux_1489;
	    aux_1489 = CNST_TABLE_REF(((long) 0));
	    res1023_695 = make_struct(aux_1489, ((long) 1), BUNSPEC);
	 }
	 STRUCT_SET(res1023_695, ((long) 0), BFALSE);
	 return res1023_695;
      }
   }
}


obj_t 
struct_object__object_variable1752_45_ast_var(obj_t env_1340, obj_t o_1341, obj_t s_1342)
{
   {
      variable_t o_677;
      obj_t s_678;
      {
	 variable_t aux_1494;
	 o_677 = (variable_t) (o_1341);
	 s_678 = s_1342;
	 {
	    obj_t aux_1497;
	    object_t aux_1495;
	    aux_1497 = STRUCT_REF(s_678, ((long) 0));
	    aux_1495 = (object_t) (o_677);
	    OBJECT_WIDENING_SET(aux_1495, aux_1497);
	 }
	 {
	    obj_t v1039_682;
	    v1039_682 = STRUCT_REF(s_678, ((long) 1));
	    ((((variable_t) CREF(o_677))->id) = ((obj_t) v1039_682), BUNSPEC);
	 }
	 {
	    obj_t v1043_683;
	    v1043_683 = STRUCT_REF(s_678, ((long) 2));
	    ((((variable_t) CREF(o_677))->name) = ((obj_t) v1043_683), BUNSPEC);
	 }
	 {
	    type_t v1047_684;
	    {
	       obj_t aux_1504;
	       aux_1504 = STRUCT_REF(s_678, ((long) 3));
	       v1047_684 = (type_t) (aux_1504);
	    }
	    ((((variable_t) CREF(o_677))->type) = ((type_t) v1047_684), BUNSPEC);
	 }
	 {
	    value_t v1051_685;
	    {
	       obj_t aux_1508;
	       aux_1508 = STRUCT_REF(s_678, ((long) 4));
	       v1051_685 = (value_t) (aux_1508);
	    }
	    ((((variable_t) CREF(o_677))->value) = ((value_t) v1051_685), BUNSPEC);
	 }
	 {
	    obj_t v1055_686;
	    v1055_686 = STRUCT_REF(s_678, ((long) 5));
	    ((((variable_t) CREF(o_677))->access) = ((obj_t) v1055_686), BUNSPEC);
	 }
	 {
	    obj_t v1059_687;
	    v1059_687 = STRUCT_REF(s_678, ((long) 6));
	    ((((variable_t) CREF(o_677))->fast_alpha_7) = ((obj_t) v1059_687), BUNSPEC);
	 }
	 {
	    obj_t v1063_688;
	    v1063_688 = STRUCT_REF(s_678, ((long) 7));
	    ((((variable_t) CREF(o_677))->removable) = ((obj_t) v1063_688), BUNSPEC);
	 }
	 {
	    long v1067_689;
	    {
	       obj_t aux_1518;
	       aux_1518 = STRUCT_REF(s_678, ((long) 8));
	       v1067_689 = (long) CINT(aux_1518);
	    }
	    ((((variable_t) CREF(o_677))->occurrence) = ((long) v1067_689), BUNSPEC);
	 }
	 aux_1494 = o_677;
	 return (obj_t) (aux_1494);
      }
   }
}


obj_t 
object__struct_variable1753_249_ast_var(obj_t env_1343, obj_t obj1035_1344)
{
   {
      variable_t obj1035_653;
      obj1035_653 = (variable_t) (obj1035_1344);
      {
	 obj_t res1036_656;
	 {
	    obj_t aux_1524;
	    aux_1524 = CNST_TABLE_REF(((long) 1));
	    res1036_656 = make_struct(aux_1524, ((long) 9), BUNSPEC);
	 }
	 STRUCT_SET(res1036_656, ((long) 0), BFALSE);
	 {
	    obj_t aux_1528;
	    aux_1528 = (((variable_t) CREF(obj1035_653))->id);
	    STRUCT_SET(res1036_656, ((long) 1), aux_1528);
	 }
	 {
	    obj_t aux_1531;
	    aux_1531 = (((variable_t) CREF(obj1035_653))->name);
	    STRUCT_SET(res1036_656, ((long) 2), aux_1531);
	 }
	 {
	    obj_t aux_1534;
	    {
	       type_t aux_1535;
	       aux_1535 = (((variable_t) CREF(obj1035_653))->type);
	       aux_1534 = (obj_t) (aux_1535);
	    }
	    STRUCT_SET(res1036_656, ((long) 3), aux_1534);
	 }
	 {
	    obj_t aux_1539;
	    {
	       value_t aux_1540;
	       aux_1540 = (((variable_t) CREF(obj1035_653))->value);
	       aux_1539 = (obj_t) (aux_1540);
	    }
	    STRUCT_SET(res1036_656, ((long) 4), aux_1539);
	 }
	 {
	    obj_t aux_1544;
	    aux_1544 = (((variable_t) CREF(obj1035_653))->access);
	    STRUCT_SET(res1036_656, ((long) 5), aux_1544);
	 }
	 {
	    obj_t aux_1547;
	    aux_1547 = (((variable_t) CREF(obj1035_653))->fast_alpha_7);
	    STRUCT_SET(res1036_656, ((long) 6), aux_1547);
	 }
	 {
	    obj_t aux_1550;
	    aux_1550 = (((variable_t) CREF(obj1035_653))->removable);
	    STRUCT_SET(res1036_656, ((long) 7), aux_1550);
	 }
	 {
	    obj_t aux_1553;
	    {
	       long aux_1554;
	       aux_1554 = (((variable_t) CREF(obj1035_653))->occurrence);
	       aux_1553 = BINT(aux_1554);
	    }
	    STRUCT_SET(res1036_656, ((long) 8), aux_1553);
	 }
	 return res1036_656;
      }
   }
}


obj_t 
struct_object__object_global1754_72_ast_var(obj_t env_1345, obj_t o_1346, obj_t s_1347)
{
   {
      global_t o_632;
      obj_t s_633;
      {
	 global_t aux_1559;
	 o_632 = (global_t) (o_1346);
	 s_633 = s_1347;
	 {
	    obj_t aux_1562;
	    object_t aux_1560;
	    aux_1562 = STRUCT_REF(s_633, ((long) 0));
	    aux_1560 = (object_t) (o_632);
	    OBJECT_WIDENING_SET(aux_1560, aux_1562);
	 }
	 {
	    obj_t v1087_637;
	    v1087_637 = STRUCT_REF(s_633, ((long) 1));
	    ((((global_t) CREF(o_632))->id) = ((obj_t) v1087_637), BUNSPEC);
	 }
	 {
	    obj_t v1091_638;
	    v1091_638 = STRUCT_REF(s_633, ((long) 2));
	    ((((global_t) CREF(o_632))->name) = ((obj_t) v1091_638), BUNSPEC);
	 }
	 {
	    type_t v1095_639;
	    {
	       obj_t aux_1569;
	       aux_1569 = STRUCT_REF(s_633, ((long) 3));
	       v1095_639 = (type_t) (aux_1569);
	    }
	    ((((global_t) CREF(o_632))->type) = ((type_t) v1095_639), BUNSPEC);
	 }
	 {
	    value_t v1099_640;
	    {
	       obj_t aux_1573;
	       aux_1573 = STRUCT_REF(s_633, ((long) 4));
	       v1099_640 = (value_t) (aux_1573);
	    }
	    ((((global_t) CREF(o_632))->value) = ((value_t) v1099_640), BUNSPEC);
	 }
	 {
	    obj_t v1103_641;
	    v1103_641 = STRUCT_REF(s_633, ((long) 5));
	    ((((global_t) CREF(o_632))->access) = ((obj_t) v1103_641), BUNSPEC);
	 }
	 {
	    obj_t v1107_642;
	    v1107_642 = STRUCT_REF(s_633, ((long) 6));
	    ((((global_t) CREF(o_632))->fast_alpha_7) = ((obj_t) v1107_642), BUNSPEC);
	 }
	 {
	    obj_t v1111_643;
	    v1111_643 = STRUCT_REF(s_633, ((long) 7));
	    ((((global_t) CREF(o_632))->removable) = ((obj_t) v1111_643), BUNSPEC);
	 }
	 {
	    long v1115_644;
	    {
	       obj_t aux_1583;
	       aux_1583 = STRUCT_REF(s_633, ((long) 8));
	       v1115_644 = (long) CINT(aux_1583);
	    }
	    ((((global_t) CREF(o_632))->occurrence) = ((long) v1115_644), BUNSPEC);
	 }
	 {
	    obj_t v1119_645;
	    v1119_645 = STRUCT_REF(s_633, ((long) 9));
	    ((((global_t) CREF(o_632))->module) = ((obj_t) v1119_645), BUNSPEC);
	 }
	 {
	    obj_t v1123_646;
	    v1123_646 = STRUCT_REF(s_633, ((long) 10));
	    ((((global_t) CREF(o_632))->import) = ((obj_t) v1123_646), BUNSPEC);
	 }
	 {
	    bool_t v1127_647;
	    {
	       obj_t aux_1591;
	       aux_1591 = STRUCT_REF(s_633, ((long) 11));
	       v1127_647 = CBOOL(aux_1591);
	    }
	    ((((global_t) CREF(o_632))->evaluable__248) = ((bool_t) v1127_647), BUNSPEC);
	 }
	 {
	    bool_t v1131_648;
	    {
	       obj_t aux_1595;
	       aux_1595 = STRUCT_REF(s_633, ((long) 12));
	       v1131_648 = CBOOL(aux_1595);
	    }
	    ((((global_t) CREF(o_632))->library__255) = ((bool_t) v1131_648), BUNSPEC);
	 }
	 {
	    obj_t v1135_649;
	    v1135_649 = STRUCT_REF(s_633, ((long) 13));
	    ((((global_t) CREF(o_632))->pragma) = ((obj_t) v1135_649), BUNSPEC);
	 }
	 {
	    obj_t v1139_650;
	    v1139_650 = STRUCT_REF(s_633, ((long) 14));
	    ((((global_t) CREF(o_632))->src) = ((obj_t) v1139_650), BUNSPEC);
	 }
	 aux_1559 = o_632;
	 return (obj_t) (aux_1559);
      }
   }
}


obj_t 
object__struct_global1755_167_ast_var(obj_t env_1348, obj_t obj1083_1349)
{
   {
      global_t obj1083_596;
      obj1083_596 = (global_t) (obj1083_1349);
      {
	 obj_t res1084_599;
	 {
	    obj_t aux_1605;
	    aux_1605 = CNST_TABLE_REF(((long) 2));
	    res1084_599 = make_struct(aux_1605, ((long) 15), BUNSPEC);
	 }
	 STRUCT_SET(res1084_599, ((long) 0), BFALSE);
	 {
	    obj_t aux_1609;
	    aux_1609 = (((global_t) CREF(obj1083_596))->id);
	    STRUCT_SET(res1084_599, ((long) 1), aux_1609);
	 }
	 {
	    obj_t aux_1612;
	    aux_1612 = (((global_t) CREF(obj1083_596))->name);
	    STRUCT_SET(res1084_599, ((long) 2), aux_1612);
	 }
	 {
	    obj_t aux_1615;
	    {
	       type_t aux_1616;
	       aux_1616 = (((global_t) CREF(obj1083_596))->type);
	       aux_1615 = (obj_t) (aux_1616);
	    }
	    STRUCT_SET(res1084_599, ((long) 3), aux_1615);
	 }
	 {
	    obj_t aux_1620;
	    {
	       value_t aux_1621;
	       aux_1621 = (((global_t) CREF(obj1083_596))->value);
	       aux_1620 = (obj_t) (aux_1621);
	    }
	    STRUCT_SET(res1084_599, ((long) 4), aux_1620);
	 }
	 {
	    obj_t aux_1625;
	    aux_1625 = (((global_t) CREF(obj1083_596))->access);
	    STRUCT_SET(res1084_599, ((long) 5), aux_1625);
	 }
	 {
	    obj_t aux_1628;
	    aux_1628 = (((global_t) CREF(obj1083_596))->fast_alpha_7);
	    STRUCT_SET(res1084_599, ((long) 6), aux_1628);
	 }
	 {
	    obj_t aux_1631;
	    aux_1631 = (((global_t) CREF(obj1083_596))->removable);
	    STRUCT_SET(res1084_599, ((long) 7), aux_1631);
	 }
	 {
	    obj_t aux_1634;
	    {
	       long aux_1635;
	       aux_1635 = (((global_t) CREF(obj1083_596))->occurrence);
	       aux_1634 = BINT(aux_1635);
	    }
	    STRUCT_SET(res1084_599, ((long) 8), aux_1634);
	 }
	 {
	    obj_t aux_1639;
	    aux_1639 = (((global_t) CREF(obj1083_596))->module);
	    STRUCT_SET(res1084_599, ((long) 9), aux_1639);
	 }
	 {
	    obj_t aux_1642;
	    aux_1642 = (((global_t) CREF(obj1083_596))->import);
	    STRUCT_SET(res1084_599, ((long) 10), aux_1642);
	 }
	 {
	    obj_t aux_1645;
	    {
	       bool_t aux_1646;
	       aux_1646 = (((global_t) CREF(obj1083_596))->evaluable__248);
	       aux_1645 = BBOOL(aux_1646);
	    }
	    STRUCT_SET(res1084_599, ((long) 11), aux_1645);
	 }
	 {
	    obj_t aux_1650;
	    {
	       bool_t aux_1651;
	       aux_1651 = (((global_t) CREF(obj1083_596))->library__255);
	       aux_1650 = BBOOL(aux_1651);
	    }
	    STRUCT_SET(res1084_599, ((long) 12), aux_1650);
	 }
	 {
	    obj_t aux_1655;
	    aux_1655 = (((global_t) CREF(obj1083_596))->pragma);
	    STRUCT_SET(res1084_599, ((long) 13), aux_1655);
	 }
	 {
	    obj_t aux_1658;
	    aux_1658 = (((global_t) CREF(obj1083_596))->src);
	    STRUCT_SET(res1084_599, ((long) 14), aux_1658);
	 }
	 return res1084_599;
      }
   }
}


obj_t 
struct_object__object_local1756_181_ast_var(obj_t env_1350, obj_t o_1351, obj_t s_1352)
{
   {
      local_t o_580;
      obj_t s_581;
      {
	 local_t aux_1662;
	 o_580 = (local_t) (o_1351);
	 s_581 = s_1352;
	 {
	    obj_t aux_1665;
	    object_t aux_1663;
	    aux_1665 = STRUCT_REF(s_581, ((long) 0));
	    aux_1663 = (object_t) (o_580);
	    OBJECT_WIDENING_SET(aux_1663, aux_1665);
	 }
	 {
	    obj_t v1156_585;
	    v1156_585 = STRUCT_REF(s_581, ((long) 1));
	    ((((local_t) CREF(o_580))->id) = ((obj_t) v1156_585), BUNSPEC);
	 }
	 {
	    obj_t v1160_586;
	    v1160_586 = STRUCT_REF(s_581, ((long) 2));
	    ((((local_t) CREF(o_580))->name) = ((obj_t) v1160_586), BUNSPEC);
	 }
	 {
	    type_t v1164_587;
	    {
	       obj_t aux_1672;
	       aux_1672 = STRUCT_REF(s_581, ((long) 3));
	       v1164_587 = (type_t) (aux_1672);
	    }
	    ((((local_t) CREF(o_580))->type) = ((type_t) v1164_587), BUNSPEC);
	 }
	 {
	    value_t v1168_588;
	    {
	       obj_t aux_1676;
	       aux_1676 = STRUCT_REF(s_581, ((long) 4));
	       v1168_588 = (value_t) (aux_1676);
	    }
	    ((((local_t) CREF(o_580))->value) = ((value_t) v1168_588), BUNSPEC);
	 }
	 {
	    obj_t v1172_589;
	    v1172_589 = STRUCT_REF(s_581, ((long) 5));
	    ((((local_t) CREF(o_580))->access) = ((obj_t) v1172_589), BUNSPEC);
	 }
	 {
	    obj_t v1176_590;
	    v1176_590 = STRUCT_REF(s_581, ((long) 6));
	    ((((local_t) CREF(o_580))->fast_alpha_7) = ((obj_t) v1176_590), BUNSPEC);
	 }
	 {
	    obj_t v1180_591;
	    v1180_591 = STRUCT_REF(s_581, ((long) 7));
	    ((((local_t) CREF(o_580))->removable) = ((obj_t) v1180_591), BUNSPEC);
	 }
	 {
	    long v1184_592;
	    {
	       obj_t aux_1686;
	       aux_1686 = STRUCT_REF(s_581, ((long) 8));
	       v1184_592 = (long) CINT(aux_1686);
	    }
	    ((((local_t) CREF(o_580))->occurrence) = ((long) v1184_592), BUNSPEC);
	 }
	 {
	    long v1188_593;
	    {
	       obj_t aux_1690;
	       aux_1690 = STRUCT_REF(s_581, ((long) 9));
	       v1188_593 = (long) CINT(aux_1690);
	    }
	    ((((local_t) CREF(o_580))->key) = ((long) v1188_593), BUNSPEC);
	 }
	 aux_1662 = o_580;
	 return (obj_t) (aux_1662);
      }
   }
}


obj_t 
object__struct_local1757_54_ast_var(obj_t env_1353, obj_t obj1152_1354)
{
   {
      local_t obj1152_554;
      obj1152_554 = (local_t) (obj1152_1354);
      {
	 obj_t res1153_557;
	 {
	    obj_t aux_1696;
	    aux_1696 = CNST_TABLE_REF(((long) 3));
	    res1153_557 = make_struct(aux_1696, ((long) 10), BUNSPEC);
	 }
	 STRUCT_SET(res1153_557, ((long) 0), BFALSE);
	 {
	    obj_t aux_1700;
	    aux_1700 = (((local_t) CREF(obj1152_554))->id);
	    STRUCT_SET(res1153_557, ((long) 1), aux_1700);
	 }
	 {
	    obj_t aux_1703;
	    aux_1703 = (((local_t) CREF(obj1152_554))->name);
	    STRUCT_SET(res1153_557, ((long) 2), aux_1703);
	 }
	 {
	    obj_t aux_1706;
	    {
	       type_t aux_1707;
	       aux_1707 = (((local_t) CREF(obj1152_554))->type);
	       aux_1706 = (obj_t) (aux_1707);
	    }
	    STRUCT_SET(res1153_557, ((long) 3), aux_1706);
	 }
	 {
	    obj_t aux_1711;
	    {
	       value_t aux_1712;
	       aux_1712 = (((local_t) CREF(obj1152_554))->value);
	       aux_1711 = (obj_t) (aux_1712);
	    }
	    STRUCT_SET(res1153_557, ((long) 4), aux_1711);
	 }
	 {
	    obj_t aux_1716;
	    aux_1716 = (((local_t) CREF(obj1152_554))->access);
	    STRUCT_SET(res1153_557, ((long) 5), aux_1716);
	 }
	 {
	    obj_t aux_1719;
	    aux_1719 = (((local_t) CREF(obj1152_554))->fast_alpha_7);
	    STRUCT_SET(res1153_557, ((long) 6), aux_1719);
	 }
	 {
	    obj_t aux_1722;
	    aux_1722 = (((local_t) CREF(obj1152_554))->removable);
	    STRUCT_SET(res1153_557, ((long) 7), aux_1722);
	 }
	 {
	    obj_t aux_1725;
	    {
	       long aux_1726;
	       aux_1726 = (((local_t) CREF(obj1152_554))->occurrence);
	       aux_1725 = BINT(aux_1726);
	    }
	    STRUCT_SET(res1153_557, ((long) 8), aux_1725);
	 }
	 {
	    obj_t aux_1730;
	    {
	       long aux_1731;
	       aux_1731 = (((local_t) CREF(obj1152_554))->key);
	       aux_1730 = BINT(aux_1731);
	    }
	    STRUCT_SET(res1153_557, ((long) 9), aux_1730);
	 }
	 return res1153_557;
      }
   }
}


obj_t 
struct_object__object_fun1758_255_ast_var(obj_t env_1355, obj_t o_1356, obj_t s_1357)
{
   {
      fun_t o_541;
      obj_t s_542;
      {
	 fun_t aux_1736;
	 o_541 = (fun_t) (o_1356);
	 s_542 = s_1357;
	 {
	    obj_t aux_1739;
	    object_t aux_1737;
	    aux_1739 = STRUCT_REF(s_542, ((long) 0));
	    aux_1737 = (object_t) (o_541);
	    OBJECT_WIDENING_SET(aux_1737, aux_1739);
	 }
	 {
	    long v1203_546;
	    {
	       obj_t aux_1742;
	       aux_1742 = STRUCT_REF(s_542, ((long) 1));
	       v1203_546 = (long) CINT(aux_1742);
	    }
	    ((((fun_t) CREF(o_541))->arity) = ((long) v1203_546), BUNSPEC);
	 }
	 {
	    obj_t v1207_547;
	    v1207_547 = STRUCT_REF(s_542, ((long) 2));
	    ((((fun_t) CREF(o_541))->side_effect__165) = ((obj_t) v1207_547), BUNSPEC);
	 }
	 {
	    obj_t v1211_548;
	    v1211_548 = STRUCT_REF(s_542, ((long) 3));
	    ((((fun_t) CREF(o_541))->predicate_of_78) = ((obj_t) v1211_548), BUNSPEC);
	 }
	 {
	    obj_t v1215_549;
	    v1215_549 = STRUCT_REF(s_542, ((long) 4));
	    ((((fun_t) CREF(o_541))->stack_allocator_172) = ((obj_t) v1215_549), BUNSPEC);
	 }
	 {
	    bool_t v1219_550;
	    {
	       obj_t aux_1752;
	       aux_1752 = STRUCT_REF(s_542, ((long) 5));
	       v1219_550 = CBOOL(aux_1752);
	    }
	    ((((fun_t) CREF(o_541))->top__138) = ((bool_t) v1219_550), BUNSPEC);
	 }
	 {
	    obj_t v1223_551;
	    v1223_551 = STRUCT_REF(s_542, ((long) 6));
	    ((((fun_t) CREF(o_541))->the_closure_238) = ((obj_t) v1223_551), BUNSPEC);
	 }
	 aux_1736 = o_541;
	 return (obj_t) (aux_1736);
      }
   }
}


obj_t 
object__struct_fun1759_24_ast_var(obj_t env_1358, obj_t obj1199_1359)
{
   {
      fun_t obj1199_521;
      obj1199_521 = (fun_t) (obj1199_1359);
      {
	 obj_t res1200_524;
	 {
	    obj_t aux_1760;
	    aux_1760 = CNST_TABLE_REF(((long) 4));
	    res1200_524 = make_struct(aux_1760, ((long) 7), BUNSPEC);
	 }
	 STRUCT_SET(res1200_524, ((long) 0), BFALSE);
	 {
	    obj_t aux_1764;
	    {
	       long aux_1765;
	       aux_1765 = (((fun_t) CREF(obj1199_521))->arity);
	       aux_1764 = BINT(aux_1765);
	    }
	    STRUCT_SET(res1200_524, ((long) 1), aux_1764);
	 }
	 {
	    obj_t aux_1769;
	    aux_1769 = (((fun_t) CREF(obj1199_521))->side_effect__165);
	    STRUCT_SET(res1200_524, ((long) 2), aux_1769);
	 }
	 {
	    obj_t aux_1772;
	    aux_1772 = (((fun_t) CREF(obj1199_521))->predicate_of_78);
	    STRUCT_SET(res1200_524, ((long) 3), aux_1772);
	 }
	 {
	    obj_t aux_1775;
	    aux_1775 = (((fun_t) CREF(obj1199_521))->stack_allocator_172);
	    STRUCT_SET(res1200_524, ((long) 4), aux_1775);
	 }
	 {
	    obj_t aux_1778;
	    {
	       bool_t aux_1779;
	       aux_1779 = (((fun_t) CREF(obj1199_521))->top__138);
	       aux_1778 = BBOOL(aux_1779);
	    }
	    STRUCT_SET(res1200_524, ((long) 5), aux_1778);
	 }
	 {
	    obj_t aux_1783;
	    aux_1783 = (((fun_t) CREF(obj1199_521))->the_closure_238);
	    STRUCT_SET(res1200_524, ((long) 6), aux_1783);
	 }
	 return res1200_524;
      }
   }
}


obj_t 
struct_object__object_sfun1760_141_ast_var(obj_t env_1360, obj_t o_1361, obj_t s_1362)
{
   {
      sfun_t o_503;
      obj_t s_504;
      {
	 sfun_t aux_1787;
	 o_503 = (sfun_t) (o_1361);
	 s_504 = s_1362;
	 {
	    obj_t aux_1790;
	    object_t aux_1788;
	    aux_1790 = STRUCT_REF(s_504, ((long) 0));
	    aux_1788 = (object_t) (o_503);
	    OBJECT_WIDENING_SET(aux_1788, aux_1790);
	 }
	 {
	    long v1244_508;
	    {
	       obj_t aux_1793;
	       aux_1793 = STRUCT_REF(s_504, ((long) 1));
	       v1244_508 = (long) CINT(aux_1793);
	    }
	    ((((sfun_t) CREF(o_503))->arity) = ((long) v1244_508), BUNSPEC);
	 }
	 {
	    obj_t v1248_509;
	    v1248_509 = STRUCT_REF(s_504, ((long) 2));
	    ((((sfun_t) CREF(o_503))->side_effect__165) = ((obj_t) v1248_509), BUNSPEC);
	 }
	 {
	    obj_t v1252_510;
	    v1252_510 = STRUCT_REF(s_504, ((long) 3));
	    ((((sfun_t) CREF(o_503))->predicate_of_78) = ((obj_t) v1252_510), BUNSPEC);
	 }
	 {
	    obj_t v1256_511;
	    v1256_511 = STRUCT_REF(s_504, ((long) 4));
	    ((((sfun_t) CREF(o_503))->stack_allocator_172) = ((obj_t) v1256_511), BUNSPEC);
	 }
	 {
	    bool_t v1260_512;
	    {
	       obj_t aux_1803;
	       aux_1803 = STRUCT_REF(s_504, ((long) 5));
	       v1260_512 = CBOOL(aux_1803);
	    }
	    ((((sfun_t) CREF(o_503))->top__138) = ((bool_t) v1260_512), BUNSPEC);
	 }
	 {
	    obj_t v1264_513;
	    v1264_513 = STRUCT_REF(s_504, ((long) 6));
	    ((((sfun_t) CREF(o_503))->the_closure_238) = ((obj_t) v1264_513), BUNSPEC);
	 }
	 {
	    obj_t v1268_514;
	    v1268_514 = STRUCT_REF(s_504, ((long) 7));
	    ((((sfun_t) CREF(o_503))->property) = ((obj_t) v1268_514), BUNSPEC);
	 }
	 {
	    obj_t v1272_515;
	    v1272_515 = STRUCT_REF(s_504, ((long) 8));
	    ((((sfun_t) CREF(o_503))->args) = ((obj_t) v1272_515), BUNSPEC);
	 }
	 {
	    obj_t v1276_516;
	    v1276_516 = STRUCT_REF(s_504, ((long) 9));
	    ((((sfun_t) CREF(o_503))->body) = ((obj_t) v1276_516), BUNSPEC);
	 }
	 {
	    obj_t v1280_517;
	    v1280_517 = STRUCT_REF(s_504, ((long) 10));
	    ((((sfun_t) CREF(o_503))->class) = ((obj_t) v1280_517), BUNSPEC);
	 }
	 {
	    obj_t v1284_518;
	    v1284_518 = STRUCT_REF(s_504, ((long) 11));
	    ((((sfun_t) CREF(o_503))->dsssl_keywords_243) = ((obj_t) v1284_518), BUNSPEC);
	 }
	 aux_1787 = o_503;
	 return (obj_t) (aux_1787);
      }
   }
}


obj_t 
object__struct_sfun1761_29_ast_var(obj_t env_1363, obj_t obj1239_1364)
{
   {
      sfun_t obj1239_473;
      obj1239_473 = (sfun_t) (obj1239_1364);
      {
	 obj_t res1240_476;
	 {
	    obj_t aux_1821;
	    aux_1821 = CNST_TABLE_REF(((long) 5));
	    res1240_476 = make_struct(aux_1821, ((long) 12), BUNSPEC);
	 }
	 STRUCT_SET(res1240_476, ((long) 0), BFALSE);
	 {
	    obj_t aux_1825;
	    {
	       long aux_1826;
	       aux_1826 = (((sfun_t) CREF(obj1239_473))->arity);
	       aux_1825 = BINT(aux_1826);
	    }
	    STRUCT_SET(res1240_476, ((long) 1), aux_1825);
	 }
	 {
	    obj_t aux_1830;
	    aux_1830 = (((sfun_t) CREF(obj1239_473))->side_effect__165);
	    STRUCT_SET(res1240_476, ((long) 2), aux_1830);
	 }
	 {
	    obj_t aux_1833;
	    aux_1833 = (((sfun_t) CREF(obj1239_473))->predicate_of_78);
	    STRUCT_SET(res1240_476, ((long) 3), aux_1833);
	 }
	 {
	    obj_t aux_1836;
	    aux_1836 = (((sfun_t) CREF(obj1239_473))->stack_allocator_172);
	    STRUCT_SET(res1240_476, ((long) 4), aux_1836);
	 }
	 {
	    obj_t aux_1839;
	    {
	       bool_t aux_1840;
	       aux_1840 = (((sfun_t) CREF(obj1239_473))->top__138);
	       aux_1839 = BBOOL(aux_1840);
	    }
	    STRUCT_SET(res1240_476, ((long) 5), aux_1839);
	 }
	 {
	    obj_t aux_1844;
	    aux_1844 = (((sfun_t) CREF(obj1239_473))->the_closure_238);
	    STRUCT_SET(res1240_476, ((long) 6), aux_1844);
	 }
	 {
	    obj_t aux_1847;
	    aux_1847 = (((sfun_t) CREF(obj1239_473))->property);
	    STRUCT_SET(res1240_476, ((long) 7), aux_1847);
	 }
	 {
	    obj_t aux_1850;
	    aux_1850 = (((sfun_t) CREF(obj1239_473))->args);
	    STRUCT_SET(res1240_476, ((long) 8), aux_1850);
	 }
	 {
	    obj_t aux_1853;
	    aux_1853 = (((sfun_t) CREF(obj1239_473))->body);
	    STRUCT_SET(res1240_476, ((long) 9), aux_1853);
	 }
	 {
	    obj_t aux_1856;
	    aux_1856 = (((sfun_t) CREF(obj1239_473))->class);
	    STRUCT_SET(res1240_476, ((long) 10), aux_1856);
	 }
	 {
	    obj_t aux_1859;
	    aux_1859 = (((sfun_t) CREF(obj1239_473))->dsssl_keywords_243);
	    STRUCT_SET(res1240_476, ((long) 11), aux_1859);
	 }
	 return res1240_476;
      }
   }
}


obj_t 
struct_object__object_cfun1762_41_ast_var(obj_t env_1365, obj_t o_1366, obj_t s_1367)
{
   {
      cfun_t o_457;
      obj_t s_458;
      {
	 cfun_t aux_1863;
	 o_457 = (cfun_t) (o_1366);
	 s_458 = s_1367;
	 {
	    obj_t aux_1866;
	    object_t aux_1864;
	    aux_1866 = STRUCT_REF(s_458, ((long) 0));
	    aux_1864 = (object_t) (o_457);
	    OBJECT_WIDENING_SET(aux_1864, aux_1866);
	 }
	 {
	    long v1300_462;
	    {
	       obj_t aux_1869;
	       aux_1869 = STRUCT_REF(s_458, ((long) 1));
	       v1300_462 = (long) CINT(aux_1869);
	    }
	    ((((cfun_t) CREF(o_457))->arity) = ((long) v1300_462), BUNSPEC);
	 }
	 {
	    obj_t v1304_463;
	    v1304_463 = STRUCT_REF(s_458, ((long) 2));
	    ((((cfun_t) CREF(o_457))->side_effect__165) = ((obj_t) v1304_463), BUNSPEC);
	 }
	 {
	    obj_t v1308_464;
	    v1308_464 = STRUCT_REF(s_458, ((long) 3));
	    ((((cfun_t) CREF(o_457))->predicate_of_78) = ((obj_t) v1308_464), BUNSPEC);
	 }
	 {
	    obj_t v1312_465;
	    v1312_465 = STRUCT_REF(s_458, ((long) 4));
	    ((((cfun_t) CREF(o_457))->stack_allocator_172) = ((obj_t) v1312_465), BUNSPEC);
	 }
	 {
	    bool_t v1316_466;
	    {
	       obj_t aux_1879;
	       aux_1879 = STRUCT_REF(s_458, ((long) 5));
	       v1316_466 = CBOOL(aux_1879);
	    }
	    ((((cfun_t) CREF(o_457))->top__138) = ((bool_t) v1316_466), BUNSPEC);
	 }
	 {
	    obj_t v1320_467;
	    v1320_467 = STRUCT_REF(s_458, ((long) 6));
	    ((((cfun_t) CREF(o_457))->the_closure_238) = ((obj_t) v1320_467), BUNSPEC);
	 }
	 {
	    obj_t v1324_468;
	    v1324_468 = STRUCT_REF(s_458, ((long) 7));
	    ((((cfun_t) CREF(o_457))->args_type_205) = ((obj_t) v1324_468), BUNSPEC);
	 }
	 {
	    bool_t v1328_469;
	    {
	       obj_t aux_1887;
	       aux_1887 = STRUCT_REF(s_458, ((long) 8));
	       v1328_469 = CBOOL(aux_1887);
	    }
	    ((((cfun_t) CREF(o_457))->macro__33) = ((bool_t) v1328_469), BUNSPEC);
	 }
	 {
	    bool_t v1332_470;
	    {
	       obj_t aux_1891;
	       aux_1891 = STRUCT_REF(s_458, ((long) 9));
	       v1332_470 = CBOOL(aux_1891);
	    }
	    ((((cfun_t) CREF(o_457))->infix__163) = ((bool_t) v1332_470), BUNSPEC);
	 }
	 aux_1863 = o_457;
	 return (obj_t) (aux_1863);
      }
   }
}


obj_t 
object__struct_cfun1763_72_ast_var(obj_t env_1368, obj_t obj1296_1369)
{
   {
      cfun_t obj1296_431;
      obj1296_431 = (cfun_t) (obj1296_1369);
      {
	 obj_t res1297_434;
	 {
	    obj_t aux_1897;
	    aux_1897 = CNST_TABLE_REF(((long) 6));
	    res1297_434 = make_struct(aux_1897, ((long) 10), BUNSPEC);
	 }
	 STRUCT_SET(res1297_434, ((long) 0), BFALSE);
	 {
	    obj_t aux_1901;
	    {
	       long aux_1902;
	       aux_1902 = (((cfun_t) CREF(obj1296_431))->arity);
	       aux_1901 = BINT(aux_1902);
	    }
	    STRUCT_SET(res1297_434, ((long) 1), aux_1901);
	 }
	 {
	    obj_t aux_1906;
	    aux_1906 = (((cfun_t) CREF(obj1296_431))->side_effect__165);
	    STRUCT_SET(res1297_434, ((long) 2), aux_1906);
	 }
	 {
	    obj_t aux_1909;
	    aux_1909 = (((cfun_t) CREF(obj1296_431))->predicate_of_78);
	    STRUCT_SET(res1297_434, ((long) 3), aux_1909);
	 }
	 {
	    obj_t aux_1912;
	    aux_1912 = (((cfun_t) CREF(obj1296_431))->stack_allocator_172);
	    STRUCT_SET(res1297_434, ((long) 4), aux_1912);
	 }
	 {
	    obj_t aux_1915;
	    {
	       bool_t aux_1916;
	       aux_1916 = (((cfun_t) CREF(obj1296_431))->top__138);
	       aux_1915 = BBOOL(aux_1916);
	    }
	    STRUCT_SET(res1297_434, ((long) 5), aux_1915);
	 }
	 {
	    obj_t aux_1920;
	    aux_1920 = (((cfun_t) CREF(obj1296_431))->the_closure_238);
	    STRUCT_SET(res1297_434, ((long) 6), aux_1920);
	 }
	 {
	    obj_t aux_1923;
	    aux_1923 = (((cfun_t) CREF(obj1296_431))->args_type_205);
	    STRUCT_SET(res1297_434, ((long) 7), aux_1923);
	 }
	 {
	    obj_t aux_1926;
	    {
	       bool_t aux_1927;
	       aux_1927 = (((cfun_t) CREF(obj1296_431))->macro__33);
	       aux_1926 = BBOOL(aux_1927);
	    }
	    STRUCT_SET(res1297_434, ((long) 8), aux_1926);
	 }
	 {
	    obj_t aux_1931;
	    {
	       bool_t aux_1932;
	       aux_1932 = (((cfun_t) CREF(obj1296_431))->infix__163);
	       aux_1931 = BBOOL(aux_1932);
	    }
	    STRUCT_SET(res1297_434, ((long) 9), aux_1931);
	 }
	 return res1297_434;
      }
   }
}


obj_t 
struct_object__object_svar1764_229_ast_var(obj_t env_1370, obj_t o_1371, obj_t s_1372)
{
   {
      svar_t o_424;
      obj_t s_425;
      {
	 svar_t aux_1937;
	 o_424 = (svar_t) (o_1371);
	 s_425 = s_1372;
	 {
	    obj_t aux_1940;
	    object_t aux_1938;
	    aux_1940 = STRUCT_REF(s_425, ((long) 0));
	    aux_1938 = (object_t) (o_424);
	    OBJECT_WIDENING_SET(aux_1938, aux_1940);
	 }
	 aux_1937 = o_424;
	 return (obj_t) (aux_1937);
      }
   }
}


obj_t 
object__struct_svar1765_105_ast_var(obj_t env_1373, obj_t obj1338_1374)
{
   {
      svar_t obj1338_416;
      obj1338_416 = (svar_t) (obj1338_1374);
      {
	 obj_t res1339_419;
	 {
	    obj_t aux_1945;
	    aux_1945 = CNST_TABLE_REF(((long) 7));
	    res1339_419 = make_struct(aux_1945, ((long) 1), BUNSPEC);
	 }
	 STRUCT_SET(res1339_419, ((long) 0), BFALSE);
	 return res1339_419;
      }
   }
}


obj_t 
struct_object__object_scnst1766_40_ast_var(obj_t env_1375, obj_t o_1376, obj_t s_1377)
{
   {
      scnst_t o_407;
      obj_t s_408;
      {
	 scnst_t aux_1950;
	 o_407 = (scnst_t) (o_1376);
	 s_408 = s_1377;
	 {
	    obj_t aux_1953;
	    object_t aux_1951;
	    aux_1953 = STRUCT_REF(s_408, ((long) 0));
	    aux_1951 = (object_t) (o_407);
	    OBJECT_WIDENING_SET(aux_1951, aux_1953);
	 }
	 {
	    obj_t v1349_412;
	    v1349_412 = STRUCT_REF(s_408, ((long) 1));
	    ((((scnst_t) CREF(o_407))->node) = ((obj_t) v1349_412), BUNSPEC);
	 }
	 {
	    obj_t v1353_413;
	    v1353_413 = STRUCT_REF(s_408, ((long) 2));
	    ((((scnst_t) CREF(o_407))->class) = ((obj_t) v1353_413), BUNSPEC);
	 }
	 aux_1950 = o_407;
	 return (obj_t) (aux_1950);
      }
   }
}


obj_t 
object__struct_scnst1767_121_ast_var(obj_t env_1378, obj_t obj1345_1379)
{
   {
      scnst_t obj1345_395;
      obj1345_395 = (scnst_t) (obj1345_1379);
      {
	 obj_t res1346_398;
	 {
	    obj_t aux_1962;
	    aux_1962 = CNST_TABLE_REF(((long) 8));
	    res1346_398 = make_struct(aux_1962, ((long) 3), BUNSPEC);
	 }
	 STRUCT_SET(res1346_398, ((long) 0), BFALSE);
	 {
	    obj_t aux_1966;
	    aux_1966 = (((scnst_t) CREF(obj1345_395))->node);
	    STRUCT_SET(res1346_398, ((long) 1), aux_1966);
	 }
	 {
	    obj_t aux_1969;
	    aux_1969 = (((scnst_t) CREF(obj1345_395))->class);
	    STRUCT_SET(res1346_398, ((long) 2), aux_1969);
	 }
	 return res1346_398;
      }
   }
}


obj_t 
struct_object__object_cvar1768_108_ast_var(obj_t env_1380, obj_t o_1381, obj_t s_1382)
{
   {
      cvar_t o_387;
      obj_t s_388;
      {
	 cvar_t aux_1973;
	 o_387 = (cvar_t) (o_1381);
	 s_388 = s_1382;
	 {
	    obj_t aux_1976;
	    object_t aux_1974;
	    aux_1976 = STRUCT_REF(s_388, ((long) 0));
	    aux_1974 = (object_t) (o_387);
	    OBJECT_WIDENING_SET(aux_1974, aux_1976);
	 }
	 {
	    bool_t v1364_392;
	    {
	       obj_t aux_1979;
	       aux_1979 = STRUCT_REF(s_388, ((long) 1));
	       v1364_392 = CBOOL(aux_1979);
	    }
	    ((((cvar_t) CREF(o_387))->macro__33) = ((bool_t) v1364_392), BUNSPEC);
	 }
	 aux_1973 = o_387;
	 return (obj_t) (aux_1973);
      }
   }
}


obj_t 
object__struct_cvar1769_129_ast_var(obj_t env_1383, obj_t obj1359_1384)
{
   {
      cvar_t obj1359_377;
      obj1359_377 = (cvar_t) (obj1359_1384);
      {
	 obj_t res1360_380;
	 {
	    obj_t aux_1985;
	    aux_1985 = CNST_TABLE_REF(((long) 9));
	    res1360_380 = make_struct(aux_1985, ((long) 2), BUNSPEC);
	 }
	 STRUCT_SET(res1360_380, ((long) 0), BFALSE);
	 {
	    obj_t aux_1989;
	    {
	       bool_t aux_1990;
	       aux_1990 = (((cvar_t) CREF(obj1359_377))->macro__33);
	       aux_1989 = BBOOL(aux_1990);
	    }
	    STRUCT_SET(res1360_380, ((long) 1), aux_1989);
	 }
	 return res1360_380;
      }
   }
}


obj_t 
struct_object__object_sexit1770_154_ast_var(obj_t env_1385, obj_t o_1386, obj_t s_1387)
{
   {
      sexit_t o_368;
      obj_t s_369;
      {
	 sexit_t aux_1995;
	 o_368 = (sexit_t) (o_1386);
	 s_369 = s_1387;
	 {
	    obj_t aux_1998;
	    object_t aux_1996;
	    aux_1998 = STRUCT_REF(s_369, ((long) 0));
	    aux_1996 = (object_t) (o_368);
	    OBJECT_WIDENING_SET(aux_1996, aux_1998);
	 }
	 {
	    obj_t v1376_373;
	    v1376_373 = STRUCT_REF(s_369, ((long) 1));
	    ((((sexit_t) CREF(o_368))->handler) = ((obj_t) v1376_373), BUNSPEC);
	 }
	 {
	    bool_t v1380_374;
	    {
	       obj_t aux_2003;
	       aux_2003 = STRUCT_REF(s_369, ((long) 2));
	       v1380_374 = CBOOL(aux_2003);
	    }
	    ((((sexit_t) CREF(o_368))->detached__120) = ((bool_t) v1380_374), BUNSPEC);
	 }
	 aux_1995 = o_368;
	 return (obj_t) (aux_1995);
      }
   }
}


obj_t 
object__struct_sexit1771_236_ast_var(obj_t env_1388, obj_t obj1372_1389)
{
   {
      sexit_t obj1372_356;
      obj1372_356 = (sexit_t) (obj1372_1389);
      {
	 obj_t res1373_359;
	 {
	    obj_t aux_2009;
	    aux_2009 = CNST_TABLE_REF(((long) 10));
	    res1373_359 = make_struct(aux_2009, ((long) 3), BUNSPEC);
	 }
	 STRUCT_SET(res1373_359, ((long) 0), BFALSE);
	 {
	    obj_t aux_2013;
	    aux_2013 = (((sexit_t) CREF(obj1372_356))->handler);
	    STRUCT_SET(res1373_359, ((long) 1), aux_2013);
	 }
	 {
	    obj_t aux_2016;
	    {
	       bool_t aux_2017;
	       aux_2017 = (((sexit_t) CREF(obj1372_356))->detached__120);
	       aux_2016 = BBOOL(aux_2017);
	    }
	    STRUCT_SET(res1373_359, ((long) 2), aux_2016);
	 }
	 return res1373_359;
      }
   }
}


sexit_t 
allocate_sexit_47_ast_var()
{
   {
      sexit_t new1371_707;
      new1371_707 = ((sexit_t) BREF(GC_MALLOC(sizeof(struct sexit))));
      {
	 long arg1719_708;
	 arg1719_708 = class_num_218___object(sexit_ast_var);
	 {
	    obj_t obj_1291;
	    obj_1291 = (obj_t) (new1371_707);
	    (((obj_t) CREF(obj_1291))->header = MAKE_HEADER(arg1719_708, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2026;
	 aux_2026 = (object_t) (new1371_707);
	 OBJECT_WIDENING_SET(aux_2026, BFALSE);
      }
      return new1371_707;
   }
}


obj_t 
_allocate_sexit_130_ast_var(obj_t env_1400)
{
   {
      sexit_t aux_2029;
      aux_2029 = allocate_sexit_47_ast_var();
      return (obj_t) (aux_2029);
   }
}


cvar_t 
allocate_cvar_254_ast_var()
{
   {
      cvar_t new1358_713;
      new1358_713 = ((cvar_t) BREF(GC_MALLOC(sizeof(struct cvar))));
      {
	 long arg1721_714;
	 arg1721_714 = class_num_218___object(cvar_ast_var);
	 {
	    obj_t obj_1293;
	    obj_1293 = (obj_t) (new1358_713);
	    (((obj_t) CREF(obj_1293))->header = MAKE_HEADER(arg1721_714, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2036;
	 aux_2036 = (object_t) (new1358_713);
	 OBJECT_WIDENING_SET(aux_2036, BFALSE);
      }
      return new1358_713;
   }
}


obj_t 
_allocate_cvar_101_ast_var(obj_t env_1399)
{
   {
      cvar_t aux_2039;
      aux_2039 = allocate_cvar_254_ast_var();
      return (obj_t) (aux_2039);
   }
}


scnst_t 
allocate_scnst_81_ast_var()
{
   {
      scnst_t new1344_718;
      new1344_718 = ((scnst_t) BREF(GC_MALLOC(sizeof(struct scnst))));
      {
	 long arg1724_719;
	 arg1724_719 = class_num_218___object(scnst_ast_var);
	 {
	    obj_t obj_1295;
	    obj_1295 = (obj_t) (new1344_718);
	    (((obj_t) CREF(obj_1295))->header = MAKE_HEADER(arg1724_719, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2046;
	 aux_2046 = (object_t) (new1344_718);
	 OBJECT_WIDENING_SET(aux_2046, BFALSE);
      }
      return new1344_718;
   }
}


obj_t 
_allocate_scnst_4_ast_var(obj_t env_1398)
{
   {
      scnst_t aux_2049;
      aux_2049 = allocate_scnst_81_ast_var();
      return (obj_t) (aux_2049);
   }
}


svar_t 
allocate_svar_218_ast_var()
{
   {
      svar_t new1337_724;
      new1337_724 = ((svar_t) BREF(GC_MALLOC(sizeof(struct svar))));
      {
	 long arg1730_725;
	 arg1730_725 = class_num_218___object(svar_ast_var);
	 {
	    obj_t obj_1297;
	    obj_1297 = (obj_t) (new1337_724);
	    (((obj_t) CREF(obj_1297))->header = MAKE_HEADER(arg1730_725, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2056;
	 aux_2056 = (object_t) (new1337_724);
	 OBJECT_WIDENING_SET(aux_2056, BFALSE);
      }
      return new1337_724;
   }
}


obj_t 
_allocate_svar_73_ast_var(obj_t env_1397)
{
   {
      svar_t aux_2059;
      aux_2059 = allocate_svar_218_ast_var();
      return (obj_t) (aux_2059);
   }
}


cfun_t 
allocate_cfun_23_ast_var()
{
   {
      cfun_t new1295_728;
      new1295_728 = ((cfun_t) BREF(GC_MALLOC(sizeof(struct cfun))));
      {
	 long arg1732_729;
	 arg1732_729 = class_num_218___object(cfun_ast_var);
	 {
	    obj_t obj_1299;
	    obj_1299 = (obj_t) (new1295_728);
	    (((obj_t) CREF(obj_1299))->header = MAKE_HEADER(arg1732_729, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2066;
	 aux_2066 = (object_t) (new1295_728);
	 OBJECT_WIDENING_SET(aux_2066, BFALSE);
      }
      return new1295_728;
   }
}


obj_t 
_allocate_cfun_27_ast_var(obj_t env_1396)
{
   {
      cfun_t aux_2069;
      aux_2069 = allocate_cfun_23_ast_var();
      return (obj_t) (aux_2069);
   }
}


sfun_t 
allocate_sfun_135_ast_var()
{
   {
      sfun_t new1238_741;
      new1238_741 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
      {
	 long arg1734_742;
	 arg1734_742 = class_num_218___object(sfun_ast_var);
	 {
	    obj_t obj_1301;
	    obj_1301 = (obj_t) (new1238_741);
	    (((obj_t) CREF(obj_1301))->header = MAKE_HEADER(arg1734_742, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2076;
	 aux_2076 = (object_t) (new1238_741);
	 OBJECT_WIDENING_SET(aux_2076, BFALSE);
      }
      return new1238_741;
   }
}


obj_t 
_allocate_sfun_141_ast_var(obj_t env_1395)
{
   {
      sfun_t aux_2079;
      aux_2079 = allocate_sfun_135_ast_var();
      return (obj_t) (aux_2079);
   }
}


fun_t 
allocate_fun_149_ast_var()
{
   {
      fun_t new1198_756;
      new1198_756 = ((fun_t) BREF(GC_MALLOC(sizeof(struct fun))));
      {
	 long arg1736_757;
	 arg1736_757 = class_num_218___object(fun_ast_var);
	 {
	    obj_t obj_1303;
	    obj_1303 = (obj_t) (new1198_756);
	    (((obj_t) CREF(obj_1303))->header = MAKE_HEADER(arg1736_757, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2086;
	 aux_2086 = (object_t) (new1198_756);
	 OBJECT_WIDENING_SET(aux_2086, BFALSE);
      }
      return new1198_756;
   }
}


obj_t 
_allocate_fun_230_ast_var(obj_t env_1394)
{
   {
      fun_t aux_2089;
      aux_2089 = allocate_fun_149_ast_var();
      return (obj_t) (aux_2089);
   }
}


local_t 
allocate_local_177_ast_var()
{
   {
      local_t new1151_766;
      new1151_766 = ((local_t) BREF(GC_MALLOC(sizeof(struct local))));
      {
	 long arg1738_767;
	 arg1738_767 = class_num_218___object(local_ast_var);
	 {
	    obj_t obj_1305;
	    obj_1305 = (obj_t) (new1151_766);
	    (((obj_t) CREF(obj_1305))->header = MAKE_HEADER(arg1738_767, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2096;
	 aux_2096 = (object_t) (new1151_766);
	 OBJECT_WIDENING_SET(aux_2096, BFALSE);
      }
      return new1151_766;
   }
}


obj_t 
_allocate_local_35_ast_var(obj_t env_1393)
{
   {
      local_t aux_2099;
      aux_2099 = allocate_local_177_ast_var();
      return (obj_t) (aux_2099);
   }
}


global_t 
allocate_global_222_ast_var()
{
   {
      global_t new1082_779;
      new1082_779 = ((global_t) BREF(GC_MALLOC(sizeof(struct global))));
      {
	 long arg1741_780;
	 arg1741_780 = class_num_218___object(global_ast_var);
	 {
	    obj_t obj_1307;
	    obj_1307 = (obj_t) (new1082_779);
	    (((obj_t) CREF(obj_1307))->header = MAKE_HEADER(arg1741_780, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2106;
	 aux_2106 = (object_t) (new1082_779);
	 OBJECT_WIDENING_SET(aux_2106, BFALSE);
      }
      return new1082_779;
   }
}


obj_t 
_allocate_global_232_ast_var(obj_t env_1392)
{
   {
      global_t aux_2109;
      aux_2109 = allocate_global_222_ast_var();
      return (obj_t) (aux_2109);
   }
}


variable_t 
allocate_variable_244_ast_var()
{
   {
      variable_t new1034_797;
      new1034_797 = ((variable_t) BREF(GC_MALLOC(sizeof(struct variable))));
      {
	 long arg1743_798;
	 arg1743_798 = class_num_218___object(variable_ast_var);
	 {
	    obj_t obj_1309;
	    obj_1309 = (obj_t) (new1034_797);
	    (((obj_t) CREF(obj_1309))->header = MAKE_HEADER(arg1743_798, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2116;
	 aux_2116 = (object_t) (new1034_797);
	 OBJECT_WIDENING_SET(aux_2116, BFALSE);
      }
      return new1034_797;
   }
}


obj_t 
_allocate_variable_137_ast_var(obj_t env_1391)
{
   {
      variable_t aux_2119;
      aux_2119 = allocate_variable_244_ast_var();
      return (obj_t) (aux_2119);
   }
}


value_t 
allocate_value_190_ast_var()
{
   {
      value_t new1021_809;
      new1021_809 = ((value_t) BREF(GC_MALLOC(sizeof(struct value))));
      {
	 long arg1746_810;
	 arg1746_810 = class_num_218___object(value_ast_var);
	 {
	    obj_t obj_1311;
	    obj_1311 = (obj_t) (new1021_809);
	    (((obj_t) CREF(obj_1311))->header = MAKE_HEADER(arg1746_810, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2126;
	 aux_2126 = (object_t) (new1021_809);
	 OBJECT_WIDENING_SET(aux_2126, BFALSE);
      }
      return new1021_809;
   }
}


obj_t 
_allocate_value_13_ast_var(obj_t env_1390)
{
   {
      value_t aux_2129;
      aux_2129 = allocate_value_190_ast_var();
      return (obj_t) (aux_2129);
   }
}


obj_t 
imported_modules_init_94_ast_var()
{
   module_initialization_70_engine_param(((long) 0), "AST_VAR");
   return module_initialization_70_type_type(((long) 0), "AST_VAR");
}
