/*===========================================================================*/
/*   (Ast/venv.scm)                                                          */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


extern obj_t _global_bucket_position_151_ast_env(obj_t, obj_t, obj_t);
extern obj_t _set_genv__185_ast_env(obj_t, obj_t);
extern obj_t get_hash_29___hash(obj_t, obj_t);
extern obj_t global_ast_var;
extern obj_t global_bucket_position_189_ast_env(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t make_hash_table_174___hash(long, obj_t, obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_ast_env();
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70___hash(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_ast_env();
extern long get_hash_power_number(char *, long);
static obj_t cnst_init_137_ast_env();
static obj_t _get_hash_number_209_ast_env(obj_t, obj_t);
extern obj_t __module__166_module_module;
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t get_genv_41_ast_env();
static obj_t require_initialization_114_ast_env = BUNSPEC;
static obj_t library_modules_init_112_ast_env();
extern obj_t __lib_mode__85_engine_param;
extern obj_t _bind_global__219_ast_env(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t user_warning_209_tools_error(obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t put_hash__129___hash(obj_t, obj_t);
extern obj_t unbind_global__45_ast_env(obj_t, obj_t);
extern obj_t _for_each_global__131_ast_env(obj_t, obj_t);
extern obj_t _initialize_genv__83_ast_env(obj_t);
extern obj_t for_each_hash_105___hash(obj_t, obj_t);
extern obj_t _unbind_global__69_ast_env(obj_t, obj_t, obj_t);
static obj_t arg12661320_ast_env(obj_t, obj_t);
extern obj_t _car___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t for_each_global__88_ast_env(obj_t);
extern global_t bind_global__138_ast_env(obj_t, obj_t, value_t, obj_t, obj_t);
extern obj_t set_genv__34_ast_env(obj_t);
extern obj_t _get_genv_78_ast_env(obj_t);
extern obj_t _find_global_16_ast_env(obj_t, obj_t, obj_t);
extern obj_t _eq__190___r4_equivalence_6_2(obj_t, obj_t, obj_t);
extern obj_t _____74_type_cache;
static long get_hash_number_100_ast_env(obj_t);
static obj_t __genv__8_ast_env = BUNSPEC;
extern obj_t initialize_genv__97_ast_env();
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
static obj_t __cnst[8];

DEFINE_EXPORT_PROCEDURE(bind_global__env_67_ast_env, _bind_global__219_ast_env1331, _bind_global__219_ast_env, 0L, 5);
DEFINE_EXPORT_PROCEDURE(set_genv__env_70_ast_env, _set_genv__185_ast_env1332, _set_genv__185_ast_env, 0L, 1);
DEFINE_STRING(string1321_ast_env, string1321_ast_env1333, "Scheme declaration overrides foreign declaration", 48);
DEFINE_STRING(string1323_ast_env, string1323_ast_env1334, "unbind-global!", 14);
DEFINE_EXPORT_PROCEDURE(initialize_genv__env_247_ast_env, _initialize_genv__83_ast_env1335, _initialize_genv__83_ast_env, 0L, 0);
DEFINE_STRING(string1324_ast_env, string1324_ast_env1336, "Can't find global", 17);
DEFINE_STRING(string1325_ast_env, string1325_ast_env1337, "@ NOW READ FOREIGN EQ? CAR GET-HASH-NUMBER THE-GLOBAL-ENVIRONMENT ", 66);
extern obj_t car_env_2___r4_pairs_and_lists_6_3;
DEFINE_STATIC_PROCEDURE(get_hash_number_env_189_ast_env, _get_hash_number_209_ast_env1338, _get_hash_number_209_ast_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(for_each_global__env_168_ast_env, _for_each_global__131_ast_env1339, _for_each_global__131_ast_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_bucket_position_env_214_ast_env, _global_bucket_position_151_ast_env1340, _global_bucket_position_151_ast_env, 0L, 2);
DEFINE_EXPORT_PROCEDURE(unbind_global__env_125_ast_env, _unbind_global__69_ast_env1341, _unbind_global__69_ast_env, 0L, 2);
DEFINE_STRING(string1322_ast_env, string1322_ast_env1342, "Illegal global redefinition", 27);
extern obj_t eq__env_189___r4_equivalence_6_2;
DEFINE_EXPORT_PROCEDURE(get_genv_env_66_ast_env, _get_genv_78_ast_env1343, _get_genv_78_ast_env, 0L, 0);
DEFINE_EXPORT_PROCEDURE(find_global_env_126_ast_env, _find_global_16_ast_env1344, va_generic_entry, _find_global_16_ast_env, -2);

obj_t 
module_initialization_70_ast_env(long checksum_692, char *from_693)
{
   if (CBOOL(require_initialization_114_ast_env))
     {
	require_initialization_114_ast_env = BBOOL(((bool_t) 0));
	library_modules_init_112_ast_env();
	cnst_init_137_ast_env();
	imported_modules_init_94_ast_env();
	toplevel_init_63_ast_env();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_ast_env()
{
   module_initialization_70___hash(((long) 0), "AST_ENV");
   module_initialization_70___object(((long) 0), "AST_ENV");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_ENV");
   module_initialization_70___reader(((long) 0), "AST_ENV");
   return BUNSPEC;
}


obj_t 
cnst_init_137_ast_env()
{
   {
      obj_t cnst_port_138_684;
      cnst_port_138_684 = open_input_string(string1325_ast_env);
      {
	 long i_685;
	 i_685 = ((long) 7);
       loop_686:
	 {
	    bool_t test1326_687;
	    test1326_687 = (i_685 == ((long) -1));
	    if (test1326_687)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1327_688;
		    {
		       obj_t list1328_689;
		       {
			  obj_t arg1329_690;
			  arg1329_690 = BNIL;
			  list1328_689 = MAKE_PAIR(cnst_port_138_684, arg1329_690);
		       }
		       arg1327_688 = read___reader(list1328_689);
		    }
		    CNST_TABLE_SET(i_685, arg1327_688);
		 }
		 {
		    int aux_691;
		    {
		       long aux_711;
		       aux_711 = (i_685 - ((long) 1));
		       aux_691 = (int) (aux_711);
		    }
		    {
		       long i_714;
		       i_714 = (long) (aux_691);
		       i_685 = i_714;
		       goto loop_686;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_ast_env()
{
   return (__genv__8_ast_env = CNST_TABLE_REF(((long) 0)),
      BUNSPEC);
}


long 
get_hash_number_100_ast_env(obj_t o_1)
{
   {
      obj_t arg1144_517;
      arg1144_517 = SYMBOL_TO_STRING(o_1);
      {
	 char *aux_718;
	 aux_718 = BSTRING_TO_STRING(arg1144_517);
	 return get_hash_power_number(aux_718, ((long) 12));
      }
   }
}


obj_t 
_get_hash_number_209_ast_env(obj_t env_652, obj_t o_653)
{
   {
      long aux_721;
      aux_721 = get_hash_number_100_ast_env(o_653);
      return BINT(aux_721);
   }
}


obj_t 
set_genv__34_ast_env(obj_t genv_2)
{
   __genv__8_ast_env = genv_2;
   {
      obj_t s_522;
      s_522 = __genv__8_ast_env;
      STRUCT_SET(s_522, ((long) 2), get_hash_number_env_189_ast_env);
   }
   {
      obj_t s_524;
      s_524 = __genv__8_ast_env;
      STRUCT_SET(s_524, ((long) 3), car_env_2___r4_pairs_and_lists_6_3);
   }
   {
      obj_t s_526;
      s_526 = __genv__8_ast_env;
      return STRUCT_SET(s_526, ((long) 5), eq__env_189___r4_equivalence_6_2);
   }
}


obj_t 
_set_genv__185_ast_env(obj_t env_654, obj_t genv_655)
{
   return set_genv__34_ast_env(genv_655);
}


obj_t 
get_genv_41_ast_env()
{
   {
      obj_t s_528;
      s_528 = __genv__8_ast_env;
      {
	 obj_t aux_728;
	 aux_728 = CNST_TABLE_REF(((long) 1));
	 STRUCT_SET(s_528, ((long) 2), aux_728);
      }
   }
   {
      obj_t s_531;
      s_531 = __genv__8_ast_env;
      {
	 obj_t aux_731;
	 aux_731 = CNST_TABLE_REF(((long) 2));
	 STRUCT_SET(s_531, ((long) 3), aux_731);
      }
   }
   {
      obj_t s_534;
      s_534 = __genv__8_ast_env;
      {
	 obj_t aux_734;
	 aux_734 = CNST_TABLE_REF(((long) 3));
	 STRUCT_SET(s_534, ((long) 5), aux_734);
      }
   }
   return __genv__8_ast_env;
}


obj_t 
_get_genv_78_ast_env(obj_t env_661)
{
   return get_genv_41_ast_env();
}


obj_t 
initialize_genv__97_ast_env()
{
   {
      obj_t list1165_301;
      {
	 obj_t aux_738;
	 aux_738 = BINT(((long) 1024));
	 list1165_301 = MAKE_PAIR(aux_738, BNIL);
      }
      return (__genv__8_ast_env = make_hash_table_174___hash(((long) 4096), get_hash_number_env_189_ast_env, car_env_2___r4_pairs_and_lists_6_3, eq__env_189___r4_equivalence_6_2, list1165_301),
	 BUNSPEC);
   }
}


obj_t 
_initialize_genv__83_ast_env(obj_t env_662)
{
   return initialize_genv__97_ast_env();
}


obj_t 
find_global_223_ast_env(obj_t id_3, obj_t module_4)
{
   {
      obj_t bucket_304;
      obj_t module_305;
      bucket_304 = get_hash_29___hash(id_3, __genv__8_ast_env);
      if (NULLP(module_4))
	{
	   module_305 = BNIL;
	}
      else
	{
	   module_305 = CAR(module_4);
	}
      if (PAIRP(bucket_304))
	{
	   bool_t test_749;
	   {
	      obj_t aux_750;
	      aux_750 = CDR(bucket_304);
	      test_749 = NULLP(aux_750);
	   }
	   if (test_749)
	     {
		return BFALSE;
	     }
	   else
	     {
		if (NULLP(module_305))
		  {
		     {
			obj_t aux_755;
			aux_755 = CDR(bucket_304);
			return CAR(aux_755);
		     }
		  }
		else
		  {
		     {
			obj_t globals_309;
			globals_309 = CDR(bucket_304);
		      loop_310:
			if (NULLP(globals_309))
			  {
			     return BFALSE;
			  }
			else
			  {
			     bool_t test_760;
			     {
				obj_t aux_761;
				{
				   global_t obj_550;
				   {
				      obj_t aux_762;
				      aux_762 = CAR(globals_309);
				      obj_550 = (global_t) (aux_762);
				   }
				   aux_761 = (((global_t) CREF(obj_550))->module);
				}
				test_760 = (aux_761 == module_305);
			     }
			     if (test_760)
			       {
				  return CAR(globals_309);
			       }
			     else
			       {
				  {
				     obj_t globals_768;
				     globals_768 = CDR(globals_309);
				     globals_309 = globals_768;
				     goto loop_310;
				  }
			       }
			  }
		     }
		  }
	     }
	}
      else
	{
	   return BFALSE;
	}
   }
}


obj_t 
_find_global_16_ast_env(obj_t env_663, obj_t id_664, obj_t module_665)
{
   return find_global_223_ast_env(id_664, module_665);
}


global_t 
bind_global__138_ast_env(obj_t id_5, obj_t module_6, value_t value_7, obj_t import_8, obj_t src_9)
{
   {
      obj_t global_319;
      {
	 obj_t list1235_346;
	 list1235_346 = MAKE_PAIR(module_6, BNIL);
	 global_319 = find_global_223_ast_env(id_5, list1235_346);
      }
      {
	 bool_t test_774;
	 {
	    obj_t aux_775;
	    aux_775 = CNST_TABLE_REF(((long) 4));
	    test_774 = (module_6 == aux_775);
	 }
	 if (test_774)
	   {
	      BUNSPEC;
	   }
	 else
	   {
	      obj_t old_foreign_244_321;
	      {
		 obj_t list1209_324;
		 {
		    obj_t aux_778;
		    aux_778 = CNST_TABLE_REF(((long) 4));
		    list1209_324 = MAKE_PAIR(aux_778, BNIL);
		 }
		 old_foreign_244_321 = find_global_223_ast_env(id_5, list1209_324);
	      }
	      {
		 bool_t test1207_322;
		 test1207_322 = is_a__118___object(old_foreign_244_321, global_ast_var);
		 if (test1207_322)
		   {
		      user_warning_209_tools_error(id_5, string1321_ast_env, src_9);
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	   }
      }
      {
	 bool_t test1213_327;
	 test1213_327 = is_a__118___object(global_319, global_ast_var);
	 if (test1213_327)
	   {
	      if (CBOOL(__lib_mode__85_engine_param))
		{
		   return (global_t) (global_319);
		}
	      else
		{
		   obj_t aux_790;
		   aux_790 = user_error_151_tools_error(id_5, string1322_ast_env, src_9, BNIL);
		   return (global_t) (aux_790);
		}
	   }
	 else
	   {
	      global_t new_329;
	      obj_t bucket_330;
	      {
		 obj_t arg1230_342;
		 obj_t arg1231_343;
		 arg1230_342 = CNST_TABLE_REF(((long) 5));
		 arg1231_343 = CNST_TABLE_REF(((long) 6));
		 {
		    global_t res1319_591;
		    {
		       obj_t name_560;
		       type_t type_561;
		       bool_t library__255_570;
		       name_560 = BFALSE;
		       type_561 = (type_t) (_____74_type_cache);
		       library__255_570 = CBOOL(__lib_mode__85_engine_param);
		       {
			  global_t new1034_573;
			  new1034_573 = ((global_t) BREF(GC_MALLOC(sizeof(struct global))));
			  {
			     long arg1311_574;
			     arg1311_574 = class_num_218___object(global_ast_var);
			     {
				obj_t obj_589;
				obj_589 = (obj_t) (new1034_573);
				(((obj_t) CREF(obj_589))->header = MAKE_HEADER(arg1311_574, 0), BUNSPEC);
			     }
			  }
			  {
			     object_t aux_801;
			     aux_801 = (object_t) (new1034_573);
			     OBJECT_WIDENING_SET(aux_801, name_560);
			  }
			  ((((global_t) CREF(new1034_573))->id) = ((obj_t) id_5), BUNSPEC);
			  ((((global_t) CREF(new1034_573))->name) = ((obj_t) name_560), BUNSPEC);
			  ((((global_t) CREF(new1034_573))->type) = ((type_t) type_561), BUNSPEC);
			  ((((global_t) CREF(new1034_573))->value) = ((value_t) value_7), BUNSPEC);
			  ((((global_t) CREF(new1034_573))->access) = ((obj_t) arg1230_342), BUNSPEC);
			  ((((global_t) CREF(new1034_573))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
			  ((((global_t) CREF(new1034_573))->removable) = ((obj_t) arg1231_343), BUNSPEC);
			  ((((global_t) CREF(new1034_573))->occurrence) = ((long) ((long) 0)), BUNSPEC);
			  ((((global_t) CREF(new1034_573))->module) = ((obj_t) module_6), BUNSPEC);
			  ((((global_t) CREF(new1034_573))->import) = ((obj_t) import_8), BUNSPEC);
			  ((((global_t) CREF(new1034_573))->evaluable__248) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			  ((((global_t) CREF(new1034_573))->library__255) = ((bool_t) library__255_570), BUNSPEC);
			  ((((global_t) CREF(new1034_573))->pragma) = ((obj_t) BNIL), BUNSPEC);
			  ((((global_t) CREF(new1034_573))->src) = ((obj_t) src_9), BUNSPEC);
			  res1319_591 = new1034_573;
		       }
		    }
		    new_329 = res1319_591;
		 }
	      }
	      bucket_330 = get_hash_29___hash(id_5, __genv__8_ast_env);
	      if (PAIRP(bucket_330))
		{
		   bool_t test1216_332;
		   {
		      obj_t obj2_594;
		      obj2_594 = __module__166_module_module;
		      test1216_332 = (module_6 == obj2_594);
		   }
		   if (test1216_332)
		     {
			{
			   obj_t new_bucket_15_333;
			   {
			      obj_t aux_825;
			      obj_t aux_823;
			      aux_825 = CDR(bucket_330);
			      aux_823 = (obj_t) (new_329);
			      new_bucket_15_333 = MAKE_PAIR(aux_823, aux_825);
			   }
			   SET_CDR(bucket_330, new_bucket_15_333);
			}
		     }
		   else
		     {
			{
			   obj_t arg1218_335;
			   obj_t arg1219_336;
			   arg1218_335 = CDR(bucket_330);
			   {
			      obj_t aux_832;
			      obj_t aux_830;
			      {
				 obj_t aux_833;
				 aux_833 = CDR(bucket_330);
				 aux_832 = CDR(aux_833);
			      }
			      aux_830 = (obj_t) (new_329);
			      arg1219_336 = MAKE_PAIR(aux_830, aux_832);
			   }
			   SET_CDR(arg1218_335, arg1219_336);
			}
		     }
		}
	      else
		{
		   {
		      obj_t arg1225_338;
		      {
			 obj_t list1226_339;
			 {
			    obj_t arg1227_340;
			    {
			       obj_t aux_838;
			       aux_838 = (obj_t) (new_329);
			       arg1227_340 = MAKE_PAIR(aux_838, BNIL);
			    }
			    list1226_339 = MAKE_PAIR(id_5, arg1227_340);
			 }
			 arg1225_338 = list1226_339;
		      }
		      put_hash__129___hash(arg1225_338, __genv__8_ast_env);
		   }
		}
	      return new_329;
	   }
      }
   }
}


obj_t 
_bind_global__219_ast_env(obj_t env_666, obj_t id_667, obj_t module_668, obj_t value_669, obj_t import_670, obj_t src_671)
{
   {
      global_t aux_843;
      aux_843 = bind_global__138_ast_env(id_667, module_668, (value_t) (value_669), import_670, src_671);
      return (obj_t) (aux_843);
   }
}


obj_t 
unbind_global__45_ast_env(obj_t id_10, obj_t module_11)
{
   {
      obj_t global_348;
      {
	 obj_t list1262_370;
	 list1262_370 = MAKE_PAIR(module_11, BNIL);
	 global_348 = find_global_223_ast_env(id_10, list1262_370);
      }
      {
	 bool_t test1237_349;
	 test1237_349 = is_a__118___object(global_348, global_ast_var);
	 if (test1237_349)
	   {
	      obj_t bucket_350;
	      bucket_350 = get_hash_29___hash(id_10, __genv__8_ast_env);
	      {
		 obj_t cur_351;
		 obj_t prev_352;
		 cur_351 = CDR(bucket_350);
		 prev_352 = bucket_350;
	       loop_353:
		 {
		    bool_t test_852;
		    {
		       obj_t aux_853;
		       aux_853 = CAR(cur_351);
		       test_852 = (aux_853 == global_348);
		    }
		    if (test_852)
		      {
			 obj_t aux_856;
			 aux_856 = CDR(cur_351);
			 return SET_CDR(prev_352, aux_856);
		      }
		    else
		      {
			 obj_t prev_861;
			 obj_t cur_859;
			 cur_859 = CDR(cur_351);
			 prev_861 = CDR(prev_352);
			 prev_352 = prev_861;
			 cur_351 = cur_859;
			 goto loop_353;
		      }
		 }
	      }
	   }
	 else
	   {
	      obj_t arg1251_362;
	      {
		 obj_t arg1255_364;
		 arg1255_364 = CNST_TABLE_REF(((long) 7));
		 {
		    obj_t list1257_366;
		    {
		       obj_t arg1259_367;
		       {
			  obj_t arg1260_368;
			  arg1260_368 = MAKE_PAIR(BNIL, BNIL);
			  arg1259_367 = MAKE_PAIR(module_11, arg1260_368);
		       }
		       list1257_366 = MAKE_PAIR(id_10, arg1259_367);
		    }
		    arg1251_362 = cons__138___r4_pairs_and_lists_6_3(arg1255_364, list1257_366);
		 }
	      }
	      return user_error_151_tools_error(string1323_ast_env, string1324_ast_env, arg1251_362, BNIL);
	   }
      }
   }
}


obj_t 
_unbind_global__69_ast_env(obj_t env_672, obj_t id_673, obj_t module_674)
{
   return unbind_global__45_ast_env(id_673, module_674);
}


obj_t 
for_each_global__88_ast_env(obj_t proc_12)
{
   {
      obj_t arg1266_675;
      arg1266_675 = make_fx_procedure(arg12661320_ast_env, ((long) 1), ((long) 1));
      PROCEDURE_SET(arg1266_675, ((long) 0), proc_12);
      return for_each_hash_105___hash(arg1266_675, __genv__8_ast_env);
   }
}


obj_t 
_for_each_global__131_ast_env(obj_t env_676, obj_t proc_677)
{
   return for_each_global__88_ast_env(proc_677);
}


obj_t 
arg12661320_ast_env(obj_t env_678, obj_t bucket_680)
{
   {
      obj_t proc_679;
      proc_679 = PROCEDURE_REF(env_678, ((long) 0));
      {
	 obj_t bucket_373;
	 {
	    bool_t aux_876;
	    bucket_373 = bucket_680;
	    {
	       obj_t l1110_375;
	       l1110_375 = CDR(bucket_373);
	     lname1113_376:
	       if (PAIRP(l1110_375))
		 {
		    PROCEDURE_ENTRY(proc_679) (proc_679, CAR(l1110_375), BEOA);
		    {
		       obj_t l1110_882;
		       l1110_882 = CDR(l1110_375);
		       l1110_375 = l1110_882;
		       goto lname1113_376;
		    }
		 }
	       else
		 {
		    aux_876 = ((bool_t) 1);
		 }
	    }
	    return BBOOL(aux_876);
	 }
      }
   }
}


obj_t 
global_bucket_position_189_ast_env(obj_t id_13, obj_t module_14)
{
   {
      obj_t bucket_382;
      bucket_382 = get_hash_29___hash(id_13, __genv__8_ast_env);
      if (PAIRP(bucket_382))
	{
	   obj_t globals_384;
	   long pos_385;
	   {
	      long aux_889;
	      globals_384 = CDR(bucket_382);
	      pos_385 = ((long) 0);
	    loop_386:
	      if (NULLP(globals_384))
		{
		   aux_889 = ((long) -1);
		}
	      else
		{
		   bool_t test_892;
		   {
		      obj_t aux_893;
		      {
			 global_t obj_628;
			 {
			    obj_t aux_894;
			    aux_894 = CAR(globals_384);
			    obj_628 = (global_t) (aux_894);
			 }
			 aux_893 = (((global_t) CREF(obj_628))->module);
		      }
		      test_892 = (aux_893 == module_14);
		   }
		   if (test_892)
		     {
			aux_889 = pos_385;
		     }
		   else
		     {
			{
			   long pos_901;
			   obj_t globals_899;
			   globals_899 = CDR(globals_384);
			   pos_901 = (pos_385 + ((long) 1));
			   pos_385 = pos_901;
			   globals_384 = globals_899;
			   goto loop_386;
			}
		     }
		}
	      return BINT(aux_889);
	   }
	}
      else
	{
	   return BINT(((long) -1));
	}
   }
}


obj_t 
_global_bucket_position_151_ast_env(obj_t env_681, obj_t id_682, obj_t module_683)
{
   return global_bucket_position_189_ast_env(id_682, module_683);
}


obj_t 
imported_modules_init_94_ast_env()
{
   module_initialization_70_tools_shape(((long) 0), "AST_ENV");
   module_initialization_70_engine_param(((long) 0), "AST_ENV");
   module_initialization_70_tools_error(((long) 0), "AST_ENV");
   module_initialization_70_type_type(((long) 0), "AST_ENV");
   module_initialization_70_type_cache(((long) 0), "AST_ENV");
   module_initialization_70_ast_var(((long) 0), "AST_ENV");
   return module_initialization_70_module_module(((long) 0), "AST_ENV");
}
