/*===========================================================================*/
/*   (Callcc/walk.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct local_cell_149
  {
     char dummy;
  }
              *local_cell_149_t;


extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t let_fun_218_ast_node;
static obj_t celled_bindings_3_callcc_walk(obj_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
static obj_t _callcc__default1327_4_callcc_walk(obj_t, obj_t);
extern obj_t global_ast_var;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
extern obj_t _struct_object__object_6___object(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_callcc_walk();
extern obj_t module_initialization_70_callcc_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t toplevel_init_63_callcc_walk();
static obj_t cnst_init_137_callcc_walk();
static obj_t object__struct_local_cell1785_235_callcc_walk(obj_t, obj_t);
extern obj_t __compiler_debug__134_engine_param;
extern obj_t _callcc_walk__182_callcc_walk(obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
static local_t allocate_local_cell_184_callcc_walk();
static obj_t require_initialization_114_callcc_walk = BUNSPEC;
extern obj_t var_ast_node;
static bool_t celled__113_callcc_walk(variable_t);
static obj_t library_modules_init_112_callcc_walk();
extern obj_t cast_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t conditional_ast_node;
static node_t callcc__192_callcc_walk(node_t);
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
static obj_t struct_object__object_local_cell1784_10_callcc_walk(obj_t, obj_t, obj_t);
extern obj_t pragma_ast_node;
extern long class_num_218___object(obj_t);
static obj_t _allocate_local_cell_31_callcc_walk(obj_t);
static make_box_202_t a_make_cell_117_callcc_walk(node_t, variable_t);
extern obj_t object__struct_50___object(object_t);
extern obj_t current_error_port;
extern obj_t app_ly_162_ast_node;
static obj_t callcc___127_callcc_walk(obj_t);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
static obj_t object_init_111_callcc_walk();
extern obj_t set_ex_it_116_ast_node;
static obj_t _callcc__107_callcc_walk(obj_t, obj_t);
extern obj_t local_ast_var;
extern obj_t kwote_ast_node;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static node_t callcc__default1327_194_callcc_walk(node_t);
extern obj_t _____74_type_cache;
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t box_ref_242_ast_node;
static bool_t callcc_fun__197_callcc_walk(obj_t);
extern obj_t __current_pass__25_engine_pass;
extern obj_t _object__struct_74___object(obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t callcc_walk__209_callcc_walk(obj_t);
extern obj_t funcall_ast_node;
static obj_t local_cell_149_callcc_walk = BUNSPEC;
extern obj_t __obj__252_type_cache;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
extern object_t struct_object__object_93___object(object_t, obj_t);
static node_t cell_formals_12_callcc_walk(obj_t, node_t);
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t);
extern obj_t app_ast_node;
static obj_t __cnst[7];

DEFINE_STATIC_PROCEDURE(proc1793_callcc_walk, object__struct_local_cell1785_235_callcc_walk1802, object__struct_local_cell1785_235_callcc_walk, 0L, 1);
DEFINE_EXPORT_PROCEDURE(callcc_walk__env_78_callcc_walk, _callcc_walk__182_callcc_walk1803, _callcc_walk__182_callcc_walk, 0L, 1);
DEFINE_STRING(string1792_callcc_walk, string1792_callcc_walk1804, "No method for this object", 25);
DEFINE_STRING(string1788_callcc_walk, string1788_callcc_walk1805, "failure during prelude hook", 27);
DEFINE_STATIC_PROCEDURE(callcc__default1327_env_246_callcc_walk, _callcc__default1327_4_callcc_walk1806, _callcc__default1327_4_callcc_walk, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_local_cell_env_161_callcc_walk, _allocate_local_cell_31_callcc_walk1807, _allocate_local_cell_31_callcc_walk, 0L, 0);
DEFINE_STRING(string1789_callcc_walk, string1789_callcc_walk1808, " occured, ending ...", 20);
extern obj_t struct_object__object_env_209___object;
DEFINE_STATIC_PROCEDURE(proc1794_callcc_walk, struct_object__object_local_cell1784_10_callcc_walk1809, struct_object__object_local_cell1784_10_callcc_walk, 0L, 2);
DEFINE_STRING(string1787_callcc_walk, string1787_callcc_walk1810, "   . ", 5);
DEFINE_STRING(string1786_callcc_walk, string1786_callcc_walk1811, "Callcc", 6);
extern obj_t object__struct_env_210___object;
DEFINE_STRING(string1790_callcc_walk, string1790_callcc_walk1812, " error", 6);
DEFINE_STRING(string1795_callcc_walk, string1795_callcc_walk1813, "LOCAL/CELL DONE AUX CALLCC!-DEFAULT1327 WRITE CELL-CALLCC PASS-STARTED ", 71);
DEFINE_STATIC_GENERIC(callcc__env_142_callcc_walk, _callcc__107_callcc_walk1814, _callcc__107_callcc_walk, 0L, 1);
DEFINE_STRING(string1791_callcc_walk, string1791_callcc_walk1815, "failure during postlude hook", 28);

obj_t 
module_initialization_70_callcc_walk(long checksum_1799, char *from_1800)
{
   if (CBOOL(require_initialization_114_callcc_walk))
     {
	require_initialization_114_callcc_walk = BBOOL(((bool_t) 0));
	library_modules_init_112_callcc_walk();
	cnst_init_137_callcc_walk();
	object_init_111_callcc_walk();
	imported_modules_init_94_callcc_walk();
	toplevel_init_63_callcc_walk();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_callcc_walk()
{
   module_initialization_70___object(((long) 0), "CALLCC_WALK");
   module_initialization_70___r4_output_6_10_3(((long) 0), "CALLCC_WALK");
   module_initialization_70___reader(((long) 0), "CALLCC_WALK");
   module_initialization_70___r4_numbers_6_5(((long) 0), "CALLCC_WALK");
   return BUNSPEC;
}


obj_t 
cnst_init_137_callcc_walk()
{
   {
      obj_t cnst_port_138_1791;
      cnst_port_138_1791 = open_input_string(string1795_callcc_walk);
      {
	 long i_1792;
	 i_1792 = ((long) 6);
       loop_1793:
	 {
	    bool_t test1796_1794;
	    test1796_1794 = (i_1792 == ((long) -1));
	    if (test1796_1794)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1798_1795;
		    {
		       obj_t list1799_1796;
		       {
			  obj_t arg1800_1797;
			  arg1800_1797 = BNIL;
			  list1799_1796 = MAKE_PAIR(cnst_port_138_1791, arg1800_1797);
		       }
		       arg1798_1795 = read___reader(list1799_1796);
		    }
		    CNST_TABLE_SET(i_1792, arg1798_1795);
		 }
		 {
		    int aux_1798;
		    {
		       long aux_1819;
		       aux_1819 = (i_1792 - ((long) 1));
		       aux_1798 = (int) (aux_1819);
		    }
		    {
		       long i_1822;
		       i_1822 = (long) (aux_1798);
		       i_1792 = i_1822;
		       goto loop_1793;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_callcc_walk()
{
   add_generic__110___object(callcc__env_142_callcc_walk, callcc__default1327_env_246_callcc_walk);
   add_inlined_method__244___object(callcc__env_142_callcc_walk, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, var_ast_node, ((long) 2));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, sequence_ast_node, ((long) 3));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, app_ast_node, ((long) 4));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, setq_ast_node, ((long) 9));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, conditional_ast_node, ((long) 10));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, fail_ast_node, ((long) 11));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, select_ast_node, ((long) 12));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, let_fun_218_ast_node, ((long) 13));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, let_var_6_ast_node, ((long) 14));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, set_ex_it_116_ast_node, ((long) 15));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, jump_ex_it_184_ast_node, ((long) 16));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, make_box_202_ast_node, ((long) 17));
   add_inlined_method__244___object(callcc__env_142_callcc_walk, box_ref_242_ast_node, ((long) 18));
   {
      long aux_1844;
      aux_1844 = add_inlined_method__244___object(callcc__env_142_callcc_walk, box_set__221_ast_node, ((long) 19));
      return BINT(aux_1844);
   }
}


obj_t 
callcc_walk__209_callcc_walk(obj_t globals_1)
{
   {
      obj_t list1358_697;
      {
	 obj_t arg1361_699;
	 {
	    obj_t arg1364_701;
	    {
	       obj_t aux_1847;
	       aux_1847 = BCHAR(((unsigned char) '\n'));
	       arg1364_701 = MAKE_PAIR(aux_1847, BNIL);
	    }
	    arg1361_699 = MAKE_PAIR(string1786_callcc_walk, arg1364_701);
	 }
	 list1358_697 = MAKE_PAIR(string1787_callcc_walk, arg1361_699);
      }
      verbose_tools_speek(BINT(((long) 1)), list1358_697);
   }
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   __current_pass__25_engine_pass = string1786_callcc_walk;
   {
      obj_t hooks_703;
      obj_t hnames_704;
      hooks_703 = BNIL;
      hnames_704 = BNIL;
    loop_705:
      if (NULLP(hooks_703))
	{
	   CNST_TABLE_REF(((long) 0));
	}
      else
	{
	   bool_t test1372_710;
	   {
	      obj_t fun1383_716;
	      fun1383_716 = CAR(hooks_703);
	      {
		 obj_t aux_1859;
		 aux_1859 = PROCEDURE_ENTRY(fun1383_716) (fun1383_716, BEOA);
		 test1372_710 = CBOOL(aux_1859);
	      }
	   }
	   if (test1372_710)
	     {
		{
		   obj_t hnames_1866;
		   obj_t hooks_1864;
		   hooks_1864 = CDR(hooks_703);
		   hnames_1866 = CDR(hnames_704);
		   hnames_704 = hnames_1866;
		   hooks_703 = hooks_1864;
		   goto loop_705;
		}
	     }
	   else
	     {
		internal_error_43_tools_error(string1786_callcc_walk, string1788_callcc_walk, CAR(hnames_704));
	     }
	}
   }
   {
      bool_t test1384_717;
      {
	 long n1_1322;
	 n1_1322 = (long) CINT(__compiler_debug__134_engine_param);
	 test1384_717 = (n1_1322 > ((long) 2));
      }
      if (test1384_717)
	{
	   __compiler_debug__134_engine_param = BINT(((long) 2));
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t l1291_718;
      l1291_718 = globals_1;
    lname1292_719:
      if (PAIRP(l1291_718))
	{
	   callcc_fun__197_callcc_walk(CAR(l1291_718));
	   {
	      obj_t l1291_1878;
	      l1291_1878 = CDR(l1291_718);
	      l1291_718 = l1291_1878;
	      goto lname1292_719;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      bool_t test1391_724;
      {
	 long n1_1327;
	 n1_1327 = (long) CINT(__nb_error_on_pass__70_tools_error);
	 test1391_724 = (n1_1327 > ((long) 0));
      }
      if (test1391_724)
	{
	   {
	      char *arg1400_727;
	      {
		 bool_t test1411_734;
		 {
		    bool_t test1412_735;
		    {
		       obj_t obj_1329;
		       obj_1329 = __nb_error_on_pass__70_tools_error;
		       test1412_735 = INTEGERP(obj_1329);
		    }
		    if (test1412_735)
		      {
			 test1411_734 = _2__206___r4_numbers_6_5(__nb_error_on_pass__70_tools_error, BINT(((long) 1)));
		      }
		    else
		      {
			 test1411_734 = ((bool_t) 0);
		      }
		 }
		 if (test1411_734)
		   {
		      arg1400_727 = "s";
		   }
		 else
		   {
		      arg1400_727 = "";
		   }
	      }
	      {
		 obj_t list1403_729;
		 {
		    obj_t arg1404_730;
		    {
		       obj_t arg1406_731;
		       {
			  obj_t arg1408_732;
			  arg1408_732 = MAKE_PAIR(string1789_callcc_walk, BNIL);
			  {
			     obj_t aux_1889;
			     aux_1889 = string_to_bstring(arg1400_727);
			     arg1406_731 = MAKE_PAIR(aux_1889, arg1408_732);
			  }
		       }
		       arg1404_730 = MAKE_PAIR(string1790_callcc_walk, arg1406_731);
		    }
		    list1403_729 = MAKE_PAIR(__nb_error_on_pass__70_tools_error, arg1404_730);
		 }
		 fprint___r4_output_6_10_3(current_error_port, list1403_729);
	      }
	   }
	   {
	      obj_t res1743_1331;
	      exit(((long) -1));
	      res1743_1331 = BINT(((long) -1));
	      return res1743_1331;
	   }
	}
      else
	{
	   obj_t hooks_736;
	   obj_t hnames_737;
	   hooks_736 = BNIL;
	   hnames_737 = BNIL;
	 loop_738:
	   if (NULLP(hooks_736))
	     {
		return globals_1;
	     }
	   else
	     {
		bool_t test1418_743;
		{
		   obj_t fun1427_748;
		   fun1427_748 = CAR(hooks_736);
		   {
		      obj_t aux_1900;
		      aux_1900 = PROCEDURE_ENTRY(fun1427_748) (fun1427_748, BEOA);
		      test1418_743 = CBOOL(aux_1900);
		   }
		}
		if (test1418_743)
		  {
		     {
			obj_t hnames_1907;
			obj_t hooks_1905;
			hooks_1905 = CDR(hooks_736);
			hnames_1907 = CDR(hnames_737);
			hnames_737 = hnames_1907;
			hooks_736 = hooks_1905;
			goto loop_738;
		     }
		  }
		else
		  {
		     return internal_error_43_tools_error(__current_pass__25_engine_pass, string1791_callcc_walk, CAR(hnames_737));
		  }
	     }
	}
   }
}


obj_t 
_callcc_walk__182_callcc_walk(obj_t env_1750, obj_t globals_1751)
{
   return callcc_walk__209_callcc_walk(globals_1751);
}


bool_t 
callcc_fun__197_callcc_walk(obj_t var_2)
{
   {
      value_t fun_749;
      {
	 variable_t obj_1338;
	 obj_1338 = (variable_t) (var_2);
	 fun_749 = (((variable_t) CREF(obj_1338))->value);
      }
      {
	 obj_t body_750;
	 {
	    sfun_t obj_1339;
	    obj_1339 = (sfun_t) (fun_749);
	    body_750 = (((sfun_t) CREF(obj_1339))->body);
	 }
	 {
	    obj_t celled_751;
	    {
	       obj_t aux_1916;
	       {
		  sfun_t obj_1340;
		  obj_1340 = (sfun_t) (fun_749);
		  aux_1916 = (((sfun_t) CREF(obj_1340))->args);
	       }
	       celled_751 = celled_bindings_3_callcc_walk(aux_1916);
	    }
	    {
	       {
		  obj_t l1293_752;
		  l1293_752 = celled_751;
		lname1294_753:
		  if (PAIRP(l1293_752))
		    {
		       {
			  obj_t w_b_127_755;
			  w_b_127_755 = CAR(l1293_752);
			  {
			     obj_t arg1432_757;
			     arg1432_757 = CDR(w_b_127_755);
			     {
				obj_t res1744_1347;
				{
				   local_t obj_1345;
				   {
				      obj_t aux_1924;
				      aux_1924 = CAR(w_b_127_755);
				      obj_1345 = (local_t) (aux_1924);
				   }
				   {
				      obj_t x_1765;
				      x_1765 = ((((local_t) CREF(obj_1345))->fast_alpha_7) = ((obj_t) arg1432_757), BUNSPEC);
				      res1744_1347 = BUNSPEC;
				   }
				}
				res1744_1347;
			     }
			  }
		       }
		       {
			  obj_t l1293_1928;
			  l1293_1928 = CDR(l1293_752);
			  l1293_752 = l1293_1928;
			  goto lname1294_753;
		       }
		    }
		  else
		    {
		       ((bool_t) 1);
		    }
	       }
	       {
		  node_t arg1441_759;
		  {
		     node_t arg1444_760;
		     arg1444_760 = callcc__192_callcc_walk((node_t) (body_750));
		     arg1441_759 = cell_formals_12_callcc_walk(celled_751, arg1444_760);
		  }
		  {
		     obj_t res1745_1351;
		     {
			sfun_t obj_1349;
			obj_t val1078_1350;
			obj_1349 = (sfun_t) (fun_749);
			val1078_1350 = (obj_t) (arg1441_759);
			{
			   obj_t x_1766;
			   x_1766 = ((((sfun_t) CREF(obj_1349))->body) = ((obj_t) val1078_1350), BUNSPEC);
			   res1745_1351 = BUNSPEC;
			}
		     }
		     res1745_1351;
		  }
	       }
	       {
		  obj_t l1295_761;
		  l1295_761 = celled_751;
		lname1296_762:
		  if (PAIRP(l1295_761))
		    {
		       {
			  obj_t res1746_1357;
			  {
			     local_t obj_1355;
			     {
				obj_t aux_1938;
				{
				   obj_t aux_1939;
				   aux_1939 = CAR(l1295_761);
				   aux_1938 = CAR(aux_1939);
				}
				obj_1355 = (local_t) (aux_1938);
			     }
			     {
				obj_t x_1767;
				x_1767 = ((((local_t) CREF(obj_1355))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
				res1746_1357 = BUNSPEC;
			     }
			  }
			  res1746_1357;
		       }
		       {
			  obj_t l1295_1944;
			  l1295_1944 = CDR(l1295_761);
			  l1295_761 = l1295_1944;
			  goto lname1296_762;
		       }
		    }
		  else
		    {
		       return ((bool_t) 1);
		    }
	       }
	    }
	 }
      }
   }
}


obj_t 
celled_bindings_3_callcc_walk(obj_t formals_3)
{
   {
      obj_t celled_768;
      obj_t formals_769;
      celled_768 = BNIL;
      formals_769 = formals_3;
    loop_770:
      if (NULLP(formals_769))
	{
	   return celled_768;
	}
      else
	{
	   bool_t test_1948;
	   {
	      variable_t aux_1949;
	      {
		 obj_t aux_1950;
		 aux_1950 = CAR(formals_769);
		 aux_1949 = (variable_t) (aux_1950);
	      }
	      test_1948 = celled__113_callcc_walk(aux_1949);
	   }
	   if (test_1948)
	     {
		{
		   local_t var_774;
		   {
		      obj_t aux_1954;
		      {
			 local_t obj_1362;
			 {
			    obj_t aux_1955;
			    aux_1955 = CAR(formals_769);
			    obj_1362 = (local_t) (aux_1955);
			 }
			 aux_1954 = (((local_t) CREF(obj_1362))->id);
		      }
		      var_774 = make_local_svar_140_ast_local(aux_1954, (type_t) (__obj__252_type_cache));
		   }
		   {
		      obj_t o_n_168_775;
		      {
			 obj_t aux_1963;
			 obj_t aux_1961;
			 aux_1963 = (obj_t) (var_774);
			 aux_1961 = CAR(formals_769);
			 o_n_168_775 = MAKE_PAIR(aux_1961, aux_1963);
		      }
		      {
			 {
			    local_cell_149_t obj1297_776;
			    obj1297_776 = ((local_cell_149_t) (var_774));
			    {
			       obj_t aux_1969;
			       object_t aux_1967;
			       {
				  local_cell_149_t aux_1970;
				  {
				     aux_1970 = ((local_cell_149_t) BREF(GC_MALLOC(sizeof(struct local_cell_149))));
				  }
				  aux_1969 = (obj_t) (aux_1970);
			       }
			       aux_1967 = (object_t) (obj1297_776);
			       OBJECT_WIDENING_SET(aux_1967, aux_1969);
			    }
			    {
			       long arg1453_778;
			       arg1453_778 = class_num_218___object(local_cell_149_callcc_walk);
			       {
				  obj_t obj_1368;
				  obj_1368 = (obj_t) (obj1297_776);
				  (((obj_t) CREF(obj_1368))->header = MAKE_HEADER(arg1453_778, 0), BUNSPEC);
			       }
			    }
			    obj1297_776;
			 }
			 {
			    obj_t arg1454_779;
			    obj_t arg1457_780;
			    arg1454_779 = MAKE_PAIR(o_n_168_775, celled_768);
			    arg1457_780 = CDR(formals_769);
			    {
			       obj_t formals_1980;
			       obj_t celled_1979;
			       celled_1979 = arg1454_779;
			       formals_1980 = arg1457_780;
			       formals_769 = formals_1980;
			       celled_768 = celled_1979;
			       goto loop_770;
			    }
			 }
		      }
		   }
		}
	     }
	   else
	     {
		{
		   obj_t formals_1981;
		   formals_1981 = CDR(formals_769);
		   formals_769 = formals_1981;
		   goto loop_770;
		}
	     }
	}
   }
}


node_t 
cell_formals_12_callcc_walk(obj_t celled_4, node_t body_5)
{
   {
      bool_t test1467_786;
      test1467_786 = NULLP(celled_4);
      if (test1467_786)
	{
	   return body_5;
	}
      else
	{
	   obj_t loc_787;
	   loc_787 = (((node_t) CREF(body_5))->loc);
	   {
	      obj_t arg1468_788;
	      if (test1467_786)
		{
		   arg1468_788 = BNIL;
		}
	      else
		{
		   obj_t head1302_791;
		   head1302_791 = MAKE_PAIR(BNIL, BNIL);
		   {
		      obj_t l1298_792;
		      obj_t tail1303_793;
		      l1298_792 = celled_4;
		      tail1303_793 = head1302_791;
		    lname1301_794:
		      if (NULLP(l1298_792))
			{
			   arg1468_788 = CDR(head1302_791);
			}
		      else
			{
			   obj_t new_tail1304_1_796;
			   {
			      obj_t arg1472_798;
			      {
				 obj_t o_n_168_800;
				 o_n_168_800 = CAR(l1298_792);
				 {
				    obj_t arg1476_801;
				    make_box_202_t arg1477_802;
				    arg1476_801 = CDR(o_n_168_800);
				    {
				       var_t arg1478_803;
				       obj_t arg1480_804;
				       {
					  var_t res1748_1394;
					  {
					     type_t type_1385;
					     variable_t variable_1386;
					     type_1385 = (type_t) (_____74_type_cache);
					     {
						obj_t aux_1994;
						aux_1994 = CAR(o_n_168_800);
						variable_1386 = (variable_t) (aux_1994);
					     }
					     {
						var_t new1129_1387;
						new1129_1387 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
						{
						   long arg1578_1388;
						   arg1578_1388 = class_num_218___object(var_ast_node);
						   {
						      obj_t obj_1392;
						      obj_1392 = (obj_t) (new1129_1387);
						      (((obj_t) CREF(obj_1392))->header = MAKE_HEADER(arg1578_1388, 0), BUNSPEC);
						   }
						}
						{
						   object_t aux_2001;
						   aux_2001 = (object_t) (new1129_1387);
						   OBJECT_WIDENING_SET(aux_2001, BFALSE);
						}
						((((var_t) CREF(new1129_1387))->loc) = ((obj_t) loc_787), BUNSPEC);
						((((var_t) CREF(new1129_1387))->type) = ((type_t) type_1385), BUNSPEC);
						((((var_t) CREF(new1129_1387))->variable) = ((variable_t) variable_1386), BUNSPEC);
						res1748_1394 = new1129_1387;
					     }
					  }
					  arg1478_803 = res1748_1394;
				       }
				       arg1480_804 = CAR(o_n_168_800);
				       arg1477_802 = a_make_cell_117_callcc_walk((node_t) (arg1478_803), (variable_t) (arg1480_804));
				    }
				    {
				       obj_t aux_2011;
				       aux_2011 = (obj_t) (arg1477_802);
				       arg1472_798 = MAKE_PAIR(arg1476_801, aux_2011);
				    }
				 }
			      }
			      new_tail1304_1_796 = MAKE_PAIR(arg1472_798, BNIL);
			   }
			   SET_CDR(tail1303_793, new_tail1304_1_796);
			   {
			      obj_t tail1303_2018;
			      obj_t l1298_2016;
			      l1298_2016 = CDR(l1298_792);
			      tail1303_2018 = new_tail1304_1_796;
			      tail1303_793 = tail1303_2018;
			      l1298_792 = l1298_2016;
			      goto lname1301_794;
			   }
			}
		   }
		}
	      {
		 let_var_6_t res1749_1419;
		 {
		    type_t type_1404;
		    type_1404 = (type_t) (_____74_type_cache);
		    {
		       let_var_6_t new1229_1409;
		       new1229_1409 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
		       {
			  long arg1543_1410;
			  arg1543_1410 = class_num_218___object(let_var_6_ast_node);
			  {
			     obj_t obj_1417;
			     obj_1417 = (obj_t) (new1229_1409);
			     (((obj_t) CREF(obj_1417))->header = MAKE_HEADER(arg1543_1410, 0), BUNSPEC);
			  }
		       }
		       {
			  object_t aux_2024;
			  aux_2024 = (object_t) (new1229_1409);
			  OBJECT_WIDENING_SET(aux_2024, BFALSE);
		       }
		       ((((let_var_6_t) CREF(new1229_1409))->loc) = ((obj_t) loc_787), BUNSPEC);
		       ((((let_var_6_t) CREF(new1229_1409))->type) = ((type_t) type_1404), BUNSPEC);
		       ((((let_var_6_t) CREF(new1229_1409))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		       ((((let_var_6_t) CREF(new1229_1409))->bindings) = ((obj_t) arg1468_788), BUNSPEC);
		       ((((let_var_6_t) CREF(new1229_1409))->body) = ((node_t) body_5), BUNSPEC);
		       ((((let_var_6_t) CREF(new1229_1409))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		       res1749_1419 = new1229_1409;
		    }
		 }
		 return (node_t) (res1749_1419);
	      }
	   }
	}
   }
}


make_box_202_t 
a_make_cell_117_callcc_walk(node_t node_6, variable_t variable_7)
{
   {
      obj_t arg1486_809;
      arg1486_809 = CNST_TABLE_REF(((long) 1));
      {
	 obj_t res1750_1422;
	 {
	    local_t obj_1420;
	    obj_1420 = (local_t) (variable_7);
	    {
	       obj_t x_1768;
	       x_1768 = ((((local_t) CREF(obj_1420))->access) = ((obj_t) arg1486_809), BUNSPEC);
	       res1750_1422 = BUNSPEC;
	    }
	 }
	 res1750_1422;
      }
   }
   {
      local_cell_149_t obj1306_810;
      obj1306_810 = ((local_cell_149_t) (variable_7));
      {
	 obj_t aux_2040;
	 object_t aux_2038;
	 {
	    local_cell_149_t aux_2041;
	    {
	       aux_2041 = ((local_cell_149_t) BREF(GC_MALLOC(sizeof(struct local_cell_149))));
	    }
	    aux_2040 = (obj_t) (aux_2041);
	 }
	 aux_2038 = (object_t) (obj1306_810);
	 OBJECT_WIDENING_SET(aux_2038, aux_2040);
      }
      {
	 long arg1489_812;
	 arg1489_812 = class_num_218___object(local_cell_149_callcc_walk);
	 {
	    obj_t obj_1425;
	    obj_1425 = (obj_t) (obj1306_810);
	    (((obj_t) CREF(obj_1425))->header = MAKE_HEADER(arg1489_812, 0), BUNSPEC);
	 }
      }
      obj1306_810;
   }
   {
      obj_t arg1490_813;
      arg1490_813 = (((node_t) CREF(node_6))->loc);
      {
	 make_box_202_t res1752_1440;
	 {
	    type_t type_1429;
	    type_1429 = (type_t) (_____74_type_cache);
	    {
	       make_box_202_t new1252_1432;
	       new1252_1432 = ((make_box_202_t) BREF(GC_MALLOC(sizeof(struct make_box_202))));
	       {
		  long arg1537_1433;
		  arg1537_1433 = class_num_218___object(make_box_202_ast_node);
		  {
		     obj_t obj_1438;
		     obj_1438 = (obj_t) (new1252_1432);
		     (((obj_t) CREF(obj_1438))->header = MAKE_HEADER(arg1537_1433, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_2054;
		  aux_2054 = (object_t) (new1252_1432);
		  OBJECT_WIDENING_SET(aux_2054, BFALSE);
	       }
	       ((((make_box_202_t) CREF(new1252_1432))->loc) = ((obj_t) arg1490_813), BUNSPEC);
	       ((((make_box_202_t) CREF(new1252_1432))->type) = ((type_t) type_1429), BUNSPEC);
	       ((((make_box_202_t) CREF(new1252_1432))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
	       ((((make_box_202_t) CREF(new1252_1432))->value) = ((node_t) node_6), BUNSPEC);
	       res1752_1440 = new1252_1432;
	    }
	 }
	 return res1752_1440;
      }
   }
}


bool_t 
celled__113_callcc_walk(variable_t var_8)
{
   {
      bool_t _ortest_1307_814;
      _ortest_1307_814 = is_a__118___object((obj_t) (var_8), local_cell_149_callcc_walk);
      if (_ortest_1307_814)
	{
	   return _ortest_1307_814;
	}
      else
	{
	   obj_t aux_2067;
	   obj_t aux_2064;
	   aux_2067 = CNST_TABLE_REF(((long) 2));
	   {
	      local_t obj_1442;
	      obj_1442 = (local_t) (var_8);
	      aux_2064 = (((local_t) CREF(obj_1442))->access);
	   }
	   return (aux_2064 == aux_2067);
	}
   }
}


node_t 
callcc__default1327_194_callcc_walk(node_t node_10)
{
   FAILURE(CNST_TABLE_REF(((long) 3)), string1792_callcc_walk, (obj_t) (node_10));
}


obj_t 
_callcc__default1327_4_callcc_walk(obj_t env_1748, obj_t node_1749)
{
   {
      node_t aux_2073;
      aux_2073 = callcc__default1327_194_callcc_walk((node_t) (node_1749));
      return (obj_t) (aux_2073);
   }
}


node_t 
callcc__192_callcc_walk(node_t node_9)
{
   {
      obj_t method1621_1170;
      obj_t class1626_1171;
      {
	 obj_t arg1630_1168;
	 obj_t arg1632_1169;
	 {
	    object_t obj_1450;
	    obj_1450 = (object_t) (node_9);
	    {
	       obj_t pre_method_105_1451;
	       pre_method_105_1451 = PROCEDURE_REF(callcc__env_142_callcc_walk, ((long) 2));
	       if (INTEGERP(pre_method_105_1451))
		 {
		    PROCEDURE_SET(callcc__env_142_callcc_walk, ((long) 2), BUNSPEC);
		    arg1630_1168 = pre_method_105_1451;
		 }
	       else
		 {
		    long obj_class_num_177_1456;
		    obj_class_num_177_1456 = TYPE(obj_1450);
		    {
		       obj_t arg1183_1457;
		       arg1183_1457 = PROCEDURE_REF(callcc__env_142_callcc_walk, ((long) 1));
		       {
			  long arg1184_1461;
			  {
			     long arg1186_1462;
			     arg1186_1462 = OBJECT_TYPE;
			     arg1184_1461 = (obj_class_num_177_1456 - arg1186_1462);
			  }
			  arg1630_1168 = VECTOR_REF(arg1183_1457, arg1184_1461);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1467;
	    object_1467 = (object_t) (node_9);
	    {
	       long arg1187_1468;
	       {
		  long arg1188_1469;
		  long arg1189_1470;
		  arg1188_1469 = TYPE(object_1467);
		  arg1189_1470 = OBJECT_TYPE;
		  arg1187_1468 = (arg1188_1469 - arg1189_1470);
	       }
	       {
		  obj_t vector_1474;
		  vector_1474 = __classes__134___object;
		  arg1632_1169 = VECTOR_REF(vector_1474, arg1187_1468);
	       }
	    }
	 }
	 {
	    obj_t aux_2092;
	    method1621_1170 = arg1630_1168;
	    class1626_1171 = arg1632_1169;
	    {
	       if (INTEGERP(method1621_1170))
		 {
		    switch ((long) CINT(method1621_1170))
		      {
		      case ((long) 0):
			 {
			    atom_t aux_2095;
			    aux_2095 = (atom_t) (node_9);
			    aux_2092 = (obj_t) (aux_2095);
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t aux_2098;
			    aux_2098 = (kwote_t) (node_9);
			    aux_2092 = (obj_t) (aux_2098);
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t node_1179;
			    node_1179 = (var_t) (node_9);
			    {
			       variable_t var_1180;
			       var_1180 = (((var_t) CREF(node_1179))->variable);
			       {
				  obj_t var_1181;
				  obj_t alpha_1182;
				  var_1181 = (obj_t) (var_1180);
				  alpha_1182 = (((variable_t) CREF(var_1180))->fast_alpha_7);
				loop_1183:
				  {
				     bool_t test1638_1185;
				     test1638_1185 = is_a__118___object(alpha_1182, local_ast_var);
				     if (test1638_1185)
				       {
					  {
					     obj_t res1753_1481;
					     {
						variable_t val1132_1480;
						val1132_1480 = (variable_t) (alpha_1182);
						{
						   obj_t x_1769;
						   x_1769 = ((((var_t) CREF(node_1179))->variable) = ((variable_t) val1132_1480), BUNSPEC);
						   res1753_1481 = BUNSPEC;
						}
					     }
					     res1753_1481;
					  }
					  {
					     obj_t alpha_2108;
					     obj_t var_2107;
					     var_2107 = alpha_1182;
					     {
						variable_t obj_1482;
						obj_1482 = (variable_t) (alpha_1182);
						alpha_2108 = (((variable_t) CREF(obj_1482))->fast_alpha_7);
					     }
					     alpha_1182 = alpha_2108;
					     var_1181 = var_2107;
					     goto loop_1183;
					  }
				       }
				     else
				       {
					  bool_t test1642_1187;
					  test1642_1187 = is_a__118___object(alpha_1182, local_ast_var);
					  if (test1642_1187)
					    {
					       {
						  obj_t res1754_1486;
						  {
						     variable_t val1132_1485;
						     val1132_1485 = (variable_t) (alpha_1182);
						     {
							obj_t x_1770;
							x_1770 = ((((var_t) CREF(node_1179))->variable) = ((variable_t) val1132_1485), BUNSPEC);
							res1754_1486 = BUNSPEC;
						     }
						  }
						  res1754_1486;
					       }
					       {
						  node_t aux_2115;
						  aux_2115 = callcc__192_callcc_walk((node_t) (node_1179));
						  aux_2092 = (obj_t) (aux_2115);
					       }
					    }
					  else
					    {
					       bool_t test1643_1188;
					       test1643_1188 = is_a__118___object(var_1181, global_ast_var);
					       if (test1643_1188)
						 {
						    aux_2092 = (obj_t) (node_1179);
						 }
					       else
						 {
						    if (celled__113_callcc_walk((variable_t) (var_1181)))
						      {
							 {
							    obj_t arg1645_1190;
							    {
							       node_t obj_1488;
							       obj_1488 = (node_t) (node_1179);
							       arg1645_1190 = (((node_t) CREF(obj_1488))->loc);
							    }
							    {
							       box_ref_242_t res1755_1501;
							       {
								  type_t type_1490;
								  type_1490 = (type_t) (_____74_type_cache);
								  {
								     box_ref_242_t new1259_1493;
								     new1259_1493 = ((box_ref_242_t) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
								     {
									long arg1535_1494;
									arg1535_1494 = class_num_218___object(box_ref_242_ast_node);
									{
									   obj_t obj_1499;
									   obj_1499 = (obj_t) (new1259_1493);
									   (((obj_t) CREF(obj_1499))->header = MAKE_HEADER(arg1535_1494, 0), BUNSPEC);
									}
								     }
								     {
									object_t aux_2132;
									aux_2132 = (object_t) (new1259_1493);
									OBJECT_WIDENING_SET(aux_2132, BFALSE);
								     }
								     ((((box_ref_242_t) CREF(new1259_1493))->loc) = ((obj_t) arg1645_1190), BUNSPEC);
								     ((((box_ref_242_t) CREF(new1259_1493))->type) = ((type_t) type_1490), BUNSPEC);
								     ((((box_ref_242_t) CREF(new1259_1493))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
								     ((((box_ref_242_t) CREF(new1259_1493))->var) = ((var_t) node_1179), BUNSPEC);
								     res1755_1501 = new1259_1493;
								  }
							       }
							       aux_2092 = (obj_t) (res1755_1501);
							    }
							 }
						      }
						    else
						      {
							 aux_2092 = (obj_t) (node_1179);
						      }
						 }
					    }
				       }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 3):
			 {
			    sequence_t node_1191;
			    node_1191 = (sequence_t) (node_9);
			    callcc___127_callcc_walk((((sequence_t) CREF(node_1191))->nodes));
			    aux_2092 = (obj_t) (node_1191);
			 }
			 break;
		      case ((long) 4):
			 {
			    app_t node_1193;
			    node_1193 = (app_t) (node_9);
			    callcc___127_callcc_walk((((app_t) CREF(node_1193))->args));
			    aux_2092 = (obj_t) (node_1193);
			 }
			 break;
		      case ((long) 5):
			 {
			    app_ly_162_t node_1196;
			    node_1196 = (app_ly_162_t) (node_9);
			    {
			       node_t arg1648_1198;
			       arg1648_1198 = callcc__192_callcc_walk((((app_ly_162_t) CREF(node_1196))->fun));
			       {
				  obj_t res1756_1507;
				  {
				     obj_t x_1771;
				     x_1771 = ((((app_ly_162_t) CREF(node_1196))->fun) = ((node_t) arg1648_1198), BUNSPEC);
				     res1756_1507 = BUNSPEC;
				  }
				  res1756_1507;
			       }
			    }
			    {
			       node_t arg1651_1200;
			       arg1651_1200 = callcc__192_callcc_walk((((app_ly_162_t) CREF(node_1196))->arg));
			       {
				  obj_t res1757_1511;
				  {
				     obj_t x_1772;
				     x_1772 = ((((app_ly_162_t) CREF(node_1196))->arg) = ((node_t) arg1651_1200), BUNSPEC);
				     res1757_1511 = BUNSPEC;
				  }
				  res1757_1511;
			       }
			    }
			    aux_2092 = (obj_t) (node_1196);
			 }
			 break;
		      case ((long) 6):
			 {
			    funcall_t node_1202;
			    node_1202 = (funcall_t) (node_9);
			    {
			       node_t arg1653_1204;
			       arg1653_1204 = callcc__192_callcc_walk((((funcall_t) CREF(node_1202))->fun));
			       {
				  obj_t res1758_1515;
				  {
				     obj_t x_1773;
				     x_1773 = ((((funcall_t) CREF(node_1202))->fun) = ((node_t) arg1653_1204), BUNSPEC);
				     res1758_1515 = BUNSPEC;
				  }
				  res1758_1515;
			       }
			    }
			    callcc___127_callcc_walk((((funcall_t) CREF(node_1202))->args));
			    aux_2092 = (obj_t) (node_1202);
			 }
			 break;
		      case ((long) 7):
			 {
			    pragma_t node_1207;
			    node_1207 = (pragma_t) (node_9);
			    callcc___127_callcc_walk((((pragma_t) CREF(node_1207))->args));
			    aux_2092 = (obj_t) (node_1207);
			 }
			 break;
		      case ((long) 8):
			 {
			    cast_t node_1209;
			    node_1209 = (cast_t) (node_9);
			    callcc__192_callcc_walk((((cast_t) CREF(node_1209))->arg));
			    aux_2092 = (obj_t) (node_1209);
			 }
			 break;
		      case ((long) 9):
			 {
			    setq_t node_1211;
			    node_1211 = (setq_t) (node_9);
			    {
			       node_t arg1659_1212;
			       arg1659_1212 = callcc__192_callcc_walk((((setq_t) CREF(node_1211))->value));
			       {
				  obj_t res1759_1522;
				  {
				     obj_t x_1774;
				     x_1774 = ((((setq_t) CREF(node_1211))->value) = ((node_t) arg1659_1212), BUNSPEC);
				     res1759_1522 = BUNSPEC;
				  }
				  res1759_1522;
			       }
			    }
			    {
			       variable_t var_1214;
			       {
				  var_t arg1682_1235;
				  arg1682_1235 = (((setq_t) CREF(node_1211))->var);
				  var_1214 = (((var_t) CREF(arg1682_1235))->variable);
			       }
			       {
				  obj_t var_1215;
				  obj_t alpha_1216;
				  var_1215 = (obj_t) (var_1214);
				  alpha_1216 = (((variable_t) CREF(var_1214))->fast_alpha_7);
				loop_1217:
				  {
				     bool_t test1664_1219;
				     test1664_1219 = is_a__118___object(alpha_1216, local_ast_var);
				     if (test1664_1219)
				       {
					  {
					     var_t arg1665_1220;
					     arg1665_1220 = (((setq_t) CREF(node_1211))->var);
					     {
						obj_t res1760_1530;
						{
						   variable_t val1132_1529;
						   val1132_1529 = (variable_t) (alpha_1216);
						   {
						      obj_t x_1775;
						      x_1775 = ((((var_t) CREF(arg1665_1220))->variable) = ((variable_t) val1132_1529), BUNSPEC);
						      res1760_1530 = BUNSPEC;
						   }
						}
						res1760_1530;
					     }
					  }
					  {
					     obj_t alpha_2186;
					     obj_t var_2185;
					     var_2185 = alpha_1216;
					     {
						variable_t obj_1531;
						obj_1531 = (variable_t) (alpha_1216);
						alpha_2186 = (((variable_t) CREF(obj_1531))->fast_alpha_7);
					     }
					     alpha_1216 = alpha_2186;
					     var_1215 = var_2185;
					     goto loop_1217;
					  }
				       }
				     else
				       {
					  bool_t test1668_1222;
					  test1668_1222 = is_a__118___object(var_1215, global_ast_var);
					  if (test1668_1222)
					    {
					       aux_2092 = (obj_t) (node_1211);
					    }
					  else
					    {
					       if (celled__113_callcc_walk((variable_t) (var_1215)))
						 {
						    {
						       local_t a_var_30_1224;
						       obj_t loc_1225;
						       a_var_30_1224 = make_local_svar_140_ast_local(CNST_TABLE_REF(((long) 4)), (type_t) (__obj__252_type_cache));
						       {
							  node_t obj_1533;
							  obj_1533 = (node_t) (node_1211);
							  loc_1225 = (((node_t) CREF(obj_1533))->loc);
						       }
						       {
							  obj_t arg1671_1226;
							  box_set__221_t arg1673_1227;
							  {
							     obj_t arg1674_1228;
							     {
								obj_t aux_2202;
								obj_t aux_2200;
								{
								   node_t aux_2203;
								   aux_2203 = (((setq_t) CREF(node_1211))->value);
								   aux_2202 = (obj_t) (aux_2203);
								}
								aux_2200 = (obj_t) (a_var_30_1224);
								arg1674_1228 = MAKE_PAIR(aux_2200, aux_2202);
							     }
							     {
								obj_t list1675_1229;
								list1675_1229 = MAKE_PAIR(arg1674_1228, BNIL);
								arg1671_1226 = list1675_1229;
							     }
							  }
							  {
							     var_t arg1679_1232;
							     var_t arg1680_1233;
							     arg1679_1232 = (((setq_t) CREF(node_1211))->var);
							     {
								var_t res1761_1549;
								{
								   type_t type_1540;
								   variable_t variable_1541;
								   type_1540 = (type_t) (_____74_type_cache);
								   variable_1541 = (variable_t) (a_var_30_1224);
								   {
								      var_t new1129_1542;
								      new1129_1542 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
								      {
									 long arg1578_1543;
									 arg1578_1543 = class_num_218___object(var_ast_node);
									 {
									    obj_t obj_1547;
									    obj_1547 = (obj_t) (new1129_1542);
									    (((obj_t) CREF(obj_1547))->header = MAKE_HEADER(arg1578_1543, 0), BUNSPEC);
									 }
								      }
								      {
									 object_t aux_2215;
									 aux_2215 = (object_t) (new1129_1542);
									 OBJECT_WIDENING_SET(aux_2215, BFALSE);
								      }
								      ((((var_t) CREF(new1129_1542))->loc) = ((obj_t) loc_1225), BUNSPEC);
								      ((((var_t) CREF(new1129_1542))->type) = ((type_t) type_1540), BUNSPEC);
								      ((((var_t) CREF(new1129_1542))->variable) = ((variable_t) variable_1541), BUNSPEC);
								      res1761_1549 = new1129_1542;
								   }
								}
								arg1680_1233 = res1761_1549;
							     }
							     {
								box_set__221_t res1762_1562;
								{
								   type_t type_1551;
								   node_t value_1553;
								   type_1551 = (type_t) (_____74_type_cache);
								   value_1553 = (node_t) (arg1680_1233);
								   {
								      box_set__221_t new1266_1554;
								      new1266_1554 = ((box_set__221_t) BREF(GC_MALLOC(sizeof(struct box_set__221))));
								      {
									 long arg1532_1555;
									 arg1532_1555 = class_num_218___object(box_set__221_ast_node);
									 {
									    obj_t obj_1560;
									    obj_1560 = (obj_t) (new1266_1554);
									    (((obj_t) CREF(obj_1560))->header = MAKE_HEADER(arg1532_1555, 0), BUNSPEC);
									 }
								      }
								      {
									 object_t aux_2227;
									 aux_2227 = (object_t) (new1266_1554);
									 OBJECT_WIDENING_SET(aux_2227, BFALSE);
								      }
								      ((((box_set__221_t) CREF(new1266_1554))->loc) = ((obj_t) loc_1225), BUNSPEC);
								      ((((box_set__221_t) CREF(new1266_1554))->type) = ((type_t) type_1551), BUNSPEC);
								      ((((box_set__221_t) CREF(new1266_1554))->var) = ((var_t) arg1679_1232), BUNSPEC);
								      ((((box_set__221_t) CREF(new1266_1554))->value) = ((node_t) value_1553), BUNSPEC);
								      res1762_1562 = new1266_1554;
								   }
								}
								arg1673_1227 = res1762_1562;
							     }
							  }
							  {
							     let_var_6_t res1763_1579;
							     {
								type_t type_1564;
								node_t body_1567;
								type_1564 = (type_t) (_____74_type_cache);
								body_1567 = (node_t) (arg1673_1227);
								{
								   let_var_6_t new1229_1569;
								   new1229_1569 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
								   {
								      long arg1543_1570;
								      arg1543_1570 = class_num_218___object(let_var_6_ast_node);
								      {
									 obj_t obj_1577;
									 obj_1577 = (obj_t) (new1229_1569);
									 (((obj_t) CREF(obj_1577))->header = MAKE_HEADER(arg1543_1570, 0), BUNSPEC);
								      }
								   }
								   {
								      object_t aux_2240;
								      aux_2240 = (object_t) (new1229_1569);
								      OBJECT_WIDENING_SET(aux_2240, BFALSE);
								   }
								   ((((let_var_6_t) CREF(new1229_1569))->loc) = ((obj_t) loc_1225), BUNSPEC);
								   ((((let_var_6_t) CREF(new1229_1569))->type) = ((type_t) type_1564), BUNSPEC);
								   ((((let_var_6_t) CREF(new1229_1569))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
								   ((((let_var_6_t) CREF(new1229_1569))->bindings) = ((obj_t) arg1671_1226), BUNSPEC);
								   ((((let_var_6_t) CREF(new1229_1569))->body) = ((node_t) body_1567), BUNSPEC);
								   ((((let_var_6_t) CREF(new1229_1569))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
								   res1763_1579 = new1229_1569;
								}
							     }
							     aux_2092 = (obj_t) (res1763_1579);
							  }
						       }
						    }
						 }
					       else
						 {
						    aux_2092 = (obj_t) (node_1211);
						 }
					    }
				       }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 10):
			 {
			    conditional_t node_1236;
			    node_1236 = (conditional_t) (node_9);
			    {
			       node_t arg1684_1238;
			       arg1684_1238 = callcc__192_callcc_walk((((conditional_t) CREF(node_1236))->test));
			       {
				  obj_t res1764_1583;
				  {
				     obj_t x_1776;
				     x_1776 = ((((conditional_t) CREF(node_1236))->test) = ((node_t) arg1684_1238), BUNSPEC);
				     res1764_1583 = BUNSPEC;
				  }
				  res1764_1583;
			       }
			    }
			    {
			       node_t arg1687_1240;
			       arg1687_1240 = callcc__192_callcc_walk((((conditional_t) CREF(node_1236))->true));
			       {
				  obj_t res1765_1587;
				  {
				     obj_t x_1777;
				     x_1777 = ((((conditional_t) CREF(node_1236))->true) = ((node_t) arg1687_1240), BUNSPEC);
				     res1765_1587 = BUNSPEC;
				  }
				  res1765_1587;
			       }
			    }
			    {
			       node_t arg1689_1242;
			       arg1689_1242 = callcc__192_callcc_walk((((conditional_t) CREF(node_1236))->false));
			       {
				  obj_t res1766_1591;
				  {
				     obj_t x_1778;
				     x_1778 = ((((conditional_t) CREF(node_1236))->false) = ((node_t) arg1689_1242), BUNSPEC);
				     res1766_1591 = BUNSPEC;
				  }
				  res1766_1591;
			       }
			    }
			    aux_2092 = (obj_t) (node_1236);
			 }
			 break;
		      case ((long) 11):
			 {
			    fail_t node_1244;
			    node_1244 = (fail_t) (node_9);
			    {
			       node_t arg1691_1246;
			       arg1691_1246 = callcc__192_callcc_walk((((fail_t) CREF(node_1244))->proc));
			       {
				  obj_t res1767_1595;
				  {
				     obj_t x_1779;
				     x_1779 = ((((fail_t) CREF(node_1244))->proc) = ((node_t) arg1691_1246), BUNSPEC);
				     res1767_1595 = BUNSPEC;
				  }
				  res1767_1595;
			       }
			    }
			    {
			       node_t arg1694_1248;
			       arg1694_1248 = callcc__192_callcc_walk((((fail_t) CREF(node_1244))->msg));
			       {
				  obj_t res1768_1599;
				  {
				     obj_t x_1780;
				     x_1780 = ((((fail_t) CREF(node_1244))->msg) = ((node_t) arg1694_1248), BUNSPEC);
				     res1768_1599 = BUNSPEC;
				  }
				  res1768_1599;
			       }
			    }
			    {
			       node_t arg1696_1250;
			       arg1696_1250 = callcc__192_callcc_walk((((fail_t) CREF(node_1244))->obj));
			       {
				  obj_t res1769_1603;
				  {
				     obj_t x_1781;
				     x_1781 = ((((fail_t) CREF(node_1244))->obj) = ((node_t) arg1696_1250), BUNSPEC);
				     res1769_1603 = BUNSPEC;
				  }
				  res1769_1603;
			       }
			    }
			    aux_2092 = (obj_t) (node_1244);
			 }
			 break;
		      case ((long) 12):
			 {
			    select_t node_1252;
			    node_1252 = (select_t) (node_9);
			    {
			       node_t arg1698_1254;
			       arg1698_1254 = callcc__192_callcc_walk((((select_t) CREF(node_1252))->test));
			       {
				  obj_t res1770_1607;
				  {
				     obj_t x_1782;
				     x_1782 = ((((select_t) CREF(node_1252))->test) = ((node_t) arg1698_1254), BUNSPEC);
				     res1770_1607 = BUNSPEC;
				  }
				  res1770_1607;
			       }
			    }
			    {
			       obj_t l1314_1256;
			       l1314_1256 = (((select_t) CREF(node_1252))->clauses);
			     lname1316_1257:
			       if (PAIRP(l1314_1256))
				 {
				    {
				       obj_t clause_1260;
				       clause_1260 = CAR(l1314_1256);
				       {
					  node_t arg1703_1261;
					  {
					     node_t aux_2282;
					     {
						obj_t aux_2283;
						aux_2283 = CDR(clause_1260);
						aux_2282 = (node_t) (aux_2283);
					     }
					     arg1703_1261 = callcc__192_callcc_walk(aux_2282);
					  }
					  {
					     obj_t aux_2287;
					     aux_2287 = (obj_t) (arg1703_1261);
					     SET_CDR(clause_1260, aux_2287);
					  }
				       }
				    }
				    {
				       obj_t l1314_2290;
				       l1314_2290 = CDR(l1314_1256);
				       l1314_1256 = l1314_2290;
				       goto lname1316_1257;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_2092 = (obj_t) (node_1252);
			 }
			 break;
		      case ((long) 13):
			 {
			    let_fun_218_t node_1264;
			    node_1264 = (let_fun_218_t) (node_9);
			    {
			       obj_t l1318_1266;
			       l1318_1266 = (((let_fun_218_t) CREF(node_1264))->locals);
			     lname1319_1267:
			       if (PAIRP(l1318_1266))
				 {
				    callcc_fun__197_callcc_walk(CAR(l1318_1266));
				    {
				       obj_t l1318_2299;
				       l1318_2299 = CDR(l1318_1266);
				       l1318_1266 = l1318_2299;
				       goto lname1319_1267;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1710_1272;
			       arg1710_1272 = callcc__192_callcc_walk((((let_fun_218_t) CREF(node_1264))->body));
			       {
				  obj_t res1771_1622;
				  {
				     obj_t x_1783;
				     x_1783 = ((((let_fun_218_t) CREF(node_1264))->body) = ((node_t) arg1710_1272), BUNSPEC);
				     res1771_1622 = BUNSPEC;
				  }
				  res1771_1622;
			       }
			    }
			    aux_2092 = (obj_t) (node_1264);
			 }
			 break;
		      case ((long) 14):
			 {
			    let_var_6_t node_1274;
			    node_1274 = (let_var_6_t) (node_9);
			    {
			       node_t arg1712_1276;
			       arg1712_1276 = callcc__192_callcc_walk((((let_var_6_t) CREF(node_1274))->body));
			       {
				  obj_t res1772_1626;
				  {
				     obj_t x_1784;
				     x_1784 = ((((let_var_6_t) CREF(node_1274))->body) = ((node_t) arg1712_1276), BUNSPEC);
				     res1772_1626 = BUNSPEC;
				  }
				  res1772_1626;
			       }
			    }
			    {
			       obj_t l1321_1278;
			       l1321_1278 = (((let_var_6_t) CREF(node_1274))->bindings);
			     lname1324_1279:
			       if (PAIRP(l1321_1278))
				 {
				    {
				       obj_t binding_1282;
				       binding_1282 = CAR(l1321_1278);
				       {
					  obj_t var_1283;
					  var_1283 = CAR(binding_1282);
					  {
					     node_t arg1717_1285;
					     {
						node_t aux_2314;
						{
						   obj_t aux_2315;
						   aux_2315 = CDR(binding_1282);
						   aux_2314 = (node_t) (aux_2315);
						}
						arg1717_1285 = callcc__192_callcc_walk(aux_2314);
					     }
					     {
						obj_t aux_2319;
						aux_2319 = (obj_t) (arg1717_1285);
						SET_CDR(binding_1282, aux_2319);
					     }
					  }
					  if (celled__113_callcc_walk((variable_t) (var_1283)))
					    {
					       {
						  obj_t res1773_1636;
						  {
						     local_t obj_1634;
						     type_t val1052_1635;
						     obj_1634 = (local_t) (var_1283);
						     val1052_1635 = (type_t) (__obj__252_type_cache);
						     {
							obj_t x_1785;
							x_1785 = ((((local_t) CREF(obj_1634))->type) = ((type_t) val1052_1635), BUNSPEC);
							res1773_1636 = BUNSPEC;
						     }
						  }
						  res1773_1636;
					       }
					       {
						  make_box_202_t arg1719_1287;
						  {
						     node_t aux_2328;
						     {
							obj_t aux_2329;
							aux_2329 = CDR(binding_1282);
							aux_2328 = (node_t) (aux_2329);
						     }
						     arg1719_1287 = a_make_cell_117_callcc_walk(aux_2328, (variable_t) (var_1283));
						  }
						  {
						     obj_t aux_2334;
						     aux_2334 = (obj_t) (arg1719_1287);
						     SET_CDR(binding_1282, aux_2334);
						  }
					       }
					    }
					  else
					    {
					       BUNSPEC;
					    }
				       }
				    }
				    {
				       obj_t l1321_2337;
				       l1321_2337 = CDR(l1321_1278);
				       l1321_1278 = l1321_2337;
				       goto lname1324_1279;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_2092 = (obj_t) (node_1274);
			 }
			 break;
		      case ((long) 15):
			 {
			    set_ex_it_116_t node_1290;
			    node_1290 = (set_ex_it_116_t) (node_9);
			    {
			       node_t arg1722_1291;
			       arg1722_1291 = callcc__192_callcc_walk((((set_ex_it_116_t) CREF(node_1290))->body));
			       {
				  obj_t res1774_1644;
				  {
				     obj_t x_1786;
				     x_1786 = ((((set_ex_it_116_t) CREF(node_1290))->body) = ((node_t) arg1722_1291), BUNSPEC);
				     res1774_1644 = BUNSPEC;
				  }
				  res1774_1644;
			       }
			    }
			    aux_2092 = (obj_t) (node_1290);
			 }
			 break;
		      case ((long) 16):
			 {
			    jump_ex_it_184_t node_1293;
			    node_1293 = (jump_ex_it_184_t) (node_9);
			    {
			       node_t arg1725_1295;
			       arg1725_1295 = callcc__192_callcc_walk((((jump_ex_it_184_t) CREF(node_1293))->exit));
			       {
				  obj_t res1775_1648;
				  {
				     obj_t x_1787;
				     x_1787 = ((((jump_ex_it_184_t) CREF(node_1293))->exit) = ((node_t) arg1725_1295), BUNSPEC);
				     res1775_1648 = BUNSPEC;
				  }
				  res1775_1648;
			       }
			    }
			    {
			       node_t arg1731_1297;
			       arg1731_1297 = callcc__192_callcc_walk((((jump_ex_it_184_t) CREF(node_1293))->value));
			       {
				  obj_t res1776_1652;
				  {
				     obj_t x_1788;
				     x_1788 = ((((jump_ex_it_184_t) CREF(node_1293))->value) = ((node_t) arg1731_1297), BUNSPEC);
				     res1776_1652 = BUNSPEC;
				  }
				  res1776_1652;
			       }
			    }
			    aux_2092 = (obj_t) (node_1293);
			 }
			 break;
		      case ((long) 17):
			 {
			    make_box_202_t node_1299;
			    node_1299 = (make_box_202_t) (node_9);
			    {
			       node_t arg1733_1300;
			       arg1733_1300 = callcc__192_callcc_walk((((make_box_202_t) CREF(node_1299))->value));
			       {
				  obj_t res1777_1656;
				  {
				     obj_t x_1789;
				     x_1789 = ((((make_box_202_t) CREF(node_1299))->value) = ((node_t) arg1733_1300), BUNSPEC);
				     res1777_1656 = BUNSPEC;
				  }
				  res1777_1656;
			       }
			    }
			    aux_2092 = (obj_t) (node_1299);
			 }
			 break;
		      case ((long) 18):
			 {
			    box_ref_242_t aux_2359;
			    aux_2359 = (box_ref_242_t) (node_9);
			    aux_2092 = (obj_t) (aux_2359);
			 }
			 break;
		      case ((long) 19):
			 {
			    box_set__221_t node_1303;
			    node_1303 = (box_set__221_t) (node_9);
			    {
			       node_t arg1735_1305;
			       arg1735_1305 = callcc__192_callcc_walk((((box_set__221_t) CREF(node_1303))->value));
			       {
				  obj_t res1778_1660;
				  {
				     obj_t x_1790;
				     x_1790 = ((((box_set__221_t) CREF(node_1303))->value) = ((node_t) arg1735_1305), BUNSPEC);
				     res1778_1660 = BUNSPEC;
				  }
				  res1778_1660;
			       }
			    }
			    aux_2092 = (obj_t) (node_1303);
			 }
			 break;
		      default:
		       case_else1627_73_1174:
			 if (PROCEDUREP(method1621_1170))
			   {
			      aux_2092 = PROCEDURE_ENTRY(method1621_1170) (method1621_1170, (obj_t) (node_9), BEOA);
			   }
			 else
			   {
			      obj_t fun1498_819;
			      fun1498_819 = PROCEDURE_REF(callcc__env_142_callcc_walk, ((long) 0));
			      aux_2092 = PROCEDURE_ENTRY(fun1498_819) (fun1498_819, (obj_t) (node_9), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1627_73_1174;
		 }
	    }
	    return (node_t) (aux_2092);
	 }
      }
   }
}


obj_t 
_callcc__107_callcc_walk(obj_t env_1746, obj_t node_1747)
{
   {
      node_t aux_2379;
      aux_2379 = callcc__192_callcc_walk((node_t) (node_1747));
      return (obj_t) (aux_2379);
   }
}


obj_t 
callcc___127_callcc_walk(obj_t node__221_31)
{
 callcc___127_callcc_walk:
   if (NULLP(node__221_31))
     {
	return CNST_TABLE_REF(((long) 5));
     }
   else
     {
	{
	   node_t arg1500_821;
	   {
	      node_t aux_2386;
	      {
		 obj_t aux_2387;
		 aux_2387 = CAR(node__221_31);
		 aux_2386 = (node_t) (aux_2387);
	      }
	      arg1500_821 = callcc__192_callcc_walk(aux_2386);
	   }
	   {
	      obj_t aux_2391;
	      aux_2391 = (obj_t) (arg1500_821);
	      SET_CAR(node__221_31, aux_2391);
	   }
	}
	{
	   obj_t node__221_2394;
	   node__221_2394 = CDR(node__221_31);
	   node__221_31 = node__221_2394;
	   goto callcc___127_callcc_walk;
	}
     }
}


obj_t 
object_init_111_callcc_walk()
{
   {
      obj_t arg1507_825;
      arg1507_825 = local_ast_var;
      local_cell_149_callcc_walk = add_class__117___object(CNST_TABLE_REF(((long) 6)), arg1507_825, allocate_local_cell_env_161_callcc_walk, ((long) 5896), BUNSPEC);
   }
   {
      obj_t object__struct_local_cell_80_1756;
      object__struct_local_cell_80_1756 = proc1793_callcc_walk;
      add_method__1___object(object__struct_env_210___object, local_cell_149_callcc_walk, object__struct_local_cell_80_1756);
   }
   {
      obj_t struct_object__object_local_cell_0_1752;
      struct_object__object_local_cell_0_1752 = proc1794_callcc_walk;
      return add_method__1___object(struct_object__object_env_209___object, local_cell_149_callcc_walk, struct_object__object_local_cell_0_1752);
   }
}


obj_t 
struct_object__object_local_cell1784_10_callcc_walk(obj_t env_1759, obj_t o_1760, obj_t s_1761)
{
   {
      local_cell_149_t o_839;
      obj_t s_840;
      {
	 local_cell_149_t aux_2400;
	 o_839 = (local_cell_149_t) (o_1760);
	 s_840 = s_1761;
	 {
	    {
	       obj_t old1288_843;
	       {
		  obj_t next_method1357_79_848;
		  next_method1357_79_848 = find_super_class_method_167___object((object_t) (o_839), struct_object__object_env_209___object, local_cell_149_callcc_walk);
		  if (PROCEDUREP(next_method1357_79_848))
		    {
		       old1288_843 = PROCEDURE_ENTRY(next_method1357_79_848) (next_method1357_79_848, (obj_t) (o_839), s_840, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1357_79_848);
		       {
			  object_t aux_2409;
			  aux_2409 = struct_object__object_93___object((object_t) (o_839), s_840);
			  old1288_843 = (obj_t) (aux_2409);
		       }
		    }
	       }
	       {
		  local_cell_149_t new1290_845;
		  new1290_845 = ((local_cell_149_t) (old1288_843));
		  {
		     long arg1520_846;
		     arg1520_846 = class_num_218___object(local_cell_149_callcc_walk);
		     {
			obj_t obj_1683;
			obj_1683 = (obj_t) (new1290_845);
			(((obj_t) CREF(obj_1683))->header = MAKE_HEADER(arg1520_846, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_2419;
		     object_t aux_2417;
		     {
			local_cell_149_t aux_2420;
			{
			   aux_2420 = ((local_cell_149_t) BREF(GC_MALLOC(sizeof(struct local_cell_149))));
			}
			aux_2419 = (obj_t) (aux_2420);
		     }
		     aux_2417 = (object_t) (new1290_845);
		     OBJECT_WIDENING_SET(aux_2417, aux_2419);
		  }
		  aux_2400 = new1290_845;
	       }
	    }
	 }
	 return (obj_t) (aux_2400);
      }
   }
}


obj_t 
object__struct_local_cell1785_235_callcc_walk(obj_t env_1762, obj_t obj1285_1763)
{
   {
      local_cell_149_t obj1285_828;
      obj1285_828 = (local_cell_149_t) (obj1285_1763);
      {
	 {
	    obj_t res1286_831;
	    {
	       obj_t next_method1356_46_837;
	       next_method1356_46_837 = find_super_class_method_167___object((object_t) (obj1285_828), object__struct_env_210___object, local_cell_149_callcc_walk);
	       if (PROCEDUREP(next_method1356_46_837))
		 {
		    res1286_831 = PROCEDURE_ENTRY(next_method1356_46_837) (next_method1356_46_837, (obj_t) (obj1285_828), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1356_46_837);
		    res1286_831 = object__struct_50___object((object_t) (obj1285_828));
		 }
	    }
	    {
	       obj_t aux1287_832;
	       {
		  obj_t aux_2436;
		  aux_2436 = CNST_TABLE_REF(((long) 6));
		  aux1287_832 = make_struct(aux_2436, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res1286_831, ((long) 0), aux1287_832);
	       {
		  obj_t aux_2440;
		  aux_2440 = STRUCT_KEY(res1286_831);
		  STRUCT_KEY_SET(aux1287_832, aux_2440);
	       }
	       {
		  obj_t aux_2443;
		  aux_2443 = CNST_TABLE_REF(((long) 6));
		  STRUCT_KEY_SET(res1286_831, aux_2443);
	       }
	       return res1286_831;
	    }
	 }
      }
   }
}


local_t 
allocate_local_cell_184_callcc_walk()
{
   {
      local_t new1284_850;
      new1284_850 = ((local_t) BREF(GC_MALLOC(sizeof(struct local))));
      {
	 long arg1524_851;
	 arg1524_851 = class_num_218___object(local_cell_149_callcc_walk);
	 {
	    obj_t obj_1689;
	    obj_1689 = (obj_t) (new1284_850);
	    (((obj_t) CREF(obj_1689))->header = MAKE_HEADER(arg1524_851, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2451;
	 aux_2451 = (object_t) (new1284_850);
	 OBJECT_WIDENING_SET(aux_2451, BFALSE);
      }
      return new1284_850;
   }
}


obj_t 
_allocate_local_cell_31_callcc_walk(obj_t env_1764)
{
   {
      local_t aux_2454;
      aux_2454 = allocate_local_cell_184_callcc_walk();
      return (obj_t) (aux_2454);
   }
}


obj_t 
imported_modules_init_94_callcc_walk()
{
   module_initialization_70_tools_speek(((long) 0), "CALLCC_WALK");
   module_initialization_70_tools_error(((long) 0), "CALLCC_WALK");
   module_initialization_70_engine_pass(((long) 0), "CALLCC_WALK");
   module_initialization_70_type_type(((long) 0), "CALLCC_WALK");
   module_initialization_70_ast_var(((long) 0), "CALLCC_WALK");
   module_initialization_70_ast_node(((long) 0), "CALLCC_WALK");
   module_initialization_70_tools_shape(((long) 0), "CALLCC_WALK");
   module_initialization_70_type_cache(((long) 0), "CALLCC_WALK");
   module_initialization_70_ast_local(((long) 0), "CALLCC_WALK");
   return module_initialization_70_engine_param(((long) 0), "CALLCC_WALK");
}
