/*===========================================================================*/
/*   (Cfa/app.scm)                                                           */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


extern approx_t cfa_intern_sfun__162_cfa_iterate(intern_sfun_cinfo_192_t, obj_t);
static obj_t cfa__app2255_226_cfa_app(obj_t, obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern approx_t loose__226_cfa_loose(approx_t, obj_t);
extern obj_t _cfa__186_cfa_cfa(obj_t, obj_t);
extern obj_t __classes__134___object;
extern approx_t app__231_cfa_app(fun_t, var_t, obj_t);
static obj_t imported_modules_init_94_cfa_app();
extern obj_t module_initialization_70_cfa_app(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_cfa_app();
static obj_t cnst_init_137_cfa_app();
static obj_t require_initialization_114_cfa_app = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cfa_app();
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
static approx_t app__default1890_51_cfa_app(fun_t, var_t, obj_t);
extern approx_t union_approx__241_cfa_approx(approx_t, approx_t);
extern approx_t cfa__102_cfa_cfa(node_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t _app__default1890_189_cfa_app(obj_t, obj_t, obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_6_cfa_info;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t cfun_cinfo_200_cfa_info;
extern obj_t intern_sfun_cinfo_192_cfa_info;
extern obj_t _app__252_cfa_app(obj_t, obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t __cnst[2];

extern obj_t cfa__env_153_cfa_cfa;
DEFINE_STRING(string2262_cfa_app, string2262_cfa_app2271, "  app(intern)!: ", 16);
DEFINE_STATIC_PROCEDURE(proc2257_cfa_app, cfa__app2255_226_cfa_app2272, cfa__app2255_226_cfa_app, 0L, 1);
DEFINE_STRING(string2261_cfa_app, string2261_cfa_app2273, " ", 1);
DEFINE_STRING(string2263_cfa_app, string2263_cfa_app2274, "  app(extern)!: ", 16);
DEFINE_STATIC_PROCEDURE(app__default1890_env_181_cfa_app, _app__default1890_189_cfa_app2275, _app__default1890_189_cfa_app, 0L, 3);
DEFINE_STRING(string2265_cfa_app, string2265_cfa_app2276, "ALL CFA ", 8);
DEFINE_STRING(string2264_cfa_app, string2264_cfa_app2277, "  app(cfun)!: ", 14);
DEFINE_STRING(string2259_cfa_app, string2259_cfa_app2278, "app!", 4);
DEFINE_STRING(string2258_cfa_app, string2258_cfa_app2279, " app: ", 6);
DEFINE_STRING(string2260_cfa_app, string2260_cfa_app2280, "No method for this function", 27);
DEFINE_EXPORT_GENERIC(app__env_198_cfa_app, _app__252_cfa_app2281, _app__252_cfa_app, 0L, 3);

obj_t 
module_initialization_70_cfa_app(long checksum_3264, char *from_3265)
{
   if (CBOOL(require_initialization_114_cfa_app))
     {
	require_initialization_114_cfa_app = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_app();
	cnst_init_137_cfa_app();
	imported_modules_init_94_cfa_app();
	toplevel_init_63_cfa_app();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_app()
{
   module_initialization_70___object(((long) 0), "CFA_APP");
   module_initialization_70___reader(((long) 0), "CFA_APP");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_app()
{
   {
      obj_t cnst_port_138_3256;
      cnst_port_138_3256 = open_input_string(string2265_cfa_app);
      {
	 long i_3257;
	 i_3257 = ((long) 1);
       loop_3258:
	 {
	    bool_t test2266_3259;
	    test2266_3259 = (i_3257 == ((long) -1));
	    if (test2266_3259)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2267_3260;
		    {
		       obj_t list2268_3261;
		       {
			  obj_t arg2269_3262;
			  arg2269_3262 = BNIL;
			  list2268_3261 = MAKE_PAIR(cnst_port_138_3256, arg2269_3262);
		       }
		       arg2267_3260 = read___reader(list2268_3261);
		    }
		    CNST_TABLE_SET(i_3257, arg2267_3260);
		 }
		 {
		    int aux_3263;
		    {
		       long aux_3281;
		       aux_3281 = (i_3257 - ((long) 1));
		       aux_3263 = (int) (aux_3281);
		    }
		    {
		       long i_3284;
		       i_3284 = (long) (aux_3263);
		       i_3257 = i_3284;
		       goto loop_3258;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_app()
{
   {
      obj_t cfa__app_90_3243;
      cfa__app_90_3243 = proc2257_cfa_app;
      add_method__1___object(cfa__env_153_cfa_cfa, app_ast_node, cfa__app_90_3243);
   }
   add_generic__110___object(app__env_198_cfa_app, app__default1890_env_181_cfa_app);
   add_inlined_method__244___object(app__env_198_cfa_app, intern_sfun_cinfo_192_cfa_info, ((long) 0));
   add_inlined_method__244___object(app__env_198_cfa_app, extern_sfun_cinfo_6_cfa_info, ((long) 1));
   {
      long aux_3290;
      aux_3290 = add_inlined_method__244___object(app__env_198_cfa_app, cfun_cinfo_200_cfa_info, ((long) 2));
      return BINT(aux_3290);
   }
}


obj_t 
cfa__app2255_226_cfa_app(obj_t env_3244, obj_t node_3245)
{
   {
      app_t node_1946;
      {
	 approx_t aux_3293;
	 node_1946 = (app_t) (node_3245);
	 {
	    bool_t test1894_1949;
	    {
	       obj_t aux_3294;
	       aux_3294 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	       test1894_1949 = CBOOL(aux_3294);
	    }
	    if (test1894_1949)
	      {
		 obj_t arg1896_1951;
		 arg1896_1951 = shape_tools_shape((obj_t) (node_1946));
		 {
		    obj_t list1897_1952;
		    {
		       obj_t arg1898_1953;
		       {
			  obj_t arg1899_1954;
			  {
			     obj_t aux_3302;
			     aux_3302 = BCHAR(((unsigned char) '\n'));
			     arg1899_1954 = MAKE_PAIR(aux_3302, BNIL);
			  }
			  arg1898_1953 = MAKE_PAIR(arg1896_1951, arg1899_1954);
		       }
		       list1897_1952 = MAKE_PAIR(string2258_cfa_app, arg1898_1953);
		    }
		    print_trace_107_tools_trace(list1897_1952);
		 }
	      }
	    else
	      {
		 BUNSPEC;
	      }
	 }
	 {
	    value_t arg1904_1959;
	    var_t arg1905_1960;
	    obj_t arg1906_1961;
	    {
	       variable_t arg1907_1962;
	       {
		  var_t arg1908_1963;
		  arg1908_1963 = (((app_t) CREF(node_1946))->fun);
		  arg1907_1962 = (((var_t) CREF(arg1908_1963))->variable);
	       }
	       arg1904_1959 = (((variable_t) CREF(arg1907_1962))->value);
	    }
	    arg1905_1960 = (((app_t) CREF(node_1946))->fun);
	    {
	       obj_t l1871_1964;
	       l1871_1964 = (((app_t) CREF(node_1946))->args);
	       if (NULLP(l1871_1964))
		 {
		    arg1906_1961 = BNIL;
		 }
	       else
		 {
		    obj_t head1876_1966;
		    {
		       approx_t arg1917_1977;
		       {
			  node_t aux_3315;
			  {
			     obj_t aux_3316;
			     aux_3316 = CAR(l1871_1964);
			     aux_3315 = (node_t) (aux_3316);
			  }
			  arg1917_1977 = cfa__102_cfa_cfa(aux_3315);
		       }
		       {
			  obj_t aux_3320;
			  aux_3320 = (obj_t) (arg1917_1977);
			  head1876_1966 = MAKE_PAIR(aux_3320, BNIL);
		       }
		    }
		    {
		       obj_t l1871_1967;
		       obj_t tail1877_1968;
		       l1871_1967 = CDR(l1871_1964);
		       tail1877_1968 = head1876_1966;
		     lname1875_1969:
		       if (NULLP(l1871_1967))
			 {
			    arg1906_1961 = head1876_1966;
			 }
		       else
			 {
			    obj_t new_tail1878_13_1972;
			    {
			       approx_t arg1914_1974;
			       {
				  node_t aux_3325;
				  {
				     obj_t aux_3326;
				     aux_3326 = CAR(l1871_1967);
				     aux_3325 = (node_t) (aux_3326);
				  }
				  arg1914_1974 = cfa__102_cfa_cfa(aux_3325);
			       }
			       {
				  obj_t aux_3330;
				  aux_3330 = (obj_t) (arg1914_1974);
				  new_tail1878_13_1972 = MAKE_PAIR(aux_3330, BNIL);
			       }
			    }
			    SET_CDR(tail1877_1968, new_tail1878_13_1972);
			    {
			       obj_t tail1877_3336;
			       obj_t l1871_3334;
			       l1871_3334 = CDR(l1871_1967);
			       tail1877_3336 = new_tail1878_13_1972;
			       tail1877_1968 = tail1877_3336;
			       l1871_1967 = l1871_3334;
			       goto lname1875_1969;
			    }
			 }
		    }
		 }
	    }
	    aux_3293 = app__231_cfa_app((fun_t) (arg1904_1959), arg1905_1960, arg1906_1961);
	 }
	 return (obj_t) (aux_3293);
      }
   }
}


approx_t 
app__default1890_51_cfa_app(fun_t fun_5, var_t var_6, obj_t args_approx_137_7)
{
   {
      obj_t arg1926_2846;
      {
	 obj_t arg1927_2847;
	 arg1927_2847 = shape_tools_shape((obj_t) (var_6));
	 {
	    obj_t aux_3344;
	    aux_3344 = (obj_t) (fun_5);
	    arg1926_2846 = MAKE_PAIR(aux_3344, arg1927_2847);
	 }
      }
      {
	 obj_t aux_3347;
	 aux_3347 = internal_error_43_tools_error(string2259_cfa_app, string2260_cfa_app, arg1926_2846);
	 return (approx_t) (aux_3347);
      }
   }
}


obj_t 
_app__default1890_189_cfa_app(obj_t env_3252, obj_t fun_3253, obj_t var_3254, obj_t args_approx_137_3255)
{
   {
      approx_t aux_3350;
      aux_3350 = app__default1890_51_cfa_app((fun_t) (fun_3253), (var_t) (var_3254), args_approx_137_3255);
      return (obj_t) (aux_3350);
   }
}


approx_t 
app__231_cfa_app(fun_t fun_2, var_t var_3, obj_t args_approx_137_4)
{
   {
      obj_t method2181_2738;
      obj_t class2186_2739;
      {
	 obj_t arg2189_2736;
	 obj_t arg2190_2737;
	 {
	    object_t obj_2850;
	    obj_2850 = (object_t) (fun_2);
	    {
	       obj_t pre_method_105_2851;
	       pre_method_105_2851 = PROCEDURE_REF(app__env_198_cfa_app, ((long) 2));
	       if (INTEGERP(pre_method_105_2851))
		 {
		    PROCEDURE_SET(app__env_198_cfa_app, ((long) 2), BUNSPEC);
		    arg2189_2736 = pre_method_105_2851;
		 }
	       else
		 {
		    long obj_class_num_177_2856;
		    obj_class_num_177_2856 = TYPE(obj_2850);
		    {
		       obj_t arg1183_2857;
		       arg1183_2857 = PROCEDURE_REF(app__env_198_cfa_app, ((long) 1));
		       {
			  long arg1184_2861;
			  {
			     long arg1186_2862;
			     arg1186_2862 = OBJECT_TYPE;
			     arg1184_2861 = (obj_class_num_177_2856 - arg1186_2862);
			  }
			  arg2189_2736 = VECTOR_REF(arg1183_2857, arg1184_2861);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_2867;
	    object_2867 = (object_t) (fun_2);
	    {
	       long arg1187_2868;
	       {
		  long arg1188_2869;
		  long arg1189_2870;
		  arg1188_2869 = TYPE(object_2867);
		  arg1189_2870 = OBJECT_TYPE;
		  arg1187_2868 = (arg1188_2869 - arg1189_2870);
	       }
	       {
		  obj_t vector_2874;
		  vector_2874 = __classes__134___object;
		  arg2190_2737 = VECTOR_REF(vector_2874, arg1187_2868);
	       }
	    }
	 }
	 {
	    obj_t aux_3370;
	    method2181_2738 = arg2189_2736;
	    class2186_2739 = arg2190_2737;
	    {
	       if (INTEGERP(method2181_2738))
		 {
		    switch ((long) CINT(method2181_2738))
		      {
		      case ((long) 0):
			 {
			    intern_sfun_cinfo_192_t fun_2745;
			    fun_2745 = (intern_sfun_cinfo_192_t) (fun_2);
			    {
			       bool_t test2193_2748;
			       {
				  obj_t aux_3374;
				  aux_3374 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2193_2748 = CBOOL(aux_3374);
			       }
			       if (test2193_2748)
				 {
				    obj_t arg2195_2750;
				    obj_t arg2197_2752;
				    arg2195_2750 = shape_tools_shape((obj_t) (var_3));
				    arg2197_2752 = shape_tools_shape(args_approx_137_4);
				    {
				       obj_t list2198_2753;
				       {
					  obj_t arg2199_2754;
					  {
					     obj_t arg2200_2755;
					     {
						obj_t arg2201_2756;
						{
						   obj_t arg2202_2757;
						   {
						      obj_t aux_3383;
						      aux_3383 = BCHAR(((unsigned char) '\n'));
						      arg2202_2757 = MAKE_PAIR(aux_3383, BNIL);
						   }
						   arg2201_2756 = MAKE_PAIR(arg2197_2752, arg2202_2757);
						}
						arg2200_2755 = MAKE_PAIR(string2261_cfa_app, arg2201_2756);
					     }
					     arg2199_2754 = MAKE_PAIR(arg2195_2750, arg2200_2755);
					  }
					  list2198_2753 = MAKE_PAIR(string2262_cfa_app, arg2199_2754);
				       }
				       print_trace_107_tools_trace(list2198_2753);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       obj_t ll1880_2762;
			       obj_t ll1881_2763;
			       {
				  sfun_t obj_2876;
				  obj_2876 = (sfun_t) (fun_2745);
				  ll1880_2762 = (((sfun_t) CREF(obj_2876))->args);
			       }
			       ll1881_2763 = args_approx_137_4;
			     lname1882_2764:
			       if (NULLP(ll1880_2762))
				 {
				    ((bool_t) 1);
				 }
			       else
				 {
				    {
				       approx_t aux_3405;
				       approx_t aux_3393;
				       {
					  obj_t aux_3406;
					  aux_3406 = CAR(ll1881_2763);
					  aux_3405 = (approx_t) (aux_3406);
				       }
				       {
					  svar_cinfo_166_t obj_2881;
					  {
					     value_t aux_3394;
					     {
						local_t obj_2880;
						{
						   obj_t aux_3395;
						   aux_3395 = CAR(ll1880_2762);
						   obj_2880 = (local_t) (aux_3395);
						}
						aux_3394 = (((local_t) CREF(obj_2880))->value);
					     }
					     obj_2881 = (svar_cinfo_166_t) (aux_3394);
					  }
					  {
					     obj_t aux_3400;
					     {
						object_t aux_3401;
						aux_3401 = (object_t) (obj_2881);
						aux_3400 = OBJECT_WIDENING(aux_3401);
					     }
					     aux_3393 = (((svar_cinfo_166_t) CREF(aux_3400))->approx);
					  }
				       }
				       union_approx__241_cfa_approx(aux_3393, aux_3405);
				    }
				    {
				       obj_t ll1881_3412;
				       obj_t ll1880_3410;
				       ll1880_3410 = CDR(ll1880_2762);
				       ll1881_3412 = CDR(ll1881_2763);
				       ll1881_2763 = ll1881_3412;
				       ll1880_2762 = ll1880_3410;
				       goto lname1882_2764;
				    }
				 }
			    }
			    {
			       approx_t aux_3416;
			       {
				  obj_t aux_3417;
				  {
				     variable_t aux_3418;
				     aux_3418 = (((var_t) CREF(var_3))->variable);
				     aux_3417 = (obj_t) (aux_3418);
				  }
				  aux_3416 = cfa_intern_sfun__162_cfa_iterate(fun_2745, aux_3417);
			       }
			       aux_3370 = (obj_t) (aux_3416);
			    }
			 }
			 break;
		      case ((long) 1):
			 {
			    extern_sfun_cinfo_6_t fun_2774;
			    fun_2774 = (extern_sfun_cinfo_6_t) (fun_2);
			    {
			       bool_t test2214_2777;
			       {
				  obj_t aux_3424;
				  aux_3424 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2214_2777 = CBOOL(aux_3424);
			       }
			       if (test2214_2777)
				 {
				    obj_t arg2216_2779;
				    obj_t arg2218_2781;
				    arg2216_2779 = shape_tools_shape((obj_t) (var_3));
				    arg2218_2781 = shape_tools_shape(args_approx_137_4);
				    {
				       obj_t list2219_2782;
				       {
					  obj_t arg2220_2783;
					  {
					     obj_t arg2221_2784;
					     {
						obj_t arg2222_2785;
						{
						   obj_t arg2223_2786;
						   {
						      obj_t aux_3433;
						      aux_3433 = BCHAR(((unsigned char) '\n'));
						      arg2223_2786 = MAKE_PAIR(aux_3433, BNIL);
						   }
						   arg2222_2785 = MAKE_PAIR(arg2218_2781, arg2223_2786);
						}
						arg2221_2784 = MAKE_PAIR(string2261_cfa_app, arg2222_2785);
					     }
					     arg2220_2783 = MAKE_PAIR(arg2216_2779, arg2221_2784);
					  }
					  list2219_2782 = MAKE_PAIR(string2263_cfa_app, arg2220_2783);
				       }
				       print_trace_107_tools_trace(list2219_2782);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       bool_t test_3441;
			       {
				  sfun_t obj_2885;
				  obj_2885 = (sfun_t) (fun_2774);
				  test_3441 = (((sfun_t) CREF(obj_2885))->top__138);
			       }
			       if (test_3441)
				 {
				    obj_t l1884_2792;
				    {
				       bool_t aux_3444;
				       l1884_2792 = args_approx_137_4;
				     lname1885_2793:
				       if (PAIRP(l1884_2792))
					 {
					    {
					       approx_t aux_3447;
					       {
						  obj_t aux_3448;
						  aux_3448 = CAR(l1884_2792);
						  aux_3447 = (approx_t) (aux_3448);
					       }
					       loose__226_cfa_loose(aux_3447, CNST_TABLE_REF(((long) 1)));
					    }
					    {
					       obj_t l1884_3453;
					       l1884_3453 = CDR(l1884_2792);
					       l1884_2792 = l1884_3453;
					       goto lname1885_2793;
					    }
					 }
				       else
					 {
					    aux_3444 = ((bool_t) 1);
					 }
				       BBOOL(aux_3444);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       approx_t aux_3456;
			       {
				  obj_t aux_3457;
				  {
				     object_t aux_3458;
				     aux_3458 = (object_t) (fun_2774);
				     aux_3457 = OBJECT_WIDENING(aux_3458);
				  }
				  aux_3456 = (((extern_sfun_cinfo_6_t) CREF(aux_3457))->approx);
			       }
			       aux_3370 = (obj_t) (aux_3456);
			    }
			 }
			 break;
		      case ((long) 2):
			 {
			    cfun_cinfo_200_t fun_2798;
			    fun_2798 = (cfun_cinfo_200_t) (fun_2);
			    {
			       bool_t test2231_2801;
			       {
				  obj_t aux_3464;
				  aux_3464 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2231_2801 = CBOOL(aux_3464);
			       }
			       if (test2231_2801)
				 {
				    obj_t arg2233_2803;
				    arg2233_2803 = shape_tools_shape((obj_t) (var_3));
				    {
				       obj_t list2234_2804;
				       {
					  obj_t arg2235_2805;
					  {
					     obj_t arg2236_2806;
					     {
						obj_t aux_3472;
						aux_3472 = BCHAR(((unsigned char) '\n'));
						arg2236_2806 = MAKE_PAIR(aux_3472, BNIL);
					     }
					     arg2235_2805 = MAKE_PAIR(arg2233_2803, arg2236_2806);
					  }
					  list2234_2804 = MAKE_PAIR(string2264_cfa_app, arg2235_2805);
				       }
				       print_trace_107_tools_trace(list2234_2804);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       bool_t test_3478;
			       {
				  cfun_t obj_2890;
				  obj_2890 = (cfun_t) (fun_2798);
				  test_3478 = (((cfun_t) CREF(obj_2890))->top__138);
			       }
			       if (test_3478)
				 {
				    obj_t l1887_2812;
				    {
				       bool_t aux_3481;
				       l1887_2812 = args_approx_137_4;
				     lname1888_2813:
				       if (PAIRP(l1887_2812))
					 {
					    {
					       approx_t aux_3484;
					       {
						  obj_t aux_3485;
						  aux_3485 = CAR(l1887_2812);
						  aux_3484 = (approx_t) (aux_3485);
					       }
					       loose__226_cfa_loose(aux_3484, CNST_TABLE_REF(((long) 1)));
					    }
					    {
					       obj_t l1887_3490;
					       l1887_3490 = CDR(l1887_2812);
					       l1887_2812 = l1887_3490;
					       goto lname1888_2813;
					    }
					 }
				       else
					 {
					    aux_3481 = ((bool_t) 1);
					 }
				       BBOOL(aux_3481);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       approx_t aux_3493;
			       {
				  obj_t aux_3494;
				  {
				     object_t aux_3495;
				     aux_3495 = (object_t) (fun_2798);
				     aux_3494 = OBJECT_WIDENING(aux_3495);
				  }
				  aux_3493 = (((cfun_cinfo_200_t) CREF(aux_3494))->approx);
			       }
			       aux_3370 = (obj_t) (aux_3493);
			    }
			 }
			 break;
		      default:
		       case_else2187_14_2742:
			 if (PROCEDUREP(method2181_2738))
			   {
			      aux_3370 = PROCEDURE_ENTRY(method2181_2738) (method2181_2738, (obj_t) (fun_2), (obj_t) (var_3), args_approx_137_4, BEOA);
			   }
			 else
			   {
			      obj_t fun1928_1986;
			      fun1928_1986 = PROCEDURE_REF(app__env_198_cfa_app, ((long) 0));
			      aux_3370 = PROCEDURE_ENTRY(fun1928_1986) (fun1928_1986, (obj_t) (fun_2), (obj_t) (var_3), args_approx_137_4, BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else2187_14_2742;
		 }
	    }
	    return (approx_t) (aux_3370);
	 }
      }
   }
}


obj_t 
_app__252_cfa_app(obj_t env_3248, obj_t fun_3249, obj_t var_3250, obj_t args_approx_137_3251)
{
   {
      approx_t aux_3514;
      aux_3514 = app__231_cfa_app((fun_t) (fun_3249), (var_t) (var_3250), args_approx_137_3251);
      return (obj_t) (aux_3514);
   }
}


obj_t 
imported_modules_init_94_cfa_app()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_APP");
   module_initialization_70_tools_shape(((long) 0), "CFA_APP");
   module_initialization_70_tools_error(((long) 0), "CFA_APP");
   module_initialization_70_type_type(((long) 0), "CFA_APP");
   module_initialization_70_ast_var(((long) 0), "CFA_APP");
   module_initialization_70_ast_node(((long) 0), "CFA_APP");
   module_initialization_70_cfa_info(((long) 0), "CFA_APP");
   module_initialization_70_cfa_cfa(((long) 0), "CFA_APP");
   module_initialization_70_cfa_iterate(((long) 0), "CFA_APP");
   module_initialization_70_cfa_loose(((long) 0), "CFA_APP");
   return module_initialization_70_cfa_approx(((long) 0), "CFA_APP");
}
