/*===========================================================================*/
/*   (Cfa/approx.scm)                                                        */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


extern obj_t get_node_atom_value_135_cfa_approx(node_t);
extern obj_t set__vector_66_cfa_set(obj_t);
extern obj_t _approx_set_type__245_cfa_approx(obj_t, obj_t, obj_t);
extern obj_t __procedure__226_type_cache;
extern obj_t type_type_type;
extern obj_t _shape_tools_shape(obj_t, obj_t);
extern obj_t declare_set__41_cfa_set(obj_t, obj_t, obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t set_extend__187_cfa_set(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t _for_each_approx_alloc_106_cfa_approx(obj_t, obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t _union_approx__74_cfa_approx(obj_t, obj_t, obj_t);
extern obj_t list__vector_101___r4_vectors_6_8(obj_t);
extern obj_t get_allocs_52_cfa_collect();
static obj_t imported_modules_init_94_cfa_approx();
extern obj_t _approx_set_top__201_cfa_approx(obj_t, obj_t);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_collect(long, char *);
extern obj_t module_initialization_70_cfa_set(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_procedure(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_vectors_6_8(long, char *);
static obj_t toplevel_init_63_cfa_approx();
static obj_t cnst_init_137_cfa_approx();
extern obj_t _make_empty_approx_139_cfa_approx(obj_t);
static obj_t get_node_atom_value_default1875_100_cfa_approx(node_t);
extern obj_t _node_key_105_cfa_approx(obj_t, obj_t);
extern obj_t _make_type_approx_211_cfa_approx(obj_t, obj_t);
static obj_t require_initialization_114_cfa_approx = BUNSPEC;
extern approx_t make_empty_approx_131_cfa_approx();
extern obj_t var_ast_node;
extern obj_t node_key_123_cfa_approx(node_t);
static obj_t library_modules_init_112_cfa_approx();
extern obj_t _make_alloc_approx_59_cfa_approx(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t declare_approx_sets__132_cfa_approx();
static obj_t node_key_set__default1873_213_cfa_approx(node_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t _get_node_atom_value_97_cfa_approx(obj_t, obj_t);
static obj_t shape_approx2248_236_cfa_approx(obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t set_union__206_cfa_set(obj_t, obj_t);
static obj_t _node_key_default1872_87_cfa_approx(obj_t, obj_t);
extern approx_t union_approx__241_cfa_approx(approx_t, approx_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern approx_t make_type_alloc_approx_134_cfa_approx(type_t, node_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t disable_x_t__211_cfa_procedure(approx_t);
extern obj_t _node_key_set__44_cfa_approx(obj_t, obj_t, obj_t);
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern approx_t make_type_approx_184_cfa_approx(type_t);
extern obj_t approx_cfa_info;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t _get_node_atom_value_default1875_95_cfa_approx(obj_t, obj_t);
extern obj_t approx_set_type__239_cfa_approx(approx_t, type_t);
static obj_t node_key_default1872_127_cfa_approx(node_t);
extern obj_t _4dots_tools_misc;
extern obj_t reshaped_local_224_cfa_info;
extern obj_t make_set__25_cfa_set(obj_t);
extern obj_t _make_type_alloc_approx_37_cfa_approx(obj_t, obj_t, obj_t);
extern approx_t make_alloc_approx_89_cfa_approx(app_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t _declare_approx_sets__161_cfa_approx(obj_t);
extern obj_t _____74_type_cache;
extern obj_t node_ast_node;
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t approx_set_top__187_cfa_approx(approx_t);
extern obj_t continue_cfa__104_cfa_iterate();
extern obj_t __obj__252_type_cache;
extern obj_t atom_ast_node;
extern obj_t set_for_each_94_cfa_set(obj_t, obj_t);
extern obj_t node_key_set__195_cfa_approx(node_t, obj_t);
static obj_t _node_key_set__default1873_186_cfa_approx(obj_t, obj_t, obj_t);
static obj_t __alloc_set__27_cfa_approx = BUNSPEC;
static obj_t __cnst[3];

DEFINE_EXPORT_PROCEDURE(make_alloc_approx_env_133_cfa_approx, _make_alloc_approx_59_cfa_approx2259, _make_alloc_approx_59_cfa_approx, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_type_approx_env_161_cfa_approx, _make_type_approx_211_cfa_approx2260, _make_type_approx_211_cfa_approx, 0L, 1);
DEFINE_EXPORT_GENERIC(get_node_atom_value_env_18_cfa_approx, _get_node_atom_value_97_cfa_approx2261, _get_node_atom_value_97_cfa_approx, 0L, 1);
DEFINE_STRING(string2253_cfa_approx, string2253_cfa_approx2262, "(NO-ATOM-VALUE) NODE-KEY-SET!-DEFAULT1873 TOP ", 46);
DEFINE_STRING(string2251_cfa_approx, string2251_cfa_approx2263, "node-key", 8);
DEFINE_EXPORT_GENERIC(node_key_set__env_57_cfa_approx, _node_key_set__44_cfa_approx2264, _node_key_set__44_cfa_approx, 0L, 2);
DEFINE_EXPORT_GENERIC(node_key_env_229_cfa_approx, _node_key_105_cfa_approx2265, _node_key_105_cfa_approx, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2250_cfa_approx, shape_approx2248_236_cfa_approx2266, shape_approx2248_236_cfa_approx, 0L, 1);
DEFINE_STRING(string2252_cfa_approx, string2252_cfa_approx2267, "No method for this object", 25);
DEFINE_STATIC_PROCEDURE(node_key_default1872_env_254_cfa_approx, _node_key_default1872_87_cfa_approx2268, _node_key_default1872_87_cfa_approx, 0L, 1);
DEFINE_EXPORT_PROCEDURE(approx_set_type__env_251_cfa_approx, _approx_set_type__245_cfa_approx2269, _approx_set_type__245_cfa_approx, 0L, 2);
DEFINE_EXPORT_PROCEDURE(approx_set_top__env_151_cfa_approx, _approx_set_top__201_cfa_approx2270, _approx_set_top__201_cfa_approx, 0L, 1);
DEFINE_STATIC_PROCEDURE(get_node_atom_value_default1875_env_189_cfa_approx, _get_node_atom_value_default1875_95_cfa_approx2271, _get_node_atom_value_default1875_95_cfa_approx, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_empty_approx_env_91_cfa_approx, _make_empty_approx_139_cfa_approx2272, _make_empty_approx_139_cfa_approx, 0L, 0);
DEFINE_EXPORT_PROCEDURE(union_approx__env_180_cfa_approx, _union_approx__74_cfa_approx2273, _union_approx__74_cfa_approx, 0L, 2);
DEFINE_STATIC_PROCEDURE(node_key_set__default1873_env_36_cfa_approx, _node_key_set__default1873_186_cfa_approx2274, _node_key_set__default1873_186_cfa_approx, 0L, 2);
DEFINE_EXPORT_PROCEDURE(declare_approx_sets__env_104_cfa_approx, _declare_approx_sets__161_cfa_approx2275, _declare_approx_sets__161_cfa_approx, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_type_alloc_approx_env_199_cfa_approx, _make_type_alloc_approx_37_cfa_approx2276, _make_type_alloc_approx_37_cfa_approx, 0L, 2);
extern obj_t shape_env_98_tools_shape;
DEFINE_EXPORT_PROCEDURE(for_each_approx_alloc_env_245_cfa_approx, _for_each_approx_alloc_106_cfa_approx2277, _for_each_approx_alloc_106_cfa_approx, 0L, 2);

obj_t 
module_initialization_70_cfa_approx(long checksum_3462, char *from_3463)
{
   if (CBOOL(require_initialization_114_cfa_approx))
     {
	require_initialization_114_cfa_approx = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_approx();
	cnst_init_137_cfa_approx();
	imported_modules_init_94_cfa_approx();
	toplevel_init_63_cfa_approx();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_approx()
{
   module_initialization_70___object(((long) 0), "CFA_APPROX");
   module_initialization_70___r4_vectors_6_8(((long) 0), "CFA_APPROX");
   module_initialization_70___reader(((long) 0), "CFA_APPROX");
   module_initialization_70___r4_symbols_6_4(((long) 0), "CFA_APPROX");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_approx()
{
   {
      obj_t cnst_port_138_3454;
      cnst_port_138_3454 = open_input_string(string2253_cfa_approx);
      {
	 long i_3455;
	 i_3455 = ((long) 2);
       loop_3456:
	 {
	    bool_t test2254_3457;
	    test2254_3457 = (i_3455 == ((long) -1));
	    if (test2254_3457)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2255_3458;
		    {
		       obj_t list2256_3459;
		       {
			  obj_t arg2257_3460;
			  arg2257_3460 = BNIL;
			  list2256_3459 = MAKE_PAIR(cnst_port_138_3454, arg2257_3460);
		       }
		       arg2255_3458 = read___reader(list2256_3459);
		    }
		    CNST_TABLE_SET(i_3455, arg2255_3458);
		 }
		 {
		    int aux_3461;
		    {
		       long aux_3481;
		       aux_3481 = (i_3455 - ((long) 1));
		       aux_3461 = (int) (aux_3481);
		    }
		    {
		       long i_3484;
		       i_3484 = (long) (aux_3461);
		       i_3455 = i_3484;
		       goto loop_3456;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_approx()
{
   __alloc_set__27_cfa_approx = BUNSPEC;
   add_generic__110___object(node_key_env_229_cfa_approx, node_key_default1872_env_254_cfa_approx);
   add_generic__110___object(node_key_set__env_57_cfa_approx, node_key_set__default1873_env_36_cfa_approx);
   {
      obj_t shape_approx_123_3412;
      shape_approx_123_3412 = proc2250_cfa_approx;
      add_method__1___object(shape_env_98_tools_shape, approx_cfa_info, shape_approx_123_3412);
   }
   add_generic__110___object(get_node_atom_value_env_18_cfa_approx, get_node_atom_value_default1875_env_189_cfa_approx);
   add_inlined_method__244___object(get_node_atom_value_env_18_cfa_approx, atom_ast_node, ((long) 0));
   {
      long aux_3491;
      aux_3491 = add_inlined_method__244___object(get_node_atom_value_env_18_cfa_approx, var_ast_node, ((long) 1));
      return BINT(aux_3491);
   }
}


obj_t 
shape_approx2248_236_cfa_approx(obj_t env_3413, obj_t exp_3414)
{
   {
      approx_t exp_1952;
      exp_1952 = (approx_t) (exp_3414);
      {
	 obj_t type_id_229_1956;
	 {
	    obj_t list1893_1978;
	    {
	       obj_t arg1894_1979;
	       {
		  obj_t aux_3494;
		  {
		     type_t arg1896_1981;
		     arg1896_1981 = (((approx_t) CREF(exp_1952))->type);
		     aux_3494 = (((type_t) CREF(arg1896_1981))->id);
		  }
		  arg1894_1979 = MAKE_PAIR(aux_3494, BNIL);
	       }
	       list1893_1978 = MAKE_PAIR(_4dots_tools_misc, arg1894_1979);
	    }
	    type_id_229_1956 = symbol_append_197___r4_symbols_6_4(list1893_1978);
	 }
	 {
	    obj_t keys_1957;
	    keys_1957 = set__vector_66_cfa_set((((approx_t) CREF(exp_1952))->allocs));
	    {
	       long len_1958;
	       len_1958 = VECTOR_LENGTH(keys_1957);
	       {
		  obj_t struct_116_1960;
		  {
		     long aux_3503;
		     if ((((approx_t) CREF(exp_1952))->top__138))
		       {
			  aux_3503 = (len_1958 + ((long) 1));
		       }
		     else
		       {
			  aux_3503 = len_1958;
		       }
		     struct_116_1960 = make_struct(type_id_229_1956, aux_3503, BUNSPEC);
		  }
		  {
		     if ((((approx_t) CREF(exp_1952))->top__138))
		       {
			  obj_t aux_3510;
			  aux_3510 = CNST_TABLE_REF(((long) 0));
			  STRUCT_SET(struct_116_1960, ((long) 0), aux_3510);
		       }
		     else
		       {
			  BUNSPEC;
		       }
		     {
			long r_1964;
			long w_1965;
			if ((((approx_t) CREF(exp_1952))->top__138))
			  {
			     r_1964 = ((long) 1);
			  }
			else
			  {
			     r_1964 = ((long) 0);
			  }
			w_1965 = ((long) 0);
		      loop_1966:
			if ((w_1965 == len_1958))
			  {
			     return struct_116_1960;
			  }
			else
			  {
			     {
				obj_t arg1885_1971;
				{
				   node_t aux_3515;
				   {
				      obj_t aux_3516;
				      aux_3516 = VECTOR_REF(keys_1957, w_1965);
				      aux_3515 = (node_t) (aux_3516);
				   }
				   arg1885_1971 = node_key_123_cfa_approx(aux_3515);
				}
				STRUCT_SET(struct_116_1960, r_1964, arg1885_1971);
			     }
			     {
				long w_3523;
				long r_3521;
				r_3521 = (r_1964 + ((long) 1));
				w_3523 = (w_1965 + ((long) 1));
				w_1965 = w_3523;
				r_1964 = r_3521;
				goto loop_1966;
			     }
			  }
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
declare_approx_sets__132_cfa_approx()
{
   {
      obj_t arg1898_1984;
      {
	 obj_t arg1899_1985;
	 arg1899_1985 = get_allocs_52_cfa_collect();
	 arg1898_1984 = list__vector_101___r4_vectors_6_8(arg1899_1985);
      }
      return (__alloc_set__27_cfa_approx = declare_set__41_cfa_set(arg1898_1984, node_key_env_229_cfa_approx, node_key_set__env_57_cfa_approx),
	 BUNSPEC);
   }
}


obj_t 
_declare_approx_sets__161_cfa_approx(obj_t env_3431)
{
   return declare_approx_sets__132_cfa_approx();
}


obj_t 
node_key_default1872_127_cfa_approx(node_t node_2)
{
   {
      obj_t arg1902_1988;
      {
	 obj_t arg1904_1989;
	 arg1904_1989 = shape_tools_shape((obj_t) (node_2));
	 {
	    obj_t aux_3534;
	    aux_3534 = (obj_t) (node_2);
	    arg1902_1988 = MAKE_PAIR(aux_3534, arg1904_1989);
	 }
      }
      return internal_error_43_tools_error(string2251_cfa_approx, string2252_cfa_approx, arg1902_1988);
   }
}


obj_t 
_node_key_default1872_87_cfa_approx(obj_t env_3417, obj_t node_3418)
{
   return node_key_default1872_127_cfa_approx((node_t) (node_3418));
}


obj_t 
node_key_123_cfa_approx(node_t node_1)
{
   {
      obj_t method2224_2821;
      obj_t class2229_2822;
      {
	 obj_t arg2230_2819;
	 obj_t arg2231_2820;
	 {
	    object_t obj_2863;
	    obj_2863 = (object_t) (node_1);
	    {
	       obj_t pre_method_105_2864;
	       pre_method_105_2864 = PROCEDURE_REF(node_key_env_229_cfa_approx, ((long) 2));
	       if (INTEGERP(pre_method_105_2864))
		 {
		    PROCEDURE_SET(node_key_env_229_cfa_approx, ((long) 2), BUNSPEC);
		    arg2230_2819 = pre_method_105_2864;
		 }
	       else
		 {
		    long obj_class_num_177_2869;
		    obj_class_num_177_2869 = TYPE(obj_2863);
		    {
		       obj_t arg1183_2870;
		       arg1183_2870 = PROCEDURE_REF(node_key_env_229_cfa_approx, ((long) 1));
		       {
			  long arg1184_2874;
			  {
			     long arg1186_2875;
			     arg1186_2875 = OBJECT_TYPE;
			     arg1184_2874 = (obj_class_num_177_2869 - arg1186_2875);
			  }
			  arg2230_2819 = VECTOR_REF(arg1183_2870, arg1184_2874);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_2880;
	    object_2880 = (object_t) (node_1);
	    {
	       long arg1187_2881;
	       {
		  long arg1188_2882;
		  long arg1189_2883;
		  arg1188_2882 = TYPE(object_2880);
		  arg1189_2883 = OBJECT_TYPE;
		  arg1187_2881 = (arg1188_2882 - arg1189_2883);
	       }
	       {
		  obj_t vector_2887;
		  vector_2887 = __classes__134___object;
		  arg2231_2820 = VECTOR_REF(vector_2887, arg1187_2881);
	       }
	    }
	 }
	 method2224_2821 = arg2230_2819;
	 class2229_2822 = arg2231_2820;
	 if (PROCEDUREP(method2224_2821))
	   {
	      return PROCEDURE_ENTRY(method2224_2821) (method2224_2821, (obj_t) (node_1), BEOA);
	   }
	 else
	   {
	      obj_t fun1905_1990;
	      fun1905_1990 = PROCEDURE_REF(node_key_env_229_cfa_approx, ((long) 0));
	      return PROCEDURE_ENTRY(fun1905_1990) (fun1905_1990, (obj_t) (node_1), BEOA);
	   }
      }
   }
}


obj_t 
_node_key_105_cfa_approx(obj_t env_3415, obj_t node_3416)
{
   return node_key_123_cfa_approx((node_t) (node_3416));
}


obj_t 
node_key_set__default1873_213_cfa_approx(node_t node_5, obj_t key_6)
{
   FAILURE(CNST_TABLE_REF(((long) 1)), string2252_cfa_approx, (obj_t) (node_5));
}


obj_t 
_node_key_set__default1873_186_cfa_approx(obj_t env_3422, obj_t node_3423, obj_t key_3424)
{
   return node_key_set__default1873_213_cfa_approx((node_t) (node_3423), key_3424);
}


obj_t 
node_key_set__195_cfa_approx(node_t node_3, obj_t key_4)
{
   {
      obj_t method2210_2804;
      obj_t class2215_2805;
      {
	 obj_t arg2216_2802;
	 obj_t arg2217_2803;
	 {
	    object_t obj_2896;
	    obj_2896 = (object_t) (node_3);
	    {
	       obj_t pre_method_105_2897;
	       pre_method_105_2897 = PROCEDURE_REF(node_key_set__env_57_cfa_approx, ((long) 2));
	       if (INTEGERP(pre_method_105_2897))
		 {
		    PROCEDURE_SET(node_key_set__env_57_cfa_approx, ((long) 2), BUNSPEC);
		    arg2216_2802 = pre_method_105_2897;
		 }
	       else
		 {
		    long obj_class_num_177_2902;
		    obj_class_num_177_2902 = TYPE(obj_2896);
		    {
		       obj_t arg1183_2903;
		       arg1183_2903 = PROCEDURE_REF(node_key_set__env_57_cfa_approx, ((long) 1));
		       {
			  long arg1184_2907;
			  {
			     long arg1186_2908;
			     arg1186_2908 = OBJECT_TYPE;
			     arg1184_2907 = (obj_class_num_177_2902 - arg1186_2908);
			  }
			  arg2216_2802 = VECTOR_REF(arg1183_2903, arg1184_2907);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_2913;
	    object_2913 = (object_t) (node_3);
	    {
	       long arg1187_2914;
	       {
		  long arg1188_2915;
		  long arg1189_2916;
		  arg1188_2915 = TYPE(object_2913);
		  arg1189_2916 = OBJECT_TYPE;
		  arg1187_2914 = (arg1188_2915 - arg1189_2916);
	       }
	       {
		  obj_t vector_2920;
		  vector_2920 = __classes__134___object;
		  arg2217_2803 = VECTOR_REF(vector_2920, arg1187_2914);
	       }
	    }
	 }
	 method2210_2804 = arg2216_2802;
	 class2215_2805 = arg2217_2803;
	 if (PROCEDUREP(method2210_2804))
	   {
	      return PROCEDURE_ENTRY(method2210_2804) (method2210_2804, (obj_t) (node_3), key_4, BEOA);
	   }
	 else
	   {
	      obj_t fun1908_1993;
	      fun1908_1993 = PROCEDURE_REF(node_key_set__env_57_cfa_approx, ((long) 0));
	      return PROCEDURE_ENTRY(fun1908_1993) (fun1908_1993, (obj_t) (node_3), key_4, BEOA);
	   }
      }
   }
}


obj_t 
_node_key_set__44_cfa_approx(obj_t env_3419, obj_t node_3420, obj_t key_3421)
{
   return node_key_set__195_cfa_approx((node_t) (node_3420), key_3421);
}


approx_t 
union_approx__241_cfa_approx(approx_t dst_7, approx_t src_8)
{
   approx_set_type__239_cfa_approx(dst_7, (((approx_t) CREF(src_8))->type));
   {
      bool_t test1910_1995;
      {
	 bool_t test1911_1996;
	 {
	    obj_t obj2_2927;
	    obj2_2927 = __procedure__226_type_cache;
	    {
	       obj_t aux_3599;
	       {
		  type_t aux_3600;
		  aux_3600 = (((approx_t) CREF(dst_7))->type);
		  aux_3599 = (obj_t) (aux_3600);
	       }
	       test1911_1996 = (aux_3599 == obj2_2927);
	    }
	 }
	 if (test1911_1996)
	   {
	      test1910_1995 = ((bool_t) 1);
	   }
	 else
	   {
	      obj_t obj2_2930;
	      obj2_2930 = _____74_type_cache;
	      {
		 obj_t aux_3605;
		 {
		    type_t aux_3606;
		    aux_3606 = (((approx_t) CREF(dst_7))->type);
		    aux_3605 = (obj_t) (aux_3606);
		 }
		 test1910_1995 = (aux_3605 == obj2_2930);
	      }
	   }
      }
      if (test1910_1995)
	{
	   BUNSPEC;
	}
      else
	{
	   disable_x_t__211_cfa_procedure(src_8);
	}
   }
   if ((((approx_t) CREF(src_8))->top__138))
     {
	approx_set_top__187_cfa_approx(dst_7);
     }
   else
     {
	BUNSPEC;
     }
   {
      bool_t test1915_2000;
      {
	 obj_t arg1916_2001;
	 arg1916_2001 = (((approx_t) CREF(dst_7))->allocs);
	 {
	    obj_t list1918_2003;
	    {
	       obj_t aux_3616;
	       aux_3616 = (((approx_t) CREF(src_8))->allocs);
	       list1918_2003 = MAKE_PAIR(aux_3616, BNIL);
	    }
	    {
	       obj_t aux_3619;
	       aux_3619 = set_union__206_cfa_set(arg1916_2001, list1918_2003);
	       test1915_2000 = CBOOL(aux_3619);
	    }
	 }
      }
      if (test1915_2000)
	{
	   continue_cfa__104_cfa_iterate();
	}
      else
	{
	   BUNSPEC;
	}
   }
   return dst_7;
}


obj_t 
_union_approx__74_cfa_approx(obj_t env_3432, obj_t dst_3433, obj_t src_3434)
{
   {
      approx_t aux_3624;
      aux_3624 = union_approx__241_cfa_approx((approx_t) (dst_3433), (approx_t) (src_3434));
      return (obj_t) (aux_3624);
   }
}


obj_t 
approx_set_type__239_cfa_approx(approx_t dst_9, type_t type_10)
{
   if ((((approx_t) CREF(dst_9))->type_locked__184))
     {
	return BFALSE;
     }
   else
     {
	bool_t test1923_2006;
	{
	   obj_t obj2_2936;
	   obj2_2936 = _____74_type_cache;
	   {
	      obj_t aux_3631;
	      aux_3631 = (obj_t) (type_10);
	      test1923_2006 = (aux_3631 == obj2_2936);
	   }
	}
	if (test1923_2006)
	  {
	     return BFALSE;
	  }
	else
	  {
	     bool_t test_3635;
	     {
		obj_t aux_3640;
		obj_t aux_3636;
		aux_3640 = (obj_t) (type_10);
		{
		   type_t aux_3637;
		   aux_3637 = (((approx_t) CREF(dst_9))->type);
		   aux_3636 = (obj_t) (aux_3637);
		}
		test_3635 = (aux_3636 == aux_3640);
	     }
	     if (test_3635)
	       {
		  return BFALSE;
	       }
	     else
	       {
		  bool_t test1925_2008;
		  {
		     obj_t obj2_2942;
		     obj2_2942 = __obj__252_type_cache;
		     {
			obj_t aux_3643;
			{
			   type_t aux_3644;
			   aux_3644 = (((approx_t) CREF(dst_9))->type);
			   aux_3643 = (obj_t) (aux_3644);
			}
			test1925_2008 = (aux_3643 == obj2_2942);
		     }
		  }
		  if (test1925_2008)
		    {
		       return BFALSE;
		    }
		  else
		    {
		       bool_t test1926_2009;
		       {
			  obj_t obj2_2945;
			  obj2_2945 = _____74_type_cache;
			  {
			     obj_t aux_3649;
			     {
				type_t aux_3650;
				aux_3650 = (((approx_t) CREF(dst_9))->type);
				aux_3649 = (obj_t) (aux_3650);
			     }
			     test1926_2009 = (aux_3649 == obj2_2945);
			  }
		       }
		       if (test1926_2009)
			 {
			    {
			       obj_t res2240_2948;
			       {
				  obj_t x_3451;
				  x_3451 = ((((approx_t) CREF(dst_9))->type) = ((type_t) type_10), BUNSPEC);
				  res2240_2948 = BUNSPEC;
			       }
			       res2240_2948;
			    }
			    return continue_cfa__104_cfa_iterate();
			 }
		       else
			 {
			    {
			       obj_t res2241_2951;
			       {
				  type_t val1324_2950;
				  val1324_2950 = (type_t) (__obj__252_type_cache);
				  {
				     obj_t x_3452;
				     x_3452 = ((((approx_t) CREF(dst_9))->type) = ((type_t) val1324_2950), BUNSPEC);
				     res2241_2951 = BUNSPEC;
				  }
			       }
			       res2241_2951;
			    }
			    return continue_cfa__104_cfa_iterate();
			 }
		    }
	       }
	  }
     }
}


obj_t 
_approx_set_type__245_cfa_approx(obj_t env_3435, obj_t dst_3436, obj_t type_3437)
{
   return approx_set_type__239_cfa_approx((approx_t) (dst_3436), (type_t) (type_3437));
}


obj_t 
approx_set_top__187_cfa_approx(approx_t dst_11)
{
   if ((((approx_t) CREF(dst_11))->top__138))
     {
	return BUNSPEC;
     }
   else
     {
	{
	   obj_t res2242_2955;
	   {
	      obj_t x_3453;
	      x_3453 = ((((approx_t) CREF(dst_11))->top__138) = ((bool_t) ((bool_t) 1)), BUNSPEC);
	      res2242_2955 = BUNSPEC;
	   }
	   res2242_2955;
	}
	return continue_cfa__104_cfa_iterate();
     }
}


obj_t 
_approx_set_top__201_cfa_approx(obj_t env_3438, obj_t dst_3439)
{
   return approx_set_top__187_cfa_approx((approx_t) (dst_3439));
}


approx_t 
make_empty_approx_131_cfa_approx()
{
   {
      obj_t allocs_2014;
      allocs_2014 = make_set__25_cfa_set(__alloc_set__27_cfa_approx);
      {
	 approx_t res2243_2970;
	 {
	    type_t type_2956;
	    type_2956 = (type_t) (_____74_type_cache);
	    {
	       approx_t new1322_2961;
	       new1322_2961 = ((approx_t) BREF(GC_MALLOC(sizeof(struct approx))));
	       {
		  long arg2111_2962;
		  arg2111_2962 = class_num_218___object(approx_cfa_info);
		  {
		     obj_t obj_2968;
		     obj_2968 = (obj_t) (new1322_2961);
		     (((obj_t) CREF(obj_2968))->header = MAKE_HEADER(arg2111_2962, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_3675;
		  aux_3675 = (object_t) (new1322_2961);
		  OBJECT_WIDENING_SET(aux_3675, BFALSE);
	       }
	       ((((approx_t) CREF(new1322_2961))->type) = ((type_t) type_2956), BUNSPEC);
	       ((((approx_t) CREF(new1322_2961))->type_locked__184) = ((bool_t) ((bool_t) 0)), BUNSPEC);
	       ((((approx_t) CREF(new1322_2961))->allocs) = ((obj_t) allocs_2014), BUNSPEC);
	       ((((approx_t) CREF(new1322_2961))->top__138) = ((bool_t) ((bool_t) 0)), BUNSPEC);
	       ((((approx_t) CREF(new1322_2961))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
	       res2243_2970 = new1322_2961;
	    }
	 }
	 return res2243_2970;
      }
   }
}


obj_t 
_make_empty_approx_139_cfa_approx(obj_t env_3440)
{
   {
      approx_t aux_3683;
      aux_3683 = make_empty_approx_131_cfa_approx();
      return (obj_t) (aux_3683);
   }
}


approx_t 
make_type_approx_184_cfa_approx(type_t type_12)
{
   {
      obj_t allocs_2015;
      allocs_2015 = make_set__25_cfa_set(__alloc_set__27_cfa_approx);
      {
	 bool_t arg1931_2016;
	 {
	    bool_t test1933_2018;
	    {
	       obj_t obj2_2972;
	       obj2_2972 = _____74_type_cache;
	       {
		  obj_t aux_3687;
		  aux_3687 = (obj_t) (type_12);
		  test1933_2018 = (aux_3687 == obj2_2972);
	       }
	    }
	    if (test1933_2018)
	      {
		 arg1931_2016 = ((bool_t) 0);
	      }
	    else
	      {
		 arg1931_2016 = ((bool_t) 1);
	      }
	 }
	 {
	    approx_t res2244_2987;
	    {
	       approx_t new1322_2978;
	       new1322_2978 = ((approx_t) BREF(GC_MALLOC(sizeof(struct approx))));
	       {
		  long arg2111_2979;
		  arg2111_2979 = class_num_218___object(approx_cfa_info);
		  {
		     obj_t obj_2985;
		     obj_2985 = (obj_t) (new1322_2978);
		     (((obj_t) CREF(obj_2985))->header = MAKE_HEADER(arg2111_2979, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_3695;
		  aux_3695 = (object_t) (new1322_2978);
		  OBJECT_WIDENING_SET(aux_3695, BFALSE);
	       }
	       ((((approx_t) CREF(new1322_2978))->type) = ((type_t) type_12), BUNSPEC);
	       ((((approx_t) CREF(new1322_2978))->type_locked__184) = ((bool_t) arg1931_2016), BUNSPEC);
	       ((((approx_t) CREF(new1322_2978))->allocs) = ((obj_t) allocs_2015), BUNSPEC);
	       ((((approx_t) CREF(new1322_2978))->top__138) = ((bool_t) ((bool_t) 0)), BUNSPEC);
	       ((((approx_t) CREF(new1322_2978))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
	       res2244_2987 = new1322_2978;
	    }
	    return res2244_2987;
	 }
      }
   }
}


obj_t 
_make_type_approx_211_cfa_approx(obj_t env_3441, obj_t type_3442)
{
   {
      approx_t aux_3703;
      aux_3703 = make_type_approx_184_cfa_approx((type_t) (type_3442));
      return (obj_t) (aux_3703);
   }
}


approx_t 
make_alloc_approx_89_cfa_approx(app_t alloc_13)
{
   {
      obj_t allocs_2019;
      allocs_2019 = make_set__25_cfa_set(__alloc_set__27_cfa_approx);
      set_extend__187_cfa_set(allocs_2019, (obj_t) (alloc_13));
      {
	 approx_t res2245_3002;
	 {
	    type_t type_2988;
	    type_2988 = (type_t) (type_type_type);
	    {
	       approx_t new1322_2993;
	       new1322_2993 = ((approx_t) BREF(GC_MALLOC(sizeof(struct approx))));
	       {
		  long arg2111_2994;
		  arg2111_2994 = class_num_218___object(approx_cfa_info);
		  {
		     obj_t obj_3000;
		     obj_3000 = (obj_t) (new1322_2993);
		     (((obj_t) CREF(obj_3000))->header = MAKE_HEADER(arg2111_2994, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_3715;
		  aux_3715 = (object_t) (new1322_2993);
		  OBJECT_WIDENING_SET(aux_3715, BFALSE);
	       }
	       ((((approx_t) CREF(new1322_2993))->type) = ((type_t) type_2988), BUNSPEC);
	       ((((approx_t) CREF(new1322_2993))->type_locked__184) = ((bool_t) ((bool_t) 0)), BUNSPEC);
	       ((((approx_t) CREF(new1322_2993))->allocs) = ((obj_t) allocs_2019), BUNSPEC);
	       ((((approx_t) CREF(new1322_2993))->top__138) = ((bool_t) ((bool_t) 0)), BUNSPEC);
	       ((((approx_t) CREF(new1322_2993))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
	       res2245_3002 = new1322_2993;
	    }
	 }
	 return res2245_3002;
      }
   }
}


obj_t 
_make_alloc_approx_59_cfa_approx(obj_t env_3443, obj_t alloc_3444)
{
   {
      approx_t aux_3723;
      aux_3723 = make_alloc_approx_89_cfa_approx((app_t) (alloc_3444));
      return (obj_t) (aux_3723);
   }
}


approx_t 
make_type_alloc_approx_134_cfa_approx(type_t type_14, node_t alloc_15)
{
   {
      obj_t allocs_2020;
      allocs_2020 = make_set__25_cfa_set(__alloc_set__27_cfa_approx);
      set_extend__187_cfa_set(allocs_2020, (obj_t) (alloc_15));
      {
	 bool_t arg1934_2021;
	 {
	    bool_t test1936_2023;
	    {
	       obj_t obj2_3004;
	       obj2_3004 = _____74_type_cache;
	       {
		  obj_t aux_3730;
		  aux_3730 = (obj_t) (type_14);
		  test1936_2023 = (aux_3730 == obj2_3004);
	       }
	    }
	    if (test1936_2023)
	      {
		 arg1934_2021 = ((bool_t) 0);
	      }
	    else
	      {
		 arg1934_2021 = ((bool_t) 1);
	      }
	 }
	 {
	    approx_t res2246_3019;
	    {
	       approx_t new1322_3010;
	       new1322_3010 = ((approx_t) BREF(GC_MALLOC(sizeof(struct approx))));
	       {
		  long arg2111_3011;
		  arg2111_3011 = class_num_218___object(approx_cfa_info);
		  {
		     obj_t obj_3017;
		     obj_3017 = (obj_t) (new1322_3010);
		     (((obj_t) CREF(obj_3017))->header = MAKE_HEADER(arg2111_3011, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_3738;
		  aux_3738 = (object_t) (new1322_3010);
		  OBJECT_WIDENING_SET(aux_3738, BFALSE);
	       }
	       ((((approx_t) CREF(new1322_3010))->type) = ((type_t) type_14), BUNSPEC);
	       ((((approx_t) CREF(new1322_3010))->type_locked__184) = ((bool_t) arg1934_2021), BUNSPEC);
	       ((((approx_t) CREF(new1322_3010))->allocs) = ((obj_t) allocs_2020), BUNSPEC);
	       ((((approx_t) CREF(new1322_3010))->top__138) = ((bool_t) ((bool_t) 0)), BUNSPEC);
	       ((((approx_t) CREF(new1322_3010))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
	       res2246_3019 = new1322_3010;
	    }
	    return res2246_3019;
	 }
      }
   }
}


obj_t 
_make_type_alloc_approx_37_cfa_approx(obj_t env_3445, obj_t type_3446, obj_t alloc_3447)
{
   {
      approx_t aux_3746;
      aux_3746 = make_type_alloc_approx_134_cfa_approx((type_t) (type_3446), (node_t) (alloc_3447));
      return (obj_t) (aux_3746);
   }
}


obj_t 
for_each_approx_alloc_83_cfa_approx(obj_t proc_17, approx_t approx_18)
{
   return set_for_each_94_cfa_set(proc_17, (((approx_t) CREF(approx_18))->allocs));
}


obj_t 
_for_each_approx_alloc_106_cfa_approx(obj_t env_3448, obj_t proc_3449, obj_t approx_3450)
{
   return for_each_approx_alloc_83_cfa_approx(proc_3449, (approx_t) (approx_3450));
}


obj_t 
get_node_atom_value_default1875_100_cfa_approx(node_t node_20)
{
   return CNST_TABLE_REF(((long) 2));
}


obj_t 
_get_node_atom_value_default1875_95_cfa_approx(obj_t env_3429, obj_t node_3430)
{
   return get_node_atom_value_default1875_100_cfa_approx((node_t) (node_3430));
}


obj_t 
get_node_atom_value_135_cfa_approx(node_t node_19)
{
 get_node_atom_value_135_cfa_approx:
   {
      obj_t method2188_2778;
      obj_t class2193_2779;
      {
	 obj_t arg2196_2776;
	 obj_t arg2197_2777;
	 {
	    object_t obj_3023;
	    obj_3023 = (object_t) (node_19);
	    {
	       obj_t pre_method_105_3024;
	       pre_method_105_3024 = PROCEDURE_REF(get_node_atom_value_env_18_cfa_approx, ((long) 2));
	       if (INTEGERP(pre_method_105_3024))
		 {
		    PROCEDURE_SET(get_node_atom_value_env_18_cfa_approx, ((long) 2), BUNSPEC);
		    arg2196_2776 = pre_method_105_3024;
		 }
	       else
		 {
		    long obj_class_num_177_3029;
		    obj_class_num_177_3029 = TYPE(obj_3023);
		    {
		       obj_t arg1183_3030;
		       arg1183_3030 = PROCEDURE_REF(get_node_atom_value_env_18_cfa_approx, ((long) 1));
		       {
			  long arg1184_3034;
			  {
			     long arg1186_3035;
			     arg1186_3035 = OBJECT_TYPE;
			     arg1184_3034 = (obj_class_num_177_3029 - arg1186_3035);
			  }
			  arg2196_2776 = VECTOR_REF(arg1183_3030, arg1184_3034);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_3040;
	    object_3040 = (object_t) (node_19);
	    {
	       long arg1187_3041;
	       {
		  long arg1188_3042;
		  long arg1189_3043;
		  arg1188_3042 = TYPE(object_3040);
		  arg1189_3043 = OBJECT_TYPE;
		  arg1187_3041 = (arg1188_3042 - arg1189_3043);
	       }
	       {
		  obj_t vector_3047;
		  vector_3047 = __classes__134___object;
		  arg2197_2777 = VECTOR_REF(vector_3047, arg1187_3041);
	       }
	    }
	 }
	 method2188_2778 = arg2196_2776;
	 class2193_2779 = arg2197_2777;
	 {
	    if (INTEGERP(method2188_2778))
	      {
		 switch ((long) CINT(method2188_2778))
		   {
		   case ((long) 0):
		      {
			 atom_t node_2785;
			 node_2785 = (atom_t) (node_19);
			 return (((atom_t) CREF(node_2785))->value);
		      }
		      break;
		   case ((long) 1):
		      {
			 var_t node_2786;
			 node_2786 = (var_t) (node_19);
			 {
			    variable_t v_2787;
			    v_2787 = (((var_t) CREF(node_2786))->variable);
			    {
			       bool_t test2200_2788;
			       {
				  bool_t test2202_2790;
				  test2202_2790 = is_a__118___object((obj_t) (v_2787), reshaped_local_224_cfa_info);
				  if (test2202_2790)
				    {
				       obj_t aux_3782;
				       {
					  reshaped_local_224_t obj_3052;
					  obj_3052 = (reshaped_local_224_t) (v_2787);
					  {
					     obj_t aux_3784;
					     {
						object_t aux_3785;
						aux_3785 = (object_t) (obj_3052);
						aux_3784 = OBJECT_WIDENING(aux_3785);
					     }
					     aux_3782 = (((reshaped_local_224_t) CREF(aux_3784))->binding_value_3);
					  }
				       }
				       test2200_2788 = is_a__118___object(aux_3782, node_ast_node);
				    }
				  else
				    {
				       test2200_2788 = ((bool_t) 0);
				    }
			       }
			       if (test2200_2788)
				 {
				    node_t node_3791;
				    {
				       obj_t aux_3792;
				       {
					  reshaped_local_224_t obj_3054;
					  obj_3054 = (reshaped_local_224_t) (v_2787);
					  {
					     obj_t aux_3794;
					     {
						object_t aux_3795;
						aux_3795 = (object_t) (obj_3054);
						aux_3794 = OBJECT_WIDENING(aux_3795);
					     }
					     aux_3792 = (((reshaped_local_224_t) CREF(aux_3794))->binding_value_3);
					  }
				       }
				       node_3791 = (node_t) (aux_3792);
				    }
				    node_19 = node_3791;
				    goto get_node_atom_value_135_cfa_approx;
				 }
			       else
				 {
				    return CNST_TABLE_REF(((long) 2));
				 }
			    }
			 }
		      }
		      break;
		   default:
		    case_else2194_23_2782:
		      if (PROCEDUREP(method2188_2778))
			{
			   return PROCEDURE_ENTRY(method2188_2778) (method2188_2778, (obj_t) (node_19), BEOA);
			}
		      else
			{
			   obj_t fun1938_2026;
			   fun1938_2026 = PROCEDURE_REF(get_node_atom_value_env_18_cfa_approx, ((long) 0));
			   return PROCEDURE_ENTRY(fun1938_2026) (fun1938_2026, (obj_t) (node_19), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else2194_23_2782;
	      }
	 }
      }
   }
}


obj_t 
_get_node_atom_value_97_cfa_approx(obj_t env_3427, obj_t node_3428)
{
   return get_node_atom_value_135_cfa_approx((node_t) (node_3428));
}


obj_t 
imported_modules_init_94_cfa_approx()
{
   module_initialization_70_type_type(((long) 0), "CFA_APPROX");
   module_initialization_70_type_cache(((long) 0), "CFA_APPROX");
   module_initialization_70_tools_shape(((long) 0), "CFA_APPROX");
   module_initialization_70_tools_error(((long) 0), "CFA_APPROX");
   module_initialization_70_tools_misc(((long) 0), "CFA_APPROX");
   module_initialization_70_ast_var(((long) 0), "CFA_APPROX");
   module_initialization_70_ast_node(((long) 0), "CFA_APPROX");
   module_initialization_70_cfa_info(((long) 0), "CFA_APPROX");
   module_initialization_70_cfa_collect(((long) 0), "CFA_APPROX");
   module_initialization_70_cfa_set(((long) 0), "CFA_APPROX");
   module_initialization_70_cfa_iterate(((long) 0), "CFA_APPROX");
   module_initialization_70_cfa_loose(((long) 0), "CFA_APPROX");
   return module_initialization_70_cfa_procedure(((long) 0), "CFA_APPROX");
}
