/*===========================================================================*/
/*   (Cfa/box.scm)                                                           */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


static obj_t cfa__box_ref_o_cinfo2250_246_cfa_box(obj_t, obj_t);
extern obj_t _stack_loose_alloc__18_cfa_loose(obj_t, obj_t, obj_t);
extern obj_t _node_setup__114_cfa_setup(obj_t, obj_t);
static obj_t node_key_make_box_o_cinfo2243_117_cfa_box(obj_t, obj_t);
extern obj_t node_setup__189_cfa_setup(node_t);
extern approx_t loose__226_cfa_loose(approx_t, obj_t);
extern obj_t _cfa__186_cfa_cfa(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t loose_alloc__make_box2247_15_cfa_box(obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t box_ref_o_cinfo_98_cfa_info;
static obj_t imported_modules_init_94_cfa_box();
extern obj_t module_initialization_70_cfa_box(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_setup(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_closure(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_cfa_box();
static obj_t node_key_pre_make_box2245_175_cfa_box(obj_t, obj_t);
static obj_t cnst_init_137_cfa_box();
extern obj_t __optim__89_engine_param;
static obj_t node_key_set__pre_make_box2244_8_cfa_box(obj_t, obj_t, obj_t);
static obj_t stack_loose_alloc__make_box2246_32_cfa_box(obj_t, obj_t, obj_t);
static obj_t node_setup__box_set_2254_202_cfa_box(obj_t, obj_t);
extern obj_t _node_key_105_cfa_approx(obj_t, obj_t);
extern obj_t _loose_alloc__239_cfa_loose(obj_t, obj_t);
static obj_t require_initialization_114_cfa_box = BUNSPEC;
extern approx_t make_empty_approx_131_cfa_approx();
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cfa_box();
extern obj_t make_box_cinfo_127_cfa_info;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t box_set__cinfo_94_cfa_info;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t open_input_string(obj_t);
static obj_t cfa__make_box_o_cinfo2252_47_cfa_box(obj_t, obj_t);
extern obj_t make_box_o_cinfo_96_cfa_info;
extern obj_t __unspec__87_type_cache;
extern obj_t pre_make_box_186_cfa_info;
extern obj_t class_super_145___object(obj_t);
extern long class_num_218___object(obj_t);
static obj_t node_setup__pre_make_box2255_68_cfa_box(obj_t, obj_t);
extern approx_t union_approx__241_cfa_approx(approx_t, approx_t);
extern approx_t cfa__102_cfa_cfa(node_t);
extern approx_t make_type_alloc_approx_134_cfa_approx(type_t, node_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t _node_key_set__44_cfa_approx(obj_t, obj_t, obj_t);
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern approx_t make_type_approx_184_cfa_approx(type_t);
static obj_t node_setup__make_box2256_173_cfa_box(obj_t, obj_t);
static obj_t node_setup__box_ref2253_147_cfa_box(obj_t, obj_t);
static obj_t arg19602251_cfa_box(obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static obj_t arg19732249_cfa_box(obj_t, obj_t);
extern obj_t approx_set_top__187_cfa_approx(approx_t);
extern obj_t box_ref_242_ast_node;
static obj_t cfa__box_set__o_cinfo2248_137_cfa_box(obj_t, obj_t);
extern obj_t box_set__o_cinfo_6_cfa_info;
extern obj_t __obj__252_type_cache;
extern obj_t make_box_202_ast_node;
extern obj_t box_ref_cinfo_214_cfa_info;
static obj_t __cnst[2];

extern obj_t cfa__env_153_cfa_cfa;
DEFINE_STATIC_PROCEDURE(proc2266_cfa_box, node_setup__pre_make_box2255_68_cfa_box2287, node_setup__pre_make_box2255_68_cfa_box, 0L, 1);
DEFINE_STRING(string2278_cfa_box, string2278_cfa_box2288, "Illegal mixed of optimized and unoptimize `make-box'", 52);
DEFINE_STRING(string2277_cfa_box, string2277_cfa_box2289, "box-ref", 7);
DEFINE_STATIC_PROCEDURE(proc2268_cfa_box, node_setup__box_ref2253_147_cfa_box2290, node_setup__box_ref2253_147_cfa_box, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2267_cfa_box, node_setup__box_set_2254_202_cfa_box2291, node_setup__box_set_2254_202_cfa_box, 0L, 1);
extern obj_t node_key_set__env_57_cfa_approx;
extern obj_t node_key_env_229_cfa_approx;
DEFINE_STATIC_PROCEDURE(proc2274_cfa_box, node_key_pre_make_box2245_175_cfa_box2292, node_key_pre_make_box2245_175_cfa_box, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2275_cfa_box, node_key_set__pre_make_box2244_8_cfa_box2293, node_key_set__pre_make_box2244_8_cfa_box, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2270_cfa_box, cfa__box_ref_o_cinfo2250_246_cfa_box2294, cfa__box_ref_o_cinfo2250_246_cfa_box, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2276_cfa_box, node_key_make_box_o_cinfo2243_117_cfa_box2295, node_key_make_box_o_cinfo2243_117_cfa_box, 0L, 1);
extern obj_t node_setup__env_214_cfa_setup;
DEFINE_STATIC_PROCEDURE(proc2269_cfa_box, cfa__make_box_o_cinfo2252_47_cfa_box2296, cfa__make_box_o_cinfo2252_47_cfa_box, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2265_cfa_box, node_setup__make_box2256_173_cfa_box2297, node_setup__make_box2256_173_cfa_box, 0L, 1);
DEFINE_STRING(string2279_cfa_box, string2279_cfa_box2298, "cfa!(make-box/O-cinfo): ", 24);
extern obj_t loose_alloc__env_83_cfa_loose;
DEFINE_STATIC_PROCEDURE(proc2271_cfa_box, cfa__box_set__o_cinfo2248_137_cfa_box2299, cfa__box_set__o_cinfo2248_137_cfa_box, 0L, 1);
extern obj_t stack_loose_alloc__env_147_cfa_loose;
DEFINE_STATIC_PROCEDURE(proc2273_cfa_box, stack_loose_alloc__make_box2246_32_cfa_box2300, stack_loose_alloc__make_box2246_32_cfa_box, 0L, 2);
DEFINE_STRING(string2280_cfa_box, string2280_cfa_box2301, "CFA ALL ", 8);
DEFINE_STATIC_PROCEDURE(proc2272_cfa_box, loose_alloc__make_box2247_15_cfa_box2302, loose_alloc__make_box2247_15_cfa_box, 0L, 1);

obj_t 
module_initialization_70_cfa_box(long checksum_3359, char *from_3360)
{
   if (CBOOL(require_initialization_114_cfa_box))
     {
	require_initialization_114_cfa_box = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_box();
	cnst_init_137_cfa_box();
	imported_modules_init_94_cfa_box();
	toplevel_init_63_cfa_box();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_box()
{
   module_initialization_70___object(((long) 0), "CFA_BOX");
   module_initialization_70___reader(((long) 0), "CFA_BOX");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_box()
{
   {
      obj_t cnst_port_138_3351;
      cnst_port_138_3351 = open_input_string(string2280_cfa_box);
      {
	 long i_3352;
	 i_3352 = ((long) 1);
       loop_3353:
	 {
	    bool_t test2281_3354;
	    test2281_3354 = (i_3352 == ((long) -1));
	    if (test2281_3354)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2283_3355;
		    {
		       obj_t list2284_3356;
		       {
			  obj_t arg2285_3357;
			  arg2285_3357 = BNIL;
			  list2284_3356 = MAKE_PAIR(cnst_port_138_3351, arg2285_3357);
		       }
		       arg2283_3355 = read___reader(list2284_3356);
		    }
		    CNST_TABLE_SET(i_3352, arg2283_3355);
		 }
		 {
		    int aux_3358;
		    {
		       long aux_3376;
		       aux_3376 = (i_3352 - ((long) 1));
		       aux_3358 = (int) (aux_3376);
		    }
		    {
		       long i_3379;
		       i_3379 = (long) (aux_3358);
		       i_3352 = i_3379;
		       goto loop_3353;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_box()
{
   {
      obj_t node_setup__make_box_254_3300;
      node_setup__make_box_254_3300 = proc2265_cfa_box;
      add_method__1___object(node_setup__env_214_cfa_setup, make_box_202_ast_node, node_setup__make_box_254_3300);
   }
   {
      obj_t node_setup__pre_make_box_50_3299;
      node_setup__pre_make_box_50_3299 = proc2266_cfa_box;
      add_method__1___object(node_setup__env_214_cfa_setup, pre_make_box_186_cfa_info, node_setup__pre_make_box_50_3299);
   }
   {
      obj_t node_setup__box_set__65_3298;
      node_setup__box_set__65_3298 = proc2267_cfa_box;
      add_method__1___object(node_setup__env_214_cfa_setup, box_set__221_ast_node, node_setup__box_set__65_3298);
   }
   {
      obj_t node_setup__box_ref_19_3297;
      node_setup__box_ref_19_3297 = proc2268_cfa_box;
      add_method__1___object(node_setup__env_214_cfa_setup, box_ref_242_ast_node, node_setup__box_ref_19_3297);
   }
   {
      obj_t cfa__make_box_o_cinfo_123_3296;
      cfa__make_box_o_cinfo_123_3296 = proc2269_cfa_box;
      add_method__1___object(cfa__env_153_cfa_cfa, make_box_o_cinfo_96_cfa_info, cfa__make_box_o_cinfo_123_3296);
   }
   {
      obj_t cfa__box_ref_o_cinfo_85_3295;
      cfa__box_ref_o_cinfo_85_3295 = proc2270_cfa_box;
      add_method__1___object(cfa__env_153_cfa_cfa, box_ref_o_cinfo_98_cfa_info, cfa__box_ref_o_cinfo_85_3295);
   }
   {
      obj_t cfa__box_set__o_cinfo_199_3293;
      cfa__box_set__o_cinfo_199_3293 = proc2271_cfa_box;
      add_method__1___object(cfa__env_153_cfa_cfa, box_set__o_cinfo_6_cfa_info, cfa__box_set__o_cinfo_199_3293);
   }
   {
      obj_t loose_alloc__make_box_109_3291;
      loose_alloc__make_box_109_3291 = proc2272_cfa_box;
      add_method__1___object(loose_alloc__env_83_cfa_loose, make_box_202_ast_node, loose_alloc__make_box_109_3291);
   }
   {
      obj_t stack_loose_alloc__make_box_48_3290;
      stack_loose_alloc__make_box_48_3290 = proc2273_cfa_box;
      add_method__1___object(stack_loose_alloc__env_147_cfa_loose, make_box_202_ast_node, stack_loose_alloc__make_box_48_3290);
   }
   {
      obj_t node_key_pre_make_box_112_3289;
      node_key_pre_make_box_112_3289 = proc2274_cfa_box;
      add_method__1___object(node_key_env_229_cfa_approx, pre_make_box_186_cfa_info, node_key_pre_make_box_112_3289);
   }
   {
      obj_t node_key_set__pre_make_box_2_3288;
      node_key_set__pre_make_box_2_3288 = proc2275_cfa_box;
      add_method__1___object(node_key_set__env_57_cfa_approx, pre_make_box_186_cfa_info, node_key_set__pre_make_box_2_3288);
   }
   {
      obj_t node_key_make_box_o_cinfo_150_3287;
      node_key_make_box_o_cinfo_150_3287 = proc2276_cfa_box;
      return add_method__1___object(node_key_env_229_cfa_approx, make_box_o_cinfo_96_cfa_info, node_key_make_box_o_cinfo_150_3287);
   }
}


obj_t 
node_key_make_box_o_cinfo2243_117_cfa_box(obj_t env_3301, obj_t node_3302)
{
   {
      make_box_o_cinfo_96_t node_2096;
      node_2096 = (make_box_o_cinfo_96_t) (node_3302);
      {
	 obj_t aux_3393;
	 {
	    object_t aux_3394;
	    aux_3394 = (object_t) (node_2096);
	    aux_3393 = OBJECT_WIDENING(aux_3394);
	 }
	 return (((make_box_o_cinfo_96_t) CREF(aux_3393))->key);
      }
   }
}


obj_t 
node_key_set__pre_make_box2244_8_cfa_box(obj_t env_3303, obj_t node_3304, obj_t new_key_72_3305)
{
   {
      pre_make_box_186_t node_2089;
      obj_t new_key_72_2090;
      node_2089 = (pre_make_box_186_t) (node_3304);
      new_key_72_2090 = new_key_72_3305;
      {
	 obj_t res2242_2938;
	 {
	    obj_t x_3349;
	    {
	       obj_t aux_3399;
	       {
		  object_t aux_3400;
		  aux_3400 = (object_t) (node_2089);
		  aux_3399 = OBJECT_WIDENING(aux_3400);
	       }
	       x_3349 = ((((pre_make_box_186_t) CREF(aux_3399))->key) = ((obj_t) new_key_72_2090), BUNSPEC);
	    }
	    res2242_2938 = BUNSPEC;
	 }
	 return res2242_2938;
      }
   }
}


obj_t 
node_key_pre_make_box2245_175_cfa_box(obj_t env_3306, obj_t node_3307)
{
   {
      pre_make_box_186_t node_2083;
      node_2083 = (pre_make_box_186_t) (node_3307);
      {
	 obj_t aux_3405;
	 {
	    object_t aux_3406;
	    aux_3406 = (object_t) (node_2083);
	    aux_3405 = OBJECT_WIDENING(aux_3406);
	 }
	 return (((pre_make_box_186_t) CREF(aux_3405))->key);
      }
   }
}


obj_t 
stack_loose_alloc__make_box2246_32_cfa_box(obj_t env_3308, obj_t alloc_3309, obj_t cowner_3310)
{
   {
      make_box_202_t alloc_2077;
      obj_t cowner_2078;
      alloc_2077 = (make_box_202_t) (alloc_3309);
      cowner_2078 = cowner_3310;
      return BUNSPEC;
   }
}


obj_t 
loose_alloc__make_box2247_15_cfa_box(obj_t env_3311, obj_t alloc_3312)
{
   {
      make_box_202_t alloc_2072;
      alloc_2072 = (make_box_202_t) (alloc_3312);
      return BUNSPEC;
   }
}


obj_t 
cfa__box_set__o_cinfo2248_137_cfa_box(obj_t env_3313, obj_t node_3314)
{
   {
      box_set__o_cinfo_6_t node_2049;
      {
	 approx_t aux_3413;
	 node_2049 = (box_set__o_cinfo_6_t) (node_3314);
	 {
	    approx_t box_approx_152_2053;
	    approx_t val_approx_22_2054;
	    {
	       node_t aux_3414;
	       {
		  var_t aux_3415;
		  {
		     box_set__221_t obj_2926;
		     obj_2926 = (box_set__221_t) (node_2049);
		     aux_3415 = (((box_set__221_t) CREF(obj_2926))->var);
		  }
		  aux_3414 = (node_t) (aux_3415);
	       }
	       box_approx_152_2053 = cfa__102_cfa_cfa(aux_3414);
	    }
	    {
	       node_t aux_3420;
	       {
		  box_set__221_t obj_2927;
		  obj_2927 = (box_set__221_t) (node_2049);
		  aux_3420 = (((box_set__221_t) CREF(obj_2927))->value);
	       }
	       val_approx_22_2054 = cfa__102_cfa_cfa(aux_3420);
	    }
	    if ((((approx_t) CREF(box_approx_152_2053))->top__138))
	      {
		 approx_t aux_3426;
		 aux_3426 = loose__226_cfa_loose(val_approx_22_2054, CNST_TABLE_REF(((long) 0)));
		 (obj_t) (aux_3426);
	      }
	    else
	      {
		 obj_t arg1973_3292;
		 arg1973_3292 = make_fx_procedure(arg19732249_cfa_box, ((long) 1), ((long) 2));
		 {
		    obj_t aux_3431;
		    aux_3431 = (obj_t) (node_2049);
		    PROCEDURE_SET(arg1973_3292, ((long) 0), aux_3431);
		 }
		 {
		    obj_t aux_3434;
		    aux_3434 = (obj_t) (val_approx_22_2054);
		    PROCEDURE_SET(arg1973_3292, ((long) 1), aux_3434);
		 }
		 for_each_approx_alloc_83_cfa_approx(arg1973_3292, box_approx_152_2053);
	      }
	 }
	 {
	    obj_t aux_3438;
	    {
	       object_t aux_3439;
	       aux_3439 = (object_t) (node_2049);
	       aux_3438 = OBJECT_WIDENING(aux_3439);
	    }
	    aux_3413 = (((box_set__o_cinfo_6_t) CREF(aux_3438))->approx);
	 }
	 return (obj_t) (aux_3413);
      }
   }
}


obj_t 
arg19732249_cfa_box(obj_t env_3315, obj_t box_3318)
{
   {
      obj_t node_3316;
      obj_t val_approx_22_3317;
      node_3316 = PROCEDURE_REF(env_3315, ((long) 0));
      val_approx_22_3317 = PROCEDURE_REF(env_3315, ((long) 1));
      {
	 obj_t box_2058;
	 box_2058 = box_3318;
	 {
	    bool_t test1975_2060;
	    test1975_2060 = is_a__118___object(box_2058, make_box_o_cinfo_96_cfa_info);
	    if (test1975_2060)
	      {
		 {
		    approx_t aux_3449;
		    {
		       approx_t aux_3450;
		       {
			  make_box_o_cinfo_96_t obj_2930;
			  obj_2930 = (make_box_o_cinfo_96_t) (box_2058);
			  {
			     obj_t aux_3452;
			     {
				object_t aux_3453;
				aux_3453 = (object_t) (obj_2930);
				aux_3452 = OBJECT_WIDENING(aux_3453);
			     }
			     aux_3450 = (((make_box_o_cinfo_96_t) CREF(aux_3452))->value_approx_19);
			  }
		       }
		       aux_3449 = union_approx__241_cfa_approx(aux_3450, (approx_t) (val_approx_22_3317));
		    }
		    return (obj_t) (aux_3449);
		 }
	      }
	    else
	      {
		 bool_t test1977_2063;
		 test1977_2063 = is_a__118___object(box_2058, make_box_cinfo_127_cfa_info);
		 if (test1977_2063)
		   {
		      {
			 obj_t arg1980_2066;
			 arg1980_2066 = shape_tools_shape(node_3316);
			 return internal_error_43_tools_error(string2277_cfa_box, string2278_cfa_box, arg1980_2066);
		      }
		   }
		 else
		   {
		      return BFALSE;
		   }
	      }
	 }
      }
   }
}


obj_t 
cfa__box_ref_o_cinfo2250_246_cfa_box(obj_t env_3319, obj_t node_3320)
{
   {
      box_ref_o_cinfo_98_t node_2029;
      {
	 approx_t aux_3464;
	 node_2029 = (box_ref_o_cinfo_98_t) (node_3320);
	 {
	    approx_t box_approx_152_2033;
	    {
	       node_t aux_3465;
	       {
		  var_t aux_3466;
		  {
		     box_ref_242_t obj_2920;
		     obj_2920 = (box_ref_242_t) (node_2029);
		     aux_3466 = (((box_ref_242_t) CREF(obj_2920))->var);
		  }
		  aux_3465 = (node_t) (aux_3466);
	       }
	       box_approx_152_2033 = cfa__102_cfa_cfa(aux_3465);
	    }
	    {
	       obj_t arg1960_3294;
	       arg1960_3294 = make_fx_procedure(arg19602251_cfa_box, ((long) 1), ((long) 2));
	       {
		  obj_t aux_3472;
		  aux_3472 = (obj_t) (node_2029);
		  PROCEDURE_SET(arg1960_3294, ((long) 0), aux_3472);
	       }
	       {
		  obj_t aux_3475;
		  aux_3475 = (obj_t) (node_2029);
		  PROCEDURE_SET(arg1960_3294, ((long) 1), aux_3475);
	       }
	       for_each_approx_alloc_83_cfa_approx(arg1960_3294, box_approx_152_2033);
	    }
	 }
	 {
	    obj_t aux_3479;
	    {
	       object_t aux_3480;
	       aux_3480 = (object_t) (node_2029);
	       aux_3479 = OBJECT_WIDENING(aux_3480);
	    }
	    aux_3464 = (((box_ref_o_cinfo_98_t) CREF(aux_3479))->approx);
	 }
	 return (obj_t) (aux_3464);
      }
   }
}


obj_t 
arg19602251_cfa_box(obj_t env_3321, obj_t box_3324)
{
   {
      obj_t node_3322;
      obj_t instance1882_3323;
      node_3322 = PROCEDURE_REF(env_3321, ((long) 0));
      instance1882_3323 = PROCEDURE_REF(env_3321, ((long) 1));
      {
	 obj_t box_2035;
	 box_2035 = box_3324;
	 {
	    bool_t test1962_2037;
	    test1962_2037 = is_a__118___object(box_2035, make_box_o_cinfo_96_cfa_info);
	    if (test1962_2037)
	      {
		 {
		    approx_t aux_3490;
		    {
		       approx_t aux_3498;
		       approx_t aux_3491;
		       {
			  make_box_o_cinfo_96_t obj_2923;
			  obj_2923 = (make_box_o_cinfo_96_t) (box_2035);
			  {
			     obj_t aux_3500;
			     {
				object_t aux_3501;
				aux_3501 = (object_t) (obj_2923);
				aux_3500 = OBJECT_WIDENING(aux_3501);
			     }
			     aux_3498 = (((make_box_o_cinfo_96_t) CREF(aux_3500))->value_approx_19);
			  }
		       }
		       {
			  box_ref_o_cinfo_98_t obj_2922;
			  obj_2922 = (box_ref_o_cinfo_98_t) (instance1882_3323);
			  {
			     obj_t aux_3493;
			     {
				object_t aux_3494;
				aux_3494 = (object_t) (obj_2922);
				aux_3493 = OBJECT_WIDENING(aux_3494);
			     }
			     aux_3491 = (((box_ref_o_cinfo_98_t) CREF(aux_3493))->approx);
			  }
		       }
		       aux_3490 = union_approx__241_cfa_approx(aux_3491, aux_3498);
		    }
		    return (obj_t) (aux_3490);
		 }
	      }
	    else
	      {
		 bool_t test1965_2041;
		 test1965_2041 = is_a__118___object(box_2035, make_box_cinfo_127_cfa_info);
		 if (test1965_2041)
		   {
		      {
			 obj_t arg1968_2044;
			 arg1968_2044 = shape_tools_shape(node_3322);
			 return internal_error_43_tools_error(string2277_cfa_box, string2278_cfa_box, arg1968_2044);
		      }
		   }
		 else
		   {
		      return BFALSE;
		   }
	      }
	 }
      }
   }
}


obj_t 
cfa__make_box_o_cinfo2252_47_cfa_box(obj_t env_3325, obj_t node_3326)
{
   {
      make_box_o_cinfo_96_t node_2010;
      {
	 approx_t aux_3511;
	 node_2010 = (make_box_o_cinfo_96_t) (node_3326);
	 {
	    bool_t test1944_2014;
	    {
	       obj_t aux_3512;
	       aux_3512 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 3)));
	       test1944_2014 = CBOOL(aux_3512);
	    }
	    if (test1944_2014)
	      {
		 obj_t arg1947_2016;
		 {
		    obj_t aux_3518;
		    {
		       node_t aux_3519;
		       {
			  make_box_202_t obj_2916;
			  obj_2916 = (make_box_202_t) (node_2010);
			  aux_3519 = (((make_box_202_t) CREF(obj_2916))->value);
		       }
		       aux_3518 = (obj_t) (aux_3519);
		    }
		    arg1947_2016 = shape_tools_shape(aux_3518);
		 }
		 {
		    obj_t list1948_2017;
		    {
		       obj_t arg1949_2018;
		       {
			  obj_t arg1950_2019;
			  {
			     obj_t aux_3524;
			     aux_3524 = BCHAR(((unsigned char) '\n'));
			     arg1950_2019 = MAKE_PAIR(aux_3524, BNIL);
			  }
			  arg1949_2018 = MAKE_PAIR(arg1947_2016, arg1950_2019);
		       }
		       list1948_2017 = MAKE_PAIR(string2279_cfa_box, arg1949_2018);
		    }
		    print_trace_107_tools_trace(list1948_2017);
		 }
	      }
	    else
	      {
		 BUNSPEC;
	      }
	 }
	 {
	    approx_t init_value_approx_9_2024;
	    {
	       node_t aux_3530;
	       {
		  make_box_202_t obj_2917;
		  obj_2917 = (make_box_202_t) (node_2010);
		  aux_3530 = (((make_box_202_t) CREF(obj_2917))->value);
	       }
	       init_value_approx_9_2024 = cfa__102_cfa_cfa(aux_3530);
	    }
	    {
	       approx_t aux_3534;
	       {
		  obj_t aux_3535;
		  {
		     object_t aux_3536;
		     aux_3536 = (object_t) (node_2010);
		     aux_3535 = OBJECT_WIDENING(aux_3536);
		  }
		  aux_3534 = (((make_box_o_cinfo_96_t) CREF(aux_3535))->value_approx_19);
	       }
	       union_approx__241_cfa_approx(aux_3534, init_value_approx_9_2024);
	    }
	    {
	       obj_t aux_3541;
	       {
		  object_t aux_3542;
		  aux_3542 = (object_t) (node_2010);
		  aux_3541 = OBJECT_WIDENING(aux_3542);
	       }
	       aux_3511 = (((make_box_o_cinfo_96_t) CREF(aux_3541))->approx);
	    }
	 }
	 return (obj_t) (aux_3511);
      }
   }
}


obj_t 
node_setup__box_ref2253_147_cfa_box(obj_t env_3327, obj_t node_3328)
{
   {
      box_ref_242_t node_1993;
      node_1993 = (box_ref_242_t) (node_3328);
      {
	 node_t aux_3548;
	 {
	    var_t aux_3549;
	    aux_3549 = (((box_ref_242_t) CREF(node_1993))->var);
	    aux_3548 = (node_t) (aux_3549);
	 }
	 node_setup__189_cfa_setup(aux_3548);
      }
      {
	 bool_t test1935_1998;
	 {
	    long n1_2901;
	    n1_2901 = (long) CINT(__optim__89_engine_param);
	    test1935_1998 = (n1_2901 >= ((long) 1));
	 }
	 if (test1935_1998)
	   {
	      box_ref_o_cinfo_98_t obj1879_1999;
	      obj1879_1999 = ((box_ref_o_cinfo_98_t) (node_1993));
	      {
		 box_ref_o_cinfo_98_t arg1936_2000;
		 {
		    approx_t arg1937_2001;
		    arg1937_2001 = make_type_approx_184_cfa_approx((type_t) (__obj__252_type_cache));
		    {
		       box_ref_o_cinfo_98_t res2240_2906;
		       {
			  box_ref_o_cinfo_98_t new1610_2904;
			  new1610_2904 = ((box_ref_o_cinfo_98_t) BREF(GC_MALLOC(sizeof(struct box_ref_o_cinfo_98))));
			  ((((box_ref_o_cinfo_98_t) CREF(new1610_2904))->approx) = ((approx_t) arg1937_2001), BUNSPEC);
			  res2240_2906 = new1610_2904;
		       }
		       arg1936_2000 = res2240_2906;
		    }
		 }
		 {
		    obj_t aux_3563;
		    object_t aux_3561;
		    aux_3563 = (obj_t) (arg1936_2000);
		    aux_3561 = (object_t) (obj1879_1999);
		    OBJECT_WIDENING_SET(aux_3561, aux_3563);
		 }
	      }
	      {
		 long arg1938_2002;
		 arg1938_2002 = class_num_218___object(box_ref_o_cinfo_98_cfa_info);
		 {
		    obj_t obj_2907;
		    obj_2907 = (obj_t) (obj1879_1999);
		    (((obj_t) CREF(obj_2907))->header = MAKE_HEADER(arg1938_2002, 0), BUNSPEC);
		 }
	      }
	      return (obj_t) (obj1879_1999);
	   }
	 else
	   {
	      {
		 box_ref_cinfo_214_t obj1880_2003;
		 obj1880_2003 = ((box_ref_cinfo_214_t) (node_1993));
		 {
		    box_ref_cinfo_214_t arg1939_2004;
		    {
		       approx_t arg1940_2005;
		       arg1940_2005 = make_type_approx_184_cfa_approx((type_t) (__obj__252_type_cache));
		       {
			  box_ref_cinfo_214_t res2241_2912;
			  {
			     box_ref_cinfo_214_t new1591_2910;
			     new1591_2910 = ((box_ref_cinfo_214_t) BREF(GC_MALLOC(sizeof(struct box_ref_cinfo_214))));
			     ((((box_ref_cinfo_214_t) CREF(new1591_2910))->approx) = ((approx_t) arg1940_2005), BUNSPEC);
			     res2241_2912 = new1591_2910;
			  }
			  arg1939_2004 = res2241_2912;
		       }
		    }
		    {
		       obj_t aux_3577;
		       object_t aux_3575;
		       aux_3577 = (obj_t) (arg1939_2004);
		       aux_3575 = (object_t) (obj1880_2003);
		       OBJECT_WIDENING_SET(aux_3575, aux_3577);
		    }
		 }
		 {
		    long arg1941_2006;
		    arg1941_2006 = class_num_218___object(box_ref_cinfo_214_cfa_info);
		    {
		       obj_t obj_2913;
		       obj_2913 = (obj_t) (obj1880_2003);
		       (((obj_t) CREF(obj_2913))->header = MAKE_HEADER(arg1941_2006, 0), BUNSPEC);
		    }
		 }
		 obj1880_2003;
	      }
	      {
		 approx_t aux_3583;
		 {
		    box_ref_cinfo_214_t obj_2915;
		    obj_2915 = (box_ref_cinfo_214_t) (node_1993);
		    {
		       obj_t aux_3585;
		       {
			  object_t aux_3586;
			  aux_3586 = (object_t) (obj_2915);
			  aux_3585 = OBJECT_WIDENING(aux_3586);
		       }
		       aux_3583 = (((box_ref_cinfo_214_t) CREF(aux_3585))->approx);
		    }
		 }
		 return approx_set_top__187_cfa_approx(aux_3583);
	      }
	   }
      }
   }
}


obj_t 
node_setup__box_set_2254_202_cfa_box(obj_t env_3329, obj_t node_3330)
{
   {
      box_set__221_t node_1976;
      node_1976 = (box_set__221_t) (node_3330);
      {
	 node_t aux_3592;
	 {
	    var_t aux_3593;
	    aux_3593 = (((box_set__221_t) CREF(node_1976))->var);
	    aux_3592 = (node_t) (aux_3593);
	 }
	 node_setup__189_cfa_setup(aux_3592);
      }
      node_setup__189_cfa_setup((((box_set__221_t) CREF(node_1976))->value));
      {
	 bool_t test1923_1982;
	 {
	    long n1_2886;
	    n1_2886 = (long) CINT(__optim__89_engine_param);
	    test1923_1982 = (n1_2886 >= ((long) 1));
	 }
	 if (test1923_1982)
	   {
	      box_set__o_cinfo_6_t obj1876_1983;
	      obj1876_1983 = ((box_set__o_cinfo_6_t) (node_1976));
	      {
		 box_set__o_cinfo_6_t arg1925_1984;
		 {
		    approx_t arg1926_1985;
		    arg1926_1985 = make_type_approx_184_cfa_approx((type_t) (__unspec__87_type_cache));
		    {
		       box_set__o_cinfo_6_t res2238_2891;
		       {
			  box_set__o_cinfo_6_t new1600_2889;
			  new1600_2889 = ((box_set__o_cinfo_6_t) BREF(GC_MALLOC(sizeof(struct box_set__o_cinfo_6))));
			  ((((box_set__o_cinfo_6_t) CREF(new1600_2889))->approx) = ((approx_t) arg1926_1985), BUNSPEC);
			  res2238_2891 = new1600_2889;
		       }
		       arg1925_1984 = res2238_2891;
		    }
		 }
		 {
		    obj_t aux_3609;
		    object_t aux_3607;
		    aux_3609 = (obj_t) (arg1925_1984);
		    aux_3607 = (object_t) (obj1876_1983);
		    OBJECT_WIDENING_SET(aux_3607, aux_3609);
		 }
	      }
	      {
		 long arg1927_1986;
		 arg1927_1986 = class_num_218___object(box_set__o_cinfo_6_cfa_info);
		 {
		    obj_t obj_2892;
		    obj_2892 = (obj_t) (obj1876_1983);
		    (((obj_t) CREF(obj_2892))->header = MAKE_HEADER(arg1927_1986, 0), BUNSPEC);
		 }
	      }
	      return (obj_t) (obj1876_1983);
	   }
	 else
	   {
	      box_set__cinfo_94_t obj1877_1987;
	      obj1877_1987 = ((box_set__cinfo_94_t) (node_1976));
	      {
		 box_set__cinfo_94_t arg1928_1988;
		 {
		    approx_t arg1929_1989;
		    arg1929_1989 = make_type_approx_184_cfa_approx((type_t) (__unspec__87_type_cache));
		    {
		       box_set__cinfo_94_t res2239_2897;
		       {
			  box_set__cinfo_94_t new1582_2895;
			  new1582_2895 = ((box_set__cinfo_94_t) BREF(GC_MALLOC(sizeof(struct box_set__cinfo_94))));
			  ((((box_set__cinfo_94_t) CREF(new1582_2895))->approx) = ((approx_t) arg1929_1989), BUNSPEC);
			  res2239_2897 = new1582_2895;
		       }
		       arg1928_1988 = res2239_2897;
		    }
		 }
		 {
		    obj_t aux_3623;
		    object_t aux_3621;
		    aux_3623 = (obj_t) (arg1928_1988);
		    aux_3621 = (object_t) (obj1877_1987);
		    OBJECT_WIDENING_SET(aux_3621, aux_3623);
		 }
	      }
	      {
		 long arg1931_1990;
		 arg1931_1990 = class_num_218___object(box_set__cinfo_94_cfa_info);
		 {
		    obj_t obj_2898;
		    obj_2898 = (obj_t) (obj1877_1987);
		    (((obj_t) CREF(obj_2898))->header = MAKE_HEADER(arg1931_1990, 0), BUNSPEC);
		 }
	      }
	      return (obj_t) (obj1877_1987);
	   }
      }
   }
}


obj_t 
node_setup__pre_make_box2255_68_cfa_box(obj_t env_3331, obj_t node_3332)
{
   {
      pre_make_box_186_t node_1956;
      node_1956 = (pre_make_box_186_t) (node_3332);
      {
	 node_t aux_3631;
	 {
	    make_box_202_t obj_2858;
	    obj_2858 = (make_box_202_t) (node_1956);
	    aux_3631 = (((make_box_202_t) CREF(obj_2858))->value);
	 }
	 node_setup__189_cfa_setup(aux_3631);
      }
      {
	 obj_t key_1961;
	 {
	    obj_t aux_3635;
	    {
	       object_t aux_3636;
	       aux_3636 = (object_t) (node_1956);
	       aux_3635 = OBJECT_WIDENING(aux_3636);
	    }
	    key_1961 = (((pre_make_box_186_t) CREF(aux_3635))->key);
	 }
	 {
	    pre_make_box_186_t node_1962;
	    {
	       long arg1916_1971;
	       {
		  obj_t arg1917_1972;
		  {
		     obj_t arg1918_1973;
		     {
			object_t object_2860;
			object_2860 = (object_t) (node_1956);
			{
			   long arg1187_2861;
			   {
			      long arg1188_2862;
			      long arg1189_2863;
			      arg1188_2862 = TYPE(object_2860);
			      arg1189_2863 = OBJECT_TYPE;
			      arg1187_2861 = (arg1188_2862 - arg1189_2863);
			   }
			   {
			      obj_t vector_2867;
			      vector_2867 = __classes__134___object;
			      arg1918_1973 = VECTOR_REF(vector_2867, arg1187_2861);
			   }
			}
		     }
		     arg1917_1972 = class_super_145___object(arg1918_1973);
		  }
		  arg1916_1971 = class_num_218___object(arg1917_1972);
	       }
	       {
		  obj_t obj_2869;
		  obj_2869 = (obj_t) (node_1956);
		  (((obj_t) CREF(obj_2869))->header = MAKE_HEADER(arg1916_1971, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_3649;
	       aux_3649 = (object_t) (node_1956);
	       OBJECT_WIDENING_SET(aux_3649, BFALSE);
	    }
	    node_1962 = node_1956;
	    {
	       {
		  make_box_o_cinfo_96_t node_1963;
		  {
		     make_box_o_cinfo_96_t obj1874_1965;
		     obj1874_1965 = ((make_box_o_cinfo_96_t) (node_1962));
		     {
			make_box_o_cinfo_96_t arg1912_1966;
			{
			   approx_t arg1913_1967;
			   approx_t arg1914_1968;
			   arg1913_1967 = make_type_approx_184_cfa_approx((type_t) (__obj__252_type_cache));
			   arg1914_1968 = make_empty_approx_131_cfa_approx();
			   {
			      make_box_o_cinfo_96_t res2236_2878;
			      {
				 make_box_o_cinfo_96_t new1570_2874;
				 new1570_2874 = ((make_box_o_cinfo_96_t) BREF(GC_MALLOC(sizeof(struct make_box_o_cinfo_96))));
				 ((((make_box_o_cinfo_96_t) CREF(new1570_2874))->key) = ((obj_t) key_1961), BUNSPEC);
				 ((((make_box_o_cinfo_96_t) CREF(new1570_2874))->approx) = ((approx_t) arg1913_1967), BUNSPEC);
				 ((((make_box_o_cinfo_96_t) CREF(new1570_2874))->value_approx_19) = ((approx_t) arg1914_1968), BUNSPEC);
				 res2236_2878 = new1570_2874;
			      }
			      arg1912_1966 = res2236_2878;
			   }
			}
			{
			   obj_t aux_3662;
			   object_t aux_3660;
			   aux_3662 = (obj_t) (arg1912_1966);
			   aux_3660 = (object_t) (obj1874_1965);
			   OBJECT_WIDENING_SET(aux_3660, aux_3662);
			}
		     }
		     {
			long arg1915_1969;
			arg1915_1969 = class_num_218___object(make_box_o_cinfo_96_cfa_info);
			{
			   obj_t obj_2879;
			   obj_2879 = (obj_t) (obj1874_1965);
			   (((obj_t) CREF(obj_2879))->header = MAKE_HEADER(arg1915_1969, 0), BUNSPEC);
			}
		     }
		     node_1963 = obj1874_1965;
		  }
		  {
		     approx_t arg1911_1964;
		     arg1911_1964 = make_type_alloc_approx_134_cfa_approx((type_t) (__obj__252_type_cache), (node_t) (node_1963));
		     {
			obj_t res2237_2883;
			{
			   obj_t x_3350;
			   {
			      obj_t aux_3671;
			      {
				 object_t aux_3672;
				 aux_3672 = (object_t) (node_1963);
				 aux_3671 = OBJECT_WIDENING(aux_3672);
			      }
			      x_3350 = ((((make_box_o_cinfo_96_t) CREF(aux_3671))->approx) = ((approx_t) arg1911_1964), BUNSPEC);
			   }
			   res2237_2883 = BUNSPEC;
			}
			return res2237_2883;
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
node_setup__make_box2256_173_cfa_box(obj_t env_3333, obj_t node_3334)
{
   {
      make_box_202_t node_1944;
      node_1944 = (make_box_202_t) (node_3334);
      node_setup__189_cfa_setup((((make_box_202_t) CREF(node_1944))->value));
      {
	 make_box_cinfo_127_t obj1871_1949;
	 obj1871_1949 = ((make_box_cinfo_127_t) (node_1944));
	 {
	    make_box_cinfo_127_t arg1904_1950;
	    {
	       approx_t arg1905_1951;
	       arg1905_1951 = make_type_approx_184_cfa_approx((type_t) (__obj__252_type_cache));
	       {
		  make_box_cinfo_127_t res2235_2854;
		  {
		     make_box_cinfo_127_t new1561_2852;
		     new1561_2852 = ((make_box_cinfo_127_t) BREF(GC_MALLOC(sizeof(struct make_box_cinfo_127))));
		     ((((make_box_cinfo_127_t) CREF(new1561_2852))->approx) = ((approx_t) arg1905_1951), BUNSPEC);
		     res2235_2854 = new1561_2852;
		  }
		  arg1904_1950 = res2235_2854;
	       }
	    }
	    {
	       obj_t aux_3686;
	       object_t aux_3684;
	       aux_3686 = (obj_t) (arg1904_1950);
	       aux_3684 = (object_t) (obj1871_1949);
	       OBJECT_WIDENING_SET(aux_3684, aux_3686);
	    }
	 }
	 {
	    long arg1906_1952;
	    arg1906_1952 = class_num_218___object(make_box_cinfo_127_cfa_info);
	    {
	       obj_t obj_2855;
	       obj_2855 = (obj_t) (obj1871_1949);
	       (((obj_t) CREF(obj_2855))->header = MAKE_HEADER(arg1906_1952, 0), BUNSPEC);
	    }
	 }
	 obj1871_1949;
      }
      {
	 approx_t aux_3692;
	 {
	    make_box_cinfo_127_t obj_2857;
	    obj_2857 = (make_box_cinfo_127_t) (node_1944);
	    {
	       obj_t aux_3694;
	       {
		  object_t aux_3695;
		  aux_3695 = (object_t) (obj_2857);
		  aux_3694 = OBJECT_WIDENING(aux_3695);
	       }
	       aux_3692 = (((make_box_cinfo_127_t) CREF(aux_3694))->approx);
	    }
	 }
	 return approx_set_top__187_cfa_approx(aux_3692);
      }
   }
}


obj_t 
imported_modules_init_94_cfa_box()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_BOX");
   module_initialization_70_tools_error(((long) 0), "CFA_BOX");
   module_initialization_70_tools_shape(((long) 0), "CFA_BOX");
   module_initialization_70_engine_param(((long) 0), "CFA_BOX");
   module_initialization_70_type_type(((long) 0), "CFA_BOX");
   module_initialization_70_type_cache(((long) 0), "CFA_BOX");
   module_initialization_70_ast_var(((long) 0), "CFA_BOX");
   module_initialization_70_ast_node(((long) 0), "CFA_BOX");
   module_initialization_70_cfa_info(((long) 0), "CFA_BOX");
   module_initialization_70_cfa_loose(((long) 0), "CFA_BOX");
   module_initialization_70_cfa_setup(((long) 0), "CFA_BOX");
   module_initialization_70_cfa_approx(((long) 0), "CFA_BOX");
   module_initialization_70_cfa_cfa(((long) 0), "CFA_BOX");
   module_initialization_70_cfa_iterate(((long) 0), "CFA_BOX");
   return module_initialization_70_cfa_closure(((long) 0), "CFA_BOX");
}
