/*===========================================================================*/
/*   (Cfa/cfa.scm)                                                           */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


extern obj_t app_ly_cinfo_234_cfa_info;
static obj_t cfa_variable_value_approx_default1905_106_cfa_cfa(value_t);
extern obj_t let_fun_218_ast_node;
extern obj_t svar_cinfo_166_cfa_info;
extern obj_t setq_cinfo_191_cfa_info;
extern obj_t cvar_cinfo_53_cfa_info;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
extern approx_t loose__226_cfa_loose(approx_t, obj_t);
extern obj_t _cfa__186_cfa_cfa(obj_t, obj_t);
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t jump_ex_it_cinfo_139_cfa_info;
static obj_t imported_modules_init_94_cfa_cfa();
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_app(long, char *);
extern obj_t module_initialization_70_cfa_funcall(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_cfa_cfa();
static obj_t cnst_init_137_cfa_cfa();
extern obj_t conditional_cinfo_212_cfa_info;
extern obj_t pragma_cinfo_220_cfa_info;
extern obj_t fail_cinfo_75_cfa_info;
extern obj_t set_ex_it_cinfo_168_cfa_info;
static obj_t require_initialization_114_cfa_cfa = BUNSPEC;
extern obj_t scnst_cinfo_0_cfa_info;
extern obj_t kwote_cinfo_48_cfa_info;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cfa_cfa();
extern obj_t atom_cinfo_155_cfa_info;
extern obj_t make_box_cinfo_127_cfa_info;
extern obj_t kwote_node_102_cfa_info;
extern obj_t sexit_cinfo_49_cfa_info;
extern obj_t cast_ast_node;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t box_set__cinfo_94_cfa_info;
extern obj_t global_loose__8_cfa_loose(global_t, approx_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern approx_t union_approx__241_cfa_approx(approx_t, approx_t);
static obj_t _cfa_variable_value_approx_default1905_161_cfa_cfa(obj_t, obj_t);
extern approx_t cfa__102_cfa_cfa(node_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t select_cinfo_150_cfa_info;
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t _cfa__default1899_198_cfa_cfa(obj_t, obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t cfa_variable_value_approx_39_cfa_cfa(value_t);
extern obj_t _____74_type_cache;
extern obj_t approx_set_top__187_cfa_approx(approx_t);
extern obj_t __obj__252_type_cache;
static approx_t cfa__default1899_68_cfa_cfa(node_t);
extern obj_t box_ref_cinfo_214_cfa_info;
extern obj_t _cfa_variable_value_approx_165_cfa_cfa(obj_t, obj_t);
extern obj_t intern_sfun_cinfo_192_cfa_info;
static obj_t __cnst[3];

DEFINE_EXPORT_GENERIC(cfa__env_153_cfa_cfa, _cfa__186_cfa_cfa2408, _cfa__186_cfa_cfa, 0L, 1);
DEFINE_STRING(string2388_cfa_cfa, string2388_cfa_cfa2409, " -> ", 4);
DEFINE_STRING(string2392_cfa_cfa, string2392_cfa_cfa2410, " <- ", 4);
DEFINE_STRING(string2397_cfa_cfa, string2397_cfa_cfa2411, "       val: ", 12);
DEFINE_STRING(string2394_cfa_cfa, string2394_cfa_cfa2412, "cfa! ::let-var: ", 16);
DEFINE_STATIC_PROCEDURE(cfa__default1899_env_179_cfa_cfa, _cfa__default1899_198_cfa_cfa2413, _cfa__default1899_198_cfa_cfa, 0L, 1);
DEFINE_STRING(string2401_cfa_cfa, string2401_cfa_cfa2414, "No method for this object", 25);
DEFINE_STRING(string2389_cfa_cfa, string2389_cfa_cfa2415, "kwote/node: ", 12);
DEFINE_STRING(string2393_cfa_cfa, string2393_cfa_cfa2416, "*** ", 4);
DEFINE_STRING(string2400_cfa_cfa, string2400_cfa_cfa2417, "cfa!(make-box): ", 16);
DEFINE_STRING(string2402_cfa_cfa, string2402_cfa_cfa2418, "CFA-VARIABLE-VALUE-APPROX-DEFAULT1905 ALL CFA ", 46);
DEFINE_STRING(string2395_cfa_cfa, string2395_cfa_cfa2419, "     atype: ", 12);
DEFINE_STRING(string2396_cfa_cfa, string2396_cfa_cfa2420, "     vtype: ", 12);
DEFINE_STRING(string2387_cfa_cfa, string2387_cfa_cfa2421, "cfa!:no method for this ast", 27);
DEFINE_STRING(string2391_cfa_cfa, string2391_cfa_cfa2422, "Unexpected closure", 18);
DEFINE_STRING(string2399_cfa_cfa, string2399_cfa_cfa2423, "   binding: ", 12);
DEFINE_EXPORT_GENERIC(cfa_variable_value_approx_env_230_cfa_cfa, _cfa_variable_value_approx_165_cfa_cfa2424, _cfa_variable_value_approx_165_cfa_cfa, 0L, 1);
DEFINE_STRING(string2390_cfa_cfa, string2390_cfa_cfa2425, "cfa!", 4);
DEFINE_STRING(string2398_cfa_cfa, string2398_cfa_cfa2426, "       var: ", 12);
DEFINE_STATIC_PROCEDURE(cfa_variable_value_approx_default1905_env_17_cfa_cfa, _cfa_variable_value_approx_default1905_161_cfa_cfa2427, _cfa_variable_value_approx_default1905_161_cfa_cfa, 0L, 1);

obj_t 
module_initialization_70_cfa_cfa(long checksum_3478, char *from_3479)
{
   if (CBOOL(require_initialization_114_cfa_cfa))
     {
	require_initialization_114_cfa_cfa = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_cfa();
	cnst_init_137_cfa_cfa();
	imported_modules_init_94_cfa_cfa();
	toplevel_init_63_cfa_cfa();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_cfa()
{
   module_initialization_70___object(((long) 0), "CFA_CFA");
   module_initialization_70___reader(((long) 0), "CFA_CFA");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_cfa()
{
   {
      obj_t cnst_port_138_3470;
      cnst_port_138_3470 = open_input_string(string2402_cfa_cfa);
      {
	 long i_3471;
	 i_3471 = ((long) 2);
       loop_3472:
	 {
	    bool_t test2403_3473;
	    test2403_3473 = (i_3471 == ((long) -1));
	    if (test2403_3473)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2404_3474;
		    {
		       obj_t list2405_3475;
		       {
			  obj_t arg2406_3476;
			  arg2406_3476 = BNIL;
			  list2405_3475 = MAKE_PAIR(cnst_port_138_3470, arg2406_3476);
		       }
		       arg2404_3474 = read___reader(list2405_3475);
		    }
		    CNST_TABLE_SET(i_3471, arg2404_3474);
		 }
		 {
		    int aux_3477;
		    {
		       long aux_3495;
		       aux_3495 = (i_3471 - ((long) 1));
		       aux_3477 = (int) (aux_3495);
		    }
		    {
		       long i_3498;
		       i_3498 = (long) (aux_3477);
		       i_3471 = i_3498;
		       goto loop_3472;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_cfa()
{
   add_generic__110___object(cfa__env_153_cfa_cfa, cfa__default1899_env_179_cfa_cfa);
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, atom_cinfo_155_cfa_info, ((long) 0));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, kwote_cinfo_48_cfa_info, ((long) 1));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, kwote_node_102_cfa_info, ((long) 2));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, var_ast_node, ((long) 3));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, closure_ast_node, ((long) 4));
   add_generic__110___object(cfa_variable_value_approx_env_230_cfa_cfa, cfa_variable_value_approx_default1905_env_17_cfa_cfa);
   add_inlined_method__244___object(cfa_variable_value_approx_env_230_cfa_cfa, svar_cinfo_166_cfa_info, ((long) 0));
   add_inlined_method__244___object(cfa_variable_value_approx_env_230_cfa_cfa, scnst_cinfo_0_cfa_info, ((long) 1));
   add_inlined_method__244___object(cfa_variable_value_approx_env_230_cfa_cfa, cvar_cinfo_53_cfa_info, ((long) 2));
   add_inlined_method__244___object(cfa_variable_value_approx_env_230_cfa_cfa, sexit_cinfo_49_cfa_info, ((long) 3));
   add_inlined_method__244___object(cfa_variable_value_approx_env_230_cfa_cfa, intern_sfun_cinfo_192_cfa_info, ((long) 4));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, sequence_ast_node, ((long) 5));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, app_ly_cinfo_234_cfa_info, ((long) 6));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, pragma_cinfo_220_cfa_info, ((long) 7));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, setq_cinfo_191_cfa_info, ((long) 9));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, conditional_cinfo_212_cfa_info, ((long) 10));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, fail_cinfo_75_cfa_info, ((long) 11));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, select_cinfo_150_cfa_info, ((long) 12));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, let_fun_218_ast_node, ((long) 13));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, let_var_6_ast_node, ((long) 14));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, set_ex_it_cinfo_168_cfa_info, ((long) 15));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, jump_ex_it_cinfo_139_cfa_info, ((long) 16));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, make_box_cinfo_127_cfa_info, ((long) 17));
   add_inlined_method__244___object(cfa__env_153_cfa_cfa, box_set__cinfo_94_cfa_info, ((long) 18));
   {
      long aux_3526;
      aux_3526 = add_inlined_method__244___object(cfa__env_153_cfa_cfa, box_ref_cinfo_214_cfa_info, ((long) 19));
      return BINT(aux_3526);
   }
}


approx_t 
cfa__default1899_68_cfa_cfa(node_t node_2)
{
   {
      obj_t arg1927_2974;
      arg1927_2974 = shape_tools_shape((obj_t) (node_2));
      {
	 obj_t aux_3531;
	 aux_3531 = internal_error_43_tools_error(string2387_cfa_cfa, (obj_t) (node_2), arg1927_2974);
	 return (approx_t) (aux_3531);
      }
   }
}


obj_t 
_cfa__default1899_198_cfa_cfa(obj_t env_3464, obj_t node_3465)
{
   {
      approx_t aux_3535;
      aux_3535 = cfa__default1899_68_cfa_cfa((node_t) (node_3465));
      return (obj_t) (aux_3535);
   }
}


approx_t 
cfa__102_cfa_cfa(node_t node_1)
{
   {
      obj_t method2202_2745;
      obj_t class2207_2746;
      {
	 obj_t arg2210_2743;
	 obj_t arg2211_2744;
	 {
	    object_t obj_2975;
	    obj_2975 = (object_t) (node_1);
	    {
	       obj_t pre_method_105_2976;
	       pre_method_105_2976 = PROCEDURE_REF(cfa__env_153_cfa_cfa, ((long) 2));
	       if (INTEGERP(pre_method_105_2976))
		 {
		    PROCEDURE_SET(cfa__env_153_cfa_cfa, ((long) 2), BUNSPEC);
		    arg2210_2743 = pre_method_105_2976;
		 }
	       else
		 {
		    long obj_class_num_177_2981;
		    obj_class_num_177_2981 = TYPE(obj_2975);
		    {
		       obj_t arg1183_2982;
		       arg1183_2982 = PROCEDURE_REF(cfa__env_153_cfa_cfa, ((long) 1));
		       {
			  long arg1184_2986;
			  {
			     long arg1186_2987;
			     arg1186_2987 = OBJECT_TYPE;
			     arg1184_2986 = (obj_class_num_177_2981 - arg1186_2987);
			  }
			  arg2210_2743 = VECTOR_REF(arg1183_2982, arg1184_2986);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_2992;
	    object_2992 = (object_t) (node_1);
	    {
	       long arg1187_2993;
	       {
		  long arg1188_2994;
		  long arg1189_2995;
		  arg1188_2994 = TYPE(object_2992);
		  arg1189_2995 = OBJECT_TYPE;
		  arg1187_2993 = (arg1188_2994 - arg1189_2995);
	       }
	       {
		  obj_t vector_2999;
		  vector_2999 = __classes__134___object;
		  arg2211_2744 = VECTOR_REF(vector_2999, arg1187_2993);
	       }
	    }
	 }
	 {
	    obj_t aux_3554;
	    method2202_2745 = arg2210_2743;
	    class2207_2746 = arg2211_2744;
	    {
	       if (INTEGERP(method2202_2745))
		 {
		    switch ((long) CINT(method2202_2745))
		      {
		      case ((long) 0):
			 {
			    atom_cinfo_155_t node_2752;
			    node_2752 = (atom_cinfo_155_t) (node_1);
			    {
			       approx_t aux_3558;
			       {
				  obj_t aux_3559;
				  {
				     object_t aux_3560;
				     aux_3560 = (object_t) (node_2752);
				     aux_3559 = OBJECT_WIDENING(aux_3560);
				  }
				  aux_3558 = (((atom_cinfo_155_t) CREF(aux_3559))->approx);
			       }
			       aux_3554 = (obj_t) (aux_3558);
			    }
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_cinfo_48_t node_2754;
			    node_2754 = (kwote_cinfo_48_t) (node_1);
			    {
			       approx_t aux_3566;
			       {
				  obj_t aux_3567;
				  {
				     object_t aux_3568;
				     aux_3568 = (object_t) (node_2754);
				     aux_3567 = OBJECT_WIDENING(aux_3568);
				  }
				  aux_3566 = (((kwote_cinfo_48_t) CREF(aux_3567))->approx);
			       }
			       aux_3554 = (obj_t) (aux_3566);
			    }
			 }
			 break;
		      case ((long) 2):
			 {
			    kwote_node_102_t knode_2756;
			    knode_2756 = (kwote_node_102_t) (node_1);
			    {
			       bool_t test2214_2758;
			       {
				  obj_t aux_3574;
				  aux_3574 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2214_2758 = CBOOL(aux_3574);
			       }
			       if (test2214_2758)
				 {
				    obj_t arg2216_2760;
				    obj_t arg2218_2762;
				    arg2216_2760 = shape_tools_shape((obj_t) (knode_2756));
				    {
				       obj_t aux_3582;
				       {
					  node_t aux_3583;
					  {
					     obj_t aux_3584;
					     {
						object_t aux_3585;
						aux_3585 = (object_t) (knode_2756);
						aux_3584 = OBJECT_WIDENING(aux_3585);
					     }
					     aux_3583 = (((kwote_node_102_t) CREF(aux_3584))->node);
					  }
					  aux_3582 = (obj_t) (aux_3583);
				       }
				       arg2218_2762 = shape_tools_shape(aux_3582);
				    }
				    {
				       obj_t list2219_2763;
				       {
					  obj_t arg2220_2764;
					  {
					     obj_t arg2221_2765;
					     {
						obj_t arg2222_2766;
						{
						   obj_t arg2223_2767;
						   {
						      obj_t aux_3591;
						      aux_3591 = BCHAR(((unsigned char) '\n'));
						      arg2223_2767 = MAKE_PAIR(aux_3591, BNIL);
						   }
						   arg2222_2766 = MAKE_PAIR(arg2218_2762, arg2223_2767);
						}
						arg2221_2765 = MAKE_PAIR(string2388_cfa_cfa, arg2222_2766);
					     }
					     arg2220_2764 = MAKE_PAIR(arg2216_2760, arg2221_2765);
					  }
					  list2219_2763 = MAKE_PAIR(string2389_cfa_cfa, arg2220_2764);
				       }
				       print_trace_107_tools_trace(list2219_2763);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       approx_t aux_3599;
			       {
				  node_t aux_3600;
				  {
				     obj_t aux_3601;
				     {
					object_t aux_3602;
					aux_3602 = (object_t) (knode_2756);
					aux_3601 = OBJECT_WIDENING(aux_3602);
				     }
				     aux_3600 = (((kwote_node_102_t) CREF(aux_3601))->node);
				  }
				  aux_3599 = cfa__102_cfa_cfa(aux_3600);
			       }
			       aux_3554 = (obj_t) (aux_3599);
			    }
			 }
			 break;
		      case ((long) 3):
			 {
			    var_t node_2773;
			    node_2773 = (var_t) (node_1);
			    {
			       value_t aux_3609;
			       {
				  variable_t arg2230_2776;
				  arg2230_2776 = (((var_t) CREF(node_2773))->variable);
				  aux_3609 = (((variable_t) CREF(arg2230_2776))->value);
			       }
			       aux_3554 = cfa_variable_value_approx_39_cfa_cfa(aux_3609);
			    }
			 }
			 break;
		      case ((long) 4):
			 {
			    obj_t arg2233_2780;
			    {
			       obj_t aux_3613;
			       {
				  closure_t aux_3614;
				  aux_3614 = (closure_t) (node_1);
				  aux_3613 = (obj_t) (aux_3614);
			       }
			       arg2233_2780 = shape_tools_shape(aux_3613);
			    }
			    aux_3554 = internal_error_43_tools_error(string2390_cfa_cfa, string2391_cfa_cfa, arg2233_2780);
			 }
			 break;
		      case ((long) 5):
			 {
			    sequence_t node_2781;
			    node_2781 = (sequence_t) (node_1);
			    {
			       obj_t n_2783;
			       obj_t approx_2784;
			       n_2783 = (((sequence_t) CREF(node_2781))->nodes);
			       approx_2784 = BUNSPEC;
			     loop_2785:
			       if (NULLP(n_2783))
				 {
				    aux_3554 = approx_2784;
				 }
			       else
				 {
				    obj_t arg2236_2788;
				    approx_t arg2242_2789;
				    arg2236_2788 = CDR(n_2783);
				    {
				       node_t aux_3623;
				       {
					  obj_t aux_3624;
					  aux_3624 = CAR(n_2783);
					  aux_3623 = (node_t) (aux_3624);
				       }
				       arg2242_2789 = cfa__102_cfa_cfa(aux_3623);
				    }
				    {
				       obj_t approx_3629;
				       obj_t n_3628;
				       n_3628 = arg2236_2788;
				       approx_3629 = (obj_t) (arg2242_2789);
				       approx_2784 = approx_3629;
				       n_2783 = n_3628;
				       goto loop_2785;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 6):
			 {
			    app_ly_cinfo_234_t node_2791;
			    node_2791 = (app_ly_cinfo_234_t) (node_1);
			    {
			       approx_t arg2244_2793;
			       obj_t arg2245_2794;
			       {
				  node_t aux_3633;
				  {
				     app_ly_162_t obj_3011;
				     obj_3011 = (app_ly_162_t) (node_2791);
				     aux_3633 = (((app_ly_162_t) CREF(obj_3011))->arg);
				  }
				  arg2244_2793 = cfa__102_cfa_cfa(aux_3633);
			       }
			       arg2245_2794 = CNST_TABLE_REF(((long) 1));
			       loose__226_cfa_loose(arg2244_2793, arg2245_2794);
			    }
			    {
			       approx_t arg2247_2796;
			       obj_t arg2248_2797;
			       {
				  node_t aux_3639;
				  {
				     app_ly_162_t obj_3012;
				     obj_3012 = (app_ly_162_t) (node_2791);
				     aux_3639 = (((app_ly_162_t) CREF(obj_3012))->fun);
				  }
				  arg2247_2796 = cfa__102_cfa_cfa(aux_3639);
			       }
			       arg2248_2797 = CNST_TABLE_REF(((long) 1));
			       loose__226_cfa_loose(arg2247_2796, arg2248_2797);
			    }
			    {
			       approx_t aux_3645;
			       {
				  obj_t aux_3646;
				  {
				     object_t aux_3647;
				     aux_3647 = (object_t) (node_2791);
				     aux_3646 = OBJECT_WIDENING(aux_3647);
				  }
				  aux_3645 = (((app_ly_cinfo_234_t) CREF(aux_3646))->approx);
			       }
			       aux_3554 = (obj_t) (aux_3645);
			    }
			 }
			 break;
		      case ((long) 7):
			 {
			    pragma_cinfo_220_t node_2799;
			    node_2799 = (pragma_cinfo_220_t) (node_1);
			    {
			       obj_t l1882_2801;
			       {
				  pragma_t obj_3014;
				  obj_3014 = (pragma_t) (node_2799);
				  l1882_2801 = (((pragma_t) CREF(obj_3014))->args);
			       }
			     lname1883_2802:
			       if (PAIRP(l1882_2801))
				 {
				    {
				       approx_t arg2252_2806;
				       obj_t arg2254_2807;
				       {
					  node_t aux_3655;
					  {
					     obj_t aux_3656;
					     aux_3656 = CAR(l1882_2801);
					     aux_3655 = (node_t) (aux_3656);
					  }
					  arg2252_2806 = cfa__102_cfa_cfa(aux_3655);
				       }
				       arg2254_2807 = CNST_TABLE_REF(((long) 1));
				       loose__226_cfa_loose(arg2252_2806, arg2254_2807);
				    }
				    {
				       obj_t l1882_3662;
				       l1882_3662 = CDR(l1882_2801);
				       l1882_2801 = l1882_3662;
				       goto lname1883_2802;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       approx_t aux_3666;
			       {
				  obj_t aux_3667;
				  {
				     object_t aux_3668;
				     aux_3668 = (object_t) (node_2799);
				     aux_3667 = OBJECT_WIDENING(aux_3668);
				  }
				  aux_3666 = (((pragma_cinfo_220_t) CREF(aux_3667))->approx);
			       }
			       aux_3554 = (obj_t) (aux_3666);
			    }
			 }
			 break;
		      case ((long) 8):
			 {
			    cast_t node_2809;
			    node_2809 = (cast_t) (node_1);
			    {
			       approx_t aux_3674;
			       aux_3674 = cfa__102_cfa_cfa((((cast_t) CREF(node_2809))->arg));
			       aux_3554 = (obj_t) (aux_3674);
			    }
			 }
			 break;
		      case ((long) 9):
			 {
			    setq_cinfo_191_t node_2812;
			    node_2812 = (setq_cinfo_191_t) (node_1);
			    {
			       approx_t var_approx_58_2814;
			       {
				  node_t aux_3679;
				  {
				     var_t aux_3680;
				     {
					setq_t obj_3020;
					obj_3020 = (setq_t) (node_2812);
					aux_3680 = (((setq_t) CREF(obj_3020))->var);
				     }
				     aux_3679 = (node_t) (aux_3680);
				  }
				  var_approx_58_2814 = cfa__102_cfa_cfa(aux_3679);
			       }
			       {
				  approx_t val_approx_22_2815;
				  {
				     node_t aux_3685;
				     {
					setq_t obj_3021;
					obj_3021 = (setq_t) (node_2812);
					aux_3685 = (((setq_t) CREF(obj_3021))->value);
				     }
				     val_approx_22_2815 = cfa__102_cfa_cfa(aux_3685);
				  }
				  {
				     variable_t v_2816;
				     {
					var_t arg2272_2831;
					{
					   setq_t obj_3022;
					   obj_3022 = (setq_t) (node_2812);
					   arg2272_2831 = (((setq_t) CREF(obj_3022))->var);
					}
					v_2816 = (((var_t) CREF(arg2272_2831))->variable);
				     }
				     {
					{
					   bool_t test2257_2817;
					   {
					      obj_t aux_3692;
					      aux_3692 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
					      test2257_2817 = CBOOL(aux_3692);
					   }
					   if (test2257_2817)
					     {
						obj_t arg2259_2819;
						obj_t arg2261_2821;
						arg2259_2819 = shape_tools_shape((obj_t) (node_2812));
						arg2261_2821 = shape_tools_shape((obj_t) (val_approx_22_2815));
						{
						   obj_t list2262_2822;
						   {
						      obj_t arg2263_2823;
						      {
							 obj_t arg2264_2824;
							 {
							    obj_t arg2265_2825;
							    {
							       obj_t arg2266_2826;
							       {
								  obj_t aux_3702;
								  aux_3702 = BCHAR(((unsigned char) '\n'));
								  arg2266_2826 = MAKE_PAIR(aux_3702, BNIL);
							       }
							       arg2265_2825 = MAKE_PAIR(arg2261_2821, arg2266_2826);
							    }
							    arg2264_2824 = MAKE_PAIR(string2392_cfa_cfa, arg2265_2825);
							 }
							 arg2263_2823 = MAKE_PAIR(arg2259_2819, arg2264_2824);
						      }
						      list2262_2822 = MAKE_PAIR(string2393_cfa_cfa, arg2263_2823);
						   }
						   print_trace_107_tools_trace(list2262_2822);
						}
					     }
					   else
					     {
						BUNSPEC;
					     }
					}
					union_approx__241_cfa_approx(var_approx_58_2814, val_approx_22_2815);
					{
					   bool_t test2271_2830;
					   test2271_2830 = is_a__118___object((obj_t) (v_2816), global_ast_var);
					   if (test2271_2830)
					     {
						global_loose__8_cfa_loose((global_t) (v_2816), var_approx_58_2814);
					     }
					   else
					     {
						BUNSPEC;
					     }
					}
					{
					   approx_t aux_3716;
					   {
					      obj_t aux_3717;
					      {
						 object_t aux_3718;
						 aux_3718 = (object_t) (node_2812);
						 aux_3717 = OBJECT_WIDENING(aux_3718);
					      }
					      aux_3716 = (((setq_cinfo_191_t) CREF(aux_3717))->approx);
					   }
					   aux_3554 = (obj_t) (aux_3716);
					}
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 10):
			 {
			    conditional_cinfo_212_t node_2834;
			    node_2834 = (conditional_cinfo_212_t) (node_1);
			    {
			       node_t aux_3724;
			       {
				  conditional_t obj_3026;
				  obj_3026 = (conditional_t) (node_2834);
				  aux_3724 = (((conditional_t) CREF(obj_3026))->test);
			       }
			       cfa__102_cfa_cfa(aux_3724);
			    }
			    {
			       approx_t then_approx_125_2837;
			       approx_t else_approx_184_2838;
			       {
				  node_t aux_3728;
				  {
				     conditional_t obj_3027;
				     obj_3027 = (conditional_t) (node_2834);
				     aux_3728 = (((conditional_t) CREF(obj_3027))->true);
				  }
				  then_approx_125_2837 = cfa__102_cfa_cfa(aux_3728);
			       }
			       {
				  node_t aux_3732;
				  {
				     conditional_t obj_3028;
				     obj_3028 = (conditional_t) (node_2834);
				     aux_3732 = (((conditional_t) CREF(obj_3028))->false);
				  }
				  else_approx_184_2838 = cfa__102_cfa_cfa(aux_3732);
			       }
			       {
				  approx_t aux_3736;
				  {
				     obj_t aux_3737;
				     {
					object_t aux_3738;
					aux_3738 = (object_t) (node_2834);
					aux_3737 = OBJECT_WIDENING(aux_3738);
				     }
				     aux_3736 = (((conditional_cinfo_212_t) CREF(aux_3737))->approx);
				  }
				  union_approx__241_cfa_approx(aux_3736, then_approx_125_2837);
			       }
			       {
				  approx_t aux_3743;
				  {
				     obj_t aux_3744;
				     {
					object_t aux_3745;
					aux_3745 = (object_t) (node_2834);
					aux_3744 = OBJECT_WIDENING(aux_3745);
				     }
				     aux_3743 = (((conditional_cinfo_212_t) CREF(aux_3744))->approx);
				  }
				  union_approx__241_cfa_approx(aux_3743, else_approx_184_2838);
			       }
			       {
				  approx_t aux_3750;
				  {
				     obj_t aux_3751;
				     {
					object_t aux_3752;
					aux_3752 = (object_t) (node_2834);
					aux_3751 = OBJECT_WIDENING(aux_3752);
				     }
				     aux_3750 = (((conditional_cinfo_212_t) CREF(aux_3751))->approx);
				  }
				  aux_3554 = (obj_t) (aux_3750);
			       }
			    }
			 }
			 break;
		      case ((long) 11):
			 {
			    fail_cinfo_75_t node_2843;
			    node_2843 = (fail_cinfo_75_t) (node_1);
			    {
			       approx_t arg2286_2845;
			       obj_t arg2287_2846;
			       {
				  node_t aux_3758;
				  {
				     fail_t obj_3032;
				     obj_3032 = (fail_t) (node_2843);
				     aux_3758 = (((fail_t) CREF(obj_3032))->proc);
				  }
				  arg2286_2845 = cfa__102_cfa_cfa(aux_3758);
			       }
			       arg2287_2846 = CNST_TABLE_REF(((long) 1));
			       loose__226_cfa_loose(arg2286_2845, arg2287_2846);
			    }
			    {
			       approx_t arg2289_2848;
			       obj_t arg2290_2849;
			       {
				  node_t aux_3764;
				  {
				     fail_t obj_3033;
				     obj_3033 = (fail_t) (node_2843);
				     aux_3764 = (((fail_t) CREF(obj_3033))->msg);
				  }
				  arg2289_2848 = cfa__102_cfa_cfa(aux_3764);
			       }
			       arg2290_2849 = CNST_TABLE_REF(((long) 1));
			       loose__226_cfa_loose(arg2289_2848, arg2290_2849);
			    }
			    {
			       approx_t arg2292_2851;
			       obj_t arg2293_2852;
			       {
				  node_t aux_3770;
				  {
				     fail_t obj_3034;
				     obj_3034 = (fail_t) (node_2843);
				     aux_3770 = (((fail_t) CREF(obj_3034))->obj);
				  }
				  arg2292_2851 = cfa__102_cfa_cfa(aux_3770);
			       }
			       arg2293_2852 = CNST_TABLE_REF(((long) 1));
			       loose__226_cfa_loose(arg2292_2851, arg2293_2852);
			    }
			    {
			       approx_t aux_3776;
			       {
				  obj_t aux_3777;
				  {
				     object_t aux_3778;
				     aux_3778 = (object_t) (node_2843);
				     aux_3777 = OBJECT_WIDENING(aux_3778);
				  }
				  aux_3776 = (((fail_cinfo_75_t) CREF(aux_3777))->approx);
			       }
			       aux_3554 = (obj_t) (aux_3776);
			    }
			 }
			 break;
		      case ((long) 12):
			 {
			    select_cinfo_150_t node_2854;
			    node_2854 = (select_cinfo_150_t) (node_1);
			    {
			       node_t aux_3784;
			       {
				  select_t obj_3036;
				  obj_3036 = (select_t) (node_2854);
				  aux_3784 = (((select_t) CREF(obj_3036))->test);
			       }
			       cfa__102_cfa_cfa(aux_3784);
			    }
			    {
			       approx_t res_approx_73_2857;
			       {
				  obj_t aux_3788;
				  {
				     object_t aux_3789;
				     aux_3789 = (object_t) (node_2854);
				     aux_3788 = OBJECT_WIDENING(aux_3789);
				  }
				  res_approx_73_2857 = (((select_cinfo_150_t) CREF(aux_3788))->approx);
			       }
			       {
				  obj_t cls_2858;
				  {
				     approx_t aux_3793;
				     {
					select_t obj_3038;
					obj_3038 = (select_t) (node_2854);
					cls_2858 = (((select_t) CREF(obj_3038))->clauses);
				     }
				   loop_2859:
				     if (NULLP(cls_2858))
				       {
					  aux_3793 = res_approx_73_2857;
				       }
				     else
				       {
					  approx_t new_approx_178_2862;
					  {
					     node_t aux_3796;
					     {
						obj_t aux_3797;
						{
						   obj_t aux_3798;
						   aux_3798 = CAR(cls_2858);
						   aux_3797 = CDR(aux_3798);
						}
						aux_3796 = (node_t) (aux_3797);
					     }
					     new_approx_178_2862 = cfa__102_cfa_cfa(aux_3796);
					  }
					  union_approx__241_cfa_approx(res_approx_73_2857, new_approx_178_2862);
					  {
					     obj_t cls_3804;
					     cls_3804 = CDR(cls_2858);
					     cls_2858 = cls_3804;
					     goto loop_2859;
					  }
				       }
				     aux_3554 = (obj_t) (aux_3793);
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 13):
			 {
			    let_fun_218_t node_2866;
			    node_2866 = (let_fun_218_t) (node_1);
			    {
			       approx_t aux_3810;
			       aux_3810 = cfa__102_cfa_cfa((((let_fun_218_t) CREF(node_2866))->body));
			       aux_3554 = (obj_t) (aux_3810);
			    }
			 }
			 break;
		      case ((long) 14):
			 {
			    let_var_6_t node_2869;
			    node_2869 = (let_var_6_t) (node_1);
			    {
			       bool_t test2302_2871;
			       {
				  obj_t aux_3815;
				  aux_3815 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2302_2871 = CBOOL(aux_3815);
			       }
			       if (test2302_2871)
				 {
				    obj_t arg2304_2873;
				    arg2304_2873 = shape_tools_shape((obj_t) (node_2869));
				    {
				       obj_t list2305_2874;
				       {
					  obj_t arg2306_2875;
					  {
					     obj_t arg2307_2876;
					     {
						obj_t aux_3823;
						aux_3823 = BCHAR(((unsigned char) '\n'));
						arg2307_2876 = MAKE_PAIR(aux_3823, BNIL);
					     }
					     arg2306_2875 = MAKE_PAIR(arg2304_2873, arg2307_2876);
					  }
					  list2305_2874 = MAKE_PAIR(string2394_cfa_cfa, arg2306_2875);
				       }
				       print_trace_107_tools_trace(list2305_2874);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       obj_t l1891_2880;
			       l1891_2880 = (((let_var_6_t) CREF(node_2869))->bindings);
			     lname1893_2881:
			       if (PAIRP(l1891_2880))
				 {
				    {
				       obj_t binding_2884;
				       binding_2884 = CAR(l1891_2880);
				       {
					  obj_t var_2885;
					  var_2885 = CAR(binding_2884);
					  {
					     approx_t var_approx_58_2886;
					     {
						svar_cinfo_166_t obj_3049;
						{
						   value_t aux_3833;
						   {
						      variable_t obj_3048;
						      obj_3048 = (variable_t) (var_2885);
						      aux_3833 = (((variable_t) CREF(obj_3048))->value);
						   }
						   obj_3049 = (svar_cinfo_166_t) (aux_3833);
						}
						{
						   obj_t aux_3837;
						   {
						      object_t aux_3838;
						      aux_3838 = (object_t) (obj_3049);
						      aux_3837 = OBJECT_WIDENING(aux_3838);
						   }
						   var_approx_58_2886 = (((svar_cinfo_166_t) CREF(aux_3837))->approx);
						}
					     }
					     {
						approx_t val_approx_22_2887;
						{
						   node_t aux_3842;
						   {
						      obj_t aux_3843;
						      aux_3843 = CDR(binding_2884);
						      aux_3842 = (node_t) (aux_3843);
						   }
						   val_approx_22_2887 = cfa__102_cfa_cfa(aux_3842);
						}
						{
						   {
						      type_t vtype_2888;
						      type_t atype_2889;
						      {
							 variable_t obj_3051;
							 obj_3051 = (variable_t) (var_2885);
							 vtype_2888 = (((variable_t) CREF(obj_3051))->type);
						      }
						      atype_2889 = (((approx_t) CREF(val_approx_22_2887))->type);
						      union_approx__241_cfa_approx(var_approx_58_2886, val_approx_22_2887);
						      {
							 bool_t test2313_2890;
							 {
							    obj_t aux_3851;
							    aux_3851 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
							    test2313_2890 = CBOOL(aux_3851);
							 }
							 if (test2313_2890)
							   {
							      obj_t arg2315_2892;
							      obj_t arg2317_2894;
							      obj_t arg2319_2896;
							      obj_t arg2321_2898;
							      obj_t arg2323_2900;
							      arg2315_2892 = shape_tools_shape(binding_2884);
							      arg2317_2894 = shape_tools_shape((obj_t) (var_approx_58_2886));
							      arg2319_2896 = shape_tools_shape((obj_t) (val_approx_22_2887));
							      arg2321_2898 = shape_tools_shape((obj_t) (vtype_2888));
							      arg2323_2900 = shape_tools_shape((obj_t) (atype_2889));
							      {
								 obj_t list2324_2901;
								 {
								    obj_t arg2325_2902;
								    {
								       obj_t arg2326_2903;
								       {
									  obj_t arg2327_2904;
									  {
									     obj_t arg2328_2905;
									     {
										obj_t arg2329_2906;
										{
										   obj_t arg2330_2907;
										   {
										      obj_t arg2331_2908;
										      {
											 obj_t arg2332_2909;
											 {
											    obj_t arg2334_2910;
											    {
											       obj_t arg2335_2911;
											       {
												  obj_t arg2336_2912;
												  {
												     obj_t arg2338_2913;
												     {
													obj_t arg2339_2914;
													{
													   obj_t arg2341_2915;
													   {
													      obj_t aux_3866;
													      aux_3866 = BCHAR(((unsigned char) '\n'));
													      arg2341_2915 = MAKE_PAIR(aux_3866, BNIL);
													   }
													   arg2339_2914 = MAKE_PAIR(arg2323_2900, arg2341_2915);
													}
													arg2338_2913 = MAKE_PAIR(string2395_cfa_cfa, arg2339_2914);
												     }
												     {
													obj_t aux_3871;
													aux_3871 = BCHAR(((unsigned char) '\n'));
													arg2336_2912 = MAKE_PAIR(aux_3871, arg2338_2913);
												     }
												  }
												  arg2335_2911 = MAKE_PAIR(arg2321_2898, arg2336_2912);
											       }
											       arg2334_2910 = MAKE_PAIR(string2396_cfa_cfa, arg2335_2911);
											    }
											    {
											       obj_t aux_3876;
											       aux_3876 = BCHAR(((unsigned char) '\n'));
											       arg2332_2909 = MAKE_PAIR(aux_3876, arg2334_2910);
											    }
											 }
											 arg2331_2908 = MAKE_PAIR(arg2319_2896, arg2332_2909);
										      }
										      arg2330_2907 = MAKE_PAIR(string2397_cfa_cfa, arg2331_2908);
										   }
										   {
										      obj_t aux_3881;
										      aux_3881 = BCHAR(((unsigned char) '\n'));
										      arg2329_2906 = MAKE_PAIR(aux_3881, arg2330_2907);
										   }
										}
										arg2328_2905 = MAKE_PAIR(arg2317_2894, arg2329_2906);
									     }
									     arg2327_2904 = MAKE_PAIR(string2398_cfa_cfa, arg2328_2905);
									  }
									  {
									     obj_t aux_3886;
									     aux_3886 = BCHAR(((unsigned char) '\n'));
									     arg2326_2903 = MAKE_PAIR(aux_3886, arg2327_2904);
									  }
								       }
								       arg2325_2902 = MAKE_PAIR(arg2315_2892, arg2326_2903);
								    }
								    list2324_2901 = MAKE_PAIR(string2399_cfa_cfa, arg2325_2902);
								 }
								 print_trace_107_tools_trace(list2324_2901);
							      }
							   }
							 else
							   {
							      BUNSPEC;
							   }
						      }
						      {
							 bool_t test2346_2919;
							 {
							    bool_t test2348_2921;
							    {
							       obj_t obj2_3054;
							       obj2_3054 = _____74_type_cache;
							       {
								  obj_t aux_3892;
								  aux_3892 = (obj_t) (vtype_2888);
								  test2348_2921 = (aux_3892 == obj2_3054);
							       }
							    }
							    if (test2348_2921)
							      {
								 test2346_2919 = ((bool_t) 0);
							      }
							    else
							      {
								 bool_t test2349_2922;
								 {
								    obj_t obj2_3056;
								    obj2_3056 = __obj__252_type_cache;
								    {
								       obj_t aux_3896;
								       aux_3896 = (obj_t) (vtype_2888);
								       test2349_2922 = (aux_3896 == obj2_3056);
								    }
								 }
								 if (test2349_2922)
								   {
								      test2346_2919 = ((bool_t) 0);
								   }
								 else
								   {
								      bool_t test2350_2923;
								      {
									 obj_t obj2_3058;
									 obj2_3058 = _____74_type_cache;
									 {
									    obj_t aux_3900;
									    aux_3900 = (obj_t) (atype_2889);
									    test2350_2923 = (aux_3900 == obj2_3058);
									 }
								      }
								      if (test2350_2923)
									{
									   test2346_2919 = ((bool_t) 0);
									}
								      else
									{
									   bool_t test_3904;
									   {
									      obj_t aux_3907;
									      obj_t aux_3905;
									      aux_3907 = (obj_t) (vtype_2888);
									      aux_3905 = (obj_t) (atype_2889);
									      test_3904 = (aux_3905 == aux_3907);
									   }
									   if (test_3904)
									     {
										test2346_2919 = ((bool_t) 0);
									     }
									   else
									     {
										test2346_2919 = ((bool_t) 1);
									     }
									}
								   }
							      }
							 }
							 if (test2346_2919)
							   {
							      approx_set_top__187_cfa_approx(val_approx_22_2887);
							      {
								 approx_t aux_3912;
								 aux_3912 = loose__226_cfa_loose(val_approx_22_2887, CNST_TABLE_REF(((long) 1)));
								 (obj_t) (aux_3912);
							      }
							   }
							 else
							   {
							      BUNSPEC;
							   }
						      }
						   }
						}
					     }
					  }
				       }
				    }
				    {
				       obj_t l1891_3916;
				       l1891_3916 = CDR(l1891_2880);
				       l1891_2880 = l1891_3916;
				       goto lname1893_2881;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       approx_t aux_3919;
			       aux_3919 = cfa__102_cfa_cfa((((let_var_6_t) CREF(node_2869))->body));
			       aux_3554 = (obj_t) (aux_3919);
			    }
			 }
			 break;
		      case ((long) 15):
			 {
			    set_ex_it_cinfo_168_t node_2929;
			    node_2929 = (set_ex_it_cinfo_168_t) (node_1);
			    {
			       approx_t arg2356_2931;
			       obj_t arg2357_2932;
			       {
				  node_t aux_3924;
				  {
				     set_ex_it_116_t obj_3063;
				     obj_3063 = (set_ex_it_116_t) (node_2929);
				     aux_3924 = (((set_ex_it_116_t) CREF(obj_3063))->body);
				  }
				  arg2356_2931 = cfa__102_cfa_cfa(aux_3924);
			       }
			       arg2357_2932 = CNST_TABLE_REF(((long) 1));
			       loose__226_cfa_loose(arg2356_2931, arg2357_2932);
			    }
			    {
			       approx_t aux_3930;
			       {
				  obj_t aux_3931;
				  {
				     object_t aux_3932;
				     aux_3932 = (object_t) (node_2929);
				     aux_3931 = OBJECT_WIDENING(aux_3932);
				  }
				  aux_3930 = (((set_ex_it_cinfo_168_t) CREF(aux_3931))->approx);
			       }
			       aux_3554 = (obj_t) (aux_3930);
			    }
			 }
			 break;
		      case ((long) 16):
			 {
			    jump_ex_it_cinfo_139_t node_2934;
			    node_2934 = (jump_ex_it_cinfo_139_t) (node_1);
			    {
			       node_t aux_3938;
			       {
				  jump_ex_it_184_t obj_3065;
				  obj_3065 = (jump_ex_it_184_t) (node_2934);
				  aux_3938 = (((jump_ex_it_184_t) CREF(obj_3065))->exit);
			       }
			       cfa__102_cfa_cfa(aux_3938);
			    }
			    {
			       approx_t val_approx_22_2937;
			       {
				  node_t aux_3942;
				  {
				     jump_ex_it_184_t obj_3066;
				     obj_3066 = (jump_ex_it_184_t) (node_2934);
				     aux_3942 = (((jump_ex_it_184_t) CREF(obj_3066))->value);
				  }
				  val_approx_22_2937 = cfa__102_cfa_cfa(aux_3942);
			       }
			       loose__226_cfa_loose(val_approx_22_2937, CNST_TABLE_REF(((long) 1)));
			       {
				  approx_t aux_3948;
				  {
				     obj_t aux_3949;
				     {
					object_t aux_3950;
					aux_3950 = (object_t) (node_2934);
					aux_3949 = OBJECT_WIDENING(aux_3950);
				     }
				     aux_3948 = (((jump_ex_it_cinfo_139_t) CREF(aux_3949))->approx);
				  }
				  aux_3554 = (obj_t) (aux_3948);
			       }
			    }
			 }
			 break;
		      case ((long) 17):
			 {
			    make_box_cinfo_127_t node_2940;
			    node_2940 = (make_box_cinfo_127_t) (node_1);
			    {
			       bool_t test2362_2942;
			       {
				  obj_t aux_3956;
				  aux_3956 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2362_2942 = CBOOL(aux_3956);
			       }
			       if (test2362_2942)
				 {
				    obj_t arg2364_2944;
				    {
				       obj_t aux_3962;
				       {
					  node_t aux_3963;
					  {
					     make_box_202_t obj_3068;
					     obj_3068 = (make_box_202_t) (node_2940);
					     aux_3963 = (((make_box_202_t) CREF(obj_3068))->value);
					  }
					  aux_3962 = (obj_t) (aux_3963);
				       }
				       arg2364_2944 = shape_tools_shape(aux_3962);
				    }
				    {
				       obj_t list2365_2945;
				       {
					  obj_t arg2366_2946;
					  {
					     obj_t arg2367_2947;
					     {
						obj_t aux_3968;
						aux_3968 = BCHAR(((unsigned char) '\n'));
						arg2367_2947 = MAKE_PAIR(aux_3968, BNIL);
					     }
					     arg2366_2946 = MAKE_PAIR(arg2364_2944, arg2367_2947);
					  }
					  list2365_2945 = MAKE_PAIR(string2400_cfa_cfa, arg2366_2946);
				       }
				       print_trace_107_tools_trace(list2365_2945);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       approx_t arg2372_2952;
			       obj_t arg2373_2953;
			       {
				  node_t aux_3974;
				  {
				     make_box_202_t obj_3069;
				     obj_3069 = (make_box_202_t) (node_2940);
				     aux_3974 = (((make_box_202_t) CREF(obj_3069))->value);
				  }
				  arg2372_2952 = cfa__102_cfa_cfa(aux_3974);
			       }
			       arg2373_2953 = CNST_TABLE_REF(((long) 1));
			       loose__226_cfa_loose(arg2372_2952, arg2373_2953);
			    }
			    {
			       approx_t aux_3980;
			       {
				  obj_t aux_3981;
				  {
				     object_t aux_3982;
				     aux_3982 = (object_t) (node_2940);
				     aux_3981 = OBJECT_WIDENING(aux_3982);
				  }
				  aux_3980 = (((make_box_cinfo_127_t) CREF(aux_3981))->approx);
			       }
			       aux_3554 = (obj_t) (aux_3980);
			    }
			 }
			 break;
		      case ((long) 18):
			 {
			    box_set__cinfo_94_t node_2955;
			    node_2955 = (box_set__cinfo_94_t) (node_1);
			    {
			       node_t aux_3988;
			       {
				  var_t aux_3989;
				  {
				     box_set__221_t obj_3071;
				     obj_3071 = (box_set__221_t) (node_2955);
				     aux_3989 = (((box_set__221_t) CREF(obj_3071))->var);
				  }
				  aux_3988 = (node_t) (aux_3989);
			       }
			       cfa__102_cfa_cfa(aux_3988);
			    }
			    {
			       approx_t arg2376_2958;
			       obj_t arg2377_2959;
			       {
				  node_t aux_3994;
				  {
				     box_set__221_t obj_3072;
				     obj_3072 = (box_set__221_t) (node_2955);
				     aux_3994 = (((box_set__221_t) CREF(obj_3072))->value);
				  }
				  arg2376_2958 = cfa__102_cfa_cfa(aux_3994);
			       }
			       arg2377_2959 = CNST_TABLE_REF(((long) 1));
			       loose__226_cfa_loose(arg2376_2958, arg2377_2959);
			    }
			    {
			       approx_t aux_4000;
			       {
				  obj_t aux_4001;
				  {
				     object_t aux_4002;
				     aux_4002 = (object_t) (node_2955);
				     aux_4001 = OBJECT_WIDENING(aux_4002);
				  }
				  aux_4000 = (((box_set__cinfo_94_t) CREF(aux_4001))->approx);
			       }
			       aux_3554 = (obj_t) (aux_4000);
			    }
			 }
			 break;
		      case ((long) 19):
			 {
			    box_ref_cinfo_214_t node_2961;
			    node_2961 = (box_ref_cinfo_214_t) (node_1);
			    {
			       node_t aux_4008;
			       {
				  var_t aux_4009;
				  {
				     box_ref_242_t obj_3074;
				     obj_3074 = (box_ref_242_t) (node_2961);
				     aux_4009 = (((box_ref_242_t) CREF(obj_3074))->var);
				  }
				  aux_4008 = (node_t) (aux_4009);
			       }
			       cfa__102_cfa_cfa(aux_4008);
			    }
			    {
			       approx_t aux_4014;
			       {
				  obj_t aux_4015;
				  {
				     object_t aux_4016;
				     aux_4016 = (object_t) (node_2961);
				     aux_4015 = OBJECT_WIDENING(aux_4016);
				  }
				  aux_4014 = (((box_ref_cinfo_214_t) CREF(aux_4015))->approx);
			       }
			       aux_3554 = (obj_t) (aux_4014);
			    }
			 }
			 break;
		      default:
		       case_else2208_236_2749:
			 if (PROCEDUREP(method2202_2745))
			   {
			      aux_3554 = PROCEDURE_ENTRY(method2202_2745) (method2202_2745, (obj_t) (node_1), BEOA);
			   }
			 else
			   {
			      obj_t fun1928_1961;
			      fun1928_1961 = PROCEDURE_REF(cfa__env_153_cfa_cfa, ((long) 0));
			      aux_3554 = PROCEDURE_ENTRY(fun1928_1961) (fun1928_1961, (obj_t) (node_1), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else2208_236_2749;
		 }
	    }
	    return (approx_t) (aux_3554);
	 }
      }
   }
}


obj_t 
_cfa__186_cfa_cfa(obj_t env_3462, obj_t node_3463)
{
   {
      approx_t aux_4033;
      aux_4033 = cfa__102_cfa_cfa((node_t) (node_3463));
      return (obj_t) (aux_4033);
   }
}


obj_t 
cfa_variable_value_approx_default1905_106_cfa_cfa(value_t value_9)
{
   FAILURE(CNST_TABLE_REF(((long) 2)), string2401_cfa_cfa, (obj_t) (value_9));
}


obj_t 
_cfa_variable_value_approx_default1905_161_cfa_cfa(obj_t env_3468, obj_t value_3469)
{
   return cfa_variable_value_approx_default1905_106_cfa_cfa((value_t) (value_3469));
}


obj_t 
cfa_variable_value_approx_39_cfa_cfa(value_t value_8)
{
   {
      obj_t method2184_2716;
      obj_t class2189_2717;
      {
	 obj_t arg2192_2714;
	 obj_t arg2193_2715;
	 {
	    object_t obj_3083;
	    obj_3083 = (object_t) (value_8);
	    {
	       obj_t pre_method_105_3084;
	       pre_method_105_3084 = PROCEDURE_REF(cfa_variable_value_approx_env_230_cfa_cfa, ((long) 2));
	       if (INTEGERP(pre_method_105_3084))
		 {
		    PROCEDURE_SET(cfa_variable_value_approx_env_230_cfa_cfa, ((long) 2), BUNSPEC);
		    arg2192_2714 = pre_method_105_3084;
		 }
	       else
		 {
		    long obj_class_num_177_3089;
		    obj_class_num_177_3089 = TYPE(obj_3083);
		    {
		       obj_t arg1183_3090;
		       arg1183_3090 = PROCEDURE_REF(cfa_variable_value_approx_env_230_cfa_cfa, ((long) 1));
		       {
			  long arg1184_3094;
			  {
			     long arg1186_3095;
			     arg1186_3095 = OBJECT_TYPE;
			     arg1184_3094 = (obj_class_num_177_3089 - arg1186_3095);
			  }
			  arg2192_2714 = VECTOR_REF(arg1183_3090, arg1184_3094);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_3100;
	    object_3100 = (object_t) (value_8);
	    {
	       long arg1187_3101;
	       {
		  long arg1188_3102;
		  long arg1189_3103;
		  arg1188_3102 = TYPE(object_3100);
		  arg1189_3103 = OBJECT_TYPE;
		  arg1187_3101 = (arg1188_3102 - arg1189_3103);
	       }
	       {
		  obj_t vector_3107;
		  vector_3107 = __classes__134___object;
		  arg2193_2715 = VECTOR_REF(vector_3107, arg1187_3101);
	       }
	    }
	 }
	 method2184_2716 = arg2192_2714;
	 class2189_2717 = arg2193_2715;
	 {
	    if (INTEGERP(method2184_2716))
	      {
		 switch ((long) CINT(method2184_2716))
		   {
		   case ((long) 0):
		      {
			 svar_cinfo_166_t value_2723;
			 value_2723 = (svar_cinfo_166_t) (value_8);
			 {
			    approx_t aux_4060;
			    {
			       obj_t aux_4061;
			       {
				  object_t aux_4062;
				  aux_4062 = (object_t) (value_2723);
				  aux_4061 = OBJECT_WIDENING(aux_4062);
			       }
			       aux_4060 = (((svar_cinfo_166_t) CREF(aux_4061))->approx);
			    }
			    return (obj_t) (aux_4060);
			 }
		      }
		      break;
		   case ((long) 1):
		      {
			 scnst_cinfo_0_t value_2725;
			 value_2725 = (scnst_cinfo_0_t) (value_8);
			 {
			    approx_t aux_4068;
			    {
			       obj_t aux_4069;
			       {
				  object_t aux_4070;
				  aux_4070 = (object_t) (value_2725);
				  aux_4069 = OBJECT_WIDENING(aux_4070);
			       }
			       aux_4068 = (((scnst_cinfo_0_t) CREF(aux_4069))->approx);
			    }
			    return (obj_t) (aux_4068);
			 }
		      }
		      break;
		   case ((long) 2):
		      {
			 cvar_cinfo_53_t value_2727;
			 value_2727 = (cvar_cinfo_53_t) (value_8);
			 {
			    approx_t aux_4076;
			    {
			       obj_t aux_4077;
			       {
				  object_t aux_4078;
				  aux_4078 = (object_t) (value_2727);
				  aux_4077 = OBJECT_WIDENING(aux_4078);
			       }
			       aux_4076 = (((cvar_cinfo_53_t) CREF(aux_4077))->approx);
			    }
			    return (obj_t) (aux_4076);
			 }
		      }
		      break;
		   case ((long) 3):
		      {
			 sexit_cinfo_49_t value_2729;
			 value_2729 = (sexit_cinfo_49_t) (value_8);
			 {
			    approx_t aux_4084;
			    {
			       obj_t aux_4085;
			       {
				  object_t aux_4086;
				  aux_4086 = (object_t) (value_2729);
				  aux_4085 = OBJECT_WIDENING(aux_4086);
			       }
			       aux_4084 = (((sexit_cinfo_49_t) CREF(aux_4085))->approx);
			    }
			    return (obj_t) (aux_4084);
			 }
		      }
		      break;
		   case ((long) 4):
		      {
			 intern_sfun_cinfo_192_t value_2731;
			 value_2731 = (intern_sfun_cinfo_192_t) (value_8);
			 {
			    approx_t aux_4092;
			    {
			       obj_t aux_4093;
			       {
				  object_t aux_4094;
				  aux_4094 = (object_t) (value_2731);
				  aux_4093 = OBJECT_WIDENING(aux_4094);
			       }
			       aux_4092 = (((intern_sfun_cinfo_192_t) CREF(aux_4093))->approx);
			    }
			    return (obj_t) (aux_4092);
			 }
		      }
		      break;
		   default:
		    case_else2190_117_2720:
		      if (PROCEDUREP(method2184_2716))
			{
			   return PROCEDURE_ENTRY(method2184_2716) (method2184_2716, (obj_t) (value_8), BEOA);
			}
		      else
			{
			   obj_t fun1932_1964;
			   fun1932_1964 = PROCEDURE_REF(cfa_variable_value_approx_env_230_cfa_cfa, ((long) 0));
			   return PROCEDURE_ENTRY(fun1932_1964) (fun1932_1964, (obj_t) (value_8), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else2190_117_2720;
	      }
	 }
      }
   }
}


obj_t 
_cfa_variable_value_approx_165_cfa_cfa(obj_t env_3466, obj_t value_3467)
{
   return cfa_variable_value_approx_39_cfa_cfa((value_t) (value_3467));
}


obj_t 
imported_modules_init_94_cfa_cfa()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_CFA");
   module_initialization_70_tools_shape(((long) 0), "CFA_CFA");
   module_initialization_70_tools_error(((long) 0), "CFA_CFA");
   module_initialization_70_type_type(((long) 0), "CFA_CFA");
   module_initialization_70_type_cache(((long) 0), "CFA_CFA");
   module_initialization_70_ast_var(((long) 0), "CFA_CFA");
   module_initialization_70_ast_node(((long) 0), "CFA_CFA");
   module_initialization_70_cfa_info(((long) 0), "CFA_CFA");
   module_initialization_70_cfa_loose(((long) 0), "CFA_CFA");
   module_initialization_70_cfa_approx(((long) 0), "CFA_CFA");
   module_initialization_70_cfa_app(((long) 0), "CFA_CFA");
   return module_initialization_70_cfa_funcall(((long) 0), "CFA_CFA");
}
