/*===========================================================================*/
/*   (Cfa/closure.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


extern obj_t get_node_atom_value_135_cfa_approx(node_t);
static obj_t __procedure_l_ref__76_cfa_closure = BUNSPEC;
static obj_t __procedure_ref_list__19_cfa_closure = BUNSPEC;
static obj_t __procedure_1_el_set___97_cfa_closure = BUNSPEC;
extern obj_t __procedure__226_type_cache;
extern obj_t set_length_165_cfa_set(obj_t);
static obj_t __procedure_ref__66_cfa_closure = BUNSPEC;
static bool_t light_access__52_cfa_closure();
extern obj_t scnst_ast_var;
static bool_t light_make_procedure__143_cfa_closure();
static obj_t stop_cache_174_cfa_closure();
extern obj_t global_ast_var;
extern obj_t _closure_optimization__207_cfa_closure(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_cfa_closure();
extern obj_t module_initialization_70_cfa_closure(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_set(long, char *);
extern obj_t module_initialization_70_cfa_stack(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_cfa_closure();
static obj_t cnst_init_137_cfa_closure();
extern obj_t __optim__89_engine_param;
static obj_t __procedure_el_set___46_cfa_closure = BUNSPEC;
static obj_t show_x_t_233_cfa_closure(obj_t);
static bool_t x__157_cfa_closure(obj_t);
extern obj_t _closure_optimization__187_cfa_closure(obj_t);
extern obj_t add_funcall__195_cfa_closure(node_t);
extern obj_t __unsafe_type__146_engine_param;
static obj_t require_initialization_114_cfa_closure = BUNSPEC;
extern obj_t make_procedure_app_48_cfa_info;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cfa_closure();
extern obj_t closure_optimization__75_cfa_closure();
static obj_t __procedure_set___197_cfa_closure = BUNSPEC;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
static obj_t __procedure_1_el_ref__37_cfa_closure = BUNSPEC;
extern obj_t read___reader(obj_t);
static obj_t __procedure_el_ref__61_cfa_closure = BUNSPEC;
extern obj_t _add_procedure_ref__99_cfa_closure(obj_t, obj_t);
static obj_t __procedure_l_set___202_cfa_closure = BUNSPEC;
extern obj_t open_input_string(obj_t);
static obj_t show_cfa_closure(obj_t, obj_t);
static obj_t arg20452605_cfa_closure(obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern approx_t cfa__102_cfa_cfa(node_t);
extern obj_t _add_funcall__114_cfa_closure(obj_t, obj_t);
static obj_t t_fix_point__90_cfa_closure(obj_t);
extern obj_t shape_tools_shape(obj_t);
extern node_t stack__132_cfa_stack(node_t);
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_t);
static obj_t __make_el_procedure__202_cfa_closure = BUNSPEC;
extern obj_t closure_optimization__48_cfa_closure();
static obj_t __make_procedure_list__56_cfa_closure = BUNSPEC;
static bool_t light_funcall__169_cfa_closure();
extern obj_t _add_make_procedure__196_cfa_closure(obj_t, obj_t);
static obj_t start_cache_11_cfa_closure();
extern obj_t set__list_248_cfa_set(obj_t);
static obj_t arg20162604_cfa_closure(obj_t, obj_t);
static obj_t __make_l_procedure__54_cfa_closure = BUNSPEC;
extern obj_t add_make_procedure__219_cfa_closure(node_t);
extern obj_t add_procedure_ref__36_cfa_closure(node_t);
extern bool_t stack_optimization__133_cfa_stack();
static obj_t __funcall_list__139_cfa_closure = BUNSPEC;
extern obj_t find_global_223_ast_env(obj_t, obj_t);
static obj_t __make_el_procedure_1__141_cfa_closure = BUNSPEC;
static obj_t __cnst[22];

DEFINE_STRING(string2610_cfa_closure, string2610_cfa_closure2641, "light?: ", 8);
DEFINE_STRING(string2616_cfa_closure, string2616_cfa_closure2642, " may be X and T.", 16);
DEFINE_STRING(string2606_cfa_closure, string2606_cfa_closure2643, "   . Light closures", 19);
DEFINE_STATIC_PROCEDURE(proc2620_cfa_closure, arg20162604_cfa_closure2644, arg20162604_cfa_closure, 0L, 1);
DEFINE_STRING(string2612_cfa_closure, string2612_cfa_closure2645, "        size : ", 15);
DEFINE_EXPORT_PROCEDURE(add_funcall__env_57_cfa_closure, _add_funcall__114_cfa_closure2646, _add_funcall__114_cfa_closure, 0L, 1);
DEFINE_STRING(string2613_cfa_closure, string2613_cfa_closure2647, "        X-T?: ", 14);
DEFINE_STRING(string2635_cfa_closure, string2635_cfa_closure2648, "MAKE-L-PROCEDURE MAKE-EL-PROCEDURE-1 MAKE-EL-PROCEDURE PROCEDURE-1-EL-SET! PROCEDURE-1-EL-REF PROCEDURE-EL-SET! PROCEDURE-EL-REF PROCEDURE-L-SET! PROCEDURE-L-REF PROCEDURE-SET! FOREIGN PROCEDURE-REF T X LIGHT ELIGHT NOTHING-TO-DO SELFUN SEFUN DONE OK CFA ", 255);
DEFINE_STRING(string2617_cfa_closure, string2617_cfa_closure2649, "X! ... ", 7);
DEFINE_STRING(string2621_cfa_closure, string2621_cfa_closure2650, "ok.\n", 4);
DEFINE_STRING(string2607_cfa_closure, string2607_cfa_closure2651, "closure-optimization! :", 23);
DEFINE_EXPORT_PROCEDURE(closure_optimization__env_164_cfa_closure, _closure_optimization__207_cfa_closure2652, _closure_optimization__207_cfa_closure, 0L, 0);
DEFINE_EXPORT_PROCEDURE(add_procedure_ref__env_174_cfa_closure, _add_procedure_ref__99_cfa_closure2653, _add_procedure_ref__99_cfa_closure, 0L, 1);
DEFINE_STRING(string2619_cfa_closure, string2619_cfa_closure2654, "nok (top?)", 10);
DEFINE_STATIC_PROCEDURE(proc2622_cfa_closure, arg20452605_cfa_closure2655, arg20452605_cfa_closure, 0L, 1);
DEFINE_STRING(string2608_cfa_closure, string2608_cfa_closure2656, "--------------------------------------", 38);
DEFINE_STRING(string2629_cfa_closure, string2629_cfa_closure2657, "extra-light", 11);
DEFINE_EXPORT_PROCEDURE(add_make_procedure__env_11_cfa_closure, _add_make_procedure__196_cfa_closure2658, _add_make_procedure__196_cfa_closure, 0L, 1);
DEFINE_STRING(string2623_cfa_closure, string2623_cfa_closure2659, "nok: ", 5);
DEFINE_STRING(string2634_cfa_closure, string2634_cfa_closure2660, "        ", 8);
DEFINE_STRING(string2626_cfa_closure, string2626_cfa_closure2661, "      one-non-T?: ", 18);
DEFINE_STRING(string2631_cfa_closure, string2631_cfa_closure2662, "heavy2", 6);
DEFINE_STRING(string2618_cfa_closure, string2618_cfa_closure2663, "funcall: ", 9);
DEFINE_STRING(string2628_cfa_closure, string2628_cfa_closure2664, "heavy1", 6);
DEFINE_STRING(string2615_cfa_closure, string2615_cfa_closure2665, " can't be X nor T because: ", 27);
DEFINE_EXPORT_PROCEDURE(closure_optimization__env_163_cfa_closure, _closure_optimization__187_cfa_closure2666, _closure_optimization__187_cfa_closure, 0L, 0);
DEFINE_STRING(string2633_cfa_closure, string2633_cfa_closure2667, "     ", 5);
DEFINE_STRING(string2624_cfa_closure, string2624_cfa_closure2668, "T-fix-point! ... ", 17);
DEFINE_STRING(string2609_cfa_closure, string2609_cfa_closure2669, " ... ", 5);
DEFINE_STRING(string2614_cfa_closure, string2614_cfa_closure2670, "        lost?: ", 15);
DEFINE_STRING(string2611_cfa_closure, string2611_cfa_closure2671, "        arity: ", 15);
DEFINE_STRING(string2630_cfa_closure, string2630_cfa_closure2672, "light", 5);
DEFINE_STRING(string2627_cfa_closure, string2627_cfa_closure2673, "light-funcall!: ", 16);
DEFINE_STRING(string2632_cfa_closure, string2632_cfa_closure2674, ": ", 2);
DEFINE_STRING(string2625_cfa_closure, string2625_cfa_closure2675, "          allocs: ", 18);

obj_t 
module_initialization_70_cfa_closure(long checksum_3848, char *from_3849)
{
   if (CBOOL(require_initialization_114_cfa_closure))
     {
	require_initialization_114_cfa_closure = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_closure();
	cnst_init_137_cfa_closure();
	imported_modules_init_94_cfa_closure();
	toplevel_init_63_cfa_closure();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_closure()
{
   module_initialization_70___object(((long) 0), "CFA_CLOSURE");
   module_initialization_70___reader(((long) 0), "CFA_CLOSURE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_closure()
{
   {
      obj_t cnst_port_138_3840;
      cnst_port_138_3840 = open_input_string(string2635_cfa_closure);
      {
	 long i_3841;
	 i_3841 = ((long) 21);
       loop_3842:
	 {
	    bool_t test2636_3843;
	    test2636_3843 = (i_3841 == ((long) -1));
	    if (test2636_3843)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2637_3844;
		    {
		       obj_t list2638_3845;
		       {
			  obj_t arg2639_3846;
			  arg2639_3846 = BNIL;
			  list2638_3845 = MAKE_PAIR(cnst_port_138_3840, arg2639_3846);
		       }
		       arg2637_3844 = read___reader(list2638_3845);
		    }
		    CNST_TABLE_SET(i_3841, arg2637_3844);
		 }
		 {
		    int aux_3847;
		    {
		       long aux_3865;
		       aux_3865 = (i_3841 - ((long) 1));
		       aux_3847 = (int) (aux_3865);
		    }
		    {
		       long i_3868;
		       i_3868 = (long) (aux_3847);
		       i_3841 = i_3868;
		       goto loop_3842;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_closure()
{
   __funcall_list__139_cfa_closure = BNIL;
   __make_procedure_list__56_cfa_closure = BNIL;
   __procedure_ref_list__19_cfa_closure = BNIL;
   __procedure_ref__66_cfa_closure = BFALSE;
   __procedure_set___197_cfa_closure = BFALSE;
   __procedure_l_ref__76_cfa_closure = BFALSE;
   __procedure_l_set___202_cfa_closure = BFALSE;
   __procedure_el_ref__61_cfa_closure = BFALSE;
   __procedure_el_set___46_cfa_closure = BFALSE;
   __procedure_1_el_ref__37_cfa_closure = BFALSE;
   __procedure_1_el_set___97_cfa_closure = BFALSE;
   __make_el_procedure__202_cfa_closure = BFALSE;
   __make_el_procedure_1__141_cfa_closure = BFALSE;
   return (__make_l_procedure__54_cfa_closure = BFALSE,
      BUNSPEC);
}


obj_t 
closure_optimization__75_cfa_closure()
{
   {
      long n1_3169;
      n1_3169 = (long) CINT(__optim__89_engine_param);
      {
	 bool_t aux_3871;
	 aux_3871 = (n1_3169 >= ((long) 2));
	 return BBOOL(aux_3871);
      }
   }
}


obj_t 
_closure_optimization__187_cfa_closure(obj_t env_3805)
{
   return closure_optimization__75_cfa_closure();
}


obj_t 
closure_optimization__48_cfa_closure()
{
   {
      bool_t test1903_1937;
      {
	 long n1_3171;
	 n1_3171 = (long) CINT(__optim__89_engine_param);
	 test1903_1937 = (n1_3171 >= ((long) 2));
      }
      if (test1903_1937)
	{
	   {
	      obj_t list1904_1938;
	      {
		 obj_t arg1906_1940;
		 {
		    obj_t aux_3878;
		    aux_3878 = BCHAR(((unsigned char) '\n'));
		    arg1906_1940 = MAKE_PAIR(aux_3878, BNIL);
		 }
		 list1904_1938 = MAKE_PAIR(string2606_cfa_closure, arg1906_1940);
	      }
	      verbose_tools_speek(BINT(((long) 1)), list1904_1938);
	   }
	   {
	      bool_t test1908_1942;
	      {
		 obj_t aux_3884;
		 aux_3884 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
		 test1908_1942 = CBOOL(aux_3884);
	      }
	      if (test1908_1942)
		{
		   obj_t arg1912_1945;
		   arg1912_1945 = shape_tools_shape(__make_procedure_list__56_cfa_closure);
		   {
		      obj_t list1913_1946;
		      {
			 obj_t arg1914_1947;
			 {
			    obj_t arg1915_1948;
			    {
			       obj_t arg1916_1949;
			       {
				  obj_t arg1917_1950;
				  {
				     obj_t arg1918_1951;
				     {
					obj_t aux_3891;
					aux_3891 = BCHAR(((unsigned char) '\n'));
					arg1918_1951 = MAKE_PAIR(aux_3891, BNIL);
				     }
				     arg1917_1950 = MAKE_PAIR(arg1912_1945, arg1918_1951);
				  }
				  {
				     obj_t aux_3895;
				     aux_3895 = BCHAR(((unsigned char) '\n'));
				     arg1916_1949 = MAKE_PAIR(aux_3895, arg1917_1950);
				  }
			       }
			       arg1915_1948 = MAKE_PAIR(string2607_cfa_closure, arg1916_1949);
			    }
			    {
			       obj_t aux_3899;
			       aux_3899 = BCHAR(((unsigned char) '\n'));
			       arg1914_1947 = MAKE_PAIR(aux_3899, arg1915_1948);
			    }
			 }
			 list1913_1946 = MAKE_PAIR(string2608_cfa_closure, arg1914_1947);
		      }
		      print_trace_107_tools_trace(list1913_1946);
		   }
		}
	      else
		{
		   BUNSPEC;
		}
	   }
	   start_cache_11_cfa_closure();
	   {
	      obj_t l1870_1955;
	      l1870_1955 = __make_procedure_list__56_cfa_closure;
	    lname1871_1956:
	      if (PAIRP(l1870_1955))
		{
		   {
		      obj_t app_1958;
		      app_1958 = CAR(l1870_1955);
		      {
			 variable_t fun_1960;
			 bool_t lost__227_1961;
			 obj_t size_1962;
			 {
			    var_t obj_3177;
			    {
			       obj_t aux_3908;
			       {
				  obj_t aux_3909;
				  {
				     app_t obj_3175;
				     obj_3175 = (app_t) (app_1958);
				     aux_3909 = (((app_t) CREF(obj_3175))->args);
				  }
				  aux_3908 = CAR(aux_3909);
			       }
			       obj_3177 = (var_t) (aux_3908);
			    }
			    fun_1960 = (((var_t) CREF(obj_3177))->variable);
			 }
			 {
			    long aux_3915;
			    {
			       make_procedure_app_48_t obj_3178;
			       obj_3178 = (make_procedure_app_48_t) (app_1958);
			       {
				  obj_t aux_3917;
				  {
				     object_t aux_3918;
				     aux_3918 = (object_t) (obj_3178);
				     aux_3917 = OBJECT_WIDENING(aux_3918);
				  }
				  aux_3915 = (((make_procedure_app_48_t) CREF(aux_3917))->lost_stamp_114);
			       }
			    }
			    lost__227_1961 = (aux_3915 > ((long) -1));
			 }
			 {
			    node_t aux_3923;
			    {
			       obj_t aux_3924;
			       {
				  obj_t aux_3925;
				  {
				     obj_t aux_3926;
				     {
					obj_t aux_3927;
					{
					   app_t obj_3181;
					   obj_3181 = (app_t) (app_1958);
					   aux_3927 = (((app_t) CREF(obj_3181))->args);
					}
					aux_3926 = CDR(aux_3927);
				     }
				     aux_3925 = CDR(aux_3926);
				  }
				  aux_3924 = CAR(aux_3925);
			       }
			       aux_3923 = (node_t) (aux_3924);
			    }
			    size_1962 = get_node_atom_value_135_cfa_approx(aux_3923);
			 }
			 {
			    bool_t test1925_1963;
			    {
			       obj_t aux_3935;
			       aux_3935 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
			       test1925_1963 = CBOOL(aux_3935);
			    }
			    if (test1925_1963)
			      {
				 obj_t arg1927_1965;
				 arg1927_1965 = shape_tools_shape(app_1958);
				 {
				    obj_t list1929_1967;
				    {
				       obj_t arg1931_1968;
				       {
					  obj_t arg1932_1969;
					  arg1932_1969 = MAKE_PAIR(string2609_cfa_closure, BNIL);
					  arg1931_1968 = MAKE_PAIR(arg1927_1965, arg1932_1969);
				       }
				       list1929_1967 = MAKE_PAIR(string2610_cfa_closure, arg1931_1968);
				    }
				    print_trace_107_tools_trace(list1929_1967);
				 }
			      }
			    else
			      {
				 BUNSPEC;
			      }
			 }
			 {
			    bool_t test_3946;
			    if (lost__227_1961)
			      {
				 test_3946 = ((bool_t) 1);
			      }
			    else
			      {
				 bool_t test_3948;
				 {
				    make_procedure_app_48_t obj_3188;
				    obj_3188 = (make_procedure_app_48_t) (app_1958);
				    {
				       obj_t aux_3950;
				       {
					  object_t aux_3951;
					  aux_3951 = (object_t) (obj_3188);
					  aux_3950 = OBJECT_WIDENING(aux_3951);
				       }
				       test_3948 = (((make_procedure_app_48_t) CREF(aux_3950))->x_t__142);
				    }
				 }
				 if (test_3948)
				   {
				      bool_t test_3955;
				      {
					 long aux_3956;
					 {
					    sfun_t obj_3190;
					    {
					       value_t aux_3957;
					       {
						  global_t obj_3189;
						  obj_3189 = (global_t) (fun_1960);
						  aux_3957 = (((global_t) CREF(obj_3189))->value);
					       }
					       obj_3190 = (sfun_t) (aux_3957);
					    }
					    aux_3956 = (((sfun_t) CREF(obj_3190))->arity);
					 }
					 test_3955 = (aux_3956 < ((long) 0));
				      }
				      if (test_3955)
					{
					   test_3946 = ((bool_t) 1);
					}
				      else
					{
					   if (INTEGERP(size_1962))
					     {
						long aux_3965;
						aux_3965 = (long) CINT(size_1962);
						test_3946 = (aux_3965 == ((long) 0));
					     }
					   else
					     {
						test_3946 = ((bool_t) 1);
					     }
					}
				   }
				 else
				   {
				      test_3946 = ((bool_t) 1);
				   }
			      }
			    if (test_3946)
			      {
				 {
				    bool_t test1938_1974;
				    {
				       obj_t aux_3968;
				       aux_3968 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				       test1938_1974 = CBOOL(aux_3968);
				    }
				    if (test1938_1974)
				      {
					 bool_t arg1942_1978;
					 long arg1945_1981;
					 {
					    make_procedure_app_48_t obj_3196;
					    obj_3196 = (make_procedure_app_48_t) (app_1958);
					    {
					       obj_t aux_3975;
					       {
						  object_t aux_3976;
						  aux_3976 = (object_t) (obj_3196);
						  aux_3975 = OBJECT_WIDENING(aux_3976);
					       }
					       arg1942_1978 = (((make_procedure_app_48_t) CREF(aux_3975))->x_t__142);
					    }
					 }
					 {
					    sfun_t obj_3198;
					    {
					       value_t aux_3980;
					       {
						  global_t obj_3197;
						  obj_3197 = (global_t) (fun_1960);
						  aux_3980 = (((global_t) CREF(obj_3197))->value);
					       }
					       obj_3198 = (sfun_t) (aux_3980);
					    }
					    arg1945_1981 = (((sfun_t) CREF(obj_3198))->arity);
					 }
					 {
					    obj_t list1946_1982;
					    {
					       obj_t arg1947_1983;
					       {
						  obj_t arg1948_1984;
						  {
						     obj_t arg1949_1985;
						     {
							obj_t arg1950_1986;
							{
							   obj_t arg1951_1987;
							   {
							      obj_t arg1952_1988;
							      {
								 obj_t arg1953_1989;
								 {
								    obj_t arg1954_1990;
								    {
								       obj_t arg1956_1991;
								       {
									  obj_t arg1957_1992;
									  {
									     obj_t arg1958_1993;
									     {
										obj_t arg1960_1994;
										{
										   obj_t arg1963_1995;
										   {
										      obj_t aux_3985;
										      aux_3985 = BCHAR(((unsigned char) '\n'));
										      arg1963_1995 = MAKE_PAIR(aux_3985, BNIL);
										   }
										   {
										      obj_t aux_3988;
										      aux_3988 = BINT(arg1945_1981);
										      arg1960_1994 = MAKE_PAIR(aux_3988, arg1963_1995);
										   }
										}
										arg1958_1993 = MAKE_PAIR(string2611_cfa_closure, arg1960_1994);
									     }
									     {
										obj_t aux_3992;
										aux_3992 = BCHAR(((unsigned char) '\n'));
										arg1957_1992 = MAKE_PAIR(aux_3992, arg1958_1993);
									     }
									  }
									  arg1956_1991 = MAKE_PAIR(size_1962, arg1957_1992);
								       }
								       arg1954_1990 = MAKE_PAIR(string2612_cfa_closure, arg1956_1991);
								    }
								    {
								       obj_t aux_3997;
								       aux_3997 = BCHAR(((unsigned char) '\n'));
								       arg1953_1989 = MAKE_PAIR(aux_3997, arg1954_1990);
								    }
								 }
								 {
								    obj_t aux_4000;
								    aux_4000 = BBOOL(arg1942_1978);
								    arg1952_1988 = MAKE_PAIR(aux_4000, arg1953_1989);
								 }
							      }
							      arg1951_1987 = MAKE_PAIR(string2613_cfa_closure, arg1952_1988);
							   }
							   {
							      obj_t aux_4004;
							      aux_4004 = BCHAR(((unsigned char) '\n'));
							      arg1950_1986 = MAKE_PAIR(aux_4004, arg1951_1987);
							   }
							}
							{
							   obj_t aux_4007;
							   aux_4007 = BBOOL(lost__227_1961);
							   arg1949_1985 = MAKE_PAIR(aux_4007, arg1950_1986);
							}
						     }
						     arg1948_1984 = MAKE_PAIR(string2614_cfa_closure, arg1949_1985);
						  }
						  {
						     obj_t aux_4011;
						     aux_4011 = BCHAR(((unsigned char) '\n'));
						     arg1947_1983 = MAKE_PAIR(aux_4011, arg1948_1984);
						  }
					       }
					       list1946_1982 = MAKE_PAIR(string2615_cfa_closure, arg1947_1983);
					    }
					    print_trace_107_tools_trace(list1946_1982);
					 }
				      }
				    else
				      {
					 BUNSPEC;
				      }
				 }
			      }
			    else
			      {
				 {
				    bool_t test1968_2000;
				    {
				       obj_t aux_4016;
				       aux_4016 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				       test1968_2000 = CBOOL(aux_4016);
				    }
				    if (test1968_2000)
				      {
					 obj_t list1969_2001;
					 {
					    obj_t arg1971_2003;
					    {
					       obj_t aux_4022;
					       aux_4022 = BCHAR(((unsigned char) '\n'));
					       arg1971_2003 = MAKE_PAIR(aux_4022, BNIL);
					    }
					    list1969_2001 = MAKE_PAIR(string2616_cfa_closure, arg1971_2003);
					 }
					 print_trace_107_tools_trace(list1969_2001);
				      }
				    else
				      {
					 BUNSPEC;
				      }
				 }
				 {
				    obj_t res2582_3201;
				    {
				       make_procedure_app_48_t obj_3199;
				       obj_3199 = (make_procedure_app_48_t) (app_1958);
				       {
					  obj_t x_3819;
					  {
					     obj_t aux_4028;
					     {
						object_t aux_4029;
						aux_4029 = (object_t) (obj_3199);
						aux_4028 = OBJECT_WIDENING(aux_4029);
					     }
					     x_3819 = ((((make_procedure_app_48_t) CREF(aux_4028))->x) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					  }
					  res2582_3201 = BUNSPEC;
				       }
				    }
				    res2582_3201;
				 }
				 {
				    obj_t res2583_3204;
				    {
				       make_procedure_app_48_t obj_3202;
				       obj_3202 = (make_procedure_app_48_t) (app_1958);
				       {
					  obj_t x_3820;
					  {
					     obj_t aux_4034;
					     {
						object_t aux_4035;
						aux_4035 = (object_t) (obj_3202);
						aux_4034 = OBJECT_WIDENING(aux_4035);
					     }
					     x_3820 = ((((make_procedure_app_48_t) CREF(aux_4034))->t) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					  }
					  res2583_3204 = BUNSPEC;
				       }
				    }
				    res2583_3204;
				 }
			      }
			 }
		      }
		   }
		   {
		      obj_t l1870_4039;
		      l1870_4039 = CDR(l1870_1955);
		      l1870_1955 = l1870_4039;
		      goto lname1871_1956;
		   }
		}
	      else
		{
		   ((bool_t) 1);
		}
	   }
	   x__157_cfa_closure(__funcall_list__139_cfa_closure);
	   t_fix_point__90_cfa_closure(__funcall_list__139_cfa_closure);
	   show_x_t_233_cfa_closure(__make_procedure_list__56_cfa_closure);
	   light_funcall__169_cfa_closure();
	   light_access__52_cfa_closure();
	   light_make_procedure__143_cfa_closure();
	   return stop_cache_174_cfa_closure();
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_closure_optimization__207_cfa_closure(obj_t env_3806)
{
   return closure_optimization__48_cfa_closure();
}


bool_t 
x__157_cfa_closure(obj_t funcall_list_16_1)
{
   {
      bool_t test1988_2020;
      {
	 obj_t aux_4049;
	 aux_4049 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
	 test1988_2020 = CBOOL(aux_4049);
      }
      if (test1988_2020)
	{
	   obj_t list1989_2021;
	   {
	      obj_t arg1992_2023;
	      {
		 obj_t aux_4055;
		 aux_4055 = BCHAR(((unsigned char) '\n'));
		 arg1992_2023 = MAKE_PAIR(aux_4055, BNIL);
	      }
	      list1989_2021 = MAKE_PAIR(string2617_cfa_closure, arg1992_2023);
	   }
	   print_trace_107_tools_trace(list1989_2021);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t l1873_2027;
      l1873_2027 = funcall_list_16_1;
    lname1875_2028:
      if (PAIRP(l1873_2027))
	{
	   {
	      funcall_t app_2030;
	      {
		 obj_t aux_4062;
		 aux_4062 = CAR(l1873_2027);
		 app_2030 = (funcall_t) (aux_4062);
	      }
	      {
		 bool_t test1998_2031;
		 {
		    obj_t aux_4065;
		    aux_4065 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
		    test1998_2031 = CBOOL(aux_4065);
		 }
		 if (test1998_2031)
		   {
		      obj_t arg2000_2033;
		      arg2000_2033 = shape_tools_shape((obj_t) (app_2030));
		      {
			 obj_t list2002_2035;
			 {
			    obj_t arg2003_2036;
			    {
			       obj_t arg2004_2037;
			       arg2004_2037 = MAKE_PAIR(string2609_cfa_closure, BNIL);
			       arg2003_2036 = MAKE_PAIR(arg2000_2033, arg2004_2037);
			    }
			    list2002_2035 = MAKE_PAIR(string2618_cfa_closure, arg2003_2036);
			 }
			 print_trace_107_tools_trace(list2002_2035);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	      {
		 approx_t approx_2042;
		 approx_2042 = cfa__102_cfa_cfa((((funcall_t) CREF(app_2030))->fun));
		 {
		    obj_t alloc_2043;
		    alloc_2043 = (((approx_t) CREF(approx_2042))->allocs);
		    {
		       type_t type_2044;
		       type_2044 = (((approx_t) CREF(approx_2042))->type);
		       {
			  if ((((approx_t) CREF(approx_2042))->top__138))
			    {
			       {
				  bool_t test2008_2046;
				  {
				     obj_t aux_4083;
				     aux_4083 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				     test2008_2046 = CBOOL(aux_4083);
				  }
				  if (test2008_2046)
				    {
				       obj_t list2009_2047;
				       list2009_2047 = MAKE_PAIR(string2619_cfa_closure, BNIL);
				       print_trace_107_tools_trace(list2009_2047);
				    }
				  else
				    {
				       BUNSPEC;
				    }
			       }
			       {
				  obj_t arg2016_3807;
				  arg2016_3807 = proc2620_cfa_closure;
				  for_each_approx_alloc_83_cfa_approx(arg2016_3807, approx_2042);
			       }
			    }
			  else
			    {
			       bool_t test2029_2066;
			       {
				  obj_t arg2061_2098;
				  arg2061_2098 = set_length_165_cfa_set(alloc_2043);
				  {
				     long aux_4093;
				     aux_4093 = (long) CINT(arg2061_2098);
				     test2029_2066 = (aux_4093 == ((long) 0));
				  }
			       }
			       if (test2029_2066)
				 {
				    {
				       bool_t test2030_2067;
				       {
					  obj_t aux_4097;
					  aux_4097 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
					  test2030_2067 = CBOOL(aux_4097);
				       }
				       if (test2030_2067)
					 {
					    obj_t list2031_2068;
					    list2031_2068 = MAKE_PAIR(string2621_cfa_closure, BNIL);
					    print_trace_107_tools_trace(list2031_2068);
					 }
				       else
					 {
					    BUNSPEC;
					 }
				    }
				    CNST_TABLE_REF(((long) 1));
				 }
			       else
				 {
				    bool_t test2036_2073;
				    {
				       bool_t test2058_2094;
				       {
					  obj_t arg2059_2096;
					  arg2059_2096 = set_length_165_cfa_set(alloc_2043);
					  {
					     long aux_4107;
					     aux_4107 = (long) CINT(arg2059_2096);
					     test2058_2094 = (aux_4107 == ((long) 1));
					  }
				       }
				       if (test2058_2094)
					 {
					    obj_t _ortest_1876_2095;
					    _ortest_1876_2095 = __unsafe_type__146_engine_param;
					    if (CBOOL(_ortest_1876_2095))
					      {
						 test2036_2073 = CBOOL(_ortest_1876_2095);
					      }
					    else
					      {
						 obj_t obj2_3224;
						 obj2_3224 = __procedure__226_type_cache;
						 {
						    obj_t aux_4114;
						    aux_4114 = (obj_t) (type_2044);
						    test2036_2073 = (aux_4114 == obj2_3224);
						 }
					      }
					 }
				       else
					 {
					    test2036_2073 = ((bool_t) 0);
					 }
				    }
				    if (test2036_2073)
				      {
					 {
					    bool_t test2037_2074;
					    {
					       obj_t aux_4118;
					       aux_4118 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
					       test2037_2074 = CBOOL(aux_4118);
					    }
					    if (test2037_2074)
					      {
						 obj_t list2038_2075;
						 list2038_2075 = MAKE_PAIR(string2621_cfa_closure, BNIL);
						 print_trace_107_tools_trace(list2038_2075);
					      }
					    else
					      {
						 BUNSPEC;
					      }
					 }
					 CNST_TABLE_REF(((long) 1));
				      }
				    else
				      {
					 {
					    obj_t arg2045_3808;
					    arg2045_3808 = proc2622_cfa_closure;
					    for_each_approx_alloc_83_cfa_approx(arg2045_3808, approx_2042);
					 }
				      }
				 }
			    }
		       }
		    }
		 }
	      }
	   }
	   {
	      obj_t l1873_4128;
	      l1873_4128 = CDR(l1873_2027);
	      l1873_2027 = l1873_4128;
	      goto lname1875_2028;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
arg20162604_cfa_closure(obj_t env_3809, obj_t alloc_3810)
{
   {
      obj_t alloc_2053;
      alloc_2053 = alloc_3810;
      {
	 bool_t test2018_2055;
	 test2018_2055 = is_a__118___object(alloc_2053, make_procedure_app_48_cfa_info);
	 if (test2018_2055)
	   {
	      {
		 bool_t test2019_2056;
		 {
		    obj_t aux_4132;
		    aux_4132 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
		    test2019_2056 = CBOOL(aux_4132);
		 }
		 if (test2019_2056)
		   {
		      obj_t arg2021_2058;
		      arg2021_2058 = shape_tools_shape(alloc_2053);
		      {
			 obj_t list2022_2059;
			 {
			    obj_t arg2023_2060;
			    {
			       obj_t arg2025_2061;
			       {
				  obj_t aux_4139;
				  aux_4139 = BCHAR(((unsigned char) '\n'));
				  arg2025_2061 = MAKE_PAIR(aux_4139, BNIL);
			       }
			       arg2023_2060 = MAKE_PAIR(arg2021_2058, arg2025_2061);
			    }
			    list2022_2059 = MAKE_PAIR(string2623_cfa_closure, arg2023_2060);
			 }
			 print_trace_107_tools_trace(list2022_2059);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	      {
		 obj_t res2584_3215;
		 {
		    make_procedure_app_48_t obj_3213;
		    obj_3213 = (make_procedure_app_48_t) (alloc_2053);
		    {
		       obj_t x_3821;
		       {
			  obj_t aux_4146;
			  {
			     object_t aux_4147;
			     aux_4147 = (object_t) (obj_3213);
			     aux_4146 = OBJECT_WIDENING(aux_4147);
			  }
			  x_3821 = ((((make_procedure_app_48_t) CREF(aux_4146))->t) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		       }
		       res2584_3215 = BUNSPEC;
		    }
		 }
		 res2584_3215;
	      }
	      {
		 obj_t res2585_3218;
		 {
		    make_procedure_app_48_t obj_3216;
		    obj_3216 = (make_procedure_app_48_t) (alloc_2053);
		    {
		       obj_t x_3822;
		       {
			  obj_t aux_4152;
			  {
			     object_t aux_4153;
			     aux_4153 = (object_t) (obj_3216);
			     aux_4152 = OBJECT_WIDENING(aux_4153);
			  }
			  x_3822 = ((((make_procedure_app_48_t) CREF(aux_4152))->x) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		       }
		       res2585_3218 = BUNSPEC;
		    }
		 }
		 return res2585_3218;
	      }
	   }
	 else
	   {
	      return BUNSPEC;
	   }
      }
   }
}


obj_t 
arg20452605_cfa_closure(obj_t env_3811, obj_t alloc_3812)
{
   {
      obj_t alloc_2081;
      alloc_2081 = alloc_3812;
      {
	 bool_t test2047_2083;
	 test2047_2083 = is_a__118___object(alloc_2081, make_procedure_app_48_cfa_info);
	 if (test2047_2083)
	   {
	      {
		 bool_t test2048_2084;
		 {
		    obj_t aux_4159;
		    aux_4159 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
		    test2048_2084 = CBOOL(aux_4159);
		 }
		 if (test2048_2084)
		   {
		      obj_t arg2051_2086;
		      arg2051_2086 = shape_tools_shape(alloc_2081);
		      {
			 obj_t list2052_2087;
			 {
			    obj_t arg2053_2088;
			    {
			       obj_t arg2054_2089;
			       {
				  obj_t aux_4166;
				  aux_4166 = BCHAR(((unsigned char) '\n'));
				  arg2054_2089 = MAKE_PAIR(aux_4166, BNIL);
			       }
			       arg2053_2088 = MAKE_PAIR(arg2051_2086, arg2054_2089);
			    }
			    list2052_2087 = MAKE_PAIR(string2623_cfa_closure, arg2053_2088);
			 }
			 print_trace_107_tools_trace(list2052_2087);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	      {
		 obj_t res2586_3228;
		 {
		    make_procedure_app_48_t obj_3226;
		    obj_3226 = (make_procedure_app_48_t) (alloc_2081);
		    {
		       obj_t x_3823;
		       {
			  obj_t aux_4173;
			  {
			     object_t aux_4174;
			     aux_4174 = (object_t) (obj_3226);
			     aux_4173 = OBJECT_WIDENING(aux_4174);
			  }
			  x_3823 = ((((make_procedure_app_48_t) CREF(aux_4173))->x) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		       }
		       res2586_3228 = BUNSPEC;
		    }
		 }
		 return res2586_3228;
	      }
	   }
	 else
	   {
	      return BUNSPEC;
	   }
      }
   }
}


obj_t 
t_fix_point__90_cfa_closure(obj_t funcall_list_16_2)
{
   {
      bool_t test2066_2101;
      {
	 obj_t aux_4178;
	 aux_4178 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test2066_2101 = CBOOL(aux_4178);
      }
      if (test2066_2101)
	{
	   obj_t list2067_2102;
	   {
	      obj_t arg2069_2104;
	      {
		 obj_t aux_4184;
		 aux_4184 = BCHAR(((unsigned char) '\n'));
		 arg2069_2104 = MAKE_PAIR(aux_4184, BNIL);
	      }
	      list2067_2102 = MAKE_PAIR(string2624_cfa_closure, arg2069_2104);
	   }
	   print_trace_107_tools_trace(list2067_2102);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t continue__191_2108;
      continue__191_2108 = ((bool_t) 1);
    loop_2109:
      if (continue__191_2108)
	{
	   bool_t continue__191_2110;
	   continue__191_2110 = ((bool_t) 0);
	   {
	      obj_t l1877_2111;
	      l1877_2111 = funcall_list_16_2;
	    lname1880_2112:
	      if (PAIRP(l1877_2111))
		{
		   {
		      obj_t app_2114;
		      app_2114 = CAR(l1877_2111);
		      {
			 bool_t test2074_2115;
			 {
			    obj_t aux_4193;
			    aux_4193 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
			    test2074_2115 = CBOOL(aux_4193);
			 }
			 if (test2074_2115)
			   {
			      obj_t arg2077_2117;
			      arg2077_2117 = shape_tools_shape(app_2114);
			      {
				 obj_t list2078_2118;
				 {
				    obj_t arg2079_2119;
				    {
				       obj_t arg2080_2120;
				       {
					  obj_t aux_4200;
					  aux_4200 = BCHAR(((unsigned char) '\n'));
					  arg2080_2120 = MAKE_PAIR(aux_4200, BNIL);
				       }
				       arg2079_2119 = MAKE_PAIR(arg2077_2117, arg2080_2120);
				    }
				    list2078_2118 = MAKE_PAIR(string2618_cfa_closure, arg2079_2119);
				 }
				 print_trace_107_tools_trace(list2078_2118);
			      }
			   }
			 else
			   {
			      BUNSPEC;
			   }
		      }
		      {
			 approx_t approx_2125;
			 {
			    node_t aux_4206;
			    {
			       funcall_t obj_3232;
			       obj_3232 = (funcall_t) (app_2114);
			       aux_4206 = (((funcall_t) CREF(obj_3232))->fun);
			    }
			    approx_2125 = cfa__102_cfa_cfa(aux_4206);
			 }
			 {
			    obj_t alloc_2126;
			    alloc_2126 = set__list_248_cfa_set((((approx_t) CREF(approx_2125))->allocs));
			    {
			       bool_t t_init__227_2128;
			       {
				  bool_t _ortest_1881_2160;
				  _ortest_1881_2160 = (((approx_t) CREF(approx_2125))->top__138);
				  if (_ortest_1881_2160)
				    {
				       t_init__227_2128 = _ortest_1881_2160;
				    }
				  else
				    {
				       bool_t test2111_2161;
				       {
					  bool_t test2112_2162;
					  {
					     obj_t obj2_3237;
					     obj2_3237 = __procedure__226_type_cache;
					     {
						obj_t aux_4214;
						{
						   type_t aux_4215;
						   aux_4215 = (((approx_t) CREF(approx_2125))->type);
						   aux_4214 = (obj_t) (aux_4215);
						}
						test2112_2162 = (aux_4214 == obj2_3237);
					     }
					  }
					  if (test2112_2162)
					    {
					       test2111_2161 = ((bool_t) 1);
					    }
					  else
					    {
					       test2111_2161 = CBOOL(__unsafe_type__146_engine_param);
					    }
				       }
				       if (test2111_2161)
					 {
					    t_init__227_2128 = ((bool_t) 0);
					 }
				       else
					 {
					    t_init__227_2128 = ((bool_t) 1);
					 }
				    }
			       }
			       {
				  {
				     bool_t one_non_t__209_2129;
				     obj_t allocs_2130;
				     one_non_t__209_2129 = t_init__227_2128;
				     allocs_2130 = alloc_2126;
				   loop_2131:
				     {
					bool_t test2085_2132;
					{
					   obj_t aux_4222;
					   aux_4222 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
					   test2085_2132 = CBOOL(aux_4222);
					}
					if (test2085_2132)
					  {
					     obj_t arg2088_2135;
					     arg2088_2135 = shape_tools_shape(allocs_2130);
					     {
						obj_t list2089_2136;
						{
						   obj_t arg2091_2137;
						   {
						      obj_t arg2092_2138;
						      {
							 obj_t arg2095_2139;
							 {
							    obj_t arg2096_2140;
							    {
							       obj_t arg2097_2141;
							       {
								  obj_t aux_4229;
								  aux_4229 = BCHAR(((unsigned char) '\n'));
								  arg2097_2141 = MAKE_PAIR(aux_4229, BNIL);
							       }
							       arg2096_2140 = MAKE_PAIR(arg2088_2135, arg2097_2141);
							    }
							    arg2095_2139 = MAKE_PAIR(string2625_cfa_closure, arg2096_2140);
							 }
							 {
							    obj_t aux_4234;
							    aux_4234 = BCHAR(((unsigned char) '\n'));
							    arg2092_2138 = MAKE_PAIR(aux_4234, arg2095_2139);
							 }
						      }
						      {
							 obj_t aux_4237;
							 aux_4237 = BBOOL(one_non_t__209_2129);
							 arg2091_2137 = MAKE_PAIR(aux_4237, arg2092_2138);
						      }
						   }
						   list2089_2136 = MAKE_PAIR(string2626_cfa_closure, arg2091_2137);
						}
						print_trace_107_tools_trace(list2089_2136);
					     }
					  }
					else
					  {
					     BUNSPEC;
					  }
				     }
				     if (NULLP(allocs_2130))
				       {
					  CNST_TABLE_REF(((long) 2));
				       }
				     else
				       {
					  if (one_non_t__209_2129)
					    {
					       {
						  obj_t l1882_2146;
						  {
						     bool_t aux_4246;
						     l1882_2146 = alloc_2126;
						   lname1883_2147:
						     if (PAIRP(l1882_2146))
						       {
							  {
							     obj_t alloc_2149;
							     alloc_2149 = CAR(l1882_2146);
							     {
								bool_t test2103_2150;
								test2103_2150 = is_a__118___object(alloc_2149, make_procedure_app_48_cfa_info);
								if (test2103_2150)
								  {
								     bool_t test_4252;
								     {
									make_procedure_app_48_t obj_3242;
									obj_3242 = (make_procedure_app_48_t) (alloc_2149);
									{
									   obj_t aux_4254;
									   {
									      object_t aux_4255;
									      aux_4255 = (object_t) (obj_3242);
									      aux_4254 = OBJECT_WIDENING(aux_4255);
									   }
									   test_4252 = (((make_procedure_app_48_t) CREF(aux_4254))->t);
									}
								     }
								     if (test_4252)
								       {
									  {
									     obj_t res2587_3245;
									     {
										make_procedure_app_48_t obj_3243;
										obj_3243 = (make_procedure_app_48_t) (alloc_2149);
										{
										   obj_t x_3824;
										   {
										      obj_t aux_4260;
										      {
											 object_t aux_4261;
											 aux_4261 = (object_t) (obj_3243);
											 aux_4260 = OBJECT_WIDENING(aux_4261);
										      }
										      x_3824 = ((((make_procedure_app_48_t) CREF(aux_4260))->t) = ((bool_t) ((bool_t) 0)), BUNSPEC);
										   }
										   res2587_3245 = BUNSPEC;
										}
									     }
									     res2587_3245;
									  }
									  continue__191_2110 = ((bool_t) 1);
								       }
								     else
								       {
									  BUNSPEC;
								       }
								  }
								else
								  {
								     BUNSPEC;
								  }
							     }
							  }
							  {
							     obj_t l1882_4265;
							     l1882_4265 = CDR(l1882_2146);
							     l1882_2146 = l1882_4265;
							     goto lname1883_2147;
							  }
						       }
						     else
						       {
							  aux_4246 = ((bool_t) 1);
						       }
						     BBOOL(aux_4246);
						  }
					       }
					    }
					  else
					    {
					       bool_t test2106_2154;
					       test2106_2154 = is_a__118___object(CAR(allocs_2130), make_procedure_app_48_cfa_info);
					       if (test2106_2154)
						 {
						    {
						       bool_t test_4271;
						       {
							  make_procedure_app_48_t obj_3250;
							  {
							     obj_t aux_4272;
							     aux_4272 = CAR(allocs_2130);
							     obj_3250 = (make_procedure_app_48_t) (aux_4272);
							  }
							  {
							     obj_t aux_4275;
							     {
								object_t aux_4276;
								aux_4276 = (object_t) (obj_3250);
								aux_4275 = OBJECT_WIDENING(aux_4276);
							     }
							     test_4271 = (((make_procedure_app_48_t) CREF(aux_4275))->t);
							  }
						       }
						       if (test_4271)
							 {
							    obj_t allocs_4280;
							    allocs_4280 = CDR(allocs_2130);
							    allocs_2130 = allocs_4280;
							    goto loop_2131;
							 }
						       else
							 {
							    bool_t one_non_t__209_4282;
							    one_non_t__209_4282 = ((bool_t) 1);
							    one_non_t__209_2129 = one_non_t__209_4282;
							    goto loop_2131;
							 }
						    }
						 }
					       else
						 {
						    if (CBOOL(__unsafe_type__146_engine_param))
						      {
							 obj_t allocs_4285;
							 allocs_4285 = CDR(allocs_2130);
							 allocs_2130 = allocs_4285;
							 goto loop_2131;
						      }
						    else
						      {
							 bool_t one_non_t__209_4287;
							 one_non_t__209_4287 = ((bool_t) 1);
							 one_non_t__209_2129 = one_non_t__209_4287;
							 goto loop_2131;
						      }
						 }
					    }
				       }
				  }
			       }
			    }
			 }
		      }
		   }
		   {
		      obj_t l1877_4288;
		      l1877_4288 = CDR(l1877_2111);
		      l1877_2111 = l1877_4288;
		      goto lname1880_2112;
		   }
		}
	      else
		{
		   ((bool_t) 1);
		}
	   }
	   {
	      bool_t continue__191_4290;
	      continue__191_4290 = continue__191_2110;
	      continue__191_2108 = continue__191_4290;
	      goto loop_2109;
	   }
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


bool_t 
light_make_procedure__143_cfa_closure()
{
   {
      obj_t app_2202;
      obj_t app_2178;
      {
	 obj_t l1889_2170;
	 l1889_2170 = __make_procedure_list__56_cfa_closure;
       lname1890_2171:
	 if (PAIRP(l1889_2170))
	   {
	      {
		 obj_t app_2173;
		 app_2173 = CAR(l1889_2170);
		 {
		    bool_t test_4294;
		    {
		       make_procedure_app_48_t obj_3256;
		       obj_3256 = (make_procedure_app_48_t) (app_2173);
		       {
			  obj_t aux_4296;
			  {
			     object_t aux_4297;
			     aux_4297 = (object_t) (obj_3256);
			     aux_4296 = OBJECT_WIDENING(aux_4297);
			  }
			  test_4294 = (((make_procedure_app_48_t) CREF(aux_4296))->x);
		       }
		    }
		    if (test_4294)
		      {
			 app_2202 = app_2173;
			 {
			    obj_t size_2205;
			    {
			       node_t aux_4301;
			       {
				  obj_t aux_4302;
				  {
				     obj_t aux_4303;
				     {
					obj_t aux_4304;
					{
					   obj_t aux_4305;
					   {
					      app_t obj_3293;
					      obj_3293 = (app_t) (app_2202);
					      aux_4305 = (((app_t) CREF(obj_3293))->args);
					   }
					   aux_4304 = CDR(aux_4305);
					}
					aux_4303 = CDR(aux_4304);
				     }
				     aux_4302 = CAR(aux_4303);
				  }
				  aux_4301 = (node_t) (aux_4302);
			       }
			       size_2205 = get_node_atom_value_135_cfa_approx(aux_4301);
			    }
			    {
			       variable_t ffun_2206;
			       {
				  var_t obj_3302;
				  {
				     obj_t aux_4313;
				     {
					obj_t aux_4314;
					{
					   app_t obj_3300;
					   obj_3300 = (app_t) (app_2202);
					   aux_4314 = (((app_t) CREF(obj_3300))->args);
					}
					aux_4313 = CAR(aux_4314);
				     }
				     obj_3302 = (var_t) (aux_4313);
				  }
				  ffun_2206 = (((var_t) CREF(obj_3302))->variable);
			       }
			       {
				  value_t sfun_2207;
				  sfun_2207 = (((variable_t) CREF(ffun_2206))->value);
				  {
				     {
					bool_t test_4321;
					{
					   long aux_4322;
					   aux_4322 = (long) CINT(size_2205);
					   test_4321 = (aux_4322 == ((long) 1));
					}
					if (test_4321)
					  {
					     {
						bool_t test2144_2209;
						{
						   bool_t test2149_2213;
						   test2149_2213 = is_a__118___object((obj_t) (ffun_2206), global_ast_var);
						   if (test2149_2213)
						     {
							bool_t test2150_2214;
							{
							   obj_t aux_4328;
							   {
							      sfun_t obj_3307;
							      obj_3307 = (sfun_t) (sfun_2207);
							      aux_4328 = (((sfun_t) CREF(obj_3307))->the_closure_238);
							   }
							   test2150_2214 = is_a__118___object(aux_4328, global_ast_var);
							}
							if (test2150_2214)
							  {
							     obj_t aux_4333;
							     {
								value_t aux_4334;
								{
								   global_t obj_3310;
								   {
								      obj_t aux_4335;
								      {
									 sfun_t obj_3309;
									 obj_3309 = (sfun_t) (sfun_2207);
									 aux_4335 = (((sfun_t) CREF(obj_3309))->the_closure_238);
								      }
								      obj_3310 = (global_t) (aux_4335);
								   }
								   aux_4334 = (((global_t) CREF(obj_3310))->value);
								}
								aux_4333 = (obj_t) (aux_4334);
							     }
							     test2144_2209 = is_a__118___object(aux_4333, scnst_ast_var);
							  }
							else
							  {
							     test2144_2209 = ((bool_t) 0);
							  }
						     }
						   else
						     {
							test2144_2209 = ((bool_t) 0);
						     }
						}
						if (test2144_2209)
						  {
						     obj_t arg2146_2211;
						     arg2146_2211 = CNST_TABLE_REF(((long) 4));
						     {
							obj_t res2590_3316;
							{
							   scnst_t obj_3314;
							   {
							      value_t aux_4344;
							      {
								 global_t obj_3313;
								 {
								    obj_t aux_4345;
								    {
								       sfun_t obj_3312;
								       obj_3312 = (sfun_t) (sfun_2207);
								       aux_4345 = (((sfun_t) CREF(obj_3312))->the_closure_238);
								    }
								    obj_3313 = (global_t) (aux_4345);
								 }
								 aux_4344 = (((global_t) CREF(obj_3313))->value);
							      }
							      obj_3314 = (scnst_t) (aux_4344);
							   }
							   {
							      obj_t x_3827;
							      x_3827 = ((((scnst_t) CREF(obj_3314))->class) = ((obj_t) arg2146_2211), BUNSPEC);
							      res2590_3316 = BUNSPEC;
							   }
							}
							res2590_3316;
						     }
						  }
						else
						  {
						     BUNSPEC;
						  }
					     }
					     {
						var_t arg2154_2218;
						{
						   app_t obj_3317;
						   obj_3317 = (app_t) (app_2202);
						   arg2154_2218 = (((app_t) CREF(obj_3317))->fun);
						}
						{
						   obj_t res2591_3320;
						   {
						      variable_t val1180_3319;
						      val1180_3319 = (variable_t) (__make_el_procedure_1__141_cfa_closure);
						      {
							 obj_t x_3828;
							 x_3828 = ((((var_t) CREF(arg2154_2218))->variable) = ((variable_t) val1180_3319), BUNSPEC);
							 res2591_3320 = BUNSPEC;
						      }
						   }
						   res2591_3320;
						}
					     }
					  }
					else
					  {
					     {
						var_t arg2155_2219;
						{
						   app_t obj_3321;
						   obj_3321 = (app_t) (app_2202);
						   arg2155_2219 = (((app_t) CREF(obj_3321))->fun);
						}
						{
						   obj_t res2592_3324;
						   {
						      variable_t val1180_3323;
						      val1180_3323 = (variable_t) (__make_el_procedure__202_cfa_closure);
						      {
							 obj_t x_3829;
							 x_3829 = ((((var_t) CREF(arg2155_2219))->variable) = ((variable_t) val1180_3323), BUNSPEC);
							 res2592_3324 = BUNSPEC;
						      }
						   }
						   res2592_3324;
						}
					     }
					  }
				     }
				  }
			       }
			    }
			 }
			 {
			    obj_t arg2163_2224;
			    {
			       obj_t aux_4360;
			       {
				  obj_t aux_4361;
				  {
				     app_t obj_3325;
				     obj_3325 = (app_t) (app_2202);
				     aux_4361 = (((app_t) CREF(obj_3325))->args);
				  }
				  aux_4360 = CDR(aux_4361);
			       }
			       arg2163_2224 = CDR(aux_4360);
			    }
			    {
			       obj_t res2593_3332;
			       {
				  app_t obj_3330;
				  obj_3330 = (app_t) (app_2202);
				  {
				     obj_t x_3830;
				     x_3830 = ((((app_t) CREF(obj_3330))->args) = ((obj_t) arg2163_2224), BUNSPEC);
				     res2593_3332 = BUNSPEC;
				  }
			       }
			       res2593_3332;
			    }
			 }
			 {
			    bool_t test2165_2226;
			    test2165_2226 = stack_optimization__133_cfa_stack();
			    if (test2165_2226)
			      {
				 node_t aux_4370;
				 aux_4370 = stack__132_cfa_stack((node_t) (app_2202));
				 (obj_t) (aux_4370);
			      }
			    else
			      {
				 app_2202;
			      }
			 }
		      }
		    else
		      {
			 bool_t test_4374;
			 {
			    make_procedure_app_48_t obj_3257;
			    obj_3257 = (make_procedure_app_48_t) (app_2173);
			    {
			       obj_t aux_4376;
			       {
				  object_t aux_4377;
				  aux_4377 = (object_t) (obj_3257);
				  aux_4376 = OBJECT_WIDENING(aux_4377);
			       }
			       test_4374 = (((make_procedure_app_48_t) CREF(aux_4376))->t);
			    }
			 }
			 if (test_4374)
			   {
			      app_2178 = app_2173;
			      {
				 obj_t size_2181;
				 {
				    node_t aux_4381;
				    {
				       obj_t aux_4382;
				       {
					  obj_t aux_4383;
					  {
					     obj_t aux_4384;
					     {
						obj_t aux_4385;
						{
						   app_t obj_3259;
						   obj_3259 = (app_t) (app_2178);
						   aux_4385 = (((app_t) CREF(obj_3259))->args);
						}
						aux_4384 = CDR(aux_4385);
					     }
					     aux_4383 = CDR(aux_4384);
					  }
					  aux_4382 = CAR(aux_4383);
				       }
				       aux_4381 = (node_t) (aux_4382);
				    }
				    size_2181 = get_node_atom_value_135_cfa_approx(aux_4381);
				 }
				 {
				    variable_t ffun_2182;
				    {
				       var_t obj_3268;
				       {
					  obj_t aux_4393;
					  {
					     obj_t aux_4394;
					     {
						app_t obj_3266;
						obj_3266 = (app_t) (app_2178);
						aux_4394 = (((app_t) CREF(obj_3266))->args);
					     }
					     aux_4393 = CAR(aux_4394);
					  }
					  obj_3268 = (var_t) (aux_4393);
				       }
				       ffun_2182 = (((var_t) CREF(obj_3268))->variable);
				    }
				    {
				       value_t sfun_2183;
				       sfun_2183 = (((variable_t) CREF(ffun_2182))->value);
				       {
					  {
					     bool_t test2123_2184;
					     {
						bool_t test2127_2188;
						test2127_2188 = is_a__118___object((obj_t) (ffun_2182), global_ast_var);
						if (test2127_2188)
						  {
						     bool_t test2128_2189;
						     {
							obj_t aux_4404;
							{
							   sfun_t obj_3271;
							   obj_3271 = (sfun_t) (sfun_2183);
							   aux_4404 = (((sfun_t) CREF(obj_3271))->the_closure_238);
							}
							test2128_2189 = is_a__118___object(aux_4404, global_ast_var);
						     }
						     if (test2128_2189)
						       {
							  obj_t aux_4409;
							  {
							     value_t aux_4410;
							     {
								global_t obj_3274;
								{
								   obj_t aux_4411;
								   {
								      sfun_t obj_3273;
								      obj_3273 = (sfun_t) (sfun_2183);
								      aux_4411 = (((sfun_t) CREF(obj_3273))->the_closure_238);
								   }
								   obj_3274 = (global_t) (aux_4411);
								}
								aux_4410 = (((global_t) CREF(obj_3274))->value);
							     }
							     aux_4409 = (obj_t) (aux_4410);
							  }
							  test2123_2184 = is_a__118___object(aux_4409, scnst_ast_var);
						       }
						     else
						       {
							  test2123_2184 = ((bool_t) 0);
						       }
						  }
						else
						  {
						     test2123_2184 = ((bool_t) 0);
						  }
					     }
					     if (test2123_2184)
					       {
						  obj_t arg2125_2186;
						  arg2125_2186 = CNST_TABLE_REF(((long) 3));
						  {
						     obj_t res2588_3280;
						     {
							scnst_t obj_3278;
							{
							   value_t aux_4420;
							   {
							      global_t obj_3277;
							      {
								 obj_t aux_4421;
								 {
								    sfun_t obj_3276;
								    obj_3276 = (sfun_t) (sfun_2183);
								    aux_4421 = (((sfun_t) CREF(obj_3276))->the_closure_238);
								 }
								 obj_3277 = (global_t) (aux_4421);
							      }
							      aux_4420 = (((global_t) CREF(obj_3277))->value);
							   }
							   obj_3278 = (scnst_t) (aux_4420);
							}
							{
							   obj_t x_3825;
							   x_3825 = ((((scnst_t) CREF(obj_3278))->class) = ((obj_t) arg2125_2186), BUNSPEC);
							   res2588_3280 = BUNSPEC;
							}
						     }
						     res2588_3280;
						  }
					       }
					     else
					       {
						  BUNSPEC;
					       }
					  }
					  {
					     var_t arg2132_2193;
					     {
						app_t obj_3281;
						obj_3281 = (app_t) (app_2178);
						arg2132_2193 = (((app_t) CREF(obj_3281))->fun);
					     }
					     {
						obj_t res2589_3284;
						{
						   variable_t val1180_3283;
						   val1180_3283 = (variable_t) (__make_l_procedure__54_cfa_closure);
						   {
						      obj_t x_3826;
						      x_3826 = ((((var_t) CREF(arg2132_2193))->variable) = ((variable_t) val1180_3283), BUNSPEC);
						      res2589_3284 = BUNSPEC;
						   }
						}
						res2589_3284;
					     }
					  }
					  {
					     obj_t aux_4435;
					     obj_t aux_4432;
					     {
						obj_t aux_4436;
						{
						   obj_t aux_4437;
						   {
						      app_t obj_3286;
						      obj_3286 = (app_t) (app_2178);
						      aux_4437 = (((app_t) CREF(obj_3286))->args);
						   }
						   aux_4436 = CDR(aux_4437);
						}
						aux_4435 = CDR(aux_4436);
					     }
					     {
						app_t obj_3285;
						obj_3285 = (app_t) (app_2178);
						aux_4432 = (((app_t) CREF(obj_3285))->args);
					     }
					     SET_CDR(aux_4432, aux_4435);
					  }
					  {
					     bool_t test2136_2197;
					     test2136_2197 = stack_optimization__133_cfa_stack();
					     if (test2136_2197)
					       {
						  node_t aux_4445;
						  aux_4445 = stack__132_cfa_stack((node_t) (app_2178));
						  (obj_t) (aux_4445);
					       }
					     else
					       {
						  app_2178;
					       }
					  }
				       }
				    }
				 }
			      }
			   }
			 else
			   {
			      BFALSE;
			   }
		      }
		 }
	      }
	      {
		 obj_t l1889_4449;
		 l1889_4449 = CDR(l1889_2170);
		 l1889_2170 = l1889_4449;
		 goto lname1890_2171;
	      }
	   }
	 else
	   {
	      return ((bool_t) 1);
	   }
      }
   }
}


bool_t 
light_funcall__169_cfa_closure()
{
   {
      obj_t l1892_2229;
      l1892_2229 = __funcall_list__139_cfa_closure;
    lname1893_2230:
      if (PAIRP(l1892_2229))
	{
	   {
	      funcall_t app_2232;
	      {
		 obj_t aux_4453;
		 aux_4453 = CAR(l1892_2229);
		 app_2232 = (funcall_t) (aux_4453);
	      }
	      {
		 bool_t test2167_2233;
		 {
		    obj_t aux_4456;
		    aux_4456 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
		    test2167_2233 = CBOOL(aux_4456);
		 }
		 if (test2167_2233)
		   {
		      obj_t arg2169_2235;
		      arg2169_2235 = shape_tools_shape((obj_t) (app_2232));
		      {
			 obj_t list2171_2237;
			 {
			    obj_t arg2172_2238;
			    {
			       obj_t arg2173_2239;
			       arg2173_2239 = MAKE_PAIR(string2609_cfa_closure, BNIL);
			       arg2172_2238 = MAKE_PAIR(arg2169_2235, arg2173_2239);
			    }
			    list2171_2237 = MAKE_PAIR(string2627_cfa_closure, arg2172_2238);
			 }
			 print_trace_107_tools_trace(list2171_2237);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	      {
		 approx_t approx_2244;
		 approx_2244 = cfa__102_cfa_cfa((((funcall_t) CREF(app_2232))->fun));
		 {
		    obj_t alloc_list_184_2245;
		    alloc_list_184_2245 = set__list_248_cfa_set((((approx_t) CREF(approx_2244))->allocs));
		    {
		       {
			  bool_t test2177_2246;
			  if (PAIRP(alloc_list_184_2245))
			    {
			       bool_t test2217_2288;
			       test2217_2288 = is_a__118___object(CAR(alloc_list_184_2245), make_procedure_app_48_cfa_info);
			       if (test2217_2288)
				 {
				    test2177_2246 = ((bool_t) 0);
				 }
			       else
				 {
				    test2177_2246 = ((bool_t) 1);
				 }
			    }
			  else
			    {
			       test2177_2246 = ((bool_t) 1);
			    }
			  if (test2177_2246)
			    {
			       {
				  bool_t test2178_2247;
				  {
				     obj_t aux_4478;
				     aux_4478 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
				     test2178_2247 = CBOOL(aux_4478);
				  }
				  if (test2178_2247)
				    {
				       obj_t list2179_2248;
				       {
					  obj_t arg2181_2250;
					  {
					     obj_t aux_4484;
					     aux_4484 = BCHAR(((unsigned char) '\n'));
					     arg2181_2250 = MAKE_PAIR(aux_4484, BNIL);
					  }
					  list2179_2248 = MAKE_PAIR(string2628_cfa_closure, arg2181_2250);
				       }
				       print_trace_107_tools_trace(list2179_2248);
				    }
				  else
				    {
				       BUNSPEC;
				    }
			       }
			       CNST_TABLE_REF(((long) 5));
			    }
			  else
			    {
			       app_t alloc_2254;
			       {
				  obj_t aux_4490;
				  aux_4490 = CAR(alloc_list_184_2245);
				  alloc_2254 = (app_t) (aux_4490);
			       }
			       {
				  bool_t test_4493;
				  {
				     make_procedure_app_48_t obj_3341;
				     obj_3341 = (make_procedure_app_48_t) (alloc_2254);
				     {
					obj_t aux_4495;
					{
					   object_t aux_4496;
					   aux_4496 = (object_t) (obj_3341);
					   aux_4495 = OBJECT_WIDENING(aux_4496);
					}
					test_4493 = (((make_procedure_app_48_t) CREF(aux_4495))->x);
				     }
				  }
				  if (test_4493)
				    {
				       {
					  bool_t test2186_2257;
					  {
					     obj_t aux_4500;
					     aux_4500 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
					     test2186_2257 = CBOOL(aux_4500);
					  }
					  if (test2186_2257)
					    {
					       obj_t list2187_2258;
					       {
						  obj_t arg2189_2260;
						  {
						     obj_t aux_4506;
						     aux_4506 = BCHAR(((unsigned char) '\n'));
						     arg2189_2260 = MAKE_PAIR(aux_4506, BNIL);
						  }
						  list2187_2258 = MAKE_PAIR(string2629_cfa_closure, arg2189_2260);
					       }
					       print_trace_107_tools_trace(list2187_2258);
					    }
					  else
					    {
					       BUNSPEC;
					    }
				       }
				       {
					  var_t arg2193_2264;
					  {
					     var_t duplicated1895_2265;
					     {
						obj_t aux_4511;
						{
						   obj_t aux_4512;
						   aux_4512 = (((app_t) CREF(alloc_2254))->args);
						   aux_4511 = CAR(aux_4512);
						}
						duplicated1895_2265 = (var_t) (aux_4511);
					     }
					     {
						obj_t arg2194_2266;
						type_t arg2195_2267;
						variable_t arg2196_2268;
						arg2194_2266 = (((var_t) CREF(duplicated1895_2265))->loc);
						arg2195_2267 = (((var_t) CREF(duplicated1895_2265))->type);
						arg2196_2268 = (((var_t) CREF(duplicated1895_2265))->variable);
						{
						   var_t res2594_3357;
						   {
						      var_t new1177_3350;
						      new1177_3350 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
						      {
							 long arg2551_3351;
							 arg2551_3351 = class_num_218___object(var_ast_node);
							 {
							    obj_t obj_3355;
							    obj_3355 = (obj_t) (new1177_3350);
							    (((obj_t) CREF(obj_3355))->header = MAKE_HEADER(arg2551_3351, 0), BUNSPEC);
							 }
						      }
						      {
							 object_t aux_4523;
							 aux_4523 = (object_t) (new1177_3350);
							 OBJECT_WIDENING_SET(aux_4523, BFALSE);
						      }
						      ((((var_t) CREF(new1177_3350))->loc) = ((obj_t) arg2194_2266), BUNSPEC);
						      ((((var_t) CREF(new1177_3350))->type) = ((type_t) arg2195_2267), BUNSPEC);
						      ((((var_t) CREF(new1177_3350))->variable) = ((variable_t) arg2196_2268), BUNSPEC);
						      res2594_3357 = new1177_3350;
						   }
						   arg2193_2264 = res2594_3357;
						}
					     }
					  }
					  {
					     obj_t res2595_3360;
					     {
						node_t val1219_3359;
						val1219_3359 = (node_t) (arg2193_2264);
						{
						   obj_t x_3831;
						   x_3831 = ((((funcall_t) CREF(app_2232))->fun) = ((node_t) val1219_3359), BUNSPEC);
						   res2595_3360 = BUNSPEC;
						}
					     }
					     res2595_3360;
					  }
				       }
				       {
					  obj_t arg2198_2270;
					  arg2198_2270 = CNST_TABLE_REF(((long) 6));
					  {
					     obj_t res2596_3363;
					     {
						obj_t x_3832;
						x_3832 = ((((funcall_t) CREF(app_2232))->strength) = ((obj_t) arg2198_2270), BUNSPEC);
						res2596_3363 = BUNSPEC;
					     }
					     res2596_3363;
					  }
				       }
				    }
				  else
				    {
				       bool_t test_4533;
				       {
					  make_procedure_app_48_t obj_3364;
					  obj_3364 = (make_procedure_app_48_t) (alloc_2254);
					  {
					     obj_t aux_4535;
					     {
						object_t aux_4536;
						aux_4536 = (object_t) (obj_3364);
						aux_4535 = OBJECT_WIDENING(aux_4536);
					     }
					     test_4533 = (((make_procedure_app_48_t) CREF(aux_4535))->t);
					  }
				       }
				       if (test_4533)
					 {
					    {
					       bool_t test2200_2272;
					       {
						  obj_t aux_4540;
						  aux_4540 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
						  test2200_2272 = CBOOL(aux_4540);
					       }
					       if (test2200_2272)
						 {
						    obj_t list2201_2273;
						    {
						       obj_t arg2203_2275;
						       {
							  obj_t aux_4546;
							  aux_4546 = BCHAR(((unsigned char) '\n'));
							  arg2203_2275 = MAKE_PAIR(aux_4546, BNIL);
						       }
						       list2201_2273 = MAKE_PAIR(string2630_cfa_closure, arg2203_2275);
						    }
						    print_trace_107_tools_trace(list2201_2273);
						 }
					       else
						 {
						    BUNSPEC;
						 }
					    }
					    {
					       obj_t arg2208_2279;
					       arg2208_2279 = CNST_TABLE_REF(((long) 7));
					       {
						  obj_t res2597_3367;
						  {
						     obj_t x_3833;
						     x_3833 = ((((funcall_t) CREF(app_2232))->strength) = ((obj_t) arg2208_2279), BUNSPEC);
						     res2597_3367 = BUNSPEC;
						  }
						  res2597_3367;
					       }
					    }
					 }
				       else
					 {
					    {
					       bool_t test2209_2280;
					       {
						  obj_t aux_4553;
						  aux_4553 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
						  test2209_2280 = CBOOL(aux_4553);
					       }
					       if (test2209_2280)
						 {
						    obj_t list2210_2281;
						    {
						       obj_t arg2212_2283;
						       {
							  obj_t aux_4559;
							  aux_4559 = BCHAR(((unsigned char) '\n'));
							  arg2212_2283 = MAKE_PAIR(aux_4559, BNIL);
						       }
						       list2210_2281 = MAKE_PAIR(string2631_cfa_closure, arg2212_2283);
						    }
						    print_trace_107_tools_trace(list2210_2281);
						 }
					       else
						 {
						    BUNSPEC;
						 }
					    }
					    CNST_TABLE_REF(((long) 5));
					 }
				    }
			       }
			    }
		       }
		    }
		 }
	      }
	   }
	   {
	      obj_t l1892_4565;
	      l1892_4565 = CDR(l1892_2229);
	      l1892_2229 = l1892_4565;
	      goto lname1893_2230;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


bool_t 
light_access__52_cfa_closure()
{
   {
      obj_t l1896_2292;
      l1896_2292 = __procedure_ref_list__19_cfa_closure;
    lname1898_2293:
      if (PAIRP(l1896_2292))
	{
	   {
	      obj_t app_2295;
	      app_2295 = CAR(l1896_2292);
	      {
		 approx_t approx_2297;
		 {
		    node_t aux_4570;
		    {
		       obj_t aux_4571;
		       {
			  obj_t aux_4572;
			  {
			     app_t obj_3372;
			     obj_3372 = (app_t) (app_2295);
			     aux_4572 = (((app_t) CREF(obj_3372))->args);
			  }
			  aux_4571 = CAR(aux_4572);
		       }
		       aux_4570 = (node_t) (aux_4571);
		    }
		    approx_2297 = cfa__102_cfa_cfa(aux_4570);
		 }
		 {
		    obj_t alloc_list_184_2298;
		    alloc_list_184_2298 = set__list_248_cfa_set((((approx_t) CREF(approx_2297))->allocs));
		    {
		       var_t fun_2299;
		       {
			  app_t obj_3375;
			  obj_3375 = (app_t) (app_2295);
			  fun_2299 = (((app_t) CREF(obj_3375))->fun);
		       }
		       {
			  variable_t vfun_2300;
			  vfun_2300 = (((var_t) CREF(fun_2299))->variable);
			  {
			     {
				bool_t test2222_2301;
				if (PAIRP(alloc_list_184_2298))
				  {
				     bool_t test2234_2315;
				     test2234_2315 = is_a__118___object(CAR(alloc_list_184_2298), make_procedure_app_48_cfa_info);
				     if (test2234_2315)
				       {
					  test2222_2301 = ((bool_t) 0);
				       }
				     else
				       {
					  test2222_2301 = ((bool_t) 1);
				       }
				  }
				else
				  {
				     test2222_2301 = ((bool_t) 1);
				  }
				if (test2222_2301)
				  {
				     CNST_TABLE_REF(((long) 5));
				  }
				else
				  {
				     app_t alloc_2302;
				     {
					obj_t aux_4590;
					aux_4590 = CAR(alloc_list_184_2298);
					alloc_2302 = (app_t) (aux_4590);
				     }
				     {
					bool_t test_4593;
					{
					   make_procedure_app_48_t obj_3381;
					   obj_3381 = (make_procedure_app_48_t) (alloc_2302);
					   {
					      obj_t aux_4595;
					      {
						 object_t aux_4596;
						 aux_4596 = (object_t) (obj_3381);
						 aux_4595 = OBJECT_WIDENING(aux_4596);
					      }
					      test_4593 = (((make_procedure_app_48_t) CREF(aux_4595))->x);
					   }
					}
					if (test_4593)
					  {
					     {
						bool_t test2224_2305;
						{
						   obj_t arg2227_2308;
						   {
						      node_t aux_4600;
						      {
							 obj_t aux_4601;
							 {
							    obj_t aux_4602;
							    {
							       obj_t aux_4603;
							       {
								  obj_t aux_4604;
								  aux_4604 = (((app_t) CREF(alloc_2302))->args);
								  aux_4603 = CDR(aux_4604);
							       }
							       aux_4602 = CDR(aux_4603);
							    }
							    aux_4601 = CAR(aux_4602);
							 }
							 aux_4600 = (node_t) (aux_4601);
						      }
						      arg2227_2308 = get_node_atom_value_135_cfa_approx(aux_4600);
						   }
						   {
						      long aux_4611;
						      aux_4611 = (long) CINT(arg2227_2308);
						      test2224_2305 = (aux_4611 == ((long) 1));
						   }
						}
						if (test2224_2305)
						  {
						     bool_t test2225_2306;
						     {
							obj_t obj2_3392;
							obj2_3392 = __procedure_ref__66_cfa_closure;
							{
							   obj_t aux_4615;
							   aux_4615 = (obj_t) (vfun_2300);
							   test2225_2306 = (aux_4615 == obj2_3392);
							}
						     }
						     if (test2225_2306)
						       {
							  obj_t res2598_3395;
							  {
							     variable_t val1180_3394;
							     val1180_3394 = (variable_t) (__procedure_1_el_ref__37_cfa_closure);
							     {
								obj_t x_3834;
								x_3834 = ((((var_t) CREF(fun_2299))->variable) = ((variable_t) val1180_3394), BUNSPEC);
								res2598_3395 = BUNSPEC;
							     }
							  }
							  res2598_3395;
						       }
						     else
						       {
							  obj_t res2599_3398;
							  {
							     variable_t val1180_3397;
							     val1180_3397 = (variable_t) (__procedure_1_el_set___97_cfa_closure);
							     {
								obj_t x_3835;
								x_3835 = ((((var_t) CREF(fun_2299))->variable) = ((variable_t) val1180_3397), BUNSPEC);
								res2599_3398 = BUNSPEC;
							     }
							  }
							  res2599_3398;
						       }
						  }
						else
						  {
						     bool_t test2226_2307;
						     {
							obj_t obj2_3400;
							obj2_3400 = __procedure_ref__66_cfa_closure;
							{
							   obj_t aux_4623;
							   aux_4623 = (obj_t) (vfun_2300);
							   test2226_2307 = (aux_4623 == obj2_3400);
							}
						     }
						     if (test2226_2307)
						       {
							  obj_t res2600_3403;
							  {
							     variable_t val1180_3402;
							     val1180_3402 = (variable_t) (__procedure_el_ref__61_cfa_closure);
							     {
								obj_t x_3836;
								x_3836 = ((((var_t) CREF(fun_2299))->variable) = ((variable_t) val1180_3402), BUNSPEC);
								res2600_3403 = BUNSPEC;
							     }
							  }
							  res2600_3403;
						       }
						     else
						       {
							  obj_t res2601_3406;
							  {
							     variable_t val1180_3405;
							     val1180_3405 = (variable_t) (__procedure_el_set___46_cfa_closure);
							     {
								obj_t x_3837;
								x_3837 = ((((var_t) CREF(fun_2299))->variable) = ((variable_t) val1180_3405), BUNSPEC);
								res2601_3406 = BUNSPEC;
							     }
							  }
							  res2601_3406;
						       }
						  }
					     }
					  }
					else
					  {
					     bool_t test_4631;
					     {
						make_procedure_app_48_t obj_3407;
						obj_3407 = (make_procedure_app_48_t) (alloc_2302);
						{
						   obj_t aux_4633;
						   {
						      object_t aux_4634;
						      aux_4634 = (object_t) (obj_3407);
						      aux_4633 = OBJECT_WIDENING(aux_4634);
						   }
						   test_4631 = (((make_procedure_app_48_t) CREF(aux_4633))->t);
						}
					     }
					     if (test_4631)
					       {
						  {
						     bool_t test2232_2313;
						     {
							obj_t obj2_3409;
							obj2_3409 = __procedure_ref__66_cfa_closure;
							{
							   obj_t aux_4638;
							   aux_4638 = (obj_t) (vfun_2300);
							   test2232_2313 = (aux_4638 == obj2_3409);
							}
						     }
						     if (test2232_2313)
						       {
							  obj_t res2602_3412;
							  {
							     variable_t val1180_3411;
							     val1180_3411 = (variable_t) (__procedure_l_ref__76_cfa_closure);
							     {
								obj_t x_3838;
								x_3838 = ((((var_t) CREF(fun_2299))->variable) = ((variable_t) val1180_3411), BUNSPEC);
								res2602_3412 = BUNSPEC;
							     }
							  }
							  res2602_3412;
						       }
						     else
						       {
							  obj_t res2603_3415;
							  {
							     variable_t val1180_3414;
							     val1180_3414 = (variable_t) (__procedure_l_set___202_cfa_closure);
							     {
								obj_t x_3839;
								x_3839 = ((((var_t) CREF(fun_2299))->variable) = ((variable_t) val1180_3414), BUNSPEC);
								res2603_3415 = BUNSPEC;
							     }
							  }
							  res2603_3415;
						       }
						  }
					       }
					     else
					       {
						  BFALSE;
					       }
					  }
				     }
				  }
			     }
			  }
		       }
		    }
		 }
	      }
	   }
	   {
	      obj_t l1896_4646;
	      l1896_4646 = CDR(l1896_2292);
	      l1896_2292 = l1896_4646;
	      goto lname1898_2293;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
show_x_t_233_cfa_closure(obj_t allocs_4)
{
   {
      obj_t xp_2322;
      obj_t tp_2323;
      obj_t allocs_2324;
      xp_2322 = BNIL;
      tp_2323 = BNIL;
      allocs_2324 = allocs_4;
    loop_2325:
      if (NULLP(allocs_2324))
	{
	   show_cfa_closure(CNST_TABLE_REF(((long) 8)), xp_2322);
	   show_cfa_closure(CNST_TABLE_REF(((long) 9)), tp_2323);
	   return BUNSPEC;
	}
      else
	{
	   obj_t instance1902_2331;
	   instance1902_2331 = CAR(allocs_2324);
	   {
	      bool_t test_4655;
	      {
		 make_procedure_app_48_t obj_3419;
		 obj_3419 = (make_procedure_app_48_t) (instance1902_2331);
		 {
		    obj_t aux_4657;
		    {
		       object_t aux_4658;
		       aux_4658 = (object_t) (obj_3419);
		       aux_4657 = OBJECT_WIDENING(aux_4658);
		    }
		    test_4655 = (((make_procedure_app_48_t) CREF(aux_4657))->x);
		 }
	      }
	      if (test_4655)
		{
		   {
		      obj_t arg2251_2333;
		      obj_t arg2252_2334;
		      {
			 obj_t aux_4662;
			 {
			    variable_t aux_4663;
			    {
			       var_t obj_3422;
			       {
				  obj_t aux_4664;
				  {
				     obj_t aux_4665;
				     {
					app_t obj_3420;
					obj_3420 = (app_t) (instance1902_2331);
					aux_4665 = (((app_t) CREF(obj_3420))->args);
				     }
				     aux_4664 = CAR(aux_4665);
				  }
				  obj_3422 = (var_t) (aux_4664);
			       }
			       aux_4663 = (((var_t) CREF(obj_3422))->variable);
			    }
			    aux_4662 = (obj_t) (aux_4663);
			 }
			 arg2251_2333 = MAKE_PAIR(aux_4662, xp_2322);
		      }
		      arg2252_2334 = CDR(allocs_2324);
		      {
			 obj_t allocs_4675;
			 obj_t xp_4674;
			 xp_4674 = arg2251_2333;
			 allocs_4675 = arg2252_2334;
			 allocs_2324 = allocs_4675;
			 xp_2322 = xp_4674;
			 goto loop_2325;
		      }
		   }
		}
	      else
		{
		   bool_t test_4676;
		   {
		      make_procedure_app_48_t obj_3426;
		      obj_3426 = (make_procedure_app_48_t) (instance1902_2331);
		      {
			 obj_t aux_4678;
			 {
			    object_t aux_4679;
			    aux_4679 = (object_t) (obj_3426);
			    aux_4678 = OBJECT_WIDENING(aux_4679);
			 }
			 test_4676 = (((make_procedure_app_48_t) CREF(aux_4678))->t);
		      }
		   }
		   if (test_4676)
		     {
			{
			   obj_t arg2258_2339;
			   obj_t arg2259_2340;
			   {
			      obj_t aux_4683;
			      {
				 variable_t aux_4684;
				 {
				    var_t obj_3429;
				    {
				       obj_t aux_4685;
				       {
					  obj_t aux_4686;
					  {
					     app_t obj_3427;
					     obj_3427 = (app_t) (instance1902_2331);
					     aux_4686 = (((app_t) CREF(obj_3427))->args);
					  }
					  aux_4685 = CAR(aux_4686);
				       }
				       obj_3429 = (var_t) (aux_4685);
				    }
				    aux_4684 = (((var_t) CREF(obj_3429))->variable);
				 }
				 aux_4683 = (obj_t) (aux_4684);
			      }
			      arg2258_2339 = MAKE_PAIR(aux_4683, tp_2323);
			   }
			   arg2259_2340 = CDR(allocs_2324);
			   {
			      obj_t allocs_4696;
			      obj_t tp_4695;
			      tp_4695 = arg2258_2339;
			      allocs_4696 = arg2259_2340;
			      allocs_2324 = allocs_4696;
			      tp_2323 = tp_4695;
			      goto loop_2325;
			   }
			}
		     }
		   else
		     {
			{
			   obj_t allocs_4697;
			   allocs_4697 = CDR(allocs_2324);
			   allocs_2324 = allocs_4697;
			   goto loop_2325;
			}
		     }
		}
	   }
	}
   }
}


obj_t 
show_cfa_closure(obj_t prop_2345, obj_t l_2346)
{
   if (PAIRP(l_2346))
     {
	{
	   obj_t arg2270_2352;
	   arg2270_2352 = shape_tools_shape(CAR(l_2346));
	   {
	      obj_t list2271_2353;
	      {
		 obj_t arg2272_2354;
		 {
		    obj_t arg2273_2355;
		    {
		       obj_t arg2274_2356;
		       {
			  obj_t arg2280_2357;
			  {
			     obj_t aux_4703;
			     aux_4703 = BCHAR(((unsigned char) '\n'));
			     arg2280_2357 = MAKE_PAIR(aux_4703, BNIL);
			  }
			  arg2274_2356 = MAKE_PAIR(arg2270_2352, arg2280_2357);
		       }
		       arg2273_2355 = MAKE_PAIR(string2632_cfa_closure, arg2274_2356);
		    }
		    arg2272_2354 = MAKE_PAIR(prop_2345, arg2273_2355);
		 }
		 list2271_2353 = MAKE_PAIR(string2633_cfa_closure, arg2272_2354);
	      }
	      verbose_tools_speek(BINT(((long) 2)), list2271_2353);
	   }
	}
	{
	   obj_t l1900_2360;
	   {
	      bool_t aux_4712;
	      l1900_2360 = CDR(l_2346);
	    lname1901_2361:
	      if (PAIRP(l1900_2360))
		{
		   {
		      obj_t arg2288_2367;
		      arg2288_2367 = shape_tools_shape(CAR(l1900_2360));
		      {
			 obj_t list2289_2368;
			 {
			    obj_t arg2290_2369;
			    {
			       obj_t arg2291_2370;
			       {
				  obj_t aux_4717;
				  aux_4717 = BCHAR(((unsigned char) '\n'));
				  arg2291_2370 = MAKE_PAIR(aux_4717, BNIL);
			       }
			       arg2290_2369 = MAKE_PAIR(arg2288_2367, arg2291_2370);
			    }
			    list2289_2368 = MAKE_PAIR(string2634_cfa_closure, arg2290_2369);
			 }
			 verbose_tools_speek(BINT(((long) 2)), list2289_2368);
		      }
		   }
		   {
		      obj_t l1900_4724;
		      l1900_4724 = CDR(l1900_2360);
		      l1900_2360 = l1900_4724;
		      goto lname1901_2361;
		   }
		}
	      else
		{
		   aux_4712 = ((bool_t) 1);
		}
	      return BBOOL(aux_4712);
	   }
	}
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
add_funcall__195_cfa_closure(node_t ast_5)
{
   {
      bool_t test2294_2374;
      {
	 long n1_3440;
	 n1_3440 = (long) CINT(__optim__89_engine_param);
	 test2294_2374 = (n1_3440 >= ((long) 2));
      }
      if (test2294_2374)
	{
	   obj_t obj2_3443;
	   obj2_3443 = __funcall_list__139_cfa_closure;
	   {
	      obj_t aux_4731;
	      aux_4731 = (obj_t) (ast_5);
	      return (__funcall_list__139_cfa_closure = MAKE_PAIR(aux_4731, obj2_3443),
		 BUNSPEC);
	   }
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_add_funcall__114_cfa_closure(obj_t env_3813, obj_t ast_3814)
{
   return add_funcall__195_cfa_closure((node_t) (ast_3814));
}


obj_t 
add_make_procedure__219_cfa_closure(node_t ast_6)
{
   {
      bool_t test2295_2375;
      {
	 long n1_3444;
	 n1_3444 = (long) CINT(__optim__89_engine_param);
	 test2295_2375 = (n1_3444 >= ((long) 2));
      }
      if (test2295_2375)
	{
	   obj_t obj2_3447;
	   obj2_3447 = __make_procedure_list__56_cfa_closure;
	   {
	      obj_t aux_4739;
	      aux_4739 = (obj_t) (ast_6);
	      return (__make_procedure_list__56_cfa_closure = MAKE_PAIR(aux_4739, obj2_3447),
		 BUNSPEC);
	   }
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_add_make_procedure__196_cfa_closure(obj_t env_3815, obj_t ast_3816)
{
   return add_make_procedure__219_cfa_closure((node_t) (ast_3816));
}


obj_t 
add_procedure_ref__36_cfa_closure(node_t ast_7)
{
   {
      bool_t test2296_2376;
      {
	 long n1_3448;
	 n1_3448 = (long) CINT(__optim__89_engine_param);
	 test2296_2376 = (n1_3448 >= ((long) 2));
      }
      if (test2296_2376)
	{
	   obj_t obj2_3451;
	   obj2_3451 = __procedure_ref_list__19_cfa_closure;
	   {
	      obj_t aux_4747;
	      aux_4747 = (obj_t) (ast_7);
	      return (__procedure_ref_list__19_cfa_closure = MAKE_PAIR(aux_4747, obj2_3451),
		 BUNSPEC);
	   }
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_add_procedure_ref__99_cfa_closure(obj_t env_3817, obj_t ast_3818)
{
   return add_procedure_ref__36_cfa_closure((node_t) (ast_3818));
}


obj_t 
start_cache_11_cfa_closure()
{
   {
      obj_t arg2297_2377;
      arg2297_2377 = CNST_TABLE_REF(((long) 10));
      {
	 obj_t list2299_2379;
	 {
	    obj_t aux_4753;
	    aux_4753 = CNST_TABLE_REF(((long) 11));
	    list2299_2379 = MAKE_PAIR(aux_4753, BNIL);
	 }
	 __procedure_ref__66_cfa_closure = find_global_223_ast_env(arg2297_2377, list2299_2379);
      }
   }
   {
      obj_t arg2301_2381;
      arg2301_2381 = CNST_TABLE_REF(((long) 12));
      {
	 obj_t list2303_2383;
	 {
	    obj_t aux_4758;
	    aux_4758 = CNST_TABLE_REF(((long) 11));
	    list2303_2383 = MAKE_PAIR(aux_4758, BNIL);
	 }
	 __procedure_set___197_cfa_closure = find_global_223_ast_env(arg2301_2381, list2303_2383);
      }
   }
   {
      obj_t arg2305_2385;
      arg2305_2385 = CNST_TABLE_REF(((long) 13));
      {
	 obj_t list2307_2387;
	 {
	    obj_t aux_4763;
	    aux_4763 = CNST_TABLE_REF(((long) 11));
	    list2307_2387 = MAKE_PAIR(aux_4763, BNIL);
	 }
	 __procedure_l_ref__76_cfa_closure = find_global_223_ast_env(arg2305_2385, list2307_2387);
      }
   }
   {
      obj_t arg2309_2389;
      arg2309_2389 = CNST_TABLE_REF(((long) 14));
      {
	 obj_t list2311_2391;
	 {
	    obj_t aux_4768;
	    aux_4768 = CNST_TABLE_REF(((long) 11));
	    list2311_2391 = MAKE_PAIR(aux_4768, BNIL);
	 }
	 __procedure_l_set___202_cfa_closure = find_global_223_ast_env(arg2309_2389, list2311_2391);
      }
   }
   {
      obj_t arg2313_2393;
      arg2313_2393 = CNST_TABLE_REF(((long) 15));
      {
	 obj_t list2315_2395;
	 {
	    obj_t aux_4773;
	    aux_4773 = CNST_TABLE_REF(((long) 11));
	    list2315_2395 = MAKE_PAIR(aux_4773, BNIL);
	 }
	 __procedure_el_ref__61_cfa_closure = find_global_223_ast_env(arg2313_2393, list2315_2395);
      }
   }
   {
      obj_t arg2317_2397;
      arg2317_2397 = CNST_TABLE_REF(((long) 16));
      {
	 obj_t list2319_2399;
	 {
	    obj_t aux_4778;
	    aux_4778 = CNST_TABLE_REF(((long) 11));
	    list2319_2399 = MAKE_PAIR(aux_4778, BNIL);
	 }
	 __procedure_el_set___46_cfa_closure = find_global_223_ast_env(arg2317_2397, list2319_2399);
      }
   }
   {
      obj_t arg2321_2401;
      arg2321_2401 = CNST_TABLE_REF(((long) 17));
      {
	 obj_t list2323_2403;
	 {
	    obj_t aux_4783;
	    aux_4783 = CNST_TABLE_REF(((long) 11));
	    list2323_2403 = MAKE_PAIR(aux_4783, BNIL);
	 }
	 __procedure_1_el_ref__37_cfa_closure = find_global_223_ast_env(arg2321_2401, list2323_2403);
      }
   }
   {
      obj_t arg2325_2405;
      arg2325_2405 = CNST_TABLE_REF(((long) 18));
      {
	 obj_t list2327_2407;
	 {
	    obj_t aux_4788;
	    aux_4788 = CNST_TABLE_REF(((long) 11));
	    list2327_2407 = MAKE_PAIR(aux_4788, BNIL);
	 }
	 __procedure_1_el_set___97_cfa_closure = find_global_223_ast_env(arg2325_2405, list2327_2407);
      }
   }
   {
      obj_t arg2329_2409;
      arg2329_2409 = CNST_TABLE_REF(((long) 19));
      {
	 obj_t list2331_2411;
	 {
	    obj_t aux_4793;
	    aux_4793 = CNST_TABLE_REF(((long) 11));
	    list2331_2411 = MAKE_PAIR(aux_4793, BNIL);
	 }
	 __make_el_procedure__202_cfa_closure = find_global_223_ast_env(arg2329_2409, list2331_2411);
      }
   }
   {
      obj_t arg2334_2413;
      arg2334_2413 = CNST_TABLE_REF(((long) 20));
      {
	 obj_t list2336_2415;
	 {
	    obj_t aux_4798;
	    aux_4798 = CNST_TABLE_REF(((long) 11));
	    list2336_2415 = MAKE_PAIR(aux_4798, BNIL);
	 }
	 __make_el_procedure_1__141_cfa_closure = find_global_223_ast_env(arg2334_2413, list2336_2415);
      }
   }
   {
      obj_t arg2339_2417;
      arg2339_2417 = CNST_TABLE_REF(((long) 21));
      {
	 obj_t list2342_2419;
	 {
	    obj_t aux_4803;
	    aux_4803 = CNST_TABLE_REF(((long) 11));
	    list2342_2419 = MAKE_PAIR(aux_4803, BNIL);
	 }
	 return (__make_l_procedure__54_cfa_closure = find_global_223_ast_env(arg2339_2417, list2342_2419),
	    BUNSPEC);
      }
   }
}


obj_t 
stop_cache_174_cfa_closure()
{
   __procedure_ref__66_cfa_closure = BFALSE;
   __procedure_set___197_cfa_closure = BFALSE;
   __procedure_l_ref__76_cfa_closure = BFALSE;
   __procedure_l_set___202_cfa_closure = BFALSE;
   __procedure_el_ref__61_cfa_closure = BFALSE;
   __procedure_el_set___46_cfa_closure = BFALSE;
   __procedure_1_el_ref__37_cfa_closure = BFALSE;
   __procedure_1_el_set___97_cfa_closure = BFALSE;
   __make_el_procedure__202_cfa_closure = BFALSE;
   __make_el_procedure_1__141_cfa_closure = BFALSE;
   return (__make_l_procedure__54_cfa_closure = BFALSE,
      BUNSPEC);
}


obj_t 
imported_modules_init_94_cfa_closure()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_CLOSURE");
   module_initialization_70_engine_param(((long) 0), "CFA_CLOSURE");
   module_initialization_70_type_type(((long) 0), "CFA_CLOSURE");
   module_initialization_70_type_cache(((long) 0), "CFA_CLOSURE");
   module_initialization_70_tools_shape(((long) 0), "CFA_CLOSURE");
   module_initialization_70_tools_speek(((long) 0), "CFA_CLOSURE");
   module_initialization_70_ast_var(((long) 0), "CFA_CLOSURE");
   module_initialization_70_ast_node(((long) 0), "CFA_CLOSURE");
   module_initialization_70_ast_env(((long) 0), "CFA_CLOSURE");
   module_initialization_70_cfa_info(((long) 0), "CFA_CLOSURE");
   module_initialization_70_cfa_cfa(((long) 0), "CFA_CLOSURE");
   module_initialization_70_cfa_approx(((long) 0), "CFA_CLOSURE");
   module_initialization_70_cfa_set(((long) 0), "CFA_CLOSURE");
   return module_initialization_70_cfa_stack(((long) 0), "CFA_CLOSURE");
}
