/*===========================================================================*/
/*   (Cfa/collect.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


extern obj_t pre_vector_set__app_211_cfa_info;
static obj_t get_atype_143_cfa_collect(obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t __used_alloc__125_cfa_collect = BUNSPEC;
static obj_t node_collect__175_cfa_collect(node_t, variable_t);
static bool_t monomorphic_vector__154_cfa_collect(obj_t);
extern obj_t scnst_ast_var;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t node_collect__default1910_218_cfa_collect(node_t, variable_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t get_allocs_52_cfa_collect();
static obj_t imported_modules_init_94_cfa_collect();
extern obj_t module_initialization_70_cfa_collect(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_typeof(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_dump(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_procedure(long, char *);
extern obj_t module_initialization_70_cfa_vector(long, char *);
extern obj_t module_initialization_70_cfa_struct(long, char *);
extern obj_t module_initialization_70_cfa_box(long, char *);
extern obj_t module_initialization_70_cfa_closure(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_cfa_collect();
static obj_t cnst_init_137_cfa_collect();
extern obj_t __optim__89_engine_param;
extern obj_t cfun_ast_var;
extern obj_t pre_make_procedure_app_60_cfa_info;
extern obj_t __module__166_module_module;
extern obj_t pre_create_vector_app_162_cfa_info;
extern obj_t add_funcall__195_cfa_closure(node_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t pre_vector_ref_app_208_cfa_info;
static obj_t require_initialization_114_cfa_collect = BUNSPEC;
extern obj_t pre_procedure_set__app_208_cfa_info;
extern obj_t var_ast_node;
static bool_t node_collect___108_cfa_collect(obj_t, variable_t);
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cfa_collect();
extern obj_t kwote_node_102_cfa_info;
extern obj_t cast_ast_node;
extern obj_t pre_make_vector_app_251_cfa_info;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t pre_make_struct_app_218_cfa_info;
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
static obj_t _node_collect__default1910_229_cfa_collect(obj_t, obj_t, obj_t);
extern obj_t pre_make_box_186_cfa_info;
extern long class_num_218___object(obj_t);
extern obj_t _get_allocs_32_cfa_collect(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t _collect_all_approx__18_cfa_collect(obj_t, obj_t);
extern obj_t pre_procedure_ref_app_85_cfa_info;
static obj_t _node_collect__42_cfa_collect(obj_t, obj_t, obj_t);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t kwote_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t collect_all_approx__236_cfa_collect(obj_t);
extern obj_t funcall_ast_node;
extern obj_t pre_struct_set__app_116_cfa_info;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t pre_struct_ref_app_207_cfa_info;
extern obj_t app_ast_node;
extern node_t top_level_sexp__node_204_ast_sexp(obj_t, obj_t);
static obj_t __cnst[19];

DEFINE_STATIC_GENERIC(node_collect__env_176_cfa_collect, _node_collect__42_cfa_collect2389, _node_collect__42_cfa_collect, 0L, 2);
DEFINE_STRING(string2380_cfa_collect, string2380_cfa_collect2390, "No method for this object", 25);
DEFINE_EXPORT_PROCEDURE(collect_all_approx__env_94_cfa_collect, _collect_all_approx__18_cfa_collect2391, _collect_all_approx__18_cfa_collect, 0L, 1);
DEFINE_EXPORT_PROCEDURE(get_allocs_env_59_cfa_collect, _get_allocs_32_cfa_collect2392, _get_allocs_32_cfa_collect, 0L, 0);
DEFINE_STRING(string2383_cfa_collect, string2383_cfa_collect2393, "REAL STRING BOOLEAN CHAR INTEGER C-STRUCT-SET! C-STRUCT-REF C-MAKE-STRUCT C-VECTOR-SET! C-VECTOR-REF C-CREATE-VECTOR PROCEDURE-SET! PROCEDURE-REF MAKE-VA-PROCEDURE MAKE-FX-PROCEDURE CFA (PRAGMA \"\") C-MAKE-VECTOR NODE-COLLECT!-DEFAULT1910 ", 238);
DEFINE_STRING(string2381_cfa_collect, string2381_cfa_collect2394, " ", 1);
DEFINE_STRING(string2382_cfa_collect, string2382_cfa_collect2395, "Je collecte une scnt: ", 22);
DEFINE_STATIC_PROCEDURE(node_collect__default1910_env_12_cfa_collect, _node_collect__default1910_229_cfa_collect2396, _node_collect__default1910_229_cfa_collect, 0L, 2);

obj_t 
module_initialization_70_cfa_collect(long checksum_3639, char *from_3640)
{
   if (CBOOL(require_initialization_114_cfa_collect))
     {
	require_initialization_114_cfa_collect = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_collect();
	cnst_init_137_cfa_collect();
	imported_modules_init_94_cfa_collect();
	toplevel_init_63_cfa_collect();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_collect()
{
   module_initialization_70___object(((long) 0), "CFA_COLLECT");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_COLLECT");
   module_initialization_70___reader(((long) 0), "CFA_COLLECT");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_collect()
{
   {
      obj_t cnst_port_138_3631;
      cnst_port_138_3631 = open_input_string(string2383_cfa_collect);
      {
	 long i_3632;
	 i_3632 = ((long) 18);
       loop_3633:
	 {
	    bool_t test2384_3634;
	    test2384_3634 = (i_3632 == ((long) -1));
	    if (test2384_3634)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2385_3635;
		    {
		       obj_t list2386_3636;
		       {
			  obj_t arg2387_3637;
			  arg2387_3637 = BNIL;
			  list2386_3636 = MAKE_PAIR(cnst_port_138_3631, arg2387_3637);
		       }
		       arg2385_3635 = read___reader(list2386_3636);
		    }
		    CNST_TABLE_SET(i_3632, arg2385_3635);
		 }
		 {
		    int aux_3638;
		    {
		       long aux_3657;
		       aux_3657 = (i_3632 - ((long) 1));
		       aux_3638 = (int) (aux_3657);
		    }
		    {
		       long i_3660;
		       i_3660 = (long) (aux_3638);
		       i_3632 = i_3660;
		       goto loop_3633;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_collect()
{
   add_generic__110___object(node_collect__env_176_cfa_collect, node_collect__default1910_env_12_cfa_collect);
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, var_ast_node, ((long) 2));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, sequence_ast_node, ((long) 3));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, app_ast_node, ((long) 4));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, setq_ast_node, ((long) 9));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, conditional_ast_node, ((long) 10));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, fail_ast_node, ((long) 11));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, select_ast_node, ((long) 12));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, let_fun_218_ast_node, ((long) 13));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, let_var_6_ast_node, ((long) 14));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, set_ex_it_116_ast_node, ((long) 15));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, jump_ex_it_184_ast_node, ((long) 16));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, make_box_202_ast_node, ((long) 17));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, box_set__221_ast_node, ((long) 18));
   add_inlined_method__244___object(node_collect__env_176_cfa_collect, box_ref_242_ast_node, ((long) 19));
   return (__used_alloc__125_cfa_collect = BNIL,
      BUNSPEC);
}


obj_t 
collect_all_approx__236_cfa_collect(obj_t globals_1)
{
   {
      obj_t l1870_1993;
      {
	 bool_t aux_3683;
	 l1870_1993 = globals_1;
       lname1871_1994:
	 if (PAIRP(l1870_1993))
	   {
	      {
		 obj_t global_1996;
		 global_1996 = CAR(l1870_1993);
		 {
		    sfun_t value_3021;
		    {
		       value_t aux_3687;
		       {
			  global_t obj_3020;
			  obj_3020 = (global_t) (global_1996);
			  aux_3687 = (((global_t) CREF(obj_3020))->value);
		       }
		       value_3021 = (sfun_t) (aux_3687);
		    }
		    {
		       variable_t aux_3695;
		       node_t aux_3691;
		       {
			  global_t aux_3696;
			  aux_3696 = (global_t) (global_1996);
			  aux_3695 = (variable_t) (aux_3696);
		       }
		       {
			  obj_t aux_3692;
			  aux_3692 = (((sfun_t) CREF(value_3021))->body);
			  aux_3691 = (node_t) (aux_3692);
		       }
		       node_collect__175_cfa_collect(aux_3691, aux_3695);
		    }
		 }
	      }
	      {
		 obj_t l1870_3700;
		 l1870_3700 = CDR(l1870_1993);
		 l1870_1993 = l1870_3700;
		 goto lname1871_1994;
	      }
	   }
	 else
	   {
	      aux_3683 = ((bool_t) 1);
	   }
	 return BBOOL(aux_3683);
      }
   }
}


obj_t 
_collect_all_approx__18_cfa_collect(obj_t env_3628, obj_t globals_3629)
{
   return collect_all_approx__236_cfa_collect(globals_3629);
}


obj_t 
node_collect__default1910_218_cfa_collect(node_t node_6, variable_t owner_7)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string2380_cfa_collect, (obj_t) (node_6));
}


obj_t 
_node_collect__default1910_229_cfa_collect(obj_t env_3625, obj_t node_3626, obj_t owner_3627)
{
   return node_collect__default1910_218_cfa_collect((node_t) (node_3626), (variable_t) (owner_3627));
}


obj_t 
node_collect__175_cfa_collect(node_t node_4, variable_t owner_5)
{
 node_collect__175_cfa_collect:
   {
      obj_t method2205_2788;
      obj_t class2210_2789;
      {
	 obj_t arg2213_2786;
	 obj_t arg2214_2787;
	 {
	    object_t obj_3033;
	    obj_3033 = (object_t) (node_4);
	    {
	       obj_t pre_method_105_3034;
	       pre_method_105_3034 = PROCEDURE_REF(node_collect__env_176_cfa_collect, ((long) 2));
	       if (INTEGERP(pre_method_105_3034))
		 {
		    PROCEDURE_SET(node_collect__env_176_cfa_collect, ((long) 2), BUNSPEC);
		    arg2213_2786 = pre_method_105_3034;
		 }
	       else
		 {
		    long obj_class_num_177_3039;
		    obj_class_num_177_3039 = TYPE(obj_3033);
		    {
		       obj_t arg1183_3040;
		       arg1183_3040 = PROCEDURE_REF(node_collect__env_176_cfa_collect, ((long) 1));
		       {
			  long arg1184_3044;
			  {
			     long arg1186_3045;
			     arg1186_3045 = OBJECT_TYPE;
			     arg1184_3044 = (obj_class_num_177_3039 - arg1186_3045);
			  }
			  arg2213_2786 = VECTOR_REF(arg1183_3040, arg1184_3044);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_3050;
	    object_3050 = (object_t) (node_4);
	    {
	       long arg1187_3051;
	       {
		  long arg1188_3052;
		  long arg1189_3053;
		  arg1188_3052 = TYPE(object_3050);
		  arg1189_3053 = OBJECT_TYPE;
		  arg1187_3051 = (arg1188_3052 - arg1189_3053);
	       }
	       {
		  obj_t vector_3057;
		  vector_3057 = __classes__134___object;
		  arg2214_2787 = VECTOR_REF(vector_3057, arg1187_3051);
	       }
	    }
	 }
	 method2205_2788 = arg2213_2786;
	 class2210_2789 = arg2214_2787;
	 {
	    if (INTEGERP(method2205_2788))
	      {
		 switch ((long) CINT(method2205_2788))
		   {
		   case ((long) 0):
		      return BUNSPEC;
		      break;
		   case ((long) 1):
		      {
			 kwote_t node_2797;
			 node_2797 = (kwote_t) (node_4);
			 {
			    obj_t value_2799;
			    value_2799 = (((kwote_t) CREF(node_2797))->value);
			    {
			       bool_t test2217_2800;
			       {
				  bool_t test2230_2815;
				  {
				     long n1_3060;
				     n1_3060 = (long) CINT(__optim__89_engine_param);
				     test2230_2815 = (n1_3060 >= ((long) 2));
				  }
				  if (test2230_2815)
				    {
				       test2217_2800 = VECTORP(value_2799);
				    }
				  else
				    {
				       test2217_2800 = ((bool_t) 0);
				    }
			       }
			       if (test2217_2800)
				 {
				    node_t dummy_2801;
				    {
				       obj_t arg2220_2805;
				       {
					  obj_t arg2221_2806;
					  long arg2222_2807;
					  obj_t arg2223_2808;
					  arg2221_2806 = CNST_TABLE_REF(((long) 1));
					  arg2222_2807 = VECTOR_LENGTH(value_2799);
					  if (monomorphic_vector__154_cfa_collect(value_2799))
					    {
					       arg2223_2808 = VECTOR_REF(value_2799, ((long) 0));
					    }
					  else
					    {
					       arg2223_2808 = CNST_TABLE_REF(((long) 2));
					    }
					  {
					     obj_t list2225_2810;
					     {
						obj_t arg2226_2811;
						{
						   obj_t arg2227_2812;
						   arg2227_2812 = MAKE_PAIR(BNIL, BNIL);
						   arg2226_2811 = MAKE_PAIR(arg2223_2808, arg2227_2812);
						}
						{
						   obj_t aux_3742;
						   aux_3742 = BINT(arg2222_2807);
						   list2225_2810 = MAKE_PAIR(aux_3742, arg2226_2811);
						}
					     }
					     arg2220_2805 = cons__138___r4_pairs_and_lists_6_3(arg2221_2806, list2225_2810);
					  }
				       }
				       dummy_2801 = top_level_sexp__node_204_ast_sexp(arg2220_2805, BFALSE);
				    }
				    {
				       kwote_node_102_t obj1872_2802;
				       obj1872_2802 = ((kwote_node_102_t) (node_2797));
				       {
					  kwote_node_102_t arg2218_2803;
					  {
					     kwote_node_102_t res2365_3069;
					     {
						kwote_node_102_t new1449_3067;
						new1449_3067 = ((kwote_node_102_t) BREF(GC_MALLOC(sizeof(struct kwote_node_102))));
						((((kwote_node_102_t) CREF(new1449_3067))->node) = ((node_t) dummy_2801), BUNSPEC);
						res2365_3069 = new1449_3067;
					     }
					     arg2218_2803 = res2365_3069;
					  }
					  {
					     obj_t aux_3752;
					     object_t aux_3750;
					     aux_3752 = (obj_t) (arg2218_2803);
					     aux_3750 = (object_t) (obj1872_2802);
					     OBJECT_WIDENING_SET(aux_3750, aux_3752);
					  }
				       }
				       {
					  long arg2219_2804;
					  arg2219_2804 = class_num_218___object(kwote_node_102_cfa_info);
					  {
					     obj_t obj_3070;
					     obj_3070 = (obj_t) (obj1872_2802);
					     (((obj_t) CREF(obj_3070))->header = MAKE_HEADER(arg2219_2804, 0), BUNSPEC);
					  }
				       }
				       obj1872_2802;
				    }
				    {
				       node_t node_3758;
				       node_3758 = dummy_2801;
				       node_4 = node_3758;
				       goto node_collect__175_cfa_collect;
				    }
				 }
			       else
				 {
				    return BUNSPEC;
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 2):
		      {
			 var_t node_2816;
			 node_2816 = (var_t) (node_4);
			 {
			    variable_t v_2818;
			    v_2818 = (((var_t) CREF(node_2816))->variable);
			    {
			       bool_t test2231_2819;
			       {
				  bool_t test2253_2837;
				  test2253_2837 = is_a__118___object((obj_t) (v_2818), global_ast_var);
				  if (test2253_2837)
				    {
				       bool_t test2254_2838;
				       {
					  obj_t obj2_3076;
					  obj2_3076 = __module__166_module_module;
					  {
					     obj_t aux_3764;
					     {
						global_t obj_3074;
						obj_3074 = (global_t) (v_2818);
						aux_3764 = (((global_t) CREF(obj_3074))->module);
					     }
					     test2254_2838 = (aux_3764 == obj2_3076);
					  }
				       }
				       if (test2254_2838)
					 {
					    bool_t test2255_2839;
					    {
					       obj_t aux_3769;
					       {
						  value_t aux_3770;
						  {
						     global_t obj_3077;
						     obj_3077 = (global_t) (v_2818);
						     aux_3770 = (((global_t) CREF(obj_3077))->value);
						  }
						  aux_3769 = (obj_t) (aux_3770);
					       }
					       test2255_2839 = is_a__118___object(aux_3769, scnst_ast_var);
					    }
					    if (test2255_2839)
					      {
						 bool_t test2256_2840;
						 {
						    obj_t aux_3776;
						    {
						       obj_t aux_3777;
						       {
							  scnst_t obj_3080;
							  {
							     value_t aux_3778;
							     {
								global_t obj_3079;
								obj_3079 = (global_t) (v_2818);
								aux_3778 = (((global_t) CREF(obj_3079))->value);
							     }
							     obj_3080 = (scnst_t) (aux_3778);
							  }
							  aux_3777 = (((scnst_t) CREF(obj_3080))->node);
						       }
						       aux_3776 = memq___r4_pairs_and_lists_6_3(aux_3777, __used_alloc__125_cfa_collect);
						    }
						    test2256_2840 = CBOOL(aux_3776);
						 }
						 if (test2256_2840)
						   {
						      test2231_2819 = ((bool_t) 0);
						   }
						 else
						   {
						      test2231_2819 = ((bool_t) 1);
						   }
					      }
					    else
					      {
						 test2231_2819 = ((bool_t) 0);
					      }
					 }
				       else
					 {
					    test2231_2819 = ((bool_t) 0);
					 }
				    }
				  else
				    {
				       test2231_2819 = ((bool_t) 0);
				    }
			       }
			       if (test2231_2819)
				 {
				    {
				       bool_t test2232_2820;
				       {
					  obj_t aux_3787;
					  aux_3787 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 3)), BINT(((long) 2)));
					  test2232_2820 = CBOOL(aux_3787);
				       }
				       if (test2232_2820)
					 {
					    obj_t arg2234_2822;
					    obj_t arg2236_2824;
					    arg2234_2822 = shape_tools_shape((obj_t) (v_2818));
					    {
					       obj_t aux_3795;
					       {
						  scnst_t obj_3083;
						  {
						     value_t aux_3796;
						     {
							global_t obj_3082;
							obj_3082 = (global_t) (v_2818);
							aux_3796 = (((global_t) CREF(obj_3082))->value);
						     }
						     obj_3083 = (scnst_t) (aux_3796);
						  }
						  aux_3795 = (((scnst_t) CREF(obj_3083))->node);
					       }
					       arg2236_2824 = shape_tools_shape(aux_3795);
					    }
					    {
					       obj_t list2237_2825;
					       {
						  obj_t arg2242_2826;
						  {
						     obj_t arg2243_2827;
						     {
							obj_t arg2244_2828;
							{
							   obj_t arg2245_2829;
							   {
							      obj_t aux_3802;
							      aux_3802 = BCHAR(((unsigned char) '\n'));
							      arg2245_2829 = MAKE_PAIR(aux_3802, BNIL);
							   }
							   arg2244_2828 = MAKE_PAIR(arg2236_2824, arg2245_2829);
							}
							arg2243_2827 = MAKE_PAIR(string2381_cfa_collect, arg2244_2828);
						     }
						     arg2242_2826 = MAKE_PAIR(arg2234_2822, arg2243_2827);
						  }
						  list2237_2825 = MAKE_PAIR(string2382_cfa_collect, arg2242_2826);
					       }
					       print_trace_107_tools_trace(list2237_2825);
					    }
					 }
				       else
					 {
					    BUNSPEC;
					 }
				    }
				    {
				       node_t aux_3810;
				       {
					  obj_t aux_3811;
					  {
					     scnst_t obj_3085;
					     {
						value_t aux_3812;
						{
						   global_t obj_3084;
						   obj_3084 = (global_t) (v_2818);
						   aux_3812 = (((global_t) CREF(obj_3084))->value);
						}
						obj_3085 = (scnst_t) (aux_3812);
					     }
					     aux_3811 = (((scnst_t) CREF(obj_3085))->node);
					  }
					  aux_3810 = (node_t) (aux_3811);
				       }
				       node_collect__175_cfa_collect(aux_3810, owner_5);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			 }
			 return BUNSPEC;
		      }
		      break;
		   case ((long) 3):
		      {
			 sequence_t node_2845;
			 node_2845 = (sequence_t) (node_4);
			 {
			    bool_t aux_3820;
			    aux_3820 = node_collect___108_cfa_collect((((sequence_t) CREF(node_2845))->nodes), owner_5);
			    return BBOOL(aux_3820);
			 }
		      }
		      break;
		   case ((long) 4):
		      {
			 app_t node_2848;
			 node_2848 = (app_t) (node_4);
			 node_collect___108_cfa_collect((((app_t) CREF(node_2848))->args), owner_5);
			 {
			    node_t aux_3827;
			    {
			       var_t aux_3828;
			       aux_3828 = (((app_t) CREF(node_2848))->fun);
			       aux_3827 = (node_t) (aux_3828);
			    }
			    node_collect__175_cfa_collect(aux_3827, owner_5);
			 }
			 {
			    variable_t v_2853;
			    {
			       var_t arg2318_2915;
			       arg2318_2915 = (((app_t) CREF(node_2848))->fun);
			       v_2853 = (((var_t) CREF(arg2318_2915))->variable);
			    }
			    {
			       bool_t test2264_2854;
			       {
				  bool_t test2316_2913;
				  test2316_2913 = is_a__118___object((obj_t) (v_2853), global_ast_var);
				  if (test2316_2913)
				    {
				       obj_t aux_3837;
				       {
					  value_t aux_3838;
					  aux_3838 = (((variable_t) CREF(v_2853))->value);
					  aux_3837 = (obj_t) (aux_3838);
				       }
				       test2264_2854 = is_a__118___object(aux_3837, cfun_ast_var);
				    }
				  else
				    {
				       test2264_2854 = ((bool_t) 0);
				    }
			       }
			       if (test2264_2854)
				 {
				    {
				       obj_t case_value_58_2855;
				       {
					  global_t obj_3094;
					  obj_3094 = (global_t) (v_2853);
					  case_value_58_2855 = (((global_t) CREF(obj_3094))->id);
				       }
				       {
					  bool_t test_3845;
					  {
					     obj_t aux_3846;
					     aux_3846 = CNST_TABLE_REF(((long) 4));
					     test_3845 = (case_value_58_2855 == aux_3846);
					  }
					  if (test_3845)
					    {
					       {
						  obj_t obj2_3099;
						  obj2_3099 = __used_alloc__125_cfa_collect;
						  {
						     obj_t aux_3849;
						     aux_3849 = (obj_t) (node_2848);
						     __used_alloc__125_cfa_collect = MAKE_PAIR(aux_3849, obj2_3099);
						  }
					       }
					       {
						  pre_make_procedure_app_60_t obj1874_2857;
						  obj1874_2857 = ((pre_make_procedure_app_60_t) (node_2848));
						  {
						     pre_make_procedure_app_60_t arg2266_2858;
						     {
							pre_make_procedure_app_60_t res2366_3105;
							{
							   obj_t key_3101;
							   key_3101 = BINT(((long) -1));
							   {
							      pre_make_procedure_app_60_t new1620_3102;
							      new1620_3102 = ((pre_make_procedure_app_60_t) BREF(GC_MALLOC(sizeof(struct pre_make_procedure_app_60))));
							      ((((pre_make_procedure_app_60_t) CREF(new1620_3102))->owner) = ((variable_t) owner_5), BUNSPEC);
							      ((((pre_make_procedure_app_60_t) CREF(new1620_3102))->key) = ((obj_t) key_3101), BUNSPEC);
							      res2366_3105 = new1620_3102;
							   }
							}
							arg2266_2858 = res2366_3105;
						     }
						     {
							obj_t aux_3859;
							object_t aux_3857;
							aux_3859 = (obj_t) (arg2266_2858);
							aux_3857 = (object_t) (obj1874_2857);
							OBJECT_WIDENING_SET(aux_3857, aux_3859);
						     }
						  }
						  {
						     long arg2267_2859;
						     arg2267_2859 = class_num_218___object(pre_make_procedure_app_60_cfa_info);
						     {
							obj_t obj_3106;
							obj_3106 = (obj_t) (obj1874_2857);
							(((obj_t) CREF(obj_3106))->header = MAKE_HEADER(arg2267_2859, 0), BUNSPEC);
						     }
						  }
						  (obj_t) (obj1874_2857);
					       }
					    }
					  else
					    {
					       bool_t test_3866;
					       {
						  obj_t aux_3867;
						  aux_3867 = CNST_TABLE_REF(((long) 5));
						  test_3866 = (case_value_58_2855 == aux_3867);
					       }
					       if (test_3866)
						 {
						    {
						       obj_t obj2_3112;
						       obj2_3112 = __used_alloc__125_cfa_collect;
						       {
							  obj_t aux_3870;
							  aux_3870 = (obj_t) (node_2848);
							  __used_alloc__125_cfa_collect = MAKE_PAIR(aux_3870, obj2_3112);
						       }
						    }
						    {
						       pre_make_procedure_app_60_t obj1875_2861;
						       obj1875_2861 = ((pre_make_procedure_app_60_t) (node_2848));
						       {
							  pre_make_procedure_app_60_t arg2269_2862;
							  {
							     pre_make_procedure_app_60_t res2367_3118;
							     {
								obj_t key_3114;
								key_3114 = BINT(((long) -1));
								{
								   pre_make_procedure_app_60_t new1620_3115;
								   new1620_3115 = ((pre_make_procedure_app_60_t) BREF(GC_MALLOC(sizeof(struct pre_make_procedure_app_60))));
								   ((((pre_make_procedure_app_60_t) CREF(new1620_3115))->owner) = ((variable_t) owner_5), BUNSPEC);
								   ((((pre_make_procedure_app_60_t) CREF(new1620_3115))->key) = ((obj_t) key_3114), BUNSPEC);
								   res2367_3118 = new1620_3115;
								}
							     }
							     arg2269_2862 = res2367_3118;
							  }
							  {
							     obj_t aux_3880;
							     object_t aux_3878;
							     aux_3880 = (obj_t) (arg2269_2862);
							     aux_3878 = (object_t) (obj1875_2861);
							     OBJECT_WIDENING_SET(aux_3878, aux_3880);
							  }
						       }
						       {
							  long arg2270_2863;
							  arg2270_2863 = class_num_218___object(pre_make_procedure_app_60_cfa_info);
							  {
							     obj_t obj_3119;
							     obj_3119 = (obj_t) (obj1875_2861);
							     (((obj_t) CREF(obj_3119))->header = MAKE_HEADER(arg2270_2863, 0), BUNSPEC);
							  }
						       }
						       (obj_t) (obj1875_2861);
						    }
						 }
					       else
						 {
						    bool_t test_3887;
						    {
						       obj_t aux_3888;
						       aux_3888 = CNST_TABLE_REF(((long) 6));
						       test_3887 = (case_value_58_2855 == aux_3888);
						    }
						    if (test_3887)
						      {
							 pre_procedure_ref_app_85_t obj1876_2865;
							 obj1876_2865 = ((pre_procedure_ref_app_85_t) (node_2848));
							 {
							    obj_t aux_3894;
							    object_t aux_3892;
							    {
							       pre_procedure_ref_app_85_t aux_3895;
							       {
								  aux_3895 = ((pre_procedure_ref_app_85_t) BREF(GC_MALLOC(sizeof(struct pre_procedure_ref_app_85))));
							       }
							       aux_3894 = (obj_t) (aux_3895);
							    }
							    aux_3892 = (object_t) (obj1876_2865);
							    OBJECT_WIDENING_SET(aux_3892, aux_3894);
							 }
							 {
							    long arg2273_2867;
							    arg2273_2867 = class_num_218___object(pre_procedure_ref_app_85_cfa_info);
							    {
							       obj_t obj_3125;
							       obj_3125 = (obj_t) (obj1876_2865);
							       (((obj_t) CREF(obj_3125))->header = MAKE_HEADER(arg2273_2867, 0), BUNSPEC);
							    }
							 }
							 (obj_t) (obj1876_2865);
						      }
						    else
						      {
							 bool_t test_3903;
							 {
							    obj_t aux_3904;
							    aux_3904 = CNST_TABLE_REF(((long) 7));
							    test_3903 = (case_value_58_2855 == aux_3904);
							 }
							 if (test_3903)
							   {
							      pre_procedure_set__app_208_t obj1877_2869;
							      obj1877_2869 = ((pre_procedure_set__app_208_t) (node_2848));
							      {
								 obj_t aux_3910;
								 object_t aux_3908;
								 {
								    pre_procedure_set__app_208_t aux_3911;
								    {
								       aux_3911 = ((pre_procedure_set__app_208_t) BREF(GC_MALLOC(sizeof(struct pre_procedure_set__app_208))));
								    }
								    aux_3910 = (obj_t) (aux_3911);
								 }
								 aux_3908 = (object_t) (obj1877_2869);
								 OBJECT_WIDENING_SET(aux_3908, aux_3910);
							      }
							      {
								 long arg2281_2871;
								 arg2281_2871 = class_num_218___object(pre_procedure_set__app_208_cfa_info);
								 {
								    obj_t obj_3131;
								    obj_3131 = (obj_t) (obj1877_2869);
								    (((obj_t) CREF(obj_3131))->header = MAKE_HEADER(arg2281_2871, 0), BUNSPEC);
								 }
							      }
							      (obj_t) (obj1877_2869);
							   }
							 else
							   {
							      BFALSE;
							   }
						      }
						 }
					    }
				       }
				    }
				    {
				       bool_t test2287_2876;
				       {
					  long n1_3133;
					  n1_3133 = (long) CINT(__optim__89_engine_param);
					  test2287_2876 = (n1_3133 >= ((long) 2));
				       }
				       if (test2287_2876)
					 {
					    obj_t case_value_58_2877;
					    {
					       global_t obj_3135;
					       obj_3135 = (global_t) (v_2853);
					       case_value_58_2877 = (((global_t) CREF(obj_3135))->id);
					    }
					    {
					       bool_t test_3924;
					       {
						  obj_t aux_3925;
						  aux_3925 = CNST_TABLE_REF(((long) 1));
						  test_3924 = (case_value_58_2877 == aux_3925);
					       }
					       if (test_3924)
						 {
						    {
						       obj_t obj2_3140;
						       obj2_3140 = __used_alloc__125_cfa_collect;
						       {
							  obj_t aux_3928;
							  aux_3928 = (obj_t) (node_2848);
							  __used_alloc__125_cfa_collect = MAKE_PAIR(aux_3928, obj2_3140);
						       }
						    }
						    {
						       pre_make_vector_app_251_t obj1878_2879;
						       obj1878_2879 = ((pre_make_vector_app_251_t) (node_2848));
						       {
							  pre_make_vector_app_251_t arg2289_2880;
							  {
							     pre_make_vector_app_251_t res2370_3146;
							     {
								obj_t key_3142;
								key_3142 = BINT(((long) -1));
								{
								   pre_make_vector_app_251_t new1698_3143;
								   new1698_3143 = ((pre_make_vector_app_251_t) BREF(GC_MALLOC(sizeof(struct pre_make_vector_app_251))));
								   ((((pre_make_vector_app_251_t) CREF(new1698_3143))->owner) = ((variable_t) owner_5), BUNSPEC);
								   ((((pre_make_vector_app_251_t) CREF(new1698_3143))->key) = ((obj_t) key_3142), BUNSPEC);
								   res2370_3146 = new1698_3143;
								}
							     }
							     arg2289_2880 = res2370_3146;
							  }
							  {
							     obj_t aux_3938;
							     object_t aux_3936;
							     aux_3938 = (obj_t) (arg2289_2880);
							     aux_3936 = (object_t) (obj1878_2879);
							     OBJECT_WIDENING_SET(aux_3936, aux_3938);
							  }
						       }
						       {
							  long arg2290_2881;
							  arg2290_2881 = class_num_218___object(pre_make_vector_app_251_cfa_info);
							  {
							     obj_t obj_3147;
							     obj_3147 = (obj_t) (obj1878_2879);
							     (((obj_t) CREF(obj_3147))->header = MAKE_HEADER(arg2290_2881, 0), BUNSPEC);
							  }
						       }
						       return (obj_t) (obj1878_2879);
						    }
						 }
					       else
						 {
						    bool_t test_3945;
						    {
						       obj_t aux_3946;
						       aux_3946 = CNST_TABLE_REF(((long) 8));
						       test_3945 = (case_value_58_2877 == aux_3946);
						    }
						    if (test_3945)
						      {
							 {
							    obj_t obj2_3153;
							    obj2_3153 = __used_alloc__125_cfa_collect;
							    {
							       obj_t aux_3949;
							       aux_3949 = (obj_t) (node_2848);
							       __used_alloc__125_cfa_collect = MAKE_PAIR(aux_3949, obj2_3153);
							    }
							 }
							 {
							    pre_create_vector_app_162_t obj1879_2883;
							    obj1879_2883 = ((pre_create_vector_app_162_t) (node_2848));
							    {
							       pre_create_vector_app_162_t arg2292_2884;
							       {
								  pre_create_vector_app_162_t res2371_3159;
								  {
								     obj_t key_3155;
								     key_3155 = BINT(((long) -1));
								     {
									pre_create_vector_app_162_t new1710_3156;
									new1710_3156 = ((pre_create_vector_app_162_t) BREF(GC_MALLOC(sizeof(struct pre_create_vector_app_162))));
									((((pre_create_vector_app_162_t) CREF(new1710_3156))->owner) = ((variable_t) owner_5), BUNSPEC);
									((((pre_create_vector_app_162_t) CREF(new1710_3156))->key) = ((obj_t) key_3155), BUNSPEC);
									res2371_3159 = new1710_3156;
								     }
								  }
								  arg2292_2884 = res2371_3159;
							       }
							       {
								  obj_t aux_3959;
								  object_t aux_3957;
								  aux_3959 = (obj_t) (arg2292_2884);
								  aux_3957 = (object_t) (obj1879_2883);
								  OBJECT_WIDENING_SET(aux_3957, aux_3959);
							       }
							    }
							    {
							       long arg2293_2885;
							       arg2293_2885 = class_num_218___object(pre_create_vector_app_162_cfa_info);
							       {
								  obj_t obj_3160;
								  obj_3160 = (obj_t) (obj1879_2883);
								  (((obj_t) CREF(obj_3160))->header = MAKE_HEADER(arg2293_2885, 0), BUNSPEC);
							       }
							    }
							    return (obj_t) (obj1879_2883);
							 }
						      }
						    else
						      {
							 bool_t test_3966;
							 {
							    obj_t aux_3967;
							    aux_3967 = CNST_TABLE_REF(((long) 9));
							    test_3966 = (case_value_58_2877 == aux_3967);
							 }
							 if (test_3966)
							   {
							      pre_vector_ref_app_208_t obj1880_2887;
							      obj1880_2887 = ((pre_vector_ref_app_208_t) (node_2848));
							      {
								 obj_t aux_3973;
								 object_t aux_3971;
								 {
								    pre_vector_ref_app_208_t aux_3974;
								    {
								       aux_3974 = ((pre_vector_ref_app_208_t) BREF(GC_MALLOC(sizeof(struct pre_vector_ref_app_208))));
								    }
								    aux_3973 = (obj_t) (aux_3974);
								 }
								 aux_3971 = (object_t) (obj1880_2887);
								 OBJECT_WIDENING_SET(aux_3971, aux_3973);
							      }
							      {
								 long arg2296_2889;
								 arg2296_2889 = class_num_218___object(pre_vector_ref_app_208_cfa_info);
								 {
								    obj_t obj_3166;
								    obj_3166 = (obj_t) (obj1880_2887);
								    (((obj_t) CREF(obj_3166))->header = MAKE_HEADER(arg2296_2889, 0), BUNSPEC);
								 }
							      }
							      return (obj_t) (obj1880_2887);
							   }
							 else
							   {
							      bool_t test_3982;
							      {
								 obj_t aux_3983;
								 aux_3983 = CNST_TABLE_REF(((long) 10));
								 test_3982 = (case_value_58_2877 == aux_3983);
							      }
							      if (test_3982)
								{
								   pre_vector_set__app_211_t obj1881_2891;
								   obj1881_2891 = ((pre_vector_set__app_211_t) (node_2848));
								   {
								      obj_t aux_3989;
								      object_t aux_3987;
								      {
									 pre_vector_set__app_211_t aux_3990;
									 {
									    aux_3990 = ((pre_vector_set__app_211_t) BREF(GC_MALLOC(sizeof(struct pre_vector_set__app_211))));
									 }
									 aux_3989 = (obj_t) (aux_3990);
								      }
								      aux_3987 = (object_t) (obj1881_2891);
								      OBJECT_WIDENING_SET(aux_3987, aux_3989);
								   }
								   {
								      long arg2299_2893;
								      arg2299_2893 = class_num_218___object(pre_vector_set__app_211_cfa_info);
								      {
									 obj_t obj_3172;
									 obj_3172 = (obj_t) (obj1881_2891);
									 (((obj_t) CREF(obj_3172))->header = MAKE_HEADER(arg2299_2893, 0), BUNSPEC);
								      }
								   }
								   return (obj_t) (obj1881_2891);
								}
							      else
								{
								   bool_t test_3998;
								   {
								      obj_t aux_3999;
								      aux_3999 = CNST_TABLE_REF(((long) 11));
								      test_3998 = (case_value_58_2877 == aux_3999);
								   }
								   if (test_3998)
								     {
									{
									   obj_t obj2_3178;
									   obj2_3178 = __used_alloc__125_cfa_collect;
									   {
									      obj_t aux_4002;
									      aux_4002 = (obj_t) (node_2848);
									      __used_alloc__125_cfa_collect = MAKE_PAIR(aux_4002, obj2_3178);
									   }
									}
									{
									   pre_make_struct_app_218_t obj1882_2895;
									   obj1882_2895 = ((pre_make_struct_app_218_t) (node_2848));
									   {
									      pre_make_struct_app_218_t arg2301_2896;
									      {
										 pre_make_struct_app_218_t res2374_3184;
										 {
										    obj_t key_3180;
										    key_3180 = BINT(((long) -1));
										    {
										       pre_make_struct_app_218_t new1800_3181;
										       new1800_3181 = ((pre_make_struct_app_218_t) BREF(GC_MALLOC(sizeof(struct pre_make_struct_app_218))));
										       ((((pre_make_struct_app_218_t) CREF(new1800_3181))->owner) = ((variable_t) owner_5), BUNSPEC);
										       ((((pre_make_struct_app_218_t) CREF(new1800_3181))->key) = ((obj_t) key_3180), BUNSPEC);
										       res2374_3184 = new1800_3181;
										    }
										 }
										 arg2301_2896 = res2374_3184;
									      }
									      {
										 obj_t aux_4012;
										 object_t aux_4010;
										 aux_4012 = (obj_t) (arg2301_2896);
										 aux_4010 = (object_t) (obj1882_2895);
										 OBJECT_WIDENING_SET(aux_4010, aux_4012);
									      }
									   }
									   {
									      long arg2302_2897;
									      arg2302_2897 = class_num_218___object(pre_make_struct_app_218_cfa_info);
									      {
										 obj_t obj_3185;
										 obj_3185 = (obj_t) (obj1882_2895);
										 (((obj_t) CREF(obj_3185))->header = MAKE_HEADER(arg2302_2897, 0), BUNSPEC);
									      }
									   }
									   return (obj_t) (obj1882_2895);
									}
								     }
								   else
								     {
									bool_t test_4019;
									{
									   obj_t aux_4020;
									   aux_4020 = CNST_TABLE_REF(((long) 12));
									   test_4019 = (case_value_58_2877 == aux_4020);
									}
									if (test_4019)
									  {
									     pre_struct_ref_app_207_t obj1883_2899;
									     obj1883_2899 = ((pre_struct_ref_app_207_t) (node_2848));
									     {
										obj_t aux_4026;
										object_t aux_4024;
										{
										   pre_struct_ref_app_207_t aux_4027;
										   {
										      aux_4027 = ((pre_struct_ref_app_207_t) BREF(GC_MALLOC(sizeof(struct pre_struct_ref_app_207))));
										   }
										   aux_4026 = (obj_t) (aux_4027);
										}
										aux_4024 = (object_t) (obj1883_2899);
										OBJECT_WIDENING_SET(aux_4024, aux_4026);
									     }
									     {
										long arg2305_2901;
										arg2305_2901 = class_num_218___object(pre_struct_ref_app_207_cfa_info);
										{
										   obj_t obj_3191;
										   obj_3191 = (obj_t) (obj1883_2899);
										   (((obj_t) CREF(obj_3191))->header = MAKE_HEADER(arg2305_2901, 0), BUNSPEC);
										}
									     }
									     return (obj_t) (obj1883_2899);
									  }
									else
									  {
									     bool_t test_4035;
									     {
										obj_t aux_4036;
										aux_4036 = CNST_TABLE_REF(((long) 13));
										test_4035 = (case_value_58_2877 == aux_4036);
									     }
									     if (test_4035)
									       {
										  pre_struct_set__app_116_t obj1885_2903;
										  obj1885_2903 = ((pre_struct_set__app_116_t) (node_2848));
										  {
										     obj_t aux_4042;
										     object_t aux_4040;
										     {
											pre_struct_set__app_116_t aux_4043;
											{
											   aux_4043 = ((pre_struct_set__app_116_t) BREF(GC_MALLOC(sizeof(struct pre_struct_set__app_116))));
											}
											aux_4042 = (obj_t) (aux_4043);
										     }
										     aux_4040 = (object_t) (obj1885_2903);
										     OBJECT_WIDENING_SET(aux_4040, aux_4042);
										  }
										  {
										     long arg2308_2905;
										     arg2308_2905 = class_num_218___object(pre_struct_set__app_116_cfa_info);
										     {
											obj_t obj_3197;
											obj_3197 = (obj_t) (obj1885_2903);
											(((obj_t) CREF(obj_3197))->header = MAKE_HEADER(arg2308_2905, 0), BUNSPEC);
										     }
										  }
										  return (obj_t) (obj1885_2903);
									       }
									     else
									       {
										  return BFALSE;
									       }
									  }
								     }
								}
							   }
						      }
						 }
					    }
					 }
				       else
					 {
					    return BUNSPEC;
					 }
				    }
				 }
			       else
				 {
				    return BUNSPEC;
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 app_ly_162_t node_2916;
			 node_2916 = (app_ly_162_t) (node_4);
			 node_collect__175_cfa_collect((((app_ly_162_t) CREF(node_2916))->fun), owner_5);
			 {
			    node_t node_4054;
			    node_4054 = (((app_ly_162_t) CREF(node_2916))->arg);
			    node_4 = node_4054;
			    goto node_collect__175_cfa_collect;
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 funcall_t node_2921;
			 node_2921 = (funcall_t) (node_4);
			 add_funcall__195_cfa_closure((node_t) (node_2921));
			 node_collect__175_cfa_collect((((funcall_t) CREF(node_2921))->fun), owner_5);
			 {
			    bool_t aux_4061;
			    aux_4061 = node_collect___108_cfa_collect((((funcall_t) CREF(node_2921))->args), owner_5);
			    return BBOOL(aux_4061);
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 pragma_t node_2926;
			 node_2926 = (pragma_t) (node_4);
			 {
			    bool_t aux_4066;
			    aux_4066 = node_collect___108_cfa_collect((((pragma_t) CREF(node_2926))->args), owner_5);
			    return BBOOL(aux_4066);
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 cast_t node_2930;
			 node_2930 = (cast_t) (node_4);
			 {
			    node_t node_4071;
			    node_4071 = (((cast_t) CREF(node_2930))->arg);
			    node_4 = node_4071;
			    goto node_collect__175_cfa_collect;
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 setq_t node_2934;
			 node_2934 = (setq_t) (node_4);
			 {
			    node_t node_4074;
			    node_4074 = (((setq_t) CREF(node_2934))->value);
			    node_4 = node_4074;
			    goto node_collect__175_cfa_collect;
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 conditional_t node_2938;
			 node_2938 = (conditional_t) (node_4);
			 node_collect__175_cfa_collect((((conditional_t) CREF(node_2938))->test), owner_5);
			 node_collect__175_cfa_collect((((conditional_t) CREF(node_2938))->true), owner_5);
			 {
			    node_t node_4081;
			    node_4081 = (((conditional_t) CREF(node_2938))->false);
			    node_4 = node_4081;
			    goto node_collect__175_cfa_collect;
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 fail_t node_2944;
			 node_2944 = (fail_t) (node_4);
			 node_collect__175_cfa_collect((((fail_t) CREF(node_2944))->proc), owner_5);
			 node_collect__175_cfa_collect((((fail_t) CREF(node_2944))->msg), owner_5);
			 {
			    node_t node_4088;
			    node_4088 = (((fail_t) CREF(node_2944))->obj);
			    node_4 = node_4088;
			    goto node_collect__175_cfa_collect;
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 select_t node_2950;
			 node_2950 = (select_t) (node_4);
			 node_collect__175_cfa_collect((((select_t) CREF(node_2950))->test), owner_5);
			 {
			    obj_t l1894_2954;
			    {
			       bool_t aux_4093;
			       l1894_2954 = (((select_t) CREF(node_2950))->clauses);
			     lname1896_2955:
			       if (PAIRP(l1894_2954))
				 {
				    {
				       node_t aux_4096;
				       {
					  obj_t aux_4097;
					  {
					     obj_t aux_4098;
					     aux_4098 = CAR(l1894_2954);
					     aux_4097 = CDR(aux_4098);
					  }
					  aux_4096 = (node_t) (aux_4097);
				       }
				       node_collect__175_cfa_collect(aux_4096, owner_5);
				    }
				    {
				       obj_t l1894_4103;
				       l1894_4103 = CDR(l1894_2954);
				       l1894_2954 = l1894_4103;
				       goto lname1896_2955;
				    }
				 }
			       else
				 {
				    aux_4093 = ((bool_t) 1);
				 }
			       return BBOOL(aux_4093);
			    }
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 let_fun_218_t node_2961;
			 node_2961 = (let_fun_218_t) (node_4);
			 {
			    obj_t l1898_2964;
			    l1898_2964 = (((let_fun_218_t) CREF(node_2961))->locals);
			  lname1899_2965:
			    if (PAIRP(l1898_2964))
			      {
				 {
				    obj_t l_2968;
				    l_2968 = CAR(l1898_2964);
				    {
				       node_t aux_4111;
				       {
					  obj_t aux_4112;
					  {
					     sfun_t obj_3222;
					     {
						value_t aux_4113;
						{
						   local_t obj_3221;
						   obj_3221 = (local_t) (l_2968);
						   aux_4113 = (((local_t) CREF(obj_3221))->value);
						}
						obj_3222 = (sfun_t) (aux_4113);
					     }
					     aux_4112 = (((sfun_t) CREF(obj_3222))->body);
					  }
					  aux_4111 = (node_t) (aux_4112);
				       }
				       node_collect__175_cfa_collect(aux_4111, (variable_t) (l_2968));
				    }
				 }
				 {
				    obj_t l1898_4121;
				    l1898_4121 = CDR(l1898_2964);
				    l1898_2964 = l1898_4121;
				    goto lname1899_2965;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    node_t node_4124;
			    node_4124 = (((let_fun_218_t) CREF(node_2961))->body);
			    node_4 = node_4124;
			    goto node_collect__175_cfa_collect;
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 let_var_6_t node_2973;
			 node_2973 = (let_var_6_t) (node_4);
			 {
			    obj_t l1901_2976;
			    l1901_2976 = (((let_var_6_t) CREF(node_2973))->bindings);
			  lname1902_2977:
			    if (PAIRP(l1901_2976))
			      {
				 {
				    node_t aux_4129;
				    {
				       obj_t aux_4130;
				       {
					  obj_t aux_4131;
					  aux_4131 = CAR(l1901_2976);
					  aux_4130 = CDR(aux_4131);
				       }
				       aux_4129 = (node_t) (aux_4130);
				    }
				    node_collect__175_cfa_collect(aux_4129, owner_5);
				 }
				 {
				    obj_t l1901_4136;
				    l1901_4136 = CDR(l1901_2976);
				    l1901_2976 = l1901_4136;
				    goto lname1902_2977;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    node_t node_4139;
			    node_4139 = (((let_var_6_t) CREF(node_2973))->body);
			    node_4 = node_4139;
			    goto node_collect__175_cfa_collect;
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 set_ex_it_116_t node_2984;
			 node_2984 = (set_ex_it_116_t) (node_4);
			 {
			    node_t node_4142;
			    node_4142 = (((set_ex_it_116_t) CREF(node_2984))->body);
			    node_4 = node_4142;
			    goto node_collect__175_cfa_collect;
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 jump_ex_it_184_t node_2988;
			 node_2988 = (jump_ex_it_184_t) (node_4);
			 node_collect__175_cfa_collect((((jump_ex_it_184_t) CREF(node_2988))->exit), owner_5);
			 {
			    node_t node_4147;
			    node_4147 = (((jump_ex_it_184_t) CREF(node_2988))->value);
			    node_4 = node_4147;
			    goto node_collect__175_cfa_collect;
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 make_box_202_t node_2993;
			 node_2993 = (make_box_202_t) (node_4);
			 node_collect__175_cfa_collect((((make_box_202_t) CREF(node_2993))->value), owner_5);
			 {
			    bool_t test2354_2996;
			    {
			       long n1_3235;
			       n1_3235 = (long) CINT(__optim__89_engine_param);
			       test2354_2996 = (n1_3235 >= ((long) 1));
			    }
			    if (test2354_2996)
			      {
				 {
				    obj_t obj2_3239;
				    obj2_3239 = __used_alloc__125_cfa_collect;
				    {
				       obj_t aux_4155;
				       aux_4155 = (obj_t) (node_2993);
				       __used_alloc__125_cfa_collect = MAKE_PAIR(aux_4155, obj2_3239);
				    }
				 }
				 {
				    pre_make_box_186_t obj1905_2997;
				    obj1905_2997 = ((pre_make_box_186_t) (node_2993));
				    {
				       pre_make_box_186_t arg2355_2998;
				       {
					  pre_make_box_186_t res2377_3243;
					  {
					     obj_t key_3240;
					     key_3240 = BINT(((long) -1));
					     {
						pre_make_box_186_t new1551_3241;
						new1551_3241 = ((pre_make_box_186_t) BREF(GC_MALLOC(sizeof(struct pre_make_box_186))));
						((((pre_make_box_186_t) CREF(new1551_3241))->key) = ((obj_t) key_3240), BUNSPEC);
						res2377_3243 = new1551_3241;
					     }
					  }
					  arg2355_2998 = res2377_3243;
				       }
				       {
					  obj_t aux_4164;
					  object_t aux_4162;
					  aux_4164 = (obj_t) (arg2355_2998);
					  aux_4162 = (object_t) (obj1905_2997);
					  OBJECT_WIDENING_SET(aux_4162, aux_4164);
				       }
				    }
				    {
				       long arg2356_2999;
				       arg2356_2999 = class_num_218___object(pre_make_box_186_cfa_info);
				       {
					  obj_t obj_3244;
					  obj_3244 = (obj_t) (obj1905_2997);
					  (((obj_t) CREF(obj_3244))->header = MAKE_HEADER(arg2356_2999, 0), BUNSPEC);
				       }
				    }
				    return (obj_t) (obj1905_2997);
				 }
			      }
			    else
			      {
				 return BUNSPEC;
			      }
			 }
		      }
		      break;
		   case ((long) 18):
		      {
			 box_set__221_t node_3000;
			 node_3000 = (box_set__221_t) (node_4);
			 {
			    node_t aux_4172;
			    {
			       var_t aux_4173;
			       aux_4173 = (((box_set__221_t) CREF(node_3000))->var);
			       aux_4172 = (node_t) (aux_4173);
			    }
			    node_collect__175_cfa_collect(aux_4172, owner_5);
			 }
			 {
			    node_t node_4177;
			    node_4177 = (((box_set__221_t) CREF(node_3000))->value);
			    node_4 = node_4177;
			    goto node_collect__175_cfa_collect;
			 }
		      }
		      break;
		   case ((long) 19):
		      {
			 box_ref_242_t node_3005;
			 node_3005 = (box_ref_242_t) (node_4);
			 {
			    node_t node_4180;
			    {
			       var_t aux_4181;
			       aux_4181 = (((box_ref_242_t) CREF(node_3005))->var);
			       node_4180 = (node_t) (aux_4181);
			    }
			    node_4 = node_4180;
			    goto node_collect__175_cfa_collect;
			 }
		      }
		      break;
		   default:
		    case_else2211_180_2792:
		      if (PROCEDUREP(method2205_2788))
			{
			   return PROCEDURE_ENTRY(method2205_2788) (method2205_2788, (obj_t) (node_4), (obj_t) (owner_5), BEOA);
			}
		      else
			{
			   obj_t fun1938_2002;
			   fun1938_2002 = PROCEDURE_REF(node_collect__env_176_cfa_collect, ((long) 0));
			   return PROCEDURE_ENTRY(fun1938_2002) (fun1938_2002, (obj_t) (node_4), (obj_t) (owner_5), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else2211_180_2792;
	      }
	 }
      }
   }
}


obj_t 
_node_collect__42_cfa_collect(obj_t env_3622, obj_t node_3623, obj_t owner_3624)
{
   return node_collect__175_cfa_collect((node_t) (node_3623), (variable_t) (owner_3624));
}


bool_t 
monomorphic_vector__154_cfa_collect(obj_t vector_12)
{
   {
      long len_2004;
      len_2004 = VECTOR_LENGTH(vector_12);
      if ((len_2004 == ((long) 0)))
	{
	   return ((bool_t) 0);
	}
      else
	{
	   obj_t atype_2006;
	   atype_2006 = get_atype_143_cfa_collect(VECTOR_REF(vector_12, ((long) 0)));
	   {
	      long i_2007;
	      i_2007 = ((long) 1);
	    loop_2008:
	      if (CBOOL(atype_2006))
		{
		   if ((i_2007 == len_2004))
		     {
			return ((bool_t) 1);
		     }
		   else
		     {
			bool_t test_4209;
			{
			   obj_t aux_4210;
			   aux_4210 = get_atype_143_cfa_collect(VECTOR_REF(vector_12, i_2007));
			   test_4209 = (aux_4210 == atype_2006);
			}
			if (test_4209)
			  {
			     {
				long i_4214;
				i_4214 = (i_2007 + ((long) 1));
				i_2007 = i_4214;
				goto loop_2008;
			     }
			  }
			else
			  {
			     return ((bool_t) 0);
			  }
		     }
		}
	      else
		{
		   return ((bool_t) 0);
		}
	   }
	}
   }
}


obj_t 
get_atype_143_cfa_collect(obj_t value_2015)
{
   {
      bool_t test1947_2017;
      test1947_2017 = INTEGERP(value_2015);
      if (test1947_2017)
	{
	   return CNST_TABLE_REF(((long) 14));
	}
      else
	{
	   if (CHARP(value_2015))
	     {
		return CNST_TABLE_REF(((long) 15));
	     }
	   else
	     {
		if (BOOLEANP(value_2015))
		  {
		     return CNST_TABLE_REF(((long) 16));
		  }
		else
		  {
		     if (STRINGP(value_2015))
		       {
			  return CNST_TABLE_REF(((long) 17));
		       }
		     else
		       {
			  bool_t test_4228;
			  if (test1947_2017)
			    {
			       test_4228 = ((bool_t) 1);
			    }
			  else
			    {
			       test_4228 = REALP(value_2015);
			    }
			  if (test_4228)
			    {
			       return CNST_TABLE_REF(((long) 18));
			    }
			  else
			    {
			       return BFALSE;
			    }
		       }
		  }
	     }
	}
   }
}


bool_t 
node_collect___108_cfa_collect(obj_t node__221_49, variable_t owner_50)
{
   {
      obj_t l1908_2023;
      l1908_2023 = node__221_49;
    lname1909_2024:
      if (PAIRP(l1908_2023))
	{
	   {
	      node_t aux_4234;
	      {
		 obj_t aux_4235;
		 aux_4235 = CAR(l1908_2023);
		 aux_4234 = (node_t) (aux_4235);
	      }
	      node_collect__175_cfa_collect(aux_4234, owner_50);
	   }
	   {
	      obj_t l1908_4239;
	      l1908_4239 = CDR(l1908_2023);
	      l1908_2023 = l1908_4239;
	      goto lname1909_2024;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
get_allocs_52_cfa_collect()
{
   return __used_alloc__125_cfa_collect;
}


obj_t 
_get_allocs_32_cfa_collect(obj_t env_3630)
{
   return get_allocs_52_cfa_collect();
}


obj_t 
imported_modules_init_94_cfa_collect()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_COLLECT");
   module_initialization_70_tools_shape(((long) 0), "CFA_COLLECT");
   module_initialization_70_type_type(((long) 0), "CFA_COLLECT");
   module_initialization_70_type_cache(((long) 0), "CFA_COLLECT");
   module_initialization_70_type_typeof(((long) 0), "CFA_COLLECT");
   module_initialization_70_module_module(((long) 0), "CFA_COLLECT");
   module_initialization_70_engine_param(((long) 0), "CFA_COLLECT");
   module_initialization_70_ast_var(((long) 0), "CFA_COLLECT");
   module_initialization_70_ast_node(((long) 0), "CFA_COLLECT");
   module_initialization_70_ast_dump(((long) 0), "CFA_COLLECT");
   module_initialization_70_ast_env(((long) 0), "CFA_COLLECT");
   module_initialization_70_ast_sexp(((long) 0), "CFA_COLLECT");
   module_initialization_70_cfa_info(((long) 0), "CFA_COLLECT");
   module_initialization_70_cfa_procedure(((long) 0), "CFA_COLLECT");
   module_initialization_70_cfa_vector(((long) 0), "CFA_COLLECT");
   module_initialization_70_cfa_struct(((long) 0), "CFA_COLLECT");
   module_initialization_70_cfa_box(((long) 0), "CFA_COLLECT");
   return module_initialization_70_cfa_closure(((long) 0), "CFA_COLLECT");
}
