/*===========================================================================*/
/*   (Cfa/funcall.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


extern obj_t __procedure__226_type_cache;
static obj_t funcall_type_error_218_cfa_funcall(funcall_cinfo_75_t, type_t);
extern obj_t global_ast_var;
extern approx_t loose__226_cfa_loose(approx_t, obj_t);
extern obj_t _cfa__186_cfa_cfa(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern bool_t sound_arity__135_tools_args(obj_t, obj_t);
extern approx_t app__231_cfa_app(fun_t, var_t, obj_t);
static obj_t arg19362342_cfa_funcall(obj_t, obj_t);
static obj_t imported_modules_init_94_cfa_funcall();
extern obj_t module_initialization_70_cfa_funcall(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_app(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t toplevel_init_63_cfa_funcall();
static obj_t cnst_init_137_cfa_funcall();
static approx_t funcall_arity_error_199_cfa_funcall(obj_t, variable_t, long, obj_t);
static obj_t cfa__funcall_cinfo2340_110_cfa_funcall(obj_t, obj_t);
static obj_t require_initialization_114_cfa_funcall = BUNSPEC;
extern approx_t make_empty_approx_131_cfa_approx();
extern obj_t make_procedure_app_48_cfa_info;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cfa_funcall();
static obj_t arg19272341_cfa_funcall(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern long class_num_218___object(obj_t);
extern approx_t union_approx__241_cfa_approx(approx_t, approx_t);
extern approx_t cfa__102_cfa_cfa(node_t);
extern obj_t shape_tools_shape(obj_t);
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern obj_t funcall_cinfo_75_cfa_info;
static approx_t funcall__128_cfa_funcall(make_procedure_app_48_t, obj_t, obj_t);
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_t);
extern obj_t approx_set_type__239_cfa_approx(approx_t, type_t);
extern obj_t local_ast_var;
extern long list_length(obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t _____74_type_cache;
extern obj_t approx_set_top__187_cfa_approx(approx_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t __obj__252_type_cache;
extern obj_t user_warning_location_190_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[2];

extern obj_t cfa__env_153_cfa_cfa;
DEFINE_STATIC_PROCEDURE(proc2344_cfa_funcall, cfa__funcall_cinfo2340_110_cfa_funcall2366, cfa__funcall_cinfo2340_110_cfa_funcall, 0L, 1);
DEFINE_STRING(string2358_cfa_funcall, string2358_cfa_funcall2367, "Possible funcall arity error", 28);
DEFINE_STRING(string2346_cfa_funcall, string2346_cfa_funcall2368, "     args: ", 11);
DEFINE_STRING(string2345_cfa_funcall, string2345_cfa_funcall2369, "  funcall: ", 11);
DEFINE_STRING(string2355_cfa_funcall, string2355_cfa_funcall2370, "Possible funcall type error", 27);
DEFINE_STRING(string2359_cfa_funcall, string2359_cfa_funcall2371, " *** arity error *** ", 21);
DEFINE_STRING(string2354_cfa_funcall, string2354_cfa_funcall2372, "cfa", 3);
DEFINE_STRING(string2357_cfa_funcall, string2357_cfa_funcall2373, " arg(s) expected, ", 18);
DEFINE_STRING(string2353_cfa_funcall, string2353_cfa_funcall2374, " *** type error *** ", 20);
DEFINE_STRING(string2347_cfa_funcall, string2347_cfa_funcall2375, "      fun: ", 11);
DEFINE_STRING(string2356_cfa_funcall, string2356_cfa_funcall2376, " provided", 9);
DEFINE_STRING(string2352_cfa_funcall, string2352_cfa_funcall2377, "   ->app!: ", 11);
DEFINE_STRING(string2360_cfa_funcall, string2360_cfa_funcall2378, "ALL CFA ", 8);
DEFINE_STRING(string2350_cfa_funcall, string2350_cfa_funcall2379, " arity: ", 8);
DEFINE_STRING(string2348_cfa_funcall, string2348_cfa_funcall2380, "       ->: ", 11);
DEFINE_STRING(string2351_cfa_funcall, string2351_cfa_funcall2381, " funcall!: ", 11);
DEFINE_STRING(string2349_cfa_funcall, string2349_cfa_funcall2382, " ", 1);

obj_t 
module_initialization_70_cfa_funcall(long checksum_3443, char *from_3444)
{
   if (CBOOL(require_initialization_114_cfa_funcall))
     {
	require_initialization_114_cfa_funcall = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_funcall();
	cnst_init_137_cfa_funcall();
	imported_modules_init_94_cfa_funcall();
	toplevel_init_63_cfa_funcall();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_funcall()
{
   module_initialization_70___object(((long) 0), "CFA_FUNCALL");
   module_initialization_70___reader(((long) 0), "CFA_FUNCALL");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_FUNCALL");
   module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "CFA_FUNCALL");
   module_initialization_70___r4_strings_6_7(((long) 0), "CFA_FUNCALL");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_funcall()
{
   {
      obj_t cnst_port_138_3435;
      cnst_port_138_3435 = open_input_string(string2360_cfa_funcall);
      {
	 long i_3436;
	 i_3436 = ((long) 1);
       loop_3437:
	 {
	    bool_t test2361_3438;
	    test2361_3438 = (i_3436 == ((long) -1));
	    if (test2361_3438)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2362_3439;
		    {
		       obj_t list2363_3440;
		       {
			  obj_t arg2364_3441;
			  arg2364_3441 = BNIL;
			  list2363_3440 = MAKE_PAIR(cnst_port_138_3435, arg2364_3441);
		       }
		       arg2362_3439 = read___reader(list2363_3440);
		    }
		    CNST_TABLE_SET(i_3436, arg2362_3439);
		 }
		 {
		    int aux_3442;
		    {
		       long aux_3463;
		       aux_3463 = (i_3436 - ((long) 1));
		       aux_3442 = (int) (aux_3463);
		    }
		    {
		       long i_3466;
		       i_3466 = (long) (aux_3442);
		       i_3436 = i_3466;
		       goto loop_3437;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_funcall()
{
   {
      obj_t cfa__funcall_cinfo_215_3418;
      cfa__funcall_cinfo_215_3418 = proc2344_cfa_funcall;
      return add_method__1___object(cfa__env_153_cfa_cfa, funcall_cinfo_75_cfa_info, cfa__funcall_cinfo_215_3418);
   }
}


obj_t 
cfa__funcall_cinfo2340_110_cfa_funcall(obj_t env_3419, obj_t node_3420)
{
   {
      funcall_cinfo_75_t node_1940;
      {
	 approx_t aux_3469;
	 node_1940 = (funcall_cinfo_75_t) (node_3420);
	 {
	    bool_t test1888_1943;
	    {
	       obj_t aux_3470;
	       aux_3470 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	       test1888_1943 = CBOOL(aux_3470);
	    }
	    if (test1888_1943)
	      {
		 obj_t arg1890_1945;
		 arg1890_1945 = shape_tools_shape((obj_t) (node_1940));
		 {
		    obj_t list1891_1946;
		    {
		       obj_t arg1892_1947;
		       {
			  obj_t arg1893_1948;
			  {
			     obj_t aux_3478;
			     aux_3478 = BCHAR(((unsigned char) '\n'));
			     arg1893_1948 = MAKE_PAIR(aux_3478, BNIL);
			  }
			  arg1892_1947 = MAKE_PAIR(arg1890_1945, arg1893_1948);
		       }
		       list1891_1946 = MAKE_PAIR(string2345_cfa_funcall, arg1892_1947);
		    }
		    print_trace_107_tools_trace(list1891_1946);
		 }
	      }
	    else
	      {
		 BUNSPEC;
	      }
	 }
	 {
	    approx_t fun_approx_73_1953;
	    {
	       node_t aux_3484;
	       {
		  funcall_t obj_2907;
		  obj_2907 = (funcall_t) (node_1940);
		  aux_3484 = (((funcall_t) CREF(obj_2907))->fun);
	       }
	       fun_approx_73_1953 = cfa__102_cfa_cfa(aux_3484);
	    }
	    {
	       obj_t args_approx_137_1954;
	       {
		  obj_t l1871_2017;
		  {
		     obj_t aux_3488;
		     {
			funcall_t obj_2908;
			obj_2908 = (funcall_t) (node_1940);
			aux_3488 = (((funcall_t) CREF(obj_2908))->args);
		     }
		     l1871_2017 = CDR(aux_3488);
		  }
		  if (NULLP(l1871_2017))
		    {
		       args_approx_137_1954 = BNIL;
		    }
		  else
		    {
		       obj_t head1876_2019;
		       {
			  approx_t arg1966_2030;
			  {
			     node_t aux_3494;
			     {
				obj_t aux_3495;
				aux_3495 = CAR(l1871_2017);
				aux_3494 = (node_t) (aux_3495);
			     }
			     arg1966_2030 = cfa__102_cfa_cfa(aux_3494);
			  }
			  {
			     obj_t aux_3499;
			     aux_3499 = (obj_t) (arg1966_2030);
			     head1876_2019 = MAKE_PAIR(aux_3499, BNIL);
			  }
		       }
		       {
			  obj_t l1871_2020;
			  obj_t tail1877_2021;
			  l1871_2020 = CDR(l1871_2017);
			  tail1877_2021 = head1876_2019;
			lname1875_2022:
			  if (NULLP(l1871_2020))
			    {
			       args_approx_137_1954 = head1876_2019;
			    }
			  else
			    {
			       obj_t new_tail1878_13_2025;
			       {
				  approx_t arg1963_2027;
				  {
				     node_t aux_3504;
				     {
					obj_t aux_3505;
					aux_3505 = CAR(l1871_2020);
					aux_3504 = (node_t) (aux_3505);
				     }
				     arg1963_2027 = cfa__102_cfa_cfa(aux_3504);
				  }
				  {
				     obj_t aux_3509;
				     aux_3509 = (obj_t) (arg1963_2027);
				     new_tail1878_13_2025 = MAKE_PAIR(aux_3509, BNIL);
				  }
			       }
			       SET_CDR(tail1877_2021, new_tail1878_13_2025);
			       {
				  obj_t tail1877_3515;
				  obj_t l1871_3513;
				  l1871_3513 = CDR(l1871_2020);
				  tail1877_3515 = new_tail1878_13_2025;
				  tail1877_2021 = tail1877_3515;
				  l1871_2020 = l1871_3513;
				  goto lname1875_2022;
			       }
			    }
		       }
		    }
	       }
	       {
		  {
		     bool_t test1897_1955;
		     {
			obj_t aux_3517;
			aux_3517 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			test1897_1955 = CBOOL(aux_3517);
		     }
		     if (test1897_1955)
		       {
			  obj_t arg1899_1957;
			  obj_t arg1901_1959;
			  arg1899_1957 = shape_tools_shape((obj_t) (fun_approx_73_1953));
			  arg1901_1959 = shape_tools_shape(args_approx_137_1954);
			  {
			     obj_t list1902_1960;
			     {
				obj_t arg1904_1961;
				{
				   obj_t arg1905_1962;
				   {
				      obj_t arg1906_1963;
				      {
					 obj_t arg1907_1964;
					 {
					    obj_t arg1908_1965;
					    {
					       obj_t aux_3526;
					       aux_3526 = BCHAR(((unsigned char) '\n'));
					       arg1908_1965 = MAKE_PAIR(aux_3526, BNIL);
					    }
					    arg1907_1964 = MAKE_PAIR(arg1901_1959, arg1908_1965);
					 }
					 arg1906_1963 = MAKE_PAIR(string2346_cfa_funcall, arg1907_1964);
				      }
				      {
					 obj_t aux_3531;
					 aux_3531 = BCHAR(((unsigned char) '\n'));
					 arg1905_1962 = MAKE_PAIR(aux_3531, arg1906_1963);
				      }
				   }
				   arg1904_1961 = MAKE_PAIR(arg1899_1957, arg1905_1962);
				}
				list1902_1960 = MAKE_PAIR(string2347_cfa_funcall, arg1904_1961);
			     }
			     print_trace_107_tools_trace(list1902_1960);
			  }
		       }
		     else
		       {
			  BUNSPEC;
		       }
		  }
		  {
		     type_t fun_type_165_1969;
		     fun_type_165_1969 = (((approx_t) CREF(fun_approx_73_1953))->type);
		     {
			bool_t test1913_1970;
			{
			   bool_t test1914_1971;
			   {
			      obj_t obj2_2924;
			      obj2_2924 = _____74_type_cache;
			      {
				 obj_t aux_3538;
				 aux_3538 = (obj_t) (fun_type_165_1969);
				 test1914_1971 = (aux_3538 == obj2_2924);
			      }
			   }
			   if (test1914_1971)
			     {
				test1913_1970 = ((bool_t) 0);
			     }
			   else
			     {
				bool_t test1915_1972;
				{
				   obj_t obj2_2926;
				   obj2_2926 = __obj__252_type_cache;
				   {
				      obj_t aux_3542;
				      aux_3542 = (obj_t) (fun_type_165_1969);
				      test1915_1972 = (aux_3542 == obj2_2926);
				   }
				}
				if (test1915_1972)
				  {
				     test1913_1970 = ((bool_t) 0);
				  }
				else
				  {
				     bool_t test1916_1973;
				     {
					obj_t obj2_2928;
					obj2_2928 = __procedure__226_type_cache;
					{
					   obj_t aux_3546;
					   aux_3546 = (obj_t) (fun_type_165_1969);
					   test1916_1973 = (aux_3546 == obj2_2928);
					}
				     }
				     if (test1916_1973)
				       {
					  test1913_1970 = ((bool_t) 0);
				       }
				     else
				       {
					  test1913_1970 = ((bool_t) 1);
				       }
				  }
			     }
			}
			if (test1913_1970)
			  {
			     funcall_type_error_218_cfa_funcall(node_1940, fun_type_165_1969);
			  }
			else
			  {
			     BUNSPEC;
			  }
		     }
		  }
		  {
		     bool_t test1917_1974;
		     {
			bool_t test1919_1976;
			{
			   obj_t obj2_2931;
			   obj2_2931 = __procedure__226_type_cache;
			   {
			      obj_t aux_3552;
			      {
				 type_t aux_3553;
				 aux_3553 = (((approx_t) CREF(fun_approx_73_1953))->type);
				 aux_3552 = (obj_t) (aux_3553);
			      }
			      test1919_1976 = (aux_3552 == obj2_2931);
			   }
			}
			if (test1919_1976)
			  {
			     test1917_1974 = (((approx_t) CREF(fun_approx_73_1953))->top__138);
			  }
			else
			  {
			     test1917_1974 = ((bool_t) 1);
			  }
		     }
		     if (test1917_1974)
		       {
			  approx_t aux_3560;
			  {
			     obj_t aux_3561;
			     {
				object_t aux_3562;
				aux_3562 = (object_t) (node_1940);
				aux_3561 = OBJECT_WIDENING(aux_3562);
			     }
			     aux_3560 = (((funcall_cinfo_75_t) CREF(aux_3561))->approx);
			  }
			  approx_set_type__239_cfa_approx(aux_3560, (type_t) (__obj__252_type_cache));
		       }
		     else
		       {
			  BUNSPEC;
		       }
		  }
		  {
		     bool_t test1922_1978;
		     if ((((approx_t) CREF(fun_approx_73_1953))->top__138))
		       {
			  test1922_1978 = ((bool_t) 1);
		       }
		     else
		       {
			  bool_t test1943_2005;
			  {
			     obj_t obj2_2937;
			     obj2_2937 = __procedure__226_type_cache;
			     {
				obj_t aux_3570;
				{
				   type_t aux_3571;
				   aux_3571 = (((approx_t) CREF(fun_approx_73_1953))->type);
				   aux_3570 = (obj_t) (aux_3571);
				}
				test1943_2005 = (aux_3570 == obj2_2937);
			     }
			  }
			  if (test1943_2005)
			    {
			       test1922_1978 = ((bool_t) 0);
			    }
			  else
			    {
			       test1922_1978 = ((bool_t) 1);
			    }
		       }
		     if (test1922_1978)
		       {
			  {
			     obj_t l1879_1979;
			     l1879_1979 = args_approx_137_1954;
			   lname1880_1980:
			     if (PAIRP(l1879_1979))
			       {
				  {
				     approx_t aux_3579;
				     {
					obj_t aux_3580;
					aux_3580 = CAR(l1879_1979);
					aux_3579 = (approx_t) (aux_3580);
				     }
				     loose__226_cfa_loose(aux_3579, CNST_TABLE_REF(((long) 1)));
				  }
				  {
				     obj_t l1879_3585;
				     l1879_3585 = CDR(l1879_1979);
				     l1879_1979 = l1879_3585;
				     goto lname1880_1980;
				  }
			       }
			     else
			       {
				  ((bool_t) 1);
			       }
			  }
			  {
			     obj_t arg1927_3417;
			     arg1927_3417 = make_fx_procedure(arg19272341_cfa_funcall, ((long) 1), ((long) 3));
			     {
				obj_t aux_3588;
				aux_3588 = (obj_t) (node_1940);
				PROCEDURE_SET(arg1927_3417, ((long) 0), aux_3588);
			     }
			     PROCEDURE_SET(arg1927_3417, ((long) 1), args_approx_137_1954);
			     {
				obj_t aux_3592;
				aux_3592 = (obj_t) (node_1940);
				PROCEDURE_SET(arg1927_3417, ((long) 2), aux_3592);
			     }
			     for_each_approx_alloc_83_cfa_approx(arg1927_3417, fun_approx_73_1953);
			  }
			  {
			     approx_t aux_3596;
			     {
				obj_t aux_3597;
				{
				   object_t aux_3598;
				   aux_3598 = (object_t) (node_1940);
				   aux_3597 = OBJECT_WIDENING(aux_3598);
				}
				aux_3596 = (((funcall_cinfo_75_t) CREF(aux_3597))->approx);
			     }
			     approx_set_top__187_cfa_approx(aux_3596);
			  }
		       }
		     else
		       {
			  obj_t arg1936_3416;
			  arg1936_3416 = make_fx_procedure(arg19362342_cfa_funcall, ((long) 1), ((long) 3));
			  {
			     obj_t aux_3604;
			     aux_3604 = (obj_t) (node_1940);
			     PROCEDURE_SET(arg1936_3416, ((long) 0), aux_3604);
			  }
			  PROCEDURE_SET(arg1936_3416, ((long) 1), args_approx_137_1954);
			  {
			     obj_t aux_3608;
			     aux_3608 = (obj_t) (node_1940);
			     PROCEDURE_SET(arg1936_3416, ((long) 2), aux_3608);
			  }
			  for_each_approx_alloc_83_cfa_approx(arg1936_3416, fun_approx_73_1953);
		       }
		  }
		  {
		     bool_t test1945_2007;
		     {
			obj_t aux_3612;
			aux_3612 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			test1945_2007 = CBOOL(aux_3612);
		     }
		     if (test1945_2007)
		       {
			  obj_t arg1948_2009;
			  {
			     obj_t aux_3618;
			     {
				approx_t aux_3619;
				{
				   obj_t aux_3620;
				   {
				      object_t aux_3621;
				      aux_3621 = (object_t) (node_1940);
				      aux_3620 = OBJECT_WIDENING(aux_3621);
				   }
				   aux_3619 = (((funcall_cinfo_75_t) CREF(aux_3620))->approx);
				}
				aux_3618 = (obj_t) (aux_3619);
			     }
			     arg1948_2009 = shape_tools_shape(aux_3618);
			  }
			  {
			     obj_t list1949_2010;
			     {
				obj_t arg1950_2011;
				{
				   obj_t arg1951_2012;
				   {
				      obj_t aux_3627;
				      aux_3627 = BCHAR(((unsigned char) '\n'));
				      arg1951_2012 = MAKE_PAIR(aux_3627, BNIL);
				   }
				   arg1950_2011 = MAKE_PAIR(arg1948_2009, arg1951_2012);
				}
				list1949_2010 = MAKE_PAIR(string2348_cfa_funcall, arg1950_2011);
			     }
			     print_trace_107_tools_trace(list1949_2010);
			  }
		       }
		     else
		       {
			  BUNSPEC;
		       }
		  }
		  {
		     obj_t aux_3633;
		     {
			object_t aux_3634;
			aux_3634 = (object_t) (node_1940);
			aux_3633 = OBJECT_WIDENING(aux_3634);
		     }
		     aux_3469 = (((funcall_cinfo_75_t) CREF(aux_3633))->approx);
		  }
	       }
	    }
	 }
	 return (obj_t) (aux_3469);
      }
   }
}


obj_t 
arg19272341_cfa_funcall(obj_t env_3421, obj_t alloc_3425)
{
   {
      obj_t instance1870_3422;
      obj_t args_approx_137_3423;
      obj_t node_3424;
      instance1870_3422 = PROCEDURE_REF(env_3421, ((long) 0));
      args_approx_137_3423 = PROCEDURE_REF(env_3421, ((long) 1));
      node_3424 = PROCEDURE_REF(env_3421, ((long) 2));
      {
	 obj_t alloc_1986;
	 {
	    approx_t aux_3643;
	    alloc_1986 = alloc_3425;
	    {
	       bool_t test1929_1988;
	       test1929_1988 = is_a__118___object(alloc_1986, make_procedure_app_48_cfa_info);
	       if (test1929_1988)
		 {
		    approx_t arg1931_1990;
		    approx_t arg1932_1991;
		    {
		       funcall_cinfo_75_t obj_2943;
		       obj_2943 = (funcall_cinfo_75_t) (instance1870_3422);
		       {
			  obj_t aux_3647;
			  {
			     object_t aux_3648;
			     aux_3648 = (object_t) (obj_2943);
			     aux_3647 = OBJECT_WIDENING(aux_3648);
			  }
			  arg1931_1990 = (((funcall_cinfo_75_t) CREF(aux_3647))->approx);
		       }
		    }
		    {
		       obj_t arg1934_1992;
		       {
			  obj_t aux_3652;
			  {
			     approx_t aux_3653;
			     {
				make_procedure_app_48_t obj_2942;
				obj_2942 = (make_procedure_app_48_t) (alloc_1986);
				{
				   obj_t aux_3655;
				   {
				      object_t aux_3656;
				      aux_3656 = (object_t) (obj_2942);
				      aux_3655 = OBJECT_WIDENING(aux_3656);
				   }
				   aux_3653 = (((make_procedure_app_48_t) CREF(aux_3655))->approx);
				}
			     }
			     aux_3652 = (obj_t) (aux_3653);
			  }
			  arg1934_1992 = MAKE_PAIR(aux_3652, args_approx_137_3423);
		       }
		       arg1932_1991 = funcall__128_cfa_funcall((make_procedure_app_48_t) (alloc_1986), arg1934_1992, node_3424);
		    }
		    aux_3643 = union_approx__241_cfa_approx(arg1931_1990, arg1932_1991);
		 }
	       else
		 {
		    aux_3643 = make_empty_approx_131_cfa_approx();
		 }
	    }
	    return (obj_t) (aux_3643);
	 }
      }
   }
}


obj_t 
arg19362342_cfa_funcall(obj_t env_3426, obj_t alloc_3430)
{
   {
      obj_t instance1870_3427;
      obj_t args_approx_137_3428;
      obj_t node_3429;
      instance1870_3427 = PROCEDURE_REF(env_3426, ((long) 0));
      args_approx_137_3428 = PROCEDURE_REF(env_3426, ((long) 1));
      node_3429 = PROCEDURE_REF(env_3426, ((long) 2));
      {
	 obj_t alloc_1996;
	 {
	    approx_t aux_3670;
	    alloc_1996 = alloc_3430;
	    {
	       bool_t test1938_1998;
	       test1938_1998 = is_a__118___object(alloc_1996, make_procedure_app_48_cfa_info);
	       if (test1938_1998)
		 {
		    approx_t arg1939_2000;
		    approx_t arg1940_2001;
		    {
		       funcall_cinfo_75_t obj_2949;
		       obj_2949 = (funcall_cinfo_75_t) (instance1870_3427);
		       {
			  obj_t aux_3674;
			  {
			     object_t aux_3675;
			     aux_3675 = (object_t) (obj_2949);
			     aux_3674 = OBJECT_WIDENING(aux_3675);
			  }
			  arg1939_2000 = (((funcall_cinfo_75_t) CREF(aux_3674))->approx);
		       }
		    }
		    {
		       obj_t arg1941_2002;
		       {
			  obj_t aux_3679;
			  {
			     approx_t aux_3680;
			     {
				make_procedure_app_48_t obj_2948;
				obj_2948 = (make_procedure_app_48_t) (alloc_1996);
				{
				   obj_t aux_3682;
				   {
				      object_t aux_3683;
				      aux_3683 = (object_t) (obj_2948);
				      aux_3682 = OBJECT_WIDENING(aux_3683);
				   }
				   aux_3680 = (((make_procedure_app_48_t) CREF(aux_3682))->approx);
				}
			     }
			     aux_3679 = (obj_t) (aux_3680);
			  }
			  arg1941_2002 = MAKE_PAIR(aux_3679, args_approx_137_3428);
		       }
		       arg1940_2001 = funcall__128_cfa_funcall((make_procedure_app_48_t) (alloc_1996), arg1941_2002, node_3429);
		    }
		    aux_3670 = union_approx__241_cfa_approx(arg1939_2000, arg1940_2001);
		 }
	       else
		 {
		    aux_3670 = make_empty_approx_131_cfa_approx();
		 }
	    }
	    return (obj_t) (aux_3670);
	 }
      }
   }
}


approx_t 
funcall__128_cfa_funcall(make_procedure_app_48_t alloc_2, obj_t args_approx_137_3, obj_t node_4)
{
   {
      obj_t callee_2037;
      {
	 obj_t aux_3694;
	 {
	    app_t obj_2954;
	    obj_2954 = (app_t) (alloc_2);
	    aux_3694 = (((app_t) CREF(obj_2954))->args);
	 }
	 callee_2037 = CAR(aux_3694);
      }
      {
	 variable_t v_2038;
	 {
	    var_t obj_2956;
	    obj_2956 = (var_t) (callee_2037);
	    v_2038 = (((var_t) CREF(obj_2956))->variable);
	 }
	 {
	    value_t fun_2039;
	    fun_2039 = (((variable_t) CREF(v_2038))->value);
	    {
	       long arity_2040;
	       {
		  fun_t obj_2958;
		  obj_2958 = (fun_t) (fun_2039);
		  arity_2040 = (((fun_t) CREF(obj_2958))->arity);
	       }
	       {
		  {
		     bool_t test1972_2041;
		     {
			obj_t aux_3703;
			aux_3703 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
			test1972_2041 = CBOOL(aux_3703);
		     }
		     if (test1972_2041)
		       {
			  obj_t arg1974_2043;
			  obj_t arg1977_2046;
			  arg1974_2043 = shape_tools_shape(callee_2037);
			  arg1977_2046 = shape_tools_shape(args_approx_137_3);
			  {
			     obj_t list1978_2047;
			     {
				obj_t arg1979_2048;
				{
				   obj_t arg1980_2049;
				   {
				      obj_t arg1981_2050;
				      {
					 obj_t arg1982_2051;
					 {
					    obj_t arg1983_2052;
					    {
					       obj_t arg1984_2053;
					       {
						  obj_t aux_3711;
						  aux_3711 = BCHAR(((unsigned char) '\n'));
						  arg1984_2053 = MAKE_PAIR(aux_3711, BNIL);
					       }
					       arg1983_2052 = MAKE_PAIR(arg1977_2046, arg1984_2053);
					    }
					    arg1982_2051 = MAKE_PAIR(string2349_cfa_funcall, arg1983_2052);
					 }
					 {
					    obj_t aux_3716;
					    aux_3716 = BINT(arity_2040);
					    arg1981_2050 = MAKE_PAIR(aux_3716, arg1982_2051);
					 }
				      }
				      arg1980_2049 = MAKE_PAIR(string2350_cfa_funcall, arg1981_2050);
				   }
				   arg1979_2048 = MAKE_PAIR(arg1974_2043, arg1980_2049);
				}
				list1978_2047 = MAKE_PAIR(string2351_cfa_funcall, arg1979_2048);
			     }
			     print_trace_107_tools_trace(list1978_2047);
			  }
		       }
		     else
		       {
			  BUNSPEC;
		       }
		  }
		  {
		     bool_t test1988_2057;
		     test1988_2057 = sound_arity__135_tools_args(BINT(arity_2040), args_approx_137_3);
		     if (test1988_2057)
		       {
			  if ((arity_2040 >= ((long) 0)))
			    {
			       {
				  bool_t test1990_2059;
				  {
				     obj_t aux_3728;
				     aux_3728 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				     test1990_2059 = CBOOL(aux_3728);
				  }
				  if (test1990_2059)
				    {
				       obj_t list1991_2060;
				       {
					  obj_t arg1993_2062;
					  {
					     obj_t aux_3734;
					     aux_3734 = BCHAR(((unsigned char) '\n'));
					     arg1993_2062 = MAKE_PAIR(aux_3734, BNIL);
					  }
					  list1991_2060 = MAKE_PAIR(string2352_cfa_funcall, arg1993_2062);
				       }
				       print_trace_107_tools_trace(list1991_2060);
				    }
				  else
				    {
				       BUNSPEC;
				    }
			       }
			       return app__231_cfa_app((fun_t) (fun_2039), (var_t) (callee_2037), args_approx_137_3);
			    }
			  else
			    {
			       {
				  obj_t old_args_approx_165_2066;
				  obj_t new_args_approx_79_2067;
				  long arity_2068;
				  old_args_approx_165_2066 = args_approx_137_3;
				  new_args_approx_79_2067 = BNIL;
				  arity_2068 = arity_2040;
				loop_2069:
				  if ((arity_2068 == ((long) -1)))
				    {
				       {
					  obj_t l1881_2072;
					  l1881_2072 = old_args_approx_165_2066;
					lname1882_2073:
					  if (PAIRP(l1881_2072))
					    {
					       {
						  approx_t aux_3746;
						  {
						     obj_t aux_3747;
						     aux_3747 = CAR(l1881_2072);
						     aux_3746 = (approx_t) (aux_3747);
						  }
						  loose__226_cfa_loose(aux_3746, CNST_TABLE_REF(((long) 1)));
					       }
					       {
						  obj_t l1881_3752;
						  l1881_3752 = CDR(l1881_2072);
						  l1881_2072 = l1881_3752;
						  goto lname1882_2073;
					       }
					    }
					  else
					    {
					       ((bool_t) 1);
					    }
				       }
				       {
					  obj_t arg2003_2078;
					  {
					     obj_t arg2004_2079;
					     {
						obj_t aux_3754;
						{
						   approx_t aux_3755;
						   {
						      funcall_cinfo_75_t obj_2966;
						      obj_2966 = (funcall_cinfo_75_t) (node_4);
						      {
							 obj_t aux_3757;
							 {
							    object_t aux_3758;
							    aux_3758 = (object_t) (obj_2966);
							    aux_3757 = OBJECT_WIDENING(aux_3758);
							 }
							 aux_3755 = (((funcall_cinfo_75_t) CREF(aux_3757))->va_approx_63);
						      }
						   }
						   aux_3754 = (obj_t) (aux_3755);
						}
						arg2004_2079 = MAKE_PAIR(aux_3754, new_args_approx_79_2067);
					     }
					     arg2003_2078 = reverse__39___r4_pairs_and_lists_6_3(arg2004_2079);
					  }
					  return app__231_cfa_app((fun_t) (fun_2039), (var_t) (callee_2037), arg2003_2078);
				       }
				    }
				  else
				    {
				       obj_t arg2006_2081;
				       obj_t arg2007_2082;
				       long arg2008_2083;
				       arg2006_2081 = CDR(old_args_approx_165_2066);
				       {
					  obj_t aux_3769;
					  aux_3769 = CAR(old_args_approx_165_2066);
					  arg2007_2082 = MAKE_PAIR(aux_3769, new_args_approx_79_2067);
				       }
				       arg2008_2083 = (arity_2068 + ((long) 1));
				       {
					  long arity_3775;
					  obj_t new_args_approx_79_3774;
					  obj_t old_args_approx_165_3773;
					  old_args_approx_165_3773 = arg2006_2081;
					  new_args_approx_79_3774 = arg2007_2082;
					  arity_3775 = arg2008_2083;
					  arity_2068 = arity_3775;
					  new_args_approx_79_2067 = new_args_approx_79_3774;
					  old_args_approx_165_2066 = old_args_approx_165_3773;
					  goto loop_2069;
				       }
				    }
			       }
			    }
		       }
		     else
		       {
			  return funcall_arity_error_199_cfa_funcall(node_4, v_2038, arity_2040, args_approx_137_3);
		       }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
funcall_type_error_218_cfa_funcall(funcall_cinfo_75_t node_5, type_t type_6)
{
   {
      bool_t test2013_2086;
      {
	 obj_t aux_3777;
	 aux_3777 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
	 test2013_2086 = CBOOL(aux_3777);
      }
      if (test2013_2086)
	{
	   obj_t arg2015_2088;
	   arg2015_2088 = shape_tools_shape((obj_t) (node_5));
	   {
	      obj_t list2016_2089;
	      {
		 obj_t arg2017_2090;
		 {
		    obj_t arg2018_2091;
		    {
		       obj_t aux_3785;
		       aux_3785 = BCHAR(((unsigned char) '\n'));
		       arg2018_2091 = MAKE_PAIR(aux_3785, BNIL);
		    }
		    arg2017_2090 = MAKE_PAIR(arg2015_2088, arg2018_2091);
		 }
		 list2016_2089 = MAKE_PAIR(string2353_cfa_funcall, arg2017_2090);
	      }
	      print_trace_107_tools_trace(list2016_2089);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test_3791;
      {
	 obj_t aux_3792;
	 {
	    object_t aux_3793;
	    aux_3793 = (object_t) (node_5);
	    aux_3792 = OBJECT_WIDENING(aux_3793);
	 }
	 test_3791 = (((funcall_cinfo_75_t) CREF(aux_3792))->type_error_noticed__36);
      }
      if (test_3791)
	{
	   return BUNSPEC;
	}
      else
	{
	   {
	      obj_t res2336_2978;
	      {
		 obj_t x_3433;
		 {
		    obj_t aux_3797;
		    {
		       object_t aux_3798;
		       aux_3798 = (object_t) (node_5);
		       aux_3797 = OBJECT_WIDENING(aux_3798);
		    }
		    x_3433 = ((((funcall_cinfo_75_t) CREF(aux_3797))->type_error_noticed__36) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		 }
		 res2336_2978 = BUNSPEC;
	      }
	      res2336_2978;
	   }
	   {
	      obj_t arg2023_2097;
	      obj_t arg2027_2100;
	      {
		 funcall_t obj_2979;
		 obj_2979 = (funcall_t) (node_5);
		 arg2023_2097 = (((funcall_t) CREF(obj_2979))->loc);
	      }
	      arg2027_2100 = shape_tools_shape((obj_t) (type_6));
	      return user_warning_location_190_tools_error(arg2023_2097, string2354_cfa_funcall, string2355_cfa_funcall, arg2027_2100);
	   }
	}
   }
}


approx_t 
funcall_arity_error_199_cfa_funcall(obj_t node_7, variable_t v_8, long arity_9, obj_t args_approx_137_10)
{
   {
      bool_t test_3807;
      {
	 funcall_cinfo_75_t obj_2980;
	 obj_2980 = (funcall_cinfo_75_t) (node_7);
	 {
	    obj_t aux_3809;
	    {
	       object_t aux_3810;
	       aux_3810 = (object_t) (obj_2980);
	       aux_3809 = OBJECT_WIDENING(aux_3810);
	    }
	    test_3807 = (((funcall_cinfo_75_t) CREF(aux_3809))->arity_error_noticed__118);
	 }
      }
      if (test_3807)
	{
	   BUNSPEC;
	}
      else
	{
	   long len_prov_87_2103;
	   {
	      long aux_3814;
	      aux_3814 = list_length(args_approx_137_10);
	      len_prov_87_2103 = (aux_3814 - ((long) 1));
	   }
	   {
	      obj_t res2337_2985;
	      {
		 funcall_cinfo_75_t obj_2983;
		 obj_2983 = (funcall_cinfo_75_t) (node_7);
		 {
		    obj_t x_3434;
		    {
		       obj_t aux_3818;
		       {
			  object_t aux_3819;
			  aux_3819 = (object_t) (obj_2983);
			  aux_3818 = OBJECT_WIDENING(aux_3819);
		       }
		       x_3434 = ((((funcall_cinfo_75_t) CREF(aux_3818))->arity_error_noticed__118) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		    }
		    res2337_2985 = BUNSPEC;
		 }
	      }
	      res2337_2985;
	   }
	   {
	      obj_t arg2029_2104;
	      obj_t arg2030_2105;
	      obj_t arg2032_2107;
	      {
		 funcall_t obj_2986;
		 obj_2986 = (funcall_t) (node_7);
		 arg2029_2104 = (((funcall_t) CREF(obj_2986))->loc);
	      }
	      {
		 obj_t arg2033_2108;
		 {
		    bool_t test2034_2109;
		    test2034_2109 = is_a__118___object((obj_t) (v_8), local_ast_var);
		    if (test2034_2109)
		      {
			 {
			    local_t duplicated1885_2110;
			    duplicated1885_2110 = (local_t) (v_8);
			    {
			       obj_t arg2035_2111;
			       obj_t arg2036_2112;
			       type_t arg2037_2113;
			       value_t arg2039_2114;
			       obj_t arg2040_2115;
			       obj_t arg2041_2116;
			       obj_t arg2043_2117;
			       long arg2045_2118;
			       long arg2046_2119;
			       arg2035_2111 = (((local_t) CREF(duplicated1885_2110))->id);
			       arg2036_2112 = (((local_t) CREF(duplicated1885_2110))->name);
			       arg2037_2113 = (((local_t) CREF(duplicated1885_2110))->type);
			       arg2039_2114 = (((local_t) CREF(duplicated1885_2110))->value);
			       arg2040_2115 = (((local_t) CREF(duplicated1885_2110))->access);
			       arg2041_2116 = (((local_t) CREF(duplicated1885_2110))->fast_alpha_7);
			       arg2043_2117 = (((local_t) CREF(duplicated1885_2110))->removable);
			       arg2045_2118 = (((local_t) CREF(duplicated1885_2110))->occurrence);
			       arg2046_2119 = (((local_t) CREF(duplicated1885_2110))->key);
			       {
				  local_t res2338_3019;
				  {
				     local_t new1097_3006;
				     new1097_3006 = ((local_t) BREF(GC_MALLOC(sizeof(struct local))));
				     {
					long arg2326_3007;
					arg2326_3007 = class_num_218___object(local_ast_var);
					{
					   obj_t obj_3017;
					   obj_3017 = (obj_t) (new1097_3006);
					   (((obj_t) CREF(obj_3017))->header = MAKE_HEADER(arg2326_3007, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_3842;
					aux_3842 = (object_t) (new1097_3006);
					OBJECT_WIDENING_SET(aux_3842, BFALSE);
				     }
				     ((((local_t) CREF(new1097_3006))->id) = ((obj_t) arg2035_2111), BUNSPEC);
				     ((((local_t) CREF(new1097_3006))->name) = ((obj_t) arg2036_2112), BUNSPEC);
				     ((((local_t) CREF(new1097_3006))->type) = ((type_t) arg2037_2113), BUNSPEC);
				     ((((local_t) CREF(new1097_3006))->value) = ((value_t) arg2039_2114), BUNSPEC);
				     ((((local_t) CREF(new1097_3006))->access) = ((obj_t) arg2040_2115), BUNSPEC);
				     ((((local_t) CREF(new1097_3006))->fast_alpha_7) = ((obj_t) arg2041_2116), BUNSPEC);
				     ((((local_t) CREF(new1097_3006))->removable) = ((obj_t) arg2043_2117), BUNSPEC);
				     ((((local_t) CREF(new1097_3006))->occurrence) = ((long) arg2045_2118), BUNSPEC);
				     ((((local_t) CREF(new1097_3006))->key) = ((long) arg2046_2119), BUNSPEC);
				     res2338_3019 = new1097_3006;
				  }
				  arg2033_2108 = (obj_t) (res2338_3019);
			       }
			    }
			 }
		      }
		    else
		      {
			 bool_t test2047_2120;
			 test2047_2120 = is_a__118___object((obj_t) (v_8), global_ast_var);
			 if (test2047_2120)
			   {
			      {
				 global_t duplicated1886_2121;
				 duplicated1886_2121 = (global_t) (v_8);
				 {
				    obj_t arg2048_2122;
				    obj_t arg2050_2123;
				    type_t arg2051_2124;
				    value_t arg2052_2125;
				    obj_t arg2053_2126;
				    obj_t arg2054_2127;
				    obj_t arg2055_2128;
				    long arg2056_2129;
				    obj_t arg2057_2130;
				    obj_t arg2058_2131;
				    bool_t arg2059_2132;
				    bool_t arg2060_2133;
				    obj_t arg2061_2134;
				    obj_t arg2062_2135;
				    arg2048_2122 = (((global_t) CREF(duplicated1886_2121))->id);
				    arg2050_2123 = (((global_t) CREF(duplicated1886_2121))->name);
				    arg2051_2124 = (((global_t) CREF(duplicated1886_2121))->type);
				    arg2052_2125 = (((global_t) CREF(duplicated1886_2121))->value);
				    arg2053_2126 = (((global_t) CREF(duplicated1886_2121))->access);
				    arg2054_2127 = (((global_t) CREF(duplicated1886_2121))->fast_alpha_7);
				    arg2055_2128 = (((global_t) CREF(duplicated1886_2121))->removable);
				    arg2056_2129 = (((global_t) CREF(duplicated1886_2121))->occurrence);
				    arg2057_2130 = (((global_t) CREF(duplicated1886_2121))->module);
				    arg2058_2131 = (((global_t) CREF(duplicated1886_2121))->import);
				    arg2059_2132 = (((global_t) CREF(duplicated1886_2121))->evaluable__248);
				    arg2060_2133 = (((global_t) CREF(duplicated1886_2121))->library__255);
				    arg2061_2134 = (((global_t) CREF(duplicated1886_2121))->pragma);
				    arg2062_2135 = (((global_t) CREF(duplicated1886_2121))->src);
				    {
				       global_t res2339_3067;
				       {
					  global_t new1083_3049;
					  new1083_3049 = ((global_t) BREF(GC_MALLOC(sizeof(struct global))));
					  {
					     long arg2328_3050;
					     arg2328_3050 = class_num_218___object(global_ast_var);
					     {
						obj_t obj_3065;
						obj_3065 = (obj_t) (new1083_3049);
						(((obj_t) CREF(obj_3065))->header = MAKE_HEADER(arg2328_3050, 0), BUNSPEC);
					     }
					  }
					  {
					     object_t aux_3877;
					     aux_3877 = (object_t) (new1083_3049);
					     OBJECT_WIDENING_SET(aux_3877, BFALSE);
					  }
					  ((((global_t) CREF(new1083_3049))->id) = ((obj_t) arg2048_2122), BUNSPEC);
					  ((((global_t) CREF(new1083_3049))->name) = ((obj_t) arg2050_2123), BUNSPEC);
					  ((((global_t) CREF(new1083_3049))->type) = ((type_t) arg2051_2124), BUNSPEC);
					  ((((global_t) CREF(new1083_3049))->value) = ((value_t) arg2052_2125), BUNSPEC);
					  ((((global_t) CREF(new1083_3049))->access) = ((obj_t) arg2053_2126), BUNSPEC);
					  ((((global_t) CREF(new1083_3049))->fast_alpha_7) = ((obj_t) arg2054_2127), BUNSPEC);
					  ((((global_t) CREF(new1083_3049))->removable) = ((obj_t) arg2055_2128), BUNSPEC);
					  ((((global_t) CREF(new1083_3049))->occurrence) = ((long) arg2056_2129), BUNSPEC);
					  ((((global_t) CREF(new1083_3049))->module) = ((obj_t) arg2057_2130), BUNSPEC);
					  ((((global_t) CREF(new1083_3049))->import) = ((obj_t) arg2058_2131), BUNSPEC);
					  ((((global_t) CREF(new1083_3049))->evaluable__248) = ((bool_t) arg2059_2132), BUNSPEC);
					  ((((global_t) CREF(new1083_3049))->library__255) = ((bool_t) arg2060_2133), BUNSPEC);
					  ((((global_t) CREF(new1083_3049))->pragma) = ((obj_t) arg2061_2134), BUNSPEC);
					  ((((global_t) CREF(new1083_3049))->src) = ((obj_t) arg2062_2135), BUNSPEC);
					  res2339_3067 = new1083_3049;
				       }
				       arg2033_2108 = (obj_t) (res2339_3067);
				    }
				 }
			      }
			   }
			 else
			   {
			      arg2033_2108 = (obj_t) (v_8);
			   }
		      }
		 }
		 arg2030_2105 = shape_tools_shape(arg2033_2108);
	      }
	      {
		 char *arg2065_2136;
		 char *arg2068_2138;
		 arg2065_2136 = integer__string_135___r4_numbers_6_5_fixnum((arity_9 - ((long) 1)), BNIL);
		 arg2068_2138 = integer__string_135___r4_numbers_6_5_fixnum(len_prov_87_2103, BNIL);
		 {
		    obj_t list2070_2140;
		    {
		       obj_t arg2071_2141;
		       {
			  obj_t arg2072_2142;
			  {
			     obj_t arg2073_2143;
			     arg2073_2143 = MAKE_PAIR(string2356_cfa_funcall, BNIL);
			     {
				obj_t aux_3901;
				aux_3901 = string_to_bstring(arg2068_2138);
				arg2072_2142 = MAKE_PAIR(aux_3901, arg2073_2143);
			     }
			  }
			  arg2071_2141 = MAKE_PAIR(string2357_cfa_funcall, arg2072_2142);
		       }
		       {
			  obj_t aux_3905;
			  aux_3905 = string_to_bstring(arg2065_2136);
			  list2070_2140 = MAKE_PAIR(aux_3905, arg2071_2141);
		       }
		    }
		    arg2032_2107 = string_append_106___r4_strings_6_7(list2070_2140);
		 }
	      }
	      user_warning_location_190_tools_error(arg2029_2104, arg2030_2105, string2358_cfa_funcall, arg2032_2107);
	   }
	}
   }
   {
      bool_t test2081_2150;
      {
	 obj_t aux_3910;
	 aux_3910 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
	 test2081_2150 = CBOOL(aux_3910);
      }
      if (test2081_2150)
	{
	   obj_t arg2084_2152;
	   arg2084_2152 = shape_tools_shape(node_7);
	   {
	      obj_t list2085_2153;
	      {
		 obj_t arg2086_2154;
		 {
		    obj_t arg2087_2155;
		    {
		       obj_t aux_3917;
		       aux_3917 = BCHAR(((unsigned char) '\n'));
		       arg2087_2155 = MAKE_PAIR(aux_3917, BNIL);
		    }
		    arg2086_2154 = MAKE_PAIR(arg2084_2152, arg2087_2155);
		 }
		 list2085_2153 = MAKE_PAIR(string2359_cfa_funcall, arg2086_2154);
	      }
	      print_trace_107_tools_trace(list2085_2153);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   return make_empty_approx_131_cfa_approx();
}


obj_t 
imported_modules_init_94_cfa_funcall()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_FUNCALL");
   module_initialization_70_tools_shape(((long) 0), "CFA_FUNCALL");
   module_initialization_70_tools_args(((long) 0), "CFA_FUNCALL");
   module_initialization_70_tools_error(((long) 0), "CFA_FUNCALL");
   module_initialization_70_type_type(((long) 0), "CFA_FUNCALL");
   module_initialization_70_type_cache(((long) 0), "CFA_FUNCALL");
   module_initialization_70_ast_var(((long) 0), "CFA_FUNCALL");
   module_initialization_70_ast_node(((long) 0), "CFA_FUNCALL");
   module_initialization_70_cfa_info(((long) 0), "CFA_FUNCALL");
   module_initialization_70_cfa_cfa(((long) 0), "CFA_FUNCALL");
   module_initialization_70_cfa_loose(((long) 0), "CFA_FUNCALL");
   module_initialization_70_cfa_approx(((long) 0), "CFA_FUNCALL");
   return module_initialization_70_cfa_app(((long) 0), "CFA_FUNCALL");
}
