/*===========================================================================*/
/*   (Cfa/iterate.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


extern approx_t cfa_intern_sfun__162_cfa_iterate(intern_sfun_cinfo_192_t, obj_t);
extern obj_t svar_cinfo_166_cfa_info;
extern obj_t cfa_iterate__222_cfa_iterate(obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern approx_t loose__226_cfa_loose(approx_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t _cfa_intern_sfun__144_cfa_iterate(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_cfa_iterate();
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_unit(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_cfa_iterate();
static obj_t cnst_init_137_cfa_iterate();
extern obj_t cfa_export_var__93_cfa_iterate(value_t, obj_t);
extern obj_t unit_initializers_25_ast_unit();
static obj_t require_initialization_114_cfa_iterate = BUNSPEC;
extern obj_t _cfa_iterate__24_cfa_iterate(obj_t, obj_t);
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cfa_iterate();
extern obj_t sfun_ast_var;
extern obj_t _continue_cfa__96_cfa_iterate(obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t cfa_export_var__default1882_12_cfa_iterate(value_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t cfa_iterate_to_fixpoint__166_cfa_iterate(obj_t);
obj_t __cfa_stamp__16_cfa_iterate = BUNSPEC;
extern approx_t union_approx__241_cfa_approx(approx_t, approx_t);
extern approx_t cfa__102_cfa_cfa(node_t);
static obj_t _cfa_export_var__default1882_74_cfa_iterate(obj_t, obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t cfa_variable_value_approx_39_cfa_cfa(value_t);
extern obj_t _cfa_export_var__160_cfa_iterate(obj_t, obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t stack_intern_sfun_loose__226_cfa_loose(approx_t, obj_t);
extern obj_t approx_set_top__187_cfa_approx(approx_t);
extern obj_t _cfa_iterate_to_fixpoint__26_cfa_iterate(obj_t, obj_t);
extern obj_t continue_cfa__104_cfa_iterate();
static obj_t __cfa_continue___179_cfa_iterate = BUNSPEC;
extern obj_t intern_sfun_cinfo_192_cfa_info;
static obj_t __cnst[4];

DEFINE_STATIC_PROCEDURE(cfa_export_var__default1882_env_74_cfa_iterate, _cfa_export_var__default1882_74_cfa_iterate2303, _cfa_export_var__default1882_74_cfa_iterate, 0L, 2);
DEFINE_STRING(string2292_cfa_iterate, string2292_cfa_iterate2304, " *cfa-stamp*: ", 14);
DEFINE_STRING(string2295_cfa_iterate, string2295_cfa_iterate2305, "~~~ cfa-intern-sfun!: ", 22);
DEFINE_EXPORT_PROCEDURE(cfa_iterate_to_fixpoint__env_242_cfa_iterate, _cfa_iterate_to_fixpoint__26_cfa_iterate2306, _cfa_iterate_to_fixpoint__26_cfa_iterate, 0L, 1);
DEFINE_STRING(string2288_cfa_iterate, string2288_cfa_iterate2307, "=======> Cfa iteration!: ", 25);
DEFINE_EXPORT_GENERIC(cfa_export_var__env_209_cfa_iterate, _cfa_export_var__160_cfa_iterate2308, _cfa_export_var__160_cfa_iterate, 0L, 2);
DEFINE_STRING(string2294_cfa_iterate, string2294_cfa_iterate2309, "~~~ cfa-export-var!::intern-sfun/Cinfo[stamp: ", 46);
DEFINE_EXPORT_PROCEDURE(cfa_iterate__env_97_cfa_iterate, _cfa_iterate__24_cfa_iterate2310, _cfa_iterate__24_cfa_iterate, 0L, 1);
DEFINE_STRING(string2291_cfa_iterate, string2291_cfa_iterate2311, "]", 1);
DEFINE_STRING(string2293_cfa_iterate, string2293_cfa_iterate2312, "~~~ cfa-export/var!::svar/Cinfo[stamp: ", 39);
DEFINE_STRING(string2296_cfa_iterate, string2296_cfa_iterate2313, "--> continue-cfa!", 17);
DEFINE_STRING(string2289_cfa_iterate, string2289_cfa_iterate2314, "Exporting ", 10);
DEFINE_STRING(string2287_cfa_iterate, string2287_cfa_iterate2315, "<======= Cfa iteration!: ", 25);
DEFINE_STRING(string2290_cfa_iterate, string2290_cfa_iterate2316, "No method for this object", 25);
DEFINE_STRING(string2297_cfa_iterate, string2297_cfa_iterate2317, "ALL CFA-EXPORT-VAR!-DEFAULT1882 CFA EXPORT ", 43);
DEFINE_EXPORT_PROCEDURE(continue_cfa__env_5_cfa_iterate, _continue_cfa__96_cfa_iterate2318, _continue_cfa__96_cfa_iterate, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cfa_intern_sfun__env_197_cfa_iterate, _cfa_intern_sfun__144_cfa_iterate2319, _cfa_intern_sfun__144_cfa_iterate, 0L, 2);

obj_t 
module_initialization_70_cfa_iterate(long checksum_3294, char *from_3295)
{
   if (CBOOL(require_initialization_114_cfa_iterate))
     {
	require_initialization_114_cfa_iterate = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_iterate();
	cnst_init_137_cfa_iterate();
	imported_modules_init_94_cfa_iterate();
	toplevel_init_63_cfa_iterate();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_iterate()
{
   module_initialization_70___object(((long) 0), "CFA_ITERATE");
   module_initialization_70___reader(((long) 0), "CFA_ITERATE");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_ITERATE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_iterate()
{
   {
      obj_t cnst_port_138_3286;
      cnst_port_138_3286 = open_input_string(string2297_cfa_iterate);
      {
	 long i_3287;
	 i_3287 = ((long) 3);
       loop_3288:
	 {
	    bool_t test2298_3289;
	    test2298_3289 = (i_3287 == ((long) -1));
	    if (test2298_3289)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2299_3290;
		    {
		       obj_t list2300_3291;
		       {
			  obj_t arg2301_3292;
			  arg2301_3292 = BNIL;
			  list2300_3291 = MAKE_PAIR(cnst_port_138_3286, arg2301_3292);
		       }
		       arg2299_3290 = read___reader(list2300_3291);
		    }
		    CNST_TABLE_SET(i_3287, arg2299_3290);
		 }
		 {
		    int aux_3293;
		    {
		       long aux_3312;
		       aux_3312 = (i_3287 - ((long) 1));
		       aux_3293 = (int) (aux_3312);
		    }
		    {
		       long i_3315;
		       i_3315 = (long) (aux_3293);
		       i_3287 = i_3315;
		       goto loop_3288;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_iterate()
{
   add_generic__110___object(cfa_export_var__env_209_cfa_iterate, cfa_export_var__default1882_env_74_cfa_iterate);
   add_inlined_method__244___object(cfa_export_var__env_209_cfa_iterate, svar_cinfo_166_cfa_info, ((long) 0));
   add_inlined_method__244___object(cfa_export_var__env_209_cfa_iterate, intern_sfun_cinfo_192_cfa_info, ((long) 1));
   __cfa_continue___179_cfa_iterate = BUNSPEC;
   return (__cfa_stamp__16_cfa_iterate = BINT(((long) -1)),
      BUNSPEC);
}


obj_t 
cfa_iterate_to_fixpoint__166_cfa_iterate(obj_t globals_1)
{
   __cfa_stamp__16_cfa_iterate = BINT(((long) -1));
   {
      obj_t glodefs_1942;
      glodefs_1942 = BNIL;
      {
	 obj_t l1870_1943;
	 l1870_1943 = globals_1;
       lname1871_1944:
	 if (PAIRP(l1870_1943))
	   {
	      {
		 obj_t g_1946;
		 g_1946 = CAR(l1870_1943);
		 {
		    bool_t test_3325;
		    {
		       obj_t aux_3329;
		       obj_t aux_3326;
		       aux_3329 = CNST_TABLE_REF(((long) 0));
		       {
			  global_t obj_2844;
			  obj_2844 = (global_t) (g_1946);
			  aux_3326 = (((global_t) CREF(obj_2844))->import);
		       }
		       test_3325 = (aux_3326 == aux_3329);
		    }
		    if (test_3325)
		      {
			 obj_t obj2_2848;
			 obj2_2848 = glodefs_1942;
			 glodefs_1942 = MAKE_PAIR(g_1946, obj2_2848);
		      }
		    else
		      {
			 BUNSPEC;
		      }
		 }
	      }
	      {
		 obj_t l1870_3333;
		 l1870_3333 = CDR(l1870_1943);
		 l1870_1943 = l1870_3333;
		 goto lname1871_1944;
	      }
	   }
	 else
	   {
	      ((bool_t) 1);
	   }
      }
      {
	 obj_t arg1891_1951;
	 arg1891_1951 = unit_initializers_25_ast_unit();
	 glodefs_1942 = append_2_18___r4_pairs_and_lists_6_3(arg1891_1951, glodefs_1942);
      }
      continue_cfa__104_cfa_iterate();
      {
       loop_1952:
	 {
	    bool_t test1892_1953;
	    test1892_1953 = CBOOL(__cfa_continue___179_cfa_iterate);
	    if (test1892_1953)
	      {
		 cfa_iterate__222_cfa_iterate(glodefs_1942);
		 {
		    bool_t test1893_1954;
		    {
		       obj_t aux_3341;
		       aux_3341 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
		       test1893_1954 = CBOOL(aux_3341);
		    }
		    if (test1893_1954)
		      {
			 obj_t list1894_1955;
			 {
			    obj_t arg1896_1957;
			    {
			       obj_t arg1897_1958;
			       {
				  obj_t aux_3347;
				  aux_3347 = BCHAR(((unsigned char) '\n'));
				  arg1897_1958 = MAKE_PAIR(aux_3347, BNIL);
			       }
			       arg1896_1957 = MAKE_PAIR(__cfa_stamp__16_cfa_iterate, arg1897_1958);
			    }
			    list1894_1955 = MAKE_PAIR(string2287_cfa_iterate, arg1896_1957);
			 }
			 print_trace_107_tools_trace(list1894_1955);
		      }
		    else
		      {
			 BUNSPEC;
		      }
		 }
		 goto loop_1952;
	      }
	    else
	      {
		 return glodefs_1942;
	      }
	 }
      }
   }
}


obj_t 
_cfa_iterate_to_fixpoint__26_cfa_iterate(obj_t env_3275, obj_t globals_3276)
{
   return cfa_iterate_to_fixpoint__166_cfa_iterate(globals_3276);
}


obj_t 
cfa_iterate__222_cfa_iterate(obj_t globals_2)
{
   __cfa_continue___179_cfa_iterate = BFALSE;
   {
      long z2_2851;
      z2_2851 = (long) CINT(__cfa_stamp__16_cfa_iterate);
      {
	 long aux_3355;
	 aux_3355 = (((long) 1) + z2_2851);
	 __cfa_stamp__16_cfa_iterate = BINT(aux_3355);
      }
   }
   {
      bool_t test1901_1962;
      {
	 obj_t aux_3358;
	 aux_3358 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
	 test1901_1962 = CBOOL(aux_3358);
      }
      if (test1901_1962)
	{
	   obj_t list1902_1963;
	   {
	      obj_t arg1904_1964;
	      {
		 obj_t arg1906_1966;
		 {
		    obj_t arg1907_1967;
		    {
		       obj_t aux_3364;
		       aux_3364 = BCHAR(((unsigned char) '\n'));
		       arg1907_1967 = MAKE_PAIR(aux_3364, BNIL);
		    }
		    arg1906_1966 = MAKE_PAIR(__cfa_stamp__16_cfa_iterate, arg1907_1967);
		 }
		 arg1904_1964 = MAKE_PAIR(string2288_cfa_iterate, arg1906_1966);
	      }
	      {
		 obj_t aux_3369;
		 aux_3369 = BCHAR(((unsigned char) '\n'));
		 list1902_1963 = MAKE_PAIR(aux_3369, arg1904_1964);
	      }
	   }
	   print_trace_107_tools_trace(list1902_1963);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t l1872_1971;
      l1872_1971 = globals_2;
    lname1875_1972:
      if (PAIRP(l1872_1971))
	{
	   {
	      obj_t g_1974;
	      g_1974 = CAR(l1872_1971);
	      {
		 bool_t test1913_1975;
		 {
		    obj_t aux_3376;
		    aux_3376 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
		    test1913_1975 = CBOOL(aux_3376);
		 }
		 if (test1913_1975)
		   {
		      obj_t arg1915_1977;
		      arg1915_1977 = shape_tools_shape(g_1974);
		      {
			 obj_t list1916_1978;
			 {
			    obj_t arg1917_1979;
			    {
			       obj_t arg1918_1980;
			       {
				  obj_t arg1921_1981;
				  {
				     obj_t aux_3383;
				     aux_3383 = BCHAR(((unsigned char) '\n'));
				     arg1921_1981 = MAKE_PAIR(aux_3383, BNIL);
				  }
				  {
				     obj_t aux_3386;
				     aux_3386 = BCHAR(((unsigned char) ':'));
				     arg1918_1980 = MAKE_PAIR(aux_3386, arg1921_1981);
				  }
			       }
			       arg1917_1979 = MAKE_PAIR(arg1915_1977, arg1918_1980);
			    }
			    list1916_1978 = MAKE_PAIR(string2289_cfa_iterate, arg1917_1979);
			 }
			 print_trace_107_tools_trace(list1916_1978);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	      {
		 value_t aux_3392;
		 {
		    global_t obj_2854;
		    obj_2854 = (global_t) (g_1974);
		    aux_3392 = (((global_t) CREF(obj_2854))->value);
		 }
		 cfa_export_var__93_cfa_iterate(aux_3392, g_1974);
	      }
	      {
		 bool_t test1927_1986;
		 {
		    obj_t aux_3396;
		    aux_3396 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
		    test1927_1986 = CBOOL(aux_3396);
		 }
		 if (test1927_1986)
		   {
		      obj_t list1928_1987;
		      {
			 obj_t aux_3402;
			 aux_3402 = BCHAR(((unsigned char) '\n'));
			 list1928_1987 = MAKE_PAIR(aux_3402, BNIL);
		      }
		      print_trace_107_tools_trace(list1928_1987);
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	   }
	   {
	      obj_t l1872_3406;
	      l1872_3406 = CDR(l1872_1971);
	      l1872_1971 = l1872_3406;
	      goto lname1875_1972;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      bool_t test1935_1992;
      {
	 obj_t aux_3408;
	 aux_3408 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
	 test1935_1992 = CBOOL(aux_3408);
      }
      if (test1935_1992)
	{
	   obj_t list1936_1993;
	   {
	      obj_t aux_3414;
	      aux_3414 = BCHAR(((unsigned char) '\n'));
	      list1936_1993 = MAKE_PAIR(aux_3414, BNIL);
	   }
	   return print_trace_107_tools_trace(list1936_1993);
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_cfa_iterate__24_cfa_iterate(obj_t env_3277, obj_t globals_3278)
{
   return cfa_iterate__222_cfa_iterate(globals_3278);
}


obj_t 
cfa_export_var__default1882_12_cfa_iterate(value_t value_5, obj_t owner_6)
{
   FAILURE(CNST_TABLE_REF(((long) 2)), string2290_cfa_iterate, (obj_t) (value_5));
}


obj_t 
_cfa_export_var__default1882_74_cfa_iterate(obj_t env_3272, obj_t value_3273, obj_t owner_3274)
{
   return cfa_export_var__default1882_12_cfa_iterate((value_t) (value_3273), owner_3274);
}


obj_t 
cfa_export_var__93_cfa_iterate(value_t value_3, obj_t owner_4)
{
   {
      obj_t method2214_2775;
      obj_t class2219_2776;
      {
	 obj_t arg2222_2773;
	 obj_t arg2223_2774;
	 {
	    object_t obj_2861;
	    obj_2861 = (object_t) (value_3);
	    {
	       obj_t pre_method_105_2862;
	       pre_method_105_2862 = PROCEDURE_REF(cfa_export_var__env_209_cfa_iterate, ((long) 2));
	       if (INTEGERP(pre_method_105_2862))
		 {
		    PROCEDURE_SET(cfa_export_var__env_209_cfa_iterate, ((long) 2), BUNSPEC);
		    arg2222_2773 = pre_method_105_2862;
		 }
	       else
		 {
		    long obj_class_num_177_2867;
		    obj_class_num_177_2867 = TYPE(obj_2861);
		    {
		       obj_t arg1183_2868;
		       arg1183_2868 = PROCEDURE_REF(cfa_export_var__env_209_cfa_iterate, ((long) 1));
		       {
			  long arg1184_2872;
			  {
			     long arg1186_2873;
			     arg1186_2873 = OBJECT_TYPE;
			     arg1184_2872 = (obj_class_num_177_2867 - arg1186_2873);
			  }
			  arg2222_2773 = VECTOR_REF(arg1183_2868, arg1184_2872);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_2878;
	    object_2878 = (object_t) (value_3);
	    {
	       long arg1187_2879;
	       {
		  long arg1188_2880;
		  long arg1189_2881;
		  arg1188_2880 = TYPE(object_2878);
		  arg1189_2881 = OBJECT_TYPE;
		  arg1187_2879 = (arg1188_2880 - arg1189_2881);
	       }
	       {
		  obj_t vector_2885;
		  vector_2885 = __classes__134___object;
		  arg2223_2774 = VECTOR_REF(vector_2885, arg1187_2879);
	       }
	    }
	 }
	 method2214_2775 = arg2222_2773;
	 class2219_2776 = arg2223_2774;
	 {
	    if (INTEGERP(method2214_2775))
	      {
		 switch ((long) CINT(method2214_2775))
		   {
		   case ((long) 0):
		      {
			 svar_cinfo_166_t value_2782;
			 value_2782 = (svar_cinfo_166_t) (value_3);
			 {
			    obj_t instance1876_2784;
			    instance1876_2784 = sfun_ast_var;
			    {
			       bool_t test2226_2785;
			       {
				  obj_t aux_3442;
				  aux_3442 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 3)));
				  test2226_2785 = CBOOL(aux_3442);
			       }
			       if (test2226_2785)
				 {
				    long arg2228_2787;
				    {
				       intern_sfun_cinfo_192_t obj_2887;
				       obj_2887 = (intern_sfun_cinfo_192_t) (instance1876_2784);
				       {
					  obj_t aux_3449;
					  {
					     object_t aux_3450;
					     aux_3450 = (object_t) (obj_2887);
					     aux_3449 = OBJECT_WIDENING(aux_3450);
					  }
					  arg2228_2787 = (((intern_sfun_cinfo_192_t) CREF(aux_3449))->stamp);
				       }
				    }
				    {
				       obj_t list2231_2790;
				       {
					  obj_t arg2232_2791;
					  {
					     obj_t arg2233_2792;
					     {
						obj_t arg2234_2793;
						{
						   obj_t arg2235_2794;
						   {
						      obj_t arg2236_2795;
						      {
							 obj_t aux_3454;
							 aux_3454 = BCHAR(((unsigned char) '\n'));
							 arg2236_2795 = MAKE_PAIR(aux_3454, BNIL);
						      }
						      arg2235_2794 = MAKE_PAIR(string2291_cfa_iterate, arg2236_2795);
						   }
						   arg2234_2793 = MAKE_PAIR(__cfa_stamp__16_cfa_iterate, arg2235_2794);
						}
						arg2233_2792 = MAKE_PAIR(string2292_cfa_iterate, arg2234_2793);
					     }
					     {
						obj_t aux_3460;
						aux_3460 = BINT(arg2228_2787);
						arg2232_2791 = MAKE_PAIR(aux_3460, arg2233_2792);
					     }
					  }
					  list2231_2790 = MAKE_PAIR(string2293_cfa_iterate, arg2232_2791);
				       }
				       print_trace_107_tools_trace(list2231_2790);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       bool_t test2245_2799;
			       {
				  long arg2248_2802;
				  {
				     intern_sfun_cinfo_192_t obj_2888;
				     obj_2888 = (intern_sfun_cinfo_192_t) (instance1876_2784);
				     {
					obj_t aux_3466;
					{
					   object_t aux_3467;
					   aux_3467 = (object_t) (obj_2888);
					   aux_3466 = OBJECT_WIDENING(aux_3467);
					}
					arg2248_2802 = (((intern_sfun_cinfo_192_t) CREF(aux_3466))->stamp);
				     }
				  }
				  {
				     long n2_2890;
				     n2_2890 = (long) CINT(__cfa_stamp__16_cfa_iterate);
				     test2245_2799 = (arg2248_2802 == n2_2890);
				  }
			       }
			       if (test2245_2799)
				 {
				    return cfa_variable_value_approx_39_cfa_cfa((value_t) (value_2782));
				 }
			       else
				 {
				    {
				       obj_t res2283_2893;
				       {
					  intern_sfun_cinfo_192_t obj_2891;
					  long val1371_2892;
					  obj_2891 = (intern_sfun_cinfo_192_t) (instance1876_2784);
					  val1371_2892 = (long) CINT(__cfa_stamp__16_cfa_iterate);
					  {
					     obj_t x_3283;
					     {
						obj_t aux_3478;
						{
						   object_t aux_3479;
						   aux_3479 = (object_t) (obj_2891);
						   aux_3478 = OBJECT_WIDENING(aux_3479);
						}
						x_3283 = ((((intern_sfun_cinfo_192_t) CREF(aux_3478))->stamp) = ((long) val1371_2892), BUNSPEC);
					     }
					     res2283_2893 = BUNSPEC;
					  }
				       }
				       res2283_2893;
				    }
				    {
				       obj_t arg2246_2800;
				       obj_t arg2247_2801;
				       arg2246_2800 = cfa_variable_value_approx_39_cfa_cfa((value_t) (value_2782));
				       arg2247_2801 = CNST_TABLE_REF(((long) 3));
				       {
					  approx_t aux_3486;
					  aux_3486 = loose__226_cfa_loose((approx_t) (arg2246_2800), arg2247_2801);
					  return (obj_t) (aux_3486);
				       }
				    }
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 1):
		      {
			 intern_sfun_cinfo_192_t value_2803;
			 value_2803 = (intern_sfun_cinfo_192_t) (value_3);
			 {
			    bool_t test2249_2806;
			    {
			       obj_t aux_3491;
			       aux_3491 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 3)));
			       test2249_2806 = CBOOL(aux_3491);
			    }
			    if (test2249_2806)
			      {
				 long arg2251_2808;
				 {
				    obj_t aux_3497;
				    {
				       object_t aux_3498;
				       aux_3498 = (object_t) (value_2803);
				       aux_3497 = OBJECT_WIDENING(aux_3498);
				    }
				    arg2251_2808 = (((intern_sfun_cinfo_192_t) CREF(aux_3497))->stamp);
				 }
				 {
				    obj_t list2255_2811;
				    {
				       obj_t arg2256_2812;
				       {
					  obj_t arg2257_2813;
					  {
					     obj_t arg2258_2814;
					     {
						obj_t arg2259_2815;
						{
						   obj_t arg2260_2816;
						   {
						      obj_t aux_3502;
						      aux_3502 = BCHAR(((unsigned char) '\n'));
						      arg2260_2816 = MAKE_PAIR(aux_3502, BNIL);
						   }
						   arg2259_2815 = MAKE_PAIR(string2291_cfa_iterate, arg2260_2816);
						}
						arg2258_2814 = MAKE_PAIR(__cfa_stamp__16_cfa_iterate, arg2259_2815);
					     }
					     arg2257_2813 = MAKE_PAIR(string2292_cfa_iterate, arg2258_2814);
					  }
					  {
					     obj_t aux_3508;
					     aux_3508 = BINT(arg2251_2808);
					     arg2256_2812 = MAKE_PAIR(aux_3508, arg2257_2813);
					  }
				       }
				       list2255_2811 = MAKE_PAIR(string2294_cfa_iterate, arg2256_2812);
				    }
				    print_trace_107_tools_trace(list2255_2811);
				 }
			      }
			    else
			      {
				 BUNSPEC;
			      }
			 }
			 {
			    bool_t test2264_2820;
			    {
			       long arg2273_2832;
			       {
				  obj_t aux_3513;
				  {
				     object_t aux_3514;
				     aux_3514 = (object_t) (value_2803);
				     aux_3513 = OBJECT_WIDENING(aux_3514);
				  }
				  arg2273_2832 = (((intern_sfun_cinfo_192_t) CREF(aux_3513))->stamp);
			       }
			       {
				  long n2_2897;
				  n2_2897 = (long) CINT(__cfa_stamp__16_cfa_iterate);
				  test2264_2820 = (arg2273_2832 == n2_2897);
			       }
			    }
			    if (test2264_2820)
			      {
				 {
				    obj_t res2284_2900;
				    {
				       long val1371_2899;
				       val1371_2899 = (long) CINT(__cfa_stamp__16_cfa_iterate);
				       {
					  obj_t x_3284;
					  {
					     obj_t aux_3522;
					     {
						object_t aux_3523;
						aux_3523 = (object_t) (value_2803);
						aux_3522 = OBJECT_WIDENING(aux_3523);
					     }
					     x_3284 = ((((intern_sfun_cinfo_192_t) CREF(aux_3522))->stamp) = ((long) val1371_2899), BUNSPEC);
					  }
					  res2284_2900 = BUNSPEC;
				       }
				    }
				    res2284_2900;
				 }
				 {
				    approx_t aux_3527;
				    {
				       obj_t aux_3528;
				       {
					  object_t aux_3529;
					  aux_3529 = (object_t) (value_2803);
					  aux_3528 = OBJECT_WIDENING(aux_3529);
				       }
				       aux_3527 = (((intern_sfun_cinfo_192_t) CREF(aux_3528))->approx);
				    }
				    return (obj_t) (aux_3527);
				 }
			      }
			    else
			      {
				 {
				    obj_t l1878_2821;
				    {
				       sfun_t obj_2902;
				       obj_2902 = (sfun_t) (value_2803);
				       l1878_2821 = (((sfun_t) CREF(obj_2902))->args);
				    }
				  lname1880_2822:
				    if (PAIRP(l1878_2821))
				      {
					 {
					    value_t val_2826;
					    {
					       local_t obj_2905;
					       {
						  obj_t aux_3536;
						  aux_3536 = CAR(l1878_2821);
						  obj_2905 = (local_t) (aux_3536);
					       }
					       val_2826 = (((local_t) CREF(obj_2905))->value);
					    }
					    {
					       bool_t test_3540;
					       {
						  svar_cinfo_166_t obj_2906;
						  obj_2906 = (svar_cinfo_166_t) (val_2826);
						  {
						     obj_t aux_3542;
						     {
							object_t aux_3543;
							aux_3543 = (object_t) (obj_2906);
							aux_3542 = OBJECT_WIDENING(aux_3543);
						     }
						     test_3540 = (((svar_cinfo_166_t) CREF(aux_3542))->clo_env__87);
						  }
					       }
					       if (test_3540)
						 {
						    BUNSPEC;
						 }
					       else
						 {
						    approx_t aux_3547;
						    {
						       svar_cinfo_166_t obj_2907;
						       obj_2907 = (svar_cinfo_166_t) (val_2826);
						       {
							  obj_t aux_3549;
							  {
							     object_t aux_3550;
							     aux_3550 = (object_t) (obj_2907);
							     aux_3549 = OBJECT_WIDENING(aux_3550);
							  }
							  aux_3547 = (((svar_cinfo_166_t) CREF(aux_3549))->approx);
						       }
						    }
						    approx_set_top__187_cfa_approx(aux_3547);
						 }
					    }
					 }
					 {
					    obj_t l1878_3555;
					    l1878_3555 = CDR(l1878_2821);
					    l1878_2821 = l1878_3555;
					    goto lname1880_2822;
					 }
				      }
				    else
				      {
					 ((bool_t) 1);
				      }
				 }
				 {
				    approx_t arg2271_2830;
				    obj_t arg2272_2831;
				    arg2271_2830 = cfa_intern_sfun__162_cfa_iterate(value_2803, owner_4);
				    arg2272_2831 = CNST_TABLE_REF(((long) 3));
				    {
				       approx_t aux_3561;
				       aux_3561 = loose__226_cfa_loose(arg2271_2830, arg2272_2831);
				       return (obj_t) (aux_3561);
				    }
				 }
			      }
			 }
		      }
		      break;
		   default:
		    case_else2220_40_2779:
		      if (PROCEDUREP(method2214_2775))
			{
			   return PROCEDURE_ENTRY(method2214_2775) (method2214_2775, (obj_t) (value_3), owner_4, BEOA);
			}
		      else
			{
			   obj_t fun1942_1999;
			   fun1942_1999 = PROCEDURE_REF(cfa_export_var__env_209_cfa_iterate, ((long) 0));
			   return PROCEDURE_ENTRY(fun1942_1999) (fun1942_1999, (obj_t) (value_3), owner_4, BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else2220_40_2779;
	      }
	 }
      }
   }
}


obj_t 
_cfa_export_var__160_cfa_iterate(obj_t env_3269, obj_t value_3270, obj_t owner_3271)
{
   return cfa_export_var__93_cfa_iterate((value_t) (value_3270), owner_3271);
}


approx_t 
cfa_intern_sfun__162_cfa_iterate(intern_sfun_cinfo_192_t sfun_11, obj_t owner_12)
{
   {
      bool_t test1943_2001;
      {
	 obj_t aux_3577;
	 aux_3577 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 3)));
	 test1943_2001 = CBOOL(aux_3577);
      }
      if (test1943_2001)
	{
	   obj_t arg1945_2003;
	   {
	      obj_t aux_3583;
	      {
		 sfun_t obj_2911;
		 obj_2911 = (sfun_t) (sfun_11);
		 aux_3583 = (((sfun_t) CREF(obj_2911))->body);
	      }
	      arg1945_2003 = shape_tools_shape(aux_3583);
	   }
	   {
	      obj_t list1946_2004;
	      {
		 obj_t arg1947_2005;
		 {
		    obj_t arg1948_2006;
		    {
		       obj_t aux_3587;
		       aux_3587 = BCHAR(((unsigned char) '\n'));
		       arg1948_2006 = MAKE_PAIR(aux_3587, BNIL);
		    }
		    arg1947_2005 = MAKE_PAIR(arg1945_2003, arg1948_2006);
		 }
		 list1946_2004 = MAKE_PAIR(string2295_cfa_iterate, arg1947_2005);
	      }
	      print_trace_107_tools_trace(list1946_2004);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test1953_2011;
      {
	 long arg1960_2016;
	 {
	    obj_t aux_3593;
	    {
	       object_t aux_3594;
	       aux_3594 = (object_t) (sfun_11);
	       aux_3593 = OBJECT_WIDENING(aux_3594);
	    }
	    arg1960_2016 = (((intern_sfun_cinfo_192_t) CREF(aux_3593))->stamp);
	 }
	 {
	    long n2_2914;
	    n2_2914 = (long) CINT(__cfa_stamp__16_cfa_iterate);
	    test1953_2011 = (arg1960_2016 == n2_2914);
	 }
      }
      if (test1953_2011)
	{
	   obj_t aux_3601;
	   {
	      object_t aux_3602;
	      aux_3602 = (object_t) (sfun_11);
	      aux_3601 = OBJECT_WIDENING(aux_3602);
	   }
	   return (((intern_sfun_cinfo_192_t) CREF(aux_3601))->approx);
	}
      else
	{
	   {
	      obj_t res2286_2918;
	      {
		 long val1371_2917;
		 val1371_2917 = (long) CINT(__cfa_stamp__16_cfa_iterate);
		 {
		    obj_t x_3285;
		    {
		       obj_t aux_3607;
		       {
			  object_t aux_3608;
			  aux_3608 = (object_t) (sfun_11);
			  aux_3607 = OBJECT_WIDENING(aux_3608);
		       }
		       x_3285 = ((((intern_sfun_cinfo_192_t) CREF(aux_3607))->stamp) = ((long) val1371_2917), BUNSPEC);
		    }
		    res2286_2918 = BUNSPEC;
		 }
	      }
	      res2286_2918;
	   }
	   {
	      approx_t arg1954_2012;
	      approx_t arg1956_2013;
	      {
		 obj_t aux_3612;
		 {
		    object_t aux_3613;
		    aux_3613 = (object_t) (sfun_11);
		    aux_3612 = OBJECT_WIDENING(aux_3613);
		 }
		 arg1954_2012 = (((intern_sfun_cinfo_192_t) CREF(aux_3612))->approx);
	      }
	      {
		 node_t aux_3617;
		 {
		    obj_t aux_3618;
		    {
		       sfun_t obj_2920;
		       obj_2920 = (sfun_t) (sfun_11);
		       aux_3618 = (((sfun_t) CREF(obj_2920))->body);
		    }
		    aux_3617 = (node_t) (aux_3618);
		 }
		 arg1956_2013 = cfa__102_cfa_cfa(aux_3617);
	      }
	      union_approx__241_cfa_approx(arg1954_2012, arg1956_2013);
	   }
	   {
	      approx_t aux_3624;
	      {
		 obj_t aux_3625;
		 {
		    object_t aux_3626;
		    aux_3626 = (object_t) (sfun_11);
		    aux_3625 = OBJECT_WIDENING(aux_3626);
		 }
		 aux_3624 = (((intern_sfun_cinfo_192_t) CREF(aux_3625))->approx);
	      }
	      stack_intern_sfun_loose__226_cfa_loose(aux_3624, owner_12);
	   }
	   {
	      obj_t aux_3631;
	      {
		 object_t aux_3632;
		 aux_3632 = (object_t) (sfun_11);
		 aux_3631 = OBJECT_WIDENING(aux_3632);
	      }
	      return (((intern_sfun_cinfo_192_t) CREF(aux_3631))->approx);
	   }
	}
   }
}


obj_t 
_cfa_intern_sfun__144_cfa_iterate(obj_t env_3279, obj_t sfun_3280, obj_t owner_3281)
{
   {
      approx_t aux_3636;
      aux_3636 = cfa_intern_sfun__162_cfa_iterate((intern_sfun_cinfo_192_t) (sfun_3280), owner_3281);
      return (obj_t) (aux_3636);
   }
}


obj_t 
continue_cfa__104_cfa_iterate()
{
   if (CBOOL(__cfa_continue___179_cfa_iterate))
     {
	BUNSPEC;
     }
   else
     {
	bool_t test1961_2017;
	{
	   obj_t aux_3642;
	   aux_3642 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
	   test1961_2017 = CBOOL(aux_3642);
	}
	if (test1961_2017)
	  {
	     obj_t list1962_2018;
	     {
		obj_t arg1964_2020;
		{
		   obj_t aux_3648;
		   aux_3648 = BCHAR(((unsigned char) '\n'));
		   arg1964_2020 = MAKE_PAIR(aux_3648, BNIL);
		}
		list1962_2018 = MAKE_PAIR(string2296_cfa_iterate, arg1964_2020);
	     }
	     print_trace_107_tools_trace(list1962_2018);
	  }
	else
	  {
	     BUNSPEC;
	  }
     }
   return (__cfa_continue___179_cfa_iterate = BTRUE,
      BUNSPEC);
}


obj_t 
_continue_cfa__96_cfa_iterate(obj_t env_3282)
{
   return continue_cfa__104_cfa_iterate();
}


obj_t 
imported_modules_init_94_cfa_iterate()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_ITERATE");
   module_initialization_70_tools_shape(((long) 0), "CFA_ITERATE");
   module_initialization_70_type_type(((long) 0), "CFA_ITERATE");
   module_initialization_70_ast_var(((long) 0), "CFA_ITERATE");
   module_initialization_70_ast_node(((long) 0), "CFA_ITERATE");
   module_initialization_70_ast_unit(((long) 0), "CFA_ITERATE");
   module_initialization_70_cfa_cfa(((long) 0), "CFA_ITERATE");
   module_initialization_70_cfa_info(((long) 0), "CFA_ITERATE");
   module_initialization_70_cfa_loose(((long) 0), "CFA_ITERATE");
   return module_initialization_70_cfa_approx(((long) 0), "CFA_ITERATE");
}
