/*===========================================================================*/
/*   (Cfa/loose.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


extern obj_t _stack_intern_sfun_loose__108_cfa_loose(obj_t, obj_t, obj_t);
extern obj_t _stack_loose_alloc__18_cfa_loose(obj_t, obj_t, obj_t);
extern obj_t _set_looser__78_cfa_loose(obj_t, obj_t);
static obj_t arg18932220_cfa_loose(obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern approx_t loose__226_cfa_loose(approx_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_cfa_loose();
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_set(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_procedure(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_cfa_loose();
static obj_t cnst_init_137_cfa_loose();
extern obj_t _loose_alloc__239_cfa_loose(obj_t, obj_t);
extern obj_t stack_loose_alloc__95_cfa_loose(node_t, obj_t);
static obj_t require_initialization_114_cfa_loose = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cfa_loose();
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t global_loose__8_cfa_loose(global_t, approx_t);
extern obj_t read___reader(obj_t);
static obj_t _stack_loose_alloc__default1872_234_cfa_loose(obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
static obj_t loose_alloc__default1871_63_cfa_loose(node_t);
extern obj_t _loose__76_cfa_loose(obj_t, obj_t, obj_t);
extern obj_t __cfa_stamp__16_cfa_iterate;
extern obj_t shape_tools_shape(obj_t);
extern obj_t loose_alloc__73_cfa_loose(node_t);
extern obj_t disable_x_t__211_cfa_procedure(approx_t);
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t stack_loose_alloc__default1872_119_cfa_loose(node_t, obj_t);
extern obj_t _global_loose__64_cfa_loose(obj_t, obj_t, obj_t);
extern obj_t stack_intern_sfun_loose__226_cfa_loose(approx_t, obj_t);
extern obj_t set_looser__198_cfa_loose(obj_t);
static approx_t cfa_loose__48_cfa_loose(approx_t);
static obj_t _loose_alloc__default1871_43_cfa_loose(obj_t, obj_t);
static obj_t __looser__194_cfa_loose = BUNSPEC;
static obj_t __cnst[6];

DEFINE_STRING(string2225_cfa_loose, string2225_cfa_loose2233, "global-loose!: ", 15);
DEFINE_STRING(string2227_cfa_loose, string2227_cfa_loose2234, "STACK ALL (IMPORT EXPORT) STACK-LOOSE-ALLOC!-DEFAULT1872 LOOSE-ALLOC!-DEFAULT1871 CFA ", 86);
DEFINE_EXPORT_PROCEDURE(stack_intern_sfun_loose__env_222_cfa_loose, _stack_intern_sfun_loose__108_cfa_loose2235, _stack_intern_sfun_loose__108_cfa_loose, 0L, 2);
DEFINE_STRING(string2221_cfa_loose, string2221_cfa_loose2236, "): ", 3);
DEFINE_EXPORT_PROCEDURE(set_looser__env_207_cfa_loose, _set_looser__78_cfa_loose2237, _set_looser__78_cfa_loose, 0L, 1);
DEFINE_STATIC_PROCEDURE(loose_alloc__default1871_env_111_cfa_loose, _loose_alloc__default1871_43_cfa_loose2238, _loose_alloc__default1871_43_cfa_loose, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_loose__env_130_cfa_loose, _global_loose__64_cfa_loose2239, _global_loose__64_cfa_loose, 0L, 2);
DEFINE_STRING(string2224_cfa_loose, string2224_cfa_loose2240, " ", 1);
DEFINE_STATIC_PROCEDURE(stack_loose_alloc__default1872_env_51_cfa_loose, _stack_loose_alloc__default1872_234_cfa_loose2241, _stack_loose_alloc__default1872_234_cfa_loose, 0L, 2);
DEFINE_EXPORT_GENERIC(loose_alloc__env_83_cfa_loose, _loose_alloc__239_cfa_loose2242, _loose_alloc__239_cfa_loose, 0L, 1);
DEFINE_STRING(string2223_cfa_loose, string2223_cfa_loose2243, "No method for this object", 25);
DEFINE_EXPORT_GENERIC(stack_loose_alloc__env_147_cfa_loose, _stack_loose_alloc__18_cfa_loose2244, _stack_loose_alloc__18_cfa_loose, 0L, 2);
DEFINE_STRING(string2226_cfa_loose, string2226_cfa_loose2245, "stack-intern-sfun-loose!: ", 26);
DEFINE_STRING(string2222_cfa_loose, string2222_cfa_loose2246, "loose!(", 7);
DEFINE_EXPORT_PROCEDURE(loose__env_222_cfa_loose, _loose__76_cfa_loose2247, _loose__76_cfa_loose, 0L, 2);

obj_t 
module_initialization_70_cfa_loose(long checksum_3256, char *from_3257)
{
   if (CBOOL(require_initialization_114_cfa_loose))
     {
	require_initialization_114_cfa_loose = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_loose();
	cnst_init_137_cfa_loose();
	imported_modules_init_94_cfa_loose();
	toplevel_init_63_cfa_loose();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_loose()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_LOOSE");
   module_initialization_70___object(((long) 0), "CFA_LOOSE");
   module_initialization_70___reader(((long) 0), "CFA_LOOSE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_loose()
{
   {
      obj_t cnst_port_138_3248;
      cnst_port_138_3248 = open_input_string(string2227_cfa_loose);
      {
	 long i_3249;
	 i_3249 = ((long) 5);
       loop_3250:
	 {
	    bool_t test2228_3251;
	    test2228_3251 = (i_3249 == ((long) -1));
	    if (test2228_3251)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2229_3252;
		    {
		       obj_t list2230_3253;
		       {
			  obj_t arg2231_3254;
			  arg2231_3254 = BNIL;
			  list2230_3253 = MAKE_PAIR(cnst_port_138_3248, arg2231_3254);
		       }
		       arg2229_3252 = read___reader(list2230_3253);
		    }
		    CNST_TABLE_SET(i_3249, arg2229_3252);
		 }
		 {
		    int aux_3255;
		    {
		       long aux_3274;
		       aux_3274 = (i_3249 - ((long) 1));
		       aux_3255 = (int) (aux_3274);
		    }
		    {
		       long i_3277;
		       i_3277 = (long) (aux_3255);
		       i_3249 = i_3277;
		       goto loop_3250;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_loose()
{
   __looser__194_cfa_loose = CNST_TABLE_REF(((long) 0));
   add_generic__110___object(loose_alloc__env_83_cfa_loose, loose_alloc__default1871_env_111_cfa_loose);
   return add_generic__110___object(stack_loose_alloc__env_147_cfa_loose, stack_loose_alloc__default1872_env_51_cfa_loose);
}


obj_t 
set_looser__198_cfa_loose(obj_t looser_1)
{
   return (__looser__194_cfa_loose = looser_1,
      BUNSPEC);
}


obj_t 
_set_looser__78_cfa_loose(obj_t env_3232, obj_t looser_3233)
{
   return set_looser__198_cfa_loose(looser_3233);
}


approx_t 
loose__226_cfa_loose(approx_t approx_2, obj_t owner_3)
{
   {
      bool_t test1873_1946;
      {
	 obj_t aux_3283;
	 aux_3283 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
	 test1873_1946 = CBOOL(aux_3283);
      }
      if (test1873_1946)
	{
	   obj_t arg1876_1949;
	   arg1876_1949 = shape_tools_shape((obj_t) (approx_2));
	   {
	      obj_t list1877_1950;
	      {
		 obj_t arg1879_1951;
		 {
		    obj_t arg1880_1952;
		    {
		       obj_t arg1881_1953;
		       {
			  obj_t arg1882_1954;
			  {
			     obj_t aux_3291;
			     aux_3291 = BCHAR(((unsigned char) '\n'));
			     arg1882_1954 = MAKE_PAIR(aux_3291, BNIL);
			  }
			  arg1881_1953 = MAKE_PAIR(arg1876_1949, arg1882_1954);
		       }
		       arg1880_1952 = MAKE_PAIR(string2221_cfa_loose, arg1881_1953);
		    }
		    arg1879_1951 = MAKE_PAIR(__looser__194_cfa_loose, arg1880_1952);
		 }
		 list1877_1950 = MAKE_PAIR(string2222_cfa_loose, arg1879_1951);
	      }
	      print_trace_107_tools_trace(list1877_1950);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test1886_1958;
      {
	 obj_t obj1_2790;
	 obj1_2790 = __looser__194_cfa_loose;
	 {
	    obj_t aux_3299;
	    aux_3299 = CNST_TABLE_REF(((long) 0));
	    test1886_1958 = (obj1_2790 == aux_3299);
	 }
      }
      if (test1886_1958)
	{
	   return cfa_loose__48_cfa_loose(approx_2);
	}
      else
	{
	   approx_t res2216_2796;
	   {
	      obj_t arg1893_3234;
	      arg1893_3234 = make_fx_procedure(arg18932220_cfa_loose, ((long) 1), ((long) 1));
	      PROCEDURE_SET(arg1893_3234, ((long) 0), owner_3);
	      for_each_approx_alloc_83_cfa_approx(arg1893_3234, approx_2);
	   }
	   res2216_2796 = approx_2;
	   return res2216_2796;
	}
   }
}


obj_t 
_loose__76_cfa_loose(obj_t env_3235, obj_t approx_3236, obj_t owner_3237)
{
   {
      approx_t aux_3307;
      aux_3307 = loose__226_cfa_loose((approx_t) (approx_3236), owner_3237);
      return (obj_t) (aux_3307);
   }
}


obj_t 
arg18932220_cfa_loose(obj_t env_3238, obj_t alloc_3240)
{
   {
      obj_t owner_3239;
      owner_3239 = PROCEDURE_REF(env_3238, ((long) 0));
      {
	 obj_t alloc_2795;
	 alloc_2795 = alloc_3240;
	 return stack_loose_alloc__95_cfa_loose((node_t) (alloc_2795), owner_3239);
      }
   }
}


approx_t 
cfa_loose__48_cfa_loose(approx_t approx_4)
{
   {
      bool_t test1888_1961;
      {
	 long arg1889_1962;
	 arg1889_1962 = (((approx_t) CREF(approx_4))->lost_stamp_114);
	 {
	    long n2_2799;
	    n2_2799 = (long) CINT(__cfa_stamp__16_cfa_iterate);
	    test1888_1961 = (arg1889_1962 < n2_2799);
	 }
      }
      if (test1888_1961)
	{
	   {
	      obj_t res2217_2802;
	      {
		 long val1326_2801;
		 val1326_2801 = (long) CINT(__cfa_stamp__16_cfa_iterate);
		 {
		    obj_t x_3247;
		    x_3247 = ((((approx_t) CREF(approx_4))->lost_stamp_114) = ((long) val1326_2801), BUNSPEC);
		    res2217_2802 = BUNSPEC;
		 }
	      }
	      res2217_2802;
	   }
	   for_each_approx_alloc_83_cfa_approx(loose_alloc__env_83_cfa_loose, approx_4);
	}
      else
	{
	   BUNSPEC;
	}
   }
   return approx_4;
}


obj_t 
loose_alloc__default1871_63_cfa_loose(node_t node_6)
{
   FAILURE(CNST_TABLE_REF(((long) 1)), string2223_cfa_loose, (obj_t) (node_6));
}


obj_t 
_loose_alloc__default1871_43_cfa_loose(obj_t env_3224, obj_t node_3225)
{
   return loose_alloc__default1871_63_cfa_loose((node_t) (node_3225));
}


obj_t 
loose_alloc__73_cfa_loose(node_t node_5)
{
   {
      obj_t method2202_2776;
      obj_t class2207_2777;
      {
	 obj_t arg2208_2774;
	 obj_t arg2209_2775;
	 {
	    object_t obj_2808;
	    obj_2808 = (object_t) (node_5);
	    {
	       obj_t pre_method_105_2809;
	       pre_method_105_2809 = PROCEDURE_REF(loose_alloc__env_83_cfa_loose, ((long) 2));
	       if (INTEGERP(pre_method_105_2809))
		 {
		    PROCEDURE_SET(loose_alloc__env_83_cfa_loose, ((long) 2), BUNSPEC);
		    arg2208_2774 = pre_method_105_2809;
		 }
	       else
		 {
		    long obj_class_num_177_2814;
		    obj_class_num_177_2814 = TYPE(obj_2808);
		    {
		       obj_t arg1183_2815;
		       arg1183_2815 = PROCEDURE_REF(loose_alloc__env_83_cfa_loose, ((long) 1));
		       {
			  long arg1184_2819;
			  {
			     long arg1186_2820;
			     arg1186_2820 = OBJECT_TYPE;
			     arg1184_2819 = (obj_class_num_177_2814 - arg1186_2820);
			  }
			  arg2208_2774 = VECTOR_REF(arg1183_2815, arg1184_2819);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_2825;
	    object_2825 = (object_t) (node_5);
	    {
	       long arg1187_2826;
	       {
		  long arg1188_2827;
		  long arg1189_2828;
		  arg1188_2827 = TYPE(object_2825);
		  arg1189_2828 = OBJECT_TYPE;
		  arg1187_2826 = (arg1188_2827 - arg1189_2828);
	       }
	       {
		  obj_t vector_2832;
		  vector_2832 = __classes__134___object;
		  arg2209_2775 = VECTOR_REF(vector_2832, arg1187_2826);
	       }
	    }
	 }
	 method2202_2776 = arg2208_2774;
	 class2207_2777 = arg2209_2775;
	 if (PROCEDUREP(method2202_2776))
	   {
	      return PROCEDURE_ENTRY(method2202_2776) (method2202_2776, (obj_t) (node_5), BEOA);
	   }
	 else
	   {
	      obj_t fun1892_1965;
	      fun1892_1965 = PROCEDURE_REF(loose_alloc__env_83_cfa_loose, ((long) 0));
	      return PROCEDURE_ENTRY(fun1892_1965) (fun1892_1965, (obj_t) (node_5), BEOA);
	   }
      }
   }
}


obj_t 
_loose_alloc__239_cfa_loose(obj_t env_3222, obj_t node_3223)
{
   return loose_alloc__73_cfa_loose((node_t) (node_3223));
}


obj_t 
stack_loose_alloc__default1872_119_cfa_loose(node_t node_11, obj_t owner_12)
{
   FAILURE(CNST_TABLE_REF(((long) 2)), string2223_cfa_loose, (obj_t) (node_11));
}


obj_t 
_stack_loose_alloc__default1872_234_cfa_loose(obj_t env_3229, obj_t node_3230, obj_t owner_3231)
{
   return stack_loose_alloc__default1872_119_cfa_loose((node_t) (node_3230), owner_3231);
}


obj_t 
stack_loose_alloc__95_cfa_loose(node_t node_9, obj_t owner_10)
{
   {
      obj_t method2188_2759;
      obj_t class2193_2760;
      {
	 obj_t arg2194_2757;
	 obj_t arg2195_2758;
	 {
	    object_t obj_2843;
	    obj_2843 = (object_t) (node_9);
	    {
	       obj_t pre_method_105_2844;
	       pre_method_105_2844 = PROCEDURE_REF(stack_loose_alloc__env_147_cfa_loose, ((long) 2));
	       if (INTEGERP(pre_method_105_2844))
		 {
		    PROCEDURE_SET(stack_loose_alloc__env_147_cfa_loose, ((long) 2), BUNSPEC);
		    arg2194_2757 = pre_method_105_2844;
		 }
	       else
		 {
		    long obj_class_num_177_2849;
		    obj_class_num_177_2849 = TYPE(obj_2843);
		    {
		       obj_t arg1183_2850;
		       arg1183_2850 = PROCEDURE_REF(stack_loose_alloc__env_147_cfa_loose, ((long) 1));
		       {
			  long arg1184_2854;
			  {
			     long arg1186_2855;
			     arg1186_2855 = OBJECT_TYPE;
			     arg1184_2854 = (obj_class_num_177_2849 - arg1186_2855);
			  }
			  arg2194_2757 = VECTOR_REF(arg1183_2850, arg1184_2854);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_2860;
	    object_2860 = (object_t) (node_9);
	    {
	       long arg1187_2861;
	       {
		  long arg1188_2862;
		  long arg1189_2863;
		  arg1188_2862 = TYPE(object_2860);
		  arg1189_2863 = OBJECT_TYPE;
		  arg1187_2861 = (arg1188_2862 - arg1189_2863);
	       }
	       {
		  obj_t vector_2867;
		  vector_2867 = __classes__134___object;
		  arg2195_2758 = VECTOR_REF(vector_2867, arg1187_2861);
	       }
	    }
	 }
	 method2188_2759 = arg2194_2757;
	 class2193_2760 = arg2195_2758;
	 if (PROCEDUREP(method2188_2759))
	   {
	      return PROCEDURE_ENTRY(method2188_2759) (method2188_2759, (obj_t) (node_9), owner_10, BEOA);
	   }
	 else
	   {
	      obj_t fun1897_1972;
	      fun1897_1972 = PROCEDURE_REF(stack_loose_alloc__env_147_cfa_loose, ((long) 0));
	      return PROCEDURE_ENTRY(fun1897_1972) (fun1897_1972, (obj_t) (node_9), owner_10, BEOA);
	   }
      }
   }
}


obj_t 
_stack_loose_alloc__18_cfa_loose(obj_t env_3226, obj_t node_3227, obj_t owner_3228)
{
   return stack_loose_alloc__95_cfa_loose((node_t) (node_3227), owner_3228);
}


obj_t 
global_loose__8_cfa_loose(global_t global_13, approx_t approx_14)
{
   {
      bool_t test1898_1973;
      {
	 obj_t aux_3383;
	 aux_3383 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1898_1973 = CBOOL(aux_3383);
      }
      if (test1898_1973)
	{
	   obj_t arg1900_1975;
	   obj_t arg1902_1977;
	   arg1900_1975 = shape_tools_shape((obj_t) (global_13));
	   arg1902_1977 = shape_tools_shape((obj_t) (approx_14));
	   {
	      obj_t list1903_1978;
	      {
		 obj_t arg1904_1979;
		 {
		    obj_t arg1905_1980;
		    {
		       obj_t arg1906_1981;
		       {
			  obj_t arg1907_1982;
			  {
			     obj_t aux_3393;
			     aux_3393 = BCHAR(((unsigned char) '\n'));
			     arg1907_1982 = MAKE_PAIR(aux_3393, BNIL);
			  }
			  arg1906_1981 = MAKE_PAIR(arg1902_1977, arg1907_1982);
		       }
		       arg1905_1980 = MAKE_PAIR(string2224_cfa_loose, arg1906_1981);
		    }
		    arg1904_1979 = MAKE_PAIR(arg1900_1975, arg1905_1980);
		 }
		 list1903_1978 = MAKE_PAIR(string2225_cfa_loose, arg1904_1979);
	      }
	      print_trace_107_tools_trace(list1903_1978);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test_3401;
      {
	 obj_t aux_3402;
	 aux_3402 = memq___r4_pairs_and_lists_6_3((((global_t) CREF(global_13))->import), CNST_TABLE_REF(((long) 3)));
	 test_3401 = CBOOL(aux_3402);
      }
      if (test_3401)
	{
	   {
	      approx_t aux_3407;
	      aux_3407 = loose__226_cfa_loose(approx_14, CNST_TABLE_REF(((long) 4)));
	      return (obj_t) (aux_3407);
	   }
	}
      else
	{
	   bool_t test1914_1988;
	   {
	      obj_t obj1_2872;
	      obj1_2872 = __looser__194_cfa_loose;
	      {
		 obj_t aux_3411;
		 aux_3411 = CNST_TABLE_REF(((long) 5));
		 test1914_1988 = (obj1_2872 == aux_3411);
	      }
	   }
	   if (test1914_1988)
	     {
		disable_x_t__211_cfa_procedure(approx_14);
		{
		   approx_t aux_3416;
		   aux_3416 = loose__226_cfa_loose(approx_14, CNST_TABLE_REF(((long) 4)));
		   return (obj_t) (aux_3416);
		}
	     }
	   else
	     {
		return disable_x_t__211_cfa_procedure(approx_14);
	     }
	}
   }
}


obj_t 
_global_loose__64_cfa_loose(obj_t env_3241, obj_t global_3242, obj_t approx_3243)
{
   return global_loose__8_cfa_loose((global_t) (global_3242), (approx_t) (approx_3243));
}


obj_t 
stack_intern_sfun_loose__226_cfa_loose(approx_t approx_15, obj_t owner_16)
{
   {
      bool_t test1919_1993;
      {
	 obj_t aux_3424;
	 aux_3424 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
	 test1919_1993 = CBOOL(aux_3424);
      }
      if (test1919_1993)
	{
	   obj_t arg1922_1995;
	   obj_t arg1925_1997;
	   arg1922_1995 = shape_tools_shape(owner_16);
	   arg1925_1997 = shape_tools_shape((obj_t) (approx_15));
	   {
	      obj_t list1926_1998;
	      {
		 obj_t arg1927_1999;
		 {
		    obj_t arg1928_2000;
		    {
		       obj_t arg1929_2001;
		       {
			  obj_t arg1931_2002;
			  {
			     obj_t aux_3433;
			     aux_3433 = BCHAR(((unsigned char) '\n'));
			     arg1931_2002 = MAKE_PAIR(aux_3433, BNIL);
			  }
			  arg1929_2001 = MAKE_PAIR(arg1925_1997, arg1931_2002);
		       }
		       arg1928_2000 = MAKE_PAIR(string2224_cfa_loose, arg1929_2001);
		    }
		    arg1927_1999 = MAKE_PAIR(arg1922_1995, arg1928_2000);
		 }
		 list1926_1998 = MAKE_PAIR(string2226_cfa_loose, arg1927_1999);
	      }
	      print_trace_107_tools_trace(list1926_1998);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test1936_2006;
      {
	 obj_t obj1_2874;
	 obj1_2874 = __looser__194_cfa_loose;
	 {
	    obj_t aux_3441;
	    aux_3441 = CNST_TABLE_REF(((long) 5));
	    test1936_2006 = (obj1_2874 == aux_3441);
	 }
      }
      if (test1936_2006)
	{
	   approx_t aux_3445;
	   aux_3445 = loose__226_cfa_loose(approx_15, owner_16);
	   return (obj_t) (aux_3445);
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_stack_intern_sfun_loose__108_cfa_loose(obj_t env_3244, obj_t approx_3245, obj_t owner_3246)
{
   return stack_intern_sfun_loose__226_cfa_loose((approx_t) (approx_3245), owner_3246);
}


obj_t 
imported_modules_init_94_cfa_loose()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_LOOSE");
   module_initialization_70_type_type(((long) 0), "CFA_LOOSE");
   module_initialization_70_tools_shape(((long) 0), "CFA_LOOSE");
   module_initialization_70_ast_var(((long) 0), "CFA_LOOSE");
   module_initialization_70_ast_node(((long) 0), "CFA_LOOSE");
   module_initialization_70_cfa_iterate(((long) 0), "CFA_LOOSE");
   module_initialization_70_cfa_set(((long) 0), "CFA_LOOSE");
   module_initialization_70_cfa_info(((long) 0), "CFA_LOOSE");
   module_initialization_70_cfa_approx(((long) 0), "CFA_LOOSE");
   return module_initialization_70_cfa_procedure(((long) 0), "CFA_LOOSE");
}
