/*===========================================================================*/
/*   (Cfa/procedure.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


extern obj_t get_node_atom_value_135_cfa_approx(node_t);
static obj_t node_setup__pre_make_procedure_app2501_89_cfa_procedure(obj_t, obj_t);
static obj_t arg21052494_cfa_procedure(obj_t, obj_t);
static obj_t stack__make_procedure_app2486_134_cfa_procedure(obj_t, obj_t);
extern obj_t _stack_loose_alloc__18_cfa_loose(obj_t, obj_t, obj_t);
extern obj_t __procedure__226_type_cache;
extern obj_t svar_cinfo_166_cfa_info;
extern obj_t _node_setup__114_cfa_setup(obj_t, obj_t);
extern obj_t pre_clo_env_191_cfa_info;
static obj_t node_key_make_procedure_app2487_10_cfa_procedure(obj_t, obj_t);
extern obj_t fun_ast_var;
extern obj_t node_setup__189_cfa_setup(node_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern approx_t loose__226_cfa_loose(approx_t, obj_t);
extern obj_t _cfa__186_cfa_cfa(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_cfa_procedure();
extern obj_t module_initialization_70_cfa_procedure(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_setup(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_closure(long, char *);
extern obj_t module_initialization_70_cfa_stack(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_cfa_procedure();
static obj_t cnst_init_137_cfa_procedure();
extern obj_t _disable_x_t__100_cfa_procedure(obj_t, obj_t);
static obj_t arg22232511_cfa_procedure(obj_t, obj_t);
extern obj_t pre_make_procedure_app_60_cfa_info;
static obj_t stack_loose_alloc__make_procedure_app2490_61_cfa_procedure(obj_t, obj_t, obj_t);
extern obj_t cfa_export_var__93_cfa_iterate(value_t, obj_t);
extern obj_t _node_key_105_cfa_approx(obj_t, obj_t);
extern obj_t _loose_alloc__239_cfa_loose(obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
extern obj_t node_setup___185_cfa_setup(obj_t);
static obj_t node_setup__pre_procedure_ref_app2500_215_cfa_procedure(obj_t, obj_t);
extern obj_t stack_loose_alloc__95_cfa_loose(node_t, obj_t);
static obj_t arg20452497_cfa_procedure(obj_t, obj_t);
static obj_t require_initialization_114_cfa_procedure = BUNSPEC;
extern obj_t pre_procedure_set__app_208_cfa_info;
extern approx_t make_empty_approx_131_cfa_approx();
extern obj_t make_procedure_app_48_cfa_info;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cfa_procedure();
extern obj_t variable_ast_var;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t procedure_set__app_32_cfa_info;
static obj_t cfa__procedure_ref_app2495_149_cfa_procedure(obj_t, obj_t);
extern obj_t __unspec__87_type_cache;
extern obj_t class_super_145___object(obj_t);
extern long class_num_218___object(obj_t);
static obj_t arg20352496_cfa_procedure(obj_t, obj_t);
static obj_t node_setup__pre_procedure_set__app2499_226_cfa_procedure(obj_t, obj_t);
static obj_t stack_loose_procedure_env__187_cfa_procedure(make_procedure_app_48_t, obj_t);
extern obj_t __cfa_stamp__16_cfa_iterate;
extern approx_t union_approx__241_cfa_approx(approx_t, approx_t);
extern approx_t cfa__102_cfa_cfa(node_t);
static obj_t cfa__make_procedure_app2498_175_cfa_procedure(obj_t, obj_t);
static obj_t arg21942510_cfa_procedure(obj_t, obj_t);
extern obj_t pre_procedure_ref_app_85_cfa_info;
extern approx_t make_type_alloc_approx_134_cfa_approx(type_t, node_t);
extern obj_t procedure_ref_app_49_cfa_info;
extern obj_t shape_tools_shape(obj_t);
extern obj_t disable_x_t__211_cfa_procedure(approx_t);
static obj_t node_key_pre_make_procedure_app2489_176_cfa_procedure(obj_t, obj_t);
extern obj_t _node_key_set__44_cfa_approx(obj_t, obj_t, obj_t);
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_t);
extern approx_t make_type_approx_184_cfa_approx(type_t);
extern obj_t stack___129_cfa_stack(obj_t);
static obj_t loose_alloc__make_procedure_app2491_196_cfa_procedure(obj_t, obj_t);
extern obj_t _stack__205_cfa_stack(obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern node_t node_heap__stack__239_cfa_stack(app_t, bool_t);
extern obj_t approx_set_top__187_cfa_approx(approx_t);
extern obj_t add_make_procedure__219_cfa_closure(node_t);
extern obj_t add_procedure_ref__36_cfa_closure(node_t);
static obj_t cfa__procedure_set__app2492_59_cfa_procedure(obj_t, obj_t);
static obj_t node_key_set__pre_make_procedure_app2488_126_cfa_procedure(obj_t, obj_t, obj_t);
static obj_t arg20992493_cfa_procedure(obj_t, obj_t);
extern obj_t __obj__252_type_cache;
static obj_t __cnst[3];

extern obj_t cfa__env_153_cfa_cfa;
extern obj_t stack__env_104_cfa_stack;
DEFINE_STATIC_PROCEDURE(proc2515_cfa_procedure, cfa__make_procedure_app2498_175_cfa_procedure2551, cfa__make_procedure_app2498_175_cfa_procedure, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2522_cfa_procedure, node_key_make_procedure_app2487_10_cfa_procedure2552, node_key_make_procedure_app2487_10_cfa_procedure, 0L, 1);
DEFINE_EXPORT_PROCEDURE(disable_x_t__env_219_cfa_procedure, _disable_x_t__100_cfa_procedure2553, _disable_x_t__100_cfa_procedure, 0L, 1);
DEFINE_STRING(string2540_cfa_procedure, string2540_cfa_procedure2554, "Je set un pre-clo-env...", 24);
DEFINE_STRING(string2525_cfa_procedure, string2525_cfa_procedure2555, " owner: ", 8);
DEFINE_STRING(string2534_cfa_procedure, string2534_cfa_procedure2556, " procedure-ref: ", 16);
DEFINE_STRING(string2528_cfa_procedure, string2528_cfa_procedure2557, " *** loose-alloc::make-procedure-app: ", 38);
DEFINE_STRING(string2543_cfa_procedure, string2543_cfa_procedure2558, " cowner: ", 9);
DEFINE_STRING(string2526_cfa_procedure, string2526_cfa_procedure2559, " ", 1);
DEFINE_STRING(string2535_cfa_procedure, string2535_cfa_procedure2560, "  <- ", 5);
DEFINE_STRING(string2531_cfa_procedure, string2531_cfa_procedure2561, "         offset: ", 17);
DEFINE_STRING(string2538_cfa_procedure, string2538_cfa_procedure2562, "          proc-size: ", 21);
DEFINE_STATIC_PROCEDURE(proc2516_cfa_procedure, cfa__procedure_ref_app2495_149_cfa_procedure2563, cfa__procedure_ref_app2495_149_cfa_procedure, 0L, 1);
extern obj_t node_key_set__env_57_cfa_approx;
DEFINE_STATIC_PROCEDURE(proc2523_cfa_procedure, stack__make_procedure_app2486_134_cfa_procedure2564, stack__make_procedure_app2486_134_cfa_procedure, 0L, 1);
extern obj_t node_key_env_229_cfa_approx;
DEFINE_STATIC_PROCEDURE(proc2512_cfa_procedure, node_setup__pre_make_procedure_app2501_89_cfa_procedure2565, node_setup__pre_make_procedure_app2501_89_cfa_procedure, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2513_cfa_procedure, node_setup__pre_procedure_ref_app2500_215_cfa_procedure2566, node_setup__pre_procedure_ref_app2500_215_cfa_procedure, 0L, 1);
DEFINE_STRING(string2527_cfa_procedure, string2527_cfa_procedure2567, " *** stack-loose::make-procedure-app: ", 38);
DEFINE_STRING(string2537_cfa_procedure, string2537_cfa_procedure2568, "                key: ", 21);
DEFINE_STRING(string2536_cfa_procedure, string2536_cfa_procedure2569, "make-procedure-app(je set l'env): (union ", 41);
DEFINE_STATIC_PROCEDURE(proc2541_cfa_procedure, arg21942510_cfa_procedure2570, arg21942510_cfa_procedure, 0L, 1);
DEFINE_STRING(string2524_cfa_procedure, string2524_cfa_procedure2571, "stack(make-procedure-app): s?: ", 31);
DEFINE_STRING(string2530_cfa_procedure, string2530_cfa_procedure2572, "         val-ap: ", 17);
DEFINE_STATIC_PROCEDURE(proc2521_cfa_procedure, node_key_set__pre_make_procedure_app2488_126_cfa_procedure2573, node_key_set__pre_make_procedure_app2488_126_cfa_procedure, 0L, 2);
extern obj_t node_setup__env_214_cfa_setup;
DEFINE_STRING(string2542_cfa_procedure, string2542_cfa_procedure2574, "!!! Je disable X-T pour: ", 25);
DEFINE_STATIC_PROCEDURE(proc2520_cfa_procedure, node_key_pre_make_procedure_app2489_176_cfa_procedure2575, node_key_pre_make_procedure_app2489_176_cfa_procedure, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2517_cfa_procedure, cfa__procedure_set__app2492_59_cfa_procedure2576, cfa__procedure_set__app2492_59_cfa_procedure, 0L, 1);
DEFINE_STRING(string2533_cfa_procedure, string2533_cfa_procedure2577, "        offset: ", 16);
DEFINE_STRING(string2529_cfa_procedure, string2529_cfa_procedure2578, " *** loose: ", 12);
extern obj_t loose_alloc__env_83_cfa_loose;
DEFINE_STRING(string2532_cfa_procedure, string2532_cfa_procedure2579, " procedure-set!: ", 17);
DEFINE_STATIC_PROCEDURE(proc2514_cfa_procedure, node_setup__pre_procedure_set__app2499_226_cfa_procedure2580, node_setup__pre_procedure_set__app2499_226_cfa_procedure, 0L, 1);
DEFINE_STRING(string2539_cfa_procedure, string2539_cfa_procedure2581, " make-procedure-app: ", 21);
extern obj_t stack_loose_alloc__env_147_cfa_loose;
DEFINE_STRING(string2544_cfa_procedure, string2544_cfa_procedure2582, " *** stack-loose-procedure-env: ", 32);
DEFINE_STATIC_PROCEDURE(proc2519_cfa_procedure, stack_loose_alloc__make_procedure_app2490_61_cfa_procedure2583, stack_loose_alloc__make_procedure_app2490_61_cfa_procedure, 0L, 2);
DEFINE_STRING(string2545_cfa_procedure, string2545_cfa_procedure2584, "DONE ALL CFA ", 13);
DEFINE_STATIC_PROCEDURE(proc2518_cfa_procedure, loose_alloc__make_procedure_app2491_196_cfa_procedure2585, loose_alloc__make_procedure_app2491_196_cfa_procedure, 0L, 1);

obj_t 
module_initialization_70_cfa_procedure(long checksum_3814, char *from_3815)
{
   if (CBOOL(require_initialization_114_cfa_procedure))
     {
	require_initialization_114_cfa_procedure = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_procedure();
	cnst_init_137_cfa_procedure();
	imported_modules_init_94_cfa_procedure();
	toplevel_init_63_cfa_procedure();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_procedure()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_PROCEDURE");
   module_initialization_70___object(((long) 0), "CFA_PROCEDURE");
   module_initialization_70___reader(((long) 0), "CFA_PROCEDURE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_procedure()
{
   {
      obj_t cnst_port_138_3806;
      cnst_port_138_3806 = open_input_string(string2545_cfa_procedure);
      {
	 long i_3807;
	 i_3807 = ((long) 2);
       loop_3808:
	 {
	    bool_t test2546_3809;
	    test2546_3809 = (i_3807 == ((long) -1));
	    if (test2546_3809)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2547_3810;
		    {
		       obj_t list2548_3811;
		       {
			  obj_t arg2549_3812;
			  arg2549_3812 = BNIL;
			  list2548_3811 = MAKE_PAIR(cnst_port_138_3806, arg2549_3812);
		       }
		       arg2547_3810 = read___reader(list2548_3811);
		    }
		    CNST_TABLE_SET(i_3807, arg2547_3810);
		 }
		 {
		    int aux_3813;
		    {
		       long aux_3832;
		       aux_3832 = (i_3807 - ((long) 1));
		       aux_3813 = (int) (aux_3832);
		    }
		    {
		       long i_3835;
		       i_3835 = (long) (aux_3813);
		       i_3807 = i_3835;
		       goto loop_3808;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_procedure()
{
   {
      obj_t node_setup__pre_make_procedure_app_207_3732;
      node_setup__pre_make_procedure_app_207_3732 = proc2512_cfa_procedure;
      add_method__1___object(node_setup__env_214_cfa_setup, pre_make_procedure_app_60_cfa_info, node_setup__pre_make_procedure_app_207_3732);
   }
   {
      obj_t node_setup__pre_procedure_ref_app_179_3731;
      node_setup__pre_procedure_ref_app_179_3731 = proc2513_cfa_procedure;
      add_method__1___object(node_setup__env_214_cfa_setup, pre_procedure_ref_app_85_cfa_info, node_setup__pre_procedure_ref_app_179_3731);
   }
   {
      obj_t node_setup__pre_procedure_set__app_200_3730;
      node_setup__pre_procedure_set__app_200_3730 = proc2514_cfa_procedure;
      add_method__1___object(node_setup__env_214_cfa_setup, pre_procedure_set__app_208_cfa_info, node_setup__pre_procedure_set__app_200_3730);
   }
   {
      obj_t cfa__make_procedure_app_58_3729;
      cfa__make_procedure_app_58_3729 = proc2515_cfa_procedure;
      add_method__1___object(cfa__env_153_cfa_cfa, make_procedure_app_48_cfa_info, cfa__make_procedure_app_58_3729);
   }
   {
      obj_t cfa__procedure_ref_app_118_3728;
      cfa__procedure_ref_app_118_3728 = proc2516_cfa_procedure;
      add_method__1___object(cfa__env_153_cfa_cfa, procedure_ref_app_49_cfa_info, cfa__procedure_ref_app_118_3728);
   }
   {
      obj_t cfa__procedure_set__app_197_3725;
      cfa__procedure_set__app_197_3725 = proc2517_cfa_procedure;
      add_method__1___object(cfa__env_153_cfa_cfa, procedure_set__app_32_cfa_info, cfa__procedure_set__app_197_3725);
   }
   {
      obj_t loose_alloc__make_procedure_app_211_3722;
      loose_alloc__make_procedure_app_211_3722 = proc2518_cfa_procedure;
      add_method__1___object(loose_alloc__env_83_cfa_loose, make_procedure_app_48_cfa_info, loose_alloc__make_procedure_app_211_3722);
   }
   {
      obj_t stack_loose_alloc__make_procedure_app_108_3721;
      stack_loose_alloc__make_procedure_app_108_3721 = proc2519_cfa_procedure;
      add_method__1___object(stack_loose_alloc__env_147_cfa_loose, make_procedure_app_48_cfa_info, stack_loose_alloc__make_procedure_app_108_3721);
   }
   {
      obj_t node_key_pre_make_procedure_app_196_3720;
      node_key_pre_make_procedure_app_196_3720 = proc2520_cfa_procedure;
      add_method__1___object(node_key_env_229_cfa_approx, pre_make_procedure_app_60_cfa_info, node_key_pre_make_procedure_app_196_3720);
   }
   {
      obj_t node_key_set__pre_make_procedure_app_149_3719;
      node_key_set__pre_make_procedure_app_149_3719 = proc2521_cfa_procedure;
      add_method__1___object(node_key_set__env_57_cfa_approx, pre_make_procedure_app_60_cfa_info, node_key_set__pre_make_procedure_app_149_3719);
   }
   {
      obj_t node_key_make_procedure_app_66_3718;
      node_key_make_procedure_app_66_3718 = proc2522_cfa_procedure;
      add_method__1___object(node_key_env_229_cfa_approx, make_procedure_app_48_cfa_info, node_key_make_procedure_app_66_3718);
   }
   {
      obj_t stack__make_procedure_app_154_3717;
      stack__make_procedure_app_154_3717 = proc2523_cfa_procedure;
      return add_method__1___object(stack__env_104_cfa_stack, make_procedure_app_48_cfa_info, stack__make_procedure_app_154_3717);
   }
}


obj_t 
stack__make_procedure_app2486_134_cfa_procedure(obj_t env_3735, obj_t node_3736)
{
   {
      make_procedure_app_48_t node_2297;
      {
	 node_t aux_3849;
	 node_2297 = (make_procedure_app_48_t) (node_3736);
	 {
	    bool_t test2180_2301;
	    {
	       obj_t aux_3850;
	       aux_3850 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	       test2180_2301 = CBOOL(aux_3850);
	    }
	    if (test2180_2301)
	      {
		 bool_t arg2182_2303;
		 {
		    obj_t aux_3856;
		    {
		       object_t aux_3857;
		       aux_3857 = (object_t) (node_2297);
		       aux_3856 = OBJECT_WIDENING(aux_3857);
		    }
		    arg2182_2303 = (((make_procedure_app_48_t) CREF(aux_3856))->stackable__42);
		 }
		 {
		    obj_t list2183_2304;
		    {
		       obj_t arg2184_2305;
		       {
			  obj_t arg2185_2306;
			  {
			     obj_t aux_3861;
			     aux_3861 = BCHAR(((unsigned char) '\n'));
			     arg2185_2306 = MAKE_PAIR(aux_3861, BNIL);
			  }
			  {
			     obj_t aux_3864;
			     aux_3864 = BBOOL(arg2182_2303);
			     arg2184_2305 = MAKE_PAIR(aux_3864, arg2185_2306);
			  }
		       }
		       list2183_2304 = MAKE_PAIR(string2524_cfa_procedure, arg2184_2305);
		    }
		    print_trace_107_tools_trace(list2183_2304);
		 }
	      }
	    else
	      {
		 BUNSPEC;
	      }
	 }
	 {
	    obj_t aux_3869;
	    {
	       app_t obj_3355;
	       obj_3355 = (app_t) (node_2297);
	       aux_3869 = (((app_t) CREF(obj_3355))->args);
	    }
	    stack___129_cfa_stack(aux_3869);
	 }
	 {
	    bool_t aux_3873;
	    {
	       bool_t test_3875;
	       {
		  long aux_3876;
		  {
		     obj_t aux_3877;
		     {
			object_t aux_3878;
			aux_3878 = (object_t) (node_2297);
			aux_3877 = OBJECT_WIDENING(aux_3878);
		     }
		     aux_3876 = (((make_procedure_app_48_t) CREF(aux_3877))->lost_stamp_114);
		  }
		  test_3875 = (aux_3876 == ((long) -1));
	       }
	       if (test_3875)
		 {
		    obj_t aux_3883;
		    {
		       object_t aux_3884;
		       aux_3884 = (object_t) (node_2297);
		       aux_3883 = OBJECT_WIDENING(aux_3884);
		    }
		    aux_3873 = (((make_procedure_app_48_t) CREF(aux_3883))->stackable__42);
		 }
	       else
		 {
		    aux_3873 = ((bool_t) 0);
		 }
	    }
	    aux_3849 = node_heap__stack__239_cfa_stack((app_t) (node_2297), aux_3873);
	 }
	 return (obj_t) (aux_3849);
      }
   }
}


obj_t 
node_key_make_procedure_app2487_10_cfa_procedure(obj_t env_3737, obj_t app_3738)
{
   {
      make_procedure_app_48_t app_2291;
      app_2291 = (make_procedure_app_48_t) (app_3738);
      {
	 obj_t aux_3891;
	 {
	    object_t aux_3892;
	    aux_3892 = (object_t) (app_2291);
	    aux_3891 = OBJECT_WIDENING(aux_3892);
	 }
	 return (((make_procedure_app_48_t) CREF(aux_3891))->key);
      }
   }
}


obj_t 
node_key_set__pre_make_procedure_app2488_126_cfa_procedure(obj_t env_3739, obj_t app_3740, obj_t new_key_72_3741)
{
   {
      pre_make_procedure_app_60_t app_2284;
      obj_t new_key_72_2285;
      app_2284 = (pre_make_procedure_app_60_t) (app_3740);
      new_key_72_2285 = new_key_72_3741;
      {
	 obj_t res2483_3351;
	 {
	    obj_t x_3798;
	    {
	       obj_t aux_3897;
	       {
		  object_t aux_3898;
		  aux_3898 = (object_t) (app_2284);
		  aux_3897 = OBJECT_WIDENING(aux_3898);
	       }
	       x_3798 = ((((pre_make_procedure_app_60_t) CREF(aux_3897))->key) = ((obj_t) new_key_72_2285), BUNSPEC);
	    }
	    res2483_3351 = BUNSPEC;
	 }
	 return res2483_3351;
      }
   }
}


obj_t 
node_key_pre_make_procedure_app2489_176_cfa_procedure(obj_t env_3742, obj_t app_3743)
{
   {
      pre_make_procedure_app_60_t app_2278;
      app_2278 = (pre_make_procedure_app_60_t) (app_3743);
      {
	 obj_t aux_3903;
	 {
	    object_t aux_3904;
	    aux_3904 = (object_t) (app_2278);
	    aux_3903 = OBJECT_WIDENING(aux_3904);
	 }
	 return (((pre_make_procedure_app_60_t) CREF(aux_3903))->key);
      }
   }
}


obj_t 
stack_loose_alloc__make_procedure_app2490_61_cfa_procedure(obj_t env_3744, obj_t alloc_3745, obj_t cowner_3746)
{
   {
      make_procedure_app_48_t alloc_2241;
      obj_t cowner_2242;
      alloc_2241 = (make_procedure_app_48_t) (alloc_3745);
      cowner_2242 = cowner_3746;
      {
	 bool_t test2145_2246;
	 {
	    obj_t aux_3909;
	    aux_3909 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
	    test2145_2246 = CBOOL(aux_3909);
	 }
	 if (test2145_2246)
	   {
	      obj_t arg2149_2249;
	      obj_t arg2151_2251;
	      arg2149_2249 = shape_tools_shape((obj_t) (alloc_2241));
	      {
		 obj_t aux_3917;
		 {
		    variable_t aux_3918;
		    {
		       obj_t aux_3919;
		       {
			  object_t aux_3920;
			  aux_3920 = (object_t) (alloc_2241);
			  aux_3919 = OBJECT_WIDENING(aux_3920);
		       }
		       aux_3918 = (((make_procedure_app_48_t) CREF(aux_3919))->owner);
		    }
		    aux_3917 = (obj_t) (aux_3918);
		 }
		 arg2151_2251 = shape_tools_shape(aux_3917);
	      }
	      {
		 obj_t list2152_2252;
		 {
		    obj_t arg2153_2253;
		    {
		       obj_t arg2154_2254;
		       {
			  obj_t arg2155_2255;
			  {
			     obj_t arg2156_2256;
			     {
				obj_t arg2160_2257;
				{
				   obj_t arg2161_2258;
				   {
				      obj_t aux_3926;
				      aux_3926 = BCHAR(((unsigned char) '\n'));
				      arg2161_2258 = MAKE_PAIR(aux_3926, BNIL);
				   }
				   arg2160_2257 = MAKE_PAIR(arg2151_2251, arg2161_2258);
				}
				arg2156_2256 = MAKE_PAIR(string2525_cfa_procedure, arg2160_2257);
			     }
			     arg2155_2255 = MAKE_PAIR(arg2149_2249, arg2156_2256);
			  }
			  arg2154_2254 = MAKE_PAIR(string2526_cfa_procedure, arg2155_2255);
		       }
		       arg2153_2253 = MAKE_PAIR(__cfa_stamp__16_cfa_iterate, arg2154_2254);
		    }
		    list2152_2252 = MAKE_PAIR(string2527_cfa_procedure, arg2153_2253);
		 }
		 print_trace_107_tools_trace(list2152_2252);
	      }
	   }
	 else
	   {
	      BUNSPEC;
	   }
      }
      {
	 bool_t test_3936;
	 {
	    bool_t test_3937;
	    {
	       obj_t aux_3938;
	       {
		  object_t aux_3939;
		  aux_3939 = (object_t) (alloc_2241);
		  aux_3938 = OBJECT_WIDENING(aux_3939);
	       }
	       test_3937 = (((make_procedure_app_48_t) CREF(aux_3938))->stackable__42);
	    }
	    if (test_3937)
	      {
		 obj_t aux_3943;
		 {
		    obj_t aux_3944;
		    {
		       obj_t aux_3945;
		       {
			  object_t aux_3946;
			  aux_3946 = (object_t) (alloc_2241);
			  aux_3945 = OBJECT_WIDENING(aux_3946);
		       }
		       aux_3944 = (((make_procedure_app_48_t) CREF(aux_3945))->stack_stamp_31);
		    }
		    aux_3943 = memq___r4_pairs_and_lists_6_3(cowner_2242, aux_3944);
		 }
		 test_3936 = CBOOL(aux_3943);
	      }
	    else
	      {
		 test_3936 = ((bool_t) 1);
	      }
	 }
	 if (test_3936)
	   {
	      return BUNSPEC;
	   }
	 else
	   {
	      {
		 obj_t arg2167_2264;
		 {
		    obj_t aux_3952;
		    {
		       obj_t aux_3953;
		       {
			  object_t aux_3954;
			  aux_3954 = (object_t) (alloc_2241);
			  aux_3953 = OBJECT_WIDENING(aux_3954);
		       }
		       aux_3952 = (((make_procedure_app_48_t) CREF(aux_3953))->stack_stamp_31);
		    }
		    arg2167_2264 = MAKE_PAIR(cowner_2242, aux_3952);
		 }
		 {
		    obj_t res2481_3334;
		    {
		       obj_t x_3799;
		       {
			  obj_t aux_3959;
			  {
			     object_t aux_3960;
			     aux_3960 = (object_t) (alloc_2241);
			     aux_3959 = OBJECT_WIDENING(aux_3960);
			  }
			  x_3799 = ((((make_procedure_app_48_t) CREF(aux_3959))->stack_stamp_31) = ((obj_t) arg2167_2264), BUNSPEC);
		       }
		       res2481_3334 = BUNSPEC;
		    }
		    res2481_3334;
		 }
	      }
	      {
		 bool_t test2169_2266;
		 {
		    bool_t test2171_2268;
		    test2171_2268 = is_a__118___object(cowner_2242, variable_ast_var);
		    if (test2171_2268)
		      {
			 obj_t aux_3966;
			 {
			    variable_t aux_3967;
			    {
			       obj_t aux_3968;
			       {
				  object_t aux_3969;
				  aux_3969 = (object_t) (alloc_2241);
				  aux_3968 = OBJECT_WIDENING(aux_3969);
			       }
			       aux_3967 = (((make_procedure_app_48_t) CREF(aux_3968))->owner);
			    }
			    aux_3966 = (obj_t) (aux_3967);
			 }
			 test2169_2266 = (aux_3966 == cowner_2242);
		      }
		    else
		      {
			 test2169_2266 = ((bool_t) 1);
		      }
		 }
		 if (test2169_2266)
		   {
		      {
			 obj_t res2482_3341;
			 {
			    obj_t x_3800;
			    {
			       obj_t aux_3976;
			       {
				  object_t aux_3977;
				  aux_3977 = (object_t) (alloc_2241);
				  aux_3976 = OBJECT_WIDENING(aux_3977);
			       }
			       x_3800 = ((((make_procedure_app_48_t) CREF(aux_3976))->stackable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			    }
			    res2482_3341 = BUNSPEC;
			 }
			 res2482_3341;
		      }
		      stack_loose_procedure_env__187_cfa_procedure(alloc_2241, CNST_TABLE_REF(((long) 1)));
		   }
		 else
		   {
		      stack_loose_procedure_env__187_cfa_procedure(alloc_2241, cowner_2242);
		   }
	      }
	      {
		 variable_t v_2271;
		 {
		    var_t obj_3344;
		    {
		       obj_t aux_3984;
		       {
			  obj_t aux_3985;
			  {
			     app_t obj_3342;
			     obj_3342 = (app_t) (alloc_2241);
			     aux_3985 = (((app_t) CREF(obj_3342))->args);
			  }
			  aux_3984 = CAR(aux_3985);
		       }
		       obj_3344 = (var_t) (aux_3984);
		    }
		    v_2271 = (((var_t) CREF(obj_3344))->variable);
		 }
		 {
		    return cfa_export_var__93_cfa_iterate((((variable_t) CREF(v_2271))->value), cowner_2242);
		 }
	      }
	   }
      }
   }
}


obj_t 
loose_alloc__make_procedure_app2491_196_cfa_procedure(obj_t env_3747, obj_t alloc_3748)
{
   {
      make_procedure_app_48_t alloc_2208;
      alloc_2208 = (make_procedure_app_48_t) (alloc_3748);
      {
	 bool_t test2119_2211;
	 {
	    obj_t aux_3994;
	    aux_3994 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
	    test2119_2211 = CBOOL(aux_3994);
	 }
	 if (test2119_2211)
	   {
	      obj_t arg2122_2214;
	      arg2122_2214 = shape_tools_shape((obj_t) (alloc_2208));
	      {
		 obj_t list2123_2215;
		 {
		    obj_t arg2124_2216;
		    {
		       obj_t arg2125_2217;
		       {
			  obj_t arg2126_2218;
			  {
			     obj_t arg2127_2219;
			     {
				obj_t aux_4002;
				aux_4002 = BCHAR(((unsigned char) '\n'));
				arg2127_2219 = MAKE_PAIR(aux_4002, BNIL);
			     }
			     arg2126_2218 = MAKE_PAIR(arg2122_2214, arg2127_2219);
			  }
			  arg2125_2217 = MAKE_PAIR(string2526_cfa_procedure, arg2126_2218);
		       }
		       arg2124_2216 = MAKE_PAIR(__cfa_stamp__16_cfa_iterate, arg2125_2217);
		    }
		    list2123_2215 = MAKE_PAIR(string2528_cfa_procedure, arg2124_2216);
		 }
		 print_trace_107_tools_trace(list2123_2215);
	      }
	   }
	 else
	   {
	      BUNSPEC;
	   }
      }
      {
	 bool_t test2131_2224;
	 {
	    long arg2143_2238;
	    {
	       obj_t aux_4010;
	       {
		  object_t aux_4011;
		  aux_4011 = (object_t) (alloc_2208);
		  aux_4010 = OBJECT_WIDENING(aux_4011);
	       }
	       arg2143_2238 = (((make_procedure_app_48_t) CREF(aux_4010))->lost_stamp_114);
	    }
	    {
	       long n2_3318;
	       n2_3318 = (long) CINT(__cfa_stamp__16_cfa_iterate);
	       test2131_2224 = (arg2143_2238 == n2_3318);
	    }
	 }
	 if (test2131_2224)
	   {
	      return BUNSPEC;
	   }
	 else
	   {
	      {
		 bool_t test2132_2225;
		 {
		    obj_t aux_4018;
		    aux_4018 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
		    test2132_2225 = CBOOL(aux_4018);
		 }
		 if (test2132_2225)
		   {
		      obj_t arg2134_2227;
		      arg2134_2227 = shape_tools_shape((obj_t) (alloc_2208));
		      {
			 obj_t list2135_2228;
			 {
			    obj_t arg2136_2229;
			    {
			       obj_t arg2137_2230;
			       {
				  obj_t aux_4026;
				  aux_4026 = BCHAR(((unsigned char) '\n'));
				  arg2137_2230 = MAKE_PAIR(aux_4026, BNIL);
			       }
			       arg2136_2229 = MAKE_PAIR(arg2134_2227, arg2137_2230);
			    }
			    list2135_2228 = MAKE_PAIR(string2529_cfa_procedure, arg2136_2229);
			 }
			 print_trace_107_tools_trace(list2135_2228);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	      {
		 obj_t res2480_3321;
		 {
		    long val1666_3320;
		    val1666_3320 = (long) CINT(__cfa_stamp__16_cfa_iterate);
		    {
		       obj_t x_3801;
		       {
			  obj_t aux_4033;
			  {
			     object_t aux_4034;
			     aux_4034 = (object_t) (alloc_2208);
			     aux_4033 = OBJECT_WIDENING(aux_4034);
			  }
			  x_3801 = ((((make_procedure_app_48_t) CREF(aux_4033))->lost_stamp_114) = ((long) val1666_3320), BUNSPEC);
		       }
		       res2480_3321 = BUNSPEC;
		    }
		 }
		 res2480_3321;
	      }
	      {
		 variable_t v_2235;
		 {
		    var_t obj_3324;
		    {
		       obj_t aux_4038;
		       {
			  obj_t aux_4039;
			  {
			     app_t obj_3322;
			     obj_3322 = (app_t) (alloc_2208);
			     aux_4039 = (((app_t) CREF(obj_3322))->args);
			  }
			  aux_4038 = CAR(aux_4039);
		       }
		       obj_3324 = (var_t) (aux_4038);
		    }
		    v_2235 = (((var_t) CREF(obj_3324))->variable);
		 }
		 {
		    return cfa_export_var__93_cfa_iterate((((variable_t) CREF(v_2235))->value), (obj_t) (v_2235));
		 }
	      }
	   }
      }
   }
}


obj_t 
cfa__procedure_set__app2492_59_cfa_procedure(obj_t env_3749, obj_t node_3750)
{
   {
      procedure_set__app_32_t node_2151;
      {
	 approx_t aux_4049;
	 node_2151 = (procedure_set__app_32_t) (node_3750);
	 {
	    node_t aux_4050;
	    {
	       obj_t aux_4051;
	       {
		  obj_t aux_4052;
		  {
		     obj_t aux_4053;
		     {
			app_t obj_3280;
			obj_3280 = (app_t) (node_2151);
			aux_4053 = (((app_t) CREF(obj_3280))->args);
		     }
		     aux_4052 = CDR(aux_4053);
		  }
		  aux_4051 = CAR(aux_4052);
	       }
	       aux_4050 = (node_t) (aux_4051);
	    }
	    cfa__102_cfa_cfa(aux_4050);
	 }
	 {
	    approx_t proc_approx_11_2157;
	    obj_t offset_2158;
	    approx_t val_approx_22_2159;
	    {
	       node_t aux_4060;
	       {
		  obj_t aux_4061;
		  {
		     obj_t aux_4062;
		     {
			app_t obj_3285;
			obj_3285 = (app_t) (node_2151);
			aux_4062 = (((app_t) CREF(obj_3285))->args);
		     }
		     aux_4061 = CAR(aux_4062);
		  }
		  aux_4060 = (node_t) (aux_4061);
	       }
	       proc_approx_11_2157 = cfa__102_cfa_cfa(aux_4060);
	    }
	    {
	       node_t aux_4068;
	       {
		  obj_t aux_4069;
		  {
		     obj_t aux_4070;
		     {
			obj_t aux_4071;
			{
			   app_t obj_3287;
			   obj_3287 = (app_t) (node_2151);
			   aux_4071 = (((app_t) CREF(obj_3287))->args);
			}
			aux_4070 = CDR(aux_4071);
		     }
		     aux_4069 = CAR(aux_4070);
		  }
		  aux_4068 = (node_t) (aux_4069);
	       }
	       offset_2158 = get_node_atom_value_135_cfa_approx(aux_4068);
	    }
	    {
	       node_t aux_4078;
	       {
		  obj_t aux_4079;
		  {
		     obj_t aux_4080;
		     {
			obj_t aux_4081;
			{
			   obj_t aux_4082;
			   {
			      app_t obj_3292;
			      obj_3292 = (app_t) (node_2151);
			      aux_4082 = (((app_t) CREF(obj_3292))->args);
			   }
			   aux_4081 = CDR(aux_4082);
			}
			aux_4080 = CDR(aux_4081);
		     }
		     aux_4079 = CAR(aux_4080);
		  }
		  aux_4078 = (node_t) (aux_4079);
	       }
	       val_approx_22_2159 = cfa__102_cfa_cfa(aux_4078);
	    }
	    {
	       bool_t test2073_2160;
	       {
		  obj_t aux_4090;
		  aux_4090 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
		  test2073_2160 = CBOOL(aux_4090);
	       }
	       if (test2073_2160)
		 {
		    obj_t arg2076_2162;
		    obj_t arg2079_2165;
		    arg2076_2162 = shape_tools_shape((obj_t) (node_2151));
		    arg2079_2165 = shape_tools_shape((obj_t) (val_approx_22_2159));
		    {
		       obj_t list2080_2166;
		       {
			  obj_t arg2081_2167;
			  {
			     obj_t arg2083_2168;
			     {
				obj_t arg2084_2169;
				{
				   obj_t arg2085_2170;
				   {
				      obj_t arg2086_2171;
				      {
					 obj_t arg2087_2172;
					 {
					    obj_t arg2088_2173;
					    {
					       obj_t arg2089_2174;
					       {
						  obj_t aux_4100;
						  aux_4100 = BCHAR(((unsigned char) '\n'));
						  arg2089_2174 = MAKE_PAIR(aux_4100, BNIL);
					       }
					       arg2088_2173 = MAKE_PAIR(arg2079_2165, arg2089_2174);
					    }
					    arg2087_2172 = MAKE_PAIR(string2530_cfa_procedure, arg2088_2173);
					 }
					 {
					    obj_t aux_4105;
					    aux_4105 = BCHAR(((unsigned char) '\n'));
					    arg2086_2171 = MAKE_PAIR(aux_4105, arg2087_2172);
					 }
				      }
				      arg2085_2170 = MAKE_PAIR(offset_2158, arg2086_2171);
				   }
				   arg2084_2169 = MAKE_PAIR(string2531_cfa_procedure, arg2085_2170);
				}
				{
				   obj_t aux_4110;
				   aux_4110 = BCHAR(((unsigned char) '\n'));
				   arg2083_2168 = MAKE_PAIR(aux_4110, arg2084_2169);
				}
			     }
			     arg2081_2167 = MAKE_PAIR(arg2076_2162, arg2083_2168);
			  }
			  list2080_2166 = MAKE_PAIR(string2532_cfa_procedure, arg2081_2167);
		       }
		       print_trace_107_tools_trace(list2080_2166);
		    }
		 }
	       else
		 {
		    BUNSPEC;
		 }
	    }
	    if ((((approx_t) CREF(proc_approx_11_2157))->top__138))
	      {
		 approx_t aux_4118;
		 aux_4118 = loose__226_cfa_loose(val_approx_22_2159, CNST_TABLE_REF(((long) 1)));
		 (obj_t) (aux_4118);
	      }
	    else
	      {
		 if (INTEGERP(offset_2158))
		   {
		      obj_t arg2099_3723;
		      arg2099_3723 = make_fx_procedure(arg20992493_cfa_procedure, ((long) 1), ((long) 2));
		      PROCEDURE_SET(arg2099_3723, ((long) 0), offset_2158);
		      {
			 obj_t aux_4126;
			 aux_4126 = (obj_t) (val_approx_22_2159);
			 PROCEDURE_SET(arg2099_3723, ((long) 1), aux_4126);
		      }
		      for_each_approx_alloc_83_cfa_approx(arg2099_3723, proc_approx_11_2157);
		   }
		 else
		   {
		      obj_t arg2105_3724;
		      arg2105_3724 = make_fx_procedure(arg21052494_cfa_procedure, ((long) 1), ((long) 1));
		      {
			 obj_t aux_4131;
			 aux_4131 = (obj_t) (val_approx_22_2159);
			 PROCEDURE_SET(arg2105_3724, ((long) 0), aux_4131);
		      }
		      for_each_approx_alloc_83_cfa_approx(arg2105_3724, proc_approx_11_2157);
		   }
	      }
	    {
	       obj_t aux_4135;
	       {
		  object_t aux_4136;
		  aux_4136 = (object_t) (node_2151);
		  aux_4135 = OBJECT_WIDENING(aux_4136);
	       }
	       aux_4049 = (((procedure_set__app_32_t) CREF(aux_4135))->approx);
	    }
	 }
	 return (obj_t) (aux_4049);
      }
   }
}


obj_t 
arg20992493_cfa_procedure(obj_t env_3751, obj_t app_3754)
{
   {
      obj_t offset_3752;
      obj_t val_approx_22_3753;
      offset_3752 = PROCEDURE_REF(env_3751, ((long) 0));
      val_approx_22_3753 = PROCEDURE_REF(env_3751, ((long) 1));
      {
	 obj_t app_2182;
	 app_2182 = app_3754;
	 {
	    bool_t test2101_2184;
	    {
	       bool_t test2103_2186;
	       test2103_2186 = is_a__118___object(app_2182, make_procedure_app_48_cfa_info);
	       if (test2103_2186)
		 {
		    long aux_4148;
		    long aux_4146;
		    {
		       make_procedure_app_48_t obj_3302;
		       obj_3302 = (make_procedure_app_48_t) (app_2182);
		       {
			  obj_t aux_4150;
			  {
			     object_t aux_4151;
			     aux_4151 = (object_t) (obj_3302);
			     aux_4150 = OBJECT_WIDENING(aux_4151);
			  }
			  aux_4148 = (((make_procedure_app_48_t) CREF(aux_4150))->values_approx_len_106);
		       }
		    }
		    aux_4146 = (long) CINT(offset_3752);
		    test2101_2184 = (aux_4146 < aux_4148);
		 }
	       else
		 {
		    test2101_2184 = ((bool_t) 0);
		 }
	    }
	    if (test2101_2184)
	      {
		 approx_t aux_4157;
		 {
		    approx_t aux_4158;
		    {
		       make_procedure_app_48_t obj_3305;
		       long index_3306;
		       obj_3305 = (make_procedure_app_48_t) (app_2182);
		       index_3306 = (long) CINT(offset_3752);
		       {
			  obj_t aux_4161;
			  {
			     object_t aux_4162;
			     aux_4162 = (object_t) (obj_3305);
			     aux_4161 = OBJECT_WIDENING(aux_4162);
			  }
			  aux_4158 = (((make_procedure_app_48_t) CREF(aux_4161))->values_approx_79)[index_3306];
		       }
		    }
		    aux_4157 = union_approx__241_cfa_approx(aux_4158, (approx_t) (val_approx_22_3753));
		 }
		 return (obj_t) (aux_4157);
	      }
	    else
	      {
		 return BUNSPEC;
	      }
	 }
      }
   }
}


obj_t 
arg21052494_cfa_procedure(obj_t env_3755, obj_t app_3757)
{
   {
      obj_t val_approx_22_3756;
      val_approx_22_3756 = PROCEDURE_REF(env_3755, ((long) 0));
      {
	 obj_t app_2190;
	 app_2190 = app_3757;
	 {
	    bool_t test2107_2192;
	    test2107_2192 = is_a__118___object(app_2190, make_procedure_app_48_cfa_info);
	    if (test2107_2192)
	      {
		 long len_2193;
		 {
		    make_procedure_app_48_t obj_3308;
		    obj_3308 = (make_procedure_app_48_t) (app_2190);
		    {
		       obj_t aux_4173;
		       {
			  object_t aux_4174;
			  aux_4174 = (object_t) (obj_3308);
			  aux_4173 = OBJECT_WIDENING(aux_4174);
		       }
		       len_2193 = (((make_procedure_app_48_t) CREF(aux_4173))->values_approx_len_106);
		    }
		 }
		 {
		    long i_2194;
		    i_2194 = ((long) 0);
		  loop_2195:
		    if ((i_2194 < len_2193))
		      {
			 {
			    approx_t aux_4180;
			    {
			       make_procedure_app_48_t obj_3311;
			       obj_3311 = (make_procedure_app_48_t) (app_2190);
			       {
				  obj_t aux_4182;
				  {
				     object_t aux_4183;
				     aux_4183 = (object_t) (obj_3311);
				     aux_4182 = OBJECT_WIDENING(aux_4183);
				  }
				  aux_4180 = (((make_procedure_app_48_t) CREF(aux_4182))->values_approx_79)[i_2194];
			       }
			    }
			    union_approx__241_cfa_approx(aux_4180, (approx_t) (val_approx_22_3756));
			 }
			 {
			    long i_4189;
			    i_4189 = (i_2194 + ((long) 1));
			    i_2194 = i_4189;
			    goto loop_2195;
			 }
		      }
		    else
		      {
			 return BUNSPEC;
		      }
		 }
	      }
	    else
	      {
		 return BUNSPEC;
	      }
	 }
      }
   }
}


obj_t 
cfa__procedure_ref_app2495_149_cfa_procedure(obj_t env_3758, obj_t node_3759)
{
   {
      procedure_ref_app_49_t node_2089;
      {
	 approx_t aux_4191;
	 node_2089 = (procedure_ref_app_49_t) (node_3759);
	 {
	    node_t aux_4192;
	    {
	       obj_t aux_4193;
	       {
		  obj_t aux_4194;
		  {
		     obj_t aux_4195;
		     {
			app_t obj_3246;
			obj_3246 = (app_t) (node_2089);
			aux_4195 = (((app_t) CREF(obj_3246))->args);
		     }
		     aux_4194 = CDR(aux_4195);
		  }
		  aux_4193 = CAR(aux_4194);
	       }
	       aux_4192 = (node_t) (aux_4193);
	    }
	    cfa__102_cfa_cfa(aux_4192);
	 }
	 {
	    approx_t proc_approx_11_2095;
	    obj_t offset_2096;
	    {
	       node_t aux_4202;
	       {
		  obj_t aux_4203;
		  {
		     obj_t aux_4204;
		     {
			app_t obj_3251;
			obj_3251 = (app_t) (node_2089);
			aux_4204 = (((app_t) CREF(obj_3251))->args);
		     }
		     aux_4203 = CAR(aux_4204);
		  }
		  aux_4202 = (node_t) (aux_4203);
	       }
	       proc_approx_11_2095 = cfa__102_cfa_cfa(aux_4202);
	    }
	    {
	       node_t aux_4210;
	       {
		  obj_t aux_4211;
		  {
		     obj_t aux_4212;
		     {
			obj_t aux_4213;
			{
			   app_t obj_3253;
			   obj_3253 = (app_t) (node_2089);
			   aux_4213 = (((app_t) CREF(obj_3253))->args);
			}
			aux_4212 = CDR(aux_4213);
		     }
		     aux_4211 = CAR(aux_4212);
		  }
		  aux_4210 = (node_t) (aux_4211);
	       }
	       offset_2096 = get_node_atom_value_135_cfa_approx(aux_4210);
	    }
	    {
	       bool_t test2017_2097;
	       {
		  obj_t aux_4220;
		  aux_4220 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
		  test2017_2097 = CBOOL(aux_4220);
	       }
	       if (test2017_2097)
		 {
		    obj_t arg2019_2099;
		    arg2019_2099 = shape_tools_shape((obj_t) (node_2089));
		    {
		       obj_t list2021_2101;
		       {
			  obj_t arg2023_2102;
			  {
			     obj_t arg2025_2103;
			     {
				obj_t arg2026_2104;
				{
				   obj_t arg2027_2105;
				   {
				      obj_t arg2028_2106;
				      {
					 obj_t aux_4228;
					 aux_4228 = BCHAR(((unsigned char) '\n'));
					 arg2028_2106 = MAKE_PAIR(aux_4228, BNIL);
				      }
				      arg2027_2105 = MAKE_PAIR(offset_2096, arg2028_2106);
				   }
				   arg2026_2104 = MAKE_PAIR(string2533_cfa_procedure, arg2027_2105);
				}
				{
				   obj_t aux_4233;
				   aux_4233 = BCHAR(((unsigned char) '\n'));
				   arg2025_2103 = MAKE_PAIR(aux_4233, arg2026_2104);
				}
			     }
			     arg2023_2102 = MAKE_PAIR(arg2019_2099, arg2025_2103);
			  }
			  list2021_2101 = MAKE_PAIR(string2534_cfa_procedure, arg2023_2102);
		       }
		       print_trace_107_tools_trace(list2021_2101);
		    }
		 }
	       else
		 {
		    BUNSPEC;
		 }
	    }
	    if ((((approx_t) CREF(proc_approx_11_2095))->top__138))
	      {
		 approx_t aux_4241;
		 {
		    obj_t aux_4242;
		    {
		       object_t aux_4243;
		       aux_4243 = (object_t) (node_2089);
		       aux_4242 = OBJECT_WIDENING(aux_4243);
		    }
		    aux_4241 = (((procedure_ref_app_49_t) CREF(aux_4242))->approx);
		 }
		 approx_set_top__187_cfa_approx(aux_4241);
	      }
	    else
	      {
		 BUNSPEC;
	      }
	    if (INTEGERP(offset_2096))
	      {
		 obj_t arg2035_3726;
		 arg2035_3726 = make_fx_procedure(arg20352496_cfa_procedure, ((long) 1), ((long) 2));
		 PROCEDURE_SET(arg2035_3726, ((long) 0), offset_2096);
		 {
		    obj_t aux_4252;
		    aux_4252 = (obj_t) (node_2089);
		    PROCEDURE_SET(arg2035_3726, ((long) 1), aux_4252);
		 }
		 for_each_approx_alloc_83_cfa_approx(arg2035_3726, proc_approx_11_2095);
	      }
	    else
	      {
		 obj_t arg2045_3727;
		 arg2045_3727 = make_fx_procedure(arg20452497_cfa_procedure, ((long) 1), ((long) 1));
		 {
		    obj_t aux_4257;
		    aux_4257 = (obj_t) (node_2089);
		    PROCEDURE_SET(arg2045_3727, ((long) 0), aux_4257);
		 }
		 for_each_approx_alloc_83_cfa_approx(arg2045_3727, proc_approx_11_2095);
	      }
	    {
	       bool_t test2053_2135;
	       {
		  obj_t aux_4261;
		  aux_4261 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
		  test2053_2135 = CBOOL(aux_4261);
	       }
	       if (test2053_2135)
		 {
		    obj_t arg2055_2137;
		    {
		       obj_t aux_4267;
		       {
			  approx_t aux_4268;
			  {
			     obj_t aux_4269;
			     {
				object_t aux_4270;
				aux_4270 = (object_t) (node_2089);
				aux_4269 = OBJECT_WIDENING(aux_4270);
			     }
			     aux_4268 = (((procedure_ref_app_49_t) CREF(aux_4269))->approx);
			  }
			  aux_4267 = (obj_t) (aux_4268);
		       }
		       arg2055_2137 = shape_tools_shape(aux_4267);
		    }
		    {
		       obj_t list2056_2138;
		       {
			  obj_t arg2057_2139;
			  {
			     obj_t arg2058_2140;
			     {
				obj_t aux_4276;
				aux_4276 = BCHAR(((unsigned char) '\n'));
				arg2058_2140 = MAKE_PAIR(aux_4276, BNIL);
			     }
			     arg2057_2139 = MAKE_PAIR(arg2055_2137, arg2058_2140);
			  }
			  list2056_2138 = MAKE_PAIR(string2535_cfa_procedure, arg2057_2139);
		       }
		       print_trace_107_tools_trace(list2056_2138);
		    }
		 }
	       else
		 {
		    BUNSPEC;
		 }
	    }
	    {
	       obj_t aux_4282;
	       {
		  object_t aux_4283;
		  aux_4283 = (object_t) (node_2089);
		  aux_4282 = OBJECT_WIDENING(aux_4283);
	       }
	       aux_4191 = (((procedure_ref_app_49_t) CREF(aux_4282))->approx);
	    }
	 }
	 return (obj_t) (aux_4191);
      }
   }
}


obj_t 
arg20352496_cfa_procedure(obj_t env_3760, obj_t app_3763)
{
   {
      obj_t offset_3761;
      obj_t instance1883_3762;
      offset_3761 = PROCEDURE_REF(env_3760, ((long) 0));
      instance1883_3762 = PROCEDURE_REF(env_3760, ((long) 1));
      {
	 obj_t app_2114;
	 app_2114 = app_3763;
	 {
	    bool_t test2037_2116;
	    {
	       bool_t test2042_2120;
	       test2042_2120 = is_a__118___object(app_2114, make_procedure_app_48_cfa_info);
	       if (test2042_2120)
		 {
		    long aux_4295;
		    long aux_4293;
		    {
		       make_procedure_app_48_t obj_3262;
		       obj_3262 = (make_procedure_app_48_t) (app_2114);
		       {
			  obj_t aux_4297;
			  {
			     object_t aux_4298;
			     aux_4298 = (object_t) (obj_3262);
			     aux_4297 = OBJECT_WIDENING(aux_4298);
			  }
			  aux_4295 = (((make_procedure_app_48_t) CREF(aux_4297))->values_approx_len_106);
		       }
		    }
		    aux_4293 = (long) CINT(offset_3761);
		    test2037_2116 = (aux_4293 < aux_4295);
		 }
	       else
		 {
		    test2037_2116 = ((bool_t) 0);
		 }
	    }
	    if (test2037_2116)
	      {
		 approx_t aux_4304;
		 {
		    approx_t aux_4312;
		    approx_t aux_4305;
		    {
		       make_procedure_app_48_t obj_3266;
		       long index_3267;
		       obj_3266 = (make_procedure_app_48_t) (app_2114);
		       index_3267 = (long) CINT(offset_3761);
		       {
			  obj_t aux_4315;
			  {
			     object_t aux_4316;
			     aux_4316 = (object_t) (obj_3266);
			     aux_4315 = OBJECT_WIDENING(aux_4316);
			  }
			  aux_4312 = (((make_procedure_app_48_t) CREF(aux_4315))->values_approx_79)[index_3267];
		       }
		    }
		    {
		       procedure_ref_app_49_t obj_3265;
		       obj_3265 = (procedure_ref_app_49_t) (instance1883_3762);
		       {
			  obj_t aux_4307;
			  {
			     object_t aux_4308;
			     aux_4308 = (object_t) (obj_3265);
			     aux_4307 = OBJECT_WIDENING(aux_4308);
			  }
			  aux_4305 = (((procedure_ref_app_49_t) CREF(aux_4307))->approx);
		       }
		    }
		    aux_4304 = union_approx__241_cfa_approx(aux_4305, aux_4312);
		 }
		 return (obj_t) (aux_4304);
	      }
	    else
	      {
		 approx_t aux_4322;
		 {
		    procedure_ref_app_49_t obj_3268;
		    obj_3268 = (procedure_ref_app_49_t) (instance1883_3762);
		    {
		       obj_t aux_4324;
		       {
			  object_t aux_4325;
			  aux_4325 = (object_t) (obj_3268);
			  aux_4324 = OBJECT_WIDENING(aux_4325);
		       }
		       aux_4322 = (((procedure_ref_app_49_t) CREF(aux_4324))->approx);
		    }
		 }
		 return approx_set_top__187_cfa_approx(aux_4322);
	      }
	 }
      }
   }
}


obj_t 
arg20452497_cfa_procedure(obj_t env_3764, obj_t app_3766)
{
   {
      obj_t instance1883_3765;
      instance1883_3765 = PROCEDURE_REF(env_3764, ((long) 0));
      {
	 obj_t app_2124;
	 app_2124 = app_3766;
	 {
	    bool_t test2047_2126;
	    test2047_2126 = is_a__118___object(app_2124, make_procedure_app_48_cfa_info);
	    if (test2047_2126)
	      {
		 long len_2127;
		 {
		    make_procedure_app_48_t obj_3270;
		    obj_3270 = (make_procedure_app_48_t) (app_2124);
		    {
		       obj_t aux_4334;
		       {
			  object_t aux_4335;
			  aux_4335 = (object_t) (obj_3270);
			  aux_4334 = OBJECT_WIDENING(aux_4335);
		       }
		       len_2127 = (((make_procedure_app_48_t) CREF(aux_4334))->values_approx_len_106);
		    }
		 }
		 {
		    long i_2128;
		    {
		       approx_t aux_4339;
		       i_2128 = ((long) 0);
		     loop_2129:
		       if ((i_2128 < len_2127))
			 {
			    {
			       approx_t aux_4349;
			       approx_t aux_4342;
			       {
				  make_procedure_app_48_t obj_3274;
				  obj_3274 = (make_procedure_app_48_t) (app_2124);
				  {
				     obj_t aux_4351;
				     {
					object_t aux_4352;
					aux_4352 = (object_t) (obj_3274);
					aux_4351 = OBJECT_WIDENING(aux_4352);
				     }
				     aux_4349 = (((make_procedure_app_48_t) CREF(aux_4351))->values_approx_79)[i_2128];
				  }
			       }
			       {
				  procedure_ref_app_49_t obj_3273;
				  obj_3273 = (procedure_ref_app_49_t) (instance1883_3765);
				  {
				     obj_t aux_4344;
				     {
					object_t aux_4345;
					aux_4345 = (object_t) (obj_3273);
					aux_4344 = OBJECT_WIDENING(aux_4345);
				     }
				     aux_4342 = (((procedure_ref_app_49_t) CREF(aux_4344))->approx);
				  }
			       }
			       aux_4339 = union_approx__241_cfa_approx(aux_4342, aux_4349);
			    }
			 }
		       else
			 {
			    long i_4357;
			    i_4357 = (i_2128 + ((long) 1));
			    i_2128 = i_4357;
			    goto loop_2129;
			 }
		       return (obj_t) (aux_4339);
		    }
		 }
	      }
	    else
	      {
		 return BUNSPEC;
	      }
	 }
      }
   }
}


obj_t 
cfa__make_procedure_app2498_175_cfa_procedure(obj_t env_3767, obj_t node_3768)
{
   {
      make_procedure_app_48_t node_2052;
      {
	 approx_t aux_4360;
	 node_2052 = (make_procedure_app_48_t) (node_3768);
	 {
	    obj_t env_2058;
	    {
	       obj_t aux_4361;
	       {
		  sfun_t obj_3233;
		  {
		     value_t aux_4362;
		     {
			variable_t arg2006_2079;
			{
			   var_t obj_3231;
			   {
			      obj_t aux_4363;
			      {
				 obj_t aux_4364;
				 {
				    app_t obj_3229;
				    obj_3229 = (app_t) (node_2052);
				    aux_4364 = (((app_t) CREF(obj_3229))->args);
				 }
				 aux_4363 = CAR(aux_4364);
			      }
			      obj_3231 = (var_t) (aux_4363);
			   }
			   arg2006_2079 = (((var_t) CREF(obj_3231))->variable);
			}
			aux_4362 = (((variable_t) CREF(arg2006_2079))->value);
		     }
		     obj_3233 = (sfun_t) (aux_4362);
		  }
		  aux_4361 = (((sfun_t) CREF(obj_3233))->args);
	       }
	       env_2058 = CAR(aux_4361);
	    }
	    {
	       {
		  bool_t test1984_2059;
		  {
		     obj_t aux_4374;
		     aux_4374 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
		     test1984_2059 = CBOOL(aux_4374);
		  }
		  if (test1984_2059)
		    {
		       obj_t arg1986_2061;
		       obj_t arg1988_2063;
		       {
			  obj_t aux_4380;
			  {
			     approx_t aux_4381;
			     {
				svar_cinfo_166_t obj_3236;
				{
				   value_t aux_4382;
				   {
				      local_t obj_3235;
				      obj_3235 = (local_t) (env_2058);
				      aux_4382 = (((local_t) CREF(obj_3235))->value);
				   }
				   obj_3236 = (svar_cinfo_166_t) (aux_4382);
				}
				{
				   obj_t aux_4386;
				   {
				      object_t aux_4387;
				      aux_4387 = (object_t) (obj_3236);
				      aux_4386 = OBJECT_WIDENING(aux_4387);
				   }
				   aux_4381 = (((svar_cinfo_166_t) CREF(aux_4386))->approx);
				}
			     }
			     aux_4380 = (obj_t) (aux_4381);
			  }
			  arg1986_2061 = shape_tools_shape(aux_4380);
		       }
		       {
			  obj_t aux_4393;
			  {
			     approx_t aux_4394;
			     {
				obj_t aux_4395;
				{
				   object_t aux_4396;
				   aux_4396 = (object_t) (node_2052);
				   aux_4395 = OBJECT_WIDENING(aux_4396);
				}
				aux_4394 = (((make_procedure_app_48_t) CREF(aux_4395))->approx);
			     }
			     aux_4393 = (obj_t) (aux_4394);
			  }
			  arg1988_2063 = shape_tools_shape(aux_4393);
		       }
		       {
			  obj_t list1989_2064;
			  {
			     obj_t arg1990_2065;
			     {
				obj_t arg1992_2066;
				{
				   obj_t arg1993_2067;
				   {
				      obj_t arg1995_2068;
				      {
					 obj_t aux_4402;
					 aux_4402 = BCHAR(((unsigned char) '\n'));
					 arg1995_2068 = MAKE_PAIR(aux_4402, BNIL);
				      }
				      arg1993_2067 = MAKE_PAIR(arg1988_2063, arg1995_2068);
				   }
				   arg1992_2066 = MAKE_PAIR(string2526_cfa_procedure, arg1993_2067);
				}
				arg1990_2065 = MAKE_PAIR(arg1986_2061, arg1992_2066);
			     }
			     list1989_2064 = MAKE_PAIR(string2536_cfa_procedure, arg1990_2065);
			  }
			  print_trace_107_tools_trace(list1989_2064);
		       }
		    }
		  else
		    {
		       BUNSPEC;
		    }
	       }
	       {
		  approx_t aux_4420;
		  approx_t aux_4410;
		  {
		     obj_t aux_4421;
		     {
			object_t aux_4422;
			aux_4422 = (object_t) (node_2052);
			aux_4421 = OBJECT_WIDENING(aux_4422);
		     }
		     aux_4420 = (((make_procedure_app_48_t) CREF(aux_4421))->approx);
		  }
		  {
		     svar_cinfo_166_t obj_3239;
		     {
			value_t aux_4411;
			{
			   local_t obj_3238;
			   obj_3238 = (local_t) (env_2058);
			   aux_4411 = (((local_t) CREF(obj_3238))->value);
			}
			obj_3239 = (svar_cinfo_166_t) (aux_4411);
		     }
		     {
			obj_t aux_4415;
			{
			   object_t aux_4416;
			   aux_4416 = (object_t) (obj_3239);
			   aux_4415 = OBJECT_WIDENING(aux_4416);
			}
			aux_4410 = (((svar_cinfo_166_t) CREF(aux_4415))->approx);
		     }
		  }
		  union_approx__241_cfa_approx(aux_4410, aux_4420);
	       }
	    }
	 }
	 {
	    obj_t l1881_2081;
	    {
	       app_t obj_3241;
	       obj_3241 = (app_t) (node_2052);
	       l1881_2081 = (((app_t) CREF(obj_3241))->args);
	    }
	  lname1882_2082:
	    if (PAIRP(l1881_2081))
	      {
		 {
		    node_t aux_4429;
		    {
		       obj_t aux_4430;
		       aux_4430 = CAR(l1881_2081);
		       aux_4429 = (node_t) (aux_4430);
		    }
		    cfa__102_cfa_cfa(aux_4429);
		 }
		 {
		    obj_t l1881_4434;
		    l1881_4434 = CDR(l1881_2081);
		    l1881_2081 = l1881_4434;
		    goto lname1882_2082;
		 }
	      }
	    else
	      {
		 ((bool_t) 1);
	      }
	 }
	 {
	    obj_t aux_4438;
	    {
	       object_t aux_4439;
	       aux_4439 = (object_t) (node_2052);
	       aux_4438 = OBJECT_WIDENING(aux_4439);
	    }
	    aux_4360 = (((make_procedure_app_48_t) CREF(aux_4438))->approx);
	 }
	 return (obj_t) (aux_4360);
      }
   }
}


obj_t 
node_setup__pre_procedure_set__app2499_226_cfa_procedure(obj_t env_3769, obj_t node_3770)
{
   {
      pre_procedure_set__app_208_t node_2036;
      {
	 procedure_set__app_32_t aux_4445;
	 node_2036 = (pre_procedure_set__app_208_t) (node_3770);
	 add_procedure_ref__36_cfa_closure((node_t) (node_2036));
	 {
	    obj_t aux_4448;
	    {
	       app_t obj_3211;
	       obj_3211 = (app_t) (node_2036);
	       aux_4448 = (((app_t) CREF(obj_3211))->args);
	    }
	    node_setup___185_cfa_setup(aux_4448);
	 }
	 {
	    pre_procedure_set__app_208_t node_2041;
	    {
	       long arg1980_2047;
	       {
		  obj_t arg1981_2048;
		  {
		     obj_t arg1982_2049;
		     {
			object_t object_3212;
			object_3212 = (object_t) (node_2036);
			{
			   long arg1187_3213;
			   {
			      long arg1188_3214;
			      long arg1189_3215;
			      arg1188_3214 = TYPE(object_3212);
			      arg1189_3215 = OBJECT_TYPE;
			      arg1187_3213 = (arg1188_3214 - arg1189_3215);
			   }
			   {
			      obj_t vector_3219;
			      vector_3219 = __classes__134___object;
			      arg1982_2049 = VECTOR_REF(vector_3219, arg1187_3213);
			   }
			}
		     }
		     arg1981_2048 = class_super_145___object(arg1982_2049);
		  }
		  arg1980_2047 = class_num_218___object(arg1981_2048);
	       }
	       {
		  obj_t obj_3221;
		  obj_3221 = (obj_t) (node_2036);
		  (((obj_t) CREF(obj_3221))->header = MAKE_HEADER(arg1980_2047, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_4461;
	       aux_4461 = (object_t) (node_2036);
	       OBJECT_WIDENING_SET(aux_4461, BFALSE);
	    }
	    node_2041 = node_2036;
	    {
	       procedure_set__app_32_t obj1879_2042;
	       obj1879_2042 = ((procedure_set__app_32_t) (node_2041));
	       {
		  procedure_set__app_32_t arg1977_2043;
		  {
		     approx_t arg1978_2044;
		     arg1978_2044 = make_type_approx_184_cfa_approx((type_t) (__unspec__87_type_cache));
		     {
			procedure_set__app_32_t res2479_3226;
			{
			   procedure_set__app_32_t new1687_3224;
			   new1687_3224 = ((procedure_set__app_32_t) BREF(GC_MALLOC(sizeof(struct procedure_set__app_32))));
			   ((((procedure_set__app_32_t) CREF(new1687_3224))->approx) = ((approx_t) arg1978_2044), BUNSPEC);
			   res2479_3226 = new1687_3224;
			}
			arg1977_2043 = res2479_3226;
		     }
		  }
		  {
		     obj_t aux_4471;
		     object_t aux_4469;
		     aux_4471 = (obj_t) (arg1977_2043);
		     aux_4469 = (object_t) (obj1879_2042);
		     OBJECT_WIDENING_SET(aux_4469, aux_4471);
		  }
	       }
	       {
		  long arg1979_2045;
		  arg1979_2045 = class_num_218___object(procedure_set__app_32_cfa_info);
		  {
		     obj_t obj_3227;
		     obj_3227 = (obj_t) (obj1879_2042);
		     (((obj_t) CREF(obj_3227))->header = MAKE_HEADER(arg1979_2045, 0), BUNSPEC);
		  }
	       }
	       aux_4445 = obj1879_2042;
	    }
	 }
	 return (obj_t) (aux_4445);
      }
   }
}


obj_t 
node_setup__pre_procedure_ref_app2500_215_cfa_procedure(obj_t env_3771, obj_t node_3772)
{
   {
      pre_procedure_ref_app_85_t node_2020;
      {
	 procedure_ref_app_49_t aux_4479;
	 node_2020 = (pre_procedure_ref_app_85_t) (node_3772);
	 add_procedure_ref__36_cfa_closure((node_t) (node_2020));
	 {
	    obj_t aux_4482;
	    {
	       app_t obj_3193;
	       obj_3193 = (app_t) (node_2020);
	       aux_4482 = (((app_t) CREF(obj_3193))->args);
	    }
	    node_setup___185_cfa_setup(aux_4482);
	 }
	 {
	    pre_procedure_ref_app_85_t node_2025;
	    {
	       long arg1972_2031;
	       {
		  obj_t arg1973_2032;
		  {
		     obj_t arg1974_2033;
		     {
			object_t object_3194;
			object_3194 = (object_t) (node_2020);
			{
			   long arg1187_3195;
			   {
			      long arg1188_3196;
			      long arg1189_3197;
			      arg1188_3196 = TYPE(object_3194);
			      arg1189_3197 = OBJECT_TYPE;
			      arg1187_3195 = (arg1188_3196 - arg1189_3197);
			   }
			   {
			      obj_t vector_3201;
			      vector_3201 = __classes__134___object;
			      arg1974_2033 = VECTOR_REF(vector_3201, arg1187_3195);
			   }
			}
		     }
		     arg1973_2032 = class_super_145___object(arg1974_2033);
		  }
		  arg1972_2031 = class_num_218___object(arg1973_2032);
	       }
	       {
		  obj_t obj_3203;
		  obj_3203 = (obj_t) (node_2020);
		  (((obj_t) CREF(obj_3203))->header = MAKE_HEADER(arg1972_2031, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_4495;
	       aux_4495 = (object_t) (node_2020);
	       OBJECT_WIDENING_SET(aux_4495, BFALSE);
	    }
	    node_2025 = node_2020;
	    {
	       procedure_ref_app_49_t obj1876_2026;
	       obj1876_2026 = ((procedure_ref_app_49_t) (node_2025));
	       {
		  procedure_ref_app_49_t arg1969_2027;
		  {
		     approx_t arg1970_2028;
		     arg1970_2028 = make_type_approx_184_cfa_approx((type_t) (__obj__252_type_cache));
		     {
			procedure_ref_app_49_t res2478_3208;
			{
			   procedure_ref_app_49_t new1674_3206;
			   new1674_3206 = ((procedure_ref_app_49_t) BREF(GC_MALLOC(sizeof(struct procedure_ref_app_49))));
			   ((((procedure_ref_app_49_t) CREF(new1674_3206))->approx) = ((approx_t) arg1970_2028), BUNSPEC);
			   res2478_3208 = new1674_3206;
			}
			arg1969_2027 = res2478_3208;
		     }
		  }
		  {
		     obj_t aux_4505;
		     object_t aux_4503;
		     aux_4505 = (obj_t) (arg1969_2027);
		     aux_4503 = (object_t) (obj1876_2026);
		     OBJECT_WIDENING_SET(aux_4503, aux_4505);
		  }
	       }
	       {
		  long arg1971_2029;
		  arg1971_2029 = class_num_218___object(procedure_ref_app_49_cfa_info);
		  {
		     obj_t obj_3209;
		     obj_3209 = (obj_t) (obj1876_2026);
		     (((obj_t) CREF(obj_3209))->header = MAKE_HEADER(arg1971_2029, 0), BUNSPEC);
		  }
	       }
	       aux_4479 = obj1876_2026;
	    }
	 }
	 return (obj_t) (aux_4479);
      }
   }
}


obj_t 
node_setup__pre_make_procedure_app2501_89_cfa_procedure(obj_t env_3773, obj_t node_3774)
{
   {
      pre_make_procedure_app_60_t node_1947;
      node_1947 = (pre_make_procedure_app_60_t) (node_3774);
      {
	 add_make_procedure__219_cfa_closure((node_t) (node_1947));
	 {
	    obj_t aux_4515;
	    {
	       app_t obj_3105;
	       obj_3105 = (app_t) (node_1947);
	       aux_4515 = (((app_t) CREF(obj_3105))->args);
	    }
	    node_setup___185_cfa_setup(aux_4515);
	 }
	 {
	    obj_t key_1952;
	    {
	       obj_t aux_4519;
	       {
		  object_t aux_4520;
		  aux_4520 = (object_t) (node_1947);
		  aux_4519 = OBJECT_WIDENING(aux_4520);
	       }
	       key_1952 = (((pre_make_procedure_app_60_t) CREF(aux_4519))->key);
	    }
	    {
	       variable_t owner_1953;
	       {
		  obj_t aux_4524;
		  {
		     object_t aux_4525;
		     aux_4525 = (object_t) (node_1947);
		     aux_4524 = OBJECT_WIDENING(aux_4525);
		  }
		  owner_1953 = (((pre_make_procedure_app_60_t) CREF(aux_4524))->owner);
	       }
	       {
		  pre_make_procedure_app_60_t node_1954;
		  {
		     long arg1964_2015;
		     {
			obj_t arg1965_2016;
			{
			   obj_t arg1966_2017;
			   {
			      object_t object_3108;
			      object_3108 = (object_t) (node_1947);
			      {
				 long arg1187_3109;
				 {
				    long arg1188_3110;
				    long arg1189_3111;
				    arg1188_3110 = TYPE(object_3108);
				    arg1189_3111 = OBJECT_TYPE;
				    arg1187_3109 = (arg1188_3110 - arg1189_3111);
				 }
				 {
				    obj_t vector_3115;
				    vector_3115 = __classes__134___object;
				    arg1966_2017 = VECTOR_REF(vector_3115, arg1187_3109);
				 }
			      }
			   }
			   arg1965_2016 = class_super_145___object(arg1966_2017);
			}
			arg1964_2015 = class_num_218___object(arg1965_2016);
		     }
		     {
			obj_t obj_3117;
			obj_3117 = (obj_t) (node_1947);
			(((obj_t) CREF(obj_3117))->header = MAKE_HEADER(arg1964_2015, 0), BUNSPEC);
		     }
		  }
		  {
		     object_t aux_4538;
		     aux_4538 = (object_t) (node_1947);
		     OBJECT_WIDENING_SET(aux_4538, BFALSE);
		  }
		  node_1954 = node_1947;
		  {
		     {
			obj_t proc_size_203_1955;
			obj_t proc_1956;
			{
			   node_t aux_4541;
			   {
			      obj_t aux_4542;
			      {
				 obj_t aux_4543;
				 {
				    obj_t aux_4544;
				    {
				       obj_t aux_4545;
				       {
					  app_t obj_3119;
					  obj_3119 = (app_t) (node_1947);
					  aux_4545 = (((app_t) CREF(obj_3119))->args);
				       }
				       aux_4544 = CDR(aux_4545);
				    }
				    aux_4543 = CDR(aux_4544);
				 }
				 aux_4542 = CAR(aux_4543);
			      }
			      aux_4541 = (node_t) (aux_4542);
			   }
			   proc_size_203_1955 = get_node_atom_value_135_cfa_approx(aux_4541);
			}
			{
			   obj_t aux_4553;
			   {
			      app_t obj_3126;
			      obj_3126 = (app_t) (node_1947);
			      aux_4553 = (((app_t) CREF(obj_3126))->args);
			   }
			   proc_1956 = CAR(aux_4553);
			}
			{
			   bool_t test1906_1957;
			   if (INTEGERP(proc_size_203_1955))
			     {
				bool_t test1955_2008;
				test1955_2008 = is_a__118___object(proc_1956, var_ast_node);
				if (test1955_2008)
				  {
				     obj_t aux_4561;
				     {
					value_t aux_4562;
					{
					   variable_t arg1957_2010;
					   {
					      var_t obj_3130;
					      obj_3130 = (var_t) (proc_1956);
					      arg1957_2010 = (((var_t) CREF(obj_3130))->variable);
					   }
					   aux_4562 = (((variable_t) CREF(arg1957_2010))->value);
					}
					aux_4561 = (obj_t) (aux_4562);
				     }
				     test1906_1957 = is_a__118___object(aux_4561, fun_ast_var);
				  }
				else
				  {
				     test1906_1957 = ((bool_t) 0);
				  }
			     }
			   else
			     {
				test1906_1957 = ((bool_t) 0);
			     }
			   if (test1906_1957)
			     {
				make_procedure_app_48_t node_1958;
				{
				   make_procedure_app_48_t obj1872_2000;
				   obj1872_2000 = ((make_procedure_app_48_t) (node_1954));
				   {
				      make_procedure_app_48_t arg1948_2001;
				      {
					 approx_t arg1949_2002;
					 approx_t arg1950_2003;
					 arg1949_2002 = make_empty_approx_131_cfa_approx();
					 arg1950_2003 = make_empty_approx_131_cfa_approx();
					 {
					    make_procedure_app_48_t res2473_3164;
					    {
					       long values_approx_len_106_3135;
					       values_approx_len_106_3135 = (long) CINT(proc_size_203_1955);
					       {
						  make_procedure_app_48_t new1655_3144;
						  new1655_3144 = ((make_procedure_app_48_t) BREF(GC_MALLOC(sizeof(struct make_procedure_app_48))));
						  ((((make_procedure_app_48_t) CREF(new1655_3144))->key) = ((obj_t) key_1952), BUNSPEC);
						  ((((make_procedure_app_48_t) CREF(new1655_3144))->approx) = ((approx_t) arg1949_2002), BUNSPEC);
						  ((((make_procedure_app_48_t) CREF(new1655_3144))->values_approx_len_106) = ((long) values_approx_len_106_3135), BUNSPEC);
						  ((((make_procedure_app_48_t) CREF(new1655_3144))->values_approx_79) = ((approx_t *) GC_MALLOC(sizeof(struct approx) * values_approx_len_106_3135)), BUNSPEC);
						  {
						     long i1656_3157;
						     i1656_3157 = ((long) 0);
						   loop1654_3156:
						     if ((i1656_3157 == values_approx_len_106_3135))
						       {
							  CNST_TABLE_REF(((long) 2));
						       }
						     else
						       {
							  ((((make_procedure_app_48_t) CREF(new1655_3144))->values_approx_79)[i1656_3157] = ((approx_t) arg1950_2003), BUNSPEC);
							  {
							     long i1656_4583;
							     i1656_4583 = (i1656_3157 + ((long) 1));
							     i1656_3157 = i1656_4583;
							     goto loop1654_3156;
							  }
						       }
						  }
						  ((((make_procedure_app_48_t) CREF(new1655_3144))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
						  ((((make_procedure_app_48_t) CREF(new1655_3144))->x_t__142) = ((bool_t) ((bool_t) 1)), BUNSPEC);
						  ((((make_procedure_app_48_t) CREF(new1655_3144))->x) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						  ((((make_procedure_app_48_t) CREF(new1655_3144))->t) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						  ((((make_procedure_app_48_t) CREF(new1655_3144))->owner) = ((variable_t) owner_1953), BUNSPEC);
						  ((((make_procedure_app_48_t) CREF(new1655_3144))->stackable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
						  ((((make_procedure_app_48_t) CREF(new1655_3144))->stack_stamp_31) = ((obj_t) BNIL), BUNSPEC);
						  res2473_3164 = new1655_3144;
					       }
					    }
					    arg1948_2001 = res2473_3164;
					 }
				      }
				      {
					 obj_t aux_4594;
					 object_t aux_4592;
					 aux_4594 = (obj_t) (arg1948_2001);
					 aux_4592 = (object_t) (obj1872_2000);
					 OBJECT_WIDENING_SET(aux_4592, aux_4594);
				      }
				   }
				   {
				      long arg1953_2006;
				      arg1953_2006 = class_num_218___object(make_procedure_app_48_cfa_info);
				      {
					 obj_t obj_3165;
					 obj_3165 = (obj_t) (obj1872_2000);
					 (((obj_t) CREF(obj_3165))->header = MAKE_HEADER(arg1953_2006, 0), BUNSPEC);
				      }
				   }
				   node_1958 = obj1872_2000;
				}
				{
				   bool_t test1907_1959;
				   {
				      obj_t aux_4600;
				      aux_4600 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				      test1907_1959 = CBOOL(aux_4600);
				   }
				   if (test1907_1959)
				     {
					obj_t arg1909_1961;
					arg1909_1961 = shape_tools_shape((obj_t) (node_1958));
					{
					   obj_t list1913_1964;
					   {
					      obj_t arg1914_1965;
					      {
						 obj_t arg1915_1966;
						 {
						    obj_t arg1916_1967;
						    {
						       obj_t arg1917_1968;
						       {
							  obj_t arg1918_1969;
							  {
							     obj_t arg1921_1970;
							     {
								obj_t arg1922_1971;
								{
								   obj_t arg1923_1972;
								   {
								      obj_t aux_4608;
								      aux_4608 = BCHAR(((unsigned char) '\n'));
								      arg1923_1972 = MAKE_PAIR(aux_4608, BNIL);
								   }
								   arg1922_1971 = MAKE_PAIR(key_1952, arg1923_1972);
								}
								arg1921_1970 = MAKE_PAIR(string2537_cfa_procedure, arg1922_1971);
							     }
							     {
								obj_t aux_4613;
								aux_4613 = BCHAR(((unsigned char) '\n'));
								arg1918_1969 = MAKE_PAIR(aux_4613, arg1921_1970);
							     }
							  }
							  arg1917_1968 = MAKE_PAIR(proc_size_203_1955, arg1918_1969);
						       }
						       arg1916_1967 = MAKE_PAIR(string2538_cfa_procedure, arg1917_1968);
						    }
						    {
						       obj_t aux_4618;
						       aux_4618 = BCHAR(((unsigned char) '\n'));
						       arg1915_1966 = MAKE_PAIR(aux_4618, arg1916_1967);
						    }
						 }
						 arg1914_1965 = MAKE_PAIR(arg1909_1961, arg1915_1966);
					      }
					      list1913_1964 = MAKE_PAIR(string2539_cfa_procedure, arg1914_1965);
					   }
					   print_trace_107_tools_trace(list1913_1964);
					}
				     }
				   else
				     {
					BUNSPEC;
				     }
				}
				{
				   approx_t arg1928_1976;
				   arg1928_1976 = make_type_alloc_approx_134_cfa_approx((type_t) (__procedure__226_type_cache), (node_t) (node_1958));
				   {
				      obj_t res2474_3169;
				      {
					 obj_t x_3802;
					 {
					    obj_t aux_4627;
					    {
					       object_t aux_4628;
					       aux_4628 = (object_t) (node_1958);
					       aux_4627 = OBJECT_WIDENING(aux_4628);
					    }
					    x_3802 = ((((make_procedure_app_48_t) CREF(aux_4627))->approx) = ((approx_t) arg1928_1976), BUNSPEC);
					 }
					 res2474_3169 = BUNSPEC;
				      }
				      res2474_3169;
				   }
				}
				{
				   obj_t clo_1977;
				   {
				      obj_t aux_4632;
				      {
					 sfun_t obj_3172;
					 {
					    value_t aux_4633;
					    {
					       variable_t arg1943_1994;
					       {
						  var_t obj_3170;
						  obj_3170 = (var_t) (proc_1956);
						  arg1943_1994 = (((var_t) CREF(obj_3170))->variable);
					       }
					       aux_4633 = (((variable_t) CREF(arg1943_1994))->value);
					    }
					    obj_3172 = (sfun_t) (aux_4633);
					 }
					 aux_4632 = (((sfun_t) CREF(obj_3172))->args);
				      }
				      clo_1977 = CAR(aux_4632);
				   }
				   {
				      value_t vclo_1978;
				      {
					 local_t obj_3174;
					 obj_3174 = (local_t) (clo_1977);
					 vclo_1978 = (((local_t) CREF(obj_3174))->value);
				      }
				      {
					 {
					    bool_t test1929_1979;
					    test1929_1979 = is_a__118___object((obj_t) (vclo_1978), svar_cinfo_166_cfa_info);
					    if (test1929_1979)
					      {
						 {
						    bool_t test1930_1980;
						    {
						       obj_t aux_4645;
						       aux_4645 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
						       test1930_1980 = CBOOL(aux_4645);
						    }
						    if (test1930_1980)
						      {
							 obj_t arg1932_1982;
							 arg1932_1982 = shape_tools_shape(clo_1977);
							 {
							    obj_t list1933_1983;
							    {
							       obj_t arg1934_1984;
							       {
								  obj_t arg1935_1985;
								  {
								     obj_t aux_4652;
								     aux_4652 = BCHAR(((unsigned char) '\n'));
								     arg1935_1985 = MAKE_PAIR(aux_4652, BNIL);
								  }
								  arg1934_1984 = MAKE_PAIR(arg1932_1982, arg1935_1985);
							       }
							       list1933_1983 = MAKE_PAIR(string2540_cfa_procedure, arg1934_1984);
							    }
							    print_trace_107_tools_trace(list1933_1983);
							 }
						      }
						    else
						      {
							 BUNSPEC;
						      }
						 }
						 {
						    obj_t res2475_3178;
						    {
						       svar_cinfo_166_t obj_3176;
						       obj_3176 = (svar_cinfo_166_t) (vclo_1978);
						       {
							  obj_t x_3803;
							  {
							     obj_t aux_4659;
							     {
								object_t aux_4660;
								aux_4660 = (object_t) (obj_3176);
								aux_4659 = OBJECT_WIDENING(aux_4660);
							     }
							     x_3803 = ((((svar_cinfo_166_t) CREF(aux_4659))->clo_env__87) = ((bool_t) ((bool_t) 1)), BUNSPEC);
							  }
							  res2475_3178 = BUNSPEC;
						       }
						    }
						    res2475_3178;
						 }
					      }
					    else
					      {
						 pre_clo_env_191_t obj1873_1989;
						 obj1873_1989 = ((pre_clo_env_191_t) (vclo_1978));
						 {
						    obj_t aux_4667;
						    object_t aux_4665;
						    {
						       pre_clo_env_191_t aux_4668;
						       {
							  aux_4668 = ((pre_clo_env_191_t) BREF(GC_MALLOC(sizeof(struct pre_clo_env_191))));
						       }
						       aux_4667 = (obj_t) (aux_4668);
						    }
						    aux_4665 = (object_t) (obj1873_1989);
						    OBJECT_WIDENING_SET(aux_4665, aux_4667);
						 }
						 {
						    long arg1940_1991;
						    arg1940_1991 = class_num_218___object(pre_clo_env_191_cfa_info);
						    {
						       obj_t obj_3181;
						       obj_3181 = (obj_t) (obj1873_1989);
						       (((obj_t) CREF(obj_3181))->header = MAKE_HEADER(arg1940_1991, 0), BUNSPEC);
						    }
						 }
						 (obj_t) (obj1873_1989);
					      }
					 }
				      }
				   }
				}
				{
				   long i_1995;
				   i_1995 = ((long) 0);
				 loop_1996:
				   {
				      bool_t test_4676;
				      {
					 long aux_4677;
					 aux_4677 = (long) CINT(proc_size_203_1955);
					 test_4676 = (i_1995 < aux_4677);
				      }
				      if (test_4676)
					{
					   {
					      approx_t arg1945_1998;
					      arg1945_1998 = make_type_approx_184_cfa_approx((type_t) (__obj__252_type_cache));
					      {
						 obj_t res2477_3188;
						 {
						    obj_t x_3804;
						    {
						       obj_t aux_4682;
						       {
							  object_t aux_4683;
							  aux_4683 = (object_t) (node_1958);
							  aux_4682 = OBJECT_WIDENING(aux_4683);
						       }
						       x_3804 = ((((make_procedure_app_48_t) CREF(aux_4682))->values_approx_79)[i_1995] = ((approx_t) arg1945_1998), BUNSPEC);
						    }
						    res2477_3188 = BUNSPEC;
						 }
						 res2477_3188;
					      }
					   }
					   {
					      long i_4687;
					      i_4687 = (i_1995 + ((long) 1));
					      i_1995 = i_4687;
					      goto loop_1996;
					   }
					}
				      else
					{
					   return BUNSPEC;
					}
				   }
				}
			     }
			   else
			     {
				{
				   obj_t next_method1892_223_2018;
				   next_method1892_223_2018 = find_super_class_method_167___object((object_t) (node_1947), node_setup__env_214_cfa_setup, pre_make_procedure_app_60_cfa_info);
				   if (PROCEDUREP(next_method1892_223_2018))
				     {
					return PROCEDURE_ENTRY(next_method1892_223_2018) (next_method1892_223_2018, (obj_t) (node_1947), BEOA);
				     }
				   else
				     {
					PROCEDURE_SET(node_setup__env_214_cfa_setup, ((long) 2), next_method1892_223_2018);
					return node_setup__189_cfa_setup((node_t) (node_1947));
				     }
				}
			     }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
disable_x_t__211_cfa_procedure(approx_t approx_1)
{
   {
      obj_t arg2194_3789;
      arg2194_3789 = proc2541_cfa_procedure;
      return for_each_approx_alloc_83_cfa_approx(arg2194_3789, approx_1);
   }
}


obj_t 
_disable_x_t__100_cfa_procedure(obj_t env_3790, obj_t approx_3791)
{
   return disable_x_t__211_cfa_procedure((approx_t) (approx_3791));
}


obj_t 
arg21942510_cfa_procedure(obj_t env_3792, obj_t app_3793)
{
   {
      obj_t app_2318;
      app_2318 = app_3793;
      {
	 bool_t test2196_2320;
	 {
	    obj_t aux_4703;
	    aux_4703 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
	    test2196_2320 = CBOOL(aux_4703);
	 }
	 if (test2196_2320)
	   {
	      obj_t arg2198_2322;
	      arg2198_2322 = shape_tools_shape(app_2318);
	      {
		 obj_t list2199_2323;
		 {
		    obj_t arg2200_2324;
		    {
		       obj_t arg2201_2325;
		       {
			  obj_t aux_4710;
			  aux_4710 = BCHAR(((unsigned char) '\n'));
			  arg2201_2325 = MAKE_PAIR(aux_4710, BNIL);
		       }
		       arg2200_2324 = MAKE_PAIR(arg2198_2322, arg2201_2325);
		    }
		    list2199_2323 = MAKE_PAIR(string2542_cfa_procedure, arg2200_2324);
		 }
		 print_trace_107_tools_trace(list2199_2323);
	      }
	   }
	 else
	   {
	      BUNSPEC;
	   }
      }
      {
	 bool_t test2205_2329;
	 test2205_2329 = is_a__118___object(app_2318, make_procedure_app_48_cfa_info);
	 if (test2205_2329)
	   {
	      obj_t res2484_3363;
	      {
		 make_procedure_app_48_t obj_3361;
		 obj_3361 = (make_procedure_app_48_t) (app_2318);
		 {
		    obj_t x_3805;
		    {
		       obj_t aux_4719;
		       {
			  object_t aux_4720;
			  aux_4720 = (object_t) (obj_3361);
			  aux_4719 = OBJECT_WIDENING(aux_4720);
		       }
		       x_3805 = ((((make_procedure_app_48_t) CREF(aux_4719))->x_t__142) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		    }
		    res2484_3363 = BUNSPEC;
		 }
	      }
	      return res2484_3363;
	   }
	 else
	   {
	      return BUNSPEC;
	   }
      }
   }
}


obj_t 
stack_loose_procedure_env__187_cfa_procedure(make_procedure_app_48_t alloc_11, obj_t cowner_12)
{
   {
      bool_t test2206_2331;
      {
	 obj_t aux_4724;
	 aux_4724 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
	 test2206_2331 = CBOOL(aux_4724);
      }
      if (test2206_2331)
	{
	   obj_t arg2209_2334;
	   obj_t arg2211_2336;
	   arg2209_2334 = shape_tools_shape((obj_t) (alloc_11));
	   arg2211_2336 = shape_tools_shape(cowner_12);
	   {
	      obj_t list2212_2337;
	      {
		 obj_t arg2213_2338;
		 {
		    obj_t arg2214_2339;
		    {
		       obj_t arg2215_2340;
		       {
			  obj_t arg2216_2341;
			  {
			     obj_t arg2217_2342;
			     {
				obj_t arg2218_2343;
				{
				   obj_t aux_4733;
				   aux_4733 = BCHAR(((unsigned char) '\n'));
				   arg2218_2343 = MAKE_PAIR(aux_4733, BNIL);
				}
				arg2217_2342 = MAKE_PAIR(arg2211_2336, arg2218_2343);
			     }
			     arg2216_2341 = MAKE_PAIR(string2543_cfa_procedure, arg2217_2342);
			  }
			  arg2215_2340 = MAKE_PAIR(arg2209_2334, arg2216_2341);
		       }
		       arg2214_2339 = MAKE_PAIR(string2526_cfa_procedure, arg2215_2340);
		    }
		    arg2213_2338 = MAKE_PAIR(__cfa_stamp__16_cfa_iterate, arg2214_2339);
		 }
		 list2212_2337 = MAKE_PAIR(string2544_cfa_procedure, arg2213_2338);
	      }
	      print_trace_107_tools_trace(list2212_2337);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      long len_2347;
      {
	 obj_t aux_4743;
	 {
	    object_t aux_4744;
	    aux_4744 = (object_t) (alloc_11);
	    aux_4743 = OBJECT_WIDENING(aux_4744);
	 }
	 len_2347 = (((make_procedure_app_48_t) CREF(aux_4743))->values_approx_len_106);
      }
      {
	 long i_2348;
	 i_2348 = ((long) 0);
       loop_2349:
	 if ((i_2348 < len_2347))
	   {
	      {
		 approx_t arg2224_2352;
		 {
		    obj_t aux_4750;
		    {
		       object_t aux_4751;
		       aux_4751 = (object_t) (alloc_11);
		       aux_4750 = OBJECT_WIDENING(aux_4751);
		    }
		    arg2224_2352 = (((make_procedure_app_48_t) CREF(aux_4750))->values_approx_79)[i_2348];
		 }
		 {
		    obj_t arg2223_3794;
		    arg2223_3794 = make_fx_procedure(arg22232511_cfa_procedure, ((long) 1), ((long) 1));
		    PROCEDURE_SET(arg2223_3794, ((long) 0), cowner_12);
		    for_each_approx_alloc_83_cfa_approx(arg2223_3794, arg2224_2352);
		 }
	      }
	      {
		 long i_4758;
		 i_4758 = (i_2348 + ((long) 1));
		 i_2348 = i_4758;
		 goto loop_2349;
	      }
	   }
	 else
	   {
	      return BUNSPEC;
	   }
      }
   }
}


obj_t 
arg22232511_cfa_procedure(obj_t env_3795, obj_t alloc_3797)
{
   {
      obj_t cowner_3796;
      cowner_3796 = PROCEDURE_REF(env_3795, ((long) 0));
      {
	 obj_t alloc_2353;
	 alloc_2353 = alloc_3797;
	 return stack_loose_alloc__95_cfa_loose((node_t) (alloc_2353), cowner_3796);
      }
   }
}


obj_t 
imported_modules_init_94_cfa_procedure()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_PROCEDURE");
   module_initialization_70_tools_error(((long) 0), "CFA_PROCEDURE");
   module_initialization_70_tools_shape(((long) 0), "CFA_PROCEDURE");
   module_initialization_70_type_type(((long) 0), "CFA_PROCEDURE");
   module_initialization_70_type_cache(((long) 0), "CFA_PROCEDURE");
   module_initialization_70_ast_var(((long) 0), "CFA_PROCEDURE");
   module_initialization_70_ast_node(((long) 0), "CFA_PROCEDURE");
   module_initialization_70_cfa_info(((long) 0), "CFA_PROCEDURE");
   module_initialization_70_cfa_loose(((long) 0), "CFA_PROCEDURE");
   module_initialization_70_cfa_setup(((long) 0), "CFA_PROCEDURE");
   module_initialization_70_cfa_approx(((long) 0), "CFA_PROCEDURE");
   module_initialization_70_cfa_cfa(((long) 0), "CFA_PROCEDURE");
   module_initialization_70_cfa_iterate(((long) 0), "CFA_PROCEDURE");
   module_initialization_70_cfa_closure(((long) 0), "CFA_PROCEDURE");
   return module_initialization_70_cfa_stack(((long) 0), "CFA_PROCEDURE");
}
