/*===========================================================================*/
/*   (Cfa/setup.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


extern obj_t app_ly_cinfo_234_cfa_info;
extern obj_t __procedure__226_type_cache;
extern obj_t let_fun_218_ast_node;
extern obj_t svar_cinfo_166_cfa_info;
static obj_t _fun_setup__218_cfa_setup(obj_t, obj_t, obj_t);
static obj_t _variable_value_setup__default1946_1_cfa_setup(obj_t, obj_t, obj_t);
extern obj_t _node_setup__114_cfa_setup(obj_t, obj_t);
extern obj_t setq_cinfo_191_cfa_info;
extern obj_t cvar_cinfo_53_cfa_info;
extern obj_t pre_clo_env_191_cfa_info;
extern obj_t scnst_ast_var;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
extern obj_t node_setup__189_cfa_setup(node_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t jump_ex_it_cinfo_139_cfa_info;
static obj_t imported_modules_init_94_cfa_setup();
extern obj_t module_initialization_70_cfa_setup(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_typeof(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t sexit_ast_var;
static bool_t alloc_type__187_cfa_setup(type_t);
static obj_t node_setup__default1941_212_cfa_setup(node_t);
static obj_t toplevel_init_63_cfa_setup();
static obj_t cnst_init_137_cfa_setup();
static obj_t case_else2305_50_cfa_setup(variable_t, value_t, obj_t);
extern obj_t conditional_cinfo_212_cfa_info;
extern obj_t pragma_cinfo_220_cfa_info;
extern obj_t cfun_ast_var;
extern obj_t pre_make_procedure_app_60_cfa_info;
extern obj_t fail_cinfo_75_cfa_info;
extern obj_t __module__166_module_module;
extern obj_t set_ex_it_cinfo_168_cfa_info;
extern type_t typeof_kwote_49_type_typeof(obj_t);
static obj_t loop2300_cfa_setup(variable_t, value_t, obj_t, obj_t);
extern obj_t node_setup___185_cfa_setup(obj_t);
static obj_t require_initialization_114_cfa_setup = BUNSPEC;
extern obj_t scnst_cinfo_0_cfa_info;
extern obj_t kwote_cinfo_48_cfa_info;
extern approx_t make_empty_approx_131_cfa_approx();
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cfa_setup();
extern obj_t atom_cinfo_155_cfa_info;
extern obj_t kwote_node_102_cfa_info;
static obj_t fun_setup__186_cfa_setup(fun_t, obj_t);
extern obj_t sexit_cinfo_49_cfa_info;
extern obj_t sfun_ast_var;
extern obj_t cast_ast_node;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
static obj_t variable_value_setup__default1946_8_cfa_setup(value_t, variable_t);
extern obj_t set_initial_approx__92_cfa_setup(obj_t);
extern obj_t select_ast_node;
static obj_t fun_setup__default1957_132_cfa_setup(fun_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern obj_t __unspec__87_type_cache;
extern obj_t class_super_145___object(obj_t);
static obj_t _node_setup__default1941_51_cfa_setup(obj_t, obj_t);
extern long class_num_218___object(obj_t);
static obj_t variable_value_setup__80_cfa_setup(value_t, variable_t);
extern obj_t find_method_from_44___object(object_t, obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t __vector__240_type_cache;
extern obj_t jump_ex_it_184_ast_node;
static obj_t _fun_setup__default1957_195_cfa_setup(obj_t, obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t funcall_cinfo_75_cfa_info;
extern obj_t _node_setup___39_cfa_setup(obj_t, obj_t);
extern obj_t select_cinfo_150_cfa_info;
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern approx_t make_type_approx_184_cfa_approx(type_t);
extern obj_t svar_ast_var;
extern obj_t reshaped_global_160_cfa_info;
extern obj_t setq_ast_node;
extern obj_t cvar_ast_var;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t __warning__61___error;
extern obj_t fail_ast_node;
extern obj_t extern_sfun_cinfo_6_cfa_info;
extern obj_t set_ex_it_116_ast_node;
extern obj_t reshaped_local_224_cfa_info;
extern obj_t local_ast_var;
extern obj_t kwote_ast_node;
static obj_t call_next_method_114_cfa_setup(value_t, obj_t, variable_t);
extern obj_t __struct__183_type_cache;
extern obj_t approx_set_top__187_cfa_approx(approx_t);
extern obj_t funcall_ast_node;
extern obj_t __obj__252_type_cache;
extern obj_t atom_ast_node;
extern obj_t cfun_cinfo_200_cfa_info;
static obj_t _variable_value_setup__30_cfa_setup(obj_t, obj_t, obj_t);
extern obj_t intern_sfun_cinfo_192_cfa_info;
extern obj_t _set_initial_approx__130_cfa_setup(obj_t, obj_t);
extern obj_t app_ast_node;
extern type_t typeof_atom_134_type_typeof(obj_t);
static obj_t __cnst[8];

DEFINE_STRING(string2610_cfa_setup, string2610_cfa_setup2621, "  ", 2);
DEFINE_STATIC_PROCEDURE(node_setup__default1941_env_145_cfa_setup, _node_setup__default1941_51_cfa_setup2622, _node_setup__default1941_51_cfa_setup, 0L, 1);
DEFINE_STATIC_GENERIC(fun_setup__env_196_cfa_setup, _fun_setup__218_cfa_setup2623, _fun_setup__218_cfa_setup, 0L, 2);
DEFINE_STRING(string2606_cfa_setup, string2606_cfa_setup2624, "node-setup!", 11);
DEFINE_STATIC_PROCEDURE(fun_setup__default1957_env_104_cfa_setup, _fun_setup__default1957_195_cfa_setup2625, _fun_setup__default1957_195_cfa_setup, 0L, 2);
DEFINE_STATIC_GENERIC(variable_value_setup__env_134_cfa_setup, _variable_value_setup__30_cfa_setup2626, _variable_value_setup__30_cfa_setup, 0L, 2);
DEFINE_STRING(string2612_cfa_setup, string2612_cfa_setup2627, " ", 1);
DEFINE_EXPORT_PROCEDURE(node_setup___env_203_cfa_setup, _node_setup___39_cfa_setup2628, _node_setup___39_cfa_setup, 0L, 1);
DEFINE_STRING(string2613_cfa_setup, string2613_cfa_setup2629, "Je setup une scnst: ", 20);
DEFINE_STRING(string2607_cfa_setup, string2607_cfa_setup2630, "Unexpected closure", 18);
DEFINE_STATIC_PROCEDURE(variable_value_setup__default1946_env_130_cfa_setup, _variable_value_setup__default1946_1_cfa_setup2631, _variable_value_setup__default1946_1_cfa_setup, 0L, 2);
DEFINE_STRING(string2608_cfa_setup, string2608_cfa_setup2632, "let-var settup: ", 16);
DEFINE_EXPORT_PROCEDURE(set_initial_approx__env_29_cfa_setup, _set_initial_approx__130_cfa_setup2633, _set_initial_approx__130_cfa_setup, 0L, 1);
DEFINE_STRING(string2615_cfa_setup, string2615_cfa_setup2634, "IMPORT (SFUN SGFUN) ALREADY-DONE STATIC VARIABLE-VALUE-SETUP!-DEFAULT1946 READ CFA NODE-SETUP!-DEFAULT1941 ", 107);
DEFINE_EXPORT_GENERIC(node_setup__env_214_cfa_setup, _node_setup__114_cfa_setup2635, _node_setup__114_cfa_setup, 0L, 1);
DEFINE_STRING(string2605_cfa_setup, string2605_cfa_setup2636, "No method for this object", 25);
DEFINE_STRING(string2609_cfa_setup, string2609_cfa_setup2637, " ... ", 5);
DEFINE_STRING(string2614_cfa_setup, string2614_cfa_setup2638, "    et en plus, c'est une closure", 33);
DEFINE_STRING(string2611_cfa_setup, string2611_cfa_setup2639, "Je set un pre-clo-env...", 24);

obj_t 
module_initialization_70_cfa_setup(long checksum_4007, char *from_4008)
{
   if (CBOOL(require_initialization_114_cfa_setup))
     {
	require_initialization_114_cfa_setup = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_setup();
	cnst_init_137_cfa_setup();
	imported_modules_init_94_cfa_setup();
	toplevel_init_63_cfa_setup();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_setup()
{
   module_initialization_70___object(((long) 0), "CFA_SETUP");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_SETUP");
   module_initialization_70___reader(((long) 0), "CFA_SETUP");
   module_initialization_70___error(((long) 0), "CFA_SETUP");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_setup()
{
   {
      obj_t cnst_port_138_3999;
      cnst_port_138_3999 = open_input_string(string2615_cfa_setup);
      {
	 long i_4000;
	 i_4000 = ((long) 7);
       loop_4001:
	 {
	    bool_t test2616_4002;
	    test2616_4002 = (i_4000 == ((long) -1));
	    if (test2616_4002)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2617_4003;
		    {
		       obj_t list2618_4004;
		       {
			  obj_t arg2619_4005;
			  arg2619_4005 = BNIL;
			  list2618_4004 = MAKE_PAIR(cnst_port_138_3999, arg2619_4005);
		       }
		       arg2617_4003 = read___reader(list2618_4004);
		    }
		    CNST_TABLE_SET(i_4000, arg2617_4003);
		 }
		 {
		    int aux_4006;
		    {
		       long aux_4026;
		       aux_4026 = (i_4000 - ((long) 1));
		       aux_4006 = (int) (aux_4026);
		    }
		    {
		       long i_4029;
		       i_4029 = (long) (aux_4006);
		       i_4000 = i_4029;
		       goto loop_4001;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_setup()
{
   add_generic__110___object(node_setup__env_214_cfa_setup, node_setup__default1941_env_145_cfa_setup);
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, kwote_node_102_cfa_info, ((long) 2));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, var_ast_node, ((long) 3));
   add_generic__110___object(variable_value_setup__env_134_cfa_setup, variable_value_setup__default1946_env_130_cfa_setup);
   add_inlined_method__244___object(variable_value_setup__env_134_cfa_setup, sfun_ast_var, ((long) 0));
   add_inlined_method__244___object(variable_value_setup__env_134_cfa_setup, svar_ast_var, ((long) 1));
   add_inlined_method__244___object(variable_value_setup__env_134_cfa_setup, pre_clo_env_191_cfa_info, ((long) 2));
   add_inlined_method__244___object(variable_value_setup__env_134_cfa_setup, sexit_ast_var, ((long) 3));
   add_inlined_method__244___object(variable_value_setup__env_134_cfa_setup, scnst_cinfo_0_cfa_info, ((long) 4));
   add_inlined_method__244___object(variable_value_setup__env_134_cfa_setup, scnst_ast_var, ((long) 5));
   add_inlined_method__244___object(variable_value_setup__env_134_cfa_setup, cvar_ast_var, ((long) 6));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, closure_ast_node, ((long) 4));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, sequence_ast_node, ((long) 5));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, app_ast_node, ((long) 6));
   add_generic__110___object(fun_setup__env_196_cfa_setup, fun_setup__default1957_env_104_cfa_setup);
   add_inlined_method__244___object(fun_setup__env_196_cfa_setup, sfun_ast_var, ((long) 0));
   add_inlined_method__244___object(fun_setup__env_196_cfa_setup, cfun_ast_var, ((long) 1));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, app_ly_162_ast_node, ((long) 7));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, funcall_ast_node, ((long) 8));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, pragma_ast_node, ((long) 9));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, cast_ast_node, ((long) 10));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, setq_ast_node, ((long) 11));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, conditional_ast_node, ((long) 12));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, fail_ast_node, ((long) 13));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, select_ast_node, ((long) 14));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, let_fun_218_ast_node, ((long) 15));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, let_var_6_ast_node, ((long) 16));
   add_inlined_method__244___object(node_setup__env_214_cfa_setup, set_ex_it_116_ast_node, ((long) 17));
   {
      long aux_4061;
      aux_4061 = add_inlined_method__244___object(node_setup__env_214_cfa_setup, jump_ex_it_184_ast_node, ((long) 18));
      return BINT(aux_4061);
   }
}


obj_t 
set_initial_approx__92_cfa_setup(obj_t globals_1)
{
   {
      obj_t l1870_1991;
      {
	 bool_t aux_4064;
	 l1870_1991 = globals_1;
       lname1871_1992:
	 if (PAIRP(l1870_1991))
	   {
	      {
		 obj_t global_1994;
		 global_1994 = CAR(l1870_1991);
		 {
		    value_t fun_1995;
		    {
		       global_t obj_3192;
		       obj_3192 = (global_t) (global_1994);
		       fun_1995 = (((global_t) CREF(obj_3192))->value);
		    }
		    fun_setup__186_cfa_setup((fun_t) (fun_1995), global_1994);
		    {
		       obj_t l1872_1996;
		       {
			  sfun_t obj_3193;
			  obj_3193 = (sfun_t) (fun_1995);
			  l1872_1996 = (((sfun_t) CREF(obj_3193))->args);
		       }
		     lname1875_1997:
		       if (PAIRP(l1872_1996))
			 {
			    {
			       obj_t local_2000;
			       local_2000 = CAR(l1872_1996);
			       {
				  reshaped_local_224_t obj1876_2001;
				  obj1876_2001 = ((reshaped_local_224_t) (local_2000));
				  {
				     reshaped_local_224_t arg1975_2002;
				     {
					reshaped_local_224_t res2569_3199;
					{
					   obj_t binding_value_3_3196;
					   binding_value_3_3196 = BFALSE;
					   {
					      reshaped_local_224_t new1412_3197;
					      new1412_3197 = ((reshaped_local_224_t) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
					      ((((reshaped_local_224_t) CREF(new1412_3197))->binding_value_3) = ((obj_t) binding_value_3_3196), BUNSPEC);
					      res2569_3199 = new1412_3197;
					   }
					}
					arg1975_2002 = res2569_3199;
				     }
				     {
					obj_t aux_4080;
					object_t aux_4078;
					aux_4080 = (obj_t) (arg1975_2002);
					aux_4078 = (object_t) (obj1876_2001);
					OBJECT_WIDENING_SET(aux_4078, aux_4080);
				     }
				  }
				  {
				     long arg1976_2003;
				     arg1976_2003 = class_num_218___object(reshaped_local_224_cfa_info);
				     {
					obj_t obj_3200;
					obj_3200 = (obj_t) (obj1876_2001);
					(((obj_t) CREF(obj_3200))->header = MAKE_HEADER(arg1976_2003, 0), BUNSPEC);
				     }
				  }
				  obj1876_2001;
			       }
			       {
				  value_t aux_4086;
				  {
				     local_t obj_3202;
				     obj_3202 = (local_t) (local_2000);
				     aux_4086 = (((local_t) CREF(obj_3202))->value);
				  }
				  variable_value_setup__80_cfa_setup(aux_4086, (variable_t) (local_2000));
			       }
			    }
			    {
			       obj_t l1872_4091;
			       l1872_4091 = CDR(l1872_1996);
			       l1872_1996 = l1872_4091;
			       goto lname1875_1997;
			    }
			 }
		       else
			 {
			    ((bool_t) 1);
			 }
		    }
		 }
		 {
		    node_t aux_4095;
		    {
		       obj_t aux_4096;
		       {
			  sfun_t obj_3205;
			  {
			     value_t aux_4097;
			     {
				global_t obj_3204;
				obj_3204 = (global_t) (global_1994);
				aux_4097 = (((global_t) CREF(obj_3204))->value);
			     }
			     obj_3205 = (sfun_t) (aux_4097);
			  }
			  aux_4096 = (((sfun_t) CREF(obj_3205))->body);
		       }
		       aux_4095 = (node_t) (aux_4096);
		    }
		    node_setup__189_cfa_setup(aux_4095);
		 }
	      }
	      {
		 obj_t l1870_4104;
		 l1870_4104 = CDR(l1870_1991);
		 l1870_1991 = l1870_4104;
		 goto lname1871_1992;
	      }
	   }
	 else
	   {
	      aux_4064 = ((bool_t) 1);
	   }
	 return BBOOL(aux_4064);
      }
   }
}


obj_t 
_set_initial_approx__130_cfa_setup(obj_t env_3986, obj_t globals_3987)
{
   return set_initial_approx__92_cfa_setup(globals_3987);
}


obj_t 
node_setup__default1941_212_cfa_setup(node_t node_3)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string2605_cfa_setup, (obj_t) (node_3));
}


obj_t 
_node_setup__default1941_51_cfa_setup(obj_t env_3972, obj_t node_3973)
{
   return node_setup__default1941_212_cfa_setup((node_t) (node_3973));
}


obj_t 
node_setup__189_cfa_setup(node_t node_2)
{
 node_setup__189_cfa_setup:
   {
      obj_t method2397_2965;
      obj_t class2403_2966;
      {
	 obj_t arg2406_2963;
	 obj_t arg2407_2964;
	 {
	    object_t obj_3212;
	    obj_3212 = (object_t) (node_2);
	    {
	       obj_t pre_method_105_3213;
	       pre_method_105_3213 = PROCEDURE_REF(node_setup__env_214_cfa_setup, ((long) 2));
	       if (INTEGERP(pre_method_105_3213))
		 {
		    PROCEDURE_SET(node_setup__env_214_cfa_setup, ((long) 2), BUNSPEC);
		    arg2406_2963 = pre_method_105_3213;
		 }
	       else
		 {
		    long obj_class_num_177_3218;
		    obj_class_num_177_3218 = TYPE(obj_3212);
		    {
		       obj_t arg1183_3219;
		       arg1183_3219 = PROCEDURE_REF(node_setup__env_214_cfa_setup, ((long) 1));
		       {
			  long arg1184_3223;
			  {
			     long arg1186_3224;
			     arg1186_3224 = OBJECT_TYPE;
			     arg1184_3223 = (obj_class_num_177_3218 - arg1186_3224);
			  }
			  arg2406_2963 = VECTOR_REF(arg1183_3219, arg1184_3223);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_3229;
	    object_3229 = (object_t) (node_2);
	    {
	       long arg1187_3230;
	       {
		  long arg1188_3231;
		  long arg1189_3232;
		  arg1188_3231 = TYPE(object_3229);
		  arg1189_3232 = OBJECT_TYPE;
		  arg1187_3230 = (arg1188_3231 - arg1189_3232);
	       }
	       {
		  obj_t vector_3236;
		  vector_3236 = __classes__134___object;
		  arg2407_2964 = VECTOR_REF(vector_3236, arg1187_3230);
	       }
	    }
	 }
	 method2397_2965 = arg2406_2963;
	 class2403_2966 = arg2407_2964;
	 {
	    if (INTEGERP(method2397_2965))
	      {
		 switch ((long) CINT(method2397_2965))
		   {
		   case ((long) 0):
		      {
			 atom_t node_2972;
			 node_2972 = (atom_t) (node_2);
			 {
			    atom_cinfo_155_t obj1878_2974;
			    obj1878_2974 = ((atom_cinfo_155_t) (node_2972));
			    {
			       atom_cinfo_155_t arg2410_2975;
			       {
				  approx_t arg2417_2976;
				  {
				     type_t arg2418_2977;
				     arg2418_2977 = typeof_atom_134_type_typeof((((atom_t) CREF(node_2972))->value));
				     arg2417_2976 = make_type_approx_184_cfa_approx(arg2418_2977);
				  }
				  {
				     atom_cinfo_155_t res2570_3242;
				     {
					atom_cinfo_155_t new1441_3240;
					new1441_3240 = ((atom_cinfo_155_t) BREF(GC_MALLOC(sizeof(struct atom_cinfo_155))));
					((((atom_cinfo_155_t) CREF(new1441_3240))->approx) = ((approx_t) arg2417_2976), BUNSPEC);
					res2570_3242 = new1441_3240;
				     }
				     arg2410_2975 = res2570_3242;
				  }
			       }
			       {
				  obj_t aux_4139;
				  object_t aux_4137;
				  aux_4139 = (obj_t) (arg2410_2975);
				  aux_4137 = (object_t) (obj1878_2974);
				  OBJECT_WIDENING_SET(aux_4137, aux_4139);
			       }
			    }
			    {
			       long arg2420_2979;
			       arg2420_2979 = class_num_218___object(atom_cinfo_155_cfa_info);
			       {
				  obj_t obj_3243;
				  obj_3243 = (obj_t) (obj1878_2974);
				  (((obj_t) CREF(obj_3243))->header = MAKE_HEADER(arg2420_2979, 0), BUNSPEC);
			       }
			    }
			    return (obj_t) (obj1878_2974);
			 }
		      }
		      break;
		   case ((long) 1):
		      {
			 kwote_t node_2980;
			 node_2980 = (kwote_t) (node_2);
			 {
			    kwote_cinfo_48_t obj1880_2982;
			    obj1880_2982 = ((kwote_cinfo_48_t) (node_2980));
			    {
			       kwote_cinfo_48_t arg2421_2983;
			       {
				  approx_t arg2422_2984;
				  {
				     type_t arg2423_2985;
				     arg2423_2985 = typeof_kwote_49_type_typeof((((kwote_t) CREF(node_2980))->value));
				     arg2422_2984 = make_type_approx_184_cfa_approx(arg2423_2985);
				  }
				  {
				     kwote_cinfo_48_t res2571_3249;
				     {
					kwote_cinfo_48_t new1456_3247;
					new1456_3247 = ((kwote_cinfo_48_t) BREF(GC_MALLOC(sizeof(struct kwote_cinfo_48))));
					((((kwote_cinfo_48_t) CREF(new1456_3247))->approx) = ((approx_t) arg2422_2984), BUNSPEC);
					res2571_3249 = new1456_3247;
				     }
				     arg2421_2983 = res2571_3249;
				  }
			       }
			       {
				  obj_t aux_4155;
				  object_t aux_4153;
				  aux_4155 = (obj_t) (arg2421_2983);
				  aux_4153 = (object_t) (obj1880_2982);
				  OBJECT_WIDENING_SET(aux_4153, aux_4155);
			       }
			    }
			    {
			       long arg2425_2987;
			       arg2425_2987 = class_num_218___object(kwote_cinfo_48_cfa_info);
			       {
				  obj_t obj_3250;
				  obj_3250 = (obj_t) (obj1880_2982);
				  (((obj_t) CREF(obj_3250))->header = MAKE_HEADER(arg2425_2987, 0), BUNSPEC);
			       }
			    }
			    return (obj_t) (obj1880_2982);
			 }
		      }
		      break;
		   case ((long) 2):
		      {
			 kwote_node_102_t kwote_2988;
			 kwote_2988 = (kwote_node_102_t) (node_2);
			 {
			    node_t node_4163;
			    {
			       obj_t aux_4164;
			       {
				  object_t aux_4165;
				  aux_4165 = (object_t) (kwote_2988);
				  aux_4164 = OBJECT_WIDENING(aux_4165);
			       }
			       node_4163 = (((kwote_node_102_t) CREF(aux_4164))->node);
			    }
			    node_2 = node_4163;
			    goto node_setup__189_cfa_setup;
			 }
		      }
		      break;
		   case ((long) 3):
		      {
			 var_t node_2991;
			 node_2991 = (var_t) (node_2);
			 {
			    value_t aux_4170;
			    {
			       variable_t arg2429_2995;
			       arg2429_2995 = (((var_t) CREF(node_2991))->variable);
			       aux_4170 = (((variable_t) CREF(arg2429_2995))->value);
			    }
			    variable_value_setup__80_cfa_setup(aux_4170, (((var_t) CREF(node_2991))->variable));
			 }
			 {
			    bool_t test2430_2996;
			    {
			       bool_t test2440_3008;
			       {
				  obj_t aux_4175;
				  {
				     variable_t aux_4176;
				     aux_4176 = (((var_t) CREF(node_2991))->variable);
				     aux_4175 = (obj_t) (aux_4176);
				  }
				  test2440_3008 = is_a__118___object(aux_4175, local_ast_var);
			       }
			       if (test2440_3008)
				 {
				    bool_t test2441_3009;
				    {
				       obj_t aux_4181;
				       {
					  variable_t aux_4182;
					  aux_4182 = (((var_t) CREF(node_2991))->variable);
					  aux_4181 = (obj_t) (aux_4182);
				       }
				       test2441_3009 = is_a__118___object(aux_4181, reshaped_local_224_cfa_info);
				    }
				    if (test2441_3009)
				      {
					 test2430_2996 = ((bool_t) 0);
				      }
				    else
				      {
					 test2430_2996 = ((bool_t) 1);
				      }
				 }
			       else
				 {
				    test2430_2996 = ((bool_t) 0);
				 }
			    }
			    if (test2430_2996)
			      {
				 {
				    reshaped_local_224_t obj1883_2997;
				    obj1883_2997 = ((reshaped_local_224_t) ((((var_t) CREF(node_2991))->variable)));
				    {
				       reshaped_local_224_t arg2431_2998;
				       {
					  reshaped_local_224_t res2572_3264;
					  {
					     obj_t binding_value_3_3261;
					     binding_value_3_3261 = BFALSE;
					     {
						reshaped_local_224_t new1412_3262;
						new1412_3262 = ((reshaped_local_224_t) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
						((((reshaped_local_224_t) CREF(new1412_3262))->binding_value_3) = ((obj_t) binding_value_3_3261), BUNSPEC);
						res2572_3264 = new1412_3262;
					     }
					  }
					  arg2431_2998 = res2572_3264;
				       }
				       {
					  obj_t aux_4194;
					  object_t aux_4192;
					  aux_4194 = (obj_t) (arg2431_2998);
					  aux_4192 = (object_t) (obj1883_2997);
					  OBJECT_WIDENING_SET(aux_4192, aux_4194);
				       }
				    }
				    {
				       long arg2432_2999;
				       arg2432_2999 = class_num_218___object(reshaped_local_224_cfa_info);
				       {
					  obj_t obj_3265;
					  obj_3265 = (obj_t) (obj1883_2997);
					  (((obj_t) CREF(obj_3265))->header = MAKE_HEADER(arg2432_2999, 0), BUNSPEC);
				       }
				    }
				    return (obj_t) (obj1883_2997);
				 }
			      }
			    else
			      {
				 bool_t test2433_3000;
				 {
				    bool_t test2436_3004;
				    {
				       obj_t aux_4201;
				       {
					  variable_t aux_4202;
					  aux_4202 = (((var_t) CREF(node_2991))->variable);
					  aux_4201 = (obj_t) (aux_4202);
				       }
				       test2436_3004 = is_a__118___object(aux_4201, global_ast_var);
				    }
				    if (test2436_3004)
				      {
					 bool_t test2437_3005;
					 {
					    obj_t aux_4207;
					    {
					       variable_t aux_4208;
					       aux_4208 = (((var_t) CREF(node_2991))->variable);
					       aux_4207 = (obj_t) (aux_4208);
					    }
					    test2437_3005 = is_a__118___object(aux_4207, reshaped_global_160_cfa_info);
					 }
					 if (test2437_3005)
					   {
					      test2433_3000 = ((bool_t) 0);
					   }
					 else
					   {
					      test2433_3000 = ((bool_t) 1);
					   }
				      }
				    else
				      {
					 test2433_3000 = ((bool_t) 0);
				      }
				 }
				 if (test2433_3000)
				   {
				      {
					 reshaped_global_160_t obj1885_3001;
					 obj1885_3001 = ((reshaped_global_160_t) ((((var_t) CREF(node_2991))->variable)));
					 {
					    obj_t aux_4218;
					    object_t aux_4216;
					    {
					       reshaped_global_160_t aux_4219;
					       {
						  aux_4219 = ((reshaped_global_160_t) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
					       }
					       aux_4218 = (obj_t) (aux_4219);
					    }
					    aux_4216 = (object_t) (obj1885_3001);
					    OBJECT_WIDENING_SET(aux_4216, aux_4218);
					 }
					 {
					    long arg2435_3003;
					    arg2435_3003 = class_num_218___object(reshaped_global_160_cfa_info);
					    {
					       obj_t obj_3274;
					       obj_3274 = (obj_t) (obj1885_3001);
					       (((obj_t) CREF(obj_3274))->header = MAKE_HEADER(arg2435_3003, 0), BUNSPEC);
					    }
					 }
					 return (obj_t) (obj1885_3001);
				      }
				   }
				 else
				   {
				      return BFALSE;
				   }
			      }
			 }
		      }
		      break;
		   case ((long) 4):
		      {
			 obj_t arg2446_3015;
			 {
			    obj_t aux_4227;
			    {
			       closure_t aux_4228;
			       aux_4228 = (closure_t) (node_2);
			       aux_4227 = (obj_t) (aux_4228);
			    }
			    arg2446_3015 = shape_tools_shape(aux_4227);
			 }
			 return internal_error_43_tools_error(string2606_cfa_setup, string2607_cfa_setup, arg2446_3015);
		      }
		      break;
		   case ((long) 5):
		      {
			 sequence_t node_3016;
			 node_3016 = (sequence_t) (node_2);
			 return node_setup___185_cfa_setup((((sequence_t) CREF(node_3016))->nodes));
		      }
		      break;
		   case ((long) 6):
		      {
			 app_t node_3019;
			 node_3019 = (app_t) (node_2);
			 node_setup___185_cfa_setup((((app_t) CREF(node_3019))->args));
			 {
			    variable_t variable_3022;
			    {
			       var_t arg2450_3024;
			       arg2450_3024 = (((app_t) CREF(node_3019))->fun);
			       variable_3022 = (((var_t) CREF(arg2450_3024))->variable);
			    }
			    {
			       fun_t aux_4241;
			       {
				  value_t aux_4242;
				  aux_4242 = (((variable_t) CREF(variable_3022))->value);
				  aux_4241 = (fun_t) (aux_4242);
			       }
			       return fun_setup__186_cfa_setup(aux_4241, (obj_t) (variable_3022));
			    }
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 app_ly_162_t node_3025;
			 node_3025 = (app_ly_162_t) (node_2);
			 node_setup__189_cfa_setup((((app_ly_162_t) CREF(node_3025))->fun));
			 node_setup__189_cfa_setup((((app_ly_162_t) CREF(node_3025))->arg));
			 {
			    app_ly_cinfo_234_t obj1902_3029;
			    obj1902_3029 = ((app_ly_cinfo_234_t) (node_3025));
			    {
			       app_ly_cinfo_234_t arg2453_3030;
			       {
				  approx_t arg2454_3031;
				  arg2454_3031 = make_type_approx_184_cfa_approx((type_t) (__obj__252_type_cache));
				  {
				     app_ly_cinfo_234_t res2574_3286;
				     {
					app_ly_cinfo_234_t new1463_3284;
					new1463_3284 = ((app_ly_cinfo_234_t) BREF(GC_MALLOC(sizeof(struct app_ly_cinfo_234))));
					((((app_ly_cinfo_234_t) CREF(new1463_3284))->approx) = ((approx_t) arg2454_3031), BUNSPEC);
					res2574_3286 = new1463_3284;
				     }
				     arg2453_3030 = res2574_3286;
				  }
			       }
			       {
				  obj_t aux_4259;
				  object_t aux_4257;
				  aux_4259 = (obj_t) (arg2453_3030);
				  aux_4257 = (object_t) (obj1902_3029);
				  OBJECT_WIDENING_SET(aux_4257, aux_4259);
			       }
			    }
			    {
			       long arg2455_3032;
			       arg2455_3032 = class_num_218___object(app_ly_cinfo_234_cfa_info);
			       {
				  obj_t obj_3287;
				  obj_3287 = (obj_t) (obj1902_3029);
				  (((obj_t) CREF(obj_3287))->header = MAKE_HEADER(arg2455_3032, 0), BUNSPEC);
			       }
			    }
			    obj1902_3029;
			 }
			 {
			    approx_t aux_4265;
			    {
			       app_ly_cinfo_234_t obj_3289;
			       obj_3289 = (app_ly_cinfo_234_t) (node_3025);
			       {
				  obj_t aux_4267;
				  {
				     object_t aux_4268;
				     aux_4268 = (object_t) (obj_3289);
				     aux_4267 = OBJECT_WIDENING(aux_4268);
				  }
				  aux_4265 = (((app_ly_cinfo_234_t) CREF(aux_4267))->approx);
			       }
			    }
			    return approx_set_top__187_cfa_approx(aux_4265);
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 funcall_t node_3034;
			 node_3034 = (funcall_t) (node_2);
			 node_setup__189_cfa_setup((((funcall_t) CREF(node_3034))->fun));
			 node_setup___185_cfa_setup((((funcall_t) CREF(node_3034))->args));
			 {
			    funcall_cinfo_75_t obj1904_3038;
			    obj1904_3038 = ((funcall_cinfo_75_t) (node_3034));
			    {
			       funcall_cinfo_75_t arg2459_3039;
			       {
				  approx_t arg2460_3040;
				  approx_t arg2461_3041;
				  bool_t arg2462_3042;
				  bool_t arg2463_3043;
				  arg2460_3040 = make_type_approx_184_cfa_approx((type_t) (__obj__252_type_cache));
				  arg2461_3041 = make_type_approx_184_cfa_approx((type_t) (__obj__252_type_cache));
				  if (CBOOL(__warning__61___error))
				    {
				       arg2462_3042 = ((bool_t) 0);
				    }
				  else
				    {
				       arg2462_3042 = ((bool_t) 1);
				    }
				  if (CBOOL(__warning__61___error))
				    {
				       arg2463_3043 = ((bool_t) 0);
				    }
				  else
				    {
				       arg2463_3043 = ((bool_t) 1);
				    }
				  {
				     funcall_cinfo_75_t res2575_3301;
				     {
					funcall_cinfo_75_t new1472_3296;
					new1472_3296 = ((funcall_cinfo_75_t) BREF(GC_MALLOC(sizeof(struct funcall_cinfo_75))));
					((((funcall_cinfo_75_t) CREF(new1472_3296))->approx) = ((approx_t) arg2460_3040), BUNSPEC);
					((((funcall_cinfo_75_t) CREF(new1472_3296))->va_approx_63) = ((approx_t) arg2461_3041), BUNSPEC);
					((((funcall_cinfo_75_t) CREF(new1472_3296))->arity_error_noticed__118) = ((bool_t) arg2462_3042), BUNSPEC);
					((((funcall_cinfo_75_t) CREF(new1472_3296))->type_error_noticed__36) = ((bool_t) arg2463_3043), BUNSPEC);
					res2575_3301 = new1472_3296;
				     }
				     arg2459_3039 = res2575_3301;
				  }
			       }
			       {
				  obj_t aux_4294;
				  object_t aux_4292;
				  aux_4294 = (obj_t) (arg2459_3039);
				  aux_4292 = (object_t) (obj1904_3038);
				  OBJECT_WIDENING_SET(aux_4292, aux_4294);
			       }
			    }
			    {
			       long arg2464_3044;
			       arg2464_3044 = class_num_218___object(funcall_cinfo_75_cfa_info);
			       {
				  obj_t obj_3302;
				  obj_3302 = (obj_t) (obj1904_3038);
				  (((obj_t) CREF(obj_3302))->header = MAKE_HEADER(arg2464_3044, 0), BUNSPEC);
			       }
			    }
			    obj1904_3038;
			 }
			 {
			    approx_t aux_4300;
			    {
			       funcall_cinfo_75_t obj_3304;
			       obj_3304 = (funcall_cinfo_75_t) (node_3034);
			       {
				  obj_t aux_4302;
				  {
				     object_t aux_4303;
				     aux_4303 = (object_t) (obj_3304);
				     aux_4302 = OBJECT_WIDENING(aux_4303);
				  }
				  aux_4300 = (((funcall_cinfo_75_t) CREF(aux_4302))->va_approx_63);
			       }
			    }
			    return approx_set_top__187_cfa_approx(aux_4300);
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 pragma_t node_3046;
			 node_3046 = (pragma_t) (node_2);
			 node_setup___185_cfa_setup((((pragma_t) CREF(node_3046))->args));
			 {
			    pragma_cinfo_220_t obj1906_3049;
			    obj1906_3049 = ((pragma_cinfo_220_t) (node_3046));
			    {
			       pragma_cinfo_220_t arg2469_3050;
			       {
				  approx_t arg2470_3051;
				  arg2470_3051 = make_type_approx_184_cfa_approx((((pragma_t) CREF(node_3046))->type));
				  {
				     pragma_cinfo_220_t res2576_3310;
				     {
					pragma_cinfo_220_t new1484_3308;
					new1484_3308 = ((pragma_cinfo_220_t) BREF(GC_MALLOC(sizeof(struct pragma_cinfo_220))));
					((((pragma_cinfo_220_t) CREF(new1484_3308))->approx) = ((approx_t) arg2470_3051), BUNSPEC);
					res2576_3310 = new1484_3308;
				     }
				     arg2469_3050 = res2576_3310;
				  }
			       }
			       {
				  obj_t aux_4318;
				  object_t aux_4316;
				  aux_4318 = (obj_t) (arg2469_3050);
				  aux_4316 = (object_t) (obj1906_3049);
				  OBJECT_WIDENING_SET(aux_4316, aux_4318);
			       }
			    }
			    {
			       long arg2472_3053;
			       arg2472_3053 = class_num_218___object(pragma_cinfo_220_cfa_info);
			       {
				  obj_t obj_3311;
				  obj_3311 = (obj_t) (obj1906_3049);
				  (((obj_t) CREF(obj_3311))->header = MAKE_HEADER(arg2472_3053, 0), BUNSPEC);
			       }
			    }
			    obj1906_3049;
			 }
			 {
			    approx_t aux_4324;
			    {
			       pragma_cinfo_220_t obj_3313;
			       obj_3313 = (pragma_cinfo_220_t) (node_3046);
			       {
				  obj_t aux_4326;
				  {
				     object_t aux_4327;
				     aux_4327 = (object_t) (obj_3313);
				     aux_4326 = OBJECT_WIDENING(aux_4327);
				  }
				  aux_4324 = (((pragma_cinfo_220_t) CREF(aux_4326))->approx);
			       }
			    }
			    return approx_set_top__187_cfa_approx(aux_4324);
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 cast_t node_3055;
			 node_3055 = (cast_t) (node_2);
			 {
			    node_t node_4333;
			    node_4333 = (((cast_t) CREF(node_3055))->arg);
			    node_2 = node_4333;
			    goto node_setup__189_cfa_setup;
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 setq_t node_3058;
			 node_3058 = (setq_t) (node_2);
			 node_setup__189_cfa_setup((((setq_t) CREF(node_3058))->value));
			 {
			    node_t aux_4338;
			    {
			       var_t aux_4339;
			       aux_4339 = (((setq_t) CREF(node_3058))->var);
			       aux_4338 = (node_t) (aux_4339);
			    }
			    node_setup__189_cfa_setup(aux_4338);
			 }
			 {
			    setq_cinfo_191_t obj1909_3062;
			    obj1909_3062 = ((setq_cinfo_191_t) (node_3058));
			    {
			       setq_cinfo_191_t arg2477_3063;
			       {
				  approx_t arg2478_3064;
				  arg2478_3064 = make_type_approx_184_cfa_approx((type_t) (__unspec__87_type_cache));
				  {
				     setq_cinfo_191_t res2577_3320;
				     {
					setq_cinfo_191_t new1493_3318;
					new1493_3318 = ((setq_cinfo_191_t) BREF(GC_MALLOC(sizeof(struct setq_cinfo_191))));
					((((setq_cinfo_191_t) CREF(new1493_3318))->approx) = ((approx_t) arg2478_3064), BUNSPEC);
					res2577_3320 = new1493_3318;
				     }
				     arg2477_3063 = res2577_3320;
				  }
			       }
			       {
				  obj_t aux_4350;
				  object_t aux_4348;
				  aux_4350 = (obj_t) (arg2477_3063);
				  aux_4348 = (object_t) (obj1909_3062);
				  OBJECT_WIDENING_SET(aux_4348, aux_4350);
			       }
			    }
			    {
			       long arg2479_3065;
			       arg2479_3065 = class_num_218___object(setq_cinfo_191_cfa_info);
			       {
				  obj_t obj_3321;
				  obj_3321 = (obj_t) (obj1909_3062);
				  (((obj_t) CREF(obj_3321))->header = MAKE_HEADER(arg2479_3065, 0), BUNSPEC);
			       }
			    }
			    return (obj_t) (obj1909_3062);
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 conditional_t node_3066;
			 node_3066 = (conditional_t) (node_2);
			 node_setup__189_cfa_setup((((conditional_t) CREF(node_3066))->test));
			 node_setup__189_cfa_setup((((conditional_t) CREF(node_3066))->true));
			 node_setup__189_cfa_setup((((conditional_t) CREF(node_3066))->false));
			 {
			    conditional_cinfo_212_t obj1911_3071;
			    obj1911_3071 = ((conditional_cinfo_212_t) (node_3066));
			    {
			       conditional_cinfo_212_t arg2485_3072;
			       {
				  approx_t arg2486_3073;
				  arg2486_3073 = make_empty_approx_131_cfa_approx();
				  {
				     conditional_cinfo_212_t res2578_3329;
				     {
					conditional_cinfo_212_t new1502_3327;
					new1502_3327 = ((conditional_cinfo_212_t) BREF(GC_MALLOC(sizeof(struct conditional_cinfo_212))));
					((((conditional_cinfo_212_t) CREF(new1502_3327))->approx) = ((approx_t) arg2486_3073), BUNSPEC);
					res2578_3329 = new1502_3327;
				     }
				     arg2485_3072 = res2578_3329;
				  }
			       }
			       {
				  obj_t aux_4370;
				  object_t aux_4368;
				  aux_4370 = (obj_t) (arg2485_3072);
				  aux_4368 = (object_t) (obj1911_3071);
				  OBJECT_WIDENING_SET(aux_4368, aux_4370);
			       }
			    }
			    {
			       long arg2487_3074;
			       arg2487_3074 = class_num_218___object(conditional_cinfo_212_cfa_info);
			       {
				  obj_t obj_3330;
				  obj_3330 = (obj_t) (obj1911_3071);
				  (((obj_t) CREF(obj_3330))->header = MAKE_HEADER(arg2487_3074, 0), BUNSPEC);
			       }
			    }
			    return (obj_t) (obj1911_3071);
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 fail_t node_3075;
			 node_3075 = (fail_t) (node_2);
			 node_setup__189_cfa_setup((((fail_t) CREF(node_3075))->proc));
			 node_setup__189_cfa_setup((((fail_t) CREF(node_3075))->msg));
			 node_setup__189_cfa_setup((((fail_t) CREF(node_3075))->obj));
			 {
			    fail_cinfo_75_t obj1913_3080;
			    obj1913_3080 = ((fail_cinfo_75_t) (node_3075));
			    {
			       fail_cinfo_75_t arg2491_3081;
			       {
				  approx_t arg2492_3082;
				  arg2492_3082 = make_type_approx_184_cfa_approx((type_t) (__obj__252_type_cache));
				  {
				     fail_cinfo_75_t res2579_3338;
				     {
					fail_cinfo_75_t new1513_3336;
					new1513_3336 = ((fail_cinfo_75_t) BREF(GC_MALLOC(sizeof(struct fail_cinfo_75))));
					((((fail_cinfo_75_t) CREF(new1513_3336))->approx) = ((approx_t) arg2492_3082), BUNSPEC);
					res2579_3338 = new1513_3336;
				     }
				     arg2491_3081 = res2579_3338;
				  }
			       }
			       {
				  obj_t aux_4391;
				  object_t aux_4389;
				  aux_4391 = (obj_t) (arg2491_3081);
				  aux_4389 = (object_t) (obj1913_3080);
				  OBJECT_WIDENING_SET(aux_4389, aux_4391);
			       }
			    }
			    {
			       long arg2493_3083;
			       arg2493_3083 = class_num_218___object(fail_cinfo_75_cfa_info);
			       {
				  obj_t obj_3339;
				  obj_3339 = (obj_t) (obj1913_3080);
				  (((obj_t) CREF(obj_3339))->header = MAKE_HEADER(arg2493_3083, 0), BUNSPEC);
			       }
			    }
			    return (obj_t) (obj1913_3080);
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 select_t node_3084;
			 node_3084 = (select_t) (node_2);
			 node_setup__189_cfa_setup((((select_t) CREF(node_3084))->test));
			 {
			    obj_t l1915_3087;
			    l1915_3087 = (((select_t) CREF(node_3084))->clauses);
			  lname1916_3088:
			    if (PAIRP(l1915_3087))
			      {
				 {
				    node_t aux_4403;
				    {
				       obj_t aux_4404;
				       {
					  obj_t aux_4405;
					  aux_4405 = CAR(l1915_3087);
					  aux_4404 = CDR(aux_4405);
				       }
				       aux_4403 = (node_t) (aux_4404);
				    }
				    node_setup__189_cfa_setup(aux_4403);
				 }
				 {
				    obj_t l1915_4410;
				    l1915_4410 = CDR(l1915_3087);
				    l1915_3087 = l1915_4410;
				    goto lname1916_3088;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    select_cinfo_150_t obj1917_3094;
			    obj1917_3094 = ((select_cinfo_150_t) (node_3084));
			    {
			       select_cinfo_150_t arg2499_3095;
			       {
				  approx_t arg2500_3096;
				  arg2500_3096 = make_empty_approx_131_cfa_approx();
				  {
				     select_cinfo_150_t res2580_3350;
				     {
					select_cinfo_150_t new1524_3348;
					new1524_3348 = ((select_cinfo_150_t) BREF(GC_MALLOC(sizeof(struct select_cinfo_150))));
					((((select_cinfo_150_t) CREF(new1524_3348))->approx) = ((approx_t) arg2500_3096), BUNSPEC);
					res2580_3350 = new1524_3348;
				     }
				     arg2499_3095 = res2580_3350;
				  }
			       }
			       {
				  obj_t aux_4419;
				  object_t aux_4417;
				  aux_4419 = (obj_t) (arg2499_3095);
				  aux_4417 = (object_t) (obj1917_3094);
				  OBJECT_WIDENING_SET(aux_4417, aux_4419);
			       }
			    }
			    {
			       long arg2501_3097;
			       arg2501_3097 = class_num_218___object(select_cinfo_150_cfa_info);
			       {
				  obj_t obj_3351;
				  obj_3351 = (obj_t) (obj1917_3094);
				  (((obj_t) CREF(obj_3351))->header = MAKE_HEADER(arg2501_3097, 0), BUNSPEC);
			       }
			    }
			    return (obj_t) (obj1917_3094);
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 let_fun_218_t node_3098;
			 node_3098 = (let_fun_218_t) (node_2);
			 {
			    obj_t l1919_3100;
			    l1919_3100 = (((let_fun_218_t) CREF(node_3098))->locals);
			  lname1923_3101:
			    if (PAIRP(l1919_3100))
			      {
				 {
				    obj_t l_3104;
				    l_3104 = CAR(l1919_3100);
				    {
				       reshaped_local_224_t obj1924_3105;
				       obj1924_3105 = ((reshaped_local_224_t) (l_3104));
				       {
					  reshaped_local_224_t arg2504_3106;
					  {
					     reshaped_local_224_t res2581_3359;
					     {
						obj_t binding_value_3_3356;
						binding_value_3_3356 = BFALSE;
						{
						   reshaped_local_224_t new1412_3357;
						   new1412_3357 = ((reshaped_local_224_t) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
						   ((((reshaped_local_224_t) CREF(new1412_3357))->binding_value_3) = ((obj_t) binding_value_3_3356), BUNSPEC);
						   res2581_3359 = new1412_3357;
						}
					     }
					     arg2504_3106 = res2581_3359;
					  }
					  {
					     obj_t aux_4435;
					     object_t aux_4433;
					     aux_4435 = (obj_t) (arg2504_3106);
					     aux_4433 = (object_t) (obj1924_3105);
					     OBJECT_WIDENING_SET(aux_4433, aux_4435);
					  }
				       }
				       {
					  long arg2506_3107;
					  arg2506_3107 = class_num_218___object(reshaped_local_224_cfa_info);
					  {
					     obj_t obj_3360;
					     obj_3360 = (obj_t) (obj1924_3105);
					     (((obj_t) CREF(obj_3360))->header = MAKE_HEADER(arg2506_3107, 0), BUNSPEC);
					  }
				       }
				       obj1924_3105;
				    }
				    {
				       value_t fun_3108;
				       {
					  local_t obj_3362;
					  obj_3362 = (local_t) (l_3104);
					  fun_3108 = (((local_t) CREF(obj_3362))->value);
				       }
				       {
					  obj_t l1925_3109;
					  {
					     sfun_t obj_3363;
					     obj_3363 = (sfun_t) (fun_3108);
					     l1925_3109 = (((sfun_t) CREF(obj_3363))->args);
					  }
					lname1927_3110:
					  if (PAIRP(l1925_3109))
					    {
					       {
						  obj_t local_3113;
						  local_3113 = CAR(l1925_3109);
						  {
						     reshaped_local_224_t obj1929_3114;
						     obj1929_3114 = ((reshaped_local_224_t) (local_3113));
						     {
							reshaped_local_224_t arg2509_3115;
							{
							   reshaped_local_224_t res2582_3369;
							   {
							      obj_t binding_value_3_3366;
							      binding_value_3_3366 = BFALSE;
							      {
								 reshaped_local_224_t new1412_3367;
								 new1412_3367 = ((reshaped_local_224_t) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
								 ((((reshaped_local_224_t) CREF(new1412_3367))->binding_value_3) = ((obj_t) binding_value_3_3366), BUNSPEC);
								 res2582_3369 = new1412_3367;
							      }
							   }
							   arg2509_3115 = res2582_3369;
							}
							{
							   obj_t aux_4451;
							   object_t aux_4449;
							   aux_4451 = (obj_t) (arg2509_3115);
							   aux_4449 = (object_t) (obj1929_3114);
							   OBJECT_WIDENING_SET(aux_4449, aux_4451);
							}
						     }
						     {
							long arg2511_3116;
							arg2511_3116 = class_num_218___object(reshaped_local_224_cfa_info);
							{
							   obj_t obj_3370;
							   obj_3370 = (obj_t) (obj1929_3114);
							   (((obj_t) CREF(obj_3370))->header = MAKE_HEADER(arg2511_3116, 0), BUNSPEC);
							}
						     }
						     obj1929_3114;
						  }
						  {
						     value_t aux_4457;
						     {
							local_t obj_3372;
							obj_3372 = (local_t) (local_3113);
							aux_4457 = (((local_t) CREF(obj_3372))->value);
						     }
						     variable_value_setup__80_cfa_setup(aux_4457, (variable_t) (local_3113));
						  }
					       }
					       {
						  obj_t l1925_4462;
						  l1925_4462 = CDR(l1925_3109);
						  l1925_3109 = l1925_4462;
						  goto lname1927_3110;
					       }
					    }
					  else
					    {
					       ((bool_t) 1);
					    }
				       }
				       {
					  node_t aux_4466;
					  {
					     obj_t aux_4467;
					     {
						sfun_t obj_3374;
						obj_3374 = (sfun_t) (fun_3108);
						aux_4467 = (((sfun_t) CREF(obj_3374))->body);
					     }
					     aux_4466 = (node_t) (aux_4467);
					  }
					  node_setup__189_cfa_setup(aux_4466);
				       }
				    }
				 }
				 {
				    obj_t l1919_4472;
				    l1919_4472 = CDR(l1919_3100);
				    l1919_3100 = l1919_4472;
				    goto lname1923_3101;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    node_t node_4475;
			    node_4475 = (((let_fun_218_t) CREF(node_3098))->body);
			    node_2 = node_4475;
			    goto node_setup__189_cfa_setup;
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 let_var_6_t node_3122;
			 node_3122 = (let_var_6_t) (node_2);
			 {
			    bool_t test2519_3124;
			    {
			       obj_t aux_4478;
			       aux_4478 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 3)));
			       test2519_3124 = CBOOL(aux_4478);
			    }
			    if (test2519_3124)
			      {
				 obj_t list2520_3125;
				 {
				    obj_t arg2522_3127;
				    {
				       obj_t aux_4484;
				       aux_4484 = BCHAR(((unsigned char) '\n'));
				       arg2522_3127 = MAKE_PAIR(aux_4484, BNIL);
				    }
				    list2520_3125 = MAKE_PAIR(string2608_cfa_setup, arg2522_3127);
				 }
				 print_trace_107_tools_trace(list2520_3125);
			      }
			    else
			      {
				 BUNSPEC;
			      }
			 }
			 {
			    obj_t l1931_3131;
			    l1931_3131 = (((let_var_6_t) CREF(node_3122))->bindings);
			  lname1932_3132:
			    if (PAIRP(l1931_3131))
			      {
				 {
				    obj_t binding_3135;
				    binding_3135 = CAR(l1931_3131);
				    {
				       obj_t var_3136;
				       obj_t val_3137;
				       var_3136 = CAR(binding_3135);
				       val_3137 = CDR(binding_3135);
				       {
					  value_t aux_4494;
					  {
					     local_t obj_3382;
					     obj_3382 = (local_t) (var_3136);
					     aux_4494 = (((local_t) CREF(obj_3382))->value);
					  }
					  variable_value_setup__80_cfa_setup(aux_4494, (variable_t) (var_3136));
				       }
				       {
					  reshaped_local_224_t obj1933_3139;
					  obj1933_3139 = ((reshaped_local_224_t) (var_3136));
					  {
					     reshaped_local_224_t arg2530_3140;
					     {
						obj_t arg2531_3141;
						{
						   bool_t test_4500;
						   {
						      obj_t aux_4504;
						      obj_t aux_4501;
						      aux_4504 = CNST_TABLE_REF(((long) 2));
						      {
							 local_t obj_3383;
							 obj_3383 = (local_t) (var_3136);
							 aux_4501 = (((local_t) CREF(obj_3383))->access);
						      }
						      test_4500 = (aux_4501 == aux_4504);
						   }
						   if (test_4500)
						     {
							arg2531_3141 = val_3137;
						     }
						   else
						     {
							arg2531_3141 = BFALSE;
						     }
						}
						{
						   reshaped_local_224_t res2583_3389;
						   {
						      reshaped_local_224_t new1412_3387;
						      new1412_3387 = ((reshaped_local_224_t) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
						      ((((reshaped_local_224_t) CREF(new1412_3387))->binding_value_3) = ((obj_t) arg2531_3141), BUNSPEC);
						      res2583_3389 = new1412_3387;
						   }
						   arg2530_3140 = res2583_3389;
						}
					     }
					     {
						obj_t aux_4511;
						object_t aux_4509;
						aux_4511 = (obj_t) (arg2530_3140);
						aux_4509 = (object_t) (obj1933_3139);
						OBJECT_WIDENING_SET(aux_4509, aux_4511);
					     }
					  }
					  {
					     long arg2535_3145;
					     arg2535_3145 = class_num_218___object(reshaped_local_224_cfa_info);
					     {
						obj_t obj_3390;
						obj_3390 = (obj_t) (obj1933_3139);
						(((obj_t) CREF(obj_3390))->header = MAKE_HEADER(arg2535_3145, 0), BUNSPEC);
					     }
					  }
					  obj1933_3139;
				       }
				       node_setup__189_cfa_setup((node_t) (val_3137));
				       {
					  bool_t test2536_3146;
					  {
					     obj_t aux_4519;
					     aux_4519 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 3)));
					     test2536_3146 = CBOOL(aux_4519);
					  }
					  if (test2536_3146)
					    {
					       obj_t arg2538_3148;
					       arg2538_3148 = shape_tools_shape(var_3136);
					       {
						  obj_t list2540_3150;
						  {
						     obj_t arg2541_3151;
						     {
							obj_t arg2542_3152;
							{
							   obj_t arg2543_3153;
							   {
							      obj_t aux_4526;
							      aux_4526 = BCHAR(((unsigned char) '\n'));
							      arg2543_3153 = MAKE_PAIR(aux_4526, BNIL);
							   }
							   arg2542_3152 = MAKE_PAIR(string2609_cfa_setup, arg2543_3153);
							}
							arg2541_3151 = MAKE_PAIR(arg2538_3148, arg2542_3152);
						     }
						     list2540_3150 = MAKE_PAIR(string2610_cfa_setup, arg2541_3151);
						  }
						  print_trace_107_tools_trace(list2540_3150);
					       }
					    }
					  else
					    {
					       BUNSPEC;
					    }
				       }
				    }
				 }
				 {
				    obj_t l1931_4533;
				    l1931_4533 = CDR(l1931_3131);
				    l1931_3131 = l1931_4533;
				    goto lname1932_3132;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    node_t node_4536;
			    node_4536 = (((let_var_6_t) CREF(node_3122))->body);
			    node_2 = node_4536;
			    goto node_setup__189_cfa_setup;
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 set_ex_it_116_t node_3159;
			 node_3159 = (set_ex_it_116_t) (node_2);
			 node_setup__189_cfa_setup((((set_ex_it_116_t) CREF(node_3159))->body));
			 {
			    node_t aux_4541;
			    {
			       var_t aux_4542;
			       aux_4542 = (((set_ex_it_116_t) CREF(node_3159))->var);
			       aux_4541 = (node_t) (aux_4542);
			    }
			    node_setup__189_cfa_setup(aux_4541);
			 }
			 {
			    reshaped_local_224_t obj1935_3163;
			    {
			       variable_t aux_4546;
			       {
				  var_t arg2553_3166;
				  arg2553_3166 = (((set_ex_it_116_t) CREF(node_3159))->var);
				  aux_4546 = (((var_t) CREF(arg2553_3166))->variable);
			       }
			       obj1935_3163 = ((reshaped_local_224_t) (aux_4546));
			    }
			    {
			       reshaped_local_224_t arg2551_3164;
			       {
				  reshaped_local_224_t res2584_3401;
				  {
				     obj_t binding_value_3_3398;
				     binding_value_3_3398 = BFALSE;
				     {
					reshaped_local_224_t new1412_3399;
					new1412_3399 = ((reshaped_local_224_t) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
					((((reshaped_local_224_t) CREF(new1412_3399))->binding_value_3) = ((obj_t) binding_value_3_3398), BUNSPEC);
					res2584_3401 = new1412_3399;
				     }
				  }
				  arg2551_3164 = res2584_3401;
			       }
			       {
				  obj_t aux_4554;
				  object_t aux_4552;
				  aux_4554 = (obj_t) (arg2551_3164);
				  aux_4552 = (object_t) (obj1935_3163);
				  OBJECT_WIDENING_SET(aux_4552, aux_4554);
			       }
			    }
			    {
			       long arg2552_3165;
			       arg2552_3165 = class_num_218___object(reshaped_local_224_cfa_info);
			       {
				  obj_t obj_3402;
				  obj_3402 = (obj_t) (obj1935_3163);
				  (((obj_t) CREF(obj_3402))->header = MAKE_HEADER(arg2552_3165, 0), BUNSPEC);
			       }
			    }
			    obj1935_3163;
			 }
			 {
			    set_ex_it_cinfo_168_t obj1936_3167;
			    obj1936_3167 = ((set_ex_it_cinfo_168_t) (node_3159));
			    {
			       set_ex_it_cinfo_168_t arg2554_3168;
			       {
				  approx_t arg2555_3169;
				  arg2555_3169 = make_type_approx_184_cfa_approx((type_t) (__obj__252_type_cache));
				  {
				     set_ex_it_cinfo_168_t res2585_3407;
				     {
					set_ex_it_cinfo_168_t new1533_3405;
					new1533_3405 = ((set_ex_it_cinfo_168_t) BREF(GC_MALLOC(sizeof(struct set_ex_it_cinfo_168))));
					((((set_ex_it_cinfo_168_t) CREF(new1533_3405))->approx) = ((approx_t) arg2555_3169), BUNSPEC);
					res2585_3407 = new1533_3405;
				     }
				     arg2554_3168 = res2585_3407;
				  }
			       }
			       {
				  obj_t aux_4567;
				  object_t aux_4565;
				  aux_4567 = (obj_t) (arg2554_3168);
				  aux_4565 = (object_t) (obj1936_3167);
				  OBJECT_WIDENING_SET(aux_4565, aux_4567);
			       }
			    }
			    {
			       long arg2556_3170;
			       arg2556_3170 = class_num_218___object(set_ex_it_cinfo_168_cfa_info);
			       {
				  obj_t obj_3408;
				  obj_3408 = (obj_t) (obj1936_3167);
				  (((obj_t) CREF(obj_3408))->header = MAKE_HEADER(arg2556_3170, 0), BUNSPEC);
			       }
			    }
			    obj1936_3167;
			 }
			 {
			    approx_t aux_4573;
			    {
			       set_ex_it_cinfo_168_t obj_3410;
			       obj_3410 = (set_ex_it_cinfo_168_t) (node_3159);
			       {
				  obj_t aux_4575;
				  {
				     object_t aux_4576;
				     aux_4576 = (object_t) (obj_3410);
				     aux_4575 = OBJECT_WIDENING(aux_4576);
				  }
				  aux_4573 = (((set_ex_it_cinfo_168_t) CREF(aux_4575))->approx);
			       }
			    }
			    return approx_set_top__187_cfa_approx(aux_4573);
			 }
		      }
		      break;
		   case ((long) 18):
		      {
			 jump_ex_it_184_t node_3172;
			 node_3172 = (jump_ex_it_184_t) (node_2);
			 node_setup__189_cfa_setup((((jump_ex_it_184_t) CREF(node_3172))->exit));
			 node_setup__189_cfa_setup((((jump_ex_it_184_t) CREF(node_3172))->value));
			 {
			    jump_ex_it_cinfo_139_t obj1938_3176;
			    obj1938_3176 = ((jump_ex_it_cinfo_139_t) (node_3172));
			    {
			       jump_ex_it_cinfo_139_t arg2560_3177;
			       {
				  approx_t arg2561_3178;
				  arg2561_3178 = make_type_approx_184_cfa_approx((type_t) (__obj__252_type_cache));
				  {
				     jump_ex_it_cinfo_139_t res2586_3416;
				     {
					jump_ex_it_cinfo_139_t new1542_3414;
					new1542_3414 = ((jump_ex_it_cinfo_139_t) BREF(GC_MALLOC(sizeof(struct jump_ex_it_cinfo_139))));
					((((jump_ex_it_cinfo_139_t) CREF(new1542_3414))->approx) = ((approx_t) arg2561_3178), BUNSPEC);
					res2586_3416 = new1542_3414;
				     }
				     arg2560_3177 = res2586_3416;
				  }
			       }
			       {
				  obj_t aux_4593;
				  object_t aux_4591;
				  aux_4593 = (obj_t) (arg2560_3177);
				  aux_4591 = (object_t) (obj1938_3176);
				  OBJECT_WIDENING_SET(aux_4591, aux_4593);
			       }
			    }
			    {
			       long arg2562_3179;
			       arg2562_3179 = class_num_218___object(jump_ex_it_cinfo_139_cfa_info);
			       {
				  obj_t obj_3417;
				  obj_3417 = (obj_t) (obj1938_3176);
				  (((obj_t) CREF(obj_3417))->header = MAKE_HEADER(arg2562_3179, 0), BUNSPEC);
			       }
			    }
			    obj1938_3176;
			 }
			 {
			    approx_t aux_4599;
			    {
			       jump_ex_it_cinfo_139_t obj_3419;
			       obj_3419 = (jump_ex_it_cinfo_139_t) (node_3172);
			       {
				  obj_t aux_4601;
				  {
				     object_t aux_4602;
				     aux_4602 = (object_t) (obj_3419);
				     aux_4601 = OBJECT_WIDENING(aux_4602);
				  }
				  aux_4599 = (((jump_ex_it_cinfo_139_t) CREF(aux_4601))->approx);
			       }
			    }
			    return approx_set_top__187_cfa_approx(aux_4599);
			 }
		      }
		      break;
		   default:
		    case_else2404_9_2969:
		      if (PROCEDUREP(method2397_2965))
			{
			   return PROCEDURE_ENTRY(method2397_2965) (method2397_2965, (obj_t) (node_2), BEOA);
			}
		      else
			{
			   obj_t fun1984_2011;
			   fun1984_2011 = PROCEDURE_REF(node_setup__env_214_cfa_setup, ((long) 0));
			   return PROCEDURE_ENTRY(fun1984_2011) (fun1984_2011, (obj_t) (node_2), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else2404_9_2969;
	      }
	 }
      }
   }
}


obj_t 
_node_setup__114_cfa_setup(obj_t env_3970, obj_t node_3971)
{
   return node_setup__189_cfa_setup((node_t) (node_3971));
}


bool_t 
alloc_type__187_cfa_setup(type_t type_8)
{
   {
      bool_t test1985_2012;
      {
	 obj_t obj2_3423;
	 obj2_3423 = __vector__240_type_cache;
	 {
	    obj_t aux_4620;
	    aux_4620 = (obj_t) (type_8);
	    test1985_2012 = (aux_4620 == obj2_3423);
	 }
      }
      if (test1985_2012)
	{
	   return ((bool_t) 1);
	}
      else
	{
	   bool_t test1986_2013;
	   {
	      obj_t obj2_3425;
	      obj2_3425 = __procedure__226_type_cache;
	      {
		 obj_t aux_4624;
		 aux_4624 = (obj_t) (type_8);
		 test1986_2013 = (aux_4624 == obj2_3425);
	      }
	   }
	   if (test1986_2013)
	     {
		return ((bool_t) 1);
	     }
	   else
	     {
		bool_t test1987_2014;
		{
		   obj_t obj2_3427;
		   obj2_3427 = __struct__183_type_cache;
		   {
		      obj_t aux_4628;
		      aux_4628 = (obj_t) (type_8);
		      test1987_2014 = (aux_4628 == obj2_3427);
		   }
		}
		if (test1987_2014)
		  {
		     return ((bool_t) 1);
		  }
		else
		  {
		     return ((bool_t) 0);
		  }
	     }
	}
   }
}


obj_t 
variable_value_setup__default1946_8_cfa_setup(value_t value_11, variable_t variable_12)
{
   FAILURE(CNST_TABLE_REF(((long) 3)), string2605_cfa_setup, (obj_t) (value_11));
}


obj_t 
_variable_value_setup__default1946_1_cfa_setup(obj_t env_3977, obj_t value_3978, obj_t variable_3979)
{
   return variable_value_setup__default1946_8_cfa_setup((value_t) (value_3978), (variable_t) (variable_3979));
}


obj_t 
variable_value_setup__80_cfa_setup(value_t value_9, variable_t variable_10)
{
   {
      obj_t arg2307_2843;
      obj_t arg2308_2844;
      {
	 object_t obj_3433;
	 obj_3433 = (object_t) (value_9);
	 {
	    obj_t pre_method_105_3434;
	    pre_method_105_3434 = PROCEDURE_REF(variable_value_setup__env_134_cfa_setup, ((long) 2));
	    if (INTEGERP(pre_method_105_3434))
	      {
		 PROCEDURE_SET(variable_value_setup__env_134_cfa_setup, ((long) 2), BUNSPEC);
		 arg2307_2843 = pre_method_105_3434;
	      }
	    else
	      {
		 long obj_class_num_177_3439;
		 obj_class_num_177_3439 = TYPE(obj_3433);
		 {
		    obj_t arg1183_3440;
		    arg1183_3440 = PROCEDURE_REF(variable_value_setup__env_134_cfa_setup, ((long) 1));
		    {
		       long arg1184_3444;
		       {
			  long arg1186_3445;
			  arg1186_3445 = OBJECT_TYPE;
			  arg1184_3444 = (obj_class_num_177_3439 - arg1186_3445);
		       }
		       arg2307_2843 = VECTOR_REF(arg1183_3440, arg1184_3444);
		    }
		 }
	      }
	 }
      }
      {
	 object_t object_3450;
	 object_3450 = (object_t) (value_9);
	 {
	    long arg1187_3451;
	    {
	       long arg1188_3452;
	       long arg1189_3453;
	       arg1188_3452 = TYPE(object_3450);
	       arg1189_3453 = OBJECT_TYPE;
	       arg1187_3451 = (arg1188_3452 - arg1189_3453);
	    }
	    {
	       obj_t vector_3457;
	       vector_3457 = __classes__134___object;
	       arg2308_2844 = VECTOR_REF(vector_3457, arg1187_3451);
	    }
	 }
      }
      return loop2300_cfa_setup(variable_10, value_9, arg2307_2843, arg2308_2844);
   }
}


obj_t 
case_else2305_50_cfa_setup(variable_t variable_3992, value_t value_3991, obj_t method2299_3990)
{
   if (PROCEDUREP(method2299_3990))
     {
	return PROCEDURE_ENTRY(method2299_3990) (method2299_3990, (obj_t) (value_3991), (obj_t) (variable_3992), BEOA);
     }
   else
     {
	obj_t fun1990_2017;
	fun1990_2017 = PROCEDURE_REF(variable_value_setup__env_134_cfa_setup, ((long) 0));
	return PROCEDURE_ENTRY(fun1990_2017) (fun1990_2017, (obj_t) (value_3991), (obj_t) (variable_3992), BEOA);
     }
}


obj_t 
loop2300_cfa_setup(variable_t variable_3994, value_t value_3993, obj_t method2299_2845, obj_t class2304_2846)
{
   if (INTEGERP(method2299_2845))
     {
	switch ((long) CINT(method2299_2845))
	  {
	  case ((long) 0):
	     return BUNSPEC;
	     break;
	  case ((long) 1):
	     {
		svar_t value_2854;
		value_2854 = (svar_t) (value_3993);
		{
		   bool_t test2311_2856;
		   test2311_2856 = is_a__118___object((obj_t) (variable_3994), global_ast_var);
		   if (test2311_2856)
		     {
			svar_cinfo_166_t value_2857;
			{
			   svar_cinfo_166_t obj1886_2864;
			   obj1886_2864 = ((svar_cinfo_166_t) (value_2854));
			   {
			      svar_cinfo_166_t arg2318_2865;
			      {
				 approx_t arg2319_2866;
				 arg2319_2866 = make_type_approx_184_cfa_approx((((variable_t) CREF(variable_3994))->type));
				 {
				    svar_cinfo_166_t res2588_3466;
				    {
				       svar_cinfo_166_t new1391_3463;
				       new1391_3463 = ((svar_cinfo_166_t) BREF(GC_MALLOC(sizeof(struct svar_cinfo_166))));
				       ((((svar_cinfo_166_t) CREF(new1391_3463))->approx) = ((approx_t) arg2319_2866), BUNSPEC);
				       ((((svar_cinfo_166_t) CREF(new1391_3463))->clo_env__87) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				       res2588_3466 = new1391_3463;
				    }
				    arg2318_2865 = res2588_3466;
				 }
			      }
			      {
				 obj_t aux_4679;
				 object_t aux_4677;
				 aux_4679 = (obj_t) (arg2318_2865);
				 aux_4677 = (object_t) (obj1886_2864);
				 OBJECT_WIDENING_SET(aux_4677, aux_4679);
			      }
			   }
			   {
			      long arg2321_2868;
			      arg2321_2868 = class_num_218___object(svar_cinfo_166_cfa_info);
			      {
				 obj_t obj_3467;
				 obj_3467 = (obj_t) (obj1886_2864);
				 (((obj_t) CREF(obj_3467))->header = MAKE_HEADER(arg2321_2868, 0), BUNSPEC);
			      }
			   }
			   value_2857 = obj1886_2864;
			}
			{
			   bool_t test_4685;
			   {
			      bool_t test_4686;
			      {
				 obj_t aux_4690;
				 obj_t aux_4687;
				 aux_4690 = CNST_TABLE_REF(((long) 4));
				 {
				    global_t obj_3469;
				    obj_3469 = (global_t) (variable_3994);
				    aux_4687 = (((global_t) CREF(obj_3469))->import);
				 }
				 test_4686 = (aux_4687 == aux_4690);
			      }
			      if (test_4686)
				{
				   test_4685 = ((bool_t) 0);
				}
			      else
				{
				   test_4685 = alloc_type__187_cfa_setup((((variable_t) CREF(variable_3994))->type));
				}
			   }
			   if (test_4685)
			     {
				approx_t aux_4695;
				{
				   obj_t aux_4696;
				   {
				      object_t aux_4697;
				      aux_4697 = (object_t) (value_2857);
				      aux_4696 = OBJECT_WIDENING(aux_4697);
				   }
				   aux_4695 = (((svar_cinfo_166_t) CREF(aux_4696))->approx);
				}
				return approx_set_top__187_cfa_approx(aux_4695);
			     }
			   else
			     {
				return BUNSPEC;
			     }
			}
		     }
		   else
		     {
			svar_cinfo_166_t obj1887_2869;
			obj1887_2869 = ((svar_cinfo_166_t) (value_2854));
			{
			   svar_cinfo_166_t arg2322_2870;
			   {
			      approx_t arg2323_2871;
			      arg2323_2871 = make_type_approx_184_cfa_approx((((variable_t) CREF(variable_3994))->type));
			      {
				 svar_cinfo_166_t res2589_3480;
				 {
				    svar_cinfo_166_t new1391_3477;
				    new1391_3477 = ((svar_cinfo_166_t) BREF(GC_MALLOC(sizeof(struct svar_cinfo_166))));
				    ((((svar_cinfo_166_t) CREF(new1391_3477))->approx) = ((approx_t) arg2323_2871), BUNSPEC);
				    ((((svar_cinfo_166_t) CREF(new1391_3477))->clo_env__87) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				    res2589_3480 = new1391_3477;
				 }
				 arg2322_2870 = res2589_3480;
			      }
			   }
			   {
			      obj_t aux_4710;
			      object_t aux_4708;
			      aux_4710 = (obj_t) (arg2322_2870);
			      aux_4708 = (object_t) (obj1887_2869);
			      OBJECT_WIDENING_SET(aux_4708, aux_4710);
			   }
			}
			{
			   long arg2325_2873;
			   arg2325_2873 = class_num_218___object(svar_cinfo_166_cfa_info);
			   {
			      obj_t obj_3481;
			      obj_3481 = (obj_t) (obj1887_2869);
			      (((obj_t) CREF(obj_3481))->header = MAKE_HEADER(arg2325_2873, 0), BUNSPEC);
			   }
			}
			return (obj_t) (obj1887_2869);
		     }
		}
	     }
	     break;
	  case ((long) 2):
	     {
		bool_t test2326_2876;
		{
		   obj_t aux_4717;
		   aux_4717 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
		   test2326_2876 = CBOOL(aux_4717);
		}
		if (test2326_2876)
		  {
		     obj_t arg2328_2878;
		     arg2328_2878 = shape_tools_shape((obj_t) (variable_3994));
		     {
			obj_t list2329_2879;
			{
			   obj_t arg2330_2880;
			   {
			      obj_t arg2331_2881;
			      {
				 obj_t aux_4725;
				 aux_4725 = BCHAR(((unsigned char) '\n'));
				 arg2331_2881 = MAKE_PAIR(aux_4725, BNIL);
			      }
			      arg2330_2880 = MAKE_PAIR(arg2328_2878, arg2331_2881);
			   }
			   list2329_2879 = MAKE_PAIR(string2611_cfa_setup, arg2330_2880);
			}
			print_trace_107_tools_trace(list2329_2879);
		     }
		  }
		else
		  {
		     BUNSPEC;
		  }
	     }
	     call_next_method_114_cfa_setup(value_3993, class2304_2846, variable_3994);
	     {
		obj_t res2590_3486;
		{
		   svar_cinfo_166_t obj_3484;
		   {
		      value_t aux_4732;
		      {
			 local_t obj_3483;
			 obj_3483 = (local_t) (variable_3994);
			 aux_4732 = (((local_t) CREF(obj_3483))->value);
		      }
		      obj_3484 = (svar_cinfo_166_t) (aux_4732);
		   }
		   {
		      obj_t x_3998;
		      {
			 obj_t aux_4736;
			 {
			    object_t aux_4737;
			    aux_4737 = (object_t) (obj_3484);
			    aux_4736 = OBJECT_WIDENING(aux_4737);
			 }
			 x_3998 = ((((svar_cinfo_166_t) CREF(aux_4736))->clo_env__87) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		      }
		      res2590_3486 = BUNSPEC;
		   }
		}
		return res2590_3486;
	     }
	     break;
	  case ((long) 3):
	     {
		sexit_t value_2886;
		value_2886 = (sexit_t) (value_3993);
		{
		   sexit_cinfo_49_t obj1888_2888;
		   obj1888_2888 = ((sexit_cinfo_49_t) (value_2886));
		   {
		      sexit_cinfo_49_t arg2338_2889;
		      {
			 approx_t arg2339_2890;
			 arg2339_2890 = make_type_approx_184_cfa_approx((((variable_t) CREF(variable_3994))->type));
			 {
			    sexit_cinfo_49_t res2591_3491;
			    {
			       sexit_cinfo_49_t new1404_3489;
			       new1404_3489 = ((sexit_cinfo_49_t) BREF(GC_MALLOC(sizeof(struct sexit_cinfo_49))));
			       ((((sexit_cinfo_49_t) CREF(new1404_3489))->approx) = ((approx_t) arg2339_2890), BUNSPEC);
			       res2591_3491 = new1404_3489;
			    }
			    arg2338_2889 = res2591_3491;
			 }
		      }
		      {
			 obj_t aux_4749;
			 object_t aux_4747;
			 aux_4749 = (obj_t) (arg2338_2889);
			 aux_4747 = (object_t) (obj1888_2888);
			 OBJECT_WIDENING_SET(aux_4747, aux_4749);
		      }
		   }
		   {
		      long arg2343_2892;
		      arg2343_2892 = class_num_218___object(sexit_cinfo_49_cfa_info);
		      {
			 obj_t obj_3492;
			 obj_3492 = (obj_t) (obj1888_2888);
			 (((obj_t) CREF(obj_3492))->header = MAKE_HEADER(arg2343_2892, 0), BUNSPEC);
		      }
		   }
		   return (obj_t) (obj1888_2888);
		}
	     }
	     break;
	  case ((long) 4):
	     return CNST_TABLE_REF(((long) 5));
	     break;
	  case ((long) 5):
	     {
		scnst_t value_2895;
		value_2895 = (scnst_t) (value_3993);
		{
		   bool_t test2344_2897;
		   {
		      obj_t aux_4758;
		      aux_4758 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
		      test2344_2897 = CBOOL(aux_4758);
		   }
		   if (test2344_2897)
		     {
			obj_t arg2346_2899;
			obj_t arg2348_2901;
			arg2346_2899 = shape_tools_shape((obj_t) (variable_3994));
			arg2348_2901 = shape_tools_shape((((scnst_t) CREF(value_2895))->node));
			{
			   obj_t list2349_2902;
			   {
			      obj_t arg2350_2903;
			      {
				 obj_t arg2351_2904;
				 {
				    obj_t arg2352_2905;
				    {
				       obj_t arg2353_2906;
				       {
					  obj_t aux_4768;
					  aux_4768 = BCHAR(((unsigned char) '\n'));
					  arg2353_2906 = MAKE_PAIR(aux_4768, BNIL);
				       }
				       arg2352_2905 = MAKE_PAIR(arg2348_2901, arg2353_2906);
				    }
				    arg2351_2904 = MAKE_PAIR(string2612_cfa_setup, arg2352_2905);
				 }
				 arg2350_2903 = MAKE_PAIR(arg2346_2899, arg2351_2904);
			      }
			      list2349_2902 = MAKE_PAIR(string2613_cfa_setup, arg2350_2903);
			   }
			   print_trace_107_tools_trace(list2349_2902);
			}
		     }
		   else
		     {
			BUNSPEC;
		     }
		}
		{
		   bool_t test2358_2911;
		   test2358_2911 = is_a__118___object((obj_t) (variable_3994), global_ast_var);
		   if (test2358_2911)
		     {
			bool_t test2359_2912;
			{
			   bool_t test2375_2932;
			   {
			      obj_t obj2_3498;
			      obj2_3498 = __module__166_module_module;
			      {
				 obj_t aux_4779;
				 {
				    global_t obj_3496;
				    obj_3496 = (global_t) (variable_3994);
				    aux_4779 = (((global_t) CREF(obj_3496))->module);
				 }
				 test2375_2932 = (aux_4779 == obj2_3498);
			      }
			   }
			   if (test2375_2932)
			     {
				bool_t test_4784;
				{
				   obj_t aux_4785;
				   aux_4785 = memq___r4_pairs_and_lists_6_3((((scnst_t) CREF(value_2895))->class), CNST_TABLE_REF(((long) 6)));
				   test_4784 = CBOOL(aux_4785);
				}
				if (test_4784)
				  {
				     test2359_2912 = is_a__118___object((((scnst_t) CREF(value_2895))->node), pre_make_procedure_app_60_cfa_info);
				  }
				else
				  {
				     test2359_2912 = ((bool_t) 0);
				  }
			     }
			   else
			     {
				test2359_2912 = ((bool_t) 0);
			     }
			}
			if (test2359_2912)
			  {
			     obj_t node_2913;
			     node_2913 = (((scnst_t) CREF(value_2895))->node);
			     {
				bool_t test2360_2914;
				{
				   obj_t aux_4794;
				   aux_4794 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
				   test2360_2914 = CBOOL(aux_4794);
				}
				if (test2360_2914)
				  {
				     obj_t list2361_2915;
				     {
					obj_t arg2363_2917;
					{
					   obj_t aux_4800;
					   aux_4800 = BCHAR(((unsigned char) '\n'));
					   arg2363_2917 = MAKE_PAIR(aux_4800, BNIL);
					}
					list2361_2915 = MAKE_PAIR(string2614_cfa_setup, arg2363_2917);
				     }
				     print_trace_107_tools_trace(list2361_2915);
				  }
				else
				  {
				     BUNSPEC;
				  }
			     }
			     node_setup__189_cfa_setup((node_t) (node_2913));
			     {
				scnst_cinfo_0_t obj1889_2921;
				obj1889_2921 = ((scnst_cinfo_0_t) (value_2895));
				{
				   scnst_cinfo_0_t arg2367_2922;
				   {
				      approx_t arg2368_2923;
				      {
					 make_procedure_app_48_t obj_3503;
					 obj_3503 = (make_procedure_app_48_t) (node_2913);
					 {
					    obj_t aux_4809;
					    {
					       object_t aux_4810;
					       aux_4810 = (object_t) (obj_3503);
					       aux_4809 = OBJECT_WIDENING(aux_4810);
					    }
					    arg2368_2923 = (((make_procedure_app_48_t) CREF(aux_4809))->approx);
					 }
				      }
				      {
					 scnst_cinfo_0_t res2592_3507;
					 {
					    scnst_cinfo_0_t new1378_3505;
					    new1378_3505 = ((scnst_cinfo_0_t) BREF(GC_MALLOC(sizeof(struct scnst_cinfo_0))));
					    ((((scnst_cinfo_0_t) CREF(new1378_3505))->approx) = ((approx_t) arg2368_2923), BUNSPEC);
					    res2592_3507 = new1378_3505;
					 }
					 arg2367_2922 = res2592_3507;
				      }
				   }
				   {
				      obj_t aux_4818;
				      object_t aux_4816;
				      aux_4818 = (obj_t) (arg2367_2922);
				      aux_4816 = (object_t) (obj1889_2921);
				      OBJECT_WIDENING_SET(aux_4816, aux_4818);
				   }
				}
				{
				   long arg2369_2924;
				   arg2369_2924 = class_num_218___object(scnst_cinfo_0_cfa_info);
				   {
				      obj_t obj_3508;
				      obj_3508 = (obj_t) (obj1889_2921);
				      (((obj_t) CREF(obj_3508))->header = MAKE_HEADER(arg2369_2924, 0), BUNSPEC);
				   }
				}
				return (obj_t) (obj1889_2921);
			     }
			  }
			else
			  {
			     scnst_cinfo_0_t value_2925;
			     {
				scnst_cinfo_0_t obj1890_2927;
				obj1890_2927 = ((scnst_cinfo_0_t) (value_2895));
				{
				   scnst_cinfo_0_t arg2371_2928;
				   {
				      approx_t arg2372_2929;
				      arg2372_2929 = make_type_approx_184_cfa_approx((((variable_t) CREF(variable_3994))->type));
				      {
					 scnst_cinfo_0_t res2593_3514;
					 {
					    scnst_cinfo_0_t new1378_3512;
					    new1378_3512 = ((scnst_cinfo_0_t) BREF(GC_MALLOC(sizeof(struct scnst_cinfo_0))));
					    ((((scnst_cinfo_0_t) CREF(new1378_3512))->approx) = ((approx_t) arg2372_2929), BUNSPEC);
					    res2593_3514 = new1378_3512;
					 }
					 arg2371_2928 = res2593_3514;
				      }
				   }
				   {
				      obj_t aux_4832;
				      object_t aux_4830;
				      aux_4832 = (obj_t) (arg2371_2928);
				      aux_4830 = (object_t) (obj1890_2927);
				      OBJECT_WIDENING_SET(aux_4830, aux_4832);
				   }
				}
				{
				   long arg2374_2931;
				   arg2374_2931 = class_num_218___object(scnst_cinfo_0_cfa_info);
				   {
				      obj_t obj_3515;
				      obj_3515 = (obj_t) (obj1890_2927);
				      (((obj_t) CREF(obj_3515))->header = MAKE_HEADER(arg2374_2931, 0), BUNSPEC);
				   }
				}
				value_2925 = obj1890_2927;
			     }
			     {
				approx_t aux_4838;
				{
				   obj_t aux_4839;
				   {
				      object_t aux_4840;
				      aux_4840 = (object_t) (value_2925);
				      aux_4839 = OBJECT_WIDENING(aux_4840);
				   }
				   aux_4838 = (((scnst_cinfo_0_t) CREF(aux_4839))->approx);
				}
				return approx_set_top__187_cfa_approx(aux_4838);
			     }
			  }
		     }
		   else
		     {
			scnst_cinfo_0_t obj1891_2938;
			obj1891_2938 = ((scnst_cinfo_0_t) (value_2895));
			{
			   scnst_cinfo_0_t arg2381_2939;
			   {
			      approx_t arg2382_2940;
			      arg2382_2940 = make_type_approx_184_cfa_approx((((variable_t) CREF(variable_3994))->type));
			      {
				 scnst_cinfo_0_t res2594_3522;
				 {
				    scnst_cinfo_0_t new1378_3520;
				    new1378_3520 = ((scnst_cinfo_0_t) BREF(GC_MALLOC(sizeof(struct scnst_cinfo_0))));
				    ((((scnst_cinfo_0_t) CREF(new1378_3520))->approx) = ((approx_t) arg2382_2940), BUNSPEC);
				    res2594_3522 = new1378_3520;
				 }
				 arg2381_2939 = res2594_3522;
			      }
			   }
			   {
			      obj_t aux_4852;
			      object_t aux_4850;
			      aux_4852 = (obj_t) (arg2381_2939);
			      aux_4850 = (object_t) (obj1891_2938);
			      OBJECT_WIDENING_SET(aux_4850, aux_4852);
			   }
			}
			{
			   long arg2384_2942;
			   arg2384_2942 = class_num_218___object(scnst_cinfo_0_cfa_info);
			   {
			      obj_t obj_3523;
			      obj_3523 = (obj_t) (obj1891_2938);
			      (((obj_t) CREF(obj_3523))->header = MAKE_HEADER(arg2384_2942, 0), BUNSPEC);
			   }
			}
			return (obj_t) (obj1891_2938);
		     }
		}
	     }
	     break;
	  case ((long) 6):
	     {
		cvar_t value_2943;
		value_2943 = (cvar_t) (value_3993);
		{
		   cvar_cinfo_53_t obj1892_2945;
		   obj1892_2945 = ((cvar_cinfo_53_t) (value_2943));
		   {
		      cvar_cinfo_53_t arg2385_2946;
		      {
			 approx_t arg2386_2947;
			 arg2386_2947 = make_type_approx_184_cfa_approx((((variable_t) CREF(variable_3994))->type));
			 {
			    cvar_cinfo_53_t res2595_3529;
			    {
			       cvar_cinfo_53_t new1398_3527;
			       new1398_3527 = ((cvar_cinfo_53_t) BREF(GC_MALLOC(sizeof(struct cvar_cinfo_53))));
			       ((((cvar_cinfo_53_t) CREF(new1398_3527))->approx) = ((approx_t) arg2386_2947), BUNSPEC);
			       res2595_3529 = new1398_3527;
			    }
			    arg2385_2946 = res2595_3529;
			 }
		      }
		      {
			 obj_t aux_4867;
			 object_t aux_4865;
			 aux_4867 = (obj_t) (arg2385_2946);
			 aux_4865 = (object_t) (obj1892_2945);
			 OBJECT_WIDENING_SET(aux_4865, aux_4867);
		      }
		   }
		   {
		      long arg2388_2949;
		      arg2388_2949 = class_num_218___object(cvar_cinfo_53_cfa_info);
		      {
			 obj_t obj_3530;
			 obj_3530 = (obj_t) (obj1892_2945);
			 (((obj_t) CREF(obj_3530))->header = MAKE_HEADER(arg2388_2949, 0), BUNSPEC);
		      }
		   }
		   obj1892_2945;
		}
		if (alloc_type__187_cfa_setup((((variable_t) CREF(variable_3994))->type)))
		  {
		     approx_t aux_4876;
		     {
			cvar_cinfo_53_t obj_3533;
			obj_3533 = (cvar_cinfo_53_t) (value_2943);
			{
			   obj_t aux_4878;
			   {
			      object_t aux_4879;
			      aux_4879 = (object_t) (obj_3533);
			      aux_4878 = OBJECT_WIDENING(aux_4879);
			   }
			   aux_4876 = (((cvar_cinfo_53_t) CREF(aux_4878))->approx);
			}
		     }
		     return approx_set_top__187_cfa_approx(aux_4876);
		  }
		else
		  {
		     return BUNSPEC;
		  }
	     }
	     break;
	  default:
	     return case_else2305_50_cfa_setup(variable_3994, value_3993, method2299_2845);
	  }
     }
   else
     {
	return case_else2305_50_cfa_setup(variable_3994, value_3993, method2299_2845);
     }
}


obj_t 
call_next_method_114_cfa_setup(value_t value_3997, obj_t class2304_3996, variable_t variable_3995)
{
   {
      obj_t aux2302_2956;
      {
	 obj_t aux_4888;
	 {
	    bool_t test_4890;
	    if (VECTORP(class2304_3996))
	      {
		 long aux_4893;
		 aux_4893 = VECTOR_LENGTH(class2304_3996);
		 test_4890 = (aux_4893 == ((long) 9));
	      }
	    else
	      {
		 test_4890 = ((bool_t) 0);
	      }
	    if (test_4890)
	      {
		 aux_4888 = class_super_145___object(class2304_3996);
	      }
	    else
	      {
		 aux_4888 = BFALSE;
	      }
	 }
	 aux2302_2956 = find_method_from_44___object((object_t) (value_3997), variable_value_setup__env_134_cfa_setup, aux_4888);
      }
      {
	 return loop2300_cfa_setup(variable_3995, value_3997, CDR(aux2302_2956), CAR(aux2302_2956));
      }
   }
}


obj_t 
_variable_value_setup__30_cfa_setup(obj_t env_3974, obj_t value_3975, obj_t variable_3976)
{
   return variable_value_setup__80_cfa_setup((value_t) (value_3975), (variable_t) (variable_3976));
}


obj_t 
fun_setup__default1957_132_cfa_setup(fun_t fun_32, obj_t var_33)
{
   {
      bool_t test1991_2018;
      {
	 bool_t test1994_2022;
	 test1994_2022 = is_a__118___object(var_33, global_ast_var);
	 if (test1994_2022)
	   {
	      bool_t test1995_2023;
	      test1995_2023 = is_a__118___object(var_33, reshaped_global_160_cfa_info);
	      if (test1995_2023)
		{
		   test1991_2018 = ((bool_t) 0);
		}
	      else
		{
		   test1991_2018 = ((bool_t) 1);
		}
	   }
	 else
	   {
	      test1991_2018 = ((bool_t) 0);
	   }
      }
      if (test1991_2018)
	{
	   reshaped_global_160_t obj1895_2019;
	   obj1895_2019 = ((reshaped_global_160_t) (var_33));
	   {
	      obj_t aux_4912;
	      object_t aux_4910;
	      {
		 reshaped_global_160_t aux_4913;
		 {
		    aux_4913 = ((reshaped_global_160_t) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
		 }
		 aux_4912 = (obj_t) (aux_4913);
	      }
	      aux_4910 = (object_t) (obj1895_2019);
	      OBJECT_WIDENING_SET(aux_4910, aux_4912);
	   }
	   {
	      long arg1993_2021;
	      arg1993_2021 = class_num_218___object(reshaped_global_160_cfa_info);
	      {
		 obj_t obj_3551;
		 obj_3551 = (obj_t) (obj1895_2019);
		 (((obj_t) CREF(obj_3551))->header = MAKE_HEADER(arg1993_2021, 0), BUNSPEC);
	      }
	   }
	   (obj_t) (obj1895_2019);
	}
      else
	{
	   BUNSPEC;
	}
   }
   return BUNSPEC;
}


obj_t 
_fun_setup__default1957_195_cfa_setup(obj_t env_3983, obj_t fun_3984, obj_t var_3985)
{
   return fun_setup__default1957_132_cfa_setup((fun_t) (fun_3984), var_3985);
}


obj_t 
fun_setup__186_cfa_setup(fun_t fun_30, obj_t var_31)
{
   {
      obj_t method2251_2790;
      obj_t class2256_2791;
      {
	 obj_t arg2259_2788;
	 obj_t arg2260_2789;
	 {
	    object_t obj_3553;
	    obj_3553 = (object_t) (fun_30);
	    {
	       obj_t pre_method_105_3554;
	       pre_method_105_3554 = PROCEDURE_REF(fun_setup__env_196_cfa_setup, ((long) 2));
	       if (INTEGERP(pre_method_105_3554))
		 {
		    PROCEDURE_SET(fun_setup__env_196_cfa_setup, ((long) 2), BUNSPEC);
		    arg2259_2788 = pre_method_105_3554;
		 }
	       else
		 {
		    long obj_class_num_177_3559;
		    obj_class_num_177_3559 = TYPE(obj_3553);
		    {
		       obj_t arg1183_3560;
		       arg1183_3560 = PROCEDURE_REF(fun_setup__env_196_cfa_setup, ((long) 1));
		       {
			  long arg1184_3564;
			  {
			     long arg1186_3565;
			     arg1186_3565 = OBJECT_TYPE;
			     arg1184_3564 = (obj_class_num_177_3559 - arg1186_3565);
			  }
			  arg2259_2788 = VECTOR_REF(arg1183_3560, arg1184_3564);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_3570;
	    object_3570 = (object_t) (fun_30);
	    {
	       long arg1187_3571;
	       {
		  long arg1188_3572;
		  long arg1189_3573;
		  arg1188_3572 = TYPE(object_3570);
		  arg1189_3573 = OBJECT_TYPE;
		  arg1187_3571 = (arg1188_3572 - arg1189_3573);
	       }
	       {
		  obj_t vector_3577;
		  vector_3577 = __classes__134___object;
		  arg2260_2789 = VECTOR_REF(vector_3577, arg1187_3571);
	       }
	    }
	 }
	 method2251_2790 = arg2259_2788;
	 class2256_2791 = arg2260_2789;
	 {
	    if (INTEGERP(method2251_2790))
	      {
		 switch ((long) CINT(method2251_2790))
		   {
		   case ((long) 0):
		      {
			 sfun_t fun_2797;
			 fun_2797 = (sfun_t) (fun_30);
			 {
			    bool_t test2263_2799;
			    {
			       bool_t test2266_2803;
			       test2266_2803 = is_a__118___object(var_31, global_ast_var);
			       if (test2266_2803)
				 {
				    bool_t test2267_2804;
				    test2267_2804 = is_a__118___object(var_31, reshaped_global_160_cfa_info);
				    if (test2267_2804)
				      {
					 test2263_2799 = ((bool_t) 0);
				      }
				    else
				      {
					 test2263_2799 = ((bool_t) 1);
				      }
				 }
			       else
				 {
				    test2263_2799 = ((bool_t) 0);
				 }
			    }
			    if (test2263_2799)
			      {
				 reshaped_global_160_t obj1896_2800;
				 obj1896_2800 = ((reshaped_global_160_t) (var_31));
				 {
				    obj_t aux_4949;
				    object_t aux_4947;
				    {
				       reshaped_global_160_t aux_4950;
				       {
					  aux_4950 = ((reshaped_global_160_t) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
				       }
				       aux_4949 = (obj_t) (aux_4950);
				    }
				    aux_4947 = (object_t) (obj1896_2800);
				    OBJECT_WIDENING_SET(aux_4947, aux_4949);
				 }
				 {
				    long arg2265_2802;
				    arg2265_2802 = class_num_218___object(reshaped_global_160_cfa_info);
				    {
				       obj_t obj_3583;
				       obj_3583 = (obj_t) (obj1896_2800);
				       (((obj_t) CREF(obj_3583))->header = MAKE_HEADER(arg2265_2802, 0), BUNSPEC);
				    }
				 }
				 (obj_t) (obj1896_2800);
			      }
			    else
			      {
				 BUNSPEC;
			      }
			 }
			 {
			    bool_t test2268_2805;
			    {
			       bool_t test2284_2818;
			       test2284_2818 = is_a__118___object(var_31, global_ast_var);
			       if (test2284_2818)
				 {
				    obj_t aux_4963;
				    obj_t aux_4960;
				    aux_4963 = CNST_TABLE_REF(((long) 7));
				    {
				       global_t obj_3586;
				       obj_3586 = (global_t) (var_31);
				       aux_4960 = (((global_t) CREF(obj_3586))->import);
				    }
				    test2268_2805 = (aux_4960 == aux_4963);
				 }
			       else
				 {
				    test2268_2805 = ((bool_t) 0);
				 }
			    }
			    if (test2268_2805)
			      {
				 approx_t approx_2806;
				 {
				    type_t aux_4967;
				    {
				       global_t obj_3589;
				       obj_3589 = (global_t) (var_31);
				       aux_4967 = (((global_t) CREF(obj_3589))->type);
				    }
				    approx_2806 = make_type_approx_184_cfa_approx(aux_4967);
				 }
				 if ((((sfun_t) CREF(fun_2797))->top__138))
				   {
				      approx_set_top__187_cfa_approx(approx_2806);
				   }
				 else
				   {
				      BUNSPEC;
				   }
				 {
				    extern_sfun_cinfo_6_t obj1897_2808;
				    obj1897_2808 = ((extern_sfun_cinfo_6_t) (fun_2797));
				    {
				       extern_sfun_cinfo_6_t arg2270_2809;
				       {
					  extern_sfun_cinfo_6_t res2600_3594;
					  {
					     extern_sfun_cinfo_6_t new1345_3592;
					     new1345_3592 = ((extern_sfun_cinfo_6_t) BREF(GC_MALLOC(sizeof(struct extern_sfun_cinfo_6))));
					     ((((extern_sfun_cinfo_6_t) CREF(new1345_3592))->approx) = ((approx_t) approx_2806), BUNSPEC);
					     res2600_3594 = new1345_3592;
					  }
					  arg2270_2809 = res2600_3594;
				       }
				       {
					  obj_t aux_4979;
					  object_t aux_4977;
					  aux_4979 = (obj_t) (arg2270_2809);
					  aux_4977 = (object_t) (obj1897_2808);
					  OBJECT_WIDENING_SET(aux_4977, aux_4979);
				       }
				    }
				    {
				       long arg2271_2810;
				       arg2271_2810 = class_num_218___object(extern_sfun_cinfo_6_cfa_info);
				       {
					  obj_t obj_3595;
					  obj_3595 = (obj_t) (obj1897_2808);
					  (((obj_t) CREF(obj_3595))->header = MAKE_HEADER(arg2271_2810, 0), BUNSPEC);
				       }
				    }
				    return (obj_t) (obj1897_2808);
				 }
			      }
			    else
			      {
				 intern_sfun_cinfo_192_t obj1898_2812;
				 obj1898_2812 = ((intern_sfun_cinfo_192_t) (fun_2797));
				 {
				    intern_sfun_cinfo_192_t arg2273_2813;
				    {
				       approx_t arg2274_2814;
				       {
					  type_t aux_4987;
					  {
					     variable_t obj_3597;
					     obj_3597 = (variable_t) (var_31);
					     aux_4987 = (((variable_t) CREF(obj_3597))->type);
					  }
					  arg2274_2814 = make_type_approx_184_cfa_approx(aux_4987);
				       }
				       {
					  intern_sfun_cinfo_192_t res2601_3603;
					  {
					     intern_sfun_cinfo_192_t new1361_3600;
					     new1361_3600 = ((intern_sfun_cinfo_192_t) BREF(GC_MALLOC(sizeof(struct intern_sfun_cinfo_192))));
					     ((((intern_sfun_cinfo_192_t) CREF(new1361_3600))->approx) = ((approx_t) arg2274_2814), BUNSPEC);
					     ((((intern_sfun_cinfo_192_t) CREF(new1361_3600))->stamp) = ((long) ((long) -1)), BUNSPEC);
					     res2601_3603 = new1361_3600;
					  }
					  arg2273_2813 = res2601_3603;
				       }
				    }
				    {
				       obj_t aux_4996;
				       object_t aux_4994;
				       aux_4996 = (obj_t) (arg2273_2813);
				       aux_4994 = (object_t) (obj1898_2812);
				       OBJECT_WIDENING_SET(aux_4994, aux_4996);
				    }
				 }
				 {
				    long arg2283_2817;
				    arg2283_2817 = class_num_218___object(intern_sfun_cinfo_192_cfa_info);
				    {
				       obj_t obj_3604;
				       obj_3604 = (obj_t) (obj1898_2812);
				       (((obj_t) CREF(obj_3604))->header = MAKE_HEADER(arg2283_2817, 0), BUNSPEC);
				    }
				 }
				 return (obj_t) (obj1898_2812);
			      }
			 }
		      }
		      break;
		   case ((long) 1):
		      {
			 cfun_t fun_2821;
			 fun_2821 = (cfun_t) (fun_30);
			 {
			    bool_t test2287_2823;
			    test2287_2823 = is_a__118___object(var_31, reshaped_global_160_cfa_info);
			    if (test2287_2823)
			      {
				 BUNSPEC;
			      }
			    else
			      {
				 reshaped_global_160_t obj1899_2824;
				 obj1899_2824 = ((reshaped_global_160_t) (var_31));
				 {
				    obj_t aux_5009;
				    object_t aux_5007;
				    {
				       reshaped_global_160_t aux_5010;
				       {
					  aux_5010 = ((reshaped_global_160_t) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
				       }
				       aux_5009 = (obj_t) (aux_5010);
				    }
				    aux_5007 = (object_t) (obj1899_2824);
				    OBJECT_WIDENING_SET(aux_5007, aux_5009);
				 }
				 {
				    long arg2289_2826;
				    arg2289_2826 = class_num_218___object(reshaped_global_160_cfa_info);
				    {
				       obj_t obj_3609;
				       obj_3609 = (obj_t) (obj1899_2824);
				       (((obj_t) CREF(obj_3609))->header = MAKE_HEADER(arg2289_2826, 0), BUNSPEC);
				    }
				 }
				 (obj_t) (obj1899_2824);
			      }
			 }
			 {
			    approx_t approx_2827;
			    {
			       type_t aux_5018;
			       {
				  global_t obj_3611;
				  obj_3611 = (global_t) (var_31);
				  aux_5018 = (((global_t) CREF(obj_3611))->type);
			       }
			       approx_2827 = make_type_approx_184_cfa_approx(aux_5018);
			    }
			    if ((((cfun_t) CREF(fun_2821))->top__138))
			      {
				 approx_set_top__187_cfa_approx(approx_2827);
			      }
			    else
			      {
				 BUNSPEC;
			      }
			    {
			       cfun_cinfo_200_t obj1900_2829;
			       obj1900_2829 = ((cfun_cinfo_200_t) (fun_2821));
			       {
				  cfun_cinfo_200_t arg2291_2830;
				  {
				     cfun_cinfo_200_t res2603_3616;
				     {
					cfun_cinfo_200_t new1333_3614;
					new1333_3614 = ((cfun_cinfo_200_t) BREF(GC_MALLOC(sizeof(struct cfun_cinfo_200))));
					((((cfun_cinfo_200_t) CREF(new1333_3614))->approx) = ((approx_t) approx_2827), BUNSPEC);
					res2603_3616 = new1333_3614;
				     }
				     arg2291_2830 = res2603_3616;
				  }
				  {
				     obj_t aux_5030;
				     object_t aux_5028;
				     aux_5030 = (obj_t) (arg2291_2830);
				     aux_5028 = (object_t) (obj1900_2829);
				     OBJECT_WIDENING_SET(aux_5028, aux_5030);
				  }
			       }
			       {
				  long arg2292_2831;
				  arg2292_2831 = class_num_218___object(cfun_cinfo_200_cfa_info);
				  {
				     obj_t obj_3617;
				     obj_3617 = (obj_t) (obj1900_2829);
				     (((obj_t) CREF(obj_3617))->header = MAKE_HEADER(arg2292_2831, 0), BUNSPEC);
				  }
			       }
			       return (obj_t) (obj1900_2829);
			    }
			 }
		      }
		      break;
		   default:
		    case_else2257_64_2794:
		      if (PROCEDUREP(method2251_2790))
			{
			   return PROCEDURE_ENTRY(method2251_2790) (method2251_2790, (obj_t) (fun_30), var_31, BEOA);
			}
		      else
			{
			   obj_t fun1996_2024;
			   fun1996_2024 = PROCEDURE_REF(fun_setup__env_196_cfa_setup, ((long) 0));
			   return PROCEDURE_ENTRY(fun1996_2024) (fun1996_2024, (obj_t) (fun_30), var_31, BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else2257_64_2794;
	      }
	 }
      }
   }
}


obj_t 
_fun_setup__218_cfa_setup(obj_t env_3980, obj_t fun_3981, obj_t var_3982)
{
   return fun_setup__186_cfa_setup((fun_t) (fun_3981), var_3982);
}


obj_t 
node_setup___185_cfa_setup(obj_t node__221_50)
{
   {
      obj_t l1939_2025;
      {
	 bool_t aux_5050;
	 l1939_2025 = node__221_50;
       lname1940_2026:
	 if (PAIRP(l1939_2025))
	   {
	      {
		 node_t aux_5053;
		 {
		    obj_t aux_5054;
		    aux_5054 = CAR(l1939_2025);
		    aux_5053 = (node_t) (aux_5054);
		 }
		 node_setup__189_cfa_setup(aux_5053);
	      }
	      {
		 obj_t l1939_5058;
		 l1939_5058 = CDR(l1939_2025);
		 l1939_2025 = l1939_5058;
		 goto lname1940_2026;
	      }
	   }
	 else
	   {
	      aux_5050 = ((bool_t) 1);
	   }
	 return BBOOL(aux_5050);
      }
   }
}


obj_t 
_node_setup___39_cfa_setup(obj_t env_3988, obj_t node__221_3989)
{
   return node_setup___185_cfa_setup(node__221_3989);
}


obj_t 
imported_modules_init_94_cfa_setup()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_SETUP");
   module_initialization_70_type_type(((long) 0), "CFA_SETUP");
   module_initialization_70_type_cache(((long) 0), "CFA_SETUP");
   module_initialization_70_type_typeof(((long) 0), "CFA_SETUP");
   module_initialization_70_module_module(((long) 0), "CFA_SETUP");
   module_initialization_70_tools_shape(((long) 0), "CFA_SETUP");
   module_initialization_70_tools_error(((long) 0), "CFA_SETUP");
   module_initialization_70_ast_var(((long) 0), "CFA_SETUP");
   module_initialization_70_ast_node(((long) 0), "CFA_SETUP");
   module_initialization_70_cfa_info(((long) 0), "CFA_SETUP");
   return module_initialization_70_cfa_approx(((long) 0), "CFA_SETUP");
}
