/*===========================================================================*/
/*   (Cfa/show.scm)                                                          */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


extern obj_t _show_cfa_nb_iterations_163_cfa_show(obj_t);
extern obj_t svar_cinfo_166_cfa_info;
extern obj_t _shape_tools_shape(obj_t, obj_t);
extern obj_t cvar_cinfo_53_cfa_info;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t get_allocs_52_cfa_collect();
extern obj_t open_output_string();
static obj_t imported_modules_init_94_cfa_show();
extern obj_t module_initialization_70_cfa_show(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_write_scheme(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_collect(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___pp(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t string_to_symbol(char *);
static obj_t toplevel_init_63_cfa_show();
extern obj_t _show_cfa_results_182_cfa_show(obj_t, obj_t);
static obj_t cnst_init_137_cfa_show();
extern obj_t pp___pp(obj_t, obj_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
static obj_t require_initialization_114_cfa_show = BUNSPEC;
extern obj_t scnst_cinfo_0_cfa_info;
extern obj_t print_trace_107_tools_trace(obj_t);
extern obj_t node_key_123_cfa_approx(node_t);
static obj_t library_modules_init_112_cfa_show();
static obj_t cfa_variable_shape_84_cfa_show(obj_t, obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t show_cfa_results_28_cfa_show(obj_t);
extern obj_t show_cfa_nb_iterations_231_cfa_show();
extern obj_t open_input_string(obj_t);
extern obj_t close_output_port(obj_t);
extern obj_t __trace_port__84_tools_trace;
extern obj_t __cfa_stamp__16_cfa_iterate;
extern obj_t shape_tools_shape(obj_t);
extern obj_t write_scheme_comment_102_write_scheme(obj_t, obj_t);
extern obj_t reshaped_global_160_cfa_info;
extern obj_t __pp_case__242___pp;
extern obj_t display___r4_output_6_10_3(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_6_cfa_info;
static obj_t shape_reshaped_local2299_239_cfa_show(obj_t, obj_t);
extern obj_t reshaped_local_224_cfa_info;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t cfun_cinfo_200_cfa_info;
extern obj_t intern_sfun_cinfo_192_cfa_info;
static obj_t shape_reshaped_global2298_3_cfa_show(obj_t, obj_t);
static obj_t __cnst[9];

DEFINE_EXPORT_PROCEDURE(show_cfa_nb_iterations_env_198_cfa_show, _show_cfa_nb_iterations_163_cfa_show2315, _show_cfa_nb_iterations_163_cfa_show, 0L, 0);
DEFINE_STRING(string2302_cfa_show, string2302_cfa_show2316, " Iterations)", 12);
DEFINE_STRING(string2306_cfa_show, string2306_cfa_show2317, "", 0);
DEFINE_STRING(string2307_cfa_show, string2307_cfa_show2318, " ", 1);
DEFINE_STRING(string2309_cfa_show, string2309_cfa_show2319, "DEFINE DEFINE-METHOD SMFUN DEFINE-INLINE SIFUN DEFINE-GENERIC SGFUN LOWER CFA ", 78);
DEFINE_STRING(string2305_cfa_show, string2305_cfa_show2320, "============================================", 44);
DEFINE_EXPORT_PROCEDURE(show_cfa_results_env_131_cfa_show, _show_cfa_results_182_cfa_show2321, _show_cfa_results_182_cfa_show, 0L, 1);
DEFINE_STRING(string2308_cfa_show, string2308_cfa_show2322, ": ", 2);
DEFINE_STRING(string2304_cfa_show, string2304_cfa_show2323, "cfa-results:", 12);
DEFINE_STATIC_PROCEDURE(proc2301_cfa_show, shape_reshaped_global2298_3_cfa_show2324, shape_reshaped_global2298_3_cfa_show, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2300_cfa_show, shape_reshaped_local2299_239_cfa_show2325, shape_reshaped_local2299_239_cfa_show, 0L, 1);
extern obj_t shape_env_98_tools_shape;
DEFINE_STRING(string2303_cfa_show, string2303_cfa_show2326, "      (", 7);

obj_t 
module_initialization_70_cfa_show(long checksum_3272, char *from_3273)
{
   if (CBOOL(require_initialization_114_cfa_show))
     {
	require_initialization_114_cfa_show = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_show();
	cnst_init_137_cfa_show();
	imported_modules_init_94_cfa_show();
	toplevel_init_63_cfa_show();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_show()
{
   module_initialization_70___object(((long) 0), "CFA_SHOW");
   module_initialization_70___pp(((long) 0), "CFA_SHOW");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_SHOW");
   module_initialization_70___reader(((long) 0), "CFA_SHOW");
   module_initialization_70___r4_output_6_10_3(((long) 0), "CFA_SHOW");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_show()
{
   {
      obj_t cnst_port_138_3264;
      cnst_port_138_3264 = open_input_string(string2309_cfa_show);
      {
	 long i_3265;
	 i_3265 = ((long) 8);
       loop_3266:
	 {
	    bool_t test2310_3267;
	    test2310_3267 = (i_3265 == ((long) -1));
	    if (test2310_3267)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2311_3268;
		    {
		       obj_t list2312_3269;
		       {
			  obj_t arg2313_3270;
			  arg2313_3270 = BNIL;
			  list2312_3269 = MAKE_PAIR(cnst_port_138_3264, arg2313_3270);
		       }
		       arg2311_3268 = read___reader(list2312_3269);
		    }
		    CNST_TABLE_SET(i_3265, arg2311_3268);
		 }
		 {
		    int aux_3271;
		    {
		       long aux_3292;
		       aux_3292 = (i_3265 - ((long) 1));
		       aux_3271 = (int) (aux_3292);
		    }
		    {
		       long i_3295;
		       i_3295 = (long) (aux_3271);
		       i_3265 = i_3295;
		       goto loop_3266;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_show()
{
   {
      obj_t shape_reshaped_local_21_3256;
      shape_reshaped_local_21_3256 = proc2300_cfa_show;
      add_method__1___object(shape_env_98_tools_shape, reshaped_local_224_cfa_info, shape_reshaped_local_21_3256);
   }
   {
      obj_t shape_reshaped_global_104_3253;
      shape_reshaped_global_104_3253 = proc2301_cfa_show;
      return add_method__1___object(shape_env_98_tools_shape, reshaped_global_160_cfa_info, shape_reshaped_global_104_3253);
   }
}


obj_t 
shape_reshaped_global2298_3_cfa_show(obj_t env_3257, obj_t global_3258)
{
   {
      reshaped_global_160_t global_1944;
      global_1944 = (reshaped_global_160_t) (global_3258);
      {
	 {
	    obj_t port_1947;
	    port_1947 = open_output_string();
	    {
	       obj_t arg1887_1948;
	       {
		  obj_t next_method1882_178_1951;
		  next_method1882_178_1951 = find_super_class_method_167___object((object_t) (global_1944), shape_env_98_tools_shape, reshaped_global_160_cfa_info);
		  if (PROCEDUREP(next_method1882_178_1951))
		    {
		       arg1887_1948 = PROCEDURE_ENTRY(next_method1882_178_1951) (next_method1882_178_1951, (obj_t) (global_1944), BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(shape_env_98_tools_shape, ((long) 2), next_method1882_178_1951);
		       arg1887_1948 = shape_tools_shape((obj_t) (global_1944));
		    }
	       }
	       {
		  obj_t list1888_1949;
		  list1888_1949 = MAKE_PAIR(port_1947, BNIL);
		  display___r4_output_6_10_3(arg1887_1948, list1888_1949);
	       }
	    }
	    return cfa_variable_shape_84_cfa_show((obj_t) (global_1944), port_1947);
	 }
      }
   }
}


obj_t 
shape_reshaped_local2299_239_cfa_show(obj_t env_3259, obj_t local_3260)
{
   {
      reshaped_local_224_t local_1935;
      local_1935 = (reshaped_local_224_t) (local_3260);
      {
	 {
	    obj_t port_1938;
	    port_1938 = open_output_string();
	    {
	       obj_t arg1883_1939;
	       {
		  obj_t next_method1881_237_1942;
		  next_method1881_237_1942 = find_super_class_method_167___object((object_t) (local_1935), shape_env_98_tools_shape, reshaped_local_224_cfa_info);
		  if (PROCEDUREP(next_method1881_237_1942))
		    {
		       arg1883_1939 = PROCEDURE_ENTRY(next_method1881_237_1942) (next_method1881_237_1942, (obj_t) (local_1935), BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(shape_env_98_tools_shape, ((long) 2), next_method1881_237_1942);
		       arg1883_1939 = shape_tools_shape((obj_t) (local_1935));
		    }
	       }
	       {
		  obj_t list1884_1940;
		  list1884_1940 = MAKE_PAIR(port_1938, BNIL);
		  display___r4_output_6_10_3(arg1883_1939, list1884_1940);
	       }
	    }
	    return cfa_variable_shape_84_cfa_show((obj_t) (local_1935), port_1938);
	 }
      }
   }
}


obj_t 
show_cfa_nb_iterations_231_cfa_show()
{
   {
      long arg1893_1955;
      {
	 long z2_2862;
	 z2_2862 = (long) CINT(__cfa_stamp__16_cfa_iterate);
	 arg1893_1955 = (((long) 1) + z2_2862);
      }
      {
	 obj_t list1895_1957;
	 {
	    obj_t arg1896_1958;
	    {
	       obj_t arg1897_1959;
	       {
		  obj_t arg1898_1960;
		  {
		     obj_t aux_3333;
		     aux_3333 = BCHAR(((unsigned char) '\n'));
		     arg1898_1960 = MAKE_PAIR(aux_3333, BNIL);
		  }
		  arg1897_1959 = MAKE_PAIR(string2302_cfa_show, arg1898_1960);
	       }
	       {
		  obj_t aux_3337;
		  aux_3337 = BINT(arg1893_1955);
		  arg1896_1958 = MAKE_PAIR(aux_3337, arg1897_1959);
	       }
	    }
	    list1895_1957 = MAKE_PAIR(string2303_cfa_show, arg1896_1958);
	 }
	 return verbose_tools_speek(BINT(((long) 2)), list1895_1957);
      }
   }
}


obj_t 
_show_cfa_nb_iterations_163_cfa_show(obj_t env_3261)
{
   return show_cfa_nb_iterations_231_cfa_show();
}


obj_t 
show_cfa_results_28_cfa_show(obj_t globals_1)
{
   {
      bool_t test1900_1962;
      {
	 obj_t aux_3344;
	 aux_3344 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1900_1962 = CBOOL(aux_3344);
      }
      if (test1900_1962)
	{
	   obj_t list1901_1963;
	   {
	      obj_t arg1902_1964;
	      {
		 obj_t arg1905_1966;
		 {
		    obj_t arg1906_1967;
		    {
		       obj_t arg1908_1969;
		       {
			  obj_t aux_3350;
			  aux_3350 = BCHAR(((unsigned char) '\n'));
			  arg1908_1969 = MAKE_PAIR(aux_3350, BNIL);
		       }
		       arg1906_1967 = MAKE_PAIR(string2304_cfa_show, arg1908_1969);
		    }
		    {
		       obj_t aux_3354;
		       aux_3354 = BCHAR(((unsigned char) '\n'));
		       arg1905_1966 = MAKE_PAIR(aux_3354, arg1906_1967);
		    }
		 }
		 arg1902_1964 = MAKE_PAIR(string2305_cfa_show, arg1905_1966);
	      }
	      {
		 obj_t aux_3358;
		 aux_3358 = BCHAR(((unsigned char) '\n'));
		 list1901_1963 = MAKE_PAIR(aux_3358, arg1902_1964);
	      }
	   }
	   print_trace_107_tools_trace(list1901_1963);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test1913_1973;
      {
	 obj_t arg1921_1979;
	 arg1921_1979 = get_allocs_52_cfa_collect();
	 test1913_1973 = PAIRP(arg1921_1979);
      }
      if (test1913_1973)
	{
	   bool_t test1914_1974;
	   {
	      obj_t aux_3365;
	      aux_3365 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	      test1914_1974 = CBOOL(aux_3365);
	   }
	   if (test1914_1974)
	     {
		obj_t list1915_1975;
		{
		   obj_t aux_3371;
		   aux_3371 = BCHAR(((unsigned char) '\n'));
		   list1915_1975 = MAKE_PAIR(aux_3371, BNIL);
		}
		print_trace_107_tools_trace(list1915_1975);
	     }
	   else
	     {
		BUNSPEC;
	     }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t l1870_1980;
      {
	 obj_t arg1922_1982;
	 arg1922_1982 = get_allocs_52_cfa_collect();
	 l1870_1980 = arg1922_1982;
       lname1871_1981:
	 if (PAIRP(l1870_1980))
	   {
	      {
		 obj_t a_1984;
		 a_1984 = CAR(l1870_1980);
		 {
		    bool_t test1924_1985;
		    {
		       obj_t aux_3379;
		       aux_3379 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
		       test1924_1985 = CBOOL(aux_3379);
		    }
		    if (test1924_1985)
		      {
			 obj_t arg1925_1986;
			 obj_t arg1927_1988;
			 arg1925_1986 = node_key_123_cfa_approx((node_t) (a_1984));
			 arg1927_1988 = shape_tools_shape(a_1984);
			 {
			    obj_t list1930_1991;
			    {
			       obj_t arg1931_1992;
			       {
				  obj_t arg1932_1993;
				  {
				     obj_t arg1934_1994;
				     {
					obj_t arg1935_1995;
					{
					   obj_t arg1936_1996;
					   {
					      obj_t aux_3388;
					      aux_3388 = BCHAR(((unsigned char) '\n'));
					      arg1936_1996 = MAKE_PAIR(aux_3388, BNIL);
					   }
					   arg1935_1995 = MAKE_PAIR(string2306_cfa_show, arg1936_1996);
					}
					arg1934_1994 = MAKE_PAIR(string2307_cfa_show, arg1935_1995);
				     }
				     arg1932_1993 = MAKE_PAIR(arg1927_1988, arg1934_1994);
				  }
				  arg1931_1992 = MAKE_PAIR(string2308_cfa_show, arg1932_1993);
			       }
			       list1930_1991 = MAKE_PAIR(arg1925_1986, arg1931_1992);
			    }
			    print_trace_107_tools_trace(list1930_1991);
			 }
		      }
		    else
		      {
			 BUNSPEC;
		      }
		 }
	      }
	      {
		 obj_t l1870_3397;
		 l1870_3397 = CDR(l1870_1980);
		 l1870_1980 = l1870_3397;
		 goto lname1871_1981;
	      }
	   }
	 else
	   {
	      ((bool_t) 1);
	   }
      }
   }
   {
      bool_t test1941_2001;
      {
	 obj_t aux_3399;
	 aux_3399 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1941_2001 = CBOOL(aux_3399);
      }
      if (test1941_2001)
	{
	   obj_t list1942_2002;
	   {
	      obj_t aux_3405;
	      aux_3405 = BCHAR(((unsigned char) '\n'));
	      list1942_2002 = MAKE_PAIR(aux_3405, BNIL);
	   }
	   print_trace_107_tools_trace(list1942_2002);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test1946_2006;
      {
	 obj_t aux_3409;
	 aux_3409 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1946_2006 = CBOOL(aux_3409);
      }
      if (test1946_2006)
	{
	   unsigned char arg1947_2007;
	   {
	      obj_t old_case_198_2010;
	      old_case_198_2010 = __pp_case__242___pp;
	      __pp_case__242___pp = CNST_TABLE_REF(((long) 1));
	      {
		 obj_t l1872_2011;
		 l1872_2011 = globals_1;
	       lname1875_2012:
		 if (PAIRP(l1872_2011))
		   {
		      {
			 obj_t g_2014;
			 g_2014 = CAR(l1872_2011);
			 {
			    value_t fun_2015;
			    {
			       global_t obj_2869;
			       obj_2869 = (global_t) (g_2014);
			       fun_2015 = (((global_t) CREF(obj_2869))->value);
			    }
			    {
			       obj_t arg1951_2016;
			       arg1951_2016 = shape_tools_shape(g_2014);
			       {
				  obj_t list1952_2017;
				  list1952_2017 = MAKE_PAIR(arg1951_2016, BNIL);
				  write_scheme_comment_102_write_scheme(__trace_port__84_tools_trace, list1952_2017);
			       }
			    }
			    {
			       obj_t arg1954_2019;
			       {
				  obj_t arg1957_2022;
				  obj_t arg1958_2023;
				  obj_t arg1960_2024;
				  {
				     obj_t case_value_58_2030;
				     {
					sfun_t obj_2870;
					obj_2870 = (sfun_t) (fun_2015);
					case_value_58_2030 = (((sfun_t) CREF(obj_2870))->class);
				     }
				     {
					bool_t test_3426;
					{
					   obj_t aux_3427;
					   aux_3427 = CNST_TABLE_REF(((long) 2));
					   test_3426 = (case_value_58_2030 == aux_3427);
					}
					if (test_3426)
					  {
					     arg1957_2022 = CNST_TABLE_REF(((long) 3));
					  }
					else
					  {
					     bool_t test_3431;
					     {
						obj_t aux_3432;
						aux_3432 = CNST_TABLE_REF(((long) 4));
						test_3431 = (case_value_58_2030 == aux_3432);
					     }
					     if (test_3431)
					       {
						  arg1957_2022 = CNST_TABLE_REF(((long) 5));
					       }
					     else
					       {
						  bool_t test_3436;
						  {
						     obj_t aux_3437;
						     aux_3437 = CNST_TABLE_REF(((long) 6));
						     test_3436 = (case_value_58_2030 == aux_3437);
						  }
						  if (test_3436)
						    {
						       arg1957_2022 = CNST_TABLE_REF(((long) 7));
						    }
						  else
						    {
						       arg1957_2022 = CNST_TABLE_REF(((long) 8));
						    }
					       }
					  }
				     }
				  }
				  {
				     obj_t arg1974_2037;
				     obj_t arg1975_2038;
				     arg1974_2037 = shape_tools_shape(g_2014);
				     {
					obj_t arg1978_2041;
					obj_t arg1979_2042;
					{
					   obj_t l1876_2043;
					   {
					      sfun_t obj_2877;
					      obj_2877 = (sfun_t) (fun_2015);
					      l1876_2043 = (((sfun_t) CREF(obj_2877))->args);
					   }
					   if (NULLP(l1876_2043))
					     {
						arg1978_2041 = BNIL;
					     }
					   else
					     {
						obj_t head1878_2045;
						{
						   obj_t arg1987_2056;
						   arg1987_2056 = shape_tools_shape(CAR(l1876_2043));
						   head1878_2045 = MAKE_PAIR(arg1987_2056, BNIL);
						}
						{
						   obj_t l1876_2046;
						   obj_t tail1879_2047;
						   l1876_2046 = CDR(l1876_2043);
						   tail1879_2047 = head1878_2045;
						 lname1877_2048:
						   if (NULLP(l1876_2046))
						     {
							arg1978_2041 = head1878_2045;
						     }
						   else
						     {
							obj_t new_tail1880_65_2051;
							{
							   obj_t arg1984_2053;
							   arg1984_2053 = shape_tools_shape(CAR(l1876_2046));
							   new_tail1880_65_2051 = MAKE_PAIR(arg1984_2053, BNIL);
							}
							SET_CDR(tail1879_2047, new_tail1880_65_2051);
							{
							   obj_t tail1879_3458;
							   obj_t l1876_3456;
							   l1876_3456 = CDR(l1876_2046);
							   tail1879_3458 = new_tail1880_65_2051;
							   tail1879_2047 = tail1879_3458;
							   l1876_2046 = l1876_3456;
							   goto lname1877_2048;
							}
						     }
						}
					     }
					}
					arg1979_2042 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
					arg1975_2038 = append_2_18___r4_pairs_and_lists_6_3(arg1978_2041, arg1979_2042);
				     }
				     {
					obj_t list1976_2039;
					list1976_2039 = MAKE_PAIR(arg1975_2038, BNIL);
					arg1958_2023 = cons__138___r4_pairs_and_lists_6_3(arg1974_2037, list1976_2039);
				     }
				  }
				  {
				     obj_t aux_3464;
				     {
					sfun_t obj_2890;
					obj_2890 = (sfun_t) (fun_2015);
					aux_3464 = (((sfun_t) CREF(obj_2890))->body);
				     }
				     arg1960_2024 = shape_tools_shape(aux_3464);
				  }
				  {
				     obj_t list1964_2026;
				     {
					obj_t arg1965_2027;
					{
					   obj_t arg1966_2028;
					   arg1966_2028 = MAKE_PAIR(BNIL, BNIL);
					   arg1965_2027 = MAKE_PAIR(arg1960_2024, arg1966_2028);
					}
					list1964_2026 = MAKE_PAIR(arg1958_2023, arg1965_2027);
				     }
				     arg1954_2019 = cons__138___r4_pairs_and_lists_6_3(arg1957_2022, list1964_2026);
				  }
			       }
			       {
				  obj_t list1955_2020;
				  list1955_2020 = MAKE_PAIR(__trace_port__84_tools_trace, BNIL);
				  pp___pp(arg1954_2019, list1955_2020);
			       }
			    }
			 }
		      }
		      {
			 obj_t l1872_3474;
			 l1872_3474 = CDR(l1872_2011);
			 l1872_2011 = l1872_3474;
			 goto lname1875_2012;
		      }
		   }
		 else
		   {
		      ((bool_t) 1);
		   }
	      }
	      __pp_case__242___pp = old_case_198_2010;
	      arg1947_2007 = ((unsigned char) '\n');
	   }
	   {
	      obj_t list1948_2008;
	      {
		 obj_t aux_3476;
		 aux_3476 = BCHAR(arg1947_2007);
		 list1948_2008 = MAKE_PAIR(aux_3476, BNIL);
	      }
	      return print_trace_107_tools_trace(list1948_2008);
	   }
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_show_cfa_results_182_cfa_show(obj_t env_3262, obj_t globals_3263)
{
   return show_cfa_results_28_cfa_show(globals_3263);
}


obj_t 
cfa_variable_shape_84_cfa_show(obj_t variable_4, obj_t port_5)
{
   {
      value_t value_2065;
      {
	 variable_t obj_2892;
	 obj_2892 = (variable_t) (variable_4);
	 value_2065 = (((variable_t) CREF(obj_2892))->value);
      }
      {
	 bool_t test1997_2066;
	 test1997_2066 = is_a__118___object((obj_t) (value_2065), svar_cinfo_166_cfa_info);
	 if (test1997_2066)
	   {
	      {
		 obj_t list1998_2067;
		 list1998_2067 = MAKE_PAIR(port_5, BNIL);
		 display___r4_output_6_10_3(string2307_cfa_show, list1998_2067);
	      }
	      {
		 obj_t arg2000_2069;
		 {
		    obj_t aux_3488;
		    {
		       approx_t aux_3489;
		       {
			  svar_cinfo_166_t obj_2894;
			  obj_2894 = (svar_cinfo_166_t) (value_2065);
			  {
			     obj_t aux_3491;
			     {
				object_t aux_3492;
				aux_3492 = (object_t) (obj_2894);
				aux_3491 = OBJECT_WIDENING(aux_3492);
			     }
			     aux_3489 = (((svar_cinfo_166_t) CREF(aux_3491))->approx);
			  }
		       }
		       aux_3488 = (obj_t) (aux_3489);
		    }
		    arg2000_2069 = shape_tools_shape(aux_3488);
		 }
		 {
		    obj_t list2001_2070;
		    list2001_2070 = MAKE_PAIR(port_5, BNIL);
		    display___r4_output_6_10_3(arg2000_2069, list2001_2070);
		 }
	      }
	   }
	 else
	   {
	      bool_t test2004_2073;
	      test2004_2073 = is_a__118___object((obj_t) (value_2065), cvar_cinfo_53_cfa_info);
	      if (test2004_2073)
		{
		   {
		      obj_t list2005_2074;
		      list2005_2074 = MAKE_PAIR(port_5, BNIL);
		      display___r4_output_6_10_3(string2307_cfa_show, list2005_2074);
		   }
		   {
		      obj_t arg2007_2076;
		      {
			 obj_t aux_3505;
			 {
			    approx_t aux_3506;
			    {
			       cvar_cinfo_53_t obj_2896;
			       obj_2896 = (cvar_cinfo_53_t) (value_2065);
			       {
				  obj_t aux_3508;
				  {
				     object_t aux_3509;
				     aux_3509 = (object_t) (obj_2896);
				     aux_3508 = OBJECT_WIDENING(aux_3509);
				  }
				  aux_3506 = (((cvar_cinfo_53_t) CREF(aux_3508))->approx);
			       }
			    }
			    aux_3505 = (obj_t) (aux_3506);
			 }
			 arg2007_2076 = shape_tools_shape(aux_3505);
		      }
		      {
			 obj_t list2008_2077;
			 list2008_2077 = MAKE_PAIR(port_5, BNIL);
			 display___r4_output_6_10_3(arg2007_2076, list2008_2077);
		      }
		   }
		}
	      else
		{
		   bool_t test2013_2080;
		   test2013_2080 = is_a__118___object((obj_t) (value_2065), scnst_cinfo_0_cfa_info);
		   if (test2013_2080)
		     {
			{
			   obj_t list2014_2081;
			   list2014_2081 = MAKE_PAIR(port_5, BNIL);
			   display___r4_output_6_10_3(string2307_cfa_show, list2014_2081);
			}
			{
			   obj_t arg2016_2083;
			   {
			      obj_t aux_3522;
			      {
				 approx_t aux_3523;
				 {
				    scnst_cinfo_0_t obj_2898;
				    obj_2898 = (scnst_cinfo_0_t) (value_2065);
				    {
				       obj_t aux_3525;
				       {
					  object_t aux_3526;
					  aux_3526 = (object_t) (obj_2898);
					  aux_3525 = OBJECT_WIDENING(aux_3526);
				       }
				       aux_3523 = (((scnst_cinfo_0_t) CREF(aux_3525))->approx);
				    }
				 }
				 aux_3522 = (obj_t) (aux_3523);
			      }
			      arg2016_2083 = shape_tools_shape(aux_3522);
			   }
			   {
			      obj_t list2017_2084;
			      list2017_2084 = MAKE_PAIR(port_5, BNIL);
			      display___r4_output_6_10_3(arg2016_2083, list2017_2084);
			   }
			}
		     }
		   else
		     {
			bool_t test2020_2087;
			test2020_2087 = is_a__118___object((obj_t) (value_2065), intern_sfun_cinfo_192_cfa_info);
			if (test2020_2087)
			  {
			     {
				obj_t list2021_2088;
				list2021_2088 = MAKE_PAIR(port_5, BNIL);
				display___r4_output_6_10_3(string2307_cfa_show, list2021_2088);
			     }
			     {
				obj_t arg2025_2090;
				{
				   obj_t aux_3539;
				   {
				      approx_t aux_3540;
				      {
					 intern_sfun_cinfo_192_t obj_2900;
					 obj_2900 = (intern_sfun_cinfo_192_t) (value_2065);
					 {
					    obj_t aux_3542;
					    {
					       object_t aux_3543;
					       aux_3543 = (object_t) (obj_2900);
					       aux_3542 = OBJECT_WIDENING(aux_3543);
					    }
					    aux_3540 = (((intern_sfun_cinfo_192_t) CREF(aux_3542))->approx);
					 }
				      }
				      aux_3539 = (obj_t) (aux_3540);
				   }
				   arg2025_2090 = shape_tools_shape(aux_3539);
				}
				{
				   obj_t list2026_2091;
				   list2026_2091 = MAKE_PAIR(port_5, BNIL);
				   display___r4_output_6_10_3(arg2025_2090, list2026_2091);
				}
			     }
			  }
			else
			  {
			     bool_t test2029_2094;
			     test2029_2094 = is_a__118___object((obj_t) (value_2065), extern_sfun_cinfo_6_cfa_info);
			     if (test2029_2094)
			       {
				  {
				     obj_t list2030_2095;
				     list2030_2095 = MAKE_PAIR(port_5, BNIL);
				     display___r4_output_6_10_3(string2307_cfa_show, list2030_2095);
				  }
				  {
				     obj_t arg2032_2097;
				     {
					obj_t aux_3556;
					{
					   approx_t aux_3557;
					   {
					      extern_sfun_cinfo_6_t obj_2902;
					      obj_2902 = (extern_sfun_cinfo_6_t) (value_2065);
					      {
						 obj_t aux_3559;
						 {
						    object_t aux_3560;
						    aux_3560 = (object_t) (obj_2902);
						    aux_3559 = OBJECT_WIDENING(aux_3560);
						 }
						 aux_3557 = (((extern_sfun_cinfo_6_t) CREF(aux_3559))->approx);
					      }
					   }
					   aux_3556 = (obj_t) (aux_3557);
					}
					arg2032_2097 = shape_tools_shape(aux_3556);
				     }
				     {
					obj_t list2033_2098;
					list2033_2098 = MAKE_PAIR(port_5, BNIL);
					display___r4_output_6_10_3(arg2032_2097, list2033_2098);
				     }
				  }
			       }
			     else
			       {
				  bool_t test2036_2101;
				  test2036_2101 = is_a__118___object((obj_t) (value_2065), cfun_cinfo_200_cfa_info);
				  if (test2036_2101)
				    {
				       {
					  obj_t list2037_2102;
					  list2037_2102 = MAKE_PAIR(port_5, BNIL);
					  display___r4_output_6_10_3(string2307_cfa_show, list2037_2102);
				       }
				       {
					  obj_t arg2040_2104;
					  {
					     obj_t aux_3573;
					     {
						approx_t aux_3574;
						{
						   cfun_cinfo_200_t obj_2904;
						   obj_2904 = (cfun_cinfo_200_t) (value_2065);
						   {
						      obj_t aux_3576;
						      {
							 object_t aux_3577;
							 aux_3577 = (object_t) (obj_2904);
							 aux_3576 = OBJECT_WIDENING(aux_3577);
						      }
						      aux_3574 = (((cfun_cinfo_200_t) CREF(aux_3576))->approx);
						   }
						}
						aux_3573 = (obj_t) (aux_3574);
					     }
					     arg2040_2104 = shape_tools_shape(aux_3573);
					  }
					  {
					     obj_t list2041_2105;
					     list2041_2105 = MAKE_PAIR(port_5, BNIL);
					     display___r4_output_6_10_3(arg2040_2104, list2041_2105);
					  }
				       }
				    }
				  else
				    {
				       BFALSE;
				    }
			       }
			  }
		     }
		}
	   }
      }
      {
	 obj_t arg2046_2108;
	 arg2046_2108 = close_output_port(port_5);
	 {
	    char *aux_3586;
	    aux_3586 = BSTRING_TO_STRING(arg2046_2108);
	    return string_to_symbol(aux_3586);
	 }
      }
   }
}


obj_t 
imported_modules_init_94_cfa_show()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_SHOW");
   module_initialization_70_tools_shape(((long) 0), "CFA_SHOW");
   module_initialization_70_tools_speek(((long) 0), "CFA_SHOW");
   module_initialization_70_write_scheme(((long) 0), "CFA_SHOW");
   module_initialization_70_type_type(((long) 0), "CFA_SHOW");
   module_initialization_70_ast_var(((long) 0), "CFA_SHOW");
   module_initialization_70_ast_node(((long) 0), "CFA_SHOW");
   module_initialization_70_cfa_info(((long) 0), "CFA_SHOW");
   module_initialization_70_cfa_approx(((long) 0), "CFA_SHOW");
   module_initialization_70_cfa_collect(((long) 0), "CFA_SHOW");
   return module_initialization_70_cfa_iterate(((long) 0), "CFA_SHOW");
}
