/*===========================================================================*/
/*   (Cfa/specialize.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_t;

typedef struct specialized_global_131
  {
     obj_t fix;
  }
                      *specialized_global_131_t;


extern obj_t let_fun_218_ast_node;
static bool_t show_specialize_223_cfa_specialize();
static obj_t patch_fun__141_cfa_specialize(obj_t);
static global_t allocate_specialized_global_107_cfa_specialize();
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
static obj_t _patch__default1348_12_cfa_specialize(obj_t, obj_t);
extern obj_t closure_ast_node;
static obj_t object__struct_specialized_global2023_109_cfa_specialize(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t _struct_object__object_6___object(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_cfa_specialize();
extern obj_t module_initialization_70_cfa_specialize(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_inline_walk(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t __specialized_types__137_cfa_specialize = BUNSPEC;
static obj_t toplevel_init_63_cfa_specialize();
static obj_t cnst_init_137_cfa_specialize();
extern obj_t __optim__89_engine_param;
static bool_t uninstall_specializes__251_cfa_specialize();
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
static obj_t require_initialization_114_cfa_specialize = BUNSPEC;
static obj_t _patch__77_cfa_specialize(obj_t, obj_t);
static obj_t patch__default1348_94_cfa_specialize(node_t);
extern obj_t var_ast_node;
static obj_t library_modules_init_112_cfa_specialize();
extern obj_t sfun_ast_var;
extern obj_t cast_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t __lib_mode__85_engine_param;
extern obj_t conditional_ast_node;
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t patch__227_cfa_specialize(node_t);
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t warning___error(obj_t);
extern obj_t pragma_ast_node;
static obj_t specialized_global_131_cfa_specialize = BUNSPEC;
extern obj_t class_super_145___object(obj_t);
extern long class_num_218___object(obj_t);
static obj_t install_specialized_type__228_cfa_specialize(type_t);
static obj_t __specialize__50_cfa_specialize = BUNSPEC;
extern obj_t object__struct_50___object(object_t);
static obj_t add_specialized_type__70_cfa_specialize(type_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t _specialize__238_cfa_specialize(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static bool_t patch_tree__164_cfa_specialize(obj_t);
extern obj_t setq_ast_node;
static obj_t _allocate_specialized_global_95_cfa_specialize(obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
static bool_t specialize_optimization__103_cfa_specialize();
static obj_t object_init_111_cfa_specialize();
static node_t specialize_app__163_cfa_specialize(app_t);
extern obj_t set_ex_it_116_ast_node;
extern type_t typeof_coerce_typeof(node_t);
static obj_t patch___72_cfa_specialize(obj_t);
extern obj_t kwote_ast_node;
extern obj_t specialize__184_cfa_specialize(obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t _object__struct_74___object(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
static obj_t struct_object__object_specialized_global2022_107_cfa_specialize(obj_t, obj_t, obj_t);
extern object_t struct_object__object_93___object(object_t, obj_t);
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t install_specialize__168_cfa_specialize(obj_t, obj_t, obj_t);
static obj_t __cnst[60];

DEFINE_STRING(string2025_cfa_specialize, string2025_cfa_specialize2045, ")\n", 2);
DEFINE_STRING(string2024_cfa_specialize, string2024_cfa_specialize2046, "   . specializing", 17);
DEFINE_STRING(string2028_cfa_specialize, string2028_cfa_specialize2047, "add-specialized-type!", 21);
DEFINE_STATIC_GENERIC(patch__env_129_cfa_specialize, _patch__77_cfa_specialize2048, _patch__77_cfa_specialize, 0L, 1);
DEFINE_EXPORT_PROCEDURE(specialize__env_161_cfa_specialize, _specialize__238_cfa_specialize2049, _specialize__238_cfa_specialize, 0L, 1);
DEFINE_STRING(string2033_cfa_specialize, string2033_cfa_specialize2050, "Can't fund global", 17);
DEFINE_STRING(string2039_cfa_specialize, string2039_cfa_specialize2051, "SPECIALIZED-GLOBAL DONE PATCH!-DEFAULT1348 SQRTFL SQRT ACOSFL ACOS ASINFL ASIN TANFL TAN COSFL COS SINFL SIN EXPFL EXP LOGFL LOG ABSFL ABSFX ABS /FL 2/ *FL *FX 2* -FL -FX 2- +FL +FX 2+ NEGATIVEFL? NEGATIVEFX? NEGATIVE? POSITIVEFL? POSITIVEFX? POSITIVE? ZEROFL? ZEROFX? ZERO? >=FL >=FX 2>= <=FL <=FX 2<= >FL >FX 2> <FL <FX 2< __R4_NUMBERS_6_5_FLONUM =FL __R4_NUMBERS_6_5_FIXNUM =FX __R4_NUMBERS_6_5 2= ", 401);
DEFINE_STRING(string2027_cfa_specialize, string2027_cfa_specialize2052, "        (-> ", 12);
DEFINE_STRING(string2032_cfa_specialize, string2032_cfa_specialize2053, "install-specialize!", 19);
DEFINE_STRING(string2036_cfa_specialize, string2036_cfa_specialize2054, "Unexpected closure", 18);
DEFINE_STATIC_PROCEDURE(allocate_specialized_global_env_23_cfa_specialize, _allocate_specialized_global_95_cfa_specialize2055, _allocate_specialized_global_95_cfa_specialize, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2037_cfa_specialize, object__struct_specialized_global2023_109_cfa_specialize2056, object__struct_specialized_global2023_109_cfa_specialize, 0L, 1);
extern obj_t struct_object__object_env_209___object;
DEFINE_STRING(string2030_cfa_specialize, string2030_cfa_specialize2057, " -- ", 4);
DEFINE_STRING(string2031_cfa_specialize, string2031_cfa_specialize2058, "Can't find global", 17);
DEFINE_STRING(string2026_cfa_specialize, string2026_cfa_specialize2059, ": ", 2);
DEFINE_STRING(string2029_cfa_specialize, string2029_cfa_specialize2060, "Unspecialized type", 18);
DEFINE_STATIC_PROCEDURE(patch__default1348_env_0_cfa_specialize, _patch__default1348_12_cfa_specialize2061, _patch__default1348_12_cfa_specialize, 0L, 1);
DEFINE_STRING(string2034_cfa_specialize, string2034_cfa_specialize2062, "No method for this object", 25);
extern obj_t object__struct_env_210___object;
DEFINE_STRING(string2035_cfa_specialize, string2035_cfa_specialize2063, "patch!", 6);
DEFINE_STATIC_PROCEDURE(proc2038_cfa_specialize, struct_object__object_specialized_global2022_107_cfa_specialize2064, struct_object__object_specialized_global2022_107_cfa_specialize, 0L, 2);

obj_t 
module_initialization_70_cfa_specialize(long checksum_1970, char *from_1971)
{
   if (CBOOL(require_initialization_114_cfa_specialize))
     {
	require_initialization_114_cfa_specialize = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_specialize();
	cnst_init_137_cfa_specialize();
	object_init_111_cfa_specialize();
	imported_modules_init_94_cfa_specialize();
	toplevel_init_63_cfa_specialize();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_specialize()
{
   module_initialization_70___object(((long) 0), "CFA_SPECIALIZE");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_SPECIALIZE");
   module_initialization_70___reader(((long) 0), "CFA_SPECIALIZE");
   module_initialization_70___error(((long) 0), "CFA_SPECIALIZE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_specialize()
{
   {
      obj_t cnst_port_138_1962;
      cnst_port_138_1962 = open_input_string(string2039_cfa_specialize);
      {
	 long i_1963;
	 i_1963 = ((long) 59);
       loop_1964:
	 {
	    bool_t test2040_1965;
	    test2040_1965 = (i_1963 == ((long) -1));
	    if (test2040_1965)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2041_1966;
		    {
		       obj_t list2042_1967;
		       {
			  obj_t arg2043_1968;
			  arg2043_1968 = BNIL;
			  list2042_1967 = MAKE_PAIR(cnst_port_138_1962, arg2043_1968);
		       }
		       arg2041_1966 = read___reader(list2042_1967);
		    }
		    CNST_TABLE_SET(i_1963, arg2041_1966);
		 }
		 {
		    int aux_1969;
		    {
		       long aux_1990;
		       aux_1990 = (i_1963 - ((long) 1));
		       aux_1969 = (int) (aux_1990);
		    }
		    {
		       long i_1993;
		       i_1993 = (long) (aux_1969);
		       i_1963 = i_1993;
		       goto loop_1964;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_specialize()
{
   __specialize__50_cfa_specialize = BNIL;
   __specialized_types__137_cfa_specialize = BNIL;
   add_generic__110___object(patch__env_129_cfa_specialize, patch__default1348_env_0_cfa_specialize);
   add_inlined_method__244___object(patch__env_129_cfa_specialize, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, var_ast_node, ((long) 2));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, setq_ast_node, ((long) 9));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, conditional_ast_node, ((long) 10));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, fail_ast_node, ((long) 11));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, select_ast_node, ((long) 12));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, let_fun_218_ast_node, ((long) 13));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, let_var_6_ast_node, ((long) 14));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, set_ex_it_116_ast_node, ((long) 15));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, jump_ex_it_184_ast_node, ((long) 16));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, make_box_202_ast_node, ((long) 17));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, box_set__221_ast_node, ((long) 18));
   add_inlined_method__244___object(patch__env_129_cfa_specialize, box_ref_242_ast_node, ((long) 19));
   {
      long aux_2016;
      aux_2016 = add_inlined_method__244___object(patch__env_129_cfa_specialize, app_ast_node, ((long) 20));
      return BINT(aux_2016);
   }
}


bool_t 
specialize_optimization__103_cfa_specialize()
{
   {
      bool_t _andtest_1312_769;
      {
	 long n1_1589;
	 n1_1589 = (long) CINT(__optim__89_engine_param);
	 _andtest_1312_769 = (n1_1589 >= ((long) 1));
      }
      if (_andtest_1312_769)
	{
	   if (CBOOL(__lib_mode__85_engine_param))
	     {
		return ((bool_t) 0);
	     }
	   else
	     {
		return ((bool_t) 1);
	     }
	}
      else
	{
	   return ((bool_t) 0);
	}
   }
}


bool_t 
show_specialize_223_cfa_specialize()
{
   {
      obj_t list1384_770;
      {
	 obj_t arg1388_772;
	 {
	    obj_t aux_2024;
	    aux_2024 = BCHAR(((unsigned char) '\n'));
	    arg1388_772 = MAKE_PAIR(aux_2024, BNIL);
	 }
	 list1384_770 = MAKE_PAIR(string2024_cfa_specialize, arg1388_772);
      }
      verbose_tools_speek(BINT(((long) 1)), list1384_770);
   }
   {
      obj_t l1313_774;
      l1313_774 = __specialized_types__137_cfa_specialize;
    lname1314_775:
      if (PAIRP(l1313_774))
	{
	   {
	      obj_t type_num_186_777;
	      type_num_186_777 = CAR(l1313_774);
	      {
		 bool_t test_2033;
		 {
		    long aux_2034;
		    {
		       obj_t aux_2035;
		       aux_2035 = CDR(type_num_186_777);
		       aux_2034 = (long) CINT(aux_2035);
		    }
		    test_2033 = (aux_2034 > ((long) 0));
		 }
		 if (test_2033)
		   {
		      obj_t arg1400_781;
		      obj_t arg1403_783;
		      arg1400_781 = shape_tools_shape(CAR(type_num_186_777));
		      arg1403_783 = CDR(type_num_186_777);
		      {
			 obj_t list1405_785;
			 {
			    obj_t arg1406_786;
			    {
			       obj_t arg1408_787;
			       {
				  obj_t arg1410_788;
				  {
				     obj_t arg1411_789;
				     arg1411_789 = MAKE_PAIR(string2025_cfa_specialize, BNIL);
				     arg1410_788 = MAKE_PAIR(arg1403_783, arg1411_789);
				  }
				  arg1408_787 = MAKE_PAIR(string2026_cfa_specialize, arg1410_788);
			       }
			       arg1406_786 = MAKE_PAIR(arg1400_781, arg1408_787);
			    }
			    list1405_785 = MAKE_PAIR(string2027_cfa_specialize, arg1406_786);
			 }
			 verbose_tools_speek(BINT(((long) 2)), list1405_785);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	   }
	   {
	      obj_t l1313_2049;
	      l1313_2049 = CDR(l1313_774);
	      l1313_774 = l1313_2049;
	      goto lname1314_775;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
install_specialized_type__228_cfa_specialize(type_t type_1)
{
   {
      bool_t test1418_795;
      {
	 obj_t arg1421_797;
	 arg1421_797 = assq___r4_pairs_and_lists_6_3((obj_t) (type_1), __specialized_types__137_cfa_specialize);
	 test1418_795 = PAIRP(arg1421_797);
      }
      if (test1418_795)
	{
	   return BUNSPEC;
	}
      else
	{
	   obj_t arg1420_796;
	   {
	      obj_t aux_2057;
	      obj_t aux_2055;
	      aux_2057 = BINT(((long) 0));
	      aux_2055 = (obj_t) (type_1);
	      arg1420_796 = MAKE_PAIR(aux_2055, aux_2057);
	   }
	   {
	      obj_t obj2_1603;
	      obj2_1603 = __specialized_types__137_cfa_specialize;
	      return (__specialized_types__137_cfa_specialize = MAKE_PAIR(arg1420_796, obj2_1603),
		 BUNSPEC);
	   }
	}
   }
}


obj_t 
add_specialized_type__70_cfa_specialize(type_t type_2)
{
   {
      obj_t cell_798;
      cell_798 = assq___r4_pairs_and_lists_6_3((obj_t) (type_2), __specialized_types__137_cfa_specialize);
      if (PAIRP(cell_798))
	{
	   obj_t aux_2065;
	   {
	      long aux_2066;
	      {
		 long aux_2067;
		 {
		    obj_t aux_2068;
		    aux_2068 = CDR(cell_798);
		    aux_2067 = (long) CINT(aux_2068);
		 }
		 aux_2066 = (((long) 1) + aux_2067);
	      }
	      aux_2065 = BINT(aux_2066);
	   }
	   return SET_CDR(cell_798, aux_2065);
	}
      else
	{
	   obj_t arg1432_805;
	   arg1432_805 = shape_tools_shape((obj_t) (type_2));
	   return internal_error_43_tools_error(string2028_cfa_specialize, string2029_cfa_specialize, arg1432_805);
	}
   }
}


obj_t 
install_specialize__168_cfa_specialize(obj_t gen_id_29_3, obj_t gen_mod_247_4, obj_t fixes_5)
{
   {
      obj_t generic_806;
      {
	 obj_t list1488_853;
	 list1488_853 = MAKE_PAIR(gen_mod_247_4, BNIL);
	 generic_806 = find_global_223_ast_env(gen_id_29_3, list1488_853);
      }
      {
	 bool_t test1433_807;
	 test1433_807 = is_a__118___object(generic_806, global_ast_var);
	 if (test1433_807)
	   {
	      obj_t fixes_808;
	      obj_t res_809;
	      fixes_808 = fixes_5;
	      res_809 = BNIL;
	    loop_810:
	      if (NULLP(fixes_808))
		{
		   {
		      specialized_global_131_t obj1315_813;
		      obj1315_813 = ((specialized_global_131_t) (generic_806));
		      {
			 specialized_global_131_t arg1444_814;
			 {
			    specialized_global_131_t res1991_1615;
			    {
			       specialized_global_131_t new1290_1613;
			       new1290_1613 = ((specialized_global_131_t) BREF(GC_MALLOC(sizeof(struct specialized_global_131))));
			       ((((specialized_global_131_t) CREF(new1290_1613))->fix) = ((obj_t) res_809), BUNSPEC);
			       res1991_1615 = new1290_1613;
			    }
			    arg1444_814 = res1991_1615;
			 }
			 {
			    obj_t aux_2088;
			    object_t aux_2086;
			    aux_2088 = (obj_t) (arg1444_814);
			    aux_2086 = (object_t) (obj1315_813);
			    OBJECT_WIDENING_SET(aux_2086, aux_2088);
			 }
		      }
		      {
			 long arg1445_815;
			 arg1445_815 = class_num_218___object(specialized_global_131_cfa_specialize);
			 {
			    obj_t obj_1616;
			    obj_1616 = (obj_t) (obj1315_813);
			    (((obj_t) CREF(obj_1616))->header = MAKE_HEADER(arg1445_815, 0), BUNSPEC);
			 }
		      }
		      obj1315_813;
		   }
		   {
		      obj_t obj2_1619;
		      obj2_1619 = __specialize__50_cfa_specialize;
		      return (__specialize__50_cfa_specialize = MAKE_PAIR(generic_806, obj2_1619),
			 BUNSPEC);
		   }
		}
	      else
		{
		   obj_t id_816;
		   id_816 = CAR(fixes_808);
		   {
		      obj_t mod_817;
		      {
			 obj_t aux_2096;
			 aux_2096 = CDR(fixes_808);
			 mod_817 = CAR(aux_2096);
		      }
		      {
			 obj_t global_818;
			 {
			    obj_t list1475_842;
			    list1475_842 = MAKE_PAIR(mod_817, BNIL);
			    global_818 = find_global_223_ast_env(id_816, list1475_842);
			 }
			 {
			    {
			       bool_t test1446_819;
			       {
				  bool_t test1469_837;
				  test1469_837 = is_a__118___object(global_818, global_ast_var);
				  if (test1469_837)
				    {
				       bool_t test1470_838;
				       {
					  obj_t aux_2103;
					  {
					     value_t aux_2104;
					     {
						global_t obj_1626;
						obj_1626 = (global_t) (global_818);
						aux_2104 = (((global_t) CREF(obj_1626))->value);
					     }
					     aux_2103 = (obj_t) (aux_2104);
					  }
					  test1470_838 = is_a__118___object(aux_2103, sfun_ast_var);
				       }
				       if (test1470_838)
					 {
					    obj_t aux_2110;
					    {
					       sfun_t obj_1629;
					       {
						  value_t aux_2111;
						  {
						     global_t obj_1628;
						     obj_1628 = (global_t) (global_818);
						     aux_2111 = (((global_t) CREF(obj_1628))->value);
						  }
						  obj_1629 = (sfun_t) (aux_2111);
					       }
					       aux_2110 = (((sfun_t) CREF(obj_1629))->args);
					    }
					    test1446_819 = PAIRP(aux_2110);
					 }
				       else
					 {
					    test1446_819 = ((bool_t) 0);
					 }
				    }
				  else
				    {
				       test1446_819 = ((bool_t) 0);
				    }
			       }
			       if (test1446_819)
				 {
				    type_t type_820;
				    {
				       local_t obj_1634;
				       {
					  obj_t aux_2118;
					  {
					     obj_t aux_2119;
					     {
						sfun_t obj_1632;
						{
						   value_t aux_2120;
						   {
						      global_t obj_1631;
						      obj_1631 = (global_t) (global_818);
						      aux_2120 = (((global_t) CREF(obj_1631))->value);
						   }
						   obj_1632 = (sfun_t) (aux_2120);
						}
						aux_2119 = (((sfun_t) CREF(obj_1632))->args);
					     }
					     aux_2118 = CAR(aux_2119);
					  }
					  obj_1634 = (local_t) (aux_2118);
				       }
				       type_820 = (((local_t) CREF(obj_1634))->type);
				    }
				    install_specialized_type__228_cfa_specialize(type_820);
				    {
				       obj_t arg1447_821;
				       obj_t arg1448_822;
				       {
					  obj_t aux_2129;
					  aux_2129 = CDR(fixes_808);
					  arg1447_821 = CDR(aux_2129);
				       }
				       {
					  obj_t arg1449_823;
					  {
					     obj_t aux_2132;
					     aux_2132 = (obj_t) (type_820);
					     arg1449_823 = MAKE_PAIR(aux_2132, global_818);
					  }
					  arg1448_822 = MAKE_PAIR(arg1449_823, res_809);
				       }
				       {
					  obj_t res_2137;
					  obj_t fixes_2136;
					  fixes_2136 = arg1447_821;
					  res_2137 = arg1448_822;
					  res_809 = res_2137;
					  fixes_808 = fixes_2136;
					  goto loop_810;
				       }
				    }
				 }
			       else
				 {
				    {
				       obj_t arg1461_830;
				       arg1461_830 = MAKE_PAIR(id_816, mod_817);
				       {
					  obj_t list1462_831;
					  {
					     obj_t arg1463_832;
					     {
						obj_t arg1465_833;
						{
						   obj_t arg1466_834;
						   arg1466_834 = MAKE_PAIR(arg1461_830, BNIL);
						   arg1465_833 = MAKE_PAIR(string2030_cfa_specialize, arg1466_834);
						}
						arg1463_832 = MAKE_PAIR(string2031_cfa_specialize, arg1465_833);
					     }
					     list1462_831 = MAKE_PAIR(string2032_cfa_specialize, arg1463_832);
					  }
					  warning___error(list1462_831);
				       }
				    }
				    {
				       obj_t fixes_2144;
				       {
					  obj_t aux_2145;
					  aux_2145 = CDR(fixes_808);
					  fixes_2144 = CDR(aux_2145);
				       }
				       fixes_808 = fixes_2144;
				       goto loop_810;
				    }
				 }
			    }
			 }
		      }
		   }
		}
	   }
	 else
	   {
	      obj_t arg1481_847;
	      arg1481_847 = MAKE_PAIR(gen_id_29_3, gen_mod_247_4);
	      {
		 obj_t list1482_848;
		 {
		    obj_t arg1484_849;
		    {
		       obj_t arg1485_850;
		       {
			  obj_t arg1486_851;
			  arg1486_851 = MAKE_PAIR(arg1481_847, BNIL);
			  arg1485_850 = MAKE_PAIR(string2030_cfa_specialize, arg1486_851);
		       }
		       arg1484_849 = MAKE_PAIR(string2033_cfa_specialize, arg1485_850);
		    }
		    list1482_848 = MAKE_PAIR(string2032_cfa_specialize, arg1484_849);
		 }
		 return warning___error(list1482_848);
	      }
	   }
      }
   }
}


bool_t 
uninstall_specializes__251_cfa_specialize()
{
   __specialized_types__137_cfa_specialize = BNIL;
   {
      obj_t l1316_855;
      l1316_855 = __specialize__50_cfa_specialize;
    lname1318_856:
      if (PAIRP(l1316_855))
	{
	   {
	      obj_t o1319_858;
	      o1319_858 = CAR(l1316_855);
	      {
		 long arg1493_859;
		 {
		    obj_t arg1494_860;
		    {
		       obj_t arg1496_861;
		       {
			  object_t object_1653;
			  object_1653 = (object_t) (o1319_858);
			  {
			     long arg1187_1654;
			     {
				long arg1188_1655;
				long arg1189_1656;
				arg1188_1655 = TYPE(object_1653);
				arg1189_1656 = OBJECT_TYPE;
				arg1187_1654 = (arg1188_1655 - arg1189_1656);
			     }
			     {
				obj_t vector_1660;
				vector_1660 = __classes__134___object;
				arg1496_861 = VECTOR_REF(vector_1660, arg1187_1654);
			     }
			  }
		       }
		       arg1494_860 = class_super_145___object(arg1496_861);
		    }
		    arg1493_859 = class_num_218___object(arg1494_860);
		 }
		 (((obj_t) CREF(o1319_858))->header = MAKE_HEADER(arg1493_859, 0), BUNSPEC);
	      }
	      {
		 object_t aux_2165;
		 aux_2165 = (object_t) (o1319_858);
		 OBJECT_WIDENING_SET(aux_2165, BFALSE);
	      }
	      o1319_858;
	   }
	   {
	      obj_t l1316_2168;
	      l1316_2168 = CDR(l1316_855);
	      l1316_855 = l1316_2168;
	      goto lname1318_856;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
specialize__184_cfa_specialize(obj_t globals_6)
{
   if (specialize_optimization__103_cfa_specialize())
     {
	{
	   obj_t arg1499_864;
	   obj_t arg1500_865;
	   obj_t arg1501_866;
	   obj_t arg1505_867;
	   obj_t arg1506_868;
	   arg1499_864 = CNST_TABLE_REF(((long) 0));
	   arg1500_865 = CNST_TABLE_REF(((long) 1));
	   arg1501_866 = CNST_TABLE_REF(((long) 2));
	   arg1505_867 = CNST_TABLE_REF(((long) 3));
	   arg1506_868 = CNST_TABLE_REF(((long) 4));
	   {
	      obj_t list1508_870;
	      {
		 obj_t arg1509_871;
		 {
		    obj_t arg1510_872;
		    {
		       obj_t arg1511_873;
		       {
			  obj_t aux_2177;
			  aux_2177 = CNST_TABLE_REF(((long) 5));
			  arg1511_873 = MAKE_PAIR(aux_2177, BNIL);
		       }
		       arg1510_872 = MAKE_PAIR(arg1506_868, arg1511_873);
		    }
		    arg1509_871 = MAKE_PAIR(arg1505_867, arg1510_872);
		 }
		 list1508_870 = MAKE_PAIR(arg1501_866, arg1509_871);
	      }
	      install_specialize__168_cfa_specialize(arg1499_864, arg1500_865, list1508_870);
	   }
	}
	{
	   obj_t arg1514_875;
	   obj_t arg1517_876;
	   obj_t arg1518_877;
	   obj_t arg1520_878;
	   obj_t arg1522_879;
	   arg1514_875 = CNST_TABLE_REF(((long) 6));
	   arg1517_876 = CNST_TABLE_REF(((long) 1));
	   arg1518_877 = CNST_TABLE_REF(((long) 7));
	   arg1520_878 = CNST_TABLE_REF(((long) 3));
	   arg1522_879 = CNST_TABLE_REF(((long) 8));
	   {
	      obj_t list1524_881;
	      {
		 obj_t arg1526_882;
		 {
		    obj_t arg1529_883;
		    {
		       obj_t arg1531_884;
		       {
			  obj_t aux_2189;
			  aux_2189 = CNST_TABLE_REF(((long) 5));
			  arg1531_884 = MAKE_PAIR(aux_2189, BNIL);
		       }
		       arg1529_883 = MAKE_PAIR(arg1522_879, arg1531_884);
		    }
		    arg1526_882 = MAKE_PAIR(arg1520_878, arg1529_883);
		 }
		 list1524_881 = MAKE_PAIR(arg1518_877, arg1526_882);
	      }
	      install_specialize__168_cfa_specialize(arg1514_875, arg1517_876, list1524_881);
	   }
	}
	{
	   obj_t arg1534_886;
	   obj_t arg1535_887;
	   obj_t arg1536_888;
	   obj_t arg1537_889;
	   obj_t arg1538_890;
	   arg1534_886 = CNST_TABLE_REF(((long) 9));
	   arg1535_887 = CNST_TABLE_REF(((long) 1));
	   arg1536_888 = CNST_TABLE_REF(((long) 10));
	   arg1537_889 = CNST_TABLE_REF(((long) 3));
	   arg1538_890 = CNST_TABLE_REF(((long) 11));
	   {
	      obj_t list1540_892;
	      {
		 obj_t arg1541_893;
		 {
		    obj_t arg1542_894;
		    {
		       obj_t arg1543_895;
		       {
			  obj_t aux_2201;
			  aux_2201 = CNST_TABLE_REF(((long) 5));
			  arg1543_895 = MAKE_PAIR(aux_2201, BNIL);
		       }
		       arg1542_894 = MAKE_PAIR(arg1538_890, arg1543_895);
		    }
		    arg1541_893 = MAKE_PAIR(arg1537_889, arg1542_894);
		 }
		 list1540_892 = MAKE_PAIR(arg1536_888, arg1541_893);
	      }
	      install_specialize__168_cfa_specialize(arg1534_886, arg1535_887, list1540_892);
	   }
	}
	{
	   obj_t arg1549_897;
	   obj_t arg1550_898;
	   obj_t arg1551_899;
	   obj_t arg1552_900;
	   obj_t arg1553_901;
	   arg1549_897 = CNST_TABLE_REF(((long) 12));
	   arg1550_898 = CNST_TABLE_REF(((long) 1));
	   arg1551_899 = CNST_TABLE_REF(((long) 13));
	   arg1552_900 = CNST_TABLE_REF(((long) 3));
	   arg1553_901 = CNST_TABLE_REF(((long) 14));
	   {
	      obj_t list1555_903;
	      {
		 obj_t arg1557_904;
		 {
		    obj_t arg1559_905;
		    {
		       obj_t arg1560_906;
		       {
			  obj_t aux_2213;
			  aux_2213 = CNST_TABLE_REF(((long) 5));
			  arg1560_906 = MAKE_PAIR(aux_2213, BNIL);
		       }
		       arg1559_905 = MAKE_PAIR(arg1553_901, arg1560_906);
		    }
		    arg1557_904 = MAKE_PAIR(arg1552_900, arg1559_905);
		 }
		 list1555_903 = MAKE_PAIR(arg1551_899, arg1557_904);
	      }
	      install_specialize__168_cfa_specialize(arg1549_897, arg1550_898, list1555_903);
	   }
	}
	{
	   obj_t arg1562_908;
	   obj_t arg1563_909;
	   obj_t arg1564_910;
	   obj_t arg1565_911;
	   obj_t arg1566_912;
	   arg1562_908 = CNST_TABLE_REF(((long) 15));
	   arg1563_909 = CNST_TABLE_REF(((long) 1));
	   arg1564_910 = CNST_TABLE_REF(((long) 16));
	   arg1565_911 = CNST_TABLE_REF(((long) 3));
	   arg1566_912 = CNST_TABLE_REF(((long) 17));
	   {
	      obj_t list1568_914;
	      {
		 obj_t arg1570_915;
		 {
		    obj_t arg1571_916;
		    {
		       obj_t arg1572_917;
		       {
			  obj_t aux_2225;
			  aux_2225 = CNST_TABLE_REF(((long) 5));
			  arg1572_917 = MAKE_PAIR(aux_2225, BNIL);
		       }
		       arg1571_916 = MAKE_PAIR(arg1566_912, arg1572_917);
		    }
		    arg1570_915 = MAKE_PAIR(arg1565_911, arg1571_916);
		 }
		 list1568_914 = MAKE_PAIR(arg1564_910, arg1570_915);
	      }
	      install_specialize__168_cfa_specialize(arg1562_908, arg1563_909, list1568_914);
	   }
	}
	{
	   obj_t arg1574_919;
	   obj_t arg1575_920;
	   obj_t arg1576_921;
	   obj_t arg1577_922;
	   obj_t arg1578_923;
	   arg1574_919 = CNST_TABLE_REF(((long) 18));
	   arg1575_920 = CNST_TABLE_REF(((long) 1));
	   arg1576_921 = CNST_TABLE_REF(((long) 19));
	   arg1577_922 = CNST_TABLE_REF(((long) 3));
	   arg1578_923 = CNST_TABLE_REF(((long) 20));
	   {
	      obj_t list1580_925;
	      {
		 obj_t arg1582_926;
		 {
		    obj_t arg1583_927;
		    {
		       obj_t arg1584_928;
		       {
			  obj_t aux_2237;
			  aux_2237 = CNST_TABLE_REF(((long) 5));
			  arg1584_928 = MAKE_PAIR(aux_2237, BNIL);
		       }
		       arg1583_927 = MAKE_PAIR(arg1578_923, arg1584_928);
		    }
		    arg1582_926 = MAKE_PAIR(arg1577_922, arg1583_927);
		 }
		 list1580_925 = MAKE_PAIR(arg1576_921, arg1582_926);
	      }
	      install_specialize__168_cfa_specialize(arg1574_919, arg1575_920, list1580_925);
	   }
	}
	{
	   obj_t arg1587_930;
	   obj_t arg1588_931;
	   obj_t arg1589_932;
	   obj_t arg1590_933;
	   obj_t arg1591_934;
	   arg1587_930 = CNST_TABLE_REF(((long) 21));
	   arg1588_931 = CNST_TABLE_REF(((long) 1));
	   arg1589_932 = CNST_TABLE_REF(((long) 22));
	   arg1590_933 = CNST_TABLE_REF(((long) 3));
	   arg1591_934 = CNST_TABLE_REF(((long) 23));
	   {
	      obj_t list1593_936;
	      {
		 obj_t arg1595_937;
		 {
		    obj_t arg1596_938;
		    {
		       obj_t arg1597_939;
		       {
			  obj_t aux_2249;
			  aux_2249 = CNST_TABLE_REF(((long) 5));
			  arg1597_939 = MAKE_PAIR(aux_2249, BNIL);
		       }
		       arg1596_938 = MAKE_PAIR(arg1591_934, arg1597_939);
		    }
		    arg1595_937 = MAKE_PAIR(arg1590_933, arg1596_938);
		 }
		 list1593_936 = MAKE_PAIR(arg1589_932, arg1595_937);
	      }
	      install_specialize__168_cfa_specialize(arg1587_930, arg1588_931, list1593_936);
	   }
	}
	{
	   obj_t arg1601_941;
	   obj_t arg1603_942;
	   obj_t arg1604_943;
	   obj_t arg1605_944;
	   obj_t arg1606_945;
	   arg1601_941 = CNST_TABLE_REF(((long) 24));
	   arg1603_942 = CNST_TABLE_REF(((long) 1));
	   arg1604_943 = CNST_TABLE_REF(((long) 25));
	   arg1605_944 = CNST_TABLE_REF(((long) 3));
	   arg1606_945 = CNST_TABLE_REF(((long) 26));
	   {
	      obj_t list1609_947;
	      {
		 obj_t arg1611_948;
		 {
		    obj_t arg1614_949;
		    {
		       obj_t arg1616_950;
		       {
			  obj_t aux_2261;
			  aux_2261 = CNST_TABLE_REF(((long) 5));
			  arg1616_950 = MAKE_PAIR(aux_2261, BNIL);
		       }
		       arg1614_949 = MAKE_PAIR(arg1606_945, arg1616_950);
		    }
		    arg1611_948 = MAKE_PAIR(arg1605_944, arg1614_949);
		 }
		 list1609_947 = MAKE_PAIR(arg1604_943, arg1611_948);
	      }
	      install_specialize__168_cfa_specialize(arg1601_941, arg1603_942, list1609_947);
	   }
	}
	{
	   obj_t arg1618_952;
	   obj_t arg1619_953;
	   obj_t arg1620_954;
	   obj_t arg1621_955;
	   obj_t arg1623_956;
	   arg1618_952 = CNST_TABLE_REF(((long) 27));
	   arg1619_953 = CNST_TABLE_REF(((long) 1));
	   arg1620_954 = CNST_TABLE_REF(((long) 28));
	   arg1621_955 = CNST_TABLE_REF(((long) 3));
	   arg1623_956 = CNST_TABLE_REF(((long) 29));
	   {
	      obj_t list1625_958;
	      {
		 obj_t arg1626_959;
		 {
		    obj_t arg1627_960;
		    {
		       obj_t arg1628_961;
		       {
			  obj_t aux_2273;
			  aux_2273 = CNST_TABLE_REF(((long) 5));
			  arg1628_961 = MAKE_PAIR(aux_2273, BNIL);
		       }
		       arg1627_960 = MAKE_PAIR(arg1623_956, arg1628_961);
		    }
		    arg1626_959 = MAKE_PAIR(arg1621_955, arg1627_960);
		 }
		 list1625_958 = MAKE_PAIR(arg1620_954, arg1626_959);
	      }
	      install_specialize__168_cfa_specialize(arg1618_952, arg1619_953, list1625_958);
	   }
	}
	{
	   obj_t arg1632_963;
	   obj_t arg1634_964;
	   obj_t arg1637_965;
	   obj_t arg1638_966;
	   obj_t arg1641_967;
	   arg1632_963 = CNST_TABLE_REF(((long) 30));
	   arg1634_964 = CNST_TABLE_REF(((long) 1));
	   arg1637_965 = CNST_TABLE_REF(((long) 31));
	   arg1638_966 = CNST_TABLE_REF(((long) 3));
	   arg1641_967 = CNST_TABLE_REF(((long) 32));
	   {
	      obj_t list1643_969;
	      {
		 obj_t arg1644_970;
		 {
		    obj_t arg1645_971;
		    {
		       obj_t arg1646_972;
		       {
			  obj_t aux_2285;
			  aux_2285 = CNST_TABLE_REF(((long) 5));
			  arg1646_972 = MAKE_PAIR(aux_2285, BNIL);
		       }
		       arg1645_971 = MAKE_PAIR(arg1641_967, arg1646_972);
		    }
		    arg1644_970 = MAKE_PAIR(arg1638_966, arg1645_971);
		 }
		 list1643_969 = MAKE_PAIR(arg1637_965, arg1644_970);
	      }
	      install_specialize__168_cfa_specialize(arg1632_963, arg1634_964, list1643_969);
	   }
	}
	{
	   obj_t arg1648_974;
	   obj_t arg1650_975;
	   obj_t arg1651_976;
	   obj_t arg1652_977;
	   obj_t arg1653_978;
	   arg1648_974 = CNST_TABLE_REF(((long) 33));
	   arg1650_975 = CNST_TABLE_REF(((long) 1));
	   arg1651_976 = CNST_TABLE_REF(((long) 34));
	   arg1652_977 = CNST_TABLE_REF(((long) 3));
	   arg1653_978 = CNST_TABLE_REF(((long) 35));
	   {
	      obj_t list1655_980;
	      {
		 obj_t arg1656_981;
		 {
		    obj_t arg1657_982;
		    {
		       obj_t arg1659_983;
		       {
			  obj_t aux_2297;
			  aux_2297 = CNST_TABLE_REF(((long) 5));
			  arg1659_983 = MAKE_PAIR(aux_2297, BNIL);
		       }
		       arg1657_982 = MAKE_PAIR(arg1653_978, arg1659_983);
		    }
		    arg1656_981 = MAKE_PAIR(arg1652_977, arg1657_982);
		 }
		 list1655_980 = MAKE_PAIR(arg1651_976, arg1656_981);
	      }
	      install_specialize__168_cfa_specialize(arg1648_974, arg1650_975, list1655_980);
	   }
	}
	{
	   obj_t arg1663_985;
	   obj_t arg1664_986;
	   obj_t arg1665_987;
	   arg1663_985 = CNST_TABLE_REF(((long) 36));
	   arg1664_986 = CNST_TABLE_REF(((long) 1));
	   arg1665_987 = CNST_TABLE_REF(((long) 37));
	   {
	      obj_t list1668_989;
	      {
		 obj_t arg1669_990;
		 {
		    obj_t aux_2307;
		    aux_2307 = CNST_TABLE_REF(((long) 5));
		    arg1669_990 = MAKE_PAIR(aux_2307, BNIL);
		 }
		 list1668_989 = MAKE_PAIR(arg1665_987, arg1669_990);
	      }
	      install_specialize__168_cfa_specialize(arg1663_985, arg1664_986, list1668_989);
	   }
	}
	{
	   obj_t arg1673_992;
	   obj_t arg1674_993;
	   obj_t arg1677_994;
	   obj_t arg1678_995;
	   obj_t arg1679_996;
	   arg1673_992 = CNST_TABLE_REF(((long) 38));
	   arg1674_993 = CNST_TABLE_REF(((long) 1));
	   arg1677_994 = CNST_TABLE_REF(((long) 39));
	   arg1678_995 = CNST_TABLE_REF(((long) 3));
	   arg1679_996 = CNST_TABLE_REF(((long) 40));
	   {
	      obj_t list1681_998;
	      {
		 obj_t arg1682_999;
		 {
		    obj_t arg1684_1000;
		    {
		       obj_t arg1686_1001;
		       {
			  obj_t aux_2317;
			  aux_2317 = CNST_TABLE_REF(((long) 5));
			  arg1686_1001 = MAKE_PAIR(aux_2317, BNIL);
		       }
		       arg1684_1000 = MAKE_PAIR(arg1679_996, arg1686_1001);
		    }
		    arg1682_999 = MAKE_PAIR(arg1678_995, arg1684_1000);
		 }
		 list1681_998 = MAKE_PAIR(arg1677_994, arg1682_999);
	      }
	      install_specialize__168_cfa_specialize(arg1673_992, arg1674_993, list1681_998);
	   }
	}
	{
	   obj_t arg1688_1003;
	   obj_t arg1689_1004;
	   obj_t arg1690_1005;
	   arg1688_1003 = CNST_TABLE_REF(((long) 41));
	   arg1689_1004 = CNST_TABLE_REF(((long) 1));
	   arg1690_1005 = CNST_TABLE_REF(((long) 42));
	   {
	      obj_t list1692_1007;
	      {
		 obj_t arg1693_1008;
		 {
		    obj_t aux_2327;
		    aux_2327 = CNST_TABLE_REF(((long) 5));
		    arg1693_1008 = MAKE_PAIR(aux_2327, BNIL);
		 }
		 list1692_1007 = MAKE_PAIR(arg1690_1005, arg1693_1008);
	      }
	      install_specialize__168_cfa_specialize(arg1688_1003, arg1689_1004, list1692_1007);
	   }
	}
	{
	   obj_t arg1695_1010;
	   obj_t arg1696_1011;
	   obj_t arg1697_1012;
	   arg1695_1010 = CNST_TABLE_REF(((long) 43));
	   arg1696_1011 = CNST_TABLE_REF(((long) 1));
	   arg1697_1012 = CNST_TABLE_REF(((long) 44));
	   {
	      obj_t list1699_1014;
	      {
		 obj_t arg1701_1015;
		 {
		    obj_t aux_2335;
		    aux_2335 = CNST_TABLE_REF(((long) 5));
		    arg1701_1015 = MAKE_PAIR(aux_2335, BNIL);
		 }
		 list1699_1014 = MAKE_PAIR(arg1697_1012, arg1701_1015);
	      }
	      install_specialize__168_cfa_specialize(arg1695_1010, arg1696_1011, list1699_1014);
	   }
	}
	{
	   obj_t arg1703_1017;
	   obj_t arg1704_1018;
	   obj_t arg1705_1019;
	   arg1703_1017 = CNST_TABLE_REF(((long) 45));
	   arg1704_1018 = CNST_TABLE_REF(((long) 1));
	   arg1705_1019 = CNST_TABLE_REF(((long) 46));
	   {
	      obj_t list1707_1021;
	      {
		 obj_t arg1708_1022;
		 {
		    obj_t aux_2343;
		    aux_2343 = CNST_TABLE_REF(((long) 5));
		    arg1708_1022 = MAKE_PAIR(aux_2343, BNIL);
		 }
		 list1707_1021 = MAKE_PAIR(arg1705_1019, arg1708_1022);
	      }
	      install_specialize__168_cfa_specialize(arg1703_1017, arg1704_1018, list1707_1021);
	   }
	}
	{
	   obj_t arg1710_1024;
	   obj_t arg1711_1025;
	   obj_t arg1712_1026;
	   arg1710_1024 = CNST_TABLE_REF(((long) 47));
	   arg1711_1025 = CNST_TABLE_REF(((long) 1));
	   arg1712_1026 = CNST_TABLE_REF(((long) 48));
	   {
	      obj_t list1715_1028;
	      {
		 obj_t arg1716_1029;
		 {
		    obj_t aux_2351;
		    aux_2351 = CNST_TABLE_REF(((long) 5));
		    arg1716_1029 = MAKE_PAIR(aux_2351, BNIL);
		 }
		 list1715_1028 = MAKE_PAIR(arg1712_1026, arg1716_1029);
	      }
	      install_specialize__168_cfa_specialize(arg1710_1024, arg1711_1025, list1715_1028);
	   }
	}
	{
	   obj_t arg1718_1031;
	   obj_t arg1719_1032;
	   obj_t arg1720_1033;
	   arg1718_1031 = CNST_TABLE_REF(((long) 49));
	   arg1719_1032 = CNST_TABLE_REF(((long) 1));
	   arg1720_1033 = CNST_TABLE_REF(((long) 50));
	   {
	      obj_t list1722_1035;
	      {
		 obj_t arg1724_1036;
		 {
		    obj_t aux_2359;
		    aux_2359 = CNST_TABLE_REF(((long) 5));
		    arg1724_1036 = MAKE_PAIR(aux_2359, BNIL);
		 }
		 list1722_1035 = MAKE_PAIR(arg1720_1033, arg1724_1036);
	      }
	      install_specialize__168_cfa_specialize(arg1718_1031, arg1719_1032, list1722_1035);
	   }
	}
	{
	   obj_t arg1730_1038;
	   obj_t arg1731_1039;
	   obj_t arg1732_1040;
	   arg1730_1038 = CNST_TABLE_REF(((long) 51));
	   arg1731_1039 = CNST_TABLE_REF(((long) 1));
	   arg1732_1040 = CNST_TABLE_REF(((long) 52));
	   {
	      obj_t list1734_1042;
	      {
		 obj_t arg1735_1043;
		 {
		    obj_t aux_2367;
		    aux_2367 = CNST_TABLE_REF(((long) 5));
		    arg1735_1043 = MAKE_PAIR(aux_2367, BNIL);
		 }
		 list1734_1042 = MAKE_PAIR(arg1732_1040, arg1735_1043);
	      }
	      install_specialize__168_cfa_specialize(arg1730_1038, arg1731_1039, list1734_1042);
	   }
	}
	{
	   obj_t arg1737_1045;
	   obj_t arg1738_1046;
	   obj_t arg1740_1047;
	   arg1737_1045 = CNST_TABLE_REF(((long) 53));
	   arg1738_1046 = CNST_TABLE_REF(((long) 1));
	   arg1740_1047 = CNST_TABLE_REF(((long) 54));
	   {
	      obj_t list1742_1049;
	      {
		 obj_t arg1743_1050;
		 {
		    obj_t aux_2375;
		    aux_2375 = CNST_TABLE_REF(((long) 5));
		    arg1743_1050 = MAKE_PAIR(aux_2375, BNIL);
		 }
		 list1742_1049 = MAKE_PAIR(arg1740_1047, arg1743_1050);
	      }
	      install_specialize__168_cfa_specialize(arg1737_1045, arg1738_1046, list1742_1049);
	   }
	}
	{
	   obj_t arg1746_1052;
	   obj_t arg1747_1053;
	   obj_t arg1748_1054;
	   arg1746_1052 = CNST_TABLE_REF(((long) 55));
	   arg1747_1053 = CNST_TABLE_REF(((long) 1));
	   arg1748_1054 = CNST_TABLE_REF(((long) 56));
	   {
	      obj_t list1750_1056;
	      {
		 obj_t arg1751_1057;
		 {
		    obj_t aux_2383;
		    aux_2383 = CNST_TABLE_REF(((long) 5));
		    arg1751_1057 = MAKE_PAIR(aux_2383, BNIL);
		 }
		 list1750_1056 = MAKE_PAIR(arg1748_1054, arg1751_1057);
	      }
	      install_specialize__168_cfa_specialize(arg1746_1052, arg1747_1053, list1750_1056);
	   }
	}
	patch_tree__164_cfa_specialize(globals_6);
	show_specialize_223_cfa_specialize();
	{
	   bool_t aux_2390;
	   aux_2390 = uninstall_specializes__251_cfa_specialize();
	   BBOOL(aux_2390);
	}
     }
   else
     {
	BUNSPEC;
     }
   return globals_6;
}


obj_t 
_specialize__238_cfa_specialize(obj_t env_1922, obj_t globals_1923)
{
   return specialize__184_cfa_specialize(globals_1923);
}


bool_t 
patch_tree__164_cfa_specialize(obj_t globals_7)
{
   {
      obj_t l1320_1059;
      l1320_1059 = globals_7;
    lname1321_1060:
      if (PAIRP(l1320_1059))
	{
	   patch_fun__141_cfa_specialize(CAR(l1320_1059));
	   {
	      obj_t l1320_2398;
	      l1320_2398 = CDR(l1320_1059);
	      l1320_1059 = l1320_2398;
	      goto lname1321_1060;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
patch_fun__141_cfa_specialize(obj_t variable_8)
{
   {
      value_t fun_1064;
      {
	 variable_t obj_1668;
	 obj_1668 = (variable_t) (variable_8);
	 fun_1064 = (((variable_t) CREF(obj_1668))->value);
      }
      {
	 obj_t arg1758_1065;
	 {
	    node_t aux_2402;
	    {
	       obj_t aux_2403;
	       {
		  sfun_t obj_1669;
		  obj_1669 = (sfun_t) (fun_1064);
		  aux_2403 = (((sfun_t) CREF(obj_1669))->body);
	       }
	       aux_2402 = (node_t) (aux_2403);
	    }
	    arg1758_1065 = patch__227_cfa_specialize(aux_2402);
	 }
	 {
	    obj_t res1992_1672;
	    {
	       sfun_t obj_1670;
	       obj_1670 = (sfun_t) (fun_1064);
	       {
		  obj_t x_1937;
		  x_1937 = ((((sfun_t) CREF(obj_1670))->body) = ((obj_t) arg1758_1065), BUNSPEC);
		  res1992_1672 = BUNSPEC;
	       }
	    }
	    return res1992_1672;
	 }
      }
   }
}


obj_t 
patch__default1348_94_cfa_specialize(node_t node_10)
{
   FAILURE(CNST_TABLE_REF(((long) 57)), string2034_cfa_specialize, (obj_t) (node_10));
}


obj_t 
_patch__default1348_12_cfa_specialize(obj_t env_1920, obj_t node_1921)
{
   return patch__default1348_94_cfa_specialize((node_t) (node_1921));
}


obj_t 
patch__227_cfa_specialize(node_t node_9)
{
   {
      obj_t method1895_1457;
      obj_t class1900_1458;
      {
	 obj_t arg1904_1455;
	 obj_t arg1905_1456;
	 {
	    object_t obj_1678;
	    obj_1678 = (object_t) (node_9);
	    {
	       obj_t pre_method_105_1679;
	       pre_method_105_1679 = PROCEDURE_REF(patch__env_129_cfa_specialize, ((long) 2));
	       if (INTEGERP(pre_method_105_1679))
		 {
		    PROCEDURE_SET(patch__env_129_cfa_specialize, ((long) 2), BUNSPEC);
		    arg1904_1455 = pre_method_105_1679;
		 }
	       else
		 {
		    long obj_class_num_177_1684;
		    obj_class_num_177_1684 = TYPE(obj_1678);
		    {
		       obj_t arg1183_1685;
		       arg1183_1685 = PROCEDURE_REF(patch__env_129_cfa_specialize, ((long) 1));
		       {
			  long arg1184_1689;
			  {
			     long arg1186_1690;
			     arg1186_1690 = OBJECT_TYPE;
			     arg1184_1689 = (obj_class_num_177_1684 - arg1186_1690);
			  }
			  arg1904_1455 = VECTOR_REF(arg1183_1685, arg1184_1689);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1695;
	    object_1695 = (object_t) (node_9);
	    {
	       long arg1187_1696;
	       {
		  long arg1188_1697;
		  long arg1189_1698;
		  arg1188_1697 = TYPE(object_1695);
		  arg1189_1698 = OBJECT_TYPE;
		  arg1187_1696 = (arg1188_1697 - arg1189_1698);
	       }
	       {
		  obj_t vector_1702;
		  vector_1702 = __classes__134___object;
		  arg1905_1456 = VECTOR_REF(vector_1702, arg1187_1696);
	       }
	    }
	 }
	 method1895_1457 = arg1904_1455;
	 class1900_1458 = arg1905_1456;
	 {
	    if (INTEGERP(method1895_1457))
	      {
		 switch ((long) CINT(method1895_1457))
		   {
		   case ((long) 0):
		      {
			 atom_t aux_2432;
			 aux_2432 = (atom_t) (node_9);
			 return (obj_t) (aux_2432);
		      }
		      break;
		   case ((long) 1):
		      {
			 kwote_t aux_2435;
			 aux_2435 = (kwote_t) (node_9);
			 return (obj_t) (aux_2435);
		      }
		      break;
		   case ((long) 2):
		      {
			 var_t aux_2438;
			 aux_2438 = (var_t) (node_9);
			 return (obj_t) (aux_2438);
		      }
		      break;
		   case ((long) 3):
		      {
			 obj_t arg1911_1470;
			 {
			    obj_t aux_2441;
			    {
			       closure_t aux_2442;
			       aux_2442 = (closure_t) (node_9);
			       aux_2441 = (obj_t) (aux_2442);
			    }
			    arg1911_1470 = shape_tools_shape(aux_2441);
			 }
			 return internal_error_43_tools_error(string2035_cfa_specialize, string2036_cfa_specialize, arg1911_1470);
		      }
		      break;
		   case ((long) 4):
		      {
			 sequence_t node_1471;
			 node_1471 = (sequence_t) (node_9);
			 patch___72_cfa_specialize((((sequence_t) CREF(node_1471))->nodes));
			 return (obj_t) (node_1471);
		      }
		      break;
		   case ((long) 5):
		      {
			 app_ly_162_t node_1474;
			 node_1474 = (app_ly_162_t) (node_9);
			 {
			    obj_t arg1913_1476;
			    arg1913_1476 = patch__227_cfa_specialize((((app_ly_162_t) CREF(node_1474))->fun));
			    {
			       obj_t res1993_1708;
			       {
				  node_t val1165_1707;
				  val1165_1707 = (node_t) (arg1913_1476);
				  {
				     obj_t x_1938;
				     x_1938 = ((((app_ly_162_t) CREF(node_1474))->fun) = ((node_t) val1165_1707), BUNSPEC);
				     res1993_1708 = BUNSPEC;
				  }
			       }
			       res1993_1708;
			    }
			 }
			 {
			    obj_t arg1915_1478;
			    arg1915_1478 = patch__227_cfa_specialize((((app_ly_162_t) CREF(node_1474))->arg));
			    {
			       obj_t res1994_1712;
			       {
				  node_t val1166_1711;
				  val1166_1711 = (node_t) (arg1915_1478);
				  {
				     obj_t x_1939;
				     x_1939 = ((((app_ly_162_t) CREF(node_1474))->arg) = ((node_t) val1166_1711), BUNSPEC);
				     res1994_1712 = BUNSPEC;
				  }
			       }
			       res1994_1712;
			    }
			 }
			 return (obj_t) (node_1474);
		      }
		      break;
		   case ((long) 6):
		      {
			 funcall_t node_1480;
			 node_1480 = (funcall_t) (node_9);
			 {
			    obj_t arg1917_1482;
			    arg1917_1482 = patch__227_cfa_specialize((((funcall_t) CREF(node_1480))->fun));
			    {
			       obj_t res1995_1716;
			       {
				  node_t val1172_1715;
				  val1172_1715 = (node_t) (arg1917_1482);
				  {
				     obj_t x_1940;
				     x_1940 = ((((funcall_t) CREF(node_1480))->fun) = ((node_t) val1172_1715), BUNSPEC);
				     res1995_1716 = BUNSPEC;
				  }
			       }
			       res1995_1716;
			    }
			 }
			 patch___72_cfa_specialize((((funcall_t) CREF(node_1480))->args));
			 return (obj_t) (node_1480);
		      }
		      break;
		   case ((long) 7):
		      {
			 pragma_t node_1485;
			 node_1485 = (pragma_t) (node_9);
			 patch___72_cfa_specialize((((pragma_t) CREF(node_1485))->args));
			 return (obj_t) (node_1485);
		      }
		      break;
		   case ((long) 8):
		      {
			 cast_t node_1488;
			 node_1488 = (cast_t) (node_9);
			 patch__227_cfa_specialize((((cast_t) CREF(node_1488))->arg));
			 return (obj_t) (node_1488);
		      }
		      break;
		   case ((long) 9):
		      {
			 setq_t node_1491;
			 node_1491 = (setq_t) (node_9);
			 {
			    obj_t arg1925_1493;
			    arg1925_1493 = patch__227_cfa_specialize((((setq_t) CREF(node_1491))->value));
			    {
			       obj_t res1996_1723;
			       {
				  node_t val1194_1722;
				  val1194_1722 = (node_t) (arg1925_1493);
				  {
				     obj_t x_1941;
				     x_1941 = ((((setq_t) CREF(node_1491))->value) = ((node_t) val1194_1722), BUNSPEC);
				     res1996_1723 = BUNSPEC;
				  }
			       }
			       res1996_1723;
			    }
			 }
			 {
			    obj_t arg1927_1495;
			    {
			       node_t aux_2482;
			       {
				  var_t aux_2483;
				  aux_2483 = (((setq_t) CREF(node_1491))->var);
				  aux_2482 = (node_t) (aux_2483);
			       }
			       arg1927_1495 = patch__227_cfa_specialize(aux_2482);
			    }
			    {
			       obj_t res1997_1727;
			       {
				  var_t val1193_1726;
				  val1193_1726 = (var_t) (arg1927_1495);
				  {
				     obj_t x_1942;
				     x_1942 = ((((setq_t) CREF(node_1491))->var) = ((var_t) val1193_1726), BUNSPEC);
				     res1997_1727 = BUNSPEC;
				  }
			       }
			       res1997_1727;
			    }
			 }
			 return (obj_t) (node_1491);
		      }
		      break;
		   case ((long) 10):
		      {
			 conditional_t node_1497;
			 node_1497 = (conditional_t) (node_9);
			 {
			    obj_t arg1929_1499;
			    arg1929_1499 = patch__227_cfa_specialize((((conditional_t) CREF(node_1497))->test));
			    {
			       obj_t res1998_1731;
			       {
				  node_t val1201_1730;
				  val1201_1730 = (node_t) (arg1929_1499);
				  {
				     obj_t x_1943;
				     x_1943 = ((((conditional_t) CREF(node_1497))->test) = ((node_t) val1201_1730), BUNSPEC);
				     res1998_1731 = BUNSPEC;
				  }
			       }
			       res1998_1731;
			    }
			 }
			 {
			    obj_t arg1932_1501;
			    arg1932_1501 = patch__227_cfa_specialize((((conditional_t) CREF(node_1497))->true));
			    {
			       obj_t res1999_1735;
			       {
				  node_t val1202_1734;
				  val1202_1734 = (node_t) (arg1932_1501);
				  {
				     obj_t x_1944;
				     x_1944 = ((((conditional_t) CREF(node_1497))->true) = ((node_t) val1202_1734), BUNSPEC);
				     res1999_1735 = BUNSPEC;
				  }
			       }
			       res1999_1735;
			    }
			 }
			 {
			    obj_t arg1935_1503;
			    arg1935_1503 = patch__227_cfa_specialize((((conditional_t) CREF(node_1497))->false));
			    {
			       obj_t res2000_1739;
			       {
				  node_t val1203_1738;
				  val1203_1738 = (node_t) (arg1935_1503);
				  {
				     obj_t x_1945;
				     x_1945 = ((((conditional_t) CREF(node_1497))->false) = ((node_t) val1203_1738), BUNSPEC);
				     res2000_1739 = BUNSPEC;
				  }
			       }
			       res2000_1739;
			    }
			 }
			 return (obj_t) (node_1497);
		      }
		      break;
		   case ((long) 11):
		      {
			 fail_t node_1505;
			 node_1505 = (fail_t) (node_9);
			 {
			    obj_t arg1937_1507;
			    arg1937_1507 = patch__227_cfa_specialize((((fail_t) CREF(node_1505))->proc));
			    {
			       obj_t res2001_1743;
			       {
				  node_t val1209_1742;
				  val1209_1742 = (node_t) (arg1937_1507);
				  {
				     obj_t x_1946;
				     x_1946 = ((((fail_t) CREF(node_1505))->proc) = ((node_t) val1209_1742), BUNSPEC);
				     res2001_1743 = BUNSPEC;
				  }
			       }
			       res2001_1743;
			    }
			 }
			 {
			    obj_t arg1939_1509;
			    arg1939_1509 = patch__227_cfa_specialize((((fail_t) CREF(node_1505))->msg));
			    {
			       obj_t res2002_1747;
			       {
				  node_t val1210_1746;
				  val1210_1746 = (node_t) (arg1939_1509);
				  {
				     obj_t x_1947;
				     x_1947 = ((((fail_t) CREF(node_1505))->msg) = ((node_t) val1210_1746), BUNSPEC);
				     res2002_1747 = BUNSPEC;
				  }
			       }
			       res2002_1747;
			    }
			 }
			 {
			    obj_t arg1941_1511;
			    arg1941_1511 = patch__227_cfa_specialize((((fail_t) CREF(node_1505))->obj));
			    {
			       obj_t res2003_1751;
			       {
				  node_t val1211_1750;
				  val1211_1750 = (node_t) (arg1941_1511);
				  {
				     obj_t x_1948;
				     x_1948 = ((((fail_t) CREF(node_1505))->obj) = ((node_t) val1211_1750), BUNSPEC);
				     res2003_1751 = BUNSPEC;
				  }
			       }
			       res2003_1751;
			    }
			 }
			 return (obj_t) (node_1505);
		      }
		      break;
		   case ((long) 12):
		      {
			 select_t node_1513;
			 node_1513 = (select_t) (node_9);
			 {
			    obj_t arg1943_1515;
			    arg1943_1515 = patch__227_cfa_specialize((((select_t) CREF(node_1513))->test));
			    {
			       obj_t res2004_1755;
			       {
				  node_t val1218_1754;
				  val1218_1754 = (node_t) (arg1943_1515);
				  {
				     obj_t x_1949;
				     x_1949 = ((((select_t) CREF(node_1513))->test) = ((node_t) val1218_1754), BUNSPEC);
				     res2004_1755 = BUNSPEC;
				  }
			       }
			       res2004_1755;
			    }
			 }
			 {
			    obj_t l1331_1517;
			    l1331_1517 = (((select_t) CREF(node_1513))->clauses);
			  lname1333_1518:
			    if (PAIRP(l1331_1517))
			      {
				 {
				    obj_t clause_1521;
				    clause_1521 = CAR(l1331_1517);
				    {
				       obj_t arg1947_1522;
				       {
					  node_t aux_2526;
					  {
					     obj_t aux_2527;
					     aux_2527 = CDR(clause_1521);
					     aux_2526 = (node_t) (aux_2527);
					  }
					  arg1947_1522 = patch__227_cfa_specialize(aux_2526);
				       }
				       SET_CDR(clause_1521, arg1947_1522);
				    }
				 }
				 {
				    obj_t l1331_2532;
				    l1331_2532 = CDR(l1331_1517);
				    l1331_1517 = l1331_2532;
				    goto lname1333_1518;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 return (obj_t) (node_1513);
		      }
		      break;
		   case ((long) 13):
		      {
			 let_fun_218_t node_1525;
			 node_1525 = (let_fun_218_t) (node_9);
			 {
			    obj_t l1335_1527;
			    l1335_1527 = (((let_fun_218_t) CREF(node_1525))->locals);
			  lname1336_1528:
			    if (PAIRP(l1335_1527))
			      {
				 patch_fun__141_cfa_specialize(CAR(l1335_1527));
				 {
				    obj_t l1335_2541;
				    l1335_2541 = CDR(l1335_1527);
				    l1335_1527 = l1335_2541;
				    goto lname1336_1528;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    obj_t arg1954_1533;
			    arg1954_1533 = patch__227_cfa_specialize((((let_fun_218_t) CREF(node_1525))->body));
			    {
			       obj_t res2005_1770;
			       {
				  node_t val1226_1769;
				  val1226_1769 = (node_t) (arg1954_1533);
				  {
				     obj_t x_1950;
				     x_1950 = ((((let_fun_218_t) CREF(node_1525))->body) = ((node_t) val1226_1769), BUNSPEC);
				     res2005_1770 = BUNSPEC;
				  }
			       }
			       res2005_1770;
			    }
			 }
			 return (obj_t) (node_1525);
		      }
		      break;
		   case ((long) 14):
		      {
			 let_var_6_t node_1535;
			 node_1535 = (let_var_6_t) (node_9);
			 {
			    obj_t l1338_1537;
			    l1338_1537 = (((let_var_6_t) CREF(node_1535))->bindings);
			  lname1340_1538:
			    if (PAIRP(l1338_1537))
			      {
				 {
				    obj_t binding_1541;
				    binding_1541 = CAR(l1338_1537);
				    {
				       obj_t arg1960_1543;
				       {
					  node_t aux_2553;
					  {
					     obj_t aux_2554;
					     aux_2554 = CDR(binding_1541);
					     aux_2553 = (node_t) (aux_2554);
					  }
					  arg1960_1543 = patch__227_cfa_specialize(aux_2553);
				       }
				       SET_CDR(binding_1541, arg1960_1543);
				    }
				 }
				 {
				    obj_t l1338_2559;
				    l1338_2559 = CDR(l1338_1537);
				    l1338_1537 = l1338_2559;
				    goto lname1340_1538;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    obj_t arg1964_1545;
			    arg1964_1545 = patch__227_cfa_specialize((((let_var_6_t) CREF(node_1535))->body));
			    {
			       obj_t res2006_1781;
			       {
				  node_t val1234_1780;
				  val1234_1780 = (node_t) (arg1964_1545);
				  {
				     obj_t x_1951;
				     x_1951 = ((((let_var_6_t) CREF(node_1535))->body) = ((node_t) val1234_1780), BUNSPEC);
				     res2006_1781 = BUNSPEC;
				  }
			       }
			       res2006_1781;
			    }
			 }
			 return (obj_t) (node_1535);
		      }
		      break;
		   case ((long) 15):
		      {
			 set_ex_it_116_t node_1547;
			 node_1547 = (set_ex_it_116_t) (node_9);
			 {
			    obj_t arg1966_1549;
			    arg1966_1549 = patch__227_cfa_specialize((((set_ex_it_116_t) CREF(node_1547))->body));
			    {
			       obj_t res2007_1785;
			       {
				  node_t val1242_1784;
				  val1242_1784 = (node_t) (arg1966_1549);
				  {
				     obj_t x_1952;
				     x_1952 = ((((set_ex_it_116_t) CREF(node_1547))->body) = ((node_t) val1242_1784), BUNSPEC);
				     res2007_1785 = BUNSPEC;
				  }
			       }
			       res2007_1785;
			    }
			 }
			 {
			    node_t aux_2572;
			    {
			       var_t aux_2573;
			       aux_2573 = (((set_ex_it_116_t) CREF(node_1547))->var);
			       aux_2572 = (node_t) (aux_2573);
			    }
			    patch__227_cfa_specialize(aux_2572);
			 }
			 return (obj_t) (node_1547);
		      }
		      break;
		   case ((long) 16):
		      {
			 jump_ex_it_184_t node_1552;
			 node_1552 = (jump_ex_it_184_t) (node_9);
			 {
			    obj_t arg1969_1554;
			    arg1969_1554 = patch__227_cfa_specialize((((jump_ex_it_184_t) CREF(node_1552))->exit));
			    {
			       obj_t res2008_1790;
			       {
				  node_t val1248_1789;
				  val1248_1789 = (node_t) (arg1969_1554);
				  {
				     obj_t x_1953;
				     x_1953 = ((((jump_ex_it_184_t) CREF(node_1552))->exit) = ((node_t) val1248_1789), BUNSPEC);
				     res2008_1790 = BUNSPEC;
				  }
			       }
			       res2008_1790;
			    }
			 }
			 {
			    obj_t arg1971_1556;
			    arg1971_1556 = patch__227_cfa_specialize((((jump_ex_it_184_t) CREF(node_1552))->value));
			    {
			       obj_t res2009_1794;
			       {
				  node_t val1249_1793;
				  val1249_1793 = (node_t) (arg1971_1556);
				  {
				     obj_t x_1954;
				     x_1954 = ((((jump_ex_it_184_t) CREF(node_1552))->value) = ((node_t) val1249_1793), BUNSPEC);
				     res2009_1794 = BUNSPEC;
				  }
			       }
			       res2009_1794;
			    }
			 }
			 return (obj_t) (node_1552);
		      }
		      break;
		   case ((long) 17):
		      {
			 make_box_202_t node_1558;
			 node_1558 = (make_box_202_t) (node_9);
			 {
			    obj_t arg1973_1560;
			    arg1973_1560 = patch__227_cfa_specialize((((make_box_202_t) CREF(node_1558))->value));
			    {
			       obj_t res2010_1798;
			       {
				  node_t val1256_1797;
				  val1256_1797 = (node_t) (arg1973_1560);
				  {
				     obj_t x_1955;
				     x_1955 = ((((make_box_202_t) CREF(node_1558))->value) = ((node_t) val1256_1797), BUNSPEC);
				     res2010_1798 = BUNSPEC;
				  }
			       }
			       res2010_1798;
			    }
			 }
			 return (obj_t) (node_1558);
		      }
		      break;
		   case ((long) 18):
		      {
			 box_set__221_t node_1562;
			 node_1562 = (box_set__221_t) (node_9);
			 {
			    obj_t arg1975_1564;
			    {
			       node_t aux_2595;
			       {
				  var_t aux_2596;
				  aux_2596 = (((box_set__221_t) CREF(node_1562))->var);
				  aux_2595 = (node_t) (aux_2596);
			       }
			       arg1975_1564 = patch__227_cfa_specialize(aux_2595);
			    }
			    {
			       obj_t res2011_1802;
			       {
				  var_t val1269_1801;
				  val1269_1801 = (var_t) (arg1975_1564);
				  {
				     obj_t x_1956;
				     x_1956 = ((((box_set__221_t) CREF(node_1562))->var) = ((var_t) val1269_1801), BUNSPEC);
				     res2011_1802 = BUNSPEC;
				  }
			       }
			       res2011_1802;
			    }
			 }
			 {
			    obj_t arg1977_1566;
			    arg1977_1566 = patch__227_cfa_specialize((((box_set__221_t) CREF(node_1562))->value));
			    {
			       obj_t res2012_1806;
			       {
				  node_t val1270_1805;
				  val1270_1805 = (node_t) (arg1977_1566);
				  {
				     obj_t x_1957;
				     x_1957 = ((((box_set__221_t) CREF(node_1562))->value) = ((node_t) val1270_1805), BUNSPEC);
				     res2012_1806 = BUNSPEC;
				  }
			       }
			       res2012_1806;
			    }
			 }
			 return (obj_t) (node_1562);
		      }
		      break;
		   case ((long) 19):
		      {
			 box_ref_242_t node_1568;
			 node_1568 = (box_ref_242_t) (node_9);
			 {
			    obj_t arg1979_1570;
			    {
			       node_t aux_2608;
			       {
				  var_t aux_2609;
				  aux_2609 = (((box_ref_242_t) CREF(node_1568))->var);
				  aux_2608 = (node_t) (aux_2609);
			       }
			       arg1979_1570 = patch__227_cfa_specialize(aux_2608);
			    }
			    {
			       obj_t res2013_1810;
			       {
				  var_t val1263_1809;
				  val1263_1809 = (var_t) (arg1979_1570);
				  {
				     obj_t x_1958;
				     x_1958 = ((((box_ref_242_t) CREF(node_1568))->var) = ((var_t) val1263_1809), BUNSPEC);
				     res2013_1810 = BUNSPEC;
				  }
			       }
			       res2013_1810;
			    }
			 }
			 return (obj_t) (node_1568);
		      }
		      break;
		   case ((long) 20):
		      {
			 app_t node_1572;
			 node_1572 = (app_t) (node_9);
			 patch___72_cfa_specialize((((app_t) CREF(node_1572))->args));
			 {
			    obj_t arg1982_1575;
			    {
			       node_t aux_2619;
			       {
				  var_t aux_2620;
				  aux_2620 = (((app_t) CREF(node_1572))->fun);
				  aux_2619 = (node_t) (aux_2620);
			       }
			       arg1982_1575 = patch__227_cfa_specialize(aux_2619);
			    }
			    {
			       obj_t res2014_1815;
			       {
				  var_t val1157_1814;
				  val1157_1814 = (var_t) (arg1982_1575);
				  {
				     obj_t x_1959;
				     x_1959 = ((((app_t) CREF(node_1572))->fun) = ((var_t) val1157_1814), BUNSPEC);
				     res2014_1815 = BUNSPEC;
				  }
			       }
			       res2014_1815;
			    }
			 }
			 {
			    bool_t test_2626;
			    {
			       obj_t aux_2627;
			       {
				  variable_t aux_2628;
				  {
				     var_t arg1985_1579;
				     arg1985_1579 = (((app_t) CREF(node_1572))->fun);
				     aux_2628 = (((var_t) CREF(arg1985_1579))->variable);
				  }
				  aux_2627 = (obj_t) (aux_2628);
			       }
			       test_2626 = is_a__118___object(aux_2627, specialized_global_131_cfa_specialize);
			    }
			    if (test_2626)
			      {
				 node_t aux_2633;
				 aux_2633 = specialize_app__163_cfa_specialize(node_1572);
				 return (obj_t) (aux_2633);
			      }
			    else
			      {
				 return (obj_t) (node_1572);
			      }
			 }
		      }
		      break;
		   default:
		    case_else1901_181_1461:
		      if (PROCEDUREP(method1895_1457))
			{
			   return PROCEDURE_ENTRY(method1895_1457) (method1895_1457, (obj_t) (node_9), BEOA);
			}
		      else
			{
			   obj_t fun1763_1069;
			   fun1763_1069 = PROCEDURE_REF(patch__env_129_cfa_specialize, ((long) 0));
			   return PROCEDURE_ENTRY(fun1763_1069) (fun1763_1069, (obj_t) (node_9), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1901_181_1461;
	      }
	 }
      }
   }
}


obj_t 
_patch__77_cfa_specialize(obj_t env_1918, obj_t node_1919)
{
   return patch__227_cfa_specialize((node_t) (node_1919));
}


obj_t 
patch___72_cfa_specialize(obj_t node__221_31)
{
   {
      obj_t node__221_1070;
      node__221_1070 = node__221_31;
    loop_1071:
      if (NULLP(node__221_1070))
	{
	   return CNST_TABLE_REF(((long) 58));
	}
      else
	{
	   {
	      obj_t arg1766_1073;
	      {
		 node_t aux_2653;
		 {
		    obj_t aux_2654;
		    aux_2654 = CAR(node__221_1070);
		    aux_2653 = (node_t) (aux_2654);
		 }
		 arg1766_1073 = patch__227_cfa_specialize(aux_2653);
	      }
	      SET_CAR(node__221_1070, arg1766_1073);
	   }
	   {
	      obj_t node__221_2659;
	      node__221_2659 = CDR(node__221_1070);
	      node__221_1070 = node__221_2659;
	      goto loop_1071;
	   }
	}
   }
}


node_t 
specialize_app__163_cfa_specialize(app_t node_33)
{
   {
      bool_t test_2661;
      {
	 obj_t aux_2662;
	 aux_2662 = (((app_t) CREF(node_33))->args);
	 test_2661 = NULLP(aux_2662);
      }
      if (test_2661)
	{
	   return (node_t) (node_33);
	}
      else
	{
	   type_t type_1078;
	   {
	      node_t aux_2666;
	      {
		 obj_t aux_2667;
		 {
		    obj_t aux_2668;
		    aux_2668 = (((app_t) CREF(node_33))->args);
		    aux_2667 = CAR(aux_2668);
		 }
		 aux_2666 = (node_t) (aux_2667);
	      }
	      type_1078 = typeof_coerce_typeof(aux_2666);
	   }
	   {
	      obj_t spec_1080;
	      {
		 obj_t aux_2673;
		 {
		    specialized_global_131_t obj_1832;
		    {
		       variable_t aux_2675;
		       {
			  var_t arg1783_1094;
			  arg1783_1094 = (((app_t) CREF(node_33))->fun);
			  aux_2675 = (((var_t) CREF(arg1783_1094))->variable);
		       }
		       obj_1832 = (specialized_global_131_t) (aux_2675);
		    }
		    {
		       obj_t aux_2679;
		       {
			  object_t aux_2680;
			  aux_2680 = (object_t) (obj_1832);
			  aux_2679 = OBJECT_WIDENING(aux_2680);
		       }
		       aux_2673 = (((specialized_global_131_t) CREF(aux_2679))->fix);
		    }
		 }
		 spec_1080 = assq___r4_pairs_and_lists_6_3((obj_t) (type_1078), aux_2673);
	      }
	      {
		 if (PAIRP(spec_1080))
		   {
		      obj_t args_1082;
		      {
			 app_t aux_2687;
			 {
			    obj_t aux_2711;
			    aux_2711 = (((app_t) CREF(node_33))->args);
			    args_1082 = CDR(aux_2711);
			 }
		       loop_1083:
			 if (NULLP(args_1082))
			   {
			      add_specialized_type__70_cfa_specialize(type_1078);
			      {
				 var_t arg1775_1087;
				 arg1775_1087 = (((app_t) CREF(node_33))->fun);
				 {
				    obj_t res2016_1841;
				    {
				       variable_t val1133_1840;
				       {
					  obj_t aux_2692;
					  aux_2692 = CDR(spec_1080);
					  val1133_1840 = (variable_t) (aux_2692);
				       }
				       {
					  obj_t x_1960;
					  x_1960 = ((((var_t) CREF(arg1775_1087))->variable) = ((variable_t) val1133_1840), BUNSPEC);
					  res2016_1841 = BUNSPEC;
				       }
				    }
				    res2016_1841;
				 }
			      }
			      {
				 obj_t res2017_1844;
				 {
				    node_t obj_1842;
				    obj_1842 = (node_t) (node_33);
				    {
				       obj_t x_1961;
				       x_1961 = ((((node_t) CREF(obj_1842))->type) = ((type_t) type_1078), BUNSPEC);
				       res2017_1844 = BUNSPEC;
				    }
				 }
				 res2017_1844;
			      }
			      aux_2687 = node_33;
			   }
			 else
			   {
			      bool_t test1777_1089;
			      {
				 type_t arg1779_1091;
				 {
				    node_t aux_2698;
				    {
				       obj_t aux_2699;
				       aux_2699 = CAR(args_1082);
				       aux_2698 = (node_t) (aux_2699);
				    }
				    arg1779_1091 = typeof_coerce_typeof(aux_2698);
				 }
				 {
				    obj_t aux_2705;
				    obj_t aux_2703;
				    aux_2705 = (obj_t) (type_1078);
				    aux_2703 = (obj_t) (arg1779_1091);
				    test1777_1089 = (aux_2703 == aux_2705);
				 }
			      }
			      if (test1777_1089)
				{
				   {
				      obj_t args_2709;
				      args_2709 = CDR(args_1082);
				      args_1082 = args_2709;
				      goto loop_1083;
				   }
				}
			      else
				{
				   aux_2687 = node_33;
				}
			   }
			 return (node_t) (aux_2687);
		      }
		   }
		 else
		   {
		      return (node_t) (node_33);
		   }
	      }
	   }
	}
   }
}


obj_t 
object_init_111_cfa_specialize()
{
   {
      obj_t arg1789_1099;
      arg1789_1099 = global_ast_var;
      specialized_global_131_cfa_specialize = add_class__117___object(CNST_TABLE_REF(((long) 59)), arg1789_1099, allocate_specialized_global_env_23_cfa_specialize, ((long) 39310), BUNSPEC);
   }
   {
      obj_t object__struct_specialized_global_35_1928;
      object__struct_specialized_global_35_1928 = proc2037_cfa_specialize;
      add_method__1___object(object__struct_env_210___object, specialized_global_131_cfa_specialize, object__struct_specialized_global_35_1928);
   }
   {
      obj_t struct_object__object_specialized_global_181_1924;
      struct_object__object_specialized_global_181_1924 = proc2038_cfa_specialize;
      return add_method__1___object(struct_object__object_env_209___object, specialized_global_131_cfa_specialize, struct_object__object_specialized_global_181_1924);
   }
}


obj_t 
struct_object__object_specialized_global2022_107_cfa_specialize(obj_t env_1931, obj_t o_1932, obj_t s_1933)
{
   {
      specialized_global_131_t o_1115;
      obj_t s_1116;
      {
	 specialized_global_131_t aux_2720;
	 o_1115 = (specialized_global_131_t) (o_1932);
	 s_1116 = s_1933;
	 {
	    {
	       obj_t old1309_1119;
	       obj_t aux1310_1120;
	       {
		  obj_t next_method1383_60_1125;
		  next_method1383_60_1125 = find_super_class_method_167___object((object_t) (o_1115), struct_object__object_env_209___object, specialized_global_131_cfa_specialize);
		  if (PROCEDUREP(next_method1383_60_1125))
		    {
		       old1309_1119 = PROCEDURE_ENTRY(next_method1383_60_1125) (next_method1383_60_1125, (obj_t) (o_1115), s_1116, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1383_60_1125);
		       {
			  object_t aux_2729;
			  aux_2729 = struct_object__object_93___object((object_t) (o_1115), s_1116);
			  old1309_1119 = (obj_t) (aux_2729);
		       }
		    }
	       }
	       aux1310_1120 = STRUCT_REF(s_1116, ((long) 0));
	       {
		  specialized_global_131_t new1311_1121;
		  new1311_1121 = ((specialized_global_131_t) (old1309_1119));
		  {
		     long arg1802_1122;
		     arg1802_1122 = class_num_218___object(specialized_global_131_cfa_specialize);
		     {
			obj_t obj_1868;
			obj_1868 = (obj_t) (new1311_1121);
			(((obj_t) CREF(obj_1868))->header = MAKE_HEADER(arg1802_1122, 0), BUNSPEC);
		     }
		  }
		  {
		     specialized_global_131_t arg1804_1123;
		     {
			obj_t arg1805_1124;
			arg1805_1124 = STRUCT_REF(aux1310_1120, ((long) 0));
			{
			   specialized_global_131_t res2018_1875;
			   {
			      specialized_global_131_t new1290_1873;
			      new1290_1873 = ((specialized_global_131_t) BREF(GC_MALLOC(sizeof(struct specialized_global_131))));
			      ((((specialized_global_131_t) CREF(new1290_1873))->fix) = ((obj_t) arg1805_1124), BUNSPEC);
			      res2018_1875 = new1290_1873;
			   }
			   arg1804_1123 = res2018_1875;
			}
		     }
		     {
			obj_t aux_2743;
			object_t aux_2741;
			aux_2743 = (obj_t) (arg1804_1123);
			aux_2741 = (object_t) (new1311_1121);
			OBJECT_WIDENING_SET(aux_2741, aux_2743);
		     }
		  }
		  aux_2720 = new1311_1121;
	       }
	    }
	 }
	 return (obj_t) (aux_2720);
      }
   }
}


obj_t 
object__struct_specialized_global2023_109_cfa_specialize(obj_t env_1934, obj_t obj1306_1935)
{
   {
      specialized_global_131_t obj1306_1102;
      obj1306_1102 = (specialized_global_131_t) (obj1306_1935);
      {
	 {
	    obj_t res1307_1105;
	    {
	       obj_t next_method1382_66_1113;
	       next_method1382_66_1113 = find_super_class_method_167___object((object_t) (obj1306_1102), object__struct_env_210___object, specialized_global_131_cfa_specialize);
	       if (PROCEDUREP(next_method1382_66_1113))
		 {
		    res1307_1105 = PROCEDURE_ENTRY(next_method1382_66_1113) (next_method1382_66_1113, (obj_t) (obj1306_1102), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1382_66_1113);
		    res1307_1105 = object__struct_50___object((object_t) (obj1306_1102));
		 }
	    }
	    {
	       obj_t aux1308_1106;
	       {
		  obj_t aux_2758;
		  aux_2758 = CNST_TABLE_REF(((long) 59));
		  aux1308_1106 = make_struct(aux_2758, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_2761;
		  {
		     obj_t aux_2762;
		     {
			object_t aux_2763;
			aux_2763 = (object_t) (obj1306_1102);
			aux_2762 = OBJECT_WIDENING(aux_2763);
		     }
		     aux_2761 = (((specialized_global_131_t) CREF(aux_2762))->fix);
		  }
		  STRUCT_SET(aux1308_1106, ((long) 0), aux_2761);
	       }
	       STRUCT_SET(res1307_1105, ((long) 0), aux1308_1106);
	       {
		  obj_t aux_2769;
		  aux_2769 = STRUCT_KEY(res1307_1105);
		  STRUCT_KEY_SET(aux1308_1106, aux_2769);
	       }
	       {
		  obj_t aux_2772;
		  aux_2772 = CNST_TABLE_REF(((long) 59));
		  STRUCT_KEY_SET(res1307_1105, aux_2772);
	       }
	       return res1307_1105;
	    }
	 }
      }
   }
}


global_t 
allocate_specialized_global_107_cfa_specialize()
{
   {
      global_t new1304_1127;
      new1304_1127 = ((global_t) BREF(GC_MALLOC(sizeof(struct global))));
      {
	 long arg1807_1128;
	 arg1807_1128 = class_num_218___object(specialized_global_131_cfa_specialize);
	 {
	    obj_t obj_1878;
	    obj_1878 = (obj_t) (new1304_1127);
	    (((obj_t) CREF(obj_1878))->header = MAKE_HEADER(arg1807_1128, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2780;
	 aux_2780 = (object_t) (new1304_1127);
	 OBJECT_WIDENING_SET(aux_2780, BFALSE);
      }
      return new1304_1127;
   }
}


obj_t 
_allocate_specialized_global_95_cfa_specialize(obj_t env_1936)
{
   {
      global_t aux_2783;
      aux_2783 = allocate_specialized_global_107_cfa_specialize();
      return (obj_t) (aux_2783);
   }
}


obj_t 
imported_modules_init_94_cfa_specialize()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_SPECIALIZE");
   module_initialization_70_engine_param(((long) 0), "CFA_SPECIALIZE");
   module_initialization_70_type_type(((long) 0), "CFA_SPECIALIZE");
   module_initialization_70_type_cache(((long) 0), "CFA_SPECIALIZE");
   module_initialization_70_tools_shape(((long) 0), "CFA_SPECIALIZE");
   module_initialization_70_tools_speek(((long) 0), "CFA_SPECIALIZE");
   module_initialization_70_tools_error(((long) 0), "CFA_SPECIALIZE");
   module_initialization_70_coerce_typeof(((long) 0), "CFA_SPECIALIZE");
   module_initialization_70_ast_var(((long) 0), "CFA_SPECIALIZE");
   module_initialization_70_ast_node(((long) 0), "CFA_SPECIALIZE");
   module_initialization_70_ast_env(((long) 0), "CFA_SPECIALIZE");
   module_initialization_70_inline_inline(((long) 0), "CFA_SPECIALIZE");
   return module_initialization_70_inline_walk(((long) 0), "CFA_SPECIALIZE");
}
