/*===========================================================================*/
/*   (Cfa/stack.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_t;


extern obj_t let_fun_218_ast_node;
static obj_t __statistics__64_cfa_stack = BUNSPEC;
extern obj_t cfa_iterate__222_cfa_iterate(obj_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
extern obj_t closure_ast_node;
extern obj_t _stack_optimization__209_cfa_stack(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t stack_stat_fail_33_cfa_stack(obj_t);
static obj_t imported_modules_init_94_cfa_stack();
extern obj_t module_initialization_70_cfa_stack(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_inline_walk(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t toplevel_init_63_cfa_stack();
static obj_t cnst_init_137_cfa_stack();
static obj_t stack_stat_succeed_138_cfa_stack(obj_t);
extern obj_t _stack___237_cfa_stack(obj_t, obj_t);
extern obj_t _node_heap__stack__85_cfa_stack(obj_t, obj_t, obj_t);
extern obj_t _heap__stack__192_cfa_stack(obj_t, obj_t, obj_t);
extern node_t inline_node_218_inline_inline(node_t, long, obj_t);
static obj_t require_initialization_114_cfa_stack = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cfa_stack();
extern obj_t inline_setup__219_inline_walk(obj_t);
extern obj_t cast_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
static obj_t _stack__default1921_91_cfa_stack(obj_t, obj_t);
static bool_t verb_stat_110_cfa_stack();
extern obj_t pragma_ast_node;
extern long class_num_218___object(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern node_t stack__132_cfa_stack(node_t);
extern obj_t string_downcase__42___r4_strings_6_7(obj_t);
static node_t stack__default1921_128_cfa_stack(node_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t stack___129_cfa_stack(obj_t);
extern obj_t _stack__205_cfa_stack(obj_t, obj_t);
extern obj_t kwote_ast_node;
extern obj_t __inlining___224_engine_param;
extern obj_t set_looser__198_cfa_loose(obj_t);
extern node_t node_heap__stack__239_cfa_stack(app_t, bool_t);
extern obj_t box_ref_242_ast_node;
extern obj_t heap__stack__166_cfa_stack(obj_t, obj_t);
extern obj_t __optim_stack___57_engine_param;
extern bool_t stack_optimization__133_cfa_stack();
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t app_ast_node;
static obj_t __cnst[5];

DEFINE_EXPORT_GENERIC(stack__env_104_cfa_stack, _stack__205_cfa_stack2421, _stack__205_cfa_stack, 0L, 1);
DEFINE_STRING(string2405_cfa_stack, string2405_cfa_stack2422, "Stack optimization! :", 21);
DEFINE_STRING(string2411_cfa_stack, string2411_cfa_stack2423, "DONE STACK!-DEFAULT1921 ALL CFA STACK ", 38);
DEFINE_STRING(string2410_cfa_stack, string2410_cfa_stack2424, "No method for this object", 25);
DEFINE_EXPORT_PROCEDURE(stack___env_10_cfa_stack, _stack___237_cfa_stack2425, _stack___237_cfa_stack, 0L, 1);
DEFINE_EXPORT_PROCEDURE(stack_optimization__env_248_cfa_stack, _stack_optimization__209_cfa_stack2426, _stack_optimization__209_cfa_stack, 0L, 0);
DEFINE_STRING(string2406_cfa_stack, string2406_cfa_stack2427, "--------------------------------------", 38);
DEFINE_EXPORT_PROCEDURE(node_heap__stack__env_251_cfa_stack, _node_heap__stack__85_cfa_stack2428, _node_heap__stack__85_cfa_stack, 0L, 2);
DEFINE_STRING(string2407_cfa_stack, string2407_cfa_stack2429, " (of ", 5);
DEFINE_EXPORT_PROCEDURE(heap__stack__env_242_cfa_stack, _heap__stack__192_cfa_stack2430, _heap__stack__192_cfa_stack, 0L, 2);
DEFINE_STATIC_PROCEDURE(stack__default1921_env_80_cfa_stack, _stack__default1921_91_cfa_stack2431, _stack__default1921_91_cfa_stack, 0L, 1);
DEFINE_STRING(string2404_cfa_stack, string2404_cfa_stack2432, "   . Heap -> Stack", 18);
DEFINE_STRING(string2409_cfa_stack, string2409_cfa_stack2433, "       ", 7);
DEFINE_STRING(string2408_cfa_stack, string2408_cfa_stack2434, ": ", 2);

obj_t 
module_initialization_70_cfa_stack(long checksum_3638, char *from_3639)
{
   if (CBOOL(require_initialization_114_cfa_stack))
     {
	require_initialization_114_cfa_stack = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_stack();
	cnst_init_137_cfa_stack();
	imported_modules_init_94_cfa_stack();
	toplevel_init_63_cfa_stack();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_stack()
{
   module_initialization_70___object(((long) 0), "CFA_STACK");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_STACK");
   module_initialization_70___reader(((long) 0), "CFA_STACK");
   module_initialization_70___r4_strings_6_7(((long) 0), "CFA_STACK");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_stack()
{
   {
      obj_t cnst_port_138_3630;
      cnst_port_138_3630 = open_input_string(string2411_cfa_stack);
      {
	 long i_3631;
	 i_3631 = ((long) 4);
       loop_3632:
	 {
	    bool_t test2412_3633;
	    test2412_3633 = (i_3631 == ((long) -1));
	    if (test2412_3633)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2417_3634;
		    {
		       obj_t list2418_3635;
		       {
			  obj_t arg2419_3636;
			  arg2419_3636 = BNIL;
			  list2418_3635 = MAKE_PAIR(cnst_port_138_3630, arg2419_3636);
		       }
		       arg2417_3634 = read___reader(list2418_3635);
		    }
		    CNST_TABLE_SET(i_3631, arg2417_3634);
		 }
		 {
		    int aux_3637;
		    {
		       long aux_3657;
		       aux_3657 = (i_3631 - ((long) 1));
		       aux_3637 = (int) (aux_3657);
		    }
		    {
		       long i_3660;
		       i_3660 = (long) (aux_3637);
		       i_3631 = i_3660;
		       goto loop_3632;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_stack()
{
   __statistics__64_cfa_stack = BNIL;
   add_generic__110___object(stack__env_104_cfa_stack, stack__default1921_env_80_cfa_stack);
   add_inlined_method__244___object(stack__env_104_cfa_stack, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(stack__env_104_cfa_stack, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(stack__env_104_cfa_stack, var_ast_node, ((long) 2));
   add_inlined_method__244___object(stack__env_104_cfa_stack, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(stack__env_104_cfa_stack, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(stack__env_104_cfa_stack, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(stack__env_104_cfa_stack, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(stack__env_104_cfa_stack, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(stack__env_104_cfa_stack, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(stack__env_104_cfa_stack, setq_ast_node, ((long) 9));
   add_inlined_method__244___object(stack__env_104_cfa_stack, conditional_ast_node, ((long) 10));
   add_inlined_method__244___object(stack__env_104_cfa_stack, fail_ast_node, ((long) 11));
   add_inlined_method__244___object(stack__env_104_cfa_stack, select_ast_node, ((long) 12));
   add_inlined_method__244___object(stack__env_104_cfa_stack, let_fun_218_ast_node, ((long) 13));
   add_inlined_method__244___object(stack__env_104_cfa_stack, let_var_6_ast_node, ((long) 14));
   add_inlined_method__244___object(stack__env_104_cfa_stack, set_ex_it_116_ast_node, ((long) 15));
   add_inlined_method__244___object(stack__env_104_cfa_stack, jump_ex_it_184_ast_node, ((long) 16));
   add_inlined_method__244___object(stack__env_104_cfa_stack, make_box_202_ast_node, ((long) 17));
   add_inlined_method__244___object(stack__env_104_cfa_stack, box_set__221_ast_node, ((long) 18));
   add_inlined_method__244___object(stack__env_104_cfa_stack, box_ref_242_ast_node, ((long) 19));
   {
      long aux_3683;
      aux_3683 = add_inlined_method__244___object(stack__env_104_cfa_stack, app_ast_node, ((long) 20));
      return BINT(aux_3683);
   }
}


bool_t 
stack_optimization__133_cfa_stack()
{
   {
      obj_t _andtest_1887_2011;
      _andtest_1887_2011 = __optim_stack___57_engine_param;
      if (CBOOL(_andtest_1887_2011))
	{
	   return CBOOL(__inlining___224_engine_param);
	}
      else
	{
	   return ((bool_t) 0);
	}
   }
}


obj_t 
_stack_optimization__209_cfa_stack(obj_t env_3596)
{
   {
      bool_t aux_3689;
      aux_3689 = stack_optimization__133_cfa_stack();
      return BBOOL(aux_3689);
   }
}


obj_t 
heap__stack__166_cfa_stack(obj_t roots_1, obj_t globals_2)
{
   if (stack_optimization__133_cfa_stack())
     {
	{
	   obj_t list1944_2013;
	   {
	      obj_t arg1947_2015;
	      {
		 obj_t aux_3694;
		 aux_3694 = BCHAR(((unsigned char) '\n'));
		 arg1947_2015 = MAKE_PAIR(aux_3694, BNIL);
	      }
	      list1944_2013 = MAKE_PAIR(string2404_cfa_stack, arg1947_2015);
	   }
	   verbose_tools_speek(BINT(((long) 1)), list1944_2013);
	}
	set_looser__198_cfa_loose(CNST_TABLE_REF(((long) 0)));
	{
	   bool_t test1950_2018;
	   {
	      obj_t aux_3702;
	      aux_3702 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
	      test1950_2018 = CBOOL(aux_3702);
	   }
	   if (test1950_2018)
	     {
		obj_t list1951_2019;
		{
		   obj_t arg1953_2021;
		   {
		      obj_t arg1954_2022;
		      {
			 obj_t arg1957_2024;
			 {
			    obj_t arg1958_2025;
			    {
			       obj_t aux_3708;
			       aux_3708 = BCHAR(((unsigned char) '\n'));
			       arg1958_2025 = MAKE_PAIR(aux_3708, BNIL);
			    }
			    {
			       obj_t aux_3711;
			       aux_3711 = BCHAR(((unsigned char) '\n'));
			       arg1957_2024 = MAKE_PAIR(aux_3711, arg1958_2025);
			    }
			 }
			 arg1954_2022 = MAKE_PAIR(string2405_cfa_stack, arg1957_2024);
		      }
		      {
			 obj_t aux_3715;
			 aux_3715 = BCHAR(((unsigned char) '\n'));
			 arg1953_2021 = MAKE_PAIR(aux_3715, arg1954_2022);
		      }
		   }
		   list1951_2019 = MAKE_PAIR(string2406_cfa_stack, arg1953_2021);
		}
		print_trace_107_tools_trace(list1951_2019);
	     }
	   else
	     {
		BUNSPEC;
	     }
	}
	cfa_iterate__222_cfa_iterate(roots_1);
	inline_setup__219_inline_walk(CNST_TABLE_REF(((long) 2)));
	{
	   obj_t l1888_2030;
	   l1888_2030 = globals_2;
	 lname1890_2031:
	   if (PAIRP(l1888_2030))
	     {
		{
		   value_t fun_2034;
		   {
		      global_t obj_3000;
		      {
			 obj_t aux_3725;
			 aux_3725 = CAR(l1888_2030);
			 obj_3000 = (global_t) (aux_3725);
		      }
		      fun_2034 = (((global_t) CREF(obj_3000))->value);
		   }
		   {
		      node_t arg1967_2035;
		      {
			 node_t aux_3729;
			 {
			    obj_t aux_3730;
			    {
			       sfun_t obj_3001;
			       obj_3001 = (sfun_t) (fun_2034);
			       aux_3730 = (((sfun_t) CREF(obj_3001))->body);
			    }
			    aux_3729 = (node_t) (aux_3730);
			 }
			 arg1967_2035 = stack__132_cfa_stack(aux_3729);
		      }
		      {
			 obj_t res2377_3004;
			 {
			    sfun_t obj_3002;
			    obj_t val1127_3003;
			    obj_3002 = (sfun_t) (fun_2034);
			    val1127_3003 = (obj_t) (arg1967_2035);
			    {
			       obj_t x_3605;
			       x_3605 = ((((sfun_t) CREF(obj_3002))->body) = ((obj_t) val1127_3003), BUNSPEC);
			       res2377_3004 = BUNSPEC;
			    }
			 }
			 res2377_3004;
		      }
		   }
		}
		{
		   obj_t l1888_3738;
		   l1888_3738 = CDR(l1888_2030);
		   l1888_2030 = l1888_3738;
		   goto lname1890_2031;
		}
	     }
	   else
	     {
		((bool_t) 1);
	     }
	}
	{
	   bool_t test1970_2038;
	   {
	      obj_t aux_3740;
	      aux_3740 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
	      test1970_2038 = CBOOL(aux_3740);
	   }
	   if (test1970_2038)
	     {
		obj_t list1971_2039;
		{
		   obj_t arg1973_2041;
		   {
		      obj_t aux_3746;
		      aux_3746 = BCHAR(((unsigned char) '\n'));
		      arg1973_2041 = MAKE_PAIR(aux_3746, BNIL);
		   }
		   list1971_2039 = MAKE_PAIR(string2406_cfa_stack, arg1973_2041);
		}
		print_trace_107_tools_trace(list1971_2039);
	     }
	   else
	     {
		BUNSPEC;
	     }
	}
	verb_stat_110_cfa_stack();
	return globals_2;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
_heap__stack__192_cfa_stack(obj_t env_3597, obj_t roots_3598, obj_t globals_3599)
{
   return heap__stack__166_cfa_stack(roots_3598, globals_3599);
}


node_t 
node_heap__stack__239_cfa_stack(app_t node_3, bool_t stackable__42_4)
{
   {
      variable_t v_2046;
      {
	 var_t arg1987_2059;
	 arg1987_2059 = (((app_t) CREF(node_3))->fun);
	 v_2046 = (((var_t) CREF(arg1987_2059))->variable);
      }
      {
	 value_t f_2047;
	 f_2047 = (((variable_t) CREF(v_2046))->value);
	 {
	    {
	       bool_t test1977_2048;
	       {
		  obj_t aux_3756;
		  {
		     fun_t obj_3009;
		     obj_3009 = (fun_t) (f_2047);
		     aux_3756 = (((fun_t) CREF(obj_3009))->stack_allocator_172);
		  }
		  test1977_2048 = is_a__118___object(aux_3756, global_ast_var);
	       }
	       if (test1977_2048)
		 {
		    if (stackable__42_4)
		      {
			 stack_stat_succeed_138_cfa_stack((((variable_t) CREF(v_2046))->id));
			 {
			    var_t arg1979_2050;
			    {
			       var_t duplicated1892_2051;
			       duplicated1892_2051 = (((app_t) CREF(node_3))->fun);
			       {
				  obj_t arg1980_2052;
				  type_t arg1981_2053;
				  arg1980_2052 = (((var_t) CREF(duplicated1892_2051))->loc);
				  arg1981_2053 = (((var_t) CREF(duplicated1892_2051))->type);
				  {
				     var_t res2378_3026;
				     {
					variable_t variable_3018;
					{
					   obj_t aux_3767;
					   {
					      fun_t obj_3015;
					      obj_3015 = (fun_t) (f_2047);
					      aux_3767 = (((fun_t) CREF(obj_3015))->stack_allocator_172);
					   }
					   variable_3018 = (variable_t) (aux_3767);
					}
					{
					   var_t new1178_3019;
					   new1178_3019 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
					   {
					      long arg2255_3020;
					      arg2255_3020 = class_num_218___object(var_ast_node);
					      {
						 obj_t obj_3024;
						 obj_3024 = (obj_t) (new1178_3019);
						 (((obj_t) CREF(obj_3024))->header = MAKE_HEADER(arg2255_3020, 0), BUNSPEC);
					      }
					   }
					   {
					      object_t aux_3775;
					      aux_3775 = (object_t) (new1178_3019);
					      OBJECT_WIDENING_SET(aux_3775, BFALSE);
					   }
					   ((((var_t) CREF(new1178_3019))->loc) = ((obj_t) arg1980_2052), BUNSPEC);
					   ((((var_t) CREF(new1178_3019))->type) = ((type_t) arg1981_2053), BUNSPEC);
					   ((((var_t) CREF(new1178_3019))->variable) = ((variable_t) variable_3018), BUNSPEC);
					   res2378_3026 = new1178_3019;
					}
				     }
				     arg1979_2050 = res2378_3026;
				  }
			       }
			    }
			    {
			       obj_t res2379_3029;
			       {
				  obj_t x_3606;
				  x_3606 = ((((app_t) CREF(node_3))->fun) = ((var_t) arg1979_2050), BUNSPEC);
				  res2379_3029 = BUNSPEC;
			       }
			       res2379_3029;
			    }
			 }
			 return inline_node_218_inline_inline((node_t) (node_3), ((long) 1), BNIL);
		      }
		    else
		      {
			 stack_stat_fail_33_cfa_stack((((variable_t) CREF(v_2046))->id));
			 return (node_t) (node_3);
		      }
		 }
	       else
		 {
		    return (node_t) (node_3);
		 }
	    }
	 }
      }
   }
}


obj_t 
_node_heap__stack__85_cfa_stack(obj_t env_3600, obj_t node_3601, obj_t stackable__42_3602)
{
   {
      node_t aux_3788;
      aux_3788 = node_heap__stack__239_cfa_stack((app_t) (node_3601), CBOOL(stackable__42_3602));
      return (obj_t) (aux_3788);
   }
}


obj_t 
stack_stat_succeed_138_cfa_stack(obj_t kind_5)
{
   {
      obj_t cell_2060;
      cell_2060 = assq___r4_pairs_and_lists_6_3(kind_5, __statistics__64_cfa_stack);
      if (PAIRP(cell_2060))
	{
	   obj_t aux_3798;
	   obj_t aux_3796;
	   {
	      long aux_3799;
	      {
		 long aux_3800;
		 {
		    obj_t aux_3801;
		    {
		       obj_t aux_3802;
		       aux_3802 = CDR(cell_2060);
		       aux_3801 = CAR(aux_3802);
		    }
		    aux_3800 = (long) CINT(aux_3801);
		 }
		 aux_3799 = (((long) 1) + aux_3800);
	      }
	      aux_3798 = BINT(aux_3799);
	   }
	   aux_3796 = CDR(cell_2060);
	   return SET_CAR(aux_3796, aux_3798);
	}
      else
	{
	   obj_t arg1995_2066;
	   {
	      obj_t arg1996_2067;
	      {
		 obj_t aux_3811;
		 obj_t aux_3809;
		 aux_3811 = BINT(((long) 0));
		 aux_3809 = BINT(((long) 1));
		 arg1996_2067 = MAKE_PAIR(aux_3809, aux_3811);
	      }
	      arg1995_2066 = MAKE_PAIR(kind_5, arg1996_2067);
	   }
	   {
	      obj_t obj2_3046;
	      obj2_3046 = __statistics__64_cfa_stack;
	      return (__statistics__64_cfa_stack = MAKE_PAIR(arg1995_2066, obj2_3046),
		 BUNSPEC);
	   }
	}
   }
}


obj_t 
stack_stat_fail_33_cfa_stack(obj_t kind_6)
{
   {
      obj_t cell_2068;
      cell_2068 = assq___r4_pairs_and_lists_6_3(kind_6, __statistics__64_cfa_stack);
      if (PAIRP(cell_2068))
	{
	   obj_t aux_3821;
	   obj_t aux_3819;
	   {
	      long aux_3822;
	      {
		 long aux_3823;
		 {
		    obj_t aux_3824;
		    {
		       obj_t aux_3825;
		       aux_3825 = CDR(cell_2068);
		       aux_3824 = CDR(aux_3825);
		    }
		    aux_3823 = (long) CINT(aux_3824);
		 }
		 aux_3822 = (((long) 1) + aux_3823);
	      }
	      aux_3821 = BINT(aux_3822);
	   }
	   aux_3819 = CDR(cell_2068);
	   return SET_CDR(aux_3819, aux_3821);
	}
      else
	{
	   obj_t arg2002_2074;
	   {
	      obj_t arg2003_2075;
	      {
		 obj_t aux_3834;
		 obj_t aux_3832;
		 aux_3834 = BINT(((long) 1));
		 aux_3832 = BINT(((long) 0));
		 arg2003_2075 = MAKE_PAIR(aux_3832, aux_3834);
	      }
	      arg2002_2074 = MAKE_PAIR(kind_6, arg2003_2075);
	   }
	   {
	      obj_t obj2_3062;
	      obj2_3062 = __statistics__64_cfa_stack;
	      return (__statistics__64_cfa_stack = MAKE_PAIR(arg2002_2074, obj2_3062),
		 BUNSPEC);
	   }
	}
   }
}


bool_t 
verb_stat_110_cfa_stack()
{
   {
      obj_t l1893_2076;
      l1893_2076 = __statistics__64_cfa_stack;
    lname1896_2077:
      if (PAIRP(l1893_2076))
	{
	   {
	      obj_t stat_2079;
	      stat_2079 = CAR(l1893_2076);
	      {
		 obj_t arg2007_2082;
		 obj_t arg2009_2084;
		 long arg2013_2086;
		 {
		    obj_t arg2025_2096;
		    {
		       obj_t aux_3842;
		       aux_3842 = CAR(stat_2079);
		       arg2025_2096 = SYMBOL_TO_STRING(aux_3842);
		    }
		    arg2007_2082 = string_downcase__42___r4_strings_6_7(arg2025_2096);
		 }
		 {
		    obj_t aux_3846;
		    aux_3846 = CDR(stat_2079);
		    arg2009_2084 = CAR(aux_3846);
		 }
		 {
		    long aux_3855;
		    long aux_3849;
		    {
		       obj_t aux_3856;
		       {
			  obj_t aux_3857;
			  aux_3857 = CDR(stat_2079);
			  aux_3856 = CDR(aux_3857);
		       }
		       aux_3855 = (long) CINT(aux_3856);
		    }
		    {
		       obj_t aux_3850;
		       {
			  obj_t aux_3851;
			  aux_3851 = CDR(stat_2079);
			  aux_3850 = CAR(aux_3851);
		       }
		       aux_3849 = (long) CINT(aux_3850);
		    }
		    arg2013_2086 = (aux_3849 + aux_3855);
		 }
		 {
		    obj_t list2014_2087;
		    {
		       obj_t arg2015_2088;
		       {
			  obj_t arg2016_2089;
			  {
			     obj_t arg2017_2090;
			     {
				obj_t arg2018_2091;
				{
				   obj_t arg2019_2092;
				   {
				      obj_t arg2020_2093;
				      {
					 obj_t arg2021_2094;
					 {
					    obj_t aux_3862;
					    aux_3862 = BCHAR(((unsigned char) '\n'));
					    arg2021_2094 = MAKE_PAIR(aux_3862, BNIL);
					 }
					 {
					    obj_t aux_3865;
					    aux_3865 = BCHAR(((unsigned char) ')'));
					    arg2020_2093 = MAKE_PAIR(aux_3865, arg2021_2094);
					 }
				      }
				      {
					 obj_t aux_3868;
					 aux_3868 = BINT(arg2013_2086);
					 arg2019_2092 = MAKE_PAIR(aux_3868, arg2020_2093);
				      }
				   }
				   arg2018_2091 = MAKE_PAIR(string2407_cfa_stack, arg2019_2092);
				}
				arg2017_2090 = MAKE_PAIR(arg2009_2084, arg2018_2091);
			     }
			     arg2016_2089 = MAKE_PAIR(string2408_cfa_stack, arg2017_2090);
			  }
			  arg2015_2088 = MAKE_PAIR(arg2007_2082, arg2016_2089);
		       }
		       list2014_2087 = MAKE_PAIR(string2409_cfa_stack, arg2015_2088);
		    }
		    verbose_tools_speek(BINT(((long) 2)), list2014_2087);
		 }
	      }
	   }
	   {
	      obj_t l1893_3878;
	      l1893_3878 = CDR(l1893_2076);
	      l1893_2076 = l1893_3878;
	      goto lname1896_2077;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


node_t 
stack__default1921_128_cfa_stack(node_t node_8)
{
   FAILURE(CNST_TABLE_REF(((long) 3)), string2410_cfa_stack, (obj_t) (node_8));
}


obj_t 
_stack__default1921_91_cfa_stack(obj_t env_3594, obj_t node_3595)
{
   {
      node_t aux_3883;
      aux_3883 = stack__default1921_128_cfa_stack((node_t) (node_3595));
      return (obj_t) (aux_3883);
   }
}


node_t 
stack__132_cfa_stack(node_t node_7)
{
   {
      obj_t method2293_2870;
      obj_t class2298_2871;
      {
	 obj_t arg2301_2868;
	 obj_t arg2302_2869;
	 {
	    object_t obj_3087;
	    obj_3087 = (object_t) (node_7);
	    {
	       obj_t pre_method_105_3088;
	       pre_method_105_3088 = PROCEDURE_REF(stack__env_104_cfa_stack, ((long) 2));
	       if (INTEGERP(pre_method_105_3088))
		 {
		    PROCEDURE_SET(stack__env_104_cfa_stack, ((long) 2), BUNSPEC);
		    arg2301_2868 = pre_method_105_3088;
		 }
	       else
		 {
		    long obj_class_num_177_3093;
		    obj_class_num_177_3093 = TYPE(obj_3087);
		    {
		       obj_t arg1183_3094;
		       arg1183_3094 = PROCEDURE_REF(stack__env_104_cfa_stack, ((long) 1));
		       {
			  long arg1184_3098;
			  {
			     long arg1186_3099;
			     arg1186_3099 = OBJECT_TYPE;
			     arg1184_3098 = (obj_class_num_177_3093 - arg1186_3099);
			  }
			  arg2301_2868 = VECTOR_REF(arg1183_3094, arg1184_3098);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_3104;
	    object_3104 = (object_t) (node_7);
	    {
	       long arg1187_3105;
	       {
		  long arg1188_3106;
		  long arg1189_3107;
		  arg1188_3106 = TYPE(object_3104);
		  arg1189_3107 = OBJECT_TYPE;
		  arg1187_3105 = (arg1188_3106 - arg1189_3107);
	       }
	       {
		  obj_t vector_3111;
		  vector_3111 = __classes__134___object;
		  arg2302_2869 = VECTOR_REF(vector_3111, arg1187_3105);
	       }
	    }
	 }
	 {
	    obj_t aux_3902;
	    method2293_2870 = arg2301_2868;
	    class2298_2871 = arg2302_2869;
	    {
	       if (INTEGERP(method2293_2870))
		 {
		    switch ((long) CINT(method2293_2870))
		      {
		      case ((long) 0):
			 {
			    atom_t aux_3905;
			    aux_3905 = (atom_t) (node_7);
			    aux_3902 = (obj_t) (aux_3905);
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t aux_3908;
			    aux_3908 = (kwote_t) (node_7);
			    aux_3902 = (obj_t) (aux_3908);
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t aux_3911;
			    aux_3911 = (var_t) (node_7);
			    aux_3902 = (obj_t) (aux_3911);
			 }
			 break;
		      case ((long) 3):
			 {
			    closure_t aux_3914;
			    aux_3914 = (closure_t) (node_7);
			    aux_3902 = (obj_t) (aux_3914);
			 }
			 break;
		      case ((long) 4):
			 {
			    sequence_t node_2881;
			    node_2881 = (sequence_t) (node_7);
			    stack___129_cfa_stack((((sequence_t) CREF(node_2881))->nodes));
			    aux_3902 = (obj_t) (node_2881);
			 }
			 break;
		      case ((long) 5):
			 {
			    app_ly_162_t node_2884;
			    node_2884 = (app_ly_162_t) (node_7);
			    {
			       node_t arg2306_2886;
			       arg2306_2886 = stack__132_cfa_stack((((app_ly_162_t) CREF(node_2884))->fun));
			       {
				  obj_t res2380_3117;
				  {
				     obj_t x_3607;
				     x_3607 = ((((app_ly_162_t) CREF(node_2884))->fun) = ((node_t) arg2306_2886), BUNSPEC);
				     res2380_3117 = BUNSPEC;
				  }
				  res2380_3117;
			       }
			    }
			    {
			       node_t arg2308_2888;
			       arg2308_2888 = stack__132_cfa_stack((((app_ly_162_t) CREF(node_2884))->arg));
			       {
				  obj_t res2381_3121;
				  {
				     obj_t x_3608;
				     x_3608 = ((((app_ly_162_t) CREF(node_2884))->arg) = ((node_t) arg2308_2888), BUNSPEC);
				     res2381_3121 = BUNSPEC;
				  }
				  res2381_3121;
			       }
			    }
			    aux_3902 = (obj_t) (node_2884);
			 }
			 break;
		      case ((long) 6):
			 {
			    funcall_t node_2890;
			    node_2890 = (funcall_t) (node_7);
			    {
			       node_t arg2310_2892;
			       arg2310_2892 = stack__132_cfa_stack((((funcall_t) CREF(node_2890))->fun));
			       {
				  obj_t res2382_3125;
				  {
				     obj_t x_3609;
				     x_3609 = ((((funcall_t) CREF(node_2890))->fun) = ((node_t) arg2310_2892), BUNSPEC);
				     res2382_3125 = BUNSPEC;
				  }
				  res2382_3125;
			       }
			    }
			    stack___129_cfa_stack((((funcall_t) CREF(node_2890))->args));
			    aux_3902 = (obj_t) (node_2890);
			 }
			 break;
		      case ((long) 7):
			 {
			    pragma_t node_2895;
			    node_2895 = (pragma_t) (node_7);
			    stack___129_cfa_stack((((pragma_t) CREF(node_2895))->args));
			    aux_3902 = (obj_t) (node_2895);
			 }
			 break;
		      case ((long) 8):
			 {
			    cast_t node_2898;
			    node_2898 = (cast_t) (node_7);
			    stack__132_cfa_stack((((cast_t) CREF(node_2898))->arg));
			    aux_3902 = (obj_t) (node_2898);
			 }
			 break;
		      case ((long) 9):
			 {
			    setq_t node_2901;
			    node_2901 = (setq_t) (node_7);
			    {
			       node_t arg2315_2903;
			       arg2315_2903 = stack__132_cfa_stack((((setq_t) CREF(node_2901))->value));
			       {
				  obj_t res2383_3132;
				  {
				     obj_t x_3610;
				     x_3610 = ((((setq_t) CREF(node_2901))->value) = ((node_t) arg2315_2903), BUNSPEC);
				     res2383_3132 = BUNSPEC;
				  }
				  res2383_3132;
			       }
			    }
			    {
			       node_t arg2317_2905;
			       {
				  node_t aux_3948;
				  {
				     var_t aux_3949;
				     aux_3949 = (((setq_t) CREF(node_2901))->var);
				     aux_3948 = (node_t) (aux_3949);
				  }
				  arg2317_2905 = stack__132_cfa_stack(aux_3948);
			       }
			       {
				  obj_t res2384_3136;
				  {
				     var_t val1242_3135;
				     val1242_3135 = (var_t) (arg2317_2905);
				     {
					obj_t x_3611;
					x_3611 = ((((setq_t) CREF(node_2901))->var) = ((var_t) val1242_3135), BUNSPEC);
					res2384_3136 = BUNSPEC;
				     }
				  }
				  res2384_3136;
			       }
			    }
			    aux_3902 = (obj_t) (node_2901);
			 }
			 break;
		      case ((long) 10):
			 {
			    conditional_t node_2907;
			    node_2907 = (conditional_t) (node_7);
			    {
			       node_t arg2319_2909;
			       arg2319_2909 = stack__132_cfa_stack((((conditional_t) CREF(node_2907))->test));
			       {
				  obj_t res2385_3140;
				  {
				     obj_t x_3612;
				     x_3612 = ((((conditional_t) CREF(node_2907))->test) = ((node_t) arg2319_2909), BUNSPEC);
				     res2385_3140 = BUNSPEC;
				  }
				  res2385_3140;
			       }
			    }
			    {
			       node_t arg2321_2911;
			       arg2321_2911 = stack__132_cfa_stack((((conditional_t) CREF(node_2907))->true));
			       {
				  obj_t res2386_3144;
				  {
				     obj_t x_3613;
				     x_3613 = ((((conditional_t) CREF(node_2907))->true) = ((node_t) arg2321_2911), BUNSPEC);
				     res2386_3144 = BUNSPEC;
				  }
				  res2386_3144;
			       }
			    }
			    {
			       node_t arg2323_2913;
			       arg2323_2913 = stack__132_cfa_stack((((conditional_t) CREF(node_2907))->false));
			       {
				  obj_t res2387_3148;
				  {
				     obj_t x_3614;
				     x_3614 = ((((conditional_t) CREF(node_2907))->false) = ((node_t) arg2323_2913), BUNSPEC);
				     res2387_3148 = BUNSPEC;
				  }
				  res2387_3148;
			       }
			    }
			    aux_3902 = (obj_t) (node_2907);
			 }
			 break;
		      case ((long) 11):
			 {
			    fail_t node_2915;
			    node_2915 = (fail_t) (node_7);
			    {
			       node_t arg2325_2917;
			       arg2325_2917 = stack__132_cfa_stack((((fail_t) CREF(node_2915))->proc));
			       {
				  obj_t res2388_3152;
				  {
				     obj_t x_3615;
				     x_3615 = ((((fail_t) CREF(node_2915))->proc) = ((node_t) arg2325_2917), BUNSPEC);
				     res2388_3152 = BUNSPEC;
				  }
				  res2388_3152;
			       }
			    }
			    {
			       node_t arg2327_2919;
			       arg2327_2919 = stack__132_cfa_stack((((fail_t) CREF(node_2915))->msg));
			       {
				  obj_t res2389_3156;
				  {
				     obj_t x_3616;
				     x_3616 = ((((fail_t) CREF(node_2915))->msg) = ((node_t) arg2327_2919), BUNSPEC);
				     res2389_3156 = BUNSPEC;
				  }
				  res2389_3156;
			       }
			    }
			    {
			       node_t arg2329_2921;
			       arg2329_2921 = stack__132_cfa_stack((((fail_t) CREF(node_2915))->obj));
			       {
				  obj_t res2390_3160;
				  {
				     obj_t x_3617;
				     x_3617 = ((((fail_t) CREF(node_2915))->obj) = ((node_t) arg2329_2921), BUNSPEC);
				     res2390_3160 = BUNSPEC;
				  }
				  res2390_3160;
			       }
			    }
			    aux_3902 = (obj_t) (node_2915);
			 }
			 break;
		      case ((long) 12):
			 {
			    select_t node_2923;
			    node_2923 = (select_t) (node_7);
			    {
			       node_t arg2331_2925;
			       arg2331_2925 = stack__132_cfa_stack((((select_t) CREF(node_2923))->test));
			       {
				  obj_t res2391_3164;
				  {
				     obj_t x_3618;
				     x_3618 = ((((select_t) CREF(node_2923))->test) = ((node_t) arg2331_2925), BUNSPEC);
				     res2391_3164 = BUNSPEC;
				  }
				  res2391_3164;
			       }
			    }
			    {
			       obj_t l1906_2927;
			       l1906_2927 = (((select_t) CREF(node_2923))->clauses);
			     lname1908_2928:
			       if (PAIRP(l1906_2927))
				 {
				    {
				       obj_t clause_2931;
				       clause_2931 = CAR(l1906_2927);
				       {
					  node_t arg2336_2932;
					  {
					     node_t aux_3985;
					     {
						obj_t aux_3986;
						aux_3986 = CDR(clause_2931);
						aux_3985 = (node_t) (aux_3986);
					     }
					     arg2336_2932 = stack__132_cfa_stack(aux_3985);
					  }
					  {
					     obj_t aux_3990;
					     aux_3990 = (obj_t) (arg2336_2932);
					     SET_CDR(clause_2931, aux_3990);
					  }
				       }
				    }
				    {
				       obj_t l1906_3993;
				       l1906_3993 = CDR(l1906_2927);
				       l1906_2927 = l1906_3993;
				       goto lname1908_2928;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_3902 = (obj_t) (node_2923);
			 }
			 break;
		      case ((long) 13):
			 {
			    let_fun_218_t node_2935;
			    node_2935 = (let_fun_218_t) (node_7);
			    {
			       obj_t l1910_2937;
			       l1910_2937 = (((let_fun_218_t) CREF(node_2935))->locals);
			     lname1911_2938:
			       if (PAIRP(l1910_2937))
				 {
				    {
				       value_t fun_2942;
				       {
					  local_t obj_3175;
					  {
					     obj_t aux_4000;
					     aux_4000 = CAR(l1910_2937);
					     obj_3175 = (local_t) (aux_4000);
					  }
					  fun_2942 = (((local_t) CREF(obj_3175))->value);
				       }
				       {
					  node_t arg2343_2943;
					  {
					     node_t aux_4004;
					     {
						obj_t aux_4005;
						{
						   sfun_t obj_3176;
						   obj_3176 = (sfun_t) (fun_2942);
						   aux_4005 = (((sfun_t) CREF(obj_3176))->body);
						}
						aux_4004 = (node_t) (aux_4005);
					     }
					     arg2343_2943 = stack__132_cfa_stack(aux_4004);
					  }
					  {
					     obj_t res2392_3179;
					     {
						sfun_t obj_3177;
						obj_t val1127_3178;
						obj_3177 = (sfun_t) (fun_2942);
						val1127_3178 = (obj_t) (arg2343_2943);
						{
						   obj_t x_3619;
						   x_3619 = ((((sfun_t) CREF(obj_3177))->body) = ((obj_t) val1127_3178), BUNSPEC);
						   res2392_3179 = BUNSPEC;
						}
					     }
					     res2392_3179;
					  }
				       }
				    }
				    {
				       obj_t l1910_4013;
				       l1910_4013 = CDR(l1910_2937);
				       l1910_2937 = l1910_4013;
				       goto lname1911_2938;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg2346_2946;
			       arg2346_2946 = stack__132_cfa_stack((((let_fun_218_t) CREF(node_2935))->body));
			       {
				  obj_t res2393_3184;
				  {
				     obj_t x_3620;
				     x_3620 = ((((let_fun_218_t) CREF(node_2935))->body) = ((node_t) arg2346_2946), BUNSPEC);
				     res2393_3184 = BUNSPEC;
				  }
				  res2393_3184;
			       }
			    }
			    aux_3902 = (obj_t) (node_2935);
			 }
			 break;
		      case ((long) 14):
			 {
			    let_var_6_t node_2948;
			    node_2948 = (let_var_6_t) (node_7);
			    {
			       node_t arg2348_2950;
			       arg2348_2950 = stack__132_cfa_stack((((let_var_6_t) CREF(node_2948))->body));
			       {
				  obj_t res2394_3188;
				  {
				     obj_t x_3621;
				     x_3621 = ((((let_var_6_t) CREF(node_2948))->body) = ((node_t) arg2348_2950), BUNSPEC);
				     res2394_3188 = BUNSPEC;
				  }
				  res2394_3188;
			       }
			    }
			    {
			       obj_t l1913_2952;
			       l1913_2952 = (((let_var_6_t) CREF(node_2948))->bindings);
			     lname1914_2953:
			       if (PAIRP(l1913_2952))
				 {
				    {
				       obj_t binding_2956;
				       binding_2956 = CAR(l1913_2952);
				       {
					  node_t arg2352_2957;
					  {
					     node_t aux_4027;
					     {
						obj_t aux_4028;
						aux_4028 = CDR(binding_2956);
						aux_4027 = (node_t) (aux_4028);
					     }
					     arg2352_2957 = stack__132_cfa_stack(aux_4027);
					  }
					  {
					     obj_t aux_4032;
					     aux_4032 = (obj_t) (arg2352_2957);
					     SET_CDR(binding_2956, aux_4032);
					  }
				       }
				    }
				    {
				       obj_t l1913_4035;
				       l1913_4035 = CDR(l1913_2952);
				       l1913_2952 = l1913_4035;
				       goto lname1914_2953;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_3902 = (obj_t) (node_2948);
			 }
			 break;
		      case ((long) 15):
			 {
			    set_ex_it_116_t node_2960;
			    node_2960 = (set_ex_it_116_t) (node_7);
			    {
			       node_t arg2355_2962;
			       arg2355_2962 = stack__132_cfa_stack((((set_ex_it_116_t) CREF(node_2960))->body));
			       {
				  obj_t res2395_3199;
				  {
				     obj_t x_3622;
				     x_3622 = ((((set_ex_it_116_t) CREF(node_2960))->body) = ((node_t) arg2355_2962), BUNSPEC);
				     res2395_3199 = BUNSPEC;
				  }
				  res2395_3199;
			       }
			    }
			    {
			       node_t arg2357_2964;
			       {
				  node_t aux_4043;
				  {
				     var_t aux_4044;
				     aux_4044 = (((set_ex_it_116_t) CREF(node_2960))->var);
				     aux_4043 = (node_t) (aux_4044);
				  }
				  arg2357_2964 = stack__132_cfa_stack(aux_4043);
			       }
			       {
				  obj_t res2396_3203;
				  {
				     var_t val1290_3202;
				     val1290_3202 = (var_t) (arg2357_2964);
				     {
					obj_t x_3623;
					x_3623 = ((((set_ex_it_116_t) CREF(node_2960))->var) = ((var_t) val1290_3202), BUNSPEC);
					res2396_3203 = BUNSPEC;
				     }
				  }
				  res2396_3203;
			       }
			    }
			    aux_3902 = (obj_t) (node_2960);
			 }
			 break;
		      case ((long) 16):
			 {
			    jump_ex_it_184_t node_2966;
			    node_2966 = (jump_ex_it_184_t) (node_7);
			    {
			       node_t arg2359_2968;
			       arg2359_2968 = stack__132_cfa_stack((((jump_ex_it_184_t) CREF(node_2966))->exit));
			       {
				  obj_t res2397_3207;
				  {
				     obj_t x_3624;
				     x_3624 = ((((jump_ex_it_184_t) CREF(node_2966))->exit) = ((node_t) arg2359_2968), BUNSPEC);
				     res2397_3207 = BUNSPEC;
				  }
				  res2397_3207;
			       }
			    }
			    {
			       node_t arg2361_2970;
			       arg2361_2970 = stack__132_cfa_stack((((jump_ex_it_184_t) CREF(node_2966))->value));
			       {
				  obj_t res2398_3211;
				  {
				     obj_t x_3625;
				     x_3625 = ((((jump_ex_it_184_t) CREF(node_2966))->value) = ((node_t) arg2361_2970), BUNSPEC);
				     res2398_3211 = BUNSPEC;
				  }
				  res2398_3211;
			       }
			    }
			    aux_3902 = (obj_t) (node_2966);
			 }
			 break;
		      case ((long) 17):
			 {
			    make_box_202_t node_2972;
			    node_2972 = (make_box_202_t) (node_7);
			    {
			       node_t arg2363_2974;
			       arg2363_2974 = stack__132_cfa_stack((((make_box_202_t) CREF(node_2972))->value));
			       {
				  obj_t res2399_3215;
				  {
				     obj_t x_3626;
				     x_3626 = ((((make_box_202_t) CREF(node_2972))->value) = ((node_t) arg2363_2974), BUNSPEC);
				     res2399_3215 = BUNSPEC;
				  }
				  res2399_3215;
			       }
			    }
			    aux_3902 = (obj_t) (node_2972);
			 }
			 break;
		      case ((long) 18):
			 {
			    box_set__221_t node_2976;
			    node_2976 = (box_set__221_t) (node_7);
			    {
			       node_t arg2365_2978;
			       {
				  node_t aux_4065;
				  {
				     var_t aux_4066;
				     aux_4066 = (((box_set__221_t) CREF(node_2976))->var);
				     aux_4065 = (node_t) (aux_4066);
				  }
				  arg2365_2978 = stack__132_cfa_stack(aux_4065);
			       }
			       {
				  obj_t res2400_3219;
				  {
				     var_t val1318_3218;
				     val1318_3218 = (var_t) (arg2365_2978);
				     {
					obj_t x_3627;
					x_3627 = ((((box_set__221_t) CREF(node_2976))->var) = ((var_t) val1318_3218), BUNSPEC);
					res2400_3219 = BUNSPEC;
				     }
				  }
				  res2400_3219;
			       }
			    }
			    {
			       node_t arg2367_2980;
			       arg2367_2980 = stack__132_cfa_stack((((box_set__221_t) CREF(node_2976))->value));
			       {
				  obj_t res2401_3223;
				  {
				     obj_t x_3628;
				     x_3628 = ((((box_set__221_t) CREF(node_2976))->value) = ((node_t) arg2367_2980), BUNSPEC);
				     res2401_3223 = BUNSPEC;
				  }
				  res2401_3223;
			       }
			    }
			    aux_3902 = (obj_t) (node_2976);
			 }
			 break;
		      case ((long) 19):
			 {
			    box_ref_242_t node_2982;
			    node_2982 = (box_ref_242_t) (node_7);
			    {
			       node_t arg2369_2984;
			       {
				  node_t aux_4077;
				  {
				     var_t aux_4078;
				     aux_4078 = (((box_ref_242_t) CREF(node_2982))->var);
				     aux_4077 = (node_t) (aux_4078);
				  }
				  arg2369_2984 = stack__132_cfa_stack(aux_4077);
			       }
			       {
				  obj_t res2402_3227;
				  {
				     var_t val1312_3226;
				     val1312_3226 = (var_t) (arg2369_2984);
				     {
					obj_t x_3629;
					x_3629 = ((((box_ref_242_t) CREF(node_2982))->var) = ((var_t) val1312_3226), BUNSPEC);
					res2402_3227 = BUNSPEC;
				     }
				  }
				  res2402_3227;
			       }
			    }
			    aux_3902 = (obj_t) (node_2982);
			 }
			 break;
		      case ((long) 20):
			 {
			    app_t node_2986;
			    node_2986 = (app_t) (node_7);
			    stack___129_cfa_stack((((app_t) CREF(node_2986))->args));
			    aux_3902 = (obj_t) (node_2986);
			 }
			 break;
		      default:
		       case_else2299_240_2874:
			 if (PROCEDUREP(method2293_2870))
			   {
			      aux_3902 = PROCEDURE_ENTRY(method2293_2870) (method2293_2870, (obj_t) (node_7), BEOA);
			   }
			 else
			   {
			      obj_t fun2032_2103;
			      fun2032_2103 = PROCEDURE_REF(stack__env_104_cfa_stack, ((long) 0));
			      aux_3902 = PROCEDURE_ENTRY(fun2032_2103) (fun2032_2103, (obj_t) (node_7), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else2299_240_2874;
		 }
	    }
	    return (node_t) (aux_3902);
	 }
      }
   }
}


obj_t 
_stack__205_cfa_stack(obj_t env_3592, obj_t node_3593)
{
   {
      node_t aux_4101;
      aux_4101 = stack__132_cfa_stack((node_t) (node_3593));
      return (obj_t) (aux_4101);
   }
}


obj_t 
stack___129_cfa_stack(obj_t node__221_30)
{
   {
      obj_t node__221_2104;
      node__221_2104 = node__221_30;
    loop_2105:
      if (NULLP(node__221_2104))
	{
	   return CNST_TABLE_REF(((long) 4));
	}
      else
	{
	   {
	      node_t arg2034_2107;
	      {
		 node_t aux_4108;
		 {
		    obj_t aux_4109;
		    aux_4109 = CAR(node__221_2104);
		    aux_4108 = (node_t) (aux_4109);
		 }
		 arg2034_2107 = stack__132_cfa_stack(aux_4108);
	      }
	      {
		 obj_t aux_4113;
		 aux_4113 = (obj_t) (arg2034_2107);
		 SET_CAR(node__221_2104, aux_4113);
	      }
	   }
	   {
	      obj_t node__221_4116;
	      node__221_4116 = CDR(node__221_2104);
	      node__221_2104 = node__221_4116;
	      goto loop_2105;
	   }
	}
   }
}


obj_t 
_stack___237_cfa_stack(obj_t env_3603, obj_t node__221_3604)
{
   return stack___129_cfa_stack(node__221_3604);
}


obj_t 
imported_modules_init_94_cfa_stack()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_STACK");
   module_initialization_70_engine_param(((long) 0), "CFA_STACK");
   module_initialization_70_tools_speek(((long) 0), "CFA_STACK");
   module_initialization_70_tools_shape(((long) 0), "CFA_STACK");
   module_initialization_70_type_type(((long) 0), "CFA_STACK");
   module_initialization_70_ast_var(((long) 0), "CFA_STACK");
   module_initialization_70_ast_node(((long) 0), "CFA_STACK");
   module_initialization_70_cfa_info(((long) 0), "CFA_STACK");
   module_initialization_70_cfa_iterate(((long) 0), "CFA_STACK");
   module_initialization_70_cfa_loose(((long) 0), "CFA_STACK");
   module_initialization_70_inline_inline(((long) 0), "CFA_STACK");
   return module_initialization_70_inline_walk(((long) 0), "CFA_STACK");
}
