/*===========================================================================*/
/*   (Cfa/struct.scm)                                                        */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


extern obj_t _stack_loose_alloc__18_cfa_loose(obj_t, obj_t, obj_t);
static obj_t node_key_pre_make_struct_app2339_165_cfa_struct(obj_t, obj_t);
static obj_t loose_alloc__make_struct_app2343_217_cfa_struct(obj_t, obj_t);
extern obj_t _node_setup__114_cfa_setup(obj_t, obj_t);
static obj_t node_setup__pre_make_struct_app2351_10_cfa_struct(obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern approx_t loose__226_cfa_loose(approx_t, obj_t);
extern obj_t _cfa__186_cfa_cfa(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t stack__make_struct_app2336_100_cfa_struct(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_cfa_struct();
extern obj_t module_initialization_70_cfa_struct(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_setup(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_stack(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t node_key_make_struct_app2337_162_cfa_struct(obj_t, obj_t);
static obj_t toplevel_init_63_cfa_struct();
static obj_t cnst_init_137_cfa_struct();
static obj_t node_setup__pre_struct_ref_app2350_249_cfa_struct(obj_t, obj_t);
static obj_t node_key_set__pre_make_struct_app2338_163_cfa_struct(obj_t, obj_t, obj_t);
static obj_t arg20542342_cfa_struct(obj_t, obj_t);
static obj_t arg19832347_cfa_struct(obj_t, obj_t);
static obj_t arg20082345_cfa_struct(obj_t, obj_t);
extern obj_t _node_key_105_cfa_approx(obj_t, obj_t);
extern obj_t _loose_alloc__239_cfa_loose(obj_t, obj_t);
static obj_t cfa__struct_ref_app2346_149_cfa_struct(obj_t, obj_t);
extern obj_t node_setup___185_cfa_setup(obj_t);
static obj_t arg20502341_cfa_struct(obj_t, obj_t);
extern obj_t stack_loose_alloc__95_cfa_loose(node_t, obj_t);
static obj_t require_initialization_114_cfa_struct = BUNSPEC;
extern approx_t make_empty_approx_131_cfa_approx();
static obj_t node_setup__pre_struct_set__app2349_164_cfa_struct(obj_t, obj_t);
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cfa_struct();
extern obj_t struct_ref_app_73_cfa_info;
extern obj_t variable_ast_var;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t pre_make_struct_app_218_cfa_info;
extern obj_t open_input_string(obj_t);
extern obj_t __unspec__87_type_cache;
extern obj_t class_super_145___object(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t __cfa_stamp__16_cfa_iterate;
extern obj_t struct_set__app_162_cfa_info;
extern approx_t union_approx__241_cfa_approx(approx_t, approx_t);
extern approx_t cfa__102_cfa_cfa(node_t);
extern approx_t make_type_alloc_approx_134_cfa_approx(type_t, node_t);
static obj_t cfa__make_struct_app2348_235_cfa_struct(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t _node_key_set__44_cfa_approx(obj_t, obj_t, obj_t);
extern obj_t make_struct_app_214_cfa_info;
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_t);
extern approx_t make_type_approx_184_cfa_approx(type_t);
extern obj_t approx_set_type__239_cfa_approx(approx_t, type_t);
extern obj_t stack___129_cfa_stack(obj_t);
extern obj_t _stack__205_cfa_stack(obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t __struct__183_type_cache;
extern node_t node_heap__stack__239_cfa_stack(app_t, bool_t);
extern obj_t approx_set_top__187_cfa_approx(approx_t);
static obj_t cfa__struct_set__app2344_61_cfa_struct(obj_t, obj_t);
static obj_t stack_loose_alloc__make_struct_app2340_231_cfa_struct(obj_t, obj_t, obj_t);
extern obj_t __obj__252_type_cache;
extern obj_t pre_struct_set__app_116_cfa_info;
extern obj_t pre_struct_ref_app_207_cfa_info;
static obj_t __cnst[2];

extern obj_t cfa__env_153_cfa_cfa;
DEFINE_STATIC_PROCEDURE(proc2369_cfa_struct, node_key_set__pre_make_struct_app2338_163_cfa_struct2387, node_key_set__pre_make_struct_app2338_163_cfa_struct, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2367_cfa_struct, stack_loose_alloc__make_struct_app2340_231_cfa_struct2388, stack_loose_alloc__make_struct_app2340_231_cfa_struct, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2374_cfa_struct, arg20502341_cfa_struct2389, arg20502341_cfa_struct, 0L, 1);
extern obj_t stack__env_104_cfa_stack;
DEFINE_STATIC_PROCEDURE(proc2368_cfa_struct, node_key_pre_make_struct_app2339_165_cfa_struct2390, node_key_pre_make_struct_app2339_165_cfa_struct, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2364_cfa_struct, cfa__struct_ref_app2346_149_cfa_struct2391, cfa__struct_ref_app2346_149_cfa_struct, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2362_cfa_struct, node_setup__pre_struct_set__app2349_164_cfa_struct2392, node_setup__pre_struct_set__app2349_164_cfa_struct, 0L, 1);
DEFINE_STRING(string2377_cfa_struct, string2377_cfa_struct2393, "    struct-ref: ", 16);
DEFINE_STATIC_PROCEDURE(proc2366_cfa_struct, loose_alloc__make_struct_app2343_217_cfa_struct2394, loose_alloc__make_struct_app2343_217_cfa_struct, 0L, 1);
DEFINE_STRING(string2380_cfa_struct, string2380_cfa_struct2395, "    make-struct-app: ", 21);
DEFINE_STRING(string2376_cfa_struct, string2376_cfa_struct2396, "   struct-set!: ", 16);
DEFINE_STRING(string2375_cfa_struct, string2375_cfa_struct2397, " *** loose: ", 12);
extern obj_t node_key_set__env_57_cfa_approx;
DEFINE_STRING(string2373_cfa_struct, string2373_cfa_struct2398, " *** stack-loose: ", 18);
extern obj_t node_key_env_229_cfa_approx;
DEFINE_STRING(string2378_cfa_struct, string2378_cfa_struct2399, "   make-struct: ", 16);
DEFINE_STATIC_PROCEDURE(proc2371_cfa_struct, stack__make_struct_app2336_100_cfa_struct2400, stack__make_struct_app2336_100_cfa_struct, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2360_cfa_struct, node_setup__pre_make_struct_app2351_10_cfa_struct2401, node_setup__pre_make_struct_app2351_10_cfa_struct, 0L, 1);
DEFINE_STRING(string2372_cfa_struct, string2372_cfa_struct2402, "stack(make-struct-app): s?: ", 28);
DEFINE_STATIC_PROCEDURE(proc2361_cfa_struct, node_setup__pre_struct_ref_app2350_249_cfa_struct2403, node_setup__pre_struct_ref_app2350_249_cfa_struct, 0L, 1);
extern obj_t node_setup__env_214_cfa_setup;
DEFINE_STATIC_PROCEDURE(proc2370_cfa_struct, node_key_make_struct_app2337_162_cfa_struct2404, node_key_make_struct_app2337_162_cfa_struct, 0L, 1);
DEFINE_STRING(string2379_cfa_struct, string2379_cfa_struct2405, "                key: ", 21);
DEFINE_STATIC_PROCEDURE(proc2365_cfa_struct, cfa__struct_set__app2344_61_cfa_struct2406, cfa__struct_set__app2344_61_cfa_struct, 0L, 1);
DEFINE_STRING(string2381_cfa_struct, string2381_cfa_struct2407, "ALL CFA ", 8);
extern obj_t loose_alloc__env_83_cfa_loose;
DEFINE_STATIC_PROCEDURE(proc2363_cfa_struct, cfa__make_struct_app2348_235_cfa_struct2408, cfa__make_struct_app2348_235_cfa_struct, 0L, 1);
extern obj_t stack_loose_alloc__env_147_cfa_loose;

obj_t 
module_initialization_70_cfa_struct(long checksum_3527, char *from_3528)
{
   if (CBOOL(require_initialization_114_cfa_struct))
     {
	require_initialization_114_cfa_struct = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_struct();
	cnst_init_137_cfa_struct();
	imported_modules_init_94_cfa_struct();
	toplevel_init_63_cfa_struct();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_struct()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_STRUCT");
   module_initialization_70___object(((long) 0), "CFA_STRUCT");
   module_initialization_70___reader(((long) 0), "CFA_STRUCT");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_struct()
{
   {
      obj_t cnst_port_138_3519;
      cnst_port_138_3519 = open_input_string(string2381_cfa_struct);
      {
	 long i_3520;
	 i_3520 = ((long) 1);
       loop_3521:
	 {
	    bool_t test2382_3522;
	    test2382_3522 = (i_3520 == ((long) -1));
	    if (test2382_3522)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2383_3523;
		    {
		       obj_t list2384_3524;
		       {
			  obj_t arg2385_3525;
			  arg2385_3525 = BNIL;
			  list2384_3524 = MAKE_PAIR(cnst_port_138_3519, arg2385_3525);
		       }
		       arg2383_3523 = read___reader(list2384_3524);
		    }
		    CNST_TABLE_SET(i_3520, arg2383_3523);
		 }
		 {
		    int aux_3526;
		    {
		       long aux_3545;
		       aux_3545 = (i_3520 - ((long) 1));
		       aux_3526 = (int) (aux_3545);
		    }
		    {
		       long i_3548;
		       i_3548 = (long) (aux_3526);
		       i_3520 = i_3548;
		       goto loop_3521;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_struct()
{
   {
      obj_t node_setup__pre_make_struct_app_238_3461;
      node_setup__pre_make_struct_app_238_3461 = proc2360_cfa_struct;
      add_method__1___object(node_setup__env_214_cfa_setup, pre_make_struct_app_218_cfa_info, node_setup__pre_make_struct_app_238_3461);
   }
   {
      obj_t node_setup__pre_struct_ref_app_157_3460;
      node_setup__pre_struct_ref_app_157_3460 = proc2361_cfa_struct;
      add_method__1___object(node_setup__env_214_cfa_setup, pre_struct_ref_app_207_cfa_info, node_setup__pre_struct_ref_app_157_3460);
   }
   {
      obj_t node_setup__pre_struct_set__app_230_3459;
      node_setup__pre_struct_set__app_230_3459 = proc2362_cfa_struct;
      add_method__1___object(node_setup__env_214_cfa_setup, pre_struct_set__app_116_cfa_info, node_setup__pre_struct_set__app_230_3459);
   }
   {
      obj_t cfa__make_struct_app_189_3458;
      cfa__make_struct_app_189_3458 = proc2363_cfa_struct;
      add_method__1___object(cfa__env_153_cfa_cfa, make_struct_app_214_cfa_info, cfa__make_struct_app_189_3458);
   }
   {
      obj_t cfa__struct_ref_app_92_3457;
      cfa__struct_ref_app_92_3457 = proc2364_cfa_struct;
      add_method__1___object(cfa__env_153_cfa_cfa, struct_ref_app_73_cfa_info, cfa__struct_ref_app_92_3457);
   }
   {
      obj_t cfa__struct_set__app_51_3455;
      cfa__struct_set__app_51_3455 = proc2365_cfa_struct;
      add_method__1___object(cfa__env_153_cfa_cfa, struct_set__app_162_cfa_info, cfa__struct_set__app_51_3455);
   }
   {
      obj_t loose_alloc__make_struct_app_81_3451;
      loose_alloc__make_struct_app_81_3451 = proc2366_cfa_struct;
      add_method__1___object(loose_alloc__env_83_cfa_loose, make_struct_app_214_cfa_info, loose_alloc__make_struct_app_81_3451);
   }
   {
      obj_t stack_loose_alloc__make_struct_app_85_3450;
      stack_loose_alloc__make_struct_app_85_3450 = proc2367_cfa_struct;
      add_method__1___object(stack_loose_alloc__env_147_cfa_loose, make_struct_app_214_cfa_info, stack_loose_alloc__make_struct_app_85_3450);
   }
   {
      obj_t node_key_pre_make_struct_app_67_3447;
      node_key_pre_make_struct_app_67_3447 = proc2368_cfa_struct;
      add_method__1___object(node_key_env_229_cfa_approx, pre_make_struct_app_218_cfa_info, node_key_pre_make_struct_app_67_3447);
   }
   {
      obj_t node_key_set__pre_make_struct_app_46_3446;
      node_key_set__pre_make_struct_app_46_3446 = proc2369_cfa_struct;
      add_method__1___object(node_key_set__env_57_cfa_approx, pre_make_struct_app_218_cfa_info, node_key_set__pre_make_struct_app_46_3446);
   }
   {
      obj_t node_key_make_struct_app_193_3445;
      node_key_make_struct_app_193_3445 = proc2370_cfa_struct;
      add_method__1___object(node_key_env_229_cfa_approx, make_struct_app_214_cfa_info, node_key_make_struct_app_193_3445);
   }
   {
      obj_t stack__make_struct_app_69_3444;
      stack__make_struct_app_69_3444 = proc2371_cfa_struct;
      return add_method__1___object(stack__env_104_cfa_stack, make_struct_app_214_cfa_info, stack__make_struct_app_69_3444);
   }
}


obj_t 
stack__make_struct_app2336_100_cfa_struct(obj_t env_3462, obj_t node_3463)
{
   {
      make_struct_app_214_t node_2172;
      {
	 node_t aux_3562;
	 node_2172 = (make_struct_app_214_t) (node_3463);
	 {
	    bool_t test2065_2176;
	    {
	       obj_t aux_3563;
	       aux_3563 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	       test2065_2176 = CBOOL(aux_3563);
	    }
	    if (test2065_2176)
	      {
		 bool_t arg2068_2178;
		 {
		    obj_t aux_3569;
		    {
		       object_t aux_3570;
		       aux_3570 = (object_t) (node_2172);
		       aux_3569 = OBJECT_WIDENING(aux_3570);
		    }
		    arg2068_2178 = (((make_struct_app_214_t) CREF(aux_3569))->stackable__42);
		 }
		 {
		    obj_t list2069_2179;
		    {
		       obj_t arg2070_2180;
		       {
			  obj_t arg2071_2181;
			  {
			     obj_t aux_3574;
			     aux_3574 = BCHAR(((unsigned char) '\n'));
			     arg2071_2181 = MAKE_PAIR(aux_3574, BNIL);
			  }
			  {
			     obj_t aux_3577;
			     aux_3577 = BBOOL(arg2068_2178);
			     arg2070_2180 = MAKE_PAIR(aux_3577, arg2071_2181);
			  }
		       }
		       list2069_2179 = MAKE_PAIR(string2372_cfa_struct, arg2070_2180);
		    }
		    print_trace_107_tools_trace(list2069_2179);
		 }
	      }
	    else
	      {
		 BUNSPEC;
	      }
	 }
	 {
	    obj_t aux_3582;
	    {
	       app_t obj_3093;
	       obj_3093 = (app_t) (node_2172);
	       aux_3582 = (((app_t) CREF(obj_3093))->args);
	    }
	    stack___129_cfa_stack(aux_3582);
	 }
	 {
	    bool_t aux_3586;
	    {
	       bool_t test_3588;
	       {
		  long aux_3589;
		  {
		     obj_t aux_3590;
		     {
			object_t aux_3591;
			aux_3591 = (object_t) (node_2172);
			aux_3590 = OBJECT_WIDENING(aux_3591);
		     }
		     aux_3589 = (((make_struct_app_214_t) CREF(aux_3590))->lost_stamp_114);
		  }
		  test_3588 = (aux_3589 == ((long) -1));
	       }
	       if (test_3588)
		 {
		    obj_t aux_3596;
		    {
		       object_t aux_3597;
		       aux_3597 = (object_t) (node_2172);
		       aux_3596 = OBJECT_WIDENING(aux_3597);
		    }
		    aux_3586 = (((make_struct_app_214_t) CREF(aux_3596))->stackable__42);
		 }
	       else
		 {
		    aux_3586 = ((bool_t) 0);
		 }
	    }
	    aux_3562 = node_heap__stack__239_cfa_stack((app_t) (node_2172), aux_3586);
	 }
	 return (obj_t) (aux_3562);
      }
   }
}


obj_t 
node_key_make_struct_app2337_162_cfa_struct(obj_t env_3464, obj_t app_3465)
{
   {
      make_struct_app_214_t app_2166;
      app_2166 = (make_struct_app_214_t) (app_3465);
      {
	 obj_t aux_3604;
	 {
	    object_t aux_3605;
	    aux_3605 = (object_t) (app_2166);
	    aux_3604 = OBJECT_WIDENING(aux_3605);
	 }
	 return (((make_struct_app_214_t) CREF(aux_3604))->key);
      }
   }
}


obj_t 
node_key_set__pre_make_struct_app2338_163_cfa_struct(obj_t env_3466, obj_t app_3467, obj_t new_key_72_3468)
{
   {
      pre_make_struct_app_218_t app_2159;
      obj_t new_key_72_2160;
      app_2159 = (pre_make_struct_app_218_t) (app_3467);
      new_key_72_2160 = new_key_72_3468;
      {
	 obj_t res2334_3089;
	 {
	    obj_t x_3513;
	    {
	       obj_t aux_3610;
	       {
		  object_t aux_3611;
		  aux_3611 = (object_t) (app_2159);
		  aux_3610 = OBJECT_WIDENING(aux_3611);
	       }
	       x_3513 = ((((pre_make_struct_app_218_t) CREF(aux_3610))->key) = ((obj_t) new_key_72_2160), BUNSPEC);
	    }
	    res2334_3089 = BUNSPEC;
	 }
	 return res2334_3089;
      }
   }
}


obj_t 
node_key_pre_make_struct_app2339_165_cfa_struct(obj_t env_3469, obj_t app_3470)
{
   {
      pre_make_struct_app_218_t app_2153;
      app_2153 = (pre_make_struct_app_218_t) (app_3470);
      {
	 obj_t aux_3616;
	 {
	    object_t aux_3617;
	    aux_3617 = (object_t) (app_2153);
	    aux_3616 = OBJECT_WIDENING(aux_3617);
	 }
	 return (((pre_make_struct_app_218_t) CREF(aux_3616))->key);
      }
   }
}


obj_t 
stack_loose_alloc__make_struct_app2340_231_cfa_struct(obj_t env_3471, obj_t alloc_3472, obj_t cowner_3473)
{
   {
      make_struct_app_214_t alloc_2118;
      obj_t cowner_2119;
      alloc_2118 = (make_struct_app_214_t) (alloc_3472);
      cowner_2119 = cowner_3473;
      {
	 bool_t test_3622;
	 {
	    bool_t test_3623;
	    {
	       obj_t aux_3624;
	       {
		  object_t aux_3625;
		  aux_3625 = (object_t) (alloc_2118);
		  aux_3624 = OBJECT_WIDENING(aux_3625);
	       }
	       test_3623 = (((make_struct_app_214_t) CREF(aux_3624))->stackable__42);
	    }
	    if (test_3623)
	      {
		 obj_t aux_3629;
		 {
		    obj_t aux_3630;
		    {
		       obj_t aux_3631;
		       {
			  object_t aux_3632;
			  aux_3632 = (object_t) (alloc_2118);
			  aux_3631 = OBJECT_WIDENING(aux_3632);
		       }
		       aux_3630 = (((make_struct_app_214_t) CREF(aux_3631))->stack_stamp_31);
		    }
		    aux_3629 = memq___r4_pairs_and_lists_6_3(cowner_2119, aux_3630);
		 }
		 test_3622 = CBOOL(aux_3629);
	      }
	    else
	      {
		 test_3622 = ((bool_t) 1);
	      }
	 }
	 if (test_3622)
	   {
	      return BUNSPEC;
	   }
	 else
	   {
	      {
		 obj_t arg2035_2124;
		 {
		    obj_t aux_3638;
		    {
		       obj_t aux_3639;
		       {
			  object_t aux_3640;
			  aux_3640 = (object_t) (alloc_2118);
			  aux_3639 = OBJECT_WIDENING(aux_3640);
		       }
		       aux_3638 = (((make_struct_app_214_t) CREF(aux_3639))->stack_stamp_31);
		    }
		    arg2035_2124 = MAKE_PAIR(cowner_2119, aux_3638);
		 }
		 {
		    obj_t res2332_3073;
		    {
		       obj_t x_3514;
		       {
			  obj_t aux_3645;
			  {
			     object_t aux_3646;
			     aux_3646 = (object_t) (alloc_2118);
			     aux_3645 = OBJECT_WIDENING(aux_3646);
			  }
			  x_3514 = ((((make_struct_app_214_t) CREF(aux_3645))->stack_stamp_31) = ((obj_t) arg2035_2124), BUNSPEC);
		       }
		       res2332_3073 = BUNSPEC;
		    }
		    res2332_3073;
		 }
	      }
	      {
		 bool_t test2037_2126;
		 {
		    bool_t test2057_2147;
		    test2057_2147 = is_a__118___object(cowner_2119, variable_ast_var);
		    if (test2057_2147)
		      {
			 obj_t aux_3652;
			 {
			    variable_t aux_3653;
			    {
			       obj_t aux_3654;
			       {
				  object_t aux_3655;
				  aux_3655 = (object_t) (alloc_2118);
				  aux_3654 = OBJECT_WIDENING(aux_3655);
			       }
			       aux_3653 = (((make_struct_app_214_t) CREF(aux_3654))->owner);
			    }
			    aux_3652 = (obj_t) (aux_3653);
			 }
			 test2037_2126 = (aux_3652 == cowner_2119);
		      }
		    else
		      {
			 test2037_2126 = ((bool_t) 1);
		      }
		 }
		 if (test2037_2126)
		   {
		      {
			 bool_t test2038_2127;
			 {
			    obj_t aux_3662;
			    aux_3662 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			    test2038_2127 = CBOOL(aux_3662);
			 }
			 if (test2038_2127)
			   {
			      obj_t arg2040_2129;
			      arg2040_2129 = shape_tools_shape((obj_t) (alloc_2118));
			      {
				 obj_t list2041_2130;
				 {
				    obj_t arg2043_2131;
				    {
				       obj_t arg2045_2132;
				       {
					  obj_t aux_3670;
					  aux_3670 = BCHAR(((unsigned char) '\n'));
					  arg2045_2132 = MAKE_PAIR(aux_3670, BNIL);
				       }
				       arg2043_2131 = MAKE_PAIR(arg2040_2129, arg2045_2132);
				    }
				    list2041_2130 = MAKE_PAIR(string2373_cfa_struct, arg2043_2131);
				 }
				 print_trace_107_tools_trace(list2041_2130);
			      }
			   }
			 else
			   {
			      BUNSPEC;
			   }
		      }
		      {
			 obj_t res2333_3080;
			 {
			    obj_t x_3515;
			    {
			       obj_t aux_3676;
			       {
				  object_t aux_3677;
				  aux_3677 = (object_t) (alloc_2118);
				  aux_3676 = OBJECT_WIDENING(aux_3677);
			       }
			       x_3515 = ((((make_struct_app_214_t) CREF(aux_3676))->stackable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			    }
			    res2333_3080 = BUNSPEC;
			 }
			 res2333_3080;
		      }
		      {
			 approx_t arg2051_2137;
			 {
			    obj_t aux_3681;
			    {
			       object_t aux_3682;
			       aux_3682 = (object_t) (alloc_2118);
			       aux_3681 = OBJECT_WIDENING(aux_3682);
			    }
			    arg2051_2137 = (((make_struct_app_214_t) CREF(aux_3681))->value_approx_19);
			 }
			 {
			    obj_t arg2050_3448;
			    arg2050_3448 = proc2374_cfa_struct;
			    return for_each_approx_alloc_83_cfa_approx(arg2050_3448, arg2051_2137);
			 }
		      }
		   }
		 else
		   {
		      approx_t arg2055_2143;
		      {
			 obj_t aux_3687;
			 {
			    object_t aux_3688;
			    aux_3688 = (object_t) (alloc_2118);
			    aux_3687 = OBJECT_WIDENING(aux_3688);
			 }
			 arg2055_2143 = (((make_struct_app_214_t) CREF(aux_3687))->value_approx_19);
		      }
		      {
			 obj_t arg2054_3449;
			 arg2054_3449 = make_fx_procedure(arg20542342_cfa_struct, ((long) 1), ((long) 1));
			 PROCEDURE_SET(arg2054_3449, ((long) 0), cowner_2119);
			 return for_each_approx_alloc_83_cfa_approx(arg2054_3449, arg2055_2143);
		      }
		   }
	      }
	   }
      }
   }
}


obj_t 
arg20502341_cfa_struct(obj_t env_3474, obj_t alloc_3475)
{
   {
      obj_t alloc_2138;
      alloc_2138 = alloc_3475;
      return stack_loose_alloc__95_cfa_loose((node_t) (alloc_2138), CNST_TABLE_REF(((long) 1)));
   }
}


obj_t 
arg20542342_cfa_struct(obj_t env_3476, obj_t alloc_3478)
{
   {
      obj_t cowner_3477;
      cowner_3477 = PROCEDURE_REF(env_3476, ((long) 0));
      {
	 obj_t alloc_2144;
	 alloc_2144 = alloc_3478;
	 return stack_loose_alloc__95_cfa_loose((node_t) (alloc_2144), cowner_3477);
      }
   }
}


obj_t 
loose_alloc__make_struct_app2343_217_cfa_struct(obj_t env_3479, obj_t alloc_3480)
{
   {
      make_struct_app_214_t alloc_2098;
      alloc_2098 = (make_struct_app_214_t) (alloc_3480);
      {
	 bool_t test2018_2102;
	 {
	    long arg2032_2115;
	    {
	       obj_t aux_3702;
	       {
		  object_t aux_3703;
		  aux_3703 = (object_t) (alloc_2098);
		  aux_3702 = OBJECT_WIDENING(aux_3703);
	       }
	       arg2032_2115 = (((make_struct_app_214_t) CREF(aux_3702))->lost_stamp_114);
	    }
	    {
	       long n2_3056;
	       n2_3056 = (long) CINT(__cfa_stamp__16_cfa_iterate);
	       test2018_2102 = (arg2032_2115 == n2_3056);
	    }
	 }
	 if (test2018_2102)
	   {
	      return BUNSPEC;
	   }
	 else
	   {
	      {
		 bool_t test2019_2103;
		 {
		    obj_t aux_3710;
		    aux_3710 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
		    test2019_2103 = CBOOL(aux_3710);
		 }
		 if (test2019_2103)
		   {
		      obj_t arg2021_2105;
		      arg2021_2105 = shape_tools_shape((obj_t) (alloc_2098));
		      {
			 obj_t list2022_2106;
			 {
			    obj_t arg2023_2107;
			    {
			       obj_t arg2025_2108;
			       {
				  obj_t aux_3718;
				  aux_3718 = BCHAR(((unsigned char) '\n'));
				  arg2025_2108 = MAKE_PAIR(aux_3718, BNIL);
			       }
			       arg2023_2107 = MAKE_PAIR(arg2021_2105, arg2025_2108);
			    }
			    list2022_2106 = MAKE_PAIR(string2375_cfa_struct, arg2023_2107);
			 }
			 print_trace_107_tools_trace(list2022_2106);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	      {
		 obj_t res2330_3059;
		 {
		    long val1844_3058;
		    val1844_3058 = (long) CINT(__cfa_stamp__16_cfa_iterate);
		    {
		       obj_t x_3516;
		       {
			  obj_t aux_3725;
			  {
			     object_t aux_3726;
			     aux_3726 = (object_t) (alloc_2098);
			     aux_3725 = OBJECT_WIDENING(aux_3726);
			  }
			  x_3516 = ((((make_struct_app_214_t) CREF(aux_3725))->lost_stamp_114) = ((long) val1844_3058), BUNSPEC);
		       }
		       res2330_3059 = BUNSPEC;
		    }
		 }
		 res2330_3059;
	      }
	      {
		 obj_t res2331_3062;
		 {
		    obj_t x_3517;
		    {
		       obj_t aux_3730;
		       {
			  object_t aux_3731;
			  aux_3731 = (object_t) (alloc_2098);
			  aux_3730 = OBJECT_WIDENING(aux_3731);
		       }
		       x_3517 = ((((make_struct_app_214_t) CREF(aux_3730))->stackable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		    }
		    res2331_3062 = BUNSPEC;
		 }
		 res2331_3062;
	      }
	      {
		 approx_t aux_3735;
		 {
		    obj_t aux_3736;
		    {
		       object_t aux_3737;
		       aux_3737 = (object_t) (alloc_2098);
		       aux_3736 = OBJECT_WIDENING(aux_3737);
		    }
		    aux_3735 = (((make_struct_app_214_t) CREF(aux_3736))->value_approx_19);
		 }
		 for_each_approx_alloc_83_cfa_approx(loose_alloc__env_83_cfa_loose, aux_3735);
	      }
	      {
		 approx_t aux_3742;
		 {
		    obj_t aux_3743;
		    {
		       object_t aux_3744;
		       aux_3744 = (object_t) (alloc_2098);
		       aux_3743 = OBJECT_WIDENING(aux_3744);
		    }
		    aux_3742 = (((make_struct_app_214_t) CREF(aux_3743))->value_approx_19);
		 }
		 approx_set_type__239_cfa_approx(aux_3742, (type_t) (__obj__252_type_cache));
	      }
	      {
		 approx_t aux_3750;
		 {
		    obj_t aux_3751;
		    {
		       object_t aux_3752;
		       aux_3752 = (object_t) (alloc_2098);
		       aux_3751 = OBJECT_WIDENING(aux_3752);
		    }
		    aux_3750 = (((make_struct_app_214_t) CREF(aux_3751))->value_approx_19);
		 }
		 return approx_set_top__187_cfa_approx(aux_3750);
	      }
	   }
      }
   }
}


obj_t 
cfa__struct_set__app2344_61_cfa_struct(obj_t env_3481, obj_t node_3482)
{
   {
      struct_set__app_162_t node_2066;
      {
	 approx_t aux_3758;
	 node_2066 = (struct_set__app_162_t) (node_3482);
	 {
	    node_t aux_3759;
	    {
	       obj_t aux_3760;
	       {
		  obj_t aux_3761;
		  {
		     obj_t aux_3762;
		     {
			app_t obj_3036;
			obj_3036 = (app_t) (node_2066);
			aux_3762 = (((app_t) CREF(obj_3036))->args);
		     }
		     aux_3761 = CDR(aux_3762);
		  }
		  aux_3760 = CAR(aux_3761);
	       }
	       aux_3759 = (node_t) (aux_3760);
	    }
	    cfa__102_cfa_cfa(aux_3759);
	 }
	 {
	    approx_t struct_approx_51_2072;
	    approx_t val_approx_22_2073;
	    {
	       node_t aux_3769;
	       {
		  obj_t aux_3770;
		  {
		     obj_t aux_3771;
		     {
			app_t obj_3041;
			obj_3041 = (app_t) (node_2066);
			aux_3771 = (((app_t) CREF(obj_3041))->args);
		     }
		     aux_3770 = CAR(aux_3771);
		  }
		  aux_3769 = (node_t) (aux_3770);
	       }
	       struct_approx_51_2072 = cfa__102_cfa_cfa(aux_3769);
	    }
	    {
	       node_t aux_3777;
	       {
		  obj_t aux_3778;
		  {
		     obj_t aux_3779;
		     {
			obj_t aux_3780;
			{
			   obj_t aux_3781;
			   {
			      app_t obj_3043;
			      obj_3043 = (app_t) (node_2066);
			      aux_3781 = (((app_t) CREF(obj_3043))->args);
			   }
			   aux_3780 = CDR(aux_3781);
			}
			aux_3779 = CDR(aux_3780);
		     }
		     aux_3778 = CAR(aux_3779);
		  }
		  aux_3777 = (node_t) (aux_3778);
	       }
	       val_approx_22_2073 = cfa__102_cfa_cfa(aux_3777);
	    }
	    {
	       bool_t test1997_2074;
	       {
		  obj_t aux_3789;
		  aux_3789 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
		  test1997_2074 = CBOOL(aux_3789);
	       }
	       if (test1997_2074)
		 {
		    obj_t arg1999_2076;
		    arg1999_2076 = shape_tools_shape((obj_t) (node_2066));
		    {
		       obj_t list2000_2077;
		       {
			  obj_t arg2001_2078;
			  {
			     obj_t arg2002_2079;
			     {
				obj_t aux_3797;
				aux_3797 = BCHAR(((unsigned char) '\n'));
				arg2002_2079 = MAKE_PAIR(aux_3797, BNIL);
			     }
			     arg2001_2078 = MAKE_PAIR(arg1999_2076, arg2002_2079);
			  }
			  list2000_2077 = MAKE_PAIR(string2376_cfa_struct, arg2001_2078);
		       }
		       print_trace_107_tools_trace(list2000_2077);
		    }
		 }
	       else
		 {
		    BUNSPEC;
		 }
	    }
	    if ((((approx_t) CREF(struct_approx_51_2072))->top__138))
	      {
		 approx_t aux_3805;
		 aux_3805 = loose__226_cfa_loose(val_approx_22_2073, CNST_TABLE_REF(((long) 1)));
		 (obj_t) (aux_3805);
	      }
	    else
	      {
		 obj_t arg2008_3454;
		 arg2008_3454 = make_fx_procedure(arg20082345_cfa_struct, ((long) 1), ((long) 1));
		 {
		    obj_t aux_3810;
		    aux_3810 = (obj_t) (val_approx_22_2073);
		    PROCEDURE_SET(arg2008_3454, ((long) 0), aux_3810);
		 }
		 for_each_approx_alloc_83_cfa_approx(arg2008_3454, struct_approx_51_2072);
	      }
	 }
	 {
	    obj_t aux_3814;
	    {
	       object_t aux_3815;
	       aux_3815 = (object_t) (node_2066);
	       aux_3814 = OBJECT_WIDENING(aux_3815);
	    }
	    aux_3758 = (((struct_set__app_162_t) CREF(aux_3814))->approx);
	 }
	 return (obj_t) (aux_3758);
      }
   }
}


obj_t 
arg20082345_cfa_struct(obj_t env_3483, obj_t app_3485)
{
   {
      obj_t val_approx_22_3484;
      val_approx_22_3484 = PROCEDURE_REF(env_3483, ((long) 0));
      {
	 obj_t app_2086;
	 app_2086 = app_3485;
	 {
	    bool_t test2010_2088;
	    test2010_2088 = is_a__118___object(app_2086, make_struct_app_214_cfa_info);
	    if (test2010_2088)
	      {
		 approx_t aux_3824;
		 {
		    approx_t aux_3825;
		    {
		       make_struct_app_214_t obj_3052;
		       obj_3052 = (make_struct_app_214_t) (app_2086);
		       {
			  obj_t aux_3827;
			  {
			     object_t aux_3828;
			     aux_3828 = (object_t) (obj_3052);
			     aux_3827 = OBJECT_WIDENING(aux_3828);
			  }
			  aux_3825 = (((make_struct_app_214_t) CREF(aux_3827))->value_approx_19);
		       }
		    }
		    aux_3824 = union_approx__241_cfa_approx(aux_3825, (approx_t) (val_approx_22_3484));
		 }
		 return (obj_t) (aux_3824);
	      }
	    else
	      {
		 return BUNSPEC;
	      }
	 }
      }
   }
}


obj_t 
cfa__struct_ref_app2346_149_cfa_struct(obj_t env_3486, obj_t node_3487)
{
   {
      struct_ref_app_73_t node_2033;
      {
	 approx_t aux_3835;
	 node_2033 = (struct_ref_app_73_t) (node_3487);
	 {
	    node_t aux_3836;
	    {
	       obj_t aux_3837;
	       {
		  obj_t aux_3838;
		  {
		     obj_t aux_3839;
		     {
			app_t obj_3020;
			obj_3020 = (app_t) (node_2033);
			aux_3839 = (((app_t) CREF(obj_3020))->args);
		     }
		     aux_3838 = CDR(aux_3839);
		  }
		  aux_3837 = CAR(aux_3838);
	       }
	       aux_3836 = (node_t) (aux_3837);
	    }
	    cfa__102_cfa_cfa(aux_3836);
	 }
	 {
	    approx_t struct_approx_51_2039;
	    {
	       node_t aux_3846;
	       {
		  obj_t aux_3847;
		  {
		     obj_t aux_3848;
		     {
			app_t obj_3025;
			obj_3025 = (app_t) (node_2033);
			aux_3848 = (((app_t) CREF(obj_3025))->args);
		     }
		     aux_3847 = CAR(aux_3848);
		  }
		  aux_3846 = (node_t) (aux_3847);
	       }
	       struct_approx_51_2039 = cfa__102_cfa_cfa(aux_3846);
	    }
	    {
	       bool_t test1972_2040;
	       {
		  obj_t aux_3854;
		  aux_3854 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
		  test1972_2040 = CBOOL(aux_3854);
	       }
	       if (test1972_2040)
		 {
		    obj_t arg1974_2042;
		    arg1974_2042 = shape_tools_shape((obj_t) (node_2033));
		    {
		       obj_t list1975_2043;
		       {
			  obj_t arg1976_2044;
			  {
			     obj_t arg1977_2045;
			     {
				obj_t aux_3862;
				aux_3862 = BCHAR(((unsigned char) '\n'));
				arg1977_2045 = MAKE_PAIR(aux_3862, BNIL);
			     }
			     arg1976_2044 = MAKE_PAIR(arg1974_2042, arg1977_2045);
			  }
			  list1975_2043 = MAKE_PAIR(string2377_cfa_struct, arg1976_2044);
		       }
		       print_trace_107_tools_trace(list1975_2043);
		    }
		 }
	       else
		 {
		    BUNSPEC;
		 }
	    }
	    if ((((approx_t) CREF(struct_approx_51_2039))->top__138))
	      {
		 approx_t aux_3870;
		 {
		    obj_t aux_3871;
		    {
		       object_t aux_3872;
		       aux_3872 = (object_t) (node_2033);
		       aux_3871 = OBJECT_WIDENING(aux_3872);
		    }
		    aux_3870 = (((struct_ref_app_73_t) CREF(aux_3871))->approx);
		 }
		 approx_set_top__187_cfa_approx(aux_3870);
	      }
	    else
	      {
		 BUNSPEC;
	      }
	    {
	       obj_t arg1983_3456;
	       arg1983_3456 = make_fx_procedure(arg19832347_cfa_struct, ((long) 1), ((long) 1));
	       {
		  obj_t aux_3878;
		  aux_3878 = (obj_t) (node_2033);
		  PROCEDURE_SET(arg1983_3456, ((long) 0), aux_3878);
	       }
	       for_each_approx_alloc_83_cfa_approx(arg1983_3456, struct_approx_51_2039);
	    }
	 }
	 {
	    obj_t aux_3882;
	    {
	       object_t aux_3883;
	       aux_3883 = (object_t) (node_2033);
	       aux_3882 = OBJECT_WIDENING(aux_3883);
	    }
	    aux_3835 = (((struct_ref_app_73_t) CREF(aux_3882))->approx);
	 }
	 return (obj_t) (aux_3835);
      }
   }
}


obj_t 
arg19832347_cfa_struct(obj_t env_3488, obj_t app_3490)
{
   {
      obj_t instance1880_3489;
      instance1880_3489 = PROCEDURE_REF(env_3488, ((long) 0));
      {
	 obj_t app_2052;
	 app_2052 = app_3490;
	 {
	    bool_t test1985_2054;
	    test1985_2054 = is_a__118___object(app_2052, make_struct_app_214_cfa_info);
	    if (test1985_2054)
	      {
		 {
		    approx_t aux_3899;
		    approx_t aux_3892;
		    {
		       make_struct_app_214_t obj_3031;
		       obj_3031 = (make_struct_app_214_t) (app_2052);
		       {
			  obj_t aux_3901;
			  {
			     object_t aux_3902;
			     aux_3902 = (object_t) (obj_3031);
			     aux_3901 = OBJECT_WIDENING(aux_3902);
			  }
			  aux_3899 = (((make_struct_app_214_t) CREF(aux_3901))->value_approx_19);
		       }
		    }
		    {
		       struct_ref_app_73_t obj_3030;
		       obj_3030 = (struct_ref_app_73_t) (instance1880_3489);
		       {
			  obj_t aux_3894;
			  {
			     object_t aux_3895;
			     aux_3895 = (object_t) (obj_3030);
			     aux_3894 = OBJECT_WIDENING(aux_3895);
			  }
			  aux_3892 = (((struct_ref_app_73_t) CREF(aux_3894))->approx);
		       }
		    }
		    union_approx__241_cfa_approx(aux_3892, aux_3899);
		 }
		 {
		    type_t aux_3914;
		    approx_t aux_3907;
		    {
		       approx_t arg1990_2060;
		       {
			  struct_ref_app_73_t obj_3033;
			  obj_3033 = (struct_ref_app_73_t) (instance1880_3489);
			  {
			     obj_t aux_3916;
			     {
				object_t aux_3917;
				aux_3917 = (object_t) (obj_3033);
				aux_3916 = OBJECT_WIDENING(aux_3917);
			     }
			     arg1990_2060 = (((struct_ref_app_73_t) CREF(aux_3916))->approx);
			  }
		       }
		       aux_3914 = (((approx_t) CREF(arg1990_2060))->type);
		    }
		    {
		       make_struct_app_214_t obj_3032;
		       obj_3032 = (make_struct_app_214_t) (app_2052);
		       {
			  obj_t aux_3909;
			  {
			     object_t aux_3910;
			     aux_3910 = (object_t) (obj_3032);
			     aux_3909 = OBJECT_WIDENING(aux_3910);
			  }
			  aux_3907 = (((make_struct_app_214_t) CREF(aux_3909))->value_approx_19);
		       }
		    }
		    return approx_set_type__239_cfa_approx(aux_3907, aux_3914);
		 }
	      }
	    else
	      {
		 return BUNSPEC;
	      }
	 }
      }
   }
}


obj_t 
cfa__make_struct_app2348_235_cfa_struct(obj_t env_3491, obj_t node_3492)
{
   {
      make_struct_app_214_t node_2012;
      {
	 approx_t aux_3923;
	 node_2012 = (make_struct_app_214_t) (node_3492);
	 {
	    bool_t test1951_2016;
	    {
	       obj_t aux_3924;
	       aux_3924 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
	       test1951_2016 = CBOOL(aux_3924);
	    }
	    if (test1951_2016)
	      {
		 obj_t arg1953_2018;
		 arg1953_2018 = shape_tools_shape((obj_t) (node_2012));
		 {
		    obj_t list1954_2019;
		    {
		       obj_t arg1956_2020;
		       {
			  obj_t arg1957_2021;
			  {
			     obj_t aux_3932;
			     aux_3932 = BCHAR(((unsigned char) '\n'));
			     arg1957_2021 = MAKE_PAIR(aux_3932, BNIL);
			  }
			  arg1956_2020 = MAKE_PAIR(arg1953_2018, arg1957_2021);
		       }
		       list1954_2019 = MAKE_PAIR(string2378_cfa_struct, arg1956_2020);
		    }
		    print_trace_107_tools_trace(list1954_2019);
		 }
	      }
	    else
	      {
		 BUNSPEC;
	      }
	 }
	 {
	    node_t aux_3938;
	    {
	       obj_t aux_3939;
	       {
		  obj_t aux_3940;
		  {
		     app_t obj_3011;
		     obj_3011 = (app_t) (node_2012);
		     aux_3940 = (((app_t) CREF(obj_3011))->args);
		  }
		  aux_3939 = CAR(aux_3940);
	       }
	       aux_3938 = (node_t) (aux_3939);
	    }
	    cfa__102_cfa_cfa(aux_3938);
	 }
	 {
	    approx_t init_value_approx_9_2027;
	    {
	       node_t aux_3946;
	       {
		  obj_t aux_3947;
		  {
		     obj_t aux_3948;
		     {
			obj_t aux_3949;
			{
			   app_t obj_3013;
			   obj_3013 = (app_t) (node_2012);
			   aux_3949 = (((app_t) CREF(obj_3013))->args);
			}
			aux_3948 = CDR(aux_3949);
		     }
		     aux_3947 = CAR(aux_3948);
		  }
		  aux_3946 = (node_t) (aux_3947);
	       }
	       init_value_approx_9_2027 = cfa__102_cfa_cfa(aux_3946);
	    }
	    {
	       approx_t aux_3956;
	       {
		  obj_t aux_3957;
		  {
		     object_t aux_3958;
		     aux_3958 = (object_t) (node_2012);
		     aux_3957 = OBJECT_WIDENING(aux_3958);
		  }
		  aux_3956 = (((make_struct_app_214_t) CREF(aux_3957))->value_approx_19);
	       }
	       union_approx__241_cfa_approx(aux_3956, init_value_approx_9_2027);
	    }
	    {
	       obj_t aux_3963;
	       {
		  object_t aux_3964;
		  aux_3964 = (object_t) (node_2012);
		  aux_3963 = OBJECT_WIDENING(aux_3964);
	       }
	       aux_3923 = (((make_struct_app_214_t) CREF(aux_3963))->approx);
	    }
	 }
	 return (obj_t) (aux_3923);
      }
   }
}


obj_t 
node_setup__pre_struct_set__app2349_164_cfa_struct(obj_t env_3493, obj_t node_3494)
{
   {
      pre_struct_set__app_116_t node_1996;
      {
	 struct_set__app_162_t aux_3970;
	 node_1996 = (pre_struct_set__app_116_t) (node_3494);
	 {
	    obj_t aux_3971;
	    {
	       app_t obj_2993;
	       obj_2993 = (app_t) (node_1996);
	       aux_3971 = (((app_t) CREF(obj_2993))->args);
	    }
	    node_setup___185_cfa_setup(aux_3971);
	 }
	 {
	    pre_struct_set__app_116_t node_2001;
	    {
	       long arg1947_2007;
	       {
		  obj_t arg1948_2008;
		  {
		     obj_t arg1949_2009;
		     {
			object_t object_2994;
			object_2994 = (object_t) (node_1996);
			{
			   long arg1187_2995;
			   {
			      long arg1188_2996;
			      long arg1189_2997;
			      arg1188_2996 = TYPE(object_2994);
			      arg1189_2997 = OBJECT_TYPE;
			      arg1187_2995 = (arg1188_2996 - arg1189_2997);
			   }
			   {
			      obj_t vector_3001;
			      vector_3001 = __classes__134___object;
			      arg1949_2009 = VECTOR_REF(vector_3001, arg1187_2995);
			   }
			}
		     }
		     arg1948_2008 = class_super_145___object(arg1949_2009);
		  }
		  arg1947_2007 = class_num_218___object(arg1948_2008);
	       }
	       {
		  obj_t obj_3003;
		  obj_3003 = (obj_t) (node_1996);
		  (((obj_t) CREF(obj_3003))->header = MAKE_HEADER(arg1947_2007, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_3984;
	       aux_3984 = (object_t) (node_1996);
	       OBJECT_WIDENING_SET(aux_3984, BFALSE);
	    }
	    node_2001 = node_1996;
	    {
	       struct_set__app_162_t obj1878_2002;
	       obj1878_2002 = ((struct_set__app_162_t) (node_2001));
	       {
		  struct_set__app_162_t arg1943_2003;
		  {
		     approx_t arg1944_2004;
		     arg1944_2004 = make_type_approx_184_cfa_approx((type_t) (__unspec__87_type_cache));
		     {
			struct_set__app_162_t res2329_3008;
			{
			   struct_set__app_162_t new1860_3006;
			   new1860_3006 = ((struct_set__app_162_t) BREF(GC_MALLOC(sizeof(struct struct_set__app_162))));
			   ((((struct_set__app_162_t) CREF(new1860_3006))->approx) = ((approx_t) arg1944_2004), BUNSPEC);
			   res2329_3008 = new1860_3006;
			}
			arg1943_2003 = res2329_3008;
		     }
		  }
		  {
		     obj_t aux_3994;
		     object_t aux_3992;
		     aux_3994 = (obj_t) (arg1943_2003);
		     aux_3992 = (object_t) (obj1878_2002);
		     OBJECT_WIDENING_SET(aux_3992, aux_3994);
		  }
	       }
	       {
		  long arg1945_2005;
		  arg1945_2005 = class_num_218___object(struct_set__app_162_cfa_info);
		  {
		     obj_t obj_3009;
		     obj_3009 = (obj_t) (obj1878_2002);
		     (((obj_t) CREF(obj_3009))->header = MAKE_HEADER(arg1945_2005, 0), BUNSPEC);
		  }
	       }
	       aux_3970 = obj1878_2002;
	    }
	 }
	 return (obj_t) (aux_3970);
      }
   }
}


obj_t 
node_setup__pre_struct_ref_app2350_249_cfa_struct(obj_t env_3495, obj_t node_3496)
{
   {
      pre_struct_ref_app_207_t node_1980;
      {
	 struct_ref_app_73_t aux_4002;
	 node_1980 = (pre_struct_ref_app_207_t) (node_3496);
	 {
	    obj_t aux_4003;
	    {
	       app_t obj_2975;
	       obj_2975 = (app_t) (node_1980);
	       aux_4003 = (((app_t) CREF(obj_2975))->args);
	    }
	    node_setup___185_cfa_setup(aux_4003);
	 }
	 {
	    pre_struct_ref_app_207_t node_1985;
	    {
	       long arg1938_1991;
	       {
		  obj_t arg1939_1992;
		  {
		     obj_t arg1940_1993;
		     {
			object_t object_2976;
			object_2976 = (object_t) (node_1980);
			{
			   long arg1187_2977;
			   {
			      long arg1188_2978;
			      long arg1189_2979;
			      arg1188_2978 = TYPE(object_2976);
			      arg1189_2979 = OBJECT_TYPE;
			      arg1187_2977 = (arg1188_2978 - arg1189_2979);
			   }
			   {
			      obj_t vector_2983;
			      vector_2983 = __classes__134___object;
			      arg1940_1993 = VECTOR_REF(vector_2983, arg1187_2977);
			   }
			}
		     }
		     arg1939_1992 = class_super_145___object(arg1940_1993);
		  }
		  arg1938_1991 = class_num_218___object(arg1939_1992);
	       }
	       {
		  obj_t obj_2985;
		  obj_2985 = (obj_t) (node_1980);
		  (((obj_t) CREF(obj_2985))->header = MAKE_HEADER(arg1938_1991, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_4016;
	       aux_4016 = (object_t) (node_1980);
	       OBJECT_WIDENING_SET(aux_4016, BFALSE);
	    }
	    node_1985 = node_1980;
	    {
	       struct_ref_app_73_t obj1875_1986;
	       obj1875_1986 = ((struct_ref_app_73_t) (node_1985));
	       {
		  struct_ref_app_73_t arg1935_1987;
		  {
		     approx_t arg1936_1988;
		     arg1936_1988 = make_type_approx_184_cfa_approx((type_t) (__obj__252_type_cache));
		     {
			struct_ref_app_73_t res2328_2990;
			{
			   struct_ref_app_73_t new1849_2988;
			   new1849_2988 = ((struct_ref_app_73_t) BREF(GC_MALLOC(sizeof(struct struct_ref_app_73))));
			   ((((struct_ref_app_73_t) CREF(new1849_2988))->approx) = ((approx_t) arg1936_1988), BUNSPEC);
			   res2328_2990 = new1849_2988;
			}
			arg1935_1987 = res2328_2990;
		     }
		  }
		  {
		     obj_t aux_4026;
		     object_t aux_4024;
		     aux_4026 = (obj_t) (arg1935_1987);
		     aux_4024 = (object_t) (obj1875_1986);
		     OBJECT_WIDENING_SET(aux_4024, aux_4026);
		  }
	       }
	       {
		  long arg1937_1989;
		  arg1937_1989 = class_num_218___object(struct_ref_app_73_cfa_info);
		  {
		     obj_t obj_2991;
		     obj_2991 = (obj_t) (obj1875_1986);
		     (((obj_t) CREF(obj_2991))->header = MAKE_HEADER(arg1937_1989, 0), BUNSPEC);
		  }
	       }
	       aux_4002 = obj1875_1986;
	    }
	 }
	 return (obj_t) (aux_4002);
      }
   }
}


obj_t 
node_setup__pre_make_struct_app2351_10_cfa_struct(obj_t env_3497, obj_t node_3498)
{
   {
      pre_make_struct_app_218_t node_1944;
      node_1944 = (pre_make_struct_app_218_t) (node_3498);
      {
	 obj_t aux_4034;
	 {
	    app_t obj_2940;
	    obj_2940 = (app_t) (node_1944);
	    aux_4034 = (((app_t) CREF(obj_2940))->args);
	 }
	 node_setup___185_cfa_setup(aux_4034);
      }
      {
	 obj_t key_1949;
	 {
	    obj_t aux_4038;
	    {
	       object_t aux_4039;
	       aux_4039 = (object_t) (node_1944);
	       aux_4038 = OBJECT_WIDENING(aux_4039);
	    }
	    key_1949 = (((pre_make_struct_app_218_t) CREF(aux_4038))->key);
	 }
	 {
	    variable_t owner_1950;
	    {
	       obj_t aux_4043;
	       {
		  object_t aux_4044;
		  aux_4044 = (object_t) (node_1944);
		  aux_4043 = OBJECT_WIDENING(aux_4044);
	       }
	       owner_1950 = (((pre_make_struct_app_218_t) CREF(aux_4043))->owner);
	    }
	    {
	       pre_make_struct_app_218_t node_1951;
	       {
		  long arg1929_1975;
		  {
		     obj_t arg1931_1976;
		     {
			obj_t arg1932_1977;
			{
			   object_t object_2943;
			   object_2943 = (object_t) (node_1944);
			   {
			      long arg1187_2944;
			      {
				 long arg1188_2945;
				 long arg1189_2946;
				 arg1188_2945 = TYPE(object_2943);
				 arg1189_2946 = OBJECT_TYPE;
				 arg1187_2944 = (arg1188_2945 - arg1189_2946);
			      }
			      {
				 obj_t vector_2950;
				 vector_2950 = __classes__134___object;
				 arg1932_1977 = VECTOR_REF(vector_2950, arg1187_2944);
			      }
			   }
			}
			arg1931_1976 = class_super_145___object(arg1932_1977);
		     }
		     arg1929_1975 = class_num_218___object(arg1931_1976);
		  }
		  {
		     obj_t obj_2952;
		     obj_2952 = (obj_t) (node_1944);
		     (((obj_t) CREF(obj_2952))->header = MAKE_HEADER(arg1929_1975, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_4057;
		  aux_4057 = (object_t) (node_1944);
		  OBJECT_WIDENING_SET(aux_4057, BFALSE);
	       }
	       node_1951 = node_1944;
	       {
		  {
		     make_struct_app_214_t wnode_1952;
		     {
			make_struct_app_214_t obj1872_1967;
			obj1872_1967 = ((make_struct_app_214_t) (node_1951));
			{
			   make_struct_app_214_t arg1922_1968;
			   {
			      approx_t arg1923_1969;
			      approx_t arg1925_1970;
			      arg1923_1969 = make_empty_approx_131_cfa_approx();
			      arg1925_1970 = make_empty_approx_131_cfa_approx();
			      {
				 make_struct_app_214_t res2326_2969;
				 {
				    make_struct_app_214_t new1834_2961;
				    new1834_2961 = ((make_struct_app_214_t) BREF(GC_MALLOC(sizeof(struct make_struct_app_214))));
				    ((((make_struct_app_214_t) CREF(new1834_2961))->key) = ((obj_t) key_1949), BUNSPEC);
				    ((((make_struct_app_214_t) CREF(new1834_2961))->approx) = ((approx_t) arg1923_1969), BUNSPEC);
				    ((((make_struct_app_214_t) CREF(new1834_2961))->value_approx_19) = ((approx_t) arg1925_1970), BUNSPEC);
				    ((((make_struct_app_214_t) CREF(new1834_2961))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
				    ((((make_struct_app_214_t) CREF(new1834_2961))->owner) = ((variable_t) owner_1950), BUNSPEC);
				    ((((make_struct_app_214_t) CREF(new1834_2961))->stackable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				    ((((make_struct_app_214_t) CREF(new1834_2961))->stack_stamp_31) = ((obj_t) BNIL), BUNSPEC);
				    res2326_2969 = new1834_2961;
				 }
				 arg1922_1968 = res2326_2969;
			      }
			   }
			   {
			      obj_t aux_4073;
			      object_t aux_4071;
			      aux_4073 = (obj_t) (arg1922_1968);
			      aux_4071 = (object_t) (obj1872_1967);
			      OBJECT_WIDENING_SET(aux_4071, aux_4073);
			   }
			}
			{
			   long arg1928_1973;
			   arg1928_1973 = class_num_218___object(make_struct_app_214_cfa_info);
			   {
			      obj_t obj_2970;
			      obj_2970 = (obj_t) (obj1872_1967);
			      (((obj_t) CREF(obj_2970))->header = MAKE_HEADER(arg1928_1973, 0), BUNSPEC);
			   }
			}
			wnode_1952 = obj1872_1967;
		     }
		     {
			bool_t test1905_1953;
			{
			   obj_t aux_4079;
			   aux_4079 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
			   test1905_1953 = CBOOL(aux_4079);
			}
			if (test1905_1953)
			  {
			     obj_t arg1907_1955;
			     arg1907_1955 = shape_tools_shape((obj_t) (node_1951));
			     {
				obj_t list1909_1957;
				{
				   obj_t arg1911_1958;
				   {
				      obj_t arg1912_1959;
				      {
					 obj_t arg1913_1960;
					 {
					    obj_t arg1914_1961;
					    {
					       obj_t arg1915_1962;
					       {
						  obj_t aux_4087;
						  aux_4087 = BCHAR(((unsigned char) '\n'));
						  arg1915_1962 = MAKE_PAIR(aux_4087, BNIL);
					       }
					       arg1914_1961 = MAKE_PAIR(key_1949, arg1915_1962);
					    }
					    arg1913_1960 = MAKE_PAIR(string2379_cfa_struct, arg1914_1961);
					 }
					 {
					    obj_t aux_4092;
					    aux_4092 = BCHAR(((unsigned char) '\n'));
					    arg1912_1959 = MAKE_PAIR(aux_4092, arg1913_1960);
					 }
				      }
				      arg1911_1958 = MAKE_PAIR(arg1907_1955, arg1912_1959);
				   }
				   list1909_1957 = MAKE_PAIR(string2380_cfa_struct, arg1911_1958);
				}
				print_trace_107_tools_trace(list1909_1957);
			     }
			  }
			else
			  {
			     BUNSPEC;
			  }
		     }
		     {
			approx_t arg1921_1966;
			arg1921_1966 = make_type_alloc_approx_134_cfa_approx((type_t) (__struct__183_type_cache), (node_t) (node_1951));
			{
			   obj_t res2327_2974;
			   {
			      obj_t x_3518;
			      {
				 obj_t aux_4101;
				 {
				    object_t aux_4102;
				    aux_4102 = (object_t) (wnode_1952);
				    aux_4101 = OBJECT_WIDENING(aux_4102);
				 }
				 x_3518 = ((((make_struct_app_214_t) CREF(aux_4101))->approx) = ((approx_t) arg1921_1966), BUNSPEC);
			      }
			      res2327_2974 = BUNSPEC;
			   }
			   return res2327_2974;
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
imported_modules_init_94_cfa_struct()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_STRUCT");
   module_initialization_70_tools_error(((long) 0), "CFA_STRUCT");
   module_initialization_70_tools_shape(((long) 0), "CFA_STRUCT");
   module_initialization_70_type_type(((long) 0), "CFA_STRUCT");
   module_initialization_70_type_cache(((long) 0), "CFA_STRUCT");
   module_initialization_70_ast_var(((long) 0), "CFA_STRUCT");
   module_initialization_70_ast_node(((long) 0), "CFA_STRUCT");
   module_initialization_70_cfa_info(((long) 0), "CFA_STRUCT");
   module_initialization_70_cfa_loose(((long) 0), "CFA_STRUCT");
   module_initialization_70_cfa_iterate(((long) 0), "CFA_STRUCT");
   module_initialization_70_cfa_cfa(((long) 0), "CFA_STRUCT");
   module_initialization_70_cfa_setup(((long) 0), "CFA_STRUCT");
   module_initialization_70_cfa_approx(((long) 0), "CFA_STRUCT");
   return module_initialization_70_cfa_stack(((long) 0), "CFA_STRUCT");
}
