/*===========================================================================*/
/*   (Cfa/tvector.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct tvec
  {
     struct type *item_type_130;
  }
    *tvec_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_t;


extern obj_t _tvector_optimization__242_cfa_tvector(obj_t);
extern obj_t let_fun_218_ast_node;
extern obj_t type_type_type;
static obj_t get_vector_item_type_default1949_191_cfa_tvector(app_t);
static obj_t patch_fun__141_cfa_tvector(obj_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
static obj_t get_tvectors_38_cfa_tvector();
extern type_t get_vector_item_type_88_cfa_tvector(app_t);
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_cfa_tvector();
extern obj_t module_initialization_70_cfa_tvector(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_type(long, char *);
extern obj_t module_initialization_70_module_pragma(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_tvector_tvector(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_build(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_set(long, char *);
extern obj_t module_initialization_70_cfa_type(long, char *);
extern obj_t module_initialization_70_cfa_stack(long, char *);
extern obj_t module_initialization_70_globalize_walk(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_inline_walk(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t toplevel_init_63_cfa_tvector();
static obj_t cnst_init_137_cfa_tvector();
extern obj_t build_ast_sans_remove_93_ast_build(obj_t);
extern obj_t __optim__89_engine_param;
extern obj_t tvector_optimization__143_cfa_tvector();
static obj_t patch_vector___0_cfa_tvector(app_t);
extern obj_t _patch_vector_set__187_cfa_tvector(obj_t);
extern obj_t create_vector_app_150_cfa_info;
extern obj_t cfun_ast_var;
static obj_t __make_vector_list__231_cfa_tvector = BUNSPEC;
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t add_make_vector__104_cfa_tvector(node_t);
static obj_t patch_vector__list__149_cfa_tvector(app_t);
extern obj_t vector__tvector__205_cfa_tvector(obj_t);
extern node_t inline_node_218_inline_inline(node_t, long, obj_t);
static obj_t require_initialization_114_cfa_tvector = BUNSPEC;
static obj_t _patch__77_cfa_tvector(obj_t, obj_t);
extern obj_t var_ast_node;
extern obj_t _get_vector_item_type_42_cfa_tvector(obj_t, obj_t);
extern obj_t __bool__149_type_cache;
extern obj_t tvec_tvector_tvector;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cfa_tvector();
extern obj_t kwote_node_102_cfa_info;
static obj_t declare_tvectors_117_cfa_tvector(obj_t);
extern obj_t inline_setup__219_inline_walk(obj_t);
extern obj_t sfun_ast_var;
extern obj_t _vector__tvector__184_cfa_tvector(obj_t, obj_t);
extern obj_t cast_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t __lib_mode__85_engine_param;
extern obj_t vector_ref_app_195_cfa_info;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
static obj_t patch__default1952_50_cfa_tvector(node_t);
extern obj_t conditional_ast_node;
static obj_t patch__227_cfa_tvector(node_t);
extern obj_t pragma_finalizer_170_module_pragma();
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t unpatch_vector_set__139_cfa_tvector();
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t pragma_ast_node;
static obj_t patch_vector_length__86_cfa_tvector(app_t);
extern obj_t class_super_145___object(obj_t);
extern obj_t __long__149_type_cache;
extern long class_num_218___object(obj_t);
extern obj_t patch_vector_set__231_cfa_tvector();
extern approx_t cfa__102_cfa_cfa(node_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t __vector__240_type_cache;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t set_default_type__106_type_cache(type_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t get_approx_type_210_cfa_type(approx_t);
extern obj_t globalize_walk__63_globalize_walk(obj_t, obj_t);
extern obj_t vector_set__app_21_cfa_info;
extern bool_t sub_type__174_type_env(type_t, type_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static bool_t patch_tree__164_cfa_tvector(obj_t);
extern obj_t setq_ast_node;
extern type_t get_default_type_181_type_cache();
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
static bool_t show_tvector_204_cfa_tvector(obj_t);
extern obj_t set_ex_it_116_ast_node;
extern obj_t _unpatch_vector_set__250_cfa_tvector(obj_t);
static obj_t patch___72_cfa_tvector(obj_t);
extern obj_t kwote_ast_node;
extern obj_t _add_make_vector__56_cfa_tvector(obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _____74_type_cache;
extern obj_t make_vector_app_205_cfa_info;
extern node_t node_heap__stack__239_cfa_stack(app_t, bool_t);
extern obj_t box_ref_242_ast_node;
extern bool_t stack_optimization__133_cfa_stack();
extern obj_t funcall_ast_node;
static obj_t _patch__default1952_121_cfa_tvector(obj_t, obj_t);
extern obj_t tvector_finalizer_246_module_type();
extern obj_t __obj__252_type_cache;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t type_parser_173_module_type(obj_t, obj_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
static obj_t _get_vector_item_type_default1949_224_cfa_tvector(obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
extern obj_t app_ast_node;
static obj_t __cnst[23];

DEFINE_STATIC_GENERIC(patch__env_129_cfa_tvector, _patch__77_cfa_tvector2802, _patch__77_cfa_tvector, 0L, 1);
DEFINE_STRING(string2789_cfa_tvector, string2789_cfa_tvector2803, "   . Vector -> Tvector", 22);
DEFINE_EXPORT_PROCEDURE(tvector_optimization__env_42_cfa_tvector, _tvector_optimization__242_cfa_tvector2804, _tvector_optimization__242_cfa_tvector, 0L, 0);
DEFINE_STATIC_PROCEDURE(patch__default1952_env_210_cfa_tvector, _patch__default1952_121_cfa_tvector2805, _patch__default1952_121_cfa_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector__tvector__env_76_cfa_tvector, _vector__tvector__184_cfa_tvector2806, _vector__tvector__184_cfa_tvector, 0L, 1);
DEFINE_STRING(string2781_cfa_tvector, string2781_cfa_tvector2807, "tvector-optimization! :", 23);
DEFINE_EXPORT_PROCEDURE(add_make_vector__env_5_cfa_tvector, _add_make_vector__56_cfa_tvector2808, _add_make_vector__56_cfa_tvector, 0L, 1);
DEFINE_STRING(string2790_cfa_tvector, string2790_cfa_tvector2809, " -> vector of ", 14);
DEFINE_STRING(string2782_cfa_tvector, string2782_cfa_tvector2810, "--------------------------------------", 38);
DEFINE_STATIC_PROCEDURE(get_vector_item_type_default1949_env_2_cfa_tvector, _get_vector_item_type_default1949_224_cfa_tvector2811, _get_vector_item_type_default1949_224_cfa_tvector, 0L, 1);
DEFINE_STRING(string2793_cfa_tvector, string2793_cfa_tvector2812, "Je patch l'arbre de ", 20);
DEFINE_STRING(string2792_cfa_tvector, string2792_cfa_tvector2813, ": ", 2);
DEFINE_STRING(string2796_cfa_tvector, string2796_cfa_tvector2814, "->LIST -LENGTH DONE -SET! -REF ALLOCATE- VALUE MAKE- __R4_VECTORS_6_8 VECTOR->LIST C-VECTOR-LENGTH A-TVECTOR PATCH!-DEFAULT1952 NO-REMOVE UNIT TVECTOR TV-OF- GET-VECTOR-ITEM-TYPE-DEFAULT1949 ALL CFA VECTOR? C-VECTOR? (VECTOR-SET! C-VECTOR-SET! VECTOR-SET-UR!) ", 260);
DEFINE_EXPORT_PROCEDURE(unpatch_vector_set__env_116_cfa_tvector, _unpatch_vector_set__250_cfa_tvector2815, _unpatch_vector_set__250_cfa_tvector, 0L, 0);
DEFINE_STRING(string2784_cfa_tvector, string2784_cfa_tvector2816, "additional-body: ", 17);
DEFINE_STRING(string2787_cfa_tvector, string2787_cfa_tvector2817, "vector: ", 8);
DEFINE_STRING(string2788_cfa_tvector, string2788_cfa_tvector2818, "No method for this object", 25);
DEFINE_EXPORT_PROCEDURE(patch_vector_set__env_198_cfa_tvector, _patch_vector_set__187_cfa_tvector2819, _patch_vector_set__187_cfa_tvector, 0L, 0);
DEFINE_STRING(string2783_cfa_tvector, string2783_cfa_tvector2820, "tvectors: ", 10);
DEFINE_STRING(string2785_cfa_tvector, string2785_cfa_tvector2821, " ", 1);
DEFINE_STRING(string2795_cfa_tvector, string2795_cfa_tvector2822, "Unexpected closure", 18);
DEFINE_STRING(string2786_cfa_tvector, string2786_cfa_tvector2823, " type: ", 7);
DEFINE_STRING(string2791_cfa_tvector, string2791_cfa_tvector2824, "        vector of ", 18);
DEFINE_STRING(string2794_cfa_tvector, string2794_cfa_tvector2825, "patch!", 6);
DEFINE_EXPORT_GENERIC(get_vector_item_type_env_168_cfa_tvector, _get_vector_item_type_42_cfa_tvector2826, _get_vector_item_type_42_cfa_tvector, 0L, 1);

obj_t 
module_initialization_70_cfa_tvector(long checksum_4414, char *from_4415)
{
   if (CBOOL(require_initialization_114_cfa_tvector))
     {
	require_initialization_114_cfa_tvector = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_tvector();
	cnst_init_137_cfa_tvector();
	imported_modules_init_94_cfa_tvector();
	toplevel_init_63_cfa_tvector();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_tvector()
{
   module_initialization_70___object(((long) 0), "CFA_TVECTOR");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_TVECTOR");
   module_initialization_70___reader(((long) 0), "CFA_TVECTOR");
   module_initialization_70___r4_symbols_6_4(((long) 0), "CFA_TVECTOR");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_tvector()
{
   {
      obj_t cnst_port_138_4406;
      cnst_port_138_4406 = open_input_string(string2796_cfa_tvector);
      {
	 long i_4407;
	 i_4407 = ((long) 22);
       loop_4408:
	 {
	    bool_t test2797_4409;
	    test2797_4409 = (i_4407 == ((long) -1));
	    if (test2797_4409)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2798_4410;
		    {
		       obj_t list2799_4411;
		       {
			  obj_t arg2800_4412;
			  arg2800_4412 = BNIL;
			  list2799_4411 = MAKE_PAIR(cnst_port_138_4406, arg2800_4412);
		       }
		       arg2798_4410 = read___reader(list2799_4411);
		    }
		    CNST_TABLE_SET(i_4407, arg2798_4410);
		 }
		 {
		    int aux_4413;
		    {
		       long aux_4433;
		       aux_4433 = (i_4407 - ((long) 1));
		       aux_4413 = (int) (aux_4433);
		    }
		    {
		       long i_4436;
		       i_4436 = (long) (aux_4413);
		       i_4407 = i_4436;
		       goto loop_4408;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_tvector()
{
   __make_vector_list__231_cfa_tvector = BNIL;
   add_generic__110___object(get_vector_item_type_env_168_cfa_tvector, get_vector_item_type_default1949_env_2_cfa_tvector);
   add_inlined_method__244___object(get_vector_item_type_env_168_cfa_tvector, make_vector_app_205_cfa_info, ((long) 0));
   add_inlined_method__244___object(get_vector_item_type_env_168_cfa_tvector, create_vector_app_150_cfa_info, ((long) 1));
   add_generic__110___object(patch__env_129_cfa_tvector, patch__default1952_env_210_cfa_tvector);
   add_inlined_method__244___object(patch__env_129_cfa_tvector, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, kwote_node_102_cfa_info, ((long) 2));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, var_ast_node, ((long) 3));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, closure_ast_node, ((long) 4));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, sequence_ast_node, ((long) 5));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, app_ly_162_ast_node, ((long) 6));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, funcall_ast_node, ((long) 7));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, pragma_ast_node, ((long) 8));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, cast_ast_node, ((long) 9));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, setq_ast_node, ((long) 10));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, conditional_ast_node, ((long) 11));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, fail_ast_node, ((long) 12));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, select_ast_node, ((long) 13));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, let_fun_218_ast_node, ((long) 14));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, let_var_6_ast_node, ((long) 15));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, set_ex_it_116_ast_node, ((long) 16));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, jump_ex_it_184_ast_node, ((long) 17));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, make_box_202_ast_node, ((long) 18));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, box_set__221_ast_node, ((long) 19));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, box_ref_242_ast_node, ((long) 20));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, app_ast_node, ((long) 21));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, make_vector_app_205_cfa_info, ((long) 22));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, create_vector_app_150_cfa_info, ((long) 23));
   add_inlined_method__244___object(patch__env_129_cfa_tvector, vector_ref_app_195_cfa_info, ((long) 24));
   {
      long aux_4467;
      aux_4467 = add_inlined_method__244___object(patch__env_129_cfa_tvector, vector_set__app_21_cfa_info, ((long) 25));
      return BINT(aux_4467);
   }
}


obj_t 
tvector_optimization__143_cfa_tvector()
{
   {
      bool_t _andtest_1898_2135;
      {
	 long n1_3538;
	 n1_3538 = (long) CINT(__optim__89_engine_param);
	 _andtest_1898_2135 = (n1_3538 >= ((long) 3));
      }
      if (_andtest_1898_2135)
	{
	   if (CBOOL(__lib_mode__85_engine_param))
	     {
		return BFALSE;
	     }
	   else
	     {
		return BTRUE;
	     }
	}
      else
	{
	   return BFALSE;
	}
   }
}


obj_t 
_tvector_optimization__242_cfa_tvector(obj_t env_4365)
{
   return tvector_optimization__143_cfa_tvector();
}


obj_t 
patch_vector_set__231_cfa_tvector()
{
   {
      bool_t test_4476;
      {
	 obj_t aux_4477;
	 aux_4477 = tvector_optimization__143_cfa_tvector();
	 test_4476 = CBOOL(aux_4477);
      }
      if (test_4476)
	{
	   {
	      obj_t l1899_2137;
	      l1899_2137 = CNST_TABLE_REF(((long) 0));
	    lname1900_2138:
	      if (PAIRP(l1899_2137))
		{
		   {
		      obj_t g_2142;
		      g_2142 = find_global_223_ast_env(CAR(l1899_2137), BNIL);
		      {
			 bool_t test2017_2143;
			 test2017_2143 = is_a__118___object(g_2142, global_ast_var);
			 if (test2017_2143)
			   {
			      value_t fun_2144;
			      {
				 global_t obj_3543;
				 obj_3543 = (global_t) (g_2142);
				 fun_2144 = (((global_t) CREF(obj_3543))->value);
			      }
			      {
				 bool_t test2018_2145;
				 test2018_2145 = is_a__118___object((obj_t) (fun_2144), cfun_ast_var);
				 if (test2018_2145)
				   {
				      {
					 obj_t arg2019_2146;
					 type_t arg2020_2147;
					 {
					    obj_t aux_4491;
					    {
					       obj_t aux_4492;
					       {
						  cfun_t obj_3545;
						  obj_3545 = (cfun_t) (fun_2144);
						  aux_4492 = (((cfun_t) CREF(obj_3545))->args_type_205);
					       }
					       aux_4491 = CDR(aux_4492);
					    }
					    arg2019_2146 = CDR(aux_4491);
					 }
					 arg2020_2147 = get_default_type_181_type_cache();
					 {
					    obj_t aux_4498;
					    aux_4498 = (obj_t) (arg2020_2147);
					    SET_CAR(arg2019_2146, aux_4498);
					 }
				      }
				   }
				 else
				   {
				      bool_t test2022_2149;
				      test2022_2149 = is_a__118___object((obj_t) (fun_2144), sfun_ast_var);
				      if (test2022_2149)
					{
					   {
					      obj_t arg2023_2150;
					      type_t arg2025_2151;
					      {
						 obj_t aux_4504;
						 {
						    obj_t aux_4505;
						    {
						       obj_t aux_4506;
						       {
							  sfun_t obj_3553;
							  obj_3553 = (sfun_t) (fun_2144);
							  aux_4506 = (((sfun_t) CREF(obj_3553))->args);
						       }
						       aux_4505 = CDR(aux_4506);
						    }
						    aux_4504 = CDR(aux_4505);
						 }
						 arg2023_2150 = CAR(aux_4504);
					      }
					      arg2025_2151 = get_default_type_181_type_cache();
					      {
						 obj_t res2745_3562;
						 {
						    local_t obj_3560;
						    obj_3560 = (local_t) (arg2023_2150);
						    {
						       obj_t x_4374;
						       x_4374 = ((((local_t) CREF(obj_3560))->type) = ((type_t) arg2025_2151), BUNSPEC);
						       res2745_3562 = BUNSPEC;
						    }
						 }
						 res2745_3562;
					      }
					   }
					}
				      else
					{
					   BFALSE;
					}
				   }
			      }
			   }
			 else
			   {
			      BUNSPEC;
			   }
		      }
		   }
		   {
		      obj_t l1899_4515;
		      l1899_4515 = CDR(l1899_2137);
		      l1899_2137 = l1899_4515;
		      goto lname1900_2138;
		   }
		}
	      else
		{
		   ((bool_t) 1);
		}
	   }
	   {
	      obj_t g_2155;
	      g_2155 = find_global_223_ast_env(CNST_TABLE_REF(((long) 1)), BNIL);
	      {
		 bool_t test2029_2156;
		 test2029_2156 = is_a__118___object(g_2155, global_ast_var);
		 if (test2029_2156)
		   {
		      obj_t arg2030_2158;
		      type_t arg2031_2159;
		      {
			 cfun_t obj_3566;
			 {
			    value_t aux_4522;
			    {
			       global_t obj_3565;
			       obj_3565 = (global_t) (g_2155);
			       aux_4522 = (((global_t) CREF(obj_3565))->value);
			    }
			    obj_3566 = (cfun_t) (aux_4522);
			 }
			 arg2030_2158 = (((cfun_t) CREF(obj_3566))->args_type_205);
		      }
		      arg2031_2159 = get_default_type_181_type_cache();
		      {
			 obj_t aux_4528;
			 aux_4528 = (obj_t) (arg2031_2159);
			 SET_CAR(arg2030_2158, aux_4528);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	   }
	   {
	      obj_t g_2162;
	      g_2162 = find_global_223_ast_env(CNST_TABLE_REF(((long) 2)), BNIL);
	      {
		 bool_t test2034_2163;
		 test2034_2163 = is_a__118___object(g_2162, global_ast_var);
		 if (test2034_2163)
		   {
		      obj_t arg2035_2165;
		      type_t arg2036_2166;
		      {
			 obj_t aux_4535;
			 {
			    sfun_t obj_3571;
			    {
			       value_t aux_4536;
			       {
				  global_t obj_3570;
				  obj_3570 = (global_t) (g_2162);
				  aux_4536 = (((global_t) CREF(obj_3570))->value);
			       }
			       obj_3571 = (sfun_t) (aux_4536);
			    }
			    aux_4535 = (((sfun_t) CREF(obj_3571))->args);
			 }
			 arg2035_2165 = CAR(aux_4535);
		      }
		      arg2036_2166 = get_default_type_181_type_cache();
		      {
			 obj_t res2746_3575;
			 {
			    local_t obj_3573;
			    obj_3573 = (local_t) (arg2035_2165);
			    {
			       obj_t x_4375;
			       x_4375 = ((((local_t) CREF(obj_3573))->type) = ((type_t) arg2036_2166), BUNSPEC);
			       res2746_3575 = BUNSPEC;
			    }
			 }
			 return res2746_3575;
		      }
		   }
		 else
		   {
		      return BUNSPEC;
		   }
	      }
	   }
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_patch_vector_set__187_cfa_tvector(obj_t env_4366)
{
   return patch_vector_set__231_cfa_tvector();
}


obj_t 
unpatch_vector_set__139_cfa_tvector()
{
   {
      bool_t test_4546;
      {
	 obj_t aux_4547;
	 aux_4547 = tvector_optimization__143_cfa_tvector();
	 test_4546 = CBOOL(aux_4547);
      }
      if (test_4546)
	{
	   {
	      obj_t l1901_2171;
	      l1901_2171 = CNST_TABLE_REF(((long) 0));
	    lname1902_2172:
	      if (PAIRP(l1901_2171))
		{
		   {
		      obj_t g_2176;
		      g_2176 = find_global_223_ast_env(CAR(l1901_2171), BNIL);
		      {
			 bool_t test2045_2177;
			 test2045_2177 = is_a__118___object(g_2176, global_ast_var);
			 if (test2045_2177)
			   {
			      value_t fun_2178;
			      {
				 global_t obj_3579;
				 obj_3579 = (global_t) (g_2176);
				 fun_2178 = (((global_t) CREF(obj_3579))->value);
			      }
			      {
				 bool_t test2046_2179;
				 test2046_2179 = is_a__118___object((obj_t) (fun_2178), cfun_ast_var);
				 if (test2046_2179)
				   {
				      {
					 obj_t obj_3587;
					 obj_3587 = __obj__252_type_cache;
					 {
					    obj_t aux_4561;
					    {
					       obj_t aux_4562;
					       {
						  obj_t aux_4563;
						  {
						     cfun_t obj_3581;
						     obj_3581 = (cfun_t) (fun_2178);
						     aux_4563 = (((cfun_t) CREF(obj_3581))->args_type_205);
						  }
						  aux_4562 = CDR(aux_4563);
					       }
					       aux_4561 = CDR(aux_4562);
					    }
					    SET_CAR(aux_4561, obj_3587);
					 }
				      }
				   }
				 else
				   {
				      bool_t test2049_2182;
				      test2049_2182 = is_a__118___object((obj_t) (fun_2178), sfun_ast_var);
				      if (test2049_2182)
					{
					   {
					      obj_t res2747_3598;
					      {
						 local_t obj_3596;
						 type_t val1102_3597;
						 {
						    obj_t aux_4572;
						    {
						       obj_t aux_4573;
						       {
							  obj_t aux_4574;
							  {
							     obj_t aux_4575;
							     {
								sfun_t obj_3589;
								obj_3589 = (sfun_t) (fun_2178);
								aux_4575 = (((sfun_t) CREF(obj_3589))->args);
							     }
							     aux_4574 = CDR(aux_4575);
							  }
							  aux_4573 = CDR(aux_4574);
						       }
						       aux_4572 = CAR(aux_4573);
						    }
						    obj_3596 = (local_t) (aux_4572);
						 }
						 val1102_3597 = (type_t) (__obj__252_type_cache);
						 {
						    obj_t x_4376;
						    x_4376 = ((((local_t) CREF(obj_3596))->type) = ((type_t) val1102_3597), BUNSPEC);
						    res2747_3598 = BUNSPEC;
						 }
					      }
					      res2747_3598;
					   }
					}
				      else
					{
					   BFALSE;
					}
				   }
			      }
			   }
			 else
			   {
			      BUNSPEC;
			   }
		      }
		   }
		   {
		      obj_t l1901_4584;
		      l1901_4584 = CDR(l1901_2171);
		      l1901_2171 = l1901_4584;
		      goto lname1902_2172;
		   }
		}
	      else
		{
		   ((bool_t) 1);
		}
	   }
	   {
	      obj_t g_2187;
	      g_2187 = find_global_223_ast_env(CNST_TABLE_REF(((long) 1)), BNIL);
	      {
		 bool_t test2054_2188;
		 test2054_2188 = is_a__118___object(g_2187, global_ast_var);
		 if (test2054_2188)
		   {
		      obj_t obj_3604;
		      obj_3604 = __obj__252_type_cache;
		      {
			 obj_t aux_4591;
			 {
			    cfun_t obj_3602;
			    {
			       value_t aux_4592;
			       {
				  global_t obj_3601;
				  obj_3601 = (global_t) (g_2187);
				  aux_4592 = (((global_t) CREF(obj_3601))->value);
			       }
			       obj_3602 = (cfun_t) (aux_4592);
			    }
			    aux_4591 = (((cfun_t) CREF(obj_3602))->args_type_205);
			 }
			 SET_CAR(aux_4591, obj_3604);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	   }
	   {
	      obj_t g_2193;
	      g_2193 = find_global_223_ast_env(CNST_TABLE_REF(((long) 2)), BNIL);
	      {
		 bool_t test2058_2194;
		 test2058_2194 = is_a__118___object(g_2193, global_ast_var);
		 if (test2058_2194)
		   {
		      obj_t res2748_3611;
		      {
			 local_t obj_3609;
			 type_t val1102_3610;
			 {
			    obj_t aux_4602;
			    {
			       obj_t aux_4603;
			       {
				  sfun_t obj_3607;
				  {
				     value_t aux_4604;
				     {
					global_t obj_3606;
					obj_3606 = (global_t) (g_2193);
					aux_4604 = (((global_t) CREF(obj_3606))->value);
				     }
				     obj_3607 = (sfun_t) (aux_4604);
				  }
				  aux_4603 = (((sfun_t) CREF(obj_3607))->args);
			       }
			       aux_4602 = CAR(aux_4603);
			    }
			    obj_3609 = (local_t) (aux_4602);
			 }
			 val1102_3610 = (type_t) (__obj__252_type_cache);
			 {
			    obj_t x_4377;
			    x_4377 = ((((local_t) CREF(obj_3609))->type) = ((type_t) val1102_3610), BUNSPEC);
			    res2748_3611 = BUNSPEC;
			 }
		      }
		      return res2748_3611;
		   }
		 else
		   {
		      return BUNSPEC;
		   }
	      }
	   }
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_unpatch_vector_set__250_cfa_tvector(obj_t env_4367)
{
   return unpatch_vector_set__139_cfa_tvector();
}


obj_t 
vector__tvector__205_cfa_tvector(obj_t globals_29)
{
   {
      bool_t test_4614;
      {
	 obj_t aux_4615;
	 aux_4615 = tvector_optimization__143_cfa_tvector();
	 test_4614 = CBOOL(aux_4615);
      }
      if (test_4614)
	{
	   {
	      bool_t test2064_2201;
	      {
		 obj_t aux_4618;
		 aux_4618 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 3)), BINT(((long) 0)));
		 test2064_2201 = CBOOL(aux_4618);
	      }
	      if (test2064_2201)
		{
		   obj_t arg2068_2204;
		   arg2068_2204 = shape_tools_shape(__make_vector_list__231_cfa_tvector);
		   {
		      obj_t list2069_2205;
		      {
			 obj_t arg2070_2206;
			 {
			    obj_t arg2071_2207;
			    {
			       obj_t arg2072_2208;
			       {
				  obj_t arg2073_2209;
				  {
				     obj_t arg2074_2210;
				     {
					obj_t aux_4625;
					aux_4625 = BCHAR(((unsigned char) '\n'));
					arg2074_2210 = MAKE_PAIR(aux_4625, BNIL);
				     }
				     arg2073_2209 = MAKE_PAIR(arg2068_2204, arg2074_2210);
				  }
				  {
				     obj_t aux_4629;
				     aux_4629 = BCHAR(((unsigned char) '\n'));
				     arg2072_2208 = MAKE_PAIR(aux_4629, arg2073_2209);
				  }
			       }
			       arg2071_2207 = MAKE_PAIR(string2781_cfa_tvector, arg2072_2208);
			    }
			    {
			       obj_t aux_4633;
			       aux_4633 = BCHAR(((unsigned char) '\n'));
			       arg2070_2206 = MAKE_PAIR(aux_4633, arg2071_2207);
			    }
			 }
			 list2069_2205 = MAKE_PAIR(string2782_cfa_tvector, arg2070_2206);
		      }
		      print_trace_107_tools_trace(list2069_2205);
		   }
		}
	      else
		{
		   BUNSPEC;
		}
	   }
	   inline_setup__219_inline_walk(CNST_TABLE_REF(((long) 4)));
	   {
	      obj_t tvectors_2215;
	      tvectors_2215 = get_tvectors_38_cfa_tvector();
	      show_tvector_204_cfa_tvector(tvectors_2215);
	      {
		 bool_t test2080_2216;
		 {
		    obj_t aux_4642;
		    aux_4642 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 3)), BINT(((long) 2)));
		    test2080_2216 = CBOOL(aux_4642);
		 }
		 if (test2080_2216)
		   {
		      obj_t arg2083_2218;
		      arg2083_2218 = shape_tools_shape(tvectors_2215);
		      {
			 obj_t list2084_2219;
			 {
			    obj_t arg2085_2220;
			    {
			       obj_t arg2086_2221;
			       {
				  obj_t aux_4649;
				  aux_4649 = BCHAR(((unsigned char) '\n'));
				  arg2086_2221 = MAKE_PAIR(aux_4649, BNIL);
			       }
			       arg2085_2220 = MAKE_PAIR(arg2083_2218, arg2086_2221);
			    }
			    list2084_2219 = MAKE_PAIR(string2783_cfa_tvector, arg2085_2220);
			 }
			 print_trace_107_tools_trace(list2084_2219);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	      if (PAIRP(tvectors_2215))
		{
		   obj_t add_tree_17_2226;
		   add_tree_17_2226 = declare_tvectors_117_cfa_tvector(tvectors_2215);
		   {
		      bool_t test2091_2227;
		      {
			 obj_t aux_4658;
			 aux_4658 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 3)), BINT(((long) 2)));
			 test2091_2227 = CBOOL(aux_4658);
		      }
		      if (test2091_2227)
			{
			   obj_t arg2095_2229;
			   arg2095_2229 = shape_tools_shape(add_tree_17_2226);
			   {
			      obj_t list2096_2230;
			      {
				 obj_t arg2097_2231;
				 {
				    obj_t arg2098_2232;
				    {
				       obj_t aux_4665;
				       aux_4665 = BCHAR(((unsigned char) '\n'));
				       arg2098_2232 = MAKE_PAIR(aux_4665, BNIL);
				    }
				    arg2097_2231 = MAKE_PAIR(arg2095_2229, arg2098_2232);
				 }
				 list2096_2230 = MAKE_PAIR(string2784_cfa_tvector, arg2097_2231);
			      }
			      print_trace_107_tools_trace(list2096_2230);
			   }
			}
		      else
			{
			   BUNSPEC;
			}
		   }
		   patch_tree__164_cfa_tvector(globals_29);
		   return add_tree_17_2226;
		}
	      else
		{
		   return BNIL;
		}
	   }
	}
      else
	{
	   return BNIL;
	}
   }
}


obj_t 
_vector__tvector__184_cfa_tvector(obj_t env_4368, obj_t globals_4369)
{
   return vector__tvector__205_cfa_tvector(globals_4369);
}


obj_t 
add_make_vector__104_cfa_tvector(node_t node_30)
{
   {
      bool_t test_4673;
      {
	 obj_t aux_4674;
	 aux_4674 = tvector_optimization__143_cfa_tvector();
	 test_4673 = CBOOL(aux_4674);
      }
      if (test_4673)
	{
	   obj_t obj2_3614;
	   obj2_3614 = __make_vector_list__231_cfa_tvector;
	   {
	      obj_t aux_4677;
	      aux_4677 = (obj_t) (node_30);
	      return (__make_vector_list__231_cfa_tvector = MAKE_PAIR(aux_4677, obj2_3614),
		 BUNSPEC);
	   }
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_add_make_vector__56_cfa_tvector(obj_t env_4370, obj_t node_4371)
{
   return add_make_vector__104_cfa_tvector((node_t) (node_4371));
}


obj_t 
get_tvectors_38_cfa_tvector()
{
   {
      obj_t apps_2237;
      obj_t tvectors_2238;
      apps_2237 = __make_vector_list__231_cfa_tvector;
      tvectors_2238 = BNIL;
    loop_2239:
      if (NULLP(apps_2237))
	{
	   return tvectors_2238;
	}
      else
	{
	   obj_t app_2242;
	   app_2242 = CAR(apps_2237);
	   {
	      type_t type_2243;
	      type_2243 = get_vector_item_type_88_cfa_tvector((app_t) (app_2242));
	      {
		 {
		    bool_t test2105_2244;
		    {
		       obj_t aux_4687;
		       aux_4687 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 3)), BINT(((long) 1)));
		       test2105_2244 = CBOOL(aux_4687);
		    }
		    if (test2105_2244)
		      {
			 obj_t arg2107_2246;
			 obj_t arg2109_2248;
			 obj_t arg2111_2250;
			 arg2107_2246 = shape_tools_shape(app_2242);
			 arg2109_2248 = shape_tools_shape((obj_t) (type_2243));
			 arg2111_2250 = (((type_t) CREF(type_2243))->class);
			 {
			    obj_t list2112_2251;
			    {
			       obj_t arg2113_2252;
			       {
				  obj_t arg2114_2253;
				  {
				     obj_t arg2115_2254;
				     {
					obj_t arg2117_2255;
					{
					   obj_t arg2118_2256;
					   {
					      obj_t arg2119_2257;
					      {
						 obj_t aux_4697;
						 aux_4697 = BCHAR(((unsigned char) '\n'));
						 arg2119_2257 = MAKE_PAIR(aux_4697, BNIL);
					      }
					      arg2118_2256 = MAKE_PAIR(arg2111_2250, arg2119_2257);
					   }
					   arg2117_2255 = MAKE_PAIR(string2785_cfa_tvector, arg2118_2256);
					}
					arg2115_2254 = MAKE_PAIR(arg2109_2248, arg2117_2255);
				     }
				     arg2114_2253 = MAKE_PAIR(string2786_cfa_tvector, arg2115_2254);
				  }
				  arg2113_2252 = MAKE_PAIR(arg2107_2246, arg2114_2253);
			       }
			       list2112_2251 = MAKE_PAIR(string2787_cfa_tvector, arg2113_2252);
			    }
			    print_trace_107_tools_trace(list2112_2251);
			 }
		      }
		    else
		      {
			 BUNSPEC;
		      }
		 }
		 {
		    bool_t test2123_2261;
		    {
		       bool_t test2127_2265;
		       {
			  obj_t obj2_3619;
			  obj2_3619 = _____74_type_cache;
			  {
			     obj_t aux_4707;
			     aux_4707 = (obj_t) (type_2243);
			     test2127_2265 = (aux_4707 == obj2_3619);
			  }
		       }
		       if (test2127_2265)
			 {
			    test2123_2261 = ((bool_t) 0);
			 }
		       else
			 {
			    bool_t test2128_2266;
			    test2128_2266 = sub_type__174_type_env(type_2243, (type_t) (__obj__252_type_cache));
			    if (test2128_2266)
			      {
				 test2123_2261 = ((bool_t) 0);
			      }
			    else
			      {
				 test2123_2261 = ((bool_t) 1);
			      }
			 }
		    }
		    if (test2123_2261)
		      {
			 obj_t arg2124_2262;
			 obj_t arg2125_2263;
			 arg2124_2262 = CDR(apps_2237);
			 arg2125_2263 = MAKE_PAIR(app_2242, tvectors_2238);
			 {
			    obj_t tvectors_4718;
			    obj_t apps_4717;
			    apps_4717 = arg2124_2262;
			    tvectors_4718 = arg2125_2263;
			    tvectors_2238 = tvectors_4718;
			    apps_2237 = apps_4717;
			    goto loop_2239;
			 }
		      }
		    else
		      {
			 obj_t apps_4719;
			 apps_4719 = CDR(apps_2237);
			 apps_2237 = apps_4719;
			 goto loop_2239;
		      }
		 }
	      }
	   }
	}
   }
}


obj_t 
get_vector_item_type_default1949_191_cfa_tvector(app_t app_32)
{
   FAILURE(CNST_TABLE_REF(((long) 5)), string2788_cfa_tvector, (obj_t) (app_32));
}


obj_t 
_get_vector_item_type_default1949_224_cfa_tvector(obj_t env_4359, obj_t app_4360)
{
   return get_vector_item_type_default1949_191_cfa_tvector((app_t) (app_4360));
}


type_t 
get_vector_item_type_88_cfa_tvector(app_t app_31)
{
   {
      obj_t method2722_3474;
      obj_t class2727_3475;
      {
	 obj_t arg2730_3472;
	 obj_t arg2731_3473;
	 {
	    object_t obj_3629;
	    obj_3629 = (object_t) (app_31);
	    {
	       obj_t pre_method_105_3630;
	       pre_method_105_3630 = PROCEDURE_REF(get_vector_item_type_env_168_cfa_tvector, ((long) 2));
	       if (INTEGERP(pre_method_105_3630))
		 {
		    PROCEDURE_SET(get_vector_item_type_env_168_cfa_tvector, ((long) 2), BUNSPEC);
		    arg2730_3472 = pre_method_105_3630;
		 }
	       else
		 {
		    long obj_class_num_177_3635;
		    obj_class_num_177_3635 = TYPE(obj_3629);
		    {
		       obj_t arg1183_3636;
		       arg1183_3636 = PROCEDURE_REF(get_vector_item_type_env_168_cfa_tvector, ((long) 1));
		       {
			  long arg1184_3640;
			  {
			     long arg1186_3641;
			     arg1186_3641 = OBJECT_TYPE;
			     arg1184_3640 = (obj_class_num_177_3635 - arg1186_3641);
			  }
			  arg2730_3472 = VECTOR_REF(arg1183_3636, arg1184_3640);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_3646;
	    object_3646 = (object_t) (app_31);
	    {
	       long arg1187_3647;
	       {
		  long arg1188_3648;
		  long arg1189_3649;
		  arg1188_3648 = TYPE(object_3646);
		  arg1189_3649 = OBJECT_TYPE;
		  arg1187_3647 = (arg1188_3648 - arg1189_3649);
	       }
	       {
		  obj_t vector_3653;
		  vector_3653 = __classes__134___object;
		  arg2731_3473 = VECTOR_REF(vector_3653, arg1187_3647);
	       }
	    }
	 }
	 {
	    obj_t aux_4741;
	    method2722_3474 = arg2730_3472;
	    class2727_3475 = arg2731_3473;
	    {
	       if (INTEGERP(method2722_3474))
		 {
		    switch ((long) CINT(method2722_3474))
		      {
		      case ((long) 0):
			 {
			    make_vector_app_205_t app_3481;
			    app_3481 = (make_vector_app_205_t) (app_31);
			    {
			       bool_t test_4745;
			       {
				  obj_t aux_4746;
				  {
				     object_t aux_4747;
				     aux_4747 = (object_t) (app_3481);
				     aux_4746 = OBJECT_WIDENING(aux_4747);
				  }
				  test_4745 = (((make_vector_app_205_t) CREF(aux_4746))->seen__39);
			       }
			       if (test_4745)
				 {
				    approx_t arg2735_3484;
				    {
				       obj_t aux_4751;
				       {
					  object_t aux_4752;
					  aux_4752 = (object_t) (app_3481);
					  aux_4751 = OBJECT_WIDENING(aux_4752);
				       }
				       arg2735_3484 = (((make_vector_app_205_t) CREF(aux_4751))->value_approx_19);
				    }
				    {
				       type_t aux_4756;
				       aux_4756 = (((approx_t) CREF(arg2735_3484))->type);
				       aux_4741 = (obj_t) (aux_4756);
				    }
				 }
			       else
				 {
				    aux_4741 = __vector__240_type_cache;
				 }
			    }
			 }
			 break;
		      case ((long) 1):
			 {
			    create_vector_app_150_t app_3485;
			    app_3485 = (create_vector_app_150_t) (app_31);
			    {
			       bool_t test_4760;
			       {
				  obj_t aux_4761;
				  {
				     object_t aux_4762;
				     aux_4762 = (object_t) (app_3485);
				     aux_4761 = OBJECT_WIDENING(aux_4762);
				  }
				  test_4760 = (((create_vector_app_150_t) CREF(aux_4761))->seen__39);
			       }
			       if (test_4760)
				 {
				    approx_t arg2737_3488;
				    {
				       obj_t aux_4766;
				       {
					  object_t aux_4767;
					  aux_4767 = (object_t) (app_3485);
					  aux_4766 = OBJECT_WIDENING(aux_4767);
				       }
				       arg2737_3488 = (((create_vector_app_150_t) CREF(aux_4766))->value_approx_19);
				    }
				    {
				       type_t aux_4771;
				       aux_4771 = (((approx_t) CREF(arg2737_3488))->type);
				       aux_4741 = (obj_t) (aux_4771);
				    }
				 }
			       else
				 {
				    aux_4741 = __vector__240_type_cache;
				 }
			    }
			 }
			 break;
		      default:
		       case_else2728_186_3478:
			 if (PROCEDUREP(method2722_3474))
			   {
			      aux_4741 = PROCEDURE_ENTRY(method2722_3474) (method2722_3474, (obj_t) (app_31), BEOA);
			   }
			 else
			   {
			      obj_t fun2131_2269;
			      fun2131_2269 = PROCEDURE_REF(get_vector_item_type_env_168_cfa_tvector, ((long) 0));
			      aux_4741 = PROCEDURE_ENTRY(fun2131_2269) (fun2131_2269, (obj_t) (app_31), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else2728_186_3478;
		 }
	    }
	    return (type_t) (aux_4741);
	 }
      }
   }
}


obj_t 
_get_vector_item_type_42_cfa_tvector(obj_t env_4357, obj_t app_4358)
{
   {
      type_t aux_4786;
      aux_4786 = get_vector_item_type_88_cfa_tvector((app_t) (app_4358));
      return (obj_t) (aux_4786);
   }
}


bool_t 
show_tvector_204_cfa_tvector(obj_t tvector_35)
{
   {
      obj_t list2132_2270;
      {
	 obj_t arg2134_2272;
	 {
	    obj_t aux_4790;
	    aux_4790 = BCHAR(((unsigned char) '\n'));
	    arg2134_2272 = MAKE_PAIR(aux_4790, BNIL);
	 }
	 list2132_2270 = MAKE_PAIR(string2789_cfa_tvector, arg2134_2272);
      }
      verbose_tools_speek(BINT(((long) 1)), list2132_2270);
   }
   {
      obj_t l1905_2274;
      l1905_2274 = tvector_35;
    lname1908_2275:
      if (PAIRP(l1905_2274))
	{
	   {
	      obj_t arg2139_2280;
	      obj_t arg2142_2282;
	      arg2139_2280 = shape_tools_shape(__obj__252_type_cache);
	      {
		 type_t arg2150_2289;
		 {
		    app_t aux_4799;
		    {
		       obj_t aux_4800;
		       aux_4800 = CAR(l1905_2274);
		       aux_4799 = (app_t) (aux_4800);
		    }
		    arg2150_2289 = get_vector_item_type_88_cfa_tvector(aux_4799);
		 }
		 arg2142_2282 = shape_tools_shape((obj_t) (arg2150_2289));
	      }
	      {
		 obj_t list2143_2283;
		 {
		    obj_t arg2144_2284;
		    {
		       obj_t arg2145_2285;
		       {
			  obj_t arg2146_2286;
			  {
			     obj_t arg2148_2287;
			     {
				obj_t aux_4806;
				aux_4806 = BCHAR(((unsigned char) '\n'));
				arg2148_2287 = MAKE_PAIR(aux_4806, BNIL);
			     }
			     arg2146_2286 = MAKE_PAIR(arg2142_2282, arg2148_2287);
			  }
			  arg2145_2285 = MAKE_PAIR(string2790_cfa_tvector, arg2146_2286);
		       }
		       arg2144_2284 = MAKE_PAIR(arg2139_2280, arg2145_2285);
		    }
		    list2143_2283 = MAKE_PAIR(string2791_cfa_tvector, arg2144_2284);
		 }
		 verbose_tools_speek(BINT(((long) 2)), list2143_2283);
	      }
	   }
	   {
	      obj_t l1905_4815;
	      l1905_4815 = CDR(l1905_2274);
	      l1905_2274 = l1905_4815;
	      goto lname1908_2275;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
declare_tvectors_117_cfa_tvector(obj_t tvector_36)
{
   {
      obj_t l1909_2291;
      l1909_2291 = tvector_36;
    lname1911_2292:
      if (PAIRP(l1909_2291))
	{
	   {
	      type_t type_2295;
	      {
		 app_t aux_4819;
		 {
		    obj_t aux_4820;
		    aux_4820 = CAR(l1909_2291);
		    aux_4819 = (app_t) (aux_4820);
		 }
		 type_2295 = get_vector_item_type_88_cfa_tvector(aux_4819);
	      }
	      {
		 bool_t test2153_2297;
		 test2153_2297 = is_a__118___object((((type_t) CREF(type_2295))->tvector), type_type_type);
		 if (test2153_2297)
		   {
		      BUNSPEC;
		   }
		 else
		   {
		      obj_t tv_id_119_2298;
		      {
			 obj_t arg2171_2313;
			 arg2171_2313 = CNST_TABLE_REF(((long) 6));
			 {
			    obj_t list2173_2315;
			    {
			       obj_t arg2174_2316;
			       {
				  obj_t aux_4828;
				  aux_4828 = (((type_t) CREF(type_2295))->id);
				  arg2174_2316 = MAKE_PAIR(aux_4828, BNIL);
			       }
			       list2173_2315 = MAKE_PAIR(arg2171_2313, arg2174_2316);
			    }
			    tv_id_119_2298 = symbol_append_197___r4_symbols_6_4(list2173_2315);
			 }
		      }
		      {
			 obj_t arg2154_2299;
			 {
			    obj_t arg2155_2300;
			    {
			       obj_t arg2160_2302;
			       obj_t arg2161_2303;
			       arg2160_2302 = CNST_TABLE_REF(((long) 7));
			       {
				  obj_t arg2167_2309;
				  arg2167_2309 = (((type_t) CREF(type_2295))->id);
				  {
				     obj_t list2169_2311;
				     list2169_2311 = MAKE_PAIR(BNIL, BNIL);
				     arg2161_2303 = cons__138___r4_pairs_and_lists_6_3(arg2167_2309, list2169_2311);
				  }
			       }
			       {
				  obj_t list2163_2305;
				  {
				     obj_t arg2164_2306;
				     {
					obj_t arg2165_2307;
					arg2165_2307 = MAKE_PAIR(BNIL, BNIL);
					arg2164_2306 = MAKE_PAIR(arg2161_2303, arg2165_2307);
				     }
				     list2163_2305 = MAKE_PAIR(tv_id_119_2298, arg2164_2306);
				  }
				  arg2155_2300 = cons__138___r4_pairs_and_lists_6_3(arg2160_2302, list2163_2305);
			       }
			    }
			    arg2154_2299 = type_parser_173_module_type(arg2155_2300, BNIL);
			 }
			 {
			    obj_t res2750_3674;
			    {
			       obj_t x_4378;
			       x_4378 = ((((type_t) CREF(type_2295))->tvector) = ((obj_t) arg2154_2299), BUNSPEC);
			       res2750_3674 = BUNSPEC;
			    }
			    res2750_3674;
			 }
		      }
		   }
	      }
	   }
	   {
	      obj_t l1909_4843;
	      l1909_4843 = CDR(l1909_2291);
	      l1909_2291 = l1909_4843;
	      goto lname1911_2292;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      type_t old_default_type_182_2320;
      old_default_type_182_2320 = get_default_type_181_type_cache();
      set_default_type__106_type_cache((type_t) (__obj__252_type_cache));
      {
	 obj_t tvector_unit_55_2321;
	 tvector_unit_55_2321 = tvector_finalizer_246_module_type();
	 pragma_finalizer_170_module_pragma();
	 {
	    obj_t res_2322;
	    {
	       bool_t test_4850;
	       if (STRUCTP(tvector_unit_55_2321))
		 {
		    obj_t aux_4855;
		    obj_t aux_4853;
		    aux_4855 = CNST_TABLE_REF(((long) 8));
		    aux_4853 = STRUCT_KEY(tvector_unit_55_2321);
		    test_4850 = (aux_4853 == aux_4855);
		 }
	       else
		 {
		    test_4850 = ((bool_t) 0);
		 }
	       if (test_4850)
		 {
		    obj_t arg2179_2324;
		    obj_t arg2180_2325;
		    {
		       obj_t arg2181_2326;
		       {
			  obj_t list2182_2327;
			  list2182_2327 = MAKE_PAIR(tvector_unit_55_2321, BNIL);
			  arg2181_2326 = list2182_2327;
		       }
		       arg2179_2324 = build_ast_sans_remove_93_ast_build(arg2181_2326);
		    }
		    arg2180_2325 = CNST_TABLE_REF(((long) 9));
		    res_2322 = globalize_walk__63_globalize_walk(arg2179_2324, arg2180_2325);
		 }
	       else
		 {
		    res_2322 = BNIL;
		 }
	    }
	    set_default_type__106_type_cache(old_default_type_182_2320);
	    return res_2322;
	 }
      }
   }
}


bool_t 
patch_tree__164_cfa_tvector(obj_t globals_37)
{
   {
      obj_t l1913_2329;
      l1913_2329 = globals_37;
    lname1914_2330:
      if (PAIRP(l1913_2329))
	{
	   patch_fun__141_cfa_tvector(CAR(l1913_2329));
	   {
	      obj_t l1913_4867;
	      l1913_4867 = CDR(l1913_2329);
	      l1913_2329 = l1913_4867;
	      goto lname1914_2330;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
patch_fun__141_cfa_tvector(obj_t variable_38)
{
   {
      value_t fun_2334;
      {
	 variable_t obj_3688;
	 obj_3688 = (variable_t) (variable_38);
	 fun_2334 = (((variable_t) CREF(obj_3688))->value);
      }
      {
	 bool_t test2187_2335;
	 {
	    obj_t aux_4871;
	    aux_4871 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 3)), BINT(((long) 4)));
	    test2187_2335 = CBOOL(aux_4871);
	 }
	 if (test2187_2335)
	   {
	      obj_t arg2189_2337;
	      obj_t arg2191_2339;
	      arg2189_2337 = shape_tools_shape(variable_38);
	      {
		 obj_t aux_4878;
		 {
		    sfun_t obj_3689;
		    obj_3689 = (sfun_t) (fun_2334);
		    aux_4878 = (((sfun_t) CREF(obj_3689))->body);
		 }
		 arg2191_2339 = shape_tools_shape(aux_4878);
	      }
	      {
		 obj_t list2192_2340;
		 {
		    obj_t arg2193_2341;
		    {
		       obj_t arg2194_2342;
		       {
			  obj_t arg2195_2343;
			  {
			     obj_t arg2196_2344;
			     {
				obj_t arg2197_2345;
				{
				   obj_t aux_4882;
				   aux_4882 = BCHAR(((unsigned char) '\n'));
				   arg2197_2345 = MAKE_PAIR(aux_4882, BNIL);
				}
				arg2196_2344 = MAKE_PAIR(arg2191_2339, arg2197_2345);
			     }
			     {
				obj_t aux_4886;
				aux_4886 = BCHAR(((unsigned char) '\n'));
				arg2195_2343 = MAKE_PAIR(aux_4886, arg2196_2344);
			     }
			  }
			  arg2194_2342 = MAKE_PAIR(string2792_cfa_tvector, arg2195_2343);
		       }
		       arg2193_2341 = MAKE_PAIR(arg2189_2337, arg2194_2342);
		    }
		    list2192_2340 = MAKE_PAIR(string2793_cfa_tvector, arg2193_2341);
		 }
		 print_trace_107_tools_trace(list2192_2340);
	      }
	   }
	 else
	   {
	      BUNSPEC;
	   }
      }
      {
	 obj_t arg2202_2350;
	 {
	    node_t aux_4893;
	    {
	       obj_t aux_4894;
	       {
		  sfun_t obj_3690;
		  obj_3690 = (sfun_t) (fun_2334);
		  aux_4894 = (((sfun_t) CREF(obj_3690))->body);
	       }
	       aux_4893 = (node_t) (aux_4894);
	    }
	    arg2202_2350 = patch__227_cfa_tvector(aux_4893);
	 }
	 {
	    obj_t res2751_3693;
	    {
	       sfun_t obj_3691;
	       obj_3691 = (sfun_t) (fun_2334);
	       {
		  obj_t x_4379;
		  x_4379 = ((((sfun_t) CREF(obj_3691))->body) = ((obj_t) arg2202_2350), BUNSPEC);
		  res2751_3693 = BUNSPEC;
	       }
	    }
	    return res2751_3693;
	 }
      }
   }
}


obj_t 
patch__default1952_50_cfa_tvector(node_t node_40)
{
   FAILURE(CNST_TABLE_REF(((long) 10)), string2788_cfa_tvector, (obj_t) (node_40));
}


obj_t 
_patch__default1952_121_cfa_tvector(obj_t env_4363, obj_t node_4364)
{
   return patch__default1952_50_cfa_tvector((node_t) (node_4364));
}


obj_t 
patch__227_cfa_tvector(node_t node_39)
{
   {
      obj_t method2518_3190;
      obj_t class2523_3191;
      {
	 obj_t arg2527_3188;
	 obj_t arg2529_3189;
	 {
	    object_t obj_3699;
	    obj_3699 = (object_t) (node_39);
	    {
	       obj_t pre_method_105_3700;
	       pre_method_105_3700 = PROCEDURE_REF(patch__env_129_cfa_tvector, ((long) 2));
	       if (INTEGERP(pre_method_105_3700))
		 {
		    PROCEDURE_SET(patch__env_129_cfa_tvector, ((long) 2), BUNSPEC);
		    arg2527_3188 = pre_method_105_3700;
		 }
	       else
		 {
		    long obj_class_num_177_3705;
		    obj_class_num_177_3705 = TYPE(obj_3699);
		    {
		       obj_t arg1183_3706;
		       arg1183_3706 = PROCEDURE_REF(patch__env_129_cfa_tvector, ((long) 1));
		       {
			  long arg1184_3710;
			  {
			     long arg1186_3711;
			     arg1186_3711 = OBJECT_TYPE;
			     arg1184_3710 = (obj_class_num_177_3705 - arg1186_3711);
			  }
			  arg2527_3188 = VECTOR_REF(arg1183_3706, arg1184_3710);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_3716;
	    object_3716 = (object_t) (node_39);
	    {
	       long arg1187_3717;
	       {
		  long arg1188_3718;
		  long arg1189_3719;
		  arg1188_3718 = TYPE(object_3716);
		  arg1189_3719 = OBJECT_TYPE;
		  arg1187_3717 = (arg1188_3718 - arg1189_3719);
	       }
	       {
		  obj_t vector_3723;
		  vector_3723 = __classes__134___object;
		  arg2529_3189 = VECTOR_REF(vector_3723, arg1187_3717);
	       }
	    }
	 }
	 method2518_3190 = arg2527_3188;
	 class2523_3191 = arg2529_3189;
	 {
	    if (INTEGERP(method2518_3190))
	      {
		 switch ((long) CINT(method2518_3190))
		   {
		   case ((long) 0):
		      {
			 atom_t aux_4923;
			 aux_4923 = (atom_t) (node_39);
			 return (obj_t) (aux_4923);
		      }
		      break;
		   case ((long) 1):
		      {
			 kwote_t aux_4926;
			 aux_4926 = (kwote_t) (node_39);
			 return (obj_t) (aux_4926);
		      }
		      break;
		   case ((long) 2):
		      {
			 kwote_node_102_t knode_3199;
			 knode_3199 = (kwote_node_102_t) (node_39);
			 {
			    approx_t approx_3201;
			    {
			       node_t aux_4930;
			       {
				  obj_t aux_4931;
				  {
				     object_t aux_4932;
				     aux_4932 = (object_t) (knode_3199);
				     aux_4931 = OBJECT_WIDENING(aux_4932);
				  }
				  aux_4930 = (((kwote_node_102_t) CREF(aux_4931))->node);
			       }
			       approx_3201 = cfa__102_cfa_cfa(aux_4930);
			    }
			    {
			       obj_t tv_3202;
			       tv_3202 = get_approx_type_210_cfa_type(approx_3201);
			       {
				  {
				     bool_t test2532_3203;
				     test2532_3203 = is_a__118___object(tv_3202, tvec_tvector_tvector);
				     if (test2532_3203)
				       {
					  kwote_node_102_t knode_3204;
					  {
					     long arg2537_3211;
					     {
						obj_t arg2538_3212;
						{
						   obj_t arg2539_3213;
						   {
						      object_t object_3727;
						      object_3727 = (object_t) (knode_3199);
						      {
							 long arg1187_3728;
							 {
							    long arg1188_3729;
							    long arg1189_3730;
							    arg1188_3729 = TYPE(object_3727);
							    arg1189_3730 = OBJECT_TYPE;
							    arg1187_3728 = (arg1188_3729 - arg1189_3730);
							 }
							 {
							    obj_t vector_3734;
							    vector_3734 = __classes__134___object;
							    arg2539_3213 = VECTOR_REF(vector_3734, arg1187_3728);
							 }
						      }
						   }
						   arg2538_3212 = class_super_145___object(arg2539_3213);
						}
						arg2537_3211 = class_num_218___object(arg2538_3212);
					     }
					     {
						obj_t obj_3736;
						obj_3736 = (obj_t) (knode_3199);
						(((obj_t) CREF(obj_3736))->header = MAKE_HEADER(arg2537_3211, 0), BUNSPEC);
					     }
					  }
					  {
					     object_t aux_4949;
					     aux_4949 = (object_t) (knode_3199);
					     OBJECT_WIDENING_SET(aux_4949, BFALSE);
					  }
					  knode_3204 = knode_3199;
					  {
					     kwote_t duplicated1917_3205;
					     duplicated1917_3205 = (kwote_t) (knode_3204);
					     {
						obj_t arg2533_3206;
						type_t arg2534_3207;
						obj_t arg2535_3208;
						arg2533_3206 = (((kwote_t) CREF(duplicated1917_3205))->loc);
						arg2534_3207 = (((kwote_t) CREF(duplicated1917_3205))->type);
						{
						   obj_t arg2536_3209;
						   {
						      kwote_t obj_3740;
						      obj_3740 = (kwote_t) (knode_3199);
						      arg2536_3209 = (((kwote_t) CREF(obj_3740))->value);
						   }
						   {
						      obj_t new_3743;
						      {
							 obj_t aux_4957;
							 aux_4957 = CNST_TABLE_REF(((long) 11));
							 new_3743 = create_struct(aux_4957, ((long) 2));
						      }
						      STRUCT_SET(new_3743, ((long) 1), arg2536_3209);
						      STRUCT_SET(new_3743, ((long) 0), tv_3202);
						      arg2535_3208 = new_3743;
						   }
						}
						{
						   kwote_t res2752_3766;
						   {
						      kwote_t new1191_3759;
						      new1191_3759 = ((kwote_t) BREF(GC_MALLOC(sizeof(struct kwote))));
						      {
							 long arg2476_3760;
							 arg2476_3760 = class_num_218___object(kwote_ast_node);
							 {
							    obj_t obj_3764;
							    obj_3764 = (obj_t) (new1191_3759);
							    (((obj_t) CREF(obj_3764))->header = MAKE_HEADER(arg2476_3760, 0), BUNSPEC);
							 }
						      }
						      {
							 object_t aux_4966;
							 aux_4966 = (object_t) (new1191_3759);
							 OBJECT_WIDENING_SET(aux_4966, BFALSE);
						      }
						      ((((kwote_t) CREF(new1191_3759))->loc) = ((obj_t) arg2533_3206), BUNSPEC);
						      ((((kwote_t) CREF(new1191_3759))->type) = ((type_t) arg2534_3207), BUNSPEC);
						      ((((kwote_t) CREF(new1191_3759))->value) = ((obj_t) arg2535_3208), BUNSPEC);
						      res2752_3766 = new1191_3759;
						   }
						   return (obj_t) (res2752_3766);
						}
					     }
					  }
				       }
				     else
				       {
					  {
					     long arg2540_3215;
					     {
						obj_t arg2541_3216;
						{
						   obj_t arg2542_3217;
						   {
						      object_t object_3767;
						      object_3767 = (object_t) (knode_3199);
						      {
							 long arg1187_3768;
							 {
							    long arg1188_3769;
							    long arg1189_3770;
							    arg1188_3769 = TYPE(object_3767);
							    arg1189_3770 = OBJECT_TYPE;
							    arg1187_3768 = (arg1188_3769 - arg1189_3770);
							 }
							 {
							    obj_t vector_3774;
							    vector_3774 = __classes__134___object;
							    arg2542_3217 = VECTOR_REF(vector_3774, arg1187_3768);
							 }
						      }
						   }
						   arg2541_3216 = class_super_145___object(arg2542_3217);
						}
						arg2540_3215 = class_num_218___object(arg2541_3216);
					     }
					     {
						obj_t obj_3776;
						obj_3776 = (obj_t) (knode_3199);
						(((obj_t) CREF(obj_3776))->header = MAKE_HEADER(arg2540_3215, 0), BUNSPEC);
					     }
					  }
					  {
					     object_t aux_4982;
					     aux_4982 = (object_t) (knode_3199);
					     OBJECT_WIDENING_SET(aux_4982, BFALSE);
					  }
					  return (obj_t) (knode_3199);
				       }
				  }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 3):
		      {
			 var_t aux_4986;
			 aux_4986 = (var_t) (node_39);
			 return (obj_t) (aux_4986);
		      }
		      break;
		   case ((long) 4):
		      {
			 obj_t arg2546_3223;
			 {
			    obj_t aux_4989;
			    {
			       closure_t aux_4990;
			       aux_4990 = (closure_t) (node_39);
			       aux_4989 = (obj_t) (aux_4990);
			    }
			    arg2546_3223 = shape_tools_shape(aux_4989);
			 }
			 return internal_error_43_tools_error(string2794_cfa_tvector, string2795_cfa_tvector, arg2546_3223);
		      }
		      break;
		   case ((long) 5):
		      {
			 sequence_t node_3224;
			 node_3224 = (sequence_t) (node_39);
			 patch___72_cfa_tvector((((sequence_t) CREF(node_3224))->nodes));
			 return (obj_t) (node_3224);
		      }
		      break;
		   case ((long) 6):
		      {
			 app_ly_162_t node_3227;
			 node_3227 = (app_ly_162_t) (node_39);
			 {
			    obj_t arg2548_3229;
			    arg2548_3229 = patch__227_cfa_tvector((((app_ly_162_t) CREF(node_3227))->fun));
			    {
			       obj_t res2753_3782;
			       {
				  node_t val1214_3781;
				  val1214_3781 = (node_t) (arg2548_3229);
				  {
				     obj_t x_4380;
				     x_4380 = ((((app_ly_162_t) CREF(node_3227))->fun) = ((node_t) val1214_3781), BUNSPEC);
				     res2753_3782 = BUNSPEC;
				  }
			       }
			       res2753_3782;
			    }
			 }
			 {
			    obj_t arg2550_3231;
			    arg2550_3231 = patch__227_cfa_tvector((((app_ly_162_t) CREF(node_3227))->arg));
			    {
			       obj_t res2754_3786;
			       {
				  node_t val1215_3785;
				  val1215_3785 = (node_t) (arg2550_3231);
				  {
				     obj_t x_4381;
				     x_4381 = ((((app_ly_162_t) CREF(node_3227))->arg) = ((node_t) val1215_3785), BUNSPEC);
				     res2754_3786 = BUNSPEC;
				  }
			       }
			       res2754_3786;
			    }
			 }
			 return (obj_t) (node_3227);
		      }
		      break;
		   case ((long) 7):
		      {
			 funcall_t node_3233;
			 node_3233 = (funcall_t) (node_39);
			 {
			    obj_t arg2552_3235;
			    arg2552_3235 = patch__227_cfa_tvector((((funcall_t) CREF(node_3233))->fun));
			    {
			       obj_t res2755_3790;
			       {
				  node_t val1221_3789;
				  val1221_3789 = (node_t) (arg2552_3235);
				  {
				     obj_t x_4382;
				     x_4382 = ((((funcall_t) CREF(node_3233))->fun) = ((node_t) val1221_3789), BUNSPEC);
				     res2755_3790 = BUNSPEC;
				  }
			       }
			       res2755_3790;
			    }
			 }
			 patch___72_cfa_tvector((((funcall_t) CREF(node_3233))->args));
			 return (obj_t) (node_3233);
		      }
		      break;
		   case ((long) 8):
		      {
			 pragma_t node_3238;
			 node_3238 = (pragma_t) (node_39);
			 patch___72_cfa_tvector((((pragma_t) CREF(node_3238))->args));
			 return (obj_t) (node_3238);
		      }
		      break;
		   case ((long) 9):
		      {
			 cast_t node_3241;
			 node_3241 = (cast_t) (node_39);
			 patch__227_cfa_tvector((((cast_t) CREF(node_3241))->arg));
			 return (obj_t) (node_3241);
		      }
		      break;
		   case ((long) 10):
		      {
			 setq_t node_3244;
			 node_3244 = (setq_t) (node_39);
			 {
			    obj_t arg2557_3246;
			    arg2557_3246 = patch__227_cfa_tvector((((setq_t) CREF(node_3244))->value));
			    {
			       obj_t res2756_3797;
			       {
				  node_t val1243_3796;
				  val1243_3796 = (node_t) (arg2557_3246);
				  {
				     obj_t x_4383;
				     x_4383 = ((((setq_t) CREF(node_3244))->value) = ((node_t) val1243_3796), BUNSPEC);
				     res2756_3797 = BUNSPEC;
				  }
			       }
			       res2756_3797;
			    }
			 }
			 {
			    obj_t arg2559_3248;
			    {
			       node_t aux_5030;
			       {
				  var_t aux_5031;
				  aux_5031 = (((setq_t) CREF(node_3244))->var);
				  aux_5030 = (node_t) (aux_5031);
			       }
			       arg2559_3248 = patch__227_cfa_tvector(aux_5030);
			    }
			    {
			       obj_t res2757_3801;
			       {
				  var_t val1242_3800;
				  val1242_3800 = (var_t) (arg2559_3248);
				  {
				     obj_t x_4384;
				     x_4384 = ((((setq_t) CREF(node_3244))->var) = ((var_t) val1242_3800), BUNSPEC);
				     res2757_3801 = BUNSPEC;
				  }
			       }
			       res2757_3801;
			    }
			 }
			 return (obj_t) (node_3244);
		      }
		      break;
		   case ((long) 11):
		      {
			 conditional_t node_3250;
			 node_3250 = (conditional_t) (node_39);
			 {
			    obj_t arg2561_3252;
			    arg2561_3252 = patch__227_cfa_tvector((((conditional_t) CREF(node_3250))->test));
			    {
			       obj_t res2758_3805;
			       {
				  node_t val1250_3804;
				  val1250_3804 = (node_t) (arg2561_3252);
				  {
				     obj_t x_4385;
				     x_4385 = ((((conditional_t) CREF(node_3250))->test) = ((node_t) val1250_3804), BUNSPEC);
				     res2758_3805 = BUNSPEC;
				  }
			       }
			       res2758_3805;
			    }
			 }
			 {
			    obj_t arg2563_3254;
			    arg2563_3254 = patch__227_cfa_tvector((((conditional_t) CREF(node_3250))->true));
			    {
			       obj_t res2759_3809;
			       {
				  node_t val1251_3808;
				  val1251_3808 = (node_t) (arg2563_3254);
				  {
				     obj_t x_4386;
				     x_4386 = ((((conditional_t) CREF(node_3250))->true) = ((node_t) val1251_3808), BUNSPEC);
				     res2759_3809 = BUNSPEC;
				  }
			       }
			       res2759_3809;
			    }
			 }
			 {
			    obj_t arg2565_3256;
			    arg2565_3256 = patch__227_cfa_tvector((((conditional_t) CREF(node_3250))->false));
			    {
			       obj_t res2760_3813;
			       {
				  node_t val1252_3812;
				  val1252_3812 = (node_t) (arg2565_3256);
				  {
				     obj_t x_4387;
				     x_4387 = ((((conditional_t) CREF(node_3250))->false) = ((node_t) val1252_3812), BUNSPEC);
				     res2760_3813 = BUNSPEC;
				  }
			       }
			       res2760_3813;
			    }
			 }
			 return (obj_t) (node_3250);
		      }
		      break;
		   case ((long) 12):
		      {
			 fail_t node_3258;
			 node_3258 = (fail_t) (node_39);
			 {
			    obj_t arg2567_3260;
			    arg2567_3260 = patch__227_cfa_tvector((((fail_t) CREF(node_3258))->proc));
			    {
			       obj_t res2761_3817;
			       {
				  node_t val1258_3816;
				  val1258_3816 = (node_t) (arg2567_3260);
				  {
				     obj_t x_4388;
				     x_4388 = ((((fail_t) CREF(node_3258))->proc) = ((node_t) val1258_3816), BUNSPEC);
				     res2761_3817 = BUNSPEC;
				  }
			       }
			       res2761_3817;
			    }
			 }
			 {
			    obj_t arg2569_3262;
			    arg2569_3262 = patch__227_cfa_tvector((((fail_t) CREF(node_3258))->msg));
			    {
			       obj_t res2762_3821;
			       {
				  node_t val1259_3820;
				  val1259_3820 = (node_t) (arg2569_3262);
				  {
				     obj_t x_4389;
				     x_4389 = ((((fail_t) CREF(node_3258))->msg) = ((node_t) val1259_3820), BUNSPEC);
				     res2762_3821 = BUNSPEC;
				  }
			       }
			       res2762_3821;
			    }
			 }
			 {
			    obj_t arg2571_3264;
			    arg2571_3264 = patch__227_cfa_tvector((((fail_t) CREF(node_3258))->obj));
			    {
			       obj_t res2763_3825;
			       {
				  node_t val1260_3824;
				  val1260_3824 = (node_t) (arg2571_3264);
				  {
				     obj_t x_4390;
				     x_4390 = ((((fail_t) CREF(node_3258))->obj) = ((node_t) val1260_3824), BUNSPEC);
				     res2763_3825 = BUNSPEC;
				  }
			       }
			       res2763_3825;
			    }
			 }
			 return (obj_t) (node_3258);
		      }
		      break;
		   case ((long) 13):
		      {
			 select_t node_3266;
			 node_3266 = (select_t) (node_39);
			 {
			    obj_t arg2573_3268;
			    arg2573_3268 = patch__227_cfa_tvector((((select_t) CREF(node_3266))->test));
			    {
			       obj_t res2764_3829;
			       {
				  node_t val1267_3828;
				  val1267_3828 = (node_t) (arg2573_3268);
				  {
				     obj_t x_4391;
				     x_4391 = ((((select_t) CREF(node_3266))->test) = ((node_t) val1267_3828), BUNSPEC);
				     res2764_3829 = BUNSPEC;
				  }
			       }
			       res2764_3829;
			    }
			 }
			 {
			    obj_t l1928_3270;
			    l1928_3270 = (((select_t) CREF(node_3266))->clauses);
			  lname1929_3271:
			    if (PAIRP(l1928_3270))
			      {
				 {
				    obj_t clause_3274;
				    clause_3274 = CAR(l1928_3270);
				    {
				       obj_t arg2577_3275;
				       {
					  node_t aux_5074;
					  {
					     obj_t aux_5075;
					     aux_5075 = CDR(clause_3274);
					     aux_5074 = (node_t) (aux_5075);
					  }
					  arg2577_3275 = patch__227_cfa_tvector(aux_5074);
				       }
				       SET_CDR(clause_3274, arg2577_3275);
				    }
				 }
				 {
				    obj_t l1928_5080;
				    l1928_5080 = CDR(l1928_3270);
				    l1928_3270 = l1928_5080;
				    goto lname1929_3271;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 return (obj_t) (node_3266);
		      }
		      break;
		   case ((long) 14):
		      {
			 let_fun_218_t node_3278;
			 node_3278 = (let_fun_218_t) (node_39);
			 {
			    obj_t l1931_3280;
			    l1931_3280 = (((let_fun_218_t) CREF(node_3278))->locals);
			  lname1932_3281:
			    if (PAIRP(l1931_3280))
			      {
				 patch_fun__141_cfa_tvector(CAR(l1931_3280));
				 {
				    obj_t l1931_5089;
				    l1931_5089 = CDR(l1931_3280);
				    l1931_3280 = l1931_5089;
				    goto lname1932_3281;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    obj_t arg2584_3286;
			    arg2584_3286 = patch__227_cfa_tvector((((let_fun_218_t) CREF(node_3278))->body));
			    {
			       obj_t res2765_3844;
			       {
				  node_t val1275_3843;
				  val1275_3843 = (node_t) (arg2584_3286);
				  {
				     obj_t x_4392;
				     x_4392 = ((((let_fun_218_t) CREF(node_3278))->body) = ((node_t) val1275_3843), BUNSPEC);
				     res2765_3844 = BUNSPEC;
				  }
			       }
			       res2765_3844;
			    }
			 }
			 return (obj_t) (node_3278);
		      }
		      break;
		   case ((long) 15):
		      {
			 let_var_6_t node_3288;
			 node_3288 = (let_var_6_t) (node_39);
			 {
			    obj_t l1934_3290;
			    l1934_3290 = (((let_var_6_t) CREF(node_3288))->bindings);
			  lname1935_3291:
			    if (PAIRP(l1934_3290))
			      {
				 {
				    obj_t binding_3294;
				    binding_3294 = CAR(l1934_3290);
				    {
				       obj_t arg2588_3296;
				       {
					  node_t aux_5101;
					  {
					     obj_t aux_5102;
					     aux_5102 = CDR(binding_3294);
					     aux_5101 = (node_t) (aux_5102);
					  }
					  arg2588_3296 = patch__227_cfa_tvector(aux_5101);
				       }
				       SET_CDR(binding_3294, arg2588_3296);
				    }
				 }
				 {
				    obj_t l1934_5107;
				    l1934_5107 = CDR(l1934_3290);
				    l1934_3290 = l1934_5107;
				    goto lname1935_3291;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    obj_t arg2590_3298;
			    arg2590_3298 = patch__227_cfa_tvector((((let_var_6_t) CREF(node_3288))->body));
			    {
			       obj_t res2766_3855;
			       {
				  node_t val1283_3854;
				  val1283_3854 = (node_t) (arg2590_3298);
				  {
				     obj_t x_4393;
				     x_4393 = ((((let_var_6_t) CREF(node_3288))->body) = ((node_t) val1283_3854), BUNSPEC);
				     res2766_3855 = BUNSPEC;
				  }
			       }
			       res2766_3855;
			    }
			 }
			 return (obj_t) (node_3288);
		      }
		      break;
		   case ((long) 16):
		      {
			 set_ex_it_116_t node_3300;
			 node_3300 = (set_ex_it_116_t) (node_39);
			 {
			    obj_t arg2592_3302;
			    arg2592_3302 = patch__227_cfa_tvector((((set_ex_it_116_t) CREF(node_3300))->body));
			    {
			       obj_t res2767_3859;
			       {
				  node_t val1291_3858;
				  val1291_3858 = (node_t) (arg2592_3302);
				  {
				     obj_t x_4394;
				     x_4394 = ((((set_ex_it_116_t) CREF(node_3300))->body) = ((node_t) val1291_3858), BUNSPEC);
				     res2767_3859 = BUNSPEC;
				  }
			       }
			       res2767_3859;
			    }
			 }
			 {
			    node_t aux_5120;
			    {
			       var_t aux_5121;
			       aux_5121 = (((set_ex_it_116_t) CREF(node_3300))->var);
			       aux_5120 = (node_t) (aux_5121);
			    }
			    patch__227_cfa_tvector(aux_5120);
			 }
			 return (obj_t) (node_3300);
		      }
		      break;
		   case ((long) 17):
		      {
			 jump_ex_it_184_t node_3305;
			 node_3305 = (jump_ex_it_184_t) (node_39);
			 {
			    obj_t arg2595_3307;
			    arg2595_3307 = patch__227_cfa_tvector((((jump_ex_it_184_t) CREF(node_3305))->exit));
			    {
			       obj_t res2768_3864;
			       {
				  node_t val1297_3863;
				  val1297_3863 = (node_t) (arg2595_3307);
				  {
				     obj_t x_4395;
				     x_4395 = ((((jump_ex_it_184_t) CREF(node_3305))->exit) = ((node_t) val1297_3863), BUNSPEC);
				     res2768_3864 = BUNSPEC;
				  }
			       }
			       res2768_3864;
			    }
			 }
			 {
			    obj_t arg2597_3309;
			    arg2597_3309 = patch__227_cfa_tvector((((jump_ex_it_184_t) CREF(node_3305))->value));
			    {
			       obj_t res2769_3868;
			       {
				  node_t val1298_3867;
				  val1298_3867 = (node_t) (arg2597_3309);
				  {
				     obj_t x_4396;
				     x_4396 = ((((jump_ex_it_184_t) CREF(node_3305))->value) = ((node_t) val1298_3867), BUNSPEC);
				     res2769_3868 = BUNSPEC;
				  }
			       }
			       res2769_3868;
			    }
			 }
			 return (obj_t) (node_3305);
		      }
		      break;
		   case ((long) 18):
		      {
			 make_box_202_t node_3311;
			 node_3311 = (make_box_202_t) (node_39);
			 {
			    obj_t arg2599_3313;
			    arg2599_3313 = patch__227_cfa_tvector((((make_box_202_t) CREF(node_3311))->value));
			    {
			       obj_t res2770_3872;
			       {
				  node_t val1305_3871;
				  val1305_3871 = (node_t) (arg2599_3313);
				  {
				     obj_t x_4397;
				     x_4397 = ((((make_box_202_t) CREF(node_3311))->value) = ((node_t) val1305_3871), BUNSPEC);
				     res2770_3872 = BUNSPEC;
				  }
			       }
			       res2770_3872;
			    }
			 }
			 return (obj_t) (node_3311);
		      }
		      break;
		   case ((long) 19):
		      {
			 box_set__221_t node_3315;
			 node_3315 = (box_set__221_t) (node_39);
			 {
			    obj_t arg2601_3317;
			    {
			       node_t aux_5143;
			       {
				  var_t aux_5144;
				  aux_5144 = (((box_set__221_t) CREF(node_3315))->var);
				  aux_5143 = (node_t) (aux_5144);
			       }
			       arg2601_3317 = patch__227_cfa_tvector(aux_5143);
			    }
			    {
			       obj_t res2771_3876;
			       {
				  var_t val1318_3875;
				  val1318_3875 = (var_t) (arg2601_3317);
				  {
				     obj_t x_4398;
				     x_4398 = ((((box_set__221_t) CREF(node_3315))->var) = ((var_t) val1318_3875), BUNSPEC);
				     res2771_3876 = BUNSPEC;
				  }
			       }
			       res2771_3876;
			    }
			 }
			 {
			    obj_t arg2603_3319;
			    arg2603_3319 = patch__227_cfa_tvector((((box_set__221_t) CREF(node_3315))->value));
			    {
			       obj_t res2772_3880;
			       {
				  node_t val1319_3879;
				  val1319_3879 = (node_t) (arg2603_3319);
				  {
				     obj_t x_4399;
				     x_4399 = ((((box_set__221_t) CREF(node_3315))->value) = ((node_t) val1319_3879), BUNSPEC);
				     res2772_3880 = BUNSPEC;
				  }
			       }
			       res2772_3880;
			    }
			 }
			 return (obj_t) (node_3315);
		      }
		      break;
		   case ((long) 20):
		      {
			 box_ref_242_t node_3321;
			 node_3321 = (box_ref_242_t) (node_39);
			 {
			    obj_t arg2605_3323;
			    {
			       node_t aux_5156;
			       {
				  var_t aux_5157;
				  aux_5157 = (((box_ref_242_t) CREF(node_3321))->var);
				  aux_5156 = (node_t) (aux_5157);
			       }
			       arg2605_3323 = patch__227_cfa_tvector(aux_5156);
			    }
			    {
			       obj_t res2773_3884;
			       {
				  var_t val1312_3883;
				  val1312_3883 = (var_t) (arg2605_3323);
				  {
				     obj_t x_4400;
				     x_4400 = ((((box_ref_242_t) CREF(node_3321))->var) = ((var_t) val1312_3883), BUNSPEC);
				     res2773_3884 = BUNSPEC;
				  }
			       }
			       res2773_3884;
			    }
			 }
			 return (obj_t) (node_3321);
		      }
		      break;
		   case ((long) 21):
		      {
			 app_t node_3325;
			 node_3325 = (app_t) (node_39);
			 patch___72_cfa_tvector((((app_t) CREF(node_3325))->args));
			 {
			    obj_t arg2608_3328;
			    {
			       node_t aux_5167;
			       {
				  var_t aux_5168;
				  aux_5168 = (((app_t) CREF(node_3325))->fun);
				  aux_5167 = (node_t) (aux_5168);
			       }
			       arg2608_3328 = patch__227_cfa_tvector(aux_5167);
			    }
			    {
			       obj_t res2774_3889;
			       {
				  var_t val1206_3888;
				  val1206_3888 = (var_t) (arg2608_3328);
				  {
				     obj_t x_4401;
				     x_4401 = ((((app_t) CREF(node_3325))->fun) = ((var_t) val1206_3888), BUNSPEC);
				     res2774_3889 = BUNSPEC;
				  }
			       }
			       res2774_3889;
			    }
			 }
			 {
			    variable_t v_3330;
			    {
			       var_t arg2623_3345;
			       arg2623_3345 = (((app_t) CREF(node_3325))->fun);
			       v_3330 = (((var_t) CREF(arg2623_3345))->variable);
			    }
			    {
			       bool_t test2610_3331;
			       test2610_3331 = is_a__118___object((obj_t) (v_3330), global_ast_var);
			       if (test2610_3331)
				 {
				    bool_t test2611_3332;
				    {
				       obj_t aux_5179;
				       {
					  value_t aux_5180;
					  aux_5180 = (((variable_t) CREF(v_3330))->value);
					  aux_5179 = (obj_t) (aux_5180);
				       }
				       test2611_3332 = is_a__118___object(aux_5179, cfun_ast_var);
				    }
				    if (test2611_3332)
				      {
					 obj_t case_value_58_3333;
					 {
					    global_t obj_3895;
					    obj_3895 = (global_t) (v_3330);
					    case_value_58_3333 = (((global_t) CREF(obj_3895))->id);
					 }
					 {
					    bool_t test_5187;
					    {
					       obj_t aux_5188;
					       aux_5188 = CNST_TABLE_REF(((long) 12));
					       test_5187 = (case_value_58_3333 == aux_5188);
					    }
					    if (test_5187)
					      {
						 return patch_vector_length__86_cfa_tvector(node_3325);
					      }
					    else
					      {
						 bool_t test_5192;
						 {
						    obj_t aux_5193;
						    aux_5193 = CNST_TABLE_REF(((long) 1));
						    test_5192 = (case_value_58_3333 == aux_5193);
						 }
						 if (test_5192)
						   {
						      return patch_vector___0_cfa_tvector(node_3325);
						   }
						 else
						   {
						      return (obj_t) (node_3325);
						   }
					      }
					 }
				      }
				    else
				      {
					 bool_t test_5198;
					 {
					    bool_t test_5199;
					    {
					       obj_t aux_5203;
					       obj_t aux_5200;
					       aux_5203 = CNST_TABLE_REF(((long) 13));
					       {
						  global_t obj_3900;
						  obj_3900 = (global_t) (v_3330);
						  aux_5200 = (((global_t) CREF(obj_3900))->id);
					       }
					       test_5199 = (aux_5200 == aux_5203);
					    }
					    if (test_5199)
					      {
						 obj_t aux_5209;
						 obj_t aux_5206;
						 aux_5209 = CNST_TABLE_REF(((long) 14));
						 {
						    global_t obj_3903;
						    obj_3903 = (global_t) (v_3330);
						    aux_5206 = (((global_t) CREF(obj_3903))->module);
						 }
						 test_5198 = (aux_5206 == aux_5209);
					      }
					    else
					      {
						 test_5198 = ((bool_t) 0);
					      }
					 }
					 if (test_5198)
					   {
					      return patch_vector__list__149_cfa_tvector(node_3325);
					   }
					 else
					   {
					      return (obj_t) (node_3325);
					   }
				      }
				 }
			       else
				 {
				    return (obj_t) (node_3325);
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 22):
		      {
			 make_vector_app_205_t node_3346;
			 node_3346 = (make_vector_app_205_t) (node_39);
			 {
			    obj_t aux_5216;
			    {
			       app_t obj_3906;
			       obj_3906 = (app_t) (node_3346);
			       aux_5216 = (((app_t) CREF(obj_3906))->args);
			    }
			    patch___72_cfa_tvector(aux_5216);
			 }
			 {
			    type_t type_3349;
			    {
			       approx_t arg2648_3375;
			       {
				  obj_t aux_5220;
				  {
				     object_t aux_5221;
				     aux_5221 = (object_t) (node_3346);
				     aux_5220 = OBJECT_WIDENING(aux_5221);
				  }
				  arg2648_3375 = (((make_vector_app_205_t) CREF(aux_5220))->value_approx_19);
			       }
			       type_3349 = (((approx_t) CREF(arg2648_3375))->type);
			    }
			    {
			       obj_t tv_3350;
			       tv_3350 = (((type_t) CREF(type_3349))->tvector);
			       {
				  {
				     bool_t test2625_3351;
				     test2625_3351 = is_a__118___object(tv_3350, type_type_type);
				     if (test2625_3351)
				       {
					  obj_t make_tv_69_3352;
					  {
					     obj_t arg2643_3370;
					     arg2643_3370 = CNST_TABLE_REF(((long) 15));
					     {
						obj_t list2645_3372;
						{
						   obj_t arg2646_3373;
						   {
						      obj_t aux_5230;
						      {
							 type_t obj_3911;
							 obj_3911 = (type_t) (tv_3350);
							 aux_5230 = (((type_t) CREF(obj_3911))->id);
						      }
						      arg2646_3373 = MAKE_PAIR(aux_5230, BNIL);
						   }
						   list2645_3372 = MAKE_PAIR(arg2643_3370, arg2646_3373);
						}
						make_tv_69_3352 = symbol_append_197___r4_symbols_6_4(list2645_3372);
					     }
					  }
					  {
					     node_t new_node_11_3353;
					     {
						obj_t arg2631_3359;
						obj_t arg2633_3361;
						obj_t arg2634_3362;
						{
						   obj_t arg2636_3363;
						   {
						      obj_t arg2639_3366;
						      obj_t arg2640_3367;
						      {
							 app_t obj_3912;
							 obj_3912 = (app_t) (node_3346);
							 arg2639_3366 = (((app_t) CREF(obj_3912))->args);
						      }
						      arg2640_3367 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
						      arg2636_3363 = append_2_18___r4_pairs_and_lists_6_3(arg2639_3366, arg2640_3367);
						   }
						   {
						      obj_t list2637_3364;
						      list2637_3364 = MAKE_PAIR(arg2636_3363, BNIL);
						      arg2631_3359 = cons__138___r4_pairs_and_lists_6_3(make_tv_69_3352, list2637_3364);
						   }
						}
						{
						   app_t obj_3913;
						   obj_3913 = (app_t) (node_3346);
						   arg2633_3361 = (((app_t) CREF(obj_3913))->loc);
						}
						arg2634_3362 = CNST_TABLE_REF(((long) 16));
						new_node_11_3353 = sexp__node_235_ast_sexp(arg2631_3359, BNIL, arg2633_3361, arg2634_3362);
					     }
					     {
						{
						   obj_t res2775_3916;
						   {
						      type_t val1164_3915;
						      val1164_3915 = (type_t) (tv_3350);
						      {
							 obj_t x_4402;
							 x_4402 = ((((node_t) CREF(new_node_11_3353))->type) = ((type_t) val1164_3915), BUNSPEC);
							 res2775_3916 = BUNSPEC;
						      }
						   }
						   res2775_3916;
						}
						{
						   node_t arg2626_3354;
						   {
						      bool_t test2629_3357;
						      test2629_3357 = stack_optimization__133_cfa_stack();
						      if (test2629_3357)
							{
							   bool_t aux_5250;
							   {
							      obj_t aux_5252;
							      {
								 object_t aux_5253;
								 aux_5253 = (object_t) (node_3346);
								 aux_5252 = OBJECT_WIDENING(aux_5253);
							      }
							      aux_5250 = (((make_vector_app_205_t) CREF(aux_5252))->stackable__42);
							   }
							   arg2626_3354 = node_heap__stack__239_cfa_stack((app_t) (new_node_11_3353), aux_5250);
							}
						      else
							{
							   arg2626_3354 = new_node_11_3353;
							}
						   }
						   {
						      node_t aux_5258;
						      aux_5258 = inline_node_218_inline_inline(arg2626_3354, ((long) 1), BNIL);
						      return (obj_t) (aux_5258);
						   }
						}
					     }
					  }
				       }
				     else
				       {
					  return (obj_t) (node_3346);
				       }
				  }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 23):
		      {
			 create_vector_app_150_t node_3376;
			 node_3376 = (create_vector_app_150_t) (node_39);
			 {
			    obj_t aux_5263;
			    {
			       app_t obj_3918;
			       obj_3918 = (app_t) (node_3376);
			       aux_5263 = (((app_t) CREF(obj_3918))->args);
			    }
			    patch___72_cfa_tvector(aux_5263);
			 }
			 {
			    type_t type_3379;
			    {
			       approx_t arg2672_3405;
			       {
				  obj_t aux_5267;
				  {
				     object_t aux_5268;
				     aux_5268 = (object_t) (node_3376);
				     aux_5267 = OBJECT_WIDENING(aux_5268);
				  }
				  arg2672_3405 = (((create_vector_app_150_t) CREF(aux_5267))->value_approx_19);
			       }
			       type_3379 = (((approx_t) CREF(arg2672_3405))->type);
			    }
			    {
			       obj_t tv_3380;
			       tv_3380 = (((type_t) CREF(type_3379))->tvector);
			       {
				  {
				     bool_t test2650_3381;
				     test2650_3381 = is_a__118___object(tv_3380, type_type_type);
				     if (test2650_3381)
				       {
					  obj_t create_tv_3_3382;
					  {
					     obj_t arg2667_3400;
					     arg2667_3400 = CNST_TABLE_REF(((long) 17));
					     {
						obj_t list2669_3402;
						{
						   obj_t arg2670_3403;
						   {
						      obj_t aux_5277;
						      {
							 type_t obj_3923;
							 obj_3923 = (type_t) (tv_3380);
							 aux_5277 = (((type_t) CREF(obj_3923))->id);
						      }
						      arg2670_3403 = MAKE_PAIR(aux_5277, BNIL);
						   }
						   list2669_3402 = MAKE_PAIR(arg2667_3400, arg2670_3403);
						}
						create_tv_3_3382 = symbol_append_197___r4_symbols_6_4(list2669_3402);
					     }
					  }
					  {
					     node_t new_node_11_3383;
					     {
						obj_t arg2656_3389;
						obj_t arg2658_3391;
						obj_t arg2659_3392;
						{
						   obj_t arg2660_3393;
						   {
						      obj_t arg2663_3396;
						      obj_t arg2664_3397;
						      {
							 app_t obj_3924;
							 obj_3924 = (app_t) (node_3376);
							 arg2663_3396 = (((app_t) CREF(obj_3924))->args);
						      }
						      arg2664_3397 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
						      arg2660_3393 = append_2_18___r4_pairs_and_lists_6_3(arg2663_3396, arg2664_3397);
						   }
						   {
						      obj_t list2661_3394;
						      list2661_3394 = MAKE_PAIR(arg2660_3393, BNIL);
						      arg2656_3389 = cons__138___r4_pairs_and_lists_6_3(create_tv_3_3382, list2661_3394);
						   }
						}
						{
						   app_t obj_3925;
						   obj_3925 = (app_t) (node_3376);
						   arg2658_3391 = (((app_t) CREF(obj_3925))->loc);
						}
						arg2659_3392 = CNST_TABLE_REF(((long) 16));
						new_node_11_3383 = sexp__node_235_ast_sexp(arg2656_3389, BNIL, arg2658_3391, arg2659_3392);
					     }
					     {
						{
						   obj_t res2776_3928;
						   {
						      type_t val1164_3927;
						      val1164_3927 = (type_t) (tv_3380);
						      {
							 obj_t x_4403;
							 x_4403 = ((((node_t) CREF(new_node_11_3383))->type) = ((type_t) val1164_3927), BUNSPEC);
							 res2776_3928 = BUNSPEC;
						      }
						   }
						   res2776_3928;
						}
						{
						   node_t arg2651_3384;
						   {
						      bool_t test2654_3387;
						      test2654_3387 = stack_optimization__133_cfa_stack();
						      if (test2654_3387)
							{
							   bool_t aux_5297;
							   {
							      obj_t aux_5299;
							      {
								 object_t aux_5300;
								 aux_5300 = (object_t) (node_3376);
								 aux_5299 = OBJECT_WIDENING(aux_5300);
							      }
							      aux_5297 = (((create_vector_app_150_t) CREF(aux_5299))->stackable__42);
							   }
							   arg2651_3384 = node_heap__stack__239_cfa_stack((app_t) (new_node_11_3383), aux_5297);
							}
						      else
							{
							   arg2651_3384 = new_node_11_3383;
							}
						   }
						   {
						      node_t aux_5305;
						      aux_5305 = inline_node_218_inline_inline(arg2651_3384, ((long) 1), BNIL);
						      return (obj_t) (aux_5305);
						   }
						}
					     }
					  }
				       }
				     else
				       {
					  return (obj_t) (node_3376);
				       }
				  }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 24):
		      {
			 vector_ref_app_195_t node_3406;
			 node_3406 = (vector_ref_app_195_t) (node_39);
			 {
			    obj_t aux_5310;
			    {
			       app_t obj_3930;
			       obj_3930 = (app_t) (node_3406);
			       aux_5310 = (((app_t) CREF(obj_3930))->args);
			    }
			    patch___72_cfa_tvector(aux_5310);
			 }
			 {
			    approx_t vec_approx_215_3409;
			    {
			       node_t aux_5314;
			       {
				  obj_t aux_5315;
				  {
				     obj_t aux_5316;
				     {
					app_t obj_3931;
					obj_3931 = (app_t) (node_3406);
					aux_5316 = (((app_t) CREF(obj_3931))->args);
				     }
				     aux_5315 = CAR(aux_5316);
				  }
				  aux_5314 = (node_t) (aux_5315);
			       }
			       vec_approx_215_3409 = cfa__102_cfa_cfa(aux_5314);
			    }
			    {
			       obj_t tv_3410;
			       tv_3410 = get_approx_type_210_cfa_type(vec_approx_215_3409);
			       {
				  {
				     bool_t test2674_3411;
				     test2674_3411 = is_a__118___object(tv_3410, tvec_tvector_tvector);
				     if (test2674_3411)
				       {
					  obj_t tv_ref_74_3412;
					  {
					     obj_t arg2688_3427;
					     {
						type_t obj_3934;
						obj_3934 = (type_t) (tv_3410);
						arg2688_3427 = (((type_t) CREF(obj_3934))->id);
					     }
					     {
						obj_t list2690_3429;
						{
						   obj_t arg2691_3430;
						   {
						      obj_t aux_5327;
						      aux_5327 = CNST_TABLE_REF(((long) 18));
						      arg2691_3430 = MAKE_PAIR(aux_5327, BNIL);
						   }
						   list2690_3429 = MAKE_PAIR(arg2688_3427, arg2691_3430);
						}
						tv_ref_74_3412 = symbol_append_197___r4_symbols_6_4(list2690_3429);
					     }
					  }
					  {
					     node_t new_node_11_3413;
					     {
						obj_t arg2677_3416;
						obj_t arg2679_3418;
						obj_t arg2680_3419;
						{
						   obj_t arg2681_3420;
						   {
						      obj_t arg2684_3423;
						      obj_t arg2685_3424;
						      {
							 app_t obj_3935;
							 obj_3935 = (app_t) (node_3406);
							 arg2684_3423 = (((app_t) CREF(obj_3935))->args);
						      }
						      arg2685_3424 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
						      arg2681_3420 = append_2_18___r4_pairs_and_lists_6_3(arg2684_3423, arg2685_3424);
						   }
						   {
						      obj_t list2682_3421;
						      list2682_3421 = MAKE_PAIR(arg2681_3420, BNIL);
						      arg2677_3416 = cons__138___r4_pairs_and_lists_6_3(tv_ref_74_3412, list2682_3421);
						   }
						}
						{
						   app_t obj_3936;
						   obj_3936 = (app_t) (node_3406);
						   arg2679_3418 = (((app_t) CREF(obj_3936))->loc);
						}
						arg2680_3419 = CNST_TABLE_REF(((long) 16));
						new_node_11_3413 = sexp__node_235_ast_sexp(arg2677_3416, BNIL, arg2679_3418, arg2680_3419);
					     }
					     {
						{
						   node_t aux_5342;
						   aux_5342 = inline_node_218_inline_inline(new_node_11_3413, ((long) 1), BNIL);
						   return (obj_t) (aux_5342);
						}
					     }
					  }
				       }
				     else
				       {
					  return (obj_t) (node_3406);
				       }
				  }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 25):
		      {
			 vector_set__app_21_t node_3434;
			 node_3434 = (vector_set__app_21_t) (node_39);
			 {
			    obj_t aux_5347;
			    {
			       app_t obj_3937;
			       obj_3937 = (app_t) (node_3434);
			       aux_5347 = (((app_t) CREF(obj_3937))->args);
			    }
			    patch___72_cfa_tvector(aux_5347);
			 }
			 {
			    approx_t vec_approx_215_3437;
			    {
			       node_t aux_5351;
			       {
				  obj_t aux_5352;
				  {
				     obj_t aux_5353;
				     {
					app_t obj_3938;
					obj_3938 = (app_t) (node_3434);
					aux_5353 = (((app_t) CREF(obj_3938))->args);
				     }
				     aux_5352 = CAR(aux_5353);
				  }
				  aux_5351 = (node_t) (aux_5352);
			       }
			       vec_approx_215_3437 = cfa__102_cfa_cfa(aux_5351);
			    }
			    {
			       obj_t tv_3438;
			       tv_3438 = get_approx_type_210_cfa_type(vec_approx_215_3437);
			       {
				  {
				     bool_t test2696_3439;
				     test2696_3439 = is_a__118___object(tv_3438, tvec_tvector_tvector);
				     if (test2696_3439)
				       {
					  obj_t tv_set__238_3440;
					  {
					     obj_t arg2710_3455;
					     {
						type_t obj_3941;
						obj_3941 = (type_t) (tv_3438);
						arg2710_3455 = (((type_t) CREF(obj_3941))->id);
					     }
					     {
						obj_t list2712_3457;
						{
						   obj_t arg2713_3458;
						   {
						      obj_t aux_5364;
						      aux_5364 = CNST_TABLE_REF(((long) 19));
						      arg2713_3458 = MAKE_PAIR(aux_5364, BNIL);
						   }
						   list2712_3457 = MAKE_PAIR(arg2710_3455, arg2713_3458);
						}
						tv_set__238_3440 = symbol_append_197___r4_symbols_6_4(list2712_3457);
					     }
					  }
					  {
					     node_t new_node_11_3441;
					     {
						obj_t arg2699_3444;
						obj_t arg2701_3446;
						obj_t arg2702_3447;
						{
						   obj_t arg2703_3448;
						   {
						      obj_t arg2706_3451;
						      obj_t arg2707_3452;
						      {
							 app_t obj_3942;
							 obj_3942 = (app_t) (node_3434);
							 arg2706_3451 = (((app_t) CREF(obj_3942))->args);
						      }
						      arg2707_3452 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
						      arg2703_3448 = append_2_18___r4_pairs_and_lists_6_3(arg2706_3451, arg2707_3452);
						   }
						   {
						      obj_t list2704_3449;
						      list2704_3449 = MAKE_PAIR(arg2703_3448, BNIL);
						      arg2699_3444 = cons__138___r4_pairs_and_lists_6_3(tv_set__238_3440, list2704_3449);
						   }
						}
						{
						   app_t obj_3943;
						   obj_3943 = (app_t) (node_3434);
						   arg2701_3446 = (((app_t) CREF(obj_3943))->loc);
						}
						arg2702_3447 = CNST_TABLE_REF(((long) 16));
						new_node_11_3441 = sexp__node_235_ast_sexp(arg2699_3444, BNIL, arg2701_3446, arg2702_3447);
					     }
					     {
						{
						   node_t aux_5379;
						   aux_5379 = inline_node_218_inline_inline(new_node_11_3441, ((long) 1), BNIL);
						   return (obj_t) (aux_5379);
						}
					     }
					  }
				       }
				     else
				       {
					  return (obj_t) (node_3434);
				       }
				  }
			       }
			    }
			 }
		      }
		      break;
		   default:
		    case_else2524_253_3194:
		      if (PROCEDUREP(method2518_3190))
			{
			   return PROCEDURE_ENTRY(method2518_3190) (method2518_3190, (obj_t) (node_39), BEOA);
			}
		      else
			{
			   obj_t fun2206_2354;
			   fun2206_2354 = PROCEDURE_REF(patch__env_129_cfa_tvector, ((long) 0));
			   return PROCEDURE_ENTRY(fun2206_2354) (fun2206_2354, (obj_t) (node_39), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else2524_253_3194;
	      }
	 }
      }
   }
}


obj_t 
_patch__77_cfa_tvector(obj_t env_4361, obj_t node_4362)
{
   return patch__227_cfa_tvector((node_t) (node_4362));
}


obj_t 
patch___72_cfa_tvector(obj_t node__221_62)
{
   {
      obj_t node__221_2355;
      node__221_2355 = node__221_62;
    loop_2356:
      if (NULLP(node__221_2355))
	{
	   return CNST_TABLE_REF(((long) 20));
	}
      else
	{
	   {
	      obj_t arg2208_2358;
	      {
		 node_t aux_5399;
		 {
		    obj_t aux_5400;
		    aux_5400 = CAR(node__221_2355);
		    aux_5399 = (node_t) (aux_5400);
		 }
		 arg2208_2358 = patch__227_cfa_tvector(aux_5399);
	      }
	      SET_CAR(node__221_2355, arg2208_2358);
	   }
	   {
	      obj_t node__221_5405;
	      node__221_5405 = CDR(node__221_2355);
	      node__221_2355 = node__221_5405;
	      goto loop_2356;
	   }
	}
   }
}


obj_t 
patch_vector_length__86_cfa_tvector(app_t node_64)
{
   patch___72_cfa_tvector((((app_t) CREF(node_64))->args));
   {
      approx_t approx_2363;
      {
	 node_t aux_5409;
	 {
	    obj_t aux_5410;
	    {
	       obj_t aux_5411;
	       aux_5411 = (((app_t) CREF(node_64))->args);
	       aux_5410 = CAR(aux_5411);
	    }
	    aux_5409 = (node_t) (aux_5410);
	 }
	 approx_2363 = cfa__102_cfa_cfa(aux_5409);
      }
      {
	 obj_t tv_2364;
	 tv_2364 = get_approx_type_210_cfa_type(approx_2363);
	 {
	    {
	       bool_t test2212_2365;
	       test2212_2365 = is_a__118___object(tv_2364, tvec_tvector_tvector);
	       if (test2212_2365)
		 {
		    obj_t length_tv_142_2366;
		    {
		       obj_t arg2226_2381;
		       {
			  type_t obj_3955;
			  obj_3955 = (type_t) (tv_2364);
			  arg2226_2381 = (((type_t) CREF(obj_3955))->id);
		       }
		       {
			  obj_t list2228_2383;
			  {
			     obj_t arg2229_2384;
			     {
				obj_t aux_5421;
				aux_5421 = CNST_TABLE_REF(((long) 21));
				arg2229_2384 = MAKE_PAIR(aux_5421, BNIL);
			     }
			     list2228_2383 = MAKE_PAIR(arg2226_2381, arg2229_2384);
			  }
			  length_tv_142_2366 = symbol_append_197___r4_symbols_6_4(list2228_2383);
		       }
		    }
		    {
		       node_t new_node_11_2367;
		       {
			  obj_t arg2215_2370;
			  obj_t arg2217_2372;
			  obj_t arg2218_2373;
			  {
			     obj_t arg2219_2374;
			     {
				obj_t arg2222_2377;
				obj_t arg2223_2378;
				arg2222_2377 = (((app_t) CREF(node_64))->args);
				arg2223_2378 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
				arg2219_2374 = append_2_18___r4_pairs_and_lists_6_3(arg2222_2377, arg2223_2378);
			     }
			     {
				obj_t list2220_2375;
				list2220_2375 = MAKE_PAIR(arg2219_2374, BNIL);
				arg2215_2370 = cons__138___r4_pairs_and_lists_6_3(length_tv_142_2366, list2220_2375);
			     }
			  }
			  arg2217_2372 = (((app_t) CREF(node_64))->loc);
			  arg2218_2373 = CNST_TABLE_REF(((long) 16));
			  new_node_11_2367 = sexp__node_235_ast_sexp(arg2215_2370, BNIL, arg2217_2372, arg2218_2373);
		       }
		       {
			  {
			     obj_t res2778_3960;
			     {
				type_t val1164_3959;
				val1164_3959 = (type_t) (__long__149_type_cache);
				{
				   obj_t x_4404;
				   x_4404 = ((((node_t) CREF(new_node_11_2367))->type) = ((type_t) val1164_3959), BUNSPEC);
				   res2778_3960 = BUNSPEC;
				}
			     }
			     res2778_3960;
			  }
			  {
			     node_t aux_5436;
			     aux_5436 = inline_node_218_inline_inline(new_node_11_2367, ((long) 1), BNIL);
			     return (obj_t) (aux_5436);
			  }
		       }
		    }
		 }
	       else
		 {
		    return (obj_t) (node_64);
		 }
	    }
	 }
      }
   }
}


obj_t 
patch_vector___0_cfa_tvector(app_t node_65)
{
   patch___72_cfa_tvector((((app_t) CREF(node_65))->args));
   {
      approx_t approx_2390;
      {
	 node_t aux_5442;
	 {
	    obj_t aux_5443;
	    {
	       obj_t aux_5444;
	       aux_5444 = (((app_t) CREF(node_65))->args);
	       aux_5443 = CAR(aux_5444);
	    }
	    aux_5442 = (node_t) (aux_5443);
	 }
	 approx_2390 = cfa__102_cfa_cfa(aux_5442);
      }
      {
	 {
	    bool_t test2234_2392;
	    {
	       obj_t obj2_3966;
	       obj2_3966 = __vector__240_type_cache;
	       {
		  obj_t aux_5449;
		  {
		     type_t aux_5450;
		     aux_5450 = (((approx_t) CREF(approx_2390))->type);
		     aux_5449 = (obj_t) (aux_5450);
		  }
		  test2234_2392 = (aux_5449 == obj2_3966);
	       }
	    }
	    if (test2234_2392)
	      {
		 obj_t arg2235_2393;
		 arg2235_2393 = (((app_t) CREF(node_65))->loc);
		 {
		    atom_t res2779_3978;
		    {
		       type_t type_3969;
		       obj_t value_3970;
		       type_3969 = (type_t) (__bool__149_type_cache);
		       value_3970 = BTRUE;
		       {
			  atom_t new1173_3971;
			  new1173_3971 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
			  {
			     long arg2484_3972;
			     arg2484_3972 = class_num_218___object(atom_ast_node);
			     {
				obj_t obj_3976;
				obj_3976 = (obj_t) (new1173_3971);
				(((obj_t) CREF(obj_3976))->header = MAKE_HEADER(arg2484_3972, 0), BUNSPEC);
			     }
			  }
			  {
			     object_t aux_5461;
			     aux_5461 = (object_t) (new1173_3971);
			     OBJECT_WIDENING_SET(aux_5461, BFALSE);
			  }
			  ((((atom_t) CREF(new1173_3971))->loc) = ((obj_t) arg2235_2393), BUNSPEC);
			  ((((atom_t) CREF(new1173_3971))->type) = ((type_t) type_3969), BUNSPEC);
			  ((((atom_t) CREF(new1173_3971))->value) = ((obj_t) value_3970), BUNSPEC);
			  res2779_3978 = new1173_3971;
		       }
		    }
		    return (obj_t) (res2779_3978);
		 }
	      }
	    else
	      {
		 return (obj_t) (node_65);
	      }
	 }
      }
   }
}


obj_t 
patch_vector__list__149_cfa_tvector(app_t node_66)
{
   patch___72_cfa_tvector((((app_t) CREF(node_66))->args));
   {
      approx_t approx_2398;
      {
	 node_t aux_5471;
	 {
	    obj_t aux_5472;
	    {
	       obj_t aux_5473;
	       aux_5473 = (((app_t) CREF(node_66))->args);
	       aux_5472 = CAR(aux_5473);
	    }
	    aux_5471 = (node_t) (aux_5472);
	 }
	 approx_2398 = cfa__102_cfa_cfa(aux_5471);
      }
      {
	 obj_t tv_2399;
	 tv_2399 = get_approx_type_210_cfa_type(approx_2398);
	 {
	    {
	       bool_t test2244_2400;
	       test2244_2400 = is_a__118___object(tv_2399, tvec_tvector_tvector);
	       if (test2244_2400)
		 {
		    obj_t tv__list_235_2401;
		    {
		       obj_t arg2258_2415;
		       {
			  type_t obj_3983;
			  obj_3983 = (type_t) (tv_2399);
			  arg2258_2415 = (((type_t) CREF(obj_3983))->id);
		       }
		       {
			  obj_t list2260_2417;
			  {
			     obj_t arg2261_2418;
			     {
				obj_t aux_5483;
				aux_5483 = CNST_TABLE_REF(((long) 22));
				arg2261_2418 = MAKE_PAIR(aux_5483, BNIL);
			     }
			     list2260_2417 = MAKE_PAIR(arg2258_2415, arg2261_2418);
			  }
			  tv__list_235_2401 = symbol_append_197___r4_symbols_6_4(list2260_2417);
		       }
		    }
		    {
		       node_t new_node_11_2402;
		       {
			  obj_t arg2246_2404;
			  obj_t arg2248_2406;
			  obj_t arg2249_2407;
			  {
			     obj_t arg2250_2408;
			     {
				obj_t arg2254_2411;
				obj_t arg2255_2412;
				arg2254_2411 = (((app_t) CREF(node_66))->args);
				arg2255_2412 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
				arg2250_2408 = append_2_18___r4_pairs_and_lists_6_3(arg2254_2411, arg2255_2412);
			     }
			     {
				obj_t list2251_2409;
				list2251_2409 = MAKE_PAIR(arg2250_2408, BNIL);
				arg2246_2404 = cons__138___r4_pairs_and_lists_6_3(tv__list_235_2401, list2251_2409);
			     }
			  }
			  arg2248_2406 = (((app_t) CREF(node_66))->loc);
			  arg2249_2407 = CNST_TABLE_REF(((long) 16));
			  new_node_11_2402 = sexp__node_235_ast_sexp(arg2246_2404, BNIL, arg2248_2406, arg2249_2407);
		       }
		       {
			  {
			     type_t arg2245_2403;
			     {
				node_t obj_3986;
				obj_3986 = (node_t) (node_66);
				arg2245_2403 = (((node_t) CREF(obj_3986))->type);
			     }
			     {
				obj_t res2780_3989;
				{
				   obj_t x_4405;
				   x_4405 = ((((node_t) CREF(new_node_11_2402))->type) = ((type_t) arg2245_2403), BUNSPEC);
				   res2780_3989 = BUNSPEC;
				}
				res2780_3989;
			     }
			  }
			  return (obj_t) (new_node_11_2402);
		       }
		    }
		 }
	       else
		 {
		    return (obj_t) (node_66);
		 }
	    }
	 }
      }
   }
}


obj_t 
imported_modules_init_94_cfa_tvector()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_TVECTOR");
   module_initialization_70_engine_param(((long) 0), "CFA_TVECTOR");
   module_initialization_70_module_type(((long) 0), "CFA_TVECTOR");
   module_initialization_70_module_pragma(((long) 0), "CFA_TVECTOR");
   module_initialization_70_type_type(((long) 0), "CFA_TVECTOR");
   module_initialization_70_type_cache(((long) 0), "CFA_TVECTOR");
   module_initialization_70_type_env(((long) 0), "CFA_TVECTOR");
   module_initialization_70_tvector_tvector(((long) 0), "CFA_TVECTOR");
   module_initialization_70_tools_shape(((long) 0), "CFA_TVECTOR");
   module_initialization_70_tools_speek(((long) 0), "CFA_TVECTOR");
   module_initialization_70_tools_error(((long) 0), "CFA_TVECTOR");
   module_initialization_70_ast_var(((long) 0), "CFA_TVECTOR");
   module_initialization_70_ast_node(((long) 0), "CFA_TVECTOR");
   module_initialization_70_ast_build(((long) 0), "CFA_TVECTOR");
   module_initialization_70_ast_sexp(((long) 0), "CFA_TVECTOR");
   module_initialization_70_ast_env(((long) 0), "CFA_TVECTOR");
   module_initialization_70_cfa_info(((long) 0), "CFA_TVECTOR");
   module_initialization_70_cfa_cfa(((long) 0), "CFA_TVECTOR");
   module_initialization_70_cfa_approx(((long) 0), "CFA_TVECTOR");
   module_initialization_70_cfa_set(((long) 0), "CFA_TVECTOR");
   module_initialization_70_cfa_type(((long) 0), "CFA_TVECTOR");
   module_initialization_70_cfa_stack(((long) 0), "CFA_TVECTOR");
   module_initialization_70_globalize_walk(((long) 0), "CFA_TVECTOR");
   module_initialization_70_inline_inline(((long) 0), "CFA_TVECTOR");
   return module_initialization_70_inline_walk(((long) 0), "CFA_TVECTOR");
}
