/*===========================================================================*/
/*   (Cfa/type.scm)                                                          */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;

typedef struct tvec
  {
     struct type *item_type_130;
  }
    *tvec_t;


extern obj_t _type_settings__245_cfa_type(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
extern obj_t type_type_type;
extern obj_t svar_cinfo_166_cfa_info;
extern obj_t cvar_cinfo_53_cfa_info;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
extern obj_t fun_ast_var;
extern type_t get_vector_item_type_88_cfa_tvector(app_t);
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_cfa_type();
extern obj_t module_initialization_70_cfa_type(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_set(long, char *);
extern obj_t module_initialization_70_cfa_tvector(long, char *);
extern obj_t module_initialization_70_tvector_tvector(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_cfa_type();
static obj_t cnst_init_137_cfa_type();
extern obj_t tvector_optimization__143_cfa_tvector();
extern obj_t create_vector_app_150_cfa_info;
static obj_t _type_node__11_cfa_type(obj_t, obj_t);
static obj_t type_fun__174_cfa_type(variable_t);
extern obj_t __unsafe_type__146_engine_param;
static obj_t require_initialization_114_cfa_type = BUNSPEC;
extern obj_t scnst_cinfo_0_cfa_info;
extern obj_t var_ast_node;
extern obj_t tvec_tvector_tvector;
static bool_t type_node___42_cfa_type(obj_t);
static obj_t type_variable__default1924_75_cfa_type(value_t, variable_t);
static obj_t library_modules_init_112_cfa_type();
extern obj_t sexit_cinfo_49_cfa_info;
static obj_t _type_variable__default1924_90_cfa_type(obj_t, obj_t, obj_t);
extern obj_t cast_ast_node;
static obj_t set_variable_type__9_cfa_type(variable_t, type_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
static obj_t _type_variable__16_cfa_type(obj_t, obj_t, obj_t);
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
static obj_t _type_node__default1930_80_cfa_type(obj_t, obj_t);
extern obj_t pragma_ast_node;
extern obj_t app_ly_162_ast_node;
extern obj_t __vector__240_type_cache;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t get_approx_type_210_cfa_type(approx_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t type_variable__242_cfa_type(value_t, variable_t);
extern obj_t setq_ast_node;
extern type_t get_default_type_181_type_cache();
extern obj_t approx_cfa_info;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t type_settings__207_cfa_type(obj_t);
extern obj_t kwote_ast_node;
extern obj_t set__list_248_cfa_set(obj_t);
extern obj_t _____74_type_cache;
extern obj_t make_vector_app_205_cfa_info;
extern obj_t box_ref_242_ast_node;
extern obj_t _get_approx_type_72_cfa_type(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t __obj__252_type_cache;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
static obj_t type_node__55_cfa_type(node_t);
extern obj_t intern_sfun_cinfo_192_cfa_info;
extern obj_t app_ast_node;
static obj_t type_node__default1930_248_cfa_type(node_t);
static obj_t __cnst[4];

DEFINE_EXPORT_PROCEDURE(type_settings__env_8_cfa_type, _type_settings__245_cfa_type2363, _type_settings__245_cfa_type, 0L, 1);
DEFINE_STATIC_GENERIC(type_variable__env_200_cfa_type, _type_variable__16_cfa_type2364, _type_variable__16_cfa_type, 0L, 2);
DEFINE_STATIC_PROCEDURE(type_node__default1930_env_124_cfa_type, _type_node__default1930_80_cfa_type2365, _type_node__default1930_80_cfa_type, 0L, 1);
DEFINE_STRING(string2355_cfa_type, string2355_cfa_type2366, "type-node!", 10);
DEFINE_STRING(string2354_cfa_type, string2354_cfa_type2367, "No method for this object", 25);
DEFINE_STRING(string2357_cfa_type, string2357_cfa_type2368, "STATIC TYPE-NODE!-DEFAULT1930 BIGLOO NOTHING ", 45);
DEFINE_STRING(string2356_cfa_type, string2356_cfa_type2369, "Unexpected closure", 18);
DEFINE_STATIC_GENERIC(type_node__env_231_cfa_type, _type_node__11_cfa_type2370, _type_node__11_cfa_type, 0L, 1);
DEFINE_STATIC_PROCEDURE(type_variable__default1924_env_163_cfa_type, _type_variable__default1924_90_cfa_type2371, _type_variable__default1924_90_cfa_type, 0L, 2);
DEFINE_EXPORT_PROCEDURE(get_approx_type_env_38_cfa_type, _get_approx_type_72_cfa_type2372, _get_approx_type_72_cfa_type, 0L, 1);

obj_t 
module_initialization_70_cfa_type(long checksum_3567, char *from_3568)
{
   if (CBOOL(require_initialization_114_cfa_type))
     {
	require_initialization_114_cfa_type = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_type();
	cnst_init_137_cfa_type();
	imported_modules_init_94_cfa_type();
	toplevel_init_63_cfa_type();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_type()
{
   module_initialization_70___object(((long) 0), "CFA_TYPE");
   module_initialization_70___reader(((long) 0), "CFA_TYPE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_type()
{
   {
      obj_t cnst_port_138_3559;
      cnst_port_138_3559 = open_input_string(string2357_cfa_type);
      {
	 long i_3560;
	 i_3560 = ((long) 3);
       loop_3561:
	 {
	    bool_t test2358_3562;
	    test2358_3562 = (i_3560 == ((long) -1));
	    if (test2358_3562)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2359_3563;
		    {
		       obj_t list2360_3564;
		       {
			  obj_t arg2361_3565;
			  arg2361_3565 = BNIL;
			  list2360_3564 = MAKE_PAIR(cnst_port_138_3559, arg2361_3565);
		       }
		       arg2359_3563 = read___reader(list2360_3564);
		    }
		    CNST_TABLE_SET(i_3560, arg2359_3563);
		 }
		 {
		    int aux_3566;
		    {
		       long aux_3584;
		       aux_3584 = (i_3560 - ((long) 1));
		       aux_3566 = (int) (aux_3584);
		    }
		    {
		       long i_3587;
		       i_3587 = (long) (aux_3566);
		       i_3560 = i_3587;
		       goto loop_3561;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_type()
{
   add_generic__110___object(type_variable__env_200_cfa_type, type_variable__default1924_env_163_cfa_type);
   add_inlined_method__244___object(type_variable__env_200_cfa_type, svar_cinfo_166_cfa_info, ((long) 0));
   add_inlined_method__244___object(type_variable__env_200_cfa_type, scnst_cinfo_0_cfa_info, ((long) 1));
   add_inlined_method__244___object(type_variable__env_200_cfa_type, cvar_cinfo_53_cfa_info, ((long) 2));
   approx_cfa_info;
   add_inlined_method__244___object(type_variable__env_200_cfa_type, sexit_cinfo_49_cfa_info, ((long) 3));
   add_inlined_method__244___object(type_variable__env_200_cfa_type, intern_sfun_cinfo_192_cfa_info, ((long) 4));
   add_generic__110___object(type_node__env_231_cfa_type, type_node__default1930_env_124_cfa_type);
   add_inlined_method__244___object(type_node__env_231_cfa_type, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(type_node__env_231_cfa_type, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(type_node__env_231_cfa_type, var_ast_node, ((long) 2));
   add_inlined_method__244___object(type_node__env_231_cfa_type, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(type_node__env_231_cfa_type, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(type_node__env_231_cfa_type, app_ast_node, ((long) 5));
   add_inlined_method__244___object(type_node__env_231_cfa_type, app_ly_162_ast_node, ((long) 6));
   add_inlined_method__244___object(type_node__env_231_cfa_type, funcall_ast_node, ((long) 7));
   add_inlined_method__244___object(type_node__env_231_cfa_type, pragma_ast_node, ((long) 8));
   add_inlined_method__244___object(type_node__env_231_cfa_type, cast_ast_node, ((long) 9));
   add_inlined_method__244___object(type_node__env_231_cfa_type, setq_ast_node, ((long) 10));
   add_inlined_method__244___object(type_node__env_231_cfa_type, conditional_ast_node, ((long) 11));
   add_inlined_method__244___object(type_node__env_231_cfa_type, fail_ast_node, ((long) 12));
   add_inlined_method__244___object(type_node__env_231_cfa_type, select_ast_node, ((long) 13));
   add_inlined_method__244___object(type_node__env_231_cfa_type, let_fun_218_ast_node, ((long) 14));
   add_inlined_method__244___object(type_node__env_231_cfa_type, let_var_6_ast_node, ((long) 15));
   add_inlined_method__244___object(type_node__env_231_cfa_type, set_ex_it_116_ast_node, ((long) 16));
   add_inlined_method__244___object(type_node__env_231_cfa_type, jump_ex_it_184_ast_node, ((long) 17));
   add_inlined_method__244___object(type_node__env_231_cfa_type, make_box_202_ast_node, ((long) 18));
   add_inlined_method__244___object(type_node__env_231_cfa_type, box_set__221_ast_node, ((long) 19));
   {
      long aux_3616;
      aux_3616 = add_inlined_method__244___object(type_node__env_231_cfa_type, box_ref_242_ast_node, ((long) 20));
      return BINT(aux_3616);
   }
}


obj_t 
type_settings__207_cfa_type(obj_t globals_1)
{
   {
      obj_t l1887_2023;
      {
	 bool_t aux_3619;
	 l1887_2023 = globals_1;
       lname1888_2024:
	 if (PAIRP(l1887_2023))
	   {
	      {
		 variable_t aux_3622;
		 {
		    obj_t aux_3623;
		    aux_3623 = CAR(l1887_2023);
		    aux_3622 = (variable_t) (aux_3623);
		 }
		 type_fun__174_cfa_type(aux_3622);
	      }
	      {
		 obj_t l1887_3627;
		 l1887_3627 = CDR(l1887_2023);
		 l1887_2023 = l1887_3627;
		 goto lname1888_2024;
	      }
	   }
	 else
	   {
	      aux_3619 = ((bool_t) 1);
	   }
	 return BBOOL(aux_3619);
      }
   }
}


obj_t 
_type_settings__245_cfa_type(obj_t env_3552, obj_t globals_3553)
{
   return type_settings__207_cfa_type(globals_3553);
}


obj_t 
type_fun__174_cfa_type(variable_t var_2)
{
   {
      value_t fun_2028;
      fun_2028 = (((variable_t) CREF(var_2))->value);
      {
	 bool_t test1955_2029;
	 test1955_2029 = is_a__118___object((obj_t) (fun_2028), intern_sfun_cinfo_192_cfa_info);
	 if (test1955_2029)
	   {
	      {
		 obj_t l1890_2031;
		 {
		    sfun_t obj_3005;
		    obj_3005 = (sfun_t) (fun_2028);
		    l1890_2031 = (((sfun_t) CREF(obj_3005))->args);
		 }
	       lname1893_2032:
		 if (PAIRP(l1890_2031))
		   {
		      {
			 obj_t var_2035;
			 var_2035 = CAR(l1890_2031);
			 {
			    value_t aux_3638;
			    {
			       local_t obj_3008;
			       obj_3008 = (local_t) (var_2035);
			       aux_3638 = (((local_t) CREF(obj_3008))->value);
			    }
			    type_variable__242_cfa_type(aux_3638, (variable_t) (var_2035));
			 }
		      }
		      {
			 obj_t l1890_3643;
			 l1890_3643 = CDR(l1890_2031);
			 l1890_2031 = l1890_3643;
			 goto lname1893_2032;
		      }
		   }
		 else
		   {
		      ((bool_t) 1);
		   }
	      }
	      {
		 node_t aux_3647;
		 {
		    obj_t aux_3648;
		    {
		       sfun_t obj_3010;
		       obj_3010 = (sfun_t) (fun_2028);
		       aux_3648 = (((sfun_t) CREF(obj_3010))->body);
		    }
		    aux_3647 = (node_t) (aux_3648);
		 }
		 type_node__55_cfa_type(aux_3647);
	      }
	      {
		 obj_t arg1964_2039;
		 {
		    approx_t aux_3653;
		    {
		       intern_sfun_cinfo_192_t obj_3011;
		       obj_3011 = (intern_sfun_cinfo_192_t) (fun_2028);
		       {
			  obj_t aux_3655;
			  {
			     object_t aux_3656;
			     aux_3656 = (object_t) (obj_3011);
			     aux_3655 = OBJECT_WIDENING(aux_3656);
			  }
			  aux_3653 = (((intern_sfun_cinfo_192_t) CREF(aux_3655))->approx);
		       }
		    }
		    arg1964_2039 = get_approx_type_210_cfa_type(aux_3653);
		 }
		 return set_variable_type__9_cfa_type(var_2, (type_t) (arg1964_2039));
	      }
	   }
	 else
	   {
	      return BUNSPEC;
	   }
      }
   }
}


obj_t 
get_approx_type_210_cfa_type(approx_t approx_3)
{
   {
      type_t type_2041;
      obj_t alloc_list_184_2042;
      type_2041 = (((approx_t) CREF(approx_3))->type);
      alloc_list_184_2042 = set__list_248_cfa_set((((approx_t) CREF(approx_3))->allocs));
      if (PAIRP(alloc_list_184_2042))
	{
	   bool_t test1967_2044;
	   {
	      obj_t aux_3668;
	      aux_3668 = tvector_optimization__143_cfa_tvector();
	      test1967_2044 = CBOOL(aux_3668);
	   }
	   if (test1967_2044)
	     {
		bool_t test1968_2045;
		test1968_2045 = is_a__118___object(CAR(alloc_list_184_2042), make_vector_app_205_cfa_info);
		if (test1968_2045)
		  {
		     {
			obj_t app_2046;
			app_2046 = CAR(alloc_list_184_2042);
			{
			   type_t tv_type_111_2047;
			   tv_type_111_2047 = get_vector_item_type_88_cfa_tvector((app_t) (app_2046));
			   {
			      approx_t value_approx_19_2048;
			      {
				 make_vector_app_205_t obj_3018;
				 obj_3018 = (make_vector_app_205_t) (app_2046);
				 {
				    obj_t aux_3679;
				    {
				       object_t aux_3680;
				       aux_3680 = (object_t) (obj_3018);
				       aux_3679 = OBJECT_WIDENING(aux_3680);
				    }
				    value_approx_19_2048 = (((make_vector_app_205_t) CREF(aux_3679))->value_approx_19);
				 }
			      }
			      {
				 type_t item_type_130_2049;
				 item_type_130_2049 = (((approx_t) CREF(value_approx_19_2048))->type);
				 {
				    obj_t tv_2050;
				    tv_2050 = (((type_t) CREF(item_type_130_2049))->tvector);
				    {
				       {
					  bool_t test1969_2051;
					  test1969_2051 = is_a__118___object(tv_2050, type_type_type);
					  if (test1969_2051)
					    {
					       return tv_2050;
					    }
					  else
					    {
					       return (obj_t) (type_2041);
					    }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
		else
		  {
		     bool_t test1970_2052;
		     test1970_2052 = is_a__118___object(CAR(alloc_list_184_2042), create_vector_app_150_cfa_info);
		     if (test1970_2052)
		       {
			  {
			     obj_t app_2053;
			     app_2053 = CAR(alloc_list_184_2042);
			     {
				type_t tv_type_111_2054;
				tv_type_111_2054 = get_vector_item_type_88_cfa_tvector((app_t) (app_2053));
				{
				   approx_t value_approx_19_2055;
				   {
				      create_vector_app_150_t obj_3025;
				      obj_3025 = (create_vector_app_150_t) (app_2053);
				      {
					 obj_t aux_3696;
					 {
					    object_t aux_3697;
					    aux_3697 = (object_t) (obj_3025);
					    aux_3696 = OBJECT_WIDENING(aux_3697);
					 }
					 value_approx_19_2055 = (((create_vector_app_150_t) CREF(aux_3696))->value_approx_19);
				      }
				   }
				   {
				      type_t item_type_130_2056;
				      item_type_130_2056 = (((approx_t) CREF(value_approx_19_2055))->type);
				      {
					 obj_t tv_2057;
					 tv_2057 = (((type_t) CREF(item_type_130_2056))->tvector);
					 {
					    {
					       bool_t test1971_2058;
					       test1971_2058 = is_a__118___object(tv_2057, type_type_type);
					       if (test1971_2058)
						 {
						    return tv_2057;
						 }
					       else
						 {
						    return (obj_t) (type_2041);
						 }
					    }
					 }
				      }
				   }
				}
			     }
			  }
		       }
		     else
		       {
			  return (obj_t) (type_2041);
		       }
		  }
	     }
	   else
	     {
		return (obj_t) (type_2041);
	     }
	}
      else
	{
	   return (obj_t) (type_2041);
	}
   }
}


obj_t 
_get_approx_type_72_cfa_type(obj_t env_3554, obj_t approx_3555)
{
   return get_approx_type_210_cfa_type((approx_t) (approx_3555));
}


obj_t 
type_variable__default1924_75_cfa_type(value_t value_6, variable_t variable_7)
{
   {
      bool_t test1975_3030;
      {
	 obj_t aux_3711;
	 {
	    type_t aux_3712;
	    aux_3712 = (((variable_t) CREF(variable_7))->type);
	    aux_3711 = (obj_t) (aux_3712);
	 }
	 test1975_3030 = is_a__118___object(aux_3711, type_type_type);
      }
      if (test1975_3030)
	{
	   return CNST_TABLE_REF(((long) 0));
	}
      else
	{
	   type_t arg1976_3031;
	   arg1976_3031 = get_default_type_181_type_cache();
	   return set_variable_type__9_cfa_type(variable_7, arg1976_3031);
	}
   }
}


obj_t 
_type_variable__default1924_90_cfa_type(obj_t env_3545, obj_t value_3546, obj_t variable_3547)
{
   return type_variable__default1924_75_cfa_type((value_t) (value_3546), (variable_t) (variable_3547));
}


obj_t 
type_variable__242_cfa_type(value_t value_4, variable_t variable_5)
{
   {
      obj_t method2325_2968;
      obj_t class2330_2969;
      {
	 obj_t arg2334_2966;
	 obj_t arg2335_2967;
	 {
	    object_t obj_3034;
	    obj_3034 = (object_t) (value_4);
	    {
	       obj_t pre_method_105_3035;
	       pre_method_105_3035 = PROCEDURE_REF(type_variable__env_200_cfa_type, ((long) 2));
	       if (INTEGERP(pre_method_105_3035))
		 {
		    PROCEDURE_SET(type_variable__env_200_cfa_type, ((long) 2), BUNSPEC);
		    arg2334_2966 = pre_method_105_3035;
		 }
	       else
		 {
		    long obj_class_num_177_3040;
		    obj_class_num_177_3040 = TYPE(obj_3034);
		    {
		       obj_t arg1183_3041;
		       arg1183_3041 = PROCEDURE_REF(type_variable__env_200_cfa_type, ((long) 1));
		       {
			  long arg1184_3045;
			  {
			     long arg1186_3046;
			     arg1186_3046 = OBJECT_TYPE;
			     arg1184_3045 = (obj_class_num_177_3040 - arg1186_3046);
			  }
			  arg2334_2966 = VECTOR_REF(arg1183_3041, arg1184_3045);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_3051;
	    object_3051 = (object_t) (value_4);
	    {
	       long arg1187_3052;
	       {
		  long arg1188_3053;
		  long arg1189_3054;
		  arg1188_3053 = TYPE(object_3051);
		  arg1189_3054 = OBJECT_TYPE;
		  arg1187_3052 = (arg1188_3053 - arg1189_3054);
	       }
	       {
		  obj_t vector_3058;
		  vector_3058 = __classes__134___object;
		  arg2335_2967 = VECTOR_REF(vector_3058, arg1187_3052);
	       }
	    }
	 }
	 method2325_2968 = arg2334_2966;
	 class2330_2969 = arg2335_2967;
	 {
	    if (INTEGERP(method2325_2968))
	      {
		 switch ((long) CINT(method2325_2968))
		   {
		   case ((long) 0):
		      {
			 svar_cinfo_166_t value_2975;
			 value_2975 = (svar_cinfo_166_t) (value_4);
			 {
			    obj_t arg2338_2978;
			    {
			       approx_t aux_3741;
			       {
				  obj_t aux_3742;
				  {
				     object_t aux_3743;
				     aux_3743 = (object_t) (value_2975);
				     aux_3742 = OBJECT_WIDENING(aux_3743);
				  }
				  aux_3741 = (((svar_cinfo_166_t) CREF(aux_3742))->approx);
			       }
			       arg2338_2978 = get_approx_type_210_cfa_type(aux_3741);
			    }
			    return set_variable_type__9_cfa_type(variable_5, (type_t) (arg2338_2978));
			 }
		      }
		      break;
		   case ((long) 1):
		      return CNST_TABLE_REF(((long) 0));
		      break;
		   case ((long) 2):
		      {
			 cvar_cinfo_53_t value_2982;
			 value_2982 = (cvar_cinfo_53_t) (value_4);
			 {
			    obj_t arg2341_2985;
			    {
			       approx_t aux_3752;
			       {
				  obj_t aux_3753;
				  {
				     object_t aux_3754;
				     aux_3754 = (object_t) (value_2982);
				     aux_3753 = OBJECT_WIDENING(aux_3754);
				  }
				  aux_3752 = (((cvar_cinfo_53_t) CREF(aux_3753))->approx);
			       }
			       arg2341_2985 = get_approx_type_210_cfa_type(aux_3752);
			    }
			    return set_variable_type__9_cfa_type(variable_5, (type_t) (arg2341_2985));
			 }
		      }
		      break;
		   case ((long) 3):
		      return CNST_TABLE_REF(((long) 0));
		      break;
		   case ((long) 4):
		      return CNST_TABLE_REF(((long) 0));
		      break;
		   default:
		    case_else2331_104_2972:
		      if (PROCEDUREP(method2325_2968))
			{
			   return PROCEDURE_ENTRY(method2325_2968) (method2325_2968, (obj_t) (value_4), (obj_t) (variable_5), BEOA);
			}
		      else
			{
			   obj_t fun1977_2065;
			   fun1977_2065 = PROCEDURE_REF(type_variable__env_200_cfa_type, ((long) 0));
			   return PROCEDURE_ENTRY(fun1977_2065) (fun1977_2065, (obj_t) (value_4), (obj_t) (variable_5), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else2331_104_2972;
	      }
	 }
      }
   }
}


obj_t 
_type_variable__16_cfa_type(obj_t env_3542, obj_t value_3543, obj_t variable_3544)
{
   return type_variable__242_cfa_type((value_t) (value_3543), (variable_t) (variable_3544));
}


obj_t 
set_variable_type__9_cfa_type(variable_t variable_18, type_t type_19)
{
   {
      obj_t ntype_2066;
      type_t otype_2067;
      {
	 bool_t test1988_2078;
	 {
	    obj_t obj2_3065;
	    obj2_3065 = _____74_type_cache;
	    {
	       obj_t aux_3779;
	       aux_3779 = (obj_t) (type_19);
	       test1988_2078 = (aux_3779 == obj2_3065);
	    }
	 }
	 if (test1988_2078)
	   {
	      ntype_2066 = __obj__252_type_cache;
	   }
	 else
	   {
	      ntype_2066 = (obj_t) (type_19);
	   }
      }
      otype_2067 = (((variable_t) CREF(variable_18))->type);
      {
	 bool_t test1978_2068;
	 {
	    obj_t obj2_3068;
	    obj2_3068 = _____74_type_cache;
	    {
	       obj_t aux_3785;
	       aux_3785 = (obj_t) (otype_2067);
	       test1978_2068 = (aux_3785 == obj2_3068);
	    }
	 }
	 if (test1978_2068)
	   {
	      {
		 bool_t test1979_2069;
		 {
		    bool_t test1980_2070;
		    test1980_2070 = is_a__118___object((obj_t) (variable_18), global_ast_var);
		    if (test1980_2070)
		      {
			 bool_t test1981_2071;
			 {
			    obj_t aux_3792;
			    {
			       value_t aux_3793;
			       {
				  global_t obj_3070;
				  obj_3070 = (global_t) (variable_18);
				  aux_3793 = (((global_t) CREF(obj_3070))->value);
			       }
			       aux_3792 = (obj_t) (aux_3793);
			    }
			    test1981_2071 = is_a__118___object(aux_3792, fun_ast_var);
			 }
			 if (test1981_2071)
			   {
			      test1979_2069 = ((bool_t) 0);
			   }
			 else
			   {
			      if (CBOOL(__unsafe_type__146_engine_param))
				{
				   test1979_2069 = ((bool_t) 0);
				}
			      else
				{
				   bool_t test_3801;
				   {
				      obj_t aux_3805;
				      obj_t aux_3802;
				      aux_3805 = CNST_TABLE_REF(((long) 1));
				      {
					 type_t obj_3072;
					 obj_3072 = (type_t) (ntype_2066);
					 aux_3802 = (((type_t) CREF(obj_3072))->class);
				      }
				      test_3801 = (aux_3802 == aux_3805);
				   }
				   if (test_3801)
				     {
					test1979_2069 = ((bool_t) 0);
				     }
				   else
				     {
					test1979_2069 = ((bool_t) 1);
				     }
				}
			   }
		      }
		    else
		      {
			 test1979_2069 = ((bool_t) 0);
		      }
		 }
		 if (test1979_2069)
		   {
		      obj_t res2350_3077;
		      {
			 type_t val1076_3076;
			 val1076_3076 = (type_t) (__obj__252_type_cache);
			 {
			    obj_t x_3556;
			    x_3556 = ((((variable_t) CREF(variable_18))->type) = ((type_t) val1076_3076), BUNSPEC);
			    res2350_3077 = BUNSPEC;
			 }
		      }
		      return res2350_3077;
		   }
		 else
		   {
		      obj_t res2351_3080;
		      {
			 type_t val1076_3079;
			 val1076_3079 = (type_t) (ntype_2066);
			 {
			    obj_t x_3557;
			    x_3557 = ((((variable_t) CREF(variable_18))->type) = ((type_t) val1076_3079), BUNSPEC);
			    res2351_3080 = BUNSPEC;
			 }
		      }
		      return res2351_3080;
		   }
	      }
	   }
	 else
	   {
	      bool_t test1986_2076;
	      {
		 bool_t test1987_2077;
		 {
		    obj_t obj2_3082;
		    obj2_3082 = __vector__240_type_cache;
		    {
		       obj_t aux_3813;
		       aux_3813 = (obj_t) (otype_2067);
		       test1987_2077 = (aux_3813 == obj2_3082);
		    }
		 }
		 if (test1987_2077)
		   {
		      test1986_2076 = is_a__118___object(ntype_2066, tvec_tvector_tvector);
		   }
		 else
		   {
		      test1986_2076 = ((bool_t) 0);
		   }
	      }
	      if (test1986_2076)
		{
		   {
		      obj_t res2352_3086;
		      {
			 type_t val1076_3085;
			 val1076_3085 = (type_t) (ntype_2066);
			 {
			    obj_t x_3558;
			    x_3558 = ((((variable_t) CREF(variable_18))->type) = ((type_t) val1076_3085), BUNSPEC);
			    res2352_3086 = BUNSPEC;
			 }
		      }
		      return res2352_3086;
		   }
		}
	      else
		{
		   return BFALSE;
		}
	   }
      }
   }
}


obj_t 
type_node__default1930_248_cfa_type(node_t node_21)
{
   FAILURE(CNST_TABLE_REF(((long) 2)), string2354_cfa_type, (obj_t) (node_21));
}


obj_t 
_type_node__default1930_80_cfa_type(obj_t env_3550, obj_t node_3551)
{
   return type_node__default1930_248_cfa_type((node_t) (node_3551));
}


obj_t 
type_node__55_cfa_type(node_t node_20)
{
 type_node__55_cfa_type:
   {
      obj_t method2248_2846;
      obj_t class2253_2847;
      {
	 obj_t arg2256_2844;
	 obj_t arg2257_2845;
	 {
	    object_t obj_3092;
	    obj_3092 = (object_t) (node_20);
	    {
	       obj_t pre_method_105_3093;
	       pre_method_105_3093 = PROCEDURE_REF(type_node__env_231_cfa_type, ((long) 2));
	       if (INTEGERP(pre_method_105_3093))
		 {
		    PROCEDURE_SET(type_node__env_231_cfa_type, ((long) 2), BUNSPEC);
		    arg2256_2844 = pre_method_105_3093;
		 }
	       else
		 {
		    long obj_class_num_177_3098;
		    obj_class_num_177_3098 = TYPE(obj_3092);
		    {
		       obj_t arg1183_3099;
		       arg1183_3099 = PROCEDURE_REF(type_node__env_231_cfa_type, ((long) 1));
		       {
			  long arg1184_3103;
			  {
			     long arg1186_3104;
			     arg1186_3104 = OBJECT_TYPE;
			     arg1184_3103 = (obj_class_num_177_3098 - arg1186_3104);
			  }
			  arg2256_2844 = VECTOR_REF(arg1183_3099, arg1184_3103);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_3109;
	    object_3109 = (object_t) (node_20);
	    {
	       long arg1187_3110;
	       {
		  long arg1188_3111;
		  long arg1189_3112;
		  arg1188_3111 = TYPE(object_3109);
		  arg1189_3112 = OBJECT_TYPE;
		  arg1187_3110 = (arg1188_3111 - arg1189_3112);
	       }
	       {
		  obj_t vector_3116;
		  vector_3116 = __classes__134___object;
		  arg2257_2845 = VECTOR_REF(vector_3116, arg1187_3110);
	       }
	    }
	 }
	 method2248_2846 = arg2256_2844;
	 class2253_2847 = arg2257_2845;
	 {
	    if (INTEGERP(method2248_2846))
	      {
		 switch ((long) CINT(method2248_2846))
		   {
		   case ((long) 0):
		      return BUNSPEC;
		      break;
		   case ((long) 1):
		      return BUNSPEC;
		      break;
		   case ((long) 2):
		      {
			 var_t node_2855;
			 node_2855 = (var_t) (node_20);
			 {
			    bool_t test2260_2857;
			    {
			       bool_t test2264_2861;
			       {
				  obj_t aux_3844;
				  {
				     variable_t aux_3845;
				     aux_3845 = (((var_t) CREF(node_2855))->variable);
				     aux_3844 = (obj_t) (aux_3845);
				  }
				  test2264_2861 = is_a__118___object(aux_3844, global_ast_var);
			       }
			       if (test2264_2861)
				 {
				    obj_t aux_3855;
				    obj_t aux_3850;
				    aux_3855 = CNST_TABLE_REF(((long) 3));
				    {
				       global_t obj_3121;
				       {
					  variable_t aux_3851;
					  aux_3851 = (((var_t) CREF(node_2855))->variable);
					  obj_3121 = (global_t) (aux_3851);
				       }
				       aux_3850 = (((global_t) CREF(obj_3121))->import);
				    }
				    test2260_2857 = (aux_3850 == aux_3855);
				 }
			       else
				 {
				    test2260_2857 = ((bool_t) 0);
				 }
			    }
			    if (test2260_2857)
			      {
				 value_t aux_3859;
				 {
				    global_t obj_3125;
				    {
				       variable_t aux_3860;
				       aux_3860 = (((var_t) CREF(node_2855))->variable);
				       obj_3125 = (global_t) (aux_3860);
				    }
				    aux_3859 = (((global_t) CREF(obj_3125))->value);
				 }
				 return type_variable__242_cfa_type(aux_3859, (((var_t) CREF(node_2855))->variable));
			      }
			    else
			      {
				 return BUNSPEC;
			      }
			 }
		      }
		      break;
		   case ((long) 3):
		      {
			 obj_t arg2272_2869;
			 {
			    obj_t aux_3866;
			    {
			       closure_t aux_3867;
			       aux_3867 = (closure_t) (node_20);
			       aux_3866 = (obj_t) (aux_3867);
			    }
			    arg2272_2869 = shape_tools_shape(aux_3866);
			 }
			 return internal_error_43_tools_error(string2355_cfa_type, string2356_cfa_type, arg2272_2869);
		      }
		      break;
		   case ((long) 4):
		      {
			 sequence_t node_2870;
			 node_2870 = (sequence_t) (node_20);
			 {
			    bool_t aux_3873;
			    aux_3873 = type_node___42_cfa_type((((sequence_t) CREF(node_2870))->nodes));
			    return BBOOL(aux_3873);
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 app_t node_2873;
			 node_2873 = (app_t) (node_20);
			 {
			    bool_t aux_3878;
			    aux_3878 = type_node___42_cfa_type((((app_t) CREF(node_2873))->args));
			    return BBOOL(aux_3878);
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 app_ly_162_t node_2876;
			 node_2876 = (app_ly_162_t) (node_20);
			 type_node__55_cfa_type((((app_ly_162_t) CREF(node_2876))->fun));
			 {
			    node_t node_3885;
			    node_3885 = (((app_ly_162_t) CREF(node_2876))->arg);
			    node_20 = node_3885;
			    goto type_node__55_cfa_type;
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 funcall_t node_2880;
			 node_2880 = (funcall_t) (node_20);
			 type_node__55_cfa_type((((funcall_t) CREF(node_2880))->fun));
			 {
			    bool_t aux_3890;
			    aux_3890 = type_node___42_cfa_type((((funcall_t) CREF(node_2880))->args));
			    return BBOOL(aux_3890);
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 pragma_t node_2884;
			 node_2884 = (pragma_t) (node_20);
			 {
			    bool_t aux_3895;
			    aux_3895 = type_node___42_cfa_type((((pragma_t) CREF(node_2884))->args));
			    return BBOOL(aux_3895);
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 cast_t node_2887;
			 node_2887 = (cast_t) (node_20);
			 {
			    node_t node_3900;
			    node_3900 = (((cast_t) CREF(node_2887))->arg);
			    node_20 = node_3900;
			    goto type_node__55_cfa_type;
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 setq_t node_2890;
			 node_2890 = (setq_t) (node_20);
			 type_node__55_cfa_type((((setq_t) CREF(node_2890))->value));
			 {
			    node_t node_3905;
			    {
			       var_t aux_3906;
			       aux_3906 = (((setq_t) CREF(node_2890))->var);
			       node_3905 = (node_t) (aux_3906);
			    }
			    node_20 = node_3905;
			    goto type_node__55_cfa_type;
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 conditional_t node_2894;
			 node_2894 = (conditional_t) (node_20);
			 type_node__55_cfa_type((((conditional_t) CREF(node_2894))->test));
			 type_node__55_cfa_type((((conditional_t) CREF(node_2894))->true));
			 {
			    node_t node_3914;
			    node_3914 = (((conditional_t) CREF(node_2894))->false);
			    node_20 = node_3914;
			    goto type_node__55_cfa_type;
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 fail_t node_2899;
			 node_2899 = (fail_t) (node_20);
			 type_node__55_cfa_type((((fail_t) CREF(node_2899))->proc));
			 type_node__55_cfa_type((((fail_t) CREF(node_2899))->msg));
			 {
			    node_t node_3921;
			    node_3921 = (((fail_t) CREF(node_2899))->obj);
			    node_20 = node_3921;
			    goto type_node__55_cfa_type;
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 select_t node_2904;
			 node_2904 = (select_t) (node_20);
			 type_node__55_cfa_type((((select_t) CREF(node_2904))->test));
			 {
			    obj_t l1907_2907;
			    {
			       bool_t aux_3926;
			       l1907_2907 = (((select_t) CREF(node_2904))->clauses);
			     lname1908_2908:
			       if (PAIRP(l1907_2907))
				 {
				    {
				       node_t aux_3929;
				       {
					  obj_t aux_3930;
					  {
					     obj_t aux_3931;
					     aux_3931 = CAR(l1907_2907);
					     aux_3930 = CDR(aux_3931);
					  }
					  aux_3929 = (node_t) (aux_3930);
				       }
				       type_node__55_cfa_type(aux_3929);
				    }
				    {
				       obj_t l1907_3936;
				       l1907_3936 = CDR(l1907_2907);
				       l1907_2907 = l1907_3936;
				       goto lname1908_2908;
				    }
				 }
			       else
				 {
				    aux_3926 = ((bool_t) 1);
				 }
			       return BBOOL(aux_3926);
			    }
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 let_fun_218_t node_2914;
			 node_2914 = (let_fun_218_t) (node_20);
			 {
			    obj_t l1910_2916;
			    l1910_2916 = (((let_fun_218_t) CREF(node_2914))->locals);
			  lname1911_2917:
			    if (PAIRP(l1910_2916))
			      {
				 {
				    variable_t aux_3943;
				    {
				       obj_t aux_3944;
				       aux_3944 = CAR(l1910_2916);
				       aux_3943 = (variable_t) (aux_3944);
				    }
				    type_fun__174_cfa_type(aux_3943);
				 }
				 {
				    obj_t l1910_3948;
				    l1910_3948 = CDR(l1910_2916);
				    l1910_2916 = l1910_3948;
				    goto lname1911_2917;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    node_t node_3951;
			    node_3951 = (((let_fun_218_t) CREF(node_2914))->body);
			    node_20 = node_3951;
			    goto type_node__55_cfa_type;
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 let_var_6_t node_2923;
			 node_2923 = (let_var_6_t) (node_20);
			 {
			    obj_t l1913_2925;
			    l1913_2925 = (((let_var_6_t) CREF(node_2923))->bindings);
			  lname1914_2926:
			    if (PAIRP(l1913_2925))
			      {
				 {
				    obj_t binding_2929;
				    binding_2929 = CAR(l1913_2925);
				    {
				       obj_t var_2930;
				       var_2930 = CAR(binding_2929);
				       {
					  node_t aux_3958;
					  {
					     obj_t aux_3959;
					     aux_3959 = CDR(binding_2929);
					     aux_3958 = (node_t) (aux_3959);
					  }
					  type_node__55_cfa_type(aux_3958);
				       }
				       {
					  value_t aux_3963;
					  {
					     local_t obj_3159;
					     obj_3159 = (local_t) (var_2930);
					     aux_3963 = (((local_t) CREF(obj_3159))->value);
					  }
					  type_variable__242_cfa_type(aux_3963, (variable_t) (var_2930));
				       }
				    }
				 }
				 {
				    obj_t l1913_3968;
				    l1913_3968 = CDR(l1913_2925);
				    l1913_2925 = l1913_3968;
				    goto lname1914_2926;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    node_t node_3971;
			    node_3971 = (((let_var_6_t) CREF(node_2923))->body);
			    node_20 = node_3971;
			    goto type_node__55_cfa_type;
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 set_ex_it_116_t node_2935;
			 node_2935 = (set_ex_it_116_t) (node_20);
			 {
			    variable_t v_2937;
			    {
			       var_t arg2311_2939;
			       arg2311_2939 = (((set_ex_it_116_t) CREF(node_2935))->var);
			       v_2937 = (((var_t) CREF(arg2311_2939))->variable);
			    }
			    {
			       value_t aux_3976;
			       {
				  local_t obj_3164;
				  obj_3164 = (local_t) (v_2937);
				  aux_3976 = (((local_t) CREF(obj_3164))->value);
			       }
			       type_variable__242_cfa_type(aux_3976, v_2937);
			    }
			 }
			 type_node__55_cfa_type((((set_ex_it_116_t) CREF(node_2935))->body));
			 {
			    node_t node_3982;
			    {
			       var_t aux_3983;
			       aux_3983 = (((set_ex_it_116_t) CREF(node_2935))->var);
			       node_3982 = (node_t) (aux_3983);
			    }
			    node_20 = node_3982;
			    goto type_node__55_cfa_type;
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 jump_ex_it_184_t node_2942;
			 node_2942 = (jump_ex_it_184_t) (node_20);
			 type_node__55_cfa_type((((jump_ex_it_184_t) CREF(node_2942))->exit));
			 {
			    node_t node_3989;
			    node_3989 = (((jump_ex_it_184_t) CREF(node_2942))->value);
			    node_20 = node_3989;
			    goto type_node__55_cfa_type;
			 }
		      }
		      break;
		   case ((long) 18):
		      {
			 make_box_202_t node_2946;
			 node_2946 = (make_box_202_t) (node_20);
			 {
			    node_t node_3992;
			    node_3992 = (((make_box_202_t) CREF(node_2946))->value);
			    node_20 = node_3992;
			    goto type_node__55_cfa_type;
			 }
		      }
		      break;
		   case ((long) 19):
		      {
			 box_set__221_t node_2949;
			 node_2949 = (box_set__221_t) (node_20);
			 {
			    node_t aux_3995;
			    {
			       var_t aux_3996;
			       aux_3996 = (((box_set__221_t) CREF(node_2949))->var);
			       aux_3995 = (node_t) (aux_3996);
			    }
			    type_node__55_cfa_type(aux_3995);
			 }
			 {
			    node_t node_4000;
			    node_4000 = (((box_set__221_t) CREF(node_2949))->value);
			    node_20 = node_4000;
			    goto type_node__55_cfa_type;
			 }
		      }
		      break;
		   case ((long) 20):
		      {
			 box_ref_242_t node_2953;
			 node_2953 = (box_ref_242_t) (node_20);
			 {
			    node_t node_4003;
			    {
			       var_t aux_4004;
			       aux_4004 = (((box_ref_242_t) CREF(node_2953))->var);
			       node_4003 = (node_t) (aux_4004);
			    }
			    node_20 = node_4003;
			    goto type_node__55_cfa_type;
			 }
		      }
		      break;
		   default:
		    case_else2254_77_2850:
		      if (PROCEDUREP(method2248_2846))
			{
			   return PROCEDURE_ENTRY(method2248_2846) (method2248_2846, (obj_t) (node_20), BEOA);
			}
		      else
			{
			   obj_t fun1991_2081;
			   fun1991_2081 = PROCEDURE_REF(type_node__env_231_cfa_type, ((long) 0));
			   return PROCEDURE_ENTRY(fun1991_2081) (fun1991_2081, (obj_t) (node_20), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else2254_77_2850;
	      }
	 }
      }
   }
}


obj_t 
_type_node__11_cfa_type(obj_t env_3548, obj_t node_3549)
{
   return type_node__55_cfa_type((node_t) (node_3549));
}


bool_t 
type_node___42_cfa_type(obj_t node__221_43)
{
   {
      obj_t l1920_2082;
      l1920_2082 = node__221_43;
    lname1923_2083:
      if (PAIRP(l1920_2082))
	{
	   {
	      node_t aux_4022;
	      {
		 obj_t aux_4023;
		 aux_4023 = CAR(l1920_2082);
		 aux_4022 = (node_t) (aux_4023);
	      }
	      type_node__55_cfa_type(aux_4022);
	   }
	   {
	      obj_t l1920_4027;
	      l1920_4027 = CDR(l1920_2082);
	      l1920_2082 = l1920_4027;
	      goto lname1923_2083;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
imported_modules_init_94_cfa_type()
{
   module_initialization_70_type_type(((long) 0), "CFA_TYPE");
   module_initialization_70_type_cache(((long) 0), "CFA_TYPE");
   module_initialization_70_tools_shape(((long) 0), "CFA_TYPE");
   module_initialization_70_tools_error(((long) 0), "CFA_TYPE");
   module_initialization_70_engine_param(((long) 0), "CFA_TYPE");
   module_initialization_70_ast_var(((long) 0), "CFA_TYPE");
   module_initialization_70_ast_node(((long) 0), "CFA_TYPE");
   module_initialization_70_cfa_info(((long) 0), "CFA_TYPE");
   module_initialization_70_cfa_set(((long) 0), "CFA_TYPE");
   module_initialization_70_cfa_tvector(((long) 0), "CFA_TYPE");
   return module_initialization_70_tvector_tvector(((long) 0), "CFA_TYPE");
}
