/*===========================================================================*/
/*   (Cfa/vector.scm)                                                        */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


extern obj_t pre_vector_set__app_211_cfa_info;
static obj_t node_setup__pre_make_vector_app2561_141_cfa_vector(obj_t, obj_t);
extern obj_t _stack_loose_alloc__18_cfa_loose(obj_t, obj_t, obj_t);
static obj_t cfa__vector_set__app2552_73_cfa_vector(obj_t, obj_t);
extern obj_t _node_setup__114_cfa_setup(obj_t, obj_t);
static obj_t arg22182545_cfa_vector(obj_t, obj_t);
static obj_t cfa__vector_ref_app2554_22_cfa_vector(obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern approx_t loose__226_cfa_loose(approx_t, obj_t);
extern obj_t _cfa__186_cfa_cfa(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t loose_alloc__make_vector_app2551_20_cfa_vector(obj_t, obj_t);
static obj_t arg21822548_cfa_vector(obj_t, obj_t);
static obj_t node_setup__pre_create_vector_app2560_253_cfa_vector(obj_t, obj_t);
static obj_t imported_modules_init_94_cfa_vector();
extern obj_t module_initialization_70_cfa_vector(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_setup(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_tvector(long, char *);
extern obj_t module_initialization_70_cfa_stack(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_cfa_vector();
static obj_t cnst_init_137_cfa_vector();
extern obj_t create_vector_app_150_cfa_info;
extern obj_t _node_key_105_cfa_approx(obj_t, obj_t);
extern obj_t pre_create_vector_app_162_cfa_info;
static obj_t node_setup__pre_vector_set__app2558_128_cfa_vector(obj_t, obj_t);
extern obj_t _loose_alloc__239_cfa_loose(obj_t, obj_t);
extern obj_t add_make_vector__104_cfa_tvector(node_t);
extern obj_t pre_vector_ref_app_208_cfa_info;
extern obj_t node_setup___185_cfa_setup(obj_t);
static obj_t node_key_create_vector_app2538_252_cfa_vector(obj_t, obj_t);
extern obj_t stack_loose_alloc__95_cfa_loose(node_t, obj_t);
static obj_t node_setup__pre_vector_ref_app2559_248_cfa_vector(obj_t, obj_t);
static obj_t stack__make_vector_app2537_210_cfa_vector(obj_t, obj_t);
static obj_t cfa__create_vector_app2556_191_cfa_vector(obj_t, obj_t);
static obj_t require_initialization_114_cfa_vector = BUNSPEC;
extern approx_t make_empty_approx_131_cfa_approx();
static obj_t stack__create_vector_app2536_50_cfa_vector(obj_t, obj_t);
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cfa_vector();
extern obj_t variable_ast_var;
extern obj_t pre_make_vector_app_251_cfa_info;
extern obj_t vector_ref_app_195_cfa_info;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t node_key_pre_make_vector_app2543_61_cfa_vector(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
static obj_t arg22222546_cfa_vector(obj_t, obj_t);
extern obj_t __unspec__87_type_cache;
extern obj_t class_super_145___object(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t __cfa_stamp__16_cfa_iterate;
static obj_t stack_loose_alloc__create_vector_app2544_89_cfa_vector(obj_t, obj_t, obj_t);
extern approx_t union_approx__241_cfa_approx(approx_t, approx_t);
extern approx_t cfa__102_cfa_cfa(node_t);
static obj_t cfa__make_vector_app2557_60_cfa_vector(obj_t, obj_t);
extern approx_t make_type_alloc_approx_134_cfa_approx(type_t, node_t);
extern obj_t __vector__240_type_cache;
static obj_t arg21042553_cfa_vector(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t arg20612555_cfa_vector(obj_t, obj_t);
extern obj_t _node_key_set__44_cfa_approx(obj_t, obj_t, obj_t);
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_t);
extern obj_t vector_set__app_21_cfa_info;
extern approx_t make_type_approx_184_cfa_approx(type_t);
static obj_t node_key_set__pre_make_vector_app2542_97_cfa_vector(obj_t, obj_t, obj_t);
static obj_t arg21862549_cfa_vector(obj_t, obj_t);
extern obj_t approx_set_type__239_cfa_approx(approx_t, type_t);
extern obj_t stack___129_cfa_stack(obj_t);
static obj_t node_key_make_vector_app2541_150_cfa_vector(obj_t, obj_t);
extern obj_t _stack__205_cfa_stack(obj_t, obj_t);
static obj_t stack_loose_alloc__make_vector_app2547_141_cfa_vector(obj_t, obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t make_vector_app_205_cfa_info;
extern node_t node_heap__stack__239_cfa_stack(app_t, bool_t);
extern obj_t approx_set_top__187_cfa_approx(approx_t);
static obj_t loose_alloc__create_vector_app2550_135_cfa_vector(obj_t, obj_t);
extern obj_t __obj__252_type_cache;
static obj_t node_key_set__pre_create_vector_app2539_16_cfa_vector(obj_t, obj_t, obj_t);
static obj_t node_key_pre_create_vector_app2540_108_cfa_vector(obj_t, obj_t);
static obj_t __cnst[2];

DEFINE_STATIC_PROCEDURE(proc2575_cfa_vector, cfa__create_vector_app2556_191_cfa_vector2613, cfa__create_vector_app2556_191_cfa_vector, 0L, 1);
extern obj_t cfa__env_153_cfa_cfa;
extern obj_t stack__env_104_cfa_stack;
DEFINE_STATIC_PROCEDURE(proc2574_cfa_vector, cfa__make_vector_app2557_60_cfa_vector2614, cfa__make_vector_app2557_60_cfa_vector, 0L, 1);
DEFINE_STRING(string2598_cfa_vector, string2598_cfa_vector2615, " ", 1);
DEFINE_STRING(string2597_cfa_vector, string2597_cfa_vector2616, "     value: ", 12);
DEFINE_STRING(string2592_cfa_vector, string2592_cfa_vector2617, " *** stack-loose: ", 18);
DEFINE_STRING(string2606_cfa_vector, string2606_cfa_vector2618, "    make-vector-app: ", 21);
DEFINE_STATIC_PROCEDURE(proc2576_cfa_vector, cfa__vector_ref_app2554_22_cfa_vector2619, cfa__vector_ref_app2554_22_cfa_vector, 0L, 1);
DEFINE_STRING(string2600_cfa_vector, string2600_cfa_vector2620, " currently: ", 12);
DEFINE_STRING(string2604_cfa_vector, string2604_cfa_vector2621, "                key: ", 21);
DEFINE_STATIC_PROCEDURE(proc2570_cfa_vector, node_setup__pre_make_vector_app2561_141_cfa_vector2622, node_setup__pre_make_vector_app2561_141_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2595_cfa_vector, arg21822548_cfa_vector2623, arg21822548_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2584_cfa_vector, node_key_make_vector_app2541_150_cfa_vector2624, node_key_make_vector_app2541_150_cfa_vector, 0L, 1);
DEFINE_STRING(string2599_cfa_vector, string2599_cfa_vector2625, "   vector-set!: ", 16);
DEFINE_STRING(string2602_cfa_vector, string2602_cfa_vector2626, " create-vector: ", 16);
DEFINE_STATIC_PROCEDURE(proc2585_cfa_vector, node_key_pre_create_vector_app2540_108_cfa_vector2627, node_key_pre_create_vector_app2540_108_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2581_cfa_vector, stack_loose_alloc__create_vector_app2544_89_cfa_vector2628, stack_loose_alloc__create_vector_app2544_89_cfa_vector, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2579_cfa_vector, loose_alloc__create_vector_app2550_135_cfa_vector2629, loose_alloc__create_vector_app2550_135_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2571_cfa_vector, node_setup__pre_create_vector_app2560_253_cfa_vector2630, node_setup__pre_create_vector_app2560_253_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2588_cfa_vector, stack__make_vector_app2537_210_cfa_vector2631, stack__make_vector_app2537_210_cfa_vector, 0L, 1);
DEFINE_STRING(string2607_cfa_vector, string2607_cfa_vector2632, "ALL CFA ", 8);
DEFINE_STRING(string2596_cfa_vector, string2596_cfa_vector2633, " *** loose: ", 12);
extern obj_t node_key_set__env_57_cfa_approx;
DEFINE_STRING(string2593_cfa_vector, string2593_cfa_vector2634, "           value: ", 18);
extern obj_t node_key_env_229_cfa_approx;
DEFINE_STATIC_PROCEDURE(proc2572_cfa_vector, node_setup__pre_vector_ref_app2559_248_cfa_vector2635, node_setup__pre_vector_ref_app2559_248_cfa_vector, 0L, 1);
DEFINE_STRING(string2603_cfa_vector, string2603_cfa_vector2636, "   make-vector: ", 16);
DEFINE_STATIC_PROCEDURE(proc2577_cfa_vector, cfa__vector_set__app2552_73_cfa_vector2637, cfa__vector_set__app2552_73_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2587_cfa_vector, node_key_create_vector_app2538_252_cfa_vector2638, node_key_create_vector_app2538_252_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2586_cfa_vector, node_key_set__pre_create_vector_app2539_16_cfa_vector2639, node_key_set__pre_create_vector_app2539_16_cfa_vector, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2578_cfa_vector, loose_alloc__make_vector_app2551_20_cfa_vector2640, loose_alloc__make_vector_app2551_20_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2594_cfa_vector, arg22182545_cfa_vector2641, arg22182545_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2573_cfa_vector, node_setup__pre_vector_set__app2558_128_cfa_vector2642, node_setup__pre_vector_set__app2558_128_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2580_cfa_vector, stack_loose_alloc__make_vector_app2547_141_cfa_vector2643, stack_loose_alloc__make_vector_app2547_141_cfa_vector, 0L, 2);
DEFINE_STRING(string2591_cfa_vector, string2591_cfa_vector2644, "stack(make-vector-app): s?: ", 28);
extern obj_t node_setup__env_214_cfa_setup;
DEFINE_STRING(string2590_cfa_vector, string2590_cfa_vector2645, "stack(create-vector-app): s?: ", 30);
DEFINE_STRING(string2605_cfa_vector, string2605_cfa_vector2646, "  create-vector-app: ", 21);
DEFINE_STATIC_PROCEDURE(proc2583_cfa_vector, node_key_set__pre_make_vector_app2542_97_cfa_vector2647, node_key_set__pre_make_vector_app2542_97_cfa_vector, 0L, 2);
DEFINE_STRING(string2601_cfa_vector, string2601_cfa_vector2648, ">>> vector-ref: ", 16);
extern obj_t loose_alloc__env_83_cfa_loose;
DEFINE_STATIC_PROCEDURE(proc2582_cfa_vector, node_key_pre_make_vector_app2543_61_cfa_vector2649, node_key_pre_make_vector_app2543_61_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2589_cfa_vector, stack__create_vector_app2536_50_cfa_vector2650, stack__create_vector_app2536_50_cfa_vector, 0L, 1);
extern obj_t stack_loose_alloc__env_147_cfa_loose;

obj_t 
module_initialization_70_cfa_vector(long checksum_3910, char *from_3911)
{
   if (CBOOL(require_initialization_114_cfa_vector))
     {
	require_initialization_114_cfa_vector = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_vector();
	cnst_init_137_cfa_vector();
	imported_modules_init_94_cfa_vector();
	toplevel_init_63_cfa_vector();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_vector()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_VECTOR");
   module_initialization_70___object(((long) 0), "CFA_VECTOR");
   module_initialization_70___reader(((long) 0), "CFA_VECTOR");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_vector()
{
   {
      obj_t cnst_port_138_3902;
      cnst_port_138_3902 = open_input_string(string2607_cfa_vector);
      {
	 long i_3903;
	 i_3903 = ((long) 1);
       loop_3904:
	 {
	    bool_t test2608_3905;
	    test2608_3905 = (i_3903 == ((long) -1));
	    if (test2608_3905)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2609_3906;
		    {
		       obj_t list2610_3907;
		       {
			  obj_t arg2611_3908;
			  arg2611_3908 = BNIL;
			  list2610_3907 = MAKE_PAIR(cnst_port_138_3902, arg2611_3908);
		       }
		       arg2609_3906 = read___reader(list2610_3907);
		    }
		    CNST_TABLE_SET(i_3903, arg2609_3906);
		 }
		 {
		    int aux_3909;
		    {
		       long aux_3928;
		       aux_3928 = (i_3903 - ((long) 1));
		       aux_3909 = (int) (aux_3928);
		    }
		    {
		       long i_3931;
		       i_3931 = (long) (aux_3909);
		       i_3903 = i_3931;
		       goto loop_3904;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_vector()
{
   {
      obj_t node_setup__pre_make_vector_app_233_3811;
      node_setup__pre_make_vector_app_233_3811 = proc2570_cfa_vector;
      add_method__1___object(node_setup__env_214_cfa_setup, pre_make_vector_app_251_cfa_info, node_setup__pre_make_vector_app_233_3811);
   }
   {
      obj_t node_setup__pre_create_vector_app_101_3810;
      node_setup__pre_create_vector_app_101_3810 = proc2571_cfa_vector;
      add_method__1___object(node_setup__env_214_cfa_setup, pre_create_vector_app_162_cfa_info, node_setup__pre_create_vector_app_101_3810);
   }
   {
      obj_t node_setup__pre_vector_ref_app_36_3809;
      node_setup__pre_vector_ref_app_36_3809 = proc2572_cfa_vector;
      add_method__1___object(node_setup__env_214_cfa_setup, pre_vector_ref_app_208_cfa_info, node_setup__pre_vector_ref_app_36_3809);
   }
   {
      obj_t node_setup__pre_vector_set__app_35_3808;
      node_setup__pre_vector_set__app_35_3808 = proc2573_cfa_vector;
      add_method__1___object(node_setup__env_214_cfa_setup, pre_vector_set__app_211_cfa_info, node_setup__pre_vector_set__app_35_3808);
   }
   {
      obj_t cfa__make_vector_app_74_3807;
      cfa__make_vector_app_74_3807 = proc2574_cfa_vector;
      add_method__1___object(cfa__env_153_cfa_cfa, make_vector_app_205_cfa_info, cfa__make_vector_app_74_3807);
   }
   {
      obj_t cfa__create_vector_app_163_3806;
      cfa__create_vector_app_163_3806 = proc2575_cfa_vector;
      add_method__1___object(cfa__env_153_cfa_cfa, create_vector_app_150_cfa_info, cfa__create_vector_app_163_3806);
   }
   {
      obj_t cfa__vector_ref_app_32_3805;
      cfa__vector_ref_app_32_3805 = proc2576_cfa_vector;
      add_method__1___object(cfa__env_153_cfa_cfa, vector_ref_app_195_cfa_info, cfa__vector_ref_app_32_3805);
   }
   {
      obj_t cfa__vector_set__app_153_3803;
      cfa__vector_set__app_153_3803 = proc2577_cfa_vector;
      add_method__1___object(cfa__env_153_cfa_cfa, vector_set__app_21_cfa_info, cfa__vector_set__app_153_3803);
   }
   {
      obj_t loose_alloc__make_vector_app_71_3801;
      loose_alloc__make_vector_app_71_3801 = proc2578_cfa_vector;
      add_method__1___object(loose_alloc__env_83_cfa_loose, make_vector_app_205_cfa_info, loose_alloc__make_vector_app_71_3801);
   }
   {
      obj_t loose_alloc__create_vector_app_169_3798;
      loose_alloc__create_vector_app_169_3798 = proc2579_cfa_vector;
      add_method__1___object(loose_alloc__env_83_cfa_loose, create_vector_app_150_cfa_info, loose_alloc__create_vector_app_169_3798);
   }
   {
      obj_t stack_loose_alloc__make_vector_app_80_3797;
      stack_loose_alloc__make_vector_app_80_3797 = proc2580_cfa_vector;
      add_method__1___object(stack_loose_alloc__env_147_cfa_loose, make_vector_app_205_cfa_info, stack_loose_alloc__make_vector_app_80_3797);
   }
   {
      obj_t stack_loose_alloc__create_vector_app_171_3794;
      stack_loose_alloc__create_vector_app_171_3794 = proc2581_cfa_vector;
      add_method__1___object(stack_loose_alloc__env_147_cfa_loose, create_vector_app_150_cfa_info, stack_loose_alloc__create_vector_app_171_3794);
   }
   {
      obj_t node_key_pre_make_vector_app_196_3791;
      node_key_pre_make_vector_app_196_3791 = proc2582_cfa_vector;
      add_method__1___object(node_key_env_229_cfa_approx, pre_make_vector_app_251_cfa_info, node_key_pre_make_vector_app_196_3791);
   }
   {
      obj_t node_key_set__pre_make_vector_app_67_3790;
      node_key_set__pre_make_vector_app_67_3790 = proc2583_cfa_vector;
      add_method__1___object(node_key_set__env_57_cfa_approx, pre_make_vector_app_251_cfa_info, node_key_set__pre_make_vector_app_67_3790);
   }
   {
      obj_t node_key_make_vector_app_132_3789;
      node_key_make_vector_app_132_3789 = proc2584_cfa_vector;
      add_method__1___object(node_key_env_229_cfa_approx, make_vector_app_205_cfa_info, node_key_make_vector_app_132_3789);
   }
   {
      obj_t node_key_pre_create_vector_app_189_3788;
      node_key_pre_create_vector_app_189_3788 = proc2585_cfa_vector;
      add_method__1___object(node_key_env_229_cfa_approx, pre_create_vector_app_162_cfa_info, node_key_pre_create_vector_app_189_3788);
   }
   {
      obj_t node_key_set__pre_create_vector_app_233_3787;
      node_key_set__pre_create_vector_app_233_3787 = proc2586_cfa_vector;
      add_method__1___object(node_key_set__env_57_cfa_approx, pre_create_vector_app_162_cfa_info, node_key_set__pre_create_vector_app_233_3787);
   }
   {
      obj_t node_key_create_vector_app_192_3786;
      node_key_create_vector_app_192_3786 = proc2587_cfa_vector;
      add_method__1___object(node_key_env_229_cfa_approx, create_vector_app_150_cfa_info, node_key_create_vector_app_192_3786);
   }
   {
      obj_t stack__make_vector_app_190_3785;
      stack__make_vector_app_190_3785 = proc2588_cfa_vector;
      add_method__1___object(stack__env_104_cfa_stack, make_vector_app_205_cfa_info, stack__make_vector_app_190_3785);
   }
   {
      obj_t stack__create_vector_app_141_3784;
      stack__create_vector_app_141_3784 = proc2589_cfa_vector;
      return add_method__1___object(stack__env_104_cfa_stack, create_vector_app_150_cfa_info, stack__create_vector_app_141_3784);
   }
}


obj_t 
stack__create_vector_app2536_50_cfa_vector(obj_t env_3812, obj_t node_3813)
{
   {
      create_vector_app_150_t node_2392;
      {
	 node_t aux_3953;
	 node_2392 = (create_vector_app_150_t) (node_3813);
	 {
	    bool_t test2256_2396;
	    {
	       obj_t aux_3954;
	       aux_3954 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	       test2256_2396 = CBOOL(aux_3954);
	    }
	    if (test2256_2396)
	      {
		 bool_t arg2258_2398;
		 {
		    obj_t aux_3960;
		    {
		       object_t aux_3961;
		       aux_3961 = (object_t) (node_2392);
		       aux_3960 = OBJECT_WIDENING(aux_3961);
		    }
		    arg2258_2398 = (((create_vector_app_150_t) CREF(aux_3960))->stackable__42);
		 }
		 {
		    obj_t list2259_2399;
		    {
		       obj_t arg2260_2400;
		       {
			  obj_t arg2261_2401;
			  {
			     obj_t aux_3965;
			     aux_3965 = BCHAR(((unsigned char) '\n'));
			     arg2261_2401 = MAKE_PAIR(aux_3965, BNIL);
			  }
			  {
			     obj_t aux_3968;
			     aux_3968 = BBOOL(arg2258_2398);
			     arg2260_2400 = MAKE_PAIR(aux_3968, arg2261_2401);
			  }
		       }
		       list2259_2399 = MAKE_PAIR(string2590_cfa_vector, arg2260_2400);
		    }
		    print_trace_107_tools_trace(list2259_2399);
		 }
	      }
	    else
	      {
		 BUNSPEC;
	      }
	 }
	 {
	    obj_t aux_3973;
	    {
	       app_t obj_3433;
	       obj_3433 = (app_t) (node_2392);
	       aux_3973 = (((app_t) CREF(obj_3433))->args);
	    }
	    stack___129_cfa_stack(aux_3973);
	 }
	 {
	    bool_t aux_3977;
	    {
	       bool_t test_3979;
	       {
		  long aux_3980;
		  {
		     obj_t aux_3981;
		     {
			object_t aux_3982;
			aux_3982 = (object_t) (node_2392);
			aux_3981 = OBJECT_WIDENING(aux_3982);
		     }
		     aux_3980 = (((create_vector_app_150_t) CREF(aux_3981))->lost_stamp_114);
		  }
		  test_3979 = (aux_3980 == ((long) -1));
	       }
	       if (test_3979)
		 {
		    obj_t aux_3987;
		    {
		       object_t aux_3988;
		       aux_3988 = (object_t) (node_2392);
		       aux_3987 = OBJECT_WIDENING(aux_3988);
		    }
		    aux_3977 = (((create_vector_app_150_t) CREF(aux_3987))->stackable__42);
		 }
	       else
		 {
		    aux_3977 = ((bool_t) 0);
		 }
	    }
	    aux_3953 = node_heap__stack__239_cfa_stack((app_t) (node_2392), aux_3977);
	 }
	 return (obj_t) (aux_3953);
      }
   }
}


obj_t 
stack__make_vector_app2537_210_cfa_vector(obj_t env_3814, obj_t node_3815)
{
   {
      make_vector_app_205_t node_2372;
      {
	 node_t aux_3995;
	 node_2372 = (make_vector_app_205_t) (node_3815);
	 {
	    bool_t test2236_2376;
	    {
	       obj_t aux_3996;
	       aux_3996 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	       test2236_2376 = CBOOL(aux_3996);
	    }
	    if (test2236_2376)
	      {
		 bool_t arg2243_2378;
		 {
		    obj_t aux_4002;
		    {
		       object_t aux_4003;
		       aux_4003 = (object_t) (node_2372);
		       aux_4002 = OBJECT_WIDENING(aux_4003);
		    }
		    arg2243_2378 = (((make_vector_app_205_t) CREF(aux_4002))->stackable__42);
		 }
		 {
		    obj_t list2244_2379;
		    {
		       obj_t arg2245_2380;
		       {
			  obj_t arg2246_2381;
			  {
			     obj_t aux_4007;
			     aux_4007 = BCHAR(((unsigned char) '\n'));
			     arg2246_2381 = MAKE_PAIR(aux_4007, BNIL);
			  }
			  {
			     obj_t aux_4010;
			     aux_4010 = BBOOL(arg2243_2378);
			     arg2245_2380 = MAKE_PAIR(aux_4010, arg2246_2381);
			  }
		       }
		       list2244_2379 = MAKE_PAIR(string2591_cfa_vector, arg2245_2380);
		    }
		    print_trace_107_tools_trace(list2244_2379);
		 }
	      }
	    else
	      {
		 BUNSPEC;
	      }
	 }
	 {
	    obj_t aux_4015;
	    {
	       app_t obj_3427;
	       obj_3427 = (app_t) (node_2372);
	       aux_4015 = (((app_t) CREF(obj_3427))->args);
	    }
	    stack___129_cfa_stack(aux_4015);
	 }
	 {
	    bool_t aux_4019;
	    {
	       bool_t test_4021;
	       {
		  long aux_4022;
		  {
		     obj_t aux_4023;
		     {
			object_t aux_4024;
			aux_4024 = (object_t) (node_2372);
			aux_4023 = OBJECT_WIDENING(aux_4024);
		     }
		     aux_4022 = (((make_vector_app_205_t) CREF(aux_4023))->lost_stamp_114);
		  }
		  test_4021 = (aux_4022 == ((long) -1));
	       }
	       if (test_4021)
		 {
		    obj_t aux_4029;
		    {
		       object_t aux_4030;
		       aux_4030 = (object_t) (node_2372);
		       aux_4029 = OBJECT_WIDENING(aux_4030);
		    }
		    aux_4019 = (((make_vector_app_205_t) CREF(aux_4029))->stackable__42);
		 }
	       else
		 {
		    aux_4019 = ((bool_t) 0);
		 }
	    }
	    aux_3995 = node_heap__stack__239_cfa_stack((app_t) (node_2372), aux_4019);
	 }
	 return (obj_t) (aux_3995);
      }
   }
}


obj_t 
node_key_create_vector_app2538_252_cfa_vector(obj_t env_3816, obj_t app_3817)
{
   {
      create_vector_app_150_t app_2366;
      app_2366 = (create_vector_app_150_t) (app_3817);
      {
	 obj_t aux_4037;
	 {
	    object_t aux_4038;
	    aux_4038 = (object_t) (app_2366);
	    aux_4037 = OBJECT_WIDENING(aux_4038);
	 }
	 return (((create_vector_app_150_t) CREF(aux_4037))->key);
      }
   }
}


obj_t 
node_key_set__pre_create_vector_app2539_16_cfa_vector(obj_t env_3818, obj_t app_3819, obj_t new_key_72_3820)
{
   {
      pre_create_vector_app_162_t app_2359;
      obj_t new_key_72_2360;
      app_2359 = (pre_create_vector_app_162_t) (app_3819);
      new_key_72_2360 = new_key_72_3820;
      {
	 obj_t res2534_3423;
	 {
	    obj_t x_3886;
	    {
	       obj_t aux_4043;
	       {
		  object_t aux_4044;
		  aux_4044 = (object_t) (app_2359);
		  aux_4043 = OBJECT_WIDENING(aux_4044);
	       }
	       x_3886 = ((((pre_create_vector_app_162_t) CREF(aux_4043))->key) = ((obj_t) new_key_72_2360), BUNSPEC);
	    }
	    res2534_3423 = BUNSPEC;
	 }
	 return res2534_3423;
      }
   }
}


obj_t 
node_key_pre_create_vector_app2540_108_cfa_vector(obj_t env_3821, obj_t app_3822)
{
   {
      pre_create_vector_app_162_t app_2353;
      app_2353 = (pre_create_vector_app_162_t) (app_3822);
      {
	 obj_t aux_4049;
	 {
	    object_t aux_4050;
	    aux_4050 = (object_t) (app_2353);
	    aux_4049 = OBJECT_WIDENING(aux_4050);
	 }
	 return (((pre_create_vector_app_162_t) CREF(aux_4049))->key);
      }
   }
}


obj_t 
node_key_make_vector_app2541_150_cfa_vector(obj_t env_3823, obj_t app_3824)
{
   {
      make_vector_app_205_t app_2347;
      app_2347 = (make_vector_app_205_t) (app_3824);
      {
	 obj_t aux_4055;
	 {
	    object_t aux_4056;
	    aux_4056 = (object_t) (app_2347);
	    aux_4055 = OBJECT_WIDENING(aux_4056);
	 }
	 return (((make_vector_app_205_t) CREF(aux_4055))->key);
      }
   }
}


obj_t 
node_key_set__pre_make_vector_app2542_97_cfa_vector(obj_t env_3825, obj_t app_3826, obj_t new_key_72_3827)
{
   {
      pre_make_vector_app_251_t app_2340;
      obj_t new_key_72_2341;
      app_2340 = (pre_make_vector_app_251_t) (app_3826);
      new_key_72_2341 = new_key_72_3827;
      {
	 obj_t res2533_3415;
	 {
	    obj_t x_3887;
	    {
	       obj_t aux_4061;
	       {
		  object_t aux_4062;
		  aux_4062 = (object_t) (app_2340);
		  aux_4061 = OBJECT_WIDENING(aux_4062);
	       }
	       x_3887 = ((((pre_make_vector_app_251_t) CREF(aux_4061))->key) = ((obj_t) new_key_72_2341), BUNSPEC);
	    }
	    res2533_3415 = BUNSPEC;
	 }
	 return res2533_3415;
      }
   }
}


obj_t 
node_key_pre_make_vector_app2543_61_cfa_vector(obj_t env_3828, obj_t app_3829)
{
   {
      pre_make_vector_app_251_t app_2334;
      app_2334 = (pre_make_vector_app_251_t) (app_3829);
      {
	 obj_t aux_4067;
	 {
	    object_t aux_4068;
	    aux_4068 = (object_t) (app_2334);
	    aux_4067 = OBJECT_WIDENING(aux_4068);
	 }
	 return (((pre_make_vector_app_251_t) CREF(aux_4067))->key);
      }
   }
}


obj_t 
stack_loose_alloc__create_vector_app2544_89_cfa_vector(obj_t env_3830, obj_t alloc_3831, obj_t cowner_3832)
{
   {
      create_vector_app_150_t alloc_2289;
      obj_t cowner_2290;
      alloc_2289 = (create_vector_app_150_t) (alloc_3831);
      cowner_2290 = cowner_3832;
      {
	 bool_t test_4073;
	 {
	    bool_t test_4074;
	    {
	       obj_t aux_4075;
	       {
		  object_t aux_4076;
		  aux_4076 = (object_t) (alloc_2289);
		  aux_4075 = OBJECT_WIDENING(aux_4076);
	       }
	       test_4074 = (((create_vector_app_150_t) CREF(aux_4075))->stackable__42);
	    }
	    if (test_4074)
	      {
		 obj_t aux_4080;
		 {
		    obj_t aux_4081;
		    {
		       obj_t aux_4082;
		       {
			  object_t aux_4083;
			  aux_4083 = (object_t) (alloc_2289);
			  aux_4082 = OBJECT_WIDENING(aux_4083);
		       }
		       aux_4081 = (((create_vector_app_150_t) CREF(aux_4082))->stack_stamp_31);
		    }
		    aux_4080 = memq___r4_pairs_and_lists_6_3(cowner_2290, aux_4081);
		 }
		 test_4073 = CBOOL(aux_4080);
	      }
	    else
	      {
		 test_4073 = ((bool_t) 1);
	      }
	 }
	 if (test_4073)
	   {
	      return BUNSPEC;
	   }
	 else
	   {
	      {
		 obj_t arg2195_2295;
		 {
		    obj_t aux_4089;
		    {
		       obj_t aux_4090;
		       {
			  object_t aux_4091;
			  aux_4091 = (object_t) (alloc_2289);
			  aux_4090 = OBJECT_WIDENING(aux_4091);
		       }
		       aux_4089 = (((create_vector_app_150_t) CREF(aux_4090))->stack_stamp_31);
		    }
		    arg2195_2295 = MAKE_PAIR(cowner_2290, aux_4089);
		 }
		 {
		    obj_t res2531_3398;
		    {
		       obj_t x_3888;
		       {
			  obj_t aux_4096;
			  {
			     object_t aux_4097;
			     aux_4097 = (object_t) (alloc_2289);
			     aux_4096 = OBJECT_WIDENING(aux_4097);
			  }
			  x_3888 = ((((create_vector_app_150_t) CREF(aux_4096))->stack_stamp_31) = ((obj_t) arg2195_2295), BUNSPEC);
		       }
		       res2531_3398 = BUNSPEC;
		    }
		    res2531_3398;
		 }
	      }
	      {
		 bool_t test2197_2297;
		 {
		    bool_t test2225_2328;
		    test2225_2328 = is_a__118___object(cowner_2290, variable_ast_var);
		    if (test2225_2328)
		      {
			 obj_t aux_4103;
			 {
			    variable_t aux_4104;
			    {
			       obj_t aux_4105;
			       {
				  object_t aux_4106;
				  aux_4106 = (object_t) (alloc_2289);
				  aux_4105 = OBJECT_WIDENING(aux_4106);
			       }
			       aux_4104 = (((create_vector_app_150_t) CREF(aux_4105))->owner);
			    }
			    aux_4103 = (obj_t) (aux_4104);
			 }
			 test2197_2297 = (aux_4103 == cowner_2290);
		      }
		    else
		      {
			 test2197_2297 = ((bool_t) 1);
		      }
		 }
		 if (test2197_2297)
		   {
		      {
			 bool_t test2198_2298;
			 {
			    obj_t aux_4113;
			    aux_4113 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			    test2198_2298 = CBOOL(aux_4113);
			 }
			 if (test2198_2298)
			   {
			      obj_t arg2200_2300;
			      arg2200_2300 = shape_tools_shape((obj_t) (alloc_2289));
			      {
				 obj_t list2201_2301;
				 {
				    obj_t arg2202_2302;
				    {
				       obj_t arg2203_2303;
				       {
					  obj_t aux_4121;
					  aux_4121 = BCHAR(((unsigned char) '\n'));
					  arg2203_2303 = MAKE_PAIR(aux_4121, BNIL);
				       }
				       arg2202_2302 = MAKE_PAIR(arg2200_2300, arg2203_2303);
				    }
				    list2201_2301 = MAKE_PAIR(string2592_cfa_vector, arg2202_2302);
				 }
				 print_trace_107_tools_trace(list2201_2301);
			      }
			   }
			 else
			   {
			      BUNSPEC;
			   }
		      }
		      {
			 bool_t test2208_2307;
			 {
			    obj_t aux_4127;
			    aux_4127 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
			    test2208_2307 = CBOOL(aux_4127);
			 }
			 if (test2208_2307)
			   {
			      obj_t arg2210_2309;
			      {
				 obj_t aux_4133;
				 {
				    approx_t aux_4134;
				    {
				       obj_t aux_4135;
				       {
					  object_t aux_4136;
					  aux_4136 = (object_t) (alloc_2289);
					  aux_4135 = OBJECT_WIDENING(aux_4136);
				       }
				       aux_4134 = (((create_vector_app_150_t) CREF(aux_4135))->value_approx_19);
				    }
				    aux_4133 = (obj_t) (aux_4134);
				 }
				 arg2210_2309 = shape_tools_shape(aux_4133);
			      }
			      {
				 obj_t list2211_2310;
				 {
				    obj_t arg2212_2311;
				    {
				       obj_t arg2213_2312;
				       {
					  obj_t aux_4142;
					  aux_4142 = BCHAR(((unsigned char) '\n'));
					  arg2213_2312 = MAKE_PAIR(aux_4142, BNIL);
				       }
				       arg2212_2311 = MAKE_PAIR(arg2210_2309, arg2213_2312);
				    }
				    list2211_2310 = MAKE_PAIR(string2593_cfa_vector, arg2212_2311);
				 }
				 print_trace_107_tools_trace(list2211_2310);
			      }
			   }
			 else
			   {
			      BUNSPEC;
			   }
		      }
		      {
			 obj_t res2532_3406;
			 {
			    obj_t x_3889;
			    {
			       obj_t aux_4148;
			       {
				  object_t aux_4149;
				  aux_4149 = (object_t) (alloc_2289);
				  aux_4148 = OBJECT_WIDENING(aux_4149);
			       }
			       x_3889 = ((((create_vector_app_150_t) CREF(aux_4148))->stackable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			    }
			    res2532_3406 = BUNSPEC;
			 }
			 res2532_3406;
		      }
		      {
			 approx_t arg2219_2318;
			 {
			    obj_t aux_4153;
			    {
			       object_t aux_4154;
			       aux_4154 = (object_t) (alloc_2289);
			       aux_4153 = OBJECT_WIDENING(aux_4154);
			    }
			    arg2219_2318 = (((create_vector_app_150_t) CREF(aux_4153))->value_approx_19);
			 }
			 {
			    obj_t arg2218_3792;
			    arg2218_3792 = proc2594_cfa_vector;
			    return for_each_approx_alloc_83_cfa_approx(arg2218_3792, arg2219_2318);
			 }
		      }
		   }
		 else
		   {
		      approx_t arg2223_2324;
		      {
			 obj_t aux_4159;
			 {
			    object_t aux_4160;
			    aux_4160 = (object_t) (alloc_2289);
			    aux_4159 = OBJECT_WIDENING(aux_4160);
			 }
			 arg2223_2324 = (((create_vector_app_150_t) CREF(aux_4159))->value_approx_19);
		      }
		      {
			 obj_t arg2222_3793;
			 arg2222_3793 = make_fx_procedure(arg22222546_cfa_vector, ((long) 1), ((long) 1));
			 PROCEDURE_SET(arg2222_3793, ((long) 0), cowner_2290);
			 return for_each_approx_alloc_83_cfa_approx(arg2222_3793, arg2223_2324);
		      }
		   }
	      }
	   }
      }
   }
}


obj_t 
arg22182545_cfa_vector(obj_t env_3833, obj_t alloc_3834)
{
   {
      obj_t alloc_2319;
      alloc_2319 = alloc_3834;
      return stack_loose_alloc__95_cfa_loose((node_t) (alloc_2319), CNST_TABLE_REF(((long) 1)));
   }
}


obj_t 
arg22222546_cfa_vector(obj_t env_3835, obj_t alloc_3837)
{
   {
      obj_t cowner_3836;
      cowner_3836 = PROCEDURE_REF(env_3835, ((long) 0));
      {
	 obj_t alloc_2325;
	 alloc_2325 = alloc_3837;
	 return stack_loose_alloc__95_cfa_loose((node_t) (alloc_2325), cowner_3836);
      }
   }
}


obj_t 
stack_loose_alloc__make_vector_app2547_141_cfa_vector(obj_t env_3838, obj_t alloc_3839, obj_t cowner_3840)
{
   {
      make_vector_app_205_t alloc_2244;
      obj_t cowner_2245;
      alloc_2244 = (make_vector_app_205_t) (alloc_3839);
      cowner_2245 = cowner_3840;
      {
	 bool_t test_4174;
	 {
	    bool_t test_4175;
	    {
	       obj_t aux_4176;
	       {
		  object_t aux_4177;
		  aux_4177 = (object_t) (alloc_2244);
		  aux_4176 = OBJECT_WIDENING(aux_4177);
	       }
	       test_4175 = (((make_vector_app_205_t) CREF(aux_4176))->stackable__42);
	    }
	    if (test_4175)
	      {
		 obj_t aux_4181;
		 {
		    obj_t aux_4182;
		    {
		       obj_t aux_4183;
		       {
			  object_t aux_4184;
			  aux_4184 = (object_t) (alloc_2244);
			  aux_4183 = OBJECT_WIDENING(aux_4184);
		       }
		       aux_4182 = (((make_vector_app_205_t) CREF(aux_4183))->stack_stamp_31);
		    }
		    aux_4181 = memq___r4_pairs_and_lists_6_3(cowner_2245, aux_4182);
		 }
		 test_4174 = CBOOL(aux_4181);
	      }
	    else
	      {
		 test_4174 = ((bool_t) 1);
	      }
	 }
	 if (test_4174)
	   {
	      return BUNSPEC;
	   }
	 else
	   {
	      {
		 obj_t arg2160_2250;
		 {
		    obj_t aux_4190;
		    {
		       obj_t aux_4191;
		       {
			  object_t aux_4192;
			  aux_4192 = (object_t) (alloc_2244);
			  aux_4191 = OBJECT_WIDENING(aux_4192);
		       }
		       aux_4190 = (((make_vector_app_205_t) CREF(aux_4191))->stack_stamp_31);
		    }
		    arg2160_2250 = MAKE_PAIR(cowner_2245, aux_4190);
		 }
		 {
		    obj_t res2529_3379;
		    {
		       obj_t x_3890;
		       {
			  obj_t aux_4197;
			  {
			     object_t aux_4198;
			     aux_4198 = (object_t) (alloc_2244);
			     aux_4197 = OBJECT_WIDENING(aux_4198);
			  }
			  x_3890 = ((((make_vector_app_205_t) CREF(aux_4197))->stack_stamp_31) = ((obj_t) arg2160_2250), BUNSPEC);
		       }
		       res2529_3379 = BUNSPEC;
		    }
		    res2529_3379;
		 }
	      }
	      {
		 bool_t test2162_2252;
		 {
		    bool_t test2189_2283;
		    test2189_2283 = is_a__118___object(cowner_2245, variable_ast_var);
		    if (test2189_2283)
		      {
			 obj_t aux_4204;
			 {
			    variable_t aux_4205;
			    {
			       obj_t aux_4206;
			       {
				  object_t aux_4207;
				  aux_4207 = (object_t) (alloc_2244);
				  aux_4206 = OBJECT_WIDENING(aux_4207);
			       }
			       aux_4205 = (((make_vector_app_205_t) CREF(aux_4206))->owner);
			    }
			    aux_4204 = (obj_t) (aux_4205);
			 }
			 test2162_2252 = (aux_4204 == cowner_2245);
		      }
		    else
		      {
			 test2162_2252 = ((bool_t) 1);
		      }
		 }
		 if (test2162_2252)
		   {
		      {
			 bool_t test2163_2253;
			 {
			    obj_t aux_4214;
			    aux_4214 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			    test2163_2253 = CBOOL(aux_4214);
			 }
			 if (test2163_2253)
			   {
			      obj_t arg2165_2255;
			      arg2165_2255 = shape_tools_shape((obj_t) (alloc_2244));
			      {
				 obj_t list2166_2256;
				 {
				    obj_t arg2167_2257;
				    {
				       obj_t arg2168_2258;
				       {
					  obj_t aux_4222;
					  aux_4222 = BCHAR(((unsigned char) '\n'));
					  arg2168_2258 = MAKE_PAIR(aux_4222, BNIL);
				       }
				       arg2167_2257 = MAKE_PAIR(arg2165_2255, arg2168_2258);
				    }
				    list2166_2256 = MAKE_PAIR(string2592_cfa_vector, arg2167_2257);
				 }
				 print_trace_107_tools_trace(list2166_2256);
			      }
			   }
			 else
			   {
			      BUNSPEC;
			   }
		      }
		      {
			 bool_t test2172_2262;
			 {
			    obj_t aux_4228;
			    aux_4228 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
			    test2172_2262 = CBOOL(aux_4228);
			 }
			 if (test2172_2262)
			   {
			      obj_t arg2174_2264;
			      {
				 obj_t aux_4234;
				 {
				    approx_t aux_4235;
				    {
				       obj_t aux_4236;
				       {
					  object_t aux_4237;
					  aux_4237 = (object_t) (alloc_2244);
					  aux_4236 = OBJECT_WIDENING(aux_4237);
				       }
				       aux_4235 = (((make_vector_app_205_t) CREF(aux_4236))->value_approx_19);
				    }
				    aux_4234 = (obj_t) (aux_4235);
				 }
				 arg2174_2264 = shape_tools_shape(aux_4234);
			      }
			      {
				 obj_t list2175_2265;
				 {
				    obj_t arg2176_2266;
				    {
				       obj_t arg2177_2267;
				       {
					  obj_t aux_4243;
					  aux_4243 = BCHAR(((unsigned char) '\n'));
					  arg2177_2267 = MAKE_PAIR(aux_4243, BNIL);
				       }
				       arg2176_2266 = MAKE_PAIR(arg2174_2264, arg2177_2267);
				    }
				    list2175_2265 = MAKE_PAIR(string2593_cfa_vector, arg2176_2266);
				 }
				 print_trace_107_tools_trace(list2175_2265);
			      }
			   }
			 else
			   {
			      BUNSPEC;
			   }
		      }
		      {
			 obj_t res2530_3387;
			 {
			    obj_t x_3891;
			    {
			       obj_t aux_4249;
			       {
				  object_t aux_4250;
				  aux_4250 = (object_t) (alloc_2244);
				  aux_4249 = OBJECT_WIDENING(aux_4250);
			       }
			       x_3891 = ((((make_vector_app_205_t) CREF(aux_4249))->stackable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			    }
			    res2530_3387 = BUNSPEC;
			 }
			 res2530_3387;
		      }
		      {
			 approx_t arg2183_2273;
			 {
			    obj_t aux_4254;
			    {
			       object_t aux_4255;
			       aux_4255 = (object_t) (alloc_2244);
			       aux_4254 = OBJECT_WIDENING(aux_4255);
			    }
			    arg2183_2273 = (((make_vector_app_205_t) CREF(aux_4254))->value_approx_19);
			 }
			 {
			    obj_t arg2182_3795;
			    arg2182_3795 = proc2595_cfa_vector;
			    return for_each_approx_alloc_83_cfa_approx(arg2182_3795, arg2183_2273);
			 }
		      }
		   }
		 else
		   {
		      approx_t arg2187_2279;
		      {
			 obj_t aux_4260;
			 {
			    object_t aux_4261;
			    aux_4261 = (object_t) (alloc_2244);
			    aux_4260 = OBJECT_WIDENING(aux_4261);
			 }
			 arg2187_2279 = (((make_vector_app_205_t) CREF(aux_4260))->value_approx_19);
		      }
		      {
			 obj_t arg2186_3796;
			 arg2186_3796 = make_fx_procedure(arg21862549_cfa_vector, ((long) 1), ((long) 1));
			 PROCEDURE_SET(arg2186_3796, ((long) 0), cowner_2245);
			 return for_each_approx_alloc_83_cfa_approx(arg2186_3796, arg2187_2279);
		      }
		   }
	      }
	   }
      }
   }
}


obj_t 
arg21822548_cfa_vector(obj_t env_3841, obj_t alloc_3842)
{
   {
      obj_t alloc_2274;
      alloc_2274 = alloc_3842;
      return stack_loose_alloc__95_cfa_loose((node_t) (alloc_2274), CNST_TABLE_REF(((long) 1)));
   }
}


obj_t 
arg21862549_cfa_vector(obj_t env_3843, obj_t alloc_3845)
{
   {
      obj_t cowner_3844;
      cowner_3844 = PROCEDURE_REF(env_3843, ((long) 0));
      {
	 obj_t alloc_2280;
	 alloc_2280 = alloc_3845;
	 return stack_loose_alloc__95_cfa_loose((node_t) (alloc_2280), cowner_3844);
      }
   }
}


obj_t 
loose_alloc__create_vector_app2550_135_cfa_vector(obj_t env_3846, obj_t alloc_3847)
{
   {
      create_vector_app_150_t alloc_2214;
      alloc_2214 = (create_vector_app_150_t) (alloc_3847);
      {
	 bool_t test2130_2218;
	 {
	    long arg2154_2241;
	    {
	       obj_t aux_4275;
	       {
		  object_t aux_4276;
		  aux_4276 = (object_t) (alloc_2214);
		  aux_4275 = OBJECT_WIDENING(aux_4276);
	       }
	       arg2154_2241 = (((create_vector_app_150_t) CREF(aux_4275))->lost_stamp_114);
	    }
	    {
	       long n2_3361;
	       n2_3361 = (long) CINT(__cfa_stamp__16_cfa_iterate);
	       test2130_2218 = (arg2154_2241 == n2_3361);
	    }
	 }
	 if (test2130_2218)
	   {
	      return BUNSPEC;
	   }
	 else
	   {
	      {
		 bool_t test2131_2219;
		 {
		    obj_t aux_4283;
		    aux_4283 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
		    test2131_2219 = CBOOL(aux_4283);
		 }
		 if (test2131_2219)
		   {
		      obj_t arg2133_2221;
		      arg2133_2221 = shape_tools_shape((obj_t) (alloc_2214));
		      {
			 obj_t list2134_2222;
			 {
			    obj_t arg2135_2223;
			    {
			       obj_t arg2136_2224;
			       {
				  obj_t aux_4291;
				  aux_4291 = BCHAR(((unsigned char) '\n'));
				  arg2136_2224 = MAKE_PAIR(aux_4291, BNIL);
			       }
			       arg2135_2223 = MAKE_PAIR(arg2133_2221, arg2136_2224);
			    }
			    list2134_2222 = MAKE_PAIR(string2596_cfa_vector, arg2135_2223);
			 }
			 print_trace_107_tools_trace(list2134_2222);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	      {
		 bool_t test2140_2228;
		 {
		    obj_t aux_4297;
		    aux_4297 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
		    test2140_2228 = CBOOL(aux_4297);
		 }
		 if (test2140_2228)
		   {
		      obj_t arg2142_2230;
		      {
			 obj_t aux_4303;
			 {
			    approx_t aux_4304;
			    {
			       obj_t aux_4305;
			       {
				  object_t aux_4306;
				  aux_4306 = (object_t) (alloc_2214);
				  aux_4305 = OBJECT_WIDENING(aux_4306);
			       }
			       aux_4304 = (((create_vector_app_150_t) CREF(aux_4305))->value_approx_19);
			    }
			    aux_4303 = (obj_t) (aux_4304);
			 }
			 arg2142_2230 = shape_tools_shape(aux_4303);
		      }
		      {
			 obj_t list2143_2231;
			 {
			    obj_t arg2144_2232;
			    {
			       obj_t arg2145_2233;
			       {
				  obj_t aux_4312;
				  aux_4312 = BCHAR(((unsigned char) '\n'));
				  arg2145_2233 = MAKE_PAIR(aux_4312, BNIL);
			       }
			       arg2144_2232 = MAKE_PAIR(arg2142_2230, arg2145_2233);
			    }
			    list2143_2231 = MAKE_PAIR(string2597_cfa_vector, arg2144_2232);
			 }
			 print_trace_107_tools_trace(list2143_2231);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	      {
		 obj_t res2527_3365;
		 {
		    long val1771_3364;
		    val1771_3364 = (long) CINT(__cfa_stamp__16_cfa_iterate);
		    {
		       obj_t x_3892;
		       {
			  obj_t aux_4319;
			  {
			     object_t aux_4320;
			     aux_4320 = (object_t) (alloc_2214);
			     aux_4319 = OBJECT_WIDENING(aux_4320);
			  }
			  x_3892 = ((((create_vector_app_150_t) CREF(aux_4319))->lost_stamp_114) = ((long) val1771_3364), BUNSPEC);
		       }
		       res2527_3365 = BUNSPEC;
		    }
		 }
		 res2527_3365;
	      }
	      {
		 obj_t res2528_3368;
		 {
		    obj_t x_3893;
		    {
		       obj_t aux_4324;
		       {
			  object_t aux_4325;
			  aux_4325 = (object_t) (alloc_2214);
			  aux_4324 = OBJECT_WIDENING(aux_4325);
		       }
		       x_3893 = ((((create_vector_app_150_t) CREF(aux_4324))->stackable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		    }
		    res2528_3368 = BUNSPEC;
		 }
		 res2528_3368;
	      }
	      {
		 approx_t aux_4329;
		 {
		    obj_t aux_4330;
		    {
		       object_t aux_4331;
		       aux_4331 = (object_t) (alloc_2214);
		       aux_4330 = OBJECT_WIDENING(aux_4331);
		    }
		    aux_4329 = (((create_vector_app_150_t) CREF(aux_4330))->value_approx_19);
		 }
		 for_each_approx_alloc_83_cfa_approx(loose_alloc__env_83_cfa_loose, aux_4329);
	      }
	      {
		 approx_t aux_4336;
		 {
		    obj_t aux_4337;
		    {
		       object_t aux_4338;
		       aux_4338 = (object_t) (alloc_2214);
		       aux_4337 = OBJECT_WIDENING(aux_4338);
		    }
		    aux_4336 = (((create_vector_app_150_t) CREF(aux_4337))->value_approx_19);
		 }
		 approx_set_type__239_cfa_approx(aux_4336, (type_t) (__obj__252_type_cache));
	      }
	      {
		 approx_t aux_4344;
		 {
		    obj_t aux_4345;
		    {
		       object_t aux_4346;
		       aux_4346 = (object_t) (alloc_2214);
		       aux_4345 = OBJECT_WIDENING(aux_4346);
		    }
		    aux_4344 = (((create_vector_app_150_t) CREF(aux_4345))->value_approx_19);
		 }
		 return approx_set_top__187_cfa_approx(aux_4344);
	      }
	   }
      }
   }
}


obj_t 
loose_alloc__make_vector_app2551_20_cfa_vector(obj_t env_3848, obj_t alloc_3849)
{
   {
      make_vector_app_205_t alloc_2194;
      alloc_2194 = (make_vector_app_205_t) (alloc_3849);
      {
	 bool_t test2115_2198;
	 {
	    long arg2128_2211;
	    {
	       obj_t aux_4352;
	       {
		  object_t aux_4353;
		  aux_4353 = (object_t) (alloc_2194);
		  aux_4352 = OBJECT_WIDENING(aux_4353);
	       }
	       arg2128_2211 = (((make_vector_app_205_t) CREF(aux_4352))->lost_stamp_114);
	    }
	    {
	       long n2_3349;
	       n2_3349 = (long) CINT(__cfa_stamp__16_cfa_iterate);
	       test2115_2198 = (arg2128_2211 == n2_3349);
	    }
	 }
	 if (test2115_2198)
	   {
	      return BUNSPEC;
	   }
	 else
	   {
	      {
		 bool_t test2116_2199;
		 {
		    obj_t aux_4360;
		    aux_4360 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
		    test2116_2199 = CBOOL(aux_4360);
		 }
		 if (test2116_2199)
		   {
		      obj_t arg2118_2201;
		      arg2118_2201 = shape_tools_shape((obj_t) (alloc_2194));
		      {
			 obj_t list2119_2202;
			 {
			    obj_t arg2120_2203;
			    {
			       obj_t arg2121_2204;
			       {
				  obj_t aux_4368;
				  aux_4368 = BCHAR(((unsigned char) '\n'));
				  arg2121_2204 = MAKE_PAIR(aux_4368, BNIL);
			       }
			       arg2120_2203 = MAKE_PAIR(arg2118_2201, arg2121_2204);
			    }
			    list2119_2202 = MAKE_PAIR(string2596_cfa_vector, arg2120_2203);
			 }
			 print_trace_107_tools_trace(list2119_2202);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	      {
		 obj_t res2525_3352;
		 {
		    long val1755_3351;
		    val1755_3351 = (long) CINT(__cfa_stamp__16_cfa_iterate);
		    {
		       obj_t x_3894;
		       {
			  obj_t aux_4375;
			  {
			     object_t aux_4376;
			     aux_4376 = (object_t) (alloc_2194);
			     aux_4375 = OBJECT_WIDENING(aux_4376);
			  }
			  x_3894 = ((((make_vector_app_205_t) CREF(aux_4375))->lost_stamp_114) = ((long) val1755_3351), BUNSPEC);
		       }
		       res2525_3352 = BUNSPEC;
		    }
		 }
		 res2525_3352;
	      }
	      {
		 obj_t res2526_3355;
		 {
		    obj_t x_3895;
		    {
		       obj_t aux_4380;
		       {
			  object_t aux_4381;
			  aux_4381 = (object_t) (alloc_2194);
			  aux_4380 = OBJECT_WIDENING(aux_4381);
		       }
		       x_3895 = ((((make_vector_app_205_t) CREF(aux_4380))->stackable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		    }
		    res2526_3355 = BUNSPEC;
		 }
		 res2526_3355;
	      }
	      {
		 approx_t aux_4385;
		 {
		    obj_t aux_4386;
		    {
		       object_t aux_4387;
		       aux_4387 = (object_t) (alloc_2194);
		       aux_4386 = OBJECT_WIDENING(aux_4387);
		    }
		    aux_4385 = (((make_vector_app_205_t) CREF(aux_4386))->value_approx_19);
		 }
		 for_each_approx_alloc_83_cfa_approx(loose_alloc__env_83_cfa_loose, aux_4385);
	      }
	      {
		 approx_t aux_4392;
		 {
		    obj_t aux_4393;
		    {
		       object_t aux_4394;
		       aux_4394 = (object_t) (alloc_2194);
		       aux_4393 = OBJECT_WIDENING(aux_4394);
		    }
		    aux_4392 = (((make_vector_app_205_t) CREF(aux_4393))->value_approx_19);
		 }
		 approx_set_type__239_cfa_approx(aux_4392, (type_t) (__obj__252_type_cache));
	      }
	      {
		 approx_t aux_4400;
		 {
		    obj_t aux_4401;
		    {
		       object_t aux_4402;
		       aux_4402 = (object_t) (alloc_2194);
		       aux_4401 = OBJECT_WIDENING(aux_4402);
		    }
		    aux_4400 = (((make_vector_app_205_t) CREF(aux_4401))->value_approx_19);
		 }
		 return approx_set_top__187_cfa_approx(aux_4400);
	      }
	   }
      }
   }
}


obj_t 
cfa__vector_set__app2552_73_cfa_vector(obj_t env_3850, obj_t node_3851)
{
   {
      vector_set__app_21_t node_2153;
      {
	 approx_t aux_4408;
	 node_2153 = (vector_set__app_21_t) (node_3851);
	 {
	    node_t aux_4409;
	    {
	       obj_t aux_4410;
	       {
		  obj_t aux_4411;
		  {
		     obj_t aux_4412;
		     {
			app_t obj_3318;
			obj_3318 = (app_t) (node_2153);
			aux_4412 = (((app_t) CREF(obj_3318))->args);
		     }
		     aux_4411 = CDR(aux_4412);
		  }
		  aux_4410 = CAR(aux_4411);
	       }
	       aux_4409 = (node_t) (aux_4410);
	    }
	    cfa__102_cfa_cfa(aux_4409);
	 }
	 {
	    approx_t vec_approx_215_2159;
	    approx_t val_approx_22_2160;
	    {
	       node_t aux_4419;
	       {
		  obj_t aux_4420;
		  {
		     obj_t aux_4421;
		     {
			app_t obj_3323;
			obj_3323 = (app_t) (node_2153);
			aux_4421 = (((app_t) CREF(obj_3323))->args);
		     }
		     aux_4420 = CAR(aux_4421);
		  }
		  aux_4419 = (node_t) (aux_4420);
	       }
	       vec_approx_215_2159 = cfa__102_cfa_cfa(aux_4419);
	    }
	    {
	       node_t aux_4427;
	       {
		  obj_t aux_4428;
		  {
		     obj_t aux_4429;
		     {
			obj_t aux_4430;
			{
			   obj_t aux_4431;
			   {
			      app_t obj_3325;
			      obj_3325 = (app_t) (node_2153);
			      aux_4431 = (((app_t) CREF(obj_3325))->args);
			   }
			   aux_4430 = CDR(aux_4431);
			}
			aux_4429 = CDR(aux_4430);
		     }
		     aux_4428 = CAR(aux_4429);
		  }
		  aux_4427 = (node_t) (aux_4428);
	       }
	       val_approx_22_2160 = cfa__102_cfa_cfa(aux_4427);
	    }
	    {
	       bool_t test2084_2161;
	       {
		  obj_t aux_4439;
		  aux_4439 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
		  test2084_2161 = CBOOL(aux_4439);
	       }
	       if (test2084_2161)
		 {
		    obj_t arg2086_2163;
		    obj_t arg2088_2165;
		    arg2086_2163 = shape_tools_shape((obj_t) (node_2153));
		    arg2088_2165 = shape_tools_shape((obj_t) (vec_approx_215_2159));
		    {
		       obj_t list2089_2166;
		       {
			  obj_t arg2091_2167;
			  {
			     obj_t arg2092_2168;
			     {
				obj_t arg2095_2169;
				{
				   obj_t arg2096_2170;
				   {
				      obj_t aux_4449;
				      aux_4449 = BCHAR(((unsigned char) '\n'));
				      arg2096_2170 = MAKE_PAIR(aux_4449, BNIL);
				   }
				   arg2095_2169 = MAKE_PAIR(arg2088_2165, arg2096_2170);
				}
				arg2092_2168 = MAKE_PAIR(string2598_cfa_vector, arg2095_2169);
			     }
			     arg2091_2167 = MAKE_PAIR(arg2086_2163, arg2092_2168);
			  }
			  list2089_2166 = MAKE_PAIR(string2599_cfa_vector, arg2091_2167);
		       }
		       print_trace_107_tools_trace(list2089_2166);
		    }
		 }
	       else
		 {
		    BUNSPEC;
		 }
	    }
	    {
	       bool_t test2100_2174;
	       {
		  obj_t obj2_3334;
		  obj2_3334 = __vector__240_type_cache;
		  {
		     obj_t aux_4457;
		     {
			type_t aux_4458;
			aux_4458 = (((approx_t) CREF(vec_approx_215_2159))->type);
			aux_4457 = (obj_t) (aux_4458);
		     }
		     test2100_2174 = (aux_4457 == obj2_3334);
		  }
	       }
	       if (test2100_2174)
		 {
		    BUNSPEC;
		 }
	       else
		 {
		    approx_set_type__239_cfa_approx(val_approx_22_2160, (type_t) (__obj__252_type_cache));
		 }
	    }
	    if ((((approx_t) CREF(vec_approx_215_2159))->top__138))
	      {
		 approx_t aux_4467;
		 aux_4467 = loose__226_cfa_loose(val_approx_22_2160, CNST_TABLE_REF(((long) 1)));
		 (obj_t) (aux_4467);
	      }
	    else
	      {
		 obj_t arg2104_3802;
		 arg2104_3802 = make_fx_procedure(arg21042553_cfa_vector, ((long) 1), ((long) 1));
		 {
		    obj_t aux_4472;
		    aux_4472 = (obj_t) (val_approx_22_2160);
		    PROCEDURE_SET(arg2104_3802, ((long) 0), aux_4472);
		 }
		 for_each_approx_alloc_83_cfa_approx(arg2104_3802, vec_approx_215_2159);
	      }
	 }
	 {
	    obj_t aux_4476;
	    {
	       object_t aux_4477;
	       aux_4477 = (object_t) (node_2153);
	       aux_4476 = OBJECT_WIDENING(aux_4477);
	    }
	    aux_4408 = (((vector_set__app_21_t) CREF(aux_4476))->approx);
	 }
	 return (obj_t) (aux_4408);
      }
   }
}


obj_t 
arg21042553_cfa_vector(obj_t env_3852, obj_t app_3854)
{
   {
      obj_t val_approx_22_3853;
      val_approx_22_3853 = PROCEDURE_REF(env_3852, ((long) 0));
      {
	 obj_t app_2179;
	 app_2179 = app_3854;
	 {
	    bool_t test2106_2181;
	    test2106_2181 = is_a__118___object(app_2179, make_vector_app_205_cfa_info);
	    if (test2106_2181)
	      {
		 {
		    obj_t res2523_3339;
		    {
		       make_vector_app_205_t obj_3337;
		       obj_3337 = (make_vector_app_205_t) (app_2179);
		       {
			  obj_t x_3896;
			  {
			     obj_t aux_4487;
			     {
				object_t aux_4488;
				aux_4488 = (object_t) (obj_3337);
				aux_4487 = OBJECT_WIDENING(aux_4488);
			     }
			     x_3896 = ((((make_vector_app_205_t) CREF(aux_4487))->seen__39) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			  }
			  res2523_3339 = BUNSPEC;
		       }
		    }
		    res2523_3339;
		 }
		 {
		    approx_t aux_4492;
		    {
		       approx_t aux_4493;
		       {
			  make_vector_app_205_t obj_3340;
			  obj_3340 = (make_vector_app_205_t) (app_2179);
			  {
			     obj_t aux_4495;
			     {
				object_t aux_4496;
				aux_4496 = (object_t) (obj_3340);
				aux_4495 = OBJECT_WIDENING(aux_4496);
			     }
			     aux_4493 = (((make_vector_app_205_t) CREF(aux_4495))->value_approx_19);
			  }
		       }
		       aux_4492 = union_approx__241_cfa_approx(aux_4493, (approx_t) (val_approx_22_3853));
		    }
		    return (obj_t) (aux_4492);
		 }
	      }
	    else
	      {
		 bool_t test2108_2184;
		 test2108_2184 = is_a__118___object(app_2179, create_vector_app_150_cfa_info);
		 if (test2108_2184)
		   {
		      {
			 obj_t res2524_3344;
			 {
			    create_vector_app_150_t obj_3342;
			    obj_3342 = (create_vector_app_150_t) (app_2179);
			    {
			       obj_t x_3897;
			       {
				  obj_t aux_4506;
				  {
				     object_t aux_4507;
				     aux_4507 = (object_t) (obj_3342);
				     aux_4506 = OBJECT_WIDENING(aux_4507);
				  }
				  x_3897 = ((((create_vector_app_150_t) CREF(aux_4506))->seen__39) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			       }
			       res2524_3344 = BUNSPEC;
			    }
			 }
			 res2524_3344;
		      }
		      {
			 approx_t aux_4511;
			 {
			    approx_t aux_4512;
			    {
			       create_vector_app_150_t obj_3345;
			       obj_3345 = (create_vector_app_150_t) (app_2179);
			       {
				  obj_t aux_4514;
				  {
				     object_t aux_4515;
				     aux_4515 = (object_t) (obj_3345);
				     aux_4514 = OBJECT_WIDENING(aux_4515);
				  }
				  aux_4512 = (((create_vector_app_150_t) CREF(aux_4514))->value_approx_19);
			       }
			    }
			    aux_4511 = union_approx__241_cfa_approx(aux_4512, (approx_t) (val_approx_22_3853));
			 }
			 return (obj_t) (aux_4511);
		      }
		   }
		 else
		   {
		      return BFALSE;
		   }
	      }
	 }
      }
   }
}


obj_t 
cfa__vector_ref_app2554_22_cfa_vector(obj_t env_3855, obj_t node_3856)
{
   {
      vector_ref_app_195_t node_2100;
      {
	 approx_t aux_4522;
	 node_2100 = (vector_ref_app_195_t) (node_3856);
	 {
	    node_t aux_4523;
	    {
	       obj_t aux_4524;
	       {
		  obj_t aux_4525;
		  {
		     obj_t aux_4526;
		     {
			app_t obj_3284;
			obj_3284 = (app_t) (node_2100);
			aux_4526 = (((app_t) CREF(obj_3284))->args);
		     }
		     aux_4525 = CDR(aux_4526);
		  }
		  aux_4524 = CAR(aux_4525);
	       }
	       aux_4523 = (node_t) (aux_4524);
	    }
	    cfa__102_cfa_cfa(aux_4523);
	 }
	 {
	    approx_t vec_approx_215_2106;
	    {
	       node_t aux_4533;
	       {
		  obj_t aux_4534;
		  {
		     obj_t aux_4535;
		     {
			app_t obj_3289;
			obj_3289 = (app_t) (node_2100);
			aux_4535 = (((app_t) CREF(obj_3289))->args);
		     }
		     aux_4534 = CAR(aux_4535);
		  }
		  aux_4533 = (node_t) (aux_4534);
	       }
	       vec_approx_215_2106 = cfa__102_cfa_cfa(aux_4533);
	    }
	    {
	       bool_t test2034_2107;
	       {
		  obj_t aux_4541;
		  aux_4541 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
		  test2034_2107 = CBOOL(aux_4541);
	       }
	       if (test2034_2107)
		 {
		    obj_t arg2036_2109;
		    obj_t arg2039_2111;
		    obj_t arg2041_2113;
		    arg2036_2109 = shape_tools_shape((obj_t) (node_2100));
		    arg2039_2111 = shape_tools_shape((obj_t) (vec_approx_215_2106));
		    {
		       obj_t aux_4551;
		       {
			  approx_t aux_4552;
			  {
			     obj_t aux_4553;
			     {
				object_t aux_4554;
				aux_4554 = (object_t) (node_2100);
				aux_4553 = OBJECT_WIDENING(aux_4554);
			     }
			     aux_4552 = (((vector_ref_app_195_t) CREF(aux_4553))->approx);
			  }
			  aux_4551 = (obj_t) (aux_4552);
		       }
		       arg2041_2113 = shape_tools_shape(aux_4551);
		    }
		    {
		       obj_t list2042_2114;
		       {
			  obj_t arg2043_2115;
			  {
			     obj_t arg2045_2116;
			     {
				obj_t arg2046_2117;
				{
				   obj_t arg2047_2118;
				   {
				      obj_t arg2048_2119;
				      {
					 obj_t arg2050_2120;
					 {
					    obj_t aux_4560;
					    aux_4560 = BCHAR(((unsigned char) '\n'));
					    arg2050_2120 = MAKE_PAIR(aux_4560, BNIL);
					 }
					 arg2048_2119 = MAKE_PAIR(arg2041_2113, arg2050_2120);
				      }
				      arg2047_2118 = MAKE_PAIR(string2600_cfa_vector, arg2048_2119);
				   }
				   arg2046_2117 = MAKE_PAIR(arg2039_2111, arg2047_2118);
				}
				arg2045_2116 = MAKE_PAIR(string2598_cfa_vector, arg2046_2117);
			     }
			     arg2043_2115 = MAKE_PAIR(arg2036_2109, arg2045_2116);
			  }
			  list2042_2114 = MAKE_PAIR(string2601_cfa_vector, arg2043_2115);
		       }
		       print_trace_107_tools_trace(list2042_2114);
		    }
		 }
	       else
		 {
		    BUNSPEC;
		 }
	    }
	    {
	       bool_t test2055_2125;
	       {
		  bool_t test2057_2127;
		  {
		     obj_t obj2_3294;
		     obj2_3294 = __vector__240_type_cache;
		     {
			obj_t aux_4570;
			{
			   type_t aux_4571;
			   aux_4571 = (((approx_t) CREF(vec_approx_215_2106))->type);
			   aux_4570 = (obj_t) (aux_4571);
			}
			test2057_2127 = (aux_4570 == obj2_3294);
		     }
		  }
		  if (test2057_2127)
		    {
		       test2055_2125 = (((approx_t) CREF(vec_approx_215_2106))->top__138);
		    }
		  else
		    {
		       test2055_2125 = ((bool_t) 1);
		    }
	       }
	       if (test2055_2125)
		 {
		    approx_t aux_4578;
		    {
		       obj_t aux_4579;
		       {
			  object_t aux_4580;
			  aux_4580 = (object_t) (node_2100);
			  aux_4579 = OBJECT_WIDENING(aux_4580);
		       }
		       aux_4578 = (((vector_ref_app_195_t) CREF(aux_4579))->approx);
		    }
		    approx_set_type__239_cfa_approx(aux_4578, (type_t) (__obj__252_type_cache));
		 }
	       else
		 {
		    BUNSPEC;
		 }
	    }
	    if ((((approx_t) CREF(vec_approx_215_2106))->top__138))
	      {
		 approx_t aux_4588;
		 {
		    obj_t aux_4589;
		    {
		       object_t aux_4590;
		       aux_4590 = (object_t) (node_2100);
		       aux_4589 = OBJECT_WIDENING(aux_4590);
		    }
		    aux_4588 = (((vector_ref_app_195_t) CREF(aux_4589))->approx);
		 }
		 approx_set_top__187_cfa_approx(aux_4588);
	      }
	    else
	      {
		 BUNSPEC;
	      }
	    {
	       obj_t arg2061_3804;
	       arg2061_3804 = make_fx_procedure(arg20612555_cfa_vector, ((long) 1), ((long) 1));
	       {
		  obj_t aux_4596;
		  aux_4596 = (obj_t) (node_2100);
		  PROCEDURE_SET(arg2061_3804, ((long) 0), aux_4596);
	       }
	       for_each_approx_alloc_83_cfa_approx(arg2061_3804, vec_approx_215_2106);
	    }
	 }
	 {
	    obj_t aux_4600;
	    {
	       object_t aux_4601;
	       aux_4601 = (object_t) (node_2100);
	       aux_4600 = OBJECT_WIDENING(aux_4601);
	    }
	    aux_4522 = (((vector_ref_app_195_t) CREF(aux_4600))->approx);
	 }
	 return (obj_t) (aux_4522);
      }
   }
}


obj_t 
arg20612555_cfa_vector(obj_t env_3857, obj_t app_3859)
{
   {
      obj_t instance1886_3858;
      instance1886_3858 = PROCEDURE_REF(env_3857, ((long) 0));
      {
	 obj_t app_2132;
	 app_2132 = app_3859;
	 {
	    bool_t test2063_2134;
	    test2063_2134 = is_a__118___object(app_2132, make_vector_app_205_cfa_info);
	    if (test2063_2134)
	      {
		 {
		    obj_t res2521_3302;
		    {
		       make_vector_app_205_t obj_3300;
		       obj_3300 = (make_vector_app_205_t) (app_2132);
		       {
			  obj_t x_3898;
			  {
			     obj_t aux_4611;
			     {
				object_t aux_4612;
				aux_4612 = (object_t) (obj_3300);
				aux_4611 = OBJECT_WIDENING(aux_4612);
			     }
			     x_3898 = ((((make_vector_app_205_t) CREF(aux_4611))->seen__39) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			  }
			  res2521_3302 = BUNSPEC;
		       }
		    }
		    res2521_3302;
		 }
		 {
		    approx_t aux_4623;
		    approx_t aux_4616;
		    {
		       make_vector_app_205_t obj_3304;
		       obj_3304 = (make_vector_app_205_t) (app_2132);
		       {
			  obj_t aux_4625;
			  {
			     object_t aux_4626;
			     aux_4626 = (object_t) (obj_3304);
			     aux_4625 = OBJECT_WIDENING(aux_4626);
			  }
			  aux_4623 = (((make_vector_app_205_t) CREF(aux_4625))->value_approx_19);
		       }
		    }
		    {
		       vector_ref_app_195_t obj_3303;
		       obj_3303 = (vector_ref_app_195_t) (instance1886_3858);
		       {
			  obj_t aux_4618;
			  {
			     object_t aux_4619;
			     aux_4619 = (object_t) (obj_3303);
			     aux_4618 = OBJECT_WIDENING(aux_4619);
			  }
			  aux_4616 = (((vector_ref_app_195_t) CREF(aux_4618))->approx);
		       }
		    }
		    union_approx__241_cfa_approx(aux_4616, aux_4623);
		 }
		 {
		    type_t aux_4638;
		    approx_t aux_4631;
		    {
		       approx_t arg2070_2140;
		       {
			  vector_ref_app_195_t obj_3306;
			  obj_3306 = (vector_ref_app_195_t) (instance1886_3858);
			  {
			     obj_t aux_4640;
			     {
				object_t aux_4641;
				aux_4641 = (object_t) (obj_3306);
				aux_4640 = OBJECT_WIDENING(aux_4641);
			     }
			     arg2070_2140 = (((vector_ref_app_195_t) CREF(aux_4640))->approx);
			  }
		       }
		       aux_4638 = (((approx_t) CREF(arg2070_2140))->type);
		    }
		    {
		       make_vector_app_205_t obj_3305;
		       obj_3305 = (make_vector_app_205_t) (app_2132);
		       {
			  obj_t aux_4633;
			  {
			     object_t aux_4634;
			     aux_4634 = (object_t) (obj_3305);
			     aux_4633 = OBJECT_WIDENING(aux_4634);
			  }
			  aux_4631 = (((make_vector_app_205_t) CREF(aux_4633))->value_approx_19);
		       }
		    }
		    return approx_set_type__239_cfa_approx(aux_4631, aux_4638);
		 }
	      }
	    else
	      {
		 bool_t test2071_2141;
		 test2071_2141 = is_a__118___object(app_2132, create_vector_app_150_cfa_info);
		 if (test2071_2141)
		   {
		      {
			 obj_t res2522_3311;
			 {
			    create_vector_app_150_t obj_3309;
			    obj_3309 = (create_vector_app_150_t) (app_2132);
			    {
			       obj_t x_3899;
			       {
				  obj_t aux_4650;
				  {
				     object_t aux_4651;
				     aux_4651 = (object_t) (obj_3309);
				     aux_4650 = OBJECT_WIDENING(aux_4651);
				  }
				  x_3899 = ((((create_vector_app_150_t) CREF(aux_4650))->seen__39) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			       }
			       res2522_3311 = BUNSPEC;
			    }
			 }
			 res2522_3311;
		      }
		      {
			 approx_t aux_4662;
			 approx_t aux_4655;
			 {
			    create_vector_app_150_t obj_3313;
			    obj_3313 = (create_vector_app_150_t) (app_2132);
			    {
			       obj_t aux_4664;
			       {
				  object_t aux_4665;
				  aux_4665 = (object_t) (obj_3313);
				  aux_4664 = OBJECT_WIDENING(aux_4665);
			       }
			       aux_4662 = (((create_vector_app_150_t) CREF(aux_4664))->value_approx_19);
			    }
			 }
			 {
			    vector_ref_app_195_t obj_3312;
			    obj_3312 = (vector_ref_app_195_t) (instance1886_3858);
			    {
			       obj_t aux_4657;
			       {
				  object_t aux_4658;
				  aux_4658 = (object_t) (obj_3312);
				  aux_4657 = OBJECT_WIDENING(aux_4658);
			       }
			       aux_4655 = (((vector_ref_app_195_t) CREF(aux_4657))->approx);
			    }
			 }
			 union_approx__241_cfa_approx(aux_4655, aux_4662);
		      }
		      {
			 type_t aux_4677;
			 approx_t aux_4670;
			 {
			    approx_t arg2077_2147;
			    {
			       vector_ref_app_195_t obj_3315;
			       obj_3315 = (vector_ref_app_195_t) (instance1886_3858);
			       {
				  obj_t aux_4679;
				  {
				     object_t aux_4680;
				     aux_4680 = (object_t) (obj_3315);
				     aux_4679 = OBJECT_WIDENING(aux_4680);
				  }
				  arg2077_2147 = (((vector_ref_app_195_t) CREF(aux_4679))->approx);
			       }
			    }
			    aux_4677 = (((approx_t) CREF(arg2077_2147))->type);
			 }
			 {
			    create_vector_app_150_t obj_3314;
			    obj_3314 = (create_vector_app_150_t) (app_2132);
			    {
			       obj_t aux_4672;
			       {
				  object_t aux_4673;
				  aux_4673 = (object_t) (obj_3314);
				  aux_4672 = OBJECT_WIDENING(aux_4673);
			       }
			       aux_4670 = (((create_vector_app_150_t) CREF(aux_4672))->value_approx_19);
			    }
			 }
			 return approx_set_type__239_cfa_approx(aux_4670, aux_4677);
		      }
		   }
		 else
		   {
		      return BFALSE;
		   }
	      }
	 }
      }
   }
}


obj_t 
cfa__create_vector_app2556_191_cfa_vector(obj_t env_3860, obj_t node_3861)
{
   {
      create_vector_app_150_t node_2079;
      {
	 approx_t aux_4686;
	 node_2079 = (create_vector_app_150_t) (node_3861);
	 {
	    bool_t test2016_2083;
	    {
	       obj_t aux_4687;
	       aux_4687 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
	       test2016_2083 = CBOOL(aux_4687);
	    }
	    if (test2016_2083)
	      {
		 obj_t arg2018_2085;
		 arg2018_2085 = shape_tools_shape((obj_t) (node_2079));
		 {
		    obj_t list2019_2086;
		    {
		       obj_t arg2020_2087;
		       {
			  obj_t arg2021_2088;
			  {
			     obj_t aux_4695;
			     aux_4695 = BCHAR(((unsigned char) '\n'));
			     arg2021_2088 = MAKE_PAIR(aux_4695, BNIL);
			  }
			  arg2020_2087 = MAKE_PAIR(arg2018_2085, arg2021_2088);
		       }
		       list2019_2086 = MAKE_PAIR(string2602_cfa_vector, arg2020_2087);
		    }
		    print_trace_107_tools_trace(list2019_2086);
		 }
	      }
	    else
	      {
		 BUNSPEC;
	      }
	 }
	 {
	    obj_t l1884_2092;
	    {
	       app_t obj_3279;
	       obj_3279 = (app_t) (node_2079);
	       l1884_2092 = (((app_t) CREF(obj_3279))->args);
	    }
	  lname1885_2093:
	    if (PAIRP(l1884_2092))
	      {
		 {
		    node_t aux_4703;
		    {
		       obj_t aux_4704;
		       aux_4704 = CAR(l1884_2092);
		       aux_4703 = (node_t) (aux_4704);
		    }
		    cfa__102_cfa_cfa(aux_4703);
		 }
		 {
		    obj_t l1884_4708;
		    l1884_4708 = CDR(l1884_2092);
		    l1884_2092 = l1884_4708;
		    goto lname1885_2093;
		 }
	      }
	    else
	      {
		 ((bool_t) 1);
	      }
	 }
	 {
	    obj_t aux_4712;
	    {
	       object_t aux_4713;
	       aux_4713 = (object_t) (node_2079);
	       aux_4712 = OBJECT_WIDENING(aux_4713);
	    }
	    aux_4686 = (((create_vector_app_150_t) CREF(aux_4712))->approx);
	 }
	 return (obj_t) (aux_4686);
      }
   }
}


obj_t 
cfa__make_vector_app2557_60_cfa_vector(obj_t env_3862, obj_t node_3863)
{
   {
      make_vector_app_205_t node_2058;
      {
	 approx_t aux_4719;
	 node_2058 = (make_vector_app_205_t) (node_3863);
	 {
	    bool_t test1999_2062;
	    {
	       obj_t aux_4720;
	       aux_4720 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
	       test1999_2062 = CBOOL(aux_4720);
	    }
	    if (test1999_2062)
	      {
		 obj_t arg2001_2064;
		 arg2001_2064 = shape_tools_shape((obj_t) (node_2058));
		 {
		    obj_t list2002_2065;
		    {
		       obj_t arg2003_2066;
		       {
			  obj_t arg2004_2067;
			  {
			     obj_t aux_4728;
			     aux_4728 = BCHAR(((unsigned char) '\n'));
			     arg2004_2067 = MAKE_PAIR(aux_4728, BNIL);
			  }
			  arg2003_2066 = MAKE_PAIR(arg2001_2064, arg2004_2067);
		       }
		       list2002_2065 = MAKE_PAIR(string2603_cfa_vector, arg2003_2066);
		    }
		    print_trace_107_tools_trace(list2002_2065);
		 }
	      }
	    else
	      {
		 BUNSPEC;
	      }
	 }
	 {
	    node_t aux_4734;
	    {
	       obj_t aux_4735;
	       {
		  obj_t aux_4736;
		  {
		     app_t obj_3270;
		     obj_3270 = (app_t) (node_2058);
		     aux_4736 = (((app_t) CREF(obj_3270))->args);
		  }
		  aux_4735 = CAR(aux_4736);
	       }
	       aux_4734 = (node_t) (aux_4735);
	    }
	    cfa__102_cfa_cfa(aux_4734);
	 }
	 {
	    approx_t init_value_approx_9_2073;
	    {
	       node_t aux_4742;
	       {
		  obj_t aux_4743;
		  {
		     obj_t aux_4744;
		     {
			obj_t aux_4745;
			{
			   app_t obj_3272;
			   obj_3272 = (app_t) (node_2058);
			   aux_4745 = (((app_t) CREF(obj_3272))->args);
			}
			aux_4744 = CDR(aux_4745);
		     }
		     aux_4743 = CAR(aux_4744);
		  }
		  aux_4742 = (node_t) (aux_4743);
	       }
	       init_value_approx_9_2073 = cfa__102_cfa_cfa(aux_4742);
	    }
	    {
	       approx_t aux_4752;
	       {
		  obj_t aux_4753;
		  {
		     object_t aux_4754;
		     aux_4754 = (object_t) (node_2058);
		     aux_4753 = OBJECT_WIDENING(aux_4754);
		  }
		  aux_4752 = (((make_vector_app_205_t) CREF(aux_4753))->value_approx_19);
	       }
	       union_approx__241_cfa_approx(aux_4752, init_value_approx_9_2073);
	    }
	    {
	       obj_t aux_4759;
	       {
		  object_t aux_4760;
		  aux_4760 = (object_t) (node_2058);
		  aux_4759 = OBJECT_WIDENING(aux_4760);
	       }
	       aux_4719 = (((make_vector_app_205_t) CREF(aux_4759))->approx);
	    }
	 }
	 return (obj_t) (aux_4719);
      }
   }
}


obj_t 
node_setup__pre_vector_set__app2558_128_cfa_vector(obj_t env_3864, obj_t node_3865)
{
   {
      pre_vector_set__app_211_t node_2042;
      {
	 vector_set__app_21_t aux_4766;
	 node_2042 = (pre_vector_set__app_211_t) (node_3865);
	 {
	    obj_t aux_4767;
	    {
	       app_t obj_3252;
	       obj_3252 = (app_t) (node_2042);
	       aux_4767 = (((app_t) CREF(obj_3252))->args);
	    }
	    node_setup___185_cfa_setup(aux_4767);
	 }
	 {
	    pre_vector_set__app_211_t node_2047;
	    {
	       long arg1995_2053;
	       {
		  obj_t arg1996_2054;
		  {
		     obj_t arg1997_2055;
		     {
			object_t object_3253;
			object_3253 = (object_t) (node_2042);
			{
			   long arg1187_3254;
			   {
			      long arg1188_3255;
			      long arg1189_3256;
			      arg1188_3255 = TYPE(object_3253);
			      arg1189_3256 = OBJECT_TYPE;
			      arg1187_3254 = (arg1188_3255 - arg1189_3256);
			   }
			   {
			      obj_t vector_3260;
			      vector_3260 = __classes__134___object;
			      arg1997_2055 = VECTOR_REF(vector_3260, arg1187_3254);
			   }
			}
		     }
		     arg1996_2054 = class_super_145___object(arg1997_2055);
		  }
		  arg1995_2053 = class_num_218___object(arg1996_2054);
	       }
	       {
		  obj_t obj_3262;
		  obj_3262 = (obj_t) (node_2042);
		  (((obj_t) CREF(obj_3262))->header = MAKE_HEADER(arg1995_2053, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_4780;
	       aux_4780 = (object_t) (node_2042);
	       OBJECT_WIDENING_SET(aux_4780, BFALSE);
	    }
	    node_2047 = node_2042;
	    {
	       vector_set__app_21_t obj1881_2048;
	       obj1881_2048 = ((vector_set__app_21_t) (node_2047));
	       {
		  vector_set__app_21_t arg1990_2049;
		  {
		     approx_t arg1992_2050;
		     arg1992_2050 = make_type_approx_184_cfa_approx((type_t) (__unspec__87_type_cache));
		     {
			vector_set__app_21_t res2520_3267;
			{
			   vector_set__app_21_t new1789_3265;
			   new1789_3265 = ((vector_set__app_21_t) BREF(GC_MALLOC(sizeof(struct vector_set__app_21))));
			   ((((vector_set__app_21_t) CREF(new1789_3265))->approx) = ((approx_t) arg1992_2050), BUNSPEC);
			   res2520_3267 = new1789_3265;
			}
			arg1990_2049 = res2520_3267;
		     }
		  }
		  {
		     obj_t aux_4790;
		     object_t aux_4788;
		     aux_4790 = (obj_t) (arg1990_2049);
		     aux_4788 = (object_t) (obj1881_2048);
		     OBJECT_WIDENING_SET(aux_4788, aux_4790);
		  }
	       }
	       {
		  long arg1993_2051;
		  arg1993_2051 = class_num_218___object(vector_set__app_21_cfa_info);
		  {
		     obj_t obj_3268;
		     obj_3268 = (obj_t) (obj1881_2048);
		     (((obj_t) CREF(obj_3268))->header = MAKE_HEADER(arg1993_2051, 0), BUNSPEC);
		  }
	       }
	       aux_4766 = obj1881_2048;
	    }
	 }
	 return (obj_t) (aux_4766);
      }
   }
}


obj_t 
node_setup__pre_vector_ref_app2559_248_cfa_vector(obj_t env_3866, obj_t node_3867)
{
   {
      pre_vector_ref_app_208_t node_2026;
      {
	 vector_ref_app_195_t aux_4798;
	 node_2026 = (pre_vector_ref_app_208_t) (node_3867);
	 {
	    obj_t aux_4799;
	    {
	       app_t obj_3234;
	       obj_3234 = (app_t) (node_2026);
	       aux_4799 = (((app_t) CREF(obj_3234))->args);
	    }
	    node_setup___185_cfa_setup(aux_4799);
	 }
	 {
	    pre_vector_ref_app_208_t node_2031;
	    {
	       long arg1985_2037;
	       {
		  obj_t arg1986_2038;
		  {
		     obj_t arg1987_2039;
		     {
			object_t object_3235;
			object_3235 = (object_t) (node_2026);
			{
			   long arg1187_3236;
			   {
			      long arg1188_3237;
			      long arg1189_3238;
			      arg1188_3237 = TYPE(object_3235);
			      arg1189_3238 = OBJECT_TYPE;
			      arg1187_3236 = (arg1188_3237 - arg1189_3238);
			   }
			   {
			      obj_t vector_3242;
			      vector_3242 = __classes__134___object;
			      arg1987_2039 = VECTOR_REF(vector_3242, arg1187_3236);
			   }
			}
		     }
		     arg1986_2038 = class_super_145___object(arg1987_2039);
		  }
		  arg1985_2037 = class_num_218___object(arg1986_2038);
	       }
	       {
		  obj_t obj_3244;
		  obj_3244 = (obj_t) (node_2026);
		  (((obj_t) CREF(obj_3244))->header = MAKE_HEADER(arg1985_2037, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_4812;
	       aux_4812 = (object_t) (node_2026);
	       OBJECT_WIDENING_SET(aux_4812, BFALSE);
	    }
	    node_2031 = node_2026;
	    {
	       vector_ref_app_195_t obj1878_2032;
	       obj1878_2032 = ((vector_ref_app_195_t) (node_2031));
	       {
		  vector_ref_app_195_t arg1982_2033;
		  {
		     approx_t arg1983_2034;
		     arg1983_2034 = make_empty_approx_131_cfa_approx();
		     {
			vector_ref_app_195_t res2519_3249;
			{
			   vector_ref_app_195_t new1777_3247;
			   new1777_3247 = ((vector_ref_app_195_t) BREF(GC_MALLOC(sizeof(struct vector_ref_app_195))));
			   ((((vector_ref_app_195_t) CREF(new1777_3247))->approx) = ((approx_t) arg1983_2034), BUNSPEC);
			   res2519_3249 = new1777_3247;
			}
			arg1982_2033 = res2519_3249;
		     }
		  }
		  {
		     obj_t aux_4821;
		     object_t aux_4819;
		     aux_4821 = (obj_t) (arg1982_2033);
		     aux_4819 = (object_t) (obj1878_2032);
		     OBJECT_WIDENING_SET(aux_4819, aux_4821);
		  }
	       }
	       {
		  long arg1984_2035;
		  arg1984_2035 = class_num_218___object(vector_ref_app_195_cfa_info);
		  {
		     obj_t obj_3250;
		     obj_3250 = (obj_t) (obj1878_2032);
		     (((obj_t) CREF(obj_3250))->header = MAKE_HEADER(arg1984_2035, 0), BUNSPEC);
		  }
	       }
	       aux_4798 = obj1878_2032;
	    }
	 }
	 return (obj_t) (aux_4798);
      }
   }
}


obj_t 
node_setup__pre_create_vector_app2560_253_cfa_vector(obj_t env_3868, obj_t node_3869)
{
   {
      pre_create_vector_app_162_t node_1990;
      node_1990 = (pre_create_vector_app_162_t) (node_3869);
      add_make_vector__104_cfa_tvector((node_t) (node_1990));
      {
	 obj_t aux_4831;
	 {
	    app_t obj_3197;
	    obj_3197 = (app_t) (node_1990);
	    aux_4831 = (((app_t) CREF(obj_3197))->args);
	 }
	 node_setup___185_cfa_setup(aux_4831);
      }
      {
	 obj_t key_1995;
	 {
	    obj_t aux_4835;
	    {
	       object_t aux_4836;
	       aux_4836 = (object_t) (node_1990);
	       aux_4835 = OBJECT_WIDENING(aux_4836);
	    }
	    key_1995 = (((pre_create_vector_app_162_t) CREF(aux_4835))->key);
	 }
	 {
	    variable_t owner_1996;
	    {
	       obj_t aux_4840;
	       {
		  object_t aux_4841;
		  aux_4841 = (object_t) (node_1990);
		  aux_4840 = OBJECT_WIDENING(aux_4841);
	       }
	       owner_1996 = (((pre_create_vector_app_162_t) CREF(aux_4840))->owner);
	    }
	    {
	       pre_create_vector_app_162_t node_1997;
	       {
		  long arg1977_2021;
		  {
		     obj_t arg1978_2022;
		     {
			obj_t arg1979_2023;
			{
			   object_t object_3200;
			   object_3200 = (object_t) (node_1990);
			   {
			      long arg1187_3201;
			      {
				 long arg1188_3202;
				 long arg1189_3203;
				 arg1188_3202 = TYPE(object_3200);
				 arg1189_3203 = OBJECT_TYPE;
				 arg1187_3201 = (arg1188_3202 - arg1189_3203);
			      }
			      {
				 obj_t vector_3207;
				 vector_3207 = __classes__134___object;
				 arg1979_2023 = VECTOR_REF(vector_3207, arg1187_3201);
			      }
			   }
			}
			arg1978_2022 = class_super_145___object(arg1979_2023);
		     }
		     arg1977_2021 = class_num_218___object(arg1978_2022);
		  }
		  {
		     obj_t obj_3209;
		     obj_3209 = (obj_t) (node_1990);
		     (((obj_t) CREF(obj_3209))->header = MAKE_HEADER(arg1977_2021, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_4854;
		  aux_4854 = (object_t) (node_1990);
		  OBJECT_WIDENING_SET(aux_4854, BFALSE);
	       }
	       node_1997 = node_1990;
	       {
		  {
		     create_vector_app_150_t wnode_1998;
		     {
			create_vector_app_150_t obj1875_2013;
			obj1875_2013 = ((create_vector_app_150_t) (node_1997));
			{
			   create_vector_app_150_t arg1971_2014;
			   {
			      approx_t arg1972_2015;
			      approx_t arg1973_2016;
			      arg1972_2015 = make_empty_approx_131_cfa_approx();
			      arg1973_2016 = make_empty_approx_131_cfa_approx();
			      {
				 create_vector_app_150_t res2517_3228;
				 {
				    create_vector_app_150_t new1761_3219;
				    new1761_3219 = ((create_vector_app_150_t) BREF(GC_MALLOC(sizeof(struct create_vector_app_150))));
				    ((((create_vector_app_150_t) CREF(new1761_3219))->key) = ((obj_t) key_1995), BUNSPEC);
				    ((((create_vector_app_150_t) CREF(new1761_3219))->approx) = ((approx_t) arg1972_2015), BUNSPEC);
				    ((((create_vector_app_150_t) CREF(new1761_3219))->value_approx_19) = ((approx_t) arg1973_2016), BUNSPEC);
				    ((((create_vector_app_150_t) CREF(new1761_3219))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
				    ((((create_vector_app_150_t) CREF(new1761_3219))->owner) = ((variable_t) owner_1996), BUNSPEC);
				    ((((create_vector_app_150_t) CREF(new1761_3219))->stackable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				    ((((create_vector_app_150_t) CREF(new1761_3219))->stack_stamp_31) = ((obj_t) BNIL), BUNSPEC);
				    ((((create_vector_app_150_t) CREF(new1761_3219))->seen__39) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				    res2517_3228 = new1761_3219;
				 }
				 arg1971_2014 = res2517_3228;
			      }
			   }
			   {
			      obj_t aux_4871;
			      object_t aux_4869;
			      aux_4871 = (obj_t) (arg1971_2014);
			      aux_4869 = (object_t) (obj1875_2013);
			      OBJECT_WIDENING_SET(aux_4869, aux_4871);
			   }
			}
			{
			   long arg1976_2019;
			   arg1976_2019 = class_num_218___object(create_vector_app_150_cfa_info);
			   {
			      obj_t obj_3229;
			      obj_3229 = (obj_t) (obj1875_2013);
			      (((obj_t) CREF(obj_3229))->header = MAKE_HEADER(arg1976_2019, 0), BUNSPEC);
			   }
			}
			wnode_1998 = obj1875_2013;
		     }
		     {
			bool_t test1955_1999;
			{
			   obj_t aux_4877;
			   aux_4877 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
			   test1955_1999 = CBOOL(aux_4877);
			}
			if (test1955_1999)
			  {
			     obj_t arg1957_2001;
			     arg1957_2001 = shape_tools_shape((obj_t) (node_1997));
			     {
				obj_t list1959_2003;
				{
				   obj_t arg1960_2004;
				   {
				      obj_t arg1963_2005;
				      {
					 obj_t arg1964_2006;
					 {
					    obj_t arg1965_2007;
					    {
					       obj_t arg1966_2008;
					       {
						  obj_t aux_4885;
						  aux_4885 = BCHAR(((unsigned char) '\n'));
						  arg1966_2008 = MAKE_PAIR(aux_4885, BNIL);
					       }
					       arg1965_2007 = MAKE_PAIR(key_1995, arg1966_2008);
					    }
					    arg1964_2006 = MAKE_PAIR(string2604_cfa_vector, arg1965_2007);
					 }
					 {
					    obj_t aux_4890;
					    aux_4890 = BCHAR(((unsigned char) '\n'));
					    arg1963_2005 = MAKE_PAIR(aux_4890, arg1964_2006);
					 }
				      }
				      arg1960_2004 = MAKE_PAIR(arg1957_2001, arg1963_2005);
				   }
				   list1959_2003 = MAKE_PAIR(string2605_cfa_vector, arg1960_2004);
				}
				print_trace_107_tools_trace(list1959_2003);
			     }
			  }
			else
			  {
			     BUNSPEC;
			  }
		     }
		     {
			approx_t arg1970_2012;
			arg1970_2012 = make_type_alloc_approx_134_cfa_approx((type_t) (__vector__240_type_cache), (node_t) (node_1997));
			{
			   obj_t res2518_3233;
			   {
			      obj_t x_3900;
			      {
				 obj_t aux_4899;
				 {
				    object_t aux_4900;
				    aux_4900 = (object_t) (wnode_1998);
				    aux_4899 = OBJECT_WIDENING(aux_4900);
				 }
				 x_3900 = ((((create_vector_app_150_t) CREF(aux_4899))->approx) = ((approx_t) arg1970_2012), BUNSPEC);
			      }
			      res2518_3233 = BUNSPEC;
			   }
			   return res2518_3233;
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
node_setup__pre_make_vector_app2561_141_cfa_vector(obj_t env_3870, obj_t node_3871)
{
   {
      pre_make_vector_app_251_t node_1954;
      node_1954 = (pre_make_vector_app_251_t) (node_3871);
      add_make_vector__104_cfa_tvector((node_t) (node_1954));
      {
	 obj_t aux_4907;
	 {
	    app_t obj_3160;
	    obj_3160 = (app_t) (node_1954);
	    aux_4907 = (((app_t) CREF(obj_3160))->args);
	 }
	 node_setup___185_cfa_setup(aux_4907);
      }
      {
	 obj_t key_1959;
	 {
	    obj_t aux_4911;
	    {
	       object_t aux_4912;
	       aux_4912 = (object_t) (node_1954);
	       aux_4911 = OBJECT_WIDENING(aux_4912);
	    }
	    key_1959 = (((pre_make_vector_app_251_t) CREF(aux_4911))->key);
	 }
	 {
	    variable_t owner_1960;
	    {
	       obj_t aux_4916;
	       {
		  object_t aux_4917;
		  aux_4917 = (object_t) (node_1954);
		  aux_4916 = OBJECT_WIDENING(aux_4917);
	       }
	       owner_1960 = (((pre_make_vector_app_251_t) CREF(aux_4916))->owner);
	    }
	    {
	       pre_make_vector_app_251_t node_1961;
	       {
		  long arg1950_1985;
		  {
		     obj_t arg1951_1986;
		     {
			obj_t arg1952_1987;
			{
			   object_t object_3163;
			   object_3163 = (object_t) (node_1954);
			   {
			      long arg1187_3164;
			      {
				 long arg1188_3165;
				 long arg1189_3166;
				 arg1188_3165 = TYPE(object_3163);
				 arg1189_3166 = OBJECT_TYPE;
				 arg1187_3164 = (arg1188_3165 - arg1189_3166);
			      }
			      {
				 obj_t vector_3170;
				 vector_3170 = __classes__134___object;
				 arg1952_1987 = VECTOR_REF(vector_3170, arg1187_3164);
			      }
			   }
			}
			arg1951_1986 = class_super_145___object(arg1952_1987);
		     }
		     arg1950_1985 = class_num_218___object(arg1951_1986);
		  }
		  {
		     obj_t obj_3172;
		     obj_3172 = (obj_t) (node_1954);
		     (((obj_t) CREF(obj_3172))->header = MAKE_HEADER(arg1950_1985, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_4930;
		  aux_4930 = (object_t) (node_1954);
		  OBJECT_WIDENING_SET(aux_4930, BFALSE);
	       }
	       node_1961 = node_1954;
	       {
		  {
		     make_vector_app_205_t wnode_1962;
		     {
			make_vector_app_205_t obj1872_1977;
			obj1872_1977 = ((make_vector_app_205_t) (node_1961));
			{
			   make_vector_app_205_t arg1943_1978;
			   {
			      approx_t arg1944_1979;
			      approx_t arg1945_1980;
			      arg1944_1979 = make_empty_approx_131_cfa_approx();
			      arg1945_1980 = make_empty_approx_131_cfa_approx();
			      {
				 make_vector_app_205_t res2515_3191;
				 {
				    make_vector_app_205_t new1745_3182;
				    new1745_3182 = ((make_vector_app_205_t) BREF(GC_MALLOC(sizeof(struct make_vector_app_205))));
				    ((((make_vector_app_205_t) CREF(new1745_3182))->key) = ((obj_t) key_1959), BUNSPEC);
				    ((((make_vector_app_205_t) CREF(new1745_3182))->approx) = ((approx_t) arg1944_1979), BUNSPEC);
				    ((((make_vector_app_205_t) CREF(new1745_3182))->value_approx_19) = ((approx_t) arg1945_1980), BUNSPEC);
				    ((((make_vector_app_205_t) CREF(new1745_3182))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
				    ((((make_vector_app_205_t) CREF(new1745_3182))->owner) = ((variable_t) owner_1960), BUNSPEC);
				    ((((make_vector_app_205_t) CREF(new1745_3182))->stackable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				    ((((make_vector_app_205_t) CREF(new1745_3182))->stack_stamp_31) = ((obj_t) BNIL), BUNSPEC);
				    ((((make_vector_app_205_t) CREF(new1745_3182))->seen__39) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				    res2515_3191 = new1745_3182;
				 }
				 arg1943_1978 = res2515_3191;
			      }
			   }
			   {
			      obj_t aux_4947;
			      object_t aux_4945;
			      aux_4947 = (obj_t) (arg1943_1978);
			      aux_4945 = (object_t) (obj1872_1977);
			      OBJECT_WIDENING_SET(aux_4945, aux_4947);
			   }
			}
			{
			   long arg1949_1983;
			   arg1949_1983 = class_num_218___object(make_vector_app_205_cfa_info);
			   {
			      obj_t obj_3192;
			      obj_3192 = (obj_t) (obj1872_1977);
			      (((obj_t) CREF(obj_3192))->header = MAKE_HEADER(arg1949_1983, 0), BUNSPEC);
			   }
			}
			wnode_1962 = obj1872_1977;
		     }
		     {
			bool_t test1927_1963;
			{
			   obj_t aux_4953;
			   aux_4953 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
			   test1927_1963 = CBOOL(aux_4953);
			}
			if (test1927_1963)
			  {
			     obj_t arg1929_1965;
			     arg1929_1965 = shape_tools_shape((obj_t) (node_1961));
			     {
				obj_t list1932_1967;
				{
				   obj_t arg1934_1968;
				   {
				      obj_t arg1935_1969;
				      {
					 obj_t arg1936_1970;
					 {
					    obj_t arg1937_1971;
					    {
					       obj_t arg1938_1972;
					       {
						  obj_t aux_4961;
						  aux_4961 = BCHAR(((unsigned char) '\n'));
						  arg1938_1972 = MAKE_PAIR(aux_4961, BNIL);
					       }
					       arg1937_1971 = MAKE_PAIR(key_1959, arg1938_1972);
					    }
					    arg1936_1970 = MAKE_PAIR(string2604_cfa_vector, arg1937_1971);
					 }
					 {
					    obj_t aux_4966;
					    aux_4966 = BCHAR(((unsigned char) '\n'));
					    arg1935_1969 = MAKE_PAIR(aux_4966, arg1936_1970);
					 }
				      }
				      arg1934_1968 = MAKE_PAIR(arg1929_1965, arg1935_1969);
				   }
				   list1932_1967 = MAKE_PAIR(string2606_cfa_vector, arg1934_1968);
				}
				print_trace_107_tools_trace(list1932_1967);
			     }
			  }
			else
			  {
			     BUNSPEC;
			  }
		     }
		     {
			approx_t arg1942_1976;
			arg1942_1976 = make_type_alloc_approx_134_cfa_approx((type_t) (__vector__240_type_cache), (node_t) (node_1961));
			{
			   obj_t res2516_3196;
			   {
			      obj_t x_3901;
			      {
				 obj_t aux_4975;
				 {
				    object_t aux_4976;
				    aux_4976 = (object_t) (wnode_1962);
				    aux_4975 = OBJECT_WIDENING(aux_4976);
				 }
				 x_3901 = ((((make_vector_app_205_t) CREF(aux_4975))->approx) = ((approx_t) arg1942_1976), BUNSPEC);
			      }
			      res2516_3196 = BUNSPEC;
			   }
			   return res2516_3196;
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
imported_modules_init_94_cfa_vector()
{
   module_initialization_70_tools_trace(((long) 0), "CFA_VECTOR");
   module_initialization_70_tools_error(((long) 0), "CFA_VECTOR");
   module_initialization_70_tools_shape(((long) 0), "CFA_VECTOR");
   module_initialization_70_type_type(((long) 0), "CFA_VECTOR");
   module_initialization_70_type_cache(((long) 0), "CFA_VECTOR");
   module_initialization_70_ast_var(((long) 0), "CFA_VECTOR");
   module_initialization_70_ast_node(((long) 0), "CFA_VECTOR");
   module_initialization_70_cfa_info(((long) 0), "CFA_VECTOR");
   module_initialization_70_cfa_loose(((long) 0), "CFA_VECTOR");
   module_initialization_70_cfa_iterate(((long) 0), "CFA_VECTOR");
   module_initialization_70_cfa_cfa(((long) 0), "CFA_VECTOR");
   module_initialization_70_cfa_setup(((long) 0), "CFA_VECTOR");
   module_initialization_70_cfa_approx(((long) 0), "CFA_VECTOR");
   module_initialization_70_cfa_tvector(((long) 0), "CFA_VECTOR");
   return module_initialization_70_cfa_stack(((long) 0), "CFA_VECTOR");
}
