/*===========================================================================*/
/*   (Cgen/capp.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct cop
  {
     header_t header;
     obj_t widening;
  }
   *cop_t;

typedef struct clabel
  {
     header_t header;
     obj_t widening;
     obj_t name;
     bool_t used__226;
     obj_t body;
  }
      *clabel_t;

typedef struct cgoto
  {
     header_t header;
     obj_t widening;
     struct clabel *label;
  }
     *cgoto_t;

typedef struct block
  {
     header_t header;
     obj_t widening;
     struct cop *body;
  }
     *block_t;

typedef struct creturn
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
       *creturn_t;

typedef struct cvoid
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
     *cvoid_t;

typedef struct catom
  {
     header_t header;
     obj_t widening;
     obj_t value;
  }
     *catom_t;

typedef struct varc
  {
     header_t header;
     obj_t widening;
     struct variable *variable;
  }
    *varc_t;

typedef struct cpragma
  {
     header_t header;
     obj_t widening;
     obj_t format;
     obj_t args;
  }
       *cpragma_t;

typedef struct ccast
  {
     header_t header;
     obj_t widening;
     struct type *type;
     struct cop *arg;
  }
     *ccast_t;

typedef struct csequence
  {
     header_t header;
     obj_t widening;
     bool_t c_exp__163;
     obj_t cops;
  }
         *csequence_t;

typedef struct nop
  {
     header_t header;
     obj_t widening;
  }
   *nop_t;

typedef struct stop
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
    *stop_t;

typedef struct csetq
  {
     header_t header;
     obj_t widening;
     struct varc *var;
     struct cop *value;
  }
     *csetq_t;

typedef struct cif
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     struct cop *true;
     struct cop *false;
  }
   *cif_t;

typedef struct branch
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     struct cop *true;
     struct cop *false;
     struct cop *end;
  }
      *branch_t;

typedef struct local_var_164
  {
     header_t header;
     obj_t widening;
     obj_t vars;
  }
             *local_var_164_t;

typedef struct cfuncall
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     obj_t args;
     obj_t strength;
  }
        *cfuncall_t;

typedef struct capply
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     struct cop *arg;
  }
      *capply_t;

typedef struct capp
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     obj_t args;
  }
    *capp_t;

typedef struct cfail
  {
     header_t header;
     obj_t widening;
     struct cop *proc;
     struct cop *msg;
     struct cop *obj;
  }
     *cfail_t;

typedef struct cswitch
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     obj_t clauses;
  }
       *cswitch_t;

typedef struct cmake_box_177
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
             *cmake_box_177_t;

typedef struct cbox_ref_44
  {
     header_t header;
     obj_t widening;
     struct cop *var;
  }
           *cbox_ref_44_t;

typedef struct cbox_set__132
  {
     header_t header;
     obj_t widening;
     struct cop *var;
     struct cop *value;
  }
             *cbox_set__132_t;

typedef struct cset_ex_it_123
  {
     header_t header;
     obj_t widening;
     struct cop *exit;
     struct cop *jump_value_221;
     struct cop *body;
  }
              *cset_ex_it_123_t;

typedef struct cjump_ex_it_131
  {
     header_t header;
     obj_t widening;
     struct cop *exit;
     struct cop *value;
  }
               *cjump_ex_it_131_t;

typedef struct sfun_c_188
  {
     struct clabel *label;
     bool_t integrated;
  }
          *sfun_c_188_t;


extern setq_t node_setq_243_cgen_cgen(variable_t, node_t);
static obj_t useless_2042_202_cgen_capp(obj_t, obj_t, obj_t);
extern obj_t __procedure__226_type_cache;
extern obj_t __block_kont__38_cgen_cgen;
extern obj_t __return_kont__110_cgen_cgen;
extern obj_t stop_cgen_cop;
extern obj_t global_ast_var;
static obj_t node_sfun_cfun_non_tail_app__cop_160_cgen_capp(variable_t, app_t, obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t last_pair_93___r4_pairs_and_lists_6_3(obj_t);
static obj_t imported_modules_init_94_cgen_capp();
extern obj_t catom_cgen_cop;
extern obj_t module_initialization_70_cgen_capp(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_cgen_emit(long, char *);
extern obj_t module_initialization_70_cgen_cop(long, char *);
extern obj_t module_initialization_70_cgen_cgen(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_cgen_capp();
static obj_t cnst_init_137_cgen_capp();
extern obj_t __stop_kont__121_cgen_cgen;
static obj_t node_tail_app__cop_48_cgen_capp(variable_t, app_t, obj_t);
extern obj_t cgoto_cgen_cop;
extern local_t make_local_svar_name_219_cgen_cgen(obj_t, type_t);
extern obj_t capply_cgen_cop;
extern obj_t __id_kont__126_cgen_cgen;
static obj_t require_initialization_114_cgen_capp = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
extern obj_t __the_global__73_cgen_cgen;
static obj_t library_modules_init_112_cgen_capp();
extern obj_t sfun_ast_var;
extern obj_t capp_cgen_cop;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
static obj_t useless_2043_217_cgen_capp(obj_t, obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t csetq_cgen_cop;
static obj_t node_non_tail_app__cop_76_cgen_capp(variable_t, app_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t shape_tools_shape(obj_t);
static obj_t node__cop_app_ly2039_130_cgen_capp(obj_t, obj_t, obj_t);
static obj_t node__cop_funcall2038_241_cgen_capp(obj_t, obj_t, obj_t);
extern cop_t node__cop_142_cgen_cgen(node_t, obj_t);
extern obj_t local_var_164_cgen_cop;
extern obj_t varc_cgen_cop;
extern obj_t _node__cop_12_cgen_cgen(obj_t, obj_t, obj_t);
static obj_t node_sfun_non_tail_app__cop_176_cgen_capp(variable_t, app_t, obj_t);
extern obj_t local_ast_var;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t block_cgen_cop;
static obj_t node__cop_app2037_248_cgen_capp(obj_t, obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t __obj__252_type_cache;
extern obj_t cfuncall_cgen_cop;
static obj_t node_cfun_non_tail_app__cop_38_cgen_capp(variable_t, app_t, obj_t);
extern obj_t csequence_cgen_cop;
extern obj_t app_ast_node;
static obj_t __cnst[3];

DEFINE_STATIC_PROCEDURE(proc2054_cgen_capp, useless_2042_202_cgen_capp2062, useless_2042_202_cgen_capp, 0L, 2);
extern obj_t node__cop_env_160_cgen_cgen;
DEFINE_STRING(string2047_cgen_capp, string2047_cgen_capp2063, "  kont: ", 8);
DEFINE_STRING(string2048_cgen_capp, string2048_cgen_capp2064, "(node->cop node::app kont): ", 28);
DEFINE_STATIC_PROCEDURE(proc2055_cgen_capp, useless_2043_217_cgen_capp2065, useless_2043_217_cgen_capp, 0L, 2);
DEFINE_STRING(string2053_cgen_capp, string2053_cgen_capp2066, "node-non-tail-app->cop: ", 24);
DEFINE_STATIC_PROCEDURE(proc2046_cgen_capp, node__cop_app2037_248_cgen_capp2067, node__cop_app2037_248_cgen_capp, 0L, 2);
DEFINE_STRING(string2052_cgen_capp, string2052_cgen_capp2068, " ", 1);
DEFINE_STATIC_PROCEDURE(proc2045_cgen_capp, node__cop_funcall2038_241_cgen_capp2069, node__cop_funcall2038_241_cgen_capp, 0L, 2);
DEFINE_STRING(string2050_cgen_capp, string2050_cgen_capp2070, "(node->cop node::app-ly kont): ", 31);
DEFINE_STRING(string2051_cgen_capp, string2051_cgen_capp2071, "kont: ", 6);
DEFINE_STATIC_PROCEDURE(proc2044_cgen_capp, node__cop_app_ly2039_130_cgen_capp2072, node__cop_app_ly2039_130_cgen_capp, 0L, 2);
DEFINE_STRING(string2049_cgen_capp, string2049_cgen_capp2073, "(node->cop node::funcall kont): ", 32);
DEFINE_STRING(string2056_cgen_capp, string2056_cgen_capp2074, "FUN AUX CGEN ", 13);

obj_t 
module_initialization_70_cgen_capp(long checksum_2419, char *from_2420)
{
   if (CBOOL(require_initialization_114_cgen_capp))
     {
	require_initialization_114_cgen_capp = BBOOL(((bool_t) 0));
	library_modules_init_112_cgen_capp();
	cnst_init_137_cgen_capp();
	imported_modules_init_94_cgen_capp();
	toplevel_init_63_cgen_capp();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cgen_capp()
{
   module_initialization_70___object(((long) 0), "CGEN_CAPP");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CGEN_CAPP");
   module_initialization_70___reader(((long) 0), "CGEN_CAPP");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cgen_capp()
{
   {
      obj_t cnst_port_138_2411;
      cnst_port_138_2411 = open_input_string(string2056_cgen_capp);
      {
	 long i_2412;
	 i_2412 = ((long) 2);
       loop_2413:
	 {
	    bool_t test2057_2414;
	    test2057_2414 = (i_2412 == ((long) -1));
	    if (test2057_2414)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2058_2415;
		    {
		       obj_t list2059_2416;
		       {
			  obj_t arg2060_2417;
			  arg2060_2417 = BNIL;
			  list2059_2416 = MAKE_PAIR(cnst_port_138_2411, arg2060_2417);
		       }
		       arg2058_2415 = read___reader(list2059_2416);
		    }
		    CNST_TABLE_SET(i_2412, arg2058_2415);
		 }
		 {
		    int aux_2418;
		    {
		       long aux_2437;
		       aux_2437 = (i_2412 - ((long) 1));
		       aux_2418 = (int) (aux_2437);
		    }
		    {
		       long i_2440;
		       i_2440 = (long) (aux_2418);
		       i_2412 = i_2440;
		       goto loop_2413;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cgen_capp()
{
   {
      obj_t node__cop_app_ly_235_2385;
      node__cop_app_ly_235_2385 = proc2044_cgen_capp;
      add_method__1___object(node__cop_env_160_cgen_cgen, app_ly_162_ast_node, node__cop_app_ly_235_2385);
   }
   {
      obj_t node__cop_funcall_165_2384;
      node__cop_funcall_165_2384 = proc2045_cgen_capp;
      add_method__1___object(node__cop_env_160_cgen_cgen, funcall_ast_node, node__cop_funcall_165_2384);
   }
   {
      obj_t node__cop_app_91_2383;
      node__cop_app_91_2383 = proc2046_cgen_capp;
      return add_method__1___object(node__cop_env_160_cgen_cgen, app_ast_node, node__cop_app_91_2383);
   }
}


obj_t 
node__cop_app2037_248_cgen_capp(obj_t env_2386, obj_t node_2387, obj_t kont_2388)
{
   {
      app_t node_1028;
      obj_t kont_1029;
      node_1028 = (app_t) (node_2387);
      kont_1029 = kont_2388;
      {
	 bool_t test1654_1032;
	 {
	    obj_t aux_2445;
	    aux_2445 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
	    test1654_1032 = CBOOL(aux_2445);
	 }
	 if (test1654_1032)
	   {
	      obj_t arg1656_1034;
	      arg1656_1034 = shape_tools_shape((obj_t) (node_1028));
	      {
		 obj_t list1658_1036;
		 {
		    obj_t arg1659_1037;
		    {
		       obj_t arg1661_1038;
		       {
			  obj_t arg1663_1039;
			  {
			     obj_t arg1664_1040;
			     {
				obj_t arg1665_1041;
				{
				   obj_t aux_2453;
				   aux_2453 = BCHAR(((unsigned char) '\n'));
				   arg1665_1041 = MAKE_PAIR(aux_2453, BNIL);
				}
				arg1664_1040 = MAKE_PAIR(kont_1029, arg1665_1041);
			     }
			     arg1663_1039 = MAKE_PAIR(string2047_cgen_capp, arg1664_1040);
			  }
			  {
			     obj_t aux_2458;
			     aux_2458 = BCHAR(((unsigned char) '\n'));
			     arg1661_1038 = MAKE_PAIR(aux_2458, arg1663_1039);
			  }
		       }
		       arg1659_1037 = MAKE_PAIR(arg1656_1034, arg1661_1038);
		    }
		    list1658_1036 = MAKE_PAIR(string2048_cgen_capp, arg1659_1037);
		 }
		 print_trace_107_tools_trace(list1658_1036);
	      }
	   }
	 else
	   {
	      BUNSPEC;
	   }
      }
      {
	 variable_t var_1046;
	 {
	    var_t arg1674_1052;
	    arg1674_1052 = (((app_t) CREF(node_1028))->fun);
	    var_1046 = (((var_t) CREF(arg1674_1052))->variable);
	 }
	 {
	    bool_t test1670_1047;
	    {
	       bool_t test1671_1048;
	       test1671_1048 = is_a__118___object((obj_t) (var_1046), global_ast_var);
	       if (test1671_1048)
		 {
		    bool_t _ortest_1406_1049;
		    {
		       bool_t test1673_1051;
		       {
			  obj_t obj2_2059;
			  obj2_2059 = __the_global__73_cgen_cgen;
			  {
			     obj_t aux_2469;
			     aux_2469 = (obj_t) (var_1046);
			     test1673_1051 = (aux_2469 == obj2_2059);
			  }
		       }
		       if (test1673_1051)
			 {
			    _ortest_1406_1049 = ((bool_t) 0);
			 }
		       else
			 {
			    _ortest_1406_1049 = ((bool_t) 1);
			 }
		    }
		    if (_ortest_1406_1049)
		      {
			 test1670_1047 = _ortest_1406_1049;
		      }
		    else
		      {
			 bool_t test1672_1050;
			 {
			    obj_t obj2_2061;
			    obj2_2061 = __return_kont__110_cgen_cgen;
			    test1672_1050 = (kont_1029 == obj2_2061);
			 }
			 if (test1672_1050)
			   {
			      test1670_1047 = ((bool_t) 0);
			   }
			 else
			   {
			      test1670_1047 = ((bool_t) 1);
			   }
		      }
		 }
	       else
		 {
		    test1670_1047 = ((bool_t) 0);
		 }
	    }
	    if (test1670_1047)
	      {
		 return node_non_tail_app__cop_76_cgen_capp(var_1046, node_1028, kont_1029);
	      }
	    else
	      {
		 return node_tail_app__cop_48_cgen_capp(var_1046, node_1028, kont_1029);
	      }
	 }
      }
   }
}


obj_t 
node__cop_funcall2038_241_cgen_capp(obj_t env_2389, obj_t node_2390, obj_t kont_2391)
{
   {
      funcall_t node_934;
      obj_t kont_935;
      node_934 = (funcall_t) (node_2390);
      kont_935 = kont_2391;
      {
	 bool_t test1557_938;
	 {
	    obj_t aux_2480;
	    aux_2480 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
	    test1557_938 = CBOOL(aux_2480);
	 }
	 if (test1557_938)
	   {
	      obj_t arg1560_940;
	      arg1560_940 = shape_tools_shape((obj_t) (node_934));
	      {
		 obj_t list1562_942;
		 {
		    obj_t arg1563_943;
		    {
		       obj_t arg1564_944;
		       {
			  obj_t arg1565_945;
			  {
			     obj_t arg1566_946;
			     {
				obj_t arg1567_947;
				{
				   obj_t aux_2488;
				   aux_2488 = BCHAR(((unsigned char) '\n'));
				   arg1567_947 = MAKE_PAIR(aux_2488, BNIL);
				}
				arg1566_946 = MAKE_PAIR(kont_935, arg1567_947);
			     }
			     arg1565_945 = MAKE_PAIR(string2047_cgen_capp, arg1566_946);
			  }
			  {
			     obj_t aux_2493;
			     aux_2493 = BCHAR(((unsigned char) '\n'));
			     arg1564_944 = MAKE_PAIR(aux_2493, arg1565_945);
			  }
		       }
		       arg1563_943 = MAKE_PAIR(arg1560_940, arg1564_944);
		    }
		    list1562_942 = MAKE_PAIR(string2049_cgen_capp, arg1563_943);
		 }
		 print_trace_107_tools_trace(list1562_942);
	      }
	   }
	 else
	   {
	      BUNSPEC;
	   }
      }
      {
	 obj_t old_actuals_174_952;
	 obj_t new_actuals_73_953;
	 local_t aux_954;
	 obj_t auxs_955;
	 obj_t exps_956;
	 {
	    obj_t arg1572_958;
	    local_t arg1574_960;
	    arg1572_958 = (((funcall_t) CREF(node_934))->args);
	    arg1574_960 = make_local_svar_name_219_cgen_cgen(CNST_TABLE_REF(((long) 1)), (type_t) (__obj__252_type_cache));
	    old_actuals_174_952 = arg1572_958;
	    new_actuals_73_953 = BNIL;
	    aux_954 = arg1574_960;
	    auxs_955 = BNIL;
	    exps_956 = BNIL;
	  loop_957:
	    if (NULLP(old_actuals_174_952))
	      {
		 local_t aux_965;
		 aux_965 = make_local_svar_name_219_cgen_cgen(CNST_TABLE_REF(((long) 1)), (type_t) (__obj__252_type_cache));
		 {
		    cop_t cop_966;
		    {
		       setq_t arg1627_1006;
		       arg1627_1006 = node_setq_243_cgen_cgen((variable_t) (aux_965), (((funcall_t) CREF(node_934))->fun));
		       cop_966 = node__cop_142_cgen_cgen((node_t) (arg1627_1006), __id_kont__126_cgen_cgen);
		    }
		    {
		       {
			  bool_t test1579_967;
			  {
			     bool_t test1621_1001;
			     test1621_1001 = is_a__118___object((obj_t) (cop_966), csetq_cgen_cop);
			     if (test1621_1001)
			       {
				  bool_t test1622_1002;
				  {
				     obj_t aux_2516;
				     {
					node_t aux_2517;
					aux_2517 = (((funcall_t) CREF(node_934))->fun);
					aux_2516 = (obj_t) (aux_2517);
				     }
				     test1622_1002 = is_a__118___object(aux_2516, var_ast_node);
				  }
				  if (test1622_1002)
				    {
				       obj_t aux_2528;
				       obj_t aux_2522;
				       aux_2528 = (obj_t) (aux_965);
				       {
					  variable_t aux_2523;
					  {
					     varc_t arg1624_1004;
					     {
						csetq_t obj_1912;
						obj_1912 = (csetq_t) (cop_966);
						arg1624_1004 = (((csetq_t) CREF(obj_1912))->var);
					     }
					     aux_2523 = (((varc_t) CREF(arg1624_1004))->variable);
					  }
					  aux_2522 = (obj_t) (aux_2523);
				       }
				       test1579_967 = (aux_2522 == aux_2528);
				    }
				  else
				    {
				       test1579_967 = ((bool_t) 0);
				    }
			       }
			     else
			       {
				  test1579_967 = ((bool_t) 0);
			       }
			  }
			  if (test1579_967)
			    {
			       cop_t cfun_968;
			       {
				  csetq_t obj_1916;
				  obj_1916 = (csetq_t) (cop_966);
				  cfun_968 = (((csetq_t) CREF(obj_1916))->value);
			       }
			       if (NULLP(auxs_955))
				 {
				    cfuncall_t arg1582_970;
				    {
				       obj_t arg1583_971;
				       obj_t arg1584_972;
				       arg1583_971 = reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_953);
				       arg1584_972 = (((funcall_t) CREF(node_934))->strength);
				       {
					  cfuncall_t res2003_1929;
					  {
					     cfuncall_t new1346_1922;
					     new1346_1922 = ((cfuncall_t) BREF(GC_MALLOC(sizeof(struct cfuncall))));
					     {
						long arg1861_1923;
						arg1861_1923 = class_num_218___object(cfuncall_cgen_cop);
						{
						   obj_t obj_1927;
						   obj_1927 = (obj_t) (new1346_1922);
						   (((obj_t) CREF(obj_1927))->header = MAKE_HEADER(arg1861_1923, 0), BUNSPEC);
						}
					     }
					     {
						object_t aux_2542;
						aux_2542 = (object_t) (new1346_1922);
						OBJECT_WIDENING_SET(aux_2542, BFALSE);
					     }
					     ((((cfuncall_t) CREF(new1346_1922))->fun) = ((cop_t) cfun_968), BUNSPEC);
					     ((((cfuncall_t) CREF(new1346_1922))->args) = ((obj_t) arg1583_971), BUNSPEC);
					     ((((cfuncall_t) CREF(new1346_1922))->strength) = ((obj_t) arg1584_972), BUNSPEC);
					     res2003_1929 = new1346_1922;
					  }
					  arg1582_970 = res2003_1929;
				       }
				    }
				    return PROCEDURE_ENTRY(kont_935) (kont_935, (obj_t) (arg1582_970), BEOA);
				 }
			       else
				 {
				    csequence_t arg1585_973;
				    {
				       obj_t arg1587_974;
				       {
					  local_var_164_t arg1588_975;
					  csequence_t arg1589_976;
					  obj_t arg1590_977;
					  {
					     local_var_164_t res2004_1936;
					     {
						local_var_164_t new1342_1931;
						new1342_1931 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
						{
						   long arg1863_1932;
						   arg1863_1932 = class_num_218___object(local_var_164_cgen_cop);
						   {
						      obj_t obj_1934;
						      obj_1934 = (obj_t) (new1342_1931);
						      (((obj_t) CREF(obj_1934))->header = MAKE_HEADER(arg1863_1932, 0), BUNSPEC);
						   }
						}
						{
						   object_t aux_2555;
						   aux_2555 = (object_t) (new1342_1931);
						   OBJECT_WIDENING_SET(aux_2555, BFALSE);
						}
						((((local_var_164_t) CREF(new1342_1931))->vars) = ((obj_t) auxs_955), BUNSPEC);
						res2004_1936 = new1342_1931;
					     }
					     arg1588_975 = res2004_1936;
					  }
					  {
					     csequence_t res2005_1945;
					     {
						csequence_t new1317_1939;
						new1317_1939 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
						{
						   long arg1879_1940;
						   arg1879_1940 = class_num_218___object(csequence_cgen_cop);
						   {
						      obj_t obj_1943;
						      obj_1943 = (obj_t) (new1317_1939);
						      (((obj_t) CREF(obj_1943))->header = MAKE_HEADER(arg1879_1940, 0), BUNSPEC);
						   }
						}
						{
						   object_t aux_2563;
						   aux_2563 = (object_t) (new1317_1939);
						   OBJECT_WIDENING_SET(aux_2563, BFALSE);
						}
						((((csequence_t) CREF(new1317_1939))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						((((csequence_t) CREF(new1317_1939))->cops) = ((obj_t) exps_956), BUNSPEC);
						res2005_1945 = new1317_1939;
					     }
					     arg1589_976 = res2005_1945;
					  }
					  {
					     cfuncall_t arg1596_982;
					     {
						obj_t arg1597_983;
						obj_t arg1600_984;
						arg1597_983 = reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_953);
						arg1600_984 = (((funcall_t) CREF(node_934))->strength);
						{
						   cfuncall_t res2006_1957;
						   {
						      cfuncall_t new1346_1950;
						      new1346_1950 = ((cfuncall_t) BREF(GC_MALLOC(sizeof(struct cfuncall))));
						      {
							 long arg1861_1951;
							 arg1861_1951 = class_num_218___object(cfuncall_cgen_cop);
							 {
							    obj_t obj_1955;
							    obj_1955 = (obj_t) (new1346_1950);
							    (((obj_t) CREF(obj_1955))->header = MAKE_HEADER(arg1861_1951, 0), BUNSPEC);
							 }
						      }
						      {
							 object_t aux_2574;
							 aux_2574 = (object_t) (new1346_1950);
							 OBJECT_WIDENING_SET(aux_2574, BFALSE);
						      }
						      ((((cfuncall_t) CREF(new1346_1950))->fun) = ((cop_t) cfun_968), BUNSPEC);
						      ((((cfuncall_t) CREF(new1346_1950))->args) = ((obj_t) arg1597_983), BUNSPEC);
						      ((((cfuncall_t) CREF(new1346_1950))->strength) = ((obj_t) arg1600_984), BUNSPEC);
						      res2006_1957 = new1346_1950;
						   }
						   arg1596_982 = res2006_1957;
						}
					     }
					     arg1590_977 = PROCEDURE_ENTRY(kont_935) (kont_935, (obj_t) (arg1596_982), BEOA);
					  }
					  {
					     obj_t list1591_978;
					     {
						obj_t arg1592_979;
						{
						   obj_t arg1593_980;
						   arg1593_980 = MAKE_PAIR(arg1590_977, BNIL);
						   {
						      obj_t aux_2584;
						      aux_2584 = (obj_t) (arg1589_976);
						      arg1592_979 = MAKE_PAIR(aux_2584, arg1593_980);
						   }
						}
						{
						   obj_t aux_2587;
						   aux_2587 = (obj_t) (arg1588_975);
						   list1591_978 = MAKE_PAIR(aux_2587, arg1592_979);
						}
					     }
					     arg1587_974 = list1591_978;
					  }
				       }
				       {
					  csequence_t res2007_1967;
					  {
					     csequence_t new1317_1961;
					     new1317_1961 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
					     {
						long arg1879_1962;
						arg1879_1962 = class_num_218___object(csequence_cgen_cop);
						{
						   obj_t obj_1965;
						   obj_1965 = (obj_t) (new1317_1961);
						   (((obj_t) CREF(obj_1965))->header = MAKE_HEADER(arg1879_1962, 0), BUNSPEC);
						}
					     }
					     {
						object_t aux_2594;
						aux_2594 = (object_t) (new1317_1961);
						OBJECT_WIDENING_SET(aux_2594, BFALSE);
					     }
					     ((((csequence_t) CREF(new1317_1961))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					     ((((csequence_t) CREF(new1317_1961))->cops) = ((obj_t) arg1587_974), BUNSPEC);
					     res2007_1967 = new1317_1961;
					  }
					  arg1585_973 = res2007_1967;
				       }
				    }
				    {
				       block_t res2008_1974;
				       {
					  cop_t body_1968;
					  body_1968 = (cop_t) (arg1585_973);
					  {
					     block_t new1287_1969;
					     new1287_1969 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
					     {
						long arg1894_1970;
						arg1894_1970 = class_num_218___object(block_cgen_cop);
						{
						   obj_t obj_1972;
						   obj_1972 = (obj_t) (new1287_1969);
						   (((obj_t) CREF(obj_1972))->header = MAKE_HEADER(arg1894_1970, 0), BUNSPEC);
						}
					     }
					     {
						object_t aux_2604;
						aux_2604 = (object_t) (new1287_1969);
						OBJECT_WIDENING_SET(aux_2604, BFALSE);
					     }
					     ((((block_t) CREF(new1287_1969))->body) = ((cop_t) body_1968), BUNSPEC);
					     res2008_1974 = new1287_1969;
					  }
				       }
				       return (obj_t) (res2008_1974);
				    }
				 }
			    }
			  else
			    {
			       csequence_t arg1601_986;
			       {
				  obj_t arg1603_987;
				  {
				     local_var_164_t arg1604_988;
				     csequence_t arg1605_989;
				     obj_t arg1606_990;
				     {
					obj_t arg1614_995;
					{
					   obj_t aux_2609;
					   aux_2609 = (obj_t) (aux_965);
					   arg1614_995 = MAKE_PAIR(aux_2609, auxs_955);
					}
					{
					   local_var_164_t res2009_1983;
					   {
					      local_var_164_t new1342_1978;
					      new1342_1978 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
					      {
						 long arg1863_1979;
						 arg1863_1979 = class_num_218___object(local_var_164_cgen_cop);
						 {
						    obj_t obj_1981;
						    obj_1981 = (obj_t) (new1342_1978);
						    (((obj_t) CREF(obj_1981))->header = MAKE_HEADER(arg1863_1979, 0), BUNSPEC);
						 }
					      }
					      {
						 object_t aux_2616;
						 aux_2616 = (object_t) (new1342_1978);
						 OBJECT_WIDENING_SET(aux_2616, BFALSE);
					      }
					      ((((local_var_164_t) CREF(new1342_1978))->vars) = ((obj_t) arg1614_995), BUNSPEC);
					      res2009_1983 = new1342_1978;
					   }
					   arg1604_988 = res2009_1983;
					}
				     }
				     {
					obj_t arg1616_996;
					{
					   obj_t aux_2620;
					   aux_2620 = (obj_t) (cop_966);
					   arg1616_996 = MAKE_PAIR(aux_2620, exps_956);
					}
					{
					   csequence_t res2010_1994;
					   {
					      csequence_t new1317_1988;
					      new1317_1988 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
					      {
						 long arg1879_1989;
						 arg1879_1989 = class_num_218___object(csequence_cgen_cop);
						 {
						    obj_t obj_1992;
						    obj_1992 = (obj_t) (new1317_1988);
						    (((obj_t) CREF(obj_1992))->header = MAKE_HEADER(arg1879_1989, 0), BUNSPEC);
						 }
					      }
					      {
						 object_t aux_2627;
						 aux_2627 = (object_t) (new1317_1988);
						 OBJECT_WIDENING_SET(aux_2627, BFALSE);
					      }
					      ((((csequence_t) CREF(new1317_1988))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					      ((((csequence_t) CREF(new1317_1988))->cops) = ((obj_t) arg1616_996), BUNSPEC);
					      res2010_1994 = new1317_1988;
					   }
					   arg1605_989 = res2010_1994;
					}
				     }
				     {
					cfuncall_t arg1617_997;
					{
					   varc_t arg1618_998;
					   obj_t arg1619_999;
					   obj_t arg1620_1000;
					   {
					      varc_t res2011_2001;
					      {
						 variable_t variable_1995;
						 variable_1995 = (variable_t) (aux_965);
						 {
						    varc_t new1305_1996;
						    new1305_1996 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
						    {
						       long arg1885_1997;
						       arg1885_1997 = class_num_218___object(varc_cgen_cop);
						       {
							  obj_t obj_1999;
							  obj_1999 = (obj_t) (new1305_1996);
							  (((obj_t) CREF(obj_1999))->header = MAKE_HEADER(arg1885_1997, 0), BUNSPEC);
						       }
						    }
						    {
						       object_t aux_2637;
						       aux_2637 = (object_t) (new1305_1996);
						       OBJECT_WIDENING_SET(aux_2637, BFALSE);
						    }
						    ((((varc_t) CREF(new1305_1996))->variable) = ((variable_t) variable_1995), BUNSPEC);
						    res2011_2001 = new1305_1996;
						 }
					      }
					      arg1618_998 = res2011_2001;
					   }
					   arg1619_999 = reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_953);
					   arg1620_1000 = (((funcall_t) CREF(node_934))->strength);
					   {
					      cfuncall_t res2012_2013;
					      {
						 cop_t fun_2003;
						 fun_2003 = (cop_t) (arg1618_998);
						 {
						    cfuncall_t new1346_2006;
						    new1346_2006 = ((cfuncall_t) BREF(GC_MALLOC(sizeof(struct cfuncall))));
						    {
						       long arg1861_2007;
						       arg1861_2007 = class_num_218___object(cfuncall_cgen_cop);
						       {
							  obj_t obj_2011;
							  obj_2011 = (obj_t) (new1346_2006);
							  (((obj_t) CREF(obj_2011))->header = MAKE_HEADER(arg1861_2007, 0), BUNSPEC);
						       }
						    }
						    {
						       object_t aux_2648;
						       aux_2648 = (object_t) (new1346_2006);
						       OBJECT_WIDENING_SET(aux_2648, BFALSE);
						    }
						    ((((cfuncall_t) CREF(new1346_2006))->fun) = ((cop_t) fun_2003), BUNSPEC);
						    ((((cfuncall_t) CREF(new1346_2006))->args) = ((obj_t) arg1619_999), BUNSPEC);
						    ((((cfuncall_t) CREF(new1346_2006))->strength) = ((obj_t) arg1620_1000), BUNSPEC);
						    res2012_2013 = new1346_2006;
						 }
					      }
					      arg1617_997 = res2012_2013;
					   }
					}
					arg1606_990 = PROCEDURE_ENTRY(kont_935) (kont_935, (obj_t) (arg1617_997), BEOA);
				     }
				     {
					obj_t list1607_991;
					{
					   obj_t arg1608_992;
					   {
					      obj_t arg1609_993;
					      arg1609_993 = MAKE_PAIR(arg1606_990, BNIL);
					      {
						 obj_t aux_2658;
						 aux_2658 = (obj_t) (arg1605_989);
						 arg1608_992 = MAKE_PAIR(aux_2658, arg1609_993);
					      }
					   }
					   {
					      obj_t aux_2661;
					      aux_2661 = (obj_t) (arg1604_988);
					      list1607_991 = MAKE_PAIR(aux_2661, arg1608_992);
					   }
					}
					arg1603_987 = list1607_991;
				     }
				  }
				  {
				     csequence_t res2013_2023;
				     {
					csequence_t new1317_2017;
					new1317_2017 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
					{
					   long arg1879_2018;
					   arg1879_2018 = class_num_218___object(csequence_cgen_cop);
					   {
					      obj_t obj_2021;
					      obj_2021 = (obj_t) (new1317_2017);
					      (((obj_t) CREF(obj_2021))->header = MAKE_HEADER(arg1879_2018, 0), BUNSPEC);
					   }
					}
					{
					   object_t aux_2668;
					   aux_2668 = (object_t) (new1317_2017);
					   OBJECT_WIDENING_SET(aux_2668, BFALSE);
					}
					((((csequence_t) CREF(new1317_2017))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					((((csequence_t) CREF(new1317_2017))->cops) = ((obj_t) arg1603_987), BUNSPEC);
					res2013_2023 = new1317_2017;
				     }
				     arg1601_986 = res2013_2023;
				  }
			       }
			       {
				  block_t res2014_2030;
				  {
				     cop_t body_2024;
				     body_2024 = (cop_t) (arg1601_986);
				     {
					block_t new1287_2025;
					new1287_2025 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
					{
					   long arg1894_2026;
					   arg1894_2026 = class_num_218___object(block_cgen_cop);
					   {
					      obj_t obj_2028;
					      obj_2028 = (obj_t) (new1287_2025);
					      (((obj_t) CREF(obj_2028))->header = MAKE_HEADER(arg1894_2026, 0), BUNSPEC);
					   }
					}
					{
					   object_t aux_2678;
					   aux_2678 = (object_t) (new1287_2025);
					   OBJECT_WIDENING_SET(aux_2678, BFALSE);
					}
					((((block_t) CREF(new1287_2025))->body) = ((cop_t) body_2024), BUNSPEC);
					res2014_2030 = new1287_2025;
				     }
				  }
				  return (obj_t) (res2014_2030);
			       }
			    }
		       }
		    }
		 }
	      }
	    else
	      {
		 cop_t cop_1009;
		 {
		    setq_t arg1651_1024;
		    {
		       node_t aux_2683;
		       {
			  obj_t aux_2685;
			  aux_2685 = CAR(old_actuals_174_952);
			  aux_2683 = (node_t) (aux_2685);
		       }
		       arg1651_1024 = node_setq_243_cgen_cgen((variable_t) (aux_954), aux_2683);
		    }
		    cop_1009 = node__cop_142_cgen_cgen((node_t) (arg1651_1024), __id_kont__126_cgen_cgen);
		 }
		 {
		    bool_t test1631_1010;
		    {
		       bool_t test1647_1021;
		       test1647_1021 = is_a__118___object((obj_t) (cop_1009), csetq_cgen_cop);
		       if (test1647_1021)
			 {
			    obj_t aux_2700;
			    obj_t aux_2694;
			    aux_2700 = (obj_t) (aux_954);
			    {
			       variable_t aux_2695;
			       {
				  varc_t arg1650_1023;
				  {
				     csetq_t obj_2033;
				     obj_2033 = (csetq_t) (cop_1009);
				     arg1650_1023 = (((csetq_t) CREF(obj_2033))->var);
				  }
				  aux_2695 = (((varc_t) CREF(arg1650_1023))->variable);
			       }
			       aux_2694 = (obj_t) (aux_2695);
			    }
			    test1631_1010 = (aux_2694 == aux_2700);
			 }
		       else
			 {
			    test1631_1010 = ((bool_t) 0);
			 }
		    }
		    if (test1631_1010)
		      {
			 obj_t arg1632_1011;
			 obj_t arg1634_1012;
			 arg1632_1011 = CDR(old_actuals_174_952);
			 {
			    obj_t aux_2705;
			    {
			       cop_t aux_2706;
			       {
				  csetq_t obj_2038;
				  obj_2038 = (csetq_t) (cop_1009);
				  aux_2706 = (((csetq_t) CREF(obj_2038))->value);
			       }
			       aux_2705 = (obj_t) (aux_2706);
			    }
			    arg1634_1012 = MAKE_PAIR(aux_2705, new_actuals_73_953);
			 }
			 {
			    obj_t new_actuals_73_2712;
			    obj_t old_actuals_174_2711;
			    old_actuals_174_2711 = arg1632_1011;
			    new_actuals_73_2712 = arg1634_1012;
			    new_actuals_73_953 = new_actuals_73_2712;
			    old_actuals_174_952 = old_actuals_174_2711;
			    goto loop_957;
			 }
		      }
		    else
		      {
			 {
			    obj_t arg1638_1014;
			    obj_t arg1641_1015;
			    local_t arg1642_1016;
			    obj_t arg1643_1017;
			    obj_t arg1644_1018;
			    arg1638_1014 = CDR(old_actuals_174_952);
			    {
			       varc_t arg1645_1019;
			       {
				  varc_t res2015_2048;
				  {
				     variable_t variable_2042;
				     variable_2042 = (variable_t) (aux_954);
				     {
					varc_t new1305_2043;
					new1305_2043 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
					{
					   long arg1885_2044;
					   arg1885_2044 = class_num_218___object(varc_cgen_cop);
					   {
					      obj_t obj_2046;
					      obj_2046 = (obj_t) (new1305_2043);
					      (((obj_t) CREF(obj_2046))->header = MAKE_HEADER(arg1885_2044, 0), BUNSPEC);
					   }
					}
					{
					   object_t aux_2719;
					   aux_2719 = (object_t) (new1305_2043);
					   OBJECT_WIDENING_SET(aux_2719, BFALSE);
					}
					((((varc_t) CREF(new1305_2043))->variable) = ((variable_t) variable_2042), BUNSPEC);
					res2015_2048 = new1305_2043;
				     }
				  }
				  arg1645_1019 = res2015_2048;
			       }
			       {
				  obj_t aux_2723;
				  aux_2723 = (obj_t) (arg1645_1019);
				  arg1641_1015 = MAKE_PAIR(aux_2723, new_actuals_73_953);
			       }
			    }
			    arg1642_1016 = make_local_svar_name_219_cgen_cgen(CNST_TABLE_REF(((long) 1)), (type_t) (__obj__252_type_cache));
			    {
			       obj_t aux_2729;
			       aux_2729 = (obj_t) (aux_954);
			       arg1643_1017 = MAKE_PAIR(aux_2729, auxs_955);
			    }
			    {
			       obj_t aux_2732;
			       aux_2732 = (obj_t) (cop_1009);
			       arg1644_1018 = MAKE_PAIR(aux_2732, exps_956);
			    }
			    {
			       obj_t exps_2739;
			       obj_t auxs_2738;
			       local_t aux_2737;
			       obj_t new_actuals_73_2736;
			       obj_t old_actuals_174_2735;
			       old_actuals_174_2735 = arg1638_1014;
			       new_actuals_73_2736 = arg1641_1015;
			       aux_2737 = arg1642_1016;
			       auxs_2738 = arg1643_1017;
			       exps_2739 = arg1644_1018;
			       exps_956 = exps_2739;
			       auxs_955 = auxs_2738;
			       aux_954 = aux_2737;
			       new_actuals_73_953 = new_actuals_73_2736;
			       old_actuals_174_952 = old_actuals_174_2735;
			       goto loop_957;
			    }
			 }
		      }
		 }
	      }
	 }
      }
   }
}


obj_t 
node__cop_app_ly2039_130_cgen_capp(obj_t env_2392, obj_t node_2393, obj_t kont_2394)
{
   {
      app_ly_162_t node_829;
      obj_t kont_830;
      node_829 = (app_ly_162_t) (node_2393);
      kont_830 = kont_2394;
      {
	 bool_t test1421_833;
	 {
	    obj_t aux_2741;
	    aux_2741 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
	    test1421_833 = CBOOL(aux_2741);
	 }
	 if (test1421_833)
	   {
	      obj_t arg1426_835;
	      arg1426_835 = shape_tools_shape((obj_t) (node_829));
	      {
		 obj_t list1428_837;
		 {
		    obj_t arg1431_838;
		    {
		       obj_t arg1432_839;
		       {
			  obj_t arg1440_840;
			  {
			     obj_t arg1441_841;
			     {
				obj_t arg1444_842;
				{
				   obj_t aux_2749;
				   aux_2749 = BCHAR(((unsigned char) '\n'));
				   arg1444_842 = MAKE_PAIR(aux_2749, BNIL);
				}
				arg1441_841 = MAKE_PAIR(kont_830, arg1444_842);
			     }
			     arg1440_840 = MAKE_PAIR(string2047_cgen_capp, arg1441_841);
			  }
			  {
			     obj_t aux_2754;
			     aux_2754 = BCHAR(((unsigned char) '\n'));
			     arg1432_839 = MAKE_PAIR(aux_2754, arg1440_840);
			  }
		       }
		       arg1431_838 = MAKE_PAIR(arg1426_835, arg1432_839);
		    }
		    list1428_837 = MAKE_PAIR(string2050_cgen_capp, arg1431_838);
		 }
		 print_trace_107_tools_trace(list1428_837);
	      }
	   }
	 else
	   {
	      BUNSPEC;
	   }
      }
      {
	 node_t value_847;
	 value_847 = (((app_ly_162_t) CREF(node_829))->arg);
	 {
	    local_t vaux_848;
	    vaux_848 = make_local_svar_name_219_cgen_cgen(CNST_TABLE_REF(((long) 1)), (type_t) (__obj__252_type_cache));
	    {
	       cop_t vcop_849;
	       {
		  setq_t arg1554_930;
		  arg1554_930 = node_setq_243_cgen_cgen((variable_t) (vaux_848), value_847);
		  vcop_849 = node__cop_142_cgen_cgen((node_t) (arg1554_930), __id_kont__126_cgen_cgen);
	       }
	       {
		  node_t fun_850;
		  fun_850 = (((app_ly_162_t) CREF(node_829))->fun);
		  {
		     local_t faux_851;
		     faux_851 = make_local_svar_name_219_cgen_cgen(CNST_TABLE_REF(((long) 2)), (type_t) (__procedure__226_type_cache));
		     {
			cop_t fcop_852;
			{
			   setq_t arg1552_928;
			   arg1552_928 = node_setq_243_cgen_cgen((variable_t) (faux_851), fun_850);
			   fcop_852 = node__cop_142_cgen_cgen((node_t) (arg1552_928), __id_kont__126_cgen_cgen);
			}
			{
			   {
			      bool_t test1448_853;
			      {
				 bool_t test1541_921;
				 test1541_921 = is_a__118___object((obj_t) (vcop_849), csetq_cgen_cop);
				 if (test1541_921)
				   {
				      bool_t test_2779;
				      {
					 obj_t aux_2786;
					 obj_t aux_2780;
					 aux_2786 = (obj_t) (vaux_848);
					 {
					    variable_t aux_2781;
					    {
					       varc_t arg1551_927;
					       {
						  csetq_t obj_1714;
						  obj_1714 = (csetq_t) (vcop_849);
						  arg1551_927 = (((csetq_t) CREF(obj_1714))->var);
					       }
					       aux_2781 = (((varc_t) CREF(arg1551_927))->variable);
					    }
					    aux_2780 = (obj_t) (aux_2781);
					 }
					 test_2779 = (aux_2780 == aux_2786);
				      }
				      if (test_2779)
					{
					   bool_t test1543_923;
					   test1543_923 = is_a__118___object((obj_t) (fcop_852), csetq_cgen_cop);
					   if (test1543_923)
					     {
						obj_t aux_2798;
						obj_t aux_2792;
						aux_2798 = (obj_t) (faux_851);
						{
						   variable_t aux_2793;
						   {
						      varc_t arg1549_925;
						      {
							 csetq_t obj_1719;
							 obj_1719 = (csetq_t) (fcop_852);
							 arg1549_925 = (((csetq_t) CREF(obj_1719))->var);
						      }
						      aux_2793 = (((varc_t) CREF(arg1549_925))->variable);
						   }
						   aux_2792 = (obj_t) (aux_2793);
						}
						test1448_853 = (aux_2792 == aux_2798);
					     }
					   else
					     {
						test1448_853 = ((bool_t) 0);
					     }
					}
				      else
					{
					   test1448_853 = ((bool_t) 0);
					}
				   }
				 else
				   {
				      test1448_853 = ((bool_t) 0);
				   }
			      }
			      if (test1448_853)
				{
				   {
				      capply_t arg1449_854;
				      {
					 cop_t arg1450_855;
					 cop_t arg1452_856;
					 {
					    csetq_t obj_1723;
					    obj_1723 = (csetq_t) (fcop_852);
					    arg1450_855 = (((csetq_t) CREF(obj_1723))->value);
					 }
					 {
					    csetq_t obj_1724;
					    obj_1724 = (csetq_t) (vcop_849);
					    arg1452_856 = (((csetq_t) CREF(obj_1724))->value);
					 }
					 {
					    capply_t res1983_1733;
					    {
					       capply_t new1350_1727;
					       new1350_1727 = ((capply_t) BREF(GC_MALLOC(sizeof(struct capply))));
					       {
						  long arg1859_1728;
						  arg1859_1728 = class_num_218___object(capply_cgen_cop);
						  {
						     obj_t obj_1731;
						     obj_1731 = (obj_t) (new1350_1727);
						     (((obj_t) CREF(obj_1731))->header = MAKE_HEADER(arg1859_1728, 0), BUNSPEC);
						  }
					       }
					       {
						  object_t aux_2810;
						  aux_2810 = (object_t) (new1350_1727);
						  OBJECT_WIDENING_SET(aux_2810, BFALSE);
					       }
					       ((((capply_t) CREF(new1350_1727))->fun) = ((cop_t) arg1450_855), BUNSPEC);
					       ((((capply_t) CREF(new1350_1727))->arg) = ((cop_t) arg1452_856), BUNSPEC);
					       res1983_1733 = new1350_1727;
					    }
					    arg1449_854 = res1983_1733;
					 }
				      }
				      return PROCEDURE_ENTRY(kont_830) (kont_830, (obj_t) (arg1449_854), BEOA);
				   }
				}
			      else
				{
				   bool_t test1453_857;
				   {
				      bool_t test1538_918;
				      test1538_918 = is_a__118___object((obj_t) (vcop_849), csetq_cgen_cop);
				      if (test1538_918)
					{
					   obj_t aux_2827;
					   obj_t aux_2821;
					   aux_2827 = (obj_t) (vaux_848);
					   {
					      variable_t aux_2822;
					      {
						 varc_t arg1540_920;
						 {
						    csetq_t obj_1735;
						    obj_1735 = (csetq_t) (vcop_849);
						    arg1540_920 = (((csetq_t) CREF(obj_1735))->var);
						 }
						 aux_2822 = (((varc_t) CREF(arg1540_920))->variable);
					      }
					      aux_2821 = (obj_t) (aux_2822);
					   }
					   test1453_857 = (aux_2821 == aux_2827);
					}
				      else
					{
					   test1453_857 = ((bool_t) 0);
					}
				   }
				   if (test1453_857)
				     {
					{
					   csequence_t arg1454_858;
					   {
					      obj_t arg1457_859;
					      {
						 local_var_164_t arg1458_860;
						 csequence_t arg1461_861;
						 obj_t arg1463_862;
						 {
						    obj_t arg1468_867;
						    {
						       obj_t list1469_868;
						       {
							  obj_t aux_2831;
							  aux_2831 = (obj_t) (faux_851);
							  list1469_868 = MAKE_PAIR(aux_2831, BNIL);
						       }
						       arg1468_867 = list1469_868;
						    }
						    {
						       local_var_164_t res1984_1746;
						       {
							  local_var_164_t new1342_1741;
							  new1342_1741 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							  {
							     long arg1863_1742;
							     arg1863_1742 = class_num_218___object(local_var_164_cgen_cop);
							     {
								obj_t obj_1744;
								obj_1744 = (obj_t) (new1342_1741);
								(((obj_t) CREF(obj_1744))->header = MAKE_HEADER(arg1863_1742, 0), BUNSPEC);
							     }
							  }
							  {
							     object_t aux_2838;
							     aux_2838 = (object_t) (new1342_1741);
							     OBJECT_WIDENING_SET(aux_2838, BFALSE);
							  }
							  ((((local_var_164_t) CREF(new1342_1741))->vars) = ((obj_t) arg1468_867), BUNSPEC);
							  res1984_1746 = new1342_1741;
						       }
						       arg1458_860 = res1984_1746;
						    }
						 }
						 {
						    obj_t arg1471_870;
						    {
						       obj_t list1472_871;
						       {
							  obj_t aux_2842;
							  aux_2842 = (obj_t) (fcop_852);
							  list1472_871 = MAKE_PAIR(aux_2842, BNIL);
						       }
						       arg1471_870 = list1472_871;
						    }
						    {
						       csequence_t res1985_1756;
						       {
							  csequence_t new1317_1750;
							  new1317_1750 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
							  {
							     long arg1879_1751;
							     arg1879_1751 = class_num_218___object(csequence_cgen_cop);
							     {
								obj_t obj_1754;
								obj_1754 = (obj_t) (new1317_1750);
								(((obj_t) CREF(obj_1754))->header = MAKE_HEADER(arg1879_1751, 0), BUNSPEC);
							     }
							  }
							  {
							     object_t aux_2849;
							     aux_2849 = (object_t) (new1317_1750);
							     OBJECT_WIDENING_SET(aux_2849, BFALSE);
							  }
							  ((((csequence_t) CREF(new1317_1750))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							  ((((csequence_t) CREF(new1317_1750))->cops) = ((obj_t) arg1471_870), BUNSPEC);
							  res1985_1756 = new1317_1750;
						       }
						       arg1461_861 = res1985_1756;
						    }
						 }
						 {
						    capply_t arg1476_873;
						    {
						       varc_t arg1477_874;
						       cop_t arg1478_875;
						       {
							  varc_t res1986_1763;
							  {
							     variable_t variable_1757;
							     variable_1757 = (variable_t) (faux_851);
							     {
								varc_t new1305_1758;
								new1305_1758 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
								{
								   long arg1885_1759;
								   arg1885_1759 = class_num_218___object(varc_cgen_cop);
								   {
								      obj_t obj_1761;
								      obj_1761 = (obj_t) (new1305_1758);
								      (((obj_t) CREF(obj_1761))->header = MAKE_HEADER(arg1885_1759, 0), BUNSPEC);
								   }
								}
								{
								   object_t aux_2859;
								   aux_2859 = (object_t) (new1305_1758);
								   OBJECT_WIDENING_SET(aux_2859, BFALSE);
								}
								((((varc_t) CREF(new1305_1758))->variable) = ((variable_t) variable_1757), BUNSPEC);
								res1986_1763 = new1305_1758;
							     }
							  }
							  arg1477_874 = res1986_1763;
						       }
						       {
							  csetq_t obj_1764;
							  obj_1764 = (csetq_t) (vcop_849);
							  arg1478_875 = (((csetq_t) CREF(obj_1764))->value);
						       }
						       {
							  capply_t res1987_1773;
							  {
							     cop_t fun_1765;
							     fun_1765 = (cop_t) (arg1477_874);
							     {
								capply_t new1350_1767;
								new1350_1767 = ((capply_t) BREF(GC_MALLOC(sizeof(struct capply))));
								{
								   long arg1859_1768;
								   arg1859_1768 = class_num_218___object(capply_cgen_cop);
								   {
								      obj_t obj_1771;
								      obj_1771 = (obj_t) (new1350_1767);
								      (((obj_t) CREF(obj_1771))->header = MAKE_HEADER(arg1859_1768, 0), BUNSPEC);
								   }
								}
								{
								   object_t aux_2870;
								   aux_2870 = (object_t) (new1350_1767);
								   OBJECT_WIDENING_SET(aux_2870, BFALSE);
								}
								((((capply_t) CREF(new1350_1767))->fun) = ((cop_t) fun_1765), BUNSPEC);
								((((capply_t) CREF(new1350_1767))->arg) = ((cop_t) arg1478_875), BUNSPEC);
								res1987_1773 = new1350_1767;
							     }
							  }
							  arg1476_873 = res1987_1773;
						       }
						    }
						    arg1463_862 = PROCEDURE_ENTRY(kont_830) (kont_830, (obj_t) (arg1476_873), BEOA);
						 }
						 {
						    obj_t list1464_863;
						    {
						       obj_t arg1465_864;
						       {
							  obj_t arg1466_865;
							  arg1466_865 = MAKE_PAIR(arg1463_862, BNIL);
							  {
							     obj_t aux_2879;
							     aux_2879 = (obj_t) (arg1461_861);
							     arg1465_864 = MAKE_PAIR(aux_2879, arg1466_865);
							  }
						       }
						       {
							  obj_t aux_2882;
							  aux_2882 = (obj_t) (arg1458_860);
							  list1464_863 = MAKE_PAIR(aux_2882, arg1465_864);
						       }
						    }
						    arg1457_859 = list1464_863;
						 }
					      }
					      {
						 csequence_t res1988_1783;
						 {
						    csequence_t new1317_1777;
						    new1317_1777 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
						    {
						       long arg1879_1778;
						       arg1879_1778 = class_num_218___object(csequence_cgen_cop);
						       {
							  obj_t obj_1781;
							  obj_1781 = (obj_t) (new1317_1777);
							  (((obj_t) CREF(obj_1781))->header = MAKE_HEADER(arg1879_1778, 0), BUNSPEC);
						       }
						    }
						    {
						       object_t aux_2889;
						       aux_2889 = (object_t) (new1317_1777);
						       OBJECT_WIDENING_SET(aux_2889, BFALSE);
						    }
						    ((((csequence_t) CREF(new1317_1777))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						    ((((csequence_t) CREF(new1317_1777))->cops) = ((obj_t) arg1457_859), BUNSPEC);
						    res1988_1783 = new1317_1777;
						 }
						 arg1454_858 = res1988_1783;
					      }
					   }
					   {
					      block_t res1989_1790;
					      {
						 cop_t body_1784;
						 body_1784 = (cop_t) (arg1454_858);
						 {
						    block_t new1287_1785;
						    new1287_1785 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
						    {
						       long arg1894_1786;
						       arg1894_1786 = class_num_218___object(block_cgen_cop);
						       {
							  obj_t obj_1788;
							  obj_1788 = (obj_t) (new1287_1785);
							  (((obj_t) CREF(obj_1788))->header = MAKE_HEADER(arg1894_1786, 0), BUNSPEC);
						       }
						    }
						    {
						       object_t aux_2899;
						       aux_2899 = (object_t) (new1287_1785);
						       OBJECT_WIDENING_SET(aux_2899, BFALSE);
						    }
						    ((((block_t) CREF(new1287_1785))->body) = ((cop_t) body_1784), BUNSPEC);
						    res1989_1790 = new1287_1785;
						 }
					      }
					      return (obj_t) (res1989_1790);
					   }
					}
				     }
				   else
				     {
					bool_t test1479_876;
					{
					   bool_t test1535_915;
					   test1535_915 = is_a__118___object((obj_t) (fcop_852), csetq_cgen_cop);
					   if (test1535_915)
					     {
						obj_t aux_2913;
						obj_t aux_2907;
						aux_2913 = (obj_t) (faux_851);
						{
						   variable_t aux_2908;
						   {
						      varc_t arg1537_917;
						      {
							 csetq_t obj_1792;
							 obj_1792 = (csetq_t) (fcop_852);
							 arg1537_917 = (((csetq_t) CREF(obj_1792))->var);
						      }
						      aux_2908 = (((varc_t) CREF(arg1537_917))->variable);
						   }
						   aux_2907 = (obj_t) (aux_2908);
						}
						test1479_876 = (aux_2907 == aux_2913);
					     }
					   else
					     {
						test1479_876 = ((bool_t) 0);
					     }
					}
					if (test1479_876)
					  {
					     {
						csequence_t arg1480_877;
						{
						   obj_t arg1481_878;
						   {
						      local_var_164_t arg1484_879;
						      csequence_t arg1485_880;
						      obj_t arg1486_881;
						      {
							 obj_t arg1494_886;
							 {
							    obj_t list1495_887;
							    {
							       obj_t aux_2917;
							       aux_2917 = (obj_t) (vaux_848);
							       list1495_887 = MAKE_PAIR(aux_2917, BNIL);
							    }
							    arg1494_886 = list1495_887;
							 }
							 {
							    local_var_164_t res1990_1803;
							    {
							       local_var_164_t new1342_1798;
							       new1342_1798 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							       {
								  long arg1863_1799;
								  arg1863_1799 = class_num_218___object(local_var_164_cgen_cop);
								  {
								     obj_t obj_1801;
								     obj_1801 = (obj_t) (new1342_1798);
								     (((obj_t) CREF(obj_1801))->header = MAKE_HEADER(arg1863_1799, 0), BUNSPEC);
								  }
							       }
							       {
								  object_t aux_2924;
								  aux_2924 = (object_t) (new1342_1798);
								  OBJECT_WIDENING_SET(aux_2924, BFALSE);
							       }
							       ((((local_var_164_t) CREF(new1342_1798))->vars) = ((obj_t) arg1494_886), BUNSPEC);
							       res1990_1803 = new1342_1798;
							    }
							    arg1484_879 = res1990_1803;
							 }
						      }
						      {
							 obj_t arg1497_889;
							 {
							    obj_t list1498_890;
							    {
							       obj_t aux_2928;
							       aux_2928 = (obj_t) (vcop_849);
							       list1498_890 = MAKE_PAIR(aux_2928, BNIL);
							    }
							    arg1497_889 = list1498_890;
							 }
							 {
							    csequence_t res1991_1813;
							    {
							       csequence_t new1317_1807;
							       new1317_1807 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
							       {
								  long arg1879_1808;
								  arg1879_1808 = class_num_218___object(csequence_cgen_cop);
								  {
								     obj_t obj_1811;
								     obj_1811 = (obj_t) (new1317_1807);
								     (((obj_t) CREF(obj_1811))->header = MAKE_HEADER(arg1879_1808, 0), BUNSPEC);
								  }
							       }
							       {
								  object_t aux_2935;
								  aux_2935 = (object_t) (new1317_1807);
								  OBJECT_WIDENING_SET(aux_2935, BFALSE);
							       }
							       ((((csequence_t) CREF(new1317_1807))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							       ((((csequence_t) CREF(new1317_1807))->cops) = ((obj_t) arg1497_889), BUNSPEC);
							       res1991_1813 = new1317_1807;
							    }
							    arg1485_880 = res1991_1813;
							 }
						      }
						      {
							 capply_t arg1500_892;
							 {
							    cop_t arg1501_893;
							    varc_t arg1505_894;
							    {
							       csetq_t obj_1814;
							       obj_1814 = (csetq_t) (fcop_852);
							       arg1501_893 = (((csetq_t) CREF(obj_1814))->value);
							    }
							    {
							       varc_t res1992_1821;
							       {
								  variable_t variable_1815;
								  variable_1815 = (variable_t) (vaux_848);
								  {
								     varc_t new1305_1816;
								     new1305_1816 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
								     {
									long arg1885_1817;
									arg1885_1817 = class_num_218___object(varc_cgen_cop);
									{
									   obj_t obj_1819;
									   obj_1819 = (obj_t) (new1305_1816);
									   (((obj_t) CREF(obj_1819))->header = MAKE_HEADER(arg1885_1817, 0), BUNSPEC);
									}
								     }
								     {
									object_t aux_2947;
									aux_2947 = (object_t) (new1305_1816);
									OBJECT_WIDENING_SET(aux_2947, BFALSE);
								     }
								     ((((varc_t) CREF(new1305_1816))->variable) = ((variable_t) variable_1815), BUNSPEC);
								     res1992_1821 = new1305_1816;
								  }
							       }
							       arg1505_894 = res1992_1821;
							    }
							    {
							       capply_t res1993_1830;
							       {
								  cop_t arg_1823;
								  arg_1823 = (cop_t) (arg1505_894);
								  {
								     capply_t new1350_1824;
								     new1350_1824 = ((capply_t) BREF(GC_MALLOC(sizeof(struct capply))));
								     {
									long arg1859_1825;
									arg1859_1825 = class_num_218___object(capply_cgen_cop);
									{
									   obj_t obj_1828;
									   obj_1828 = (obj_t) (new1350_1824);
									   (((obj_t) CREF(obj_1828))->header = MAKE_HEADER(arg1859_1825, 0), BUNSPEC);
									}
								     }
								     {
									object_t aux_2956;
									aux_2956 = (object_t) (new1350_1824);
									OBJECT_WIDENING_SET(aux_2956, BFALSE);
								     }
								     ((((capply_t) CREF(new1350_1824))->fun) = ((cop_t) arg1501_893), BUNSPEC);
								     ((((capply_t) CREF(new1350_1824))->arg) = ((cop_t) arg_1823), BUNSPEC);
								     res1993_1830 = new1350_1824;
								  }
							       }
							       arg1500_892 = res1993_1830;
							    }
							 }
							 arg1486_881 = PROCEDURE_ENTRY(kont_830) (kont_830, (obj_t) (arg1500_892), BEOA);
						      }
						      {
							 obj_t list1487_882;
							 {
							    obj_t arg1489_883;
							    {
							       obj_t arg1490_884;
							       arg1490_884 = MAKE_PAIR(arg1486_881, BNIL);
							       {
								  obj_t aux_2965;
								  aux_2965 = (obj_t) (arg1485_880);
								  arg1489_883 = MAKE_PAIR(aux_2965, arg1490_884);
							       }
							    }
							    {
							       obj_t aux_2968;
							       aux_2968 = (obj_t) (arg1484_879);
							       list1487_882 = MAKE_PAIR(aux_2968, arg1489_883);
							    }
							 }
							 arg1481_878 = list1487_882;
						      }
						   }
						   {
						      csequence_t res1994_1840;
						      {
							 csequence_t new1317_1834;
							 new1317_1834 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
							 {
							    long arg1879_1835;
							    arg1879_1835 = class_num_218___object(csequence_cgen_cop);
							    {
							       obj_t obj_1838;
							       obj_1838 = (obj_t) (new1317_1834);
							       (((obj_t) CREF(obj_1838))->header = MAKE_HEADER(arg1879_1835, 0), BUNSPEC);
							    }
							 }
							 {
							    object_t aux_2975;
							    aux_2975 = (object_t) (new1317_1834);
							    OBJECT_WIDENING_SET(aux_2975, BFALSE);
							 }
							 ((((csequence_t) CREF(new1317_1834))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							 ((((csequence_t) CREF(new1317_1834))->cops) = ((obj_t) arg1481_878), BUNSPEC);
							 res1994_1840 = new1317_1834;
						      }
						      arg1480_877 = res1994_1840;
						   }
						}
						{
						   block_t res1995_1847;
						   {
						      cop_t body_1841;
						      body_1841 = (cop_t) (arg1480_877);
						      {
							 block_t new1287_1842;
							 new1287_1842 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
							 {
							    long arg1894_1843;
							    arg1894_1843 = class_num_218___object(block_cgen_cop);
							    {
							       obj_t obj_1845;
							       obj_1845 = (obj_t) (new1287_1842);
							       (((obj_t) CREF(obj_1845))->header = MAKE_HEADER(arg1894_1843, 0), BUNSPEC);
							    }
							 }
							 {
							    object_t aux_2985;
							    aux_2985 = (object_t) (new1287_1842);
							    OBJECT_WIDENING_SET(aux_2985, BFALSE);
							 }
							 ((((block_t) CREF(new1287_1842))->body) = ((cop_t) body_1841), BUNSPEC);
							 res1995_1847 = new1287_1842;
						      }
						   }
						   return (obj_t) (res1995_1847);
						}
					     }
					  }
					else
					  {
					     {
						csequence_t arg1506_895;
						{
						   obj_t arg1507_896;
						   {
						      local_var_164_t arg1509_897;
						      csequence_t arg1510_898;
						      obj_t arg1511_899;
						      {
							 obj_t arg1518_904;
							 {
							    obj_t list1519_905;
							    {
							       obj_t arg1520_906;
							       {
								  obj_t aux_2990;
								  aux_2990 = (obj_t) (vaux_848);
								  arg1520_906 = MAKE_PAIR(aux_2990, BNIL);
							       }
							       {
								  obj_t aux_2993;
								  aux_2993 = (obj_t) (faux_851);
								  list1519_905 = MAKE_PAIR(aux_2993, arg1520_906);
							       }
							    }
							    arg1518_904 = list1519_905;
							 }
							 {
							    local_var_164_t res1996_1855;
							    {
							       local_var_164_t new1342_1850;
							       new1342_1850 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							       {
								  long arg1863_1851;
								  arg1863_1851 = class_num_218___object(local_var_164_cgen_cop);
								  {
								     obj_t obj_1853;
								     obj_1853 = (obj_t) (new1342_1850);
								     (((obj_t) CREF(obj_1853))->header = MAKE_HEADER(arg1863_1851, 0), BUNSPEC);
								  }
							       }
							       {
								  object_t aux_3000;
								  aux_3000 = (object_t) (new1342_1850);
								  OBJECT_WIDENING_SET(aux_3000, BFALSE);
							       }
							       ((((local_var_164_t) CREF(new1342_1850))->vars) = ((obj_t) arg1518_904), BUNSPEC);
							       res1996_1855 = new1342_1850;
							    }
							    arg1509_897 = res1996_1855;
							 }
						      }
						      {
							 obj_t arg1523_908;
							 {
							    obj_t list1524_909;
							    {
							       obj_t arg1526_910;
							       {
								  obj_t aux_3004;
								  aux_3004 = (obj_t) (vcop_849);
								  arg1526_910 = MAKE_PAIR(aux_3004, BNIL);
							       }
							       {
								  obj_t aux_3007;
								  aux_3007 = (obj_t) (fcop_852);
								  list1524_909 = MAKE_PAIR(aux_3007, arg1526_910);
							       }
							    }
							    arg1523_908 = list1524_909;
							 }
							 {
							    csequence_t res1997_1865;
							    {
							       csequence_t new1317_1859;
							       new1317_1859 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
							       {
								  long arg1879_1860;
								  arg1879_1860 = class_num_218___object(csequence_cgen_cop);
								  {
								     obj_t obj_1863;
								     obj_1863 = (obj_t) (new1317_1859);
								     (((obj_t) CREF(obj_1863))->header = MAKE_HEADER(arg1879_1860, 0), BUNSPEC);
								  }
							       }
							       {
								  object_t aux_3014;
								  aux_3014 = (object_t) (new1317_1859);
								  OBJECT_WIDENING_SET(aux_3014, BFALSE);
							       }
							       ((((csequence_t) CREF(new1317_1859))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							       ((((csequence_t) CREF(new1317_1859))->cops) = ((obj_t) arg1523_908), BUNSPEC);
							       res1997_1865 = new1317_1859;
							    }
							    arg1510_898 = res1997_1865;
							 }
						      }
						      {
							 capply_t arg1531_912;
							 {
							    varc_t arg1532_913;
							    varc_t arg1534_914;
							    {
							       varc_t res1998_1872;
							       {
								  variable_t variable_1866;
								  variable_1866 = (variable_t) (faux_851);
								  {
								     varc_t new1305_1867;
								     new1305_1867 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
								     {
									long arg1885_1868;
									arg1885_1868 = class_num_218___object(varc_cgen_cop);
									{
									   obj_t obj_1870;
									   obj_1870 = (obj_t) (new1305_1867);
									   (((obj_t) CREF(obj_1870))->header = MAKE_HEADER(arg1885_1868, 0), BUNSPEC);
									}
								     }
								     {
									object_t aux_3024;
									aux_3024 = (object_t) (new1305_1867);
									OBJECT_WIDENING_SET(aux_3024, BFALSE);
								     }
								     ((((varc_t) CREF(new1305_1867))->variable) = ((variable_t) variable_1866), BUNSPEC);
								     res1998_1872 = new1305_1867;
								  }
							       }
							       arg1532_913 = res1998_1872;
							    }
							    {
							       varc_t res1999_1879;
							       {
								  variable_t variable_1873;
								  variable_1873 = (variable_t) (vaux_848);
								  {
								     varc_t new1305_1874;
								     new1305_1874 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
								     {
									long arg1885_1875;
									arg1885_1875 = class_num_218___object(varc_cgen_cop);
									{
									   obj_t obj_1877;
									   obj_1877 = (obj_t) (new1305_1874);
									   (((obj_t) CREF(obj_1877))->header = MAKE_HEADER(arg1885_1875, 0), BUNSPEC);
									}
								     }
								     {
									object_t aux_3033;
									aux_3033 = (object_t) (new1305_1874);
									OBJECT_WIDENING_SET(aux_3033, BFALSE);
								     }
								     ((((varc_t) CREF(new1305_1874))->variable) = ((variable_t) variable_1873), BUNSPEC);
								     res1999_1879 = new1305_1874;
								  }
							       }
							       arg1534_914 = res1999_1879;
							    }
							    {
							       capply_t res2000_1888;
							       {
								  cop_t fun_1880;
								  cop_t arg_1881;
								  fun_1880 = (cop_t) (arg1532_913);
								  arg_1881 = (cop_t) (arg1534_914);
								  {
								     capply_t new1350_1882;
								     new1350_1882 = ((capply_t) BREF(GC_MALLOC(sizeof(struct capply))));
								     {
									long arg1859_1883;
									arg1859_1883 = class_num_218___object(capply_cgen_cop);
									{
									   obj_t obj_1886;
									   obj_1886 = (obj_t) (new1350_1882);
									   (((obj_t) CREF(obj_1886))->header = MAKE_HEADER(arg1859_1883, 0), BUNSPEC);
									}
								     }
								     {
									object_t aux_3043;
									aux_3043 = (object_t) (new1350_1882);
									OBJECT_WIDENING_SET(aux_3043, BFALSE);
								     }
								     ((((capply_t) CREF(new1350_1882))->fun) = ((cop_t) fun_1880), BUNSPEC);
								     ((((capply_t) CREF(new1350_1882))->arg) = ((cop_t) arg_1881), BUNSPEC);
								     res2000_1888 = new1350_1882;
								  }
							       }
							       arg1531_912 = res2000_1888;
							    }
							 }
							 arg1511_899 = PROCEDURE_ENTRY(kont_830) (kont_830, (obj_t) (arg1531_912), BEOA);
						      }
						      {
							 obj_t list1512_900;
							 {
							    obj_t arg1513_901;
							    {
							       obj_t arg1514_902;
							       arg1514_902 = MAKE_PAIR(arg1511_899, BNIL);
							       {
								  obj_t aux_3052;
								  aux_3052 = (obj_t) (arg1510_898);
								  arg1513_901 = MAKE_PAIR(aux_3052, arg1514_902);
							       }
							    }
							    {
							       obj_t aux_3055;
							       aux_3055 = (obj_t) (arg1509_897);
							       list1512_900 = MAKE_PAIR(aux_3055, arg1513_901);
							    }
							 }
							 arg1507_896 = list1512_900;
						      }
						   }
						   {
						      csequence_t res2001_1898;
						      {
							 csequence_t new1317_1892;
							 new1317_1892 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
							 {
							    long arg1879_1893;
							    arg1879_1893 = class_num_218___object(csequence_cgen_cop);
							    {
							       obj_t obj_1896;
							       obj_1896 = (obj_t) (new1317_1892);
							       (((obj_t) CREF(obj_1896))->header = MAKE_HEADER(arg1879_1893, 0), BUNSPEC);
							    }
							 }
							 {
							    object_t aux_3062;
							    aux_3062 = (object_t) (new1317_1892);
							    OBJECT_WIDENING_SET(aux_3062, BFALSE);
							 }
							 ((((csequence_t) CREF(new1317_1892))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							 ((((csequence_t) CREF(new1317_1892))->cops) = ((obj_t) arg1507_896), BUNSPEC);
							 res2001_1898 = new1317_1892;
						      }
						      arg1506_895 = res2001_1898;
						   }
						}
						{
						   block_t res2002_1905;
						   {
						      cop_t body_1899;
						      body_1899 = (cop_t) (arg1506_895);
						      {
							 block_t new1287_1900;
							 new1287_1900 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
							 {
							    long arg1894_1901;
							    arg1894_1901 = class_num_218___object(block_cgen_cop);
							    {
							       obj_t obj_1903;
							       obj_1903 = (obj_t) (new1287_1900);
							       (((obj_t) CREF(obj_1903))->header = MAKE_HEADER(arg1894_1901, 0), BUNSPEC);
							    }
							 }
							 {
							    object_t aux_3072;
							    aux_3072 = (object_t) (new1287_1900);
							    OBJECT_WIDENING_SET(aux_3072, BFALSE);
							 }
							 ((((block_t) CREF(new1287_1900))->body) = ((cop_t) body_1899), BUNSPEC);
							 res2002_1905 = new1287_1900;
						      }
						   }
						   return (obj_t) (res2002_1905);
						}
					     }
					  }
				     }
				}
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
node_non_tail_app__cop_76_cgen_capp(variable_t var_7, app_t node_8, obj_t kont_9)
{
   {
      bool_t test1676_1055;
      {
	 obj_t aux_3078;
	 aux_3078 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1676_1055 = CBOOL(aux_3078);
      }
      if (test1676_1055)
	{
	   obj_t arg1678_1057;
	   obj_t arg1680_1059;
	   arg1678_1057 = shape_tools_shape((obj_t) (var_7));
	   arg1680_1059 = shape_tools_shape((obj_t) (node_8));
	   {
	      obj_t list1683_1062;
	      {
		 obj_t arg1684_1063;
		 {
		    obj_t arg1686_1064;
		    {
		       obj_t arg1687_1065;
		       {
			  obj_t arg1688_1066;
			  {
			     obj_t arg1689_1067;
			     {
				obj_t arg1690_1068;
				{
				   obj_t arg1691_1069;
				   {
				      obj_t aux_3088;
				      aux_3088 = BCHAR(((unsigned char) '\n'));
				      arg1691_1069 = MAKE_PAIR(aux_3088, BNIL);
				   }
				   arg1690_1068 = MAKE_PAIR(kont_9, arg1691_1069);
				}
				arg1689_1067 = MAKE_PAIR(string2051_cgen_capp, arg1690_1068);
			     }
			     arg1688_1066 = MAKE_PAIR(string2052_cgen_capp, arg1689_1067);
			  }
			  arg1687_1065 = MAKE_PAIR(arg1680_1059, arg1688_1066);
		       }
		       arg1686_1064 = MAKE_PAIR(string2052_cgen_capp, arg1687_1065);
		    }
		    arg1684_1063 = MAKE_PAIR(arg1678_1057, arg1686_1064);
		 }
		 list1683_1062 = MAKE_PAIR(string2053_cgen_capp, arg1684_1063);
	      }
	      print_trace_107_tools_trace(list1683_1062);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test1696_1073;
      {
	 obj_t aux_3099;
	 {
	    value_t aux_3100;
	    aux_3100 = (((variable_t) CREF(var_7))->value);
	    aux_3099 = (obj_t) (aux_3100);
	 }
	 test1696_1073 = is_a__118___object(aux_3099, sfun_ast_var);
      }
      if (test1696_1073)
	{
	   return node_sfun_non_tail_app__cop_176_cgen_capp(var_7, node_8, kont_9);
	}
      else
	{
	   return node_cfun_non_tail_app__cop_38_cgen_capp(var_7, node_8, kont_9);
	}
   }
}


obj_t 
node_sfun_non_tail_app__cop_176_cgen_capp(variable_t var_10, app_t node_11, obj_t kont_12)
{
   {
      obj_t args_1075;
      {
	 sfun_t obj_2065;
	 {
	    value_t aux_3107;
	    aux_3107 = (((variable_t) CREF(var_10))->value);
	    obj_2065 = (sfun_t) (aux_3107);
	 }
	 args_1075 = (((sfun_t) CREF(obj_2065))->args);
      }
      {
	 obj_t args_type_205_1076;
	 {
	    bool_t test1702_1085;
	    test1702_1085 = NULLP(args_1075);
	    if (test1702_1085)
	      {
		 args_type_205_1076 = BNIL;
	      }
	    else
	      {
		 bool_t test1703_1086;
		 test1703_1086 = is_a__118___object(CAR(args_1075), local_ast_var);
		 if (test1703_1086)
		   {
		      if (test1702_1085)
			{
			   args_type_205_1076 = BNIL;
			}
		      else
			{
			   obj_t head1409_1089;
			   {
			      obj_t aux_3117;
			      {
				 type_t aux_3118;
				 {
				    local_t obj_2071;
				    {
				       obj_t aux_3119;
				       aux_3119 = CAR(args_1075);
				       obj_2071 = (local_t) (aux_3119);
				    }
				    aux_3118 = (((local_t) CREF(obj_2071))->type);
				 }
				 aux_3117 = (obj_t) (aux_3118);
			      }
			      head1409_1089 = MAKE_PAIR(aux_3117, BNIL);
			   }
			   {
			      obj_t l1407_1090;
			      obj_t tail1410_1091;
			      l1407_1090 = CDR(args_1075);
			      tail1410_1091 = head1409_1089;
			    lname1408_1092:
			      if (NULLP(l1407_1090))
				{
				   args_type_205_1076 = head1409_1089;
				}
			      else
				{
				   obj_t new_tail1411_123_1095;
				   {
				      obj_t aux_3127;
				      {
					 type_t aux_3128;
					 {
					    local_t obj_2077;
					    {
					       obj_t aux_3129;
					       aux_3129 = CAR(l1407_1090);
					       obj_2077 = (local_t) (aux_3129);
					    }
					    aux_3128 = (((local_t) CREF(obj_2077))->type);
					 }
					 aux_3127 = (obj_t) (aux_3128);
				      }
				      new_tail1411_123_1095 = MAKE_PAIR(aux_3127, BNIL);
				   }
				   SET_CDR(tail1410_1091, new_tail1411_123_1095);
				   {
				      obj_t tail1410_3138;
				      obj_t l1407_3136;
				      l1407_3136 = CDR(l1407_1090);
				      tail1410_3138 = new_tail1411_123_1095;
				      tail1410_1091 = tail1410_3138;
				      l1407_1090 = l1407_3136;
				      goto lname1408_1092;
				   }
				}
			   }
			}
		   }
		 else
		   {
		      args_type_205_1076 = args_1075;
		   }
	      }
	 }
	 {
	    obj_t useless__199_2398;
	    useless__199_2398 = proc2054_cgen_capp;
	    {
	       return node_sfun_cfun_non_tail_app__cop_160_cgen_capp(var_10, node_11, kont_12, args_type_205_1076, useless__199_2398);
	    }
	 }
      }
   }
}


obj_t 
useless_2042_202_cgen_capp(obj_t env_2399, obj_t cop_2400, obj_t aux_2401)
{
   {
      obj_t cop_1078;
      obj_t aux_1079;
      {
	 bool_t aux_3141;
	 cop_1078 = cop_2400;
	 aux_1079 = aux_2401;
	 {
	    bool_t _andtest_1412_1081;
	    _andtest_1412_1081 = is_a__118___object(cop_1078, csetq_cgen_cop);
	    if (_andtest_1412_1081)
	      {
		 obj_t aux_3144;
		 {
		    variable_t aux_3145;
		    {
		       varc_t arg1701_1083;
		       {
			  csetq_t obj_2084;
			  obj_2084 = (csetq_t) (cop_1078);
			  arg1701_1083 = (((csetq_t) CREF(obj_2084))->var);
		       }
		       aux_3145 = (((varc_t) CREF(arg1701_1083))->variable);
		    }
		    aux_3144 = (obj_t) (aux_3145);
		 }
		 aux_3141 = (aux_3144 == aux_1079);
	      }
	    else
	      {
		 aux_3141 = ((bool_t) 0);
	      }
	 }
	 return BBOOL(aux_3141);
      }
   }
}


obj_t 
node_cfun_non_tail_app__cop_38_cgen_capp(variable_t var_13, app_t node_14, obj_t kont_15)
{
   {
      obj_t args_type_205_1105;
      {
	 cfun_t obj_2089;
	 {
	    value_t aux_3152;
	    aux_3152 = (((variable_t) CREF(var_13))->value);
	    obj_2089 = (cfun_t) (aux_3152);
	 }
	 args_type_205_1105 = (((cfun_t) CREF(obj_2089))->args_type_205);
      }
      {
	 obj_t useless__199_2402;
	 useless__199_2402 = proc2055_cgen_capp;
	 return node_sfun_cfun_non_tail_app__cop_160_cgen_capp(var_13, node_14, kont_15, args_type_205_1105, useless__199_2402);
      }
   }
}


obj_t 
useless_2043_217_cgen_capp(obj_t env_2403, obj_t cop_2404, obj_t aux_2405)
{
   {
      obj_t cop_1108;
      obj_t aux_1109;
      {
	 bool_t aux_3157;
	 cop_1108 = cop_2404;
	 aux_1109 = aux_2405;
	 {
	    bool_t _andtest_1413_1111;
	    _andtest_1413_1111 = is_a__118___object(cop_1108, csetq_cgen_cop);
	    if (_andtest_1413_1111)
	      {
		 bool_t test_3160;
		 {
		    obj_t aux_3161;
		    {
		       variable_t aux_3162;
		       {
			  varc_t arg1722_1117;
			  {
			     csetq_t obj_2091;
			     obj_2091 = (csetq_t) (cop_1108);
			     arg1722_1117 = (((csetq_t) CREF(obj_2091))->var);
			  }
			  aux_3162 = (((varc_t) CREF(arg1722_1117))->variable);
		       }
		       aux_3161 = (obj_t) (aux_3162);
		    }
		    test_3160 = (aux_3161 == aux_1109);
		 }
		 if (test_3160)
		   {
		      bool_t _ortest_1415_1113;
		      {
			 obj_t aux_3168;
			 {
			    cop_t aux_3169;
			    {
			       csetq_t obj_2095;
			       obj_2095 = (csetq_t) (cop_1108);
			       aux_3169 = (((csetq_t) CREF(obj_2095))->value);
			    }
			    aux_3168 = (obj_t) (aux_3169);
			 }
			 _ortest_1415_1113 = is_a__118___object(aux_3168, catom_cgen_cop);
		      }
		      if (_ortest_1415_1113)
			{
			   aux_3157 = _ortest_1415_1113;
			}
		      else
			{
			   obj_t aux_3175;
			   {
			      cop_t aux_3176;
			      {
				 csetq_t obj_2097;
				 obj_2097 = (csetq_t) (cop_1108);
				 aux_3176 = (((csetq_t) CREF(obj_2097))->value);
			      }
			      aux_3175 = (obj_t) (aux_3176);
			   }
			   aux_3157 = is_a__118___object(aux_3175, varc_cgen_cop);
			}
		   }
		 else
		   {
		      aux_3157 = ((bool_t) 0);
		   }
	      }
	    else
	      {
		 aux_3157 = ((bool_t) 0);
	      }
	 }
	 return BBOOL(aux_3157);
      }
   }
}


obj_t 
node_sfun_cfun_non_tail_app__cop_160_cgen_capp(variable_t var_16, app_t node_17, obj_t kont_18, obj_t args_type_205_19, obj_t useless__199_20)
{
   {
      obj_t old_actuals_174_1119;
      obj_t args_type_205_1120;
      obj_t new_actuals_73_1121;
      local_t aux_1122;
      obj_t auxs_1123;
      obj_t exps_1124;
      {
	 obj_t arg1724_1126;
	 local_t arg1730_1128;
	 arg1724_1126 = (((app_t) CREF(node_17))->args);
	 arg1730_1128 = make_local_svar_name_219_cgen_cgen(CNST_TABLE_REF(((long) 1)), (type_t) (__obj__252_type_cache));
	 old_actuals_174_1119 = arg1724_1126;
	 args_type_205_1120 = args_type_205_19;
	 new_actuals_73_1121 = BNIL;
	 aux_1122 = arg1730_1128;
	 auxs_1123 = BNIL;
	 exps_1124 = BNIL;
       loop_1125:
	 if (NULLP(old_actuals_174_1119))
	   {
	      if (NULLP(auxs_1123))
		{
		   capp_t arg1736_1134;
		   {
		      cop_t arg1737_1135;
		      obj_t arg1738_1136;
		      {
			 node_t aux_3190;
			 {
			    var_t aux_3191;
			    aux_3191 = (((app_t) CREF(node_17))->fun);
			    aux_3190 = (node_t) (aux_3191);
			 }
			 arg1737_1135 = node__cop_142_cgen_cgen(aux_3190, __id_kont__126_cgen_cgen);
		      }
		      arg1738_1136 = reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_1121);
		      {
			 capp_t res2016_2111;
			 {
			    capp_t new1354_2105;
			    new1354_2105 = ((capp_t) BREF(GC_MALLOC(sizeof(struct capp))));
			    {
			       long arg1857_2106;
			       arg1857_2106 = class_num_218___object(capp_cgen_cop);
			       {
				  obj_t obj_2109;
				  obj_2109 = (obj_t) (new1354_2105);
				  (((obj_t) CREF(obj_2109))->header = MAKE_HEADER(arg1857_2106, 0), BUNSPEC);
			       }
			    }
			    {
			       object_t aux_3200;
			       aux_3200 = (object_t) (new1354_2105);
			       OBJECT_WIDENING_SET(aux_3200, BFALSE);
			    }
			    ((((capp_t) CREF(new1354_2105))->fun) = ((cop_t) arg1737_1135), BUNSPEC);
			    ((((capp_t) CREF(new1354_2105))->args) = ((obj_t) arg1738_1136), BUNSPEC);
			    res2016_2111 = new1354_2105;
			 }
			 arg1736_1134 = res2016_2111;
		      }
		   }
		   return PROCEDURE_ENTRY(kont_18) (kont_18, (obj_t) (arg1736_1134), BEOA);
		}
	      else
		{
		   csequence_t arg1741_1138;
		   {
		      obj_t arg1742_1139;
		      {
			 local_var_164_t arg1743_1140;
			 csequence_t arg1745_1141;
			 obj_t arg1746_1142;
			 {
			    local_var_164_t res2017_2118;
			    {
			       local_var_164_t new1342_2113;
			       new1342_2113 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
			       {
				  long arg1863_2114;
				  arg1863_2114 = class_num_218___object(local_var_164_cgen_cop);
				  {
				     obj_t obj_2116;
				     obj_2116 = (obj_t) (new1342_2113);
				     (((obj_t) CREF(obj_2116))->header = MAKE_HEADER(arg1863_2114, 0), BUNSPEC);
				  }
			       }
			       {
				  object_t aux_3212;
				  aux_3212 = (object_t) (new1342_2113);
				  OBJECT_WIDENING_SET(aux_3212, BFALSE);
			       }
			       ((((local_var_164_t) CREF(new1342_2113))->vars) = ((obj_t) auxs_1123), BUNSPEC);
			       res2017_2118 = new1342_2113;
			    }
			    arg1743_1140 = res2017_2118;
			 }
			 {
			    csequence_t res2018_2127;
			    {
			       csequence_t new1317_2121;
			       new1317_2121 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
			       {
				  long arg1879_2122;
				  arg1879_2122 = class_num_218___object(csequence_cgen_cop);
				  {
				     obj_t obj_2125;
				     obj_2125 = (obj_t) (new1317_2121);
				     (((obj_t) CREF(obj_2125))->header = MAKE_HEADER(arg1879_2122, 0), BUNSPEC);
				  }
			       }
			       {
				  object_t aux_3220;
				  aux_3220 = (object_t) (new1317_2121);
				  OBJECT_WIDENING_SET(aux_3220, BFALSE);
			       }
			       ((((csequence_t) CREF(new1317_2121))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			       ((((csequence_t) CREF(new1317_2121))->cops) = ((obj_t) exps_1124), BUNSPEC);
			       res2018_2127 = new1317_2121;
			    }
			    arg1745_1141 = res2018_2127;
			 }
			 {
			    capp_t arg1753_1147;
			    {
			       cop_t arg1754_1148;
			       obj_t arg1755_1149;
			       {
				  node_t aux_3225;
				  {
				     var_t aux_3226;
				     aux_3226 = (((app_t) CREF(node_17))->fun);
				     aux_3225 = (node_t) (aux_3226);
				  }
				  arg1754_1148 = node__cop_142_cgen_cgen(aux_3225, __id_kont__126_cgen_cgen);
			       }
			       arg1755_1149 = reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_1121);
			       {
				  capp_t res2019_2137;
				  {
				     capp_t new1354_2131;
				     new1354_2131 = ((capp_t) BREF(GC_MALLOC(sizeof(struct capp))));
				     {
					long arg1857_2132;
					arg1857_2132 = class_num_218___object(capp_cgen_cop);
					{
					   obj_t obj_2135;
					   obj_2135 = (obj_t) (new1354_2131);
					   (((obj_t) CREF(obj_2135))->header = MAKE_HEADER(arg1857_2132, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_3235;
					aux_3235 = (object_t) (new1354_2131);
					OBJECT_WIDENING_SET(aux_3235, BFALSE);
				     }
				     ((((capp_t) CREF(new1354_2131))->fun) = ((cop_t) arg1754_1148), BUNSPEC);
				     ((((capp_t) CREF(new1354_2131))->args) = ((obj_t) arg1755_1149), BUNSPEC);
				     res2019_2137 = new1354_2131;
				  }
				  arg1753_1147 = res2019_2137;
			       }
			    }
			    arg1746_1142 = PROCEDURE_ENTRY(kont_18) (kont_18, (obj_t) (arg1753_1147), BEOA);
			 }
			 {
			    obj_t list1747_1143;
			    {
			       obj_t arg1748_1144;
			       {
				  obj_t arg1749_1145;
				  arg1749_1145 = MAKE_PAIR(arg1746_1142, BNIL);
				  {
				     obj_t aux_3244;
				     aux_3244 = (obj_t) (arg1745_1141);
				     arg1748_1144 = MAKE_PAIR(aux_3244, arg1749_1145);
				  }
			       }
			       {
				  obj_t aux_3247;
				  aux_3247 = (obj_t) (arg1743_1140);
				  list1747_1143 = MAKE_PAIR(aux_3247, arg1748_1144);
			       }
			    }
			    arg1742_1139 = list1747_1143;
			 }
		      }
		      {
			 csequence_t res2020_2147;
			 {
			    csequence_t new1317_2141;
			    new1317_2141 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
			    {
			       long arg1879_2142;
			       arg1879_2142 = class_num_218___object(csequence_cgen_cop);
			       {
				  obj_t obj_2145;
				  obj_2145 = (obj_t) (new1317_2141);
				  (((obj_t) CREF(obj_2145))->header = MAKE_HEADER(arg1879_2142, 0), BUNSPEC);
			       }
			    }
			    {
			       object_t aux_3254;
			       aux_3254 = (object_t) (new1317_2141);
			       OBJECT_WIDENING_SET(aux_3254, BFALSE);
			    }
			    ((((csequence_t) CREF(new1317_2141))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			    ((((csequence_t) CREF(new1317_2141))->cops) = ((obj_t) arg1742_1139), BUNSPEC);
			    res2020_2147 = new1317_2141;
			 }
			 arg1741_1138 = res2020_2147;
		      }
		   }
		   {
		      block_t res2021_2154;
		      {
			 cop_t body_2148;
			 body_2148 = (cop_t) (arg1741_1138);
			 {
			    block_t new1287_2149;
			    new1287_2149 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
			    {
			       long arg1894_2150;
			       arg1894_2150 = class_num_218___object(block_cgen_cop);
			       {
				  obj_t obj_2152;
				  obj_2152 = (obj_t) (new1287_2149);
				  (((obj_t) CREF(obj_2152))->header = MAKE_HEADER(arg1894_2150, 0), BUNSPEC);
			       }
			    }
			    {
			       object_t aux_3264;
			       aux_3264 = (object_t) (new1287_2149);
			       OBJECT_WIDENING_SET(aux_3264, BFALSE);
			    }
			    ((((block_t) CREF(new1287_2149))->body) = ((cop_t) body_2148), BUNSPEC);
			    res2021_2154 = new1287_2149;
			 }
		      }
		      return (obj_t) (res2021_2154);
		   }
		}
	   }
	 else
	   {
	      cop_t cop_1151;
	      {
		 setq_t arg1775_1167;
		 {
		    node_t aux_3269;
		    {
		       obj_t aux_3271;
		       aux_3271 = CAR(old_actuals_174_1119);
		       aux_3269 = (node_t) (aux_3271);
		    }
		    arg1775_1167 = node_setq_243_cgen_cgen((variable_t) (aux_1122), aux_3269);
		 }
		 cop_1151 = node__cop_142_cgen_cgen((node_t) (arg1775_1167), __id_kont__126_cgen_cgen);
	      }
	      {
		 bool_t test1757_1152;
		 {
		    obj_t aux_3277;
		    aux_3277 = PROCEDURE_ENTRY(useless__199_20) (useless__199_20, (obj_t) (cop_1151), (obj_t) (aux_1122), BEOA);
		    test1757_1152 = CBOOL(aux_3277);
		 }
		 if (test1757_1152)
		   {
		      obj_t arg1758_1153;
		      obj_t arg1759_1154;
		      obj_t arg1761_1155;
		      arg1758_1153 = CDR(old_actuals_174_1119);
		      arg1759_1154 = CDR(args_type_205_1120);
		      {
			 obj_t aux_3286;
			 {
			    cop_t aux_3287;
			    {
			       csetq_t obj_2158;
			       obj_2158 = (csetq_t) (cop_1151);
			       aux_3287 = (((csetq_t) CREF(obj_2158))->value);
			    }
			    aux_3286 = (obj_t) (aux_3287);
			 }
			 arg1761_1155 = MAKE_PAIR(aux_3286, new_actuals_73_1121);
		      }
		      {
			 obj_t new_actuals_73_3294;
			 obj_t args_type_205_3293;
			 obj_t old_actuals_174_3292;
			 old_actuals_174_3292 = arg1758_1153;
			 args_type_205_3293 = arg1759_1154;
			 new_actuals_73_3294 = arg1761_1155;
			 new_actuals_73_1121 = new_actuals_73_3294;
			 args_type_205_1120 = args_type_205_3293;
			 old_actuals_174_1119 = old_actuals_174_3292;
			 goto loop_1125;
		      }
		   }
		 else
		   {
		      {
			 obj_t res2022_2164;
			 {
			    type_t val1052_2163;
			    {
			       obj_t aux_3295;
			       aux_3295 = CAR(args_type_205_1120);
			       val1052_2163 = (type_t) (aux_3295);
			    }
			    {
			       obj_t x_2406;
			       x_2406 = ((((local_t) CREF(aux_1122))->type) = ((type_t) val1052_2163), BUNSPEC);
			       res2022_2164 = BUNSPEC;
			    }
			 }
			 res2022_2164;
		      }
		      {
			 obj_t arg1764_1158;
			 obj_t arg1766_1159;
			 obj_t arg1767_1160;
			 local_t arg1769_1161;
			 obj_t arg1770_1162;
			 obj_t arg1771_1163;
			 arg1764_1158 = CDR(old_actuals_174_1119);
			 arg1766_1159 = CDR(args_type_205_1120);
			 {
			    varc_t arg1772_1164;
			    {
			       varc_t res2023_2173;
			       {
				  variable_t variable_2167;
				  variable_2167 = (variable_t) (aux_1122);
				  {
				     varc_t new1305_2168;
				     new1305_2168 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
				     {
					long arg1885_2169;
					arg1885_2169 = class_num_218___object(varc_cgen_cop);
					{
					   obj_t obj_2171;
					   obj_2171 = (obj_t) (new1305_2168);
					   (((obj_t) CREF(obj_2171))->header = MAKE_HEADER(arg1885_2169, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_3306;
					aux_3306 = (object_t) (new1305_2168);
					OBJECT_WIDENING_SET(aux_3306, BFALSE);
				     }
				     ((((varc_t) CREF(new1305_2168))->variable) = ((variable_t) variable_2167), BUNSPEC);
				     res2023_2173 = new1305_2168;
				  }
			       }
			       arg1772_1164 = res2023_2173;
			    }
			    {
			       obj_t aux_3310;
			       aux_3310 = (obj_t) (arg1772_1164);
			       arg1767_1160 = MAKE_PAIR(aux_3310, new_actuals_73_1121);
			    }
			 }
			 {
			    type_t aux_3313;
			    {
			       obj_t aux_3315;
			       aux_3315 = CAR(args_type_205_1120);
			       aux_3313 = (type_t) (aux_3315);
			    }
			    arg1769_1161 = make_local_svar_name_219_cgen_cgen(CNST_TABLE_REF(((long) 1)), aux_3313);
			 }
			 {
			    obj_t aux_3319;
			    aux_3319 = (obj_t) (aux_1122);
			    arg1770_1162 = MAKE_PAIR(aux_3319, auxs_1123);
			 }
			 {
			    obj_t aux_3322;
			    aux_3322 = (obj_t) (cop_1151);
			    arg1771_1163 = MAKE_PAIR(aux_3322, exps_1124);
			 }
			 {
			    obj_t exps_3330;
			    obj_t auxs_3329;
			    local_t aux_3328;
			    obj_t new_actuals_73_3327;
			    obj_t args_type_205_3326;
			    obj_t old_actuals_174_3325;
			    old_actuals_174_3325 = arg1764_1158;
			    args_type_205_3326 = arg1766_1159;
			    new_actuals_73_3327 = arg1767_1160;
			    aux_3328 = arg1769_1161;
			    auxs_3329 = arg1770_1162;
			    exps_3330 = arg1771_1163;
			    exps_1124 = exps_3330;
			    auxs_1123 = auxs_3329;
			    aux_1122 = aux_3328;
			    new_actuals_73_1121 = new_actuals_73_3327;
			    args_type_205_1120 = args_type_205_3326;
			    old_actuals_174_1119 = old_actuals_174_3325;
			    goto loop_1125;
			 }
		      }
		   }
	      }
	   }
      }
   }
}


obj_t 
node_tail_app__cop_48_cgen_capp(variable_t var_21, app_t node_22, obj_t kont_23)
{
   {
      clabel_t label_1169;
      obj_t args_1170;
      {
	 sfun_c_188_t obj_2182;
	 {
	    value_t aux_3331;
	    aux_3331 = (((variable_t) CREF(var_21))->value);
	    obj_2182 = (sfun_c_188_t) (aux_3331);
	 }
	 {
	    obj_t aux_3334;
	    {
	       object_t aux_3335;
	       aux_3335 = (object_t) (obj_2182);
	       aux_3334 = OBJECT_WIDENING(aux_3335);
	    }
	    label_1169 = (((sfun_c_188_t) CREF(aux_3334))->label);
	 }
      }
      {
	 sfun_t obj_2184;
	 {
	    value_t aux_3339;
	    aux_3339 = (((variable_t) CREF(var_21))->value);
	    obj_2184 = (sfun_t) (aux_3339);
	 }
	 args_1170 = (((sfun_t) CREF(obj_2184))->args);
      }
      {
	 bool_t test_3343;
	 {
	    sfun_c_188_t obj_2186;
	    {
	       value_t aux_3344;
	       aux_3344 = (((variable_t) CREF(var_21))->value);
	       obj_2186 = (sfun_c_188_t) (aux_3344);
	    }
	    {
	       obj_t aux_3347;
	       {
		  object_t aux_3348;
		  aux_3348 = (object_t) (obj_2186);
		  aux_3347 = OBJECT_WIDENING(aux_3348);
	       }
	       test_3343 = (((sfun_c_188_t) CREF(aux_3347))->integrated);
	    }
	 }
	 if (test_3343)
	   {
	      if (NULLP(args_1170))
		{
		   {
		      obj_t res2024_2190;
		      {
			 obj_t x_2407;
			 x_2407 = ((((clabel_t) CREF(label_1169))->used__226) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			 res2024_2190 = BUNSPEC;
		      }
		      res2024_2190;
		   }
		   {
		      cgoto_t res2025_2197;
		      {
			 cgoto_t new1283_2192;
			 new1283_2192 = ((cgoto_t) BREF(GC_MALLOC(sizeof(struct cgoto))));
			 {
			    long arg1896_2193;
			    arg1896_2193 = class_num_218___object(cgoto_cgen_cop);
			    {
			       obj_t obj_2195;
			       obj_2195 = (obj_t) (new1283_2192);
			       (((obj_t) CREF(obj_2195))->header = MAKE_HEADER(arg1896_2193, 0), BUNSPEC);
			    }
			 }
			 {
			    object_t aux_3359;
			    aux_3359 = (object_t) (new1283_2192);
			    OBJECT_WIDENING_SET(aux_3359, BFALSE);
			 }
			 ((((cgoto_t) CREF(new1283_2192))->label) = ((clabel_t) label_1169), BUNSPEC);
			 res2025_2197 = new1283_2192;
		      }
		      return (obj_t) (res2025_2197);
		   }
		}
	      else
		{
		   obj_t args_1173;
		   obj_t actuals_1174;
		   obj_t auxs_1175;
		   obj_t seq1_1176;
		   obj_t seq2_1177;
		   {
		      obj_t arg1779_1179;
		      obj_t arg1783_1182;
		      arg1779_1179 = (((app_t) CREF(node_22))->args);
		      {
			 cgoto_t arg1784_1183;
			 {
			    obj_t res2026_2201;
			    {
			       obj_t x_2408;
			       x_2408 = ((((clabel_t) CREF(label_1169))->used__226) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			       res2026_2201 = BUNSPEC;
			    }
			    res2026_2201;
			 }
			 {
			    cgoto_t res2027_2208;
			    {
			       cgoto_t new1283_2203;
			       new1283_2203 = ((cgoto_t) BREF(GC_MALLOC(sizeof(struct cgoto))));
			       {
				  long arg1896_2204;
				  arg1896_2204 = class_num_218___object(cgoto_cgen_cop);
				  {
				     obj_t obj_2206;
				     obj_2206 = (obj_t) (new1283_2203);
				     (((obj_t) CREF(obj_2206))->header = MAKE_HEADER(arg1896_2204, 0), BUNSPEC);
				  }
			       }
			       {
				  object_t aux_3370;
				  aux_3370 = (object_t) (new1283_2203);
				  OBJECT_WIDENING_SET(aux_3370, BFALSE);
			       }
			       ((((cgoto_t) CREF(new1283_2203))->label) = ((clabel_t) label_1169), BUNSPEC);
			       res2027_2208 = new1283_2203;
			    }
			    arg1784_1183 = res2027_2208;
			 }
			 {
			    obj_t list1785_1184;
			    {
			       obj_t aux_3374;
			       aux_3374 = (obj_t) (arg1784_1183);
			       list1785_1184 = MAKE_PAIR(aux_3374, BNIL);
			    }
			    arg1783_1182 = list1785_1184;
			 }
		      }
		      args_1173 = args_1170;
		      actuals_1174 = arg1779_1179;
		      auxs_1175 = BNIL;
		      seq1_1176 = BNIL;
		      seq2_1177 = arg1783_1182;
		    loop_1178:
		      if (NULLP(args_1173))
			{
			   {
			      bool_t test1788_1187;
			      {
				 obj_t obj_2211;
				 obj_2211 = seq1_1176;
				 test1788_1187 = NULLP(obj_2211);
			      }
			      if (test1788_1187)
				{
				   seq1_1176 = seq2_1177;
				}
			      else
				{
				   seq1_1176 = reverse__39___r4_pairs_and_lists_6_3(seq1_1176);
				   {
				      obj_t arg1789_1188;
				      arg1789_1188 = last_pair_93___r4_pairs_and_lists_6_3(seq1_1176);
				      SET_CDR(arg1789_1188, seq2_1177);
				   }
				}
			   }
			   {
			      csequence_t arg1791_1189;
			      {
				 obj_t arg1792_1190;
				 {
				    local_var_164_t arg1793_1191;
				    {
				       local_var_164_t res2028_2220;
				       {
					  local_var_164_t new1342_2215;
					  new1342_2215 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
					  {
					     long arg1863_2216;
					     arg1863_2216 = class_num_218___object(local_var_164_cgen_cop);
					     {
						obj_t obj_2218;
						obj_2218 = (obj_t) (new1342_2215);
						(((obj_t) CREF(obj_2218))->header = MAKE_HEADER(arg1863_2216, 0), BUNSPEC);
					     }
					  }
					  {
					     object_t aux_3388;
					     aux_3388 = (object_t) (new1342_2215);
					     OBJECT_WIDENING_SET(aux_3388, BFALSE);
					  }
					  ((((local_var_164_t) CREF(new1342_2215))->vars) = ((obj_t) auxs_1175), BUNSPEC);
					  res2028_2220 = new1342_2215;
				       }
				       arg1793_1191 = res2028_2220;
				    }
				    {
				       obj_t obj2_2222;
				       obj2_2222 = seq1_1176;
				       {
					  obj_t aux_3392;
					  aux_3392 = (obj_t) (arg1793_1191);
					  arg1792_1190 = MAKE_PAIR(aux_3392, obj2_2222);
				       }
				    }
				 }
				 {
				    csequence_t res2029_2231;
				    {
				       csequence_t new1317_2225;
				       new1317_2225 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
				       {
					  long arg1879_2226;
					  arg1879_2226 = class_num_218___object(csequence_cgen_cop);
					  {
					     obj_t obj_2229;
					     obj_2229 = (obj_t) (new1317_2225);
					     (((obj_t) CREF(obj_2229))->header = MAKE_HEADER(arg1879_2226, 0), BUNSPEC);
					  }
				       }
				       {
					  object_t aux_3399;
					  aux_3399 = (object_t) (new1317_2225);
					  OBJECT_WIDENING_SET(aux_3399, BFALSE);
				       }
				       ((((csequence_t) CREF(new1317_2225))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				       ((((csequence_t) CREF(new1317_2225))->cops) = ((obj_t) arg1792_1190), BUNSPEC);
				       res2029_2231 = new1317_2225;
				    }
				    arg1791_1189 = res2029_2231;
				 }
			      }
			      return PROCEDURE_ENTRY(__block_kont__38_cgen_cgen) (__block_kont__38_cgen_cgen, (obj_t) (arg1791_1189), BEOA);
			   }
			}
		      else
			{
			   obj_t arg_1192;
			   obj_t act_1193;
			   arg_1192 = CAR(args_1173);
			   act_1193 = CAR(actuals_1174);
			   {
			      bool_t test1794_1194;
			      {
				 bool_t test1812_1211;
				 test1812_1211 = is_a__118___object(act_1193, var_ast_node);
				 if (test1812_1211)
				   {
				      obj_t aux_3411;
				      {
					 variable_t aux_3412;
					 {
					    var_t obj_2235;
					    obj_2235 = (var_t) (act_1193);
					    aux_3412 = (((var_t) CREF(obj_2235))->variable);
					 }
					 aux_3411 = (obj_t) (aux_3412);
				      }
				      test1794_1194 = (arg_1192 == aux_3411);
				   }
				 else
				   {
				      test1794_1194 = ((bool_t) 0);
				   }
			      }
			      if (test1794_1194)
				{
				   obj_t actuals_3420;
				   obj_t args_3418;
				   args_3418 = CDR(args_1173);
				   actuals_3420 = CDR(actuals_1174);
				   actuals_1174 = actuals_3420;
				   args_1173 = args_3418;
				   goto loop_1178;
				}
			      else
				{
				   local_t aux_1197;
				   {
				      type_t aux_3425;
				      obj_t aux_3422;
				      {
					 local_t obj_2241;
					 obj_2241 = (local_t) (arg_1192);
					 aux_3425 = (((local_t) CREF(obj_2241))->type);
				      }
				      {
					 local_t obj_2240;
					 obj_2240 = (local_t) (arg_1192);
					 aux_3422 = (((local_t) CREF(obj_2240))->id);
				      }
				      aux_1197 = make_local_svar_name_219_cgen_cgen(aux_3422, aux_3425);
				   }
				   {
				      obj_t arg1798_1198;
				      obj_t arg1799_1199;
				      obj_t arg1800_1200;
				      obj_t arg1801_1201;
				      obj_t arg1802_1202;
				      arg1798_1198 = CDR(args_1173);
				      arg1799_1199 = CDR(actuals_1174);
				      {
					 obj_t aux_3431;
					 aux_3431 = (obj_t) (aux_1197);
					 arg1800_1200 = MAKE_PAIR(aux_3431, auxs_1175);
				      }
				      {
					 cop_t arg1804_1203;
					 {
					    setq_t arg1805_1204;
					    arg1805_1204 = node_setq_243_cgen_cgen((variable_t) (aux_1197), (node_t) (act_1193));
					    arg1804_1203 = node__cop_142_cgen_cgen((node_t) (arg1805_1204), __stop_kont__121_cgen_cgen);
					 }
					 {
					    obj_t obj2_2247;
					    obj2_2247 = seq1_1176;
					    {
					       obj_t aux_3439;
					       aux_3439 = (obj_t) (arg1804_1203);
					       arg1801_1201 = MAKE_PAIR(aux_3439, obj2_2247);
					    }
					 }
				      }
				      {
					 stop_t arg1806_1205;
					 {
					    csetq_t arg1807_1206;
					    {
					       varc_t arg1808_1207;
					       varc_t arg1809_1208;
					       {
						  varc_t res2030_2254;
						  {
						     variable_t variable_2248;
						     variable_2248 = (variable_t) (arg_1192);
						     {
							varc_t new1305_2249;
							new1305_2249 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
							{
							   long arg1885_2250;
							   arg1885_2250 = class_num_218___object(varc_cgen_cop);
							   {
							      obj_t obj_2252;
							      obj_2252 = (obj_t) (new1305_2249);
							      (((obj_t) CREF(obj_2252))->header = MAKE_HEADER(arg1885_2250, 0), BUNSPEC);
							   }
							}
							{
							   object_t aux_3447;
							   aux_3447 = (object_t) (new1305_2249);
							   OBJECT_WIDENING_SET(aux_3447, BFALSE);
							}
							((((varc_t) CREF(new1305_2249))->variable) = ((variable_t) variable_2248), BUNSPEC);
							res2030_2254 = new1305_2249;
						     }
						  }
						  arg1808_1207 = res2030_2254;
					       }
					       {
						  varc_t res2031_2261;
						  {
						     variable_t variable_2255;
						     variable_2255 = (variable_t) (aux_1197);
						     {
							varc_t new1305_2256;
							new1305_2256 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
							{
							   long arg1885_2257;
							   arg1885_2257 = class_num_218___object(varc_cgen_cop);
							   {
							      obj_t obj_2259;
							      obj_2259 = (obj_t) (new1305_2256);
							      (((obj_t) CREF(obj_2259))->header = MAKE_HEADER(arg1885_2257, 0), BUNSPEC);
							   }
							}
							{
							   object_t aux_3456;
							   aux_3456 = (object_t) (new1305_2256);
							   OBJECT_WIDENING_SET(aux_3456, BFALSE);
							}
							((((varc_t) CREF(new1305_2256))->variable) = ((variable_t) variable_2255), BUNSPEC);
							res2031_2261 = new1305_2256;
						     }
						  }
						  arg1809_1208 = res2031_2261;
					       }
					       {
						  csetq_t res2032_2270;
						  {
						     cop_t value_2263;
						     value_2263 = (cop_t) (arg1809_1208);
						     {
							csetq_t new1330_2264;
							new1330_2264 = ((csetq_t) BREF(GC_MALLOC(sizeof(struct csetq))));
							{
							   long arg1871_2265;
							   arg1871_2265 = class_num_218___object(csetq_cgen_cop);
							   {
							      obj_t obj_2268;
							      obj_2268 = (obj_t) (new1330_2264);
							      (((obj_t) CREF(obj_2268))->header = MAKE_HEADER(arg1871_2265, 0), BUNSPEC);
							   }
							}
							{
							   object_t aux_3465;
							   aux_3465 = (object_t) (new1330_2264);
							   OBJECT_WIDENING_SET(aux_3465, BFALSE);
							}
							((((csetq_t) CREF(new1330_2264))->var) = ((varc_t) arg1808_1207), BUNSPEC);
							((((csetq_t) CREF(new1330_2264))->value) = ((cop_t) value_2263), BUNSPEC);
							res2032_2270 = new1330_2264;
						     }
						  }
						  arg1807_1206 = res2032_2270;
					       }
					    }
					    {
					       stop_t res2033_2277;
					       {
						  cop_t value_2271;
						  value_2271 = (cop_t) (arg1807_1206);
						  {
						     stop_t new1326_2272;
						     new1326_2272 = ((stop_t) BREF(GC_MALLOC(sizeof(struct stop))));
						     {
							long arg1874_2273;
							arg1874_2273 = class_num_218___object(stop_cgen_cop);
							{
							   obj_t obj_2275;
							   obj_2275 = (obj_t) (new1326_2272);
							   (((obj_t) CREF(obj_2275))->header = MAKE_HEADER(arg1874_2273, 0), BUNSPEC);
							}
						     }
						     {
							object_t aux_3475;
							aux_3475 = (object_t) (new1326_2272);
							OBJECT_WIDENING_SET(aux_3475, BFALSE);
						     }
						     ((((stop_t) CREF(new1326_2272))->value) = ((cop_t) value_2271), BUNSPEC);
						     res2033_2277 = new1326_2272;
						  }
					       }
					       arg1806_1205 = res2033_2277;
					    }
					 }
					 {
					    obj_t aux_3479;
					    aux_3479 = (obj_t) (arg1806_1205);
					    arg1802_1202 = MAKE_PAIR(aux_3479, seq2_1177);
					 }
				      }
				      {
					 obj_t seq2_3486;
					 obj_t seq1_3485;
					 obj_t auxs_3484;
					 obj_t actuals_3483;
					 obj_t args_3482;
					 args_3482 = arg1798_1198;
					 actuals_3483 = arg1799_1199;
					 auxs_3484 = arg1800_1200;
					 seq1_3485 = arg1801_1201;
					 seq2_3486 = arg1802_1202;
					 seq2_1177 = seq2_3486;
					 seq1_1176 = seq1_3485;
					 auxs_1175 = auxs_3484;
					 actuals_1174 = actuals_3483;
					 args_1173 = args_3482;
					 goto loop_1178;
				      }
				   }
				}
			   }
			}
		   }
		}
	   }
	 else
	   {
	      {
		 obj_t res2034_2283;
		 {
		    sfun_c_188_t obj_2281;
		    {
		       value_t aux_3487;
		       aux_3487 = (((variable_t) CREF(var_21))->value);
		       obj_2281 = (sfun_c_188_t) (aux_3487);
		    }
		    {
		       obj_t x_2409;
		       {
			  obj_t aux_3490;
			  {
			     object_t aux_3491;
			     aux_3491 = (object_t) (obj_2281);
			     aux_3490 = OBJECT_WIDENING(aux_3491);
			  }
			  x_2409 = ((((sfun_c_188_t) CREF(aux_3490))->integrated) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		       }
		       res2034_2283 = BUNSPEC;
		    }
		 }
		 res2034_2283;
	      }
	      {
		 cop_t body_1214;
		 {
		    node_t aux_3495;
		    {
		       obj_t aux_3496;
		       {
			  sfun_t obj_2285;
			  {
			     value_t aux_3497;
			     {
				local_t obj_2284;
				obj_2284 = (local_t) (var_21);
				aux_3497 = (((local_t) CREF(obj_2284))->value);
			     }
			     obj_2285 = (sfun_t) (aux_3497);
			  }
			  aux_3496 = (((sfun_t) CREF(obj_2285))->body);
		       }
		       aux_3495 = (node_t) (aux_3496);
		    }
		    body_1214 = node__cop_142_cgen_cgen(aux_3495, kont_23);
		 }
		 {
		    obj_t res2035_2288;
		    {
		       obj_t val1280_2287;
		       val1280_2287 = (obj_t) (body_1214);
		       {
			  obj_t x_2410;
			  x_2410 = ((((clabel_t) CREF(label_1169))->body) = ((obj_t) val1280_2287), BUNSPEC);
			  res2035_2288 = BUNSPEC;
		       }
		    }
		    res2035_2288;
		 }
		 if (NULLP(args_1170))
		   {
		      return (obj_t) (label_1169);
		   }
		 else
		   {
		      obj_t formals_1216;
		      obj_t actuals_1217;
		      obj_t seq_1218;
		      {
			 csequence_t aux_3509;
			 formals_1216 = args_1170;
			 actuals_1217 = (((app_t) CREF(node_22))->args);
			 seq_1218 = BNIL;
		       loop_1219:
			 if (NULLP(formals_1216))
			   {
			      obj_t arg1822_1223;
			      {
				 obj_t arg1823_1224;
				 {
				    obj_t aux_3512;
				    aux_3512 = (obj_t) (label_1169);
				    arg1823_1224 = MAKE_PAIR(aux_3512, seq_1218);
				 }
				 arg1822_1223 = reverse__39___r4_pairs_and_lists_6_3(arg1823_1224);
			      }
			      {
				 csequence_t res2036_2302;
				 {
				    csequence_t new1317_2296;
				    new1317_2296 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
				    {
				       long arg1879_2297;
				       arg1879_2297 = class_num_218___object(csequence_cgen_cop);
				       {
					  obj_t obj_2300;
					  obj_2300 = (obj_t) (new1317_2296);
					  (((obj_t) CREF(obj_2300))->header = MAKE_HEADER(arg1879_2297, 0), BUNSPEC);
				       }
				    }
				    {
				       object_t aux_3520;
				       aux_3520 = (object_t) (new1317_2296);
				       OBJECT_WIDENING_SET(aux_3520, BFALSE);
				    }
				    ((((csequence_t) CREF(new1317_2296))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				    ((((csequence_t) CREF(new1317_2296))->cops) = ((obj_t) arg1822_1223), BUNSPEC);
				    res2036_2302 = new1317_2296;
				 }
				 aux_3509 = res2036_2302;
			      }
			   }
			 else
			   {
			      obj_t arg1824_1225;
			      obj_t arg1825_1226;
			      obj_t arg1826_1227;
			      arg1824_1225 = CDR(formals_1216);
			      arg1825_1226 = CDR(actuals_1217);
			      {
				 cop_t arg1827_1228;
				 {
				    setq_t arg1828_1229;
				    {
				       node_t aux_3531;
				       variable_t aux_3527;
				       {
					  obj_t aux_3532;
					  aux_3532 = CAR(actuals_1217);
					  aux_3531 = (node_t) (aux_3532);
				       }
				       {
					  obj_t aux_3528;
					  aux_3528 = CAR(formals_1216);
					  aux_3527 = (variable_t) (aux_3528);
				       }
				       arg1828_1229 = node_setq_243_cgen_cgen(aux_3527, aux_3531);
				    }
				    arg1827_1228 = node__cop_142_cgen_cgen((node_t) (arg1828_1229), __stop_kont__121_cgen_cgen);
				 }
				 {
				    obj_t aux_3538;
				    aux_3538 = (obj_t) (arg1827_1228);
				    arg1826_1227 = MAKE_PAIR(aux_3538, seq_1218);
				 }
			      }
			      {
				 obj_t seq_3543;
				 obj_t actuals_3542;
				 obj_t formals_3541;
				 formals_3541 = arg1824_1225;
				 actuals_3542 = arg1825_1226;
				 seq_3543 = arg1826_1227;
				 seq_1218 = seq_3543;
				 actuals_1217 = actuals_3542;
				 formals_1216 = formals_3541;
				 goto loop_1219;
			      }
			   }
			 return (obj_t) (aux_3509);
		      }
		   }
	      }
	   }
      }
   }
}


obj_t 
imported_modules_init_94_cgen_capp()
{
   module_initialization_70_tools_trace(((long) 0), "CGEN_CAPP");
   module_initialization_70_tools_error(((long) 0), "CGEN_CAPP");
   module_initialization_70_tools_shape(((long) 0), "CGEN_CAPP");
   module_initialization_70_type_type(((long) 0), "CGEN_CAPP");
   module_initialization_70_type_tools(((long) 0), "CGEN_CAPP");
   module_initialization_70_type_cache(((long) 0), "CGEN_CAPP");
   module_initialization_70_ast_var(((long) 0), "CGEN_CAPP");
   module_initialization_70_ast_node(((long) 0), "CGEN_CAPP");
   module_initialization_70_ast_local(((long) 0), "CGEN_CAPP");
   module_initialization_70_effect_effect(((long) 0), "CGEN_CAPP");
   module_initialization_70_cgen_emit(((long) 0), "CGEN_CAPP");
   module_initialization_70_cgen_cop(((long) 0), "CGEN_CAPP");
   return module_initialization_70_cgen_cgen(((long) 0), "CGEN_CAPP");
}
