/*===========================================================================*/
/*   (Cgen/cop.scm)                                                          */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct cop
  {
     header_t header;
     obj_t widening;
  }
   *cop_t;

typedef struct clabel
  {
     header_t header;
     obj_t widening;
     obj_t name;
     bool_t used__226;
     obj_t body;
  }
      *clabel_t;

typedef struct cgoto
  {
     header_t header;
     obj_t widening;
     struct clabel *label;
  }
     *cgoto_t;

typedef struct block
  {
     header_t header;
     obj_t widening;
     struct cop *body;
  }
     *block_t;

typedef struct creturn
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
       *creturn_t;

typedef struct cvoid
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
     *cvoid_t;

typedef struct catom
  {
     header_t header;
     obj_t widening;
     obj_t value;
  }
     *catom_t;

typedef struct varc
  {
     header_t header;
     obj_t widening;
     struct variable *variable;
  }
    *varc_t;

typedef struct cpragma
  {
     header_t header;
     obj_t widening;
     obj_t format;
     obj_t args;
  }
       *cpragma_t;

typedef struct ccast
  {
     header_t header;
     obj_t widening;
     struct type *type;
     struct cop *arg;
  }
     *ccast_t;

typedef struct csequence
  {
     header_t header;
     obj_t widening;
     bool_t c_exp__163;
     obj_t cops;
  }
         *csequence_t;

typedef struct nop
  {
     header_t header;
     obj_t widening;
  }
   *nop_t;

typedef struct stop
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
    *stop_t;

typedef struct csetq
  {
     header_t header;
     obj_t widening;
     struct varc *var;
     struct cop *value;
  }
     *csetq_t;

typedef struct cif
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     struct cop *true;
     struct cop *false;
  }
   *cif_t;

typedef struct branch
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     struct cop *true;
     struct cop *false;
     struct cop *end;
  }
      *branch_t;

typedef struct local_var_164
  {
     header_t header;
     obj_t widening;
     obj_t vars;
  }
             *local_var_164_t;

typedef struct cfuncall
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     obj_t args;
     obj_t strength;
  }
        *cfuncall_t;

typedef struct capply
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     struct cop *arg;
  }
      *capply_t;

typedef struct capp
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     obj_t args;
  }
    *capp_t;

typedef struct cfail
  {
     header_t header;
     obj_t widening;
     struct cop *proc;
     struct cop *msg;
     struct cop *obj;
  }
     *cfail_t;

typedef struct cswitch
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     obj_t clauses;
  }
       *cswitch_t;

typedef struct cmake_box_177
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
             *cmake_box_177_t;

typedef struct cbox_ref_44
  {
     header_t header;
     obj_t widening;
     struct cop *var;
  }
           *cbox_ref_44_t;

typedef struct cbox_set__132
  {
     header_t header;
     obj_t widening;
     struct cop *var;
     struct cop *value;
  }
             *cbox_set__132_t;

typedef struct cset_ex_it_123
  {
     header_t header;
     obj_t widening;
     struct cop *exit;
     struct cop *jump_value_221;
     struct cop *body;
  }
              *cset_ex_it_123_t;

typedef struct cjump_ex_it_131
  {
     header_t header;
     obj_t widening;
     struct cop *exit;
     struct cop *value;
  }
               *cjump_ex_it_131_t;

typedef struct sfun_c_188
  {
     struct clabel *label;
     bool_t integrated;
  }
          *sfun_c_188_t;


static obj_t _allocate_cset_ex_it_129_cgen_cop(obj_t);
static obj_t object__struct_csequence2298_177_cgen_cop(obj_t, obj_t);
static obj_t object__struct_capply2314_0_cgen_cop(obj_t, obj_t);
static capply_t allocate_capply_99_cgen_cop();
static obj_t object__struct_cfuncall2312_175_cgen_cop(obj_t, obj_t);
static obj_t _allocate_capp_243_cgen_cop(obj_t);
obj_t cswitch_cgen_cop = BUNSPEC;
static obj_t struct_object__object_stop2301_26_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _allocate_nop_142_cgen_cop(obj_t);
static obj_t object__struct_cbox_set_2326_8_cgen_cop(obj_t, obj_t);
static obj_t object__struct_catom2290_207_cgen_cop(obj_t, obj_t);
static obj_t _allocate_varc_172_cgen_cop(obj_t);
static obj_t _allocate_branch_193_cgen_cop(obj_t);
static obj_t struct_object__object_cop2277_178_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _allocate_creturn_205_cgen_cop(obj_t);
static cop_t allocate_cop_141_cgen_cop();
static cset_ex_it_123_t allocate_cset_ex_it_68_cgen_cop();
static obj_t object__struct_cif2306_72_cgen_cop(obj_t, obj_t);
static cpragma_t allocate_cpragma_231_cgen_cop();
static obj_t struct_object__object_block2283_10_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _allocate_clabel_4_cgen_cop(obj_t);
static cfail_t allocate_cfail_187_cgen_cop();
obj_t stop_cgen_cop = BUNSPEC;
static obj_t struct_object__object_cfail2317_117_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _allocate_capply_222_cgen_cop(obj_t);
obj_t cbox_ref_44_cgen_cop = BUNSPEC;
static ccast_t allocate_ccast_96_cgen_cop();
static obj_t struct_object__object_sfun_c2331_82_cgen_cop(obj_t, obj_t, obj_t);
static obj_t object__struct_cbox_ref2324_170_cgen_cop(obj_t, obj_t);
static cjump_ex_it_131_t allocate_cjump_ex_it_67_cgen_cop();
static obj_t struct_object__object_catom2289_133_cgen_cop(obj_t, obj_t, obj_t);
static obj_t object__struct_stop2302_167_cgen_cop(obj_t, obj_t);
static obj_t struct_object__object_csetq2303_51_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _allocate_local_var_109_cgen_cop(obj_t);
static obj_t struct_object__object_cfuncall2311_235_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t _struct_object__object_6___object(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_cgen_cop();
static obj_t struct_object__object_csequence2297_155_cgen_cop(obj_t, obj_t, obj_t);
obj_t catom_cgen_cop = BUNSPEC;
extern obj_t module_initialization_70_cgen_cop(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_cgen_cop();
static obj_t object__struct_varc2292_0_cgen_cop(obj_t, obj_t);
static obj_t cnst_init_137_cgen_cop();
obj_t cvoid_cgen_cop = BUNSPEC;
obj_t creturn_cgen_cop = BUNSPEC;
static obj_t _allocate_cfuncall_49_cgen_cop(obj_t);
static obj_t struct_object__object_branch2307_22_cgen_cop(obj_t, obj_t, obj_t);
static catom_t allocate_catom_78_cgen_cop();
static obj_t _allocate_cbox_set__70_cgen_cop(obj_t);
static obj_t struct_object__object_varc2291_166_cgen_cop(obj_t, obj_t, obj_t);
obj_t cjump_ex_it_131_cgen_cop = BUNSPEC;
static branch_t allocate_branch_45_cgen_cop();
obj_t cgoto_cgen_cop = BUNSPEC;
static obj_t struct_object__object_ccast2295_225_cgen_cop(obj_t, obj_t, obj_t);
static obj_t struct_object__object_local_var2309_105_cgen_cop(obj_t, obj_t, obj_t);
static obj_t struct_object__object_clabel2279_128_cgen_cop(obj_t, obj_t, obj_t);
static obj_t object__struct_cmake_box2322_194_cgen_cop(obj_t, obj_t);
static obj_t _allocate_cif_80_cgen_cop(obj_t);
static obj_t struct_object__object_cjump_ex_it2329_116_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
obj_t capply_cgen_cop = BUNSPEC;
static obj_t object__struct_cop2278_114_cgen_cop(obj_t, obj_t);
static block_t allocate_block_20_cgen_cop();
static obj_t require_initialization_114_cgen_cop = BUNSPEC;
static obj_t object__struct_cjump_ex_it2330_74_cgen_cop(obj_t, obj_t);
static obj_t struct_object__object_capp2315_158_cgen_cop(obj_t, obj_t, obj_t);
static obj_t object__struct_cgoto2282_70_cgen_cop(obj_t, obj_t);
static obj_t _allocate_cgoto_159_cgen_cop(obj_t);
static obj_t object__struct_clabel2280_107_cgen_cop(obj_t, obj_t);
static obj_t _allocate_csequence_87_cgen_cop(obj_t);
static sfun_t allocate_sfun_c_74_cgen_cop();
obj_t clabel_cgen_cop = BUNSPEC;
static obj_t library_modules_init_112_cgen_cop();
obj_t cset_ex_it_123_cgen_cop = BUNSPEC;
static cvoid_t allocate_cvoid_159_cgen_cop();
static obj_t object__struct_local_var2310_216_cgen_cop(obj_t, obj_t);
static obj_t _allocate_cmake_box_154_cgen_cop(obj_t);
extern obj_t sfun_ast_var;
static capp_t allocate_capp_109_cgen_cop();
static obj_t struct_object__object_cmake_box2321_46_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _allocate_sfun_c_103_cgen_cop(obj_t);
static obj_t _allocate_csetq_62_cgen_cop(obj_t);
obj_t capp_cgen_cop = BUNSPEC;
static obj_t _allocate_cop_129_cgen_cop(obj_t);
extern obj_t read___reader(obj_t);
static obj_t _allocate_ccast_222_cgen_cop(obj_t);
static obj_t object__struct_sfun_c2332_165_cgen_cop(obj_t, obj_t);
static obj_t struct_object__object_cif2305_67_cgen_cop(obj_t, obj_t, obj_t);
static nop_t allocate_nop_42_cgen_cop();
static cbox_set__132_t allocate_cbox_set__13_cgen_cop();
obj_t cfail_cgen_cop = BUNSPEC;
extern obj_t open_input_string(obj_t);
static obj_t _allocate_cvoid_169_cgen_cop(obj_t);
static cgoto_t allocate_cgoto_58_cgen_cop();
obj_t cif_cgen_cop = BUNSPEC;
extern long class_num_218___object(obj_t);
static obj_t _allocate_cbox_ref_237_cgen_cop(obj_t);
extern obj_t object__struct_50___object(object_t);
static obj_t _allocate_cjump_ex_it_10_cgen_cop(obj_t);
static cfuncall_t allocate_cfuncall_37_cgen_cop();
static obj_t object__struct_cfail2318_137_cgen_cop(obj_t, obj_t);
obj_t cbox_set__132_cgen_cop = BUNSPEC;
obj_t csetq_cgen_cop = BUNSPEC;
static obj_t object__struct_cset_ex_it2328_165_cgen_cop(obj_t, obj_t);
static clabel_t allocate_clabel_48_cgen_cop();
static obj_t struct_object__object_cbox_set_2325_176_cgen_cop(obj_t, obj_t, obj_t);
static obj_t object__struct_ccast2296_170_cgen_cop(obj_t, obj_t);
obj_t sfun_c_188_cgen_cop = BUNSPEC;
obj_t cpragma_cgen_cop = BUNSPEC;
static cswitch_t allocate_cswitch_92_cgen_cop();
extern obj_t object___object;
static local_var_164_t allocate_local_var_218_cgen_cop();
static obj_t struct_object__object_cvoid2287_53_cgen_cop(obj_t, obj_t, obj_t);
static obj_t struct_object__object_capply2313_131_cgen_cop(obj_t, obj_t, obj_t);
static cif_t allocate_cif_90_cgen_cop();
static obj_t struct_object__object_cgoto2281_69_cgen_cop(obj_t, obj_t, obj_t);
static cbox_ref_44_t allocate_cbox_ref_60_cgen_cop();
static creturn_t allocate_creturn_170_cgen_cop();
static obj_t object_init_111_cgen_cop();
static obj_t struct_object__object_creturn2285_109_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _allocate_cfail_114_cgen_cop(obj_t);
obj_t cmake_box_177_cgen_cop = BUNSPEC;
static obj_t object__struct_branch2308_20_cgen_cop(obj_t, obj_t);
obj_t local_var_164_cgen_cop = BUNSPEC;
obj_t varc_cgen_cop = BUNSPEC;
static obj_t _allocate_block_150_cgen_cop(obj_t);
static stop_t allocate_stop_49_cgen_cop();
obj_t ccast_cgen_cop = BUNSPEC;
static obj_t object__struct_csetq2304_34_cgen_cop(obj_t, obj_t);
static csetq_t allocate_csetq_141_cgen_cop();
static obj_t object__struct_nop2300_212_cgen_cop(obj_t, obj_t);
static cmake_box_177_t allocate_cmake_box_148_cgen_cop();
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static obj_t struct_object__object_cset_ex_it2327_241_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _allocate_cswitch_108_cgen_cop(obj_t);
static obj_t object__struct_cpragma2294_242_cgen_cop(obj_t, obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
obj_t cop_cgen_cop = BUNSPEC;
obj_t block_cgen_cop = BUNSPEC;
static varc_t allocate_varc_53_cgen_cop();
extern obj_t _object__struct_74___object(obj_t, obj_t);
static obj_t struct_object__object_cbox_ref2323_202_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _allocate_stop_67_cgen_cop(obj_t);
static obj_t struct_object__object_cswitch2319_108_cgen_cop(obj_t, obj_t, obj_t);
static obj_t object__struct_cvoid2288_173_cgen_cop(obj_t, obj_t);
static obj_t _allocate_catom_138_cgen_cop(obj_t);
static csequence_t allocate_csequence_231_cgen_cop();
static obj_t _allocate_cpragma_102_cgen_cop(obj_t);
static obj_t object__struct_creturn2286_204_cgen_cop(obj_t, obj_t);
obj_t nop_cgen_cop = BUNSPEC;
static obj_t struct_object__object_nop2299_22_cgen_cop(obj_t, obj_t, obj_t);
obj_t cfuncall_cgen_cop = BUNSPEC;
extern object_t struct_object__object_93___object(object_t, obj_t);
obj_t branch_cgen_cop = BUNSPEC;
static obj_t object__struct_block2284_57_cgen_cop(obj_t, obj_t);
static obj_t object__struct_capp2316_5_cgen_cop(obj_t, obj_t);
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t);
obj_t csequence_cgen_cop = BUNSPEC;
static obj_t struct_object__object_cpragma2293_175_cgen_cop(obj_t, obj_t, obj_t);
static obj_t object__struct_cswitch2320_65_cgen_cop(obj_t, obj_t);
static obj_t __cnst[28];

DEFINE_STATIC_PROCEDURE(proc2355_cgen_cop, object__struct_local_var2310_216_cgen_cop2395, object__struct_local_var2310_216_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2369_cgen_cop, object__struct_ccast2296_170_cgen_cop2396, object__struct_ccast2296_170_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2367_cgen_cop, object__struct_csequence2298_177_cgen_cop2397, object__struct_csequence2298_177_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2341_cgen_cop, object__struct_cbox_ref2324_170_cgen_cop2398, object__struct_cbox_ref2324_170_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2374_cgen_cop, struct_object__object_varc2291_166_cgen_cop2399, struct_object__object_varc2291_166_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_nop_env_73_cgen_cop, _allocate_nop_142_cgen_cop2400, _allocate_nop_142_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_cbox_set__env_34_cgen_cop, _allocate_cbox_set__70_cgen_cop2401, _allocate_cbox_set__70_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2340_cgen_cop, struct_object__object_cbox_set_2325_176_cgen_cop2402, struct_object__object_cbox_set_2325_176_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2354_cgen_cop, struct_object__object_cfuncall2311_235_cgen_cop2403, struct_object__object_cfuncall2311_235_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2368_cgen_cop, struct_object__object_csequence2297_155_cgen_cop2404, struct_object__object_csequence2297_155_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2346_cgen_cop, struct_object__object_cswitch2319_108_cgen_cop2405, struct_object__object_cswitch2319_108_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2335_cgen_cop, object__struct_cjump_ex_it2330_74_cgen_cop2406, object__struct_cjump_ex_it2330_74_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_local_var_env_12_cgen_cop, _allocate_local_var_109_cgen_cop2407, _allocate_local_var_109_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2347_cgen_cop, object__struct_cfail2318_137_cgen_cop2408, object__struct_cfail2318_137_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2364_cgen_cop, struct_object__object_stop2301_26_cgen_cop2409, struct_object__object_stop2301_26_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_clabel_env_164_cgen_cop, _allocate_clabel_4_cgen_cop2410, _allocate_clabel_4_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2343_cgen_cop, object__struct_cmake_box2322_194_cgen_cop2411, object__struct_cmake_box2322_194_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2356_cgen_cop, struct_object__object_local_var2309_105_cgen_cop2412, struct_object__object_local_var2309_105_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_cjump_ex_it_env_109_cgen_cop, _allocate_cjump_ex_it_10_cgen_cop2413, _allocate_cjump_ex_it_10_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_sfun_c_env_52_cgen_cop, _allocate_sfun_c_103_cgen_cop2414, _allocate_sfun_c_103_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2375_cgen_cop, object__struct_catom2290_207_cgen_cop2415, object__struct_catom2290_207_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_cif_env_237_cgen_cop, _allocate_cif_80_cgen_cop2416, _allocate_cif_80_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2362_cgen_cop, struct_object__object_csetq2303_51_cgen_cop2417, struct_object__object_csetq2303_51_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2349_cgen_cop, object__struct_capp2316_5_cgen_cop2418, object__struct_capp2316_5_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2350_cgen_cop, struct_object__object_capp2315_158_cgen_cop2419, struct_object__object_capp2315_158_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2344_cgen_cop, struct_object__object_cmake_box2321_46_cgen_cop2420, struct_object__object_cmake_box2321_46_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2366_cgen_cop, struct_object__object_nop2299_22_cgen_cop2421, struct_object__object_nop2299_22_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2384_cgen_cop, struct_object__object_cgoto2281_69_cgen_cop2422, struct_object__object_cgoto2281_69_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_branch_env_125_cgen_cop, _allocate_branch_193_cgen_cop2423, _allocate_branch_193_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2382_cgen_cop, struct_object__object_block2283_10_cgen_cop2424, struct_object__object_block2283_10_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_cset_ex_it_env_179_cgen_cop, _allocate_cset_ex_it_129_cgen_cop2425, _allocate_cset_ex_it_129_cgen_cop, 0L, 0);
DEFINE_STRING(string2389_cgen_cop, string2389_cgen_cop2426, "SFUN/C CJUMP-EX-IT CSET-EX-IT CBOX-SET! CBOX-REF CMAKE-BOX CSWITCH CFAIL CAPP CAPPLY CFUNCALL LOCAL-VAR BRANCH CIF CSETQ STOP NOP CSEQUENCE CCAST CPRAGMA VARC CATOM CVOID CRETURN BLOCK CGOTO CLABEL COP ", 202);
DEFINE_STATIC_PROCEDURE(proc2345_cgen_cop, object__struct_cswitch2320_65_cgen_cop2427, object__struct_cswitch2320_65_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_block_env_49_cgen_cop, _allocate_block_150_cgen_cop2428, _allocate_block_150_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2359_cgen_cop, object__struct_cif2306_72_cgen_cop2429, object__struct_cif2306_72_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2351_cgen_cop, object__struct_capply2314_0_cgen_cop2430, object__struct_capply2314_0_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_capply_env_184_cgen_cop, _allocate_capply_222_cgen_cop2431, _allocate_capply_222_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_cfail_env_151_cgen_cop, _allocate_cfail_114_cgen_cop2432, _allocate_cfail_114_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_catom_env_249_cgen_cop, _allocate_catom_138_cgen_cop2433, _allocate_catom_138_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2379_cgen_cop, object__struct_creturn2286_204_cgen_cop2434, object__struct_creturn2286_204_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2336_cgen_cop, struct_object__object_cjump_ex_it2329_116_cgen_cop2435, struct_object__object_cjump_ex_it2329_116_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2377_cgen_cop, object__struct_cvoid2288_173_cgen_cop2436, object__struct_cvoid2288_173_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2376_cgen_cop, struct_object__object_catom2289_133_cgen_cop2437, struct_object__object_catom2289_133_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2371_cgen_cop, object__struct_cpragma2294_242_cgen_cop2438, object__struct_cpragma2294_242_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_cmake_box_env_82_cgen_cop, _allocate_cmake_box_154_cgen_cop2439, _allocate_cmake_box_154_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2333_cgen_cop, object__struct_sfun_c2332_165_cgen_cop2440, object__struct_sfun_c2332_165_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2360_cgen_cop, struct_object__object_cif2305_67_cgen_cop2441, struct_object__object_cif2305_67_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_cvoid_env_139_cgen_cop, _allocate_cvoid_169_cgen_cop2442, _allocate_cvoid_169_cgen_cop, 0L, 0);
extern obj_t struct_object__object_env_209___object;
DEFINE_STATIC_PROCEDURE(allocate_ccast_env_158_cgen_cop, _allocate_ccast_222_cgen_cop2443, _allocate_ccast_222_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_cop_env_232_cgen_cop, _allocate_cop_129_cgen_cop2444, _allocate_cop_129_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2352_cgen_cop, struct_object__object_capply2313_131_cgen_cop2445, struct_object__object_capply2313_131_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2357_cgen_cop, object__struct_branch2308_20_cgen_cop2446, object__struct_branch2308_20_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2361_cgen_cop, object__struct_csetq2304_34_cgen_cop2447, object__struct_csetq2304_34_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2358_cgen_cop, struct_object__object_branch2307_22_cgen_cop2448, struct_object__object_branch2307_22_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_capp_env_45_cgen_cop, _allocate_capp_243_cgen_cop2449, _allocate_capp_243_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2388_cgen_cop, struct_object__object_cop2277_178_cgen_cop2450, struct_object__object_cop2277_178_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_cgoto_env_81_cgen_cop, _allocate_cgoto_159_cgen_cop2451, _allocate_cgoto_159_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2353_cgen_cop, object__struct_cfuncall2312_175_cgen_cop2452, object__struct_cfuncall2312_175_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_stop_env_110_cgen_cop, _allocate_stop_67_cgen_cop2453, _allocate_stop_67_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2373_cgen_cop, object__struct_varc2292_0_cgen_cop2454, object__struct_varc2292_0_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2348_cgen_cop, struct_object__object_cfail2317_117_cgen_cop2455, struct_object__object_cfail2317_117_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2383_cgen_cop, object__struct_cgoto2282_70_cgen_cop2456, object__struct_cgoto2282_70_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2372_cgen_cop, struct_object__object_cpragma2293_175_cgen_cop2457, struct_object__object_cpragma2293_175_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_cpragma_env_198_cgen_cop, _allocate_cpragma_102_cgen_cop2458, _allocate_cpragma_102_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_cfuncall_env_121_cgen_cop, _allocate_cfuncall_49_cgen_cop2459, _allocate_cfuncall_49_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2387_cgen_cop, object__struct_cop2278_114_cgen_cop2460, object__struct_cop2278_114_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2370_cgen_cop, struct_object__object_ccast2295_225_cgen_cop2461, struct_object__object_ccast2295_225_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2378_cgen_cop, struct_object__object_cvoid2287_53_cgen_cop2462, struct_object__object_cvoid2287_53_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2365_cgen_cop, object__struct_nop2300_212_cgen_cop2463, object__struct_nop2300_212_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2337_cgen_cop, object__struct_cset_ex_it2328_165_cgen_cop2464, object__struct_cset_ex_it2328_165_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_varc_env_92_cgen_cop, _allocate_varc_172_cgen_cop2465, _allocate_varc_172_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2385_cgen_cop, object__struct_clabel2280_107_cgen_cop2466, object__struct_clabel2280_107_cgen_cop, 0L, 1);
extern obj_t object__struct_env_210___object;
DEFINE_STATIC_PROCEDURE(proc2386_cgen_cop, struct_object__object_clabel2279_128_cgen_cop2467, struct_object__object_clabel2279_128_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2363_cgen_cop, object__struct_stop2302_167_cgen_cop2468, object__struct_stop2302_167_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2380_cgen_cop, struct_object__object_creturn2285_109_cgen_cop2469, struct_object__object_creturn2285_109_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_creturn_env_89_cgen_cop, _allocate_creturn_205_cgen_cop2470, _allocate_creturn_205_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2334_cgen_cop, struct_object__object_sfun_c2331_82_cgen_cop2471, struct_object__object_sfun_c2331_82_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_cswitch_env_29_cgen_cop, _allocate_cswitch_108_cgen_cop2472, _allocate_cswitch_108_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_cbox_ref_env_46_cgen_cop, _allocate_cbox_ref_237_cgen_cop2473, _allocate_cbox_ref_237_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2339_cgen_cop, object__struct_cbox_set_2326_8_cgen_cop2474, object__struct_cbox_set_2326_8_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_csetq_env_232_cgen_cop, _allocate_csetq_62_cgen_cop2475, _allocate_csetq_62_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_csequence_env_198_cgen_cop, _allocate_csequence_87_cgen_cop2476, _allocate_csequence_87_cgen_cop, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2342_cgen_cop, struct_object__object_cbox_ref2323_202_cgen_cop2477, struct_object__object_cbox_ref2323_202_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2381_cgen_cop, object__struct_block2284_57_cgen_cop2478, object__struct_block2284_57_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2338_cgen_cop, struct_object__object_cset_ex_it2327_241_cgen_cop2479, struct_object__object_cset_ex_it2327_241_cgen_cop, 0L, 2);

obj_t 
module_initialization_70_cgen_cop(long checksum_2898, char *from_2899)
{
   if (CBOOL(require_initialization_114_cgen_cop))
     {
	require_initialization_114_cgen_cop = BBOOL(((bool_t) 0));
	library_modules_init_112_cgen_cop();
	cnst_init_137_cgen_cop();
	object_init_111_cgen_cop();
	imported_modules_init_94_cgen_cop();
	toplevel_init_63_cgen_cop();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cgen_cop()
{
   module_initialization_70___object(((long) 0), "CGEN_COP");
   module_initialization_70___reader(((long) 0), "CGEN_COP");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cgen_cop()
{
   {
      obj_t cnst_port_138_2890;
      cnst_port_138_2890 = open_input_string(string2389_cgen_cop);
      {
	 long i_2891;
	 i_2891 = ((long) 27);
       loop_2892:
	 {
	    bool_t test2390_2893;
	    test2390_2893 = (i_2891 == ((long) -1));
	    if (test2390_2893)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2391_2894;
		    {
		       obj_t list2392_2895;
		       {
			  obj_t arg2393_2896;
			  arg2393_2896 = BNIL;
			  list2392_2895 = MAKE_PAIR(cnst_port_138_2890, arg2393_2896);
		       }
		       arg2391_2894 = read___reader(list2392_2895);
		    }
		    CNST_TABLE_SET(i_2891, arg2391_2894);
		 }
		 {
		    int aux_2897;
		    {
		       long aux_2916;
		       aux_2916 = (i_2891 - ((long) 1));
		       aux_2897 = (int) (aux_2916);
		    }
		    {
		       long i_2919;
		       i_2919 = (long) (aux_2897);
		       i_2891 = i_2919;
		       goto loop_2892;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cgen_cop()
{
   return BUNSPEC;
}


obj_t 
object_init_111_cgen_cop()
{
   {
      obj_t arg1725_891;
      arg1725_891 = object___object;
      cop_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 0)), arg1725_891, allocate_cop_env_232_cgen_cop, ((long) 8536), BUNSPEC);
   }
   {
      obj_t arg1733_895;
      arg1733_895 = cop_cgen_cop;
      clabel_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 1)), arg1733_895, allocate_clabel_env_164_cgen_cop, ((long) 50110), BUNSPEC);
   }
   {
      obj_t arg1737_899;
      arg1737_899 = cop_cgen_cop;
      cgoto_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 2)), arg1737_899, allocate_cgoto_env_81_cgen_cop, ((long) 10634), BUNSPEC);
   }
   {
      obj_t arg1742_903;
      arg1742_903 = cop_cgen_cop;
      block_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 3)), arg1742_903, allocate_block_env_49_cgen_cop, ((long) 35940), BUNSPEC);
   }
   {
      obj_t arg1747_907;
      arg1747_907 = cop_cgen_cop;
      creturn_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 4)), arg1747_907, allocate_creturn_env_89_cgen_cop, ((long) 35134), BUNSPEC);
   }
   {
      obj_t arg1753_911;
      arg1753_911 = cop_cgen_cop;
      cvoid_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 5)), arg1753_911, allocate_cvoid_env_139_cgen_cop, ((long) 63141), BUNSPEC);
   }
   {
      obj_t arg1758_915;
      arg1758_915 = cop_cgen_cop;
      catom_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 6)), arg1758_915, allocate_catom_env_249_cgen_cop, ((long) 63212), BUNSPEC);
   }
   {
      obj_t arg1763_919;
      arg1763_919 = cop_cgen_cop;
      varc_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 7)), arg1763_919, allocate_varc_env_92_cgen_cop, ((long) 47203), BUNSPEC);
   }
   {
      obj_t arg1769_923;
      arg1769_923 = cop_cgen_cop;
      cpragma_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 8)), arg1769_923, allocate_cpragma_env_198_cgen_cop, ((long) 28397), BUNSPEC);
   }
   {
      obj_t arg1773_927;
      arg1773_927 = cop_cgen_cop;
      ccast_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 9)), arg1773_927, allocate_ccast_env_158_cgen_cop, ((long) 61763), BUNSPEC);
   }
   {
      obj_t arg1777_931;
      arg1777_931 = cop_cgen_cop;
      csequence_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 10)), arg1777_931, allocate_csequence_env_198_cgen_cop, ((long) 51861), BUNSPEC);
   }
   {
      obj_t arg1781_935;
      arg1781_935 = cop_cgen_cop;
      nop_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 11)), arg1781_935, allocate_nop_env_73_cgen_cop, ((long) 4839), BUNSPEC);
   }
   {
      obj_t arg1786_939;
      arg1786_939 = cop_cgen_cop;
      stop_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 12)), arg1786_939, allocate_stop_env_110_cgen_cop, ((long) 59548), BUNSPEC);
   }
   {
      obj_t arg1792_943;
      arg1792_943 = cop_cgen_cop;
      csetq_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 13)), arg1792_943, allocate_csetq_env_232_cgen_cop, ((long) 2148), BUNSPEC);
   }
   {
      obj_t arg1798_947;
      arg1798_947 = cop_cgen_cop;
      cif_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 14)), arg1798_947, allocate_cif_env_237_cgen_cop, ((long) 7257), BUNSPEC);
   }
   {
      obj_t arg1802_951;
      arg1802_951 = cop_cgen_cop;
      branch_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 15)), arg1802_951, allocate_branch_env_125_cgen_cop, ((long) 29465), BUNSPEC);
   }
   {
      obj_t arg1807_955;
      arg1807_955 = cop_cgen_cop;
      local_var_164_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 16)), arg1807_955, allocate_local_var_env_12_cgen_cop, ((long) 27940), BUNSPEC);
   }
   {
      obj_t arg1811_959;
      arg1811_959 = cop_cgen_cop;
      cfuncall_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 17)), arg1811_959, allocate_cfuncall_env_121_cgen_cop, ((long) 35120), BUNSPEC);
   }
   {
      obj_t arg1819_963;
      arg1819_963 = cop_cgen_cop;
      capply_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 18)), arg1819_963, allocate_capply_env_184_cgen_cop, ((long) 20890), BUNSPEC);
   }
   {
      obj_t arg1823_967;
      arg1823_967 = cop_cgen_cop;
      capp_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 19)), arg1823_967, allocate_capp_env_45_cgen_cop, ((long) 22950), BUNSPEC);
   }
   {
      obj_t arg1827_971;
      arg1827_971 = cop_cgen_cop;
      cfail_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 20)), arg1827_971, allocate_cfail_env_151_cgen_cop, ((long) 34617), BUNSPEC);
   }
   {
      obj_t arg1831_975;
      arg1831_975 = cop_cgen_cop;
      cswitch_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 21)), arg1831_975, allocate_cswitch_env_29_cgen_cop, ((long) 8416), BUNSPEC);
   }
   {
      obj_t arg1835_979;
      arg1835_979 = cop_cgen_cop;
      cmake_box_177_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 22)), arg1835_979, allocate_cmake_box_env_82_cgen_cop, ((long) 3273), BUNSPEC);
   }
   {
      obj_t arg1839_983;
      arg1839_983 = cop_cgen_cop;
      cbox_ref_44_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 23)), arg1839_983, allocate_cbox_ref_env_46_cgen_cop, ((long) 18477), BUNSPEC);
   }
   {
      obj_t arg1843_987;
      arg1843_987 = cop_cgen_cop;
      cbox_set__132_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 24)), arg1843_987, allocate_cbox_set__env_34_cgen_cop, ((long) 64417), BUNSPEC);
   }
   {
      obj_t arg1847_991;
      arg1847_991 = cop_cgen_cop;
      cset_ex_it_123_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 25)), arg1847_991, allocate_cset_ex_it_env_179_cgen_cop, ((long) 66), BUNSPEC);
   }
   {
      obj_t arg1853_995;
      arg1853_995 = cop_cgen_cop;
      cjump_ex_it_131_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 26)), arg1853_995, allocate_cjump_ex_it_env_109_cgen_cop, ((long) 25602), BUNSPEC);
   }
   {
      obj_t arg1858_999;
      arg1858_999 = sfun_ast_var;
      sfun_c_188_cgen_cop = add_class__117___object(CNST_TABLE_REF(((long) 27)), arg1858_999, allocate_sfun_c_env_52_cgen_cop, ((long) 51973), BUNSPEC);
   }
   {
      obj_t object__struct_sfun_c_73_2719;
      object__struct_sfun_c_73_2719 = proc2333_cgen_cop;
      add_method__1___object(object__struct_env_210___object, sfun_c_188_cgen_cop, object__struct_sfun_c_73_2719);
   }
   {
      obj_t struct_object__object_sfun_c_84_2715;
      struct_object__object_sfun_c_84_2715 = proc2334_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, sfun_c_188_cgen_cop, struct_object__object_sfun_c_84_2715);
   }
   {
      obj_t object__struct_cjump_ex_it_155_2714;
      object__struct_cjump_ex_it_155_2714 = proc2335_cgen_cop;
      add_method__1___object(object__struct_env_210___object, cjump_ex_it_131_cgen_cop, object__struct_cjump_ex_it_155_2714);
   }
   {
      obj_t struct_object__object_cjump_ex_it_93_2713;
      struct_object__object_cjump_ex_it_93_2713 = proc2336_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, cjump_ex_it_131_cgen_cop, struct_object__object_cjump_ex_it_93_2713);
   }
   {
      obj_t object__struct_cset_ex_it_165_2712;
      object__struct_cset_ex_it_165_2712 = proc2337_cgen_cop;
      add_method__1___object(object__struct_env_210___object, cset_ex_it_123_cgen_cop, object__struct_cset_ex_it_165_2712);
   }
   {
      obj_t struct_object__object_cset_ex_it_17_2711;
      struct_object__object_cset_ex_it_17_2711 = proc2338_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, cset_ex_it_123_cgen_cop, struct_object__object_cset_ex_it_17_2711);
   }
   {
      obj_t object__struct_cbox_set__79_2710;
      object__struct_cbox_set__79_2710 = proc2339_cgen_cop;
      add_method__1___object(object__struct_env_210___object, cbox_set__132_cgen_cop, object__struct_cbox_set__79_2710);
   }
   {
      obj_t struct_object__object_cbox_set__145_2709;
      struct_object__object_cbox_set__145_2709 = proc2340_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, cbox_set__132_cgen_cop, struct_object__object_cbox_set__145_2709);
   }
   {
      obj_t object__struct_cbox_ref_102_2708;
      object__struct_cbox_ref_102_2708 = proc2341_cgen_cop;
      add_method__1___object(object__struct_env_210___object, cbox_ref_44_cgen_cop, object__struct_cbox_ref_102_2708);
   }
   {
      obj_t struct_object__object_cbox_ref_164_2707;
      struct_object__object_cbox_ref_164_2707 = proc2342_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, cbox_ref_44_cgen_cop, struct_object__object_cbox_ref_164_2707);
   }
   {
      obj_t object__struct_cmake_box_32_2706;
      object__struct_cmake_box_32_2706 = proc2343_cgen_cop;
      add_method__1___object(object__struct_env_210___object, cmake_box_177_cgen_cop, object__struct_cmake_box_32_2706);
   }
   {
      obj_t struct_object__object_cmake_box_25_2705;
      struct_object__object_cmake_box_25_2705 = proc2344_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, cmake_box_177_cgen_cop, struct_object__object_cmake_box_25_2705);
   }
   {
      obj_t object__struct_cswitch_161_2704;
      object__struct_cswitch_161_2704 = proc2345_cgen_cop;
      add_method__1___object(object__struct_env_210___object, cswitch_cgen_cop, object__struct_cswitch_161_2704);
   }
   {
      obj_t struct_object__object_cswitch_246_2703;
      struct_object__object_cswitch_246_2703 = proc2346_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, cswitch_cgen_cop, struct_object__object_cswitch_246_2703);
   }
   {
      obj_t object__struct_cfail_230_2702;
      object__struct_cfail_230_2702 = proc2347_cgen_cop;
      add_method__1___object(object__struct_env_210___object, cfail_cgen_cop, object__struct_cfail_230_2702);
   }
   {
      obj_t struct_object__object_cfail_119_2701;
      struct_object__object_cfail_119_2701 = proc2348_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, cfail_cgen_cop, struct_object__object_cfail_119_2701);
   }
   {
      obj_t object__struct_capp_230_2700;
      object__struct_capp_230_2700 = proc2349_cgen_cop;
      add_method__1___object(object__struct_env_210___object, capp_cgen_cop, object__struct_capp_230_2700);
   }
   {
      obj_t struct_object__object_capp_36_2699;
      struct_object__object_capp_36_2699 = proc2350_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, capp_cgen_cop, struct_object__object_capp_36_2699);
   }
   {
      obj_t object__struct_capply_87_2698;
      object__struct_capply_87_2698 = proc2351_cgen_cop;
      add_method__1___object(object__struct_env_210___object, capply_cgen_cop, object__struct_capply_87_2698);
   }
   {
      obj_t struct_object__object_capply_0_2697;
      struct_object__object_capply_0_2697 = proc2352_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, capply_cgen_cop, struct_object__object_capply_0_2697);
   }
   {
      obj_t object__struct_cfuncall_147_2696;
      object__struct_cfuncall_147_2696 = proc2353_cgen_cop;
      add_method__1___object(object__struct_env_210___object, cfuncall_cgen_cop, object__struct_cfuncall_147_2696);
   }
   {
      obj_t struct_object__object_cfuncall_72_2695;
      struct_object__object_cfuncall_72_2695 = proc2354_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, cfuncall_cgen_cop, struct_object__object_cfuncall_72_2695);
   }
   {
      obj_t object__struct_local_var_3_2694;
      object__struct_local_var_3_2694 = proc2355_cgen_cop;
      add_method__1___object(object__struct_env_210___object, local_var_164_cgen_cop, object__struct_local_var_3_2694);
   }
   {
      obj_t struct_object__object_local_var_195_2693;
      struct_object__object_local_var_195_2693 = proc2356_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, local_var_164_cgen_cop, struct_object__object_local_var_195_2693);
   }
   {
      obj_t object__struct_branch_149_2692;
      object__struct_branch_149_2692 = proc2357_cgen_cop;
      add_method__1___object(object__struct_env_210___object, branch_cgen_cop, object__struct_branch_149_2692);
   }
   {
      obj_t struct_object__object_branch_88_2691;
      struct_object__object_branch_88_2691 = proc2358_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, branch_cgen_cop, struct_object__object_branch_88_2691);
   }
   {
      obj_t object__struct_cif_61_2690;
      object__struct_cif_61_2690 = proc2359_cgen_cop;
      add_method__1___object(object__struct_env_210___object, cif_cgen_cop, object__struct_cif_61_2690);
   }
   {
      obj_t struct_object__object_cif_118_2689;
      struct_object__object_cif_118_2689 = proc2360_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, cif_cgen_cop, struct_object__object_cif_118_2689);
   }
   {
      obj_t object__struct_csetq_144_2688;
      object__struct_csetq_144_2688 = proc2361_cgen_cop;
      add_method__1___object(object__struct_env_210___object, csetq_cgen_cop, object__struct_csetq_144_2688);
   }
   {
      obj_t struct_object__object_csetq_16_2687;
      struct_object__object_csetq_16_2687 = proc2362_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, csetq_cgen_cop, struct_object__object_csetq_16_2687);
   }
   {
      obj_t object__struct_stop_197_2686;
      object__struct_stop_197_2686 = proc2363_cgen_cop;
      add_method__1___object(object__struct_env_210___object, stop_cgen_cop, object__struct_stop_197_2686);
   }
   {
      obj_t struct_object__object_stop_60_2685;
      struct_object__object_stop_60_2685 = proc2364_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, stop_cgen_cop, struct_object__object_stop_60_2685);
   }
   {
      obj_t object__struct_nop_253_2684;
      object__struct_nop_253_2684 = proc2365_cgen_cop;
      add_method__1___object(object__struct_env_210___object, nop_cgen_cop, object__struct_nop_253_2684);
   }
   {
      obj_t struct_object__object_nop_31_2683;
      struct_object__object_nop_31_2683 = proc2366_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, nop_cgen_cop, struct_object__object_nop_31_2683);
   }
   {
      obj_t object__struct_csequence_69_2682;
      object__struct_csequence_69_2682 = proc2367_cgen_cop;
      add_method__1___object(object__struct_env_210___object, csequence_cgen_cop, object__struct_csequence_69_2682);
   }
   {
      obj_t struct_object__object_csequence_144_2681;
      struct_object__object_csequence_144_2681 = proc2368_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, csequence_cgen_cop, struct_object__object_csequence_144_2681);
   }
   {
      obj_t object__struct_ccast_238_2680;
      object__struct_ccast_238_2680 = proc2369_cgen_cop;
      add_method__1___object(object__struct_env_210___object, ccast_cgen_cop, object__struct_ccast_238_2680);
   }
   {
      obj_t struct_object__object_ccast_65_2679;
      struct_object__object_ccast_65_2679 = proc2370_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, ccast_cgen_cop, struct_object__object_ccast_65_2679);
   }
   {
      obj_t object__struct_cpragma_233_2678;
      object__struct_cpragma_233_2678 = proc2371_cgen_cop;
      add_method__1___object(object__struct_env_210___object, cpragma_cgen_cop, object__struct_cpragma_233_2678);
   }
   {
      obj_t struct_object__object_cpragma_169_2677;
      struct_object__object_cpragma_169_2677 = proc2372_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, cpragma_cgen_cop, struct_object__object_cpragma_169_2677);
   }
   {
      obj_t object__struct_varc_203_2676;
      object__struct_varc_203_2676 = proc2373_cgen_cop;
      add_method__1___object(object__struct_env_210___object, varc_cgen_cop, object__struct_varc_203_2676);
   }
   {
      obj_t struct_object__object_varc_23_2675;
      struct_object__object_varc_23_2675 = proc2374_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, varc_cgen_cop, struct_object__object_varc_23_2675);
   }
   {
      obj_t object__struct_catom_180_2674;
      object__struct_catom_180_2674 = proc2375_cgen_cop;
      add_method__1___object(object__struct_env_210___object, catom_cgen_cop, object__struct_catom_180_2674);
   }
   {
      obj_t struct_object__object_catom_48_2673;
      struct_object__object_catom_48_2673 = proc2376_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, catom_cgen_cop, struct_object__object_catom_48_2673);
   }
   {
      obj_t object__struct_cvoid_78_2672;
      object__struct_cvoid_78_2672 = proc2377_cgen_cop;
      add_method__1___object(object__struct_env_210___object, cvoid_cgen_cop, object__struct_cvoid_78_2672);
   }
   {
      obj_t struct_object__object_cvoid_49_2671;
      struct_object__object_cvoid_49_2671 = proc2378_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, cvoid_cgen_cop, struct_object__object_cvoid_49_2671);
   }
   {
      obj_t object__struct_creturn_165_2670;
      object__struct_creturn_165_2670 = proc2379_cgen_cop;
      add_method__1___object(object__struct_env_210___object, creturn_cgen_cop, object__struct_creturn_165_2670);
   }
   {
      obj_t struct_object__object_creturn_28_2669;
      struct_object__object_creturn_28_2669 = proc2380_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, creturn_cgen_cop, struct_object__object_creturn_28_2669);
   }
   {
      obj_t object__struct_block_53_2668;
      object__struct_block_53_2668 = proc2381_cgen_cop;
      add_method__1___object(object__struct_env_210___object, block_cgen_cop, object__struct_block_53_2668);
   }
   {
      obj_t struct_object__object_block_188_2667;
      struct_object__object_block_188_2667 = proc2382_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, block_cgen_cop, struct_object__object_block_188_2667);
   }
   {
      obj_t object__struct_cgoto_44_2666;
      object__struct_cgoto_44_2666 = proc2383_cgen_cop;
      add_method__1___object(object__struct_env_210___object, cgoto_cgen_cop, object__struct_cgoto_44_2666);
   }
   {
      obj_t struct_object__object_cgoto_101_2665;
      struct_object__object_cgoto_101_2665 = proc2384_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, cgoto_cgen_cop, struct_object__object_cgoto_101_2665);
   }
   {
      obj_t object__struct_clabel_136_2664;
      object__struct_clabel_136_2664 = proc2385_cgen_cop;
      add_method__1___object(object__struct_env_210___object, clabel_cgen_cop, object__struct_clabel_136_2664);
   }
   {
      obj_t struct_object__object_clabel_24_2663;
      struct_object__object_clabel_24_2663 = proc2386_cgen_cop;
      add_method__1___object(struct_object__object_env_209___object, clabel_cgen_cop, struct_object__object_clabel_24_2663);
   }
   {
      obj_t object__struct_cop_119_2662;
      object__struct_cop_119_2662 = proc2387_cgen_cop;
      add_method__1___object(object__struct_env_210___object, cop_cgen_cop, object__struct_cop_119_2662);
   }
   {
      obj_t struct_object__object_cop_66_2661;
      struct_object__object_cop_66_2661 = proc2388_cgen_cop;
      return add_method__1___object(struct_object__object_env_209___object, cop_cgen_cop, struct_object__object_cop_66_2661);
   }
}


obj_t 
struct_object__object_cop2277_178_cgen_cop(obj_t env_2722, obj_t o_2723, obj_t s_2724)
{
   {
      cop_t o_1569;
      obj_t s_1570;
      {
	 cop_t aux_3033;
	 o_1569 = (cop_t) (o_2723);
	 s_1570 = s_2724;
	 {
	    obj_t aux_3036;
	    object_t aux_3034;
	    aux_3036 = STRUCT_REF(s_1570, ((long) 0));
	    aux_3034 = (object_t) (o_1569);
	    OBJECT_WIDENING_SET(aux_3034, aux_3036);
	 }
	 aux_3033 = o_1569;
	 return (obj_t) (aux_3033);
      }
   }
}


obj_t 
object__struct_cop2278_114_cgen_cop(obj_t env_2725, obj_t obj1276_2726)
{
   {
      cop_t obj1276_1561;
      obj1276_1561 = (cop_t) (obj1276_2726);
      {
	 obj_t res1277_1564;
	 {
	    obj_t aux_3041;
	    aux_3041 = CNST_TABLE_REF(((long) 0));
	    res1277_1564 = make_struct(aux_3041, ((long) 1), BUNSPEC);
	 }
	 STRUCT_SET(res1277_1564, ((long) 0), BFALSE);
	 return res1277_1564;
      }
   }
}


obj_t 
struct_object__object_clabel2279_128_cgen_cop(obj_t env_2727, obj_t o_2728, obj_t s_2729)
{
   {
      clabel_t o_1551;
      obj_t s_1552;
      {
	 clabel_t aux_3046;
	 o_1551 = (clabel_t) (o_2728);
	 s_1552 = s_2729;
	 {
	    obj_t aux_3049;
	    object_t aux_3047;
	    aux_3049 = STRUCT_REF(s_1552, ((long) 0));
	    aux_3047 = (object_t) (o_1551);
	    OBJECT_WIDENING_SET(aux_3047, aux_3049);
	 }
	 {
	    obj_t v1289_1556;
	    v1289_1556 = STRUCT_REF(s_1552, ((long) 1));
	    ((((clabel_t) CREF(o_1551))->name) = ((obj_t) v1289_1556), BUNSPEC);
	 }
	 {
	    bool_t v1293_1557;
	    {
	       obj_t aux_3054;
	       aux_3054 = STRUCT_REF(s_1552, ((long) 2));
	       v1293_1557 = CBOOL(aux_3054);
	    }
	    ((((clabel_t) CREF(o_1551))->used__226) = ((bool_t) v1293_1557), BUNSPEC);
	 }
	 {
	    obj_t v1298_1558;
	    v1298_1558 = STRUCT_REF(s_1552, ((long) 3));
	    ((((clabel_t) CREF(o_1551))->body) = ((obj_t) v1298_1558), BUNSPEC);
	 }
	 aux_3046 = o_1551;
	 return (obj_t) (aux_3046);
      }
   }
}


obj_t 
object__struct_clabel2280_107_cgen_cop(obj_t env_2730, obj_t obj1285_2731)
{
   {
      clabel_t obj1285_1537;
      obj1285_1537 = (clabel_t) (obj1285_2731);
      {
	 obj_t res1286_1540;
	 {
	    obj_t aux_3062;
	    aux_3062 = CNST_TABLE_REF(((long) 1));
	    res1286_1540 = make_struct(aux_3062, ((long) 4), BUNSPEC);
	 }
	 STRUCT_SET(res1286_1540, ((long) 0), BFALSE);
	 {
	    obj_t aux_3066;
	    aux_3066 = (((clabel_t) CREF(obj1285_1537))->name);
	    STRUCT_SET(res1286_1540, ((long) 1), aux_3066);
	 }
	 {
	    obj_t aux_3069;
	    {
	       bool_t aux_3070;
	       aux_3070 = (((clabel_t) CREF(obj1285_1537))->used__226);
	       aux_3069 = BBOOL(aux_3070);
	    }
	    STRUCT_SET(res1286_1540, ((long) 2), aux_3069);
	 }
	 {
	    obj_t aux_3074;
	    aux_3074 = (((clabel_t) CREF(obj1285_1537))->body);
	    STRUCT_SET(res1286_1540, ((long) 3), aux_3074);
	 }
	 return res1286_1540;
      }
   }
}


obj_t 
struct_object__object_cgoto2281_69_cgen_cop(obj_t env_2732, obj_t o_2733, obj_t s_2734)
{
   {
      cgoto_t o_1529;
      obj_t s_1530;
      {
	 cgoto_t aux_3078;
	 o_1529 = (cgoto_t) (o_2733);
	 s_1530 = s_2734;
	 {
	    obj_t aux_3081;
	    object_t aux_3079;
	    aux_3081 = STRUCT_REF(s_1530, ((long) 0));
	    aux_3079 = (object_t) (o_1529);
	    OBJECT_WIDENING_SET(aux_3079, aux_3081);
	 }
	 {
	    clabel_t v1308_1534;
	    {
	       obj_t aux_3084;
	       aux_3084 = STRUCT_REF(s_1530, ((long) 1));
	       v1308_1534 = (clabel_t) (aux_3084);
	    }
	    ((((cgoto_t) CREF(o_1529))->label) = ((clabel_t) v1308_1534), BUNSPEC);
	 }
	 aux_3078 = o_1529;
	 return (obj_t) (aux_3078);
      }
   }
}


obj_t 
object__struct_cgoto2282_70_cgen_cop(obj_t env_2735, obj_t obj1304_2736)
{
   {
      cgoto_t obj1304_1519;
      obj1304_1519 = (cgoto_t) (obj1304_2736);
      {
	 obj_t res1305_1522;
	 {
	    obj_t aux_3090;
	    aux_3090 = CNST_TABLE_REF(((long) 2));
	    res1305_1522 = make_struct(aux_3090, ((long) 2), BUNSPEC);
	 }
	 STRUCT_SET(res1305_1522, ((long) 0), BFALSE);
	 {
	    obj_t aux_3094;
	    {
	       clabel_t aux_3095;
	       aux_3095 = (((cgoto_t) CREF(obj1304_1519))->label);
	       aux_3094 = (obj_t) (aux_3095);
	    }
	    STRUCT_SET(res1305_1522, ((long) 1), aux_3094);
	 }
	 return res1305_1522;
      }
   }
}


obj_t 
struct_object__object_block2283_10_cgen_cop(obj_t env_2737, obj_t o_2738, obj_t s_2739)
{
   {
      block_t o_1511;
      obj_t s_1512;
      {
	 block_t aux_3100;
	 o_1511 = (block_t) (o_2738);
	 s_1512 = s_2739;
	 {
	    obj_t aux_3103;
	    object_t aux_3101;
	    aux_3103 = STRUCT_REF(s_1512, ((long) 0));
	    aux_3101 = (object_t) (o_1511);
	    OBJECT_WIDENING_SET(aux_3101, aux_3103);
	 }
	 {
	    cop_t v1319_1516;
	    {
	       obj_t aux_3106;
	       aux_3106 = STRUCT_REF(s_1512, ((long) 1));
	       v1319_1516 = (cop_t) (aux_3106);
	    }
	    ((((block_t) CREF(o_1511))->body) = ((cop_t) v1319_1516), BUNSPEC);
	 }
	 aux_3100 = o_1511;
	 return (obj_t) (aux_3100);
      }
   }
}


obj_t 
object__struct_block2284_57_cgen_cop(obj_t env_2740, obj_t obj1315_2741)
{
   {
      block_t obj1315_1501;
      obj1315_1501 = (block_t) (obj1315_2741);
      {
	 obj_t res1316_1504;
	 {
	    obj_t aux_3112;
	    aux_3112 = CNST_TABLE_REF(((long) 3));
	    res1316_1504 = make_struct(aux_3112, ((long) 2), BUNSPEC);
	 }
	 STRUCT_SET(res1316_1504, ((long) 0), BFALSE);
	 {
	    obj_t aux_3116;
	    {
	       cop_t aux_3117;
	       aux_3117 = (((block_t) CREF(obj1315_1501))->body);
	       aux_3116 = (obj_t) (aux_3117);
	    }
	    STRUCT_SET(res1316_1504, ((long) 1), aux_3116);
	 }
	 return res1316_1504;
      }
   }
}


obj_t 
struct_object__object_creturn2285_109_cgen_cop(obj_t env_2742, obj_t o_2743, obj_t s_2744)
{
   {
      creturn_t o_1493;
      obj_t s_1494;
      {
	 creturn_t aux_3122;
	 o_1493 = (creturn_t) (o_2743);
	 s_1494 = s_2744;
	 {
	    obj_t aux_3125;
	    object_t aux_3123;
	    aux_3125 = STRUCT_REF(s_1494, ((long) 0));
	    aux_3123 = (object_t) (o_1493);
	    OBJECT_WIDENING_SET(aux_3123, aux_3125);
	 }
	 {
	    cop_t v1329_1498;
	    {
	       obj_t aux_3128;
	       aux_3128 = STRUCT_REF(s_1494, ((long) 1));
	       v1329_1498 = (cop_t) (aux_3128);
	    }
	    ((((creturn_t) CREF(o_1493))->value) = ((cop_t) v1329_1498), BUNSPEC);
	 }
	 aux_3122 = o_1493;
	 return (obj_t) (aux_3122);
      }
   }
}


obj_t 
object__struct_creturn2286_204_cgen_cop(obj_t env_2745, obj_t obj1325_2746)
{
   {
      creturn_t obj1325_1483;
      obj1325_1483 = (creturn_t) (obj1325_2746);
      {
	 obj_t res1326_1486;
	 {
	    obj_t aux_3134;
	    aux_3134 = CNST_TABLE_REF(((long) 4));
	    res1326_1486 = make_struct(aux_3134, ((long) 2), BUNSPEC);
	 }
	 STRUCT_SET(res1326_1486, ((long) 0), BFALSE);
	 {
	    obj_t aux_3138;
	    {
	       cop_t aux_3139;
	       aux_3139 = (((creturn_t) CREF(obj1325_1483))->value);
	       aux_3138 = (obj_t) (aux_3139);
	    }
	    STRUCT_SET(res1326_1486, ((long) 1), aux_3138);
	 }
	 return res1326_1486;
      }
   }
}


obj_t 
struct_object__object_cvoid2287_53_cgen_cop(obj_t env_2747, obj_t o_2748, obj_t s_2749)
{
   {
      cvoid_t o_1475;
      obj_t s_1476;
      {
	 cvoid_t aux_3144;
	 o_1475 = (cvoid_t) (o_2748);
	 s_1476 = s_2749;
	 {
	    obj_t aux_3147;
	    object_t aux_3145;
	    aux_3147 = STRUCT_REF(s_1476, ((long) 0));
	    aux_3145 = (object_t) (o_1475);
	    OBJECT_WIDENING_SET(aux_3145, aux_3147);
	 }
	 {
	    cop_t v1339_1480;
	    {
	       obj_t aux_3150;
	       aux_3150 = STRUCT_REF(s_1476, ((long) 1));
	       v1339_1480 = (cop_t) (aux_3150);
	    }
	    ((((cvoid_t) CREF(o_1475))->value) = ((cop_t) v1339_1480), BUNSPEC);
	 }
	 aux_3144 = o_1475;
	 return (obj_t) (aux_3144);
      }
   }
}


obj_t 
object__struct_cvoid2288_173_cgen_cop(obj_t env_2750, obj_t obj1335_2751)
{
   {
      cvoid_t obj1335_1465;
      obj1335_1465 = (cvoid_t) (obj1335_2751);
      {
	 obj_t res1336_1468;
	 {
	    obj_t aux_3156;
	    aux_3156 = CNST_TABLE_REF(((long) 5));
	    res1336_1468 = make_struct(aux_3156, ((long) 2), BUNSPEC);
	 }
	 STRUCT_SET(res1336_1468, ((long) 0), BFALSE);
	 {
	    obj_t aux_3160;
	    {
	       cop_t aux_3161;
	       aux_3161 = (((cvoid_t) CREF(obj1335_1465))->value);
	       aux_3160 = (obj_t) (aux_3161);
	    }
	    STRUCT_SET(res1336_1468, ((long) 1), aux_3160);
	 }
	 return res1336_1468;
      }
   }
}


obj_t 
struct_object__object_catom2289_133_cgen_cop(obj_t env_2752, obj_t o_2753, obj_t s_2754)
{
   {
      catom_t o_1457;
      obj_t s_1458;
      {
	 catom_t aux_3166;
	 o_1457 = (catom_t) (o_2753);
	 s_1458 = s_2754;
	 {
	    obj_t aux_3169;
	    object_t aux_3167;
	    aux_3169 = STRUCT_REF(s_1458, ((long) 0));
	    aux_3167 = (object_t) (o_1457);
	    OBJECT_WIDENING_SET(aux_3167, aux_3169);
	 }
	 {
	    obj_t v1349_1462;
	    v1349_1462 = STRUCT_REF(s_1458, ((long) 1));
	    ((((catom_t) CREF(o_1457))->value) = ((obj_t) v1349_1462), BUNSPEC);
	 }
	 aux_3166 = o_1457;
	 return (obj_t) (aux_3166);
      }
   }
}


obj_t 
object__struct_catom2290_207_cgen_cop(obj_t env_2755, obj_t obj1345_2756)
{
   {
      catom_t obj1345_1447;
      obj1345_1447 = (catom_t) (obj1345_2756);
      {
	 obj_t res1346_1450;
	 {
	    obj_t aux_3176;
	    aux_3176 = CNST_TABLE_REF(((long) 6));
	    res1346_1450 = make_struct(aux_3176, ((long) 2), BUNSPEC);
	 }
	 STRUCT_SET(res1346_1450, ((long) 0), BFALSE);
	 {
	    obj_t aux_3180;
	    aux_3180 = (((catom_t) CREF(obj1345_1447))->value);
	    STRUCT_SET(res1346_1450, ((long) 1), aux_3180);
	 }
	 return res1346_1450;
      }
   }
}


obj_t 
struct_object__object_varc2291_166_cgen_cop(obj_t env_2757, obj_t o_2758, obj_t s_2759)
{
   {
      varc_t o_1439;
      obj_t s_1440;
      {
	 varc_t aux_3184;
	 o_1439 = (varc_t) (o_2758);
	 s_1440 = s_2759;
	 {
	    obj_t aux_3187;
	    object_t aux_3185;
	    aux_3187 = STRUCT_REF(s_1440, ((long) 0));
	    aux_3185 = (object_t) (o_1439);
	    OBJECT_WIDENING_SET(aux_3185, aux_3187);
	 }
	 {
	    variable_t v1359_1444;
	    {
	       obj_t aux_3190;
	       aux_3190 = STRUCT_REF(s_1440, ((long) 1));
	       v1359_1444 = (variable_t) (aux_3190);
	    }
	    ((((varc_t) CREF(o_1439))->variable) = ((variable_t) v1359_1444), BUNSPEC);
	 }
	 aux_3184 = o_1439;
	 return (obj_t) (aux_3184);
      }
   }
}


obj_t 
object__struct_varc2292_0_cgen_cop(obj_t env_2760, obj_t obj1355_2761)
{
   {
      varc_t obj1355_1429;
      obj1355_1429 = (varc_t) (obj1355_2761);
      {
	 obj_t res1356_1432;
	 {
	    obj_t aux_3196;
	    aux_3196 = CNST_TABLE_REF(((long) 7));
	    res1356_1432 = make_struct(aux_3196, ((long) 2), BUNSPEC);
	 }
	 STRUCT_SET(res1356_1432, ((long) 0), BFALSE);
	 {
	    obj_t aux_3200;
	    {
	       variable_t aux_3201;
	       aux_3201 = (((varc_t) CREF(obj1355_1429))->variable);
	       aux_3200 = (obj_t) (aux_3201);
	    }
	    STRUCT_SET(res1356_1432, ((long) 1), aux_3200);
	 }
	 return res1356_1432;
      }
   }
}


obj_t 
struct_object__object_cpragma2293_175_cgen_cop(obj_t env_2762, obj_t o_2763, obj_t s_2764)
{
   {
      cpragma_t o_1420;
      obj_t s_1421;
      {
	 cpragma_t aux_3206;
	 o_1420 = (cpragma_t) (o_2763);
	 s_1421 = s_2764;
	 {
	    obj_t aux_3209;
	    object_t aux_3207;
	    aux_3209 = STRUCT_REF(s_1421, ((long) 0));
	    aux_3207 = (object_t) (o_1420);
	    OBJECT_WIDENING_SET(aux_3207, aux_3209);
	 }
	 {
	    obj_t v1370_1425;
	    v1370_1425 = STRUCT_REF(s_1421, ((long) 1));
	    ((((cpragma_t) CREF(o_1420))->format) = ((obj_t) v1370_1425), BUNSPEC);
	 }
	 {
	    obj_t v1374_1426;
	    v1374_1426 = STRUCT_REF(s_1421, ((long) 2));
	    ((((cpragma_t) CREF(o_1420))->args) = ((obj_t) v1374_1426), BUNSPEC);
	 }
	 aux_3206 = o_1420;
	 return (obj_t) (aux_3206);
      }
   }
}


obj_t 
object__struct_cpragma2294_242_cgen_cop(obj_t env_2765, obj_t obj1366_2766)
{
   {
      cpragma_t obj1366_1408;
      obj1366_1408 = (cpragma_t) (obj1366_2766);
      {
	 obj_t res1367_1411;
	 {
	    obj_t aux_3218;
	    aux_3218 = CNST_TABLE_REF(((long) 8));
	    res1367_1411 = make_struct(aux_3218, ((long) 3), BUNSPEC);
	 }
	 STRUCT_SET(res1367_1411, ((long) 0), BFALSE);
	 {
	    obj_t aux_3222;
	    aux_3222 = (((cpragma_t) CREF(obj1366_1408))->format);
	    STRUCT_SET(res1367_1411, ((long) 1), aux_3222);
	 }
	 {
	    obj_t aux_3225;
	    aux_3225 = (((cpragma_t) CREF(obj1366_1408))->args);
	    STRUCT_SET(res1367_1411, ((long) 2), aux_3225);
	 }
	 return res1367_1411;
      }
   }
}


obj_t 
struct_object__object_ccast2295_225_cgen_cop(obj_t env_2767, obj_t o_2768, obj_t s_2769)
{
   {
      ccast_t o_1399;
      obj_t s_1400;
      {
	 ccast_t aux_3229;
	 o_1399 = (ccast_t) (o_2768);
	 s_1400 = s_2769;
	 {
	    obj_t aux_3232;
	    object_t aux_3230;
	    aux_3232 = STRUCT_REF(s_1400, ((long) 0));
	    aux_3230 = (object_t) (o_1399);
	    OBJECT_WIDENING_SET(aux_3230, aux_3232);
	 }
	 {
	    type_t v1384_1404;
	    {
	       obj_t aux_3235;
	       aux_3235 = STRUCT_REF(s_1400, ((long) 1));
	       v1384_1404 = (type_t) (aux_3235);
	    }
	    ((((ccast_t) CREF(o_1399))->type) = ((type_t) v1384_1404), BUNSPEC);
	 }
	 {
	    cop_t v1388_1405;
	    {
	       obj_t aux_3239;
	       aux_3239 = STRUCT_REF(s_1400, ((long) 2));
	       v1388_1405 = (cop_t) (aux_3239);
	    }
	    ((((ccast_t) CREF(o_1399))->arg) = ((cop_t) v1388_1405), BUNSPEC);
	 }
	 aux_3229 = o_1399;
	 return (obj_t) (aux_3229);
      }
   }
}


obj_t 
object__struct_ccast2296_170_cgen_cop(obj_t env_2770, obj_t obj1380_2771)
{
   {
      ccast_t obj1380_1387;
      obj1380_1387 = (ccast_t) (obj1380_2771);
      {
	 obj_t res1381_1390;
	 {
	    obj_t aux_3245;
	    aux_3245 = CNST_TABLE_REF(((long) 9));
	    res1381_1390 = make_struct(aux_3245, ((long) 3), BUNSPEC);
	 }
	 STRUCT_SET(res1381_1390, ((long) 0), BFALSE);
	 {
	    obj_t aux_3249;
	    {
	       type_t aux_3250;
	       aux_3250 = (((ccast_t) CREF(obj1380_1387))->type);
	       aux_3249 = (obj_t) (aux_3250);
	    }
	    STRUCT_SET(res1381_1390, ((long) 1), aux_3249);
	 }
	 {
	    obj_t aux_3254;
	    {
	       cop_t aux_3255;
	       aux_3255 = (((ccast_t) CREF(obj1380_1387))->arg);
	       aux_3254 = (obj_t) (aux_3255);
	    }
	    STRUCT_SET(res1381_1390, ((long) 2), aux_3254);
	 }
	 return res1381_1390;
      }
   }
}


obj_t 
struct_object__object_csequence2297_155_cgen_cop(obj_t env_2772, obj_t o_2773, obj_t s_2774)
{
   {
      csequence_t o_1378;
      obj_t s_1379;
      {
	 csequence_t aux_3260;
	 o_1378 = (csequence_t) (o_2773);
	 s_1379 = s_2774;
	 {
	    obj_t aux_3263;
	    object_t aux_3261;
	    aux_3263 = STRUCT_REF(s_1379, ((long) 0));
	    aux_3261 = (object_t) (o_1378);
	    OBJECT_WIDENING_SET(aux_3261, aux_3263);
	 }
	 {
	    bool_t v1398_1383;
	    {
	       obj_t aux_3266;
	       aux_3266 = STRUCT_REF(s_1379, ((long) 1));
	       v1398_1383 = CBOOL(aux_3266);
	    }
	    ((((csequence_t) CREF(o_1378))->c_exp__163) = ((bool_t) v1398_1383), BUNSPEC);
	 }
	 {
	    obj_t v1402_1384;
	    v1402_1384 = STRUCT_REF(s_1379, ((long) 2));
	    ((((csequence_t) CREF(o_1378))->cops) = ((obj_t) v1402_1384), BUNSPEC);
	 }
	 aux_3260 = o_1378;
	 return (obj_t) (aux_3260);
      }
   }
}


obj_t 
object__struct_csequence2298_177_cgen_cop(obj_t env_2775, obj_t obj1394_2776)
{
   {
      csequence_t obj1394_1366;
      obj1394_1366 = (csequence_t) (obj1394_2776);
      {
	 obj_t res1395_1369;
	 {
	    obj_t aux_3274;
	    aux_3274 = CNST_TABLE_REF(((long) 10));
	    res1395_1369 = make_struct(aux_3274, ((long) 3), BUNSPEC);
	 }
	 STRUCT_SET(res1395_1369, ((long) 0), BFALSE);
	 {
	    obj_t aux_3278;
	    {
	       bool_t aux_3279;
	       aux_3279 = (((csequence_t) CREF(obj1394_1366))->c_exp__163);
	       aux_3278 = BBOOL(aux_3279);
	    }
	    STRUCT_SET(res1395_1369, ((long) 1), aux_3278);
	 }
	 {
	    obj_t aux_3283;
	    aux_3283 = (((csequence_t) CREF(obj1394_1366))->cops);
	    STRUCT_SET(res1395_1369, ((long) 2), aux_3283);
	 }
	 return res1395_1369;
      }
   }
}


obj_t 
struct_object__object_nop2299_22_cgen_cop(obj_t env_2777, obj_t o_2778, obj_t s_2779)
{
   {
      nop_t o_1359;
      obj_t s_1360;
      {
	 nop_t aux_3287;
	 o_1359 = (nop_t) (o_2778);
	 s_1360 = s_2779;
	 {
	    obj_t aux_3290;
	    object_t aux_3288;
	    aux_3290 = STRUCT_REF(s_1360, ((long) 0));
	    aux_3288 = (object_t) (o_1359);
	    OBJECT_WIDENING_SET(aux_3288, aux_3290);
	 }
	 aux_3287 = o_1359;
	 return (obj_t) (aux_3287);
      }
   }
}


obj_t 
object__struct_nop2300_212_cgen_cop(obj_t env_2780, obj_t obj1408_2781)
{
   {
      nop_t obj1408_1351;
      obj1408_1351 = (nop_t) (obj1408_2781);
      {
	 obj_t res1409_1354;
	 {
	    obj_t aux_3295;
	    aux_3295 = CNST_TABLE_REF(((long) 11));
	    res1409_1354 = make_struct(aux_3295, ((long) 1), BUNSPEC);
	 }
	 STRUCT_SET(res1409_1354, ((long) 0), BFALSE);
	 return res1409_1354;
      }
   }
}


obj_t 
struct_object__object_stop2301_26_cgen_cop(obj_t env_2782, obj_t o_2783, obj_t s_2784)
{
   {
      stop_t o_1343;
      obj_t s_1344;
      {
	 stop_t aux_3300;
	 o_1343 = (stop_t) (o_2783);
	 s_1344 = s_2784;
	 {
	    obj_t aux_3303;
	    object_t aux_3301;
	    aux_3303 = STRUCT_REF(s_1344, ((long) 0));
	    aux_3301 = (object_t) (o_1343);
	    OBJECT_WIDENING_SET(aux_3301, aux_3303);
	 }
	 {
	    cop_t v1418_1348;
	    {
	       obj_t aux_3306;
	       aux_3306 = STRUCT_REF(s_1344, ((long) 1));
	       v1418_1348 = (cop_t) (aux_3306);
	    }
	    ((((stop_t) CREF(o_1343))->value) = ((cop_t) v1418_1348), BUNSPEC);
	 }
	 aux_3300 = o_1343;
	 return (obj_t) (aux_3300);
      }
   }
}


obj_t 
object__struct_stop2302_167_cgen_cop(obj_t env_2785, obj_t obj1414_2786)
{
   {
      stop_t obj1414_1333;
      obj1414_1333 = (stop_t) (obj1414_2786);
      {
	 obj_t res1415_1336;
	 {
	    obj_t aux_3312;
	    aux_3312 = CNST_TABLE_REF(((long) 12));
	    res1415_1336 = make_struct(aux_3312, ((long) 2), BUNSPEC);
	 }
	 STRUCT_SET(res1415_1336, ((long) 0), BFALSE);
	 {
	    obj_t aux_3316;
	    {
	       cop_t aux_3317;
	       aux_3317 = (((stop_t) CREF(obj1414_1333))->value);
	       aux_3316 = (obj_t) (aux_3317);
	    }
	    STRUCT_SET(res1415_1336, ((long) 1), aux_3316);
	 }
	 return res1415_1336;
      }
   }
}


obj_t 
struct_object__object_csetq2303_51_cgen_cop(obj_t env_2787, obj_t o_2788, obj_t s_2789)
{
   {
      csetq_t o_1324;
      obj_t s_1325;
      {
	 csetq_t aux_3322;
	 o_1324 = (csetq_t) (o_2788);
	 s_1325 = s_2789;
	 {
	    obj_t aux_3325;
	    object_t aux_3323;
	    aux_3325 = STRUCT_REF(s_1325, ((long) 0));
	    aux_3323 = (object_t) (o_1324);
	    OBJECT_WIDENING_SET(aux_3323, aux_3325);
	 }
	 {
	    varc_t v1430_1329;
	    {
	       obj_t aux_3328;
	       aux_3328 = STRUCT_REF(s_1325, ((long) 1));
	       v1430_1329 = (varc_t) (aux_3328);
	    }
	    ((((csetq_t) CREF(o_1324))->var) = ((varc_t) v1430_1329), BUNSPEC);
	 }
	 {
	    cop_t v1434_1330;
	    {
	       obj_t aux_3332;
	       aux_3332 = STRUCT_REF(s_1325, ((long) 2));
	       v1434_1330 = (cop_t) (aux_3332);
	    }
	    ((((csetq_t) CREF(o_1324))->value) = ((cop_t) v1434_1330), BUNSPEC);
	 }
	 aux_3322 = o_1324;
	 return (obj_t) (aux_3322);
      }
   }
}


obj_t 
object__struct_csetq2304_34_cgen_cop(obj_t env_2790, obj_t obj1425_2791)
{
   {
      csetq_t obj1425_1312;
      obj1425_1312 = (csetq_t) (obj1425_2791);
      {
	 obj_t res1426_1315;
	 {
	    obj_t aux_3338;
	    aux_3338 = CNST_TABLE_REF(((long) 13));
	    res1426_1315 = make_struct(aux_3338, ((long) 3), BUNSPEC);
	 }
	 STRUCT_SET(res1426_1315, ((long) 0), BFALSE);
	 {
	    obj_t aux_3342;
	    {
	       varc_t aux_3343;
	       aux_3343 = (((csetq_t) CREF(obj1425_1312))->var);
	       aux_3342 = (obj_t) (aux_3343);
	    }
	    STRUCT_SET(res1426_1315, ((long) 1), aux_3342);
	 }
	 {
	    obj_t aux_3347;
	    {
	       cop_t aux_3348;
	       aux_3348 = (((csetq_t) CREF(obj1425_1312))->value);
	       aux_3347 = (obj_t) (aux_3348);
	    }
	    STRUCT_SET(res1426_1315, ((long) 2), aux_3347);
	 }
	 return res1426_1315;
      }
   }
}


obj_t 
struct_object__object_cif2305_67_cgen_cop(obj_t env_2792, obj_t o_2793, obj_t s_2794)
{
   {
      cif_t o_1302;
      obj_t s_1303;
      {
	 cif_t aux_3353;
	 o_1302 = (cif_t) (o_2793);
	 s_1303 = s_2794;
	 {
	    obj_t aux_3356;
	    object_t aux_3354;
	    aux_3356 = STRUCT_REF(s_1303, ((long) 0));
	    aux_3354 = (object_t) (o_1302);
	    OBJECT_WIDENING_SET(aux_3354, aux_3356);
	 }
	 {
	    cop_t v1444_1307;
	    {
	       obj_t aux_3359;
	       aux_3359 = STRUCT_REF(s_1303, ((long) 1));
	       v1444_1307 = (cop_t) (aux_3359);
	    }
	    ((((cif_t) CREF(o_1302))->test) = ((cop_t) v1444_1307), BUNSPEC);
	 }
	 {
	    cop_t v1449_1308;
	    {
	       obj_t aux_3363;
	       aux_3363 = STRUCT_REF(s_1303, ((long) 2));
	       v1449_1308 = (cop_t) (aux_3363);
	    }
	    ((((cif_t) CREF(o_1302))->true) = ((cop_t) v1449_1308), BUNSPEC);
	 }
	 {
	    cop_t v1453_1309;
	    {
	       obj_t aux_3367;
	       aux_3367 = STRUCT_REF(s_1303, ((long) 3));
	       v1453_1309 = (cop_t) (aux_3367);
	    }
	    ((((cif_t) CREF(o_1302))->false) = ((cop_t) v1453_1309), BUNSPEC);
	 }
	 aux_3353 = o_1302;
	 return (obj_t) (aux_3353);
      }
   }
}


obj_t 
object__struct_cif2306_72_cgen_cop(obj_t env_2795, obj_t obj1440_2796)
{
   {
      cif_t obj1440_1288;
      obj1440_1288 = (cif_t) (obj1440_2796);
      {
	 obj_t res1441_1291;
	 {
	    obj_t aux_3373;
	    aux_3373 = CNST_TABLE_REF(((long) 14));
	    res1441_1291 = make_struct(aux_3373, ((long) 4), BUNSPEC);
	 }
	 STRUCT_SET(res1441_1291, ((long) 0), BFALSE);
	 {
	    obj_t aux_3377;
	    {
	       cop_t aux_3378;
	       aux_3378 = (((cif_t) CREF(obj1440_1288))->test);
	       aux_3377 = (obj_t) (aux_3378);
	    }
	    STRUCT_SET(res1441_1291, ((long) 1), aux_3377);
	 }
	 {
	    obj_t aux_3382;
	    {
	       cop_t aux_3383;
	       aux_3383 = (((cif_t) CREF(obj1440_1288))->true);
	       aux_3382 = (obj_t) (aux_3383);
	    }
	    STRUCT_SET(res1441_1291, ((long) 2), aux_3382);
	 }
	 {
	    obj_t aux_3387;
	    {
	       cop_t aux_3388;
	       aux_3388 = (((cif_t) CREF(obj1440_1288))->false);
	       aux_3387 = (obj_t) (aux_3388);
	    }
	    STRUCT_SET(res1441_1291, ((long) 3), aux_3387);
	 }
	 return res1441_1291;
      }
   }
}


obj_t 
struct_object__object_branch2307_22_cgen_cop(obj_t env_2797, obj_t o_2798, obj_t s_2799)
{
   {
      branch_t o_1277;
      obj_t s_1278;
      {
	 branch_t aux_3393;
	 o_1277 = (branch_t) (o_2798);
	 s_1278 = s_2799;
	 {
	    obj_t aux_3396;
	    object_t aux_3394;
	    aux_3396 = STRUCT_REF(s_1278, ((long) 0));
	    aux_3394 = (object_t) (o_1277);
	    OBJECT_WIDENING_SET(aux_3394, aux_3396);
	 }
	 {
	    cop_t v1463_1282;
	    {
	       obj_t aux_3399;
	       aux_3399 = STRUCT_REF(s_1278, ((long) 1));
	       v1463_1282 = (cop_t) (aux_3399);
	    }
	    ((((branch_t) CREF(o_1277))->test) = ((cop_t) v1463_1282), BUNSPEC);
	 }
	 {
	    cop_t v1467_1283;
	    {
	       obj_t aux_3403;
	       aux_3403 = STRUCT_REF(s_1278, ((long) 2));
	       v1467_1283 = (cop_t) (aux_3403);
	    }
	    ((((branch_t) CREF(o_1277))->true) = ((cop_t) v1467_1283), BUNSPEC);
	 }
	 {
	    cop_t v1473_1284;
	    {
	       obj_t aux_3407;
	       aux_3407 = STRUCT_REF(s_1278, ((long) 3));
	       v1473_1284 = (cop_t) (aux_3407);
	    }
	    ((((branch_t) CREF(o_1277))->false) = ((cop_t) v1473_1284), BUNSPEC);
	 }
	 {
	    cop_t v1477_1285;
	    {
	       obj_t aux_3411;
	       aux_3411 = STRUCT_REF(s_1278, ((long) 4));
	       v1477_1285 = (cop_t) (aux_3411);
	    }
	    ((((branch_t) CREF(o_1277))->end) = ((cop_t) v1477_1285), BUNSPEC);
	 }
	 aux_3393 = o_1277;
	 return (obj_t) (aux_3393);
      }
   }
}


obj_t 
object__struct_branch2308_20_cgen_cop(obj_t env_2800, obj_t obj1459_2801)
{
   {
      branch_t obj1459_1261;
      obj1459_1261 = (branch_t) (obj1459_2801);
      {
	 obj_t res1460_1264;
	 {
	    obj_t aux_3417;
	    aux_3417 = CNST_TABLE_REF(((long) 15));
	    res1460_1264 = make_struct(aux_3417, ((long) 5), BUNSPEC);
	 }
	 STRUCT_SET(res1460_1264, ((long) 0), BFALSE);
	 {
	    obj_t aux_3421;
	    {
	       cop_t aux_3422;
	       aux_3422 = (((branch_t) CREF(obj1459_1261))->test);
	       aux_3421 = (obj_t) (aux_3422);
	    }
	    STRUCT_SET(res1460_1264, ((long) 1), aux_3421);
	 }
	 {
	    obj_t aux_3426;
	    {
	       cop_t aux_3427;
	       aux_3427 = (((branch_t) CREF(obj1459_1261))->true);
	       aux_3426 = (obj_t) (aux_3427);
	    }
	    STRUCT_SET(res1460_1264, ((long) 2), aux_3426);
	 }
	 {
	    obj_t aux_3431;
	    {
	       cop_t aux_3432;
	       aux_3432 = (((branch_t) CREF(obj1459_1261))->false);
	       aux_3431 = (obj_t) (aux_3432);
	    }
	    STRUCT_SET(res1460_1264, ((long) 3), aux_3431);
	 }
	 {
	    obj_t aux_3436;
	    {
	       cop_t aux_3437;
	       aux_3437 = (((branch_t) CREF(obj1459_1261))->end);
	       aux_3436 = (obj_t) (aux_3437);
	    }
	    STRUCT_SET(res1460_1264, ((long) 4), aux_3436);
	 }
	 return res1460_1264;
      }
   }
}


obj_t 
struct_object__object_local_var2309_105_cgen_cop(obj_t env_2802, obj_t o_2803, obj_t s_2804)
{
   {
      local_var_164_t o_1253;
      obj_t s_1254;
      {
	 local_var_164_t aux_3442;
	 o_1253 = (local_var_164_t) (o_2803);
	 s_1254 = s_2804;
	 {
	    obj_t aux_3445;
	    object_t aux_3443;
	    aux_3445 = STRUCT_REF(s_1254, ((long) 0));
	    aux_3443 = (object_t) (o_1253);
	    OBJECT_WIDENING_SET(aux_3443, aux_3445);
	 }
	 {
	    obj_t v1487_1258;
	    v1487_1258 = STRUCT_REF(s_1254, ((long) 1));
	    ((((local_var_164_t) CREF(o_1253))->vars) = ((obj_t) v1487_1258), BUNSPEC);
	 }
	 aux_3442 = o_1253;
	 return (obj_t) (aux_3442);
      }
   }
}


obj_t 
object__struct_local_var2310_216_cgen_cop(obj_t env_2805, obj_t obj1483_2806)
{
   {
      local_var_164_t obj1483_1243;
      obj1483_1243 = (local_var_164_t) (obj1483_2806);
      {
	 obj_t res1484_1246;
	 {
	    obj_t aux_3452;
	    aux_3452 = CNST_TABLE_REF(((long) 16));
	    res1484_1246 = make_struct(aux_3452, ((long) 2), BUNSPEC);
	 }
	 STRUCT_SET(res1484_1246, ((long) 0), BFALSE);
	 {
	    obj_t aux_3456;
	    aux_3456 = (((local_var_164_t) CREF(obj1483_1243))->vars);
	    STRUCT_SET(res1484_1246, ((long) 1), aux_3456);
	 }
	 return res1484_1246;
      }
   }
}


obj_t 
struct_object__object_cfuncall2311_235_cgen_cop(obj_t env_2807, obj_t o_2808, obj_t s_2809)
{
   {
      cfuncall_t o_1233;
      obj_t s_1234;
      {
	 cfuncall_t aux_3460;
	 o_1233 = (cfuncall_t) (o_2808);
	 s_1234 = s_2809;
	 {
	    obj_t aux_3463;
	    object_t aux_3461;
	    aux_3463 = STRUCT_REF(s_1234, ((long) 0));
	    aux_3461 = (object_t) (o_1233);
	    OBJECT_WIDENING_SET(aux_3461, aux_3463);
	 }
	 {
	    cop_t v1498_1238;
	    {
	       obj_t aux_3466;
	       aux_3466 = STRUCT_REF(s_1234, ((long) 1));
	       v1498_1238 = (cop_t) (aux_3466);
	    }
	    ((((cfuncall_t) CREF(o_1233))->fun) = ((cop_t) v1498_1238), BUNSPEC);
	 }
	 {
	    obj_t v1502_1239;
	    v1502_1239 = STRUCT_REF(s_1234, ((long) 2));
	    ((((cfuncall_t) CREF(o_1233))->args) = ((obj_t) v1502_1239), BUNSPEC);
	 }
	 {
	    obj_t v1508_1240;
	    v1508_1240 = STRUCT_REF(s_1234, ((long) 3));
	    ((((cfuncall_t) CREF(o_1233))->strength) = ((obj_t) v1508_1240), BUNSPEC);
	 }
	 aux_3460 = o_1233;
	 return (obj_t) (aux_3460);
      }
   }
}


obj_t 
object__struct_cfuncall2312_175_cgen_cop(obj_t env_2810, obj_t obj1494_2811)
{
   {
      cfuncall_t obj1494_1219;
      obj1494_1219 = (cfuncall_t) (obj1494_2811);
      {
	 obj_t res1495_1222;
	 {
	    obj_t aux_3476;
	    aux_3476 = CNST_TABLE_REF(((long) 17));
	    res1495_1222 = make_struct(aux_3476, ((long) 4), BUNSPEC);
	 }
	 STRUCT_SET(res1495_1222, ((long) 0), BFALSE);
	 {
	    obj_t aux_3480;
	    {
	       cop_t aux_3481;
	       aux_3481 = (((cfuncall_t) CREF(obj1494_1219))->fun);
	       aux_3480 = (obj_t) (aux_3481);
	    }
	    STRUCT_SET(res1495_1222, ((long) 1), aux_3480);
	 }
	 {
	    obj_t aux_3485;
	    aux_3485 = (((cfuncall_t) CREF(obj1494_1219))->args);
	    STRUCT_SET(res1495_1222, ((long) 2), aux_3485);
	 }
	 {
	    obj_t aux_3488;
	    aux_3488 = (((cfuncall_t) CREF(obj1494_1219))->strength);
	    STRUCT_SET(res1495_1222, ((long) 3), aux_3488);
	 }
	 return res1495_1222;
      }
   }
}


obj_t 
struct_object__object_capply2313_131_cgen_cop(obj_t env_2812, obj_t o_2813, obj_t s_2814)
{
   {
      capply_t o_1210;
      obj_t s_1211;
      {
	 capply_t aux_3492;
	 o_1210 = (capply_t) (o_2813);
	 s_1211 = s_2814;
	 {
	    obj_t aux_3495;
	    object_t aux_3493;
	    aux_3495 = STRUCT_REF(s_1211, ((long) 0));
	    aux_3493 = (object_t) (o_1210);
	    OBJECT_WIDENING_SET(aux_3493, aux_3495);
	 }
	 {
	    cop_t v1518_1215;
	    {
	       obj_t aux_3498;
	       aux_3498 = STRUCT_REF(s_1211, ((long) 1));
	       v1518_1215 = (cop_t) (aux_3498);
	    }
	    ((((capply_t) CREF(o_1210))->fun) = ((cop_t) v1518_1215), BUNSPEC);
	 }
	 {
	    cop_t v1522_1216;
	    {
	       obj_t aux_3502;
	       aux_3502 = STRUCT_REF(s_1211, ((long) 2));
	       v1522_1216 = (cop_t) (aux_3502);
	    }
	    ((((capply_t) CREF(o_1210))->arg) = ((cop_t) v1522_1216), BUNSPEC);
	 }
	 aux_3492 = o_1210;
	 return (obj_t) (aux_3492);
      }
   }
}


obj_t 
object__struct_capply2314_0_cgen_cop(obj_t env_2815, obj_t obj1514_2816)
{
   {
      capply_t obj1514_1198;
      obj1514_1198 = (capply_t) (obj1514_2816);
      {
	 obj_t res1515_1201;
	 {
	    obj_t aux_3508;
	    aux_3508 = CNST_TABLE_REF(((long) 18));
	    res1515_1201 = make_struct(aux_3508, ((long) 3), BUNSPEC);
	 }
	 STRUCT_SET(res1515_1201, ((long) 0), BFALSE);
	 {
	    obj_t aux_3512;
	    {
	       cop_t aux_3513;
	       aux_3513 = (((capply_t) CREF(obj1514_1198))->fun);
	       aux_3512 = (obj_t) (aux_3513);
	    }
	    STRUCT_SET(res1515_1201, ((long) 1), aux_3512);
	 }
	 {
	    obj_t aux_3517;
	    {
	       cop_t aux_3518;
	       aux_3518 = (((capply_t) CREF(obj1514_1198))->arg);
	       aux_3517 = (obj_t) (aux_3518);
	    }
	    STRUCT_SET(res1515_1201, ((long) 2), aux_3517);
	 }
	 return res1515_1201;
      }
   }
}


obj_t 
struct_object__object_capp2315_158_cgen_cop(obj_t env_2817, obj_t o_2818, obj_t s_2819)
{
   {
      capp_t o_1189;
      obj_t s_1190;
      {
	 capp_t aux_3523;
	 o_1189 = (capp_t) (o_2818);
	 s_1190 = s_2819;
	 {
	    obj_t aux_3526;
	    object_t aux_3524;
	    aux_3526 = STRUCT_REF(s_1190, ((long) 0));
	    aux_3524 = (object_t) (o_1189);
	    OBJECT_WIDENING_SET(aux_3524, aux_3526);
	 }
	 {
	    cop_t v1533_1194;
	    {
	       obj_t aux_3529;
	       aux_3529 = STRUCT_REF(s_1190, ((long) 1));
	       v1533_1194 = (cop_t) (aux_3529);
	    }
	    ((((capp_t) CREF(o_1189))->fun) = ((cop_t) v1533_1194), BUNSPEC);
	 }
	 {
	    obj_t v1537_1195;
	    v1537_1195 = STRUCT_REF(s_1190, ((long) 2));
	    ((((capp_t) CREF(o_1189))->args) = ((obj_t) v1537_1195), BUNSPEC);
	 }
	 aux_3523 = o_1189;
	 return (obj_t) (aux_3523);
      }
   }
}


obj_t 
object__struct_capp2316_5_cgen_cop(obj_t env_2820, obj_t obj1528_2821)
{
   {
      capp_t obj1528_1177;
      obj1528_1177 = (capp_t) (obj1528_2821);
      {
	 obj_t res1529_1180;
	 {
	    obj_t aux_3537;
	    aux_3537 = CNST_TABLE_REF(((long) 19));
	    res1529_1180 = make_struct(aux_3537, ((long) 3), BUNSPEC);
	 }
	 STRUCT_SET(res1529_1180, ((long) 0), BFALSE);
	 {
	    obj_t aux_3541;
	    {
	       cop_t aux_3542;
	       aux_3542 = (((capp_t) CREF(obj1528_1177))->fun);
	       aux_3541 = (obj_t) (aux_3542);
	    }
	    STRUCT_SET(res1529_1180, ((long) 1), aux_3541);
	 }
	 {
	    obj_t aux_3546;
	    aux_3546 = (((capp_t) CREF(obj1528_1177))->args);
	    STRUCT_SET(res1529_1180, ((long) 2), aux_3546);
	 }
	 return res1529_1180;
      }
   }
}


obj_t 
struct_object__object_cfail2317_117_cgen_cop(obj_t env_2822, obj_t o_2823, obj_t s_2824)
{
   {
      cfail_t o_1167;
      obj_t s_1168;
      {
	 cfail_t aux_3550;
	 o_1167 = (cfail_t) (o_2823);
	 s_1168 = s_2824;
	 {
	    obj_t aux_3553;
	    object_t aux_3551;
	    aux_3553 = STRUCT_REF(s_1168, ((long) 0));
	    aux_3551 = (object_t) (o_1167);
	    OBJECT_WIDENING_SET(aux_3551, aux_3553);
	 }
	 {
	    cop_t v1547_1172;
	    {
	       obj_t aux_3556;
	       aux_3556 = STRUCT_REF(s_1168, ((long) 1));
	       v1547_1172 = (cop_t) (aux_3556);
	    }
	    ((((cfail_t) CREF(o_1167))->proc) = ((cop_t) v1547_1172), BUNSPEC);
	 }
	 {
	    cop_t v1552_1173;
	    {
	       obj_t aux_3560;
	       aux_3560 = STRUCT_REF(s_1168, ((long) 2));
	       v1552_1173 = (cop_t) (aux_3560);
	    }
	    ((((cfail_t) CREF(o_1167))->msg) = ((cop_t) v1552_1173), BUNSPEC);
	 }
	 {
	    cop_t v1556_1174;
	    {
	       obj_t aux_3564;
	       aux_3564 = STRUCT_REF(s_1168, ((long) 3));
	       v1556_1174 = (cop_t) (aux_3564);
	    }
	    ((((cfail_t) CREF(o_1167))->obj) = ((cop_t) v1556_1174), BUNSPEC);
	 }
	 aux_3550 = o_1167;
	 return (obj_t) (aux_3550);
      }
   }
}


obj_t 
object__struct_cfail2318_137_cgen_cop(obj_t env_2825, obj_t obj1543_2826)
{
   {
      cfail_t obj1543_1153;
      obj1543_1153 = (cfail_t) (obj1543_2826);
      {
	 obj_t res1544_1156;
	 {
	    obj_t aux_3570;
	    aux_3570 = CNST_TABLE_REF(((long) 20));
	    res1544_1156 = make_struct(aux_3570, ((long) 4), BUNSPEC);
	 }
	 STRUCT_SET(res1544_1156, ((long) 0), BFALSE);
	 {
	    obj_t aux_3574;
	    {
	       cop_t aux_3575;
	       aux_3575 = (((cfail_t) CREF(obj1543_1153))->proc);
	       aux_3574 = (obj_t) (aux_3575);
	    }
	    STRUCT_SET(res1544_1156, ((long) 1), aux_3574);
	 }
	 {
	    obj_t aux_3579;
	    {
	       cop_t aux_3580;
	       aux_3580 = (((cfail_t) CREF(obj1543_1153))->msg);
	       aux_3579 = (obj_t) (aux_3580);
	    }
	    STRUCT_SET(res1544_1156, ((long) 2), aux_3579);
	 }
	 {
	    obj_t aux_3584;
	    {
	       cop_t aux_3585;
	       aux_3585 = (((cfail_t) CREF(obj1543_1153))->obj);
	       aux_3584 = (obj_t) (aux_3585);
	    }
	    STRUCT_SET(res1544_1156, ((long) 3), aux_3584);
	 }
	 return res1544_1156;
      }
   }
}


obj_t 
struct_object__object_cswitch2319_108_cgen_cop(obj_t env_2827, obj_t o_2828, obj_t s_2829)
{
   {
      cswitch_t o_1144;
      obj_t s_1145;
      {
	 cswitch_t aux_3590;
	 o_1144 = (cswitch_t) (o_2828);
	 s_1145 = s_2829;
	 {
	    obj_t aux_3593;
	    object_t aux_3591;
	    aux_3593 = STRUCT_REF(s_1145, ((long) 0));
	    aux_3591 = (object_t) (o_1144);
	    OBJECT_WIDENING_SET(aux_3591, aux_3593);
	 }
	 {
	    cop_t v1568_1149;
	    {
	       obj_t aux_3596;
	       aux_3596 = STRUCT_REF(s_1145, ((long) 1));
	       v1568_1149 = (cop_t) (aux_3596);
	    }
	    ((((cswitch_t) CREF(o_1144))->test) = ((cop_t) v1568_1149), BUNSPEC);
	 }
	 {
	    obj_t v1572_1150;
	    v1572_1150 = STRUCT_REF(s_1145, ((long) 2));
	    ((((cswitch_t) CREF(o_1144))->clauses) = ((obj_t) v1572_1150), BUNSPEC);
	 }
	 aux_3590 = o_1144;
	 return (obj_t) (aux_3590);
      }
   }
}


obj_t 
object__struct_cswitch2320_65_cgen_cop(obj_t env_2830, obj_t obj1562_2831)
{
   {
      cswitch_t obj1562_1132;
      obj1562_1132 = (cswitch_t) (obj1562_2831);
      {
	 obj_t res1563_1135;
	 {
	    obj_t aux_3604;
	    aux_3604 = CNST_TABLE_REF(((long) 21));
	    res1563_1135 = make_struct(aux_3604, ((long) 3), BUNSPEC);
	 }
	 STRUCT_SET(res1563_1135, ((long) 0), BFALSE);
	 {
	    obj_t aux_3608;
	    {
	       cop_t aux_3609;
	       aux_3609 = (((cswitch_t) CREF(obj1562_1132))->test);
	       aux_3608 = (obj_t) (aux_3609);
	    }
	    STRUCT_SET(res1563_1135, ((long) 1), aux_3608);
	 }
	 {
	    obj_t aux_3613;
	    aux_3613 = (((cswitch_t) CREF(obj1562_1132))->clauses);
	    STRUCT_SET(res1563_1135, ((long) 2), aux_3613);
	 }
	 return res1563_1135;
      }
   }
}


obj_t 
struct_object__object_cmake_box2321_46_cgen_cop(obj_t env_2832, obj_t o_2833, obj_t s_2834)
{
   {
      cmake_box_177_t o_1124;
      obj_t s_1125;
      {
	 cmake_box_177_t aux_3617;
	 o_1124 = (cmake_box_177_t) (o_2833);
	 s_1125 = s_2834;
	 {
	    obj_t aux_3620;
	    object_t aux_3618;
	    aux_3620 = STRUCT_REF(s_1125, ((long) 0));
	    aux_3618 = (object_t) (o_1124);
	    OBJECT_WIDENING_SET(aux_3618, aux_3620);
	 }
	 {
	    cop_t v1583_1129;
	    {
	       obj_t aux_3623;
	       aux_3623 = STRUCT_REF(s_1125, ((long) 1));
	       v1583_1129 = (cop_t) (aux_3623);
	    }
	    ((((cmake_box_177_t) CREF(o_1124))->value) = ((cop_t) v1583_1129), BUNSPEC);
	 }
	 aux_3617 = o_1124;
	 return (obj_t) (aux_3617);
      }
   }
}


obj_t 
object__struct_cmake_box2322_194_cgen_cop(obj_t env_2835, obj_t obj1578_2836)
{
   {
      cmake_box_177_t obj1578_1114;
      obj1578_1114 = (cmake_box_177_t) (obj1578_2836);
      {
	 obj_t res1579_1117;
	 {
	    obj_t aux_3629;
	    aux_3629 = CNST_TABLE_REF(((long) 22));
	    res1579_1117 = make_struct(aux_3629, ((long) 2), BUNSPEC);
	 }
	 STRUCT_SET(res1579_1117, ((long) 0), BFALSE);
	 {
	    obj_t aux_3633;
	    {
	       cop_t aux_3634;
	       aux_3634 = (((cmake_box_177_t) CREF(obj1578_1114))->value);
	       aux_3633 = (obj_t) (aux_3634);
	    }
	    STRUCT_SET(res1579_1117, ((long) 1), aux_3633);
	 }
	 return res1579_1117;
      }
   }
}


obj_t 
struct_object__object_cbox_ref2323_202_cgen_cop(obj_t env_2837, obj_t o_2838, obj_t s_2839)
{
   {
      cbox_ref_44_t o_1106;
      obj_t s_1107;
      {
	 cbox_ref_44_t aux_3639;
	 o_1106 = (cbox_ref_44_t) (o_2838);
	 s_1107 = s_2839;
	 {
	    obj_t aux_3642;
	    object_t aux_3640;
	    aux_3642 = STRUCT_REF(s_1107, ((long) 0));
	    aux_3640 = (object_t) (o_1106);
	    OBJECT_WIDENING_SET(aux_3640, aux_3642);
	 }
	 {
	    cop_t v1593_1111;
	    {
	       obj_t aux_3645;
	       aux_3645 = STRUCT_REF(s_1107, ((long) 1));
	       v1593_1111 = (cop_t) (aux_3645);
	    }
	    ((((cbox_ref_44_t) CREF(o_1106))->var) = ((cop_t) v1593_1111), BUNSPEC);
	 }
	 aux_3639 = o_1106;
	 return (obj_t) (aux_3639);
      }
   }
}


obj_t 
object__struct_cbox_ref2324_170_cgen_cop(obj_t env_2840, obj_t obj1589_2841)
{
   {
      cbox_ref_44_t obj1589_1096;
      obj1589_1096 = (cbox_ref_44_t) (obj1589_2841);
      {
	 obj_t res1590_1099;
	 {
	    obj_t aux_3651;
	    aux_3651 = CNST_TABLE_REF(((long) 23));
	    res1590_1099 = make_struct(aux_3651, ((long) 2), BUNSPEC);
	 }
	 STRUCT_SET(res1590_1099, ((long) 0), BFALSE);
	 {
	    obj_t aux_3655;
	    {
	       cop_t aux_3656;
	       aux_3656 = (((cbox_ref_44_t) CREF(obj1589_1096))->var);
	       aux_3655 = (obj_t) (aux_3656);
	    }
	    STRUCT_SET(res1590_1099, ((long) 1), aux_3655);
	 }
	 return res1590_1099;
      }
   }
}


obj_t 
struct_object__object_cbox_set_2325_176_cgen_cop(obj_t env_2842, obj_t o_2843, obj_t s_2844)
{
   {
      cbox_set__132_t o_1087;
      obj_t s_1088;
      {
	 cbox_set__132_t aux_3661;
	 o_1087 = (cbox_set__132_t) (o_2843);
	 s_1088 = s_2844;
	 {
	    obj_t aux_3664;
	    object_t aux_3662;
	    aux_3664 = STRUCT_REF(s_1088, ((long) 0));
	    aux_3662 = (object_t) (o_1087);
	    OBJECT_WIDENING_SET(aux_3662, aux_3664);
	 }
	 {
	    cop_t v1603_1092;
	    {
	       obj_t aux_3667;
	       aux_3667 = STRUCT_REF(s_1088, ((long) 1));
	       v1603_1092 = (cop_t) (aux_3667);
	    }
	    ((((cbox_set__132_t) CREF(o_1087))->var) = ((cop_t) v1603_1092), BUNSPEC);
	 }
	 {
	    cop_t v1607_1093;
	    {
	       obj_t aux_3671;
	       aux_3671 = STRUCT_REF(s_1088, ((long) 2));
	       v1607_1093 = (cop_t) (aux_3671);
	    }
	    ((((cbox_set__132_t) CREF(o_1087))->value) = ((cop_t) v1607_1093), BUNSPEC);
	 }
	 aux_3661 = o_1087;
	 return (obj_t) (aux_3661);
      }
   }
}


obj_t 
object__struct_cbox_set_2326_8_cgen_cop(obj_t env_2845, obj_t obj1599_2846)
{
   {
      cbox_set__132_t obj1599_1075;
      obj1599_1075 = (cbox_set__132_t) (obj1599_2846);
      {
	 obj_t res1600_1078;
	 {
	    obj_t aux_3677;
	    aux_3677 = CNST_TABLE_REF(((long) 24));
	    res1600_1078 = make_struct(aux_3677, ((long) 3), BUNSPEC);
	 }
	 STRUCT_SET(res1600_1078, ((long) 0), BFALSE);
	 {
	    obj_t aux_3681;
	    {
	       cop_t aux_3682;
	       aux_3682 = (((cbox_set__132_t) CREF(obj1599_1075))->var);
	       aux_3681 = (obj_t) (aux_3682);
	    }
	    STRUCT_SET(res1600_1078, ((long) 1), aux_3681);
	 }
	 {
	    obj_t aux_3686;
	    {
	       cop_t aux_3687;
	       aux_3687 = (((cbox_set__132_t) CREF(obj1599_1075))->value);
	       aux_3686 = (obj_t) (aux_3687);
	    }
	    STRUCT_SET(res1600_1078, ((long) 2), aux_3686);
	 }
	 return res1600_1078;
      }
   }
}


obj_t 
struct_object__object_cset_ex_it2327_241_cgen_cop(obj_t env_2847, obj_t o_2848, obj_t s_2849)
{
   {
      cset_ex_it_123_t o_1065;
      obj_t s_1066;
      {
	 cset_ex_it_123_t aux_3692;
	 o_1065 = (cset_ex_it_123_t) (o_2848);
	 s_1066 = s_2849;
	 {
	    obj_t aux_3695;
	    object_t aux_3693;
	    aux_3695 = STRUCT_REF(s_1066, ((long) 0));
	    aux_3693 = (object_t) (o_1065);
	    OBJECT_WIDENING_SET(aux_3693, aux_3695);
	 }
	 {
	    cop_t v1618_1070;
	    {
	       obj_t aux_3698;
	       aux_3698 = STRUCT_REF(s_1066, ((long) 1));
	       v1618_1070 = (cop_t) (aux_3698);
	    }
	    ((((cset_ex_it_123_t) CREF(o_1065))->exit) = ((cop_t) v1618_1070), BUNSPEC);
	 }
	 {
	    cop_t v1622_1071;
	    {
	       obj_t aux_3702;
	       aux_3702 = STRUCT_REF(s_1066, ((long) 2));
	       v1622_1071 = (cop_t) (aux_3702);
	    }
	    ((((cset_ex_it_123_t) CREF(o_1065))->jump_value_221) = ((cop_t) v1622_1071), BUNSPEC);
	 }
	 {
	    cop_t v1626_1072;
	    {
	       obj_t aux_3706;
	       aux_3706 = STRUCT_REF(s_1066, ((long) 3));
	       v1626_1072 = (cop_t) (aux_3706);
	    }
	    ((((cset_ex_it_123_t) CREF(o_1065))->body) = ((cop_t) v1626_1072), BUNSPEC);
	 }
	 aux_3692 = o_1065;
	 return (obj_t) (aux_3692);
      }
   }
}


obj_t 
object__struct_cset_ex_it2328_165_cgen_cop(obj_t env_2850, obj_t obj1613_2851)
{
   {
      cset_ex_it_123_t obj1613_1051;
      obj1613_1051 = (cset_ex_it_123_t) (obj1613_2851);
      {
	 obj_t res1614_1054;
	 {
	    obj_t aux_3712;
	    aux_3712 = CNST_TABLE_REF(((long) 25));
	    res1614_1054 = make_struct(aux_3712, ((long) 4), BUNSPEC);
	 }
	 STRUCT_SET(res1614_1054, ((long) 0), BFALSE);
	 {
	    obj_t aux_3716;
	    {
	       cop_t aux_3717;
	       aux_3717 = (((cset_ex_it_123_t) CREF(obj1613_1051))->exit);
	       aux_3716 = (obj_t) (aux_3717);
	    }
	    STRUCT_SET(res1614_1054, ((long) 1), aux_3716);
	 }
	 {
	    obj_t aux_3721;
	    {
	       cop_t aux_3722;
	       aux_3722 = (((cset_ex_it_123_t) CREF(obj1613_1051))->jump_value_221);
	       aux_3721 = (obj_t) (aux_3722);
	    }
	    STRUCT_SET(res1614_1054, ((long) 2), aux_3721);
	 }
	 {
	    obj_t aux_3726;
	    {
	       cop_t aux_3727;
	       aux_3727 = (((cset_ex_it_123_t) CREF(obj1613_1051))->body);
	       aux_3726 = (obj_t) (aux_3727);
	    }
	    STRUCT_SET(res1614_1054, ((long) 3), aux_3726);
	 }
	 return res1614_1054;
      }
   }
}


obj_t 
struct_object__object_cjump_ex_it2329_116_cgen_cop(obj_t env_2852, obj_t o_2853, obj_t s_2854)
{
   {
      cjump_ex_it_131_t o_1042;
      obj_t s_1043;
      {
	 cjump_ex_it_131_t aux_3732;
	 o_1042 = (cjump_ex_it_131_t) (o_2853);
	 s_1043 = s_2854;
	 {
	    obj_t aux_3735;
	    object_t aux_3733;
	    aux_3735 = STRUCT_REF(s_1043, ((long) 0));
	    aux_3733 = (object_t) (o_1042);
	    OBJECT_WIDENING_SET(aux_3733, aux_3735);
	 }
	 {
	    cop_t v1636_1047;
	    {
	       obj_t aux_3738;
	       aux_3738 = STRUCT_REF(s_1043, ((long) 1));
	       v1636_1047 = (cop_t) (aux_3738);
	    }
	    ((((cjump_ex_it_131_t) CREF(o_1042))->exit) = ((cop_t) v1636_1047), BUNSPEC);
	 }
	 {
	    cop_t v1640_1048;
	    {
	       obj_t aux_3742;
	       aux_3742 = STRUCT_REF(s_1043, ((long) 2));
	       v1640_1048 = (cop_t) (aux_3742);
	    }
	    ((((cjump_ex_it_131_t) CREF(o_1042))->value) = ((cop_t) v1640_1048), BUNSPEC);
	 }
	 aux_3732 = o_1042;
	 return (obj_t) (aux_3732);
      }
   }
}


obj_t 
object__struct_cjump_ex_it2330_74_cgen_cop(obj_t env_2855, obj_t obj1632_2856)
{
   {
      cjump_ex_it_131_t obj1632_1030;
      obj1632_1030 = (cjump_ex_it_131_t) (obj1632_2856);
      {
	 obj_t res1633_1033;
	 {
	    obj_t aux_3748;
	    aux_3748 = CNST_TABLE_REF(((long) 26));
	    res1633_1033 = make_struct(aux_3748, ((long) 3), BUNSPEC);
	 }
	 STRUCT_SET(res1633_1033, ((long) 0), BFALSE);
	 {
	    obj_t aux_3752;
	    {
	       cop_t aux_3753;
	       aux_3753 = (((cjump_ex_it_131_t) CREF(obj1632_1030))->exit);
	       aux_3752 = (obj_t) (aux_3753);
	    }
	    STRUCT_SET(res1633_1033, ((long) 1), aux_3752);
	 }
	 {
	    obj_t aux_3757;
	    {
	       cop_t aux_3758;
	       aux_3758 = (((cjump_ex_it_131_t) CREF(obj1632_1030))->value);
	       aux_3757 = (obj_t) (aux_3758);
	    }
	    STRUCT_SET(res1633_1033, ((long) 2), aux_3757);
	 }
	 return res1633_1033;
      }
   }
}


obj_t 
struct_object__object_sfun_c2331_82_cgen_cop(obj_t env_2857, obj_t o_2858, obj_t s_2859)
{
   {
      sfun_c_188_t o_1017;
      obj_t s_1018;
      {
	 sfun_c_188_t aux_3763;
	 o_1017 = (sfun_c_188_t) (o_2858);
	 s_1018 = s_2859;
	 {
	    {
	       obj_t old1662_1021;
	       obj_t aux1663_1022;
	       {
		  obj_t next_method1666_102_1028;
		  next_method1666_102_1028 = find_super_class_method_167___object((object_t) (o_1017), struct_object__object_env_209___object, sfun_c_188_cgen_cop);
		  if (PROCEDUREP(next_method1666_102_1028))
		    {
		       old1662_1021 = PROCEDURE_ENTRY(next_method1666_102_1028) (next_method1666_102_1028, (obj_t) (o_1017), s_1018, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1666_102_1028);
		       {
			  object_t aux_3772;
			  aux_3772 = struct_object__object_93___object((object_t) (o_1017), s_1018);
			  old1662_1021 = (obj_t) (aux_3772);
		       }
		    }
	       }
	       aux1663_1022 = STRUCT_REF(s_1018, ((long) 0));
	       {
		  sfun_c_188_t new1664_1023;
		  new1664_1023 = ((sfun_c_188_t) (old1662_1021));
		  {
		     long arg1872_1024;
		     arg1872_1024 = class_num_218___object(sfun_c_188_cgen_cop);
		     {
			obj_t obj_2073;
			obj_2073 = (obj_t) (new1664_1023);
			(((obj_t) CREF(obj_2073))->header = MAKE_HEADER(arg1872_1024, 0), BUNSPEC);
		     }
		  }
		  {
		     sfun_c_188_t arg1874_1025;
		     {
			sfun_c_188_t res2273_2084;
			{
			   clabel_t label_2079;
			   bool_t integrated_2080;
			   {
			      obj_t aux_3781;
			      aux_3781 = STRUCT_REF(aux1663_1022, ((long) 0));
			      label_2079 = (clabel_t) (aux_3781);
			   }
			   {
			      obj_t aux_3784;
			      aux_3784 = STRUCT_REF(aux1663_1022, ((long) 1));
			      integrated_2080 = CBOOL(aux_3784);
			   }
			   {
			      sfun_c_188_t new1643_2081;
			      new1643_2081 = ((sfun_c_188_t) BREF(GC_MALLOC(sizeof(struct sfun_c_188))));
			      ((((sfun_c_188_t) CREF(new1643_2081))->label) = ((clabel_t) label_2079), BUNSPEC);
			      ((((sfun_c_188_t) CREF(new1643_2081))->integrated) = ((bool_t) integrated_2080), BUNSPEC);
			      res2273_2084 = new1643_2081;
			   }
			}
			arg1874_1025 = res2273_2084;
		     }
		     {
			obj_t aux_3792;
			object_t aux_3790;
			aux_3792 = (obj_t) (arg1874_1025);
			aux_3790 = (object_t) (new1664_1023);
			OBJECT_WIDENING_SET(aux_3790, aux_3792);
		     }
		  }
		  aux_3763 = new1664_1023;
	       }
	    }
	 }
	 return (obj_t) (aux_3763);
      }
   }
}


obj_t 
object__struct_sfun_c2332_165_cgen_cop(obj_t env_2860, obj_t obj1659_2861)
{
   {
      sfun_c_188_t obj1659_1002;
      obj1659_1002 = (sfun_c_188_t) (obj1659_2861);
      {
	 {
	    obj_t res1660_1005;
	    {
	       obj_t next_method1665_240_1015;
	       next_method1665_240_1015 = find_super_class_method_167___object((object_t) (obj1659_1002), object__struct_env_210___object, sfun_c_188_cgen_cop);
	       if (PROCEDUREP(next_method1665_240_1015))
		 {
		    res1660_1005 = PROCEDURE_ENTRY(next_method1665_240_1015) (next_method1665_240_1015, (obj_t) (obj1659_1002), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1665_240_1015);
		    res1660_1005 = object__struct_50___object((object_t) (obj1659_1002));
		 }
	    }
	    {
	       obj_t aux1661_1006;
	       {
		  obj_t aux_3807;
		  aux_3807 = CNST_TABLE_REF(((long) 27));
		  aux1661_1006 = make_struct(aux_3807, ((long) 2), BUNSPEC);
	       }
	       {
		  obj_t aux_3810;
		  {
		     clabel_t aux_3811;
		     {
			obj_t aux_3812;
			{
			   object_t aux_3813;
			   aux_3813 = (object_t) (obj1659_1002);
			   aux_3812 = OBJECT_WIDENING(aux_3813);
			}
			aux_3811 = (((sfun_c_188_t) CREF(aux_3812))->label);
		     }
		     aux_3810 = (obj_t) (aux_3811);
		  }
		  STRUCT_SET(aux1661_1006, ((long) 0), aux_3810);
	       }
	       {
		  obj_t aux_3819;
		  {
		     bool_t aux_3820;
		     {
			obj_t aux_3821;
			{
			   object_t aux_3822;
			   aux_3822 = (object_t) (obj1659_1002);
			   aux_3821 = OBJECT_WIDENING(aux_3822);
			}
			aux_3820 = (((sfun_c_188_t) CREF(aux_3821))->integrated);
		     }
		     aux_3819 = BBOOL(aux_3820);
		  }
		  STRUCT_SET(aux1661_1006, ((long) 1), aux_3819);
	       }
	       STRUCT_SET(res1660_1005, ((long) 0), aux1661_1006);
	       {
		  obj_t aux_3829;
		  aux_3829 = STRUCT_KEY(res1660_1005);
		  STRUCT_KEY_SET(aux1661_1006, aux_3829);
	       }
	       {
		  obj_t aux_3832;
		  aux_3832 = CNST_TABLE_REF(((long) 27));
		  STRUCT_KEY_SET(res1660_1005, aux_3832);
	       }
	       return res1660_1005;
	    }
	 }
      }
   }
}


sfun_t 
allocate_sfun_c_74_cgen_cop()
{
   {
      sfun_t new1658_1576;
      new1658_1576 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
      {
	 long arg2133_1577;
	 arg2133_1577 = class_num_218___object(sfun_c_188_cgen_cop);
	 {
	    obj_t obj_2587;
	    obj_2587 = (obj_t) (new1658_1576);
	    (((obj_t) CREF(obj_2587))->header = MAKE_HEADER(arg2133_1577, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3840;
	 aux_3840 = (object_t) (new1658_1576);
	 OBJECT_WIDENING_SET(aux_3840, BFALSE);
      }
      return new1658_1576;
   }
}


obj_t 
_allocate_sfun_c_103_cgen_cop(obj_t env_2889)
{
   {
      sfun_t aux_3843;
      aux_3843 = allocate_sfun_c_74_cgen_cop();
      return (obj_t) (aux_3843);
   }
}


cjump_ex_it_131_t 
allocate_cjump_ex_it_67_cgen_cop()
{
   {
      cjump_ex_it_131_t new1631_1585;
      new1631_1585 = ((cjump_ex_it_131_t) BREF(GC_MALLOC(sizeof(struct cjump_ex_it_131))));
      {
	 long arg2136_1586;
	 arg2136_1586 = class_num_218___object(cjump_ex_it_131_cgen_cop);
	 {
	    obj_t obj_2592;
	    obj_2592 = (obj_t) (new1631_1585);
	    (((obj_t) CREF(obj_2592))->header = MAKE_HEADER(arg2136_1586, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3850;
	 aux_3850 = (object_t) (new1631_1585);
	 OBJECT_WIDENING_SET(aux_3850, BFALSE);
      }
      return new1631_1585;
   }
}


obj_t 
_allocate_cjump_ex_it_10_cgen_cop(obj_t env_2888)
{
   {
      cjump_ex_it_131_t aux_3853;
      aux_3853 = allocate_cjump_ex_it_67_cgen_cop();
      return (obj_t) (aux_3853);
   }
}


cset_ex_it_123_t 
allocate_cset_ex_it_68_cgen_cop()
{
   {
      cset_ex_it_123_t new1612_1591;
      new1612_1591 = ((cset_ex_it_123_t) BREF(GC_MALLOC(sizeof(struct cset_ex_it_123))));
      {
	 long arg2138_1592;
	 arg2138_1592 = class_num_218___object(cset_ex_it_123_cgen_cop);
	 {
	    obj_t obj_2594;
	    obj_2594 = (obj_t) (new1612_1591);
	    (((obj_t) CREF(obj_2594))->header = MAKE_HEADER(arg2138_1592, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3860;
	 aux_3860 = (object_t) (new1612_1591);
	 OBJECT_WIDENING_SET(aux_3860, BFALSE);
      }
      return new1612_1591;
   }
}


obj_t 
_allocate_cset_ex_it_129_cgen_cop(obj_t env_2887)
{
   {
      cset_ex_it_123_t aux_3863;
      aux_3863 = allocate_cset_ex_it_68_cgen_cop();
      return (obj_t) (aux_3863);
   }
}


cbox_set__132_t 
allocate_cbox_set__13_cgen_cop()
{
   {
      cbox_set__132_t new1598_1598;
      new1598_1598 = ((cbox_set__132_t) BREF(GC_MALLOC(sizeof(struct cbox_set__132))));
      {
	 long arg2141_1599;
	 arg2141_1599 = class_num_218___object(cbox_set__132_cgen_cop);
	 {
	    obj_t obj_2596;
	    obj_2596 = (obj_t) (new1598_1598);
	    (((obj_t) CREF(obj_2596))->header = MAKE_HEADER(arg2141_1599, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3870;
	 aux_3870 = (object_t) (new1598_1598);
	 OBJECT_WIDENING_SET(aux_3870, BFALSE);
      }
      return new1598_1598;
   }
}


obj_t 
_allocate_cbox_set__70_cgen_cop(obj_t env_2886)
{
   {
      cbox_set__132_t aux_3873;
      aux_3873 = allocate_cbox_set__13_cgen_cop();
      return (obj_t) (aux_3873);
   }
}


cbox_ref_44_t 
allocate_cbox_ref_60_cgen_cop()
{
   {
      cbox_ref_44_t new1588_1604;
      new1588_1604 = ((cbox_ref_44_t) BREF(GC_MALLOC(sizeof(struct cbox_ref_44))));
      {
	 long arg2143_1605;
	 arg2143_1605 = class_num_218___object(cbox_ref_44_cgen_cop);
	 {
	    obj_t obj_2598;
	    obj_2598 = (obj_t) (new1588_1604);
	    (((obj_t) CREF(obj_2598))->header = MAKE_HEADER(arg2143_1605, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3880;
	 aux_3880 = (object_t) (new1588_1604);
	 OBJECT_WIDENING_SET(aux_3880, BFALSE);
      }
      return new1588_1604;
   }
}


obj_t 
_allocate_cbox_ref_237_cgen_cop(obj_t env_2885)
{
   {
      cbox_ref_44_t aux_3883;
      aux_3883 = allocate_cbox_ref_60_cgen_cop();
      return (obj_t) (aux_3883);
   }
}


cmake_box_177_t 
allocate_cmake_box_148_cgen_cop()
{
   {
      cmake_box_177_t new1577_1609;
      new1577_1609 = ((cmake_box_177_t) BREF(GC_MALLOC(sizeof(struct cmake_box_177))));
      {
	 long arg2145_1610;
	 arg2145_1610 = class_num_218___object(cmake_box_177_cgen_cop);
	 {
	    obj_t obj_2600;
	    obj_2600 = (obj_t) (new1577_1609);
	    (((obj_t) CREF(obj_2600))->header = MAKE_HEADER(arg2145_1610, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3890;
	 aux_3890 = (object_t) (new1577_1609);
	 OBJECT_WIDENING_SET(aux_3890, BFALSE);
      }
      return new1577_1609;
   }
}


obj_t 
_allocate_cmake_box_154_cgen_cop(obj_t env_2884)
{
   {
      cmake_box_177_t aux_3893;
      aux_3893 = allocate_cmake_box_148_cgen_cop();
      return (obj_t) (aux_3893);
   }
}


cswitch_t 
allocate_cswitch_92_cgen_cop()
{
   {
      cswitch_t new1561_1614;
      new1561_1614 = ((cswitch_t) BREF(GC_MALLOC(sizeof(struct cswitch))));
      {
	 long arg2148_1615;
	 arg2148_1615 = class_num_218___object(cswitch_cgen_cop);
	 {
	    obj_t obj_2602;
	    obj_2602 = (obj_t) (new1561_1614);
	    (((obj_t) CREF(obj_2602))->header = MAKE_HEADER(arg2148_1615, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3900;
	 aux_3900 = (object_t) (new1561_1614);
	 OBJECT_WIDENING_SET(aux_3900, BFALSE);
      }
      return new1561_1614;
   }
}


obj_t 
_allocate_cswitch_108_cgen_cop(obj_t env_2883)
{
   {
      cswitch_t aux_3903;
      aux_3903 = allocate_cswitch_92_cgen_cop();
      return (obj_t) (aux_3903);
   }
}


cfail_t 
allocate_cfail_187_cgen_cop()
{
   {
      cfail_t new1542_1620;
      new1542_1620 = ((cfail_t) BREF(GC_MALLOC(sizeof(struct cfail))));
      {
	 long arg2150_1621;
	 arg2150_1621 = class_num_218___object(cfail_cgen_cop);
	 {
	    obj_t obj_2604;
	    obj_2604 = (obj_t) (new1542_1620);
	    (((obj_t) CREF(obj_2604))->header = MAKE_HEADER(arg2150_1621, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3910;
	 aux_3910 = (object_t) (new1542_1620);
	 OBJECT_WIDENING_SET(aux_3910, BFALSE);
      }
      return new1542_1620;
   }
}


obj_t 
_allocate_cfail_114_cgen_cop(obj_t env_2882)
{
   {
      cfail_t aux_3913;
      aux_3913 = allocate_cfail_187_cgen_cop();
      return (obj_t) (aux_3913);
   }
}


capp_t 
allocate_capp_109_cgen_cop()
{
   {
      capp_t new1527_1627;
      new1527_1627 = ((capp_t) BREF(GC_MALLOC(sizeof(struct capp))));
      {
	 long arg2152_1628;
	 arg2152_1628 = class_num_218___object(capp_cgen_cop);
	 {
	    obj_t obj_2606;
	    obj_2606 = (obj_t) (new1527_1627);
	    (((obj_t) CREF(obj_2606))->header = MAKE_HEADER(arg2152_1628, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3920;
	 aux_3920 = (object_t) (new1527_1627);
	 OBJECT_WIDENING_SET(aux_3920, BFALSE);
      }
      return new1527_1627;
   }
}


obj_t 
_allocate_capp_243_cgen_cop(obj_t env_2881)
{
   {
      capp_t aux_3923;
      aux_3923 = allocate_capp_109_cgen_cop();
      return (obj_t) (aux_3923);
   }
}


capply_t 
allocate_capply_99_cgen_cop()
{
   {
      capply_t new1513_1633;
      new1513_1633 = ((capply_t) BREF(GC_MALLOC(sizeof(struct capply))));
      {
	 long arg2154_1634;
	 arg2154_1634 = class_num_218___object(capply_cgen_cop);
	 {
	    obj_t obj_2608;
	    obj_2608 = (obj_t) (new1513_1633);
	    (((obj_t) CREF(obj_2608))->header = MAKE_HEADER(arg2154_1634, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3930;
	 aux_3930 = (object_t) (new1513_1633);
	 OBJECT_WIDENING_SET(aux_3930, BFALSE);
      }
      return new1513_1633;
   }
}


obj_t 
_allocate_capply_222_cgen_cop(obj_t env_2880)
{
   {
      capply_t aux_3933;
      aux_3933 = allocate_capply_99_cgen_cop();
      return (obj_t) (aux_3933);
   }
}


cfuncall_t 
allocate_cfuncall_37_cgen_cop()
{
   {
      cfuncall_t new1493_1639;
      new1493_1639 = ((cfuncall_t) BREF(GC_MALLOC(sizeof(struct cfuncall))));
      {
	 long arg2156_1640;
	 arg2156_1640 = class_num_218___object(cfuncall_cgen_cop);
	 {
	    obj_t obj_2610;
	    obj_2610 = (obj_t) (new1493_1639);
	    (((obj_t) CREF(obj_2610))->header = MAKE_HEADER(arg2156_1640, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3940;
	 aux_3940 = (object_t) (new1493_1639);
	 OBJECT_WIDENING_SET(aux_3940, BFALSE);
      }
      return new1493_1639;
   }
}


obj_t 
_allocate_cfuncall_49_cgen_cop(obj_t env_2879)
{
   {
      cfuncall_t aux_3943;
      aux_3943 = allocate_cfuncall_37_cgen_cop();
      return (obj_t) (aux_3943);
   }
}


local_var_164_t 
allocate_local_var_218_cgen_cop()
{
   {
      local_var_164_t new1482_1646;
      new1482_1646 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
      {
	 long arg2161_1647;
	 arg2161_1647 = class_num_218___object(local_var_164_cgen_cop);
	 {
	    obj_t obj_2612;
	    obj_2612 = (obj_t) (new1482_1646);
	    (((obj_t) CREF(obj_2612))->header = MAKE_HEADER(arg2161_1647, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3950;
	 aux_3950 = (object_t) (new1482_1646);
	 OBJECT_WIDENING_SET(aux_3950, BFALSE);
      }
      return new1482_1646;
   }
}


obj_t 
_allocate_local_var_109_cgen_cop(obj_t env_2878)
{
   {
      local_var_164_t aux_3953;
      aux_3953 = allocate_local_var_218_cgen_cop();
      return (obj_t) (aux_3953);
   }
}


branch_t 
allocate_branch_45_cgen_cop()
{
   {
      branch_t new1458_1651;
      new1458_1651 = ((branch_t) BREF(GC_MALLOC(sizeof(struct branch))));
      {
	 long arg2163_1652;
	 arg2163_1652 = class_num_218___object(branch_cgen_cop);
	 {
	    obj_t obj_2614;
	    obj_2614 = (obj_t) (new1458_1651);
	    (((obj_t) CREF(obj_2614))->header = MAKE_HEADER(arg2163_1652, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3960;
	 aux_3960 = (object_t) (new1458_1651);
	 OBJECT_WIDENING_SET(aux_3960, BFALSE);
      }
      return new1458_1651;
   }
}


obj_t 
_allocate_branch_193_cgen_cop(obj_t env_2877)
{
   {
      branch_t aux_3963;
      aux_3963 = allocate_branch_45_cgen_cop();
      return (obj_t) (aux_3963);
   }
}


cif_t 
allocate_cif_90_cgen_cop()
{
   {
      cif_t new1439_1659;
      new1439_1659 = ((cif_t) BREF(GC_MALLOC(sizeof(struct cif))));
      {
	 long arg2165_1660;
	 arg2165_1660 = class_num_218___object(cif_cgen_cop);
	 {
	    obj_t obj_2616;
	    obj_2616 = (obj_t) (new1439_1659);
	    (((obj_t) CREF(obj_2616))->header = MAKE_HEADER(arg2165_1660, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3970;
	 aux_3970 = (object_t) (new1439_1659);
	 OBJECT_WIDENING_SET(aux_3970, BFALSE);
      }
      return new1439_1659;
   }
}


obj_t 
_allocate_cif_80_cgen_cop(obj_t env_2876)
{
   {
      cif_t aux_3973;
      aux_3973 = allocate_cif_90_cgen_cop();
      return (obj_t) (aux_3973);
   }
}


csetq_t 
allocate_csetq_141_cgen_cop()
{
   {
      csetq_t new1424_1666;
      new1424_1666 = ((csetq_t) BREF(GC_MALLOC(sizeof(struct csetq))));
      {
	 long arg2167_1667;
	 arg2167_1667 = class_num_218___object(csetq_cgen_cop);
	 {
	    obj_t obj_2618;
	    obj_2618 = (obj_t) (new1424_1666);
	    (((obj_t) CREF(obj_2618))->header = MAKE_HEADER(arg2167_1667, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3980;
	 aux_3980 = (object_t) (new1424_1666);
	 OBJECT_WIDENING_SET(aux_3980, BFALSE);
      }
      return new1424_1666;
   }
}


obj_t 
_allocate_csetq_62_cgen_cop(obj_t env_2875)
{
   {
      csetq_t aux_3983;
      aux_3983 = allocate_csetq_141_cgen_cop();
      return (obj_t) (aux_3983);
   }
}


stop_t 
allocate_stop_49_cgen_cop()
{
   {
      stop_t new1413_1672;
      new1413_1672 = ((stop_t) BREF(GC_MALLOC(sizeof(struct stop))));
      {
	 long arg2169_1673;
	 arg2169_1673 = class_num_218___object(stop_cgen_cop);
	 {
	    obj_t obj_2620;
	    obj_2620 = (obj_t) (new1413_1672);
	    (((obj_t) CREF(obj_2620))->header = MAKE_HEADER(arg2169_1673, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3990;
	 aux_3990 = (object_t) (new1413_1672);
	 OBJECT_WIDENING_SET(aux_3990, BFALSE);
      }
      return new1413_1672;
   }
}


obj_t 
_allocate_stop_67_cgen_cop(obj_t env_2874)
{
   {
      stop_t aux_3993;
      aux_3993 = allocate_stop_49_cgen_cop();
      return (obj_t) (aux_3993);
   }
}


nop_t 
allocate_nop_42_cgen_cop()
{
   {
      nop_t new1407_1677;
      new1407_1677 = ((nop_t) BREF(GC_MALLOC(sizeof(struct nop))));
      {
	 long arg2171_1678;
	 arg2171_1678 = class_num_218___object(nop_cgen_cop);
	 {
	    obj_t obj_2622;
	    obj_2622 = (obj_t) (new1407_1677);
	    (((obj_t) CREF(obj_2622))->header = MAKE_HEADER(arg2171_1678, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4000;
	 aux_4000 = (object_t) (new1407_1677);
	 OBJECT_WIDENING_SET(aux_4000, BFALSE);
      }
      return new1407_1677;
   }
}


obj_t 
_allocate_nop_142_cgen_cop(obj_t env_2873)
{
   {
      nop_t aux_4003;
      aux_4003 = allocate_nop_42_cgen_cop();
      return (obj_t) (aux_4003);
   }
}


csequence_t 
allocate_csequence_231_cgen_cop()
{
   {
      csequence_t new1393_1681;
      new1393_1681 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
      {
	 long arg2173_1682;
	 arg2173_1682 = class_num_218___object(csequence_cgen_cop);
	 {
	    obj_t obj_2624;
	    obj_2624 = (obj_t) (new1393_1681);
	    (((obj_t) CREF(obj_2624))->header = MAKE_HEADER(arg2173_1682, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4010;
	 aux_4010 = (object_t) (new1393_1681);
	 OBJECT_WIDENING_SET(aux_4010, BFALSE);
      }
      return new1393_1681;
   }
}


obj_t 
_allocate_csequence_87_cgen_cop(obj_t env_2872)
{
   {
      csequence_t aux_4013;
      aux_4013 = allocate_csequence_231_cgen_cop();
      return (obj_t) (aux_4013);
   }
}


ccast_t 
allocate_ccast_96_cgen_cop()
{
   {
      ccast_t new1379_1687;
      new1379_1687 = ((ccast_t) BREF(GC_MALLOC(sizeof(struct ccast))));
      {
	 long arg2175_1688;
	 arg2175_1688 = class_num_218___object(ccast_cgen_cop);
	 {
	    obj_t obj_2626;
	    obj_2626 = (obj_t) (new1379_1687);
	    (((obj_t) CREF(obj_2626))->header = MAKE_HEADER(arg2175_1688, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4020;
	 aux_4020 = (object_t) (new1379_1687);
	 OBJECT_WIDENING_SET(aux_4020, BFALSE);
      }
      return new1379_1687;
   }
}


obj_t 
_allocate_ccast_222_cgen_cop(obj_t env_2871)
{
   {
      ccast_t aux_4023;
      aux_4023 = allocate_ccast_96_cgen_cop();
      return (obj_t) (aux_4023);
   }
}


cpragma_t 
allocate_cpragma_231_cgen_cop()
{
   {
      cpragma_t new1365_1693;
      new1365_1693 = ((cpragma_t) BREF(GC_MALLOC(sizeof(struct cpragma))));
      {
	 long arg2177_1694;
	 arg2177_1694 = class_num_218___object(cpragma_cgen_cop);
	 {
	    obj_t obj_2628;
	    obj_2628 = (obj_t) (new1365_1693);
	    (((obj_t) CREF(obj_2628))->header = MAKE_HEADER(arg2177_1694, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4030;
	 aux_4030 = (object_t) (new1365_1693);
	 OBJECT_WIDENING_SET(aux_4030, BFALSE);
      }
      return new1365_1693;
   }
}


obj_t 
_allocate_cpragma_102_cgen_cop(obj_t env_2870)
{
   {
      cpragma_t aux_4033;
      aux_4033 = allocate_cpragma_231_cgen_cop();
      return (obj_t) (aux_4033);
   }
}


varc_t 
allocate_varc_53_cgen_cop()
{
   {
      varc_t new1354_1699;
      new1354_1699 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
      {
	 long arg2179_1700;
	 arg2179_1700 = class_num_218___object(varc_cgen_cop);
	 {
	    obj_t obj_2630;
	    obj_2630 = (obj_t) (new1354_1699);
	    (((obj_t) CREF(obj_2630))->header = MAKE_HEADER(arg2179_1700, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4040;
	 aux_4040 = (object_t) (new1354_1699);
	 OBJECT_WIDENING_SET(aux_4040, BFALSE);
      }
      return new1354_1699;
   }
}


obj_t 
_allocate_varc_172_cgen_cop(obj_t env_2869)
{
   {
      varc_t aux_4043;
      aux_4043 = allocate_varc_53_cgen_cop();
      return (obj_t) (aux_4043);
   }
}


catom_t 
allocate_catom_78_cgen_cop()
{
   {
      catom_t new1344_1704;
      new1344_1704 = ((catom_t) BREF(GC_MALLOC(sizeof(struct catom))));
      {
	 long arg2181_1705;
	 arg2181_1705 = class_num_218___object(catom_cgen_cop);
	 {
	    obj_t obj_2632;
	    obj_2632 = (obj_t) (new1344_1704);
	    (((obj_t) CREF(obj_2632))->header = MAKE_HEADER(arg2181_1705, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4050;
	 aux_4050 = (object_t) (new1344_1704);
	 OBJECT_WIDENING_SET(aux_4050, BFALSE);
      }
      return new1344_1704;
   }
}


obj_t 
_allocate_catom_138_cgen_cop(obj_t env_2868)
{
   {
      catom_t aux_4053;
      aux_4053 = allocate_catom_78_cgen_cop();
      return (obj_t) (aux_4053);
   }
}


cvoid_t 
allocate_cvoid_159_cgen_cop()
{
   {
      cvoid_t new1334_1709;
      new1334_1709 = ((cvoid_t) BREF(GC_MALLOC(sizeof(struct cvoid))));
      {
	 long arg2183_1710;
	 arg2183_1710 = class_num_218___object(cvoid_cgen_cop);
	 {
	    obj_t obj_2634;
	    obj_2634 = (obj_t) (new1334_1709);
	    (((obj_t) CREF(obj_2634))->header = MAKE_HEADER(arg2183_1710, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4060;
	 aux_4060 = (object_t) (new1334_1709);
	 OBJECT_WIDENING_SET(aux_4060, BFALSE);
      }
      return new1334_1709;
   }
}


obj_t 
_allocate_cvoid_169_cgen_cop(obj_t env_2867)
{
   {
      cvoid_t aux_4063;
      aux_4063 = allocate_cvoid_159_cgen_cop();
      return (obj_t) (aux_4063);
   }
}


creturn_t 
allocate_creturn_170_cgen_cop()
{
   {
      creturn_t new1324_1714;
      new1324_1714 = ((creturn_t) BREF(GC_MALLOC(sizeof(struct creturn))));
      {
	 long arg2185_1715;
	 arg2185_1715 = class_num_218___object(creturn_cgen_cop);
	 {
	    obj_t obj_2636;
	    obj_2636 = (obj_t) (new1324_1714);
	    (((obj_t) CREF(obj_2636))->header = MAKE_HEADER(arg2185_1715, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4070;
	 aux_4070 = (object_t) (new1324_1714);
	 OBJECT_WIDENING_SET(aux_4070, BFALSE);
      }
      return new1324_1714;
   }
}


obj_t 
_allocate_creturn_205_cgen_cop(obj_t env_2866)
{
   {
      creturn_t aux_4073;
      aux_4073 = allocate_creturn_170_cgen_cop();
      return (obj_t) (aux_4073);
   }
}


block_t 
allocate_block_20_cgen_cop()
{
   {
      block_t new1313_1719;
      new1313_1719 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
      {
	 long arg2187_1720;
	 arg2187_1720 = class_num_218___object(block_cgen_cop);
	 {
	    obj_t obj_2638;
	    obj_2638 = (obj_t) (new1313_1719);
	    (((obj_t) CREF(obj_2638))->header = MAKE_HEADER(arg2187_1720, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4080;
	 aux_4080 = (object_t) (new1313_1719);
	 OBJECT_WIDENING_SET(aux_4080, BFALSE);
      }
      return new1313_1719;
   }
}


obj_t 
_allocate_block_150_cgen_cop(obj_t env_2865)
{
   {
      block_t aux_4083;
      aux_4083 = allocate_block_20_cgen_cop();
      return (obj_t) (aux_4083);
   }
}


cgoto_t 
allocate_cgoto_58_cgen_cop()
{
   {
      cgoto_t new1303_1724;
      new1303_1724 = ((cgoto_t) BREF(GC_MALLOC(sizeof(struct cgoto))));
      {
	 long arg2189_1725;
	 arg2189_1725 = class_num_218___object(cgoto_cgen_cop);
	 {
	    obj_t obj_2640;
	    obj_2640 = (obj_t) (new1303_1724);
	    (((obj_t) CREF(obj_2640))->header = MAKE_HEADER(arg2189_1725, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4090;
	 aux_4090 = (object_t) (new1303_1724);
	 OBJECT_WIDENING_SET(aux_4090, BFALSE);
      }
      return new1303_1724;
   }
}


obj_t 
_allocate_cgoto_159_cgen_cop(obj_t env_2864)
{
   {
      cgoto_t aux_4093;
      aux_4093 = allocate_cgoto_58_cgen_cop();
      return (obj_t) (aux_4093);
   }
}


clabel_t 
allocate_clabel_48_cgen_cop()
{
   {
      clabel_t new1283_1729;
      new1283_1729 = ((clabel_t) BREF(GC_MALLOC(sizeof(struct clabel))));
      {
	 long arg2191_1730;
	 arg2191_1730 = class_num_218___object(clabel_cgen_cop);
	 {
	    obj_t obj_2642;
	    obj_2642 = (obj_t) (new1283_1729);
	    (((obj_t) CREF(obj_2642))->header = MAKE_HEADER(arg2191_1730, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4100;
	 aux_4100 = (object_t) (new1283_1729);
	 OBJECT_WIDENING_SET(aux_4100, BFALSE);
      }
      return new1283_1729;
   }
}


obj_t 
_allocate_clabel_4_cgen_cop(obj_t env_2863)
{
   {
      clabel_t aux_4103;
      aux_4103 = allocate_clabel_48_cgen_cop();
      return (obj_t) (aux_4103);
   }
}


cop_t 
allocate_cop_141_cgen_cop()
{
   {
      cop_t new1275_1736;
      new1275_1736 = ((cop_t) BREF(GC_MALLOC(sizeof(struct cop))));
      {
	 long arg2193_1737;
	 arg2193_1737 = class_num_218___object(cop_cgen_cop);
	 {
	    obj_t obj_2644;
	    obj_2644 = (obj_t) (new1275_1736);
	    (((obj_t) CREF(obj_2644))->header = MAKE_HEADER(arg2193_1737, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_4110;
	 aux_4110 = (object_t) (new1275_1736);
	 OBJECT_WIDENING_SET(aux_4110, BFALSE);
      }
      return new1275_1736;
   }
}


obj_t 
_allocate_cop_129_cgen_cop(obj_t env_2862)
{
   {
      cop_t aux_4113;
      aux_4113 = allocate_cop_141_cgen_cop();
      return (obj_t) (aux_4113);
   }
}


obj_t 
imported_modules_init_94_cgen_cop()
{
   module_initialization_70_type_type(((long) 0), "CGEN_COP");
   module_initialization_70_ast_var(((long) 0), "CGEN_COP");
   return module_initialization_70_ast_node(((long) 0), "CGEN_COP");
}
