/*===========================================================================*/
/*   (Cgen/emit-cop.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct cop
  {
     header_t header;
     obj_t widening;
  }
   *cop_t;

typedef struct clabel
  {
     header_t header;
     obj_t widening;
     obj_t name;
     bool_t used__226;
     obj_t body;
  }
      *clabel_t;

typedef struct cgoto
  {
     header_t header;
     obj_t widening;
     struct clabel *label;
  }
     *cgoto_t;

typedef struct block
  {
     header_t header;
     obj_t widening;
     struct cop *body;
  }
     *block_t;

typedef struct creturn
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
       *creturn_t;

typedef struct cvoid
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
     *cvoid_t;

typedef struct catom
  {
     header_t header;
     obj_t widening;
     obj_t value;
  }
     *catom_t;

typedef struct varc
  {
     header_t header;
     obj_t widening;
     struct variable *variable;
  }
    *varc_t;

typedef struct cpragma
  {
     header_t header;
     obj_t widening;
     obj_t format;
     obj_t args;
  }
       *cpragma_t;

typedef struct ccast
  {
     header_t header;
     obj_t widening;
     struct type *type;
     struct cop *arg;
  }
     *ccast_t;

typedef struct csequence
  {
     header_t header;
     obj_t widening;
     bool_t c_exp__163;
     obj_t cops;
  }
         *csequence_t;

typedef struct nop
  {
     header_t header;
     obj_t widening;
  }
   *nop_t;

typedef struct stop
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
    *stop_t;

typedef struct csetq
  {
     header_t header;
     obj_t widening;
     struct varc *var;
     struct cop *value;
  }
     *csetq_t;

typedef struct cif
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     struct cop *true;
     struct cop *false;
  }
   *cif_t;

typedef struct branch
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     struct cop *true;
     struct cop *false;
     struct cop *end;
  }
      *branch_t;

typedef struct local_var_164
  {
     header_t header;
     obj_t widening;
     obj_t vars;
  }
             *local_var_164_t;

typedef struct cfuncall
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     obj_t args;
     obj_t strength;
  }
        *cfuncall_t;

typedef struct capply
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     struct cop *arg;
  }
      *capply_t;

typedef struct capp
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     obj_t args;
  }
    *capp_t;

typedef struct cfail
  {
     header_t header;
     obj_t widening;
     struct cop *proc;
     struct cop *msg;
     struct cop *obj;
  }
     *cfail_t;

typedef struct cswitch
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     obj_t clauses;
  }
       *cswitch_t;

typedef struct cmake_box_177
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
             *cmake_box_177_t;

typedef struct cbox_ref_44
  {
     header_t header;
     obj_t widening;
     struct cop *var;
  }
           *cbox_ref_44_t;

typedef struct cbox_set__132
  {
     header_t header;
     obj_t widening;
     struct cop *var;
     struct cop *value;
  }
             *cbox_set__132_t;

typedef struct cset_ex_it_123
  {
     header_t header;
     obj_t widening;
     struct cop *exit;
     struct cop *jump_value_221;
     struct cop *body;
  }
              *cset_ex_it_123_t;

typedef struct cjump_ex_it_131
  {
     header_t header;
     obj_t widening;
     struct cop *exit;
     struct cop *value;
  }
               *cjump_ex_it_131_t;

typedef struct sfun_c_188
  {
     struct clabel *label;
     bool_t integrated;
  }
          *sfun_c_188_t;


extern obj_t string_for_read(obj_t);
extern obj_t cswitch_cgen_cop;
extern obj_t string__number_104___r4_numbers_6_5(obj_t, obj_t);
static obj_t emit_atom_value_68_cgen_emit_cop_239(obj_t);
extern obj_t stop_cgen_cop;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t cbox_ref_44_cgen_cop;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
extern obj_t make_typed_declaration_180_type_tools(type_t, obj_t);
extern obj_t list__vector_101___r4_vectors_6_8(obj_t);
static obj_t imported_modules_init_94_cgen_emit_cop_239();
extern obj_t catom_cgen_cop;
extern obj_t module_initialization_70_cgen_emit_cop_239(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cgen_emit(long, char *);
extern obj_t module_initialization_70_cgen_cop(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_vectors_6_8(long, char *);
extern obj_t module_initialization_70___r4_input_6_10_2(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t newline___r4_output_6_10_3(obj_t);
static obj_t toplevel_init_63_cgen_emit_cop_239();
static obj_t cnst_init_137_cgen_emit_cop_239();
static bool_t emit_cop_default1443_120_cgen_emit_cop_239(cop_t);
static bool_t emit_regular_cfuncall_eoa_48_cgen_emit_cop_239(cfuncall_t);
extern obj_t cvoid_cgen_cop;
extern obj_t creturn_cgen_cop;
extern obj_t __about_to_read__202___r4_input_6_10_2;
extern obj_t cfun_ast_var;
extern obj_t __stdc__25_engine_param;
extern obj_t __real__144_type_cache;
extern obj_t cjump_ex_it_131_cgen_cop;
extern obj_t cgoto_cgen_cop;
extern obj_t string_sans___40_type_tools(obj_t);
extern obj_t capply_cgen_cop;
static obj_t require_initialization_114_cgen_emit_cop_239 = BUNSPEC;
extern obj_t __bool__149_type_cache;
extern obj_t clabel_cgen_cop;
static obj_t library_modules_init_112_cgen_emit_cop_239();
extern obj_t cset_ex_it_123_cgen_cop;
extern obj_t capp_cgen_cop;
extern obj_t __c_port__188_cgen_emit;
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t cfail_cgen_cop;
extern obj_t open_input_string(obj_t);
extern obj_t cif_cgen_cop;
static obj_t _emit_cop_default1443_113_cgen_emit_cop_239(obj_t, obj_t);
extern obj_t __long__149_type_cache;
extern obj_t cbox_set__132_cgen_cop;
extern obj_t csetq_cgen_cop;
extern obj_t untrigraph_cgen_emit_cop_239(obj_t);
extern obj_t _untrigraph_cgen_emit_cop_239(obj_t, obj_t);
extern obj_t cpragma_cgen_cop;
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern obj_t make_string(long, unsigned char);
extern obj_t _emit_cop_216_cgen_emit_cop_239(obj_t, obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t display___r4_output_6_10_3(obj_t, obj_t);
static obj_t lambda19102255_cgen_emit_cop_239(obj_t, obj_t);
extern obj_t cmake_box_177_cgen_cop;
extern obj_t local_var_164_cgen_cop;
extern obj_t varc_cgen_cop;
extern obj_t write_char_165___r4_output_6_10_3(unsigned char, obj_t);
extern bool_t emit_cop_45_cgen_emit_cop_239(cop_t);
extern obj_t ccast_cgen_cop;
extern obj_t __char__84_type_cache;
extern obj_t block_cgen_cop;
extern obj_t input_port_get_string(obj_t);
extern obj_t nop_cgen_cop;
extern bool_t input_port_fill_buffer(obj_t);
extern obj_t cfuncall_cgen_cop;
extern obj_t c_substring(obj_t, long, long);
extern obj_t branch_cgen_cop;
extern obj_t csequence_cgen_cop;
static obj_t __cnst[4];

DEFINE_STRING(string2262_cgen_emit_cop_239, string2262_cgen_emit_cop_2392300, " else ", 6);
DEFINE_EXPORT_GENERIC(emit_cop_env_125_cgen_emit_cop_239, _emit_cop_216_cgen_emit_cop_2392301, _emit_cop_216_cgen_emit_cop_239, 0L, 1);
DEFINE_STRING(string2261_cgen_emit_cop_239, string2261_cgen_emit_cop_2392302, "if(", 3);
DEFINE_EXPORT_PROCEDURE(untrigraph_env_176_cgen_emit_cop_239, _untrigraph_cgen_emit_cop_2392303, _untrigraph_cgen_emit_cop_239, 0L, 1);
DEFINE_STRING(string2292_cgen_emit_cop_239, string2292_cgen_emit_cop_2392304, "BUNSPEC", 7);
DEFINE_STRING(string2278_cgen_emit_cop_239, string2278_cgen_emit_cop_2392305, "break;", 6);
DEFINE_STRING(string2285_cgen_emit_cop_239, string2285_cgen_emit_cop_2392306, "} else {", 8);
DEFINE_STRING(string2277_cgen_emit_cop_239, string2277_cgen_emit_cop_2392307, "case ", 5);
DEFINE_STRING(string2267_cgen_emit_cop_239, string2267_cgen_emit_cop_2392308, "PROCEDURE_ENTRY(", 16);
DEFINE_STRING(string2263_cgen_emit_cop_239, string2263_cgen_emit_cop_2392309, "(VA_PROCUDUREP( ", 16);
DEFINE_STRING(string2288_cgen_emit_cop_239, string2288_cgen_emit_cop_2392310, "token too large", 15);
DEFINE_STRING(string2274_cgen_emit_cop_239, string2274_cgen_emit_cop_2392311, ");", 2);
DEFINE_STRING(string2286_cgen_emit_cop_239, string2286_cgen_emit_cop_2392312, "JUMP_EXIT( ", 11);
DEFINE_STRING(string2256_cgen_emit_cop_239, string2256_cgen_emit_cop_2392313, "No method for this object", 25);
DEFINE_STATIC_PROCEDURE(emit_cop_default1443_env_192_cgen_emit_cop_239, _emit_cop_default1443_113_cgen_emit_cop_2392314, _emit_cop_default1443_113_cgen_emit_cop_239, 0L, 1);
DEFINE_STRING(string2294_cgen_emit_cop_239, string2294_cgen_emit_cop_2392315, "ELSE LIGHT ELIGHT EMIT-COP-DEFAULT1443 ", 39);
DEFINE_STRING(string2257_cgen_emit_cop_239, string2257_cgen_emit_cop_2392316, "goto ", 5);
DEFINE_STRING(string2291_cgen_emit_cop_239, string2291_cgen_emit_cop_2392317, "\\''", 3);
DEFINE_STRING(string2293_cgen_emit_cop_239, string2293_cgen_emit_cop_2392318, "BCNST(", 6);
DEFINE_STRING(string2268_cgen_emit_cop_239, string2268_cgen_emit_cop_2392319, ")(", 2);
DEFINE_STRING(string2265_cgen_emit_cop_239, string2265_cgen_emit_cop_2392320, " : ", 3);
DEFINE_STRING(string2270_cgen_emit_cop_239, string2270_cgen_emit_cop_2392321, ", ", 2);
DEFINE_STRING(string2282_cgen_emit_cop_239, string2282_cgen_emit_cop_2392322, "if( SET_EXIT(", 13);
DEFINE_STRING(string2289_cgen_emit_cop_239, string2289_cgen_emit_cop_2392323, "BNIL", 4);
DEFINE_STRING(string2264_cgen_emit_cop_239, string2264_cgen_emit_cop_2392324, " ) ? ", 5);
DEFINE_STRING(string2269_cgen_emit_cop_239, string2269_cgen_emit_cop_2392325, ")", 1);
DEFINE_STRING(string2259_cgen_emit_cop_239, string2259_cgen_emit_cop_2392326, "((", 2);
DEFINE_STRING(string2258_cgen_emit_cop_239, string2258_cgen_emit_cop_2392327, "return ", 7);
DEFINE_STRING(string2287_cgen_emit_cop_239, string2287_cgen_emit_cop_2392328, "regular-grammar", 15);
DEFINE_STRING(string2275_cgen_emit_cop_239, string2275_cgen_emit_cop_2392329, "switch ", 7);
DEFINE_STRING(string2260_cgen_emit_cop_239, string2260_cgen_emit_cop_2392330, " = ", 3);
DEFINE_STRING(string2290_cgen_emit_cop_239, string2290_cgen_emit_cop_2392331, "'\\000'", 6);
DEFINE_STRING(string2279_cgen_emit_cop_239, string2279_cgen_emit_cop_2392332, "MAKE_CELL(", 10);
DEFINE_STRING(string2283_cgen_emit_cop_239, string2283_cgen_emit_cop_2392333, ") ) {", 5);
DEFINE_STRING(string2271_cgen_emit_cop_239, string2271_cgen_emit_cop_2392334, "PROCEDURE_L_ENTRY(", 18);
DEFINE_STRING(string2266_cgen_emit_cop_239, string2266_cgen_emit_cop_2392335, " )", 2);
DEFINE_STRING(string2284_cgen_emit_cop_239, string2284_cgen_emit_cop_2392336, "RESTORE_TRACE(); ", 17);
DEFINE_STRING(string2276_cgen_emit_cop_239, string2276_cgen_emit_cop_2392337, "default: ", 9);
DEFINE_STRING(string2281_cgen_emit_cop_239, string2281_cgen_emit_cop_2392338, "CELL_SET(", 9);
DEFINE_STRING(string2273_cgen_emit_cop_239, string2273_cgen_emit_cop_2392339, "FAILURE(", 8);
DEFINE_STRING(string2272_cgen_emit_cop_239, string2272_cgen_emit_cop_2392340, "apply(", 6);
DEFINE_STRING(string2280_cgen_emit_cop_239, string2280_cgen_emit_cop_2392341, "CELL_REF(", 9);

obj_t 
module_initialization_70_cgen_emit_cop_239(long checksum_2472, char *from_2473)
{
   if (CBOOL(require_initialization_114_cgen_emit_cop_239))
     {
	require_initialization_114_cgen_emit_cop_239 = BBOOL(((bool_t) 0));
	library_modules_init_112_cgen_emit_cop_239();
	cnst_init_137_cgen_emit_cop_239();
	imported_modules_init_94_cgen_emit_cop_239();
	toplevel_init_63_cgen_emit_cop_239();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cgen_emit_cop_239()
{
   module_initialization_70___r4_numbers_6_5(((long) 0), "CGEN_EMIT-COP");
   module_initialization_70___object(((long) 0), "CGEN_EMIT-COP");
   module_initialization_70___r4_output_6_10_3(((long) 0), "CGEN_EMIT-COP");
   module_initialization_70___r4_vectors_6_8(((long) 0), "CGEN_EMIT-COP");
   module_initialization_70___r4_input_6_10_2(((long) 0), "CGEN_EMIT-COP");
   module_initialization_70___reader(((long) 0), "CGEN_EMIT-COP");
   module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "CGEN_EMIT-COP");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cgen_emit_cop_239()
{
   {
      obj_t cnst_port_138_2464;
      cnst_port_138_2464 = open_input_string(string2294_cgen_emit_cop_239);
      {
	 long i_2465;
	 i_2465 = ((long) 3);
       loop_2466:
	 {
	    bool_t test2295_2467;
	    test2295_2467 = (i_2465 == ((long) -1));
	    if (test2295_2467)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2296_2468;
		    {
		       obj_t list2297_2469;
		       {
			  obj_t arg2298_2470;
			  arg2298_2470 = BNIL;
			  list2297_2469 = MAKE_PAIR(cnst_port_138_2464, arg2298_2470);
		       }
		       arg2296_2468 = read___reader(list2297_2469);
		    }
		    CNST_TABLE_SET(i_2465, arg2296_2468);
		 }
		 {
		    int aux_2471;
		    {
		       long aux_2494;
		       aux_2494 = (i_2465 - ((long) 1));
		       aux_2471 = (int) (aux_2494);
		    }
		    {
		       long i_2497;
		       i_2497 = (long) (aux_2471);
		       i_2465 = i_2497;
		       goto loop_2466;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cgen_emit_cop_239()
{
   add_generic__110___object(emit_cop_env_125_cgen_emit_cop_239, emit_cop_default1443_env_192_cgen_emit_cop_239);
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, clabel_cgen_cop, ((long) 0));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cgoto_cgen_cop, ((long) 1));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, block_cgen_cop, ((long) 2));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, creturn_cgen_cop, ((long) 3));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, catom_cgen_cop, ((long) 4));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cvoid_cgen_cop, ((long) 5));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, varc_cgen_cop, ((long) 6));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cpragma_cgen_cop, ((long) 7));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, ccast_cgen_cop, ((long) 8));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, csequence_cgen_cop, ((long) 9));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, nop_cgen_cop, ((long) 10));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, stop_cgen_cop, ((long) 11));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, csetq_cgen_cop, ((long) 12));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cif_cgen_cop, ((long) 13));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, branch_cgen_cop, ((long) 14));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, local_var_164_cgen_cop, ((long) 15));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cfuncall_cgen_cop, ((long) 16));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, capply_cgen_cop, ((long) 17));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, capp_cgen_cop, ((long) 18));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cfail_cgen_cop, ((long) 19));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cswitch_cgen_cop, ((long) 20));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cmake_box_177_cgen_cop, ((long) 21));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cbox_ref_44_cgen_cop, ((long) 22));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cbox_set__132_cgen_cop, ((long) 23));
   add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cset_ex_it_123_cgen_cop, ((long) 24));
   {
      long aux_2525;
      aux_2525 = add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cjump_ex_it_131_cgen_cop, ((long) 25));
      return BINT(aux_2525);
   }
}


bool_t 
emit_cop_default1443_120_cgen_emit_cop_239(cop_t cop_2)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string2256_cgen_emit_cop_239, (obj_t) (cop_2));
}


obj_t 
_emit_cop_default1443_113_cgen_emit_cop_239(obj_t env_2455, obj_t cop_2456)
{
   {
      bool_t aux_2531;
      aux_2531 = emit_cop_default1443_120_cgen_emit_cop_239((cop_t) (cop_2456));
      return BBOOL(aux_2531);
   }
}


bool_t 
emit_cop_45_cgen_emit_cop_239(cop_t cop_1)
{
   {
      obj_t method1837_1500;
      obj_t class1842_1501;
      {
	 obj_t arg1855_1498;
	 obj_t arg1856_1499;
	 {
	    object_t obj_2017;
	    obj_2017 = (object_t) (cop_1);
	    {
	       obj_t pre_method_105_2018;
	       pre_method_105_2018 = PROCEDURE_REF(emit_cop_env_125_cgen_emit_cop_239, ((long) 2));
	       if (INTEGERP(pre_method_105_2018))
		 {
		    PROCEDURE_SET(emit_cop_env_125_cgen_emit_cop_239, ((long) 2), BUNSPEC);
		    arg1855_1498 = pre_method_105_2018;
		 }
	       else
		 {
		    long obj_class_num_177_2023;
		    obj_class_num_177_2023 = TYPE(obj_2017);
		    {
		       obj_t arg1183_2024;
		       arg1183_2024 = PROCEDURE_REF(emit_cop_env_125_cgen_emit_cop_239, ((long) 1));
		       {
			  long arg1184_2028;
			  {
			     long arg1186_2029;
			     arg1186_2029 = OBJECT_TYPE;
			     arg1184_2028 = (obj_class_num_177_2023 - arg1186_2029);
			  }
			  arg1855_1498 = VECTOR_REF(arg1183_2024, arg1184_2028);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_2034;
	    object_2034 = (object_t) (cop_1);
	    {
	       long arg1187_2035;
	       {
		  long arg1188_2036;
		  long arg1189_2037;
		  arg1188_2036 = TYPE(object_2034);
		  arg1189_2037 = OBJECT_TYPE;
		  arg1187_2035 = (arg1188_2036 - arg1189_2037);
	       }
	       {
		  obj_t vector_2041;
		  vector_2041 = __classes__134___object;
		  arg1856_1499 = VECTOR_REF(vector_2041, arg1187_2035);
	       }
	    }
	 }
	 {
	    obj_t aux_2550;
	    method1837_1500 = arg1855_1498;
	    class1842_1501 = arg1856_1499;
	    {
	       if (INTEGERP(method1837_1500))
		 {
		    switch ((long) CINT(method1837_1500))
		      {
		      case ((long) 0):
			 {
			    clabel_t cop_1507;
			    cop_1507 = (clabel_t) (cop_1);
			    if ((((clabel_t) CREF(cop_1507))->used__226))
			      {
				 {
				    obj_t arg1860_1510;
				    arg1860_1510 = (((clabel_t) CREF(cop_1507))->name);
				    {
				       obj_t list1861_1511;
				       list1861_1511 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				       display___r4_output_6_10_3(arg1860_1510, list1861_1511);
				    }
				 }
				 {
				    obj_t list1863_1513;
				    list1863_1513 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				    write_char_165___r4_output_6_10_3(((unsigned char) ':'), list1863_1513);
				 }
				 {
				    obj_t list1865_1515;
				    list1865_1515 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				    newline___r4_output_6_10_3(list1865_1515);
				 }
			      }
			    else
			      {
				 BUNSPEC;
			      }
			    {
			       bool_t aux_2563;
			       {
				  cop_t aux_2564;
				  {
				     obj_t aux_2565;
				     aux_2565 = (((clabel_t) CREF(cop_1507))->body);
				     aux_2564 = (cop_t) (aux_2565);
				  }
				  aux_2563 = emit_cop_45_cgen_emit_cop_239(aux_2564);
			       }
			       aux_2550 = BBOOL(aux_2563);
			    }
			 }
			 break;
		      case ((long) 1):
			 {
			    cgoto_t cop_1518;
			    cop_1518 = (cgoto_t) (cop_1);
			    {
			       obj_t arg1871_1521;
			       {
				  clabel_t arg1877_1526;
				  arg1877_1526 = (((cgoto_t) CREF(cop_1518))->label);
				  arg1871_1521 = (((clabel_t) CREF(arg1877_1526))->name);
			       }
			       {
				  obj_t list1872_1522;
				  {
				     obj_t arg1874_1523;
				     {
					obj_t arg1875_1524;
					{
					   obj_t aux_2573;
					   aux_2573 = BCHAR(((unsigned char) ';'));
					   arg1875_1524 = MAKE_PAIR(aux_2573, BNIL);
					}
					arg1874_1523 = MAKE_PAIR(arg1871_1521, arg1875_1524);
				     }
				     list1872_1522 = MAKE_PAIR(string2257_cgen_emit_cop_239, arg1874_1523);
				  }
				  fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1872_1522);
			       }
			    }
			    aux_2550 = BFALSE;
			 }
			 break;
		      case ((long) 2):
			 {
			    block_t cop_1527;
			    cop_1527 = (block_t) (cop_1);
			    {
			       bool_t test1878_1529;
			       {
				  obj_t aux_2580;
				  {
				     cop_t aux_2581;
				     aux_2581 = (((block_t) CREF(cop_1527))->body);
				     aux_2580 = (obj_t) (aux_2581);
				  }
				  test1878_1529 = is_a__118___object(aux_2580, block_cgen_cop);
			       }
			       if (test1878_1529)
				 {
				    bool_t aux_2586;
				    aux_2586 = emit_cop_45_cgen_emit_cop_239((((block_t) CREF(cop_1527))->body));
				    aux_2550 = BBOOL(aux_2586);
				 }
			       else
				 {
				    {
				       obj_t list1880_1531;
				       list1880_1531 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				       write_char_165___r4_output_6_10_3(((unsigned char) '{'), list1880_1531);
				    }
				    {
				       obj_t list1882_1533;
				       list1882_1533 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				       newline___r4_output_6_10_3(list1882_1533);
				    }
				    {
				       bool_t test1884_1535;
				       test1884_1535 = emit_cop_45_cgen_emit_cop_239((((block_t) CREF(cop_1527))->body));
				       if (test1884_1535)
					 {
					    obj_t list1885_1536;
					    {
					       obj_t aux_2597;
					       aux_2597 = BCHAR(((unsigned char) ';'));
					       list1885_1536 = MAKE_PAIR(aux_2597, BNIL);
					    }
					    fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1885_1536);
					 }
				       else
					 {
					    BUNSPEC;
					 }
				    }
				    {
				       obj_t list1888_1539;
				       list1888_1539 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				       write_char_165___r4_output_6_10_3(((unsigned char) '}'), list1888_1539);
				    }
				    {
				       obj_t list1890_1541;
				       list1890_1541 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				       newline___r4_output_6_10_3(list1890_1541);
				    }
				    aux_2550 = BFALSE;
				 }
			    }
			 }
			 break;
		      case ((long) 3):
			 {
			    creturn_t cop_1544;
			    cop_1544 = (creturn_t) (cop_1);
			    {
			       obj_t list1893_1546;
			       list1893_1546 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2258_cgen_emit_cop_239, list1893_1546);
			    }
			    {
			       bool_t test1895_1548;
			       test1895_1548 = emit_cop_45_cgen_emit_cop_239((((creturn_t) CREF(cop_1544))->value));
			       if (test1895_1548)
				 {
				    obj_t list1896_1549;
				    {
				       obj_t aux_2611;
				       aux_2611 = BCHAR(((unsigned char) ';'));
				       list1896_1549 = MAKE_PAIR(aux_2611, BNIL);
				    }
				    fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1896_1549);
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    aux_2550 = BFALSE;
			 }
			 break;
		      case ((long) 4):
			 {
			    catom_t cop_1552;
			    cop_1552 = (catom_t) (cop_1);
			    emit_atom_value_68_cgen_emit_cop_239((((catom_t) CREF(cop_1552))->value));
			    aux_2550 = BTRUE;
			 }
			 break;
		      case ((long) 5):
			 {
			    cvoid_t cop_1555;
			    cop_1555 = (cvoid_t) (cop_1);
			    {
			       bool_t aux_2619;
			       aux_2619 = emit_cop_45_cgen_emit_cop_239((((cvoid_t) CREF(cop_1555))->value));
			       aux_2550 = BBOOL(aux_2619);
			    }
			 }
			 break;
		      case ((long) 6):
			 {
			    varc_t cop_1558;
			    cop_1558 = (varc_t) (cop_1);
			    {
			       obj_t arg1901_1560;
			       {
				  variable_t arg1905_1563;
				  arg1905_1563 = (((varc_t) CREF(cop_1558))->variable);
				  arg1901_1560 = (((variable_t) CREF(arg1905_1563))->name);
			       }
			       {
				  obj_t list1902_1561;
				  list1902_1561 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				  display___r4_output_6_10_3(arg1901_1560, list1902_1561);
			       }
			    }
			    aux_2550 = BTRUE;
			 }
			 break;
		      case ((long) 7):
			 {
			    cpragma_t cop_1564;
			    cop_1564 = (cpragma_t) (cop_1);
			    {
			       bool_t test_2629;
			       {
				  obj_t aux_2630;
				  aux_2630 = (((cpragma_t) CREF(cop_1564))->args);
				  test_2629 = NULLP(aux_2630);
			       }
			       if (test_2629)
				 {
				    obj_t arg1907_1567;
				    arg1907_1567 = (((cpragma_t) CREF(cop_1564))->format);
				    {
				       obj_t list1908_1568;
				       list1908_1568 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				       aux_2550 = display___r4_output_6_10_3(arg1907_1567, list1908_1568);
				    }
				 }
			       else
				 {
				    obj_t sport_1570;
				    {
				       obj_t aux_2636;
				       aux_2636 = (((cpragma_t) CREF(cop_1564))->format);
				       sport_1570 = open_input_string(aux_2636);
				    }
				    {
				       obj_t args_1571;
				       args_1571 = list__vector_101___r4_vectors_6_8((((cpragma_t) CREF(cop_1564))->args));
				       {
					  obj_t parser_1572;
					  {
					     obj_t lambda1910_2457;
					     lambda1910_2457 = MAKE_EL_PROCEDURE_1(((long) 1));
					     PROCEDURE_1_EL_SET(lambda1910_2457, ((long) 0), args_1571);
					     parser_1572 = lambda1910_2457;
					  }
					  {
					     lambda19102255_cgen_emit_cop_239(parser_1572, sport_1570);
					     aux_2550 = BTRUE;
					  }
				       }
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 8):
			 {
			    ccast_t cop_1650;
			    cop_1650 = (ccast_t) (cop_1);
			    {
			       obj_t list1941_1652;
			       list1941_1652 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2259_cgen_emit_cop_239, list1941_1652);
			    }
			    {
			       obj_t arg1943_1654;
			       {
				  type_t arg1947_1657;
				  arg1947_1657 = (((ccast_t) CREF(cop_1650))->type);
				  arg1943_1654 = (((type_t) CREF(arg1947_1657))->name);
			       }
			       {
				  obj_t list1944_1655;
				  list1944_1655 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				  display___r4_output_6_10_3(arg1943_1654, list1944_1655);
			       }
			    }
			    {
			       obj_t list1948_1658;
			       list1948_1658 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) ')'), list1948_1658);
			    }
			    emit_cop_45_cgen_emit_cop_239((((ccast_t) CREF(cop_1650))->arg));
			    {
			       obj_t list1951_1661;
			       list1951_1661 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) ')'), list1951_1661);
			    }
			    aux_2550 = BTRUE;
			 }
			 break;
		      case ((long) 9):
			 {
			    csequence_t cop_1663;
			    cop_1663 = (csequence_t) (cop_1);
			    if ((((csequence_t) CREF(cop_1663))->c_exp__163))
			      {
				 {
				    bool_t test_2661;
				    {
				       obj_t aux_2662;
				       aux_2662 = (((csequence_t) CREF(cop_1663))->cops);
				       test_2661 = NULLP(aux_2662);
				    }
				    if (test_2661)
				      {
					 aux_2550 = emit_atom_value_68_cgen_emit_cop_239(BUNSPEC);
				      }
				    else
				      {
					 {
					    obj_t list1955_1667;
					    list1955_1667 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
					    write_char_165___r4_output_6_10_3(((unsigned char) '('), list1955_1667);
					 }
					 {
					    obj_t exp_1669;
					    {
					       bool_t aux_2668;
					       exp_1669 = (((csequence_t) CREF(cop_1663))->cops);
					     liip_1670:
					       {
						  bool_t test_2669;
						  {
						     obj_t aux_2670;
						     aux_2670 = CDR(exp_1669);
						     test_2669 = NULLP(aux_2670);
						  }
						  if (test_2669)
						    {
						       {
							  cop_t aux_2673;
							  {
							     obj_t aux_2674;
							     aux_2674 = CAR(exp_1669);
							     aux_2673 = (cop_t) (aux_2674);
							  }
							  emit_cop_45_cgen_emit_cop_239(aux_2673);
						       }
						       {
							  obj_t list1961_1674;
							  list1961_1674 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
							  write_char_165___r4_output_6_10_3(((unsigned char) ')'), list1961_1674);
						       }
						       aux_2668 = ((bool_t) 1);
						    }
						  else
						    {
						       {
							  cop_t aux_2680;
							  {
							     obj_t aux_2681;
							     aux_2681 = CAR(exp_1669);
							     aux_2680 = (cop_t) (aux_2681);
							  }
							  emit_cop_45_cgen_emit_cop_239(aux_2680);
						       }
						       {
							  bool_t test1965_1677;
							  test1965_1677 = is_a__118___object(CAR(exp_1669), cfail_cgen_cop);
							  if (test1965_1677)
							    {
							       {
								  obj_t list1966_1678;
								  list1966_1678 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
								  write_char_165___r4_output_6_10_3(((unsigned char) ')'), list1966_1678);
							       }
							       aux_2668 = ((bool_t) 1);
							    }
							  else
							    {
							       {
								  obj_t list1968_1680;
								  list1968_1680 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
								  write_char_165___r4_output_6_10_3(((unsigned char) ','), list1968_1680);
							       }
							       {
								  obj_t list1970_1682;
								  list1970_1682 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
								  newline___r4_output_6_10_3(list1970_1682);
							       }
							       {
								  obj_t exp_2694;
								  exp_2694 = CDR(exp_1669);
								  exp_1669 = exp_2694;
								  goto liip_1670;
							       }
							    }
						       }
						    }
					       }
					       aux_2550 = BBOOL(aux_2668);
					    }
					 }
				      }
				 }
			      }
			    else
			      {
				 obj_t exp_1688;
				 {
				    bool_t aux_2698;
				    exp_1688 = (((csequence_t) CREF(cop_1663))->cops);
				  liip_1689:
				    if (NULLP(exp_1688))
				      {
					 aux_2698 = ((bool_t) 0);
				      }
				    else
				      {
					 obj_t e_1692;
					 e_1692 = CAR(exp_1688);
					 {
					    bool_t test1978_1693;
					    test1978_1693 = emit_cop_45_cgen_emit_cop_239((cop_t) (e_1692));
					    if (test1978_1693)
					      {
						 obj_t list1979_1694;
						 {
						    obj_t aux_2705;
						    aux_2705 = BCHAR(((unsigned char) ';'));
						    list1979_1694 = MAKE_PAIR(aux_2705, BNIL);
						 }
						 fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1979_1694);
					      }
					    else
					      {
						 BUNSPEC;
					      }
					 }
					 {
					    bool_t test1981_1696;
					    test1981_1696 = is_a__118___object(e_1692, cfail_cgen_cop);
					    if (test1981_1696)
					      {
						 obj_t exp_2711;
						 exp_2711 = BNIL;
						 exp_1688 = exp_2711;
						 goto liip_1689;
					      }
					    else
					      {
						 obj_t exp_2712;
						 exp_2712 = CDR(exp_1688);
						 exp_1688 = exp_2712;
						 goto liip_1689;
					      }
					 }
				      }
				    aux_2550 = BBOOL(aux_2698);
				 }
			      }
			 }
			 break;
		      case ((long) 10):
			 {
			    obj_t list1984_1700;
			    {
			       obj_t aux_2716;
			       aux_2716 = BCHAR(((unsigned char) ';'));
			       list1984_1700 = MAKE_PAIR(aux_2716, BNIL);
			    }
			    fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1984_1700);
			 }
			 aux_2550 = BFALSE;
			 break;
		      case ((long) 11):
			 {
			    stop_t cop_1702;
			    cop_1702 = (stop_t) (cop_1);
			    {
			       bool_t test1986_1704;
			       test1986_1704 = emit_cop_45_cgen_emit_cop_239((((stop_t) CREF(cop_1702))->value));
			       if (test1986_1704)
				 {
				    obj_t list1987_1705;
				    {
				       obj_t aux_2724;
				       aux_2724 = BCHAR(((unsigned char) ';'));
				       list1987_1705 = MAKE_PAIR(aux_2724, BNIL);
				    }
				    fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1987_1705);
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    aux_2550 = BFALSE;
			 }
			 break;
		      case ((long) 12):
			 {
			    csetq_t cop_1708;
			    cop_1708 = (csetq_t) (cop_1);
			    {
			       cop_t aux_2729;
			       {
				  varc_t aux_2730;
				  aux_2730 = (((csetq_t) CREF(cop_1708))->var);
				  aux_2729 = (cop_t) (aux_2730);
			       }
			       emit_cop_45_cgen_emit_cop_239(aux_2729);
			    }
			    {
			       obj_t list1991_1711;
			       list1991_1711 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2260_cgen_emit_cop_239, list1991_1711);
			    }
			    emit_cop_45_cgen_emit_cop_239((((csetq_t) CREF(cop_1708))->value));
			    aux_2550 = BTRUE;
			 }
			 break;
		      case ((long) 13):
			 {
			    cif_t cop_1714;
			    cop_1714 = (cif_t) (cop_1);
			    {
			       obj_t list1994_1716;
			       list1994_1716 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2261_cgen_emit_cop_239, list1994_1716);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cif_t) CREF(cop_1714))->test));
			    {
			       obj_t list1997_1719;
			       list1997_1719 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) ')'), list1997_1719);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cif_t) CREF(cop_1714))->true));
			    {
			       obj_t list2000_1722;
			       list2000_1722 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2262_cgen_emit_cop_239, list2000_1722);
			    }
			    {
			       bool_t aux_2749;
			       aux_2749 = emit_cop_45_cgen_emit_cop_239((((cif_t) CREF(cop_1714))->false));
			       aux_2550 = BBOOL(aux_2749);
			    }
			 }
			 break;
		      case ((long) 14):
			 {
			    branch_t cop_1725;
			    cop_1725 = (branch_t) (cop_1);
			    emit_cop_45_cgen_emit_cop_239((((branch_t) CREF(cop_1725))->test));
			    {
			       bool_t test2004_1728;
			       test2004_1728 = emit_cop_45_cgen_emit_cop_239((((branch_t) CREF(cop_1725))->true));
			       if (test2004_1728)
				 {
				    obj_t list2005_1729;
				    {
				       obj_t aux_2759;
				       aux_2759 = BCHAR(((unsigned char) ';'));
				       list2005_1729 = MAKE_PAIR(aux_2759, BNIL);
				    }
				    fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list2005_1729);
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       bool_t test2008_1732;
			       test2008_1732 = emit_cop_45_cgen_emit_cop_239((((branch_t) CREF(cop_1725))->false));
			       if (test2008_1732)
				 {
				    obj_t list2009_1733;
				    {
				       obj_t aux_2766;
				       aux_2766 = BCHAR(((unsigned char) ';'));
				       list2009_1733 = MAKE_PAIR(aux_2766, BNIL);
				    }
				    fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list2009_1733);
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       bool_t aux_2770;
			       aux_2770 = emit_cop_45_cgen_emit_cop_239((((branch_t) CREF(cop_1725))->end));
			       aux_2550 = BBOOL(aux_2770);
			    }
			 }
			 break;
		      case ((long) 15):
			 {
			    local_var_164_t cop_1737;
			    cop_1737 = (local_var_164_t) (cop_1);
			    {
			       obj_t l1428_1739;
			       l1428_1739 = (((local_var_164_t) CREF(cop_1737))->vars);
			     lname1430_1740:
			       if (PAIRP(l1428_1739))
				 {
				    {
				       obj_t local_1743;
				       local_1743 = CAR(l1428_1739);
				       {
					  obj_t arg2017_1744;
					  {
					     obj_t aux_2781;
					     type_t aux_2778;
					     {
						local_t obj_2146;
						obj_2146 = (local_t) (local_1743);
						aux_2781 = (((local_t) CREF(obj_2146))->name);
					     }
					     {
						local_t obj_2145;
						obj_2145 = (local_t) (local_1743);
						aux_2778 = (((local_t) CREF(obj_2145))->type);
					     }
					     arg2017_1744 = make_typed_declaration_180_type_tools(aux_2778, aux_2781);
					  }
					  {
					     obj_t list2018_1745;
					     {
						obj_t arg2019_1746;
						{
						   obj_t aux_2785;
						   aux_2785 = BCHAR(((unsigned char) ';'));
						   arg2019_1746 = MAKE_PAIR(aux_2785, BNIL);
						}
						list2018_1745 = MAKE_PAIR(arg2017_1744, arg2019_1746);
					     }
					     fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list2018_1745);
					  }
				       }
				    }
				    {
				       obj_t l1428_2790;
				       l1428_2790 = CDR(l1428_1739);
				       l1428_1739 = l1428_2790;
				       goto lname1430_1740;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_2550 = BFALSE;
			 }
			 break;
		      case ((long) 16):
			 {
			    cfuncall_t cop_1751;
			    cop_1751 = (cfuncall_t) (cop_1);
			    {
			       cfuncall_t cop_1752;
			       cfuncall_t cop_1754;
			       cfuncall_t cop_1758;
			       cfuncall_t cop_1760;
			       {
				  obj_t case_value_58_1762;
				  case_value_58_1762 = (((cfuncall_t) CREF(cop_1751))->strength);
				  {
				     bool_t test_2795;
				     {
					obj_t aux_2796;
					aux_2796 = CNST_TABLE_REF(((long) 1));
					test_2795 = (case_value_58_1762 == aux_2796);
				     }
				     if (test_2795)
				       {
					  bool_t aux_2799;
					  cop_1752 = cop_1751;
					  {
					     obj_t actuals_1767;
					     actuals_1767 = (((cfuncall_t) CREF(cop_1752))->args);
					     emit_cop_45_cgen_emit_cop_239((((cfuncall_t) CREF(cop_1752))->fun));
					     {
						obj_t list2031_1769;
						list2031_1769 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						write_char_165___r4_output_6_10_3(((unsigned char) '('), list2031_1769);
					     }
					     {
						obj_t actuals_1771;
						actuals_1771 = actuals_1767;
					      loop_1772:
						{
						   bool_t test_2805;
						   {
						      obj_t aux_2806;
						      {
							 obj_t aux_2807;
							 aux_2807 = CDR(actuals_1771);
							 aux_2806 = CDR(aux_2807);
						      }
						      test_2805 = NULLP(aux_2806);
						   }
						   if (test_2805)
						     {
							{
							   cop_t aux_2811;
							   {
							      obj_t aux_2812;
							      aux_2812 = CAR(actuals_1771);
							      aux_2811 = (cop_t) (aux_2812);
							   }
							   emit_cop_45_cgen_emit_cop_239(aux_2811);
							}
							{
							   obj_t list2035_1775;
							   list2035_1775 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
							   write_char_165___r4_output_6_10_3(((unsigned char) ')'), list2035_1775);
							}
							aux_2799 = ((bool_t) 1);
						     }
						   else
						     {
							{
							   cop_t aux_2818;
							   {
							      obj_t aux_2819;
							      aux_2819 = CAR(actuals_1771);
							      aux_2818 = (cop_t) (aux_2819);
							   }
							   emit_cop_45_cgen_emit_cop_239(aux_2818);
							}
							{
							   obj_t list2038_1778;
							   list2038_1778 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
							   display___r4_output_6_10_3(string2270_cgen_emit_cop_239, list2038_1778);
							}
							{
							   obj_t actuals_2825;
							   actuals_2825 = CDR(actuals_1771);
							   actuals_1771 = actuals_2825;
							   goto loop_1772;
							}
						     }
						}
					     }
					  }
					  aux_2550 = BBOOL(aux_2799);
				       }
				     else
				       {
					  bool_t test_2828;
					  {
					     obj_t aux_2829;
					     aux_2829 = CNST_TABLE_REF(((long) 2));
					     test_2828 = (case_value_58_1762 == aux_2829);
					  }
					  if (test_2828)
					    {
					       bool_t aux_2832;
					       cop_1754 = cop_1751;
					       {
						  obj_t actuals_1782;
						  actuals_1782 = (((cfuncall_t) CREF(cop_1754))->args);
						  {
						     obj_t list2042_1783;
						     list2042_1783 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						     display___r4_output_6_10_3(string2271_cgen_emit_cop_239, list2042_1783);
						  }
						  emit_cop_45_cgen_emit_cop_239((((cfuncall_t) CREF(cop_1754))->fun));
						  {
						     obj_t list2046_1786;
						     list2046_1786 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						     display___r4_output_6_10_3(string2268_cgen_emit_cop_239, list2046_1786);
						  }
						  {
						     obj_t actuals_1788;
						     actuals_1788 = actuals_1782;
						   loop_1789:
						     {
							bool_t test_2840;
							{
							   obj_t aux_2841;
							   {
							      obj_t aux_2842;
							      aux_2842 = CDR(actuals_1788);
							      aux_2841 = CDR(aux_2842);
							   }
							   test_2840 = NULLP(aux_2841);
							}
							if (test_2840)
							  {
							     {
								cop_t aux_2846;
								{
								   obj_t aux_2847;
								   aux_2847 = CAR(actuals_1788);
								   aux_2846 = (cop_t) (aux_2847);
								}
								emit_cop_45_cgen_emit_cop_239(aux_2846);
							     }
							     {
								obj_t list2051_1792;
								list2051_1792 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
								display___r4_output_6_10_3(string2269_cgen_emit_cop_239, list2051_1792);
							     }
							     aux_2832 = ((bool_t) 1);
							  }
							else
							  {
							     {
								cop_t aux_2853;
								{
								   obj_t aux_2854;
								   aux_2854 = CAR(actuals_1788);
								   aux_2853 = (cop_t) (aux_2854);
								}
								emit_cop_45_cgen_emit_cop_239(aux_2853);
							     }
							     {
								obj_t list2054_1795;
								list2054_1795 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
								display___r4_output_6_10_3(string2270_cgen_emit_cop_239, list2054_1795);
							     }
							     {
								obj_t actuals_2860;
								actuals_2860 = CDR(actuals_1788);
								actuals_1788 = actuals_2860;
								goto loop_1789;
							     }
							  }
						     }
						  }
					       }
					       aux_2550 = BBOOL(aux_2832);
					    }
					  else
					    {
					       if (CBOOL(__stdc__25_engine_param))
						 {
						    bool_t aux_2865;
						    cop_1760 = cop_1751;
						    {
						       obj_t list2089_1833;
						       list2089_1833 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						       display___r4_output_6_10_3(string2263_cgen_emit_cop_239, list2089_1833);
						    }
						    emit_cop_45_cgen_emit_cop_239((((cfuncall_t) CREF(cop_1760))->fun));
						    {
						       obj_t list2093_1836;
						       list2093_1836 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						       display___r4_output_6_10_3(string2264_cgen_emit_cop_239, list2093_1836);
						    }
						    emit_regular_cfuncall_eoa_48_cgen_emit_cop_239(cop_1760);
						    {
						       obj_t list2096_1838;
						       list2096_1838 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						       display___r4_output_6_10_3(string2265_cgen_emit_cop_239, list2096_1838);
						    }
						    cop_1758 = cop_1760;
						    {
						       obj_t actuals_1816;
						       actuals_1816 = (((cfuncall_t) CREF(cop_1758))->args);
						       {
							  obj_t list2074_1817;
							  list2074_1817 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
							  display___r4_output_6_10_3(string2267_cgen_emit_cop_239, list2074_1817);
						       }
						       emit_cop_45_cgen_emit_cop_239((((cfuncall_t) CREF(cop_1758))->fun));
						       {
							  obj_t list2078_1820;
							  list2078_1820 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
							  display___r4_output_6_10_3(string2268_cgen_emit_cop_239, list2078_1820);
						       }
						       {
							  obj_t actuals_1822;
							  actuals_1822 = actuals_1816;
							loop_1823:
							  {
							     bool_t test_2882;
							     {
								obj_t aux_2883;
								{
								   obj_t aux_2884;
								   aux_2884 = CDR(actuals_1822);
								   aux_2883 = CDR(aux_2884);
								}
								test_2882 = NULLP(aux_2883);
							     }
							     if (test_2882)
							       {
								  {
								     cop_t aux_2888;
								     {
									obj_t aux_2889;
									aux_2889 = CAR(actuals_1822);
									aux_2888 = (cop_t) (aux_2889);
								     }
								     emit_cop_45_cgen_emit_cop_239(aux_2888);
								  }
								  {
								     obj_t list2082_1826;
								     list2082_1826 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
								     display___r4_output_6_10_3(string2269_cgen_emit_cop_239, list2082_1826);
								  }
								  ((bool_t) 1);
							       }
							     else
							       {
								  {
								     cop_t aux_2895;
								     {
									obj_t aux_2896;
									aux_2896 = CAR(actuals_1822);
									aux_2895 = (cop_t) (aux_2896);
								     }
								     emit_cop_45_cgen_emit_cop_239(aux_2895);
								  }
								  {
								     obj_t list2085_1829;
								     list2085_1829 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
								     display___r4_output_6_10_3(string2270_cgen_emit_cop_239, list2085_1829);
								  }
								  {
								     obj_t actuals_2902;
								     actuals_2902 = CDR(actuals_1822);
								     actuals_1822 = actuals_2902;
								     goto loop_1823;
								  }
							       }
							  }
						       }
						    }
						    {
						       obj_t list2098_1840;
						       list2098_1840 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						       display___r4_output_6_10_3(string2266_cgen_emit_cop_239, list2098_1840);
						    }
						    aux_2865 = ((bool_t) 1);
						    aux_2550 = BBOOL(aux_2865);
						 }
					       else
						 {
						    bool_t aux_2907;
						    aux_2907 = emit_regular_cfuncall_eoa_48_cgen_emit_cop_239(cop_1751);
						    aux_2550 = BBOOL(aux_2907);
						 }
					    }
				       }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 17):
			 {
			    capply_t cop_1842;
			    cop_1842 = (capply_t) (cop_1);
			    {
			       obj_t list2100_1844;
			       list2100_1844 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2272_cgen_emit_cop_239, list2100_1844);
			    }
			    emit_cop_45_cgen_emit_cop_239((((capply_t) CREF(cop_1842))->fun));
			    {
			       obj_t list2103_1847;
			       list2103_1847 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2270_cgen_emit_cop_239, list2103_1847);
			    }
			    emit_cop_45_cgen_emit_cop_239((((capply_t) CREF(cop_1842))->arg));
			    {
			       obj_t list2106_1850;
			       list2106_1850 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) ')'), list2106_1850);
			    }
			    aux_2550 = BTRUE;
			 }
			 break;
		      case ((long) 18):
			 {
			    capp_t cop_1852;
			    cop_1852 = (capp_t) (cop_1);
			    {
			       {
				  variable_t fun_1855;
				  {
				     varc_t obj_2194;
				     {
					cop_t aux_2922;
					aux_2922 = (((capp_t) CREF(cop_1852))->fun);
					obj_2194 = (varc_t) (aux_2922);
				     }
				     fun_1855 = (((varc_t) CREF(obj_2194))->variable);
				  }
				  {
				     bool_t test2108_1856;
				     {
					bool_t test2109_1857;
					{
					   obj_t aux_2926;
					   {
					      value_t aux_2927;
					      {
						 global_t obj_2195;
						 obj_2195 = (global_t) (fun_1855);
						 aux_2927 = (((global_t) CREF(obj_2195))->value);
					      }
					      aux_2926 = (obj_t) (aux_2927);
					   }
					   test2109_1857 = is_a__118___object(aux_2926, cfun_ast_var);
					}
					if (test2109_1857)
					  {
					     cfun_t obj_2198;
					     {
						value_t aux_2933;
						{
						   global_t obj_2197;
						   obj_2197 = (global_t) (fun_1855);
						   aux_2933 = (((global_t) CREF(obj_2197))->value);
						}
						obj_2198 = (cfun_t) (aux_2933);
					     }
					     test2108_1856 = (((cfun_t) CREF(obj_2198))->infix__163);
					  }
					else
					  {
					     test2108_1856 = ((bool_t) 0);
					  }
				     }
				     if (test2108_1856)
				       {
					  bool_t aux_2939;
					  {
					     obj_t actuals_1861;
					     actuals_1861 = (((capp_t) CREF(cop_1852))->args);
					     {
						obj_t list2113_1862;
						list2113_1862 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						write_char_165___r4_output_6_10_3(((unsigned char) '('), list2113_1862);
					     }
					     {
						cop_t aux_2943;
						{
						   obj_t aux_2944;
						   aux_2944 = CAR(actuals_1861);
						   aux_2943 = (cop_t) (aux_2944);
						}
						emit_cop_45_cgen_emit_cop_239(aux_2943);
					     }
					     emit_cop_45_cgen_emit_cop_239((((capp_t) CREF(cop_1852))->fun));
					     {
						cop_t aux_2950;
						{
						   obj_t aux_2951;
						   {
						      obj_t aux_2952;
						      aux_2952 = CDR(actuals_1861);
						      aux_2951 = CAR(aux_2952);
						   }
						   aux_2950 = (cop_t) (aux_2951);
						}
						emit_cop_45_cgen_emit_cop_239(aux_2950);
					     }
					     {
						obj_t list2119_1867;
						list2119_1867 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						write_char_165___r4_output_6_10_3(((unsigned char) ')'), list2119_1867);
					     }
					     aux_2939 = ((bool_t) 1);
					  }
					  aux_2550 = BBOOL(aux_2939);
				       }
				     else
				       {
					  bool_t aux_2960;
					  {
					     obj_t actuals_1869;
					     actuals_1869 = (((capp_t) CREF(cop_1852))->args);
					     emit_cop_45_cgen_emit_cop_239((((capp_t) CREF(cop_1852))->fun));
					     {
						obj_t list2122_1871;
						list2122_1871 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						write_char_165___r4_output_6_10_3(((unsigned char) '('), list2122_1871);
					     }
					     if (NULLP(actuals_1869))
					       {
						  {
						     obj_t list2125_1874;
						     list2125_1874 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						     write_char_165___r4_output_6_10_3(((unsigned char) ')'), list2125_1874);
						  }
						  aux_2960 = ((bool_t) 1);
					       }
					     else
					       {
						  obj_t actuals_1876;
						  actuals_1876 = actuals_1869;
						loop_1877:
						  {
						     bool_t test_2970;
						     {
							obj_t aux_2971;
							aux_2971 = CDR(actuals_1876);
							test_2970 = NULLP(aux_2971);
						     }
						     if (test_2970)
						       {
							  {
							     cop_t aux_2974;
							     {
								obj_t aux_2975;
								aux_2975 = CAR(actuals_1876);
								aux_2974 = (cop_t) (aux_2975);
							     }
							     emit_cop_45_cgen_emit_cop_239(aux_2974);
							  }
							  {
							     obj_t list2129_1880;
							     list2129_1880 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
							     write_char_165___r4_output_6_10_3(((unsigned char) ')'), list2129_1880);
							  }
							  aux_2960 = ((bool_t) 1);
						       }
						     else
						       {
							  {
							     cop_t aux_2981;
							     {
								obj_t aux_2982;
								aux_2982 = CAR(actuals_1876);
								aux_2981 = (cop_t) (aux_2982);
							     }
							     emit_cop_45_cgen_emit_cop_239(aux_2981);
							  }
							  {
							     obj_t list2132_1883;
							     list2132_1883 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
							     display___r4_output_6_10_3(string2270_cgen_emit_cop_239, list2132_1883);
							  }
							  {
							     obj_t actuals_2988;
							     actuals_2988 = CDR(actuals_1876);
							     actuals_1876 = actuals_2988;
							     goto loop_1877;
							  }
						       }
						  }
					       }
					  }
					  aux_2550 = BBOOL(aux_2960);
				       }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 19):
			 {
			    cfail_t cop_1887;
			    cop_1887 = (cfail_t) (cop_1);
			    {
			       obj_t list2136_1889;
			       list2136_1889 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2273_cgen_emit_cop_239, list2136_1889);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cfail_t) CREF(cop_1887))->proc));
			    {
			       obj_t list2139_1892;
			       list2139_1892 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) ','), list2139_1892);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cfail_t) CREF(cop_1887))->msg));
			    {
			       obj_t list2143_1895;
			       list2143_1895 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) ','), list2143_1895);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cfail_t) CREF(cop_1887))->obj));
			    {
			       obj_t list2146_1898;
			       list2146_1898 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2274_cgen_emit_cop_239, list2146_1898);
			    }
			    aux_2550 = BFALSE;
			 }
			 break;
		      case ((long) 20):
			 {
			    cswitch_t cop_1900;
			    cop_1900 = (cswitch_t) (cop_1);
			    {
			       obj_t list2149_1902;
			       list2149_1902 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2275_cgen_emit_cop_239, list2149_1902);
			    }
			    {
			       obj_t list2151_1904;
			       list2151_1904 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) '('), list2151_1904);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cswitch_t) CREF(cop_1900))->test));
			    {
			       obj_t list2154_1907;
			       list2154_1907 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) ')'), list2154_1907);
			    }
			    {
			       obj_t list2156_1909;
			       list2156_1909 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) '{'), list2156_1909);
			    }
			    {
			       obj_t list2161_1911;
			       list2161_1911 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       newline___r4_output_6_10_3(list2161_1911);
			    }
			    {
			       obj_t clauses_1913;
			       {
				  bool_t aux_3019;
				  clauses_1913 = (((cswitch_t) CREF(cop_1900))->clauses);
				loop_1914:
				  {
				     obj_t clause_1916;
				     clause_1916 = CAR(clauses_1913);
				     {
					bool_t test_3021;
					{
					   obj_t aux_3024;
					   obj_t aux_3022;
					   aux_3024 = CNST_TABLE_REF(((long) 3));
					   aux_3022 = CAR(clause_1916);
					   test_3021 = (aux_3022 == aux_3024);
					}
					if (test_3021)
					  {
					     {
						obj_t list2165_1918;
						list2165_1918 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						display___r4_output_6_10_3(string2276_cgen_emit_cop_239, list2165_1918);
					     }
					     {
						obj_t list2167_1920;
						list2167_1920 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						newline___r4_output_6_10_3(list2167_1920);
					     }
					     {
						bool_t test2169_1922;
						{
						   cop_t aux_3031;
						   {
						      obj_t aux_3032;
						      aux_3032 = CDR(clause_1916);
						      aux_3031 = (cop_t) (aux_3032);
						   }
						   test2169_1922 = emit_cop_45_cgen_emit_cop_239(aux_3031);
						}
						if (test2169_1922)
						  {
						     obj_t list2170_1923;
						     {
							obj_t aux_3037;
							aux_3037 = BCHAR(((unsigned char) ';'));
							list2170_1923 = MAKE_PAIR(aux_3037, BNIL);
						     }
						     fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list2170_1923);
						  }
						else
						  {
						     BUNSPEC;
						  }
					     }
					     {
						obj_t list2173_1926;
						list2173_1926 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						write_char_165___r4_output_6_10_3(((unsigned char) '}'), list2173_1926);
					     }
					     {
						obj_t list2175_1928;
						list2175_1928 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						newline___r4_output_6_10_3(list2175_1928);
					     }
					     aux_3019 = ((bool_t) 0);
					  }
					else
					  {
					     {
						obj_t l1434_1930;
						l1434_1930 = CAR(clause_1916);
					      lname1435_1931:
						if (PAIRP(l1434_1930))
						  {
						     {
							obj_t t_1934;
							t_1934 = CAR(l1434_1930);
							{
							   obj_t list2179_1935;
							   list2179_1935 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
							   display___r4_output_6_10_3(string2277_cgen_emit_cop_239, list2179_1935);
							}
							emit_atom_value_68_cgen_emit_cop_239(t_1934);
							{
							   obj_t list2181_1937;
							   list2181_1937 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
							   display___r4_output_6_10_3(string2265_cgen_emit_cop_239, list2181_1937);
							}
							{
							   obj_t list2183_1939;
							   list2183_1939 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
							   newline___r4_output_6_10_3(list2183_1939);
							}
						     }
						     {
							obj_t l1434_3055;
							l1434_3055 = CDR(l1434_1930);
							l1434_1930 = l1434_3055;
							goto lname1435_1931;
						     }
						  }
						else
						  {
						     ((bool_t) 1);
						  }
					     }
					     {
						bool_t test2186_1942;
						{
						   cop_t aux_3058;
						   {
						      obj_t aux_3059;
						      aux_3059 = CDR(clause_1916);
						      aux_3058 = (cop_t) (aux_3059);
						   }
						   test2186_1942 = emit_cop_45_cgen_emit_cop_239(aux_3058);
						}
						if (test2186_1942)
						  {
						     obj_t list2187_1943;
						     {
							obj_t aux_3064;
							aux_3064 = BCHAR(((unsigned char) ';'));
							list2187_1943 = MAKE_PAIR(aux_3064, BNIL);
						     }
						     fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list2187_1943);
						  }
						else
						  {
						     BUNSPEC;
						  }
					     }
					     {
						obj_t list2190_1946;
						list2190_1946 = MAKE_PAIR(string2278_cgen_emit_cop_239, BNIL);
						fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list2190_1946);
					     }
					     {
						obj_t clauses_3070;
						clauses_3070 = CDR(clauses_1913);
						clauses_1913 = clauses_3070;
						goto loop_1914;
					     }
					  }
				     }
				  }
				  aux_2550 = BBOOL(aux_3019);
			       }
			    }
			 }
			 break;
		      case ((long) 21):
			 {
			    cmake_box_177_t cop_1952;
			    cop_1952 = (cmake_box_177_t) (cop_1);
			    {
			       obj_t list2196_1954;
			       list2196_1954 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2279_cgen_emit_cop_239, list2196_1954);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cmake_box_177_t) CREF(cop_1952))->value));
			    {
			       obj_t list2199_1957;
			       list2199_1957 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) ')'), list2199_1957);
			    }
			    aux_2550 = BTRUE;
			 }
			 break;
		      case ((long) 22):
			 {
			    cbox_ref_44_t cop_1959;
			    cop_1959 = (cbox_ref_44_t) (cop_1);
			    {
			       obj_t list2201_1961;
			       list2201_1961 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2280_cgen_emit_cop_239, list2201_1961);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cbox_ref_44_t) CREF(cop_1959))->var));
			    {
			       obj_t list2204_1964;
			       list2204_1964 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) ')'), list2204_1964);
			    }
			    aux_2550 = BTRUE;
			 }
			 break;
		      case ((long) 23):
			 {
			    cbox_set__132_t cop_1966;
			    cop_1966 = (cbox_set__132_t) (cop_1);
			    {
			       obj_t list2206_1968;
			       list2206_1968 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2281_cgen_emit_cop_239, list2206_1968);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cbox_set__132_t) CREF(cop_1966))->var));
			    {
			       obj_t list2209_1971;
			       list2209_1971 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2270_cgen_emit_cop_239, list2209_1971);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cbox_set__132_t) CREF(cop_1966))->value));
			    {
			       obj_t list2212_1974;
			       list2212_1974 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) ')'), list2212_1974);
			    }
			    aux_2550 = BTRUE;
			 }
			 break;
		      case ((long) 24):
			 {
			    cset_ex_it_123_t cop_1976;
			    cop_1976 = (cset_ex_it_123_t) (cop_1);
			    {
			       obj_t list2214_1978;
			       list2214_1978 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2282_cgen_emit_cop_239, list2214_1978);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cset_ex_it_123_t) CREF(cop_1976))->exit));
			    {
			       obj_t list2217_1981;
			       list2217_1981 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2283_cgen_emit_cop_239, list2217_1981);
			    }
			    {
			       obj_t list2219_1983;
			       list2219_1983 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2284_cgen_emit_cop_239, list2219_1983);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cset_ex_it_123_t) CREF(cop_1976))->jump_value_221));
			    {
			       obj_t list2222_1986;
			       list2222_1986 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2285_cgen_emit_cop_239, list2222_1986);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cset_ex_it_123_t) CREF(cop_1976))->body));
			    {
			       obj_t list2225_1989;
			       list2225_1989 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) '}'), list2225_1989);
			    }
			    {
			       obj_t list2227_1991;
			       list2227_1991 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       newline___r4_output_6_10_3(list2227_1991);
			    }
			    aux_2550 = BFALSE;
			 }
			 break;
		      case ((long) 25):
			 {
			    cjump_ex_it_131_t cop_1993;
			    cop_1993 = (cjump_ex_it_131_t) (cop_1);
			    {
			       obj_t list2229_1995;
			       list2229_1995 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2286_cgen_emit_cop_239, list2229_1995);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cjump_ex_it_131_t) CREF(cop_1993))->exit));
			    {
			       obj_t list2232_1998;
			       list2232_1998 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) ','), list2232_1998);
			    }
			    emit_cop_45_cgen_emit_cop_239((((cjump_ex_it_131_t) CREF(cop_1993))->value));
			    {
			       obj_t list2235_2001;
			       list2235_2001 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       write_char_165___r4_output_6_10_3(((unsigned char) ')'), list2235_2001);
			    }
			    aux_2550 = BTRUE;
			 }
			 break;
		      default:
		       case_else1843_191_1504:
			 if (PROCEDUREP(method1837_1500))
			   {
			      aux_2550 = PROCEDURE_ENTRY(method1837_1500) (method1837_1500, (obj_t) (cop_1), BEOA);
			   }
			 else
			   {
			      obj_t fun1472_838;
			      fun1472_838 = PROCEDURE_REF(emit_cop_env_125_cgen_emit_cop_239, ((long) 0));
			      aux_2550 = PROCEDURE_ENTRY(fun1472_838) (fun1472_838, (obj_t) (cop_1), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1843_191_1504;
		 }
	    }
	    return CBOOL(aux_2550);
	 }
      }
   }
}


bool_t 
emit_regular_cfuncall_eoa_48_cgen_emit_cop_239(cfuncall_t cop_1756)
{
   {
      obj_t actuals_1799;
      actuals_1799 = (((cfuncall_t) CREF(cop_1756))->args);
      {
	 obj_t list2058_1800;
	 list2058_1800 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
	 display___r4_output_6_10_3(string2267_cgen_emit_cop_239, list2058_1800);
      }
      emit_cop_45_cgen_emit_cop_239((((cfuncall_t) CREF(cop_1756))->fun));
      {
	 obj_t list2061_1803;
	 list2061_1803 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
	 display___r4_output_6_10_3(string2268_cgen_emit_cop_239, list2061_1803);
      }
      {
	 obj_t actuals_1805;
	 actuals_1805 = actuals_1799;
       loop_1806:
	 {
	    bool_t test_3148;
	    {
	       obj_t aux_3149;
	       aux_3149 = CDR(actuals_1805);
	       test_3148 = NULLP(aux_3149);
	    }
	    if (test_3148)
	      {
		 {
		    cop_t aux_3152;
		    {
		       obj_t aux_3153;
		       aux_3153 = CAR(actuals_1805);
		       aux_3152 = (cop_t) (aux_3153);
		    }
		    emit_cop_45_cgen_emit_cop_239(aux_3152);
		 }
		 {
		    obj_t list2066_1809;
		    list2066_1809 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
		    display___r4_output_6_10_3(string2269_cgen_emit_cop_239, list2066_1809);
		 }
		 return ((bool_t) 1);
	      }
	    else
	      {
		 {
		    cop_t aux_3159;
		    {
		       obj_t aux_3160;
		       aux_3160 = CAR(actuals_1805);
		       aux_3159 = (cop_t) (aux_3160);
		    }
		    emit_cop_45_cgen_emit_cop_239(aux_3159);
		 }
		 {
		    obj_t list2070_1812;
		    list2070_1812 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
		    display___r4_output_6_10_3(string2270_cgen_emit_cop_239, list2070_1812);
		 }
		 {
		    obj_t actuals_3166;
		    actuals_3166 = CDR(actuals_1805);
		    actuals_1805 = actuals_3166;
		    goto loop_1806;
		 }
	      }
	 }
      }
   }
}


obj_t 
_emit_cop_216_cgen_emit_cop_239(obj_t env_2453, obj_t cop_2454)
{
   {
      bool_t aux_3168;
      aux_3168 = emit_cop_45_cgen_emit_cop_239((cop_t) (cop_2454));
      return BBOOL(aux_3168);
   }
}


obj_t 
lambda19102255_cgen_emit_cop_239(obj_t env_2458, obj_t input_port_219_2460)
{
   {
      obj_t args_2459;
      args_2459 = PROCEDURE_1_EL_REF(env_2458, ((long) 0));
      {
	 obj_t input_port_219_1574;
	 input_port_219_1574 = input_port_219_2460;
	 {
	    long rule_1586;
	  ignore_1588:
	    INPUT_PORT_RESET_ANNEXE(input_port_219_1574);
	    {
	       long rule_1626;
	       rule_1586 = ((long) 0);
	       {
		  long mr_1596;
		  long mr_1594;
		  long mr_1592;
		  long mr_1590;
		  mr_1590 = rule_1586;
		state_0_1591:
		  {
		     int aux1412_1599;
		     aux1412_1599 = INPUT_PORT_READ_CHAR(input_port_219_1574);
		     switch ((long) (aux1412_1599))
		       {
		       case ((long) 254):
		       case ((long) 253):
		       case ((long) 252):
		       case ((long) 251):
		       case ((long) 250):
		       case ((long) 249):
		       case ((long) 248):
		       case ((long) 247):
		       case ((long) 246):
		       case ((long) 245):
		       case ((long) 244):
		       case ((long) 243):
		       case ((long) 242):
		       case ((long) 241):
		       case ((long) 240):
		       case ((long) 239):
		       case ((long) 238):
		       case ((long) 237):
		       case ((long) 236):
		       case ((long) 235):
		       case ((long) 234):
		       case ((long) 233):
		       case ((long) 232):
		       case ((long) 231):
		       case ((long) 230):
		       case ((long) 229):
		       case ((long) 228):
		       case ((long) 227):
		       case ((long) 226):
		       case ((long) 225):
		       case ((long) 224):
		       case ((long) 223):
		       case ((long) 222):
		       case ((long) 221):
		       case ((long) 220):
		       case ((long) 219):
		       case ((long) 218):
		       case ((long) 217):
		       case ((long) 216):
		       case ((long) 215):
		       case ((long) 214):
		       case ((long) 213):
		       case ((long) 212):
		       case ((long) 211):
		       case ((long) 210):
		       case ((long) 209):
		       case ((long) 208):
		       case ((long) 207):
		       case ((long) 206):
		       case ((long) 205):
		       case ((long) 204):
		       case ((long) 203):
		       case ((long) 202):
		       case ((long) 201):
		       case ((long) 200):
		       case ((long) 199):
		       case ((long) 198):
		       case ((long) 197):
		       case ((long) 196):
		       case ((long) 195):
		       case ((long) 194):
		       case ((long) 193):
		       case ((long) 192):
		       case ((long) 191):
		       case ((long) 190):
		       case ((long) 189):
		       case ((long) 188):
		       case ((long) 187):
		       case ((long) 186):
		       case ((long) 185):
		       case ((long) 184):
		       case ((long) 183):
		       case ((long) 182):
		       case ((long) 181):
		       case ((long) 180):
		       case ((long) 179):
		       case ((long) 178):
		       case ((long) 177):
		       case ((long) 176):
		       case ((long) 175):
		       case ((long) 174):
		       case ((long) 173):
		       case ((long) 172):
		       case ((long) 171):
		       case ((long) 170):
		       case ((long) 169):
		       case ((long) 168):
		       case ((long) 167):
		       case ((long) 166):
		       case ((long) 165):
		       case ((long) 164):
		       case ((long) 163):
		       case ((long) 162):
		       case ((long) 161):
		       case ((long) 160):
		       case ((long) 159):
		       case ((long) 158):
		       case ((long) 157):
		       case ((long) 156):
		       case ((long) 155):
		       case ((long) 154):
		       case ((long) 153):
		       case ((long) 152):
		       case ((long) 151):
		       case ((long) 150):
		       case ((long) 149):
		       case ((long) 148):
		       case ((long) 147):
		       case ((long) 146):
		       case ((long) 145):
		       case ((long) 144):
		       case ((long) 143):
		       case ((long) 142):
		       case ((long) 141):
		       case ((long) 140):
		       case ((long) 139):
		       case ((long) 138):
		       case ((long) 137):
		       case ((long) 136):
		       case ((long) 135):
		       case ((long) 134):
		       case ((long) 133):
		       case ((long) 132):
		       case ((long) 131):
		       case ((long) 130):
		       case ((long) 129):
		       case ((long) 128):
		       case ((long) 127):
		       case ((long) 126):
		       case ((long) 125):
		       case ((long) 124):
		       case ((long) 123):
		       case ((long) 122):
		       case ((long) 121):
		       case ((long) 120):
		       case ((long) 119):
		       case ((long) 118):
		       case ((long) 117):
		       case ((long) 116):
		       case ((long) 115):
		       case ((long) 114):
		       case ((long) 113):
		       case ((long) 112):
		       case ((long) 111):
		       case ((long) 110):
		       case ((long) 109):
		       case ((long) 108):
		       case ((long) 107):
		       case ((long) 106):
		       case ((long) 105):
		       case ((long) 104):
		       case ((long) 103):
		       case ((long) 102):
		       case ((long) 101):
		       case ((long) 100):
		       case ((long) 99):
		       case ((long) 98):
		       case ((long) 97):
		       case ((long) 96):
		       case ((long) 95):
		       case ((long) 94):
		       case ((long) 93):
		       case ((long) 92):
		       case ((long) 91):
		       case ((long) 90):
		       case ((long) 89):
		       case ((long) 88):
		       case ((long) 87):
		       case ((long) 86):
		       case ((long) 85):
		       case ((long) 84):
		       case ((long) 83):
		       case ((long) 82):
		       case ((long) 81):
		       case ((long) 80):
		       case ((long) 79):
		       case ((long) 78):
		       case ((long) 77):
		       case ((long) 76):
		       case ((long) 75):
		       case ((long) 74):
		       case ((long) 73):
		       case ((long) 72):
		       case ((long) 71):
		       case ((long) 70):
		       case ((long) 69):
		       case ((long) 68):
		       case ((long) 67):
		       case ((long) 66):
		       case ((long) 65):
		       case ((long) 64):
		       case ((long) 63):
		       case ((long) 62):
		       case ((long) 61):
		       case ((long) 60):
		       case ((long) 59):
		       case ((long) 58):
		       case ((long) 57):
		       case ((long) 56):
		       case ((long) 55):
		       case ((long) 54):
		       case ((long) 53):
		       case ((long) 52):
		       case ((long) 51):
		       case ((long) 50):
		       case ((long) 49):
		       case ((long) 48):
		       case ((long) 47):
		       case ((long) 46):
		       case ((long) 45):
		       case ((long) 44):
		       case ((long) 43):
		       case ((long) 42):
		       case ((long) 41):
		       case ((long) 40):
		       case ((long) 39):
		       case ((long) 38):
		       case ((long) 37):
		       case ((long) 35):
		       case ((long) 34):
		       case ((long) 33):
		       case ((long) 32):
		       case ((long) 31):
		       case ((long) 30):
		       case ((long) 29):
		       case ((long) 28):
		       case ((long) 27):
		       case ((long) 26):
		       case ((long) 25):
		       case ((long) 24):
		       case ((long) 23):
		       case ((long) 22):
		       case ((long) 21):
		       case ((long) 20):
		       case ((long) 19):
		       case ((long) 18):
		       case ((long) 17):
		       case ((long) 16):
		       case ((long) 15):
		       case ((long) 14):
		       case ((long) 13):
		       case ((long) 12):
		       case ((long) 11):
		       case ((long) 10):
		       case ((long) 9):
		       case ((long) 8):
		       case ((long) 7):
		       case ((long) 6):
		       case ((long) 5):
		       case ((long) 4):
		       case ((long) 3):
		       case ((long) 2):
		       case ((long) 1):
			  INPUT_PORT_REMEMBER_REF(input_port_219_1574);
			  mr_1592 = ((long) 2);
			state_1_1593:
			  {
			     int aux1414_1606;
			     aux1414_1606 = INPUT_PORT_READ_CHAR(input_port_219_1574);
			     switch ((long) (aux1414_1606))
			       {
			       case ((long) 254):
			       case ((long) 253):
			       case ((long) 252):
			       case ((long) 251):
			       case ((long) 250):
			       case ((long) 249):
			       case ((long) 248):
			       case ((long) 247):
			       case ((long) 246):
			       case ((long) 245):
			       case ((long) 244):
			       case ((long) 243):
			       case ((long) 242):
			       case ((long) 241):
			       case ((long) 240):
			       case ((long) 239):
			       case ((long) 238):
			       case ((long) 237):
			       case ((long) 236):
			       case ((long) 235):
			       case ((long) 234):
			       case ((long) 233):
			       case ((long) 232):
			       case ((long) 231):
			       case ((long) 230):
			       case ((long) 229):
			       case ((long) 228):
			       case ((long) 227):
			       case ((long) 226):
			       case ((long) 225):
			       case ((long) 224):
			       case ((long) 223):
			       case ((long) 222):
			       case ((long) 221):
			       case ((long) 220):
			       case ((long) 219):
			       case ((long) 218):
			       case ((long) 217):
			       case ((long) 216):
			       case ((long) 215):
			       case ((long) 214):
			       case ((long) 213):
			       case ((long) 212):
			       case ((long) 211):
			       case ((long) 210):
			       case ((long) 209):
			       case ((long) 208):
			       case ((long) 207):
			       case ((long) 206):
			       case ((long) 205):
			       case ((long) 204):
			       case ((long) 203):
			       case ((long) 202):
			       case ((long) 201):
			       case ((long) 200):
			       case ((long) 199):
			       case ((long) 198):
			       case ((long) 197):
			       case ((long) 196):
			       case ((long) 195):
			       case ((long) 194):
			       case ((long) 193):
			       case ((long) 192):
			       case ((long) 191):
			       case ((long) 190):
			       case ((long) 189):
			       case ((long) 188):
			       case ((long) 187):
			       case ((long) 186):
			       case ((long) 185):
			       case ((long) 184):
			       case ((long) 183):
			       case ((long) 182):
			       case ((long) 181):
			       case ((long) 180):
			       case ((long) 179):
			       case ((long) 178):
			       case ((long) 177):
			       case ((long) 176):
			       case ((long) 175):
			       case ((long) 174):
			       case ((long) 173):
			       case ((long) 172):
			       case ((long) 171):
			       case ((long) 170):
			       case ((long) 169):
			       case ((long) 168):
			       case ((long) 167):
			       case ((long) 166):
			       case ((long) 165):
			       case ((long) 164):
			       case ((long) 163):
			       case ((long) 162):
			       case ((long) 161):
			       case ((long) 160):
			       case ((long) 159):
			       case ((long) 158):
			       case ((long) 157):
			       case ((long) 156):
			       case ((long) 155):
			       case ((long) 154):
			       case ((long) 153):
			       case ((long) 152):
			       case ((long) 151):
			       case ((long) 150):
			       case ((long) 149):
			       case ((long) 148):
			       case ((long) 147):
			       case ((long) 146):
			       case ((long) 145):
			       case ((long) 144):
			       case ((long) 143):
			       case ((long) 142):
			       case ((long) 141):
			       case ((long) 140):
			       case ((long) 139):
			       case ((long) 138):
			       case ((long) 137):
			       case ((long) 136):
			       case ((long) 135):
			       case ((long) 134):
			       case ((long) 133):
			       case ((long) 132):
			       case ((long) 131):
			       case ((long) 130):
			       case ((long) 129):
			       case ((long) 128):
			       case ((long) 127):
			       case ((long) 126):
			       case ((long) 125):
			       case ((long) 124):
			       case ((long) 123):
			       case ((long) 122):
			       case ((long) 121):
			       case ((long) 120):
			       case ((long) 119):
			       case ((long) 118):
			       case ((long) 117):
			       case ((long) 116):
			       case ((long) 115):
			       case ((long) 114):
			       case ((long) 113):
			       case ((long) 112):
			       case ((long) 111):
			       case ((long) 110):
			       case ((long) 109):
			       case ((long) 108):
			       case ((long) 107):
			       case ((long) 106):
			       case ((long) 105):
			       case ((long) 104):
			       case ((long) 103):
			       case ((long) 102):
			       case ((long) 101):
			       case ((long) 100):
			       case ((long) 99):
			       case ((long) 98):
			       case ((long) 97):
			       case ((long) 96):
			       case ((long) 95):
			       case ((long) 94):
			       case ((long) 93):
			       case ((long) 92):
			       case ((long) 91):
			       case ((long) 90):
			       case ((long) 89):
			       case ((long) 88):
			       case ((long) 87):
			       case ((long) 86):
			       case ((long) 85):
			       case ((long) 84):
			       case ((long) 83):
			       case ((long) 82):
			       case ((long) 81):
			       case ((long) 80):
			       case ((long) 79):
			       case ((long) 78):
			       case ((long) 77):
			       case ((long) 76):
			       case ((long) 75):
			       case ((long) 74):
			       case ((long) 73):
			       case ((long) 72):
			       case ((long) 71):
			       case ((long) 70):
			       case ((long) 69):
			       case ((long) 68):
			       case ((long) 67):
			       case ((long) 66):
			       case ((long) 65):
			       case ((long) 64):
			       case ((long) 63):
			       case ((long) 62):
			       case ((long) 61):
			       case ((long) 60):
			       case ((long) 59):
			       case ((long) 58):
			       case ((long) 57):
			       case ((long) 56):
			       case ((long) 55):
			       case ((long) 54):
			       case ((long) 53):
			       case ((long) 52):
			       case ((long) 51):
			       case ((long) 50):
			       case ((long) 49):
			       case ((long) 48):
			       case ((long) 47):
			       case ((long) 46):
			       case ((long) 45):
			       case ((long) 44):
			       case ((long) 43):
			       case ((long) 42):
			       case ((long) 41):
			       case ((long) 40):
			       case ((long) 39):
			       case ((long) 38):
			       case ((long) 37):
			       case ((long) 35):
			       case ((long) 34):
			       case ((long) 33):
			       case ((long) 32):
			       case ((long) 31):
			       case ((long) 30):
			       case ((long) 29):
			       case ((long) 28):
			       case ((long) 27):
			       case ((long) 26):
			       case ((long) 25):
			       case ((long) 24):
			       case ((long) 23):
			       case ((long) 22):
			       case ((long) 21):
			       case ((long) 20):
			       case ((long) 19):
			       case ((long) 18):
			       case ((long) 17):
			       case ((long) 16):
			       case ((long) 15):
			       case ((long) 14):
			       case ((long) 13):
			       case ((long) 12):
			       case ((long) 11):
			       case ((long) 10):
			       case ((long) 9):
			       case ((long) 8):
			       case ((long) 7):
			       case ((long) 6):
			       case ((long) 5):
			       case ((long) 4):
			       case ((long) 3):
			       case ((long) 2):
			       case ((long) 1):
				  INPUT_PORT_REMEMBER_REF(input_port_219_1574);
				  {
				     long mr_3178;
				     mr_3178 = ((long) 2);
				     mr_1592 = mr_3178;
				     goto state_1_1593;
				  }
				  break;
			       case ((long) 0):
				  {
				     bool_t test1917_1611;
				     {
					bool_t res2247_2078;
					{
					   bool_t test1148_2076;
					   {
					      obj_t obj_2077;
					      obj_2077 = __about_to_read__202___r4_input_6_10_2;
					      test1148_2076 = PROCEDUREP(obj_2077);
					   }
					   if (test1148_2076)
					     {
						PROCEDURE_ENTRY(__about_to_read__202___r4_input_6_10_2) (__about_to_read__202___r4_input_6_10_2, input_port_219_1574, BEOA);
					     }
					   else
					     {
						BUNSPEC;
					     }
					}
					res2247_2078 = input_port_fill_buffer(input_port_219_1574);
					test1917_1611 = res2247_2078;
				     }
				     if (test1917_1611)
				       {
					  goto state_1_1593;
				       }
				     else
				       {
					  rule_1626 = mr_1592;
				       }
				  }
				  break;
			       default:
				  rule_1626 = mr_1592;
			       }
			  }
			  break;
		       case ((long) 36):
			  mr_1594 = mr_1590;
			state_2_1595:
			  {
			     int aux1416_1613;
			     aux1416_1613 = INPUT_PORT_READ_CHAR(input_port_219_1574);
			     switch ((long) (aux1416_1613))
			       {
			       case ((long) 48):
			       case ((long) 49):
			       case ((long) 50):
			       case ((long) 51):
			       case ((long) 52):
			       case ((long) 53):
			       case ((long) 54):
			       case ((long) 55):
			       case ((long) 56):
			       case ((long) 57):
				  INPUT_PORT_REMEMBER_REF(input_port_219_1574);
				  mr_1596 = ((long) 1);
				state_3_1597:
				  {
				     int aux1418_1620;
				     aux1418_1620 = INPUT_PORT_READ_CHAR(input_port_219_1574);
				     switch ((long) (aux1418_1620))
				       {
				       case ((long) 48):
				       case ((long) 49):
				       case ((long) 50):
				       case ((long) 51):
				       case ((long) 52):
				       case ((long) 53):
				       case ((long) 54):
				       case ((long) 55):
				       case ((long) 56):
				       case ((long) 57):
					  INPUT_PORT_REMEMBER_REF(input_port_219_1574);
					  {
					     long mr_3191;
					     mr_3191 = ((long) 1);
					     mr_1596 = mr_3191;
					     goto state_3_1597;
					  }
					  break;
				       case ((long) 0):
					  {
					     bool_t test1923_1625;
					     {
						bool_t res2249_2090;
						{
						   bool_t test1148_2088;
						   {
						      obj_t obj_2089;
						      obj_2089 = __about_to_read__202___r4_input_6_10_2;
						      test1148_2088 = PROCEDUREP(obj_2089);
						   }
						   if (test1148_2088)
						     {
							PROCEDURE_ENTRY(__about_to_read__202___r4_input_6_10_2) (__about_to_read__202___r4_input_6_10_2, input_port_219_1574, BEOA);
						     }
						   else
						     {
							BUNSPEC;
						     }
						}
						res2249_2090 = input_port_fill_buffer(input_port_219_1574);
						test1923_1625 = res2249_2090;
					     }
					     if (test1923_1625)
					       {
						  goto state_3_1597;
					       }
					     else
					       {
						  rule_1626 = mr_1596;
					       }
					  }
					  break;
				       default:
					  rule_1626 = mr_1596;
				       }
				  }
				  break;
			       case ((long) 0):
				  {
				     bool_t test1920_1618;
				     {
					bool_t res2248_2084;
					{
					   bool_t test1148_2082;
					   {
					      obj_t obj_2083;
					      obj_2083 = __about_to_read__202___r4_input_6_10_2;
					      test1148_2082 = PROCEDUREP(obj_2083);
					   }
					   if (test1148_2082)
					     {
						PROCEDURE_ENTRY(__about_to_read__202___r4_input_6_10_2) (__about_to_read__202___r4_input_6_10_2, input_port_219_1574, BEOA);
					     }
					   else
					     {
						BUNSPEC;
					     }
					}
					res2248_2084 = input_port_fill_buffer(input_port_219_1574);
					test1920_1618 = res2248_2084;
				     }
				     if (test1920_1618)
				       {
					  goto state_2_1595;
				       }
				     else
				       {
					  rule_1626 = mr_1594;
				       }
				  }
				  break;
			       default:
				  rule_1626 = mr_1594;
			       }
			  }
			  break;
		       case ((long) 0):
			  {
			     bool_t test1914_1604;
			     {
				bool_t res2246_2072;
				{
				   bool_t test1148_2070;
				   {
				      obj_t obj_2071;
				      obj_2071 = __about_to_read__202___r4_input_6_10_2;
				      test1148_2070 = PROCEDUREP(obj_2071);
				   }
				   if (test1148_2070)
				     {
					PROCEDURE_ENTRY(__about_to_read__202___r4_input_6_10_2) (__about_to_read__202___r4_input_6_10_2, input_port_219_1574, BEOA);
				     }
				   else
				     {
					BUNSPEC;
				     }
				}
				res2246_2072 = input_port_fill_buffer(input_port_219_1574);
				test1914_1604 = res2246_2072;
			     }
			     if (test1914_1604)
			       {
				  goto state_0_1591;
			       }
			     else
			       {
				  rule_1626 = mr_1590;
			       }
			  }
			  break;
		       default:
			  rule_1626 = mr_1590;
		       }
		  }
	       }
	       INPUT_PORT_AJUST_CURSOR(input_port_219_1574);
	       {
		  switch (rule_1626)
		    {
		    case ((long) 2):
		       {
			  obj_t arg1926_1633;
			  {
			     obj_t res2250_2094;
			     res2250_2094 = input_port_get_string(input_port_219_1574);
			     arg1926_1633 = res2250_2094;
			  }
			  {
			     obj_t list1927_1634;
			     list1927_1634 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			     display___r4_output_6_10_3(arg1926_1633, list1927_1634);
			  }
		       }
		       goto ignore_1588;
		       break;
		    case ((long) 1):
		       {
			  obj_t str_1636;
			  {
			     obj_t res2251_2096;
			     res2251_2096 = input_port_get_string(input_port_219_1574);
			     str_1636 = res2251_2096;
			  }
			  {
			     long len_1637;
			     len_1637 = INPUT_PORT_GET_LENGTH(input_port_219_1574);
			     {
				obj_t index_1638;
				{
				   obj_t arg1932_1641;
				   arg1932_1641 = c_substring(str_1636, ((long) 1), len_1637);
				   index_1638 = string__number_104___r4_numbers_6_5(arg1932_1641, BNIL);
				}
				{
				   {
				      cop_t aux_3224;
				      {
					 obj_t aux_3225;
					 {
					    long aux_3226;
					    {
					       long aux_3227;
					       aux_3227 = (long) CINT(index_1638);
					       aux_3226 = (aux_3227 - ((long) 1));
					    }
					    aux_3225 = VECTOR_REF(args_2459, aux_3226);
					 }
					 aux_3224 = (cop_t) (aux_3225);
				      }
				      emit_cop_45_cgen_emit_cop_239(aux_3224);
				   }
				   goto ignore_1588;
				}
			     }
			  }
		       }
		       break;
		    default:
		       {
			  bool_t test1934_1643;
			  test1934_1643 = INPUT_PORT_TOKEN_TOO_LARGEP(input_port_219_1574);
			  if (test1934_1643)
			    {
			       FAILURE(string2287_cgen_emit_cop_239, string2288_cgen_emit_cop_239, BUNSPEC);
			    }
			  else
			    {
			       BUNSPEC;
			    }
		       }
		       return INPUT_PORT_STEAL_CHAR(input_port_219_1574);
		    }
	       }
	    }
	 }
      }
   }
}


obj_t 
emit_atom_value_68_cgen_emit_cop_239(obj_t value_29)
{
   if (BOOLEANP(value_29))
     {
	{
	   obj_t list1474_840;
	   list1474_840 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
	   display___r4_output_6_10_3(string2259_cgen_emit_cop_239, list1474_840);
	}
	{
	   obj_t arg1477_842;
	   {
	      obj_t arg1481_845;
	      {
		 type_t obj_2242;
		 obj_2242 = (type_t) (__bool__149_type_cache);
		 arg1481_845 = (((type_t) CREF(obj_2242))->name);
	      }
	      arg1477_842 = string_sans___40_type_tools(arg1481_845);
	   }
	   {
	      obj_t list1478_843;
	      list1478_843 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
	      display___r4_output_6_10_3(arg1477_842, list1478_843);
	   }
	}
	{
	   obj_t list1482_846;
	   list1482_846 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
	   display___r4_output_6_10_3(BCHAR(((unsigned char) ')')), list1482_846);
	}
	{
	   long arg1485_848;
	   if (CBOOL(value_29))
	     {
		arg1485_848 = ((long) 1);
	     }
	   else
	     {
		arg1485_848 = ((long) 0);
	     }
	   {
	      obj_t list1486_849;
	      list1486_849 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
	      display___r4_output_6_10_3(BINT(arg1485_848), list1486_849);
	   }
	}
	{
	   obj_t list1488_851;
	   list1488_851 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
	   return display___r4_output_6_10_3(BCHAR(((unsigned char) ')')), list1488_851);
	}
     }
   else
     {
	if (NULLP(value_29))
	  {
	     {
		obj_t list1491_854;
		list1491_854 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
		return display___r4_output_6_10_3(string2289_cgen_emit_cop_239, list1491_854);
	     }
	  }
	else
	  {
	     if (CHARP(value_29))
	       {
		  {
		     obj_t list1495_857;
		     list1495_857 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
		     display___r4_output_6_10_3(string2259_cgen_emit_cop_239, list1495_857);
		  }
		  {
		     obj_t arg1497_859;
		     {
			obj_t arg1500_862;
			{
			   type_t obj_2245;
			   obj_2245 = (type_t) (__char__84_type_cache);
			   arg1500_862 = (((type_t) CREF(obj_2245))->name);
			}
			arg1497_859 = string_sans___40_type_tools(arg1500_862);
		     }
		     {
			obj_t list1498_860;
			list1498_860 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			display___r4_output_6_10_3(arg1497_859, list1498_860);
		     }
		  }
		  {
		     obj_t list1501_863;
		     list1501_863 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
		     display___r4_output_6_10_3(string2269_cgen_emit_cop_239, list1501_863);
		  }
		  {
		     bool_t test_3273;
		     {
			long aux_3274;
			{
			   unsigned char aux_3275;
			   aux_3275 = (unsigned char) CCHAR(value_29);
			   aux_3274 = (aux_3275);
			}
			test_3273 = (aux_3274 == ((long) 0));
		     }
		     if (test_3273)
		       {
			  obj_t list1507_866;
			  list1507_866 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			  display___r4_output_6_10_3(string2290_cgen_emit_cop_239, list1507_866);
		       }
		     else
		       {
			  {
			     obj_t list1510_868;
			     list1510_868 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			     write_char_165___r4_output_6_10_3(((unsigned char) '\''), list1510_868);
			  }
			  {
			     bool_t test_3283;
			     {
				long aux_3284;
				{
				   unsigned char aux_3285;
				   aux_3285 = (unsigned char) CCHAR(value_29);
				   aux_3284 = (aux_3285);
				}
				test_3283 = (aux_3284 == ((long) 39));
			     }
			     if (test_3283)
			       {
				  obj_t list1513_871;
				  list1513_871 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				  display___r4_output_6_10_3(string2291_cgen_emit_cop_239, list1513_871);
			       }
			     else
			       {
				  {
				     if (CHARP(value_29))
				       {
					  switch ((unsigned char) CCHAR(value_29))
					    {
					    case ((unsigned char) '\r'):
					       {
						  obj_t list1516_876;
						  list1516_876 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						  write_char_165___r4_output_6_10_3(((unsigned char) '\\'), list1516_876);
					       }
					       {
						  obj_t list1518_878;
						  list1518_878 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						  write_char_165___r4_output_6_10_3(((unsigned char) 'r'), list1518_878);
					       }
					       break;
					    case ((unsigned char) '\t'):
					       {
						  obj_t list1521_880;
						  list1521_880 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						  write_char_165___r4_output_6_10_3(((unsigned char) '\\'), list1521_880);
					       }
					       {
						  obj_t list1523_882;
						  list1523_882 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						  write_char_165___r4_output_6_10_3(((unsigned char) 't'), list1523_882);
					       }
					       break;
					    case ((unsigned char) '\n'):
					       {
						  obj_t list1525_884;
						  list1525_884 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						  write_char_165___r4_output_6_10_3(((unsigned char) '\\'), list1525_884);
					       }
					       {
						  obj_t list1527_886;
						  list1527_886 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						  write_char_165___r4_output_6_10_3(((unsigned char) 'n'), list1527_886);
					       }
					       break;
					    case ((unsigned char) '\\'):
					       {
						  obj_t list1530_888;
						  list1530_888 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						  write_char_165___r4_output_6_10_3(((unsigned char) '\\'), list1530_888);
					       }
					       {
						  obj_t list1532_890;
						  list1532_890 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						  write_char_165___r4_output_6_10_3(((unsigned char) '\\'), list1532_890);
					       }
					       break;
					    default:
					     case_else1441_253_873:
					       {
						  obj_t list1535_892;
						  list1535_892 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						  write_char_165___r4_output_6_10_3((unsigned char) CCHAR(value_29), list1535_892);
					       }
					    }
				       }
				     else
				       {
					  goto case_else1441_253_873;
				       }
				  }
				  {
				     obj_t list1537_894;
				     list1537_894 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				     write_char_165___r4_output_6_10_3(((unsigned char) '\''), list1537_894);
				  }
			       }
			  }
		       }
		  }
		  {
		     obj_t list1543_900;
		     list1543_900 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
		     return write_char_165___r4_output_6_10_3(((unsigned char) ')'), list1543_900);
		  }
	       }
	     else
	       {
		  if ((value_29 == BUNSPEC))
		    {
		       {
			  obj_t list1549_903;
			  list1549_903 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			  return display___r4_output_6_10_3(string2292_cgen_emit_cop_239, list1549_903);
		       }
		    }
		  else
		    {
		       if (CNSTP(value_29))
			 {
			    {
			       obj_t list1552_906;
			       list1552_906 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       display___r4_output_6_10_3(string2293_cgen_emit_cop_239, list1552_906);
			    }
			    {
			       long arg1554_908;
			       arg1554_908 = CCNST(value_29);
			       {
				  obj_t list1555_909;
				  list1555_909 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				  display___r4_output_6_10_3(BINT(arg1554_908), list1555_909);
			       }
			    }
			    {
			       obj_t list1558_911;
			       list1558_911 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			       return display___r4_output_6_10_3(BCHAR(((unsigned char) ')')), list1558_911);
			    }
			 }
		       else
			 {
			    if (STRINGP(value_29))
			      {
				 {
				    obj_t list1561_914;
				    list1561_914 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				    display___r4_output_6_10_3(BCHAR(((unsigned char) '"')), list1561_914);
				 }
				 {
				    obj_t arg1563_916;
				    {
				       obj_t arg1566_919;
				       arg1566_919 = string_for_read(value_29);
				       arg1563_916 = untrigraph_cgen_emit_cop_239(arg1566_919);
				    }
				    {
				       obj_t list1564_917;
				       list1564_917 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				       display___r4_output_6_10_3(arg1563_916, list1564_917);
				    }
				 }
				 {
				    obj_t list1567_920;
				    list1567_920 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
				    return display___r4_output_6_10_3(BCHAR(((unsigned char) '"')), list1567_920);
				 }
			      }
			    else
			      {
				 if (INTEGERP(value_29))
				   {
				      {
					 obj_t list1570_923;
					 list1570_923 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
					 display___r4_output_6_10_3(string2259_cgen_emit_cop_239, list1570_923);
				      }
				      {
					 obj_t arg1572_925;
					 {
					    obj_t arg1575_928;
					    {
					       type_t obj_2258;
					       obj_2258 = (type_t) (__long__149_type_cache);
					       arg1575_928 = (((type_t) CREF(obj_2258))->name);
					    }
					    arg1572_925 = string_sans___40_type_tools(arg1575_928);
					 }
					 {
					    obj_t list1573_926;
					    list1573_926 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
					    display___r4_output_6_10_3(arg1572_925, list1573_926);
					 }
				      }
				      {
					 obj_t list1576_929;
					 list1576_929 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
					 display___r4_output_6_10_3(string2269_cgen_emit_cop_239, list1576_929);
				      }
				      {
					 obj_t list1578_931;
					 list1578_931 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
					 display___r4_output_6_10_3(value_29, list1578_931);
				      }
				      {
					 obj_t list1580_933;
					 list1580_933 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
					 return display___r4_output_6_10_3(string2269_cgen_emit_cop_239, list1580_933);
				      }
				   }
				 else
				   {
				      if (REALP(value_29))
					{
					   {
					      obj_t list1584_936;
					      list1584_936 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
					      display___r4_output_6_10_3(string2259_cgen_emit_cop_239, list1584_936);
					   }
					   {
					      obj_t arg1587_938;
					      {
						 obj_t arg1590_941;
						 {
						    type_t obj_2260;
						    obj_2260 = (type_t) (__real__144_type_cache);
						    arg1590_941 = (((type_t) CREF(obj_2260))->name);
						 }
						 arg1587_938 = string_sans___40_type_tools(arg1590_941);
					      }
					      {
						 obj_t list1588_939;
						 list1588_939 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
						 display___r4_output_6_10_3(arg1587_938, list1588_939);
					      }
					   }
					   {
					      obj_t list1591_942;
					      list1591_942 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
					      display___r4_output_6_10_3(string2269_cgen_emit_cop_239, list1591_942);
					   }
					   {
					      obj_t list1593_944;
					      list1593_944 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
					      display___r4_output_6_10_3(value_29, list1593_944);
					   }
					   {
					      obj_t list1596_946;
					      list1596_946 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
					      return display___r4_output_6_10_3(string2269_cgen_emit_cop_239, list1596_946);
					   }
					}
				      else
					{
					   {
					      obj_t list1598_948;
					      list1598_948 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
					      return display___r4_output_6_10_3(value_29, list1598_948);
					   }
					}
				   }
			      }
			 }
		    }
	       }
	  }
     }
}


obj_t 
untrigraph_cgen_emit_cop_239(obj_t from_30)
{
   {
      long len_950;
      len_950 = STRING_LENGTH(from_30);
      {
	 long len_3_234_951;
	 len_3_234_951 = (len_950 - ((long) 3));
	 {
	    {
	       long nb_col_224_952;
	       {
		  long i_1010;
		  long nb_col_224_1011;
		  i_1010 = ((long) 0);
		  nb_col_224_1011 = ((long) 0);
		loop_1012:
		  if ((i_1010 > len_3_234_951))
		    {
		       nb_col_224_952 = nb_col_224_1011;
		    }
		  else
		    {
		       bool_t test_3381;
		       {
			  unsigned char aux_3382;
			  aux_3382 = STRING_REF(from_30, i_1010);
			  test_3381 = (aux_3382 == ((unsigned char) '?'));
		       }
		       if (test_3381)
			 {
			    bool_t test_3385;
			    {
			       unsigned char aux_3386;
			       {
				  long aux_3387;
				  aux_3387 = (i_1010 + ((long) 1));
				  aux_3386 = STRING_REF(from_30, aux_3387);
			       }
			       test_3385 = (aux_3386 == ((unsigned char) '?'));
			    }
			    if (test_3385)
			      {
				 {
				    long nb_col_224_3393;
				    long i_3391;
				    i_3391 = (i_1010 + ((long) 3));
				    nb_col_224_3393 = (nb_col_224_1011 + ((long) 1));
				    nb_col_224_1011 = nb_col_224_3393;
				    i_1010 = i_3391;
				    goto loop_1012;
				 }
			      }
			    else
			      {
				 {
				    long i_3395;
				    i_3395 = (i_1010 + ((long) 2));
				    i_1010 = i_3395;
				    goto loop_1012;
				 }
			      }
			 }
		       else
			 {
			    {
			       long i_3397;
			       i_3397 = (i_1010 + ((long) 1));
			       i_1010 = i_3397;
			       goto loop_1012;
			    }
			 }
		    }
	       }
	       if ((nb_col_224_952 == ((long) 0)))
		 {
		    return from_30;
		 }
	       else
		 {
		    obj_t res_954;
		    {
		       obj_t res2254_2298;
		       {
			  long aux_3401;
			  {
			     int aux_3402;
			     {
				long aux_3403;
				{
				   long aux_3404;
				   {
				      long aux_3405;
				      aux_3405 = (nb_col_224_952 * ((long) 3));
				      aux_3404 = (((long) 3) * aux_3405);
				   }
				   aux_3403 = (len_950 + aux_3404);
				}
				aux_3402 = (int) (aux_3403);
			     }
			     aux_3401 = (long) (aux_3402);
			  }
			  res2254_2298 = make_string(aux_3401, ((unsigned char) ' '));
		       }
		       res_954 = res2254_2298;
		    }
		    {
		       long r_956;
		       long w_957;
		       r_956 = ((long) 0);
		       w_957 = ((long) 0);
		     loop_958:
		       if ((r_956 == len_950))
			 {
			    return res_954;
			 }
		       else
			 {
			    bool_t test_3414;
			    {
			       bool_t test_3415;
			       {
				  unsigned char aux_3416;
				  aux_3416 = STRING_REF(from_30, r_956);
				  test_3415 = (aux_3416 == ((unsigned char) '?'));
			       }
			       if (test_3415)
				 {
				    test_3414 = (r_956 > len_3_234_951);
				 }
			       else
				 {
				    test_3414 = ((bool_t) 1);
				 }
			    }
			    if (test_3414)
			      {
				 {
				    unsigned char aux_3420;
				    aux_3420 = STRING_REF(from_30, r_956);
				    STRING_SET(res_954, w_957, aux_3420);
				 }
				 {
				    long w_3425;
				    long r_3423;
				    r_3423 = (r_956 + ((long) 1));
				    w_3425 = (w_957 + ((long) 1));
				    w_957 = w_3425;
				    r_956 = r_3423;
				    goto loop_958;
				 }
			      }
			    else
			      {
				 bool_t test_3427;
				 {
				    unsigned char aux_3428;
				    {
				       long aux_3429;
				       aux_3429 = (r_956 + ((long) 1));
				       aux_3428 = STRING_REF(from_30, aux_3429);
				    }
				    test_3427 = (aux_3428 == ((unsigned char) '?'));
				 }
				 if (test_3427)
				   {
				      STRING_SET(res_954, w_957, ((unsigned char) '\\'));
				      {
					 long aux_3434;
					 aux_3434 = (w_957 + ((long) 1));
					 STRING_SET(res_954, aux_3434, ((unsigned char) '0'));
				      }
				      {
					 long aux_3437;
					 aux_3437 = (w_957 + ((long) 2));
					 STRING_SET(res_954, aux_3437, ((unsigned char) '7'));
				      }
				      {
					 long aux_3440;
					 aux_3440 = (w_957 + ((long) 3));
					 STRING_SET(res_954, aux_3440, ((unsigned char) '7'));
				      }
				      {
					 long aux_3443;
					 aux_3443 = (w_957 + ((long) 4));
					 STRING_SET(res_954, aux_3443, ((unsigned char) '\\'));
				      }
				      {
					 long aux_3446;
					 aux_3446 = (w_957 + ((long) 5));
					 STRING_SET(res_954, aux_3446, ((unsigned char) '0'));
				      }
				      {
					 long aux_3449;
					 aux_3449 = (w_957 + ((long) 6));
					 STRING_SET(res_954, aux_3449, ((unsigned char) '7'));
				      }
				      {
					 long aux_3452;
					 aux_3452 = (w_957 + ((long) 7));
					 STRING_SET(res_954, aux_3452, ((unsigned char) '7'));
				      }
				      {
					 long aux_3455;
					 aux_3455 = (w_957 + ((long) 8));
					 STRING_SET(res_954, aux_3455, ((unsigned char) '\\'));
				      }
				      {
					 char *code_973;
					 {
					    long arg1643_988;
					    {
					       unsigned char aux_3458;
					       {
						  long aux_3459;
						  aux_3459 = (r_956 + ((long) 2));
						  aux_3458 = STRING_REF(from_30, aux_3459);
					       }
					       arg1643_988 = (aux_3458);
					    }
					    {
					       obj_t list1645_990;
					       {
						  obj_t aux_3463;
						  aux_3463 = BINT(((long) 8));
						  list1645_990 = MAKE_PAIR(aux_3463, BNIL);
					       }
					       code_973 = integer__string_135___r4_numbers_6_5_fixnum(arg1643_988, list1645_990);
					    }
					 }
					 {
					    bool_t test_3467;
					    {
					       long aux_3468;
					       {
						  obj_t aux_3469;
						  aux_3469 = string_to_bstring(code_973);
						  aux_3468 = STRING_LENGTH(aux_3469);
					       }
					       test_3467 = (aux_3468 == ((long) 4));
					    }
					    if (test_3467)
					      {
						 {
						    long aux_3473;
						    aux_3473 = (w_957 + ((long) 9));
						    STRING_SET(res_954, aux_3473, ((unsigned char) '0'));
						 }
						 {
						    unsigned char aux_3478;
						    long aux_3476;
						    {
						       obj_t aux_3479;
						       aux_3479 = string_to_bstring(code_973);
						       aux_3478 = STRING_REF(aux_3479, ((long) 2));
						    }
						    aux_3476 = (w_957 + ((long) 10));
						    STRING_SET(res_954, aux_3476, aux_3478);
						 }
						 {
						    unsigned char aux_3485;
						    long aux_3483;
						    {
						       obj_t aux_3486;
						       aux_3486 = string_to_bstring(code_973);
						       aux_3485 = STRING_REF(aux_3486, ((long) 3));
						    }
						    aux_3483 = (w_957 + ((long) 11));
						    STRING_SET(res_954, aux_3483, aux_3485);
						 }
					      }
					    else
					      {
						 {
						    unsigned char aux_3492;
						    long aux_3490;
						    {
						       obj_t aux_3493;
						       aux_3493 = string_to_bstring(code_973);
						       aux_3492 = STRING_REF(aux_3493, ((long) 2));
						    }
						    aux_3490 = (w_957 + ((long) 9));
						    STRING_SET(res_954, aux_3490, aux_3492);
						 }
						 {
						    unsigned char aux_3499;
						    long aux_3497;
						    {
						       obj_t aux_3500;
						       aux_3500 = string_to_bstring(code_973);
						       aux_3499 = STRING_REF(aux_3500, ((long) 3));
						    }
						    aux_3497 = (w_957 + ((long) 10));
						    STRING_SET(res_954, aux_3497, aux_3499);
						 }
						 {
						    unsigned char aux_3506;
						    long aux_3504;
						    {
						       obj_t aux_3507;
						       aux_3507 = string_to_bstring(code_973);
						       aux_3506 = STRING_REF(aux_3507, ((long) 4));
						    }
						    aux_3504 = (w_957 + ((long) 11));
						    STRING_SET(res_954, aux_3504, aux_3506);
						 }
					      }
					 }
				      }
				      {
					 long w_3513;
					 long r_3511;
					 r_3511 = (r_956 + ((long) 3));
					 w_3513 = (w_957 + ((long) 12));
					 w_957 = w_3513;
					 r_956 = r_3511;
					 goto loop_958;
				      }
				   }
				 else
				   {
				      STRING_SET(res_954, w_957, ((unsigned char) '?'));
				      {
					 unsigned char aux_3518;
					 long aux_3516;
					 {
					    long aux_3519;
					    aux_3519 = (r_956 + ((long) 1));
					    aux_3518 = STRING_REF(from_30, aux_3519);
					 }
					 aux_3516 = (w_957 + ((long) 1));
					 STRING_SET(res_954, aux_3516, aux_3518);
				      }
				      {
					 long w_3525;
					 long r_3523;
					 r_3523 = (r_956 + ((long) 2));
					 w_3525 = (w_957 + ((long) 2));
					 w_957 = w_3525;
					 r_956 = r_3523;
					 goto loop_958;
				      }
				   }
			      }
			 }
		    }
		 }
	    }
	 }
      }
   }
}


obj_t 
_untrigraph_cgen_emit_cop_239(obj_t env_2461, obj_t from_2462)
{
   return untrigraph_cgen_emit_cop_239(from_2462);
}


obj_t 
imported_modules_init_94_cgen_emit_cop_239()
{
   module_initialization_70_type_type(((long) 0), "CGEN_EMIT-COP");
   module_initialization_70_type_tools(((long) 0), "CGEN_EMIT-COP");
   module_initialization_70_type_cache(((long) 0), "CGEN_EMIT-COP");
   module_initialization_70_engine_param(((long) 0), "CGEN_EMIT-COP");
   module_initialization_70_ast_var(((long) 0), "CGEN_EMIT-COP");
   module_initialization_70_ast_node(((long) 0), "CGEN_EMIT-COP");
   module_initialization_70_cgen_emit(((long) 0), "CGEN_EMIT-COP");
   return module_initialization_70_cgen_cop(((long) 0), "CGEN_EMIT-COP");
}
