/*===========================================================================*/
/*   (Cgen/init.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t _make_module_init_166_cgen_init(obj_t);
extern node_t coerce__182_coerce_coerce(node_t, type_t);
extern global_t def_global_sfun__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_cgen_init();
extern obj_t module_initialization_70_cgen_init(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_ast_unit(long, char *);
extern obj_t module_initialization_70_ast_occur(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t cnst_init_137_cgen_init();
extern obj_t module_initialization_id_110_module_module(obj_t);
extern obj_t __module__166_module_module;
extern obj_t make_module_init_70_cgen_init();
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t unit_init_calls_56_ast_unit();
extern obj_t __unsafe_type__146_engine_param;
static obj_t require_initialization_114_cgen_init = BUNSPEC;
static obj_t library_modules_init_112_cgen_init();
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t __string__3_type_cache;
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern global_t def_global_svar__184_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
extern obj_t __long__149_type_cache;
extern obj_t __module_checksum__252_module_module;
extern obj_t __unsafe_version__81_engine_param;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _____74_type_cache;
extern obj_t __obj__252_type_cache;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
extern obj_t occur_node_in__115_ast_occur(node_t, global_t);
static obj_t __cnst[16];

DEFINE_STRING(string1508_cgen_init, string1508_cgen_init1515, "((($1) & ($2)) == ($1))", 23);
DEFINE_STRING(string1509_cgen_init, string1509_cgen_init1516, "EXPORT MODULE-INITIALIZATION SFUN (CHECKSUM FROM) VALUE FROM MODULE-INIT-ERROR CHECKSUM PRAGMA::BOOL SET! BEGIN REQUIRE-INITIALIZATION IF NOW MODULE-INITALIZATION REQUIRE-INITIALIZATION::OBJ ", 191);
DEFINE_EXPORT_PROCEDURE(make_module_init_env_79_cgen_init, _make_module_init_166_cgen_init1517, _make_module_init_166_cgen_init, 0L, 0);

obj_t 
module_initialization_70_cgen_init(long checksum_1065, char *from_1066)
{
   if (CBOOL(require_initialization_114_cgen_init))
     {
	require_initialization_114_cgen_init = BBOOL(((bool_t) 0));
	library_modules_init_112_cgen_init();
	cnst_init_137_cgen_init();
	imported_modules_init_94_cgen_init();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cgen_init()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CGEN_INIT");
   module_initialization_70___reader(((long) 0), "CGEN_INIT");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cgen_init()
{
   {
      obj_t cnst_port_138_1057;
      cnst_port_138_1057 = open_input_string(string1509_cgen_init);
      {
	 long i_1058;
	 i_1058 = ((long) 15);
       loop_1059:
	 {
	    bool_t test1510_1060;
	    test1510_1060 = (i_1058 == ((long) -1));
	    if (test1510_1060)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1511_1061;
		    {
		       obj_t list1512_1062;
		       {
			  obj_t arg1513_1063;
			  arg1513_1063 = BNIL;
			  list1512_1062 = MAKE_PAIR(cnst_port_138_1057, arg1513_1063);
		       }
		       arg1511_1061 = read___reader(list1512_1062);
		    }
		    CNST_TABLE_SET(i_1058, arg1511_1061);
		 }
		 {
		    int aux_1064;
		    {
		       long aux_1081;
		       aux_1081 = (i_1058 - ((long) 1));
		       aux_1064 = (int) (aux_1081);
		    }
		    {
		       long i_1084;
		       i_1084 = (long) (aux_1064);
		       i_1058 = i_1084;
		       goto loop_1059;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
make_module_init_70_cgen_init()
{
   {
      global_t req_641;
      req_641 = def_global_svar__184_ast_glo_def_117(CNST_TABLE_REF(((long) 0)), __module__166_module_module, CNST_TABLE_REF(((long) 1)), CNST_TABLE_REF(((long) 2)));
      {
	 obj_t ubody_642;
	 {
	    obj_t arg1340_696;
	    obj_t arg1342_697;
	    obj_t arg1343_698;
	    arg1340_696 = CNST_TABLE_REF(((long) 3));
	    arg1342_697 = CNST_TABLE_REF(((long) 4));
	    {
	       obj_t arg1353_705;
	       obj_t arg1355_706;
	       obj_t arg1356_707;
	       arg1353_705 = CNST_TABLE_REF(((long) 5));
	       {
		  obj_t arg1361_711;
		  obj_t arg1363_712;
		  arg1361_711 = CNST_TABLE_REF(((long) 6));
		  arg1363_712 = CNST_TABLE_REF(((long) 4));
		  {
		     obj_t list1365_714;
		     {
			obj_t arg1366_715;
			{
			   obj_t arg1367_716;
			   arg1367_716 = MAKE_PAIR(BNIL, BNIL);
			   arg1366_715 = MAKE_PAIR(BFALSE, arg1367_716);
			}
			list1365_714 = MAKE_PAIR(arg1363_712, arg1366_715);
		     }
		     arg1355_706 = cons__138___r4_pairs_and_lists_6_3(arg1361_711, list1365_714);
		  }
	       }
	       {
		  obj_t arg1370_718;
		  obj_t arg1372_719;
		  arg1370_718 = unit_init_calls_56_ast_unit();
		  {
		     obj_t list1377_721;
		     list1377_721 = MAKE_PAIR(BNIL, BNIL);
		     arg1372_719 = cons__138___r4_pairs_and_lists_6_3(BUNSPEC, list1377_721);
		  }
		  arg1356_707 = append_2_18___r4_pairs_and_lists_6_3(arg1370_718, arg1372_719);
	       }
	       {
		  obj_t list1357_708;
		  {
		     obj_t arg1358_709;
		     arg1358_709 = MAKE_PAIR(arg1356_707, BNIL);
		     list1357_708 = MAKE_PAIR(arg1355_706, arg1358_709);
		  }
		  arg1343_698 = cons__138___r4_pairs_and_lists_6_3(arg1353_705, list1357_708);
	       }
	    }
	    {
	       obj_t list1346_700;
	       {
		  obj_t arg1347_701;
		  {
		     obj_t arg1349_702;
		     {
			obj_t arg1350_703;
			arg1350_703 = MAKE_PAIR(BNIL, BNIL);
			arg1349_702 = MAKE_PAIR(BUNSPEC, arg1350_703);
		     }
		     arg1347_701 = MAKE_PAIR(arg1343_698, arg1349_702);
		  }
		  list1346_700 = MAKE_PAIR(arg1342_697, arg1347_701);
	       }
	       ubody_642 = cons__138___r4_pairs_and_lists_6_3(arg1340_696, list1346_700);
	    }
	 }
	 {
	    obj_t body_643;
	    if (CBOOL(__unsafe_version__81_engine_param))
	      {
		 body_643 = ubody_642;
	      }
	    else
	      {
		 obj_t arg1305_670;
		 obj_t arg1307_671;
		 obj_t arg1308_672;
		 arg1305_670 = CNST_TABLE_REF(((long) 3));
		 {
		    obj_t arg1316_679;
		    obj_t arg1319_681;
		    arg1316_679 = CNST_TABLE_REF(((long) 7));
		    arg1319_681 = CNST_TABLE_REF(((long) 8));
		    {
		       obj_t list1321_683;
		       {
			  obj_t arg1322_684;
			  {
			     obj_t arg1323_685;
			     {
				obj_t arg1325_686;
				arg1325_686 = MAKE_PAIR(BNIL, BNIL);
				arg1323_685 = MAKE_PAIR(__module_checksum__252_module_module, arg1325_686);
			     }
			     arg1322_684 = MAKE_PAIR(arg1319_681, arg1323_685);
			  }
			  list1321_683 = MAKE_PAIR(string1508_cgen_init, arg1322_684);
		       }
		       arg1307_671 = cons__138___r4_pairs_and_lists_6_3(arg1316_679, list1321_683);
		    }
		 }
		 {
		    obj_t arg1328_688;
		    obj_t arg1329_689;
		    obj_t arg1331_690;
		    arg1328_688 = CNST_TABLE_REF(((long) 9));
		    {
		       obj_t symbol_1045;
		       symbol_1045 = __module__166_module_module;
		       arg1329_689 = SYMBOL_TO_STRING(symbol_1045);
		    }
		    arg1331_690 = CNST_TABLE_REF(((long) 10));
		    {
		       obj_t list1333_692;
		       {
			  obj_t arg1334_693;
			  {
			     obj_t arg1337_694;
			     arg1337_694 = MAKE_PAIR(BNIL, BNIL);
			     arg1334_693 = MAKE_PAIR(arg1331_690, arg1337_694);
			  }
			  list1333_692 = MAKE_PAIR(arg1329_689, arg1334_693);
		       }
		       arg1308_672 = cons__138___r4_pairs_and_lists_6_3(arg1328_688, list1333_692);
		    }
		 }
		 {
		    obj_t list1311_674;
		    {
		       obj_t arg1312_675;
		       {
			  obj_t arg1313_676;
			  {
			     obj_t arg1314_677;
			     arg1314_677 = MAKE_PAIR(BNIL, BNIL);
			     arg1313_676 = MAKE_PAIR(arg1308_672, arg1314_677);
			  }
			  arg1312_675 = MAKE_PAIR(ubody_642, arg1313_676);
		       }
		       list1311_674 = MAKE_PAIR(arg1307_671, arg1312_675);
		    }
		    body_643 = cons__138___r4_pairs_and_lists_6_3(arg1305_670, list1311_674);
		 }
	      }
	    {
	       local_t cvar_644;
	       cvar_644 = make_local_svar_140_ast_local(CNST_TABLE_REF(((long) 8)), (type_t) (__long__149_type_cache));
	       {
		  local_t nvar_645;
		  nvar_645 = make_local_svar_140_ast_local(CNST_TABLE_REF(((long) 10)), (type_t) (__string__3_type_cache));
		  {
		     node_t node_646;
		     {
			obj_t __658;
			obj_t unsafe_type_48_659;
			__658 = _____74_type_cache;
			unsafe_type_48_659 = __unsafe_type__146_engine_param;
			_____74_type_cache = __obj__252_type_cache;
			__unsafe_type__146_engine_param = BTRUE;
			{
			   node_t node_660;
			   {
			      node_t arg1290_661;
			      {
				 obj_t arg1293_662;
				 obj_t arg1296_664;
				 {
				    obj_t list1297_665;
				    {
				       obj_t arg1298_666;
				       {
					  obj_t aux_1139;
					  aux_1139 = (obj_t) (nvar_645);
					  arg1298_666 = MAKE_PAIR(aux_1139, BNIL);
				       }
				       {
					  obj_t aux_1142;
					  aux_1142 = (obj_t) (cvar_644);
					  list1297_665 = MAKE_PAIR(aux_1142, arg1298_666);
				       }
				    }
				    arg1293_662 = list1297_665;
				 }
				 arg1296_664 = CNST_TABLE_REF(((long) 11));
				 arg1290_661 = sexp__node_235_ast_sexp(body_643, arg1293_662, BNIL, arg1296_664);
			      }
			      node_660 = coerce__182_coerce_coerce(arg1290_661, (type_t) (__obj__252_type_cache));
			   }
			   _____74_type_cache = __658;
			   __unsafe_type__146_engine_param = unsafe_type_48_659;
			   node_646 = node_660;
			}
		     }
		     {
			global_t init_647;
			{
			   obj_t arg1276_649;
			   obj_t arg1278_650;
			   obj_t arg1279_651;
			   obj_t arg1280_652;
			   obj_t arg1282_653;
			   obj_t arg1283_654;
			   arg1276_649 = module_initialization_id_110_module_module(__module__166_module_module);
			   arg1278_650 = CNST_TABLE_REF(((long) 12));
			   {
			      obj_t list1284_655;
			      {
				 obj_t arg1286_656;
				 {
				    obj_t aux_1151;
				    aux_1151 = (obj_t) (nvar_645);
				    arg1286_656 = MAKE_PAIR(aux_1151, BNIL);
				 }
				 {
				    obj_t aux_1154;
				    aux_1154 = (obj_t) (cvar_644);
				    list1284_655 = MAKE_PAIR(aux_1154, arg1286_656);
				 }
			      }
			      arg1279_651 = list1284_655;
			   }
			   arg1280_652 = CNST_TABLE_REF(((long) 13));
			   arg1282_653 = CNST_TABLE_REF(((long) 14));
			   arg1283_654 = CNST_TABLE_REF(((long) 2));
			   init_647 = def_global_sfun__93_ast_glo_def_117(arg1276_649, arg1278_650, arg1279_651, __module__166_module_module, arg1280_652, arg1282_653, arg1283_654, (obj_t) (node_646));
			}
			{
			   {
			      obj_t arg1275_648;
			      arg1275_648 = CNST_TABLE_REF(((long) 15));
			      {
				 obj_t res1506_1050;
				 {
				    obj_t x_1055;
				    x_1055 = ((((global_t) CREF(init_647))->import) = ((obj_t) arg1275_648), BUNSPEC);
				    res1506_1050 = BUNSPEC;
				 }
				 res1506_1050;
			      }
			   }
			   {
			      obj_t res1507_1053;
			      {
				 type_t val1041_1052;
				 val1041_1052 = (type_t) (__obj__252_type_cache);
				 {
				    obj_t x_1056;
				    x_1056 = ((((global_t) CREF(init_647))->type) = ((type_t) val1041_1052), BUNSPEC);
				    res1507_1053 = BUNSPEC;
				 }
			      }
			      res1507_1053;
			   }
			   occur_node_in__115_ast_occur(node_646, init_647);
			   return (obj_t) (init_647);
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_make_module_init_166_cgen_init(obj_t env_1054)
{
   return make_module_init_70_cgen_init();
}


obj_t 
imported_modules_init_94_cgen_init()
{
   module_initialization_70_engine_param(((long) 0), "CGEN_INIT");
   module_initialization_70_module_module(((long) 0), "CGEN_INIT");
   module_initialization_70_tools_shape(((long) 0), "CGEN_INIT");
   module_initialization_70_type_type(((long) 0), "CGEN_INIT");
   module_initialization_70_type_cache(((long) 0), "CGEN_INIT");
   module_initialization_70_ast_var(((long) 0), "CGEN_INIT");
   module_initialization_70_ast_node(((long) 0), "CGEN_INIT");
   module_initialization_70_ast_env(((long) 0), "CGEN_INIT");
   module_initialization_70_ast_sexp(((long) 0), "CGEN_INIT");
   module_initialization_70_ast_local(((long) 0), "CGEN_INIT");
   module_initialization_70_ast_glo_def_117(((long) 0), "CGEN_INIT");
   module_initialization_70_ast_unit(((long) 0), "CGEN_INIT");
   module_initialization_70_ast_occur(((long) 0), "CGEN_INIT");
   return module_initialization_70_coerce_coerce(((long) 0), "CGEN_INIT");
}
