/*===========================================================================*/
/*   (Cgen/main.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern global_t def_global_sfun__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern obj_t _make_bigloo_main_92_cgen_main(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_cgen_main();
extern obj_t module_initialization_70_cgen_main(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t cnst_init_137_cgen_main();
extern obj_t module_initialization_id_110_module_module(obj_t);
extern obj_t __module__166_module_module;
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t require_initialization_114_cgen_main = BUNSPEC;
static obj_t library_modules_init_112_cgen_main();
extern obj_t __main__152_module_module;
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t make_bigloo_main_85_cgen_main();
extern obj_t _____74_type_cache;
extern obj_t __obj__252_type_cache;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
static obj_t __cnst[10];

DEFINE_EXPORT_PROCEDURE(make_bigloo_main_env_171_cgen_main, _make_bigloo_main_92_cgen_main1495, _make_bigloo_main_92_cgen_main, 0L, 0);
DEFINE_STRING(string1486_cgen_main, string1486_cgen_main1496, "bigloo_main", 11);
DEFINE_STRING(string1487_cgen_main, string1487_cgen_main1497, "NOW BIGLOO-MAIN-PROCEDURE SFUN (ARGV::OBJ) BIGLOO_MAIN::OBJ VALUE @ BIGLOO-EXIT BEGIN ARGV ", 91);

obj_t 
module_initialization_70_cgen_main(long checksum_1049, char *from_1050)
{
   if (CBOOL(require_initialization_114_cgen_main))
     {
	require_initialization_114_cgen_main = BBOOL(((bool_t) 0));
	library_modules_init_112_cgen_main();
	cnst_init_137_cgen_main();
	imported_modules_init_94_cgen_main();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cgen_main()
{
   module_initialization_70___object(((long) 0), "CGEN_MAIN");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CGEN_MAIN");
   module_initialization_70___reader(((long) 0), "CGEN_MAIN");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cgen_main()
{
   {
      obj_t cnst_port_138_1041;
      cnst_port_138_1041 = open_input_string(string1487_cgen_main);
      {
	 long i_1042;
	 i_1042 = ((long) 9);
       loop_1043:
	 {
	    bool_t test1488_1044;
	    test1488_1044 = (i_1042 == ((long) -1));
	    if (test1488_1044)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1489_1045;
		    {
		       obj_t list1490_1046;
		       {
			  obj_t arg1493_1047;
			  arg1493_1047 = BNIL;
			  list1490_1046 = MAKE_PAIR(cnst_port_138_1041, arg1493_1047);
		       }
		       arg1489_1045 = read___reader(list1490_1046);
		    }
		    CNST_TABLE_SET(i_1042, arg1489_1045);
		 }
		 {
		    int aux_1048;
		    {
		       long aux_1066;
		       aux_1066 = (i_1042 - ((long) 1));
		       aux_1048 = (int) (aux_1066);
		    }
		    {
		       long i_1069;
		       i_1069 = (long) (aux_1048);
		       i_1042 = i_1069;
		       goto loop_1043;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
make_bigloo_main_85_cgen_main()
{
   {
      obj_t args_641;
      {
	 local_t arg1355_706;
	 arg1355_706 = make_local_svar_140_ast_local(CNST_TABLE_REF(((long) 0)), (type_t) (__obj__252_type_cache));
	 {
	    obj_t list1356_707;
	    {
	       obj_t aux_1074;
	       aux_1074 = (obj_t) (arg1355_706);
	       list1356_707 = MAKE_PAIR(aux_1074, BNIL);
	    }
	    args_641 = list1356_707;
	 }
      }
      {
	 obj_t user_main_99_642;
	 {
	    bool_t test1353_705;
	    {
	       obj_t obj_1030;
	       obj_1030 = __main__152_module_module;
	       test1353_705 = is_a__118___object(obj_1030, global_ast_var);
	    }
	    if (test1353_705)
	      {
		 user_main_99_642 = __main__152_module_module;
	      }
	    else
	      {
		 user_main_99_642 = BFALSE;
	      }
	 }
	 {
	    obj_t main_body_213_643;
	    {
	       bool_t test1283_654;
	       test1283_654 = is_a__118___object(user_main_99_642, global_ast_var);
	       if (test1283_654)
		 {
		    obj_t arg1284_655;
		    obj_t arg1286_656;
		    obj_t arg1287_657;
		    arg1284_655 = CNST_TABLE_REF(((long) 1));
		    {
		       obj_t arg1297_663;
		       obj_t arg1299_665;
		       arg1297_663 = module_initialization_id_110_module_module(__module__166_module_module);
		       {
			  obj_t symbol_1032;
			  symbol_1032 = __module__166_module_module;
			  arg1299_665 = SYMBOL_TO_STRING(symbol_1032);
		       }
		       {
			  obj_t list1301_667;
			  {
			     obj_t arg1303_668;
			     {
				obj_t arg1305_669;
				arg1305_669 = MAKE_PAIR(BNIL, BNIL);
				arg1303_668 = MAKE_PAIR(arg1299_665, arg1305_669);
			     }
			     {
				obj_t aux_1086;
				aux_1086 = BINT(((long) 0));
				list1301_667 = MAKE_PAIR(aux_1086, arg1303_668);
			     }
			  }
			  arg1286_656 = cons__138___r4_pairs_and_lists_6_3(arg1297_663, list1301_667);
		       }
		    }
		    {
		       obj_t arg1308_671;
		       obj_t arg1310_672;
		       arg1308_671 = CNST_TABLE_REF(((long) 2));
		       {
			  obj_t arg1315_677;
			  obj_t arg1316_678;
			  {
			     obj_t arg1322_683;
			     obj_t arg1323_684;
			     obj_t arg1325_685;
			     arg1322_683 = CNST_TABLE_REF(((long) 3));
			     {
				global_t obj_1033;
				obj_1033 = (global_t) (user_main_99_642);
				arg1323_684 = (((global_t) CREF(obj_1033))->id);
			     }
			     {
				global_t obj_1034;
				obj_1034 = (global_t) (user_main_99_642);
				arg1325_685 = (((global_t) CREF(obj_1034))->module);
			     }
			     {
				obj_t list1328_687;
				{
				   obj_t arg1329_688;
				   {
				      obj_t arg1331_689;
				      arg1331_689 = MAKE_PAIR(BNIL, BNIL);
				      arg1329_688 = MAKE_PAIR(arg1325_685, arg1331_689);
				   }
				   list1328_687 = MAKE_PAIR(arg1323_684, arg1329_688);
				}
				arg1315_677 = cons__138___r4_pairs_and_lists_6_3(arg1322_683, list1328_687);
			     }
			  }
			  arg1316_678 = CNST_TABLE_REF(((long) 0));
			  {
			     obj_t list1319_680;
			     {
				obj_t arg1320_681;
				arg1320_681 = MAKE_PAIR(BNIL, BNIL);
				list1319_680 = MAKE_PAIR(arg1316_678, arg1320_681);
			     }
			     arg1310_672 = cons__138___r4_pairs_and_lists_6_3(arg1315_677, list1319_680);
			  }
		       }
		       {
			  obj_t list1312_674;
			  {
			     obj_t arg1313_675;
			     arg1313_675 = MAKE_PAIR(BNIL, BNIL);
			     list1312_674 = MAKE_PAIR(arg1310_672, arg1313_675);
			  }
			  arg1287_657 = cons__138___r4_pairs_and_lists_6_3(arg1308_671, list1312_674);
		       }
		    }
		    {
		       obj_t list1291_659;
		       {
			  obj_t arg1293_660;
			  {
			     obj_t arg1295_661;
			     arg1295_661 = MAKE_PAIR(BNIL, BNIL);
			     arg1293_660 = MAKE_PAIR(arg1287_657, arg1295_661);
			  }
			  list1291_659 = MAKE_PAIR(arg1286_656, arg1293_660);
		       }
		       main_body_213_643 = cons__138___r4_pairs_and_lists_6_3(arg1284_655, list1291_659);
		    }
		 }
	       else
		 {
		    obj_t arg1333_691;
		    obj_t arg1334_692;
		    arg1333_691 = CNST_TABLE_REF(((long) 2));
		    {
		       obj_t arg1342_697;
		       obj_t arg1345_699;
		       arg1342_697 = module_initialization_id_110_module_module(__module__166_module_module);
		       {
			  obj_t symbol_1035;
			  symbol_1035 = __module__166_module_module;
			  arg1345_699 = SYMBOL_TO_STRING(symbol_1035);
		       }
		       {
			  obj_t list1347_701;
			  {
			     obj_t arg1349_702;
			     {
				obj_t arg1350_703;
				arg1350_703 = MAKE_PAIR(BNIL, BNIL);
				arg1349_702 = MAKE_PAIR(arg1345_699, arg1350_703);
			     }
			     {
				obj_t aux_1116;
				aux_1116 = BINT(((long) 0));
				list1347_701 = MAKE_PAIR(aux_1116, arg1349_702);
			     }
			  }
			  arg1334_692 = cons__138___r4_pairs_and_lists_6_3(arg1342_697, list1347_701);
		       }
		    }
		    {
		       obj_t list1338_694;
		       {
			  obj_t arg1339_695;
			  arg1339_695 = MAKE_PAIR(BNIL, BNIL);
			  list1338_694 = MAKE_PAIR(arg1334_692, arg1339_695);
		       }
		       main_body_213_643 = cons__138___r4_pairs_and_lists_6_3(arg1333_691, list1338_694);
		    }
		 }
	    }
	    {
	       node_t node_644;
	       {
		  obj_t __651;
		  __651 = _____74_type_cache;
		  _____74_type_cache = __obj__252_type_cache;
		  {
		     node_t node_652;
		     node_652 = sexp__node_235_ast_sexp(main_body_213_643, args_641, BFALSE, CNST_TABLE_REF(((long) 4)));
		     _____74_type_cache = __651;
		     node_644 = node_652;
		  }
	       }
	       {
		  global_t bigloo_main_109_645;
		  bigloo_main_109_645 = def_global_sfun__93_ast_glo_def_117(CNST_TABLE_REF(((long) 5)), CNST_TABLE_REF(((long) 6)), args_641, __module__166_module_module, CNST_TABLE_REF(((long) 7)), CNST_TABLE_REF(((long) 8)), CNST_TABLE_REF(((long) 9)), (obj_t) (node_644));
		  {
		     {
			obj_t res1485_1038;
			{
			   obj_t val1040_1037;
			   val1040_1037 = string1486_cgen_main;
			   {
			      obj_t x_1040;
			      x_1040 = ((((global_t) CREF(bigloo_main_109_645))->name) = ((obj_t) val1040_1037), BUNSPEC);
			      res1485_1038 = BUNSPEC;
			   }
			}
			res1485_1038;
		     }
		     return (obj_t) (bigloo_main_109_645);
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_make_bigloo_main_92_cgen_main(obj_t env_1039)
{
   return make_bigloo_main_85_cgen_main();
}


obj_t 
imported_modules_init_94_cgen_main()
{
   module_initialization_70_engine_param(((long) 0), "CGEN_MAIN");
   module_initialization_70_module_module(((long) 0), "CGEN_MAIN");
   module_initialization_70_type_type(((long) 0), "CGEN_MAIN");
   module_initialization_70_type_cache(((long) 0), "CGEN_MAIN");
   module_initialization_70_ast_var(((long) 0), "CGEN_MAIN");
   module_initialization_70_ast_node(((long) 0), "CGEN_MAIN");
   module_initialization_70_ast_env(((long) 0), "CGEN_MAIN");
   module_initialization_70_ast_sexp(((long) 0), "CGEN_MAIN");
   module_initialization_70_ast_local(((long) 0), "CGEN_MAIN");
   return module_initialization_70_ast_glo_def_117(((long) 0), "CGEN_MAIN");
}
