/*===========================================================================*/
/*   (Cgen/proto.scm)                                                        */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct tvec
  {
     struct type *item_type_130;
  }
    *tvec_t;

typedef struct cop
  {
     header_t header;
     obj_t widening;
  }
   *cop_t;

typedef struct clabel
  {
     header_t header;
     obj_t widening;
     obj_t name;
     bool_t used__226;
     obj_t body;
  }
      *clabel_t;

typedef struct cgoto
  {
     header_t header;
     obj_t widening;
     struct clabel *label;
  }
     *cgoto_t;

typedef struct block
  {
     header_t header;
     obj_t widening;
     struct cop *body;
  }
     *block_t;

typedef struct creturn
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
       *creturn_t;

typedef struct cvoid
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
     *cvoid_t;

typedef struct catom
  {
     header_t header;
     obj_t widening;
     obj_t value;
  }
     *catom_t;

typedef struct varc
  {
     header_t header;
     obj_t widening;
     struct variable *variable;
  }
    *varc_t;

typedef struct cpragma
  {
     header_t header;
     obj_t widening;
     obj_t format;
     obj_t args;
  }
       *cpragma_t;

typedef struct ccast
  {
     header_t header;
     obj_t widening;
     struct type *type;
     struct cop *arg;
  }
     *ccast_t;

typedef struct csequence
  {
     header_t header;
     obj_t widening;
     bool_t c_exp__163;
     obj_t cops;
  }
         *csequence_t;

typedef struct nop
  {
     header_t header;
     obj_t widening;
  }
   *nop_t;

typedef struct stop
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
    *stop_t;

typedef struct csetq
  {
     header_t header;
     obj_t widening;
     struct varc *var;
     struct cop *value;
  }
     *csetq_t;

typedef struct cif
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     struct cop *true;
     struct cop *false;
  }
   *cif_t;

typedef struct branch
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     struct cop *true;
     struct cop *false;
     struct cop *end;
  }
      *branch_t;

typedef struct local_var_164
  {
     header_t header;
     obj_t widening;
     obj_t vars;
  }
             *local_var_164_t;

typedef struct cfuncall
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     obj_t args;
     obj_t strength;
  }
        *cfuncall_t;

typedef struct capply
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     struct cop *arg;
  }
      *capply_t;

typedef struct capp
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     obj_t args;
  }
    *capp_t;

typedef struct cfail
  {
     header_t header;
     obj_t widening;
     struct cop *proc;
     struct cop *msg;
     struct cop *obj;
  }
     *cfail_t;

typedef struct cswitch
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     obj_t clauses;
  }
       *cswitch_t;

typedef struct cmake_box_177
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
             *cmake_box_177_t;

typedef struct cbox_ref_44
  {
     header_t header;
     obj_t widening;
     struct cop *var;
  }
           *cbox_ref_44_t;

typedef struct cbox_set__132
  {
     header_t header;
     obj_t widening;
     struct cop *var;
     struct cop *value;
  }
             *cbox_set__132_t;

typedef struct cset_ex_it_123
  {
     header_t header;
     obj_t widening;
     struct cop *exit;
     struct cop *jump_value_221;
     struct cop *body;
  }
              *cset_ex_it_123_t;

typedef struct cjump_ex_it_131
  {
     header_t header;
     obj_t widening;
     struct cop *exit;
     struct cop *value;
  }
               *cjump_ex_it_131_t;

typedef struct sfun_c_188
  {
     struct clabel *label;
     bool_t integrated;
  }
          *sfun_c_188_t;


static obj_t _emit_prototype_default1436_149_cgen_prototype(obj_t, obj_t, obj_t);
extern obj_t string_for_read(obj_t);
static obj_t arg14672151_cgen_prototype(obj_t, obj_t);
extern obj_t type_type_type;
static bool_t emit_prototype_formal_types_237_cgen_prototype(obj_t);
extern obj_t _emit_prototypes_68_cgen_prototype(obj_t);
extern obj_t scnst_ast_var;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
static obj_t _get_c_scope_default1442_42_cgen_prototype(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
extern obj_t make_typed_declaration_180_type_tools(type_t, obj_t);
static obj_t imported_modules_init_94_cgen_prototype();
extern obj_t module_initialization_70_cgen_prototype(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_tvector_tvector(long, char *);
extern obj_t module_initialization_70_tvector_cnst(long, char *);
extern obj_t module_initialization_70_cnst_alloc(long, char *);
extern obj_t module_initialization_70_cgen_cop(long, char *);
extern obj_t module_initialization_70_cgen_emit(long, char *);
extern obj_t module_initialization_70_cgen_emit_cop_239(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t emit_cnst_string_104_cgen_prototype(obj_t, global_t);
extern obj_t newline___r4_output_6_10_3(obj_t);
static obj_t toplevel_init_63_cgen_prototype();
static obj_t cnst_init_137_cgen_prototype();
static obj_t emit_cnst_stvector_253_cgen_prototype(obj_t, global_t);
extern obj_t cfun_ast_var;
extern obj_t __module__166_module_module;
static obj_t get_c_scope_184_cgen_prototype(variable_t);
static obj_t get_c_scope_default1442_143_cgen_prototype(variable_t);
extern obj_t string_sans___40_type_tools(obj_t);
static obj_t emit_cnst_real_94_cgen_prototype(obj_t, global_t);
static obj_t require_initialization_114_cgen_prototype = BUNSPEC;
static obj_t _emit_prototype_100_cgen_prototype(obj_t, obj_t, obj_t);
static obj_t emit_prototype_svar_scnst_27_cgen_prototype(obj_t, variable_t);
static obj_t library_modules_init_112_cgen_prototype();
extern obj_t sfun_ast_var;
extern obj_t _emit_cnsts_87_cgen_prototype(obj_t);
extern obj_t __c_port__188_cgen_emit;
extern obj_t read___reader(obj_t);
extern obj_t emit_prototypes_82_cgen_prototype();
static obj_t emit_cnst_44_cgen_prototype(scnst_t, global_t);
static bool_t fprin_cgen_prototype(obj_t, obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t type_name_sans___47_type_tools(type_t);
extern obj_t open_input_string(obj_t);
static bool_t emit_prototype_formals_182_cgen_prototype(obj_t);
extern obj_t untrigraph_cgen_emit_cop_239(obj_t);
static obj_t emit_prototype_23_cgen_prototype(value_t, variable_t);
static obj_t _get_c_scope_242_cgen_prototype(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern bool_t sub_type__174_type_env(type_t, type_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t svar_ast_var;
extern obj_t id__name_228_ast_ident(obj_t);
extern obj_t cvar_ast_var;
extern obj_t for_each_global__88_ast_env(obj_t);
static obj_t emit_cnst_sfun_sgfun_176_cgen_prototype(obj_t, global_t, char *);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t display___r4_output_6_10_3(obj_t, obj_t);
extern obj_t _set_variable_name__28_cgen_prototype(obj_t, obj_t);
extern obj_t local_ast_var;
extern obj_t gensym___r4_symbols_6_4;
static obj_t arg14892152_cgen_prototype(obj_t, obj_t);
extern obj_t set_variable_name__102_cgen_prototype(obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t emit_cnsts_221_cgen_prototype();
extern obj_t get_cnst_table_42_cnst_alloc();
extern obj_t __max_c_token_length__129_engine_param;
extern obj_t __obj__252_type_cache;
static obj_t emit_prototype_default1436_125_cgen_prototype(value_t, variable_t);
extern obj_t c_substring(obj_t, long, long);
extern obj_t tvector__c_vector_165_tvector_cnst(obj_t);
static obj_t __cnst[10];

DEFINE_STRING(string2176_cgen_prototype, string2176_cgen_prototype2193, ", 0L, ", 6);
DEFINE_STRING(string2164_cgen_prototype, string2164_cgen_prototype2194, "Unknown cnst class", 18);
DEFINE_STATIC_PROCEDURE(proc2154_cgen_prototype, arg14892152_cgen_prototype2195, arg14892152_cgen_prototype, 0L, 1);
DEFINE_STRING(string2177_cgen_prototype, string2177_cgen_prototype2196, ", va_generic_entry", 18);
DEFINE_STRING(string2162_cgen_prototype, string2162_cgen_prototype2197, "()", 2);
DEFINE_STRING(string2161_cgen_prototype, string2161_cgen_prototype2198, "static", 6);
DEFINE_STRING(string2155_cgen_prototype, string2155_cgen_prototype2199, "No method for this object", 25);
DEFINE_STATIC_GENERIC(emit_prototype_env_241_cgen_prototype, _emit_prototype_100_cgen_prototype2200, _emit_prototype_100_cgen_prototype, 0L, 2);
DEFINE_STRING(string2175_cgen_prototype, string2175_cgen_prototype2201, "DEFINE_EXPORT_", 14);
DEFINE_STRING(string2169_cgen_prototype, string2169_cgen_prototype2202, "emit-cnst-string", 16);
DEFINE_STRING(string2157_cgen_prototype, string2157_cgen_prototype2203, ", ...)", 6);
DEFINE_STRING(string2173_cgen_prototype, string2173_cgen_prototype2204, "( ", 2);
DEFINE_EXPORT_PROCEDURE(emit_cnsts_env_4_cgen_prototype, _emit_cnsts_87_cgen_prototype2205, _emit_cnsts_87_cgen_prototype, 0L, 0);
DEFINE_STRING(string2187_cgen_prototype, string2187_cgen_prototype2206, "GET-C-SCOPE-DEFAULT1442 IMPORT STVECTOR SGFUN SFUN SREAL SSTRING STATIC EMIT-PROTOTYPE-DEFAULT1436 EXPORT ", 106);
DEFINE_STATIC_PROCEDURE(get_c_scope_default1442_env_42_cgen_prototype, _get_c_scope_default1442_42_cgen_prototype2207, _get_c_scope_default1442_42_cgen_prototype, 0L, 1);
DEFINE_STRING(string2167_cgen_prototype, string2167_cgen_prototype2208, " );", 3);
DEFINE_STRING(string2181_cgen_prototype, string2181_cgen_prototype2209, "extern", 6);
DEFINE_STATIC_GENERIC(get_c_scope_env_161_cgen_prototype, _get_c_scope_242_cgen_prototype2210, _get_c_scope_242_cgen_prototype, 0L, 1);
DEFINE_STATIC_PROCEDURE(emit_prototype_default1436_env_217_cgen_prototype, _emit_prototype_default1436_149_cgen_prototype2211, _emit_prototype_default1436_149_cgen_prototype, 0L, 2);
DEFINE_STRING(string2168_cgen_prototype, string2168_cgen_prototype2212, "\", ", 3);
DEFINE_STRING(string2172_cgen_prototype, string2172_cgen_prototype2213, "DEFINE_REAL( ", 13);
DEFINE_STRING(string2179_cgen_prototype, string2179_cgen_prototype2214, " ) ", 3);
DEFINE_STRING(string2163_cgen_prototype, string2163_cgen_prototype2215, "emit-cnst", 9);
DEFINE_EXPORT_PROCEDURE(set_variable_name__env_153_cgen_prototype, _set_variable_name__28_cgen_prototype2216, _set_variable_name__28_cgen_prototype, 0L, 1);
DEFINE_STRING(string2165_cgen_prototype, string2165_cgen_prototype2217, ", \"", 3);
DEFINE_STRING(string2171_cgen_prototype, string2171_cgen_prototype2218, "\"\n\"", 3);
DEFINE_STRING(string2174_cgen_prototype, string2174_cgen_prototype2219, "DEFINE_STATIC_", 14);
DEFINE_STRING(string2160_cgen_prototype, string2160_cgen_prototype2220, " = BUNSPEC;", 11);
DEFINE_EXPORT_PROCEDURE(emit_prototypes_env_106_cgen_prototype, _emit_prototypes_68_cgen_prototype2221, _emit_prototypes_68_cgen_prototype, 0L, 0);
DEFINE_STRING(string2170_cgen_prototype, string2170_cgen_prototype2222, "Can't emit string", 17);
DEFINE_STRING(string2180_cgen_prototype, string2180_cgen_prototype2223, "DEFINE_TVECTOR_START( ", 22);
DEFINE_STRING(string2184_cgen_prototype, string2184_cgen_prototype2224, "_", 1);
DEFINE_STRING(string2166_cgen_prototype, string2166_cgen_prototype2225, "DEFINE_STRING( ", 15);
DEFINE_STRING(string2156_cgen_prototype, string2156_cgen_prototype2226, "extern ", 7);
DEFINE_STRING(string2178_cgen_prototype, string2178_cgen_prototype2227, " DEFINE_TVECTOR_STOP( ", 22);
DEFINE_STATIC_PROCEDURE(proc2153_cgen_prototype, arg14672151_cgen_prototype2228, arg14672151_cgen_prototype, 0L, 1);
DEFINE_STRING(string2186_cgen_prototype, string2186_cgen_prototype2229, "Unknown variable sort", 21);
DEFINE_STRING(string2185_cgen_prototype, string2185_cgen_prototype2230, "set-variable-name!", 18);
DEFINE_STRING(string2183_cgen_prototype, string2183_cgen_prototype2231, "Unknown importation", 19);
DEFINE_STRING(string2158_cgen_prototype, string2158_cgen_prototype2232, "...)", 4);
DEFINE_STRING(string2182_cgen_prototype, string2182_cgen_prototype2233, "get-c-scope", 11);
DEFINE_STRING(string2159_cgen_prototype, string2159_cgen_prototype2234, ", ", 2);

obj_t 
module_initialization_70_cgen_prototype(long checksum_2308, char *from_2309)
{
   if (CBOOL(require_initialization_114_cgen_prototype))
     {
	require_initialization_114_cgen_prototype = BBOOL(((bool_t) 0));
	library_modules_init_112_cgen_prototype();
	cnst_init_137_cgen_prototype();
	imported_modules_init_94_cgen_prototype();
	toplevel_init_63_cgen_prototype();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cgen_prototype()
{
   module_initialization_70___object(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70___r4_output_6_10_3(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70___reader(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70___r4_symbols_6_4(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70___r4_strings_6_7(((long) 0), "CGEN_PROTOTYPE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cgen_prototype()
{
   {
      obj_t cnst_port_138_2300;
      cnst_port_138_2300 = open_input_string(string2187_cgen_prototype);
      {
	 long i_2301;
	 i_2301 = ((long) 9);
       loop_2302:
	 {
	    bool_t test2188_2303;
	    test2188_2303 = (i_2301 == ((long) -1));
	    if (test2188_2303)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2189_2304;
		    {
		       obj_t list2190_2305;
		       {
			  obj_t arg2191_2306;
			  arg2191_2306 = BNIL;
			  list2190_2305 = MAKE_PAIR(cnst_port_138_2300, arg2191_2306);
		       }
		       arg2189_2304 = read___reader(list2190_2305);
		    }
		    CNST_TABLE_SET(i_2301, arg2189_2304);
		 }
		 {
		    int aux_2307;
		    {
		       long aux_2329;
		       aux_2329 = (i_2301 - ((long) 1));
		       aux_2307 = (int) (aux_2329);
		    }
		    {
		       long i_2332;
		       i_2332 = (long) (aux_2307);
		       i_2301 = i_2332;
		       goto loop_2302;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cgen_prototype()
{
   add_generic__110___object(emit_prototype_env_241_cgen_prototype, emit_prototype_default1436_env_217_cgen_prototype);
   add_inlined_method__244___object(emit_prototype_env_241_cgen_prototype, svar_ast_var, ((long) 0));
   add_inlined_method__244___object(emit_prototype_env_241_cgen_prototype, scnst_ast_var, ((long) 1));
   add_inlined_method__244___object(emit_prototype_env_241_cgen_prototype, sfun_ast_var, ((long) 2));
   add_inlined_method__244___object(emit_prototype_env_241_cgen_prototype, cfun_ast_var, ((long) 3));
   add_inlined_method__244___object(emit_prototype_env_241_cgen_prototype, cvar_ast_var, ((long) 4));
   add_generic__110___object(get_c_scope_env_161_cgen_prototype, get_c_scope_default1442_env_42_cgen_prototype);
   add_inlined_method__244___object(get_c_scope_env_161_cgen_prototype, global_ast_var, ((long) 0));
   {
      long aux_2342;
      aux_2342 = add_inlined_method__244___object(get_c_scope_env_161_cgen_prototype, local_ast_var, ((long) 1));
      return BINT(aux_2342);
   }
}


obj_t 
emit_prototypes_82_cgen_prototype()
{
   {
      obj_t arg1467_2288;
      arg1467_2288 = proc2153_cgen_prototype;
      for_each_global__88_ast_env(arg1467_2288);
   }
   {
      obj_t cnst_init_137_950;
      cnst_init_137_950 = get_cnst_table_42_cnst_alloc();
      {
	 value_t aux_2347;
	 {
	    global_t obj_1952;
	    obj_1952 = (global_t) (cnst_init_137_950);
	    aux_2347 = (((global_t) CREF(obj_1952))->value);
	 }
	 emit_prototype_23_cgen_prototype(aux_2347, (variable_t) (cnst_init_137_950));
      }
   }
   {
      obj_t list1486_952;
      list1486_952 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
      return newline___r4_output_6_10_3(list1486_952);
   }
}


obj_t 
_emit_prototypes_68_cgen_prototype(obj_t env_2289)
{
   return emit_prototypes_82_cgen_prototype();
}


obj_t 
arg14672151_cgen_prototype(obj_t env_2290, obj_t global_2291)
{
   {
      obj_t global_935;
      global_935 = global_2291;
      {
	 bool_t test1469_937;
	 {
	    bool_t test1471_939;
	    {
	       bool_t test1475_942;
	       {
		  bool_t test1478_945;
		  {
		     obj_t obj2_1942;
		     obj2_1942 = __module__166_module_module;
		     {
			obj_t aux_2355;
			{
			   global_t obj_1940;
			   obj_1940 = (global_t) (global_935);
			   aux_2355 = (((global_t) CREF(obj_1940))->module);
			}
			test1478_945 = (aux_2355 == obj2_1942);
		     }
		  }
		  if (test1478_945)
		    {
		       obj_t aux_2363;
		       obj_t aux_2360;
		       aux_2363 = CNST_TABLE_REF(((long) 0));
		       {
			  global_t obj_1943;
			  obj_1943 = (global_t) (global_935);
			  aux_2360 = (((global_t) CREF(obj_1943))->import);
		       }
		       test1475_942 = (aux_2360 == aux_2363);
		    }
		  else
		    {
		       test1475_942 = ((bool_t) 0);
		    }
	       }
	       if (test1475_942)
		 {
		    test1471_939 = ((bool_t) 1);
		 }
	       else
		 {
		    long aux_2367;
		    {
		       global_t obj_1946;
		       obj_1946 = (global_t) (global_935);
		       aux_2367 = (((global_t) CREF(obj_1946))->occurrence);
		    }
		    test1471_939 = (aux_2367 > ((long) 0));
		 }
	    }
	    if (test1471_939)
	      {
		 bool_t test1472_940;
		 {
		    obj_t aux_2372;
		    {
		       value_t aux_2373;
		       {
			  global_t obj_1949;
			  obj_1949 = (global_t) (global_935);
			  aux_2373 = (((global_t) CREF(obj_1949))->value);
		       }
		       aux_2372 = (obj_t) (aux_2373);
		    }
		    test1472_940 = is_a__118___object(aux_2372, scnst_ast_var);
		 }
		 if (test1472_940)
		   {
		      test1469_937 = ((bool_t) 0);
		   }
		 else
		   {
		      test1469_937 = ((bool_t) 1);
		   }
	      }
	    else
	      {
		 test1469_937 = ((bool_t) 0);
	      }
	 }
	 if (test1469_937)
	   {
	      value_t aux_2380;
	      {
		 global_t obj_1951;
		 obj_1951 = (global_t) (global_935);
		 aux_2380 = (((global_t) CREF(obj_1951))->value);
	      }
	      return emit_prototype_23_cgen_prototype(aux_2380, (variable_t) (global_935));
	   }
	 else
	   {
	      return BUNSPEC;
	   }
      }
   }
}


obj_t 
emit_cnsts_221_cgen_prototype()
{
   {
      obj_t arg1489_2292;
      arg1489_2292 = proc2154_cgen_prototype;
      for_each_global__88_ast_env(arg1489_2292);
   }
   {
      obj_t list1507_969;
      list1507_969 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
      return newline___r4_output_6_10_3(list1507_969);
   }
}


obj_t 
_emit_cnsts_87_cgen_prototype(obj_t env_2293)
{
   return emit_cnsts_221_cgen_prototype();
}


obj_t 
arg14892152_cgen_prototype(obj_t env_2294, obj_t global_2295)
{
   {
      obj_t global_955;
      global_955 = global_2295;
      {
	 bool_t test1491_957;
	 {
	    bool_t test1494_959;
	    {
	       bool_t test1497_961;
	       {
		  bool_t test1500_964;
		  {
		     obj_t obj2_1955;
		     obj2_1955 = __module__166_module_module;
		     {
			obj_t aux_2389;
			{
			   global_t obj_1953;
			   obj_1953 = (global_t) (global_955);
			   aux_2389 = (((global_t) CREF(obj_1953))->module);
			}
			test1500_964 = (aux_2389 == obj2_1955);
		     }
		  }
		  if (test1500_964)
		    {
		       obj_t aux_2397;
		       obj_t aux_2394;
		       aux_2397 = CNST_TABLE_REF(((long) 0));
		       {
			  global_t obj_1956;
			  obj_1956 = (global_t) (global_955);
			  aux_2394 = (((global_t) CREF(obj_1956))->import);
		       }
		       test1497_961 = (aux_2394 == aux_2397);
		    }
		  else
		    {
		       test1497_961 = ((bool_t) 0);
		    }
	       }
	       if (test1497_961)
		 {
		    test1494_959 = ((bool_t) 1);
		 }
	       else
		 {
		    long aux_2401;
		    {
		       global_t obj_1959;
		       obj_1959 = (global_t) (global_955);
		       aux_2401 = (((global_t) CREF(obj_1959))->occurrence);
		    }
		    test1494_959 = (aux_2401 > ((long) 0));
		 }
	    }
	    if (test1494_959)
	      {
		 obj_t aux_2406;
		 {
		    value_t aux_2407;
		    {
		       global_t obj_1962;
		       obj_1962 = (global_t) (global_955);
		       aux_2407 = (((global_t) CREF(obj_1962))->value);
		    }
		    aux_2406 = (obj_t) (aux_2407);
		 }
		 test1491_957 = is_a__118___object(aux_2406, scnst_ast_var);
	      }
	    else
	      {
		 test1491_957 = ((bool_t) 0);
	      }
	 }
	 if (test1491_957)
	   {
	      scnst_t aux_2413;
	      {
		 value_t aux_2414;
		 {
		    global_t obj_1964;
		    obj_1964 = (global_t) (global_955);
		    aux_2414 = (((global_t) CREF(obj_1964))->value);
		 }
		 aux_2413 = (scnst_t) (aux_2414);
	      }
	      return emit_cnst_44_cgen_prototype(aux_2413, (global_t) (global_955));
	   }
	 else
	   {
	      return BUNSPEC;
	   }
      }
   }
}


obj_t 
emit_prototype_default1436_125_cgen_prototype(value_t value_13, variable_t variable_14)
{
   FAILURE(CNST_TABLE_REF(((long) 1)), string2155_cgen_prototype, (obj_t) (value_13));
}


obj_t 
_emit_prototype_default1436_149_cgen_prototype(obj_t env_2281, obj_t value_2282, obj_t variable_2283)
{
   return emit_prototype_default1436_125_cgen_prototype((value_t) (value_2282), (variable_t) (variable_2283));
}


obj_t 
emit_prototype_23_cgen_prototype(value_t value_11, variable_t variable_12)
{
   {
      obj_t method2056_1830;
      obj_t class2061_1831;
      {
	 obj_t arg2065_1828;
	 obj_t arg2066_1829;
	 {
	    object_t obj_1970;
	    obj_1970 = (object_t) (value_11);
	    {
	       obj_t pre_method_105_1971;
	       pre_method_105_1971 = PROCEDURE_REF(emit_prototype_env_241_cgen_prototype, ((long) 2));
	       if (INTEGERP(pre_method_105_1971))
		 {
		    PROCEDURE_SET(emit_prototype_env_241_cgen_prototype, ((long) 2), BUNSPEC);
		    arg2065_1828 = pre_method_105_1971;
		 }
	       else
		 {
		    long obj_class_num_177_1976;
		    obj_class_num_177_1976 = TYPE(obj_1970);
		    {
		       obj_t arg1183_1977;
		       arg1183_1977 = PROCEDURE_REF(emit_prototype_env_241_cgen_prototype, ((long) 1));
		       {
			  long arg1184_1981;
			  {
			     long arg1186_1982;
			     arg1186_1982 = OBJECT_TYPE;
			     arg1184_1981 = (obj_class_num_177_1976 - arg1186_1982);
			  }
			  arg2065_1828 = VECTOR_REF(arg1183_1977, arg1184_1981);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1987;
	    object_1987 = (object_t) (value_11);
	    {
	       long arg1187_1988;
	       {
		  long arg1188_1989;
		  long arg1189_1990;
		  arg1188_1989 = TYPE(object_1987);
		  arg1189_1990 = OBJECT_TYPE;
		  arg1187_1988 = (arg1188_1989 - arg1189_1990);
	       }
	       {
		  obj_t vector_1994;
		  vector_1994 = __classes__134___object;
		  arg2066_1829 = VECTOR_REF(vector_1994, arg1187_1988);
	       }
	    }
	 }
	 method2056_1830 = arg2065_1828;
	 class2061_1831 = arg2066_1829;
	 {
	    if (INTEGERP(method2056_1830))
	      {
		 switch ((long) CINT(method2056_1830))
		   {
		   case ((long) 0):
		      {
			 obj_t aux_2443;
			 {
			    svar_t aux_2444;
			    aux_2444 = (svar_t) (value_11);
			    aux_2443 = (obj_t) (aux_2444);
			 }
			 return emit_prototype_svar_scnst_27_cgen_prototype(aux_2443, variable_12);
		      }
		      break;
		   case ((long) 1):
		      {
			 obj_t aux_2448;
			 {
			    scnst_t aux_2449;
			    aux_2449 = (scnst_t) (value_11);
			    aux_2448 = (obj_t) (aux_2449);
			 }
			 return emit_prototype_svar_scnst_27_cgen_prototype(aux_2448, variable_12);
		      }
		      break;
		   case ((long) 2):
		      {
			 sfun_t value_1841;
			 value_1841 = (sfun_t) (value_11);
			 set_variable_name__102_cgen_prototype((obj_t) (variable_12));
			 {
			    obj_t arg2069_1844;
			    arg2069_1844 = get_c_scope_184_cgen_prototype(variable_12);
			    {
			       obj_t list2070_1845;
			       {
				  obj_t arg2071_1846;
				  {
				     obj_t aux_2457;
				     aux_2457 = BCHAR(((unsigned char) ' '));
				     arg2071_1846 = MAKE_PAIR(aux_2457, BNIL);
				  }
				  list2070_1845 = MAKE_PAIR(arg2069_1844, arg2071_1846);
			       }
			       fprin_cgen_prototype(__c_port__188_cgen_emit, list2070_1845);
			    }
			 }
			 {
			    obj_t arg2073_1848;
			    arg2073_1848 = make_typed_declaration_180_type_tools((((variable_t) CREF(variable_12))->type), (((variable_t) CREF(variable_12))->name));
			    {
			       obj_t list2074_1849;
			       list2074_1849 = MAKE_PAIR(arg2073_1848, BNIL);
			       fprin_cgen_prototype(__c_port__188_cgen_emit, list2074_1849);
			    }
			 }
			 {
			    obj_t args_1853;
			    args_1853 = (((sfun_t) CREF(value_1841))->args);
			    {
			       bool_t test2079_1854;
			       if (PAIRP(args_1853))
				 {
				    test2079_1854 = is_a__118___object(CAR(args_1853), type_type_type);
				 }
			       else
				 {
				    test2079_1854 = ((bool_t) 0);
				 }
			       if (test2079_1854)
				 {
				    emit_prototype_formal_types_237_cgen_prototype(args_1853);
				 }
			       else
				 {
				    emit_prototype_formals_182_cgen_prototype(args_1853);
				 }
			    }
			 }
			 {
			    obj_t list2082_1857;
			    {
			       obj_t aux_2475;
			       aux_2475 = BCHAR(((unsigned char) ';'));
			       list2082_1857 = MAKE_PAIR(aux_2475, BNIL);
			    }
			    return fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list2082_1857);
			 }
		      }
		      break;
		   case ((long) 3):
		      {
			 cfun_t value_1859;
			 value_1859 = (cfun_t) (value_11);
			 if ((((cfun_t) CREF(value_1859))->macro__33))
			   {
			      return BUNSPEC;
			   }
			 else
			   {
			      {
				 obj_t list2085_1863;
				 list2085_1863 = MAKE_PAIR(string2156_cgen_prototype, BNIL);
				 fprin_cgen_prototype(__c_port__188_cgen_emit, list2085_1863);
			      }
			      {
				 long arity_1866;
				 arity_1866 = (((cfun_t) CREF(value_1859))->arity);
				 {
				    obj_t targs_1867;
				    targs_1867 = (((cfun_t) CREF(value_1859))->args_type_205);
				    {
				       {
					  obj_t arg2088_1868;
					  {
					     obj_t aux_2489;
					     type_t aux_2486;
					     {
						global_t obj_2006;
						obj_2006 = (global_t) (variable_12);
						aux_2489 = (((global_t) CREF(obj_2006))->name);
					     }
					     {
						global_t obj_2005;
						obj_2005 = (global_t) (variable_12);
						aux_2486 = (((global_t) CREF(obj_2005))->type);
					     }
					     arg2088_1868 = make_typed_declaration_180_type_tools(aux_2486, aux_2489);
					  }
					  {
					     obj_t list2089_1869;
					     {
						obj_t arg2091_1870;
						{
						   obj_t aux_2493;
						   aux_2493 = BCHAR(((unsigned char) '('));
						   arg2091_1870 = MAKE_PAIR(aux_2493, BNIL);
						}
						list2089_1869 = MAKE_PAIR(arg2088_1868, arg2091_1870);
					     }
					     fprin_cgen_prototype(__c_port__188_cgen_emit, list2089_1869);
					  }
				       }
				       if (NULLP(targs_1867))
					 {
					    {
					       obj_t list2098_1875;
					       list2098_1875 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
					       display___r4_output_6_10_3(BCHAR(((unsigned char) ')')), list2098_1875);
					    }
					 }
				       else
					 {
					    if ((arity_1866 <= ((long) -1)))
					      {
						 {
						    obj_t arg2101_1878;
						    {
						       type_t aux_2505;
						       {
							  obj_t aux_2506;
							  aux_2506 = CAR(targs_1867);
							  aux_2505 = (type_t) (aux_2506);
						       }
						       arg2101_1878 = type_name_sans___47_type_tools(aux_2505);
						    }
						    {
						       obj_t list2103_1880;
						       {
							  obj_t arg2104_1881;
							  arg2104_1881 = MAKE_PAIR(string2157_cgen_prototype, BNIL);
							  list2103_1880 = MAKE_PAIR(arg2101_1878, arg2104_1881);
						       }
						       {
							  bool_t aux_2512;
							  aux_2512 = fprin_cgen_prototype(__c_port__188_cgen_emit, list2103_1880);
							  BBOOL(aux_2512);
						       }
						    }
						 }
					      }
					    else
					      {
						 {
						    obj_t targs_1884;
						    {
						       bool_t aux_2515;
						       targs_1884 = targs_1867;
						     loop_1885:
						       {
							  bool_t test_2516;
							  {
							     obj_t aux_2517;
							     aux_2517 = CDR(targs_1884);
							     test_2516 = NULLP(aux_2517);
							  }
							  if (test_2516)
							    {
							       if ((arity_1866 < ((long) 0)))
								 {
								    obj_t list2109_1888;
								    list2109_1888 = MAKE_PAIR(string2158_cgen_prototype, BNIL);
								    aux_2515 = fprin_cgen_prototype(__c_port__188_cgen_emit, list2109_1888);
								 }
							       else
								 {
								    obj_t arg2112_1891;
								    {
								       type_t aux_2524;
								       {
									  obj_t aux_2525;
									  aux_2525 = CAR(targs_1884);
									  aux_2524 = (type_t) (aux_2525);
								       }
								       arg2112_1891 = type_name_sans___47_type_tools(aux_2524);
								    }
								    {
								       obj_t list2113_1892;
								       {
									  obj_t arg2114_1893;
									  {
									     obj_t aux_2529;
									     aux_2529 = BCHAR(((unsigned char) ')'));
									     arg2114_1893 = MAKE_PAIR(aux_2529, BNIL);
									  }
									  list2113_1892 = MAKE_PAIR(arg2112_1891, arg2114_1893);
								       }
								       aux_2515 = fprin_cgen_prototype(__c_port__188_cgen_emit, list2113_1892);
								    }
								 }
							    }
							  else
							    {
							       {
								  obj_t arg2118_1896;
								  {
								     type_t aux_2534;
								     {
									obj_t aux_2535;
									aux_2535 = CAR(targs_1884);
									aux_2534 = (type_t) (aux_2535);
								     }
								     arg2118_1896 = type_name_sans___47_type_tools(aux_2534);
								  }
								  {
								     obj_t list2120_1898;
								     {
									obj_t arg2121_1899;
									arg2121_1899 = MAKE_PAIR(string2159_cgen_prototype, BNIL);
									list2120_1898 = MAKE_PAIR(arg2118_1896, arg2121_1899);
								     }
								     fprin_cgen_prototype(__c_port__188_cgen_emit, list2120_1898);
								  }
							       }
							       {
								  obj_t targs_2542;
								  targs_2542 = CDR(targs_1884);
								  targs_1884 = targs_2542;
								  goto loop_1885;
							       }
							    }
						       }
						       BBOOL(aux_2515);
						    }
						 }
					      }
					 }
				       {
					  obj_t list2126_1904;
					  list2126_1904 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
					  display___r4_output_6_10_3(BCHAR(((unsigned char) ';')), list2126_1904);
				       }
				       {
					  obj_t list2128_1906;
					  list2128_1906 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
					  return newline___r4_output_6_10_3(list2128_1906);
				       }
				    }
				 }
			      }
			   }
		      }
		      break;
		   case ((long) 4):
		      {
			 cvar_t value_1908;
			 value_1908 = (cvar_t) (value_11);
			 if ((((cvar_t) CREF(value_1908))->macro__33))
			   {
			      return BUNSPEC;
			   }
			 else
			   {
			      obj_t arg2132_1913;
			      {
				 obj_t aux_2556;
				 type_t aux_2553;
				 {
				    global_t obj_2020;
				    obj_2020 = (global_t) (variable_12);
				    aux_2556 = (((global_t) CREF(obj_2020))->name);
				 }
				 {
				    global_t obj_2019;
				    obj_2019 = (global_t) (variable_12);
				    aux_2553 = (((global_t) CREF(obj_2019))->type);
				 }
				 arg2132_1913 = make_typed_declaration_180_type_tools(aux_2553, aux_2556);
			      }
			      {
				 obj_t list2133_1914;
				 {
				    obj_t arg2134_1915;
				    {
				       obj_t arg2135_1916;
				       {
					  obj_t aux_2560;
					  aux_2560 = BCHAR(((unsigned char) ';'));
					  arg2135_1916 = MAKE_PAIR(aux_2560, BNIL);
				       }
				       arg2134_1915 = MAKE_PAIR(arg2132_1913, arg2135_1916);
				    }
				    list2133_1914 = MAKE_PAIR(string2156_cgen_prototype, arg2134_1915);
				 }
				 return fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list2133_1914);
			      }
			   }
		      }
		      break;
		   default:
		    case_else2062_169_1834:
		      if (PROCEDUREP(method2056_1830))
			{
			   return PROCEDURE_ENTRY(method2056_1830) (method2056_1830, (obj_t) (value_11), (obj_t) (variable_12), BEOA);
			}
		      else
			{
			   obj_t fun1512_973;
			   fun1512_973 = PROCEDURE_REF(emit_prototype_env_241_cgen_prototype, ((long) 0));
			   return PROCEDURE_ENTRY(fun1512_973) (fun1512_973, (obj_t) (value_11), (obj_t) (variable_12), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else2062_169_1834;
	      }
	 }
      }
   }
}


obj_t 
_emit_prototype_100_cgen_prototype(obj_t env_2278, obj_t value_2279, obj_t variable_2280)
{
   return emit_prototype_23_cgen_prototype((value_t) (value_2279), (variable_t) (variable_2280));
}


obj_t 
emit_prototype_svar_scnst_27_cgen_prototype(obj_t value_19, variable_t variable_20)
{
   set_variable_name__102_cgen_prototype((obj_t) (variable_20));
   {
      bool_t test_2584;
      {
	 obj_t aux_2588;
	 obj_t aux_2585;
	 aux_2588 = CNST_TABLE_REF(((long) 2));
	 {
	    global_t obj_2023;
	    obj_2023 = (global_t) (variable_20);
	    aux_2585 = (((global_t) CREF(obj_2023))->import);
	 }
	 test_2584 = (aux_2585 == aux_2588);
      }
      if (test_2584)
	{
	   {
	      obj_t arg1517_977;
	      obj_t arg1518_978;
	      arg1517_977 = make_typed_declaration_180_type_tools((((variable_t) CREF(variable_20))->type), (((variable_t) CREF(variable_20))->name));
	      {
		 bool_t test1530_986;
		 test1530_986 = sub_type__174_type_env((((variable_t) CREF(variable_20))->type), (type_t) (__obj__252_type_cache));
		 if (test1530_986)
		   {
		      arg1518_978 = string2160_cgen_prototype;
		   }
		 else
		   {
		      arg1518_978 = BCHAR(((unsigned char) ';'));
		   }
	      }
	      {
		 obj_t list1519_979;
		 {
		    obj_t arg1520_980;
		    {
		       obj_t arg1522_981;
		       {
			  obj_t arg1523_982;
			  arg1523_982 = MAKE_PAIR(arg1518_978, BNIL);
			  arg1522_981 = MAKE_PAIR(arg1517_977, arg1523_982);
		       }
		       {
			  obj_t aux_2601;
			  aux_2601 = BCHAR(((unsigned char) ' '));
			  arg1520_980 = MAKE_PAIR(aux_2601, arg1522_981);
		       }
		    }
		    list1519_979 = MAKE_PAIR(string2161_cgen_prototype, arg1520_980);
		 }
		 return fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1519_979);
	      }
	   }
	}
      else
	{
	   bool_t test_2606;
	   {
	      obj_t aux_2610;
	      obj_t aux_2607;
	      aux_2610 = CNST_TABLE_REF(((long) 0));
	      {
		 global_t obj_2029;
		 obj_2029 = (global_t) (variable_20);
		 aux_2607 = (((global_t) CREF(obj_2029))->import);
	      }
	      test_2606 = (aux_2607 == aux_2610);
	   }
	   if (test_2606)
	     {
		{
		   obj_t arg1534_989;
		   obj_t arg1535_990;
		   arg1534_989 = make_typed_declaration_180_type_tools((((variable_t) CREF(variable_20))->type), (((variable_t) CREF(variable_20))->name));
		   {
		      bool_t test1541_996;
		      test1541_996 = sub_type__174_type_env((((variable_t) CREF(variable_20))->type), (type_t) (__obj__252_type_cache));
		      if (test1541_996)
			{
			   arg1535_990 = string2160_cgen_prototype;
			}
		      else
			{
			   arg1535_990 = BCHAR(((unsigned char) ';'));
			}
		   }
		   {
		      obj_t list1536_991;
		      {
			 obj_t arg1537_992;
			 arg1537_992 = MAKE_PAIR(arg1535_990, BNIL);
			 list1536_991 = MAKE_PAIR(arg1534_989, arg1537_992);
		      }
		      return fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1536_991);
		   }
		}
	     }
	   else
	     {
		{
		   obj_t arg1543_998;
		   obj_t arg1547_999;
		   arg1543_998 = get_c_scope_184_cgen_prototype(variable_20);
		   arg1547_999 = make_typed_declaration_180_type_tools((((variable_t) CREF(variable_20))->type), (((variable_t) CREF(variable_20))->name));
		   {
		      obj_t list1548_1000;
		      {
			 obj_t arg1549_1001;
			 {
			    obj_t arg1550_1002;
			    {
			       obj_t arg1551_1003;
			       {
				  obj_t aux_2628;
				  aux_2628 = BCHAR(((unsigned char) ';'));
				  arg1551_1003 = MAKE_PAIR(aux_2628, BNIL);
			       }
			       arg1550_1002 = MAKE_PAIR(arg1547_999, arg1551_1003);
			    }
			    {
			       obj_t aux_2632;
			       aux_2632 = BCHAR(((unsigned char) ' '));
			       arg1549_1001 = MAKE_PAIR(aux_2632, arg1550_1002);
			    }
			 }
			 list1548_1000 = MAKE_PAIR(arg1543_998, arg1549_1001);
		      }
		      return fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1548_1000);
		   }
		}
	     }
	}
   }
}


bool_t 
emit_prototype_formal_types_237_cgen_prototype(obj_t types_23)
{
   if (NULLP(types_23))
     {
	obj_t list1562_1012;
	list1562_1012 = MAKE_PAIR(string2162_cgen_prototype, BNIL);
	return fprin_cgen_prototype(__c_port__188_cgen_emit, list1562_1012);
     }
   else
     {
	{
	   obj_t list1565_1015;
	   list1565_1015 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
	   display___r4_output_6_10_3(BCHAR(((unsigned char) '(')), list1565_1015);
	}
	{
	   obj_t types_1017;
	   types_1017 = types_23;
	 loop_1018:
	   {
	      bool_t test_2644;
	      {
		 obj_t aux_2645;
		 aux_2645 = CDR(types_1017);
		 test_2644 = NULLP(aux_2645);
	      }
	      if (test_2644)
		{
		   obj_t arg1568_1020;
		   {
		      type_t aux_2648;
		      {
			 obj_t aux_2649;
			 aux_2649 = CAR(types_1017);
			 aux_2648 = (type_t) (aux_2649);
		      }
		      arg1568_1020 = type_name_sans___47_type_tools(aux_2648);
		   }
		   {
		      obj_t list1569_1021;
		      {
			 obj_t arg1570_1022;
			 {
			    obj_t aux_2653;
			    aux_2653 = BCHAR(((unsigned char) ')'));
			    arg1570_1022 = MAKE_PAIR(aux_2653, BNIL);
			 }
			 list1569_1021 = MAKE_PAIR(arg1568_1020, arg1570_1022);
		      }
		      return fprin_cgen_prototype(__c_port__188_cgen_emit, list1569_1021);
		   }
		}
	      else
		{
		   {
		      obj_t arg1573_1025;
		      {
			 type_t aux_2658;
			 {
			    obj_t aux_2659;
			    aux_2659 = CAR(types_1017);
			    aux_2658 = (type_t) (aux_2659);
			 }
			 arg1573_1025 = type_name_sans___47_type_tools(aux_2658);
		      }
		      {
			 obj_t list1575_1027;
			 {
			    obj_t arg1576_1028;
			    arg1576_1028 = MAKE_PAIR(string2159_cgen_prototype, BNIL);
			    list1575_1027 = MAKE_PAIR(arg1573_1025, arg1576_1028);
			 }
			 fprin_cgen_prototype(__c_port__188_cgen_emit, list1575_1027);
		      }
		   }
		   {
		      obj_t types_2666;
		      types_2666 = CDR(types_1017);
		      types_1017 = types_2666;
		      goto loop_1018;
		   }
		}
	   }
	}
     }
}


bool_t 
emit_prototype_formals_182_cgen_prototype(obj_t args_24)
{
   if (NULLP(args_24))
     {
	obj_t list1584_1034;
	list1584_1034 = MAKE_PAIR(string2162_cgen_prototype, BNIL);
	return fprin_cgen_prototype(__c_port__188_cgen_emit, list1584_1034);
     }
   else
     {
	{
	   obj_t list1588_1037;
	   list1588_1037 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
	   display___r4_output_6_10_3(BCHAR(((unsigned char) '(')), list1588_1037);
	}
	{
	   obj_t args_1039;
	   args_1039 = args_24;
	 loop_1040:
	   {
	      bool_t test_2675;
	      {
		 obj_t aux_2676;
		 aux_2676 = CDR(args_1039);
		 test_2675 = NULLP(aux_2676);
	      }
	      if (test_2675)
		{
		   obj_t arg1591_1043;
		   {
		      type_t aux_2679;
		      {
			 local_t obj_2047;
			 {
			    obj_t aux_2680;
			    aux_2680 = CAR(args_1039);
			    obj_2047 = (local_t) (aux_2680);
			 }
			 aux_2679 = (((local_t) CREF(obj_2047))->type);
		      }
		      arg1591_1043 = type_name_sans___47_type_tools(aux_2679);
		   }
		   {
		      obj_t list1592_1044;
		      {
			 obj_t arg1593_1045;
			 {
			    obj_t aux_2685;
			    aux_2685 = BCHAR(((unsigned char) ')'));
			    arg1593_1045 = MAKE_PAIR(aux_2685, BNIL);
			 }
			 list1592_1044 = MAKE_PAIR(arg1591_1043, arg1593_1045);
		      }
		      return fprin_cgen_prototype(__c_port__188_cgen_emit, list1592_1044);
		   }
		}
	      else
		{
		   {
		      obj_t arg1597_1049;
		      {
			 type_t aux_2690;
			 {
			    local_t obj_2049;
			    {
			       obj_t aux_2691;
			       aux_2691 = CAR(args_1039);
			       obj_2049 = (local_t) (aux_2691);
			    }
			    aux_2690 = (((local_t) CREF(obj_2049))->type);
			 }
			 arg1597_1049 = type_name_sans___47_type_tools(aux_2690);
		      }
		      {
			 obj_t list1601_1051;
			 {
			    obj_t arg1603_1052;
			    arg1603_1052 = MAKE_PAIR(string2159_cgen_prototype, BNIL);
			    list1601_1051 = MAKE_PAIR(arg1597_1049, arg1603_1052);
			 }
			 fprin_cgen_prototype(__c_port__188_cgen_emit, list1601_1051);
		      }
		   }
		   {
		      obj_t args_2699;
		      args_2699 = CDR(args_1039);
		      args_1039 = args_2699;
		      goto loop_1040;
		   }
		}
	   }
	}
     }
}


obj_t 
emit_cnst_44_cgen_prototype(scnst_t value_29, global_t variable_30)
{
   {
      obj_t case_value_58_1058;
      case_value_58_1058 = (((scnst_t) CREF(value_29))->class);
      {
	 bool_t test_2702;
	 {
	    obj_t aux_2703;
	    aux_2703 = CNST_TABLE_REF(((long) 3));
	    test_2702 = (case_value_58_1058 == aux_2703);
	 }
	 if (test_2702)
	   {
	      return emit_cnst_string_104_cgen_prototype((((scnst_t) CREF(value_29))->node), variable_30);
	   }
	 else
	   {
	      bool_t test_2708;
	      {
		 obj_t aux_2709;
		 aux_2709 = CNST_TABLE_REF(((long) 4));
		 test_2708 = (case_value_58_1058 == aux_2709);
	      }
	      if (test_2708)
		{
		   return emit_cnst_real_94_cgen_prototype((((scnst_t) CREF(value_29))->node), variable_30);
		}
	      else
		{
		   bool_t test_2714;
		   {
		      obj_t aux_2715;
		      aux_2715 = CNST_TABLE_REF(((long) 5));
		      test_2714 = (case_value_58_1058 == aux_2715);
		   }
		   if (test_2714)
		     {
			return emit_cnst_sfun_sgfun_176_cgen_prototype((((scnst_t) CREF(value_29))->node), variable_30, "PROCEDURE");
		     }
		   else
		     {
			bool_t test_2720;
			{
			   obj_t aux_2721;
			   aux_2721 = CNST_TABLE_REF(((long) 6));
			   test_2720 = (case_value_58_1058 == aux_2721);
			}
			if (test_2720)
			  {
			     return emit_cnst_sfun_sgfun_176_cgen_prototype((((scnst_t) CREF(value_29))->node), variable_30, "GENERIC");
			  }
			else
			  {
			     bool_t test_2726;
			     {
				obj_t aux_2727;
				aux_2727 = CNST_TABLE_REF(((long) 7));
				test_2726 = (case_value_58_1058 == aux_2727);
			     }
			     if (test_2726)
			       {
				  return emit_cnst_stvector_253_cgen_prototype((((scnst_t) CREF(value_29))->node), variable_30);
			       }
			     else
			       {
				  return internal_error_43_tools_error(string2163_cgen_prototype, string2164_cgen_prototype, (((scnst_t) CREF(value_29))->class));
			       }
			  }
		     }
		}
	   }
      }
   }
}


obj_t 
emit_cnst_string_104_cgen_prototype(obj_t ostr_31, global_t global_32)
{
   set_variable_name__102_cgen_prototype((obj_t) (global_32));
   {
      obj_t str_1077;
      str_1077 = string_for_read(ostr_31);
      {
	 obj_t arg1637_1079;
	 obj_t arg1641_1081;
	 arg1637_1079 = (((global_t) CREF(global_32))->name);
	 {
	    obj_t arg1650_1089;
	    arg1650_1089 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, (((global_t) CREF(global_32))->name), BEOA);
	    arg1641_1081 = id__name_228_ast_ident(arg1650_1089);
	 }
	 {
	    obj_t list1643_1083;
	    {
	       obj_t arg1644_1084;
	       {
		  obj_t arg1645_1085;
		  {
		     obj_t arg1646_1086;
		     {
			obj_t arg1647_1087;
			arg1647_1087 = MAKE_PAIR(string2165_cgen_prototype, BNIL);
			arg1646_1086 = MAKE_PAIR(arg1641_1081, arg1647_1087);
		     }
		     arg1645_1085 = MAKE_PAIR(string2159_cgen_prototype, arg1646_1086);
		  }
		  arg1644_1084 = MAKE_PAIR(arg1637_1079, arg1645_1085);
	       }
	       list1643_1083 = MAKE_PAIR(string2166_cgen_prototype, arg1644_1084);
	    }
	    fprin_cgen_prototype(__c_port__188_cgen_emit, list1643_1083);
	 }
      }
      {
	 long read_1091;
	 long rlen_1092;
	 read_1091 = ((long) 0);
	 rlen_1092 = STRING_LENGTH(str_1077);
       loop_1093:
	 {
	    bool_t test1654_1096;
	    {
	       long n2_2077;
	       n2_2077 = (long) CINT(__max_c_token_length__129_engine_param);
	       test1654_1096 = (rlen_1092 <= n2_2077);
	    }
	    if (test1654_1096)
	      {
		 {
		    obj_t arg1655_1097;
		    {
		       obj_t arg1659_1100;
		       {
			  long aux_2751;
			  aux_2751 = (read_1091 + rlen_1092);
			  arg1659_1100 = c_substring(str_1077, read_1091, aux_2751);
		       }
		       arg1655_1097 = untrigraph_cgen_emit_cop_239(arg1659_1100);
		    }
		    {
		       obj_t list1656_1098;
		       list1656_1098 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
		       display___r4_output_6_10_3(arg1655_1097, list1656_1098);
		    }
		 }
		 {
		    long arg1664_1103;
		    arg1664_1103 = STRING_LENGTH(ostr_31);
		    {
		       obj_t list1666_1105;
		       {
			  obj_t arg1667_1106;
			  {
			     obj_t arg1668_1107;
			     arg1668_1107 = MAKE_PAIR(string2167_cgen_prototype, BNIL);
			     {
				obj_t aux_2759;
				aux_2759 = BINT(arg1664_1103);
				arg1667_1106 = MAKE_PAIR(aux_2759, arg1668_1107);
			     }
			  }
			  list1666_1105 = MAKE_PAIR(string2168_cgen_prototype, arg1667_1106);
		       }
		       return fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1666_1105);
		    }
		 }
	      }
	    else
	      {
		 {
		    long offset_1109;
		    {
		       long arg1671_1111;
		       {
			  long z2_2085;
			  z2_2085 = (long) CINT(__max_c_token_length__129_engine_param);
			  arg1671_1111 = (read_1091 + z2_2085);
		       }
		       offset_1109 = arg1671_1111;
		     laap_1110:
		       {
			  bool_t test_2766;
			  {
			     long aux_2767;
			     aux_2767 = (read_1091 + ((long) 3));
			     test_2766 = (aux_2767 >= offset_1109);
			  }
			  if (test_2766)
			    {
			       return internal_error_43_tools_error(string2169_cgen_prototype, string2170_cgen_prototype, ostr_31);
			    }
			  else
			    {
			       bool_t test_2771;
			       {
				  unsigned char aux_2772;
				  {
				     long aux_2773;
				     aux_2773 = (offset_1109 - ((long) 1));
				     aux_2772 = STRING_REF(str_1077, aux_2773);
				  }
				  test_2771 = (aux_2772 == ((unsigned char) '\\'));
			       }
			       if (test_2771)
				 {
				    {
				       long offset_2777;
				       offset_2777 = (offset_1109 - ((long) 1));
				       offset_1109 = offset_2777;
				       goto laap_1110;
				    }
				 }
			       else
				 {
				    bool_t test_2779;
				    {
				       bool_t test_2780;
				       {
					  unsigned char aux_2781;
					  {
					     long aux_2782;
					     aux_2782 = (offset_1109 - ((long) 2));
					     aux_2781 = STRING_REF(str_1077, aux_2782);
					  }
					  test_2780 = (aux_2781 == ((unsigned char) '\\'));
				       }
				       if (test_2780)
					 {
					    unsigned char arg1699_1135;
					    {
					       long aux_2786;
					       aux_2786 = (offset_1109 - ((long) 1));
					       arg1699_1135 = STRING_REF(str_1077, aux_2786);
					    }
					    if ((arg1699_1135 >= ((unsigned char) '0')))
					      {
						 test_2779 = (arg1699_1135 <= ((unsigned char) '9'));
					      }
					    else
					      {
						 test_2779 = ((bool_t) 0);
					      }
					 }
				       else
					 {
					    test_2779 = ((bool_t) 0);
					 }
				    }
				    if (test_2779)
				      {
					 {
					    long offset_2792;
					    offset_2792 = (offset_1109 - ((long) 2));
					    offset_1109 = offset_2792;
					    goto laap_1110;
					 }
				      }
				    else
				      {
					 bool_t test_2794;
					 {
					    bool_t test_2795;
					    {
					       unsigned char aux_2796;
					       {
						  long aux_2797;
						  aux_2797 = (offset_1109 - ((long) 3));
						  aux_2796 = STRING_REF(str_1077, aux_2797);
					       }
					       test_2795 = (aux_2796 == ((unsigned char) '\\'));
					    }
					    if (test_2795)
					      {
						 bool_t test_2801;
						 {
						    unsigned char arg1694_1130;
						    {
						       long aux_2802;
						       aux_2802 = (offset_1109 - ((long) 2));
						       arg1694_1130 = STRING_REF(str_1077, aux_2802);
						    }
						    if ((arg1694_1130 >= ((unsigned char) '0')))
						      {
							 test_2801 = (arg1694_1130 <= ((unsigned char) '9'));
						      }
						    else
						      {
							 test_2801 = ((bool_t) 0);
						      }
						 }
						 if (test_2801)
						   {
						      unsigned char arg1691_1128;
						      {
							 long aux_2808;
							 aux_2808 = (offset_1109 - ((long) 1));
							 arg1691_1128 = STRING_REF(str_1077, aux_2808);
						      }
						      if ((arg1691_1128 >= ((unsigned char) '0')))
							{
							   test_2794 = (arg1691_1128 <= ((unsigned char) '9'));
							}
						      else
							{
							   test_2794 = ((bool_t) 0);
							}
						   }
						 else
						   {
						      test_2794 = ((bool_t) 0);
						   }
					      }
					    else
					      {
						 test_2794 = ((bool_t) 0);
					      }
					 }
					 if (test_2794)
					   {
					      {
						 long offset_2814;
						 offset_2814 = (offset_1109 - ((long) 3));
						 offset_1109 = offset_2814;
						 goto laap_1110;
					      }
					   }
					 else
					   {
					      {
						 obj_t arg1680_1119;
						 arg1680_1119 = c_substring(str_1077, read_1091, offset_1109);
						 {
						    obj_t list1682_1121;
						    {
						       obj_t arg1684_1122;
						       arg1684_1122 = MAKE_PAIR(string2171_cgen_prototype, BNIL);
						       list1682_1121 = MAKE_PAIR(arg1680_1119, arg1684_1122);
						    }
						    fprin_cgen_prototype(__c_port__188_cgen_emit, list1682_1121);
						 }
					      }
					      {
						 long rlen_2821;
						 long read_2820;
						 read_2820 = offset_1109;
						 {
						    long aux_2822;
						    aux_2822 = (offset_1109 - read_1091);
						    rlen_2821 = (rlen_1092 - aux_2822);
						 }
						 rlen_1092 = rlen_2821;
						 read_1091 = read_2820;
						 goto loop_1093;
					      }
					   }
				      }
				 }
			    }
		       }
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
emit_cnst_real_94_cgen_prototype(obj_t real_33, global_t global_34)
{
   set_variable_name__102_cgen_prototype((obj_t) (global_34));
   {
      obj_t arg1708_1143;
      obj_t arg1710_1145;
      arg1708_1143 = (((global_t) CREF(global_34))->name);
      {
	 obj_t arg1721_1156;
	 arg1721_1156 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, (((global_t) CREF(global_34))->name), BEOA);
	 arg1710_1145 = id__name_228_ast_ident(arg1721_1156);
      }
      {
	 obj_t list1713_1148;
	 {
	    obj_t arg1714_1149;
	    {
	       obj_t arg1715_1150;
	       {
		  obj_t arg1716_1151;
		  {
		     obj_t arg1717_1152;
		     {
			obj_t arg1718_1153;
			{
			   obj_t arg1719_1154;
			   arg1719_1154 = MAKE_PAIR(string2167_cgen_prototype, BNIL);
			   arg1718_1153 = MAKE_PAIR(real_33, arg1719_1154);
			}
			arg1717_1152 = MAKE_PAIR(string2159_cgen_prototype, arg1718_1153);
		     }
		     arg1716_1151 = MAKE_PAIR(arg1710_1145, arg1717_1152);
		  }
		  arg1715_1150 = MAKE_PAIR(string2159_cgen_prototype, arg1716_1151);
	       }
	       arg1714_1149 = MAKE_PAIR(arg1708_1143, arg1715_1150);
	    }
	    list1713_1148 = MAKE_PAIR(string2172_cgen_prototype, arg1714_1149);
	 }
	 return fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1713_1148);
      }
   }
}


obj_t 
emit_cnst_sfun_sgfun_176_cgen_prototype(obj_t fun_39, global_t global_40, char *kind_41)
{
   {
      bool_t test_2841;
      {
	 obj_t aux_2844;
	 obj_t aux_2842;
	 aux_2844 = CNST_TABLE_REF(((long) 8));
	 aux_2842 = (((global_t) CREF(global_40))->import);
	 test_2841 = (aux_2842 == aux_2844);
      }
      if (test_2841)
	{
	   return emit_prototype_23_cgen_prototype((((global_t) CREF(global_40))->value), (variable_t) (global_40));
	}
      else
	{
	   obj_t actuals_1160;
	   {
	      app_t obj_2160;
	      obj_2160 = (app_t) (fun_39);
	      actuals_1160 = (((app_t) CREF(obj_2160))->args);
	   }
	   {
	      obj_t entry_113_1161;
	      entry_113_1161 = CAR(actuals_1160);
	      {
		 obj_t arity_1162;
		 {
		    atom_t obj_2166;
		    {
		       obj_t aux_2853;
		       {
			  obj_t aux_2854;
			  aux_2854 = CDR(actuals_1160);
			  aux_2853 = CAR(aux_2854);
		       }
		       obj_2166 = (atom_t) (aux_2853);
		    }
		    arity_1162 = (((atom_t) CREF(obj_2166))->value);
		 }
		 {
		    obj_t vname_1163;
		    vname_1163 = set_variable_name__102_cgen_prototype((obj_t) (global_40));
		    {
		       obj_t name_1164;
		       {
			  obj_t aux_2861;
			  {
			     variable_t aux_2862;
			     {
				var_t obj_2167;
				obj_2167 = (var_t) (entry_113_1161);
				aux_2862 = (((var_t) CREF(obj_2167))->variable);
			     }
			     aux_2861 = (obj_t) (aux_2862);
			  }
			  name_1164 = set_variable_name__102_cgen_prototype(aux_2861);
		       }
		       {
			  {
			     bool_t test_2867;
			     {
				long aux_2868;
				aux_2868 = (long) CINT(arity_1162);
				test_2867 = (aux_2868 >= ((long) 0));
			     }
			     if (test_2867)
			       {
				  obj_t arg1730_1166;
				  obj_t arg1732_1168;
				  {
				     bool_t test_2871;
				     {
					obj_t aux_2874;
					obj_t aux_2872;
					aux_2874 = CNST_TABLE_REF(((long) 2));
					aux_2872 = (((global_t) CREF(global_40))->import);
					test_2871 = (aux_2872 == aux_2874);
				     }
				     if (test_2871)
				       {
					  obj_t list1749_1183;
					  {
					     obj_t arg1753_1185;
					     {
						obj_t arg1754_1186;
						arg1754_1186 = MAKE_PAIR(string2173_cgen_prototype, BNIL);
						{
						   obj_t aux_2878;
						   aux_2878 = string_to_bstring(kind_41);
						   arg1753_1185 = MAKE_PAIR(aux_2878, arg1754_1186);
						}
					     }
					     list1749_1183 = MAKE_PAIR(string2174_cgen_prototype, arg1753_1185);
					  }
					  arg1730_1166 = string_append_106___r4_strings_6_7(list1749_1183);
				       }
				     else
				       {
					  obj_t list1757_1189;
					  {
					     obj_t arg1759_1191;
					     {
						obj_t arg1761_1192;
						arg1761_1192 = MAKE_PAIR(string2173_cgen_prototype, BNIL);
						{
						   obj_t aux_2884;
						   aux_2884 = string_to_bstring(kind_41);
						   arg1759_1191 = MAKE_PAIR(aux_2884, arg1761_1192);
						}
					     }
					     list1757_1189 = MAKE_PAIR(string2175_cgen_prototype, arg1759_1191);
					  }
					  arg1730_1166 = string_append_106___r4_strings_6_7(list1757_1189);
				       }
				  }
				  {
				     obj_t arg1767_1197;
				     arg1767_1197 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, name_1164, BEOA);
				     arg1732_1168 = id__name_228_ast_ident(arg1767_1197);
				  }
				  {
				     obj_t list1736_1172;
				     {
					obj_t arg1737_1173;
					{
					   obj_t arg1738_1174;
					   {
					      obj_t arg1740_1175;
					      {
						 obj_t arg1741_1176;
						 {
						    obj_t arg1742_1177;
						    {
						       obj_t arg1743_1178;
						       {
							  obj_t arg1745_1179;
							  {
							     obj_t arg1746_1180;
							     arg1746_1180 = MAKE_PAIR(string2167_cgen_prototype, BNIL);
							     arg1745_1179 = MAKE_PAIR(arity_1162, arg1746_1180);
							  }
							  arg1743_1178 = MAKE_PAIR(string2176_cgen_prototype, arg1745_1179);
						       }
						       arg1742_1177 = MAKE_PAIR(name_1164, arg1743_1178);
						    }
						    arg1741_1176 = MAKE_PAIR(string2159_cgen_prototype, arg1742_1177);
						 }
						 arg1740_1175 = MAKE_PAIR(arg1732_1168, arg1741_1176);
					      }
					      arg1738_1174 = MAKE_PAIR(string2159_cgen_prototype, arg1740_1175);
					   }
					   arg1737_1173 = MAKE_PAIR(vname_1163, arg1738_1174);
					}
					list1736_1172 = MAKE_PAIR(arg1730_1166, arg1737_1173);
				     }
				     return fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1736_1172);
				  }
			       }
			     else
			       {
				  obj_t arg1769_1198;
				  obj_t arg1771_1200;
				  {
				     bool_t test_2902;
				     {
					obj_t aux_2905;
					obj_t aux_2903;
					aux_2905 = CNST_TABLE_REF(((long) 2));
					aux_2903 = (((global_t) CREF(global_40))->import);
					test_2902 = (aux_2903 == aux_2905);
				     }
				     if (test_2902)
				       {
					  obj_t list1790_1217;
					  {
					     obj_t arg1792_1219;
					     {
						obj_t arg1793_1220;
						arg1793_1220 = MAKE_PAIR(string2173_cgen_prototype, BNIL);
						{
						   obj_t aux_2909;
						   aux_2909 = string_to_bstring(kind_41);
						   arg1792_1219 = MAKE_PAIR(aux_2909, arg1793_1220);
						}
					     }
					     list1790_1217 = MAKE_PAIR(string2174_cgen_prototype, arg1792_1219);
					  }
					  arg1769_1198 = string_append_106___r4_strings_6_7(list1790_1217);
				       }
				     else
				       {
					  obj_t list1797_1223;
					  {
					     obj_t arg1799_1225;
					     {
						obj_t arg1800_1226;
						arg1800_1226 = MAKE_PAIR(string2173_cgen_prototype, BNIL);
						{
						   obj_t aux_2915;
						   aux_2915 = string_to_bstring(kind_41);
						   arg1799_1225 = MAKE_PAIR(aux_2915, arg1800_1226);
						}
					     }
					     list1797_1223 = MAKE_PAIR(string2175_cgen_prototype, arg1799_1225);
					  }
					  arg1769_1198 = string_append_106___r4_strings_6_7(list1797_1223);
				       }
				  }
				  {
				     obj_t arg1806_1231;
				     arg1806_1231 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, name_1164, BEOA);
				     arg1771_1200 = id__name_228_ast_ident(arg1806_1231);
				  }
				  {
				     obj_t list1776_1205;
				     {
					obj_t arg1777_1206;
					{
					   obj_t arg1778_1207;
					   {
					      obj_t arg1779_1208;
					      {
						 obj_t arg1780_1209;
						 {
						    obj_t arg1781_1210;
						    {
						       obj_t arg1783_1211;
						       {
							  obj_t arg1784_1212;
							  {
							     obj_t arg1785_1213;
							     {
								obj_t arg1786_1214;
								arg1786_1214 = MAKE_PAIR(string2167_cgen_prototype, BNIL);
								arg1785_1213 = MAKE_PAIR(arity_1162, arg1786_1214);
							     }
							     arg1784_1212 = MAKE_PAIR(string2159_cgen_prototype, arg1785_1213);
							  }
							  arg1783_1211 = MAKE_PAIR(name_1164, arg1784_1212);
						       }
						       arg1781_1210 = MAKE_PAIR(string2159_cgen_prototype, arg1783_1211);
						    }
						    arg1780_1209 = MAKE_PAIR(string2177_cgen_prototype, arg1781_1210);
						 }
						 arg1779_1208 = MAKE_PAIR(arg1771_1200, arg1780_1209);
					      }
					      arg1778_1207 = MAKE_PAIR(string2159_cgen_prototype, arg1779_1208);
					   }
					   arg1777_1206 = MAKE_PAIR(vname_1163, arg1778_1207);
					}
					list1776_1205 = MAKE_PAIR(arg1769_1198, arg1777_1206);
				     }
				     return fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1776_1205);
				  }
			       }
			  }
		       }
		    }
		 }
	      }
	   }
	}
   }
}


obj_t 
emit_cnst_stvector_253_cgen_prototype(obj_t tvec_42, global_t global_43)
{
   {
      obj_t vec_1236;
      vec_1236 = STRUCT_REF(tvec_42, ((long) 1));
      {
	 type_t itype_1237;
	 {
	    tvec_t obj_2182;
	    {
	       obj_t aux_2935;
	       aux_2935 = STRUCT_REF(tvec_42, ((long) 0));
	       obj_2182 = (tvec_t) (aux_2935);
	    }
	    {
	       obj_t aux_2938;
	       {
		  object_t aux_2939;
		  aux_2939 = (object_t) (obj_2182);
		  aux_2938 = OBJECT_WIDENING(aux_2939);
	       }
	       itype_1237 = (((tvec_t) CREF(aux_2938))->item_type_130);
	    }
	 }
	 {
	    obj_t c_vec_209_1238;
	    c_vec_209_1238 = tvector__c_vector_165_tvector_cnst(tvec_42);
	    {
	       set_variable_name__102_cgen_prototype((obj_t) (global_43));
	       {
		  obj_t aux_1239;
		  {
		     obj_t arg1840_1265;
		     arg1840_1265 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, (((global_t) CREF(global_43))->name), BEOA);
		     aux_1239 = id__name_228_ast_ident(arg1840_1265);
		  }
		  {
		     long arg1813_1242;
		     obj_t arg1819_1244;
		     obj_t arg1822_1247;
		     arg1813_1242 = VECTOR_LENGTH(vec_1236);
		     arg1819_1244 = string_sans___40_type_tools((((type_t) CREF(itype_1237))->name));
		     arg1822_1247 = (((global_t) CREF(global_43))->name);
		     {
			obj_t list1825_1250;
			{
			   obj_t arg1826_1251;
			   {
			      obj_t arg1827_1252;
			      {
				 obj_t arg1828_1253;
				 {
				    obj_t arg1829_1254;
				    {
				       obj_t arg1830_1255;
				       {
					  obj_t arg1831_1256;
					  {
					     obj_t arg1832_1257;
					     {
						obj_t arg1833_1258;
						{
						   obj_t arg1834_1259;
						   {
						      obj_t arg1835_1260;
						      {
							 obj_t arg1836_1261;
							 {
							    obj_t arg1837_1262;
							    arg1837_1262 = MAKE_PAIR(string2167_cgen_prototype, BNIL);
							    arg1836_1261 = MAKE_PAIR(aux_1239, arg1837_1262);
							 }
							 arg1835_1260 = MAKE_PAIR(string2159_cgen_prototype, arg1836_1261);
						      }
						      arg1834_1259 = MAKE_PAIR(arg1822_1247, arg1835_1260);
						   }
						   arg1833_1258 = MAKE_PAIR(string2178_cgen_prototype, arg1834_1259);
						}
						arg1832_1257 = MAKE_PAIR(c_vec_209_1238, arg1833_1258);
					     }
					     arg1831_1256 = MAKE_PAIR(string2179_cgen_prototype, arg1832_1257);
					  }
					  arg1830_1255 = MAKE_PAIR(arg1819_1244, arg1831_1256);
				       }
				       arg1829_1254 = MAKE_PAIR(string2159_cgen_prototype, arg1830_1255);
				    }
				    {
				       obj_t aux_2963;
				       aux_2963 = BINT(arg1813_1242);
				       arg1828_1253 = MAKE_PAIR(aux_2963, arg1829_1254);
				    }
				 }
				 arg1827_1252 = MAKE_PAIR(string2159_cgen_prototype, arg1828_1253);
			      }
			      arg1826_1251 = MAKE_PAIR(aux_1239, arg1827_1252);
			   }
			   list1825_1250 = MAKE_PAIR(string2180_cgen_prototype, arg1826_1251);
			}
			return fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1825_1250);
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
get_c_scope_default1442_143_cgen_prototype(variable_t variable_45)
{
   FAILURE(CNST_TABLE_REF(((long) 9)), string2155_cgen_prototype, (obj_t) (variable_45));
}


obj_t 
_get_c_scope_default1442_42_cgen_prototype(obj_t env_2286, obj_t variable_2287)
{
   return get_c_scope_default1442_143_cgen_prototype((variable_t) (variable_2287));
}


obj_t 
get_c_scope_184_cgen_prototype(variable_t variable_44)
{
   {
      obj_t method2028_1798;
      obj_t class2033_1799;
      {
	 obj_t arg2036_1796;
	 obj_t arg2037_1797;
	 {
	    object_t obj_2192;
	    obj_2192 = (object_t) (variable_44);
	    {
	       obj_t pre_method_105_2193;
	       pre_method_105_2193 = PROCEDURE_REF(get_c_scope_env_161_cgen_prototype, ((long) 2));
	       if (INTEGERP(pre_method_105_2193))
		 {
		    PROCEDURE_SET(get_c_scope_env_161_cgen_prototype, ((long) 2), BUNSPEC);
		    arg2036_1796 = pre_method_105_2193;
		 }
	       else
		 {
		    long obj_class_num_177_2198;
		    obj_class_num_177_2198 = TYPE(obj_2192);
		    {
		       obj_t arg1183_2199;
		       arg1183_2199 = PROCEDURE_REF(get_c_scope_env_161_cgen_prototype, ((long) 1));
		       {
			  long arg1184_2203;
			  {
			     long arg1186_2204;
			     arg1186_2204 = OBJECT_TYPE;
			     arg1184_2203 = (obj_class_num_177_2198 - arg1186_2204);
			  }
			  arg2036_1796 = VECTOR_REF(arg1183_2199, arg1184_2203);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_2209;
	    object_2209 = (object_t) (variable_44);
	    {
	       long arg1187_2210;
	       {
		  long arg1188_2211;
		  long arg1189_2212;
		  arg1188_2211 = TYPE(object_2209);
		  arg1189_2212 = OBJECT_TYPE;
		  arg1187_2210 = (arg1188_2211 - arg1189_2212);
	       }
	       {
		  obj_t vector_2216;
		  vector_2216 = __classes__134___object;
		  arg2037_1797 = VECTOR_REF(vector_2216, arg1187_2210);
	       }
	    }
	 }
	 method2028_1798 = arg2036_1796;
	 class2033_1799 = arg2037_1797;
	 {
	    if (INTEGERP(method2028_1798))
	      {
		 switch ((long) CINT(method2028_1798))
		   {
		   case ((long) 0):
		      {
			 global_t variable_1805;
			 variable_1805 = (global_t) (variable_44);
			 {
			    obj_t case_value_58_1807;
			    case_value_58_1807 = (((global_t) CREF(variable_1805))->import);
			    {
			       bool_t test_2994;
			       {
				  obj_t aux_2995;
				  aux_2995 = CNST_TABLE_REF(((long) 2));
				  test_2994 = (case_value_58_1807 == aux_2995);
			       }
			       if (test_2994)
				 {
				    return string2161_cgen_prototype;
				 }
			       else
				 {
				    bool_t test_2998;
				    {
				       obj_t aux_2999;
				       aux_2999 = CNST_TABLE_REF(((long) 8));
				       test_2998 = (case_value_58_1807 == aux_2999);
				    }
				    if (test_2998)
				      {
					 return string2181_cgen_prototype;
				      }
				    else
				      {
					 bool_t test_3002;
					 {
					    obj_t aux_3003;
					    aux_3003 = CNST_TABLE_REF(((long) 0));
					    test_3002 = (case_value_58_1807 == aux_3003);
					 }
					 if (test_3002)
					   {
					      return string2181_cgen_prototype;
					   }
					 else
					   {
					      return internal_error_43_tools_error(string2182_cgen_prototype, string2183_cgen_prototype, (((global_t) CREF(variable_1805))->import));
					   }
				      }
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 1):
		      return string2161_cgen_prototype;
		      break;
		   default:
		    case_else2034_190_1802:
		      if (PROCEDUREP(method2028_1798))
			{
			   return PROCEDURE_ENTRY(method2028_1798) (method2028_1798, (obj_t) (variable_44), BEOA);
			}
		      else
			{
			   obj_t fun1845_1270;
			   fun1845_1270 = PROCEDURE_REF(get_c_scope_env_161_cgen_prototype, ((long) 0));
			   return PROCEDURE_ENTRY(fun1845_1270) (fun1845_1270, (obj_t) (variable_44), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else2034_190_1802;
	      }
	 }
      }
   }
}


obj_t 
_get_c_scope_242_cgen_prototype(obj_t env_2284, obj_t variable_2285)
{
   return get_c_scope_184_cgen_prototype((variable_t) (variable_2285));
}


obj_t 
set_variable_name__102_cgen_prototype(obj_t variable_48)
{
   {
      bool_t test_3021;
      {
	 obj_t aux_3022;
	 {
	    variable_t obj_2228;
	    obj_2228 = (variable_t) (variable_48);
	    aux_3022 = (((variable_t) CREF(obj_2228))->name);
	 }
	 test_3021 = STRINGP(aux_3022);
      }
      if (test_3021)
	{
	   variable_t obj_2230;
	   obj_2230 = (variable_t) (variable_48);
	   return (((variable_t) CREF(obj_2230))->name);
	}
      else
	{
	   obj_t n_1273;
	   {
	      obj_t name_1274;
	      {
		 obj_t aux_3028;
		 {
		    variable_t obj_2231;
		    obj_2231 = (variable_t) (variable_48);
		    aux_3028 = (((variable_t) CREF(obj_2231))->id);
		 }
		 name_1274 = id__name_228_ast_ident(aux_3028);
	      }
	      {
		 bool_t test1847_1275;
		 test1847_1275 = is_a__118___object(variable_48, global_ast_var);
		 if (test1847_1275)
		   {
		      {
			 obj_t arg1849_1278;
			 {
			    obj_t aux_3034;
			    {
			       global_t obj_2233;
			       obj_2233 = (global_t) (variable_48);
			       aux_3034 = (((global_t) CREF(obj_2233))->module);
			    }
			    arg1849_1278 = id__name_228_ast_ident(aux_3034);
			 }
			 {
			    obj_t list1850_1279;
			    {
			       obj_t arg1852_1280;
			       {
				  obj_t arg1853_1281;
				  arg1853_1281 = MAKE_PAIR(arg1849_1278, BNIL);
				  arg1852_1280 = MAKE_PAIR(string2184_cgen_prototype, arg1853_1281);
			       }
			       list1850_1279 = MAKE_PAIR(name_1274, arg1852_1280);
			    }
			    n_1273 = string_append_106___r4_strings_6_7(list1850_1279);
			 }
		      }
		   }
		 else
		   {
		      bool_t test1856_1283;
		      test1856_1283 = is_a__118___object(variable_48, local_ast_var);
		      if (test1856_1283)
			{
			   {
			      obj_t list1859_1286;
			      {
				 obj_t arg1860_1287;
				 {
				    obj_t arg1861_1288;
				    {
				       obj_t aux_3044;
				       {
					  char *aux_3045;
					  {
					     long aux_3046;
					     {
						local_t obj_2235;
						obj_2235 = (local_t) (variable_48);
						aux_3046 = (((local_t) CREF(obj_2235))->key);
					     }
					     aux_3045 = integer__string_135___r4_numbers_6_5_fixnum(aux_3046, BNIL);
					  }
					  aux_3044 = string_to_bstring(aux_3045);
				       }
				       arg1861_1288 = MAKE_PAIR(aux_3044, BNIL);
				    }
				    arg1860_1287 = MAKE_PAIR(string2184_cgen_prototype, arg1861_1288);
				 }
				 list1859_1286 = MAKE_PAIR(name_1274, arg1860_1287);
			      }
			      n_1273 = string_append_106___r4_strings_6_7(list1859_1286);
			   }
			}
		      else
			{
			   {
			      obj_t arg1867_1294;
			      arg1867_1294 = shape_tools_shape(variable_48);
			      n_1273 = internal_error_43_tools_error(string2185_cgen_prototype, string2186_cgen_prototype, arg1867_1294);
			   }
			}
		   }
	      }
	   }
	   {
	      obj_t res2150_2238;
	      {
		 variable_t obj_2236;
		 obj_2236 = (variable_t) (variable_48);
		 {
		    obj_t x_2299;
		    x_2299 = ((((variable_t) CREF(obj_2236))->name) = ((obj_t) n_1273), BUNSPEC);
		    res2150_2238 = BUNSPEC;
		 }
	      }
	      res2150_2238;
	   }
	   return n_1273;
	}
   }
}


obj_t 
_set_variable_name__28_cgen_prototype(obj_t env_2296, obj_t variable_2297)
{
   return set_variable_name__102_cgen_prototype(variable_2297);
}


bool_t 
fprin_cgen_prototype(obj_t port_49, obj_t obj_50)
{
   {
      obj_t l1433_1297;
      l1433_1297 = obj_50;
    lname1435_1298:
      if (PAIRP(l1433_1297))
	{
	   {
	      obj_t o_1300;
	      o_1300 = CAR(l1433_1297);
	      {
		 obj_t list1873_1301;
		 list1873_1301 = MAKE_PAIR(port_49, BNIL);
		 display___r4_output_6_10_3(o_1300, list1873_1301);
	      }
	   }
	   {
	      obj_t l1433_3065;
	      l1433_3065 = CDR(l1433_1297);
	      l1433_1297 = l1433_3065;
	      goto lname1435_1298;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
imported_modules_init_94_cgen_prototype()
{
   module_initialization_70_tools_error(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_tools_shape(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_engine_param(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_module_module(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_type_type(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_type_cache(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_type_tools(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_type_env(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_ast_var(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_ast_node(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_ast_env(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_ast_ident(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_tvector_tvector(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_tvector_cnst(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_cnst_alloc(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_cgen_cop(((long) 0), "CGEN_PROTOTYPE");
   module_initialization_70_cgen_emit(((long) 0), "CGEN_PROTOTYPE");
   return module_initialization_70_cgen_emit_cop_239(((long) 0), "CGEN_PROTOTYPE");
}
