/*===========================================================================*/
/*   (Cgen/walk.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;

typedef struct cop
  {
     header_t header;
     obj_t widening;
  }
   *cop_t;

typedef struct clabel
  {
     header_t header;
     obj_t widening;
     obj_t name;
     bool_t used__226;
     obj_t body;
  }
      *clabel_t;

typedef struct cgoto
  {
     header_t header;
     obj_t widening;
     struct clabel *label;
  }
     *cgoto_t;

typedef struct block
  {
     header_t header;
     obj_t widening;
     struct cop *body;
  }
     *block_t;

typedef struct creturn
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
       *creturn_t;

typedef struct cvoid
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
     *cvoid_t;

typedef struct catom
  {
     header_t header;
     obj_t widening;
     obj_t value;
  }
     *catom_t;

typedef struct varc
  {
     header_t header;
     obj_t widening;
     struct variable *variable;
  }
    *varc_t;

typedef struct cpragma
  {
     header_t header;
     obj_t widening;
     obj_t format;
     obj_t args;
  }
       *cpragma_t;

typedef struct ccast
  {
     header_t header;
     obj_t widening;
     struct type *type;
     struct cop *arg;
  }
     *ccast_t;

typedef struct csequence
  {
     header_t header;
     obj_t widening;
     bool_t c_exp__163;
     obj_t cops;
  }
         *csequence_t;

typedef struct nop
  {
     header_t header;
     obj_t widening;
  }
   *nop_t;

typedef struct stop
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
    *stop_t;

typedef struct csetq
  {
     header_t header;
     obj_t widening;
     struct varc *var;
     struct cop *value;
  }
     *csetq_t;

typedef struct cif
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     struct cop *true;
     struct cop *false;
  }
   *cif_t;

typedef struct branch
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     struct cop *true;
     struct cop *false;
     struct cop *end;
  }
      *branch_t;

typedef struct local_var_164
  {
     header_t header;
     obj_t widening;
     obj_t vars;
  }
             *local_var_164_t;

typedef struct cfuncall
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     obj_t args;
     obj_t strength;
  }
        *cfuncall_t;

typedef struct capply
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     struct cop *arg;
  }
      *capply_t;

typedef struct capp
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     obj_t args;
  }
    *capp_t;

typedef struct cfail
  {
     header_t header;
     obj_t widening;
     struct cop *proc;
     struct cop *msg;
     struct cop *obj;
  }
     *cfail_t;

typedef struct cswitch
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     obj_t clauses;
  }
       *cswitch_t;

typedef struct cmake_box_177
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
             *cmake_box_177_t;

typedef struct cbox_ref_44
  {
     header_t header;
     obj_t widening;
     struct cop *var;
  }
           *cbox_ref_44_t;

typedef struct cbox_set__132
  {
     header_t header;
     obj_t widening;
     struct cop *var;
     struct cop *value;
  }
             *cbox_set__132_t;

typedef struct cset_ex_it_123
  {
     header_t header;
     obj_t widening;
     struct cop *exit;
     struct cop *jump_value_221;
     struct cop *body;
  }
              *cset_ex_it_123_t;

typedef struct cjump_ex_it_131
  {
     header_t header;
     obj_t widening;
     struct cop *exit;
     struct cop *value;
  }
               *cjump_ex_it_131_t;

typedef struct sfun_c_188
  {
     struct clabel *label;
     bool_t integrated;
  }
          *sfun_c_188_t;


extern obj_t start_emission__101_cgen_emit(obj_t);
extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t library_finalizer_97_module_library();
extern obj_t _cgen_walk_165_cgen_walk(obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t emit_main_179_cgen_emit();
extern obj_t __c_debug__136_engine_param;
static obj_t imported_modules_init_94_cgen_walk();
extern obj_t module_initialization_70_cgen_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_library(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_occur(long, char *);
extern obj_t module_initialization_70_ast_build(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_cgen_cop(long, char *);
extern obj_t module_initialization_70_cgen_emit(long, char *);
extern obj_t module_initialization_70_cgen_prototype(long, char *);
extern obj_t module_initialization_70_cgen_main(long, char *);
extern obj_t module_initialization_70_cgen_init(long, char *);
extern obj_t module_initialization_70_cgen_cgen(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_cgen_walk();
static obj_t cnst_init_137_cgen_walk();
extern obj_t build_ast_sans_remove_93_ast_build(obj_t);
extern obj_t __compiler_debug__134_engine_param;
extern obj_t make_module_init_70_cgen_init();
static obj_t require_initialization_114_cgen_walk = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_cgen_walk();
static obj_t arg14711713_cgen_walk(obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t emit_garbage_collector_selection_89_cgen_emit();
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t __c_port__188_cgen_emit;
extern obj_t __main__152_module_module;
extern obj_t read___reader(obj_t);
extern obj_t emit_prototypes_82_cgen_prototype();
extern obj_t open_input_string(obj_t);
extern obj_t cgen_cgen_cgen(global_t);
extern obj_t emit_class_types_26_object_class(obj_t);
extern obj_t make_bigloo_main_85_cgen_main();
extern obj_t stop_emission__231_cgen_emit();
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t emit_header_99_cgen_emit();
extern obj_t emit_include_217_cgen_emit();
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t __current_pass__25_engine_pass;
extern obj_t emit_cnsts_221_cgen_prototype();
extern obj_t emit_debug_activation_148_cgen_emit();
extern obj_t __pass__125_engine_param;
extern obj_t cgen_walk_174_cgen_walk(obj_t);
extern obj_t occur_node_in__115_ast_occur(node_t, global_t);
static obj_t __cnst[6];

DEFINE_STATIC_PROCEDURE(proc1717_cgen_walk, arg14711713_cgen_walk1726, arg14711713_cgen_walk, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cgen_walk_env_156_cgen_walk, _cgen_walk_165_cgen_walk1727, _cgen_walk_165_cgen_walk, 0L, 1);
DEFINE_STRING(string1716_cgen_walk, string1716_cgen_walk1728, "failure during prelude hook", 27);
DEFINE_STRING(string1715_cgen_walk, string1715_cgen_walk1729, "   . ", 5);
DEFINE_STRING(string1720_cgen_walk, string1720_cgen_walk1730, "IMPORTED (LD DISTRIB) UNIT CGEN ((LAMBDA () (START-EMISSION! \".c\"))) PASS-STARTED ", 82);
DEFINE_STRING(string1714_cgen_walk, string1714_cgen_walk1731, "C generation", 12);
DEFINE_STRING(string1718_cgen_walk, string1718_cgen_walk1732, "cgen-walk: *main*: ", 19);
DEFINE_STRING(string1719_cgen_walk, string1719_cgen_walk1733, ".c", 2);

obj_t 
module_initialization_70_cgen_walk(long checksum_1597, char *from_1598)
{
   if (CBOOL(require_initialization_114_cgen_walk))
     {
	require_initialization_114_cgen_walk = BBOOL(((bool_t) 0));
	library_modules_init_112_cgen_walk();
	cnst_init_137_cgen_walk();
	imported_modules_init_94_cgen_walk();
	toplevel_init_63_cgen_walk();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cgen_walk()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CGEN_WALK");
   module_initialization_70___reader(((long) 0), "CGEN_WALK");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cgen_walk()
{
   {
      obj_t cnst_port_138_1589;
      cnst_port_138_1589 = open_input_string(string1720_cgen_walk);
      {
	 long i_1590;
	 i_1590 = ((long) 5);
       loop_1591:
	 {
	    bool_t test1721_1592;
	    test1721_1592 = (i_1590 == ((long) -1));
	    if (test1721_1592)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1722_1593;
		    {
		       obj_t list1723_1594;
		       {
			  obj_t arg1724_1595;
			  arg1724_1595 = BNIL;
			  list1723_1594 = MAKE_PAIR(cnst_port_138_1589, arg1724_1595);
		       }
		       arg1722_1593 = read___reader(list1723_1594);
		    }
		    CNST_TABLE_SET(i_1590, arg1722_1593);
		 }
		 {
		    int aux_1596;
		    {
		       long aux_1614;
		       aux_1614 = (i_1590 - ((long) 1));
		       aux_1596 = (int) (aux_1614);
		    }
		    {
		       long i_1617;
		       i_1617 = (long) (aux_1596);
		       i_1590 = i_1617;
		       goto loop_1591;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cgen_walk()
{
   return BUNSPEC;
}


obj_t 
cgen_walk_174_cgen_walk(obj_t globals_19)
{
   {
      obj_t list1459_922;
      {
	 obj_t arg1463_924;
	 {
	    obj_t arg1466_926;
	    {
	       obj_t aux_1619;
	       aux_1619 = BCHAR(((unsigned char) '\n'));
	       arg1466_926 = MAKE_PAIR(aux_1619, BNIL);
	    }
	    arg1463_924 = MAKE_PAIR(string1714_cgen_walk, arg1466_926);
	 }
	 list1459_922 = MAKE_PAIR(string1715_cgen_walk, arg1463_924);
      }
      verbose_tools_speek(BINT(((long) 1)), list1459_922);
   }
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   __current_pass__25_engine_pass = string1714_cgen_walk;
   {
      obj_t hooks_928;
      obj_t hnames_929;
      {
	 obj_t arg1468_931;
	 obj_t arg1470_932;
	 {
	    obj_t arg1471_1584;
	    arg1471_1584 = proc1717_cgen_walk;
	    {
	       obj_t list1472_934;
	       list1472_934 = MAKE_PAIR(arg1471_1584, BNIL);
	       arg1468_931 = list1472_934;
	    }
	 }
	 arg1470_932 = CNST_TABLE_REF(((long) 1));
	 hooks_928 = arg1468_931;
	 hnames_929 = arg1470_932;
       loop_930:
	 if (NULLP(hooks_928))
	   {
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {
	      bool_t test1477_939;
	      {
		 obj_t fun1486_945;
		 fun1486_945 = CAR(hooks_928);
		 {
		    obj_t aux_1633;
		    aux_1633 = PROCEDURE_ENTRY(fun1486_945) (fun1486_945, BEOA);
		    test1477_939 = CBOOL(aux_1633);
		 }
	      }
	      if (test1477_939)
		{
		   {
		      obj_t hnames_1640;
		      obj_t hooks_1638;
		      hooks_1638 = CDR(hooks_928);
		      hnames_1640 = CDR(hnames_929);
		      hnames_929 = hnames_1640;
		      hooks_928 = hooks_1638;
		      goto loop_930;
		   }
		}
	      else
		{
		   internal_error_43_tools_error(string1714_cgen_walk, string1716_cgen_walk, CAR(hnames_929));
		}
	   }
      }
   }
   {
      bool_t test1487_946;
      {
	 obj_t aux_1644;
	 aux_1644 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 2)), BINT(((long) 0)));
	 test1487_946 = CBOOL(aux_1644);
      }
      if (test1487_946)
	{
	   obj_t arg1490_948;
	   arg1490_948 = shape_tools_shape(__main__152_module_module);
	   {
	      obj_t list1491_949;
	      {
		 obj_t arg1493_950;
		 {
		    obj_t arg1494_951;
		    {
		       obj_t arg1496_952;
		       {
			  obj_t arg1497_953;
			  {
			     obj_t arg1498_954;
			     {
				obj_t aux_1651;
				aux_1651 = BCHAR(((unsigned char) '\n'));
				arg1498_954 = MAKE_PAIR(aux_1651, BNIL);
			     }
			     {
				obj_t aux_1654;
				aux_1654 = BCHAR(((unsigned char) ')'));
				arg1497_953 = MAKE_PAIR(aux_1654, arg1498_954);
			     }
			  }
			  arg1496_952 = MAKE_PAIR(__main__152_module_module, arg1497_953);
		       }
		       {
			  obj_t aux_1658;
			  aux_1658 = BCHAR(((unsigned char) '('));
			  arg1494_951 = MAKE_PAIR(aux_1658, arg1496_952);
		       }
		    }
		    arg1493_950 = MAKE_PAIR(arg1490_948, arg1494_951);
		 }
		 list1491_949 = MAKE_PAIR(string1718_cgen_walk, arg1493_950);
	      }
	      print_trace_107_tools_trace(list1491_949);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t lib_unit_138_958;
      lib_unit_138_958 = library_finalizer_97_module_library();
      {
	 obj_t lib_init_12_959;
	 {
	    bool_t test_1665;
	    if (STRUCTP(lib_unit_138_958))
	      {
		 obj_t aux_1670;
		 obj_t aux_1668;
		 aux_1670 = CNST_TABLE_REF(((long) 3));
		 aux_1668 = STRUCT_KEY(lib_unit_138_958);
		 test_1665 = (aux_1668 == aux_1670);
	      }
	    else
	      {
		 test_1665 = ((bool_t) 0);
	      }
	    if (test_1665)
	      {
		 obj_t vars_983;
		 {
		    obj_t arg1536_991;
		    {
		       obj_t list1537_992;
		       list1537_992 = MAKE_PAIR(lib_unit_138_958, BNIL);
		       arg1536_991 = list1537_992;
		    }
		    vars_983 = build_ast_sans_remove_93_ast_build(arg1536_991);
		 }
		 {
		    obj_t l1426_984;
		    l1426_984 = vars_983;
		  lname1427_985:
		    if (PAIRP(l1426_984))
		      {
			 {
			    obj_t g_987;
			    g_987 = CAR(l1426_984);
			    {
			       node_t aux_1678;
			       {
				  obj_t aux_1679;
				  {
				     sfun_t obj_1528;
				     {
					value_t aux_1680;
					{
					   global_t obj_1527;
					   obj_1527 = (global_t) (g_987);
					   aux_1680 = (((global_t) CREF(obj_1527))->value);
					}
					obj_1528 = (sfun_t) (aux_1680);
				     }
				     aux_1679 = (((sfun_t) CREF(obj_1528))->body);
				  }
				  aux_1678 = (node_t) (aux_1679);
			       }
			       occur_node_in__115_ast_occur(aux_1678, (global_t) (g_987));
			    }
			 }
			 {
			    obj_t l1426_1688;
			    l1426_1688 = CDR(l1426_984);
			    l1426_984 = l1426_1688;
			    goto lname1427_985;
			 }
		      }
		    else
		      {
			 ((bool_t) 1);
		      }
		 }
		 lib_init_12_959 = vars_983;
	      }
	    else
	      {
		 lib_init_12_959 = BNIL;
	      }
	 }
	 {
	    obj_t globals_960;
	    {
	       obj_t arg1514_973;
	       obj_t arg1517_974;
	       arg1514_973 = make_module_init_70_cgen_init();
	       {
		  bool_t test1518_975;
		  {
		     bool_t test1523_978;
		     if (CBOOL(__main__152_module_module))
		       {
			  test1523_978 = ((bool_t) 1);
		       }
		     else
		       {
			  obj_t aux_1693;
			  aux_1693 = memq___r4_pairs_and_lists_6_3(__pass__125_engine_param, CNST_TABLE_REF(((long) 4)));
			  test1523_978 = CBOOL(aux_1693);
		       }
		     if (test1523_978)
		       {
			  bool_t test1524_979;
			  {
			     obj_t obj1_1530;
			     obj1_1530 = __main__152_module_module;
			     {
				obj_t aux_1698;
				aux_1698 = CNST_TABLE_REF(((long) 5));
				test1524_979 = (obj1_1530 == aux_1698);
			     }
			  }
			  if (test1524_979)
			    {
			       test1518_975 = ((bool_t) 0);
			    }
			  else
			    {
			       test1518_975 = ((bool_t) 1);
			    }
		       }
		     else
		       {
			  test1518_975 = ((bool_t) 0);
		       }
		  }
		  if (test1518_975)
		    {
		       obj_t arg1520_976;
		       obj_t arg1522_977;
		       arg1520_976 = make_bigloo_main_85_cgen_main();
		       arg1522_977 = append_2_18___r4_pairs_and_lists_6_3(lib_init_12_959, globals_19);
		       arg1517_974 = MAKE_PAIR(arg1520_976, arg1522_977);
		    }
		  else
		    {
		       arg1517_974 = append_2_18___r4_pairs_and_lists_6_3(lib_init_12_959, globals_19);
		    }
	       }
	       globals_960 = MAKE_PAIR(arg1514_973, arg1517_974);
	    }
	    {
	       emit_header_99_cgen_emit();
	       emit_garbage_collector_selection_89_cgen_emit();
	       {
		  bool_t test1502_961;
		  {
		     bool_t test1503_962;
		     {
			long n1_1536;
			n1_1536 = (long) CINT(__compiler_debug__134_engine_param);
			test1503_962 = (n1_1536 > ((long) 0));
		     }
		     if (test1503_962)
		       {
			  test1502_961 = ((bool_t) 1);
		       }
		     else
		       {
			  test1502_961 = CBOOL(__c_debug__136_engine_param);
		       }
		  }
		  if (test1502_961)
		    {
		       emit_debug_activation_148_cgen_emit();
		    }
		  else
		    {
		       BUNSPEC;
		    }
	       }
	       emit_include_217_cgen_emit();
	       emit_class_types_26_object_class(__c_port__188_cgen_emit);
	       emit_prototypes_82_cgen_prototype();
	       emit_cnsts_221_cgen_prototype();
	       {
		  bool_t test1504_963;
		  {
		     bool_t test1505_964;
		     if (CBOOL(__main__152_module_module))
		       {
			  test1505_964 = ((bool_t) 1);
		       }
		     else
		       {
			  obj_t aux_1722;
			  aux_1722 = memq___r4_pairs_and_lists_6_3(__pass__125_engine_param, CNST_TABLE_REF(((long) 4)));
			  test1505_964 = CBOOL(aux_1722);
		       }
		     if (test1505_964)
		       {
			  bool_t test1506_965;
			  {
			     obj_t obj1_1538;
			     obj1_1538 = __main__152_module_module;
			     {
				obj_t aux_1727;
				aux_1727 = CNST_TABLE_REF(((long) 5));
				test1506_965 = (obj1_1538 == aux_1727);
			     }
			  }
			  if (test1506_965)
			    {
			       test1504_963 = ((bool_t) 0);
			    }
			  else
			    {
			       test1504_963 = ((bool_t) 1);
			    }
		       }
		     else
		       {
			  test1504_963 = ((bool_t) 0);
		       }
		  }
		  if (test1504_963)
		    {
		       emit_main_179_cgen_emit();
		    }
		  else
		    {
		       BUNSPEC;
		    }
	       }
	       {
		  obj_t l1428_968;
		  l1428_968 = globals_960;
		lname1430_969:
		  if (PAIRP(l1428_968))
		    {
		       {
			  global_t aux_1735;
			  {
			     obj_t aux_1736;
			     aux_1736 = CAR(l1428_968);
			     aux_1735 = (global_t) (aux_1736);
			  }
			  cgen_cgen_cgen(aux_1735);
		       }
		       {
			  obj_t l1428_1740;
			  l1428_1740 = CDR(l1428_968);
			  l1428_968 = l1428_1740;
			  goto lname1430_969;
		       }
		    }
		  else
		    {
		       ((bool_t) 1);
		    }
	       }
	       return stop_emission__231_cgen_emit();
	    }
	 }
      }
   }
}


obj_t 
_cgen_walk_165_cgen_walk(obj_t env_1585, obj_t globals_1586)
{
   return cgen_walk_174_cgen_walk(globals_1586);
}


obj_t 
arg14711713_cgen_walk(obj_t env_1587)
{
   {
      return start_emission__101_cgen_emit(string1719_cgen_walk);
   }
}


obj_t 
imported_modules_init_94_cgen_walk()
{
   module_initialization_70_tools_speek(((long) 0), "CGEN_WALK");
   module_initialization_70_tools_error(((long) 0), "CGEN_WALK");
   module_initialization_70_engine_pass(((long) 0), "CGEN_WALK");
   module_initialization_70_tools_trace(((long) 0), "CGEN_WALK");
   module_initialization_70_tools_shape(((long) 0), "CGEN_WALK");
   module_initialization_70_engine_param(((long) 0), "CGEN_WALK");
   module_initialization_70_module_module(((long) 0), "CGEN_WALK");
   module_initialization_70_module_library(((long) 0), "CGEN_WALK");
   module_initialization_70_type_type(((long) 0), "CGEN_WALK");
   module_initialization_70_ast_var(((long) 0), "CGEN_WALK");
   module_initialization_70_ast_node(((long) 0), "CGEN_WALK");
   module_initialization_70_ast_occur(((long) 0), "CGEN_WALK");
   module_initialization_70_ast_build(((long) 0), "CGEN_WALK");
   module_initialization_70_object_class(((long) 0), "CGEN_WALK");
   module_initialization_70_cgen_cop(((long) 0), "CGEN_WALK");
   module_initialization_70_cgen_emit(((long) 0), "CGEN_WALK");
   module_initialization_70_cgen_prototype(((long) 0), "CGEN_WALK");
   module_initialization_70_cgen_main(((long) 0), "CGEN_WALK");
   module_initialization_70_cgen_init(((long) 0), "CGEN_WALK");
   return module_initialization_70_cgen_cgen(((long) 0), "CGEN_WALK");
}
