/*===========================================================================*/
/*   (Cnst/alloc.scm)                                                        */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct tvec
  {
     struct type *item_type_130;
  }
    *tvec_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t __pair__244_type_cache;
extern obj_t _get_cnst_table_79_cnst_alloc(obj_t);
extern obj_t _cnst_alloc_list_46_cnst_alloc(obj_t, obj_t, obj_t);
extern obj_t _get_cnst_offset_51_cnst_alloc(obj_t);
static obj_t __cnst_table__103_cnst_alloc = BUNSPEC;
extern obj_t _get_cnst_set_97_cnst_alloc(obj_t);
extern node_t coerce__182_coerce_coerce(node_t, type_t);
extern obj_t get_hash_29___hash(obj_t, obj_t);
extern obj_t sequence_ast_node;
extern node_t cnst_alloc_list_56_cnst_alloc(obj_t, obj_t);
extern node_t cnst_alloc_symbol_123_cnst_alloc(obj_t, obj_t);
extern obj_t _n_o_f_u_c_k_i_n_g___init_or_fini__init_mode__183_engine_param;
extern obj_t _cnst_alloc_string_253_cnst_alloc(obj_t, obj_t, obj_t);
extern obj_t _stop_cnst_alloc__84_cnst_alloc(obj_t);
extern obj_t __vector_tag_set___225_cnst_cache;
extern obj_t make_hash_table_174___hash(long, obj_t, obj_t, obj_t, obj_t);
extern node_t cnst__44_cnst_node(node_t);
static obj_t imported_modules_init_94_cnst_alloc();
extern obj_t module_initialization_70_cnst_alloc(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tvector_tvector(long, char *);
extern obj_t module_initialization_70_tvector_cnst(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_cnst_cache(long, char *);
extern obj_t module_initialization_70_cnst_node(long, char *);
extern obj_t module_initialization_70___hash(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_equivalence_6_2(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_vectors_6_8(long, char *);
static obj_t __string_env__83_cnst_alloc = BUNSPEC;
static obj_t toplevel_init_63_cnst_alloc();
extern long get_hash_power_number(char *, long);
static obj_t cnst_init_137_cnst_alloc();
extern node_t cnst_alloc_tvector_190_cnst_alloc(obj_t, obj_t);
extern obj_t __string__keyword__251_cnst_cache;
static obj_t __global_sexp__67_cnst_alloc = BUNSPEC;
static obj_t __list_env__66_cnst_alloc = BUNSPEC;
extern obj_t __compiler_debug__134_engine_param;
static obj_t __symbol_env__148_cnst_alloc = BUNSPEC;
extern obj_t _cnst_alloc_procedure_221_cnst_alloc(obj_t, obj_t, obj_t);
static obj_t __global_set__17_cnst_alloc = BUNSPEC;
extern obj_t vector__list_155___r4_vectors_6_8(obj_t);
extern obj_t __module__166_module_module;
static obj_t cnst_info_cnst_73_cnst_alloc(obj_t);
extern obj_t __bstring__127_type_cache;
extern bool_t tvector_c_static__211_tvector_cnst(obj_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _string___169___r4_strings_6_7(obj_t, obj_t, obj_t);
static obj_t require_initialization_114_cnst_alloc = BUNSPEC;
extern obj_t get_cnst_sexp_197_cnst_alloc();
extern obj_t var_ast_node;
extern obj_t __bnil__15_type_cache;
static obj_t library_modules_init_112_cnst_alloc();
static obj_t __real_env__85_cnst_alloc = BUNSPEC;
extern bool_t equal__25___r4_equivalence_6_2(obj_t, obj_t);
extern obj_t _cnst_alloc_symbol_92_cnst_alloc(obj_t, obj_t, obj_t);
static app_t make_cnst_table_ref_93_cnst_alloc(obj_t, obj_t);
static obj_t arg13961955_cnst_alloc(obj_t, obj_t);
extern node_t cnst_alloc_string_41_cnst_alloc(obj_t, obj_t);
extern obj_t cnst_table_id_232_cnst_alloc();
extern obj_t read___reader(obj_t);
extern node_t cnst_alloc_real_118_cnst_alloc(obj_t, obj_t);
extern obj_t _cnst_alloc_real_237_cnst_alloc(obj_t, obj_t, obj_t);
extern obj_t __cnst_table_ref__15_cnst_cache;
extern node_t cnst_alloc_vector_65_cnst_alloc(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t __string__3_type_cache;
extern obj_t let_var_6_ast_node;
extern obj_t _cnst_alloc_tvector_13_cnst_alloc(obj_t, obj_t, obj_t);
extern global_t def_global_svar__184_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
extern obj_t _start_cnst_alloc__241_cnst_alloc(obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t __list__vector__161_cnst_cache;
extern long class_num_218___object(obj_t);
extern obj_t put_hash__129___hash(obj_t, obj_t);
static obj_t __keyword_env__205_cnst_alloc = BUNSPEC;
extern obj_t stop_cnst_alloc__36_cnst_alloc();
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern global_t def_global_scnst__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
extern obj_t __vector__240_type_cache;
extern obj_t get_cnst_set_138_cnst_alloc();
static obj_t loop_cnst_alloc(obj_t, obj_t);
static obj_t cnst_list_66_cnst_alloc(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern type_t get_default_type_181_type_cache();
extern obj_t __symbol__163_type_cache;
static obj_t _cnst_info_cnst_76_cnst_alloc(obj_t, obj_t);
extern obj_t __keyword__63_type_cache;
static obj_t __old_debug__29_cnst_alloc = BUNSPEC;
extern obj_t _get_cnst_sexp_123_cnst_alloc(obj_t);
extern obj_t _cnst_table_id_95_cnst_alloc(obj_t);
extern obj_t kwote_ast_node;
extern obj_t __cons__148_cnst_cache;
extern obj_t gensym___r4_symbols_6_4;
static long __cnst_offset__211_cnst_alloc;
extern obj_t _cnst_alloc_vector_187_cnst_alloc(obj_t, obj_t, obj_t);
static obj_t __vector_env__150_cnst_alloc = BUNSPEC;
static obj_t typed_cnst_table_id_34_cnst_alloc();
extern obj_t _eq__190___r4_equivalence_6_2(obj_t, obj_t, obj_t);
extern obj_t __shared_cnst___67_engine_param;
extern node_t cnst_alloc_procedure_240_cnst_alloc(node_t, obj_t);
extern obj_t _cnst_alloc_keyword_183_cnst_alloc(obj_t, obj_t, obj_t);
extern node_t cnst_alloc_keyword_47_cnst_alloc(obj_t, obj_t);
extern obj_t get_cnst_table_42_cnst_alloc();
static obj_t arg13791957_cnst_alloc(obj_t, obj_t);
extern obj_t get_cnst_offset_21_cnst_alloc();
extern obj_t __obj__252_type_cache;
extern obj_t atom_ast_node;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
extern obj_t start_cnst_alloc__206_cnst_alloc();
static obj_t arg13851956_cnst_alloc(obj_t, obj_t);
extern obj_t __string__symbol__115_cnst_cache;
extern obj_t create_struct(obj_t, long);
extern obj_t app_ast_node;
static obj_t __cnst[34];

DEFINE_STRING(string1963_cnst_alloc, string1963_cnst_alloc1969, "GET-TVECTOR-DESCRIPTOR TVECTOR-DESCR-SET! STVECTOR ::TVECTOR TVEC VAR ::VECTOR VECTOR CNST-LIST ::PAIR LIST SREAL ::REAL REAL SFUN ::PROCEDURE PROC A-KEYWORD ::KEYWORD KEYWORD LIB @ SET! A-SYMBOL ::SYMBOL SYMBOL CNST-INFO SSTRING ::BSTRING STRING NOW CNST-VECTOR ::CNST* __CNSTS_TABLE ", 285);
DEFINE_STRING(string1961_cnst_alloc, string1961_cnst_alloc1970, "read-alloc-tvector", 18);
DEFINE_EXPORT_PROCEDURE(cnst_alloc_list_env_88_cnst_alloc, _cnst_alloc_list_46_cnst_alloc1971, _cnst_alloc_list_46_cnst_alloc, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cnst_alloc_vector_env_32_cnst_alloc, _cnst_alloc_vector_187_cnst_alloc1972, _cnst_alloc_vector_187_cnst_alloc, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cnst_alloc_string_env_66_cnst_alloc, _cnst_alloc_string_253_cnst_alloc1973, _cnst_alloc_string_253_cnst_alloc, 0L, 2);
DEFINE_EXPORT_PROCEDURE(stop_cnst_alloc__env_174_cnst_alloc, _stop_cnst_alloc__84_cnst_alloc1974, _stop_cnst_alloc__84_cnst_alloc, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1959_cnst_alloc, arg13851956_cnst_alloc1975, arg13851956_cnst_alloc, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cnst_table_id_env_96_cnst_alloc, _cnst_table_id_95_cnst_alloc1976, _cnst_table_id_95_cnst_alloc, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1958_cnst_alloc, arg13791957_cnst_alloc1977, arg13791957_cnst_alloc, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cnst_alloc_tvector_env_188_cnst_alloc, _cnst_alloc_tvector_13_cnst_alloc1978, _cnst_alloc_tvector_13_cnst_alloc, 0L, 2);
DEFINE_EXPORT_PROCEDURE(start_cnst_alloc__env_227_cnst_alloc, _start_cnst_alloc__241_cnst_alloc1979, _start_cnst_alloc__241_cnst_alloc, 0L, 0);
DEFINE_STATIC_PROCEDURE(cnst_info_cnst_env_83_cnst_alloc, _cnst_info_cnst_76_cnst_alloc1980, _cnst_info_cnst_76_cnst_alloc, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1960_cnst_alloc, arg13961955_cnst_alloc1981, arg13961955_cnst_alloc, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cnst_alloc_procedure_env_95_cnst_alloc, _cnst_alloc_procedure_221_cnst_alloc1982, _cnst_alloc_procedure_221_cnst_alloc, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cnst_alloc_symbol_env_229_cnst_alloc, _cnst_alloc_symbol_92_cnst_alloc1983, _cnst_alloc_symbol_92_cnst_alloc, 0L, 2);
extern obj_t string___env_211___r4_strings_6_7;
DEFINE_EXPORT_PROCEDURE(get_cnst_offset_env_123_cnst_alloc, _get_cnst_offset_51_cnst_alloc1984, _get_cnst_offset_51_cnst_alloc, 0L, 0);
DEFINE_EXPORT_PROCEDURE(get_cnst_sexp_env_244_cnst_alloc, _get_cnst_sexp_123_cnst_alloc1985, _get_cnst_sexp_123_cnst_alloc, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cnst_alloc_keyword_env_61_cnst_alloc, _cnst_alloc_keyword_183_cnst_alloc1986, _cnst_alloc_keyword_183_cnst_alloc, 0L, 2);
DEFINE_EXPORT_PROCEDURE(get_cnst_table_env_73_cnst_alloc, _get_cnst_table_79_cnst_alloc1987, _get_cnst_table_79_cnst_alloc, 0L, 0);
DEFINE_STRING(string1962_cnst_alloc, string1962_cnst_alloc1988, "Unimplementable until bootstrap", 31);
extern obj_t eq__env_189___r4_equivalence_6_2;
DEFINE_EXPORT_PROCEDURE(cnst_alloc_real_env_220_cnst_alloc, _cnst_alloc_real_237_cnst_alloc1989, _cnst_alloc_real_237_cnst_alloc, 0L, 2);
DEFINE_EXPORT_PROCEDURE(get_cnst_set_env_67_cnst_alloc, _get_cnst_set_97_cnst_alloc1990, _get_cnst_set_97_cnst_alloc, 0L, 0);

obj_t 
module_initialization_70_cnst_alloc(long checksum_2534, char *from_2535)
{
   if (CBOOL(require_initialization_114_cnst_alloc))
     {
	require_initialization_114_cnst_alloc = BBOOL(((bool_t) 0));
	library_modules_init_112_cnst_alloc();
	cnst_init_137_cnst_alloc();
	imported_modules_init_94_cnst_alloc();
	toplevel_init_63_cnst_alloc();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cnst_alloc()
{
   module_initialization_70___hash(((long) 0), "CNST_ALLOC");
   module_initialization_70___r4_vectors_6_8(((long) 0), "CNST_ALLOC");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CNST_ALLOC");
   module_initialization_70___r4_equivalence_6_2(((long) 0), "CNST_ALLOC");
   module_initialization_70___reader(((long) 0), "CNST_ALLOC");
   module_initialization_70___object(((long) 0), "CNST_ALLOC");
   module_initialization_70___r4_symbols_6_4(((long) 0), "CNST_ALLOC");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cnst_alloc()
{
   {
      obj_t cnst_port_138_2526;
      cnst_port_138_2526 = open_input_string(string1963_cnst_alloc);
      {
	 long i_2527;
	 i_2527 = ((long) 33);
       loop_2528:
	 {
	    bool_t test1964_2529;
	    test1964_2529 = (i_2527 == ((long) -1));
	    if (test1964_2529)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1965_2530;
		    {
		       obj_t list1966_2531;
		       {
			  obj_t arg1967_2532;
			  arg1967_2532 = BNIL;
			  list1966_2531 = MAKE_PAIR(cnst_port_138_2526, arg1967_2532);
		       }
		       arg1965_2530 = read___reader(list1966_2531);
		    }
		    CNST_TABLE_SET(i_2527, arg1965_2530);
		 }
		 {
		    int aux_2533;
		    {
		       long aux_2556;
		       aux_2556 = (i_2527 - ((long) 1));
		       aux_2533 = (int) (aux_2556);
		    }
		    {
		       long i_2559;
		       i_2559 = (long) (aux_2533);
		       i_2527 = i_2559;
		       goto loop_2528;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cnst_alloc()
{
   __cnst_table__103_cnst_alloc = BUNSPEC;
   __cnst_offset__211_cnst_alloc = ((long) -1);
   __string_env__83_cnst_alloc = BNIL;
   __real_env__85_cnst_alloc = BNIL;
   __symbol_env__148_cnst_alloc = BNIL;
   __keyword_env__205_cnst_alloc = BNIL;
   __list_env__66_cnst_alloc = BNIL;
   __vector_env__150_cnst_alloc = BNIL;
   __global_set__17_cnst_alloc = BNIL;
   __global_sexp__67_cnst_alloc = BNIL;
   return (__old_debug__29_cnst_alloc = BUNSPEC,
      BUNSPEC);
}


obj_t 
cnst_info_cnst_73_cnst_alloc(obj_t s_18)
{
   return STRUCT_REF(s_18, ((long) 0));
}


obj_t 
_cnst_info_cnst_76_cnst_alloc(obj_t env_2473, obj_t s_2474)
{
   return cnst_info_cnst_73_cnst_alloc(s_2474);
}


obj_t 
get_cnst_offset_21_cnst_alloc()
{
   return BINT(__cnst_offset__211_cnst_alloc);
}


obj_t 
_get_cnst_offset_51_cnst_alloc(obj_t env_2475)
{
   return get_cnst_offset_21_cnst_alloc();
}


obj_t 
get_cnst_set_138_cnst_alloc()
{
   return __global_set__17_cnst_alloc;
}


obj_t 
_get_cnst_set_97_cnst_alloc(obj_t env_2476)
{
   return get_cnst_set_138_cnst_alloc();
}


obj_t 
get_cnst_table_42_cnst_alloc()
{
   return __cnst_table__103_cnst_alloc;
}


obj_t 
_get_cnst_table_79_cnst_alloc(obj_t env_2477)
{
   return get_cnst_table_42_cnst_alloc();
}


obj_t 
get_cnst_sexp_197_cnst_alloc()
{
   return reverse__39___r4_pairs_and_lists_6_3(__global_sexp__67_cnst_alloc);
}


obj_t 
_get_cnst_sexp_123_cnst_alloc(obj_t env_2478)
{
   return get_cnst_sexp_197_cnst_alloc();
}


obj_t 
cnst_table_id_232_cnst_alloc()
{
   return CNST_TABLE_REF(((long) 0));
}


obj_t 
_cnst_table_id_95_cnst_alloc(obj_t env_2479)
{
   return cnst_table_id_232_cnst_alloc();
}


obj_t 
typed_cnst_table_id_34_cnst_alloc()
{
   {
      obj_t arg1363_794;
      arg1363_794 = CNST_TABLE_REF(((long) 0));
      {
	 obj_t list1365_796;
	 {
	    obj_t arg1366_797;
	    {
	       obj_t aux_2572;
	       aux_2572 = CNST_TABLE_REF(((long) 1));
	       arg1366_797 = MAKE_PAIR(aux_2572, BNIL);
	    }
	    list1365_796 = MAKE_PAIR(arg1363_794, arg1366_797);
	 }
	 return symbol_append_197___r4_symbols_6_4(list1365_796);
      }
   }
}


obj_t 
start_cnst_alloc__206_cnst_alloc()
{
   __old_debug__29_cnst_alloc = __compiler_debug__134_engine_param;
   __compiler_debug__134_engine_param = BINT(((long) 0));
   {
      obj_t arg1369_799;
      obj_t arg1370_800;
      obj_t arg1372_801;
      arg1369_799 = typed_cnst_table_id_34_cnst_alloc();
      arg1370_800 = CNST_TABLE_REF(((long) 2));
      arg1372_801 = CNST_TABLE_REF(((long) 3));
      {
	 global_t aux_2581;
	 aux_2581 = def_global_svar__184_ast_glo_def_117(arg1369_799, __module__166_module_module, arg1370_800, arg1372_801);
	 __cnst_table__103_cnst_alloc = (obj_t) (aux_2581);
      }
   }
   __cnst_offset__211_cnst_alloc = ((long) 0);
   {
      obj_t arg1379_2482;
      arg1379_2482 = proc1958_cnst_alloc;
      __string_env__83_cnst_alloc = make_hash_table_174___hash(((long) 1024), arg1379_2482, cnst_info_cnst_env_83_cnst_alloc, string___env_211___r4_strings_6_7, BNIL);
   }
   __real_env__85_cnst_alloc = BNIL;
   {
      obj_t arg1385_2481;
      arg1385_2481 = proc1959_cnst_alloc;
      __symbol_env__148_cnst_alloc = make_hash_table_174___hash(((long) 1024), arg1385_2481, cnst_info_cnst_env_83_cnst_alloc, eq__env_189___r4_equivalence_6_2, BNIL);
   }
   {
      obj_t arg1396_2480;
      arg1396_2480 = proc1960_cnst_alloc;
      __keyword_env__205_cnst_alloc = make_hash_table_174___hash(((long) 1024), arg1396_2480, cnst_info_cnst_env_83_cnst_alloc, eq__env_189___r4_equivalence_6_2, BNIL);
   }
   return BTRUE;
}


obj_t 
_start_cnst_alloc__241_cnst_alloc(obj_t env_2483)
{
   return start_cnst_alloc__206_cnst_alloc();
}


obj_t 
arg13961955_cnst_alloc(obj_t env_2484, obj_t s_2485)
{
   {
      obj_t s_819;
      {
	 long aux_2588;
	 s_819 = s_2485;
	 {
	    obj_t arg1400_1616;
	    arg1400_1616 = KEYWORD_TO_STRING(s_819);
	    {
	       char *aux_2590;
	       aux_2590 = BSTRING_TO_STRING(arg1400_1616);
	       aux_2588 = get_hash_power_number(aux_2590, ((long) 10));
	    }
	 }
	 return BINT(aux_2588);
      }
   }
}


obj_t 
arg13851956_cnst_alloc(obj_t env_2486, obj_t s_2487)
{
   {
      obj_t s_811;
      {
	 long aux_2594;
	 s_811 = s_2487;
	 {
	    obj_t arg1388_1611;
	    arg1388_1611 = SYMBOL_TO_STRING(s_811);
	    {
	       char *aux_2596;
	       aux_2596 = BSTRING_TO_STRING(arg1388_1611);
	       aux_2594 = get_hash_power_number(aux_2596, ((long) 10));
	    }
	 }
	 return BINT(aux_2594);
      }
   }
}


obj_t 
arg13791957_cnst_alloc(obj_t env_2488, obj_t s_2489)
{
   {
      obj_t s_805;
      {
	 long aux_2600;
	 s_805 = s_2489;
	 {
	    char *aux_2601;
	    aux_2601 = BSTRING_TO_STRING(s_805);
	    aux_2600 = get_hash_power_number(aux_2601, ((long) 10));
	 }
	 return BINT(aux_2600);
      }
   }
}


obj_t 
stop_cnst_alloc__36_cnst_alloc()
{
   __compiler_debug__134_engine_param = __old_debug__29_cnst_alloc;
   __string_env__83_cnst_alloc = BUNSPEC;
   __real_env__85_cnst_alloc = BUNSPEC;
   __symbol_env__148_cnst_alloc = BUNSPEC;
   __keyword_env__205_cnst_alloc = BUNSPEC;
   __list_env__66_cnst_alloc = BUNSPEC;
   __vector_env__150_cnst_alloc = BUNSPEC;
   return BTRUE;
}


obj_t 
_stop_cnst_alloc__84_cnst_alloc(obj_t env_2496)
{
   return stop_cnst_alloc__36_cnst_alloc();
}


app_t 
make_cnst_table_ref_93_cnst_alloc(obj_t offset_33, obj_t loc_34)
{
   {
      type_t arg1403_824;
      var_t arg1404_825;
      obj_t arg1406_826;
      arg1403_824 = get_default_type_181_type_cache();
      {
	 type_t arg1408_827;
	 {
	    variable_t obj_1621;
	    obj_1621 = (variable_t) (__cnst_table_ref__15_cnst_cache);
	    arg1408_827 = (((variable_t) CREF(obj_1621))->type);
	 }
	 {
	    var_t res1916_1632;
	    {
	       variable_t variable_1624;
	       variable_1624 = (variable_t) (__cnst_table_ref__15_cnst_cache);
	       {
		  var_t new1133_1625;
		  new1133_1625 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
		  {
		     long arg1876_1626;
		     arg1876_1626 = class_num_218___object(var_ast_node);
		     {
			obj_t obj_1630;
			obj_1630 = (obj_t) (new1133_1625);
			(((obj_t) CREF(obj_1630))->header = MAKE_HEADER(arg1876_1626, 0), BUNSPEC);
		     }
		  }
		  {
		     object_t aux_2614;
		     aux_2614 = (object_t) (new1133_1625);
		     OBJECT_WIDENING_SET(aux_2614, BFALSE);
		  }
		  ((((var_t) CREF(new1133_1625))->loc) = ((obj_t) loc_34), BUNSPEC);
		  ((((var_t) CREF(new1133_1625))->type) = ((type_t) arg1408_827), BUNSPEC);
		  ((((var_t) CREF(new1133_1625))->variable) = ((variable_t) variable_1624), BUNSPEC);
		  res1916_1632 = new1133_1625;
	       }
	    }
	    arg1404_825 = res1916_1632;
	 }
      }
      {
	 atom_t arg1410_828;
	 {
	    type_t arg1414_831;
	    arg1414_831 = get_default_type_181_type_cache();
	    {
	       atom_t res1917_1643;
	       {
		  atom_t new1127_1636;
		  new1127_1636 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
		  {
		     long arg1879_1637;
		     arg1879_1637 = class_num_218___object(atom_ast_node);
		     {
			obj_t obj_1641;
			obj_1641 = (obj_t) (new1127_1636);
			(((obj_t) CREF(obj_1641))->header = MAKE_HEADER(arg1879_1637, 0), BUNSPEC);
		     }
		  }
		  {
		     object_t aux_2625;
		     aux_2625 = (object_t) (new1127_1636);
		     OBJECT_WIDENING_SET(aux_2625, BFALSE);
		  }
		  ((((atom_t) CREF(new1127_1636))->loc) = ((obj_t) loc_34), BUNSPEC);
		  ((((atom_t) CREF(new1127_1636))->type) = ((type_t) arg1414_831), BUNSPEC);
		  ((((atom_t) CREF(new1127_1636))->value) = ((obj_t) offset_33), BUNSPEC);
		  res1917_1643 = new1127_1636;
	       }
	       arg1410_828 = res1917_1643;
	    }
	 }
	 {
	    obj_t list1411_829;
	    {
	       obj_t aux_2631;
	       aux_2631 = (obj_t) (arg1410_828);
	       list1411_829 = MAKE_PAIR(aux_2631, BNIL);
	    }
	    arg1406_826 = list1411_829;
	 }
      }
      {
	 app_t res1918_1661;
	 {
	    app_t new1156_1651;
	    new1156_1651 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg1865_1652;
	       arg1865_1652 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_1659;
		  obj_1659 = (obj_t) (new1156_1651);
		  (((obj_t) CREF(obj_1659))->header = MAKE_HEADER(arg1865_1652, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_2638;
	       aux_2638 = (object_t) (new1156_1651);
	       OBJECT_WIDENING_SET(aux_2638, BFALSE);
	    }
	    ((((app_t) CREF(new1156_1651))->loc) = ((obj_t) loc_34), BUNSPEC);
	    ((((app_t) CREF(new1156_1651))->type) = ((type_t) arg1403_824), BUNSPEC);
	    ((((app_t) CREF(new1156_1651))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
	    ((((app_t) CREF(new1156_1651))->fun) = ((var_t) arg1404_825), BUNSPEC);
	    ((((app_t) CREF(new1156_1651))->args) = ((obj_t) arg1406_826), BUNSPEC);
	    ((((app_t) CREF(new1156_1651))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
	    res1918_1661 = new1156_1651;
	 }
	 return res1918_1661;
      }
   }
}


node_t 
cnst_alloc_string_41_cnst_alloc(obj_t string_35, obj_t loc_36)
{
   {
      {
	 obj_t old_833;
	 {
	    obj_t _andtest_1296_835;
	    _andtest_1296_835 = __shared_cnst___67_engine_param;
	    if (CBOOL(_andtest_1296_835))
	      {
		 old_833 = get_hash_29___hash(string_35, __string_env__83_cnst_alloc);
	      }
	    else
	      {
		 old_833 = BFALSE;
	      }
	 }
	 if (CBOOL(old_833))
	   {
	      {
		 var_t res1919_1675;
		 {
		    type_t type_1666;
		    variable_t variable_1667;
		    type_1666 = (type_t) (__bstring__127_type_cache);
		    {
		       obj_t aux_2653;
		       aux_2653 = STRUCT_REF(old_833, ((long) 1));
		       variable_1667 = (variable_t) (aux_2653);
		    }
		    {
		       var_t new1133_1668;
		       new1133_1668 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
		       {
			  long arg1876_1669;
			  arg1876_1669 = class_num_218___object(var_ast_node);
			  {
			     obj_t obj_1673;
			     obj_1673 = (obj_t) (new1133_1668);
			     (((obj_t) CREF(obj_1673))->header = MAKE_HEADER(arg1876_1669, 0), BUNSPEC);
			  }
		       }
		       {
			  object_t aux_2660;
			  aux_2660 = (object_t) (new1133_1668);
			  OBJECT_WIDENING_SET(aux_2660, BFALSE);
		       }
		       ((((var_t) CREF(new1133_1668))->loc) = ((obj_t) loc_36), BUNSPEC);
		       ((((var_t) CREF(new1133_1668))->type) = ((type_t) type_1666), BUNSPEC);
		       ((((var_t) CREF(new1133_1668))->variable) = ((variable_t) variable_1667), BUNSPEC);
		       res1919_1675 = new1133_1668;
		    }
		 }
		 return (node_t) (res1919_1675);
	      }
	   }
	 else
	   {
	      {
		 var_t aux_2667;
		 {
		    global_t var_837;
		    {
		       obj_t arg1420_840;
		       obj_t arg1421_841;
		       {
			  obj_t arg1424_842;
			  arg1424_842 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 4)), BEOA);
			  {
			     obj_t list1427_844;
			     {
				obj_t arg1428_845;
				{
				   obj_t aux_2671;
				   aux_2671 = CNST_TABLE_REF(((long) 5));
				   arg1428_845 = MAKE_PAIR(aux_2671, BNIL);
				}
				list1427_844 = MAKE_PAIR(arg1424_842, arg1428_845);
			     }
			     arg1420_840 = symbol_append_197___r4_symbols_6_4(list1427_844);
			  }
		       }
		       arg1421_841 = CNST_TABLE_REF(((long) 6));
		       var_837 = def_global_scnst__93_ast_glo_def_117(arg1420_840, __module__166_module_module, string_35, arg1421_841);
		    }
		    if (CBOOL(__shared_cnst___67_engine_param))
		      {
			 obj_t arg1417_838;
			 {
			    obj_t new_1678;
			    {
			       obj_t aux_2680;
			       aux_2680 = CNST_TABLE_REF(((long) 7));
			       new_1678 = create_struct(aux_2680, ((long) 2));
			    }
			    {
			       obj_t aux_2683;
			       aux_2683 = (obj_t) (var_837);
			       STRUCT_SET(new_1678, ((long) 1), aux_2683);
			    }
			    STRUCT_SET(new_1678, ((long) 0), string_35);
			    arg1417_838 = new_1678;
			 }
			 put_hash__129___hash(arg1417_838, __string_env__83_cnst_alloc);
		      }
		    else
		      {
			 BUNSPEC;
		      }
		    {
		       type_t arg1418_839;
		       {
			  variable_t obj_1691;
			  obj_1691 = (variable_t) (var_837);
			  arg1418_839 = (((variable_t) CREF(obj_1691))->type);
		       }
		       {
			  var_t res1920_1702;
			  {
			     variable_t variable_1694;
			     variable_1694 = (variable_t) (var_837);
			     {
				var_t new1133_1695;
				new1133_1695 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				{
				   long arg1876_1696;
				   arg1876_1696 = class_num_218___object(var_ast_node);
				   {
				      obj_t obj_1700;
				      obj_1700 = (obj_t) (new1133_1695);
				      (((obj_t) CREF(obj_1700))->header = MAKE_HEADER(arg1876_1696, 0), BUNSPEC);
				   }
				}
				{
				   object_t aux_2695;
				   aux_2695 = (object_t) (new1133_1695);
				   OBJECT_WIDENING_SET(aux_2695, BFALSE);
				}
				((((var_t) CREF(new1133_1695))->loc) = ((obj_t) loc_36), BUNSPEC);
				((((var_t) CREF(new1133_1695))->type) = ((type_t) arg1418_839), BUNSPEC);
				((((var_t) CREF(new1133_1695))->variable) = ((variable_t) variable_1694), BUNSPEC);
				res1920_1702 = new1133_1695;
			     }
			  }
			  aux_2667 = res1920_1702;
		       }
		    }
		 }
		 return (node_t) (aux_2667);
	      }
	   }
      }
   }
}


obj_t 
_cnst_alloc_string_253_cnst_alloc(obj_t env_2497, obj_t string_2498, obj_t loc_2499)
{
   {
      node_t aux_2702;
      aux_2702 = cnst_alloc_string_41_cnst_alloc(string_2498, loc_2499);
      return (obj_t) (aux_2702);
   }
}


node_t 
cnst_alloc_symbol_123_cnst_alloc(obj_t symbol_37, obj_t loc_38)
{
   {
      {
	 obj_t old_851;
	 obj_t symbol_as_string_235_852;
	 old_851 = get_hash_29___hash(symbol_37, __symbol_env__148_cnst_alloc);
	 symbol_as_string_235_852 = SYMBOL_TO_STRING(symbol_37);
	 if (CBOOL(old_851))
	   {
	      {
		 bool_t test1433_853;
		 {
		    obj_t obj1_1704;
		    obj1_1704 = _n_o_f_u_c_k_i_n_g___init_or_fini__init_mode__183_engine_param;
		    {
		       obj_t aux_2709;
		       aux_2709 = CNST_TABLE_REF(((long) 13));
		       test1433_853 = (obj1_1704 == aux_2709);
		    }
		 }
		 if (test1433_853)
		   {
		      type_t arg1440_854;
		      obj_t arg1441_855;
		      arg1440_854 = get_default_type_181_type_cache();
		      arg1441_855 = STRUCT_REF(old_851, ((long) 1));
		      {
			 var_t res1921_1719;
			 {
			    variable_t variable_1711;
			    variable_1711 = (variable_t) (arg1441_855);
			    {
			       var_t new1133_1712;
			       new1133_1712 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
			       {
				  long arg1876_1713;
				  arg1876_1713 = class_num_218___object(var_ast_node);
				  {
				     obj_t obj_1717;
				     obj_1717 = (obj_t) (new1133_1712);
				     (((obj_t) CREF(obj_1717))->header = MAKE_HEADER(arg1876_1713, 0), BUNSPEC);
				  }
			       }
			       {
				  object_t aux_2720;
				  aux_2720 = (object_t) (new1133_1712);
				  OBJECT_WIDENING_SET(aux_2720, BFALSE);
			       }
			       ((((var_t) CREF(new1133_1712))->loc) = ((obj_t) loc_38), BUNSPEC);
			       ((((var_t) CREF(new1133_1712))->type) = ((type_t) arg1440_854), BUNSPEC);
			       ((((var_t) CREF(new1133_1712))->variable) = ((variable_t) variable_1711), BUNSPEC);
			       res1921_1719 = new1133_1712;
			    }
			 }
			 return (node_t) (res1921_1719);
		      }
		   }
		 else
		   {
		      app_t aux_2727;
		      aux_2727 = make_cnst_table_ref_93_cnst_alloc(STRUCT_REF(old_851, ((long) 1)), loc_38);
		      return (node_t) (aux_2727);
		   }
	      }
	   }
	 else
	   {
	      bool_t test1446_858;
	      {
		 bool_t test1447_859;
		 {
		    obj_t obj1_1723;
		    obj1_1723 = _n_o_f_u_c_k_i_n_g___init_or_fini__init_mode__183_engine_param;
		    {
		       obj_t aux_2731;
		       aux_2731 = CNST_TABLE_REF(((long) 13));
		       test1447_859 = (obj1_1723 == aux_2731);
		    }
		 }
		 if (test1447_859)
		   {
		      test1446_858 = ((bool_t) 1);
		   }
		 else
		   {
		      bool_t test_2735;
		      {
			 long aux_2736;
			 aux_2736 = STRING_LENGTH(symbol_as_string_235_852);
			 test_2735 = (aux_2736 == ((long) 0));
		      }
		      if (test_2735)
			{
			   test1446_858 = ((bool_t) 1);
			}
		      else
			{
			   unsigned char aux_2739;
			   aux_2739 = STRING_REF(symbol_as_string_235_852, ((long) 0));
			   test1446_858 = (aux_2739 == ((unsigned char) ';'));
			}
		   }
	      }
	      if (test1446_858)
		{
		   {
		      var_t aux_2743;
		      {
			 global_t var_869;
			 {
			    obj_t arg1497_896;
			    obj_t arg1498_897;
			    obj_t arg1499_898;
			    {
			       obj_t arg1500_899;
			       arg1500_899 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 8)), BEOA);
			       {
				  obj_t list1502_901;
				  {
				     obj_t arg1505_902;
				     {
					obj_t aux_2747;
					aux_2747 = CNST_TABLE_REF(((long) 9));
					arg1505_902 = MAKE_PAIR(aux_2747, BNIL);
				     }
				     list1502_901 = MAKE_PAIR(arg1500_899, arg1505_902);
				  }
				  arg1497_896 = symbol_append_197___r4_symbols_6_4(list1502_901);
			       }
			    }
			    arg1498_897 = CNST_TABLE_REF(((long) 10));
			    arg1499_898 = CNST_TABLE_REF(((long) 3));
			    var_869 = def_global_svar__184_ast_glo_def_117(arg1497_896, __module__166_module_module, arg1498_897, arg1499_898);
			 }
			 {
			    obj_t arg1461_870;
			    {
			       obj_t new_1753;
			       {
				  obj_t aux_2755;
				  aux_2755 = CNST_TABLE_REF(((long) 7));
				  new_1753 = create_struct(aux_2755, ((long) 2));
			       }
			       {
				  obj_t aux_2758;
				  aux_2758 = (obj_t) (var_869);
				  STRUCT_SET(new_1753, ((long) 1), aux_2758);
			       }
			       STRUCT_SET(new_1753, ((long) 0), symbol_37);
			       arg1461_870 = new_1753;
			    }
			    put_hash__129___hash(arg1461_870, __symbol_env__148_cnst_alloc);
			 }
			 {
			    obj_t arg1463_871;
			    {
			       obj_t arg1465_872;
			       obj_t arg1466_873;
			       node_t arg1467_874;
			       arg1465_872 = CNST_TABLE_REF(((long) 11));
			       {
				  obj_t arg1474_880;
				  obj_t arg1476_881;
				  obj_t arg1477_882;
				  arg1474_880 = CNST_TABLE_REF(((long) 12));
				  arg1476_881 = (((global_t) CREF(var_869))->id);
				  arg1477_882 = (((global_t) CREF(var_869))->module);
				  {
				     obj_t list1479_884;
				     {
					obj_t arg1480_885;
					{
					   obj_t arg1481_886;
					   arg1481_886 = MAKE_PAIR(BNIL, BNIL);
					   arg1480_885 = MAKE_PAIR(arg1477_882, arg1481_886);
					}
					list1479_884 = MAKE_PAIR(arg1476_881, arg1480_885);
				     }
				     arg1466_873 = cons__138___r4_pairs_and_lists_6_3(arg1474_880, list1479_884);
				  }
			       }
			       {
				  app_t arg1485_888;
				  {
				     var_t arg1486_889;
				     obj_t arg1487_890;
				     {
					var_t res1922_1778;
					{
					   type_t type_1769;
					   variable_t variable_1770;
					   type_1769 = (type_t) (__symbol__163_type_cache);
					   variable_1770 = (variable_t) (__string__symbol__115_cnst_cache);
					   {
					      var_t new1133_1771;
					      new1133_1771 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
					      {
						 long arg1876_1772;
						 arg1876_1772 = class_num_218___object(var_ast_node);
						 {
						    obj_t obj_1776;
						    obj_1776 = (obj_t) (new1133_1771);
						    (((obj_t) CREF(obj_1776))->header = MAKE_HEADER(arg1876_1772, 0), BUNSPEC);
						 }
					      }
					      {
						 object_t aux_2777;
						 aux_2777 = (object_t) (new1133_1771);
						 OBJECT_WIDENING_SET(aux_2777, BFALSE);
					      }
					      ((((var_t) CREF(new1133_1771))->loc) = ((obj_t) loc_38), BUNSPEC);
					      ((((var_t) CREF(new1133_1771))->type) = ((type_t) type_1769), BUNSPEC);
					      ((((var_t) CREF(new1133_1771))->variable) = ((variable_t) variable_1770), BUNSPEC);
					      res1922_1778 = new1133_1771;
					   }
					}
					arg1486_889 = res1922_1778;
				     }
				     {
					atom_t arg1489_891;
					{
					   obj_t arg1494_894;
					   arg1494_894 = SYMBOL_TO_STRING(symbol_37);
					   {
					      atom_t res1923_1790;
					      {
						 type_t type_1781;
						 type_1781 = (type_t) (__string__3_type_cache);
						 {
						    atom_t new1127_1783;
						    new1127_1783 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
						    {
						       long arg1879_1784;
						       arg1879_1784 = class_num_218___object(atom_ast_node);
						       {
							  obj_t obj_1788;
							  obj_1788 = (obj_t) (new1127_1783);
							  (((obj_t) CREF(obj_1788))->header = MAKE_HEADER(arg1879_1784, 0), BUNSPEC);
						       }
						    }
						    {
						       object_t aux_2789;
						       aux_2789 = (object_t) (new1127_1783);
						       OBJECT_WIDENING_SET(aux_2789, BFALSE);
						    }
						    ((((atom_t) CREF(new1127_1783))->loc) = ((obj_t) loc_38), BUNSPEC);
						    ((((atom_t) CREF(new1127_1783))->type) = ((type_t) type_1781), BUNSPEC);
						    ((((atom_t) CREF(new1127_1783))->value) = ((obj_t) arg1494_894), BUNSPEC);
						    res1923_1790 = new1127_1783;
						 }
					      }
					      arg1489_891 = res1923_1790;
					   }
					}
					{
					   obj_t list1490_892;
					   {
					      obj_t aux_2795;
					      aux_2795 = (obj_t) (arg1489_891);
					      list1490_892 = MAKE_PAIR(aux_2795, BNIL);
					   }
					   arg1487_890 = list1490_892;
					}
				     }
				     {
					app_t res1924_1808;
					{
					   type_t type_1793;
					   type_1793 = (type_t) (__symbol__163_type_cache);
					   {
					      app_t new1156_1798;
					      new1156_1798 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
					      {
						 long arg1865_1799;
						 arg1865_1799 = class_num_218___object(app_ast_node);
						 {
						    obj_t obj_1806;
						    obj_1806 = (obj_t) (new1156_1798);
						    (((obj_t) CREF(obj_1806))->header = MAKE_HEADER(arg1865_1799, 0), BUNSPEC);
						 }
					      }
					      {
						 object_t aux_2803;
						 aux_2803 = (object_t) (new1156_1798);
						 OBJECT_WIDENING_SET(aux_2803, BFALSE);
					      }
					      ((((app_t) CREF(new1156_1798))->loc) = ((obj_t) loc_38), BUNSPEC);
					      ((((app_t) CREF(new1156_1798))->type) = ((type_t) type_1793), BUNSPEC);
					      ((((app_t) CREF(new1156_1798))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
					      ((((app_t) CREF(new1156_1798))->fun) = ((var_t) arg1486_889), BUNSPEC);
					      ((((app_t) CREF(new1156_1798))->args) = ((obj_t) arg1487_890), BUNSPEC);
					      ((((app_t) CREF(new1156_1798))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
					      res1924_1808 = new1156_1798;
					   }
					}
					arg1485_888 = res1924_1808;
				     }
				  }
				  arg1467_874 = coerce__182_coerce_coerce((node_t) (arg1485_888), (type_t) (__obj__252_type_cache));
			       }
			       {
				  obj_t list1469_876;
				  {
				     obj_t arg1470_877;
				     {
					obj_t arg1471_878;
					arg1471_878 = MAKE_PAIR(BNIL, BNIL);
					{
					   obj_t aux_2816;
					   aux_2816 = (obj_t) (arg1467_874);
					   arg1470_877 = MAKE_PAIR(aux_2816, arg1471_878);
					}
				     }
				     list1469_876 = MAKE_PAIR(arg1466_873, arg1470_877);
				  }
				  arg1463_871 = cons__138___r4_pairs_and_lists_6_3(arg1465_872, list1469_876);
			       }
			    }
			    {
			       obj_t obj2_1811;
			       obj2_1811 = __global_sexp__67_cnst_alloc;
			       __global_sexp__67_cnst_alloc = MAKE_PAIR(arg1463_871, obj2_1811);
			    }
			 }
			 {
			    type_t arg1496_895;
			    {
			       variable_t obj_1812;
			       obj_1812 = (variable_t) (var_869);
			       arg1496_895 = (((variable_t) CREF(obj_1812))->type);
			    }
			    {
			       var_t res1925_1823;
			       {
				  variable_t variable_1815;
				  variable_1815 = (variable_t) (var_869);
				  {
				     var_t new1133_1816;
				     new1133_1816 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				     {
					long arg1876_1817;
					arg1876_1817 = class_num_218___object(var_ast_node);
					{
					   obj_t obj_1821;
					   obj_1821 = (obj_t) (new1133_1816);
					   (((obj_t) CREF(obj_1821))->header = MAKE_HEADER(arg1876_1817, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_2829;
					aux_2829 = (object_t) (new1133_1816);
					OBJECT_WIDENING_SET(aux_2829, BFALSE);
				     }
				     ((((var_t) CREF(new1133_1816))->loc) = ((obj_t) loc_38), BUNSPEC);
				     ((((var_t) CREF(new1133_1816))->type) = ((type_t) arg1496_895), BUNSPEC);
				     ((((var_t) CREF(new1133_1816))->variable) = ((variable_t) variable_1815), BUNSPEC);
				     res1925_1823 = new1133_1816;
				  }
			       }
			       aux_2743 = res1925_1823;
			    }
			 }
		      }
		      return (node_t) (aux_2743);
		   }
		}
	      else
		{
		   {
		      app_t aux_2836;
		      {
			 long offset_866;
			 offset_866 = __cnst_offset__211_cnst_alloc;
			 {
			    long z2_1733;
			    z2_1733 = __cnst_offset__211_cnst_alloc;
			    __cnst_offset__211_cnst_alloc = (((long) 1) + z2_1733);
			 }
			 {
			    obj_t obj2_1735;
			    obj2_1735 = __global_set__17_cnst_alloc;
			    __global_set__17_cnst_alloc = MAKE_PAIR(symbol_37, obj2_1735);
			 }
			 {
			    obj_t arg1457_867;
			    {
			       obj_t new_1738;
			       {
				  obj_t aux_2839;
				  aux_2839 = CNST_TABLE_REF(((long) 7));
				  new_1738 = create_struct(aux_2839, ((long) 2));
			       }
			       {
				  obj_t aux_2842;
				  aux_2842 = BINT(offset_866);
				  STRUCT_SET(new_1738, ((long) 1), aux_2842);
			       }
			       STRUCT_SET(new_1738, ((long) 0), symbol_37);
			       arg1457_867 = new_1738;
			    }
			    put_hash__129___hash(arg1457_867, __symbol_env__148_cnst_alloc);
			 }
			 aux_2836 = make_cnst_table_ref_93_cnst_alloc(BINT(offset_866), loc_38);
		      }
		      return (node_t) (aux_2836);
		   }
		}
	   }
      }
   }
}


obj_t 
_cnst_alloc_symbol_92_cnst_alloc(obj_t env_2500, obj_t symbol_2501, obj_t loc_2502)
{
   {
      node_t aux_2850;
      aux_2850 = cnst_alloc_symbol_123_cnst_alloc(symbol_2501, loc_2502);
      return (obj_t) (aux_2850);
   }
}


node_t 
cnst_alloc_keyword_47_cnst_alloc(obj_t keyword_39, obj_t loc_40)
{
   {
      {
	 obj_t old_909;
	 obj_t keyword_as_string_123_910;
	 old_909 = get_hash_29___hash(keyword_39, __keyword_env__205_cnst_alloc);
	 keyword_as_string_123_910 = KEYWORD_TO_STRING(keyword_39);
	 if (CBOOL(old_909))
	   {
	      {
		 bool_t test1508_911;
		 {
		    obj_t obj1_1825;
		    obj1_1825 = _n_o_f_u_c_k_i_n_g___init_or_fini__init_mode__183_engine_param;
		    {
		       obj_t aux_2857;
		       aux_2857 = CNST_TABLE_REF(((long) 13));
		       test1508_911 = (obj1_1825 == aux_2857);
		    }
		 }
		 if (test1508_911)
		   {
		      type_t arg1509_912;
		      obj_t arg1510_913;
		      arg1509_912 = get_default_type_181_type_cache();
		      arg1510_913 = STRUCT_REF(old_909, ((long) 1));
		      {
			 var_t res1926_1840;
			 {
			    variable_t variable_1832;
			    variable_1832 = (variable_t) (arg1510_913);
			    {
			       var_t new1133_1833;
			       new1133_1833 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
			       {
				  long arg1876_1834;
				  arg1876_1834 = class_num_218___object(var_ast_node);
				  {
				     obj_t obj_1838;
				     obj_1838 = (obj_t) (new1133_1833);
				     (((obj_t) CREF(obj_1838))->header = MAKE_HEADER(arg1876_1834, 0), BUNSPEC);
				  }
			       }
			       {
				  object_t aux_2868;
				  aux_2868 = (object_t) (new1133_1833);
				  OBJECT_WIDENING_SET(aux_2868, BFALSE);
			       }
			       ((((var_t) CREF(new1133_1833))->loc) = ((obj_t) loc_40), BUNSPEC);
			       ((((var_t) CREF(new1133_1833))->type) = ((type_t) arg1509_912), BUNSPEC);
			       ((((var_t) CREF(new1133_1833))->variable) = ((variable_t) variable_1832), BUNSPEC);
			       res1926_1840 = new1133_1833;
			    }
			 }
			 return (node_t) (res1926_1840);
		      }
		   }
		 else
		   {
		      app_t aux_2875;
		      aux_2875 = make_cnst_table_ref_93_cnst_alloc(STRUCT_REF(old_909, ((long) 1)), loc_40);
		      return (node_t) (aux_2875);
		   }
	      }
	   }
	 else
	   {
	      bool_t test1514_916;
	      {
		 bool_t test1515_917;
		 {
		    obj_t obj1_1844;
		    obj1_1844 = _n_o_f_u_c_k_i_n_g___init_or_fini__init_mode__183_engine_param;
		    {
		       obj_t aux_2879;
		       aux_2879 = CNST_TABLE_REF(((long) 13));
		       test1515_917 = (obj1_1844 == aux_2879);
		    }
		 }
		 if (test1515_917)
		   {
		      test1514_916 = ((bool_t) 1);
		   }
		 else
		   {
		      bool_t test_2883;
		      {
			 long aux_2884;
			 aux_2884 = STRING_LENGTH(keyword_as_string_123_910);
			 test_2883 = (aux_2884 == ((long) 0));
		      }
		      if (test_2883)
			{
			   test1514_916 = ((bool_t) 1);
			}
		      else
			{
			   unsigned char aux_2887;
			   aux_2887 = STRING_REF(keyword_as_string_123_910, ((long) 0));
			   test1514_916 = (aux_2887 == ((unsigned char) ';'));
			}
		   }
	      }
	      if (test1514_916)
		{
		   {
		      var_t aux_2891;
		      {
			 global_t var_927;
			 {
			    obj_t arg1561_954;
			    obj_t arg1562_955;
			    obj_t arg1563_956;
			    {
			       obj_t arg1564_957;
			       arg1564_957 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 14)), BEOA);
			       {
				  obj_t list1566_959;
				  {
				     obj_t arg1567_960;
				     {
					obj_t aux_2895;
					aux_2895 = CNST_TABLE_REF(((long) 15));
					arg1567_960 = MAKE_PAIR(aux_2895, BNIL);
				     }
				     list1566_959 = MAKE_PAIR(arg1564_957, arg1567_960);
				  }
				  arg1561_954 = symbol_append_197___r4_symbols_6_4(list1566_959);
			       }
			    }
			    arg1562_955 = CNST_TABLE_REF(((long) 16));
			    arg1563_956 = CNST_TABLE_REF(((long) 3));
			    var_927 = def_global_svar__184_ast_glo_def_117(arg1561_954, __module__166_module_module, arg1562_955, arg1563_956);
			 }
			 {
			    obj_t arg1526_928;
			    {
			       obj_t new_1874;
			       {
				  obj_t aux_2903;
				  aux_2903 = CNST_TABLE_REF(((long) 7));
				  new_1874 = create_struct(aux_2903, ((long) 2));
			       }
			       {
				  obj_t aux_2906;
				  aux_2906 = (obj_t) (var_927);
				  STRUCT_SET(new_1874, ((long) 1), aux_2906);
			       }
			       STRUCT_SET(new_1874, ((long) 0), keyword_39);
			       arg1526_928 = new_1874;
			    }
			    put_hash__129___hash(arg1526_928, __keyword_env__205_cnst_alloc);
			 }
			 {
			    obj_t arg1529_929;
			    {
			       obj_t arg1531_930;
			       obj_t arg1532_931;
			       node_t arg1534_932;
			       arg1531_930 = CNST_TABLE_REF(((long) 11));
			       {
				  obj_t arg1540_938;
				  obj_t arg1541_939;
				  obj_t arg1542_940;
				  arg1540_938 = CNST_TABLE_REF(((long) 12));
				  arg1541_939 = (((global_t) CREF(var_927))->id);
				  arg1542_940 = (((global_t) CREF(var_927))->module);
				  {
				     obj_t list1544_942;
				     {
					obj_t arg1547_943;
					{
					   obj_t arg1549_944;
					   arg1549_944 = MAKE_PAIR(BNIL, BNIL);
					   arg1547_943 = MAKE_PAIR(arg1542_940, arg1549_944);
					}
					list1544_942 = MAKE_PAIR(arg1541_939, arg1547_943);
				     }
				     arg1532_931 = cons__138___r4_pairs_and_lists_6_3(arg1540_938, list1544_942);
				  }
			       }
			       {
				  app_t arg1551_946;
				  {
				     var_t arg1552_947;
				     obj_t arg1553_948;
				     {
					var_t res1927_1899;
					{
					   type_t type_1890;
					   variable_t variable_1891;
					   type_1890 = (type_t) (__keyword__63_type_cache);
					   variable_1891 = (variable_t) (__string__keyword__251_cnst_cache);
					   {
					      var_t new1133_1892;
					      new1133_1892 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
					      {
						 long arg1876_1893;
						 arg1876_1893 = class_num_218___object(var_ast_node);
						 {
						    obj_t obj_1897;
						    obj_1897 = (obj_t) (new1133_1892);
						    (((obj_t) CREF(obj_1897))->header = MAKE_HEADER(arg1876_1893, 0), BUNSPEC);
						 }
					      }
					      {
						 object_t aux_2925;
						 aux_2925 = (object_t) (new1133_1892);
						 OBJECT_WIDENING_SET(aux_2925, BFALSE);
					      }
					      ((((var_t) CREF(new1133_1892))->loc) = ((obj_t) loc_40), BUNSPEC);
					      ((((var_t) CREF(new1133_1892))->type) = ((type_t) type_1890), BUNSPEC);
					      ((((var_t) CREF(new1133_1892))->variable) = ((variable_t) variable_1891), BUNSPEC);
					      res1927_1899 = new1133_1892;
					   }
					}
					arg1552_947 = res1927_1899;
				     }
				     {
					atom_t arg1554_949;
					{
					   obj_t arg1559_952;
					   arg1559_952 = KEYWORD_TO_STRING(keyword_39);
					   {
					      atom_t res1928_1911;
					      {
						 type_t type_1902;
						 type_1902 = (type_t) (__string__3_type_cache);
						 {
						    atom_t new1127_1904;
						    new1127_1904 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
						    {
						       long arg1879_1905;
						       arg1879_1905 = class_num_218___object(atom_ast_node);
						       {
							  obj_t obj_1909;
							  obj_1909 = (obj_t) (new1127_1904);
							  (((obj_t) CREF(obj_1909))->header = MAKE_HEADER(arg1879_1905, 0), BUNSPEC);
						       }
						    }
						    {
						       object_t aux_2937;
						       aux_2937 = (object_t) (new1127_1904);
						       OBJECT_WIDENING_SET(aux_2937, BFALSE);
						    }
						    ((((atom_t) CREF(new1127_1904))->loc) = ((obj_t) loc_40), BUNSPEC);
						    ((((atom_t) CREF(new1127_1904))->type) = ((type_t) type_1902), BUNSPEC);
						    ((((atom_t) CREF(new1127_1904))->value) = ((obj_t) arg1559_952), BUNSPEC);
						    res1928_1911 = new1127_1904;
						 }
					      }
					      arg1554_949 = res1928_1911;
					   }
					}
					{
					   obj_t list1555_950;
					   {
					      obj_t aux_2943;
					      aux_2943 = (obj_t) (arg1554_949);
					      list1555_950 = MAKE_PAIR(aux_2943, BNIL);
					   }
					   arg1553_948 = list1555_950;
					}
				     }
				     {
					app_t res1929_1929;
					{
					   type_t type_1914;
					   type_1914 = (type_t) (__keyword__63_type_cache);
					   {
					      app_t new1156_1919;
					      new1156_1919 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
					      {
						 long arg1865_1920;
						 arg1865_1920 = class_num_218___object(app_ast_node);
						 {
						    obj_t obj_1927;
						    obj_1927 = (obj_t) (new1156_1919);
						    (((obj_t) CREF(obj_1927))->header = MAKE_HEADER(arg1865_1920, 0), BUNSPEC);
						 }
					      }
					      {
						 object_t aux_2951;
						 aux_2951 = (object_t) (new1156_1919);
						 OBJECT_WIDENING_SET(aux_2951, BFALSE);
					      }
					      ((((app_t) CREF(new1156_1919))->loc) = ((obj_t) loc_40), BUNSPEC);
					      ((((app_t) CREF(new1156_1919))->type) = ((type_t) type_1914), BUNSPEC);
					      ((((app_t) CREF(new1156_1919))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
					      ((((app_t) CREF(new1156_1919))->fun) = ((var_t) arg1552_947), BUNSPEC);
					      ((((app_t) CREF(new1156_1919))->args) = ((obj_t) arg1553_948), BUNSPEC);
					      ((((app_t) CREF(new1156_1919))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
					      res1929_1929 = new1156_1919;
					   }
					}
					arg1551_946 = res1929_1929;
				     }
				  }
				  arg1534_932 = coerce__182_coerce_coerce((node_t) (arg1551_946), (type_t) (__obj__252_type_cache));
			       }
			       {
				  obj_t list1536_934;
				  {
				     obj_t arg1537_935;
				     {
					obj_t arg1538_936;
					arg1538_936 = MAKE_PAIR(BNIL, BNIL);
					{
					   obj_t aux_2964;
					   aux_2964 = (obj_t) (arg1534_932);
					   arg1537_935 = MAKE_PAIR(aux_2964, arg1538_936);
					}
				     }
				     list1536_934 = MAKE_PAIR(arg1532_931, arg1537_935);
				  }
				  arg1529_929 = cons__138___r4_pairs_and_lists_6_3(arg1531_930, list1536_934);
			       }
			    }
			    {
			       obj_t obj2_1932;
			       obj2_1932 = __global_sexp__67_cnst_alloc;
			       __global_sexp__67_cnst_alloc = MAKE_PAIR(arg1529_929, obj2_1932);
			    }
			 }
			 {
			    type_t arg1560_953;
			    {
			       variable_t obj_1933;
			       obj_1933 = (variable_t) (var_927);
			       arg1560_953 = (((variable_t) CREF(obj_1933))->type);
			    }
			    {
			       var_t res1930_1944;
			       {
				  variable_t variable_1936;
				  variable_1936 = (variable_t) (var_927);
				  {
				     var_t new1133_1937;
				     new1133_1937 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				     {
					long arg1876_1938;
					arg1876_1938 = class_num_218___object(var_ast_node);
					{
					   obj_t obj_1942;
					   obj_1942 = (obj_t) (new1133_1937);
					   (((obj_t) CREF(obj_1942))->header = MAKE_HEADER(arg1876_1938, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_2977;
					aux_2977 = (object_t) (new1133_1937);
					OBJECT_WIDENING_SET(aux_2977, BFALSE);
				     }
				     ((((var_t) CREF(new1133_1937))->loc) = ((obj_t) loc_40), BUNSPEC);
				     ((((var_t) CREF(new1133_1937))->type) = ((type_t) arg1560_953), BUNSPEC);
				     ((((var_t) CREF(new1133_1937))->variable) = ((variable_t) variable_1936), BUNSPEC);
				     res1930_1944 = new1133_1937;
				  }
			       }
			       aux_2891 = res1930_1944;
			    }
			 }
		      }
		      return (node_t) (aux_2891);
		   }
		}
	      else
		{
		   {
		      app_t aux_2984;
		      {
			 long offset_924;
			 offset_924 = __cnst_offset__211_cnst_alloc;
			 {
			    long z2_1854;
			    z2_1854 = __cnst_offset__211_cnst_alloc;
			    __cnst_offset__211_cnst_alloc = (((long) 1) + z2_1854);
			 }
			 {
			    obj_t obj2_1856;
			    obj2_1856 = __global_set__17_cnst_alloc;
			    __global_set__17_cnst_alloc = MAKE_PAIR(keyword_39, obj2_1856);
			 }
			 {
			    obj_t arg1524_925;
			    {
			       obj_t new_1859;
			       {
				  obj_t aux_2987;
				  aux_2987 = CNST_TABLE_REF(((long) 7));
				  new_1859 = create_struct(aux_2987, ((long) 2));
			       }
			       {
				  obj_t aux_2990;
				  aux_2990 = BINT(offset_924);
				  STRUCT_SET(new_1859, ((long) 1), aux_2990);
			       }
			       STRUCT_SET(new_1859, ((long) 0), keyword_39);
			       arg1524_925 = new_1859;
			    }
			    put_hash__129___hash(arg1524_925, __keyword_env__205_cnst_alloc);
			 }
			 aux_2984 = make_cnst_table_ref_93_cnst_alloc(BINT(offset_924), loc_40);
		      }
		      return (node_t) (aux_2984);
		   }
		}
	   }
      }
   }
}


obj_t 
_cnst_alloc_keyword_183_cnst_alloc(obj_t env_2503, obj_t keyword_2504, obj_t loc_2505)
{
   {
      node_t aux_2998;
      aux_2998 = cnst_alloc_keyword_47_cnst_alloc(keyword_2504, loc_2505);
      return (obj_t) (aux_2998);
   }
}


node_t 
cnst_alloc_procedure_240_cnst_alloc(node_t procedure_41, obj_t loc_42)
{
   {
      global_t var_965;
      {
	 obj_t arg1572_967;
	 obj_t arg1573_968;
	 {
	    obj_t arg1574_969;
	    arg1574_969 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 17)), BEOA);
	    {
	       obj_t list1576_971;
	       {
		  obj_t arg1577_972;
		  {
		     obj_t aux_3004;
		     aux_3004 = CNST_TABLE_REF(((long) 18));
		     arg1577_972 = MAKE_PAIR(aux_3004, BNIL);
		  }
		  list1576_971 = MAKE_PAIR(arg1574_969, arg1577_972);
	       }
	       arg1572_967 = symbol_append_197___r4_symbols_6_4(list1576_971);
	    }
	 }
	 arg1573_968 = CNST_TABLE_REF(((long) 19));
	 var_965 = def_global_scnst__93_ast_glo_def_117(arg1572_967, __module__166_module_module, (obj_t) (procedure_41), arg1573_968);
      }
      {
	 type_t arg1571_966;
	 {
	    variable_t obj_1945;
	    obj_1945 = (variable_t) (var_965);
	    arg1571_966 = (((variable_t) CREF(obj_1945))->type);
	 }
	 {
	    var_t res1931_1956;
	    {
	       variable_t variable_1948;
	       variable_1948 = (variable_t) (var_965);
	       {
		  var_t new1133_1949;
		  new1133_1949 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
		  {
		     long arg1876_1950;
		     arg1876_1950 = class_num_218___object(var_ast_node);
		     {
			obj_t obj_1954;
			obj_1954 = (obj_t) (new1133_1949);
			(((obj_t) CREF(obj_1954))->header = MAKE_HEADER(arg1876_1950, 0), BUNSPEC);
		     }
		  }
		  {
		     object_t aux_3019;
		     aux_3019 = (object_t) (new1133_1949);
		     OBJECT_WIDENING_SET(aux_3019, BFALSE);
		  }
		  ((((var_t) CREF(new1133_1949))->loc) = ((obj_t) loc_42), BUNSPEC);
		  ((((var_t) CREF(new1133_1949))->type) = ((type_t) arg1571_966), BUNSPEC);
		  ((((var_t) CREF(new1133_1949))->variable) = ((variable_t) variable_1948), BUNSPEC);
		  res1931_1956 = new1133_1949;
	       }
	    }
	    return (node_t) (res1931_1956);
	 }
      }
   }
}


obj_t 
_cnst_alloc_procedure_221_cnst_alloc(obj_t env_2506, obj_t procedure_2507, obj_t loc_2508)
{
   {
      node_t aux_3026;
      aux_3026 = cnst_alloc_procedure_240_cnst_alloc((node_t) (procedure_2507), loc_2508);
      return (obj_t) (aux_3026);
   }
}


node_t 
cnst_alloc_real_118_cnst_alloc(obj_t real_43, obj_t loc_44)
{
   {
      {
	 obj_t old_977;
	 {
	    obj_t list_980;
	    list_980 = __real_env__85_cnst_alloc;
	  loop_981:
	    if (NULLP(list_980))
	      {
		 old_977 = BFALSE;
	      }
	    else
	      {
		 bool_t test_3032;
		 {
		    double aux_3039;
		    double aux_3033;
		    aux_3039 = REAL_TO_DOUBLE(real_43);
		    {
		       obj_t aux_3034;
		       {
			  obj_t aux_3035;
			  aux_3035 = CAR(list_980);
			  aux_3034 = CAR(aux_3035);
		       }
		       aux_3033 = REAL_TO_DOUBLE(aux_3034);
		    }
		    test_3032 = (aux_3033 == aux_3039);
		 }
		 if (test_3032)
		   {
		      {
			 obj_t aux_3042;
			 aux_3042 = CAR(list_980);
			 old_977 = CDR(aux_3042);
		      }
		   }
		 else
		   {
		      {
			 obj_t list_3045;
			 list_3045 = CDR(list_980);
			 list_980 = list_3045;
			 goto loop_981;
		      }
		   }
	      }
	 }
	 if (CBOOL(old_977))
	   {
	      {
		 type_t arg1582_978;
		 {
		    variable_t obj_1957;
		    obj_1957 = (variable_t) (old_977);
		    arg1582_978 = (((variable_t) CREF(obj_1957))->type);
		 }
		 {
		    var_t res1932_1968;
		    {
		       variable_t variable_1960;
		       variable_1960 = (variable_t) (old_977);
		       {
			  var_t new1133_1961;
			  new1133_1961 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
			  {
			     long arg1876_1962;
			     arg1876_1962 = class_num_218___object(var_ast_node);
			     {
				obj_t obj_1966;
				obj_1966 = (obj_t) (new1133_1961);
				(((obj_t) CREF(obj_1966))->header = MAKE_HEADER(arg1876_1962, 0), BUNSPEC);
			     }
			  }
			  {
			     object_t aux_3056;
			     aux_3056 = (object_t) (new1133_1961);
			     OBJECT_WIDENING_SET(aux_3056, BFALSE);
			  }
			  ((((var_t) CREF(new1133_1961))->loc) = ((obj_t) loc_44), BUNSPEC);
			  ((((var_t) CREF(new1133_1961))->type) = ((type_t) arg1582_978), BUNSPEC);
			  ((((var_t) CREF(new1133_1961))->variable) = ((variable_t) variable_1960), BUNSPEC);
			  res1932_1968 = new1133_1961;
		       }
		    }
		    return (node_t) (res1932_1968);
		 }
	      }
	   }
	 else
	   {
	      {
		 var_t aux_3063;
		 {
		    global_t var_989;
		    {
		       obj_t arg1595_992;
		       obj_t arg1596_993;
		       {
			  obj_t arg1597_994;
			  arg1597_994 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 20)), BEOA);
			  {
			     obj_t list1601_996;
			     {
				obj_t arg1603_997;
				{
				   obj_t aux_3067;
				   aux_3067 = CNST_TABLE_REF(((long) 21));
				   arg1603_997 = MAKE_PAIR(aux_3067, BNIL);
				}
				list1601_996 = MAKE_PAIR(arg1597_994, arg1603_997);
			     }
			     arg1595_992 = symbol_append_197___r4_symbols_6_4(list1601_996);
			  }
		       }
		       arg1596_993 = CNST_TABLE_REF(((long) 22));
		       var_989 = def_global_scnst__93_ast_glo_def_117(arg1595_992, __module__166_module_module, real_43, arg1596_993);
		    }
		    {
		       obj_t arg1592_990;
		       {
			  obj_t aux_3074;
			  aux_3074 = (obj_t) (var_989);
			  arg1592_990 = MAKE_PAIR(real_43, aux_3074);
		       }
		       {
			  obj_t obj2_1980;
			  obj2_1980 = __real_env__85_cnst_alloc;
			  __real_env__85_cnst_alloc = MAKE_PAIR(arg1592_990, obj2_1980);
		       }
		    }
		    {
		       type_t arg1593_991;
		       {
			  variable_t obj_1981;
			  obj_1981 = (variable_t) (var_989);
			  arg1593_991 = (((variable_t) CREF(obj_1981))->type);
		       }
		       {
			  var_t res1933_1992;
			  {
			     variable_t variable_1984;
			     variable_1984 = (variable_t) (var_989);
			     {
				var_t new1133_1985;
				new1133_1985 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				{
				   long arg1876_1986;
				   arg1876_1986 = class_num_218___object(var_ast_node);
				   {
				      obj_t obj_1990;
				      obj_1990 = (obj_t) (new1133_1985);
				      (((obj_t) CREF(obj_1990))->header = MAKE_HEADER(arg1876_1986, 0), BUNSPEC);
				   }
				}
				{
				   object_t aux_3085;
				   aux_3085 = (object_t) (new1133_1985);
				   OBJECT_WIDENING_SET(aux_3085, BFALSE);
				}
				((((var_t) CREF(new1133_1985))->loc) = ((obj_t) loc_44), BUNSPEC);
				((((var_t) CREF(new1133_1985))->type) = ((type_t) arg1593_991), BUNSPEC);
				((((var_t) CREF(new1133_1985))->variable) = ((variable_t) variable_1984), BUNSPEC);
				res1933_1992 = new1133_1985;
			     }
			  }
			  aux_3063 = res1933_1992;
		       }
		    }
		 }
		 return (node_t) (aux_3063);
	      }
	   }
      }
   }
}


obj_t 
_cnst_alloc_real_237_cnst_alloc(obj_t env_2509, obj_t real_2510, obj_t loc_2511)
{
   {
      node_t aux_3092;
      aux_3092 = cnst_alloc_real_118_cnst_alloc(real_2510, loc_2511);
      return (obj_t) (aux_3092);
   }
}


node_t 
cnst_alloc_list_56_cnst_alloc(obj_t pair_45, obj_t loc_46)
{
   {
      {
	 obj_t old_1005;
	 {
	    obj_t _andtest_1297_1013;
	    _andtest_1297_1013 = __shared_cnst___67_engine_param;
	    if (CBOOL(_andtest_1297_1013))
	      {
		 obj_t env_1014;
		 env_1014 = __list_env__66_cnst_alloc;
	       loop_1015:
		 if (NULLP(env_1014))
		   {
		      old_1005 = BFALSE;
		   }
		 else
		   {
		      bool_t test_3099;
		      {
			 obj_t aux_3100;
			 {
			    obj_t aux_3101;
			    aux_3101 = CAR(env_1014);
			    aux_3100 = STRUCT_REF(aux_3101, ((long) 0));
			 }
			 test_3099 = equal__25___r4_equivalence_6_2(aux_3100, pair_45);
		      }
		      if (test_3099)
			{
			   old_1005 = CAR(env_1014);
			}
		      else
			{
			   {
			      obj_t env_3106;
			      env_3106 = CDR(env_1014);
			      env_1014 = env_3106;
			      goto loop_1015;
			   }
			}
		   }
	      }
	    else
	      {
		 old_1005 = BFALSE;
	      }
	 }
	 if (CBOOL(old_1005))
	   {
	      {
		 bool_t test1606_1006;
		 {
		    obj_t obj1_2000;
		    obj1_2000 = _n_o_f_u_c_k_i_n_g___init_or_fini__init_mode__183_engine_param;
		    {
		       obj_t aux_3110;
		       aux_3110 = CNST_TABLE_REF(((long) 13));
		       test1606_1006 = (obj1_2000 == aux_3110);
		    }
		 }
		 if (test1606_1006)
		   {
		      type_t arg1608_1007;
		      obj_t arg1609_1008;
		      arg1608_1007 = get_default_type_181_type_cache();
		      arg1609_1008 = STRUCT_REF(old_1005, ((long) 1));
		      {
			 var_t res1934_2015;
			 {
			    variable_t variable_2007;
			    variable_2007 = (variable_t) (arg1609_1008);
			    {
			       var_t new1133_2008;
			       new1133_2008 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
			       {
				  long arg1876_2009;
				  arg1876_2009 = class_num_218___object(var_ast_node);
				  {
				     obj_t obj_2013;
				     obj_2013 = (obj_t) (new1133_2008);
				     (((obj_t) CREF(obj_2013))->header = MAKE_HEADER(arg1876_2009, 0), BUNSPEC);
				  }
			       }
			       {
				  object_t aux_3121;
				  aux_3121 = (object_t) (new1133_2008);
				  OBJECT_WIDENING_SET(aux_3121, BFALSE);
			       }
			       ((((var_t) CREF(new1133_2008))->loc) = ((obj_t) loc_46), BUNSPEC);
			       ((((var_t) CREF(new1133_2008))->type) = ((type_t) arg1608_1007), BUNSPEC);
			       ((((var_t) CREF(new1133_2008))->variable) = ((variable_t) variable_2007), BUNSPEC);
			       res1934_2015 = new1133_2008;
			    }
			 }
			 return (node_t) (res1934_2015);
		      }
		   }
		 else
		   {
		      app_t aux_3128;
		      aux_3128 = make_cnst_table_ref_93_cnst_alloc(STRUCT_REF(old_1005, ((long) 1)), loc_46);
		      return (node_t) (aux_3128);
		   }
	      }
	   }
	 else
	   {
	      bool_t test1615_1011;
	      {
		 obj_t obj1_2019;
		 obj1_2019 = _n_o_f_u_c_k_i_n_g___init_or_fini__init_mode__183_engine_param;
		 {
		    obj_t aux_3132;
		    aux_3132 = CNST_TABLE_REF(((long) 13));
		    test1615_1011 = (obj1_2019 == aux_3132);
		 }
	      }
	      if (test1615_1011)
		{
		   {
		      var_t aux_3136;
		      {
			 global_t var_1025;
			 {
			    obj_t arg1653_1046;
			    obj_t arg1654_1047;
			    obj_t arg1655_1048;
			    {
			       obj_t arg1656_1049;
			       arg1656_1049 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 23)), BEOA);
			       {
				  obj_t list1658_1051;
				  {
				     obj_t arg1659_1052;
				     {
					obj_t aux_3140;
					aux_3140 = CNST_TABLE_REF(((long) 24));
					arg1659_1052 = MAKE_PAIR(aux_3140, BNIL);
				     }
				     list1658_1051 = MAKE_PAIR(arg1656_1049, arg1659_1052);
				  }
				  arg1653_1046 = symbol_append_197___r4_symbols_6_4(list1658_1051);
			       }
			    }
			    arg1654_1047 = CNST_TABLE_REF(((long) 25));
			    arg1655_1048 = CNST_TABLE_REF(((long) 3));
			    var_1025 = def_global_svar__184_ast_glo_def_117(arg1653_1046, __module__166_module_module, arg1654_1047, arg1655_1048);
			 }
			 if (CBOOL(__shared_cnst___67_engine_param))
			   {
			      obj_t arg1626_1026;
			      {
				 obj_t new_2044;
				 {
				    obj_t aux_3150;
				    aux_3150 = CNST_TABLE_REF(((long) 7));
				    new_2044 = create_struct(aux_3150, ((long) 2));
				 }
				 {
				    obj_t aux_3153;
				    aux_3153 = (obj_t) (var_1025);
				    STRUCT_SET(new_2044, ((long) 1), aux_3153);
				 }
				 STRUCT_SET(new_2044, ((long) 0), pair_45);
				 arg1626_1026 = new_2044;
			      }
			      {
				 obj_t obj2_2058;
				 obj2_2058 = __list_env__66_cnst_alloc;
				 __list_env__66_cnst_alloc = MAKE_PAIR(arg1626_1026, obj2_2058);
			      }
			   }
			 else
			   {
			      BUNSPEC;
			   }
			 {
			    obj_t arg1627_1027;
			    {
			       obj_t arg1628_1028;
			       obj_t arg1630_1029;
			       node_t arg1632_1030;
			       arg1628_1028 = CNST_TABLE_REF(((long) 11));
			       {
				  obj_t arg1642_1036;
				  obj_t arg1643_1037;
				  obj_t arg1644_1038;
				  arg1642_1036 = CNST_TABLE_REF(((long) 12));
				  arg1643_1037 = (((global_t) CREF(var_1025))->id);
				  arg1644_1038 = (((global_t) CREF(var_1025))->module);
				  {
				     obj_t list1646_1040;
				     {
					obj_t arg1647_1041;
					{
					   obj_t arg1648_1042;
					   arg1648_1042 = MAKE_PAIR(BNIL, BNIL);
					   arg1647_1041 = MAKE_PAIR(arg1644_1038, arg1648_1042);
					}
					list1646_1040 = MAKE_PAIR(arg1643_1037, arg1647_1041);
				     }
				     arg1630_1029 = cons__138___r4_pairs_and_lists_6_3(arg1642_1036, list1646_1040);
				  }
			       }
			       {
				  obj_t arg1651_1044;
				  arg1651_1044 = cnst_list_66_cnst_alloc(loc_46, pair_45);
				  arg1632_1030 = coerce__182_coerce_coerce((node_t) (arg1651_1044), (type_t) (__obj__252_type_cache));
			       }
			       {
				  obj_t list1635_1032;
				  {
				     obj_t arg1637_1033;
				     {
					obj_t arg1638_1034;
					arg1638_1034 = MAKE_PAIR(BNIL, BNIL);
					{
					   obj_t aux_3171;
					   aux_3171 = (obj_t) (arg1632_1030);
					   arg1637_1033 = MAKE_PAIR(aux_3171, arg1638_1034);
					}
				     }
				     list1635_1032 = MAKE_PAIR(arg1630_1029, arg1637_1033);
				  }
				  arg1627_1027 = cons__138___r4_pairs_and_lists_6_3(arg1628_1028, list1635_1032);
			       }
			    }
			    {
			       obj_t obj2_2063;
			       obj2_2063 = __global_sexp__67_cnst_alloc;
			       __global_sexp__67_cnst_alloc = MAKE_PAIR(arg1627_1027, obj2_2063);
			    }
			 }
			 {
			    type_t arg1652_1045;
			    {
			       variable_t obj_2064;
			       obj_2064 = (variable_t) (var_1025);
			       arg1652_1045 = (((variable_t) CREF(obj_2064))->type);
			    }
			    {
			       var_t res1935_2075;
			       {
				  variable_t variable_2067;
				  variable_2067 = (variable_t) (var_1025);
				  {
				     var_t new1133_2068;
				     new1133_2068 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				     {
					long arg1876_2069;
					arg1876_2069 = class_num_218___object(var_ast_node);
					{
					   obj_t obj_2073;
					   obj_2073 = (obj_t) (new1133_2068);
					   (((obj_t) CREF(obj_2073))->header = MAKE_HEADER(arg1876_2069, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_3184;
					aux_3184 = (object_t) (new1133_2068);
					OBJECT_WIDENING_SET(aux_3184, BFALSE);
				     }
				     ((((var_t) CREF(new1133_2068))->loc) = ((obj_t) loc_46), BUNSPEC);
				     ((((var_t) CREF(new1133_2068))->type) = ((type_t) arg1652_1045), BUNSPEC);
				     ((((var_t) CREF(new1133_2068))->variable) = ((variable_t) variable_2067), BUNSPEC);
				     res1935_2075 = new1133_2068;
				  }
			       }
			       aux_3136 = res1935_2075;
			    }
			 }
		      }
		      return (node_t) (aux_3136);
		   }
		}
	      else
		{
		   {
		      app_t aux_3191;
		      {
			 long offset_1022;
			 offset_1022 = __cnst_offset__211_cnst_alloc;
			 {
			    long z2_2022;
			    z2_2022 = __cnst_offset__211_cnst_alloc;
			    __cnst_offset__211_cnst_alloc = (((long) 1) + z2_2022);
			 }
			 {
			    obj_t obj2_2024;
			    obj2_2024 = __global_set__17_cnst_alloc;
			    __global_set__17_cnst_alloc = MAKE_PAIR(pair_45, obj2_2024);
			 }
			 if (CBOOL(__shared_cnst___67_engine_param))
			   {
			      obj_t arg1623_1023;
			      {
				 obj_t new_2027;
				 {
				    obj_t aux_3196;
				    aux_3196 = CNST_TABLE_REF(((long) 7));
				    new_2027 = create_struct(aux_3196, ((long) 2));
				 }
				 {
				    obj_t aux_3199;
				    aux_3199 = BINT(offset_1022);
				    STRUCT_SET(new_2027, ((long) 1), aux_3199);
				 }
				 STRUCT_SET(new_2027, ((long) 0), pair_45);
				 arg1623_1023 = new_2027;
			      }
			      {
				 obj_t obj2_2041;
				 obj2_2041 = __list_env__66_cnst_alloc;
				 __list_env__66_cnst_alloc = MAKE_PAIR(arg1623_1023, obj2_2041);
			      }
			   }
			 else
			   {
			      BUNSPEC;
			   }
			 aux_3191 = make_cnst_table_ref_93_cnst_alloc(BINT(offset_1022), loc_46);
		      }
		      return (node_t) (aux_3191);
		   }
		}
	   }
      }
   }
}


obj_t 
cnst_list_66_cnst_alloc(obj_t loc_2521, obj_t pair_1055)
{
   return loop_cnst_alloc(loc_2521, pair_1055);
}


obj_t 
loop_cnst_alloc(obj_t loc_2522, obj_t pair_1057)
{
   if (NULLP(pair_1057))
     {
	{
	   atom_t res1936_2087;
	   {
	      type_t type_2078;
	      type_2078 = (type_t) (__bnil__15_type_cache);
	      {
		 atom_t new1127_2080;
		 new1127_2080 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
		 {
		    long arg1879_2081;
		    arg1879_2081 = class_num_218___object(atom_ast_node);
		    {
		       obj_t obj_2085;
		       obj_2085 = (obj_t) (new1127_2080);
		       (((obj_t) CREF(obj_2085))->header = MAKE_HEADER(arg1879_2081, 0), BUNSPEC);
		    }
		 }
		 {
		    object_t aux_3215;
		    aux_3215 = (object_t) (new1127_2080);
		    OBJECT_WIDENING_SET(aux_3215, BFALSE);
		 }
		 ((((atom_t) CREF(new1127_2080))->loc) = ((obj_t) loc_2522), BUNSPEC);
		 ((((atom_t) CREF(new1127_2080))->type) = ((type_t) type_2078), BUNSPEC);
		 ((((atom_t) CREF(new1127_2080))->value) = ((obj_t) BNIL), BUNSPEC);
		 res1936_2087 = new1127_2080;
	      }
	   }
	   return (obj_t) (res1936_2087);
	}
     }
   else
     {
	if (PAIRP(pair_1057))
	  {
	     {
		var_t arg1669_1062;
		obj_t arg1671_1063;
		{
		   type_t arg1673_1064;
		   {
		      variable_t obj_2089;
		      obj_2089 = (variable_t) (__cons__148_cnst_cache);
		      arg1673_1064 = (((variable_t) CREF(obj_2089))->type);
		   }
		   {
		      var_t res1937_2100;
		      {
			 variable_t variable_2092;
			 variable_2092 = (variable_t) (__cons__148_cnst_cache);
			 {
			    var_t new1133_2093;
			    new1133_2093 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
			    {
			       long arg1876_2094;
			       arg1876_2094 = class_num_218___object(var_ast_node);
			       {
				  obj_t obj_2098;
				  obj_2098 = (obj_t) (new1133_2093);
				  (((obj_t) CREF(obj_2098))->header = MAKE_HEADER(arg1876_2094, 0), BUNSPEC);
			       }
			    }
			    {
			       object_t aux_3231;
			       aux_3231 = (object_t) (new1133_2093);
			       OBJECT_WIDENING_SET(aux_3231, BFALSE);
			    }
			    ((((var_t) CREF(new1133_2093))->loc) = ((obj_t) loc_2522), BUNSPEC);
			    ((((var_t) CREF(new1133_2093))->type) = ((type_t) arg1673_1064), BUNSPEC);
			    ((((var_t) CREF(new1133_2093))->variable) = ((variable_t) variable_2092), BUNSPEC);
			    res1937_2100 = new1133_2093;
			 }
		      }
		      arg1669_1062 = res1937_2100;
		   }
		}
		{
		   node_t arg1674_1065;
		   obj_t arg1677_1066;
		   {
		      kwote_t arg1681_1070;
		      {
			 type_t arg1682_1071;
			 obj_t arg1684_1072;
			 arg1682_1071 = get_default_type_181_type_cache();
			 arg1684_1072 = CAR(pair_1057);
			 {
			    kwote_t res1938_2112;
			    {
			       kwote_t new1145_2105;
			       new1145_2105 = ((kwote_t) BREF(GC_MALLOC(sizeof(struct kwote))));
			       {
				  long arg1871_2106;
				  arg1871_2106 = class_num_218___object(kwote_ast_node);
				  {
				     obj_t obj_2110;
				     obj_2110 = (obj_t) (new1145_2105);
				     (((obj_t) CREF(obj_2110))->header = MAKE_HEADER(arg1871_2106, 0), BUNSPEC);
				  }
			       }
			       {
				  object_t aux_3243;
				  aux_3243 = (object_t) (new1145_2105);
				  OBJECT_WIDENING_SET(aux_3243, BFALSE);
			       }
			       ((((kwote_t) CREF(new1145_2105))->loc) = ((obj_t) loc_2522), BUNSPEC);
			       ((((kwote_t) CREF(new1145_2105))->type) = ((type_t) arg1682_1071), BUNSPEC);
			       ((((kwote_t) CREF(new1145_2105))->value) = ((obj_t) arg1684_1072), BUNSPEC);
			       res1938_2112 = new1145_2105;
			    }
			    arg1681_1070 = res1938_2112;
			 }
		      }
		      arg1674_1065 = cnst__44_cnst_node((node_t) (arg1681_1070));
		   }
		   arg1677_1066 = loop_cnst_alloc(loc_2522, CDR(pair_1057));
		   {
		      obj_t list1678_1067;
		      {
			 obj_t arg1679_1068;
			 arg1679_1068 = MAKE_PAIR(arg1677_1066, BNIL);
			 {
			    obj_t aux_3254;
			    aux_3254 = (obj_t) (arg1674_1065);
			    list1678_1067 = MAKE_PAIR(aux_3254, arg1679_1068);
			 }
		      }
		      arg1671_1063 = list1678_1067;
		   }
		}
		{
		   app_t res1939_2131;
		   {
		      type_t type_2116;
		      type_2116 = (type_t) (__pair__244_type_cache);
		      {
			 app_t new1156_2121;
			 new1156_2121 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
			 {
			    long arg1865_2122;
			    arg1865_2122 = class_num_218___object(app_ast_node);
			    {
			       obj_t obj_2129;
			       obj_2129 = (obj_t) (new1156_2121);
			       (((obj_t) CREF(obj_2129))->header = MAKE_HEADER(arg1865_2122, 0), BUNSPEC);
			    }
			 }
			 {
			    object_t aux_3262;
			    aux_3262 = (object_t) (new1156_2121);
			    OBJECT_WIDENING_SET(aux_3262, BFALSE);
			 }
			 ((((app_t) CREF(new1156_2121))->loc) = ((obj_t) loc_2522), BUNSPEC);
			 ((((app_t) CREF(new1156_2121))->type) = ((type_t) type_2116), BUNSPEC);
			 ((((app_t) CREF(new1156_2121))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			 ((((app_t) CREF(new1156_2121))->fun) = ((var_t) arg1669_1062), BUNSPEC);
			 ((((app_t) CREF(new1156_2121))->args) = ((obj_t) arg1671_1063), BUNSPEC);
			 ((((app_t) CREF(new1156_2121))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
			 res1939_2131 = new1156_2121;
		      }
		   }
		   return (obj_t) (res1939_2131);
		}
	     }
	  }
	else
	  {
	     {
		kwote_t arg1687_1074;
		{
		   kwote_t res1940_2142;
		   {
		      type_t type_2133;
		      type_2133 = (type_t) (__pair__244_type_cache);
		      {
			 kwote_t new1145_2135;
			 new1145_2135 = ((kwote_t) BREF(GC_MALLOC(sizeof(struct kwote))));
			 {
			    long arg1871_2136;
			    arg1871_2136 = class_num_218___object(kwote_ast_node);
			    {
			       obj_t obj_2140;
			       obj_2140 = (obj_t) (new1145_2135);
			       (((obj_t) CREF(obj_2140))->header = MAKE_HEADER(arg1871_2136, 0), BUNSPEC);
			    }
			 }
			 {
			    object_t aux_3277;
			    aux_3277 = (object_t) (new1145_2135);
			    OBJECT_WIDENING_SET(aux_3277, BFALSE);
			 }
			 ((((kwote_t) CREF(new1145_2135))->loc) = ((obj_t) loc_2522), BUNSPEC);
			 ((((kwote_t) CREF(new1145_2135))->type) = ((type_t) type_2133), BUNSPEC);
			 ((((kwote_t) CREF(new1145_2135))->value) = ((obj_t) pair_1057), BUNSPEC);
			 res1940_2142 = new1145_2135;
		      }
		   }
		   arg1687_1074 = res1940_2142;
		}
		{
		   node_t aux_3283;
		   aux_3283 = cnst__44_cnst_node((node_t) (arg1687_1074));
		   return (obj_t) (aux_3283);
		}
	     }
	  }
     }
}


obj_t 
_cnst_alloc_list_46_cnst_alloc(obj_t env_2512, obj_t pair_2513, obj_t loc_2514)
{
   {
      node_t aux_3287;
      aux_3287 = cnst_alloc_list_56_cnst_alloc(pair_2513, loc_2514);
      return (obj_t) (aux_3287);
   }
}


node_t 
cnst_alloc_vector_65_cnst_alloc(obj_t vec_47, obj_t loc_48)
{
   {
      {
	 obj_t old_1081;
	 {
	    obj_t _andtest_1298_1089;
	    _andtest_1298_1089 = __shared_cnst___67_engine_param;
	    if (CBOOL(_andtest_1298_1089))
	      {
		 obj_t env_1090;
		 env_1090 = __vector_env__150_cnst_alloc;
	       loop_1091:
		 if (NULLP(env_1090))
		   {
		      old_1081 = BFALSE;
		   }
		 else
		   {
		      bool_t test_3294;
		      {
			 obj_t aux_3295;
			 {
			    obj_t aux_3296;
			    aux_3296 = CAR(env_1090);
			    aux_3295 = STRUCT_REF(aux_3296, ((long) 0));
			 }
			 test_3294 = equal__25___r4_equivalence_6_2(aux_3295, vec_47);
		      }
		      if (test_3294)
			{
			   old_1081 = CAR(env_1090);
			}
		      else
			{
			   {
			      obj_t env_3301;
			      env_3301 = CDR(env_1090);
			      env_1090 = env_3301;
			      goto loop_1091;
			   }
			}
		   }
	      }
	    else
	      {
		 old_1081 = BFALSE;
	      }
	 }
	 if (CBOOL(old_1081))
	   {
	      {
		 bool_t test1688_1082;
		 {
		    obj_t obj1_2150;
		    obj1_2150 = _n_o_f_u_c_k_i_n_g___init_or_fini__init_mode__183_engine_param;
		    {
		       obj_t aux_3305;
		       aux_3305 = CNST_TABLE_REF(((long) 13));
		       test1688_1082 = (obj1_2150 == aux_3305);
		    }
		 }
		 if (test1688_1082)
		   {
		      type_t arg1689_1083;
		      obj_t arg1690_1084;
		      arg1689_1083 = get_default_type_181_type_cache();
		      arg1690_1084 = STRUCT_REF(old_1081, ((long) 1));
		      {
			 var_t res1941_2165;
			 {
			    variable_t variable_2157;
			    variable_2157 = (variable_t) (arg1690_1084);
			    {
			       var_t new1133_2158;
			       new1133_2158 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
			       {
				  long arg1876_2159;
				  arg1876_2159 = class_num_218___object(var_ast_node);
				  {
				     obj_t obj_2163;
				     obj_2163 = (obj_t) (new1133_2158);
				     (((obj_t) CREF(obj_2163))->header = MAKE_HEADER(arg1876_2159, 0), BUNSPEC);
				  }
			       }
			       {
				  object_t aux_3316;
				  aux_3316 = (object_t) (new1133_2158);
				  OBJECT_WIDENING_SET(aux_3316, BFALSE);
			       }
			       ((((var_t) CREF(new1133_2158))->loc) = ((obj_t) loc_48), BUNSPEC);
			       ((((var_t) CREF(new1133_2158))->type) = ((type_t) arg1689_1083), BUNSPEC);
			       ((((var_t) CREF(new1133_2158))->variable) = ((variable_t) variable_2157), BUNSPEC);
			       res1941_2165 = new1133_2158;
			    }
			 }
			 return (node_t) (res1941_2165);
		      }
		   }
		 else
		   {
		      app_t aux_3323;
		      aux_3323 = make_cnst_table_ref_93_cnst_alloc(STRUCT_REF(old_1081, ((long) 1)), loc_48);
		      return (node_t) (aux_3323);
		   }
	      }
	   }
	 else
	   {
	      bool_t test1694_1087;
	      {
		 obj_t obj1_2169;
		 obj1_2169 = _n_o_f_u_c_k_i_n_g___init_or_fini__init_mode__183_engine_param;
		 {
		    obj_t aux_3327;
		    aux_3327 = CNST_TABLE_REF(((long) 13));
		    test1694_1087 = (obj1_2169 == aux_3327);
		 }
	      }
	      if (test1694_1087)
		{
		   {
		      var_t aux_3331;
		      {
			 global_t var_1098;
			 {
			    obj_t arg1724_1118;
			    obj_t arg1725_1119;
			    obj_t arg1730_1120;
			    {
			       obj_t arg1731_1121;
			       arg1731_1121 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 26)), BEOA);
			       {
				  obj_t list1733_1123;
				  {
				     obj_t arg1734_1124;
				     {
					obj_t aux_3335;
					aux_3335 = CNST_TABLE_REF(((long) 27));
					arg1734_1124 = MAKE_PAIR(aux_3335, BNIL);
				     }
				     list1733_1123 = MAKE_PAIR(arg1731_1121, arg1734_1124);
				  }
				  arg1724_1118 = symbol_append_197___r4_symbols_6_4(list1733_1123);
			       }
			    }
			    arg1725_1119 = CNST_TABLE_REF(((long) 2));
			    arg1730_1120 = CNST_TABLE_REF(((long) 3));
			    var_1098 = def_global_svar__184_ast_glo_def_117(arg1724_1118, __module__166_module_module, arg1725_1119, arg1730_1120);
			 }
			 if (CBOOL(__shared_cnst___67_engine_param))
			   {
			      obj_t arg1703_1099;
			      {
				 obj_t new_2173;
				 {
				    obj_t aux_3345;
				    aux_3345 = CNST_TABLE_REF(((long) 7));
				    new_2173 = create_struct(aux_3345, ((long) 2));
				 }
				 {
				    obj_t aux_3348;
				    aux_3348 = (obj_t) (var_1098);
				    STRUCT_SET(new_2173, ((long) 1), aux_3348);
				 }
				 STRUCT_SET(new_2173, ((long) 0), vec_47);
				 arg1703_1099 = new_2173;
			      }
			      {
				 obj_t obj2_2187;
				 obj2_2187 = __vector_env__150_cnst_alloc;
				 __vector_env__150_cnst_alloc = MAKE_PAIR(arg1703_1099, obj2_2187);
			      }
			   }
			 else
			   {
			      BUNSPEC;
			   }
			 {
			    obj_t arg1704_1100;
			    {
			       obj_t arg1705_1101;
			       obj_t arg1706_1102;
			       node_t arg1707_1103;
			       arg1705_1101 = CNST_TABLE_REF(((long) 11));
			       {
				  obj_t arg1714_1109;
				  obj_t arg1715_1110;
				  obj_t arg1716_1111;
				  arg1714_1109 = CNST_TABLE_REF(((long) 12));
				  arg1715_1110 = (((global_t) CREF(var_1098))->id);
				  arg1716_1111 = (((global_t) CREF(var_1098))->module);
				  {
				     obj_t list1718_1113;
				     {
					obj_t arg1719_1114;
					{
					   obj_t arg1720_1115;
					   arg1720_1115 = MAKE_PAIR(BNIL, BNIL);
					   arg1719_1114 = MAKE_PAIR(arg1716_1111, arg1720_1115);
					}
					list1718_1113 = MAKE_PAIR(arg1715_1110, arg1719_1114);
				     }
				     arg1706_1102 = cons__138___r4_pairs_and_lists_6_3(arg1714_1109, list1718_1113);
				  }
			       }
			       {
				  node_t arg1740_1131;
				  {
				     let_var_6_t arg1741_1132;
				     {
					local_t var_1133;
					var_1133 = make_local_svar_140_ast_local(CNST_TABLE_REF(((long) 28)), (type_t) (__vector__240_type_cache));
					{
					   obj_t arg1742_1134;
					   obj_t arg1743_1135;
					   {
					      obj_t arg1745_1136;
					      {
						 app_t arg1748_1139;
						 {
						    var_t arg1749_1140;
						    obj_t arg1751_1141;
						    {
						       type_t arg1753_1142;
						       {
							  variable_t obj_2226;
							  obj_2226 = (variable_t) (__list__vector__161_cnst_cache);
							  arg1753_1142 = (((variable_t) CREF(obj_2226))->type);
						       }
						       {
							  var_t res1943_2237;
							  {
							     variable_t variable_2229;
							     variable_2229 = (variable_t) (__list__vector__161_cnst_cache);
							     {
								var_t new1133_2230;
								new1133_2230 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
								{
								   long arg1876_2231;
								   arg1876_2231 = class_num_218___object(var_ast_node);
								   {
								      obj_t obj_2235;
								      obj_2235 = (obj_t) (new1133_2230);
								      (((obj_t) CREF(obj_2235))->header = MAKE_HEADER(arg1876_2231, 0), BUNSPEC);
								   }
								}
								{
								   object_t aux_3371;
								   aux_3371 = (object_t) (new1133_2230);
								   OBJECT_WIDENING_SET(aux_3371, BFALSE);
								}
								((((var_t) CREF(new1133_2230))->loc) = ((obj_t) loc_48), BUNSPEC);
								((((var_t) CREF(new1133_2230))->type) = ((type_t) arg1753_1142), BUNSPEC);
								((((var_t) CREF(new1133_2230))->variable) = ((variable_t) variable_2229), BUNSPEC);
								res1943_2237 = new1133_2230;
							     }
							  }
							  arg1749_1140 = res1943_2237;
						       }
						    }
						    {
						       kwote_t arg1754_1143;
						       {
							  obj_t arg1758_1146;
							  arg1758_1146 = vector__list_155___r4_vectors_6_8(vec_47);
							  {
							     kwote_t res1944_2248;
							     {
								type_t type_2239;
								type_2239 = (type_t) (__obj__252_type_cache);
								{
								   kwote_t new1145_2241;
								   new1145_2241 = ((kwote_t) BREF(GC_MALLOC(sizeof(struct kwote))));
								   {
								      long arg1871_2242;
								      arg1871_2242 = class_num_218___object(kwote_ast_node);
								      {
									 obj_t obj_2246;
									 obj_2246 = (obj_t) (new1145_2241);
									 (((obj_t) CREF(obj_2246))->header = MAKE_HEADER(arg1871_2242, 0), BUNSPEC);
								      }
								   }
								   {
								      object_t aux_3383;
								      aux_3383 = (object_t) (new1145_2241);
								      OBJECT_WIDENING_SET(aux_3383, BFALSE);
								   }
								   ((((kwote_t) CREF(new1145_2241))->loc) = ((obj_t) loc_48), BUNSPEC);
								   ((((kwote_t) CREF(new1145_2241))->type) = ((type_t) type_2239), BUNSPEC);
								   ((((kwote_t) CREF(new1145_2241))->value) = ((obj_t) arg1758_1146), BUNSPEC);
								   res1944_2248 = new1145_2241;
								}
							     }
							     arg1754_1143 = res1944_2248;
							  }
						       }
						       {
							  obj_t list1755_1144;
							  {
							     obj_t aux_3389;
							     aux_3389 = (obj_t) (arg1754_1143);
							     list1755_1144 = MAKE_PAIR(aux_3389, BNIL);
							  }
							  arg1751_1141 = list1755_1144;
						       }
						    }
						    {
						       app_t res1945_2266;
						       {
							  type_t type_2251;
							  type_2251 = (type_t) (__vector__240_type_cache);
							  {
							     app_t new1156_2256;
							     new1156_2256 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
							     {
								long arg1865_2257;
								arg1865_2257 = class_num_218___object(app_ast_node);
								{
								   obj_t obj_2264;
								   obj_2264 = (obj_t) (new1156_2256);
								   (((obj_t) CREF(obj_2264))->header = MAKE_HEADER(arg1865_2257, 0), BUNSPEC);
								}
							     }
							     {
								object_t aux_3397;
								aux_3397 = (object_t) (new1156_2256);
								OBJECT_WIDENING_SET(aux_3397, BFALSE);
							     }
							     ((((app_t) CREF(new1156_2256))->loc) = ((obj_t) loc_48), BUNSPEC);
							     ((((app_t) CREF(new1156_2256))->type) = ((type_t) type_2251), BUNSPEC);
							     ((((app_t) CREF(new1156_2256))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
							     ((((app_t) CREF(new1156_2256))->fun) = ((var_t) arg1749_1140), BUNSPEC);
							     ((((app_t) CREF(new1156_2256))->args) = ((obj_t) arg1751_1141), BUNSPEC);
							     ((((app_t) CREF(new1156_2256))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
							     res1945_2266 = new1156_2256;
							  }
						       }
						       arg1748_1139 = res1945_2266;
						    }
						 }
						 {
						    obj_t aux_3408;
						    obj_t aux_3406;
						    aux_3408 = (obj_t) (arg1748_1139);
						    aux_3406 = (obj_t) (var_1133);
						    arg1745_1136 = MAKE_PAIR(aux_3406, aux_3408);
						 }
					      }
					      {
						 obj_t list1746_1137;
						 list1746_1137 = MAKE_PAIR(arg1745_1136, BNIL);
						 arg1742_1134 = list1746_1137;
					      }
					   }
					   {
					      var_t var_body_120_1147;
					      {
						 type_t arg1780_1166;
						 {
						    variable_t obj_2270;
						    obj_2270 = (variable_t) (var_1133);
						    arg1780_1166 = (((variable_t) CREF(obj_2270))->type);
						 }
						 {
						    var_t res1946_2281;
						    {
						       variable_t variable_2273;
						       variable_2273 = (variable_t) (var_1133);
						       {
							  var_t new1133_2274;
							  new1133_2274 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
							  {
							     long arg1876_2275;
							     arg1876_2275 = class_num_218___object(var_ast_node);
							     {
								obj_t obj_2279;
								obj_2279 = (obj_t) (new1133_2274);
								(((obj_t) CREF(obj_2279))->header = MAKE_HEADER(arg1876_2275, 0), BUNSPEC);
							     }
							  }
							  {
							     object_t aux_3419;
							     aux_3419 = (object_t) (new1133_2274);
							     OBJECT_WIDENING_SET(aux_3419, BFALSE);
							  }
							  ((((var_t) CREF(new1133_2274))->loc) = ((obj_t) loc_48), BUNSPEC);
							  ((((var_t) CREF(new1133_2274))->type) = ((type_t) arg1780_1166), BUNSPEC);
							  ((((var_t) CREF(new1133_2274))->variable) = ((variable_t) variable_2273), BUNSPEC);
							  res1946_2281 = new1133_2274;
						       }
						    }
						    var_body_120_1147 = res1946_2281;
						 }
					      }
					      {
						 bool_t test1759_1148;
						 {
						    long arg1778_1164;
						    arg1778_1164 = VECTOR_TAG(vec_47);
						    test1759_1148 = (arg1778_1164 > ((long) 0));
						 }
						 if (test1759_1148)
						   {
						      obj_t arg1761_1149;
						      {
							 app_t arg1762_1150;
							 {
							    var_t arg1767_1154;
							    obj_t arg1769_1155;
							    {
							       type_t arg1770_1156;
							       {
								  variable_t obj_2285;
								  obj_2285 = (variable_t) (__vector_tag_set___225_cnst_cache);
								  arg1770_1156 = (((variable_t) CREF(obj_2285))->type);
							       }
							       {
								  var_t res1947_2296;
								  {
								     variable_t variable_2288;
								     variable_2288 = (variable_t) (__vector_tag_set___225_cnst_cache);
								     {
									var_t new1133_2289;
									new1133_2289 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
									{
									   long arg1876_2290;
									   arg1876_2290 = class_num_218___object(var_ast_node);
									   {
									      obj_t obj_2294;
									      obj_2294 = (obj_t) (new1133_2289);
									      (((obj_t) CREF(obj_2294))->header = MAKE_HEADER(arg1876_2290, 0), BUNSPEC);
									   }
									}
									{
									   object_t aux_3435;
									   aux_3435 = (object_t) (new1133_2289);
									   OBJECT_WIDENING_SET(aux_3435, BFALSE);
									}
									((((var_t) CREF(new1133_2289))->loc) = ((obj_t) loc_48), BUNSPEC);
									((((var_t) CREF(new1133_2289))->type) = ((type_t) arg1770_1156), BUNSPEC);
									((((var_t) CREF(new1133_2289))->variable) = ((variable_t) variable_2288), BUNSPEC);
									res1947_2296 = new1133_2289;
								     }
								  }
								  arg1767_1154 = res1947_2296;
							       }
							    }
							    {
							       var_t arg1771_1157;
							       atom_t arg1772_1158;
							       {
								  type_t arg1776_1162;
								  {
								     variable_t obj_2297;
								     obj_2297 = (variable_t) (var_1133);
								     arg1776_1162 = (((variable_t) CREF(obj_2297))->type);
								  }
								  {
								     var_t res1948_2308;
								     {
									variable_t variable_2300;
									variable_2300 = (variable_t) (var_1133);
									{
									   var_t new1133_2301;
									   new1133_2301 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
									   {
									      long arg1876_2302;
									      arg1876_2302 = class_num_218___object(var_ast_node);
									      {
										 obj_t obj_2306;
										 obj_2306 = (obj_t) (new1133_2301);
										 (((obj_t) CREF(obj_2306))->header = MAKE_HEADER(arg1876_2302, 0), BUNSPEC);
									      }
									   }
									   {
									      object_t aux_3448;
									      aux_3448 = (object_t) (new1133_2301);
									      OBJECT_WIDENING_SET(aux_3448, BFALSE);
									   }
									   ((((var_t) CREF(new1133_2301))->loc) = ((obj_t) loc_48), BUNSPEC);
									   ((((var_t) CREF(new1133_2301))->type) = ((type_t) arg1776_1162), BUNSPEC);
									   ((((var_t) CREF(new1133_2301))->variable) = ((variable_t) variable_2300), BUNSPEC);
									   res1948_2308 = new1133_2301;
									}
								     }
								     arg1771_1157 = res1948_2308;
								  }
							       }
							       {
								  long arg1777_1163;
								  arg1777_1163 = VECTOR_TAG(vec_47);
								  {
								     atom_t res1949_2320;
								     {
									type_t type_2311;
									obj_t value_2312;
									type_2311 = (type_t) (__obj__252_type_cache);
									value_2312 = BINT(arg1777_1163);
									{
									   atom_t new1127_2313;
									   new1127_2313 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
									   {
									      long arg1879_2314;
									      arg1879_2314 = class_num_218___object(atom_ast_node);
									      {
										 obj_t obj_2318;
										 obj_2318 = (obj_t) (new1127_2313);
										 (((obj_t) CREF(obj_2318))->header = MAKE_HEADER(arg1879_2314, 0), BUNSPEC);
									      }
									   }
									   {
									      object_t aux_3461;
									      aux_3461 = (object_t) (new1127_2313);
									      OBJECT_WIDENING_SET(aux_3461, BFALSE);
									   }
									   ((((atom_t) CREF(new1127_2313))->loc) = ((obj_t) loc_48), BUNSPEC);
									   ((((atom_t) CREF(new1127_2313))->type) = ((type_t) type_2311), BUNSPEC);
									   ((((atom_t) CREF(new1127_2313))->value) = ((obj_t) value_2312), BUNSPEC);
									   res1949_2320 = new1127_2313;
									}
								     }
								     arg1772_1158 = res1949_2320;
								  }
							       }
							       {
								  obj_t list1773_1159;
								  {
								     obj_t arg1774_1160;
								     {
									obj_t aux_3467;
									aux_3467 = (obj_t) (arg1772_1158);
									arg1774_1160 = MAKE_PAIR(aux_3467, BNIL);
								     }
								     {
									obj_t aux_3470;
									aux_3470 = (obj_t) (arg1771_1157);
									list1773_1159 = MAKE_PAIR(aux_3470, arg1774_1160);
								     }
								  }
								  arg1769_1155 = list1773_1159;
							       }
							    }
							    {
							       app_t res1950_2338;
							       {
								  type_t type_2323;
								  type_2323 = (type_t) (__obj__252_type_cache);
								  {
								     app_t new1156_2328;
								     new1156_2328 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
								     {
									long arg1865_2329;
									arg1865_2329 = class_num_218___object(app_ast_node);
									{
									   obj_t obj_2336;
									   obj_2336 = (obj_t) (new1156_2328);
									   (((obj_t) CREF(obj_2336))->header = MAKE_HEADER(arg1865_2329, 0), BUNSPEC);
									}
								     }
								     {
									object_t aux_3478;
									aux_3478 = (object_t) (new1156_2328);
									OBJECT_WIDENING_SET(aux_3478, BFALSE);
								     }
								     ((((app_t) CREF(new1156_2328))->loc) = ((obj_t) loc_48), BUNSPEC);
								     ((((app_t) CREF(new1156_2328))->type) = ((type_t) type_2323), BUNSPEC);
								     ((((app_t) CREF(new1156_2328))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
								     ((((app_t) CREF(new1156_2328))->fun) = ((var_t) arg1767_1154), BUNSPEC);
								     ((((app_t) CREF(new1156_2328))->args) = ((obj_t) arg1769_1155), BUNSPEC);
								     ((((app_t) CREF(new1156_2328))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
								     res1950_2338 = new1156_2328;
								  }
							       }
							       arg1762_1150 = res1950_2338;
							    }
							 }
							 {
							    obj_t list1763_1151;
							    {
							       obj_t arg1764_1152;
							       {
								  obj_t aux_3487;
								  aux_3487 = (obj_t) (var_body_120_1147);
								  arg1764_1152 = MAKE_PAIR(aux_3487, BNIL);
							       }
							       {
								  obj_t aux_3490;
								  aux_3490 = (obj_t) (arg1762_1150);
								  list1763_1151 = MAKE_PAIR(aux_3490, arg1764_1152);
							       }
							    }
							    arg1761_1149 = list1763_1151;
							 }
						      }
						      {
							 sequence_t res1951_2352;
							 {
							    type_t type_2341;
							    type_2341 = (type_t) (__vector__240_type_cache);
							    {
							       sequence_t new1150_2344;
							       new1150_2344 = ((sequence_t) BREF(GC_MALLOC(sizeof(struct sequence))));
							       {
								  long arg1867_2345;
								  arg1867_2345 = class_num_218___object(sequence_ast_node);
								  {
								     obj_t obj_2350;
								     obj_2350 = (obj_t) (new1150_2344);
								     (((obj_t) CREF(obj_2350))->header = MAKE_HEADER(arg1867_2345, 0), BUNSPEC);
								  }
							       }
							       {
								  object_t aux_3498;
								  aux_3498 = (object_t) (new1150_2344);
								  OBJECT_WIDENING_SET(aux_3498, BFALSE);
							       }
							       ((((sequence_t) CREF(new1150_2344))->loc) = ((obj_t) loc_48), BUNSPEC);
							       ((((sequence_t) CREF(new1150_2344))->type) = ((type_t) type_2341), BUNSPEC);
							       ((((sequence_t) CREF(new1150_2344))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
							       ((((sequence_t) CREF(new1150_2344))->nodes) = ((obj_t) arg1761_1149), BUNSPEC);
							       res1951_2352 = new1150_2344;
							    }
							 }
							 arg1743_1135 = (obj_t) (res1951_2352);
						      }
						   }
						 else
						   {
						      arg1743_1135 = (obj_t) (var_body_120_1147);
						   }
					      }
					   }
					   {
					      let_var_6_t res1952_2369;
					      {
						 type_t type_2354;
						 node_t body_2357;
						 type_2354 = (type_t) (__obj__252_type_cache);
						 body_2357 = (node_t) (arg1743_1135);
						 {
						    let_var_6_t new1234_2359;
						    new1234_2359 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
						    {
						       long arg1842_2360;
						       arg1842_2360 = class_num_218___object(let_var_6_ast_node);
						       {
							  obj_t obj_2367;
							  obj_2367 = (obj_t) (new1234_2359);
							  (((obj_t) CREF(obj_2367))->header = MAKE_HEADER(arg1842_2360, 0), BUNSPEC);
						       }
						    }
						    {
						       object_t aux_3513;
						       aux_3513 = (object_t) (new1234_2359);
						       OBJECT_WIDENING_SET(aux_3513, BFALSE);
						    }
						    ((((let_var_6_t) CREF(new1234_2359))->loc) = ((obj_t) loc_48), BUNSPEC);
						    ((((let_var_6_t) CREF(new1234_2359))->type) = ((type_t) type_2354), BUNSPEC);
						    ((((let_var_6_t) CREF(new1234_2359))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
						    ((((let_var_6_t) CREF(new1234_2359))->bindings) = ((obj_t) arg1742_1134), BUNSPEC);
						    ((((let_var_6_t) CREF(new1234_2359))->body) = ((node_t) body_2357), BUNSPEC);
						    ((((let_var_6_t) CREF(new1234_2359))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
						    res1952_2369 = new1234_2359;
						 }
					      }
					      arg1741_1132 = res1952_2369;
					   }
					}
				     }
				     arg1740_1131 = coerce__182_coerce_coerce((node_t) (arg1741_1132), (type_t) (__obj__252_type_cache));
				  }
				  arg1707_1103 = cnst__44_cnst_node(arg1740_1131);
			       }
			       {
				  obj_t list1709_1105;
				  {
				     obj_t arg1710_1106;
				     {
					obj_t arg1711_1107;
					arg1711_1107 = MAKE_PAIR(BNIL, BNIL);
					{
					   obj_t aux_3527;
					   aux_3527 = (obj_t) (arg1707_1103);
					   arg1710_1106 = MAKE_PAIR(aux_3527, arg1711_1107);
					}
				     }
				     list1709_1105 = MAKE_PAIR(arg1706_1102, arg1710_1106);
				  }
				  arg1704_1100 = cons__138___r4_pairs_and_lists_6_3(arg1705_1101, list1709_1105);
			       }
			    }
			    {
			       obj_t obj2_2192;
			       obj2_2192 = __global_sexp__67_cnst_alloc;
			       __global_sexp__67_cnst_alloc = MAKE_PAIR(arg1704_1100, obj2_2192);
			    }
			 }
			 {
			    type_t arg1722_1117;
			    {
			       variable_t obj_2193;
			       obj_2193 = (variable_t) (var_1098);
			       arg1722_1117 = (((variable_t) CREF(obj_2193))->type);
			    }
			    {
			       var_t res1942_2204;
			       {
				  variable_t variable_2196;
				  variable_2196 = (variable_t) (var_1098);
				  {
				     var_t new1133_2197;
				     new1133_2197 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				     {
					long arg1876_2198;
					arg1876_2198 = class_num_218___object(var_ast_node);
					{
					   obj_t obj_2202;
					   obj_2202 = (obj_t) (new1133_2197);
					   (((obj_t) CREF(obj_2202))->header = MAKE_HEADER(arg1876_2198, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_3540;
					aux_3540 = (object_t) (new1133_2197);
					OBJECT_WIDENING_SET(aux_3540, BFALSE);
				     }
				     ((((var_t) CREF(new1133_2197))->loc) = ((obj_t) loc_48), BUNSPEC);
				     ((((var_t) CREF(new1133_2197))->type) = ((type_t) arg1722_1117), BUNSPEC);
				     ((((var_t) CREF(new1133_2197))->variable) = ((variable_t) variable_2196), BUNSPEC);
				     res1942_2204 = new1133_2197;
				  }
			       }
			       aux_3331 = res1942_2204;
			    }
			 }
		      }
		      return (node_t) (aux_3331);
		   }
		}
	      else
		{
		   {
		      app_t aux_3547;
		      {
			 long offset_1128;
			 offset_1128 = __cnst_offset__211_cnst_alloc;
			 {
			    long z2_2206;
			    z2_2206 = __cnst_offset__211_cnst_alloc;
			    __cnst_offset__211_cnst_alloc = (((long) 1) + z2_2206);
			 }
			 {
			    obj_t obj2_2208;
			    obj2_2208 = __global_set__17_cnst_alloc;
			    __global_set__17_cnst_alloc = MAKE_PAIR(vec_47, obj2_2208);
			 }
			 if (CBOOL(__shared_cnst___67_engine_param))
			   {
			      obj_t arg1738_1129;
			      {
				 obj_t new_2211;
				 {
				    obj_t aux_3552;
				    aux_3552 = CNST_TABLE_REF(((long) 7));
				    new_2211 = create_struct(aux_3552, ((long) 2));
				 }
				 {
				    obj_t aux_3555;
				    aux_3555 = BINT(offset_1128);
				    STRUCT_SET(new_2211, ((long) 1), aux_3555);
				 }
				 STRUCT_SET(new_2211, ((long) 0), vec_47);
				 arg1738_1129 = new_2211;
			      }
			      {
				 obj_t obj2_2225;
				 obj2_2225 = __vector_env__150_cnst_alloc;
				 __vector_env__150_cnst_alloc = MAKE_PAIR(arg1738_1129, obj2_2225);
			      }
			   }
			 else
			   {
			      BUNSPEC;
			   }
			 aux_3547 = make_cnst_table_ref_93_cnst_alloc(BINT(offset_1128), loc_48);
		      }
		      return (node_t) (aux_3547);
		   }
		}
	   }
      }
   }
}


obj_t 
_cnst_alloc_vector_187_cnst_alloc(obj_t env_2515, obj_t vec_2516, obj_t loc_2517)
{
   {
      node_t aux_3563;
      aux_3563 = cnst_alloc_vector_65_cnst_alloc(vec_2516, loc_2517);
      return (obj_t) (aux_3563);
   }
}


node_t 
cnst_alloc_tvector_190_cnst_alloc(obj_t tvec_49, obj_t loc_50)
{
   {
      {
	 bool_t test1782_1173;
	 test1782_1173 = tvector_c_static__211_tvector_cnst(tvec_49);
	 if (test1782_1173)
	   {
	      var_t aux_3568;
	      {
		 global_t var_1177;
		 {
		    obj_t arg1820_1206;
		    obj_t arg1821_1207;
		    {
		       obj_t arg1822_1208;
		       arg1822_1208 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 29)), BEOA);
		       {
			  obj_t list1824_1210;
			  {
			     obj_t arg1825_1211;
			     {
				obj_t aux_3572;
				aux_3572 = CNST_TABLE_REF(((long) 30));
				arg1825_1211 = MAKE_PAIR(aux_3572, BNIL);
			     }
			     list1824_1210 = MAKE_PAIR(arg1822_1208, arg1825_1211);
			  }
			  arg1820_1206 = symbol_append_197___r4_symbols_6_4(list1824_1210);
		       }
		    }
		    arg1821_1207 = CNST_TABLE_REF(((long) 31));
		    var_1177 = def_global_scnst__93_ast_glo_def_117(arg1820_1206, __module__166_module_module, tvec_49, arg1821_1207);
		 }
		 {
		    obj_t id_1178;
		    {
		       type_t obj_2377;
		       {
			  obj_t aux_3579;
			  aux_3579 = STRUCT_REF(tvec_49, ((long) 0));
			  obj_2377 = (type_t) (aux_3579);
		       }
		       id_1178 = (((type_t) CREF(obj_2377))->id);
		    }
		    {
		       node_t aid_1179;
		       {
			  kwote_t arg1812_1202;
			  {
			     type_t arg1813_1203;
			     arg1813_1203 = get_default_type_181_type_cache();
			     {
				kwote_t res1953_2388;
				{
				   kwote_t new1145_2381;
				   new1145_2381 = ((kwote_t) BREF(GC_MALLOC(sizeof(struct kwote))));
				   {
				      long arg1871_2382;
				      arg1871_2382 = class_num_218___object(kwote_ast_node);
				      {
					 obj_t obj_2386;
					 obj_2386 = (obj_t) (new1145_2381);
					 (((obj_t) CREF(obj_2386))->header = MAKE_HEADER(arg1871_2382, 0), BUNSPEC);
				      }
				   }
				   {
				      object_t aux_3588;
				      aux_3588 = (object_t) (new1145_2381);
				      OBJECT_WIDENING_SET(aux_3588, BFALSE);
				   }
				   ((((kwote_t) CREF(new1145_2381))->loc) = ((obj_t) loc_50), BUNSPEC);
				   ((((kwote_t) CREF(new1145_2381))->type) = ((type_t) arg1813_1203), BUNSPEC);
				   ((((kwote_t) CREF(new1145_2381))->value) = ((obj_t) id_1178), BUNSPEC);
				   res1953_2388 = new1145_2381;
				}
				arg1812_1202 = res1953_2388;
			     }
			  }
			  aid_1179 = cnst__44_cnst_node((node_t) (arg1812_1202));
		       }
		       {
			  {
			     obj_t arg1785_1180;
			     {
				obj_t arg1786_1181;
				obj_t arg1788_1182;
				obj_t arg1789_1183;
				arg1786_1181 = CNST_TABLE_REF(((long) 32));
				{
				   obj_t arg1798_1189;
				   obj_t arg1799_1190;
				   obj_t arg1800_1191;
				   arg1798_1189 = CNST_TABLE_REF(((long) 12));
				   arg1799_1190 = (((global_t) CREF(var_1177))->id);
				   arg1800_1191 = (((global_t) CREF(var_1177))->module);
				   {
				      obj_t list1802_1193;
				      {
					 obj_t arg1804_1194;
					 {
					    obj_t arg1805_1195;
					    arg1805_1195 = MAKE_PAIR(BNIL, BNIL);
					    arg1804_1194 = MAKE_PAIR(arg1800_1191, arg1805_1195);
					 }
					 list1802_1193 = MAKE_PAIR(arg1799_1190, arg1804_1194);
				      }
				      arg1788_1182 = cons__138___r4_pairs_and_lists_6_3(arg1798_1189, list1802_1193);
				   }
				}
				{
				   obj_t arg1807_1197;
				   arg1807_1197 = CNST_TABLE_REF(((long) 33));
				   {
				      obj_t list1809_1199;
				      {
					 obj_t arg1810_1200;
					 arg1810_1200 = MAKE_PAIR(BNIL, BNIL);
					 {
					    obj_t aux_3606;
					    aux_3606 = (obj_t) (aid_1179);
					    list1809_1199 = MAKE_PAIR(aux_3606, arg1810_1200);
					 }
				      }
				      arg1789_1183 = cons__138___r4_pairs_and_lists_6_3(arg1807_1197, list1809_1199);
				   }
				}
				{
				   obj_t list1792_1185;
				   {
				      obj_t arg1793_1186;
				      {
					 obj_t arg1795_1187;
					 arg1795_1187 = MAKE_PAIR(BNIL, BNIL);
					 arg1793_1186 = MAKE_PAIR(arg1789_1183, arg1795_1187);
				      }
				      list1792_1185 = MAKE_PAIR(arg1788_1182, arg1793_1186);
				   }
				   arg1785_1180 = cons__138___r4_pairs_and_lists_6_3(arg1786_1181, list1792_1185);
				}
			     }
			     {
				obj_t obj2_2393;
				obj2_2393 = __global_sexp__67_cnst_alloc;
				__global_sexp__67_cnst_alloc = MAKE_PAIR(arg1785_1180, obj2_2393);
			     }
			  }
		       }
		    }
		 }
		 {
		    type_t arg1819_1205;
		    {
		       variable_t obj_2394;
		       obj_2394 = (variable_t) (var_1177);
		       arg1819_1205 = (((variable_t) CREF(obj_2394))->type);
		    }
		    {
		       var_t res1954_2405;
		       {
			  variable_t variable_2397;
			  variable_2397 = (variable_t) (var_1177);
			  {
			     var_t new1133_2398;
			     new1133_2398 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
			     {
				long arg1876_2399;
				arg1876_2399 = class_num_218___object(var_ast_node);
				{
				   obj_t obj_2403;
				   obj_2403 = (obj_t) (new1133_2398);
				   (((obj_t) CREF(obj_2403))->header = MAKE_HEADER(arg1876_2399, 0), BUNSPEC);
				}
			     }
			     {
				object_t aux_3622;
				aux_3622 = (object_t) (new1133_2398);
				OBJECT_WIDENING_SET(aux_3622, BFALSE);
			     }
			     ((((var_t) CREF(new1133_2398))->loc) = ((obj_t) loc_50), BUNSPEC);
			     ((((var_t) CREF(new1133_2398))->type) = ((type_t) arg1819_1205), BUNSPEC);
			     ((((var_t) CREF(new1133_2398))->variable) = ((variable_t) variable_2397), BUNSPEC);
			     res1954_2405 = new1133_2398;
			  }
		       }
		       aux_3568 = res1954_2405;
		    }
		 }
	      }
	      return (node_t) (aux_3568);
	   }
	 else
	   {
	      app_t aux_3629;
	      internal_error_43_tools_error(string1961_cnst_alloc, string1962_cnst_alloc, tvec_49);
	      {
		 long offset_1175;
		 offset_1175 = __cnst_offset__211_cnst_alloc;
		 {
		    long z2_2371;
		    z2_2371 = __cnst_offset__211_cnst_alloc;
		    __cnst_offset__211_cnst_alloc = (((long) 1) + z2_2371);
		 }
		 {
		    obj_t obj2_2373;
		    obj2_2373 = __global_set__17_cnst_alloc;
		    __global_set__17_cnst_alloc = MAKE_PAIR(tvec_49, obj2_2373);
		 }
		 aux_3629 = make_cnst_table_ref_93_cnst_alloc(BINT(offset_1175), loc_50);
	      }
	      return (node_t) (aux_3629);
	   }
      }
   }
}


obj_t 
_cnst_alloc_tvector_13_cnst_alloc(obj_t env_2518, obj_t tvec_2519, obj_t loc_2520)
{
   {
      node_t aux_3636;
      aux_3636 = cnst_alloc_tvector_190_cnst_alloc(tvec_2519, loc_2520);
      return (obj_t) (aux_3636);
   }
}


obj_t 
imported_modules_init_94_cnst_alloc()
{
   module_initialization_70_engine_param(((long) 0), "CNST_ALLOC");
   module_initialization_70_module_module(((long) 0), "CNST_ALLOC");
   module_initialization_70_tools_shape(((long) 0), "CNST_ALLOC");
   module_initialization_70_tools_error(((long) 0), "CNST_ALLOC");
   module_initialization_70_type_type(((long) 0), "CNST_ALLOC");
   module_initialization_70_type_cache(((long) 0), "CNST_ALLOC");
   module_initialization_70_tvector_tvector(((long) 0), "CNST_ALLOC");
   module_initialization_70_tvector_cnst(((long) 0), "CNST_ALLOC");
   module_initialization_70_ast_var(((long) 0), "CNST_ALLOC");
   module_initialization_70_ast_node(((long) 0), "CNST_ALLOC");
   module_initialization_70_ast_sexp(((long) 0), "CNST_ALLOC");
   module_initialization_70_ast_local(((long) 0), "CNST_ALLOC");
   module_initialization_70_ast_glo_def_117(((long) 0), "CNST_ALLOC");
   module_initialization_70_coerce_coerce(((long) 0), "CNST_ALLOC");
   module_initialization_70_cnst_cache(((long) 0), "CNST_ALLOC");
   return module_initialization_70_cnst_node(((long) 0), "CNST_ALLOC");
}
