/*===========================================================================*/
/*   (Cnst/cache.scm)                                                        */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


obj_t __cnst_table_set___16_cnst_cache = BUNSPEC;
obj_t __vector_tag_set___225_cnst_cache = BUNSPEC;
extern obj_t _start_cnst_cache__252_cnst_cache(obj_t);
static obj_t imported_modules_init_94_cnst_cache();
extern obj_t module_initialization_70_cnst_cache(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t stop_cnst_cache__90_cnst_cache();
static obj_t toplevel_init_63_cnst_cache();
static obj_t cnst_init_137_cnst_cache();
obj_t __string__keyword__251_cnst_cache = BUNSPEC;
extern obj_t _stop_cnst_cache__214_cnst_cache(obj_t);
obj_t __make_fx_procedure__51_cnst_cache = BUNSPEC;
obj_t __btrue__29_cnst_cache = BUNSPEC;
static obj_t require_initialization_114_cnst_cache = BUNSPEC;
obj_t __bool__bbool__85_cnst_cache = BUNSPEC;
static obj_t library_modules_init_112_cnst_cache();
extern obj_t read___reader(obj_t);
obj_t __cnst_table_ref__15_cnst_cache = BUNSPEC;
extern obj_t open_input_string(obj_t);
obj_t __list__vector__161_cnst_cache = BUNSPEC;
static bool_t __cache_started___32_cnst_cache;
obj_t __make_va_procedure__53_cnst_cache = BUNSPEC;
obj_t __bfalse__69_cnst_cache = BUNSPEC;
obj_t __cons__148_cnst_cache = BUNSPEC;
obj_t __double__real__21_cnst_cache = BUNSPEC;
extern obj_t start_cnst_cache__172_cnst_cache();
obj_t __string__bstring__114_cnst_cache = BUNSPEC;
obj_t __string__symbol__115_cnst_cache = BUNSPEC;
extern obj_t find_global_223_ast_env(obj_t, obj_t);
static obj_t __cnst[15];

DEFINE_EXPORT_PROCEDURE(stop_cnst_cache__env_237_cnst_cache, _stop_cnst_cache__214_cnst_cache1286, _stop_cnst_cache__214_cnst_cache, 0L, 0);
DEFINE_STRING(string1280_cnst_cache, string1280_cnst_cache1287, "VECTOR-TAG-SET! LIST->VECTOR DOUBLE->REAL MAKE-VA-PROCEDURE MAKE-FX-PROCEDURE BOOL->BBOOL C-STRING->KEYWORD C-STRING->SYMBOL STRING->BSTRING BFALSE BTRUE C-CONS CNST-TABLE-SET! FOREIGN CNST-TABLE-REF ", 200);
DEFINE_EXPORT_PROCEDURE(start_cnst_cache__env_224_cnst_cache, _start_cnst_cache__252_cnst_cache1288, _start_cnst_cache__252_cnst_cache, 0L, 0);

obj_t 
module_initialization_70_cnst_cache(long checksum_463, char *from_464)
{
   if (CBOOL(require_initialization_114_cnst_cache))
     {
	require_initialization_114_cnst_cache = BBOOL(((bool_t) 0));
	library_modules_init_112_cnst_cache();
	cnst_init_137_cnst_cache();
	imported_modules_init_94_cnst_cache();
	toplevel_init_63_cnst_cache();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cnst_cache()
{
   module_initialization_70___reader(((long) 0), "CNST_CACHE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cnst_cache()
{
   {
      obj_t cnst_port_138_455;
      cnst_port_138_455 = open_input_string(string1280_cnst_cache);
      {
	 long i_456;
	 i_456 = ((long) 14);
       loop_457:
	 {
	    bool_t test1281_458;
	    test1281_458 = (i_456 == ((long) -1));
	    if (test1281_458)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1282_459;
		    {
		       obj_t list1283_460;
		       {
			  obj_t arg1284_461;
			  arg1284_461 = BNIL;
			  list1283_460 = MAKE_PAIR(cnst_port_138_455, arg1284_461);
		       }
		       arg1282_459 = read___reader(list1283_460);
		    }
		    CNST_TABLE_SET(i_456, arg1282_459);
		 }
		 {
		    int aux_462;
		    {
		       long aux_479;
		       aux_479 = (i_456 - ((long) 1));
		       aux_462 = (int) (aux_479);
		    }
		    {
		       long i_482;
		       i_482 = (long) (aux_462);
		       i_456 = i_482;
		       goto loop_457;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cnst_cache()
{
   __cache_started___32_cnst_cache = ((bool_t) 0);
   __cnst_table_ref__15_cnst_cache = BFALSE;
   __cnst_table_set___16_cnst_cache = BFALSE;
   __cons__148_cnst_cache = BFALSE;
   __btrue__29_cnst_cache = BFALSE;
   __bfalse__69_cnst_cache = BFALSE;
   __string__bstring__114_cnst_cache = BFALSE;
   __string__symbol__115_cnst_cache = BFALSE;
   __string__keyword__251_cnst_cache = BFALSE;
   __bool__bbool__85_cnst_cache = BFALSE;
   __make_fx_procedure__51_cnst_cache = BFALSE;
   __make_va_procedure__53_cnst_cache = BFALSE;
   __double__real__21_cnst_cache = BFALSE;
   __list__vector__161_cnst_cache = BFALSE;
   return (__vector_tag_set___225_cnst_cache = BFALSE,
      BUNSPEC);
}


obj_t 
start_cnst_cache__172_cnst_cache()
{
   if (__cache_started___32_cnst_cache)
     {
	return BTRUE;
     }
   else
     {
	__cache_started___32_cnst_cache = ((bool_t) 1);
	{
	   obj_t arg1144_279;
	   arg1144_279 = CNST_TABLE_REF(((long) 0));
	   {
	      obj_t list1146_281;
	      {
		 obj_t aux_486;
		 aux_486 = CNST_TABLE_REF(((long) 1));
		 list1146_281 = MAKE_PAIR(aux_486, BNIL);
	      }
	      __cnst_table_ref__15_cnst_cache = find_global_223_ast_env(arg1144_279, list1146_281);
	   }
	}
	{
	   obj_t arg1149_283;
	   arg1149_283 = CNST_TABLE_REF(((long) 2));
	   {
	      obj_t list1154_285;
	      {
		 obj_t aux_491;
		 aux_491 = CNST_TABLE_REF(((long) 1));
		 list1154_285 = MAKE_PAIR(aux_491, BNIL);
	      }
	      __cnst_table_set___16_cnst_cache = find_global_223_ast_env(arg1149_283, list1154_285);
	   }
	}
	{
	   obj_t arg1164_287;
	   arg1164_287 = CNST_TABLE_REF(((long) 3));
	   {
	      obj_t list1167_289;
	      {
		 obj_t aux_496;
		 aux_496 = CNST_TABLE_REF(((long) 1));
		 list1167_289 = MAKE_PAIR(aux_496, BNIL);
	      }
	      __cons__148_cnst_cache = find_global_223_ast_env(arg1164_287, list1167_289);
	   }
	}
	{
	   obj_t arg1182_291;
	   arg1182_291 = CNST_TABLE_REF(((long) 4));
	   {
	      obj_t list1196_293;
	      {
		 obj_t aux_501;
		 aux_501 = CNST_TABLE_REF(((long) 1));
		 list1196_293 = MAKE_PAIR(aux_501, BNIL);
	      }
	      __btrue__29_cnst_cache = find_global_223_ast_env(arg1182_291, list1196_293);
	   }
	}
	{
	   obj_t arg1199_295;
	   arg1199_295 = CNST_TABLE_REF(((long) 5));
	   {
	      obj_t list1201_297;
	      {
		 obj_t aux_506;
		 aux_506 = CNST_TABLE_REF(((long) 1));
		 list1201_297 = MAKE_PAIR(aux_506, BNIL);
	      }
	      __bfalse__69_cnst_cache = find_global_223_ast_env(arg1199_295, list1201_297);
	   }
	}
	{
	   obj_t arg1204_299;
	   arg1204_299 = CNST_TABLE_REF(((long) 6));
	   {
	      obj_t list1206_301;
	      {
		 obj_t aux_511;
		 aux_511 = CNST_TABLE_REF(((long) 1));
		 list1206_301 = MAKE_PAIR(aux_511, BNIL);
	      }
	      __string__bstring__114_cnst_cache = find_global_223_ast_env(arg1204_299, list1206_301);
	   }
	}
	{
	   obj_t arg1208_303;
	   arg1208_303 = CNST_TABLE_REF(((long) 7));
	   {
	      obj_t list1210_305;
	      {
		 obj_t aux_516;
		 aux_516 = CNST_TABLE_REF(((long) 1));
		 list1210_305 = MAKE_PAIR(aux_516, BNIL);
	      }
	      __string__symbol__115_cnst_cache = find_global_223_ast_env(arg1208_303, list1210_305);
	   }
	}
	{
	   obj_t arg1213_307;
	   arg1213_307 = CNST_TABLE_REF(((long) 8));
	   {
	      obj_t list1215_309;
	      {
		 obj_t aux_521;
		 aux_521 = CNST_TABLE_REF(((long) 1));
		 list1215_309 = MAKE_PAIR(aux_521, BNIL);
	      }
	      __string__keyword__251_cnst_cache = find_global_223_ast_env(arg1213_307, list1215_309);
	   }
	}
	{
	   obj_t arg1218_311;
	   arg1218_311 = CNST_TABLE_REF(((long) 9));
	   {
	      obj_t list1220_313;
	      {
		 obj_t aux_526;
		 aux_526 = CNST_TABLE_REF(((long) 1));
		 list1220_313 = MAKE_PAIR(aux_526, BNIL);
	      }
	      __bool__bbool__85_cnst_cache = find_global_223_ast_env(arg1218_311, list1220_313);
	   }
	}
	{
	   obj_t arg1225_315;
	   arg1225_315 = CNST_TABLE_REF(((long) 10));
	   {
	      obj_t list1228_317;
	      {
		 obj_t aux_531;
		 aux_531 = CNST_TABLE_REF(((long) 1));
		 list1228_317 = MAKE_PAIR(aux_531, BNIL);
	      }
	      __make_fx_procedure__51_cnst_cache = find_global_223_ast_env(arg1225_315, list1228_317);
	   }
	}
	{
	   obj_t arg1230_319;
	   arg1230_319 = CNST_TABLE_REF(((long) 11));
	   {
	      obj_t list1232_321;
	      {
		 obj_t aux_536;
		 aux_536 = CNST_TABLE_REF(((long) 1));
		 list1232_321 = MAKE_PAIR(aux_536, BNIL);
	      }
	      __make_va_procedure__53_cnst_cache = find_global_223_ast_env(arg1230_319, list1232_321);
	   }
	}
	{
	   obj_t arg1234_323;
	   arg1234_323 = CNST_TABLE_REF(((long) 12));
	   {
	      obj_t list1236_325;
	      {
		 obj_t aux_541;
		 aux_541 = CNST_TABLE_REF(((long) 1));
		 list1236_325 = MAKE_PAIR(aux_541, BNIL);
	      }
	      __double__real__21_cnst_cache = find_global_223_ast_env(arg1234_323, list1236_325);
	   }
	}
	__list__vector__161_cnst_cache = find_global_223_ast_env(CNST_TABLE_REF(((long) 13)), BNIL);
	__vector_tag_set___225_cnst_cache = find_global_223_ast_env(CNST_TABLE_REF(((long) 14)), BNIL);
	return BTRUE;
     }
}


obj_t 
_start_cnst_cache__252_cnst_cache(obj_t env_453)
{
   return start_cnst_cache__172_cnst_cache();
}


obj_t 
stop_cnst_cache__90_cnst_cache()
{
   __string__bstring__114_cnst_cache = BFALSE;
   __string__symbol__115_cnst_cache = BFALSE;
   __string__keyword__251_cnst_cache = BFALSE;
   __bool__bbool__85_cnst_cache = BFALSE;
   __make_fx_procedure__51_cnst_cache = BFALSE;
   __make_va_procedure__53_cnst_cache = BFALSE;
   __double__real__21_cnst_cache = BFALSE;
   __cons__148_cnst_cache = BFALSE;
   __btrue__29_cnst_cache = BFALSE;
   __bfalse__69_cnst_cache = BFALSE;
   return BTRUE;
}


obj_t 
_stop_cnst_cache__214_cnst_cache(obj_t env_454)
{
   return stop_cnst_cache__90_cnst_cache();
}


obj_t 
imported_modules_init_94_cnst_cache()
{
   module_initialization_70_type_type(((long) 0), "CNST_CACHE");
   module_initialization_70_ast_var(((long) 0), "CNST_CACHE");
   module_initialization_70_ast_env(((long) 0), "CNST_CACHE");
   return module_initialization_70_engine_param(((long) 0), "CNST_CACHE");
}
