/*===========================================================================*/
/*   (Cnst/initialize.scm)                                                   */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


static obj_t intern_initialize__196_cnst_initialize();
extern node_t coerce__182_coerce_coerce(node_t, type_t);
extern obj_t obj_to_string(obj_t);
extern obj_t _n_o_f_u_c_k_i_n_g___init_or_fini__init_mode__183_engine_param;
static obj_t intern_full_cnst_initialize__85_cnst_initialize();
extern obj_t list__vector_101___r4_vectors_6_8(obj_t);
extern obj_t open_output_string();
static obj_t read_empty_cnst_initialize__140_cnst_initialize();
static obj_t imported_modules_init_94_cnst_initialize();
extern obj_t module_initialization_70_cnst_initialize(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_build(long, char *);
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_cnst_alloc(long, char *);
extern obj_t module_initialization_70_cnst_node(long, char *);
extern obj_t module_initialization_70___intext(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_vectors_6_8(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t toplevel_init_63_cnst_initialize();
static obj_t cnst_init_137_cnst_initialize();
static obj_t lib_initialize__103_cnst_initialize();
extern obj_t initialize_ast_128_cnst_initialize();
static obj_t read_full_cnst_initialize__176_cnst_initialize();
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t read_initialize__67_cnst_initialize();
static obj_t require_initialization_114_cnst_initialize = BUNSPEC;
extern obj_t get_cnst_sexp_197_cnst_alloc();
static obj_t cnst_set__cnst_string_40_cnst_initialize(obj_t);
static obj_t library_modules_init_112_cnst_initialize();
extern obj_t build_ast_197_ast_build(obj_t);
extern node_t cnst_alloc_string_41_cnst_alloc(obj_t, obj_t);
extern char *number__string_214___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t close_output_port(obj_t);
extern obj_t get_cnst_set_138_cnst_alloc();
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t write___r4_output_6_10_3(obj_t, obj_t);
extern obj_t _initialize_ast_73_cnst_initialize(obj_t);
extern obj_t write_char_165___r4_output_6_10_3(unsigned char, obj_t);
static obj_t intern_empty_cnst_initialize__171_cnst_initialize();
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t get_cnst_table_42_cnst_alloc();
extern obj_t get_cnst_offset_21_cnst_alloc();
extern obj_t create_struct(obj_t, long);
static obj_t __cnst[28];

DEFINE_EXPORT_PROCEDURE(initialize_ast_env_80_cnst_initialize, _initialize_ast_73_cnst_initialize1869, _initialize_ast_73_cnst_initialize, 0L, 0);
DEFINE_STRING(string1857_cnst_initialize, string1857_cnst_initialize1870, "Illegal init-mode", 17);
DEFINE_STRING(string1856_cnst_initialize, string1856_cnst_initialize1871, "intialize-stop!", 15);
DEFINE_STRING(string1863_cnst_initialize, string1863_cnst_initialize1872, "CNST-TMP C-VECTOR-REF I::INT __INTEXT STRING->OBJ CNST-TMP::VECTOR AUX C--FX AUX::INT CNST-PORT __READER @ CNST-TABLE-SET! BEGIN I C-=FX IF I::LONG LOOP LABELS C-OPEN-INPUT-STRING CNST-PORT::INPUT-PORT LET UNIT CNST INTERN READ LIB ", 232);
DEFINE_STRING(string1858_cnst_initialize, string1858_cnst_initialize1873, "*__cnst", 7);
DEFINE_STRING(string1859_cnst_initialize, string1859_cnst_initialize1874, " ] ", 3);
DEFINE_STRING(string1860_cnst_initialize, string1860_cnst_initialize1875, "__cnst[ ", 8);
DEFINE_STRING(string1861_cnst_initialize, string1861_cnst_initialize1876, "cnst-set->cnst-string", 21);
DEFINE_STRING(string1862_cnst_initialize, string1862_cnst_initialize1877, "Can't open output string port", 29);

obj_t 
module_initialization_70_cnst_initialize(long checksum_1467, char *from_1468)
{
   if (CBOOL(require_initialization_114_cnst_initialize))
     {
	require_initialization_114_cnst_initialize = BBOOL(((bool_t) 0));
	library_modules_init_112_cnst_initialize();
	cnst_init_137_cnst_initialize();
	imported_modules_init_94_cnst_initialize();
	toplevel_init_63_cnst_initialize();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cnst_initialize()
{
   module_initialization_70___intext(((long) 0), "CNST_INITIALIZE");
   module_initialization_70___r4_vectors_6_8(((long) 0), "CNST_INITIALIZE");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CNST_INITIALIZE");
   module_initialization_70___r4_numbers_6_5(((long) 0), "CNST_INITIALIZE");
   module_initialization_70___reader(((long) 0), "CNST_INITIALIZE");
   module_initialization_70___r4_output_6_10_3(((long) 0), "CNST_INITIALIZE");
   module_initialization_70___r4_strings_6_7(((long) 0), "CNST_INITIALIZE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cnst_initialize()
{
   {
      obj_t cnst_port_138_1459;
      cnst_port_138_1459 = open_input_string(string1863_cnst_initialize);
      {
	 long i_1460;
	 i_1460 = ((long) 27);
       loop_1461:
	 {
	    bool_t test1864_1462;
	    test1864_1462 = (i_1460 == ((long) -1));
	    if (test1864_1462)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1865_1463;
		    {
		       obj_t list1866_1464;
		       {
			  obj_t arg1867_1465;
			  arg1867_1465 = BNIL;
			  list1866_1464 = MAKE_PAIR(cnst_port_138_1459, arg1867_1465);
		       }
		       arg1865_1463 = read___reader(list1866_1464);
		    }
		    CNST_TABLE_SET(i_1460, arg1865_1463);
		 }
		 {
		    int aux_1466;
		    {
		       long aux_1489;
		       aux_1489 = (i_1460 - ((long) 1));
		       aux_1466 = (int) (aux_1489);
		    }
		    {
		       long i_1492;
		       i_1492 = (long) (aux_1466);
		       i_1460 = i_1492;
		       goto loop_1461;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cnst_initialize()
{
   return BUNSPEC;
}


obj_t 
initialize_ast_128_cnst_initialize()
{
   {
      obj_t body_666;
      {
	 obj_t case_value_58_683;
	 case_value_58_683 = _n_o_f_u_c_k_i_n_g___init_or_fini__init_mode__183_engine_param;
	 {
	    bool_t test_1494;
	    {
	       obj_t aux_1495;
	       aux_1495 = CNST_TABLE_REF(((long) 0));
	       test_1494 = (case_value_58_683 == aux_1495);
	    }
	    if (test_1494)
	      {
		 body_666 = lib_initialize__103_cnst_initialize();
	      }
	    else
	      {
		 bool_t test_1499;
		 {
		    obj_t aux_1500;
		    aux_1500 = CNST_TABLE_REF(((long) 1));
		    test_1499 = (case_value_58_683 == aux_1500);
		 }
		 if (test_1499)
		   {
		      body_666 = read_initialize__67_cnst_initialize();
		   }
		 else
		   {
		      bool_t test_1504;
		      {
			 obj_t aux_1505;
			 aux_1505 = CNST_TABLE_REF(((long) 2));
			 test_1504 = (case_value_58_683 == aux_1505);
		      }
		      if (test_1504)
			{
			   body_666 = intern_initialize__196_cnst_initialize();
			}
		      else
			{
			   body_666 = internal_error_43_tools_error(string1856_cnst_initialize, string1857_cnst_initialize, _n_o_f_u_c_k_i_n_g___init_or_fini__init_mode__183_engine_param);
			}
		   }
	      }
	 }
      }
      if (PAIRP(body_666))
	{
	   obj_t unit_668;
	   {
	      obj_t arg1322_681;
	      arg1322_681 = CNST_TABLE_REF(((long) 3));
	      {
		 obj_t new_1386;
		 {
		    obj_t aux_1513;
		    aux_1513 = CNST_TABLE_REF(((long) 4));
		    new_1386 = create_struct(aux_1513, ((long) 4));
		 }
		 STRUCT_SET(new_1386, ((long) 3), BTRUE);
		 STRUCT_SET(new_1386, ((long) 2), body_666);
		 {
		    obj_t aux_1518;
		    aux_1518 = BINT(((long) 8));
		    STRUCT_SET(new_1386, ((long) 1), aux_1518);
		 }
		 STRUCT_SET(new_1386, ((long) 0), arg1322_681);
		 unit_668 = new_1386;
	      }
	   }
	   {
	      obj_t ast_669;
	      {
		 obj_t arg1319_678;
		 {
		    obj_t list1320_679;
		    list1320_679 = MAKE_PAIR(unit_668, BNIL);
		    arg1319_678 = list1320_679;
		 }
		 ast_669 = build_ast_197_ast_build(arg1319_678);
	      }
	      {
		 obj_t l1272_670;
		 l1272_670 = ast_669;
	       lname1283_671:
		 if (PAIRP(l1272_670))
		   {
		      {
			 obj_t global_673;
			 global_673 = CAR(l1272_670);
			 {
			    type_t aux_1535;
			    node_t aux_1527;
			    {
			       global_t obj_1414;
			       obj_1414 = (global_t) (global_673);
			       aux_1535 = (((global_t) CREF(obj_1414))->type);
			    }
			    {
			       obj_t aux_1528;
			       {
				  sfun_t obj_1413;
				  {
				     value_t aux_1529;
				     {
					global_t obj_1412;
					obj_1412 = (global_t) (global_673);
					aux_1529 = (((global_t) CREF(obj_1412))->value);
				     }
				     obj_1413 = (sfun_t) (aux_1529);
				  }
				  aux_1528 = (((sfun_t) CREF(obj_1413))->body);
			       }
			       aux_1527 = (node_t) (aux_1528);
			    }
			    coerce__182_coerce_coerce(aux_1527, aux_1535);
			 }
		      }
		      {
			 obj_t l1272_1539;
			 l1272_1539 = CDR(l1272_670);
			 l1272_670 = l1272_1539;
			 goto lname1283_671;
		      }
		   }
		 else
		   {
		      ((bool_t) 1);
		   }
	      }
	      return ast_669;
	   }
	}
      else
	{
	   return BNIL;
	}
   }
}


obj_t 
_initialize_ast_73_cnst_initialize(obj_t env_1452)
{
   return initialize_ast_128_cnst_initialize();
}


obj_t 
lib_initialize__103_cnst_initialize()
{
   {
      obj_t arg1331_690;
      arg1331_690 = get_cnst_table_42_cnst_alloc();
      {
	 obj_t res1851_1418;
	 {
	    global_t obj_1416;
	    obj_t val1036_1417;
	    obj_1416 = (global_t) (arg1331_690);
	    val1036_1417 = string1858_cnst_initialize;
	    {
	       obj_t x_1454;
	       x_1454 = ((((global_t) CREF(obj_1416))->name) = ((obj_t) val1036_1417), BUNSPEC);
	       res1851_1418 = BUNSPEC;
	    }
	 }
	 res1851_1418;
      }
   }
   return get_cnst_sexp_197_cnst_alloc();
}


obj_t 
read_initialize__67_cnst_initialize()
{
   {
      bool_t test1333_692;
      {
	 obj_t arg1334_693;
	 arg1334_693 = get_cnst_offset_21_cnst_alloc();
	 {
	    long aux_1547;
	    aux_1547 = (long) CINT(arg1334_693);
	    test1333_692 = (aux_1547 == ((long) 0));
	 }
      }
      if (test1333_692)
	{
	   return read_empty_cnst_initialize__140_cnst_initialize();
	}
      else
	{
	   return read_full_cnst_initialize__176_cnst_initialize();
	}
   }
}


obj_t 
read_empty_cnst_initialize__140_cnst_initialize()
{
   {
      obj_t arg1339_695;
      arg1339_695 = get_cnst_table_42_cnst_alloc();
      {
	 obj_t res1852_1423;
	 {
	    global_t obj_1421;
	    obj_t val1036_1422;
	    obj_1421 = (global_t) (arg1339_695);
	    val1036_1422 = string1858_cnst_initialize;
	    {
	       obj_t x_1455;
	       x_1455 = ((((global_t) CREF(obj_1421))->name) = ((obj_t) val1036_1422), BUNSPEC);
	       res1852_1423 = BUNSPEC;
	    }
	 }
	 res1852_1423;
      }
   }
   return get_cnst_sexp_197_cnst_alloc();
}


obj_t 
read_full_cnst_initialize__176_cnst_initialize()
{
   {
      obj_t cnst_string_99_711;
      {
	 obj_t arg1342_698;
	 obj_t arg1343_699;
	 arg1342_698 = get_cnst_table_42_cnst_alloc();
	 {
	    char *arg1346_701;
	    {
	       obj_t arg1353_707;
	       arg1353_707 = get_cnst_offset_21_cnst_alloc();
	       arg1346_701 = number__string_214___r4_numbers_6_5(arg1353_707, BNIL);
	    }
	    {
	       obj_t list1348_703;
	       {
		  obj_t arg1349_704;
		  {
		     obj_t arg1350_705;
		     arg1350_705 = MAKE_PAIR(string1859_cnst_initialize, BNIL);
		     {
			obj_t aux_1561;
			aux_1561 = string_to_bstring(arg1346_701);
			arg1349_704 = MAKE_PAIR(aux_1561, arg1350_705);
		     }
		  }
		  list1348_703 = MAKE_PAIR(string1860_cnst_initialize, arg1349_704);
	       }
	       arg1343_699 = string_append_106___r4_strings_6_7(list1348_703);
	    }
	 }
	 {
	    obj_t res1853_1426;
	    {
	       global_t obj_1424;
	       obj_1424 = (global_t) (arg1342_698);
	       {
		  obj_t x_1456;
		  x_1456 = ((((global_t) CREF(obj_1424))->name) = ((obj_t) arg1343_699), BUNSPEC);
		  res1853_1426 = BUNSPEC;
	       }
	    }
	    res1853_1426;
	 }
      }
      {
	 obj_t cnst_string_99_709;
	 {
	    obj_t arg1355_710;
	    arg1355_710 = get_cnst_set_138_cnst_alloc();
	    cnst_string_99_709 = cnst_set__cnst_string_40_cnst_initialize(arg1355_710);
	 }
	 {
	    cnst_string_99_711 = cnst_string_99_709;
	    {
	       node_t var_string_203_713;
	       var_string_203_713 = cnst_alloc_string_41_cnst_alloc(cnst_string_99_711, BFALSE);
	       {
		  obj_t sexp_714;
		  {
		     obj_t arg1358_716;
		     obj_t arg1359_717;
		     obj_t arg1361_718;
		     arg1358_716 = CNST_TABLE_REF(((long) 5));
		     {
			obj_t arg1370_724;
			{
			   obj_t arg1379_728;
			   obj_t arg1380_729;
			   arg1379_728 = CNST_TABLE_REF(((long) 6));
			   {
			      obj_t arg1390_734;
			      obj_t arg1391_735;
			      arg1390_734 = CNST_TABLE_REF(((long) 7));
			      {
				 global_t obj_1428;
				 {
				    variable_t aux_1574;
				    {
				       var_t obj_1427;
				       obj_1427 = (var_t) (var_string_203_713);
				       aux_1574 = (((var_t) CREF(obj_1427))->variable);
				    }
				    obj_1428 = (global_t) (aux_1574);
				 }
				 arg1391_735 = (((global_t) CREF(obj_1428))->id);
			      }
			      {
				 obj_t list1397_737;
				 {
				    obj_t arg1398_738;
				    arg1398_738 = MAKE_PAIR(BNIL, BNIL);
				    list1397_737 = MAKE_PAIR(arg1391_735, arg1398_738);
				 }
				 arg1380_729 = cons__138___r4_pairs_and_lists_6_3(arg1390_734, list1397_737);
			      }
			   }
			   {
			      obj_t list1382_731;
			      {
				 obj_t arg1385_732;
				 arg1385_732 = MAKE_PAIR(BNIL, BNIL);
				 list1382_731 = MAKE_PAIR(arg1380_729, arg1385_732);
			      }
			      arg1370_724 = cons__138___r4_pairs_and_lists_6_3(arg1379_728, list1382_731);
			   }
			}
			{
			   obj_t list1373_726;
			   list1373_726 = MAKE_PAIR(BNIL, BNIL);
			   arg1359_717 = cons__138___r4_pairs_and_lists_6_3(arg1370_724, list1373_726);
			}
		     }
		     {
			obj_t arg1403_741;
			obj_t arg1404_742;
			obj_t arg1406_743;
			arg1403_741 = CNST_TABLE_REF(((long) 8));
			{
			   obj_t arg1414_749;
			   {
			      obj_t arg1418_753;
			      obj_t arg1420_754;
			      obj_t arg1421_755;
			      arg1418_753 = CNST_TABLE_REF(((long) 9));
			      {
				 obj_t arg1431_761;
				 arg1431_761 = CNST_TABLE_REF(((long) 10));
				 {
				    obj_t list1433_763;
				    list1433_763 = MAKE_PAIR(BNIL, BNIL);
				    arg1420_754 = cons__138___r4_pairs_and_lists_6_3(arg1431_761, list1433_763);
				 }
			      }
			      {
				 obj_t arg1441_765;
				 obj_t arg1444_766;
				 obj_t arg1445_767;
				 arg1441_765 = CNST_TABLE_REF(((long) 11));
				 {
				    obj_t arg1453_774;
				    obj_t arg1454_775;
				    arg1453_774 = CNST_TABLE_REF(((long) 12));
				    arg1454_775 = CNST_TABLE_REF(((long) 13));
				    {
				       obj_t list1459_778;
				       {
					  obj_t arg1461_779;
					  {
					     obj_t arg1463_780;
					     arg1463_780 = MAKE_PAIR(BNIL, BNIL);
					     {
						obj_t aux_1596;
						aux_1596 = BINT(((long) -1));
						arg1461_779 = MAKE_PAIR(aux_1596, arg1463_780);
					     }
					  }
					  list1459_778 = MAKE_PAIR(arg1454_775, arg1461_779);
				       }
				       arg1444_766 = cons__138___r4_pairs_and_lists_6_3(arg1453_774, list1459_778);
				    }
				 }
				 {
				    obj_t arg1466_782;
				    obj_t arg1467_783;
				    obj_t arg1468_784;
				    arg1466_782 = CNST_TABLE_REF(((long) 14));
				    {
				       obj_t arg1477_790;
				       obj_t arg1478_791;
				       obj_t arg1480_792;
				       arg1477_790 = CNST_TABLE_REF(((long) 15));
				       arg1478_791 = CNST_TABLE_REF(((long) 13));
				       {
					  obj_t arg1487_798;
					  obj_t arg1489_799;
					  {
					     obj_t arg1496_804;
					     obj_t arg1497_805;
					     obj_t arg1498_806;
					     arg1496_804 = CNST_TABLE_REF(((long) 16));
					     arg1497_805 = CNST_TABLE_REF(((long) 1));
					     arg1498_806 = CNST_TABLE_REF(((long) 17));
					     {
						obj_t list1500_808;
						{
						   obj_t arg1501_809;
						   {
						      obj_t arg1505_810;
						      arg1505_810 = MAKE_PAIR(BNIL, BNIL);
						      arg1501_809 = MAKE_PAIR(arg1498_806, arg1505_810);
						   }
						   list1500_808 = MAKE_PAIR(arg1497_805, arg1501_809);
						}
						arg1487_798 = cons__138___r4_pairs_and_lists_6_3(arg1496_804, list1500_808);
					     }
					  }
					  arg1489_799 = CNST_TABLE_REF(((long) 18));
					  {
					     obj_t list1491_801;
					     {
						obj_t arg1493_802;
						arg1493_802 = MAKE_PAIR(BNIL, BNIL);
						list1491_801 = MAKE_PAIR(arg1489_799, arg1493_802);
					     }
					     arg1480_792 = cons__138___r4_pairs_and_lists_6_3(arg1487_798, list1491_801);
					  }
				       }
				       {
					  obj_t list1482_794;
					  {
					     obj_t arg1484_795;
					     {
						obj_t arg1485_796;
						arg1485_796 = MAKE_PAIR(BNIL, BNIL);
						arg1484_795 = MAKE_PAIR(arg1480_792, arg1485_796);
					     }
					     list1482_794 = MAKE_PAIR(arg1478_791, arg1484_795);
					  }
					  arg1467_783 = cons__138___r4_pairs_and_lists_6_3(arg1477_790, list1482_794);
				       }
				    }
				    {
				       obj_t arg1507_812;
				       obj_t arg1509_813;
				       obj_t arg1510_814;
				       arg1507_812 = CNST_TABLE_REF(((long) 5));
				       {
					  obj_t arg1518_820;
					  {
					     obj_t arg1523_824;
					     obj_t arg1524_825;
					     arg1523_824 = CNST_TABLE_REF(((long) 19));
					     {
						obj_t arg1532_830;
						obj_t arg1534_831;
						arg1532_830 = CNST_TABLE_REF(((long) 20));
						arg1534_831 = CNST_TABLE_REF(((long) 13));
						{
						   obj_t list1537_834;
						   {
						      obj_t arg1538_835;
						      {
							 obj_t arg1539_836;
							 arg1539_836 = MAKE_PAIR(BNIL, BNIL);
							 {
							    obj_t aux_1624;
							    aux_1624 = BINT(((long) 1));
							    arg1538_835 = MAKE_PAIR(aux_1624, arg1539_836);
							 }
						      }
						      list1537_834 = MAKE_PAIR(arg1534_831, arg1538_835);
						   }
						   arg1524_825 = cons__138___r4_pairs_and_lists_6_3(arg1532_830, list1537_834);
						}
					     }
					     {
						obj_t list1527_827;
						{
						   obj_t arg1529_828;
						   arg1529_828 = MAKE_PAIR(BNIL, BNIL);
						   list1527_827 = MAKE_PAIR(arg1524_825, arg1529_828);
						}
						arg1518_820 = cons__138___r4_pairs_and_lists_6_3(arg1523_824, list1527_827);
					     }
					  }
					  {
					     obj_t list1521_822;
					     list1521_822 = MAKE_PAIR(BNIL, BNIL);
					     arg1509_813 = cons__138___r4_pairs_and_lists_6_3(arg1518_820, list1521_822);
					  }
				       }
				       {
					  obj_t arg1541_838;
					  obj_t arg1542_839;
					  arg1541_838 = CNST_TABLE_REF(((long) 9));
					  arg1542_839 = CNST_TABLE_REF(((long) 21));
					  {
					     obj_t list1544_841;
					     {
						obj_t arg1547_842;
						arg1547_842 = MAKE_PAIR(BNIL, BNIL);
						list1544_841 = MAKE_PAIR(arg1542_839, arg1547_842);
					     }
					     arg1510_814 = cons__138___r4_pairs_and_lists_6_3(arg1541_838, list1544_841);
					  }
				       }
				       {
					  obj_t list1512_816;
					  {
					     obj_t arg1513_817;
					     {
						obj_t arg1514_818;
						arg1514_818 = MAKE_PAIR(BNIL, BNIL);
						arg1513_817 = MAKE_PAIR(arg1510_814, arg1514_818);
					     }
					     list1512_816 = MAKE_PAIR(arg1509_813, arg1513_817);
					  }
					  arg1468_784 = cons__138___r4_pairs_and_lists_6_3(arg1507_812, list1512_816);
				       }
				    }
				    {
				       obj_t list1471_786;
				       {
					  obj_t arg1472_787;
					  {
					     obj_t arg1474_788;
					     arg1474_788 = MAKE_PAIR(BNIL, BNIL);
					     arg1472_787 = MAKE_PAIR(arg1468_784, arg1474_788);
					  }
					  list1471_786 = MAKE_PAIR(arg1467_783, arg1472_787);
				       }
				       arg1445_767 = cons__138___r4_pairs_and_lists_6_3(arg1466_782, list1471_786);
				    }
				 }
				 {
				    obj_t list1447_769;
				    {
				       obj_t arg1448_770;
				       {
					  obj_t arg1449_771;
					  {
					     obj_t arg1450_772;
					     arg1450_772 = MAKE_PAIR(BNIL, BNIL);
					     arg1449_771 = MAKE_PAIR(arg1445_767, arg1450_772);
					  }
					  arg1448_770 = MAKE_PAIR(BUNSPEC, arg1449_771);
				       }
				       list1447_769 = MAKE_PAIR(arg1444_766, arg1448_770);
				    }
				    arg1421_755 = cons__138___r4_pairs_and_lists_6_3(arg1441_765, list1447_769);
				 }
			      }
			      {
				 obj_t list1425_757;
				 {
				    obj_t arg1426_758;
				    {
				       obj_t arg1427_759;
				       arg1427_759 = MAKE_PAIR(BNIL, BNIL);
				       arg1426_758 = MAKE_PAIR(arg1421_755, arg1427_759);
				    }
				    list1425_757 = MAKE_PAIR(arg1420_754, arg1426_758);
				 }
				 arg1414_749 = cons__138___r4_pairs_and_lists_6_3(arg1418_753, list1425_757);
			      }
			   }
			   {
			      obj_t list1416_751;
			      list1416_751 = MAKE_PAIR(BNIL, BNIL);
			      arg1404_742 = cons__138___r4_pairs_and_lists_6_3(arg1414_749, list1416_751);
			   }
			}
			{
			   obj_t arg1550_844;
			   long arg1551_845;
			   arg1550_844 = CNST_TABLE_REF(((long) 9));
			   {
			      obj_t arg1557_850;
			      arg1557_850 = get_cnst_offset_21_cnst_alloc();
			      {
				 long aux_1660;
				 aux_1660 = (long) CINT(arg1557_850);
				 arg1551_845 = (aux_1660 - ((long) 1));
			      }
			   }
			   {
			      obj_t list1553_847;
			      {
				 obj_t arg1554_848;
				 arg1554_848 = MAKE_PAIR(BNIL, BNIL);
				 {
				    obj_t aux_1664;
				    aux_1664 = BINT(arg1551_845);
				    list1553_847 = MAKE_PAIR(aux_1664, arg1554_848);
				 }
			      }
			      arg1406_743 = cons__138___r4_pairs_and_lists_6_3(arg1550_844, list1553_847);
			   }
			}
			{
			   obj_t list1409_745;
			   {
			      obj_t arg1410_746;
			      {
				 obj_t arg1411_747;
				 arg1411_747 = MAKE_PAIR(BNIL, BNIL);
				 arg1410_746 = MAKE_PAIR(arg1406_743, arg1411_747);
			      }
			      list1409_745 = MAKE_PAIR(arg1404_742, arg1410_746);
			   }
			   arg1361_718 = cons__138___r4_pairs_and_lists_6_3(arg1403_741, list1409_745);
			}
		     }
		     {
			obj_t list1364_720;
			{
			   obj_t arg1366_721;
			   {
			      obj_t arg1367_722;
			      arg1367_722 = MAKE_PAIR(BNIL, BNIL);
			      arg1366_721 = MAKE_PAIR(arg1361_718, arg1367_722);
			   }
			   list1364_720 = MAKE_PAIR(arg1359_717, arg1366_721);
			}
			sexp_714 = cons__138___r4_pairs_and_lists_6_3(arg1358_716, list1364_720);
		     }
		  }
		  {
		     {
			obj_t arg1357_715;
			arg1357_715 = get_cnst_sexp_197_cnst_alloc();
			return MAKE_PAIR(sexp_714, arg1357_715);
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
cnst_set__cnst_string_40_cnst_initialize(obj_t set_19)
{
   {
      obj_t port_853;
      port_853 = open_output_string();
      if (OUTPUT_PORTP(port_853))
	{
	   {
	      obj_t l1284_855;
	      l1284_855 = set_19;
	    lname1285_856:
	      if (PAIRP(l1284_855))
		{
		   {
		      obj_t cnst_858;
		      cnst_858 = CAR(l1284_855);
		      {
			 obj_t list1562_859;
			 list1562_859 = MAKE_PAIR(port_853, BNIL);
			 write___r4_output_6_10_3(cnst_858, list1562_859);
		      }
		      {
			 obj_t list1564_861;
			 list1564_861 = MAKE_PAIR(port_853, BNIL);
			 write_char_165___r4_output_6_10_3(((unsigned char) ' '), list1564_861);
		      }
		   }
		   {
		      obj_t l1284_1688;
		      l1284_1688 = CDR(l1284_855);
		      l1284_855 = l1284_1688;
		      goto lname1285_856;
		   }
		}
	      else
		{
		   ((bool_t) 1);
		}
	   }
	   return close_output_port(port_853);
	}
      else
	{
	   return internal_error_43_tools_error(string1861_cnst_initialize, string1862_cnst_initialize, port_853);
	}
   }
}


obj_t 
intern_initialize__196_cnst_initialize()
{
   {
      bool_t test1567_864;
      {
	 obj_t arg1568_865;
	 arg1568_865 = get_cnst_offset_21_cnst_alloc();
	 {
	    long aux_1693;
	    aux_1693 = (long) CINT(arg1568_865);
	    test1567_864 = (aux_1693 == ((long) 0));
	 }
      }
      if (test1567_864)
	{
	   return intern_empty_cnst_initialize__171_cnst_initialize();
	}
      else
	{
	   return intern_full_cnst_initialize__85_cnst_initialize();
	}
   }
}


obj_t 
intern_empty_cnst_initialize__171_cnst_initialize()
{
   {
      obj_t arg1571_867;
      arg1571_867 = get_cnst_table_42_cnst_alloc();
      {
	 obj_t res1854_1442;
	 {
	    global_t obj_1440;
	    obj_t val1036_1441;
	    obj_1440 = (global_t) (arg1571_867);
	    val1036_1441 = string1858_cnst_initialize;
	    {
	       obj_t x_1457;
	       x_1457 = ((((global_t) CREF(obj_1440))->name) = ((obj_t) val1036_1441), BUNSPEC);
	       res1854_1442 = BUNSPEC;
	    }
	 }
	 res1854_1442;
      }
   }
   return get_cnst_sexp_197_cnst_alloc();
}


obj_t 
intern_full_cnst_initialize__85_cnst_initialize()
{
   {
      obj_t cnst_string_99_885;
      {
	 obj_t arg1573_870;
	 obj_t arg1574_871;
	 arg1573_870 = get_cnst_table_42_cnst_alloc();
	 {
	    char *arg1576_873;
	    {
	       obj_t arg1584_879;
	       arg1584_879 = get_cnst_offset_21_cnst_alloc();
	       arg1576_873 = number__string_214___r4_numbers_6_5(arg1584_879, BNIL);
	    }
	    {
	       obj_t list1578_875;
	       {
		  obj_t arg1579_876;
		  {
		     obj_t arg1582_877;
		     arg1582_877 = MAKE_PAIR(string1859_cnst_initialize, BNIL);
		     {
			obj_t aux_1707;
			aux_1707 = string_to_bstring(arg1576_873);
			arg1579_876 = MAKE_PAIR(aux_1707, arg1582_877);
		     }
		  }
		  list1578_875 = MAKE_PAIR(string1860_cnst_initialize, arg1579_876);
	       }
	       arg1574_871 = string_append_106___r4_strings_6_7(list1578_875);
	    }
	 }
	 {
	    obj_t res1855_1445;
	    {
	       global_t obj_1443;
	       obj_1443 = (global_t) (arg1573_870);
	       {
		  obj_t x_1458;
		  x_1458 = ((((global_t) CREF(obj_1443))->name) = ((obj_t) arg1574_871), BUNSPEC);
		  res1855_1445 = BUNSPEC;
	       }
	    }
	    res1855_1445;
	 }
      }
      {
	 obj_t cnst_string_99_881;
	 {
	    obj_t arg1587_882;
	    {
	       obj_t arg1588_883;
	       {
		  obj_t arg1589_884;
		  arg1589_884 = get_cnst_set_138_cnst_alloc();
		  arg1588_883 = reverse__39___r4_pairs_and_lists_6_3(arg1589_884);
	       }
	       arg1587_882 = list__vector_101___r4_vectors_6_8(arg1588_883);
	    }
	    cnst_string_99_881 = obj_to_string(arg1587_882);
	 }
	 {
	    cnst_string_99_885 = cnst_string_99_881;
	    {
	       node_t var_string_203_887;
	       var_string_203_887 = cnst_alloc_string_41_cnst_alloc(cnst_string_99_885, BFALSE);
	       {
		  obj_t sexp_888;
		  {
		     obj_t arg1592_890;
		     obj_t arg1593_891;
		     obj_t arg1595_892;
		     arg1592_890 = CNST_TABLE_REF(((long) 5));
		     {
			obj_t arg1604_898;
			{
			   obj_t arg1609_902;
			   obj_t arg1611_903;
			   arg1609_902 = CNST_TABLE_REF(((long) 22));
			   {
			      obj_t arg1618_908;
			      obj_t arg1619_909;
			      {
				 obj_t arg1626_914;
				 obj_t arg1627_915;
				 obj_t arg1628_916;
				 arg1626_914 = CNST_TABLE_REF(((long) 16));
				 arg1627_915 = CNST_TABLE_REF(((long) 23));
				 arg1628_916 = CNST_TABLE_REF(((long) 24));
				 {
				    obj_t list1631_918;
				    {
				       obj_t arg1632_919;
				       {
					  obj_t arg1634_920;
					  arg1634_920 = MAKE_PAIR(BNIL, BNIL);
					  arg1632_919 = MAKE_PAIR(arg1628_916, arg1634_920);
				       }
				       list1631_918 = MAKE_PAIR(arg1627_915, arg1632_919);
				    }
				    arg1618_908 = cons__138___r4_pairs_and_lists_6_3(arg1626_914, list1631_918);
				 }
			      }
			      {
				 global_t obj_1447;
				 {
				    variable_t aux_1728;
				    {
				       var_t obj_1446;
				       obj_1446 = (var_t) (var_string_203_887);
				       aux_1728 = (((var_t) CREF(obj_1446))->variable);
				    }
				    obj_1447 = (global_t) (aux_1728);
				 }
				 arg1619_909 = (((global_t) CREF(obj_1447))->id);
			      }
			      {
				 obj_t list1621_911;
				 {
				    obj_t arg1623_912;
				    arg1623_912 = MAKE_PAIR(BNIL, BNIL);
				    list1621_911 = MAKE_PAIR(arg1619_909, arg1623_912);
				 }
				 arg1611_903 = cons__138___r4_pairs_and_lists_6_3(arg1618_908, list1621_911);
			      }
			   }
			   {
			      obj_t list1615_905;
			      {
				 obj_t arg1616_906;
				 arg1616_906 = MAKE_PAIR(BNIL, BNIL);
				 list1615_905 = MAKE_PAIR(arg1611_903, arg1616_906);
			      }
			      arg1604_898 = cons__138___r4_pairs_and_lists_6_3(arg1609_902, list1615_905);
			   }
			}
			{
			   obj_t list1606_900;
			   list1606_900 = MAKE_PAIR(BNIL, BNIL);
			   arg1593_891 = cons__138___r4_pairs_and_lists_6_3(arg1604_898, list1606_900);
			}
		     }
		     {
			obj_t arg1641_923;
			obj_t arg1642_924;
			obj_t arg1643_925;
			arg1641_923 = CNST_TABLE_REF(((long) 8));
			{
			   obj_t arg1650_931;
			   {
			      obj_t arg1654_935;
			      obj_t arg1655_936;
			      obj_t arg1656_937;
			      arg1654_935 = CNST_TABLE_REF(((long) 9));
			      {
				 obj_t arg1664_943;
				 arg1664_943 = CNST_TABLE_REF(((long) 25));
				 {
				    obj_t list1666_945;
				    list1666_945 = MAKE_PAIR(BNIL, BNIL);
				    arg1655_936 = cons__138___r4_pairs_and_lists_6_3(arg1664_943, list1666_945);
				 }
			      }
			      {
				 obj_t arg1668_947;
				 obj_t arg1669_948;
				 obj_t arg1671_949;
				 arg1668_947 = CNST_TABLE_REF(((long) 11));
				 {
				    obj_t arg1681_956;
				    obj_t arg1682_957;
				    arg1681_956 = CNST_TABLE_REF(((long) 12));
				    arg1682_957 = CNST_TABLE_REF(((long) 13));
				    {
				       obj_t list1687_960;
				       {
					  obj_t arg1688_961;
					  {
					     obj_t arg1689_962;
					     arg1689_962 = MAKE_PAIR(BNIL, BNIL);
					     {
						obj_t aux_1750;
						aux_1750 = BINT(((long) -1));
						arg1688_961 = MAKE_PAIR(aux_1750, arg1689_962);
					     }
					  }
					  list1687_960 = MAKE_PAIR(arg1682_957, arg1688_961);
				       }
				       arg1669_948 = cons__138___r4_pairs_and_lists_6_3(arg1681_956, list1687_960);
				    }
				 }
				 {
				    obj_t arg1691_964;
				    obj_t arg1693_965;
				    obj_t arg1694_966;
				    arg1691_964 = CNST_TABLE_REF(((long) 14));
				    {
				       obj_t arg1701_972;
				       obj_t arg1702_973;
				       obj_t arg1703_974;
				       arg1701_972 = CNST_TABLE_REF(((long) 15));
				       arg1702_973 = CNST_TABLE_REF(((long) 13));
				       {
					  obj_t arg1709_980;
					  obj_t arg1710_981;
					  obj_t arg1711_982;
					  arg1709_980 = CNST_TABLE_REF(((long) 26));
					  arg1710_981 = CNST_TABLE_REF(((long) 27));
					  arg1711_982 = CNST_TABLE_REF(((long) 13));
					  {
					     obj_t list1713_984;
					     {
						obj_t arg1714_985;
						{
						   obj_t arg1715_986;
						   arg1715_986 = MAKE_PAIR(BNIL, BNIL);
						   arg1714_985 = MAKE_PAIR(arg1711_982, arg1715_986);
						}
						list1713_984 = MAKE_PAIR(arg1710_981, arg1714_985);
					     }
					     arg1703_974 = cons__138___r4_pairs_and_lists_6_3(arg1709_980, list1713_984);
					  }
				       }
				       {
					  obj_t list1705_976;
					  {
					     obj_t arg1706_977;
					     {
						obj_t arg1707_978;
						arg1707_978 = MAKE_PAIR(BNIL, BNIL);
						arg1706_977 = MAKE_PAIR(arg1703_974, arg1707_978);
					     }
					     list1705_976 = MAKE_PAIR(arg1702_973, arg1706_977);
					  }
					  arg1693_965 = cons__138___r4_pairs_and_lists_6_3(arg1701_972, list1705_976);
				       }
				    }
				    {
				       obj_t arg1717_988;
				       obj_t arg1718_989;
				       obj_t arg1719_990;
				       arg1717_988 = CNST_TABLE_REF(((long) 5));
				       {
					  obj_t arg1730_996;
					  {
					     obj_t arg1734_1000;
					     obj_t arg1735_1001;
					     arg1734_1000 = CNST_TABLE_REF(((long) 19));
					     {
						obj_t arg1741_1006;
						obj_t arg1742_1007;
						arg1741_1006 = CNST_TABLE_REF(((long) 20));
						arg1742_1007 = CNST_TABLE_REF(((long) 13));
						{
						   obj_t list1746_1010;
						   {
						      obj_t arg1747_1011;
						      {
							 obj_t arg1748_1012;
							 arg1748_1012 = MAKE_PAIR(BNIL, BNIL);
							 {
							    obj_t aux_1774;
							    aux_1774 = BINT(((long) 1));
							    arg1747_1011 = MAKE_PAIR(aux_1774, arg1748_1012);
							 }
						      }
						      list1746_1010 = MAKE_PAIR(arg1742_1007, arg1747_1011);
						   }
						   arg1735_1001 = cons__138___r4_pairs_and_lists_6_3(arg1741_1006, list1746_1010);
						}
					     }
					     {
						obj_t list1737_1003;
						{
						   obj_t arg1738_1004;
						   arg1738_1004 = MAKE_PAIR(BNIL, BNIL);
						   list1737_1003 = MAKE_PAIR(arg1735_1001, arg1738_1004);
						}
						arg1730_996 = cons__138___r4_pairs_and_lists_6_3(arg1734_1000, list1737_1003);
					     }
					  }
					  {
					     obj_t list1732_998;
					     list1732_998 = MAKE_PAIR(BNIL, BNIL);
					     arg1718_989 = cons__138___r4_pairs_and_lists_6_3(arg1730_996, list1732_998);
					  }
				       }
				       {
					  obj_t arg1751_1014;
					  obj_t arg1753_1015;
					  arg1751_1014 = CNST_TABLE_REF(((long) 9));
					  arg1753_1015 = CNST_TABLE_REF(((long) 21));
					  {
					     obj_t list1755_1017;
					     {
						obj_t arg1756_1018;
						arg1756_1018 = MAKE_PAIR(BNIL, BNIL);
						list1755_1017 = MAKE_PAIR(arg1753_1015, arg1756_1018);
					     }
					     arg1719_990 = cons__138___r4_pairs_and_lists_6_3(arg1751_1014, list1755_1017);
					  }
				       }
				       {
					  obj_t list1721_992;
					  {
					     obj_t arg1722_993;
					     {
						obj_t arg1724_994;
						arg1724_994 = MAKE_PAIR(BNIL, BNIL);
						arg1722_993 = MAKE_PAIR(arg1719_990, arg1724_994);
					     }
					     list1721_992 = MAKE_PAIR(arg1718_989, arg1722_993);
					  }
					  arg1694_966 = cons__138___r4_pairs_and_lists_6_3(arg1717_988, list1721_992);
				       }
				    }
				    {
				       obj_t list1696_968;
				       {
					  obj_t arg1697_969;
					  {
					     obj_t arg1698_970;
					     arg1698_970 = MAKE_PAIR(BNIL, BNIL);
					     arg1697_969 = MAKE_PAIR(arg1694_966, arg1698_970);
					  }
					  list1696_968 = MAKE_PAIR(arg1693_965, arg1697_969);
				       }
				       arg1671_949 = cons__138___r4_pairs_and_lists_6_3(arg1691_964, list1696_968);
				    }
				 }
				 {
				    obj_t list1674_951;
				    {
				       obj_t arg1677_952;
				       {
					  obj_t arg1678_953;
					  {
					     obj_t arg1679_954;
					     arg1679_954 = MAKE_PAIR(BNIL, BNIL);
					     arg1678_953 = MAKE_PAIR(arg1671_949, arg1679_954);
					  }
					  arg1677_952 = MAKE_PAIR(BUNSPEC, arg1678_953);
				       }
				       list1674_951 = MAKE_PAIR(arg1669_948, arg1677_952);
				    }
				    arg1656_937 = cons__138___r4_pairs_and_lists_6_3(arg1668_947, list1674_951);
				 }
			      }
			      {
				 obj_t list1658_939;
				 {
				    obj_t arg1659_940;
				    {
				       obj_t arg1661_941;
				       arg1661_941 = MAKE_PAIR(BNIL, BNIL);
				       arg1659_940 = MAKE_PAIR(arg1656_937, arg1661_941);
				    }
				    list1658_939 = MAKE_PAIR(arg1655_936, arg1659_940);
				 }
				 arg1650_931 = cons__138___r4_pairs_and_lists_6_3(arg1654_935, list1658_939);
			      }
			   }
			   {
			      obj_t list1652_933;
			      list1652_933 = MAKE_PAIR(BNIL, BNIL);
			      arg1642_924 = cons__138___r4_pairs_and_lists_6_3(arg1650_931, list1652_933);
			   }
			}
			{
			   obj_t arg1759_1020;
			   long arg1761_1021;
			   arg1759_1020 = CNST_TABLE_REF(((long) 9));
			   {
			      obj_t arg1767_1026;
			      arg1767_1026 = get_cnst_offset_21_cnst_alloc();
			      {
				 long aux_1810;
				 aux_1810 = (long) CINT(arg1767_1026);
				 arg1761_1021 = (aux_1810 - ((long) 1));
			      }
			   }
			   {
			      obj_t list1763_1023;
			      {
				 obj_t arg1764_1024;
				 arg1764_1024 = MAKE_PAIR(BNIL, BNIL);
				 {
				    obj_t aux_1814;
				    aux_1814 = BINT(arg1761_1021);
				    list1763_1023 = MAKE_PAIR(aux_1814, arg1764_1024);
				 }
			      }
			      arg1643_925 = cons__138___r4_pairs_and_lists_6_3(arg1759_1020, list1763_1023);
			   }
			}
			{
			   obj_t list1645_927;
			   {
			      obj_t arg1646_928;
			      {
				 obj_t arg1647_929;
				 arg1647_929 = MAKE_PAIR(BNIL, BNIL);
				 arg1646_928 = MAKE_PAIR(arg1643_925, arg1647_929);
			      }
			      list1645_927 = MAKE_PAIR(arg1642_924, arg1646_928);
			   }
			   arg1595_892 = cons__138___r4_pairs_and_lists_6_3(arg1641_923, list1645_927);
			}
		     }
		     {
			obj_t list1597_894;
			{
			   obj_t arg1600_895;
			   {
			      obj_t arg1601_896;
			      arg1601_896 = MAKE_PAIR(BNIL, BNIL);
			      arg1600_895 = MAKE_PAIR(arg1595_892, arg1601_896);
			   }
			   list1597_894 = MAKE_PAIR(arg1593_891, arg1600_895);
			}
			sexp_888 = cons__138___r4_pairs_and_lists_6_3(arg1592_890, list1597_894);
		     }
		  }
		  {
		     {
			obj_t arg1591_889;
			arg1591_889 = get_cnst_sexp_197_cnst_alloc();
			return MAKE_PAIR(sexp_888, arg1591_889);
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
imported_modules_init_94_cnst_initialize()
{
   module_initialization_70_tools_trace(((long) 0), "CNST_INITIALIZE");
   module_initialization_70_tools_shape(((long) 0), "CNST_INITIALIZE");
   module_initialization_70_tools_speek(((long) 0), "CNST_INITIALIZE");
   module_initialization_70_tools_error(((long) 0), "CNST_INITIALIZE");
   module_initialization_70_engine_param(((long) 0), "CNST_INITIALIZE");
   module_initialization_70_type_type(((long) 0), "CNST_INITIALIZE");
   module_initialization_70_type_cache(((long) 0), "CNST_INITIALIZE");
   module_initialization_70_ast_var(((long) 0), "CNST_INITIALIZE");
   module_initialization_70_ast_node(((long) 0), "CNST_INITIALIZE");
   module_initialization_70_ast_env(((long) 0), "CNST_INITIALIZE");
   module_initialization_70_ast_build(((long) 0), "CNST_INITIALIZE");
   module_initialization_70_ast_lvtype(((long) 0), "CNST_INITIALIZE");
   module_initialization_70_coerce_coerce(((long) 0), "CNST_INITIALIZE");
   module_initialization_70_cnst_alloc(((long) 0), "CNST_INITIALIZE");
   return module_initialization_70_cnst_node(((long) 0), "CNST_INITIALIZE");
}
