/*===========================================================================*/
/*   (Cnst/node.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct local_bvalue_105
  {
     struct node *binding_value_3;
  }
                *local_bvalue_105_t;


static obj_t _get_node_atom_value_default1341_59_cnst_node(obj_t, obj_t);
static obj_t get_node_atom_value_135_cnst_node(node_t);
extern obj_t let_fun_218_ast_node;
static obj_t object__struct_local_bvalue1783_199_cnst_node(obj_t, obj_t);
static obj_t cnst___82_cnst_node(obj_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern node_t cnst_alloc_list_56_cnst_alloc(obj_t, obj_t);
extern node_t cnst_alloc_symbol_123_cnst_alloc(obj_t, obj_t);
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
extern node_t cnst__44_cnst_node(node_t);
extern obj_t _struct_object__object_6___object(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_cnst_node();
extern obj_t module_initialization_70_cnst_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_cnst_cache(long, char *);
extern obj_t module_initialization_70_cnst_alloc(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_cnst_node();
static obj_t struct_object__object_local_bvalue1782_36_cnst_node(obj_t, obj_t, obj_t);
static obj_t cnst_init_137_cnst_node();
extern node_t cnst_alloc_tvector_190_cnst_alloc(obj_t, obj_t);
extern obj_t __make_fx_procedure__51_cnst_cache;
extern obj_t __btrue__29_cnst_cache;
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
static local_t allocate_local_bvalue_47_cnst_node();
static obj_t require_initialization_114_cnst_node = BUNSPEC;
static obj_t get_node_atom_value_default1341_201_cnst_node(node_t);
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
extern obj_t __bool__bbool__85_cnst_cache;
static obj_t library_modules_init_112_cnst_node();
static obj_t _cnst__default1317_32_cnst_node(obj_t, obj_t);
extern obj_t cast_ast_node;
extern node_t cnst_alloc_string_41_cnst_alloc(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern node_t cnst_alloc_real_118_cnst_alloc(obj_t, obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern node_t cnst_alloc_vector_65_cnst_alloc(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
static obj_t _get_node_atom_value_97_cnst_node(obj_t, obj_t);
extern obj_t __bbool__55_type_cache;
extern long class_num_218___object(obj_t);
static obj_t local_bvalue_105_cnst_node = BUNSPEC;
extern obj_t object__struct_50___object(object_t);
extern obj_t __make_va_procedure__53_cnst_cache;
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
static node_t cnst__default1317_16_cnst_node(node_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _cnst__135_cnst_node(obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
static obj_t object_init_111_cnst_node();
extern obj_t __bfalse__69_cnst_cache;
extern obj_t set_ex_it_116_ast_node;
static obj_t _allocate_local_bvalue_102_cnst_node(obj_t);
extern obj_t local_ast_var;
extern obj_t kwote_ast_node;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t __double__real__21_cnst_cache;
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t _object__struct_74___object(obj_t, obj_t);
extern node_t cnst_alloc_procedure_240_cnst_alloc(node_t, obj_t);
extern node_t cnst_alloc_keyword_47_cnst_alloc(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern object_t struct_object__object_93___object(object_t, obj_t);
extern obj_t __string__bstring__114_cnst_cache;
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t);
extern obj_t app_ast_node;
static obj_t __cnst[7];

DEFINE_EXPORT_GENERIC(cnst__env_43_cnst_node, _cnst__135_cnst_node1800, _cnst__135_cnst_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1790_cnst_node, object__struct_local_bvalue1783_199_cnst_node1801, object__struct_local_bvalue1783_199_cnst_node, 0L, 1);
DEFINE_STRING(string1792_cnst_node, string1792_cnst_node1802, "LOCAL/BVALUE (NO-ATOM-VALUE) DONE CNST READ A-TVECTOR CNST!-DEFAULT1317 ", 72);
DEFINE_STRING(string1788_cnst_node, string1788_cnst_node1803, "Unexepected `closure' node", 26);
DEFINE_STATIC_GENERIC(get_node_atom_value_env_18_cnst_node, _get_node_atom_value_97_cnst_node1804, _get_node_atom_value_97_cnst_node, 0L, 1);
DEFINE_STRING(string1789_cnst_node, string1789_cnst_node1805, "string->bstring: ", 17);
extern obj_t struct_object__object_env_209___object;
DEFINE_STATIC_PROCEDURE(proc1791_cnst_node, struct_object__object_local_bvalue1782_36_cnst_node1806, struct_object__object_local_bvalue1782_36_cnst_node, 0L, 2);
DEFINE_STRING(string1787_cnst_node, string1787_cnst_node1807, "cnst!", 5);
DEFINE_STATIC_PROCEDURE(get_node_atom_value_default1341_env_148_cnst_node, _get_node_atom_value_default1341_59_cnst_node1808, _get_node_atom_value_default1341_59_cnst_node, 0L, 1);
DEFINE_STRING(string1786_cnst_node, string1786_cnst_node1809, "Illegal expression", 18);
DEFINE_STRING(string1785_cnst_node, string1785_cnst_node1810, "cnst-quote", 10);
DEFINE_STATIC_PROCEDURE(cnst__default1317_env_165_cnst_node, _cnst__default1317_32_cnst_node1811, _cnst__default1317_32_cnst_node, 0L, 1);
extern obj_t object__struct_env_210___object;
DEFINE_STRING(string1784_cnst_node, string1784_cnst_node1812, "No method for this object", 25);
DEFINE_STATIC_PROCEDURE(allocate_local_bvalue_env_61_cnst_node, _allocate_local_bvalue_102_cnst_node1813, _allocate_local_bvalue_102_cnst_node, 0L, 0);

obj_t 
module_initialization_70_cnst_node(long checksum_1757, char *from_1758)
{
   if (CBOOL(require_initialization_114_cnst_node))
     {
	require_initialization_114_cnst_node = BBOOL(((bool_t) 0));
	library_modules_init_112_cnst_node();
	cnst_init_137_cnst_node();
	object_init_111_cnst_node();
	imported_modules_init_94_cnst_node();
	toplevel_init_63_cnst_node();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cnst_node()
{
   module_initialization_70___object(((long) 0), "CNST_NODE");
   module_initialization_70___reader(((long) 0), "CNST_NODE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cnst_node()
{
   {
      obj_t cnst_port_138_1749;
      cnst_port_138_1749 = open_input_string(string1792_cnst_node);
      {
	 long i_1750;
	 i_1750 = ((long) 6);
       loop_1751:
	 {
	    bool_t test1793_1752;
	    test1793_1752 = (i_1750 == ((long) -1));
	    if (test1793_1752)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1795_1753;
		    {
		       obj_t list1796_1754;
		       {
			  obj_t arg1798_1755;
			  arg1798_1755 = BNIL;
			  list1796_1754 = MAKE_PAIR(cnst_port_138_1749, arg1798_1755);
		       }
		       arg1795_1753 = read___reader(list1796_1754);
		    }
		    CNST_TABLE_SET(i_1750, arg1795_1753);
		 }
		 {
		    int aux_1756;
		    {
		       long aux_1775;
		       aux_1775 = (i_1750 - ((long) 1));
		       aux_1756 = (int) (aux_1775);
		    }
		    {
		       long i_1778;
		       i_1778 = (long) (aux_1756);
		       i_1750 = i_1778;
		       goto loop_1751;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cnst_node()
{
   add_generic__110___object(cnst__env_43_cnst_node, cnst__default1317_env_165_cnst_node);
   add_inlined_method__244___object(cnst__env_43_cnst_node, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(cnst__env_43_cnst_node, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(cnst__env_43_cnst_node, var_ast_node, ((long) 2));
   add_inlined_method__244___object(cnst__env_43_cnst_node, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(cnst__env_43_cnst_node, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(cnst__env_43_cnst_node, pragma_ast_node, ((long) 5));
   add_inlined_method__244___object(cnst__env_43_cnst_node, cast_ast_node, ((long) 6));
   add_inlined_method__244___object(cnst__env_43_cnst_node, setq_ast_node, ((long) 7));
   add_inlined_method__244___object(cnst__env_43_cnst_node, conditional_ast_node, ((long) 8));
   add_inlined_method__244___object(cnst__env_43_cnst_node, fail_ast_node, ((long) 9));
   add_inlined_method__244___object(cnst__env_43_cnst_node, select_ast_node, ((long) 10));
   add_inlined_method__244___object(cnst__env_43_cnst_node, let_fun_218_ast_node, ((long) 11));
   add_inlined_method__244___object(cnst__env_43_cnst_node, let_var_6_ast_node, ((long) 12));
   add_inlined_method__244___object(cnst__env_43_cnst_node, set_ex_it_116_ast_node, ((long) 13));
   add_inlined_method__244___object(cnst__env_43_cnst_node, jump_ex_it_184_ast_node, ((long) 14));
   add_inlined_method__244___object(cnst__env_43_cnst_node, make_box_202_ast_node, ((long) 15));
   add_inlined_method__244___object(cnst__env_43_cnst_node, box_ref_242_ast_node, ((long) 16));
   add_inlined_method__244___object(cnst__env_43_cnst_node, box_set__221_ast_node, ((long) 17));
   add_inlined_method__244___object(cnst__env_43_cnst_node, app_ly_162_ast_node, ((long) 18));
   add_inlined_method__244___object(cnst__env_43_cnst_node, funcall_ast_node, ((long) 19));
   add_inlined_method__244___object(cnst__env_43_cnst_node, app_ast_node, ((long) 20));
   add_generic__110___object(get_node_atom_value_env_18_cnst_node, get_node_atom_value_default1341_env_148_cnst_node);
   add_inlined_method__244___object(get_node_atom_value_env_18_cnst_node, atom_ast_node, ((long) 0));
   {
      long aux_1804;
      aux_1804 = add_inlined_method__244___object(get_node_atom_value_env_18_cnst_node, var_ast_node, ((long) 1));
      return BINT(aux_1804);
   }
}


node_t 
cnst__default1317_16_cnst_node(node_t node_12)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1784_cnst_node, (obj_t) (node_12));
}


obj_t 
_cnst__default1317_32_cnst_node(obj_t env_1708, obj_t node_1709)
{
   {
      node_t aux_1810;
      aux_1810 = cnst__default1317_16_cnst_node((node_t) (node_1709));
      return (obj_t) (aux_1810);
   }
}


node_t 
cnst__44_cnst_node(node_t node_11)
{
   {
      obj_t method1551_1108;
      obj_t class1556_1109;
      {
	 obj_t arg1559_1106;
	 obj_t arg1560_1107;
	 {
	    object_t obj_1343;
	    obj_1343 = (object_t) (node_11);
	    {
	       obj_t pre_method_105_1344;
	       pre_method_105_1344 = PROCEDURE_REF(cnst__env_43_cnst_node, ((long) 2));
	       if (INTEGERP(pre_method_105_1344))
		 {
		    PROCEDURE_SET(cnst__env_43_cnst_node, ((long) 2), BUNSPEC);
		    arg1559_1106 = pre_method_105_1344;
		 }
	       else
		 {
		    long obj_class_num_177_1349;
		    obj_class_num_177_1349 = TYPE(obj_1343);
		    {
		       obj_t arg1183_1350;
		       arg1183_1350 = PROCEDURE_REF(cnst__env_43_cnst_node, ((long) 1));
		       {
			  long arg1184_1354;
			  {
			     long arg1186_1355;
			     arg1186_1355 = OBJECT_TYPE;
			     arg1184_1354 = (obj_class_num_177_1349 - arg1186_1355);
			  }
			  arg1559_1106 = VECTOR_REF(arg1183_1350, arg1184_1354);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1360;
	    object_1360 = (object_t) (node_11);
	    {
	       long arg1187_1361;
	       {
		  long arg1188_1362;
		  long arg1189_1363;
		  arg1188_1362 = TYPE(object_1360);
		  arg1189_1363 = OBJECT_TYPE;
		  arg1187_1361 = (arg1188_1362 - arg1189_1363);
	       }
	       {
		  obj_t vector_1367;
		  vector_1367 = __classes__134___object;
		  arg1560_1107 = VECTOR_REF(vector_1367, arg1187_1361);
	       }
	    }
	 }
	 {
	    obj_t aux_1829;
	    method1551_1108 = arg1559_1106;
	    class1556_1109 = arg1560_1107;
	    {
	       if (INTEGERP(method1551_1108))
		 {
		    switch ((long) CINT(method1551_1108))
		      {
		      case ((long) 0):
			 {
			    atom_t node_1115;
			    node_1115 = (atom_t) (node_11);
			    {
			       bool_t test_1833;
			       {
				  obj_t aux_1834;
				  aux_1834 = (((atom_t) CREF(node_1115))->value);
				  test_1833 = KEYWORDP(aux_1834);
			       }
			       if (test_1833)
				 {
				    {
				       node_t aux_1837;
				       aux_1837 = cnst_alloc_keyword_47_cnst_alloc((((atom_t) CREF(node_1115))->value), (((atom_t) CREF(node_1115))->loc));
				       aux_1829 = (obj_t) (aux_1837);
				    }
				 }
			       else
				 {
				    aux_1829 = (obj_t) (node_1115);
				 }
			    }
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t node_1121;
			    node_1121 = (kwote_t) (node_11);
			    {
			       bool_t test_1844;
			       {
				  obj_t aux_1845;
				  aux_1845 = (((kwote_t) CREF(node_1121))->value);
				  test_1844 = SYMBOLP(aux_1845);
			       }
			       if (test_1844)
				 {
				    {
				       node_t aux_1848;
				       aux_1848 = cnst_alloc_symbol_123_cnst_alloc((((kwote_t) CREF(node_1121))->value), (((kwote_t) CREF(node_1121))->loc));
				       aux_1829 = (obj_t) (aux_1848);
				    }
				 }
			       else
				 {
				    bool_t test_1853;
				    {
				       obj_t aux_1854;
				       aux_1854 = (((kwote_t) CREF(node_1121))->value);
				       test_1853 = KEYWORDP(aux_1854);
				    }
				    if (test_1853)
				      {
					 {
					    node_t aux_1857;
					    aux_1857 = cnst_alloc_keyword_47_cnst_alloc((((kwote_t) CREF(node_1121))->value), (((kwote_t) CREF(node_1121))->loc));
					    aux_1829 = (obj_t) (aux_1857);
					 }
				      }
				    else
				      {
					 bool_t test_1862;
					 {
					    obj_t aux_1863;
					    aux_1863 = (((kwote_t) CREF(node_1121))->value);
					    test_1862 = PAIRP(aux_1863);
					 }
					 if (test_1862)
					   {
					      {
						 node_t aux_1866;
						 aux_1866 = cnst_alloc_list_56_cnst_alloc((((kwote_t) CREF(node_1121))->value), (((kwote_t) CREF(node_1121))->loc));
						 aux_1829 = (obj_t) (aux_1866);
					      }
					   }
					 else
					   {
					      bool_t test_1871;
					      {
						 obj_t aux_1872;
						 aux_1872 = (((kwote_t) CREF(node_1121))->value);
						 test_1871 = VECTORP(aux_1872);
					      }
					      if (test_1871)
						{
						   {
						      node_t aux_1875;
						      aux_1875 = cnst_alloc_vector_65_cnst_alloc((((kwote_t) CREF(node_1121))->value), (((kwote_t) CREF(node_1121))->loc));
						      aux_1829 = (obj_t) (aux_1875);
						   }
						}
					      else
						{
						   bool_t test_1880;
						   {
						      obj_t aux_1881;
						      aux_1881 = (((kwote_t) CREF(node_1121))->value);
						      test_1880 = STRINGP(aux_1881);
						   }
						   if (test_1880)
						     {
							{
							   node_t aux_1884;
							   aux_1884 = cnst_alloc_string_41_cnst_alloc((((kwote_t) CREF(node_1121))->value), (((kwote_t) CREF(node_1121))->loc));
							   aux_1829 = (obj_t) (aux_1884);
							}
						     }
						   else
						     {
							bool_t test_1889;
							{
							   obj_t arg1606_1157;
							   arg1606_1157 = (((kwote_t) CREF(node_1121))->value);
							   if (STRUCTP(arg1606_1157))
							     {
								obj_t aux_1895;
								obj_t aux_1893;
								aux_1895 = CNST_TABLE_REF(((long) 1));
								aux_1893 = STRUCT_KEY(arg1606_1157);
								test_1889 = (aux_1893 == aux_1895);
							     }
							   else
							     {
								test_1889 = ((bool_t) 0);
							     }
							}
							if (test_1889)
							  {
							     {
								node_t aux_1898;
								aux_1898 = cnst_alloc_tvector_190_cnst_alloc((((kwote_t) CREF(node_1121))->value), (((kwote_t) CREF(node_1121))->loc));
								aux_1829 = (obj_t) (aux_1898);
							     }
							  }
							else
							  {
							     bool_t test_1903;
							     {
								bool_t test_1904;
								{
								   obj_t aux_1905;
								   aux_1905 = (((kwote_t) CREF(node_1121))->value);
								   test_1904 = CHARP(aux_1905);
								}
								if (test_1904)
								  {
								     test_1903 = ((bool_t) 1);
								  }
								else
								  {
								     bool_t test_1908;
								     {
									obj_t aux_1909;
									aux_1909 = (((kwote_t) CREF(node_1121))->value);
									test_1908 = INTEGERP(aux_1909);
								     }
								     if (test_1908)
								       {
									  test_1903 = ((bool_t) 1);
								       }
								     else
								       {
									  bool_t test_1912;
									  {
									     obj_t aux_1913;
									     aux_1913 = (((kwote_t) CREF(node_1121))->value);
									     test_1912 = BOOLEANP(aux_1913);
									  }
									  if (test_1912)
									    {
									       test_1903 = ((bool_t) 1);
									    }
									  else
									    {
									       bool_t test_1916;
									       {
										  obj_t arg1601_1153;
										  arg1601_1153 = (((kwote_t) CREF(node_1121))->value);
										  if (INTEGERP(arg1601_1153))
										    {
										       test_1916 = ((bool_t) 1);
										    }
										  else
										    {
										       test_1916 = REALP(arg1601_1153);
										    }
									       }
									       if (test_1916)
										 {
										    test_1903 = ((bool_t) 1);
										 }
									       else
										 {
										    obj_t aux_1921;
										    aux_1921 = (((kwote_t) CREF(node_1121))->value);
										    test_1903 = CNSTP(aux_1921);
										 }
									    }
								       }
								  }
							     }
							     if (test_1903)
							       {
								  {
								     obj_t arg1589_1142;
								     type_t arg1590_1143;
								     obj_t arg1591_1144;
								     arg1589_1142 = (((kwote_t) CREF(node_1121))->loc);
								     arg1590_1143 = (((kwote_t) CREF(node_1121))->type);
								     arg1591_1144 = (((kwote_t) CREF(node_1121))->value);
								     {
									atom_t res1750_1429;
									{
									   atom_t new1123_1422;
									   new1123_1422 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
									   {
									      long arg1485_1423;
									      arg1485_1423 = class_num_218___object(atom_ast_node);
									      {
										 obj_t obj_1427;
										 obj_1427 = (obj_t) (new1123_1422);
										 (((obj_t) CREF(obj_1427))->header = MAKE_HEADER(arg1485_1423, 0), BUNSPEC);
									      }
									   }
									   {
									      object_t aux_1931;
									      aux_1931 = (object_t) (new1123_1422);
									      OBJECT_WIDENING_SET(aux_1931, BFALSE);
									   }
									   ((((atom_t) CREF(new1123_1422))->loc) = ((obj_t) arg1589_1142), BUNSPEC);
									   ((((atom_t) CREF(new1123_1422))->type) = ((type_t) arg1590_1143), BUNSPEC);
									   ((((atom_t) CREF(new1123_1422))->value) = ((obj_t) arg1591_1144), BUNSPEC);
									   res1750_1429 = new1123_1422;
									}
									aux_1829 = (obj_t) (res1750_1429);
								     }
								  }
							       }
							     else
							       {
								  {
								     obj_t arg1595_1147;
								     arg1595_1147 = shape_tools_shape((obj_t) (node_1121));
								     aux_1829 = internal_error_43_tools_error(string1785_cnst_node, string1786_cnst_node, arg1595_1147);
								  }
							       }
							  }
						     }
						}
					   }
				      }
				 }
			    }
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t aux_1941;
			    aux_1941 = (var_t) (node_11);
			    aux_1829 = (obj_t) (aux_1941);
			 }
			 break;
		      case ((long) 3):
			 {
			    obj_t arg1619_1167;
			    {
			       obj_t aux_1944;
			       {
				  closure_t aux_1945;
				  aux_1945 = (closure_t) (node_11);
				  aux_1944 = (obj_t) (aux_1945);
			       }
			       arg1619_1167 = shape_tools_shape(aux_1944);
			    }
			    aux_1829 = internal_error_43_tools_error(string1787_cnst_node, string1788_cnst_node, arg1619_1167);
			 }
			 break;
		      case ((long) 4):
			 {
			    sequence_t node_1168;
			    node_1168 = (sequence_t) (node_11);
			    cnst___82_cnst_node((((sequence_t) CREF(node_1168))->nodes));
			    aux_1829 = (obj_t) (node_1168);
			 }
			 break;
		      case ((long) 5):
			 {
			    pragma_t node_1171;
			    node_1171 = (pragma_t) (node_11);
			    cnst___82_cnst_node((((pragma_t) CREF(node_1171))->args));
			    aux_1829 = (obj_t) (node_1171);
			 }
			 break;
		      case ((long) 6):
			 {
			    cast_t node_1174;
			    node_1174 = (cast_t) (node_11);
			    cnst__44_cnst_node((((cast_t) CREF(node_1174))->arg));
			    aux_1829 = (obj_t) (node_1174);
			 }
			 break;
		      case ((long) 7):
			 {
			    setq_t node_1177;
			    node_1177 = (setq_t) (node_11);
			    {
			       node_t arg1624_1179;
			       arg1624_1179 = cnst__44_cnst_node((((setq_t) CREF(node_1177))->value));
			       {
				  obj_t res1751_1436;
				  {
				     obj_t x_1728;
				     x_1728 = ((((setq_t) CREF(node_1177))->value) = ((node_t) arg1624_1179), BUNSPEC);
				     res1751_1436 = BUNSPEC;
				  }
				  res1751_1436;
			       }
			    }
			    aux_1829 = (obj_t) (node_1177);
			 }
			 break;
		      case ((long) 8):
			 {
			    conditional_t node_1181;
			    node_1181 = (conditional_t) (node_11);
			    {
			       node_t arg1627_1183;
			       arg1627_1183 = cnst__44_cnst_node((((conditional_t) CREF(node_1181))->test));
			       {
				  obj_t res1752_1440;
				  {
				     obj_t x_1729;
				     x_1729 = ((((conditional_t) CREF(node_1181))->test) = ((node_t) arg1627_1183), BUNSPEC);
				     res1752_1440 = BUNSPEC;
				  }
				  res1752_1440;
			       }
			    }
			    {
			       node_t arg1630_1185;
			       arg1630_1185 = cnst__44_cnst_node((((conditional_t) CREF(node_1181))->true));
			       {
				  obj_t res1753_1444;
				  {
				     obj_t x_1730;
				     x_1730 = ((((conditional_t) CREF(node_1181))->true) = ((node_t) arg1630_1185), BUNSPEC);
				     res1753_1444 = BUNSPEC;
				  }
				  res1753_1444;
			       }
			    }
			    {
			       node_t arg1634_1187;
			       arg1634_1187 = cnst__44_cnst_node((((conditional_t) CREF(node_1181))->false));
			       {
				  obj_t res1754_1448;
				  {
				     obj_t x_1731;
				     x_1731 = ((((conditional_t) CREF(node_1181))->false) = ((node_t) arg1634_1187), BUNSPEC);
				     res1754_1448 = BUNSPEC;
				  }
				  res1754_1448;
			       }
			    }
			    aux_1829 = (obj_t) (node_1181);
			 }
			 break;
		      case ((long) 9):
			 {
			    fail_t node_1189;
			    node_1189 = (fail_t) (node_11);
			    {
			       node_t arg1638_1191;
			       arg1638_1191 = cnst__44_cnst_node((((fail_t) CREF(node_1189))->proc));
			       {
				  obj_t res1755_1452;
				  {
				     obj_t x_1732;
				     x_1732 = ((((fail_t) CREF(node_1189))->proc) = ((node_t) arg1638_1191), BUNSPEC);
				     res1755_1452 = BUNSPEC;
				  }
				  res1755_1452;
			       }
			    }
			    {
			       node_t arg1642_1193;
			       arg1642_1193 = cnst__44_cnst_node((((fail_t) CREF(node_1189))->msg));
			       {
				  obj_t res1756_1456;
				  {
				     obj_t x_1733;
				     x_1733 = ((((fail_t) CREF(node_1189))->msg) = ((node_t) arg1642_1193), BUNSPEC);
				     res1756_1456 = BUNSPEC;
				  }
				  res1756_1456;
			       }
			    }
			    {
			       node_t arg1644_1195;
			       arg1644_1195 = cnst__44_cnst_node((((fail_t) CREF(node_1189))->obj));
			       {
				  obj_t res1757_1460;
				  {
				     obj_t x_1734;
				     x_1734 = ((((fail_t) CREF(node_1189))->obj) = ((node_t) arg1644_1195), BUNSPEC);
				     res1757_1460 = BUNSPEC;
				  }
				  res1757_1460;
			       }
			    }
			    aux_1829 = (obj_t) (node_1189);
			 }
			 break;
		      case ((long) 10):
			 {
			    select_t node_1197;
			    node_1197 = (select_t) (node_11);
			    {
			       node_t arg1646_1199;
			       arg1646_1199 = cnst__44_cnst_node((((select_t) CREF(node_1197))->test));
			       {
				  obj_t res1758_1464;
				  {
				     obj_t x_1735;
				     x_1735 = ((((select_t) CREF(node_1197))->test) = ((node_t) arg1646_1199), BUNSPEC);
				     res1758_1464 = BUNSPEC;
				  }
				  res1758_1464;
			       }
			    }
			    {
			       obj_t l1300_1201;
			       l1300_1201 = (((select_t) CREF(node_1197))->clauses);
			     lname1301_1202:
			       if (PAIRP(l1300_1201))
				 {
				    {
				       obj_t clause_1205;
				       clause_1205 = CAR(l1300_1201);
				       {
					  node_t arg1650_1206;
					  {
					     node_t aux_1996;
					     {
						obj_t aux_1997;
						aux_1997 = CDR(clause_1205);
						aux_1996 = (node_t) (aux_1997);
					     }
					     arg1650_1206 = cnst__44_cnst_node(aux_1996);
					  }
					  {
					     obj_t aux_2001;
					     aux_2001 = (obj_t) (arg1650_1206);
					     SET_CDR(clause_1205, aux_2001);
					  }
				       }
				    }
				    {
				       obj_t l1300_2004;
				       l1300_2004 = CDR(l1300_1201);
				       l1300_1201 = l1300_2004;
				       goto lname1301_1202;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_1829 = (obj_t) (node_1197);
			 }
			 break;
		      case ((long) 11):
			 {
			    let_fun_218_t node_1209;
			    node_1209 = (let_fun_218_t) (node_11);
			    {
			       obj_t l1303_1211;
			       l1303_1211 = (((let_fun_218_t) CREF(node_1209))->locals);
			     lname1304_1212:
			       if (PAIRP(l1303_1211))
				 {
				    {
				       value_t fun_1216;
				       {
					  local_t obj_1475;
					  {
					     obj_t aux_2011;
					     aux_2011 = CAR(l1303_1211);
					     obj_1475 = (local_t) (aux_2011);
					  }
					  fun_1216 = (((local_t) CREF(obj_1475))->value);
				       }
				       {
					  node_t arg1655_1217;
					  {
					     node_t aux_2015;
					     {
						obj_t aux_2016;
						{
						   sfun_t obj_1476;
						   obj_1476 = (sfun_t) (fun_1216);
						   aux_2016 = (((sfun_t) CREF(obj_1476))->body);
						}
						aux_2015 = (node_t) (aux_2016);
					     }
					     arg1655_1217 = cnst__44_cnst_node(aux_2015);
					  }
					  {
					     obj_t res1759_1479;
					     {
						sfun_t obj_1477;
						obj_t val1078_1478;
						obj_1477 = (sfun_t) (fun_1216);
						val1078_1478 = (obj_t) (arg1655_1217);
						{
						   obj_t x_1736;
						   x_1736 = ((((sfun_t) CREF(obj_1477))->body) = ((obj_t) val1078_1478), BUNSPEC);
						   res1759_1479 = BUNSPEC;
						}
					     }
					     res1759_1479;
					  }
				       }
				    }
				    {
				       obj_t l1303_2024;
				       l1303_2024 = CDR(l1303_1211);
				       l1303_1211 = l1303_2024;
				       goto lname1304_1212;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1659_1220;
			       arg1659_1220 = cnst__44_cnst_node((((let_fun_218_t) CREF(node_1209))->body));
			       {
				  obj_t res1760_1484;
				  {
				     obj_t x_1737;
				     x_1737 = ((((let_fun_218_t) CREF(node_1209))->body) = ((node_t) arg1659_1220), BUNSPEC);
				     res1760_1484 = BUNSPEC;
				  }
				  res1760_1484;
			       }
			    }
			    aux_1829 = (obj_t) (node_1209);
			 }
			 break;
		      case ((long) 12):
			 {
			    let_var_6_t node_1222;
			    node_1222 = (let_var_6_t) (node_11);
			    {
			       obj_t l1306_1224;
			       l1306_1224 = (((let_var_6_t) CREF(node_1222))->bindings);
			     lname1307_1225:
			       if (PAIRP(l1306_1224))
				 {
				    {
				       obj_t binding_1228;
				       binding_1228 = CAR(l1306_1224);
				       {
					  obj_t var_1229;
					  var_1229 = CAR(binding_1228);
					  {
					     node_t arg1665_1230;
					     {
						node_t aux_2036;
						{
						   obj_t aux_2037;
						   aux_2037 = CDR(binding_1228);
						   aux_2036 = (node_t) (aux_2037);
						}
						arg1665_1230 = cnst__44_cnst_node(aux_2036);
					     }
					     {
						obj_t aux_2041;
						aux_2041 = (obj_t) (arg1665_1230);
						SET_CDR(binding_1228, aux_2041);
					     }
					  }
					  {
					     bool_t test_2044;
					     {
						obj_t aux_2048;
						obj_t aux_2045;
						aux_2048 = CNST_TABLE_REF(((long) 2));
						{
						   local_t obj_1492;
						   obj_1492 = (local_t) (var_1229);
						   aux_2045 = (((local_t) CREF(obj_1492))->access);
						}
						test_2044 = (aux_2045 == aux_2048);
					     }
					     if (test_2044)
					       {
						  local_bvalue_105_t obj1308_1233;
						  obj1308_1233 = ((local_bvalue_105_t) (var_1229));
						  {
						     local_bvalue_105_t arg1669_1234;
						     {
							local_bvalue_105_t res1761_1499;
							{
							   node_t binding_value_3_1496;
							   {
							      obj_t aux_2052;
							      aux_2052 = CDR(binding_1228);
							      binding_value_3_1496 = (node_t) (aux_2052);
							   }
							   {
							      local_bvalue_105_t new1273_1497;
							      new1273_1497 = ((local_bvalue_105_t) BREF(GC_MALLOC(sizeof(struct local_bvalue_105))));
							      ((((local_bvalue_105_t) CREF(new1273_1497))->binding_value_3) = ((node_t) binding_value_3_1496), BUNSPEC);
							      res1761_1499 = new1273_1497;
							   }
							}
							arg1669_1234 = res1761_1499;
						     }
						     {
							obj_t aux_2059;
							object_t aux_2057;
							aux_2059 = (obj_t) (arg1669_1234);
							aux_2057 = (object_t) (obj1308_1233);
							OBJECT_WIDENING_SET(aux_2057, aux_2059);
						     }
						  }
						  {
						     long arg1673_1236;
						     arg1673_1236 = class_num_218___object(local_bvalue_105_cnst_node);
						     {
							obj_t obj_1500;
							obj_1500 = (obj_t) (obj1308_1233);
							(((obj_t) CREF(obj_1500))->header = MAKE_HEADER(arg1673_1236, 0), BUNSPEC);
						     }
						  }
						  (obj_t) (obj1308_1233);
					       }
					     else
					       {
						  BUNSPEC;
					       }
					  }
				       }
				    }
				    {
				       obj_t l1306_2066;
				       l1306_2066 = CDR(l1306_1224);
				       l1306_1224 = l1306_2066;
				       goto lname1307_1225;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1679_1240;
			       arg1679_1240 = cnst__44_cnst_node((((let_var_6_t) CREF(node_1222))->body));
			       {
				  obj_t res1762_1506;
				  {
				     obj_t x_1738;
				     x_1738 = ((((let_var_6_t) CREF(node_1222))->body) = ((node_t) arg1679_1240), BUNSPEC);
				     res1762_1506 = BUNSPEC;
				  }
				  res1762_1506;
			       }
			    }
			    aux_1829 = (obj_t) (node_1222);
			 }
			 break;
		      case ((long) 13):
			 {
			    set_ex_it_116_t node_1242;
			    node_1242 = (set_ex_it_116_t) (node_11);
			    {
			       node_t arg1681_1244;
			       arg1681_1244 = cnst__44_cnst_node((((set_ex_it_116_t) CREF(node_1242))->body));
			       {
				  obj_t res1763_1510;
				  {
				     obj_t x_1739;
				     x_1739 = ((((set_ex_it_116_t) CREF(node_1242))->body) = ((node_t) arg1681_1244), BUNSPEC);
				     res1763_1510 = BUNSPEC;
				  }
				  res1763_1510;
			       }
			    }
			    aux_1829 = (obj_t) (node_1242);
			 }
			 break;
		      case ((long) 14):
			 {
			    jump_ex_it_184_t node_1246;
			    node_1246 = (jump_ex_it_184_t) (node_11);
			    {
			       node_t arg1684_1248;
			       arg1684_1248 = cnst__44_cnst_node((((jump_ex_it_184_t) CREF(node_1246))->exit));
			       {
				  obj_t res1764_1514;
				  {
				     obj_t x_1740;
				     x_1740 = ((((jump_ex_it_184_t) CREF(node_1246))->exit) = ((node_t) arg1684_1248), BUNSPEC);
				     res1764_1514 = BUNSPEC;
				  }
				  res1764_1514;
			       }
			    }
			    {
			       node_t arg1687_1250;
			       arg1687_1250 = cnst__44_cnst_node((((jump_ex_it_184_t) CREF(node_1246))->value));
			       {
				  obj_t res1765_1518;
				  {
				     obj_t x_1741;
				     x_1741 = ((((jump_ex_it_184_t) CREF(node_1246))->value) = ((node_t) arg1687_1250), BUNSPEC);
				     res1765_1518 = BUNSPEC;
				  }
				  res1765_1518;
			       }
			    }
			    aux_1829 = (obj_t) (node_1246);
			 }
			 break;
		      case ((long) 15):
			 {
			    make_box_202_t node_1252;
			    node_1252 = (make_box_202_t) (node_11);
			    {
			       node_t arg1689_1254;
			       arg1689_1254 = cnst__44_cnst_node((((make_box_202_t) CREF(node_1252))->value));
			       {
				  obj_t res1766_1522;
				  {
				     obj_t x_1742;
				     x_1742 = ((((make_box_202_t) CREF(node_1252))->value) = ((node_t) arg1689_1254), BUNSPEC);
				     res1766_1522 = BUNSPEC;
				  }
				  res1766_1522;
			       }
			    }
			    aux_1829 = (obj_t) (node_1252);
			 }
			 break;
		      case ((long) 16):
			 {
			    box_ref_242_t node_1256;
			    node_1256 = (box_ref_242_t) (node_11);
			    {
			       node_t arg1691_1258;
			       {
				  node_t aux_2092;
				  {
				     var_t aux_2093;
				     aux_2093 = (((box_ref_242_t) CREF(node_1256))->var);
				     aux_2092 = (node_t) (aux_2093);
				  }
				  arg1691_1258 = cnst__44_cnst_node(aux_2092);
			       }
			       {
				  obj_t res1767_1526;
				  {
				     var_t val1263_1525;
				     val1263_1525 = (var_t) (arg1691_1258);
				     {
					obj_t x_1743;
					x_1743 = ((((box_ref_242_t) CREF(node_1256))->var) = ((var_t) val1263_1525), BUNSPEC);
					res1767_1526 = BUNSPEC;
				     }
				  }
				  res1767_1526;
			       }
			    }
			    aux_1829 = (obj_t) (node_1256);
			 }
			 break;
		      case ((long) 17):
			 {
			    box_set__221_t node_1260;
			    node_1260 = (box_set__221_t) (node_11);
			    {
			       node_t arg1694_1262;
			       {
				  node_t aux_2101;
				  {
				     var_t aux_2102;
				     aux_2102 = (((box_set__221_t) CREF(node_1260))->var);
				     aux_2101 = (node_t) (aux_2102);
				  }
				  arg1694_1262 = cnst__44_cnst_node(aux_2101);
			       }
			       {
				  obj_t res1768_1530;
				  {
				     var_t val1269_1529;
				     val1269_1529 = (var_t) (arg1694_1262);
				     {
					obj_t x_1744;
					x_1744 = ((((box_set__221_t) CREF(node_1260))->var) = ((var_t) val1269_1529), BUNSPEC);
					res1768_1530 = BUNSPEC;
				     }
				  }
				  res1768_1530;
			       }
			    }
			    {
			       node_t arg1696_1264;
			       arg1696_1264 = cnst__44_cnst_node((((box_set__221_t) CREF(node_1260))->value));
			       {
				  obj_t res1769_1534;
				  {
				     obj_t x_1745;
				     x_1745 = ((((box_set__221_t) CREF(node_1260))->value) = ((node_t) arg1696_1264), BUNSPEC);
				     res1769_1534 = BUNSPEC;
				  }
				  res1769_1534;
			       }
			    }
			    aux_1829 = (obj_t) (node_1260);
			 }
			 break;
		      case ((long) 18):
			 {
			    app_ly_162_t node_1266;
			    node_1266 = (app_ly_162_t) (node_11);
			    {
			       node_t arg1698_1268;
			       arg1698_1268 = cnst__44_cnst_node((((app_ly_162_t) CREF(node_1266))->fun));
			       {
				  obj_t res1770_1538;
				  {
				     obj_t x_1746;
				     x_1746 = ((((app_ly_162_t) CREF(node_1266))->fun) = ((node_t) arg1698_1268), BUNSPEC);
				     res1770_1538 = BUNSPEC;
				  }
				  res1770_1538;
			       }
			    }
			    {
			       node_t arg1701_1270;
			       arg1701_1270 = cnst__44_cnst_node((((app_ly_162_t) CREF(node_1266))->arg));
			       {
				  obj_t res1771_1542;
				  {
				     obj_t x_1747;
				     x_1747 = ((((app_ly_162_t) CREF(node_1266))->arg) = ((node_t) arg1701_1270), BUNSPEC);
				     res1771_1542 = BUNSPEC;
				  }
				  res1771_1542;
			       }
			    }
			    aux_1829 = (obj_t) (node_1266);
			 }
			 break;
		      case ((long) 19):
			 {
			    funcall_t node_1272;
			    node_1272 = (funcall_t) (node_11);
			    {
			       node_t arg1703_1274;
			       arg1703_1274 = cnst__44_cnst_node((((funcall_t) CREF(node_1272))->fun));
			       {
				  obj_t res1772_1546;
				  {
				     obj_t x_1748;
				     x_1748 = ((((funcall_t) CREF(node_1272))->fun) = ((node_t) arg1703_1274), BUNSPEC);
				     res1772_1546 = BUNSPEC;
				  }
				  res1772_1546;
			       }
			    }
			    cnst___82_cnst_node((((funcall_t) CREF(node_1272))->args));
			    aux_1829 = (obj_t) (node_1272);
			 }
			 break;
		      case ((long) 20):
			 {
			    app_t node_1277;
			    node_1277 = (app_t) (node_11);
			    cnst___82_cnst_node((((app_t) CREF(node_1277))->args));
			    {
			       bool_t test_2130;
			       {
				  obj_t aux_2131;
				  aux_2131 = (((app_t) CREF(node_1277))->args);
				  test_2130 = NULLP(aux_2131);
			       }
			       if (test_2130)
				 {
				    aux_1829 = (obj_t) (node_1277);
				 }
			       else
				 {
				    variable_t fun_1281;
				    {
				       var_t arg1740_1313;
				       arg1740_1313 = (((app_t) CREF(node_1277))->fun);
				       fun_1281 = (((var_t) CREF(arg1740_1313))->variable);
				    }
				    {
				       obj_t actual_value_16_1283;
				       {
					  node_t aux_2137;
					  {
					     obj_t aux_2138;
					     {
						obj_t aux_2139;
						aux_2139 = (((app_t) CREF(node_1277))->args);
						aux_2138 = CAR(aux_2139);
					     }
					     aux_2137 = (node_t) (aux_2138);
					  }
					  actual_value_16_1283 = get_node_atom_value_135_cnst_node(aux_2137);
				       }
				       {
					  {
					     bool_t test1708_1284;
					     {
						obj_t obj2_1556;
						obj2_1556 = __string__bstring__114_cnst_cache;
						{
						   obj_t aux_2144;
						   aux_2144 = (obj_t) (fun_1281);
						   test1708_1284 = (aux_2144 == obj2_1556);
						}
					     }
					     if (test1708_1284)
					       {
						  if (STRINGP(actual_value_16_1283))
						    {
						       node_t r_1286;
						       r_1286 = cnst_alloc_string_41_cnst_alloc(actual_value_16_1283, (((app_t) CREF(node_1277))->loc));
						       {
							  bool_t test1710_1287;
							  {
							     obj_t aux_2152;
							     aux_2152 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 3)), BINT(((long) 0)));
							     test1710_1287 = CBOOL(aux_2152);
							  }
							  if (test1710_1287)
							    {
							       obj_t arg1712_1289;
							       arg1712_1289 = shape_tools_shape((obj_t) (r_1286));
							       {
								  obj_t list1713_1290;
								  {
								     obj_t arg1714_1291;
								     {
									obj_t arg1715_1292;
									{
									   obj_t aux_2160;
									   aux_2160 = BCHAR(((unsigned char) '\n'));
									   arg1715_1292 = MAKE_PAIR(aux_2160, BNIL);
									}
									arg1714_1291 = MAKE_PAIR(arg1712_1289, arg1715_1292);
								     }
								     list1713_1290 = MAKE_PAIR(string1789_cnst_node, arg1714_1291);
								  }
								  print_trace_107_tools_trace(list1713_1290);
							       }
							    }
							  else
							    {
							       BUNSPEC;
							    }
						       }
						       aux_1829 = (obj_t) (r_1286);
						    }
						  else
						    {
						       aux_1829 = (obj_t) (node_1277);
						    }
					       }
					     else
					       {
						  bool_t test1720_1297;
						  {
						     obj_t obj2_1560;
						     obj2_1560 = __bool__bbool__85_cnst_cache;
						     {
							obj_t aux_2168;
							aux_2168 = (obj_t) (fun_1281);
							test1720_1297 = (aux_2168 == obj2_1560);
						     }
						  }
						  if (test1720_1297)
						    {
						       if (BOOLEANP(actual_value_16_1283))
							 {
							    if (CBOOL(actual_value_16_1283))
							      {
								 obj_t arg1722_1299;
								 arg1722_1299 = (((app_t) CREF(node_1277))->loc);
								 {
								    var_t res1773_1573;
								    {
								       type_t type_1564;
								       variable_t variable_1565;
								       type_1564 = (type_t) (__bbool__55_type_cache);
								       variable_1565 = (variable_t) (__btrue__29_cnst_cache);
								       {
									  var_t new1129_1566;
									  new1129_1566 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
									  {
									     long arg1481_1567;
									     arg1481_1567 = class_num_218___object(var_ast_node);
									     {
										obj_t obj_1571;
										obj_1571 = (obj_t) (new1129_1566);
										(((obj_t) CREF(obj_1571))->header = MAKE_HEADER(arg1481_1567, 0), BUNSPEC);
									     }
									  }
									  {
									     object_t aux_2183;
									     aux_2183 = (object_t) (new1129_1566);
									     OBJECT_WIDENING_SET(aux_2183, BFALSE);
									  }
									  ((((var_t) CREF(new1129_1566))->loc) = ((obj_t) arg1722_1299), BUNSPEC);
									  ((((var_t) CREF(new1129_1566))->type) = ((type_t) type_1564), BUNSPEC);
									  ((((var_t) CREF(new1129_1566))->variable) = ((variable_t) variable_1565), BUNSPEC);
									  res1773_1573 = new1129_1566;
								       }
								    }
								    aux_1829 = (obj_t) (res1773_1573);
								 }
							      }
							    else
							      {
								 obj_t arg1724_1300;
								 arg1724_1300 = (((app_t) CREF(node_1277))->loc);
								 {
								    var_t res1774_1585;
								    {
								       type_t type_1576;
								       variable_t variable_1577;
								       type_1576 = (type_t) (__bbool__55_type_cache);
								       variable_1577 = (variable_t) (__bfalse__69_cnst_cache);
								       {
									  var_t new1129_1578;
									  new1129_1578 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
									  {
									     long arg1481_1579;
									     arg1481_1579 = class_num_218___object(var_ast_node);
									     {
										obj_t obj_1583;
										obj_1583 = (obj_t) (new1129_1578);
										(((obj_t) CREF(obj_1583))->header = MAKE_HEADER(arg1481_1579, 0), BUNSPEC);
									     }
									  }
									  {
									     object_t aux_2197;
									     aux_2197 = (object_t) (new1129_1578);
									     OBJECT_WIDENING_SET(aux_2197, BFALSE);
									  }
									  ((((var_t) CREF(new1129_1578))->loc) = ((obj_t) arg1724_1300), BUNSPEC);
									  ((((var_t) CREF(new1129_1578))->type) = ((type_t) type_1576), BUNSPEC);
									  ((((var_t) CREF(new1129_1578))->variable) = ((variable_t) variable_1577), BUNSPEC);
									  res1774_1585 = new1129_1578;
								       }
								    }
								    aux_1829 = (obj_t) (res1774_1585);
								 }
							      }
							 }
						       else
							 {
							    aux_1829 = (obj_t) (node_1277);
							 }
						    }
						  else
						    {
						       bool_t test1725_1301;
						       {
							  bool_t test1737_1311;
							  {
							     obj_t obj2_1587;
							     obj2_1587 = __make_fx_procedure__51_cnst_cache;
							     {
								obj_t aux_2205;
								aux_2205 = (obj_t) (fun_1281);
								test1737_1311 = (aux_2205 == obj2_1587);
							     }
							  }
							  if (test1737_1311)
							    {
							       test1725_1301 = ((bool_t) 1);
							    }
							  else
							    {
							       obj_t obj2_1589;
							       obj2_1589 = __make_va_procedure__53_cnst_cache;
							       {
								  obj_t aux_2209;
								  aux_2209 = (obj_t) (fun_1281);
								  test1725_1301 = (aux_2209 == obj2_1589);
							       }
							    }
						       }
						       if (test1725_1301)
							 {
							    {
							       obj_t size_value_33_1302;
							       {
								  node_t aux_2213;
								  {
								     obj_t aux_2214;
								     {
									obj_t aux_2215;
									{
									   obj_t aux_2216;
									   {
									      obj_t aux_2217;
									      aux_2217 = (((app_t) CREF(node_1277))->args);
									      aux_2216 = CDR(aux_2217);
									   }
									   aux_2215 = CDR(aux_2216);
									}
									aux_2214 = CAR(aux_2215);
								     }
								     aux_2213 = (node_t) (aux_2214);
								  }
								  size_value_33_1302 = get_node_atom_value_135_cnst_node(aux_2213);
							       }
							       {
								  bool_t test_2224;
								  if (INTEGERP(size_value_33_1302))
								    {
								       long aux_2227;
								       aux_2227 = (long) CINT(size_value_33_1302);
								       test_2224 = (aux_2227 == ((long) 0));
								    }
								  else
								    {
								       test_2224 = ((bool_t) 0);
								    }
								  if (test_2224)
								    {
								       node_t aux_2230;
								       aux_2230 = cnst_alloc_procedure_240_cnst_alloc((node_t) (node_1277), (((app_t) CREF(node_1277))->loc));
								       aux_1829 = (obj_t) (aux_2230);
								    }
								  else
								    {
								       aux_1829 = (obj_t) (node_1277);
								    }
							       }
							    }
							 }
						       else
							 {
							    bool_t test1734_1308;
							    {
							       obj_t obj2_1602;
							       obj2_1602 = __double__real__21_cnst_cache;
							       {
								  obj_t aux_2236;
								  aux_2236 = (obj_t) (fun_1281);
								  test1734_1308 = (aux_2236 == obj2_1602);
							       }
							    }
							    if (test1734_1308)
							      {
								 {
								    bool_t test_2240;
								    if (INTEGERP(actual_value_16_1283))
								      {
									 test_2240 = ((bool_t) 1);
								      }
								    else
								      {
									 test_2240 = REALP(actual_value_16_1283);
								      }
								    if (test_2240)
								      {
									 node_t aux_2244;
									 aux_2244 = cnst_alloc_real_118_cnst_alloc(actual_value_16_1283, (((app_t) CREF(node_1277))->loc));
									 aux_1829 = (obj_t) (aux_2244);
								      }
								    else
								      {
									 aux_1829 = (obj_t) (node_1277);
								      }
								 }
							      }
							    else
							      {
								 aux_1829 = (obj_t) (node_1277);
							      }
							 }
						    }
					       }
					  }
				       }
				    }
				 }
			    }
			 }
			 break;
		      default:
		       case_else1557_243_1112:
			 if (PROCEDUREP(method1551_1108))
			   {
			      aux_1829 = PROCEDURE_ENTRY(method1551_1108) (method1551_1108, (obj_t) (node_11), BEOA);
			   }
			 else
			   {
			      obj_t fun1371_726;
			      fun1371_726 = PROCEDURE_REF(cnst__env_43_cnst_node, ((long) 0));
			      aux_1829 = PROCEDURE_ENTRY(fun1371_726) (fun1371_726, (obj_t) (node_11), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1557_243_1112;
		 }
	    }
	    return (node_t) (aux_1829);
	 }
      }
   }
}


obj_t 
_cnst__135_cnst_node(obj_t env_1706, obj_t node_1707)
{
   {
      node_t aux_2262;
      aux_2262 = cnst__44_cnst_node((node_t) (node_1707));
      return (obj_t) (aux_2262);
   }
}


obj_t 
cnst___82_cnst_node(obj_t nodes_33)
{
   {
      obj_t hook_727;
      hook_727 = nodes_33;
    loop_728:
      if (NULLP(hook_727))
	{
	   return CNST_TABLE_REF(((long) 4));
	}
      else
	{
	   {
	      node_t arg1376_730;
	      {
		 node_t aux_2269;
		 {
		    obj_t aux_2270;
		    aux_2270 = CAR(hook_727);
		    aux_2269 = (node_t) (aux_2270);
		 }
		 arg1376_730 = cnst__44_cnst_node(aux_2269);
	      }
	      {
		 obj_t aux_2274;
		 aux_2274 = (obj_t) (arg1376_730);
		 SET_CAR(hook_727, aux_2274);
	      }
	   }
	   {
	      obj_t hook_2277;
	      hook_2277 = CDR(hook_727);
	      hook_727 = hook_2277;
	      goto loop_728;
	   }
	}
   }
}


obj_t 
get_node_atom_value_default1341_201_cnst_node(node_t node_36)
{
   return CNST_TABLE_REF(((long) 5));
}


obj_t 
_get_node_atom_value_default1341_59_cnst_node(obj_t env_1712, obj_t node_1713)
{
   return get_node_atom_value_default1341_201_cnst_node((node_t) (node_1713));
}


obj_t 
get_node_atom_value_135_cnst_node(node_t node_35)
{
 get_node_atom_value_135_cnst_node:
   {
      obj_t method1530_1084;
      obj_t class1535_1085;
      {
	 obj_t arg1538_1082;
	 obj_t arg1539_1083;
	 {
	    object_t obj_1614;
	    obj_1614 = (object_t) (node_35);
	    {
	       obj_t pre_method_105_1615;
	       pre_method_105_1615 = PROCEDURE_REF(get_node_atom_value_env_18_cnst_node, ((long) 2));
	       if (INTEGERP(pre_method_105_1615))
		 {
		    PROCEDURE_SET(get_node_atom_value_env_18_cnst_node, ((long) 2), BUNSPEC);
		    arg1538_1082 = pre_method_105_1615;
		 }
	       else
		 {
		    long obj_class_num_177_1620;
		    obj_class_num_177_1620 = TYPE(obj_1614);
		    {
		       obj_t arg1183_1621;
		       arg1183_1621 = PROCEDURE_REF(get_node_atom_value_env_18_cnst_node, ((long) 1));
		       {
			  long arg1184_1625;
			  {
			     long arg1186_1626;
			     arg1186_1626 = OBJECT_TYPE;
			     arg1184_1625 = (obj_class_num_177_1620 - arg1186_1626);
			  }
			  arg1538_1082 = VECTOR_REF(arg1183_1621, arg1184_1625);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1631;
	    object_1631 = (object_t) (node_35);
	    {
	       long arg1187_1632;
	       {
		  long arg1188_1633;
		  long arg1189_1634;
		  arg1188_1633 = TYPE(object_1631);
		  arg1189_1634 = OBJECT_TYPE;
		  arg1187_1632 = (arg1188_1633 - arg1189_1634);
	       }
	       {
		  obj_t vector_1638;
		  vector_1638 = __classes__134___object;
		  arg1539_1083 = VECTOR_REF(vector_1638, arg1187_1632);
	       }
	    }
	 }
	 method1530_1084 = arg1538_1082;
	 class1535_1085 = arg1539_1083;
	 {
	    if (INTEGERP(method1530_1084))
	      {
		 switch ((long) CINT(method1530_1084))
		   {
		   case ((long) 0):
		      {
			 atom_t node_1091;
			 node_1091 = (atom_t) (node_35);
			 return (((atom_t) CREF(node_1091))->value);
		      }
		      break;
		   case ((long) 1):
		      {
			 var_t node_1092;
			 node_1092 = (var_t) (node_35);
			 {
			    variable_t v_1093;
			    v_1093 = (((var_t) CREF(node_1092))->variable);
			    if (is_a__118___object((obj_t) (v_1093), local_bvalue_105_cnst_node))
			      {
				 node_t node_2306;
				 {
				    local_bvalue_105_t obj_1643;
				    obj_1643 = (local_bvalue_105_t) (v_1093);
				    {
				       obj_t aux_2308;
				       {
					  object_t aux_2309;
					  aux_2309 = (object_t) (obj_1643);
					  aux_2308 = OBJECT_WIDENING(aux_2309);
				       }
				       node_2306 = (((local_bvalue_105_t) CREF(aux_2308))->binding_value_3);
				    }
				 }
				 node_35 = node_2306;
				 goto get_node_atom_value_135_cnst_node;
			      }
			    else
			      {
				 return CNST_TABLE_REF(((long) 5));
			      }
			 }
		      }
		      break;
		   default:
		    case_else1536_14_1088:
		      if (PROCEDUREP(method1530_1084))
			{
			   return PROCEDURE_ENTRY(method1530_1084) (method1530_1084, (obj_t) (node_35), BEOA);
			}
		      else
			{
			   obj_t fun1381_733;
			   fun1381_733 = PROCEDURE_REF(get_node_atom_value_env_18_cnst_node, ((long) 0));
			   return PROCEDURE_ENTRY(fun1381_733) (fun1381_733, (obj_t) (node_35), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1536_14_1088;
	      }
	 }
      }
   }
}


obj_t 
_get_node_atom_value_97_cnst_node(obj_t env_1710, obj_t node_1711)
{
   return get_node_atom_value_135_cnst_node((node_t) (node_1711));
}


obj_t 
object_init_111_cnst_node()
{
   {
      obj_t arg1385_735;
      arg1385_735 = local_ast_var;
      local_bvalue_105_cnst_node = add_class__117___object(CNST_TABLE_REF(((long) 6)), arg1385_735, allocate_local_bvalue_env_61_cnst_node, ((long) 49153), BUNSPEC);
   }
   {
      obj_t object__struct_local_bvalue_224_1718;
      object__struct_local_bvalue_224_1718 = proc1790_cnst_node;
      add_method__1___object(object__struct_env_210___object, local_bvalue_105_cnst_node, object__struct_local_bvalue_224_1718);
   }
   {
      obj_t struct_object__object_local_bvalue_206_1714;
      struct_object__object_local_bvalue_206_1714 = proc1791_cnst_node;
      return add_method__1___object(struct_object__object_env_209___object, local_bvalue_105_cnst_node, struct_object__object_local_bvalue_206_1714);
   }
}


obj_t 
struct_object__object_local_bvalue1782_36_cnst_node(obj_t env_1721, obj_t o_1722, obj_t s_1723)
{
   {
      local_bvalue_105_t o_751;
      obj_t s_752;
      {
	 local_bvalue_105_t aux_2331;
	 o_751 = (local_bvalue_105_t) (o_1722);
	 s_752 = s_1723;
	 {
	    {
	       obj_t old1288_755;
	       obj_t aux1289_756;
	       {
		  obj_t next_method1345_86_761;
		  next_method1345_86_761 = find_super_class_method_167___object((object_t) (o_751), struct_object__object_env_209___object, local_bvalue_105_cnst_node);
		  if (PROCEDUREP(next_method1345_86_761))
		    {
		       old1288_755 = PROCEDURE_ENTRY(next_method1345_86_761) (next_method1345_86_761, (obj_t) (o_751), s_752, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1345_86_761);
		       {
			  object_t aux_2340;
			  aux_2340 = struct_object__object_93___object((object_t) (o_751), s_752);
			  old1288_755 = (obj_t) (aux_2340);
		       }
		    }
	       }
	       aux1289_756 = STRUCT_REF(s_752, ((long) 0));
	       {
		  local_bvalue_105_t new1290_757;
		  new1290_757 = ((local_bvalue_105_t) (old1288_755));
		  {
		     long arg1406_758;
		     arg1406_758 = class_num_218___object(local_bvalue_105_cnst_node);
		     {
			obj_t obj_1665;
			obj_1665 = (obj_t) (new1290_757);
			(((obj_t) CREF(obj_1665))->header = MAKE_HEADER(arg1406_758, 0), BUNSPEC);
		     }
		  }
		  {
		     local_bvalue_105_t arg1408_759;
		     {
			local_bvalue_105_t res1778_1672;
			{
			   node_t binding_value_3_1669;
			   {
			      obj_t aux_2349;
			      aux_2349 = STRUCT_REF(aux1289_756, ((long) 0));
			      binding_value_3_1669 = (node_t) (aux_2349);
			   }
			   {
			      local_bvalue_105_t new1273_1670;
			      new1273_1670 = ((local_bvalue_105_t) BREF(GC_MALLOC(sizeof(struct local_bvalue_105))));
			      ((((local_bvalue_105_t) CREF(new1273_1670))->binding_value_3) = ((node_t) binding_value_3_1669), BUNSPEC);
			      res1778_1672 = new1273_1670;
			   }
			}
			arg1408_759 = res1778_1672;
		     }
		     {
			obj_t aux_2356;
			object_t aux_2354;
			aux_2356 = (obj_t) (arg1408_759);
			aux_2354 = (object_t) (new1290_757);
			OBJECT_WIDENING_SET(aux_2354, aux_2356);
		     }
		  }
		  aux_2331 = new1290_757;
	       }
	    }
	 }
	 return (obj_t) (aux_2331);
      }
   }
}


obj_t 
object__struct_local_bvalue1783_199_cnst_node(obj_t env_1724, obj_t obj1285_1725)
{
   {
      local_bvalue_105_t obj1285_738;
      obj1285_738 = (local_bvalue_105_t) (obj1285_1725);
      {
	 {
	    obj_t res1286_741;
	    {
	       obj_t next_method1344_141_749;
	       next_method1344_141_749 = find_super_class_method_167___object((object_t) (obj1285_738), object__struct_env_210___object, local_bvalue_105_cnst_node);
	       if (PROCEDUREP(next_method1344_141_749))
		 {
		    res1286_741 = PROCEDURE_ENTRY(next_method1344_141_749) (next_method1344_141_749, (obj_t) (obj1285_738), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1344_141_749);
		    res1286_741 = object__struct_50___object((object_t) (obj1285_738));
		 }
	    }
	    {
	       obj_t aux1287_742;
	       {
		  obj_t aux_2371;
		  aux_2371 = CNST_TABLE_REF(((long) 6));
		  aux1287_742 = make_struct(aux_2371, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_2374;
		  {
		     node_t aux_2375;
		     {
			obj_t aux_2376;
			{
			   object_t aux_2377;
			   aux_2377 = (object_t) (obj1285_738);
			   aux_2376 = OBJECT_WIDENING(aux_2377);
			}
			aux_2375 = (((local_bvalue_105_t) CREF(aux_2376))->binding_value_3);
		     }
		     aux_2374 = (obj_t) (aux_2375);
		  }
		  STRUCT_SET(aux1287_742, ((long) 0), aux_2374);
	       }
	       STRUCT_SET(res1286_741, ((long) 0), aux1287_742);
	       {
		  obj_t aux_2384;
		  aux_2384 = STRUCT_KEY(res1286_741);
		  STRUCT_KEY_SET(aux1287_742, aux_2384);
	       }
	       {
		  obj_t aux_2387;
		  aux_2387 = CNST_TABLE_REF(((long) 6));
		  STRUCT_KEY_SET(res1286_741, aux_2387);
	       }
	       return res1286_741;
	    }
	 }
      }
   }
}


local_t 
allocate_local_bvalue_47_cnst_node()
{
   {
      local_t new1284_763;
      new1284_763 = ((local_t) BREF(GC_MALLOC(sizeof(struct local))));
      {
	 long arg1412_764;
	 arg1412_764 = class_num_218___object(local_bvalue_105_cnst_node);
	 {
	    obj_t obj_1675;
	    obj_1675 = (obj_t) (new1284_763);
	    (((obj_t) CREF(obj_1675))->header = MAKE_HEADER(arg1412_764, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2395;
	 aux_2395 = (object_t) (new1284_763);
	 OBJECT_WIDENING_SET(aux_2395, BFALSE);
      }
      return new1284_763;
   }
}


obj_t 
_allocate_local_bvalue_102_cnst_node(obj_t env_1726)
{
   {
      local_t aux_2398;
      aux_2398 = allocate_local_bvalue_47_cnst_node();
      return (obj_t) (aux_2398);
   }
}


obj_t 
imported_modules_init_94_cnst_node()
{
   module_initialization_70_tools_trace(((long) 0), "CNST_NODE");
   module_initialization_70_tools_shape(((long) 0), "CNST_NODE");
   module_initialization_70_tools_speek(((long) 0), "CNST_NODE");
   module_initialization_70_tools_error(((long) 0), "CNST_NODE");
   module_initialization_70_type_type(((long) 0), "CNST_NODE");
   module_initialization_70_type_cache(((long) 0), "CNST_NODE");
   module_initialization_70_ast_var(((long) 0), "CNST_NODE");
   module_initialization_70_ast_node(((long) 0), "CNST_NODE");
   module_initialization_70_ast_env(((long) 0), "CNST_NODE");
   module_initialization_70_cnst_cache(((long) 0), "CNST_NODE");
   return module_initialization_70_cnst_alloc(((long) 0), "CNST_NODE");
}
