/*===========================================================================*/
/*   (Cnst/walk.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t __nb_error_on_pass__70_tools_error;
static obj_t __old_unsafe_version__81_cnst_walk = BUNSPEC;
extern obj_t cnst_walk__13_cnst_walk(obj_t);
extern obj_t _n_o_f_u_c_k_i_n_g___init_or_fini__init_mode__183_engine_param;
static obj_t unsafe__47_cnst_walk();
extern obj_t _stop_cnst_alloc__84_cnst_alloc(obj_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
extern node_t cnst__44_cnst_node(node_t);
static obj_t __old_unsafe_range__218_cnst_walk = BUNSPEC;
extern obj_t _start_cnst_cache__252_cnst_cache(obj_t);
static obj_t imported_modules_init_94_cnst_walk();
extern obj_t module_initialization_70_cnst_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_cnst_alloc(long, char *);
extern obj_t module_initialization_70_cnst_cache(long, char *);
extern obj_t module_initialization_70_cnst_node(long, char *);
extern obj_t module_initialization_70_cnst_initialize(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t toplevel_init_63_cnst_walk();
static obj_t cnst_init_137_cnst_walk();
extern obj_t __unsafe_range__218_engine_param;
extern obj_t initialize_ast_128_cnst_initialize();
static obj_t __old_unsafe_arity__240_cnst_walk = BUNSPEC;
extern obj_t _cnst_walk__8_cnst_walk(obj_t, obj_t);
extern obj_t __unsafe_type__146_engine_param;
extern obj_t __unsafe_struct__195_engine_param;
static obj_t require_initialization_114_cnst_walk = BUNSPEC;
static obj_t library_modules_init_112_cnst_walk();
static obj_t __old_unsafe_struct__195_cnst_walk = BUNSPEC;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t _start_cnst_alloc__241_cnst_alloc(obj_t);
extern obj_t current_error_port;
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t __old_unsafe_type__146_cnst_walk = BUNSPEC;
static obj_t _unsafe__49_cnst_walk(obj_t);
extern obj_t __unsafe_arity__240_engine_param;
extern obj_t __unsafe_version__81_engine_param;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t safe__104_cnst_walk();
static obj_t _safe__136_cnst_walk(obj_t);
extern obj_t __current_pass__25_engine_pass;
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t leave_function_170_tools_error();
static obj_t __cnst[4];

DEFINE_STRING(string1483_cnst_walk, string1483_cnst_walk1495, "failure during prelude hook", 27);
DEFINE_STRING(string1486_cnst_walk, string1486_cnst_walk1496, " error", 6);
extern obj_t stop_cnst_alloc__env_174_cnst_alloc;
DEFINE_STRING(string1482_cnst_walk, string1482_cnst_walk1497, "   . ", 5);
extern obj_t start_cnst_alloc__env_227_cnst_alloc;
DEFINE_STATIC_PROCEDURE(safe__env_5_cnst_walk, _safe__136_cnst_walk1498, _safe__136_cnst_walk, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cnst_walk__env_34_cnst_walk, _cnst_walk__8_cnst_walk1499, _cnst_walk__8_cnst_walk, 0L, 1);
DEFINE_STRING(string1484_cnst_walk, string1484_cnst_walk1500, "      [", 7);
DEFINE_STRING(string1485_cnst_walk, string1485_cnst_walk1501, " occured, ending ...", 20);
DEFINE_STRING(string1488_cnst_walk, string1488_cnst_walk1502, "(STOP-CNST-ALLOC! SAFE!) CNST (START-CNST-CACHE! START-CNST-ALLOC! UNSAFE!) PASS-STARTED ", 89);
extern obj_t start_cnst_cache__env_224_cnst_cache;
DEFINE_STATIC_PROCEDURE(unsafe__env_61_cnst_walk, _unsafe__49_cnst_walk1503, _unsafe__49_cnst_walk, 0L, 0);
DEFINE_STRING(string1481_cnst_walk, string1481_cnst_walk1504, "Cnst", 4);
DEFINE_STRING(string1487_cnst_walk, string1487_cnst_walk1505, "failure during postlude hook", 28);

obj_t 
module_initialization_70_cnst_walk(long checksum_1052, char *from_1053)
{
   if (CBOOL(require_initialization_114_cnst_walk))
     {
	require_initialization_114_cnst_walk = BBOOL(((bool_t) 0));
	library_modules_init_112_cnst_walk();
	cnst_init_137_cnst_walk();
	imported_modules_init_94_cnst_walk();
	toplevel_init_63_cnst_walk();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cnst_walk()
{
   module_initialization_70___r4_output_6_10_3(((long) 0), "CNST_WALK");
   module_initialization_70___reader(((long) 0), "CNST_WALK");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CNST_WALK");
   module_initialization_70___r4_numbers_6_5(((long) 0), "CNST_WALK");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cnst_walk()
{
   {
      obj_t cnst_port_138_1044;
      cnst_port_138_1044 = open_input_string(string1488_cnst_walk);
      {
	 long i_1045;
	 i_1045 = ((long) 3);
       loop_1046:
	 {
	    bool_t test1489_1047;
	    test1489_1047 = (i_1045 == ((long) -1));
	    if (test1489_1047)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1490_1048;
		    {
		       obj_t list1491_1049;
		       {
			  obj_t arg1493_1050;
			  arg1493_1050 = BNIL;
			  list1491_1049 = MAKE_PAIR(cnst_port_138_1044, arg1493_1050);
		       }
		       arg1490_1048 = read___reader(list1491_1049);
		    }
		    CNST_TABLE_SET(i_1045, arg1490_1048);
		 }
		 {
		    int aux_1051;
		    {
		       long aux_1071;
		       aux_1071 = (i_1045 - ((long) 1));
		       aux_1051 = (int) (aux_1071);
		    }
		    {
		       long i_1074;
		       i_1074 = (long) (aux_1051);
		       i_1045 = i_1074;
		       goto loop_1046;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cnst_walk()
{
   __old_unsafe_type__146_cnst_walk = BFALSE;
   __old_unsafe_arity__240_cnst_walk = BFALSE;
   __old_unsafe_range__218_cnst_walk = BFALSE;
   __old_unsafe_struct__195_cnst_walk = BFALSE;
   return (__old_unsafe_version__81_cnst_walk = BFALSE,
      BUNSPEC);
}


obj_t 
cnst_walk__13_cnst_walk(obj_t globals_1)
{
   {
      obj_t list1284_631;
      {
	 obj_t arg1287_633;
	 {
	    obj_t arg1293_635;
	    {
	       obj_t aux_1076;
	       aux_1076 = BCHAR(((unsigned char) '\n'));
	       arg1293_635 = MAKE_PAIR(aux_1076, BNIL);
	    }
	    arg1287_633 = MAKE_PAIR(string1481_cnst_walk, arg1293_635);
	 }
	 list1284_631 = MAKE_PAIR(string1482_cnst_walk, arg1287_633);
      }
      verbose_tools_speek(BINT(((long) 1)), list1284_631);
   }
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   __current_pass__25_engine_pass = string1481_cnst_walk;
   {
      obj_t hooks_637;
      obj_t hnames_638;
      {
	 obj_t arg1296_640;
	 obj_t arg1297_641;
	 {
	    obj_t list1298_642;
	    {
	       obj_t arg1299_643;
	       {
		  obj_t arg1300_644;
		  arg1300_644 = MAKE_PAIR(unsafe__env_61_cnst_walk, BNIL);
		  arg1299_643 = MAKE_PAIR(start_cnst_alloc__env_227_cnst_alloc, arg1300_644);
	       }
	       list1298_642 = MAKE_PAIR(start_cnst_cache__env_224_cnst_cache, arg1299_643);
	    }
	    arg1296_640 = list1298_642;
	 }
	 arg1297_641 = CNST_TABLE_REF(((long) 1));
	 hooks_637 = arg1296_640;
	 hnames_638 = arg1297_641;
       loop_639:
	 if (NULLP(hooks_637))
	   {
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {
	      bool_t test1305_647;
	      {
		 obj_t fun1313_653;
		 fun1313_653 = CAR(hooks_637);
		 {
		    obj_t aux_1092;
		    aux_1092 = PROCEDURE_ENTRY(fun1313_653) (fun1313_653, BEOA);
		    test1305_647 = CBOOL(aux_1092);
		 }
	      }
	      if (test1305_647)
		{
		   {
		      obj_t hnames_1099;
		      obj_t hooks_1097;
		      hooks_1097 = CDR(hooks_637);
		      hnames_1099 = CDR(hnames_638);
		      hnames_638 = hnames_1099;
		      hooks_637 = hooks_1097;
		      goto loop_639;
		   }
		}
	      else
		{
		   internal_error_43_tools_error(string1481_cnst_walk, string1483_cnst_walk, CAR(hnames_638));
		}
	   }
      }
   }
   {
      obj_t list1314_654;
      {
	 obj_t arg1316_656;
	 {
	    obj_t arg1318_657;
	    {
	       obj_t arg1319_658;
	       {
		  obj_t aux_1103;
		  aux_1103 = BCHAR(((unsigned char) '\n'));
		  arg1319_658 = MAKE_PAIR(aux_1103, BNIL);
	       }
	       {
		  obj_t aux_1106;
		  aux_1106 = BCHAR(((unsigned char) ']'));
		  arg1318_657 = MAKE_PAIR(aux_1106, arg1319_658);
	       }
	    }
	    arg1316_656 = MAKE_PAIR(_n_o_f_u_c_k_i_n_g___init_or_fini__init_mode__183_engine_param, arg1318_657);
	 }
	 list1314_654 = MAKE_PAIR(string1484_cnst_walk, arg1316_656);
      }
      verbose_tools_speek(BINT(((long) 2)), list1314_654);
   }
   {
      obj_t l1272_660;
      l1272_660 = globals_1;
    lname1283_661:
      if (PAIRP(l1272_660))
	{
	   {
	      obj_t global_663;
	      global_663 = CAR(l1272_660);
	      {
		 obj_t aux_1116;
		 {
		    global_t obj_1018;
		    obj_1018 = (global_t) (global_663);
		    aux_1116 = (((global_t) CREF(obj_1018))->id);
		 }
		 enter_function_81_tools_error(aux_1116);
	      }
	      {
		 value_t fun_665;
		 {
		    global_t obj_1019;
		    obj_1019 = (global_t) (global_663);
		    fun_665 = (((global_t) CREF(obj_1019))->value);
		 }
		 {
		    node_t new_body_215_666;
		    {
		       node_t aux_1122;
		       {
			  obj_t aux_1123;
			  {
			     sfun_t obj_1020;
			     obj_1020 = (sfun_t) (fun_665);
			     aux_1123 = (((sfun_t) CREF(obj_1020))->body);
			  }
			  aux_1122 = (node_t) (aux_1123);
		       }
		       new_body_215_666 = cnst__44_cnst_node(aux_1122);
		    }
		    {
		       {
			  obj_t res1479_1023;
			  {
			     sfun_t obj_1021;
			     obj_t val1077_1022;
			     obj_1021 = (sfun_t) (fun_665);
			     val1077_1022 = (obj_t) (new_body_215_666);
			     {
				obj_t x_1043;
				x_1043 = ((((sfun_t) CREF(obj_1021))->body) = ((obj_t) val1077_1022), BUNSPEC);
				res1479_1023 = BUNSPEC;
			     }
			  }
			  res1479_1023;
		       }
		    }
		 }
	      }
	      leave_function_170_tools_error();
	   }
	   {
	      obj_t l1272_1132;
	      l1272_1132 = CDR(l1272_660);
	      l1272_660 = l1272_1132;
	      goto lname1283_661;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      obj_t value_669;
      {
	 obj_t arg1355_697;
	 obj_t arg1356_698;
	 arg1355_697 = CNST_TABLE_REF(((long) 2));
	 {
	    obj_t arg1357_699;
	    arg1357_699 = initialize_ast_128_cnst_initialize();
	    arg1356_698 = append_2_18___r4_pairs_and_lists_6_3(arg1357_699, globals_1);
	 }
	 value_669 = remove_var_123_ast_remove(arg1355_697, arg1356_698);
      }
      {
	 bool_t test1326_670;
	 {
	    long n1_1025;
	    n1_1025 = (long) CINT(__nb_error_on_pass__70_tools_error);
	    test1326_670 = (n1_1025 > ((long) 0));
	 }
	 if (test1326_670)
	   {
	      {
		 char *arg1329_673;
		 {
		    bool_t test1340_680;
		    {
		       bool_t test1341_681;
		       {
			  obj_t obj_1027;
			  obj_1027 = __nb_error_on_pass__70_tools_error;
			  test1341_681 = INTEGERP(obj_1027);
		       }
		       if (test1341_681)
			 {
			    test1340_680 = _2__206___r4_numbers_6_5(__nb_error_on_pass__70_tools_error, BINT(((long) 1)));
			 }
		       else
			 {
			    test1340_680 = ((bool_t) 0);
			 }
		    }
		    if (test1340_680)
		      {
			 arg1329_673 = "s";
		      }
		    else
		      {
			 arg1329_673 = "";
		      }
		 }
		 {
		    obj_t list1332_675;
		    {
		       obj_t arg1333_676;
		       {
			  obj_t arg1334_677;
			  {
			     obj_t arg1337_678;
			     arg1337_678 = MAKE_PAIR(string1485_cnst_walk, BNIL);
			     {
				obj_t aux_1147;
				aux_1147 = string_to_bstring(arg1329_673);
				arg1334_677 = MAKE_PAIR(aux_1147, arg1337_678);
			     }
			  }
			  arg1333_676 = MAKE_PAIR(string1486_cnst_walk, arg1334_677);
		       }
		       list1332_675 = MAKE_PAIR(__nb_error_on_pass__70_tools_error, arg1333_676);
		    }
		    fprint___r4_output_6_10_3(current_error_port, list1332_675);
		 }
	      }
	      {
		 obj_t res1480_1029;
		 exit(((long) -1));
		 res1480_1029 = BINT(((long) -1));
		 return res1480_1029;
	      }
	   }
	 else
	   {
	      obj_t hooks_682;
	      obj_t hnames_683;
	      {
		 obj_t arg1342_685;
		 obj_t arg1343_686;
		 {
		    obj_t list1344_687;
		    {
		       obj_t arg1345_688;
		       arg1345_688 = MAKE_PAIR(safe__env_5_cnst_walk, BNIL);
		       list1344_687 = MAKE_PAIR(stop_cnst_alloc__env_174_cnst_alloc, arg1345_688);
		    }
		    arg1342_685 = list1344_687;
		 }
		 arg1343_686 = CNST_TABLE_REF(((long) 3));
		 hooks_682 = arg1342_685;
		 hnames_683 = arg1343_686;
	       loop_684:
		 if (NULLP(hooks_682))
		   {
		      return value_669;
		   }
		 else
		   {
		      bool_t test1348_691;
		      {
			 obj_t fun1354_696;
			 fun1354_696 = CAR(hooks_682);
			 {
			    obj_t aux_1161;
			    aux_1161 = PROCEDURE_ENTRY(fun1354_696) (fun1354_696, BEOA);
			    test1348_691 = CBOOL(aux_1161);
			 }
		      }
		      if (test1348_691)
			{
			   {
			      obj_t hnames_1168;
			      obj_t hooks_1166;
			      hooks_1166 = CDR(hooks_682);
			      hnames_1168 = CDR(hnames_683);
			      hnames_683 = hnames_1168;
			      hooks_682 = hooks_1166;
			      goto loop_684;
			   }
			}
		      else
			{
			   return internal_error_43_tools_error(__current_pass__25_engine_pass, string1487_cnst_walk, CAR(hnames_683));
			}
		   }
	      }
	   }
      }
   }
}


obj_t 
_cnst_walk__8_cnst_walk(obj_t env_1036, obj_t globals_1037)
{
   return cnst_walk__13_cnst_walk(globals_1037);
}


obj_t 
unsafe__47_cnst_walk()
{
   __old_unsafe_type__146_cnst_walk = __unsafe_type__146_engine_param;
   __unsafe_type__146_engine_param = BTRUE;
   __old_unsafe_arity__240_cnst_walk = __unsafe_arity__240_engine_param;
   __unsafe_arity__240_engine_param = BTRUE;
   __old_unsafe_range__218_cnst_walk = __unsafe_range__218_engine_param;
   __unsafe_range__218_engine_param = BTRUE;
   __old_unsafe_struct__195_cnst_walk = __unsafe_struct__195_engine_param;
   __unsafe_struct__195_engine_param = BTRUE;
   __old_unsafe_version__81_cnst_walk = __unsafe_version__81_engine_param;
   return (__unsafe_version__81_engine_param = BTRUE,
      BUNSPEC);
}


obj_t 
_unsafe__49_cnst_walk(obj_t env_1038)
{
   return unsafe__47_cnst_walk();
}


obj_t 
safe__104_cnst_walk()
{
   __unsafe_type__146_engine_param = __old_unsafe_type__146_cnst_walk;
   __unsafe_arity__240_engine_param = __old_unsafe_arity__240_cnst_walk;
   __unsafe_range__218_engine_param = __old_unsafe_range__218_cnst_walk;
   __unsafe_struct__195_engine_param = __old_unsafe_struct__195_cnst_walk;
   return (__unsafe_version__81_engine_param = __old_unsafe_version__81_cnst_walk,
      BUNSPEC);
}


obj_t 
_safe__136_cnst_walk(obj_t env_1041)
{
   return safe__104_cnst_walk();
}


obj_t 
imported_modules_init_94_cnst_walk()
{
   module_initialization_70_tools_speek(((long) 0), "CNST_WALK");
   module_initialization_70_tools_error(((long) 0), "CNST_WALK");
   module_initialization_70_engine_pass(((long) 0), "CNST_WALK");
   module_initialization_70_tools_shape(((long) 0), "CNST_WALK");
   module_initialization_70_engine_param(((long) 0), "CNST_WALK");
   module_initialization_70_type_type(((long) 0), "CNST_WALK");
   module_initialization_70_ast_var(((long) 0), "CNST_WALK");
   module_initialization_70_ast_node(((long) 0), "CNST_WALK");
   module_initialization_70_ast_remove(((long) 0), "CNST_WALK");
   module_initialization_70_cnst_alloc(((long) 0), "CNST_WALK");
   module_initialization_70_cnst_cache(((long) 0), "CNST_WALK");
   module_initialization_70_cnst_node(((long) 0), "CNST_WALK");
   return module_initialization_70_cnst_initialize(((long) 0), "CNST_WALK");
}
