/*===========================================================================*/
/*   (Coerce/app.scm)                                                        */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


static node_t coerce_foreign_fx_app__114_coerce_app(value_t, variable_t, app_t, obj_t);
extern obj_t type_type_type;
extern obj_t _coerce__156_coerce_coerce(obj_t, obj_t, obj_t);
extern node_t coerce__182_coerce_coerce(node_t, type_t);
static node_t coerce_bigloo_app__198_coerce_app(variable_t, app_t, obj_t);
extern obj_t global_ast_var;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_coerce_app();
extern obj_t module_initialization_70_coerce_app(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_coerce_convert(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_coerce_app();
static obj_t cnst_init_137_coerce_app();
extern node_t convert__122_coerce_convert(node_t, type_t, type_t);
extern obj_t cfun_ast_var;
static obj_t require_initialization_114_coerce_app = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_coerce_app();
static node_t coerce_bigloo_intern_app__35_coerce_app(variable_t, app_t, obj_t);
static node_t coerce_foreign_va_app__44_coerce_app(value_t, variable_t, app_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
static obj_t coerce__app1512_98_coerce_app(obj_t, obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
static node_t coerce_foreign_app__190_coerce_app(variable_t, app_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static node_t coerce_bigloo_extern_app__81_coerce_app(variable_t, app_t, obj_t);
extern obj_t app_ast_node;
static obj_t __cnst[2];

DEFINE_STRING(string1517_coerce_app, string1517_coerce_app1526, "coerce-foreign-app!: ", 21);
DEFINE_STRING(string1519_coerce_app, string1519_coerce_app1527, "coerce-bigloo-app!: ", 20);
DEFINE_STRING(string1518_coerce_app, string1518_coerce_app1528, " ", 1);
DEFINE_STRING(string1520_coerce_app, string1520_coerce_app1529, "IMPORT COERCE ", 14);
DEFINE_STRING(string1516_coerce_app, string1516_coerce_app1530, " -> ", 4);
extern obj_t coerce__env_127_coerce_coerce;
DEFINE_STATIC_PROCEDURE(proc1515_coerce_app, coerce__app1512_98_coerce_app1531, coerce__app1512_98_coerce_app, 0L, 2);

obj_t 
module_initialization_70_coerce_app(long checksum_1167, char *from_1168)
{
   if (CBOOL(require_initialization_114_coerce_app))
     {
	require_initialization_114_coerce_app = BBOOL(((bool_t) 0));
	library_modules_init_112_coerce_app();
	cnst_init_137_coerce_app();
	imported_modules_init_94_coerce_app();
	toplevel_init_63_coerce_app();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_coerce_app()
{
   module_initialization_70___object(((long) 0), "COERCE_APP");
   module_initialization_70___reader(((long) 0), "COERCE_APP");
   return BUNSPEC;
}


obj_t 
cnst_init_137_coerce_app()
{
   {
      obj_t cnst_port_138_1159;
      cnst_port_138_1159 = open_input_string(string1520_coerce_app);
      {
	 long i_1160;
	 i_1160 = ((long) 1);
       loop_1161:
	 {
	    bool_t test1521_1162;
	    test1521_1162 = (i_1160 == ((long) -1));
	    if (test1521_1162)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1522_1163;
		    {
		       obj_t list1523_1164;
		       {
			  obj_t arg1524_1165;
			  arg1524_1165 = BNIL;
			  list1523_1164 = MAKE_PAIR(cnst_port_138_1159, arg1524_1165);
		       }
		       arg1522_1163 = read___reader(list1523_1164);
		    }
		    CNST_TABLE_SET(i_1160, arg1522_1163);
		 }
		 {
		    int aux_1166;
		    {
		       long aux_1184;
		       aux_1184 = (i_1160 - ((long) 1));
		       aux_1166 = (int) (aux_1184);
		    }
		    {
		       long i_1187;
		       i_1187 = (long) (aux_1166);
		       i_1160 = i_1187;
		       goto loop_1161;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_coerce_app()
{
   {
      obj_t coerce__app_245_1152;
      coerce__app_245_1152 = proc1515_coerce_app;
      return add_method__1___object(coerce__env_127_coerce_coerce, app_ast_node, coerce__app_245_1152);
   }
}


obj_t 
coerce__app1512_98_coerce_app(obj_t env_1153, obj_t node_1154, obj_t to_1155)
{
   {
      app_t node_652;
      obj_t to_653;
      {
	 node_t aux_1190;
	 node_652 = (app_t) (node_1154);
	 to_653 = to_1155;
	 {
	    variable_t fun_656;
	    {
	       var_t arg1276_660;
	       arg1276_660 = (((app_t) CREF(node_652))->fun);
	       fun_656 = (((var_t) CREF(arg1276_660))->variable);
	    }
	    {
	       bool_t test1273_657;
	       {
		  bool_t test1274_658;
		  test1274_658 = is_a__118___object((obj_t) (fun_656), global_ast_var);
		  if (test1274_658)
		    {
		       obj_t aux_1196;
		       {
			  value_t aux_1197;
			  aux_1197 = (((variable_t) CREF(fun_656))->value);
			  aux_1196 = (obj_t) (aux_1197);
		       }
		       test1273_657 = is_a__118___object(aux_1196, cfun_ast_var);
		    }
		  else
		    {
		       test1273_657 = ((bool_t) 0);
		    }
	       }
	       if (test1273_657)
		 {
		    aux_1190 = coerce_foreign_app__190_coerce_app(fun_656, node_652, to_653);
		 }
	       else
		 {
		    aux_1190 = coerce_bigloo_app__198_coerce_app(fun_656, node_652, to_653);
		 }
	    }
	 }
	 return (obj_t) (aux_1190);
      }
   }
}


node_t 
coerce_foreign_app__190_coerce_app(variable_t callee_3, app_t node_4, obj_t to_5)
{
   {
      bool_t test1278_663;
      {
	 obj_t aux_1206;
	 aux_1206 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1278_663 = CBOOL(aux_1206);
      }
      if (test1278_663)
	{
	   obj_t arg1280_665;
	   obj_t arg1283_667;
	   arg1280_665 = shape_tools_shape((obj_t) (node_4));
	   arg1283_667 = shape_tools_shape(to_5);
	   {
	      obj_t list1284_668;
	      {
		 obj_t arg1286_669;
		 {
		    obj_t arg1287_670;
		    {
		       obj_t arg1290_671;
		       {
			  obj_t arg1293_672;
			  {
			     obj_t aux_1215;
			     aux_1215 = BCHAR(((unsigned char) '\n'));
			     arg1293_672 = MAKE_PAIR(aux_1215, BNIL);
			  }
			  arg1290_671 = MAKE_PAIR(arg1283_667, arg1293_672);
		       }
		       arg1287_670 = MAKE_PAIR(string1516_coerce_app, arg1290_671);
		    }
		    arg1286_669 = MAKE_PAIR(arg1280_665, arg1287_670);
		 }
		 list1284_668 = MAKE_PAIR(string1517_coerce_app, arg1286_669);
	      }
	      print_trace_107_tools_trace(list1284_668);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      value_t ffun_676;
      ffun_676 = (((variable_t) CREF(callee_3))->value);
      {
	 {
	    bool_t test_1224;
	    {
	       long aux_1225;
	       {
		  fun_t obj_1083;
		  obj_1083 = (fun_t) (ffun_676);
		  aux_1225 = (((fun_t) CREF(obj_1083))->arity);
	       }
	       test_1224 = (aux_1225 >= ((long) 0));
	    }
	    if (test_1224)
	      {
		 return coerce_foreign_fx_app__114_coerce_app(ffun_676, callee_3, node_4, to_5);
	      }
	    else
	      {
		 return coerce_foreign_va_app__44_coerce_app(ffun_676, callee_3, node_4, to_5);
	      }
	 }
      }
   }
}


node_t 
coerce_foreign_fx_app__114_coerce_app(value_t fun_6, variable_t callee_7, app_t node_8, obj_t to_9)
{
   {
      obj_t actuals_679;
      obj_t types_680;
      actuals_679 = (((app_t) CREF(node_8))->args);
      {
	 cfun_t obj_1087;
	 obj_1087 = (cfun_t) (fun_6);
	 types_680 = (((cfun_t) CREF(obj_1087))->args_type_205);
      }
    loop_681:
      if (NULLP(actuals_679))
	{
	   return convert__122_coerce_convert((node_t) (node_8), (((variable_t) CREF(callee_7))->type), (type_t) (to_9));
	}
      else
	{
	   {
	      node_t arg1305_686;
	      {
		 type_t aux_1241;
		 node_t aux_1237;
		 {
		    obj_t aux_1242;
		    aux_1242 = CAR(types_680);
		    aux_1241 = (type_t) (aux_1242);
		 }
		 {
		    obj_t aux_1238;
		    aux_1238 = CAR(actuals_679);
		    aux_1237 = (node_t) (aux_1238);
		 }
		 arg1305_686 = coerce__182_coerce_coerce(aux_1237, aux_1241);
	      }
	      {
		 obj_t aux_1246;
		 aux_1246 = (obj_t) (arg1305_686);
		 SET_CAR(actuals_679, aux_1246);
	      }
	   }
	   {
	      obj_t types_1251;
	      obj_t actuals_1249;
	      actuals_1249 = CDR(actuals_679);
	      types_1251 = CDR(types_680);
	      types_680 = types_1251;
	      actuals_679 = actuals_1249;
	      goto loop_681;
	   }
	}
   }
}


node_t 
coerce_foreign_va_app__44_coerce_app(value_t fun_10, variable_t callee_11, app_t node_12, obj_t to_13)
{
   {
      obj_t actuals_691;
      obj_t types_692;
      long counter_693;
      actuals_691 = (((app_t) CREF(node_12))->args);
      {
	 cfun_t obj_1097;
	 obj_1097 = (cfun_t) (fun_10);
	 types_692 = (((cfun_t) CREF(obj_1097))->args_type_205);
      }
      {
	 fun_t obj_1098;
	 obj_1098 = (fun_t) (fun_10);
	 counter_693 = (((fun_t) CREF(obj_1098))->arity);
      }
    loop_694:
      if ((counter_693 == ((long) -1)))
	{
	   obj_t actuals_699;
	   actuals_699 = actuals_691;
	 loop_700:
	   if (NULLP(actuals_699))
	     {
		return convert__122_coerce_convert((node_t) (node_12), (((variable_t) CREF(callee_11))->type), (type_t) (to_13));
	     }
	   else
	     {
		{
		   node_t arg1319_703;
		   {
		      type_t aux_1268;
		      node_t aux_1264;
		      {
			 obj_t aux_1269;
			 aux_1269 = CAR(types_692);
			 aux_1268 = (type_t) (aux_1269);
		      }
		      {
			 obj_t aux_1265;
			 aux_1265 = CAR(actuals_699);
			 aux_1264 = (node_t) (aux_1265);
		      }
		      arg1319_703 = coerce__182_coerce_coerce(aux_1264, aux_1268);
		   }
		   {
		      obj_t aux_1273;
		      aux_1273 = (obj_t) (arg1319_703);
		      SET_CAR(actuals_699, aux_1273);
		   }
		}
		{
		   obj_t actuals_1276;
		   actuals_1276 = CDR(actuals_699);
		   actuals_699 = actuals_1276;
		   goto loop_700;
		}
	     }
	}
      else
	{
	   {
	      node_t arg1323_707;
	      {
		 type_t aux_1282;
		 node_t aux_1278;
		 {
		    obj_t aux_1283;
		    aux_1283 = CAR(types_692);
		    aux_1282 = (type_t) (aux_1283);
		 }
		 {
		    obj_t aux_1279;
		    aux_1279 = CAR(actuals_691);
		    aux_1278 = (node_t) (aux_1279);
		 }
		 arg1323_707 = coerce__182_coerce_coerce(aux_1278, aux_1282);
	      }
	      {
		 obj_t aux_1287;
		 aux_1287 = (obj_t) (arg1323_707);
		 SET_CAR(actuals_691, aux_1287);
	      }
	   }
	   {
	      long counter_1294;
	      obj_t types_1292;
	      obj_t actuals_1290;
	      actuals_1290 = CDR(actuals_691);
	      types_1292 = CDR(types_692);
	      counter_1294 = (counter_693 + ((long) 1));
	      counter_693 = counter_1294;
	      types_692 = types_1292;
	      actuals_691 = actuals_1290;
	      goto loop_694;
	   }
	}
   }
}


node_t 
coerce_bigloo_app__198_coerce_app(variable_t callee_14, app_t node_15, obj_t to_16)
{
   {
      bool_t test1332_713;
      {
	 obj_t aux_1301;
	 aux_1301 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1332_713 = CBOOL(aux_1301);
      }
      if (test1332_713)
	{
	   obj_t arg1334_715;
	   obj_t arg1339_717;
	   arg1334_715 = shape_tools_shape((obj_t) (node_15));
	   arg1339_717 = shape_tools_shape(to_16);
	   {
	      obj_t list1340_718;
	      {
		 obj_t arg1342_719;
		 {
		    obj_t arg1343_720;
		    {
		       obj_t arg1345_721;
		       {
			  obj_t arg1346_722;
			  {
			     obj_t aux_1310;
			     aux_1310 = BCHAR(((unsigned char) '\n'));
			     arg1346_722 = MAKE_PAIR(aux_1310, BNIL);
			  }
			  arg1345_721 = MAKE_PAIR(arg1339_717, arg1346_722);
		       }
		       arg1343_720 = MAKE_PAIR(string1518_coerce_app, arg1345_721);
		    }
		    arg1342_719 = MAKE_PAIR(arg1334_715, arg1343_720);
		 }
		 list1340_718 = MAKE_PAIR(string1519_coerce_app, arg1342_719);
	      }
	      print_trace_107_tools_trace(list1340_718);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test1351_726;
      {
	 bool_t test1352_727;
	 test1352_727 = is_a__118___object((obj_t) (callee_14), global_ast_var);
	 if (test1352_727)
	   {
	      bool_t test_1321;
	      {
		 obj_t aux_1325;
		 obj_t aux_1322;
		 aux_1325 = CNST_TABLE_REF(((long) 1));
		 {
		    global_t obj_1117;
		    obj_1117 = (global_t) (callee_14);
		    aux_1322 = (((global_t) CREF(obj_1117))->import);
		 }
		 test_1321 = (aux_1322 == aux_1325);
	      }
	      if (test_1321)
		{
		   bool_t test_1328;
		   {
		      obj_t aux_1329;
		      {
			 sfun_t obj_1121;
			 {
			    value_t aux_1330;
			    aux_1330 = (((variable_t) CREF(callee_14))->value);
			    obj_1121 = (sfun_t) (aux_1330);
			 }
			 aux_1329 = (((sfun_t) CREF(obj_1121))->args);
		      }
		      test_1328 = PAIRP(aux_1329);
		   }
		   if (test_1328)
		     {
			obj_t aux_1335;
			{
			   obj_t aux_1336;
			   {
			      sfun_t obj_1124;
			      {
				 value_t aux_1337;
				 aux_1337 = (((variable_t) CREF(callee_14))->value);
				 obj_1124 = (sfun_t) (aux_1337);
			      }
			      aux_1336 = (((sfun_t) CREF(obj_1124))->args);
			   }
			   aux_1335 = CAR(aux_1336);
			}
			test1351_726 = is_a__118___object(aux_1335, type_type_type);
		     }
		   else
		     {
			test1351_726 = ((bool_t) 0);
		     }
		}
	      else
		{
		   test1351_726 = ((bool_t) 0);
		}
	   }
	 else
	   {
	      test1351_726 = ((bool_t) 0);
	   }
      }
      if (test1351_726)
	{
	   return coerce_bigloo_extern_app__81_coerce_app(callee_14, node_15, to_16);
	}
      else
	{
	   return coerce_bigloo_intern_app__35_coerce_app(callee_14, node_15, to_16);
	}
   }
}


node_t 
coerce_bigloo_intern_app__35_coerce_app(variable_t callee_17, app_t node_18, obj_t to_19)
{
   {
      value_t fun_737;
      fun_737 = (((variable_t) CREF(callee_17))->value);
      {
	 obj_t sh_739;
	 sh_739 = shape_tools_shape((obj_t) (callee_17));
	 {
	    {
	       obj_t actuals_740;
	       obj_t formals_741;
	       actuals_740 = (((app_t) CREF(node_18))->args);
	       {
		  sfun_t obj_1130;
		  obj_1130 = (sfun_t) (fun_737);
		  formals_741 = (((sfun_t) CREF(obj_1130))->args);
	       }
	     loop_742:
	       if (NULLP(actuals_740))
		 {
		    return convert__122_coerce_convert((node_t) (node_18), (((variable_t) CREF(callee_17))->type), (type_t) (to_19));
		 }
	       else
		 {
		    {
		       node_t arg1370_747;
		       {
			  type_t aux_1359;
			  node_t aux_1355;
			  {
			     local_t obj_1135;
			     {
				obj_t aux_1360;
				aux_1360 = CAR(formals_741);
				obj_1135 = (local_t) (aux_1360);
			     }
			     aux_1359 = (((local_t) CREF(obj_1135))->type);
			  }
			  {
			     obj_t aux_1356;
			     aux_1356 = CAR(actuals_740);
			     aux_1355 = (node_t) (aux_1356);
			  }
			  arg1370_747 = coerce__182_coerce_coerce(aux_1355, aux_1359);
		       }
		       {
			  obj_t aux_1365;
			  aux_1365 = (obj_t) (arg1370_747);
			  SET_CAR(actuals_740, aux_1365);
		       }
		    }
		    {
		       obj_t formals_1370;
		       obj_t actuals_1368;
		       actuals_1368 = CDR(actuals_740);
		       formals_1370 = CDR(formals_741);
		       formals_741 = formals_1370;
		       actuals_740 = actuals_1368;
		       goto loop_742;
		    }
		 }
	    }
	 }
      }
   }
}


node_t 
coerce_bigloo_extern_app__81_coerce_app(variable_t callee_20, app_t node_21, obj_t to_22)
{
   {
      {
	 obj_t actuals_755;
	 obj_t formals_756;
	 actuals_755 = (((app_t) CREF(node_21))->args);
	 {
	    sfun_t obj_1143;
	    {
	       value_t aux_1398;
	       aux_1398 = (((variable_t) CREF(callee_20))->value);
	       obj_1143 = (sfun_t) (aux_1398);
	    }
	    formals_756 = (((sfun_t) CREF(obj_1143))->args);
	 }
       loop_757:
	 if (NULLP(actuals_755))
	   {
	      return convert__122_coerce_convert((node_t) (node_21), (((variable_t) CREF(callee_20))->type), (type_t) (to_22));
	   }
	 else
	   {
	      {
		 node_t arg1390_762;
		 {
		    type_t aux_1385;
		    node_t aux_1381;
		    {
		       obj_t aux_1386;
		       aux_1386 = CAR(formals_756);
		       aux_1385 = (type_t) (aux_1386);
		    }
		    {
		       obj_t aux_1382;
		       aux_1382 = CAR(actuals_755);
		       aux_1381 = (node_t) (aux_1382);
		    }
		    arg1390_762 = coerce__182_coerce_coerce(aux_1381, aux_1385);
		 }
		 {
		    obj_t aux_1390;
		    aux_1390 = (obj_t) (arg1390_762);
		    SET_CAR(actuals_755, aux_1390);
		 }
	      }
	      {
		 obj_t formals_1395;
		 obj_t actuals_1393;
		 actuals_1393 = CDR(actuals_755);
		 formals_1395 = CDR(formals_756);
		 formals_756 = formals_1395;
		 actuals_755 = actuals_1393;
		 goto loop_757;
	      }
	   }
      }
   }
}


obj_t 
imported_modules_init_94_coerce_app()
{
   module_initialization_70_tools_trace(((long) 0), "COERCE_APP");
   module_initialization_70_tools_shape(((long) 0), "COERCE_APP");
   module_initialization_70_type_type(((long) 0), "COERCE_APP");
   module_initialization_70_type_cache(((long) 0), "COERCE_APP");
   module_initialization_70_ast_var(((long) 0), "COERCE_APP");
   module_initialization_70_ast_node(((long) 0), "COERCE_APP");
   module_initialization_70_coerce_coerce(((long) 0), "COERCE_APP");
   return module_initialization_70_coerce_convert(((long) 0), "COERCE_APP");
}
