/*===========================================================================*/
/*   (Coerce/apply.scm)                                                      */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t __procedure__226_type_cache;
extern obj_t _coerce__156_coerce_coerce(obj_t, obj_t, obj_t);
static obj_t coerce__app_ly1643_55_coerce_apply(obj_t, obj_t, obj_t);
extern node_t coerce__182_coerce_coerce(node_t, type_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_coerce_apply();
extern obj_t module_initialization_70_coerce_apply(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_coerce_convert(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t toplevel_init_63_coerce_apply();
static obj_t cnst_init_137_coerce_apply();
extern node_t convert__122_coerce_convert(node_t, type_t, type_t);
extern obj_t __compiler_debug__134_engine_param;
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t __unsafe_type__146_engine_param;
static obj_t require_initialization_114_coerce_apply = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_coerce_apply();
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern long class_num_218___object(obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t __unsafe_arity__240_engine_param;
extern obj_t location_full_fname_231_tools_location(obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static node_t make_error_node_135_coerce_apply(obj_t, obj_t, obj_t);
extern obj_t __obj__252_type_cache;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
extern obj_t current_function_76_tools_error();
extern node_t top_level_sexp__node_204_ast_sexp(obj_t, obj_t);
static obj_t __cnst[17];

DEFINE_STRING(string1647_coerce_apply, string1647_coerce_apply1655, "coerce-apply!: ", 15);
DEFINE_STATIC_PROCEDURE(proc1646_coerce_apply, coerce__app_ly1643_55_coerce_apply1656, coerce__app_ly1643_55_coerce_apply, 0L, 2);
DEFINE_STRING(string1648_coerce_apply, string1648_coerce_apply1657, "Wrong number of arguments", 25);
DEFINE_STRING(string1649_coerce_apply, string1649_coerce_apply1658, "_ FAILURE __ERROR ERROR/LOCATION @ BEGIN LOCATION CORRECT-ARITY? IF LENGTH ::LONG LET LEN VAL FUN QUOTE COERCE ", 111);
extern obj_t coerce__env_127_coerce_coerce;

obj_t 
module_initialization_70_coerce_apply(long checksum_1307, char *from_1308)
{
   if (CBOOL(require_initialization_114_coerce_apply))
     {
	require_initialization_114_coerce_apply = BBOOL(((bool_t) 0));
	library_modules_init_112_coerce_apply();
	cnst_init_137_coerce_apply();
	imported_modules_init_94_coerce_apply();
	toplevel_init_63_coerce_apply();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_coerce_apply()
{
   module_initialization_70___object(((long) 0), "COERCE_APPLY");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "COERCE_APPLY");
   module_initialization_70___reader(((long) 0), "COERCE_APPLY");
   module_initialization_70___r4_symbols_6_4(((long) 0), "COERCE_APPLY");
   return BUNSPEC;
}


obj_t 
cnst_init_137_coerce_apply()
{
   {
      obj_t cnst_port_138_1299;
      cnst_port_138_1299 = open_input_string(string1649_coerce_apply);
      {
	 long i_1300;
	 i_1300 = ((long) 16);
       loop_1301:
	 {
	    bool_t test1650_1302;
	    test1650_1302 = (i_1300 == ((long) -1));
	    if (test1650_1302)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1651_1303;
		    {
		       obj_t list1652_1304;
		       {
			  obj_t arg1653_1305;
			  arg1653_1305 = BNIL;
			  list1652_1304 = MAKE_PAIR(cnst_port_138_1299, arg1653_1305);
		       }
		       arg1651_1303 = read___reader(list1652_1304);
		    }
		    CNST_TABLE_SET(i_1300, arg1651_1303);
		 }
		 {
		    int aux_1306;
		    {
		       long aux_1326;
		       aux_1326 = (i_1300 - ((long) 1));
		       aux_1306 = (int) (aux_1326);
		    }
		    {
		       long i_1329;
		       i_1329 = (long) (aux_1306);
		       i_1300 = i_1329;
		       goto loop_1301;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_coerce_apply()
{
   {
      obj_t coerce__app_ly_232_1286;
      coerce__app_ly_232_1286 = proc1646_coerce_apply;
      return add_method__1___object(coerce__env_127_coerce_coerce, app_ly_162_ast_node, coerce__app_ly_232_1286);
   }
}


obj_t 
coerce__app_ly1643_55_coerce_apply(obj_t env_1287, obj_t node_1288, obj_t to_1289)
{
   {
      app_ly_162_t node_645;
      obj_t to_646;
      node_645 = (app_ly_162_t) (node_1288);
      to_646 = to_1289;
      {
	 bool_t test1273_649;
	 {
	    obj_t aux_1332;
	    aux_1332 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	    test1273_649 = CBOOL(aux_1332);
	 }
	 if (test1273_649)
	   {
	      obj_t arg1276_651;
	      arg1276_651 = shape_tools_shape((obj_t) (node_645));
	      {
		 obj_t list1277_652;
		 {
		    obj_t arg1278_653;
		    {
		       obj_t arg1279_654;
		       {
			  obj_t aux_1340;
			  aux_1340 = BCHAR(((unsigned char) '\n'));
			  arg1279_654 = MAKE_PAIR(aux_1340, BNIL);
		       }
		       arg1278_653 = MAKE_PAIR(arg1276_651, arg1279_654);
		    }
		    list1277_652 = MAKE_PAIR(string1647_coerce_apply, arg1278_653);
		 }
		 print_trace_107_tools_trace(list1277_652);
	      }
	   }
	 else
	   {
	      BUNSPEC;
	   }
      }
      {
	 obj_t error_msg_180_658;
	 {
	    obj_t arg1382_735;
	    obj_t arg1385_736;
	    arg1382_735 = CNST_TABLE_REF(((long) 1));
	    arg1385_736 = shape_tools_shape((obj_t) (node_645));
	    {
	       obj_t list1386_737;
	       {
		  obj_t arg1388_738;
		  arg1388_738 = MAKE_PAIR(arg1385_736, BNIL);
		  list1386_737 = MAKE_PAIR(arg1382_735, arg1388_738);
	       }
	       error_msg_180_658 = list1386_737;
	    }
	 }
	 {
	    node_t arg1284_659;
	    arg1284_659 = coerce__182_coerce_coerce((((app_ly_162_t) CREF(node_645))->arg), (type_t) (__obj__252_type_cache));
	    {
	       obj_t res1634_1156;
	       {
		  obj_t x_1294;
		  x_1294 = ((((app_ly_162_t) CREF(node_645))->arg) = ((node_t) arg1284_659), BUNSPEC);
		  res1634_1156 = BUNSPEC;
	       }
	       res1634_1156;
	    }
	 }
	 {
	    node_t c_fun_136_661;
	    c_fun_136_661 = coerce__182_coerce_coerce((((app_ly_162_t) CREF(node_645))->fun), (type_t) (__procedure__226_type_cache));
	    if (CBOOL(__unsafe_arity__240_engine_param))
	      {
		 {
		    bool_t test1287_662;
		    test1287_662 = is_a__118___object((obj_t) (c_fun_136_661), var_ast_node);
		    if (test1287_662)
		      {
			 {
			    obj_t res1635_1161;
			    {
			       obj_t x_1295;
			       x_1295 = ((((app_ly_162_t) CREF(node_645))->fun) = ((node_t) c_fun_136_661), BUNSPEC);
			       res1635_1161 = BUNSPEC;
			    }
			    res1635_1161;
			 }
			 {
			    node_t aux_1364;
			    aux_1364 = convert__122_coerce_convert((node_t) (node_645), (type_t) (__obj__252_type_cache), (type_t) (to_646));
			    return (obj_t) (aux_1364);
			 }
		      }
		    else
		      {
			 local_t fun_663;
			 fun_663 = make_local_svar_140_ast_local(CNST_TABLE_REF(((long) 2)), (type_t) (__procedure__226_type_cache));
			 {
			    obj_t res1636_1164;
			    {
			       obj_t x_1296;
			       x_1296 = ((((app_ly_162_t) CREF(node_645))->fun) = ((node_t) c_fun_136_661), BUNSPEC);
			       res1636_1164 = BUNSPEC;
			    }
			    res1636_1164;
			 }
			 {
			    obj_t arg1290_664;
			    type_t arg1293_665;
			    obj_t arg1295_666;
			    node_t arg1296_667;
			    {
			       node_t obj_1165;
			       obj_1165 = (node_t) (node_645);
			       arg1290_664 = (((node_t) CREF(obj_1165))->loc);
			    }
			    {
			       node_t obj_1166;
			       obj_1166 = (node_t) (node_645);
			       arg1293_665 = (((node_t) CREF(obj_1166))->type);
			    }
			    {
			       obj_t arg1297_668;
			       {
				  obj_t aux_1380;
				  obj_t aux_1378;
				  aux_1380 = (obj_t) (c_fun_136_661);
				  aux_1378 = (obj_t) (fun_663);
				  arg1297_668 = MAKE_PAIR(aux_1378, aux_1380);
			       }
			       {
				  obj_t list1298_669;
				  list1298_669 = MAKE_PAIR(arg1297_668, BNIL);
				  arg1295_666 = list1298_669;
			       }
			    }
			    arg1296_667 = convert__122_coerce_convert((node_t) (node_645), (type_t) (__obj__252_type_cache), (type_t) (to_646));
			    {
			       let_var_6_t res1637_1186;
			       {
				  let_var_6_t new1229_1176;
				  new1229_1176 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
				  {
				     long arg1555_1177;
				     arg1555_1177 = class_num_218___object(let_var_6_ast_node);
				     {
					obj_t obj_1184;
					obj_1184 = (obj_t) (new1229_1176);
					(((obj_t) CREF(obj_1184))->header = MAKE_HEADER(arg1555_1177, 0), BUNSPEC);
				     }
				  }
				  {
				     object_t aux_1392;
				     aux_1392 = (object_t) (new1229_1176);
				     OBJECT_WIDENING_SET(aux_1392, BFALSE);
				  }
				  ((((let_var_6_t) CREF(new1229_1176))->loc) = ((obj_t) arg1290_664), BUNSPEC);
				  ((((let_var_6_t) CREF(new1229_1176))->type) = ((type_t) arg1293_665), BUNSPEC);
				  ((((let_var_6_t) CREF(new1229_1176))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
				  ((((let_var_6_t) CREF(new1229_1176))->bindings) = ((obj_t) arg1295_666), BUNSPEC);
				  ((((let_var_6_t) CREF(new1229_1176))->body) = ((node_t) arg1296_667), BUNSPEC);
				  ((((let_var_6_t) CREF(new1229_1176))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				  res1637_1186 = new1229_1176;
			       }
			       return (obj_t) (res1637_1186);
			    }
			 }
		      }
		 }
	      }
	    else
	      {
		 local_t fun_672;
		 fun_672 = make_local_svar_140_ast_local(CNST_TABLE_REF(((long) 2)), (type_t) (__procedure__226_type_cache));
		 {
		    local_t val_673;
		    val_673 = make_local_svar_140_ast_local(CNST_TABLE_REF(((long) 3)), (type_t) (__procedure__226_type_cache));
		    {
		       obj_t len_674;
		       len_674 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 4)), BEOA);
		       {
			  obj_t loc_675;
			  {
			     node_t obj_1187;
			     obj_1187 = (node_t) (node_645);
			     loc_675 = (((node_t) CREF(obj_1187))->loc);
			  }
			  {
			     let_var_6_t lnode_676;
			     {
				obj_t arg1307_679;
				node_t arg1308_680;
				{
				   obj_t arg1310_681;
				   obj_t arg1311_682;
				   {
				      obj_t aux_1415;
				      obj_t aux_1413;
				      aux_1415 = (obj_t) (c_fun_136_661);
				      aux_1413 = (obj_t) (fun_672);
				      arg1310_681 = MAKE_PAIR(aux_1413, aux_1415);
				   }
				   {
				      obj_t aux_1420;
				      obj_t aux_1418;
				      {
					 node_t aux_1421;
					 aux_1421 = (((app_ly_162_t) CREF(node_645))->arg);
					 aux_1420 = (obj_t) (aux_1421);
				      }
				      aux_1418 = (obj_t) (val_673);
				      arg1311_682 = MAKE_PAIR(aux_1418, aux_1420);
				   }
				   {
				      obj_t list1312_683;
				      {
					 obj_t arg1313_684;
					 arg1313_684 = MAKE_PAIR(arg1311_682, BNIL);
					 list1312_683 = MAKE_PAIR(arg1310_681, arg1313_684);
				      }
				      arg1307_679 = list1312_683;
				   }
				}
				{
				   obj_t arg1316_687;
				   {
				      obj_t arg1318_688;
				      obj_t arg1319_689;
				      obj_t arg1320_690;
				      arg1318_688 = CNST_TABLE_REF(((long) 5));
				      {
					 obj_t arg1328_696;
					 {
					    obj_t arg1332_700;
					    obj_t arg1333_701;
					    {
					       obj_t list1341_707;
					       {
						  obj_t arg1342_708;
						  {
						     obj_t aux_1428;
						     aux_1428 = CNST_TABLE_REF(((long) 6));
						     arg1342_708 = MAKE_PAIR(aux_1428, BNIL);
						  }
						  list1341_707 = MAKE_PAIR(len_674, arg1342_708);
					       }
					       arg1332_700 = symbol_append_197___r4_symbols_6_4(list1341_707);
					    }
					    {
					       obj_t arg1345_710;
					       arg1345_710 = CNST_TABLE_REF(((long) 7));
					       {
						  obj_t list1347_712;
						  {
						     obj_t arg1349_713;
						     arg1349_713 = MAKE_PAIR(BNIL, BNIL);
						     {
							obj_t aux_1435;
							aux_1435 = (obj_t) (val_673);
							list1347_712 = MAKE_PAIR(aux_1435, arg1349_713);
						     }
						  }
						  arg1333_701 = cons__138___r4_pairs_and_lists_6_3(arg1345_710, list1347_712);
					       }
					    }
					    {
					       obj_t list1335_703;
					       {
						  obj_t arg1337_704;
						  arg1337_704 = MAKE_PAIR(BNIL, BNIL);
						  list1335_703 = MAKE_PAIR(arg1333_701, arg1337_704);
					       }
					       arg1328_696 = cons__138___r4_pairs_and_lists_6_3(arg1332_700, list1335_703);
					    }
					 }
					 {
					    obj_t list1330_698;
					    list1330_698 = MAKE_PAIR(BNIL, BNIL);
					    arg1319_689 = cons__138___r4_pairs_and_lists_6_3(arg1328_696, list1330_698);
					 }
				      }
				      {
					 obj_t arg1352_715;
					 obj_t arg1353_716;
					 node_t arg1355_717;
					 node_t arg1356_718;
					 arg1352_715 = CNST_TABLE_REF(((long) 8));
					 {
					    obj_t arg1366_725;
					    arg1366_725 = CNST_TABLE_REF(((long) 9));
					    {
					       obj_t list1368_727;
					       {
						  obj_t arg1369_728;
						  {
						     obj_t arg1370_729;
						     arg1370_729 = MAKE_PAIR(BNIL, BNIL);
						     arg1369_728 = MAKE_PAIR(len_674, arg1370_729);
						  }
						  {
						     obj_t aux_1448;
						     aux_1448 = (obj_t) (fun_672);
						     list1368_727 = MAKE_PAIR(aux_1448, arg1369_728);
						  }
					       }
					       arg1353_716 = cons__138___r4_pairs_and_lists_6_3(arg1366_725, list1368_727);
					    }
					 }
					 arg1355_717 = convert__122_coerce_convert((node_t) (node_645), (type_t) (__obj__252_type_cache), (type_t) (to_646));
					 arg1356_718 = make_error_node_135_coerce_apply(error_msg_180_658, loc_675, to_646);
					 {
					    obj_t list1358_720;
					    {
					       obj_t arg1359_721;
					       {
						  obj_t arg1361_722;
						  {
						     obj_t arg1363_723;
						     arg1363_723 = MAKE_PAIR(BNIL, BNIL);
						     {
							obj_t aux_1458;
							aux_1458 = (obj_t) (arg1356_718);
							arg1361_722 = MAKE_PAIR(aux_1458, arg1363_723);
						     }
						  }
						  {
						     obj_t aux_1461;
						     aux_1461 = (obj_t) (arg1355_717);
						     arg1359_721 = MAKE_PAIR(aux_1461, arg1361_722);
						  }
					       }
					       list1358_720 = MAKE_PAIR(arg1353_716, arg1359_721);
					    }
					    arg1320_690 = cons__138___r4_pairs_and_lists_6_3(arg1352_715, list1358_720);
					 }
				      }
				      {
					 obj_t list1322_692;
					 {
					    obj_t arg1323_693;
					    {
					       obj_t arg1325_694;
					       arg1325_694 = MAKE_PAIR(BNIL, BNIL);
					       arg1323_693 = MAKE_PAIR(arg1320_690, arg1325_694);
					    }
					    list1322_692 = MAKE_PAIR(arg1319_689, arg1323_693);
					 }
					 arg1316_687 = cons__138___r4_pairs_and_lists_6_3(arg1318_688, list1322_692);
				      }
				   }
				   arg1308_680 = top_level_sexp__node_204_ast_sexp(arg1316_687, loc_675);
				}
				{
				   let_var_6_t res1638_1210;
				   {
				      type_t type_1195;
				      type_1195 = (type_t) (__obj__252_type_cache);
				      {
					 let_var_6_t new1229_1200;
					 new1229_1200 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
					 {
					    long arg1555_1201;
					    arg1555_1201 = class_num_218___object(let_var_6_ast_node);
					    {
					       obj_t obj_1208;
					       obj_1208 = (obj_t) (new1229_1200);
					       (((obj_t) CREF(obj_1208))->header = MAKE_HEADER(arg1555_1201, 0), BUNSPEC);
					    }
					 }
					 {
					    object_t aux_1476;
					    aux_1476 = (object_t) (new1229_1200);
					    OBJECT_WIDENING_SET(aux_1476, BFALSE);
					 }
					 ((((let_var_6_t) CREF(new1229_1200))->loc) = ((obj_t) loc_675), BUNSPEC);
					 ((((let_var_6_t) CREF(new1229_1200))->type) = ((type_t) type_1195), BUNSPEC);
					 ((((let_var_6_t) CREF(new1229_1200))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
					 ((((let_var_6_t) CREF(new1229_1200))->bindings) = ((obj_t) arg1307_679), BUNSPEC);
					 ((((let_var_6_t) CREF(new1229_1200))->body) = ((node_t) arg1308_680), BUNSPEC);
					 ((((let_var_6_t) CREF(new1229_1200))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					 res1638_1210 = new1229_1200;
				      }
				   }
				   lnode_676 = res1638_1210;
				}
			     }
			     {
				{
				   var_t arg1303_677;
				   {
				      var_t res1639_1221;
				      {
					 type_t type_1212;
					 variable_t variable_1213;
					 type_1212 = (type_t) (__procedure__226_type_cache);
					 variable_1213 = (variable_t) (fun_672);
					 {
					    var_t new1128_1214;
					    new1128_1214 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
					    {
					       long arg1589_1215;
					       arg1589_1215 = class_num_218___object(var_ast_node);
					       {
						  obj_t obj_1219;
						  obj_1219 = (obj_t) (new1128_1214);
						  (((obj_t) CREF(obj_1219))->header = MAKE_HEADER(arg1589_1215, 0), BUNSPEC);
					       }
					    }
					    {
					       object_t aux_1491;
					       aux_1491 = (object_t) (new1128_1214);
					       OBJECT_WIDENING_SET(aux_1491, BFALSE);
					    }
					    ((((var_t) CREF(new1128_1214))->loc) = ((obj_t) loc_675), BUNSPEC);
					    ((((var_t) CREF(new1128_1214))->type) = ((type_t) type_1212), BUNSPEC);
					    ((((var_t) CREF(new1128_1214))->variable) = ((variable_t) variable_1213), BUNSPEC);
					    res1639_1221 = new1128_1214;
					 }
				      }
				      arg1303_677 = res1639_1221;
				   }
				   {
				      obj_t res1640_1224;
				      {
					 node_t val1163_1223;
					 val1163_1223 = (node_t) (arg1303_677);
					 {
					    obj_t x_1297;
					    x_1297 = ((((app_ly_162_t) CREF(node_645))->fun) = ((node_t) val1163_1223), BUNSPEC);
					    res1640_1224 = BUNSPEC;
					 }
				      }
				      res1640_1224;
				   }
				}
				{
				   var_t arg1305_678;
				   {
				      var_t res1641_1235;
				      {
					 type_t type_1226;
					 variable_t variable_1227;
					 type_1226 = (type_t) (__obj__252_type_cache);
					 variable_1227 = (variable_t) (val_673);
					 {
					    var_t new1128_1228;
					    new1128_1228 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
					    {
					       long arg1589_1229;
					       arg1589_1229 = class_num_218___object(var_ast_node);
					       {
						  obj_t obj_1233;
						  obj_1233 = (obj_t) (new1128_1228);
						  (((obj_t) CREF(obj_1233))->header = MAKE_HEADER(arg1589_1229, 0), BUNSPEC);
					       }
					    }
					    {
					       object_t aux_1505;
					       aux_1505 = (object_t) (new1128_1228);
					       OBJECT_WIDENING_SET(aux_1505, BFALSE);
					    }
					    ((((var_t) CREF(new1128_1228))->loc) = ((obj_t) loc_675), BUNSPEC);
					    ((((var_t) CREF(new1128_1228))->type) = ((type_t) type_1226), BUNSPEC);
					    ((((var_t) CREF(new1128_1228))->variable) = ((variable_t) variable_1227), BUNSPEC);
					    res1641_1235 = new1128_1228;
					 }
				      }
				      arg1305_678 = res1641_1235;
				   }
				   {
				      obj_t res1642_1238;
				      {
					 node_t val1164_1237;
					 val1164_1237 = (node_t) (arg1305_678);
					 {
					    obj_t x_1298;
					    x_1298 = ((((app_ly_162_t) CREF(node_645))->arg) = ((node_t) val1164_1237), BUNSPEC);
					    res1642_1238 = BUNSPEC;
					 }
				      }
				      res1642_1238;
				   }
				}
				return (obj_t) (lnode_676);
			     }
			  }
		       }
		    }
		 }
	      }
	 }
      }
   }
}


node_t 
make_error_node_135_coerce_apply(obj_t error_msg_180_13, obj_t loc_14, obj_t to_15)
{
   {
      obj_t ut_759;
      ut_759 = __unsafe_type__146_engine_param;
      __unsafe_type__146_engine_param = BTRUE;
      {
	 node_t node_760;
	 {
	    node_t arg1416_761;
	    {
	       obj_t arg1417_762;
	       {
		  bool_t test1418_763;
		  {
		     bool_t test1539_840;
		     {
			long n1_1254;
			n1_1254 = (long) CINT(__compiler_debug__134_engine_param);
			test1539_840 = (n1_1254 > ((long) 0));
		     }
		     if (test1539_840)
		       {
			  if (STRUCTP(loc_14))
			    {
			       obj_t aux_1522;
			       obj_t aux_1520;
			       aux_1522 = CNST_TABLE_REF(((long) 10));
			       aux_1520 = STRUCT_KEY(loc_14);
			       test1418_763 = (aux_1520 == aux_1522);
			    }
			  else
			    {
			       test1418_763 = ((bool_t) 0);
			    }
		       }
		     else
		       {
			  test1418_763 = ((bool_t) 0);
		       }
		  }
		  if (test1418_763)
		    {
		       obj_t arg1420_764;
		       obj_t arg1421_765;
		       obj_t arg1424_766;
		       arg1420_764 = CNST_TABLE_REF(((long) 11));
		       {
			  obj_t arg1440_772;
			  obj_t arg1441_773;
			  obj_t arg1445_775;
			  obj_t arg1446_776;
			  {
			     obj_t arg1458_785;
			     obj_t arg1461_786;
			     obj_t arg1463_787;
			     arg1458_785 = CNST_TABLE_REF(((long) 12));
			     arg1461_786 = CNST_TABLE_REF(((long) 13));
			     arg1463_787 = CNST_TABLE_REF(((long) 14));
			     {
				obj_t list1466_789;
				{
				   obj_t arg1467_790;
				   {
				      obj_t arg1468_791;
				      arg1468_791 = MAKE_PAIR(BNIL, BNIL);
				      arg1467_790 = MAKE_PAIR(arg1463_787, arg1468_791);
				   }
				   list1466_789 = MAKE_PAIR(arg1461_786, arg1467_790);
				}
				arg1440_772 = cons__138___r4_pairs_and_lists_6_3(arg1458_785, list1466_789);
			     }
			  }
			  {
			     obj_t arg1471_793;
			     obj_t arg1472_794;
			     arg1471_793 = CNST_TABLE_REF(((long) 1));
			     arg1472_794 = current_function_76_tools_error();
			     {
				obj_t list1473_795;
				{
				   obj_t arg1474_796;
				   arg1474_796 = MAKE_PAIR(arg1472_794, BNIL);
				   list1473_795 = MAKE_PAIR(arg1471_793, arg1474_796);
				}
				arg1441_773 = list1473_795;
			     }
			  }
			  arg1445_775 = location_full_fname_231_tools_location(loc_14);
			  arg1446_776 = STRUCT_REF(loc_14, ((long) 1));
			  {
			     obj_t list1448_778;
			     {
				obj_t arg1449_779;
				{
				   obj_t arg1450_780;
				   {
				      obj_t arg1452_781;
				      {
					 obj_t arg1453_782;
					 {
					    obj_t arg1454_783;
					    arg1454_783 = MAKE_PAIR(BNIL, BNIL);
					    arg1453_782 = MAKE_PAIR(arg1446_776, arg1454_783);
					 }
					 arg1452_781 = MAKE_PAIR(arg1445_775, arg1453_782);
				      }
				      arg1450_780 = MAKE_PAIR(error_msg_180_13, arg1452_781);
				   }
				   arg1449_779 = MAKE_PAIR(string1648_coerce_apply, arg1450_780);
				}
				list1448_778 = MAKE_PAIR(arg1441_773, arg1449_779);
			     }
			     arg1421_765 = cons__138___r4_pairs_and_lists_6_3(arg1440_772, list1448_778);
			  }
		       }
		       {
			  obj_t arg1477_798;
			  obj_t arg1478_799;
			  obj_t arg1480_800;
			  obj_t arg1481_801;
			  arg1477_798 = CNST_TABLE_REF(((long) 15));
			  {
			     obj_t arg1493_808;
			     obj_t arg1494_809;
			     arg1493_808 = CNST_TABLE_REF(((long) 1));
			     arg1494_809 = CNST_TABLE_REF(((long) 16));
			     {
				obj_t list1497_811;
				{
				   obj_t arg1498_812;
				   arg1498_812 = MAKE_PAIR(BNIL, BNIL);
				   list1497_811 = MAKE_PAIR(arg1494_809, arg1498_812);
				}
				arg1478_799 = cons__138___r4_pairs_and_lists_6_3(arg1493_808, list1497_811);
			     }
			  }
			  {
			     obj_t arg1500_814;
			     obj_t arg1501_815;
			     arg1500_814 = CNST_TABLE_REF(((long) 1));
			     arg1501_815 = CNST_TABLE_REF(((long) 16));
			     {
				obj_t list1506_817;
				{
				   obj_t arg1507_818;
				   arg1507_818 = MAKE_PAIR(BNIL, BNIL);
				   list1506_817 = MAKE_PAIR(arg1501_815, arg1507_818);
				}
				arg1480_800 = cons__138___r4_pairs_and_lists_6_3(arg1500_814, list1506_817);
			     }
			  }
			  {
			     obj_t arg1510_820;
			     obj_t arg1511_821;
			     arg1510_820 = CNST_TABLE_REF(((long) 1));
			     arg1511_821 = CNST_TABLE_REF(((long) 16));
			     {
				obj_t list1514_823;
				{
				   obj_t arg1517_824;
				   arg1517_824 = MAKE_PAIR(BNIL, BNIL);
				   list1514_823 = MAKE_PAIR(arg1511_821, arg1517_824);
				}
				arg1481_801 = cons__138___r4_pairs_and_lists_6_3(arg1510_820, list1514_823);
			     }
			  }
			  {
			     obj_t list1485_803;
			     {
				obj_t arg1486_804;
				{
				   obj_t arg1487_805;
				   {
				      obj_t arg1489_806;
				      arg1489_806 = MAKE_PAIR(BNIL, BNIL);
				      arg1487_805 = MAKE_PAIR(arg1481_801, arg1489_806);
				   }
				   arg1486_804 = MAKE_PAIR(arg1480_800, arg1487_805);
				}
				list1485_803 = MAKE_PAIR(arg1478_799, arg1486_804);
			     }
			     arg1424_766 = cons__138___r4_pairs_and_lists_6_3(arg1477_798, list1485_803);
			  }
		       }
		       {
			  obj_t list1427_768;
			  {
			     obj_t arg1428_769;
			     {
				obj_t arg1431_770;
				arg1431_770 = MAKE_PAIR(BNIL, BNIL);
				arg1428_769 = MAKE_PAIR(arg1424_766, arg1431_770);
			     }
			     list1427_768 = MAKE_PAIR(arg1421_765, arg1428_769);
			  }
			  arg1417_762 = cons__138___r4_pairs_and_lists_6_3(arg1420_764, list1427_768);
		       }
		    }
		  else
		    {
		       obj_t arg1520_826;
		       obj_t arg1522_827;
		       arg1520_826 = CNST_TABLE_REF(((long) 15));
		       {
			  obj_t arg1534_835;
			  obj_t arg1535_836;
			  arg1534_835 = CNST_TABLE_REF(((long) 1));
			  arg1535_836 = current_function_76_tools_error();
			  {
			     obj_t list1536_837;
			     {
				obj_t arg1537_838;
				arg1537_838 = MAKE_PAIR(arg1535_836, BNIL);
				list1536_837 = MAKE_PAIR(arg1534_835, arg1537_838);
			     }
			     arg1522_827 = list1536_837;
			  }
		       }
		       {
			  obj_t list1525_830;
			  {
			     obj_t arg1526_831;
			     {
				obj_t arg1529_832;
				{
				   obj_t arg1531_833;
				   arg1531_833 = MAKE_PAIR(BNIL, BNIL);
				   arg1529_832 = MAKE_PAIR(error_msg_180_13, arg1531_833);
				}
				arg1526_831 = MAKE_PAIR(string1648_coerce_apply, arg1529_832);
			     }
			     list1525_830 = MAKE_PAIR(arg1522_827, arg1526_831);
			  }
			  arg1417_762 = cons__138___r4_pairs_and_lists_6_3(arg1520_826, list1525_830);
		       }
		    }
	       }
	       arg1416_761 = top_level_sexp__node_204_ast_sexp(arg1417_762, loc_14);
	    }
	    node_760 = coerce__182_coerce_coerce(arg1416_761, (type_t) (to_15));
	 }
	 __unsafe_type__146_engine_param = ut_759;
	 return node_760;
      }
   }
}


obj_t 
imported_modules_init_94_coerce_apply()
{
   module_initialization_70_tools_trace(((long) 0), "COERCE_APPLY");
   module_initialization_70_engine_param(((long) 0), "COERCE_APPLY");
   module_initialization_70_tools_shape(((long) 0), "COERCE_APPLY");
   module_initialization_70_tools_location(((long) 0), "COERCE_APPLY");
   module_initialization_70_tools_error(((long) 0), "COERCE_APPLY");
   module_initialization_70_type_type(((long) 0), "COERCE_APPLY");
   module_initialization_70_type_cache(((long) 0), "COERCE_APPLY");
   module_initialization_70_ast_var(((long) 0), "COERCE_APPLY");
   module_initialization_70_ast_node(((long) 0), "COERCE_APPLY");
   module_initialization_70_ast_sexp(((long) 0), "COERCE_APPLY");
   module_initialization_70_ast_local(((long) 0), "COERCE_APPLY");
   module_initialization_70_coerce_coerce(((long) 0), "COERCE_APPLY");
   return module_initialization_70_coerce_convert(((long) 0), "COERCE_APPLY");
}
