/*===========================================================================*/
/*   (Coerce/coerce.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


static node_t coerce__default1296_64_coerce_coerce(node_t, type_t);
extern obj_t let_fun_218_ast_node;
extern obj_t dec_ppmarge__31_coerce_pproto();
extern obj_t _coerce__156_coerce_coerce(obj_t, obj_t, obj_t);
extern node_t coerce__182_coerce_coerce(node_t, type_t);
static obj_t _coerce__default1296_215_coerce_coerce(obj_t, obj_t, obj_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t inc_ppmarge__59_coerce_pproto();
extern obj_t closure_ast_node;
extern obj_t __classes__134___object;
extern obj_t __magic__144_type_cache;
static obj_t imported_modules_init_94_coerce_coerce();
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_coercion(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_coerce_pproto(long, char *);
extern obj_t module_initialization_70_coerce_convert(long, char *);
extern obj_t module_initialization_70_coerce_app(long, char *);
extern obj_t module_initialization_70_coerce_apply(long, char *);
extern obj_t module_initialization_70_coerce_funcall(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_coerce_coerce();
static obj_t cnst_init_137_coerce_coerce();
extern node_t convert__122_coerce_convert(node_t, type_t, type_t);
extern obj_t runtime_type_error_216_coerce_convert(obj_t, obj_t, obj_t);
static obj_t require_initialization_114_coerce_coerce = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t __bool__149_type_cache;
static obj_t library_modules_init_112_coerce_coerce();
extern obj_t cast_ast_node;
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern obj_t __unspec__87_type_cache;
extern obj_t pvariable_proto_90_coerce_pproto(long, variable_t);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t __exit__255_type_cache;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t pfunction_proto_197_coerce_pproto(long, variable_t);
extern obj_t set_ex_it_116_ast_node;
extern type_t typeof_coerce_typeof(node_t);
extern obj_t kwote_ast_node;
extern obj_t box_ref_242_ast_node;
extern bool_t coercer_exists__27_type_coercion(type_t, type_t);
extern obj_t __obj__252_type_cache;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
static obj_t __cnst[1];

DEFINE_STRING(string1609_coerce_coerce, string1609_coerce_coerce1618, "No method for this object", 25);
DEFINE_STRING(string1611_coerce_coerce, string1611_coerce_coerce1619, "Unexepected `closure' node", 26);
DEFINE_STRING(string1610_coerce_coerce, string1610_coerce_coerce1620, "coerce!", 7);
DEFINE_EXPORT_GENERIC(coerce__env_127_coerce_coerce, _coerce__156_coerce_coerce1621, _coerce__156_coerce_coerce, 0L, 2);
DEFINE_STRING(string1612_coerce_coerce, string1612_coerce_coerce1622, "COERCE!-DEFAULT1296 ", 20);
DEFINE_STATIC_PROCEDURE(coerce__default1296_env_41_coerce_coerce, _coerce__default1296_215_coerce_coerce1623, _coerce__default1296_215_coerce_coerce, 0L, 2);

obj_t 
module_initialization_70_coerce_coerce(long checksum_1360, char *from_1361)
{
   if (CBOOL(require_initialization_114_coerce_coerce))
     {
	require_initialization_114_coerce_coerce = BBOOL(((bool_t) 0));
	library_modules_init_112_coerce_coerce();
	cnst_init_137_coerce_coerce();
	imported_modules_init_94_coerce_coerce();
	toplevel_init_63_coerce_coerce();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_coerce_coerce()
{
   module_initialization_70___object(((long) 0), "COERCE_COERCE");
   module_initialization_70___reader(((long) 0), "COERCE_COERCE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_coerce_coerce()
{
   {
      obj_t cnst_port_138_1352;
      cnst_port_138_1352 = open_input_string(string1612_coerce_coerce);
      {
	 long i_1353;
	 i_1353 = ((long) 0);
       loop_1354:
	 {
	    bool_t test1613_1355;
	    test1613_1355 = (i_1353 == ((long) -1));
	    if (test1613_1355)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1614_1356;
		    {
		       obj_t list1615_1357;
		       {
			  obj_t arg1616_1358;
			  arg1616_1358 = BNIL;
			  list1615_1357 = MAKE_PAIR(cnst_port_138_1352, arg1616_1358);
		       }
		       arg1614_1356 = read___reader(list1615_1357);
		    }
		    CNST_TABLE_SET(i_1353, arg1614_1356);
		 }
		 {
		    int aux_1359;
		    {
		       long aux_1377;
		       aux_1377 = (i_1353 - ((long) 1));
		       aux_1359 = (int) (aux_1377);
		    }
		    {
		       long i_1380;
		       i_1380 = (long) (aux_1359);
		       i_1353 = i_1380;
		       goto loop_1354;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_coerce_coerce()
{
   add_generic__110___object(coerce__env_127_coerce_coerce, coerce__default1296_env_41_coerce_coerce);
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, var_ast_node, ((long) 2));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, pragma_ast_node, ((long) 5));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, cast_ast_node, ((long) 6));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, setq_ast_node, ((long) 7));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, conditional_ast_node, ((long) 8));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, fail_ast_node, ((long) 9));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, select_ast_node, ((long) 10));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, let_fun_218_ast_node, ((long) 11));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, let_var_6_ast_node, ((long) 12));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, set_ex_it_116_ast_node, ((long) 13));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, jump_ex_it_184_ast_node, ((long) 14));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, make_box_202_ast_node, ((long) 15));
   add_inlined_method__244___object(coerce__env_127_coerce_coerce, box_ref_242_ast_node, ((long) 16));
   {
      long aux_1400;
      aux_1400 = add_inlined_method__244___object(coerce__env_127_coerce_coerce, box_set__221_ast_node, ((long) 17));
      return BINT(aux_1400);
   }
}


node_t 
coerce__default1296_64_coerce_coerce(node_t node_3, type_t to_4)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1609_coerce_coerce, (obj_t) (node_3));
}


obj_t 
_coerce__default1296_215_coerce_coerce(obj_t env_1330, obj_t node_1331, obj_t to_1332)
{
   {
      node_t aux_1406;
      aux_1406 = coerce__default1296_64_coerce_coerce((node_t) (node_1331), (type_t) (to_1332));
      return (obj_t) (aux_1406);
   }
}


node_t 
coerce__182_coerce_coerce(node_t node_1, type_t to_2)
{
   {
      obj_t method1441_986;
      obj_t class1446_987;
      {
	 obj_t arg1449_984;
	 obj_t arg1450_985;
	 {
	    object_t obj_1169;
	    obj_1169 = (object_t) (node_1);
	    {
	       obj_t pre_method_105_1170;
	       pre_method_105_1170 = PROCEDURE_REF(coerce__env_127_coerce_coerce, ((long) 2));
	       if (INTEGERP(pre_method_105_1170))
		 {
		    PROCEDURE_SET(coerce__env_127_coerce_coerce, ((long) 2), BUNSPEC);
		    arg1449_984 = pre_method_105_1170;
		 }
	       else
		 {
		    long obj_class_num_177_1175;
		    obj_class_num_177_1175 = TYPE(obj_1169);
		    {
		       obj_t arg1183_1176;
		       arg1183_1176 = PROCEDURE_REF(coerce__env_127_coerce_coerce, ((long) 1));
		       {
			  long arg1184_1180;
			  {
			     long arg1186_1181;
			     arg1186_1181 = OBJECT_TYPE;
			     arg1184_1180 = (obj_class_num_177_1175 - arg1186_1181);
			  }
			  arg1449_984 = VECTOR_REF(arg1183_1176, arg1184_1180);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1186;
	    object_1186 = (object_t) (node_1);
	    {
	       long arg1187_1187;
	       {
		  long arg1188_1188;
		  long arg1189_1189;
		  arg1188_1188 = TYPE(object_1186);
		  arg1189_1189 = OBJECT_TYPE;
		  arg1187_1187 = (arg1188_1188 - arg1189_1189);
	       }
	       {
		  obj_t vector_1193;
		  vector_1193 = __classes__134___object;
		  arg1450_985 = VECTOR_REF(vector_1193, arg1187_1187);
	       }
	    }
	 }
	 {
	    obj_t aux_1426;
	    method1441_986 = arg1449_984;
	    class1446_987 = arg1450_985;
	    {
	       if (INTEGERP(method1441_986))
		 {
		    switch ((long) CINT(method1441_986))
		      {
		      case ((long) 0):
			 {
			    atom_t node_993;
			    node_993 = (atom_t) (node_1);
			    {
			       type_t arg1453_995;
			       arg1453_995 = typeof_coerce_typeof((node_t) (node_993));
			       {
				  node_t aux_1432;
				  aux_1432 = convert__122_coerce_convert((node_t) (node_993), arg1453_995, to_2);
				  aux_1426 = (obj_t) (aux_1432);
			       }
			    }
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t node_996;
			    node_996 = (kwote_t) (node_1);
			    {
			       type_t arg1454_998;
			       arg1454_998 = typeof_coerce_typeof((node_t) (node_996));
			       {
				  node_t aux_1439;
				  aux_1439 = convert__122_coerce_convert((node_t) (node_996), arg1454_998, to_2);
				  aux_1426 = (obj_t) (aux_1439);
			       }
			    }
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t node_999;
			    node_999 = (var_t) (node_1);
			    {
			       type_t type_1002;
			       type_1002 = typeof_coerce_typeof((node_t) (node_999));
			       {
				  node_t aux_1446;
				  aux_1446 = convert__122_coerce_convert((node_t) (node_999), type_1002, to_2);
				  aux_1426 = (obj_t) (aux_1446);
			       }
			    }
			 }
			 break;
		      case ((long) 3):
			 {
			    obj_t arg1461_1007;
			    {
			       obj_t aux_1450;
			       {
				  closure_t aux_1451;
				  aux_1451 = (closure_t) (node_1);
				  aux_1450 = (obj_t) (aux_1451);
			       }
			       arg1461_1007 = shape_tools_shape(aux_1450);
			    }
			    aux_1426 = internal_error_43_tools_error(string1610_coerce_coerce, string1611_coerce_coerce, arg1461_1007);
			 }
			 break;
		      case ((long) 4):
			 {
			    sequence_t node_1008;
			    node_1008 = (sequence_t) (node_1);
			    {
			       obj_t hook_1011;
			       {
				  sequence_t aux_1457;
				  hook_1011 = (((sequence_t) CREF(node_1008))->nodes);
				loop_1012:
				  {
				     bool_t test_1458;
				     {
					obj_t aux_1459;
					aux_1459 = CDR(hook_1011);
					test_1458 = NULLP(aux_1459);
				     }
				     if (test_1458)
				       {
					  {
					     node_t arg1465_1015;
					     {
						node_t aux_1462;
						{
						   obj_t aux_1463;
						   aux_1463 = CAR(hook_1011);
						   aux_1462 = (node_t) (aux_1463);
						}
						arg1465_1015 = coerce__182_coerce_coerce(aux_1462, to_2);
					     }
					     {
						obj_t aux_1467;
						aux_1467 = (obj_t) (arg1465_1015);
						SET_CAR(hook_1011, aux_1467);
					     }
					  }
					  aux_1457 = node_1008;
				       }
				     else
				       {
					  {
					     node_t arg1467_1017;
					     {
						obj_t arg1468_1018;
						type_t arg1470_1019;
						arg1468_1018 = CAR(hook_1011);
						{
						   node_t aux_1471;
						   {
						      obj_t aux_1472;
						      aux_1472 = CAR(hook_1011);
						      aux_1471 = (node_t) (aux_1472);
						   }
						   arg1470_1019 = typeof_coerce_typeof(aux_1471);
						}
						arg1467_1017 = coerce__182_coerce_coerce((node_t) (arg1468_1018), arg1470_1019);
					     }
					     {
						obj_t aux_1478;
						aux_1478 = (obj_t) (arg1467_1017);
						SET_CAR(hook_1011, aux_1478);
					     }
					  }
					  {
					     obj_t hook_1481;
					     hook_1481 = CDR(hook_1011);
					     hook_1011 = hook_1481;
					     goto loop_1012;
					  }
				       }
				  }
				  aux_1426 = (obj_t) (aux_1457);
			       }
			    }
			 }
			 break;
		      case ((long) 5):
			 {
			    pragma_t node_1023;
			    node_1023 = (pragma_t) (node_1);
			    {
			       obj_t values_1026;
			       {
				  node_t aux_1486;
				  values_1026 = (((pragma_t) CREF(node_1023))->args);
				loop_1027:
				  if (NULLP(values_1026))
				    {
				       type_t arg1478_1030;
				       arg1478_1030 = typeof_coerce_typeof((node_t) (node_1023));
				       aux_1486 = convert__122_coerce_convert((node_t) (node_1023), arg1478_1030, to_2);
				    }
				  else
				    {
				       {
					  node_t arg1480_1031;
					  {
					     obj_t arg1481_1032;
					     type_t arg1484_1033;
					     arg1481_1032 = CAR(values_1026);
					     {
						node_t aux_1494;
						{
						   obj_t aux_1495;
						   aux_1495 = CAR(values_1026);
						   aux_1494 = (node_t) (aux_1495);
						}
						arg1484_1033 = typeof_coerce_typeof(aux_1494);
					     }
					     arg1480_1031 = coerce__182_coerce_coerce((node_t) (arg1481_1032), arg1484_1033);
					  }
					  {
					     obj_t aux_1501;
					     aux_1501 = (obj_t) (arg1480_1031);
					     SET_CAR(values_1026, aux_1501);
					  }
				       }
				       {
					  obj_t values_1504;
					  values_1504 = CDR(values_1026);
					  values_1026 = values_1504;
					  goto loop_1027;
				       }
				    }
				  aux_1426 = (obj_t) (aux_1486);
			       }
			    }
			 }
			 break;
		      case ((long) 6):
			 {
			    cast_t node_1036;
			    node_1036 = (cast_t) (node_1);
			    {
			       node_t arg1487_1039;
			       {
				  node_t arg1489_1040;
				  type_t arg1490_1041;
				  arg1489_1040 = (((cast_t) CREF(node_1036))->arg);
				  arg1490_1041 = typeof_coerce_typeof((((cast_t) CREF(node_1036))->arg));
				  arg1487_1039 = coerce__182_coerce_coerce(arg1489_1040, arg1490_1041);
			       }
			       {
				  obj_t res1589_1217;
				  {
				     obj_t x_1333;
				     x_1333 = ((((cast_t) CREF(node_1036))->arg) = ((node_t) arg1487_1039), BUNSPEC);
				     res1589_1217 = BUNSPEC;
				  }
				  res1589_1217;
			       }
			    }
			    {
			       node_t aux_1514;
			       aux_1514 = convert__122_coerce_convert((node_t) (node_1036), (((cast_t) CREF(node_1036))->type), to_2);
			       aux_1426 = (obj_t) (aux_1514);
			    }
			 }
			 break;
		      case ((long) 7):
			 {
			    setq_t node_1044;
			    node_1044 = (setq_t) (node_1);
			    {
			       node_t arg1496_1047;
			       {
				  type_t aux_1520;
				  {
				     variable_t arg1499_1050;
				     {
					var_t arg1500_1051;
					arg1500_1051 = (((setq_t) CREF(node_1044))->var);
					arg1499_1050 = (((var_t) CREF(arg1500_1051))->variable);
				     }
				     aux_1520 = (((variable_t) CREF(arg1499_1050))->type);
				  }
				  arg1496_1047 = coerce__182_coerce_coerce((((setq_t) CREF(node_1044))->value), aux_1520);
			       }
			       {
				  obj_t res1590_1225;
				  {
				     obj_t x_1334;
				     x_1334 = ((((setq_t) CREF(node_1044))->value) = ((node_t) arg1496_1047), BUNSPEC);
				     res1590_1225 = BUNSPEC;
				  }
				  res1590_1225;
			       }
			    }
			    {
			       node_t aux_1527;
			       aux_1527 = convert__122_coerce_convert((node_t) (node_1044), (type_t) (__unspec__87_type_cache), to_2);
			       aux_1426 = (obj_t) (aux_1527);
			    }
			 }
			 break;
		      case ((long) 8):
			 {
			    conditional_t node_1052;
			    node_1052 = (conditional_t) (node_1);
			    {
			       node_t arg1501_1055;
			       arg1501_1055 = coerce__182_coerce_coerce((((conditional_t) CREF(node_1052))->test), (type_t) (__bool__149_type_cache));
			       {
				  obj_t res1591_1229;
				  {
				     obj_t x_1335;
				     x_1335 = ((((conditional_t) CREF(node_1052))->test) = ((node_t) arg1501_1055), BUNSPEC);
				     res1591_1229 = BUNSPEC;
				  }
				  res1591_1229;
			       }
			    }
			    {
			       node_t arg1506_1057;
			       arg1506_1057 = coerce__182_coerce_coerce((((conditional_t) CREF(node_1052))->true), to_2);
			       {
				  obj_t res1592_1233;
				  {
				     obj_t x_1336;
				     x_1336 = ((((conditional_t) CREF(node_1052))->true) = ((node_t) arg1506_1057), BUNSPEC);
				     res1592_1233 = BUNSPEC;
				  }
				  res1592_1233;
			       }
			    }
			    {
			       node_t arg1509_1059;
			       arg1509_1059 = coerce__182_coerce_coerce((((conditional_t) CREF(node_1052))->false), to_2);
			       {
				  obj_t res1593_1237;
				  {
				     obj_t x_1337;
				     x_1337 = ((((conditional_t) CREF(node_1052))->false) = ((node_t) arg1509_1059), BUNSPEC);
				     res1593_1237 = BUNSPEC;
				  }
				  res1593_1237;
			       }
			    }
			    aux_1426 = (obj_t) (node_1052);
			 }
			 break;
		      case ((long) 9):
			 {
			    fail_t node_1061;
			    node_1061 = (fail_t) (node_1);
			    {
			       node_t arg1511_1064;
			       arg1511_1064 = coerce__182_coerce_coerce((((fail_t) CREF(node_1061))->proc), (type_t) (__obj__252_type_cache));
			       {
				  obj_t res1594_1241;
				  {
				     obj_t x_1338;
				     x_1338 = ((((fail_t) CREF(node_1061))->proc) = ((node_t) arg1511_1064), BUNSPEC);
				     res1594_1241 = BUNSPEC;
				  }
				  res1594_1241;
			       }
			    }
			    {
			       node_t arg1514_1066;
			       arg1514_1066 = coerce__182_coerce_coerce((((fail_t) CREF(node_1061))->msg), (type_t) (__obj__252_type_cache));
			       {
				  obj_t res1595_1245;
				  {
				     obj_t x_1339;
				     x_1339 = ((((fail_t) CREF(node_1061))->msg) = ((node_t) arg1514_1066), BUNSPEC);
				     res1595_1245 = BUNSPEC;
				  }
				  res1595_1245;
			       }
			    }
			    {
			       node_t arg1518_1068;
			       arg1518_1068 = coerce__182_coerce_coerce((((fail_t) CREF(node_1061))->obj), (type_t) (__obj__252_type_cache));
			       {
				  obj_t res1596_1249;
				  {
				     obj_t x_1340;
				     x_1340 = ((((fail_t) CREF(node_1061))->obj) = ((node_t) arg1518_1068), BUNSPEC);
				     res1596_1249 = BUNSPEC;
				  }
				  res1596_1249;
			       }
			    }
			    {
			       node_t aux_1557;
			       aux_1557 = convert__122_coerce_convert((node_t) (node_1061), (type_t) (__magic__144_type_cache), to_2);
			       aux_1426 = (obj_t) (aux_1557);
			    }
			 }
			 break;
		      case ((long) 10):
			 {
			    select_t node_1070;
			    node_1070 = (select_t) (node_1);
			    {
			       obj_t clauses_1073;
			       type_t test_type_84_1074;
			       type_t test_node_type_36_1075;
			       clauses_1073 = (((select_t) CREF(node_1070))->clauses);
			       test_type_84_1074 = (((select_t) CREF(node_1070))->item_type_130);
			       test_node_type_36_1075 = typeof_coerce_typeof((((select_t) CREF(node_1070))->test));
			       {
				  bool_t test1521_1076;
				  test1521_1076 = coercer_exists__27_type_coercion(test_node_type_36_1075, test_type_84_1074);
				  if (test1521_1076)
				    {
				       {
					  node_t arg1522_1077;
					  arg1522_1077 = coerce__182_coerce_coerce((((select_t) CREF(node_1070))->test), test_type_84_1074);
					  {
					     obj_t res1597_1256;
					     {
						obj_t x_1341;
						x_1341 = ((((select_t) CREF(node_1070))->test) = ((node_t) arg1522_1077), BUNSPEC);
						res1597_1256 = BUNSPEC;
					     }
					     res1597_1256;
					  }
				       }
				       {
					  obj_t l1280_1079;
					  l1280_1079 = clauses_1073;
					lname1283_1080:
					  if (PAIRP(l1280_1079))
					    {
					       {
						  obj_t clause_1082;
						  clause_1082 = CAR(l1280_1079);
						  {
						     node_t arg1526_1083;
						     {
							node_t aux_1575;
							{
							   obj_t aux_1576;
							   aux_1576 = CDR(clause_1082);
							   aux_1575 = (node_t) (aux_1576);
							}
							arg1526_1083 = coerce__182_coerce_coerce(aux_1575, to_2);
						     }
						     {
							obj_t aux_1580;
							aux_1580 = (obj_t) (arg1526_1083);
							SET_CDR(clause_1082, aux_1580);
						     }
						  }
					       }
					       {
						  obj_t l1280_1583;
						  l1280_1583 = CDR(l1280_1079);
						  l1280_1079 = l1280_1583;
						  goto lname1283_1080;
					       }
					    }
					  else
					    {
					       ((bool_t) 1);
					    }
				       }
				       aux_1426 = (obj_t) (node_1070);
				    }
				  else
				    {
				       obj_t arg1532_1086;
				       {
					  obj_t aux_1586;
					  {
					     node_t aux_1589;
					     aux_1589 = (((select_t) CREF(node_1070))->test);
					     aux_1586 = (obj_t) (aux_1589);
					  }
					  arg1532_1086 = runtime_type_error_216_coerce_convert((((select_t) CREF(node_1070))->loc), (((type_t) CREF(test_type_84_1074))->id), aux_1586);
				       }
				       {
					  node_t aux_1593;
					  aux_1593 = coerce__182_coerce_coerce((node_t) (arg1532_1086), to_2);
					  aux_1426 = (obj_t) (aux_1593);
				       }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 11):
			 {
			    let_fun_218_t node_1091;
			    node_1091 = (let_fun_218_t) (node_1);
			    inc_ppmarge__59_coerce_pproto();
			    {
			       obj_t l1285_1094;
			       l1285_1094 = (((let_fun_218_t) CREF(node_1091))->locals);
			     lname1287_1095:
			       if (PAIRP(l1285_1094))
				 {
				    {
				       obj_t local_1098;
				       local_1098 = CAR(l1285_1094);
				       {
					  value_t fun_1099;
					  {
					     local_t obj_1269;
					     obj_1269 = (local_t) (local_1098);
					     fun_1099 = (((local_t) CREF(obj_1269))->value);
					  }
					  pfunction_proto_197_coerce_pproto(((long) 3), (variable_t) (local_1098));
					  {
					     node_t arg1540_1100;
					     {
						type_t aux_1611;
						node_t aux_1606;
						{
						   local_t obj_1271;
						   obj_1271 = (local_t) (local_1098);
						   aux_1611 = (((local_t) CREF(obj_1271))->type);
						}
						{
						   obj_t aux_1607;
						   {
						      sfun_t obj_1270;
						      obj_1270 = (sfun_t) (fun_1099);
						      aux_1607 = (((sfun_t) CREF(obj_1270))->body);
						   }
						   aux_1606 = (node_t) (aux_1607);
						}
						arg1540_1100 = coerce__182_coerce_coerce(aux_1606, aux_1611);
					     }
					     {
						obj_t res1598_1274;
						{
						   sfun_t obj_1272;
						   obj_t val1077_1273;
						   obj_1272 = (sfun_t) (fun_1099);
						   val1077_1273 = (obj_t) (arg1540_1100);
						   {
						      obj_t x_1342;
						      x_1342 = ((((sfun_t) CREF(obj_1272))->body) = ((obj_t) val1077_1273), BUNSPEC);
						      res1598_1274 = BUNSPEC;
						   }
						}
						res1598_1274;
					     }
					  }
				       }
				    }
				    {
				       obj_t l1285_1618;
				       l1285_1618 = CDR(l1285_1094);
				       l1285_1094 = l1285_1618;
				       goto lname1287_1095;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1547_1104;
			       arg1547_1104 = coerce__182_coerce_coerce((((let_fun_218_t) CREF(node_1091))->body), to_2);
			       {
				  obj_t res1599_1279;
				  {
				     obj_t x_1343;
				     x_1343 = ((((let_fun_218_t) CREF(node_1091))->body) = ((node_t) arg1547_1104), BUNSPEC);
				     res1599_1279 = BUNSPEC;
				  }
				  res1599_1279;
			       }
			    }
			    dec_ppmarge__31_coerce_pproto();
			    aux_1426 = (obj_t) (node_1091);
			 }
			 break;
		      case ((long) 12):
			 {
			    let_var_6_t node_1106;
			    node_1106 = (let_var_6_t) (node_1);
			    inc_ppmarge__59_coerce_pproto();
			    {
			       obj_t l1289_1109;
			       l1289_1109 = (((let_var_6_t) CREF(node_1106))->bindings);
			     lname1290_1110:
			       if (PAIRP(l1289_1109))
				 {
				    {
				       obj_t binding_1113;
				       binding_1113 = CAR(l1289_1109);
				       {
					  variable_t aux_1631;
					  {
					     obj_t aux_1632;
					     aux_1632 = CAR(binding_1113);
					     aux_1631 = (variable_t) (aux_1632);
					  }
					  pvariable_proto_90_coerce_pproto(((long) 3), aux_1631);
				       }
				       {
					  node_t arg1554_1116;
					  {
					     type_t aux_1640;
					     node_t aux_1636;
					     {
						local_t obj_1286;
						{
						   obj_t aux_1641;
						   aux_1641 = CAR(binding_1113);
						   obj_1286 = (local_t) (aux_1641);
						}
						aux_1640 = (((local_t) CREF(obj_1286))->type);
					     }
					     {
						obj_t aux_1637;
						aux_1637 = CDR(binding_1113);
						aux_1636 = (node_t) (aux_1637);
					     }
					     arg1554_1116 = coerce__182_coerce_coerce(aux_1636, aux_1640);
					  }
					  {
					     obj_t aux_1646;
					     aux_1646 = (obj_t) (arg1554_1116);
					     SET_CDR(binding_1113, aux_1646);
					  }
				       }
				    }
				    {
				       obj_t l1289_1649;
				       l1289_1649 = CDR(l1289_1109);
				       l1289_1109 = l1289_1649;
				       goto lname1290_1110;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1561_1121;
			       arg1561_1121 = coerce__182_coerce_coerce((((let_var_6_t) CREF(node_1106))->body), to_2);
			       {
				  obj_t res1600_1293;
				  {
				     obj_t x_1344;
				     x_1344 = ((((let_var_6_t) CREF(node_1106))->body) = ((node_t) arg1561_1121), BUNSPEC);
				     res1600_1293 = BUNSPEC;
				  }
				  res1600_1293;
			       }
			    }
			    dec_ppmarge__31_coerce_pproto();
			    aux_1426 = (obj_t) (node_1106);
			 }
			 break;
		      case ((long) 13):
			 {
			    set_ex_it_116_t node_1123;
			    node_1123 = (set_ex_it_116_t) (node_1);
			    {
			       node_t arg1563_1126;
			       {
				  node_t aux_1658;
				  {
				     var_t aux_1659;
				     aux_1659 = (((set_ex_it_116_t) CREF(node_1123))->var);
				     aux_1658 = (node_t) (aux_1659);
				  }
				  arg1563_1126 = coerce__182_coerce_coerce(aux_1658, (type_t) (__exit__255_type_cache));
			       }
			       {
				  obj_t res1601_1297;
				  {
				     var_t val1241_1296;
				     val1241_1296 = (var_t) (arg1563_1126);
				     {
					obj_t x_1345;
					x_1345 = ((((set_ex_it_116_t) CREF(node_1123))->var) = ((var_t) val1241_1296), BUNSPEC);
					res1601_1297 = BUNSPEC;
				     }
				  }
				  res1601_1297;
			       }
			    }
			    {
			       variable_t aux_1666;
			       {
				  var_t arg1567_1130;
				  arg1567_1130 = (((set_ex_it_116_t) CREF(node_1123))->var);
				  aux_1666 = (((var_t) CREF(arg1567_1130))->variable);
			       }
			       pvariable_proto_90_coerce_pproto(((long) 3), aux_1666);
			    }
			    {
			       node_t arg1568_1131;
			       arg1568_1131 = coerce__182_coerce_coerce((((set_ex_it_116_t) CREF(node_1123))->body), to_2);
			       {
				  obj_t res1602_1303;
				  {
				     obj_t x_1346;
				     x_1346 = ((((set_ex_it_116_t) CREF(node_1123))->body) = ((node_t) arg1568_1131), BUNSPEC);
				     res1602_1303 = BUNSPEC;
				  }
				  res1602_1303;
			       }
			    }
			    aux_1426 = (obj_t) (node_1123);
			 }
			 break;
		      case ((long) 14):
			 {
			    jump_ex_it_184_t node_1133;
			    node_1133 = (jump_ex_it_184_t) (node_1);
			    {
			       node_t arg1571_1136;
			       arg1571_1136 = coerce__182_coerce_coerce((((jump_ex_it_184_t) CREF(node_1133))->exit), (type_t) (__exit__255_type_cache));
			       {
				  obj_t res1603_1307;
				  {
				     obj_t x_1347;
				     x_1347 = ((((jump_ex_it_184_t) CREF(node_1133))->exit) = ((node_t) arg1571_1136), BUNSPEC);
				     res1603_1307 = BUNSPEC;
				  }
				  res1603_1307;
			       }
			    }
			    {
			       node_t arg1573_1138;
			       arg1573_1138 = coerce__182_coerce_coerce((((jump_ex_it_184_t) CREF(node_1133))->value), to_2);
			       {
				  obj_t res1604_1311;
				  {
				     obj_t x_1348;
				     x_1348 = ((((jump_ex_it_184_t) CREF(node_1133))->value) = ((node_t) arg1573_1138), BUNSPEC);
				     res1604_1311 = BUNSPEC;
				  }
				  res1604_1311;
			       }
			    }
			    aux_1426 = (obj_t) (node_1133);
			 }
			 break;
		      case ((long) 15):
			 {
			    make_box_202_t node_1140;
			    node_1140 = (make_box_202_t) (node_1);
			    {
			       node_t arg1575_1143;
			       arg1575_1143 = coerce__182_coerce_coerce((((make_box_202_t) CREF(node_1140))->value), (type_t) (__obj__252_type_cache));
			       {
				  obj_t res1605_1315;
				  {
				     obj_t x_1349;
				     x_1349 = ((((make_box_202_t) CREF(node_1140))->value) = ((node_t) arg1575_1143), BUNSPEC);
				     res1605_1315 = BUNSPEC;
				  }
				  res1605_1315;
			       }
			    }
			    aux_1426 = (obj_t) (node_1140);
			 }
			 break;
		      case ((long) 16):
			 {
			    node_t aux_1689;
			    {
			       node_t aux_1690;
			       {
				  box_ref_242_t aux_1691;
				  aux_1691 = (box_ref_242_t) (node_1);
				  aux_1690 = (node_t) (aux_1691);
			       }
			       aux_1689 = convert__122_coerce_convert(aux_1690, (type_t) (__obj__252_type_cache), to_2);
			    }
			    aux_1426 = (obj_t) (aux_1689);
			 }
			 break;
		      case ((long) 17):
			 {
			    box_set__221_t node_1148;
			    node_1148 = (box_set__221_t) (node_1);
			    {
			       obj_t res1606_1320;
			       {
				  local_t obj_1318;
				  type_t val1051_1319;
				  {
				     variable_t aux_1698;
				     {
					var_t arg1578_1152;
					arg1578_1152 = (((box_set__221_t) CREF(node_1148))->var);
					aux_1698 = (((var_t) CREF(arg1578_1152))->variable);
				     }
				     obj_1318 = (local_t) (aux_1698);
				  }
				  val1051_1319 = (type_t) (__obj__252_type_cache);
				  {
				     obj_t x_1350;
				     x_1350 = ((((local_t) CREF(obj_1318))->type) = ((type_t) val1051_1319), BUNSPEC);
				     res1606_1320 = BUNSPEC;
				  }
			       }
			       res1606_1320;
			    }
			    {
			       node_t arg1579_1153;
			       arg1579_1153 = coerce__182_coerce_coerce((((box_set__221_t) CREF(node_1148))->value), (type_t) (__obj__252_type_cache));
			       {
				  obj_t res1607_1324;
				  {
				     obj_t x_1351;
				     x_1351 = ((((box_set__221_t) CREF(node_1148))->value) = ((node_t) arg1579_1153), BUNSPEC);
				     res1607_1324 = BUNSPEC;
				  }
				  res1607_1324;
			       }
			    }
			    {
			       node_t aux_1708;
			       aux_1708 = convert__122_coerce_convert((node_t) (node_1148), (type_t) (__unspec__87_type_cache), to_2);
			       aux_1426 = (obj_t) (aux_1708);
			    }
			 }
			 break;
		      default:
		       case_else1447_250_990:
			 if (PROCEDUREP(method1441_986))
			   {
			      aux_1426 = PROCEDURE_ENTRY(method1441_986) (method1441_986, (obj_t) (node_1), (obj_t) (to_2), BEOA);
			   }
			 else
			   {
			      obj_t fun1320_672;
			      fun1320_672 = PROCEDURE_REF(coerce__env_127_coerce_coerce, ((long) 0));
			      aux_1426 = PROCEDURE_ENTRY(fun1320_672) (fun1320_672, (obj_t) (node_1), (obj_t) (to_2), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1447_250_990;
		 }
	    }
	    return (node_t) (aux_1426);
	 }
      }
   }
}


obj_t 
_coerce__156_coerce_coerce(obj_t env_1327, obj_t node_1328, obj_t to_1329)
{
   {
      node_t aux_1727;
      aux_1727 = coerce__182_coerce_coerce((node_t) (node_1328), (type_t) (to_1329));
      return (obj_t) (aux_1727);
   }
}


obj_t 
imported_modules_init_94_coerce_coerce()
{
   module_initialization_70_tools_trace(((long) 0), "COERCE_COERCE");
   module_initialization_70_tools_shape(((long) 0), "COERCE_COERCE");
   module_initialization_70_tools_error(((long) 0), "COERCE_COERCE");
   module_initialization_70_type_type(((long) 0), "COERCE_COERCE");
   module_initialization_70_type_cache(((long) 0), "COERCE_COERCE");
   module_initialization_70_type_coercion(((long) 0), "COERCE_COERCE");
   module_initialization_70_ast_var(((long) 0), "COERCE_COERCE");
   module_initialization_70_ast_node(((long) 0), "COERCE_COERCE");
   module_initialization_70_coerce_pproto(((long) 0), "COERCE_COERCE");
   module_initialization_70_coerce_convert(((long) 0), "COERCE_COERCE");
   module_initialization_70_coerce_app(((long) 0), "COERCE_COERCE");
   module_initialization_70_coerce_apply(((long) 0), "COERCE_COERCE");
   module_initialization_70_coerce_funcall(((long) 0), "COERCE_COERCE");
   return module_initialization_70_coerce_typeof(((long) 0), "COERCE_COERCE");
}
