/*===========================================================================*/
/*   (Coerce/convert.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;


static obj_t type_error_location_103_coerce_convert(obj_t, obj_t, type_t, type_t);
static node_t skip_let_var_187_coerce_convert(node_t);
extern obj_t lvtype_node__58_ast_lvtype(node_t);
extern type_t get_aliased_type_1_type_type(type_t);
extern node_t coerce__182_coerce_coerce(node_t, type_t);
extern bool_t type_subclass__90_object_class(type_t, type_t);
extern obj_t class_object_class;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_coerce_convert();
extern obj_t module_initialization_70_coerce_convert(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_coercion(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t toplevel_init_63_coerce_convert();
static obj_t cnst_init_137_coerce_convert();
static node_t make_one_type_conversion_101_coerce_convert(obj_t, type_t, type_t, obj_t, obj_t, obj_t);
extern node_t convert__122_coerce_convert(node_t, type_t, type_t);
extern obj_t __compiler_debug__134_engine_param;
extern obj_t runtime_type_error_216_coerce_convert(obj_t, obj_t, obj_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t __unsafe_type__146_engine_param;
extern obj_t find_coercer_15_type_coercion(type_t, type_t);
static obj_t require_initialization_114_coerce_convert = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t do_convert_128_coerce_convert(obj_t, obj_t, type_t);
static obj_t library_modules_init_112_coerce_convert();
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t cast_ast_node;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
static obj_t make_one_class_conversion_131_coerce_convert(obj_t, type_t, type_t, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern long class_num_218___object(obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t runtime_type_error_id_5_coerce_convert(obj_t, obj_t, obj_t);
extern bool_t sub_type__174_type_env(type_t, type_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _4dots_tools_misc;
extern obj_t type_error_msg_127___error(obj_t, obj_t, obj_t);
extern obj_t location_full_fname_231_tools_location(obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t node_ast_node;
extern obj_t _runtime_type_error_144_coerce_convert(obj_t, obj_t, obj_t, obj_t);
static obj_t convert_error_217_coerce_convert(type_t, type_t, obj_t, node_t);
extern obj_t __obj__252_type_cache;
extern obj_t current_function_76_tools_error();
extern obj_t user_warning_location_190_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t _convert__140_coerce_convert(obj_t, obj_t, obj_t, obj_t);
static obj_t make_one_conversion_147_coerce_convert(obj_t, type_t, type_t, obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
extern node_t top_level_sexp__node_204_ast_sexp(obj_t, obj_t);
static obj_t __cnst[16];

DEFINE_STRING(string1960_coerce_convert, string1960_coerce_convert1981, "runtime-type-error: ", 20);
DEFINE_STRING(string1963_coerce_convert, string1963_coerce_convert1982, " ", 1);
DEFINE_STRING(string1961_coerce_convert, string1961_coerce_convert1983, "   runtime-type-error/id: ", 26);
DEFINE_STRING(string1971_coerce_convert, string1971_coerce_convert1984, "do-convert: ", 12);
DEFINE_STRING(string1959_coerce_convert, string1959_coerce_convert1985, "  ", 2);
DEFINE_STRING(string1975_coerce_convert, string1975_coerce_convert1986, "AUX2 IF COERCER FAILURE FIND-RUNTIME-TYPE TYPE-ERROR-MSG QUOTE __ERROR ERROR/LOCATION @ BEGIN LOCATION ::OBJ LET AUX COERCE ", 124);
DEFINE_STRING(string1974_coerce_convert, string1974_coerce_convert1987, "Illegal converter", 17);
DEFINE_STRING(string1965_coerce_convert, string1965_coerce_convert1988, " : ", 3);
DEFINE_STRING(string1956_coerce_convert, string1956_coerce_convert1989, "", 0);
DEFINE_STRING(string1972_coerce_convert, string1972_coerce_convert1990, "   app: ", 8);
DEFINE_STRING(string1966_coerce_convert, string1966_coerce_convert1991, " -> ", 4);
DEFINE_EXPORT_PROCEDURE(convert__env_238_coerce_convert, _convert__140_coerce_convert1992, _convert__140_coerce_convert, 0L, 3);
DEFINE_STRING(string1967_coerce_convert, string1967_coerce_convert1993, "convert: ", 9);
DEFINE_STRING(string1968_coerce_convert, string1968_coerce_convert1994, "   coerces: ", 12);
DEFINE_STRING(string1964_coerce_convert, string1964_coerce_convert1995, "convert-error: ", 15);
DEFINE_STRING(string1969_coerce_convert, string1969_coerce_convert1996, "   checks : ", 12);
DEFINE_STRING(string1957_coerce_convert, string1957_coerce_convert1997, "Type error", 10);
DEFINE_STRING(string1970_coerce_convert, string1970_coerce_convert1998, "Illegal conversion", 18);
DEFINE_STRING(string1958_coerce_convert, string1958_coerce_convert1999, "   runtime-type-error/node: ", 28);
DEFINE_STRING(string1962_coerce_convert, string1962_coerce_convert2000, "Type", 4);
DEFINE_STRING(string1973_coerce_convert, string1973_coerce_convert2001, "do-convert", 10);
DEFINE_EXPORT_PROCEDURE(runtime_type_error_env_213_coerce_convert, _runtime_type_error_144_coerce_convert2002, _runtime_type_error_144_coerce_convert, 0L, 3);

obj_t 
module_initialization_70_coerce_convert(long checksum_1858, char *from_1859)
{
   if (CBOOL(require_initialization_114_coerce_convert))
     {
	require_initialization_114_coerce_convert = BBOOL(((bool_t) 0));
	library_modules_init_112_coerce_convert();
	cnst_init_137_coerce_convert();
	imported_modules_init_94_coerce_convert();
	toplevel_init_63_coerce_convert();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_coerce_convert()
{
   module_initialization_70___object(((long) 0), "COERCE_CONVERT");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "COERCE_CONVERT");
   module_initialization_70___reader(((long) 0), "COERCE_CONVERT");
   module_initialization_70___r4_symbols_6_4(((long) 0), "COERCE_CONVERT");
   module_initialization_70___error(((long) 0), "COERCE_CONVERT");
   return BUNSPEC;
}


obj_t 
cnst_init_137_coerce_convert()
{
   {
      obj_t cnst_port_138_1850;
      cnst_port_138_1850 = open_input_string(string1975_coerce_convert);
      {
	 long i_1851;
	 i_1851 = ((long) 15);
       loop_1852:
	 {
	    bool_t test1976_1853;
	    test1976_1853 = (i_1851 == ((long) -1));
	    if (test1976_1853)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1977_1854;
		    {
		       obj_t list1978_1855;
		       {
			  obj_t arg1979_1856;
			  arg1979_1856 = BNIL;
			  list1978_1855 = MAKE_PAIR(cnst_port_138_1850, arg1979_1856);
		       }
		       arg1977_1854 = read___reader(list1978_1855);
		    }
		    CNST_TABLE_SET(i_1851, arg1977_1854);
		 }
		 {
		    int aux_1857;
		    {
		       long aux_1878;
		       aux_1878 = (i_1851 - ((long) 1));
		       aux_1857 = (int) (aux_1878);
		    }
		    {
		       long i_1881;
		       i_1881 = (long) (aux_1857);
		       i_1851 = i_1881;
		       goto loop_1852;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_coerce_convert()
{
   return BUNSPEC;
}


obj_t 
type_error_location_103_coerce_convert(obj_t loc_29, obj_t function_30, type_t from_31, type_t to_32)
{
   {
      obj_t arg1333_802;
      {
	 obj_t arg1339_805;
	 obj_t arg1340_806;
	 {
	    obj_t aux_1883;
	    aux_1883 = (((type_t) CREF(to_32))->id);
	    arg1339_805 = SYMBOL_TO_STRING(aux_1883);
	 }
	 {
	    obj_t aux_1886;
	    aux_1886 = (((type_t) CREF(from_31))->id);
	    arg1340_806 = SYMBOL_TO_STRING(aux_1886);
	 }
	 arg1333_802 = type_error_msg_127___error(string1956_coerce_convert, arg1339_805, arg1340_806);
      }
      return user_error_location_137_tools_error(loc_29, function_30, string1957_coerce_convert, arg1333_802, BNIL);
   }
}


obj_t 
runtime_type_error_216_coerce_convert(obj_t loc_37, obj_t ti_38, obj_t value_39)
{
   {
      {
	 bool_t test1354_818;
	 {
	    obj_t aux_1891;
	    aux_1891 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	    test1354_818 = CBOOL(aux_1891);
	 }
	 if (test1354_818)
	   {
	      obj_t arg1356_820;
	      obj_t arg1358_822;
	      arg1356_820 = shape_tools_shape(ti_38);
	      arg1358_822 = shape_tools_shape(value_39);
	      {
		 obj_t list1359_823;
		 {
		    obj_t arg1361_824;
		    {
		       obj_t arg1363_825;
		       {
			  obj_t arg1364_826;
			  {
			     obj_t arg1366_827;
			     {
				obj_t aux_1899;
				aux_1899 = BCHAR(((unsigned char) '\n'));
				arg1366_827 = MAKE_PAIR(aux_1899, BNIL);
			     }
			     arg1364_826 = MAKE_PAIR(arg1358_822, arg1366_827);
			  }
			  arg1363_825 = MAKE_PAIR(string1959_coerce_convert, arg1364_826);
		       }
		       arg1361_824 = MAKE_PAIR(arg1356_820, arg1363_825);
		    }
		    list1359_823 = MAKE_PAIR(string1960_coerce_convert, arg1361_824);
		 }
		 print_trace_107_tools_trace(list1359_823);
	      }
	   }
	 else
	   {
	      BUNSPEC;
	   }
      }
      {
	 bool_t test1371_831;
	 test1371_831 = is_a__118___object(value_39, node_ast_node);
	 if (test1371_831)
	   {
	      node_t aux_1909;
	      {
		 bool_t test1373_833;
		 {
		    obj_t aux_1910;
		    aux_1910 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
		    test1373_833 = CBOOL(aux_1910);
		 }
		 if (test1373_833)
		   {
		      obj_t list1374_834;
		      {
			 obj_t arg1379_836;
			 {
			    obj_t aux_1916;
			    aux_1916 = BCHAR(((unsigned char) '\n'));
			    arg1379_836 = MAKE_PAIR(aux_1916, BNIL);
			 }
			 list1374_834 = MAKE_PAIR(string1958_coerce_convert, arg1379_836);
		      }
		      print_trace_107_tools_trace(list1374_834);
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	      {
		 obj_t aux_840;
		 aux_840 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 1)), BEOA);
		 {
		    node_t res_841;
		    {
		       obj_t arg1390_844;
		       {
			  obj_t arg1396_846;
			  obj_t arg1398_847;
			  obj_t arg1400_848;
			  arg1396_846 = CNST_TABLE_REF(((long) 2));
			  {
			     obj_t arg1410_854;
			     {
				obj_t arg1415_858;
				{
				   obj_t list1422_864;
				   {
				      obj_t arg1424_865;
				      {
					 obj_t aux_1925;
					 aux_1925 = CNST_TABLE_REF(((long) 3));
					 arg1424_865 = MAKE_PAIR(aux_1925, BNIL);
				      }
				      list1422_864 = MAKE_PAIR(aux_840, arg1424_865);
				   }
				   arg1415_858 = symbol_append_197___r4_symbols_6_4(list1422_864);
				}
				{
				   obj_t list1417_860;
				   {
				      obj_t arg1418_861;
				      arg1418_861 = MAKE_PAIR(BNIL, BNIL);
				      list1417_860 = MAKE_PAIR(BUNSPEC, arg1418_861);
				   }
				   arg1410_854 = cons__138___r4_pairs_and_lists_6_3(arg1415_858, list1417_860);
				}
			     }
			     {
				obj_t list1412_856;
				list1412_856 = MAKE_PAIR(BNIL, BNIL);
				arg1398_847 = cons__138___r4_pairs_and_lists_6_3(arg1410_854, list1412_856);
			     }
			  }
			  arg1400_848 = runtime_type_error_id_5_coerce_convert(ti_38, loc_37, aux_840);
			  {
			     obj_t list1403_850;
			     {
				obj_t arg1404_851;
				{
				   obj_t arg1406_852;
				   arg1406_852 = MAKE_PAIR(BNIL, BNIL);
				   arg1404_851 = MAKE_PAIR(arg1400_848, arg1406_852);
				}
				list1403_850 = MAKE_PAIR(arg1398_847, arg1404_851);
			     }
			     arg1390_844 = cons__138___r4_pairs_and_lists_6_3(arg1396_846, list1403_850);
			  }
		       }
		       res_841 = top_level_sexp__node_204_ast_sexp(arg1390_844, BNIL);
		    }
		    {
		       {
			  obj_t aux_1941;
			  {
			     obj_t aux_1942;
			     {
				let_var_6_t obj_1618;
				obj_1618 = (let_var_6_t) (res_841);
				aux_1942 = (((let_var_6_t) CREF(obj_1618))->bindings);
			     }
			     aux_1941 = CAR(aux_1942);
			  }
			  SET_CDR(aux_1941, value_39);
		       }
		       aux_1909 = res_841;
		    }
		 }
	      }
	      return (obj_t) (aux_1909);
	   }
	 else
	   {
	      return runtime_type_error_id_5_coerce_convert(ti_38, loc_37, value_39);
	   }
      }
   }
}


obj_t 
runtime_type_error_id_5_coerce_convert(obj_t ti_1839, obj_t loc_1838, obj_t id_868)
{
   {
      bool_t test1429_870;
      {
	 obj_t aux_1949;
	 aux_1949 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1429_870 = CBOOL(aux_1949);
      }
      if (test1429_870)
	{
	   obj_t arg1432_872;
	   arg1432_872 = shape_tools_shape(id_868);
	   {
	      obj_t list1433_873;
	      {
		 obj_t arg1440_874;
		 {
		    obj_t arg1441_875;
		    {
		       obj_t aux_1956;
		       aux_1956 = BCHAR(((unsigned char) '\n'));
		       arg1441_875 = MAKE_PAIR(aux_1956, BNIL);
		    }
		    arg1440_874 = MAKE_PAIR(arg1432_872, arg1441_875);
		 }
		 list1433_873 = MAKE_PAIR(string1961_coerce_convert, arg1440_874);
	      }
	      print_trace_107_tools_trace(list1433_873);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test1447_879;
      {
	 bool_t test1567_967;
	 {
	    long n1_1622;
	    n1_1622 = (long) CINT(__compiler_debug__134_engine_param);
	    test1567_967 = (n1_1622 > ((long) 0));
	 }
	 if (test1567_967)
	   {
	      if (STRUCTP(loc_1838))
		{
		   obj_t aux_1969;
		   obj_t aux_1967;
		   aux_1969 = CNST_TABLE_REF(((long) 4));
		   aux_1967 = STRUCT_KEY(loc_1838);
		   test1447_879 = (aux_1967 == aux_1969);
		}
	      else
		{
		   test1447_879 = ((bool_t) 0);
		}
	   }
	 else
	   {
	      test1447_879 = ((bool_t) 0);
	   }
      }
      if (test1447_879)
	{
	   obj_t arg1448_880;
	   obj_t arg1449_881;
	   obj_t arg1450_882;
	   arg1448_880 = CNST_TABLE_REF(((long) 5));
	   {
	      obj_t arg1461_888;
	      obj_t arg1463_889;
	      obj_t arg1465_890;
	      obj_t arg1466_891;
	      obj_t arg1467_892;
	      {
		 obj_t arg1478_901;
		 obj_t arg1480_902;
		 obj_t arg1481_903;
		 arg1478_901 = CNST_TABLE_REF(((long) 6));
		 arg1480_902 = CNST_TABLE_REF(((long) 7));
		 arg1481_903 = CNST_TABLE_REF(((long) 8));
		 {
		    obj_t list1485_905;
		    {
		       obj_t arg1486_906;
		       {
			  obj_t arg1487_907;
			  arg1487_907 = MAKE_PAIR(BNIL, BNIL);
			  arg1486_906 = MAKE_PAIR(arg1481_903, arg1487_907);
		       }
		       list1485_905 = MAKE_PAIR(arg1480_902, arg1486_906);
		    }
		    arg1461_888 = cons__138___r4_pairs_and_lists_6_3(arg1478_901, list1485_905);
		 }
	      }
	      {
		 obj_t arg1490_909;
		 obj_t arg1493_910;
		 arg1490_909 = CNST_TABLE_REF(((long) 9));
		 arg1493_910 = current_function_76_tools_error();
		 {
		    obj_t list1495_912;
		    {
		       obj_t arg1496_913;
		       arg1496_913 = MAKE_PAIR(BNIL, BNIL);
		       list1495_912 = MAKE_PAIR(arg1493_910, arg1496_913);
		    }
		    arg1463_889 = cons__138___r4_pairs_and_lists_6_3(arg1490_909, list1495_912);
		 }
	      }
	      {
		 obj_t arg1498_915;
		 obj_t arg1500_917;
		 obj_t arg1501_918;
		 arg1498_915 = CNST_TABLE_REF(((long) 10));
		 arg1500_917 = SYMBOL_TO_STRING(ti_1839);
		 {
		    obj_t arg1513_925;
		    arg1513_925 = CNST_TABLE_REF(((long) 11));
		    {
		       obj_t list1515_927;
		       {
			  obj_t arg1517_928;
			  arg1517_928 = MAKE_PAIR(BNIL, BNIL);
			  list1515_927 = MAKE_PAIR(id_868, arg1517_928);
		       }
		       arg1501_918 = cons__138___r4_pairs_and_lists_6_3(arg1513_925, list1515_927);
		    }
		 }
		 {
		    obj_t list1506_920;
		    {
		       obj_t arg1507_921;
		       {
			  obj_t arg1509_922;
			  {
			     obj_t arg1510_923;
			     arg1510_923 = MAKE_PAIR(BNIL, BNIL);
			     arg1509_922 = MAKE_PAIR(arg1501_918, arg1510_923);
			  }
			  arg1507_921 = MAKE_PAIR(arg1500_917, arg1509_922);
		       }
		       list1506_920 = MAKE_PAIR(string1962_coerce_convert, arg1507_921);
		    }
		    arg1465_890 = cons__138___r4_pairs_and_lists_6_3(arg1498_915, list1506_920);
		 }
	      }
	      arg1466_891 = location_full_fname_231_tools_location(loc_1838);
	      arg1467_892 = STRUCT_REF(loc_1838, ((long) 1));
	      {
		 obj_t list1469_894;
		 {
		    obj_t arg1470_895;
		    {
		       obj_t arg1471_896;
		       {
			  obj_t arg1472_897;
			  {
			     obj_t arg1474_898;
			     {
				obj_t arg1476_899;
				arg1476_899 = MAKE_PAIR(BNIL, BNIL);
				arg1474_898 = MAKE_PAIR(arg1467_892, arg1476_899);
			     }
			     arg1472_897 = MAKE_PAIR(arg1466_891, arg1474_898);
			  }
			  arg1471_896 = MAKE_PAIR(id_868, arg1472_897);
		       }
		       arg1470_895 = MAKE_PAIR(arg1465_890, arg1471_896);
		    }
		    list1469_894 = MAKE_PAIR(arg1463_889, arg1470_895);
		 }
		 arg1449_881 = cons__138___r4_pairs_and_lists_6_3(arg1461_888, list1469_894);
	      }
	   }
	   {
	      obj_t arg1520_930;
	      arg1520_930 = CNST_TABLE_REF(((long) 12));
	      {
		 obj_t list1523_932;
		 {
		    obj_t arg1524_933;
		    {
		       obj_t arg1526_934;
		       {
			  obj_t arg1529_935;
			  arg1529_935 = MAKE_PAIR(BNIL, BNIL);
			  arg1526_934 = MAKE_PAIR(BFALSE, arg1529_935);
		       }
		       arg1524_933 = MAKE_PAIR(BFALSE, arg1526_934);
		    }
		    list1523_932 = MAKE_PAIR(BFALSE, arg1524_933);
		 }
		 arg1450_882 = cons__138___r4_pairs_and_lists_6_3(arg1520_930, list1523_932);
	      }
	   }
	   {
	      obj_t list1453_884;
	      {
		 obj_t arg1454_885;
		 {
		    obj_t arg1457_886;
		    arg1457_886 = MAKE_PAIR(BNIL, BNIL);
		    arg1454_885 = MAKE_PAIR(arg1450_882, arg1457_886);
		 }
		 list1453_884 = MAKE_PAIR(arg1449_881, arg1454_885);
	      }
	      return cons__138___r4_pairs_and_lists_6_3(arg1448_880, list1453_884);
	   }
	}
      else
	{
	   obj_t arg1532_937;
	   obj_t arg1534_938;
	   obj_t arg1535_939;
	   arg1532_937 = CNST_TABLE_REF(((long) 12));
	   {
	      obj_t arg1542_946;
	      obj_t arg1543_947;
	      arg1542_946 = CNST_TABLE_REF(((long) 9));
	      arg1543_947 = current_function_76_tools_error();
	      {
		 obj_t list1548_949;
		 {
		    obj_t arg1549_950;
		    arg1549_950 = MAKE_PAIR(BNIL, BNIL);
		    list1548_949 = MAKE_PAIR(arg1543_947, arg1549_950);
		 }
		 arg1534_938 = cons__138___r4_pairs_and_lists_6_3(arg1542_946, list1548_949);
	      }
	   }
	   {
	      obj_t arg1551_952;
	      obj_t arg1553_954;
	      obj_t arg1554_955;
	      arg1551_952 = CNST_TABLE_REF(((long) 10));
	      arg1553_954 = SYMBOL_TO_STRING(ti_1839);
	      {
		 obj_t arg1562_962;
		 arg1562_962 = CNST_TABLE_REF(((long) 11));
		 {
		    obj_t list1564_964;
		    {
		       obj_t arg1565_965;
		       arg1565_965 = MAKE_PAIR(BNIL, BNIL);
		       list1564_964 = MAKE_PAIR(id_868, arg1565_965);
		    }
		    arg1554_955 = cons__138___r4_pairs_and_lists_6_3(arg1562_962, list1564_964);
		 }
	      }
	      {
		 obj_t list1556_957;
		 {
		    obj_t arg1557_958;
		    {
		       obj_t arg1559_959;
		       {
			  obj_t arg1560_960;
			  arg1560_960 = MAKE_PAIR(BNIL, BNIL);
			  arg1559_959 = MAKE_PAIR(arg1554_955, arg1560_960);
		       }
		       arg1557_958 = MAKE_PAIR(arg1553_954, arg1559_959);
		    }
		    list1556_957 = MAKE_PAIR(string1962_coerce_convert, arg1557_958);
		 }
		 arg1535_939 = cons__138___r4_pairs_and_lists_6_3(arg1551_952, list1556_957);
	      }
	   }
	   {
	      obj_t list1537_941;
	      {
		 obj_t arg1538_942;
		 {
		    obj_t arg1539_943;
		    {
		       obj_t arg1540_944;
		       arg1540_944 = MAKE_PAIR(BNIL, BNIL);
		       arg1539_943 = MAKE_PAIR(id_868, arg1540_944);
		    }
		    arg1538_942 = MAKE_PAIR(arg1535_939, arg1539_943);
		 }
		 list1537_941 = MAKE_PAIR(arg1534_938, arg1538_942);
	      }
	      return cons__138___r4_pairs_and_lists_6_3(arg1532_937, list1537_941);
	   }
	}
   }
}


obj_t 
_runtime_type_error_144_coerce_convert(obj_t env_1830, obj_t loc_1831, obj_t ti_1832, obj_t value_1833)
{
   return runtime_type_error_216_coerce_convert(loc_1831, ti_1832, value_1833);
}


obj_t 
convert_error_217_coerce_convert(type_t from_40, type_t to_41, obj_t loc_42, node_t node_43)
{
   {
      bool_t test1568_970;
      {
	 obj_t aux_2039;
	 aux_2039 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1568_970 = CBOOL(aux_2039);
      }
      if (test1568_970)
	{
	   obj_t arg1571_972;
	   obj_t arg1573_974;
	   obj_t arg1575_976;
	   arg1571_972 = shape_tools_shape((obj_t) (from_40));
	   arg1573_974 = shape_tools_shape((obj_t) (to_41));
	   arg1575_976 = shape_tools_shape((obj_t) (node_43));
	   {
	      obj_t list1576_977;
	      {
		 obj_t arg1577_978;
		 {
		    obj_t arg1578_979;
		    {
		       obj_t arg1579_980;
		       {
			  obj_t arg1582_981;
			  {
			     obj_t arg1583_982;
			     {
				obj_t arg1584_983;
				{
				   obj_t aux_2051;
				   aux_2051 = BCHAR(((unsigned char) '\n'));
				   arg1584_983 = MAKE_PAIR(aux_2051, BNIL);
				}
				arg1583_982 = MAKE_PAIR(arg1575_976, arg1584_983);
			     }
			     arg1582_981 = MAKE_PAIR(string1963_coerce_convert, arg1583_982);
			  }
			  arg1579_980 = MAKE_PAIR(arg1573_974, arg1582_981);
		       }
		       arg1578_979 = MAKE_PAIR(string1963_coerce_convert, arg1579_980);
		    }
		    arg1577_978 = MAKE_PAIR(arg1571_972, arg1578_979);
		 }
		 list1576_977 = MAKE_PAIR(string1964_coerce_convert, arg1577_978);
	      }
	      print_trace_107_tools_trace(list1576_977);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test1589_987;
      {
	 bool_t test1594_994;
	 {
	    obj_t obj2_1638;
	    obj2_1638 = __obj__252_type_cache;
	    {
	       obj_t aux_2061;
	       aux_2061 = (obj_t) (to_41);
	       test1594_994 = (aux_2061 == obj2_1638);
	    }
	 }
	 if (test1594_994)
	   {
	      test1589_987 = ((bool_t) 0);
	   }
	 else
	   {
	      test1589_987 = sub_type__174_type_env(to_41, (type_t) (__obj__252_type_cache));
	   }
      }
      if (test1589_987)
	{
	   obj_t unsafe_type_48_988;
	   unsafe_type_48_988 = __unsafe_type__146_engine_param;
	   __unsafe_type__146_engine_param = BTRUE;
	   {
	      obj_t arg1590_989;
	      arg1590_989 = current_function_76_tools_error();
	      {
		 obj_t arg1346_1644;
		 {
		    obj_t arg1349_1646;
		    obj_t arg1350_1647;
		    {
		       obj_t aux_2069;
		       aux_2069 = (((type_t) CREF(to_41))->id);
		       arg1349_1646 = SYMBOL_TO_STRING(aux_2069);
		    }
		    {
		       obj_t aux_2072;
		       aux_2072 = (((type_t) CREF(from_40))->id);
		       arg1350_1647 = SYMBOL_TO_STRING(aux_2072);
		    }
		    arg1346_1644 = type_error_msg_127___error(string1956_coerce_convert, arg1349_1646, arg1350_1647);
		 }
		 user_warning_location_190_tools_error(loc_42, arg1590_989, string1957_coerce_convert, arg1346_1644);
	      }
	   }
	   {
	      node_t res_990;
	      {
		 obj_t arg1591_991;
		 arg1591_991 = runtime_type_error_216_coerce_convert(loc_42, (((type_t) CREF(to_41))->id), (obj_t) (node_43));
		 res_990 = coerce__182_coerce_coerce((node_t) (arg1591_991), from_40);
	      }
	      __unsafe_type__146_engine_param = unsafe_type_48_988;
	      return (obj_t) (res_990);
	   }
	}
      else
	{
	   obj_t arg1593_993;
	   arg1593_993 = current_function_76_tools_error();
	   return type_error_location_103_coerce_convert(loc_42, arg1593_993, from_40, to_41);
	}
   }
}


node_t 
convert__122_coerce_convert(node_t node_44, type_t from_45, type_t to_46)
{
   {
      bool_t test1595_995;
      {
	 obj_t aux_2085;
	 aux_2085 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1595_995 = CBOOL(aux_2085);
      }
      if (test1595_995)
	{
	   obj_t arg1597_997;
	   obj_t arg1601_999;
	   obj_t arg1604_1001;
	   arg1597_997 = shape_tools_shape((obj_t) (from_45));
	   arg1601_999 = shape_tools_shape((obj_t) (to_46));
	   arg1604_1001 = shape_tools_shape((obj_t) (node_44));
	   {
	      obj_t list1605_1002;
	      {
		 obj_t arg1606_1003;
		 {
		    obj_t arg1608_1004;
		    {
		       obj_t arg1609_1005;
		       {
			  obj_t arg1611_1006;
			  {
			     obj_t arg1614_1007;
			     {
				obj_t arg1616_1008;
				{
				   obj_t aux_2097;
				   aux_2097 = BCHAR(((unsigned char) '\n'));
				   arg1616_1008 = MAKE_PAIR(aux_2097, BNIL);
				}
				arg1614_1007 = MAKE_PAIR(arg1604_1001, arg1616_1008);
			     }
			     arg1611_1006 = MAKE_PAIR(string1965_coerce_convert, arg1614_1007);
			  }
			  arg1609_1005 = MAKE_PAIR(arg1601_999, arg1611_1006);
		       }
		       arg1608_1004 = MAKE_PAIR(string1966_coerce_convert, arg1609_1005);
		    }
		    arg1606_1003 = MAKE_PAIR(arg1597_997, arg1608_1004);
		 }
		 list1605_1002 = MAKE_PAIR(string1967_coerce_convert, arg1606_1003);
	      }
	      print_trace_107_tools_trace(list1605_1002);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      type_t to_1012;
      type_t from_1013;
      to_1012 = get_aliased_type_1_type_type(to_46);
      from_1013 = get_aliased_type_1_type_type(from_45);
      {
	 bool_t test_2109;
	 {
	    bool_t test_2110;
	    {
	       obj_t aux_2113;
	       obj_t aux_2111;
	       aux_2113 = (obj_t) (to_1012);
	       aux_2111 = (obj_t) (from_1013);
	       test_2110 = (aux_2111 == aux_2113);
	    }
	    if (test_2110)
	      {
		 test_2109 = ((bool_t) 1);
	      }
	    else
	      {
		 test_2109 = (((type_t) CREF(from_1013))->magic__53);
	      }
	 }
	 if (test_2109)
	   {
	      return node_44;
	   }
	 else
	   {
	      obj_t coercer_1015;
	      obj_t loc_1016;
	      coercer_1015 = find_coercer_15_type_coercion(from_1013, to_1012);
	      loc_1016 = (((node_t) CREF(node_44))->loc);
	      {
		 bool_t test_2119;
		 if (STRUCTP(coercer_1015))
		   {
		      obj_t aux_2124;
		      obj_t aux_2122;
		      aux_2124 = CNST_TABLE_REF(((long) 13));
		      aux_2122 = STRUCT_KEY(coercer_1015);
		      test_2119 = (aux_2122 == aux_2124);
		   }
		 else
		   {
		      test_2119 = ((bool_t) 0);
		   }
		 if (test_2119)
		   {
		      obj_t checks_1018;
		      obj_t coerces_1019;
		      checks_1018 = STRUCT_REF(coercer_1015, ((long) 2));
		      coerces_1019 = STRUCT_REF(coercer_1015, ((long) 3));
		      {
			 bool_t test1622_1020;
			 {
			    obj_t aux_2129;
			    aux_2129 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			    test1622_1020 = CBOOL(aux_2129);
			 }
			 if (test1622_1020)
			   {
			      obj_t list1623_1021;
			      {
				 obj_t arg1626_1023;
				 {
				    obj_t arg1627_1024;
				    {
				       obj_t arg1628_1025;
				       {
					  obj_t arg1632_1027;
					  {
					     obj_t arg1634_1028;
					     {
						obj_t aux_2135;
						aux_2135 = BCHAR(((unsigned char) '\n'));
						arg1634_1028 = MAKE_PAIR(aux_2135, BNIL);
					     }
					     arg1632_1027 = MAKE_PAIR(coerces_1019, arg1634_1028);
					  }
					  arg1628_1025 = MAKE_PAIR(string1968_coerce_convert, arg1632_1027);
				       }
				       {
					  obj_t aux_2140;
					  aux_2140 = BCHAR(((unsigned char) '\n'));
					  arg1627_1024 = MAKE_PAIR(aux_2140, arg1628_1025);
				       }
				    }
				    arg1626_1023 = MAKE_PAIR(checks_1018, arg1627_1024);
				 }
				 list1623_1021 = MAKE_PAIR(string1969_coerce_convert, arg1626_1023);
			      }
			      print_trace_107_tools_trace(list1623_1021);
			   }
			 else
			   {
			      BUNSPEC;
			   }
		      }
		      {
			 obj_t checks_1032;
			 obj_t coerces_1033;
			 obj_t node_1034;
			 {
			    obj_t aux_2146;
			    checks_1032 = checks_1018;
			    coerces_1033 = coerces_1019;
			    node_1034 = (obj_t) (node_44);
			  loop_1035:
			    if (NULLP(checks_1032))
			      {
				 if (NULLP(coerces_1033))
				   {
				      aux_2146 = node_1034;
				   }
				 else
				   {
				      obj_t arg1645_1039;
				      obj_t arg1646_1040;
				      arg1645_1039 = shape_tools_shape((obj_t) (from_1013));
				      arg1646_1040 = shape_tools_shape((obj_t) (to_1012));
				      aux_2146 = internal_error_43_tools_error(string1970_coerce_convert, arg1645_1039, arg1646_1040);
				   }
			      }
			    else
			      {
				 if (NULLP(coerces_1033))
				   {
				      {
					 obj_t arg1650_1043;
					 obj_t arg1651_1044;
					 arg1650_1043 = shape_tools_shape((obj_t) (from_1013));
					 arg1651_1044 = shape_tools_shape((obj_t) (to_1012));
					 aux_2146 = internal_error_43_tools_error(string1970_coerce_convert, arg1650_1043, arg1651_1044);
				      }
				   }
				 else
				   {
				      {
					 obj_t arg1652_1045;
					 obj_t arg1653_1046;
					 obj_t arg1654_1047;
					 arg1652_1045 = CDR(checks_1032);
					 arg1653_1046 = CDR(coerces_1033);
					 arg1654_1047 = make_one_conversion_147_coerce_convert(CAR(checks_1032), from_1013, to_1012, CAR(checks_1032), CAR(coerces_1033), node_1034);
					 {
					    obj_t node_2171;
					    obj_t coerces_2170;
					    obj_t checks_2169;
					    checks_2169 = arg1652_1045;
					    coerces_2170 = arg1653_1046;
					    node_2171 = arg1654_1047;
					    node_1034 = node_2171;
					    coerces_1033 = coerces_2170;
					    checks_1032 = checks_2169;
					    goto loop_1035;
					 }
				      }
				   }
			      }
			    return (node_t) (aux_2146);
			 }
		      }
		   }
		 else
		   {
		      obj_t aux_2174;
		      aux_2174 = convert_error_217_coerce_convert(from_1013, to_1012, loc_1016, node_44);
		      return (node_t) (aux_2174);
		   }
	      }
	   }
      }
   }
}


obj_t 
_convert__140_coerce_convert(obj_t env_1834, obj_t node_1835, obj_t from_1836, obj_t to_1837)
{
   {
      node_t aux_2177;
      aux_2177 = convert__122_coerce_convert((node_t) (node_1835), (type_t) (from_1836), (type_t) (to_1837));
      return (obj_t) (aux_2177);
   }
}


obj_t 
make_one_conversion_147_coerce_convert(obj_t id_from_153_47, type_t from_48, type_t to_49, obj_t checkop_50, obj_t coerceop_51, obj_t node_52)
{
   {
      bool_t test1659_1052;
      if (NULLP(checkop_50))
	{
	   test1659_1052 = ((bool_t) 1);
	}
      else
	{
	   test1659_1052 = CBOOL(__unsafe_type__146_engine_param);
	}
      if (test1659_1052)
	{
	   return do_convert_128_coerce_convert(coerceop_51, node_52, from_48);
	}
      else
	{
	   bool_t test1660_1053;
	   test1660_1053 = is_a__118___object((obj_t) (from_48), class_object_class);
	   if (test1660_1053)
	     {
		return make_one_class_conversion_131_coerce_convert(id_from_153_47, from_48, to_49, checkop_50, coerceop_51, node_52);
	     }
	   else
	     {
		node_t aux_2192;
		aux_2192 = make_one_type_conversion_101_coerce_convert(id_from_153_47, from_48, to_49, checkop_50, coerceop_51, node_52);
		return (obj_t) (aux_2192);
	     }
	}
   }
}


node_t 
skip_let_var_187_coerce_convert(node_t node_53)
{
 skip_let_var_187_coerce_convert:
   {
      bool_t test1662_1055;
      test1662_1055 = is_a__118___object((obj_t) (node_53), let_var_6_ast_node);
      if (test1662_1055)
	{
	   node_t node_2198;
	   {
	      let_var_6_t obj_1684;
	      obj_1684 = (let_var_6_t) (node_53);
	      node_2198 = (((let_var_6_t) CREF(obj_1684))->body);
	   }
	   node_53 = node_2198;
	   goto skip_let_var_187_coerce_convert;
	}
      else
	{
	   return node_53;
	}
   }
}


node_t 
make_one_type_conversion_101_coerce_convert(obj_t id_from_153_54, type_t from_55, type_t to_56, obj_t check_op_210_57, obj_t coerce_op_79_58, obj_t node_59)
{
   {
      obj_t aux_1057;
      aux_1057 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 1)), BEOA);
      {
	 obj_t loc_1058;
	 {
	    node_t obj_1685;
	    obj_1685 = (node_t) (node_59);
	    loc_1058 = (((node_t) CREF(obj_1685))->loc);
	 }
	 {
	    node_t lnode_1059;
	    {
	       obj_t arg1674_1070;
	       {
		  obj_t arg1678_1072;
		  obj_t arg1679_1073;
		  obj_t arg1680_1074;
		  arg1678_1072 = CNST_TABLE_REF(((long) 2));
		  {
		     obj_t arg1688_1080;
		     {
			obj_t arg1693_1084;
			{
			   obj_t list1699_1090;
			   {
			      obj_t arg1701_1091;
			      {
				 obj_t arg1702_1092;
				 {
				    obj_t aux_2207;
				    aux_2207 = (((type_t) CREF(from_55))->id);
				    arg1702_1092 = MAKE_PAIR(aux_2207, BNIL);
				 }
				 arg1701_1091 = MAKE_PAIR(_4dots_tools_misc, arg1702_1092);
			      }
			      list1699_1090 = MAKE_PAIR(aux_1057, arg1701_1091);
			   }
			   arg1693_1084 = symbol_append_197___r4_symbols_6_4(list1699_1090);
			}
			{
			   obj_t list1695_1086;
			   {
			      obj_t arg1696_1087;
			      arg1696_1087 = MAKE_PAIR(BNIL, BNIL);
			      list1695_1086 = MAKE_PAIR(BUNSPEC, arg1696_1087);
			   }
			   arg1688_1080 = cons__138___r4_pairs_and_lists_6_3(arg1693_1084, list1695_1086);
			}
		     }
		     {
			obj_t list1690_1082;
			list1690_1082 = MAKE_PAIR(BNIL, BNIL);
			arg1679_1073 = cons__138___r4_pairs_and_lists_6_3(arg1688_1080, list1690_1082);
		     }
		  }
		  {
		     obj_t arg1704_1094;
		     obj_t arg1705_1095;
		     obj_t arg1706_1096;
		     arg1704_1094 = CNST_TABLE_REF(((long) 14));
		     {
			obj_t list1715_1104;
			{
			   obj_t arg1716_1105;
			   arg1716_1105 = MAKE_PAIR(BNIL, BNIL);
			   list1715_1104 = MAKE_PAIR(aux_1057, arg1716_1105);
			}
			arg1705_1095 = cons__138___r4_pairs_and_lists_6_3(check_op_210_57, list1715_1104);
		     }
		     arg1706_1096 = runtime_type_error_216_coerce_convert(loc_1058, (((type_t) CREF(to_56))->id), aux_1057);
		     {
			obj_t list1708_1098;
			{
			   obj_t arg1709_1099;
			   {
			      obj_t arg1710_1100;
			      {
				 obj_t arg1711_1101;
				 arg1711_1101 = MAKE_PAIR(BNIL, BNIL);
				 arg1710_1100 = MAKE_PAIR(arg1706_1096, arg1711_1101);
			      }
			      arg1709_1099 = MAKE_PAIR(aux_1057, arg1710_1100);
			   }
			   list1708_1098 = MAKE_PAIR(arg1705_1095, arg1709_1099);
			}
			arg1680_1074 = cons__138___r4_pairs_and_lists_6_3(arg1704_1094, list1708_1098);
		     }
		  }
		  {
		     obj_t list1682_1076;
		     {
			obj_t arg1684_1077;
			{
			   obj_t arg1686_1078;
			   arg1686_1078 = MAKE_PAIR(BNIL, BNIL);
			   arg1684_1077 = MAKE_PAIR(arg1680_1074, arg1686_1078);
			}
			list1682_1076 = MAKE_PAIR(arg1679_1073, arg1684_1077);
		     }
		     arg1674_1070 = cons__138___r4_pairs_and_lists_6_3(arg1678_1072, list1682_1076);
		  }
	       }
	       lnode_1059 = top_level_sexp__node_204_ast_sexp(arg1674_1070, BNIL);
	    }
	    {
	       lvtype_node__58_ast_lvtype(lnode_1059);
	       {
		  obj_t var_1060;
		  {
		     obj_t aux_2235;
		     {
			obj_t aux_2236;
			{
			   let_var_6_t obj_1688;
			   obj_1688 = (let_var_6_t) (lnode_1059);
			   aux_2236 = (((let_var_6_t) CREF(obj_1688))->bindings);
			}
			aux_2235 = CAR(aux_2236);
		     }
		     var_1060 = CAR(aux_2235);
		  }
		  {
		     obj_t coerce_app_174_1061;
		     {
			var_t arg1669_1067;
			{
			   var_t res1944_1701;
			   {
			      variable_t variable_1693;
			      variable_1693 = (variable_t) (var_1060);
			      {
				 var_t new1129_1694;
				 new1129_1694 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				 {
				    long arg1905_1695;
				    arg1905_1695 = class_num_218___object(var_ast_node);
				    {
				       obj_t obj_1699;
				       obj_1699 = (obj_t) (new1129_1694);
				       (((obj_t) CREF(obj_1699))->header = MAKE_HEADER(arg1905_1695, 0), BUNSPEC);
				    }
				 }
				 {
				    object_t aux_2246;
				    aux_2246 = (object_t) (new1129_1694);
				    OBJECT_WIDENING_SET(aux_2246, BFALSE);
				 }
				 ((((var_t) CREF(new1129_1694))->loc) = ((obj_t) loc_1058), BUNSPEC);
				 ((((var_t) CREF(new1129_1694))->type) = ((type_t) from_55), BUNSPEC);
				 ((((var_t) CREF(new1129_1694))->variable) = ((variable_t) variable_1693), BUNSPEC);
				 res1944_1701 = new1129_1694;
			      }
			   }
			   arg1669_1067 = res1944_1701;
			}
			coerce_app_174_1061 = do_convert_128_coerce_convert(coerce_op_79_58, (obj_t) (arg1669_1067), from_55);
		     }
		     {
			node_t condn_1062;
			condn_1062 = skip_let_var_187_coerce_convert(lnode_1059);
			{
			   {
			      obj_t res1945_1704;
			      {
				 local_t obj_1702;
				 obj_1702 = (local_t) (var_1060);
				 {
				    obj_t x_1842;
				    x_1842 = ((((local_t) CREF(obj_1702))->type) = ((type_t) from_55), BUNSPEC);
				    res1945_1704 = BUNSPEC;
				 }
			      }
			      res1945_1704;
			   }
			   {
			      obj_t aux_2257;
			      {
				 obj_t aux_2258;
				 {
				    let_var_6_t obj_1705;
				    obj_1705 = (let_var_6_t) (lnode_1059);
				    aux_2258 = (((let_var_6_t) CREF(obj_1705))->bindings);
				 }
				 aux_2257 = CAR(aux_2258);
			      }
			      SET_CDR(aux_2257, node_59);
			   }
			   {
			      obj_t res1946_1711;
			      {
				 conditional_t obj_1709;
				 node_t val1201_1710;
				 obj_1709 = (conditional_t) (condn_1062);
				 val1201_1710 = (node_t) (coerce_app_174_1061);
				 {
				    obj_t x_1843;
				    x_1843 = ((((conditional_t) CREF(obj_1709))->true) = ((node_t) val1201_1710), BUNSPEC);
				    res1946_1711 = BUNSPEC;
				 }
			      }
			      res1946_1711;
			   }
			   __unsafe_type__146_engine_param = BTRUE;
			   {
			      node_t arg1667_1065;
			      {
				 node_t aux_2266;
				 {
				    conditional_t obj_1712;
				    obj_1712 = (conditional_t) (condn_1062);
				    aux_2266 = (((conditional_t) CREF(obj_1712))->false);
				 }
				 arg1667_1065 = coerce__182_coerce_coerce(aux_2266, from_55);
			      }
			      {
				 obj_t res1947_1715;
				 {
				    conditional_t obj_1713;
				    obj_1713 = (conditional_t) (condn_1062);
				    {
				       obj_t x_1844;
				       x_1844 = ((((conditional_t) CREF(obj_1713))->false) = ((node_t) arg1667_1065), BUNSPEC);
				       res1947_1715 = BUNSPEC;
				    }
				 }
				 res1947_1715;
			      }
			   }
			   __unsafe_type__146_engine_param = BFALSE;
			   return lnode_1059;
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
make_one_class_conversion_131_coerce_convert(obj_t id_from_153_60, type_t from_61, type_t to_62, obj_t check_op_210_63, obj_t coerce_op_79_64, obj_t node_65)
{
   {
      bool_t test1720_1109;
      {
	 bool_t test1803_1189;
	 test1803_1189 = is_a__118___object((obj_t) (to_62), class_object_class);
	 if (test1803_1189)
	   {
	      test1720_1109 = type_subclass__90_object_class(from_61, to_62);
	   }
	 else
	   {
	      test1720_1109 = ((bool_t) 0);
	   }
      }
      if (test1720_1109)
	{
	   return do_convert_128_coerce_convert(coerce_op_79_64, node_65, from_61);
	}
      else
	{
	   obj_t aux_1110;
	   aux_1110 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 1)), BEOA);
	   {
	      obj_t aux2_1111;
	      aux2_1111 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 15)), BEOA);
	      {
		 obj_t loc_1112;
		 {
		    node_t obj_1717;
		    obj_1717 = (node_t) (node_65);
		    loc_1112 = (((node_t) CREF(obj_1717))->loc);
		 }
		 {
		    node_t lnode_1113;
		    {
		       obj_t arg1737_1129;
		       {
			  obj_t arg1740_1131;
			  obj_t arg1741_1132;
			  obj_t arg1742_1133;
			  arg1740_1131 = CNST_TABLE_REF(((long) 2));
			  {
			     obj_t arg1748_1139;
			     {
				obj_t arg1753_1143;
				{
				   obj_t list1760_1149;
				   {
				      obj_t arg1761_1150;
				      {
					 obj_t aux_2287;
					 aux_2287 = CNST_TABLE_REF(((long) 3));
					 arg1761_1150 = MAKE_PAIR(aux_2287, BNIL);
				      }
				      list1760_1149 = MAKE_PAIR(aux_1110, arg1761_1150);
				   }
				   arg1753_1143 = symbol_append_197___r4_symbols_6_4(list1760_1149);
				}
				{
				   obj_t list1755_1145;
				   {
				      obj_t arg1756_1146;
				      arg1756_1146 = MAKE_PAIR(BNIL, BNIL);
				      list1755_1145 = MAKE_PAIR(BUNSPEC, arg1756_1146);
				   }
				   arg1748_1139 = cons__138___r4_pairs_and_lists_6_3(arg1753_1143, list1755_1145);
				}
			     }
			     {
				obj_t list1750_1141;
				list1750_1141 = MAKE_PAIR(BNIL, BNIL);
				arg1741_1132 = cons__138___r4_pairs_and_lists_6_3(arg1748_1139, list1750_1141);
			     }
			  }
			  {
			     obj_t arg1763_1152;
			     obj_t arg1764_1153;
			     obj_t arg1766_1154;
			     arg1763_1152 = CNST_TABLE_REF(((long) 2));
			     {
				obj_t arg1772_1160;
				{
				   obj_t arg1776_1164;
				   {
				      obj_t list1782_1170;
				      {
					 obj_t arg1783_1171;
					 {
					    obj_t aux_2298;
					    aux_2298 = CNST_TABLE_REF(((long) 3));
					    arg1783_1171 = MAKE_PAIR(aux_2298, BNIL);
					 }
					 list1782_1170 = MAKE_PAIR(aux2_1111, arg1783_1171);
				      }
				      arg1776_1164 = symbol_append_197___r4_symbols_6_4(list1782_1170);
				   }
				   {
				      obj_t list1778_1166;
				      {
					 obj_t arg1779_1167;
					 arg1779_1167 = MAKE_PAIR(BNIL, BNIL);
					 list1778_1166 = MAKE_PAIR(BUNSPEC, arg1779_1167);
				      }
				      arg1772_1160 = cons__138___r4_pairs_and_lists_6_3(arg1776_1164, list1778_1166);
				   }
				}
				{
				   obj_t list1774_1162;
				   list1774_1162 = MAKE_PAIR(BNIL, BNIL);
				   arg1764_1153 = cons__138___r4_pairs_and_lists_6_3(arg1772_1160, list1774_1162);
				}
			     }
			     {
				obj_t arg1785_1173;
				obj_t arg1786_1174;
				obj_t arg1788_1175;
				arg1785_1173 = CNST_TABLE_REF(((long) 14));
				{
				   obj_t list1797_1183;
				   {
				      obj_t arg1798_1184;
				      arg1798_1184 = MAKE_PAIR(BNIL, BNIL);
				      list1797_1183 = MAKE_PAIR(aux2_1111, arg1798_1184);
				   }
				   arg1786_1174 = cons__138___r4_pairs_and_lists_6_3(check_op_210_63, list1797_1183);
				}
				arg1788_1175 = runtime_type_error_216_coerce_convert(loc_1112, (((type_t) CREF(to_62))->id), aux_1110);
				{
				   obj_t list1790_1177;
				   {
				      obj_t arg1791_1178;
				      {
					 obj_t arg1792_1179;
					 {
					    obj_t arg1793_1180;
					    arg1793_1180 = MAKE_PAIR(BNIL, BNIL);
					    arg1792_1179 = MAKE_PAIR(arg1788_1175, arg1793_1180);
					 }
					 arg1791_1178 = MAKE_PAIR(aux_1110, arg1792_1179);
				      }
				      list1790_1177 = MAKE_PAIR(arg1786_1174, arg1791_1178);
				   }
				   arg1766_1154 = cons__138___r4_pairs_and_lists_6_3(arg1785_1173, list1790_1177);
				}
			     }
			     {
				obj_t list1768_1156;
				{
				   obj_t arg1769_1157;
				   {
				      obj_t arg1770_1158;
				      arg1770_1158 = MAKE_PAIR(BNIL, BNIL);
				      arg1769_1157 = MAKE_PAIR(arg1766_1154, arg1770_1158);
				   }
				   list1768_1156 = MAKE_PAIR(arg1764_1153, arg1769_1157);
				}
				arg1742_1133 = cons__138___r4_pairs_and_lists_6_3(arg1763_1152, list1768_1156);
			     }
			  }
			  {
			     obj_t list1744_1135;
			     {
				obj_t arg1745_1136;
				{
				   obj_t arg1746_1137;
				   arg1746_1137 = MAKE_PAIR(BNIL, BNIL);
				   arg1745_1136 = MAKE_PAIR(arg1742_1133, arg1746_1137);
				}
				list1744_1135 = MAKE_PAIR(arg1741_1132, arg1745_1136);
			     }
			     arg1737_1129 = cons__138___r4_pairs_and_lists_6_3(arg1740_1131, list1744_1135);
			  }
		       }
		       lnode_1113 = top_level_sexp__node_204_ast_sexp(arg1737_1129, BNIL);
		    }
		    {
		       lvtype_node__58_ast_lvtype(lnode_1113);
		       {
			  obj_t var_1114;
			  {
			     obj_t aux_2329;
			     {
				obj_t aux_2330;
				{
				   let_var_6_t obj_1719;
				   obj_1719 = (let_var_6_t) (lnode_1113);
				   aux_2330 = (((let_var_6_t) CREF(obj_1719))->bindings);
				}
				aux_2329 = CAR(aux_2330);
			     }
			     var_1114 = CAR(aux_2329);
			  }
			  {
			     obj_t coerce_app_174_1115;
			     {
				var_t arg1734_1126;
				{
				   var_t res1948_1732;
				   {
				      variable_t variable_1724;
				      variable_1724 = (variable_t) (var_1114);
				      {
					 var_t new1129_1725;
					 new1129_1725 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
					 {
					    long arg1905_1726;
					    arg1905_1726 = class_num_218___object(var_ast_node);
					    {
					       obj_t obj_1730;
					       obj_1730 = (obj_t) (new1129_1725);
					       (((obj_t) CREF(obj_1730))->header = MAKE_HEADER(arg1905_1726, 0), BUNSPEC);
					    }
					 }
					 {
					    object_t aux_2340;
					    aux_2340 = (object_t) (new1129_1725);
					    OBJECT_WIDENING_SET(aux_2340, BFALSE);
					 }
					 ((((var_t) CREF(new1129_1725))->loc) = ((obj_t) loc_1112), BUNSPEC);
					 ((((var_t) CREF(new1129_1725))->type) = ((type_t) from_61), BUNSPEC);
					 ((((var_t) CREF(new1129_1725))->variable) = ((variable_t) variable_1724), BUNSPEC);
					 res1948_1732 = new1129_1725;
				      }
				   }
				   arg1734_1126 = res1948_1732;
				}
				coerce_app_174_1115 = do_convert_128_coerce_convert(coerce_op_79_64, (obj_t) (arg1734_1126), from_61);
			     }
			     {
				node_t condn_1116;
				condn_1116 = skip_let_var_187_coerce_convert(lnode_1113);
				{
				   {
				      obj_t res1949_1735;
				      {
					 local_t obj_1733;
					 obj_1733 = (local_t) (var_1114);
					 {
					    obj_t x_1845;
					    x_1845 = ((((local_t) CREF(obj_1733))->type) = ((type_t) from_61), BUNSPEC);
					    res1949_1735 = BUNSPEC;
					 }
				      }
				      res1949_1735;
				   }
				   {
				      obj_t aux_2351;
				      {
					 obj_t aux_2352;
					 {
					    let_var_6_t obj_1736;
					    obj_1736 = (let_var_6_t) (lnode_1113);
					    aux_2352 = (((let_var_6_t) CREF(obj_1736))->bindings);
					 }
					 aux_2351 = CAR(aux_2352);
				      }
				      SET_CDR(aux_2351, node_65);
				   }
				   {
				      obj_t binding2_1119;
				      {
					 obj_t aux_2357;
					 {
					    let_var_6_t obj_1741;
					    {
					       node_t aux_2358;
					       {
						  let_var_6_t obj_1740;
						  obj_1740 = (let_var_6_t) (lnode_1113);
						  aux_2358 = (((let_var_6_t) CREF(obj_1740))->body);
					       }
					       obj_1741 = (let_var_6_t) (aux_2358);
					    }
					    aux_2357 = (((let_var_6_t) CREF(obj_1741))->bindings);
					 }
					 binding2_1119 = CAR(aux_2357);
				      }
				      {
					 cast_t arg1724_1120;
					 {
					    var_t arg1725_1121;
					    {
					       var_t res1950_1753;
					       {
						  variable_t variable_1745;
						  variable_1745 = (variable_t) (var_1114);
						  {
						     var_t new1129_1746;
						     new1129_1746 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
						     {
							long arg1905_1747;
							arg1905_1747 = class_num_218___object(var_ast_node);
							{
							   obj_t obj_1751;
							   obj_1751 = (obj_t) (new1129_1746);
							   (((obj_t) CREF(obj_1751))->header = MAKE_HEADER(arg1905_1747, 0), BUNSPEC);
							}
						     }
						     {
							object_t aux_2369;
							aux_2369 = (object_t) (new1129_1746);
							OBJECT_WIDENING_SET(aux_2369, BFALSE);
						     }
						     ((((var_t) CREF(new1129_1746))->loc) = ((obj_t) loc_1112), BUNSPEC);
						     ((((var_t) CREF(new1129_1746))->type) = ((type_t) from_61), BUNSPEC);
						     ((((var_t) CREF(new1129_1746))->variable) = ((variable_t) variable_1745), BUNSPEC);
						     res1950_1753 = new1129_1746;
						  }
					       }
					       arg1725_1121 = res1950_1753;
					    }
					    {
					       cast_t res1951_1764;
					       {
						  type_t type_1755;
						  node_t arg_1756;
						  type_1755 = (type_t) (__obj__252_type_cache);
						  arg_1756 = (node_t) (arg1725_1121);
						  {
						     cast_t new1183_1757;
						     new1183_1757 = ((cast_t) BREF(GC_MALLOC(sizeof(struct cast))));
						     {
							long arg1887_1758;
							arg1887_1758 = class_num_218___object(cast_ast_node);
							{
							   obj_t obj_1762;
							   obj_1762 = (obj_t) (new1183_1757);
							   (((obj_t) CREF(obj_1762))->header = MAKE_HEADER(arg1887_1758, 0), BUNSPEC);
							}
						     }
						     {
							object_t aux_2381;
							aux_2381 = (object_t) (new1183_1757);
							OBJECT_WIDENING_SET(aux_2381, BFALSE);
						     }
						     ((((cast_t) CREF(new1183_1757))->loc) = ((obj_t) loc_1112), BUNSPEC);
						     ((((cast_t) CREF(new1183_1757))->type) = ((type_t) type_1755), BUNSPEC);
						     ((((cast_t) CREF(new1183_1757))->arg) = ((node_t) arg_1756), BUNSPEC);
						     res1951_1764 = new1183_1757;
						  }
					       }
					       arg1724_1120 = res1951_1764;
					    }
					 }
					 {
					    obj_t aux_2387;
					    aux_2387 = (obj_t) (arg1724_1120);
					    SET_CDR(binding2_1119, aux_2387);
					 }
				      }
				   }
				   {
				      obj_t res1952_1769;
				      {
					 conditional_t obj_1767;
					 node_t val1201_1768;
					 obj_1767 = (conditional_t) (condn_1116);
					 val1201_1768 = (node_t) (coerce_app_174_1115);
					 {
					    obj_t x_1846;
					    x_1846 = ((((conditional_t) CREF(obj_1767))->true) = ((node_t) val1201_1768), BUNSPEC);
					    res1952_1769 = BUNSPEC;
					 }
				      }
				      res1952_1769;
				   }
				   __unsafe_type__146_engine_param = BTRUE;
				   {
				      node_t arg1732_1124;
				      {
					 node_t aux_2393;
					 {
					    conditional_t obj_1770;
					    obj_1770 = (conditional_t) (condn_1116);
					    aux_2393 = (((conditional_t) CREF(obj_1770))->false);
					 }
					 arg1732_1124 = coerce__182_coerce_coerce(aux_2393, from_61);
				      }
				      {
					 obj_t res1953_1773;
					 {
					    conditional_t obj_1771;
					    obj_1771 = (conditional_t) (condn_1116);
					    {
					       obj_t x_1847;
					       x_1847 = ((((conditional_t) CREF(obj_1771))->false) = ((node_t) arg1732_1124), BUNSPEC);
					       res1953_1773 = BUNSPEC;
					    }
					 }
					 res1953_1773;
				      }
				   }
				   __unsafe_type__146_engine_param = BFALSE;
				   return (obj_t) (lnode_1113);
				}
			     }
			  }
		       }
		    }
		 }
	      }
	   }
	}
   }
}


obj_t 
do_convert_128_coerce_convert(obj_t coerce_op_79_66, obj_t node_67, type_t from_68)
{
   {
      bool_t test1804_1190;
      {
	 obj_t aux_2400;
	 aux_2400 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1804_1190 = CBOOL(aux_2400);
      }
      if (test1804_1190)
	{
	   obj_t arg1806_1192;
	   obj_t arg1808_1194;
	   arg1806_1192 = shape_tools_shape(coerce_op_79_66);
	   arg1808_1194 = shape_tools_shape(node_67);
	   {
	      obj_t list1809_1195;
	      {
		 obj_t arg1810_1196;
		 {
		    obj_t arg1811_1197;
		    {
		       obj_t arg1812_1198;
		       {
			  obj_t arg1813_1199;
			  {
			     obj_t aux_2408;
			     aux_2408 = BCHAR(((unsigned char) '\n'));
			     arg1813_1199 = MAKE_PAIR(aux_2408, BNIL);
			  }
			  arg1812_1198 = MAKE_PAIR(arg1808_1194, arg1813_1199);
		       }
		       arg1811_1197 = MAKE_PAIR(string1963_coerce_convert, arg1812_1198);
		    }
		    arg1810_1196 = MAKE_PAIR(arg1806_1192, arg1811_1197);
		 }
		 list1809_1195 = MAKE_PAIR(string1971_coerce_convert, arg1810_1196);
	      }
	      print_trace_107_tools_trace(list1809_1195);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   if (NULLP(coerce_op_79_66))
     {
	return node_67;
     }
   else
     {
	node_t nnode_1204;
	{
	   obj_t arg1849_1233;
	   {
	      obj_t list1854_1236;
	      {
		 obj_t arg1855_1237;
		 arg1855_1237 = MAKE_PAIR(BNIL, BNIL);
		 list1854_1236 = MAKE_PAIR(BUNSPEC, arg1855_1237);
	      }
	      arg1849_1233 = cons__138___r4_pairs_and_lists_6_3(coerce_op_79_66, list1854_1236);
	   }
	   nnode_1204 = top_level_sexp__node_204_ast_sexp(arg1849_1233, BNIL);
	}
	{
	   {
	      bool_t test1822_1205;
	      {
		 obj_t aux_2422;
		 aux_2422 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
		 test1822_1205 = CBOOL(aux_2422);
	      }
	      if (test1822_1205)
		{
		   obj_t arg1824_1207;
		   arg1824_1207 = shape_tools_shape((obj_t) (nnode_1204));
		   {
		      obj_t list1825_1208;
		      {
			 obj_t arg1826_1209;
			 {
			    obj_t arg1827_1210;
			    {
			       obj_t aux_2430;
			       aux_2430 = BCHAR(((unsigned char) '\n'));
			       arg1827_1210 = MAKE_PAIR(aux_2430, BNIL);
			    }
			    arg1826_1209 = MAKE_PAIR(arg1824_1207, arg1827_1210);
			 }
			 list1825_1208 = MAKE_PAIR(string1972_coerce_convert, arg1826_1209);
		      }
		      print_trace_107_tools_trace(list1825_1208);
		   }
		}
	      else
		{
		   BUNSPEC;
		}
	   }
	   {
	      bool_t test1831_1214;
	      test1831_1214 = is_a__118___object((obj_t) (nnode_1204), app_ast_node);
	      if (test1831_1214)
		{
		   {
		      obj_t arg1832_1215;
		      {
			 obj_t list1833_1216;
			 list1833_1216 = MAKE_PAIR(node_67, BNIL);
			 arg1832_1215 = list1833_1216;
		      }
		      {
			 obj_t res1954_1779;
			 {
			    app_t obj_1777;
			    obj_1777 = (app_t) (nnode_1204);
			    {
			       obj_t x_1848;
			       x_1848 = ((((app_t) CREF(obj_1777))->args) = ((obj_t) arg1832_1215), BUNSPEC);
			       res1954_1779 = BUNSPEC;
			    }
			 }
			 res1954_1779;
		      }
		   }
		   return (obj_t) (nnode_1204);
		}
	      else
		{
		   bool_t test1835_1218;
		   test1835_1218 = is_a__118___object((obj_t) (nnode_1204), let_var_6_ast_node);
		   if (test1835_1218)
		     {
			{
			   obj_t bdgs_1219;
			   {
			      let_var_6_t obj_1781;
			      obj_1781 = (let_var_6_t) (nnode_1204);
			      bdgs_1219 = (((let_var_6_t) CREF(obj_1781))->bindings);
			   }
			   {
			      bool_t test_2448;
			      if (NULLP(bdgs_1219))
				{
				   test_2448 = ((bool_t) 1);
				}
			      else
				{
				   bool_t test_2451;
				   {
				      obj_t aux_2452;
				      aux_2452 = CDR(bdgs_1219);
				      test_2451 = NULLP(aux_2452);
				   }
				   if (test_2451)
				     {
					test_2448 = ((bool_t) 0);
				     }
				   else
				     {
					test_2448 = ((bool_t) 1);
				     }
				}
			      if (test_2448)
				{
				   obj_t arg1839_1223;
				   arg1839_1223 = shape_tools_shape(coerce_op_79_66);
				   return internal_error_43_tools_error(string1973_coerce_convert, string1974_coerce_convert, arg1839_1223);
				}
			      else
				{
				   {
				      obj_t res1955_1789;
				      {
					 local_t obj_1787;
					 {
					    obj_t aux_2457;
					    {
					       obj_t aux_2458;
					       aux_2458 = CAR(bdgs_1219);
					       aux_2457 = CAR(aux_2458);
					    }
					    obj_1787 = (local_t) (aux_2457);
					 }
					 {
					    obj_t x_1849;
					    x_1849 = ((((local_t) CREF(obj_1787))->type) = ((type_t) from_68), BUNSPEC);
					    res1955_1789 = BUNSPEC;
					 }
				      }
				      res1955_1789;
				   }
				   {
				      obj_t aux_2463;
				      aux_2463 = CAR(bdgs_1219);
				      SET_CDR(aux_2463, node_67);
				   }
				   return (obj_t) (nnode_1204);
				}
			   }
			}
		     }
		   else
		     {
			{
			   obj_t arg1848_1232;
			   arg1848_1232 = shape_tools_shape(coerce_op_79_66);
			   return internal_error_43_tools_error(string1973_coerce_convert, string1974_coerce_convert, arg1848_1232);
			}
		     }
		}
	   }
	}
     }
}


obj_t 
imported_modules_init_94_coerce_convert()
{
   module_initialization_70_tools_trace(((long) 0), "COERCE_CONVERT");
   module_initialization_70_engine_param(((long) 0), "COERCE_CONVERT");
   module_initialization_70_tools_shape(((long) 0), "COERCE_CONVERT");
   module_initialization_70_tools_location(((long) 0), "COERCE_CONVERT");
   module_initialization_70_tools_error(((long) 0), "COERCE_CONVERT");
   module_initialization_70_tools_misc(((long) 0), "COERCE_CONVERT");
   module_initialization_70_type_type(((long) 0), "COERCE_CONVERT");
   module_initialization_70_type_cache(((long) 0), "COERCE_CONVERT");
   module_initialization_70_type_coercion(((long) 0), "COERCE_CONVERT");
   module_initialization_70_type_env(((long) 0), "COERCE_CONVERT");
   module_initialization_70_ast_sexp(((long) 0), "COERCE_CONVERT");
   module_initialization_70_ast_var(((long) 0), "COERCE_CONVERT");
   module_initialization_70_ast_node(((long) 0), "COERCE_CONVERT");
   module_initialization_70_ast_lvtype(((long) 0), "COERCE_CONVERT");
   module_initialization_70_object_class(((long) 0), "COERCE_CONVERT");
   module_initialization_70_coerce_typeof(((long) 0), "COERCE_CONVERT");
   return module_initialization_70_coerce_coerce(((long) 0), "COERCE_CONVERT");
}
