/*===========================================================================*/
/*   (Coerce/funcall.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t __procedure__226_type_cache;
extern obj_t _coerce__156_coerce_coerce(obj_t, obj_t, obj_t);
extern node_t coerce__182_coerce_coerce(node_t, type_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t imported_modules_init_94_coerce_funcall();
extern obj_t module_initialization_70_coerce_funcall(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_coerce_convert(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t toplevel_init_63_coerce_funcall();
static obj_t cnst_init_137_coerce_funcall();
extern node_t convert__122_coerce_convert(node_t, type_t, type_t);
extern obj_t __compiler_debug__134_engine_param;
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t __unsafe_type__146_engine_param;
static obj_t require_initialization_114_coerce_funcall = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_coerce_funcall();
static obj_t coerce_funcall_args__156_coerce_funcall(funcall_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern long class_num_218___object(obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t coerce__funcall1634_1_coerce_funcall(obj_t, obj_t, obj_t);
extern obj_t __unsafe_arity__240_engine_param;
extern obj_t location_full_fname_231_tools_location(obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern long list_length(obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static node_t make_error_node_135_coerce_funcall(local_t, obj_t, obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t __obj__252_type_cache;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
extern obj_t current_function_76_tools_error();
extern node_t top_level_sexp__node_204_ast_sexp(obj_t, obj_t);
static obj_t __cnst[18];

DEFINE_STRING(string1638_coerce_funcall, string1638_coerce_funcall1646, "coerce-funcall!: ", 17);
extern obj_t coerce__env_127_coerce_coerce;
DEFINE_STRING(string1640_coerce_funcall, string1640_coerce_funcall1647, "DUMMY __EOA__ _ FAILURE __ERROR ERROR/LOCATION @ BEGIN LOCATION CORRECT-ARITY? IF LET ::LONG LEN FUN (LIGHT ELIGHT) QUOTE COERCE ", 129);
DEFINE_STATIC_PROCEDURE(proc1637_coerce_funcall, coerce__funcall1634_1_coerce_funcall1648, coerce__funcall1634_1_coerce_funcall, 0L, 2);
DEFINE_STRING(string1639_coerce_funcall, string1639_coerce_funcall1649, ":Wrong number of arguments", 26);

obj_t 
module_initialization_70_coerce_funcall(long checksum_1282, char *from_1283)
{
   if (CBOOL(require_initialization_114_coerce_funcall))
     {
	require_initialization_114_coerce_funcall = BBOOL(((bool_t) 0));
	library_modules_init_112_coerce_funcall();
	cnst_init_137_coerce_funcall();
	imported_modules_init_94_coerce_funcall();
	toplevel_init_63_coerce_funcall();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_coerce_funcall()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "COERCE_FUNCALL");
   module_initialization_70___reader(((long) 0), "COERCE_FUNCALL");
   module_initialization_70___object(((long) 0), "COERCE_FUNCALL");
   module_initialization_70___r4_symbols_6_4(((long) 0), "COERCE_FUNCALL");
   return BUNSPEC;
}


obj_t 
cnst_init_137_coerce_funcall()
{
   {
      obj_t cnst_port_138_1274;
      cnst_port_138_1274 = open_input_string(string1640_coerce_funcall);
      {
	 long i_1275;
	 i_1275 = ((long) 17);
       loop_1276:
	 {
	    bool_t test1641_1277;
	    test1641_1277 = (i_1275 == ((long) -1));
	    if (test1641_1277)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1642_1278;
		    {
		       obj_t list1643_1279;
		       {
			  obj_t arg1644_1280;
			  arg1644_1280 = BNIL;
			  list1643_1279 = MAKE_PAIR(cnst_port_138_1274, arg1644_1280);
		       }
		       arg1642_1278 = read___reader(list1643_1279);
		    }
		    CNST_TABLE_SET(i_1275, arg1642_1278);
		 }
		 {
		    int aux_1281;
		    {
		       long aux_1301;
		       aux_1301 = (i_1275 - ((long) 1));
		       aux_1281 = (int) (aux_1301);
		    }
		    {
		       long i_1304;
		       i_1304 = (long) (aux_1281);
		       i_1275 = i_1304;
		       goto loop_1276;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_coerce_funcall()
{
   {
      obj_t coerce__funcall_115_1263;
      coerce__funcall_115_1263 = proc1637_coerce_funcall;
      return add_method__1___object(coerce__env_127_coerce_coerce, funcall_ast_node, coerce__funcall_115_1263);
   }
}


obj_t 
coerce__funcall1634_1_coerce_funcall(obj_t env_1264, obj_t node_1265, obj_t to_1266)
{
   {
      funcall_t node_648;
      obj_t to_649;
      node_648 = (funcall_t) (node_1265);
      to_649 = to_1266;
      {
	 bool_t test1273_652;
	 {
	    obj_t aux_1307;
	    aux_1307 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	    test1273_652 = CBOOL(aux_1307);
	 }
	 if (test1273_652)
	   {
	      obj_t arg1276_654;
	      arg1276_654 = shape_tools_shape((obj_t) (node_648));
	      {
		 obj_t list1277_655;
		 {
		    obj_t arg1278_656;
		    {
		       obj_t arg1279_657;
		       {
			  obj_t aux_1315;
			  aux_1315 = BCHAR(((unsigned char) '\n'));
			  arg1279_657 = MAKE_PAIR(aux_1315, BNIL);
		       }
		       arg1278_656 = MAKE_PAIR(arg1276_654, arg1279_657);
		    }
		    list1277_655 = MAKE_PAIR(string1638_coerce_funcall, arg1278_656);
		 }
		 print_trace_107_tools_trace(list1277_655);
	      }
	   }
	 else
	   {
	      BUNSPEC;
	   }
      }
      {
	 obj_t error_msg_180_661;
	 obj_t strength_662;
	 {
	    obj_t arg1355_721;
	    obj_t arg1356_722;
	    arg1355_721 = CNST_TABLE_REF(((long) 1));
	    arg1356_722 = shape_tools_shape((obj_t) (node_648));
	    {
	       obj_t list1357_723;
	       {
		  obj_t arg1358_724;
		  arg1358_724 = MAKE_PAIR(arg1356_722, BNIL);
		  list1357_723 = MAKE_PAIR(arg1355_721, arg1358_724);
	       }
	       error_msg_180_661 = list1357_723;
	    }
	 }
	 strength_662 = (((funcall_t) CREF(node_648))->strength);
	 coerce_funcall_args__156_coerce_funcall(node_648, to_649);
	 {
	    bool_t test_1328;
	    {
	       obj_t aux_1329;
	       aux_1329 = memq___r4_pairs_and_lists_6_3(strength_662, CNST_TABLE_REF(((long) 2)));
	       test_1328 = CBOOL(aux_1329);
	    }
	    if (test_1328)
	      {
		 node_t aux_1333;
		 aux_1333 = convert__122_coerce_convert((node_t) (node_648), (type_t) (__obj__252_type_cache), (type_t) (to_649));
		 return (obj_t) (aux_1333);
	      }
	    else
	      {
		 node_t c_fun_136_664;
		 c_fun_136_664 = coerce__182_coerce_coerce((((funcall_t) CREF(node_648))->fun), (type_t) (__procedure__226_type_cache));
		 if (CBOOL(__unsafe_arity__240_engine_param))
		   {
		      {
			 obj_t res1629_1160;
			 {
			    obj_t x_1271;
			    x_1271 = ((((funcall_t) CREF(node_648))->fun) = ((node_t) c_fun_136_664), BUNSPEC);
			    res1629_1160 = BUNSPEC;
			 }
			 res1629_1160;
		      }
		      {
			 node_t aux_1345;
			 aux_1345 = convert__122_coerce_convert((node_t) (node_648), (type_t) (__obj__252_type_cache), (type_t) (to_649));
			 return (obj_t) (aux_1345);
		      }
		   }
		 else
		   {
		      local_t fun_665;
		      fun_665 = make_local_svar_140_ast_local(CNST_TABLE_REF(((long) 3)), (type_t) (__procedure__226_type_cache));
		      {
			 obj_t loc_666;
			 {
			    node_t obj_1161;
			    obj_1161 = (node_t) (node_648);
			    loc_666 = (((node_t) CREF(obj_1161))->loc);
			 }
			 {
			    long len_667;
			    {
			       long aux_1356;
			       aux_1356 = list_length((((funcall_t) CREF(node_648))->args));
			       len_667 = (aux_1356 - ((long) 2));
			    }
			    {
			       obj_t a_len_134_668;
			       a_len_134_668 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 4)), BEOA);
			       {
				  obj_t a_tlen_49_669;
				  {
				     obj_t list1341_711;
				     {
					obj_t arg1342_712;
					{
					   obj_t aux_1363;
					   aux_1363 = CNST_TABLE_REF(((long) 5));
					   arg1342_712 = MAKE_PAIR(aux_1363, BNIL);
					}
					list1341_711 = MAKE_PAIR(a_len_134_668, arg1342_712);
				     }
				     a_tlen_49_669 = symbol_append_197___r4_symbols_6_4(list1341_711);
				  }
				  {
				     let_var_6_t lnode_670;
				     {
					obj_t arg1287_672;
					node_t arg1290_673;
					{
					   obj_t arg1293_674;
					   {
					      obj_t aux_1370;
					      obj_t aux_1368;
					      aux_1370 = (obj_t) (c_fun_136_664);
					      aux_1368 = (obj_t) (fun_665);
					      arg1293_674 = MAKE_PAIR(aux_1368, aux_1370);
					   }
					   {
					      obj_t list1294_675;
					      list1294_675 = MAKE_PAIR(arg1293_674, BNIL);
					      arg1287_672 = list1294_675;
					   }
					}
					{
					   obj_t arg1296_677;
					   {
					      obj_t arg1297_678;
					      obj_t arg1298_679;
					      obj_t arg1299_680;
					      arg1297_678 = CNST_TABLE_REF(((long) 6));
					      {
						 obj_t arg1308_686;
						 {
						    obj_t list1314_691;
						    {
						       obj_t arg1315_692;
						       arg1315_692 = MAKE_PAIR(BNIL, BNIL);
						       {
							  obj_t aux_1376;
							  aux_1376 = BINT(len_667);
							  list1314_691 = MAKE_PAIR(aux_1376, arg1315_692);
						       }
						    }
						    arg1308_686 = cons__138___r4_pairs_and_lists_6_3(a_tlen_49_669, list1314_691);
						 }
						 {
						    obj_t list1311_688;
						    list1311_688 = MAKE_PAIR(BNIL, BNIL);
						    arg1298_679 = cons__138___r4_pairs_and_lists_6_3(arg1308_686, list1311_688);
						 }
					      }
					      {
						 obj_t arg1318_694;
						 obj_t arg1319_695;
						 node_t arg1320_696;
						 node_t arg1321_697;
						 arg1318_694 = CNST_TABLE_REF(((long) 7));
						 {
						    obj_t arg1331_704;
						    arg1331_704 = CNST_TABLE_REF(((long) 8));
						    {
						       obj_t list1333_706;
						       {
							  obj_t arg1334_707;
							  {
							     obj_t arg1337_708;
							     arg1337_708 = MAKE_PAIR(BNIL, BNIL);
							     arg1334_707 = MAKE_PAIR(a_len_134_668, arg1337_708);
							  }
							  {
							     obj_t aux_1386;
							     aux_1386 = (obj_t) (fun_665);
							     list1333_706 = MAKE_PAIR(aux_1386, arg1334_707);
							  }
						       }
						       arg1319_695 = cons__138___r4_pairs_and_lists_6_3(arg1331_704, list1333_706);
						    }
						 }
						 arg1320_696 = convert__122_coerce_convert((node_t) (node_648), (type_t) (__obj__252_type_cache), (type_t) (to_649));
						 arg1321_697 = make_error_node_135_coerce_funcall(fun_665, error_msg_180_661, loc_666, to_649);
						 {
						    obj_t list1323_699;
						    {
						       obj_t arg1325_700;
						       {
							  obj_t arg1327_701;
							  {
							     obj_t arg1328_702;
							     arg1328_702 = MAKE_PAIR(BNIL, BNIL);
							     {
								obj_t aux_1396;
								aux_1396 = (obj_t) (arg1321_697);
								arg1327_701 = MAKE_PAIR(aux_1396, arg1328_702);
							     }
							  }
							  {
							     obj_t aux_1399;
							     aux_1399 = (obj_t) (arg1320_696);
							     arg1325_700 = MAKE_PAIR(aux_1399, arg1327_701);
							  }
						       }
						       list1323_699 = MAKE_PAIR(arg1319_695, arg1325_700);
						    }
						    arg1299_680 = cons__138___r4_pairs_and_lists_6_3(arg1318_694, list1323_699);
						 }
					      }
					      {
						 obj_t list1301_682;
						 {
						    obj_t arg1303_683;
						    {
						       obj_t arg1305_684;
						       arg1305_684 = MAKE_PAIR(BNIL, BNIL);
						       arg1303_683 = MAKE_PAIR(arg1299_680, arg1305_684);
						    }
						    list1301_682 = MAKE_PAIR(arg1298_679, arg1303_683);
						 }
						 arg1296_677 = cons__138___r4_pairs_and_lists_6_3(arg1297_678, list1301_682);
					      }
					   }
					   arg1290_673 = top_level_sexp__node_204_ast_sexp(arg1296_677, loc_666);
					}
					{
					   let_var_6_t res1630_1184;
					   {
					      type_t type_1169;
					      type_1169 = (type_t) (__obj__252_type_cache);
					      {
						 let_var_6_t new1229_1174;
						 new1229_1174 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
						 {
						    long arg1552_1175;
						    arg1552_1175 = class_num_218___object(let_var_6_ast_node);
						    {
						       obj_t obj_1182;
						       obj_1182 = (obj_t) (new1229_1174);
						       (((obj_t) CREF(obj_1182))->header = MAKE_HEADER(arg1552_1175, 0), BUNSPEC);
						    }
						 }
						 {
						    object_t aux_1414;
						    aux_1414 = (object_t) (new1229_1174);
						    OBJECT_WIDENING_SET(aux_1414, BFALSE);
						 }
						 ((((let_var_6_t) CREF(new1229_1174))->loc) = ((obj_t) loc_666), BUNSPEC);
						 ((((let_var_6_t) CREF(new1229_1174))->type) = ((type_t) type_1169), BUNSPEC);
						 ((((let_var_6_t) CREF(new1229_1174))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
						 ((((let_var_6_t) CREF(new1229_1174))->bindings) = ((obj_t) arg1287_672), BUNSPEC);
						 ((((let_var_6_t) CREF(new1229_1174))->body) = ((node_t) arg1290_673), BUNSPEC);
						 ((((let_var_6_t) CREF(new1229_1174))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
						 res1630_1184 = new1229_1174;
					      }
					   }
					   lnode_670 = res1630_1184;
					}
				     }
				     {
					{
					   var_t arg1286_671;
					   {
					      var_t res1631_1195;
					      {
						 type_t type_1186;
						 variable_t variable_1187;
						 type_1186 = (type_t) (__obj__252_type_cache);
						 variable_1187 = (variable_t) (fun_665);
						 {
						    var_t new1128_1188;
						    new1128_1188 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
						    {
						       long arg1585_1189;
						       arg1585_1189 = class_num_218___object(var_ast_node);
						       {
							  obj_t obj_1193;
							  obj_1193 = (obj_t) (new1128_1188);
							  (((obj_t) CREF(obj_1193))->header = MAKE_HEADER(arg1585_1189, 0), BUNSPEC);
						       }
						    }
						    {
						       object_t aux_1429;
						       aux_1429 = (object_t) (new1128_1188);
						       OBJECT_WIDENING_SET(aux_1429, BFALSE);
						    }
						    ((((var_t) CREF(new1128_1188))->loc) = ((obj_t) loc_666), BUNSPEC);
						    ((((var_t) CREF(new1128_1188))->type) = ((type_t) type_1186), BUNSPEC);
						    ((((var_t) CREF(new1128_1188))->variable) = ((variable_t) variable_1187), BUNSPEC);
						    res1631_1195 = new1128_1188;
						 }
					      }
					      arg1286_671 = res1631_1195;
					   }
					   {
					      obj_t res1632_1198;
					      {
						 node_t val1170_1197;
						 val1170_1197 = (node_t) (arg1286_671);
						 {
						    obj_t x_1272;
						    x_1272 = ((((funcall_t) CREF(node_648))->fun) = ((node_t) val1170_1197), BUNSPEC);
						    res1632_1198 = BUNSPEC;
						 }
					      }
					      res1632_1198;
					   }
					}
					return (obj_t) (lnode_670);
				     }
				  }
			       }
			    }
			 }
		      }
		   }
	      }
	 }
      }
   }
}


node_t 
make_error_node_135_coerce_funcall(local_t fun_13, obj_t error_msg_180_14, obj_t loc_15, obj_t to_16)
{
   {
      obj_t ut_745;
      ut_745 = __unsafe_type__146_engine_param;
      __unsafe_type__146_engine_param = BTRUE;
      {
	 node_t node_746;
	 {
	    node_t arg1390_747;
	    {
	       obj_t arg1391_748;
	       {
		  bool_t test1392_749;
		  {
		     bool_t test1506_820;
		     {
			long n1_1214;
			n1_1214 = (long) CINT(__compiler_debug__134_engine_param);
			test1506_820 = (n1_1214 > ((long) 0));
		     }
		     if (test1506_820)
		       {
			  if (STRUCTP(loc_15))
			    {
			       obj_t aux_1446;
			       obj_t aux_1444;
			       aux_1446 = CNST_TABLE_REF(((long) 9));
			       aux_1444 = STRUCT_KEY(loc_15);
			       test1392_749 = (aux_1444 == aux_1446);
			    }
			  else
			    {
			       test1392_749 = ((bool_t) 0);
			    }
		       }
		     else
		       {
			  test1392_749 = ((bool_t) 0);
		       }
		  }
		  if (test1392_749)
		    {
		       obj_t arg1396_750;
		       obj_t arg1398_751;
		       obj_t arg1400_752;
		       arg1396_750 = CNST_TABLE_REF(((long) 10));
		       {
			  obj_t arg1410_758;
			  obj_t arg1411_759;
			  obj_t arg1412_760;
			  obj_t arg1414_761;
			  {
			     obj_t arg1427_770;
			     obj_t arg1428_771;
			     obj_t arg1431_772;
			     arg1427_770 = CNST_TABLE_REF(((long) 11));
			     arg1428_771 = CNST_TABLE_REF(((long) 12));
			     arg1431_772 = CNST_TABLE_REF(((long) 13));
			     {
				obj_t list1433_774;
				{
				   obj_t arg1440_775;
				   {
				      obj_t arg1441_776;
				      arg1441_776 = MAKE_PAIR(BNIL, BNIL);
				      arg1440_775 = MAKE_PAIR(arg1431_772, arg1441_776);
				   }
				   list1433_774 = MAKE_PAIR(arg1428_771, arg1440_775);
				}
				arg1410_758 = cons__138___r4_pairs_and_lists_6_3(arg1427_770, list1433_774);
			     }
			  }
			  {
			     obj_t arg1445_778;
			     {
				obj_t arg1447_780;
				arg1447_780 = current_function_76_tools_error();
				arg1445_778 = SYMBOL_TO_STRING(arg1447_780);
			     }
			     arg1411_759 = string_append(arg1445_778, string1639_coerce_funcall);
			  }
			  arg1412_760 = location_full_fname_231_tools_location(loc_15);
			  arg1414_761 = STRUCT_REF(loc_15, ((long) 1));
			  {
			     obj_t list1416_763;
			     {
				obj_t arg1417_764;
				{
				   obj_t arg1418_765;
				   {
				      obj_t arg1420_766;
				      {
					 obj_t arg1421_767;
					 {
					    obj_t arg1424_768;
					    arg1424_768 = MAKE_PAIR(BNIL, BNIL);
					    arg1421_767 = MAKE_PAIR(arg1414_761, arg1424_768);
					 }
					 arg1420_766 = MAKE_PAIR(arg1412_760, arg1421_767);
				      }
				      {
					 obj_t aux_1466;
					 aux_1466 = (obj_t) (fun_13);
					 arg1418_765 = MAKE_PAIR(aux_1466, arg1420_766);
				      }
				   }
				   arg1417_764 = MAKE_PAIR(error_msg_180_14, arg1418_765);
				}
				list1416_763 = MAKE_PAIR(arg1411_759, arg1417_764);
			     }
			     arg1398_751 = cons__138___r4_pairs_and_lists_6_3(arg1410_758, list1416_763);
			  }
		       }
		       {
			  obj_t arg1448_781;
			  obj_t arg1449_782;
			  obj_t arg1450_783;
			  obj_t arg1452_784;
			  arg1448_781 = CNST_TABLE_REF(((long) 14));
			  {
			     obj_t arg1465_791;
			     obj_t arg1466_792;
			     arg1465_791 = CNST_TABLE_REF(((long) 1));
			     arg1466_792 = CNST_TABLE_REF(((long) 15));
			     {
				obj_t list1468_794;
				{
				   obj_t arg1470_795;
				   arg1470_795 = MAKE_PAIR(BNIL, BNIL);
				   list1468_794 = MAKE_PAIR(arg1466_792, arg1470_795);
				}
				arg1449_782 = cons__138___r4_pairs_and_lists_6_3(arg1465_791, list1468_794);
			     }
			  }
			  {
			     obj_t arg1472_797;
			     obj_t arg1474_798;
			     arg1472_797 = CNST_TABLE_REF(((long) 1));
			     arg1474_798 = CNST_TABLE_REF(((long) 15));
			     {
				obj_t list1477_800;
				{
				   obj_t arg1478_801;
				   arg1478_801 = MAKE_PAIR(BNIL, BNIL);
				   list1477_800 = MAKE_PAIR(arg1474_798, arg1478_801);
				}
				arg1450_783 = cons__138___r4_pairs_and_lists_6_3(arg1472_797, list1477_800);
			     }
			  }
			  {
			     obj_t arg1481_803;
			     obj_t arg1484_804;
			     arg1481_803 = CNST_TABLE_REF(((long) 1));
			     arg1484_804 = CNST_TABLE_REF(((long) 15));
			     {
				obj_t list1486_806;
				{
				   obj_t arg1487_807;
				   arg1487_807 = MAKE_PAIR(BNIL, BNIL);
				   list1486_806 = MAKE_PAIR(arg1484_804, arg1487_807);
				}
				arg1452_784 = cons__138___r4_pairs_and_lists_6_3(arg1481_803, list1486_806);
			     }
			  }
			  {
			     obj_t list1454_786;
			     {
				obj_t arg1457_787;
				{
				   obj_t arg1458_788;
				   {
				      obj_t arg1461_789;
				      arg1461_789 = MAKE_PAIR(BNIL, BNIL);
				      arg1458_788 = MAKE_PAIR(arg1452_784, arg1461_789);
				   }
				   arg1457_787 = MAKE_PAIR(arg1450_783, arg1458_788);
				}
				list1454_786 = MAKE_PAIR(arg1449_782, arg1457_787);
			     }
			     arg1400_752 = cons__138___r4_pairs_and_lists_6_3(arg1448_781, list1454_786);
			  }
		       }
		       {
			  obj_t list1403_754;
			  {
			     obj_t arg1404_755;
			     {
				obj_t arg1406_756;
				arg1406_756 = MAKE_PAIR(BNIL, BNIL);
				arg1404_755 = MAKE_PAIR(arg1400_752, arg1406_756);
			     }
			     list1403_754 = MAKE_PAIR(arg1398_751, arg1404_755);
			  }
			  arg1391_748 = cons__138___r4_pairs_and_lists_6_3(arg1396_750, list1403_754);
		       }
		    }
		  else
		    {
		       obj_t arg1490_809;
		       obj_t arg1493_810;
		       arg1490_809 = CNST_TABLE_REF(((long) 14));
		       {
			  obj_t arg1500_817;
			  {
			     obj_t arg1505_819;
			     arg1505_819 = current_function_76_tools_error();
			     arg1500_817 = SYMBOL_TO_STRING(arg1505_819);
			  }
			  arg1493_810 = string_append(arg1500_817, string1639_coerce_funcall);
		       }
		       {
			  obj_t list1495_812;
			  {
			     obj_t arg1496_813;
			     {
				obj_t arg1497_814;
				{
				   obj_t arg1498_815;
				   arg1498_815 = MAKE_PAIR(BNIL, BNIL);
				   {
				      obj_t aux_1502;
				      aux_1502 = (obj_t) (fun_13);
				      arg1497_814 = MAKE_PAIR(aux_1502, arg1498_815);
				   }
				}
				arg1496_813 = MAKE_PAIR(error_msg_180_14, arg1497_814);
			     }
			     list1495_812 = MAKE_PAIR(arg1493_810, arg1496_813);
			  }
			  arg1391_748 = cons__138___r4_pairs_and_lists_6_3(arg1490_809, list1495_812);
		       }
		    }
	       }
	       arg1390_747 = top_level_sexp__node_204_ast_sexp(arg1391_748, loc_15);
	    }
	    node_746 = coerce__182_coerce_coerce(arg1390_747, (type_t) (to_16));
	 }
	 __unsafe_type__146_engine_param = ut_745;
	 return node_746;
      }
   }
}


obj_t 
coerce_funcall_args__156_coerce_funcall(funcall_t node_17, obj_t to_18)
{
   {
      bool_t test_1511;
      {
	 obj_t aux_1512;
	 aux_1512 = (((funcall_t) CREF(node_17))->args);
	 test_1511 = NULLP(aux_1512);
      }
      if (test_1511)
	{
	   obj_t arg1509_822;
	   {
	      node_t arg1510_823;
	      {
		 obj_t aux_1515;
		 {
		    node_t obj_1231;
		    obj_1231 = (node_t) (node_17);
		    aux_1515 = (((node_t) CREF(obj_1231))->loc);
		 }
		 arg1510_823 = top_level_sexp__node_204_ast_sexp(CNST_TABLE_REF(((long) 16)), aux_1515);
	      }
	      {
		 obj_t list1511_824;
		 {
		    obj_t aux_1520;
		    aux_1520 = (obj_t) (arg1510_823);
		    list1511_824 = MAKE_PAIR(aux_1520, BNIL);
		 }
		 arg1509_822 = list1511_824;
	      }
	   }
	   {
	      obj_t res1633_1235;
	      {
		 obj_t x_1273;
		 x_1273 = ((((funcall_t) CREF(node_17))->args) = ((obj_t) arg1509_822), BUNSPEC);
		 res1633_1235 = BUNSPEC;
	      }
	      return res1633_1235;
	   }
	}
      else
	{
	   obj_t actuals_828;
	   obj_t prev_829;
	   actuals_828 = (((funcall_t) CREF(node_17))->args);
	   prev_829 = CNST_TABLE_REF(((long) 17));
	 loop_830:
	   if (NULLP(actuals_828))
	     {
		obj_t arg1522_834;
		{
		   node_t arg1523_835;
		   {
		      obj_t aux_1526;
		      {
			 node_t obj_1238;
			 obj_1238 = (node_t) (node_17);
			 aux_1526 = (((node_t) CREF(obj_1238))->loc);
		      }
		      arg1523_835 = top_level_sexp__node_204_ast_sexp(CNST_TABLE_REF(((long) 16)), aux_1526);
		   }
		   {
		      obj_t list1524_836;
		      {
			 obj_t aux_1531;
			 aux_1531 = (obj_t) (arg1523_835);
			 list1524_836 = MAKE_PAIR(aux_1531, BNIL);
		      }
		      arg1522_834 = list1524_836;
		   }
		}
		return SET_CDR(prev_829, arg1522_834);
	     }
	   else
	     {
		{
		   node_t arg1532_840;
		   {
		      node_t aux_1535;
		      {
			 obj_t aux_1536;
			 aux_1536 = CAR(actuals_828);
			 aux_1535 = (node_t) (aux_1536);
		      }
		      arg1532_840 = coerce__182_coerce_coerce(aux_1535, (type_t) (__obj__252_type_cache));
		   }
		   {
		      obj_t aux_1541;
		      aux_1541 = (obj_t) (arg1532_840);
		      SET_CAR(actuals_828, aux_1541);
		   }
		}
		{
		   obj_t prev_1546;
		   obj_t actuals_1544;
		   actuals_1544 = CDR(actuals_828);
		   prev_1546 = actuals_828;
		   prev_829 = prev_1546;
		   actuals_828 = actuals_1544;
		   goto loop_830;
		}
	     }
	}
   }
}


obj_t 
imported_modules_init_94_coerce_funcall()
{
   module_initialization_70_tools_trace(((long) 0), "COERCE_FUNCALL");
   module_initialization_70_engine_param(((long) 0), "COERCE_FUNCALL");
   module_initialization_70_tools_shape(((long) 0), "COERCE_FUNCALL");
   module_initialization_70_tools_error(((long) 0), "COERCE_FUNCALL");
   module_initialization_70_tools_location(((long) 0), "COERCE_FUNCALL");
   module_initialization_70_type_type(((long) 0), "COERCE_FUNCALL");
   module_initialization_70_type_cache(((long) 0), "COERCE_FUNCALL");
   module_initialization_70_ast_var(((long) 0), "COERCE_FUNCALL");
   module_initialization_70_ast_node(((long) 0), "COERCE_FUNCALL");
   module_initialization_70_ast_sexp(((long) 0), "COERCE_FUNCALL");
   module_initialization_70_ast_local(((long) 0), "COERCE_FUNCALL");
   module_initialization_70_coerce_coerce(((long) 0), "COERCE_FUNCALL");
   return module_initialization_70_coerce_convert(((long) 0), "COERCE_FUNCALL");
}
