/*===========================================================================*/
/*   (Coerce/typeof.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t __procedure__226_type_cache;
extern obj_t let_fun_218_ast_node;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t last_pair_93___r4_pairs_and_lists_6_3(obj_t);
extern obj_t __magic__144_type_cache;
static obj_t imported_modules_init_94_coerce_typeof();
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_typeof(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_coerce_typeof();
static obj_t cnst_init_137_coerce_typeof();
extern obj_t cfun_ast_var;
extern type_t typeof_kwote_49_type_typeof(obj_t);
static obj_t require_initialization_114_coerce_typeof = BUNSPEC;
static obj_t _typeof_default1284_51_coerce_typeof(obj_t, obj_t);
extern obj_t var_ast_node;
static obj_t library_modules_init_112_coerce_typeof();
extern obj_t sfun_ast_var;
extern obj_t cast_ast_node;
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern obj_t __unspec__87_type_cache;
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
static type_t typeof_default1284_108_coerce_typeof(node_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern type_t typeof_coerce_typeof(node_t);
extern obj_t kwote_ast_node;
extern obj_t _typeof_coerce_typeof(obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t __obj__252_type_cache;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t app_ast_node;
extern type_t typeof_atom_134_type_typeof(obj_t);
static obj_t __cnst[1];

DEFINE_STATIC_PROCEDURE(typeof_default1284_env_26_coerce_typeof, _typeof_default1284_51_coerce_typeof1498, _typeof_default1284_51_coerce_typeof, 0L, 1);
DEFINE_STRING(string1489_coerce_typeof, string1489_coerce_typeof1499, "typeof", 6);
DEFINE_STRING(string1490_coerce_typeof, string1490_coerce_typeof1500, "Je n'ai pas encore fait ce truc", 31);
DEFINE_STRING(string1491_coerce_typeof, string1491_coerce_typeof1501, "TYPEOF-DEFAULT1284 ", 19);
DEFINE_STRING(string1488_coerce_typeof, string1488_coerce_typeof1502, "No method for this object", 25);
DEFINE_EXPORT_GENERIC(typeof_env_7_coerce_typeof, _typeof_coerce_typeof1503, _typeof_coerce_typeof, 0L, 1);

obj_t 
module_initialization_70_coerce_typeof(long checksum_1135, char *from_1136)
{
   if (CBOOL(require_initialization_114_coerce_typeof))
     {
	require_initialization_114_coerce_typeof = BBOOL(((bool_t) 0));
	library_modules_init_112_coerce_typeof();
	cnst_init_137_coerce_typeof();
	imported_modules_init_94_coerce_typeof();
	toplevel_init_63_coerce_typeof();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_coerce_typeof()
{
   module_initialization_70___object(((long) 0), "COERCE_TYPEOF");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "COERCE_TYPEOF");
   module_initialization_70___reader(((long) 0), "COERCE_TYPEOF");
   return BUNSPEC;
}


obj_t 
cnst_init_137_coerce_typeof()
{
   {
      obj_t cnst_port_138_1127;
      cnst_port_138_1127 = open_input_string(string1491_coerce_typeof);
      {
	 long i_1128;
	 i_1128 = ((long) 0);
       loop_1129:
	 {
	    bool_t test1492_1130;
	    test1492_1130 = (i_1128 == ((long) -1));
	    if (test1492_1130)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1493_1131;
		    {
		       obj_t list1494_1132;
		       {
			  obj_t arg1496_1133;
			  arg1496_1133 = BNIL;
			  list1494_1132 = MAKE_PAIR(cnst_port_138_1127, arg1496_1133);
		       }
		       arg1493_1131 = read___reader(list1494_1132);
		    }
		    CNST_TABLE_SET(i_1128, arg1493_1131);
		 }
		 {
		    int aux_1134;
		    {
		       long aux_1153;
		       aux_1153 = (i_1128 - ((long) 1));
		       aux_1134 = (int) (aux_1153);
		    }
		    {
		       long i_1156;
		       i_1156 = (long) (aux_1134);
		       i_1128 = i_1156;
		       goto loop_1129;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_coerce_typeof()
{
   add_generic__110___object(typeof_env_7_coerce_typeof, typeof_default1284_env_26_coerce_typeof);
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, var_ast_node, ((long) 2));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, pragma_ast_node, ((long) 5));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, cast_ast_node, ((long) 6));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, setq_ast_node, ((long) 7));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, conditional_ast_node, ((long) 8));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, fail_ast_node, ((long) 9));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, select_ast_node, ((long) 10));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, let_fun_218_ast_node, ((long) 11));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, let_var_6_ast_node, ((long) 12));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, set_ex_it_116_ast_node, ((long) 13));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, jump_ex_it_184_ast_node, ((long) 14));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, make_box_202_ast_node, ((long) 15));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, box_ref_242_ast_node, ((long) 16));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, box_set__221_ast_node, ((long) 17));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, app_ly_162_ast_node, ((long) 18));
   add_inlined_method__244___object(typeof_env_7_coerce_typeof, funcall_ast_node, ((long) 19));
   {
      long aux_1179;
      aux_1179 = add_inlined_method__244___object(typeof_env_7_coerce_typeof, app_ast_node, ((long) 20));
      return BINT(aux_1179);
   }
}


type_t 
typeof_default1284_108_coerce_typeof(node_t node_2)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1488_coerce_typeof, (obj_t) (node_2));
}


obj_t 
_typeof_default1284_51_coerce_typeof(obj_t env_1125, obj_t node_1126)
{
   {
      type_t aux_1185;
      aux_1185 = typeof_default1284_108_coerce_typeof((node_t) (node_1126));
      return (obj_t) (aux_1185);
   }
}


type_t 
typeof_coerce_typeof(node_t node_1)
{
   {
      obj_t method1418_969;
      obj_t class1423_970;
      {
	 obj_t arg1426_967;
	 obj_t arg1427_968;
	 {
	    object_t obj_1060;
	    obj_1060 = (object_t) (node_1);
	    {
	       obj_t pre_method_105_1061;
	       pre_method_105_1061 = PROCEDURE_REF(typeof_env_7_coerce_typeof, ((long) 2));
	       if (INTEGERP(pre_method_105_1061))
		 {
		    PROCEDURE_SET(typeof_env_7_coerce_typeof, ((long) 2), BUNSPEC);
		    arg1426_967 = pre_method_105_1061;
		 }
	       else
		 {
		    long obj_class_num_177_1066;
		    obj_class_num_177_1066 = TYPE(obj_1060);
		    {
		       obj_t arg1183_1067;
		       arg1183_1067 = PROCEDURE_REF(typeof_env_7_coerce_typeof, ((long) 1));
		       {
			  long arg1184_1071;
			  {
			     long arg1186_1072;
			     arg1186_1072 = OBJECT_TYPE;
			     arg1184_1071 = (obj_class_num_177_1066 - arg1186_1072);
			  }
			  arg1426_967 = VECTOR_REF(arg1183_1067, arg1184_1071);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1077;
	    object_1077 = (object_t) (node_1);
	    {
	       long arg1187_1078;
	       {
		  long arg1188_1079;
		  long arg1189_1080;
		  arg1188_1079 = TYPE(object_1077);
		  arg1189_1080 = OBJECT_TYPE;
		  arg1187_1078 = (arg1188_1079 - arg1189_1080);
	       }
	       {
		  obj_t vector_1084;
		  vector_1084 = __classes__134___object;
		  arg1427_968 = VECTOR_REF(vector_1084, arg1187_1078);
	       }
	    }
	 }
	 {
	    obj_t aux_1204;
	    method1418_969 = arg1426_967;
	    class1423_970 = arg1427_968;
	    {
	       if (INTEGERP(method1418_969))
		 {
		    switch ((long) CINT(method1418_969))
		      {
		      case ((long) 0):
			 {
			    atom_t node_976;
			    node_976 = (atom_t) (node_1);
			    {
			       type_t aux_1208;
			       aux_1208 = typeof_atom_134_type_typeof((((atom_t) CREF(node_976))->value));
			       aux_1204 = (obj_t) (aux_1208);
			    }
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t node_979;
			    node_979 = (kwote_t) (node_1);
			    {
			       type_t aux_1213;
			       aux_1213 = typeof_kwote_49_type_typeof((((kwote_t) CREF(node_979))->value));
			       aux_1204 = (obj_t) (aux_1213);
			    }
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t node_982;
			    node_982 = (var_t) (node_1);
			    {
			       value_t value_984;
			       {
				  variable_t arg1446_991;
				  arg1446_991 = (((var_t) CREF(node_982))->variable);
				  value_984 = (((variable_t) CREF(arg1446_991))->value);
			       }
			       {
				  bool_t test1433_985;
				  test1433_985 = is_a__118___object((obj_t) (value_984), sfun_ast_var);
				  if (test1433_985)
				    {
				       aux_1204 = __procedure__226_type_cache;
				    }
				  else
				    {
				       bool_t test1434_986;
				       test1434_986 = is_a__118___object((obj_t) (value_984), cfun_ast_var);
				       if (test1434_986)
					 {
					    {
					       obj_t arg1444_989;
					       arg1444_989 = shape_tools_shape((obj_t) (node_982));
					       FAILURE(string1489_coerce_typeof, string1490_coerce_typeof, arg1444_989);
					    }
					 }
				       else
					 {
					    {
					       variable_t arg1445_990;
					       arg1445_990 = (((var_t) CREF(node_982))->variable);
					       {
						  type_t aux_1230;
						  aux_1230 = (((variable_t) CREF(arg1445_990))->type);
						  aux_1204 = (obj_t) (aux_1230);
					       }
					    }
					 }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 3):
			 aux_1204 = __procedure__226_type_cache;
			 break;
		      case ((long) 4):
			 {
			    sequence_t node_993;
			    node_993 = (sequence_t) (node_1);
			    {
			       type_t aux_1234;
			       {
				  node_t aux_1235;
				  {
				     obj_t aux_1236;
				     {
					obj_t aux_1237;
					aux_1237 = last_pair_93___r4_pairs_and_lists_6_3((((sequence_t) CREF(node_993))->nodes));
					aux_1236 = CAR(aux_1237);
				     }
				     aux_1235 = (node_t) (aux_1236);
				  }
				  aux_1234 = typeof_coerce_typeof(aux_1235);
			       }
			       aux_1204 = (obj_t) (aux_1234);
			    }
			 }
			 break;
		      case ((long) 5):
			 {
			    pragma_t node_998;
			    node_998 = (pragma_t) (node_1);
			    {
			       type_t aux_1245;
			       aux_1245 = (((pragma_t) CREF(node_998))->type);
			       aux_1204 = (obj_t) (aux_1245);
			    }
			 }
			 break;
		      case ((long) 6):
			 {
			    cast_t node_1000;
			    node_1000 = (cast_t) (node_1);
			    {
			       type_t aux_1249;
			       aux_1249 = (((cast_t) CREF(node_1000))->type);
			       aux_1204 = (obj_t) (aux_1249);
			    }
			 }
			 break;
		      case ((long) 7):
			 aux_1204 = __unspec__87_type_cache;
			 break;
		      case ((long) 8):
			 {
			    conditional_t node_1003;
			    node_1003 = (conditional_t) (node_1);
			    {
			       type_t ttrue_1005;
			       type_t tfalse_1006;
			       ttrue_1005 = typeof_coerce_typeof((((conditional_t) CREF(node_1003))->true));
			       tfalse_1006 = typeof_coerce_typeof((((conditional_t) CREF(node_1003))->false));
			       {
				  bool_t test_1257;
				  {
				     obj_t aux_1260;
				     obj_t aux_1258;
				     aux_1260 = (obj_t) (tfalse_1006);
				     aux_1258 = (obj_t) (ttrue_1005);
				     test_1257 = (aux_1258 == aux_1260);
				  }
				  if (test_1257)
				    {
				       aux_1204 = (obj_t) (ttrue_1005);
				    }
				  else
				    {
				       aux_1204 = __obj__252_type_cache;
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 9):
			 aux_1204 = __magic__144_type_cache;
			 break;
		      case ((long) 10):
			 {
			    select_t node_1012;
			    node_1012 = (select_t) (node_1);
			    {
			       obj_t clauses_1014;
			       type_t type_1015;
			       {
				  obj_t arg1454_1017;
				  type_t arg1457_1018;
				  {
				     obj_t aux_1265;
				     aux_1265 = (((select_t) CREF(node_1012))->clauses);
				     arg1454_1017 = CDR(aux_1265);
				  }
				  {
				     node_t aux_1268;
				     {
					obj_t aux_1269;
					{
					   obj_t aux_1270;
					   {
					      obj_t aux_1271;
					      aux_1271 = (((select_t) CREF(node_1012))->clauses);
					      aux_1270 = CAR(aux_1271);
					   }
					   aux_1269 = CDR(aux_1270);
					}
					aux_1268 = (node_t) (aux_1269);
				     }
				     arg1457_1018 = typeof_coerce_typeof(aux_1268);
				  }
				  clauses_1014 = arg1454_1017;
				  type_1015 = arg1457_1018;
				loop_1016:
				  if (NULLP(clauses_1014))
				    {
				       aux_1204 = (obj_t) (type_1015);
				    }
				  else
				    {
				       bool_t test1467_1024;
				       {
					  type_t arg1470_1026;
					  {
					     node_t aux_1280;
					     {
						obj_t aux_1281;
						{
						   obj_t aux_1282;
						   aux_1282 = CAR(clauses_1014);
						   aux_1281 = CDR(aux_1282);
						}
						aux_1280 = (node_t) (aux_1281);
					     }
					     arg1470_1026 = typeof_coerce_typeof(aux_1280);
					  }
					  {
					     obj_t aux_1289;
					     obj_t aux_1287;
					     aux_1289 = (obj_t) (type_1015);
					     aux_1287 = (obj_t) (arg1470_1026);
					     test1467_1024 = (aux_1287 == aux_1289);
					  }
				       }
				       if (test1467_1024)
					 {
					    obj_t clauses_1293;
					    clauses_1293 = CDR(clauses_1014);
					    clauses_1014 = clauses_1293;
					    goto loop_1016;
					 }
				       else
					 {
					    aux_1204 = __obj__252_type_cache;
					 }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 11):
			 {
			    let_fun_218_t node_1029;
			    node_1029 = (let_fun_218_t) (node_1);
			    {
			       type_t aux_1296;
			       aux_1296 = typeof_coerce_typeof((((let_fun_218_t) CREF(node_1029))->body));
			       aux_1204 = (obj_t) (aux_1296);
			    }
			 }
			 break;
		      case ((long) 12):
			 {
			    let_var_6_t node_1032;
			    node_1032 = (let_var_6_t) (node_1);
			    {
			       type_t aux_1301;
			       aux_1301 = typeof_coerce_typeof((((let_var_6_t) CREF(node_1032))->body));
			       aux_1204 = (obj_t) (aux_1301);
			    }
			 }
			 break;
		      case ((long) 13):
			 aux_1204 = __obj__252_type_cache;
			 break;
		      case ((long) 14):
			 aux_1204 = __obj__252_type_cache;
			 break;
		      case ((long) 15):
			 aux_1204 = __obj__252_type_cache;
			 break;
		      case ((long) 16):
			 aux_1204 = __obj__252_type_cache;
			 break;
		      case ((long) 17):
			 aux_1204 = __unspec__87_type_cache;
			 break;
		      case ((long) 18):
			 aux_1204 = __obj__252_type_cache;
			 break;
		      case ((long) 19):
			 aux_1204 = __obj__252_type_cache;
			 break;
		      case ((long) 20):
			 {
			    app_t node_1042;
			    node_1042 = (app_t) (node_1);
			    {
			       variable_t arg1477_1044;
			       {
				  var_t arg1478_1045;
				  arg1478_1045 = (((app_t) CREF(node_1042))->fun);
				  arg1477_1044 = (((var_t) CREF(arg1478_1045))->variable);
			       }
			       {
				  type_t aux_1308;
				  aux_1308 = (((variable_t) CREF(arg1477_1044))->type);
				  aux_1204 = (obj_t) (aux_1308);
			       }
			    }
			 }
			 break;
		      default:
		       case_else1424_82_973:
			 if (PROCEDUREP(method1418_969))
			   {
			      aux_1204 = PROCEDURE_ENTRY(method1418_969) (method1418_969, (obj_t) (node_1), BEOA);
			   }
			 else
			   {
			      obj_t fun1309_655;
			      fun1309_655 = PROCEDURE_REF(typeof_env_7_coerce_typeof, ((long) 0));
			      aux_1204 = PROCEDURE_ENTRY(fun1309_655) (fun1309_655, (obj_t) (node_1), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1424_82_973;
		 }
	    }
	    return (type_t) (aux_1204);
	 }
      }
   }
}


obj_t 
_typeof_coerce_typeof(obj_t env_1123, obj_t node_1124)
{
   {
      type_t aux_1323;
      aux_1323 = typeof_coerce_typeof((node_t) (node_1124));
      return (obj_t) (aux_1323);
   }
}


obj_t 
imported_modules_init_94_coerce_typeof()
{
   module_initialization_70_type_type(((long) 0), "COERCE_TYPEOF");
   module_initialization_70_type_cache(((long) 0), "COERCE_TYPEOF");
   module_initialization_70_type_typeof(((long) 0), "COERCE_TYPEOF");
   module_initialization_70_tools_shape(((long) 0), "COERCE_TYPEOF");
   module_initialization_70_ast_var(((long) 0), "COERCE_TYPEOF");
   return module_initialization_70_ast_node(((long) 0), "COERCE_TYPEOF");
}
