/*===========================================================================*/
/*   (Coerce/walk.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t coerce_walk__125_coerce_walk(obj_t);
extern node_t coerce__182_coerce_coerce(node_t, type_t);
extern obj_t reset_ppmarge__67_coerce_pproto();
extern obj_t fun_ast_var;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_coerce_walk();
extern obj_t module_initialization_70_coerce_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_coerce_pproto(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t cnst_init_137_coerce_walk();
static obj_t require_initialization_114_coerce_walk = BUNSPEC;
static obj_t library_modules_init_112_coerce_walk();
extern obj_t _coerce_walk__98_coerce_walk(obj_t, obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t current_error_port;
extern obj_t pvariable_proto_90_coerce_pproto(long, variable_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t for_each_global__88_ast_env(obj_t);
extern obj_t pfunction_proto_197_coerce_pproto(long, variable_t);
extern obj_t __current_pass__25_engine_pass;
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
static obj_t arg13181481_coerce_walk(obj_t, obj_t);
extern obj_t leave_function_170_tools_error();
static obj_t __cnst[4];

DEFINE_STRING(string1483_coerce_walk, string1483_coerce_walk1498, "   . ", 5);
DEFINE_STRING(string1486_coerce_walk, string1486_coerce_walk1499, " occured, ending ...", 20);
DEFINE_STRING(string1482_coerce_walk, string1482_coerce_walk1500, "Coercions & Checks", 18);
DEFINE_STRING(string1489_coerce_walk, string1489_coerce_walk1501, "EXPORT STATIC COERCE PASS-STARTED ", 34);
DEFINE_STRING(string1484_coerce_walk, string1484_coerce_walk1502, "failure during prelude hook", 27);
DEFINE_STRING(string1488_coerce_walk, string1488_coerce_walk1503, "failure during postlude hook", 28);
DEFINE_EXPORT_PROCEDURE(coerce_walk__env_217_coerce_walk, _coerce_walk__98_coerce_walk1504, _coerce_walk__98_coerce_walk, 0L, 1);
DEFINE_STRING(string1487_coerce_walk, string1487_coerce_walk1505, " error", 6);
DEFINE_STATIC_PROCEDURE(proc1485_coerce_walk, arg13181481_coerce_walk1506, arg13181481_coerce_walk, 0L, 1);

obj_t 
module_initialization_70_coerce_walk(long checksum_1059, char *from_1060)
{
   if (CBOOL(require_initialization_114_coerce_walk))
     {
	require_initialization_114_coerce_walk = BBOOL(((bool_t) 0));
	library_modules_init_112_coerce_walk();
	cnst_init_137_coerce_walk();
	imported_modules_init_94_coerce_walk();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_coerce_walk()
{
   module_initialization_70___object(((long) 0), "COERCE_WALK");
   module_initialization_70___r4_output_6_10_3(((long) 0), "COERCE_WALK");
   module_initialization_70___reader(((long) 0), "COERCE_WALK");
   module_initialization_70___r4_numbers_6_5(((long) 0), "COERCE_WALK");
   return BUNSPEC;
}


obj_t 
cnst_init_137_coerce_walk()
{
   {
      obj_t cnst_port_138_1051;
      cnst_port_138_1051 = open_input_string(string1489_coerce_walk);
      {
	 long i_1052;
	 i_1052 = ((long) 3);
       loop_1053:
	 {
	    bool_t test1490_1054;
	    test1490_1054 = (i_1052 == ((long) -1));
	    if (test1490_1054)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1493_1055;
		    {
		       obj_t list1494_1056;
		       {
			  obj_t arg1496_1057;
			  arg1496_1057 = BNIL;
			  list1494_1056 = MAKE_PAIR(cnst_port_138_1051, arg1496_1057);
		       }
		       arg1493_1055 = read___reader(list1494_1056);
		    }
		    CNST_TABLE_SET(i_1052, arg1493_1055);
		 }
		 {
		    int aux_1058;
		    {
		       long aux_1077;
		       aux_1077 = (i_1052 - ((long) 1));
		       aux_1058 = (int) (aux_1077);
		    }
		    {
		       long i_1080;
		       i_1080 = (long) (aux_1058);
		       i_1052 = i_1080;
		       goto loop_1053;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
coerce_walk__125_coerce_walk(obj_t ast_1)
{
   {
      obj_t list1285_631;
      {
	 obj_t arg1287_633;
	 {
	    obj_t arg1293_635;
	    {
	       obj_t aux_1082;
	       aux_1082 = BCHAR(((unsigned char) '\n'));
	       arg1293_635 = MAKE_PAIR(aux_1082, BNIL);
	    }
	    arg1287_633 = MAKE_PAIR(string1482_coerce_walk, arg1293_635);
	 }
	 list1285_631 = MAKE_PAIR(string1483_coerce_walk, arg1287_633);
      }
      verbose_tools_speek(BINT(((long) 1)), list1285_631);
   }
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   __current_pass__25_engine_pass = string1482_coerce_walk;
   {
      obj_t hooks_637;
      obj_t hnames_638;
      hooks_637 = BNIL;
      hnames_638 = BNIL;
    loop_639:
      if (NULLP(hooks_637))
	{
	   CNST_TABLE_REF(((long) 0));
	}
      else
	{
	   bool_t test1300_644;
	   {
	      obj_t fun1312_650;
	      fun1312_650 = CAR(hooks_637);
	      {
		 obj_t aux_1094;
		 aux_1094 = PROCEDURE_ENTRY(fun1312_650) (fun1312_650, BEOA);
		 test1300_644 = CBOOL(aux_1094);
	      }
	   }
	   if (test1300_644)
	     {
		{
		   obj_t hnames_1101;
		   obj_t hooks_1099;
		   hooks_1099 = CDR(hooks_637);
		   hnames_1101 = CDR(hnames_638);
		   hnames_638 = hnames_1101;
		   hooks_637 = hooks_1099;
		   goto loop_639;
		}
	     }
	   else
	     {
		internal_error_43_tools_error(string1482_coerce_walk, string1484_coerce_walk, CAR(hnames_638));
	     }
	}
   }
   {
      obj_t l1272_651;
      l1272_651 = ast_1;
    lname1283_652:
      if (PAIRP(l1272_651))
	{
	   {
	      obj_t global_654;
	      global_654 = CAR(l1272_651);
	      {
		 value_t fun_655;
		 {
		    global_t obj_1018;
		    obj_1018 = (global_t) (global_654);
		    fun_655 = (((global_t) CREF(obj_1018))->value);
		 }
		 {
		    obj_t body_656;
		    {
		       sfun_t obj_1019;
		       obj_1019 = (sfun_t) (fun_655);
		       body_656 = (((sfun_t) CREF(obj_1019))->body);
		    }
		    {
		       {
			  type_t tres_657;
			  {
			     global_t obj_1020;
			     obj_1020 = (global_t) (global_654);
			     tres_657 = (((global_t) CREF(obj_1020))->type);
			  }
			  reset_ppmarge__67_coerce_pproto();
			  pfunction_proto_197_coerce_pproto(((long) 3), (variable_t) (global_654));
			  {
			     obj_t aux_1117;
			     {
				global_t obj_1021;
				obj_1021 = (global_t) (global_654);
				aux_1117 = (((global_t) CREF(obj_1021))->id);
			     }
			     enter_function_81_tools_error(aux_1117);
			  }
			  {
			     node_t arg1315_659;
			     arg1315_659 = coerce__182_coerce_coerce((node_t) (body_656), tres_657);
			     {
				obj_t res1479_1024;
				{
				   sfun_t obj_1022;
				   obj_t val1077_1023;
				   obj_1022 = (sfun_t) (fun_655);
				   val1077_1023 = (obj_t) (arg1315_659);
				   {
				      obj_t x_1050;
				      x_1050 = ((((sfun_t) CREF(obj_1022))->body) = ((obj_t) val1077_1023), BUNSPEC);
				      res1479_1024 = BUNSPEC;
				   }
				}
				res1479_1024;
			     }
			  }
			  leave_function_170_tools_error();
		       }
		    }
		 }
	      }
	   }
	   {
	      obj_t l1272_1127;
	      l1272_1127 = CDR(l1272_651);
	      l1272_651 = l1272_1127;
	      goto lname1283_652;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   reset_ppmarge__67_coerce_pproto();
   {
      obj_t arg1318_1045;
      arg1318_1045 = proc1485_coerce_walk;
      for_each_global__88_ast_env(arg1318_1045);
   }
   {
      obj_t value_673;
      value_673 = remove_var_123_ast_remove(CNST_TABLE_REF(((long) 1)), ast_1);
      {
	 bool_t test1329_674;
	 {
	    long n1_1034;
	    n1_1034 = (long) CINT(__nb_error_on_pass__70_tools_error);
	    test1329_674 = (n1_1034 > ((long) 0));
	 }
	 if (test1329_674)
	   {
	      {
		 char *arg1333_677;
		 {
		    bool_t test1343_684;
		    {
		       bool_t test1344_685;
		       {
			  obj_t obj_1036;
			  obj_1036 = __nb_error_on_pass__70_tools_error;
			  test1344_685 = INTEGERP(obj_1036);
		       }
		       if (test1344_685)
			 {
			    test1343_684 = _2__206___r4_numbers_6_5(__nb_error_on_pass__70_tools_error, BINT(((long) 1)));
			 }
		       else
			 {
			    test1343_684 = ((bool_t) 0);
			 }
		    }
		    if (test1343_684)
		      {
			 arg1333_677 = "s";
		      }
		    else
		      {
			 arg1333_677 = "";
		      }
		 }
		 {
		    obj_t list1335_679;
		    {
		       obj_t arg1337_680;
		       {
			  obj_t arg1339_681;
			  {
			     obj_t arg1340_682;
			     arg1340_682 = MAKE_PAIR(string1486_coerce_walk, BNIL);
			     {
				obj_t aux_1142;
				aux_1142 = string_to_bstring(arg1333_677);
				arg1339_681 = MAKE_PAIR(aux_1142, arg1340_682);
			     }
			  }
			  arg1337_680 = MAKE_PAIR(string1487_coerce_walk, arg1339_681);
		       }
		       list1335_679 = MAKE_PAIR(__nb_error_on_pass__70_tools_error, arg1337_680);
		    }
		    fprint___r4_output_6_10_3(current_error_port, list1335_679);
		 }
	      }
	      {
		 obj_t res1480_1038;
		 exit(((long) -1));
		 res1480_1038 = BINT(((long) -1));
		 return res1480_1038;
	      }
	   }
	 else
	   {
	      obj_t hooks_686;
	      obj_t hnames_687;
	      hooks_686 = BNIL;
	      hnames_687 = BNIL;
	    loop_688:
	      if (NULLP(hooks_686))
		{
		   return value_673;
		}
	      else
		{
		   bool_t test1349_693;
		   {
		      obj_t fun1356_698;
		      fun1356_698 = CAR(hooks_686);
		      {
			 obj_t aux_1153;
			 aux_1153 = PROCEDURE_ENTRY(fun1356_698) (fun1356_698, BEOA);
			 test1349_693 = CBOOL(aux_1153);
		      }
		   }
		   if (test1349_693)
		     {
			{
			   obj_t hnames_1160;
			   obj_t hooks_1158;
			   hooks_1158 = CDR(hooks_686);
			   hnames_1160 = CDR(hnames_687);
			   hnames_687 = hnames_1160;
			   hooks_686 = hooks_1158;
			   goto loop_688;
			}
		     }
		   else
		     {
			return internal_error_43_tools_error(__current_pass__25_engine_pass, string1488_coerce_walk, CAR(hnames_687));
		     }
		}
	   }
      }
   }
}


obj_t 
_coerce_walk__98_coerce_walk(obj_t env_1046, obj_t ast_1047)
{
   return coerce_walk__125_coerce_walk(ast_1047);
}


obj_t 
arg13181481_coerce_walk(obj_t env_1048, obj_t global_1049)
{
   {
      obj_t global_662;
      global_662 = global_1049;
      {
	 bool_t test1320_664;
	 {
	    bool_t test1321_665;
	    {
	       obj_t aux_1165;
	       {
		  value_t aux_1166;
		  {
		     global_t obj_1026;
		     obj_1026 = (global_t) (global_662);
		     aux_1166 = (((global_t) CREF(obj_1026))->value);
		  }
		  aux_1165 = (obj_t) (aux_1166);
	       }
	       test1321_665 = is_a__118___object(aux_1165, fun_ast_var);
	    }
	    if (test1321_665)
	      {
		 test1320_664 = ((bool_t) 0);
	      }
	    else
	      {
		 bool_t _ortest_1284_666;
		 {
		    obj_t aux_1175;
		    obj_t aux_1172;
		    aux_1175 = CNST_TABLE_REF(((long) 2));
		    {
		       global_t obj_1028;
		       obj_1028 = (global_t) (global_662);
		       aux_1172 = (((global_t) CREF(obj_1028))->import);
		    }
		    _ortest_1284_666 = (aux_1172 == aux_1175);
		 }
		 if (_ortest_1284_666)
		   {
		      test1320_664 = _ortest_1284_666;
		   }
		 else
		   {
		      obj_t aux_1182;
		      obj_t aux_1179;
		      aux_1182 = CNST_TABLE_REF(((long) 3));
		      {
			 global_t obj_1031;
			 obj_1031 = (global_t) (global_662);
			 aux_1179 = (((global_t) CREF(obj_1031))->import);
		      }
		      test1320_664 = (aux_1179 == aux_1182);
		   }
	      }
	 }
	 if (test1320_664)
	   {
	      return pvariable_proto_90_coerce_pproto(((long) 3), (variable_t) (global_662));
	   }
	 else
	   {
	      return BUNSPEC;
	   }
      }
   }
}


obj_t 
imported_modules_init_94_coerce_walk()
{
   module_initialization_70_tools_speek(((long) 0), "COERCE_WALK");
   module_initialization_70_tools_error(((long) 0), "COERCE_WALK");
   module_initialization_70_engine_pass(((long) 0), "COERCE_WALK");
   module_initialization_70_tools_shape(((long) 0), "COERCE_WALK");
   module_initialization_70_type_type(((long) 0), "COERCE_WALK");
   module_initialization_70_type_cache(((long) 0), "COERCE_WALK");
   module_initialization_70_ast_var(((long) 0), "COERCE_WALK");
   module_initialization_70_ast_env(((long) 0), "COERCE_WALK");
   module_initialization_70_ast_node(((long) 0), "COERCE_WALK");
   module_initialization_70_ast_remove(((long) 0), "COERCE_WALK");
   module_initialization_70_coerce_pproto(((long) 0), "COERCE_WALK");
   return module_initialization_70_coerce_coerce(((long) 0), "COERCE_WALK");
}
