/*===========================================================================*/
/*   (Effect/cgraph.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct local_from_91
  {
     obj_t from;
  }
             *local_from_91_t;

typedef struct global_from_205
  {
     obj_t from;
  }
               *global_from_205_t;


static obj_t __var_all__30_effect_cgraph = BUNSPEC;
extern obj_t _get_var_side_effect_19_effect_cgraph(obj_t);
static obj_t _call_graph__9_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t _allocate_global_from_157_effect_cgraph(obj_t);
extern obj_t get_var_side_effect_0_effect_cgraph();
static obj_t struct_object__object_global_from1717_97_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t _call_graph__default1344_34_effect_cgraph(obj_t, obj_t, obj_t);
extern obj_t fun_call_graph__231_effect_cgraph(variable_t);
extern obj_t let_fun_218_ast_node;
static obj_t mark_side_effect__61_effect_cgraph(variable_t);
static obj_t __var_side_effect__143_effect_cgraph = BUNSPEC;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t _struct_object__object_6___object(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_effect_cgraph();
extern obj_t module_initialization_70_effect_cgraph(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_effect_cgraph();
static obj_t cnst_init_137_effect_cgraph();
static obj_t _save_call__94_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t object__struct_global_from1718_69_effect_cgraph(obj_t, obj_t);
extern obj_t cfun_ast_var;
extern obj_t _get_var_all_236_effect_cgraph(obj_t);
static obj_t _save_call__default1370_252_effect_cgraph(obj_t, obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
static obj_t require_initialization_114_effect_cgraph = BUNSPEC;
static obj_t save_call__default1370_119_effect_cgraph(variable_t, variable_t);
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_effect_cgraph();
static obj_t _allocate_local_from_49_effect_cgraph(obj_t);
extern obj_t sfun_ast_var;
extern obj_t get_var_all_239_effect_cgraph();
extern obj_t cast_ast_node;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
static obj_t call_graph__81_effect_cgraph(node_t, variable_t);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
static local_t allocate_local_from_4_effect_cgraph();
extern long class_num_218___object(obj_t);
extern obj_t object__struct_50___object(object_t);
extern obj_t app_ly_162_ast_node;
static obj_t call_graph__default1344_87_effect_cgraph(node_t, variable_t);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
static obj_t save_call__133_effect_cgraph(variable_t, variable_t);
obj_t global_from_205_effect_cgraph = BUNSPEC;
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
static obj_t object_init_111_effect_cgraph();
extern obj_t set_ex_it_116_ast_node;
static bool_t call_graph___13_effect_cgraph(obj_t, variable_t);
extern obj_t _fun_call_graph__58_effect_cgraph(obj_t, obj_t);
extern obj_t local_ast_var;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
obj_t local_from_91_effect_cgraph = BUNSPEC;
static global_t allocate_global_from_170_effect_cgraph();
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t _object__struct_74___object(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t make_box_202_ast_node;
static obj_t object__struct_local_from1716_202_effect_cgraph(obj_t, obj_t);
extern object_t struct_object__object_93___object(object_t, obj_t);
static obj_t struct_object__object_local_from1715_220_effect_cgraph(obj_t, obj_t, obj_t);
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t);
extern obj_t app_ast_node;
static obj_t __cnst[7];

DEFINE_STATIC_PROCEDURE(save_call__default1370_env_51_effect_cgraph, _save_call__default1370_252_effect_cgraph1734, _save_call__default1370_252_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(get_var_side_effect_env_93_effect_cgraph, _get_var_side_effect_19_effect_cgraph1735, _get_var_side_effect_19_effect_cgraph, 0L, 0);
DEFINE_EXPORT_PROCEDURE(fun_call_graph__env_198_effect_cgraph, _fun_call_graph__58_effect_cgraph1736, _fun_call_graph__58_effect_cgraph, 0L, 1);
DEFINE_STATIC_GENERIC(call_graph__env_226_effect_cgraph, _call_graph__9_effect_cgraph1737, _call_graph__9_effect_cgraph, 0L, 2);
DEFINE_STRING(string1726_effect_cgraph, string1726_effect_cgraph1738, "GLOBAL/FROM LOCAL/FROM NOTHING EFFECT IMPORT SAVE-CALL!-DEFAULT1370 DONE ", 73);
DEFINE_STATIC_PROCEDURE(allocate_global_from_env_89_effect_cgraph, _allocate_global_from_157_effect_cgraph1739, _allocate_global_from_157_effect_cgraph, 0L, 0);
DEFINE_STATIC_PROCEDURE(call_graph__default1344_env_234_effect_cgraph, _call_graph__default1344_34_effect_cgraph1740, _call_graph__default1344_34_effect_cgraph, 0L, 2);
DEFINE_STATIC_GENERIC(save_call__env_248_effect_cgraph, _save_call__94_effect_cgraph1741, _save_call__94_effect_cgraph, 0L, 2);
DEFINE_STRING(string1720_effect_cgraph, string1720_effect_cgraph1742, ")", 1);
DEFINE_STATIC_PROCEDURE(proc1723_effect_cgraph, struct_object__object_global_from1717_97_effect_cgraph1743, struct_object__object_global_from1717_97_effect_cgraph, 0L, 2);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_PROCEDURE(get_var_all_env_251_effect_cgraph, _get_var_all_236_effect_cgraph1744, _get_var_all_236_effect_cgraph, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1725_effect_cgraph, struct_object__object_local_from1715_220_effect_cgraph1745, struct_object__object_local_from1715_220_effect_cgraph, 0L, 2);
DEFINE_STRING(string1721_effect_cgraph, string1721_effect_cgraph1746, "!!! mark-side-effect!(", 22);
extern obj_t object__struct_env_210___object;
DEFINE_STRING(string1719_effect_cgraph, string1719_effect_cgraph1747, "No method for this object", 25);
DEFINE_STATIC_PROCEDURE(allocate_local_from_env_235_effect_cgraph, _allocate_local_from_49_effect_cgraph1748, _allocate_local_from_49_effect_cgraph, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1724_effect_cgraph, object__struct_local_from1716_202_effect_cgraph1749, object__struct_local_from1716_202_effect_cgraph, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1722_effect_cgraph, object__struct_global_from1718_69_effect_cgraph1750, object__struct_global_from1718_69_effect_cgraph, 0L, 1);

obj_t 
module_initialization_70_effect_cgraph(long checksum_1675, char *from_1676)
{
   if (CBOOL(require_initialization_114_effect_cgraph))
     {
	require_initialization_114_effect_cgraph = BBOOL(((bool_t) 0));
	library_modules_init_112_effect_cgraph();
	cnst_init_137_effect_cgraph();
	object_init_111_effect_cgraph();
	imported_modules_init_94_effect_cgraph();
	toplevel_init_63_effect_cgraph();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_effect_cgraph()
{
   module_initialization_70___object(((long) 0), "EFFECT_CGRAPH");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "EFFECT_CGRAPH");
   module_initialization_70___reader(((long) 0), "EFFECT_CGRAPH");
   return BUNSPEC;
}


obj_t 
cnst_init_137_effect_cgraph()
{
   {
      obj_t cnst_port_138_1667;
      cnst_port_138_1667 = open_input_string(string1726_effect_cgraph);
      {
	 long i_1668;
	 i_1668 = ((long) 6);
       loop_1669:
	 {
	    bool_t test1727_1670;
	    test1727_1670 = (i_1668 == ((long) -1));
	    if (test1727_1670)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1730_1671;
		    {
		       obj_t list1731_1672;
		       {
			  obj_t arg1732_1673;
			  arg1732_1673 = BNIL;
			  list1731_1672 = MAKE_PAIR(cnst_port_138_1667, arg1732_1673);
		       }
		       arg1730_1671 = read___reader(list1731_1672);
		    }
		    CNST_TABLE_SET(i_1668, arg1730_1671);
		 }
		 {
		    int aux_1674;
		    {
		       long aux_1694;
		       aux_1694 = (i_1668 - ((long) 1));
		       aux_1674 = (int) (aux_1694);
		    }
		    {
		       long i_1697;
		       i_1697 = (long) (aux_1674);
		       i_1668 = i_1697;
		       goto loop_1669;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_effect_cgraph()
{
   add_generic__110___object(call_graph__env_226_effect_cgraph, call_graph__default1344_env_234_effect_cgraph);
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, sequence_ast_node, ((long) 0));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, app_ast_node, ((long) 1));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, app_ly_162_ast_node, ((long) 2));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, funcall_ast_node, ((long) 3));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, pragma_ast_node, ((long) 4));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, cast_ast_node, ((long) 5));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, setq_ast_node, ((long) 6));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, conditional_ast_node, ((long) 7));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, fail_ast_node, ((long) 8));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, select_ast_node, ((long) 9));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, let_fun_218_ast_node, ((long) 10));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, let_var_6_ast_node, ((long) 11));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, set_ex_it_116_ast_node, ((long) 12));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, jump_ex_it_184_ast_node, ((long) 13));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, make_box_202_ast_node, ((long) 14));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, box_ref_242_ast_node, ((long) 15));
   add_inlined_method__244___object(call_graph__env_226_effect_cgraph, box_set__221_ast_node, ((long) 16));
   add_generic__110___object(save_call__env_248_effect_cgraph, save_call__default1370_env_51_effect_cgraph);
   add_inlined_method__244___object(save_call__env_248_effect_cgraph, global_ast_var, ((long) 0));
   add_inlined_method__244___object(save_call__env_248_effect_cgraph, global_from_205_effect_cgraph, ((long) 1));
   add_inlined_method__244___object(save_call__env_248_effect_cgraph, local_ast_var, ((long) 2));
   add_inlined_method__244___object(save_call__env_248_effect_cgraph, local_from_91_effect_cgraph, ((long) 3));
   __var_side_effect__143_effect_cgraph = BNIL;
   return (__var_all__30_effect_cgraph = BNIL,
      BUNSPEC);
}


obj_t 
fun_call_graph__231_effect_cgraph(variable_t variable_1)
{
   {
      obj_t obj2_1370;
      obj2_1370 = __var_all__30_effect_cgraph;
      {
	 obj_t aux_1722;
	 aux_1722 = (obj_t) (variable_1);
	 __var_all__30_effect_cgraph = MAKE_PAIR(aux_1722, obj2_1370);
      }
   }
   {
      node_t aux_1725;
      {
	 obj_t aux_1726;
	 {
	    sfun_t obj_1372;
	    {
	       value_t aux_1727;
	       aux_1727 = (((variable_t) CREF(variable_1))->value);
	       obj_1372 = (sfun_t) (aux_1727);
	    }
	    aux_1726 = (((sfun_t) CREF(obj_1372))->body);
	 }
	 aux_1725 = (node_t) (aux_1726);
      }
      return call_graph__81_effect_cgraph(aux_1725, variable_1);
   }
}


obj_t 
_fun_call_graph__58_effect_cgraph(obj_t env_1639, obj_t variable_1640)
{
   return fun_call_graph__231_effect_cgraph((variable_t) (variable_1640));
}


obj_t 
call_graph__default1344_87_effect_cgraph(node_t node_4, variable_t owner_5)
{
   return CNST_TABLE_REF(((long) 0));
}


obj_t 
_call_graph__default1344_34_effect_cgraph(obj_t env_1630, obj_t node_1631, obj_t owner_1632)
{
   return call_graph__default1344_87_effect_cgraph((node_t) (node_1631), (variable_t) (owner_1632));
}


obj_t 
call_graph__81_effect_cgraph(node_t node_2, variable_t owner_3)
{
 call_graph__81_effect_cgraph:
   {
      obj_t method1622_1248;
      obj_t class1627_1249;
      {
	 obj_t arg1630_1246;
	 obj_t arg1632_1247;
	 {
	    object_t obj_1373;
	    obj_1373 = (object_t) (node_2);
	    {
	       obj_t pre_method_105_1374;
	       pre_method_105_1374 = PROCEDURE_REF(call_graph__env_226_effect_cgraph, ((long) 2));
	       if (INTEGERP(pre_method_105_1374))
		 {
		    PROCEDURE_SET(call_graph__env_226_effect_cgraph, ((long) 2), BUNSPEC);
		    arg1630_1246 = pre_method_105_1374;
		 }
	       else
		 {
		    long obj_class_num_177_1379;
		    obj_class_num_177_1379 = TYPE(obj_1373);
		    {
		       obj_t arg1183_1380;
		       arg1183_1380 = PROCEDURE_REF(call_graph__env_226_effect_cgraph, ((long) 1));
		       {
			  long arg1184_1384;
			  {
			     long arg1186_1385;
			     arg1186_1385 = OBJECT_TYPE;
			     arg1184_1384 = (obj_class_num_177_1379 - arg1186_1385);
			  }
			  arg1630_1246 = VECTOR_REF(arg1183_1380, arg1184_1384);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1390;
	    object_1390 = (object_t) (node_2);
	    {
	       long arg1187_1391;
	       {
		  long arg1188_1392;
		  long arg1189_1393;
		  arg1188_1392 = TYPE(object_1390);
		  arg1189_1393 = OBJECT_TYPE;
		  arg1187_1391 = (arg1188_1392 - arg1189_1393);
	       }
	       {
		  obj_t vector_1397;
		  vector_1397 = __classes__134___object;
		  arg1632_1247 = VECTOR_REF(vector_1397, arg1187_1391);
	       }
	    }
	 }
	 method1622_1248 = arg1630_1246;
	 class1627_1249 = arg1632_1247;
	 {
	    if (INTEGERP(method1622_1248))
	      {
		 switch ((long) CINT(method1622_1248))
		   {
		   case ((long) 0):
		      {
			 sequence_t node_1255;
			 node_1255 = (sequence_t) (node_2);
			 {
			    bool_t aux_1757;
			    aux_1757 = call_graph___13_effect_cgraph((((sequence_t) CREF(node_1255))->nodes), owner_3);
			    return BBOOL(aux_1757);
			 }
		      }
		      break;
		   case ((long) 1):
		      {
			 app_t node_1258;
			 node_1258 = (app_t) (node_2);
			 {
			    variable_t aux_1762;
			    {
			       var_t arg1641_1262;
			       arg1641_1262 = (((app_t) CREF(node_1258))->fun);
			       aux_1762 = (((var_t) CREF(arg1641_1262))->variable);
			    }
			    save_call__133_effect_cgraph(aux_1762, owner_3);
			 }
			 {
			    bool_t aux_1766;
			    aux_1766 = call_graph___13_effect_cgraph((((app_t) CREF(node_1258))->args), owner_3);
			    return BBOOL(aux_1766);
			 }
		      }
		      break;
		   case ((long) 2):
		      {
			 app_ly_162_t node_1264;
			 node_1264 = (app_ly_162_t) (node_2);
			 mark_side_effect__61_effect_cgraph(owner_3);
			 call_graph__81_effect_cgraph((((app_ly_162_t) CREF(node_1264))->fun), owner_3);
			 {
			    node_t node_1774;
			    node_1774 = (((app_ly_162_t) CREF(node_1264))->arg);
			    node_2 = node_1774;
			    goto call_graph__81_effect_cgraph;
			 }
		      }
		      break;
		   case ((long) 3):
		      {
			 funcall_t node_1269;
			 node_1269 = (funcall_t) (node_2);
			 mark_side_effect__61_effect_cgraph(owner_3);
			 call_graph__81_effect_cgraph((((funcall_t) CREF(node_1269))->fun), owner_3);
			 {
			    bool_t aux_1780;
			    aux_1780 = call_graph___13_effect_cgraph((((funcall_t) CREF(node_1269))->args), owner_3);
			    return BBOOL(aux_1780);
			 }
		      }
		      break;
		   case ((long) 4):
		      {
			 pragma_t node_1274;
			 node_1274 = (pragma_t) (node_2);
			 {
			    bool_t test_1785;
			    {
			       obj_t aux_1786;
			       aux_1786 = (((pragma_t) CREF(node_1274))->side_effect__165);
			       test_1785 = CBOOL(aux_1786);
			    }
			    if (test_1785)
			      {
				 mark_side_effect__61_effect_cgraph(owner_3);
			      }
			    else
			      {
				 BUNSPEC;
			      }
			 }
			 {
			    bool_t aux_1790;
			    aux_1790 = call_graph___13_effect_cgraph((((pragma_t) CREF(node_1274))->args), owner_3);
			    return BBOOL(aux_1790);
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 cast_t node_1279;
			 node_1279 = (cast_t) (node_2);
			 {
			    node_t node_1795;
			    node_1795 = (((cast_t) CREF(node_1279))->arg);
			    node_2 = node_1795;
			    goto call_graph__81_effect_cgraph;
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 setq_t node_1283;
			 node_1283 = (setq_t) (node_2);
			 {
			    bool_t test1651_1286;
			    {
			       bool_t test1652_1287;
			       test1652_1287 = is_a__118___object((obj_t) (owner_3), local_ast_var);
			       if (test1652_1287)
				 {
				    test1651_1286 = ((bool_t) 1);
				 }
			       else
				 {
				    obj_t aux_1801;
				    {
				       variable_t aux_1802;
				       {
					  var_t arg1654_1289;
					  arg1654_1289 = (((setq_t) CREF(node_1283))->var);
					  aux_1802 = (((var_t) CREF(arg1654_1289))->variable);
				       }
				       aux_1801 = (obj_t) (aux_1802);
				    }
				    test1651_1286 = is_a__118___object(aux_1801, global_ast_var);
				 }
			    }
			    if (test1651_1286)
			      {
				 mark_side_effect__61_effect_cgraph(owner_3);
			      }
			    else
			      {
				 BUNSPEC;
			      }
			 }
			 {
			    node_t aux_1809;
			    {
			       var_t aux_1810;
			       aux_1810 = (((setq_t) CREF(node_1283))->var);
			       aux_1809 = (node_t) (aux_1810);
			    }
			    call_graph__81_effect_cgraph(aux_1809, owner_3);
			 }
			 {
			    node_t node_1814;
			    node_1814 = (((setq_t) CREF(node_1283))->value);
			    node_2 = node_1814;
			    goto call_graph__81_effect_cgraph;
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 conditional_t node_1292;
			 node_1292 = (conditional_t) (node_2);
			 call_graph__81_effect_cgraph((((conditional_t) CREF(node_1292))->test), owner_3);
			 call_graph__81_effect_cgraph((((conditional_t) CREF(node_1292))->true), owner_3);
			 {
			    node_t node_1821;
			    node_1821 = (((conditional_t) CREF(node_1292))->false);
			    node_2 = node_1821;
			    goto call_graph__81_effect_cgraph;
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 fail_t node_1298;
			 node_1298 = (fail_t) (node_2);
			 mark_side_effect__61_effect_cgraph(owner_3);
			 call_graph__81_effect_cgraph((((fail_t) CREF(node_1298))->proc), owner_3);
			 call_graph__81_effect_cgraph((((fail_t) CREF(node_1298))->msg), owner_3);
			 {
			    node_t node_1829;
			    node_1829 = (((fail_t) CREF(node_1298))->obj);
			    node_2 = node_1829;
			    goto call_graph__81_effect_cgraph;
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 select_t node_1304;
			 node_1304 = (select_t) (node_2);
			 call_graph__81_effect_cgraph((((select_t) CREF(node_1304))->test), owner_3);
			 {
			    obj_t l1325_1308;
			    {
			       bool_t aux_1834;
			       l1325_1308 = (((select_t) CREF(node_1304))->clauses);
			     lname1326_1309:
			       if (PAIRP(l1325_1308))
				 {
				    {
				       node_t aux_1837;
				       {
					  obj_t aux_1838;
					  {
					     obj_t aux_1839;
					     aux_1839 = CAR(l1325_1308);
					     aux_1838 = CDR(aux_1839);
					  }
					  aux_1837 = (node_t) (aux_1838);
				       }
				       call_graph__81_effect_cgraph(aux_1837, owner_3);
				    }
				    {
				       obj_t l1325_1844;
				       l1325_1844 = CDR(l1325_1308);
				       l1325_1308 = l1325_1844;
				       goto lname1326_1309;
				    }
				 }
			       else
				 {
				    aux_1834 = ((bool_t) 1);
				 }
			       return BBOOL(aux_1834);
			    }
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 let_fun_218_t node_1315;
			 node_1315 = (let_fun_218_t) (node_2);
			 {
			    obj_t l1328_1318;
			    l1328_1318 = (((let_fun_218_t) CREF(node_1315))->locals);
			  lname1330_1319:
			    if (PAIRP(l1328_1318))
			      {
				 {
				    variable_t aux_1851;
				    {
				       obj_t aux_1852;
				       aux_1852 = CAR(l1328_1318);
				       aux_1851 = (variable_t) (aux_1852);
				    }
				    fun_call_graph__231_effect_cgraph(aux_1851);
				 }
				 {
				    obj_t l1328_1856;
				    l1328_1856 = CDR(l1328_1318);
				    l1328_1318 = l1328_1856;
				    goto lname1330_1319;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    node_t node_1859;
			    node_1859 = (((let_fun_218_t) CREF(node_1315))->body);
			    node_2 = node_1859;
			    goto call_graph__81_effect_cgraph;
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 let_var_6_t node_1325;
			 node_1325 = (let_var_6_t) (node_2);
			 call_graph__81_effect_cgraph((((let_var_6_t) CREF(node_1325))->body), owner_3);
			 {
			    obj_t l1332_1329;
			    {
			       bool_t aux_1864;
			       l1332_1329 = (((let_var_6_t) CREF(node_1325))->bindings);
			     lname1333_1330:
			       if (PAIRP(l1332_1329))
				 {
				    {
				       node_t aux_1867;
				       {
					  obj_t aux_1868;
					  {
					     obj_t aux_1869;
					     aux_1869 = CAR(l1332_1329);
					     aux_1868 = CDR(aux_1869);
					  }
					  aux_1867 = (node_t) (aux_1868);
				       }
				       call_graph__81_effect_cgraph(aux_1867, owner_3);
				    }
				    {
				       obj_t l1332_1874;
				       l1332_1874 = CDR(l1332_1329);
				       l1332_1329 = l1332_1874;
				       goto lname1333_1330;
				    }
				 }
			       else
				 {
				    aux_1864 = ((bool_t) 1);
				 }
			       return BBOOL(aux_1864);
			    }
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 set_ex_it_116_t node_1336;
			 node_1336 = (set_ex_it_116_t) (node_2);
			 mark_side_effect__61_effect_cgraph(owner_3);
			 {
			    node_t node_1880;
			    node_1880 = (((set_ex_it_116_t) CREF(node_1336))->body);
			    node_2 = node_1880;
			    goto call_graph__81_effect_cgraph;
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 jump_ex_it_184_t node_1340;
			 node_1340 = (jump_ex_it_184_t) (node_2);
			 mark_side_effect__61_effect_cgraph(owner_3);
			 call_graph__81_effect_cgraph((((jump_ex_it_184_t) CREF(node_1340))->exit), owner_3);
			 {
			    node_t node_1886;
			    node_1886 = (((jump_ex_it_184_t) CREF(node_1340))->value);
			    node_2 = node_1886;
			    goto call_graph__81_effect_cgraph;
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 make_box_202_t node_1345;
			 node_1345 = (make_box_202_t) (node_2);
			 {
			    node_t node_1889;
			    node_1889 = (((make_box_202_t) CREF(node_1345))->value);
			    node_2 = node_1889;
			    goto call_graph__81_effect_cgraph;
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 box_ref_242_t node_1348;
			 node_1348 = (box_ref_242_t) (node_2);
			 {
			    node_t node_1892;
			    {
			       var_t aux_1893;
			       aux_1893 = (((box_ref_242_t) CREF(node_1348))->var);
			       node_1892 = (node_t) (aux_1893);
			    }
			    node_2 = node_1892;
			    goto call_graph__81_effect_cgraph;
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 box_set__221_t node_1351;
			 node_1351 = (box_set__221_t) (node_2);
			 {
			    bool_t test1691_1354;
			    {
			       bool_t test1692_1355;
			       test1692_1355 = is_a__118___object((obj_t) (owner_3), local_ast_var);
			       if (test1692_1355)
				 {
				    test1691_1354 = ((bool_t) 1);
				 }
			       else
				 {
				    obj_t aux_1900;
				    {
				       variable_t aux_1901;
				       {
					  var_t arg1694_1357;
					  arg1694_1357 = (((box_set__221_t) CREF(node_1351))->var);
					  aux_1901 = (((var_t) CREF(arg1694_1357))->variable);
				       }
				       aux_1900 = (obj_t) (aux_1901);
				    }
				    test1691_1354 = is_a__118___object(aux_1900, global_ast_var);
				 }
			    }
			    if (test1691_1354)
			      {
				 mark_side_effect__61_effect_cgraph(owner_3);
			      }
			    else
			      {
				 BUNSPEC;
			      }
			 }
			 {
			    node_t aux_1908;
			    {
			       var_t aux_1909;
			       aux_1909 = (((box_set__221_t) CREF(node_1351))->var);
			       aux_1908 = (node_t) (aux_1909);
			    }
			    call_graph__81_effect_cgraph(aux_1908, owner_3);
			 }
			 {
			    node_t node_1913;
			    node_1913 = (((box_set__221_t) CREF(node_1351))->value);
			    node_2 = node_1913;
			    goto call_graph__81_effect_cgraph;
			 }
		      }
		      break;
		   default:
		    case_else1628_234_1252:
		      if (PROCEDUREP(method1622_1248))
			{
			   return PROCEDURE_ENTRY(method1622_1248) (method1622_1248, (obj_t) (node_2), (obj_t) (owner_3), BEOA);
			}
		      else
			{
			   obj_t fun1389_784;
			   fun1389_784 = PROCEDURE_REF(call_graph__env_226_effect_cgraph, ((long) 0));
			   return PROCEDURE_ENTRY(fun1389_784) (fun1389_784, (obj_t) (node_2), (obj_t) (owner_3), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1628_234_1252;
	      }
	 }
      }
   }
}


obj_t 
_call_graph__9_effect_cgraph(obj_t env_1627, obj_t node_1628, obj_t owner_1629)
{
   return call_graph__81_effect_cgraph((node_t) (node_1628), (variable_t) (owner_1629));
}


bool_t 
call_graph___13_effect_cgraph(obj_t node__221_40, variable_t owner_41)
{
   {
      obj_t l1337_785;
      l1337_785 = node__221_40;
    lname1338_786:
      if (PAIRP(l1337_785))
	{
	   {
	      node_t aux_1933;
	      {
		 obj_t aux_1934;
		 aux_1934 = CAR(l1337_785);
		 aux_1933 = (node_t) (aux_1934);
	      }
	      call_graph__81_effect_cgraph(aux_1933, owner_41);
	   }
	   {
	      obj_t l1337_1938;
	      l1337_1938 = CDR(l1337_785);
	      l1337_785 = l1337_1938;
	      goto lname1338_786;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
save_call__default1370_119_effect_cgraph(variable_t callee_44, variable_t owner_45)
{
   FAILURE(CNST_TABLE_REF(((long) 1)), string1719_effect_cgraph, (obj_t) (callee_44));
}


obj_t 
_save_call__default1370_252_effect_cgraph(obj_t env_1636, obj_t callee_1637, obj_t owner_1638)
{
   return save_call__default1370_119_effect_cgraph((variable_t) (callee_1637), (variable_t) (owner_1638));
}


obj_t 
save_call__133_effect_cgraph(variable_t callee_42, variable_t owner_43)
{
 save_call__133_effect_cgraph:
   {
      obj_t method1576_1194;
      obj_t class1581_1195;
      {
	 obj_t arg1584_1192;
	 obj_t arg1585_1193;
	 {
	    object_t obj_1460;
	    obj_1460 = (object_t) (callee_42);
	    {
	       obj_t pre_method_105_1461;
	       pre_method_105_1461 = PROCEDURE_REF(save_call__env_248_effect_cgraph, ((long) 2));
	       if (INTEGERP(pre_method_105_1461))
		 {
		    PROCEDURE_SET(save_call__env_248_effect_cgraph, ((long) 2), BUNSPEC);
		    arg1584_1192 = pre_method_105_1461;
		 }
	       else
		 {
		    long obj_class_num_177_1466;
		    obj_class_num_177_1466 = TYPE(obj_1460);
		    {
		       obj_t arg1183_1467;
		       arg1183_1467 = PROCEDURE_REF(save_call__env_248_effect_cgraph, ((long) 1));
		       {
			  long arg1184_1471;
			  {
			     long arg1186_1472;
			     arg1186_1472 = OBJECT_TYPE;
			     arg1184_1471 = (obj_class_num_177_1466 - arg1186_1472);
			  }
			  arg1584_1192 = VECTOR_REF(arg1183_1467, arg1184_1471);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1477;
	    object_1477 = (object_t) (callee_42);
	    {
	       long arg1187_1478;
	       {
		  long arg1188_1479;
		  long arg1189_1480;
		  arg1188_1479 = TYPE(object_1477);
		  arg1189_1480 = OBJECT_TYPE;
		  arg1187_1478 = (arg1188_1479 - arg1189_1480);
	       }
	       {
		  obj_t vector_1484;
		  vector_1484 = __classes__134___object;
		  arg1585_1193 = VECTOR_REF(vector_1484, arg1187_1478);
	       }
	    }
	 }
	 method1576_1194 = arg1584_1192;
	 class1581_1195 = arg1585_1193;
	 {
	    if (INTEGERP(method1576_1194))
	      {
		 switch ((long) CINT(method1576_1194))
		   {
		   case ((long) 0):
		      {
			 global_t callee_1201;
			 callee_1201 = (global_t) (callee_42);
			 {
			    value_t fun_1203;
			    fun_1203 = (((global_t) CREF(callee_1201))->value);
			    {
			       bool_t test1588_1204;
			       {
				  bool_t test1594_1211;
				  test1594_1211 = is_a__118___object((obj_t) (fun_1203), cfun_ast_var);
				  if (test1594_1211)
				    {
				       test1588_1204 = ((bool_t) 1);
				    }
				  else
				    {
				       bool_t _andtest_1339_1212;
				       _andtest_1339_1212 = is_a__118___object((obj_t) (fun_1203), sfun_ast_var);
				       if (_andtest_1339_1212)
					 {
					    obj_t aux_1973;
					    obj_t aux_1971;
					    aux_1973 = CNST_TABLE_REF(((long) 2));
					    aux_1971 = (((global_t) CREF(callee_1201))->import);
					    test1588_1204 = (aux_1971 == aux_1973);
					 }
				       else
					 {
					    test1588_1204 = ((bool_t) 0);
					 }
				    }
			       }
			       if (test1588_1204)
				 {
				    bool_t test_1977;
				    {
				       fun_t obj_1492;
				       obj_1492 = (fun_t) (fun_1203);
				       {
					  obj_t aux_1979;
					  aux_1979 = (((fun_t) CREF(obj_1492))->side_effect__165);
					  test_1977 = CBOOL(aux_1979);
				       }
				    }
				    if (test_1977)
				      {
					 return mark_side_effect__61_effect_cgraph(owner_43);
				      }
				    else
				      {
					 return BUNSPEC;
				      }
				 }
			       else
				 {
				    global_from_205_t arg1590_1206;
				    {
				       global_from_205_t obj1340_1207;
				       obj1340_1207 = ((global_from_205_t) (callee_1201));
				       {
					  global_from_205_t arg1591_1208;
					  {
					     global_from_205_t res1704_1496;
					     {
						global_from_205_t new1294_1494;
						new1294_1494 = ((global_from_205_t) BREF(GC_MALLOC(sizeof(struct global_from_205))));
						((((global_from_205_t) CREF(new1294_1494))->from) = ((obj_t) BNIL), BUNSPEC);
						res1704_1496 = new1294_1494;
					     }
					     arg1591_1208 = res1704_1496;
					  }
					  {
					     obj_t aux_1988;
					     object_t aux_1986;
					     aux_1988 = (obj_t) (arg1591_1208);
					     aux_1986 = (object_t) (obj1340_1207);
					     OBJECT_WIDENING_SET(aux_1986, aux_1988);
					  }
				       }
				       {
					  long arg1593_1210;
					  arg1593_1210 = class_num_218___object(global_from_205_effect_cgraph);
					  {
					     obj_t obj_1497;
					     obj_1497 = (obj_t) (obj1340_1207);
					     (((obj_t) CREF(obj_1497))->header = MAKE_HEADER(arg1593_1210, 0), BUNSPEC);
					  }
				       }
				       arg1590_1206 = obj1340_1207;
				    }
				    {
				       variable_t callee_1994;
				       callee_1994 = (variable_t) (arg1590_1206);
				       callee_42 = callee_1994;
				       goto save_call__133_effect_cgraph;
				    }
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 1):
		      {
			 global_from_205_t callee_1215;
			 callee_1215 = (global_from_205_t) (callee_42);
			 {
			    bool_t test_1997;
			    {
			       obj_t aux_1998;
			       {
				  obj_t aux_1999;
				  {
				     obj_t aux_2001;
				     {
					object_t aux_2002;
					aux_2002 = (object_t) (callee_1215);
					aux_2001 = OBJECT_WIDENING(aux_2002);
				     }
				     aux_1999 = (((global_from_205_t) CREF(aux_2001))->from);
				  }
				  aux_1998 = memq___r4_pairs_and_lists_6_3((obj_t) (owner_43), aux_1999);
			       }
			       test_1997 = CBOOL(aux_1998);
			    }
			    if (test_1997)
			      {
				 return BUNSPEC;
			      }
			    else
			      {
				 obj_t arg1600_1219;
				 {
				    obj_t aux_2010;
				    obj_t aux_2008;
				    {
				       obj_t aux_2011;
				       {
					  object_t aux_2012;
					  aux_2012 = (object_t) (callee_1215);
					  aux_2011 = OBJECT_WIDENING(aux_2012);
				       }
				       aux_2010 = (((global_from_205_t) CREF(aux_2011))->from);
				    }
				    aux_2008 = (obj_t) (owner_43);
				    arg1600_1219 = MAKE_PAIR(aux_2008, aux_2010);
				 }
				 {
				    obj_t res1705_1505;
				    {
				       obj_t x_1664;
				       {
					  obj_t aux_2017;
					  {
					     object_t aux_2018;
					     aux_2018 = (object_t) (callee_1215);
					     aux_2017 = OBJECT_WIDENING(aux_2018);
					  }
					  x_1664 = ((((global_from_205_t) CREF(aux_2017))->from) = ((obj_t) arg1600_1219), BUNSPEC);
				       }
				       res1705_1505 = BUNSPEC;
				    }
				    return res1705_1505;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 2):
		      {
			 local_t callee_1222;
			 callee_1222 = (local_t) (callee_42);
			 {
			    local_from_91_t arg1604_1224;
			    {
			       local_from_91_t obj1342_1225;
			       obj1342_1225 = ((local_from_91_t) (callee_1222));
			       {
				  local_from_91_t arg1605_1226;
				  {
				     local_from_91_t res1706_1509;
				     {
					local_from_91_t new1273_1507;
					new1273_1507 = ((local_from_91_t) BREF(GC_MALLOC(sizeof(struct local_from_91))));
					((((local_from_91_t) CREF(new1273_1507))->from) = ((obj_t) BNIL), BUNSPEC);
					res1706_1509 = new1273_1507;
				     }
				     arg1605_1226 = res1706_1509;
				  }
				  {
				     obj_t aux_2028;
				     object_t aux_2026;
				     aux_2028 = (obj_t) (arg1605_1226);
				     aux_2026 = (object_t) (obj1342_1225);
				     OBJECT_WIDENING_SET(aux_2026, aux_2028);
				  }
			       }
			       {
				  long arg1608_1228;
				  arg1608_1228 = class_num_218___object(local_from_91_effect_cgraph);
				  {
				     obj_t obj_1510;
				     obj_1510 = (obj_t) (obj1342_1225);
				     (((obj_t) CREF(obj_1510))->header = MAKE_HEADER(arg1608_1228, 0), BUNSPEC);
				  }
			       }
			       arg1604_1224 = obj1342_1225;
			    }
			    {
			       variable_t callee_2034;
			       callee_2034 = (variable_t) (arg1604_1224);
			       callee_42 = callee_2034;
			       goto save_call__133_effect_cgraph;
			    }
			 }
		      }
		      break;
		   case ((long) 3):
		      {
			 local_from_91_t callee_1229;
			 callee_1229 = (local_from_91_t) (callee_42);
			 {
			    bool_t test_2037;
			    {
			       obj_t aux_2038;
			       {
				  obj_t aux_2039;
				  {
				     obj_t aux_2041;
				     {
					object_t aux_2042;
					aux_2042 = (object_t) (callee_1229);
					aux_2041 = OBJECT_WIDENING(aux_2042);
				     }
				     aux_2039 = (((local_from_91_t) CREF(aux_2041))->from);
				  }
				  aux_2038 = memq___r4_pairs_and_lists_6_3((obj_t) (owner_43), aux_2039);
			       }
			       test_2037 = CBOOL(aux_2038);
			    }
			    if (test_2037)
			      {
				 return BUNSPEC;
			      }
			    else
			      {
				 obj_t arg1611_1233;
				 {
				    obj_t aux_2050;
				    obj_t aux_2048;
				    {
				       obj_t aux_2051;
				       {
					  object_t aux_2052;
					  aux_2052 = (object_t) (callee_1229);
					  aux_2051 = OBJECT_WIDENING(aux_2052);
				       }
				       aux_2050 = (((local_from_91_t) CREF(aux_2051))->from);
				    }
				    aux_2048 = (obj_t) (owner_43);
				    arg1611_1233 = MAKE_PAIR(aux_2048, aux_2050);
				 }
				 {
				    obj_t res1707_1518;
				    {
				       obj_t x_1665;
				       {
					  obj_t aux_2057;
					  {
					     object_t aux_2058;
					     aux_2058 = (object_t) (callee_1229);
					     aux_2057 = OBJECT_WIDENING(aux_2058);
					  }
					  x_1665 = ((((local_from_91_t) CREF(aux_2057))->from) = ((obj_t) arg1611_1233), BUNSPEC);
				       }
				       res1707_1518 = BUNSPEC;
				    }
				    return res1707_1518;
				 }
			      }
			 }
		      }
		      break;
		   default:
		    case_else1582_189_1198:
		      if (PROCEDUREP(method1576_1194))
			{
			   return PROCEDURE_ENTRY(method1576_1194) (method1576_1194, (obj_t) (callee_42), (obj_t) (owner_43), BEOA);
			}
		      else
			{
			   obj_t fun1400_792;
			   fun1400_792 = PROCEDURE_REF(save_call__env_248_effect_cgraph, ((long) 0));
			   return PROCEDURE_ENTRY(fun1400_792) (fun1400_792, (obj_t) (callee_42), (obj_t) (owner_43), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1582_189_1198;
	      }
	 }
      }
   }
}


obj_t 
_save_call__94_effect_cgraph(obj_t env_1633, obj_t callee_1634, obj_t owner_1635)
{
   return save_call__133_effect_cgraph((variable_t) (callee_1634), (variable_t) (owner_1635));
}


obj_t 
get_var_side_effect_0_effect_cgraph()
{
   return __var_side_effect__143_effect_cgraph;
}


obj_t 
_get_var_side_effect_19_effect_cgraph(obj_t env_1641)
{
   return get_var_side_effect_0_effect_cgraph();
}


obj_t 
get_var_all_239_effect_cgraph()
{
   return __var_all__30_effect_cgraph;
}


obj_t 
_get_var_all_236_effect_cgraph(obj_t env_1642)
{
   return get_var_all_239_effect_cgraph();
}


obj_t 
mark_side_effect__61_effect_cgraph(variable_t v_54)
{
   {
      bool_t test1401_793;
      {
	 obj_t aux_2080;
	 aux_2080 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 3)), BINT(((long) 2)));
	 test1401_793 = CBOOL(aux_2080);
      }
      if (test1401_793)
	{
	   obj_t arg1403_795;
	   arg1403_795 = shape_tools_shape((obj_t) (v_54));
	   {
	      obj_t list1405_797;
	      {
		 obj_t arg1406_798;
		 {
		    obj_t arg1408_799;
		    {
		       obj_t arg1410_800;
		       {
			  obj_t aux_2088;
			  aux_2088 = BCHAR(((unsigned char) '\n'));
			  arg1410_800 = MAKE_PAIR(aux_2088, BNIL);
		       }
		       arg1408_799 = MAKE_PAIR(string1720_effect_cgraph, arg1410_800);
		    }
		    arg1406_798 = MAKE_PAIR(arg1403_795, arg1408_799);
		 }
		 list1405_797 = MAKE_PAIR(string1721_effect_cgraph, arg1406_798);
	      }
	      print_trace_107_tools_trace(list1405_797);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      value_t fun_804;
      fun_804 = (((variable_t) CREF(v_54))->value);
      {
	 bool_t test_2096;
	 {
	    fun_t obj_1522;
	    obj_1522 = (fun_t) (fun_804);
	    {
	       obj_t aux_2098;
	       aux_2098 = (((fun_t) CREF(obj_1522))->side_effect__165);
	       test_2096 = CBOOL(aux_2098);
	    }
	 }
	 if (test_2096)
	   {
	      bool_t test1416_806;
	      {
		 obj_t aux_2101;
		 aux_2101 = memq___r4_pairs_and_lists_6_3((obj_t) (v_54), __var_side_effect__143_effect_cgraph);
		 test1416_806 = CBOOL(aux_2101);
	      }
	      if (test1416_806)
		{
		   return CNST_TABLE_REF(((long) 4));
		}
	      else
		{
		   {
		      obj_t obj2_1524;
		      obj2_1524 = __var_side_effect__143_effect_cgraph;
		      {
			 obj_t aux_2107;
			 aux_2107 = (obj_t) (v_54);
			 return (__var_side_effect__143_effect_cgraph = MAKE_PAIR(aux_2107, obj2_1524),
			    BUNSPEC);
		      }
		   }
		}
	   }
	 else
	   {
	      {
		 obj_t obj2_1526;
		 obj2_1526 = __var_side_effect__143_effect_cgraph;
		 {
		    obj_t aux_2110;
		    aux_2110 = (obj_t) (v_54);
		    __var_side_effect__143_effect_cgraph = MAKE_PAIR(aux_2110, obj2_1526);
		 }
	      }
	      {
		 obj_t res1709_1529;
		 {
		    fun_t obj_1527;
		    obj_t val1063_1528;
		    obj_1527 = (fun_t) (fun_804);
		    val1063_1528 = BTRUE;
		    {
		       obj_t x_1666;
		       x_1666 = ((((fun_t) CREF(obj_1527))->side_effect__165) = ((obj_t) val1063_1528), BUNSPEC);
		       res1709_1529 = BUNSPEC;
		    }
		 }
		 return res1709_1529;
	      }
	   }
      }
   }
}


obj_t 
object_init_111_effect_cgraph()
{
   {
      obj_t arg1418_808;
      arg1418_808 = local_ast_var;
      local_from_91_effect_cgraph = add_class__117___object(CNST_TABLE_REF(((long) 5)), arg1418_808, allocate_local_from_env_235_effect_cgraph, ((long) 248), BUNSPEC);
   }
   {
      obj_t arg1426_812;
      arg1426_812 = global_ast_var;
      global_from_205_effect_cgraph = add_class__117___object(CNST_TABLE_REF(((long) 6)), arg1426_812, allocate_global_from_env_89_effect_cgraph, ((long) 28388), BUNSPEC);
   }
   {
      obj_t object__struct_global_from_23_1651;
      object__struct_global_from_23_1651 = proc1722_effect_cgraph;
      add_method__1___object(object__struct_env_210___object, global_from_205_effect_cgraph, object__struct_global_from_23_1651);
   }
   {
      obj_t struct_object__object_global_from_226_1650;
      struct_object__object_global_from_226_1650 = proc1723_effect_cgraph;
      add_method__1___object(struct_object__object_env_209___object, global_from_205_effect_cgraph, struct_object__object_global_from_226_1650);
   }
   {
      obj_t object__struct_local_from_176_1647;
      object__struct_local_from_176_1647 = proc1724_effect_cgraph;
      add_method__1___object(object__struct_env_210___object, local_from_91_effect_cgraph, object__struct_local_from_176_1647);
   }
   {
      obj_t struct_object__object_local_from_22_1643;
      struct_object__object_local_from_22_1643 = proc1725_effect_cgraph;
      return add_method__1___object(struct_object__object_env_209___object, local_from_91_effect_cgraph, struct_object__object_local_from_22_1643);
   }
}


obj_t 
struct_object__object_local_from1715_220_effect_cgraph(obj_t env_1652, obj_t o_1653, obj_t s_1654)
{
   {
      local_from_91_t o_853;
      obj_t s_854;
      {
	 local_from_91_t aux_2123;
	 o_853 = (local_from_91_t) (o_1653);
	 s_854 = s_1654;
	 {
	    {
	       obj_t old1290_857;
	       obj_t aux1291_858;
	       {
		  obj_t next_method1382_66_863;
		  next_method1382_66_863 = find_super_class_method_167___object((object_t) (o_853), struct_object__object_env_209___object, local_from_91_effect_cgraph);
		  if (PROCEDUREP(next_method1382_66_863))
		    {
		       old1290_857 = PROCEDURE_ENTRY(next_method1382_66_863) (next_method1382_66_863, (obj_t) (o_853), s_854, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1382_66_863);
		       {
			  object_t aux_2132;
			  aux_2132 = struct_object__object_93___object((object_t) (o_853), s_854);
			  old1290_857 = (obj_t) (aux_2132);
		       }
		    }
	       }
	       aux1291_858 = STRUCT_REF(s_854, ((long) 0));
	       {
		  local_from_91_t new1292_859;
		  new1292_859 = ((local_from_91_t) (old1290_857));
		  {
		     long arg1463_860;
		     arg1463_860 = class_num_218___object(local_from_91_effect_cgraph);
		     {
			obj_t obj_1578;
			obj_1578 = (obj_t) (new1292_859);
			(((obj_t) CREF(obj_1578))->header = MAKE_HEADER(arg1463_860, 0), BUNSPEC);
		     }
		  }
		  {
		     local_from_91_t arg1465_861;
		     {
			obj_t arg1466_862;
			arg1466_862 = STRUCT_REF(aux1291_858, ((long) 0));
			{
			   local_from_91_t res1711_1585;
			   {
			      local_from_91_t new1273_1583;
			      new1273_1583 = ((local_from_91_t) BREF(GC_MALLOC(sizeof(struct local_from_91))));
			      ((((local_from_91_t) CREF(new1273_1583))->from) = ((obj_t) arg1466_862), BUNSPEC);
			      res1711_1585 = new1273_1583;
			   }
			   arg1465_861 = res1711_1585;
			}
		     }
		     {
			obj_t aux_2146;
			object_t aux_2144;
			aux_2146 = (obj_t) (arg1465_861);
			aux_2144 = (object_t) (new1292_859);
			OBJECT_WIDENING_SET(aux_2144, aux_2146);
		     }
		  }
		  aux_2123 = new1292_859;
	       }
	    }
	 }
	 return (obj_t) (aux_2123);
      }
   }
}


obj_t 
object__struct_local_from1716_202_effect_cgraph(obj_t env_1655, obj_t obj1287_1656)
{
   {
      local_from_91_t obj1287_840;
      obj1287_840 = (local_from_91_t) (obj1287_1656);
      {
	 {
	    obj_t res1288_843;
	    {
	       obj_t next_method1377_204_851;
	       next_method1377_204_851 = find_super_class_method_167___object((object_t) (obj1287_840), object__struct_env_210___object, local_from_91_effect_cgraph);
	       if (PROCEDUREP(next_method1377_204_851))
		 {
		    res1288_843 = PROCEDURE_ENTRY(next_method1377_204_851) (next_method1377_204_851, (obj_t) (obj1287_840), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1377_204_851);
		    res1288_843 = object__struct_50___object((object_t) (obj1287_840));
		 }
	    }
	    {
	       obj_t aux1289_844;
	       {
		  obj_t aux_2161;
		  aux_2161 = CNST_TABLE_REF(((long) 5));
		  aux1289_844 = make_struct(aux_2161, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_2164;
		  {
		     obj_t aux_2165;
		     {
			object_t aux_2166;
			aux_2166 = (object_t) (obj1287_840);
			aux_2165 = OBJECT_WIDENING(aux_2166);
		     }
		     aux_2164 = (((local_from_91_t) CREF(aux_2165))->from);
		  }
		  STRUCT_SET(aux1289_844, ((long) 0), aux_2164);
	       }
	       STRUCT_SET(res1288_843, ((long) 0), aux1289_844);
	       {
		  obj_t aux_2172;
		  aux_2172 = STRUCT_KEY(res1288_843);
		  STRUCT_KEY_SET(aux1289_844, aux_2172);
	       }
	       {
		  obj_t aux_2175;
		  aux_2175 = CNST_TABLE_REF(((long) 5));
		  STRUCT_KEY_SET(res1288_843, aux_2175);
	       }
	       return res1288_843;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_global_from1717_97_effect_cgraph(obj_t env_1657, obj_t o_1658, obj_t s_1659)
{
   {
      global_from_205_t o_828;
      obj_t s_829;
      {
	 global_from_205_t aux_2179;
	 o_828 = (global_from_205_t) (o_1658);
	 s_829 = s_1659;
	 {
	    {
	       obj_t old1313_832;
	       obj_t aux1314_833;
	       {
		  obj_t next_method1376_247_838;
		  next_method1376_247_838 = find_super_class_method_167___object((object_t) (o_828), struct_object__object_env_209___object, global_from_205_effect_cgraph);
		  if (PROCEDUREP(next_method1376_247_838))
		    {
		       old1313_832 = PROCEDURE_ENTRY(next_method1376_247_838) (next_method1376_247_838, (obj_t) (o_828), s_829, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1376_247_838);
		       {
			  object_t aux_2188;
			  aux_2188 = struct_object__object_93___object((object_t) (o_828), s_829);
			  old1313_832 = (obj_t) (aux_2188);
		       }
		    }
	       }
	       aux1314_833 = STRUCT_REF(s_829, ((long) 0));
	       {
		  global_from_205_t new1315_834;
		  new1315_834 = ((global_from_205_t) (old1313_832));
		  {
		     long arg1447_835;
		     arg1447_835 = class_num_218___object(global_from_205_effect_cgraph);
		     {
			obj_t obj_1549;
			obj_1549 = (obj_t) (new1315_834);
			(((obj_t) CREF(obj_1549))->header = MAKE_HEADER(arg1447_835, 0), BUNSPEC);
		     }
		  }
		  {
		     global_from_205_t arg1448_836;
		     {
			obj_t arg1449_837;
			arg1449_837 = STRUCT_REF(aux1314_833, ((long) 0));
			{
			   global_from_205_t res1710_1556;
			   {
			      global_from_205_t new1294_1554;
			      new1294_1554 = ((global_from_205_t) BREF(GC_MALLOC(sizeof(struct global_from_205))));
			      ((((global_from_205_t) CREF(new1294_1554))->from) = ((obj_t) arg1449_837), BUNSPEC);
			      res1710_1556 = new1294_1554;
			   }
			   arg1448_836 = res1710_1556;
			}
		     }
		     {
			obj_t aux_2202;
			object_t aux_2200;
			aux_2202 = (obj_t) (arg1448_836);
			aux_2200 = (object_t) (new1315_834);
			OBJECT_WIDENING_SET(aux_2200, aux_2202);
		     }
		  }
		  aux_2179 = new1315_834;
	       }
	    }
	 }
	 return (obj_t) (aux_2179);
      }
   }
}


obj_t 
object__struct_global_from1718_69_effect_cgraph(obj_t env_1660, obj_t obj1310_1661)
{
   {
      global_from_205_t obj1310_815;
      obj1310_815 = (global_from_205_t) (obj1310_1661);
      {
	 {
	    obj_t res1311_818;
	    {
	       obj_t next_method1375_43_826;
	       next_method1375_43_826 = find_super_class_method_167___object((object_t) (obj1310_815), object__struct_env_210___object, global_from_205_effect_cgraph);
	       if (PROCEDUREP(next_method1375_43_826))
		 {
		    res1311_818 = PROCEDURE_ENTRY(next_method1375_43_826) (next_method1375_43_826, (obj_t) (obj1310_815), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1375_43_826);
		    res1311_818 = object__struct_50___object((object_t) (obj1310_815));
		 }
	    }
	    {
	       obj_t aux1312_819;
	       {
		  obj_t aux_2217;
		  aux_2217 = CNST_TABLE_REF(((long) 6));
		  aux1312_819 = make_struct(aux_2217, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_2220;
		  {
		     obj_t aux_2221;
		     {
			object_t aux_2222;
			aux_2222 = (object_t) (obj1310_815);
			aux_2221 = OBJECT_WIDENING(aux_2222);
		     }
		     aux_2220 = (((global_from_205_t) CREF(aux_2221))->from);
		  }
		  STRUCT_SET(aux1312_819, ((long) 0), aux_2220);
	       }
	       STRUCT_SET(res1311_818, ((long) 0), aux1312_819);
	       {
		  obj_t aux_2228;
		  aux_2228 = STRUCT_KEY(res1311_818);
		  STRUCT_KEY_SET(aux1312_819, aux_2228);
	       }
	       {
		  obj_t aux_2231;
		  aux_2231 = CNST_TABLE_REF(((long) 6));
		  STRUCT_KEY_SET(res1311_818, aux_2231);
	       }
	       return res1311_818;
	    }
	 }
      }
   }
}


global_t 
allocate_global_from_170_effect_cgraph()
{
   {
      global_t new1309_865;
      new1309_865 = ((global_t) BREF(GC_MALLOC(sizeof(struct global))));
      {
	 long arg1468_866;
	 arg1468_866 = class_num_218___object(global_from_205_effect_cgraph);
	 {
	    obj_t obj_1588;
	    obj_1588 = (obj_t) (new1309_865);
	    (((obj_t) CREF(obj_1588))->header = MAKE_HEADER(arg1468_866, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2239;
	 aux_2239 = (object_t) (new1309_865);
	 OBJECT_WIDENING_SET(aux_2239, BFALSE);
      }
      return new1309_865;
   }
}


obj_t 
_allocate_global_from_157_effect_cgraph(obj_t env_1663)
{
   {
      global_t aux_2242;
      aux_2242 = allocate_global_from_170_effect_cgraph();
      return (obj_t) (aux_2242);
   }
}


local_t 
allocate_local_from_4_effect_cgraph()
{
   {
      local_t new1285_873;
      new1285_873 = ((local_t) BREF(GC_MALLOC(sizeof(struct local))));
      {
	 long arg1472_874;
	 arg1472_874 = class_num_218___object(local_from_91_effect_cgraph);
	 {
	    obj_t obj_1592;
	    obj_1592 = (obj_t) (new1285_873);
	    (((obj_t) CREF(obj_1592))->header = MAKE_HEADER(arg1472_874, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2249;
	 aux_2249 = (object_t) (new1285_873);
	 OBJECT_WIDENING_SET(aux_2249, BFALSE);
      }
      return new1285_873;
   }
}


obj_t 
_allocate_local_from_49_effect_cgraph(obj_t env_1662)
{
   {
      local_t aux_2252;
      aux_2252 = allocate_local_from_4_effect_cgraph();
      return (obj_t) (aux_2252);
   }
}


obj_t 
imported_modules_init_94_effect_cgraph()
{
   module_initialization_70_type_type(((long) 0), "EFFECT_CGRAPH");
   module_initialization_70_ast_var(((long) 0), "EFFECT_CGRAPH");
   module_initialization_70_ast_node(((long) 0), "EFFECT_CGRAPH");
   module_initialization_70_tools_trace(((long) 0), "EFFECT_CGRAPH");
   module_initialization_70_tools_shape(((long) 0), "EFFECT_CGRAPH");
   return module_initialization_70_tools_error(((long) 0), "EFFECT_CGRAPH");
}
