/*===========================================================================*/
/*   (Effect/effect.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


static obj_t side_effect__default1273_176_effect_effect(node_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_effect_effect();
static obj_t _side_effect__default1273_199_effect_effect(obj_t, obj_t);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_effect_effect();
static obj_t cnst_init_137_effect_effect();
extern obj_t node_effect_213_ast_node;
static obj_t require_initialization_114_effect_effect = BUNSPEC;
extern obj_t var_ast_node;
static obj_t library_modules_init_112_effect_effect();
extern obj_t cast_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t _side_effect__79_effect_effect(obj_t, obj_t);
extern bool_t side_effect__165_effect_effect(node_t);
extern obj_t node_ast_node;
extern obj_t funcall_ast_node;
static obj_t __cnst[2];

DEFINE_STATIC_PROCEDURE(side_effect__default1273_env_239_effect_effect, _side_effect__default1273_199_effect_effect1442, _side_effect__default1273_199_effect_effect, 0L, 1);
DEFINE_STRING(string1430_effect_effect, string1430_effect_effect1443, "READ SIDE-EFFECT?-DEFAULT1273 ", 30);
DEFINE_STRING(string1429_effect_effect, string1429_effect_effect1444, "No method for this object", 25);
DEFINE_EXPORT_GENERIC(side_effect__env_35_effect_effect, _side_effect__79_effect_effect1445, _side_effect__79_effect_effect, 0L, 1);

obj_t 
module_initialization_70_effect_effect(long checksum_1046, char *from_1047)
{
   if (CBOOL(require_initialization_114_effect_effect))
     {
	require_initialization_114_effect_effect = BBOOL(((bool_t) 0));
	library_modules_init_112_effect_effect();
	cnst_init_137_effect_effect();
	imported_modules_init_94_effect_effect();
	toplevel_init_63_effect_effect();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_effect_effect()
{
   module_initialization_70___object(((long) 0), "EFFECT_EFFECT");
   module_initialization_70___reader(((long) 0), "EFFECT_EFFECT");
   return BUNSPEC;
}


obj_t 
cnst_init_137_effect_effect()
{
   {
      obj_t cnst_port_138_1038;
      cnst_port_138_1038 = open_input_string(string1430_effect_effect);
      {
	 long i_1039;
	 i_1039 = ((long) 1);
       loop_1040:
	 {
	    bool_t test1431_1041;
	    test1431_1041 = (i_1039 == ((long) -1));
	    if (test1431_1041)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1432_1042;
		    {
		       obj_t list1433_1043;
		       {
			  obj_t arg1440_1044;
			  arg1440_1044 = BNIL;
			  list1433_1043 = MAKE_PAIR(cnst_port_138_1038, arg1440_1044);
		       }
		       arg1432_1042 = read___reader(list1433_1043);
		    }
		    CNST_TABLE_SET(i_1039, arg1432_1042);
		 }
		 {
		    int aux_1045;
		    {
		       long aux_1063;
		       aux_1063 = (i_1039 - ((long) 1));
		       aux_1045 = (int) (aux_1063);
		    }
		    {
		       long i_1066;
		       i_1066 = (long) (aux_1045);
		       i_1039 = i_1066;
		       goto loop_1040;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_effect_effect()
{
   add_generic__110___object(side_effect__env_35_effect_effect, side_effect__default1273_env_239_effect_effect);
   add_inlined_method__244___object(side_effect__env_35_effect_effect, node_ast_node, ((long) 0));
   add_inlined_method__244___object(side_effect__env_35_effect_effect, var_ast_node, ((long) 1));
   add_inlined_method__244___object(side_effect__env_35_effect_effect, node_effect_213_ast_node, ((long) 2));
   add_inlined_method__244___object(side_effect__env_35_effect_effect, setq_ast_node, ((long) 3));
   add_inlined_method__244___object(side_effect__env_35_effect_effect, fail_ast_node, ((long) 4));
   add_inlined_method__244___object(side_effect__env_35_effect_effect, set_ex_it_116_ast_node, ((long) 5));
   add_inlined_method__244___object(side_effect__env_35_effect_effect, jump_ex_it_184_ast_node, ((long) 6));
   add_inlined_method__244___object(side_effect__env_35_effect_effect, box_set__221_ast_node, ((long) 7));
   add_inlined_method__244___object(side_effect__env_35_effect_effect, app_ly_162_ast_node, ((long) 8));
   add_inlined_method__244___object(side_effect__env_35_effect_effect, funcall_ast_node, ((long) 9));
   {
      long aux_1079;
      aux_1079 = add_inlined_method__244___object(side_effect__env_35_effect_effect, cast_ast_node, ((long) 10));
      return BINT(aux_1079);
   }
}


obj_t 
side_effect__default1273_176_effect_effect(node_t node_2)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1429_effect_effect, (obj_t) (node_2));
}


obj_t 
_side_effect__default1273_199_effect_effect(obj_t env_1036, obj_t node_1037)
{
   return side_effect__default1273_176_effect_effect((node_t) (node_1037));
}


bool_t 
side_effect__165_effect_effect(node_t node_1)
{
   {
      obj_t method1401_959;
      obj_t class1406_960;
      {
	 obj_t arg1410_957;
	 obj_t arg1411_958;
	 {
	    object_t obj_999;
	    obj_999 = (object_t) (node_1);
	    {
	       obj_t pre_method_105_1000;
	       pre_method_105_1000 = PROCEDURE_REF(side_effect__env_35_effect_effect, ((long) 2));
	       if (INTEGERP(pre_method_105_1000))
		 {
		    PROCEDURE_SET(side_effect__env_35_effect_effect, ((long) 2), BUNSPEC);
		    arg1410_957 = pre_method_105_1000;
		 }
	       else
		 {
		    long obj_class_num_177_1005;
		    obj_class_num_177_1005 = TYPE(obj_999);
		    {
		       obj_t arg1183_1006;
		       arg1183_1006 = PROCEDURE_REF(side_effect__env_35_effect_effect, ((long) 1));
		       {
			  long arg1184_1010;
			  {
			     long arg1186_1011;
			     arg1186_1011 = OBJECT_TYPE;
			     arg1184_1010 = (obj_class_num_177_1005 - arg1186_1011);
			  }
			  arg1410_957 = VECTOR_REF(arg1183_1006, arg1184_1010);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1016;
	    object_1016 = (object_t) (node_1);
	    {
	       long arg1187_1017;
	       {
		  long arg1188_1018;
		  long arg1189_1019;
		  arg1188_1018 = TYPE(object_1016);
		  arg1189_1019 = OBJECT_TYPE;
		  arg1187_1017 = (arg1188_1018 - arg1189_1019);
	       }
	       {
		  obj_t vector_1023;
		  vector_1023 = __classes__134___object;
		  arg1411_958 = VECTOR_REF(vector_1023, arg1187_1017);
	       }
	    }
	 }
	 {
	    obj_t aux_1102;
	    method1401_959 = arg1410_957;
	    class1406_960 = arg1411_958;
	    {
	       if (INTEGERP(method1401_959))
		 {
		    switch ((long) CINT(method1401_959))
		      {
		      case ((long) 0):
			 aux_1102 = BFALSE;
			 break;
		      case ((long) 1):
			 {
			    var_t node_967;
			    node_967 = (var_t) (node_1);
			    {
			       bool_t test_1106;
			       {
				  obj_t aux_1110;
				  obj_t aux_1107;
				  aux_1110 = CNST_TABLE_REF(((long) 1));
				  {
				     variable_t arg1417_971;
				     arg1417_971 = (((var_t) CREF(node_967))->variable);
				     aux_1107 = (((variable_t) CREF(arg1417_971))->access);
				  }
				  test_1106 = (aux_1107 == aux_1110);
			       }
			       if (test_1106)
				 {
				    aux_1102 = BFALSE;
				 }
			       else
				 {
				    aux_1102 = BTRUE;
				 }
			    }
			 }
			 break;
		      case ((long) 2):
			 {
			    node_effect_213_t node_972;
			    node_972 = (node_effect_213_t) (node_1);
			    {
			       obj_t effect_973;
			       effect_973 = (((node_effect_213_t) CREF(node_972))->side_effect__165);
			       if (BOOLEANP(effect_973))
				 {
				    aux_1102 = effect_973;
				 }
			       else
				 {
				    aux_1102 = BTRUE;
				 }
			    }
			 }
			 break;
		      case ((long) 3):
			 aux_1102 = BTRUE;
			 break;
		      case ((long) 4):
			 aux_1102 = BTRUE;
			 break;
		      case ((long) 5):
			 aux_1102 = BTRUE;
			 break;
		      case ((long) 6):
			 aux_1102 = BTRUE;
			 break;
		      case ((long) 7):
			 aux_1102 = BTRUE;
			 break;
		      case ((long) 8):
			 aux_1102 = BTRUE;
			 break;
		      case ((long) 9):
			 aux_1102 = BTRUE;
			 break;
		      case ((long) 10):
			 {
			    cast_t node_982;
			    node_982 = (cast_t) (node_1);
			    {
			       bool_t aux_1118;
			       aux_1118 = side_effect__165_effect_effect((((cast_t) CREF(node_982))->arg));
			       aux_1102 = BBOOL(aux_1118);
			    }
			 }
			 break;
		      default:
		       case_else1407_169_963:
			 if (PROCEDUREP(method1401_959))
			   {
			      aux_1102 = PROCEDURE_ENTRY(method1401_959) (method1401_959, (obj_t) (node_1), BEOA);
			   }
			 else
			   {
			      obj_t fun1289_645;
			      fun1289_645 = PROCEDURE_REF(side_effect__env_35_effect_effect, ((long) 0));
			      aux_1102 = PROCEDURE_ENTRY(fun1289_645) (fun1289_645, (obj_t) (node_1), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1407_169_963;
		 }
	    }
	    return CBOOL(aux_1102);
	 }
      }
   }
}


obj_t 
_side_effect__79_effect_effect(obj_t env_1034, obj_t node_1035)
{
   {
      bool_t aux_1134;
      aux_1134 = side_effect__165_effect_effect((node_t) (node_1035));
      return BBOOL(aux_1134);
   }
}


obj_t 
imported_modules_init_94_effect_effect()
{
   module_initialization_70_type_type(((long) 0), "EFFECT_EFFECT");
   module_initialization_70_ast_var(((long) 0), "EFFECT_EFFECT");
   return module_initialization_70_ast_node(((long) 0), "EFFECT_EFFECT");
}
