/*===========================================================================*/
/*   (Effect/spread.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t let_fun_218_ast_node;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_effect_spread();
extern obj_t module_initialization_70_effect_spread(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_effect_spread();
static obj_t cnst_init_137_effect_spread();
static obj_t require_initialization_114_effect_spread = BUNSPEC;
extern obj_t var_ast_node;
static obj_t library_modules_init_112_effect_spread();
extern obj_t _spread_side_effect__127_effect_spread(obj_t, obj_t);
extern obj_t cast_ast_node;
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
static bool_t spread_side_effect___103_effect_spread(obj_t);
extern obj_t pragma_ast_node;
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t setq_ast_node;
static bool_t spread_side_effect__default1299_221_effect_spread(node_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
static obj_t _spread_side_effect__default1299_48_effect_spread(obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t make_box_202_ast_node;
extern bool_t spread_side_effect__136_effect_spread(node_t);
extern obj_t app_ast_node;
static obj_t __cnst[1];

DEFINE_STRING(string1550_effect_spread, string1550_effect_spread1556, "READ ", 5);
DEFINE_EXPORT_GENERIC(spread_side_effect__env_137_effect_spread, _spread_side_effect__127_effect_spread1557, _spread_side_effect__127_effect_spread, 0L, 1);
DEFINE_STATIC_PROCEDURE(spread_side_effect__default1299_env_4_effect_spread, _spread_side_effect__default1299_48_effect_spread1558, _spread_side_effect__default1299_48_effect_spread, 0L, 1);

obj_t 
module_initialization_70_effect_spread(long checksum_1224, char *from_1225)
{
   if (CBOOL(require_initialization_114_effect_spread))
     {
	require_initialization_114_effect_spread = BBOOL(((bool_t) 0));
	library_modules_init_112_effect_spread();
	cnst_init_137_effect_spread();
	imported_modules_init_94_effect_spread();
	toplevel_init_63_effect_spread();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_effect_spread()
{
   module_initialization_70___object(((long) 0), "EFFECT_SPREAD");
   module_initialization_70___reader(((long) 0), "EFFECT_SPREAD");
   return BUNSPEC;
}


obj_t 
cnst_init_137_effect_spread()
{
   {
      obj_t cnst_port_138_1216;
      cnst_port_138_1216 = open_input_string(string1550_effect_spread);
      {
	 long i_1217;
	 i_1217 = ((long) 0);
       loop_1218:
	 {
	    bool_t test1551_1219;
	    test1551_1219 = (i_1217 == ((long) -1));
	    if (test1551_1219)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1552_1220;
		    {
		       obj_t list1553_1221;
		       {
			  obj_t arg1554_1222;
			  arg1554_1222 = BNIL;
			  list1553_1221 = MAKE_PAIR(cnst_port_138_1216, arg1554_1222);
		       }
		       arg1552_1220 = read___reader(list1553_1221);
		    }
		    CNST_TABLE_SET(i_1217, arg1552_1220);
		 }
		 {
		    int aux_1223;
		    {
		       long aux_1241;
		       aux_1241 = (i_1217 - ((long) 1));
		       aux_1223 = (int) (aux_1241);
		    }
		    {
		       long i_1244;
		       i_1244 = (long) (aux_1223);
		       i_1217 = i_1244;
		       goto loop_1218;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_effect_spread()
{
   add_generic__110___object(spread_side_effect__env_137_effect_spread, spread_side_effect__default1299_env_4_effect_spread);
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, var_ast_node, ((long) 0));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, sequence_ast_node, ((long) 1));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, app_ast_node, ((long) 2));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, app_ly_162_ast_node, ((long) 3));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, funcall_ast_node, ((long) 4));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, pragma_ast_node, ((long) 5));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, cast_ast_node, ((long) 6));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, setq_ast_node, ((long) 7));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, conditional_ast_node, ((long) 8));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, fail_ast_node, ((long) 9));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, select_ast_node, ((long) 10));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, let_fun_218_ast_node, ((long) 11));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, let_var_6_ast_node, ((long) 12));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, set_ex_it_116_ast_node, ((long) 13));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, jump_ex_it_184_ast_node, ((long) 14));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, make_box_202_ast_node, ((long) 15));
   add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, box_set__221_ast_node, ((long) 16));
   {
      long aux_1264;
      aux_1264 = add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, box_ref_242_ast_node, ((long) 17));
      return BINT(aux_1264);
   }
}


bool_t 
spread_side_effect__default1299_221_effect_spread(node_t node_2)
{
   return ((bool_t) 0);
}


obj_t 
_spread_side_effect__default1299_48_effect_spread(obj_t env_1206, obj_t node_1207)
{
   {
      bool_t aux_1267;
      aux_1267 = spread_side_effect__default1299_221_effect_spread((node_t) (node_1207));
      return BBOOL(aux_1267);
   }
}


bool_t 
spread_side_effect__136_effect_spread(node_t node_1)
{
   {
      obj_t method1447_973;
      obj_t class1452_974;
      {
	 obj_t arg1457_971;
	 obj_t arg1458_972;
	 {
	    object_t obj_1100;
	    obj_1100 = (object_t) (node_1);
	    {
	       obj_t pre_method_105_1101;
	       pre_method_105_1101 = PROCEDURE_REF(spread_side_effect__env_137_effect_spread, ((long) 2));
	       if (INTEGERP(pre_method_105_1101))
		 {
		    PROCEDURE_SET(spread_side_effect__env_137_effect_spread, ((long) 2), BUNSPEC);
		    arg1457_971 = pre_method_105_1101;
		 }
	       else
		 {
		    long obj_class_num_177_1106;
		    obj_class_num_177_1106 = TYPE(obj_1100);
		    {
		       obj_t arg1183_1107;
		       arg1183_1107 = PROCEDURE_REF(spread_side_effect__env_137_effect_spread, ((long) 1));
		       {
			  long arg1184_1111;
			  {
			     long arg1186_1112;
			     arg1186_1112 = OBJECT_TYPE;
			     arg1184_1111 = (obj_class_num_177_1106 - arg1186_1112);
			  }
			  arg1457_971 = VECTOR_REF(arg1183_1107, arg1184_1111);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1117;
	    object_1117 = (object_t) (node_1);
	    {
	       long arg1187_1118;
	       {
		  long arg1188_1119;
		  long arg1189_1120;
		  arg1188_1119 = TYPE(object_1117);
		  arg1189_1120 = OBJECT_TYPE;
		  arg1187_1118 = (arg1188_1119 - arg1189_1120);
	       }
	       {
		  obj_t vector_1124;
		  vector_1124 = __classes__134___object;
		  arg1458_972 = VECTOR_REF(vector_1124, arg1187_1118);
	       }
	    }
	 }
	 {
	    obj_t aux_1286;
	    method1447_973 = arg1457_971;
	    class1452_974 = arg1458_972;
	    {
	       if (INTEGERP(method1447_973))
		 {
		    switch ((long) CINT(method1447_973))
		      {
		      case ((long) 0):
			 {
			    var_t node_980;
			    node_980 = (var_t) (node_1);
			    {
			       bool_t test_1290;
			       {
				  obj_t aux_1294;
				  obj_t aux_1291;
				  aux_1294 = CNST_TABLE_REF(((long) 0));
				  {
				     variable_t arg1466_984;
				     arg1466_984 = (((var_t) CREF(node_980))->variable);
				     aux_1291 = (((variable_t) CREF(arg1466_984))->access);
				  }
				  test_1290 = (aux_1291 == aux_1294);
			       }
			       if (test_1290)
				 {
				    aux_1286 = BFALSE;
				 }
			       else
				 {
				    aux_1286 = BTRUE;
				 }
			    }
			 }
			 break;
		      case ((long) 1):
			 {
			    sequence_t node_985;
			    node_985 = (sequence_t) (node_1);
			    {
			       bool_t res_986;
			       res_986 = spread_side_effect___103_effect_spread((((sequence_t) CREF(node_985))->nodes));
			       {
				  obj_t res1541_1133;
				  {
				     obj_t val1148_1132;
				     val1148_1132 = BBOOL(res_986);
				     {
					obj_t x_1208;
					x_1208 = ((((sequence_t) CREF(node_985))->side_effect__165) = ((obj_t) val1148_1132), BUNSPEC);
					res1541_1133 = BUNSPEC;
				     }
				  }
				  res1541_1133;
			       }
			       aux_1286 = BBOOL(res_986);
			    }
			 }
			 break;
		      case ((long) 2):
			 {
			    app_t node_988;
			    node_988 = (app_t) (node_1);
			    {
			       obj_t res_990;
			       {
				  bool_t _ortest_1273_991;
				  _ortest_1273_991 = spread_side_effect___103_effect_spread((((app_t) CREF(node_988))->args));
				  if (_ortest_1273_991)
				    {
				       res_990 = BBOOL(_ortest_1273_991);
				    }
				  else
				    {
				       fun_t obj_1138;
				       {
					  value_t aux_1308;
					  {
					     variable_t arg1470_993;
					     {
						var_t arg1471_994;
						arg1471_994 = (((app_t) CREF(node_988))->fun);
						arg1470_993 = (((var_t) CREF(arg1471_994))->variable);
					     }
					     aux_1308 = (((variable_t) CREF(arg1470_993))->value);
					  }
					  obj_1138 = (fun_t) (aux_1308);
				       }
				       res_990 = (((fun_t) CREF(obj_1138))->side_effect__165);
				    }
			       }
			       {
				  obj_t res1542_1141;
				  {
				     obj_t x_1209;
				     x_1209 = ((((app_t) CREF(node_988))->side_effect__165) = ((obj_t) res_990), BUNSPEC);
				     res1542_1141 = BUNSPEC;
				  }
				  res1542_1141;
			       }
			       aux_1286 = res_990;
			    }
			 }
			 break;
		      case ((long) 3):
			 {
			    app_ly_162_t node_996;
			    node_996 = (app_ly_162_t) (node_1);
			    spread_side_effect__136_effect_spread((((app_ly_162_t) CREF(node_996))->fun));
			    spread_side_effect__136_effect_spread((((app_ly_162_t) CREF(node_996))->arg));
			    aux_1286 = BTRUE;
			 }
			 break;
		      case ((long) 4):
			 {
			    funcall_t node_1000;
			    node_1000 = (funcall_t) (node_1);
			    spread_side_effect__136_effect_spread((((funcall_t) CREF(node_1000))->fun));
			    spread_side_effect___103_effect_spread((((funcall_t) CREF(node_1000))->args));
			    aux_1286 = BTRUE;
			 }
			 break;
		      case ((long) 5):
			 {
			    pragma_t node_1004;
			    node_1004 = (pragma_t) (node_1);
			    {
			       obj_t res_1006;
			       {
				  bool_t _ortest_1277_1007;
				  _ortest_1277_1007 = spread_side_effect___103_effect_spread((((pragma_t) CREF(node_1004))->args));
				  if (_ortest_1277_1007)
				    {
				       res_1006 = BBOOL(_ortest_1277_1007);
				    }
				  else
				    {
				       res_1006 = (((pragma_t) CREF(node_1004))->side_effect__165);
				    }
			       }
			       {
				  obj_t res1543_1150;
				  {
				     obj_t x_1210;
				     x_1210 = ((((pragma_t) CREF(node_1004))->side_effect__165) = ((obj_t) res_1006), BUNSPEC);
				     res1543_1150 = BUNSPEC;
				  }
				  res1543_1150;
			       }
			       aux_1286 = res_1006;
			    }
			 }
			 break;
		      case ((long) 6):
			 {
			    cast_t node_1009;
			    node_1009 = (cast_t) (node_1);
			    {
			       bool_t aux_1333;
			       aux_1333 = spread_side_effect__136_effect_spread((((cast_t) CREF(node_1009))->arg));
			       aux_1286 = BBOOL(aux_1333);
			    }
			 }
			 break;
		      case ((long) 7):
			 {
			    setq_t node_1012;
			    node_1012 = (setq_t) (node_1);
			    spread_side_effect__136_effect_spread((((setq_t) CREF(node_1012))->value));
			    aux_1286 = BTRUE;
			 }
			 break;
		      case ((long) 8):
			 {
			    conditional_t node_1015;
			    node_1015 = (conditional_t) (node_1);
			    {
			       bool_t res_test_153_1017;
			       res_test_153_1017 = spread_side_effect__136_effect_spread((((conditional_t) CREF(node_1015))->test));
			       {
				  bool_t res_true_149_1018;
				  res_true_149_1018 = spread_side_effect__136_effect_spread((((conditional_t) CREF(node_1015))->true));
				  {
				     bool_t res_false_133_1019;
				     res_false_133_1019 = spread_side_effect__136_effect_spread((((conditional_t) CREF(node_1015))->false));
				     {
					bool_t res_1020;
					if (res_test_153_1017)
					  {
					     res_1020 = res_test_153_1017;
					  }
					else
					  {
					     if (res_true_149_1018)
					       {
						  res_1020 = res_true_149_1018;
					       }
					     else
					       {
						  res_1020 = res_false_133_1019;
					       }
					  }
					{
					   {
					      obj_t res1544_1158;
					      {
						 obj_t val1198_1157;
						 val1198_1157 = BBOOL(res_1020);
						 {
						    obj_t x_1211;
						    x_1211 = ((((conditional_t) CREF(node_1015))->side_effect__165) = ((obj_t) val1198_1157), BUNSPEC);
						    res1544_1158 = BUNSPEC;
						 }
					      }
					      res1544_1158;
					   }
					   aux_1286 = BBOOL(res_1020);
					}
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 9):
			 {
			    fail_t node_1026;
			    node_1026 = (fail_t) (node_1);
			    {
			       bool_t res_proc_202_1028;
			       res_proc_202_1028 = spread_side_effect__136_effect_spread((((fail_t) CREF(node_1026))->proc));
			       {
				  bool_t res_msg_53_1029;
				  res_msg_53_1029 = spread_side_effect__136_effect_spread((((fail_t) CREF(node_1026))->msg));
				  {
				     bool_t res_obj_160_1030;
				     res_obj_160_1030 = spread_side_effect__136_effect_spread((((fail_t) CREF(node_1026))->obj));
				     {
					aux_1286 = BTRUE;
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 10):
			 {
			    select_t node_1034;
			    node_1034 = (select_t) (node_1);
			    {
			       obj_t clauses_1036;
			       bool_t res_1037;
			       {
				  obj_t arg1494_1039;
				  bool_t arg1496_1040;
				  arg1494_1039 = (((select_t) CREF(node_1034))->clauses);
				  arg1496_1040 = spread_side_effect__136_effect_spread((((select_t) CREF(node_1034))->test));
				  {
				     bool_t aux_1363;
				     clauses_1036 = arg1494_1039;
				     res_1037 = arg1496_1040;
				   loop_1038:
				     if (NULLP(clauses_1036))
				       {
					  {
					     obj_t res1545_1167;
					     {
						obj_t val1215_1166;
						val1215_1166 = BBOOL(res_1037);
						{
						   obj_t x_1212;
						   x_1212 = ((((select_t) CREF(node_1034))->side_effect__165) = ((obj_t) val1215_1166), BUNSPEC);
						   res1545_1167 = BUNSPEC;
						}
					     }
					     res1545_1167;
					  }
					  aux_1363 = res_1037;
				       }
				     else
				       {
					  obj_t arg1499_1043;
					  bool_t arg1500_1044;
					  arg1499_1043 = CDR(clauses_1036);
					  {
					     bool_t _ortest_1285_1045;
					     {
						node_t aux_1369;
						{
						   obj_t aux_1370;
						   {
						      obj_t aux_1371;
						      aux_1371 = CAR(clauses_1036);
						      aux_1370 = CDR(aux_1371);
						   }
						   aux_1369 = (node_t) (aux_1370);
						}
						_ortest_1285_1045 = spread_side_effect__136_effect_spread(aux_1369);
					     }
					     if (_ortest_1285_1045)
					       {
						  arg1500_1044 = _ortest_1285_1045;
					       }
					     else
					       {
						  arg1500_1044 = res_1037;
					       }
					  }
					  {
					     bool_t res_1378;
					     obj_t clauses_1377;
					     clauses_1377 = arg1499_1043;
					     res_1378 = arg1500_1044;
					     res_1037 = res_1378;
					     clauses_1036 = clauses_1377;
					     goto loop_1038;
					  }
				       }
				     aux_1286 = BBOOL(aux_1363);
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 11):
			 {
			    let_fun_218_t node_1048;
			    node_1048 = (let_fun_218_t) (node_1);
			    {
			       obj_t l1287_1050;
			       l1287_1050 = (((let_fun_218_t) CREF(node_1048))->locals);
			     lname1290_1051:
			       if (PAIRP(l1287_1050))
				 {
				    {
				       node_t aux_1383;
				       {
					  obj_t aux_1384;
					  {
					     sfun_t obj_1175;
					     {
						value_t aux_1385;
						{
						   local_t obj_1174;
						   {
						      obj_t aux_1386;
						      aux_1386 = CAR(l1287_1050);
						      obj_1174 = (local_t) (aux_1386);
						   }
						   aux_1385 = (((local_t) CREF(obj_1174))->value);
						}
						obj_1175 = (sfun_t) (aux_1385);
					     }
					     aux_1384 = (((sfun_t) CREF(obj_1175))->body);
					  }
					  aux_1383 = (node_t) (aux_1384);
				       }
				       spread_side_effect__136_effect_spread(aux_1383);
				    }
				    {
				       obj_t l1287_1394;
				       l1287_1394 = CDR(l1287_1050);
				       l1287_1050 = l1287_1394;
				       goto lname1290_1051;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       bool_t res_1058;
			       res_1058 = spread_side_effect__136_effect_spread((((let_fun_218_t) CREF(node_1048))->body));
			       {
				  obj_t res1546_1180;
				  {
				     obj_t val1224_1179;
				     val1224_1179 = BBOOL(res_1058);
				     {
					obj_t x_1213;
					x_1213 = ((((let_fun_218_t) CREF(node_1048))->side_effect__165) = ((obj_t) val1224_1179), BUNSPEC);
					res1546_1180 = BUNSPEC;
				     }
				  }
				  res1546_1180;
			       }
			       aux_1286 = BBOOL(res_1058);
			    }
			 }
			 break;
		      case ((long) 12):
			 {
			    let_var_6_t node_1060;
			    node_1060 = (let_var_6_t) (node_1);
			    {
			       obj_t bdgs_1062;
			       bool_t res_1063;
			       {
				  obj_t arg1514_1065;
				  bool_t arg1517_1066;
				  arg1514_1065 = (((let_var_6_t) CREF(node_1060))->bindings);
				  arg1517_1066 = spread_side_effect__136_effect_spread((((let_var_6_t) CREF(node_1060))->body));
				  {
				     bool_t aux_1406;
				     bdgs_1062 = arg1514_1065;
				     res_1063 = arg1517_1066;
				   loop_1064:
				     if (NULLP(bdgs_1062))
				       {
					  {
					     obj_t res1547_1186;
					     {
						obj_t val1232_1185;
						val1232_1185 = BBOOL(res_1063);
						{
						   obj_t x_1214;
						   x_1214 = ((((let_var_6_t) CREF(node_1060))->side_effect__165) = ((obj_t) val1232_1185), BUNSPEC);
						   res1547_1186 = BUNSPEC;
						}
					     }
					     res1547_1186;
					  }
					  aux_1406 = res_1063;
				       }
				     else
				       {
					  obj_t arg1520_1069;
					  bool_t arg1522_1070;
					  arg1520_1069 = CDR(bdgs_1062);
					  {
					     bool_t _ortest_1292_1071;
					     {
						node_t aux_1412;
						{
						   obj_t aux_1413;
						   {
						      obj_t aux_1414;
						      aux_1414 = CAR(bdgs_1062);
						      aux_1413 = CDR(aux_1414);
						   }
						   aux_1412 = (node_t) (aux_1413);
						}
						_ortest_1292_1071 = spread_side_effect__136_effect_spread(aux_1412);
					     }
					     if (_ortest_1292_1071)
					       {
						  arg1522_1070 = _ortest_1292_1071;
					       }
					     else
					       {
						  arg1522_1070 = res_1063;
					       }
					  }
					  {
					     bool_t res_1421;
					     obj_t bdgs_1420;
					     bdgs_1420 = arg1520_1069;
					     res_1421 = arg1522_1070;
					     res_1063 = res_1421;
					     bdgs_1062 = bdgs_1420;
					     goto loop_1064;
					  }
				       }
				     aux_1286 = BBOOL(aux_1406);
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 13):
			 {
			    set_ex_it_116_t node_1074;
			    node_1074 = (set_ex_it_116_t) (node_1);
			    {
			       bool_t aux_1424;
			       aux_1424 = spread_side_effect__136_effect_spread((((set_ex_it_116_t) CREF(node_1074))->body));
			       aux_1286 = BBOOL(aux_1424);
			    }
			 }
			 break;
		      case ((long) 14):
			 {
			    jump_ex_it_184_t node_1077;
			    node_1077 = (jump_ex_it_184_t) (node_1);
			    spread_side_effect__136_effect_spread((((jump_ex_it_184_t) CREF(node_1077))->exit));
			    spread_side_effect__136_effect_spread((((jump_ex_it_184_t) CREF(node_1077))->value));
			    aux_1286 = BTRUE;
			 }
			 break;
		      case ((long) 15):
			 {
			    make_box_202_t node_1081;
			    node_1081 = (make_box_202_t) (node_1);
			    {
			       bool_t res_1083;
			       res_1083 = spread_side_effect__136_effect_spread((((make_box_202_t) CREF(node_1081))->value));
			       {
				  obj_t res1548_1196;
				  {
				     obj_t val1255_1195;
				     val1255_1195 = BBOOL(res_1083);
				     {
					obj_t x_1215;
					x_1215 = ((((make_box_202_t) CREF(node_1081))->side_effect__165) = ((obj_t) val1255_1195), BUNSPEC);
					res1548_1196 = BUNSPEC;
				     }
				  }
				  res1548_1196;
			       }
			       aux_1286 = BBOOL(res_1083);
			    }
			 }
			 break;
		      case ((long) 16):
			 {
			    box_set__221_t node_1085;
			    node_1085 = (box_set__221_t) (node_1);
			    spread_side_effect__136_effect_spread((((box_set__221_t) CREF(node_1085))->value));
			    aux_1286 = BTRUE;
			 }
			 break;
		      case ((long) 17):
			 {
			    box_ref_242_t node_1088;
			    node_1088 = (box_ref_242_t) (node_1);
			    {
			       bool_t aux_1443;
			       {
				  node_t aux_1444;
				  {
				     var_t aux_1445;
				     aux_1445 = (((box_ref_242_t) CREF(node_1088))->var);
				     aux_1444 = (node_t) (aux_1445);
				  }
				  aux_1443 = spread_side_effect__136_effect_spread(aux_1444);
			       }
			       aux_1286 = BBOOL(aux_1443);
			    }
			 }
			 break;
		      default:
		       case_else1453_88_977:
			 if (PROCEDUREP(method1447_973))
			   {
			      aux_1286 = PROCEDURE_ENTRY(method1447_973) (method1447_973, (obj_t) (node_1), BEOA);
			   }
			 else
			   {
			      obj_t fun1320_651;
			      fun1320_651 = PROCEDURE_REF(spread_side_effect__env_137_effect_spread, ((long) 0));
			      aux_1286 = PROCEDURE_ENTRY(fun1320_651) (fun1320_651, (obj_t) (node_1), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1453_88_977;
		 }
	    }
	    return CBOOL(aux_1286);
	 }
      }
   }
}


obj_t 
_spread_side_effect__127_effect_spread(obj_t env_1204, obj_t node_1205)
{
   {
      bool_t aux_1462;
      aux_1462 = spread_side_effect__136_effect_spread((node_t) (node_1205));
      return BBOOL(aux_1462);
   }
}


bool_t 
spread_side_effect___103_effect_spread(obj_t node__221_21)
{
   {
      obj_t node__221_652;
      bool_t res_653;
      node__221_652 = node__221_21;
      res_653 = ((bool_t) 0);
    loop_654:
      if (NULLP(node__221_652))
	{
	   return res_653;
	}
      else
	{
	   obj_t arg1322_656;
	   bool_t arg1323_657;
	   arg1322_656 = CDR(node__221_652);
	   {
	      bool_t _ortest_1298_658;
	      {
		 node_t aux_1469;
		 {
		    obj_t aux_1470;
		    aux_1470 = CAR(node__221_652);
		    aux_1469 = (node_t) (aux_1470);
		 }
		 _ortest_1298_658 = spread_side_effect__136_effect_spread(aux_1469);
	      }
	      if (_ortest_1298_658)
		{
		   arg1323_657 = _ortest_1298_658;
		}
	      else
		{
		   arg1323_657 = res_653;
		}
	   }
	   {
	      bool_t res_1476;
	      obj_t node__221_1475;
	      node__221_1475 = arg1322_656;
	      res_1476 = arg1323_657;
	      res_653 = res_1476;
	      node__221_652 = node__221_1475;
	      goto loop_654;
	   }
	}
   }
}


obj_t 
imported_modules_init_94_effect_spread()
{
   module_initialization_70_type_type(((long) 0), "EFFECT_SPREAD");
   module_initialization_70_ast_var(((long) 0), "EFFECT_SPREAD");
   return module_initialization_70_ast_node(((long) 0), "EFFECT_SPREAD");
}
