/*===========================================================================*/
/*   (Effect/walk.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct local_from_91
  {
     obj_t from;
  }
             *local_from_91_t;

typedef struct global_from_205
  {
     obj_t from;
  }
               *global_from_205_t;


extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t get_var_side_effect_0_effect_cgraph();
extern obj_t fun_call_graph__231_effect_cgraph(variable_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_effect_walk();
extern obj_t module_initialization_70_effect_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_effect_cgraph(long, char *);
extern obj_t module_initialization_70_effect_spread(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t cnst_init_137_effect_walk();
static obj_t require_initialization_114_effect_walk = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_effect_walk();
extern obj_t get_var_all_239_effect_cgraph();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
static obj_t iterate_to_fix_point__167_effect_walk(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t current_error_port;
extern obj_t _effect_walk__96_effect_walk(obj_t, obj_t);
extern obj_t global_from_205_effect_cgraph;
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t effect_walk__175_effect_walk(obj_t);
extern obj_t local_from_91_effect_cgraph;
extern obj_t __current_pass__25_engine_pass;
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern bool_t spread_side_effect__136_effect_spread(node_t);
static obj_t __cnst[3];

DEFINE_STRING(string1559_effect_walk, string1559_effect_walk1575, "Effect", 6);
DEFINE_STRING(string1564_effect_walk, string1564_effect_walk1576, "spread...", 9);
DEFINE_STRING(string1568_effect_walk, string1568_effect_walk1577, "failure during postlude hook", 28);
DEFINE_EXPORT_PROCEDURE(effect_walk__env_176_effect_walk, _effect_walk__96_effect_walk1578, _effect_walk__96_effect_walk, 0L, 1);
DEFINE_STRING(string1565_effect_walk, string1565_effect_walk1579, "Effect done.", 12);
DEFINE_STRING(string1566_effect_walk, string1566_effect_walk1580, " occured, ending ...", 20);
DEFINE_STRING(string1560_effect_walk, string1560_effect_walk1581, "   . ", 5);
DEFINE_STRING(string1563_effect_walk, string1563_effect_walk1582, "fix point...", 12);
DEFINE_STRING(string1567_effect_walk, string1567_effect_walk1583, " error", 6);
DEFINE_STRING(string1561_effect_walk, string1561_effect_walk1584, "failure during prelude hook", 27);
DEFINE_STRING(string1569_effect_walk, string1569_effect_walk1585, "DONE EFFECT PASS-STARTED ", 25);
DEFINE_STRING(string1562_effect_walk, string1562_effect_walk1586, "cgraph...", 9);

obj_t 
module_initialization_70_effect_walk(long checksum_1256, char *from_1257)
{
   if (CBOOL(require_initialization_114_effect_walk))
     {
	require_initialization_114_effect_walk = BBOOL(((bool_t) 0));
	library_modules_init_112_effect_walk();
	cnst_init_137_effect_walk();
	imported_modules_init_94_effect_walk();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_effect_walk()
{
   module_initialization_70___object(((long) 0), "EFFECT_WALK");
   module_initialization_70___r4_output_6_10_3(((long) 0), "EFFECT_WALK");
   module_initialization_70___reader(((long) 0), "EFFECT_WALK");
   module_initialization_70___r4_numbers_6_5(((long) 0), "EFFECT_WALK");
   return BUNSPEC;
}


obj_t 
cnst_init_137_effect_walk()
{
   {
      obj_t cnst_port_138_1248;
      cnst_port_138_1248 = open_input_string(string1569_effect_walk);
      {
	 long i_1249;
	 i_1249 = ((long) 2);
       loop_1250:
	 {
	    bool_t test1570_1251;
	    test1570_1251 = (i_1249 == ((long) -1));
	    if (test1570_1251)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1571_1252;
		    {
		       obj_t list1572_1253;
		       {
			  obj_t arg1573_1254;
			  arg1573_1254 = BNIL;
			  list1572_1253 = MAKE_PAIR(cnst_port_138_1248, arg1573_1254);
		       }
		       arg1571_1252 = read___reader(list1572_1253);
		    }
		    CNST_TABLE_SET(i_1249, arg1571_1252);
		 }
		 {
		    int aux_1255;
		    {
		       long aux_1274;
		       aux_1274 = (i_1249 - ((long) 1));
		       aux_1255 = (int) (aux_1274);
		    }
		    {
		       long i_1277;
		       i_1277 = (long) (aux_1255);
		       i_1249 = i_1277;
		       goto loop_1250;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
effect_walk__175_effect_walk(obj_t globals_1)
{
   {
      obj_t list1312_724;
      {
	 obj_t arg1314_726;
	 {
	    obj_t arg1316_728;
	    {
	       obj_t aux_1279;
	       aux_1279 = BCHAR(((unsigned char) '\n'));
	       arg1316_728 = MAKE_PAIR(aux_1279, BNIL);
	    }
	    arg1314_726 = MAKE_PAIR(string1559_effect_walk, arg1316_728);
	 }
	 list1312_724 = MAKE_PAIR(string1560_effect_walk, arg1314_726);
      }
      verbose_tools_speek(BINT(((long) 1)), list1312_724);
   }
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   __current_pass__25_engine_pass = string1559_effect_walk;
   {
      obj_t hooks_730;
      obj_t hnames_731;
      hooks_730 = BNIL;
      hnames_731 = BNIL;
    loop_732:
      if (NULLP(hooks_730))
	{
	   CNST_TABLE_REF(((long) 0));
	}
      else
	{
	   bool_t test1323_737;
	   {
	      obj_t fun1333_743;
	      fun1333_743 = CAR(hooks_730);
	      {
		 obj_t aux_1291;
		 aux_1291 = PROCEDURE_ENTRY(fun1333_743) (fun1333_743, BEOA);
		 test1323_737 = CBOOL(aux_1291);
	      }
	   }
	   if (test1323_737)
	     {
		{
		   obj_t hnames_1298;
		   obj_t hooks_1296;
		   hooks_1296 = CDR(hooks_730);
		   hnames_1298 = CDR(hnames_731);
		   hnames_731 = hnames_1298;
		   hooks_730 = hooks_1296;
		   goto loop_732;
		}
	     }
	   else
	     {
		internal_error_43_tools_error(string1559_effect_walk, string1561_effect_walk, CAR(hnames_731));
	     }
	}
   }
   {
      bool_t test1334_744;
      {
	 obj_t aux_1302;
	 aux_1302 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
	 test1334_744 = CBOOL(aux_1302);
      }
      if (test1334_744)
	{
	   obj_t list1335_745;
	   {
	      obj_t arg1339_747;
	      {
		 obj_t aux_1308;
		 aux_1308 = BCHAR(((unsigned char) '\n'));
		 arg1339_747 = MAKE_PAIR(aux_1308, BNIL);
	      }
	      list1335_745 = MAKE_PAIR(string1562_effect_walk, arg1339_747);
	   }
	   print_trace_107_tools_trace(list1335_745);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t l1303_751;
      l1303_751 = globals_1;
    lname1304_752:
      if (PAIRP(l1303_751))
	{
	   {
	      variable_t aux_1315;
	      {
		 obj_t aux_1316;
		 aux_1316 = CAR(l1303_751);
		 aux_1315 = (variable_t) (aux_1316);
	      }
	      fun_call_graph__231_effect_cgraph(aux_1315);
	   }
	   {
	      obj_t l1303_1320;
	      l1303_1320 = CDR(l1303_751);
	      l1303_751 = l1303_1320;
	      goto lname1304_752;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      bool_t test1346_756;
      {
	 obj_t aux_1322;
	 aux_1322 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
	 test1346_756 = CBOOL(aux_1322);
      }
      if (test1346_756)
	{
	   obj_t list1347_757;
	   {
	      obj_t arg1350_759;
	      {
		 obj_t aux_1328;
		 aux_1328 = BCHAR(((unsigned char) '\n'));
		 arg1350_759 = MAKE_PAIR(aux_1328, BNIL);
	      }
	      list1347_757 = MAKE_PAIR(string1563_effect_walk, arg1350_759);
	   }
	   print_trace_107_tools_trace(list1347_757);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t arg1356_763;
      arg1356_763 = get_var_side_effect_0_effect_cgraph();
      iterate_to_fix_point__167_effect_walk(arg1356_763);
   }
   {
      obj_t l1305_764;
      {
	 obj_t arg1357_766;
	 arg1357_766 = get_var_all_239_effect_cgraph();
	 l1305_764 = arg1357_766;
       lname1307_765:
	 if (PAIRP(l1305_764))
	   {
	      {
		 value_t fun_769;
		 {
		    variable_t obj_1170;
		    {
		       obj_t aux_1338;
		       aux_1338 = CAR(l1305_764);
		       obj_1170 = (variable_t) (aux_1338);
		    }
		    fun_769 = (((variable_t) CREF(obj_1170))->value);
		 }
		 {
		    bool_t test_1342;
		    {
		       obj_t aux_1343;
		       {
			  fun_t obj_1171;
			  obj_1171 = (fun_t) (fun_769);
			  aux_1343 = (((fun_t) CREF(obj_1171))->side_effect__165);
		       }
		       test_1342 = (aux_1343 == BUNSPEC);
		    }
		    if (test_1342)
		      {
			 obj_t res1556_1176;
			 {
			    fun_t obj_1174;
			    obj_t val1063_1175;
			    obj_1174 = (fun_t) (fun_769);
			    val1063_1175 = BFALSE;
			    {
			       obj_t x_1246;
			       x_1246 = ((((fun_t) CREF(obj_1174))->side_effect__165) = ((obj_t) val1063_1175), BUNSPEC);
			       res1556_1176 = BUNSPEC;
			    }
			 }
			 res1556_1176;
		      }
		    else
		      {
			 BUNSPEC;
		      }
		 }
	      }
	      {
		 obj_t l1305_1349;
		 l1305_1349 = CDR(l1305_764);
		 l1305_764 = l1305_1349;
		 goto lname1307_765;
	      }
	   }
	 else
	   {
	      ((bool_t) 1);
	   }
      }
   }
   {
      bool_t test1364_773;
      {
	 obj_t aux_1351;
	 aux_1351 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
	 test1364_773 = CBOOL(aux_1351);
      }
      if (test1364_773)
	{
	   obj_t list1365_774;
	   {
	      obj_t arg1367_776;
	      {
		 obj_t aux_1357;
		 aux_1357 = BCHAR(((unsigned char) '\n'));
		 arg1367_776 = MAKE_PAIR(aux_1357, BNIL);
	      }
	      list1365_774 = MAKE_PAIR(string1564_effect_walk, arg1367_776);
	   }
	   print_trace_107_tools_trace(list1365_774);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t l1308_780;
      l1308_780 = globals_1;
    lname1309_781:
      if (PAIRP(l1308_780))
	{
	   {
	      node_t aux_1364;
	      {
		 obj_t aux_1365;
		 {
		    sfun_t obj_1181;
		    {
		       value_t aux_1366;
		       {
			  global_t obj_1180;
			  {
			     obj_t aux_1367;
			     aux_1367 = CAR(l1308_780);
			     obj_1180 = (global_t) (aux_1367);
			  }
			  aux_1366 = (((global_t) CREF(obj_1180))->value);
		       }
		       obj_1181 = (sfun_t) (aux_1366);
		    }
		    aux_1365 = (((sfun_t) CREF(obj_1181))->body);
		 }
		 aux_1364 = (node_t) (aux_1365);
	      }
	      spread_side_effect__136_effect_spread(aux_1364);
	   }
	   {
	      obj_t l1308_1375;
	      l1308_1375 = CDR(l1308_780);
	      l1308_780 = l1308_1375;
	      goto lname1309_781;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      bool_t test1381_787;
      {
	 obj_t aux_1377;
	 aux_1377 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
	 test1381_787 = CBOOL(aux_1377);
      }
      if (test1381_787)
	{
	   obj_t list1382_788;
	   {
	      obj_t arg1388_790;
	      {
		 obj_t aux_1383;
		 aux_1383 = BCHAR(((unsigned char) '\n'));
		 arg1388_790 = MAKE_PAIR(aux_1383, BNIL);
	      }
	      list1382_788 = MAKE_PAIR(string1565_effect_walk, arg1388_790);
	   }
	   print_trace_107_tools_trace(list1382_788);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test1397_795;
      {
	 long n1_1183;
	 n1_1183 = (long) CINT(__nb_error_on_pass__70_tools_error);
	 test1397_795 = (n1_1183 > ((long) 0));
      }
      if (test1397_795)
	{
	   {
	      char *arg1402_798;
	      {
		 bool_t test1412_805;
		 {
		    bool_t test1413_806;
		    {
		       obj_t obj_1185;
		       obj_1185 = __nb_error_on_pass__70_tools_error;
		       test1413_806 = INTEGERP(obj_1185);
		    }
		    if (test1413_806)
		      {
			 test1412_805 = _2__206___r4_numbers_6_5(__nb_error_on_pass__70_tools_error, BINT(((long) 1)));
		      }
		    else
		      {
			 test1412_805 = ((bool_t) 0);
		      }
		 }
		 if (test1412_805)
		   {
		      arg1402_798 = "s";
		   }
		 else
		   {
		      arg1402_798 = "";
		   }
	      }
	      {
		 obj_t list1404_800;
		 {
		    obj_t arg1406_801;
		    {
		       obj_t arg1408_802;
		       {
			  obj_t arg1410_803;
			  arg1410_803 = MAKE_PAIR(string1566_effect_walk, BNIL);
			  {
			     obj_t aux_1397;
			     aux_1397 = string_to_bstring(arg1402_798);
			     arg1408_802 = MAKE_PAIR(aux_1397, arg1410_803);
			  }
		       }
		       arg1406_801 = MAKE_PAIR(string1567_effect_walk, arg1408_802);
		    }
		    list1404_800 = MAKE_PAIR(__nb_error_on_pass__70_tools_error, arg1406_801);
		 }
		 fprint___r4_output_6_10_3(current_error_port, list1404_800);
	      }
	   }
	   {
	      obj_t res1557_1187;
	      exit(((long) -1));
	      res1557_1187 = BINT(((long) -1));
	      return res1557_1187;
	   }
	}
      else
	{
	   obj_t hooks_807;
	   obj_t hnames_808;
	   hooks_807 = BNIL;
	   hnames_808 = BNIL;
	 loop_809:
	   if (NULLP(hooks_807))
	     {
		return globals_1;
	     }
	   else
	     {
		bool_t test1418_814;
		{
		   obj_t fun1427_819;
		   fun1427_819 = CAR(hooks_807);
		   {
		      obj_t aux_1408;
		      aux_1408 = PROCEDURE_ENTRY(fun1427_819) (fun1427_819, BEOA);
		      test1418_814 = CBOOL(aux_1408);
		   }
		}
		if (test1418_814)
		  {
		     {
			obj_t hnames_1415;
			obj_t hooks_1413;
			hooks_1413 = CDR(hooks_807);
			hnames_1415 = CDR(hnames_808);
			hnames_808 = hnames_1415;
			hooks_807 = hooks_1413;
			goto loop_809;
		     }
		  }
		else
		  {
		     return internal_error_43_tools_error(__current_pass__25_engine_pass, string1568_effect_walk, CAR(hnames_808));
		  }
	     }
	}
   }
}


obj_t 
_effect_walk__96_effect_walk(obj_t env_1244, obj_t globals_1245)
{
   return effect_walk__175_effect_walk(globals_1245);
}


obj_t 
iterate_to_fix_point__167_effect_walk(obj_t w_2)
{
   if (NULLP(w_2))
     {
	return CNST_TABLE_REF(((long) 2));
     }
   else
     {
	obj_t l1310_821;
	{
	   bool_t aux_1423;
	   l1310_821 = w_2;
	 lname1311_822:
	   if (PAIRP(l1310_821))
	     {
		{
		   obj_t var_824;
		   var_824 = CAR(l1310_821);
		   {
		      value_t fun_825;
		      {
			 variable_t obj_1197;
			 obj_1197 = (variable_t) (var_824);
			 fun_825 = (((variable_t) CREF(obj_1197))->value);
		      }
		      {
			 bool_t test_1429;
			 {
			    obj_t aux_1430;
			    {
			       fun_t obj_1198;
			       obj_1198 = (fun_t) (fun_825);
			       aux_1430 = (((fun_t) CREF(obj_1198))->side_effect__165);
			    }
			    test_1429 = (aux_1430 == BTRUE);
			 }
			 if (test_1429)
			   {
			      BUNSPEC;
			   }
			 else
			   {
			      {
				 obj_t res1558_1203;
				 {
				    fun_t obj_1201;
				    obj_t val1063_1202;
				    obj_1201 = (fun_t) (fun_825);
				    val1063_1202 = BTRUE;
				    {
				       obj_t x_1247;
				       x_1247 = ((((fun_t) CREF(obj_1201))->side_effect__165) = ((obj_t) val1063_1202), BUNSPEC);
				       res1558_1203 = BUNSPEC;
				    }
				 }
				 res1558_1203;
			      }
			      {
				 bool_t test1431_827;
				 test1431_827 = is_a__118___object(var_824, local_from_91_effect_cgraph);
				 if (test1431_827)
				   {
				      {
					 obj_t aux_1438;
					 {
					    local_from_91_t obj_1205;
					    obj_1205 = (local_from_91_t) (var_824);
					    {
					       obj_t aux_1440;
					       {
						  object_t aux_1441;
						  aux_1441 = (object_t) (obj_1205);
						  aux_1440 = OBJECT_WIDENING(aux_1441);
					       }
					       aux_1438 = (((local_from_91_t) CREF(aux_1440))->from);
					    }
					 }
					 iterate_to_fix_point__167_effect_walk(aux_1438);
				      }
				   }
				 else
				   {
				      bool_t test1433_829;
				      test1433_829 = is_a__118___object(var_824, global_from_205_effect_cgraph);
				      if (test1433_829)
					{
					   {
					      obj_t aux_1448;
					      {
						 global_from_205_t obj_1207;
						 obj_1207 = (global_from_205_t) (var_824);
						 {
						    obj_t aux_1450;
						    {
						       object_t aux_1451;
						       aux_1451 = (object_t) (obj_1207);
						       aux_1450 = OBJECT_WIDENING(aux_1451);
						    }
						    aux_1448 = (((global_from_205_t) CREF(aux_1450))->from);
						 }
					      }
					      iterate_to_fix_point__167_effect_walk(aux_1448);
					   }
					}
				      else
					{
					   BFALSE;
					}
				   }
			      }
			   }
		      }
		   }
		}
		{
		   obj_t l1310_1456;
		   l1310_1456 = CDR(l1310_821);
		   l1310_821 = l1310_1456;
		   goto lname1311_822;
		}
	     }
	   else
	     {
		aux_1423 = ((bool_t) 1);
	     }
	   return BBOOL(aux_1423);
	}
     }
}


obj_t 
imported_modules_init_94_effect_walk()
{
   module_initialization_70_tools_speek(((long) 0), "EFFECT_WALK");
   module_initialization_70_tools_error(((long) 0), "EFFECT_WALK");
   module_initialization_70_engine_pass(((long) 0), "EFFECT_WALK");
   module_initialization_70_tools_trace(((long) 0), "EFFECT_WALK");
   module_initialization_70_type_type(((long) 0), "EFFECT_WALK");
   module_initialization_70_ast_var(((long) 0), "EFFECT_WALK");
   module_initialization_70_ast_node(((long) 0), "EFFECT_WALK");
   module_initialization_70_effect_cgraph(((long) 0), "EFFECT_WALK");
   return module_initialization_70_effect_spread(((long) 0), "EFFECT_WALK");
}
