/*===========================================================================*/
/*   (Engine/compiler.scm)                                                   */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>
#include <signal.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;


static obj_t arg13491593_engine_compiler(obj_t);
static obj_t arg13791586_engine_compiler(obj_t);
static obj_t arg14571574_engine_compiler(obj_t);
extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t syntax_expand_units_115_expand_syntax_case_44(obj_t);
extern obj_t make_heap_12_heap_make();
extern obj_t reduce_walk__148_reduce_walk(obj_t);
static obj_t arg14451576_engine_compiler(obj_t);
extern obj_t coerce_walk__125_coerce_walk(obj_t);
static obj_t arg14261578_engine_compiler(obj_t);
extern obj_t cc_cc_cc(obj_t, bool_t);
extern obj_t exit_bigloo_229_init_main(obj_t);
static obj_t arg13531592_engine_compiler(obj_t);
extern obj_t inline_walk__185_inline_walk(obj_t, obj_t);
extern obj_t cnst_walk__13_cnst_walk(obj_t);
extern obj_t expand_units_9_expand_eps(obj_t);
extern obj_t restore_heap_59_heap_restore();
static obj_t arg13901585_engine_compiler(obj_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
extern obj_t __c_debug__136_engine_param;
extern obj_t stop_on_pass_198_engine_pass(obj_t, obj_t);
static obj_t imported_modules_init_94_engine_compiler();
extern obj_t module_initialization_70_engine_compiler(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_engine_signals(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_engine_engine(long, char *);
extern obj_t module_initialization_70_read_src(long, char *);
extern obj_t module_initialization_70_write_expanded(long, char *);
extern obj_t module_initialization_70_write_ast(long, char *);
extern obj_t module_initialization_70_read_access(long, char *);
extern obj_t module_initialization_70_heap_restore(long, char *);
extern obj_t module_initialization_70_heap_make(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_build(long, char *);
extern obj_t module_initialization_70_ast_unit(long, char *);
extern obj_t module_initialization_70_user_user(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_include(long, char *);
extern obj_t module_initialization_70_expand_syntax_case_44(long, char *);
extern obj_t module_initialization_70_expand_eps(long, char *);
extern obj_t module_initialization_70_expand_install(long, char *);
extern obj_t module_initialization_70_init_main(long, char *);
extern obj_t module_initialization_70_trace_walk(long, char *);
extern obj_t module_initialization_70_inline_walk(long, char *);
extern obj_t module_initialization_70_effect_walk(long, char *);
extern obj_t module_initialization_70_callcc_walk(long, char *);
extern obj_t module_initialization_70_fail_walk(long, char *);
extern obj_t module_initialization_70_globalize_walk(long, char *);
extern obj_t module_initialization_70_cfa_walk(long, char *);
extern obj_t module_initialization_70_cfa_tvector(long, char *);
extern obj_t module_initialization_70_integrate_walk(long, char *);
extern obj_t module_initialization_70_coerce_walk(long, char *);
extern obj_t module_initialization_70_reduce_walk(long, char *);
extern obj_t module_initialization_70_cnst_walk(long, char *);
extern obj_t module_initialization_70_cgen_walk(long, char *);
extern obj_t module_initialization_70_hgen_walk(long, char *);
extern obj_t module_initialization_70_cc_indent(long, char *);
extern obj_t module_initialization_70_cc_cc(long, char *);
extern obj_t module_initialization_70_cc_ld(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t module_initialization_70___r5_macro_4_3_init(long, char *);
extern obj_t read_access_file_42_read_access();
extern obj_t integrate_walk__134_integrate_walk(obj_t);
static obj_t toplevel_init_63_engine_compiler();
static obj_t cnst_init_137_engine_compiler();
extern obj_t __optim__89_engine_param;
static obj_t arg14081582_engine_compiler(obj_t);
extern obj_t fail_walk__172_fail_walk(obj_t);
extern obj_t __compiler_debug__134_engine_param;
static obj_t arg13451594_engine_compiler(obj_t);
static obj_t arg14151580_engine_compiler(obj_t);
extern obj_t __interpreter__140_engine_param;
static obj_t require_initialization_114_engine_compiler = BUNSPEC;
static obj_t arg14481575_engine_compiler(obj_t);
static obj_t library_modules_init_112_engine_compiler();
extern obj_t build_ast_197_ast_build(obj_t);
extern obj_t engine_engine_engine();
extern obj_t __lib_mode__85_engine_param;
static obj_t arg14001584_engine_compiler(obj_t);
extern obj_t check_types_141_type_env();
extern obj_t trace_walk__65_trace_walk(obj_t);
extern obj_t produce_module__65_module_module(obj_t);
extern obj_t read___reader(obj_t);
extern obj_t install_initial_expander_168_expand_install();
extern obj_t user_walk_92_user_user(obj_t);
static obj_t arg14031583_engine_compiler(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t write_ast_133_write_ast(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t warning___error(obj_t);
extern obj_t unit_sexp__add__71_ast_unit(obj_t, obj_t);
extern obj_t _compiler_engine_compiler(obj_t);
static obj_t arg14111581_engine_compiler(obj_t);
static obj_t arg14661573_engine_compiler(obj_t);
static obj_t arg13591590_engine_compiler(obj_t);
extern obj_t __call_cc___102_engine_param;
extern obj_t patch_vector_set__231_cfa_tvector();
extern obj_t current_error_port;
static obj_t arg14401577_engine_compiler(obj_t);
extern obj_t set_default_type__106_type_cache(type_t);
extern obj_t ld_cc_ld(obj_t, bool_t);
extern obj_t read_src_204_read_src();
extern obj_t globalize_walk__63_globalize_walk(obj_t, obj_t);
extern obj_t indent_cc_indent(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t get_toplevel_unit_32_module_include();
extern obj_t effect_walk__175_effect_walk(obj_t);
extern obj_t compiler_engine_compiler();
extern obj_t install_compiler_signals__223_engine_signals();
static obj_t arg14201579_engine_compiler(obj_t);
static obj_t arg13671588_engine_compiler(obj_t);
extern obj_t initialize_tenv__150_type_env();
extern obj_t __rest_args__8_engine_param;
extern obj_t write_expanded_48_write_expanded(obj_t);
extern obj_t hello_world_248_engine_engine();
extern obj_t __current_pass__25_engine_pass;
static obj_t arg13561591_engine_compiler(obj_t);
extern obj_t __hygien___100___r5_macro_4_3_init;
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t initialize_genv__97_ast_env();
extern obj_t callcc_walk__209_callcc_walk(obj_t);
extern obj_t __obj__252_type_cache;
extern obj_t install_type_cache__77_type_cache();
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t cfa_walk__41_cfa_walk(obj_t);
extern obj_t _hgen_walk_236_hgen_walk(obj_t);
static obj_t arg13641589_engine_compiler(obj_t);
extern obj_t __optim_unroll_loop___80_engine_param;
extern obj_t __pass__125_engine_param;
extern obj_t cgen_walk_174_cgen_walk(obj_t);
static obj_t arg13701587_engine_compiler(obj_t);
static obj_t __cnst[27];

DEFINE_STATIC_PROCEDURE(proc1603_engine_compiler, arg14481575_engine_compiler1613, arg14481575_engine_compiler, 0L, 0);
DEFINE_STRING(string1599_engine_compiler, string1599_engine_compiler1614, " error", 6);
DEFINE_STRING(string1598_engine_compiler, string1598_engine_compiler1615, " occured, ending ...", 20);
DEFINE_STRING(string1600_engine_compiler, string1600_engine_compiler1616, "failure during postlude hook", 28);
DEFINE_STRING(string1597_engine_compiler, string1597_engine_compiler1617, "Don't know what to do with arguments: ", 38);
DEFINE_STRING(string1596_engine_compiler, string1596_engine_compiler1618, "Illegal source file", 19);
extern obj_t hgen_walk_env_69_hgen_walk;
DEFINE_STATIC_PROCEDURE(proc1602_engine_compiler, arg14451576_engine_compiler1619, arg14451576_engine_compiler, 0L, 0);
DEFINE_EXPORT_PROCEDURE(compiler_env_81_engine_compiler, _compiler_engine_compiler1620, _compiler_engine_compiler, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1601_engine_compiler, arg13591590_engine_compiler1621, arg13591590_engine_compiler, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1605_engine_compiler, arg14661573_engine_compiler1622, arg14661573_engine_compiler, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1604_engine_compiler, arg14571574_engine_compiler1623, arg14571574_engine_compiler, 0L, 0);
DEFINE_STRING(string1606_engine_compiler, string1606_engine_compiler1624, "DONE CC CINDENT DISTRIB CGEN INLINE+ REDUCER CNST REDUCE COERCE INTEGRATE CFA GLOBALIZE GLOBALIZATION FAIL INLINE ALL EFFECT CALLCC TRACE MAKE-HEAP AST EXPAND SYNTAX USER HGEN (#unspecified) ", 191);
DEFINE_STRING(string1595_engine_compiler, string1595_engine_compiler1625, "Parse error", 11);

obj_t 
module_initialization_70_engine_compiler(long checksum_1284, char *from_1285)
{
   if (CBOOL(require_initialization_114_engine_compiler))
     {
	require_initialization_114_engine_compiler = BBOOL(((bool_t) 0));
	library_modules_init_112_engine_compiler();
	cnst_init_137_engine_compiler();
	imported_modules_init_94_engine_compiler();
	toplevel_init_63_engine_compiler();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_engine_compiler()
{
   module_initialization_70___r4_output_6_10_3(((long) 0), "ENGINE_COMPILER");
   module_initialization_70___reader(((long) 0), "ENGINE_COMPILER");
   module_initialization_70___error(((long) 0), "ENGINE_COMPILER");
   module_initialization_70___r5_macro_4_3_init(((long) 0), "ENGINE_COMPILER");
   module_initialization_70___r4_numbers_6_5(((long) 0), "ENGINE_COMPILER");
   return BUNSPEC;
}


obj_t 
cnst_init_137_engine_compiler()
{
   {
      obj_t cnst_port_138_1276;
      cnst_port_138_1276 = open_input_string(string1606_engine_compiler);
      {
	 long i_1277;
	 i_1277 = ((long) 26);
       loop_1278:
	 {
	    bool_t test1607_1279;
	    test1607_1279 = (i_1277 == ((long) -1));
	    if (test1607_1279)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1608_1280;
		    {
		       obj_t list1609_1281;
		       {
			  obj_t arg1611_1282;
			  arg1611_1282 = BNIL;
			  list1609_1281 = MAKE_PAIR(cnst_port_138_1276, arg1611_1282);
		       }
		       arg1608_1280 = read___reader(list1609_1281);
		    }
		    CNST_TABLE_SET(i_1277, arg1608_1280);
		 }
		 {
		    int aux_1283;
		    {
		       long aux_1304;
		       aux_1304 = (i_1277 - ((long) 1));
		       aux_1283 = (int) (aux_1304);
		    }
		    {
		       long i_1307;
		       i_1307 = (long) (aux_1283);
		       i_1277 = i_1307;
		       goto loop_1278;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_engine_compiler()
{
   return BUNSPEC;
}


obj_t 
compiler_engine_compiler()
{
   install_compiler_signals__223_engine_signals();
   {
      obj_t src_676;
      src_676 = read_src_204_read_src();
      if (CBOOL(src_676))
	{
	   if (PAIRP(src_676))
	     {
		BFALSE;
	     }
	   else
	     {
		user_error_151_tools_error(string1595_engine_compiler, string1596_engine_compiler, src_676, BNIL);
	     }
	}
      else
	{
	   __interpreter__140_engine_param = BTRUE;
	   {
	      obj_t arg1303_679;
	      arg1303_679 = engine_engine_engine();
	      exit_bigloo_229_init_main(arg1303_679);
	   }
	}
      hello_world_248_engine_engine();
      {
	 bool_t test1304_680;
	 {
	    obj_t obj_1161;
	    obj_1161 = __rest_args__8_engine_param;
	    test1304_680 = NULLP(obj_1161);
	 }
	 if (test1304_680)
	   {
	      BUNSPEC;
	   }
	 else
	   {
	      obj_t list1305_681;
	      {
		 obj_t arg1308_683;
		 arg1308_683 = MAKE_PAIR(__rest_args__8_engine_param, BNIL);
		 list1305_681 = MAKE_PAIR(string1597_engine_compiler, arg1308_683);
	      }
	      warning___error(list1305_681);
	   }
      }
      read_access_file_42_read_access();
      if (CBOOL(__lib_mode__85_engine_param))
	{
	   initialize_genv__97_ast_env();
	   initialize_tenv__150_type_env();
	}
      else
	{
	   restore_heap_59_heap_restore();
	}
      install_type_cache__77_type_cache();
      patch_vector_set__231_cfa_tvector();
      {
	 obj_t src_code_162_686;
	 src_code_162_686 = CDR(src_676);
	 {
	    obj_t units_687;
	    units_687 = produce_module__65_module_module(CAR(src_676));
	    {
	       {
		  obj_t arg1311_688;
		  obj_t arg1312_689;
		  arg1311_688 = get_toplevel_unit_32_module_include();
		  if (NULLP(src_code_162_686))
		    {
		       arg1312_689 = CNST_TABLE_REF(((long) 0));
		    }
		  else
		    {
		       arg1312_689 = src_code_162_686;
		    }
		  unit_sexp__add__71_ast_unit(arg1311_688, arg1312_689);
	       }
	       {
		  bool_t test1314_692;
		  {
		     long n1_1165;
		     n1_1165 = (long) CINT(__nb_error_on_pass__70_tools_error);
		     test1314_692 = (n1_1165 > ((long) 0));
		  }
		  if (test1314_692)
		    {
		       {
			  char *arg1318_695;
			  {
			     bool_t test1326_702;
			     {
				bool_t test1327_703;
				{
				   obj_t obj_1167;
				   obj_1167 = __nb_error_on_pass__70_tools_error;
				   test1327_703 = INTEGERP(obj_1167);
				}
				if (test1327_703)
				  {
				     test1326_702 = _2__206___r4_numbers_6_5(__nb_error_on_pass__70_tools_error, BINT(((long) 1)));
				  }
				else
				  {
				     test1326_702 = ((bool_t) 0);
				  }
			     }
			     if (test1326_702)
			       {
				  arg1318_695 = "s";
			       }
			     else
			       {
				  arg1318_695 = "";
			       }
			  }
			  {
			     obj_t list1320_697;
			     {
				obj_t arg1321_698;
				{
				   obj_t arg1322_699;
				   {
				      obj_t arg1323_700;
				      arg1323_700 = MAKE_PAIR(string1598_engine_compiler, BNIL);
				      {
					 obj_t aux_1349;
					 aux_1349 = string_to_bstring(arg1318_695);
					 arg1322_699 = MAKE_PAIR(aux_1349, arg1323_700);
				      }
				   }
				   arg1321_698 = MAKE_PAIR(string1599_engine_compiler, arg1322_699);
				}
				list1320_697 = MAKE_PAIR(__nb_error_on_pass__70_tools_error, arg1321_698);
			     }
			     fprint___r4_output_6_10_3(current_error_port, list1320_697);
			  }
		       }
		       {
			  obj_t res1572_1169;
			  exit(((long) -1));
			  res1572_1169 = BINT(((long) -1));
			  res1572_1169;
		       }
		    }
		  else
		    {
		       obj_t hooks_704;
		       obj_t hnames_705;
		       hooks_704 = BNIL;
		       hnames_705 = BNIL;
		     loop_706:
		       if (NULLP(hooks_704))
			 {
			    BUNSPEC;
			 }
		       else
			 {
			    bool_t test1332_711;
			    {
			       obj_t fun1341_716;
			       fun1341_716 = CAR(hooks_704);
			       {
				  obj_t aux_1360;
				  aux_1360 = PROCEDURE_ENTRY(fun1341_716) (fun1341_716, BEOA);
				  test1332_711 = CBOOL(aux_1360);
			       }
			    }
			    if (test1332_711)
			      {
				 {
				    obj_t hnames_1367;
				    obj_t hooks_1365;
				    hooks_1365 = CDR(hooks_704);
				    hnames_1367 = CDR(hnames_705);
				    hnames_705 = hnames_1367;
				    hooks_704 = hooks_1365;
				    goto loop_706;
				 }
			      }
			    else
			      {
				 internal_error_43_tools_error(__current_pass__25_engine_pass, string1600_engine_compiler, CAR(hnames_705));
			      }
			 }
		    }
	       }
	       check_types_141_type_env();
	       stop_on_pass_198_engine_pass(CNST_TABLE_REF(((long) 1)), hgen_walk_env_69_hgen_walk);
	       user_walk_92_user_user(units_687);
	       {
		  obj_t arg1343_718;
		  arg1343_718 = CNST_TABLE_REF(((long) 2));
		  {
		     obj_t arg1345_1219;
		     arg1345_1219 = make_fx_procedure(arg13451594_engine_compiler, ((long) 0), ((long) 1));
		     PROCEDURE_SET(arg1345_1219, ((long) 0), units_687);
		     stop_on_pass_198_engine_pass(arg1343_718, arg1345_1219);
		  }
	       }
	       if (CBOOL(__hygien___100___r5_macro_4_3_init))
		 {
		    syntax_expand_units_115_expand_syntax_case_44(units_687);
		 }
	       else
		 {
		    BUNSPEC;
		 }
	       {
		  obj_t arg1347_722;
		  arg1347_722 = CNST_TABLE_REF(((long) 3));
		  {
		     obj_t arg1349_1218;
		     arg1349_1218 = make_fx_procedure(arg13491593_engine_compiler, ((long) 0), ((long) 1));
		     PROCEDURE_SET(arg1349_1218, ((long) 0), units_687);
		     stop_on_pass_198_engine_pass(arg1347_722, arg1349_1218);
		  }
	       }
	       install_initial_expander_168_expand_install();
	       expand_units_9_expand_eps(units_687);
	       {
		  obj_t arg1352_726;
		  arg1352_726 = CNST_TABLE_REF(((long) 4));
		  {
		     obj_t arg1353_1217;
		     arg1353_1217 = make_fx_procedure(arg13531592_engine_compiler, ((long) 0), ((long) 1));
		     PROCEDURE_SET(arg1353_1217, ((long) 0), units_687);
		     stop_on_pass_198_engine_pass(arg1352_726, arg1353_1217);
		  }
	       }
	       {
		  obj_t ast_730;
		  {
		     obj_t cell_val_58_1392;
		     cell_val_58_1392 = build_ast_197_ast_build(units_687);
		     ast_730 = MAKE_CELL(cell_val_58_1392);
		  }
		  {
		     obj_t arg1355_731;
		     arg1355_731 = CNST_TABLE_REF(((long) 5));
		     {
			obj_t arg1356_1216;
			arg1356_1216 = make_fx_procedure(arg13561591_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(arg1356_1216, ((long) 0), ast_730);
			stop_on_pass_198_engine_pass(arg1355_731, arg1356_1216);
		     }
		  }
		  {
		     obj_t arg1358_735;
		     arg1358_735 = CNST_TABLE_REF(((long) 6));
		     {
			obj_t arg1359_1215;
			arg1359_1215 = proc1601_engine_compiler;
			stop_on_pass_198_engine_pass(arg1358_735, arg1359_1215);
		     }
		  }
		  {
		     bool_t test1361_739;
		     {
			bool_t test1362_740;
			{
			   obj_t obj_1176;
			   obj_1176 = __compiler_debug__134_engine_param;
			   test1362_740 = INTEGERP(obj_1176);
			}
			if (test1362_740)
			  {
			     long n1_1177;
			     n1_1177 = (long) CINT(__compiler_debug__134_engine_param);
			     test1361_739 = (n1_1177 > ((long) 2));
			  }
			else
			  {
			     test1361_739 = ((bool_t) 0);
			  }
		     }
		     if (test1361_739)
		       {
			  obj_t aux_1261;
			  aux_1261 = trace_walk__65_trace_walk(CELL_REF(ast_730));
			  CELL_SET(ast_730, aux_1261);
		       }
		     else
		       {
			  BUNSPEC;
		       }
		  }
		  {
		     obj_t arg1363_741;
		     arg1363_741 = CNST_TABLE_REF(((long) 7));
		     {
			obj_t arg1364_1214;
			arg1364_1214 = make_fx_procedure(arg13641589_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(arg1364_1214, ((long) 0), ast_730);
			stop_on_pass_198_engine_pass(arg1363_741, arg1364_1214);
		     }
		  }
		  if (CBOOL(__call_cc___102_engine_param))
		    {
		       obj_t aux_1262;
		       aux_1262 = callcc_walk__209_callcc_walk(CELL_REF(ast_730));
		       CELL_SET(ast_730, aux_1262);
		    }
		  else
		    {
		       BUNSPEC;
		    }
		  {
		     obj_t arg1366_745;
		     arg1366_745 = CNST_TABLE_REF(((long) 8));
		     {
			obj_t arg1367_1213;
			arg1367_1213 = make_fx_procedure(arg13671588_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(arg1367_1213, ((long) 0), ast_730);
			stop_on_pass_198_engine_pass(arg1366_745, arg1367_1213);
		     }
		  }
		  if (CBOOL(__optim_unroll_loop___80_engine_param))
		    {
		       {
			  obj_t aux_1263;
			  aux_1263 = effect_walk__175_effect_walk(CELL_REF(ast_730));
			  CELL_SET(ast_730, aux_1263);
		       }
		       {
			  obj_t arg1369_749;
			  arg1369_749 = CNST_TABLE_REF(((long) 9));
			  {
			     obj_t arg1370_1212;
			     arg1370_1212 = make_fx_procedure(arg13701587_engine_compiler, ((long) 0), ((long) 1));
			     PROCEDURE_SET(arg1370_1212, ((long) 0), ast_730);
			     stop_on_pass_198_engine_pass(arg1369_749, arg1370_1212);
			  }
		       }
		    }
		  else
		    {
		       BUNSPEC;
		    }
		  {
		     obj_t aux_1264;
		     aux_1264 = inline_walk__185_inline_walk(CELL_REF(ast_730), CNST_TABLE_REF(((long) 10)));
		     CELL_SET(ast_730, aux_1264);
		  }
		  {
		     obj_t arg1376_754;
		     arg1376_754 = CNST_TABLE_REF(((long) 11));
		     {
			obj_t arg1379_1211;
			arg1379_1211 = make_fx_procedure(arg13791586_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(arg1379_1211, ((long) 0), ast_730);
			stop_on_pass_198_engine_pass(arg1376_754, arg1379_1211);
		     }
		  }
		  {
		     bool_t test1381_758;
		     {
			bool_t test1382_759;
			{
			   obj_t obj_1179;
			   obj_1179 = __compiler_debug__134_engine_param;
			   test1382_759 = INTEGERP(obj_1179);
			}
			if (test1382_759)
			  {
			     bool_t test1383_760;
			     {
				long n1_1180;
				n1_1180 = (long) CINT(__compiler_debug__134_engine_param);
				test1383_760 = (n1_1180 > ((long) 0));
			     }
			     if (test1383_760)
			       {
				  long n1_1182;
				  n1_1182 = (long) CINT(__compiler_debug__134_engine_param);
				  test1381_758 = (n1_1182 <= ((long) 2));
			       }
			     else
			       {
				  test1381_758 = ((bool_t) 0);
			       }
			  }
			else
			  {
			     test1381_758 = ((bool_t) 0);
			  }
		     }
		     if (test1381_758)
		       {
			  obj_t aux_1265;
			  aux_1265 = trace_walk__65_trace_walk(CELL_REF(ast_730));
			  CELL_SET(ast_730, aux_1265);
		       }
		     else
		       {
			  BUNSPEC;
		       }
		  }
		  {
		     bool_t test1384_761;
		     {
			bool_t test1385_762;
			{
			   obj_t obj_1184;
			   obj_1184 = __compiler_debug__134_engine_param;
			   test1385_762 = INTEGERP(obj_1184);
			}
			if (test1385_762)
			  {
			     long n1_1185;
			     n1_1185 = (long) CINT(__compiler_debug__134_engine_param);
			     test1384_761 = (n1_1185 > ((long) 0));
			  }
			else
			  {
			     test1384_761 = ((bool_t) 0);
			  }
		     }
		     if (test1384_761)
		       {
			  obj_t aux_1266;
			  aux_1266 = fail_walk__172_fail_walk(CELL_REF(ast_730));
			  CELL_SET(ast_730, aux_1266);
		       }
		     else
		       {
			  BUNSPEC;
		       }
		  }
		  {
		     obj_t arg1388_763;
		     arg1388_763 = CNST_TABLE_REF(((long) 12));
		     {
			obj_t arg1390_1210;
			arg1390_1210 = make_fx_procedure(arg13901585_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(arg1390_1210, ((long) 0), ast_730);
			stop_on_pass_198_engine_pass(arg1388_763, arg1390_1210);
		     }
		  }
		  {
		     obj_t aux_1267;
		     aux_1267 = globalize_walk__63_globalize_walk(CELL_REF(ast_730), CNST_TABLE_REF(((long) 13)));
		     CELL_SET(ast_730, aux_1267);
		  }
		  {
		     obj_t arg1398_768;
		     arg1398_768 = CNST_TABLE_REF(((long) 14));
		     {
			obj_t arg1400_1209;
			arg1400_1209 = make_fx_procedure(arg14001584_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(arg1400_1209, ((long) 0), ast_730);
			stop_on_pass_198_engine_pass(arg1398_768, arg1400_1209);
		     }
		  }
		  {
		     obj_t aux_1268;
		     aux_1268 = cfa_walk__41_cfa_walk(CELL_REF(ast_730));
		     CELL_SET(ast_730, aux_1268);
		  }
		  {
		     obj_t arg1402_772;
		     arg1402_772 = CNST_TABLE_REF(((long) 15));
		     {
			obj_t arg1403_1208;
			arg1403_1208 = make_fx_procedure(arg14031583_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(arg1403_1208, ((long) 0), ast_730);
			stop_on_pass_198_engine_pass(arg1402_772, arg1403_1208);
		     }
		  }
		  set_default_type__106_type_cache((type_t) (__obj__252_type_cache));
		  {
		     obj_t aux_1269;
		     aux_1269 = integrate_walk__134_integrate_walk(CELL_REF(ast_730));
		     CELL_SET(ast_730, aux_1269);
		  }
		  {
		     obj_t arg1406_776;
		     arg1406_776 = CNST_TABLE_REF(((long) 16));
		     {
			obj_t arg1408_1207;
			arg1408_1207 = make_fx_procedure(arg14081582_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(arg1408_1207, ((long) 0), ast_730);
			stop_on_pass_198_engine_pass(arg1406_776, arg1408_1207);
		     }
		  }
		  {
		     obj_t aux_1270;
		     aux_1270 = coerce_walk__125_coerce_walk(CELL_REF(ast_730));
		     CELL_SET(ast_730, aux_1270);
		  }
		  {
		     obj_t arg1410_780;
		     arg1410_780 = CNST_TABLE_REF(((long) 17));
		     {
			obj_t arg1411_1206;
			arg1411_1206 = make_fx_procedure(arg14111581_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(arg1411_1206, ((long) 0), ast_730);
			stop_on_pass_198_engine_pass(arg1410_780, arg1411_1206);
		     }
		  }
		  {
		     bool_t test1413_784;
		     {
			long n1_1187;
			n1_1187 = (long) CINT(__optim__89_engine_param);
			test1413_784 = (n1_1187 >= ((long) 2));
		     }
		     if (test1413_784)
		       {
			  {
			     obj_t aux_1271;
			     aux_1271 = effect_walk__175_effect_walk(CELL_REF(ast_730));
			     CELL_SET(ast_730, aux_1271);
			  }
			  {
			     obj_t arg1414_785;
			     arg1414_785 = CNST_TABLE_REF(((long) 9));
			     {
				obj_t arg1415_1205;
				arg1415_1205 = make_fx_procedure(arg14151580_engine_compiler, ((long) 0), ((long) 1));
				PROCEDURE_SET(arg1415_1205, ((long) 0), ast_730);
				stop_on_pass_198_engine_pass(arg1414_785, arg1415_1205);
			     }
			  }
		       }
		     else
		       {
			  BUNSPEC;
		       }
		  }
		  {
		     bool_t test1417_789;
		     {
			long n1_1189;
			n1_1189 = (long) CINT(__optim__89_engine_param);
			test1417_789 = (n1_1189 >= ((long) 1));
		     }
		     if (test1417_789)
		       {
			  obj_t aux_1272;
			  aux_1272 = reduce_walk__148_reduce_walk(CELL_REF(ast_730));
			  CELL_SET(ast_730, aux_1272);
		       }
		     else
		       {
			  BUNSPEC;
		       }
		  }
		  {
		     obj_t arg1418_790;
		     arg1418_790 = CNST_TABLE_REF(((long) 18));
		     {
			obj_t arg1420_1204;
			arg1420_1204 = make_fx_procedure(arg14201579_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(arg1420_1204, ((long) 0), ast_730);
			stop_on_pass_198_engine_pass(arg1418_790, arg1420_1204);
		     }
		  }
		  {
		     obj_t aux_1273;
		     aux_1273 = cnst_walk__13_cnst_walk(CELL_REF(ast_730));
		     CELL_SET(ast_730, aux_1273);
		  }
		  {
		     obj_t arg1424_794;
		     arg1424_794 = CNST_TABLE_REF(((long) 19));
		     {
			obj_t arg1426_1203;
			arg1426_1203 = make_fx_procedure(arg14261578_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(arg1426_1203, ((long) 0), ast_730);
			stop_on_pass_198_engine_pass(arg1424_794, arg1426_1203);
		     }
		  }
		  {
		     bool_t test1428_798;
		     {
			long n1_1191;
			n1_1191 = (long) CINT(__optim__89_engine_param);
			test1428_798 = (n1_1191 >= ((long) 3));
		     }
		     if (test1428_798)
		       {
			  obj_t aux_1274;
			  aux_1274 = inline_walk__185_inline_walk(CELL_REF(ast_730), CNST_TABLE_REF(((long) 20)));
			  CELL_SET(ast_730, aux_1274);
		       }
		     else
		       {
			  BUNSPEC;
		       }
		  }
		  {
		     obj_t arg1432_800;
		     arg1432_800 = CNST_TABLE_REF(((long) 21));
		     {
			obj_t arg1440_1202;
			arg1440_1202 = make_fx_procedure(arg14401577_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(arg1440_1202, ((long) 0), ast_730);
			stop_on_pass_198_engine_pass(arg1432_800, arg1440_1202);
		     }
		  }
		  {
		     obj_t c_prefix_211_804;
		     c_prefix_211_804 = cgen_walk_174_cgen_walk(CELL_REF(ast_730));
		     {
			obj_t arg1444_805;
			arg1444_805 = CNST_TABLE_REF(((long) 22));
			{
			   obj_t arg1445_1201;
			   arg1445_1201 = proc1602_engine_compiler;
			   stop_on_pass_198_engine_pass(arg1444_805, arg1445_1201);
			}
		     }
		     {
			obj_t arg1447_809;
			arg1447_809 = CNST_TABLE_REF(((long) 23));
			{
			   obj_t arg1448_1200;
			   arg1448_1200 = proc1603_engine_compiler;
			   stop_on_pass_198_engine_pass(arg1447_809, arg1448_1200);
			}
		     }
		     if (STRINGP(c_prefix_211_804))
		       {
			  {
			     bool_t test1451_814;
			     {
				bool_t test1452_815;
				{
				   obj_t obj1_1194;
				   obj1_1194 = __pass__125_engine_param;
				   {
				      obj_t aux_1509;
				      aux_1509 = CNST_TABLE_REF(((long) 24));
				      test1452_815 = (obj1_1194 == aux_1509);
				   }
				}
				if (test1452_815)
				  {
				     test1451_814 = ((bool_t) 1);
				  }
				else
				  {
				     test1451_814 = CBOOL(__c_debug__136_engine_param);
				  }
			     }
			     if (test1451_814)
			       {
				  indent_cc_indent(c_prefix_211_804);
			       }
			     else
			       {
				  BUNSPEC;
			       }
			  }
			  {
			     obj_t arg1454_817;
			     arg1454_817 = CNST_TABLE_REF(((long) 24));
			     {
				obj_t arg1457_1199;
				arg1457_1199 = proc1604_engine_compiler;
				stop_on_pass_198_engine_pass(arg1454_817, arg1457_1199);
			     }
			  }
			  {
			     bool_t arg1461_821;
			     {
				bool_t test1462_822;
				{
				   obj_t obj1_1196;
				   obj1_1196 = __pass__125_engine_param;
				   {
				      obj_t aux_1518;
				      aux_1518 = CNST_TABLE_REF(((long) 25));
				      test1462_822 = (obj1_1196 == aux_1518);
				   }
				}
				if (test1462_822)
				  {
				     arg1461_821 = ((bool_t) 0);
				  }
				else
				  {
				     arg1461_821 = ((bool_t) 1);
				  }
			     }
			     cc_cc_cc(c_prefix_211_804, arg1461_821);
			  }
			  {
			     obj_t arg1465_824;
			     arg1465_824 = CNST_TABLE_REF(((long) 25));
			     {
				obj_t arg1466_1198;
				arg1466_1198 = proc1605_engine_compiler;
				stop_on_pass_198_engine_pass(arg1465_824, arg1466_1198);
			     }
			  }
			  ld_cc_ld(c_prefix_211_804, ((bool_t) 1));
		       }
		     else
		       {
			  BUNSPEC;
		       }
		     return BINT(((long) 0));
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_compiler_engine_compiler(obj_t env_1220)
{
   return compiler_engine_compiler();
}


obj_t 
arg14661573_engine_compiler(obj_t env_1221)
{
   {
      return CNST_TABLE_REF(((long) 26));
   }
}


obj_t 
arg14571574_engine_compiler(obj_t env_1222)
{
   {
      return CNST_TABLE_REF(((long) 26));
   }
}


obj_t 
arg14481575_engine_compiler(obj_t env_1223)
{
   {
      return CNST_TABLE_REF(((long) 26));
   }
}


obj_t 
arg14451576_engine_compiler(obj_t env_1224)
{
   {
      return CNST_TABLE_REF(((long) 26));
   }
}


obj_t 
arg14401577_engine_compiler(obj_t env_1225)
{
   {
      obj_t ast_1226;
      ast_1226 = PROCEDURE_REF(env_1225, ((long) 0));
      {
	 return write_ast_133_write_ast(CELL_REF(ast_1226));
      }
   }
}


obj_t 
arg14261578_engine_compiler(obj_t env_1227)
{
   {
      obj_t ast_1228;
      ast_1228 = PROCEDURE_REF(env_1227, ((long) 0));
      {
	 return write_ast_133_write_ast(CELL_REF(ast_1228));
      }
   }
}


obj_t 
arg14201579_engine_compiler(obj_t env_1229)
{
   {
      obj_t ast_1230;
      ast_1230 = PROCEDURE_REF(env_1229, ((long) 0));
      {
	 return write_ast_133_write_ast(CELL_REF(ast_1230));
      }
   }
}


obj_t 
arg14151580_engine_compiler(obj_t env_1231)
{
   {
      obj_t ast_1232;
      ast_1232 = PROCEDURE_REF(env_1231, ((long) 0));
      {
	 return write_ast_133_write_ast(CELL_REF(ast_1232));
      }
   }
}


obj_t 
arg14111581_engine_compiler(obj_t env_1233)
{
   {
      obj_t ast_1234;
      ast_1234 = PROCEDURE_REF(env_1233, ((long) 0));
      {
	 return write_ast_133_write_ast(CELL_REF(ast_1234));
      }
   }
}


obj_t 
arg14081582_engine_compiler(obj_t env_1235)
{
   {
      obj_t ast_1236;
      ast_1236 = PROCEDURE_REF(env_1235, ((long) 0));
      {
	 return write_ast_133_write_ast(CELL_REF(ast_1236));
      }
   }
}


obj_t 
arg14031583_engine_compiler(obj_t env_1237)
{
   {
      obj_t ast_1238;
      ast_1238 = PROCEDURE_REF(env_1237, ((long) 0));
      {
	 return write_ast_133_write_ast(CELL_REF(ast_1238));
      }
   }
}


obj_t 
arg14001584_engine_compiler(obj_t env_1239)
{
   {
      obj_t ast_1240;
      ast_1240 = PROCEDURE_REF(env_1239, ((long) 0));
      {
	 return write_ast_133_write_ast(CELL_REF(ast_1240));
      }
   }
}


obj_t 
arg13901585_engine_compiler(obj_t env_1241)
{
   {
      obj_t ast_1242;
      ast_1242 = PROCEDURE_REF(env_1241, ((long) 0));
      {
	 return write_ast_133_write_ast(CELL_REF(ast_1242));
      }
   }
}


obj_t 
arg13791586_engine_compiler(obj_t env_1243)
{
   {
      obj_t ast_1244;
      ast_1244 = PROCEDURE_REF(env_1243, ((long) 0));
      {
	 return write_ast_133_write_ast(CELL_REF(ast_1244));
      }
   }
}


obj_t 
arg13701587_engine_compiler(obj_t env_1245)
{
   {
      obj_t ast_1246;
      ast_1246 = PROCEDURE_REF(env_1245, ((long) 0));
      {
	 return write_ast_133_write_ast(CELL_REF(ast_1246));
      }
   }
}


obj_t 
arg13671588_engine_compiler(obj_t env_1247)
{
   {
      obj_t ast_1248;
      ast_1248 = PROCEDURE_REF(env_1247, ((long) 0));
      {
	 return write_ast_133_write_ast(CELL_REF(ast_1248));
      }
   }
}


obj_t 
arg13641589_engine_compiler(obj_t env_1249)
{
   {
      obj_t ast_1250;
      ast_1250 = PROCEDURE_REF(env_1249, ((long) 0));
      {
	 return write_ast_133_write_ast(CELL_REF(ast_1250));
      }
   }
}


obj_t 
arg13591590_engine_compiler(obj_t env_1251)
{
   {
      return make_heap_12_heap_make();
   }
}


obj_t 
arg13561591_engine_compiler(obj_t env_1252)
{
   {
      obj_t ast_1253;
      ast_1253 = PROCEDURE_REF(env_1252, ((long) 0));
      {
	 return write_ast_133_write_ast(CELL_REF(ast_1253));
      }
   }
}


obj_t 
arg13531592_engine_compiler(obj_t env_1254)
{
   {
      obj_t units_1255;
      units_1255 = PROCEDURE_REF(env_1254, ((long) 0));
      {
	 return write_expanded_48_write_expanded(units_1255);
      }
   }
}


obj_t 
arg13491593_engine_compiler(obj_t env_1256)
{
   {
      obj_t units_1257;
      units_1257 = PROCEDURE_REF(env_1256, ((long) 0));
      {
	 return write_expanded_48_write_expanded(units_1257);
      }
   }
}


obj_t 
arg13451594_engine_compiler(obj_t env_1258)
{
   {
      obj_t units_1259;
      units_1259 = PROCEDURE_REF(env_1258, ((long) 0));
      {
	 return write_expanded_48_write_expanded(units_1259);
      }
   }
}


obj_t 
imported_modules_init_94_engine_compiler()
{
   module_initialization_70_tools_speek(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_tools_error(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_engine_pass(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_engine_signals(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_engine_param(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_engine_engine(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_read_src(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_write_expanded(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_write_ast(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_read_access(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_heap_restore(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_heap_make(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_ast_env(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_type_type(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_ast_var(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_ast_node(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_ast_build(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_ast_unit(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_user_user(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_type_env(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_type_cache(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_module_module(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_module_include(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_expand_syntax_case_44(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_expand_eps(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_expand_install(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_init_main(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_trace_walk(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_inline_walk(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_effect_walk(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_callcc_walk(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_fail_walk(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_globalize_walk(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_cfa_walk(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_cfa_tvector(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_integrate_walk(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_coerce_walk(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_reduce_walk(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_cnst_walk(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_cgen_walk(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_hgen_walk(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_cc_indent(((long) 0), "ENGINE_COMPILER");
   module_initialization_70_cc_cc(((long) 0), "ENGINE_COMPILER");
   return module_initialization_70_cc_ld(((long) 0), "ENGINE_COMPILER");
}
