/*===========================================================================*/
/*   (Expand/object.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;


static obj_t duplicate__make_94_expand_object(obj_t, obj_t, obj_t, obj_t);
extern obj_t _expand_shrink__87_expand_object(obj_t, obj_t, obj_t);
static obj_t make_a_shrink__124_expand_object(obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t class_object_class;
extern obj_t expand_with_access_221_expand_object(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t replace__160_tools_misc(obj_t, obj_t);
extern obj_t normalize_progn_143_tools_progn(obj_t);
static obj_t imported_modules_init_94_expand_object();
extern obj_t module_initialization_70_expand_object(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_expand_eps(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t toplevel_init_63_expand_object();
static obj_t cnst_init_137_expand_object();
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t __unsafe_type__146_engine_param;
extern obj_t make_vector(long, obj_t);
static obj_t require_initialization_114_expand_object = BUNSPEC;
extern obj_t _expand_duplicate_242_expand_object(obj_t, obj_t, obj_t);
extern obj_t expand_widen__163_expand_object(obj_t, obj_t);
static obj_t library_modules_init_112_expand_object();
extern obj_t with_lexical_22_expand_eps(obj_t, obj_t, obj_t);
extern obj_t expand_shrink__128_expand_object(obj_t, obj_t);
extern obj_t _expand_instantiate_86_expand_object(obj_t, obj_t, obj_t);
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t _expand_widen__96_expand_object(obj_t, obj_t, obj_t);
extern obj_t parse_id_241_ast_ident(obj_t);
extern obj_t open_input_string(obj_t);
static obj_t make_widening_107_expand_object(obj_t, type_t, obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t with_access_expander_113_expand_object(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
static obj_t instantiate__make_36_expand_object(obj_t, type_t, obj_t);
extern obj_t expand_instantiate_150_expand_object(obj_t, obj_t);
extern obj_t expand_duplicate_139_expand_object(obj_t, obj_t);
extern obj_t _expand_with_access_125_expand_object(obj_t, obj_t, obj_t);
extern obj_t _4dots_tools_misc;
extern obj_t gensym___r4_symbols_6_4;
extern long list_length(obj_t);
static obj_t lambda12472273_expand_object(obj_t, obj_t, obj_t);
extern obj_t lexical_stack_189_expand_eps();
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t find_slot_offset2274_223_expand_object(obj_t, obj_t, obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t list_ref_194___r4_pairs_and_lists_6_3(obj_t, long);
static obj_t find_slot_offset_103_expand_object(obj_t, obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
static obj_t arg12092272_expand_object(obj_t);
extern type_t type_of_id_183_ast_ident(obj_t);
static obj_t find_slot_offset2275_148_expand_object(obj_t, obj_t, obj_t);
static obj_t __cnst[28];

DEFINE_EXPORT_PROCEDURE(expand_widen__env_255_expand_object, _expand_widen__96_expand_object2301, _expand_widen__96_expand_object, 0L, 2);
DEFINE_STRING(string2292_expand_object, string2292_expand_object2302, "Illegal `shrink!' form", 22);
DEFINE_STRING(string2278_expand_object, string2278_expand_object2303, "Illegal `instantiate' form (missing arguments)", 46);
DEFINE_STRING(string2285_expand_object, string2285_expand_object2304, "Illegal `widen!' form", 21);
DEFINE_STRING(string2277_expand_object, string2277_expand_object2305, "Illegal `instantiate' form", 26);
DEFINE_STRING(string2295_expand_object, string2295_expand_object2306, "OBJECT? O ERROR BEGIN OBJECT-CLASS CLASS-SUPER EQ? SHRINK! OBJECT-WIDENING IF CLASS-NUM __OBJECT OBJECT-CLASS-NUM-SET! @ OBJECT-WIDENING-SET! PRAGMA OBJ -REF NOTHING DUPLICATED MAKE- OK DONE SET! -SET! - LET INSTANCE ", 217);
DEFINE_STRING(string2288_expand_object, string2288_expand_object2307, "Illegal `widen!' form (missing arguments)", 41);
DEFINE_STRING(string2286_expand_object, string2286_expand_object2308, ")($1))", 6);
DEFINE_EXPORT_PROCEDURE(expand_shrink__env_80_expand_object, _expand_shrink__87_expand_object2309, _expand_shrink__87_expand_object, 0L, 2);
DEFINE_STRING(string2294_expand_object, string2294_expand_object2310, "shrink!", 7);
DEFINE_STRING(string2291_expand_object, string2291_expand_object2311, "Illegal `widen!' form (unknown slot ", 36);
DEFINE_STRING(string2293_expand_object, string2293_expand_object2312, "Not a wide object", 17);
DEFINE_STRING(string2282_expand_object, string2282_expand_object2313, "Illegal `duplicate' form", 24);
DEFINE_STRING(string2289_expand_object, string2289_expand_object2314, "This object can't be widened to the wanted class", 48);
DEFINE_STRING(string2287_expand_object, string2287_expand_object2315, "((", 2);
DEFINE_STRING(string2290_expand_object, string2290_expand_object2316, "widen!", 6);
DEFINE_STRING(string2279_expand_object, string2279_expand_object2317, ")", 1);
DEFINE_STRING(string2283_expand_object, string2283_expand_object2318, "Illegal `duplicate' form (unknown slot ", 39);
DEFINE_STRING(string2284_expand_object, string2284_expand_object2319, "widen!:Illegal class type:", 26);
DEFINE_STRING(string2276_expand_object, string2276_expand_object2320, "Illegal `with-access' form", 26);
DEFINE_STRING(string2281_expand_object, string2281_expand_object2321, "duplicate:Illegal class type:", 29);
DEFINE_EXPORT_PROCEDURE(expand_duplicate_env_116_expand_object, _expand_duplicate_242_expand_object2322, _expand_duplicate_242_expand_object, 0L, 2);
DEFINE_EXPORT_PROCEDURE(expand_instantiate_env_9_expand_object, _expand_instantiate_86_expand_object2323, _expand_instantiate_86_expand_object, 0L, 2);
DEFINE_STRING(string2280_expand_object, string2280_expand_object2324, "Illegal `instantiate' form (unknown slot ", 41);
DEFINE_EXPORT_PROCEDURE(expand_with_access_env_4_expand_object, _expand_with_access_125_expand_object2325, _expand_with_access_125_expand_object, 0L, 2);

obj_t 
module_initialization_70_expand_object(long checksum_2219, char *from_2220)
{
   if (CBOOL(require_initialization_114_expand_object))
     {
	require_initialization_114_expand_object = BBOOL(((bool_t) 0));
	library_modules_init_112_expand_object();
	cnst_init_137_expand_object();
	imported_modules_init_94_expand_object();
	toplevel_init_63_expand_object();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_expand_object()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "EXPAND_OBJECT");
   module_initialization_70___object(((long) 0), "EXPAND_OBJECT");
   module_initialization_70___reader(((long) 0), "EXPAND_OBJECT");
   module_initialization_70___r4_symbols_6_4(((long) 0), "EXPAND_OBJECT");
   module_initialization_70___r4_strings_6_7(((long) 0), "EXPAND_OBJECT");
   return BUNSPEC;
}


obj_t 
cnst_init_137_expand_object()
{
   {
      obj_t cnst_port_138_2211;
      cnst_port_138_2211 = open_input_string(string2295_expand_object);
      {
	 long i_2212;
	 i_2212 = ((long) 27);
       loop_2213:
	 {
	    bool_t test2296_2214;
	    test2296_2214 = (i_2212 == ((long) -1));
	    if (test2296_2214)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2297_2215;
		    {
		       obj_t list2298_2216;
		       {
			  obj_t arg2299_2217;
			  arg2299_2217 = BNIL;
			  list2298_2216 = MAKE_PAIR(cnst_port_138_2211, arg2299_2217);
		       }
		       arg2297_2215 = read___reader(list2298_2216);
		    }
		    CNST_TABLE_SET(i_2212, arg2297_2215);
		 }
		 {
		    int aux_2218;
		    {
		       long aux_2239;
		       aux_2239 = (i_2212 - ((long) 1));
		       aux_2218 = (int) (aux_2239);
		    }
		    {
		       long i_2242;
		       i_2242 = (long) (aux_2218);
		       i_2212 = i_2242;
		       goto loop_2213;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_expand_object()
{
   return BUNSPEC;
}


obj_t 
expand_with_access_221_expand_object(obj_t x_47, obj_t e_48)
{
   {
      obj_t with_access_173_439;
      obj_t instance_440;
      obj_t slots_441;
      obj_t body_442;
      if (PAIRP(x_47))
	{
	   obj_t cdr_113_28_447;
	   cdr_113_28_447 = CDR(x_47);
	   if (PAIRP(cdr_113_28_447))
	     {
		obj_t cdr_119_211_449;
		cdr_119_211_449 = CDR(cdr_113_28_447);
		if (PAIRP(cdr_119_211_449))
		  {
		     obj_t car_123_18_451;
		     car_123_18_451 = CAR(cdr_119_211_449);
		     if (PAIRP(car_123_18_451))
		       {
			  with_access_173_439 = CAR(x_47);
			  instance_440 = CAR(cdr_113_28_447);
			  slots_441 = car_123_18_451;
			  body_442 = CDR(cdr_119_211_449);
			  {
			     type_t class_456;
			     class_456 = type_of_id_183_ast_ident(with_access_173_439);
			     {
				bool_t test1206_457;
				test1206_457 = is_a__118___object((obj_t) (class_456), class_object_class);
				if (test1206_457)
				  {
				     obj_t s_458;
				     s_458 = slots_441;
				   loop_459:
				     if (NULLP(s_458))
				       {
					  {
					     obj_t aux_461;
					     aux_461 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 0)), BEOA);
					     {
						obj_t instance_463;
						instance_463 = PROCEDURE_ENTRY(e_48) (e_48, instance_440, e_48, BEOA);
						{
						   {
						      obj_t arg1208_464;
						      {
							 obj_t arg1209_2168;
							 arg1209_2168 = make_fx_procedure(arg12092272_expand_object, ((long) 0), ((long) 7));
							 {
							    obj_t aux_2267;
							    aux_2267 = (obj_t) (class_456);
							    PROCEDURE_SET(arg1209_2168, ((long) 0), aux_2267);
							 }
							 PROCEDURE_SET(arg1209_2168, ((long) 1), e_48);
							 PROCEDURE_SET(arg1209_2168, ((long) 2), aux_461);
							 PROCEDURE_SET(arg1209_2168, ((long) 3), aux_461);
							 PROCEDURE_SET(arg1209_2168, ((long) 4), slots_441);
							 PROCEDURE_SET(arg1209_2168, ((long) 5), instance_463);
							 PROCEDURE_SET(arg1209_2168, ((long) 6), body_442);
							 arg1208_464 = with_lexical_22_expand_eps(slots_441, aux_461, arg1209_2168);
						      }
						      return replace__160_tools_misc(x_47, arg1208_464);
						   }
						}
					     }
					  }
				       }
				     else
				       {
					  if (PAIRP(s_458))
					    {
					       bool_t test_2280;
					       {
						  obj_t aux_2281;
						  aux_2281 = CAR(s_458);
						  test_2280 = SYMBOLP(aux_2281);
					       }
					       if (test_2280)
						 {
						    {
						       obj_t s_2284;
						       s_2284 = CDR(s_458);
						       s_458 = s_2284;
						       goto loop_459;
						    }
						 }
					       else
						 {
						    FAILURE(BFALSE, string2276_expand_object, x_47);
						 }
					    }
					  else
					    {
					       FAILURE(BFALSE, string2276_expand_object, x_47);
					    }
				       }
				  }
				else
				  {
				     FAILURE(BFALSE, string2276_expand_object, x_47);
				  }
			     }
			  }
		       }
		     else
		       {
			tag_102_241_444:
			  FAILURE(BFALSE, string2276_expand_object, x_47);
		       }
		  }
		else
		  {
		     goto tag_102_241_444;
		  }
	     }
	   else
	     {
		goto tag_102_241_444;
	     }
	}
      else
	{
	   goto tag_102_241_444;
	}
   }
}


obj_t 
_expand_with_access_125_expand_object(obj_t env_2169, obj_t x_2170, obj_t e_2171)
{
   return expand_with_access_221_expand_object(x_2170, e_2171);
}


obj_t 
arg12092272_expand_object(obj_t env_2172)
{
   {
      obj_t class_2173;
      obj_t e_2174;
      obj_t mark_2175;
      obj_t aux_2176;
      obj_t slots_2177;
      obj_t instance_2178;
      obj_t body_2179;
      class_2173 = PROCEDURE_REF(env_2172, ((long) 0));
      e_2174 = PROCEDURE_REF(env_2172, ((long) 1));
      mark_2175 = PROCEDURE_REF(env_2172, ((long) 2));
      aux_2176 = PROCEDURE_REF(env_2172, ((long) 3));
      slots_2177 = PROCEDURE_REF(env_2172, ((long) 4));
      instance_2178 = PROCEDURE_REF(env_2172, ((long) 5));
      body_2179 = PROCEDURE_REF(env_2172, ((long) 6));
      {
	 {
	    obj_t e_467;
	    {
	       obj_t aux_2301;
	       {
		  type_t obj_1668;
		  obj_1668 = (type_t) (class_2173);
		  aux_2301 = (((type_t) CREF(obj_1668))->id);
	       }
	       e_467 = with_access_expander_113_expand_object(e_2174, mark_2175, aux_2176, aux_2301, slots_2177);
	    }
	    {
	       obj_t arg1212_468;
	       obj_t arg1213_469;
	       obj_t arg1214_470;
	       arg1212_468 = CNST_TABLE_REF(((long) 1));
	       {
		  obj_t arg1227_476;
		  {
		     obj_t list1234_481;
		     {
			obj_t arg1235_482;
			arg1235_482 = MAKE_PAIR(BNIL, BNIL);
			list1234_481 = MAKE_PAIR(instance_2178, arg1235_482);
		     }
		     arg1227_476 = cons__138___r4_pairs_and_lists_6_3(aux_2176, list1234_481);
		  }
		  {
		     obj_t list1230_478;
		     list1230_478 = MAKE_PAIR(BNIL, BNIL);
		     arg1213_469 = cons__138___r4_pairs_and_lists_6_3(arg1227_476, list1230_478);
		  }
	       }
	       {
		  obj_t arg1237_484;
		  arg1237_484 = normalize_progn_143_tools_progn(body_2179);
		  arg1214_470 = PROCEDURE_ENTRY(e_467) (e_467, arg1237_484, e_467, BEOA);
	       }
	       {
		  obj_t list1218_472;
		  {
		     obj_t arg1219_473;
		     {
			obj_t arg1222_474;
			arg1222_474 = MAKE_PAIR(BNIL, BNIL);
			arg1219_473 = MAKE_PAIR(arg1214_470, arg1222_474);
		     }
		     list1218_472 = MAKE_PAIR(arg1213_469, arg1219_473);
		  }
		  return cons__138___r4_pairs_and_lists_6_3(arg1212_468, list1218_472);
	       }
	    }
	 }
      }
   }
}


obj_t 
with_access_expander_113_expand_object(obj_t old_expander_200_49, obj_t mark_50, obj_t instance_51, obj_t class_52, obj_t slots_53)
{
   {
      obj_t lambda1247_2180;
      lambda1247_2180 = make_fx_procedure(lambda12472273_expand_object, ((long) 2), ((long) 5));
      PROCEDURE_SET(lambda1247_2180, ((long) 0), old_expander_200_49);
      PROCEDURE_SET(lambda1247_2180, ((long) 1), slots_53);
      PROCEDURE_SET(lambda1247_2180, ((long) 2), mark_50);
      PROCEDURE_SET(lambda1247_2180, ((long) 3), class_52);
      PROCEDURE_SET(lambda1247_2180, ((long) 4), instance_51);
      return lambda1247_2180;
   }
}


obj_t 
lambda12472273_expand_object(obj_t env_2181, obj_t x_2187, obj_t e_2188)
{
   {
      obj_t old_expander_200_2182;
      obj_t slots_2183;
      obj_t mark_2184;
      obj_t class_2185;
      obj_t instance_2186;
      old_expander_200_2182 = PROCEDURE_REF(env_2181, ((long) 0));
      slots_2183 = PROCEDURE_REF(env_2181, ((long) 1));
      mark_2184 = PROCEDURE_REF(env_2181, ((long) 2));
      class_2185 = PROCEDURE_REF(env_2181, ((long) 3));
      instance_2186 = PROCEDURE_REF(env_2181, ((long) 4));
      {
	 obj_t x_492;
	 obj_t e_493;
	 x_492 = x_2187;
	 e_493 = e_2188;
	 {
	    obj_t var_497;
	    obj_t val_498;
	    obj_t var_495;
	    if (SYMBOLP(x_492))
	      {
		 var_495 = x_492;
		 {
		    bool_t test1261_517;
		    {
		       bool_t test_2331;
		       {
			  obj_t aux_2332;
			  aux_2332 = memq___r4_pairs_and_lists_6_3(var_495, slots_2183);
			  test_2331 = CBOOL(aux_2332);
		       }
		       if (test_2331)
			 {
			    obj_t cell_529;
			    {
			       obj_t arg1279_532;
			       arg1279_532 = lexical_stack_189_expand_eps();
			       cell_529 = assq___r4_pairs_and_lists_6_3(var_495, arg1279_532);
			    }
			    if (PAIRP(cell_529))
			      {
				 obj_t aux_2339;
				 aux_2339 = CDR(cell_529);
				 test1261_517 = (aux_2339 == mark_2184);
			      }
			    else
			      {
				 test1261_517 = ((bool_t) 0);
			      }
			 }
		       else
			 {
			    test1261_517 = ((bool_t) 0);
			 }
		    }
		    if (test1261_517)
		      {
			 obj_t arg1265_518;
			 {
			    obj_t arg1271_523;
			    arg1271_523 = CNST_TABLE_REF(((long) 2));
			    {
			       obj_t list1272_524;
			       {
				  obj_t arg1273_525;
				  {
				     obj_t arg1275_526;
				     arg1275_526 = MAKE_PAIR(var_495, BNIL);
				     arg1273_525 = MAKE_PAIR(arg1271_523, arg1275_526);
				  }
				  list1272_524 = MAKE_PAIR(class_2185, arg1273_525);
			       }
			       arg1265_518 = symbol_append_197___r4_symbols_6_4(list1272_524);
			    }
			 }
			 {
			    obj_t list1267_520;
			    {
			       obj_t arg1268_521;
			       arg1268_521 = MAKE_PAIR(BNIL, BNIL);
			       list1267_520 = MAKE_PAIR(instance_2186, arg1268_521);
			    }
			    return cons__138___r4_pairs_and_lists_6_3(arg1265_518, list1267_520);
			 }
		      }
		    else
		      {
			 return PROCEDURE_ENTRY(old_expander_200_2182) (old_expander_200_2182, var_495, old_expander_200_2182, BEOA);
		      }
		 }
	      }
	    else
	      {
		 if (PAIRP(x_492))
		   {
		      obj_t cdr_142_147_504;
		      cdr_142_147_504 = CDR(x_492);
		      {
			 bool_t test_2356;
			 {
			    obj_t aux_2359;
			    obj_t aux_2357;
			    aux_2359 = CNST_TABLE_REF(((long) 4));
			    aux_2357 = CAR(x_492);
			    test_2356 = (aux_2357 == aux_2359);
			 }
			 if (test_2356)
			   {
			      if (PAIRP(cdr_142_147_504))
				{
				   obj_t car_145_96_507;
				   obj_t cdr_146_167_508;
				   car_145_96_507 = CAR(cdr_142_147_504);
				   cdr_146_167_508 = CDR(cdr_142_147_504);
				   if (SYMBOLP(car_145_96_507))
				     {
					if (PAIRP(cdr_146_167_508))
					  {
					     bool_t test_2370;
					     {
						obj_t aux_2371;
						aux_2371 = CDR(cdr_146_167_508);
						test_2370 = (aux_2371 == BNIL);
					     }
					     if (test_2370)
					       {
						  var_497 = car_145_96_507;
						  val_498 = CAR(cdr_146_167_508);
						  {
						     obj_t val_533;
						     val_533 = PROCEDURE_ENTRY(e_493) (e_493, val_498, e_493, BEOA);
						     {
							bool_t test1280_534;
							{
							   bool_t test_2376;
							   {
							      obj_t aux_2377;
							      aux_2377 = memq___r4_pairs_and_lists_6_3(var_497, slots_2183);
							      test_2376 = CBOOL(aux_2377);
							   }
							   if (test_2376)
							     {
								obj_t cell_550;
								{
								   obj_t arg1307_553;
								   arg1307_553 = lexical_stack_189_expand_eps();
								   cell_550 = assq___r4_pairs_and_lists_6_3(var_497, arg1307_553);
								}
								if (PAIRP(cell_550))
								  {
								     obj_t aux_2384;
								     aux_2384 = CDR(cell_550);
								     test1280_534 = (aux_2384 == mark_2184);
								  }
								else
								  {
								     test1280_534 = ((bool_t) 0);
								  }
							     }
							   else
							     {
								test1280_534 = ((bool_t) 0);
							     }
							}
							if (test1280_534)
							  {
							     obj_t arg1282_535;
							     {
								obj_t arg1293_541;
								arg1293_541 = CNST_TABLE_REF(((long) 2));
								{
								   obj_t list1296_543;
								   {
								      obj_t arg1297_544;
								      {
									 obj_t arg1298_545;
									 {
									    obj_t arg1299_546;
									    {
									       obj_t aux_2389;
									       aux_2389 = CNST_TABLE_REF(((long) 3));
									       arg1299_546 = MAKE_PAIR(aux_2389, BNIL);
									    }
									    arg1298_545 = MAKE_PAIR(var_497, arg1299_546);
									 }
									 arg1297_544 = MAKE_PAIR(arg1293_541, arg1298_545);
								      }
								      list1296_543 = MAKE_PAIR(class_2185, arg1297_544);
								   }
								   arg1282_535 = symbol_append_197___r4_symbols_6_4(list1296_543);
								}
							     }
							     {
								obj_t list1284_537;
								{
								   obj_t arg1286_538;
								   {
								      obj_t arg1287_539;
								      arg1287_539 = MAKE_PAIR(BNIL, BNIL);
								      arg1286_538 = MAKE_PAIR(val_533, arg1287_539);
								   }
								   list1284_537 = MAKE_PAIR(instance_2186, arg1286_538);
								}
								return cons__138___r4_pairs_and_lists_6_3(arg1282_535, list1284_537);
							     }
							  }
							else
							  {
							     {
								obj_t aux_2400;
								{
								   obj_t aux_2401;
								   aux_2401 = CDR(x_492);
								   aux_2400 = CDR(aux_2401);
								}
								SET_CAR(aux_2400, val_533);
							     }
							     return PROCEDURE_ENTRY(old_expander_200_2182) (old_expander_200_2182, x_492, old_expander_200_2182, BEOA);
							  }
						     }
						  }
					       }
					     else
					       {
						tag_131_18_500:
						  return PROCEDURE_ENTRY(old_expander_200_2182) (old_expander_200_2182, x_492, e_493, BEOA);
					       }
					  }
					else
					  {
					     goto tag_131_18_500;
					  }
				     }
				   else
				     {
					goto tag_131_18_500;
				     }
				}
			      else
				{
				   goto tag_131_18_500;
				}
			   }
			 else
			   {
			      goto tag_131_18_500;
			   }
		      }
		   }
		 else
		   {
		      goto tag_131_18_500;
		   }
	      }
	 }
      }
   }
}


obj_t 
expand_instantiate_150_expand_object(obj_t x_54, obj_t e_55)
{
   {
      obj_t instantiate_554;
      obj_t provided_555;
      if (PAIRP(x_54))
	{
	   instantiate_554 = CAR(x_54);
	   provided_555 = CDR(x_54);
	   {
	      type_t class_562;
	      class_562 = type_of_id_183_ast_ident(instantiate_554);
	      {
		 bool_t test1312_563;
		 test1312_563 = is_a__118___object((obj_t) (class_562), class_object_class);
		 if (test1312_563)
		   {
		      obj_t arg1313_564;
		      {
			 obj_t arg1314_565;
			 arg1314_565 = instantiate__make_36_expand_object(x_54, class_562, provided_555);
			 arg1313_564 = PROCEDURE_ENTRY(e_55) (e_55, arg1314_565, e_55, BEOA);
		      }
		      return replace__160_tools_misc(x_54, arg1313_564);
		   }
		 else
		   {
		      FAILURE(BFALSE, string2277_expand_object, x_54);
		   }
	      }
	   }
	}
      else
	{
	   FAILURE(BFALSE, string2277_expand_object, x_54);
	}
   }
}


obj_t 
_expand_instantiate_86_expand_object(obj_t env_2189, obj_t x_2190, obj_t e_2191)
{
   return expand_instantiate_150_expand_object(x_2190, e_2191);
}


obj_t 
instantiate__make_36_expand_object(obj_t form_56, type_t class_57, obj_t provided_58)
{
   {
      obj_t slots_566;
      {
	 bool_t test_2425;
	 {
	    class_t obj_1724;
	    obj_1724 = (class_t) (class_57);
	    {
	       obj_t aux_2427;
	       {
		  obj_t aux_2428;
		  {
		     object_t aux_2429;
		     aux_2429 = (object_t) (obj_1724);
		     aux_2428 = OBJECT_WIDENING(aux_2429);
		  }
		  aux_2427 = (((class_t) CREF(aux_2428))->widening);
	       }
	       test_2425 = CBOOL(aux_2427);
	    }
	 }
	 if (test_2425)
	   {
	      obj_t aux_2448;
	      obj_t aux_2434;
	      {
		 class_t obj_1727;
		 obj_1727 = (class_t) (class_57);
		 {
		    obj_t aux_2450;
		    {
		       object_t aux_2451;
		       aux_2451 = (object_t) (obj_1727);
		       aux_2450 = OBJECT_WIDENING(aux_2451);
		    }
		    aux_2448 = (((class_t) CREF(aux_2450))->slots);
		 }
	      }
	      {
		 class_t obj_1726;
		 {
		    obj_t aux_2435;
		    {
		       class_t obj_1725;
		       obj_1725 = (class_t) (class_57);
		       {
			  obj_t aux_2437;
			  {
			     object_t aux_2438;
			     aux_2438 = (object_t) (obj_1725);
			     aux_2437 = OBJECT_WIDENING(aux_2438);
			  }
			  aux_2435 = (((class_t) CREF(aux_2437))->its_super_214);
		       }
		    }
		    obj_1726 = (class_t) (aux_2435);
		 }
		 {
		    obj_t aux_2443;
		    {
		       object_t aux_2444;
		       aux_2444 = (object_t) (obj_1726);
		       aux_2443 = OBJECT_WIDENING(aux_2444);
		    }
		    aux_2434 = (((class_t) CREF(aux_2443))->slots);
		 }
	      }
	      slots_566 = append_2_18___r4_pairs_and_lists_6_3(aux_2434, aux_2448);
	   }
	 else
	   {
	      class_t obj_1728;
	      obj_1728 = (class_t) (class_57);
	      {
		 obj_t aux_2457;
		 {
		    object_t aux_2458;
		    aux_2458 = (object_t) (obj_1728);
		    aux_2457 = OBJECT_WIDENING(aux_2458);
		 }
		 slots_566 = (((class_t) CREF(aux_2457))->slots);
	      }
	   }
      }
      {
	 long len_567;
	 len_567 = list_length(slots_566);
	 {
	    obj_t vargs_568;
	    vargs_568 = make_vector(len_567, BUNSPEC);
	    {
	       {
		  long i_570;
		  obj_t slots_571;
		  i_570 = ((long) 0);
		  slots_571 = slots_566;
		loop_572:
		  if (NULLP(slots_571))
		    {
		       CNST_TABLE_REF(((long) 5));
		    }
		  else
		    {
		       obj_t s_574;
		       s_574 = CAR(slots_571);
		       {
			  bool_t test_2468;
			  {
			     obj_t aux_2469;
			     aux_2469 = STRUCT_REF(s_574, ((long) 8));
			     test_2468 = CBOOL(aux_2469);
			  }
			  if (test_2468)
			    {
			       obj_t arg1318_576;
			       {
				  obj_t aux_2472;
				  aux_2472 = STRUCT_REF(s_574, ((long) 9));
				  arg1318_576 = MAKE_PAIR(BTRUE, aux_2472);
			       }
			       VECTOR_SET(vargs_568, i_570, arg1318_576);
			    }
			  else
			    {
			       obj_t arg1320_578;
			       arg1320_578 = MAKE_PAIR(BFALSE, BUNSPEC);
			       VECTOR_SET(vargs_568, i_570, arg1320_578);
			    }
		       }
		       {
			  obj_t slots_2480;
			  long i_2478;
			  i_2478 = (i_570 + ((long) 1));
			  slots_2480 = CDR(slots_571);
			  slots_571 = slots_2480;
			  i_570 = i_2478;
			  goto loop_572;
		       }
		    }
	       }
	       {
		  obj_t provided_581;
		  provided_581 = provided_58;
		loop_582:
		  if (NULLP(provided_581))
		    {
		       CNST_TABLE_REF(((long) 5));
		    }
		  else
		    {
		       obj_t p_584;
		       p_584 = CAR(provided_581);
		       {
			  obj_t s_name_91_588;
			  obj_t len_589;
			  obj_t value_590;
			  if (PAIRP(p_584))
			    {
			       obj_t cdr_175_128_595;
			       cdr_175_128_595 = CDR(p_584);
			       if (PAIRP(cdr_175_128_595))
				 {
				    bool_t test_2491;
				    {
				       obj_t aux_2492;
				       aux_2492 = CDR(cdr_175_128_595);
				       test_2491 = (aux_2492 == BNIL);
				    }
				    if (test_2491)
				      {
					 obj_t arg1328_599;
					 arg1328_599 = CAR(cdr_175_128_595);
					 {
					    obj_t pval_1763;
					    {
					       obj_t arg1342_1764;
					       arg1342_1764 = find_slot_offset2275_148_expand_object(slots_566, form_56, CAR(p_584));
					       {
						  long aux_2498;
						  aux_2498 = (long) CINT(arg1342_1764);
						  pval_1763 = VECTOR_REF(vargs_568, aux_2498);
					       }
					    }
					    SET_CAR(pval_1763, BTRUE);
					    SET_CDR(pval_1763, arg1328_599);
					 }
				      }
				    else
				      {
					 obj_t cdr_197_63_601;
					 cdr_197_63_601 = CDR(cdr_175_128_595);
					 if (PAIRP(cdr_197_63_601))
					   {
					      bool_t test_2506;
					      {
						 obj_t aux_2507;
						 aux_2507 = CDR(cdr_197_63_601);
						 test_2506 = (aux_2507 == BNIL);
					      }
					      if (test_2506)
						{
						   s_name_91_588 = CAR(p_584);
						   len_589 = CAR(cdr_175_128_595);
						   value_590 = CAR(cdr_197_63_601);
						   {
						      obj_t snum_613;
						      snum_613 = find_slot_offset2275_148_expand_object(slots_566, form_56, s_name_91_588);
						      {
							 {
							    bool_t test_2511;
							    {
							       obj_t aux_2512;
							       {
								  obj_t aux_2513;
								  aux_2513 = list_ref_194___r4_pairs_and_lists_6_3(slots_566, (long) CINT(snum_613));
								  aux_2512 = STRUCT_REF(aux_2513, ((long) 5));
							       }
							       test_2511 = CBOOL(aux_2512);
							    }
							    if (test_2511)
							      {
								 obj_t pval_616;
								 {
								    long aux_2518;
								    aux_2518 = (long) CINT(snum_613);
								    pval_616 = VECTOR_REF(vargs_568, aux_2518);
								 }
								 {
								    obj_t plen_617;
								    {
								       long aux_2521;
								       {
									  long aux_2522;
									  aux_2522 = (long) CINT(snum_613);
									  aux_2521 = (aux_2522 - ((long) 1));
								       }
								       plen_617 = VECTOR_REF(vargs_568, aux_2521);
								    }
								    {
								       SET_CAR(pval_616, BTRUE);
								       SET_CDR(pval_616, value_590);
								       SET_CAR(plen_617, BTRUE);
								       SET_CDR(plen_617, len_589);
								    }
								 }
							      }
							    else
							      {
								 FAILURE(BFALSE, string2277_expand_object, form_56);
							      }
							 }
						      }
						   }
						}
					      else
						{
						 tag_167_203_592:
						   FAILURE(BFALSE, string2277_expand_object, form_56);
						}
					   }
					 else
					   {
					      goto tag_167_203_592;
					   }
				      }
				 }
			       else
				 {
				    goto tag_167_203_592;
				 }
			    }
			  else
			    {
			       goto tag_167_203_592;
			    }
		       }
		       {
			  obj_t provided_2535;
			  provided_2535 = CDR(provided_581);
			  provided_581 = provided_2535;
			  goto loop_582;
		       }
		    }
	       }
	       {
		  long i_620;
		  i_620 = ((long) 0);
		loop_621:
		  if ((i_620 == len_567))
		    {
		       CNST_TABLE_REF(((long) 6));
		    }
		  else
		    {
		       bool_t test_2540;
		       {
			  obj_t aux_2541;
			  {
			     obj_t aux_2542;
			     aux_2542 = VECTOR_REF(vargs_568, i_620);
			     aux_2541 = CAR(aux_2542);
			  }
			  test_2540 = CBOOL(aux_2541);
		       }
		       if (test_2540)
			 {
			    {
			       long i_2546;
			       i_2546 = (i_620 + ((long) 1));
			       i_620 = i_2546;
			       goto loop_621;
			    }
			 }
		       else
			 {
			    FAILURE(BFALSE, string2278_expand_object, form_56);
			 }
		    }
	       }
	       {
		  long i_626;
		  obj_t largs_627;
		  i_626 = ((long) 0);
		  largs_627 = BNIL;
		loop_628:
		  if ((i_626 == len_567))
		    {
		       obj_t make_name_208_632;
		       {
			  obj_t arg1363_640;
			  arg1363_640 = CNST_TABLE_REF(((long) 7));
			  {
			     obj_t list1365_642;
			     {
				obj_t arg1366_643;
				{
				   obj_t aux_2552;
				   aux_2552 = (((type_t) CREF(class_57))->id);
				   arg1366_643 = MAKE_PAIR(aux_2552, BNIL);
				}
				list1365_642 = MAKE_PAIR(arg1363_640, arg1366_643);
			     }
			     make_name_208_632 = symbol_append_197___r4_symbols_6_4(list1365_642);
			  }
		       }
		       {
			  obj_t arg1355_633;
			  {
			     obj_t arg1358_636;
			     obj_t arg1359_637;
			     arg1358_636 = reverse__39___r4_pairs_and_lists_6_3(largs_627);
			     arg1359_637 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
			     arg1355_633 = append_2_18___r4_pairs_and_lists_6_3(arg1358_636, arg1359_637);
			  }
			  {
			     obj_t list1356_634;
			     list1356_634 = MAKE_PAIR(arg1355_633, BNIL);
			     return cons__138___r4_pairs_and_lists_6_3(make_name_208_632, list1356_634);
			  }
		       }
		    }
		  else
		    {
		       long arg1369_645;
		       obj_t arg1370_646;
		       arg1369_645 = (i_626 + ((long) 1));
		       {
			  obj_t aux_2563;
			  {
			     obj_t aux_2564;
			     aux_2564 = VECTOR_REF(vargs_568, i_626);
			     aux_2563 = CDR(aux_2564);
			  }
			  arg1370_646 = MAKE_PAIR(aux_2563, largs_627);
		       }
		       {
			  obj_t largs_2569;
			  long i_2568;
			  i_2568 = arg1369_645;
			  largs_2569 = arg1370_646;
			  largs_627 = largs_2569;
			  i_626 = i_2568;
			  goto loop_628;
		       }
		    }
	       }
	    }
	 }
      }
   }
}


obj_t 
find_slot_offset2275_148_expand_object(obj_t slots_2206, obj_t form_2205, obj_t s_name_91_649)
{
   {
      obj_t slots_651;
      long i_652;
      slots_651 = slots_2206;
      i_652 = ((long) 0);
    loop_653:
      if (NULLP(slots_651))
	{
	   {
	      obj_t arg1379_655;
	      {
		 obj_t arg1381_657;
		 arg1381_657 = SYMBOL_TO_STRING(s_name_91_649);
		 {
		    obj_t list1383_659;
		    {
		       obj_t arg1385_660;
		       {
			  obj_t arg1388_661;
			  arg1388_661 = MAKE_PAIR(string2279_expand_object, BNIL);
			  arg1385_660 = MAKE_PAIR(arg1381_657, arg1388_661);
		       }
		       list1383_659 = MAKE_PAIR(string2280_expand_object, arg1385_660);
		    }
		    arg1379_655 = string_append_106___r4_strings_6_7(list1383_659);
		 }
	      }
	      FAILURE(BFALSE, arg1379_655, form_2205);
	   }
	}
      else
	{
	   bool_t test_2578;
	   {
	      obj_t aux_2579;
	      {
		 obj_t aux_2580;
		 aux_2580 = CAR(slots_651);
		 aux_2579 = STRUCT_REF(aux_2580, ((long) 0));
	      }
	      test_2578 = (aux_2579 == s_name_91_649);
	   }
	   if (test_2578)
	     {
		return BINT(i_652);
	     }
	   else
	     {
		{
		   long i_2587;
		   obj_t slots_2585;
		   slots_2585 = CDR(slots_651);
		   i_2587 = (i_652 + ((long) 1));
		   i_652 = i_2587;
		   slots_651 = slots_2585;
		   goto loop_653;
		}
	     }
	}
   }
}


obj_t 
expand_duplicate_139_expand_object(obj_t x_59, obj_t e_60)
{
   {
      obj_t duplicate_675;
      obj_t dup_676;
      obj_t prov_677;
      if (PAIRP(x_59))
	{
	   obj_t cdr_227_91_682;
	   cdr_227_91_682 = CDR(x_59);
	   if (PAIRP(cdr_227_91_682))
	     {
		duplicate_675 = CAR(x_59);
		dup_676 = CAR(cdr_227_91_682);
		prov_677 = CDR(cdr_227_91_682);
		{
		   obj_t id_type_89_687;
		   id_type_89_687 = parse_id_241_ast_ident(duplicate_675);
		   {
		      obj_t id_688;
		      id_688 = CAR(id_type_89_687);
		      {
			 obj_t class_689;
			 class_689 = CDR(id_type_89_687);
			 {
			    {
			       bool_t test1417_690;
			       test1417_690 = is_a__118___object(class_689, class_object_class);
			       if (test1417_690)
				 {
				    obj_t arg1418_691;
				    {
				       obj_t arg1420_692;
				       arg1420_692 = duplicate__make_94_expand_object(x_59, class_689, dup_676, prov_677);
				       arg1418_691 = PROCEDURE_ENTRY(e_60) (e_60, arg1420_692, e_60, BEOA);
				    }
				    return replace__160_tools_misc(x_59, arg1418_691);
				 }
			       else
				 {
				    obj_t arg1421_693;
				    {
				       obj_t arg1426_695;
				       arg1426_695 = SYMBOL_TO_STRING(id_688);
				       arg1421_693 = string_append(string2281_expand_object, arg1426_695);
				    }
				    FAILURE(BFALSE, arg1421_693, x_59);
				 }
			    }
			 }
		      }
		   }
		}
	     }
	   else
	     {
	      tag_218_42_679:
		FAILURE(BFALSE, string2282_expand_object, x_59);
	     }
	}
      else
	{
	   goto tag_218_42_679;
	}
   }
}


obj_t 
_expand_duplicate_242_expand_object(obj_t env_2192, obj_t x_2193, obj_t e_2194)
{
   return expand_duplicate_139_expand_object(x_2193, e_2194);
}


obj_t 
duplicate__make_94_expand_object(obj_t form_61, obj_t class_62, obj_t duplicated_63, obj_t provided_64)
{
   {
      obj_t slots_696;
      {
	 bool_t test_2611;
	 {
	    class_t obj_1862;
	    obj_1862 = (class_t) (class_62);
	    {
	       obj_t aux_2613;
	       {
		  obj_t aux_2614;
		  {
		     object_t aux_2615;
		     aux_2615 = (object_t) (obj_1862);
		     aux_2614 = OBJECT_WIDENING(aux_2615);
		  }
		  aux_2613 = (((class_t) CREF(aux_2614))->widening);
	       }
	       test_2611 = CBOOL(aux_2613);
	    }
	 }
	 if (test_2611)
	   {
	      obj_t aux_2634;
	      obj_t aux_2620;
	      {
		 class_t obj_1865;
		 obj_1865 = (class_t) (class_62);
		 {
		    obj_t aux_2636;
		    {
		       object_t aux_2637;
		       aux_2637 = (object_t) (obj_1865);
		       aux_2636 = OBJECT_WIDENING(aux_2637);
		    }
		    aux_2634 = (((class_t) CREF(aux_2636))->slots);
		 }
	      }
	      {
		 class_t obj_1864;
		 {
		    obj_t aux_2621;
		    {
		       class_t obj_1863;
		       obj_1863 = (class_t) (class_62);
		       {
			  obj_t aux_2623;
			  {
			     object_t aux_2624;
			     aux_2624 = (object_t) (obj_1863);
			     aux_2623 = OBJECT_WIDENING(aux_2624);
			  }
			  aux_2621 = (((class_t) CREF(aux_2623))->its_super_214);
		       }
		    }
		    obj_1864 = (class_t) (aux_2621);
		 }
		 {
		    obj_t aux_2629;
		    {
		       object_t aux_2630;
		       aux_2630 = (object_t) (obj_1864);
		       aux_2629 = OBJECT_WIDENING(aux_2630);
		    }
		    aux_2620 = (((class_t) CREF(aux_2629))->slots);
		 }
	      }
	      slots_696 = append_2_18___r4_pairs_and_lists_6_3(aux_2620, aux_2634);
	   }
	 else
	   {
	      class_t obj_1866;
	      obj_1866 = (class_t) (class_62);
	      {
		 obj_t aux_2643;
		 {
		    object_t aux_2644;
		    aux_2644 = (object_t) (obj_1866);
		    aux_2643 = OBJECT_WIDENING(aux_2644);
		 }
		 slots_696 = (((class_t) CREF(aux_2643))->slots);
	      }
	   }
      }
      {
	 long len_697;
	 len_697 = list_length(slots_696);
	 {
	    obj_t vargs_698;
	    vargs_698 = make_vector(len_697, BUNSPEC);
	    {
	       obj_t dup_var_35_699;
	       dup_var_35_699 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 8)), BEOA);
	       {
		  obj_t dup_var_typed_156_700;
		  {
		     obj_t list1573_845;
		     {
			obj_t arg1574_846;
			{
			   obj_t arg1575_847;
			   {
			      obj_t aux_2653;
			      {
				 type_t obj_1868;
				 obj_1868 = (type_t) (class_62);
				 aux_2653 = (((type_t) CREF(obj_1868))->id);
			      }
			      arg1575_847 = MAKE_PAIR(aux_2653, BNIL);
			   }
			   arg1574_846 = MAKE_PAIR(_4dots_tools_misc, arg1575_847);
			}
			list1573_845 = MAKE_PAIR(dup_var_35_699, arg1574_846);
		     }
		     dup_var_typed_156_700 = symbol_append_197___r4_symbols_6_4(list1573_845);
		  }
		  {
		     {
			obj_t provided_702;
			provided_702 = provided_64;
		      loop_703:
			if (NULLP(provided_702))
			  {
			     CNST_TABLE_REF(((long) 5));
			  }
			else
			  {
			     obj_t p_705;
			     p_705 = CAR(provided_702);
			     {
				obj_t s_name_91_709;
				obj_t len_710;
				obj_t value_711;
				if (PAIRP(p_705))
				  {
				     obj_t cdr_245_234_716;
				     cdr_245_234_716 = CDR(p_705);
				     if (PAIRP(cdr_245_234_716))
				       {
					  bool_t test_2669;
					  {
					     obj_t aux_2670;
					     aux_2670 = CDR(cdr_245_234_716);
					     test_2669 = (aux_2670 == BNIL);
					  }
					  if (test_2669)
					    {
					       obj_t arg1449_1881;
					       obj_t arg1450_1882;
					       arg1449_1881 = find_slot_offset2274_223_expand_object(slots_696, form_61, CAR(p_705));
					       {
						  obj_t aux_2675;
						  aux_2675 = CAR(cdr_245_234_716);
						  arg1450_1882 = MAKE_PAIR(BTRUE, aux_2675);
					       }
					       {
						  long aux_2678;
						  aux_2678 = (long) CINT(arg1449_1881);
						  VECTOR_SET(vargs_698, aux_2678, arg1450_1882);
					       }
					    }
					  else
					    {
					       obj_t cdr_267_105_722;
					       cdr_267_105_722 = CDR(cdr_245_234_716);
					       if (PAIRP(cdr_267_105_722))
						 {
						    bool_t test_2684;
						    {
						       obj_t aux_2685;
						       aux_2685 = CDR(cdr_267_105_722);
						       test_2684 = (aux_2685 == BNIL);
						    }
						    if (test_2684)
						      {
							 s_name_91_709 = CAR(p_705);
							 len_710 = CAR(cdr_245_234_716);
							 value_711 = CAR(cdr_267_105_722);
							 {
							    obj_t snum_734;
							    snum_734 = find_slot_offset2274_223_expand_object(slots_696, form_61, s_name_91_709);
							    {
							       obj_t slot_735;
							       slot_735 = list_ref_194___r4_pairs_and_lists_6_3(slots_696, (long) CINT(snum_734));
							       {
								  {
								     bool_t test_2691;
								     {
									bool_t test_2692;
									{
									   obj_t aux_2693;
									   aux_2693 = STRUCT_REF(slot_735, ((long) 3));
									   test_2692 = CBOOL(aux_2693);
									}
									if (test_2692)
									  {
									     test_2691 = ((bool_t) 1);
									  }
									else
									  {
									     obj_t aux_2696;
									     aux_2696 = STRUCT_REF(slot_735, ((long) 5));
									     test_2691 = CBOOL(aux_2696);
									  }
								     }
								     if (test_2691)
								       {
									  {
									     obj_t arg1452_737;
									     arg1452_737 = MAKE_PAIR(BTRUE, value_711);
									     {
										long aux_2700;
										aux_2700 = (long) CINT(snum_734);
										VECTOR_SET(vargs_698, aux_2700, arg1452_737);
									     }
									  }
									  {
									     long arg1453_738;
									     obj_t arg1454_739;
									     {
										long aux_2703;
										aux_2703 = (long) CINT(snum_734);
										arg1453_738 = (aux_2703 - ((long) 1));
									     }
									     arg1454_739 = MAKE_PAIR(BFALSE, len_710);
									     VECTOR_SET(vargs_698, arg1453_738, arg1454_739);
									  }
								       }
								     else
								       {
									  FAILURE(BFALSE, string2282_expand_object, form_61);
								       }
								  }
							       }
							    }
							 }
						      }
						    else
						      {
						       tag_237_211_713:
							 FAILURE(BFALSE, string2282_expand_object, form_61);
						      }
						 }
					       else
						 {
						    goto tag_237_211_713;
						 }
					    }
				       }
				     else
				       {
					  goto tag_237_211_713;
				       }
				  }
				else
				  {
				     goto tag_237_211_713;
				  }
			     }
			     {
				obj_t provided_2713;
				provided_2713 = CDR(provided_702);
				provided_702 = provided_2713;
				goto loop_703;
			     }
			  }
		     }
		     {
			long i_742;
			obj_t slots_743;
			i_742 = ((long) 0);
			slots_743 = slots_696;
		      loop_744:
			if (NULLP(slots_743))
			  {
			     CNST_TABLE_REF(((long) 5));
			  }
			else
			  {
			     {
				bool_t test_2718;
				{
				   obj_t aux_2719;
				   aux_2719 = VECTOR_REF(vargs_698, i_742);
				   test_2718 = PAIRP(aux_2719);
				}
				if (test_2718)
				  {
				     CNST_TABLE_REF(((long) 9));
				  }
				else
				  {
				     obj_t slot_748;
				     slot_748 = CAR(slots_743);
				     {
					bool_t test_2724;
					{
					   bool_t test_2725;
					   {
					      obj_t aux_2726;
					      aux_2726 = STRUCT_REF(slot_748, ((long) 5));
					      test_2725 = CBOOL(aux_2726);
					   }
					   if (test_2725)
					     {
						test_2724 = ((bool_t) 1);
					     }
					   else
					     {
						obj_t aux_2729;
						aux_2729 = STRUCT_REF(slot_748, ((long) 3));
						test_2724 = CBOOL(aux_2729);
					     }
					}
					if (test_2724)
					  {
					     obj_t a_name_201_750;
					     {
						obj_t arg1472_759;
						obj_t arg1474_760;
						obj_t arg1476_761;
						{
						   type_t obj_1940;
						   obj_1940 = (type_t) (class_62);
						   arg1472_759 = (((type_t) CREF(obj_1940))->id);
						}
						arg1474_760 = CNST_TABLE_REF(((long) 2));
						arg1476_761 = STRUCT_REF(slot_748, ((long) 0));
						{
						   obj_t list1478_763;
						   {
						      obj_t arg1480_764;
						      {
							 obj_t arg1481_765;
							 {
							    obj_t arg1484_766;
							    {
							       obj_t aux_2736;
							       aux_2736 = CNST_TABLE_REF(((long) 10));
							       arg1484_766 = MAKE_PAIR(aux_2736, BNIL);
							    }
							    arg1481_765 = MAKE_PAIR(arg1476_761, arg1484_766);
							 }
							 arg1480_764 = MAKE_PAIR(arg1474_760, arg1481_765);
						      }
						      list1478_763 = MAKE_PAIR(arg1472_759, arg1480_764);
						   }
						   a_name_201_750 = symbol_append_197___r4_symbols_6_4(list1478_763);
						}
					     }
					     {
						obj_t arg1461_751;
						{
						   obj_t arg1463_752;
						   {
						      obj_t list1467_755;
						      {
							 obj_t arg1468_756;
							 {
							    obj_t arg1470_757;
							    arg1470_757 = MAKE_PAIR(BNIL, BNIL);
							    {
							       obj_t aux_2744;
							       aux_2744 = BINT(((long) 0));
							       arg1468_756 = MAKE_PAIR(aux_2744, arg1470_757);
							    }
							 }
							 list1467_755 = MAKE_PAIR(dup_var_35_699, arg1468_756);
						      }
						      arg1463_752 = cons__138___r4_pairs_and_lists_6_3(a_name_201_750, list1467_755);
						   }
						   arg1461_751 = MAKE_PAIR(BTRUE, arg1463_752);
						}
						VECTOR_SET(vargs_698, i_742, arg1461_751);
					     }
					  }
					else
					  {
					     obj_t a_name_201_768;
					     {
						obj_t arg1496_775;
						obj_t arg1497_776;
						{
						   type_t obj_1949;
						   obj_1949 = (type_t) (class_62);
						   arg1496_775 = (((type_t) CREF(obj_1949))->id);
						}
						arg1497_776 = CNST_TABLE_REF(((long) 2));
						{
						   obj_t list1499_778;
						   {
						      obj_t arg1500_779;
						      {
							 obj_t arg1501_780;
							 {
							    obj_t aux_2754;
							    aux_2754 = STRUCT_REF(slot_748, ((long) 0));
							    arg1501_780 = MAKE_PAIR(aux_2754, BNIL);
							 }
							 arg1500_779 = MAKE_PAIR(arg1497_776, arg1501_780);
						      }
						      list1499_778 = MAKE_PAIR(arg1496_775, arg1500_779);
						   }
						   a_name_201_768 = symbol_append_197___r4_symbols_6_4(list1499_778);
						}
					     }
					     {
						obj_t arg1486_769;
						{
						   obj_t arg1487_770;
						   {
						      obj_t list1490_772;
						      {
							 obj_t arg1493_773;
							 arg1493_773 = MAKE_PAIR(BNIL, BNIL);
							 list1490_772 = MAKE_PAIR(dup_var_35_699, arg1493_773);
						      }
						      arg1487_770 = cons__138___r4_pairs_and_lists_6_3(a_name_201_768, list1490_772);
						   }
						   arg1486_769 = MAKE_PAIR(BTRUE, arg1487_770);
						}
						VECTOR_SET(vargs_698, i_742, arg1486_769);
					     }
					  }
				     }
				  }
			     }
			     {
				obj_t slots_2767;
				long i_2765;
				i_2765 = (i_742 + ((long) 1));
				slots_2767 = CDR(slots_743);
				slots_743 = slots_2767;
				i_742 = i_2765;
				goto loop_744;
			     }
			  }
		     }
		     {
			long i_785;
			obj_t largs_786;
			i_785 = ((long) 0);
			largs_786 = BNIL;
		      loop_787:
			if ((i_785 == len_697))
			  {
			     obj_t make_name_208_791;
			     {
				obj_t arg1543_815;
				arg1543_815 = CNST_TABLE_REF(((long) 7));
				{
				   obj_t list1548_817;
				   {
				      obj_t arg1549_818;
				      {
					 obj_t aux_2772;
					 {
					    type_t obj_1963;
					    obj_1963 = (type_t) (class_62);
					    aux_2772 = (((type_t) CREF(obj_1963))->id);
					 }
					 arg1549_818 = MAKE_PAIR(aux_2772, BNIL);
				      }
				      list1548_817 = MAKE_PAIR(arg1543_815, arg1549_818);
				   }
				   make_name_208_791 = symbol_append_197___r4_symbols_6_4(list1548_817);
				}
			     }
			     {
				obj_t arg1513_792;
				obj_t arg1514_793;
				obj_t arg1517_794;
				arg1513_792 = CNST_TABLE_REF(((long) 1));
				{
				   obj_t arg1524_800;
				   {
				      obj_t list1532_805;
				      {
					 obj_t arg1534_806;
					 arg1534_806 = MAKE_PAIR(BNIL, BNIL);
					 list1532_805 = MAKE_PAIR(duplicated_63, arg1534_806);
				      }
				      arg1524_800 = cons__138___r4_pairs_and_lists_6_3(dup_var_typed_156_700, list1532_805);
				   }
				   {
				      obj_t list1527_802;
				      list1527_802 = MAKE_PAIR(BNIL, BNIL);
				      arg1514_793 = cons__138___r4_pairs_and_lists_6_3(arg1524_800, list1527_802);
				   }
				}
				{
				   obj_t arg1536_808;
				   {
				      obj_t arg1539_811;
				      obj_t arg1540_812;
				      arg1539_811 = reverse__39___r4_pairs_and_lists_6_3(largs_786);
				      arg1540_812 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
				      arg1536_808 = append_2_18___r4_pairs_and_lists_6_3(arg1539_811, arg1540_812);
				   }
				   {
				      obj_t list1537_809;
				      list1537_809 = MAKE_PAIR(arg1536_808, BNIL);
				      arg1517_794 = cons__138___r4_pairs_and_lists_6_3(make_name_208_791, list1537_809);
				   }
				}
				{
				   obj_t list1519_796;
				   {
				      obj_t arg1520_797;
				      {
					 obj_t arg1522_798;
					 arg1522_798 = MAKE_PAIR(BNIL, BNIL);
					 arg1520_797 = MAKE_PAIR(arg1517_794, arg1522_798);
				      }
				      list1519_796 = MAKE_PAIR(arg1514_793, arg1520_797);
				   }
				   return cons__138___r4_pairs_and_lists_6_3(arg1513_792, list1519_796);
				}
			     }
			  }
			else
			  {
			     long arg1551_820;
			     obj_t arg1552_821;
			     arg1551_820 = (i_785 + ((long) 1));
			     {
				obj_t aux_2794;
				{
				   obj_t aux_2795;
				   aux_2795 = VECTOR_REF(vargs_698, i_785);
				   aux_2794 = CDR(aux_2795);
				}
				arg1552_821 = MAKE_PAIR(aux_2794, largs_786);
			     }
			     {
				obj_t largs_2800;
				long i_2799;
				i_2799 = arg1551_820;
				largs_2800 = arg1552_821;
				largs_786 = largs_2800;
				i_785 = i_2799;
				goto loop_787;
			     }
			  }
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
find_slot_offset2274_223_expand_object(obj_t slots_2204, obj_t form_2203, obj_t s_name_91_824)
{
   {
      obj_t slots_826;
      long i_827;
      slots_826 = slots_2204;
      i_827 = ((long) 0);
    loop_828:
      if (NULLP(slots_826))
	{
	   {
	      obj_t arg1557_830;
	      {
		 obj_t arg1560_832;
		 arg1560_832 = SYMBOL_TO_STRING(s_name_91_824);
		 {
		    obj_t list1562_834;
		    {
		       obj_t arg1563_835;
		       {
			  obj_t arg1564_836;
			  arg1564_836 = MAKE_PAIR(string2279_expand_object, BNIL);
			  arg1563_835 = MAKE_PAIR(arg1560_832, arg1564_836);
		       }
		       list1562_834 = MAKE_PAIR(string2283_expand_object, arg1563_835);
		    }
		    arg1557_830 = string_append_106___r4_strings_6_7(list1562_834);
		 }
	      }
	      FAILURE(BFALSE, arg1557_830, form_2203);
	   }
	}
      else
	{
	   bool_t test_2809;
	   {
	      obj_t aux_2810;
	      {
		 obj_t aux_2811;
		 aux_2811 = CAR(slots_826);
		 aux_2810 = STRUCT_REF(aux_2811, ((long) 0));
	      }
	      test_2809 = (aux_2810 == s_name_91_824);
	   }
	   if (test_2809)
	     {
		return BINT(i_827);
	     }
	   else
	     {
		{
		   long i_2818;
		   obj_t slots_2816;
		   slots_2816 = CDR(slots_826);
		   i_2818 = (i_827 + ((long) 1));
		   i_827 = i_2818;
		   slots_826 = slots_2816;
		   goto loop_828;
		}
	     }
	}
   }
}


obj_t 
expand_widen__163_expand_object(obj_t x_65, obj_t e_66)
{
   {
      obj_t widen__231_856;
      obj_t obj_857;
      obj_t provided_858;
      if (PAIRP(x_65))
	{
	   obj_t cdr_297_239_863;
	   cdr_297_239_863 = CDR(x_65);
	   if (PAIRP(cdr_297_239_863))
	     {
		widen__231_856 = CAR(x_65);
		obj_857 = CAR(cdr_297_239_863);
		provided_858 = CDR(cdr_297_239_863);
		{
		   type_t class_868;
		   class_868 = type_of_id_183_ast_ident(widen__231_856);
		   {
		      bool_t test1590_869;
		      {
			 bool_t test1598_876;
			 test1598_876 = is_a__118___object((obj_t) (class_868), class_object_class);
			 if (test1598_876)
			   {
			      class_t obj_1992;
			      obj_1992 = (class_t) (class_868);
			      {
				 obj_t aux_2830;
				 {
				    obj_t aux_2831;
				    {
				       object_t aux_2832;
				       aux_2832 = (object_t) (obj_1992);
				       aux_2831 = OBJECT_WIDENING(aux_2832);
				    }
				    aux_2830 = (((class_t) CREF(aux_2831))->widening);
				 }
				 test1590_869 = CBOOL(aux_2830);
			      }
			   }
			 else
			   {
			      test1590_869 = ((bool_t) 0);
			   }
		      }
		      if (test1590_869)
			{
			   obj_t arg1591_870;
			   {
			      obj_t arg1592_871;
			      arg1592_871 = make_widening_107_expand_object(x_65, class_868, obj_857, provided_858);
			      arg1591_870 = PROCEDURE_ENTRY(e_66) (e_66, arg1592_871, e_66, BEOA);
			   }
			   return replace__160_tools_misc(x_65, arg1591_870);
			}
		      else
			{
			   obj_t arg1593_872;
			   {
			      obj_t arg1596_874;
			      {
				 obj_t aux_2842;
				 aux_2842 = (((type_t) CREF(class_868))->id);
				 arg1596_874 = SYMBOL_TO_STRING(aux_2842);
			      }
			      arg1593_872 = string_append(string2284_expand_object, arg1596_874);
			   }
			   FAILURE(BFALSE, arg1593_872, x_65);
			}
		   }
		}
	     }
	   else
	     {
	      tag_288_135_860:
		FAILURE(BFALSE, string2285_expand_object, x_65);
	     }
	}
      else
	{
	   goto tag_288_135_860;
	}
   }
}


obj_t 
_expand_widen__96_expand_object(obj_t env_2195, obj_t x_2196, obj_t e_2197)
{
   return expand_widen__163_expand_object(x_2196, e_2197);
}


obj_t 
make_widening_107_expand_object(obj_t form_67, type_t class_68, obj_t obj_69, obj_t provided_70)
{
   {
      obj_t slots_877;
      {
	 class_t obj_2001;
	 obj_2001 = (class_t) (class_68);
	 {
	    obj_t aux_2853;
	    {
	       object_t aux_2854;
	       aux_2854 = (object_t) (obj_2001);
	       aux_2853 = OBJECT_WIDENING(aux_2854);
	    }
	    slots_877 = (((class_t) CREF(aux_2853))->slots);
	 }
      }
      {
	 global_t holder_878;
	 {
	    class_t obj_2002;
	    obj_2002 = (class_t) (class_68);
	    {
	       obj_t aux_2859;
	       {
		  object_t aux_2860;
		  aux_2860 = (object_t) (obj_2002);
		  aux_2859 = OBJECT_WIDENING(aux_2860);
	       }
	       holder_878 = (((class_t) CREF(aux_2859))->holder);
	    }
	 }
	 {
	    long len_879;
	    len_879 = list_length(slots_877);
	    {
	       obj_t vargs_880;
	       vargs_880 = make_vector(len_879, BUNSPEC);
	       {
		  obj_t dup_var_35_881;
		  dup_var_35_881 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 11)), BEOA);
		  {
		     obj_t dup_var_typed_156_882;
		     {
			obj_t list1975_1235;
			{
			   obj_t arg1976_1236;
			   {
			      obj_t arg1977_1237;
			      {
				 obj_t aux_2869;
				 aux_2869 = (((type_t) CREF(class_68))->id);
				 arg1977_1237 = MAKE_PAIR(aux_2869, BNIL);
			      }
			      arg1976_1236 = MAKE_PAIR(_4dots_tools_misc, arg1977_1237);
			   }
			   list1975_1235 = MAKE_PAIR(dup_var_35_881, arg1976_1236);
			}
			dup_var_typed_156_882 = symbol_append_197___r4_symbols_6_4(list1975_1235);
		     }
		     {
			obj_t pragma_typed_60_883;
			{
			   obj_t arg1968_1228;
			   arg1968_1228 = CNST_TABLE_REF(((long) 12));
			   {
			      obj_t list1970_1230;
			      {
				 obj_t arg1971_1231;
				 {
				    obj_t arg1972_1232;
				    {
				       obj_t aux_2876;
				       aux_2876 = (((type_t) CREF(class_68))->id);
				       arg1972_1232 = MAKE_PAIR(aux_2876, BNIL);
				    }
				    arg1971_1231 = MAKE_PAIR(_4dots_tools_misc, arg1972_1232);
				 }
				 list1970_1230 = MAKE_PAIR(arg1968_1228, arg1971_1231);
			      }
			      pragma_typed_60_883 = symbol_append_197___r4_symbols_6_4(list1970_1230);
			   }
			}
			{
			   obj_t pragma_format_172_884;
			   {
			      obj_t arg1960_1222;
			      arg1960_1222 = (((type_t) CREF(class_68))->name);
			      {
				 obj_t list1964_1224;
				 {
				    obj_t arg1965_1225;
				    {
				       obj_t arg1966_1226;
				       arg1966_1226 = MAKE_PAIR(string2286_expand_object, BNIL);
				       arg1965_1225 = MAKE_PAIR(arg1960_1222, arg1966_1226);
				    }
				    list1964_1224 = MAKE_PAIR(string2287_expand_object, arg1965_1225);
				 }
				 pragma_format_172_884 = string_append_106___r4_strings_6_7(list1964_1224);
			      }
			   }
			   {
			      {
				 long i_886;
				 obj_t slots_887;
				 i_886 = ((long) 0);
				 slots_887 = slots_877;
			       loop_888:
				 if (NULLP(slots_887))
				   {
				      CNST_TABLE_REF(((long) 5));
				   }
				 else
				   {
				      obj_t s_890;
				      s_890 = CAR(slots_887);
				      {
					 bool_t test_2891;
					 {
					    obj_t aux_2892;
					    aux_2892 = STRUCT_REF(s_890, ((long) 8));
					    test_2891 = CBOOL(aux_2892);
					 }
					 if (test_2891)
					   {
					      obj_t arg1601_892;
					      {
						 obj_t aux_2895;
						 aux_2895 = STRUCT_REF(s_890, ((long) 9));
						 arg1601_892 = MAKE_PAIR(BTRUE, aux_2895);
					      }
					      VECTOR_SET(vargs_880, i_886, arg1601_892);
					   }
					 else
					   {
					      obj_t arg1604_894;
					      arg1604_894 = MAKE_PAIR(BFALSE, BUNSPEC);
					      VECTOR_SET(vargs_880, i_886, arg1604_894);
					   }
				      }
				      {
					 obj_t slots_2903;
					 long i_2901;
					 i_2901 = (i_886 + ((long) 1));
					 slots_2903 = CDR(slots_887);
					 slots_887 = slots_2903;
					 i_886 = i_2901;
					 goto loop_888;
				      }
				   }
			      }
			      {
				 obj_t provided_897;
				 provided_897 = provided_70;
			       loop_898:
				 if (NULLP(provided_897))
				   {
				      CNST_TABLE_REF(((long) 5));
				   }
				 else
				   {
				      obj_t p_900;
				      p_900 = CAR(provided_897);
				      {
					 obj_t s_name_91_904;
					 obj_t len_905;
					 obj_t value_906;
					 if (PAIRP(p_900))
					   {
					      obj_t cdr_315_206_911;
					      cdr_315_206_911 = CDR(p_900);
					      if (PAIRP(cdr_315_206_911))
						{
						   bool_t test_2914;
						   {
						      obj_t aux_2915;
						      aux_2915 = CDR(cdr_315_206_911);
						      test_2914 = (aux_2915 == BNIL);
						   }
						   if (test_2914)
						     {
							obj_t arg1626_2040;
							obj_t arg1627_2041;
							arg1626_2040 = find_slot_offset_103_expand_object(slots_877, form_67, CAR(p_900));
							{
							   obj_t aux_2920;
							   aux_2920 = CAR(cdr_315_206_911);
							   arg1627_2041 = MAKE_PAIR(BTRUE, aux_2920);
							}
							{
							   long aux_2923;
							   aux_2923 = (long) CINT(arg1626_2040);
							   VECTOR_SET(vargs_880, aux_2923, arg1627_2041);
							}
						     }
						   else
						     {
							obj_t cdr_337_109_917;
							cdr_337_109_917 = CDR(cdr_315_206_911);
							if (PAIRP(cdr_337_109_917))
							  {
							     bool_t test_2929;
							     {
								obj_t aux_2930;
								aux_2930 = CDR(cdr_337_109_917);
								test_2929 = (aux_2930 == BNIL);
							     }
							     if (test_2929)
							       {
								  s_name_91_904 = CAR(p_900);
								  len_905 = CAR(cdr_315_206_911);
								  value_906 = CAR(cdr_337_109_917);
								  {
								     obj_t snum_929;
								     snum_929 = find_slot_offset_103_expand_object(slots_877, form_67, s_name_91_904);
								     {
									obj_t slot_930;
									slot_930 = list_ref_194___r4_pairs_and_lists_6_3(slots_877, (long) CINT(snum_929));
									{
									   {
									      bool_t test_2936;
									      {
										 bool_t test_2937;
										 {
										    obj_t aux_2938;
										    aux_2938 = STRUCT_REF(slot_930, ((long) 3));
										    test_2937 = CBOOL(aux_2938);
										 }
										 if (test_2937)
										   {
										      test_2936 = ((bool_t) 1);
										   }
										 else
										   {
										      obj_t aux_2941;
										      aux_2941 = STRUCT_REF(slot_930, ((long) 5));
										      test_2936 = CBOOL(aux_2941);
										   }
									      }
									      if (test_2936)
										{
										   {
										      obj_t arg1630_932;
										      arg1630_932 = MAKE_PAIR(BTRUE, value_906);
										      {
											 long aux_2945;
											 aux_2945 = (long) CINT(snum_929);
											 VECTOR_SET(vargs_880, aux_2945, arg1630_932);
										      }
										   }
										   {
										      long arg1632_933;
										      obj_t arg1634_934;
										      {
											 long aux_2948;
											 aux_2948 = (long) CINT(snum_929);
											 arg1632_933 = (aux_2948 - ((long) 1));
										      }
										      arg1634_934 = MAKE_PAIR(BFALSE, len_905);
										      VECTOR_SET(vargs_880, arg1632_933, arg1634_934);
										   }
										}
									      else
										{
										   FAILURE(BFALSE, string2285_expand_object, form_67);
										}
									   }
									}
								     }
								  }
							       }
							     else
							       {
								tag_307_159_908:
								  FAILURE(BFALSE, string2285_expand_object, form_67);
							       }
							  }
							else
							  {
							     goto tag_307_159_908;
							  }
						     }
						}
					      else
						{
						   goto tag_307_159_908;
						}
					   }
					 else
					   {
					      goto tag_307_159_908;
					   }
				      }
				      {
					 obj_t provided_2958;
					 provided_2958 = CDR(provided_897);
					 provided_897 = provided_2958;
					 goto loop_898;
				      }
				   }
			      }
			      {
				 long i_937;
				 i_937 = ((long) 0);
			       loop_938:
				 if ((i_937 == len_879))
				   {
				      CNST_TABLE_REF(((long) 6));
				   }
				 else
				   {
				      bool_t test_2963;
				      {
					 obj_t aux_2964;
					 {
					    obj_t aux_2965;
					    aux_2965 = VECTOR_REF(vargs_880, i_937);
					    aux_2964 = CAR(aux_2965);
					 }
					 test_2963 = CBOOL(aux_2964);
				      }
				      if (test_2963)
					{
					   {
					      long i_2969;
					      i_2969 = (i_937 + ((long) 1));
					      i_937 = i_2969;
					      goto loop_938;
					   }
					}
				      else
					{
					   FAILURE(BFALSE, string2288_expand_object, form_67);
					}
				   }
			      }
			      {
				 long i_943;
				 obj_t largs_944;
				 i_943 = ((long) 0);
				 largs_944 = BNIL;
			       loop_945:
				 if ((i_943 == len_879))
				   {
				      obj_t widening_949;
				      {
					 obj_t arg1928_1190;
					 obj_t arg1929_1191;
					 {
					    class_t obj_2100;
					    obj_2100 = (class_t) (class_68);
					    {
					       obj_t aux_2975;
					       {
						  object_t aux_2976;
						  aux_2976 = (object_t) (obj_2100);
						  aux_2975 = OBJECT_WIDENING(aux_2976);
					       }
					       arg1928_1190 = (((class_t) CREF(aux_2975))->widening);
					    }
					 }
					 arg1929_1191 = CNST_TABLE_REF(((long) 2));
					 {
					    obj_t list1932_1193;
					    {
					       obj_t arg1934_1194;
					       {
						  obj_t arg1935_1195;
						  {
						     obj_t aux_2981;
						     aux_2981 = (((type_t) CREF(class_68))->id);
						     arg1935_1195 = MAKE_PAIR(aux_2981, BNIL);
						  }
						  arg1934_1194 = MAKE_PAIR(arg1929_1191, arg1935_1195);
					       }
					       list1932_1193 = MAKE_PAIR(arg1928_1190, arg1934_1194);
					    }
					    widening_949 = symbol_append_197___r4_symbols_6_4(list1932_1193);
					 }
				      }
				      if (CBOOL(__unsafe_type__146_engine_param))
					{
					   obj_t arg1646_950;
					   obj_t arg1647_951;
					   obj_t arg1648_952;
					   obj_t arg1650_953;
					   arg1646_950 = CNST_TABLE_REF(((long) 1));
					   {
					      obj_t arg1659_961;
					      {
						 obj_t arg1664_965;
						 {
						    obj_t list1670_971;
						    {
						       obj_t arg1671_972;
						       {
							  obj_t arg1673_973;
							  arg1673_973 = MAKE_PAIR(BNIL, BNIL);
							  arg1671_972 = MAKE_PAIR(obj_69, arg1673_973);
						       }
						       list1670_971 = MAKE_PAIR(pragma_format_172_884, arg1671_972);
						    }
						    arg1664_965 = cons__138___r4_pairs_and_lists_6_3(pragma_typed_60_883, list1670_971);
						 }
						 {
						    obj_t list1666_967;
						    {
						       obj_t arg1667_968;
						       arg1667_968 = MAKE_PAIR(BNIL, BNIL);
						       list1666_967 = MAKE_PAIR(arg1664_965, arg1667_968);
						    }
						    arg1659_961 = cons__138___r4_pairs_and_lists_6_3(dup_var_typed_156_882, list1666_967);
						 }
					      }
					      {
						 obj_t list1662_963;
						 list1662_963 = MAKE_PAIR(BNIL, BNIL);
						 arg1647_951 = cons__138___r4_pairs_and_lists_6_3(arg1659_961, list1662_963);
					      }
					   }
					   {
					      obj_t arg1677_975;
					      obj_t arg1678_976;
					      arg1677_975 = CNST_TABLE_REF(((long) 13));
					      {
						 obj_t arg1686_982;
						 {
						    obj_t arg1689_985;
						    obj_t arg1690_986;
						    arg1689_985 = reverse__39___r4_pairs_and_lists_6_3(largs_944);
						    arg1690_986 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
						    arg1686_982 = append_2_18___r4_pairs_and_lists_6_3(arg1689_985, arg1690_986);
						 }
						 {
						    obj_t list1687_983;
						    list1687_983 = MAKE_PAIR(arg1686_982, BNIL);
						    arg1678_976 = cons__138___r4_pairs_and_lists_6_3(widening_949, list1687_983);
						 }
					      }
					      {
						 obj_t list1680_978;
						 {
						    obj_t arg1681_979;
						    {
						       obj_t arg1682_980;
						       arg1682_980 = MAKE_PAIR(BNIL, BNIL);
						       arg1681_979 = MAKE_PAIR(arg1678_976, arg1682_980);
						    }
						    list1680_978 = MAKE_PAIR(dup_var_35_881, arg1681_979);
						 }
						 arg1648_952 = cons__138___r4_pairs_and_lists_6_3(arg1677_975, list1680_978);
					      }
					   }
					   {
					      obj_t arg1693_989;
					      obj_t arg1694_990;
					      {
						 obj_t arg1701_996;
						 obj_t arg1702_997;
						 obj_t arg1703_998;
						 arg1701_996 = CNST_TABLE_REF(((long) 14));
						 arg1702_997 = CNST_TABLE_REF(((long) 15));
						 arg1703_998 = CNST_TABLE_REF(((long) 16));
						 {
						    obj_t list1705_1000;
						    {
						       obj_t arg1706_1001;
						       {
							  obj_t arg1707_1002;
							  arg1707_1002 = MAKE_PAIR(BNIL, BNIL);
							  arg1706_1001 = MAKE_PAIR(arg1703_998, arg1707_1002);
						       }
						       list1705_1000 = MAKE_PAIR(arg1702_997, arg1706_1001);
						    }
						    arg1693_989 = cons__138___r4_pairs_and_lists_6_3(arg1701_996, list1705_1000);
						 }
					      }
					      {
						 obj_t arg1709_1004;
						 obj_t arg1710_1005;
						 {
						    obj_t arg1716_1010;
						    obj_t arg1717_1011;
						    obj_t arg1718_1012;
						    arg1716_1010 = CNST_TABLE_REF(((long) 14));
						    arg1717_1011 = CNST_TABLE_REF(((long) 17));
						    arg1718_1012 = CNST_TABLE_REF(((long) 16));
						    {
						       obj_t list1720_1014;
						       {
							  obj_t arg1721_1015;
							  {
							     obj_t arg1722_1016;
							     arg1722_1016 = MAKE_PAIR(BNIL, BNIL);
							     arg1721_1015 = MAKE_PAIR(arg1718_1012, arg1722_1016);
							  }
							  list1720_1014 = MAKE_PAIR(arg1717_1011, arg1721_1015);
						       }
						       arg1709_1004 = cons__138___r4_pairs_and_lists_6_3(arg1716_1010, list1720_1014);
						    }
						 }
						 {
						    obj_t arg1725_1018;
						    obj_t arg1730_1019;
						    obj_t arg1731_1020;
						    arg1725_1018 = CNST_TABLE_REF(((long) 14));
						    arg1730_1019 = (((global_t) CREF(holder_878))->id);
						    arg1731_1020 = (((global_t) CREF(holder_878))->module);
						    {
						       obj_t list1733_1022;
						       {
							  obj_t arg1734_1023;
							  {
							     obj_t arg1735_1024;
							     arg1735_1024 = MAKE_PAIR(BNIL, BNIL);
							     arg1734_1023 = MAKE_PAIR(arg1731_1020, arg1735_1024);
							  }
							  list1733_1022 = MAKE_PAIR(arg1730_1019, arg1734_1023);
						       }
						       arg1710_1005 = cons__138___r4_pairs_and_lists_6_3(arg1725_1018, list1733_1022);
						    }
						 }
						 {
						    obj_t list1712_1007;
						    {
						       obj_t arg1714_1008;
						       arg1714_1008 = MAKE_PAIR(BNIL, BNIL);
						       list1712_1007 = MAKE_PAIR(arg1710_1005, arg1714_1008);
						    }
						    arg1694_990 = cons__138___r4_pairs_and_lists_6_3(arg1709_1004, list1712_1007);
						 }
					      }
					      {
						 obj_t list1696_992;
						 {
						    obj_t arg1697_993;
						    {
						       obj_t arg1698_994;
						       arg1698_994 = MAKE_PAIR(BNIL, BNIL);
						       arg1697_993 = MAKE_PAIR(arg1694_990, arg1698_994);
						    }
						    list1696_992 = MAKE_PAIR(dup_var_35_881, arg1697_993);
						 }
						 arg1650_953 = cons__138___r4_pairs_and_lists_6_3(arg1693_989, list1696_992);
					      }
					   }
					   {
					      obj_t list1652_955;
					      {
						 obj_t arg1653_956;
						 {
						    obj_t arg1654_957;
						    {
						       obj_t arg1655_958;
						       {
							  obj_t arg1656_959;
							  arg1656_959 = MAKE_PAIR(BNIL, BNIL);
							  arg1655_958 = MAKE_PAIR(dup_var_35_881, arg1656_959);
						       }
						       arg1654_957 = MAKE_PAIR(arg1650_953, arg1655_958);
						    }
						    arg1653_956 = MAKE_PAIR(arg1648_952, arg1654_957);
						 }
						 list1652_955 = MAKE_PAIR(arg1647_951, arg1653_956);
					      }
					      return cons__138___r4_pairs_and_lists_6_3(arg1646_950, list1652_955);
					   }
					}
				      else
					{
					   obj_t arg1737_1026;
					   obj_t arg1738_1027;
					   obj_t arg1740_1028;
					   obj_t arg1741_1029;
					   arg1737_1026 = CNST_TABLE_REF(((long) 1));
					   {
					      obj_t arg1749_1036;
					      {
						 obj_t arg1754_1040;
						 {
						    obj_t list1762_1046;
						    {
						       obj_t arg1763_1047;
						       {
							  obj_t arg1764_1048;
							  arg1764_1048 = MAKE_PAIR(BNIL, BNIL);
							  arg1763_1047 = MAKE_PAIR(obj_69, arg1764_1048);
						       }
						       list1762_1046 = MAKE_PAIR(pragma_format_172_884, arg1763_1047);
						    }
						    arg1754_1040 = cons__138___r4_pairs_and_lists_6_3(pragma_typed_60_883, list1762_1046);
						 }
						 {
						    obj_t list1756_1042;
						    {
						       obj_t arg1758_1043;
						       arg1758_1043 = MAKE_PAIR(BNIL, BNIL);
						       list1756_1042 = MAKE_PAIR(arg1754_1040, arg1758_1043);
						    }
						    arg1749_1036 = cons__138___r4_pairs_and_lists_6_3(dup_var_typed_156_882, list1756_1042);
						 }
					      }
					      {
						 obj_t list1752_1038;
						 list1752_1038 = MAKE_PAIR(BNIL, BNIL);
						 arg1738_1027 = cons__138___r4_pairs_and_lists_6_3(arg1749_1036, list1752_1038);
					      }
					   }
					   {
					      obj_t arg1767_1050;
					      obj_t arg1769_1051;
					      obj_t arg1770_1052;
					      arg1767_1050 = CNST_TABLE_REF(((long) 18));
					      {
						 obj_t arg1776_1058;
						 arg1776_1058 = CNST_TABLE_REF(((long) 19));
						 {
						    obj_t list1778_1060;
						    {
						       obj_t arg1779_1061;
						       arg1779_1061 = MAKE_PAIR(BNIL, BNIL);
						       list1778_1060 = MAKE_PAIR(dup_var_35_881, arg1779_1061);
						    }
						    arg1769_1051 = cons__138___r4_pairs_and_lists_6_3(arg1776_1058, list1778_1060);
						 }
					      }
					      {
						 obj_t arg1781_1063;
						 arg1781_1063 = CNST_TABLE_REF(((long) 20));
						 {
						    obj_t list1784_1065;
						    {
						       obj_t arg1785_1066;
						       arg1785_1066 = MAKE_PAIR(BNIL, BNIL);
						       list1784_1065 = MAKE_PAIR(dup_var_35_881, arg1785_1066);
						    }
						    arg1770_1052 = cons__138___r4_pairs_and_lists_6_3(arg1781_1063, list1784_1065);
						 }
					      }
					      {
						 obj_t list1772_1054;
						 {
						    obj_t arg1773_1055;
						    {
						       obj_t arg1774_1056;
						       arg1774_1056 = MAKE_PAIR(BNIL, BNIL);
						       arg1773_1055 = MAKE_PAIR(arg1770_1052, arg1774_1056);
						    }
						    list1772_1054 = MAKE_PAIR(arg1769_1051, arg1773_1055);
						 }
						 arg1740_1028 = cons__138___r4_pairs_and_lists_6_3(arg1767_1050, list1772_1054);
					      }
					   }
					   {
					      obj_t arg1788_1068;
					      obj_t arg1789_1069;
					      obj_t arg1791_1070;
					      obj_t arg1792_1071;
					      arg1788_1068 = CNST_TABLE_REF(((long) 18));
					      {
						 obj_t arg1800_1078;
						 obj_t arg1801_1079;
						 obj_t arg1802_1080;
						 arg1800_1078 = CNST_TABLE_REF(((long) 21));
						 {
						    obj_t arg1809_1086;
						    obj_t arg1810_1087;
						    {
						       obj_t arg1819_1092;
						       obj_t arg1820_1093;
						       obj_t arg1821_1094;
						       arg1819_1092 = CNST_TABLE_REF(((long) 14));
						       arg1820_1093 = CNST_TABLE_REF(((long) 22));
						       arg1821_1094 = CNST_TABLE_REF(((long) 16));
						       {
							  obj_t list1823_1096;
							  {
							     obj_t arg1824_1097;
							     {
								obj_t arg1825_1098;
								arg1825_1098 = MAKE_PAIR(BNIL, BNIL);
								arg1824_1097 = MAKE_PAIR(arg1821_1094, arg1825_1098);
							     }
							     list1823_1096 = MAKE_PAIR(arg1820_1093, arg1824_1097);
							  }
							  arg1809_1086 = cons__138___r4_pairs_and_lists_6_3(arg1819_1092, list1823_1096);
						       }
						    }
						    {
						       obj_t arg1827_1100;
						       obj_t arg1828_1101;
						       obj_t arg1829_1102;
						       arg1827_1100 = CNST_TABLE_REF(((long) 14));
						       arg1828_1101 = (((global_t) CREF(holder_878))->id);
						       arg1829_1102 = (((global_t) CREF(holder_878))->module);
						       {
							  obj_t list1831_1104;
							  {
							     obj_t arg1832_1105;
							     {
								obj_t arg1833_1106;
								arg1833_1106 = MAKE_PAIR(BNIL, BNIL);
								arg1832_1105 = MAKE_PAIR(arg1829_1102, arg1833_1106);
							     }
							     list1831_1104 = MAKE_PAIR(arg1828_1101, arg1832_1105);
							  }
							  arg1810_1087 = cons__138___r4_pairs_and_lists_6_3(arg1827_1100, list1831_1104);
						       }
						    }
						    {
						       obj_t list1812_1089;
						       {
							  obj_t arg1813_1090;
							  arg1813_1090 = MAKE_PAIR(BNIL, BNIL);
							  list1812_1089 = MAKE_PAIR(arg1810_1087, arg1813_1090);
						       }
						       arg1801_1079 = cons__138___r4_pairs_and_lists_6_3(arg1809_1086, list1812_1089);
						    }
						 }
						 {
						    obj_t arg1835_1108;
						    {
						       obj_t arg1840_1113;
						       obj_t arg1841_1114;
						       obj_t arg1842_1115;
						       arg1840_1113 = CNST_TABLE_REF(((long) 14));
						       arg1841_1114 = CNST_TABLE_REF(((long) 23));
						       arg1842_1115 = CNST_TABLE_REF(((long) 16));
						       {
							  obj_t list1844_1117;
							  {
							     obj_t arg1845_1118;
							     {
								obj_t arg1846_1119;
								arg1846_1119 = MAKE_PAIR(BNIL, BNIL);
								arg1845_1118 = MAKE_PAIR(arg1842_1115, arg1846_1119);
							     }
							     list1844_1117 = MAKE_PAIR(arg1841_1114, arg1845_1118);
							  }
							  arg1835_1108 = cons__138___r4_pairs_and_lists_6_3(arg1840_1113, list1844_1117);
						       }
						    }
						    {
						       obj_t list1837_1110;
						       {
							  obj_t arg1838_1111;
							  arg1838_1111 = MAKE_PAIR(BNIL, BNIL);
							  list1837_1110 = MAKE_PAIR(dup_var_35_881, arg1838_1111);
						       }
						       arg1802_1080 = cons__138___r4_pairs_and_lists_6_3(arg1835_1108, list1837_1110);
						    }
						 }
						 {
						    obj_t list1805_1082;
						    {
						       obj_t arg1806_1083;
						       {
							  obj_t arg1807_1084;
							  arg1807_1084 = MAKE_PAIR(BNIL, BNIL);
							  arg1806_1083 = MAKE_PAIR(arg1802_1080, arg1807_1084);
						       }
						       list1805_1082 = MAKE_PAIR(arg1801_1079, arg1806_1083);
						    }
						    arg1789_1069 = cons__138___r4_pairs_and_lists_6_3(arg1800_1078, list1805_1082);
						 }
					      }
					      {
						 obj_t arg1848_1121;
						 obj_t arg1849_1122;
						 obj_t arg1852_1123;
						 arg1848_1121 = CNST_TABLE_REF(((long) 24));
						 {
						    obj_t arg1859_1130;
						    obj_t arg1860_1131;
						    arg1859_1130 = CNST_TABLE_REF(((long) 13));
						    {
						       obj_t arg1866_1137;
						       {
							  obj_t arg1871_1140;
							  obj_t arg1872_1141;
							  arg1871_1140 = reverse__39___r4_pairs_and_lists_6_3(largs_944);
							  arg1872_1141 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
							  arg1866_1137 = append_2_18___r4_pairs_and_lists_6_3(arg1871_1140, arg1872_1141);
						       }
						       {
							  obj_t list1867_1138;
							  list1867_1138 = MAKE_PAIR(arg1866_1137, BNIL);
							  arg1860_1131 = cons__138___r4_pairs_and_lists_6_3(widening_949, list1867_1138);
						       }
						    }
						    {
						       obj_t list1862_1133;
						       {
							  obj_t arg1863_1134;
							  {
							     obj_t arg1864_1135;
							     arg1864_1135 = MAKE_PAIR(BNIL, BNIL);
							     arg1863_1134 = MAKE_PAIR(arg1860_1131, arg1864_1135);
							  }
							  list1862_1133 = MAKE_PAIR(dup_var_35_881, arg1863_1134);
						       }
						       arg1849_1122 = cons__138___r4_pairs_and_lists_6_3(arg1859_1130, list1862_1133);
						    }
						 }
						 {
						    obj_t arg1876_1144;
						    obj_t arg1877_1145;
						    {
						       obj_t arg1884_1151;
						       obj_t arg1885_1152;
						       obj_t arg1886_1153;
						       arg1884_1151 = CNST_TABLE_REF(((long) 14));
						       arg1885_1152 = CNST_TABLE_REF(((long) 15));
						       arg1886_1153 = CNST_TABLE_REF(((long) 16));
						       {
							  obj_t list1888_1155;
							  {
							     obj_t arg1889_1156;
							     {
								obj_t arg1890_1157;
								arg1890_1157 = MAKE_PAIR(BNIL, BNIL);
								arg1889_1156 = MAKE_PAIR(arg1886_1153, arg1890_1157);
							     }
							     list1888_1155 = MAKE_PAIR(arg1885_1152, arg1889_1156);
							  }
							  arg1876_1144 = cons__138___r4_pairs_and_lists_6_3(arg1884_1151, list1888_1155);
						       }
						    }
						    {
						       obj_t arg1892_1159;
						       obj_t arg1893_1160;
						       {
							  obj_t arg1898_1165;
							  obj_t arg1899_1166;
							  obj_t arg1900_1167;
							  arg1898_1165 = CNST_TABLE_REF(((long) 14));
							  arg1899_1166 = CNST_TABLE_REF(((long) 17));
							  arg1900_1167 = CNST_TABLE_REF(((long) 16));
							  {
							     obj_t list1902_1169;
							     {
								obj_t arg1904_1170;
								{
								   obj_t arg1905_1171;
								   arg1905_1171 = MAKE_PAIR(BNIL, BNIL);
								   arg1904_1170 = MAKE_PAIR(arg1900_1167, arg1905_1171);
								}
								list1902_1169 = MAKE_PAIR(arg1899_1166, arg1904_1170);
							     }
							     arg1892_1159 = cons__138___r4_pairs_and_lists_6_3(arg1898_1165, list1902_1169);
							  }
						       }
						       {
							  obj_t arg1907_1173;
							  obj_t arg1908_1174;
							  obj_t arg1909_1175;
							  arg1907_1173 = CNST_TABLE_REF(((long) 14));
							  arg1908_1174 = (((global_t) CREF(holder_878))->id);
							  arg1909_1175 = (((global_t) CREF(holder_878))->module);
							  {
							     obj_t list1912_1177;
							     {
								obj_t arg1913_1178;
								{
								   obj_t arg1914_1179;
								   arg1914_1179 = MAKE_PAIR(BNIL, BNIL);
								   arg1913_1178 = MAKE_PAIR(arg1909_1175, arg1914_1179);
								}
								list1912_1177 = MAKE_PAIR(arg1908_1174, arg1913_1178);
							     }
							     arg1893_1160 = cons__138___r4_pairs_and_lists_6_3(arg1907_1173, list1912_1177);
							  }
						       }
						       {
							  obj_t list1895_1162;
							  {
							     obj_t arg1896_1163;
							     arg1896_1163 = MAKE_PAIR(BNIL, BNIL);
							     list1895_1162 = MAKE_PAIR(arg1893_1160, arg1896_1163);
							  }
							  arg1877_1145 = cons__138___r4_pairs_and_lists_6_3(arg1892_1159, list1895_1162);
						       }
						    }
						    {
						       obj_t list1880_1147;
						       {
							  obj_t arg1881_1148;
							  {
							     obj_t arg1882_1149;
							     arg1882_1149 = MAKE_PAIR(BNIL, BNIL);
							     arg1881_1148 = MAKE_PAIR(arg1877_1145, arg1882_1149);
							  }
							  list1880_1147 = MAKE_PAIR(dup_var_35_881, arg1881_1148);
						       }
						       arg1852_1123 = cons__138___r4_pairs_and_lists_6_3(arg1876_1144, list1880_1147);
						    }
						 }
						 {
						    obj_t list1854_1125;
						    {
						       obj_t arg1855_1126;
						       {
							  obj_t arg1856_1127;
							  {
							     obj_t arg1857_1128;
							     arg1857_1128 = MAKE_PAIR(BNIL, BNIL);
							     arg1856_1127 = MAKE_PAIR(dup_var_35_881, arg1857_1128);
							  }
							  arg1855_1126 = MAKE_PAIR(arg1852_1123, arg1856_1127);
						       }
						       list1854_1125 = MAKE_PAIR(arg1849_1122, arg1855_1126);
						    }
						    arg1791_1070 = cons__138___r4_pairs_and_lists_6_3(arg1848_1121, list1854_1125);
						 }
					      }
					      {
						 obj_t arg1916_1181;
						 arg1916_1181 = CNST_TABLE_REF(((long) 25));
						 {
						    obj_t list1922_1185;
						    {
						       obj_t arg1923_1186;
						       {
							  obj_t arg1925_1187;
							  {
							     obj_t arg1926_1188;
							     arg1926_1188 = MAKE_PAIR(BNIL, BNIL);
							     arg1925_1187 = MAKE_PAIR(dup_var_35_881, arg1926_1188);
							  }
							  arg1923_1186 = MAKE_PAIR(string2289_expand_object, arg1925_1187);
						       }
						       list1922_1185 = MAKE_PAIR(string2290_expand_object, arg1923_1186);
						    }
						    arg1792_1071 = cons__138___r4_pairs_and_lists_6_3(arg1916_1181, list1922_1185);
						 }
					      }
					      {
						 obj_t list1794_1073;
						 {
						    obj_t arg1795_1074;
						    {
						       obj_t arg1796_1075;
						       {
							  obj_t arg1798_1076;
							  arg1798_1076 = MAKE_PAIR(BNIL, BNIL);
							  arg1796_1075 = MAKE_PAIR(arg1792_1071, arg1798_1076);
						       }
						       arg1795_1074 = MAKE_PAIR(arg1791_1070, arg1796_1075);
						    }
						    list1794_1073 = MAKE_PAIR(arg1789_1069, arg1795_1074);
						 }
						 arg1741_1029 = cons__138___r4_pairs_and_lists_6_3(arg1788_1068, list1794_1073);
					      }
					   }
					   {
					      obj_t list1743_1031;
					      {
						 obj_t arg1745_1032;
						 {
						    obj_t arg1746_1033;
						    {
						       obj_t arg1747_1034;
						       arg1747_1034 = MAKE_PAIR(BNIL, BNIL);
						       arg1746_1033 = MAKE_PAIR(arg1741_1029, arg1747_1034);
						    }
						    arg1745_1032 = MAKE_PAIR(arg1740_1028, arg1746_1033);
						 }
						 list1743_1031 = MAKE_PAIR(arg1738_1027, arg1745_1032);
					      }
					      return cons__138___r4_pairs_and_lists_6_3(arg1737_1026, list1743_1031);
					   }
					}
				   }
				 else
				   {
				      long arg1937_1197;
				      obj_t arg1938_1198;
				      arg1937_1197 = (i_943 + ((long) 1));
				      {
					 obj_t aux_3160;
					 {
					    obj_t aux_3161;
					    aux_3161 = VECTOR_REF(vargs_880, i_943);
					    aux_3160 = CDR(aux_3161);
					 }
					 arg1938_1198 = MAKE_PAIR(aux_3160, largs_944);
				      }
				      {
					 obj_t largs_3166;
					 long i_3165;
					 i_3165 = arg1937_1197;
					 largs_3166 = arg1938_1198;
					 largs_944 = largs_3166;
					 i_943 = i_3165;
					 goto loop_945;
				      }
				   }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
find_slot_offset_103_expand_object(obj_t slots_2202, obj_t form_2201, obj_t s_name_91_1201)
{
   {
      obj_t slots_1203;
      long i_1204;
      slots_1203 = slots_2202;
      i_1204 = ((long) 0);
    loop_1205:
      if (NULLP(slots_1203))
	{
	   {
	      obj_t arg1943_1207;
	      {
		 obj_t arg1945_1209;
		 arg1945_1209 = SYMBOL_TO_STRING(s_name_91_1201);
		 {
		    obj_t list1948_1211;
		    {
		       obj_t arg1949_1212;
		       {
			  obj_t arg1950_1213;
			  arg1950_1213 = MAKE_PAIR(string2279_expand_object, BNIL);
			  arg1949_1212 = MAKE_PAIR(arg1945_1209, arg1950_1213);
		       }
		       list1948_1211 = MAKE_PAIR(string2291_expand_object, arg1949_1212);
		    }
		    arg1943_1207 = string_append_106___r4_strings_6_7(list1948_1211);
		 }
	      }
	      FAILURE(BFALSE, arg1943_1207, form_2201);
	   }
	}
      else
	{
	   bool_t test_3175;
	   {
	      obj_t aux_3176;
	      {
		 obj_t aux_3177;
		 aux_3177 = CAR(slots_1203);
		 aux_3176 = STRUCT_REF(aux_3177, ((long) 0));
	      }
	      test_3175 = (aux_3176 == s_name_91_1201);
	   }
	   if (test_3175)
	     {
		return BINT(i_1204);
	     }
	   else
	     {
		{
		   long i_3184;
		   obj_t slots_3182;
		   slots_3182 = CDR(slots_1203);
		   i_3184 = (i_1204 + ((long) 1));
		   i_1204 = i_3184;
		   slots_1203 = slots_3182;
		   goto loop_1205;
		}
	     }
	}
   }
}


obj_t 
expand_shrink__128_expand_object(obj_t x_71, obj_t e_72)
{
   {
      if (PAIRP(x_71))
	{
	   obj_t cdr_363_114_1247;
	   cdr_363_114_1247 = CDR(x_71);
	   {
	      bool_t test_3189;
	      {
		 obj_t aux_3192;
		 obj_t aux_3190;
		 aux_3192 = CNST_TABLE_REF(((long) 20));
		 aux_3190 = CAR(x_71);
		 test_3189 = (aux_3190 == aux_3192);
	      }
	      if (test_3189)
		{
		   if (PAIRP(cdr_363_114_1247))
		     {
			bool_t test_3197;
			{
			   obj_t aux_3198;
			   aux_3198 = CDR(cdr_363_114_1247);
			   test_3197 = (aux_3198 == BNIL);
			}
			if (test_3197)
			  {
			     obj_t arg1992_2140;
			     arg1992_2140 = make_a_shrink__124_expand_object(e_72, CAR(cdr_363_114_1247));
			     return replace__160_tools_misc(x_71, arg1992_2140);
			  }
			else
			  {
			   tag_358_106_1244:
			     FAILURE(BFALSE, string2292_expand_object, x_71);
			  }
		     }
		   else
		     {
			goto tag_358_106_1244;
		     }
		}
	      else
		{
		   goto tag_358_106_1244;
		}
	   }
	}
      else
	{
	   goto tag_358_106_1244;
	}
   }
}


obj_t 
_expand_shrink__87_expand_object(obj_t env_2198, obj_t x_2199, obj_t e_2200)
{
   return expand_shrink__128_expand_object(x_2199, e_2200);
}


obj_t 
make_a_shrink__124_expand_object(obj_t e_73, obj_t o_74)
{
   {
      obj_t newo_1257;
      newo_1257 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 26)), BEOA);
      if (CBOOL(__unsafe_type__146_engine_param))
	{
	   obj_t arg1993_1258;
	   obj_t arg1995_1259;
	   obj_t arg1996_1260;
	   obj_t arg1997_1261;
	   arg1993_1258 = CNST_TABLE_REF(((long) 1));
	   {
	      obj_t arg2005_1269;
	      {
		 obj_t arg2009_1273;
		 arg2009_1273 = PROCEDURE_ENTRY(e_73) (e_73, o_74, e_73, BEOA);
		 {
		    obj_t list2013_1275;
		    {
		       obj_t arg2014_1276;
		       arg2014_1276 = MAKE_PAIR(BNIL, BNIL);
		       list2013_1275 = MAKE_PAIR(arg2009_1273, arg2014_1276);
		    }
		    arg2005_1269 = cons__138___r4_pairs_and_lists_6_3(newo_1257, list2013_1275);
		 }
	      }
	      {
		 obj_t list2007_1271;
		 list2007_1271 = MAKE_PAIR(BNIL, BNIL);
		 arg1995_1259 = cons__138___r4_pairs_and_lists_6_3(arg2005_1269, list2007_1271);
	      }
	   }
	   {
	      obj_t arg2016_1278;
	      obj_t arg2017_1279;
	      {
		 obj_t arg2025_1285;
		 obj_t arg2026_1286;
		 obj_t arg2027_1287;
		 arg2025_1285 = CNST_TABLE_REF(((long) 14));
		 arg2026_1286 = CNST_TABLE_REF(((long) 15));
		 arg2027_1287 = CNST_TABLE_REF(((long) 16));
		 {
		    obj_t list2029_1289;
		    {
		       obj_t arg2030_1290;
		       {
			  obj_t arg2031_1291;
			  arg2031_1291 = MAKE_PAIR(BNIL, BNIL);
			  arg2030_1290 = MAKE_PAIR(arg2027_1287, arg2031_1291);
		       }
		       list2029_1289 = MAKE_PAIR(arg2026_1286, arg2030_1290);
		    }
		    arg2016_1278 = cons__138___r4_pairs_and_lists_6_3(arg2025_1285, list2029_1289);
		 }
	      }
	      {
		 obj_t arg2033_1293;
		 obj_t arg2034_1294;
		 {
		    obj_t arg2040_1299;
		    obj_t arg2041_1300;
		    obj_t arg2043_1301;
		    arg2040_1299 = CNST_TABLE_REF(((long) 14));
		    arg2041_1300 = CNST_TABLE_REF(((long) 17));
		    arg2043_1301 = CNST_TABLE_REF(((long) 16));
		    {
		       obj_t list2046_1303;
		       {
			  obj_t arg2047_1304;
			  {
			     obj_t arg2048_1305;
			     arg2048_1305 = MAKE_PAIR(BNIL, BNIL);
			     arg2047_1304 = MAKE_PAIR(arg2043_1301, arg2048_1305);
			  }
			  list2046_1303 = MAKE_PAIR(arg2041_1300, arg2047_1304);
		       }
		       arg2033_1293 = cons__138___r4_pairs_and_lists_6_3(arg2040_1299, list2046_1303);
		    }
		 }
		 {
		    obj_t arg2051_1307;
		    obj_t arg2052_1308;
		    {
		       obj_t arg2057_1313;
		       obj_t arg2058_1314;
		       obj_t arg2059_1315;
		       arg2057_1313 = CNST_TABLE_REF(((long) 14));
		       arg2058_1314 = CNST_TABLE_REF(((long) 22));
		       arg2059_1315 = CNST_TABLE_REF(((long) 16));
		       {
			  obj_t list2061_1317;
			  {
			     obj_t arg2062_1318;
			     {
				obj_t arg2065_1319;
				arg2065_1319 = MAKE_PAIR(BNIL, BNIL);
				arg2062_1318 = MAKE_PAIR(arg2059_1315, arg2065_1319);
			     }
			     list2061_1317 = MAKE_PAIR(arg2058_1314, arg2062_1318);
			  }
			  arg2051_1307 = cons__138___r4_pairs_and_lists_6_3(arg2057_1313, list2061_1317);
		       }
		    }
		    {
		       obj_t arg2068_1321;
		       {
			  obj_t arg2073_1326;
			  obj_t arg2074_1327;
			  obj_t arg2076_1328;
			  arg2073_1326 = CNST_TABLE_REF(((long) 14));
			  arg2074_1327 = CNST_TABLE_REF(((long) 23));
			  arg2076_1328 = CNST_TABLE_REF(((long) 16));
			  {
			     obj_t list2078_1330;
			     {
				obj_t arg2079_1331;
				{
				   obj_t arg2080_1332;
				   arg2080_1332 = MAKE_PAIR(BNIL, BNIL);
				   arg2079_1331 = MAKE_PAIR(arg2076_1328, arg2080_1332);
				}
				list2078_1330 = MAKE_PAIR(arg2074_1327, arg2079_1331);
			     }
			     arg2068_1321 = cons__138___r4_pairs_and_lists_6_3(arg2073_1326, list2078_1330);
			  }
		       }
		       {
			  obj_t list2070_1323;
			  {
			     obj_t arg2071_1324;
			     arg2071_1324 = MAKE_PAIR(BNIL, BNIL);
			     list2070_1323 = MAKE_PAIR(newo_1257, arg2071_1324);
			  }
			  arg2052_1308 = cons__138___r4_pairs_and_lists_6_3(arg2068_1321, list2070_1323);
		       }
		    }
		    {
		       obj_t list2054_1310;
		       {
			  obj_t arg2055_1311;
			  arg2055_1311 = MAKE_PAIR(BNIL, BNIL);
			  list2054_1310 = MAKE_PAIR(arg2052_1308, arg2055_1311);
		       }
		       arg2034_1294 = cons__138___r4_pairs_and_lists_6_3(arg2051_1307, list2054_1310);
		    }
		 }
		 {
		    obj_t list2036_1296;
		    {
		       obj_t arg2037_1297;
		       arg2037_1297 = MAKE_PAIR(BNIL, BNIL);
		       list2036_1296 = MAKE_PAIR(arg2034_1294, arg2037_1297);
		    }
		    arg2017_1279 = cons__138___r4_pairs_and_lists_6_3(arg2033_1293, list2036_1296);
		 }
	      }
	      {
		 obj_t list2019_1281;
		 {
		    obj_t arg2020_1282;
		    {
		       obj_t arg2021_1283;
		       arg2021_1283 = MAKE_PAIR(BNIL, BNIL);
		       arg2020_1282 = MAKE_PAIR(arg2017_1279, arg2021_1283);
		    }
		    list2019_1281 = MAKE_PAIR(newo_1257, arg2020_1282);
		 }
		 arg1996_1260 = cons__138___r4_pairs_and_lists_6_3(arg2016_1278, list2019_1281);
	      }
	   }
	   {
	      obj_t arg2083_1334;
	      arg2083_1334 = CNST_TABLE_REF(((long) 13));
	      {
		 obj_t list2085_1336;
		 {
		    obj_t arg2086_1337;
		    {
		       obj_t arg2087_1338;
		       arg2087_1338 = MAKE_PAIR(BNIL, BNIL);
		       arg2086_1337 = MAKE_PAIR(BFALSE, arg2087_1338);
		    }
		    list2085_1336 = MAKE_PAIR(newo_1257, arg2086_1337);
		 }
		 arg1997_1261 = cons__138___r4_pairs_and_lists_6_3(arg2083_1334, list2085_1336);
	      }
	   }
	   {
	      obj_t list1999_1263;
	      {
		 obj_t arg2000_1264;
		 {
		    obj_t arg2001_1265;
		    {
		       obj_t arg2002_1266;
		       {
			  obj_t arg2003_1267;
			  arg2003_1267 = MAKE_PAIR(BNIL, BNIL);
			  arg2002_1266 = MAKE_PAIR(newo_1257, arg2003_1267);
		       }
		       arg2001_1265 = MAKE_PAIR(arg1997_1261, arg2002_1266);
		    }
		    arg2000_1264 = MAKE_PAIR(arg1996_1260, arg2001_1265);
		 }
		 list1999_1263 = MAKE_PAIR(arg1995_1259, arg2000_1264);
	      }
	      return cons__138___r4_pairs_and_lists_6_3(arg1993_1258, list1999_1263);
	   }
	}
      else
	{
	   obj_t arg2089_1340;
	   obj_t arg2091_1341;
	   obj_t arg2092_1342;
	   arg2089_1340 = CNST_TABLE_REF(((long) 1));
	   {
	      obj_t arg2100_1348;
	      {
		 obj_t arg2104_1352;
		 arg2104_1352 = PROCEDURE_ENTRY(e_73) (e_73, o_74, e_73, BEOA);
		 {
		    obj_t list2106_1354;
		    {
		       obj_t arg2107_1355;
		       arg2107_1355 = MAKE_PAIR(BNIL, BNIL);
		       list2106_1354 = MAKE_PAIR(arg2104_1352, arg2107_1355);
		    }
		    arg2100_1348 = cons__138___r4_pairs_and_lists_6_3(newo_1257, list2106_1354);
		 }
	      }
	      {
		 obj_t list2102_1350;
		 list2102_1350 = MAKE_PAIR(BNIL, BNIL);
		 arg2091_1341 = cons__138___r4_pairs_and_lists_6_3(arg2100_1348, list2102_1350);
	      }
	   }
	   {
	      obj_t arg2109_1357;
	      obj_t arg2110_1358;
	      obj_t arg2111_1359;
	      obj_t arg2112_1360;
	      arg2109_1357 = CNST_TABLE_REF(((long) 18));
	      {
		 obj_t arg2120_1367;
		 arg2120_1367 = CNST_TABLE_REF(((long) 27));
		 {
		    obj_t list2122_1369;
		    {
		       obj_t arg2123_1370;
		       arg2123_1370 = MAKE_PAIR(BNIL, BNIL);
		       list2122_1369 = MAKE_PAIR(newo_1257, arg2123_1370);
		    }
		    arg2110_1358 = cons__138___r4_pairs_and_lists_6_3(arg2120_1367, list2122_1369);
		 }
	      }
	      {
		 obj_t arg2125_1372;
		 obj_t arg2126_1373;
		 obj_t arg2127_1374;
		 obj_t arg2128_1375;
		 arg2125_1372 = CNST_TABLE_REF(((long) 18));
		 {
		    obj_t arg2135_1382;
		    arg2135_1382 = CNST_TABLE_REF(((long) 19));
		    {
		       obj_t list2137_1384;
		       {
			  obj_t arg2138_1385;
			  arg2138_1385 = MAKE_PAIR(BNIL, BNIL);
			  list2137_1384 = MAKE_PAIR(newo_1257, arg2138_1385);
		       }
		       arg2126_1373 = cons__138___r4_pairs_and_lists_6_3(arg2135_1382, list2137_1384);
		    }
		 }
		 {
		    obj_t arg2141_1387;
		    obj_t arg2142_1388;
		    obj_t arg2143_1389;
		    arg2141_1387 = CNST_TABLE_REF(((long) 24));
		    {
		       obj_t arg2151_1396;
		       obj_t arg2152_1397;
		       {
			  obj_t arg2161_1403;
			  obj_t arg2162_1404;
			  obj_t arg2163_1405;
			  arg2161_1403 = CNST_TABLE_REF(((long) 14));
			  arg2162_1404 = CNST_TABLE_REF(((long) 15));
			  arg2163_1405 = CNST_TABLE_REF(((long) 16));
			  {
			     obj_t list2165_1407;
			     {
				obj_t arg2166_1408;
				{
				   obj_t arg2167_1409;
				   arg2167_1409 = MAKE_PAIR(BNIL, BNIL);
				   arg2166_1408 = MAKE_PAIR(arg2163_1405, arg2167_1409);
				}
				list2165_1407 = MAKE_PAIR(arg2162_1404, arg2166_1408);
			     }
			     arg2151_1396 = cons__138___r4_pairs_and_lists_6_3(arg2161_1403, list2165_1407);
			  }
		       }
		       {
			  obj_t arg2169_1411;
			  obj_t arg2170_1412;
			  {
			     obj_t arg2175_1417;
			     obj_t arg2176_1418;
			     obj_t arg2177_1419;
			     arg2175_1417 = CNST_TABLE_REF(((long) 14));
			     arg2176_1418 = CNST_TABLE_REF(((long) 17));
			     arg2177_1419 = CNST_TABLE_REF(((long) 16));
			     {
				obj_t list2179_1421;
				{
				   obj_t arg2180_1422;
				   {
				      obj_t arg2181_1423;
				      arg2181_1423 = MAKE_PAIR(BNIL, BNIL);
				      arg2180_1422 = MAKE_PAIR(arg2177_1419, arg2181_1423);
				   }
				   list2179_1421 = MAKE_PAIR(arg2176_1418, arg2180_1422);
				}
				arg2169_1411 = cons__138___r4_pairs_and_lists_6_3(arg2175_1417, list2179_1421);
			     }
			  }
			  {
			     obj_t arg2183_1425;
			     obj_t arg2184_1426;
			     {
				obj_t arg2189_1431;
				obj_t arg2190_1432;
				obj_t arg2191_1433;
				arg2189_1431 = CNST_TABLE_REF(((long) 14));
				arg2190_1432 = CNST_TABLE_REF(((long) 22));
				arg2191_1433 = CNST_TABLE_REF(((long) 16));
				{
				   obj_t list2193_1435;
				   {
				      obj_t arg2194_1436;
				      {
					 obj_t arg2195_1437;
					 arg2195_1437 = MAKE_PAIR(BNIL, BNIL);
					 arg2194_1436 = MAKE_PAIR(arg2191_1433, arg2195_1437);
				      }
				      list2193_1435 = MAKE_PAIR(arg2190_1432, arg2194_1436);
				   }
				   arg2183_1425 = cons__138___r4_pairs_and_lists_6_3(arg2189_1431, list2193_1435);
				}
			     }
			     {
				obj_t arg2197_1439;
				{
				   obj_t arg2202_1444;
				   obj_t arg2203_1445;
				   obj_t arg2204_1446;
				   arg2202_1444 = CNST_TABLE_REF(((long) 14));
				   arg2203_1445 = CNST_TABLE_REF(((long) 23));
				   arg2204_1446 = CNST_TABLE_REF(((long) 16));
				   {
				      obj_t list2206_1448;
				      {
					 obj_t arg2207_1449;
					 {
					    obj_t arg2208_1450;
					    arg2208_1450 = MAKE_PAIR(BNIL, BNIL);
					    arg2207_1449 = MAKE_PAIR(arg2204_1446, arg2208_1450);
					 }
					 list2206_1448 = MAKE_PAIR(arg2203_1445, arg2207_1449);
				      }
				      arg2197_1439 = cons__138___r4_pairs_and_lists_6_3(arg2202_1444, list2206_1448);
				   }
				}
				{
				   obj_t list2199_1441;
				   {
				      obj_t arg2200_1442;
				      arg2200_1442 = MAKE_PAIR(BNIL, BNIL);
				      list2199_1441 = MAKE_PAIR(newo_1257, arg2200_1442);
				   }
				   arg2184_1426 = cons__138___r4_pairs_and_lists_6_3(arg2197_1439, list2199_1441);
				}
			     }
			     {
				obj_t list2186_1428;
				{
				   obj_t arg2187_1429;
				   arg2187_1429 = MAKE_PAIR(BNIL, BNIL);
				   list2186_1428 = MAKE_PAIR(arg2184_1426, arg2187_1429);
				}
				arg2170_1412 = cons__138___r4_pairs_and_lists_6_3(arg2183_1425, list2186_1428);
			     }
			  }
			  {
			     obj_t list2172_1414;
			     {
				obj_t arg2173_1415;
				arg2173_1415 = MAKE_PAIR(BNIL, BNIL);
				list2172_1414 = MAKE_PAIR(arg2170_1412, arg2173_1415);
			     }
			     arg2152_1397 = cons__138___r4_pairs_and_lists_6_3(arg2169_1411, list2172_1414);
			  }
		       }
		       {
			  obj_t list2154_1399;
			  {
			     obj_t arg2155_1400;
			     {
				obj_t arg2156_1401;
				arg2156_1401 = MAKE_PAIR(BNIL, BNIL);
				arg2155_1400 = MAKE_PAIR(arg2152_1397, arg2156_1401);
			     }
			     list2154_1399 = MAKE_PAIR(newo_1257, arg2155_1400);
			  }
			  arg2142_1388 = cons__138___r4_pairs_and_lists_6_3(arg2151_1396, list2154_1399);
		       }
		    }
		    {
		       obj_t arg2210_1452;
		       arg2210_1452 = CNST_TABLE_REF(((long) 13));
		       {
			  obj_t list2212_1454;
			  {
			     obj_t arg2213_1455;
			     {
				obj_t arg2214_1456;
				arg2214_1456 = MAKE_PAIR(BNIL, BNIL);
				arg2213_1455 = MAKE_PAIR(BFALSE, arg2214_1456);
			     }
			     list2212_1454 = MAKE_PAIR(newo_1257, arg2213_1455);
			  }
			  arg2143_1389 = cons__138___r4_pairs_and_lists_6_3(arg2210_1452, list2212_1454);
		       }
		    }
		    {
		       obj_t list2145_1391;
		       {
			  obj_t arg2146_1392;
			  {
			     obj_t arg2148_1393;
			     {
				obj_t arg2149_1394;
				arg2149_1394 = MAKE_PAIR(BNIL, BNIL);
				arg2148_1393 = MAKE_PAIR(newo_1257, arg2149_1394);
			     }
			     arg2146_1392 = MAKE_PAIR(arg2143_1389, arg2148_1393);
			  }
			  list2145_1391 = MAKE_PAIR(arg2142_1388, arg2146_1392);
		       }
		       arg2127_1374 = cons__138___r4_pairs_and_lists_6_3(arg2141_1387, list2145_1391);
		    }
		 }
		 {
		    obj_t arg2216_1458;
		    arg2216_1458 = CNST_TABLE_REF(((long) 25));
		    {
		       obj_t list2220_1462;
		       {
			  obj_t arg2221_1463;
			  {
			     obj_t arg2222_1464;
			     {
				obj_t arg2223_1465;
				arg2223_1465 = MAKE_PAIR(BNIL, BNIL);
				arg2222_1464 = MAKE_PAIR(newo_1257, arg2223_1465);
			     }
			     arg2221_1463 = MAKE_PAIR(string2293_expand_object, arg2222_1464);
			  }
			  list2220_1462 = MAKE_PAIR(string2294_expand_object, arg2221_1463);
		       }
		       arg2128_1375 = cons__138___r4_pairs_and_lists_6_3(arg2216_1458, list2220_1462);
		    }
		 }
		 {
		    obj_t list2130_1377;
		    {
		       obj_t arg2131_1378;
		       {
			  obj_t arg2132_1379;
			  {
			     obj_t arg2133_1380;
			     arg2133_1380 = MAKE_PAIR(BNIL, BNIL);
			     arg2132_1379 = MAKE_PAIR(arg2128_1375, arg2133_1380);
			  }
			  arg2131_1378 = MAKE_PAIR(arg2127_1374, arg2132_1379);
		       }
		       list2130_1377 = MAKE_PAIR(arg2126_1373, arg2131_1378);
		    }
		    arg2111_1359 = cons__138___r4_pairs_and_lists_6_3(arg2125_1372, list2130_1377);
		 }
	      }
	      {
		 obj_t arg2225_1467;
		 arg2225_1467 = CNST_TABLE_REF(((long) 25));
		 {
		    obj_t list2229_1471;
		    {
		       obj_t arg2230_1472;
		       {
			  obj_t arg2231_1473;
			  {
			     obj_t arg2232_1474;
			     arg2232_1474 = MAKE_PAIR(BNIL, BNIL);
			     arg2231_1473 = MAKE_PAIR(newo_1257, arg2232_1474);
			  }
			  arg2230_1472 = MAKE_PAIR(string2293_expand_object, arg2231_1473);
		       }
		       list2229_1471 = MAKE_PAIR(string2294_expand_object, arg2230_1472);
		    }
		    arg2112_1360 = cons__138___r4_pairs_and_lists_6_3(arg2225_1467, list2229_1471);
		 }
	      }
	      {
		 obj_t list2114_1362;
		 {
		    obj_t arg2115_1363;
		    {
		       obj_t arg2117_1364;
		       {
			  obj_t arg2118_1365;
			  arg2118_1365 = MAKE_PAIR(BNIL, BNIL);
			  arg2117_1364 = MAKE_PAIR(arg2112_1360, arg2118_1365);
		       }
		       arg2115_1363 = MAKE_PAIR(arg2111_1359, arg2117_1364);
		    }
		    list2114_1362 = MAKE_PAIR(arg2110_1358, arg2115_1363);
		 }
		 arg2092_1342 = cons__138___r4_pairs_and_lists_6_3(arg2109_1357, list2114_1362);
	      }
	   }
	   {
	      obj_t list2096_1344;
	      {
		 obj_t arg2097_1345;
		 {
		    obj_t arg2098_1346;
		    arg2098_1346 = MAKE_PAIR(BNIL, BNIL);
		    arg2097_1345 = MAKE_PAIR(arg2092_1342, arg2098_1346);
		 }
		 list2096_1344 = MAKE_PAIR(arg2091_1341, arg2097_1345);
	      }
	      return cons__138___r4_pairs_and_lists_6_3(arg2089_1340, list2096_1344);
	   }
	}
   }
}


obj_t 
imported_modules_init_94_expand_object()
{
   module_initialization_70_tools_args(((long) 0), "EXPAND_OBJECT");
   module_initialization_70_tools_progn(((long) 0), "EXPAND_OBJECT");
   module_initialization_70_tools_misc(((long) 0), "EXPAND_OBJECT");
   module_initialization_70_type_type(((long) 0), "EXPAND_OBJECT");
   module_initialization_70_type_env(((long) 0), "EXPAND_OBJECT");
   module_initialization_70_expand_eps(((long) 0), "EXPAND_OBJECT");
   module_initialization_70_engine_param(((long) 0), "EXPAND_OBJECT");
   module_initialization_70_ast_var(((long) 0), "EXPAND_OBJECT");
   module_initialization_70_ast_ident(((long) 0), "EXPAND_OBJECT");
   return module_initialization_70_object_class(((long) 0), "EXPAND_OBJECT");
}
