/*===========================================================================*/
/*   (Fail/walk.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t let_fun_218_ast_node;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t __classes__134___object;
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_fail_walk();
extern obj_t module_initialization_70_fail_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t toplevel_init_63_fail_walk();
static obj_t cnst_init_137_fail_walk();
extern obj_t fail_walk__172_fail_walk(obj_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t require_initialization_114_fail_walk = BUNSPEC;
extern obj_t var_ast_node;
static obj_t library_modules_init_112_fail_walk();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
static obj_t fail_fun__97_fail_walk(obj_t);
static obj_t __error__173_fail_walk = BUNSPEC;
extern obj_t select_ast_node;
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t enter_function_81_tools_error(obj_t);
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t pragma_ast_node;
extern obj_t current_error_port;
extern obj_t app_ly_162_ast_node;
static obj_t _fail_node__default1301_129_fail_walk(obj_t, obj_t);
extern obj_t jump_ex_it_184_ast_node;
static obj_t _fail_node__15_fail_walk(obj_t, obj_t);
static obj_t fail_node___231_fail_walk(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t _fail_walk__150_fail_walk(obj_t, obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
static node_t fail_node__default1301_236_fail_walk(node_t);
extern obj_t set_ex_it_116_ast_node;
extern obj_t location_full_fname_231_tools_location(obj_t);
extern obj_t kwote_ast_node;
extern obj_t box_ref_242_ast_node;
static node_t fail_node__137_fail_walk(node_t);
extern obj_t __current_pass__25_engine_pass;
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t app_ast_node;
extern obj_t leave_function_170_tools_error();
static obj_t __cnst[6];

DEFINE_STRING(string1680_fail_walk, string1680_fail_walk1688, "No method for this object", 25);
DEFINE_STRING(string1674_fail_walk, string1674_fail_walk1689, "Fail", 4);
DEFINE_STATIC_PROCEDURE(fail_node__default1301_env_94_fail_walk, _fail_node__default1301_129_fail_walk1690, _fail_node__default1301_129_fail_walk, 0L, 1);
DEFINE_STRING(string1681_fail_walk, string1681_fail_walk1691, "DONE VALUE DEBUG-ERROR/LOCATION LOCATION FAIL-NODE!-DEFAULT1301 PASS-STARTED ", 77);
DEFINE_EXPORT_PROCEDURE(fail_walk__env_224_fail_walk, _fail_walk__150_fail_walk1692, _fail_walk__150_fail_walk, 0L, 1);
DEFINE_STRING(string1676_fail_walk, string1676_fail_walk1693, "failure during prelude hook", 27);
DEFINE_STRING(string1677_fail_walk, string1677_fail_walk1694, " occured, ending ...", 20);
DEFINE_STRING(string1675_fail_walk, string1675_fail_walk1695, "   . ", 5);
DEFINE_STRING(string1679_fail_walk, string1679_fail_walk1696, "failure during postlude hook", 28);
DEFINE_STRING(string1678_fail_walk, string1678_fail_walk1697, " error", 6);
DEFINE_STATIC_GENERIC(fail_node__env_77_fail_walk, _fail_node__15_fail_walk1698, _fail_node__15_fail_walk, 0L, 1);

obj_t 
module_initialization_70_fail_walk(long checksum_1413, char *from_1414)
{
   if (CBOOL(require_initialization_114_fail_walk))
     {
	require_initialization_114_fail_walk = BBOOL(((bool_t) 0));
	library_modules_init_112_fail_walk();
	cnst_init_137_fail_walk();
	imported_modules_init_94_fail_walk();
	toplevel_init_63_fail_walk();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_fail_walk()
{
   module_initialization_70___object(((long) 0), "FAIL_WALK");
   module_initialization_70___r4_output_6_10_3(((long) 0), "FAIL_WALK");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "FAIL_WALK");
   module_initialization_70___reader(((long) 0), "FAIL_WALK");
   module_initialization_70___r4_numbers_6_5(((long) 0), "FAIL_WALK");
   return BUNSPEC;
}


obj_t 
cnst_init_137_fail_walk()
{
   {
      obj_t cnst_port_138_1405;
      cnst_port_138_1405 = open_input_string(string1681_fail_walk);
      {
	 long i_1406;
	 i_1406 = ((long) 5);
       loop_1407:
	 {
	    bool_t test1682_1408;
	    test1682_1408 = (i_1406 == ((long) -1));
	    if (test1682_1408)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1684_1409;
		    {
		       obj_t list1685_1410;
		       {
			  obj_t arg1686_1411;
			  arg1686_1411 = BNIL;
			  list1685_1410 = MAKE_PAIR(cnst_port_138_1405, arg1686_1411);
		       }
		       arg1684_1409 = read___reader(list1685_1410);
		    }
		    CNST_TABLE_SET(i_1406, arg1684_1409);
		 }
		 {
		    int aux_1412;
		    {
		       long aux_1433;
		       aux_1433 = (i_1406 - ((long) 1));
		       aux_1412 = (int) (aux_1433);
		    }
		    {
		       long i_1436;
		       i_1436 = (long) (aux_1412);
		       i_1406 = i_1436;
		       goto loop_1407;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_fail_walk()
{
   __error__173_fail_walk = BUNSPEC;
   add_generic__110___object(fail_node__env_77_fail_walk, fail_node__default1301_env_94_fail_walk);
   add_inlined_method__244___object(fail_node__env_77_fail_walk, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, var_ast_node, ((long) 2));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, sequence_ast_node, ((long) 3));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, app_ast_node, ((long) 4));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, setq_ast_node, ((long) 8));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, conditional_ast_node, ((long) 9));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, fail_ast_node, ((long) 10));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, select_ast_node, ((long) 11));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, let_fun_218_ast_node, ((long) 12));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, let_var_6_ast_node, ((long) 13));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, set_ex_it_116_ast_node, ((long) 14));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, jump_ex_it_184_ast_node, ((long) 15));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, make_box_202_ast_node, ((long) 16));
   add_inlined_method__244___object(fail_node__env_77_fail_walk, box_ref_242_ast_node, ((long) 17));
   {
      long aux_1457;
      aux_1457 = add_inlined_method__244___object(fail_node__env_77_fail_walk, box_set__221_ast_node, ((long) 18));
      return BINT(aux_1457);
   }
}


obj_t 
fail_walk__172_fail_walk(obj_t globals_11)
{
   {
      obj_t list1344_681;
      {
	 obj_t arg1346_683;
	 {
	    obj_t arg1349_685;
	    {
	       obj_t aux_1460;
	       aux_1460 = BCHAR(((unsigned char) '\n'));
	       arg1349_685 = MAKE_PAIR(aux_1460, BNIL);
	    }
	    arg1346_683 = MAKE_PAIR(string1674_fail_walk, arg1349_685);
	 }
	 list1344_681 = MAKE_PAIR(string1675_fail_walk, arg1346_683);
      }
      verbose_tools_speek(BINT(((long) 1)), list1344_681);
   }
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   __current_pass__25_engine_pass = string1674_fail_walk;
   {
      obj_t hooks_687;
      obj_t hnames_688;
      hooks_687 = BNIL;
      hnames_688 = BNIL;
    loop_689:
      if (NULLP(hooks_687))
	{
	   CNST_TABLE_REF(((long) 0));
	}
      else
	{
	   bool_t test1356_694;
	   {
	      obj_t fun1365_700;
	      fun1365_700 = CAR(hooks_687);
	      {
		 obj_t aux_1472;
		 aux_1472 = PROCEDURE_ENTRY(fun1365_700) (fun1365_700, BEOA);
		 test1356_694 = CBOOL(aux_1472);
	      }
	   }
	   if (test1356_694)
	     {
		{
		   obj_t hnames_1479;
		   obj_t hooks_1477;
		   hooks_1477 = CDR(hooks_687);
		   hnames_1479 = CDR(hnames_688);
		   hnames_688 = hnames_1479;
		   hooks_687 = hooks_1477;
		   goto loop_689;
		}
	     }
	   else
	     {
		internal_error_43_tools_error(string1674_fail_walk, string1676_fail_walk, CAR(hnames_688));
	     }
	}
   }
   {
      obj_t l1272_701;
      l1272_701 = globals_11;
    lname1283_702:
      if (PAIRP(l1272_701))
	{
	   fail_fun__97_fail_walk(CAR(l1272_701));
	   {
	      obj_t l1272_1487;
	      l1272_1487 = CDR(l1272_701);
	      l1272_701 = l1272_1487;
	      goto lname1283_702;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      bool_t test1370_707;
      {
	 long n1_1211;
	 n1_1211 = (long) CINT(__nb_error_on_pass__70_tools_error);
	 test1370_707 = (n1_1211 > ((long) 0));
      }
      if (test1370_707)
	{
	   {
	      char *arg1379_710;
	      {
		 bool_t test1391_717;
		 {
		    bool_t test1392_718;
		    {
		       obj_t obj_1213;
		       obj_1213 = __nb_error_on_pass__70_tools_error;
		       test1392_718 = INTEGERP(obj_1213);
		    }
		    if (test1392_718)
		      {
			 test1391_717 = _2__206___r4_numbers_6_5(__nb_error_on_pass__70_tools_error, BINT(((long) 1)));
		      }
		    else
		      {
			 test1391_717 = ((bool_t) 0);
		      }
		 }
		 if (test1391_717)
		   {
		      arg1379_710 = "s";
		   }
		 else
		   {
		      arg1379_710 = "";
		   }
	      }
	      {
		 obj_t list1381_712;
		 {
		    obj_t arg1382_713;
		    {
		       obj_t arg1385_714;
		       {
			  obj_t arg1388_715;
			  arg1388_715 = MAKE_PAIR(string1677_fail_walk, BNIL);
			  {
			     obj_t aux_1498;
			     aux_1498 = string_to_bstring(arg1379_710);
			     arg1385_714 = MAKE_PAIR(aux_1498, arg1388_715);
			  }
		       }
		       arg1382_713 = MAKE_PAIR(string1678_fail_walk, arg1385_714);
		    }
		    list1381_712 = MAKE_PAIR(__nb_error_on_pass__70_tools_error, arg1382_713);
		 }
		 fprint___r4_output_6_10_3(current_error_port, list1381_712);
	      }
	   }
	   {
	      obj_t res1653_1215;
	      exit(((long) -1));
	      res1653_1215 = BINT(((long) -1));
	      return res1653_1215;
	   }
	}
      else
	{
	   obj_t hooks_719;
	   obj_t hnames_720;
	   hooks_719 = BNIL;
	   hnames_720 = BNIL;
	 loop_721:
	   if (NULLP(hooks_719))
	     {
		return globals_11;
	     }
	   else
	     {
		bool_t test1401_726;
		{
		   obj_t fun1407_731;
		   fun1407_731 = CAR(hooks_719);
		   {
		      obj_t aux_1509;
		      aux_1509 = PROCEDURE_ENTRY(fun1407_731) (fun1407_731, BEOA);
		      test1401_726 = CBOOL(aux_1509);
		   }
		}
		if (test1401_726)
		  {
		     {
			obj_t hnames_1516;
			obj_t hooks_1514;
			hooks_1514 = CDR(hooks_719);
			hnames_1516 = CDR(hnames_720);
			hnames_720 = hnames_1516;
			hooks_719 = hooks_1514;
			goto loop_721;
		     }
		  }
		else
		  {
		     return internal_error_43_tools_error(__current_pass__25_engine_pass, string1679_fail_walk, CAR(hnames_720));
		  }
	     }
	}
   }
}


obj_t 
_fail_walk__150_fail_walk(obj_t env_1383, obj_t globals_1384)
{
   return fail_walk__172_fail_walk(globals_1384);
}


obj_t 
fail_fun__97_fail_walk(obj_t var_12)
{
   {
      value_t fun_732;
      {
	 variable_t obj_1222;
	 obj_1222 = (variable_t) (var_12);
	 fun_732 = (((variable_t) CREF(obj_1222))->value);
      }
      {
	 obj_t body_733;
	 {
	    sfun_t obj_1223;
	    obj_1223 = (sfun_t) (fun_732);
	    body_733 = (((sfun_t) CREF(obj_1223))->body);
	 }
	 {
	    {
	       obj_t aux_1525;
	       {
		  variable_t obj_1225;
		  obj_1225 = (variable_t) (var_12);
		  aux_1525 = (((variable_t) CREF(obj_1225))->id);
	       }
	       enter_function_81_tools_error(aux_1525);
	    }
	    {
	       node_t arg1410_736;
	       arg1410_736 = fail_node__137_fail_walk((node_t) (body_733));
	       {
		  obj_t res1654_1228;
		  {
		     sfun_t obj_1226;
		     obj_t val1077_1227;
		     obj_1226 = (sfun_t) (fun_732);
		     val1077_1227 = (obj_t) (arg1410_736);
		     {
			obj_t x_1386;
			x_1386 = ((((sfun_t) CREF(obj_1226))->body) = ((obj_t) val1077_1227), BUNSPEC);
			res1654_1228 = BUNSPEC;
		     }
		  }
		  res1654_1228;
	       }
	    }
	    return leave_function_170_tools_error();
	 }
      }
   }
}


node_t 
fail_node__default1301_236_fail_walk(node_t node_14)
{
   FAILURE(CNST_TABLE_REF(((long) 1)), string1680_fail_walk, (obj_t) (node_14));
}


obj_t 
_fail_node__default1301_129_fail_walk(obj_t env_1381, obj_t node_1382)
{
   {
      node_t aux_1538;
      aux_1538 = fail_node__default1301_236_fail_walk((node_t) (node_1382));
      return (obj_t) (aux_1538);
   }
}


node_t 
fail_node__137_fail_walk(node_t node_13)
{
   {
      obj_t method1533_1057;
      obj_t class1538_1058;
      {
	 obj_t arg1541_1055;
	 obj_t arg1542_1056;
	 {
	    object_t obj_1234;
	    obj_1234 = (object_t) (node_13);
	    {
	       obj_t pre_method_105_1235;
	       pre_method_105_1235 = PROCEDURE_REF(fail_node__env_77_fail_walk, ((long) 2));
	       if (INTEGERP(pre_method_105_1235))
		 {
		    PROCEDURE_SET(fail_node__env_77_fail_walk, ((long) 2), BUNSPEC);
		    arg1541_1055 = pre_method_105_1235;
		 }
	       else
		 {
		    long obj_class_num_177_1240;
		    obj_class_num_177_1240 = TYPE(obj_1234);
		    {
		       obj_t arg1183_1241;
		       arg1183_1241 = PROCEDURE_REF(fail_node__env_77_fail_walk, ((long) 1));
		       {
			  long arg1184_1245;
			  {
			     long arg1186_1246;
			     arg1186_1246 = OBJECT_TYPE;
			     arg1184_1245 = (obj_class_num_177_1240 - arg1186_1246);
			  }
			  arg1541_1055 = VECTOR_REF(arg1183_1241, arg1184_1245);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1251;
	    object_1251 = (object_t) (node_13);
	    {
	       long arg1187_1252;
	       {
		  long arg1188_1253;
		  long arg1189_1254;
		  arg1188_1253 = TYPE(object_1251);
		  arg1189_1254 = OBJECT_TYPE;
		  arg1187_1252 = (arg1188_1253 - arg1189_1254);
	       }
	       {
		  obj_t vector_1258;
		  vector_1258 = __classes__134___object;
		  arg1542_1056 = VECTOR_REF(vector_1258, arg1187_1252);
	       }
	    }
	 }
	 {
	    obj_t aux_1557;
	    method1533_1057 = arg1541_1055;
	    class1538_1058 = arg1542_1056;
	    {
	       if (INTEGERP(method1533_1057))
		 {
		    switch ((long) CINT(method1533_1057))
		      {
		      case ((long) 0):
			 {
			    atom_t aux_1560;
			    aux_1560 = (atom_t) (node_13);
			    aux_1557 = (obj_t) (aux_1560);
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t aux_1563;
			    aux_1563 = (kwote_t) (node_13);
			    aux_1557 = (obj_t) (aux_1563);
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t aux_1566;
			    aux_1566 = (var_t) (node_13);
			    aux_1557 = (obj_t) (aux_1566);
			 }
			 break;
		      case ((long) 3):
			 {
			    sequence_t node_1067;
			    node_1067 = (sequence_t) (node_13);
			    fail_node___231_fail_walk((((sequence_t) CREF(node_1067))->nodes));
			    aux_1557 = (obj_t) (node_1067);
			 }
			 break;
		      case ((long) 4):
			 {
			    app_t node_1069;
			    node_1069 = (app_t) (node_13);
			    fail_node___231_fail_walk((((app_t) CREF(node_1069))->args));
			    aux_1557 = (obj_t) (node_1069);
			 }
			 break;
		      case ((long) 5):
			 {
			    app_ly_162_t node_1072;
			    node_1072 = (app_ly_162_t) (node_13);
			    {
			       node_t arg1550_1074;
			       arg1550_1074 = fail_node__137_fail_walk((((app_ly_162_t) CREF(node_1072))->fun));
			       {
				  obj_t res1655_1265;
				  {
				     obj_t x_1387;
				     x_1387 = ((((app_ly_162_t) CREF(node_1072))->fun) = ((node_t) arg1550_1074), BUNSPEC);
				     res1655_1265 = BUNSPEC;
				  }
				  res1655_1265;
			       }
			    }
			    {
			       node_t arg1552_1076;
			       arg1552_1076 = fail_node__137_fail_walk((((app_ly_162_t) CREF(node_1072))->arg));
			       {
				  obj_t res1656_1269;
				  {
				     obj_t x_1388;
				     x_1388 = ((((app_ly_162_t) CREF(node_1072))->arg) = ((node_t) arg1552_1076), BUNSPEC);
				     res1656_1269 = BUNSPEC;
				  }
				  res1656_1269;
			       }
			    }
			    aux_1557 = (obj_t) (node_1072);
			 }
			 break;
		      case ((long) 6):
			 {
			    funcall_t node_1078;
			    node_1078 = (funcall_t) (node_13);
			    {
			       node_t arg1554_1080;
			       arg1554_1080 = fail_node__137_fail_walk((((funcall_t) CREF(node_1078))->fun));
			       {
				  obj_t res1657_1273;
				  {
				     obj_t x_1389;
				     x_1389 = ((((funcall_t) CREF(node_1078))->fun) = ((node_t) arg1554_1080), BUNSPEC);
				     res1657_1273 = BUNSPEC;
				  }
				  res1657_1273;
			       }
			    }
			    fail_node___231_fail_walk((((funcall_t) CREF(node_1078))->args));
			    aux_1557 = (obj_t) (node_1078);
			 }
			 break;
		      case ((long) 7):
			 {
			    pragma_t node_1083;
			    node_1083 = (pragma_t) (node_13);
			    fail_node___231_fail_walk((((pragma_t) CREF(node_1083))->args));
			    aux_1557 = (obj_t) (node_1083);
			 }
			 break;
		      case ((long) 8):
			 {
			    setq_t node_1085;
			    node_1085 = (setq_t) (node_13);
			    {
			       node_t arg1560_1086;
			       arg1560_1086 = fail_node__137_fail_walk((((setq_t) CREF(node_1085))->value));
			       {
				  obj_t res1658_1279;
				  {
				     obj_t x_1390;
				     x_1390 = ((((setq_t) CREF(node_1085))->value) = ((node_t) arg1560_1086), BUNSPEC);
				     res1658_1279 = BUNSPEC;
				  }
				  res1658_1279;
			       }
			    }
			    aux_1557 = (obj_t) (node_1085);
			 }
			 break;
		      case ((long) 9):
			 {
			    conditional_t node_1088;
			    node_1088 = (conditional_t) (node_13);
			    {
			       node_t arg1562_1090;
			       arg1562_1090 = fail_node__137_fail_walk((((conditional_t) CREF(node_1088))->test));
			       {
				  obj_t res1659_1283;
				  {
				     obj_t x_1391;
				     x_1391 = ((((conditional_t) CREF(node_1088))->test) = ((node_t) arg1562_1090), BUNSPEC);
				     res1659_1283 = BUNSPEC;
				  }
				  res1659_1283;
			       }
			    }
			    {
			       node_t arg1564_1092;
			       arg1564_1092 = fail_node__137_fail_walk((((conditional_t) CREF(node_1088))->true));
			       {
				  obj_t res1660_1287;
				  {
				     obj_t x_1392;
				     x_1392 = ((((conditional_t) CREF(node_1088))->true) = ((node_t) arg1564_1092), BUNSPEC);
				     res1660_1287 = BUNSPEC;
				  }
				  res1660_1287;
			       }
			    }
			    {
			       node_t arg1566_1094;
			       arg1566_1094 = fail_node__137_fail_walk((((conditional_t) CREF(node_1088))->false));
			       {
				  obj_t res1661_1291;
				  {
				     obj_t x_1393;
				     x_1393 = ((((conditional_t) CREF(node_1088))->false) = ((node_t) arg1566_1094), BUNSPEC);
				     res1661_1291 = BUNSPEC;
				  }
				  res1661_1291;
			       }
			    }
			    aux_1557 = (obj_t) (node_1088);
			 }
			 break;
		      case ((long) 10):
			 {
			    fail_t node_1096;
			    node_1096 = (fail_t) (node_13);
			    {
			       node_t arg1568_1098;
			       arg1568_1098 = fail_node__137_fail_walk((((fail_t) CREF(node_1096))->proc));
			       {
				  obj_t res1662_1295;
				  {
				     obj_t x_1394;
				     x_1394 = ((((fail_t) CREF(node_1096))->proc) = ((node_t) arg1568_1098), BUNSPEC);
				     res1662_1295 = BUNSPEC;
				  }
				  res1662_1295;
			       }
			    }
			    {
			       node_t arg1571_1100;
			       arg1571_1100 = fail_node__137_fail_walk((((fail_t) CREF(node_1096))->msg));
			       {
				  obj_t res1663_1299;
				  {
				     obj_t x_1395;
				     x_1395 = ((((fail_t) CREF(node_1096))->msg) = ((node_t) arg1571_1100), BUNSPEC);
				     res1663_1299 = BUNSPEC;
				  }
				  res1663_1299;
			       }
			    }
			    {
			       node_t arg1573_1102;
			       arg1573_1102 = fail_node__137_fail_walk((((fail_t) CREF(node_1096))->obj));
			       {
				  obj_t res1664_1303;
				  {
				     obj_t x_1396;
				     x_1396 = ((((fail_t) CREF(node_1096))->obj) = ((node_t) arg1573_1102), BUNSPEC);
				     res1664_1303 = BUNSPEC;
				  }
				  res1664_1303;
			       }
			    }
			    {
			       bool_t test_1622;
			       {
				  obj_t arg1603_1125;
				  arg1603_1125 = (((fail_t) CREF(node_1096))->loc);
				  if (STRUCTP(arg1603_1125))
				    {
				       obj_t aux_1628;
				       obj_t aux_1626;
				       aux_1628 = CNST_TABLE_REF(((long) 2));
				       aux_1626 = STRUCT_KEY(arg1603_1125);
				       test_1622 = (aux_1626 == aux_1628);
				    }
				  else
				    {
				       test_1622 = ((bool_t) 0);
				    }
			       }
			       if (test_1622)
				 {
				    obj_t arg1576_1105;
				    obj_t arg1578_1107;
				    obj_t arg1579_1108;
				    {
				       obj_t arg1582_1109;
				       node_t arg1583_1110;
				       node_t arg1584_1111;
				       node_t arg1585_1112;
				       obj_t arg1587_1113;
				       obj_t arg1588_1114;
				       arg1582_1109 = CNST_TABLE_REF(((long) 3));
				       arg1583_1110 = (((fail_t) CREF(node_1096))->proc);
				       arg1584_1111 = (((fail_t) CREF(node_1096))->msg);
				       arg1585_1112 = (((fail_t) CREF(node_1096))->obj);
				       arg1587_1113 = location_full_fname_231_tools_location((((fail_t) CREF(node_1096))->loc));
				       {
					  obj_t aux_1637;
					  aux_1637 = (((fail_t) CREF(node_1096))->loc);
					  arg1588_1114 = STRUCT_REF(aux_1637, ((long) 1));
				       }
				       {
					  obj_t list1590_1116;
					  {
					     obj_t arg1591_1117;
					     {
						obj_t arg1592_1118;
						{
						   obj_t arg1593_1119;
						   {
						      obj_t arg1595_1120;
						      {
							 obj_t arg1596_1121;
							 arg1596_1121 = MAKE_PAIR(BNIL, BNIL);
							 arg1595_1120 = MAKE_PAIR(arg1588_1114, arg1596_1121);
						      }
						      arg1593_1119 = MAKE_PAIR(arg1587_1113, arg1595_1120);
						   }
						   {
						      obj_t aux_1643;
						      aux_1643 = (obj_t) (arg1585_1112);
						      arg1592_1118 = MAKE_PAIR(aux_1643, arg1593_1119);
						   }
						}
						{
						   obj_t aux_1646;
						   aux_1646 = (obj_t) (arg1584_1111);
						   arg1591_1117 = MAKE_PAIR(aux_1646, arg1592_1118);
						}
					     }
					     {
						obj_t aux_1649;
						aux_1649 = (obj_t) (arg1583_1110);
						list1590_1116 = MAKE_PAIR(aux_1649, arg1591_1117);
					     }
					  }
					  arg1576_1105 = cons__138___r4_pairs_and_lists_6_3(arg1582_1109, list1590_1116);
				       }
				    }
				    arg1578_1107 = (((fail_t) CREF(node_1096))->loc);
				    arg1579_1108 = CNST_TABLE_REF(((long) 4));
				    {
				       node_t aux_1655;
				       aux_1655 = sexp__node_235_ast_sexp(arg1576_1105, BNIL, arg1578_1107, arg1579_1108);
				       aux_1557 = (obj_t) (aux_1655);
				    }
				 }
			       else
				 {
				    aux_1557 = (obj_t) (node_1096);
				 }
			    }
			 }
			 break;
		      case ((long) 11):
			 {
			    select_t node_1126;
			    node_1126 = (select_t) (node_13);
			    {
			       node_t arg1604_1128;
			       arg1604_1128 = fail_node__137_fail_walk((((select_t) CREF(node_1126))->test));
			       {
				  obj_t res1665_1325;
				  {
				     obj_t x_1397;
				     x_1397 = ((((select_t) CREF(node_1126))->test) = ((node_t) arg1604_1128), BUNSPEC);
				     res1665_1325 = BUNSPEC;
				  }
				  res1665_1325;
			       }
			    }
			    {
			       obj_t l1290_1130;
			       l1290_1130 = (((select_t) CREF(node_1126))->clauses);
			     lname1291_1131:
			       if (PAIRP(l1290_1130))
				 {
				    {
				       obj_t clause_1134;
				       clause_1134 = CAR(l1290_1130);
				       {
					  node_t arg1608_1135;
					  {
					     node_t aux_1666;
					     {
						obj_t aux_1667;
						aux_1667 = CDR(clause_1134);
						aux_1666 = (node_t) (aux_1667);
					     }
					     arg1608_1135 = fail_node__137_fail_walk(aux_1666);
					  }
					  {
					     obj_t aux_1671;
					     aux_1671 = (obj_t) (arg1608_1135);
					     SET_CDR(clause_1134, aux_1671);
					  }
				       }
				    }
				    {
				       obj_t l1290_1674;
				       l1290_1674 = CDR(l1290_1130);
				       l1290_1130 = l1290_1674;
				       goto lname1291_1131;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_1557 = (obj_t) (node_1126);
			 }
			 break;
		      case ((long) 12):
			 {
			    let_fun_218_t node_1138;
			    node_1138 = (let_fun_218_t) (node_13);
			    {
			       obj_t l1293_1140;
			       l1293_1140 = (((let_fun_218_t) CREF(node_1138))->locals);
			     lname1294_1141:
			       if (PAIRP(l1293_1140))
				 {
				    fail_fun__97_fail_walk(CAR(l1293_1140));
				    {
				       obj_t l1293_1683;
				       l1293_1683 = CDR(l1293_1140);
				       l1293_1140 = l1293_1683;
				       goto lname1294_1141;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1618_1146;
			       arg1618_1146 = fail_node__137_fail_walk((((let_fun_218_t) CREF(node_1138))->body));
			       {
				  obj_t res1666_1340;
				  {
				     obj_t x_1398;
				     x_1398 = ((((let_fun_218_t) CREF(node_1138))->body) = ((node_t) arg1618_1146), BUNSPEC);
				     res1666_1340 = BUNSPEC;
				  }
				  res1666_1340;
			       }
			    }
			    aux_1557 = (obj_t) (node_1138);
			 }
			 break;
		      case ((long) 13):
			 {
			    let_var_6_t node_1148;
			    node_1148 = (let_var_6_t) (node_13);
			    {
			       obj_t l1296_1150;
			       l1296_1150 = (((let_var_6_t) CREF(node_1148))->bindings);
			     lname1298_1151:
			       if (PAIRP(l1296_1150))
				 {
				    {
				       obj_t binding_1154;
				       binding_1154 = CAR(l1296_1150);
				       {
					  node_t arg1623_1155;
					  {
					     node_t aux_1694;
					     {
						obj_t aux_1695;
						aux_1695 = CDR(binding_1154);
						aux_1694 = (node_t) (aux_1695);
					     }
					     arg1623_1155 = fail_node__137_fail_walk(aux_1694);
					  }
					  {
					     obj_t aux_1699;
					     aux_1699 = (obj_t) (arg1623_1155);
					     SET_CDR(binding_1154, aux_1699);
					  }
				       }
				    }
				    {
				       obj_t l1296_1702;
				       l1296_1702 = CDR(l1296_1150);
				       l1296_1150 = l1296_1702;
				       goto lname1298_1151;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1627_1158;
			       arg1627_1158 = fail_node__137_fail_walk((((let_var_6_t) CREF(node_1148))->body));
			       {
				  obj_t res1667_1351;
				  {
				     obj_t x_1399;
				     x_1399 = ((((let_var_6_t) CREF(node_1148))->body) = ((node_t) arg1627_1158), BUNSPEC);
				     res1667_1351 = BUNSPEC;
				  }
				  res1667_1351;
			       }
			    }
			    aux_1557 = (obj_t) (node_1148);
			 }
			 break;
		      case ((long) 14):
			 {
			    set_ex_it_116_t node_1160;
			    node_1160 = (set_ex_it_116_t) (node_13);
			    {
			       node_t arg1630_1161;
			       arg1630_1161 = fail_node__137_fail_walk((((set_ex_it_116_t) CREF(node_1160))->body));
			       {
				  obj_t res1668_1355;
				  {
				     obj_t x_1400;
				     x_1400 = ((((set_ex_it_116_t) CREF(node_1160))->body) = ((node_t) arg1630_1161), BUNSPEC);
				     res1668_1355 = BUNSPEC;
				  }
				  res1668_1355;
			       }
			    }
			    aux_1557 = (obj_t) (node_1160);
			 }
			 break;
		      case ((long) 15):
			 {
			    jump_ex_it_184_t node_1163;
			    node_1163 = (jump_ex_it_184_t) (node_13);
			    {
			       node_t arg1634_1165;
			       arg1634_1165 = fail_node__137_fail_walk((((jump_ex_it_184_t) CREF(node_1163))->exit));
			       {
				  obj_t res1669_1359;
				  {
				     obj_t x_1401;
				     x_1401 = ((((jump_ex_it_184_t) CREF(node_1163))->exit) = ((node_t) arg1634_1165), BUNSPEC);
				     res1669_1359 = BUNSPEC;
				  }
				  res1669_1359;
			       }
			    }
			    {
			       node_t arg1638_1167;
			       arg1638_1167 = fail_node__137_fail_walk((((jump_ex_it_184_t) CREF(node_1163))->value));
			       {
				  obj_t res1670_1363;
				  {
				     obj_t x_1402;
				     x_1402 = ((((jump_ex_it_184_t) CREF(node_1163))->value) = ((node_t) arg1638_1167), BUNSPEC);
				     res1670_1363 = BUNSPEC;
				  }
				  res1670_1363;
			       }
			    }
			    aux_1557 = (obj_t) (node_1163);
			 }
			 break;
		      case ((long) 16):
			 {
			    make_box_202_t node_1169;
			    node_1169 = (make_box_202_t) (node_13);
			    {
			       node_t arg1642_1170;
			       arg1642_1170 = fail_node__137_fail_walk((((make_box_202_t) CREF(node_1169))->value));
			       {
				  obj_t res1671_1367;
				  {
				     obj_t x_1403;
				     x_1403 = ((((make_box_202_t) CREF(node_1169))->value) = ((node_t) arg1642_1170), BUNSPEC);
				     res1671_1367 = BUNSPEC;
				  }
				  res1671_1367;
			       }
			    }
			    aux_1557 = (obj_t) (node_1169);
			 }
			 break;
		      case ((long) 17):
			 {
			    box_ref_242_t aux_1727;
			    aux_1727 = (box_ref_242_t) (node_13);
			    aux_1557 = (obj_t) (aux_1727);
			 }
			 break;
		      case ((long) 18):
			 {
			    box_set__221_t node_1173;
			    node_1173 = (box_set__221_t) (node_13);
			    {
			       node_t arg1644_1175;
			       arg1644_1175 = fail_node__137_fail_walk((((box_set__221_t) CREF(node_1173))->value));
			       {
				  obj_t res1672_1371;
				  {
				     obj_t x_1404;
				     x_1404 = ((((box_set__221_t) CREF(node_1173))->value) = ((node_t) arg1644_1175), BUNSPEC);
				     res1672_1371 = BUNSPEC;
				  }
				  res1672_1371;
			       }
			    }
			    aux_1557 = (obj_t) (node_1173);
			 }
			 break;
		      default:
		       case_else1539_140_1061:
			 if (PROCEDUREP(method1533_1057))
			   {
			      aux_1557 = PROCEDURE_ENTRY(method1533_1057) (method1533_1057, (obj_t) (node_13), BEOA);
			   }
			 else
			   {
			      obj_t fun1413_739;
			      fun1413_739 = PROCEDURE_REF(fail_node__env_77_fail_walk, ((long) 0));
			      aux_1557 = PROCEDURE_ENTRY(fun1413_739) (fun1413_739, (obj_t) (node_13), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1539_140_1061;
		 }
	    }
	    return (node_t) (aux_1557);
	 }
      }
   }
}


obj_t 
_fail_node__15_fail_walk(obj_t env_1379, obj_t node_1380)
{
   {
      node_t aux_1747;
      aux_1747 = fail_node__137_fail_walk((node_t) (node_1380));
      return (obj_t) (aux_1747);
   }
}


obj_t 
fail_node___231_fail_walk(obj_t node__221_34)
{
 fail_node___231_fail_walk:
   if (NULLP(node__221_34))
     {
	return CNST_TABLE_REF(((long) 5));
     }
   else
     {
	{
	   node_t arg1415_741;
	   {
	      node_t aux_1754;
	      {
		 obj_t aux_1755;
		 aux_1755 = CAR(node__221_34);
		 aux_1754 = (node_t) (aux_1755);
	      }
	      arg1415_741 = fail_node__137_fail_walk(aux_1754);
	   }
	   {
	      obj_t aux_1759;
	      aux_1759 = (obj_t) (arg1415_741);
	      SET_CAR(node__221_34, aux_1759);
	   }
	}
	{
	   obj_t node__221_1762;
	   node__221_1762 = CDR(node__221_34);
	   node__221_34 = node__221_1762;
	   goto fail_node___231_fail_walk;
	}
     }
}


obj_t 
imported_modules_init_94_fail_walk()
{
   module_initialization_70_tools_speek(((long) 0), "FAIL_WALK");
   module_initialization_70_tools_error(((long) 0), "FAIL_WALK");
   module_initialization_70_engine_pass(((long) 0), "FAIL_WALK");
   module_initialization_70_type_type(((long) 0), "FAIL_WALK");
   module_initialization_70_ast_var(((long) 0), "FAIL_WALK");
   module_initialization_70_ast_node(((long) 0), "FAIL_WALK");
   module_initialization_70_tools_shape(((long) 0), "FAIL_WALK");
   module_initialization_70_tools_location(((long) 0), "FAIL_WALK");
   return module_initialization_70_ast_sexp(((long) 0), "FAIL_WALK");
}
