/*===========================================================================*/
/*   (Globalize/clocto.scm)                                                  */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_t;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_t;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_t;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_t;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_t;


extern obj_t _cto_transitive_closure__188_globalize_clocto(obj_t, obj_t);
static obj_t imported_modules_init_94_globalize_clocto();
extern obj_t module_initialization_70_globalize_clocto(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_kapture(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t union_3_globalize_kapture(obj_t);
static obj_t require_initialization_114_globalize_clocto = BUNSPEC;
static obj_t library_modules_init_112_globalize_clocto();
extern obj_t cto_transitive_closure__123_globalize_clocto(local_t);
extern obj_t local_ast_var;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE(cto_transitive_closure__env_229_globalize_clocto, _cto_transitive_closure__188_globalize_clocto1545, _cto_transitive_closure__188_globalize_clocto, 0L, 1);

obj_t 
module_initialization_70_globalize_clocto(long checksum_1435, char *from_1436)
{
   if (CBOOL(require_initialization_114_globalize_clocto))
     {
	require_initialization_114_globalize_clocto = BBOOL(((bool_t) 0));
	library_modules_init_112_globalize_clocto();
	imported_modules_init_94_globalize_clocto();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_globalize_clocto()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_CLOCTO");
   return BUNSPEC;
}


obj_t 
cto_transitive_closure__123_globalize_clocto(local_t host_1)
{
   {
      value_t info_911;
      info_911 = (((local_t) CREF(host_1))->value);
      {
	 obj_t cto_912;
	 {
	    obj_t aux_1451;
	    obj_t aux_1444;
	    {
	       sfun_ginfo_98_t obj_1316;
	       obj_1316 = (sfun_ginfo_98_t) (info_911);
	       {
		  obj_t aux_1453;
		  {
		     object_t aux_1454;
		     aux_1454 = (object_t) (obj_1316);
		     aux_1453 = OBJECT_WIDENING(aux_1454);
		  }
		  aux_1451 = (((sfun_ginfo_98_t) CREF(aux_1453))->cfunction);
	       }
	    }
	    {
	       sfun_ginfo_98_t obj_1315;
	       obj_1315 = (sfun_ginfo_98_t) (info_911);
	       {
		  obj_t aux_1446;
		  {
		     object_t aux_1447;
		     aux_1447 = (object_t) (obj_1315);
		     aux_1446 = OBJECT_WIDENING(aux_1447);
		  }
		  aux_1444 = (((sfun_ginfo_98_t) CREF(aux_1446))->cto);
	       }
	    }
	    cto_912 = append_2_18___r4_pairs_and_lists_6_3(aux_1444, aux_1451);
	 }
	 {
	    obj_t cto__orig_75_913;
	    {
	       obj_t list1404_936;
	       list1404_936 = MAKE_PAIR(cto_912, BNIL);
	       cto__orig_75_913 = list1404_936;
	    }
	    {
	       {
		  obj_t cto_914;
		  obj_t cto__14_915;
		  cto_914 = cto_912;
		  cto__14_915 = cto__orig_75_913;
		loop_916:
		  if (NULLP(cto_914))
		    {
		       {
			  obj_t arg1370_918;
			  if ((cto__14_915 == cto__orig_75_913))
			    {
			       arg1370_918 = CAR(cto__orig_75_913);
			    }
			  else
			    {
			       arg1370_918 = union_3_globalize_kapture(cto__14_915);
			    }
			  {
			     obj_t res1543_1324;
			     {
				sfun_ginfo_98_t obj_1322;
				obj_1322 = (sfun_ginfo_98_t) (info_911);
				{
				   obj_t x_1434;
				   {
				      obj_t aux_1467;
				      {
					 object_t aux_1468;
					 aux_1468 = (object_t) (obj_1322);
					 aux_1467 = OBJECT_WIDENING(aux_1468);
				      }
				      x_1434 = ((((sfun_ginfo_98_t) CREF(aux_1467))->cto__14) = ((obj_t) arg1370_918), BUNSPEC);
				   }
				   res1543_1324 = BUNSPEC;
				}
			     }
			     return res1543_1324;
			  }
		       }
		    }
		  else
		    {
		       bool_t test1372_920;
		       {
			  obj_t obj2_1327;
			  obj2_1327 = local_ast_var;
			  {
			     obj_t aux_1472;
			     aux_1472 = CAR(cto_914);
			     test1372_920 = (aux_1472 == obj2_1327);
			  }
		       }
		       if (test1372_920)
			 {
			    {
			       obj_t cto_1476;
			       cto_1476 = CDR(cto_914);
			       cto_914 = cto_1476;
			       goto loop_916;
			    }
			 }
		       else
			 {
			    bool_t test_1478;
			    {
			       sfun_ginfo_98_t obj_1331;
			       {
				  value_t aux_1479;
				  {
				     local_t obj_1330;
				     {
					obj_t aux_1480;
					aux_1480 = CAR(cto_914);
					obj_1330 = (local_t) (aux_1480);
				     }
				     aux_1479 = (((local_t) CREF(obj_1330))->value);
				  }
				  obj_1331 = (sfun_ginfo_98_t) (aux_1479);
			       }
			       {
				  obj_t aux_1485;
				  {
				     object_t aux_1486;
				     aux_1486 = (object_t) (obj_1331);
				     aux_1485 = OBJECT_WIDENING(aux_1486);
				  }
				  test_1478 = (((sfun_ginfo_98_t) CREF(aux_1485))->g__219);
			       }
			    }
			    if (test_1478)
			      {
				 {
				    obj_t cto_1490;
				    cto_1490 = CDR(cto_914);
				    cto_914 = cto_1490;
				    goto loop_916;
				 }
			      }
			    else
			      {
				 {
				    obj_t arg1380_924;
				    obj_t arg1381_925;
				    arg1380_924 = CDR(cto_914);
				    {
				       obj_t aux_1493;
				       {
					  obj_t aux_1506;
					  obj_t aux_1494;
					  {
					     sfun_ginfo_98_t obj_1339;
					     {
						value_t aux_1507;
						{
						   local_t obj_1338;
						   {
						      obj_t aux_1508;
						      aux_1508 = CAR(cto_914);
						      obj_1338 = (local_t) (aux_1508);
						   }
						   aux_1507 = (((local_t) CREF(obj_1338))->value);
						}
						obj_1339 = (sfun_ginfo_98_t) (aux_1507);
					     }
					     {
						obj_t aux_1513;
						{
						   object_t aux_1514;
						   aux_1514 = (object_t) (obj_1339);
						   aux_1513 = OBJECT_WIDENING(aux_1514);
						}
						aux_1506 = (((sfun_ginfo_98_t) CREF(aux_1513))->cfunction);
					     }
					  }
					  {
					     sfun_ginfo_98_t obj_1336;
					     {
						value_t aux_1495;
						{
						   local_t obj_1335;
						   {
						      obj_t aux_1496;
						      aux_1496 = CAR(cto_914);
						      obj_1335 = (local_t) (aux_1496);
						   }
						   aux_1495 = (((local_t) CREF(obj_1335))->value);
						}
						obj_1336 = (sfun_ginfo_98_t) (aux_1495);
					     }
					     {
						obj_t aux_1501;
						{
						   object_t aux_1502;
						   aux_1502 = (object_t) (obj_1336);
						   aux_1501 = OBJECT_WIDENING(aux_1502);
						}
						aux_1494 = (((sfun_ginfo_98_t) CREF(aux_1501))->cto);
					     }
					  }
					  aux_1493 = append_2_18___r4_pairs_and_lists_6_3(aux_1494, aux_1506);
				       }
				       arg1381_925 = MAKE_PAIR(aux_1493, cto__14_915);
				    }
				    {
				       obj_t cto__14_1521;
				       obj_t cto_1520;
				       cto_1520 = arg1380_924;
				       cto__14_1521 = arg1381_925;
				       cto__14_915 = cto__14_1521;
				       cto_914 = cto_1520;
				       goto loop_916;
				    }
				 }
			      }
			 }
		    }
	       }
	    }
	 }
      }
   }
}


obj_t 
_cto_transitive_closure__188_globalize_clocto(obj_t env_1432, obj_t host_1433)
{
   return cto_transitive_closure__123_globalize_clocto((local_t) (host_1433));
}


obj_t 
imported_modules_init_94_globalize_clocto()
{
   module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_CLOCTO");
   module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_CLOCTO");
   module_initialization_70_type_type(((long) 0), "GLOBALIZE_CLOCTO");
   module_initialization_70_ast_var(((long) 0), "GLOBALIZE_CLOCTO");
   module_initialization_70_ast_node(((long) 0), "GLOBALIZE_CLOCTO");
   module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_CLOCTO");
   return module_initialization_70_globalize_kapture(((long) 0), "GLOBALIZE_CLOCTO");
}
