/*===========================================================================*/
/*   (Globalize/escape.scm)                                                  */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_t;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_t;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_t;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_t;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_t;


extern obj_t escape_fun__53_globalize_escape(variable_t);
extern obj_t svar_ginfo_131_globalize_ginfo;
extern obj_t let_fun_218_ast_node;
extern obj_t _escape_fun__253_globalize_escape(obj_t, obj_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
extern obj_t sexit_ginfo_81_globalize_ginfo;
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
static bool_t escape___220_globalize_escape(obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_globalize_escape();
extern obj_t module_initialization_70_globalize_escape(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_globalize_escape();
static obj_t _escape_fun__default1409_104_globalize_escape(obj_t, obj_t);
static obj_t cnst_init_137_globalize_escape();
static obj_t _set_escaping_fun__208_globalize_escape(obj_t, obj_t);
extern obj_t global_ginfo_75_globalize_ginfo;
static obj_t _escape__default1420_244_globalize_escape(obj_t, obj_t);
static obj_t require_initialization_114_globalize_escape = BUNSPEC;
extern obj_t var_ast_node;
static obj_t library_modules_init_112_globalize_escape();
static obj_t escape__235_globalize_escape(node_t);
static obj_t set_escaping_fun__default1412_30_globalize_escape(variable_t);
extern obj_t cast_ast_node;
extern obj_t conditional_ast_node;
static obj_t escape__default1420_75_globalize_escape(node_t);
extern obj_t sfun_ginfo_98_globalize_ginfo;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern obj_t class_super_145___object(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t local_ginfo_108_globalize_ginfo;
static obj_t set_escaping_fun__14_globalize_escape(variable_t);
extern obj_t find_method_from_44___object(object_t, obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
static obj_t _set_escaping_fun__default1412_157_globalize_escape(obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t local_ast_var;
extern obj_t kwote_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
static obj_t escape_fun__default1409_67_globalize_escape(variable_t);
static obj_t _escape__238_globalize_escape(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t __cnst[3];

DEFINE_STATIC_GENERIC(set_escaping_fun__env_225_globalize_escape, _set_escaping_fun__208_globalize_escape1787, _set_escaping_fun__208_globalize_escape, 0L, 1);
DEFINE_STATIC_PROCEDURE(escape__default1420_env_163_globalize_escape, _escape__default1420_244_globalize_escape1788, _escape__default1420_244_globalize_escape, 0L, 1);
DEFINE_STRING(string1779_globalize_escape, string1779_globalize_escape1789, "No method for this object", 25);
DEFINE_STRING(string1777_globalize_escape, string1777_globalize_escape1790, "set-escaping-fun!", 17);
DEFINE_STATIC_GENERIC(escape__env_201_globalize_escape, _escape__238_globalize_escape1791, _escape__238_globalize_escape, 0L, 1);
DEFINE_EXPORT_GENERIC(escape_fun__env_92_globalize_escape, _escape_fun__253_globalize_escape1792, _escape_fun__253_globalize_escape, 0L, 1);
DEFINE_STATIC_PROCEDURE(set_escaping_fun__default1412_env_193_globalize_escape, _set_escaping_fun__default1412_157_globalize_escape1793, _set_escaping_fun__default1412_157_globalize_escape, 0L, 1);
DEFINE_STATIC_PROCEDURE(escape_fun__default1409_env_109_globalize_escape, _escape_fun__default1409_104_globalize_escape1794, _escape_fun__default1409_104_globalize_escape, 0L, 1);
DEFINE_STRING(string1778_globalize_escape, string1778_globalize_escape1795, "Illegal variable", 16);
DEFINE_STRING(string1780_globalize_escape, string1780_globalize_escape1796, "DONE ESCAPE!-DEFAULT1420 EXPORT ", 32);

obj_t 
module_initialization_70_globalize_escape(long checksum_2005, char *from_2006)
{
   if (CBOOL(require_initialization_114_globalize_escape))
     {
	require_initialization_114_globalize_escape = BBOOL(((bool_t) 0));
	library_modules_init_112_globalize_escape();
	cnst_init_137_globalize_escape();
	imported_modules_init_94_globalize_escape();
	toplevel_init_63_globalize_escape();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_globalize_escape()
{
   module_initialization_70___object(((long) 0), "GLOBALIZE_ESCAPE");
   module_initialization_70___reader(((long) 0), "GLOBALIZE_ESCAPE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_globalize_escape()
{
   {
      obj_t cnst_port_138_1997;
      cnst_port_138_1997 = open_input_string(string1780_globalize_escape);
      {
	 long i_1998;
	 i_1998 = ((long) 2);
       loop_1999:
	 {
	    bool_t test1781_2000;
	    test1781_2000 = (i_1998 == ((long) -1));
	    if (test1781_2000)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1783_2001;
		    {
		       obj_t list1784_2002;
		       {
			  obj_t arg1785_2003;
			  arg1785_2003 = BNIL;
			  list1784_2002 = MAKE_PAIR(cnst_port_138_1997, arg1785_2003);
		       }
		       arg1783_2001 = read___reader(list1784_2002);
		    }
		    CNST_TABLE_SET(i_1998, arg1783_2001);
		 }
		 {
		    int aux_2004;
		    {
		       long aux_2022;
		       aux_2022 = (i_1998 - ((long) 1));
		       aux_2004 = (int) (aux_2022);
		    }
		    {
		       long i_2025;
		       i_2025 = (long) (aux_2004);
		       i_1998 = i_2025;
		       goto loop_1999;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_globalize_escape()
{
   add_generic__110___object(escape_fun__env_92_globalize_escape, escape_fun__default1409_env_109_globalize_escape);
   add_inlined_method__244___object(escape_fun__env_92_globalize_escape, global_ast_var, ((long) 0));
   add_inlined_method__244___object(escape_fun__env_92_globalize_escape, local_ast_var, ((long) 1));
   add_generic__110___object(set_escaping_fun__env_225_globalize_escape, set_escaping_fun__default1412_env_193_globalize_escape);
   add_inlined_method__244___object(set_escaping_fun__env_225_globalize_escape, global_ast_var, ((long) 0));
   add_inlined_method__244___object(set_escaping_fun__env_225_globalize_escape, global_ginfo_75_globalize_ginfo, ((long) 1));
   add_inlined_method__244___object(set_escaping_fun__env_225_globalize_escape, local_ginfo_108_globalize_ginfo, ((long) 2));
   add_generic__110___object(escape__env_201_globalize_escape, escape__default1420_env_163_globalize_escape);
   add_inlined_method__244___object(escape__env_201_globalize_escape, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(escape__env_201_globalize_escape, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(escape__env_201_globalize_escape, var_ast_node, ((long) 2));
   add_inlined_method__244___object(escape__env_201_globalize_escape, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(escape__env_201_globalize_escape, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(escape__env_201_globalize_escape, app_ast_node, ((long) 5));
   add_inlined_method__244___object(escape__env_201_globalize_escape, app_ly_162_ast_node, ((long) 6));
   add_inlined_method__244___object(escape__env_201_globalize_escape, funcall_ast_node, ((long) 7));
   add_inlined_method__244___object(escape__env_201_globalize_escape, pragma_ast_node, ((long) 8));
   add_inlined_method__244___object(escape__env_201_globalize_escape, cast_ast_node, ((long) 9));
   add_inlined_method__244___object(escape__env_201_globalize_escape, setq_ast_node, ((long) 10));
   add_inlined_method__244___object(escape__env_201_globalize_escape, conditional_ast_node, ((long) 11));
   add_inlined_method__244___object(escape__env_201_globalize_escape, fail_ast_node, ((long) 12));
   add_inlined_method__244___object(escape__env_201_globalize_escape, select_ast_node, ((long) 13));
   add_inlined_method__244___object(escape__env_201_globalize_escape, let_fun_218_ast_node, ((long) 14));
   add_inlined_method__244___object(escape__env_201_globalize_escape, let_var_6_ast_node, ((long) 15));
   add_inlined_method__244___object(escape__env_201_globalize_escape, set_ex_it_116_ast_node, ((long) 16));
   add_inlined_method__244___object(escape__env_201_globalize_escape, jump_ex_it_184_ast_node, ((long) 17));
   add_inlined_method__244___object(escape__env_201_globalize_escape, make_box_202_ast_node, ((long) 18));
   add_inlined_method__244___object(escape__env_201_globalize_escape, box_set__221_ast_node, ((long) 19));
   {
      long aux_2055;
      aux_2055 = add_inlined_method__244___object(escape__env_201_globalize_escape, box_ref_242_ast_node, ((long) 20));
      return BINT(aux_2055);
   }
}


obj_t 
escape_fun__default1409_67_globalize_escape(variable_t variable_2)
{
   {
      value_t fun_943;
      fun_943 = (((variable_t) CREF(variable_2))->value);
      {
	 obj_t l1369_944;
	 {
	    sfun_t obj_1556;
	    obj_1556 = (sfun_t) (fun_943);
	    l1369_944 = (((sfun_t) CREF(obj_1556))->args);
	 }
       lname1370_945:
	 if (PAIRP(l1369_944))
	   {
	      {
		 obj_t local_948;
		 local_948 = CAR(l1369_944);
		 {
		    svar_ginfo_131_t obj1371_949;
		    {
		       value_t aux_2062;
		       {
			  local_t obj_1559;
			  obj_1559 = (local_t) (local_948);
			  aux_2062 = (((local_t) CREF(obj_1559))->value);
		       }
		       obj1371_949 = ((svar_ginfo_131_t) (aux_2062));
		    }
		    {
		       svar_ginfo_131_t arg1446_950;
		       {
			  svar_ginfo_131_t res1761_1569;
			  {
			     svar_ginfo_131_t new1314_1564;
			     new1314_1564 = ((svar_ginfo_131_t) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
			     ((((svar_ginfo_131_t) CREF(new1314_1564))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			     ((((svar_ginfo_131_t) CREF(new1314_1564))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
			     ((((svar_ginfo_131_t) CREF(new1314_1564))->mark) = ((long) ((long) -10)), BUNSPEC);
			     ((((svar_ginfo_131_t) CREF(new1314_1564))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			     res1761_1569 = new1314_1564;
			  }
			  arg1446_950 = res1761_1569;
		       }
		       {
			  obj_t aux_2073;
			  object_t aux_2071;
			  aux_2073 = (obj_t) (arg1446_950);
			  aux_2071 = (object_t) (obj1371_949);
			  OBJECT_WIDENING_SET(aux_2071, aux_2073);
		       }
		    }
		    {
		       long arg1447_951;
		       arg1447_951 = class_num_218___object(svar_ginfo_131_globalize_ginfo);
		       {
			  obj_t obj_1570;
			  obj_1570 = (obj_t) (obj1371_949);
			  (((obj_t) CREF(obj_1570))->header = MAKE_HEADER(arg1447_951, 0), BUNSPEC);
		       }
		    }
		    obj1371_949;
		 }
	      }
	      {
		 obj_t l1369_2079;
		 l1369_2079 = CDR(l1369_944);
		 l1369_944 = l1369_2079;
		 goto lname1370_945;
	      }
	   }
	 else
	   {
	      ((bool_t) 1);
	   }
      }
      {
	 sfun_ginfo_98_t obj1372_953;
	 obj1372_953 = ((sfun_ginfo_98_t) (fun_943));
	 {
	    sfun_ginfo_98_t arg1449_954;
	    {
	       sfun_ginfo_98_t res1762_1610;
	       {
		  obj_t cfrom__119_1575;
		  obj_t cto__14_1577;
		  obj_t the_global_201_1584;
		  obj_t kaptured_1585;
		  obj_t new_body_215_1586;
		  cfrom__119_1575 = BFALSE;
		  cto__14_1577 = BFALSE;
		  the_global_201_1584 = BFALSE;
		  kaptured_1585 = BFALSE;
		  new_body_215_1586 = BFALSE;
		  {
		     sfun_ginfo_98_t new1280_1591;
		     new1280_1591 = ((sfun_ginfo_98_t) BREF(GC_MALLOC(sizeof(struct sfun_ginfo_98))));
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->g__219) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->cfrom) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->cfrom__119) = ((obj_t) cfrom__119_1575), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->cto) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->cto__14) = ((obj_t) cto__14_1577), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->cfunction) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->integrator) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->integrated) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->plugged_in_15) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->mark) = ((long) ((long) -10)), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->free_mark_81) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->the_global_201) = ((obj_t) the_global_201_1584), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->kaptured) = ((obj_t) kaptured_1585), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->new_body_215) = ((obj_t) new_body_215_1586), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->bmark) = ((long) ((long) -10)), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->umark) = ((long) ((long) -10)), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->free) = ((obj_t) BUNSPEC), BUNSPEC);
		     ((((sfun_ginfo_98_t) CREF(new1280_1591))->bound) = ((obj_t) BNIL), BUNSPEC);
		     res1762_1610 = new1280_1591;
		  }
	       }
	       arg1449_954 = res1762_1610;
	    }
	    {
	       obj_t aux_2105;
	       object_t aux_2103;
	       aux_2105 = (obj_t) (arg1449_954);
	       aux_2103 = (object_t) (obj1372_953);
	       OBJECT_WIDENING_SET(aux_2103, aux_2105);
	    }
	 }
	 {
	    long arg1468_966;
	    arg1468_966 = class_num_218___object(sfun_ginfo_98_globalize_ginfo);
	    {
	       obj_t obj_1611;
	       obj_1611 = (obj_t) (obj1372_953);
	       (((obj_t) CREF(obj_1611))->header = MAKE_HEADER(arg1468_966, 0), BUNSPEC);
	    }
	 }
	 obj1372_953;
      }
      {
	 node_t aux_2111;
	 {
	    obj_t aux_2112;
	    {
	       sfun_t obj_1613;
	       obj_1613 = (sfun_t) (fun_943);
	       aux_2112 = (((sfun_t) CREF(obj_1613))->body);
	    }
	    aux_2111 = (node_t) (aux_2112);
	 }
	 return escape__235_globalize_escape(aux_2111);
      }
   }
}


obj_t 
_escape_fun__default1409_104_globalize_escape(obj_t env_1985, obj_t variable_1986)
{
   return escape_fun__default1409_67_globalize_escape((variable_t) (variable_1986));
}


obj_t 
escape_fun__53_globalize_escape(variable_t variable_1)
{
   {
      obj_t method1733_1526;
      obj_t class1738_1527;
      {
	 obj_t arg1741_1524;
	 obj_t arg1742_1525;
	 {
	    object_t obj_1614;
	    obj_1614 = (object_t) (variable_1);
	    {
	       obj_t pre_method_105_1615;
	       pre_method_105_1615 = PROCEDURE_REF(escape_fun__env_92_globalize_escape, ((long) 2));
	       if (INTEGERP(pre_method_105_1615))
		 {
		    PROCEDURE_SET(escape_fun__env_92_globalize_escape, ((long) 2), BUNSPEC);
		    arg1741_1524 = pre_method_105_1615;
		 }
	       else
		 {
		    long obj_class_num_177_1620;
		    obj_class_num_177_1620 = TYPE(obj_1614);
		    {
		       obj_t arg1183_1621;
		       arg1183_1621 = PROCEDURE_REF(escape_fun__env_92_globalize_escape, ((long) 1));
		       {
			  long arg1184_1625;
			  {
			     long arg1186_1626;
			     arg1186_1626 = OBJECT_TYPE;
			     arg1184_1625 = (obj_class_num_177_1620 - arg1186_1626);
			  }
			  arg1741_1524 = VECTOR_REF(arg1183_1621, arg1184_1625);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1631;
	    object_1631 = (object_t) (variable_1);
	    {
	       long arg1187_1632;
	       {
		  long arg1188_1633;
		  long arg1189_1634;
		  arg1188_1633 = TYPE(object_1631);
		  arg1189_1634 = OBJECT_TYPE;
		  arg1187_1632 = (arg1188_1633 - arg1189_1634);
	       }
	       {
		  obj_t vector_1638;
		  vector_1638 = __classes__134___object;
		  arg1742_1525 = VECTOR_REF(vector_1638, arg1187_1632);
	       }
	    }
	 }
	 method1733_1526 = arg1741_1524;
	 class1738_1527 = arg1742_1525;
       loop1734_1554:
	 {
	    {
	       if (INTEGERP(method1733_1526))
		 {
		    switch ((long) CINT(method1733_1526))
		      {
		      case ((long) 0):
			 {
			    global_t variable_1533;
			    variable_1533 = (global_t) (variable_1);
			    {
			       bool_t test1745_1534;
			       test1745_1534 = is_a__118___object((obj_t) (variable_1533), global_ginfo_75_globalize_ginfo);
			       if (test1745_1534)
				 {
				    BUNSPEC;
				 }
			       else
				 {
				    global_ginfo_75_t obj1373_1535;
				    obj1373_1535 = ((global_ginfo_75_t) (variable_1533));
				    {
				       global_ginfo_75_t arg1746_1536;
				       {
					  bool_t arg1747_1537;
					  {
					     obj_t aux_2143;
					     obj_t aux_2141;
					     aux_2143 = CNST_TABLE_REF(((long) 0));
					     aux_2141 = (((global_t) CREF(variable_1533))->import);
					     arg1747_1537 = (aux_2141 == aux_2143);
					  }
					  {
					     global_ginfo_75_t res1763_1649;
					     {
						obj_t global_closure_229_1645;
						global_closure_229_1645 = BFALSE;
						{
						   global_ginfo_75_t new1352_1646;
						   new1352_1646 = ((global_ginfo_75_t) BREF(GC_MALLOC(sizeof(struct global_ginfo_75))));
						   ((((global_ginfo_75_t) CREF(new1352_1646))->escape__117) = ((bool_t) arg1747_1537), BUNSPEC);
						   ((((global_ginfo_75_t) CREF(new1352_1646))->global_closure_229) = ((obj_t) global_closure_229_1645), BUNSPEC);
						   res1763_1649 = new1352_1646;
						}
					     }
					     arg1746_1536 = res1763_1649;
					  }
				       }
				       {
					  obj_t aux_2151;
					  object_t aux_2149;
					  aux_2151 = (obj_t) (arg1746_1536);
					  aux_2149 = (object_t) (obj1373_1535);
					  OBJECT_WIDENING_SET(aux_2149, aux_2151);
				       }
				    }
				    {
				       long arg1751_1540;
				       arg1751_1540 = class_num_218___object(global_ginfo_75_globalize_ginfo);
				       {
					  obj_t obj_1650;
					  obj_1650 = (obj_t) (obj1373_1535);
					  (((obj_t) CREF(obj_1650))->header = MAKE_HEADER(arg1751_1540, 0), BUNSPEC);
				       }
				    }
				    (obj_t) (obj1373_1535);
				 }
			    }
			  call_next_method_114_1553:
			    {
			       obj_t aux1736_1549;
			       {
				  obj_t aux_2158;
				  {
				     bool_t test_2160;
				     if (VECTORP(class1738_1527))
				       {
					  long aux_2163;
					  aux_2163 = VECTOR_LENGTH(class1738_1527);
					  test_2160 = (aux_2163 == ((long) 9));
				       }
				     else
				       {
					  test_2160 = ((bool_t) 0);
				       }
				     if (test_2160)
				       {
					  aux_2158 = class_super_145___object(class1738_1527);
				       }
				     else
				       {
					  aux_2158 = BFALSE;
				       }
				  }
				  aux1736_1549 = find_method_from_44___object((object_t) (variable_1), escape_fun__env_92_globalize_escape, aux_2158);
			       }
			       {
				  {
				     obj_t class1738_2170;
				     obj_t method1733_2168;
				     method1733_2168 = CDR(aux1736_1549);
				     class1738_2170 = CAR(aux1736_1549);
				     class1738_1527 = class1738_2170;
				     method1733_1526 = method1733_2168;
				     goto loop1734_1554;
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 1):
			 {
			    local_t variable_1541;
			    variable_1541 = (local_t) (variable_1);
			    {
			       bool_t test1752_1542;
			       test1752_1542 = is_a__118___object((obj_t) (variable_1541), local_ginfo_108_globalize_ginfo);
			       if (test1752_1542)
				 {
				    BUNSPEC;
				 }
			       else
				 {
				    local_ginfo_108_t obj1374_1543;
				    obj1374_1543 = ((local_ginfo_108_t) (variable_1541));
				    {
				       local_ginfo_108_t arg1753_1544;
				       {
					  local_ginfo_108_t res1764_1656;
					  {
					     local_ginfo_108_t new1338_1654;
					     new1338_1654 = ((local_ginfo_108_t) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
					     ((((local_ginfo_108_t) CREF(new1338_1654))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					     res1764_1656 = new1338_1654;
					  }
					  arg1753_1544 = res1764_1656;
				       }
				       {
					  obj_t aux_2181;
					  object_t aux_2179;
					  aux_2181 = (obj_t) (arg1753_1544);
					  aux_2179 = (object_t) (obj1374_1543);
					  OBJECT_WIDENING_SET(aux_2179, aux_2181);
				       }
				    }
				    {
				       long arg1754_1545;
				       arg1754_1545 = class_num_218___object(local_ginfo_108_globalize_ginfo);
				       {
					  obj_t obj_1657;
					  obj_1657 = (obj_t) (obj1374_1543);
					  (((obj_t) CREF(obj_1657))->header = MAKE_HEADER(arg1754_1545, 0), BUNSPEC);
				       }
				    }
				    (obj_t) (obj1374_1543);
				 }
			    }
			    goto call_next_method_114_1553;
			 }
			 break;
		      default:
		       case_else1739_211_1530:
			 if (PROCEDUREP(method1733_1526))
			   {
			      return PROCEDURE_ENTRY(method1733_1526) (method1733_1526, (obj_t) (variable_1), BEOA);
			   }
			 else
			   {
			      obj_t fun1471_968;
			      fun1471_968 = PROCEDURE_REF(escape_fun__env_92_globalize_escape, ((long) 0));
			      return PROCEDURE_ENTRY(fun1471_968) (fun1471_968, (obj_t) (variable_1), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1739_211_1530;
		 }
	    }
	 }
      }
   }
}


obj_t 
_escape_fun__253_globalize_escape(obj_t env_1983, obj_t variable_1984)
{
   return escape_fun__53_globalize_escape((variable_t) (variable_1984));
}


obj_t 
set_escaping_fun__default1412_30_globalize_escape(variable_t variable_6)
{
   {
      obj_t arg1476_971;
      {
	 obj_t arg1477_972;
	 arg1477_972 = shape_tools_shape((obj_t) (variable_6));
	 {
	    obj_t aux_2203;
	    aux_2203 = (obj_t) (variable_6);
	    arg1476_971 = MAKE_PAIR(aux_2203, arg1477_972);
	 }
      }
      FAILURE(string1777_globalize_escape, string1778_globalize_escape, arg1476_971);
   }
}


obj_t 
_set_escaping_fun__default1412_157_globalize_escape(obj_t env_1989, obj_t variable_1990)
{
   return set_escaping_fun__default1412_30_globalize_escape((variable_t) (variable_1990));
}


obj_t 
set_escaping_fun__14_globalize_escape(variable_t variable_5)
{
   {
      obj_t method1710_1501;
      obj_t class1715_1502;
      {
	 obj_t arg1718_1499;
	 obj_t arg1719_1500;
	 {
	    object_t obj_1677;
	    obj_1677 = (object_t) (variable_5);
	    {
	       obj_t pre_method_105_1678;
	       pre_method_105_1678 = PROCEDURE_REF(set_escaping_fun__env_225_globalize_escape, ((long) 2));
	       if (INTEGERP(pre_method_105_1678))
		 {
		    PROCEDURE_SET(set_escaping_fun__env_225_globalize_escape, ((long) 2), BUNSPEC);
		    arg1718_1499 = pre_method_105_1678;
		 }
	       else
		 {
		    long obj_class_num_177_1683;
		    obj_class_num_177_1683 = TYPE(obj_1677);
		    {
		       obj_t arg1183_1684;
		       arg1183_1684 = PROCEDURE_REF(set_escaping_fun__env_225_globalize_escape, ((long) 1));
		       {
			  long arg1184_1688;
			  {
			     long arg1186_1689;
			     arg1186_1689 = OBJECT_TYPE;
			     arg1184_1688 = (obj_class_num_177_1683 - arg1186_1689);
			  }
			  arg1718_1499 = VECTOR_REF(arg1183_1684, arg1184_1688);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1694;
	    object_1694 = (object_t) (variable_5);
	    {
	       long arg1187_1695;
	       {
		  long arg1188_1696;
		  long arg1189_1697;
		  arg1188_1696 = TYPE(object_1694);
		  arg1189_1697 = OBJECT_TYPE;
		  arg1187_1695 = (arg1188_1696 - arg1189_1697);
	       }
	       {
		  obj_t vector_1701;
		  vector_1701 = __classes__134___object;
		  arg1719_1500 = VECTOR_REF(vector_1701, arg1187_1695);
	       }
	    }
	 }
	 method1710_1501 = arg1718_1499;
	 class1715_1502 = arg1719_1500;
	 {
	    if (INTEGERP(method1710_1501))
	      {
		 switch ((long) CINT(method1710_1501))
		   {
		   case ((long) 0):
		      {
			 global_t variable_1508;
			 variable_1508 = (global_t) (variable_5);
			 {
			    global_ginfo_75_t obj1375_1509;
			    obj1375_1509 = ((global_ginfo_75_t) (variable_1508));
			    {
			       global_ginfo_75_t arg1722_1510;
			       {
				  global_ginfo_75_t res1767_1708;
				  {
				     obj_t global_closure_229_1704;
				     global_closure_229_1704 = BFALSE;
				     {
					global_ginfo_75_t new1352_1705;
					new1352_1705 = ((global_ginfo_75_t) BREF(GC_MALLOC(sizeof(struct global_ginfo_75))));
					((((global_ginfo_75_t) CREF(new1352_1705))->escape__117) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					((((global_ginfo_75_t) CREF(new1352_1705))->global_closure_229) = ((obj_t) global_closure_229_1704), BUNSPEC);
					res1767_1708 = new1352_1705;
				     }
				  }
				  arg1722_1510 = res1767_1708;
			       }
			       {
				  obj_t aux_2233;
				  object_t aux_2231;
				  aux_2233 = (obj_t) (arg1722_1510);
				  aux_2231 = (object_t) (obj1375_1509);
				  OBJECT_WIDENING_SET(aux_2231, aux_2233);
			       }
			    }
			    {
			       long arg1724_1511;
			       arg1724_1511 = class_num_218___object(global_ginfo_75_globalize_ginfo);
			       {
				  obj_t obj_1709;
				  obj_1709 = (obj_t) (obj1375_1509);
				  (((obj_t) CREF(obj_1709))->header = MAKE_HEADER(arg1724_1511, 0), BUNSPEC);
			       }
			    }
			    return (obj_t) (obj1375_1509);
			 }
		      }
		      break;
		   case ((long) 1):
		      {
			 global_ginfo_75_t variable_1512;
			 variable_1512 = (global_ginfo_75_t) (variable_5);
			 {
			    obj_t res1768_1713;
			    {
			       obj_t x_1995;
			       {
				  obj_t aux_2241;
				  {
				     object_t aux_2242;
				     aux_2242 = (object_t) (variable_1512);
				     aux_2241 = OBJECT_WIDENING(aux_2242);
				  }
				  x_1995 = ((((global_ginfo_75_t) CREF(aux_2241))->escape__117) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			       }
			       res1768_1713 = BUNSPEC;
			    }
			    return res1768_1713;
			 }
		      }
		      break;
		   case ((long) 2):
		      {
			 local_ginfo_108_t variable_1513;
			 variable_1513 = (local_ginfo_108_t) (variable_5);
			 {
			    obj_t res1769_1716;
			    {
			       obj_t x_1996;
			       {
				  obj_t aux_2247;
				  {
				     object_t aux_2248;
				     aux_2248 = (object_t) (variable_1513);
				     aux_2247 = OBJECT_WIDENING(aux_2248);
				  }
				  x_1996 = ((((local_ginfo_108_t) CREF(aux_2247))->escape__117) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			       }
			       res1769_1716 = BUNSPEC;
			    }
			    return res1769_1716;
			 }
		      }
		      break;
		   default:
		    case_else1716_29_1505:
		      if (PROCEDUREP(method1710_1501))
			{
			   return PROCEDURE_ENTRY(method1710_1501) (method1710_1501, (obj_t) (variable_5), BEOA);
			}
		      else
			{
			   obj_t fun1478_973;
			   fun1478_973 = PROCEDURE_REF(set_escaping_fun__env_225_globalize_escape, ((long) 0));
			   return PROCEDURE_ENTRY(fun1478_973) (fun1478_973, (obj_t) (variable_5), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1716_29_1505;
	      }
	 }
      }
   }
}


obj_t 
_set_escaping_fun__208_globalize_escape(obj_t env_1987, obj_t variable_1988)
{
   return set_escaping_fun__14_globalize_escape((variable_t) (variable_1988));
}


obj_t 
escape__default1420_75_globalize_escape(node_t node_11)
{
   FAILURE(CNST_TABLE_REF(((long) 1)), string1779_globalize_escape, (obj_t) (node_11));
}


obj_t 
_escape__default1420_244_globalize_escape(obj_t env_1993, obj_t node_1994)
{
   return escape__default1420_75_globalize_escape((node_t) (node_1994));
}


obj_t 
escape__235_globalize_escape(node_t node_10)
{
 escape__235_globalize_escape:
   {
      obj_t method1602_1359;
      obj_t class1607_1360;
      {
	 obj_t arg1611_1357;
	 obj_t arg1614_1358;
	 {
	    object_t obj_1724;
	    obj_1724 = (object_t) (node_10);
	    {
	       obj_t pre_method_105_1725;
	       pre_method_105_1725 = PROCEDURE_REF(escape__env_201_globalize_escape, ((long) 2));
	       if (INTEGERP(pre_method_105_1725))
		 {
		    PROCEDURE_SET(escape__env_201_globalize_escape, ((long) 2), BUNSPEC);
		    arg1611_1357 = pre_method_105_1725;
		 }
	       else
		 {
		    long obj_class_num_177_1730;
		    obj_class_num_177_1730 = TYPE(obj_1724);
		    {
		       obj_t arg1183_1731;
		       arg1183_1731 = PROCEDURE_REF(escape__env_201_globalize_escape, ((long) 1));
		       {
			  long arg1184_1735;
			  {
			     long arg1186_1736;
			     arg1186_1736 = OBJECT_TYPE;
			     arg1184_1735 = (obj_class_num_177_1730 - arg1186_1736);
			  }
			  arg1611_1357 = VECTOR_REF(arg1183_1731, arg1184_1735);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1741;
	    object_1741 = (object_t) (node_10);
	    {
	       long arg1187_1742;
	       {
		  long arg1188_1743;
		  long arg1189_1744;
		  arg1188_1743 = TYPE(object_1741);
		  arg1189_1744 = OBJECT_TYPE;
		  arg1187_1742 = (arg1188_1743 - arg1189_1744);
	       }
	       {
		  obj_t vector_1748;
		  vector_1748 = __classes__134___object;
		  arg1614_1358 = VECTOR_REF(vector_1748, arg1187_1742);
	       }
	    }
	 }
	 method1602_1359 = arg1611_1357;
	 class1607_1360 = arg1614_1358;
	 {
	    if (INTEGERP(method1602_1359))
	      {
		 switch ((long) CINT(method1602_1359))
		   {
		   case ((long) 0):
		      return CNST_TABLE_REF(((long) 2));
		      break;
		   case ((long) 1):
		      return CNST_TABLE_REF(((long) 2));
		      break;
		   case ((long) 2):
		      return CNST_TABLE_REF(((long) 2));
		      break;
		   case ((long) 3):
		      {
			 closure_t node_1369;
			 node_1369 = (closure_t) (node_10);
			 return set_escaping_fun__14_globalize_escape((((closure_t) CREF(node_1369))->variable));
		      }
		      break;
		   case ((long) 4):
		      {
			 sequence_t node_1371;
			 node_1371 = (sequence_t) (node_10);
			 {
			    bool_t aux_2294;
			    aux_2294 = escape___220_globalize_escape((((sequence_t) CREF(node_1371))->nodes));
			    return BBOOL(aux_2294);
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 app_t node_1373;
			 node_1373 = (app_t) (node_10);
			 {
			    bool_t aux_2299;
			    aux_2299 = escape___220_globalize_escape((((app_t) CREF(node_1373))->args));
			    return BBOOL(aux_2299);
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 app_ly_162_t node_1376;
			 node_1376 = (app_ly_162_t) (node_10);
			 escape__235_globalize_escape((((app_ly_162_t) CREF(node_1376))->fun));
			 {
			    node_t node_2306;
			    node_2306 = (((app_ly_162_t) CREF(node_1376))->arg);
			    node_10 = node_2306;
			    goto escape__235_globalize_escape;
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 funcall_t node_1380;
			 node_1380 = (funcall_t) (node_10);
			 escape__235_globalize_escape((((funcall_t) CREF(node_1380))->fun));
			 {
			    bool_t aux_2311;
			    aux_2311 = escape___220_globalize_escape((((funcall_t) CREF(node_1380))->args));
			    return BBOOL(aux_2311);
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 pragma_t node_1384;
			 node_1384 = (pragma_t) (node_10);
			 {
			    bool_t aux_2316;
			    aux_2316 = escape___220_globalize_escape((((pragma_t) CREF(node_1384))->args));
			    return BBOOL(aux_2316);
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 cast_t node_1386;
			 node_1386 = (cast_t) (node_10);
			 {
			    node_t node_2321;
			    node_2321 = (((cast_t) CREF(node_1386))->arg);
			    node_10 = node_2321;
			    goto escape__235_globalize_escape;
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 setq_t node_1388;
			 node_1388 = (setq_t) (node_10);
			 {
			    node_t node_2324;
			    node_2324 = (((setq_t) CREF(node_1388))->value);
			    node_10 = node_2324;
			    goto escape__235_globalize_escape;
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 conditional_t node_1391;
			 node_1391 = (conditional_t) (node_10);
			 escape__235_globalize_escape((((conditional_t) CREF(node_1391))->test));
			 escape__235_globalize_escape((((conditional_t) CREF(node_1391))->true));
			 {
			    node_t node_2331;
			    node_2331 = (((conditional_t) CREF(node_1391))->false);
			    node_10 = node_2331;
			    goto escape__235_globalize_escape;
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 fail_t node_1396;
			 node_1396 = (fail_t) (node_10);
			 escape__235_globalize_escape((((fail_t) CREF(node_1396))->proc));
			 escape__235_globalize_escape((((fail_t) CREF(node_1396))->msg));
			 {
			    node_t node_2338;
			    node_2338 = (((fail_t) CREF(node_1396))->obj);
			    node_10 = node_2338;
			    goto escape__235_globalize_escape;
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 select_t node_1401;
			 node_1401 = (select_t) (node_10);
			 escape__235_globalize_escape((((select_t) CREF(node_1401))->test));
			 {
			    obj_t l1383_1404;
			    {
			       bool_t aux_2343;
			       l1383_1404 = (((select_t) CREF(node_1401))->clauses);
			     lname1384_1405:
			       if (PAIRP(l1383_1404))
				 {
				    {
				       node_t aux_2346;
				       {
					  obj_t aux_2347;
					  {
					     obj_t aux_2348;
					     aux_2348 = CAR(l1383_1404);
					     aux_2347 = CDR(aux_2348);
					  }
					  aux_2346 = (node_t) (aux_2347);
				       }
				       escape__235_globalize_escape(aux_2346);
				    }
				    {
				       obj_t l1383_2353;
				       l1383_2353 = CDR(l1383_1404);
				       l1383_1404 = l1383_2353;
				       goto lname1384_1405;
				    }
				 }
			       else
				 {
				    aux_2343 = ((bool_t) 1);
				 }
			       return BBOOL(aux_2343);
			    }
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 let_fun_218_t node_1411;
			 node_1411 = (let_fun_218_t) (node_10);
			 {
			    obj_t l1386_1413;
			    l1386_1413 = (((let_fun_218_t) CREF(node_1411))->locals);
			  lname1387_1414:
			    if (PAIRP(l1386_1413))
			      {
				 {
				    obj_t local_1417;
				    local_1417 = CAR(l1386_1413);
				    {
				       local_ginfo_108_t obj1388_1418;
				       obj1388_1418 = ((local_ginfo_108_t) (local_1417));
				       {
					  local_ginfo_108_t arg1650_1419;
					  {
					     local_ginfo_108_t res1771_1778;
					     {
						local_ginfo_108_t new1338_1776;
						new1338_1776 = ((local_ginfo_108_t) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
						((((local_ginfo_108_t) CREF(new1338_1776))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						res1771_1778 = new1338_1776;
					     }
					     arg1650_1419 = res1771_1778;
					  }
					  {
					     obj_t aux_2366;
					     object_t aux_2364;
					     aux_2366 = (obj_t) (arg1650_1419);
					     aux_2364 = (object_t) (obj1388_1418);
					     OBJECT_WIDENING_SET(aux_2364, aux_2366);
					  }
				       }
				       {
					  long arg1651_1420;
					  arg1651_1420 = class_num_218___object(local_ginfo_108_globalize_ginfo);
					  {
					     obj_t obj_1779;
					     obj_1779 = (obj_t) (obj1388_1418);
					     (((obj_t) CREF(obj_1779))->header = MAKE_HEADER(arg1651_1420, 0), BUNSPEC);
					  }
				       }
				       obj1388_1418;
				    }
				    {
				       value_t fun_1421;
				       {
					  local_t obj_1781;
					  obj_1781 = (local_t) (local_1417);
					  fun_1421 = (((local_t) CREF(obj_1781))->value);
				       }
				       {
					  sfun_ginfo_98_t obj1389_1422;
					  obj1389_1422 = ((sfun_ginfo_98_t) (fun_1421));
					  {
					     sfun_ginfo_98_t arg1652_1423;
					     {
						sfun_ginfo_98_t res1772_1819;
						{
						   obj_t cfrom__119_1784;
						   obj_t cto__14_1786;
						   obj_t the_global_201_1793;
						   obj_t kaptured_1794;
						   obj_t new_body_215_1795;
						   cfrom__119_1784 = BFALSE;
						   cto__14_1786 = BFALSE;
						   the_global_201_1793 = BFALSE;
						   kaptured_1794 = BFALSE;
						   new_body_215_1795 = BFALSE;
						   {
						      sfun_ginfo_98_t new1280_1800;
						      new1280_1800 = ((sfun_ginfo_98_t) BREF(GC_MALLOC(sizeof(struct sfun_ginfo_98))));
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->g__219) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->cfrom) = ((obj_t) BNIL), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->cfrom__119) = ((obj_t) cfrom__119_1784), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->cto) = ((obj_t) BNIL), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->cto__14) = ((obj_t) cto__14_1786), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->cfunction) = ((obj_t) BNIL), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->integrator) = ((obj_t) BNIL), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->integrated) = ((obj_t) BNIL), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->plugged_in_15) = ((obj_t) BNIL), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->mark) = ((long) ((long) -10)), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->free_mark_81) = ((obj_t) BNIL), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->the_global_201) = ((obj_t) the_global_201_1793), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->kaptured) = ((obj_t) kaptured_1794), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->new_body_215) = ((obj_t) new_body_215_1795), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->bmark) = ((long) ((long) -10)), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->umark) = ((long) ((long) -10)), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->free) = ((obj_t) BUNSPEC), BUNSPEC);
						      ((((sfun_ginfo_98_t) CREF(new1280_1800))->bound) = ((obj_t) BNIL), BUNSPEC);
						      res1772_1819 = new1280_1800;
						   }
						}
						arg1652_1423 = res1772_1819;
					     }
					     {
						obj_t aux_2396;
						object_t aux_2394;
						aux_2396 = (obj_t) (arg1652_1423);
						aux_2394 = (object_t) (obj1389_1422);
						OBJECT_WIDENING_SET(aux_2394, aux_2396);
					     }
					  }
					  {
					     long arg1668_1435;
					     arg1668_1435 = class_num_218___object(sfun_ginfo_98_globalize_ginfo);
					     {
						obj_t obj_1820;
						obj_1820 = (obj_t) (obj1389_1422);
						(((obj_t) CREF(obj_1820))->header = MAKE_HEADER(arg1668_1435, 0), BUNSPEC);
					     }
					  }
					  obj1389_1422;
				       }
				       {
					  obj_t l1390_1436;
					  {
					     sfun_t obj_1822;
					     obj_1822 = (sfun_t) (fun_1421);
					     l1390_1436 = (((sfun_t) CREF(obj_1822))->args);
					  }
					lname1392_1437:
					  if (PAIRP(l1390_1436))
					    {
					       {
						  obj_t local_1440;
						  local_1440 = CAR(l1390_1436);
						  {
						     svar_ginfo_131_t obj1394_1441;
						     {
							value_t aux_2405;
							{
							   local_t obj_1825;
							   obj_1825 = (local_t) (local_1440);
							   aux_2405 = (((local_t) CREF(obj_1825))->value);
							}
							obj1394_1441 = ((svar_ginfo_131_t) (aux_2405));
						     }
						     {
							svar_ginfo_131_t arg1671_1442;
							{
							   svar_ginfo_131_t res1773_1835;
							   {
							      svar_ginfo_131_t new1314_1830;
							      new1314_1830 = ((svar_ginfo_131_t) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
							      ((((svar_ginfo_131_t) CREF(new1314_1830))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							      ((((svar_ginfo_131_t) CREF(new1314_1830))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
							      ((((svar_ginfo_131_t) CREF(new1314_1830))->mark) = ((long) ((long) -10)), BUNSPEC);
							      ((((svar_ginfo_131_t) CREF(new1314_1830))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							      res1773_1835 = new1314_1830;
							   }
							   arg1671_1442 = res1773_1835;
							}
							{
							   obj_t aux_2416;
							   object_t aux_2414;
							   aux_2416 = (obj_t) (arg1671_1442);
							   aux_2414 = (object_t) (obj1394_1441);
							   OBJECT_WIDENING_SET(aux_2414, aux_2416);
							}
						     }
						     {
							long arg1673_1443;
							arg1673_1443 = class_num_218___object(svar_ginfo_131_globalize_ginfo);
							{
							   obj_t obj_1836;
							   obj_1836 = (obj_t) (obj1394_1441);
							   (((obj_t) CREF(obj_1836))->header = MAKE_HEADER(arg1673_1443, 0), BUNSPEC);
							}
						     }
						     obj1394_1441;
						  }
					       }
					       {
						  obj_t l1390_2422;
						  l1390_2422 = CDR(l1390_1436);
						  l1390_1436 = l1390_2422;
						  goto lname1392_1437;
					       }
					    }
					  else
					    {
					       ((bool_t) 1);
					    }
				       }
				    }
				 }
				 {
				    obj_t l1386_2426;
				    l1386_2426 = CDR(l1386_1413);
				    l1386_1413 = l1386_2426;
				    goto lname1387_1414;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    obj_t l1395_1446;
			    l1395_1446 = (((let_fun_218_t) CREF(node_1411))->locals);
			  lname1396_1447:
			    if (PAIRP(l1395_1446))
			      {
				 {
				    node_t aux_2431;
				    {
				       obj_t aux_2432;
				       {
					  sfun_t obj_1844;
					  {
					     value_t aux_2433;
					     {
						local_t obj_1843;
						{
						   obj_t aux_2434;
						   aux_2434 = CAR(l1395_1446);
						   obj_1843 = (local_t) (aux_2434);
						}
						aux_2433 = (((local_t) CREF(obj_1843))->value);
					     }
					     obj_1844 = (sfun_t) (aux_2433);
					  }
					  aux_2432 = (((sfun_t) CREF(obj_1844))->body);
				       }
				       aux_2431 = (node_t) (aux_2432);
				    }
				    escape__235_globalize_escape(aux_2431);
				 }
				 {
				    obj_t l1395_2442;
				    l1395_2442 = CDR(l1395_1446);
				    l1395_1446 = l1395_2442;
				    goto lname1396_1447;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    node_t node_2445;
			    node_2445 = (((let_fun_218_t) CREF(node_1411))->body);
			    node_10 = node_2445;
			    goto escape__235_globalize_escape;
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 let_var_6_t node_1455;
			 node_1455 = (let_var_6_t) (node_10);
			 escape__235_globalize_escape((((let_var_6_t) CREF(node_1455))->body));
			 {
			    obj_t l1398_1458;
			    {
			       bool_t aux_2450;
			       l1398_1458 = (((let_var_6_t) CREF(node_1455))->bindings);
			     lname1399_1459:
			       if (PAIRP(l1398_1458))
				 {
				    {
				       obj_t binding_1462;
				       binding_1462 = CAR(l1398_1458);
				       {
					  svar_ginfo_131_t obj1401_1463;
					  {
					     value_t aux_2454;
					     {
						obj_t arg1690_1466;
						arg1690_1466 = CAR(binding_1462);
						{
						   local_t obj_1852;
						   obj_1852 = (local_t) (arg1690_1466);
						   aux_2454 = (((local_t) CREF(obj_1852))->value);
						}
					     }
					     obj1401_1463 = ((svar_ginfo_131_t) (aux_2454));
					  }
					  {
					     svar_ginfo_131_t arg1688_1464;
					     {
						svar_ginfo_131_t res1774_1862;
						{
						   svar_ginfo_131_t new1314_1857;
						   new1314_1857 = ((svar_ginfo_131_t) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
						   ((((svar_ginfo_131_t) CREF(new1314_1857))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						   ((((svar_ginfo_131_t) CREF(new1314_1857))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
						   ((((svar_ginfo_131_t) CREF(new1314_1857))->mark) = ((long) ((long) -10)), BUNSPEC);
						   ((((svar_ginfo_131_t) CREF(new1314_1857))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						   res1774_1862 = new1314_1857;
						}
						arg1688_1464 = res1774_1862;
					     }
					     {
						obj_t aux_2466;
						object_t aux_2464;
						aux_2466 = (obj_t) (arg1688_1464);
						aux_2464 = (object_t) (obj1401_1463);
						OBJECT_WIDENING_SET(aux_2464, aux_2466);
					     }
					  }
					  {
					     long arg1689_1465;
					     arg1689_1465 = class_num_218___object(svar_ginfo_131_globalize_ginfo);
					     {
						obj_t obj_1863;
						obj_1863 = (obj_t) (obj1401_1463);
						(((obj_t) CREF(obj_1863))->header = MAKE_HEADER(arg1689_1465, 0), BUNSPEC);
					     }
					  }
					  obj1401_1463;
				       }
				       {
					  node_t aux_2472;
					  {
					     obj_t aux_2473;
					     aux_2473 = CDR(binding_1462);
					     aux_2472 = (node_t) (aux_2473);
					  }
					  escape__235_globalize_escape(aux_2472);
				       }
				    }
				    {
				       obj_t l1398_2477;
				       l1398_2477 = CDR(l1398_1458);
				       l1398_1458 = l1398_2477;
				       goto lname1399_1459;
				    }
				 }
			       else
				 {
				    aux_2450 = ((bool_t) 1);
				 }
			       return BBOOL(aux_2450);
			    }
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 set_ex_it_116_t node_1469;
			 node_1469 = (set_ex_it_116_t) (node_10);
			 {
			    sexit_ginfo_81_t obj1403_1471;
			    {
			       value_t aux_2482;
			       {
				  variable_t arg1696_1474;
				  {
				     var_t arg1697_1475;
				     arg1697_1475 = (((set_ex_it_116_t) CREF(node_1469))->var);
				     arg1696_1474 = (((var_t) CREF(arg1697_1475))->variable);
				  }
				  {
				     local_t obj_1869;
				     obj_1869 = (local_t) (arg1696_1474);
				     aux_2482 = (((local_t) CREF(obj_1869))->value);
				  }
			       }
			       obj1403_1471 = ((sexit_ginfo_81_t) (aux_2482));
			    }
			    {
			       sexit_ginfo_81_t arg1694_1472;
			       {
				  sexit_ginfo_81_t res1775_1879;
				  {
				     sexit_ginfo_81_t new1326_1874;
				     new1326_1874 = ((sexit_ginfo_81_t) BREF(GC_MALLOC(sizeof(struct sexit_ginfo_81))));
				     ((((sexit_ginfo_81_t) CREF(new1326_1874))->g__219) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				     ((((sexit_ginfo_81_t) CREF(new1326_1874))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				     ((((sexit_ginfo_81_t) CREF(new1326_1874))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
				     ((((sexit_ginfo_81_t) CREF(new1326_1874))->mark) = ((long) ((long) -10)), BUNSPEC);
				     res1775_1879 = new1326_1874;
				  }
				  arg1694_1472 = res1775_1879;
			       }
			       {
				  obj_t aux_2495;
				  object_t aux_2493;
				  aux_2495 = (obj_t) (arg1694_1472);
				  aux_2493 = (object_t) (obj1403_1471);
				  OBJECT_WIDENING_SET(aux_2493, aux_2495);
			       }
			    }
			    {
			       long arg1695_1473;
			       arg1695_1473 = class_num_218___object(sexit_ginfo_81_globalize_ginfo);
			       {
				  obj_t obj_1880;
				  obj_1880 = (obj_t) (obj1403_1471);
				  (((obj_t) CREF(obj_1880))->header = MAKE_HEADER(arg1695_1473, 0), BUNSPEC);
			       }
			    }
			    obj1403_1471;
			 }
			 {
			    node_t node_2501;
			    node_2501 = (((set_ex_it_116_t) CREF(node_1469))->body);
			    node_10 = node_2501;
			    goto escape__235_globalize_escape;
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 jump_ex_it_184_t node_1477;
			 node_1477 = (jump_ex_it_184_t) (node_10);
			 escape__235_globalize_escape((((jump_ex_it_184_t) CREF(node_1477))->exit));
			 {
			    node_t node_2506;
			    node_2506 = (((jump_ex_it_184_t) CREF(node_1477))->value);
			    node_10 = node_2506;
			    goto escape__235_globalize_escape;
			 }
		      }
		      break;
		   case ((long) 18):
		      {
			 make_box_202_t node_1481;
			 node_1481 = (make_box_202_t) (node_10);
			 {
			    node_t node_2509;
			    node_2509 = (((make_box_202_t) CREF(node_1481))->value);
			    node_10 = node_2509;
			    goto escape__235_globalize_escape;
			 }
		      }
		      break;
		   case ((long) 19):
		      {
			 box_set__221_t node_1483;
			 node_1483 = (box_set__221_t) (node_10);
			 {
			    node_t node_2512;
			    node_2512 = (((box_set__221_t) CREF(node_1483))->value);
			    node_10 = node_2512;
			    goto escape__235_globalize_escape;
			 }
		      }
		      break;
		   case ((long) 20):
		      {
			 box_ref_242_t node_1486;
			 node_1486 = (box_ref_242_t) (node_10);
			 {
			    node_t node_2515;
			    {
			       var_t aux_2516;
			       aux_2516 = (((box_ref_242_t) CREF(node_1486))->var);
			       node_2515 = (node_t) (aux_2516);
			    }
			    node_10 = node_2515;
			    goto escape__235_globalize_escape;
			 }
		      }
		      break;
		   default:
		    case_else1608_223_1363:
		      if (PROCEDUREP(method1602_1359))
			{
			   return PROCEDURE_ENTRY(method1602_1359) (method1602_1359, (obj_t) (node_10), BEOA);
			}
		      else
			{
			   obj_t fun1482_976;
			   fun1482_976 = PROCEDURE_REF(escape__env_201_globalize_escape, ((long) 0));
			   return PROCEDURE_ENTRY(fun1482_976) (fun1482_976, (obj_t) (node_10), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1608_223_1363;
	      }
	 }
      }
   }
}


obj_t 
_escape__238_globalize_escape(obj_t env_1991, obj_t node_1992)
{
   return escape__235_globalize_escape((node_t) (node_1992));
}


bool_t 
escape___220_globalize_escape(obj_t node__221_33)
{
   {
      obj_t l1407_977;
      l1407_977 = node__221_33;
    lname1408_978:
      if (PAIRP(l1407_977))
	{
	   {
	      node_t aux_2534;
	      {
		 obj_t aux_2535;
		 aux_2535 = CAR(l1407_977);
		 aux_2534 = (node_t) (aux_2535);
	      }
	      escape__235_globalize_escape(aux_2534);
	   }
	   {
	      obj_t l1407_2539;
	      l1407_2539 = CDR(l1407_977);
	      l1407_977 = l1407_2539;
	      goto lname1408_978;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
imported_modules_init_94_globalize_escape()
{
   module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_ESCAPE");
   module_initialization_70_type_type(((long) 0), "GLOBALIZE_ESCAPE");
   module_initialization_70_ast_var(((long) 0), "GLOBALIZE_ESCAPE");
   module_initialization_70_ast_node(((long) 0), "GLOBALIZE_ESCAPE");
   return module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_ESCAPE");
}
