/*===========================================================================*/
/*   (Globalize/free.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_t;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_t;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_t;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_t;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_t;


extern obj_t svar_ginfo_131_globalize_ginfo;
extern obj_t __procedure__226_type_cache;
extern obj_t let_fun_218_ast_node;
static long __round__57_globalize_free;
static obj_t free_variable__181_globalize_free(obj_t);
static obj_t _node_free_default1407_221_globalize_free(obj_t, obj_t, obj_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
extern obj_t sexit_ginfo_81_globalize_ginfo;
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t the_local_closure_213_globalize_free(obj_t, obj_t);
static obj_t imported_modules_init_94_globalize_free();
extern obj_t module_initialization_70_globalize_free(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_node(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_globalize_global_closure_246(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t toplevel_init_63_globalize_free();
static obj_t cnst_init_137_globalize_free();
extern obj_t the_closure_238_globalize_free(variable_t, obj_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t require_initialization_114_globalize_free = BUNSPEC;
static obj_t bind_variable__14_globalize_free(local_t, local_t);
extern obj_t _free_from_124_globalize_free(obj_t, obj_t, obj_t);
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_globalize_free();
extern obj_t sfun_ast_var;
static obj_t node_free_158_globalize_free(node_t, obj_t);
extern obj_t cast_ast_node;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t sfun_ginfo_98_globalize_ginfo;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t _the_global_closure_99_globalize_free(obj_t, obj_t, obj_t);
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t pragma_ast_node;
static obj_t _node_free_100_globalize_free(obj_t, obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t local_ginfo_108_globalize_ginfo;
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t app_ly_162_ast_node;
extern global_t def_global_scnst__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
static obj_t __integrator__235_globalize_free = BUNSPEC;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t free_from_222_globalize_free(obj_t, local_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t node_free__199_globalize_free(obj_t, obj_t);
static obj_t mark_variable__104_globalize_free(local_t);
static obj_t internal_get_free_vars__185_globalize_free(node_t, local_t);
extern obj_t setq_ast_node;
extern obj_t the_global_closure_233_globalize_free(global_t, obj_t);
static obj_t node_free_default1407_63_globalize_free(node_t, obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern global_t make_global_closure_44_globalize_global_closure_246(global_t);
extern obj_t set_ex_it_116_ast_node;
extern obj_t get_free_vars_244_globalize_free(node_t, local_t);
extern obj_t local_ast_var;
extern obj_t _the_closure_68_globalize_free(obj_t, obj_t, obj_t);
extern obj_t _____74_type_cache;
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
extern obj_t _get_free_vars_234_globalize_free(obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t __cnst[7];

DEFINE_STRING(string1855_globalize_free, string1855_globalize_free1872, "free-variable?", 14);
DEFINE_STATIC_GENERIC(node_free_env_48_globalize_free, _node_free_100_globalize_free1873, _node_free_100_globalize_free, 0L, 2);
DEFINE_EXPORT_PROCEDURE(get_free_vars_env_212_globalize_free, _get_free_vars_234_globalize_free1874, _get_free_vars_234_globalize_free, 0L, 2);
DEFINE_STRING(string1857_globalize_free, string1857_globalize_free1875, "] : ", 4);
DEFINE_EXPORT_PROCEDURE(the_closure_env_75_globalize_free, _the_closure_68_globalize_free1876, _the_closure_68_globalize_free, 0L, 2);
DEFINE_STRING(string1856_globalize_free, string1856_globalize_free1877, "Unknown variable type", 21);
DEFINE_STRING(string1863_globalize_free, string1863_globalize_free1878, "   bound(", 9);
DEFINE_STATIC_PROCEDURE(node_free_default1407_env_111_globalize_free, _node_free_default1407_221_globalize_free1879, _node_free_default1407_221_globalize_free, 0L, 2);
DEFINE_EXPORT_PROCEDURE(the_global_closure_env_40_globalize_free, _the_global_closure_99_globalize_free1880, _the_global_closure_99_globalize_free, 0L, 2);
DEFINE_STRING(string1858_globalize_free, string1858_globalize_free1881, "get-free-vars [", 15);
DEFINE_STRING(string1864_globalize_free, string1864_globalize_free1882, "SFUN SGFUN -ENV::PROCEDURE VALUE MAKE-FX-PROCEDURE MAKE-VA-PROCEDURE GLOBALIZE ", 79);
DEFINE_STRING(string1859_globalize_free, string1859_globalize_free1883, " l'ast: ", 8);
DEFINE_EXPORT_PROCEDURE(free_from_env_97_globalize_free, _free_from_124_globalize_free1884, _free_from_124_globalize_free, 0L, 2);
DEFINE_STRING(string1860_globalize_free, string1860_globalize_free1885, "J'ai pluge pour la globale: ", 28);
DEFINE_STRING(string1861_globalize_free, string1861_globalize_free1886, "   sets: ", 9);
DEFINE_STRING(string1862_globalize_free, string1862_globalize_free1887, ") : ", 4);

obj_t 
module_initialization_70_globalize_free(long checksum_2118, char *from_2119)
{
   if (CBOOL(require_initialization_114_globalize_free))
     {
	require_initialization_114_globalize_free = BBOOL(((bool_t) 0));
	library_modules_init_112_globalize_free();
	cnst_init_137_globalize_free();
	imported_modules_init_94_globalize_free();
	toplevel_init_63_globalize_free();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_globalize_free()
{
   module_initialization_70___object(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70___reader(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70___r4_symbols_6_4(((long) 0), "GLOBALIZE_FREE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_globalize_free()
{
   {
      obj_t cnst_port_138_2110;
      cnst_port_138_2110 = open_input_string(string1864_globalize_free);
      {
	 long i_2111;
	 i_2111 = ((long) 6);
       loop_2112:
	 {
	    bool_t test1865_2113;
	    test1865_2113 = (i_2111 == ((long) -1));
	    if (test1865_2113)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1866_2114;
		    {
		       obj_t list1867_2115;
		       {
			  obj_t arg1870_2116;
			  arg1870_2116 = BNIL;
			  list1867_2115 = MAKE_PAIR(cnst_port_138_2110, arg1870_2116);
		       }
		       arg1866_2114 = read___reader(list1867_2115);
		    }
		    CNST_TABLE_SET(i_2111, arg1866_2114);
		 }
		 {
		    int aux_2117;
		    {
		       long aux_2137;
		       aux_2137 = (i_2111 - ((long) 1));
		       aux_2117 = (int) (aux_2137);
		    }
		    {
		       long i_2140;
		       i_2140 = (long) (aux_2117);
		       i_2111 = i_2140;
		       goto loop_2112;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_globalize_free()
{
   __round__57_globalize_free = ((long) 0);
   __integrator__235_globalize_free = BUNSPEC;
   add_generic__110___object(node_free_env_48_globalize_free, node_free_default1407_env_111_globalize_free);
   add_inlined_method__244___object(node_free_env_48_globalize_free, var_ast_node, ((long) 0));
   add_inlined_method__244___object(node_free_env_48_globalize_free, closure_ast_node, ((long) 1));
   add_inlined_method__244___object(node_free_env_48_globalize_free, sequence_ast_node, ((long) 2));
   add_inlined_method__244___object(node_free_env_48_globalize_free, app_ast_node, ((long) 3));
   add_inlined_method__244___object(node_free_env_48_globalize_free, app_ly_162_ast_node, ((long) 4));
   add_inlined_method__244___object(node_free_env_48_globalize_free, funcall_ast_node, ((long) 5));
   add_inlined_method__244___object(node_free_env_48_globalize_free, pragma_ast_node, ((long) 6));
   add_inlined_method__244___object(node_free_env_48_globalize_free, cast_ast_node, ((long) 7));
   add_inlined_method__244___object(node_free_env_48_globalize_free, setq_ast_node, ((long) 8));
   add_inlined_method__244___object(node_free_env_48_globalize_free, conditional_ast_node, ((long) 9));
   add_inlined_method__244___object(node_free_env_48_globalize_free, fail_ast_node, ((long) 10));
   add_inlined_method__244___object(node_free_env_48_globalize_free, select_ast_node, ((long) 11));
   add_inlined_method__244___object(node_free_env_48_globalize_free, let_fun_218_ast_node, ((long) 12));
   add_inlined_method__244___object(node_free_env_48_globalize_free, let_var_6_ast_node, ((long) 13));
   add_inlined_method__244___object(node_free_env_48_globalize_free, set_ex_it_116_ast_node, ((long) 14));
   add_inlined_method__244___object(node_free_env_48_globalize_free, jump_ex_it_184_ast_node, ((long) 15));
   add_inlined_method__244___object(node_free_env_48_globalize_free, make_box_202_ast_node, ((long) 16));
   add_inlined_method__244___object(node_free_env_48_globalize_free, box_ref_242_ast_node, ((long) 17));
   {
      long aux_2161;
      aux_2161 = add_inlined_method__244___object(node_free_env_48_globalize_free, box_set__221_ast_node, ((long) 18));
      return BINT(aux_2161);
   }
}


obj_t 
mark_variable__104_globalize_free(local_t local_1)
{
   {
      value_t info_970;
      info_970 = (((local_t) CREF(local_1))->value);
      {
	 bool_t test1431_971;
	 test1431_971 = is_a__118___object((obj_t) (info_970), svar_ginfo_131_globalize_ginfo);
	 if (test1431_971)
	   {
	      {
		 obj_t res1840_1696;
		 {
		    svar_ginfo_131_t obj_1694;
		    long val1319_1695;
		    obj_1694 = (svar_ginfo_131_t) (info_970);
		    val1319_1695 = __round__57_globalize_free;
		    {
		       obj_t x_2101;
		       {
			  obj_t aux_2169;
			  {
			     object_t aux_2170;
			     aux_2170 = (object_t) (obj_1694);
			     aux_2169 = OBJECT_WIDENING(aux_2170);
			  }
			  x_2101 = ((((svar_ginfo_131_t) CREF(aux_2169))->free_mark_81) = ((long) val1319_1695), BUNSPEC);
		       }
		       res1840_1696 = BUNSPEC;
		    }
		 }
		 return res1840_1696;
	      }
	   }
	 else
	   {
	      bool_t test1432_972;
	      test1432_972 = is_a__118___object((obj_t) (info_970), sfun_ginfo_98_globalize_ginfo);
	      if (test1432_972)
		{
		   {
		      obj_t res1841_1700;
		      {
			 sfun_ginfo_98_t obj_1698;
			 obj_t val1304_1699;
			 obj_1698 = (sfun_ginfo_98_t) (info_970);
			 val1304_1699 = BINT(__round__57_globalize_free);
			 {
			    obj_t x_2102;
			    {
			       obj_t aux_2179;
			       {
				  object_t aux_2180;
				  aux_2180 = (object_t) (obj_1698);
				  aux_2179 = OBJECT_WIDENING(aux_2180);
			       }
			       x_2102 = ((((sfun_ginfo_98_t) CREF(aux_2179))->free_mark_81) = ((obj_t) val1304_1699), BUNSPEC);
			    }
			    res1841_1700 = BUNSPEC;
			 }
		      }
		      return res1841_1700;
		   }
		}
	      else
		{
		   bool_t test1433_973;
		   test1433_973 = is_a__118___object((obj_t) (info_970), sexit_ginfo_81_globalize_ginfo);
		   if (test1433_973)
		     {
			{
			   obj_t res1842_1704;
			   {
			      sexit_ginfo_81_t obj_1702;
			      long val1334_1703;
			      obj_1702 = (sexit_ginfo_81_t) (info_970);
			      val1334_1703 = __round__57_globalize_free;
			      {
				 obj_t x_2103;
				 {
				    obj_t aux_2188;
				    {
				       object_t aux_2189;
				       aux_2189 = (object_t) (obj_1702);
				       aux_2188 = OBJECT_WIDENING(aux_2189);
				    }
				    x_2103 = ((((sexit_ginfo_81_t) CREF(aux_2188))->free_mark_81) = ((long) val1334_1703), BUNSPEC);
				 }
				 res1842_1704 = BUNSPEC;
			      }
			   }
			   return res1842_1704;
			}
		     }
		   else
		     {
			return BFALSE;
		     }
		}
	   }
      }
   }
}


obj_t 
bind_variable__14_globalize_free(local_t local_2, local_t integrator_3)
{
   {
      value_t finfo_974;
      finfo_974 = (((local_t) CREF(integrator_3))->value);
      {
	 obj_t arg1440_975;
	 {
	    obj_t aux_2196;
	    obj_t aux_2194;
	    {
	       sfun_ginfo_98_t obj_1706;
	       obj_1706 = (sfun_ginfo_98_t) (finfo_974);
	       {
		  obj_t aux_2198;
		  {
		     object_t aux_2199;
		     aux_2199 = (object_t) (obj_1706);
		     aux_2198 = OBJECT_WIDENING(aux_2199);
		  }
		  aux_2196 = (((sfun_ginfo_98_t) CREF(aux_2198))->bound);
	       }
	    }
	    aux_2194 = (obj_t) (local_2);
	    arg1440_975 = MAKE_PAIR(aux_2194, aux_2196);
	 }
	 {
	    obj_t res1843_1711;
	    {
	       sfun_ginfo_98_t obj_1709;
	       obj_1709 = (sfun_ginfo_98_t) (finfo_974);
	       {
		  obj_t x_2104;
		  {
		     obj_t aux_2205;
		     {
			object_t aux_2206;
			aux_2206 = (object_t) (obj_1709);
			aux_2205 = OBJECT_WIDENING(aux_2206);
		     }
		     x_2104 = ((((sfun_ginfo_98_t) CREF(aux_2205))->bound) = ((obj_t) arg1440_975), BUNSPEC);
		  }
		  res1843_1711 = BUNSPEC;
	       }
	    }
	    res1843_1711;
	 }
      }
      return mark_variable__104_globalize_free(local_2);
   }
}


obj_t 
free_variable__181_globalize_free(obj_t local_4)
{
   {
      value_t info_977;
      {
	 local_t obj_1712;
	 obj_1712 = (local_t) (local_4);
	 info_977 = (((local_t) CREF(obj_1712))->value);
      }
      {
	 bool_t test1442_978;
	 test1442_978 = is_a__118___object((obj_t) (info_977), svar_ginfo_131_globalize_ginfo);
	 if (test1442_978)
	   {
	      {
		 bool_t test1443_979;
		 {
		    obj_t obj1_1715;
		    obj_t obj2_1716;
		    {
		       long aux_2216;
		       {
			  svar_ginfo_131_t obj_1714;
			  obj_1714 = (svar_ginfo_131_t) (info_977);
			  {
			     obj_t aux_2218;
			     {
				object_t aux_2219;
				aux_2219 = (object_t) (obj_1714);
				aux_2218 = OBJECT_WIDENING(aux_2219);
			     }
			     aux_2216 = (((svar_ginfo_131_t) CREF(aux_2218))->free_mark_81);
			  }
		       }
		       obj1_1715 = BINT(aux_2216);
		    }
		    obj2_1716 = BINT(__round__57_globalize_free);
		    test1443_979 = (obj1_1715 == obj2_1716);
		 }
		 if (test1443_979)
		   {
		      return BFALSE;
		   }
		 else
		   {
		      return BTRUE;
		   }
	      }
	   }
	 else
	   {
	      bool_t test1445_981;
	      test1445_981 = is_a__118___object((obj_t) (info_977), sfun_ginfo_98_globalize_ginfo);
	      if (test1445_981)
		{
		   {
		      bool_t test1446_982;
		      {
			 obj_t arg1447_983;
			 {
			    sfun_ginfo_98_t obj_1718;
			    obj_1718 = (sfun_ginfo_98_t) (info_977);
			    {
			       obj_t aux_2231;
			       {
				  object_t aux_2232;
				  aux_2232 = (object_t) (obj_1718);
				  aux_2231 = OBJECT_WIDENING(aux_2232);
			       }
			       arg1447_983 = (((sfun_ginfo_98_t) CREF(aux_2231))->free_mark_81);
			    }
			 }
			 {
			    obj_t obj2_1720;
			    obj2_1720 = BINT(__round__57_globalize_free);
			    test1446_982 = (arg1447_983 == obj2_1720);
			 }
		      }
		      if (test1446_982)
			{
			   return BFALSE;
			}
		      else
			{
			   return BTRUE;
			}
		   }
		}
	      else
		{
		   bool_t test1448_984;
		   test1448_984 = is_a__118___object((obj_t) (info_977), sexit_ginfo_81_globalize_ginfo);
		   if (test1448_984)
		     {
			{
			   bool_t test1449_985;
			   {
			      obj_t obj1_1723;
			      obj_t obj2_1724;
			      {
				 long aux_2242;
				 {
				    sexit_ginfo_81_t obj_1722;
				    obj_1722 = (sexit_ginfo_81_t) (info_977);
				    {
				       obj_t aux_2244;
				       {
					  object_t aux_2245;
					  aux_2245 = (object_t) (obj_1722);
					  aux_2244 = OBJECT_WIDENING(aux_2245);
				       }
				       aux_2242 = (((sexit_ginfo_81_t) CREF(aux_2244))->free_mark_81);
				    }
				 }
				 obj1_1723 = BINT(aux_2242);
			      }
			      obj2_1724 = BINT(__round__57_globalize_free);
			      test1449_985 = (obj1_1723 == obj2_1724);
			   }
			   if (test1449_985)
			     {
				return BFALSE;
			     }
			   else
			     {
				return BTRUE;
			     }
			}
		     }
		   else
		     {
			{
			   obj_t arg1454_989;
			   {
			      obj_t arg1457_990;
			      arg1457_990 = shape_tools_shape(local_4);
			      arg1454_989 = MAKE_PAIR(local_4, arg1457_990);
			   }
			   FAILURE(string1855_globalize_free, string1856_globalize_free, arg1454_989);
			}
		     }
		}
	   }
      }
   }
}


obj_t 
get_free_vars_244_globalize_free(node_t node_5, local_t integrator_6)
{
   {
      bool_t test1458_991;
      {
	 obj_t aux_2256;
	 aux_2256 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1458_991 = CBOOL(aux_2256);
      }
      if (test1458_991)
	{
	   obj_t arg1463_993;
	   arg1463_993 = shape_tools_shape((obj_t) (integrator_6));
	   {
	      obj_t list1466_995;
	      {
		 obj_t arg1467_996;
		 {
		    obj_t arg1468_997;
		    {
		       obj_t arg1470_998;
		       {
			  obj_t aux_2264;
			  aux_2264 = BCHAR(((unsigned char) '\n'));
			  arg1470_998 = MAKE_PAIR(aux_2264, BNIL);
		       }
		       arg1468_997 = MAKE_PAIR(string1857_globalize_free, arg1470_998);
		    }
		    arg1467_996 = MAKE_PAIR(arg1463_993, arg1468_997);
		 }
		 list1466_995 = MAKE_PAIR(string1858_globalize_free, arg1467_996);
	      }
	      print_trace_107_tools_trace(list1466_995);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t free_1002;
      {
	 sfun_ginfo_98_t obj_1731;
	 {
	    value_t aux_2271;
	    aux_2271 = (((local_t) CREF(integrator_6))->value);
	    obj_1731 = (sfun_ginfo_98_t) (aux_2271);
	 }
	 {
	    obj_t aux_2274;
	    {
	       object_t aux_2275;
	       aux_2275 = (object_t) (obj_1731);
	       aux_2274 = OBJECT_WIDENING(aux_2275);
	    }
	    free_1002 = (((sfun_ginfo_98_t) CREF(aux_2274))->free);
	 }
      }
      {
	 bool_t test_2279;
	 if (NULLP(free_1002))
	   {
	      test_2279 = ((bool_t) 1);
	   }
	 else
	   {
	      test_2279 = PAIRP(free_1002);
	   }
	 if (test_2279)
	   {
	      return free_1002;
	   }
	 else
	   {
	      obj_t free_1004;
	      free_1004 = internal_get_free_vars__185_globalize_free(node_5, integrator_6);
	      {
		 obj_t res1844_1737;
		 {
		    sfun_ginfo_98_t obj_1735;
		    {
		       value_t aux_2284;
		       aux_2284 = (((local_t) CREF(integrator_6))->value);
		       obj_1735 = (sfun_ginfo_98_t) (aux_2284);
		    }
		    {
		       obj_t x_2105;
		       {
			  obj_t aux_2287;
			  {
			     object_t aux_2288;
			     aux_2288 = (object_t) (obj_1735);
			     aux_2287 = OBJECT_WIDENING(aux_2288);
			  }
			  x_2105 = ((((sfun_ginfo_98_t) CREF(aux_2287))->free) = ((obj_t) free_1004), BUNSPEC);
		       }
		       res1844_1737 = BUNSPEC;
		    }
		 }
		 res1844_1737;
	      }
	      return free_1004;
	   }
      }
   }
}


obj_t 
_get_free_vars_234_globalize_free(obj_t env_2089, obj_t node_2090, obj_t integrator_2091)
{
   return get_free_vars_244_globalize_free((node_t) (node_2090), (local_t) (integrator_2091));
}


obj_t 
internal_get_free_vars__185_globalize_free(node_t node_7, local_t integrator_8)
{
   {
      long z1_1738;
      z1_1738 = __round__57_globalize_free;
      __round__57_globalize_free = (z1_1738 + ((long) 1));
   }
   __integrator__235_globalize_free = (obj_t) (integrator_8);
   bind_variable__14_globalize_free(integrator_8, integrator_8);
   {
      obj_t arg1480_1008;
      {
	 variable_t variable_1740;
	 obj_t loc_1741;
	 variable_1740 = (variable_t) (integrator_8);
	 loc_1741 = BFALSE;
	 {
	    bool_t test1495_1742;
	    test1495_1742 = is_a__118___object((obj_t) (variable_1740), global_ast_var);
	    if (test1495_1742)
	      {
		 arg1480_1008 = the_global_closure_233_globalize_free((global_t) (variable_1740), loc_1741);
	      }
	    else
	      {
		 arg1480_1008 = the_local_closure_213_globalize_free((obj_t) (variable_1740), loc_1741);
	      }
	 }
      }
      bind_variable__14_globalize_free((local_t) (arg1480_1008), integrator_8);
   }
   {
      obj_t l1369_1009;
      {
	 sfun_t obj_1745;
	 {
	    value_t aux_2317;
	    aux_2317 = (((local_t) CREF(integrator_8))->value);
	    obj_1745 = (sfun_t) (aux_2317);
	 }
	 l1369_1009 = (((sfun_t) CREF(obj_1745))->args);
      }
    lname1370_1010:
      if (PAIRP(l1369_1009))
	{
	   {
	      local_t aux_2310;
	      {
		 obj_t aux_2311;
		 aux_2311 = CAR(l1369_1009);
		 aux_2310 = (local_t) (aux_2311);
	      }
	      bind_variable__14_globalize_free(aux_2310, integrator_8);
	   }
	   {
	      obj_t l1369_2315;
	      l1369_2315 = CDR(l1369_1009);
	      l1369_1009 = l1369_2315;
	      goto lname1370_1010;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   return node_free_158_globalize_free(node_7, BNIL);
}


obj_t 
node_free_default1407_63_globalize_free(node_t node_11, obj_t free_12)
{
   return free_12;
}


obj_t 
_node_free_default1407_221_globalize_free(obj_t env_2086, obj_t node_2087, obj_t free_2088)
{
   return node_free_default1407_63_globalize_free((node_t) (node_2087), free_2088);
}


obj_t 
node_free_158_globalize_free(node_t node_9, obj_t free_10)
{
 node_free_158_globalize_free:
   {
      obj_t method1732_1519;
      obj_t class1737_1520;
      {
	 obj_t arg1740_1517;
	 obj_t arg1741_1518;
	 {
	    object_t obj_1749;
	    obj_1749 = (object_t) (node_9);
	    {
	       obj_t pre_method_105_1750;
	       pre_method_105_1750 = PROCEDURE_REF(node_free_env_48_globalize_free, ((long) 2));
	       if (INTEGERP(pre_method_105_1750))
		 {
		    PROCEDURE_SET(node_free_env_48_globalize_free, ((long) 2), BUNSPEC);
		    arg1740_1517 = pre_method_105_1750;
		 }
	       else
		 {
		    long obj_class_num_177_1755;
		    obj_class_num_177_1755 = TYPE(obj_1749);
		    {
		       obj_t arg1183_1756;
		       arg1183_1756 = PROCEDURE_REF(node_free_env_48_globalize_free, ((long) 1));
		       {
			  long arg1184_1760;
			  {
			     long arg1186_1761;
			     arg1186_1761 = OBJECT_TYPE;
			     arg1184_1760 = (obj_class_num_177_1755 - arg1186_1761);
			  }
			  arg1740_1517 = VECTOR_REF(arg1183_1756, arg1184_1760);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1766;
	    object_1766 = (object_t) (node_9);
	    {
	       long arg1187_1767;
	       {
		  long arg1188_1768;
		  long arg1189_1769;
		  arg1188_1768 = TYPE(object_1766);
		  arg1189_1769 = OBJECT_TYPE;
		  arg1187_1767 = (arg1188_1768 - arg1189_1769);
	       }
	       {
		  obj_t vector_1773;
		  vector_1773 = __classes__134___object;
		  arg1741_1518 = VECTOR_REF(vector_1773, arg1187_1767);
	       }
	    }
	 }
	 method1732_1519 = arg1740_1517;
	 class1737_1520 = arg1741_1518;
	 {
	    if (INTEGERP(method1732_1519))
	      {
		 switch ((long) CINT(method1732_1519))
		   {
		   case ((long) 0):
		      {
			 var_t node_1526;
			 node_1526 = (var_t) (node_9);
			 {
			    bool_t test1744_1529;
			    {
			       obj_t aux_2342;
			       {
				  variable_t aux_2343;
				  aux_2343 = (((var_t) CREF(node_1526))->variable);
				  aux_2342 = (obj_t) (aux_2343);
			       }
			       test1744_1529 = is_a__118___object(aux_2342, global_ast_var);
			    }
			    if (test1744_1529)
			      {
				 return free_10;
			      }
			    else
			      {
				 bool_t test1745_1530;
				 {
				    obj_t aux_2348;
				    {
				       obj_t aux_2349;
				       {
					  variable_t aux_2350;
					  aux_2350 = (((var_t) CREF(node_1526))->variable);
					  aux_2349 = (obj_t) (aux_2350);
				       }
				       aux_2348 = free_variable__181_globalize_free(aux_2349);
				    }
				    test1745_1530 = CBOOL(aux_2348);
				 }
				 if (test1745_1530)
				   {
				      {
					 local_t aux_2356;
					 {
					    variable_t aux_2357;
					    aux_2357 = (((var_t) CREF(node_1526))->variable);
					    aux_2356 = (local_t) (aux_2357);
					 }
					 mark_variable__104_globalize_free(aux_2356);
				      }
				      {
					 obj_t aux_2361;
					 {
					    variable_t aux_2362;
					    aux_2362 = (((var_t) CREF(node_1526))->variable);
					    aux_2361 = (obj_t) (aux_2362);
					 }
					 return MAKE_PAIR(aux_2361, free_10);
				      }
				   }
				 else
				   {
				      return free_10;
				   }
			      }
			 }
		      }
		      break;
		   case ((long) 1):
		      {
			 closure_t node_1535;
			 node_1535 = (closure_t) (node_9);
			 {
			    obj_t var_1538;
			    {
			       variable_t arg1753_1541;
			       arg1753_1541 = (((closure_t) CREF(node_1535))->variable);
			       {
				  obj_t loc_1784;
				  loc_1784 = BFALSE;
				  {
				     bool_t test1495_1785;
				     test1495_1785 = is_a__118___object((obj_t) (arg1753_1541), global_ast_var);
				     if (test1495_1785)
				       {
					  var_1538 = the_global_closure_233_globalize_free((global_t) (arg1753_1541), loc_1784);
				       }
				     else
				       {
					  var_1538 = the_local_closure_213_globalize_free((obj_t) (arg1753_1541), loc_1784);
				       }
				  }
			       }
			    }
			    {
			       bool_t test1750_1539;
			       test1750_1539 = is_a__118___object(var_1538, global_ast_var);
			       if (test1750_1539)
				 {
				    return free_10;
				 }
			       else
				 {
				    bool_t test1751_1540;
				    {
				       obj_t aux_2377;
				       aux_2377 = free_variable__181_globalize_free(var_1538);
				       test1751_1540 = CBOOL(aux_2377);
				    }
				    if (test1751_1540)
				      {
					 mark_variable__104_globalize_free((local_t) (var_1538));
					 return MAKE_PAIR(var_1538, free_10);
				      }
				    else
				      {
					 return free_10;
				      }
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 2):
		      {
			 sequence_t node_1542;
			 node_1542 = (sequence_t) (node_9);
			 return node_free__199_globalize_free((((sequence_t) CREF(node_1542))->nodes), free_10);
		      }
		      break;
		   case ((long) 3):
		      {
			 app_t node_1546;
			 node_1546 = (app_t) (node_9);
			 {
			    obj_t free_1549;
			    {
			       variable_t var_1551;
			       {
				  var_t arg1761_1557;
				  arg1761_1557 = (((app_t) CREF(node_1546))->fun);
				  var_1551 = (((var_t) CREF(arg1761_1557))->variable);
			       }
			       {
				  bool_t test1756_1552;
				  test1756_1552 = is_a__118___object((obj_t) (var_1551), global_ast_var);
				  if (test1756_1552)
				    {
				       free_1549 = free_10;
				    }
				  else
				    {
				       bool_t test1757_1553;
				       {
					  bool_t test_2393;
					  {
					     local_ginfo_108_t obj_1794;
					     obj_1794 = (local_ginfo_108_t) (var_1551);
					     {
						obj_t aux_2395;
						{
						   object_t aux_2396;
						   aux_2396 = (object_t) (obj_1794);
						   aux_2395 = OBJECT_WIDENING(aux_2396);
						}
						test_2393 = (((local_ginfo_108_t) CREF(aux_2395))->escape__117);
					     }
					  }
					  if (test_2393)
					    {
					       obj_t aux_2400;
					       aux_2400 = free_variable__181_globalize_free((obj_t) (var_1551));
					       test1757_1553 = CBOOL(aux_2400);
					    }
					  else
					    {
					       test1757_1553 = ((bool_t) 0);
					    }
				       }
				       if (test1757_1553)
					 {
					    mark_variable__104_globalize_free((local_t) (var_1551));
					    {
					       obj_t arg1758_1554;
					       {
						  obj_t arg1759_1555;
						  {
						     node_t obj_1795;
						     obj_1795 = (node_t) (node_1546);
						     arg1759_1555 = (((node_t) CREF(obj_1795))->loc);
						  }
						  {
						     bool_t test1495_1798;
						     test1495_1798 = is_a__118___object((obj_t) (var_1551), global_ast_var);
						     if (test1495_1798)
						       {
							  arg1758_1554 = the_global_closure_233_globalize_free((global_t) (var_1551), arg1759_1555);
						       }
						     else
						       {
							  arg1758_1554 = the_local_closure_213_globalize_free((obj_t) (var_1551), arg1759_1555);
						       }
						  }
					       }
					       free_1549 = MAKE_PAIR(arg1758_1554, free_10);
					    }
					 }
				       else
					 {
					    free_1549 = free_10;
					 }
				    }
			       }
			    }
			    return node_free__199_globalize_free((((app_t) CREF(node_1546))->args), free_1549);
			 }
		      }
		      break;
		   case ((long) 4):
		      {
			 app_ly_162_t node_1558;
			 node_1558 = (app_ly_162_t) (node_9);
			 {
			    node_t arg1762_1561;
			    obj_t arg1763_1562;
			    arg1762_1561 = (((app_ly_162_t) CREF(node_1558))->fun);
			    arg1763_1562 = node_free_158_globalize_free((((app_ly_162_t) CREF(node_1558))->arg), free_10);
			    {
			       obj_t free_2424;
			       node_t node_2423;
			       node_2423 = arg1762_1561;
			       free_2424 = arg1763_1562;
			       free_10 = free_2424;
			       node_9 = node_2423;
			       goto node_free_158_globalize_free;
			    }
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 funcall_t node_1564;
			 node_1564 = (funcall_t) (node_9);
			 {
			    node_t arg1766_1567;
			    obj_t arg1767_1568;
			    arg1766_1567 = (((funcall_t) CREF(node_1564))->fun);
			    arg1767_1568 = node_free__199_globalize_free((((funcall_t) CREF(node_1564))->args), free_10);
			    {
			       obj_t free_2430;
			       node_t node_2429;
			       node_2429 = arg1766_1567;
			       free_2430 = arg1767_1568;
			       free_10 = free_2430;
			       node_9 = node_2429;
			       goto node_free_158_globalize_free;
			    }
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 pragma_t node_1570;
			 node_1570 = (pragma_t) (node_9);
			 return node_free__199_globalize_free((((pragma_t) CREF(node_1570))->args), free_10);
		      }
		      break;
		   case ((long) 7):
		      {
			 cast_t node_1574;
			 node_1574 = (cast_t) (node_9);
			 {
			    node_t node_2435;
			    node_2435 = (((cast_t) CREF(node_1574))->arg);
			    node_9 = node_2435;
			    goto node_free_158_globalize_free;
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 setq_t node_1578;
			 node_1578 = (setq_t) (node_9);
			 {
			    var_t arg1772_1581;
			    obj_t arg1773_1582;
			    arg1772_1581 = (((setq_t) CREF(node_1578))->var);
			    arg1773_1582 = node_free_158_globalize_free((((setq_t) CREF(node_1578))->value), free_10);
			    {
			       obj_t free_2443;
			       node_t node_2441;
			       node_2441 = (node_t) (arg1772_1581);
			       free_2443 = arg1773_1582;
			       free_10 = free_2443;
			       node_9 = node_2441;
			       goto node_free_158_globalize_free;
			    }
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 conditional_t node_1584;
			 node_1584 = (conditional_t) (node_9);
			 {
			    node_t arg1775_1587;
			    obj_t arg1776_1588;
			    arg1775_1587 = (((conditional_t) CREF(node_1584))->test);
			    {
			       node_t arg1777_1589;
			       obj_t arg1778_1590;
			       arg1777_1589 = (((conditional_t) CREF(node_1584))->true);
			       arg1778_1590 = node_free_158_globalize_free((((conditional_t) CREF(node_1584))->false), free_10);
			       arg1776_1588 = node_free_158_globalize_free(arg1777_1589, arg1778_1590);
			    }
			    {
			       obj_t free_2451;
			       node_t node_2450;
			       node_2450 = arg1775_1587;
			       free_2451 = arg1776_1588;
			       free_10 = free_2451;
			       node_9 = node_2450;
			       goto node_free_158_globalize_free;
			    }
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 fail_t node_1592;
			 node_1592 = (fail_t) (node_9);
			 {
			    node_t arg1780_1595;
			    obj_t arg1781_1596;
			    arg1780_1595 = (((fail_t) CREF(node_1592))->proc);
			    {
			       node_t arg1783_1597;
			       obj_t arg1784_1598;
			       arg1783_1597 = (((fail_t) CREF(node_1592))->msg);
			       arg1784_1598 = node_free_158_globalize_free((((fail_t) CREF(node_1592))->obj), free_10);
			       arg1781_1596 = node_free_158_globalize_free(arg1783_1597, arg1784_1598);
			    }
			    {
			       obj_t free_2459;
			       node_t node_2458;
			       node_2458 = arg1780_1595;
			       free_2459 = arg1781_1596;
			       free_10 = free_2459;
			       node_9 = node_2458;
			       goto node_free_158_globalize_free;
			    }
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 select_t node_1600;
			 node_1600 = (select_t) (node_9);
			 {
			    obj_t clauses_1603;
			    obj_t free_1604;
			    clauses_1603 = (((select_t) CREF(node_1600))->clauses);
			    free_1604 = free_10;
			  loop_1605:
			    if (NULLP(clauses_1603))
			      {
				 obj_t free_2465;
				 node_t node_2463;
				 node_2463 = (((select_t) CREF(node_1600))->test);
				 free_2465 = free_1604;
				 free_10 = free_2465;
				 node_9 = node_2463;
				 goto node_free_158_globalize_free;
			      }
			    else
			      {
				 obj_t arg1789_1609;
				 obj_t arg1791_1610;
				 arg1789_1609 = CDR(clauses_1603);
				 {
				    node_t aux_2467;
				    {
				       obj_t aux_2468;
				       {
					  obj_t aux_2469;
					  aux_2469 = CAR(clauses_1603);
					  aux_2468 = CDR(aux_2469);
				       }
				       aux_2467 = (node_t) (aux_2468);
				    }
				    arg1791_1610 = node_free_158_globalize_free(aux_2467, free_1604);
				 }
				 {
				    obj_t free_2475;
				    obj_t clauses_2474;
				    clauses_2474 = arg1789_1609;
				    free_2475 = arg1791_1610;
				    free_1604 = free_2475;
				    clauses_1603 = clauses_2474;
				    goto loop_1605;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 let_fun_218_t node_1613;
			 node_1613 = (let_fun_218_t) (node_9);
			 {
			    obj_t l1384_1616;
			    l1384_1616 = (((let_fun_218_t) CREF(node_1613))->locals);
			  lname1386_1617:
			    if (PAIRP(l1384_1616))
			      {
				 {
				    obj_t f_1620;
				    f_1620 = CAR(l1384_1616);
				    bind_variable__14_globalize_free((local_t) (f_1620), (local_t) (__integrator__235_globalize_free));
				    {
				       bool_t test_2484;
				       {
					  local_ginfo_108_t obj_1826;
					  obj_1826 = (local_ginfo_108_t) (f_1620);
					  {
					     obj_t aux_2486;
					     {
						object_t aux_2487;
						aux_2487 = (object_t) (obj_1826);
						aux_2486 = OBJECT_WIDENING(aux_2487);
					     }
					     test_2484 = (((local_ginfo_108_t) CREF(aux_2486))->escape__117);
					  }
				       }
				       if (test_2484)
					 {
					    obj_t arg1798_1622;
					    {
					       obj_t aux_2491;
					       {
						  node_t obj_1827;
						  obj_1827 = (node_t) (node_1613);
						  aux_2491 = (((node_t) CREF(obj_1827))->loc);
					       }
					       arg1798_1622 = the_local_closure_213_globalize_free(f_1620, aux_2491);
					    }
					    bind_variable__14_globalize_free((local_t) (arg1798_1622), (local_t) (__integrator__235_globalize_free));
					 }
				       else
					 {
					    BUNSPEC;
					 }
				    }
				 }
				 {
				    obj_t l1384_2498;
				    l1384_2498 = CDR(l1384_1616);
				    l1384_1616 = l1384_2498;
				    goto lname1386_1617;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    obj_t lcls_1625;
			    obj_t free_1626;
			    lcls_1625 = (((let_fun_218_t) CREF(node_1613))->locals);
			    free_1626 = free_10;
			  liip_1627:
			    if (NULLP(lcls_1625))
			      {
				 obj_t free_2505;
				 node_t node_2503;
				 node_2503 = (((let_fun_218_t) CREF(node_1613))->body);
				 free_2505 = free_1626;
				 free_10 = free_2505;
				 node_9 = node_2503;
				 goto node_free_158_globalize_free;
			      }
			    else
			      {
				 value_t fun_1632;
				 {
				    local_t obj_1833;
				    {
				       obj_t aux_2506;
				       aux_2506 = CAR(lcls_1625);
				       obj_1833 = (local_t) (aux_2506);
				    }
				    fun_1632 = (((local_t) CREF(obj_1833))->value);
				 }
				 {
				    {
				       obj_t l1387_1633;
				       {
					  sfun_t obj_1834;
					  obj_1834 = (sfun_t) (fun_1632);
					  l1387_1633 = (((sfun_t) CREF(obj_1834))->args);
				       }
				     lname1390_1634:
				       if (PAIRP(l1387_1633))
					 {
					    {
					       local_t aux_2512;
					       {
						  obj_t aux_2513;
						  aux_2513 = CAR(l1387_1633);
						  aux_2512 = (local_t) (aux_2513);
					       }
					       bind_variable__14_globalize_free(aux_2512, (local_t) (__integrator__235_globalize_free));
					    }
					    {
					       obj_t l1387_2518;
					       l1387_2518 = CDR(l1387_1633);
					       l1387_1633 = l1387_2518;
					       goto lname1390_1634;
					    }
					 }
				       else
					 {
					    ((bool_t) 1);
					 }
				    }
				    {
				       obj_t arg1808_1639;
				       obj_t arg1809_1640;
				       arg1808_1639 = CDR(lcls_1625);
				       {
					  node_t aux_2523;
					  {
					     obj_t aux_2524;
					     {
						sfun_t obj_1839;
						obj_1839 = (sfun_t) (fun_1632);
						aux_2524 = (((sfun_t) CREF(obj_1839))->body);
					     }
					     aux_2523 = (node_t) (aux_2524);
					  }
					  arg1809_1640 = node_free_158_globalize_free(aux_2523, free_1626);
				       }
				       {
					  obj_t free_2530;
					  obj_t lcls_2529;
					  lcls_2529 = arg1808_1639;
					  free_2530 = arg1809_1640;
					  free_1626 = free_2530;
					  lcls_1625 = lcls_2529;
					  goto liip_1627;
				       }
				    }
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 let_var_6_t node_1642;
			 node_1642 = (let_var_6_t) (node_9);
			 {
			    obj_t bindings_1645;
			    obj_t free_1646;
			    bindings_1645 = (((let_var_6_t) CREF(node_1642))->bindings);
			    free_1646 = free_10;
			  loop_1647:
			    if (NULLP(bindings_1645))
			      {
				 obj_t free_2537;
				 node_t node_2535;
				 node_2535 = (((let_var_6_t) CREF(node_1642))->body);
				 free_2537 = free_1646;
				 free_10 = free_2537;
				 node_9 = node_2535;
				 goto node_free_158_globalize_free;
			      }
			    else
			      {
				 {
				    local_t aux_2538;
				    {
				       obj_t aux_2539;
				       {
					  obj_t aux_2540;
					  aux_2540 = CAR(bindings_1645);
					  aux_2539 = CAR(aux_2540);
				       }
				       aux_2538 = (local_t) (aux_2539);
				    }
				    bind_variable__14_globalize_free(aux_2538, (local_t) (__integrator__235_globalize_free));
				 }
				 {
				    obj_t arg1820_1653;
				    obj_t arg1821_1654;
				    arg1820_1653 = CDR(bindings_1645);
				    {
				       node_t aux_2547;
				       {
					  obj_t aux_2548;
					  {
					     obj_t aux_2549;
					     aux_2549 = CAR(bindings_1645);
					     aux_2548 = CDR(aux_2549);
					  }
					  aux_2547 = (node_t) (aux_2548);
				       }
				       arg1821_1654 = node_free_158_globalize_free(aux_2547, free_1646);
				    }
				    {
				       obj_t free_2555;
				       obj_t bindings_2554;
				       bindings_2554 = arg1820_1653;
				       free_2555 = arg1821_1654;
				       free_1646 = free_2555;
				       bindings_1645 = bindings_2554;
				       goto loop_1647;
				    }
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 set_ex_it_116_t node_1657;
			 node_1657 = (set_ex_it_116_t) (node_9);
			 {
			    local_t aux_2558;
			    {
			       variable_t aux_2559;
			       {
				  var_t arg1825_1661;
				  arg1825_1661 = (((set_ex_it_116_t) CREF(node_1657))->var);
				  aux_2559 = (((var_t) CREF(arg1825_1661))->variable);
			       }
			       aux_2558 = (local_t) (aux_2559);
			    }
			    bind_variable__14_globalize_free(aux_2558, (local_t) (__integrator__235_globalize_free));
			 }
			 {
			    node_t node_2565;
			    node_2565 = (((set_ex_it_116_t) CREF(node_1657))->body);
			    node_9 = node_2565;
			    goto node_free_158_globalize_free;
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 jump_ex_it_184_t node_1663;
			 node_1663 = (jump_ex_it_184_t) (node_9);
			 {
			    node_t arg1827_1666;
			    obj_t arg1828_1667;
			    arg1827_1666 = (((jump_ex_it_184_t) CREF(node_1663))->exit);
			    arg1828_1667 = node_free_158_globalize_free((((jump_ex_it_184_t) CREF(node_1663))->value), free_10);
			    {
			       obj_t free_2572;
			       node_t node_2571;
			       node_2571 = arg1827_1666;
			       free_2572 = arg1828_1667;
			       free_10 = free_2572;
			       node_9 = node_2571;
			       goto node_free_158_globalize_free;
			    }
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 make_box_202_t node_1669;
			 node_1669 = (make_box_202_t) (node_9);
			 {
			    node_t node_2574;
			    node_2574 = (((make_box_202_t) CREF(node_1669))->value);
			    node_9 = node_2574;
			    goto node_free_158_globalize_free;
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 box_ref_242_t node_1673;
			 node_1673 = (box_ref_242_t) (node_9);
			 {
			    node_t node_2577;
			    {
			       var_t aux_2578;
			       aux_2578 = (((box_ref_242_t) CREF(node_1673))->var);
			       node_2577 = (node_t) (aux_2578);
			    }
			    node_9 = node_2577;
			    goto node_free_158_globalize_free;
			 }
		      }
		      break;
		   case ((long) 18):
		      {
			 box_set__221_t node_1677;
			 node_1677 = (box_set__221_t) (node_9);
			 {
			    var_t arg1832_1680;
			    obj_t arg1833_1681;
			    arg1832_1680 = (((box_set__221_t) CREF(node_1677))->var);
			    arg1833_1681 = node_free_158_globalize_free((((box_set__221_t) CREF(node_1677))->value), free_10);
			    {
			       obj_t free_2587;
			       node_t node_2585;
			       node_2585 = (node_t) (arg1832_1680);
			       free_2587 = arg1833_1681;
			       free_10 = free_2587;
			       node_9 = node_2585;
			       goto node_free_158_globalize_free;
			    }
			 }
		      }
		      break;
		   default:
		    case_else1738_57_1523:
		      if (PROCEDUREP(method1732_1519))
			{
			   return PROCEDURE_ENTRY(method1732_1519) (method1732_1519, (obj_t) (node_9), free_10, BEOA);
			}
		      else
			{
			   obj_t fun1488_1017;
			   fun1488_1017 = PROCEDURE_REF(node_free_env_48_globalize_free, ((long) 0));
			   return PROCEDURE_ENTRY(fun1488_1017) (fun1488_1017, (obj_t) (node_9), free_10, BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1738_57_1523;
	      }
	 }
      }
   }
}


obj_t 
_node_free_100_globalize_free(obj_t env_2083, obj_t node_2084, obj_t free_2085)
{
   return node_free_158_globalize_free((node_t) (node_2084), free_2085);
}


obj_t 
node_free__199_globalize_free(obj_t node__221_51, obj_t free_52)
{
   {
      obj_t node__221_1018;
      obj_t free_1019;
      node__221_1018 = node__221_51;
      free_1019 = free_52;
    loop_1020:
      if (NULLP(node__221_1018))
	{
	   return free_1019;
	}
      else
	{
	   obj_t arg1490_1022;
	   obj_t arg1493_1023;
	   arg1490_1022 = CDR(node__221_1018);
	   {
	      node_t aux_2604;
	      {
		 obj_t aux_2605;
		 aux_2605 = CAR(node__221_1018);
		 aux_2604 = (node_t) (aux_2605);
	      }
	      arg1493_1023 = node_free_158_globalize_free(aux_2604, free_1019);
	   }
	   {
	      obj_t free_2610;
	      obj_t node__221_2609;
	      node__221_2609 = arg1490_1022;
	      free_2610 = arg1493_1023;
	      free_1019 = free_2610;
	      node__221_1018 = node__221_2609;
	      goto loop_1020;
	   }
	}
   }
}


obj_t 
the_closure_238_globalize_free(variable_t variable_53, obj_t loc_54)
{
   {
      bool_t test1495_1862;
      test1495_1862 = is_a__118___object((obj_t) (variable_53), global_ast_var);
      if (test1495_1862)
	{
	   return the_global_closure_233_globalize_free((global_t) (variable_53), loc_54);
	}
      else
	{
	   return the_local_closure_213_globalize_free((obj_t) (variable_53), loc_54);
	}
   }
}


obj_t 
_the_closure_68_globalize_free(obj_t env_2092, obj_t variable_2093, obj_t loc_2094)
{
   return the_closure_238_globalize_free((variable_t) (variable_2093), loc_2094);
}


obj_t 
the_global_closure_233_globalize_free(global_t global_55, obj_t loc_56)
{
   {
      obj_t closure_1026;
      {
	 fun_t obj_1865;
	 {
	    value_t aux_2620;
	    aux_2620 = (((global_t) CREF(global_55))->value);
	    obj_1865 = (fun_t) (aux_2620);
	 }
	 closure_1026 = (((fun_t) CREF(obj_1865))->the_closure_238);
      }
      {
	 bool_t test1496_1027;
	 test1496_1027 = is_a__118___object(closure_1026, global_ast_var);
	 if (test1496_1027)
	   {
	      return closure_1026;
	   }
	 else
	   {
	      global_t gloclo_1028;
	      gloclo_1028 = make_global_closure_44_globalize_global_closure_246(global_55);
	      {
		 long arity_1029;
		 {
		    fun_t obj_1868;
		    {
		       value_t aux_2627;
		       aux_2627 = (((global_t) CREF(global_55))->value);
		       obj_1868 = (fun_t) (aux_2627);
		    }
		    arity_1029 = (((fun_t) CREF(obj_1868))->arity);
		 }
		 {
		    obj_t make_clo_34_1030;
		    if ((arity_1029 < ((long) 0)))
		      {
			 make_clo_34_1030 = CNST_TABLE_REF(((long) 1));
		      }
		    else
		      {
			 make_clo_34_1030 = CNST_TABLE_REF(((long) 2));
		      }
		    {
		       node_t node_1031;
		       {
			  obj_t arg1541_1065;
			  obj_t arg1543_1067;
			  {
			     var_t arg1547_1068;
			     atom_t arg1549_1069;
			     atom_t arg1550_1070;
			     {
				var_t res1846_1881;
				{
				   type_t type_1872;
				   variable_t variable_1873;
				   type_1872 = (type_t) (_____74_type_cache);
				   variable_1873 = (variable_t) (gloclo_1028);
				   {
				      var_t new1133_1874;
				      new1133_1874 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				      {
					 long arg1694_1875;
					 arg1694_1875 = class_num_218___object(var_ast_node);
					 {
					    obj_t obj_1879;
					    obj_1879 = (obj_t) (new1133_1874);
					    (((obj_t) CREF(obj_1879))->header = MAKE_HEADER(arg1694_1875, 0), BUNSPEC);
					 }
				      }
				      {
					 object_t aux_2641;
					 aux_2641 = (object_t) (new1133_1874);
					 OBJECT_WIDENING_SET(aux_2641, BFALSE);
				      }
				      ((((var_t) CREF(new1133_1874))->loc) = ((obj_t) loc_56), BUNSPEC);
				      ((((var_t) CREF(new1133_1874))->type) = ((type_t) type_1872), BUNSPEC);
				      ((((var_t) CREF(new1133_1874))->variable) = ((variable_t) variable_1873), BUNSPEC);
				      res1846_1881 = new1133_1874;
				   }
				}
				arg1547_1068 = res1846_1881;
			     }
			     {
				atom_t res1847_1892;
				{
				   type_t type_1883;
				   obj_t value_1884;
				   type_1883 = (type_t) (_____74_type_cache);
				   value_1884 = BINT(arity_1029);
				   {
				      atom_t new1127_1885;
				      new1127_1885 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
				      {
					 long arg1696_1886;
					 arg1696_1886 = class_num_218___object(atom_ast_node);
					 {
					    obj_t obj_1890;
					    obj_1890 = (obj_t) (new1127_1885);
					    (((obj_t) CREF(obj_1890))->header = MAKE_HEADER(arg1696_1886, 0), BUNSPEC);
					 }
				      }
				      {
					 object_t aux_2653;
					 aux_2653 = (object_t) (new1127_1885);
					 OBJECT_WIDENING_SET(aux_2653, BFALSE);
				      }
				      ((((atom_t) CREF(new1127_1885))->loc) = ((obj_t) loc_56), BUNSPEC);
				      ((((atom_t) CREF(new1127_1885))->type) = ((type_t) type_1883), BUNSPEC);
				      ((((atom_t) CREF(new1127_1885))->value) = ((obj_t) value_1884), BUNSPEC);
				      res1847_1892 = new1127_1885;
				   }
				}
				arg1549_1069 = res1847_1892;
			     }
			     {
				atom_t res1848_1903;
				{
				   type_t type_1894;
				   obj_t value_1895;
				   type_1894 = (type_t) (_____74_type_cache);
				   value_1895 = BINT(((long) 0));
				   {
				      atom_t new1127_1896;
				      new1127_1896 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
				      {
					 long arg1696_1897;
					 arg1696_1897 = class_num_218___object(atom_ast_node);
					 {
					    obj_t obj_1901;
					    obj_1901 = (obj_t) (new1127_1896);
					    (((obj_t) CREF(obj_1901))->header = MAKE_HEADER(arg1696_1897, 0), BUNSPEC);
					 }
				      }
				      {
					 object_t aux_2665;
					 aux_2665 = (object_t) (new1127_1896);
					 OBJECT_WIDENING_SET(aux_2665, BFALSE);
				      }
				      ((((atom_t) CREF(new1127_1896))->loc) = ((obj_t) loc_56), BUNSPEC);
				      ((((atom_t) CREF(new1127_1896))->type) = ((type_t) type_1894), BUNSPEC);
				      ((((atom_t) CREF(new1127_1896))->value) = ((obj_t) value_1895), BUNSPEC);
				      res1848_1903 = new1127_1896;
				   }
				}
				arg1550_1070 = res1848_1903;
			     }
			     {
				obj_t list1552_1072;
				{
				   obj_t arg1553_1073;
				   {
				      obj_t arg1554_1074;
				      {
					 obj_t arg1555_1075;
					 arg1555_1075 = MAKE_PAIR(BNIL, BNIL);
					 {
					    obj_t aux_2672;
					    aux_2672 = (obj_t) (arg1550_1070);
					    arg1554_1074 = MAKE_PAIR(aux_2672, arg1555_1075);
					 }
				      }
				      {
					 obj_t aux_2675;
					 aux_2675 = (obj_t) (arg1549_1069);
					 arg1553_1073 = MAKE_PAIR(aux_2675, arg1554_1074);
				      }
				   }
				   {
				      obj_t aux_2678;
				      aux_2678 = (obj_t) (arg1547_1068);
				      list1552_1072 = MAKE_PAIR(aux_2678, arg1553_1073);
				   }
				}
				arg1541_1065 = cons__138___r4_pairs_and_lists_6_3(make_clo_34_1030, list1552_1072);
			     }
			  }
			  arg1543_1067 = CNST_TABLE_REF(((long) 3));
			  node_1031 = sexp__node_235_ast_sexp(arg1541_1065, BNIL, loc_56, arg1543_1067);
		       }
		       {
			  global_t closure_1032;
			  {
			     obj_t arg1523_1051;
			     obj_t arg1524_1052;
			     obj_t arg1526_1053;
			     {
				obj_t arg1529_1054;
				arg1529_1054 = (((global_t) CREF(global_55))->id);
				{
				   obj_t list1532_1056;
				   {
				      obj_t arg1534_1057;
				      {
					 obj_t aux_2685;
					 aux_2685 = CNST_TABLE_REF(((long) 4));
					 arg1534_1057 = MAKE_PAIR(aux_2685, BNIL);
				      }
				      list1532_1056 = MAKE_PAIR(arg1529_1054, arg1534_1057);
				   }
				   arg1523_1051 = symbol_append_197___r4_symbols_6_4(list1532_1056);
				}
			     }
			     arg1524_1052 = (((global_t) CREF(global_55))->module);
			     {
				bool_t test1536_1059;
				{
				   obj_t aux_2691;
				   {
				      value_t aux_2692;
				      aux_2692 = (((global_t) CREF(global_55))->value);
				      aux_2691 = (obj_t) (aux_2692);
				   }
				   test1536_1059 = is_a__118___object(aux_2691, sfun_ast_var);
				}
				if (test1536_1059)
				  {
				     bool_t test_2697;
				     {
					obj_t aux_2703;
					obj_t aux_2698;
					aux_2703 = CNST_TABLE_REF(((long) 5));
					{
					   sfun_t obj_1909;
					   {
					      value_t aux_2699;
					      aux_2699 = (((global_t) CREF(global_55))->value);
					      obj_1909 = (sfun_t) (aux_2699);
					   }
					   aux_2698 = (((sfun_t) CREF(obj_1909))->class);
					}
					test_2697 = (aux_2698 == aux_2703);
				     }
				     if (test_2697)
				       {
					  arg1526_1053 = CNST_TABLE_REF(((long) 5));
				       }
				     else
				       {
					  arg1526_1053 = CNST_TABLE_REF(((long) 6));
				       }
				  }
				else
				  {
				     arg1526_1053 = CNST_TABLE_REF(((long) 6));
				  }
			     }
			     closure_1032 = def_global_scnst__93_ast_glo_def_117(arg1523_1051, arg1524_1052, (obj_t) (node_1031), arg1526_1053);
			  }
			  {
			     {
				obj_t arg1497_1033;
				arg1497_1033 = (((global_t) CREF(global_55))->import);
				{
				   obj_t res1849_1915;
				   {
				      obj_t x_2106;
				      x_2106 = ((((global_t) CREF(closure_1032))->import) = ((obj_t) arg1497_1033), BUNSPEC);
				      res1849_1915 = BUNSPEC;
				   }
				   res1849_1915;
				}
			     }
			     {
				obj_t res1850_1919;
				{
				   fun_t obj_1917;
				   obj_t val1070_1918;
				   {
				      value_t aux_2713;
				      aux_2713 = (((global_t) CREF(global_55))->value);
				      obj_1917 = (fun_t) (aux_2713);
				   }
				   val1070_1918 = (obj_t) (closure_1032);
				   {
				      obj_t x_2107;
				      x_2107 = ((((fun_t) CREF(obj_1917))->the_closure_238) = ((obj_t) val1070_1918), BUNSPEC);
				      res1850_1919 = BUNSPEC;
				   }
				}
				res1850_1919;
			     }
			     {
				obj_t res1851_1923;
				{
				   fun_t obj_1921;
				   obj_t val1070_1922;
				   {
				      value_t aux_2718;
				      aux_2718 = (((global_t) CREF(gloclo_1028))->value);
				      obj_1921 = (fun_t) (aux_2718);
				   }
				   val1070_1922 = (obj_t) (closure_1032);
				   {
				      obj_t x_2108;
				      x_2108 = ((((fun_t) CREF(obj_1921))->the_closure_238) = ((obj_t) val1070_1922), BUNSPEC);
				      res1851_1923 = BUNSPEC;
				   }
				}
				res1851_1923;
			     }
			     {
				bool_t test1500_1036;
				{
				   obj_t aux_2723;
				   aux_2723 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
				   test1500_1036 = CBOOL(aux_2723);
				}
				if (test1500_1036)
				  {
				     obj_t arg1505_1038;
				     obj_t arg1507_1040;
				     arg1505_1038 = shape_tools_shape((obj_t) (closure_1032));
				     {
					obj_t aux_2731;
					{
					   scnst_t obj_1925;
					   {
					      value_t aux_2732;
					      aux_2732 = (((global_t) CREF(closure_1032))->value);
					      obj_1925 = (scnst_t) (aux_2732);
					   }
					   aux_2731 = (((scnst_t) CREF(obj_1925))->node);
					}
					arg1507_1040 = shape_tools_shape(aux_2731);
				     }
				     {
					obj_t list1508_1041;
					{
					   obj_t arg1509_1042;
					   {
					      obj_t arg1510_1043;
					      {
						 obj_t arg1511_1044;
						 {
						    obj_t arg1513_1045;
						    {
						       obj_t aux_2737;
						       aux_2737 = BCHAR(((unsigned char) '\n'));
						       arg1513_1045 = MAKE_PAIR(aux_2737, BNIL);
						    }
						    arg1511_1044 = MAKE_PAIR(arg1507_1040, arg1513_1045);
						 }
						 arg1510_1043 = MAKE_PAIR(string1859_globalize_free, arg1511_1044);
					      }
					      arg1509_1042 = MAKE_PAIR(arg1505_1038, arg1510_1043);
					   }
					   list1508_1041 = MAKE_PAIR(string1860_globalize_free, arg1509_1042);
					}
					print_trace_107_tools_trace(list1508_1041);
				     }
				  }
				else
				  {
				     BUNSPEC;
				  }
			     }
			     return (obj_t) (closure_1032);
			  }
		       }
		    }
		 }
	      }
	   }
      }
   }
}


obj_t 
_the_global_closure_99_globalize_free(obj_t env_2095, obj_t global_2096, obj_t loc_2097)
{
   return the_global_closure_233_globalize_free((global_t) (global_2096), loc_2097);
}


obj_t 
the_local_closure_213_globalize_free(obj_t local_57, obj_t loc_58)
{
   {
      value_t info_1080;
      {
	 local_t obj_1926;
	 obj_1926 = (local_t) (local_57);
	 info_1080 = (((local_t) CREF(obj_1926))->value);
      }
      {
	 bool_t test1561_1081;
	 {
	    obj_t aux_2750;
	    {
	       sfun_t obj_1927;
	       obj_1927 = (sfun_t) (info_1080);
	       aux_2750 = (((sfun_t) CREF(obj_1927))->the_closure_238);
	    }
	    test1561_1081 = is_a__118___object(aux_2750, local_ast_var);
	 }
	 if (test1561_1081)
	   {
	      sfun_t obj_1929;
	      obj_1929 = (sfun_t) (info_1080);
	      return (((sfun_t) CREF(obj_1929))->the_closure_238);
	   }
	 else
	   {
	      local_t closure_1082;
	      {
		 obj_t aux_2757;
		 {
		    local_t obj_1930;
		    obj_1930 = (local_t) (local_57);
		    aux_2757 = (((local_t) CREF(obj_1930))->id);
		 }
		 closure_1082 = make_local_svar_140_ast_local(aux_2757, (type_t) (__procedure__226_type_cache));
	      }
	      {
		 svar_ginfo_131_t obj1397_1083;
		 obj1397_1083 = ((svar_ginfo_131_t) ((((local_t) CREF(closure_1082))->value)));
		 {
		    svar_ginfo_131_t arg1562_1084;
		    {
		       svar_ginfo_131_t res1852_1941;
		       {
			  svar_ginfo_131_t new1314_1936;
			  new1314_1936 = ((svar_ginfo_131_t) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
			  ((((svar_ginfo_131_t) CREF(new1314_1936))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			  ((((svar_ginfo_131_t) CREF(new1314_1936))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
			  ((((svar_ginfo_131_t) CREF(new1314_1936))->mark) = ((long) ((long) -10)), BUNSPEC);
			  ((((svar_ginfo_131_t) CREF(new1314_1936))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			  res1852_1941 = new1314_1936;
		       }
		       arg1562_1084 = res1852_1941;
		    }
		    {
		       obj_t aux_2771;
		       object_t aux_2769;
		       aux_2771 = (obj_t) (arg1562_1084);
		       aux_2769 = (object_t) (obj1397_1083);
		       OBJECT_WIDENING_SET(aux_2769, aux_2771);
		    }
		 }
		 {
		    long arg1563_1085;
		    arg1563_1085 = class_num_218___object(svar_ginfo_131_globalize_ginfo);
		    {
		       obj_t obj_1942;
		       obj_1942 = (obj_t) (obj1397_1083);
		       (((obj_t) CREF(obj_1942))->header = MAKE_HEADER(arg1563_1085, 0), BUNSPEC);
		    }
		 }
		 obj1397_1083;
	      }
	      {
		 local_ginfo_108_t obj1398_1086;
		 obj1398_1086 = ((local_ginfo_108_t) (closure_1082));
		 {
		    local_ginfo_108_t arg1564_1087;
		    {
		       local_ginfo_108_t res1853_1947;
		       {
			  local_ginfo_108_t new1338_1945;
			  new1338_1945 = ((local_ginfo_108_t) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
			  ((((local_ginfo_108_t) CREF(new1338_1945))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			  res1853_1947 = new1338_1945;
		       }
		       arg1564_1087 = res1853_1947;
		    }
		    {
		       obj_t aux_2782;
		       object_t aux_2780;
		       aux_2782 = (obj_t) (arg1564_1087);
		       aux_2780 = (object_t) (obj1398_1086);
		       OBJECT_WIDENING_SET(aux_2780, aux_2782);
		    }
		 }
		 {
		    long arg1565_1088;
		    arg1565_1088 = class_num_218___object(local_ginfo_108_globalize_ginfo);
		    {
		       obj_t obj_1948;
		       obj_1948 = (obj_t) (obj1398_1086);
		       (((obj_t) CREF(obj_1948))->header = MAKE_HEADER(arg1565_1088, 0), BUNSPEC);
		    }
		 }
		 obj1398_1086;
	      }
	      {
		 obj_t res1854_1952;
		 {
		    sfun_t obj_1950;
		    obj_t val1288_1951;
		    obj_1950 = (sfun_t) (info_1080);
		    val1288_1951 = (obj_t) (closure_1082);
		    {
		       obj_t x_2109;
		       x_2109 = ((((sfun_t) CREF(obj_1950))->the_closure_238) = ((obj_t) val1288_1951), BUNSPEC);
		       res1854_1952 = BUNSPEC;
		    }
		 }
		 res1854_1952;
	      }
	      return (obj_t) (closure_1082);
	   }
      }
   }
}


obj_t 
free_from_222_globalize_free(obj_t sets_59, local_t integrator_60)
{
   {
      long z1_1953;
      z1_1953 = __round__57_globalize_free;
      __round__57_globalize_free = (z1_1953 + ((long) 1));
   }
   {
      value_t finfo_1091;
      finfo_1091 = (((local_t) CREF(integrator_60))->value);
      {
	 bool_t test1568_1092;
	 {
	    obj_t aux_2794;
	    aux_2794 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	    test1568_1092 = CBOOL(aux_2794);
	 }
	 if (test1568_1092)
	   {
	      obj_t arg1571_1094;
	      obj_t arg1573_1096;
	      obj_t arg1575_1098;
	      arg1571_1094 = shape_tools_shape((obj_t) (integrator_60));
	      {
		 obj_t aux_2802;
		 {
		    sfun_ginfo_98_t obj_1956;
		    obj_1956 = (sfun_ginfo_98_t) (finfo_1091);
		    {
		       obj_t aux_2804;
		       {
			  object_t aux_2805;
			  aux_2805 = (object_t) (obj_1956);
			  aux_2804 = OBJECT_WIDENING(aux_2805);
		       }
		       aux_2802 = (((sfun_ginfo_98_t) CREF(aux_2804))->bound);
		    }
		 }
		 arg1573_1096 = shape_tools_shape(aux_2802);
	      }
	      arg1575_1098 = shape_tools_shape(sets_59);
	      {
		 obj_t list1576_1099;
		 {
		    obj_t arg1577_1100;
		    {
		       obj_t arg1578_1101;
		       {
			  obj_t arg1579_1102;
			  {
			     obj_t arg1582_1103;
			     {
				obj_t arg1583_1104;
				{
				   obj_t arg1584_1105;
				   {
				      obj_t arg1585_1106;
				      {
					 obj_t aux_2811;
					 aux_2811 = BCHAR(((unsigned char) '\n'));
					 arg1585_1106 = MAKE_PAIR(aux_2811, BNIL);
				      }
				      arg1584_1105 = MAKE_PAIR(arg1575_1098, arg1585_1106);
				   }
				   arg1583_1104 = MAKE_PAIR(string1861_globalize_free, arg1584_1105);
				}
				{
				   obj_t aux_2816;
				   aux_2816 = BCHAR(((unsigned char) '\n'));
				   arg1582_1103 = MAKE_PAIR(aux_2816, arg1583_1104);
				}
			     }
			     arg1579_1102 = MAKE_PAIR(arg1573_1096, arg1582_1103);
			  }
			  arg1578_1101 = MAKE_PAIR(string1862_globalize_free, arg1579_1102);
		       }
		       arg1577_1100 = MAKE_PAIR(arg1571_1094, arg1578_1101);
		    }
		    list1576_1099 = MAKE_PAIR(string1863_globalize_free, arg1577_1100);
		 }
		 print_trace_107_tools_trace(list1576_1099);
	      }
	   }
	 else
	   {
	      BUNSPEC;
	   }
      }
      {
	 obj_t l1399_1111;
	 {
	    sfun_ginfo_98_t obj_1957;
	    obj_1957 = (sfun_ginfo_98_t) (finfo_1091);
	    {
	       obj_t aux_2834;
	       {
		  object_t aux_2835;
		  aux_2835 = (object_t) (obj_1957);
		  aux_2834 = OBJECT_WIDENING(aux_2835);
	       }
	       l1399_1111 = (((sfun_ginfo_98_t) CREF(aux_2834))->bound);
	    }
	 }
       lname1400_1112:
	 if (PAIRP(l1399_1111))
	   {
	      {
		 local_t aux_2826;
		 {
		    obj_t aux_2827;
		    aux_2827 = CAR(l1399_1111);
		    aux_2826 = (local_t) (aux_2827);
		 }
		 mark_variable__104_globalize_free(aux_2826);
	      }
	      {
		 obj_t l1399_2831;
		 l1399_2831 = CDR(l1399_1111);
		 l1399_1111 = l1399_2831;
		 goto lname1400_1112;
	      }
	   }
	 else
	   {
	      ((bool_t) 1);
	   }
      }
   }
   if (NULLP(sets_59))
     {
	return BNIL;
     }
   else
     {
	obj_t head1404_1119;
	head1404_1119 = MAKE_PAIR(BNIL, BNIL);
	{
	   obj_t l1401_1120;
	   obj_t tail1405_1121;
	   l1401_1120 = sets_59;
	   tail1405_1121 = head1404_1119;
	 lname1403_1122:
	   if (NULLP(l1401_1120))
	     {
		return CDR(head1404_1119);
	     }
	   else
	     {
		obj_t new_tail1406_16_1124;
		{
		   obj_t arg1601_1126;
		   {
		      obj_t set_1129;
		      obj_t res_1130;
		      set_1129 = CAR(l1401_1120);
		      res_1130 = BNIL;
		    loop_1131:
		      if (NULLP(set_1129))
			{
			   arg1601_1126 = res_1130;
			}
		      else
			{
			   bool_t test1606_1134;
			   {
			      obj_t aux_2847;
			      aux_2847 = free_variable__181_globalize_free(CAR(set_1129));
			      test1606_1134 = CBOOL(aux_2847);
			   }
			   if (test1606_1134)
			     {
				{
				   obj_t arg1608_1135;
				   obj_t arg1609_1136;
				   arg1608_1135 = CDR(set_1129);
				   {
				      obj_t aux_2853;
				      aux_2853 = CAR(set_1129);
				      arg1609_1136 = MAKE_PAIR(aux_2853, res_1130);
				   }
				   {
				      obj_t res_2857;
				      obj_t set_2856;
				      set_2856 = arg1608_1135;
				      res_2857 = arg1609_1136;
				      res_1130 = res_2857;
				      set_1129 = set_2856;
				      goto loop_1131;
				   }
				}
			     }
			   else
			     {
				{
				   obj_t set_2858;
				   set_2858 = CDR(set_1129);
				   set_1129 = set_2858;
				   goto loop_1131;
				}
			     }
			}
		   }
		   new_tail1406_16_1124 = MAKE_PAIR(arg1601_1126, BNIL);
		}
		SET_CDR(tail1405_1121, new_tail1406_16_1124);
		{
		   obj_t tail1405_2865;
		   obj_t l1401_2863;
		   l1401_2863 = CDR(l1401_1120);
		   tail1405_2865 = new_tail1406_16_1124;
		   tail1405_1121 = tail1405_2865;
		   l1401_1120 = l1401_2863;
		   goto lname1403_1122;
		}
	     }
	}
     }
}


obj_t 
_free_from_124_globalize_free(obj_t env_2098, obj_t sets_2099, obj_t integrator_2100)
{
   return free_from_222_globalize_free(sets_2099, (local_t) (integrator_2100));
}


obj_t 
imported_modules_init_94_globalize_free()
{
   module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70_tools_speek(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70_type_type(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70_type_cache(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70_ast_var(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70_ast_local(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70_ast_node(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70_ast_sexp(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70_ast_glo_def_117(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70_globalize_node(((long) 0), "GLOBALIZE_FREE");
   module_initialization_70_engine_param(((long) 0), "GLOBALIZE_FREE");
   return module_initialization_70_globalize_global_closure_246(((long) 0), "GLOBALIZE_FREE");
}
