/*===========================================================================*/
/*   (Globalize/ginfo.scm)                                                   */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_t;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_t;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_t;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_t;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_t;


obj_t svar_ginfo_131_globalize_ginfo = BUNSPEC;
static obj_t _allocate_local_ginfo_111_globalize_ginfo(obj_t);
static obj_t _allocate_sexit_ginfo_207_globalize_ginfo(obj_t);
static obj_t object__struct_sfun_ginfo1744_70_globalize_ginfo(obj_t, obj_t);
static obj_t object__struct_global_ginfo1752_235_globalize_ginfo(obj_t, obj_t);
extern obj_t global_ast_var;
obj_t sexit_ginfo_81_globalize_ginfo = BUNSPEC;
static obj_t struct_object__object_svar_ginfo1745_79_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _allocate_sfun_ginfo_166_globalize_ginfo(obj_t);
extern obj_t _struct_object__object_6___object(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_globalize_ginfo();
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t sexit_ast_var;
static obj_t toplevel_init_63_globalize_ginfo();
static obj_t cnst_init_137_globalize_ginfo();
obj_t global_ginfo_75_globalize_ginfo = BUNSPEC;
static obj_t _allocate_global_ginfo_49_globalize_ginfo(obj_t);
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
static obj_t require_initialization_114_globalize_ginfo = BUNSPEC;
static obj_t library_modules_init_112_globalize_ginfo();
extern obj_t sfun_ast_var;
static sfun_t allocate_sfun_ginfo_135_globalize_ginfo();
obj_t sfun_ginfo_98_globalize_ginfo = BUNSPEC;
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
static obj_t object__struct_sexit_ginfo1748_86_globalize_ginfo(obj_t, obj_t);
static obj_t _allocate_svar_ginfo_235_globalize_ginfo(obj_t);
static obj_t object__struct_svar_ginfo1746_85_globalize_ginfo(obj_t, obj_t);
extern long class_num_218___object(obj_t);
static global_t allocate_global_ginfo_174_globalize_ginfo();
static obj_t struct_object__object_local_ginfo1749_133_globalize_ginfo(obj_t, obj_t, obj_t);
obj_t local_ginfo_108_globalize_ginfo = BUNSPEC;
extern obj_t object__struct_50___object(object_t);
static obj_t struct_object__object_sfun_ginfo1743_202_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t struct_object__object_global_ginfo1751_97_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t svar_ast_var;
static svar_t allocate_svar_ginfo_12_globalize_ginfo();
static obj_t object_init_111_globalize_ginfo();
extern obj_t local_ast_var;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static local_t allocate_local_ginfo_201_globalize_ginfo();
extern obj_t make_struct(obj_t, long, obj_t);
static obj_t object__struct_local_ginfo1750_101_globalize_ginfo(obj_t, obj_t);
extern obj_t _object__struct_74___object(obj_t, obj_t);
extern object_t struct_object__object_93___object(object_t, obj_t);
static sexit_t allocate_sexit_ginfo_150_globalize_ginfo();
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t);
static obj_t struct_object__object_sexit_ginfo1747_66_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t __cnst[5];

DEFINE_STATIC_PROCEDURE(proc1760_globalize_ginfo, struct_object__object_svar_ginfo1745_79_globalize_ginfo1771, struct_object__object_svar_ginfo1745_79_globalize_ginfo, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1758_globalize_ginfo, struct_object__object_sexit_ginfo1747_66_globalize_ginfo1772, struct_object__object_sexit_ginfo1747_66_globalize_ginfo, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1761_globalize_ginfo, object__struct_sfun_ginfo1744_70_globalize_ginfo1773, object__struct_sfun_ginfo1744_70_globalize_ginfo, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_sfun_ginfo_env_18_globalize_ginfo, _allocate_sfun_ginfo_166_globalize_ginfo1774, _allocate_sfun_ginfo_166_globalize_ginfo, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_global_ginfo_env_156_globalize_ginfo, _allocate_global_ginfo_49_globalize_ginfo1775, _allocate_global_ginfo_49_globalize_ginfo, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_local_ginfo_env_148_globalize_ginfo, _allocate_local_ginfo_111_globalize_ginfo1776, _allocate_local_ginfo_111_globalize_ginfo, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1762_globalize_ginfo, struct_object__object_sfun_ginfo1743_202_globalize_ginfo1777, struct_object__object_sfun_ginfo1743_202_globalize_ginfo, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1759_globalize_ginfo, object__struct_svar_ginfo1746_85_globalize_ginfo1778, object__struct_svar_ginfo1746_85_globalize_ginfo, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1753_globalize_ginfo, object__struct_global_ginfo1752_235_globalize_ginfo1779, object__struct_global_ginfo1752_235_globalize_ginfo, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_svar_ginfo_env_74_globalize_ginfo, _allocate_svar_ginfo_235_globalize_ginfo1780, _allocate_svar_ginfo_235_globalize_ginfo, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1757_globalize_ginfo, object__struct_sexit_ginfo1748_86_globalize_ginfo1781, object__struct_sexit_ginfo1748_86_globalize_ginfo, 0L, 1);
extern obj_t struct_object__object_env_209___object;
DEFINE_STRING(string1763_globalize_ginfo, string1763_globalize_ginfo1782, "GLOBAL/GINFO LOCAL/GINFO SEXIT/GINFO SVAR/GINFO SFUN/GINFO ", 59);
DEFINE_STATIC_PROCEDURE(proc1756_globalize_ginfo, struct_object__object_local_ginfo1749_133_globalize_ginfo1783, struct_object__object_local_ginfo1749_133_globalize_ginfo, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1754_globalize_ginfo, struct_object__object_global_ginfo1751_97_globalize_ginfo1784, struct_object__object_global_ginfo1751_97_globalize_ginfo, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1755_globalize_ginfo, object__struct_local_ginfo1750_101_globalize_ginfo1785, object__struct_local_ginfo1750_101_globalize_ginfo, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_sexit_ginfo_env_9_globalize_ginfo, _allocate_sexit_ginfo_207_globalize_ginfo1786, _allocate_sexit_ginfo_207_globalize_ginfo, 0L, 0);
extern obj_t object__struct_env_210___object;

obj_t 
module_initialization_70_globalize_ginfo(long checksum_2006, char *from_2007)
{
   if (CBOOL(require_initialization_114_globalize_ginfo))
     {
	require_initialization_114_globalize_ginfo = BBOOL(((bool_t) 0));
	library_modules_init_112_globalize_ginfo();
	cnst_init_137_globalize_ginfo();
	object_init_111_globalize_ginfo();
	imported_modules_init_94_globalize_ginfo();
	toplevel_init_63_globalize_ginfo();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_globalize_ginfo()
{
   module_initialization_70___object(((long) 0), "GLOBALIZE_GINFO");
   module_initialization_70___reader(((long) 0), "GLOBALIZE_GINFO");
   return BUNSPEC;
}


obj_t 
cnst_init_137_globalize_ginfo()
{
   {
      obj_t cnst_port_138_1998;
      cnst_port_138_1998 = open_input_string(string1763_globalize_ginfo);
      {
	 long i_1999;
	 i_1999 = ((long) 4);
       loop_2000:
	 {
	    bool_t test1764_2001;
	    test1764_2001 = (i_1999 == ((long) -1));
	    if (test1764_2001)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1766_2002;
		    {
		       obj_t list1767_2003;
		       {
			  obj_t arg1769_2004;
			  arg1769_2004 = BNIL;
			  list1767_2003 = MAKE_PAIR(cnst_port_138_1998, arg1769_2004);
		       }
		       arg1766_2002 = read___reader(list1767_2003);
		    }
		    CNST_TABLE_SET(i_1999, arg1766_2002);
		 }
		 {
		    int aux_2005;
		    {
		       long aux_2024;
		       aux_2024 = (i_1999 - ((long) 1));
		       aux_2005 = (int) (aux_2024);
		    }
		    {
		       long i_2027;
		       i_2027 = (long) (aux_2005);
		       i_1999 = i_2027;
		       goto loop_2000;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_globalize_ginfo()
{
   return BUNSPEC;
}


obj_t 
object_init_111_globalize_ginfo()
{
   {
      obj_t arg1415_926;
      arg1415_926 = sfun_ast_var;
      sfun_ginfo_98_globalize_ginfo = add_class__117___object(CNST_TABLE_REF(((long) 0)), arg1415_926, allocate_sfun_ginfo_env_18_globalize_ginfo, ((long) 396), BUNSPEC);
   }
   {
      obj_t arg1420_930;
      arg1420_930 = svar_ast_var;
      svar_ginfo_131_globalize_ginfo = add_class__117___object(CNST_TABLE_REF(((long) 1)), arg1420_930, allocate_svar_ginfo_env_74_globalize_ginfo, ((long) 41749), BUNSPEC);
   }
   {
      obj_t arg1427_934;
      arg1427_934 = sexit_ast_var;
      sexit_ginfo_81_globalize_ginfo = add_class__117___object(CNST_TABLE_REF(((long) 2)), arg1427_934, allocate_sexit_ginfo_env_9_globalize_ginfo, ((long) 46691), BUNSPEC);
   }
   {
      obj_t arg1440_938;
      arg1440_938 = local_ast_var;
      local_ginfo_108_globalize_ginfo = add_class__117___object(CNST_TABLE_REF(((long) 3)), arg1440_938, allocate_local_ginfo_env_148_globalize_ginfo, ((long) 60304), BUNSPEC);
   }
   {
      obj_t arg1446_942;
      arg1446_942 = global_ast_var;
      global_ginfo_75_globalize_ginfo = add_class__117___object(CNST_TABLE_REF(((long) 4)), arg1446_942, allocate_global_ginfo_env_156_globalize_ginfo, ((long) 27090), BUNSPEC);
   }
   {
      obj_t object__struct_global_ginfo_101_1967;
      object__struct_global_ginfo_101_1967 = proc1753_globalize_ginfo;
      add_method__1___object(object__struct_env_210___object, global_ginfo_75_globalize_ginfo, object__struct_global_ginfo_101_1967);
   }
   {
      obj_t struct_object__object_global_ginfo_231_1966;
      struct_object__object_global_ginfo_231_1966 = proc1754_globalize_ginfo;
      add_method__1___object(struct_object__object_env_209___object, global_ginfo_75_globalize_ginfo, struct_object__object_global_ginfo_231_1966);
   }
   {
      obj_t object__struct_local_ginfo_71_1965;
      object__struct_local_ginfo_71_1965 = proc1755_globalize_ginfo;
      add_method__1___object(object__struct_env_210___object, local_ginfo_108_globalize_ginfo, object__struct_local_ginfo_71_1965);
   }
   {
      obj_t struct_object__object_local_ginfo_129_1964;
      struct_object__object_local_ginfo_129_1964 = proc1756_globalize_ginfo;
      add_method__1___object(struct_object__object_env_209___object, local_ginfo_108_globalize_ginfo, struct_object__object_local_ginfo_129_1964);
   }
   {
      obj_t object__struct_sexit_ginfo_51_1963;
      object__struct_sexit_ginfo_51_1963 = proc1757_globalize_ginfo;
      add_method__1___object(object__struct_env_210___object, sexit_ginfo_81_globalize_ginfo, object__struct_sexit_ginfo_51_1963);
   }
   {
      obj_t struct_object__object_sexit_ginfo_170_1962;
      struct_object__object_sexit_ginfo_170_1962 = proc1758_globalize_ginfo;
      add_method__1___object(struct_object__object_env_209___object, sexit_ginfo_81_globalize_ginfo, struct_object__object_sexit_ginfo_170_1962);
   }
   {
      obj_t object__struct_svar_ginfo_152_1961;
      object__struct_svar_ginfo_152_1961 = proc1759_globalize_ginfo;
      add_method__1___object(object__struct_env_210___object, svar_ginfo_131_globalize_ginfo, object__struct_svar_ginfo_152_1961);
   }
   {
      obj_t struct_object__object_svar_ginfo_79_1960;
      struct_object__object_svar_ginfo_79_1960 = proc1760_globalize_ginfo;
      add_method__1___object(struct_object__object_env_209___object, svar_ginfo_131_globalize_ginfo, struct_object__object_svar_ginfo_79_1960);
   }
   {
      obj_t object__struct_sfun_ginfo_180_1957;
      object__struct_sfun_ginfo_180_1957 = proc1761_globalize_ginfo;
      add_method__1___object(object__struct_env_210___object, sfun_ginfo_98_globalize_ginfo, object__struct_sfun_ginfo_180_1957);
   }
   {
      obj_t struct_object__object_sfun_ginfo_84_1953;
      struct_object__object_sfun_ginfo_84_1953 = proc1762_globalize_ginfo;
      return add_method__1___object(struct_object__object_env_209___object, sfun_ginfo_98_globalize_ginfo, struct_object__object_sfun_ginfo_84_1953);
   }
}


obj_t 
struct_object__object_sfun_ginfo1743_202_globalize_ginfo(obj_t env_1968, obj_t o_1969, obj_t s_1970)
{
   {
      sfun_ginfo_98_t o_1113;
      obj_t s_1114;
      {
	 sfun_ginfo_98_t aux_2049;
	 o_1113 = (sfun_ginfo_98_t) (o_1969);
	 s_1114 = s_1970;
	 {
	    {
	       obj_t old1316_1117;
	       obj_t aux1317_1118;
	       {
		  obj_t next_method1412_174_1140;
		  next_method1412_174_1140 = find_super_class_method_167___object((object_t) (o_1113), struct_object__object_env_209___object, sfun_ginfo_98_globalize_ginfo);
		  if (PROCEDUREP(next_method1412_174_1140))
		    {
		       old1316_1117 = PROCEDURE_ENTRY(next_method1412_174_1140) (next_method1412_174_1140, (obj_t) (o_1113), s_1114, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1412_174_1140);
		       {
			  object_t aux_2058;
			  aux_2058 = struct_object__object_93___object((object_t) (o_1113), s_1114);
			  old1316_1117 = (obj_t) (aux_2058);
		       }
		    }
	       }
	       aux1317_1118 = STRUCT_REF(s_1114, ((long) 0));
	       {
		  sfun_ginfo_98_t new1318_1119;
		  new1318_1119 = ((sfun_ginfo_98_t) (old1316_1117));
		  {
		     long arg1592_1120;
		     arg1592_1120 = class_num_218___object(sfun_ginfo_98_globalize_ginfo);
		     {
			obj_t obj_1775;
			obj_1775 = (obj_t) (new1318_1119);
			(((obj_t) CREF(obj_1775))->header = MAKE_HEADER(arg1592_1120, 0), BUNSPEC);
		     }
		  }
		  {
		     sfun_ginfo_98_t arg1593_1121;
		     {
			obj_t arg1596_1123;
			obj_t arg1597_1124;
			obj_t arg1600_1125;
			obj_t arg1601_1126;
			obj_t arg1603_1127;
			obj_t arg1604_1128;
			obj_t arg1605_1129;
			obj_t arg1606_1130;
			obj_t arg1609_1132;
			obj_t arg1611_1133;
			obj_t arg1614_1134;
			obj_t arg1616_1135;
			obj_t arg1619_1138;
			obj_t arg1620_1139;
			arg1596_1123 = STRUCT_REF(aux1317_1118, ((long) 1));
			arg1597_1124 = STRUCT_REF(aux1317_1118, ((long) 2));
			arg1600_1125 = STRUCT_REF(aux1317_1118, ((long) 3));
			arg1601_1126 = STRUCT_REF(aux1317_1118, ((long) 4));
			arg1603_1127 = STRUCT_REF(aux1317_1118, ((long) 5));
			arg1604_1128 = STRUCT_REF(aux1317_1118, ((long) 6));
			arg1605_1129 = STRUCT_REF(aux1317_1118, ((long) 7));
			arg1606_1130 = STRUCT_REF(aux1317_1118, ((long) 8));
			arg1609_1132 = STRUCT_REF(aux1317_1118, ((long) 10));
			arg1611_1133 = STRUCT_REF(aux1317_1118, ((long) 11));
			arg1614_1134 = STRUCT_REF(aux1317_1118, ((long) 12));
			arg1616_1135 = STRUCT_REF(aux1317_1118, ((long) 13));
			arg1619_1138 = STRUCT_REF(aux1317_1118, ((long) 16));
			arg1620_1139 = STRUCT_REF(aux1317_1118, ((long) 17));
			{
			   sfun_ginfo_98_t res1739_1850;
			   {
			      bool_t g__219_1813;
			      long mark_1822;
			      long bmark_1827;
			      long umark_1828;
			      {
				 obj_t aux_2081;
				 aux_2081 = STRUCT_REF(aux1317_1118, ((long) 0));
				 g__219_1813 = CBOOL(aux_2081);
			      }
			      {
				 obj_t aux_2084;
				 aux_2084 = STRUCT_REF(aux1317_1118, ((long) 9));
				 mark_1822 = (long) CINT(aux_2084);
			      }
			      {
				 obj_t aux_2087;
				 aux_2087 = STRUCT_REF(aux1317_1118, ((long) 14));
				 bmark_1827 = (long) CINT(aux_2087);
			      }
			      {
				 obj_t aux_2090;
				 aux_2090 = STRUCT_REF(aux1317_1118, ((long) 15));
				 umark_1828 = (long) CINT(aux_2090);
			      }
			      {
				 sfun_ginfo_98_t new1280_1831;
				 new1280_1831 = ((sfun_ginfo_98_t) BREF(GC_MALLOC(sizeof(struct sfun_ginfo_98))));
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->g__219) = ((bool_t) g__219_1813), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->cfrom) = ((obj_t) arg1596_1123), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->cfrom__119) = ((obj_t) arg1597_1124), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->cto) = ((obj_t) arg1600_1125), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->cto__14) = ((obj_t) arg1601_1126), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->cfunction) = ((obj_t) arg1603_1127), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->integrator) = ((obj_t) arg1604_1128), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->integrated) = ((obj_t) arg1605_1129), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->plugged_in_15) = ((obj_t) arg1606_1130), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->mark) = ((long) mark_1822), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->free_mark_81) = ((obj_t) arg1609_1132), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->the_global_201) = ((obj_t) arg1611_1133), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->kaptured) = ((obj_t) arg1614_1134), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->new_body_215) = ((obj_t) arg1616_1135), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->bmark) = ((long) bmark_1827), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->umark) = ((long) umark_1828), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->free) = ((obj_t) arg1619_1138), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1831))->bound) = ((obj_t) arg1620_1139), BUNSPEC);
				 res1739_1850 = new1280_1831;
			      }
			   }
			   arg1593_1121 = res1739_1850;
			}
		     }
		     {
			obj_t aux_2114;
			object_t aux_2112;
			aux_2114 = (obj_t) (arg1593_1121);
			aux_2112 = (object_t) (new1318_1119);
			OBJECT_WIDENING_SET(aux_2112, aux_2114);
		     }
		  }
		  aux_2049 = new1318_1119;
	       }
	    }
	 }
	 return (obj_t) (aux_2049);
      }
   }
}


obj_t 
object__struct_sfun_ginfo1744_70_globalize_ginfo(obj_t env_1971, obj_t obj1313_1972)
{
   {
      sfun_ginfo_98_t obj1313_1066;
      obj1313_1066 = (sfun_ginfo_98_t) (obj1313_1972);
      {
	 {
	    obj_t res1314_1069;
	    {
	       obj_t next_method1411_132_1111;
	       next_method1411_132_1111 = find_super_class_method_167___object((object_t) (obj1313_1066), object__struct_env_210___object, sfun_ginfo_98_globalize_ginfo);
	       if (PROCEDUREP(next_method1411_132_1111))
		 {
		    res1314_1069 = PROCEDURE_ENTRY(next_method1411_132_1111) (next_method1411_132_1111, (obj_t) (obj1313_1066), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1411_132_1111);
		    res1314_1069 = object__struct_50___object((object_t) (obj1313_1066));
		 }
	    }
	    {
	       obj_t aux1315_1070;
	       {
		  obj_t aux_2129;
		  aux_2129 = CNST_TABLE_REF(((long) 0));
		  aux1315_1070 = make_struct(aux_2129, ((long) 18), BUNSPEC);
	       }
	       {
		  obj_t aux_2132;
		  {
		     bool_t aux_2133;
		     {
			obj_t aux_2134;
			{
			   object_t aux_2135;
			   aux_2135 = (object_t) (obj1313_1066);
			   aux_2134 = OBJECT_WIDENING(aux_2135);
			}
			aux_2133 = (((sfun_ginfo_98_t) CREF(aux_2134))->g__219);
		     }
		     aux_2132 = BBOOL(aux_2133);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 0), aux_2132);
	       }
	       {
		  obj_t aux_2141;
		  {
		     obj_t aux_2142;
		     {
			object_t aux_2143;
			aux_2143 = (object_t) (obj1313_1066);
			aux_2142 = OBJECT_WIDENING(aux_2143);
		     }
		     aux_2141 = (((sfun_ginfo_98_t) CREF(aux_2142))->cfrom);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 1), aux_2141);
	       }
	       {
		  obj_t aux_2148;
		  {
		     obj_t aux_2149;
		     {
			object_t aux_2150;
			aux_2150 = (object_t) (obj1313_1066);
			aux_2149 = OBJECT_WIDENING(aux_2150);
		     }
		     aux_2148 = (((sfun_ginfo_98_t) CREF(aux_2149))->cfrom__119);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 2), aux_2148);
	       }
	       {
		  obj_t aux_2155;
		  {
		     obj_t aux_2156;
		     {
			object_t aux_2157;
			aux_2157 = (object_t) (obj1313_1066);
			aux_2156 = OBJECT_WIDENING(aux_2157);
		     }
		     aux_2155 = (((sfun_ginfo_98_t) CREF(aux_2156))->cto);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 3), aux_2155);
	       }
	       {
		  obj_t aux_2162;
		  {
		     obj_t aux_2163;
		     {
			object_t aux_2164;
			aux_2164 = (object_t) (obj1313_1066);
			aux_2163 = OBJECT_WIDENING(aux_2164);
		     }
		     aux_2162 = (((sfun_ginfo_98_t) CREF(aux_2163))->cto__14);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 4), aux_2162);
	       }
	       {
		  obj_t aux_2169;
		  {
		     obj_t aux_2170;
		     {
			object_t aux_2171;
			aux_2171 = (object_t) (obj1313_1066);
			aux_2170 = OBJECT_WIDENING(aux_2171);
		     }
		     aux_2169 = (((sfun_ginfo_98_t) CREF(aux_2170))->cfunction);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 5), aux_2169);
	       }
	       {
		  obj_t aux_2176;
		  {
		     obj_t aux_2177;
		     {
			object_t aux_2178;
			aux_2178 = (object_t) (obj1313_1066);
			aux_2177 = OBJECT_WIDENING(aux_2178);
		     }
		     aux_2176 = (((sfun_ginfo_98_t) CREF(aux_2177))->integrator);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 6), aux_2176);
	       }
	       {
		  obj_t aux_2183;
		  {
		     obj_t aux_2184;
		     {
			object_t aux_2185;
			aux_2185 = (object_t) (obj1313_1066);
			aux_2184 = OBJECT_WIDENING(aux_2185);
		     }
		     aux_2183 = (((sfun_ginfo_98_t) CREF(aux_2184))->integrated);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 7), aux_2183);
	       }
	       {
		  obj_t aux_2190;
		  {
		     obj_t aux_2191;
		     {
			object_t aux_2192;
			aux_2192 = (object_t) (obj1313_1066);
			aux_2191 = OBJECT_WIDENING(aux_2192);
		     }
		     aux_2190 = (((sfun_ginfo_98_t) CREF(aux_2191))->plugged_in_15);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 8), aux_2190);
	       }
	       {
		  obj_t aux_2197;
		  {
		     long aux_2198;
		     {
			obj_t aux_2199;
			{
			   object_t aux_2200;
			   aux_2200 = (object_t) (obj1313_1066);
			   aux_2199 = OBJECT_WIDENING(aux_2200);
			}
			aux_2198 = (((sfun_ginfo_98_t) CREF(aux_2199))->mark);
		     }
		     aux_2197 = BINT(aux_2198);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 9), aux_2197);
	       }
	       {
		  obj_t aux_2206;
		  {
		     obj_t aux_2207;
		     {
			object_t aux_2208;
			aux_2208 = (object_t) (obj1313_1066);
			aux_2207 = OBJECT_WIDENING(aux_2208);
		     }
		     aux_2206 = (((sfun_ginfo_98_t) CREF(aux_2207))->free_mark_81);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 10), aux_2206);
	       }
	       {
		  obj_t aux_2213;
		  {
		     obj_t aux_2214;
		     {
			object_t aux_2215;
			aux_2215 = (object_t) (obj1313_1066);
			aux_2214 = OBJECT_WIDENING(aux_2215);
		     }
		     aux_2213 = (((sfun_ginfo_98_t) CREF(aux_2214))->the_global_201);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 11), aux_2213);
	       }
	       {
		  obj_t aux_2220;
		  {
		     obj_t aux_2221;
		     {
			object_t aux_2222;
			aux_2222 = (object_t) (obj1313_1066);
			aux_2221 = OBJECT_WIDENING(aux_2222);
		     }
		     aux_2220 = (((sfun_ginfo_98_t) CREF(aux_2221))->kaptured);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 12), aux_2220);
	       }
	       {
		  obj_t aux_2227;
		  {
		     obj_t aux_2228;
		     {
			object_t aux_2229;
			aux_2229 = (object_t) (obj1313_1066);
			aux_2228 = OBJECT_WIDENING(aux_2229);
		     }
		     aux_2227 = (((sfun_ginfo_98_t) CREF(aux_2228))->new_body_215);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 13), aux_2227);
	       }
	       {
		  obj_t aux_2234;
		  {
		     long aux_2235;
		     {
			obj_t aux_2236;
			{
			   object_t aux_2237;
			   aux_2237 = (object_t) (obj1313_1066);
			   aux_2236 = OBJECT_WIDENING(aux_2237);
			}
			aux_2235 = (((sfun_ginfo_98_t) CREF(aux_2236))->bmark);
		     }
		     aux_2234 = BINT(aux_2235);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 14), aux_2234);
	       }
	       {
		  obj_t aux_2243;
		  {
		     long aux_2244;
		     {
			obj_t aux_2245;
			{
			   object_t aux_2246;
			   aux_2246 = (object_t) (obj1313_1066);
			   aux_2245 = OBJECT_WIDENING(aux_2246);
			}
			aux_2244 = (((sfun_ginfo_98_t) CREF(aux_2245))->umark);
		     }
		     aux_2243 = BINT(aux_2244);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 15), aux_2243);
	       }
	       {
		  obj_t aux_2252;
		  {
		     obj_t aux_2253;
		     {
			object_t aux_2254;
			aux_2254 = (object_t) (obj1313_1066);
			aux_2253 = OBJECT_WIDENING(aux_2254);
		     }
		     aux_2252 = (((sfun_ginfo_98_t) CREF(aux_2253))->free);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 16), aux_2252);
	       }
	       {
		  obj_t aux_2259;
		  {
		     obj_t aux_2260;
		     {
			object_t aux_2261;
			aux_2261 = (object_t) (obj1313_1066);
			aux_2260 = OBJECT_WIDENING(aux_2261);
		     }
		     aux_2259 = (((sfun_ginfo_98_t) CREF(aux_2260))->bound);
		  }
		  STRUCT_SET(aux1315_1070, ((long) 17), aux_2259);
	       }
	       STRUCT_SET(res1314_1069, ((long) 0), aux1315_1070);
	       {
		  obj_t aux_2267;
		  aux_2267 = STRUCT_KEY(res1314_1069);
		  STRUCT_KEY_SET(aux1315_1070, aux_2267);
	       }
	       {
		  obj_t aux_2270;
		  aux_2270 = CNST_TABLE_REF(((long) 0));
		  STRUCT_KEY_SET(res1314_1069, aux_2270);
	       }
	       return res1314_1069;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_svar_ginfo1745_79_globalize_ginfo(obj_t env_1973, obj_t o_1974, obj_t s_1975)
{
   {
      svar_ginfo_131_t o_1051;
      obj_t s_1052;
      {
	 svar_ginfo_131_t aux_2274;
	 o_1051 = (svar_ginfo_131_t) (o_1974);
	 s_1052 = s_1975;
	 {
	    {
	       obj_t old1332_1055;
	       obj_t aux1333_1056;
	       {
		  obj_t next_method1410_119_1064;
		  next_method1410_119_1064 = find_super_class_method_167___object((object_t) (o_1051), struct_object__object_env_209___object, svar_ginfo_131_globalize_ginfo);
		  if (PROCEDUREP(next_method1410_119_1064))
		    {
		       old1332_1055 = PROCEDURE_ENTRY(next_method1410_119_1064) (next_method1410_119_1064, (obj_t) (o_1051), s_1052, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1410_119_1064);
		       {
			  object_t aux_2283;
			  aux_2283 = struct_object__object_93___object((object_t) (o_1051), s_1052);
			  old1332_1055 = (obj_t) (aux_2283);
		       }
		    }
	       }
	       aux1333_1056 = STRUCT_REF(s_1052, ((long) 0));
	       {
		  svar_ginfo_131_t new1334_1057;
		  new1334_1057 = ((svar_ginfo_131_t) (old1332_1055));
		  {
		     long arg1534_1058;
		     arg1534_1058 = class_num_218___object(svar_ginfo_131_globalize_ginfo);
		     {
			obj_t obj_1666;
			obj_1666 = (obj_t) (new1334_1057);
			(((obj_t) CREF(obj_1666))->header = MAKE_HEADER(arg1534_1058, 0), BUNSPEC);
		     }
		  }
		  {
		     svar_ginfo_131_t arg1535_1059;
		     {
			svar_ginfo_131_t res1738_1685;
			{
			   bool_t kaptured__204_1676;
			   long free_mark_81_1677;
			   long mark_1678;
			   bool_t celled__113_1679;
			   {
			      obj_t aux_2292;
			      aux_2292 = STRUCT_REF(aux1333_1056, ((long) 0));
			      kaptured__204_1676 = CBOOL(aux_2292);
			   }
			   {
			      obj_t aux_2295;
			      aux_2295 = STRUCT_REF(aux1333_1056, ((long) 1));
			      free_mark_81_1677 = (long) CINT(aux_2295);
			   }
			   {
			      obj_t aux_2298;
			      aux_2298 = STRUCT_REF(aux1333_1056, ((long) 2));
			      mark_1678 = (long) CINT(aux_2298);
			   }
			   {
			      obj_t aux_2301;
			      aux_2301 = STRUCT_REF(aux1333_1056, ((long) 3));
			      celled__113_1679 = CBOOL(aux_2301);
			   }
			   {
			      svar_ginfo_131_t new1320_1680;
			      new1320_1680 = ((svar_ginfo_131_t) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
			      ((((svar_ginfo_131_t) CREF(new1320_1680))->kaptured__204) = ((bool_t) kaptured__204_1676), BUNSPEC);
			      ((((svar_ginfo_131_t) CREF(new1320_1680))->free_mark_81) = ((long) free_mark_81_1677), BUNSPEC);
			      ((((svar_ginfo_131_t) CREF(new1320_1680))->mark) = ((long) mark_1678), BUNSPEC);
			      ((((svar_ginfo_131_t) CREF(new1320_1680))->celled__113) = ((bool_t) celled__113_1679), BUNSPEC);
			      res1738_1685 = new1320_1680;
			   }
			}
			arg1535_1059 = res1738_1685;
		     }
		     {
			obj_t aux_2311;
			object_t aux_2309;
			aux_2311 = (obj_t) (arg1535_1059);
			aux_2309 = (object_t) (new1334_1057);
			OBJECT_WIDENING_SET(aux_2309, aux_2311);
		     }
		  }
		  aux_2274 = new1334_1057;
	       }
	    }
	 }
	 return (obj_t) (aux_2274);
      }
   }
}


obj_t 
object__struct_svar_ginfo1746_85_globalize_ginfo(obj_t env_1976, obj_t obj1329_1977)
{
   {
      svar_ginfo_131_t obj1329_1032;
      obj1329_1032 = (svar_ginfo_131_t) (obj1329_1977);
      {
	 {
	    obj_t res1330_1035;
	    {
	       obj_t next_method1409_13_1049;
	       next_method1409_13_1049 = find_super_class_method_167___object((object_t) (obj1329_1032), object__struct_env_210___object, svar_ginfo_131_globalize_ginfo);
	       if (PROCEDUREP(next_method1409_13_1049))
		 {
		    res1330_1035 = PROCEDURE_ENTRY(next_method1409_13_1049) (next_method1409_13_1049, (obj_t) (obj1329_1032), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1409_13_1049);
		    res1330_1035 = object__struct_50___object((object_t) (obj1329_1032));
		 }
	    }
	    {
	       obj_t aux1331_1036;
	       {
		  obj_t aux_2326;
		  aux_2326 = CNST_TABLE_REF(((long) 1));
		  aux1331_1036 = make_struct(aux_2326, ((long) 4), BUNSPEC);
	       }
	       {
		  obj_t aux_2329;
		  {
		     bool_t aux_2330;
		     {
			obj_t aux_2331;
			{
			   object_t aux_2332;
			   aux_2332 = (object_t) (obj1329_1032);
			   aux_2331 = OBJECT_WIDENING(aux_2332);
			}
			aux_2330 = (((svar_ginfo_131_t) CREF(aux_2331))->kaptured__204);
		     }
		     aux_2329 = BBOOL(aux_2330);
		  }
		  STRUCT_SET(aux1331_1036, ((long) 0), aux_2329);
	       }
	       {
		  obj_t aux_2338;
		  {
		     long aux_2339;
		     {
			obj_t aux_2340;
			{
			   object_t aux_2341;
			   aux_2341 = (object_t) (obj1329_1032);
			   aux_2340 = OBJECT_WIDENING(aux_2341);
			}
			aux_2339 = (((svar_ginfo_131_t) CREF(aux_2340))->free_mark_81);
		     }
		     aux_2338 = BINT(aux_2339);
		  }
		  STRUCT_SET(aux1331_1036, ((long) 1), aux_2338);
	       }
	       {
		  obj_t aux_2347;
		  {
		     long aux_2348;
		     {
			obj_t aux_2349;
			{
			   object_t aux_2350;
			   aux_2350 = (object_t) (obj1329_1032);
			   aux_2349 = OBJECT_WIDENING(aux_2350);
			}
			aux_2348 = (((svar_ginfo_131_t) CREF(aux_2349))->mark);
		     }
		     aux_2347 = BINT(aux_2348);
		  }
		  STRUCT_SET(aux1331_1036, ((long) 2), aux_2347);
	       }
	       {
		  obj_t aux_2356;
		  {
		     bool_t aux_2357;
		     {
			obj_t aux_2358;
			{
			   object_t aux_2359;
			   aux_2359 = (object_t) (obj1329_1032);
			   aux_2358 = OBJECT_WIDENING(aux_2359);
			}
			aux_2357 = (((svar_ginfo_131_t) CREF(aux_2358))->celled__113);
		     }
		     aux_2356 = BBOOL(aux_2357);
		  }
		  STRUCT_SET(aux1331_1036, ((long) 3), aux_2356);
	       }
	       STRUCT_SET(res1330_1035, ((long) 0), aux1331_1036);
	       {
		  obj_t aux_2366;
		  aux_2366 = STRUCT_KEY(res1330_1035);
		  STRUCT_KEY_SET(aux1331_1036, aux_2366);
	       }
	       {
		  obj_t aux_2369;
		  aux_2369 = CNST_TABLE_REF(((long) 1));
		  STRUCT_KEY_SET(res1330_1035, aux_2369);
	       }
	       return res1330_1035;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_sexit_ginfo1747_66_globalize_ginfo(obj_t env_1978, obj_t o_1979, obj_t s_1980)
{
   {
      sexit_ginfo_81_t o_1017;
      obj_t s_1018;
      {
	 sexit_ginfo_81_t aux_2373;
	 o_1017 = (sexit_ginfo_81_t) (o_1979);
	 s_1018 = s_1980;
	 {
	    {
	       obj_t old1350_1021;
	       obj_t aux1351_1022;
	       {
		  obj_t next_method1408_32_1030;
		  next_method1408_32_1030 = find_super_class_method_167___object((object_t) (o_1017), struct_object__object_env_209___object, sexit_ginfo_81_globalize_ginfo);
		  if (PROCEDUREP(next_method1408_32_1030))
		    {
		       old1350_1021 = PROCEDURE_ENTRY(next_method1408_32_1030) (next_method1408_32_1030, (obj_t) (o_1017), s_1018, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1408_32_1030);
		       {
			  object_t aux_2382;
			  aux_2382 = struct_object__object_93___object((object_t) (o_1017), s_1018);
			  old1350_1021 = (obj_t) (aux_2382);
		       }
		    }
	       }
	       aux1351_1022 = STRUCT_REF(s_1018, ((long) 0));
	       {
		  sexit_ginfo_81_t new1352_1023;
		  new1352_1023 = ((sexit_ginfo_81_t) (old1350_1021));
		  {
		     long arg1505_1024;
		     arg1505_1024 = class_num_218___object(sexit_ginfo_81_globalize_ginfo);
		     {
			obj_t obj_1613;
			obj_1613 = (obj_t) (new1352_1023);
			(((obj_t) CREF(obj_1613))->header = MAKE_HEADER(arg1505_1024, 0), BUNSPEC);
		     }
		  }
		  {
		     sexit_ginfo_81_t arg1506_1025;
		     {
			sexit_ginfo_81_t res1737_1632;
			{
			   bool_t g__219_1623;
			   bool_t kaptured__204_1624;
			   long free_mark_81_1625;
			   long mark_1626;
			   {
			      obj_t aux_2391;
			      aux_2391 = STRUCT_REF(aux1351_1022, ((long) 0));
			      g__219_1623 = CBOOL(aux_2391);
			   }
			   {
			      obj_t aux_2394;
			      aux_2394 = STRUCT_REF(aux1351_1022, ((long) 1));
			      kaptured__204_1624 = CBOOL(aux_2394);
			   }
			   {
			      obj_t aux_2397;
			      aux_2397 = STRUCT_REF(aux1351_1022, ((long) 2));
			      free_mark_81_1625 = (long) CINT(aux_2397);
			   }
			   {
			      obj_t aux_2400;
			      aux_2400 = STRUCT_REF(aux1351_1022, ((long) 3));
			      mark_1626 = (long) CINT(aux_2400);
			   }
			   {
			      sexit_ginfo_81_t new1336_1627;
			      new1336_1627 = ((sexit_ginfo_81_t) BREF(GC_MALLOC(sizeof(struct sexit_ginfo_81))));
			      ((((sexit_ginfo_81_t) CREF(new1336_1627))->g__219) = ((bool_t) g__219_1623), BUNSPEC);
			      ((((sexit_ginfo_81_t) CREF(new1336_1627))->kaptured__204) = ((bool_t) kaptured__204_1624), BUNSPEC);
			      ((((sexit_ginfo_81_t) CREF(new1336_1627))->free_mark_81) = ((long) free_mark_81_1625), BUNSPEC);
			      ((((sexit_ginfo_81_t) CREF(new1336_1627))->mark) = ((long) mark_1626), BUNSPEC);
			      res1737_1632 = new1336_1627;
			   }
			}
			arg1506_1025 = res1737_1632;
		     }
		     {
			obj_t aux_2410;
			object_t aux_2408;
			aux_2410 = (obj_t) (arg1506_1025);
			aux_2408 = (object_t) (new1352_1023);
			OBJECT_WIDENING_SET(aux_2408, aux_2410);
		     }
		  }
		  aux_2373 = new1352_1023;
	       }
	    }
	 }
	 return (obj_t) (aux_2373);
      }
   }
}


obj_t 
object__struct_sexit_ginfo1748_86_globalize_ginfo(obj_t env_1981, obj_t obj1347_1982)
{
   {
      sexit_ginfo_81_t obj1347_998;
      obj1347_998 = (sexit_ginfo_81_t) (obj1347_1982);
      {
	 {
	    obj_t res1348_1001;
	    {
	       obj_t next_method1407_94_1015;
	       next_method1407_94_1015 = find_super_class_method_167___object((object_t) (obj1347_998), object__struct_env_210___object, sexit_ginfo_81_globalize_ginfo);
	       if (PROCEDUREP(next_method1407_94_1015))
		 {
		    res1348_1001 = PROCEDURE_ENTRY(next_method1407_94_1015) (next_method1407_94_1015, (obj_t) (obj1347_998), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1407_94_1015);
		    res1348_1001 = object__struct_50___object((object_t) (obj1347_998));
		 }
	    }
	    {
	       obj_t aux1349_1002;
	       {
		  obj_t aux_2425;
		  aux_2425 = CNST_TABLE_REF(((long) 2));
		  aux1349_1002 = make_struct(aux_2425, ((long) 4), BUNSPEC);
	       }
	       {
		  obj_t aux_2428;
		  {
		     bool_t aux_2429;
		     {
			obj_t aux_2430;
			{
			   object_t aux_2431;
			   aux_2431 = (object_t) (obj1347_998);
			   aux_2430 = OBJECT_WIDENING(aux_2431);
			}
			aux_2429 = (((sexit_ginfo_81_t) CREF(aux_2430))->g__219);
		     }
		     aux_2428 = BBOOL(aux_2429);
		  }
		  STRUCT_SET(aux1349_1002, ((long) 0), aux_2428);
	       }
	       {
		  obj_t aux_2437;
		  {
		     bool_t aux_2438;
		     {
			obj_t aux_2439;
			{
			   object_t aux_2440;
			   aux_2440 = (object_t) (obj1347_998);
			   aux_2439 = OBJECT_WIDENING(aux_2440);
			}
			aux_2438 = (((sexit_ginfo_81_t) CREF(aux_2439))->kaptured__204);
		     }
		     aux_2437 = BBOOL(aux_2438);
		  }
		  STRUCT_SET(aux1349_1002, ((long) 1), aux_2437);
	       }
	       {
		  obj_t aux_2446;
		  {
		     long aux_2447;
		     {
			obj_t aux_2448;
			{
			   object_t aux_2449;
			   aux_2449 = (object_t) (obj1347_998);
			   aux_2448 = OBJECT_WIDENING(aux_2449);
			}
			aux_2447 = (((sexit_ginfo_81_t) CREF(aux_2448))->free_mark_81);
		     }
		     aux_2446 = BINT(aux_2447);
		  }
		  STRUCT_SET(aux1349_1002, ((long) 2), aux_2446);
	       }
	       {
		  obj_t aux_2455;
		  {
		     long aux_2456;
		     {
			obj_t aux_2457;
			{
			   object_t aux_2458;
			   aux_2458 = (object_t) (obj1347_998);
			   aux_2457 = OBJECT_WIDENING(aux_2458);
			}
			aux_2456 = (((sexit_ginfo_81_t) CREF(aux_2457))->mark);
		     }
		     aux_2455 = BINT(aux_2456);
		  }
		  STRUCT_SET(aux1349_1002, ((long) 3), aux_2455);
	       }
	       STRUCT_SET(res1348_1001, ((long) 0), aux1349_1002);
	       {
		  obj_t aux_2465;
		  aux_2465 = STRUCT_KEY(res1348_1001);
		  STRUCT_KEY_SET(aux1349_1002, aux_2465);
	       }
	       {
		  obj_t aux_2468;
		  aux_2468 = CNST_TABLE_REF(((long) 2));
		  STRUCT_KEY_SET(res1348_1001, aux_2468);
	       }
	       return res1348_1001;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_local_ginfo1749_133_globalize_ginfo(obj_t env_1983, obj_t o_1984, obj_t s_1985)
{
   {
      local_ginfo_108_t o_986;
      obj_t s_987;
      {
	 local_ginfo_108_t aux_2472;
	 o_986 = (local_ginfo_108_t) (o_1984);
	 s_987 = s_1985;
	 {
	    {
	       obj_t old1370_990;
	       obj_t aux1371_991;
	       {
		  obj_t next_method1406_220_996;
		  next_method1406_220_996 = find_super_class_method_167___object((object_t) (o_986), struct_object__object_env_209___object, local_ginfo_108_globalize_ginfo);
		  if (PROCEDUREP(next_method1406_220_996))
		    {
		       old1370_990 = PROCEDURE_ENTRY(next_method1406_220_996) (next_method1406_220_996, (obj_t) (o_986), s_987, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1406_220_996);
		       {
			  object_t aux_2481;
			  aux_2481 = struct_object__object_93___object((object_t) (o_986), s_987);
			  old1370_990 = (obj_t) (aux_2481);
		       }
		    }
	       }
	       aux1371_991 = STRUCT_REF(s_987, ((long) 0));
	       {
		  local_ginfo_108_t new1372_992;
		  new1372_992 = ((local_ginfo_108_t) (old1370_990));
		  {
		     long arg1480_993;
		     arg1480_993 = class_num_218___object(local_ginfo_108_globalize_ginfo);
		     {
			obj_t obj_1572;
			obj_1572 = (obj_t) (new1372_992);
			(((obj_t) CREF(obj_1572))->header = MAKE_HEADER(arg1480_993, 0), BUNSPEC);
		     }
		  }
		  {
		     local_ginfo_108_t arg1481_994;
		     {
			local_ginfo_108_t res1736_1579;
			{
			   bool_t escape__117_1576;
			   {
			      obj_t aux_2490;
			      aux_2490 = STRUCT_REF(aux1371_991, ((long) 0));
			      escape__117_1576 = CBOOL(aux_2490);
			   }
			   {
			      local_ginfo_108_t new1354_1577;
			      new1354_1577 = ((local_ginfo_108_t) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
			      ((((local_ginfo_108_t) CREF(new1354_1577))->escape__117) = ((bool_t) escape__117_1576), BUNSPEC);
			      res1736_1579 = new1354_1577;
			   }
			}
			arg1481_994 = res1736_1579;
		     }
		     {
			obj_t aux_2497;
			object_t aux_2495;
			aux_2497 = (obj_t) (arg1481_994);
			aux_2495 = (object_t) (new1372_992);
			OBJECT_WIDENING_SET(aux_2495, aux_2497);
		     }
		  }
		  aux_2472 = new1372_992;
	       }
	    }
	 }
	 return (obj_t) (aux_2472);
      }
   }
}


obj_t 
object__struct_local_ginfo1750_101_globalize_ginfo(obj_t env_1986, obj_t obj1367_1987)
{
   {
      local_ginfo_108_t obj1367_973;
      obj1367_973 = (local_ginfo_108_t) (obj1367_1987);
      {
	 {
	    obj_t res1368_976;
	    {
	       obj_t next_method1405_224_984;
	       next_method1405_224_984 = find_super_class_method_167___object((object_t) (obj1367_973), object__struct_env_210___object, local_ginfo_108_globalize_ginfo);
	       if (PROCEDUREP(next_method1405_224_984))
		 {
		    res1368_976 = PROCEDURE_ENTRY(next_method1405_224_984) (next_method1405_224_984, (obj_t) (obj1367_973), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1405_224_984);
		    res1368_976 = object__struct_50___object((object_t) (obj1367_973));
		 }
	    }
	    {
	       obj_t aux1369_977;
	       {
		  obj_t aux_2512;
		  aux_2512 = CNST_TABLE_REF(((long) 3));
		  aux1369_977 = make_struct(aux_2512, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_2515;
		  {
		     bool_t aux_2516;
		     {
			obj_t aux_2517;
			{
			   object_t aux_2518;
			   aux_2518 = (object_t) (obj1367_973);
			   aux_2517 = OBJECT_WIDENING(aux_2518);
			}
			aux_2516 = (((local_ginfo_108_t) CREF(aux_2517))->escape__117);
		     }
		     aux_2515 = BBOOL(aux_2516);
		  }
		  STRUCT_SET(aux1369_977, ((long) 0), aux_2515);
	       }
	       STRUCT_SET(res1368_976, ((long) 0), aux1369_977);
	       {
		  obj_t aux_2525;
		  aux_2525 = STRUCT_KEY(res1368_976);
		  STRUCT_KEY_SET(aux1369_977, aux_2525);
	       }
	       {
		  obj_t aux_2528;
		  aux_2528 = CNST_TABLE_REF(((long) 3));
		  STRUCT_KEY_SET(res1368_976, aux_2528);
	       }
	       return res1368_976;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_global_ginfo1751_97_globalize_ginfo(obj_t env_1988, obj_t o_1989, obj_t s_1990)
{
   {
      global_ginfo_75_t o_960;
      obj_t s_961;
      {
	 global_ginfo_75_t aux_2532;
	 o_960 = (global_ginfo_75_t) (o_1989);
	 s_961 = s_1990;
	 {
	    {
	       obj_t old1394_964;
	       obj_t aux1395_965;
	       {
		  obj_t next_method1398_247_971;
		  next_method1398_247_971 = find_super_class_method_167___object((object_t) (o_960), struct_object__object_env_209___object, global_ginfo_75_globalize_ginfo);
		  if (PROCEDUREP(next_method1398_247_971))
		    {
		       old1394_964 = PROCEDURE_ENTRY(next_method1398_247_971) (next_method1398_247_971, (obj_t) (o_960), s_961, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1398_247_971);
		       {
			  object_t aux_2541;
			  aux_2541 = struct_object__object_93___object((object_t) (o_960), s_961);
			  old1394_964 = (obj_t) (aux_2541);
		       }
		    }
	       }
	       aux1395_965 = STRUCT_REF(s_961, ((long) 0));
	       {
		  global_ginfo_75_t new1396_966;
		  new1396_966 = ((global_ginfo_75_t) (old1394_964));
		  {
		     long arg1463_967;
		     arg1463_967 = class_num_218___object(global_ginfo_75_globalize_ginfo);
		     {
			obj_t obj_1539;
			obj_1539 = (obj_t) (new1396_966);
			(((obj_t) CREF(obj_1539))->header = MAKE_HEADER(arg1463_967, 0), BUNSPEC);
		     }
		  }
		  {
		     global_ginfo_75_t arg1465_968;
		     {
			obj_t arg1467_970;
			arg1467_970 = STRUCT_REF(aux1395_965, ((long) 1));
			{
			   global_ginfo_75_t res1735_1550;
			   {
			      bool_t escape__117_1545;
			      {
				 obj_t aux_2551;
				 aux_2551 = STRUCT_REF(aux1395_965, ((long) 0));
				 escape__117_1545 = CBOOL(aux_2551);
			      }
			      {
				 global_ginfo_75_t new1374_1547;
				 new1374_1547 = ((global_ginfo_75_t) BREF(GC_MALLOC(sizeof(struct global_ginfo_75))));
				 ((((global_ginfo_75_t) CREF(new1374_1547))->escape__117) = ((bool_t) escape__117_1545), BUNSPEC);
				 ((((global_ginfo_75_t) CREF(new1374_1547))->global_closure_229) = ((obj_t) arg1467_970), BUNSPEC);
				 res1735_1550 = new1374_1547;
			      }
			   }
			   arg1465_968 = res1735_1550;
			}
		     }
		     {
			obj_t aux_2559;
			object_t aux_2557;
			aux_2559 = (obj_t) (arg1465_968);
			aux_2557 = (object_t) (new1396_966);
			OBJECT_WIDENING_SET(aux_2557, aux_2559);
		     }
		  }
		  aux_2532 = new1396_966;
	       }
	    }
	 }
	 return (obj_t) (aux_2532);
      }
   }
}


obj_t 
object__struct_global_ginfo1752_235_globalize_ginfo(obj_t env_1991, obj_t obj1391_1992)
{
   {
      global_ginfo_75_t obj1391_945;
      obj1391_945 = (global_ginfo_75_t) (obj1391_1992);
      {
	 {
	    obj_t res1392_948;
	    {
	       obj_t next_method1397_214_958;
	       next_method1397_214_958 = find_super_class_method_167___object((object_t) (obj1391_945), object__struct_env_210___object, global_ginfo_75_globalize_ginfo);
	       if (PROCEDUREP(next_method1397_214_958))
		 {
		    res1392_948 = PROCEDURE_ENTRY(next_method1397_214_958) (next_method1397_214_958, (obj_t) (obj1391_945), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1397_214_958);
		    res1392_948 = object__struct_50___object((object_t) (obj1391_945));
		 }
	    }
	    {
	       obj_t aux1393_949;
	       {
		  obj_t aux_2574;
		  aux_2574 = CNST_TABLE_REF(((long) 4));
		  aux1393_949 = make_struct(aux_2574, ((long) 2), BUNSPEC);
	       }
	       {
		  obj_t aux_2577;
		  {
		     bool_t aux_2578;
		     {
			obj_t aux_2579;
			{
			   object_t aux_2580;
			   aux_2580 = (object_t) (obj1391_945);
			   aux_2579 = OBJECT_WIDENING(aux_2580);
			}
			aux_2578 = (((global_ginfo_75_t) CREF(aux_2579))->escape__117);
		     }
		     aux_2577 = BBOOL(aux_2578);
		  }
		  STRUCT_SET(aux1393_949, ((long) 0), aux_2577);
	       }
	       {
		  obj_t aux_2586;
		  {
		     obj_t aux_2587;
		     {
			object_t aux_2588;
			aux_2588 = (object_t) (obj1391_945);
			aux_2587 = OBJECT_WIDENING(aux_2588);
		     }
		     aux_2586 = (((global_ginfo_75_t) CREF(aux_2587))->global_closure_229);
		  }
		  STRUCT_SET(aux1393_949, ((long) 1), aux_2586);
	       }
	       STRUCT_SET(res1392_948, ((long) 0), aux1393_949);
	       {
		  obj_t aux_2594;
		  aux_2594 = STRUCT_KEY(res1392_948);
		  STRUCT_KEY_SET(aux1393_949, aux_2594);
	       }
	       {
		  obj_t aux_2597;
		  aux_2597 = CNST_TABLE_REF(((long) 4));
		  STRUCT_KEY_SET(res1392_948, aux_2597);
	       }
	       return res1392_948;
	    }
	 }
      }
   }
}


global_t 
allocate_global_ginfo_174_globalize_ginfo()
{
   {
      global_t new1390_1142;
      new1390_1142 = ((global_t) BREF(GC_MALLOC(sizeof(struct global))));
      {
	 long arg1623_1143;
	 arg1623_1143 = class_num_218___object(global_ginfo_75_globalize_ginfo);
	 {
	    obj_t obj_1853;
	    obj_1853 = (obj_t) (new1390_1142);
	    (((obj_t) CREF(obj_1853))->header = MAKE_HEADER(arg1623_1143, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2605;
	 aux_2605 = (object_t) (new1390_1142);
	 OBJECT_WIDENING_SET(aux_2605, BFALSE);
      }
      return new1390_1142;
   }
}


obj_t 
_allocate_global_ginfo_49_globalize_ginfo(obj_t env_1997)
{
   {
      global_t aux_2608;
      aux_2608 = allocate_global_ginfo_174_globalize_ginfo();
      return (obj_t) (aux_2608);
   }
}


local_t 
allocate_local_ginfo_201_globalize_ginfo()
{
   {
      local_t new1366_1151;
      new1366_1151 = ((local_t) BREF(GC_MALLOC(sizeof(struct local))));
      {
	 long arg1627_1152;
	 arg1627_1152 = class_num_218___object(local_ginfo_108_globalize_ginfo);
	 {
	    obj_t obj_1858;
	    obj_1858 = (obj_t) (new1366_1151);
	    (((obj_t) CREF(obj_1858))->header = MAKE_HEADER(arg1627_1152, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2615;
	 aux_2615 = (object_t) (new1366_1151);
	 OBJECT_WIDENING_SET(aux_2615, BFALSE);
      }
      return new1366_1151;
   }
}


obj_t 
_allocate_local_ginfo_111_globalize_ginfo(obj_t env_1996)
{
   {
      local_t aux_2618;
      aux_2618 = allocate_local_ginfo_201_globalize_ginfo();
      return (obj_t) (aux_2618);
   }
}


sexit_t 
allocate_sexit_ginfo_150_globalize_ginfo()
{
   {
      sexit_t new1346_1159;
      new1346_1159 = ((sexit_t) BREF(GC_MALLOC(sizeof(struct sexit))));
      {
	 long arg1632_1160;
	 arg1632_1160 = class_num_218___object(sexit_ginfo_81_globalize_ginfo);
	 {
	    obj_t obj_1862;
	    obj_1862 = (obj_t) (new1346_1159);
	    (((obj_t) CREF(obj_1862))->header = MAKE_HEADER(arg1632_1160, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2625;
	 aux_2625 = (object_t) (new1346_1159);
	 OBJECT_WIDENING_SET(aux_2625, BFALSE);
      }
      return new1346_1159;
   }
}


obj_t 
_allocate_sexit_ginfo_207_globalize_ginfo(obj_t env_1995)
{
   {
      sexit_t aux_2628;
      aux_2628 = allocate_sexit_ginfo_150_globalize_ginfo();
      return (obj_t) (aux_2628);
   }
}


svar_t 
allocate_svar_ginfo_12_globalize_ginfo()
{
   {
      svar_t new1328_1170;
      new1328_1170 = ((svar_t) BREF(GC_MALLOC(sizeof(struct svar))));
      {
	 long arg1638_1171;
	 arg1638_1171 = class_num_218___object(svar_ginfo_131_globalize_ginfo);
	 {
	    obj_t obj_1869;
	    obj_1869 = (obj_t) (new1328_1170);
	    (((obj_t) CREF(obj_1869))->header = MAKE_HEADER(arg1638_1171, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2635;
	 aux_2635 = (object_t) (new1328_1170);
	 OBJECT_WIDENING_SET(aux_2635, BFALSE);
      }
      return new1328_1170;
   }
}


obj_t 
_allocate_svar_ginfo_235_globalize_ginfo(obj_t env_1994)
{
   {
      svar_t aux_2638;
      aux_2638 = allocate_svar_ginfo_12_globalize_ginfo();
      return (obj_t) (aux_2638);
   }
}


sfun_t 
allocate_sfun_ginfo_135_globalize_ginfo()
{
   {
      sfun_t new1312_1181;
      new1312_1181 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
      {
	 long arg1643_1182;
	 arg1643_1182 = class_num_218___object(sfun_ginfo_98_globalize_ginfo);
	 {
	    obj_t obj_1876;
	    obj_1876 = (obj_t) (new1312_1181);
	    (((obj_t) CREF(obj_1876))->header = MAKE_HEADER(arg1643_1182, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2645;
	 aux_2645 = (object_t) (new1312_1181);
	 OBJECT_WIDENING_SET(aux_2645, BFALSE);
      }
      return new1312_1181;
   }
}


obj_t 
_allocate_sfun_ginfo_166_globalize_ginfo(obj_t env_1993)
{
   {
      sfun_t aux_2648;
      aux_2648 = allocate_sfun_ginfo_135_globalize_ginfo();
      return (obj_t) (aux_2648);
   }
}


obj_t 
imported_modules_init_94_globalize_ginfo()
{
   module_initialization_70_type_type(((long) 0), "GLOBALIZE_GINFO");
   module_initialization_70_ast_var(((long) 0), "GLOBALIZE_GINFO");
   return module_initialization_70_ast_node(((long) 0), "GLOBALIZE_GINFO");
}
