/*===========================================================================*/
/*   (Globalize/globalize.scm)                                               */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_t;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_t;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_t;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_t;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_t;


extern obj_t globalize__167_globalize_globalize(global_t);
extern obj_t _globalize__140_globalize_globalize(obj_t, obj_t);
extern node_t node_globalize__229_globalize_node(node_t, variable_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_globalize_globalize();
extern obj_t module_initialization_70_globalize_globalize(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_node(long, char *);
extern obj_t module_initialization_70_globalize_free(long, char *);
extern obj_t module_initialization_70_globalize_kapture(long, char *);
extern obj_t module_initialization_70_globalize_gn(long, char *);
extern obj_t module_initialization_70_globalize_integration(long, char *);
extern obj_t module_initialization_70_globalize_new_body_146(long, char *);
extern obj_t module_initialization_70_globalize_local__global_194(long, char *);
extern obj_t module_initialization_70_globalize_global_closure_246(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_globalize_globalize();
static obj_t cnst_init_137_globalize_globalize();
extern obj_t set_globalized_new_bodies__10_globalize_new_body_146(global_t, obj_t);
extern global_t local__global_40_globalize_local__global_194(local_t);
static bool_t verb_globalization_175_globalize_globalize();
extern obj_t set_kaptured__104_globalize_kapture(obj_t);
static obj_t require_initialization_114_globalize_globalize = BUNSPEC;
extern obj_t gn__33_globalize_gn(obj_t, node_t, variable_t, obj_t);
extern obj_t print_trace_107_tools_trace(obj_t);
obj_t __e__34_globalize_globalize = BUNSPEC;
static obj_t library_modules_init_112_globalize_globalize();
obj_t __g1__181_globalize_globalize = BUNSPEC;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern global_t global_closure_229_globalize_global_closure_246(global_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t set_integration__52_globalize_integration();
extern obj_t local_ast_var;
obj_t __g0__244_globalize_globalize = BUNSPEC;
static obj_t __cnst[1];

DEFINE_STRING(string1680_globalize_globalize, string1680_globalize_globalize1695, "   G1 : ", 8);
DEFINE_STRING(string1686_globalize_globalize, string1686_globalize_globalize1696, " --> ", 5);
DEFINE_STRING(string1685_globalize_globalize, string1685_globalize_globalize1697, "           ", 11);
DEFINE_STRING(string1687_globalize_globalize, string1687_globalize_globalize1698, " -->", 4);
DEFINE_STRING(string1681_globalize_globalize, string1681_globalize_globalize1699, "   G0 : ", 8);
DEFINE_STRING(string1688_globalize_globalize, string1688_globalize_globalize1700, "GLOBALIZE ", 10);
DEFINE_STRING(string1682_globalize_globalize, string1682_globalize_globalize1701, "   E  : ", 8);
DEFINE_STRING(string1676_globalize_globalize, string1676_globalize_globalize1702, " ", 1);
DEFINE_STRING(string1677_globalize_globalize, string1677_globalize_globalize1703, "========================================", 40);
DEFINE_STRING(string1675_globalize_globalize, string1675_globalize_globalize1704, "----------------------------------------", 40);
DEFINE_EXPORT_PROCEDURE(globalize__env_187_globalize_globalize, _globalize__140_globalize_globalize1705, _globalize__140_globalize_globalize, 0L, 1);
DEFINE_STRING(string1684_globalize_globalize, string1684_globalize_globalize1706, " ==>", 4);
DEFINE_STRING(string1679_globalize_globalize, string1679_globalize_globalize1707, "        ", 8);
DEFINE_STRING(string1678_globalize_globalize, string1678_globalize_globalize1708, " : ", 3);
DEFINE_STRING(string1683_globalize_globalize, string1683_globalize_globalize1709, "   G  : ", 8);

obj_t 
module_initialization_70_globalize_globalize(long checksum_1566, char *from_1567)
{
   if (CBOOL(require_initialization_114_globalize_globalize))
     {
	require_initialization_114_globalize_globalize = BBOOL(((bool_t) 0));
	library_modules_init_112_globalize_globalize();
	cnst_init_137_globalize_globalize();
	imported_modules_init_94_globalize_globalize();
	toplevel_init_63_globalize_globalize();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_globalize_globalize()
{
   module_initialization_70___object(((long) 0), "GLOBALIZE_GLOBALIZE");
   module_initialization_70___reader(((long) 0), "GLOBALIZE_GLOBALIZE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_globalize_globalize()
{
   {
      obj_t cnst_port_138_1558;
      cnst_port_138_1558 = open_input_string(string1688_globalize_globalize);
      {
	 long i_1559;
	 i_1559 = ((long) 0);
       loop_1560:
	 {
	    bool_t test1689_1561;
	    test1689_1561 = (i_1559 == ((long) -1));
	    if (test1689_1561)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1690_1562;
		    {
		       obj_t list1691_1563;
		       {
			  obj_t arg1693_1564;
			  arg1693_1564 = BNIL;
			  list1691_1563 = MAKE_PAIR(cnst_port_138_1558, arg1693_1564);
		       }
		       arg1690_1562 = read___reader(list1691_1563);
		    }
		    CNST_TABLE_SET(i_1559, arg1690_1562);
		 }
		 {
		    int aux_1565;
		    {
		       long aux_1583;
		       aux_1583 = (i_1559 - ((long) 1));
		       aux_1565 = (int) (aux_1583);
		    }
		    {
		       long i_1586;
		       i_1586 = (long) (aux_1565);
		       i_1559 = i_1586;
		       goto loop_1560;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_globalize_globalize()
{
   __e__34_globalize_globalize = BNIL;
   __g0__244_globalize_globalize = BNIL;
   return (__g1__181_globalize_globalize = BNIL,
      BUNSPEC);
}


obj_t 
globalize__167_globalize_globalize(global_t global_1)
{
   {
      bool_t test1374_911;
      {
	 obj_t aux_1588;
	 aux_1588 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1374_911 = CBOOL(aux_1588);
      }
      if (test1374_911)
	{
	   obj_t arg1379_913;
	   char *arg1381_915;
	   arg1379_913 = shape_tools_shape((obj_t) (global_1));
	   {
	      bool_t test_1596;
	      {
		 global_ginfo_75_t obj_1427;
		 obj_1427 = (global_ginfo_75_t) (global_1);
		 {
		    obj_t aux_1598;
		    {
		       object_t aux_1599;
		       aux_1599 = (object_t) (obj_1427);
		       aux_1598 = OBJECT_WIDENING(aux_1599);
		    }
		    test_1596 = (((global_ginfo_75_t) CREF(aux_1598))->escape__117);
		 }
	      }
	      if (test_1596)
		{
		   arg1381_915 = "[escaping]";
		}
	      else
		{
		   arg1381_915 = "[non escaping]";
		}
	   }
	   {
	      obj_t list1383_917;
	      {
		 obj_t arg1385_918;
		 {
		    obj_t arg1388_919;
		    {
		       obj_t arg1390_920;
		       {
			  obj_t arg1391_921;
			  {
			     obj_t arg1396_922;
			     {
				obj_t arg1398_923;
				{
				   obj_t arg1400_924;
				   {
				      obj_t aux_1603;
				      aux_1603 = BCHAR(((unsigned char) '\n'));
				      arg1400_924 = MAKE_PAIR(aux_1603, BNIL);
				   }
				   arg1398_923 = MAKE_PAIR(string1675_globalize_globalize, arg1400_924);
				}
				{
				   obj_t aux_1607;
				   aux_1607 = BCHAR(((unsigned char) '\n'));
				   arg1396_922 = MAKE_PAIR(aux_1607, arg1398_923);
				}
			     }
			     {
				obj_t aux_1610;
				aux_1610 = string_to_bstring(arg1381_915);
				arg1391_921 = MAKE_PAIR(aux_1610, arg1396_922);
			     }
			  }
			  arg1390_920 = MAKE_PAIR(string1676_globalize_globalize, arg1391_921);
		       }
		       arg1388_919 = MAKE_PAIR(arg1379_913, arg1390_920);
		    }
		    {
		       obj_t aux_1615;
		       aux_1615 = BCHAR(((unsigned char) '\n'));
		       arg1385_918 = MAKE_PAIR(aux_1615, arg1388_919);
		    }
		 }
		 list1383_917 = MAKE_PAIR(string1677_globalize_globalize, arg1385_918);
	      }
	      print_trace_107_tools_trace(list1383_917);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t arg1411_931;
      arg1411_931 = shape_tools_shape((obj_t) (global_1));
      {
	 obj_t list1413_933;
	 {
	    obj_t arg1414_934;
	    {
	       obj_t arg1415_935;
	       {
		  obj_t arg1416_936;
		  {
		     obj_t aux_1622;
		     aux_1622 = BCHAR(((unsigned char) '\n'));
		     arg1416_936 = MAKE_PAIR(aux_1622, BNIL);
		  }
		  arg1415_935 = MAKE_PAIR(string1678_globalize_globalize, arg1416_936);
	       }
	       arg1414_934 = MAKE_PAIR(arg1411_931, arg1415_935);
	    }
	    list1413_933 = MAKE_PAIR(string1679_globalize_globalize, arg1414_934);
	 }
	 verbose_tools_speek(BINT(((long) 3)), list1413_933);
      }
   }
   {
      value_t fun_938;
      fun_938 = (((global_t) CREF(global_1))->value);
      __e__34_globalize_globalize = BNIL;
      __g0__244_globalize_globalize = BNIL;
      __g1__181_globalize_globalize = BNIL;
      {
	 node_t aux_1634;
	 obj_t aux_1631;
	 {
	    obj_t aux_1635;
	    {
	       sfun_t obj_1430;
	       obj_1430 = (sfun_t) (fun_938);
	       aux_1635 = (((sfun_t) CREF(obj_1430))->body);
	    }
	    aux_1634 = (node_t) (aux_1635);
	 }
	 {
	    sfun_t obj_1429;
	    obj_1429 = (sfun_t) (fun_938);
	    aux_1631 = (((sfun_t) CREF(obj_1429))->args);
	 }
	 gn__33_globalize_gn(aux_1631, aux_1634, (variable_t) (global_1), BNIL);
      }
      {
	 bool_t test1422_942;
	 {
	    obj_t aux_1641;
	    aux_1641 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	    test1422_942 = CBOOL(aux_1641);
	 }
	 if (test1422_942)
	   {
	      obj_t arg1426_944;
	      obj_t arg1428_946;
	      obj_t arg1432_948;
	      arg1426_944 = shape_tools_shape(__e__34_globalize_globalize);
	      arg1428_946 = shape_tools_shape(__g0__244_globalize_globalize);
	      arg1432_948 = shape_tools_shape(__g1__181_globalize_globalize);
	      {
		 obj_t list1433_949;
		 {
		    obj_t arg1440_950;
		    {
		       obj_t arg1441_951;
		       {
			  obj_t arg1444_952;
			  {
			     obj_t arg1445_953;
			     {
				obj_t arg1446_954;
				{
				   obj_t arg1447_955;
				   {
				      obj_t arg1448_956;
				      {
					 obj_t arg1449_957;
					 {
					    obj_t aux_1650;
					    aux_1650 = BCHAR(((unsigned char) '\n'));
					    arg1449_957 = MAKE_PAIR(aux_1650, BNIL);
					 }
					 arg1448_956 = MAKE_PAIR(arg1432_948, arg1449_957);
				      }
				      arg1447_955 = MAKE_PAIR(string1680_globalize_globalize, arg1448_956);
				   }
				   {
				      obj_t aux_1655;
				      aux_1655 = BCHAR(((unsigned char) '\n'));
				      arg1446_954 = MAKE_PAIR(aux_1655, arg1447_955);
				   }
				}
				arg1445_953 = MAKE_PAIR(arg1428_946, arg1446_954);
			     }
			     arg1444_952 = MAKE_PAIR(string1681_globalize_globalize, arg1445_953);
			  }
			  {
			     obj_t aux_1660;
			     aux_1660 = BCHAR(((unsigned char) '\n'));
			     arg1441_951 = MAKE_PAIR(aux_1660, arg1444_952);
			  }
		       }
		       arg1440_950 = MAKE_PAIR(arg1426_944, arg1441_951);
		    }
		    list1433_949 = MAKE_PAIR(string1682_globalize_globalize, arg1440_950);
		 }
		 print_trace_107_tools_trace(list1433_949);
	      }
	   }
	 else
	   {
	      BUNSPEC;
	   }
      }
      set_integration__52_globalize_integration();
      {
	 obj_t g_961;
	 {
	    obj_t g1_989;
	    obj_t g_990;
	    g1_989 = __g1__181_globalize_globalize;
	    g_990 = __e__34_globalize_globalize;
	  loop_991:
	    if (NULLP(g1_989))
	      {
		 {
		    bool_t test1488_993;
		    {
		       obj_t aux_1669;
		       aux_1669 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
		       test1488_993 = CBOOL(aux_1669);
		    }
		    if (test1488_993)
		      {
			 obj_t arg1490_995;
			 arg1490_995 = shape_tools_shape(g_990);
			 {
			    obj_t list1491_996;
			    {
			       obj_t arg1493_997;
			       {
				  obj_t arg1494_998;
				  {
				     obj_t aux_1676;
				     aux_1676 = BCHAR(((unsigned char) '\n'));
				     arg1494_998 = MAKE_PAIR(aux_1676, BNIL);
				  }
				  arg1493_997 = MAKE_PAIR(arg1490_995, arg1494_998);
			       }
			       list1491_996 = MAKE_PAIR(string1683_globalize_globalize, arg1493_997);
			    }
			    print_trace_107_tools_trace(list1491_996);
			 }
		      }
		    else
		      {
			 BUNSPEC;
		      }
		 }
		 g_961 = g_990;
	      }
	    else
	      {
		 bool_t test1499_1002;
		 {
		    obj_t aux_1682;
		    {
		       sfun_ginfo_98_t obj_1434;
		       {
			  value_t aux_1683;
			  {
			     local_t obj_1433;
			     {
				obj_t aux_1684;
				aux_1684 = CAR(g1_989);
				obj_1433 = (local_t) (aux_1684);
			     }
			     aux_1683 = (((local_t) CREF(obj_1433))->value);
			  }
			  obj_1434 = (sfun_ginfo_98_t) (aux_1683);
		       }
		       {
			  obj_t aux_1689;
			  {
			     object_t aux_1690;
			     aux_1690 = (object_t) (obj_1434);
			     aux_1689 = OBJECT_WIDENING(aux_1690);
			  }
			  aux_1682 = (((sfun_ginfo_98_t) CREF(aux_1689))->integrator);
		       }
		    }
		    test1499_1002 = is_a__118___object(aux_1682, local_ast_var);
		 }
		 if (test1499_1002)
		   {
		      {
			 obj_t g1_1696;
			 g1_1696 = CDR(g1_989);
			 g1_989 = g1_1696;
			 goto loop_991;
		      }
		   }
		 else
		   {
		      {
			 obj_t arg1501_1004;
			 obj_t arg1505_1005;
			 arg1501_1004 = CDR(g1_989);
			 {
			    obj_t aux_1699;
			    aux_1699 = CAR(g1_989);
			    arg1505_1005 = MAKE_PAIR(aux_1699, g_990);
			 }
			 {
			    obj_t g_1703;
			    obj_t g1_1702;
			    g1_1702 = arg1501_1004;
			    g_1703 = arg1505_1005;
			    g_990 = g_1703;
			    g1_989 = g1_1702;
			    goto loop_991;
			 }
		      }
		   }
	      }
	 }
	 verb_globalization_175_globalize_globalize();
	 set_globalized_new_bodies__10_globalize_new_body_146(global_1, g_961);
	 set_kaptured__104_globalize_kapture(g_961);
	 {
	    obj_t g_962;
	    obj_t new_g_67_963;
	    {
	       obj_t arg1454_965;
	       {
		  bool_t test_1707;
		  {
		     global_ginfo_75_t obj_1441;
		     obj_1441 = (global_ginfo_75_t) (global_1);
		     {
			obj_t aux_1709;
			{
			   object_t aux_1710;
			   aux_1710 = (object_t) (obj_1441);
			   aux_1709 = OBJECT_WIDENING(aux_1710);
			}
			test_1707 = (((global_ginfo_75_t) CREF(aux_1709))->escape__117);
		     }
		  }
		  if (test_1707)
		    {
		       global_t arg1457_967;
		       {
			  obj_t aux_1714;
			  {
			     node_t obj_1443;
			     {
				obj_t aux_1715;
				{
				   sfun_t obj_1442;
				   obj_1442 = (sfun_t) (fun_938);
				   aux_1715 = (((sfun_t) CREF(obj_1442))->body);
				}
				obj_1443 = (node_t) (aux_1715);
			     }
			     aux_1714 = (((node_t) CREF(obj_1443))->loc);
			  }
			  arg1457_967 = global_closure_229_globalize_global_closure_246(global_1, aux_1714);
		       }
		       {
			  obj_t list1458_968;
			  {
			     obj_t arg1461_969;
			     {
				obj_t aux_1721;
				aux_1721 = (obj_t) (global_1);
				arg1461_969 = MAKE_PAIR(aux_1721, BNIL);
			     }
			     {
				obj_t aux_1724;
				aux_1724 = (obj_t) (arg1457_967);
				list1458_968 = MAKE_PAIR(aux_1724, arg1461_969);
			     }
			  }
			  arg1454_965 = list1458_968;
		       }
		    }
		  else
		    {
		       obj_t list1467_973;
		       {
			  obj_t aux_1727;
			  aux_1727 = (obj_t) (global_1);
			  list1467_973 = MAKE_PAIR(aux_1727, BNIL);
		       }
		       arg1454_965 = list1467_973;
		    }
	       }
	       g_962 = g_961;
	       new_g_67_963 = arg1454_965;
	     loop_964:
	       if (NULLP(g_962))
		 {
		    node_t body_976;
		    {
		       node_t aux_1732;
		       {
			  obj_t aux_1733;
			  {
			     sfun_t obj_1447;
			     obj_1447 = (sfun_t) (fun_938);
			     aux_1733 = (((sfun_t) CREF(obj_1447))->body);
			  }
			  aux_1732 = (node_t) (aux_1733);
		       }
		       body_976 = node_globalize__229_globalize_node(aux_1732, (variable_t) (global_1), BNIL);
		    }
		    {
		       obj_t res1674_1450;
		       {
			  sfun_t obj_1448;
			  obj_t val1082_1449;
			  obj_1448 = (sfun_t) (fun_938);
			  val1082_1449 = (obj_t) (body_976);
			  {
			     obj_t x_1557;
			     x_1557 = ((((sfun_t) CREF(obj_1448))->body) = ((obj_t) val1082_1449), BUNSPEC);
			     res1674_1450 = BUNSPEC;
			  }
		       }
		       res1674_1450;
		    }
		    {
		       bool_t test1470_977;
		       {
			  obj_t aux_1742;
			  aux_1742 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
			  test1470_977 = CBOOL(aux_1742);
		       }
		       if (test1470_977)
			 {
			    obj_t list1471_978;
			    {
			       obj_t arg1472_979;
			       {
				  obj_t aux_1748;
				  aux_1748 = BCHAR(((unsigned char) '\n'));
				  arg1472_979 = MAKE_PAIR(aux_1748, BNIL);
			       }
			       {
				  obj_t aux_1751;
				  aux_1751 = BCHAR(((unsigned char) ''));
				  list1471_978 = MAKE_PAIR(aux_1751, arg1472_979);
			       }
			    }
			    print_trace_107_tools_trace(list1471_978);
			 }
		       else
			 {
			    BUNSPEC;
			 }
		    }
		    return new_g_67_963;
		 }
	       else
		 {
		    obj_t arg1481_985;
		    obj_t arg1484_986;
		    arg1481_985 = CDR(g_962);
		    {
		       global_t arg1485_987;
		       {
			  local_t aux_1756;
			  {
			     obj_t aux_1757;
			     aux_1757 = CAR(g_962);
			     aux_1756 = (local_t) (aux_1757);
			  }
			  arg1485_987 = local__global_40_globalize_local__global_194(aux_1756);
		       }
		       {
			  obj_t aux_1761;
			  aux_1761 = (obj_t) (arg1485_987);
			  arg1484_986 = MAKE_PAIR(aux_1761, new_g_67_963);
		       }
		    }
		    {
		       obj_t new_g_67_1765;
		       obj_t g_1764;
		       g_1764 = arg1481_985;
		       new_g_67_1765 = arg1484_986;
		       new_g_67_963 = new_g_67_1765;
		       g_962 = g_1764;
		       goto loop_964;
		    }
		 }
	    }
	 }
      }
   }
}


obj_t 
_globalize__140_globalize_globalize(obj_t env_1555, obj_t global_1556)
{
   return globalize__167_globalize_globalize((global_t) (global_1556));
}


bool_t 
verb_globalization_175_globalize_globalize()
{
   {
      obj_t l1369_1010;
      l1369_1010 = __e__34_globalize_globalize;
    lname1370_1011:
      if (PAIRP(l1369_1010))
	{
	   {
	      obj_t arg1517_1016;
	      arg1517_1016 = shape_tools_shape(CAR(l1369_1010));
	      {
		 obj_t list1519_1018;
		 {
		    obj_t arg1520_1019;
		    {
		       obj_t arg1522_1020;
		       {
			  obj_t arg1523_1021;
			  {
			     obj_t aux_1772;
			     aux_1772 = BCHAR(((unsigned char) '\n'));
			     arg1523_1021 = MAKE_PAIR(aux_1772, BNIL);
			  }
			  arg1522_1020 = MAKE_PAIR(string1684_globalize_globalize, arg1523_1021);
		       }
		       arg1520_1019 = MAKE_PAIR(arg1517_1016, arg1522_1020);
		    }
		    list1519_1018 = MAKE_PAIR(string1685_globalize_globalize, arg1520_1019);
		 }
		 verbose_tools_speek(BINT(((long) 3)), list1519_1018);
	      }
	   }
	   {
	      obj_t l1369_1780;
	      l1369_1780 = CDR(l1369_1010);
	      l1369_1010 = l1369_1780;
	      goto lname1370_1011;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      obj_t l1371_1024;
      l1371_1024 = __g1__181_globalize_globalize;
    lname1373_1025:
      if (PAIRP(l1371_1024))
	{
	   {
	      obj_t local_1027;
	      local_1027 = CAR(l1371_1024);
	      {
		 value_t sfun_ginfo_98_1028;
		 {
		    local_t obj_1460;
		    obj_1460 = (local_t) (local_1027);
		    sfun_ginfo_98_1028 = (((local_t) CREF(obj_1460))->value);
		 }
		 {
		    bool_t test1528_1029;
		    {
		       obj_t aux_1787;
		       {
			  sfun_ginfo_98_t obj_1461;
			  obj_1461 = (sfun_ginfo_98_t) (sfun_ginfo_98_1028);
			  {
			     obj_t aux_1789;
			     {
				object_t aux_1790;
				aux_1790 = (object_t) (obj_1461);
				aux_1789 = OBJECT_WIDENING(aux_1790);
			     }
			     aux_1787 = (((sfun_ginfo_98_t) CREF(aux_1789))->integrator);
			  }
		       }
		       test1528_1029 = is_a__118___object(aux_1787, local_ast_var);
		    }
		    if (test1528_1029)
		      {
			 obj_t arg1532_1032;
			 obj_t arg1535_1034;
			 arg1532_1032 = shape_tools_shape(local_1027);
			 {
			    obj_t aux_1797;
			    {
			       sfun_ginfo_98_t obj_1463;
			       obj_1463 = (sfun_ginfo_98_t) (sfun_ginfo_98_1028);
			       {
				  obj_t aux_1799;
				  {
				     object_t aux_1800;
				     aux_1800 = (object_t) (obj_1463);
				     aux_1799 = OBJECT_WIDENING(aux_1800);
				  }
				  aux_1797 = (((sfun_ginfo_98_t) CREF(aux_1799))->integrator);
			       }
			    }
			    arg1535_1034 = shape_tools_shape(aux_1797);
			 }
			 {
			    obj_t list1536_1035;
			    {
			       obj_t arg1537_1036;
			       {
				  obj_t arg1538_1037;
				  {
				     obj_t arg1539_1038;
				     {
					obj_t arg1540_1039;
					{
					   obj_t aux_1805;
					   aux_1805 = BCHAR(((unsigned char) '\n'));
					   arg1540_1039 = MAKE_PAIR(aux_1805, BNIL);
					}
					arg1539_1038 = MAKE_PAIR(arg1535_1034, arg1540_1039);
				     }
				     arg1538_1037 = MAKE_PAIR(string1686_globalize_globalize, arg1539_1038);
				  }
				  arg1537_1036 = MAKE_PAIR(arg1532_1032, arg1538_1037);
			       }
			       list1536_1035 = MAKE_PAIR(string1685_globalize_globalize, arg1537_1036);
			    }
			    verbose_tools_speek(BINT(((long) 3)), list1536_1035);
			 }
		      }
		    else
		      {
			 obj_t arg1549_1044;
			 arg1549_1044 = shape_tools_shape(local_1027);
			 {
			    obj_t list1551_1046;
			    {
			       obj_t arg1552_1047;
			       {
				  obj_t arg1553_1048;
				  {
				     obj_t arg1554_1049;
				     {
					obj_t aux_1815;
					aux_1815 = BCHAR(((unsigned char) '\n'));
					arg1554_1049 = MAKE_PAIR(aux_1815, BNIL);
				     }
				     arg1553_1048 = MAKE_PAIR(string1687_globalize_globalize, arg1554_1049);
				  }
				  arg1552_1047 = MAKE_PAIR(arg1549_1044, arg1553_1048);
			       }
			       list1551_1046 = MAKE_PAIR(string1685_globalize_globalize, arg1552_1047);
			    }
			    verbose_tools_speek(BINT(((long) 3)), list1551_1046);
			 }
		      }
		 }
	      }
	   }
	   {
	      obj_t l1371_1823;
	      l1371_1823 = CDR(l1371_1024);
	      l1371_1024 = l1371_1823;
	      goto lname1373_1025;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
imported_modules_init_94_globalize_globalize()
{
   module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_GLOBALIZE");
   module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_GLOBALIZE");
   module_initialization_70_tools_speek(((long) 0), "GLOBALIZE_GLOBALIZE");
   module_initialization_70_type_type(((long) 0), "GLOBALIZE_GLOBALIZE");
   module_initialization_70_ast_var(((long) 0), "GLOBALIZE_GLOBALIZE");
   module_initialization_70_ast_node(((long) 0), "GLOBALIZE_GLOBALIZE");
   module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_GLOBALIZE");
   module_initialization_70_globalize_node(((long) 0), "GLOBALIZE_GLOBALIZE");
   module_initialization_70_globalize_free(((long) 0), "GLOBALIZE_GLOBALIZE");
   module_initialization_70_globalize_kapture(((long) 0), "GLOBALIZE_GLOBALIZE");
   module_initialization_70_globalize_gn(((long) 0), "GLOBALIZE_GLOBALIZE");
   module_initialization_70_globalize_integration(((long) 0), "GLOBALIZE_GLOBALIZE");
   module_initialization_70_globalize_new_body_146(((long) 0), "GLOBALIZE_GLOBALIZE");
   module_initialization_70_globalize_local__global_194(((long) 0), "GLOBALIZE_GLOBALIZE");
   return module_initialization_70_globalize_global_closure_246(((long) 0), "GLOBALIZE_GLOBALIZE");
}
