/*===========================================================================*/
/*   (Globalize/gloclo.scm)                                                  */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_t;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_t;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_t;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_t;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_t;


extern obj_t svar_ginfo_131_globalize_ginfo;
extern obj_t __procedure__226_type_cache;
extern obj_t make_n_proto_123_tools_args(obj_t);
extern global_t def_global_sfun__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t _foreign_closures_249_globalize_global_closure_246(obj_t);
static obj_t imported_modules_init_94_globalize_global_closure_246();
extern obj_t module_initialization_70_globalize_global_closure_246(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_node(long, char *);
extern obj_t module_initialization_70_globalize_free(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t toplevel_init_63_globalize_global_closure_246();
static obj_t cnst_init_137_globalize_global_closure_246();
extern obj_t global_ginfo_75_globalize_ginfo;
extern obj_t cfun_ast_var;
extern obj_t __module__166_module_module;
static obj_t require_initialization_114_globalize_global_closure_246 = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_globalize_global_closure_246();
extern obj_t ___arity_132_tools_args(obj_t, obj_t);
extern obj_t foreign_closures_19_globalize_global_closure_246();
extern obj_t sfun_ast_var;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
static obj_t gloclo_globalize_global_closure_246(global_t, local_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t _make_global_closure_22_globalize_global_closure_246(obj_t, obj_t);
extern obj_t _global_closure_9_globalize_global_closure_246(obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern global_t global_closure_229_globalize_global_closure_246(global_t, obj_t);
static obj_t __foreign_closures__211_globalize_global_closure_246 = BUNSPEC;
extern long class_num_218___object(obj_t);
extern obj_t local_ginfo_108_globalize_ginfo;
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t the_global_closure_233_globalize_free(global_t, obj_t);
extern global_t make_global_closure_44_globalize_global_closure_246(global_t);
extern obj_t local_ast_var;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _____74_type_cache;
extern obj_t __obj__252_type_cache;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
extern obj_t app_ast_node;
static obj_t __cnst[8];

DEFINE_STRING(string1635_globalize_global_closure_246, string1635_globalize_global_closure_2461645, "global-closure", 14);
DEFINE_STRING(string1633_globalize_global_closure_246, string1633_globalize_global_closure_2461646, "Unexpected value", 16);
DEFINE_EXPORT_PROCEDURE(global_closure_env_218_globalize_global_closure_246, _global_closure_9_globalize_global_closure_2461647, _global_closure_9_globalize_global_closure_246, 0L, 2);
DEFINE_STRING(string1634_globalize_global_closure_246, string1634_globalize_global_closure_2461648, "=======> J'ai cree le corps:", 28);
DEFINE_EXPORT_PROCEDURE(make_global_closure_env_43_globalize_global_closure_246, _make_global_closure_22_globalize_global_closure_2461649, _make_global_closure_22_globalize_global_closure_246, 0L, 1);
DEFINE_EXPORT_PROCEDURE(foreign_closures_env_102_globalize_global_closure_246, _foreign_closures_249_globalize_global_closure_2461650, _foreign_closures_249_globalize_global_closure_246, 0L, 0);
DEFINE_STRING(string1632_globalize_global_closure_246, string1632_globalize_global_closure_2461651, "make-global-closure", 19);
DEFINE_STRING(string1636_globalize_global_closure_246, string1636_globalize_global_closure_2461652, "Can't allocate global closure", 29);
DEFINE_STRING(string1637_globalize_global_closure_246, string1637_globalize_global_closure_2461653, "STATIC NOW SFUN FOREIGN ::OBJ _ GLOBALIZE ENV ", 46);

obj_t 
module_initialization_70_globalize_global_closure_246(long checksum_1690, char *from_1691)
{
   if (CBOOL(require_initialization_114_globalize_global_closure_246))
     {
	require_initialization_114_globalize_global_closure_246 = BBOOL(((bool_t) 0));
	library_modules_init_112_globalize_global_closure_246();
	cnst_init_137_globalize_global_closure_246();
	imported_modules_init_94_globalize_global_closure_246();
	toplevel_init_63_globalize_global_closure_246();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_globalize_global_closure_246()
{
   module_initialization_70___object(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70___reader(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70___r4_symbols_6_4(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_globalize_global_closure_246()
{
   {
      obj_t cnst_port_138_1682;
      cnst_port_138_1682 = open_input_string(string1637_globalize_global_closure_246);
      {
	 long i_1683;
	 i_1683 = ((long) 7);
       loop_1684:
	 {
	    bool_t test1638_1685;
	    test1638_1685 = (i_1683 == ((long) -1));
	    if (test1638_1685)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1641_1686;
		    {
		       obj_t list1642_1687;
		       {
			  obj_t arg1643_1688;
			  arg1643_1688 = BNIL;
			  list1642_1687 = MAKE_PAIR(cnst_port_138_1682, arg1643_1688);
		       }
		       arg1641_1686 = read___reader(list1642_1687);
		    }
		    CNST_TABLE_SET(i_1683, arg1641_1686);
		 }
		 {
		    int aux_1689;
		    {
		       long aux_1708;
		       aux_1708 = (i_1683 - ((long) 1));
		       aux_1689 = (int) (aux_1708);
		    }
		    {
		       long i_1711;
		       i_1711 = (long) (aux_1689);
		       i_1683 = i_1711;
		       goto loop_1684;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_globalize_global_closure_246()
{
   return (__foreign_closures__211_globalize_global_closure_246 = BNIL,
      BUNSPEC);
}


global_t 
global_closure_229_globalize_global_closure_246(global_t global_1, obj_t loc_2)
{
   the_global_closure_233_globalize_free(global_1, loc_2);
   return make_global_closure_44_globalize_global_closure_246(global_1);
}


obj_t 
_global_closure_9_globalize_global_closure_246(obj_t env_1671, obj_t global_1672, obj_t loc_1673)
{
   {
      global_t aux_1715;
      aux_1715 = global_closure_229_globalize_global_closure_246((global_t) (global_1672), loc_1673);
      return (obj_t) (aux_1715);
   }
}


global_t 
make_global_closure_44_globalize_global_closure_246(global_t global_3)
{
   {
      obj_t glo_927;
      {
	 global_ginfo_75_t obj_1411;
	 obj_1411 = (global_ginfo_75_t) (global_3);
	 {
	    obj_t aux_1720;
	    {
	       object_t aux_1721;
	       aux_1721 = (object_t) (obj_1411);
	       aux_1720 = OBJECT_WIDENING(aux_1721);
	    }
	    glo_927 = (((global_ginfo_75_t) CREF(aux_1720))->global_closure_229);
	 }
      }
      {
	 bool_t test1386_928;
	 test1386_928 = is_a__118___object(glo_927, global_ast_var);
	 if (test1386_928)
	   {
	      return (global_t) (glo_927);
	   }
	 else
	   {
	      value_t old_fun_147_929;
	      old_fun_147_929 = (((global_t) CREF(global_3))->value);
	      {
		 local_t env_930;
		 {
		    local_t var_992;
		    var_992 = make_local_svar_140_ast_local(CNST_TABLE_REF(((long) 0)), (type_t) (__procedure__226_type_cache));
		    {
		       local_ginfo_108_t obj1371_993;
		       obj1371_993 = ((local_ginfo_108_t) (var_992));
		       {
			  local_ginfo_108_t arg1453_994;
			  {
			     local_ginfo_108_t res1619_1417;
			     {
				local_ginfo_108_t new1340_1415;
				new1340_1415 = ((local_ginfo_108_t) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
				((((local_ginfo_108_t) CREF(new1340_1415))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				res1619_1417 = new1340_1415;
			     }
			     arg1453_994 = res1619_1417;
			  }
			  {
			     obj_t aux_1737;
			     object_t aux_1735;
			     aux_1737 = (obj_t) (arg1453_994);
			     aux_1735 = (object_t) (obj1371_993);
			     OBJECT_WIDENING_SET(aux_1735, aux_1737);
			  }
		       }
		       {
			  long arg1454_995;
			  arg1454_995 = class_num_218___object(local_ginfo_108_globalize_ginfo);
			  {
			     obj_t obj_1418;
			     obj_1418 = (obj_t) (obj1371_993);
			     (((obj_t) CREF(obj_1418))->header = MAKE_HEADER(arg1454_995, 0), BUNSPEC);
			  }
		       }
		       obj1371_993;
		    }
		    env_930 = var_992;
		 }
		 {
		    obj_t new_args_235_931;
		    {
		       obj_t l1372_967;
		       {
			  bool_t test1451_990;
			  test1451_990 = is_a__118___object((obj_t) (old_fun_147_929), sfun_ast_var);
			  if (test1451_990)
			    {
			       sfun_t obj_1421;
			       obj_1421 = (sfun_t) (old_fun_147_929);
			       l1372_967 = (((sfun_t) CREF(obj_1421))->args);
			    }
			  else
			    {
			       bool_t test1452_991;
			       test1452_991 = is_a__118___object((obj_t) (old_fun_147_929), cfun_ast_var);
			       if (test1452_991)
				 {
				    cfun_t obj_1423;
				    obj_1423 = (cfun_t) (old_fun_147_929);
				    l1372_967 = (((cfun_t) CREF(obj_1423))->args_type_205);
				 }
			       else
				 {
				    l1372_967 = internal_error_43_tools_error(string1632_globalize_global_closure_246, string1633_globalize_global_closure_246, (obj_t) (old_fun_147_929));
				 }
			    }
		       }
		       if (NULLP(l1372_967))
			 {
			    new_args_235_931 = BNIL;
			 }
		       else
			 {
			    obj_t head1374_969;
			    head1374_969 = MAKE_PAIR(BNIL, BNIL);
			    {
			       obj_t l1372_970;
			       obj_t tail1375_971;
			       l1372_970 = l1372_967;
			       tail1375_971 = head1374_969;
			     lname1373_972:
			       if (NULLP(l1372_970))
				 {
				    new_args_235_931 = CDR(head1374_969);
				 }
			       else
				 {
				    obj_t new_tail1376_173_974;
				    {
				       local_t arg1432_976;
				       {
					  obj_t old_978;
					  old_978 = CAR(l1372_970);
					  {
					     local_t new_979;
					     {
						obj_t arg1447_986;
						{
						   bool_t test1448_987;
						   test1448_987 = is_a__118___object(old_978, local_ast_var);
						   if (test1448_987)
						     {
							local_t obj_1431;
							obj_1431 = (local_t) (old_978);
							arg1447_986 = (((local_t) CREF(obj_1431))->id);
						     }
						   else
						     {
							arg1447_986 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, BEOA);
						     }
						}
						new_979 = make_local_svar_140_ast_local(arg1447_986, (type_t) (__obj__252_type_cache));
					     }
					     {
						svar_ginfo_131_t obj1377_980;
						obj1377_980 = ((svar_ginfo_131_t) ((((local_t) CREF(new_979))->value)));
						{
						   svar_ginfo_131_t arg1441_981;
						   {
						      svar_ginfo_131_t res1620_1442;
						      {
							 svar_ginfo_131_t new1318_1437;
							 new1318_1437 = ((svar_ginfo_131_t) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
							 ((((svar_ginfo_131_t) CREF(new1318_1437))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							 ((((svar_ginfo_131_t) CREF(new1318_1437))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
							 ((((svar_ginfo_131_t) CREF(new1318_1437))->mark) = ((long) ((long) -10)), BUNSPEC);
							 ((((svar_ginfo_131_t) CREF(new1318_1437))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							 res1620_1442 = new1318_1437;
						      }
						      arg1441_981 = res1620_1442;
						   }
						   {
						      obj_t aux_1779;
						      object_t aux_1777;
						      aux_1779 = (obj_t) (arg1441_981);
						      aux_1777 = (object_t) (obj1377_980);
						      OBJECT_WIDENING_SET(aux_1777, aux_1779);
						   }
						}
						{
						   long arg1444_982;
						   arg1444_982 = class_num_218___object(svar_ginfo_131_globalize_ginfo);
						   {
						      obj_t obj_1443;
						      obj_1443 = (obj_t) (obj1377_980);
						      (((obj_t) CREF(obj_1443))->header = MAKE_HEADER(arg1444_982, 0), BUNSPEC);
						   }
						}
						obj1377_980;
					     }
					     {
						local_ginfo_108_t obj1378_983;
						obj1378_983 = ((local_ginfo_108_t) (new_979));
						{
						   local_ginfo_108_t arg1445_984;
						   {
						      local_ginfo_108_t res1621_1448;
						      {
							 local_ginfo_108_t new1340_1446;
							 new1340_1446 = ((local_ginfo_108_t) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
							 ((((local_ginfo_108_t) CREF(new1340_1446))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							 res1621_1448 = new1340_1446;
						      }
						      arg1445_984 = res1621_1448;
						   }
						   {
						      obj_t aux_1790;
						      object_t aux_1788;
						      aux_1790 = (obj_t) (arg1445_984);
						      aux_1788 = (object_t) (obj1378_983);
						      OBJECT_WIDENING_SET(aux_1788, aux_1790);
						   }
						}
						{
						   long arg1446_985;
						   arg1446_985 = class_num_218___object(local_ginfo_108_globalize_ginfo);
						   {
						      obj_t obj_1449;
						      obj_1449 = (obj_t) (obj1378_983);
						      (((obj_t) CREF(obj_1449))->header = MAKE_HEADER(arg1446_985, 0), BUNSPEC);
						   }
						}
						obj1378_983;
					     }
					     arg1432_976 = new_979;
					  }
				       }
				       {
					  obj_t aux_1796;
					  aux_1796 = (obj_t) (arg1432_976);
					  new_tail1376_173_974 = MAKE_PAIR(aux_1796, BNIL);
				       }
				    }
				    SET_CDR(tail1375_971, new_tail1376_173_974);
				    {
				       obj_t tail1375_1802;
				       obj_t l1372_1800;
				       l1372_1800 = CDR(l1372_970);
				       tail1375_1802 = new_tail1376_173_974;
				       tail1375_971 = tail1375_1802;
				       l1372_970 = l1372_1800;
				       goto lname1373_972;
				    }
				 }
			    }
			 }
		    }
		    {
		       obj_t gloclo_932;
		       gloclo_932 = gloclo_globalize_global_closure_246(global_3, env_930, new_args_235_931);
		       {
			  value_t new_fun_115_933;
			  {
			     global_t obj_1456;
			     obj_1456 = (global_t) (gloclo_932);
			     new_fun_115_933 = (((global_t) CREF(obj_1456))->value);
			  }
			  {
			     {
				svar_ginfo_131_t obj1379_934;
				obj1379_934 = ((svar_ginfo_131_t) ((((local_t) CREF(env_930))->value)));
				{
				   svar_ginfo_131_t arg1388_935;
				   {
				      svar_ginfo_131_t res1622_1467;
				      {
					 svar_ginfo_131_t new1318_1462;
					 new1318_1462 = ((svar_ginfo_131_t) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
					 ((((svar_ginfo_131_t) CREF(new1318_1462))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					 ((((svar_ginfo_131_t) CREF(new1318_1462))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
					 ((((svar_ginfo_131_t) CREF(new1318_1462))->mark) = ((long) ((long) -10)), BUNSPEC);
					 ((((svar_ginfo_131_t) CREF(new1318_1462))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					 res1622_1467 = new1318_1462;
				      }
				      arg1388_935 = res1622_1467;
				   }
				   {
				      obj_t aux_1815;
				      object_t aux_1813;
				      aux_1815 = (obj_t) (arg1388_935);
				      aux_1813 = (object_t) (obj1379_934);
				      OBJECT_WIDENING_SET(aux_1813, aux_1815);
				   }
				}
				{
				   long arg1390_936;
				   arg1390_936 = class_num_218___object(svar_ginfo_131_globalize_ginfo);
				   {
				      obj_t obj_1468;
				      obj_1468 = (obj_t) (obj1379_934);
				      (((obj_t) CREF(obj_1468))->header = MAKE_HEADER(arg1390_936, 0), BUNSPEC);
				   }
				}
				obj1379_934;
			     }
			     {
				global_ginfo_75_t obj1380_937;
				obj1380_937 = ((global_ginfo_75_t) (gloclo_932));
				{
				   global_ginfo_75_t arg1391_938;
				   {
				      global_ginfo_75_t res1623_1475;
				      {
					 obj_t global_closure_229_1471;
					 global_closure_229_1471 = BFALSE;
					 {
					    global_ginfo_75_t new1354_1472;
					    new1354_1472 = ((global_ginfo_75_t) BREF(GC_MALLOC(sizeof(struct global_ginfo_75))));
					    ((((global_ginfo_75_t) CREF(new1354_1472))->escape__117) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					    ((((global_ginfo_75_t) CREF(new1354_1472))->global_closure_229) = ((obj_t) global_closure_229_1471), BUNSPEC);
					    res1623_1475 = new1354_1472;
					 }
				      }
				      arg1391_938 = res1623_1475;
				   }
				   {
				      obj_t aux_1827;
				      object_t aux_1825;
				      aux_1827 = (obj_t) (arg1391_938);
				      aux_1825 = (object_t) (obj1380_937);
				      OBJECT_WIDENING_SET(aux_1825, aux_1827);
				   }
				}
				{
				   long arg1396_939;
				   arg1396_939 = class_num_218___object(global_ginfo_75_globalize_ginfo);
				   {
				      obj_t obj_1476;
				      obj_1476 = (obj_t) (obj1380_937);
				      (((obj_t) CREF(obj_1476))->header = MAKE_HEADER(arg1396_939, 0), BUNSPEC);
				   }
				}
				obj1380_937;
			     }
			     {
				app_t arg1398_940;
				{
				   var_t arg1400_941;
				   obj_t arg1402_942;
				   {
				      var_t res1624_1488;
				      {
					 obj_t loc_1478;
					 type_t type_1479;
					 variable_t variable_1480;
					 loc_1478 = BFALSE;
					 type_1479 = (type_t) (_____74_type_cache);
					 variable_1480 = (variable_t) (global_3);
					 {
					    var_t new1133_1481;
					    new1133_1481 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
					    {
					       long arg1576_1482;
					       arg1576_1482 = class_num_218___object(var_ast_node);
					       {
						  obj_t obj_1486;
						  obj_1486 = (obj_t) (new1133_1481);
						  (((obj_t) CREF(obj_1486))->header = MAKE_HEADER(arg1576_1482, 0), BUNSPEC);
					       }
					    }
					    {
					       object_t aux_1839;
					       aux_1839 = (object_t) (new1133_1481);
					       OBJECT_WIDENING_SET(aux_1839, loc_1478);
					    }
					    ((((var_t) CREF(new1133_1481))->loc) = ((obj_t) loc_1478), BUNSPEC);
					    ((((var_t) CREF(new1133_1481))->type) = ((type_t) type_1479), BUNSPEC);
					    ((((var_t) CREF(new1133_1481))->variable) = ((variable_t) variable_1480), BUNSPEC);
					    res1624_1488 = new1133_1481;
					 }
				      }
				      arg1400_941 = res1624_1488;
				   }
				   if (NULLP(new_args_235_931))
				     {
					arg1402_942 = BNIL;
				     }
				   else
				     {
					obj_t head1383_945;
					head1383_945 = MAKE_PAIR(BNIL, BNIL);
					{
					   obj_t l1381_946;
					   obj_t tail1384_947;
					   l1381_946 = new_args_235_931;
					   tail1384_947 = head1383_945;
					 lname1382_948:
					   if (NULLP(l1381_946))
					     {
						arg1402_942 = CDR(head1383_945);
					     }
					   else
					     {
						obj_t new_tail1385_164_950;
						{
						   var_t arg1408_952;
						   {
						      var_t res1625_1505;
						      {
							 obj_t loc_1495;
							 type_t type_1496;
							 variable_t variable_1497;
							 loc_1495 = BFALSE;
							 type_1496 = (type_t) (__obj__252_type_cache);
							 {
							    obj_t aux_1852;
							    aux_1852 = CAR(l1381_946);
							    variable_1497 = (variable_t) (aux_1852);
							 }
							 {
							    var_t new1133_1498;
							    new1133_1498 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
							    {
							       long arg1576_1499;
							       arg1576_1499 = class_num_218___object(var_ast_node);
							       {
								  obj_t obj_1503;
								  obj_1503 = (obj_t) (new1133_1498);
								  (((obj_t) CREF(obj_1503))->header = MAKE_HEADER(arg1576_1499, 0), BUNSPEC);
							       }
							    }
							    {
							       object_t aux_1859;
							       aux_1859 = (object_t) (new1133_1498);
							       OBJECT_WIDENING_SET(aux_1859, loc_1495);
							    }
							    ((((var_t) CREF(new1133_1498))->loc) = ((obj_t) loc_1495), BUNSPEC);
							    ((((var_t) CREF(new1133_1498))->type) = ((type_t) type_1496), BUNSPEC);
							    ((((var_t) CREF(new1133_1498))->variable) = ((variable_t) variable_1497), BUNSPEC);
							    res1625_1505 = new1133_1498;
							 }
						      }
						      arg1408_952 = res1625_1505;
						   }
						   {
						      obj_t aux_1865;
						      aux_1865 = (obj_t) (arg1408_952);
						      new_tail1385_164_950 = MAKE_PAIR(aux_1865, BNIL);
						   }
						}
						SET_CDR(tail1384_947, new_tail1385_164_950);
						{
						   obj_t tail1384_1871;
						   obj_t l1381_1869;
						   l1381_1869 = CDR(l1381_946);
						   tail1384_1871 = new_tail1385_164_950;
						   tail1384_947 = tail1384_1871;
						   l1381_946 = l1381_1869;
						   goto lname1382_948;
						}
					     }
					}
				     }
				   {
				      app_t res1626_1527;
				      {
					 obj_t loc_1511;
					 type_t type_1512;
					 loc_1511 = BFALSE;
					 type_1512 = (type_t) (__obj__252_type_cache);
					 {
					    app_t new1156_1517;
					    new1156_1517 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
					    {
					       long arg1567_1518;
					       arg1567_1518 = class_num_218___object(app_ast_node);
					       {
						  obj_t obj_1525;
						  obj_1525 = (obj_t) (new1156_1517);
						  (((obj_t) CREF(obj_1525))->header = MAKE_HEADER(arg1567_1518, 0), BUNSPEC);
					       }
					    }
					    {
					       object_t aux_1877;
					       aux_1877 = (object_t) (new1156_1517);
					       OBJECT_WIDENING_SET(aux_1877, loc_1511);
					    }
					    ((((app_t) CREF(new1156_1517))->loc) = ((obj_t) loc_1511), BUNSPEC);
					    ((((app_t) CREF(new1156_1517))->type) = ((type_t) type_1512), BUNSPEC);
					    ((((app_t) CREF(new1156_1517))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
					    ((((app_t) CREF(new1156_1517))->fun) = ((var_t) arg1400_941), BUNSPEC);
					    ((((app_t) CREF(new1156_1517))->args) = ((obj_t) arg1402_942), BUNSPEC);
					    ((((app_t) CREF(new1156_1517))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
					    res1626_1527 = new1156_1517;
					 }
				      }
				      arg1398_940 = res1626_1527;
				   }
				}
				{
				   obj_t res1627_1530;
				   {
				      sfun_t obj_1528;
				      obj_t val1082_1529;
				      obj_1528 = (sfun_t) (new_fun_115_933);
				      val1082_1529 = (obj_t) (arg1398_940);
				      {
					 obj_t x_1677;
					 x_1677 = ((((sfun_t) CREF(obj_1528))->body) = ((obj_t) val1082_1529), BUNSPEC);
					 res1627_1530 = BUNSPEC;
				      }
				   }
				   res1627_1530;
				}
			     }
			     {
				bool_t test1413_957;
				{
				   obj_t aux_1889;
				   aux_1889 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
				   test1413_957 = CBOOL(aux_1889);
				}
				if (test1413_957)
				  {
				     obj_t arg1415_959;
				     {
					obj_t aux_1895;
					{
					   sfun_t obj_1531;
					   obj_1531 = (sfun_t) (new_fun_115_933);
					   aux_1895 = (((sfun_t) CREF(obj_1531))->body);
					}
					arg1415_959 = shape_tools_shape(aux_1895);
				     }
				     {
					obj_t list1416_960;
					{
					   obj_t arg1417_961;
					   {
					      obj_t arg1418_962;
					      {
						 obj_t aux_1899;
						 aux_1899 = BCHAR(((unsigned char) '\n'));
						 arg1418_962 = MAKE_PAIR(aux_1899, BNIL);
					      }
					      arg1417_961 = MAKE_PAIR(arg1415_959, arg1418_962);
					   }
					   list1416_960 = MAKE_PAIR(string1634_globalize_global_closure_246, arg1417_961);
					}
					print_trace_107_tools_trace(list1416_960);
				     }
				  }
				else
				  {
				     BUNSPEC;
				  }
			     }
			     return (global_t) (gloclo_932);
			  }
		       }
		    }
		 }
	      }
	   }
      }
   }
}


obj_t 
_make_global_closure_22_globalize_global_closure_246(obj_t env_1674, obj_t global_1675)
{
   {
      global_t aux_1906;
      aux_1906 = make_global_closure_44_globalize_global_closure_246((global_t) (global_1675));
      return (obj_t) (aux_1906);
   }
}


obj_t 
foreign_closures_19_globalize_global_closure_246()
{
   {
      obj_t res_997;
      res_997 = __foreign_closures__211_globalize_global_closure_246;
      __foreign_closures__211_globalize_global_closure_246 = BNIL;
      return res_997;
   }
}


obj_t 
_foreign_closures_249_globalize_global_closure_246(obj_t env_1676)
{
   return foreign_closures_19_globalize_global_closure_246();
}


obj_t 
gloclo_globalize_global_closure_246(global_t global_4, local_t env_5, obj_t args_6)
{
   {
      global_t gloclo_999;
      {
	 obj_t arg1472_1009;
	 obj_t arg1474_1010;
	 obj_t arg1476_1011;
	 obj_t arg1477_1012;
	 obj_t arg1478_1013;
	 obj_t arg1480_1014;
	 obj_t arg1481_1015;
	 {
	    obj_t arg1484_1016;
	    obj_t arg1485_1017;
	    arg1484_1016 = CNST_TABLE_REF(((long) 2));
	    arg1485_1017 = (((global_t) CREF(global_4))->id);
	    {
	       obj_t list1487_1019;
	       {
		  obj_t arg1489_1020;
		  {
		     obj_t arg1490_1021;
		     {
			obj_t aux_1913;
			aux_1913 = CNST_TABLE_REF(((long) 3));
			arg1490_1021 = MAKE_PAIR(aux_1913, BNIL);
		     }
		     arg1489_1020 = MAKE_PAIR(arg1485_1017, arg1490_1021);
		  }
		  list1487_1019 = MAKE_PAIR(arg1484_1016, arg1489_1020);
	       }
	       arg1472_1009 = symbol_append_197___r4_symbols_6_4(list1487_1019);
	    }
	 }
	 {
	    obj_t arg1494_1023;
	    {
	       obj_t aux_1919;
	       {
		  long aux_1920;
		  {
		     fun_t obj_1533;
		     {
			value_t aux_1921;
			aux_1921 = (((global_t) CREF(global_4))->value);
			obj_1533 = (fun_t) (aux_1921);
		     }
		     aux_1920 = (((fun_t) CREF(obj_1533))->arity);
		  }
		  aux_1919 = BINT(aux_1920);
	       }
	       arg1494_1023 = ___arity_132_tools_args(aux_1919, BINT(((long) 1)));
	    }
	    arg1474_1010 = make_n_proto_123_tools_args(arg1494_1023);
	 }
	 {
	    obj_t aux_1929;
	    aux_1929 = (obj_t) (env_5);
	    arg1476_1011 = MAKE_PAIR(aux_1929, args_6);
	 }
	 {
	    bool_t test_1932;
	    {
	       obj_t aux_1935;
	       obj_t aux_1933;
	       aux_1935 = CNST_TABLE_REF(((long) 4));
	       aux_1933 = (((global_t) CREF(global_4))->import);
	       test_1932 = (aux_1933 == aux_1935);
	    }
	    if (test_1932)
	      {
		 arg1477_1012 = __module__166_module_module;
	      }
	    else
	      {
		 arg1477_1012 = (((global_t) CREF(global_4))->module);
	      }
	 }
	 arg1478_1013 = (((global_t) CREF(global_4))->import);
	 arg1480_1014 = CNST_TABLE_REF(((long) 5));
	 arg1481_1015 = CNST_TABLE_REF(((long) 6));
	 gloclo_999 = def_global_sfun__93_ast_glo_def_117(arg1472_1009, arg1474_1010, arg1476_1011, arg1477_1012, arg1478_1013, arg1480_1014, arg1481_1015, BUNSPEC);
      }
      {
	 {
	    obj_t res1628_1544;
	    {
	       global_ginfo_75_t obj_1542;
	       obj_t val1369_1543;
	       obj_1542 = (global_ginfo_75_t) (global_4);
	       val1369_1543 = (obj_t) (gloclo_999);
	       {
		  obj_t x_1678;
		  {
		     obj_t aux_1945;
		     {
			object_t aux_1946;
			aux_1946 = (object_t) (obj_1542);
			aux_1945 = OBJECT_WIDENING(aux_1946);
		     }
		     x_1678 = ((((global_ginfo_75_t) CREF(aux_1945))->global_closure_229) = ((obj_t) val1369_1543), BUNSPEC);
		  }
		  res1628_1544 = BUNSPEC;
	       }
	    }
	    res1628_1544;
	 }
	 {
	    bool_t test_1950;
	    {
	       obj_t aux_1953;
	       obj_t aux_1951;
	       aux_1953 = CNST_TABLE_REF(((long) 4));
	       aux_1951 = (((global_t) CREF(global_4))->import);
	       test_1950 = (aux_1951 == aux_1953);
	    }
	    if (test_1950)
	      {
		 {
		    obj_t obj2_1549;
		    obj2_1549 = __foreign_closures__211_globalize_global_closure_246;
		    {
		       obj_t aux_1956;
		       aux_1956 = (obj_t) (gloclo_999);
		       __foreign_closures__211_globalize_global_closure_246 = MAKE_PAIR(aux_1956, obj2_1549);
		    }
		 }
		 {
		    obj_t arg1461_1001;
		    arg1461_1001 = CNST_TABLE_REF(((long) 7));
		    {
		       obj_t res1629_1552;
		       {
			  obj_t x_1679;
			  x_1679 = ((((global_t) CREF(gloclo_999))->import) = ((obj_t) arg1461_1001), BUNSPEC);
			  res1629_1552 = BUNSPEC;
		       }
		       res1629_1552;
		    }
		 }
	      }
	    else
	      {
		 obj_t arg1463_1002;
		 arg1463_1002 = (((global_t) CREF(global_4))->import);
		 {
		    obj_t res1630_1556;
		    {
		       obj_t x_1680;
		       x_1680 = ((((global_t) CREF(gloclo_999))->import) = ((obj_t) arg1463_1002), BUNSPEC);
		       res1630_1556 = BUNSPEC;
		    }
		    res1630_1556;
		 }
	      }
	 }
	 {
	    obj_t arg1468_1006;
	    {
	       fun_t obj_1559;
	       {
		  value_t aux_1963;
		  aux_1963 = (((global_t) CREF(global_4))->value);
		  obj_1559 = (fun_t) (aux_1963);
	       }
	       arg1468_1006 = (((fun_t) CREF(obj_1559))->side_effect__165);
	    }
	    {
	       obj_t res1631_1562;
	       {
		  fun_t obj_1560;
		  {
		     value_t aux_1967;
		     aux_1967 = (((global_t) CREF(gloclo_999))->value);
		     obj_1560 = (fun_t) (aux_1967);
		  }
		  {
		     obj_t x_1681;
		     x_1681 = ((((fun_t) CREF(obj_1560))->side_effect__165) = ((obj_t) arg1468_1006), BUNSPEC);
		     res1631_1562 = BUNSPEC;
		  }
	       }
	       res1631_1562;
	    }
	 }
	 {
	    bool_t test1471_1008;
	    test1471_1008 = is_a__118___object((obj_t) (gloclo_999), global_ast_var);
	    if (test1471_1008)
	      {
		 return (obj_t) (gloclo_999);
	      }
	    else
	      {
		 return internal_error_43_tools_error(string1635_globalize_global_closure_246, string1636_globalize_global_closure_246, (obj_t) (gloclo_999));
	      }
	 }
      }
   }
}


obj_t 
imported_modules_init_94_globalize_global_closure_246()
{
   module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70_tools_args(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70_tools_error(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70_engine_param(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70_type_type(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70_type_cache(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70_ast_var(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70_ast_node(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70_ast_sexp(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70_ast_local(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70_ast_glo_def_117(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70_module_module(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   module_initialization_70_globalize_node(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   return module_initialization_70_globalize_free(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
}
