/*===========================================================================*/
/*   (Globalize/gn.scm)                                                      */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_t;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_t;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_t;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_t;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_t;


extern obj_t let_fun_218_ast_node;
static obj_t save_fun__213_globalize_gn(variable_t, variable_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_globalize_gn();
extern obj_t module_initialization_70_globalize_gn(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_globalize(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_globalize_gn();
static obj_t cnst_init_137_globalize_gn();
static obj_t g_from_cto_7_globalize_gn(obj_t);
static obj_t _e_default1385_136_globalize_gn(obj_t, obj_t, obj_t, obj_t);
extern obj_t _gn__74_globalize_gn(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_globalize_gn = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t gn__33_globalize_gn(obj_t, node_t, variable_t, obj_t);
extern obj_t print_trace_107_tools_trace(obj_t);
extern obj_t __e__34_globalize_globalize;
static obj_t library_modules_init_112_globalize_gn();
extern obj_t __g1__181_globalize_globalize;
static obj_t save_app__130_globalize_gn(variable_t, variable_t);
extern obj_t cast_ast_node;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
static obj_t e_default1385_116_globalize_gn(node_t, variable_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
static obj_t e_globalize_gn(node_t, variable_t, obj_t);
extern obj_t set_ex_it_116_ast_node;
static obj_t e__176_globalize_gn(obj_t, variable_t, obj_t);
extern obj_t local_ast_var;
extern obj_t kwote_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t _e_globalize_gn(obj_t, obj_t, obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t __g0__244_globalize_globalize;
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t app_ast_node;
static obj_t __cnst[3];

DEFINE_EXPORT_PROCEDURE(gn__env_63_globalize_gn, _gn__74_globalize_gn1732, _gn__74_globalize_gn, 0L, 4);
DEFINE_STATIC_PROCEDURE(e_default1385_env_159_globalize_gn, _e_default1385_136_globalize_gn1733, _e_default1385_136_globalize_gn, 0L, 3);
DEFINE_STRING(string1720_globalize_gn, string1720_globalize_gn1734, " ", 1);
DEFINE_STRING(string1722_globalize_gn, string1722_globalize_gn1735, "GLOBALIZE DONE E-DEFAULT1385 ", 29);
DEFINE_STRING(string1721_globalize_gn, string1721_globalize_gn1736, "save-fun!: ", 11);
DEFINE_STRING(string1719_globalize_gn, string1719_globalize_gn1737, "No method for this object", 25);
DEFINE_STATIC_GENERIC(e_env_17_globalize_gn, _e_globalize_gn1738, _e_globalize_gn, 0L, 3);

obj_t 
module_initialization_70_globalize_gn(long checksum_1853, char *from_1854)
{
   if (CBOOL(require_initialization_114_globalize_gn))
     {
	require_initialization_114_globalize_gn = BBOOL(((bool_t) 0));
	library_modules_init_112_globalize_gn();
	cnst_init_137_globalize_gn();
	imported_modules_init_94_globalize_gn();
	toplevel_init_63_globalize_gn();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_globalize_gn()
{
   module_initialization_70___object(((long) 0), "GLOBALIZE_GN");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_GN");
   module_initialization_70___reader(((long) 0), "GLOBALIZE_GN");
   return BUNSPEC;
}


obj_t 
cnst_init_137_globalize_gn()
{
   {
      obj_t cnst_port_138_1845;
      cnst_port_138_1845 = open_input_string(string1722_globalize_gn);
      {
	 long i_1846;
	 i_1846 = ((long) 2);
       loop_1847:
	 {
	    bool_t test1723_1848;
	    test1723_1848 = (i_1846 == ((long) -1));
	    if (test1723_1848)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1724_1849;
		    {
		       obj_t list1725_1850;
		       {
			  obj_t arg1730_1851;
			  arg1730_1851 = BNIL;
			  list1725_1850 = MAKE_PAIR(cnst_port_138_1845, arg1730_1851);
		       }
		       arg1724_1849 = read___reader(list1725_1850);
		    }
		    CNST_TABLE_SET(i_1846, arg1724_1849);
		 }
		 {
		    int aux_1852;
		    {
		       long aux_1871;
		       aux_1871 = (i_1846 - ((long) 1));
		       aux_1852 = (int) (aux_1871);
		    }
		    {
		       long i_1874;
		       i_1874 = (long) (aux_1852);
		       i_1846 = i_1874;
		       goto loop_1847;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_globalize_gn()
{
   add_generic__110___object(e_env_17_globalize_gn, e_default1385_env_159_globalize_gn);
   add_inlined_method__244___object(e_env_17_globalize_gn, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(e_env_17_globalize_gn, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(e_env_17_globalize_gn, var_ast_node, ((long) 2));
   add_inlined_method__244___object(e_env_17_globalize_gn, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(e_env_17_globalize_gn, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(e_env_17_globalize_gn, app_ast_node, ((long) 5));
   add_inlined_method__244___object(e_env_17_globalize_gn, app_ly_162_ast_node, ((long) 6));
   add_inlined_method__244___object(e_env_17_globalize_gn, funcall_ast_node, ((long) 7));
   add_inlined_method__244___object(e_env_17_globalize_gn, pragma_ast_node, ((long) 8));
   add_inlined_method__244___object(e_env_17_globalize_gn, cast_ast_node, ((long) 9));
   add_inlined_method__244___object(e_env_17_globalize_gn, setq_ast_node, ((long) 10));
   add_inlined_method__244___object(e_env_17_globalize_gn, conditional_ast_node, ((long) 11));
   add_inlined_method__244___object(e_env_17_globalize_gn, fail_ast_node, ((long) 12));
   add_inlined_method__244___object(e_env_17_globalize_gn, select_ast_node, ((long) 13));
   add_inlined_method__244___object(e_env_17_globalize_gn, let_fun_218_ast_node, ((long) 14));
   add_inlined_method__244___object(e_env_17_globalize_gn, let_var_6_ast_node, ((long) 15));
   add_inlined_method__244___object(e_env_17_globalize_gn, set_ex_it_116_ast_node, ((long) 16));
   add_inlined_method__244___object(e_env_17_globalize_gn, jump_ex_it_184_ast_node, ((long) 17));
   add_inlined_method__244___object(e_env_17_globalize_gn, make_box_202_ast_node, ((long) 18));
   add_inlined_method__244___object(e_env_17_globalize_gn, box_ref_242_ast_node, ((long) 19));
   {
      long aux_1897;
      aux_1897 = add_inlined_method__244___object(e_env_17_globalize_gn, box_set__221_ast_node, ((long) 20));
      return BINT(aux_1897);
   }
}


obj_t 
gn__33_globalize_gn(obj_t args_1, node_t node_2, variable_t caller_3, obj_t g_4)
{
   __e__34_globalize_globalize = e_globalize_gn(node_2, caller_3, g_4);
   {
      obj_t g_991;
      obj_t g1_992;
      g_991 = __e__34_globalize_globalize;
      g1_992 = BNIL;
    loop_993:
      if (NULLP(g_991))
	{
	   __g0__244_globalize_globalize = append_2_18___r4_pairs_and_lists_6_3(__e__34_globalize_globalize, g1_992);
	   return (__g1__181_globalize_globalize = g1_992,
	      BUNSPEC);
	}
      else
	{
	   obj_t new_g_67_996;
	   new_g_67_996 = g_from_cto_7_globalize_gn(CAR(g_991));
	   {
	      obj_t g1_1909;
	      obj_t g_1906;
	      g_1906 = append_2_18___r4_pairs_and_lists_6_3(new_g_67_996, CDR(g_991));
	      g1_1909 = append_2_18___r4_pairs_and_lists_6_3(new_g_67_996, g1_992);
	      g1_992 = g1_1909;
	      g_991 = g_1906;
	      goto loop_993;
	   }
	}
   }
}


obj_t 
_gn__74_globalize_gn(obj_t env_1835, obj_t args_1836, obj_t node_1837, obj_t caller_1838, obj_t g_1839)
{
   return gn__33_globalize_gn(args_1836, (node_t) (node_1837), (variable_t) (caller_1838), g_1839);
}


obj_t 
e_default1385_116_globalize_gn(node_t node_8, variable_t caller_9, obj_t g_10)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1719_globalize_gn, (obj_t) (node_8));
}


obj_t 
_e_default1385_136_globalize_gn(obj_t env_1831, obj_t node_1832, obj_t caller_1833, obj_t g_1834)
{
   return e_default1385_116_globalize_gn((node_t) (node_1832), (variable_t) (caller_1833), g_1834);
}


obj_t 
e_globalize_gn(node_t node_5, variable_t caller_6, obj_t g_7)
{
 e_globalize_gn:
   {
      obj_t method1618_1434;
      obj_t class1623_1435;
      {
	 obj_t arg1626_1432;
	 obj_t arg1627_1433;
	 {
	    object_t obj_1608;
	    obj_1608 = (object_t) (node_5);
	    {
	       obj_t pre_method_105_1609;
	       pre_method_105_1609 = PROCEDURE_REF(e_env_17_globalize_gn, ((long) 2));
	       if (INTEGERP(pre_method_105_1609))
		 {
		    PROCEDURE_SET(e_env_17_globalize_gn, ((long) 2), BUNSPEC);
		    arg1626_1432 = pre_method_105_1609;
		 }
	       else
		 {
		    long obj_class_num_177_1614;
		    obj_class_num_177_1614 = TYPE(obj_1608);
		    {
		       obj_t arg1183_1615;
		       arg1183_1615 = PROCEDURE_REF(e_env_17_globalize_gn, ((long) 1));
		       {
			  long arg1184_1619;
			  {
			     long arg1186_1620;
			     arg1186_1620 = OBJECT_TYPE;
			     arg1184_1619 = (obj_class_num_177_1614 - arg1186_1620);
			  }
			  arg1626_1432 = VECTOR_REF(arg1183_1615, arg1184_1619);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1625;
	    object_1625 = (object_t) (node_5);
	    {
	       long arg1187_1626;
	       {
		  long arg1188_1627;
		  long arg1189_1628;
		  arg1188_1627 = TYPE(object_1625);
		  arg1189_1628 = OBJECT_TYPE;
		  arg1187_1626 = (arg1188_1627 - arg1189_1628);
	       }
	       {
		  obj_t vector_1632;
		  vector_1632 = __classes__134___object;
		  arg1627_1433 = VECTOR_REF(vector_1632, arg1187_1626);
	       }
	    }
	 }
	 method1618_1434 = arg1626_1432;
	 class1623_1435 = arg1627_1433;
	 {
	    if (INTEGERP(method1618_1434))
	      {
		 switch ((long) CINT(method1618_1434))
		   {
		   case ((long) 0):
		      return g_7;
		      break;
		   case ((long) 1):
		      return g_7;
		      break;
		   case ((long) 2):
		      return g_7;
		      break;
		   case ((long) 3):
		      {
			 variable_t var_1453;
			 {
			    var_t obj_1634;
			    {
			       closure_t aux_1937;
			       aux_1937 = (closure_t) (node_5);
			       obj_1634 = (var_t) (aux_1937);
			    }
			    var_1453 = (((var_t) CREF(obj_1634))->variable);
			 }
			 save_fun__213_globalize_gn(caller_6, var_1453);
			 {
			    bool_t test1630_1454;
			    {
			       bool_t test1633_1456;
			       test1633_1456 = is_a__118___object((obj_t) (var_1453), local_ast_var);
			       if (test1633_1456)
				 {
				    bool_t test_1945;
				    {
				       local_ginfo_108_t obj_1636;
				       obj_1636 = (local_ginfo_108_t) (var_1453);
				       {
					  obj_t aux_1947;
					  {
					     object_t aux_1948;
					     aux_1948 = (object_t) (obj_1636);
					     aux_1947 = OBJECT_WIDENING(aux_1948);
					  }
					  test_1945 = (((local_ginfo_108_t) CREF(aux_1947))->escape__117);
				       }
				    }
				    if (test_1945)
				      {
					 bool_t test_1952;
					 {
					    sfun_ginfo_98_t obj_1638;
					    {
					       value_t aux_1953;
					       {
						  local_t obj_1637;
						  obj_1637 = (local_t) (var_1453);
						  aux_1953 = (((local_t) CREF(obj_1637))->value);
					       }
					       obj_1638 = (sfun_ginfo_98_t) (aux_1953);
					    }
					    {
					       obj_t aux_1957;
					       {
						  object_t aux_1958;
						  aux_1958 = (object_t) (obj_1638);
						  aux_1957 = OBJECT_WIDENING(aux_1958);
					       }
					       test_1952 = (((sfun_ginfo_98_t) CREF(aux_1957))->g__219);
					    }
					 }
					 if (test_1952)
					   {
					      test1630_1454 = ((bool_t) 0);
					   }
					 else
					   {
					      test1630_1454 = ((bool_t) 1);
					   }
				      }
				    else
				      {
					 test1630_1454 = ((bool_t) 0);
				      }
				 }
			       else
				 {
				    test1630_1454 = ((bool_t) 0);
				 }
			    }
			    if (test1630_1454)
			      {
				 {
				    obj_t res1713_1642;
				    {
				       sfun_ginfo_98_t obj_1640;
				       {
					  value_t aux_1963;
					  {
					     local_t obj_1639;
					     obj_1639 = (local_t) (var_1453);
					     aux_1963 = (((local_t) CREF(obj_1639))->value);
					  }
					  obj_1640 = (sfun_ginfo_98_t) (aux_1963);
				       }
				       {
					  obj_t x_1840;
					  {
					     obj_t aux_1967;
					     {
						object_t aux_1968;
						aux_1968 = (object_t) (obj_1640);
						aux_1967 = OBJECT_WIDENING(aux_1968);
					     }
					     x_1840 = ((((sfun_ginfo_98_t) CREF(aux_1967))->g__219) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					  }
					  res1713_1642 = BUNSPEC;
				       }
				    }
				    res1713_1642;
				 }
				 {
				    obj_t aux_1972;
				    aux_1972 = (obj_t) (var_1453);
				    return MAKE_PAIR(aux_1972, g_7);
				 }
			      }
			    else
			      {
				 return g_7;
			      }
			 }
		      }
		      break;
		   case ((long) 4):
		      {
			 sequence_t node_1460;
			 node_1460 = (sequence_t) (node_5);
			 return e__176_globalize_gn((((sequence_t) CREF(node_1460))->nodes), caller_6, g_7);
		      }
		      break;
		   case ((long) 5):
		      {
			 app_t node_1464;
			 node_1464 = (app_t) (node_5);
			 {
			    variable_t aux_1979;
			    {
			       var_t arg1642_1469;
			       arg1642_1469 = (((app_t) CREF(node_1464))->fun);
			       aux_1979 = (((var_t) CREF(arg1642_1469))->variable);
			    }
			    save_app__130_globalize_gn(caller_6, aux_1979);
			 }
			 return e__176_globalize_gn((((app_t) CREF(node_1464))->args), caller_6, g_7);
		      }
		      break;
		   case ((long) 6):
		      {
			 app_ly_162_t node_1471;
			 node_1471 = (app_ly_162_t) (node_5);
			 {
			    node_t arg1644_1475;
			    obj_t arg1645_1476;
			    arg1644_1475 = (((app_ly_162_t) CREF(node_1471))->fun);
			    arg1645_1476 = e_globalize_gn((((app_ly_162_t) CREF(node_1471))->arg), caller_6, g_7);
			    {
			       obj_t g_1990;
			       node_t node_1989;
			       node_1989 = arg1644_1475;
			       g_1990 = arg1645_1476;
			       g_7 = g_1990;
			       node_5 = node_1989;
			       goto e_globalize_gn;
			    }
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 funcall_t node_1478;
			 node_1478 = (funcall_t) (node_5);
			 {
			    node_t arg1647_1482;
			    obj_t arg1648_1483;
			    arg1647_1482 = (((funcall_t) CREF(node_1478))->fun);
			    arg1648_1483 = e__176_globalize_gn((((funcall_t) CREF(node_1478))->args), caller_6, g_7);
			    {
			       obj_t g_1996;
			       node_t node_1995;
			       node_1995 = arg1647_1482;
			       g_1996 = arg1648_1483;
			       g_7 = g_1996;
			       node_5 = node_1995;
			       goto e_globalize_gn;
			    }
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 pragma_t node_1485;
			 node_1485 = (pragma_t) (node_5);
			 return e__176_globalize_gn((((pragma_t) CREF(node_1485))->args), caller_6, g_7);
		      }
		      break;
		   case ((long) 9):
		      {
			 cast_t node_1490;
			 node_1490 = (cast_t) (node_5);
			 {
			    node_t node_2001;
			    node_2001 = (((cast_t) CREF(node_1490))->arg);
			    node_5 = node_2001;
			    goto e_globalize_gn;
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 setq_t node_1495;
			 node_1495 = (setq_t) (node_5);
			 {
			    node_t node_2004;
			    node_2004 = (((setq_t) CREF(node_1495))->value);
			    node_5 = node_2004;
			    goto e_globalize_gn;
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 conditional_t node_1500;
			 node_1500 = (conditional_t) (node_5);
			 {
			    node_t arg1654_1504;
			    obj_t arg1655_1505;
			    arg1654_1504 = (((conditional_t) CREF(node_1500))->test);
			    {
			       node_t arg1656_1506;
			       obj_t arg1657_1507;
			       arg1656_1506 = (((conditional_t) CREF(node_1500))->true);
			       arg1657_1507 = e_globalize_gn((((conditional_t) CREF(node_1500))->false), caller_6, g_7);
			       arg1655_1505 = e_globalize_gn(arg1656_1506, caller_6, arg1657_1507);
			    }
			    {
			       obj_t g_2013;
			       node_t node_2012;
			       node_2012 = arg1654_1504;
			       g_2013 = arg1655_1505;
			       g_7 = g_2013;
			       node_5 = node_2012;
			       goto e_globalize_gn;
			    }
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 fail_t node_1509;
			 node_1509 = (fail_t) (node_5);
			 {
			    node_t arg1661_1513;
			    obj_t arg1663_1514;
			    arg1661_1513 = (((fail_t) CREF(node_1509))->proc);
			    {
			       node_t arg1664_1515;
			       obj_t arg1665_1516;
			       arg1664_1515 = (((fail_t) CREF(node_1509))->msg);
			       arg1665_1516 = e_globalize_gn((((fail_t) CREF(node_1509))->obj), caller_6, g_7);
			       arg1663_1514 = e_globalize_gn(arg1664_1515, caller_6, arg1665_1516);
			    }
			    {
			       obj_t g_2021;
			       node_t node_2020;
			       node_2020 = arg1661_1513;
			       g_2021 = arg1663_1514;
			       g_7 = g_2021;
			       node_5 = node_2020;
			       goto e_globalize_gn;
			    }
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 select_t node_1518;
			 node_1518 = (select_t) (node_5);
			 {
			    obj_t clauses_1522;
			    obj_t g_1523;
			    clauses_1522 = (((select_t) CREF(node_1518))->clauses);
			    g_1523 = g_7;
			  loop_1524:
			    if (NULLP(clauses_1522))
			      {
				 obj_t g_2027;
				 node_t node_2025;
				 node_2025 = (((select_t) CREF(node_1518))->test);
				 g_2027 = g_1523;
				 g_7 = g_2027;
				 node_5 = node_2025;
				 goto e_globalize_gn;
			      }
			    else
			      {
				 obj_t arg1673_1528;
				 obj_t arg1674_1529;
				 arg1673_1528 = CDR(clauses_1522);
				 {
				    node_t aux_2029;
				    {
				       obj_t aux_2030;
				       {
					  obj_t aux_2031;
					  aux_2031 = CAR(clauses_1522);
					  aux_2030 = CDR(aux_2031);
				       }
				       aux_2029 = (node_t) (aux_2030);
				    }
				    arg1674_1529 = e_globalize_gn(aux_2029, caller_6, g_1523);
				 }
				 {
				    obj_t g_2037;
				    obj_t clauses_2036;
				    clauses_2036 = arg1673_1528;
				    g_2037 = arg1674_1529;
				    g_1523 = g_2037;
				    clauses_1522 = clauses_2036;
				    goto loop_1524;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 let_fun_218_t node_1532;
			 node_1532 = (let_fun_218_t) (node_5);
			 {
			    obj_t locals_1536;
			    obj_t g_1537;
			    locals_1536 = (((let_fun_218_t) CREF(node_1532))->locals);
			    g_1537 = g_7;
			  loop_1538:
			    if (NULLP(locals_1536))
			      {
				 obj_t g_2044;
				 node_t node_2042;
				 node_2042 = (((let_fun_218_t) CREF(node_1532))->body);
				 g_2044 = g_1537;
				 g_7 = g_2044;
				 node_5 = node_2042;
				 goto e_globalize_gn;
			      }
			    else
			      {
				 obj_t arg1682_1542;
				 obj_t arg1684_1543;
				 arg1682_1542 = CDR(locals_1536);
				 {
				    variable_t aux_2056;
				    node_t aux_2046;
				    {
				       obj_t aux_2057;
				       aux_2057 = CAR(locals_1536);
				       aux_2056 = (variable_t) (aux_2057);
				    }
				    {
				       obj_t aux_2047;
				       {
					  sfun_t obj_1674;
					  {
					     value_t aux_2048;
					     {
						local_t obj_1673;
						{
						   obj_t aux_2049;
						   aux_2049 = CAR(locals_1536);
						   obj_1673 = (local_t) (aux_2049);
						}
						aux_2048 = (((local_t) CREF(obj_1673))->value);
					     }
					     obj_1674 = (sfun_t) (aux_2048);
					  }
					  aux_2047 = (((sfun_t) CREF(obj_1674))->body);
				       }
				       aux_2046 = (node_t) (aux_2047);
				    }
				    arg1684_1543 = e_globalize_gn(aux_2046, aux_2056, g_1537);
				 }
				 {
				    obj_t g_2062;
				    obj_t locals_2061;
				    locals_2061 = arg1682_1542;
				    g_2062 = arg1684_1543;
				    g_1537 = g_2062;
				    locals_1536 = locals_2061;
				    goto loop_1538;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 let_var_6_t node_1548;
			 node_1548 = (let_var_6_t) (node_5);
			 {
			    obj_t bindings_1552;
			    obj_t g_1553;
			    bindings_1552 = (((let_var_6_t) CREF(node_1548))->bindings);
			    g_1553 = g_7;
			  loop_1554:
			    if (NULLP(bindings_1552))
			      {
				 obj_t g_2069;
				 node_t node_2067;
				 node_2067 = (((let_var_6_t) CREF(node_1548))->body);
				 g_2069 = g_1553;
				 g_7 = g_2069;
				 node_5 = node_2067;
				 goto e_globalize_gn;
			      }
			    else
			      {
				 obj_t arg1694_1558;
				 obj_t arg1695_1559;
				 arg1694_1558 = CDR(bindings_1552);
				 {
				    node_t aux_2071;
				    {
				       obj_t aux_2072;
				       {
					  obj_t aux_2073;
					  aux_2073 = CAR(bindings_1552);
					  aux_2072 = CDR(aux_2073);
				       }
				       aux_2071 = (node_t) (aux_2072);
				    }
				    arg1695_1559 = e_globalize_gn(aux_2071, caller_6, g_1553);
				 }
				 {
				    obj_t g_2079;
				    obj_t bindings_2078;
				    bindings_2078 = arg1694_1558;
				    g_2079 = arg1695_1559;
				    g_1553 = g_2079;
				    bindings_1552 = bindings_2078;
				    goto loop_1554;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 set_ex_it_116_t node_1562;
			 node_1562 = (set_ex_it_116_t) (node_5);
			 {
			    node_t node_2082;
			    node_2082 = (((set_ex_it_116_t) CREF(node_1562))->body);
			    node_5 = node_2082;
			    goto e_globalize_gn;
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 jump_ex_it_184_t node_1567;
			 node_1567 = (jump_ex_it_184_t) (node_5);
			 {
			    node_t arg1699_1571;
			    obj_t arg1701_1572;
			    arg1699_1571 = (((jump_ex_it_184_t) CREF(node_1567))->exit);
			    arg1701_1572 = e_globalize_gn((((jump_ex_it_184_t) CREF(node_1567))->value), caller_6, g_7);
			    {
			       obj_t g_2089;
			       node_t node_2088;
			       node_2088 = arg1699_1571;
			       g_2089 = arg1701_1572;
			       g_7 = g_2089;
			       node_5 = node_2088;
			       goto e_globalize_gn;
			    }
			 }
		      }
		      break;
		   case ((long) 18):
		      {
			 make_box_202_t node_1574;
			 node_1574 = (make_box_202_t) (node_5);
			 {
			    node_t node_2091;
			    node_2091 = (((make_box_202_t) CREF(node_1574))->value);
			    node_5 = node_2091;
			    goto e_globalize_gn;
			 }
		      }
		      break;
		   case ((long) 19):
		      {
			 box_ref_242_t node_1579;
			 node_1579 = (box_ref_242_t) (node_5);
			 {
			    node_t node_2094;
			    {
			       var_t aux_2095;
			       aux_2095 = (((box_ref_242_t) CREF(node_1579))->var);
			       node_2094 = (node_t) (aux_2095);
			    }
			    node_5 = node_2094;
			    goto e_globalize_gn;
			 }
		      }
		      break;
		   case ((long) 20):
		      {
			 box_set__221_t node_1584;
			 node_1584 = (box_set__221_t) (node_5);
			 {
			    var_t arg1705_1588;
			    obj_t arg1706_1589;
			    arg1705_1588 = (((box_set__221_t) CREF(node_1584))->var);
			    arg1706_1589 = e_globalize_gn((((box_set__221_t) CREF(node_1584))->value), caller_6, g_7);
			    {
			       obj_t g_2104;
			       node_t node_2102;
			       node_2102 = (node_t) (arg1705_1588);
			       g_2104 = arg1706_1589;
			       g_7 = g_2104;
			       node_5 = node_2102;
			       goto e_globalize_gn;
			    }
			 }
		      }
		      break;
		   default:
		    case_else1624_30_1438:
		      if (PROCEDUREP(method1618_1434))
			{
			   return PROCEDURE_ENTRY(method1618_1434) (method1618_1434, (obj_t) (node_5), (obj_t) (caller_6), g_7, BEOA);
			}
		      else
			{
			   obj_t fun1433_1003;
			   fun1433_1003 = PROCEDURE_REF(e_env_17_globalize_gn, ((long) 0));
			   return PROCEDURE_ENTRY(fun1433_1003) (fun1433_1003, (obj_t) (node_5), (obj_t) (caller_6), g_7, BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1624_30_1438;
	      }
	 }
      }
   }
}


obj_t 
_e_globalize_gn(obj_t env_1827, obj_t node_1828, obj_t caller_1829, obj_t g_1830)
{
   return e_globalize_gn((node_t) (node_1828), (variable_t) (caller_1829), g_1830);
}


obj_t 
e__176_globalize_gn(obj_t node__221_74, variable_t caller_75, obj_t g_76)
{
   {
      obj_t node__221_1004;
      obj_t g_1005;
      node__221_1004 = node__221_74;
      g_1005 = g_76;
    loop_1006:
      if (NULLP(node__221_1004))
	{
	   return g_1005;
	}
      else
	{
	   obj_t arg1440_1008;
	   obj_t arg1441_1009;
	   arg1440_1008 = CDR(node__221_1004);
	   {
	      node_t aux_2124;
	      {
		 obj_t aux_2125;
		 aux_2125 = CAR(node__221_1004);
		 aux_2124 = (node_t) (aux_2125);
	      }
	      arg1441_1009 = e_globalize_gn(aux_2124, caller_75, g_1005);
	   }
	   {
	      obj_t g_2130;
	      obj_t node__221_2129;
	      node__221_2129 = arg1440_1008;
	      g_2130 = arg1441_1009;
	      g_1005 = g_2130;
	      node__221_1004 = node__221_2129;
	      goto loop_1006;
	   }
	}
   }
}


obj_t 
save_app__130_globalize_gn(variable_t caller_77, variable_t callee_78)
{
   {
      bool_t test1445_1011;
      test1445_1011 = is_a__118___object((obj_t) (callee_78), global_ast_var);
      if (test1445_1011)
	{
	   return CNST_TABLE_REF(((long) 1));
	}
      else
	{
	   value_t callee_info_105_1012;
	   {
	      local_t obj_1695;
	      obj_1695 = (local_t) (callee_78);
	      callee_info_105_1012 = (((local_t) CREF(obj_1695))->value);
	   }
	   {
	      bool_t test_2137;
	      {
		 obj_t aux_2138;
		 {
		    obj_t aux_2139;
		    {
		       sfun_ginfo_98_t obj_1696;
		       obj_1696 = (sfun_ginfo_98_t) (callee_info_105_1012);
		       {
			  obj_t aux_2142;
			  {
			     object_t aux_2143;
			     aux_2143 = (object_t) (obj_1696);
			     aux_2142 = OBJECT_WIDENING(aux_2143);
			  }
			  aux_2139 = (((sfun_ginfo_98_t) CREF(aux_2142))->cfrom);
		       }
		    }
		    aux_2138 = memq___r4_pairs_and_lists_6_3((obj_t) (caller_77), aux_2139);
		 }
		 test_2137 = CBOOL(aux_2138);
	      }
	      if (test_2137)
		{
		   BUNSPEC;
		}
	      else
		{
		   {
		      obj_t arg1447_1014;
		      {
			 obj_t aux_2151;
			 obj_t aux_2149;
			 {
			    sfun_ginfo_98_t obj_1697;
			    obj_1697 = (sfun_ginfo_98_t) (callee_info_105_1012);
			    {
			       obj_t aux_2153;
			       {
				  object_t aux_2154;
				  aux_2154 = (object_t) (obj_1697);
				  aux_2153 = OBJECT_WIDENING(aux_2154);
			       }
			       aux_2151 = (((sfun_ginfo_98_t) CREF(aux_2153))->cfrom);
			    }
			 }
			 aux_2149 = (obj_t) (caller_77);
			 arg1447_1014 = MAKE_PAIR(aux_2149, aux_2151);
		      }
		      {
			 obj_t res1715_1702;
			 {
			    sfun_ginfo_98_t obj_1700;
			    obj_1700 = (sfun_ginfo_98_t) (callee_info_105_1012);
			    {
			       obj_t x_1841;
			       {
				  obj_t aux_2160;
				  {
				     object_t aux_2161;
				     aux_2161 = (object_t) (obj_1700);
				     aux_2160 = OBJECT_WIDENING(aux_2161);
				  }
				  x_1841 = ((((sfun_ginfo_98_t) CREF(aux_2160))->cfrom) = ((obj_t) arg1447_1014), BUNSPEC);
			       }
			       res1715_1702 = BUNSPEC;
			    }
			 }
			 res1715_1702;
		      }
		   }
		   {
		      bool_t test1449_1016;
		      test1449_1016 = is_a__118___object((obj_t) (caller_77), local_ast_var);
		      if (test1449_1016)
			{
			   value_t caller_info_12_1017;
			   {
			      local_t obj_1704;
			      obj_1704 = (local_t) (caller_77);
			      caller_info_12_1017 = (((local_t) CREF(obj_1704))->value);
			   }
			   {
			      obj_t arg1450_1018;
			      {
				 obj_t aux_2172;
				 obj_t aux_2170;
				 {
				    sfun_ginfo_98_t obj_1705;
				    obj_1705 = (sfun_ginfo_98_t) (caller_info_12_1017);
				    {
				       obj_t aux_2174;
				       {
					  object_t aux_2175;
					  aux_2175 = (object_t) (obj_1705);
					  aux_2174 = OBJECT_WIDENING(aux_2175);
				       }
				       aux_2172 = (((sfun_ginfo_98_t) CREF(aux_2174))->cto);
				    }
				 }
				 aux_2170 = (obj_t) (callee_78);
				 arg1450_1018 = MAKE_PAIR(aux_2170, aux_2172);
			      }
			      {
				 obj_t res1716_1710;
				 {
				    sfun_ginfo_98_t obj_1708;
				    obj_1708 = (sfun_ginfo_98_t) (caller_info_12_1017);
				    {
				       obj_t x_1842;
				       {
					  obj_t aux_2181;
					  {
					     object_t aux_2182;
					     aux_2182 = (object_t) (obj_1708);
					     aux_2181 = OBJECT_WIDENING(aux_2182);
					  }
					  x_1842 = ((((sfun_ginfo_98_t) CREF(aux_2181))->cto) = ((obj_t) arg1450_1018), BUNSPEC);
				       }
				       res1716_1710 = BUNSPEC;
				    }
				 }
				 res1716_1710;
			      }
			   }
			}
		      else
			{
			   BUNSPEC;
			}
		   }
		}
	   }
	   return CNST_TABLE_REF(((long) 1));
	}
   }
}


obj_t 
save_fun__213_globalize_gn(variable_t caller_79, variable_t callee_80)
{
   {
      bool_t test1454_1021;
      {
	 bool_t test1478_1040;
	 test1478_1040 = is_a__118___object((obj_t) (caller_79), global_ast_var);
	 if (test1478_1040)
	   {
	      test1454_1021 = ((bool_t) 1);
	   }
	 else
	   {
	      test1454_1021 = is_a__118___object((obj_t) (callee_80), global_ast_var);
	   }
      }
      if (test1454_1021)
	{
	   return CNST_TABLE_REF(((long) 1));
	}
      else
	{
	   value_t caller_info_12_1022;
	   {
	      local_t obj_1713;
	      obj_1713 = (local_t) (caller_79);
	      caller_info_12_1022 = (((local_t) CREF(obj_1713))->value);
	   }
	   {
	      bool_t test1455_1023;
	      {
		 obj_t aux_2196;
		 aux_2196 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 2)), BINT(((long) 3)));
		 test1455_1023 = CBOOL(aux_2196);
	      }
	      if (test1455_1023)
		{
		   obj_t arg1458_1025;
		   obj_t arg1463_1027;
		   arg1458_1025 = shape_tools_shape((obj_t) (caller_79));
		   arg1463_1027 = shape_tools_shape((obj_t) (callee_80));
		   {
		      obj_t list1464_1028;
		      {
			 obj_t arg1465_1029;
			 {
			    obj_t arg1466_1030;
			    {
			       obj_t arg1467_1031;
			       {
				  obj_t arg1468_1032;
				  {
				     obj_t aux_2206;
				     aux_2206 = BCHAR(((unsigned char) '\n'));
				     arg1468_1032 = MAKE_PAIR(aux_2206, BNIL);
				  }
				  arg1467_1031 = MAKE_PAIR(arg1463_1027, arg1468_1032);
			       }
			       arg1466_1030 = MAKE_PAIR(string1720_globalize_gn, arg1467_1031);
			    }
			    arg1465_1029 = MAKE_PAIR(arg1458_1025, arg1466_1030);
			 }
			 list1464_1028 = MAKE_PAIR(string1721_globalize_gn, arg1465_1029);
		      }
		      print_trace_107_tools_trace(list1464_1028);
		   }
		}
	      else
		{
		   BUNSPEC;
		}
	   }
	   {
	      bool_t test_2214;
	      {
		 obj_t aux_2215;
		 {
		    obj_t aux_2216;
		    {
		       sfun_ginfo_98_t obj_1714;
		       obj_1714 = (sfun_ginfo_98_t) (caller_info_12_1022);
		       {
			  obj_t aux_2219;
			  {
			     object_t aux_2220;
			     aux_2220 = (object_t) (obj_1714);
			     aux_2219 = OBJECT_WIDENING(aux_2220);
			  }
			  aux_2216 = (((sfun_ginfo_98_t) CREF(aux_2219))->cfunction);
		       }
		    }
		    aux_2215 = memq___r4_pairs_and_lists_6_3((obj_t) (callee_80), aux_2216);
		 }
		 test_2214 = CBOOL(aux_2215);
	      }
	      if (test_2214)
		{
		   BUNSPEC;
		}
	      else
		{
		   obj_t arg1474_1037;
		   {
		      obj_t aux_2228;
		      obj_t aux_2226;
		      {
			 sfun_ginfo_98_t obj_1715;
			 obj_1715 = (sfun_ginfo_98_t) (caller_info_12_1022);
			 {
			    obj_t aux_2230;
			    {
			       object_t aux_2231;
			       aux_2231 = (object_t) (obj_1715);
			       aux_2230 = OBJECT_WIDENING(aux_2231);
			    }
			    aux_2228 = (((sfun_ginfo_98_t) CREF(aux_2230))->cfunction);
			 }
		      }
		      aux_2226 = (obj_t) (callee_80);
		      arg1474_1037 = MAKE_PAIR(aux_2226, aux_2228);
		   }
		   {
		      obj_t res1717_1720;
		      {
			 sfun_ginfo_98_t obj_1718;
			 obj_1718 = (sfun_ginfo_98_t) (caller_info_12_1022);
			 {
			    obj_t x_1843;
			    {
			       obj_t aux_2237;
			       {
				  object_t aux_2238;
				  aux_2238 = (object_t) (obj_1718);
				  aux_2237 = OBJECT_WIDENING(aux_2238);
			       }
			       x_1843 = ((((sfun_ginfo_98_t) CREF(aux_2237))->cfunction) = ((obj_t) arg1474_1037), BUNSPEC);
			    }
			    res1717_1720 = BUNSPEC;
			 }
		      }
		      res1717_1720;
		   }
		}
	   }
	   return CNST_TABLE_REF(((long) 1));
	}
   }
}


obj_t 
g_from_cto_7_globalize_gn(obj_t local_81)
{
   {
      obj_t cto_1041;
      obj_t g_1042;
      {
	 sfun_ginfo_98_t obj_1722;
	 {
	    value_t aux_2276;
	    {
	       local_t obj_1721;
	       obj_1721 = (local_t) (local_81);
	       aux_2276 = (((local_t) CREF(obj_1721))->value);
	    }
	    obj_1722 = (sfun_ginfo_98_t) (aux_2276);
	 }
	 {
	    obj_t aux_2280;
	    {
	       object_t aux_2281;
	       aux_2281 = (object_t) (obj_1722);
	       aux_2280 = OBJECT_WIDENING(aux_2281);
	    }
	    cto_1041 = (((sfun_ginfo_98_t) CREF(aux_2280))->cto);
	 }
      }
      g_1042 = BNIL;
    loop_1043:
      if (NULLP(cto_1041))
	{
	   return g_1042;
	}
      else
	{
	   bool_t test_2245;
	   {
	      sfun_ginfo_98_t obj_1726;
	      {
		 value_t aux_2246;
		 {
		    local_t obj_1725;
		    {
		       obj_t aux_2247;
		       aux_2247 = CAR(cto_1041);
		       obj_1725 = (local_t) (aux_2247);
		    }
		    aux_2246 = (((local_t) CREF(obj_1725))->value);
		 }
		 obj_1726 = (sfun_ginfo_98_t) (aux_2246);
	      }
	      {
		 obj_t aux_2252;
		 {
		    object_t aux_2253;
		    aux_2253 = (object_t) (obj_1726);
		    aux_2252 = OBJECT_WIDENING(aux_2253);
		 }
		 test_2245 = (((sfun_ginfo_98_t) CREF(aux_2252))->g__219);
	      }
	   }
	   if (test_2245)
	     {
		{
		   obj_t cto_2257;
		   cto_2257 = CDR(cto_1041);
		   cto_1041 = cto_2257;
		   goto loop_1043;
		}
	     }
	   else
	     {
		{
		   obj_t res1718_1732;
		   {
		      sfun_ginfo_98_t obj_1730;
		      {
			 value_t aux_2259;
			 {
			    local_t obj_1729;
			    {
			       obj_t aux_2260;
			       aux_2260 = CAR(cto_1041);
			       obj_1729 = (local_t) (aux_2260);
			    }
			    aux_2259 = (((local_t) CREF(obj_1729))->value);
			 }
			 obj_1730 = (sfun_ginfo_98_t) (aux_2259);
		      }
		      {
			 obj_t x_1844;
			 {
			    obj_t aux_2265;
			    {
			       object_t aux_2266;
			       aux_2266 = (object_t) (obj_1730);
			       aux_2265 = OBJECT_WIDENING(aux_2266);
			    }
			    x_1844 = ((((sfun_ginfo_98_t) CREF(aux_2265))->g__219) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			 }
			 res1718_1732 = BUNSPEC;
		      }
		   }
		   res1718_1732;
		}
		{
		   obj_t arg1493_1052;
		   obj_t arg1494_1053;
		   arg1493_1052 = CDR(cto_1041);
		   {
		      obj_t aux_2271;
		      aux_2271 = CAR(cto_1041);
		      arg1494_1053 = MAKE_PAIR(aux_2271, g_1042);
		   }
		   {
		      obj_t g_2275;
		      obj_t cto_2274;
		      cto_2274 = arg1493_1052;
		      g_2275 = arg1494_1053;
		      g_1042 = g_2275;
		      cto_1041 = cto_2274;
		      goto loop_1043;
		   }
		}
	     }
	}
   }
}


obj_t 
imported_modules_init_94_globalize_gn()
{
   module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_GN");
   module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_GN");
   module_initialization_70_type_type(((long) 0), "GLOBALIZE_GN");
   module_initialization_70_ast_var(((long) 0), "GLOBALIZE_GN");
   module_initialization_70_ast_node(((long) 0), "GLOBALIZE_GN");
   module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_GN");
   return module_initialization_70_globalize_globalize(((long) 0), "GLOBALIZE_GN");
}
