/*===========================================================================*/
/*   (Globalize/integration.scm)                                             */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_t;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_t;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_t;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_t;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_t;


extern obj_t _set_integration__157_globalize_integration(obj_t);
static obj_t get_new_tg_254_globalize_integration(obj_t, obj_t, long);
static obj_t get_new_fg_250_globalize_integration(obj_t, long);
extern obj_t global_ast_var;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_globalize_integration();
extern obj_t module_initialization_70_globalize_integration(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_globalize(long, char *);
extern obj_t module_initialization_70_globalize_kapture(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t cnst_init_137_globalize_integration();
static obj_t set_cfrom___159_globalize_integration(local_t);
extern obj_t union_3_globalize_kapture(obj_t);
static obj_t require_initialization_114_globalize_integration = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
extern obj_t __e__34_globalize_globalize;
static obj_t set_integrators__120_globalize_integration(obj_t, obj_t, long);
static obj_t library_modules_init_112_globalize_integration();
static obj_t get_integrator_6_globalize_integration(obj_t);
extern obj_t __g1__181_globalize_globalize;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t set_integration__52_globalize_integration();
extern obj_t local_ast_var;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t __cnst[2];

DEFINE_STRING(string1771_globalize_integration, string1771_globalize_integration1781, "     cfrom*( ", 13);
DEFINE_STRING(string1774_globalize_integration, string1774_globalize_integration1782, "set-integrators: ", 17);
DEFINE_STRING(string1770_globalize_integration, string1770_globalize_integration1783, " ): ", 4);
DEFINE_STRING(string1765_globalize_integration, string1765_globalize_integration1784, "looping on: ", 12);
DEFINE_STRING(string1763_globalize_integration, string1763_globalize_integration1785, "set-integration!", 16);
DEFINE_STRING(string1775_globalize_integration, string1775_globalize_integration1786, "DONE GLOBALIZE ", 15);
DEFINE_STRING(string1764_globalize_integration, string1764_globalize_integration1787, " ", 1);
DEFINE_STRING(string1772_globalize_integration, string1772_globalize_integration1788, " ... ", 5);
DEFINE_STRING(string1773_globalize_integration, string1773_globalize_integration1789, "      get-new-tg: ", 18);
DEFINE_STRING(string1767_globalize_integration, string1767_globalize_integration1790, "  set-integration!    tg: ", 26);
DEFINE_EXPORT_PROCEDURE(set_integration__env_59_globalize_integration, _set_integration__157_globalize_integration1791, _set_integration__157_globalize_integration, 0L, 0);
DEFINE_STRING(string1766_globalize_integration, string1766_globalize_integration1792, "                      fg: ", 26);
DEFINE_STRING(string1768_globalize_integration, string1768_globalize_integration1793, "     new-tg: ", 13);
DEFINE_STRING(string1769_globalize_integration, string1769_globalize_integration1794, "     new-fg: ", 13);

obj_t 
module_initialization_70_globalize_integration(long checksum_1783, char *from_1784)
{
   if (CBOOL(require_initialization_114_globalize_integration))
     {
	require_initialization_114_globalize_integration = BBOOL(((bool_t) 0));
	library_modules_init_112_globalize_integration();
	cnst_init_137_globalize_integration();
	imported_modules_init_94_globalize_integration();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_globalize_integration()
{
   module_initialization_70___object(((long) 0), "GLOBALIZE_INTEGRATION");
   module_initialization_70___reader(((long) 0), "GLOBALIZE_INTEGRATION");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_INTEGRATION");
   return BUNSPEC;
}


obj_t 
cnst_init_137_globalize_integration()
{
   {
      obj_t cnst_port_138_1775;
      cnst_port_138_1775 = open_input_string(string1775_globalize_integration);
      {
	 long i_1776;
	 i_1776 = ((long) 1);
       loop_1777:
	 {
	    bool_t test1776_1778;
	    test1776_1778 = (i_1776 == ((long) -1));
	    if (test1776_1778)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1777_1779;
		    {
		       obj_t list1778_1780;
		       {
			  obj_t arg1779_1781;
			  arg1779_1781 = BNIL;
			  list1778_1780 = MAKE_PAIR(cnst_port_138_1775, arg1779_1781);
		       }
		       arg1777_1779 = read___reader(list1778_1780);
		    }
		    CNST_TABLE_SET(i_1776, arg1777_1779);
		 }
		 {
		    int aux_1782;
		    {
		       long aux_1800;
		       aux_1800 = (i_1776 - ((long) 1));
		       aux_1782 = (int) (aux_1800);
		    }
		    {
		       long i_1803;
		       i_1803 = (long) (aux_1782);
		       i_1776 = i_1803;
		       goto loop_1777;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
set_integration__52_globalize_integration()
{
   {
      bool_t test1377_920;
      {
	 obj_t aux_1805;
	 aux_1805 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1377_920 = CBOOL(aux_1805);
      }
      if (test1377_920)
	{
	   obj_t list1378_921;
	   {
	      obj_t arg1380_923;
	      {
		 obj_t aux_1811;
		 aux_1811 = BCHAR(((unsigned char) '\n'));
		 arg1380_923 = MAKE_PAIR(aux_1811, BNIL);
	      }
	      list1378_921 = MAKE_PAIR(string1763_globalize_integration, arg1380_923);
	   }
	   print_trace_107_tools_trace(list1378_921);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t l1369_927;
      l1369_927 = __e__34_globalize_globalize;
    lname1370_928:
      if (PAIRP(l1369_927))
	{
	   {
	      local_t aux_1818;
	      {
		 obj_t aux_1819;
		 aux_1819 = CAR(l1369_927);
		 aux_1818 = (local_t) (aux_1819);
	      }
	      set_cfrom___159_globalize_integration(aux_1818);
	   }
	   {
	      obj_t l1369_1823;
	      l1369_1823 = CDR(l1369_927);
	      l1369_927 = l1369_1823;
	      goto lname1370_928;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      obj_t l1371_932;
      l1371_932 = __g1__181_globalize_globalize;
    lname1373_933:
      if (PAIRP(l1371_932))
	{
	   {
	      local_t aux_1827;
	      {
		 obj_t aux_1828;
		 aux_1828 = CAR(l1371_932);
		 aux_1827 = (local_t) (aux_1828);
	      }
	      set_cfrom___159_globalize_integration(aux_1827);
	   }
	   {
	      obj_t l1371_1832;
	      l1371_1832 = CDR(l1371_932);
	      l1371_932 = l1371_1832;
	      goto lname1373_933;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      bool_t test1399_937;
      {
	 obj_t aux_1834;
	 aux_1834 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1399_937 = CBOOL(aux_1834);
      }
      if (test1399_937)
	{
	   obj_t arg1402_939;
	   obj_t arg1404_941;
	   arg1402_939 = shape_tools_shape(__e__34_globalize_globalize);
	   arg1404_941 = shape_tools_shape(__g1__181_globalize_globalize);
	   {
	      obj_t list1405_942;
	      {
		 obj_t arg1406_943;
		 {
		    obj_t arg1408_944;
		    {
		       obj_t arg1410_945;
		       {
			  obj_t arg1411_946;
			  {
			     obj_t aux_1842;
			     aux_1842 = BCHAR(((unsigned char) '\n'));
			     arg1411_946 = MAKE_PAIR(aux_1842, BNIL);
			  }
			  arg1410_945 = MAKE_PAIR(arg1404_941, arg1411_946);
		       }
		       arg1408_944 = MAKE_PAIR(string1764_globalize_integration, arg1410_945);
		    }
		    arg1406_943 = MAKE_PAIR(arg1402_939, arg1408_944);
		 }
		 list1405_942 = MAKE_PAIR(string1765_globalize_integration, arg1406_943);
	      }
	      print_trace_107_tools_trace(list1405_942);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t tg_950;
      obj_t fg_951;
      long round_952;
      tg_950 = __e__34_globalize_globalize;
      fg_951 = __g1__181_globalize_globalize;
      round_952 = ((long) 0);
    loop_953:
      {
	 bool_t test1416_954;
	 {
	    obj_t aux_1850;
	    aux_1850 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	    test1416_954 = CBOOL(aux_1850);
	 }
	 if (test1416_954)
	   {
	      obj_t arg1418_956;
	      obj_t arg1421_958;
	      arg1418_956 = shape_tools_shape(tg_950);
	      arg1421_958 = shape_tools_shape(fg_951);
	      {
		 obj_t list1422_959;
		 {
		    obj_t arg1424_960;
		    {
		       obj_t arg1426_961;
		       {
			  obj_t arg1427_962;
			  {
			     obj_t arg1428_963;
			     {
				obj_t arg1431_964;
				{
				   obj_t aux_1858;
				   aux_1858 = BCHAR(((unsigned char) '\n'));
				   arg1431_964 = MAKE_PAIR(aux_1858, BNIL);
				}
				arg1428_963 = MAKE_PAIR(arg1421_958, arg1431_964);
			     }
			     arg1427_962 = MAKE_PAIR(string1766_globalize_integration, arg1428_963);
			  }
			  {
			     obj_t aux_1863;
			     aux_1863 = BCHAR(((unsigned char) '\n'));
			     arg1426_961 = MAKE_PAIR(aux_1863, arg1427_962);
			  }
		       }
		       arg1424_960 = MAKE_PAIR(arg1418_956, arg1426_961);
		    }
		    list1422_959 = MAKE_PAIR(string1767_globalize_integration, arg1424_960);
		 }
		 print_trace_107_tools_trace(list1422_959);
	      }
	   }
	 else
	   {
	      BUNSPEC;
	   }
      }
      {
	 obj_t l1374_968;
	 l1374_968 = tg_950;
       lname1376_969:
	 if (PAIRP(l1374_968))
	   {
	      {
		 obj_t res1756_1545;
		 {
		    sfun_ginfo_98_t obj_1543;
		    {
		       value_t aux_1871;
		       {
			  local_t obj_1542;
			  {
			     obj_t aux_1872;
			     aux_1872 = CAR(l1374_968);
			     obj_1542 = (local_t) (aux_1872);
			  }
			  aux_1871 = (((local_t) CREF(obj_1542))->value);
		       }
		       obj_1543 = (sfun_ginfo_98_t) (aux_1871);
		    }
		    {
		       obj_t x_1768;
		       {
			  obj_t aux_1877;
			  {
			     object_t aux_1878;
			     aux_1878 = (object_t) (obj_1543);
			     aux_1877 = OBJECT_WIDENING(aux_1878);
			  }
			  x_1768 = ((((sfun_ginfo_98_t) CREF(aux_1877))->mark) = ((long) round_952), BUNSPEC);
		       }
		       res1756_1545 = BUNSPEC;
		    }
		 }
		 res1756_1545;
	      }
	      {
		 obj_t l1374_1882;
		 l1374_1882 = CDR(l1374_968);
		 l1374_968 = l1374_1882;
		 goto lname1376_969;
	      }
	   }
	 else
	   {
	      ((bool_t) 1);
	   }
      }
      {
	 obj_t new_tg_10_974;
	 new_tg_10_974 = get_new_tg_254_globalize_integration(tg_950, fg_951, round_952);
	 {
	    bool_t test1446_975;
	    {
	       obj_t aux_1885;
	       aux_1885 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	       test1446_975 = CBOOL(aux_1885);
	    }
	    if (test1446_975)
	      {
		 obj_t arg1448_977;
		 arg1448_977 = shape_tools_shape(new_tg_10_974);
		 {
		    obj_t list1449_978;
		    {
		       obj_t arg1450_979;
		       {
			  obj_t arg1452_980;
			  {
			     obj_t aux_1892;
			     aux_1892 = BCHAR(((unsigned char) '\n'));
			     arg1452_980 = MAKE_PAIR(aux_1892, BNIL);
			  }
			  arg1450_979 = MAKE_PAIR(arg1448_977, arg1452_980);
		       }
		       list1449_978 = MAKE_PAIR(string1768_globalize_integration, arg1450_979);
		    }
		    print_trace_107_tools_trace(list1449_978);
		 }
	      }
	    else
	      {
		 BUNSPEC;
	      }
	 }
	 if (NULLP(new_tg_10_974))
	   {
	      return set_integrators__120_globalize_integration(tg_950, fg_951, round_952);
	   }
	 else
	   {
	      obj_t new_fg_180_985;
	      new_fg_180_985 = get_new_fg_250_globalize_integration(fg_951, round_952);
	      {
		 bool_t test1459_986;
		 {
		    obj_t aux_1902;
		    aux_1902 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
		    test1459_986 = CBOOL(aux_1902);
		 }
		 if (test1459_986)
		   {
		      obj_t arg1463_988;
		      arg1463_988 = shape_tools_shape(new_fg_180_985);
		      {
			 obj_t list1464_989;
			 {
			    obj_t arg1465_990;
			    {
			       obj_t arg1466_991;
			       {
				  obj_t aux_1909;
				  aux_1909 = BCHAR(((unsigned char) '\n'));
				  arg1466_991 = MAKE_PAIR(aux_1909, BNIL);
			       }
			       arg1465_990 = MAKE_PAIR(arg1463_988, arg1466_991);
			    }
			    list1464_989 = MAKE_PAIR(string1769_globalize_integration, arg1465_990);
			 }
			 print_trace_107_tools_trace(list1464_989);
		      }
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	      {
		 long round_1918;
		 obj_t fg_1917;
		 obj_t tg_1915;
		 tg_1915 = append_2_18___r4_pairs_and_lists_6_3(new_tg_10_974, tg_950);
		 fg_1917 = new_fg_180_985;
		 round_1918 = (round_952 + ((long) 1));
		 round_952 = round_1918;
		 fg_951 = fg_1917;
		 tg_950 = tg_1915;
		 goto loop_953;
	      }
	   }
      }
   }
}


obj_t 
_set_integration__157_globalize_integration(obj_t env_1767)
{
   return set_integration__52_globalize_integration();
}


obj_t 
set_cfrom___159_globalize_integration(local_t local_1)
{
   {
      value_t info_997;
      info_997 = (((local_t) CREF(local_1))->value);
      {
	 bool_t test_1922;
	 {
	    bool_t test_1923;
	    {
	       obj_t aux_1924;
	       {
		  sfun_ginfo_98_t obj_1551;
		  obj_1551 = (sfun_ginfo_98_t) (info_997);
		  {
		     obj_t aux_1926;
		     {
			object_t aux_1927;
			aux_1927 = (object_t) (obj_1551);
			aux_1926 = OBJECT_WIDENING(aux_1927);
		     }
		     aux_1924 = (((sfun_ginfo_98_t) CREF(aux_1926))->cfrom__119);
		  }
	       }
	       test_1923 = PAIRP(aux_1924);
	    }
	    if (test_1923)
	      {
		 test_1922 = ((bool_t) 1);
	      }
	    else
	      {
		 obj_t aux_1932;
		 {
		    sfun_ginfo_98_t obj_1553;
		    obj_1553 = (sfun_ginfo_98_t) (info_997);
		    {
		       obj_t aux_1934;
		       {
			  object_t aux_1935;
			  aux_1935 = (object_t) (obj_1553);
			  aux_1934 = OBJECT_WIDENING(aux_1935);
		       }
		       aux_1932 = (((sfun_ginfo_98_t) CREF(aux_1934))->cfrom__119);
		    }
		 }
		 test_1922 = NULLP(aux_1932);
	      }
	 }
	 if (test_1922)
	   {
	      sfun_ginfo_98_t obj_1555;
	      obj_1555 = (sfun_ginfo_98_t) (info_997);
	      {
		 obj_t aux_1941;
		 {
		    object_t aux_1942;
		    aux_1942 = (object_t) (obj_1555);
		    aux_1941 = OBJECT_WIDENING(aux_1942);
		 }
		 return (((sfun_ginfo_98_t) CREF(aux_1941))->cfrom__119);
	      }
	   }
	 else
	   {
	      {
		 obj_t res1757_1558;
		 {
		    sfun_ginfo_98_t obj_1556;
		    obj_1556 = (sfun_ginfo_98_t) (info_997);
		    {
		       obj_t x_1769;
		       {
			  obj_t aux_1947;
			  {
			     object_t aux_1948;
			     aux_1948 = (object_t) (obj_1556);
			     aux_1947 = OBJECT_WIDENING(aux_1948);
			  }
			  x_1769 = ((((sfun_ginfo_98_t) CREF(aux_1947))->cfrom__119) = ((obj_t) BNIL), BUNSPEC);
		       }
		       res1757_1558 = BUNSPEC;
		    }
		 }
		 res1757_1558;
	      }
	      {
		 obj_t cfrom_1000;
		 obj_t cfrom__set_44_1001;
		 obj_t global_1002;
		 {
		    sfun_ginfo_98_t obj_1559;
		    obj_1559 = (sfun_ginfo_98_t) (info_997);
		    {
		       obj_t aux_2017;
		       {
			  object_t aux_2018;
			  aux_2018 = (object_t) (obj_1559);
			  aux_2017 = OBJECT_WIDENING(aux_2018);
		       }
		       cfrom_1000 = (((sfun_ginfo_98_t) CREF(aux_2017))->cfrom);
		    }
		 }
		 cfrom__set_44_1001 = BNIL;
		 global_1002 = BFALSE;
	       loop_1003:
		 if (NULLP(cfrom_1000))
		   {
		      {
			 obj_t res_1007;
			 {
			    obj_t u_1021;
			    u_1021 = union_3_globalize_kapture(cfrom__set_44_1001);
			    {
			       bool_t test1498_1022;
			       test1498_1022 = is_a__118___object(global_1002, global_ast_var);
			       if (test1498_1022)
				 {
				    res_1007 = MAKE_PAIR(global_1002, u_1021);
				 }
			       else
				 {
				    res_1007 = u_1021;
				 }
			    }
			 }
			 {
			    bool_t test1479_1008;
			    {
			       obj_t aux_1958;
			       aux_1958 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			       test1479_1008 = CBOOL(aux_1958);
			    }
			    if (test1479_1008)
			      {
				 obj_t arg1481_1010;
				 obj_t arg1485_1012;
				 arg1481_1010 = shape_tools_shape((obj_t) (local_1));
				 arg1485_1012 = shape_tools_shape(res_1007);
				 {
				    obj_t list1486_1013;
				    {
				       obj_t arg1487_1014;
				       {
					  obj_t arg1489_1015;
					  {
					     obj_t arg1490_1016;
					     {
						obj_t arg1493_1017;
						{
						   obj_t aux_1967;
						   aux_1967 = BCHAR(((unsigned char) '\n'));
						   arg1493_1017 = MAKE_PAIR(aux_1967, BNIL);
						}
						arg1490_1016 = MAKE_PAIR(arg1485_1012, arg1493_1017);
					     }
					     arg1489_1015 = MAKE_PAIR(string1770_globalize_integration, arg1490_1016);
					  }
					  arg1487_1014 = MAKE_PAIR(arg1481_1010, arg1489_1015);
				       }
				       list1486_1013 = MAKE_PAIR(string1771_globalize_integration, arg1487_1014);
				    }
				    print_trace_107_tools_trace(list1486_1013);
				 }
			      }
			    else
			      {
				 BUNSPEC;
			      }
			 }
			 {
			    obj_t res1758_1566;
			    {
			       sfun_ginfo_98_t obj_1564;
			       obj_1564 = (sfun_ginfo_98_t) (info_997);
			       {
				  obj_t x_1770;
				  {
				     obj_t aux_1976;
				     {
					object_t aux_1977;
					aux_1977 = (object_t) (obj_1564);
					aux_1976 = OBJECT_WIDENING(aux_1977);
				     }
				     x_1770 = ((((sfun_ginfo_98_t) CREF(aux_1976))->cfrom__119) = ((obj_t) res_1007), BUNSPEC);
				  }
				  res1758_1566 = BUNSPEC;
			       }
			    }
			    res1758_1566;
			 }
			 return res_1007;
		      }
		   }
		 else
		   {
		      bool_t test1499_1023;
		      test1499_1023 = is_a__118___object(CAR(cfrom_1000), global_ast_var);
		      if (test1499_1023)
			{
			   {
			      obj_t global_1986;
			      obj_t cfrom_1984;
			      cfrom_1984 = CDR(cfrom_1000);
			      global_1986 = CAR(cfrom_1000);
			      global_1002 = global_1986;
			      cfrom_1000 = cfrom_1984;
			      goto loop_1003;
			   }
			}
		      else
			{
			   {
			      obj_t cfrom__119_1026;
			      {
				 local_t aux_1988;
				 {
				    obj_t aux_1989;
				    aux_1989 = CAR(cfrom_1000);
				    aux_1988 = (local_t) (aux_1989);
				 }
				 cfrom__119_1026 = set_cfrom___159_globalize_integration(aux_1988);
			      }
			      {
				 bool_t test1502_1027;
				 if (PAIRP(cfrom__119_1026))
				   {
				      test1502_1027 = is_a__118___object(CAR(cfrom__119_1026), global_ast_var);
				   }
				 else
				   {
				      test1502_1027 = ((bool_t) 0);
				   }
				 if (test1502_1027)
				   {
				      obj_t arg1505_1028;
				      obj_t arg1506_1029;
				      obj_t arg1507_1030;
				      arg1505_1028 = CDR(cfrom_1000);
				      {
					 obj_t arg1509_1031;
					 {
					    obj_t aux_2001;
					    obj_t aux_1999;
					    aux_2001 = CDR(cfrom__119_1026);
					    aux_1999 = CAR(cfrom_1000);
					    arg1509_1031 = MAKE_PAIR(aux_1999, aux_2001);
					 }
					 arg1506_1029 = MAKE_PAIR(arg1509_1031, cfrom__set_44_1001);
				      }
				      arg1507_1030 = CAR(cfrom__119_1026);
				      {
					 obj_t global_2008;
					 obj_t cfrom__set_44_2007;
					 obj_t cfrom_2006;
					 cfrom_2006 = arg1505_1028;
					 cfrom__set_44_2007 = arg1506_1029;
					 global_2008 = arg1507_1030;
					 global_1002 = global_2008;
					 cfrom__set_44_1001 = cfrom__set_44_2007;
					 cfrom_1000 = cfrom_2006;
					 goto loop_1003;
				      }
				   }
				 else
				   {
				      obj_t arg1513_1034;
				      obj_t arg1514_1035;
				      arg1513_1034 = CDR(cfrom_1000);
				      {
					 obj_t arg1517_1036;
					 {
					    obj_t aux_2010;
					    aux_2010 = CAR(cfrom_1000);
					    arg1517_1036 = MAKE_PAIR(aux_2010, cfrom__119_1026);
					 }
					 arg1514_1035 = MAKE_PAIR(arg1517_1036, cfrom__set_44_1001);
				      }
				      {
					 obj_t cfrom__set_44_2015;
					 obj_t cfrom_2014;
					 cfrom_2014 = arg1513_1034;
					 cfrom__set_44_2015 = arg1514_1035;
					 cfrom__set_44_1001 = cfrom__set_44_2015;
					 cfrom_1000 = cfrom_2014;
					 goto loop_1003;
				      }
				   }
			      }
			   }
			}
		   }
	      }
	   }
      }
   }
}


obj_t 
get_new_tg_254_globalize_integration(obj_t tg_2, obj_t fg_3, long round_4)
{
   {
      obj_t new_tg_10_1045;
      obj_t fg_1046;
      new_tg_10_1045 = BNIL;
      fg_1046 = fg_3;
    loop_1047:
      if (NULLP(fg_1046))
	{
	   return new_tg_10_1045;
	}
      else
	{
	   obj_t local_1050;
	   local_1050 = CAR(fg_1046);
	   {
	      bool_t test1533_1051;
	      {
		 obj_t aux_2025;
		 aux_2025 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
		 test1533_1051 = CBOOL(aux_2025);
	      }
	      if (test1533_1051)
		{
		   obj_t arg1535_1053;
		   obj_t arg1537_1055;
		   arg1535_1053 = shape_tools_shape(local_1050);
		   {
		      obj_t aux_2032;
		      {
			 sfun_ginfo_98_t obj_1592;
			 {
			    value_t aux_2033;
			    {
			       local_t obj_1591;
			       obj_1591 = (local_t) (local_1050);
			       aux_2033 = (((local_t) CREF(obj_1591))->value);
			    }
			    obj_1592 = (sfun_ginfo_98_t) (aux_2033);
			 }
			 {
			    obj_t aux_2037;
			    {
			       object_t aux_2038;
			       aux_2038 = (object_t) (obj_1592);
			       aux_2037 = OBJECT_WIDENING(aux_2038);
			    }
			    aux_2032 = (((sfun_ginfo_98_t) CREF(aux_2037))->cfrom__119);
			 }
		      }
		      arg1537_1055 = shape_tools_shape(aux_2032);
		   }
		   {
		      obj_t list1538_1056;
		      {
			 obj_t arg1539_1057;
			 {
			    obj_t arg1540_1058;
			    {
			       obj_t arg1541_1059;
			       {
				  obj_t arg1542_1060;
				  {
				     obj_t aux_2043;
				     aux_2043 = BCHAR(((unsigned char) '\n'));
				     arg1542_1060 = MAKE_PAIR(aux_2043, BNIL);
				  }
				  arg1541_1059 = MAKE_PAIR(arg1537_1055, arg1542_1060);
			       }
			       arg1540_1058 = MAKE_PAIR(string1772_globalize_integration, arg1541_1059);
			    }
			    arg1539_1057 = MAKE_PAIR(arg1535_1053, arg1540_1058);
			 }
			 list1538_1056 = MAKE_PAIR(string1773_globalize_integration, arg1539_1057);
		      }
		      print_trace_107_tools_trace(list1538_1056);
		   }
		}
	      else
		{
		   BUNSPEC;
		}
	   }
	   {
	      obj_t cfrom_1066;
	      long new_1067;
	      {
		 sfun_ginfo_98_t obj_1594;
		 {
		    value_t aux_2110;
		    {
		       local_t obj_1593;
		       obj_1593 = (local_t) (local_1050);
		       aux_2110 = (((local_t) CREF(obj_1593))->value);
		    }
		    obj_1594 = (sfun_ginfo_98_t) (aux_2110);
		 }
		 {
		    obj_t aux_2114;
		    {
		       object_t aux_2115;
		       aux_2115 = (object_t) (obj_1594);
		       aux_2114 = OBJECT_WIDENING(aux_2115);
		    }
		    cfrom_1066 = (((sfun_ginfo_98_t) CREF(aux_2114))->cfrom__119);
		 }
	      }
	      new_1067 = ((long) 0);
	    liip_1068:
	      if (NULLP(cfrom_1066))
		{
		   if ((new_1067 < ((long) 2)))
		     {
			obj_t fg_2055;
			fg_2055 = CDR(fg_1046);
			fg_1046 = fg_2055;
			goto loop_1047;
		     }
		   else
		     {
			{
			   long arg1560_1076;
			   arg1560_1076 = (round_4 - ((long) 1));
			   {
			      obj_t res1759_1604;
			      {
				 sfun_ginfo_98_t obj_1602;
				 {
				    value_t aux_2058;
				    {
				       local_t obj_1599;
				       obj_1599 = (local_t) (local_1050);
				       aux_2058 = (((local_t) CREF(obj_1599))->value);
				    }
				    obj_1602 = (sfun_ginfo_98_t) (aux_2058);
				 }
				 {
				    obj_t x_1771;
				    {
				       obj_t aux_2062;
				       {
					  object_t aux_2063;
					  aux_2063 = (object_t) (obj_1602);
					  aux_2062 = OBJECT_WIDENING(aux_2063);
				       }
				       x_1771 = ((((sfun_ginfo_98_t) CREF(aux_2062))->mark) = ((long) arg1560_1076), BUNSPEC);
				    }
				    res1759_1604 = BUNSPEC;
				 }
			      }
			      res1759_1604;
			   }
			}
			{
			   obj_t arg1561_1077;
			   obj_t arg1562_1078;
			   arg1561_1077 = MAKE_PAIR(local_1050, new_tg_10_1045);
			   arg1562_1078 = CDR(fg_1046);
			   {
			      obj_t fg_2070;
			      obj_t new_tg_10_2069;
			      new_tg_10_2069 = arg1561_1077;
			      fg_2070 = arg1562_1078;
			      fg_1046 = fg_2070;
			      new_tg_10_1045 = new_tg_10_2069;
			      goto loop_1047;
			   }
			}
		     }
		}
	      else
		{
		   bool_t test1563_1079;
		   test1563_1079 = is_a__118___object(CAR(cfrom_1066), global_ast_var);
		   if (test1563_1079)
		     {
			{
			   long new_2076;
			   obj_t cfrom_2074;
			   cfrom_2074 = CDR(cfrom_1066);
			   new_2076 = (new_1067 + ((long) 1));
			   new_1067 = new_2076;
			   cfrom_1066 = cfrom_2074;
			   goto liip_1068;
			}
		     }
		   else
		     {
			bool_t test_2078;
			{
			   bool_t test_2079;
			   {
			      sfun_ginfo_98_t obj_1615;
			      {
				 value_t aux_2080;
				 {
				    local_t obj_1614;
				    {
				       obj_t aux_2081;
				       aux_2081 = CAR(cfrom_1066);
				       obj_1614 = (local_t) (aux_2081);
				    }
				    aux_2080 = (((local_t) CREF(obj_1614))->value);
				 }
				 obj_1615 = (sfun_ginfo_98_t) (aux_2080);
			      }
			      {
				 obj_t aux_2086;
				 {
				    object_t aux_2087;
				    aux_2087 = (object_t) (obj_1615);
				    aux_2086 = OBJECT_WIDENING(aux_2087);
				 }
				 test_2079 = (((sfun_ginfo_98_t) CREF(aux_2086))->g__219);
			      }
			   }
			   if (test_2079)
			     {
				long aux_2091;
				{
				   sfun_ginfo_98_t obj_1618;
				   {
				      value_t aux_2092;
				      {
					 local_t obj_1617;
					 {
					    obj_t aux_2093;
					    aux_2093 = CAR(cfrom_1066);
					    obj_1617 = (local_t) (aux_2093);
					 }
					 aux_2092 = (((local_t) CREF(obj_1617))->value);
				      }
				      obj_1618 = (sfun_ginfo_98_t) (aux_2092);
				   }
				   {
				      obj_t aux_2098;
				      {
					 object_t aux_2099;
					 aux_2099 = (object_t) (obj_1618);
					 aux_2098 = OBJECT_WIDENING(aux_2099);
				      }
				      aux_2091 = (((sfun_ginfo_98_t) CREF(aux_2098))->mark);
				   }
				}
				test_2078 = (aux_2091 < round_4);
			     }
			   else
			     {
				test_2078 = ((bool_t) 1);
			     }
			}
			if (test_2078)
			  {
			     {
				obj_t cfrom_2104;
				cfrom_2104 = CDR(cfrom_1066);
				cfrom_1066 = cfrom_2104;
				goto liip_1068;
			     }
			  }
			else
			  {
			     {
				long new_2108;
				obj_t cfrom_2106;
				cfrom_2106 = CDR(cfrom_1066);
				new_2108 = (new_1067 + ((long) 1));
				new_1067 = new_2108;
				cfrom_1066 = cfrom_2106;
				goto liip_1068;
			     }
			  }
		     }
		}
	   }
	}
   }
}


obj_t 
get_new_fg_250_globalize_integration(obj_t fg_5, long round_6)
{
   {
      obj_t old_fg_154_1093;
      obj_t new_fg_180_1094;
      old_fg_154_1093 = fg_5;
      new_fg_180_1094 = BNIL;
    loop_1095:
      if (NULLP(old_fg_154_1093))
	{
	   return new_fg_180_1094;
	}
      else
	{
	   bool_t test_2121;
	   {
	      long aux_2134;
	      long aux_2122;
	      aux_2134 = (round_6 - ((long) 1));
	      {
		 sfun_ginfo_98_t obj_1628;
		 {
		    value_t aux_2123;
		    {
		       local_t obj_1627;
		       {
			  obj_t aux_2124;
			  aux_2124 = CAR(old_fg_154_1093);
			  obj_1627 = (local_t) (aux_2124);
		       }
		       aux_2123 = (((local_t) CREF(obj_1627))->value);
		    }
		    obj_1628 = (sfun_ginfo_98_t) (aux_2123);
		 }
		 {
		    obj_t aux_2129;
		    {
		       object_t aux_2130;
		       aux_2130 = (object_t) (obj_1628);
		       aux_2129 = OBJECT_WIDENING(aux_2130);
		    }
		    aux_2122 = (((sfun_ginfo_98_t) CREF(aux_2129))->mark);
		 }
	      }
	      test_2121 = (aux_2122 == aux_2134);
	   }
	   if (test_2121)
	     {
		{
		   obj_t old_fg_154_2137;
		   old_fg_154_2137 = CDR(old_fg_154_1093);
		   old_fg_154_1093 = old_fg_154_2137;
		   goto loop_1095;
		}
	     }
	   else
	     {
		{
		   obj_t arg1583_1100;
		   obj_t arg1584_1101;
		   arg1583_1100 = CDR(old_fg_154_1093);
		   {
		      obj_t aux_2140;
		      aux_2140 = CAR(old_fg_154_1093);
		      arg1584_1101 = MAKE_PAIR(aux_2140, new_fg_180_1094);
		   }
		   {
		      obj_t new_fg_180_2144;
		      obj_t old_fg_154_2143;
		      old_fg_154_2143 = arg1583_1100;
		      new_fg_180_2144 = arg1584_1101;
		      new_fg_180_1094 = new_fg_180_2144;
		      old_fg_154_1093 = old_fg_154_2143;
		      goto loop_1095;
		   }
		}
	     }
	}
   }
}


obj_t 
set_integrators__120_globalize_integration(obj_t tg_7, obj_t fg_8, long round_9)
{
   {
      bool_t test1591_1107;
      {
	 obj_t aux_2145;
	 aux_2145 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1591_1107 = CBOOL(aux_2145);
      }
      if (test1591_1107)
	{
	   obj_t arg1593_1109;
	   obj_t arg1596_1111;
	   obj_t arg1600_1113;
	   arg1593_1109 = shape_tools_shape(tg_7);
	   arg1596_1111 = shape_tools_shape(fg_8);
	   arg1600_1113 = shape_tools_shape(BINT(round_9));
	   {
	      obj_t list1601_1114;
	      {
		 obj_t arg1603_1115;
		 {
		    obj_t arg1604_1116;
		    {
		       obj_t arg1605_1117;
		       {
			  obj_t arg1606_1118;
			  {
			     obj_t arg1608_1119;
			     {
				obj_t arg1609_1120;
				{
				   obj_t aux_2155;
				   aux_2155 = BCHAR(((unsigned char) '\n'));
				   arg1609_1120 = MAKE_PAIR(aux_2155, BNIL);
				}
				arg1608_1119 = MAKE_PAIR(arg1600_1113, arg1609_1120);
			     }
			     arg1606_1118 = MAKE_PAIR(string1764_globalize_integration, arg1608_1119);
			  }
			  arg1605_1117 = MAKE_PAIR(arg1596_1111, arg1606_1118);
		       }
		       arg1604_1116 = MAKE_PAIR(string1764_globalize_integration, arg1605_1117);
		    }
		    arg1603_1115 = MAKE_PAIR(arg1593_1109, arg1604_1116);
		 }
		 list1601_1114 = MAKE_PAIR(string1774_globalize_integration, arg1603_1115);
	      }
	      print_trace_107_tools_trace(list1601_1114);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t roots_1124;
      roots_1124 = tg_7;
    loop_1125:
      if (NULLP(roots_1124))
	{
	   return CNST_TABLE_REF(((long) 1));
	}
      else
	{
	   obj_t roots_1127;
	   obj_t new_roots_207_1128;
	   roots_1127 = roots_1124;
	   new_roots_207_1128 = BNIL;
	 liip_1129:
	   if (NULLP(roots_1127))
	     {
		obj_t roots_2170;
		roots_2170 = new_roots_207_1128;
		roots_1124 = roots_2170;
		goto loop_1125;
	     }
	   else
	     {
		obj_t root_1132;
		root_1132 = CAR(roots_1127);
		{
		   obj_t cto_1133;
		   obj_t new_1134;
		   {
		      sfun_ginfo_98_t obj_1642;
		      {
			 value_t aux_2247;
			 {
			    local_t obj_1641;
			    obj_1641 = (local_t) (root_1132);
			    aux_2247 = (((local_t) CREF(obj_1641))->value);
			 }
			 obj_1642 = (sfun_ginfo_98_t) (aux_2247);
		      }
		      {
			 obj_t aux_2251;
			 {
			    object_t aux_2252;
			    aux_2252 = (object_t) (obj_1642);
			    aux_2251 = OBJECT_WIDENING(aux_2252);
			 }
			 cto_1133 = (((sfun_ginfo_98_t) CREF(aux_2251))->cto);
		      }
		   }
		   new_1134 = new_roots_207_1128;
		 laap_1135:
		   if (NULLP(cto_1133))
		     {
			obj_t new_roots_207_2176;
			obj_t roots_2174;
			roots_2174 = CDR(roots_1127);
			new_roots_207_2176 = new_1134;
			new_roots_207_1128 = new_roots_207_2176;
			roots_1127 = roots_2174;
			goto liip_1129;
		     }
		   else
		     {
			obj_t to_1140;
			to_1140 = CAR(cto_1133);
			{
			   value_t info_1141;
			   {
			      local_t obj_1646;
			      obj_1646 = (local_t) (to_1140);
			      info_1141 = (((local_t) CREF(obj_1646))->value);
			   }
			   {
			      {
				 bool_t test_2180;
				 {
				    sfun_ginfo_98_t obj_1647;
				    obj_1647 = (sfun_ginfo_98_t) (info_1141);
				    {
				       obj_t aux_2182;
				       {
					  object_t aux_2183;
					  aux_2183 = (object_t) (obj_1647);
					  aux_2182 = OBJECT_WIDENING(aux_2183);
				       }
				       test_2180 = (((sfun_ginfo_98_t) CREF(aux_2182))->g__219);
				    }
				 }
				 if (test_2180)
				   {
				      bool_t test_2187;
				      {
					 long aux_2188;
					 {
					    sfun_ginfo_98_t obj_1648;
					    obj_1648 = (sfun_ginfo_98_t) (info_1141);
					    {
					       obj_t aux_2190;
					       {
						  object_t aux_2191;
						  aux_2191 = (object_t) (obj_1648);
						  aux_2190 = OBJECT_WIDENING(aux_2191);
					       }
					       aux_2188 = (((sfun_ginfo_98_t) CREF(aux_2190))->mark);
					    }
					 }
					 test_2187 = (aux_2188 == round_9);
				      }
				      if (test_2187)
					{
					   {
					      obj_t cto_2196;
					      cto_2196 = CDR(cto_1133);
					      cto_1133 = cto_2196;
					      goto laap_1135;
					   }
					}
				      else
					{
					   bool_t test1627_1145;
					   {
					      obj_t aux_2198;
					      {
						 sfun_ginfo_98_t obj_1652;
						 obj_1652 = (sfun_ginfo_98_t) (info_1141);
						 {
						    obj_t aux_2200;
						    {
						       object_t aux_2201;
						       aux_2201 = (object_t) (obj_1652);
						       aux_2200 = OBJECT_WIDENING(aux_2201);
						    }
						    aux_2198 = (((sfun_ginfo_98_t) CREF(aux_2200))->integrator);
						 }
					      }
					      test1627_1145 = is_a__118___object(aux_2198, local_ast_var);
					   }
					   if (test1627_1145)
					     {
						{
						   obj_t cto_2207;
						   cto_2207 = CDR(cto_1133);
						   cto_1133 = cto_2207;
						   goto laap_1135;
						}
					     }
					   else
					     {
						{
						   obj_t res1760_1657;
						   {
						      sfun_ginfo_98_t obj_1655;
						      obj_1655 = (sfun_ginfo_98_t) (info_1141);
						      {
							 obj_t x_1772;
							 {
							    obj_t aux_2210;
							    {
							       object_t aux_2211;
							       aux_2211 = (object_t) (obj_1655);
							       aux_2210 = OBJECT_WIDENING(aux_2211);
							    }
							    x_1772 = ((((sfun_ginfo_98_t) CREF(aux_2210))->g__219) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							 }
							 res1760_1657 = BUNSPEC;
						      }
						   }
						   res1760_1657;
						}
						{
						   obj_t integrator_1147;
						   integrator_1147 = get_integrator_6_globalize_integration(root_1132);
						   {
						      obj_t res1761_1660;
						      {
							 sfun_ginfo_98_t obj_1658;
							 obj_1658 = (sfun_ginfo_98_t) (info_1141);
							 {
							    obj_t x_1773;
							    {
							       obj_t aux_2217;
							       {
								  object_t aux_2218;
								  aux_2218 = (object_t) (obj_1658);
								  aux_2217 = OBJECT_WIDENING(aux_2218);
							       }
							       x_1773 = ((((sfun_ginfo_98_t) CREF(aux_2217))->integrator) = ((obj_t) integrator_1147), BUNSPEC);
							    }
							    res1761_1660 = BUNSPEC;
							 }
						      }
						      res1761_1660;
						   }
						   {
						      value_t arg1630_1148;
						      obj_t arg1632_1149;
						      {
							 local_t obj_1661;
							 obj_1661 = (local_t) (integrator_1147);
							 arg1630_1148 = (((local_t) CREF(obj_1661))->value);
						      }
						      {
							 obj_t aux_2224;
							 {
							    sfun_ginfo_98_t obj_1663;
							    {
							       value_t aux_2225;
							       {
								  local_t obj_1662;
								  obj_1662 = (local_t) (integrator_1147);
								  aux_2225 = (((local_t) CREF(obj_1662))->value);
							       }
							       obj_1663 = (sfun_ginfo_98_t) (aux_2225);
							    }
							    {
							       obj_t aux_2229;
							       {
								  object_t aux_2230;
								  aux_2230 = (object_t) (obj_1663);
								  aux_2229 = OBJECT_WIDENING(aux_2230);
							       }
							       aux_2224 = (((sfun_ginfo_98_t) CREF(aux_2229))->integrated);
							    }
							 }
							 arg1632_1149 = MAKE_PAIR(to_1140, aux_2224);
						      }
						      {
							 obj_t res1762_1668;
							 {
							    sfun_ginfo_98_t obj_1666;
							    obj_1666 = (sfun_ginfo_98_t) (arg1630_1148);
							    {
							       obj_t x_1774;
							       {
								  obj_t aux_2236;
								  {
								     object_t aux_2237;
								     aux_2237 = (object_t) (obj_1666);
								     aux_2236 = OBJECT_WIDENING(aux_2237);
								  }
								  x_1774 = ((((sfun_ginfo_98_t) CREF(aux_2236))->integrated) = ((obj_t) arg1632_1149), BUNSPEC);
							       }
							       res1762_1668 = BUNSPEC;
							    }
							 }
							 res1762_1668;
						      }
						   }
						}
						{
						   obj_t arg1638_1152;
						   obj_t arg1641_1153;
						   arg1638_1152 = CDR(cto_1133);
						   arg1641_1153 = MAKE_PAIR(to_1140, new_1134);
						   {
						      obj_t new_2244;
						      obj_t cto_2243;
						      cto_2243 = arg1638_1152;
						      new_2244 = arg1641_1153;
						      new_1134 = new_2244;
						      cto_1133 = cto_2243;
						      goto laap_1135;
						   }
						}
					     }
					}
				   }
				 else
				   {
				      {
					 obj_t cto_2245;
					 cto_2245 = CDR(cto_1133);
					 cto_1133 = cto_2245;
					 goto laap_1135;
				      }
				   }
			      }
			   }
			}
		     }
		}
	     }
	}
   }
}


obj_t 
get_integrator_6_globalize_integration(obj_t local_10)
{
   {
      bool_t test_2256;
      {
	 sfun_ginfo_98_t obj_1674;
	 {
	    value_t aux_2257;
	    {
	       local_t obj_1673;
	       obj_1673 = (local_t) (local_10);
	       aux_2257 = (((local_t) CREF(obj_1673))->value);
	    }
	    obj_1674 = (sfun_ginfo_98_t) (aux_2257);
	 }
	 {
	    obj_t aux_2261;
	    {
	       object_t aux_2262;
	       aux_2262 = (object_t) (obj_1674);
	       aux_2261 = OBJECT_WIDENING(aux_2262);
	    }
	    test_2256 = (((sfun_ginfo_98_t) CREF(aux_2261))->g__219);
	 }
      }
      if (test_2256)
	{
	   return local_10;
	}
      else
	{
	   sfun_ginfo_98_t obj_1676;
	   {
	      value_t aux_2266;
	      {
		 local_t obj_1675;
		 obj_1675 = (local_t) (local_10);
		 aux_2266 = (((local_t) CREF(obj_1675))->value);
	      }
	      obj_1676 = (sfun_ginfo_98_t) (aux_2266);
	   }
	   {
	      obj_t aux_2270;
	      {
		 object_t aux_2271;
		 aux_2271 = (object_t) (obj_1676);
		 aux_2270 = OBJECT_WIDENING(aux_2271);
	      }
	      return (((sfun_ginfo_98_t) CREF(aux_2270))->integrator);
	   }
	}
   }
}


obj_t 
imported_modules_init_94_globalize_integration()
{
   module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_INTEGRATION");
   module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_INTEGRATION");
   module_initialization_70_type_type(((long) 0), "GLOBALIZE_INTEGRATION");
   module_initialization_70_ast_var(((long) 0), "GLOBALIZE_INTEGRATION");
   module_initialization_70_ast_node(((long) 0), "GLOBALIZE_INTEGRATION");
   module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_INTEGRATION");
   module_initialization_70_globalize_globalize(((long) 0), "GLOBALIZE_INTEGRATION");
   return module_initialization_70_globalize_kapture(((long) 0), "GLOBALIZE_INTEGRATION");
}
