/*===========================================================================*/
/*   (Globalize/kapture.scm)                                                 */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_t;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_t;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_t;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_t;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_t;


extern obj_t create_vector(long);
extern obj_t fun_ast_var;
extern bool_t is_a__118___object(obj_t, obj_t);
static long __union_round__11_globalize_kapture;
static obj_t imported_modules_init_94_globalize_kapture();
extern obj_t module_initialization_70_globalize_kapture(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_node(long, char *);
extern obj_t module_initialization_70_globalize_free(long, char *);
extern obj_t module_initialization_70_globalize_clocto(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_globalize_kapture();
static obj_t cnst_init_137_globalize_kapture();
static obj_t set_one_kaptured__205_globalize_kapture(local_t, obj_t);
extern obj_t union_3_globalize_kapture(obj_t);
extern obj_t _set_kaptured__95_globalize_kapture(obj_t, obj_t);
extern obj_t set_kaptured__104_globalize_kapture(obj_t);
static obj_t require_initialization_114_globalize_kapture = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_globalize_kapture();
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t _union_globalize_kapture(obj_t, obj_t);
extern obj_t free_from_222_globalize_free(obj_t, local_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t cto_transitive_closure__123_globalize_clocto(local_t);
extern obj_t get_free_vars_244_globalize_free(node_t, local_t);
extern obj_t local_ast_var;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t __cnst[1];

DEFINE_STRING(string1771_globalize_kapture, string1771_globalize_kapture1787, "      ", 6);
DEFINE_STRING(string1774_globalize_kapture, string1774_globalize_kapture1788, ") : ", 4);
DEFINE_STRING(string1779_globalize_kapture, string1779_globalize_kapture1789, "  not globalized (car cto)", 26);
DEFINE_STRING(string1777_globalize_kapture, string1777_globalize_kapture1790, "  (eq? (car cto) local)", 23);
DEFINE_EXPORT_PROCEDURE(set_kaptured__env_5_globalize_kapture, _set_kaptured__95_globalize_kapture1791, _set_kaptured__95_globalize_kapture, 0L, 1);
DEFINE_STRING(string1770_globalize_kapture, string1770_globalize_kapture1792, "--> cto* [", 10);
DEFINE_STRING(string1765_globalize_kapture, string1765_globalize_kapture1793, " [locking:", 10);
DEFINE_STRING(string1776_globalize_kapture, string1776_globalize_kapture1794, "       free(", 12);
DEFINE_STRING(string1775_globalize_kapture, string1775_globalize_kapture1795, "   kaptured(", 12);
DEFINE_EXPORT_PROCEDURE(union_env_221_globalize_kapture, _union_globalize_kapture1796, _union_globalize_kapture, 0L, 1);
DEFINE_STRING(string1772_globalize_kapture, string1772_globalize_kapture1797, " ) : ", 5);
DEFINE_STRING(string1773_globalize_kapture, string1773_globalize_kapture1798, "loop( ", 6);
DEFINE_STRING(string1767_globalize_kapture, string1767_globalize_kapture1799, "] ", 2);
DEFINE_STRING(string1778_globalize_kapture, string1778_globalize_kapture1800, "  (sfun/Ginfo-G? (car cto))", 27);
DEFINE_STRING(string1766_globalize_kapture, string1766_globalize_kapture1801, "set-one-kaptured: ", 18);
DEFINE_STRING(string1768_globalize_kapture, string1768_globalize_kapture1802, "--> (or pair? null?) [", 22);
DEFINE_STRING(string1780_globalize_kapture, string1780_globalize_kapture1803, "GLOBALIZE ", 10);
DEFINE_STRING(string1769_globalize_kapture, string1769_globalize_kapture1804, "--> local? [", 12);

obj_t 
module_initialization_70_globalize_kapture(long checksum_1740, char *from_1741)
{
   if (CBOOL(require_initialization_114_globalize_kapture))
     {
	require_initialization_114_globalize_kapture = BBOOL(((bool_t) 0));
	library_modules_init_112_globalize_kapture();
	cnst_init_137_globalize_kapture();
	imported_modules_init_94_globalize_kapture();
	toplevel_init_63_globalize_kapture();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_globalize_kapture()
{
   module_initialization_70___object(((long) 0), "GLOBALIZE_KAPTURE");
   module_initialization_70___reader(((long) 0), "GLOBALIZE_KAPTURE");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_KAPTURE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_globalize_kapture()
{
   {
      obj_t cnst_port_138_1732;
      cnst_port_138_1732 = open_input_string(string1780_globalize_kapture);
      {
	 long i_1733;
	 i_1733 = ((long) 0);
       loop_1734:
	 {
	    bool_t test1781_1735;
	    test1781_1735 = (i_1733 == ((long) -1));
	    if (test1781_1735)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1783_1736;
		    {
		       obj_t list1784_1737;
		       {
			  obj_t arg1785_1738;
			  arg1785_1738 = BNIL;
			  list1784_1737 = MAKE_PAIR(cnst_port_138_1732, arg1785_1738);
		       }
		       arg1783_1736 = read___reader(list1784_1737);
		    }
		    CNST_TABLE_SET(i_1733, arg1783_1736);
		 }
		 {
		    int aux_1739;
		    {
		       long aux_1758;
		       aux_1758 = (i_1733 - ((long) 1));
		       aux_1739 = (int) (aux_1758);
		    }
		    {
		       long i_1761;
		       i_1761 = (long) (aux_1739);
		       i_1733 = i_1761;
		       goto loop_1734;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_globalize_kapture()
{
   return (__union_round__11_globalize_kapture = ((long) 0),
      BUNSPEC);
}


obj_t 
set_kaptured__104_globalize_kapture(obj_t local__0_1)
{
   {
      obj_t l1369_914;
      l1369_914 = local__0_1;
    lname1370_915:
      if (PAIRP(l1369_914))
	{
	   {
	      local_t aux_1765;
	      {
		 obj_t aux_1766;
		 aux_1766 = CAR(l1369_914);
		 aux_1765 = (local_t) (aux_1766);
	      }
	      cto_transitive_closure__123_globalize_clocto(aux_1765);
	   }
	   {
	      obj_t l1369_1770;
	      l1369_1770 = CDR(l1369_914);
	      l1369_914 = l1369_1770;
	      goto lname1370_915;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      obj_t l1371_919;
      {
	 bool_t aux_1772;
	 l1371_919 = local__0_1;
       lname1373_920:
	 if (PAIRP(l1371_919))
	   {
	      {
		 obj_t local_922;
		 local_922 = CAR(l1371_919);
		 set_one_kaptured__205_globalize_kapture((local_t) (local_922), local_922);
	      }
	      {
		 obj_t l1371_1778;
		 l1371_1778 = CDR(l1371_919);
		 l1371_919 = l1371_1778;
		 goto lname1373_920;
	      }
	   }
	 else
	   {
	      aux_1772 = ((bool_t) 1);
	   }
	 return BBOOL(aux_1772);
      }
   }
}


obj_t 
_set_kaptured__95_globalize_kapture(obj_t env_1722, obj_t local__0_1723)
{
   return set_kaptured__104_globalize_kapture(local__0_1723);
}


obj_t 
set_one_kaptured__205_globalize_kapture(local_t local_2, obj_t locking_3)
{
   {
      bool_t test1389_924;
      {
	 obj_t aux_1782;
	 aux_1782 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1389_924 = CBOOL(aux_1782);
      }
      if (test1389_924)
	{
	   obj_t arg1391_926;
	   obj_t arg1398_928;
	   arg1391_926 = shape_tools_shape((obj_t) (local_2));
	   arg1398_928 = shape_tools_shape(locking_3);
	   {
	      obj_t list1399_929;
	      {
		 obj_t arg1400_930;
		 {
		    obj_t arg1402_931;
		    {
		       obj_t arg1403_932;
		       {
			  obj_t arg1404_933;
			  {
			     obj_t arg1406_934;
			     {
				obj_t aux_1791;
				aux_1791 = BCHAR(((unsigned char) '\n'));
				arg1406_934 = MAKE_PAIR(aux_1791, BNIL);
			     }
			     {
				obj_t aux_1794;
				aux_1794 = BCHAR(((unsigned char) ']'));
				arg1404_933 = MAKE_PAIR(aux_1794, arg1406_934);
			     }
			  }
			  arg1403_932 = MAKE_PAIR(arg1398_928, arg1404_933);
		       }
		       arg1402_931 = MAKE_PAIR(string1765_globalize_kapture, arg1403_932);
		    }
		    arg1400_930 = MAKE_PAIR(arg1391_926, arg1402_931);
		 }
		 list1399_929 = MAKE_PAIR(string1766_globalize_kapture, arg1400_930);
	      }
	      print_trace_107_tools_trace(list1399_929);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      value_t info_938;
      info_938 = (((local_t) CREF(local_2))->value);
      {
	 obj_t kaptured_939;
	 {
	    sfun_ginfo_98_t obj_1514;
	    obj_1514 = (sfun_ginfo_98_t) (info_938);
	    {
	       obj_t aux_1804;
	       {
		  object_t aux_1805;
		  aux_1805 = (object_t) (obj_1514);
		  aux_1804 = OBJECT_WIDENING(aux_1805);
	       }
	       kaptured_939 = (((sfun_ginfo_98_t) CREF(aux_1804))->kaptured);
	    }
	 }
	 {
	    {
	       bool_t test_1809;
	       if (PAIRP(kaptured_939))
		 {
		    test_1809 = ((bool_t) 1);
		 }
	       else
		 {
		    test_1809 = NULLP(kaptured_939);
		 }
	       if (test_1809)
		 {
		    {
		       bool_t test1413_941;
		       {
			  obj_t aux_1813;
			  aux_1813 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			  test1413_941 = CBOOL(aux_1813);
		       }
		       if (test1413_941)
			 {
			    obj_t arg1415_943;
			    obj_t arg1417_945;
			    arg1415_943 = shape_tools_shape((obj_t) (local_2));
			    arg1417_945 = shape_tools_shape(kaptured_939);
			    {
			       obj_t list1418_946;
			       {
				  obj_t arg1420_947;
				  {
				     obj_t arg1421_948;
				     {
					obj_t arg1424_949;
					{
					   obj_t arg1426_950;
					   {
					      obj_t aux_1822;
					      aux_1822 = BCHAR(((unsigned char) '\n'));
					      arg1426_950 = MAKE_PAIR(aux_1822, BNIL);
					   }
					   arg1424_949 = MAKE_PAIR(arg1417_945, arg1426_950);
					}
					arg1421_948 = MAKE_PAIR(string1767_globalize_kapture, arg1424_949);
				     }
				     arg1420_947 = MAKE_PAIR(arg1415_943, arg1421_948);
				  }
				  list1418_946 = MAKE_PAIR(string1768_globalize_kapture, arg1420_947);
			       }
			       print_trace_107_tools_trace(list1418_946);
			    }
			 }
		       else
			 {
			    BUNSPEC;
			 }
		    }
		    {
		       obj_t v1374_954;
		       v1374_954 = create_vector(((long) 3));
		       VECTOR_SET(v1374_954, ((long) 2), kaptured_939);
		       VECTOR_SET(v1374_954, ((long) 1), locking_3);
		       VECTOR_SET(v1374_954, ((long) 0), BTRUE);
		       return v1374_954;
		    }
		 }
	       else
		 {
		    bool_t test1432_955;
		    test1432_955 = is_a__118___object(kaptured_939, local_ast_var);
		    if (test1432_955)
		      {
			 {
			    bool_t test1433_956;
			    {
			       obj_t aux_1836;
			       aux_1836 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			       test1433_956 = CBOOL(aux_1836);
			    }
			    if (test1433_956)
			      {
				 obj_t arg1441_958;
				 obj_t arg1445_960;
				 arg1441_958 = shape_tools_shape((obj_t) (local_2));
				 arg1445_960 = shape_tools_shape(kaptured_939);
				 {
				    obj_t list1446_961;
				    {
				       obj_t arg1447_962;
				       {
					  obj_t arg1448_963;
					  {
					     obj_t arg1449_964;
					     {
						obj_t arg1450_965;
						{
						   obj_t aux_1845;
						   aux_1845 = BCHAR(((unsigned char) '\n'));
						   arg1450_965 = MAKE_PAIR(aux_1845, BNIL);
						}
						arg1449_964 = MAKE_PAIR(arg1445_960, arg1450_965);
					     }
					     arg1448_963 = MAKE_PAIR(string1767_globalize_kapture, arg1449_964);
					  }
					  arg1447_962 = MAKE_PAIR(arg1441_958, arg1448_963);
				       }
				       list1446_961 = MAKE_PAIR(string1769_globalize_kapture, arg1447_962);
				    }
				    print_trace_107_tools_trace(list1446_961);
				 }
			      }
			    else
			      {
				 BUNSPEC;
			      }
			 }
			 {
			    obj_t v1375_969;
			    v1375_969 = create_vector(((long) 3));
			    VECTOR_SET(v1375_969, ((long) 2), BNIL);
			    VECTOR_SET(v1375_969, ((long) 1), locking_3);
			    VECTOR_SET(v1375_969, ((long) 0), BFALSE);
			    return v1375_969;
			 }
		      }
		    else
		      {
			 {
			    bool_t test1459_972;
			    {
			       obj_t aux_1857;
			       aux_1857 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			       test1459_972 = CBOOL(aux_1857);
			    }
			    if (test1459_972)
			      {
				 obj_t arg1463_974;
				 obj_t arg1466_976;
				 arg1463_974 = shape_tools_shape((obj_t) (local_2));
				 {
				    obj_t aux_1865;
				    {
				       sfun_ginfo_98_t obj_1536;
				       obj_1536 = (sfun_ginfo_98_t) (info_938);
				       {
					  obj_t aux_1867;
					  {
					     object_t aux_1868;
					     aux_1868 = (object_t) (obj_1536);
					     aux_1867 = OBJECT_WIDENING(aux_1868);
					  }
					  aux_1865 = (((sfun_ginfo_98_t) CREF(aux_1867))->cto__14);
				       }
				    }
				    arg1466_976 = shape_tools_shape(aux_1865);
				 }
				 {
				    obj_t list1467_977;
				    {
				       obj_t arg1468_978;
				       {
					  obj_t arg1470_979;
					  {
					     obj_t arg1471_980;
					     {
						obj_t arg1472_981;
						{
						   obj_t aux_1873;
						   aux_1873 = BCHAR(((unsigned char) '\n'));
						   arg1472_981 = MAKE_PAIR(aux_1873, BNIL);
						}
						arg1471_980 = MAKE_PAIR(arg1466_976, arg1472_981);
					     }
					     arg1470_979 = MAKE_PAIR(string1767_globalize_kapture, arg1471_980);
					  }
					  arg1468_978 = MAKE_PAIR(arg1463_974, arg1470_979);
				       }
				       list1467_977 = MAKE_PAIR(string1770_globalize_kapture, arg1468_978);
				    }
				    print_trace_107_tools_trace(list1467_977);
				 }
			      }
			    else
			      {
				 BUNSPEC;
			      }
			 }
			 {
			    obj_t new_body_215_986;
			    {
			       sfun_ginfo_98_t obj_1537;
			       obj_1537 = (sfun_ginfo_98_t) (info_938);
			       {
				  obj_t aux_1882;
				  {
				     object_t aux_1883;
				     aux_1883 = (object_t) (obj_1537);
				     aux_1882 = OBJECT_WIDENING(aux_1883);
				  }
				  new_body_215_986 = (((sfun_ginfo_98_t) CREF(aux_1882))->new_body_215);
			       }
			    }
			    {
			       obj_t res1759_1540;
			       {
				  sfun_ginfo_98_t obj_1538;
				  obj_t val1306_1539;
				  obj_1538 = (sfun_ginfo_98_t) (info_938);
				  val1306_1539 = (obj_t) (local_2);
				  {
				     obj_t x_1726;
				     {
					obj_t aux_1889;
					{
					   object_t aux_1890;
					   aux_1890 = (object_t) (obj_1538);
					   aux_1889 = OBJECT_WIDENING(aux_1890);
					}
					x_1726 = ((((sfun_ginfo_98_t) CREF(aux_1889))->kaptured) = ((obj_t) val1306_1539), BUNSPEC);
				     }
				     res1759_1540 = BUNSPEC;
				  }
			       }
			       res1759_1540;
			    }
			    {
			       obj_t kaptured_987;
			       obj_t cto_988;
			       bool_t setter__165_989;
			       kaptured_987 = BNIL;
			       {
				  obj_t aux_2095;
				  obj_t aux_2088;
				  {
				     sfun_ginfo_98_t obj_1542;
				     obj_1542 = (sfun_ginfo_98_t) (info_938);
				     {
					obj_t aux_2097;
					{
					   object_t aux_2098;
					   aux_2098 = (object_t) (obj_1542);
					   aux_2097 = OBJECT_WIDENING(aux_2098);
					}
					aux_2095 = (((sfun_ginfo_98_t) CREF(aux_2097))->cfunction);
				     }
				  }
				  {
				     sfun_ginfo_98_t obj_1541;
				     obj_1541 = (sfun_ginfo_98_t) (info_938);
				     {
					obj_t aux_2090;
					{
					   object_t aux_2091;
					   aux_2091 = (object_t) (obj_1541);
					   aux_2090 = OBJECT_WIDENING(aux_2091);
					}
					aux_2088 = (((sfun_ginfo_98_t) CREF(aux_2090))->cto__14);
				     }
				  }
				  cto_988 = append_2_18___r4_pairs_and_lists_6_3(aux_2088, aux_2095);
			       }
			       setter__165_989 = ((bool_t) 1);
			     loop_990:
			       {
				  bool_t test1486_995;
				  {
				     obj_t aux_1894;
				     aux_1894 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
				     test1486_995 = CBOOL(aux_1894);
				  }
				  if (test1486_995)
				    {
				       obj_t arg1489_997;
				       obj_t arg1494_1000;
				       obj_t arg1497_1002;
				       arg1489_997 = shape_tools_shape((obj_t) (local_2));
				       arg1494_1000 = shape_tools_shape(kaptured_987);
				       arg1497_1002 = shape_tools_shape(cto_988);
				       {
					  obj_t list1499_1004;
					  {
					     obj_t arg1500_1005;
					     {
						obj_t arg1501_1006;
						{
						   obj_t arg1505_1007;
						   {
						      obj_t arg1506_1008;
						      {
							 obj_t arg1507_1009;
							 {
							    obj_t arg1509_1010;
							    {
							       obj_t arg1510_1011;
							       {
								  obj_t arg1511_1012;
								  {
								     obj_t arg1513_1013;
								     {
									obj_t arg1514_1014;
									{
									   obj_t arg1517_1015;
									   {
									      obj_t arg1518_1016;
									      {
										 obj_t aux_1904;
										 aux_1904 = BCHAR(((unsigned char) '\n'));
										 arg1518_1016 = MAKE_PAIR(aux_1904, BNIL);
									      }
									      {
										 obj_t aux_1907;
										 aux_1907 = BBOOL(setter__165_989);
										 arg1517_1015 = MAKE_PAIR(aux_1907, arg1518_1016);
									      }
									   }
									   arg1514_1014 = MAKE_PAIR(string1771_globalize_kapture, arg1517_1015);
									}
									{
									   obj_t aux_1911;
									   aux_1911 = BCHAR(((unsigned char) '\n'));
									   arg1513_1013 = MAKE_PAIR(aux_1911, arg1514_1014);
									}
								     }
								     arg1511_1012 = MAKE_PAIR(arg1497_1002, arg1513_1013);
								  }
								  arg1510_1011 = MAKE_PAIR(string1771_globalize_kapture, arg1511_1012);
							       }
							       {
								  obj_t aux_1916;
								  aux_1916 = BCHAR(((unsigned char) '\n'));
								  arg1509_1010 = MAKE_PAIR(aux_1916, arg1510_1011);
							       }
							    }
							    arg1507_1009 = MAKE_PAIR(arg1494_1000, arg1509_1010);
							 }
							 arg1506_1008 = MAKE_PAIR(string1771_globalize_kapture, arg1507_1009);
						      }
						      {
							 obj_t aux_1921;
							 aux_1921 = BCHAR(((unsigned char) '\n'));
							 arg1505_1007 = MAKE_PAIR(aux_1921, arg1506_1008);
						      }
						   }
						   arg1501_1006 = MAKE_PAIR(string1772_globalize_kapture, arg1505_1007);
						}
						arg1500_1005 = MAKE_PAIR(arg1489_997, arg1501_1006);
					     }
					     list1499_1004 = MAKE_PAIR(string1773_globalize_kapture, arg1500_1005);
					  }
					  print_trace_107_tools_trace(list1499_1004);
				       }
				    }
				  else
				    {
				       BUNSPEC;
				    }
			       }
			       if (NULLP(cto_988))
				 {
				    {
				       obj_t free_1021;
				       free_1021 = get_free_vars_244_globalize_free((node_t) (new_body_215_986), local_2);
				       {
					  obj_t fkaptured_1022;
					  fkaptured_1022 = free_from_222_globalize_free(kaptured_987, local_2);
					  {
					     obj_t kaptured_1023;
					     {
						obj_t arg1563_1057;
						arg1563_1057 = MAKE_PAIR(free_1021, fkaptured_1022);
						kaptured_1023 = union_3_globalize_kapture(arg1563_1057);
					     }
					     {
						{
						   bool_t test1525_1024;
						   {
						      obj_t aux_1935;
						      aux_1935 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
						      test1525_1024 = CBOOL(aux_1935);
						   }
						   if (test1525_1024)
						     {
							obj_t arg1529_1026;
							obj_t arg1532_1028;
							arg1529_1026 = shape_tools_shape((obj_t) (local_2));
							arg1532_1028 = shape_tools_shape(kaptured_1023);
							{
							   obj_t list1533_1029;
							   {
							      obj_t arg1534_1030;
							      {
								 obj_t arg1535_1031;
								 {
								    obj_t arg1536_1032;
								    {
								       obj_t arg1537_1033;
								       {
									  obj_t aux_1944;
									  aux_1944 = BCHAR(((unsigned char) '\n'));
									  arg1537_1033 = MAKE_PAIR(aux_1944, BNIL);
								       }
								       arg1536_1032 = MAKE_PAIR(arg1532_1028, arg1537_1033);
								    }
								    arg1535_1031 = MAKE_PAIR(string1774_globalize_kapture, arg1536_1032);
								 }
								 arg1534_1030 = MAKE_PAIR(arg1529_1026, arg1535_1031);
							      }
							      list1533_1029 = MAKE_PAIR(string1775_globalize_kapture, arg1534_1030);
							   }
							   print_trace_107_tools_trace(list1533_1029);
							}
						     }
						   else
						     {
							BUNSPEC;
						     }
						}
						{
						   bool_t test1541_1037;
						   {
						      obj_t aux_1952;
						      aux_1952 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
						      test1541_1037 = CBOOL(aux_1952);
						   }
						   if (test1541_1037)
						     {
							obj_t arg1543_1039;
							obj_t arg1549_1041;
							arg1543_1039 = shape_tools_shape((obj_t) (local_2));
							arg1549_1041 = shape_tools_shape(free_1021);
							{
							   obj_t list1550_1042;
							   {
							      obj_t arg1551_1043;
							      {
								 obj_t arg1552_1044;
								 {
								    obj_t arg1553_1045;
								    {
								       obj_t arg1554_1046;
								       {
									  obj_t aux_1961;
									  aux_1961 = BCHAR(((unsigned char) '\n'));
									  arg1554_1046 = MAKE_PAIR(aux_1961, BNIL);
								       }
								       arg1553_1045 = MAKE_PAIR(arg1549_1041, arg1554_1046);
								    }
								    arg1552_1044 = MAKE_PAIR(string1774_globalize_kapture, arg1553_1045);
								 }
								 arg1551_1043 = MAKE_PAIR(arg1543_1039, arg1552_1044);
							      }
							      list1550_1042 = MAKE_PAIR(string1776_globalize_kapture, arg1551_1043);
							   }
							   print_trace_107_tools_trace(list1550_1042);
							}
						     }
						   else
						     {
							BUNSPEC;
						     }
						}
						if (setter__165_989)
						  {
						     {
							obj_t res1760_1548;
							{
							   sfun_ginfo_98_t obj_1546;
							   obj_1546 = (sfun_ginfo_98_t) (info_938);
							   {
							      obj_t x_1727;
							      {
								 obj_t aux_1971;
								 {
								    object_t aux_1972;
								    aux_1972 = (object_t) (obj_1546);
								    aux_1971 = OBJECT_WIDENING(aux_1972);
								 }
								 x_1727 = ((((sfun_ginfo_98_t) CREF(aux_1971))->kaptured) = ((obj_t) kaptured_1023), BUNSPEC);
							      }
							      res1760_1548 = BUNSPEC;
							   }
							}
							res1760_1548;
						     }
						     {
							obj_t l1376_1050;
							{
							   bool_t aux_1976;
							   l1376_1050 = kaptured_1023;
							 lname1379_1051:
							   if (PAIRP(l1376_1050))
							     {
								{
								   obj_t res1761_1554;
								   {
								      svar_ginfo_131_t obj_1552;
								      {
									 value_t aux_1979;
									 {
									    local_t obj_1551;
									    {
									       obj_t aux_1980;
									       aux_1980 = CAR(l1376_1050);
									       obj_1551 = (local_t) (aux_1980);
									    }
									    aux_1979 = (((local_t) CREF(obj_1551))->value);
									 }
									 obj_1552 = (svar_ginfo_131_t) (aux_1979);
								      }
								      {
									 obj_t x_1728;
									 {
									    obj_t aux_1985;
									    {
									       object_t aux_1986;
									       aux_1986 = (object_t) (obj_1552);
									       aux_1985 = OBJECT_WIDENING(aux_1986);
									    }
									    x_1728 = ((((svar_ginfo_131_t) CREF(aux_1985))->kaptured__204) = ((bool_t) ((bool_t) 1)), BUNSPEC);
									 }
									 res1761_1554 = BUNSPEC;
								      }
								   }
								   res1761_1554;
								}
								{
								   obj_t l1376_1990;
								   l1376_1990 = CDR(l1376_1050);
								   l1376_1050 = l1376_1990;
								   goto lname1379_1051;
								}
							     }
							   else
							     {
								aux_1976 = ((bool_t) 1);
							     }
							   BBOOL(aux_1976);
							}
						     }
						  }
						else
						  {
						     obj_t res1762_1558;
						     {
							sfun_ginfo_98_t obj_1556;
							obj_t val1306_1557;
							obj_1556 = (sfun_ginfo_98_t) (info_938);
							val1306_1557 = BFALSE;
							{
							   obj_t x_1729;
							   {
							      obj_t aux_1994;
							      {
								 object_t aux_1995;
								 aux_1995 = (object_t) (obj_1556);
								 aux_1994 = OBJECT_WIDENING(aux_1995);
							      }
							      x_1729 = ((((sfun_ginfo_98_t) CREF(aux_1994))->kaptured) = ((obj_t) val1306_1557), BUNSPEC);
							   }
							   res1762_1558 = BUNSPEC;
							}
						     }
						     res1762_1558;
						  }
						{
						   obj_t v1380_1056;
						   v1380_1056 = create_vector(((long) 3));
						   VECTOR_SET(v1380_1056, ((long) 2), kaptured_1023);
						   VECTOR_SET(v1380_1056, ((long) 1), locking_3);
						   {
						      obj_t aux_2002;
						      aux_2002 = BBOOL(setter__165_989);
						      VECTOR_SET(v1380_1056, ((long) 0), aux_2002);
						   }
						   return v1380_1056;
						}
					     }
					  }
				       }
				    }
				 }
			       else
				 {
				    bool_t test_2005;
				    {
				       obj_t aux_2008;
				       obj_t aux_2006;
				       aux_2008 = (obj_t) (local_2);
				       aux_2006 = CAR(cto_988);
				       test_2005 = (aux_2006 == aux_2008);
				    }
				    if (test_2005)
				      {
					 {
					    bool_t test1565_1059;
					    {
					       obj_t aux_2011;
					       aux_2011 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
					       test1565_1059 = CBOOL(aux_2011);
					    }
					    if (test1565_1059)
					      {
						 obj_t list1566_1060;
						 {
						    obj_t arg1568_1062;
						    {
						       obj_t aux_2017;
						       aux_2017 = BCHAR(((unsigned char) '\n'));
						       arg1568_1062 = MAKE_PAIR(aux_2017, BNIL);
						    }
						    list1566_1060 = MAKE_PAIR(string1777_globalize_kapture, arg1568_1062);
						 }
						 print_trace_107_tools_trace(list1566_1060);
					      }
					    else
					      {
						 BUNSPEC;
					      }
					 }
					 {
					    obj_t cto_2022;
					    cto_2022 = CDR(cto_988);
					    cto_988 = cto_2022;
					    goto loop_990;
					 }
				      }
				    else
				      {
					 bool_t test_2024;
					 {
					    sfun_ginfo_98_t obj_1574;
					    {
					       value_t aux_2025;
					       {
						  local_t obj_1573;
						  {
						     obj_t aux_2026;
						     aux_2026 = CAR(cto_988);
						     obj_1573 = (local_t) (aux_2026);
						  }
						  aux_2025 = (((local_t) CREF(obj_1573))->value);
					       }
					       obj_1574 = (sfun_ginfo_98_t) (aux_2025);
					    }
					    {
					       obj_t aux_2031;
					       {
						  object_t aux_2032;
						  aux_2032 = (object_t) (obj_1574);
						  aux_2031 = OBJECT_WIDENING(aux_2032);
					       }
					       test_2024 = (((sfun_ginfo_98_t) CREF(aux_2031))->g__219);
					    }
					 }
					 if (test_2024)
					   {
					      {
						 bool_t test1575_1068;
						 {
						    obj_t aux_2036;
						    aux_2036 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
						    test1575_1068 = CBOOL(aux_2036);
						 }
						 if (test1575_1068)
						   {
						      obj_t list1576_1069;
						      {
							 obj_t arg1578_1071;
							 {
							    obj_t aux_2042;
							    aux_2042 = BCHAR(((unsigned char) '\n'));
							    arg1578_1071 = MAKE_PAIR(aux_2042, BNIL);
							 }
							 list1576_1069 = MAKE_PAIR(string1778_globalize_kapture, arg1578_1071);
						      }
						      print_trace_107_tools_trace(list1576_1069);
						   }
						 else
						   {
						      BUNSPEC;
						   }
					      }
					      {
						 obj_t other_kaptured_142_1075;
						 {
						    local_t aux_2047;
						    {
						       obj_t aux_2048;
						       aux_2048 = CAR(cto_988);
						       aux_2047 = (local_t) (aux_2048);
						    }
						    other_kaptured_142_1075 = set_one_kaptured__205_globalize_kapture(aux_2047, locking_3);
						 }
						 {
						    bool_t test_2052;
						    {
						       obj_t aux_2053;
						       aux_2053 = VECTOR_REF(other_kaptured_142_1075, ((long) 0));
						       test_2052 = CBOOL(aux_2053);
						    }
						    if (test_2052)
						      {
							 obj_t arg1585_1077;
							 obj_t arg1587_1078;
							 {
							    obj_t aux_2056;
							    aux_2056 = VECTOR_REF(other_kaptured_142_1075, ((long) 2));
							    arg1585_1077 = MAKE_PAIR(aux_2056, kaptured_987);
							 }
							 arg1587_1078 = CDR(cto_988);
							 {
							    obj_t cto_2061;
							    obj_t kaptured_2060;
							    kaptured_2060 = arg1585_1077;
							    cto_2061 = arg1587_1078;
							    cto_988 = cto_2061;
							    kaptured_987 = kaptured_2060;
							    goto loop_990;
							 }
						      }
						    else
						      {
							 obj_t arg1589_1080;
							 obj_t arg1590_1081;
							 bool_t arg1591_1082;
							 {
							    obj_t aux_2062;
							    aux_2062 = VECTOR_REF(other_kaptured_142_1075, ((long) 2));
							    arg1589_1080 = MAKE_PAIR(aux_2062, kaptured_987);
							 }
							 arg1590_1081 = CDR(cto_988);
							 if (setter__165_989)
							   {
							      obj_t aux_2069;
							      obj_t aux_2067;
							      aux_2069 = (obj_t) (local_2);
							      aux_2067 = VECTOR_REF(other_kaptured_142_1075, ((long) 1));
							      arg1591_1082 = (aux_2067 == aux_2069);
							   }
							 else
							   {
							      arg1591_1082 = ((bool_t) 0);
							   }
							 {
							    bool_t setter__165_2074;
							    obj_t cto_2073;
							    obj_t kaptured_2072;
							    kaptured_2072 = arg1589_1080;
							    cto_2073 = arg1590_1081;
							    setter__165_2074 = arg1591_1082;
							    setter__165_989 = setter__165_2074;
							    cto_988 = cto_2073;
							    kaptured_987 = kaptured_2072;
							    goto loop_990;
							 }
						      }
						 }
					      }
					   }
					 else
					   {
					      {
						 bool_t test1596_1087;
						 {
						    obj_t aux_2075;
						    aux_2075 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
						    test1596_1087 = CBOOL(aux_2075);
						 }
						 if (test1596_1087)
						   {
						      obj_t list1597_1088;
						      {
							 obj_t arg1601_1090;
							 {
							    obj_t aux_2081;
							    aux_2081 = BCHAR(((unsigned char) '\n'));
							    arg1601_1090 = MAKE_PAIR(aux_2081, BNIL);
							 }
							 list1597_1088 = MAKE_PAIR(string1779_globalize_kapture, arg1601_1090);
						      }
						      print_trace_107_tools_trace(list1597_1088);
						   }
						 else
						   {
						      BUNSPEC;
						   }
					      }
					      {
						 obj_t cto_2086;
						 cto_2086 = CDR(cto_988);
						 cto_988 = cto_2086;
						 goto loop_990;
					      }
					   }
				      }
				 }
			    }
			 }
		      }
		 }
	    }
	 }
      }
   }
}


obj_t 
union_3_globalize_kapture(obj_t sets_4)
{
   {
      long z2_1594;
      z2_1594 = __union_round__11_globalize_kapture;
      __union_round__11_globalize_kapture = (((long) 1) + z2_1594);
   }
   {
      obj_t sets_1099;
      obj_t union_3_1100;
      sets_1099 = sets_4;
      union_3_1100 = BNIL;
    loop_1101:
      if (NULLP(sets_1099))
	{
	   return union_3_1100;
	}
      else
	{
	   obj_t set_1104;
	   obj_t union_3_1105;
	   set_1104 = CAR(sets_1099);
	   union_3_1105 = union_3_1100;
	 liip_1106:
	   if (NULLP(set_1104))
	     {
		{
		   obj_t union_3_2110;
		   obj_t sets_2108;
		   sets_2108 = CDR(sets_1099);
		   union_3_2110 = union_3_1105;
		   union_3_1100 = union_3_2110;
		   sets_1099 = sets_2108;
		   goto loop_1101;
		}
	     }
	   else
	     {
		bool_t test1619_1110;
		{
		   obj_t aux_2111;
		   {
		      value_t aux_2112;
		      {
			 local_t obj_1600;
			 {
			    obj_t aux_2113;
			    aux_2113 = CAR(set_1104);
			    obj_1600 = (local_t) (aux_2113);
			 }
			 aux_2112 = (((local_t) CREF(obj_1600))->value);
		      }
		      aux_2111 = (obj_t) (aux_2112);
		   }
		   test1619_1110 = is_a__118___object(aux_2111, fun_ast_var);
		}
		if (test1619_1110)
		  {
		     {
			bool_t test1620_1111;
			{
			   obj_t obj1_1605;
			   obj_t obj2_1606;
			   {
			      long aux_2120;
			      {
				 sfun_ginfo_98_t obj_1604;
				 {
				    value_t aux_2121;
				    {
				       local_t obj_1603;
				       {
					  obj_t aux_2122;
					  aux_2122 = CAR(set_1104);
					  obj_1603 = (local_t) (aux_2122);
				       }
				       aux_2121 = (((local_t) CREF(obj_1603))->value);
				    }
				    obj_1604 = (sfun_ginfo_98_t) (aux_2121);
				 }
				 {
				    obj_t aux_2127;
				    {
				       object_t aux_2128;
				       aux_2128 = (object_t) (obj_1604);
				       aux_2127 = OBJECT_WIDENING(aux_2128);
				    }
				    aux_2120 = (((sfun_ginfo_98_t) CREF(aux_2127))->umark);
				 }
			      }
			      obj1_1605 = BINT(aux_2120);
			   }
			   obj2_1606 = BINT(__union_round__11_globalize_kapture);
			   test1620_1111 = (obj1_1605 == obj2_1606);
			}
			if (test1620_1111)
			  {
			     obj_t set_2136;
			     set_2136 = CDR(set_1104);
			     set_1104 = set_2136;
			     goto liip_1106;
			  }
			else
			  {
			     {
				obj_t res1763_1612;
				{
				   sfun_ginfo_98_t obj_1610;
				   long val1309_1611;
				   {
				      value_t aux_2138;
				      {
					 local_t obj_1609;
					 {
					    obj_t aux_2139;
					    aux_2139 = CAR(set_1104);
					    obj_1609 = (local_t) (aux_2139);
					 }
					 aux_2138 = (((local_t) CREF(obj_1609))->value);
				      }
				      obj_1610 = (sfun_ginfo_98_t) (aux_2138);
				   }
				   val1309_1611 = __union_round__11_globalize_kapture;
				   {
				      obj_t x_1730;
				      {
					 obj_t aux_2144;
					 {
					    object_t aux_2145;
					    aux_2145 = (object_t) (obj_1610);
					    aux_2144 = OBJECT_WIDENING(aux_2145);
					 }
					 x_1730 = ((((sfun_ginfo_98_t) CREF(aux_2144))->umark) = ((long) val1309_1611), BUNSPEC);
				      }
				      res1763_1612 = BUNSPEC;
				   }
				}
				res1763_1612;
			     }
			     {
				obj_t arg1626_1115;
				obj_t arg1627_1116;
				arg1626_1115 = CDR(set_1104);
				{
				   obj_t aux_2150;
				   aux_2150 = CAR(set_1104);
				   arg1627_1116 = MAKE_PAIR(aux_2150, union_3_1105);
				}
				{
				   obj_t union_3_2154;
				   obj_t set_2153;
				   set_2153 = arg1626_1115;
				   union_3_2154 = arg1627_1116;
				   union_3_1105 = union_3_2154;
				   set_1104 = set_2153;
				   goto liip_1106;
				}
			     }
			  }
		     }
		  }
		else
		  {
		     bool_t test1635_1121;
		     {
			obj_t obj1_1620;
			obj_t obj2_1621;
			{
			   long aux_2155;
			   {
			      svar_ginfo_131_t obj_1619;
			      {
				 value_t aux_2156;
				 {
				    local_t obj_1618;
				    {
				       obj_t aux_2157;
				       aux_2157 = CAR(set_1104);
				       obj_1618 = (local_t) (aux_2157);
				    }
				    aux_2156 = (((local_t) CREF(obj_1618))->value);
				 }
				 obj_1619 = (svar_ginfo_131_t) (aux_2156);
			      }
			      {
				 obj_t aux_2162;
				 {
				    object_t aux_2163;
				    aux_2163 = (object_t) (obj_1619);
				    aux_2162 = OBJECT_WIDENING(aux_2163);
				 }
				 aux_2155 = (((svar_ginfo_131_t) CREF(aux_2162))->mark);
			      }
			   }
			   obj1_1620 = BINT(aux_2155);
			}
			obj2_1621 = BINT(__union_round__11_globalize_kapture);
			test1635_1121 = (obj1_1620 == obj2_1621);
		     }
		     if (test1635_1121)
		       {
			  {
			     obj_t set_2171;
			     set_2171 = CDR(set_1104);
			     set_1104 = set_2171;
			     goto liip_1106;
			  }
		       }
		     else
		       {
			  {
			     obj_t res1764_1627;
			     {
				svar_ginfo_131_t obj_1625;
				long val1320_1626;
				{
				   value_t aux_2173;
				   {
				      local_t obj_1624;
				      {
					 obj_t aux_2174;
					 aux_2174 = CAR(set_1104);
					 obj_1624 = (local_t) (aux_2174);
				      }
				      aux_2173 = (((local_t) CREF(obj_1624))->value);
				   }
				   obj_1625 = (svar_ginfo_131_t) (aux_2173);
				}
				val1320_1626 = __union_round__11_globalize_kapture;
				{
				   obj_t x_1731;
				   {
				      obj_t aux_2179;
				      {
					 object_t aux_2180;
					 aux_2180 = (object_t) (obj_1625);
					 aux_2179 = OBJECT_WIDENING(aux_2180);
				      }
				      x_1731 = ((((svar_ginfo_131_t) CREF(aux_2179))->mark) = ((long) val1320_1626), BUNSPEC);
				   }
				   res1764_1627 = BUNSPEC;
				}
			     }
			     res1764_1627;
			  }
			  {
			     obj_t arg1642_1125;
			     obj_t arg1643_1126;
			     arg1642_1125 = CDR(set_1104);
			     {
				obj_t aux_2185;
				aux_2185 = CAR(set_1104);
				arg1643_1126 = MAKE_PAIR(aux_2185, union_3_1105);
			     }
			     {
				obj_t union_3_2189;
				obj_t set_2188;
				set_2188 = arg1642_1125;
				union_3_2189 = arg1643_1126;
				union_3_1105 = union_3_2189;
				set_1104 = set_2188;
				goto liip_1106;
			     }
			  }
		       }
		  }
	     }
	}
   }
}


obj_t 
_union_globalize_kapture(obj_t env_1724, obj_t sets_1725)
{
   return union_3_globalize_kapture(sets_1725);
}


obj_t 
imported_modules_init_94_globalize_kapture()
{
   module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_KAPTURE");
   module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_KAPTURE");
   module_initialization_70_tools_speek(((long) 0), "GLOBALIZE_KAPTURE");
   module_initialization_70_tools_args(((long) 0), "GLOBALIZE_KAPTURE");
   module_initialization_70_type_type(((long) 0), "GLOBALIZE_KAPTURE");
   module_initialization_70_type_cache(((long) 0), "GLOBALIZE_KAPTURE");
   module_initialization_70_ast_var(((long) 0), "GLOBALIZE_KAPTURE");
   module_initialization_70_ast_node(((long) 0), "GLOBALIZE_KAPTURE");
   module_initialization_70_ast_sexp(((long) 0), "GLOBALIZE_KAPTURE");
   module_initialization_70_ast_local(((long) 0), "GLOBALIZE_KAPTURE");
   module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_KAPTURE");
   module_initialization_70_globalize_node(((long) 0), "GLOBALIZE_KAPTURE");
   module_initialization_70_globalize_free(((long) 0), "GLOBALIZE_KAPTURE");
   return module_initialization_70_globalize_clocto(((long) 0), "GLOBALIZE_KAPTURE");
}
