/*===========================================================================*/
/*   (Globalize/loc2glo.scm)                                                 */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_t;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_t;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_t;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_t;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_t;


extern obj_t reverse___r4_pairs_and_lists_6_3(obj_t);
extern obj_t svar_ginfo_131_globalize_ginfo;
extern obj_t __procedure__226_type_cache;
extern obj_t let_fun_218_ast_node;
extern obj_t _local__global_77_globalize_local__global_194(obj_t, obj_t);
extern global_t def_global_sfun__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern node_t node_globalize__229_globalize_node(node_t, variable_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_globalize_local__global_194();
extern obj_t module_initialization_70_globalize_local__global_194(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_node(long, char *);
extern obj_t module_initialization_70_globalize_free(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t cnst_init_137_globalize_local__global_194();
extern obj_t __optim__89_engine_param;
static global_t fix_non_escaping_definition_247_globalize_local__global_194(global_t, local_t, obj_t, obj_t, obj_t);
extern obj_t global_ginfo_75_globalize_ginfo;
extern obj_t __module__166_module_module;
extern global_t local__global_40_globalize_local__global_194(local_t);
extern obj_t the_closure_238_globalize_free(variable_t, obj_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t require_initialization_114_globalize_local__global_194 = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_globalize_local__global_194();
extern obj_t ___arity_132_tools_args(obj_t, obj_t);
static obj_t default_type_190_globalize_local__global_194();
extern obj_t sfun_ast_var;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t sfun_ginfo_98_globalize_ginfo;
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
static global_t fix_escaping_definition_56_globalize_local__global_194(global_t, local_t, obj_t, obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t local_ginfo_108_globalize_ginfo;
extern obj_t shape_tools_shape(obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern long list_length(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _____74_type_cache;
extern obj_t _the_global_232_globalize_local__global_194(obj_t, obj_t);
extern obj_t __obj__252_type_cache;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern global_t the_global_201_globalize_local__global_194(local_t);
extern obj_t app_ast_node;
static node_t make_escaping_body_209_globalize_local__global_194(local_t, global_t, obj_t, obj_t, local_t, node_t);
static obj_t __cnst[7];

DEFINE_EXPORT_PROCEDURE(local__global_env_170_globalize_local__global_194, _local__global_77_globalize_local__global_1941845, _local__global_77_globalize_local__global_194, 0L, 1);
DEFINE_STRING(string1839_globalize_local__global_194, string1839_globalize_local__global_1941846, "NOW SFUN STATIC VALUE PROCEDURE-REF ENV GLOBALIZE ", 50);
DEFINE_EXPORT_PROCEDURE(the_global_env_148_globalize_local__global_194, _the_global_232_globalize_local__global_1941847, _the_global_232_globalize_local__global_194, 0L, 1);

obj_t 
module_initialization_70_globalize_local__global_194(long checksum_2212, char *from_2213)
{
   if (CBOOL(require_initialization_114_globalize_local__global_194))
     {
	require_initialization_114_globalize_local__global_194 = BBOOL(((bool_t) 0));
	library_modules_init_112_globalize_local__global_194();
	cnst_init_137_globalize_local__global_194();
	imported_modules_init_94_globalize_local__global_194();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_globalize_local__global_194()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70___object(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70___reader(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70___r4_symbols_6_4(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   return BUNSPEC;
}


obj_t 
cnst_init_137_globalize_local__global_194()
{
   {
      obj_t cnst_port_138_2204;
      cnst_port_138_2204 = open_input_string(string1839_globalize_local__global_194);
      {
	 long i_2205;
	 i_2205 = ((long) 6);
       loop_2206:
	 {
	    bool_t test1840_2207;
	    test1840_2207 = (i_2205 == ((long) -1));
	    if (test1840_2207)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1841_2208;
		    {
		       obj_t list1842_2209;
		       {
			  obj_t arg1843_2210;
			  arg1843_2210 = BNIL;
			  list1842_2209 = MAKE_PAIR(cnst_port_138_2204, arg1843_2210);
		       }
		       arg1841_2208 = read___reader(list1842_2209);
		    }
		    CNST_TABLE_SET(i_2205, arg1841_2208);
		 }
		 {
		    int aux_2211;
		    {
		       long aux_2230;
		       aux_2230 = (i_2205 - ((long) 1));
		       aux_2211 = (int) (aux_2230);
		    }
		    {
		       long i_2233;
		       i_2233 = (long) (aux_2211);
		       i_2205 = i_2233;
		       goto loop_2206;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
default_type_190_globalize_local__global_194()
{
   {
      bool_t test1421_939;
      {
	 long n1_1608;
	 n1_1608 = (long) CINT(__optim__89_engine_param);
	 test1421_939 = (n1_1608 < ((long) 2));
      }
      if (test1421_939)
	{
	   return __obj__252_type_cache;
	}
      else
	{
	   return _____74_type_cache;
	}
   }
}


global_t 
local__global_40_globalize_local__global_194(local_t local_1)
{
   {
      bool_t test1422_940;
      {
	 obj_t aux_2238;
	 aux_2238 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1422_940 = CBOOL(aux_2238);
      }
      if (test1422_940)
	{
	   obj_t arg1424_941;
	   arg1424_941 = shape_tools_shape((obj_t) (local_1));
	   {
	      obj_t list1425_942;
	      {
		 obj_t arg1426_943;
		 {
		    obj_t arg1427_944;
		    {
		       obj_t aux_2246;
		       aux_2246 = BCHAR(((unsigned char) '\n'));
		       arg1427_944 = MAKE_PAIR(aux_2246, BNIL);
		    }
		    {
		       obj_t aux_2249;
		       aux_2249 = BCHAR(((unsigned char) ':'));
		       arg1426_943 = MAKE_PAIR(aux_2249, arg1427_944);
		    }
		 }
		 list1425_942 = MAKE_PAIR(arg1424_941, arg1426_943);
	      }
	      print_trace_107_tools_trace(list1425_942);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      global_t global_948;
      global_948 = the_global_201_globalize_local__global_194(local_1);
      {
	 obj_t args_949;
	 {
	    sfun_t obj_1611;
	    {
	       value_t aux_2255;
	       aux_2255 = (((local_t) CREF(local_1))->value);
	       obj_1611 = (sfun_t) (aux_2255);
	    }
	    args_949 = (((sfun_t) CREF(obj_1611))->args);
	 }
	 {
	    value_t info_950;
	    info_950 = (((local_t) CREF(local_1))->value);
	    {
	       obj_t new_body_215_951;
	       {
		  sfun_ginfo_98_t obj_1613;
		  obj_1613 = (sfun_ginfo_98_t) (info_950);
		  {
		     obj_t aux_2261;
		     {
			object_t aux_2262;
			aux_2262 = (object_t) (obj_1613);
			aux_2261 = OBJECT_WIDENING(aux_2262);
		     }
		     new_body_215_951 = (((sfun_ginfo_98_t) CREF(aux_2261))->new_body_215);
		  }
	       }
	       {
		  obj_t kaptured_952;
		  {
		     sfun_ginfo_98_t obj_1614;
		     obj_1614 = (sfun_ginfo_98_t) (info_950);
		     {
			obj_t aux_2267;
			{
			   object_t aux_2268;
			   aux_2268 = (object_t) (obj_1614);
			   aux_2267 = OBJECT_WIDENING(aux_2268);
			}
			kaptured_952 = (((sfun_ginfo_98_t) CREF(aux_2267))->kaptured);
		     }
		  }
		  {
		     {
			bool_t test_2272;
			{
			   local_ginfo_108_t obj_1615;
			   obj_1615 = (local_ginfo_108_t) (local_1);
			   {
			      obj_t aux_2274;
			      {
				 object_t aux_2275;
				 aux_2275 = (object_t) (obj_1615);
				 aux_2274 = OBJECT_WIDENING(aux_2275);
			      }
			      test_2272 = (((local_ginfo_108_t) CREF(aux_2274))->escape__117);
			   }
			}
			if (test_2272)
			  {
			     fix_escaping_definition_56_globalize_local__global_194(global_948, local_1, args_949, kaptured_952, new_body_215_951);
			  }
			else
			  {
			     fix_non_escaping_definition_247_globalize_local__global_194(global_948, local_1, args_949, kaptured_952, new_body_215_951);
			  }
		     }
		     {
			bool_t test1434_954;
			{
			   obj_t aux_2281;
			   aux_2281 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			   test1434_954 = CBOOL(aux_2281);
			}
			if (test1434_954)
			  {
			     obj_t list1435_955;
			     {
				obj_t aux_2287;
				aux_2287 = BCHAR(((unsigned char) '\n'));
				list1435_955 = MAKE_PAIR(aux_2287, BNIL);
			     }
			     print_trace_107_tools_trace(list1435_955);
			  }
			else
			  {
			     BUNSPEC;
			  }
		     }
		     return global_948;
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_local__global_77_globalize_local__global_194(obj_t env_2184, obj_t local_2185)
{
   {
      global_t aux_2291;
      aux_2291 = local__global_40_globalize_local__global_194((local_t) (local_2185));
      return (obj_t) (aux_2291);
   }
}


global_t 
fix_escaping_definition_56_globalize_local__global_194(global_t global_2, local_t local_3, obj_t args_4, obj_t kaptured_5, obj_t body_6)
{
   {
      local_t env_960;
      env_960 = make_local_svar_140_ast_local(CNST_TABLE_REF(((long) 1)), (type_t) (__procedure__226_type_cache));
      {
	 obj_t new_free_31_961;
	 if (NULLP(kaptured_5))
	   {
	      new_free_31_961 = BNIL;
	   }
	 else
	   {
	      obj_t head1371_1061;
	      head1371_1061 = MAKE_PAIR(BNIL, BNIL);
	      {
		 obj_t l1369_1062;
		 obj_t tail1372_1063;
		 l1369_1062 = kaptured_5;
		 tail1372_1063 = head1371_1061;
	       lname1370_1064:
		 if (NULLP(l1369_1062))
		   {
		      new_free_31_961 = CDR(head1371_1061);
		   }
		 else
		   {
		      obj_t new_tail1373_65_1066;
		      {
			 local_t arg1553_1068;
			 {
			    obj_t old_1070;
			    old_1070 = CAR(l1369_1062);
			    {
			       local_t new_1071;
			       {
				  type_t aux_2308;
				  obj_t aux_2305;
				  {
				     obj_t aux_2309;
				     aux_2309 = default_type_190_globalize_local__global_194();
				     aux_2308 = (type_t) (aux_2309);
				  }
				  {
				     local_t obj_1622;
				     obj_1622 = (local_t) (old_1070);
				     aux_2305 = (((local_t) CREF(obj_1622))->id);
				  }
				  new_1071 = make_local_svar_140_ast_local(aux_2305, aux_2308);
			       }
			       {
				  local_ginfo_108_t obj1374_1072;
				  obj1374_1072 = ((local_ginfo_108_t) (new_1071));
				  {
				     local_ginfo_108_t arg1555_1073;
				     {
					local_ginfo_108_t res1807_1626;
					{
					   local_ginfo_108_t new1338_1624;
					   new1338_1624 = ((local_ginfo_108_t) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
					   ((((local_ginfo_108_t) CREF(new1338_1624))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					   res1807_1626 = new1338_1624;
					}
					arg1555_1073 = res1807_1626;
				     }
				     {
					obj_t aux_2318;
					object_t aux_2316;
					aux_2318 = (obj_t) (arg1555_1073);
					aux_2316 = (object_t) (obj1374_1072);
					OBJECT_WIDENING_SET(aux_2316, aux_2318);
				     }
				  }
				  {
				     long arg1557_1074;
				     arg1557_1074 = class_num_218___object(local_ginfo_108_globalize_ginfo);
				     {
					obj_t obj_1627;
					obj_1627 = (obj_t) (obj1374_1072);
					(((obj_t) CREF(obj_1627))->header = MAKE_HEADER(arg1557_1074, 0), BUNSPEC);
				     }
				  }
				  obj1374_1072;
			       }
			       {
				  svar_ginfo_131_t obj1375_1075;
				  obj1375_1075 = ((svar_ginfo_131_t) ((((local_t) CREF(new_1071))->value)));
				  {
				     svar_ginfo_131_t arg1559_1076;
				     {
					svar_ginfo_131_t res1808_1639;
					{
					   svar_ginfo_131_t new1314_1634;
					   new1314_1634 = ((svar_ginfo_131_t) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
					   ((((svar_ginfo_131_t) CREF(new1314_1634))->kaptured__204) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					   ((((svar_ginfo_131_t) CREF(new1314_1634))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
					   ((((svar_ginfo_131_t) CREF(new1314_1634))->mark) = ((long) ((long) -10)), BUNSPEC);
					   ((((svar_ginfo_131_t) CREF(new1314_1634))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					   res1808_1639 = new1314_1634;
					}
					arg1559_1076 = res1808_1639;
				     }
				     {
					obj_t aux_2333;
					object_t aux_2331;
					aux_2333 = (obj_t) (arg1559_1076);
					aux_2331 = (object_t) (obj1375_1075);
					OBJECT_WIDENING_SET(aux_2331, aux_2333);
				     }
				  }
				  {
				     long arg1560_1077;
				     arg1560_1077 = class_num_218___object(svar_ginfo_131_globalize_ginfo);
				     {
					obj_t obj_1640;
					obj_1640 = (obj_t) (obj1375_1075);
					(((obj_t) CREF(obj_1640))->header = MAKE_HEADER(arg1560_1077, 0), BUNSPEC);
				     }
				  }
				  obj1375_1075;
			       }
			       {
				  obj_t arg1561_1078;
				  {
				     local_t obj_1642;
				     obj_1642 = (local_t) (old_1070);
				     arg1561_1078 = (((local_t) CREF(obj_1642))->access);
				  }
				  {
				     obj_t res1809_1645;
				     {
					obj_t x_2188;
					x_2188 = ((((local_t) CREF(new_1071))->access) = ((obj_t) arg1561_1078), BUNSPEC);
					res1809_1645 = BUNSPEC;
				     }
				     res1809_1645;
				  }
			       }
			       arg1553_1068 = new_1071;
			    }
			 }
			 {
			    obj_t aux_2342;
			    aux_2342 = (obj_t) (arg1553_1068);
			    new_tail1373_65_1066 = MAKE_PAIR(aux_2342, BNIL);
			 }
		      }
		      SET_CDR(tail1372_1063, new_tail1373_65_1066);
		      {
			 obj_t tail1372_2348;
			 obj_t l1369_2346;
			 l1369_2346 = CDR(l1369_1062);
			 tail1372_2348 = new_tail1373_65_1066;
			 tail1372_1063 = tail1372_2348;
			 l1369_1062 = l1369_2346;
			 goto lname1370_1064;
		      }
		   }
	      }
	   }
	 {
	    obj_t new_args_235_962;
	    if (NULLP(args_4))
	      {
		 new_args_235_962 = BNIL;
	      }
	    else
	      {
		 obj_t head1380_1033;
		 head1380_1033 = MAKE_PAIR(BNIL, BNIL);
		 {
		    obj_t l1376_1034;
		    obj_t tail1381_1035;
		    l1376_1034 = args_4;
		    tail1381_1035 = head1380_1033;
		  lname1379_1036:
		    if (NULLP(l1376_1034))
		      {
			 new_args_235_962 = CDR(head1380_1033);
		      }
		    else
		      {
			 obj_t new_tail1382_105_1038;
			 {
			    local_t arg1529_1040;
			    {
			       obj_t old_1042;
			       old_1042 = CAR(l1376_1034);
			       {
				  local_t new_1043;
				  {
				     type_t aux_2359;
				     obj_t aux_2356;
				     {
					obj_t aux_2360;
					aux_2360 = default_type_190_globalize_local__global_194();
					aux_2359 = (type_t) (aux_2360);
				     }
				     {
					local_t obj_1657;
					obj_1657 = (local_t) (old_1042);
					aux_2356 = (((local_t) CREF(obj_1657))->id);
				     }
				     new_1043 = make_local_svar_140_ast_local(aux_2356, aux_2359);
				  }
				  {
				     local_ginfo_108_t obj1383_1044;
				     obj1383_1044 = ((local_ginfo_108_t) (new_1043));
				     {
					local_ginfo_108_t arg1532_1045;
					{
					   local_ginfo_108_t res1810_1661;
					   {
					      local_ginfo_108_t new1338_1659;
					      new1338_1659 = ((local_ginfo_108_t) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
					      ((((local_ginfo_108_t) CREF(new1338_1659))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					      res1810_1661 = new1338_1659;
					   }
					   arg1532_1045 = res1810_1661;
					}
					{
					   obj_t aux_2369;
					   object_t aux_2367;
					   aux_2369 = (obj_t) (arg1532_1045);
					   aux_2367 = (object_t) (obj1383_1044);
					   OBJECT_WIDENING_SET(aux_2367, aux_2369);
					}
				     }
				     {
					long arg1534_1046;
					arg1534_1046 = class_num_218___object(local_ginfo_108_globalize_ginfo);
					{
					   obj_t obj_1662;
					   obj_1662 = (obj_t) (obj1383_1044);
					   (((obj_t) CREF(obj_1662))->header = MAKE_HEADER(arg1534_1046, 0), BUNSPEC);
					}
				     }
				     obj1383_1044;
				  }
				  {
				     svar_ginfo_131_t obj1385_1047;
				     obj1385_1047 = ((svar_ginfo_131_t) ((((local_t) CREF(new_1043))->value)));
				     {
					svar_ginfo_131_t arg1535_1048;
					{
					   bool_t arg1536_1049;
					   {
					      svar_ginfo_131_t obj_1666;
					      {
						 value_t aux_2377;
						 {
						    local_t obj_1665;
						    obj_1665 = (local_t) (old_1042);
						    aux_2377 = (((local_t) CREF(obj_1665))->value);
						 }
						 obj_1666 = (svar_ginfo_131_t) (aux_2377);
					      }
					      {
						 obj_t aux_2381;
						 {
						    object_t aux_2382;
						    aux_2382 = (object_t) (obj_1666);
						    aux_2381 = OBJECT_WIDENING(aux_2382);
						 }
						 arg1536_1049 = (((svar_ginfo_131_t) CREF(aux_2381))->kaptured__204);
					      }
					   }
					   {
					      svar_ginfo_131_t res1811_1676;
					      {
						 svar_ginfo_131_t new1314_1671;
						 new1314_1671 = ((svar_ginfo_131_t) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
						 ((((svar_ginfo_131_t) CREF(new1314_1671))->kaptured__204) = ((bool_t) arg1536_1049), BUNSPEC);
						 ((((svar_ginfo_131_t) CREF(new1314_1671))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
						 ((((svar_ginfo_131_t) CREF(new1314_1671))->mark) = ((long) ((long) -10)), BUNSPEC);
						 ((((svar_ginfo_131_t) CREF(new1314_1671))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						 res1811_1676 = new1314_1671;
					      }
					      arg1535_1048 = res1811_1676;
					   }
					}
					{
					   obj_t aux_2393;
					   object_t aux_2391;
					   aux_2393 = (obj_t) (arg1535_1048);
					   aux_2391 = (object_t) (obj1385_1047);
					   OBJECT_WIDENING_SET(aux_2391, aux_2393);
					}
				     }
				     {
					long arg1540_1053;
					arg1540_1053 = class_num_218___object(svar_ginfo_131_globalize_ginfo);
					{
					   obj_t obj_1677;
					   obj_1677 = (obj_t) (obj1385_1047);
					   (((obj_t) CREF(obj_1677))->header = MAKE_HEADER(arg1540_1053, 0), BUNSPEC);
					}
				     }
				     obj1385_1047;
				  }
				  {
				     obj_t arg1541_1054;
				     {
					local_t obj_1679;
					obj_1679 = (local_t) (old_1042);
					arg1541_1054 = (((local_t) CREF(obj_1679))->access);
				     }
				     {
					obj_t res1812_1682;
					{
					   obj_t x_2189;
					   x_2189 = ((((local_t) CREF(new_1043))->access) = ((obj_t) arg1541_1054), BUNSPEC);
					   res1812_1682 = BUNSPEC;
					}
					res1812_1682;
				     }
				  }
				  arg1529_1040 = new_1043;
			       }
			    }
			    {
			       obj_t aux_2402;
			       aux_2402 = (obj_t) (arg1529_1040);
			       new_tail1382_105_1038 = MAKE_PAIR(aux_2402, BNIL);
			    }
			 }
			 SET_CDR(tail1381_1035, new_tail1382_105_1038);
			 {
			    obj_t tail1381_2408;
			    obj_t l1376_2406;
			    l1376_2406 = CDR(l1376_1034);
			    tail1381_2408 = new_tail1382_105_1038;
			    tail1381_1035 = tail1381_2408;
			    l1376_1034 = l1376_2406;
			    goto lname1379_1036;
			 }
		      }
		 }
	      }
	    {
	       sfun_t new_fun_115_964;
	       {
		  sfun_t duplicated1386_1017;
		  {
		     value_t aux_2409;
		     aux_2409 = (((local_t) CREF(local_3))->value);
		     duplicated1386_1017 = (sfun_t) (aux_2409);
		  }
		  {
		     obj_t arg1501_1018;
		     obj_t arg1505_1019;
		     obj_t arg1506_1020;
		     obj_t arg1507_1021;
		     bool_t arg1509_1022;
		     obj_t arg1510_1023;
		     obj_t arg1511_1024;
		     obj_t arg1513_1025;
		     obj_t arg1514_1026;
		     obj_t arg1517_1027;
		     obj_t arg1518_1028;
		     {
			obj_t aux_2412;
			{
			   long aux_2413;
			   aux_2413 = (((sfun_t) CREF(duplicated1386_1017))->arity);
			   aux_2412 = BINT(aux_2413);
			}
			arg1501_1018 = ___arity_132_tools_args(aux_2412, BINT(((long) 1)));
		     }
		     arg1505_1019 = (((sfun_t) CREF(duplicated1386_1017))->side_effect__165);
		     arg1506_1020 = (((sfun_t) CREF(duplicated1386_1017))->predicate_of_78);
		     arg1507_1021 = (((sfun_t) CREF(duplicated1386_1017))->stack_allocator_172);
		     arg1509_1022 = (((sfun_t) CREF(duplicated1386_1017))->top__138);
		     arg1510_1023 = (((sfun_t) CREF(duplicated1386_1017))->the_closure_238);
		     arg1511_1024 = (((sfun_t) CREF(duplicated1386_1017))->property);
		     {
			obj_t aux_2424;
			aux_2424 = (obj_t) (env_960);
			arg1513_1025 = MAKE_PAIR(aux_2424, new_args_235_962);
		     }
		     arg1514_1026 = (((sfun_t) CREF(duplicated1386_1017))->body);
		     arg1517_1027 = (((sfun_t) CREF(duplicated1386_1017))->class);
		     arg1518_1028 = (((sfun_t) CREF(duplicated1386_1017))->dsssl_keywords_243);
		     {
			sfun_t res1813_1727;
			{
			   long arity_1701;
			   arity_1701 = (long) CINT(arg1501_1018);
			   {
			      sfun_t new1077_1712;
			      new1077_1712 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
			      {
				 long arg1788_1713;
				 arg1788_1713 = class_num_218___object(sfun_ast_var);
				 {
				    obj_t obj_1725;
				    obj_1725 = (obj_t) (new1077_1712);
				    (((obj_t) CREF(obj_1725))->header = MAKE_HEADER(arg1788_1713, 0), BUNSPEC);
				 }
			      }
			      {
				 object_t aux_2435;
				 aux_2435 = (object_t) (new1077_1712);
				 OBJECT_WIDENING_SET(aux_2435, BFALSE);
			      }
			      ((((sfun_t) CREF(new1077_1712))->arity) = ((long) arity_1701), BUNSPEC);
			      ((((sfun_t) CREF(new1077_1712))->side_effect__165) = ((obj_t) arg1505_1019), BUNSPEC);
			      ((((sfun_t) CREF(new1077_1712))->predicate_of_78) = ((obj_t) arg1506_1020), BUNSPEC);
			      ((((sfun_t) CREF(new1077_1712))->stack_allocator_172) = ((obj_t) arg1507_1021), BUNSPEC);
			      ((((sfun_t) CREF(new1077_1712))->top__138) = ((bool_t) arg1509_1022), BUNSPEC);
			      ((((sfun_t) CREF(new1077_1712))->the_closure_238) = ((obj_t) arg1510_1023), BUNSPEC);
			      ((((sfun_t) CREF(new1077_1712))->property) = ((obj_t) arg1511_1024), BUNSPEC);
			      ((((sfun_t) CREF(new1077_1712))->args) = ((obj_t) arg1513_1025), BUNSPEC);
			      ((((sfun_t) CREF(new1077_1712))->body) = ((obj_t) arg1514_1026), BUNSPEC);
			      ((((sfun_t) CREF(new1077_1712))->class) = ((obj_t) arg1517_1027), BUNSPEC);
			      ((((sfun_t) CREF(new1077_1712))->dsssl_keywords_243) = ((obj_t) arg1518_1028), BUNSPEC);
			      res1813_1727 = new1077_1712;
			   }
			}
			new_fun_115_964 = res1813_1727;
		     }
		  }
	       }
	       {
		  {
		     obj_t res1814_1730;
		     {
			global_ginfo_75_t obj_1728;
			obj_1728 = (global_ginfo_75_t) (global_2);
			{
			   obj_t x_2190;
			   {
			      obj_t aux_2450;
			      {
				 object_t aux_2451;
				 aux_2451 = (object_t) (obj_1728);
				 aux_2450 = OBJECT_WIDENING(aux_2451);
			      }
			      x_2190 = ((((global_ginfo_75_t) CREF(aux_2450))->escape__117) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			   }
			   res1814_1730 = BUNSPEC;
			}
		     }
		     res1814_1730;
		  }
		  {
		     sfun_ginfo_98_t obj1388_965;
		     obj1388_965 = ((sfun_ginfo_98_t) (new_fun_115_964));
		     {
			sfun_ginfo_98_t arg1446_966;
			{
			   sfun_ginfo_98_t res1815_1768;
			   {
			      obj_t cfrom__119_1733;
			      obj_t cto__14_1735;
			      obj_t the_global_201_1742;
			      obj_t kaptured_1743;
			      obj_t new_body_215_1744;
			      cfrom__119_1733 = BFALSE;
			      cto__14_1735 = BFALSE;
			      the_global_201_1742 = BFALSE;
			      kaptured_1743 = BFALSE;
			      new_body_215_1744 = BFALSE;
			      {
				 sfun_ginfo_98_t new1280_1749;
				 new1280_1749 = ((sfun_ginfo_98_t) BREF(GC_MALLOC(sizeof(struct sfun_ginfo_98))));
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->g__219) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->cfrom) = ((obj_t) BNIL), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->cfrom__119) = ((obj_t) cfrom__119_1733), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->cto) = ((obj_t) BNIL), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->cto__14) = ((obj_t) cto__14_1735), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->cfunction) = ((obj_t) BNIL), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->integrator) = ((obj_t) BNIL), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->integrated) = ((obj_t) BNIL), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->plugged_in_15) = ((obj_t) BNIL), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->mark) = ((long) ((long) -10)), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->free_mark_81) = ((obj_t) BNIL), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->the_global_201) = ((obj_t) the_global_201_1742), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->kaptured) = ((obj_t) kaptured_1743), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->new_body_215) = ((obj_t) new_body_215_1744), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->bmark) = ((long) ((long) -10)), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->umark) = ((long) ((long) -10)), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->free) = ((obj_t) BUNSPEC), BUNSPEC);
				 ((((sfun_ginfo_98_t) CREF(new1280_1749))->bound) = ((obj_t) BNIL), BUNSPEC);
				 res1815_1768 = new1280_1749;
			      }
			   }
			   arg1446_966 = res1815_1768;
			}
			{
			   obj_t aux_2477;
			   object_t aux_2475;
			   aux_2477 = (obj_t) (arg1446_966);
			   aux_2475 = (object_t) (obj1388_965);
			   OBJECT_WIDENING_SET(aux_2475, aux_2477);
			}
		     }
		     {
			long arg1465_978;
			arg1465_978 = class_num_218___object(sfun_ginfo_98_globalize_ginfo);
			{
			   obj_t obj_1769;
			   obj_1769 = (obj_t) (obj1388_965);
			   (((obj_t) CREF(obj_1769))->header = MAKE_HEADER(arg1465_978, 0), BUNSPEC);
			}
		     }
		     obj1388_965;
		  }
		  {
		     svar_ginfo_131_t obj1389_979;
		     obj1389_979 = ((svar_ginfo_131_t) ((((local_t) CREF(env_960))->value)));
		     {
			svar_ginfo_131_t arg1466_980;
			{
			   svar_ginfo_131_t res1816_1781;
			   {
			      svar_ginfo_131_t new1314_1776;
			      new1314_1776 = ((svar_ginfo_131_t) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
			      ((((svar_ginfo_131_t) CREF(new1314_1776))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			      ((((svar_ginfo_131_t) CREF(new1314_1776))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
			      ((((svar_ginfo_131_t) CREF(new1314_1776))->mark) = ((long) ((long) -10)), BUNSPEC);
			      ((((svar_ginfo_131_t) CREF(new1314_1776))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			      res1816_1781 = new1314_1776;
			   }
			   arg1466_980 = res1816_1781;
			}
			{
			   obj_t aux_2492;
			   object_t aux_2490;
			   aux_2492 = (obj_t) (arg1466_980);
			   aux_2490 = (object_t) (obj1389_979);
			   OBJECT_WIDENING_SET(aux_2490, aux_2492);
			}
		     }
		     {
			long arg1467_981;
			arg1467_981 = class_num_218___object(svar_ginfo_131_globalize_ginfo);
			{
			   obj_t obj_1782;
			   obj_1782 = (obj_t) (obj1389_979);
			   (((obj_t) CREF(obj_1782))->header = MAKE_HEADER(arg1467_981, 0), BUNSPEC);
			}
		     }
		     obj1389_979;
		  }
		  {
		     obj_t res1817_1786;
		     {
			type_t val1046_1785;
			val1046_1785 = (type_t) (__obj__252_type_cache);
			{
			   obj_t x_2191;
			   x_2191 = ((((global_t) CREF(global_2))->type) = ((type_t) val1046_1785), BUNSPEC);
			   res1817_1786 = BUNSPEC;
			}
		     }
		     res1817_1786;
		  }
		  {
		     obj_t l1390_982;
		     {
			obj_t aux_2509;
			aux_2509 = (((sfun_t) CREF(new_fun_115_964))->args);
			l1390_982 = CDR(aux_2509);
		     }
		   lname1392_983:
		     if (PAIRP(l1390_982))
		       {
			  {
			     obj_t res1818_1793;
			     {
				local_t obj_1791;
				type_t val1060_1792;
				{
				   obj_t aux_2502;
				   aux_2502 = CAR(l1390_982);
				   obj_1791 = (local_t) (aux_2502);
				}
				val1060_1792 = (type_t) (__obj__252_type_cache);
				{
				   obj_t x_2192;
				   x_2192 = ((((local_t) CREF(obj_1791))->type) = ((type_t) val1060_1792), BUNSPEC);
				   res1818_1793 = BUNSPEC;
				}
			     }
			     res1818_1793;
			  }
			  {
			     obj_t l1390_2507;
			     l1390_2507 = CDR(l1390_982);
			     l1390_982 = l1390_2507;
			     goto lname1392_983;
			  }
		       }
		     else
		       {
			  ((bool_t) 1);
		       }
		  }
		  {
		     obj_t res1819_1797;
		     {
			value_t val1047_1796;
			val1047_1796 = (value_t) (new_fun_115_964);
			{
			   obj_t x_2193;
			   x_2193 = ((((global_t) CREF(global_2))->value) = ((value_t) val1047_1796), BUNSPEC);
			   res1819_1797 = BUNSPEC;
			}
		     }
		     res1819_1797;
		  }
		  {
		     node_t arg1474_989;
		     {
			node_t arg1476_990;
			{
			   obj_t arg1477_991;
			   {
			      obj_t arg1478_992;
			      obj_t arg1480_993;
			      {
				 obj_t arg1481_994;
				 arg1481_994 = the_closure_238_globalize_free((variable_t) (local_3), BFALSE);
				 {
				    obj_t aux_2516;
				    aux_2516 = (obj_t) (env_960);
				    arg1478_992 = MAKE_PAIR(arg1481_994, aux_2516);
				 }
			      }
			      if (NULLP(kaptured_5))
				{
				   arg1480_993 = BNIL;
				}
			      else
				{
				   obj_t head1395_998;
				   {
				      obj_t arg1497_1013;
				      {
					 obj_t aux_2523;
					 obj_t aux_2521;
					 aux_2523 = CAR(new_free_31_961);
					 aux_2521 = CAR(kaptured_5);
					 arg1497_1013 = MAKE_PAIR(aux_2521, aux_2523);
				      }
				      head1395_998 = MAKE_PAIR(arg1497_1013, BNIL);
				   }
				   {
				      obj_t ll1393_999;
				      obj_t ll1394_1000;
				      obj_t tail1396_1001;
				      ll1393_999 = CDR(kaptured_5);
				      ll1394_1000 = CDR(new_free_31_961);
				      tail1396_1001 = head1395_998;
				    lname1399_1002:
				      if (NULLP(ll1393_999))
					{
					   arg1480_993 = head1395_998;
					}
				      else
					{
					   obj_t new_tail1397_17_1006;
					   {
					      obj_t arg1490_1009;
					      {
						 obj_t aux_2531;
						 obj_t aux_2529;
						 aux_2531 = CAR(ll1394_1000);
						 aux_2529 = CAR(ll1393_999);
						 arg1490_1009 = MAKE_PAIR(aux_2529, aux_2531);
					      }
					      new_tail1397_17_1006 = MAKE_PAIR(arg1490_1009, BNIL);
					   }
					   SET_CDR(tail1396_1001, new_tail1397_17_1006);
					   {
					      obj_t tail1396_2540;
					      obj_t ll1394_2538;
					      obj_t ll1393_2536;
					      ll1393_2536 = CDR(ll1393_999);
					      ll1394_2538 = CDR(ll1394_1000);
					      tail1396_2540 = new_tail1397_17_1006;
					      tail1396_1001 = tail1396_2540;
					      ll1394_1000 = ll1394_2538;
					      ll1393_999 = ll1393_2536;
					      goto lname1399_1002;
					   }
					}
				   }
				}
			      arg1477_991 = MAKE_PAIR(arg1478_992, arg1480_993);
			   }
			   arg1476_990 = node_globalize__229_globalize_node((node_t) (body_6), (variable_t) (local_3), arg1477_991);
			}
			arg1474_989 = make_escaping_body_209_globalize_local__global_194(local_3, global_2, new_args_235_962, new_free_31_961, env_960, arg1476_990);
		     }
		     {
			obj_t res1820_1824;
			{
			   obj_t val1086_1823;
			   val1086_1823 = (obj_t) (arg1474_989);
			   {
			      obj_t x_2194;
			      x_2194 = ((((sfun_t) CREF(new_fun_115_964))->body) = ((obj_t) val1086_1823), BUNSPEC);
			      res1820_1824 = BUNSPEC;
			   }
			}
			res1820_1824;
		     }
		  }
		  return global_2;
	       }
	    }
	 }
      }
   }
}


node_t 
make_escaping_body_209_globalize_local__global_194(local_t local_7, global_t global_8, obj_t args_9, obj_t kaptured_10, local_t env_11, node_t body_12)
{
   {
      obj_t stack_1084;
      obj_t loc_1085;
      {
	 obj_t list1606_1131;
	 {
	    obj_t aux_2550;
	    aux_2550 = (obj_t) (env_11);
	    list1606_1131 = MAKE_PAIR(aux_2550, BNIL);
	 }
	 stack_1084 = list1606_1131;
      }
      loc_1085 = (((node_t) CREF(body_12))->loc);
      {
	 obj_t res1821_1830;
	 {
	    sfun_t obj_1828;
	    obj_t val1086_1829;
	    {
	       value_t aux_2554;
	       aux_2554 = (((local_t) CREF(local_7))->value);
	       obj_1828 = (sfun_t) (aux_2554);
	    }
	    val1086_1829 = (obj_t) (body_12);
	    {
	       obj_t x_2195;
	       x_2195 = ((((sfun_t) CREF(obj_1828))->body) = ((obj_t) val1086_1829), BUNSPEC);
	       res1821_1830 = BUNSPEC;
	    }
	 }
	 res1821_1830;
      }
      {
	 obj_t arg1568_1087;
	 let_fun_218_t arg1570_1088;
	 {
	    obj_t kaptured_1089;
	    long num_1090;
	    obj_t res_1091;
	    kaptured_1089 = kaptured_10;
	    num_1090 = ((long) 0);
	    res_1091 = BNIL;
	  loop_1092:
	    if (NULLP(kaptured_1089))
	      {
		 arg1568_1087 = reverse__39___r4_pairs_and_lists_6_3(res_1091);
	      }
	    else
	      {
		 obj_t arg1574_1096;
		 long arg1575_1097;
		 obj_t arg1576_1098;
		 arg1574_1096 = CDR(kaptured_1089);
		 arg1575_1097 = (num_1090 + ((long) 1));
		 {
		    obj_t arg1577_1099;
		    {
		       obj_t arg1578_1100;
		       node_t arg1579_1101;
		       arg1578_1100 = CAR(kaptured_1089);
		       {
			  obj_t arg1582_1102;
			  obj_t arg1583_1103;
			  {
			     obj_t arg1584_1104;
			     obj_t arg1585_1105;
			     arg1584_1104 = CNST_TABLE_REF(((long) 2));
			     arg1585_1105 = CNST_TABLE_REF(((long) 1));
			     {
				obj_t list1588_1107;
				{
				   obj_t arg1589_1108;
				   {
				      obj_t arg1590_1109;
				      arg1590_1109 = MAKE_PAIR(BNIL, BNIL);
				      {
					 obj_t aux_2568;
					 aux_2568 = BINT(num_1090);
					 arg1589_1108 = MAKE_PAIR(aux_2568, arg1590_1109);
				      }
				   }
				   list1588_1107 = MAKE_PAIR(arg1585_1105, arg1589_1108);
				}
				arg1582_1102 = cons__138___r4_pairs_and_lists_6_3(arg1584_1104, list1588_1107);
			     }
			  }
			  arg1583_1103 = CNST_TABLE_REF(((long) 3));
			  arg1579_1101 = sexp__node_235_ast_sexp(arg1582_1102, stack_1084, loc_1085, arg1583_1103);
		       }
		       {
			  obj_t aux_2575;
			  aux_2575 = (obj_t) (arg1579_1101);
			  arg1577_1099 = MAKE_PAIR(arg1578_1100, aux_2575);
		       }
		    }
		    arg1576_1098 = MAKE_PAIR(arg1577_1099, res_1091);
		 }
		 {
		    obj_t res_2581;
		    long num_2580;
		    obj_t kaptured_2579;
		    kaptured_2579 = arg1574_1096;
		    num_2580 = arg1575_1097;
		    res_2581 = arg1576_1098;
		    res_1091 = res_2581;
		    num_1090 = num_2580;
		    kaptured_1089 = kaptured_2579;
		    goto loop_1092;
		 }
	      }
	 }
	 {
	    obj_t arg1592_1111;
	    app_t arg1593_1112;
	    {
	       obj_t list1594_1113;
	       {
		  obj_t aux_2582;
		  aux_2582 = (obj_t) (local_7);
		  list1594_1113 = MAKE_PAIR(aux_2582, BNIL);
	       }
	       arg1592_1111 = list1594_1113;
	    }
	    {
	       var_t arg1596_1115;
	       obj_t arg1597_1116;
	       {
		  var_t res1822_1851;
		  {
		     type_t type_1842;
		     variable_t variable_1843;
		     type_1842 = (type_t) (_____74_type_cache);
		     variable_1843 = (variable_t) (local_7);
		     {
			var_t new1137_1844;
			new1137_1844 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
			{
			   long arg1767_1845;
			   arg1767_1845 = class_num_218___object(var_ast_node);
			   {
			      obj_t obj_1849;
			      obj_1849 = (obj_t) (new1137_1844);
			      (((obj_t) CREF(obj_1849))->header = MAKE_HEADER(arg1767_1845, 0), BUNSPEC);
			   }
			}
			{
			   object_t aux_2591;
			   aux_2591 = (object_t) (new1137_1844);
			   OBJECT_WIDENING_SET(aux_2591, BFALSE);
			}
			((((var_t) CREF(new1137_1844))->loc) = ((obj_t) loc_1085), BUNSPEC);
			((((var_t) CREF(new1137_1844))->type) = ((type_t) type_1842), BUNSPEC);
			((((var_t) CREF(new1137_1844))->variable) = ((variable_t) variable_1843), BUNSPEC);
			res1822_1851 = new1137_1844;
		     }
		  }
		  arg1596_1115 = res1822_1851;
	       }
	       if (NULLP(args_9))
		 {
		    arg1597_1116 = BNIL;
		 }
	       else
		 {
		    obj_t head1402_1119;
		    head1402_1119 = MAKE_PAIR(BNIL, BNIL);
		    {
		       obj_t l1400_1120;
		       obj_t tail1403_1121;
		       l1400_1120 = args_9;
		       tail1403_1121 = head1402_1119;
		     lname1401_1122:
		       if (NULLP(l1400_1120))
			 {
			    arg1597_1116 = CDR(head1402_1119);
			 }
		       else
			 {
			    obj_t new_tail1404_26_1124;
			    {
			       var_t arg1601_1126;
			       {
				  var_t res1823_1868;
				  {
				     type_t type_1859;
				     variable_t variable_1860;
				     type_1859 = (type_t) (_____74_type_cache);
				     {
					obj_t aux_2604;
					aux_2604 = CAR(l1400_1120);
					variable_1860 = (variable_t) (aux_2604);
				     }
				     {
					var_t new1137_1861;
					new1137_1861 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
					{
					   long arg1767_1862;
					   arg1767_1862 = class_num_218___object(var_ast_node);
					   {
					      obj_t obj_1866;
					      obj_1866 = (obj_t) (new1137_1861);
					      (((obj_t) CREF(obj_1866))->header = MAKE_HEADER(arg1767_1862, 0), BUNSPEC);
					   }
					}
					{
					   object_t aux_2611;
					   aux_2611 = (object_t) (new1137_1861);
					   OBJECT_WIDENING_SET(aux_2611, BFALSE);
					}
					((((var_t) CREF(new1137_1861))->loc) = ((obj_t) loc_1085), BUNSPEC);
					((((var_t) CREF(new1137_1861))->type) = ((type_t) type_1859), BUNSPEC);
					((((var_t) CREF(new1137_1861))->variable) = ((variable_t) variable_1860), BUNSPEC);
					res1823_1868 = new1137_1861;
				     }
				  }
				  arg1601_1126 = res1823_1868;
			       }
			       {
				  obj_t aux_2617;
				  aux_2617 = (obj_t) (arg1601_1126);
				  new_tail1404_26_1124 = MAKE_PAIR(aux_2617, BNIL);
			       }
			    }
			    SET_CDR(tail1403_1121, new_tail1404_26_1124);
			    {
			       obj_t tail1403_2623;
			       obj_t l1400_2621;
			       l1400_2621 = CDR(l1400_1120);
			       tail1403_2623 = new_tail1404_26_1124;
			       tail1403_1121 = tail1403_2623;
			       l1400_1120 = l1400_2621;
			       goto lname1401_1122;
			    }
			 }
		    }
		 }
	       {
		  app_t res1824_1890;
		  {
		     type_t type_1875;
		     type_1875 = (type_t) (_____74_type_cache);
		     {
			app_t new1160_1880;
			new1160_1880 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
			{
			   long arg1756_1881;
			   arg1756_1881 = class_num_218___object(app_ast_node);
			   {
			      obj_t obj_1888;
			      obj_1888 = (obj_t) (new1160_1880);
			      (((obj_t) CREF(obj_1888))->header = MAKE_HEADER(arg1756_1881, 0), BUNSPEC);
			   }
			}
			{
			   object_t aux_2629;
			   aux_2629 = (object_t) (new1160_1880);
			   OBJECT_WIDENING_SET(aux_2629, BFALSE);
			}
			((((app_t) CREF(new1160_1880))->loc) = ((obj_t) loc_1085), BUNSPEC);
			((((app_t) CREF(new1160_1880))->type) = ((type_t) type_1875), BUNSPEC);
			((((app_t) CREF(new1160_1880))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			((((app_t) CREF(new1160_1880))->fun) = ((var_t) arg1596_1115), BUNSPEC);
			((((app_t) CREF(new1160_1880))->args) = ((obj_t) arg1597_1116), BUNSPEC);
			((((app_t) CREF(new1160_1880))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
			res1824_1890 = new1160_1880;
		     }
		  }
		  arg1593_1112 = res1824_1890;
	       }
	    }
	    {
	       let_fun_218_t res1825_1905;
	       {
		  type_t type_1892;
		  node_t body_1895;
		  type_1892 = (type_t) (_____74_type_cache);
		  body_1895 = (node_t) (arg1593_1112);
		  {
		     let_fun_218_t new1228_1896;
		     new1228_1896 = ((let_fun_218_t) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
		     {
			long arg1734_1897;
			arg1734_1897 = class_num_218___object(let_fun_218_ast_node);
			{
			   obj_t obj_1903;
			   obj_1903 = (obj_t) (new1228_1896);
			   (((obj_t) CREF(obj_1903))->header = MAKE_HEADER(arg1734_1897, 0), BUNSPEC);
			}
		     }
		     {
			object_t aux_2644;
			aux_2644 = (object_t) (new1228_1896);
			OBJECT_WIDENING_SET(aux_2644, BFALSE);
		     }
		     ((((let_fun_218_t) CREF(new1228_1896))->loc) = ((obj_t) loc_1085), BUNSPEC);
		     ((((let_fun_218_t) CREF(new1228_1896))->type) = ((type_t) type_1892), BUNSPEC);
		     ((((let_fun_218_t) CREF(new1228_1896))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		     ((((let_fun_218_t) CREF(new1228_1896))->locals) = ((obj_t) arg1592_1111), BUNSPEC);
		     ((((let_fun_218_t) CREF(new1228_1896))->body) = ((node_t) body_1895), BUNSPEC);
		     res1825_1905 = new1228_1896;
		  }
	       }
	       arg1570_1088 = res1825_1905;
	    }
	 }
	 {
	    let_var_6_t res1826_1922;
	    {
	       type_t type_1907;
	       node_t body_1910;
	       type_1907 = (type_t) (_____74_type_cache);
	       body_1910 = (node_t) (arg1570_1088);
	       {
		  let_var_6_t new1236_1912;
		  new1236_1912 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
		  {
		     long arg1732_1913;
		     arg1732_1913 = class_num_218___object(let_var_6_ast_node);
		     {
			obj_t obj_1920;
			obj_1920 = (obj_t) (new1236_1912);
			(((obj_t) CREF(obj_1920))->header = MAKE_HEADER(arg1732_1913, 0), BUNSPEC);
		     }
		  }
		  {
		     object_t aux_2658;
		     aux_2658 = (object_t) (new1236_1912);
		     OBJECT_WIDENING_SET(aux_2658, BFALSE);
		  }
		  ((((let_var_6_t) CREF(new1236_1912))->loc) = ((obj_t) loc_1085), BUNSPEC);
		  ((((let_var_6_t) CREF(new1236_1912))->type) = ((type_t) type_1907), BUNSPEC);
		  ((((let_var_6_t) CREF(new1236_1912))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		  ((((let_var_6_t) CREF(new1236_1912))->bindings) = ((obj_t) arg1568_1087), BUNSPEC);
		  ((((let_var_6_t) CREF(new1236_1912))->body) = ((node_t) body_1910), BUNSPEC);
		  ((((let_var_6_t) CREF(new1236_1912))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		  res1826_1922 = new1236_1912;
	       }
	    }
	    return (node_t) (res1826_1922);
	 }
      }
   }
}


global_t 
fix_non_escaping_definition_247_globalize_local__global_194(global_t global_13, local_t local_14, obj_t args_15, obj_t kaptured_16, obj_t body_17)
{
   {
      obj_t add_args_4_1133;
      if (NULLP(kaptured_16))
	{
	   add_args_4_1133 = BNIL;
	}
      else
	{
	   obj_t head1408_1180;
	   head1408_1180 = MAKE_PAIR(BNIL, BNIL);
	   {
	      obj_t l1405_1181;
	      obj_t tail1409_1182;
	      l1405_1181 = kaptured_16;
	      tail1409_1182 = head1408_1180;
	    lname1407_1183:
	      if (NULLP(l1405_1181))
		{
		   add_args_4_1133 = CDR(head1408_1180);
		}
	      else
		{
		   obj_t new_tail1410_229_1185;
		   {
		      local_t arg1661_1187;
		      {
			 obj_t old_1189;
			 old_1189 = CAR(l1405_1181);
			 {
			    local_t new_1190;
			    {
			       type_t aux_2678;
			       obj_t aux_2675;
			       {
				  obj_t aux_2679;
				  aux_2679 = default_type_190_globalize_local__global_194();
				  aux_2678 = (type_t) (aux_2679);
			       }
			       {
				  local_t obj_1929;
				  obj_1929 = (local_t) (old_1189);
				  aux_2675 = (((local_t) CREF(obj_1929))->id);
			       }
			       new_1190 = make_local_svar_140_ast_local(aux_2675, aux_2678);
			    }
			    {
			       local_ginfo_108_t obj1411_1191;
			       obj1411_1191 = ((local_ginfo_108_t) (new_1190));
			       {
				  local_ginfo_108_t arg1664_1192;
				  {
				     local_ginfo_108_t res1827_1933;
				     {
					local_ginfo_108_t new1338_1931;
					new1338_1931 = ((local_ginfo_108_t) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
					((((local_ginfo_108_t) CREF(new1338_1931))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					res1827_1933 = new1338_1931;
				     }
				     arg1664_1192 = res1827_1933;
				  }
				  {
				     obj_t aux_2688;
				     object_t aux_2686;
				     aux_2688 = (obj_t) (arg1664_1192);
				     aux_2686 = (object_t) (obj1411_1191);
				     OBJECT_WIDENING_SET(aux_2686, aux_2688);
				  }
			       }
			       {
				  long arg1665_1193;
				  arg1665_1193 = class_num_218___object(local_ginfo_108_globalize_ginfo);
				  {
				     obj_t obj_1934;
				     obj_1934 = (obj_t) (obj1411_1191);
				     (((obj_t) CREF(obj_1934))->header = MAKE_HEADER(arg1665_1193, 0), BUNSPEC);
				  }
			       }
			       obj1411_1191;
			    }
			    {
			       svar_ginfo_131_t obj1412_1194;
			       obj1412_1194 = ((svar_ginfo_131_t) ((((local_t) CREF(new_1190))->value)));
			       {
				  svar_ginfo_131_t arg1667_1195;
				  {
				     svar_ginfo_131_t res1828_1946;
				     {
					svar_ginfo_131_t new1314_1941;
					new1314_1941 = ((svar_ginfo_131_t) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
					((((svar_ginfo_131_t) CREF(new1314_1941))->kaptured__204) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					((((svar_ginfo_131_t) CREF(new1314_1941))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
					((((svar_ginfo_131_t) CREF(new1314_1941))->mark) = ((long) ((long) -10)), BUNSPEC);
					((((svar_ginfo_131_t) CREF(new1314_1941))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					res1828_1946 = new1314_1941;
				     }
				     arg1667_1195 = res1828_1946;
				  }
				  {
				     obj_t aux_2703;
				     object_t aux_2701;
				     aux_2703 = (obj_t) (arg1667_1195);
				     aux_2701 = (object_t) (obj1412_1194);
				     OBJECT_WIDENING_SET(aux_2701, aux_2703);
				  }
			       }
			       {
				  long arg1668_1196;
				  arg1668_1196 = class_num_218___object(svar_ginfo_131_globalize_ginfo);
				  {
				     obj_t obj_1947;
				     obj_1947 = (obj_t) (obj1412_1194);
				     (((obj_t) CREF(obj_1947))->header = MAKE_HEADER(arg1668_1196, 0), BUNSPEC);
				  }
			       }
			       obj1412_1194;
			    }
			    {
			       obj_t arg1669_1197;
			       {
				  local_t obj_1949;
				  obj_1949 = (local_t) (old_1189);
				  arg1669_1197 = (((local_t) CREF(obj_1949))->access);
			       }
			       {
				  obj_t res1829_1952;
				  {
				     obj_t x_2196;
				     x_2196 = ((((local_t) CREF(new_1190))->access) = ((obj_t) arg1669_1197), BUNSPEC);
				     res1829_1952 = BUNSPEC;
				  }
				  res1829_1952;
			       }
			    }
			    arg1661_1187 = new_1190;
			 }
		      }
		      {
			 obj_t aux_2712;
			 aux_2712 = (obj_t) (arg1661_1187);
			 new_tail1410_229_1185 = MAKE_PAIR(aux_2712, BNIL);
		      }
		   }
		   SET_CDR(tail1409_1182, new_tail1410_229_1185);
		   {
		      obj_t tail1409_2718;
		      obj_t l1405_2716;
		      l1405_2716 = CDR(l1405_1181);
		      tail1409_2718 = new_tail1410_229_1185;
		      tail1409_1182 = tail1409_2718;
		      l1405_1181 = l1405_2716;
		      goto lname1407_1183;
		   }
		}
	   }
	}
      {
	 sfun_t new_fun_115_1135;
	 {
	    sfun_t duplicated1413_1163;
	    {
	       value_t aux_2719;
	       aux_2719 = (((local_t) CREF(local_14))->value);
	       duplicated1413_1163 = (sfun_t) (aux_2719);
	    }
	    {
	       obj_t arg1641_1164;
	       obj_t arg1642_1165;
	       obj_t arg1643_1166;
	       obj_t arg1644_1167;
	       bool_t arg1645_1168;
	       obj_t arg1646_1169;
	       obj_t arg1647_1170;
	       obj_t arg1648_1171;
	       obj_t arg1650_1172;
	       obj_t arg1651_1173;
	       obj_t arg1652_1174;
	       {
		  obj_t aux_2726;
		  obj_t aux_2722;
		  {
		     long aux_2727;
		     aux_2727 = list_length(kaptured_16);
		     aux_2726 = BINT(aux_2727);
		  }
		  {
		     long aux_2723;
		     aux_2723 = (((sfun_t) CREF(duplicated1413_1163))->arity);
		     aux_2722 = BINT(aux_2723);
		  }
		  arg1641_1164 = ___arity_132_tools_args(aux_2722, aux_2726);
	       }
	       arg1642_1165 = (((sfun_t) CREF(duplicated1413_1163))->side_effect__165);
	       arg1643_1166 = (((sfun_t) CREF(duplicated1413_1163))->predicate_of_78);
	       arg1644_1167 = (((sfun_t) CREF(duplicated1413_1163))->stack_allocator_172);
	       arg1645_1168 = (((sfun_t) CREF(duplicated1413_1163))->top__138);
	       arg1646_1169 = (((sfun_t) CREF(duplicated1413_1163))->the_closure_238);
	       arg1647_1170 = (((sfun_t) CREF(duplicated1413_1163))->property);
	       arg1648_1171 = append_2_18___r4_pairs_and_lists_6_3(reverse___r4_pairs_and_lists_6_3(add_args_4_1133), args_15);
	       arg1650_1172 = (((sfun_t) CREF(duplicated1413_1163))->body);
	       arg1651_1173 = (((sfun_t) CREF(duplicated1413_1163))->class);
	       arg1652_1174 = (((sfun_t) CREF(duplicated1413_1163))->dsssl_keywords_243);
	       {
		  sfun_t res1830_1995;
		  {
		     long arity_1969;
		     arity_1969 = (long) CINT(arg1641_1164);
		     {
			sfun_t new1077_1980;
			new1077_1980 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
			{
			   long arg1788_1981;
			   arg1788_1981 = class_num_218___object(sfun_ast_var);
			   {
			      obj_t obj_1993;
			      obj_1993 = (obj_t) (new1077_1980);
			      (((obj_t) CREF(obj_1993))->header = MAKE_HEADER(arg1788_1981, 0), BUNSPEC);
			   }
			}
			{
			   object_t aux_2747;
			   aux_2747 = (object_t) (new1077_1980);
			   OBJECT_WIDENING_SET(aux_2747, BFALSE);
			}
			((((sfun_t) CREF(new1077_1980))->arity) = ((long) arity_1969), BUNSPEC);
			((((sfun_t) CREF(new1077_1980))->side_effect__165) = ((obj_t) arg1642_1165), BUNSPEC);
			((((sfun_t) CREF(new1077_1980))->predicate_of_78) = ((obj_t) arg1643_1166), BUNSPEC);
			((((sfun_t) CREF(new1077_1980))->stack_allocator_172) = ((obj_t) arg1644_1167), BUNSPEC);
			((((sfun_t) CREF(new1077_1980))->top__138) = ((bool_t) arg1645_1168), BUNSPEC);
			((((sfun_t) CREF(new1077_1980))->the_closure_238) = ((obj_t) arg1646_1169), BUNSPEC);
			((((sfun_t) CREF(new1077_1980))->property) = ((obj_t) arg1647_1170), BUNSPEC);
			((((sfun_t) CREF(new1077_1980))->args) = ((obj_t) arg1648_1171), BUNSPEC);
			((((sfun_t) CREF(new1077_1980))->body) = ((obj_t) arg1650_1172), BUNSPEC);
			((((sfun_t) CREF(new1077_1980))->class) = ((obj_t) arg1651_1173), BUNSPEC);
			((((sfun_t) CREF(new1077_1980))->dsssl_keywords_243) = ((obj_t) arg1652_1174), BUNSPEC);
			res1830_1995 = new1077_1980;
		     }
		  }
		  new_fun_115_1135 = res1830_1995;
	       }
	    }
	 }
	 {
	    {
	       obj_t res1831_1998;
	       {
		  local_ginfo_108_t obj_1996;
		  obj_1996 = (local_ginfo_108_t) (local_14);
		  {
		     obj_t x_2197;
		     {
			obj_t aux_2762;
			{
			   object_t aux_2763;
			   aux_2763 = (object_t) (obj_1996);
			   aux_2762 = OBJECT_WIDENING(aux_2763);
			}
			x_2197 = ((((local_ginfo_108_t) CREF(aux_2762))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		     }
		     res1831_1998 = BUNSPEC;
		  }
	       }
	       res1831_1998;
	    }
	    {
	       obj_t res1832_2001;
	       {
		  global_ginfo_75_t obj_1999;
		  obj_1999 = (global_ginfo_75_t) (global_13);
		  {
		     obj_t x_2198;
		     {
			obj_t aux_2768;
			{
			   object_t aux_2769;
			   aux_2769 = (object_t) (obj_1999);
			   aux_2768 = OBJECT_WIDENING(aux_2769);
			}
			x_2198 = ((((global_ginfo_75_t) CREF(aux_2768))->escape__117) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		     }
		     res1832_2001 = BUNSPEC;
		  }
	       }
	       res1832_2001;
	    }
	    {
	       obj_t res1833_2004;
	       {
		  type_t val1046_2003;
		  {
		     obj_t aux_2773;
		     aux_2773 = default_type_190_globalize_local__global_194();
		     val1046_2003 = (type_t) (aux_2773);
		  }
		  {
		     obj_t x_2199;
		     x_2199 = ((((global_t) CREF(global_13))->type) = ((type_t) val1046_2003), BUNSPEC);
		     res1833_2004 = BUNSPEC;
		  }
	       }
	       res1833_2004;
	    }
	    {
	       node_t arg1611_1137;
	       {
		  obj_t arg1614_1138;
		  obj_t arg1616_1139;
		  {
		     sfun_ginfo_98_t obj_2006;
		     {
			value_t aux_2777;
			aux_2777 = (((local_t) CREF(local_14))->value);
			obj_2006 = (sfun_ginfo_98_t) (aux_2777);
		     }
		     {
			obj_t aux_2780;
			{
			   object_t aux_2781;
			   aux_2781 = (object_t) (obj_2006);
			   aux_2780 = OBJECT_WIDENING(aux_2781);
			}
			arg1614_1138 = (((sfun_ginfo_98_t) CREF(aux_2780))->new_body_215);
		     }
		  }
		  if (NULLP(kaptured_16))
		    {
		       arg1616_1139 = BNIL;
		    }
		  else
		    {
		       obj_t head1416_1144;
		       {
			  obj_t arg1632_1159;
			  {
			     obj_t aux_2789;
			     obj_t aux_2787;
			     aux_2789 = CAR(add_args_4_1133);
			     aux_2787 = CAR(kaptured_16);
			     arg1632_1159 = MAKE_PAIR(aux_2787, aux_2789);
			  }
			  head1416_1144 = MAKE_PAIR(arg1632_1159, BNIL);
		       }
		       {
			  obj_t ll1414_1145;
			  obj_t ll1415_1146;
			  obj_t tail1417_1147;
			  ll1414_1145 = CDR(kaptured_16);
			  ll1415_1146 = CDR(add_args_4_1133);
			  tail1417_1147 = head1416_1144;
			lname1419_1148:
			  if (NULLP(ll1414_1145))
			    {
			       arg1616_1139 = head1416_1144;
			    }
			  else
			    {
			       obj_t new_tail1418_235_1152;
			       {
				  obj_t arg1626_1155;
				  {
				     obj_t aux_2797;
				     obj_t aux_2795;
				     aux_2797 = CAR(ll1415_1146);
				     aux_2795 = CAR(ll1414_1145);
				     arg1626_1155 = MAKE_PAIR(aux_2795, aux_2797);
				  }
				  new_tail1418_235_1152 = MAKE_PAIR(arg1626_1155, BNIL);
			       }
			       SET_CDR(tail1417_1147, new_tail1418_235_1152);
			       {
				  obj_t tail1417_2806;
				  obj_t ll1415_2804;
				  obj_t ll1414_2802;
				  ll1414_2802 = CDR(ll1414_1145);
				  ll1415_2804 = CDR(ll1415_1146);
				  tail1417_2806 = new_tail1418_235_1152;
				  tail1417_1147 = tail1417_2806;
				  ll1415_1146 = ll1415_2804;
				  ll1414_1145 = ll1414_2802;
				  goto lname1419_1148;
			       }
			    }
		       }
		    }
		  arg1611_1137 = node_globalize__229_globalize_node((node_t) (arg1614_1138), (variable_t) (local_14), arg1616_1139);
	       }
	       {
		  obj_t res1834_2029;
		  {
		     obj_t val1086_2028;
		     val1086_2028 = (obj_t) (arg1611_1137);
		     {
			obj_t x_2200;
			x_2200 = ((((sfun_t) CREF(new_fun_115_1135))->body) = ((obj_t) val1086_2028), BUNSPEC);
			res1834_2029 = BUNSPEC;
		     }
		  }
		  res1834_2029;
	       }
	    }
	    {
	       obj_t res1835_2032;
	       {
		  value_t val1047_2031;
		  val1047_2031 = (value_t) (new_fun_115_1135);
		  {
		     obj_t x_2201;
		     x_2201 = ((((global_t) CREF(global_13))->value) = ((value_t) val1047_2031), BUNSPEC);
		     res1835_2032 = BUNSPEC;
		  }
	       }
	       res1835_2032;
	    }
	    return global_13;
	 }
      }
   }
}


global_t 
the_global_201_globalize_local__global_194(local_t local_18)
{
   {
      value_t value_1202;
      value_1202 = (((local_t) CREF(local_18))->value);
      {
	 bool_t test1678_1203;
	 {
	    obj_t aux_2817;
	    {
	       sfun_ginfo_98_t obj_2034;
	       obj_2034 = (sfun_ginfo_98_t) (value_1202);
	       {
		  obj_t aux_2819;
		  {
		     object_t aux_2820;
		     aux_2820 = (object_t) (obj_2034);
		     aux_2819 = OBJECT_WIDENING(aux_2820);
		  }
		  aux_2817 = (((sfun_ginfo_98_t) CREF(aux_2819))->the_global_201);
	       }
	    }
	    test1678_1203 = is_a__118___object(aux_2817, global_ast_var);
	 }
	 if (test1678_1203)
	   {
	      sfun_ginfo_98_t obj_2036;
	      obj_2036 = (sfun_ginfo_98_t) (value_1202);
	      {
		 obj_t aux_2827;
		 {
		    obj_t aux_2828;
		    {
		       object_t aux_2829;
		       aux_2829 = (object_t) (obj_2036);
		       aux_2828 = OBJECT_WIDENING(aux_2829);
		    }
		    aux_2827 = (((sfun_ginfo_98_t) CREF(aux_2828))->the_global_201);
		 }
		 return (global_t) (aux_2827);
	      }
	   }
	 else
	   {
	      obj_t id_1204;
	      {
		 bool_t test1692_1218;
		 {
		    obj_t arg1694_1220;
		    {
		       obj_t arg1695_1221;
		       arg1695_1221 = (((local_t) CREF(local_18))->id);
		       {
			  obj_t list1696_1222;
			  list1696_1222 = MAKE_PAIR(__module__166_module_module, BNIL);
			  arg1694_1220 = find_global_223_ast_env(arg1695_1221, list1696_1222);
		       }
		    }
		    test1692_1218 = is_a__118___object(arg1694_1220, global_ast_var);
		 }
		 if (test1692_1218)
		   {
		      id_1204 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, (((local_t) CREF(local_18))->id), BEOA);
		   }
		 else
		   {
		      id_1204 = (((local_t) CREF(local_18))->id);
		   }
	      }
	      {
		 global_t global_1205;
		 {
		    obj_t arg1684_1211;
		    arg1684_1211 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, (((local_t) CREF(local_18))->id), BEOA);
		    global_1205 = def_global_sfun__93_ast_glo_def_117(arg1684_1211, BNIL, BNIL, __module__166_module_module, CNST_TABLE_REF(((long) 4)), CNST_TABLE_REF(((long) 5)), CNST_TABLE_REF(((long) 6)), BUNSPEC);
		 }
		 {
		    {
		       global_ginfo_75_t obj1420_1206;
		       obj1420_1206 = ((global_ginfo_75_t) (global_1205));
		       {
			  global_ginfo_75_t arg1679_1207;
			  {
			     global_ginfo_75_t res1836_2047;
			     {
				obj_t global_closure_229_2043;
				global_closure_229_2043 = BFALSE;
				{
				   global_ginfo_75_t new1352_2044;
				   new1352_2044 = ((global_ginfo_75_t) BREF(GC_MALLOC(sizeof(struct global_ginfo_75))));
				   ((((global_ginfo_75_t) CREF(new1352_2044))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				   ((((global_ginfo_75_t) CREF(new1352_2044))->global_closure_229) = ((obj_t) global_closure_229_2043), BUNSPEC);
				   res1836_2047 = new1352_2044;
				}
			     }
			     arg1679_1207 = res1836_2047;
			  }
			  {
			     obj_t aux_2856;
			     object_t aux_2854;
			     aux_2856 = (obj_t) (arg1679_1207);
			     aux_2854 = (object_t) (obj1420_1206);
			     OBJECT_WIDENING_SET(aux_2854, aux_2856);
			  }
		       }
		       {
			  long arg1680_1208;
			  arg1680_1208 = class_num_218___object(global_ginfo_75_globalize_ginfo);
			  {
			     obj_t obj_2048;
			     obj_2048 = (obj_t) (obj1420_1206);
			     (((obj_t) CREF(obj_2048))->header = MAKE_HEADER(arg1680_1208, 0), BUNSPEC);
			  }
		       }
		       obj1420_1206;
		    }
		    {
		       obj_t arg1682_1210;
		       {
			  sfun_t obj_2051;
			  obj_2051 = (sfun_t) (value_1202);
			  arg1682_1210 = (((sfun_t) CREF(obj_2051))->side_effect__165);
		       }
		       {
			  obj_t res1837_2054;
			  {
			     sfun_t obj_2052;
			     {
				value_t aux_2864;
				aux_2864 = (((global_t) CREF(global_1205))->value);
				obj_2052 = (sfun_t) (aux_2864);
			     }
			     {
				obj_t x_2202;
				x_2202 = ((((sfun_t) CREF(obj_2052))->side_effect__165) = ((obj_t) arg1682_1210), BUNSPEC);
				res1837_2054 = BUNSPEC;
			     }
			  }
			  res1837_2054;
		       }
		    }
		    {
		       obj_t res1838_2057;
		       {
			  sfun_ginfo_98_t obj_2055;
			  obj_t val1305_2056;
			  obj_2055 = (sfun_ginfo_98_t) (value_1202);
			  val1305_2056 = (obj_t) (global_1205);
			  {
			     obj_t x_2203;
			     {
				obj_t aux_2870;
				{
				   object_t aux_2871;
				   aux_2871 = (object_t) (obj_2055);
				   aux_2870 = OBJECT_WIDENING(aux_2871);
				}
				x_2203 = ((((sfun_ginfo_98_t) CREF(aux_2870))->the_global_201) = ((obj_t) val1305_2056), BUNSPEC);
			     }
			     res1838_2057 = BUNSPEC;
			  }
		       }
		       res1838_2057;
		    }
		    return global_1205;
		 }
	      }
	   }
      }
   }
}


obj_t 
_the_global_232_globalize_local__global_194(obj_t env_2186, obj_t local_2187)
{
   {
      global_t aux_2875;
      aux_2875 = the_global_201_globalize_local__global_194((local_t) (local_2187));
      return (obj_t) (aux_2875);
   }
}


obj_t 
imported_modules_init_94_globalize_local__global_194()
{
   module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70_tools_args(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70_engine_param(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70_module_module(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70_type_type(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70_type_cache(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70_ast_var(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70_ast_node(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70_ast_local(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70_ast_glo_def_117(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70_ast_sexp(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70_ast_env(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   module_initialization_70_globalize_node(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   return module_initialization_70_globalize_free(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
}
