/*===========================================================================*/
/*   (Globalize/new-body.scm)                                                */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_t;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_t;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_t;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_t;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_t;


extern obj_t let_fun_218_ast_node;
static long __round__57_globalize_new_body_146;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_globalize_new_body_146();
extern obj_t module_initialization_70_globalize_new_body_146(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_globalize_new_body_146();
static obj_t cnst_init_137_globalize_new_body_146();
static bool_t is_in__90_globalize_new_body_146(obj_t, obj_t);
extern obj_t set_globalized_new_bodies__10_globalize_new_body_146(global_t, obj_t);
static obj_t require_initialization_114_globalize_new_body_146 = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_globalize_new_body_146();
extern obj_t cast_ast_node;
static obj_t _rem__41_globalize_new_body_146(obj_t, obj_t, obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
static obj_t rem___100_globalize_new_body_146(obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern long class_num_218___object(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t setq_ast_node;
static node_t rem__73_globalize_new_body_146(node_t, obj_t, obj_t);
static obj_t set_globalized_new_body__17_globalize_new_body_146(obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t local_ast_var;
extern obj_t kwote_ast_node;
static node_t rem__default1396_124_globalize_new_body_146(node_t, obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
static obj_t _rem__default1396_117_globalize_new_body_146(obj_t, obj_t, obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t _set_globalized_new_bodies__36_globalize_new_body_146(obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t __cnst[3];

DEFINE_STRING(string1910_globalize_new_body_146, string1910_globalize_new_body_1461925, "No method for this object", 25);
DEFINE_STRING(string1908_globalize_new_body_146, string1908_globalize_new_body_1461926, " ): ", 4);
DEFINE_STRING(string1906_globalize_new_body_146, string1906_globalize_new_body_1461927, "     nbindings: ", 16);
DEFINE_EXPORT_PROCEDURE(set_globalized_new_bodies__env_71_globalize_new_body_146, _set_globalized_new_bodies__36_globalize_new_body_1461928, _set_globalized_new_bodies__36_globalize_new_body_146, 0L, 2);
DEFINE_STRING(string1911_globalize_new_body_146, string1911_globalize_new_body_1461929, "    current: ", 13);
DEFINE_STRING(string1909_globalize_new_body_146, string1909_globalize_new_body_1461930, "new-body( ", 10);
DEFINE_STRING(string1905_globalize_new_body_146, string1905_globalize_new_body_1461931, "scanning: ", 10);
DEFINE_STRING(string1913_globalize_new_body_146, string1913_globalize_new_body_1461932, " ### already: ", 14);
DEFINE_STRING(string1903_globalize_new_body_146, string1903_globalize_new_body_1461933, "set-globalized-new-body!: ", 26);
DEFINE_STATIC_PROCEDURE(rem__default1396_env_55_globalize_new_body_146, _rem__default1396_117_globalize_new_body_1461934, _rem__default1396_117_globalize_new_body_146, 0L, 3);
DEFINE_STRING(string1915_globalize_new_body_146, string1915_globalize_new_body_1461935, "  [current: ", 12);
DEFINE_STRING(string1907_globalize_new_body_146, string1907_globalize_new_body_1461936, "     obindings: ", 16);
DEFINE_STRING(string1914_globalize_new_body_146, string1914_globalize_new_body_1461937, "]", 1);
DEFINE_STATIC_GENERIC(rem__env_83_globalize_new_body_146, _rem__41_globalize_new_body_1461938, _rem__41_globalize_new_body_146, 0L, 3);
DEFINE_STRING(string1917_globalize_new_body_146, string1917_globalize_new_body_1461939, " ### escaping: ", 15);
DEFINE_STRING(string1912_globalize_new_body_146, string1912_globalize_new_body_1461940, "    plugged: ", 13);
DEFINE_STRING(string1918_globalize_new_body_146, string1918_globalize_new_body_1461941, " ### removing:", 14);
DEFINE_STRING(string1916_globalize_new_body_146, string1916_globalize_new_body_1461942, " ### is-in?: ", 13);
DEFINE_STRING(string1904_globalize_new_body_146, string1904_globalize_new_body_1461943, "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~", 44);
DEFINE_STRING(string1919_globalize_new_body_146, string1919_globalize_new_body_1461944, "DONE REM!-DEFAULT1396 GLOBALIZE ", 32);

obj_t 
module_initialization_70_globalize_new_body_146(long checksum_2157, char *from_2158)
{
   if (CBOOL(require_initialization_114_globalize_new_body_146))
     {
	require_initialization_114_globalize_new_body_146 = BBOOL(((bool_t) 0));
	library_modules_init_112_globalize_new_body_146();
	cnst_init_137_globalize_new_body_146();
	imported_modules_init_94_globalize_new_body_146();
	toplevel_init_63_globalize_new_body_146();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_globalize_new_body_146()
{
   module_initialization_70___object(((long) 0), "GLOBALIZE_NEW-BODY");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_NEW-BODY");
   module_initialization_70___reader(((long) 0), "GLOBALIZE_NEW-BODY");
   return BUNSPEC;
}


obj_t 
cnst_init_137_globalize_new_body_146()
{
   {
      obj_t cnst_port_138_2149;
      cnst_port_138_2149 = open_input_string(string1919_globalize_new_body_146);
      {
	 long i_2150;
	 i_2150 = ((long) 2);
       loop_2151:
	 {
	    bool_t test1920_2152;
	    test1920_2152 = (i_2150 == ((long) -1));
	    if (test1920_2152)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1921_2153;
		    {
		       obj_t list1922_2154;
		       {
			  obj_t arg1923_2155;
			  arg1923_2155 = BNIL;
			  list1922_2154 = MAKE_PAIR(cnst_port_138_2149, arg1923_2155);
		       }
		       arg1921_2153 = read___reader(list1922_2154);
		    }
		    CNST_TABLE_SET(i_2150, arg1921_2153);
		 }
		 {
		    int aux_2156;
		    {
		       long aux_2175;
		       aux_2175 = (i_2150 - ((long) 1));
		       aux_2156 = (int) (aux_2175);
		    }
		    {
		       long i_2178;
		       i_2178 = (long) (aux_2156);
		       i_2150 = i_2178;
		       goto loop_2151;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_globalize_new_body_146()
{
   __round__57_globalize_new_body_146 = ((long) 0);
   add_generic__110___object(rem__env_83_globalize_new_body_146, rem__default1396_env_55_globalize_new_body_146);
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, var_ast_node, ((long) 2));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, sequence_ast_node, ((long) 3));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, app_ast_node, ((long) 4));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, setq_ast_node, ((long) 9));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, conditional_ast_node, ((long) 10));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, fail_ast_node, ((long) 11));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, select_ast_node, ((long) 12));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, let_fun_218_ast_node, ((long) 13));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, let_var_6_ast_node, ((long) 14));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, set_ex_it_116_ast_node, ((long) 15));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, jump_ex_it_184_ast_node, ((long) 16));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, make_box_202_ast_node, ((long) 17));
   add_inlined_method__244___object(rem__env_83_globalize_new_body_146, box_ref_242_ast_node, ((long) 18));
   {
      long aux_2200;
      aux_2200 = add_inlined_method__244___object(rem__env_83_globalize_new_body_146, box_set__221_ast_node, ((long) 19));
      return BINT(aux_2200);
   }
}


obj_t 
set_globalized_new_bodies__10_globalize_new_body_146(global_t global_1, obj_t locals_2)
{
   {
      long z1_1735;
      z1_1735 = __round__57_globalize_new_body_146;
      __round__57_globalize_new_body_146 = (z1_1735 + ((long) 1));
   }
   {
      value_t fun_984;
      fun_984 = (((global_t) CREF(global_1))->value);
      {
	 node_t arg1427_985;
	 {
	    node_t aux_2205;
	    {
	       obj_t aux_2206;
	       {
		  sfun_t obj_1738;
		  obj_1738 = (sfun_t) (fun_984);
		  aux_2206 = (((sfun_t) CREF(obj_1738))->body);
	       }
	       aux_2205 = (node_t) (aux_2206);
	    }
	    arg1427_985 = rem__73_globalize_new_body_146(aux_2205, (obj_t) (global_1), (obj_t) (global_1));
	 }
	 {
	    obj_t res1873_1741;
	    {
	       sfun_t obj_1739;
	       obj_t val1082_1740;
	       obj_1739 = (sfun_t) (fun_984);
	       val1082_1740 = (obj_t) (arg1427_985);
	       {
		  obj_t x_2121;
		  x_2121 = ((((sfun_t) CREF(obj_1739))->body) = ((obj_t) val1082_1740), BUNSPEC);
		  res1873_1741 = BUNSPEC;
	       }
	    }
	    res1873_1741;
	 }
      }
   }
   {
      obj_t l1369_987;
      {
	 bool_t aux_2216;
	 l1369_987 = locals_2;
       lname1370_988:
	 if (PAIRP(l1369_987))
	   {
	      set_globalized_new_body__17_globalize_new_body_146(CAR(l1369_987));
	      {
		 obj_t l1369_2221;
		 l1369_2221 = CDR(l1369_987);
		 l1369_987 = l1369_2221;
		 goto lname1370_988;
	      }
	   }
	 else
	   {
	      aux_2216 = ((bool_t) 1);
	   }
	 return BBOOL(aux_2216);
      }
   }
}


obj_t 
_set_globalized_new_bodies__36_globalize_new_body_146(obj_t env_2118, obj_t global_2119, obj_t locals_2120)
{
   return set_globalized_new_bodies__10_globalize_new_body_146((global_t) (global_2119), locals_2120);
}


obj_t 
set_globalized_new_body__17_globalize_new_body_146(obj_t local_3)
{
   {
      bool_t test1433_992;
      {
	 obj_t aux_2226;
	 aux_2226 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1433_992 = CBOOL(aux_2226);
      }
      if (test1433_992)
	{
	   obj_t arg1444_995;
	   arg1444_995 = shape_tools_shape(local_3);
	   {
	      obj_t list1445_996;
	      {
		 obj_t arg1446_997;
		 {
		    obj_t arg1447_998;
		    {
		       obj_t arg1448_999;
		       {
			  obj_t arg1449_1000;
			  {
			     obj_t aux_2233;
			     aux_2233 = BCHAR(((unsigned char) '\n'));
			     arg1449_1000 = MAKE_PAIR(aux_2233, BNIL);
			  }
			  arg1448_999 = MAKE_PAIR(arg1444_995, arg1449_1000);
		       }
		       arg1447_998 = MAKE_PAIR(string1903_globalize_new_body_146, arg1448_999);
		    }
		    {
		       obj_t aux_2238;
		       aux_2238 = BCHAR(((unsigned char) '\n'));
		       arg1446_997 = MAKE_PAIR(aux_2238, arg1447_998);
		    }
		 }
		 list1445_996 = MAKE_PAIR(string1904_globalize_new_body_146, arg1446_997);
	      }
	      print_trace_107_tools_trace(list1445_996);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      long z1_1745;
      z1_1745 = __round__57_globalize_new_body_146;
      __round__57_globalize_new_body_146 = (z1_1745 + ((long) 1));
   }
   {
      value_t fun_1004;
      {
	 local_t obj_1747;
	 obj_1747 = (local_t) (local_3);
	 fun_1004 = (((local_t) CREF(obj_1747))->value);
      }
      {
	 obj_t old_body_129_1006;
	 {
	    sfun_t obj_1749;
	    obj_1749 = (sfun_t) (fun_1004);
	    old_body_129_1006 = (((sfun_t) CREF(obj_1749))->body);
	 }
	 {
	    obj_t obindings_1007;
	    {
	       sfun_ginfo_98_t obj_1750;
	       obj_1750 = (sfun_ginfo_98_t) (fun_1004);
	       {
		  obj_t aux_2249;
		  {
		     object_t aux_2250;
		     aux_2250 = (object_t) (obj_1750);
		     aux_2249 = OBJECT_WIDENING(aux_2250);
		  }
		  obindings_1007 = (((sfun_ginfo_98_t) CREF(aux_2249))->integrated);
	       }
	    }
	    {
	       node_t new_body_215_1008;
	       new_body_215_1008 = rem__73_globalize_new_body_146((node_t) (old_body_129_1006), local_3, local_3);
	       {
		  {
		     obj_t l1371_1009;
		     l1371_1009 = obindings_1007;
		   lname1373_1010:
		     if (PAIRP(l1371_1009))
		       {
			  {
			     obj_t f_1012;
			     f_1012 = CAR(l1371_1009);
			     {
				bool_t test1455_1013;
				{
				   obj_t aux_2259;
				   aux_2259 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
				   test1455_1013 = CBOOL(aux_2259);
				}
				if (test1455_1013)
				  {
				     obj_t arg1458_1015;
				     arg1458_1015 = shape_tools_shape(f_1012);
				     {
					obj_t list1459_1016;
					{
					   obj_t arg1461_1017;
					   {
					      obj_t arg1463_1018;
					      {
						 obj_t aux_2266;
						 aux_2266 = BCHAR(((unsigned char) '\n'));
						 arg1463_1018 = MAKE_PAIR(aux_2266, BNIL);
					      }
					      arg1461_1017 = MAKE_PAIR(arg1458_1015, arg1463_1018);
					   }
					   list1459_1016 = MAKE_PAIR(string1905_globalize_new_body_146, arg1461_1017);
					}
					print_trace_107_tools_trace(list1459_1016);
				     }
				  }
				else
				  {
				     BUNSPEC;
				  }
			     }
			     {
				bool_t test1468_1022;
				{
				   long n2_1756;
				   n2_1756 = __round__57_globalize_new_body_146;
				   {
				      long aux_2272;
				      {
					 sfun_ginfo_98_t obj_1754;
					 {
					    value_t aux_2273;
					    {
					       local_t obj_1753;
					       obj_1753 = (local_t) (f_1012);
					       aux_2273 = (((local_t) CREF(obj_1753))->value);
					    }
					    obj_1754 = (sfun_ginfo_98_t) (aux_2273);
					 }
					 {
					    obj_t aux_2277;
					    {
					       object_t aux_2278;
					       aux_2278 = (object_t) (obj_1754);
					       aux_2277 = OBJECT_WIDENING(aux_2278);
					    }
					    aux_2272 = (((sfun_ginfo_98_t) CREF(aux_2277))->bmark);
					 }
				      }
				      test1468_1022 = (aux_2272 == n2_1756);
				   }
				}
				if (test1468_1022)
				  {
				     BUNSPEC;
				  }
				else
				  {
				     value_t fun_1023;
				     {
					local_t obj_1757;
					obj_1757 = (local_t) (f_1012);
					fun_1023 = (((local_t) CREF(obj_1757))->value);
				     }
				     {
					{
					   node_t arg1470_1025;
					   {
					      node_t aux_2286;
					      {
						 obj_t aux_2287;
						 {
						    sfun_t obj_1758;
						    obj_1758 = (sfun_t) (fun_1023);
						    aux_2287 = (((sfun_t) CREF(obj_1758))->body);
						 }
						 aux_2286 = (node_t) (aux_2287);
					      }
					      arg1470_1025 = rem__73_globalize_new_body_146(aux_2286, local_3, f_1012);
					   }
					   {
					      obj_t res1874_1761;
					      {
						 sfun_t obj_1759;
						 obj_t val1082_1760;
						 obj_1759 = (sfun_t) (fun_1023);
						 val1082_1760 = (obj_t) (arg1470_1025);
						 {
						    obj_t x_2122;
						    x_2122 = ((((sfun_t) CREF(obj_1759))->body) = ((obj_t) val1082_1760), BUNSPEC);
						    res1874_1761 = BUNSPEC;
						 }
					      }
					      res1874_1761;
					   }
					}
				     }
				  }
			     }
			  }
			  {
			     obj_t l1371_2295;
			     l1371_2295 = CDR(l1371_1009);
			     l1371_1009 = l1371_2295;
			     goto lname1373_1010;
			  }
		       }
		     else
		       {
			  ((bool_t) 1);
		       }
		  }
		  {
		     obj_t nbindings_1029;
		     {
			obj_t nbdings_1080;
			obj_t obdings_1081;
			nbdings_1080 = BNIL;
			obdings_1081 = obindings_1007;
		      loop_1082:
			if (NULLP(obdings_1081))
			  {
			     nbindings_1029 = nbdings_1080;
			  }
			else
			  {
			     bool_t test1540_1085;
			     {
				long n2_1768;
				n2_1768 = __round__57_globalize_new_body_146;
				{
				   long aux_2299;
				   {
				      sfun_ginfo_98_t obj_1766;
				      {
					 value_t aux_2300;
					 {
					    local_t obj_1765;
					    {
					       obj_t aux_2301;
					       aux_2301 = CAR(obdings_1081);
					       obj_1765 = (local_t) (aux_2301);
					    }
					    aux_2300 = (((local_t) CREF(obj_1765))->value);
					 }
					 obj_1766 = (sfun_ginfo_98_t) (aux_2300);
				      }
				      {
					 obj_t aux_2306;
					 {
					    object_t aux_2307;
					    aux_2307 = (object_t) (obj_1766);
					    aux_2306 = OBJECT_WIDENING(aux_2307);
					 }
					 aux_2299 = (((sfun_ginfo_98_t) CREF(aux_2306))->bmark);
				      }
				   }
				   test1540_1085 = (aux_2299 == n2_1768);
				}
			     }
			     if (test1540_1085)
			       {
				  {
				     obj_t obdings_2313;
				     obdings_2313 = CDR(obdings_1081);
				     obdings_1081 = obdings_2313;
				     goto loop_1082;
				  }
			       }
			     else
			       {
				  {
				     obj_t arg1542_1087;
				     obj_t arg1543_1088;
				     {
					obj_t aux_2315;
					aux_2315 = CAR(obdings_1081);
					arg1542_1087 = MAKE_PAIR(aux_2315, nbdings_1080);
				     }
				     arg1543_1088 = CDR(obdings_1081);
				     {
					obj_t obdings_2320;
					obj_t nbdings_2319;
					nbdings_2319 = arg1542_1087;
					obdings_2320 = arg1543_1088;
					obdings_1081 = obdings_2320;
					nbdings_1080 = nbdings_2319;
					goto loop_1082;
				     }
				  }
			       }
			  }
		     }
		     {
			obj_t new2_body_172_1030;
			if (NULLP(nbindings_1029))
			  {
			     new2_body_172_1030 = (obj_t) (new_body_215_1008);
			  }
			else
			  {
			     obj_t arg1536_1078;
			     type_t arg1537_1079;
			     {
				node_t obj_1775;
				obj_1775 = (node_t) (old_body_129_1006);
				arg1536_1078 = (((node_t) CREF(obj_1775))->loc);
			     }
			     {
				node_t obj_1776;
				obj_1776 = (node_t) (old_body_129_1006);
				arg1537_1079 = (((node_t) CREF(obj_1776))->type);
			     }
			     {
				let_fun_218_t res1875_1791;
				{
				   let_fun_218_t new1226_1782;
				   new1226_1782 = ((let_fun_218_t) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
				   {
				      long arg1601_1783;
				      arg1601_1783 = class_num_218___object(let_fun_218_ast_node);
				      {
					 obj_t obj_1789;
					 obj_1789 = (obj_t) (new1226_1782);
					 (((obj_t) CREF(obj_1789))->header = MAKE_HEADER(arg1601_1783, 0), BUNSPEC);
				      }
				   }
				   {
				      object_t aux_2332;
				      aux_2332 = (object_t) (new1226_1782);
				      OBJECT_WIDENING_SET(aux_2332, BFALSE);
				   }
				   ((((let_fun_218_t) CREF(new1226_1782))->loc) = ((obj_t) arg1536_1078), BUNSPEC);
				   ((((let_fun_218_t) CREF(new1226_1782))->type) = ((type_t) arg1537_1079), BUNSPEC);
				   ((((let_fun_218_t) CREF(new1226_1782))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
				   ((((let_fun_218_t) CREF(new1226_1782))->locals) = ((obj_t) nbindings_1029), BUNSPEC);
				   ((((let_fun_218_t) CREF(new1226_1782))->body) = ((node_t) new_body_215_1008), BUNSPEC);
				   res1875_1791 = new1226_1782;
				}
				new2_body_172_1030 = (obj_t) (res1875_1791);
			     }
			  }
			{
			   obj_t ncto_1031;
			   obj_t nbindings_1032;
			   {
			      sfun_ginfo_98_t obj_1792;
			      obj_1792 = (sfun_ginfo_98_t) (fun_1004);
			      {
				 obj_t aux_2379;
				 {
				    object_t aux_2380;
				    aux_2380 = (object_t) (obj_1792);
				    aux_2379 = OBJECT_WIDENING(aux_2380);
				 }
				 ncto_1031 = (((sfun_ginfo_98_t) CREF(aux_2379))->cto);
			      }
			   }
			   nbindings_1032 = nbindings_1029;
			 loop_1033:
			   if (NULLP(nbindings_1032))
			     {
				obj_t res1876_1796;
				{
				   sfun_ginfo_98_t obj_1794;
				   obj_1794 = (sfun_ginfo_98_t) (fun_1004);
				   {
				      obj_t x_2123;
				      {
					 obj_t aux_2344;
					 {
					    object_t aux_2345;
					    aux_2345 = (object_t) (obj_1794);
					    aux_2344 = OBJECT_WIDENING(aux_2345);
					 }
					 x_2123 = ((((sfun_ginfo_98_t) CREF(aux_2344))->cto) = ((obj_t) ncto_1031), BUNSPEC);
				      }
				      res1876_1796 = BUNSPEC;
				   }
				}
				res1876_1796;
			     }
			   else
			     {
				obj_t ncto_1036;
				obj_t lcto_1037;
				ncto_1036 = ncto_1031;
				{
				   sfun_ginfo_98_t obj_1799;
				   {
				      value_t aux_2367;
				      {
					 local_t obj_1798;
					 {
					    obj_t aux_2368;
					    aux_2368 = CAR(nbindings_1032);
					    obj_1798 = (local_t) (aux_2368);
					 }
					 aux_2367 = (((local_t) CREF(obj_1798))->value);
				      }
				      obj_1799 = (sfun_ginfo_98_t) (aux_2367);
				   }
				   {
				      obj_t aux_2373;
				      {
					 object_t aux_2374;
					 aux_2374 = (object_t) (obj_1799);
					 aux_2373 = OBJECT_WIDENING(aux_2374);
				      }
				      lcto_1037 = (((sfun_ginfo_98_t) CREF(aux_2373))->cto);
				   }
				}
			      liip_1038:
				if (NULLP(lcto_1037))
				  {
				     {
					obj_t nbindings_2352;
					obj_t ncto_2351;
					ncto_2351 = ncto_1036;
					nbindings_2352 = CDR(nbindings_1032);
					nbindings_1032 = nbindings_2352;
					ncto_1031 = ncto_2351;
					goto loop_1033;
				     }
				  }
				else
				  {
				     bool_t test_2354;
				     {
					obj_t aux_2355;
					aux_2355 = memq___r4_pairs_and_lists_6_3(CAR(lcto_1037), ncto_1036);
					test_2354 = CBOOL(aux_2355);
				     }
				     if (test_2354)
				       {
					  {
					     obj_t lcto_2359;
					     lcto_2359 = CDR(lcto_1037);
					     lcto_1037 = lcto_2359;
					     goto liip_1038;
					  }
				       }
				     else
				       {
					  {
					     obj_t arg1487_1046;
					     obj_t arg1489_1047;
					     {
						obj_t aux_2361;
						aux_2361 = CAR(lcto_1037);
						arg1487_1046 = MAKE_PAIR(aux_2361, ncto_1036);
					     }
					     arg1489_1047 = CDR(lcto_1037);
					     {
						obj_t lcto_2366;
						obj_t ncto_2365;
						ncto_2365 = arg1487_1046;
						lcto_2366 = arg1489_1047;
						lcto_1037 = lcto_2366;
						ncto_1036 = ncto_2365;
						goto liip_1038;
					     }
					  }
				       }
				  }
			     }
			}
			{
			   bool_t test1494_1050;
			   {
			      obj_t aux_2384;
			      aux_2384 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			      test1494_1050 = CBOOL(aux_2384);
			   }
			   if (test1494_1050)
			     {
				obj_t arg1497_1052;
				obj_t arg1499_1054;
				obj_t arg1501_1056;
				obj_t arg1506_1058;
				arg1497_1052 = shape_tools_shape(local_3);
				arg1499_1054 = shape_tools_shape(new2_body_172_1030);
				arg1501_1056 = shape_tools_shape(obindings_1007);
				arg1506_1058 = shape_tools_shape(nbindings_1029);
				{
				   obj_t list1508_1060;
				   {
				      obj_t arg1509_1061;
				      {
					 obj_t arg1510_1062;
					 {
					    obj_t arg1511_1063;
					    {
					       obj_t arg1513_1064;
					       {
						  obj_t arg1514_1065;
						  {
						     obj_t arg1517_1066;
						     {
							obj_t arg1518_1067;
							{
							   obj_t arg1520_1068;
							   {
							      obj_t arg1522_1069;
							      {
								 obj_t arg1523_1070;
								 {
								    obj_t arg1524_1071;
								    {
								       obj_t arg1526_1072;
								       {
									  obj_t arg1529_1073;
									  {
									     obj_t aux_2394;
									     aux_2394 = BCHAR(((unsigned char) '\n'));
									     arg1529_1073 = MAKE_PAIR(aux_2394, BNIL);
									  }
									  {
									     obj_t aux_2397;
									     aux_2397 = BCHAR(((unsigned char) '\n'));
									     arg1526_1072 = MAKE_PAIR(aux_2397, arg1529_1073);
									  }
								       }
								       arg1524_1071 = MAKE_PAIR(string1904_globalize_new_body_146, arg1526_1072);
								    }
								    {
								       obj_t aux_2401;
								       aux_2401 = BCHAR(((unsigned char) '\n'));
								       arg1523_1070 = MAKE_PAIR(aux_2401, arg1524_1071);
								    }
								 }
								 arg1522_1069 = MAKE_PAIR(arg1506_1058, arg1523_1070);
							      }
							      arg1520_1068 = MAKE_PAIR(string1906_globalize_new_body_146, arg1522_1069);
							   }
							   {
							      obj_t aux_2406;
							      aux_2406 = BCHAR(((unsigned char) '\n'));
							      arg1518_1067 = MAKE_PAIR(aux_2406, arg1520_1068);
							   }
							}
							arg1517_1066 = MAKE_PAIR(arg1501_1056, arg1518_1067);
						     }
						     arg1514_1065 = MAKE_PAIR(string1907_globalize_new_body_146, arg1517_1066);
						  }
						  {
						     obj_t aux_2411;
						     aux_2411 = BCHAR(((unsigned char) '\n'));
						     arg1513_1064 = MAKE_PAIR(aux_2411, arg1514_1065);
						  }
					       }
					       arg1511_1063 = MAKE_PAIR(arg1499_1054, arg1513_1064);
					    }
					    arg1510_1062 = MAKE_PAIR(string1908_globalize_new_body_146, arg1511_1063);
					 }
					 arg1509_1061 = MAKE_PAIR(arg1497_1052, arg1510_1062);
				      }
				      list1508_1060 = MAKE_PAIR(string1909_globalize_new_body_146, arg1509_1061);
				   }
				   print_trace_107_tools_trace(list1508_1060);
				}
			     }
			   else
			     {
				BUNSPEC;
			     }
			}
			{
			   obj_t res1877_1810;
			   {
			      sfun_ginfo_98_t obj_1808;
			      obj_1808 = (sfun_ginfo_98_t) (fun_1004);
			      {
				 obj_t x_2124;
				 {
				    obj_t aux_2420;
				    {
				       object_t aux_2421;
				       aux_2421 = (object_t) (obj_1808);
				       aux_2420 = OBJECT_WIDENING(aux_2421);
				    }
				    x_2124 = ((((sfun_ginfo_98_t) CREF(aux_2420))->new_body_215) = ((obj_t) new2_body_172_1030), BUNSPEC);
				 }
				 res1877_1810 = BUNSPEC;
			      }
			   }
			   return res1877_1810;
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


bool_t 
is_in__90_globalize_new_body_146(obj_t f1_4, obj_t f2_5)
{
   {
      value_t info_1093;
      {
	 local_t obj_1811;
	 obj_1811 = (local_t) (f1_4);
	 info_1093 = (((local_t) CREF(obj_1811))->value);
      }
      {
	 bool_t test_2427;
	 {
	    sfun_ginfo_98_t obj_1812;
	    obj_1812 = (sfun_ginfo_98_t) (info_1093);
	    {
	       obj_t aux_2429;
	       {
		  object_t aux_2430;
		  aux_2430 = (object_t) (obj_1812);
		  aux_2429 = OBJECT_WIDENING(aux_2430);
	       }
	       test_2427 = (((sfun_ginfo_98_t) CREF(aux_2429))->g__219);
	    }
	 }
	 if (test_2427)
	   {
	      return ((bool_t) 0);
	   }
	 else
	   {
	      bool_t test1553_1095;
	      {
		 obj_t aux_2434;
		 {
		    sfun_ginfo_98_t obj_1813;
		    obj_1813 = (sfun_ginfo_98_t) (info_1093);
		    {
		       obj_t aux_2436;
		       {
			  object_t aux_2437;
			  aux_2437 = (object_t) (obj_1813);
			  aux_2436 = OBJECT_WIDENING(aux_2437);
		       }
		       aux_2434 = (((sfun_ginfo_98_t) CREF(aux_2436))->integrator);
		    }
		 }
		 test1553_1095 = is_a__118___object(aux_2434, local_ast_var);
	      }
	      if (test1553_1095)
		{
		   bool_t test_2443;
		   {
		      obj_t aux_2444;
		      {
			 sfun_ginfo_98_t obj_1815;
			 obj_1815 = (sfun_ginfo_98_t) (info_1093);
			 {
			    obj_t aux_2446;
			    {
			       object_t aux_2447;
			       aux_2447 = (object_t) (obj_1815);
			       aux_2446 = OBJECT_WIDENING(aux_2447);
			    }
			    aux_2444 = (((sfun_ginfo_98_t) CREF(aux_2446))->integrator);
			 }
		      }
		      test_2443 = (aux_2444 == f2_5);
		   }
		   if (test_2443)
		     {
			return ((bool_t) 1);
		     }
		   else
		     {
			return ((bool_t) 0);
		     }
		}
	      else
		{
		   return ((bool_t) 1);
		}
	   }
      }
   }
}


node_t 
rem__default1396_124_globalize_new_body_146(node_t node_9, obj_t owner_10, obj_t current_11)
{
   FAILURE(CNST_TABLE_REF(((long) 1)), string1910_globalize_new_body_146, (obj_t) (node_9));
}


obj_t 
_rem__default1396_117_globalize_new_body_146(obj_t env_2114, obj_t node_2115, obj_t owner_2116, obj_t current_2117)
{
   {
      node_t aux_2455;
      aux_2455 = rem__default1396_124_globalize_new_body_146((node_t) (node_2115), owner_2116, current_2117);
      return (obj_t) (aux_2455);
   }
}


node_t 
rem__73_globalize_new_body_146(node_t node_6, obj_t owner_7, obj_t current_8)
{
   {
      obj_t method1683_1485;
      obj_t class1690_1486;
      {
	 obj_t arg1693_1483;
	 obj_t arg1694_1484;
	 {
	    object_t obj_1823;
	    obj_1823 = (object_t) (node_6);
	    {
	       obj_t pre_method_105_1824;
	       pre_method_105_1824 = PROCEDURE_REF(rem__env_83_globalize_new_body_146, ((long) 2));
	       if (INTEGERP(pre_method_105_1824))
		 {
		    PROCEDURE_SET(rem__env_83_globalize_new_body_146, ((long) 2), BUNSPEC);
		    arg1693_1483 = pre_method_105_1824;
		 }
	       else
		 {
		    long obj_class_num_177_1829;
		    obj_class_num_177_1829 = TYPE(obj_1823);
		    {
		       obj_t arg1183_1830;
		       arg1183_1830 = PROCEDURE_REF(rem__env_83_globalize_new_body_146, ((long) 1));
		       {
			  long arg1184_1834;
			  {
			     long arg1186_1835;
			     arg1186_1835 = OBJECT_TYPE;
			     arg1184_1834 = (obj_class_num_177_1829 - arg1186_1835);
			  }
			  arg1693_1483 = VECTOR_REF(arg1183_1830, arg1184_1834);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1840;
	    object_1840 = (object_t) (node_6);
	    {
	       long arg1187_1841;
	       {
		  long arg1188_1842;
		  long arg1189_1843;
		  arg1188_1842 = TYPE(object_1840);
		  arg1189_1843 = OBJECT_TYPE;
		  arg1187_1841 = (arg1188_1842 - arg1189_1843);
	       }
	       {
		  obj_t vector_1847;
		  vector_1847 = __classes__134___object;
		  arg1694_1484 = VECTOR_REF(vector_1847, arg1187_1841);
	       }
	    }
	 }
	 {
	    obj_t aux_2474;
	    method1683_1485 = arg1693_1483;
	    class1690_1486 = arg1694_1484;
	    {
	       if (INTEGERP(method1683_1485))
		 {
		    switch ((long) CINT(method1683_1485))
		      {
		      case ((long) 0):
			 {
			    atom_t aux_2477;
			    aux_2477 = (atom_t) (node_6);
			    aux_2474 = (obj_t) (aux_2477);
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t aux_2480;
			    aux_2480 = (kwote_t) (node_6);
			    aux_2474 = (obj_t) (aux_2480);
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t aux_2483;
			    aux_2483 = (var_t) (node_6);
			    aux_2474 = (obj_t) (aux_2483);
			 }
			 break;
		      case ((long) 3):
			 {
			    sequence_t node_1501;
			    node_1501 = (sequence_t) (node_6);
			    rem___100_globalize_new_body_146((((sequence_t) CREF(node_1501))->nodes), owner_7, current_8);
			    aux_2474 = (obj_t) (node_1501);
			 }
			 break;
		      case ((long) 4):
			 {
			    app_t node_1506;
			    node_1506 = (app_t) (node_6);
			    rem___100_globalize_new_body_146((((app_t) CREF(node_1506))->args), owner_7, current_8);
			    aux_2474 = (obj_t) (node_1506);
			 }
			 break;
		      case ((long) 5):
			 {
			    app_ly_162_t node_1511;
			    node_1511 = (app_ly_162_t) (node_6);
			    {
			       node_t arg1699_1515;
			       arg1699_1515 = rem__73_globalize_new_body_146((((app_ly_162_t) CREF(node_1511))->fun), owner_7, current_8);
			       {
				  obj_t res1878_1854;
				  {
				     obj_t x_2125;
				     x_2125 = ((((app_ly_162_t) CREF(node_1511))->fun) = ((node_t) arg1699_1515), BUNSPEC);
				     res1878_1854 = BUNSPEC;
				  }
				  res1878_1854;
			       }
			    }
			    {
			       node_t arg1702_1517;
			       arg1702_1517 = rem__73_globalize_new_body_146((((app_ly_162_t) CREF(node_1511))->arg), owner_7, current_8);
			       {
				  obj_t res1879_1858;
				  {
				     obj_t x_2126;
				     x_2126 = ((((app_ly_162_t) CREF(node_1511))->arg) = ((node_t) arg1702_1517), BUNSPEC);
				     res1879_1858 = BUNSPEC;
				  }
				  res1879_1858;
			       }
			    }
			    aux_2474 = (obj_t) (node_1511);
			 }
			 break;
		      case ((long) 6):
			 {
			    funcall_t node_1519;
			    node_1519 = (funcall_t) (node_6);
			    {
			       node_t arg1704_1523;
			       arg1704_1523 = rem__73_globalize_new_body_146((((funcall_t) CREF(node_1519))->fun), owner_7, current_8);
			       {
				  obj_t res1880_1862;
				  {
				     obj_t x_2127;
				     x_2127 = ((((funcall_t) CREF(node_1519))->fun) = ((node_t) arg1704_1523), BUNSPEC);
				     res1880_1862 = BUNSPEC;
				  }
				  res1880_1862;
			       }
			    }
			    rem___100_globalize_new_body_146((((funcall_t) CREF(node_1519))->args), owner_7, current_8);
			    aux_2474 = (obj_t) (node_1519);
			 }
			 break;
		      case ((long) 7):
			 {
			    pragma_t node_1526;
			    node_1526 = (pragma_t) (node_6);
			    rem___100_globalize_new_body_146((((pragma_t) CREF(node_1526))->args), owner_7, current_8);
			    aux_2474 = (obj_t) (node_1526);
			 }
			 break;
		      case ((long) 8):
			 {
			    cast_t node_1531;
			    node_1531 = (cast_t) (node_6);
			    rem__73_globalize_new_body_146((((cast_t) CREF(node_1531))->arg), owner_7, current_8);
			    aux_2474 = (obj_t) (node_1531);
			 }
			 break;
		      case ((long) 9):
			 {
			    setq_t node_1536;
			    node_1536 = (setq_t) (node_6);
			    {
			       node_t arg1709_1540;
			       arg1709_1540 = rem__73_globalize_new_body_146((((setq_t) CREF(node_1536))->value), owner_7, current_8);
			       {
				  obj_t res1881_1869;
				  {
				     obj_t x_2128;
				     x_2128 = ((((setq_t) CREF(node_1536))->value) = ((node_t) arg1709_1540), BUNSPEC);
				     res1881_1869 = BUNSPEC;
				  }
				  res1881_1869;
			       }
			    }
			    aux_2474 = (obj_t) (node_1536);
			 }
			 break;
		      case ((long) 10):
			 {
			    conditional_t node_1542;
			    node_1542 = (conditional_t) (node_6);
			    {
			       node_t arg1711_1546;
			       arg1711_1546 = rem__73_globalize_new_body_146((((conditional_t) CREF(node_1542))->test), owner_7, current_8);
			       {
				  obj_t res1882_1873;
				  {
				     obj_t x_2129;
				     x_2129 = ((((conditional_t) CREF(node_1542))->test) = ((node_t) arg1711_1546), BUNSPEC);
				     res1882_1873 = BUNSPEC;
				  }
				  res1882_1873;
			       }
			    }
			    {
			       node_t arg1714_1548;
			       arg1714_1548 = rem__73_globalize_new_body_146((((conditional_t) CREF(node_1542))->true), owner_7, current_8);
			       {
				  obj_t res1883_1877;
				  {
				     obj_t x_2130;
				     x_2130 = ((((conditional_t) CREF(node_1542))->true) = ((node_t) arg1714_1548), BUNSPEC);
				     res1883_1877 = BUNSPEC;
				  }
				  res1883_1877;
			       }
			    }
			    {
			       node_t arg1716_1550;
			       arg1716_1550 = rem__73_globalize_new_body_146((((conditional_t) CREF(node_1542))->false), owner_7, current_8);
			       {
				  obj_t res1884_1881;
				  {
				     obj_t x_2131;
				     x_2131 = ((((conditional_t) CREF(node_1542))->false) = ((node_t) arg1716_1550), BUNSPEC);
				     res1884_1881 = BUNSPEC;
				  }
				  res1884_1881;
			       }
			    }
			    aux_2474 = (obj_t) (node_1542);
			 }
			 break;
		      case ((long) 11):
			 {
			    fail_t node_1552;
			    node_1552 = (fail_t) (node_6);
			    {
			       node_t arg1718_1556;
			       arg1718_1556 = rem__73_globalize_new_body_146((((fail_t) CREF(node_1552))->proc), owner_7, current_8);
			       {
				  obj_t res1885_1885;
				  {
				     obj_t x_2132;
				     x_2132 = ((((fail_t) CREF(node_1552))->proc) = ((node_t) arg1718_1556), BUNSPEC);
				     res1885_1885 = BUNSPEC;
				  }
				  res1885_1885;
			       }
			    }
			    {
			       node_t arg1720_1558;
			       arg1720_1558 = rem__73_globalize_new_body_146((((fail_t) CREF(node_1552))->msg), owner_7, current_8);
			       {
				  obj_t res1886_1889;
				  {
				     obj_t x_2133;
				     x_2133 = ((((fail_t) CREF(node_1552))->msg) = ((node_t) arg1720_1558), BUNSPEC);
				     res1886_1889 = BUNSPEC;
				  }
				  res1886_1889;
			       }
			    }
			    {
			       node_t arg1722_1560;
			       arg1722_1560 = rem__73_globalize_new_body_146((((fail_t) CREF(node_1552))->obj), owner_7, current_8);
			       {
				  obj_t res1887_1893;
				  {
				     obj_t x_2134;
				     x_2134 = ((((fail_t) CREF(node_1552))->obj) = ((node_t) arg1722_1560), BUNSPEC);
				     res1887_1893 = BUNSPEC;
				  }
				  res1887_1893;
			       }
			    }
			    aux_2474 = (obj_t) (node_1552);
			 }
			 break;
		      case ((long) 12):
			 {
			    select_t node_1562;
			    node_1562 = (select_t) (node_6);
			    {
			       node_t arg1725_1566;
			       arg1725_1566 = rem__73_globalize_new_body_146((((select_t) CREF(node_1562))->test), owner_7, current_8);
			       {
				  obj_t res1888_1897;
				  {
				     obj_t x_2135;
				     x_2135 = ((((select_t) CREF(node_1562))->test) = ((node_t) arg1725_1566), BUNSPEC);
				     res1888_1897 = BUNSPEC;
				  }
				  res1888_1897;
			       }
			    }
			    {
			       obj_t l1384_1568;
			       l1384_1568 = (((select_t) CREF(node_1562))->clauses);
			     lname1386_1569:
			       if (PAIRP(l1384_1568))
				 {
				    {
				       obj_t clause_1572;
				       clause_1572 = CAR(l1384_1568);
				       {
					  node_t arg1733_1573;
					  {
					     node_t aux_2551;
					     {
						obj_t aux_2552;
						aux_2552 = CDR(clause_1572);
						aux_2551 = (node_t) (aux_2552);
					     }
					     arg1733_1573 = rem__73_globalize_new_body_146(aux_2551, owner_7, current_8);
					  }
					  {
					     obj_t aux_2556;
					     aux_2556 = (obj_t) (arg1733_1573);
					     SET_CDR(clause_1572, aux_2556);
					  }
				       }
				    }
				    {
				       obj_t l1384_2559;
				       l1384_2559 = CDR(l1384_1568);
				       l1384_1568 = l1384_2559;
				       goto lname1386_1569;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_2474 = (obj_t) (node_1562);
			 }
			 break;
		      case ((long) 13):
			 {
			    let_fun_218_t node_1576;
			    node_1576 = (let_fun_218_t) (node_6);
			    {
			       node_t arg1736_1580;
			       arg1736_1580 = rem__73_globalize_new_body_146((((let_fun_218_t) CREF(node_1576))->body), owner_7, current_8);
			       {
				  obj_t res1889_1908;
				  {
				     obj_t x_2136;
				     x_2136 = ((((let_fun_218_t) CREF(node_1576))->body) = ((node_t) arg1736_1580), BUNSPEC);
				     res1889_1908 = BUNSPEC;
				  }
				  res1889_1908;
			       }
			    }
			    {
			       obj_t obindings_1582;
			       obj_t nbindings_1583;
			       {
				  let_fun_218_t aux_2567;
				  obindings_1582 = (((let_fun_218_t) CREF(node_1576))->locals);
				  nbindings_1583 = BNIL;
				liip_1584:
				  if (NULLP(obindings_1582))
				    {
				       {
					  obj_t res1890_1913;
					  {
					     obj_t x_2137;
					     x_2137 = ((((let_fun_218_t) CREF(node_1576))->locals) = ((obj_t) nbindings_1583), BUNSPEC);
					     res1890_1913 = BUNSPEC;
					  }
					  res1890_1913;
				       }
				       aux_2567 = node_1576;
				    }
				  else
				    {
				       bool_t test1742_1588;
				       {
					  long n2_1918;
					  n2_1918 = __round__57_globalize_new_body_146;
					  {
					     long aux_2571;
					     {
						sfun_ginfo_98_t obj_1916;
						{
						   value_t aux_2572;
						   {
						      local_t obj_1915;
						      {
							 obj_t aux_2573;
							 aux_2573 = CAR(obindings_1582);
							 obj_1915 = (local_t) (aux_2573);
						      }
						      aux_2572 = (((local_t) CREF(obj_1915))->value);
						   }
						   obj_1916 = (sfun_ginfo_98_t) (aux_2572);
						}
						{
						   obj_t aux_2578;
						   {
						      object_t aux_2579;
						      aux_2579 = (object_t) (obj_1916);
						      aux_2578 = OBJECT_WIDENING(aux_2579);
						   }
						   aux_2571 = (((sfun_ginfo_98_t) CREF(aux_2578))->bmark);
						}
					     }
					     test1742_1588 = (aux_2571 == n2_1918);
					  }
				       }
				       if (test1742_1588)
					 {
					    {
					       bool_t test1743_1589;
					       {
						  obj_t aux_2585;
						  aux_2585 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
						  test1743_1589 = CBOOL(aux_2585);
					       }
					       if (test1743_1589)
						 {
						    obj_t arg1746_1591;
						    obj_t arg1748_1593;
						    obj_t arg1751_1595;
						    arg1746_1591 = shape_tools_shape(CAR(obindings_1582));
						    {
						       obj_t aux_2593;
						       {
							  sfun_ginfo_98_t obj_1922;
							  {
							     value_t aux_2594;
							     {
								local_t obj_1921;
								{
								   obj_t aux_2595;
								   aux_2595 = CAR(obindings_1582);
								   obj_1921 = (local_t) (aux_2595);
								}
								aux_2594 = (((local_t) CREF(obj_1921))->value);
							     }
							     obj_1922 = (sfun_ginfo_98_t) (aux_2594);
							  }
							  {
							     obj_t aux_2600;
							     {
								object_t aux_2601;
								aux_2601 = (object_t) (obj_1922);
								aux_2600 = OBJECT_WIDENING(aux_2601);
							     }
							     aux_2593 = (((sfun_ginfo_98_t) CREF(aux_2600))->plugged_in_15);
							  }
						       }
						       arg1748_1593 = shape_tools_shape(aux_2593);
						    }
						    arg1751_1595 = shape_tools_shape(current_8);
						    {
						       obj_t list1752_1596;
						       {
							  obj_t arg1753_1597;
							  {
							     obj_t arg1754_1598;
							     {
								obj_t arg1755_1599;
								{
								   obj_t arg1756_1600;
								   {
								      obj_t arg1758_1601;
								      {
									 obj_t arg1759_1602;
									 {
									    obj_t arg1761_1603;
									    {
									       obj_t aux_2607;
									       aux_2607 = BCHAR(((unsigned char) '\n'));
									       arg1761_1603 = MAKE_PAIR(aux_2607, BNIL);
									    }
									    arg1759_1602 = MAKE_PAIR(arg1751_1595, arg1761_1603);
									 }
									 arg1758_1601 = MAKE_PAIR(string1911_globalize_new_body_146, arg1759_1602);
								      }
								      arg1756_1600 = MAKE_PAIR(arg1748_1593, arg1758_1601);
								   }
								   arg1755_1599 = MAKE_PAIR(string1912_globalize_new_body_146, arg1756_1600);
								}
								{
								   obj_t aux_2614;
								   aux_2614 = BCHAR(((unsigned char) '\n'));
								   arg1754_1598 = MAKE_PAIR(aux_2614, arg1755_1599);
								}
							     }
							     arg1753_1597 = MAKE_PAIR(arg1746_1591, arg1754_1598);
							  }
							  list1752_1596 = MAKE_PAIR(string1913_globalize_new_body_146, arg1753_1597);
						       }
						       print_trace_107_tools_trace(list1752_1596);
						    }
						 }
					       else
						 {
						    BUNSPEC;
						 }
					    }
					    {
					       bool_t test_2620;
					       {
						  obj_t aux_2621;
						  {
						     sfun_ginfo_98_t obj_1925;
						     {
							value_t aux_2622;
							{
							   local_t obj_1924;
							   {
							      obj_t aux_2623;
							      aux_2623 = CAR(obindings_1582);
							      obj_1924 = (local_t) (aux_2623);
							   }
							   aux_2622 = (((local_t) CREF(obj_1924))->value);
							}
							obj_1925 = (sfun_ginfo_98_t) (aux_2622);
						     }
						     {
							obj_t aux_2628;
							{
							   object_t aux_2629;
							   aux_2629 = (object_t) (obj_1925);
							   aux_2628 = OBJECT_WIDENING(aux_2629);
							}
							aux_2621 = (((sfun_ginfo_98_t) CREF(aux_2628))->plugged_in_15);
						     }
						  }
						  test_2620 = (current_8 == aux_2621);
					       }
					       if (test_2620)
						 {
						    obj_t arg1772_1612;
						    obj_t arg1773_1613;
						    arg1772_1612 = CDR(obindings_1582);
						    {
						       obj_t aux_2635;
						       aux_2635 = CAR(obindings_1582);
						       arg1773_1613 = MAKE_PAIR(aux_2635, nbindings_1583);
						    }
						    {
						       obj_t nbindings_2639;
						       obj_t obindings_2638;
						       obindings_2638 = arg1772_1612;
						       nbindings_2639 = arg1773_1613;
						       nbindings_1583 = nbindings_2639;
						       obindings_1582 = obindings_2638;
						       goto liip_1584;
						    }
						 }
					       else
						 {
						    obj_t obindings_2640;
						    obindings_2640 = CDR(obindings_1582);
						    obindings_1582 = obindings_2640;
						    goto liip_1584;
						 }
					    }
					 }
				       else
					 {
					    if (is_in__90_globalize_new_body_146(CAR(obindings_1582), owner_7))
					      {
						 {
						    bool_t test1780_1620;
						    {
						       obj_t aux_2645;
						       aux_2645 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
						       test1780_1620 = CBOOL(aux_2645);
						    }
						    if (test1780_1620)
						      {
							 obj_t arg1783_1622;
							 obj_t arg1785_1624;
							 arg1783_1622 = shape_tools_shape(CAR(obindings_1582));
							 arg1785_1624 = shape_tools_shape(current_8);
							 {
							    obj_t list1787_1626;
							    {
							       obj_t arg1788_1627;
							       {
								  obj_t arg1789_1628;
								  {
								     obj_t arg1791_1629;
								     {
									obj_t arg1792_1630;
									{
									   obj_t arg1793_1631;
									   {
									      obj_t aux_2654;
									      aux_2654 = BCHAR(((unsigned char) '\n'));
									      arg1793_1631 = MAKE_PAIR(aux_2654, BNIL);
									   }
									   arg1792_1630 = MAKE_PAIR(string1914_globalize_new_body_146, arg1793_1631);
									}
									arg1791_1629 = MAKE_PAIR(arg1785_1624, arg1792_1630);
								     }
								     arg1789_1628 = MAKE_PAIR(string1915_globalize_new_body_146, arg1791_1629);
								  }
								  arg1788_1627 = MAKE_PAIR(arg1783_1622, arg1789_1628);
							       }
							       list1787_1626 = MAKE_PAIR(string1916_globalize_new_body_146, arg1788_1627);
							    }
							    print_trace_107_tools_trace(list1787_1626);
							 }
						      }
						    else
						      {
							 BUNSPEC;
						      }
						 }
						 {
						    obj_t res1891_1939;
						    {
						       sfun_ginfo_98_t obj_1937;
						       long val1308_1938;
						       {
							  value_t aux_2663;
							  {
							     local_t obj_1936;
							     {
								obj_t aux_2664;
								aux_2664 = CAR(obindings_1582);
								obj_1936 = (local_t) (aux_2664);
							     }
							     aux_2663 = (((local_t) CREF(obj_1936))->value);
							  }
							  obj_1937 = (sfun_ginfo_98_t) (aux_2663);
						       }
						       val1308_1938 = __round__57_globalize_new_body_146;
						       {
							  obj_t x_2138;
							  {
							     obj_t aux_2669;
							     {
								object_t aux_2670;
								aux_2670 = (object_t) (obj_1937);
								aux_2669 = OBJECT_WIDENING(aux_2670);
							     }
							     x_2138 = ((((sfun_ginfo_98_t) CREF(aux_2669))->bmark) = ((long) val1308_1938), BUNSPEC);
							  }
							  res1891_1939 = BUNSPEC;
						       }
						    }
						    res1891_1939;
						 }
						 {
						    obj_t res1892_1944;
						    {
						       sfun_ginfo_98_t obj_1942;
						       {
							  value_t aux_2674;
							  {
							     local_t obj_1941;
							     {
								obj_t aux_2675;
								aux_2675 = CAR(obindings_1582);
								obj_1941 = (local_t) (aux_2675);
							     }
							     aux_2674 = (((local_t) CREF(obj_1941))->value);
							  }
							  obj_1942 = (sfun_ginfo_98_t) (aux_2674);
						       }
						       {
							  obj_t x_2139;
							  {
							     obj_t aux_2680;
							     {
								object_t aux_2681;
								aux_2681 = (object_t) (obj_1942);
								aux_2680 = OBJECT_WIDENING(aux_2681);
							     }
							     x_2139 = ((((sfun_ginfo_98_t) CREF(aux_2680))->plugged_in_15) = ((obj_t) current_8), BUNSPEC);
							  }
							  res1892_1944 = BUNSPEC;
						       }
						    }
						    res1892_1944;
						 }
						 {
						    value_t fun_1640;
						    {
						       local_t obj_1946;
						       {
							  obj_t aux_2685;
							  aux_2685 = CAR(obindings_1582);
							  obj_1946 = (local_t) (aux_2685);
						       }
						       fun_1640 = (((local_t) CREF(obj_1946))->value);
						    }
						    {
						       {
							  node_t arg1805_1642;
							  {
							     node_t aux_2689;
							     {
								obj_t aux_2690;
								{
								   sfun_t obj_1947;
								   obj_1947 = (sfun_t) (fun_1640);
								   aux_2690 = (((sfun_t) CREF(obj_1947))->body);
								}
								aux_2689 = (node_t) (aux_2690);
							     }
							     arg1805_1642 = rem__73_globalize_new_body_146(aux_2689, owner_7, CAR(obindings_1582));
							  }
							  {
							     obj_t res1893_1951;
							     {
								sfun_t obj_1949;
								obj_t val1082_1950;
								obj_1949 = (sfun_t) (fun_1640);
								val1082_1950 = (obj_t) (arg1805_1642);
								{
								   obj_t x_2140;
								   x_2140 = ((((sfun_t) CREF(obj_1949))->body) = ((obj_t) val1082_1950), BUNSPEC);
								   res1893_1951 = BUNSPEC;
								}
							     }
							     res1893_1951;
							  }
						       }
						       {
							  obj_t arg1807_1644;
							  obj_t arg1808_1645;
							  arg1807_1644 = CDR(obindings_1582);
							  {
							     obj_t aux_2700;
							     aux_2700 = CAR(obindings_1582);
							     arg1808_1645 = MAKE_PAIR(aux_2700, nbindings_1583);
							  }
							  {
							     obj_t nbindings_2704;
							     obj_t obindings_2703;
							     obindings_2703 = arg1807_1644;
							     nbindings_2704 = arg1808_1645;
							     nbindings_1583 = nbindings_2704;
							     obindings_1582 = obindings_2703;
							     goto liip_1584;
							  }
						       }
						    }
						 }
					      }
					    else
					      {
						 bool_t test_2705;
						 {
						    local_ginfo_108_t obj_1957;
						    {
						       obj_t aux_2706;
						       aux_2706 = CAR(obindings_1582);
						       obj_1957 = (local_ginfo_108_t) (aux_2706);
						    }
						    {
						       obj_t aux_2709;
						       {
							  object_t aux_2710;
							  aux_2710 = (object_t) (obj_1957);
							  aux_2709 = OBJECT_WIDENING(aux_2710);
						       }
						       test_2705 = (((local_ginfo_108_t) CREF(aux_2709))->escape__117);
						    }
						 }
						 if (test_2705)
						   {
						      {
							 bool_t test1812_1649;
							 {
							    obj_t aux_2714;
							    aux_2714 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
							    test1812_1649 = CBOOL(aux_2714);
							 }
							 if (test1812_1649)
							   {
							      obj_t arg1814_1651;
							      arg1814_1651 = shape_tools_shape(CAR(obindings_1582));
							      {
								 obj_t list1815_1652;
								 {
								    obj_t arg1819_1653;
								    {
								       obj_t arg1820_1654;
								       {
									  obj_t aux_2722;
									  aux_2722 = BCHAR(((unsigned char) '\n'));
									  arg1820_1654 = MAKE_PAIR(aux_2722, BNIL);
								       }
								       arg1819_1653 = MAKE_PAIR(arg1814_1651, arg1820_1654);
								    }
								    list1815_1652 = MAKE_PAIR(string1917_globalize_new_body_146, arg1819_1653);
								 }
								 print_trace_107_tools_trace(list1815_1652);
							      }
							   }
							 else
							   {
							      BUNSPEC;
							   }
						      }
						      {
							 obj_t arg1825_1659;
							 obj_t arg1826_1660;
							 arg1825_1659 = CDR(obindings_1582);
							 {
							    obj_t aux_2729;
							    aux_2729 = CAR(obindings_1582);
							    arg1826_1660 = MAKE_PAIR(aux_2729, nbindings_1583);
							 }
							 {
							    obj_t nbindings_2733;
							    obj_t obindings_2732;
							    obindings_2732 = arg1825_1659;
							    nbindings_2733 = arg1826_1660;
							    nbindings_1583 = nbindings_2733;
							    obindings_1582 = obindings_2732;
							    goto liip_1584;
							 }
						      }
						   }
						 else
						   {
						      {
							 bool_t test1828_1662;
							 {
							    obj_t aux_2734;
							    aux_2734 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
							    test1828_1662 = CBOOL(aux_2734);
							 }
							 if (test1828_1662)
							   {
							      obj_t arg1830_1664;
							      arg1830_1664 = shape_tools_shape(CAR(obindings_1582));
							      {
								 obj_t list1831_1665;
								 {
								    obj_t arg1832_1666;
								    {
								       obj_t arg1833_1667;
								       {
									  obj_t aux_2742;
									  aux_2742 = BCHAR(((unsigned char) '\n'));
									  arg1833_1667 = MAKE_PAIR(aux_2742, BNIL);
								       }
								       arg1832_1666 = MAKE_PAIR(arg1830_1664, arg1833_1667);
								    }
								    list1831_1665 = MAKE_PAIR(string1918_globalize_new_body_146, arg1832_1666);
								 }
								 print_trace_107_tools_trace(list1831_1665);
							      }
							   }
							 else
							   {
							      BUNSPEC;
							   }
						      }
						      {
							 obj_t obindings_2748;
							 obindings_2748 = CDR(obindings_1582);
							 obindings_1582 = obindings_2748;
							 goto liip_1584;
						      }
						   }
					      }
					 }
				    }
				  aux_2474 = (obj_t) (aux_2567);
			       }
			    }
			 }
			 break;
		      case ((long) 14):
			 {
			    let_var_6_t node_1678;
			    node_1678 = (let_var_6_t) (node_6);
			    {
			       node_t arg1844_1682;
			       arg1844_1682 = rem__73_globalize_new_body_146((((let_var_6_t) CREF(node_1678))->body), owner_7, current_8);
			       {
				  obj_t res1894_1968;
				  {
				     obj_t x_2141;
				     x_2141 = ((((let_var_6_t) CREF(node_1678))->body) = ((node_t) arg1844_1682), BUNSPEC);
				     res1894_1968 = BUNSPEC;
				  }
				  res1894_1968;
			       }
			    }
			    {
			       obj_t l1389_1684;
			       l1389_1684 = (((let_var_6_t) CREF(node_1678))->bindings);
			     lname1390_1685:
			       if (PAIRP(l1389_1684))
				 {
				    {
				       obj_t binding_1688;
				       binding_1688 = CAR(l1389_1684);
				       {
					  node_t arg1848_1689;
					  {
					     node_t aux_2759;
					     {
						obj_t aux_2760;
						aux_2760 = CDR(binding_1688);
						aux_2759 = (node_t) (aux_2760);
					     }
					     arg1848_1689 = rem__73_globalize_new_body_146(aux_2759, owner_7, current_8);
					  }
					  {
					     obj_t aux_2764;
					     aux_2764 = (obj_t) (arg1848_1689);
					     SET_CDR(binding_1688, aux_2764);
					  }
				       }
				    }
				    {
				       obj_t l1389_2767;
				       l1389_2767 = CDR(l1389_1684);
				       l1389_1684 = l1389_2767;
				       goto lname1390_1685;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_2474 = (obj_t) (node_1678);
			 }
			 break;
		      case ((long) 15):
			 {
			    set_ex_it_116_t node_1692;
			    node_1692 = (set_ex_it_116_t) (node_6);
			    {
			       node_t arg1853_1696;
			       arg1853_1696 = rem__73_globalize_new_body_146((((set_ex_it_116_t) CREF(node_1692))->body), owner_7, current_8);
			       {
				  obj_t res1895_1979;
				  {
				     obj_t x_2142;
				     x_2142 = ((((set_ex_it_116_t) CREF(node_1692))->body) = ((node_t) arg1853_1696), BUNSPEC);
				     res1895_1979 = BUNSPEC;
				  }
				  res1895_1979;
			       }
			    }
			    aux_2474 = (obj_t) (node_1692);
			 }
			 break;
		      case ((long) 16):
			 {
			    jump_ex_it_184_t node_1698;
			    node_1698 = (jump_ex_it_184_t) (node_6);
			    {
			       node_t arg1856_1702;
			       arg1856_1702 = rem__73_globalize_new_body_146((((jump_ex_it_184_t) CREF(node_1698))->exit), owner_7, current_8);
			       {
				  obj_t res1896_1983;
				  {
				     obj_t x_2143;
				     x_2143 = ((((jump_ex_it_184_t) CREF(node_1698))->exit) = ((node_t) arg1856_1702), BUNSPEC);
				     res1896_1983 = BUNSPEC;
				  }
				  res1896_1983;
			       }
			    }
			    {
			       node_t arg1858_1704;
			       arg1858_1704 = rem__73_globalize_new_body_146((((jump_ex_it_184_t) CREF(node_1698))->value), owner_7, current_8);
			       {
				  obj_t res1897_1987;
				  {
				     obj_t x_2144;
				     x_2144 = ((((jump_ex_it_184_t) CREF(node_1698))->value) = ((node_t) arg1858_1704), BUNSPEC);
				     res1897_1987 = BUNSPEC;
				  }
				  res1897_1987;
			       }
			    }
			    aux_2474 = (obj_t) (node_1698);
			 }
			 break;
		      case ((long) 17):
			 {
			    make_box_202_t node_1706;
			    node_1706 = (make_box_202_t) (node_6);
			    {
			       node_t arg1860_1710;
			       arg1860_1710 = rem__73_globalize_new_body_146((((make_box_202_t) CREF(node_1706))->value), owner_7, current_8);
			       {
				  obj_t res1898_1991;
				  {
				     obj_t x_2145;
				     x_2145 = ((((make_box_202_t) CREF(node_1706))->value) = ((node_t) arg1860_1710), BUNSPEC);
				     res1898_1991 = BUNSPEC;
				  }
				  res1898_1991;
			       }
			    }
			    aux_2474 = (obj_t) (node_1706);
			 }
			 break;
		      case ((long) 18):
			 {
			    box_ref_242_t node_1712;
			    node_1712 = (box_ref_242_t) (node_6);
			    {
			       node_t arg1862_1716;
			       {
				  node_t aux_2790;
				  {
				     var_t aux_2791;
				     aux_2791 = (((box_ref_242_t) CREF(node_1712))->var);
				     aux_2790 = (node_t) (aux_2791);
				  }
				  arg1862_1716 = rem__73_globalize_new_body_146(aux_2790, owner_7, current_8);
			       }
			       {
				  obj_t res1899_1995;
				  {
				     var_t val1270_1994;
				     val1270_1994 = (var_t) (arg1862_1716);
				     {
					obj_t x_2146;
					x_2146 = ((((box_ref_242_t) CREF(node_1712))->var) = ((var_t) val1270_1994), BUNSPEC);
					res1899_1995 = BUNSPEC;
				     }
				  }
				  res1899_1995;
			       }
			    }
			    aux_2474 = (obj_t) (node_1712);
			 }
			 break;
		      case ((long) 19):
			 {
			    box_set__221_t node_1718;
			    node_1718 = (box_set__221_t) (node_6);
			    {
			       node_t arg1864_1722;
			       {
				  node_t aux_2799;
				  {
				     var_t aux_2800;
				     aux_2800 = (((box_set__221_t) CREF(node_1718))->var);
				     aux_2799 = (node_t) (aux_2800);
				  }
				  arg1864_1722 = rem__73_globalize_new_body_146(aux_2799, owner_7, current_8);
			       }
			       {
				  obj_t res1900_1999;
				  {
				     var_t val1276_1998;
				     val1276_1998 = (var_t) (arg1864_1722);
				     {
					obj_t x_2147;
					x_2147 = ((((box_set__221_t) CREF(node_1718))->var) = ((var_t) val1276_1998), BUNSPEC);
					res1900_1999 = BUNSPEC;
				     }
				  }
				  res1900_1999;
			       }
			    }
			    {
			       node_t arg1866_1724;
			       arg1866_1724 = rem__73_globalize_new_body_146((((box_set__221_t) CREF(node_1718))->value), owner_7, current_8);
			       {
				  obj_t res1901_2003;
				  {
				     obj_t x_2148;
				     x_2148 = ((((box_set__221_t) CREF(node_1718))->value) = ((node_t) arg1866_1724), BUNSPEC);
				     res1901_2003 = BUNSPEC;
				  }
				  res1901_2003;
			       }
			    }
			    aux_2474 = (obj_t) (node_1718);
			 }
			 break;
		      default:
		       case_else1691_175_1489:
			 if (PROCEDUREP(method1683_1485))
			   {
			      aux_2474 = PROCEDURE_ENTRY(method1683_1485) (method1683_1485, (obj_t) (node_6), owner_7, current_8, BEOA);
			   }
			 else
			   {
			      obj_t fun1561_1101;
			      fun1561_1101 = PROCEDURE_REF(rem__env_83_globalize_new_body_146, ((long) 0));
			      aux_2474 = PROCEDURE_ENTRY(fun1561_1101) (fun1561_1101, (obj_t) (node_6), owner_7, current_8, BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1691_175_1489;
		 }
	    }
	    return (node_t) (aux_2474);
	 }
      }
   }
}


obj_t 
_rem__41_globalize_new_body_146(obj_t env_2110, obj_t node_2111, obj_t owner_2112, obj_t current_2113)
{
   {
      node_t aux_2822;
      aux_2822 = rem__73_globalize_new_body_146((node_t) (node_2111), owner_2112, current_2113);
      return (obj_t) (aux_2822);
   }
}


obj_t 
rem___100_globalize_new_body_146(obj_t node__221_72, obj_t owner_73, obj_t current_74)
{
   {
      obj_t node__221_1102;
      node__221_1102 = node__221_72;
    loop_1103:
      if (NULLP(node__221_1102))
	{
	   return CNST_TABLE_REF(((long) 2));
	}
      else
	{
	   {
	      node_t arg1563_1105;
	      {
		 node_t aux_2829;
		 {
		    obj_t aux_2830;
		    aux_2830 = CAR(node__221_1102);
		    aux_2829 = (node_t) (aux_2830);
		 }
		 arg1563_1105 = rem__73_globalize_new_body_146(aux_2829, owner_73, current_74);
	      }
	      {
		 obj_t aux_2834;
		 aux_2834 = (obj_t) (arg1563_1105);
		 SET_CAR(node__221_1102, aux_2834);
	      }
	   }
	   {
	      obj_t node__221_2837;
	      node__221_2837 = CDR(node__221_1102);
	      node__221_1102 = node__221_2837;
	      goto loop_1103;
	   }
	}
   }
}


obj_t 
imported_modules_init_94_globalize_new_body_146()
{
   module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_NEW-BODY");
   module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_NEW-BODY");
   module_initialization_70_tools_speek(((long) 0), "GLOBALIZE_NEW-BODY");
   module_initialization_70_type_type(((long) 0), "GLOBALIZE_NEW-BODY");
   module_initialization_70_type_cache(((long) 0), "GLOBALIZE_NEW-BODY");
   module_initialization_70_ast_var(((long) 0), "GLOBALIZE_NEW-BODY");
   module_initialization_70_ast_node(((long) 0), "GLOBALIZE_NEW-BODY");
   module_initialization_70_ast_sexp(((long) 0), "GLOBALIZE_NEW-BODY");
   module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_NEW-BODY");
   return module_initialization_70_globalize_node(((long) 0), "GLOBALIZE_NEW-BODY");
}
