/*===========================================================================*/
/*   (Globalize/node.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_t;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_t;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_t;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_t;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_t;


extern obj_t svar_ginfo_131_globalize_ginfo;
extern obj_t __procedure__226_type_cache;
extern obj_t let_fun_218_ast_node;
static obj_t celled_bindings_3_globalize_node(obj_t);
static obj_t make_sets_85_globalize_node(obj_t, obj_t, obj_t, variable_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
static obj_t _glo__107_globalize_node(obj_t, obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t closure_ast_node;
extern node_t node_globalize__229_globalize_node(node_t, variable_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t globalize_local_fun__50_globalize_node(local_t, variable_t);
static let_var_6_t make_escaping_bindings_69_globalize_node(obj_t, node_t, variable_t);
static obj_t imported_modules_init_94_globalize_node();
extern obj_t module_initialization_70_globalize_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_globalize_free(long, char *);
extern obj_t module_initialization_70_globalize_local__global_194(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_globalize_node();
static obj_t cnst_init_137_globalize_node();
static node_t glo__115_globalize_node(node_t, variable_t);
extern obj_t the_closure_238_globalize_free(variable_t, obj_t);
static app_t a_procedure_set__174_globalize_node(obj_t, obj_t, long, obj_t, variable_t);
static obj_t require_initialization_114_globalize_node = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static bool_t celled__113_globalize_node(variable_t);
static obj_t library_modules_init_112_globalize_node();
static app_t a_make_procedure_166_globalize_node(local_t);
extern obj_t _node_globalize__29_globalize_node(obj_t, obj_t, obj_t, obj_t);
extern obj_t cast_ast_node;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
static obj_t glo___241_globalize_node(obj_t, variable_t);
extern obj_t pragma_ast_node;
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern long class_num_218___object(obj_t);
static make_box_202_t a_make_cell_117_globalize_node(node_t, variable_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t local_ast_var;
extern obj_t kwote_ast_node;
extern long list_length(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _____74_type_cache;
static obj_t _glo__default1413_58_globalize_node(obj_t, obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
static node_t glo__default1413_248_globalize_node(node_t, variable_t);
extern obj_t funcall_ast_node;
extern obj_t __obj__252_type_cache;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
static obj_t cell_formals_12_globalize_node(obj_t, node_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern global_t the_global_201_globalize_local__global_194(local_t);
extern obj_t app_ast_node;
static obj_t __cnst[10];

DEFINE_STATIC_GENERIC(glo__env_172_globalize_node, _glo__107_globalize_node2011, _glo__107_globalize_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(glo__default1413_env_124_globalize_node, _glo__default1413_58_globalize_node2012, _glo__default1413_58_globalize_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(node_globalize__env_218_globalize_node, _node_globalize__29_globalize_node2013, _node_globalize__29_globalize_node, 0L, 3);
DEFINE_STRING(string2004_globalize_node, string2004_globalize_node2014, "make-escaping-bindings: ", 24);
DEFINE_STRING(string2002_globalize_node, string2002_globalize_node2015, "# glo!   :", 10);
DEFINE_STRING(string2005_globalize_node, string2005_globalize_node2016, "PROCEDURE-SET! FOREIGN MAKE-VA-PROCEDURE MAKE-FX-PROCEDURE GLOBALIZE AUX DONE GLO!-DEFAULT1413 (WRITE CELL-GLOBALIZE) CELL-GLOBALIZE ", 133);
DEFINE_STRING(string2001_globalize_node, string2001_globalize_node2017, "# handler: ", 11);
DEFINE_STRING(string2003_globalize_node, string2003_globalize_node2018, "             ebindings: ", 24);
DEFINE_STRING(string2000_globalize_node, string2000_globalize_node2019, "No method for this object", 25);

obj_t 
module_initialization_70_globalize_node(long checksum_2756, char *from_2757)
{
   if (CBOOL(require_initialization_114_globalize_node))
     {
	require_initialization_114_globalize_node = BBOOL(((bool_t) 0));
	library_modules_init_112_globalize_node();
	cnst_init_137_globalize_node();
	imported_modules_init_94_globalize_node();
	toplevel_init_63_globalize_node();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_globalize_node()
{
   module_initialization_70___object(((long) 0), "GLOBALIZE_NODE");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_NODE");
   module_initialization_70___reader(((long) 0), "GLOBALIZE_NODE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_globalize_node()
{
   {
      obj_t cnst_port_138_2748;
      cnst_port_138_2748 = open_input_string(string2005_globalize_node);
      {
	 long i_2749;
	 i_2749 = ((long) 9);
       loop_2750:
	 {
	    bool_t test2006_2751;
	    test2006_2751 = (i_2749 == ((long) -1));
	    if (test2006_2751)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2007_2752;
		    {
		       obj_t list2008_2753;
		       {
			  obj_t arg2009_2754;
			  arg2009_2754 = BNIL;
			  list2008_2753 = MAKE_PAIR(cnst_port_138_2748, arg2009_2754);
		       }
		       arg2007_2752 = read___reader(list2008_2753);
		    }
		    CNST_TABLE_SET(i_2749, arg2007_2752);
		 }
		 {
		    int aux_2755;
		    {
		       long aux_2774;
		       aux_2774 = (i_2749 - ((long) 1));
		       aux_2755 = (int) (aux_2774);
		    }
		    {
		       long i_2777;
		       i_2777 = (long) (aux_2755);
		       i_2749 = i_2777;
		       goto loop_2750;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_globalize_node()
{
   add_generic__110___object(glo__env_172_globalize_node, glo__default1413_env_124_globalize_node);
   add_inlined_method__244___object(glo__env_172_globalize_node, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(glo__env_172_globalize_node, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(glo__env_172_globalize_node, var_ast_node, ((long) 2));
   add_inlined_method__244___object(glo__env_172_globalize_node, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(glo__env_172_globalize_node, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(glo__env_172_globalize_node, app_ast_node, ((long) 5));
   add_inlined_method__244___object(glo__env_172_globalize_node, app_ly_162_ast_node, ((long) 6));
   add_inlined_method__244___object(glo__env_172_globalize_node, funcall_ast_node, ((long) 7));
   add_inlined_method__244___object(glo__env_172_globalize_node, pragma_ast_node, ((long) 8));
   add_inlined_method__244___object(glo__env_172_globalize_node, cast_ast_node, ((long) 9));
   add_inlined_method__244___object(glo__env_172_globalize_node, setq_ast_node, ((long) 10));
   add_inlined_method__244___object(glo__env_172_globalize_node, conditional_ast_node, ((long) 11));
   add_inlined_method__244___object(glo__env_172_globalize_node, fail_ast_node, ((long) 12));
   add_inlined_method__244___object(glo__env_172_globalize_node, select_ast_node, ((long) 13));
   add_inlined_method__244___object(glo__env_172_globalize_node, let_fun_218_ast_node, ((long) 14));
   add_inlined_method__244___object(glo__env_172_globalize_node, let_var_6_ast_node, ((long) 15));
   add_inlined_method__244___object(glo__env_172_globalize_node, set_ex_it_116_ast_node, ((long) 16));
   add_inlined_method__244___object(glo__env_172_globalize_node, jump_ex_it_184_ast_node, ((long) 17));
   add_inlined_method__244___object(glo__env_172_globalize_node, make_box_202_ast_node, ((long) 18));
   add_inlined_method__244___object(glo__env_172_globalize_node, box_ref_242_ast_node, ((long) 19));
   {
      long aux_2800;
      aux_2800 = add_inlined_method__244___object(glo__env_172_globalize_node, box_set__221_ast_node, ((long) 20));
      return BINT(aux_2800);
   }
}


node_t 
node_globalize__229_globalize_node(node_t node_1, variable_t integrator_2, obj_t what_by__117_3)
{
   {
      obj_t celled_983;
      {
	 obj_t aux_2803;
	 {
	    sfun_t obj_1830;
	    {
	       value_t aux_2804;
	       aux_2804 = (((variable_t) CREF(integrator_2))->value);
	       obj_1830 = (sfun_t) (aux_2804);
	    }
	    aux_2803 = (((sfun_t) CREF(obj_1830))->args);
	 }
	 celled_983 = celled_bindings_3_globalize_node(aux_2803);
      }
      {
	 obj_t what_by__117_984;
	 what_by__117_984 = append_2_18___r4_pairs_and_lists_6_3(celled_983, what_by__117_3);
	 {
	    {
	       obj_t l1369_985;
	       l1369_985 = what_by__117_984;
	     lname1370_986:
	       if (PAIRP(l1369_985))
		 {
		    {
		       obj_t w_b_127_988;
		       w_b_127_988 = CAR(l1369_985);
		       {
			  obj_t arg1441_990;
			  arg1441_990 = CDR(w_b_127_988);
			  {
			     obj_t res1934_1837;
			     {
				local_t obj_1835;
				{
				   obj_t aux_2814;
				   aux_2814 = CAR(w_b_127_988);
				   obj_1835 = (local_t) (aux_2814);
				}
				{
				   obj_t x_2709;
				   x_2709 = ((((local_t) CREF(obj_1835))->fast_alpha_7) = ((obj_t) arg1441_990), BUNSPEC);
				   res1934_1837 = BUNSPEC;
				}
			     }
			     res1934_1837;
			  }
		       }
		    }
		    {
		       obj_t l1369_2818;
		       l1369_2818 = CDR(l1369_985);
		       l1369_985 = l1369_2818;
		       goto lname1370_986;
		    }
		 }
	       else
		 {
		    ((bool_t) 1);
		 }
	    }
	    {
	       obj_t res_992;
	       {
		  node_t arg1448_999;
		  arg1448_999 = glo__115_globalize_node(node_1, integrator_2);
		  res_992 = cell_formals_12_globalize_node(celled_983, arg1448_999);
	       }
	       {
		  obj_t l1371_993;
		  l1371_993 = what_by__117_984;
		lname1373_994:
		  if (PAIRP(l1371_993))
		    {
		       {
			  obj_t res1935_1844;
			  {
			     local_t obj_1842;
			     {
				obj_t aux_2824;
				{
				   obj_t aux_2825;
				   aux_2825 = CAR(l1371_993);
				   aux_2824 = CAR(aux_2825);
				}
				obj_1842 = (local_t) (aux_2824);
			     }
			     {
				obj_t x_2710;
				x_2710 = ((((local_t) CREF(obj_1842))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
				res1935_1844 = BUNSPEC;
			     }
			  }
			  res1935_1844;
		       }
		       {
			  obj_t l1371_2830;
			  l1371_2830 = CDR(l1371_993);
			  l1371_993 = l1371_2830;
			  goto lname1373_994;
		       }
		    }
		  else
		    {
		       ((bool_t) 1);
		    }
	       }
	       return (node_t) (res_992);
	    }
	 }
      }
   }
}


obj_t 
_node_globalize__29_globalize_node(obj_t env_2705, obj_t node_2706, obj_t integrator_2707, obj_t what_by__117_2708)
{
   {
      node_t aux_2833;
      aux_2833 = node_globalize__229_globalize_node((node_t) (node_2706), (variable_t) (integrator_2707), what_by__117_2708);
      return (obj_t) (aux_2833);
   }
}


obj_t 
celled_bindings_3_globalize_node(obj_t formals_4)
{
   {
      obj_t celled_1001;
      obj_t formals_1002;
      celled_1001 = BNIL;
      formals_1002 = formals_4;
    loop_1003:
      if (NULLP(formals_1002))
	{
	   return celled_1001;
	}
      else
	{
	   bool_t test_2840;
	   {
	      variable_t aux_2841;
	      {
		 obj_t aux_2842;
		 aux_2842 = CAR(formals_1002);
		 aux_2841 = (variable_t) (aux_2842);
	      }
	      test_2840 = celled__113_globalize_node(aux_2841);
	   }
	   if (test_2840)
	     {
		{
		   local_t var_1007;
		   {
		      obj_t aux_2846;
		      {
			 local_t obj_1849;
			 {
			    obj_t aux_2847;
			    aux_2847 = CAR(formals_1002);
			    obj_1849 = (local_t) (aux_2847);
			 }
			 aux_2846 = (((local_t) CREF(obj_1849))->id);
		      }
		      var_1007 = make_local_svar_140_ast_local(aux_2846, (type_t) (__obj__252_type_cache));
		   }
		   {
		      obj_t o_n_168_1008;
		      {
			 obj_t aux_2855;
			 obj_t aux_2853;
			 aux_2855 = (obj_t) (var_1007);
			 aux_2853 = CAR(formals_1002);
			 o_n_168_1008 = MAKE_PAIR(aux_2853, aux_2855);
		      }
		      {
			 {
			    obj_t arg1453_1009;
			    arg1453_1009 = CNST_TABLE_REF(((long) 0));
			    {
			       obj_t res1936_1855;
			       {
				  obj_t x_2711;
				  x_2711 = ((((local_t) CREF(var_1007))->access) = ((obj_t) arg1453_1009), BUNSPEC);
				  res1936_1855 = BUNSPEC;
			       }
			       res1936_1855;
			    }
			 }
			 {
			    svar_ginfo_131_t obj1374_1010;
			    obj1374_1010 = ((svar_ginfo_131_t) ((((local_t) CREF(var_1007))->value)));
			    {
			       svar_ginfo_131_t arg1454_1011;
			       {
				  svar_ginfo_131_t res1937_1866;
				  {
				     svar_ginfo_131_t new1314_1861;
				     new1314_1861 = ((svar_ginfo_131_t) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
				     ((((svar_ginfo_131_t) CREF(new1314_1861))->kaptured__204) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				     ((((svar_ginfo_131_t) CREF(new1314_1861))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
				     ((((svar_ginfo_131_t) CREF(new1314_1861))->mark) = ((long) ((long) -10)), BUNSPEC);
				     ((((svar_ginfo_131_t) CREF(new1314_1861))->celled__113) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				     res1937_1866 = new1314_1861;
				  }
				  arg1454_1011 = res1937_1866;
			       }
			       {
				  obj_t aux_2869;
				  object_t aux_2867;
				  aux_2869 = (obj_t) (arg1454_1011);
				  aux_2867 = (object_t) (obj1374_1010);
				  OBJECT_WIDENING_SET(aux_2867, aux_2869);
			       }
			    }
			    {
			       long arg1457_1012;
			       arg1457_1012 = class_num_218___object(svar_ginfo_131_globalize_ginfo);
			       {
				  obj_t obj_1867;
				  obj_1867 = (obj_t) (obj1374_1010);
				  (((obj_t) CREF(obj_1867))->header = MAKE_HEADER(arg1457_1012, 0), BUNSPEC);
			       }
			    }
			    obj1374_1010;
			 }
			 {
			    obj_t arg1458_1013;
			    obj_t arg1461_1014;
			    arg1458_1013 = MAKE_PAIR(o_n_168_1008, celled_1001);
			    arg1461_1014 = CDR(formals_1002);
			    {
			       obj_t formals_2878;
			       obj_t celled_2877;
			       celled_2877 = arg1458_1013;
			       formals_2878 = arg1461_1014;
			       formals_1002 = formals_2878;
			       celled_1001 = celled_2877;
			       goto loop_1003;
			    }
			 }
		      }
		   }
		}
	     }
	   else
	     {
		{
		   obj_t formals_2879;
		   formals_2879 = CDR(formals_1002);
		   formals_1002 = formals_2879;
		   goto loop_1003;
		}
	     }
	}
   }
}


obj_t 
cell_formals_12_globalize_node(obj_t celled_5, node_t body_6)
{
   {
      bool_t test1469_1020;
      test1469_1020 = NULLP(celled_5);
      if (test1469_1020)
	{
	   return (obj_t) (body_6);
	}
      else
	{
	   obj_t loc_1021;
	   loc_1021 = (((node_t) CREF(body_6))->loc);
	   {
	      obj_t arg1470_1022;
	      if (test1469_1020)
		{
		   arg1470_1022 = BNIL;
		}
	      else
		{
		   obj_t head1377_1025;
		   head1377_1025 = MAKE_PAIR(BNIL, BNIL);
		   {
		      obj_t l1375_1026;
		      obj_t tail1378_1027;
		      l1375_1026 = celled_5;
		      tail1378_1027 = head1377_1025;
		    lname1376_1028:
		      if (NULLP(l1375_1026))
			{
			   arg1470_1022 = CDR(head1377_1025);
			}
		      else
			{
			   obj_t new_tail1379_169_1030;
			   {
			      obj_t arg1476_1032;
			      {
				 obj_t o_n_168_1034;
				 o_n_168_1034 = CAR(l1375_1026);
				 {
				    obj_t arg1478_1035;
				    make_box_202_t arg1480_1036;
				    arg1478_1035 = CDR(o_n_168_1034);
				    {
				       var_t arg1481_1037;
				       obj_t arg1484_1038;
				       {
					  var_t res1938_1893;
					  {
					     type_t type_1884;
					     variable_t variable_1885;
					     type_1884 = (type_t) (_____74_type_cache);
					     {
						obj_t aux_2893;
						aux_2893 = CAR(o_n_168_1034);
						variable_1885 = (variable_t) (aux_2893);
					     }
					     {
						var_t new1133_1886;
						new1133_1886 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
						{
						   long arg1697_1887;
						   arg1697_1887 = class_num_218___object(var_ast_node);
						   {
						      obj_t obj_1891;
						      obj_1891 = (obj_t) (new1133_1886);
						      (((obj_t) CREF(obj_1891))->header = MAKE_HEADER(arg1697_1887, 0), BUNSPEC);
						   }
						}
						{
						   object_t aux_2900;
						   aux_2900 = (object_t) (new1133_1886);
						   OBJECT_WIDENING_SET(aux_2900, BFALSE);
						}
						((((var_t) CREF(new1133_1886))->loc) = ((obj_t) loc_1021), BUNSPEC);
						((((var_t) CREF(new1133_1886))->type) = ((type_t) type_1884), BUNSPEC);
						((((var_t) CREF(new1133_1886))->variable) = ((variable_t) variable_1885), BUNSPEC);
						res1938_1893 = new1133_1886;
					     }
					  }
					  arg1481_1037 = res1938_1893;
				       }
				       arg1484_1038 = CAR(o_n_168_1034);
				       arg1480_1036 = a_make_cell_117_globalize_node((node_t) (arg1481_1037), (variable_t) (arg1484_1038));
				    }
				    {
				       obj_t aux_2910;
				       aux_2910 = (obj_t) (arg1480_1036);
				       arg1476_1032 = MAKE_PAIR(arg1478_1035, aux_2910);
				    }
				 }
			      }
			      new_tail1379_169_1030 = MAKE_PAIR(arg1476_1032, BNIL);
			   }
			   SET_CDR(tail1378_1027, new_tail1379_169_1030);
			   {
			      obj_t tail1378_2917;
			      obj_t l1375_2915;
			      l1375_2915 = CDR(l1375_1026);
			      tail1378_2917 = new_tail1379_169_1030;
			      tail1378_1027 = tail1378_2917;
			      l1375_1026 = l1375_2915;
			      goto lname1376_1028;
			   }
			}
		   }
		}
	      {
		 let_var_6_t res1939_1918;
		 {
		    type_t type_1903;
		    type_1903 = (type_t) (_____74_type_cache);
		    {
		       let_var_6_t new1234_1908;
		       new1234_1908 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
		       {
			  long arg1659_1909;
			  arg1659_1909 = class_num_218___object(let_var_6_ast_node);
			  {
			     obj_t obj_1916;
			     obj_1916 = (obj_t) (new1234_1908);
			     (((obj_t) CREF(obj_1916))->header = MAKE_HEADER(arg1659_1909, 0), BUNSPEC);
			  }
		       }
		       {
			  object_t aux_2923;
			  aux_2923 = (object_t) (new1234_1908);
			  OBJECT_WIDENING_SET(aux_2923, BFALSE);
		       }
		       ((((let_var_6_t) CREF(new1234_1908))->loc) = ((obj_t) loc_1021), BUNSPEC);
		       ((((let_var_6_t) CREF(new1234_1908))->type) = ((type_t) type_1903), BUNSPEC);
		       ((((let_var_6_t) CREF(new1234_1908))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		       ((((let_var_6_t) CREF(new1234_1908))->bindings) = ((obj_t) arg1470_1022), BUNSPEC);
		       ((((let_var_6_t) CREF(new1234_1908))->body) = ((node_t) body_6), BUNSPEC);
		       ((((let_var_6_t) CREF(new1234_1908))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		       res1939_1918 = new1234_1908;
		    }
		 }
		 return (obj_t) (res1939_1918);
	      }
	   }
	}
   }
}


make_box_202_t 
a_make_cell_117_globalize_node(node_t node_7, variable_t variable_8)
{
   {
      obj_t arg1489_1043;
      arg1489_1043 = CNST_TABLE_REF(((long) 0));
      {
	 obj_t res1940_1921;
	 {
	    local_t obj_1919;
	    obj_1919 = (local_t) (variable_8);
	    {
	       obj_t x_2712;
	       x_2712 = ((((local_t) CREF(obj_1919))->access) = ((obj_t) arg1489_1043), BUNSPEC);
	       res1940_1921 = BUNSPEC;
	    }
	 }
	 res1940_1921;
      }
   }
   {
      obj_t res1941_1925;
      {
	 svar_ginfo_131_t obj_1923;
	 {
	    value_t aux_2936;
	    aux_2936 = (((variable_t) CREF(variable_8))->value);
	    obj_1923 = (svar_ginfo_131_t) (aux_2936);
	 }
	 {
	    obj_t x_2713;
	    {
	       obj_t aux_2939;
	       {
		  object_t aux_2940;
		  aux_2940 = (object_t) (obj_1923);
		  aux_2939 = OBJECT_WIDENING(aux_2940);
	       }
	       x_2713 = ((((svar_ginfo_131_t) CREF(aux_2939))->celled__113) = ((bool_t) ((bool_t) 1)), BUNSPEC);
	    }
	    res1941_1925 = BUNSPEC;
	 }
      }
      res1941_1925;
   }
   {
      obj_t arg1493_1045;
      arg1493_1045 = (((node_t) CREF(node_7))->loc);
      {
	 make_box_202_t res1942_1939;
	 {
	    type_t type_1928;
	    type_1928 = (type_t) (_____74_type_cache);
	    {
	       make_box_202_t new1258_1931;
	       new1258_1931 = ((make_box_202_t) BREF(GC_MALLOC(sizeof(struct make_box_202))));
	       {
		  long arg1652_1932;
		  arg1652_1932 = class_num_218___object(make_box_202_ast_node);
		  {
		     obj_t obj_1937;
		     obj_1937 = (obj_t) (new1258_1931);
		     (((obj_t) CREF(obj_1937))->header = MAKE_HEADER(arg1652_1932, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_2950;
		  aux_2950 = (object_t) (new1258_1931);
		  OBJECT_WIDENING_SET(aux_2950, BFALSE);
	       }
	       ((((make_box_202_t) CREF(new1258_1931))->loc) = ((obj_t) arg1493_1045), BUNSPEC);
	       ((((make_box_202_t) CREF(new1258_1931))->type) = ((type_t) type_1928), BUNSPEC);
	       ((((make_box_202_t) CREF(new1258_1931))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
	       ((((make_box_202_t) CREF(new1258_1931))->value) = ((node_t) node_7), BUNSPEC);
	       res1942_1939 = new1258_1931;
	    }
	 }
	 return res1942_1939;
      }
   }
}


bool_t 
celled__113_globalize_node(variable_t variable_9)
{
   {
      bool_t _andtest_1381_1046;
      _andtest_1381_1046 = is_a__118___object((obj_t) (variable_9), local_ast_var);
      if (_andtest_1381_1046)
	{
	   bool_t _andtest_1382_1047;
	   {
	      obj_t aux_2960;
	      {
		 value_t aux_2961;
		 aux_2961 = (((variable_t) CREF(variable_9))->value);
		 aux_2960 = (obj_t) (aux_2961);
	      }
	      _andtest_1382_1047 = is_a__118___object(aux_2960, svar_ginfo_131_globalize_ginfo);
	   }
	   if (_andtest_1382_1047)
	     {
		bool_t _ortest_1383_1048;
		{
		   svar_ginfo_131_t obj_1944;
		   {
		      value_t aux_2966;
		      aux_2966 = (((variable_t) CREF(variable_9))->value);
		      obj_1944 = (svar_ginfo_131_t) (aux_2966);
		   }
		   {
		      obj_t aux_2969;
		      {
			 object_t aux_2970;
			 aux_2970 = (object_t) (obj_1944);
			 aux_2969 = OBJECT_WIDENING(aux_2970);
		      }
		      _ortest_1383_1048 = (((svar_ginfo_131_t) CREF(aux_2969))->celled__113);
		   }
		}
		if (_ortest_1383_1048)
		  {
		     return _ortest_1383_1048;
		  }
		else
		  {
		     bool_t test_2975;
		     {
			obj_t aux_2976;
			aux_2976 = memq___r4_pairs_and_lists_6_3((((variable_t) CREF(variable_9))->access), CNST_TABLE_REF(((long) 1)));
			test_2975 = CBOOL(aux_2976);
		     }
		     if (test_2975)
		       {
			  svar_ginfo_131_t obj_1947;
			  {
			     value_t aux_2981;
			     aux_2981 = (((variable_t) CREF(variable_9))->value);
			     obj_1947 = (svar_ginfo_131_t) (aux_2981);
			  }
			  {
			     obj_t aux_2984;
			     {
				object_t aux_2985;
				aux_2985 = (object_t) (obj_1947);
				aux_2984 = OBJECT_WIDENING(aux_2985);
			     }
			     return (((svar_ginfo_131_t) CREF(aux_2984))->kaptured__204);
			  }
		       }
		     else
		       {
			  return ((bool_t) 0);
		       }
		  }
	     }
	   else
	     {
		return ((bool_t) 0);
	     }
	}
      else
	{
	   return ((bool_t) 0);
	}
   }
}


node_t 
glo__default1413_248_globalize_node(node_t node_12, variable_t integrator_13)
{
   FAILURE(CNST_TABLE_REF(((long) 2)), string2000_globalize_node, (obj_t) (node_12));
}


obj_t 
_glo__default1413_58_globalize_node(obj_t env_2702, obj_t node_2703, obj_t integrator_2704)
{
   {
      node_t aux_2992;
      aux_2992 = glo__default1413_248_globalize_node((node_t) (node_2703), (variable_t) (integrator_2704));
      return (obj_t) (aux_2992);
   }
}


node_t 
glo__115_globalize_node(node_t node_10, variable_t integrator_11)
{
   {
      obj_t method1735_1562;
      obj_t class1742_1563;
      {
	 obj_t arg1745_1560;
	 obj_t arg1746_1561;
	 {
	    object_t obj_1953;
	    obj_1953 = (object_t) (node_10);
	    {
	       obj_t pre_method_105_1954;
	       pre_method_105_1954 = PROCEDURE_REF(glo__env_172_globalize_node, ((long) 2));
	       if (INTEGERP(pre_method_105_1954))
		 {
		    PROCEDURE_SET(glo__env_172_globalize_node, ((long) 2), BUNSPEC);
		    arg1745_1560 = pre_method_105_1954;
		 }
	       else
		 {
		    long obj_class_num_177_1959;
		    obj_class_num_177_1959 = TYPE(obj_1953);
		    {
		       obj_t arg1183_1960;
		       arg1183_1960 = PROCEDURE_REF(glo__env_172_globalize_node, ((long) 1));
		       {
			  long arg1184_1964;
			  {
			     long arg1186_1965;
			     arg1186_1965 = OBJECT_TYPE;
			     arg1184_1964 = (obj_class_num_177_1959 - arg1186_1965);
			  }
			  arg1745_1560 = VECTOR_REF(arg1183_1960, arg1184_1964);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1970;
	    object_1970 = (object_t) (node_10);
	    {
	       long arg1187_1971;
	       {
		  long arg1188_1972;
		  long arg1189_1973;
		  arg1188_1972 = TYPE(object_1970);
		  arg1189_1973 = OBJECT_TYPE;
		  arg1187_1971 = (arg1188_1972 - arg1189_1973);
	       }
	       {
		  obj_t vector_1977;
		  vector_1977 = __classes__134___object;
		  arg1746_1561 = VECTOR_REF(vector_1977, arg1187_1971);
	       }
	    }
	 }
	 {
	    obj_t aux_3012;
	    method1735_1562 = arg1745_1560;
	    class1742_1563 = arg1746_1561;
	    {
	       if (INTEGERP(method1735_1562))
		 {
		    switch ((long) CINT(method1735_1562))
		      {
		      case ((long) 0):
			 {
			    atom_t aux_3015;
			    aux_3015 = (atom_t) (node_10);
			    aux_3012 = (obj_t) (aux_3015);
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t aux_3018;
			    aux_3018 = (kwote_t) (node_10);
			    aux_3012 = (obj_t) (aux_3018);
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t node_1573;
			    node_1573 = (var_t) (node_10);
			    {
			       variable_t var_1575;
			       var_1575 = (((var_t) CREF(node_1573))->variable);
			       {
				  obj_t alpha_1576;
				  alpha_1576 = (((variable_t) CREF(var_1575))->fast_alpha_7);
				  {
				     {
					bool_t test1749_1577;
					test1749_1577 = is_a__118___object(alpha_1576, local_ast_var);
					if (test1749_1577)
					  {
					     {
						obj_t res1943_1984;
						{
						   variable_t val1136_1983;
						   val1136_1983 = (variable_t) (alpha_1576);
						   {
						      obj_t x_2714;
						      x_2714 = ((((var_t) CREF(node_1573))->variable) = ((variable_t) val1136_1983), BUNSPEC);
						      res1943_1984 = BUNSPEC;
						   }
						}
						res1943_1984;
					     }
					     {
						node_t aux_3028;
						aux_3028 = glo__115_globalize_node((node_t) (node_1573), integrator_11);
						aux_3012 = (obj_t) (aux_3028);
					     }
					  }
					else
					  {
					     bool_t test1750_1578;
					     test1750_1578 = is_a__118___object((obj_t) (var_1575), global_ast_var);
					     if (test1750_1578)
					       {
						  aux_3012 = (obj_t) (node_1573);
					       }
					     else
					       {
						  if (celled__113_globalize_node(var_1575))
						    {
						       {
							  obj_t arg1753_1580;
							  arg1753_1580 = CNST_TABLE_REF(((long) 0));
							  {
							     obj_t res1944_1988;
							     {
								local_t obj_1986;
								obj_1986 = (local_t) (var_1575);
								{
								   obj_t x_2715;
								   x_2715 = ((((local_t) CREF(obj_1986))->access) = ((obj_t) arg1753_1580), BUNSPEC);
								   res1944_1988 = BUNSPEC;
								}
							     }
							     res1944_1988;
							  }
						       }
						       {
							  obj_t arg1754_1581;
							  type_t arg1755_1582;
							  {
							     node_t obj_1989;
							     obj_1989 = (node_t) (node_1573);
							     arg1754_1581 = (((node_t) CREF(obj_1989))->loc);
							  }
							  {
							     node_t obj_1990;
							     obj_1990 = (node_t) (node_1573);
							     arg1755_1582 = (((node_t) CREF(obj_1990))->type);
							  }
							  {
							     box_ref_242_t res1945_2003;
							     {
								box_ref_242_t new1266_1995;
								new1266_1995 = ((box_ref_242_t) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
								{
								   long arg1650_1996;
								   arg1650_1996 = class_num_218___object(box_ref_242_ast_node);
								   {
								      obj_t obj_2001;
								      obj_2001 = (obj_t) (new1266_1995);
								      (((obj_t) CREF(obj_2001))->header = MAKE_HEADER(arg1650_1996, 0), BUNSPEC);
								   }
								}
								{
								   object_t aux_3049;
								   aux_3049 = (object_t) (new1266_1995);
								   OBJECT_WIDENING_SET(aux_3049, BFALSE);
								}
								((((box_ref_242_t) CREF(new1266_1995))->loc) = ((obj_t) arg1754_1581), BUNSPEC);
								((((box_ref_242_t) CREF(new1266_1995))->type) = ((type_t) arg1755_1582), BUNSPEC);
								((((box_ref_242_t) CREF(new1266_1995))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
								((((box_ref_242_t) CREF(new1266_1995))->var) = ((var_t) node_1573), BUNSPEC);
								res1945_2003 = new1266_1995;
							     }
							     aux_3012 = (obj_t) (res1945_2003);
							  }
						       }
						    }
						  else
						    {
						       aux_3012 = (obj_t) (node_1573);
						    }
					       }
					  }
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 3):
			 {
			    closure_t node_1583;
			    node_1583 = (closure_t) (node_10);
			    {
			       var_t arg1756_1586;
			       {
				  obj_t arg1758_1587;
				  obj_t arg1759_1588;
				  arg1758_1587 = (((closure_t) CREF(node_1583))->loc);
				  arg1759_1588 = the_closure_238_globalize_free((((closure_t) CREF(node_1583))->variable), (((closure_t) CREF(node_1583))->loc));
				  {
				     var_t res1946_2017;
				     {
					type_t type_2008;
					variable_t variable_2009;
					type_2008 = (type_t) (__procedure__226_type_cache);
					variable_2009 = (variable_t) (arg1759_1588);
					{
					   var_t new1133_2010;
					   new1133_2010 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
					   {
					      long arg1697_2011;
					      arg1697_2011 = class_num_218___object(var_ast_node);
					      {
						 obj_t obj_2015;
						 obj_2015 = (obj_t) (new1133_2010);
						 (((obj_t) CREF(obj_2015))->header = MAKE_HEADER(arg1697_2011, 0), BUNSPEC);
					      }
					   }
					   {
					      object_t aux_3069;
					      aux_3069 = (object_t) (new1133_2010);
					      OBJECT_WIDENING_SET(aux_3069, BFALSE);
					   }
					   ((((var_t) CREF(new1133_2010))->loc) = ((obj_t) arg1758_1587), BUNSPEC);
					   ((((var_t) CREF(new1133_2010))->type) = ((type_t) type_2008), BUNSPEC);
					   ((((var_t) CREF(new1133_2010))->variable) = ((variable_t) variable_2009), BUNSPEC);
					   res1946_2017 = new1133_2010;
					}
				     }
				     arg1756_1586 = res1946_2017;
				  }
			       }
			       {
				  node_t aux_3075;
				  aux_3075 = glo__115_globalize_node((node_t) (arg1756_1586), integrator_11);
				  aux_3012 = (obj_t) (aux_3075);
			       }
			    }
			 }
			 break;
		      case ((long) 4):
			 {
			    sequence_t node_1591;
			    node_1591 = (sequence_t) (node_10);
			    glo___241_globalize_node((((sequence_t) CREF(node_1591))->nodes), integrator_11);
			    aux_3012 = (obj_t) (node_1591);
			 }
			 break;
		      case ((long) 5):
			 {
			    app_t node_1595;
			    node_1595 = (app_t) (node_10);
			    {
			       variable_t fun_1598;
			       {
				  var_t arg1804_1642;
				  arg1804_1642 = (((app_t) CREF(node_1595))->fun);
				  fun_1598 = (((var_t) CREF(arg1804_1642))->variable);
			       }
			       {
				  value_t info_1599;
				  info_1599 = (((variable_t) CREF(fun_1598))->value);
				  {
				     {
					bool_t test1764_1600;
					{
					   bool_t test1771_1605;
					   test1771_1605 = is_a__118___object((obj_t) (fun_1598), local_ast_var);
					   if (test1771_1605)
					     {
						bool_t test_3090;
						{
						   bool_t test_3091;
						   {
						      obj_t aux_3094;
						      obj_t aux_3092;
						      aux_3094 = (obj_t) (integrator_11);
						      aux_3092 = (obj_t) (fun_1598);
						      test_3091 = (aux_3092 == aux_3094);
						   }
						   if (test_3091)
						     {
							bool_t test_3097;
							{
							   local_ginfo_108_t obj_2025;
							   obj_2025 = (local_ginfo_108_t) (fun_1598);
							   {
							      obj_t aux_3099;
							      {
								 object_t aux_3100;
								 aux_3100 = (object_t) (obj_2025);
								 aux_3099 = OBJECT_WIDENING(aux_3100);
							      }
							      test_3097 = (((local_ginfo_108_t) CREF(aux_3099))->escape__117);
							   }
							}
							if (test_3097)
							  {
							     test_3090 = ((bool_t) 0);
							  }
							else
							  {
							     test_3090 = ((bool_t) 1);
							  }
						     }
						   else
						     {
							test_3090 = ((bool_t) 1);
						     }
						}
						if (test_3090)
						  {
						     sfun_ginfo_98_t obj_2026;
						     obj_2026 = (sfun_ginfo_98_t) (info_1599);
						     {
							obj_t aux_3105;
							{
							   object_t aux_3106;
							   aux_3106 = (object_t) (obj_2026);
							   aux_3105 = OBJECT_WIDENING(aux_3106);
							}
							test1764_1600 = (((sfun_ginfo_98_t) CREF(aux_3105))->g__219);
						     }
						  }
						else
						  {
						     test1764_1600 = ((bool_t) 0);
						  }
					     }
					   else
					     {
						test1764_1600 = ((bool_t) 0);
					     }
					}
					if (test1764_1600)
					  {
					     var_t arg1766_1601;
					     {
						obj_t arg1767_1602;
						type_t arg1769_1603;
						global_t arg1770_1604;
						arg1767_1602 = (((app_t) CREF(node_1595))->loc);
						arg1769_1603 = (((app_t) CREF(node_1595))->type);
						arg1770_1604 = the_global_201_globalize_local__global_194((local_t) (fun_1598));
						{
						   var_t res1947_2039;
						   {
						      variable_t variable_2031;
						      variable_2031 = (variable_t) (arg1770_1604);
						      {
							 var_t new1133_2032;
							 new1133_2032 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
							 {
							    long arg1697_2033;
							    arg1697_2033 = class_num_218___object(var_ast_node);
							    {
							       obj_t obj_2037;
							       obj_2037 = (obj_t) (new1133_2032);
							       (((obj_t) CREF(obj_2037))->header = MAKE_HEADER(arg1697_2033, 0), BUNSPEC);
							    }
							 }
							 {
							    object_t aux_3120;
							    aux_3120 = (object_t) (new1133_2032);
							    OBJECT_WIDENING_SET(aux_3120, BFALSE);
							 }
							 ((((var_t) CREF(new1133_2032))->loc) = ((obj_t) arg1767_1602), BUNSPEC);
							 ((((var_t) CREF(new1133_2032))->type) = ((type_t) arg1769_1603), BUNSPEC);
							 ((((var_t) CREF(new1133_2032))->variable) = ((variable_t) variable_2031), BUNSPEC);
							 res1947_2039 = new1133_2032;
						      }
						   }
						   arg1766_1601 = res1947_2039;
						}
					     }
					     {
						obj_t res1948_2042;
						{
						   obj_t x_2716;
						   x_2716 = ((((app_t) CREF(node_1595))->fun) = ((var_t) arg1766_1601), BUNSPEC);
						   res1948_2042 = BUNSPEC;
						}
						res1948_2042;
					     }
					  }
					else
					  {
					     BUNSPEC;
					  }
				     }
				     {
					obj_t nodes_1609;
					nodes_1609 = (((app_t) CREF(node_1595))->args);
				      liip_1610:
					if (NULLP(nodes_1609))
					  {
					     CNST_TABLE_REF(((long) 3));
					  }
					else
					  {
					     {
						node_t arg1777_1613;
						{
						   node_t aux_3130;
						   {
						      obj_t aux_3131;
						      aux_3131 = CAR(nodes_1609);
						      aux_3130 = (node_t) (aux_3131);
						   }
						   arg1777_1613 = glo__115_globalize_node(aux_3130, integrator_11);
						}
						{
						   obj_t aux_3135;
						   aux_3135 = (obj_t) (arg1777_1613);
						   SET_CAR(nodes_1609, aux_3135);
						}
					     }
					     {
						obj_t nodes_3138;
						nodes_3138 = CDR(nodes_1609);
						nodes_1609 = nodes_3138;
						goto liip_1610;
					     }
					  }
				     }
				     {
					bool_t test1780_1616;
					{
					   bool_t test1801_1639;
					   test1801_1639 = is_a__118___object((obj_t) (fun_1598), global_ast_var);
					   if (test1801_1639)
					     {
						test1780_1616 = ((bool_t) 1);
					     }
					   else
					     {
						bool_t test_3144;
						{
						   sfun_ginfo_98_t obj_2050;
						   obj_2050 = (sfun_ginfo_98_t) (info_1599);
						   {
						      obj_t aux_3146;
						      {
							 object_t aux_3147;
							 aux_3147 = (object_t) (obj_2050);
							 aux_3146 = OBJECT_WIDENING(aux_3147);
						      }
						      test_3144 = (((sfun_ginfo_98_t) CREF(aux_3146))->g__219);
						   }
						}
						if (test_3144)
						  {
						     bool_t test_3151;
						     {
							obj_t aux_3154;
							obj_t aux_3152;
							aux_3154 = (obj_t) (integrator_11);
							aux_3152 = (obj_t) (fun_1598);
							test_3151 = (aux_3152 == aux_3154);
						     }
						     if (test_3151)
						       {
							  local_ginfo_108_t obj_2053;
							  obj_2053 = (local_ginfo_108_t) (fun_1598);
							  {
							     obj_t aux_3158;
							     {
								object_t aux_3159;
								aux_3159 = (object_t) (obj_2053);
								aux_3158 = OBJECT_WIDENING(aux_3159);
							     }
							     test1780_1616 = (((local_ginfo_108_t) CREF(aux_3158))->escape__117);
							  }
						       }
						     else
						       {
							  test1780_1616 = ((bool_t) 0);
						       }
						  }
						else
						  {
						     test1780_1616 = ((bool_t) 1);
						  }
					     }
					}
					if (test1780_1616)
					  {
					     CNST_TABLE_REF(((long) 3));
					  }
					else
					  {
					     bool_t test_3165;
					     {
						local_ginfo_108_t obj_2054;
						obj_2054 = (local_ginfo_108_t) (fun_1598);
						{
						   obj_t aux_3167;
						   {
						      object_t aux_3168;
						      aux_3168 = (object_t) (obj_2054);
						      aux_3167 = OBJECT_WIDENING(aux_3168);
						   }
						   test_3165 = (((local_ginfo_108_t) CREF(aux_3167))->escape__117);
						}
					     }
					     if (test_3165)
					       {
						  {
						     obj_t arg1783_1618;
						     {
							node_t arg1784_1619;
							obj_t arg1785_1620;
							{
							   var_t arg1786_1621;
							   {
							      obj_t arg1788_1622;
							      obj_t arg1789_1623;
							      arg1788_1622 = (((app_t) CREF(node_1595))->loc);
							      arg1789_1623 = the_closure_238_globalize_free(fun_1598, (((app_t) CREF(node_1595))->loc));
							      {
								 var_t res1949_2067;
								 {
								    type_t type_2058;
								    variable_t variable_2059;
								    type_2058 = (type_t) (_____74_type_cache);
								    variable_2059 = (variable_t) (arg1789_1623);
								    {
								       var_t new1133_2060;
								       new1133_2060 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
								       {
									  long arg1697_2061;
									  arg1697_2061 = class_num_218___object(var_ast_node);
									  {
									     obj_t obj_2065;
									     obj_2065 = (obj_t) (new1133_2060);
									     (((obj_t) CREF(obj_2065))->header = MAKE_HEADER(arg1697_2061, 0), BUNSPEC);
									  }
								       }
								       {
									  object_t aux_3181;
									  aux_3181 = (object_t) (new1133_2060);
									  OBJECT_WIDENING_SET(aux_3181, BFALSE);
								       }
								       ((((var_t) CREF(new1133_2060))->loc) = ((obj_t) arg1788_1622), BUNSPEC);
								       ((((var_t) CREF(new1133_2060))->type) = ((type_t) type_2058), BUNSPEC);
								       ((((var_t) CREF(new1133_2060))->variable) = ((variable_t) variable_2059), BUNSPEC);
								       res1949_2067 = new1133_2060;
								    }
								 }
								 arg1786_1621 = res1949_2067;
							      }
							   }
							   arg1784_1619 = glo__115_globalize_node((node_t) (arg1786_1621), integrator_11);
							}
							arg1785_1620 = (((app_t) CREF(node_1595))->args);
							{
							   obj_t aux_3190;
							   aux_3190 = (obj_t) (arg1784_1619);
							   arg1783_1618 = MAKE_PAIR(aux_3190, arg1785_1620);
							}
						     }
						     {
							obj_t res1950_2073;
							{
							   obj_t x_2717;
							   x_2717 = ((((app_t) CREF(node_1595))->args) = ((obj_t) arg1783_1618), BUNSPEC);
							   res1950_2073 = BUNSPEC;
							}
							res1950_2073;
						     }
						  }
					       }
					     else
					       {
						  {
						     obj_t new_actuals_73_1625;
						     obj_t kaptured_1626;
						     new_actuals_73_1625 = (((app_t) CREF(node_1595))->args);
						     {
							sfun_ginfo_98_t obj_2075;
							obj_2075 = (sfun_ginfo_98_t) (info_1599);
							{
							   obj_t aux_3223;
							   {
							      object_t aux_3224;
							      aux_3224 = (object_t) (obj_2075);
							      aux_3223 = OBJECT_WIDENING(aux_3224);
							   }
							   kaptured_1626 = (((sfun_ginfo_98_t) CREF(aux_3223))->kaptured);
							}
						     }
						   loop_1627:
						     if (NULLP(kaptured_1626))
						       {
							  obj_t res1951_2079;
							  {
							     obj_t x_2718;
							     x_2718 = ((((app_t) CREF(node_1595))->args) = ((obj_t) new_actuals_73_1625), BUNSPEC);
							     res1951_2079 = BUNSPEC;
							  }
							  res1951_2079;
						       }
						     else
						       {
							  obj_t kap_1631;
							  kap_1631 = CAR(kaptured_1626);
							  {
							     obj_t alpha_1632;
							     {
								local_t obj_2081;
								obj_2081 = (local_t) (kap_1631);
								alpha_1632 = (((local_t) CREF(obj_2081))->fast_alpha_7);
							     }
							     {
								obj_t var_1633;
								{
								   bool_t test1800_1638;
								   test1800_1638 = is_a__118___object(alpha_1632, local_ast_var);
								   if (test1800_1638)
								     {
									var_1633 = alpha_1632;
								     }
								   else
								     {
									var_1633 = kap_1631;
								     }
								}
								{
								   {
								      obj_t arg1795_1634;
								      obj_t arg1796_1635;
								      {
									 var_t arg1798_1636;
									 {
									    obj_t arg1799_1637;
									    arg1799_1637 = (((app_t) CREF(node_1595))->loc);
									    {
									       var_t res1952_2094;
									       {
										  type_t type_2085;
										  variable_t variable_2086;
										  type_2085 = (type_t) (_____74_type_cache);
										  variable_2086 = (variable_t) (var_1633);
										  {
										     var_t new1133_2087;
										     new1133_2087 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
										     {
											long arg1697_2088;
											arg1697_2088 = class_num_218___object(var_ast_node);
											{
											   obj_t obj_2092;
											   obj_2092 = (obj_t) (new1133_2087);
											   (((obj_t) CREF(obj_2092))->header = MAKE_HEADER(arg1697_2088, 0), BUNSPEC);
											}
										     }
										     {
											object_t aux_3209;
											aux_3209 = (object_t) (new1133_2087);
											OBJECT_WIDENING_SET(aux_3209, BFALSE);
										     }
										     ((((var_t) CREF(new1133_2087))->loc) = ((obj_t) arg1799_1637), BUNSPEC);
										     ((((var_t) CREF(new1133_2087))->type) = ((type_t) type_2085), BUNSPEC);
										     ((((var_t) CREF(new1133_2087))->variable) = ((variable_t) variable_2086), BUNSPEC);
										     res1952_2094 = new1133_2087;
										  }
									       }
									       arg1798_1636 = res1952_2094;
									    }
									 }
									 {
									    obj_t aux_3215;
									    aux_3215 = (obj_t) (arg1798_1636);
									    arg1795_1634 = MAKE_PAIR(aux_3215, new_actuals_73_1625);
									 }
								      }
								      arg1796_1635 = CDR(kaptured_1626);
								      {
									 obj_t kaptured_3220;
									 obj_t new_actuals_73_3219;
									 new_actuals_73_3219 = arg1795_1634;
									 kaptured_3220 = arg1796_1635;
									 kaptured_1626 = kaptured_3220;
									 new_actuals_73_1625 = new_actuals_73_3219;
									 goto loop_1627;
								      }
								   }
								}
							     }
							  }
						       }
						  }
					       }
					  }
				     }
				     aux_3012 = (obj_t) (node_1595);
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 6):
			 {
			    app_ly_162_t node_1643;
			    node_1643 = (app_ly_162_t) (node_10);
			    {
			       node_t arg1805_1646;
			       arg1805_1646 = glo__115_globalize_node((((app_ly_162_t) CREF(node_1643))->fun), integrator_11);
			       {
				  obj_t res1953_2101;
				  {
				     obj_t x_2719;
				     x_2719 = ((((app_ly_162_t) CREF(node_1643))->fun) = ((node_t) arg1805_1646), BUNSPEC);
				     res1953_2101 = BUNSPEC;
				  }
				  res1953_2101;
			       }
			    }
			    {
			       node_t arg1807_1648;
			       arg1807_1648 = glo__115_globalize_node((((app_ly_162_t) CREF(node_1643))->arg), integrator_11);
			       {
				  obj_t res1954_2105;
				  {
				     obj_t x_2720;
				     x_2720 = ((((app_ly_162_t) CREF(node_1643))->arg) = ((node_t) arg1807_1648), BUNSPEC);
				     res1954_2105 = BUNSPEC;
				  }
				  res1954_2105;
			       }
			    }
			    aux_3012 = (obj_t) (node_1643);
			 }
			 break;
		      case ((long) 7):
			 {
			    funcall_t node_1650;
			    node_1650 = (funcall_t) (node_10);
			    {
			       node_t arg1809_1653;
			       arg1809_1653 = glo__115_globalize_node((((funcall_t) CREF(node_1650))->fun), integrator_11);
			       {
				  obj_t res1955_2109;
				  {
				     obj_t x_2721;
				     x_2721 = ((((funcall_t) CREF(node_1650))->fun) = ((node_t) arg1809_1653), BUNSPEC);
				     res1955_2109 = BUNSPEC;
				  }
				  res1955_2109;
			       }
			    }
			    glo___241_globalize_node((((funcall_t) CREF(node_1650))->args), integrator_11);
			    aux_3012 = (obj_t) (node_1650);
			 }
			 break;
		      case ((long) 8):
			 {
			    pragma_t node_1656;
			    node_1656 = (pragma_t) (node_10);
			    glo___241_globalize_node((((pragma_t) CREF(node_1656))->args), integrator_11);
			    aux_3012 = (obj_t) (node_1656);
			 }
			 break;
		      case ((long) 9):
			 {
			    cast_t node_1660;
			    node_1660 = (cast_t) (node_10);
			    glo__115_globalize_node((((cast_t) CREF(node_1660))->arg), integrator_11);
			    aux_3012 = (obj_t) (node_1660);
			 }
			 break;
		      case ((long) 10):
			 {
			    setq_t node_1664;
			    node_1664 = (setq_t) (node_10);
			    {
			       node_t arg1814_1667;
			       arg1814_1667 = glo__115_globalize_node((((setq_t) CREF(node_1664))->value), integrator_11);
			       {
				  obj_t res1956_2116;
				  {
				     obj_t x_2722;
				     x_2722 = ((((setq_t) CREF(node_1664))->value) = ((node_t) arg1814_1667), BUNSPEC);
				     res1956_2116 = BUNSPEC;
				  }
				  res1956_2116;
			       }
			    }
			    {
			       variable_t var_1669;
			       {
				  var_t arg1839_1696;
				  arg1839_1696 = (((setq_t) CREF(node_1664))->var);
				  var_1669 = (((var_t) CREF(arg1839_1696))->variable);
			       }
			       {
				  obj_t var_1670;
				  obj_t alpha_1671;
				  var_1670 = (obj_t) (var_1669);
				  alpha_1671 = (((variable_t) CREF(var_1669))->fast_alpha_7);
				loop_1672:
				  {
				     bool_t test1821_1674;
				     test1821_1674 = is_a__118___object(alpha_1671, local_ast_var);
				     if (test1821_1674)
				       {
					  {
					     var_t arg1822_1675;
					     arg1822_1675 = (((setq_t) CREF(node_1664))->var);
					     {
						obj_t res1957_2124;
						{
						   variable_t val1136_2123;
						   val1136_2123 = (variable_t) (alpha_1671);
						   {
						      obj_t x_2723;
						      x_2723 = ((((var_t) CREF(arg1822_1675))->variable) = ((variable_t) val1136_2123), BUNSPEC);
						      res1957_2124 = BUNSPEC;
						   }
						}
						res1957_2124;
					     }
					  }
					  {
					     obj_t alpha_3264;
					     obj_t var_3263;
					     var_3263 = alpha_1671;
					     {
						variable_t obj_2125;
						obj_2125 = (variable_t) (alpha_1671);
						alpha_3264 = (((variable_t) CREF(obj_2125))->fast_alpha_7);
					     }
					     alpha_1671 = alpha_3264;
					     var_1670 = var_3263;
					     goto loop_1672;
					  }
				       }
				     else
				       {
					  variable_t var_1677;
					  {
					     var_t arg1838_1695;
					     arg1838_1695 = (((setq_t) CREF(node_1664))->var);
					     var_1677 = (((var_t) CREF(arg1838_1695))->variable);
					  }
					  {
					     bool_t test1824_1678;
					     {
						bool_t test1837_1694;
						test1837_1694 = is_a__118___object((obj_t) (var_1677), local_ast_var);
						if (test1837_1694)
						  {
						     test1824_1678 = celled__113_globalize_node(var_1677);
						  }
						else
						  {
						     test1824_1678 = ((bool_t) 0);
						  }
					     }
					     if (test1824_1678)
					       {
						  local_t a_var_30_1679;
						  obj_t loc_1680;
						  a_var_30_1679 = make_local_svar_140_ast_local(CNST_TABLE_REF(((long) 4)), (type_t) (__obj__252_type_cache));
						  {
						     node_t obj_2129;
						     obj_2129 = (node_t) (node_1664);
						     loc_1680 = (((node_t) CREF(obj_2129))->loc);
						  }
						  {
						     obj_t arg1825_1681;
						     arg1825_1681 = CNST_TABLE_REF(((long) 0));
						     {
							obj_t res1958_2132;
							{
							   local_t obj_2130;
							   obj_2130 = (local_t) (var_1677);
							   {
							      obj_t x_2724;
							      x_2724 = ((((local_t) CREF(obj_2130))->access) = ((obj_t) arg1825_1681), BUNSPEC);
							      res1958_2132 = BUNSPEC;
							   }
							}
							res1958_2132;
						     }
						  }
						  {
						     svar_ginfo_131_t obj1394_1682;
						     obj1394_1682 = ((svar_ginfo_131_t) ((((local_t) CREF(a_var_30_1679))->value)));
						     {
							svar_ginfo_131_t arg1826_1683;
							{
							   svar_ginfo_131_t res1959_2143;
							   {
							      svar_ginfo_131_t new1314_2138;
							      new1314_2138 = ((svar_ginfo_131_t) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
							      ((((svar_ginfo_131_t) CREF(new1314_2138))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							      ((((svar_ginfo_131_t) CREF(new1314_2138))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
							      ((((svar_ginfo_131_t) CREF(new1314_2138))->mark) = ((long) ((long) -10)), BUNSPEC);
							      ((((svar_ginfo_131_t) CREF(new1314_2138))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							      res1959_2143 = new1314_2138;
							   }
							   arg1826_1683 = res1959_2143;
							}
							{
							   obj_t aux_3291;
							   object_t aux_3289;
							   aux_3291 = (obj_t) (arg1826_1683);
							   aux_3289 = (object_t) (obj1394_1682);
							   OBJECT_WIDENING_SET(aux_3289, aux_3291);
							}
						     }
						     {
							long arg1827_1684;
							arg1827_1684 = class_num_218___object(svar_ginfo_131_globalize_ginfo);
							{
							   obj_t obj_2144;
							   obj_2144 = (obj_t) (obj1394_1682);
							   (((obj_t) CREF(obj_2144))->header = MAKE_HEADER(arg1827_1684, 0), BUNSPEC);
							}
						     }
						     obj1394_1682;
						  }
						  {
						     obj_t arg1828_1685;
						     box_set__221_t arg1829_1686;
						     {
							obj_t arg1830_1687;
							{
							   obj_t aux_3299;
							   obj_t aux_3297;
							   {
							      node_t aux_3300;
							      aux_3300 = (((setq_t) CREF(node_1664))->value);
							      aux_3299 = (obj_t) (aux_3300);
							   }
							   aux_3297 = (obj_t) (a_var_30_1679);
							   arg1830_1687 = MAKE_PAIR(aux_3297, aux_3299);
							}
							{
							   obj_t list1831_1688;
							   list1831_1688 = MAKE_PAIR(arg1830_1687, BNIL);
							   arg1828_1685 = list1831_1688;
							}
						     }
						     {
							var_t arg1834_1691;
							var_t arg1835_1692;
							arg1834_1691 = (((setq_t) CREF(node_1664))->var);
							{
							   var_t res1960_2161;
							   {
							      type_t type_2152;
							      variable_t variable_2153;
							      type_2152 = (type_t) (_____74_type_cache);
							      variable_2153 = (variable_t) (a_var_30_1679);
							      {
								 var_t new1133_2154;
								 new1133_2154 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
								 {
								    long arg1697_2155;
								    arg1697_2155 = class_num_218___object(var_ast_node);
								    {
								       obj_t obj_2159;
								       obj_2159 = (obj_t) (new1133_2154);
								       (((obj_t) CREF(obj_2159))->header = MAKE_HEADER(arg1697_2155, 0), BUNSPEC);
								    }
								 }
								 {
								    object_t aux_3312;
								    aux_3312 = (object_t) (new1133_2154);
								    OBJECT_WIDENING_SET(aux_3312, BFALSE);
								 }
								 ((((var_t) CREF(new1133_2154))->loc) = ((obj_t) loc_1680), BUNSPEC);
								 ((((var_t) CREF(new1133_2154))->type) = ((type_t) type_2152), BUNSPEC);
								 ((((var_t) CREF(new1133_2154))->variable) = ((variable_t) variable_2153), BUNSPEC);
								 res1960_2161 = new1133_2154;
							      }
							   }
							   arg1835_1692 = res1960_2161;
							}
							{
							   box_set__221_t res1961_2174;
							   {
							      type_t type_2163;
							      node_t value_2165;
							      type_2163 = (type_t) (_____74_type_cache);
							      value_2165 = (node_t) (arg1835_1692);
							      {
								 box_set__221_t new1273_2166;
								 new1273_2166 = ((box_set__221_t) BREF(GC_MALLOC(sizeof(struct box_set__221))));
								 {
								    long arg1647_2167;
								    arg1647_2167 = class_num_218___object(box_set__221_ast_node);
								    {
								       obj_t obj_2172;
								       obj_2172 = (obj_t) (new1273_2166);
								       (((obj_t) CREF(obj_2172))->header = MAKE_HEADER(arg1647_2167, 0), BUNSPEC);
								    }
								 }
								 {
								    object_t aux_3324;
								    aux_3324 = (object_t) (new1273_2166);
								    OBJECT_WIDENING_SET(aux_3324, BFALSE);
								 }
								 ((((box_set__221_t) CREF(new1273_2166))->loc) = ((obj_t) loc_1680), BUNSPEC);
								 ((((box_set__221_t) CREF(new1273_2166))->type) = ((type_t) type_2163), BUNSPEC);
								 ((((box_set__221_t) CREF(new1273_2166))->var) = ((var_t) arg1834_1691), BUNSPEC);
								 ((((box_set__221_t) CREF(new1273_2166))->value) = ((node_t) value_2165), BUNSPEC);
								 res1961_2174 = new1273_2166;
							      }
							   }
							   arg1829_1686 = res1961_2174;
							}
						     }
						     {
							let_var_6_t res1962_2191;
							{
							   type_t type_2176;
							   node_t body_2179;
							   type_2176 = (type_t) (_____74_type_cache);
							   body_2179 = (node_t) (arg1829_1686);
							   {
							      let_var_6_t new1234_2181;
							      new1234_2181 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
							      {
								 long arg1659_2182;
								 arg1659_2182 = class_num_218___object(let_var_6_ast_node);
								 {
								    obj_t obj_2189;
								    obj_2189 = (obj_t) (new1234_2181);
								    (((obj_t) CREF(obj_2189))->header = MAKE_HEADER(arg1659_2182, 0), BUNSPEC);
								 }
							      }
							      {
								 object_t aux_3337;
								 aux_3337 = (object_t) (new1234_2181);
								 OBJECT_WIDENING_SET(aux_3337, BFALSE);
							      }
							      ((((let_var_6_t) CREF(new1234_2181))->loc) = ((obj_t) loc_1680), BUNSPEC);
							      ((((let_var_6_t) CREF(new1234_2181))->type) = ((type_t) type_2176), BUNSPEC);
							      ((((let_var_6_t) CREF(new1234_2181))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
							      ((((let_var_6_t) CREF(new1234_2181))->bindings) = ((obj_t) arg1828_1685), BUNSPEC);
							      ((((let_var_6_t) CREF(new1234_2181))->body) = ((node_t) body_2179), BUNSPEC);
							      ((((let_var_6_t) CREF(new1234_2181))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
							      res1962_2191 = new1234_2181;
							   }
							}
							aux_3012 = (obj_t) (res1962_2191);
						     }
						  }
					       }
					     else
					       {
						  aux_3012 = (obj_t) (node_1664);
					       }
					  }
				       }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 11):
			 {
			    conditional_t node_1697;
			    node_1697 = (conditional_t) (node_10);
			    {
			       node_t arg1840_1700;
			       arg1840_1700 = glo__115_globalize_node((((conditional_t) CREF(node_1697))->test), integrator_11);
			       {
				  obj_t res1963_2195;
				  {
				     obj_t x_2725;
				     x_2725 = ((((conditional_t) CREF(node_1697))->test) = ((node_t) arg1840_1700), BUNSPEC);
				     res1963_2195 = BUNSPEC;
				  }
				  res1963_2195;
			       }
			    }
			    {
			       node_t arg1842_1702;
			       arg1842_1702 = glo__115_globalize_node((((conditional_t) CREF(node_1697))->true), integrator_11);
			       {
				  obj_t res1964_2199;
				  {
				     obj_t x_2726;
				     x_2726 = ((((conditional_t) CREF(node_1697))->true) = ((node_t) arg1842_1702), BUNSPEC);
				     res1964_2199 = BUNSPEC;
				  }
				  res1964_2199;
			       }
			    }
			    {
			       node_t arg1844_1704;
			       arg1844_1704 = glo__115_globalize_node((((conditional_t) CREF(node_1697))->false), integrator_11);
			       {
				  obj_t res1965_2203;
				  {
				     obj_t x_2727;
				     x_2727 = ((((conditional_t) CREF(node_1697))->false) = ((node_t) arg1844_1704), BUNSPEC);
				     res1965_2203 = BUNSPEC;
				  }
				  res1965_2203;
			       }
			    }
			    aux_3012 = (obj_t) (node_1697);
			 }
			 break;
		      case ((long) 12):
			 {
			    fail_t node_1706;
			    node_1706 = (fail_t) (node_10);
			    {
			       node_t arg1846_1709;
			       arg1846_1709 = glo__115_globalize_node((((fail_t) CREF(node_1706))->proc), integrator_11);
			       {
				  obj_t res1966_2207;
				  {
				     obj_t x_2728;
				     x_2728 = ((((fail_t) CREF(node_1706))->proc) = ((node_t) arg1846_1709), BUNSPEC);
				     res1966_2207 = BUNSPEC;
				  }
				  res1966_2207;
			       }
			    }
			    {
			       node_t arg1848_1711;
			       arg1848_1711 = glo__115_globalize_node((((fail_t) CREF(node_1706))->msg), integrator_11);
			       {
				  obj_t res1967_2211;
				  {
				     obj_t x_2729;
				     x_2729 = ((((fail_t) CREF(node_1706))->msg) = ((node_t) arg1848_1711), BUNSPEC);
				     res1967_2211 = BUNSPEC;
				  }
				  res1967_2211;
			       }
			    }
			    {
			       node_t arg1852_1713;
			       arg1852_1713 = glo__115_globalize_node((((fail_t) CREF(node_1706))->obj), integrator_11);
			       {
				  obj_t res1968_2215;
				  {
				     obj_t x_2730;
				     x_2730 = ((((fail_t) CREF(node_1706))->obj) = ((node_t) arg1852_1713), BUNSPEC);
				     res1968_2215 = BUNSPEC;
				  }
				  res1968_2215;
			       }
			    }
			    aux_3012 = (obj_t) (node_1706);
			 }
			 break;
		      case ((long) 13):
			 {
			    select_t node_1715;
			    node_1715 = (select_t) (node_10);
			    {
			       node_t arg1855_1718;
			       arg1855_1718 = glo__115_globalize_node((((select_t) CREF(node_1715))->test), integrator_11);
			       {
				  obj_t res1969_2219;
				  {
				     obj_t x_2731;
				     x_2731 = ((((select_t) CREF(node_1715))->test) = ((node_t) arg1855_1718), BUNSPEC);
				     res1969_2219 = BUNSPEC;
				  }
				  res1969_2219;
			       }
			    }
			    {
			       obj_t l1398_1720;
			       l1398_1720 = (((select_t) CREF(node_1715))->clauses);
			     lname1399_1721:
			       if (PAIRP(l1398_1720))
				 {
				    {
				       obj_t clause_1724;
				       clause_1724 = CAR(l1398_1720);
				       {
					  node_t arg1859_1725;
					  {
					     node_t aux_3379;
					     {
						obj_t aux_3380;
						aux_3380 = CDR(clause_1724);
						aux_3379 = (node_t) (aux_3380);
					     }
					     arg1859_1725 = glo__115_globalize_node(aux_3379, integrator_11);
					  }
					  {
					     obj_t aux_3384;
					     aux_3384 = (obj_t) (arg1859_1725);
					     SET_CDR(clause_1724, aux_3384);
					  }
				       }
				    }
				    {
				       obj_t l1398_3387;
				       l1398_3387 = CDR(l1398_1720);
				       l1398_1720 = l1398_3387;
				       goto lname1399_1721;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_3012 = (obj_t) (node_1715);
			 }
			 break;
		      case ((long) 14):
			 {
			    let_fun_218_t node_1728;
			    node_1728 = (let_fun_218_t) (node_10);
			    {
			       node_t arg1862_1731;
			       arg1862_1731 = glo__115_globalize_node((((let_fun_218_t) CREF(node_1728))->body), integrator_11);
			       {
				  obj_t res1970_2230;
				  {
				     obj_t x_2732;
				     x_2732 = ((((let_fun_218_t) CREF(node_1728))->body) = ((node_t) arg1862_1731), BUNSPEC);
				     res1970_2230 = BUNSPEC;
				  }
				  res1970_2230;
			       }
			    }
			    {
			       obj_t obindings_1733;
			       obj_t nbindings_1734;
			       obj_t ebindings_1735;
			       obindings_1733 = (((let_fun_218_t) CREF(node_1728))->locals);
			       nbindings_1734 = BNIL;
			       ebindings_1735 = BNIL;
			     liip_1736:
			       if (NULLP(obindings_1733))
				 {
				    {
				       obj_t res1971_2235;
				       {
					  obj_t x_2733;
					  x_2733 = ((((let_fun_218_t) CREF(node_1728))->locals) = ((obj_t) nbindings_1734), BUNSPEC);
					  res1971_2235 = BUNSPEC;
				       }
				       res1971_2235;
				    }
				    if (NULLP(ebindings_1735))
				      {
					 aux_3012 = (obj_t) (node_1728);
				      }
				    else
				      {
					 let_var_6_t aux_3401;
					 aux_3401 = make_escaping_bindings_69_globalize_node(ebindings_1735, (node_t) (node_1728), integrator_11);
					 aux_3012 = (obj_t) (aux_3401);
				      }
				 }
			       else
				 {
				    bool_t test_3405;
				    {
				       bool_t test_3406;
				       {
					  obj_t aux_3409;
					  obj_t aux_3407;
					  aux_3409 = (obj_t) (integrator_11);
					  aux_3407 = CAR(obindings_1733);
					  test_3406 = (aux_3407 == aux_3409);
				       }
				       if (test_3406)
					 {
					    test_3405 = ((bool_t) 0);
					 }
				       else
					 {
					    local_ginfo_108_t obj_2241;
					    {
					       obj_t aux_3412;
					       aux_3412 = CAR(obindings_1733);
					       obj_2241 = (local_ginfo_108_t) (aux_3412);
					    }
					    {
					       obj_t aux_3415;
					       {
						  object_t aux_3416;
						  aux_3416 = (object_t) (obj_2241);
						  aux_3415 = OBJECT_WIDENING(aux_3416);
					       }
					       test_3405 = (((local_ginfo_108_t) CREF(aux_3415))->escape__117);
					    }
					 }
				    }
				    if (test_3405)
				      {
					 {
					    obj_t arg1870_1743;
					    obj_t arg1871_1744;
					    arg1870_1743 = CDR(obindings_1733);
					    {
					       obj_t aux_3421;
					       aux_3421 = CAR(obindings_1733);
					       arg1871_1744 = MAKE_PAIR(aux_3421, ebindings_1735);
					    }
					    {
					       obj_t ebindings_3425;
					       obj_t obindings_3424;
					       obindings_3424 = arg1870_1743;
					       ebindings_3425 = arg1871_1744;
					       ebindings_1735 = ebindings_3425;
					       obindings_1733 = obindings_3424;
					       goto liip_1736;
					    }
					 }
				      }
				    else
				      {
					 {
					    obj_t local_1746;
					    local_1746 = CAR(obindings_1733);
					    globalize_local_fun__50_globalize_node((local_t) (local_1746), integrator_11);
					    {
					       obj_t arg1874_1747;
					       obj_t arg1875_1748;
					       arg1874_1747 = CDR(obindings_1733);
					       arg1875_1748 = MAKE_PAIR(local_1746, nbindings_1734);
					       {
						  obj_t nbindings_3432;
						  obj_t obindings_3431;
						  obindings_3431 = arg1874_1747;
						  nbindings_3432 = arg1875_1748;
						  nbindings_1734 = nbindings_3432;
						  obindings_1733 = obindings_3431;
						  goto liip_1736;
					       }
					    }
					 }
				      }
				 }
			    }
			 }
			 break;
		      case ((long) 15):
			 {
			    let_var_6_t node_1752;
			    node_1752 = (let_var_6_t) (node_10);
			    {
			       obj_t l1402_1755;
			       l1402_1755 = (((let_var_6_t) CREF(node_1752))->bindings);
			     lname1403_1756:
			       if (PAIRP(l1402_1755))
				 {
				    {
				       obj_t binding_1759;
				       binding_1759 = CAR(l1402_1755);
				       {
					  obj_t var_1760;
					  obj_t val_1761;
					  var_1760 = CAR(binding_1759);
					  val_1761 = CDR(binding_1759);
					  {
					     node_t arg1882_1762;
					     arg1882_1762 = glo__115_globalize_node((node_t) (val_1761), integrator_11);
					     {
						obj_t aux_3442;
						aux_3442 = (obj_t) (arg1882_1762);
						SET_CDR(binding_1759, aux_3442);
					     }
					  }
					  if (celled__113_globalize_node((variable_t) (var_1760)))
					    {
					       {
						  obj_t res1972_2259;
						  {
						     local_t obj_2257;
						     type_t val1056_2258;
						     obj_2257 = (local_t) (var_1760);
						     val1056_2258 = (type_t) (__obj__252_type_cache);
						     {
							obj_t x_2734;
							x_2734 = ((((local_t) CREF(obj_2257))->type) = ((type_t) val1056_2258), BUNSPEC);
							res1972_2259 = BUNSPEC;
						     }
						  }
						  res1972_2259;
					       }
					       {
						  make_box_202_t arg1884_1764;
						  arg1884_1764 = a_make_cell_117_globalize_node((node_t) (val_1761), (variable_t) (var_1760));
						  {
						     obj_t aux_3454;
						     aux_3454 = (obj_t) (arg1884_1764);
						     SET_CDR(binding_1759, aux_3454);
						  }
					       }
					    }
					  else
					    {
					       BUNSPEC;
					    }
				       }
				    }
				    {
				       obj_t l1402_3457;
				       l1402_3457 = CDR(l1402_1755);
				       l1402_1755 = l1402_3457;
				       goto lname1403_1756;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1886_1766;
			       arg1886_1766 = glo__115_globalize_node((((let_var_6_t) CREF(node_1752))->body), integrator_11);
			       {
				  obj_t res1973_2266;
				  {
				     obj_t x_2735;
				     x_2735 = ((((let_var_6_t) CREF(node_1752))->body) = ((node_t) arg1886_1766), BUNSPEC);
				     res1973_2266 = BUNSPEC;
				  }
				  res1973_2266;
			       }
			    }
			    aux_3012 = (obj_t) (node_1752);
			 }
			 break;
		      case ((long) 16):
			 {
			    set_ex_it_116_t node_1768;
			    node_1768 = (set_ex_it_116_t) (node_10);
			    {
			       obj_t hdlg_1771;
			       {
				  sexit_t obj_2270;
				  {
				     value_t aux_3465;
				     {
					local_t obj_2269;
					{
					   variable_t aux_3466;
					   {
					      var_t arg1913_1795;
					      arg1913_1795 = (((set_ex_it_116_t) CREF(node_1768))->var);
					      aux_3466 = (((var_t) CREF(arg1913_1795))->variable);
					   }
					   obj_2269 = (local_t) (aux_3466);
					}
					aux_3465 = (((local_t) CREF(obj_2269))->value);
				     }
				     obj_2270 = (sexit_t) (aux_3465);
				  }
				  hdlg_1771 = (((sexit_t) CREF(obj_2270))->handler);
			       }
			       {
				  bool_t test1888_1772;
				  {
				     obj_t aux_3473;
				     aux_3473 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 5)), BINT(((long) 2)));
				     test1888_1772 = CBOOL(aux_3473);
				  }
				  if (test1888_1772)
				    {
				       obj_t arg1890_1774;
				       obj_t arg1892_1776;
				       arg1890_1774 = shape_tools_shape((obj_t) (node_1768));
				       arg1892_1776 = shape_tools_shape(hdlg_1771);
				       {
					  obj_t list1893_1777;
					  {
					     obj_t arg1894_1778;
					     {
						obj_t arg1895_1779;
						{
						   obj_t arg1896_1780;
						   {
						      obj_t arg1897_1781;
						      {
							 obj_t arg1898_1782;
							 {
							    obj_t aux_3482;
							    aux_3482 = BCHAR(((unsigned char) '\n'));
							    arg1898_1782 = MAKE_PAIR(aux_3482, BNIL);
							 }
							 arg1897_1781 = MAKE_PAIR(arg1892_1776, arg1898_1782);
						      }
						      arg1896_1780 = MAKE_PAIR(string2001_globalize_node, arg1897_1781);
						   }
						   {
						      obj_t aux_3487;
						      aux_3487 = BCHAR(((unsigned char) '\n'));
						      arg1895_1779 = MAKE_PAIR(aux_3487, arg1896_1780);
						   }
						}
						arg1894_1778 = MAKE_PAIR(arg1890_1774, arg1895_1779);
					     }
					     list1893_1777 = MAKE_PAIR(string2002_globalize_node, arg1894_1778);
					  }
					  print_trace_107_tools_trace(list1893_1777);
				       }
				    }
				  else
				    {
				       BUNSPEC;
				    }
			       }
			       {
				  bool_t test_3493;
				  {
				     sfun_ginfo_98_t obj_2272;
				     {
					value_t aux_3494;
					{
					   local_t obj_2271;
					   obj_2271 = (local_t) (hdlg_1771);
					   aux_3494 = (((local_t) CREF(obj_2271))->value);
					}
					obj_2272 = (sfun_ginfo_98_t) (aux_3494);
				     }
				     {
					obj_t aux_3498;
					{
					   object_t aux_3499;
					   aux_3499 = (object_t) (obj_2272);
					   aux_3498 = OBJECT_WIDENING(aux_3499);
					}
					test_3493 = (((sfun_ginfo_98_t) CREF(aux_3498))->g__219);
				     }
				  }
				  if (test_3493)
				    {
				       obj_t res1974_2278;
				       {
					  sexit_t obj_2276;
					  {
					     value_t aux_3503;
					     {
						local_t obj_2275;
						{
						   variable_t aux_3504;
						   {
						      var_t arg1906_1789;
						      arg1906_1789 = (((set_ex_it_116_t) CREF(node_1768))->var);
						      aux_3504 = (((var_t) CREF(arg1906_1789))->variable);
						   }
						   obj_2275 = (local_t) (aux_3504);
						}
						aux_3503 = (((local_t) CREF(obj_2275))->value);
					     }
					     obj_2276 = (sexit_t) (aux_3503);
					  }
					  {
					     obj_t x_2736;
					     x_2736 = ((((sexit_t) CREF(obj_2276))->detached__120) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					     res1974_2278 = BUNSPEC;
					  }
				       }
				       res1974_2278;
				    }
				  else
				    {
				       BUNSPEC;
				    }
			       }
			       {
				  node_t arg1908_1791;
				  arg1908_1791 = glo__115_globalize_node((((set_ex_it_116_t) CREF(node_1768))->body), integrator_11);
				  {
				     obj_t res1975_2282;
				     {
					obj_t x_2737;
					x_2737 = ((((set_ex_it_116_t) CREF(node_1768))->body) = ((node_t) arg1908_1791), BUNSPEC);
					res1975_2282 = BUNSPEC;
				     }
				     res1975_2282;
				  }
			       }
			       aux_3012 = (obj_t) (node_1768);
			    }
			 }
			 break;
		      case ((long) 17):
			 {
			    jump_ex_it_184_t node_1796;
			    node_1796 = (jump_ex_it_184_t) (node_10);
			    {
			       node_t arg1914_1799;
			       arg1914_1799 = glo__115_globalize_node((((jump_ex_it_184_t) CREF(node_1796))->exit), integrator_11);
			       {
				  obj_t res1976_2286;
				  {
				     obj_t x_2738;
				     x_2738 = ((((jump_ex_it_184_t) CREF(node_1796))->exit) = ((node_t) arg1914_1799), BUNSPEC);
				     res1976_2286 = BUNSPEC;
				  }
				  res1976_2286;
			       }
			    }
			    {
			       node_t arg1916_1801;
			       arg1916_1801 = glo__115_globalize_node((((jump_ex_it_184_t) CREF(node_1796))->value), integrator_11);
			       {
				  obj_t res1977_2290;
				  {
				     obj_t x_2739;
				     x_2739 = ((((jump_ex_it_184_t) CREF(node_1796))->value) = ((node_t) arg1916_1801), BUNSPEC);
				     res1977_2290 = BUNSPEC;
				  }
				  res1977_2290;
			       }
			    }
			    aux_3012 = (obj_t) (node_1796);
			 }
			 break;
		      case ((long) 18):
			 {
			    make_box_202_t node_1803;
			    node_1803 = (make_box_202_t) (node_10);
			    {
			       node_t arg1918_1806;
			       arg1918_1806 = glo__115_globalize_node((((make_box_202_t) CREF(node_1803))->value), integrator_11);
			       {
				  obj_t res1978_2294;
				  {
				     obj_t x_2740;
				     x_2740 = ((((make_box_202_t) CREF(node_1803))->value) = ((node_t) arg1918_1806), BUNSPEC);
				     res1978_2294 = BUNSPEC;
				  }
				  res1978_2294;
			       }
			    }
			    aux_3012 = (obj_t) (node_1803);
			 }
			 break;
		      case ((long) 19):
			 {
			    box_ref_242_t node_1808;
			    node_1808 = (box_ref_242_t) (node_10);
			    {
			       node_t arg1922_1811;
			       {
				  node_t aux_3529;
				  {
				     var_t aux_3530;
				     aux_3530 = (((box_ref_242_t) CREF(node_1808))->var);
				     aux_3529 = (node_t) (aux_3530);
				  }
				  arg1922_1811 = glo__115_globalize_node(aux_3529, integrator_11);
			       }
			       {
				  obj_t res1979_2298;
				  {
				     var_t val1270_2297;
				     val1270_2297 = (var_t) (arg1922_1811);
				     {
					obj_t x_2741;
					x_2741 = ((((box_ref_242_t) CREF(node_1808))->var) = ((var_t) val1270_2297), BUNSPEC);
					res1979_2298 = BUNSPEC;
				     }
				  }
				  res1979_2298;
			       }
			    }
			    aux_3012 = (obj_t) (node_1808);
			 }
			 break;
		      case ((long) 20):
			 {
			    box_set__221_t node_1813;
			    node_1813 = (box_set__221_t) (node_10);
			    {
			       node_t arg1925_1816;
			       {
				  node_t aux_3538;
				  {
				     var_t aux_3539;
				     aux_3539 = (((box_set__221_t) CREF(node_1813))->var);
				     aux_3538 = (node_t) (aux_3539);
				  }
				  arg1925_1816 = glo__115_globalize_node(aux_3538, integrator_11);
			       }
			       {
				  obj_t res1980_2302;
				  {
				     var_t val1276_2301;
				     val1276_2301 = (var_t) (arg1925_1816);
				     {
					obj_t x_2742;
					x_2742 = ((((box_set__221_t) CREF(node_1813))->var) = ((var_t) val1276_2301), BUNSPEC);
					res1980_2302 = BUNSPEC;
				     }
				  }
				  res1980_2302;
			       }
			    }
			    {
			       node_t arg1927_1818;
			       arg1927_1818 = glo__115_globalize_node((((box_set__221_t) CREF(node_1813))->value), integrator_11);
			       {
				  obj_t res1981_2306;
				  {
				     obj_t x_2743;
				     x_2743 = ((((box_set__221_t) CREF(node_1813))->value) = ((node_t) arg1927_1818), BUNSPEC);
				     res1981_2306 = BUNSPEC;
				  }
				  res1981_2306;
			       }
			    }
			    aux_3012 = (obj_t) (node_1813);
			 }
			 break;
		      default:
		       case_else1743_25_1566:
			 if (PROCEDUREP(method1735_1562))
			   {
			      aux_3012 = PROCEDURE_ENTRY(method1735_1562) (method1735_1562, (obj_t) (node_10), (obj_t) (integrator_11), BEOA);
			   }
			 else
			   {
			      obj_t fun1502_1057;
			      fun1502_1057 = PROCEDURE_REF(glo__env_172_globalize_node, ((long) 0));
			      aux_3012 = PROCEDURE_ENTRY(fun1502_1057) (fun1502_1057, (obj_t) (node_10), (obj_t) (integrator_11), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1743_25_1566;
		 }
	    }
	    return (node_t) (aux_3012);
	 }
      }
   }
}


obj_t 
_glo__107_globalize_node(obj_t env_2699, obj_t node_2700, obj_t integrator_2701)
{
   {
      node_t aux_3563;
      aux_3563 = glo__115_globalize_node((node_t) (node_2700), (variable_t) (integrator_2701));
      return (obj_t) (aux_3563);
   }
}


obj_t 
glo___241_globalize_node(obj_t node__221_56, variable_t integrator_57)
{
   {
      obj_t node__221_1058;
      node__221_1058 = node__221_56;
    loop_1059:
      if (NULLP(node__221_1058))
	{
	   return CNST_TABLE_REF(((long) 3));
	}
      else
	{
	   {
	      node_t arg1505_1061;
	      {
		 node_t aux_3571;
		 {
		    obj_t aux_3572;
		    aux_3572 = CAR(node__221_1058);
		    aux_3571 = (node_t) (aux_3572);
		 }
		 arg1505_1061 = glo__115_globalize_node(aux_3571, integrator_57);
	      }
	      {
		 obj_t aux_3576;
		 aux_3576 = (obj_t) (arg1505_1061);
		 SET_CAR(node__221_1058, aux_3576);
	      }
	   }
	   {
	      obj_t node__221_3579;
	      node__221_3579 = CDR(node__221_1058);
	      node__221_1058 = node__221_3579;
	      goto loop_1059;
	   }
	}
   }
}


let_var_6_t 
make_escaping_bindings_69_globalize_node(obj_t ebindings_58, node_t node_59, variable_t integrator_60)
{
   {
      bool_t test1508_1064;
      {
	 obj_t aux_3581;
	 aux_3581 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 5)), BINT(((long) 2)));
	 test1508_1064 = CBOOL(aux_3581);
      }
      if (test1508_1064)
	{
	   obj_t arg1510_1066;
	   obj_t arg1513_1068;
	   arg1510_1066 = shape_tools_shape((obj_t) (node_59));
	   arg1513_1068 = shape_tools_shape(ebindings_58);
	   {
	      obj_t list1514_1069;
	      {
		 obj_t arg1517_1070;
		 {
		    obj_t arg1518_1071;
		    {
		       obj_t arg1520_1072;
		       {
			  obj_t arg1522_1073;
			  {
			     obj_t arg1523_1074;
			     {
				obj_t aux_3590;
				aux_3590 = BCHAR(((unsigned char) '\n'));
				arg1523_1074 = MAKE_PAIR(aux_3590, BNIL);
			     }
			     arg1522_1073 = MAKE_PAIR(arg1513_1068, arg1523_1074);
			  }
			  arg1520_1072 = MAKE_PAIR(string2003_globalize_node, arg1522_1073);
		       }
		       {
			  obj_t aux_3595;
			  aux_3595 = BCHAR(((unsigned char) '\n'));
			  arg1518_1071 = MAKE_PAIR(aux_3595, arg1520_1072);
		       }
		    }
		    arg1517_1070 = MAKE_PAIR(arg1510_1066, arg1518_1071);
		 }
		 list1514_1069 = MAKE_PAIR(string2004_globalize_node, arg1517_1070);
	      }
	      print_trace_107_tools_trace(list1514_1069);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t ebindings_1078;
      obj_t bindings_1079;
      obj_t sets_1080;
      ebindings_1078 = ebindings_58;
      bindings_1079 = BNIL;
      sets_1080 = BNIL;
    loop_1081:
      if (NULLP(ebindings_1078))
	{
	   obj_t arg1534_1085;
	   obj_t arg1535_1086;
	   arg1534_1085 = (((node_t) CREF(node_59))->loc);
	   if (NULLP(sets_1080))
	     {
		arg1535_1086 = (obj_t) (node_59);
	     }
	   else
	     {
		obj_t arg1537_1088;
		obj_t arg1538_1089;
		arg1537_1088 = (((node_t) CREF(node_59))->loc);
		{
		   obj_t arg1539_1090;
		   {
		      obj_t list1540_1091;
		      {
			 obj_t aux_3608;
			 aux_3608 = (obj_t) (node_59);
			 list1540_1091 = MAKE_PAIR(aux_3608, BNIL);
		      }
		      arg1539_1090 = list1540_1091;
		   }
		   arg1538_1089 = append_2_18___r4_pairs_and_lists_6_3(sets_1080, arg1539_1090);
		}
		{
		   sequence_t res1983_2331;
		   {
		      type_t type_2320;
		      type_2320 = (type_t) (_____74_type_cache);
		      {
			 sequence_t new1150_2323;
			 new1150_2323 = ((sequence_t) BREF(GC_MALLOC(sizeof(struct sequence))));
			 {
			    long arg1690_2324;
			    arg1690_2324 = class_num_218___object(sequence_ast_node);
			    {
			       obj_t obj_2329;
			       obj_2329 = (obj_t) (new1150_2323);
			       (((obj_t) CREF(obj_2329))->header = MAKE_HEADER(arg1690_2324, 0), BUNSPEC);
			    }
			 }
			 {
			    object_t aux_3617;
			    aux_3617 = (object_t) (new1150_2323);
			    OBJECT_WIDENING_SET(aux_3617, BFALSE);
			 }
			 ((((sequence_t) CREF(new1150_2323))->loc) = ((obj_t) arg1537_1088), BUNSPEC);
			 ((((sequence_t) CREF(new1150_2323))->type) = ((type_t) type_2320), BUNSPEC);
			 ((((sequence_t) CREF(new1150_2323))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			 ((((sequence_t) CREF(new1150_2323))->nodes) = ((obj_t) arg1538_1089), BUNSPEC);
			 res1983_2331 = new1150_2323;
		      }
		   }
		   arg1535_1086 = (obj_t) (res1983_2331);
		}
	     }
	   {
	      let_var_6_t res1984_2348;
	      {
		 type_t type_2333;
		 node_t body_2336;
		 type_2333 = (type_t) (_____74_type_cache);
		 body_2336 = (node_t) (arg1535_1086);
		 {
		    let_var_6_t new1234_2338;
		    new1234_2338 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
		    {
		       long arg1659_2339;
		       arg1659_2339 = class_num_218___object(let_var_6_ast_node);
		       {
			  obj_t obj_2346;
			  obj_2346 = (obj_t) (new1234_2338);
			  (((obj_t) CREF(obj_2346))->header = MAKE_HEADER(arg1659_2339, 0), BUNSPEC);
		       }
		    }
		    {
		       object_t aux_3631;
		       aux_3631 = (object_t) (new1234_2338);
		       OBJECT_WIDENING_SET(aux_3631, BFALSE);
		    }
		    ((((let_var_6_t) CREF(new1234_2338))->loc) = ((obj_t) arg1534_1085), BUNSPEC);
		    ((((let_var_6_t) CREF(new1234_2338))->type) = ((type_t) type_2333), BUNSPEC);
		    ((((let_var_6_t) CREF(new1234_2338))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		    ((((let_var_6_t) CREF(new1234_2338))->bindings) = ((obj_t) bindings_1079), BUNSPEC);
		    ((((let_var_6_t) CREF(new1234_2338))->body) = ((node_t) body_2336), BUNSPEC);
		    ((((let_var_6_t) CREF(new1234_2338))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		    res1984_2348 = new1234_2338;
		 }
	      }
	      return res1984_2348;
	   }
	}
      else
	{
	   obj_t local_1093;
	   local_1093 = CAR(ebindings_1078);
	   {
	      obj_t new_1094;
	      new_1094 = the_closure_238_globalize_free((variable_t) (local_1093), (((node_t) CREF(node_59))->loc));
	      {
		 obj_t nsets_1095;
		 {
		    obj_t aux_3644;
		    {
		       sfun_ginfo_98_t obj_2353;
		       {
			  value_t aux_3646;
			  {
			     local_t obj_2352;
			     obj_2352 = (local_t) (local_1093);
			     aux_3646 = (((local_t) CREF(obj_2352))->value);
			  }
			  obj_2353 = (sfun_ginfo_98_t) (aux_3646);
		       }
		       {
			  obj_t aux_3650;
			  {
			     object_t aux_3651;
			     aux_3651 = (object_t) (obj_2353);
			     aux_3650 = OBJECT_WIDENING(aux_3651);
			  }
			  aux_3644 = (((sfun_ginfo_98_t) CREF(aux_3650))->kaptured);
		       }
		    }
		    nsets_1095 = make_sets_85_globalize_node(new_1094, (((node_t) CREF(node_59))->loc), aux_3644, integrator_60);
		 }
		 {
		    {
		       obj_t arg1542_1096;
		       obj_t arg1543_1097;
		       obj_t arg1547_1098;
		       arg1542_1096 = CDR(ebindings_1078);
		       {
			  obj_t arg1549_1099;
			  {
			     app_t arg1550_1100;
			     arg1550_1100 = a_make_procedure_166_globalize_node((local_t) (local_1093));
			     {
				obj_t aux_3659;
				aux_3659 = (obj_t) (arg1550_1100);
				arg1549_1099 = MAKE_PAIR(new_1094, aux_3659);
			     }
			  }
			  arg1543_1097 = MAKE_PAIR(arg1549_1099, bindings_1079);
		       }
		       if (NULLP(nsets_1095))
			 {
			    arg1547_1098 = sets_1080;
			 }
		       else
			 {
			    arg1547_1098 = MAKE_PAIR(nsets_1095, sets_1080);
			 }
		       {
			  obj_t sets_3668;
			  obj_t bindings_3667;
			  obj_t ebindings_3666;
			  ebindings_3666 = arg1542_1096;
			  bindings_3667 = arg1543_1097;
			  sets_3668 = arg1547_1098;
			  sets_1080 = sets_3668;
			  bindings_1079 = bindings_3667;
			  ebindings_1078 = ebindings_3666;
			  goto loop_1081;
		       }
		    }
		 }
	      }
	   }
	}
   }
}


obj_t 
globalize_local_fun__50_globalize_node(local_t local_61, variable_t integrator_62)
{
   {
      value_t fun_1106;
      fun_1106 = (((local_t) CREF(local_61))->value);
      {
	 obj_t obody_1107;
	 {
	    sfun_t obj_2363;
	    obj_2363 = (sfun_t) (fun_1106);
	    obody_1107 = (((sfun_t) CREF(obj_2363))->body);
	 }
	 {
	    {
	       bool_t test_3672;
	       {
		  obj_t aux_3675;
		  obj_t aux_3673;
		  aux_3675 = (obj_t) (integrator_62);
		  aux_3673 = (obj_t) (local_61);
		  test_3672 = (aux_3673 == aux_3675);
	       }
	       if (test_3672)
		 {
		    node_t arg1557_1109;
		    arg1557_1109 = glo__115_globalize_node((node_t) (obody_1107), integrator_62);
		    {
		       obj_t res1985_2368;
		       {
			  sfun_t obj_2366;
			  obj_t val1082_2367;
			  obj_2366 = (sfun_t) (fun_1106);
			  val1082_2367 = (obj_t) (arg1557_1109);
			  {
			     obj_t x_2744;
			     x_2744 = ((((sfun_t) CREF(obj_2366))->body) = ((obj_t) val1082_2367), BUNSPEC);
			     res1985_2368 = BUNSPEC;
			  }
		       }
		       return res1985_2368;
		    }
		 }
	       else
		 {
		    obj_t celled_1110;
		    {
		       obj_t aux_3683;
		       {
			  sfun_t obj_2369;
			  obj_2369 = (sfun_t) (fun_1106);
			  aux_3683 = (((sfun_t) CREF(obj_2369))->args);
		       }
		       celled_1110 = celled_bindings_3_globalize_node(aux_3683);
		    }
		    {
		       obj_t l1409_1111;
		       l1409_1111 = celled_1110;
		     lname1410_1112:
		       if (PAIRP(l1409_1111))
			 {
			    {
			       obj_t w_b_127_1114;
			       w_b_127_1114 = CAR(l1409_1111);
			       {
				  obj_t arg1560_1116;
				  arg1560_1116 = CDR(w_b_127_1114);
				  {
				     obj_t res1986_2376;
				     {
					local_t obj_2374;
					{
					   obj_t aux_3691;
					   aux_3691 = CAR(w_b_127_1114);
					   obj_2374 = (local_t) (aux_3691);
					}
					{
					   obj_t x_2745;
					   x_2745 = ((((local_t) CREF(obj_2374))->fast_alpha_7) = ((obj_t) arg1560_1116), BUNSPEC);
					   res1986_2376 = BUNSPEC;
					}
				     }
				     res1986_2376;
				  }
			       }
			    }
			    {
			       obj_t l1409_3695;
			       l1409_3695 = CDR(l1409_1111);
			       l1409_1111 = l1409_3695;
			       goto lname1410_1112;
			    }
			 }
		       else
			 {
			    ((bool_t) 1);
			 }
		    }
		    {
		       node_t nbody1_1118;
		       nbody1_1118 = glo__115_globalize_node((node_t) (obody_1107), integrator_62);
		       {
			  obj_t nbody2_1119;
			  nbody2_1119 = cell_formals_12_globalize_node(celled_1110, nbody1_1118);
			  {
			     {
				obj_t l1411_1120;
				l1411_1120 = celled_1110;
			      lname1412_1121:
				if (PAIRP(l1411_1120))
				  {
				     {
					obj_t res1987_2383;
					{
					   local_t obj_2381;
					   {
					      obj_t aux_3702;
					      {
						 obj_t aux_3703;
						 aux_3703 = CAR(l1411_1120);
						 aux_3702 = CAR(aux_3703);
					      }
					      obj_2381 = (local_t) (aux_3702);
					   }
					   {
					      obj_t x_2746;
					      x_2746 = ((((local_t) CREF(obj_2381))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
					      res1987_2383 = BUNSPEC;
					   }
					}
					res1987_2383;
				     }
				     {
					obj_t l1411_3708;
					l1411_3708 = CDR(l1411_1120);
					l1411_1120 = l1411_3708;
					goto lname1412_1121;
				     }
				  }
				else
				  {
				     ((bool_t) 1);
				  }
			     }
			     {
				obj_t res1988_2387;
				{
				   sfun_t obj_2385;
				   obj_2385 = (sfun_t) (fun_1106);
				   {
				      obj_t x_2747;
				      x_2747 = ((((sfun_t) CREF(obj_2385))->body) = ((obj_t) nbody2_1119), BUNSPEC);
				      res1988_2387 = BUNSPEC;
				   }
				}
				return res1988_2387;
			     }
			  }
		       }
		    }
		 }
	    }
	 }
      }
   }
}


app_t 
a_make_procedure_166_globalize_node(local_t local_63)
{
   {
      value_t fun_1127;
      fun_1127 = (((local_t) CREF(local_63))->value);
      {
	 long arity_1128;
	 {
	    sfun_t obj_2389;
	    obj_2389 = (sfun_t) (fun_1127);
	    arity_1128 = (((sfun_t) CREF(obj_2389))->arity);
	 }
	 {
	    obj_t loc_1130;
	    {
	       node_t obj_2393;
	       {
		  obj_t aux_3715;
		  {
		     sfun_t obj_2392;
		     obj_2392 = (sfun_t) (fun_1127);
		     aux_3715 = (((sfun_t) CREF(obj_2392))->body);
		  }
		  obj_2393 = (node_t) (aux_3715);
	       }
	       loc_1130 = (((node_t) CREF(obj_2393))->loc);
	    }
	    {
	       obj_t make_p_144_1131;
	       if ((arity_1128 >= ((long) 0)))
		 {
		    make_p_144_1131 = CNST_TABLE_REF(((long) 6));
		 }
	       else
		 {
		    make_p_144_1131 = CNST_TABLE_REF(((long) 7));
		 }
	       {
		  {
		     var_t arg1566_1132;
		     obj_t arg1567_1133;
		     {
			obj_t arg1568_1134;
			{
			   obj_t list1571_1136;
			   {
			      obj_t aux_3724;
			      aux_3724 = CNST_TABLE_REF(((long) 8));
			      list1571_1136 = MAKE_PAIR(aux_3724, BNIL);
			   }
			   arg1568_1134 = find_global_223_ast_env(make_p_144_1131, list1571_1136);
			}
			{
			   var_t res1989_2406;
			   {
			      type_t type_2397;
			      variable_t variable_2398;
			      type_2397 = (type_t) (_____74_type_cache);
			      variable_2398 = (variable_t) (arg1568_1134);
			      {
				 var_t new1133_2399;
				 new1133_2399 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				 {
				    long arg1697_2400;
				    arg1697_2400 = class_num_218___object(var_ast_node);
				    {
				       obj_t obj_2404;
				       obj_2404 = (obj_t) (new1133_2399);
				       (((obj_t) CREF(obj_2404))->header = MAKE_HEADER(arg1697_2400, 0), BUNSPEC);
				    }
				 }
				 {
				    object_t aux_3734;
				    aux_3734 = (object_t) (new1133_2399);
				    OBJECT_WIDENING_SET(aux_3734, BFALSE);
				 }
				 ((((var_t) CREF(new1133_2399))->loc) = ((obj_t) loc_1130), BUNSPEC);
				 ((((var_t) CREF(new1133_2399))->type) = ((type_t) type_2397), BUNSPEC);
				 ((((var_t) CREF(new1133_2399))->variable) = ((variable_t) variable_2398), BUNSPEC);
				 res1989_2406 = new1133_2399;
			      }
			   }
			   arg1566_1132 = res1989_2406;
			}
		     }
		     {
			var_t arg1573_1138;
			atom_t arg1574_1139;
			atom_t arg1575_1140;
			{
			   global_t arg1582_1145;
			   arg1582_1145 = the_global_201_globalize_local__global_194(local_63);
			   {
			      var_t res1990_2417;
			      {
				 type_t type_2408;
				 variable_t variable_2409;
				 type_2408 = (type_t) (_____74_type_cache);
				 variable_2409 = (variable_t) (arg1582_1145);
				 {
				    var_t new1133_2410;
				    new1133_2410 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
				    {
				       long arg1697_2411;
				       arg1697_2411 = class_num_218___object(var_ast_node);
				       {
					  obj_t obj_2415;
					  obj_2415 = (obj_t) (new1133_2410);
					  (((obj_t) CREF(obj_2415))->header = MAKE_HEADER(arg1697_2411, 0), BUNSPEC);
				       }
				    }
				    {
				       object_t aux_3747;
				       aux_3747 = (object_t) (new1133_2410);
				       OBJECT_WIDENING_SET(aux_3747, BFALSE);
				    }
				    ((((var_t) CREF(new1133_2410))->loc) = ((obj_t) loc_1130), BUNSPEC);
				    ((((var_t) CREF(new1133_2410))->type) = ((type_t) type_2408), BUNSPEC);
				    ((((var_t) CREF(new1133_2410))->variable) = ((variable_t) variable_2409), BUNSPEC);
				    res1990_2417 = new1133_2410;
				 }
			      }
			      arg1573_1138 = res1990_2417;
			   }
			}
			{
			   atom_t res1991_2428;
			   {
			      type_t type_2419;
			      obj_t value_2420;
			      type_2419 = (type_t) (_____74_type_cache);
			      value_2420 = BINT(arity_1128);
			      {
				 atom_t new1127_2421;
				 new1127_2421 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
				 {
				    long arg1699_2422;
				    arg1699_2422 = class_num_218___object(atom_ast_node);
				    {
				       obj_t obj_2426;
				       obj_2426 = (obj_t) (new1127_2421);
				       (((obj_t) CREF(obj_2426))->header = MAKE_HEADER(arg1699_2422, 0), BUNSPEC);
				    }
				 }
				 {
				    object_t aux_3759;
				    aux_3759 = (object_t) (new1127_2421);
				    OBJECT_WIDENING_SET(aux_3759, BFALSE);
				 }
				 ((((atom_t) CREF(new1127_2421))->loc) = ((obj_t) loc_1130), BUNSPEC);
				 ((((atom_t) CREF(new1127_2421))->type) = ((type_t) type_2419), BUNSPEC);
				 ((((atom_t) CREF(new1127_2421))->value) = ((obj_t) value_2420), BUNSPEC);
				 res1991_2428 = new1127_2421;
			      }
			   }
			   arg1574_1139 = res1991_2428;
			}
			{
			   atom_t res1992_2439;
			   {
			      type_t type_2430;
			      obj_t value_2431;
			      type_2430 = (type_t) (_____74_type_cache);
			      {
				 long aux_3766;
				 {
				    obj_t aux_3767;
				    {
				       sfun_ginfo_98_t obj_2391;
				       {
					  value_t aux_3768;
					  aux_3768 = (((local_t) CREF(local_63))->value);
					  obj_2391 = (sfun_ginfo_98_t) (aux_3768);
				       }
				       {
					  obj_t aux_3771;
					  {
					     object_t aux_3772;
					     aux_3772 = (object_t) (obj_2391);
					     aux_3771 = OBJECT_WIDENING(aux_3772);
					  }
					  aux_3767 = (((sfun_ginfo_98_t) CREF(aux_3771))->kaptured);
				       }
				    }
				    aux_3766 = list_length(aux_3767);
				 }
				 value_2431 = BINT(aux_3766);
			      }
			      {
				 atom_t new1127_2432;
				 new1127_2432 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
				 {
				    long arg1699_2433;
				    arg1699_2433 = class_num_218___object(atom_ast_node);
				    {
				       obj_t obj_2437;
				       obj_2437 = (obj_t) (new1127_2432);
				       (((obj_t) CREF(obj_2437))->header = MAKE_HEADER(arg1699_2433, 0), BUNSPEC);
				    }
				 }
				 {
				    object_t aux_3782;
				    aux_3782 = (object_t) (new1127_2432);
				    OBJECT_WIDENING_SET(aux_3782, BFALSE);
				 }
				 ((((atom_t) CREF(new1127_2432))->loc) = ((obj_t) loc_1130), BUNSPEC);
				 ((((atom_t) CREF(new1127_2432))->type) = ((type_t) type_2430), BUNSPEC);
				 ((((atom_t) CREF(new1127_2432))->value) = ((obj_t) value_2431), BUNSPEC);
				 res1992_2439 = new1127_2432;
			      }
			   }
			   arg1575_1140 = res1992_2439;
			}
			{
			   obj_t list1576_1141;
			   {
			      obj_t arg1577_1142;
			      {
				 obj_t arg1578_1143;
				 {
				    obj_t aux_3788;
				    aux_3788 = (obj_t) (arg1575_1140);
				    arg1578_1143 = MAKE_PAIR(aux_3788, BNIL);
				 }
				 {
				    obj_t aux_3791;
				    aux_3791 = (obj_t) (arg1574_1139);
				    arg1577_1142 = MAKE_PAIR(aux_3791, arg1578_1143);
				 }
			      }
			      {
				 obj_t aux_3794;
				 aux_3794 = (obj_t) (arg1573_1138);
				 list1576_1141 = MAKE_PAIR(aux_3794, arg1577_1142);
			      }
			   }
			   arg1567_1133 = list1576_1141;
			}
		     }
		     {
			app_t res1993_2457;
			{
			   type_t type_2442;
			   type_2442 = (type_t) (_____74_type_cache);
			   {
			      app_t new1156_2447;
			      new1156_2447 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
			      {
				 long arg1688_2448;
				 arg1688_2448 = class_num_218___object(app_ast_node);
				 {
				    obj_t obj_2455;
				    obj_2455 = (obj_t) (new1156_2447);
				    (((obj_t) CREF(obj_2455))->header = MAKE_HEADER(arg1688_2448, 0), BUNSPEC);
				 }
			      }
			      {
				 object_t aux_3802;
				 aux_3802 = (object_t) (new1156_2447);
				 OBJECT_WIDENING_SET(aux_3802, BFALSE);
			      }
			      ((((app_t) CREF(new1156_2447))->loc) = ((obj_t) loc_1130), BUNSPEC);
			      ((((app_t) CREF(new1156_2447))->type) = ((type_t) type_2442), BUNSPEC);
			      ((((app_t) CREF(new1156_2447))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			      ((((app_t) CREF(new1156_2447))->fun) = ((var_t) arg1566_1132), BUNSPEC);
			      ((((app_t) CREF(new1156_2447))->args) = ((obj_t) arg1567_1133), BUNSPEC);
			      ((((app_t) CREF(new1156_2447))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
			      res1993_2457 = new1156_2447;
			   }
			}
			return res1993_2457;
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
make_sets_85_globalize_node(obj_t new_64, obj_t loc_65, obj_t kaptured_66, variable_t integrator_67)
{
   if (NULLP(kaptured_66))
     {
	return BNIL;
     }
   else
     {
	obj_t arg1589_1151;
	{
	   obj_t kaptured_1152;
	   long indice_1153;
	   obj_t sets_1154;
	   kaptured_1152 = kaptured_66;
	   indice_1153 = ((long) 0);
	   sets_1154 = BNIL;
	 loop_1155:
	   if (NULLP(kaptured_1152))
	     {
		arg1589_1151 = reverse__39___r4_pairs_and_lists_6_3(sets_1154);
	     }
	   else
	     {
		obj_t arg1593_1159;
		long arg1595_1160;
		obj_t arg1596_1161;
		arg1593_1159 = CDR(kaptured_1152);
		arg1595_1160 = (indice_1153 + ((long) 1));
		{
		   app_t arg1597_1162;
		   arg1597_1162 = a_procedure_set__174_globalize_node(loc_65, new_64, indice_1153, CAR(kaptured_1152), integrator_67);
		   {
		      obj_t aux_3820;
		      aux_3820 = (obj_t) (arg1597_1162);
		      arg1596_1161 = MAKE_PAIR(aux_3820, sets_1154);
		   }
		}
		{
		   obj_t sets_3825;
		   long indice_3824;
		   obj_t kaptured_3823;
		   kaptured_3823 = arg1593_1159;
		   indice_3824 = arg1595_1160;
		   sets_3825 = arg1596_1161;
		   sets_1154 = sets_3825;
		   indice_1153 = indice_3824;
		   kaptured_1152 = kaptured_3823;
		   goto loop_1155;
		}
	     }
	}
	{
	   sequence_t res1994_2478;
	   {
	      type_t type_2467;
	      type_2467 = (type_t) (_____74_type_cache);
	      {
		 sequence_t new1150_2470;
		 new1150_2470 = ((sequence_t) BREF(GC_MALLOC(sizeof(struct sequence))));
		 {
		    long arg1690_2471;
		    arg1690_2471 = class_num_218___object(sequence_ast_node);
		    {
		       obj_t obj_2476;
		       obj_2476 = (obj_t) (new1150_2470);
		       (((obj_t) CREF(obj_2476))->header = MAKE_HEADER(arg1690_2471, 0), BUNSPEC);
		    }
		 }
		 {
		    object_t aux_3831;
		    aux_3831 = (object_t) (new1150_2470);
		    OBJECT_WIDENING_SET(aux_3831, BFALSE);
		 }
		 ((((sequence_t) CREF(new1150_2470))->loc) = ((obj_t) loc_65), BUNSPEC);
		 ((((sequence_t) CREF(new1150_2470))->type) = ((type_t) type_2467), BUNSPEC);
		 ((((sequence_t) CREF(new1150_2470))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		 ((((sequence_t) CREF(new1150_2470))->nodes) = ((obj_t) arg1589_1151), BUNSPEC);
		 res1994_2478 = new1150_2470;
	      }
	   }
	   return (obj_t) (res1994_2478);
	}
     }
}


app_t 
a_procedure_set__174_globalize_node(obj_t loc_68, obj_t new_69, long indice_70, obj_t kaptured_71, variable_t integrator_72)
{
   {
      obj_t var_1180;
      {
	 var_t arg1601_1165;
	 obj_t arg1603_1166;
	 {
	    obj_t arg1604_1167;
	    {
	       obj_t arg1605_1168;
	       arg1605_1168 = CNST_TABLE_REF(((long) 9));
	       {
		  obj_t list1607_1170;
		  {
		     obj_t aux_3840;
		     aux_3840 = CNST_TABLE_REF(((long) 8));
		     list1607_1170 = MAKE_PAIR(aux_3840, BNIL);
		  }
		  arg1604_1167 = find_global_223_ast_env(arg1605_1168, list1607_1170);
	       }
	    }
	    {
	       var_t res1995_2489;
	       {
		  type_t type_2480;
		  variable_t variable_2481;
		  type_2480 = (type_t) (_____74_type_cache);
		  variable_2481 = (variable_t) (arg1604_1167);
		  {
		     var_t new1133_2482;
		     new1133_2482 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
		     {
			long arg1697_2483;
			arg1697_2483 = class_num_218___object(var_ast_node);
			{
			   obj_t obj_2487;
			   obj_2487 = (obj_t) (new1133_2482);
			   (((obj_t) CREF(obj_2487))->header = MAKE_HEADER(arg1697_2483, 0), BUNSPEC);
			}
		     }
		     {
			object_t aux_3850;
			aux_3850 = (object_t) (new1133_2482);
			OBJECT_WIDENING_SET(aux_3850, BFALSE);
		     }
		     ((((var_t) CREF(new1133_2482))->loc) = ((obj_t) loc_68), BUNSPEC);
		     ((((var_t) CREF(new1133_2482))->type) = ((type_t) type_2480), BUNSPEC);
		     ((((var_t) CREF(new1133_2482))->variable) = ((variable_t) variable_2481), BUNSPEC);
		     res1995_2489 = new1133_2482;
		  }
	       }
	       arg1601_1165 = res1995_2489;
	    }
	 }
	 {
	    var_t arg1609_1172;
	    atom_t arg1611_1173;
	    var_t arg1614_1174;
	    {
	       var_t res1996_2500;
	       {
		  type_t type_2491;
		  variable_t variable_2492;
		  type_2491 = (type_t) (_____74_type_cache);
		  variable_2492 = (variable_t) (new_69);
		  {
		     var_t new1133_2493;
		     new1133_2493 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
		     {
			long arg1697_2494;
			arg1697_2494 = class_num_218___object(var_ast_node);
			{
			   obj_t obj_2498;
			   obj_2498 = (obj_t) (new1133_2493);
			   (((obj_t) CREF(obj_2498))->header = MAKE_HEADER(arg1697_2494, 0), BUNSPEC);
			}
		     }
		     {
			object_t aux_3862;
			aux_3862 = (object_t) (new1133_2493);
			OBJECT_WIDENING_SET(aux_3862, BFALSE);
		     }
		     ((((var_t) CREF(new1133_2493))->loc) = ((obj_t) loc_68), BUNSPEC);
		     ((((var_t) CREF(new1133_2493))->type) = ((type_t) type_2491), BUNSPEC);
		     ((((var_t) CREF(new1133_2493))->variable) = ((variable_t) variable_2492), BUNSPEC);
		     res1996_2500 = new1133_2493;
		  }
	       }
	       arg1609_1172 = res1996_2500;
	    }
	    {
	       atom_t res1997_2511;
	       {
		  type_t type_2502;
		  obj_t value_2503;
		  type_2502 = (type_t) (_____74_type_cache);
		  value_2503 = BINT(indice_70);
		  {
		     atom_t new1127_2504;
		     new1127_2504 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
		     {
			long arg1699_2505;
			arg1699_2505 = class_num_218___object(atom_ast_node);
			{
			   obj_t obj_2509;
			   obj_2509 = (obj_t) (new1127_2504);
			   (((obj_t) CREF(obj_2509))->header = MAKE_HEADER(arg1699_2505, 0), BUNSPEC);
			}
		     }
		     {
			object_t aux_3874;
			aux_3874 = (object_t) (new1127_2504);
			OBJECT_WIDENING_SET(aux_3874, BFALSE);
		     }
		     ((((atom_t) CREF(new1127_2504))->loc) = ((obj_t) loc_68), BUNSPEC);
		     ((((atom_t) CREF(new1127_2504))->type) = ((type_t) type_2502), BUNSPEC);
		     ((((atom_t) CREF(new1127_2504))->value) = ((obj_t) value_2503), BUNSPEC);
		     res1997_2511 = new1127_2504;
		  }
	       }
	       arg1611_1173 = res1997_2511;
	    }
	    {
	       var_t res1998_2522;
	       {
		  type_t type_2513;
		  variable_t variable_2514;
		  type_2513 = (type_t) (_____74_type_cache);
		  {
		     obj_t aux_3881;
		     var_1180 = kaptured_71;
		   alpha_convert_60_1184:
		     {
			obj_t alpha_1182;
			{
			   variable_t obj_2541;
			   obj_2541 = (variable_t) (var_1180);
			   alpha_1182 = (((variable_t) CREF(obj_2541))->fast_alpha_7);
			}
			{
			   bool_t test1621_1183;
			   test1621_1183 = is_a__118___object(alpha_1182, local_ast_var);
			   if (test1621_1183)
			     {
				obj_t var_3886;
				var_3886 = alpha_1182;
				var_1180 = var_3886;
				goto alpha_convert_60_1184;
			     }
			   else
			     {
				aux_3881 = var_1180;
			     }
			}
		     }
		     variable_2514 = (variable_t) (aux_3881);
		  }
		  {
		     var_t new1133_2515;
		     new1133_2515 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
		     {
			long arg1697_2516;
			arg1697_2516 = class_num_218___object(var_ast_node);
			{
			   obj_t obj_2520;
			   obj_2520 = (obj_t) (new1133_2515);
			   (((obj_t) CREF(obj_2520))->header = MAKE_HEADER(arg1697_2516, 0), BUNSPEC);
			}
		     }
		     {
			object_t aux_3892;
			aux_3892 = (object_t) (new1133_2515);
			OBJECT_WIDENING_SET(aux_3892, BFALSE);
		     }
		     ((((var_t) CREF(new1133_2515))->loc) = ((obj_t) loc_68), BUNSPEC);
		     ((((var_t) CREF(new1133_2515))->type) = ((type_t) type_2513), BUNSPEC);
		     ((((var_t) CREF(new1133_2515))->variable) = ((variable_t) variable_2514), BUNSPEC);
		     res1998_2522 = new1133_2515;
		  }
	       }
	       arg1614_1174 = res1998_2522;
	    }
	    {
	       obj_t list1615_1175;
	       {
		  obj_t arg1616_1176;
		  {
		     obj_t arg1617_1177;
		     {
			obj_t aux_3898;
			aux_3898 = (obj_t) (arg1614_1174);
			arg1617_1177 = MAKE_PAIR(aux_3898, BNIL);
		     }
		     {
			obj_t aux_3901;
			aux_3901 = (obj_t) (arg1611_1173);
			arg1616_1176 = MAKE_PAIR(aux_3901, arg1617_1177);
		     }
		  }
		  {
		     obj_t aux_3904;
		     aux_3904 = (obj_t) (arg1609_1172);
		     list1615_1175 = MAKE_PAIR(aux_3904, arg1616_1176);
		  }
	       }
	       arg1603_1166 = list1615_1175;
	    }
	 }
	 {
	    app_t res1999_2540;
	    {
	       type_t type_2525;
	       type_2525 = (type_t) (_____74_type_cache);
	       {
		  app_t new1156_2530;
		  new1156_2530 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
		  {
		     long arg1688_2531;
		     arg1688_2531 = class_num_218___object(app_ast_node);
		     {
			obj_t obj_2538;
			obj_2538 = (obj_t) (new1156_2530);
			(((obj_t) CREF(obj_2538))->header = MAKE_HEADER(arg1688_2531, 0), BUNSPEC);
		     }
		  }
		  {
		     object_t aux_3912;
		     aux_3912 = (object_t) (new1156_2530);
		     OBJECT_WIDENING_SET(aux_3912, BFALSE);
		  }
		  ((((app_t) CREF(new1156_2530))->loc) = ((obj_t) loc_68), BUNSPEC);
		  ((((app_t) CREF(new1156_2530))->type) = ((type_t) type_2525), BUNSPEC);
		  ((((app_t) CREF(new1156_2530))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		  ((((app_t) CREF(new1156_2530))->fun) = ((var_t) arg1601_1165), BUNSPEC);
		  ((((app_t) CREF(new1156_2530))->args) = ((obj_t) arg1603_1166), BUNSPEC);
		  ((((app_t) CREF(new1156_2530))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
		  res1999_2540 = new1156_2530;
	       }
	    }
	    return res1999_2540;
	 }
      }
   }
}


obj_t 
imported_modules_init_94_globalize_node()
{
   module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_NODE");
   module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_NODE");
   module_initialization_70_type_type(((long) 0), "GLOBALIZE_NODE");
   module_initialization_70_type_cache(((long) 0), "GLOBALIZE_NODE");
   module_initialization_70_ast_var(((long) 0), "GLOBALIZE_NODE");
   module_initialization_70_ast_node(((long) 0), "GLOBALIZE_NODE");
   module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_NODE");
   module_initialization_70_ast_sexp(((long) 0), "GLOBALIZE_NODE");
   module_initialization_70_ast_env(((long) 0), "GLOBALIZE_NODE");
   module_initialization_70_ast_local(((long) 0), "GLOBALIZE_NODE");
   module_initialization_70_globalize_free(((long) 0), "GLOBALIZE_NODE");
   return module_initialization_70_globalize_local__global_194(((long) 0), "GLOBALIZE_NODE");
}
