/*===========================================================================*/
/*   (Globalize/walk.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t escape_fun__53_globalize_escape(variable_t);
extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t globalize__167_globalize_globalize(global_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
extern obj_t _globalize_walk__137_globalize_walk(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_globalize_walk();
extern obj_t module_initialization_70_globalize_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_globalize_escape(long, char *);
extern obj_t module_initialization_70_globalize_globalize(long, char *);
extern obj_t module_initialization_70_globalize_global_closure_246(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t cnst_init_137_globalize_walk();
static obj_t require_initialization_114_globalize_walk = BUNSPEC;
static obj_t library_modules_init_112_globalize_walk();
extern obj_t foreign_closures_19_globalize_global_closure_246();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t current_error_port;
extern obj_t globalize_walk__63_globalize_walk(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t __current_pass__25_engine_pass;
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
static obj_t __cnst[1];

DEFINE_STRING(string1479_globalize_walk, string1479_globalize_walk1488, "failure during postlude hook", 28);
DEFINE_STRING(string1478_globalize_walk, string1478_globalize_walk1489, " error", 6);
DEFINE_STRING(string1480_globalize_walk, string1480_globalize_walk1490, "PASS-STARTED ", 13);
DEFINE_STRING(string1475_globalize_walk, string1475_globalize_walk1491, "   . ", 5);
DEFINE_STRING(string1476_globalize_walk, string1476_globalize_walk1492, "failure during prelude hook", 27);
DEFINE_STRING(string1474_globalize_walk, string1474_globalize_walk1493, "Globalization", 13);
DEFINE_STRING(string1477_globalize_walk, string1477_globalize_walk1494, " occured, ending ...", 20);
DEFINE_EXPORT_PROCEDURE(globalize_walk__env_111_globalize_walk, _globalize_walk__137_globalize_walk1495, _globalize_walk__137_globalize_walk, 0L, 2);

obj_t 
module_initialization_70_globalize_walk(long checksum_1038, char *from_1039)
{
   if (CBOOL(require_initialization_114_globalize_walk))
     {
	require_initialization_114_globalize_walk = BBOOL(((bool_t) 0));
	library_modules_init_112_globalize_walk();
	cnst_init_137_globalize_walk();
	imported_modules_init_94_globalize_walk();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_globalize_walk()
{
   module_initialization_70___r4_output_6_10_3(((long) 0), "GLOBALIZE_WALK");
   module_initialization_70___reader(((long) 0), "GLOBALIZE_WALK");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_WALK");
   module_initialization_70___r4_numbers_6_5(((long) 0), "GLOBALIZE_WALK");
   return BUNSPEC;
}


obj_t 
cnst_init_137_globalize_walk()
{
   {
      obj_t cnst_port_138_1030;
      cnst_port_138_1030 = open_input_string(string1480_globalize_walk);
      {
	 long i_1031;
	 i_1031 = ((long) 0);
       loop_1032:
	 {
	    bool_t test1481_1033;
	    test1481_1033 = (i_1031 == ((long) -1));
	    if (test1481_1033)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1484_1034;
		    {
		       obj_t list1485_1035;
		       {
			  obj_t arg1486_1036;
			  arg1486_1036 = BNIL;
			  list1485_1035 = MAKE_PAIR(cnst_port_138_1030, arg1486_1036);
		       }
		       arg1484_1034 = read___reader(list1485_1035);
		    }
		    CNST_TABLE_SET(i_1031, arg1484_1034);
		 }
		 {
		    int aux_1037;
		    {
		       long aux_1056;
		       aux_1056 = (i_1031 - ((long) 1));
		       aux_1037 = (int) (aux_1056);
		    }
		    {
		       long i_1059;
		       i_1059 = (long) (aux_1037);
		       i_1031 = i_1059;
		       goto loop_1032;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
globalize_walk__63_globalize_walk(obj_t globals_1, obj_t remove_2)
{
   {
      obj_t list1284_632;
      {
	 obj_t arg1287_634;
	 {
	    obj_t arg1293_636;
	    {
	       obj_t aux_1061;
	       aux_1061 = BCHAR(((unsigned char) '\n'));
	       arg1293_636 = MAKE_PAIR(aux_1061, BNIL);
	    }
	    arg1287_634 = MAKE_PAIR(string1474_globalize_walk, arg1293_636);
	 }
	 list1284_632 = MAKE_PAIR(string1475_globalize_walk, arg1287_634);
      }
      verbose_tools_speek(BINT(((long) 1)), list1284_632);
   }
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   __current_pass__25_engine_pass = string1474_globalize_walk;
   {
      obj_t hooks_638;
      obj_t hnames_639;
      hooks_638 = BNIL;
      hnames_639 = BNIL;
    loop_640:
      if (NULLP(hooks_638))
	{
	   CNST_TABLE_REF(((long) 0));
	}
      else
	{
	   bool_t test1300_645;
	   {
	      obj_t fun1312_651;
	      fun1312_651 = CAR(hooks_638);
	      {
		 obj_t aux_1073;
		 aux_1073 = PROCEDURE_ENTRY(fun1312_651) (fun1312_651, BEOA);
		 test1300_645 = CBOOL(aux_1073);
	      }
	   }
	   if (test1300_645)
	     {
		{
		   obj_t hnames_1080;
		   obj_t hooks_1078;
		   hooks_1078 = CDR(hooks_638);
		   hnames_1080 = CDR(hnames_639);
		   hnames_639 = hnames_1080;
		   hooks_638 = hooks_1078;
		   goto loop_640;
		}
	     }
	   else
	     {
		internal_error_43_tools_error(string1474_globalize_walk, string1476_globalize_walk, CAR(hnames_639));
	     }
	}
   }
   {
      obj_t l1272_652;
      l1272_652 = globals_1;
    lname1283_653:
      if (PAIRP(l1272_652))
	{
	   {
	      variable_t aux_1086;
	      {
		 obj_t aux_1087;
		 aux_1087 = CAR(l1272_652);
		 aux_1086 = (variable_t) (aux_1087);
	      }
	      escape_fun__53_globalize_escape(aux_1086);
	   }
	   {
	      obj_t l1272_1091;
	      l1272_1091 = CDR(l1272_652);
	      l1272_652 = l1272_1091;
	      goto lname1283_653;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      obj_t globals_657;
      obj_t new_globals_42_658;
      globals_657 = globals_1;
      new_globals_42_658 = BNIL;
    loop_659:
      if (NULLP(globals_657))
	{
	   obj_t value_662;
	   {
	      obj_t arg1345_688;
	      {
		 obj_t arg1346_689;
		 arg1346_689 = foreign_closures_19_globalize_global_closure_246();
		 arg1345_688 = append_2_18___r4_pairs_and_lists_6_3(new_globals_42_658, arg1346_689);
	      }
	      value_662 = remove_var_123_ast_remove(remove_2, arg1345_688);
	   }
	   {
	      bool_t test1318_663;
	      {
		 long n1_1014;
		 n1_1014 = (long) CINT(__nb_error_on_pass__70_tools_error);
		 test1318_663 = (n1_1014 > ((long) 0));
	      }
	      if (test1318_663)
		{
		   {
		      char *arg1321_666;
		      {
			 bool_t test1330_673;
			 {
			    bool_t test1331_674;
			    {
			       obj_t obj_1016;
			       obj_1016 = __nb_error_on_pass__70_tools_error;
			       test1331_674 = INTEGERP(obj_1016);
			    }
			    if (test1331_674)
			      {
				 test1330_673 = _2__206___r4_numbers_6_5(__nb_error_on_pass__70_tools_error, BINT(((long) 1)));
			      }
			    else
			      {
				 test1330_673 = ((bool_t) 0);
			      }
			 }
			 if (test1330_673)
			   {
			      arg1321_666 = "s";
			   }
			 else
			   {
			      arg1321_666 = "";
			   }
		      }
		      {
			 obj_t list1323_668;
			 {
			    obj_t arg1325_669;
			    {
			       obj_t arg1327_670;
			       {
				  obj_t arg1328_671;
				  arg1328_671 = MAKE_PAIR(string1477_globalize_walk, BNIL);
				  {
				     obj_t aux_1107;
				     aux_1107 = string_to_bstring(arg1321_666);
				     arg1327_670 = MAKE_PAIR(aux_1107, arg1328_671);
				  }
			       }
			       arg1325_669 = MAKE_PAIR(string1478_globalize_walk, arg1327_670);
			    }
			    list1323_668 = MAKE_PAIR(__nb_error_on_pass__70_tools_error, arg1325_669);
			 }
			 fprint___r4_output_6_10_3(current_error_port, list1323_668);
		      }
		   }
		   {
		      obj_t res1473_1018;
		      exit(((long) -1));
		      res1473_1018 = BINT(((long) -1));
		      return res1473_1018;
		   }
		}
	      else
		{
		   obj_t hooks_675;
		   obj_t hnames_676;
		   hooks_675 = BNIL;
		   hnames_676 = BNIL;
		 loop_677:
		   if (NULLP(hooks_675))
		     {
			return value_662;
		     }
		   else
		     {
			bool_t test1336_682;
			{
			   obj_t fun1343_687;
			   fun1343_687 = CAR(hooks_675);
			   {
			      obj_t aux_1118;
			      aux_1118 = PROCEDURE_ENTRY(fun1343_687) (fun1343_687, BEOA);
			      test1336_682 = CBOOL(aux_1118);
			   }
			}
			if (test1336_682)
			  {
			     {
				obj_t hnames_1125;
				obj_t hooks_1123;
				hooks_1123 = CDR(hooks_675);
				hnames_1125 = CDR(hnames_676);
				hnames_676 = hnames_1125;
				hooks_675 = hooks_1123;
				goto loop_677;
			     }
			  }
			else
			  {
			     return internal_error_43_tools_error(__current_pass__25_engine_pass, string1479_globalize_walk, CAR(hnames_676));
			  }
		     }
		}
	   }
	}
      else
	{
	   obj_t arg1347_690;
	   obj_t arg1349_691;
	   arg1347_690 = CDR(globals_657);
	   {
	      obj_t arg1350_692;
	      {
		 global_t aux_1130;
		 {
		    obj_t aux_1131;
		    aux_1131 = CAR(globals_657);
		    aux_1130 = (global_t) (aux_1131);
		 }
		 arg1350_692 = globalize__167_globalize_globalize(aux_1130);
	      }
	      arg1349_691 = append_2_18___r4_pairs_and_lists_6_3(arg1350_692, new_globals_42_658);
	   }
	   {
	      obj_t new_globals_42_1137;
	      obj_t globals_1136;
	      globals_1136 = arg1347_690;
	      new_globals_42_1137 = arg1349_691;
	      new_globals_42_658 = new_globals_42_1137;
	      globals_657 = globals_1136;
	      goto loop_659;
	   }
	}
   }
}


obj_t 
_globalize_walk__137_globalize_walk(obj_t env_1027, obj_t globals_1028, obj_t remove_1029)
{
   return globalize_walk__63_globalize_walk(globals_1028, remove_1029);
}


obj_t 
imported_modules_init_94_globalize_walk()
{
   module_initialization_70_tools_speek(((long) 0), "GLOBALIZE_WALK");
   module_initialization_70_tools_error(((long) 0), "GLOBALIZE_WALK");
   module_initialization_70_engine_pass(((long) 0), "GLOBALIZE_WALK");
   module_initialization_70_type_type(((long) 0), "GLOBALIZE_WALK");
   module_initialization_70_ast_var(((long) 0), "GLOBALIZE_WALK");
   module_initialization_70_ast_node(((long) 0), "GLOBALIZE_WALK");
   module_initialization_70_globalize_escape(((long) 0), "GLOBALIZE_WALK");
   module_initialization_70_globalize_globalize(((long) 0), "GLOBALIZE_WALK");
   module_initialization_70_globalize_global_closure_246(((long) 0), "GLOBALIZE_WALK");
   return module_initialization_70_ast_remove(((long) 0), "GLOBALIZE_WALK");
}
