/*===========================================================================*/
/*   (Heap/make.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t make_heap_12_heap_make();
static obj_t _prepare_globals__42_heap_make(obj_t);
static obj_t imported_modules_init_94_heap_make();
extern obj_t module_initialization_70_heap_make(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70___os(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t cnst_init_137_heap_make();
extern obj_t __heap_name__135_engine_param;
extern obj_t _make_heap_207_heap_make(obj_t);
static bool_t prepare_globals__191_heap_make();
extern obj_t close_binary_port(obj_t);
extern obj_t make_file_name_203___os(obj_t, obj_t);
extern obj_t get_genv_41_ast_env();
static obj_t require_initialization_114_heap_make = BUNSPEC;
static obj_t library_modules_init_112_heap_make();
extern obj_t open_output_binary_file(obj_t);
extern obj_t get_tenv_245_type_env();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t arg12071262_heap_make(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t unbind_global__45_ast_env(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t output_obj(obj_t, obj_t);
extern obj_t for_each_global__88_ast_env(obj_t);
extern obj_t __current_pass__25_engine_pass;
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t __lib_dir__34_engine_param;
static obj_t __cnst[5];

DEFINE_STATIC_PROCEDURE(proc1269_heap_make, arg12071262_heap_make1277, arg12071262_heap_make, 0L, 1);
DEFINE_STRING(string1270_heap_make, string1270_heap_make1278, "IMPORT EXPORT STATIC (PREPARE-GLOBALS!) PASS-STARTED ", 53);
DEFINE_STRING(string1268_heap_make, string1268_heap_make1279, "Illegal heap's name", 19);
DEFINE_STATIC_PROCEDURE(prepare_globals__env_2_heap_make, _prepare_globals__42_heap_make1280, _prepare_globals__42_heap_make, 0L, 0);
DEFINE_STRING(string1264_heap_make, string1264_heap_make1281, "   . ", 5);
DEFINE_STRING(string1265_heap_make, string1265_heap_make1282, "failure during prelude hook", 27);
DEFINE_STRING(string1266_heap_make, string1266_heap_make1283, "make-heap", 9);
DEFINE_STRING(string1267_heap_make, string1267_heap_make1284, "Can't open output port", 22);
DEFINE_STRING(string1263_heap_make, string1263_heap_make1285, "Heap", 4);
DEFINE_EXPORT_PROCEDURE(make_heap_env_74_heap_make, _make_heap_207_heap_make1286, _make_heap_207_heap_make, 0L, 0);

obj_t 
module_initialization_70_heap_make(long checksum_489, char *from_490)
{
   if (CBOOL(require_initialization_114_heap_make))
     {
	require_initialization_114_heap_make = BBOOL(((bool_t) 0));
	library_modules_init_112_heap_make();
	cnst_init_137_heap_make();
	imported_modules_init_94_heap_make();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_heap_make()
{
   module_initialization_70___os(((long) 0), "HEAP_MAKE");
   module_initialization_70___reader(((long) 0), "HEAP_MAKE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_heap_make()
{
   {
      obj_t cnst_port_138_481;
      cnst_port_138_481 = open_input_string(string1270_heap_make);
      {
	 long i_482;
	 i_482 = ((long) 4);
       loop_483:
	 {
	    bool_t test1271_484;
	    test1271_484 = (i_482 == ((long) -1));
	    if (test1271_484)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1272_485;
		    {
		       obj_t list1273_486;
		       {
			  obj_t arg1275_487;
			  arg1275_487 = BNIL;
			  list1273_486 = MAKE_PAIR(cnst_port_138_481, arg1275_487);
		       }
		       arg1272_485 = read___reader(list1273_486);
		    }
		    CNST_TABLE_SET(i_482, arg1272_485);
		 }
		 {
		    int aux_488;
		    {
		       long aux_505;
		       aux_505 = (i_482 - ((long) 1));
		       aux_488 = (int) (aux_505);
		    }
		    {
		       long i_508;
		       i_508 = (long) (aux_488);
		       i_482 = i_508;
		       goto loop_483;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
make_heap_12_heap_make()
{
   {
      obj_t list1110_279;
      {
	 obj_t arg1145_281;
	 {
	    obj_t arg1149_283;
	    {
	       obj_t aux_510;
	       aux_510 = BCHAR(((unsigned char) '\n'));
	       arg1149_283 = MAKE_PAIR(aux_510, BNIL);
	    }
	    arg1145_281 = MAKE_PAIR(string1263_heap_make, arg1149_283);
	 }
	 list1110_279 = MAKE_PAIR(string1264_heap_make, arg1145_281);
      }
      verbose_tools_speek(BINT(((long) 1)), list1110_279);
   }
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   __current_pass__25_engine_pass = string1263_heap_make;
   {
      obj_t hooks_285;
      obj_t hnames_286;
      {
	 obj_t arg1154_288;
	 obj_t arg1161_289;
	 {
	    obj_t list1162_290;
	    list1162_290 = MAKE_PAIR(prepare_globals__env_2_heap_make, BNIL);
	    arg1154_288 = list1162_290;
	 }
	 arg1161_289 = CNST_TABLE_REF(((long) 1));
	 hooks_285 = arg1154_288;
	 hnames_286 = arg1161_289;
       loop_287:
	 if (NULLP(hooks_285))
	   {
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {
	      bool_t test1167_293;
	      {
		 obj_t fun1200_299;
		 fun1200_299 = CAR(hooks_285);
		 {
		    obj_t aux_524;
		    aux_524 = PROCEDURE_ENTRY(fun1200_299) (fun1200_299, BEOA);
		    test1167_293 = CBOOL(aux_524);
		 }
	      }
	      if (test1167_293)
		{
		   {
		      obj_t hnames_531;
		      obj_t hooks_529;
		      hooks_529 = CDR(hooks_285);
		      hnames_531 = CDR(hnames_286);
		      hnames_286 = hnames_531;
		      hooks_285 = hooks_529;
		      goto loop_287;
		   }
		}
	      else
		{
		   internal_error_43_tools_error(string1263_heap_make, string1265_heap_make, CAR(hnames_286));
		}
	   }
      }
   }
   {
      bool_t test1201_300;
      {
	 obj_t obj_449;
	 obj_449 = __heap_name__135_engine_param;
	 test1201_300 = STRINGP(obj_449);
      }
      if (test1201_300)
	{
	   obj_t hname_301;
	   hname_301 = make_file_name_203___os(__lib_dir__34_engine_param, __heap_name__135_engine_param);
	   {
	      obj_t port_302;
	      port_302 = open_output_binary_file(hname_301);
	      if (BINARY_PORTP(port_302))
		{
		   {
		      obj_t arg1203_304;
		      {
			 obj_t arg1204_305;
			 obj_t arg1205_306;
			 arg1204_305 = get_genv_41_ast_env();
			 arg1205_306 = get_tenv_245_type_env();
			 arg1203_304 = MAKE_PAIR(arg1204_305, arg1205_306);
		      }
		      output_obj(port_302, arg1203_304);
		   }
		   return close_binary_port(port_302);
		}
	      else
		{
		   FAILURE(string1266_heap_make, string1267_heap_make, hname_301);
		}
	   }
	}
      else
	{
	   return user_error_151_tools_error(string1266_heap_make, string1268_heap_make, __heap_name__135_engine_param, BNIL);
	}
   }
}


obj_t 
_make_heap_207_heap_make(obj_t env_474)
{
   return make_heap_12_heap_make();
}


bool_t 
prepare_globals__191_heap_make()
{
   {
      obj_t arg1207_476;
      arg1207_476 = proc1269_heap_make;
      for_each_global__88_ast_env(arg1207_476);
   }
   return ((bool_t) 1);
}


obj_t 
_prepare_globals__42_heap_make(obj_t env_475)
{
   {
      bool_t aux_550;
      aux_550 = prepare_globals__191_heap_make();
      return BBOOL(aux_550);
   }
}


obj_t 
arg12071262_heap_make(obj_t env_477, obj_t g_478)
{
   {
      obj_t g_309;
      g_309 = g_478;
      {
	 bool_t test_553;
	 {
	    obj_t aux_557;
	    obj_t aux_554;
	    aux_557 = CNST_TABLE_REF(((long) 2));
	    {
	       global_t obj_460;
	       obj_460 = (global_t) (g_309);
	       aux_554 = (((global_t) CREF(obj_460))->import);
	    }
	    test_553 = (aux_554 == aux_557);
	 }
	 if (test_553)
	   {
	      {
		 obj_t aux_563;
		 obj_t aux_560;
		 {
		    global_t obj_464;
		    obj_464 = (global_t) (g_309);
		    aux_563 = (((global_t) CREF(obj_464))->module);
		 }
		 {
		    global_t obj_463;
		    obj_463 = (global_t) (g_309);
		    aux_560 = (((global_t) CREF(obj_463))->id);
		 }
		 unbind_global__45_ast_env(aux_560, aux_563);
	      }
	   }
	 else
	   {
	      bool_t test_567;
	      {
		 obj_t aux_571;
		 obj_t aux_568;
		 aux_571 = CNST_TABLE_REF(((long) 3));
		 {
		    global_t obj_465;
		    obj_465 = (global_t) (g_309);
		    aux_568 = (((global_t) CREF(obj_465))->import);
		 }
		 test_567 = (aux_568 == aux_571);
	      }
	      if (test_567)
		{
		   {
		      obj_t arg1214_315;
		      arg1214_315 = CNST_TABLE_REF(((long) 4));
		      {
			 obj_t res1260_470;
			 {
			    global_t obj_468;
			    obj_468 = (global_t) (g_309);
			    {
			       obj_t x_479;
			       x_479 = ((((global_t) CREF(obj_468))->import) = ((obj_t) arg1214_315), BUNSPEC);
			       res1260_470 = BUNSPEC;
			    }
			 }
			 res1260_470;
		      }
		   }
		}
	      else
		{
		   BUNSPEC;
		}
	   }
      }
      {
	 obj_t res1261_473;
	 {
	    global_t obj_471;
	    obj_471 = (global_t) (g_309);
	    {
	       obj_t x_480;
	       x_480 = ((((global_t) CREF(obj_471))->occurrence) = ((long) ((long) 0)), BUNSPEC);
	       res1261_473 = BUNSPEC;
	    }
	 }
	 return res1261_473;
      }
   }
}


obj_t 
imported_modules_init_94_heap_make()
{
   module_initialization_70_tools_speek(((long) 0), "HEAP_MAKE");
   module_initialization_70_tools_error(((long) 0), "HEAP_MAKE");
   module_initialization_70_engine_pass(((long) 0), "HEAP_MAKE");
   module_initialization_70_engine_param(((long) 0), "HEAP_MAKE");
   module_initialization_70_type_type(((long) 0), "HEAP_MAKE");
   module_initialization_70_type_env(((long) 0), "HEAP_MAKE");
   module_initialization_70_ast_var(((long) 0), "HEAP_MAKE");
   return module_initialization_70_ast_env(((long) 0), "HEAP_MAKE");
}
