/*===========================================================================*/
/*   (Heap/restore.scm)                                                      */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t open_input_binary_file(obj_t);
extern obj_t exit_bigloo_229_init_main(obj_t);
extern obj_t restore_heap_59_heap_restore();
extern obj_t notify_error_43___error(obj_t, obj_t, obj_t);
extern obj_t exitd_top;
static obj_t imported_modules_init_94_heap_restore();
extern obj_t module_initialization_70_heap_restore(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_engine_engine(long, char *);
extern obj_t module_initialization_70_init_main(long, char *);
extern obj_t module_initialization_70_tools_file(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t arg12031269_heap_restore(obj_t, obj_t);
static obj_t cnst_init_137_heap_restore();
extern obj_t __heap_name__135_engine_param;
extern obj_t close_binary_port(obj_t);
extern obj_t find_file_path_55_tools_file(obj_t, obj_t);
static obj_t handling_function1201_209_heap_restore(obj_t, obj_t, obj_t);
extern obj_t add_error_handler__155___error(obj_t, obj_t);
extern obj_t remove_error_handler__102___error();
static obj_t require_initialization_114_heap_restore = BUNSPEC;
static obj_t library_modules_init_112_heap_restore();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t val_from_exit__100___bexit(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t input_obj(obj_t);
extern obj_t __call_cc___102_engine_param;
extern obj_t unbind_global__45_ast_env(obj_t, obj_t);
extern obj_t set_tenv__70_type_env(obj_t);
extern obj_t _restore_heap_238_heap_restore(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t handler1270_heap_restore(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t set_genv__34_ast_env(obj_t);
extern obj_t unwind_until__178___bexit(obj_t, obj_t);
static obj_t unbind_call_cc__206_heap_restore();
extern obj_t __current_pass__25_engine_pass;
extern obj_t __lib_dir__34_engine_param;
extern obj_t find_global_223_ast_env(obj_t, obj_t);
static obj_t handling_function1209_10_heap_restore(obj_t);
static obj_t __cnst[4];

DEFINE_STRING(string1274_heap_restore, string1274_heap_restore1284, "restore-heap", 12);
DEFINE_STRING(string1273_heap_restore, string1273_heap_restore1285, "failure during prelude hook", 27);
DEFINE_STRING(string1275_heap_restore, string1275_heap_restore1286, "Cannot open heap file", 21);
DEFINE_STRING(string1277_heap_restore, string1277_heap_restore1287, "CALL-WITH-CURRENT-CONTINUATION __R4_CONTROL_FEATURES_6_9 CALL/CC PASS-STARTED ", 78);
DEFINE_STRING(string1276_heap_restore, string1276_heap_restore1288, "Cannot find heap file", 21);
DEFINE_EXPORT_PROCEDURE(restore_heap_env_119_heap_restore, _restore_heap_238_heap_restore1289, _restore_heap_238_heap_restore, 0L, 0);
DEFINE_STRING(string1272_heap_restore, string1272_heap_restore1290, "   . ", 5);
DEFINE_STRING(string1271_heap_restore, string1271_heap_restore1291, "Heap", 4);

obj_t 
module_initialization_70_heap_restore(long checksum_526, char *from_527)
{
   if (CBOOL(require_initialization_114_heap_restore))
     {
	require_initialization_114_heap_restore = BBOOL(((bool_t) 0));
	library_modules_init_112_heap_restore();
	cnst_init_137_heap_restore();
	imported_modules_init_94_heap_restore();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_heap_restore()
{
   module_initialization_70___error(((long) 0), "HEAP_RESTORE");
   module_initialization_70___bexit(((long) 0), "HEAP_RESTORE");
   module_initialization_70___reader(((long) 0), "HEAP_RESTORE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_heap_restore()
{
   {
      obj_t cnst_port_138_518;
      cnst_port_138_518 = open_input_string(string1277_heap_restore);
      {
	 long i_519;
	 i_519 = ((long) 3);
       loop_520:
	 {
	    bool_t test1278_521;
	    test1278_521 = (i_519 == ((long) -1));
	    if (test1278_521)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1279_522;
		    {
		       obj_t list1280_523;
		       {
			  obj_t arg1282_524;
			  arg1282_524 = BNIL;
			  list1280_523 = MAKE_PAIR(cnst_port_138_518, arg1282_524);
		       }
		       arg1279_522 = read___reader(list1280_523);
		    }
		    CNST_TABLE_SET(i_519, arg1279_522);
		 }
		 {
		    int aux_525;
		    {
		       long aux_543;
		       aux_543 = (i_519 - ((long) 1));
		       aux_525 = (int) (aux_543);
		    }
		    {
		       long i_546;
		       i_546 = (long) (aux_525);
		       i_519 = i_546;
		       goto loop_520;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
restore_heap_59_heap_restore()
{
   {
      bool_t test1121_279;
      {
	 obj_t obj_475;
	 obj_475 = __heap_name__135_engine_param;
	 test1121_279 = STRINGP(obj_475);
      }
      if (test1121_279)
	{
	   {
	      obj_t list1122_280;
	      {
		 obj_t arg1145_282;
		 {
		    obj_t arg1149_284;
		    {
		       obj_t aux_550;
		       aux_550 = BCHAR(((unsigned char) '\n'));
		       arg1149_284 = MAKE_PAIR(aux_550, BNIL);
		    }
		    arg1145_282 = MAKE_PAIR(string1271_heap_restore, arg1149_284);
		 }
		 list1122_280 = MAKE_PAIR(string1272_heap_restore, arg1145_282);
	      }
	      verbose_tools_speek(BINT(((long) 1)), list1122_280);
	   }
	   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
	   __current_pass__25_engine_pass = string1271_heap_restore;
	   {
	      obj_t hooks_286;
	      obj_t hnames_287;
	      hooks_286 = BNIL;
	      hnames_287 = BNIL;
	    loop_288:
	      if (NULLP(hooks_286))
		{
		   CNST_TABLE_REF(((long) 0));
		}
	      else
		{
		   bool_t test1165_293;
		   {
		      obj_t fun1198_299;
		      fun1198_299 = CAR(hooks_286);
		      {
			 obj_t aux_562;
			 aux_562 = PROCEDURE_ENTRY(fun1198_299) (fun1198_299, BEOA);
			 test1165_293 = CBOOL(aux_562);
		      }
		   }
		   if (test1165_293)
		     {
			{
			   obj_t hnames_569;
			   obj_t hooks_567;
			   hooks_567 = CDR(hooks_286);
			   hnames_569 = CDR(hnames_287);
			   hnames_287 = hnames_569;
			   hooks_286 = hooks_567;
			   goto loop_288;
			}
		     }
		   else
		     {
			internal_error_43_tools_error(string1271_heap_restore, string1273_heap_restore, CAR(hnames_287));
		     }
		}
	   }
	   {
	      obj_t fname_300;
	      {
		 obj_t arg1212_336;
		 {
		    obj_t list1213_337;
		    list1213_337 = MAKE_PAIR(__lib_dir__34_engine_param, BNIL);
		    arg1212_336 = list1213_337;
		 }
		 fname_300 = find_file_path_55_tools_file(__heap_name__135_engine_param, arg1212_336);
	      }
	      if (STRINGP(fname_300))
		{
		   obj_t port_302;
		   port_302 = open_input_binary_file(fname_300);
		   {
		      obj_t handler_501;
		      handler_501 = make_fx_procedure(handler1270_heap_restore, ((long) 4), ((long) 1));
		      PROCEDURE_SET(handler_501, ((long) 0), port_302);
		      {
			 if (BINARY_PORTP(port_302))
			   {
			      obj_t armed1113_307;
			      armed1113_307 = MAKE_CELL(BTRUE);
			      return handling_function1201_209_heap_restore(handler_501, armed1113_307, port_302);
			   }
			 else
			   {
			      FAILURE(string1274_heap_restore, string1275_heap_restore, fname_300);
			   }
		      }
		   }
		}
	      else
		{
		   {
		      obj_t object_499;
		      object_499 = __heap_name__135_engine_param;
		      FAILURE(string1274_heap_restore, string1276_heap_restore, object_499);
		   }
		   return exit_bigloo_229_init_main(BINT(((long) -5)));
		}
	   }
	}
      else
	{
	   return BFALSE;
	}
   }
}


obj_t 
handling_function1201_209_heap_restore(obj_t handler1110_516, obj_t armed1113_515, obj_t port_514)
{
   jmp_buf jmpbuf;
   obj_t an_exit1114_144_309;
   if (SET_EXIT(an_exit1114_144_309))
     {
	RESTORE_TRACE();
	return _exit_value_;
     }
   else
     {
	an_exit1114_144_309 = (obj_t) jmpbuf;
	{
	   PUSH_EXIT(an_exit1114_144_309, ((bool_t) 1));
	   {
	      obj_t an_exitd1115_46_310;
	      an_exitd1115_46_310 = exitd_top;
	      {
		 obj_t res1117_313;
		 {
		    obj_t arg1203_500;
		    arg1203_500 = make_fx_procedure(arg12031269_heap_restore, ((long) 1), ((long) 2));
		    PROCEDURE_SET(arg1203_500, ((long) 0), armed1113_515);
		    PROCEDURE_SET(arg1203_500, ((long) 1), an_exitd1115_46_310);
		    add_error_handler__155___error(handler1110_516, arg1203_500);
		 }
		 {
		    obj_t val1118_318;
		    val1118_318 = handling_function1209_10_heap_restore(port_514);
		    {
		       bool_t test_597;
		       {
			  obj_t aux_598;
			  aux_598 = CELL_REF(armed1113_515);
			  test_597 = CBOOL(aux_598);
		       }
		       if (test_597)
			 {
			    remove_error_handler__102___error();
			 }
		       else
			 {
			    BUNSPEC;
			 }
		    }
		    {
		       bool_t test1205_319;
		       {
			  obj_t aux_601;
			  aux_601 = val_from_exit__100___bexit(val1118_318);
			  test1205_319 = CBOOL(aux_601);
		       }
		       if (test1205_319)
			 {
			    res1117_313 = unwind_until__178___bexit(CAR(val1118_318), CDR(val1118_318));
			 }
		       else
			 {
			    res1117_313 = val1118_318;
			 }
		    }
		 }
		 POP_EXIT();
		 return res1117_313;
	      }
	   }
	}
     }
}


obj_t 
handling_function1209_10_heap_restore(obj_t port_517)
{
   {
      jmp_buf jmpbuf;
      obj_t an_exit1119_103_323;
      if (SET_EXIT(an_exit1119_103_323))
	{
	   RESTORE_TRACE();
	   return _exit_value_;
	}
      else
	{
	   an_exit1119_103_323 = (obj_t) jmpbuf;
	   {
	      PUSH_EXIT(an_exit1119_103_323, ((bool_t) 0));
	      {
		 bool_t val1120_324;
		 {
		    obj_t envs_326;
		    envs_326 = input_obj(port_517);
		    {
		       obj_t genv_327;
		       genv_327 = CAR(envs_326);
		       {
			  obj_t tenv_328;
			  tenv_328 = CDR(envs_326);
			  {
			     close_binary_port(port_517);
			     set_genv__34_ast_env(genv_327);
			     set_tenv__70_type_env(tenv_328);
			     if (CBOOL(__call_cc___102_engine_param))
			       {
				  BUNSPEC;
			       }
			     else
			       {
				  unbind_call_cc__206_heap_restore();
			       }
			     val1120_324 = ((bool_t) 1);
			  }
		       }
		    }
		 }
		 POP_EXIT();
		 return BBOOL(val1120_324);
	      }
	   }
	}
   }
}


obj_t 
_restore_heap_238_heap_restore(obj_t env_502)
{
   return restore_heap_59_heap_restore();
}


obj_t 
arg12031269_heap_restore(obj_t env_503, obj_t arg_506)
{
   {
      obj_t armed1113_504;
      obj_t an_exitd1115_46_505;
      armed1113_504 = PROCEDURE_REF(env_503, ((long) 0));
      an_exitd1115_46_505 = PROCEDURE_REF(env_503, ((long) 1));
      {
	 obj_t arg_315;
	 arg_315 = arg_506;
	 CELL_SET(armed1113_504, BFALSE);
	 return unwind_until__178___bexit(an_exitd1115_46_505, arg_315);
      }
   }
}


obj_t 
handler1270_heap_restore(obj_t env_508, obj_t escape_510, obj_t proc_511, obj_t mes_512, obj_t obj_513)
{
   {
      obj_t port_509;
      port_509 = PROCEDURE_REF(env_508, ((long) 0));
      {
	 obj_t escape_330;
	 obj_t proc_331;
	 obj_t mes_332;
	 obj_t obj_333;
	 escape_330 = escape_510;
	 proc_331 = proc_511;
	 mes_332 = mes_512;
	 obj_333 = obj_513;
	 notify_error_43___error(proc_331, mes_332, obj_333);
	 close_binary_port(port_509);
	 return exit_bigloo_229_init_main(BINT(((long) -5)));
      }
   }
}


obj_t 
unbind_call_cc__206_heap_restore()
{
   {
      bool_t test1215_339;
      {
	 obj_t arg1219_342;
	 arg1219_342 = CNST_TABLE_REF(((long) 1));
	 {
	    obj_t list1223_344;
	    {
	       obj_t aux_633;
	       aux_633 = CNST_TABLE_REF(((long) 2));
	       list1223_344 = MAKE_PAIR(aux_633, BNIL);
	    }
	    {
	       obj_t aux_636;
	       aux_636 = find_global_223_ast_env(arg1219_342, list1223_344);
	       test1215_339 = CBOOL(aux_636);
	    }
	 }
      }
      if (test1215_339)
	{
	   unbind_global__45_ast_env(CNST_TABLE_REF(((long) 1)), CNST_TABLE_REF(((long) 2)));
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test1226_346;
      {
	 obj_t arg1230_349;
	 arg1230_349 = CNST_TABLE_REF(((long) 3));
	 {
	    obj_t list1232_351;
	    {
	       obj_t aux_644;
	       aux_644 = CNST_TABLE_REF(((long) 2));
	       list1232_351 = MAKE_PAIR(aux_644, BNIL);
	    }
	    {
	       obj_t aux_647;
	       aux_647 = find_global_223_ast_env(arg1230_349, list1232_351);
	       test1226_346 = CBOOL(aux_647);
	    }
	 }
      }
      if (test1226_346)
	{
	   return unbind_global__45_ast_env(CNST_TABLE_REF(((long) 3)), CNST_TABLE_REF(((long) 2)));
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
imported_modules_init_94_heap_restore()
{
   module_initialization_70_tools_speek(((long) 0), "HEAP_RESTORE");
   module_initialization_70_tools_error(((long) 0), "HEAP_RESTORE");
   module_initialization_70_engine_pass(((long) 0), "HEAP_RESTORE");
   module_initialization_70_engine_param(((long) 0), "HEAP_RESTORE");
   module_initialization_70_engine_engine(((long) 0), "HEAP_RESTORE");
   module_initialization_70_init_main(((long) 0), "HEAP_RESTORE");
   module_initialization_70_tools_file(((long) 0), "HEAP_RESTORE");
   module_initialization_70_ast_env(((long) 0), "HEAP_RESTORE");
   module_initialization_70_type_type(((long) 0), "HEAP_RESTORE");
   module_initialization_70_type_env(((long) 0), "HEAP_RESTORE");
   return module_initialization_70_ast_var(((long) 0), "HEAP_RESTORE");
}
