/*===========================================================================*/
/*   (Hgen/walk.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t start_emission__101_cgen_emit(obj_t);
static obj_t arg13031433_hgen_walk(obj_t);
extern obj_t __nb_error_on_pass__70_tools_error;
static obj_t imported_modules_init_94_hgen_walk();
extern obj_t module_initialization_70_hgen_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cgen_emit(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t cnst_init_137_hgen_walk();
extern obj_t hgen_walk_202_hgen_walk();
static obj_t require_initialization_114_hgen_walk = BUNSPEC;
static obj_t library_modules_init_112_hgen_walk();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t __c_port__188_cgen_emit;
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t emit_class_types_26_object_class(obj_t);
extern obj_t stop_emission__231_cgen_emit();
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t emit_header_99_cgen_emit();
extern obj_t __current_pass__25_engine_pass;
extern obj_t _hgen_walk_236_hgen_walk(obj_t);
static obj_t __cnst[2];

DEFINE_STRING(string1438_hgen_walk, string1438_hgen_walk1446, ".h", 2);
DEFINE_EXPORT_PROCEDURE(hgen_walk_env_69_hgen_walk, _hgen_walk_236_hgen_walk1447, _hgen_walk_236_hgen_walk, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1437_hgen_walk, arg13031433_hgen_walk1448, arg13031433_hgen_walk, 0L, 0);
DEFINE_STRING(string1436_hgen_walk, string1436_hgen_walk1449, "failure during prelude hook", 27);
DEFINE_STRING(string1435_hgen_walk, string1435_hgen_walk1450, "   . ", 5);
DEFINE_STRING(string1434_hgen_walk, string1434_hgen_walk1451, "C headers generation", 20);
DEFINE_STRING(string1439_hgen_walk, string1439_hgen_walk1452, "((LAMBDA () (START-EMISSION! \".h\"))) PASS-STARTED ", 50);

obj_t 
module_initialization_70_hgen_walk(long checksum_1086, char *from_1087)
{
   if (CBOOL(require_initialization_114_hgen_walk))
     {
	require_initialization_114_hgen_walk = BBOOL(((bool_t) 0));
	library_modules_init_112_hgen_walk();
	cnst_init_137_hgen_walk();
	imported_modules_init_94_hgen_walk();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_hgen_walk()
{
   module_initialization_70___reader(((long) 0), "HGEN_WALK");
   return BUNSPEC;
}


obj_t 
cnst_init_137_hgen_walk()
{
   {
      obj_t cnst_port_138_1078;
      cnst_port_138_1078 = open_input_string(string1439_hgen_walk);
      {
	 long i_1079;
	 i_1079 = ((long) 1);
       loop_1080:
	 {
	    bool_t test1440_1081;
	    test1440_1081 = (i_1079 == ((long) -1));
	    if (test1440_1081)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1441_1082;
		    {
		       obj_t list1442_1083;
		       {
			  obj_t arg1444_1084;
			  arg1444_1084 = BNIL;
			  list1442_1083 = MAKE_PAIR(cnst_port_138_1078, arg1444_1084);
		       }
		       arg1441_1082 = read___reader(list1442_1083);
		    }
		    CNST_TABLE_SET(i_1079, arg1441_1082);
		 }
		 {
		    int aux_1085;
		    {
		       long aux_1101;
		       aux_1101 = (i_1079 - ((long) 1));
		       aux_1085 = (int) (aux_1101);
		    }
		    {
		       long i_1104;
		       i_1104 = (long) (aux_1085);
		       i_1079 = i_1104;
		       goto loop_1080;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
hgen_walk_202_hgen_walk()
{
   {
      obj_t list1291_699;
      {
	 obj_t arg1295_701;
	 {
	    obj_t arg1297_703;
	    {
	       obj_t aux_1106;
	       aux_1106 = BCHAR(((unsigned char) '\n'));
	       arg1297_703 = MAKE_PAIR(aux_1106, BNIL);
	    }
	    arg1295_701 = MAKE_PAIR(string1434_hgen_walk, arg1297_703);
	 }
	 list1291_699 = MAKE_PAIR(string1435_hgen_walk, arg1295_701);
      }
      verbose_tools_speek(BINT(((long) 1)), list1291_699);
   }
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   __current_pass__25_engine_pass = string1434_hgen_walk;
   {
      obj_t hooks_705;
      obj_t hnames_706;
      {
	 obj_t arg1299_708;
	 obj_t arg1300_709;
	 {
	    obj_t arg1303_1075;
	    arg1303_1075 = proc1437_hgen_walk;
	    {
	       obj_t list1304_711;
	       list1304_711 = MAKE_PAIR(arg1303_1075, BNIL);
	       arg1299_708 = list1304_711;
	    }
	 }
	 arg1300_709 = CNST_TABLE_REF(((long) 1));
	 hooks_705 = arg1299_708;
	 hnames_706 = arg1300_709;
       loop_707:
	 if (NULLP(hooks_705))
	   {
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {
	      bool_t test1308_716;
	      {
		 obj_t fun1315_722;
		 fun1315_722 = CAR(hooks_705);
		 {
		    obj_t aux_1120;
		    aux_1120 = PROCEDURE_ENTRY(fun1315_722) (fun1315_722, BEOA);
		    test1308_716 = CBOOL(aux_1120);
		 }
	      }
	      if (test1308_716)
		{
		   {
		      obj_t hnames_1127;
		      obj_t hooks_1125;
		      hooks_1125 = CDR(hooks_705);
		      hnames_1127 = CDR(hnames_706);
		      hnames_706 = hnames_1127;
		      hooks_705 = hooks_1125;
		      goto loop_707;
		   }
		}
	      else
		{
		   internal_error_43_tools_error(string1434_hgen_walk, string1436_hgen_walk, CAR(hnames_706));
		}
	   }
      }
   }
   emit_header_99_cgen_emit();
   emit_class_types_26_object_class(__c_port__188_cgen_emit);
   return stop_emission__231_cgen_emit();
}


obj_t 
_hgen_walk_236_hgen_walk(obj_t env_1076)
{
   return hgen_walk_202_hgen_walk();
}


obj_t 
arg13031433_hgen_walk(obj_t env_1077)
{
   {
      return start_emission__101_cgen_emit(string1438_hgen_walk);
   }
}


obj_t 
imported_modules_init_94_hgen_walk()
{
   module_initialization_70_tools_speek(((long) 0), "HGEN_WALK");
   module_initialization_70_tools_error(((long) 0), "HGEN_WALK");
   module_initialization_70_engine_pass(((long) 0), "HGEN_WALK");
   module_initialization_70_type_type(((long) 0), "HGEN_WALK");
   module_initialization_70_object_class(((long) 0), "HGEN_WALK");
   module_initialization_70_ast_var(((long) 0), "HGEN_WALK");
   module_initialization_70_ast_node(((long) 0), "HGEN_WALK");
   return module_initialization_70_cgen_emit(((long) 0), "HGEN_WALK");
}
