/*===========================================================================*/
/*   (Inline/app.scm)                                                        */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_t;


extern obj_t isfun_inline_inline;
extern long node_size_119_inline_size(node_t);
extern obj_t global_ast_var;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_inline_app();
extern obj_t module_initialization_70_inline_app(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_inline_walk(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_inline_size(long, char *);
extern obj_t module_initialization_70_inline_simple(long, char *);
extern obj_t module_initialization_70_inline_recursion(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t cnst_init_137_inline_app();
extern bool_t is_recursive__125_inline_recursion(variable_t);
extern node_t inline_app_72_inline_app(app_t, long, obj_t);
static obj_t require_initialization_114_inline_app = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_inline_app();
extern obj_t __optim_loop_inlining___30_engine_param;
extern obj_t sfun_ast_var;
extern bool_t inline_app__99_inline_app(variable_t, long, long, obj_t);
extern obj_t __non_inlined_calls__201_inline_walk;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t _inline_app__45_inline_app(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t _inline_app_253_inline_app(obj_t, obj_t, obj_t, obj_t);
extern node_t inline_app_recursive_121_inline_recursion(node_t, long, obj_t);
extern long list_length(obj_t);
extern obj_t __inlining___224_engine_param;
extern obj_t __inlined_calls__118_inline_walk;
extern node_t inline_app_simple_198_inline_simple(node_t, long, obj_t, obj_t);
extern obj_t __optim_unroll_loop___80_engine_param;
static obj_t __cnst[4];

DEFINE_STRING(string1580_inline_app, string1580_inline_app1602, "] ... ", 6);
DEFINE_STRING(string1592_inline_app, string1592_inline_app1603, " no, too large (size: ", 22);
DEFINE_STRING(string1582_inline_app, string1582_inline_app1604, " [kfactor:", 10);
DEFINE_STRING(string1590_inline_app, string1590_inline_app1605, " yes, small enough (size: ", 26);
DEFINE_STRING(string1583_inline_app, string1583_inline_app1606, "inline-app?: ", 13);
DEFINE_STRING(string1581_inline_app, string1581_inline_app1607, "] [stack: ", 10);
DEFINE_STRING(string1586_inline_app, string1586_inline_app1608, " yes (sifun)", 12);
DEFINE_STRING(string1587_inline_app, string1587_inline_app1609, " no (import)", 12);
DEFINE_STRING(string1585_inline_app, string1585_inline_app1610, " no (declared snifun)", 21);
DEFINE_STRING(string1593_inline_app, string1593_inline_app1611, " no (no-inlining option)", 24);
DEFINE_STRING(string1579_inline_app, string1579_inline_app1612, "simple", 6);
DEFINE_EXPORT_PROCEDURE(inline_app__env_184_inline_app, _inline_app__45_inline_app1613, _inline_app__45_inline_app, 0L, 4);
DEFINE_STRING(string1594_inline_app, string1594_inline_app1614, "IMPORT SNIFUN INLINE SIFUN ", 27);
DEFINE_STRING(string1589_inline_app, string1589_inline_app1615, " max: ", 6);
DEFINE_STRING(string1584_inline_app, string1584_inline_app1616, " no (stack)", 11);
DEFINE_STRING(string1591_inline_app, string1591_inline_app1617, " yes, same size and not in stack (size: ", 40);
DEFINE_EXPORT_PROCEDURE(inline_app_env_13_inline_app, _inline_app_253_inline_app1618, _inline_app_253_inline_app, 0L, 3);
DEFINE_STRING(string1588_inline_app, string1588_inline_app1619, ")", 1);

obj_t 
module_initialization_70_inline_app(long checksum_1219, char *from_1220)
{
   if (CBOOL(require_initialization_114_inline_app))
     {
	require_initialization_114_inline_app = BBOOL(((bool_t) 0));
	library_modules_init_112_inline_app();
	cnst_init_137_inline_app();
	imported_modules_init_94_inline_app();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_inline_app()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_APP");
   module_initialization_70___object(((long) 0), "INLINE_APP");
   module_initialization_70___reader(((long) 0), "INLINE_APP");
   return BUNSPEC;
}


obj_t 
cnst_init_137_inline_app()
{
   {
      obj_t cnst_port_138_1211;
      cnst_port_138_1211 = open_input_string(string1594_inline_app);
      {
	 long i_1212;
	 i_1212 = ((long) 3);
       loop_1213:
	 {
	    bool_t test1595_1214;
	    test1595_1214 = (i_1212 == ((long) -1));
	    if (test1595_1214)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1596_1215;
		    {
		       obj_t list1597_1216;
		       {
			  obj_t arg1600_1217;
			  arg1600_1217 = BNIL;
			  list1597_1216 = MAKE_PAIR(cnst_port_138_1211, arg1600_1217);
		       }
		       arg1596_1215 = read___reader(list1597_1216);
		    }
		    CNST_TABLE_SET(i_1212, arg1596_1215);
		 }
		 {
		    int aux_1218;
		    {
		       long aux_1236;
		       aux_1236 = (i_1212 - ((long) 1));
		       aux_1218 = (int) (aux_1236);
		    }
		    {
		       long i_1239;
		       i_1239 = (long) (aux_1218);
		       i_1212 = i_1239;
		       goto loop_1213;
		    }
		 }
	      }
	 }
      }
   }
}


node_t 
inline_app_72_inline_app(app_t node_1, long kfactor_2, obj_t stack_3)
{
   {
      var_t callee_688;
      callee_688 = (((app_t) CREF(node_1))->fun);
      {
	 variable_t var_689;
	 var_689 = (((var_t) CREF(callee_688))->variable);
	 {
	    value_t sfun_690;
	    sfun_690 = (((variable_t) CREF(var_689))->value);
	    {
	       {
		  bool_t test1289_693;
		  test1289_693 = is_a__118___object((obj_t) (sfun_690), sfun_ast_var);
		  if (test1289_693)
		    {
		       bool_t test1290_694;
		       {
			  long aux_1247;
			  {
			     long aux_1248;
			     aux_1248 = list_length((((app_t) CREF(node_1))->args));
			     aux_1247 = (((long) 1) + aux_1248);
			  }
			  test1290_694 = inline_app__99_inline_app(var_689, kfactor_2, aux_1247, stack_3);
		       }
		       if (test1290_694)
			 {
			    {
			       bool_t test_1254;
			       {
				  obj_t aux_1258;
				  obj_t aux_1255;
				  aux_1258 = CNST_TABLE_REF(((long) 0));
				  {
				     sfun_t obj_1151;
				     obj_1151 = (sfun_t) (sfun_690);
				     aux_1255 = (((sfun_t) CREF(obj_1151))->class);
				  }
				  test_1254 = (aux_1255 == aux_1258);
			       }
			       if (test_1254)
				 {
				    BUNSPEC;
				 }
			       else
				 {
				    long z1_1154;
				    z1_1154 = (long) CINT(__inlined_calls__118_inline_walk);
				    {
				       long aux_1262;
				       aux_1262 = (z1_1154 + ((long) 1));
				       __inlined_calls__118_inline_walk = BINT(aux_1262);
				    }
				 }
			    }
			    {
			       bool_t test1296_698;
			       if (CBOOL(__optim_loop_inlining___30_engine_param))
				 {
				    test1296_698 = is_recursive__125_inline_recursion(var_689);
				 }
			       else
				 {
				    test1296_698 = ((bool_t) 0);
				 }
			       if (test1296_698)
				 {
				    return inline_app_recursive_121_inline_recursion((node_t) (node_1), kfactor_2, stack_3);
				 }
			       else
				 {
				    return inline_app_simple_198_inline_simple((node_t) (node_1), kfactor_2, stack_3, string1579_inline_app);
				 }
			    }
			 }
		       else
			 {
			    {
			       long z1_1156;
			       z1_1156 = (long) CINT(__non_inlined_calls__201_inline_walk);
			       {
				  long aux_1274;
				  aux_1274 = (z1_1156 + ((long) 1));
				  __non_inlined_calls__201_inline_walk = BINT(aux_1274);
			       }
			    }
			    return (node_t) (node_1);
			 }
		    }
		  else
		    {
		       return (node_t) (node_1);
		    }
	       }
	    }
	 }
      }
   }
}


obj_t 
_inline_app_253_inline_app(obj_t env_1202, obj_t node_1203, obj_t kfactor_1204, obj_t stack_1205)
{
   {
      node_t aux_1279;
      aux_1279 = inline_app_72_inline_app((app_t) (node_1203), (long) CINT(kfactor_1204), stack_1205);
      return (obj_t) (aux_1279);
   }
}


bool_t 
inline_app__99_inline_app(variable_t var_4, long kfactor_5, long call_size_65_6, obj_t stack_7)
{
   {
      bool_t test1301_703;
      {
	 obj_t aux_1284;
	 aux_1284 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
	 test1301_703 = CBOOL(aux_1284);
      }
      if (test1301_703)
	{
	   obj_t arg1305_705;
	   obj_t arg1310_708;
	   arg1305_705 = shape_tools_shape((obj_t) (var_4));
	   arg1310_708 = shape_tools_shape(stack_7);
	   {
	      obj_t list1312_710;
	      {
		 obj_t arg1313_711;
		 {
		    obj_t arg1314_712;
		    {
		       obj_t arg1315_713;
		       {
			  obj_t arg1316_714;
			  {
			     obj_t arg1318_715;
			     {
				obj_t arg1319_716;
				arg1319_716 = MAKE_PAIR(string1580_inline_app, BNIL);
				arg1318_715 = MAKE_PAIR(arg1310_708, arg1319_716);
			     }
			     arg1316_714 = MAKE_PAIR(string1581_inline_app, arg1318_715);
			  }
			  {
			     obj_t aux_1296;
			     aux_1296 = BINT(kfactor_5);
			     arg1315_713 = MAKE_PAIR(aux_1296, arg1316_714);
			  }
		       }
		       arg1314_712 = MAKE_PAIR(string1582_inline_app, arg1315_713);
		    }
		    arg1313_711 = MAKE_PAIR(arg1305_705, arg1314_712);
		 }
		 list1312_710 = MAKE_PAIR(string1583_inline_app, arg1313_711);
	      }
	      print_trace_107_tools_trace(list1312_710);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      value_t sfun_720;
      sfun_720 = (((variable_t) CREF(var_4))->value);
      {
	 obj_t body_721;
	 {
	    bool_t test1477_822;
	    test1477_822 = is_a__118___object((obj_t) (sfun_720), isfun_inline_inline);
	    if (test1477_822)
	      {
		 isfun_t obj_1160;
		 obj_1160 = (isfun_t) (sfun_720);
		 {
		    node_t aux_1308;
		    {
		       obj_t aux_1309;
		       {
			  object_t aux_1310;
			  aux_1310 = (object_t) (obj_1160);
			  aux_1309 = OBJECT_WIDENING(aux_1310);
		       }
		       aux_1308 = (((isfun_t) CREF(aux_1309))->original_body_40);
		    }
		    body_721 = (obj_t) (aux_1308);
		 }
	      }
	    else
	      {
		 sfun_t obj_1161;
		 obj_1161 = (sfun_t) (sfun_720);
		 body_721 = (((sfun_t) CREF(obj_1161))->body);
	      }
	 }
	 {
	    {
	       bool_t test1323_722;
	       if (CBOOL(__optim_loop_inlining___30_engine_param))
		 {
		    if (CBOOL(__optim_unroll_loop___80_engine_param))
		      {
			 test1323_722 = ((bool_t) 0);
		      }
		    else
		      {
			 obj_t aux_1321;
			 aux_1321 = memq___r4_pairs_and_lists_6_3((obj_t) (var_4), stack_7);
			 test1323_722 = CBOOL(aux_1321);
		      }
		 }
	       else
		 {
		    test1323_722 = ((bool_t) 0);
		 }
	       if (test1323_722)
		 {
		    {
		       bool_t test1324_723;
		       {
			  obj_t aux_1326;
			  aux_1326 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
			  test1324_723 = CBOOL(aux_1326);
		       }
		       if (test1324_723)
			 {
			    obj_t list1325_724;
			    {
			       obj_t arg1328_726;
			       {
				  obj_t aux_1332;
				  aux_1332 = BCHAR(((unsigned char) '\n'));
				  arg1328_726 = MAKE_PAIR(aux_1332, BNIL);
			       }
			       list1325_724 = MAKE_PAIR(string1584_inline_app, arg1328_726);
			    }
			    print_trace_107_tools_trace(list1325_724);
			 }
		       else
			 {
			    BUNSPEC;
			 }
		    }
		    return ((bool_t) 0);
		 }
	       else
		 {
		    bool_t test_1337;
		    {
		       obj_t aux_1341;
		       obj_t aux_1338;
		       aux_1341 = CNST_TABLE_REF(((long) 2));
		       {
			  sfun_t obj_1162;
			  obj_1162 = (sfun_t) (sfun_720);
			  aux_1338 = (((sfun_t) CREF(obj_1162))->class);
		       }
		       test_1337 = (aux_1338 == aux_1341);
		    }
		    if (test_1337)
		      {
			 {
			    bool_t test1334_731;
			    {
			       obj_t aux_1344;
			       aux_1344 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
			       test1334_731 = CBOOL(aux_1344);
			    }
			    if (test1334_731)
			      {
				 obj_t list1335_732;
				 {
				    obj_t arg1339_734;
				    {
				       obj_t aux_1350;
				       aux_1350 = BCHAR(((unsigned char) '\n'));
				       arg1339_734 = MAKE_PAIR(aux_1350, BNIL);
				    }
				    list1335_732 = MAKE_PAIR(string1585_inline_app, arg1339_734);
				 }
				 print_trace_107_tools_trace(list1335_732);
			      }
			    else
			      {
				 BUNSPEC;
			      }
			 }
			 return ((bool_t) 0);
		      }
		    else
		      {
			 bool_t test_1355;
			 {
			    bool_t test_1356;
			    {
			       obj_t aux_1360;
			       obj_t aux_1357;
			       aux_1360 = CNST_TABLE_REF(((long) 0));
			       {
				  sfun_t obj_1165;
				  obj_1165 = (sfun_t) (sfun_720);
				  aux_1357 = (((sfun_t) CREF(obj_1165))->class);
			       }
			       test_1356 = (aux_1357 == aux_1360);
			    }
			    if (test_1356)
			      {
				 bool_t test_1363;
				 {
				    obj_t aux_1364;
				    aux_1364 = memq___r4_pairs_and_lists_6_3((obj_t) (var_4), stack_7);
				    test_1363 = CBOOL(aux_1364);
				 }
				 if (test_1363)
				   {
				      test_1355 = ((bool_t) 0);
				   }
				 else
				   {
				      test_1355 = ((bool_t) 1);
				   }
			      }
			    else
			      {
				 test_1355 = ((bool_t) 0);
			      }
			 }
			 if (test_1355)
			   {
			      {
				 bool_t test1345_739;
				 {
				    obj_t aux_1368;
				    aux_1368 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
				    test1345_739 = CBOOL(aux_1368);
				 }
				 if (test1345_739)
				   {
				      obj_t list1346_740;
				      {
					 obj_t arg1349_742;
					 {
					    obj_t aux_1374;
					    aux_1374 = BCHAR(((unsigned char) '\n'));
					    arg1349_742 = MAKE_PAIR(aux_1374, BNIL);
					 }
					 list1346_740 = MAKE_PAIR(string1586_inline_app, arg1349_742);
				      }
				      print_trace_107_tools_trace(list1346_740);
				   }
				 else
				   {
				      BUNSPEC;
				   }
			      }
			      return ((bool_t) 1);
			   }
			 else
			   {
			      bool_t test1354_746;
			      {
				 bool_t test1466_813;
				 test1466_813 = is_a__118___object((obj_t) (var_4), global_ast_var);
				 if (test1466_813)
				   {
				      obj_t aux_1385;
				      obj_t aux_1382;
				      aux_1385 = CNST_TABLE_REF(((long) 3));
				      {
					 global_t obj_1169;
					 obj_1169 = (global_t) (var_4);
					 aux_1382 = (((global_t) CREF(obj_1169))->import);
				      }
				      test1354_746 = (aux_1382 == aux_1385);
				   }
				 else
				   {
				      test1354_746 = ((bool_t) 0);
				   }
			      }
			      if (test1354_746)
				{
				   {
				      bool_t test1355_747;
				      {
					 obj_t aux_1389;
					 aux_1389 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
					 test1355_747 = CBOOL(aux_1389);
				      }
				      if (test1355_747)
					{
					   obj_t list1356_748;
					   {
					      obj_t arg1358_750;
					      {
						 obj_t aux_1395;
						 aux_1395 = BCHAR(((unsigned char) '\n'));
						 arg1358_750 = MAKE_PAIR(aux_1395, BNIL);
					      }
					      list1356_748 = MAKE_PAIR(string1587_inline_app, arg1358_750);
					   }
					   print_trace_107_tools_trace(list1356_748);
					}
				      else
					{
					   BUNSPEC;
					}
				   }
				   return ((bool_t) 0);
				}
			      else
				{
				   if (CBOOL(__inlining___224_engine_param))
				     {
					bool_t test1364_754;
					{
					   long arg1450_804;
					   long arg1452_805;
					   arg1450_804 = node_size_119_inline_size((node_t) (body_721));
					   arg1452_805 = (kfactor_5 * call_size_65_6);
					   test1364_754 = (arg1450_804 < arg1452_805);
					}
					if (test1364_754)
					  {
					     {
						bool_t test1365_755;
						{
						   obj_t aux_1407;
						   aux_1407 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
						   test1365_755 = CBOOL(aux_1407);
						}
						if (test1365_755)
						  {
						     long arg1367_757;
						     long arg1370_759;
						     arg1367_757 = node_size_119_inline_size((node_t) (body_721));
						     arg1370_759 = (kfactor_5 * call_size_65_6);
						     {
							obj_t list1373_761;
							{
							   obj_t arg1376_762;
							   {
							      obj_t arg1379_763;
							      {
								 obj_t arg1380_764;
								 {
								    obj_t arg1381_765;
								    {
								       obj_t arg1382_766;
								       {
									  obj_t aux_1416;
									  aux_1416 = BCHAR(((unsigned char) '\n'));
									  arg1382_766 = MAKE_PAIR(aux_1416, BNIL);
								       }
								       arg1381_765 = MAKE_PAIR(string1588_inline_app, arg1382_766);
								    }
								    {
								       obj_t aux_1420;
								       aux_1420 = BINT(arg1370_759);
								       arg1380_764 = MAKE_PAIR(aux_1420, arg1381_765);
								    }
								 }
								 arg1379_763 = MAKE_PAIR(string1589_inline_app, arg1380_764);
							      }
							      {
								 obj_t aux_1424;
								 aux_1424 = BINT(arg1367_757);
								 arg1376_762 = MAKE_PAIR(aux_1424, arg1379_763);
							      }
							   }
							   list1373_761 = MAKE_PAIR(string1590_inline_app, arg1376_762);
							}
							print_trace_107_tools_trace(list1373_761);
						     }
						  }
						else
						  {
						     BUNSPEC;
						  }
					     }
					     return ((bool_t) 1);
					  }
					else
					  {
					     bool_t test1391_770;
					     {
						bool_t test1447_801;
						{
						   long arg1449_803;
						   arg1449_803 = node_size_119_inline_size((node_t) (body_721));
						   test1447_801 = (arg1449_803 == call_size_65_6);
						}
						if (test1447_801)
						  {
						     bool_t test_1433;
						     {
							obj_t aux_1434;
							aux_1434 = memq___r4_pairs_and_lists_6_3((obj_t) (var_4), stack_7);
							test_1433 = CBOOL(aux_1434);
						     }
						     if (test_1433)
						       {
							  test1391_770 = ((bool_t) 0);
						       }
						     else
						       {
							  test1391_770 = ((bool_t) 1);
						       }
						  }
						else
						  {
						     test1391_770 = ((bool_t) 0);
						  }
					     }
					     if (test1391_770)
					       {
						  {
						     bool_t test1392_771;
						     {
							obj_t aux_1439;
							aux_1439 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
							test1392_771 = CBOOL(aux_1439);
						     }
						     if (test1392_771)
						       {
							  long arg1398_773;
							  long arg1402_775;
							  arg1398_773 = node_size_119_inline_size((node_t) (body_721));
							  arg1402_775 = (kfactor_5 * call_size_65_6);
							  {
							     obj_t list1404_777;
							     {
								obj_t arg1406_778;
								{
								   obj_t arg1408_779;
								   {
								      obj_t arg1410_780;
								      {
									 obj_t arg1411_781;
									 {
									    obj_t arg1412_782;
									    {
									       obj_t aux_1448;
									       aux_1448 = BCHAR(((unsigned char) '\n'));
									       arg1412_782 = MAKE_PAIR(aux_1448, BNIL);
									    }
									    arg1411_781 = MAKE_PAIR(string1588_inline_app, arg1412_782);
									 }
									 {
									    obj_t aux_1452;
									    aux_1452 = BINT(arg1402_775);
									    arg1410_780 = MAKE_PAIR(aux_1452, arg1411_781);
									 }
								      }
								      arg1408_779 = MAKE_PAIR(string1589_inline_app, arg1410_780);
								   }
								   {
								      obj_t aux_1456;
								      aux_1456 = BINT(arg1398_773);
								      arg1406_778 = MAKE_PAIR(aux_1456, arg1408_779);
								   }
								}
								list1404_777 = MAKE_PAIR(string1591_inline_app, arg1406_778);
							     }
							     print_trace_107_tools_trace(list1404_777);
							  }
						       }
						     else
						       {
							  BUNSPEC;
						       }
						  }
						  return ((bool_t) 1);
					       }
					     else
					       {
						  {
						     bool_t test1417_786;
						     {
							obj_t aux_1461;
							aux_1461 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
							test1417_786 = CBOOL(aux_1461);
						     }
						     if (test1417_786)
						       {
							  long arg1420_788;
							  long arg1424_790;
							  arg1420_788 = node_size_119_inline_size((node_t) (body_721));
							  arg1424_790 = (kfactor_5 * call_size_65_6);
							  {
							     obj_t list1427_792;
							     {
								obj_t arg1428_793;
								{
								   obj_t arg1431_794;
								   {
								      obj_t arg1432_795;
								      {
									 obj_t arg1440_796;
									 {
									    obj_t arg1441_797;
									    {
									       obj_t aux_1470;
									       aux_1470 = BCHAR(((unsigned char) '\n'));
									       arg1441_797 = MAKE_PAIR(aux_1470, BNIL);
									    }
									    arg1440_796 = MAKE_PAIR(string1588_inline_app, arg1441_797);
									 }
									 {
									    obj_t aux_1474;
									    aux_1474 = BINT(arg1424_790);
									    arg1432_795 = MAKE_PAIR(aux_1474, arg1440_796);
									 }
								      }
								      arg1431_794 = MAKE_PAIR(string1589_inline_app, arg1432_795);
								   }
								   {
								      obj_t aux_1478;
								      aux_1478 = BINT(arg1420_788);
								      arg1428_793 = MAKE_PAIR(aux_1478, arg1431_794);
								   }
								}
								list1427_792 = MAKE_PAIR(string1592_inline_app, arg1428_793);
							     }
							     print_trace_107_tools_trace(list1427_792);
							  }
						       }
						     else
						       {
							  BUNSPEC;
						       }
						  }
						  return ((bool_t) 0);
					       }
					  }
				     }
				   else
				     {
					{
					   bool_t test1453_806;
					   {
					      obj_t aux_1483;
					      aux_1483 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 0)));
					      test1453_806 = CBOOL(aux_1483);
					   }
					   if (test1453_806)
					     {
						obj_t list1454_807;
						{
						   obj_t arg1458_809;
						   {
						      obj_t aux_1489;
						      aux_1489 = BCHAR(((unsigned char) '\n'));
						      arg1458_809 = MAKE_PAIR(aux_1489, BNIL);
						   }
						   list1454_807 = MAKE_PAIR(string1593_inline_app, arg1458_809);
						}
						print_trace_107_tools_trace(list1454_807);
					     }
					   else
					     {
						BUNSPEC;
					     }
					}
					return ((bool_t) 0);
				     }
				}
			   }
		      }
		 }
	    }
	 }
      }
   }
}


obj_t 
_inline_app__45_inline_app(obj_t env_1206, obj_t var_1207, obj_t kfactor_1208, obj_t call_size_65_1209, obj_t stack_1210)
{
   {
      bool_t aux_1494;
      aux_1494 = inline_app__99_inline_app((variable_t) (var_1207), (long) CINT(kfactor_1208), (long) CINT(call_size_65_1209), stack_1210);
      return BBOOL(aux_1494);
   }
}


obj_t 
imported_modules_init_94_inline_app()
{
   module_initialization_70_tools_trace(((long) 0), "INLINE_APP");
   module_initialization_70_engine_param(((long) 0), "INLINE_APP");
   module_initialization_70_tools_shape(((long) 0), "INLINE_APP");
   module_initialization_70_tools_error(((long) 0), "INLINE_APP");
   module_initialization_70_type_type(((long) 0), "INLINE_APP");
   module_initialization_70_ast_var(((long) 0), "INLINE_APP");
   module_initialization_70_ast_node(((long) 0), "INLINE_APP");
   module_initialization_70_inline_walk(((long) 0), "INLINE_APP");
   module_initialization_70_inline_inline(((long) 0), "INLINE_APP");
   module_initialization_70_inline_size(((long) 0), "INLINE_APP");
   module_initialization_70_inline_simple(((long) 0), "INLINE_APP");
   return module_initialization_70_inline_recursion(((long) 0), "INLINE_APP");
}
