/*===========================================================================*/
/*   (Inline/inline.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_t;


static obj_t struct_object__object_isfun1720_132_inline_inline(obj_t, obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
obj_t isfun_inline_inline = BUNSPEC;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
static obj_t _inline_node_default1310_201_inline_inline(obj_t, obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
static bool_t sfun__199_inline_inline(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t _struct_object__object_6___object(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_inline_inline();
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_inline_walk(long, char *);
extern obj_t module_initialization_70_inline_app(long, char *);
extern obj_t module_initialization_70_ast_alphatize(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_inline_inline();
static obj_t cnst_init_137_inline_inline();
extern obj_t __optim__89_engine_param;
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
extern node_t inline_node_218_inline_inline(node_t, long, obj_t);
extern node_t inline_app_72_inline_app(app_t, long, obj_t);
static obj_t require_initialization_114_inline_inline = BUNSPEC;
static obj_t inline_node___77_inline_inline(obj_t, long, obj_t);
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_inline_inline();
extern obj_t sfun_ast_var;
extern bool_t inline_app__99_inline_app(variable_t, long, long, obj_t);
static obj_t object__struct_isfun1721_223_inline_inline(obj_t, obj_t);
extern obj_t __non_inlined_calls__201_inline_walk;
extern obj_t cast_ast_node;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
static obj_t _sfun__63_inline_inline(obj_t, obj_t);
extern obj_t pragma_ast_node;
extern obj_t inline_sfun__229_inline_inline(variable_t, long, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t object__struct_50___object(object_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
static node_t inline_node_default1310_14_inline_inline(node_t, long, obj_t);
extern obj_t _inline_sfun__45_inline_inline(obj_t, obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
static obj_t object_init_111_inline_inline();
extern obj_t set_ex_it_116_ast_node;
extern obj_t kwote_ast_node;
extern obj_t __kfactor__149_inline_walk;
extern long list_length(obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t _object__struct_74___object(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
static obj_t _allocate_isfun_106_inline_inline(obj_t);
extern object_t struct_object__object_93___object(object_t, obj_t);
extern obj_t _inline_node_166_inline_inline(obj_t, obj_t, obj_t, obj_t);
extern node_t alphatize_ast_alphatize(obj_t, obj_t, obj_t, node_t);
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t);
extern obj_t app_ast_node;
static sfun_t allocate_isfun_51_inline_inline();
static obj_t __cnst[6];

DEFINE_EXPORT_PROCEDURE(inline_sfun__env_218_inline_inline, _inline_sfun__45_inline_inline1738, _inline_sfun__45_inline_inline, 0L, 3);
DEFINE_STATIC_PROCEDURE(proc1731_inline_inline, struct_object__object_isfun1720_132_inline_inline1739, struct_object__object_isfun1720_132_inline_inline, 0L, 2);
DEFINE_STATIC_PROCEDURE(sfun__env_206_inline_inline, _sfun__63_inline_inline1740, _sfun__63_inline_inline, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1730_inline_inline, object__struct_isfun1721_223_inline_inline1741, object__struct_isfun1721_223_inline_inline, 0L, 1);
DEFINE_STRING(string1727_inline_inline, string1727_inline_inline1742, "--- END SCANNING: ", 18);
DEFINE_STRING(string1726_inline_inline, string1726_inline_inline1743, " ----", 5);
DEFINE_STRING(string1725_inline_inline, string1725_inline_inline1744, "DUPLICATING ", 12);
DEFINE_STRING(string1723_inline_inline, string1723_inline_inline1745, "--- SCANNING: ", 14);
DEFINE_STRING(string1728_inline_inline, string1728_inline_inline1746, "No method for this object", 25);
extern obj_t struct_object__object_env_209___object;
DEFINE_STRING(string1722_inline_inline, string1722_inline_inline1747, " ---- kactor: ", 14);
DEFINE_STRING(string1729_inline_inline, string1729_inline_inline1748, "*** inlining global variable: ", 30);
DEFINE_STATIC_PROCEDURE(inline_node_default1310_env_225_inline_inline, _inline_node_default1310_201_inline_inline1749, _inline_node_default1310_201_inline_inline, 0L, 3);
extern obj_t object__struct_env_210___object;
DEFINE_STRING(string1724_inline_inline, string1724_inline_inline1750, "'s body", 7);
DEFINE_STATIC_PROCEDURE(allocate_isfun_env_181_inline_inline, _allocate_isfun_106_inline_inline1751, _allocate_isfun_106_inline_inline, 0L, 0);
DEFINE_EXPORT_GENERIC(inline_node_env_12_inline_inline, _inline_node_166_inline_inline1752, _inline_node_166_inline_inline, 0L, 3);
DEFINE_STRING(string1732_inline_inline, string1732_inline_inline1753, "ISFUN DONE READ STATIC INLINE-NODE-DEFAULT1310 INLINE ", 54);

obj_t 
module_initialization_70_inline_inline(long checksum_1637, char *from_1638)
{
   if (CBOOL(require_initialization_114_inline_inline))
     {
	require_initialization_114_inline_inline = BBOOL(((bool_t) 0));
	library_modules_init_112_inline_inline();
	cnst_init_137_inline_inline();
	object_init_111_inline_inline();
	imported_modules_init_94_inline_inline();
	toplevel_init_63_inline_inline();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_inline_inline()
{
   module_initialization_70___object(((long) 0), "INLINE_INLINE");
   module_initialization_70___reader(((long) 0), "INLINE_INLINE");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_INLINE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_inline_inline()
{
   {
      obj_t cnst_port_138_1629;
      cnst_port_138_1629 = open_input_string(string1732_inline_inline);
      {
	 long i_1630;
	 i_1630 = ((long) 5);
       loop_1631:
	 {
	    bool_t test1733_1632;
	    test1733_1632 = (i_1630 == ((long) -1));
	    if (test1733_1632)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1734_1633;
		    {
		       obj_t list1735_1634;
		       {
			  obj_t arg1736_1635;
			  arg1736_1635 = BNIL;
			  list1735_1634 = MAKE_PAIR(cnst_port_138_1629, arg1736_1635);
		       }
		       arg1734_1633 = read___reader(list1735_1634);
		    }
		    CNST_TABLE_SET(i_1630, arg1734_1633);
		 }
		 {
		    int aux_1636;
		    {
		       long aux_1656;
		       aux_1656 = (i_1630 - ((long) 1));
		       aux_1636 = (int) (aux_1656);
		    }
		    {
		       long i_1659;
		       i_1659 = (long) (aux_1636);
		       i_1630 = i_1659;
		       goto loop_1631;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_inline_inline()
{
   add_generic__110___object(inline_node_env_12_inline_inline, inline_node_default1310_env_225_inline_inline);
   add_inlined_method__244___object(inline_node_env_12_inline_inline, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, var_ast_node, ((long) 1));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, kwote_ast_node, ((long) 2));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, sequence_ast_node, ((long) 3));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, app_ast_node, ((long) 4));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, setq_ast_node, ((long) 9));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, conditional_ast_node, ((long) 10));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, fail_ast_node, ((long) 11));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, select_ast_node, ((long) 12));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, let_fun_218_ast_node, ((long) 13));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, let_var_6_ast_node, ((long) 14));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, set_ex_it_116_ast_node, ((long) 15));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, jump_ex_it_184_ast_node, ((long) 16));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, make_box_202_ast_node, ((long) 17));
   add_inlined_method__244___object(inline_node_env_12_inline_inline, box_ref_242_ast_node, ((long) 18));
   {
      long aux_1681;
      aux_1681 = add_inlined_method__244___object(inline_node_env_12_inline_inline, box_set__221_ast_node, ((long) 19));
      return BINT(aux_1681);
   }
}


obj_t 
inline_sfun__229_inline_inline(variable_t variable_1, long kfactor_2, obj_t stack_3)
{
   {
      bool_t test1335_756;
      {
	 obj_t aux_1684;
	 aux_1684 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1335_756 = CBOOL(aux_1684);
      }
      if (test1335_756)
	{
	   obj_t arg1339_758;
	   arg1339_758 = shape_tools_shape((obj_t) (variable_1));
	   {
	      obj_t list1341_760;
	      {
		 obj_t arg1342_761;
		 {
		    obj_t arg1343_762;
		    {
		       obj_t arg1345_763;
		       {
			  obj_t arg1346_764;
			  {
			     obj_t aux_1692;
			     aux_1692 = BCHAR(((unsigned char) '\n'));
			     arg1346_764 = MAKE_PAIR(aux_1692, BNIL);
			  }
			  {
			     obj_t aux_1695;
			     aux_1695 = BINT(kfactor_2);
			     arg1345_763 = MAKE_PAIR(aux_1695, arg1346_764);
			  }
		       }
		       arg1343_762 = MAKE_PAIR(string1722_inline_inline, arg1345_763);
		    }
		    arg1342_761 = MAKE_PAIR(arg1339_758, arg1343_762);
		 }
		 list1341_760 = MAKE_PAIR(string1723_inline_inline, arg1342_761);
	      }
	      print_trace_107_tools_trace(list1341_760);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      value_t sfun_768;
      sfun_768 = (((variable_t) CREF(variable_1))->value);
      {
	 obj_t isfun_769;
	 {
	    bool_t test1404_804;
	    test1404_804 = is_a__118___object(sfun__env_206_inline_inline, isfun_inline_inline);
	    if (test1404_804)
	      {
		 isfun_769 = (obj_t) (sfun_768);
	      }
	    else
	      {
		 isfun_t obj1295_805;
		 obj1295_805 = ((isfun_t) (sfun_768));
		 {
		    isfun_t arg1406_806;
		    {
		       isfun_t res1693_1351;
		       {
			  node_t original_body_40_1346;
			  {
			     obj_t aux_1707;
			     {
				sfun_t obj_1345;
				obj_1345 = (sfun_t) (sfun_768);
				aux_1707 = (((sfun_t) CREF(obj_1345))->body);
			     }
			     original_body_40_1346 = (node_t) (aux_1707);
			  }
			  {
			     isfun_t new1273_1348;
			     new1273_1348 = ((isfun_t) BREF(GC_MALLOC(sizeof(struct isfun))));
			     ((((isfun_t) CREF(new1273_1348))->original_body_40) = ((node_t) original_body_40_1346), BUNSPEC);
			     ((((isfun_t) CREF(new1273_1348))->recursive_calls_44) = ((obj_t) BUNSPEC), BUNSPEC);
			     res1693_1351 = new1273_1348;
			  }
		       }
		       arg1406_806 = res1693_1351;
		    }
		    {
		       obj_t aux_1716;
		       object_t aux_1714;
		       aux_1716 = (obj_t) (arg1406_806);
		       aux_1714 = (object_t) (obj1295_805);
		       OBJECT_WIDENING_SET(aux_1714, aux_1716);
		    }
		 }
		 {
		    long arg1410_808;
		    arg1410_808 = class_num_218___object(isfun_inline_inline);
		    {
		       obj_t obj_1352;
		       obj_1352 = (obj_t) (obj1295_805);
		       (((obj_t) CREF(obj_1352))->header = MAKE_HEADER(arg1410_808, 0), BUNSPEC);
		    }
		 }
		 isfun_769 = (obj_t) (obj1295_805);
	      }
	 }
	 {
	    node_t o_body_107_770;
	    {
	       isfun_t obj_1354;
	       obj_1354 = (isfun_t) (isfun_769);
	       {
		  obj_t aux_1724;
		  {
		     object_t aux_1725;
		     aux_1725 = (object_t) (obj_1354);
		     aux_1724 = OBJECT_WIDENING(aux_1725);
		  }
		  o_body_107_770 = (((isfun_t) CREF(aux_1724))->original_body_40);
	       }
	    }
	    {
	       node_t inl_body_109_771;
	       {
		  bool_t test1368_785;
		  {
		     long arg1396_799;
		     {
			long aux_1729;
			{
			   obj_t aux_1730;
			   {
			      sfun_t obj_1355;
			      obj_1355 = (sfun_t) (sfun_768);
			      aux_1730 = (((sfun_t) CREF(obj_1355))->args);
			   }
			   aux_1729 = list_length(aux_1730);
			}
			arg1396_799 = (((long) 1) + aux_1729);
		     }
		     test1368_785 = inline_app__99_inline_app(variable_1, (long) CINT(__kfactor__149_inline_walk), arg1396_799, BNIL);
		  }
		  if (test1368_785)
		    {
		       {
			  bool_t test1369_786;
			  {
			     obj_t aux_1738;
			     aux_1738 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
			     test1369_786 = CBOOL(aux_1738);
			  }
			  if (test1369_786)
			    {
			       obj_t arg1372_788;
			       arg1372_788 = shape_tools_shape((obj_t) (variable_1));
			       {
				  obj_t list1377_790;
				  {
				     obj_t arg1379_791;
				     {
					obj_t arg1380_792;
					{
					   obj_t arg1381_793;
					   {
					      obj_t aux_1746;
					      aux_1746 = BCHAR(((unsigned char) '\n'));
					      arg1381_793 = MAKE_PAIR(aux_1746, BNIL);
					   }
					   arg1380_792 = MAKE_PAIR(string1724_inline_inline, arg1381_793);
					}
					arg1379_791 = MAKE_PAIR(arg1372_788, arg1380_792);
				     }
				     list1377_790 = MAKE_PAIR(string1725_inline_inline, arg1379_791);
				  }
				  print_trace_107_tools_trace(list1377_790);
			       }
			    }
			  else
			    {
			       BUNSPEC;
			    }
		       }
		       inl_body_109_771 = alphatize_ast_alphatize(BNIL, BNIL, BFALSE, o_body_107_770);
		    }
		  else
		    {
		       inl_body_109_771 = o_body_107_770;
		    }
	       }
	       {
		  {
		     node_t arg1352_772;
		     {
			obj_t arg1353_773;
			{
			   obj_t aux_1754;
			   aux_1754 = (obj_t) (variable_1);
			   arg1353_773 = MAKE_PAIR(aux_1754, stack_3);
			}
			arg1352_772 = inline_node_218_inline_inline(inl_body_109_771, kfactor_2, arg1353_773);
		     }
		     {
			obj_t res1694_1362;
			{
			   sfun_t obj_1360;
			   obj_t val1078_1361;
			   obj_1360 = (sfun_t) (sfun_768);
			   val1078_1361 = (obj_t) (arg1352_772);
			   {
			      obj_t x_1608;
			      x_1608 = ((((sfun_t) CREF(obj_1360))->body) = ((obj_t) val1078_1361), BUNSPEC);
			      res1694_1362 = BUNSPEC;
			   }
			}
			res1694_1362;
		     }
		  }
		  {
		     bool_t test1354_774;
		     {
			obj_t aux_1761;
			aux_1761 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
			test1354_774 = CBOOL(aux_1761);
		     }
		     if (test1354_774)
		       {
			  obj_t arg1356_776;
			  arg1356_776 = shape_tools_shape((obj_t) (variable_1));
			  {
			     obj_t list1358_778;
			     {
				obj_t arg1359_779;
				{
				   obj_t arg1361_780;
				   {
				      obj_t arg1363_781;
				      {
					 obj_t aux_1769;
					 aux_1769 = BCHAR(((unsigned char) '\n'));
					 arg1363_781 = MAKE_PAIR(aux_1769, BNIL);
				      }
				      arg1361_780 = MAKE_PAIR(string1726_inline_inline, arg1363_781);
				   }
				   arg1359_779 = MAKE_PAIR(arg1356_776, arg1361_780);
				}
				list1358_778 = MAKE_PAIR(string1727_inline_inline, arg1359_779);
			     }
			     return print_trace_107_tools_trace(list1358_778);
			  }
		       }
		     else
		       {
			  return BUNSPEC;
		       }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_inline_sfun__45_inline_inline(obj_t env_1589, obj_t variable_1590, obj_t kfactor_1591, obj_t stack_1592)
{
   return inline_sfun__229_inline_inline((variable_t) (variable_1590), (long) CINT(kfactor_1591), stack_1592);
}


node_t 
inline_node_default1310_14_inline_inline(node_t node_7, long kfactor_8, obj_t stack_9)
{
   FAILURE(CNST_TABLE_REF(((long) 1)), string1728_inline_inline, (obj_t) (node_7));
}


obj_t 
_inline_node_default1310_201_inline_inline(obj_t env_1585, obj_t node_1586, obj_t kfactor_1587, obj_t stack_1588)
{
   {
      node_t aux_1782;
      aux_1782 = inline_node_default1310_14_inline_inline((node_t) (node_1586), (long) CINT(kfactor_1587), stack_1588);
      return (obj_t) (aux_1782);
   }
}


node_t 
inline_node_218_inline_inline(node_t node_4, long kfactor_5, obj_t stack_6)
{
   {
      obj_t method1561_1170;
      obj_t class1566_1171;
      {
	 obj_t arg1570_1168;
	 obj_t arg1571_1169;
	 {
	    object_t obj_1368;
	    obj_1368 = (object_t) (node_4);
	    {
	       obj_t pre_method_105_1369;
	       pre_method_105_1369 = PROCEDURE_REF(inline_node_env_12_inline_inline, ((long) 2));
	       if (INTEGERP(pre_method_105_1369))
		 {
		    PROCEDURE_SET(inline_node_env_12_inline_inline, ((long) 2), BUNSPEC);
		    arg1570_1168 = pre_method_105_1369;
		 }
	       else
		 {
		    long obj_class_num_177_1374;
		    obj_class_num_177_1374 = TYPE(obj_1368);
		    {
		       obj_t arg1183_1375;
		       arg1183_1375 = PROCEDURE_REF(inline_node_env_12_inline_inline, ((long) 1));
		       {
			  long arg1184_1379;
			  {
			     long arg1186_1380;
			     arg1186_1380 = OBJECT_TYPE;
			     arg1184_1379 = (obj_class_num_177_1374 - arg1186_1380);
			  }
			  arg1570_1168 = VECTOR_REF(arg1183_1375, arg1184_1379);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1385;
	    object_1385 = (object_t) (node_4);
	    {
	       long arg1187_1386;
	       {
		  long arg1188_1387;
		  long arg1189_1388;
		  arg1188_1387 = TYPE(object_1385);
		  arg1189_1388 = OBJECT_TYPE;
		  arg1187_1386 = (arg1188_1387 - arg1189_1388);
	       }
	       {
		  obj_t vector_1392;
		  vector_1392 = __classes__134___object;
		  arg1571_1169 = VECTOR_REF(vector_1392, arg1187_1386);
	       }
	    }
	 }
	 {
	    obj_t aux_1802;
	    method1561_1170 = arg1570_1168;
	    class1566_1171 = arg1571_1169;
	    {
	       if (INTEGERP(method1561_1170))
		 {
		    switch ((long) CINT(method1561_1170))
		      {
		      case ((long) 0):
			 {
			    atom_t aux_1805;
			    aux_1805 = (atom_t) (node_4);
			    aux_1802 = (obj_t) (aux_1805);
			 }
			 break;
		      case ((long) 1):
			 {
			    var_t node_1180;
			    node_1180 = (var_t) (node_4);
			    {
			       bool_t test1574_1184;
			       {
				  bool_t test1589_1196;
				  {
				     long n1_1394;
				     n1_1394 = (long) CINT(__optim__89_engine_param);
				     test1589_1196 = (n1_1394 > ((long) 0));
				  }
				  if (test1589_1196)
				    {
				       bool_t test1590_1197;
				       {
					  obj_t aux_1812;
					  {
					     variable_t aux_1813;
					     aux_1813 = (((var_t) CREF(node_1180))->variable);
					     aux_1812 = (obj_t) (aux_1813);
					  }
					  test1590_1197 = is_a__118___object(aux_1812, global_ast_var);
				       }
				       if (test1590_1197)
					 {
					    bool_t test_1818;
					    {
					       obj_t aux_1824;
					       obj_t aux_1819;
					       aux_1824 = CNST_TABLE_REF(((long) 2));
					       {
						  global_t obj_1399;
						  {
						     variable_t aux_1820;
						     aux_1820 = (((var_t) CREF(node_1180))->variable);
						     obj_1399 = (global_t) (aux_1820);
						  }
						  aux_1819 = (((global_t) CREF(obj_1399))->import);
					       }
					       test_1818 = (aux_1819 == aux_1824);
					    }
					    if (test_1818)
					      {
						 bool_t test_1827;
						 {
						    obj_t aux_1833;
						    obj_t aux_1828;
						    aux_1833 = CNST_TABLE_REF(((long) 3));
						    {
						       global_t obj_1403;
						       {
							  variable_t aux_1829;
							  aux_1829 = (((var_t) CREF(node_1180))->variable);
							  obj_1403 = (global_t) (aux_1829);
						       }
						       aux_1828 = (((global_t) CREF(obj_1403))->access);
						    }
						    test_1827 = (aux_1828 == aux_1833);
						 }
						 if (test_1827)
						   {
						      obj_t aux_1836;
						      {
							 global_t obj_1407;
							 {
							    variable_t aux_1837;
							    aux_1837 = (((var_t) CREF(node_1180))->variable);
							    obj_1407 = (global_t) (aux_1837);
							 }
							 aux_1836 = (((global_t) CREF(obj_1407))->src);
						      }
						      test1574_1184 = is_a__118___object(aux_1836, atom_ast_node);
						   }
						 else
						   {
						      test1574_1184 = ((bool_t) 0);
						   }
					      }
					    else
					      {
						 test1574_1184 = ((bool_t) 0);
					      }
					 }
				       else
					 {
					    test1574_1184 = ((bool_t) 0);
					 }
				    }
				  else
				    {
				       test1574_1184 = ((bool_t) 0);
				    }
			       }
			       if (test1574_1184)
				 {
				    {
				       bool_t test1575_1185;
				       {
					  obj_t aux_1843;
					  aux_1843 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
					  test1575_1185 = CBOOL(aux_1843);
				       }
				       if (test1575_1185)
					 {
					    obj_t arg1577_1187;
					    {
					       obj_t aux_1849;
					       {
						  variable_t aux_1850;
						  aux_1850 = (((var_t) CREF(node_1180))->variable);
						  aux_1849 = (obj_t) (aux_1850);
					       }
					       arg1577_1187 = shape_tools_shape(aux_1849);
					    }
					    {
					       obj_t list1578_1188;
					       {
						  obj_t arg1579_1189;
						  {
						     obj_t arg1582_1190;
						     {
							obj_t aux_1854;
							aux_1854 = BCHAR(((unsigned char) '\n'));
							arg1582_1190 = MAKE_PAIR(aux_1854, BNIL);
						     }
						     arg1579_1189 = MAKE_PAIR(arg1577_1187, arg1582_1190);
						  }
						  list1578_1188 = MAKE_PAIR(string1729_inline_inline, arg1579_1189);
					       }
					       print_trace_107_tools_trace(list1578_1188);
					    }
					 }
				       else
					 {
					    BUNSPEC;
					 }
				    }
				    {
				       global_t obj_1411;
				       {
					  variable_t aux_1860;
					  aux_1860 = (((var_t) CREF(node_1180))->variable);
					  obj_1411 = (global_t) (aux_1860);
				       }
				       aux_1802 = (((global_t) CREF(obj_1411))->src);
				    }
				 }
			       else
				 {
				    aux_1802 = (obj_t) (node_1180);
				 }
			    }
			 }
			 break;
		      case ((long) 2):
			 {
			    kwote_t aux_1865;
			    aux_1865 = (kwote_t) (node_4);
			    aux_1802 = (obj_t) (aux_1865);
			 }
			 break;
		      case ((long) 3):
			 {
			    sequence_t node_1212;
			    node_1212 = (sequence_t) (node_4);
			    inline_node___77_inline_inline((((sequence_t) CREF(node_1212))->nodes), kfactor_5, stack_6);
			    aux_1802 = (obj_t) (node_1212);
			 }
			 break;
		      case ((long) 4):
			 {
			    app_t node_1216;
			    node_1216 = (app_t) (node_4);
			    inline_node___77_inline_inline((((app_t) CREF(node_1216))->args), kfactor_5, stack_6);
			    {
			       node_t aux_1875;
			       aux_1875 = inline_app_72_inline_app(node_1216, kfactor_5, stack_6);
			       aux_1802 = (obj_t) (aux_1875);
			    }
			 }
			 break;
		      case ((long) 5):
			 {
			    app_ly_162_t node_1220;
			    node_1220 = (app_ly_162_t) (node_4);
			    {
			       node_t arg1609_1224;
			       arg1609_1224 = inline_node_218_inline_inline((((app_ly_162_t) CREF(node_1220))->fun), kfactor_5, stack_6);
			       {
				  obj_t res1695_1417;
				  {
				     obj_t x_1609;
				     x_1609 = ((((app_ly_162_t) CREF(node_1220))->fun) = ((node_t) arg1609_1224), BUNSPEC);
				     res1695_1417 = BUNSPEC;
				  }
				  res1695_1417;
			       }
			    }
			    {
			       node_t arg1614_1226;
			       arg1614_1226 = inline_node_218_inline_inline((((app_ly_162_t) CREF(node_1220))->arg), kfactor_5, stack_6);
			       {
				  obj_t res1696_1421;
				  {
				     obj_t x_1610;
				     x_1610 = ((((app_ly_162_t) CREF(node_1220))->arg) = ((node_t) arg1614_1226), BUNSPEC);
				     res1696_1421 = BUNSPEC;
				  }
				  res1696_1421;
			       }
			    }
			    aux_1802 = (obj_t) (node_1220);
			 }
			 break;
		      case ((long) 6):
			 {
			    funcall_t node_1228;
			    node_1228 = (funcall_t) (node_4);
			    {
			       long z1_1422;
			       z1_1422 = (long) CINT(__non_inlined_calls__201_inline_walk);
			       {
				  long aux_1888;
				  aux_1888 = (z1_1422 + ((long) 1));
				  __non_inlined_calls__201_inline_walk = BINT(aux_1888);
			       }
			    }
			    {
			       node_t arg1617_1231;
			       arg1617_1231 = inline_node_218_inline_inline((((funcall_t) CREF(node_1228))->fun), kfactor_5, stack_6);
			       {
				  obj_t res1697_1427;
				  {
				     obj_t x_1611;
				     x_1611 = ((((funcall_t) CREF(node_1228))->fun) = ((node_t) arg1617_1231), BUNSPEC);
				     res1697_1427 = BUNSPEC;
				  }
				  res1697_1427;
			       }
			    }
			    inline_node___77_inline_inline((((funcall_t) CREF(node_1228))->args), kfactor_5, stack_6);
			    aux_1802 = (obj_t) (node_1228);
			 }
			 break;
		      case ((long) 7):
			 {
			    pragma_t node_1234;
			    node_1234 = (pragma_t) (node_4);
			    inline_node___77_inline_inline((((pragma_t) CREF(node_1234))->args), kfactor_5, stack_6);
			    aux_1802 = (obj_t) (node_1234);
			 }
			 break;
		      case ((long) 8):
			 {
			    cast_t node_1238;
			    node_1238 = (cast_t) (node_4);
			    inline_node_218_inline_inline((((cast_t) CREF(node_1238))->arg), kfactor_5, stack_6);
			    aux_1802 = (obj_t) (node_1238);
			 }
			 break;
		      case ((long) 9):
			 {
			    setq_t node_1242;
			    node_1242 = (setq_t) (node_4);
			    {
			       node_t arg1623_1245;
			       arg1623_1245 = inline_node_218_inline_inline((((setq_t) CREF(node_1242))->value), kfactor_5, stack_6);
			       {
				  obj_t res1698_1434;
				  {
				     obj_t x_1612;
				     x_1612 = ((((setq_t) CREF(node_1242))->value) = ((node_t) arg1623_1245), BUNSPEC);
				     res1698_1434 = BUNSPEC;
				  }
				  res1698_1434;
			       }
			    }
			    aux_1802 = (obj_t) (node_1242);
			 }
			 break;
		      case ((long) 10):
			 {
			    conditional_t node_1247;
			    node_1247 = (conditional_t) (node_4);
			    {
			       node_t arg1626_1251;
			       arg1626_1251 = inline_node_218_inline_inline((((conditional_t) CREF(node_1247))->test), kfactor_5, stack_6);
			       {
				  obj_t res1699_1438;
				  {
				     obj_t x_1613;
				     x_1613 = ((((conditional_t) CREF(node_1247))->test) = ((node_t) arg1626_1251), BUNSPEC);
				     res1699_1438 = BUNSPEC;
				  }
				  res1699_1438;
			       }
			    }
			    {
			       node_t arg1628_1253;
			       arg1628_1253 = inline_node_218_inline_inline((((conditional_t) CREF(node_1247))->true), kfactor_5, stack_6);
			       {
				  obj_t res1700_1442;
				  {
				     obj_t x_1614;
				     x_1614 = ((((conditional_t) CREF(node_1247))->true) = ((node_t) arg1628_1253), BUNSPEC);
				     res1700_1442 = BUNSPEC;
				  }
				  res1700_1442;
			       }
			    }
			    {
			       node_t arg1632_1255;
			       arg1632_1255 = inline_node_218_inline_inline((((conditional_t) CREF(node_1247))->false), kfactor_5, stack_6);
			       {
				  obj_t res1701_1446;
				  {
				     obj_t x_1615;
				     x_1615 = ((((conditional_t) CREF(node_1247))->false) = ((node_t) arg1632_1255), BUNSPEC);
				     res1701_1446 = BUNSPEC;
				  }
				  res1701_1446;
			       }
			    }
			    aux_1802 = (obj_t) (node_1247);
			 }
			 break;
		      case ((long) 11):
			 {
			    fail_t node_1257;
			    node_1257 = (fail_t) (node_4);
			    {
			       node_t arg1637_1261;
			       arg1637_1261 = inline_node_218_inline_inline((((fail_t) CREF(node_1257))->proc), kfactor_5, stack_6);
			       {
				  obj_t res1702_1450;
				  {
				     obj_t x_1616;
				     x_1616 = ((((fail_t) CREF(node_1257))->proc) = ((node_t) arg1637_1261), BUNSPEC);
				     res1702_1450 = BUNSPEC;
				  }
				  res1702_1450;
			       }
			    }
			    {
			       node_t arg1641_1263;
			       arg1641_1263 = inline_node_218_inline_inline((((fail_t) CREF(node_1257))->msg), kfactor_5, stack_6);
			       {
				  obj_t res1703_1454;
				  {
				     obj_t x_1617;
				     x_1617 = ((((fail_t) CREF(node_1257))->msg) = ((node_t) arg1641_1263), BUNSPEC);
				     res1703_1454 = BUNSPEC;
				  }
				  res1703_1454;
			       }
			    }
			    {
			       node_t arg1643_1265;
			       arg1643_1265 = inline_node_218_inline_inline((((fail_t) CREF(node_1257))->obj), kfactor_5, stack_6);
			       {
				  obj_t res1704_1458;
				  {
				     obj_t x_1618;
				     x_1618 = ((((fail_t) CREF(node_1257))->obj) = ((node_t) arg1643_1265), BUNSPEC);
				     res1704_1458 = BUNSPEC;
				  }
				  res1704_1458;
			       }
			    }
			    aux_1802 = (obj_t) (node_1257);
			 }
			 break;
		      case ((long) 12):
			 {
			    select_t node_1267;
			    node_1267 = (select_t) (node_4);
			    {
			       node_t arg1645_1270;
			       arg1645_1270 = inline_node_218_inline_inline((((select_t) CREF(node_1267))->test), kfactor_5, stack_6);
			       {
				  obj_t res1705_1462;
				  {
				     obj_t x_1619;
				     x_1619 = ((((select_t) CREF(node_1267))->test) = ((node_t) arg1645_1270), BUNSPEC);
				     res1705_1462 = BUNSPEC;
				  }
				  res1705_1462;
			       }
			    }
			    {
			       obj_t l1300_1272;
			       l1300_1272 = (((select_t) CREF(node_1267))->clauses);
			     lname1301_1273:
			       if (PAIRP(l1300_1272))
				 {
				    {
				       obj_t clause_1276;
				       clause_1276 = CAR(l1300_1272);
				       {
					  node_t arg1650_1277;
					  {
					     node_t aux_1939;
					     {
						obj_t aux_1940;
						aux_1940 = CDR(clause_1276);
						aux_1939 = (node_t) (aux_1940);
					     }
					     arg1650_1277 = inline_node_218_inline_inline(aux_1939, kfactor_5, stack_6);
					  }
					  {
					     obj_t aux_1944;
					     aux_1944 = (obj_t) (arg1650_1277);
					     SET_CDR(clause_1276, aux_1944);
					  }
				       }
				    }
				    {
				       obj_t l1300_1947;
				       l1300_1947 = CDR(l1300_1272);
				       l1300_1272 = l1300_1947;
				       goto lname1301_1273;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_1802 = (obj_t) (node_1267);
			 }
			 break;
		      case ((long) 13):
			 {
			    let_fun_218_t node_1280;
			    node_1280 = (let_fun_218_t) (node_4);
			    {
			       node_t arg1653_1283;
			       arg1653_1283 = inline_node_218_inline_inline((((let_fun_218_t) CREF(node_1280))->body), kfactor_5, stack_6);
			       {
				  obj_t res1706_1473;
				  {
				     obj_t x_1620;
				     x_1620 = ((((let_fun_218_t) CREF(node_1280))->body) = ((node_t) arg1653_1283), BUNSPEC);
				     res1706_1473 = BUNSPEC;
				  }
				  res1706_1473;
			       }
			    }
			    {
			       obj_t l1302_1285;
			       l1302_1285 = (((let_fun_218_t) CREF(node_1280))->locals);
			     lname1304_1286:
			       if (PAIRP(l1302_1285))
				 {
				    {
				       variable_t aux_1957;
				       {
					  obj_t aux_1958;
					  aux_1958 = CAR(l1302_1285);
					  aux_1957 = (variable_t) (aux_1958);
				       }
				       inline_sfun__229_inline_inline(aux_1957, kfactor_5, stack_6);
				    }
				    {
				       obj_t l1302_1962;
				       l1302_1962 = CDR(l1302_1285);
				       l1302_1285 = l1302_1962;
				       goto lname1304_1286;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_1802 = (obj_t) (node_1280);
			 }
			 break;
		      case ((long) 14):
			 {
			    let_var_6_t node_1291;
			    node_1291 = (let_var_6_t) (node_4);
			    {
			       obj_t l1305_1294;
			       l1305_1294 = (((let_var_6_t) CREF(node_1291))->bindings);
			     lname1307_1295:
			       if (PAIRP(l1305_1294))
				 {
				    {
				       obj_t binding_1298;
				       binding_1298 = CAR(l1305_1294);
				       {
					  node_t arg1661_1299;
					  {
					     node_t aux_1970;
					     {
						obj_t aux_1971;
						aux_1971 = CDR(binding_1298);
						aux_1970 = (node_t) (aux_1971);
					     }
					     arg1661_1299 = inline_node_218_inline_inline(aux_1970, kfactor_5, stack_6);
					  }
					  {
					     obj_t aux_1975;
					     aux_1975 = (obj_t) (arg1661_1299);
					     SET_CDR(binding_1298, aux_1975);
					  }
				       }
				    }
				    {
				       obj_t l1305_1978;
				       l1305_1978 = CDR(l1305_1294);
				       l1305_1294 = l1305_1978;
				       goto lname1307_1295;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1665_1302;
			       arg1665_1302 = inline_node_218_inline_inline((((let_var_6_t) CREF(node_1291))->body), kfactor_5, stack_6);
			       {
				  obj_t res1707_1488;
				  {
				     obj_t x_1621;
				     x_1621 = ((((let_var_6_t) CREF(node_1291))->body) = ((node_t) arg1665_1302), BUNSPEC);
				     res1707_1488 = BUNSPEC;
				  }
				  res1707_1488;
			       }
			    }
			    aux_1802 = (obj_t) (node_1291);
			 }
			 break;
		      case ((long) 15):
			 {
			    set_ex_it_116_t node_1304;
			    node_1304 = (set_ex_it_116_t) (node_4);
			    {
			       node_t arg1668_1307;
			       arg1668_1307 = inline_node_218_inline_inline((((set_ex_it_116_t) CREF(node_1304))->body), kfactor_5, stack_6);
			       {
				  obj_t res1708_1492;
				  {
				     obj_t x_1622;
				     x_1622 = ((((set_ex_it_116_t) CREF(node_1304))->body) = ((node_t) arg1668_1307), BUNSPEC);
				     res1708_1492 = BUNSPEC;
				  }
				  res1708_1492;
			       }
			    }
			    aux_1802 = (obj_t) (node_1304);
			 }
			 break;
		      case ((long) 16):
			 {
			    jump_ex_it_184_t node_1309;
			    node_1309 = (jump_ex_it_184_t) (node_4);
			    {
			       node_t arg1671_1313;
			       arg1671_1313 = inline_node_218_inline_inline((((jump_ex_it_184_t) CREF(node_1309))->exit), kfactor_5, stack_6);
			       {
				  obj_t res1709_1496;
				  {
				     obj_t x_1623;
				     x_1623 = ((((jump_ex_it_184_t) CREF(node_1309))->exit) = ((node_t) arg1671_1313), BUNSPEC);
				     res1709_1496 = BUNSPEC;
				  }
				  res1709_1496;
			       }
			    }
			    {
			       node_t arg1674_1315;
			       arg1674_1315 = inline_node_218_inline_inline((((jump_ex_it_184_t) CREF(node_1309))->value), kfactor_5, stack_6);
			       {
				  obj_t res1710_1500;
				  {
				     obj_t x_1624;
				     x_1624 = ((((jump_ex_it_184_t) CREF(node_1309))->value) = ((node_t) arg1674_1315), BUNSPEC);
				     res1710_1500 = BUNSPEC;
				  }
				  res1710_1500;
			       }
			    }
			    aux_1802 = (obj_t) (node_1309);
			 }
			 break;
		      case ((long) 17):
			 {
			    make_box_202_t node_1317;
			    node_1317 = (make_box_202_t) (node_4);
			    {
			       node_t arg1678_1320;
			       arg1678_1320 = inline_node_218_inline_inline((((make_box_202_t) CREF(node_1317))->value), kfactor_5, stack_6);
			       {
				  obj_t res1711_1504;
				  {
				     obj_t x_1625;
				     x_1625 = ((((make_box_202_t) CREF(node_1317))->value) = ((node_t) arg1678_1320), BUNSPEC);
				     res1711_1504 = BUNSPEC;
				  }
				  res1711_1504;
			       }
			    }
			    aux_1802 = (obj_t) (node_1317);
			 }
			 break;
		      case ((long) 18):
			 {
			    box_ref_242_t node_1322;
			    node_1322 = (box_ref_242_t) (node_4);
			    {
			       node_t arg1680_1325;
			       {
				  node_t aux_2004;
				  {
				     var_t aux_2005;
				     aux_2005 = (((box_ref_242_t) CREF(node_1322))->var);
				     aux_2004 = (node_t) (aux_2005);
				  }
				  arg1680_1325 = inline_node_218_inline_inline(aux_2004, kfactor_5, stack_6);
			       }
			       {
				  obj_t res1712_1508;
				  {
				     var_t val1263_1507;
				     val1263_1507 = (var_t) (arg1680_1325);
				     {
					obj_t x_1626;
					x_1626 = ((((box_ref_242_t) CREF(node_1322))->var) = ((var_t) val1263_1507), BUNSPEC);
					res1712_1508 = BUNSPEC;
				     }
				  }
				  res1712_1508;
			       }
			    }
			    aux_1802 = (obj_t) (node_1322);
			 }
			 break;
		      case ((long) 19):
			 {
			    box_set__221_t node_1327;
			    node_1327 = (box_set__221_t) (node_4);
			    {
			       node_t arg1682_1331;
			       {
				  node_t aux_2013;
				  {
				     var_t aux_2014;
				     aux_2014 = (((box_set__221_t) CREF(node_1327))->var);
				     aux_2013 = (node_t) (aux_2014);
				  }
				  arg1682_1331 = inline_node_218_inline_inline(aux_2013, kfactor_5, stack_6);
			       }
			       {
				  obj_t res1713_1512;
				  {
				     var_t val1269_1511;
				     val1269_1511 = (var_t) (arg1682_1331);
				     {
					obj_t x_1627;
					x_1627 = ((((box_set__221_t) CREF(node_1327))->var) = ((var_t) val1269_1511), BUNSPEC);
					res1713_1512 = BUNSPEC;
				     }
				  }
				  res1713_1512;
			       }
			    }
			    {
			       node_t arg1686_1333;
			       arg1686_1333 = inline_node_218_inline_inline((((box_set__221_t) CREF(node_1327))->value), kfactor_5, stack_6);
			       {
				  obj_t res1714_1516;
				  {
				     obj_t x_1628;
				     x_1628 = ((((box_set__221_t) CREF(node_1327))->value) = ((node_t) arg1686_1333), BUNSPEC);
				     res1714_1516 = BUNSPEC;
				  }
				  res1714_1516;
			       }
			    }
			    aux_1802 = (obj_t) (node_1327);
			 }
			 break;
		      default:
		       case_else1567_15_1174:
			 if (PROCEDUREP(method1561_1170))
			   {
			      aux_1802 = PROCEDURE_ENTRY(method1561_1170) (method1561_1170, (obj_t) (node_4), BINT(kfactor_5), stack_6, BEOA);
			   }
			 else
			   {
			      obj_t fun1413_811;
			      fun1413_811 = PROCEDURE_REF(inline_node_env_12_inline_inline, ((long) 0));
			      aux_1802 = PROCEDURE_ENTRY(fun1413_811) (fun1413_811, (obj_t) (node_4), BINT(kfactor_5), stack_6, BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1567_15_1174;
		 }
	    }
	    return (node_t) (aux_1802);
	 }
      }
   }
}


obj_t 
_inline_node_166_inline_inline(obj_t env_1581, obj_t node_1582, obj_t kfactor_1583, obj_t stack_1584)
{
   {
      node_t aux_2038;
      aux_2038 = inline_node_218_inline_inline((node_t) (node_1582), (long) CINT(kfactor_1583), stack_1584);
      return (obj_t) (aux_2038);
   }
}


obj_t 
inline_node___77_inline_inline(obj_t node__221_70, long kfactor_71, obj_t stack_72)
{
 inline_node___77_inline_inline:
   if (NULLP(node__221_70))
     {
	return CNST_TABLE_REF(((long) 4));
     }
   else
     {
	{
	   node_t arg1415_813;
	   {
	      node_t aux_2046;
	      {
		 obj_t aux_2047;
		 aux_2047 = CAR(node__221_70);
		 aux_2046 = (node_t) (aux_2047);
	      }
	      arg1415_813 = inline_node_218_inline_inline(aux_2046, kfactor_71, stack_72);
	   }
	   {
	      obj_t aux_2051;
	      aux_2051 = (obj_t) (arg1415_813);
	      SET_CAR(node__221_70, aux_2051);
	   }
	}
	{
	   obj_t node__221_2054;
	   node__221_2054 = CDR(node__221_70);
	   node__221_70 = node__221_2054;
	   goto inline_node___77_inline_inline;
	}
     }
}


obj_t 
object_init_111_inline_inline()
{
   {
      obj_t arg1420_817;
      arg1420_817 = sfun_ast_var;
      isfun_inline_inline = add_class__117___object(CNST_TABLE_REF(((long) 5)), arg1420_817, allocate_isfun_env_181_inline_inline, ((long) 46743), BUNSPEC);
   }
   {
      obj_t object__struct_isfun_152_1599;
      object__struct_isfun_152_1599 = proc1730_inline_inline;
      add_method__1___object(object__struct_env_210___object, isfun_inline_inline, object__struct_isfun_152_1599);
   }
   {
      obj_t struct_object__object_isfun_164_1595;
      struct_object__object_isfun_164_1595 = proc1731_inline_inline;
      return add_method__1___object(struct_object__object_env_209___object, isfun_inline_inline, struct_object__object_isfun_164_1595);
   }
}


obj_t 
struct_object__object_isfun1720_132_inline_inline(obj_t env_1602, obj_t o_1603, obj_t s_1604)
{
   {
      isfun_t o_835;
      obj_t s_836;
      {
	 isfun_t aux_2060;
	 o_835 = (isfun_t) (o_1603);
	 s_836 = s_1604;
	 {
	    {
	       obj_t old1292_839;
	       obj_t aux1293_840;
	       {
		  obj_t next_method1334_28_846;
		  next_method1334_28_846 = find_super_class_method_167___object((object_t) (o_835), struct_object__object_env_209___object, isfun_inline_inline);
		  if (PROCEDUREP(next_method1334_28_846))
		    {
		       old1292_839 = PROCEDURE_ENTRY(next_method1334_28_846) (next_method1334_28_846, (obj_t) (o_835), s_836, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1334_28_846);
		       {
			  object_t aux_2069;
			  aux_2069 = struct_object__object_93___object((object_t) (o_835), s_836);
			  old1292_839 = (obj_t) (aux_2069);
		       }
		    }
	       }
	       aux1293_840 = STRUCT_REF(s_836, ((long) 0));
	       {
		  isfun_t new1294_841;
		  new1294_841 = ((isfun_t) (old1292_839));
		  {
		     long arg1446_842;
		     arg1446_842 = class_num_218___object(isfun_inline_inline);
		     {
			obj_t obj_1547;
			obj_1547 = (obj_t) (new1294_841);
			(((obj_t) CREF(obj_1547))->header = MAKE_HEADER(arg1446_842, 0), BUNSPEC);
		     }
		  }
		  {
		     isfun_t arg1447_843;
		     {
			obj_t arg1449_845;
			arg1449_845 = STRUCT_REF(aux1293_840, ((long) 1));
			{
			   isfun_t res1716_1558;
			   {
			      node_t original_body_40_1553;
			      {
				 obj_t aux_2079;
				 aux_2079 = STRUCT_REF(aux1293_840, ((long) 0));
				 original_body_40_1553 = (node_t) (aux_2079);
			      }
			      {
				 isfun_t new1273_1555;
				 new1273_1555 = ((isfun_t) BREF(GC_MALLOC(sizeof(struct isfun))));
				 ((((isfun_t) CREF(new1273_1555))->original_body_40) = ((node_t) original_body_40_1553), BUNSPEC);
				 ((((isfun_t) CREF(new1273_1555))->recursive_calls_44) = ((obj_t) arg1449_845), BUNSPEC);
				 res1716_1558 = new1273_1555;
			      }
			   }
			   arg1447_843 = res1716_1558;
			}
		     }
		     {
			obj_t aux_2087;
			object_t aux_2085;
			aux_2087 = (obj_t) (arg1447_843);
			aux_2085 = (object_t) (new1294_841);
			OBJECT_WIDENING_SET(aux_2085, aux_2087);
		     }
		  }
		  aux_2060 = new1294_841;
	       }
	    }
	 }
	 return (obj_t) (aux_2060);
      }
   }
}


obj_t 
object__struct_isfun1721_223_inline_inline(obj_t env_1605, obj_t obj1289_1606)
{
   {
      isfun_t obj1289_820;
      obj1289_820 = (isfun_t) (obj1289_1606);
      {
	 {
	    obj_t res1290_823;
	    {
	       obj_t next_method1333_48_833;
	       next_method1333_48_833 = find_super_class_method_167___object((object_t) (obj1289_820), object__struct_env_210___object, isfun_inline_inline);
	       if (PROCEDUREP(next_method1333_48_833))
		 {
		    res1290_823 = PROCEDURE_ENTRY(next_method1333_48_833) (next_method1333_48_833, (obj_t) (obj1289_820), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1333_48_833);
		    res1290_823 = object__struct_50___object((object_t) (obj1289_820));
		 }
	    }
	    {
	       obj_t aux1291_824;
	       {
		  obj_t aux_2102;
		  aux_2102 = CNST_TABLE_REF(((long) 5));
		  aux1291_824 = make_struct(aux_2102, ((long) 2), BUNSPEC);
	       }
	       {
		  obj_t aux_2105;
		  {
		     node_t aux_2106;
		     {
			obj_t aux_2107;
			{
			   object_t aux_2108;
			   aux_2108 = (object_t) (obj1289_820);
			   aux_2107 = OBJECT_WIDENING(aux_2108);
			}
			aux_2106 = (((isfun_t) CREF(aux_2107))->original_body_40);
		     }
		     aux_2105 = (obj_t) (aux_2106);
		  }
		  STRUCT_SET(aux1291_824, ((long) 0), aux_2105);
	       }
	       {
		  obj_t aux_2114;
		  {
		     obj_t aux_2115;
		     {
			object_t aux_2116;
			aux_2116 = (object_t) (obj1289_820);
			aux_2115 = OBJECT_WIDENING(aux_2116);
		     }
		     aux_2114 = (((isfun_t) CREF(aux_2115))->recursive_calls_44);
		  }
		  STRUCT_SET(aux1291_824, ((long) 1), aux_2114);
	       }
	       STRUCT_SET(res1290_823, ((long) 0), aux1291_824);
	       {
		  obj_t aux_2122;
		  aux_2122 = STRUCT_KEY(res1290_823);
		  STRUCT_KEY_SET(aux1291_824, aux_2122);
	       }
	       {
		  obj_t aux_2125;
		  aux_2125 = CNST_TABLE_REF(((long) 5));
		  STRUCT_KEY_SET(res1290_823, aux_2125);
	       }
	       return res1290_823;
	    }
	 }
      }
   }
}


sfun_t 
allocate_isfun_51_inline_inline()
{
   {
      sfun_t new1288_848;
      new1288_848 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
      {
	 long arg1452_849;
	 arg1452_849 = class_num_218___object(isfun_inline_inline);
	 {
	    obj_t obj_1561;
	    obj_1561 = (obj_t) (new1288_848);
	    (((obj_t) CREF(obj_1561))->header = MAKE_HEADER(arg1452_849, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2133;
	 aux_2133 = (object_t) (new1288_848);
	 OBJECT_WIDENING_SET(aux_2133, BFALSE);
      }
      return new1288_848;
   }
}


obj_t 
_allocate_isfun_106_inline_inline(obj_t env_1607)
{
   {
      sfun_t aux_2136;
      aux_2136 = allocate_isfun_51_inline_inline();
      return (obj_t) (aux_2136);
   }
}


bool_t 
sfun__199_inline_inline(obj_t obj_529)
{
   return is_a__118___object(obj_529, sfun_ast_var);
}


obj_t 
_sfun__63_inline_inline(obj_t env_1593, obj_t obj_1594)
{
   {
      bool_t aux_2140;
      aux_2140 = sfun__199_inline_inline(obj_1594);
      return BBOOL(aux_2140);
   }
}


obj_t 
imported_modules_init_94_inline_inline()
{
   module_initialization_70_type_type(((long) 0), "INLINE_INLINE");
   module_initialization_70_ast_var(((long) 0), "INLINE_INLINE");
   module_initialization_70_ast_node(((long) 0), "INLINE_INLINE");
   module_initialization_70_tools_trace(((long) 0), "INLINE_INLINE");
   module_initialization_70_inline_walk(((long) 0), "INLINE_INLINE");
   module_initialization_70_inline_app(((long) 0), "INLINE_INLINE");
   module_initialization_70_ast_alphatize(((long) 0), "INLINE_INLINE");
   module_initialization_70_engine_param(((long) 0), "INLINE_INLINE");
   module_initialization_70_tools_shape(((long) 0), "INLINE_INLINE");
   return module_initialization_70_tools_error(((long) 0), "INLINE_INLINE");
}
