/*===========================================================================*/
/*   (Inline/loop.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_t;

typedef struct local_variant_63
  {
     bool_t variant;
  }
                *local_variant_63_t;


static bool_t find_let_fun___232_inline_loop(obj_t);
extern obj_t let_fun_218_ast_node;
extern bool_t inner_loop__79_inline_loop(variable_t);
static obj_t find_let_fun__180_inline_loop(node_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_inline_loop();
static obj_t _find_let_fun__default1339_85_inline_loop(obj_t, obj_t);
extern obj_t module_initialization_70_inline_loop(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_inline_variant(long, char *);
extern obj_t module_initialization_70_inline_recursion(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_inline_loop();
extern obj_t _nest_loop__216_inline_loop(obj_t, obj_t, obj_t, obj_t);
static obj_t cnst_init_137_inline_loop();
extern bool_t is_recursive__125_inline_recursion(variable_t);
static obj_t _find_let_fun__218_inline_loop(obj_t, obj_t);
static obj_t require_initialization_114_inline_loop = BUNSPEC;
static node_t nest_loop__default1364_63_inline_loop(node_t, local_t, obj_t);
extern obj_t var_ast_node;
extern obj_t _inner_loop__3_inline_loop(obj_t, obj_t);
static obj_t library_modules_init_112_inline_loop();
extern node_t nest_loop__92_inline_loop(node_t, local_t, obj_t);
extern obj_t cast_ast_node;
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
static bool_t find_let_fun__default1339_124_inline_loop(node_t);
static obj_t nest_loop___100_inline_loop(obj_t, local_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t _nest_loop__default1364_115_inline_loop(obj_t, obj_t, obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t kwote_ast_node;
extern bool_t is_loop__232_inline_loop(variable_t);
extern long list_length(obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t _is_loop__141_inline_loop(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t __cnst[2];

DEFINE_EXPORT_GENERIC(nest_loop__env_29_inline_loop, _nest_loop__216_inline_loop1736, _nest_loop__216_inline_loop, 0L, 3);
DEFINE_STATIC_PROCEDURE(find_let_fun__default1339_env_55_inline_loop, _find_let_fun__default1339_85_inline_loop1737, _find_let_fun__default1339_85_inline_loop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(inner_loop__env_141_inline_loop, _inner_loop__3_inline_loop1738, _inner_loop__3_inline_loop, 0L, 1);
DEFINE_STRING(string1730_inline_loop, string1730_inline_loop1739, "DONE NEST-LOOP!-DEFAULT1364 ", 28);
DEFINE_STATIC_PROCEDURE(nest_loop__default1364_env_111_inline_loop, _nest_loop__default1364_115_inline_loop1740, _nest_loop__default1364_115_inline_loop, 0L, 3);
DEFINE_STRING(string1729_inline_loop, string1729_inline_loop1741, "No method for this object", 25);
DEFINE_EXPORT_PROCEDURE(is_loop__env_96_inline_loop, _is_loop__141_inline_loop1742, _is_loop__141_inline_loop, 0L, 1);
DEFINE_STATIC_GENERIC(find_let_fun__env_154_inline_loop, _find_let_fun__218_inline_loop1743, _find_let_fun__218_inline_loop, 0L, 1);

obj_t 
module_initialization_70_inline_loop(long checksum_1717, char *from_1718)
{
   if (CBOOL(require_initialization_114_inline_loop))
     {
	require_initialization_114_inline_loop = BBOOL(((bool_t) 0));
	library_modules_init_112_inline_loop();
	cnst_init_137_inline_loop();
	imported_modules_init_94_inline_loop();
	toplevel_init_63_inline_loop();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_inline_loop()
{
   module_initialization_70___object(((long) 0), "INLINE_LOOP");
   module_initialization_70___reader(((long) 0), "INLINE_LOOP");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_LOOP");
   return BUNSPEC;
}


obj_t 
cnst_init_137_inline_loop()
{
   {
      obj_t cnst_port_138_1709;
      cnst_port_138_1709 = open_input_string(string1730_inline_loop);
      {
	 long i_1710;
	 i_1710 = ((long) 1);
       loop_1711:
	 {
	    bool_t test1731_1712;
	    test1731_1712 = (i_1710 == ((long) -1));
	    if (test1731_1712)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1732_1713;
		    {
		       obj_t list1733_1714;
		       {
			  obj_t arg1734_1715;
			  arg1734_1715 = BNIL;
			  list1733_1714 = MAKE_PAIR(cnst_port_138_1709, arg1734_1715);
		       }
		       arg1732_1713 = read___reader(list1733_1714);
		    }
		    CNST_TABLE_SET(i_1710, arg1732_1713);
		 }
		 {
		    int aux_1716;
		    {
		       long aux_1735;
		       aux_1735 = (i_1710 - ((long) 1));
		       aux_1716 = (int) (aux_1735);
		    }
		    {
		       long i_1738;
		       i_1738 = (long) (aux_1716);
		       i_1710 = i_1738;
		       goto loop_1711;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_inline_loop()
{
   add_generic__110___object(find_let_fun__env_154_inline_loop, find_let_fun__default1339_env_55_inline_loop);
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, sequence_ast_node, ((long) 0));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, app_ast_node, ((long) 1));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, app_ly_162_ast_node, ((long) 2));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, funcall_ast_node, ((long) 3));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, pragma_ast_node, ((long) 4));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, cast_ast_node, ((long) 5));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, setq_ast_node, ((long) 6));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, conditional_ast_node, ((long) 7));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, fail_ast_node, ((long) 8));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, select_ast_node, ((long) 9));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, let_fun_218_ast_node, ((long) 10));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, let_var_6_ast_node, ((long) 11));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, set_ex_it_116_ast_node, ((long) 12));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, jump_ex_it_184_ast_node, ((long) 13));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, make_box_202_ast_node, ((long) 14));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, box_ref_242_ast_node, ((long) 15));
   add_inlined_method__244___object(find_let_fun__env_154_inline_loop, box_set__221_ast_node, ((long) 16));
   add_generic__110___object(nest_loop__env_29_inline_loop, nest_loop__default1364_env_111_inline_loop);
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, var_ast_node, ((long) 2));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, sequence_ast_node, ((long) 3));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, app_ast_node, ((long) 4));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, setq_ast_node, ((long) 9));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, conditional_ast_node, ((long) 10));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, fail_ast_node, ((long) 11));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, select_ast_node, ((long) 12));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, let_fun_218_ast_node, ((long) 13));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, let_var_6_ast_node, ((long) 14));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, set_ex_it_116_ast_node, ((long) 15));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, jump_ex_it_184_ast_node, ((long) 16));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, make_box_202_ast_node, ((long) 17));
   add_inlined_method__244___object(nest_loop__env_29_inline_loop, box_ref_242_ast_node, ((long) 18));
   {
      long aux_1778;
      aux_1778 = add_inlined_method__244___object(nest_loop__env_29_inline_loop, box_set__221_ast_node, ((long) 19));
      return BINT(aux_1778);
   }
}


bool_t 
is_loop__232_inline_loop(variable_t variable_1)
{
   {
      bool_t _andtest_1303_810;
      _andtest_1303_810 = is_recursive__125_inline_recursion(variable_1);
      if (_andtest_1303_810)
	{
	   long aux_1783;
	   {
	      obj_t aux_1784;
	      {
		 isfun_t obj_1419;
		 {
		    value_t aux_1785;
		    aux_1785 = (((variable_t) CREF(variable_1))->value);
		    obj_1419 = (isfun_t) (aux_1785);
		 }
		 {
		    obj_t aux_1788;
		    {
		       object_t aux_1789;
		       aux_1789 = (object_t) (obj_1419);
		       aux_1788 = OBJECT_WIDENING(aux_1789);
		    }
		    aux_1784 = (((isfun_t) CREF(aux_1788))->recursive_calls_44);
		 }
	      }
	      aux_1783 = list_length(aux_1784);
	   }
	   return (aux_1783 == ((long) 1));
	}
      else
	{
	   return ((bool_t) 0);
	}
   }
}


obj_t 
_is_loop__141_inline_loop(obj_t env_1685, obj_t variable_1686)
{
   {
      bool_t aux_1795;
      aux_1795 = is_loop__232_inline_loop((variable_t) (variable_1686));
      return BBOOL(aux_1795);
   }
}


bool_t 
inner_loop__79_inline_loop(variable_t variable_2)
{
   {
      obj_t aux_1799;
      {
	 node_t aux_1800;
	 {
	    obj_t aux_1801;
	    {
	       sfun_t obj_1425;
	       {
		  value_t aux_1802;
		  aux_1802 = (((variable_t) CREF(variable_2))->value);
		  obj_1425 = (sfun_t) (aux_1802);
	       }
	       aux_1801 = (((sfun_t) CREF(obj_1425))->body);
	    }
	    aux_1800 = (node_t) (aux_1801);
	 }
	 aux_1799 = find_let_fun__180_inline_loop(aux_1800);
      }
      return CBOOL(aux_1799);
   }
}


obj_t 
_inner_loop__3_inline_loop(obj_t env_1687, obj_t variable_1688)
{
   {
      bool_t aux_1809;
      aux_1809 = inner_loop__79_inline_loop((variable_t) (variable_1688));
      return BBOOL(aux_1809);
   }
}


bool_t 
find_let_fun__default1339_124_inline_loop(node_t node_4)
{
   return ((bool_t) 0);
}


obj_t 
_find_let_fun__default1339_85_inline_loop(obj_t env_1675, obj_t node_1676)
{
   {
      bool_t aux_1813;
      aux_1813 = find_let_fun__default1339_124_inline_loop((node_t) (node_1676));
      return BBOOL(aux_1813);
   }
}


obj_t 
find_let_fun__180_inline_loop(node_t node_3)
{
 find_let_fun__180_inline_loop:
   {
      obj_t method1641_1330;
      obj_t class1646_1331;
      {
	 obj_t arg1650_1328;
	 obj_t arg1651_1329;
	 {
	    object_t obj_1426;
	    obj_1426 = (object_t) (node_3);
	    {
	       obj_t pre_method_105_1427;
	       pre_method_105_1427 = PROCEDURE_REF(find_let_fun__env_154_inline_loop, ((long) 2));
	       if (INTEGERP(pre_method_105_1427))
		 {
		    PROCEDURE_SET(find_let_fun__env_154_inline_loop, ((long) 2), BUNSPEC);
		    arg1650_1328 = pre_method_105_1427;
		 }
	       else
		 {
		    long obj_class_num_177_1432;
		    obj_class_num_177_1432 = TYPE(obj_1426);
		    {
		       obj_t arg1183_1433;
		       arg1183_1433 = PROCEDURE_REF(find_let_fun__env_154_inline_loop, ((long) 1));
		       {
			  long arg1184_1437;
			  {
			     long arg1186_1438;
			     arg1186_1438 = OBJECT_TYPE;
			     arg1184_1437 = (obj_class_num_177_1432 - arg1186_1438);
			  }
			  arg1650_1328 = VECTOR_REF(arg1183_1433, arg1184_1437);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1443;
	    object_1443 = (object_t) (node_3);
	    {
	       long arg1187_1444;
	       {
		  long arg1188_1445;
		  long arg1189_1446;
		  arg1188_1445 = TYPE(object_1443);
		  arg1189_1446 = OBJECT_TYPE;
		  arg1187_1444 = (arg1188_1445 - arg1189_1446);
	       }
	       {
		  obj_t vector_1450;
		  vector_1450 = __classes__134___object;
		  arg1651_1329 = VECTOR_REF(vector_1450, arg1187_1444);
	       }
	    }
	 }
	 method1641_1330 = arg1650_1328;
	 class1646_1331 = arg1651_1329;
	 {
	    if (INTEGERP(method1641_1330))
	      {
		 switch ((long) CINT(method1641_1330))
		   {
		   case ((long) 0):
		      {
			 sequence_t node_1337;
			 node_1337 = (sequence_t) (node_3);
			 {
			    bool_t aux_1835;
			    aux_1835 = find_let_fun___232_inline_loop((((sequence_t) CREF(node_1337))->nodes));
			    return BBOOL(aux_1835);
			 }
		      }
		      break;
		   case ((long) 1):
		      {
			 app_t node_1339;
			 node_1339 = (app_t) (node_3);
			 {
			    bool_t aux_1840;
			    aux_1840 = find_let_fun___232_inline_loop((((app_t) CREF(node_1339))->args));
			    return BBOOL(aux_1840);
			 }
		      }
		      break;
		   case ((long) 2):
		      {
			 app_ly_162_t node_1342;
			 node_1342 = (app_ly_162_t) (node_3);
			 {
			    obj_t _ortest_1306_1344;
			    _ortest_1306_1344 = find_let_fun__180_inline_loop((((app_ly_162_t) CREF(node_1342))->fun));
			    if (CBOOL(_ortest_1306_1344))
			      {
				 return _ortest_1306_1344;
			      }
			    else
			      {
				 node_t node_1849;
				 node_1849 = (((app_ly_162_t) CREF(node_1342))->arg);
				 node_3 = node_1849;
				 goto find_let_fun__180_inline_loop;
			      }
			 }
		      }
		      break;
		   case ((long) 3):
		      {
			 funcall_t node_1347;
			 node_1347 = (funcall_t) (node_3);
			 {
			    obj_t _ortest_1308_1349;
			    _ortest_1308_1349 = find_let_fun__180_inline_loop((((funcall_t) CREF(node_1347))->fun));
			    if (CBOOL(_ortest_1308_1349))
			      {
				 return _ortest_1308_1349;
			      }
			    else
			      {
				 bool_t aux_1856;
				 aux_1856 = find_let_fun___232_inline_loop((((funcall_t) CREF(node_1347))->args));
				 return BBOOL(aux_1856);
			      }
			 }
		      }
		      break;
		   case ((long) 4):
		      {
			 pragma_t node_1352;
			 node_1352 = (pragma_t) (node_3);
			 {
			    bool_t aux_1861;
			    aux_1861 = find_let_fun___232_inline_loop((((pragma_t) CREF(node_1352))->args));
			    return BBOOL(aux_1861);
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 cast_t node_1354;
			 node_1354 = (cast_t) (node_3);
			 {
			    node_t node_1866;
			    node_1866 = (((cast_t) CREF(node_1354))->arg);
			    node_3 = node_1866;
			    goto find_let_fun__180_inline_loop;
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 setq_t node_1356;
			 node_1356 = (setq_t) (node_3);
			 {
			    node_t node_1869;
			    node_1869 = (((setq_t) CREF(node_1356))->value);
			    node_3 = node_1869;
			    goto find_let_fun__180_inline_loop;
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 conditional_t node_1358;
			 node_1358 = (conditional_t) (node_3);
			 {
			    obj_t _ortest_1310_1360;
			    _ortest_1310_1360 = find_let_fun__180_inline_loop((((conditional_t) CREF(node_1358))->test));
			    if (CBOOL(_ortest_1310_1360))
			      {
				 return _ortest_1310_1360;
			      }
			    else
			      {
				 obj_t _ortest_1311_1361;
				 _ortest_1311_1361 = find_let_fun__180_inline_loop((((conditional_t) CREF(node_1358))->true));
				 if (CBOOL(_ortest_1311_1361))
				   {
				      return _ortest_1311_1361;
				   }
				 else
				   {
				      node_t node_1880;
				      node_1880 = (((conditional_t) CREF(node_1358))->false);
				      node_3 = node_1880;
				      goto find_let_fun__180_inline_loop;
				   }
			      }
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 fail_t node_1365;
			 node_1365 = (fail_t) (node_3);
			 {
			    obj_t _ortest_1313_1367;
			    _ortest_1313_1367 = find_let_fun__180_inline_loop((((fail_t) CREF(node_1365))->proc));
			    if (CBOOL(_ortest_1313_1367))
			      {
				 return _ortest_1313_1367;
			      }
			    else
			      {
				 obj_t _ortest_1314_1368;
				 _ortest_1314_1368 = find_let_fun__180_inline_loop((((fail_t) CREF(node_1365))->msg));
				 if (CBOOL(_ortest_1314_1368))
				   {
				      return _ortest_1314_1368;
				   }
				 else
				   {
				      node_t node_1891;
				      node_1891 = (((fail_t) CREF(node_1365))->obj);
				      node_3 = node_1891;
				      goto find_let_fun__180_inline_loop;
				   }
			      }
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 select_t node_1372;
			 node_1372 = (select_t) (node_3);
			 {
			    obj_t clauses_1373;
			    clauses_1373 = (((select_t) CREF(node_1372))->clauses);
			  loop_1374:
			    if (NULLP(clauses_1373))
			      {
				 {
				    node_t node_1896;
				    node_1896 = (((select_t) CREF(node_1372))->test);
				    node_3 = node_1896;
				    goto find_let_fun__180_inline_loop;
				 }
			      }
			    else
			      {
				 bool_t test1680_1378;
				 {
				    obj_t aux_1898;
				    {
				       node_t aux_1899;
				       {
					  obj_t aux_1900;
					  {
					     obj_t aux_1901;
					     aux_1901 = CAR(clauses_1373);
					     aux_1900 = CDR(aux_1901);
					  }
					  aux_1899 = (node_t) (aux_1900);
				       }
				       aux_1898 = find_let_fun__180_inline_loop(aux_1899);
				    }
				    test1680_1378 = CBOOL(aux_1898);
				 }
				 if (test1680_1378)
				   {
				      return BTRUE;
				   }
				 else
				   {
				      {
					 obj_t clauses_1908;
					 clauses_1908 = CDR(clauses_1373);
					 clauses_1373 = clauses_1908;
					 goto loop_1374;
				      }
				   }
			      }
			 }
		      }
		      break;
		   case ((long) 10):
		      return BTRUE;
		      break;
		   case ((long) 11):
		      {
			 let_var_6_t node_1383;
			 node_1383 = (let_var_6_t) (node_3);
			 {
			    obj_t bindings_1384;
			    bindings_1384 = (((let_var_6_t) CREF(node_1383))->bindings);
			  loop_1385:
			    if (NULLP(bindings_1384))
			      {
				 {
				    node_t node_1914;
				    node_1914 = (((let_var_6_t) CREF(node_1383))->body);
				    node_3 = node_1914;
				    goto find_let_fun__180_inline_loop;
				 }
			      }
			    else
			      {
				 bool_t test1689_1389;
				 {
				    obj_t aux_1916;
				    {
				       node_t aux_1917;
				       {
					  obj_t aux_1918;
					  {
					     obj_t aux_1919;
					     aux_1919 = CAR(bindings_1384);
					     aux_1918 = CDR(aux_1919);
					  }
					  aux_1917 = (node_t) (aux_1918);
				       }
				       aux_1916 = find_let_fun__180_inline_loop(aux_1917);
				    }
				    test1689_1389 = CBOOL(aux_1916);
				 }
				 if (test1689_1389)
				   {
				      return BTRUE;
				   }
				 else
				   {
				      {
					 obj_t bindings_1926;
					 bindings_1926 = CDR(bindings_1384);
					 bindings_1384 = bindings_1926;
					 goto loop_1385;
				      }
				   }
			      }
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 set_ex_it_116_t node_1393;
			 node_1393 = (set_ex_it_116_t) (node_3);
			 {
			    node_t node_1930;
			    node_1930 = (((set_ex_it_116_t) CREF(node_1393))->body);
			    node_3 = node_1930;
			    goto find_let_fun__180_inline_loop;
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 jump_ex_it_184_t node_1395;
			 node_1395 = (jump_ex_it_184_t) (node_3);
			 {
			    obj_t _ortest_1316_1397;
			    _ortest_1316_1397 = find_let_fun__180_inline_loop((((jump_ex_it_184_t) CREF(node_1395))->exit));
			    if (CBOOL(_ortest_1316_1397))
			      {
				 return _ortest_1316_1397;
			      }
			    else
			      {
				 node_t node_1937;
				 node_1937 = (((jump_ex_it_184_t) CREF(node_1395))->value);
				 node_3 = node_1937;
				 goto find_let_fun__180_inline_loop;
			      }
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 make_box_202_t node_1400;
			 node_1400 = (make_box_202_t) (node_3);
			 {
			    node_t node_1940;
			    node_1940 = (((make_box_202_t) CREF(node_1400))->value);
			    node_3 = node_1940;
			    goto find_let_fun__180_inline_loop;
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 box_ref_242_t node_1402;
			 node_1402 = (box_ref_242_t) (node_3);
			 {
			    node_t node_1943;
			    {
			       var_t aux_1944;
			       aux_1944 = (((box_ref_242_t) CREF(node_1402))->var);
			       node_1943 = (node_t) (aux_1944);
			    }
			    node_3 = node_1943;
			    goto find_let_fun__180_inline_loop;
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 box_set__221_t node_1404;
			 node_1404 = (box_set__221_t) (node_3);
			 {
			    obj_t _ortest_1318_1406;
			    {
			       node_t aux_1948;
			       {
				  var_t aux_1949;
				  aux_1949 = (((box_set__221_t) CREF(node_1404))->var);
				  aux_1948 = (node_t) (aux_1949);
			       }
			       _ortest_1318_1406 = find_let_fun__180_inline_loop(aux_1948);
			    }
			    if (CBOOL(_ortest_1318_1406))
			      {
				 return _ortest_1318_1406;
			      }
			    else
			      {
				 node_t node_1955;
				 node_1955 = (((box_set__221_t) CREF(node_1404))->value);
				 node_3 = node_1955;
				 goto find_let_fun__180_inline_loop;
			      }
			 }
		      }
		      break;
		   default:
		    case_else1647_184_1334:
		      if (PROCEDUREP(method1641_1330))
			{
			   return PROCEDURE_ENTRY(method1641_1330) (method1641_1330, (obj_t) (node_3), BEOA);
			}
		      else
			{
			   obj_t fun1404_817;
			   fun1404_817 = PROCEDURE_REF(find_let_fun__env_154_inline_loop, ((long) 0));
			   return PROCEDURE_ENTRY(fun1404_817) (fun1404_817, (obj_t) (node_3), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1647_184_1334;
	      }
	 }
      }
   }
}


obj_t 
_find_let_fun__218_inline_loop(obj_t env_1673, obj_t node_1674)
{
   return find_let_fun__180_inline_loop((node_t) (node_1674));
}


bool_t 
find_let_fun___232_inline_loop(obj_t node__221_22)
{
   {
      obj_t node__221_818;
      node__221_818 = node__221_22;
    loop_819:
      if (NULLP(node__221_818))
	{
	   return ((bool_t) 0);
	}
      else
	{
	   bool_t test1406_821;
	   {
	      obj_t aux_1972;
	      {
		 node_t aux_1973;
		 {
		    obj_t aux_1974;
		    aux_1974 = CAR(node__221_818);
		    aux_1973 = (node_t) (aux_1974);
		 }
		 aux_1972 = find_let_fun__180_inline_loop(aux_1973);
	      }
	      test1406_821 = CBOOL(aux_1972);
	   }
	   if (test1406_821)
	     {
		return ((bool_t) 1);
	     }
	   else
	     {
		{
		   obj_t node__221_1980;
		   node__221_1980 = CDR(node__221_818);
		   node__221_818 = node__221_1980;
		   goto loop_819;
		}
	     }
	}
   }
}


node_t 
nest_loop__default1364_63_inline_loop(node_t node_26, local_t local_27, obj_t nester_28)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1729_inline_loop, (obj_t) (node_26));
}


obj_t 
_nest_loop__default1364_115_inline_loop(obj_t env_1681, obj_t node_1682, obj_t local_1683, obj_t nester_1684)
{
   {
      node_t aux_1985;
      aux_1985 = nest_loop__default1364_63_inline_loop((node_t) (node_1682), (local_t) (local_1683), nester_1684);
      return (obj_t) (aux_1985);
   }
}


node_t 
nest_loop__92_inline_loop(node_t node_23, local_t local_24, obj_t nester_25)
{
   {
      obj_t method1540_1163;
      obj_t class1545_1164;
      {
	 obj_t arg1549_1161;
	 obj_t arg1550_1162;
	 {
	    object_t obj_1496;
	    obj_1496 = (object_t) (node_23);
	    {
	       obj_t pre_method_105_1497;
	       pre_method_105_1497 = PROCEDURE_REF(nest_loop__env_29_inline_loop, ((long) 2));
	       if (INTEGERP(pre_method_105_1497))
		 {
		    PROCEDURE_SET(nest_loop__env_29_inline_loop, ((long) 2), BUNSPEC);
		    arg1549_1161 = pre_method_105_1497;
		 }
	       else
		 {
		    long obj_class_num_177_1502;
		    obj_class_num_177_1502 = TYPE(obj_1496);
		    {
		       obj_t arg1183_1503;
		       arg1183_1503 = PROCEDURE_REF(nest_loop__env_29_inline_loop, ((long) 1));
		       {
			  long arg1184_1507;
			  {
			     long arg1186_1508;
			     arg1186_1508 = OBJECT_TYPE;
			     arg1184_1507 = (obj_class_num_177_1502 - arg1186_1508);
			  }
			  arg1549_1161 = VECTOR_REF(arg1183_1503, arg1184_1507);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1513;
	    object_1513 = (object_t) (node_23);
	    {
	       long arg1187_1514;
	       {
		  long arg1188_1515;
		  long arg1189_1516;
		  arg1188_1515 = TYPE(object_1513);
		  arg1189_1516 = OBJECT_TYPE;
		  arg1187_1514 = (arg1188_1515 - arg1189_1516);
	       }
	       {
		  obj_t vector_1520;
		  vector_1520 = __classes__134___object;
		  arg1550_1162 = VECTOR_REF(vector_1520, arg1187_1514);
	       }
	    }
	 }
	 {
	    obj_t aux_2005;
	    method1540_1163 = arg1549_1161;
	    class1545_1164 = arg1550_1162;
	    {
	       if (INTEGERP(method1540_1163))
		 {
		    switch ((long) CINT(method1540_1163))
		      {
		      case ((long) 0):
			 {
			    atom_t aux_2008;
			    aux_2008 = (atom_t) (node_23);
			    aux_2005 = (obj_t) (aux_2008);
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t aux_2011;
			    aux_2011 = (kwote_t) (node_23);
			    aux_2005 = (obj_t) (aux_2011);
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t aux_2014;
			    aux_2014 = (var_t) (node_23);
			    aux_2005 = (obj_t) (aux_2014);
			 }
			 break;
		      case ((long) 3):
			 {
			    sequence_t node_1179;
			    node_1179 = (sequence_t) (node_23);
			    nest_loop___100_inline_loop((((sequence_t) CREF(node_1179))->nodes), local_24, nester_25);
			    aux_2005 = (obj_t) (node_1179);
			 }
			 break;
		      case ((long) 4):
			 {
			    app_t node_1184;
			    node_1184 = (app_t) (node_23);
			    nest_loop___100_inline_loop((((app_t) CREF(node_1184))->args), local_24, nester_25);
			    {
			       bool_t test1555_1189;
			       {
				  bool_t test1556_1190;
				  {
				     obj_t aux_2024;
				     {
					var_t aux_2025;
					aux_2025 = (((app_t) CREF(node_1184))->fun);
					aux_2024 = (obj_t) (aux_2025);
				     }
				     test1556_1190 = is_a__118___object(aux_2024, var_ast_node);
				  }
				  if (test1556_1190)
				    {
				       obj_t aux_2035;
				       obj_t aux_2030;
				       aux_2035 = (obj_t) (local_24);
				       {
					  variable_t aux_2031;
					  {
					     var_t arg1559_1192;
					     arg1559_1192 = (((app_t) CREF(node_1184))->fun);
					     aux_2031 = (((var_t) CREF(arg1559_1192))->variable);
					  }
					  aux_2030 = (obj_t) (aux_2031);
				       }
				       test1555_1189 = (aux_2030 == aux_2035);
				    }
				  else
				    {
				       test1555_1189 = ((bool_t) 0);
				    }
			       }
			       if (test1555_1189)
				 {
				    aux_2005 = PROCEDURE_ENTRY(nester_25) (nester_25, (obj_t) (node_1184), BEOA);
				 }
			       else
				 {
				    aux_2005 = (obj_t) (node_1184);
				 }
			    }
			 }
			 break;
		      case ((long) 5):
			 {
			    app_ly_162_t node_1194;
			    node_1194 = (app_ly_162_t) (node_23);
			    {
			       node_t arg1561_1198;
			       arg1561_1198 = nest_loop__92_inline_loop((((app_ly_162_t) CREF(node_1194))->fun), local_24, nester_25);
			       {
				  obj_t res1708_1533;
				  {
				     obj_t x_1689;
				     x_1689 = ((((app_ly_162_t) CREF(node_1194))->fun) = ((node_t) arg1561_1198), BUNSPEC);
				     res1708_1533 = BUNSPEC;
				  }
				  res1708_1533;
			       }
			    }
			    {
			       node_t arg1563_1200;
			       arg1563_1200 = nest_loop__92_inline_loop((((app_ly_162_t) CREF(node_1194))->arg), local_24, nester_25);
			       {
				  obj_t res1709_1537;
				  {
				     obj_t x_1690;
				     x_1690 = ((((app_ly_162_t) CREF(node_1194))->arg) = ((node_t) arg1563_1200), BUNSPEC);
				     res1709_1537 = BUNSPEC;
				  }
				  res1709_1537;
			       }
			    }
			    aux_2005 = (obj_t) (node_1194);
			 }
			 break;
		      case ((long) 6):
			 {
			    funcall_t node_1202;
			    node_1202 = (funcall_t) (node_23);
			    {
			       node_t arg1565_1206;
			       arg1565_1206 = nest_loop__92_inline_loop((((funcall_t) CREF(node_1202))->fun), local_24, nester_25);
			       {
				  obj_t res1710_1541;
				  {
				     obj_t x_1691;
				     x_1691 = ((((funcall_t) CREF(node_1202))->fun) = ((node_t) arg1565_1206), BUNSPEC);
				     res1710_1541 = BUNSPEC;
				  }
				  res1710_1541;
			       }
			    }
			    nest_loop___100_inline_loop((((funcall_t) CREF(node_1202))->args), local_24, nester_25);
			    aux_2005 = (obj_t) (node_1202);
			 }
			 break;
		      case ((long) 7):
			 {
			    pragma_t node_1209;
			    node_1209 = (pragma_t) (node_23);
			    nest_loop___100_inline_loop((((pragma_t) CREF(node_1209))->args), local_24, nester_25);
			    aux_2005 = (obj_t) (node_1209);
			 }
			 break;
		      case ((long) 8):
			 {
			    cast_t node_1213;
			    node_1213 = (cast_t) (node_23);
			    nest_loop__92_inline_loop((((cast_t) CREF(node_1213))->arg), local_24, nester_25);
			    aux_2005 = (obj_t) (node_1213);
			 }
			 break;
		      case ((long) 9):
			 {
			    setq_t node_1217;
			    node_1217 = (setq_t) (node_23);
			    nest_loop__92_inline_loop((((setq_t) CREF(node_1217))->value), local_24, nester_25);
			    aux_2005 = (obj_t) (node_1217);
			 }
			 break;
		      case ((long) 10):
			 {
			    conditional_t node_1221;
			    node_1221 = (conditional_t) (node_23);
			    {
			       node_t arg1572_1225;
			       arg1572_1225 = nest_loop__92_inline_loop((((conditional_t) CREF(node_1221))->test), local_24, nester_25);
			       {
				  obj_t res1711_1549;
				  {
				     obj_t x_1692;
				     x_1692 = ((((conditional_t) CREF(node_1221))->test) = ((node_t) arg1572_1225), BUNSPEC);
				     res1711_1549 = BUNSPEC;
				  }
				  res1711_1549;
			       }
			    }
			    {
			       node_t arg1574_1227;
			       arg1574_1227 = nest_loop__92_inline_loop((((conditional_t) CREF(node_1221))->true), local_24, nester_25);
			       {
				  obj_t res1712_1553;
				  {
				     obj_t x_1693;
				     x_1693 = ((((conditional_t) CREF(node_1221))->true) = ((node_t) arg1574_1227), BUNSPEC);
				     res1712_1553 = BUNSPEC;
				  }
				  res1712_1553;
			       }
			    }
			    {
			       node_t arg1576_1229;
			       arg1576_1229 = nest_loop__92_inline_loop((((conditional_t) CREF(node_1221))->false), local_24, nester_25);
			       {
				  obj_t res1713_1557;
				  {
				     obj_t x_1694;
				     x_1694 = ((((conditional_t) CREF(node_1221))->false) = ((node_t) arg1576_1229), BUNSPEC);
				     res1713_1557 = BUNSPEC;
				  }
				  res1713_1557;
			       }
			    }
			    aux_2005 = (obj_t) (node_1221);
			 }
			 break;
		      case ((long) 11):
			 {
			    fail_t node_1231;
			    node_1231 = (fail_t) (node_23);
			    {
			       node_t arg1578_1235;
			       arg1578_1235 = nest_loop__92_inline_loop((((fail_t) CREF(node_1231))->proc), local_24, nester_25);
			       {
				  obj_t res1714_1561;
				  {
				     obj_t x_1695;
				     x_1695 = ((((fail_t) CREF(node_1231))->proc) = ((node_t) arg1578_1235), BUNSPEC);
				     res1714_1561 = BUNSPEC;
				  }
				  res1714_1561;
			       }
			    }
			    {
			       node_t arg1582_1237;
			       arg1582_1237 = nest_loop__92_inline_loop((((fail_t) CREF(node_1231))->msg), local_24, nester_25);
			       {
				  obj_t res1715_1565;
				  {
				     obj_t x_1696;
				     x_1696 = ((((fail_t) CREF(node_1231))->msg) = ((node_t) arg1582_1237), BUNSPEC);
				     res1715_1565 = BUNSPEC;
				  }
				  res1715_1565;
			       }
			    }
			    {
			       node_t arg1584_1239;
			       arg1584_1239 = nest_loop__92_inline_loop((((fail_t) CREF(node_1231))->obj), local_24, nester_25);
			       {
				  obj_t res1716_1569;
				  {
				     obj_t x_1697;
				     x_1697 = ((((fail_t) CREF(node_1231))->obj) = ((node_t) arg1584_1239), BUNSPEC);
				     res1716_1569 = BUNSPEC;
				  }
				  res1716_1569;
			       }
			    }
			    aux_2005 = (obj_t) (node_1231);
			 }
			 break;
		      case ((long) 12):
			 {
			    select_t node_1241;
			    node_1241 = (select_t) (node_23);
			    {
			       node_t arg1587_1245;
			       arg1587_1245 = nest_loop__92_inline_loop((((select_t) CREF(node_1241))->test), local_24, nester_25);
			       {
				  obj_t res1717_1573;
				  {
				     obj_t x_1698;
				     x_1698 = ((((select_t) CREF(node_1241))->test) = ((node_t) arg1587_1245), BUNSPEC);
				     res1717_1573 = BUNSPEC;
				  }
				  res1717_1573;
			       }
			    }
			    {
			       obj_t l1326_1247;
			       l1326_1247 = (((select_t) CREF(node_1241))->clauses);
			     lname1327_1248:
			       if (PAIRP(l1326_1247))
				 {
				    {
				       obj_t clause_1251;
				       clause_1251 = CAR(l1326_1247);
				       {
					  node_t arg1591_1252;
					  {
					     node_t aux_2099;
					     {
						obj_t aux_2100;
						aux_2100 = CDR(clause_1251);
						aux_2099 = (node_t) (aux_2100);
					     }
					     arg1591_1252 = nest_loop__92_inline_loop(aux_2099, local_24, nester_25);
					  }
					  {
					     obj_t aux_2104;
					     aux_2104 = (obj_t) (arg1591_1252);
					     SET_CDR(clause_1251, aux_2104);
					  }
				       }
				    }
				    {
				       obj_t l1326_2107;
				       l1326_2107 = CDR(l1326_1247);
				       l1326_1247 = l1326_2107;
				       goto lname1327_1248;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_2005 = (obj_t) (node_1241);
			 }
			 break;
		      case ((long) 13):
			 {
			    let_fun_218_t node_1255;
			    node_1255 = (let_fun_218_t) (node_23);
			    {
			       node_t arg1595_1259;
			       arg1595_1259 = nest_loop__92_inline_loop((((let_fun_218_t) CREF(node_1255))->body), local_24, nester_25);
			       {
				  obj_t res1718_1584;
				  {
				     obj_t x_1699;
				     x_1699 = ((((let_fun_218_t) CREF(node_1255))->body) = ((node_t) arg1595_1259), BUNSPEC);
				     res1718_1584 = BUNSPEC;
				  }
				  res1718_1584;
			       }
			    }
			    {
			       obj_t l1329_1261;
			       l1329_1261 = (((let_fun_218_t) CREF(node_1255))->locals);
			     lname1330_1262:
			       if (PAIRP(l1329_1261))
				 {
				    {
				       value_t sfun_1266;
				       {
					  local_t obj_1588;
					  {
					     obj_t aux_2117;
					     aux_2117 = CAR(l1329_1261);
					     obj_1588 = (local_t) (aux_2117);
					  }
					  sfun_1266 = (((local_t) CREF(obj_1588))->value);
				       }
				       {
					  node_t arg1600_1267;
					  {
					     node_t aux_2121;
					     {
						obj_t aux_2122;
						{
						   sfun_t obj_1589;
						   obj_1589 = (sfun_t) (sfun_1266);
						   aux_2122 = (((sfun_t) CREF(obj_1589))->body);
						}
						aux_2121 = (node_t) (aux_2122);
					     }
					     arg1600_1267 = nest_loop__92_inline_loop(aux_2121, local_24, nester_25);
					  }
					  {
					     obj_t res1719_1592;
					     {
						sfun_t obj_1590;
						obj_t val1079_1591;
						obj_1590 = (sfun_t) (sfun_1266);
						val1079_1591 = (obj_t) (arg1600_1267);
						{
						   obj_t x_1700;
						   x_1700 = ((((sfun_t) CREF(obj_1590))->body) = ((obj_t) val1079_1591), BUNSPEC);
						   res1719_1592 = BUNSPEC;
						}
					     }
					     res1719_1592;
					  }
				       }
				    }
				    {
				       obj_t l1329_2130;
				       l1329_2130 = CDR(l1329_1261);
				       l1329_1261 = l1329_2130;
				       goto lname1330_1262;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_2005 = (obj_t) (node_1255);
			 }
			 break;
		      case ((long) 14):
			 {
			    let_var_6_t node_1270;
			    node_1270 = (let_var_6_t) (node_23);
			    {
			       node_t arg1604_1274;
			       arg1604_1274 = nest_loop__92_inline_loop((((let_var_6_t) CREF(node_1270))->body), local_24, nester_25);
			       {
				  obj_t res1720_1597;
				  {
				     obj_t x_1701;
				     x_1701 = ((((let_var_6_t) CREF(node_1270))->body) = ((node_t) arg1604_1274), BUNSPEC);
				     res1720_1597 = BUNSPEC;
				  }
				  res1720_1597;
			       }
			    }
			    {
			       obj_t l1332_1276;
			       l1332_1276 = (((let_var_6_t) CREF(node_1270))->bindings);
			     lname1333_1277:
			       if (PAIRP(l1332_1276))
				 {
				    {
				       obj_t binding_1280;
				       binding_1280 = CAR(l1332_1276);
				       {
					  node_t arg1608_1281;
					  {
					     node_t aux_2141;
					     {
						obj_t aux_2142;
						aux_2142 = CDR(binding_1280);
						aux_2141 = (node_t) (aux_2142);
					     }
					     arg1608_1281 = nest_loop__92_inline_loop(aux_2141, local_24, nester_25);
					  }
					  {
					     obj_t aux_2146;
					     aux_2146 = (obj_t) (arg1608_1281);
					     SET_CDR(binding_1280, aux_2146);
					  }
				       }
				    }
				    {
				       obj_t l1332_2149;
				       l1332_2149 = CDR(l1332_1276);
				       l1332_1276 = l1332_2149;
				       goto lname1333_1277;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_2005 = (obj_t) (node_1270);
			 }
			 break;
		      case ((long) 15):
			 {
			    set_ex_it_116_t node_1284;
			    node_1284 = (set_ex_it_116_t) (node_23);
			    {
			       node_t arg1614_1288;
			       arg1614_1288 = nest_loop__92_inline_loop((((set_ex_it_116_t) CREF(node_1284))->body), local_24, nester_25);
			       {
				  obj_t res1721_1608;
				  {
				     obj_t x_1702;
				     x_1702 = ((((set_ex_it_116_t) CREF(node_1284))->body) = ((node_t) arg1614_1288), BUNSPEC);
				     res1721_1608 = BUNSPEC;
				  }
				  res1721_1608;
			       }
			    }
			    aux_2005 = (obj_t) (node_1284);
			 }
			 break;
		      case ((long) 16):
			 {
			    jump_ex_it_184_t node_1290;
			    node_1290 = (jump_ex_it_184_t) (node_23);
			    {
			       node_t arg1617_1294;
			       arg1617_1294 = nest_loop__92_inline_loop((((jump_ex_it_184_t) CREF(node_1290))->exit), local_24, nester_25);
			       {
				  obj_t res1722_1612;
				  {
				     obj_t x_1703;
				     x_1703 = ((((jump_ex_it_184_t) CREF(node_1290))->exit) = ((node_t) arg1617_1294), BUNSPEC);
				     res1722_1612 = BUNSPEC;
				  }
				  res1722_1612;
			       }
			    }
			    {
			       node_t arg1619_1296;
			       arg1619_1296 = nest_loop__92_inline_loop((((jump_ex_it_184_t) CREF(node_1290))->value), local_24, nester_25);
			       {
				  obj_t res1723_1616;
				  {
				     obj_t x_1704;
				     x_1704 = ((((jump_ex_it_184_t) CREF(node_1290))->value) = ((node_t) arg1619_1296), BUNSPEC);
				     res1723_1616 = BUNSPEC;
				  }
				  res1723_1616;
			       }
			    }
			    aux_2005 = (obj_t) (node_1290);
			 }
			 break;
		      case ((long) 17):
			 {
			    make_box_202_t node_1298;
			    node_1298 = (make_box_202_t) (node_23);
			    {
			       node_t arg1621_1302;
			       arg1621_1302 = nest_loop__92_inline_loop((((make_box_202_t) CREF(node_1298))->value), local_24, nester_25);
			       {
				  obj_t res1724_1620;
				  {
				     obj_t x_1705;
				     x_1705 = ((((make_box_202_t) CREF(node_1298))->value) = ((node_t) arg1621_1302), BUNSPEC);
				     res1724_1620 = BUNSPEC;
				  }
				  res1724_1620;
			       }
			    }
			    aux_2005 = (obj_t) (node_1298);
			 }
			 break;
		      case ((long) 18):
			 {
			    box_ref_242_t node_1304;
			    node_1304 = (box_ref_242_t) (node_23);
			    {
			       node_t arg1624_1308;
			       {
				  node_t aux_2172;
				  {
				     var_t aux_2173;
				     aux_2173 = (((box_ref_242_t) CREF(node_1304))->var);
				     aux_2172 = (node_t) (aux_2173);
				  }
				  arg1624_1308 = nest_loop__92_inline_loop(aux_2172, local_24, nester_25);
			       }
			       {
				  obj_t res1725_1624;
				  {
				     var_t val1263_1623;
				     val1263_1623 = (var_t) (arg1624_1308);
				     {
					obj_t x_1706;
					x_1706 = ((((box_ref_242_t) CREF(node_1304))->var) = ((var_t) val1263_1623), BUNSPEC);
					res1725_1624 = BUNSPEC;
				     }
				  }
				  res1725_1624;
			       }
			    }
			    aux_2005 = (obj_t) (node_1304);
			 }
			 break;
		      case ((long) 19):
			 {
			    box_set__221_t node_1310;
			    node_1310 = (box_set__221_t) (node_23);
			    {
			       node_t arg1627_1314;
			       {
				  node_t aux_2181;
				  {
				     var_t aux_2182;
				     aux_2182 = (((box_set__221_t) CREF(node_1310))->var);
				     aux_2181 = (node_t) (aux_2182);
				  }
				  arg1627_1314 = nest_loop__92_inline_loop(aux_2181, local_24, nester_25);
			       }
			       {
				  obj_t res1726_1628;
				  {
				     var_t val1269_1627;
				     val1269_1627 = (var_t) (arg1627_1314);
				     {
					obj_t x_1707;
					x_1707 = ((((box_set__221_t) CREF(node_1310))->var) = ((var_t) val1269_1627), BUNSPEC);
					res1726_1628 = BUNSPEC;
				     }
				  }
				  res1726_1628;
			       }
			    }
			    {
			       node_t arg1630_1316;
			       arg1630_1316 = nest_loop__92_inline_loop((((box_set__221_t) CREF(node_1310))->value), local_24, nester_25);
			       {
				  obj_t res1727_1632;
				  {
				     obj_t x_1708;
				     x_1708 = ((((box_set__221_t) CREF(node_1310))->value) = ((node_t) arg1630_1316), BUNSPEC);
				     res1727_1632 = BUNSPEC;
				  }
				  res1727_1632;
			       }
			    }
			    aux_2005 = (obj_t) (node_1310);
			 }
			 break;
		      default:
		       case_else1546_194_1167:
			 if (PROCEDUREP(method1540_1163))
			   {
			      aux_2005 = PROCEDURE_ENTRY(method1540_1163) (method1540_1163, (obj_t) (node_23), (obj_t) (local_24), nester_25, BEOA);
			   }
			 else
			   {
			      obj_t fun1413_826;
			      fun1413_826 = PROCEDURE_REF(nest_loop__env_29_inline_loop, ((long) 0));
			      aux_2005 = PROCEDURE_ENTRY(fun1413_826) (fun1413_826, (obj_t) (node_23), (obj_t) (local_24), nester_25, BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1546_194_1167;
		 }
	    }
	    return (node_t) (aux_2005);
	 }
      }
   }
}


obj_t 
_nest_loop__216_inline_loop(obj_t env_1677, obj_t node_1678, obj_t local_1679, obj_t nester_1680)
{
   {
      node_t aux_2206;
      aux_2206 = nest_loop__92_inline_loop((node_t) (node_1678), (local_t) (local_1679), nester_1680);
      return (obj_t) (aux_2206);
   }
}


obj_t 
nest_loop___100_inline_loop(obj_t node__221_89, local_t var_90, obj_t nester_91)
{
   {
      obj_t node__221_827;
      node__221_827 = node__221_89;
    loop_828:
      if (NULLP(node__221_827))
	{
	   return CNST_TABLE_REF(((long) 1));
	}
      else
	{
	   {
	      node_t arg1415_830;
	      {
		 node_t aux_2214;
		 {
		    obj_t aux_2215;
		    aux_2215 = CAR(node__221_827);
		    aux_2214 = (node_t) (aux_2215);
		 }
		 arg1415_830 = nest_loop__92_inline_loop(aux_2214, var_90, nester_91);
	      }
	      {
		 obj_t aux_2219;
		 aux_2219 = (obj_t) (arg1415_830);
		 SET_CAR(node__221_827, aux_2219);
	      }
	   }
	   {
	      obj_t node__221_2222;
	      node__221_2222 = CDR(node__221_827);
	      node__221_827 = node__221_2222;
	      goto loop_828;
	   }
	}
   }
}


obj_t 
imported_modules_init_94_inline_loop()
{
   module_initialization_70_tools_trace(((long) 0), "INLINE_LOOP");
   module_initialization_70_engine_param(((long) 0), "INLINE_LOOP");
   module_initialization_70_type_type(((long) 0), "INLINE_LOOP");
   module_initialization_70_ast_var(((long) 0), "INLINE_LOOP");
   module_initialization_70_ast_node(((long) 0), "INLINE_LOOP");
   module_initialization_70_ast_local(((long) 0), "INLINE_LOOP");
   module_initialization_70_ast_sexp(((long) 0), "INLINE_LOOP");
   module_initialization_70_tools_speek(((long) 0), "INLINE_LOOP");
   module_initialization_70_tools_shape(((long) 0), "INLINE_LOOP");
   module_initialization_70_tools_error(((long) 0), "INLINE_LOOP");
   module_initialization_70_inline_inline(((long) 0), "INLINE_LOOP");
   module_initialization_70_inline_variant(((long) 0), "INLINE_LOOP");
   module_initialization_70_inline_recursion(((long) 0), "INLINE_LOOP");
   return module_initialization_70_effect_effect(((long) 0), "INLINE_LOOP");
}
