/*===========================================================================*/
/*   (Inline/recursion.scm)                                                  */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_t;

typedef struct local_variant_63
  {
     bool_t variant;
  }
                *local_variant_63_t;


static obj_t _find_recursive_calls_default1330_125_inline_recursion(obj_t, obj_t, obj_t);
extern obj_t substitutions_inline_variant(variable_t, obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
extern obj_t isfun_inline_inline;
extern obj_t _is_recursive__21_inline_recursion(obj_t, obj_t);
extern obj_t __res1__155___r5_control_features_6_4;
extern local_t clone_local_230_ast_local(local_t, value_t);
extern bool_t inner_loop__79_inline_loop(variable_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t inline_app_labels_34_inline_recursion(node_t, long, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t _find_recursive_calls_233_inline_recursion(obj_t, obj_t, obj_t);
extern obj_t append___r4_pairs_and_lists_6_3(obj_t);
static obj_t imported_modules_init_94_inline_recursion();
extern obj_t module_initialization_70_inline_recursion(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_alphatize(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_inline_simple(long, char *);
extern obj_t module_initialization_70_inline_variant(long, char *);
extern obj_t module_initialization_70_inline_loop(long, char *);
extern obj_t module_initialization_70_inline_app(long, char *);
extern obj_t module_initialization_70_reduce_cse(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r5_control_features_6_4(long, char *);
static obj_t toplevel_init_63_inline_recursion();
extern obj_t shrink_args__237_inline_variant(variable_t);
static obj_t cnst_init_137_inline_recursion();
extern bool_t is_recursive__125_inline_recursion(variable_t);
static obj_t arg16141881_inline_recursion(obj_t, obj_t);
extern obj_t variant_args_126_inline_variant(variable_t);
extern obj_t __inlining_reduce_kfactor__26_engine_param;
static let_fun_218_t plain_call_51_inline_recursion(variable_t, node_t, local_t, app_t, obj_t);
extern app_t remove_invariant_args__113_inline_variant(app_t);
static obj_t require_initialization_114_inline_recursion = BUNSPEC;
extern obj_t invariant_args_254_inline_variant(variable_t, obj_t);
extern obj_t var_ast_node;
static obj_t find_recursive_calls_default1330_71_inline_recursion(node_t, variable_t);
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_inline_recursion();
static obj_t unroll_call_164_inline_recursion(variable_t, node_t, local_t, obj_t, app_t, obj_t);
extern node_t nest_loop__92_inline_loop(node_t, local_t, obj_t);
extern obj_t sfun_ast_var;
extern bool_t inline_app__99_inline_app(variable_t, long, long, obj_t);
extern obj_t cast_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
static obj_t find_recursive_calls__36_inline_recursion(obj_t, variable_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern obj_t inline_sfun__229_inline_inline(variable_t, long, obj_t);
extern long class_num_218___object(obj_t);
extern local_t make_local_sfun_184_ast_local(obj_t, type_t, sfun_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t _inline_app_recursive_184_inline_recursion(obj_t, obj_t, obj_t, obj_t);
extern obj_t svar_ast_var;
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern node_t inline_app_recursive_121_inline_recursion(node_t, long, obj_t);
extern bool_t is_loop__232_inline_loop(variable_t);
static obj_t find_recursive_calls_52_inline_recursion(node_t, variable_t);
extern long list_length(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t node_cse__231_reduce_cse(node_t, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t current_function_76_tools_error();
extern node_t alphatize_ast_alphatize(obj_t, obj_t, obj_t, node_t);
extern node_t inline_app_simple_198_inline_simple(node_t, long, obj_t, obj_t);
extern obj_t __optim_unroll_loop___80_engine_param;
extern obj_t app_ast_node;
static obj_t __cnst[3];

DEFINE_STRING(string1885_inline_recursion, string1885_inline_recursion1908, "   inv-args : ", 14);
DEFINE_STRING(string1897_inline_recursion, string1897_inline_recursion1909, "unrolling: ", 11);
DEFINE_STRING(string1886_inline_recursion, string1886_inline_recursion1910, "   rec-calls: ", 14);
DEFINE_STRING(string1895_inline_recursion, string1895_inline_recursion1911, "    plain: ", 11);
DEFINE_STRING(string1892_inline_recursion, string1892_inline_recursion1912, " variable: ", 11);
DEFINE_STRING(string1898_inline_recursion, string1898_inline_recursion1913, "unrolling", 9);
DEFINE_STRING(string1884_inline_recursion, string1884_inline_recursion1914, "   var-args : ", 14);
DEFINE_STRING(string1893_inline_recursion, string1893_inline_recursion1915, "    local: ", 11);
DEFINE_STRING(string1889_inline_recursion, string1889_inline_recursion1916, "         ", 9);
DEFINE_EXPORT_PROCEDURE(inline_app_recursive_env_100_inline_recursion, _inline_app_recursive_184_inline_recursion1917, _inline_app_recursive_184_inline_recursion, 0L, 3);
DEFINE_STRING(string1882_inline_recursion, string1882_inline_recursion1918, "simple", 6);
DEFINE_STRING(string1901_inline_recursion, string1901_inline_recursion1919, "is-recursive?: ", 15);
DEFINE_STRING(string1883_inline_recursion, string1883_inline_recursion1920, "inline-app-recursive: ", 22);
DEFINE_STRING(string1900_inline_recursion, string1900_inline_recursion1921, "  old-body: ", 12);
DEFINE_STATIC_PROCEDURE(find_recursive_calls_default1330_env_136_inline_recursion, _find_recursive_calls_default1330_125_inline_recursion1922, _find_recursive_calls_default1330_125_inline_recursion, 0L, 2);
DEFINE_STRING(string1888_inline_recursion, string1888_inline_recursion1923, " --> ", 5);
DEFINE_STRING(string1896_inline_recursion, string1896_inline_recursion1924, "     call: ", 11);
DEFINE_STRING(string1887_inline_recursion, string1887_inline_recursion1925, " (recursive)", 12);
DEFINE_STRING(string1899_inline_recursion, string1899_inline_recursion1926, "  new-body: ", 12);
DEFINE_STRING(string1902_inline_recursion, string1902_inline_recursion1927, "(SIFUN SGFUN) SFUN INLINE ", 26);
DEFINE_STRING(string1891_inline_recursion, string1891_inline_recursion1928, "Je reinline: ", 13);
DEFINE_STRING(string1894_inline_recursion, string1894_inline_recursion1929, " new-call: ", 11);
DEFINE_EXPORT_PROCEDURE(is_recursive__env_217_inline_recursion, _is_recursive__21_inline_recursion1930, _is_recursive__21_inline_recursion, 0L, 1);
DEFINE_STRING(string1890_inline_recursion, string1890_inline_recursion1931, " ", 1);
DEFINE_STATIC_GENERIC(find_recursive_calls_env_59_inline_recursion, _find_recursive_calls_233_inline_recursion1932, _find_recursive_calls_233_inline_recursion, 0L, 2);

obj_t 
module_initialization_70_inline_recursion(long checksum_1857, char *from_1858)
{
   if (CBOOL(require_initialization_114_inline_recursion))
     {
	require_initialization_114_inline_recursion = BBOOL(((bool_t) 0));
	library_modules_init_112_inline_recursion();
	cnst_init_137_inline_recursion();
	imported_modules_init_94_inline_recursion();
	toplevel_init_63_inline_recursion();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_inline_recursion()
{
   module_initialization_70___r5_control_features_6_4(((long) 0), "INLINE_RECURSION");
   module_initialization_70___object(((long) 0), "INLINE_RECURSION");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_RECURSION");
   module_initialization_70___reader(((long) 0), "INLINE_RECURSION");
   return BUNSPEC;
}


obj_t 
cnst_init_137_inline_recursion()
{
   {
      obj_t cnst_port_138_1849;
      cnst_port_138_1849 = open_input_string(string1902_inline_recursion);
      {
	 long i_1850;
	 i_1850 = ((long) 2);
       loop_1851:
	 {
	    bool_t test1903_1852;
	    test1903_1852 = (i_1850 == ((long) -1));
	    if (test1903_1852)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1904_1853;
		    {
		       obj_t list1905_1854;
		       {
			  obj_t arg1906_1855;
			  arg1906_1855 = BNIL;
			  list1905_1854 = MAKE_PAIR(cnst_port_138_1849, arg1906_1855);
		       }
		       arg1904_1853 = read___reader(list1905_1854);
		    }
		    CNST_TABLE_SET(i_1850, arg1904_1853);
		 }
		 {
		    int aux_1856;
		    {
		       long aux_1876;
		       aux_1876 = (i_1850 - ((long) 1));
		       aux_1856 = (int) (aux_1876);
		    }
		    {
		       long i_1879;
		       i_1879 = (long) (aux_1856);
		       i_1850 = i_1879;
		       goto loop_1851;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_inline_recursion()
{
   add_generic__110___object(find_recursive_calls_env_59_inline_recursion, find_recursive_calls_default1330_env_136_inline_recursion);
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, sequence_ast_node, ((long) 0));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, app_ast_node, ((long) 1));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, app_ly_162_ast_node, ((long) 2));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, funcall_ast_node, ((long) 3));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, pragma_ast_node, ((long) 4));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, cast_ast_node, ((long) 5));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, setq_ast_node, ((long) 6));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, conditional_ast_node, ((long) 7));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, fail_ast_node, ((long) 8));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, select_ast_node, ((long) 9));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, let_fun_218_ast_node, ((long) 10));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, let_var_6_ast_node, ((long) 11));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, set_ex_it_116_ast_node, ((long) 12));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, jump_ex_it_184_ast_node, ((long) 13));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, make_box_202_ast_node, ((long) 14));
   add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, box_ref_242_ast_node, ((long) 15));
   {
      long aux_1898;
      aux_1898 = add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, box_set__221_ast_node, ((long) 16));
      return BINT(aux_1898);
   }
}


node_t 
inline_app_recursive_121_inline_recursion(node_t node_1, long kfactor_2, obj_t stack_3)
{
   {
      bool_t test_1901;
      {
	 obj_t aux_1902;
	 {
	    obj_t aux_1903;
	    {
	       variable_t aux_1904;
	       {
		  var_t arg1369_790;
		  {
		     app_t obj_1534;
		     obj_1534 = (app_t) (node_1);
		     arg1369_790 = (((app_t) CREF(obj_1534))->fun);
		  }
		  aux_1904 = (((var_t) CREF(arg1369_790))->variable);
	       }
	       aux_1903 = (obj_t) (aux_1904);
	    }
	    aux_1902 = memq___r4_pairs_and_lists_6_3(aux_1903, stack_3);
	 }
	 test_1901 = CBOOL(aux_1902);
      }
      if (test_1901)
	{
	   return inline_app_simple_198_inline_simple(node_1, kfactor_2, stack_3, string1882_inline_recursion);
	}
      else
	{
	   {
	      bool_t test1357_780;
	      {
		 obj_t aux_1912;
		 aux_1912 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
		 test1357_780 = CBOOL(aux_1912);
	      }
	      if (test1357_780)
		{
		   obj_t arg1359_782;
		   arg1359_782 = shape_tools_shape((obj_t) (node_1));
		   {
		      obj_t list1360_783;
		      {
			 obj_t arg1361_784;
			 {
			    obj_t arg1363_785;
			    {
			       obj_t aux_1920;
			       aux_1920 = BCHAR(((unsigned char) '\n'));
			       arg1363_785 = MAKE_PAIR(aux_1920, BNIL);
			    }
			    arg1361_784 = MAKE_PAIR(arg1359_782, arg1363_785);
			 }
			 list1360_783 = MAKE_PAIR(string1883_inline_recursion, arg1361_784);
		      }
		      print_trace_107_tools_trace(list1360_783);
		   }
		}
	      else
		{
		   BUNSPEC;
		}
	   }
	   {
	      obj_t labels_node_100_789;
	      labels_node_100_789 = inline_app_labels_34_inline_recursion(node_1, kfactor_2, stack_3);
	      return (node_t) (labels_node_100_789);
	   }
	}
   }
}


obj_t 
_inline_app_recursive_184_inline_recursion(obj_t env_1835, obj_t node_1836, obj_t kfactor_1837, obj_t stack_1838)
{
   {
      node_t aux_1928;
      aux_1928 = inline_app_recursive_121_inline_recursion((node_t) (node_1836), (long) CINT(kfactor_1837), stack_1838);
      return (obj_t) (aux_1928);
   }
}


obj_t 
inline_app_labels_34_inline_recursion(node_t node_4, long kfactor_5, obj_t stack_6)
{
   {
      variable_t variable_791;
      {
	 var_t arg1513_926;
	 {
	    app_t obj_1536;
	    obj_1536 = (app_t) (node_4);
	    arg1513_926 = (((app_t) CREF(obj_1536))->fun);
	 }
	 variable_791 = (((var_t) CREF(arg1513_926))->variable);
      }
      {
	 long call_size_65_792;
	 {
	    long aux_1936;
	    {
	       obj_t aux_1937;
	       {
		  app_t obj_1538;
		  obj_1538 = (app_t) (node_4);
		  aux_1937 = (((app_t) CREF(obj_1538))->args);
	       }
	       aux_1936 = list_length(aux_1937);
	    }
	    call_size_65_792 = (((long) 1) + aux_1936);
	 }
	 {
	    local_t local_793;
	    {
	       sfun_t aux_1942;
	       {
		  value_t aux_1945;
		  aux_1945 = (((variable_t) CREF(variable_791))->value);
		  aux_1942 = (sfun_t) (aux_1945);
	       }
	       local_793 = make_local_sfun_184_ast_local((((variable_t) CREF(variable_791))->id), (((variable_t) CREF(variable_791))->type), aux_1942);
	    }
	    {
	       value_t old_sfun_249_794;
	       old_sfun_249_794 = (((variable_t) CREF(variable_791))->value);
	       {
		  obj_t rec_calls_225_795;
		  {
		     isfun_t obj_1545;
		     obj_1545 = (isfun_t) (old_sfun_249_794);
		     {
			obj_t aux_1951;
			{
			   object_t aux_1952;
			   aux_1952 = (object_t) (obj_1545);
			   aux_1951 = OBJECT_WIDENING(aux_1952);
			}
			rec_calls_225_795 = (((isfun_t) CREF(aux_1951))->recursive_calls_44);
		     }
		  }
		  {
		     obj_t old_args_130_796;
		     {
			sfun_t obj_1546;
			obj_1546 = (sfun_t) (old_sfun_249_794);
			old_args_130_796 = (((sfun_t) CREF(obj_1546))->args);
		     }
		     {
			obj_t inv_args_8_797;
			inv_args_8_797 = invariant_args_254_inline_variant(variable_791, rec_calls_225_795);
			{
			   obj_t var_args_195_798;
			   var_args_195_798 = variant_args_126_inline_variant(variable_791);
			   {
			      obj_t new_args_235_799;
			      if (NULLP(var_args_195_798))
				{
				   new_args_235_799 = BNIL;
				}
			      else
				{
				   obj_t head1305_906;
				   head1305_906 = MAKE_PAIR(BNIL, BNIL);
				   {
				      obj_t l1303_907;
				      obj_t tail1306_908;
				      l1303_907 = var_args_195_798;
				      tail1306_908 = head1305_906;
				    lname1304_909:
				      if (NULLP(l1303_907))
					{
					   new_args_235_799 = CDR(head1305_906);
					}
				      else
					{
					   obj_t new_tail1307_25_911;
					   {
					      local_t arg1497_913;
					      {
						 obj_t l_915;
						 l_915 = CAR(l1303_907);
						 {
						    svar_t arg1499_916;
						    {
						       svar_t res1872_1558;
						       {
							  svar_t new1094_1554;
							  new1094_1554 = ((svar_t) BREF(GC_MALLOC(sizeof(struct svar))));
							  {
							     long arg1740_1555;
							     arg1740_1555 = class_num_218___object(svar_ast_var);
							     {
								obj_t obj_1556;
								obj_1556 = (obj_t) (new1094_1554);
								(((obj_t) CREF(obj_1556))->header = MAKE_HEADER(arg1740_1555, 0), BUNSPEC);
							     }
							  }
							  {
							     object_t aux_1971;
							     aux_1971 = (object_t) (new1094_1554);
							     OBJECT_WIDENING_SET(aux_1971, BFALSE);
							  }
							  {
							     res1872_1558 = new1094_1554;
							  }
						       }
						       arg1499_916 = res1872_1558;
						    }
						    arg1497_913 = clone_local_230_ast_local((local_t) (l_915), (value_t) (arg1499_916));
						 }
					      }
					      {
						 obj_t aux_1977;
						 aux_1977 = (obj_t) (arg1497_913);
						 new_tail1307_25_911 = MAKE_PAIR(aux_1977, BNIL);
					      }
					   }
					   SET_CDR(tail1306_908, new_tail1307_25_911);
					   {
					      obj_t tail1306_1983;
					      obj_t l1303_1981;
					      l1303_1981 = CDR(l1303_907);
					      tail1306_1983 = new_tail1307_25_911;
					      tail1306_908 = tail1306_1983;
					      l1303_907 = l1303_1981;
					      goto lname1304_909;
					   }
					}
				   }
				}
			      {
				 obj_t substitute_800;
				 {
				    obj_t aux_1984;
				    {
				       app_t obj_1564;
				       obj_1564 = (app_t) (node_4);
				       aux_1984 = (((app_t) CREF(obj_1564))->args);
				    }
				    substitute_800 = substitutions_inline_variant(variable_791, aux_1984, new_args_235_799);
				 }
				 {
				    obj_t old_body_129_801;
				    {
				       bool_t test1490_902;
				       test1490_902 = is_a__118___object((obj_t) (old_sfun_249_794), isfun_inline_inline);
				       if (test1490_902)
					 {
					    isfun_t obj_1566;
					    obj_1566 = (isfun_t) (old_sfun_249_794);
					    {
					       node_t aux_1992;
					       {
						  obj_t aux_1993;
						  {
						     object_t aux_1994;
						     aux_1994 = (object_t) (obj_1566);
						     aux_1993 = OBJECT_WIDENING(aux_1994);
						  }
						  aux_1992 = (((isfun_t) CREF(aux_1993))->original_body_40);
					       }
					       old_body_129_801 = (obj_t) (aux_1992);
					    }
					 }
				       else
					 {
					    sfun_t obj_1567;
					    obj_1567 = (sfun_t) (old_sfun_249_794);
					    old_body_129_801 = (((sfun_t) CREF(obj_1567))->body);
					 }
				    }
				    {
				       obj_t svg_calls_args_120_802;
				       if (NULLP(rec_calls_225_795))
					 {
					    svg_calls_args_120_802 = BNIL;
					 }
				       else
					 {
					    obj_t head1312_890;
					    head1312_890 = MAKE_PAIR(BNIL, BNIL);
					    {
					       obj_t l1309_891;
					       obj_t tail1313_892;
					       l1309_891 = rec_calls_225_795;
					       tail1313_892 = head1312_890;
					     lname1311_893:
					       if (NULLP(l1309_891))
						 {
						    svg_calls_args_120_802 = CDR(head1312_890);
						 }
					       else
						 {
						    obj_t new_tail1314_39_895;
						    {
						       obj_t aux_2007;
						       {
							  app_t obj_1574;
							  {
							     obj_t aux_2008;
							     aux_2008 = CAR(l1309_891);
							     obj_1574 = (app_t) (aux_2008);
							  }
							  aux_2007 = (((app_t) CREF(obj_1574))->args);
						       }
						       new_tail1314_39_895 = MAKE_PAIR(aux_2007, BNIL);
						    }
						    SET_CDR(tail1313_892, new_tail1314_39_895);
						    {
						       obj_t tail1313_2016;
						       obj_t l1309_2014;
						       l1309_2014 = CDR(l1309_891);
						       tail1313_2016 = new_tail1314_39_895;
						       tail1313_892 = tail1313_2016;
						       l1309_891 = l1309_2014;
						       goto lname1311_893;
						    }
						 }
					    }
					 }
				       {
					  bool_t remove__21_803;
					  {
					     obj_t l1315_883;
					     l1315_883 = rec_calls_225_795;
					   lname1316_884:
					     if (PAIRP(l1315_883))
					       {
						  {
						     app_t aux_2019;
						     {
							obj_t aux_2020;
							aux_2020 = CAR(l1315_883);
							aux_2019 = (app_t) (aux_2020);
						     }
						     remove_invariant_args__113_inline_variant(aux_2019);
						  }
						  {
						     obj_t l1315_2024;
						     l1315_2024 = CDR(l1315_883);
						     l1315_883 = l1315_2024;
						     goto lname1316_884;
						  }
					       }
					     else
					       {
						  remove__21_803 = ((bool_t) 1);
					       }
					  }
					  {
					     node_t new_body_215_804;
					     {
						obj_t arg1476_880;
						obj_t arg1477_881;
						obj_t arg1478_882;
						{
						   obj_t aux_2026;
						   aux_2026 = (obj_t) (variable_791);
						   arg1476_880 = MAKE_PAIR(aux_2026, old_args_130_796);
						}
						{
						   obj_t aux_2029;
						   aux_2029 = (obj_t) (local_793);
						   arg1477_881 = MAKE_PAIR(aux_2029, substitute_800);
						}
						arg1478_882 = (((node_t) CREF(node_4))->loc);
						new_body_215_804 = alphatize_ast_alphatize(arg1476_880, arg1477_881, arg1478_882, (node_t) (old_body_129_801));
					     }
					     {
						bool_t restore__176_805;
						{
						   obj_t ll1317_872;
						   obj_t ll1318_873;
						   ll1317_872 = rec_calls_225_795;
						   ll1318_873 = svg_calls_args_120_802;
						 lname1319_874:
						   if (NULLP(ll1317_872))
						     {
							restore__176_805 = ((bool_t) 1);
						     }
						   else
						     {
							{
							   obj_t args_877;
							   args_877 = CAR(ll1318_873);
							   {
							      obj_t res1873_1593;
							      {
								 app_t obj_1591;
								 {
								    obj_t aux_2038;
								    aux_2038 = CAR(ll1317_872);
								    obj_1591 = (app_t) (aux_2038);
								 }
								 {
								    obj_t x_1846;
								    x_1846 = ((((app_t) CREF(obj_1591))->args) = ((obj_t) args_877), BUNSPEC);
								    res1873_1593 = BUNSPEC;
								 }
							      }
							      res1873_1593;
							   }
							}
							{
							   obj_t ll1318_2044;
							   obj_t ll1317_2042;
							   ll1317_2042 = CDR(ll1317_872);
							   ll1318_2044 = CDR(ll1318_873);
							   ll1318_873 = ll1318_2044;
							   ll1317_872 = ll1317_2042;
							   goto lname1319_874;
							}
						     }
						}
						{
						   sfun_t new_sfun_134_806;
						   {
						      sfun_t duplicated1320_862;
						      duplicated1320_862 = (sfun_t) (old_sfun_249_794);
						      {
							 long arg1457_863;
							 obj_t arg1458_864;
							 obj_t arg1461_865;
							 obj_t arg1463_866;
							 bool_t arg1465_867;
							 obj_t arg1466_868;
							 obj_t arg1467_869;
							 obj_t arg1468_870;
							 obj_t arg1470_871;
							 arg1457_863 = (((sfun_t) CREF(duplicated1320_862))->arity);
							 arg1458_864 = (((sfun_t) CREF(duplicated1320_862))->side_effect__165);
							 arg1461_865 = (((sfun_t) CREF(duplicated1320_862))->predicate_of_78);
							 arg1463_866 = (((sfun_t) CREF(duplicated1320_862))->stack_allocator_172);
							 arg1465_867 = (((sfun_t) CREF(duplicated1320_862))->top__138);
							 arg1466_868 = (((sfun_t) CREF(duplicated1320_862))->the_closure_238);
							 arg1467_869 = (((sfun_t) CREF(duplicated1320_862))->property);
							 arg1468_870 = CNST_TABLE_REF(((long) 1));
							 arg1470_871 = (((sfun_t) CREF(duplicated1320_862))->dsssl_keywords_243);
							 {
							    sfun_t res1874_1630;
							    {
							       obj_t body_1612;
							       body_1612 = (obj_t) (new_body_215_804);
							       {
								  sfun_t new1070_1615;
								  new1070_1615 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
								  {
								     long arg1745_1616;
								     arg1745_1616 = class_num_218___object(sfun_ast_var);
								     {
									obj_t obj_1628;
									obj_1628 = (obj_t) (new1070_1615);
									(((obj_t) CREF(obj_1628))->header = MAKE_HEADER(arg1745_1616, 0), BUNSPEC);
								     }
								  }
								  {
								     object_t aux_2061;
								     aux_2061 = (object_t) (new1070_1615);
								     OBJECT_WIDENING_SET(aux_2061, BFALSE);
								  }
								  ((((sfun_t) CREF(new1070_1615))->arity) = ((long) arg1457_863), BUNSPEC);
								  ((((sfun_t) CREF(new1070_1615))->side_effect__165) = ((obj_t) arg1458_864), BUNSPEC);
								  ((((sfun_t) CREF(new1070_1615))->predicate_of_78) = ((obj_t) arg1461_865), BUNSPEC);
								  ((((sfun_t) CREF(new1070_1615))->stack_allocator_172) = ((obj_t) arg1463_866), BUNSPEC);
								  ((((sfun_t) CREF(new1070_1615))->top__138) = ((bool_t) arg1465_867), BUNSPEC);
								  ((((sfun_t) CREF(new1070_1615))->the_closure_238) = ((obj_t) arg1466_868), BUNSPEC);
								  ((((sfun_t) CREF(new1070_1615))->property) = ((obj_t) arg1467_869), BUNSPEC);
								  ((((sfun_t) CREF(new1070_1615))->args) = ((obj_t) new_args_235_799), BUNSPEC);
								  ((((sfun_t) CREF(new1070_1615))->body) = ((obj_t) body_1612), BUNSPEC);
								  ((((sfun_t) CREF(new1070_1615))->class) = ((obj_t) arg1468_870), BUNSPEC);
								  ((((sfun_t) CREF(new1070_1615))->dsssl_keywords_243) = ((obj_t) arg1470_871), BUNSPEC);
								  res1874_1630 = new1070_1615;
							       }
							    }
							    new_sfun_134_806 = res1874_1630;
							 }
						      }
						   }
						   {
						      obj_t new_kfactor_216_807;
						      new_kfactor_216_807 = PROCEDURE_ENTRY(__inlining_reduce_kfactor__26_engine_param) (__inlining_reduce_kfactor__26_engine_param, BINT(kfactor_5), BEOA);
						      {
							 {
							    obj_t res1875_1633;
							    {
							       value_t val1054_1632;
							       val1054_1632 = (value_t) (new_sfun_134_806);
							       {
								  obj_t x_1847;
								  x_1847 = ((((local_t) CREF(local_793))->value) = ((value_t) val1054_1632), BUNSPEC);
								  res1875_1633 = BUNSPEC;
							       }
							    }
							    res1875_1633;
							 }
							 {
							    bool_t test1370_808;
							    {
							       obj_t aux_2080;
							       aux_2080 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
							       test1370_808 = CBOOL(aux_2080);
							    }
							    if (test1370_808)
							      {
								 obj_t arg1376_810;
								 obj_t arg1380_812;
								 obj_t arg1382_814;
								 arg1376_810 = shape_tools_shape(rec_calls_225_795);
								 arg1380_812 = shape_tools_shape(inv_args_8_797);
								 arg1382_814 = shape_tools_shape(var_args_195_798);
								 {
								    obj_t list1383_815;
								    {
								       obj_t arg1385_816;
								       {
									  obj_t arg1388_817;
									  {
									     obj_t arg1390_818;
									     {
										obj_t arg1391_819;
										{
										   obj_t arg1396_820;
										   {
										      obj_t arg1398_821;
										      {
											 obj_t arg1400_822;
											 {
											    obj_t arg1402_823;
											    {
											       obj_t aux_2089;
											       aux_2089 = BCHAR(((unsigned char) '\n'));
											       arg1402_823 = MAKE_PAIR(aux_2089, BNIL);
											    }
											    arg1400_822 = MAKE_PAIR(arg1382_814, arg1402_823);
											 }
											 arg1398_821 = MAKE_PAIR(string1884_inline_recursion, arg1400_822);
										      }
										      {
											 obj_t aux_2094;
											 aux_2094 = BCHAR(((unsigned char) '\n'));
											 arg1396_820 = MAKE_PAIR(aux_2094, arg1398_821);
										      }
										   }
										   arg1391_819 = MAKE_PAIR(arg1380_812, arg1396_820);
										}
										arg1390_818 = MAKE_PAIR(string1885_inline_recursion, arg1391_819);
									     }
									     {
										obj_t aux_2099;
										aux_2099 = BCHAR(((unsigned char) '\n'));
										arg1388_817 = MAKE_PAIR(aux_2099, arg1390_818);
									     }
									  }
									  arg1385_816 = MAKE_PAIR(arg1376_810, arg1388_817);
								       }
								       list1383_815 = MAKE_PAIR(string1886_inline_recursion, arg1385_816);
								    }
								    print_trace_107_tools_trace(list1383_815);
								 }
							      }
							    else
							      {
								 BUNSPEC;
							      }
							 }
							 {
							    bool_t test_2105;
							    {
							       obj_t aux_2106;
							       {
								  obj_t aux_2107;
								  {
								     sfun_t obj_1634;
								     obj_1634 = (sfun_t) (old_sfun_249_794);
								     aux_2107 = (((sfun_t) CREF(obj_1634))->class);
								  }
								  aux_2106 = memq___r4_pairs_and_lists_6_3(aux_2107, CNST_TABLE_REF(((long) 2)));
							       }
							       test_2105 = CBOOL(aux_2106);
							    }
							    if (test_2105)
							      {
								 BUNSPEC;
							      }
							    else
							      {
								 obj_t arg1411_830;
								 obj_t arg1414_832;
								 arg1411_830 = shape_tools_shape((obj_t) (variable_791));
								 arg1414_832 = current_function_76_tools_error();
								 {
								    obj_t list1416_834;
								    {
								       obj_t arg1417_835;
								       {
									  obj_t arg1418_836;
									  {
									     obj_t arg1420_837;
									     {
										obj_t arg1421_838;
										{
										   obj_t arg1424_839;
										   {
										      obj_t aux_2116;
										      aux_2116 = BCHAR(((unsigned char) '\n'));
										      arg1424_839 = MAKE_PAIR(aux_2116, BNIL);
										   }
										   arg1421_838 = MAKE_PAIR(string1887_inline_recursion, arg1424_839);
										}
										arg1420_837 = MAKE_PAIR(arg1414_832, arg1421_838);
									     }
									     arg1418_836 = MAKE_PAIR(string1888_inline_recursion, arg1420_837);
									  }
									  arg1417_835 = MAKE_PAIR(arg1411_830, arg1418_836);
								       }
								       list1416_834 = MAKE_PAIR(string1889_inline_recursion, arg1417_835);
								    }
								    verbose_tools_speek(BINT(((long) 3)), list1416_834);
								 }
							      }
							 }
							 {
							    bool_t test1429_843;
							    {
							       obj_t aux_2126;
							       aux_2126 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
							       test1429_843 = CBOOL(aux_2126);
							    }
							    if (test1429_843)
							      {
								 obj_t arg1432_845;
								 obj_t arg1441_847;
								 arg1432_845 = shape_tools_shape((obj_t) (local_793));
								 {
								    obj_t aux_2134;
								    {
								       sfun_t obj_1636;
								       {
									  value_t aux_2135;
									  aux_2135 = (((local_t) CREF(local_793))->value);
									  obj_1636 = (sfun_t) (aux_2135);
								       }
								       aux_2134 = (((sfun_t) CREF(obj_1636))->body);
								    }
								    arg1441_847 = shape_tools_shape(aux_2134);
								 }
								 {
								    obj_t list1442_848;
								    {
								       obj_t arg1444_849;
								       {
									  obj_t arg1445_850;
									  {
									     obj_t arg1446_851;
									     {
										obj_t arg1447_852;
										{
										   obj_t aux_2140;
										   aux_2140 = BCHAR(((unsigned char) '\n'));
										   arg1447_852 = MAKE_PAIR(aux_2140, BNIL);
										}
										arg1446_851 = MAKE_PAIR(arg1441_847, arg1447_852);
									     }
									     arg1445_850 = MAKE_PAIR(string1890_inline_recursion, arg1446_851);
									  }
									  arg1444_849 = MAKE_PAIR(arg1432_845, arg1445_850);
								       }
								       list1442_848 = MAKE_PAIR(string1891_inline_recursion, arg1444_849);
								    }
								    print_trace_107_tools_trace(list1442_848);
								 }
							      }
							    else
							      {
								 BUNSPEC;
							      }
							 }
							 inline_sfun__229_inline_inline((variable_t) (local_793), (long) CINT(new_kfactor_216_807), stack_6);
							 {
							    app_t new_call_202_858;
							    new_call_202_858 = remove_invariant_args__113_inline_variant((app_t) (node_4));
							    {
							       bool_t test1454_859;
							       if (CBOOL(__optim_unroll_loop___80_engine_param))
								 {
								    bool_t test1455_860;
								    test1455_860 = is_loop__232_inline_loop(variable_791);
								    if (test1455_860)
								      {
									 bool_t test1456_861;
									 test1456_861 = inner_loop__79_inline_loop(variable_791);
									 if (test1456_861)
									   {
									      test1454_859 = ((bool_t) 0);
									   }
									 else
									   {
									      test1454_859 = inline_app__99_inline_app((variable_t) (local_793), (long) CINT(new_kfactor_216_807), call_size_65_792, stack_6);
									   }
								      }
								    else
								      {
									 test1454_859 = ((bool_t) 0);
								      }
								 }
							       else
								 {
								    test1454_859 = ((bool_t) 0);
								 }
							       if (test1454_859)
								 {
								    return unroll_call_164_inline_recursion(variable_791, node_4, local_793, new_kfactor_216_807, new_call_202_858, stack_6);
								 }
							       else
								 {
								    let_fun_218_t aux_2164;
								    aux_2164 = plain_call_51_inline_recursion(variable_791, node_4, local_793, new_call_202_858, stack_6);
								    return (obj_t) (aux_2164);
								 }
							    }
							 }
						      }
						   }
						}
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


let_fun_218_t 
plain_call_51_inline_recursion(variable_t variable_7, node_t node_8, local_t local_9, app_t new_call_202_10, obj_t stack_11)
{
   {
      bool_t test1514_927;
      {
	 obj_t aux_2167;
	 aux_2167 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
	 test1514_927 = CBOOL(aux_2167);
      }
      if (test1514_927)
	{
	   obj_t arg1518_929;
	   obj_t arg1522_931;
	   obj_t arg1524_933;
	   obj_t arg1529_935;
	   arg1518_929 = shape_tools_shape((obj_t) (node_8));
	   arg1522_931 = shape_tools_shape((obj_t) (new_call_202_10));
	   arg1524_933 = shape_tools_shape((obj_t) (local_9));
	   arg1529_935 = shape_tools_shape((obj_t) (variable_7));
	   {
	      obj_t list1530_936;
	      {
		 obj_t arg1531_937;
		 {
		    obj_t arg1532_938;
		    {
		       obj_t arg1534_939;
		       {
			  obj_t arg1535_940;
			  {
			     obj_t arg1536_941;
			     {
				obj_t arg1537_942;
				{
				   obj_t arg1538_943;
				   {
				      obj_t arg1539_944;
				      {
					 obj_t arg1540_945;
					 {
					    obj_t arg1541_946;
					    {
					       obj_t arg1542_947;
					       {
						  obj_t aux_2181;
						  aux_2181 = BCHAR(((unsigned char) '\n'));
						  arg1542_947 = MAKE_PAIR(aux_2181, BNIL);
					       }
					       arg1541_946 = MAKE_PAIR(arg1529_935, arg1542_947);
					    }
					    arg1540_945 = MAKE_PAIR(string1892_inline_recursion, arg1541_946);
					 }
					 {
					    obj_t aux_2186;
					    aux_2186 = BCHAR(((unsigned char) '\n'));
					    arg1539_944 = MAKE_PAIR(aux_2186, arg1540_945);
					 }
				      }
				      arg1538_943 = MAKE_PAIR(arg1524_933, arg1539_944);
				   }
				   arg1537_942 = MAKE_PAIR(string1893_inline_recursion, arg1538_943);
				}
				{
				   obj_t aux_2191;
				   aux_2191 = BCHAR(((unsigned char) '\n'));
				   arg1536_941 = MAKE_PAIR(aux_2191, arg1537_942);
				}
			     }
			     arg1535_940 = MAKE_PAIR(arg1522_931, arg1536_941);
			  }
			  arg1534_939 = MAKE_PAIR(string1894_inline_recursion, arg1535_940);
		       }
		       {
			  obj_t aux_2196;
			  aux_2196 = BCHAR(((unsigned char) '\n'));
			  arg1532_938 = MAKE_PAIR(aux_2196, arg1534_939);
		       }
		    }
		    arg1531_937 = MAKE_PAIR(arg1518_929, arg1532_938);
		 }
		 list1530_936 = MAKE_PAIR(string1895_inline_recursion, arg1531_937);
	      }
	      print_trace_107_tools_trace(list1530_936);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   shrink_args__237_inline_variant(variable_7);
   {
      obj_t loc_951;
      loc_951 = (((node_t) CREF(node_8))->loc);
      {
	 type_t arg1550_952;
	 obj_t arg1551_953;
	 node_t arg1552_954;
	 arg1550_952 = (((node_t) CREF(node_8))->type);
	 {
	    obj_t list1553_955;
	    {
	       obj_t aux_2205;
	       aux_2205 = (obj_t) (local_9);
	       list1553_955 = MAKE_PAIR(aux_2205, BNIL);
	    }
	    arg1551_953 = list1553_955;
	 }
	 {
	    obj_t arg1555_957;
	    obj_t arg1557_958;
	    {
	       obj_t list1558_959;
	       {
		  obj_t aux_2208;
		  aux_2208 = (obj_t) (variable_7);
		  list1558_959 = MAKE_PAIR(aux_2208, BNIL);
	       }
	       arg1555_957 = list1558_959;
	    }
	    {
	       obj_t list1560_961;
	       {
		  obj_t aux_2211;
		  aux_2211 = (obj_t) (local_9);
		  list1560_961 = MAKE_PAIR(aux_2211, BNIL);
	       }
	       arg1557_958 = list1560_961;
	    }
	    arg1552_954 = alphatize_ast_alphatize(arg1555_957, arg1557_958, loc_951, (node_t) (new_call_202_10));
	 }
	 {
	    let_fun_218_t res1876_1656;
	    {
	       let_fun_218_t new1221_1647;
	       new1221_1647 = ((let_fun_218_t) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
	       {
		  long arg1691_1648;
		  arg1691_1648 = class_num_218___object(let_fun_218_ast_node);
		  {
		     obj_t obj_1654;
		     obj_1654 = (obj_t) (new1221_1647);
		     (((obj_t) CREF(obj_1654))->header = MAKE_HEADER(arg1691_1648, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_2220;
		  aux_2220 = (object_t) (new1221_1647);
		  OBJECT_WIDENING_SET(aux_2220, BFALSE);
	       }
	       ((((let_fun_218_t) CREF(new1221_1647))->loc) = ((obj_t) loc_951), BUNSPEC);
	       ((((let_fun_218_t) CREF(new1221_1647))->type) = ((type_t) arg1550_952), BUNSPEC);
	       ((((let_fun_218_t) CREF(new1221_1647))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
	       ((((let_fun_218_t) CREF(new1221_1647))->locals) = ((obj_t) arg1551_953), BUNSPEC);
	       ((((let_fun_218_t) CREF(new1221_1647))->body) = ((node_t) arg1552_954), BUNSPEC);
	       res1876_1656 = new1221_1647;
	    }
	    return res1876_1656;
	 }
      }
   }
}


obj_t 
unroll_call_164_inline_recursion(variable_t variable_12, node_t node_13, local_t local_14, obj_t kfactor_15, app_t call_16, obj_t stack_17)
{
   {
      bool_t test1562_963;
      {
	 obj_t aux_2228;
	 aux_2228 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
	 test1562_963 = CBOOL(aux_2228);
      }
      if (test1562_963)
	{
	   obj_t arg1564_965;
	   obj_t arg1566_967;
	   obj_t arg1568_969;
	   obj_t arg1571_971;
	   arg1564_965 = shape_tools_shape((obj_t) (node_13));
	   arg1566_967 = shape_tools_shape((obj_t) (call_16));
	   arg1568_969 = shape_tools_shape((obj_t) (local_14));
	   arg1571_971 = shape_tools_shape((obj_t) (variable_12));
	   {
	      obj_t list1572_972;
	      {
		 obj_t arg1573_973;
		 {
		    obj_t arg1574_974;
		    {
		       obj_t arg1575_975;
		       {
			  obj_t arg1576_976;
			  {
			     obj_t arg1577_977;
			     {
				obj_t arg1578_978;
				{
				   obj_t arg1579_979;
				   {
				      obj_t arg1582_980;
				      {
					 obj_t arg1583_981;
					 {
					    obj_t arg1584_982;
					    {
					       obj_t arg1585_983;
					       {
						  obj_t aux_2242;
						  aux_2242 = BCHAR(((unsigned char) '\n'));
						  arg1585_983 = MAKE_PAIR(aux_2242, BNIL);
					       }
					       arg1584_982 = MAKE_PAIR(arg1571_971, arg1585_983);
					    }
					    arg1583_981 = MAKE_PAIR(string1892_inline_recursion, arg1584_982);
					 }
					 {
					    obj_t aux_2247;
					    aux_2247 = BCHAR(((unsigned char) '\n'));
					    arg1582_980 = MAKE_PAIR(aux_2247, arg1583_981);
					 }
				      }
				      arg1579_979 = MAKE_PAIR(arg1568_969, arg1582_980);
				   }
				   arg1578_978 = MAKE_PAIR(string1893_inline_recursion, arg1579_979);
				}
				{
				   obj_t aux_2252;
				   aux_2252 = BCHAR(((unsigned char) '\n'));
				   arg1577_977 = MAKE_PAIR(aux_2252, arg1578_978);
				}
			     }
			     arg1576_976 = MAKE_PAIR(arg1566_967, arg1577_977);
			  }
			  arg1575_975 = MAKE_PAIR(string1896_inline_recursion, arg1576_976);
		       }
		       {
			  obj_t aux_2257;
			  aux_2257 = BCHAR(((unsigned char) '\n'));
			  arg1574_974 = MAKE_PAIR(aux_2257, arg1575_975);
		       }
		    }
		    arg1573_973 = MAKE_PAIR(arg1564_965, arg1574_974);
		 }
		 list1572_972 = MAKE_PAIR(string1897_inline_recursion, arg1573_973);
	      }
	      print_trace_107_tools_trace(list1572_972);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t loc_987;
      {
	 node_t obj_1657;
	 obj_1657 = (node_t) (call_16);
	 loc_987 = (((node_t) CREF(obj_1657))->loc);
      }
      {
	 node_t new_call_202_988;
	 {
	    obj_t arg1624_1020;
	    obj_t arg1626_1021;
	    {
	       obj_t list1627_1022;
	       {
		  obj_t aux_2265;
		  aux_2265 = (obj_t) (variable_12);
		  list1627_1022 = MAKE_PAIR(aux_2265, BNIL);
	       }
	       arg1624_1020 = list1627_1022;
	    }
	    {
	       obj_t list1629_1024;
	       {
		  obj_t aux_2268;
		  aux_2268 = (obj_t) (local_14);
		  list1629_1024 = MAKE_PAIR(aux_2268, BNIL);
	       }
	       arg1626_1021 = list1629_1024;
	    }
	    new_call_202_988 = alphatize_ast_alphatize(arg1624_1020, arg1626_1021, loc_987, (node_t) (call_16));
	 }
	 {
	    obj_t old_body_129_989;
	    {
	       sfun_t obj_1661;
	       {
		  value_t aux_2273;
		  aux_2273 = (((variable_t) CREF(variable_12))->value);
		  obj_1661 = (sfun_t) (aux_2273);
	       }
	       old_body_129_989 = (((sfun_t) CREF(obj_1661))->body);
	    }
	    {
	       node_t new_body_215_990;
	       {
		  obj_t arg1620_1017;
		  {
		     obj_t aux_2277;
		     aux_2277 = (obj_t) (local_14);
		     arg1620_1017 = MAKE_PAIR(aux_2277, stack_17);
		  }
		  new_body_215_990 = inline_app_simple_198_inline_simple(new_call_202_988, (long) CINT(kfactor_15), arg1620_1017, string1898_inline_recursion);
	       }
	       {
		  {
		     bool_t test1590_991;
		     {
			obj_t aux_2282;
			aux_2282 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 4)));
			test1590_991 = CBOOL(aux_2282);
		     }
		     if (test1590_991)
		       {
			  obj_t arg1592_993;
			  obj_t arg1595_995;
			  arg1592_993 = shape_tools_shape(old_body_129_989);
			  arg1595_995 = shape_tools_shape((obj_t) (new_body_215_990));
			  {
			     obj_t list1596_996;
			     {
				obj_t arg1597_997;
				{
				   obj_t arg1600_998;
				   {
				      obj_t arg1601_999;
				      {
					 obj_t arg1603_1000;
					 {
					    obj_t arg1604_1001;
					    {
					       obj_t aux_2291;
					       aux_2291 = BCHAR(((unsigned char) '\n'));
					       arg1604_1001 = MAKE_PAIR(aux_2291, BNIL);
					    }
					    arg1603_1000 = MAKE_PAIR(arg1595_995, arg1604_1001);
					 }
					 arg1601_999 = MAKE_PAIR(string1899_inline_recursion, arg1603_1000);
				      }
				      {
					 obj_t aux_2296;
					 aux_2296 = BCHAR(((unsigned char) '\n'));
					 arg1600_998 = MAKE_PAIR(aux_2296, arg1601_999);
				      }
				   }
				   arg1597_997 = MAKE_PAIR(arg1592_993, arg1600_998);
				}
				list1596_996 = MAKE_PAIR(string1900_inline_recursion, arg1597_997);
			     }
			     print_trace_107_tools_trace(list1596_996);
			  }
		       }
		     else
		       {
			  BUNSPEC;
		       }
		  }
		  shrink_args__237_inline_variant(variable_12);
		  {
		     obj_t __1005;
		     {
			node_t arg1609_1007;
			{
			   obj_t arg1614_1839;
			   arg1614_1839 = make_fx_procedure(arg16141881_inline_recursion, ((long) 1), ((long) 2));
			   {
			      obj_t aux_2304;
			      aux_2304 = (obj_t) (local_14);
			      PROCEDURE_SET(arg1614_1839, ((long) 0), aux_2304);
			   }
			   PROCEDURE_SET(arg1614_1839, ((long) 1), loc_987);
			   arg1609_1007 = nest_loop__92_inline_loop(new_body_215_990, local_14, arg1614_1839);
			}
			__1005 = node_cse__231_reduce_cse(arg1609_1007, BNIL);
		     }
		     {
			obj_t node_1006;
			node_1006 = __res1__155___r5_control_features_6_4;
			return node_1006;
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
arg16141881_inline_recursion(obj_t env_1840, obj_t node_1843)
{
   {
      obj_t local_1841;
      obj_t loc_1842;
      local_1841 = PROCEDURE_REF(env_1840, ((long) 0));
      loc_1842 = PROCEDURE_REF(env_1840, ((long) 1));
      {
	 obj_t node_1010;
	 {
	    let_fun_218_t aux_2312;
	    node_1010 = node_1843;
	    {
	       type_t arg1616_1012;
	       obj_t arg1617_1013;
	       {
		  node_t obj_1664;
		  obj_1664 = (node_t) (node_1010);
		  arg1616_1012 = (((node_t) CREF(obj_1664))->type);
	       }
	       {
		  obj_t list1618_1014;
		  list1618_1014 = MAKE_PAIR(local_1841, BNIL);
		  arg1617_1013 = list1618_1014;
	       }
	       {
		  let_fun_218_t res1877_1680;
		  {
		     node_t body_1670;
		     body_1670 = (node_t) (node_1010);
		     {
			let_fun_218_t new1221_1671;
			new1221_1671 = ((let_fun_218_t) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
			{
			   long arg1691_1672;
			   arg1691_1672 = class_num_218___object(let_fun_218_ast_node);
			   {
			      obj_t obj_1678;
			      obj_1678 = (obj_t) (new1221_1671);
			      (((obj_t) CREF(obj_1678))->header = MAKE_HEADER(arg1691_1672, 0), BUNSPEC);
			   }
			}
			{
			   object_t aux_2321;
			   aux_2321 = (object_t) (new1221_1671);
			   OBJECT_WIDENING_SET(aux_2321, BFALSE);
			}
			((((let_fun_218_t) CREF(new1221_1671))->loc) = ((obj_t) loc_1842), BUNSPEC);
			((((let_fun_218_t) CREF(new1221_1671))->type) = ((type_t) arg1616_1012), BUNSPEC);
			((((let_fun_218_t) CREF(new1221_1671))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			((((let_fun_218_t) CREF(new1221_1671))->locals) = ((obj_t) arg1617_1013), BUNSPEC);
			((((let_fun_218_t) CREF(new1221_1671))->body) = ((node_t) body_1670), BUNSPEC);
			res1877_1680 = new1221_1671;
		     }
		  }
		  aux_2312 = res1877_1680;
	       }
	    }
	    return (obj_t) (aux_2312);
	 }
      }
   }
}


bool_t 
is_recursive__125_inline_recursion(variable_t var_18)
{
   {
      bool_t test1631_1026;
      {
	 obj_t aux_2330;
	 aux_2330 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1631_1026 = CBOOL(aux_2330);
      }
      if (test1631_1026)
	{
	   obj_t arg1634_1028;
	   arg1634_1028 = shape_tools_shape((obj_t) (var_18));
	   {
	      obj_t list1635_1029;
	      {
		 obj_t arg1637_1030;
		 {
		    obj_t arg1638_1031;
		    {
		       obj_t aux_2338;
		       aux_2338 = BCHAR(((unsigned char) '\n'));
		       arg1638_1031 = MAKE_PAIR(aux_2338, BNIL);
		    }
		    arg1637_1030 = MAKE_PAIR(arg1634_1028, arg1638_1031);
		 }
		 list1635_1029 = MAKE_PAIR(string1901_inline_recursion, arg1637_1030);
	      }
	      print_trace_107_tools_trace(list1635_1029);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      value_t sfun_1035;
      sfun_1035 = (((variable_t) CREF(var_18))->value);
      {
	 bool_t test1644_1036;
	 test1644_1036 = is_a__118___object((obj_t) (sfun_1035), isfun_inline_inline);
	 if (test1644_1036)
	   {
	      bool_t test_2348;
	      {
		 obj_t aux_2349;
		 {
		    isfun_t obj_1683;
		    obj_1683 = (isfun_t) (sfun_1035);
		    {
		       obj_t aux_2351;
		       {
			  object_t aux_2352;
			  aux_2352 = (object_t) (obj_1683);
			  aux_2351 = OBJECT_WIDENING(aux_2352);
		       }
		       aux_2349 = (((isfun_t) CREF(aux_2351))->recursive_calls_44);
		    }
		 }
		 test_2348 = PAIRP(aux_2349);
	      }
	      if (test_2348)
		{
		   return ((bool_t) 1);
		}
	      else
		{
		   bool_t test_2357;
		   {
		      obj_t aux_2358;
		      {
			 isfun_t obj_1685;
			 obj_1685 = (isfun_t) (sfun_1035);
			 {
			    obj_t aux_2360;
			    {
			       object_t aux_2361;
			       aux_2361 = (object_t) (obj_1685);
			       aux_2360 = OBJECT_WIDENING(aux_2361);
			    }
			    aux_2358 = (((isfun_t) CREF(aux_2360))->recursive_calls_44);
			 }
		      }
		      test_2357 = NULLP(aux_2358);
		   }
		   if (test_2357)
		     {
			return ((bool_t) 0);
		     }
		   else
		     {
			{
			   obj_t calls_1039;
			   {
			      node_t aux_2366;
			      {
				 isfun_t obj_1687;
				 obj_1687 = (isfun_t) (sfun_1035);
				 {
				    obj_t aux_2368;
				    {
				       object_t aux_2369;
				       aux_2369 = (object_t) (obj_1687);
				       aux_2368 = OBJECT_WIDENING(aux_2369);
				    }
				    aux_2366 = (((isfun_t) CREF(aux_2368))->original_body_40);
				 }
			      }
			      calls_1039 = find_recursive_calls_52_inline_recursion(aux_2366, var_18);
			   }
			   {
			      obj_t res1878_1690;
			      {
				 isfun_t obj_1688;
				 obj_1688 = (isfun_t) (sfun_1035);
				 {
				    obj_t x_1848;
				    {
				       obj_t aux_2375;
				       {
					  object_t aux_2376;
					  aux_2376 = (object_t) (obj_1688);
					  aux_2375 = OBJECT_WIDENING(aux_2376);
				       }
				       x_1848 = ((((isfun_t) CREF(aux_2375))->recursive_calls_44) = ((obj_t) calls_1039), BUNSPEC);
				    }
				    res1878_1690 = BUNSPEC;
				 }
			      }
			      res1878_1690;
			   }
			   return PAIRP(calls_1039);
			}
		     }
		}
	   }
	 else
	   {
	      obj_t calls_1043;
	      {
		 node_t aux_2381;
		 {
		    obj_t aux_2382;
		    {
		       sfun_t obj_1692;
		       obj_1692 = (sfun_t) (sfun_1035);
		       aux_2382 = (((sfun_t) CREF(obj_1692))->body);
		    }
		    aux_2381 = (node_t) (aux_2382);
		 }
		 calls_1043 = find_recursive_calls_52_inline_recursion(aux_2381, var_18);
	      }
	      {
		 isfun_t obj1322_1044;
		 obj1322_1044 = ((isfun_t) (sfun_1035));
		 {
		    isfun_t arg1651_1045;
		    {
		       isfun_t res1879_1699;
		       {
			  node_t original_body_40_1694;
			  {
			     obj_t aux_2388;
			     {
				sfun_t obj_1693;
				obj_1693 = (sfun_t) (sfun_1035);
				aux_2388 = (((sfun_t) CREF(obj_1693))->body);
			     }
			     original_body_40_1694 = (node_t) (aux_2388);
			  }
			  {
			     isfun_t new1273_1696;
			     new1273_1696 = ((isfun_t) BREF(GC_MALLOC(sizeof(struct isfun))));
			     ((((isfun_t) CREF(new1273_1696))->original_body_40) = ((node_t) original_body_40_1694), BUNSPEC);
			     ((((isfun_t) CREF(new1273_1696))->recursive_calls_44) = ((obj_t) calls_1043), BUNSPEC);
			     res1879_1699 = new1273_1696;
			  }
		       }
		       arg1651_1045 = res1879_1699;
		    }
		    {
		       obj_t aux_2397;
		       object_t aux_2395;
		       aux_2397 = (obj_t) (arg1651_1045);
		       aux_2395 = (object_t) (obj1322_1044);
		       OBJECT_WIDENING_SET(aux_2395, aux_2397);
		    }
		 }
		 {
		    long arg1653_1047;
		    arg1653_1047 = class_num_218___object(isfun_inline_inline);
		    {
		       obj_t obj_1700;
		       obj_1700 = (obj_t) (obj1322_1044);
		       (((obj_t) CREF(obj_1700))->header = MAKE_HEADER(arg1653_1047, 0), BUNSPEC);
		    }
		 }
		 obj1322_1044;
	      }
	      return PAIRP(calls_1043);
	   }
      }
   }
}


obj_t 
_is_recursive__21_inline_recursion(obj_t env_1844, obj_t var_1845)
{
   {
      bool_t aux_2404;
      aux_2404 = is_recursive__125_inline_recursion((variable_t) (var_1845));
      return BBOOL(aux_2404);
   }
}


obj_t 
find_recursive_calls_default1330_71_inline_recursion(node_t node_21, variable_t var_22)
{
   return BNIL;
}


obj_t 
_find_recursive_calls_default1330_125_inline_recursion(obj_t env_1832, obj_t node_1833, obj_t var_1834)
{
   return find_recursive_calls_default1330_71_inline_recursion((node_t) (node_1833), (variable_t) (var_1834));
}


obj_t 
find_recursive_calls_52_inline_recursion(node_t node_19, variable_t var_20)
{
 find_recursive_calls_52_inline_recursion:
   {
      obj_t method1763_1389;
      obj_t class1768_1390;
      {
	 obj_t arg1771_1387;
	 obj_t arg1772_1388;
	 {
	    object_t obj_1703;
	    obj_1703 = (object_t) (node_19);
	    {
	       obj_t pre_method_105_1704;
	       pre_method_105_1704 = PROCEDURE_REF(find_recursive_calls_env_59_inline_recursion, ((long) 2));
	       if (INTEGERP(pre_method_105_1704))
		 {
		    PROCEDURE_SET(find_recursive_calls_env_59_inline_recursion, ((long) 2), BUNSPEC);
		    arg1771_1387 = pre_method_105_1704;
		 }
	       else
		 {
		    long obj_class_num_177_1709;
		    obj_class_num_177_1709 = TYPE(obj_1703);
		    {
		       obj_t arg1183_1710;
		       arg1183_1710 = PROCEDURE_REF(find_recursive_calls_env_59_inline_recursion, ((long) 1));
		       {
			  long arg1184_1714;
			  {
			     long arg1186_1715;
			     arg1186_1715 = OBJECT_TYPE;
			     arg1184_1714 = (obj_class_num_177_1709 - arg1186_1715);
			  }
			  arg1771_1387 = VECTOR_REF(arg1183_1710, arg1184_1714);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1720;
	    object_1720 = (object_t) (node_19);
	    {
	       long arg1187_1721;
	       {
		  long arg1188_1722;
		  long arg1189_1723;
		  arg1188_1722 = TYPE(object_1720);
		  arg1189_1723 = OBJECT_TYPE;
		  arg1187_1721 = (arg1188_1722 - arg1189_1723);
	       }
	       {
		  obj_t vector_1727;
		  vector_1727 = __classes__134___object;
		  arg1772_1388 = VECTOR_REF(vector_1727, arg1187_1721);
	       }
	    }
	 }
	 method1763_1389 = arg1771_1387;
	 class1768_1390 = arg1772_1388;
	 {
	    if (INTEGERP(method1763_1389))
	      {
		 switch ((long) CINT(method1763_1389))
		   {
		   case ((long) 0):
		      {
			 sequence_t node_1396;
			 node_1396 = (sequence_t) (node_19);
			 return find_recursive_calls__36_inline_recursion((((sequence_t) CREF(node_1396))->nodes), var_20);
		      }
		      break;
		   case ((long) 1):
		      {
			 app_t node_1399;
			 node_1399 = (app_t) (node_19);
			 {
			    obj_t args_calls_209_1402;
			    args_calls_209_1402 = find_recursive_calls__36_inline_recursion((((app_t) CREF(node_1399))->args), var_20);
			    {
			       bool_t test1776_1403;
			       {
				  bool_t test1777_1404;
				  {
				     obj_t aux_2434;
				     {
					var_t aux_2435;
					aux_2435 = (((app_t) CREF(node_1399))->fun);
					aux_2434 = (obj_t) (aux_2435);
				     }
				     test1777_1404 = is_a__118___object(aux_2434, var_ast_node);
				  }
				  if (test1777_1404)
				    {
				       obj_t aux_2445;
				       obj_t aux_2440;
				       aux_2445 = (obj_t) (var_20);
				       {
					  variable_t aux_2441;
					  {
					     var_t arg1779_1406;
					     arg1779_1406 = (((app_t) CREF(node_1399))->fun);
					     aux_2441 = (((var_t) CREF(arg1779_1406))->variable);
					  }
					  aux_2440 = (obj_t) (aux_2441);
				       }
				       test1776_1403 = (aux_2440 == aux_2445);
				    }
				  else
				    {
				       test1776_1403 = ((bool_t) 0);
				    }
			       }
			       if (test1776_1403)
				 {
				    obj_t aux_2449;
				    aux_2449 = (obj_t) (node_1399);
				    return MAKE_PAIR(aux_2449, args_calls_209_1402);
				 }
			       else
				 {
				    return args_calls_209_1402;
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 2):
		      {
			 app_ly_162_t node_1409;
			 node_1409 = (app_ly_162_t) (node_19);
			 {
			    obj_t arg1783_1412;
			    obj_t arg1784_1413;
			    arg1783_1412 = find_recursive_calls_52_inline_recursion((((app_ly_162_t) CREF(node_1409))->fun), var_20);
			    arg1784_1413 = find_recursive_calls_52_inline_recursion((((app_ly_162_t) CREF(node_1409))->arg), var_20);
			    return append_2_18___r4_pairs_and_lists_6_3(arg1783_1412, arg1784_1413);
			 }
		      }
		      break;
		   case ((long) 3):
		      {
			 funcall_t node_1416;
			 node_1416 = (funcall_t) (node_19);
			 {
			    obj_t arg1788_1419;
			    obj_t arg1789_1420;
			    arg1788_1419 = find_recursive_calls_52_inline_recursion((((funcall_t) CREF(node_1416))->fun), var_20);
			    arg1789_1420 = find_recursive_calls__36_inline_recursion((((funcall_t) CREF(node_1416))->args), var_20);
			    return append_2_18___r4_pairs_and_lists_6_3(arg1788_1419, arg1789_1420);
			 }
		      }
		      break;
		   case ((long) 4):
		      {
			 pragma_t node_1423;
			 node_1423 = (pragma_t) (node_19);
			 return find_recursive_calls__36_inline_recursion((((pragma_t) CREF(node_1423))->args), var_20);
		      }
		      break;
		   case ((long) 5):
		      {
			 cast_t node_1426;
			 node_1426 = (cast_t) (node_19);
			 {
			    node_t node_2468;
			    node_2468 = (((cast_t) CREF(node_1426))->arg);
			    node_19 = node_2468;
			    goto find_recursive_calls_52_inline_recursion;
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 setq_t node_1429;
			 node_1429 = (setq_t) (node_19);
			 {
			    node_t node_2471;
			    node_2471 = (((setq_t) CREF(node_1429))->value);
			    node_19 = node_2471;
			    goto find_recursive_calls_52_inline_recursion;
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 conditional_t node_1432;
			 node_1432 = (conditional_t) (node_19);
			 {
			    obj_t arg1798_1435;
			    obj_t arg1799_1436;
			    obj_t arg1800_1437;
			    arg1798_1435 = find_recursive_calls_52_inline_recursion((((conditional_t) CREF(node_1432))->test), var_20);
			    arg1799_1436 = find_recursive_calls_52_inline_recursion((((conditional_t) CREF(node_1432))->true), var_20);
			    arg1800_1437 = find_recursive_calls_52_inline_recursion((((conditional_t) CREF(node_1432))->false), var_20);
			    {
			       obj_t list1801_1438;
			       {
				  obj_t arg1802_1439;
				  {
				     obj_t arg1804_1440;
				     arg1804_1440 = MAKE_PAIR(arg1800_1437, BNIL);
				     arg1802_1439 = MAKE_PAIR(arg1799_1436, arg1804_1440);
				  }
				  list1801_1438 = MAKE_PAIR(arg1798_1435, arg1802_1439);
			       }
			       return append___r4_pairs_and_lists_6_3(list1801_1438);
			    }
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 fail_t node_1445;
			 node_1445 = (fail_t) (node_19);
			 {
			    obj_t arg1809_1448;
			    obj_t arg1810_1449;
			    obj_t arg1811_1450;
			    arg1809_1448 = find_recursive_calls_52_inline_recursion((((fail_t) CREF(node_1445))->proc), var_20);
			    arg1810_1449 = find_recursive_calls_52_inline_recursion((((fail_t) CREF(node_1445))->msg), var_20);
			    arg1811_1450 = find_recursive_calls_52_inline_recursion((((fail_t) CREF(node_1445))->obj), var_20);
			    {
			       obj_t list1812_1451;
			       {
				  obj_t arg1813_1452;
				  {
				     obj_t arg1814_1453;
				     arg1814_1453 = MAKE_PAIR(arg1811_1450, BNIL);
				     arg1813_1452 = MAKE_PAIR(arg1810_1449, arg1814_1453);
				  }
				  list1812_1451 = MAKE_PAIR(arg1809_1448, arg1813_1452);
			       }
			       return append___r4_pairs_and_lists_6_3(list1812_1451);
			    }
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 select_t node_1458;
			 node_1458 = (select_t) (node_19);
			 {
			    obj_t clauses_1460;
			    obj_t calls_1461;
			    {
			       obj_t arg1823_1463;
			       obj_t arg1824_1464;
			       arg1823_1463 = (((select_t) CREF(node_1458))->clauses);
			       arg1824_1464 = find_recursive_calls_52_inline_recursion((((select_t) CREF(node_1458))->test), var_20);
			       clauses_1460 = arg1823_1463;
			       calls_1461 = arg1824_1464;
			     loop_1462:
			       if (NULLP(clauses_1460))
				 {
				    return calls_1461;
				 }
			       else
				 {
				    obj_t arg1827_1467;
				    obj_t arg1828_1468;
				    arg1827_1467 = CDR(clauses_1460);
				    {
				       obj_t arg1829_1469;
				       {
					  node_t aux_2502;
					  {
					     obj_t aux_2503;
					     {
						obj_t aux_2504;
						aux_2504 = CAR(clauses_1460);
						aux_2503 = CDR(aux_2504);
					     }
					     aux_2502 = (node_t) (aux_2503);
					  }
					  arg1829_1469 = find_recursive_calls_52_inline_recursion(aux_2502, var_20);
				       }
				       arg1828_1468 = append_2_18___r4_pairs_and_lists_6_3(arg1829_1469, calls_1461);
				    }
				    {
				       obj_t calls_2511;
				       obj_t clauses_2510;
				       clauses_2510 = arg1827_1467;
				       calls_2511 = arg1828_1468;
				       calls_1461 = calls_2511;
				       clauses_1460 = clauses_2510;
				       goto loop_1462;
				    }
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 let_fun_218_t node_1472;
			 node_1472 = (let_fun_218_t) (node_19);
			 {
			    obj_t locals_1474;
			    obj_t calls_1475;
			    {
			       obj_t arg1832_1477;
			       obj_t arg1833_1478;
			       arg1832_1477 = (((let_fun_218_t) CREF(node_1472))->locals);
			       arg1833_1478 = find_recursive_calls_52_inline_recursion((((let_fun_218_t) CREF(node_1472))->body), var_20);
			       locals_1474 = arg1832_1477;
			       calls_1475 = arg1833_1478;
			     loop_1476:
			       if (NULLP(locals_1474))
				 {
				    return calls_1475;
				 }
			       else
				 {
				    obj_t arg1836_1481;
				    obj_t arg1837_1482;
				    arg1836_1481 = CDR(locals_1474);
				    {
				       obj_t arg1838_1483;
				       {
					  node_t aux_2519;
					  {
					     obj_t aux_2520;
					     {
						sfun_t obj_1764;
						{
						   value_t aux_2521;
						   {
						      local_t obj_1763;
						      {
							 obj_t aux_2522;
							 aux_2522 = CAR(locals_1474);
							 obj_1763 = (local_t) (aux_2522);
						      }
						      aux_2521 = (((local_t) CREF(obj_1763))->value);
						   }
						   obj_1764 = (sfun_t) (aux_2521);
						}
						aux_2520 = (((sfun_t) CREF(obj_1764))->body);
					     }
					     aux_2519 = (node_t) (aux_2520);
					  }
					  arg1838_1483 = find_recursive_calls_52_inline_recursion(aux_2519, var_20);
				       }
				       arg1837_1482 = append_2_18___r4_pairs_and_lists_6_3(calls_1475, arg1838_1483);
				    }
				    {
				       obj_t calls_2532;
				       obj_t locals_2531;
				       locals_2531 = arg1836_1481;
				       calls_2532 = arg1837_1482;
				       calls_1475 = calls_2532;
				       locals_1474 = locals_2531;
				       goto loop_1476;
				    }
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 let_var_6_t node_1487;
			 node_1487 = (let_var_6_t) (node_19);
			 {
			    obj_t bindings_1489;
			    obj_t calls_1490;
			    {
			       obj_t arg1842_1492;
			       obj_t arg1843_1493;
			       arg1842_1492 = (((let_var_6_t) CREF(node_1487))->bindings);
			       arg1843_1493 = find_recursive_calls_52_inline_recursion((((let_var_6_t) CREF(node_1487))->body), var_20);
			       bindings_1489 = arg1842_1492;
			       calls_1490 = arg1843_1493;
			     loop_1491:
			       if (NULLP(bindings_1489))
				 {
				    return calls_1490;
				 }
			       else
				 {
				    obj_t arg1846_1496;
				    obj_t arg1847_1497;
				    arg1846_1496 = CDR(bindings_1489);
				    {
				       obj_t arg1848_1498;
				       {
					  node_t aux_2540;
					  {
					     obj_t aux_2541;
					     {
						obj_t aux_2542;
						aux_2542 = CAR(bindings_1489);
						aux_2541 = CDR(aux_2542);
					     }
					     aux_2540 = (node_t) (aux_2541);
					  }
					  arg1848_1498 = find_recursive_calls_52_inline_recursion(aux_2540, var_20);
				       }
				       arg1847_1497 = append_2_18___r4_pairs_and_lists_6_3(calls_1490, arg1848_1498);
				    }
				    {
				       obj_t calls_2549;
				       obj_t bindings_2548;
				       bindings_2548 = arg1846_1496;
				       calls_2549 = arg1847_1497;
				       calls_1490 = calls_2549;
				       bindings_1489 = bindings_2548;
				       goto loop_1491;
				    }
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 set_ex_it_116_t node_1501;
			 node_1501 = (set_ex_it_116_t) (node_19);
			 {
			    node_t node_2551;
			    node_2551 = (((set_ex_it_116_t) CREF(node_1501))->body);
			    node_19 = node_2551;
			    goto find_recursive_calls_52_inline_recursion;
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 jump_ex_it_184_t node_1504;
			 node_1504 = (jump_ex_it_184_t) (node_19);
			 {
			    obj_t arg1855_1507;
			    obj_t arg1856_1508;
			    arg1855_1507 = find_recursive_calls_52_inline_recursion((((jump_ex_it_184_t) CREF(node_1504))->exit), var_20);
			    arg1856_1508 = find_recursive_calls_52_inline_recursion((((jump_ex_it_184_t) CREF(node_1504))->value), var_20);
			    return append_2_18___r4_pairs_and_lists_6_3(arg1855_1507, arg1856_1508);
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 make_box_202_t node_1511;
			 node_1511 = (make_box_202_t) (node_19);
			 {
			    node_t node_2560;
			    node_2560 = (((make_box_202_t) CREF(node_1511))->value);
			    node_19 = node_2560;
			    goto find_recursive_calls_52_inline_recursion;
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 box_ref_242_t node_1514;
			 node_1514 = (box_ref_242_t) (node_19);
			 {
			    node_t node_2563;
			    {
			       var_t aux_2564;
			       aux_2564 = (((box_ref_242_t) CREF(node_1514))->var);
			       node_2563 = (node_t) (aux_2564);
			    }
			    node_19 = node_2563;
			    goto find_recursive_calls_52_inline_recursion;
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 box_set__221_t node_1517;
			 node_1517 = (box_set__221_t) (node_19);
			 {
			    obj_t arg1861_1520;
			    obj_t arg1862_1521;
			    {
			       node_t aux_2568;
			       {
				  var_t aux_2569;
				  aux_2569 = (((box_set__221_t) CREF(node_1517))->var);
				  aux_2568 = (node_t) (aux_2569);
			       }
			       arg1861_1520 = find_recursive_calls_52_inline_recursion(aux_2568, var_20);
			    }
			    arg1862_1521 = find_recursive_calls_52_inline_recursion((((box_set__221_t) CREF(node_1517))->value), var_20);
			    return append_2_18___r4_pairs_and_lists_6_3(arg1861_1520, arg1862_1521);
			 }
		      }
		      break;
		   default:
		    case_else1769_75_1393:
		      if (PROCEDUREP(method1763_1389))
			{
			   return PROCEDURE_ENTRY(method1763_1389) (method1763_1389, (obj_t) (node_19), (obj_t) (var_20), BEOA);
			}
		      else
			{
			   obj_t fun1655_1049;
			   fun1655_1049 = PROCEDURE_REF(find_recursive_calls_env_59_inline_recursion, ((long) 0));
			   return PROCEDURE_ENTRY(fun1655_1049) (fun1655_1049, (obj_t) (node_19), (obj_t) (var_20), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1769_75_1393;
	      }
	 }
      }
   }
}


obj_t 
_find_recursive_calls_233_inline_recursion(obj_t env_1829, obj_t node_1830, obj_t var_1831)
{
   return find_recursive_calls_52_inline_recursion((node_t) (node_1830), (variable_t) (var_1831));
}


obj_t 
find_recursive_calls__36_inline_recursion(obj_t node__221_57, variable_t var_58)
{
   {
      obj_t node__221_1050;
      obj_t calls_1051;
      node__221_1050 = node__221_57;
      calls_1051 = BNIL;
    loop_1052:
      if (NULLP(node__221_1050))
	{
	   return calls_1051;
	}
      else
	{
	   obj_t arg1659_1055;
	   obj_t arg1661_1056;
	   arg1659_1055 = CDR(node__221_1050);
	   {
	      obj_t arg1663_1057;
	      {
		 node_t aux_2595;
		 {
		    obj_t aux_2596;
		    aux_2596 = CAR(node__221_1050);
		    aux_2595 = (node_t) (aux_2596);
		 }
		 arg1663_1057 = find_recursive_calls_52_inline_recursion(aux_2595, var_58);
	      }
	      arg1661_1056 = append_2_18___r4_pairs_and_lists_6_3(arg1663_1057, calls_1051);
	   }
	   {
	      obj_t calls_2602;
	      obj_t node__221_2601;
	      node__221_2601 = arg1659_1055;
	      calls_2602 = arg1661_1056;
	      calls_1051 = calls_2602;
	      node__221_1050 = node__221_2601;
	      goto loop_1052;
	   }
	}
   }
}


obj_t 
imported_modules_init_94_inline_recursion()
{
   module_initialization_70_tools_trace(((long) 0), "INLINE_RECURSION");
   module_initialization_70_engine_param(((long) 0), "INLINE_RECURSION");
   module_initialization_70_type_type(((long) 0), "INLINE_RECURSION");
   module_initialization_70_ast_var(((long) 0), "INLINE_RECURSION");
   module_initialization_70_ast_node(((long) 0), "INLINE_RECURSION");
   module_initialization_70_ast_local(((long) 0), "INLINE_RECURSION");
   module_initialization_70_ast_alphatize(((long) 0), "INLINE_RECURSION");
   module_initialization_70_ast_sexp(((long) 0), "INLINE_RECURSION");
   module_initialization_70_tools_speek(((long) 0), "INLINE_RECURSION");
   module_initialization_70_tools_shape(((long) 0), "INLINE_RECURSION");
   module_initialization_70_tools_error(((long) 0), "INLINE_RECURSION");
   module_initialization_70_inline_inline(((long) 0), "INLINE_RECURSION");
   module_initialization_70_inline_simple(((long) 0), "INLINE_RECURSION");
   module_initialization_70_inline_variant(((long) 0), "INLINE_RECURSION");
   module_initialization_70_inline_loop(((long) 0), "INLINE_RECURSION");
   module_initialization_70_inline_app(((long) 0), "INLINE_RECURSION");
   return module_initialization_70_reduce_cse(((long) 0), "INLINE_RECURSION");
}
