/*===========================================================================*/
/*   (Inline/simple.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_t;


extern obj_t isfun_inline_inline;
extern obj_t _inline_app_simple_231_inline_simple(obj_t, obj_t, obj_t, obj_t, obj_t);
extern local_t clone_local_230_ast_local(local_t, value_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_inline_simple();
extern obj_t module_initialization_70_inline_simple(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_inline_size(long, char *);
extern obj_t module_initialization_70_ast_alphatize(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_effect_spread(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t cnst_init_137_inline_simple();
extern obj_t __inlining_reduce_kfactor__26_engine_param;
extern node_t inline_node_218_inline_inline(node_t, long, obj_t);
static obj_t require_initialization_114_inline_simple = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_inline_simple();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t svar_ast_var;
extern bool_t side_effect__165_effect_effect(node_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _____74_type_cache;
extern obj_t __obj__252_type_cache;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
extern obj_t current_function_76_tools_error();
extern bool_t spread_side_effect__136_effect_spread(node_t);
extern node_t alphatize_ast_alphatize(obj_t, obj_t, obj_t, node_t);
extern node_t inline_app_simple_198_inline_simple(node_t, long, obj_t, obj_t);
static obj_t __cnst[4];

DEFINE_STRING(string1548_inline_simple, string1548_inline_simple1559, " --> ", 5);
DEFINE_STRING(string1553_inline_simple, string1553_inline_simple1560, "RES (SIFUN SGFUN) READ INLINE ", 30);
DEFINE_STRING(string1550_inline_simple, string1550_inline_simple1561, "        sur le body: ", 21);
DEFINE_STRING(string1549_inline_simple, string1549_inline_simple1562, "         ", 9);
DEFINE_STRING(string1552_inline_simple, string1552_inline_simple1563, "J'alphatize: ", 13);
DEFINE_STRING(string1546_inline_simple, string1546_inline_simple1564, "inline-app-simple: ", 19);
DEFINE_STRING(string1547_inline_simple, string1547_inline_simple1565, " (", 2);
DEFINE_STRING(string1551_inline_simple, string1551_inline_simple1566, " ", 1);
DEFINE_EXPORT_PROCEDURE(inline_app_simple_env_207_inline_simple, _inline_app_simple_231_inline_simple1567, _inline_app_simple_231_inline_simple, 0L, 4);

obj_t 
module_initialization_70_inline_simple(long checksum_1287, char *from_1288)
{
   if (CBOOL(require_initialization_114_inline_simple))
     {
	require_initialization_114_inline_simple = BBOOL(((bool_t) 0));
	library_modules_init_112_inline_simple();
	cnst_init_137_inline_simple();
	imported_modules_init_94_inline_simple();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_inline_simple()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_SIMPLE");
   module_initialization_70___object(((long) 0), "INLINE_SIMPLE");
   module_initialization_70___reader(((long) 0), "INLINE_SIMPLE");
   module_initialization_70___r4_symbols_6_4(((long) 0), "INLINE_SIMPLE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_inline_simple()
{
   {
      obj_t cnst_port_138_1279;
      cnst_port_138_1279 = open_input_string(string1553_inline_simple);
      {
	 long i_1280;
	 i_1280 = ((long) 3);
       loop_1281:
	 {
	    bool_t test1554_1282;
	    test1554_1282 = (i_1280 == ((long) -1));
	    if (test1554_1282)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1555_1283;
		    {
		       obj_t list1556_1284;
		       {
			  obj_t arg1557_1285;
			  arg1557_1285 = BNIL;
			  list1556_1284 = MAKE_PAIR(cnst_port_138_1279, arg1557_1285);
		       }
		       arg1555_1283 = read___reader(list1556_1284);
		    }
		    CNST_TABLE_SET(i_1280, arg1555_1283);
		 }
		 {
		    int aux_1286;
		    {
		       long aux_1305;
		       aux_1305 = (i_1280 - ((long) 1));
		       aux_1286 = (int) (aux_1305);
		    }
		    {
		       long i_1308;
		       i_1308 = (long) (aux_1286);
		       i_1280 = i_1308;
		       goto loop_1281;
		    }
		 }
	      }
	 }
      }
   }
}


node_t 
inline_app_simple_198_inline_simple(node_t node_1, long kfactor_2, obj_t stack_3, obj_t msg_4)
{
   {
      bool_t test1296_685;
      {
	 obj_t aux_1310;
	 aux_1310 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1296_685 = CBOOL(aux_1310);
      }
      if (test1296_685)
	{
	   obj_t arg1298_687;
	   arg1298_687 = shape_tools_shape((obj_t) (node_1));
	   {
	      obj_t list1299_688;
	      {
		 obj_t arg1300_689;
		 {
		    obj_t arg1303_690;
		    {
		       obj_t aux_1318;
		       aux_1318 = BCHAR(((unsigned char) '\n'));
		       arg1303_690 = MAKE_PAIR(aux_1318, BNIL);
		    }
		    arg1300_689 = MAKE_PAIR(arg1298_687, arg1303_690);
		 }
		 list1299_688 = MAKE_PAIR(string1546_inline_simple, arg1300_689);
	      }
	      print_trace_107_tools_trace(list1299_688);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      variable_t callee_694;
      {
	 var_t arg1426_804;
	 {
	    app_t obj_1124;
	    obj_1124 = (app_t) (node_1);
	    arg1426_804 = (((app_t) CREF(obj_1124))->fun);
	 }
	 callee_694 = (((var_t) CREF(arg1426_804))->variable);
      }
      {
	 value_t sfun_695;
	 sfun_695 = (((variable_t) CREF(callee_694))->value);
	 {
	    obj_t formals_696;
	    {
	       sfun_t obj_1127;
	       obj_1127 = (sfun_t) (sfun_695);
	       formals_696 = (((sfun_t) CREF(obj_1127))->args);
	    }
	    {
	       obj_t actuals_697;
	       {
		  app_t obj_1128;
		  obj_1128 = (app_t) (node_1);
		  actuals_697 = (((app_t) CREF(obj_1128))->args);
	       }
	       {
		  obj_t reductors_698;
		  if (NULLP(formals_696))
		    {
		       reductors_698 = BNIL;
		    }
		  else
		    {
		       obj_t head1291_783;
		       head1291_783 = MAKE_PAIR(BNIL, BNIL);
		       {
			  obj_t ll1289_784;
			  obj_t ll1290_785;
			  obj_t tail1292_786;
			  ll1289_784 = formals_696;
			  ll1290_785 = actuals_697;
			  tail1292_786 = head1291_783;
			lname1294_787:
			  if (NULLP(ll1289_784))
			    {
			       reductors_698 = CDR(head1291_783);
			    }
			  else
			    {
			       obj_t new_tail1293_138_789;
			       {
				  obj_t arg1412_792;
				  {
				     obj_t f_794;
				     obj_t a_795;
				     f_794 = CAR(ll1289_784);
				     a_795 = CAR(ll1290_785);
				     {
					bool_t test1415_796;
					{
					   bool_t test1417_799;
					   test1417_799 = is_a__118___object(a_795, closure_ast_node);
					   if (test1417_799)
					     {
						obj_t aux_1345;
						obj_t aux_1342;
						aux_1345 = CNST_TABLE_REF(((long) 1));
						{
						   local_t obj_1137;
						   obj_1137 = (local_t) (f_794);
						   aux_1342 = (((local_t) CREF(obj_1137))->access);
						}
						test1415_796 = (aux_1342 == aux_1345);
					     }
					   else
					     {
						test1415_796 = ((bool_t) 0);
					     }
					}
					if (test1415_796)
					  {
					     closure_t obj_1140;
					     obj_1140 = (closure_t) (a_795);
					     {
						variable_t aux_1350;
						aux_1350 = (((closure_t) CREF(obj_1140))->variable);
						arg1412_792 = (obj_t) (aux_1350);
					     }
					  }
					else
					  {
					     svar_t arg1416_797;
					     {
						svar_t res1542_1146;
						{
						   svar_t new1093_1142;
						   new1093_1142 = ((svar_t) BREF(GC_MALLOC(sizeof(struct svar))));
						   {
						      long arg1518_1143;
						      arg1518_1143 = class_num_218___object(svar_ast_var);
						      {
							 obj_t obj_1144;
							 obj_1144 = (obj_t) (new1093_1142);
							 (((obj_t) CREF(obj_1144))->header = MAKE_HEADER(arg1518_1143, 0), BUNSPEC);
						      }
						   }
						   {
						      object_t aux_1357;
						      aux_1357 = (object_t) (new1093_1142);
						      OBJECT_WIDENING_SET(aux_1357, BFALSE);
						   }
						   {
						      res1542_1146 = new1093_1142;
						   }
						}
						arg1416_797 = res1542_1146;
					     }
					     {
						local_t aux_1360;
						aux_1360 = clone_local_230_ast_local((local_t) (f_794), (value_t) (arg1416_797));
						arg1412_792 = (obj_t) (aux_1360);
					     }
					  }
				     }
				  }
				  new_tail1293_138_789 = MAKE_PAIR(arg1412_792, BNIL);
			       }
			       SET_CDR(tail1292_786, new_tail1293_138_789);
			       {
				  obj_t tail1292_1371;
				  obj_t ll1290_1369;
				  obj_t ll1289_1367;
				  ll1289_1367 = CDR(ll1289_784);
				  ll1290_1369 = CDR(ll1290_785);
				  tail1292_1371 = new_tail1293_138_789;
				  tail1292_786 = tail1292_1371;
				  ll1290_785 = ll1290_1369;
				  ll1289_784 = ll1289_1367;
				  goto lname1294_787;
			       }
			    }
		       }
		    }
		  {
		     obj_t bindings_699;
		     {
			obj_t reductors_760;
			obj_t actuals_761;
			obj_t res_762;
			reductors_760 = reductors_698;
			actuals_761 = actuals_697;
			res_762 = BNIL;
		      loop_763:
			if (NULLP(actuals_761))
			  {
			     bindings_699 = reverse__39___r4_pairs_and_lists_6_3(res_762);
			  }
			else
			  {
			     bool_t test1381_766;
			     {
				bool_t test1401_775;
				test1401_775 = is_a__118___object(CAR(actuals_761), closure_ast_node);
				if (test1401_775)
				  {
				     obj_t aux_1380;
				     obj_t aux_1378;
				     {
					variable_t aux_1381;
					{
					   closure_t obj_1158;
					   {
					      obj_t aux_1382;
					      aux_1382 = CAR(actuals_761);
					      obj_1158 = (closure_t) (aux_1382);
					   }
					   aux_1381 = (((closure_t) CREF(obj_1158))->variable);
					}
					aux_1380 = (obj_t) (aux_1381);
				     }
				     aux_1378 = CAR(reductors_760);
				     test1381_766 = (aux_1378 == aux_1380);
				  }
				else
				  {
				     test1381_766 = ((bool_t) 0);
				  }
			     }
			     if (test1381_766)
			       {
				  {
				     obj_t actuals_1391;
				     obj_t reductors_1389;
				     reductors_1389 = CDR(reductors_760);
				     actuals_1391 = CDR(actuals_761);
				     actuals_761 = actuals_1391;
				     reductors_760 = reductors_1389;
				     goto loop_763;
				  }
			       }
			     else
			       {
				  {
				     obj_t arg1388_769;
				     obj_t arg1390_770;
				     obj_t arg1391_771;
				     arg1388_769 = CDR(reductors_760);
				     arg1390_770 = CDR(actuals_761);
				     {
					obj_t arg1396_772;
					{
					   obj_t aux_1397;
					   obj_t aux_1395;
					   aux_1397 = CAR(actuals_761);
					   aux_1395 = CAR(reductors_760);
					   arg1396_772 = MAKE_PAIR(aux_1395, aux_1397);
					}
					arg1391_771 = MAKE_PAIR(arg1396_772, res_762);
				     }
				     {
					obj_t res_1403;
					obj_t actuals_1402;
					obj_t reductors_1401;
					reductors_1401 = arg1388_769;
					actuals_1402 = arg1390_770;
					res_1403 = arg1391_771;
					res_762 = res_1403;
					actuals_761 = actuals_1402;
					reductors_760 = reductors_1401;
					goto loop_763;
				     }
				  }
			       }
			  }
		     }
		     {
			obj_t body_700;
			{
			   bool_t test1377_759;
			   test1377_759 = is_a__118___object((obj_t) (sfun_695), isfun_inline_inline);
			   if (test1377_759)
			     {
				isfun_t obj_1172;
				obj_1172 = (isfun_t) (sfun_695);
				{
				   node_t aux_1408;
				   {
				      obj_t aux_1409;
				      {
					 object_t aux_1410;
					 aux_1410 = (object_t) (obj_1172);
					 aux_1409 = OBJECT_WIDENING(aux_1410);
				      }
				      aux_1408 = (((isfun_t) CREF(aux_1409))->original_body_40);
				   }
				   body_700 = (obj_t) (aux_1408);
				}
			     }
			   else
			     {
				sfun_t obj_1173;
				obj_1173 = (sfun_t) (sfun_695);
				body_700 = (((sfun_t) CREF(obj_1173))->body);
			     }
			}
			{
			   obj_t new_kfactor_216_702;
			   new_kfactor_216_702 = PROCEDURE_ENTRY(__inlining_reduce_kfactor__26_engine_param) (__inlining_reduce_kfactor__26_engine_param, BINT(kfactor_2), BEOA);
			   {
			      obj_t loc_703;
			      loc_703 = (((node_t) CREF(node_1))->loc);
			      {
				 type_t type_704;
				 type_704 = (((node_t) CREF(node_1))->type);
				 {
				    {
				       bool_t test_1422;
				       {
					  obj_t aux_1423;
					  {
					     obj_t aux_1424;
					     {
						sfun_t obj_1177;
						obj_1177 = (sfun_t) (sfun_695);
						aux_1424 = (((sfun_t) CREF(obj_1177))->class);
					     }
					     aux_1423 = memq___r4_pairs_and_lists_6_3(aux_1424, CNST_TABLE_REF(((long) 2)));
					  }
					  test_1422 = CBOOL(aux_1423);
				       }
				       if (test_1422)
					 {
					    BUNSPEC;
					 }
				       else
					 {
					    obj_t arg1312_708;
					    obj_t arg1314_710;
					    arg1312_708 = shape_tools_shape((obj_t) (callee_694));
					    arg1314_710 = current_function_76_tools_error();
					    {
					       obj_t list1316_712;
					       {
						  obj_t arg1318_713;
						  {
						     obj_t arg1319_714;
						     {
							obj_t arg1320_715;
							{
							   obj_t arg1321_716;
							   {
							      obj_t arg1322_717;
							      {
								 obj_t arg1323_718;
								 {
								    obj_t arg1325_719;
								    {
								       obj_t aux_1433;
								       aux_1433 = BCHAR(((unsigned char) '\n'));
								       arg1325_719 = MAKE_PAIR(aux_1433, BNIL);
								    }
								    {
								       obj_t aux_1436;
								       aux_1436 = BCHAR(((unsigned char) ')'));
								       arg1323_718 = MAKE_PAIR(aux_1436, arg1325_719);
								    }
								 }
								 arg1322_717 = MAKE_PAIR(msg_4, arg1323_718);
							      }
							      arg1321_716 = MAKE_PAIR(string1547_inline_simple, arg1322_717);
							   }
							   arg1320_715 = MAKE_PAIR(arg1314_710, arg1321_716);
							}
							arg1319_714 = MAKE_PAIR(string1548_inline_simple, arg1320_715);
						     }
						     arg1318_713 = MAKE_PAIR(arg1312_708, arg1319_714);
						  }
						  list1316_712 = MAKE_PAIR(string1549_inline_simple, arg1318_713);
					       }
					       verbose_tools_speek(BINT(((long) 3)), list1316_712);
					    }
					 }
				    }
				    {
				       bool_t test1330_723;
				       {
					  obj_t aux_1447;
					  aux_1447 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
					  test1330_723 = CBOOL(aux_1447);
				       }
				       if (test1330_723)
					 {
					    obj_t arg1332_725;
					    obj_t arg1334_727;
					    obj_t arg1339_729;
					    arg1332_725 = shape_tools_shape(formals_696);
					    arg1334_727 = shape_tools_shape(reductors_698);
					    arg1339_729 = shape_tools_shape(body_700);
					    {
					       obj_t list1340_730;
					       {
						  obj_t arg1342_731;
						  {
						     obj_t arg1343_732;
						     {
							obj_t arg1345_733;
							{
							   obj_t arg1346_734;
							   {
							      obj_t arg1347_735;
							      {
								 obj_t arg1349_736;
								 {
								    obj_t arg1350_737;
								    {
								       obj_t aux_1456;
								       aux_1456 = BCHAR(((unsigned char) '\n'));
								       arg1350_737 = MAKE_PAIR(aux_1456, BNIL);
								    }
								    arg1349_736 = MAKE_PAIR(arg1339_729, arg1350_737);
								 }
								 arg1347_735 = MAKE_PAIR(string1550_inline_simple, arg1349_736);
							      }
							      {
								 obj_t aux_1461;
								 aux_1461 = BCHAR(((unsigned char) '\n'));
								 arg1346_734 = MAKE_PAIR(aux_1461, arg1347_735);
							      }
							   }
							   arg1345_733 = MAKE_PAIR(arg1334_727, arg1346_734);
							}
							arg1343_732 = MAKE_PAIR(string1551_inline_simple, arg1345_733);
						     }
						     arg1342_731 = MAKE_PAIR(arg1332_725, arg1343_732);
						  }
						  list1340_730 = MAKE_PAIR(string1552_inline_simple, arg1342_731);
					       }
					       print_trace_107_tools_trace(list1340_730);
					    }
					 }
				       else
					 {
					    BUNSPEC;
					 }
				    }
				    {
				       node_t alpha_body_133_741;
				       alpha_body_133_741 = alphatize_ast_alphatize(formals_696, reductors_698, loc_703, (node_t) (body_700));
				       spread_side_effect__136_effect_spread(alpha_body_133_741);
				       {
					  let_var_6_t inline_body_50_742;
					  {
					     bool_t arg1370_756;
					     node_t arg1372_757;
					     arg1370_756 = side_effect__165_effect_effect(alpha_body_133_741);
					     {
						obj_t arg1376_758;
						{
						   obj_t aux_1473;
						   aux_1473 = (obj_t) (callee_694);
						   arg1376_758 = MAKE_PAIR(aux_1473, stack_3);
						}
						arg1372_757 = inline_node_218_inline_inline(alpha_body_133_741, (long) CINT(new_kfactor_216_702), arg1376_758);
					     }
					     {
						let_var_6_t res1543_1196;
						{
						   obj_t side_effect__165_1182;
						   side_effect__165_1182 = BBOOL(arg1370_756);
						   {
						      let_var_6_t new1229_1186;
						      new1229_1186 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
						      {
							 long arg1453_1187;
							 arg1453_1187 = class_num_218___object(let_var_6_ast_node);
							 {
							    obj_t obj_1194;
							    obj_1194 = (obj_t) (new1229_1186);
							    (((obj_t) CREF(obj_1194))->header = MAKE_HEADER(arg1453_1187, 0), BUNSPEC);
							 }
						      }
						      {
							 object_t aux_1483;
							 aux_1483 = (object_t) (new1229_1186);
							 OBJECT_WIDENING_SET(aux_1483, BFALSE);
						      }
						      ((((let_var_6_t) CREF(new1229_1186))->loc) = ((obj_t) loc_703), BUNSPEC);
						      ((((let_var_6_t) CREF(new1229_1186))->type) = ((type_t) type_704), BUNSPEC);
						      ((((let_var_6_t) CREF(new1229_1186))->side_effect__165) = ((obj_t) side_effect__165_1182), BUNSPEC);
						      ((((let_var_6_t) CREF(new1229_1186))->bindings) = ((obj_t) bindings_699), BUNSPEC);
						      ((((let_var_6_t) CREF(new1229_1186))->body) = ((node_t) arg1372_757), BUNSPEC);
						      ((((let_var_6_t) CREF(new1229_1186))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
						      res1543_1196 = new1229_1186;
						   }
						}
						inline_body_50_742 = res1543_1196;
					     }
					  }
					  {
					     bool_t test1356_743;
					     {
						bool_t test1367_753;
						{
						   obj_t obj2_1198;
						   obj2_1198 = _____74_type_cache;
						   {
						      obj_t aux_1492;
						      aux_1492 = (obj_t) (type_704);
						      test1367_753 = (aux_1492 == obj2_1198);
						   }
						}
						if (test1367_753)
						  {
						     test1356_743 = ((bool_t) 1);
						  }
						else
						  {
						     bool_t test1368_754;
						     {
							obj_t obj2_1200;
							obj2_1200 = __obj__252_type_cache;
							{
							   obj_t aux_1496;
							   aux_1496 = (obj_t) (type_704);
							   test1368_754 = (aux_1496 == obj2_1200);
							}
						     }
						     if (test1368_754)
						       {
							  test1356_743 = ((bool_t) 1);
						       }
						     else
						       {
							  obj_t aux_1502;
							  obj_t aux_1500;
							  {
							     type_t aux_1503;
							     aux_1503 = (((node_t) CREF(alpha_body_133_741))->type);
							     aux_1502 = (obj_t) (aux_1503);
							  }
							  aux_1500 = (obj_t) (type_704);
							  test1356_743 = (aux_1500 == aux_1502);
						       }
						  }
					     }
					     if (test1356_743)
					       {
						  return (node_t) (inline_body_50_742);
					       }
					     else
					       {
						  local_t var_744;
						  {
						     obj_t arg1364_751;
						     arg1364_751 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 3)), BEOA);
						     var_744 = make_local_svar_140_ast_local(arg1364_751, type_704);
						  }
						  {
						     bool_t arg1357_745;
						     obj_t arg1358_746;
						     var_t arg1359_747;
						     arg1357_745 = side_effect__165_effect_effect((node_t) (inline_body_50_742));
						     {
							obj_t arg1361_748;
							{
							   obj_t aux_1517;
							   obj_t aux_1515;
							   aux_1517 = (obj_t) (inline_body_50_742);
							   aux_1515 = (obj_t) (var_744);
							   arg1361_748 = MAKE_PAIR(aux_1515, aux_1517);
							}
							{
							   obj_t list1362_749;
							   list1362_749 = MAKE_PAIR(arg1361_748, BNIL);
							   arg1358_746 = list1362_749;
							}
						     }
						     {
							var_t res1544_1217;
							{
							   variable_t variable_1209;
							   variable_1209 = (variable_t) (var_744);
							   {
							      var_t new1129_1210;
							      new1129_1210 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
							      {
								 long arg1497_1211;
								 arg1497_1211 = class_num_218___object(var_ast_node);
								 {
								    obj_t obj_1215;
								    obj_1215 = (obj_t) (new1129_1210);
								    (((obj_t) CREF(obj_1215))->header = MAKE_HEADER(arg1497_1211, 0), BUNSPEC);
								 }
							      }
							      {
								 object_t aux_1526;
								 aux_1526 = (object_t) (new1129_1210);
								 OBJECT_WIDENING_SET(aux_1526, BFALSE);
							      }
							      ((((var_t) CREF(new1129_1210))->loc) = ((obj_t) loc_703), BUNSPEC);
							      ((((var_t) CREF(new1129_1210))->type) = ((type_t) type_704), BUNSPEC);
							      ((((var_t) CREF(new1129_1210))->variable) = ((variable_t) variable_1209), BUNSPEC);
							      res1544_1217 = new1129_1210;
							   }
							}
							arg1359_747 = res1544_1217;
						     }
						     {
							let_var_6_t res1545_1234;
							{
							   obj_t side_effect__165_1220;
							   node_t body_1222;
							   side_effect__165_1220 = BBOOL(arg1357_745);
							   body_1222 = (node_t) (arg1359_747);
							   {
							      let_var_6_t new1229_1224;
							      new1229_1224 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
							      {
								 long arg1453_1225;
								 arg1453_1225 = class_num_218___object(let_var_6_ast_node);
								 {
								    obj_t obj_1232;
								    obj_1232 = (obj_t) (new1229_1224);
								    (((obj_t) CREF(obj_1232))->header = MAKE_HEADER(arg1453_1225, 0), BUNSPEC);
								 }
							      }
							      {
								 object_t aux_1538;
								 aux_1538 = (object_t) (new1229_1224);
								 OBJECT_WIDENING_SET(aux_1538, BFALSE);
							      }
							      ((((let_var_6_t) CREF(new1229_1224))->loc) = ((obj_t) loc_703), BUNSPEC);
							      ((((let_var_6_t) CREF(new1229_1224))->type) = ((type_t) type_704), BUNSPEC);
							      ((((let_var_6_t) CREF(new1229_1224))->side_effect__165) = ((obj_t) side_effect__165_1220), BUNSPEC);
							      ((((let_var_6_t) CREF(new1229_1224))->bindings) = ((obj_t) arg1358_746), BUNSPEC);
							      ((((let_var_6_t) CREF(new1229_1224))->body) = ((node_t) body_1222), BUNSPEC);
							      ((((let_var_6_t) CREF(new1229_1224))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
							      res1545_1234 = new1229_1224;
							   }
							}
							return (node_t) (res1545_1234);
						     }
						  }
					       }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_inline_app_simple_231_inline_simple(obj_t env_1274, obj_t node_1275, obj_t kfactor_1276, obj_t stack_1277, obj_t msg_1278)
{
   {
      node_t aux_1548;
      aux_1548 = inline_app_simple_198_inline_simple((node_t) (node_1275), (long) CINT(kfactor_1276), stack_1277, msg_1278);
      return (obj_t) (aux_1548);
   }
}


obj_t 
imported_modules_init_94_inline_simple()
{
   module_initialization_70_tools_trace(((long) 0), "INLINE_SIMPLE");
   module_initialization_70_engine_param(((long) 0), "INLINE_SIMPLE");
   module_initialization_70_type_type(((long) 0), "INLINE_SIMPLE");
   module_initialization_70_type_cache(((long) 0), "INLINE_SIMPLE");
   module_initialization_70_ast_var(((long) 0), "INLINE_SIMPLE");
   module_initialization_70_ast_node(((long) 0), "INLINE_SIMPLE");
   module_initialization_70_ast_local(((long) 0), "INLINE_SIMPLE");
   module_initialization_70_tools_shape(((long) 0), "INLINE_SIMPLE");
   module_initialization_70_tools_speek(((long) 0), "INLINE_SIMPLE");
   module_initialization_70_tools_error(((long) 0), "INLINE_SIMPLE");
   module_initialization_70_inline_inline(((long) 0), "INLINE_SIMPLE");
   module_initialization_70_inline_size(((long) 0), "INLINE_SIMPLE");
   module_initialization_70_ast_alphatize(((long) 0), "INLINE_SIMPLE");
   module_initialization_70_ast_sexp(((long) 0), "INLINE_SIMPLE");
   module_initialization_70_effect_effect(((long) 0), "INLINE_SIMPLE");
   return module_initialization_70_effect_spread(((long) 0), "INLINE_SIMPLE");
}
