/*===========================================================================*/
/*   (Inline/size.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct sized_sequence_48
  {
     long size;
  }
                 *sized_sequence_48_t;

typedef struct sized_app_52
  {
     long size;
  }
            *sized_app_52_t;

typedef struct sized_funcall_46
  {
     long size;
  }
                *sized_funcall_46_t;

typedef struct sized_pragma_213
  {
     long size;
  }
                *sized_pragma_213_t;

typedef struct sized_conditional_152
  {
     long size;
  }
                     *sized_conditional_152_t;

typedef struct sized_fail_63
  {
     long size;
  }
             *sized_fail_63_t;

typedef struct sized_select_166
  {
     long size;
  }
                *sized_select_166_t;

typedef struct sized_let_fun_188
  {
     long size;
  }
                 *sized_let_fun_188_t;

typedef struct sized_let_var_54
  {
     long size;
  }
                *sized_let_var_54_t;


static obj_t sized_app_52_inline_size = BUNSPEC;
static obj_t sized_sequence_48_inline_size = BUNSPEC;
static obj_t _allocate_sized_pragma_184_inline_size(obj_t);
static obj_t _allocate_sized_funcall_28_inline_size(obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t struct_object__object_sized_funcall1991_41_inline_size(obj_t, obj_t, obj_t);
extern long node_size_119_inline_size(node_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t __classes__134___object;
extern obj_t _struct_object__object_6___object(obj_t, obj_t, obj_t);
static long node_size_default1434_247_inline_size(node_t);
static obj_t imported_modules_init_94_inline_size();
extern obj_t module_initialization_70_inline_size(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_inline_size();
static obj_t cnst_init_137_inline_size();
static obj_t struct_object__object_sized_fail1997_234_inline_size(obj_t, obj_t, obj_t);
static obj_t object__struct_sized_let_var2004_62_inline_size(obj_t, obj_t);
static obj_t sized_conditional_152_inline_size = BUNSPEC;
static obj_t struct_object__object_sized_sequence1987_74_inline_size(obj_t, obj_t, obj_t);
static obj_t struct_object__object_sized_let_fun2001_119_inline_size(obj_t, obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
static obj_t struct_object__object_sized_pragma1993_110_inline_size(obj_t, obj_t, obj_t);
static obj_t sized_fail_63_inline_size = BUNSPEC;
static obj_t require_initialization_114_inline_size = BUNSPEC;
extern obj_t var_ast_node;
static obj_t library_modules_init_112_inline_size();
static funcall_t allocate_sized_funcall_74_inline_size();
static obj_t object__struct_sized_fail1998_140_inline_size(obj_t, obj_t);
static obj_t object__struct_sized_select2000_2_inline_size(obj_t, obj_t);
extern obj_t cast_ast_node;
static obj_t object__struct_sized_sequence1988_0_inline_size(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
static let_var_6_t allocate_sized_let_var_152_inline_size();
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
static obj_t sized_select_166_inline_size = BUNSPEC;
extern obj_t pragma_ast_node;
static app_t allocate_sized_app_161_inline_size();
static obj_t _node_size_default1434_180_inline_size(obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t object__struct_50___object(object_t);
static obj_t object__struct_sized_let_fun2002_105_inline_size(obj_t, obj_t);
static obj_t sized_funcall_46_inline_size = BUNSPEC;
extern obj_t app_ly_162_ast_node;
static pragma_t allocate_sized_pragma_254_inline_size();
static obj_t struct_object__object_sized_select1999_97_inline_size(obj_t, obj_t, obj_t);
extern obj_t jump_ex_it_184_ast_node;
static obj_t _allocate_sized_select_175_inline_size(obj_t);
static obj_t _allocate_sized_conditional_74_inline_size(obj_t);
static obj_t _allocate_sized_app_5_inline_size(obj_t);
static obj_t struct_object__object_sized_app1989_163_inline_size(obj_t, obj_t, obj_t);
static select_t allocate_sized_select_168_inline_size();
extern obj_t setq_ast_node;
static obj_t object__struct_sized_pragma1994_213_inline_size(obj_t, obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
static obj_t _allocate_sized_sequence_167_inline_size(obj_t);
static obj_t object_init_111_inline_size();
extern obj_t set_ex_it_116_ast_node;
static sequence_t allocate_sized_sequence_56_inline_size();
static obj_t struct_object__object_sized_conditional1995_244_inline_size(obj_t, obj_t, obj_t);
static obj_t object__struct_sized_conditional1996_49_inline_size(obj_t, obj_t);
static obj_t _allocate_sized_let_fun_213_inline_size(obj_t);
extern obj_t kwote_ast_node;
static let_fun_218_t allocate_sized_let_fun_17_inline_size();
static obj_t object__struct_sized_funcall1992_27_inline_size(obj_t, obj_t);
extern long list_length(obj_t);
static obj_t sized_pragma_213_inline_size = BUNSPEC;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t box_ref_242_ast_node;
static obj_t _allocate_sized_let_var_200_inline_size(obj_t);
extern obj_t _object__struct_74___object(obj_t, obj_t);
static fail_t allocate_sized_fail_135_inline_size();
extern obj_t funcall_ast_node;
static obj_t sized_let_var_54_inline_size = BUNSPEC;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
static obj_t _allocate_sized_fail_239_inline_size(obj_t);
extern object_t struct_object__object_93___object(object_t, obj_t);
static conditional_t allocate_sized_conditional_44_inline_size();
extern obj_t _node_size_132_inline_size(obj_t, obj_t);
static obj_t sized_let_fun_188_inline_size = BUNSPEC;
static obj_t struct_object__object_sized_let_var2003_87_inline_size(obj_t, obj_t, obj_t);
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t);
extern obj_t app_ast_node;
static obj_t object__struct_sized_app1990_5_inline_size(obj_t, obj_t);
static obj_t __cnst[10];

DEFINE_STRING(string2024_inline_size, string2024_inline_size2030, "SIZED-LET-VAR SIZED-LET-FUN SIZED-SELECT SIZED-FAIL SIZED-CONDITIONAL SIZED-PRAGMA SIZED-FUNCALL SIZED-APP SIZED-SEQUENCE NODE-SIZE-DEFAULT1434 ", 144);
DEFINE_STATIC_PROCEDURE(proc2009_inline_size, struct_object__object_sized_let_fun2001_119_inline_size2031, struct_object__object_sized_let_fun2001_119_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_sized_app_env_53_inline_size, _allocate_sized_app_5_inline_size2032, _allocate_sized_app_5_inline_size, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_sized_fail_env_18_inline_size, _allocate_sized_fail_239_inline_size2033, _allocate_sized_fail_239_inline_size, 0L, 0);
DEFINE_STRING(string2005_inline_size, string2005_inline_size2034, "No method for this object", 25);
DEFINE_STATIC_PROCEDURE(allocate_sized_funcall_env_52_inline_size, _allocate_sized_funcall_28_inline_size2035, _allocate_sized_funcall_28_inline_size, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_sized_select_env_132_inline_size, _allocate_sized_select_175_inline_size2036, _allocate_sized_select_175_inline_size, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_sized_sequence_env_88_inline_size, _allocate_sized_sequence_167_inline_size2037, _allocate_sized_sequence_167_inline_size, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2020_inline_size, object__struct_sized_app1990_5_inline_size2038, object__struct_sized_app1990_5_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2010_inline_size, object__struct_sized_select2000_2_inline_size2039, object__struct_sized_select2000_2_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_sized_pragma_env_85_inline_size, _allocate_sized_pragma_184_inline_size2040, _allocate_sized_pragma_184_inline_size, 0L, 0);
extern obj_t struct_object__object_env_209___object;
DEFINE_STATIC_PROCEDURE(allocate_sized_conditional_env_43_inline_size, _allocate_sized_conditional_74_inline_size2041, _allocate_sized_conditional_74_inline_size, 0L, 0);
DEFINE_STATIC_PROCEDURE(node_size_default1434_env_62_inline_size, _node_size_default1434_180_inline_size2042, _node_size_default1434_180_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_sized_let_var_env_114_inline_size, _allocate_sized_let_var_200_inline_size2043, _allocate_sized_let_var_200_inline_size, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2019_inline_size, struct_object__object_sized_funcall1991_41_inline_size2044, struct_object__object_sized_funcall1991_41_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2013_inline_size, struct_object__object_sized_fail1997_234_inline_size2045, struct_object__object_sized_fail1997_234_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2012_inline_size, object__struct_sized_fail1998_140_inline_size2046, object__struct_sized_fail1998_140_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_sized_let_fun_env_195_inline_size, _allocate_sized_let_fun_213_inline_size2047, _allocate_sized_let_fun_213_inline_size, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2016_inline_size, object__struct_sized_pragma1994_213_inline_size2048, object__struct_sized_pragma1994_213_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2007_inline_size, struct_object__object_sized_let_var2003_87_inline_size2049, struct_object__object_sized_let_var2003_87_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2008_inline_size, object__struct_sized_let_fun2002_105_inline_size2050, object__struct_sized_let_fun2002_105_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2023_inline_size, struct_object__object_sized_sequence1987_74_inline_size2051, struct_object__object_sized_sequence1987_74_inline_size, 0L, 2);
extern obj_t object__struct_env_210___object;
DEFINE_STATIC_PROCEDURE(proc2022_inline_size, object__struct_sized_sequence1988_0_inline_size2052, object__struct_sized_sequence1988_0_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2021_inline_size, struct_object__object_sized_app1989_163_inline_size2053, struct_object__object_sized_app1989_163_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2015_inline_size, struct_object__object_sized_conditional1995_244_inline_size2054, struct_object__object_sized_conditional1995_244_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2006_inline_size, object__struct_sized_let_var2004_62_inline_size2055, object__struct_sized_let_var2004_62_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2018_inline_size, object__struct_sized_funcall1992_27_inline_size2056, object__struct_sized_funcall1992_27_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2017_inline_size, struct_object__object_sized_pragma1993_110_inline_size2057, struct_object__object_sized_pragma1993_110_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2011_inline_size, struct_object__object_sized_select1999_97_inline_size2058, struct_object__object_sized_select1999_97_inline_size, 0L, 2);
DEFINE_EXPORT_GENERIC(node_size_env_51_inline_size, _node_size_132_inline_size2059, _node_size_132_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2014_inline_size, object__struct_sized_conditional1996_49_inline_size2060, object__struct_sized_conditional1996_49_inline_size, 0L, 1);

obj_t 
module_initialization_70_inline_size(long checksum_2420, char *from_2421)
{
   if (CBOOL(require_initialization_114_inline_size))
     {
	require_initialization_114_inline_size = BBOOL(((bool_t) 0));
	library_modules_init_112_inline_size();
	cnst_init_137_inline_size();
	object_init_111_inline_size();
	imported_modules_init_94_inline_size();
	toplevel_init_63_inline_size();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_inline_size()
{
   module_initialization_70___object(((long) 0), "INLINE_SIZE");
   module_initialization_70___reader(((long) 0), "INLINE_SIZE");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_SIZE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_inline_size()
{
   {
      obj_t cnst_port_138_2412;
      cnst_port_138_2412 = open_input_string(string2024_inline_size);
      {
	 long i_2413;
	 i_2413 = ((long) 9);
       loop_2414:
	 {
	    bool_t test2025_2415;
	    test2025_2415 = (i_2413 == ((long) -1));
	    if (test2025_2415)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2026_2416;
		    {
		       obj_t list2027_2417;
		       {
			  obj_t arg2028_2418;
			  arg2028_2418 = BNIL;
			  list2027_2417 = MAKE_PAIR(cnst_port_138_2412, arg2028_2418);
		       }
		       arg2026_2416 = read___reader(list2027_2417);
		    }
		    CNST_TABLE_SET(i_2413, arg2026_2416);
		 }
		 {
		    int aux_2419;
		    {
		       long aux_2439;
		       aux_2439 = (i_2413 - ((long) 1));
		       aux_2419 = (int) (aux_2439);
		    }
		    {
		       long i_2442;
		       i_2442 = (long) (aux_2419);
		       i_2413 = i_2442;
		       goto loop_2414;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_inline_size()
{
   add_generic__110___object(node_size_env_51_inline_size, node_size_default1434_env_62_inline_size);
   add_inlined_method__244___object(node_size_env_51_inline_size, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(node_size_env_51_inline_size, var_ast_node, ((long) 1));
   add_inlined_method__244___object(node_size_env_51_inline_size, kwote_ast_node, ((long) 2));
   add_inlined_method__244___object(node_size_env_51_inline_size, sequence_ast_node, ((long) 3));
   add_inlined_method__244___object(node_size_env_51_inline_size, sized_sequence_48_inline_size, ((long) 4));
   add_inlined_method__244___object(node_size_env_51_inline_size, app_ast_node, ((long) 5));
   add_inlined_method__244___object(node_size_env_51_inline_size, sized_app_52_inline_size, ((long) 6));
   add_inlined_method__244___object(node_size_env_51_inline_size, app_ly_162_ast_node, ((long) 7));
   add_inlined_method__244___object(node_size_env_51_inline_size, funcall_ast_node, ((long) 8));
   add_inlined_method__244___object(node_size_env_51_inline_size, sized_funcall_46_inline_size, ((long) 9));
   add_inlined_method__244___object(node_size_env_51_inline_size, sized_pragma_213_inline_size, ((long) 10));
   add_inlined_method__244___object(node_size_env_51_inline_size, cast_ast_node, ((long) 11));
   add_inlined_method__244___object(node_size_env_51_inline_size, pragma_ast_node, ((long) 12));
   add_inlined_method__244___object(node_size_env_51_inline_size, setq_ast_node, ((long) 13));
   add_inlined_method__244___object(node_size_env_51_inline_size, conditional_ast_node, ((long) 14));
   add_inlined_method__244___object(node_size_env_51_inline_size, sized_conditional_152_inline_size, ((long) 15));
   add_inlined_method__244___object(node_size_env_51_inline_size, fail_ast_node, ((long) 16));
   add_inlined_method__244___object(node_size_env_51_inline_size, sized_fail_63_inline_size, ((long) 17));
   add_inlined_method__244___object(node_size_env_51_inline_size, select_ast_node, ((long) 18));
   add_inlined_method__244___object(node_size_env_51_inline_size, sized_select_166_inline_size, ((long) 19));
   add_inlined_method__244___object(node_size_env_51_inline_size, let_fun_218_ast_node, ((long) 20));
   add_inlined_method__244___object(node_size_env_51_inline_size, sized_let_fun_188_inline_size, ((long) 21));
   add_inlined_method__244___object(node_size_env_51_inline_size, let_var_6_ast_node, ((long) 22));
   add_inlined_method__244___object(node_size_env_51_inline_size, sized_let_var_54_inline_size, ((long) 23));
   add_inlined_method__244___object(node_size_env_51_inline_size, set_ex_it_116_ast_node, ((long) 24));
   add_inlined_method__244___object(node_size_env_51_inline_size, jump_ex_it_184_ast_node, ((long) 25));
   add_inlined_method__244___object(node_size_env_51_inline_size, make_box_202_ast_node, ((long) 26));
   add_inlined_method__244___object(node_size_env_51_inline_size, box_ref_242_ast_node, ((long) 27));
   {
      long aux_2473;
      aux_2473 = add_inlined_method__244___object(node_size_env_51_inline_size, box_set__221_ast_node, ((long) 28));
      return BINT(aux_2473);
   }
}


long 
node_size_default1434_247_inline_size(node_t node_2)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string2005_inline_size, (obj_t) (node_2));
}


obj_t 
_node_size_default1434_180_inline_size(obj_t env_2333, obj_t node_2334)
{
   {
      long aux_2479;
      aux_2479 = node_size_default1434_247_inline_size((node_t) (node_2334));
      return BINT(aux_2479);
   }
}


long 
node_size_119_inline_size(node_t node_1)
{
   {
      obj_t method1801_1539;
      obj_t class1806_1540;
      {
	 obj_t arg1809_1537;
	 obj_t arg1810_1538;
	 {
	    object_t obj_1753;
	    obj_1753 = (object_t) (node_1);
	    {
	       obj_t pre_method_105_1754;
	       pre_method_105_1754 = PROCEDURE_REF(node_size_env_51_inline_size, ((long) 2));
	       if (INTEGERP(pre_method_105_1754))
		 {
		    PROCEDURE_SET(node_size_env_51_inline_size, ((long) 2), BUNSPEC);
		    arg1809_1537 = pre_method_105_1754;
		 }
	       else
		 {
		    long obj_class_num_177_1759;
		    obj_class_num_177_1759 = TYPE(obj_1753);
		    {
		       obj_t arg1183_1760;
		       arg1183_1760 = PROCEDURE_REF(node_size_env_51_inline_size, ((long) 1));
		       {
			  long arg1184_1764;
			  {
			     long arg1186_1765;
			     arg1186_1765 = OBJECT_TYPE;
			     arg1184_1764 = (obj_class_num_177_1759 - arg1186_1765);
			  }
			  arg1809_1537 = VECTOR_REF(arg1183_1760, arg1184_1764);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1770;
	    object_1770 = (object_t) (node_1);
	    {
	       long arg1187_1771;
	       {
		  long arg1188_1772;
		  long arg1189_1773;
		  arg1188_1772 = TYPE(object_1770);
		  arg1189_1773 = OBJECT_TYPE;
		  arg1187_1771 = (arg1188_1772 - arg1189_1773);
	       }
	       {
		  obj_t vector_1777;
		  vector_1777 = __classes__134___object;
		  arg1810_1538 = VECTOR_REF(vector_1777, arg1187_1771);
	       }
	    }
	 }
	 {
	    obj_t aux_2498;
	    method1801_1539 = arg1809_1537;
	    class1806_1540 = arg1810_1538;
	    {
	       if (INTEGERP(method1801_1539))
		 {
		    switch ((long) CINT(method1801_1539))
		      {
		      case ((long) 0):
			 aux_2498 = BINT(((long) 1));
			 break;
		      case ((long) 1):
			 aux_2498 = BINT(((long) 1));
			 break;
		      case ((long) 2):
			 aux_2498 = BINT(((long) 1));
			 break;
		      case ((long) 3):
			 {
			    sequence_t node_1549;
			    node_1549 = (sequence_t) (node_1);
			    {
			       obj_t nodes_1550;
			       long size_1551;
			       {
				  long aux_2505;
				  nodes_1550 = (((sequence_t) CREF(node_1549))->nodes);
				  size_1551 = ((long) 0);
				loop_1552:
				  if (NULLP(nodes_1550))
				    {
				       {
					  sized_sequence_48_t obj1424_1556;
					  obj1424_1556 = ((sized_sequence_48_t) (node_1549));
					  {
					     sized_sequence_48_t arg1819_1557;
					     {
						sized_sequence_48_t res1965_1784;
						{
						   sized_sequence_48_t new1280_1782;
						   new1280_1782 = ((sized_sequence_48_t) BREF(GC_MALLOC(sizeof(struct sized_sequence_48))));
						   ((((sized_sequence_48_t) CREF(new1280_1782))->size) = ((long) size_1551), BUNSPEC);
						   res1965_1784 = new1280_1782;
						}
						arg1819_1557 = res1965_1784;
					     }
					     {
						obj_t aux_2513;
						object_t aux_2511;
						aux_2513 = (obj_t) (arg1819_1557);
						aux_2511 = (object_t) (obj1424_1556);
						OBJECT_WIDENING_SET(aux_2511, aux_2513);
					     }
					  }
					  {
					     long arg1820_1558;
					     arg1820_1558 = class_num_218___object(sized_sequence_48_inline_size);
					     {
						obj_t obj_1785;
						obj_1785 = (obj_t) (obj1424_1556);
						(((obj_t) CREF(obj_1785))->header = MAKE_HEADER(arg1820_1558, 0), BUNSPEC);
					     }
					  }
					  obj1424_1556;
				       }
				       aux_2505 = size_1551;
				    }
				  else
				    {
				       obj_t arg1821_1559;
				       long arg1822_1560;
				       arg1821_1559 = CDR(nodes_1550);
				       {
					  long arg1823_1561;
					  {
					     node_t aux_2520;
					     {
						obj_t aux_2521;
						aux_2521 = CAR(nodes_1550);
						aux_2520 = (node_t) (aux_2521);
					     }
					     arg1823_1561 = node_size_119_inline_size(aux_2520);
					  }
					  arg1822_1560 = (size_1551 + arg1823_1561);
				       }
				       {
					  long size_2527;
					  obj_t nodes_2526;
					  nodes_2526 = arg1821_1559;
					  size_2527 = arg1822_1560;
					  size_1551 = size_2527;
					  nodes_1550 = nodes_2526;
					  goto loop_1552;
				       }
				    }
				  aux_2498 = BINT(aux_2505);
			       }
			    }
			 }
			 break;
		      case ((long) 4):
			 {
			    sized_sequence_48_t node_1563;
			    node_1563 = (sized_sequence_48_t) (node_1);
			    {
			       long aux_2531;
			       {
				  obj_t aux_2532;
				  {
				     object_t aux_2533;
				     aux_2533 = (object_t) (node_1563);
				     aux_2532 = OBJECT_WIDENING(aux_2533);
				  }
				  aux_2531 = (((sized_sequence_48_t) CREF(aux_2532))->size);
			       }
			       aux_2498 = BINT(aux_2531);
			    }
			 }
			 break;
		      case ((long) 5):
			 {
			    app_t node_1564;
			    node_1564 = (app_t) (node_1);
			    {
			       obj_t args_1565;
			       long size_1566;
			       {
				  obj_t arg1825_1568;
				  long arg1826_1569;
				  arg1825_1568 = (((app_t) CREF(node_1564))->args);
				  {
				     node_t aux_2540;
				     {
					var_t aux_2541;
					aux_2541 = (((app_t) CREF(node_1564))->fun);
					aux_2540 = (node_t) (aux_2541);
				     }
				     arg1826_1569 = node_size_119_inline_size(aux_2540);
				  }
				  {
				     long aux_2545;
				     args_1565 = arg1825_1568;
				     size_1566 = arg1826_1569;
				   loop_1567:
				     if (NULLP(args_1565))
				       {
					  {
					     sized_app_52_t obj1425_1572;
					     obj1425_1572 = ((sized_app_52_t) (node_1564));
					     {
						sized_app_52_t arg1829_1573;
						{
						   sized_app_52_t res1966_1798;
						   {
						      sized_app_52_t new1294_1796;
						      new1294_1796 = ((sized_app_52_t) BREF(GC_MALLOC(sizeof(struct sized_app_52))));
						      ((((sized_app_52_t) CREF(new1294_1796))->size) = ((long) size_1566), BUNSPEC);
						      res1966_1798 = new1294_1796;
						   }
						   arg1829_1573 = res1966_1798;
						}
						{
						   obj_t aux_2553;
						   object_t aux_2551;
						   aux_2553 = (obj_t) (arg1829_1573);
						   aux_2551 = (object_t) (obj1425_1572);
						   OBJECT_WIDENING_SET(aux_2551, aux_2553);
						}
					     }
					     {
						long arg1830_1574;
						arg1830_1574 = class_num_218___object(sized_app_52_inline_size);
						{
						   obj_t obj_1799;
						   obj_1799 = (obj_t) (obj1425_1572);
						   (((obj_t) CREF(obj_1799))->header = MAKE_HEADER(arg1830_1574, 0), BUNSPEC);
						}
					     }
					     obj1425_1572;
					  }
					  aux_2545 = size_1566;
				       }
				     else
				       {
					  obj_t arg1831_1575;
					  long arg1832_1576;
					  arg1831_1575 = CDR(args_1565);
					  {
					     long arg1833_1577;
					     {
						node_t aux_2560;
						{
						   obj_t aux_2561;
						   aux_2561 = CAR(args_1565);
						   aux_2560 = (node_t) (aux_2561);
						}
						arg1833_1577 = node_size_119_inline_size(aux_2560);
					     }
					     arg1832_1576 = (size_1566 + arg1833_1577);
					  }
					  {
					     long size_2567;
					     obj_t args_2566;
					     args_2566 = arg1831_1575;
					     size_2567 = arg1832_1576;
					     size_1566 = size_2567;
					     args_1565 = args_2566;
					     goto loop_1567;
					  }
				       }
				     aux_2498 = BINT(aux_2545);
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 6):
			 {
			    sized_app_52_t node_1579;
			    node_1579 = (sized_app_52_t) (node_1);
			    {
			       long aux_2570;
			       {
				  obj_t aux_2571;
				  {
				     object_t aux_2572;
				     aux_2572 = (object_t) (node_1579);
				     aux_2571 = OBJECT_WIDENING(aux_2572);
				  }
				  aux_2570 = (((sized_app_52_t) CREF(aux_2571))->size);
			       }
			       aux_2498 = BINT(aux_2570);
			    }
			 }
			 break;
		      case ((long) 7):
			 {
			    app_ly_162_t node_1580;
			    node_1580 = (app_ly_162_t) (node_1);
			    {
			       long arg1836_1582;
			       {
				  long arg1837_1583;
				  long arg1838_1584;
				  arg1837_1583 = node_size_119_inline_size((((app_ly_162_t) CREF(node_1580))->fun));
				  arg1838_1584 = node_size_119_inline_size((((app_ly_162_t) CREF(node_1580))->arg));
				  arg1836_1582 = (arg1837_1583 + arg1838_1584);
			       }
			       {
				  long aux_2583;
				  aux_2583 = (((long) 1) + arg1836_1582);
				  aux_2498 = BINT(aux_2583);
			       }
			    }
			 }
			 break;
		      case ((long) 8):
			 {
			    funcall_t node_1587;
			    node_1587 = (funcall_t) (node_1);
			    {
			       obj_t args_1588;
			       long size_1589;
			       {
				  obj_t arg1841_1591;
				  long arg1842_1592;
				  arg1841_1591 = (((funcall_t) CREF(node_1587))->args);
				  arg1842_1592 = node_size_119_inline_size((((funcall_t) CREF(node_1587))->fun));
				  {
				     long aux_2590;
				     args_1588 = arg1841_1591;
				     size_1589 = arg1842_1592;
				   loop_1590:
				     if (NULLP(args_1588))
				       {
					  {
					     sized_funcall_46_t obj1426_1595;
					     obj1426_1595 = ((sized_funcall_46_t) (node_1587));
					     {
						sized_funcall_46_t arg1845_1596;
						{
						   sized_funcall_46_t res1967_1818;
						   {
						      sized_funcall_46_t new1311_1816;
						      new1311_1816 = ((sized_funcall_46_t) BREF(GC_MALLOC(sizeof(struct sized_funcall_46))));
						      ((((sized_funcall_46_t) CREF(new1311_1816))->size) = ((long) size_1589), BUNSPEC);
						      res1967_1818 = new1311_1816;
						   }
						   arg1845_1596 = res1967_1818;
						}
						{
						   obj_t aux_2598;
						   object_t aux_2596;
						   aux_2598 = (obj_t) (arg1845_1596);
						   aux_2596 = (object_t) (obj1426_1595);
						   OBJECT_WIDENING_SET(aux_2596, aux_2598);
						}
					     }
					     {
						long arg1846_1597;
						arg1846_1597 = class_num_218___object(sized_funcall_46_inline_size);
						{
						   obj_t obj_1819;
						   obj_1819 = (obj_t) (obj1426_1595);
						   (((obj_t) CREF(obj_1819))->header = MAKE_HEADER(arg1846_1597, 0), BUNSPEC);
						}
					     }
					     obj1426_1595;
					  }
					  aux_2590 = size_1589;
				       }
				     else
				       {
					  obj_t arg1847_1598;
					  long arg1848_1599;
					  arg1847_1598 = CDR(args_1588);
					  {
					     long arg1849_1600;
					     {
						node_t aux_2605;
						{
						   obj_t aux_2606;
						   aux_2606 = CAR(args_1588);
						   aux_2605 = (node_t) (aux_2606);
						}
						arg1849_1600 = node_size_119_inline_size(aux_2605);
					     }
					     arg1848_1599 = (size_1589 + arg1849_1600);
					  }
					  {
					     long size_2612;
					     obj_t args_2611;
					     args_2611 = arg1847_1598;
					     size_2612 = arg1848_1599;
					     size_1589 = size_2612;
					     args_1588 = args_2611;
					     goto loop_1590;
					  }
				       }
				     aux_2498 = BINT(aux_2590);
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 9):
			 {
			    sized_funcall_46_t node_1602;
			    node_1602 = (sized_funcall_46_t) (node_1);
			    {
			       long aux_2615;
			       {
				  obj_t aux_2616;
				  {
				     object_t aux_2617;
				     aux_2617 = (object_t) (node_1602);
				     aux_2616 = OBJECT_WIDENING(aux_2617);
				  }
				  aux_2615 = (((sized_funcall_46_t) CREF(aux_2616))->size);
			       }
			       aux_2498 = BINT(aux_2615);
			    }
			 }
			 break;
		      case ((long) 10):
			 {
			    sized_pragma_213_t node_1603;
			    node_1603 = (sized_pragma_213_t) (node_1);
			    {
			       long aux_2623;
			       {
				  obj_t aux_2624;
				  {
				     object_t aux_2625;
				     aux_2625 = (object_t) (node_1603);
				     aux_2624 = OBJECT_WIDENING(aux_2625);
				  }
				  aux_2623 = (((sized_pragma_213_t) CREF(aux_2624))->size);
			       }
			       aux_2498 = BINT(aux_2623);
			    }
			 }
			 break;
		      case ((long) 11):
			 {
			    cast_t node_1604;
			    node_1604 = (cast_t) (node_1);
			    {
			       long aux_2631;
			       aux_2631 = node_size_119_inline_size((((cast_t) CREF(node_1604))->arg));
			       aux_2498 = BINT(aux_2631);
			    }
			 }
			 break;
		      case ((long) 12):
			 {
			    pragma_t node_1607;
			    node_1607 = (pragma_t) (node_1);
			    {
			       obj_t args_1608;
			       long size_1609;
			       {
				  long aux_2636;
				  args_1608 = (((pragma_t) CREF(node_1607))->args);
				  size_1609 = ((long) 1);
				loop_1610:
				  if (NULLP(args_1608))
				    {
				       {
					  sized_pragma_213_t obj1428_1614;
					  obj1428_1614 = ((sized_pragma_213_t) (node_1607));
					  {
					     sized_pragma_213_t arg1858_1615;
					     {
						sized_pragma_213_t res1968_1833;
						{
						   sized_pragma_213_t new1327_1831;
						   new1327_1831 = ((sized_pragma_213_t) BREF(GC_MALLOC(sizeof(struct sized_pragma_213))));
						   ((((sized_pragma_213_t) CREF(new1327_1831))->size) = ((long) size_1609), BUNSPEC);
						   res1968_1833 = new1327_1831;
						}
						arg1858_1615 = res1968_1833;
					     }
					     {
						obj_t aux_2644;
						object_t aux_2642;
						aux_2644 = (obj_t) (arg1858_1615);
						aux_2642 = (object_t) (obj1428_1614);
						OBJECT_WIDENING_SET(aux_2642, aux_2644);
					     }
					  }
					  {
					     long arg1859_1616;
					     arg1859_1616 = class_num_218___object(sized_pragma_213_inline_size);
					     {
						obj_t obj_1834;
						obj_1834 = (obj_t) (obj1428_1614);
						(((obj_t) CREF(obj_1834))->header = MAKE_HEADER(arg1859_1616, 0), BUNSPEC);
					     }
					  }
					  obj1428_1614;
				       }
				       aux_2636 = size_1609;
				    }
				  else
				    {
				       obj_t arg1860_1617;
				       long arg1861_1618;
				       arg1860_1617 = CDR(args_1608);
				       {
					  long arg1862_1619;
					  {
					     node_t aux_2651;
					     {
						obj_t aux_2652;
						aux_2652 = CAR(args_1608);
						aux_2651 = (node_t) (aux_2652);
					     }
					     arg1862_1619 = node_size_119_inline_size(aux_2651);
					  }
					  arg1861_1618 = (size_1609 + arg1862_1619);
				       }
				       {
					  long size_2658;
					  obj_t args_2657;
					  args_2657 = arg1860_1617;
					  size_2658 = arg1861_1618;
					  size_1609 = size_2658;
					  args_1608 = args_2657;
					  goto loop_1610;
				       }
				    }
				  aux_2498 = BINT(aux_2636);
			       }
			    }
			 }
			 break;
		      case ((long) 13):
			 {
			    setq_t node_1621;
			    node_1621 = (setq_t) (node_1);
			    {
			       long arg1865_1623;
			       arg1865_1623 = node_size_119_inline_size((((setq_t) CREF(node_1621))->value));
			       {
				  long aux_2664;
				  aux_2664 = (((long) 2) + arg1865_1623);
				  aux_2498 = BINT(aux_2664);
			       }
			    }
			 }
			 break;
		      case ((long) 14):
			 {
			    conditional_t node_1625;
			    node_1625 = (conditional_t) (node_1);
			    {
			       long test_size_137_1626;
			       test_size_137_1626 = node_size_119_inline_size((((conditional_t) CREF(node_1625))->test));
			       {
				  long true_size_36_1627;
				  true_size_36_1627 = node_size_119_inline_size((((conditional_t) CREF(node_1625))->true));
				  {
				     long false_size_136_1628;
				     false_size_136_1628 = node_size_119_inline_size((((conditional_t) CREF(node_1625))->false));
				     {
					long size_1629;
					{
					   long aux_2674;
					   {
					      long aux_2675;
					      aux_2675 = (true_size_36_1627 + false_size_136_1628);
					      aux_2674 = (test_size_137_1626 + aux_2675);
					   }
					   size_1629 = (((long) 1) + aux_2674);
					}
					{
					   {
					      sized_conditional_152_t obj1429_1630;
					      obj1429_1630 = ((sized_conditional_152_t) (node_1625));
					      {
						 sized_conditional_152_t arg1867_1631;
						 {
						    sized_conditional_152_t res1969_1855;
						    {
						       sized_conditional_152_t new1342_1853;
						       new1342_1853 = ((sized_conditional_152_t) BREF(GC_MALLOC(sizeof(struct sized_conditional_152))));
						       ((((sized_conditional_152_t) CREF(new1342_1853))->size) = ((long) size_1629), BUNSPEC);
						       res1969_1855 = new1342_1853;
						    }
						    arg1867_1631 = res1969_1855;
						 }
						 {
						    obj_t aux_2684;
						    object_t aux_2682;
						    aux_2684 = (obj_t) (arg1867_1631);
						    aux_2682 = (object_t) (obj1429_1630);
						    OBJECT_WIDENING_SET(aux_2682, aux_2684);
						 }
					      }
					      {
						 long arg1870_1632;
						 arg1870_1632 = class_num_218___object(sized_conditional_152_inline_size);
						 {
						    obj_t obj_1856;
						    obj_1856 = (obj_t) (obj1429_1630);
						    (((obj_t) CREF(obj_1856))->header = MAKE_HEADER(arg1870_1632, 0), BUNSPEC);
						 }
					      }
					      obj1429_1630;
					   }
					   aux_2498 = BINT(size_1629);
					}
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 15):
			 {
			    sized_conditional_152_t node_1639;
			    node_1639 = (sized_conditional_152_t) (node_1);
			    {
			       long aux_2692;
			       {
				  obj_t aux_2693;
				  {
				     object_t aux_2694;
				     aux_2694 = (object_t) (node_1639);
				     aux_2693 = OBJECT_WIDENING(aux_2694);
				  }
				  aux_2692 = (((sized_conditional_152_t) CREF(aux_2693))->size);
			       }
			       aux_2498 = BINT(aux_2692);
			    }
			 }
			 break;
		      case ((long) 16):
			 {
			    fail_t node_1640;
			    node_1640 = (fail_t) (node_1);
			    {
			       long proc_size_203_1641;
			       proc_size_203_1641 = node_size_119_inline_size((((fail_t) CREF(node_1640))->proc));
			       {
				  long msg_size_252_1642;
				  msg_size_252_1642 = node_size_119_inline_size((((fail_t) CREF(node_1640))->msg));
				  {
				     long obj_size_35_1643;
				     obj_size_35_1643 = node_size_119_inline_size((((fail_t) CREF(node_1640))->obj));
				     {
					long size_1644;
					{
					   long aux_2706;
					   {
					      long aux_2707;
					      aux_2707 = (msg_size_252_1642 + obj_size_35_1643);
					      aux_2706 = (proc_size_203_1641 + aux_2707);
					   }
					   size_1644 = (((long) 2) + aux_2706);
					}
					{
					   {
					      sized_fail_63_t obj1430_1645;
					      obj1430_1645 = ((sized_fail_63_t) (node_1640));
					      {
						 sized_fail_63_t arg1879_1646;
						 {
						    sized_fail_63_t res1970_1871;
						    {
						       sized_fail_63_t new1359_1869;
						       new1359_1869 = ((sized_fail_63_t) BREF(GC_MALLOC(sizeof(struct sized_fail_63))));
						       ((((sized_fail_63_t) CREF(new1359_1869))->size) = ((long) size_1644), BUNSPEC);
						       res1970_1871 = new1359_1869;
						    }
						    arg1879_1646 = res1970_1871;
						 }
						 {
						    obj_t aux_2716;
						    object_t aux_2714;
						    aux_2716 = (obj_t) (arg1879_1646);
						    aux_2714 = (object_t) (obj1430_1645);
						    OBJECT_WIDENING_SET(aux_2714, aux_2716);
						 }
					      }
					      {
						 long arg1880_1647;
						 arg1880_1647 = class_num_218___object(sized_fail_63_inline_size);
						 {
						    obj_t obj_1872;
						    obj_1872 = (obj_t) (obj1430_1645);
						    (((obj_t) CREF(obj_1872))->header = MAKE_HEADER(arg1880_1647, 0), BUNSPEC);
						 }
					      }
					      obj1430_1645;
					   }
					   aux_2498 = BINT(size_1644);
					}
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 17):
			 {
			    sized_fail_63_t node_1654;
			    node_1654 = (sized_fail_63_t) (node_1);
			    {
			       long aux_2724;
			       {
				  obj_t aux_2725;
				  {
				     object_t aux_2726;
				     aux_2726 = (object_t) (node_1654);
				     aux_2725 = OBJECT_WIDENING(aux_2726);
				  }
				  aux_2724 = (((sized_fail_63_t) CREF(aux_2725))->size);
			       }
			       aux_2498 = BINT(aux_2724);
			    }
			 }
			 break;
		      case ((long) 18):
			 {
			    select_t node_1655;
			    node_1655 = (select_t) (node_1);
			    {
			       obj_t clauses_1656;
			       long size_1657;
			       {
				  obj_t arg1887_1659;
				  long arg1889_1660;
				  arg1887_1659 = (((select_t) CREF(node_1655))->clauses);
				  {
				     long arg1891_1662;
				     arg1891_1662 = node_size_119_inline_size((((select_t) CREF(node_1655))->test));
				     arg1889_1660 = (((long) 1) + arg1891_1662);
				  }
				  {
				     long aux_2736;
				     clauses_1656 = arg1887_1659;
				     size_1657 = arg1889_1660;
				   loop_1658:
				     if (NULLP(clauses_1656))
				       {
					  {
					     sized_select_166_t obj1431_1665;
					     obj1431_1665 = ((sized_select_166_t) (node_1655));
					     {
						sized_select_166_t arg1894_1666;
						{
						   sized_select_166_t res1971_1883;
						   {
						      sized_select_166_t new1377_1881;
						      new1377_1881 = ((sized_select_166_t) BREF(GC_MALLOC(sizeof(struct sized_select_166))));
						      ((((sized_select_166_t) CREF(new1377_1881))->size) = ((long) size_1657), BUNSPEC);
						      res1971_1883 = new1377_1881;
						   }
						   arg1894_1666 = res1971_1883;
						}
						{
						   obj_t aux_2744;
						   object_t aux_2742;
						   aux_2744 = (obj_t) (arg1894_1666);
						   aux_2742 = (object_t) (obj1431_1665);
						   OBJECT_WIDENING_SET(aux_2742, aux_2744);
						}
					     }
					     {
						long arg1895_1667;
						arg1895_1667 = class_num_218___object(sized_select_166_inline_size);
						{
						   obj_t obj_1884;
						   obj_1884 = (obj_t) (obj1431_1665);
						   (((obj_t) CREF(obj_1884))->header = MAKE_HEADER(arg1895_1667, 0), BUNSPEC);
						}
					     }
					     obj1431_1665;
					  }
					  aux_2736 = size_1657;
				       }
				     else
				       {
					  obj_t arg1896_1668;
					  long arg1897_1669;
					  arg1896_1668 = CDR(clauses_1656);
					  {
					     long arg1898_1670;
					     {
						long arg1899_1671;
						long arg1900_1672;
						{
						   bool_t test_2751;
						   {
						      obj_t aux_2752;
						      {
							 obj_t aux_2753;
							 aux_2753 = CAR(clauses_1656);
							 aux_2752 = CAR(aux_2753);
						      }
						      test_2751 = PAIRP(aux_2752);
						   }
						   if (test_2751)
						     {
							obj_t aux_2757;
							{
							   obj_t aux_2758;
							   aux_2758 = CAR(clauses_1656);
							   aux_2757 = CAR(aux_2758);
							}
							arg1899_1671 = list_length(aux_2757);
						     }
						   else
						     {
							arg1899_1671 = ((long) 1);
						     }
						}
						{
						   node_t aux_2762;
						   {
						      obj_t aux_2763;
						      {
							 obj_t aux_2764;
							 aux_2764 = CAR(clauses_1656);
							 aux_2763 = CDR(aux_2764);
						      }
						      aux_2762 = (node_t) (aux_2763);
						   }
						   arg1900_1672 = node_size_119_inline_size(aux_2762);
						}
						arg1898_1670 = (arg1899_1671 + arg1900_1672);
					     }
					     arg1897_1669 = (size_1657 + arg1898_1670);
					  }
					  {
					     long size_2772;
					     obj_t clauses_2771;
					     clauses_2771 = arg1896_1668;
					     size_2772 = arg1897_1669;
					     size_1657 = size_2772;
					     clauses_1656 = clauses_2771;
					     goto loop_1658;
					  }
				       }
				     aux_2498 = BINT(aux_2736);
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 19):
			 {
			    sized_select_166_t node_1680;
			    node_1680 = (sized_select_166_t) (node_1);
			    {
			       long aux_2775;
			       {
				  obj_t aux_2776;
				  {
				     object_t aux_2777;
				     aux_2777 = (object_t) (node_1680);
				     aux_2776 = OBJECT_WIDENING(aux_2777);
				  }
				  aux_2775 = (((sized_select_166_t) CREF(aux_2776))->size);
			       }
			       aux_2498 = BINT(aux_2775);
			    }
			 }
			 break;
		      case ((long) 20):
			 {
			    let_fun_218_t node_1681;
			    node_1681 = (let_fun_218_t) (node_1);
			    {
			       obj_t locals_1682;
			       long size_1683;
			       {
				  obj_t arg1909_1685;
				  long arg1911_1686;
				  arg1909_1685 = (((let_fun_218_t) CREF(node_1681))->locals);
				  {
				     long arg1912_1687;
				     long arg1913_1688;
				     arg1912_1687 = list_length((((let_fun_218_t) CREF(node_1681))->locals));
				     arg1913_1688 = node_size_119_inline_size((((let_fun_218_t) CREF(node_1681))->body));
				     arg1911_1686 = (arg1912_1687 + arg1913_1688);
				  }
				  {
				     long aux_2789;
				     locals_1682 = arg1909_1685;
				     size_1683 = arg1911_1686;
				   loop_1684:
				     if (NULLP(locals_1682))
				       {
					  {
					     sized_let_fun_188_t obj1432_1692;
					     obj1432_1692 = ((sized_let_fun_188_t) (node_1681));
					     {
						sized_let_fun_188_t arg1917_1693;
						{
						   sized_let_fun_188_t res1972_1908;
						   {
						      sized_let_fun_188_t new1392_1906;
						      new1392_1906 = ((sized_let_fun_188_t) BREF(GC_MALLOC(sizeof(struct sized_let_fun_188))));
						      ((((sized_let_fun_188_t) CREF(new1392_1906))->size) = ((long) size_1683), BUNSPEC);
						      res1972_1908 = new1392_1906;
						   }
						   arg1917_1693 = res1972_1908;
						}
						{
						   obj_t aux_2797;
						   object_t aux_2795;
						   aux_2797 = (obj_t) (arg1917_1693);
						   aux_2795 = (object_t) (obj1432_1692);
						   OBJECT_WIDENING_SET(aux_2795, aux_2797);
						}
					     }
					     {
						long arg1918_1694;
						arg1918_1694 = class_num_218___object(sized_let_fun_188_inline_size);
						{
						   obj_t obj_1909;
						   obj_1909 = (obj_t) (obj1432_1692);
						   (((obj_t) CREF(obj_1909))->header = MAKE_HEADER(arg1918_1694, 0), BUNSPEC);
						}
					     }
					     obj1432_1692;
					  }
					  aux_2789 = size_1683;
				       }
				     else
				       {
					  obj_t arg1921_1695;
					  long arg1922_1696;
					  arg1921_1695 = CDR(locals_1682);
					  {
					     long arg1923_1697;
					     {
						node_t aux_2804;
						{
						   obj_t aux_2805;
						   {
						      sfun_t obj_1914;
						      {
							 value_t aux_2806;
							 {
							    local_t obj_1913;
							    {
							       obj_t aux_2807;
							       aux_2807 = CAR(locals_1682);
							       obj_1913 = (local_t) (aux_2807);
							    }
							    aux_2806 = (((local_t) CREF(obj_1913))->value);
							 }
							 obj_1914 = (sfun_t) (aux_2806);
						      }
						      aux_2805 = (((sfun_t) CREF(obj_1914))->body);
						   }
						   aux_2804 = (node_t) (aux_2805);
						}
						arg1923_1697 = node_size_119_inline_size(aux_2804);
					     }
					     arg1922_1696 = (size_1683 + arg1923_1697);
					  }
					  {
					     long size_2817;
					     obj_t locals_2816;
					     locals_2816 = arg1921_1695;
					     size_2817 = arg1922_1696;
					     size_1683 = size_2817;
					     locals_1682 = locals_2816;
					     goto loop_1684;
					  }
				       }
				     aux_2498 = BINT(aux_2789);
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 21):
			 {
			    sized_let_fun_188_t node_1701;
			    node_1701 = (sized_let_fun_188_t) (node_1);
			    {
			       long aux_2820;
			       {
				  obj_t aux_2821;
				  {
				     object_t aux_2822;
				     aux_2822 = (object_t) (node_1701);
				     aux_2821 = OBJECT_WIDENING(aux_2822);
				  }
				  aux_2820 = (((sized_let_fun_188_t) CREF(aux_2821))->size);
			       }
			       aux_2498 = BINT(aux_2820);
			    }
			 }
			 break;
		      case ((long) 22):
			 {
			    let_var_6_t node_1702;
			    node_1702 = (let_var_6_t) (node_1);
			    {
			       obj_t bindings_1703;
			       long size_1704;
			       {
				  obj_t arg1928_1706;
				  long arg1929_1707;
				  arg1928_1706 = (((let_var_6_t) CREF(node_1702))->bindings);
				  arg1929_1707 = node_size_119_inline_size((((let_var_6_t) CREF(node_1702))->body));
				  {
				     long aux_2831;
				     bindings_1703 = arg1928_1706;
				     size_1704 = arg1929_1707;
				   loop_1705:
				     if (NULLP(bindings_1703))
				       {
					  {
					     sized_let_var_54_t obj1433_1710;
					     obj1433_1710 = ((sized_let_var_54_t) (node_1702));
					     {
						sized_let_var_54_t arg1934_1711;
						{
						   sized_let_var_54_t res1973_1924;
						   {
						      sized_let_var_54_t new1408_1922;
						      new1408_1922 = ((sized_let_var_54_t) BREF(GC_MALLOC(sizeof(struct sized_let_var_54))));
						      ((((sized_let_var_54_t) CREF(new1408_1922))->size) = ((long) size_1704), BUNSPEC);
						      res1973_1924 = new1408_1922;
						   }
						   arg1934_1711 = res1973_1924;
						}
						{
						   obj_t aux_2839;
						   object_t aux_2837;
						   aux_2839 = (obj_t) (arg1934_1711);
						   aux_2837 = (object_t) (obj1433_1710);
						   OBJECT_WIDENING_SET(aux_2837, aux_2839);
						}
					     }
					     {
						long arg1935_1712;
						arg1935_1712 = class_num_218___object(sized_let_var_54_inline_size);
						{
						   obj_t obj_1925;
						   obj_1925 = (obj_t) (obj1433_1710);
						   (((obj_t) CREF(obj_1925))->header = MAKE_HEADER(arg1935_1712, 0), BUNSPEC);
						}
					     }
					     obj1433_1710;
					  }
					  aux_2831 = size_1704;
				       }
				     else
				       {
					  obj_t arg1936_1713;
					  long arg1937_1714;
					  arg1936_1713 = CDR(bindings_1703);
					  {
					     long arg1938_1715;
					     {
						node_t aux_2846;
						{
						   obj_t aux_2847;
						   {
						      obj_t aux_2848;
						      aux_2848 = CAR(bindings_1703);
						      aux_2847 = CDR(aux_2848);
						   }
						   aux_2846 = (node_t) (aux_2847);
						}
						arg1938_1715 = node_size_119_inline_size(aux_2846);
					     }
					     arg1937_1714 = (size_1704 + arg1938_1715);
					  }
					  {
					     long size_2855;
					     obj_t bindings_2854;
					     bindings_2854 = arg1936_1713;
					     size_2855 = arg1937_1714;
					     size_1704 = size_2855;
					     bindings_1703 = bindings_2854;
					     goto loop_1705;
					  }
				       }
				     aux_2498 = BINT(aux_2831);
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 23):
			 {
			    sized_let_var_54_t node_1718;
			    node_1718 = (sized_let_var_54_t) (node_1);
			    {
			       long aux_2858;
			       {
				  obj_t aux_2859;
				  {
				     object_t aux_2860;
				     aux_2860 = (object_t) (node_1718);
				     aux_2859 = OBJECT_WIDENING(aux_2860);
				  }
				  aux_2858 = (((sized_let_var_54_t) CREF(aux_2859))->size);
			       }
			       aux_2498 = BINT(aux_2858);
			    }
			 }
			 break;
		      case ((long) 24):
			 {
			    set_ex_it_116_t node_1719;
			    node_1719 = (set_ex_it_116_t) (node_1);
			    {
			       long arg1942_1721;
			       arg1942_1721 = node_size_119_inline_size((((set_ex_it_116_t) CREF(node_1719))->body));
			       {
				  long aux_2868;
				  aux_2868 = (((long) 2) + arg1942_1721);
				  aux_2498 = BINT(aux_2868);
			       }
			    }
			 }
			 break;
		      case ((long) 25):
			 {
			    jump_ex_it_184_t node_1723;
			    node_1723 = (jump_ex_it_184_t) (node_1);
			    {
			       long arg1945_1725;
			       {
				  long arg1947_1726;
				  long arg1948_1727;
				  arg1947_1726 = node_size_119_inline_size((((jump_ex_it_184_t) CREF(node_1723))->exit));
				  arg1948_1727 = node_size_119_inline_size((((jump_ex_it_184_t) CREF(node_1723))->value));
				  arg1945_1725 = (arg1947_1726 + arg1948_1727);
			       }
			       {
				  long aux_2877;
				  aux_2877 = (((long) 1) + arg1945_1725);
				  aux_2498 = BINT(aux_2877);
			       }
			    }
			 }
			 break;
		      case ((long) 26):
			 {
			    make_box_202_t node_1730;
			    node_1730 = (make_box_202_t) (node_1);
			    {
			       long arg1952_1732;
			       arg1952_1732 = node_size_119_inline_size((((make_box_202_t) CREF(node_1730))->value));
			       {
				  long aux_2883;
				  aux_2883 = (((long) 1) + arg1952_1732);
				  aux_2498 = BINT(aux_2883);
			       }
			    }
			 }
			 break;
		      case ((long) 27):
			 aux_2498 = BINT(((long) 2));
			 break;
		      case ((long) 28):
			 {
			    box_set__221_t node_1735;
			    node_1735 = (box_set__221_t) (node_1);
			    {
			       long arg1956_1737;
			       arg1956_1737 = node_size_119_inline_size((((box_set__221_t) CREF(node_1735))->value));
			       {
				  long aux_2890;
				  aux_2890 = (((long) 2) + arg1956_1737);
				  aux_2498 = BINT(aux_2890);
			       }
			    }
			 }
			 break;
		      default:
		       case_else1807_167_1543:
			 if (PROCEDUREP(method1801_1539))
			   {
			      aux_2498 = PROCEDURE_ENTRY(method1801_1539) (method1801_1539, (obj_t) (node_1), BEOA);
			   }
			 else
			   {
			      obj_t fun1502_892;
			      fun1502_892 = PROCEDURE_REF(node_size_env_51_inline_size, ((long) 0));
			      aux_2498 = PROCEDURE_ENTRY(fun1502_892) (fun1502_892, (obj_t) (node_1), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1807_167_1543;
		 }
	    }
	    return (long) CINT(aux_2498);
	 }
      }
   }
}


obj_t 
_node_size_132_inline_size(obj_t env_2331, obj_t node_2332)
{
   {
      long aux_2905;
      aux_2905 = node_size_119_inline_size((node_t) (node_2332));
      return BINT(aux_2905);
   }
}


obj_t 
object_init_111_inline_size()
{
   {
      obj_t arg1506_894;
      arg1506_894 = sequence_ast_node;
      sized_sequence_48_inline_size = add_class__117___object(CNST_TABLE_REF(((long) 1)), arg1506_894, allocate_sized_sequence_env_88_inline_size, ((long) 23653), BUNSPEC);
   }
   {
      obj_t arg1511_898;
      arg1511_898 = app_ast_node;
      sized_app_52_inline_size = add_class__117___object(CNST_TABLE_REF(((long) 2)), arg1511_898, allocate_sized_app_env_53_inline_size, ((long) 23887), BUNSPEC);
   }
   {
      obj_t arg1518_902;
      arg1518_902 = funcall_ast_node;
      sized_funcall_46_inline_size = add_class__117___object(CNST_TABLE_REF(((long) 3)), arg1518_902, allocate_sized_funcall_env_52_inline_size, ((long) 64519), BUNSPEC);
   }
   {
      obj_t arg1524_906;
      arg1524_906 = pragma_ast_node;
      sized_pragma_213_inline_size = add_class__117___object(CNST_TABLE_REF(((long) 4)), arg1524_906, allocate_sized_pragma_env_85_inline_size, ((long) 36778), BUNSPEC);
   }
   {
      obj_t arg1532_910;
      arg1532_910 = conditional_ast_node;
      sized_conditional_152_inline_size = add_class__117___object(CNST_TABLE_REF(((long) 5)), arg1532_910, allocate_sized_conditional_env_43_inline_size, ((long) 5110), BUNSPEC);
   }
   {
      obj_t arg1537_914;
      arg1537_914 = fail_ast_node;
      sized_fail_63_inline_size = add_class__117___object(CNST_TABLE_REF(((long) 6)), arg1537_914, allocate_sized_fail_env_18_inline_size, ((long) 1696), BUNSPEC);
   }
   {
      obj_t arg1541_918;
      arg1541_918 = select_ast_node;
      sized_select_166_inline_size = add_class__117___object(CNST_TABLE_REF(((long) 7)), arg1541_918, allocate_sized_select_env_132_inline_size, ((long) 53935), BUNSPEC);
   }
   {
      obj_t arg1549_922;
      arg1549_922 = let_fun_218_ast_node;
      sized_let_fun_188_inline_size = add_class__117___object(CNST_TABLE_REF(((long) 8)), arg1549_922, allocate_sized_let_fun_env_195_inline_size, ((long) 44450), BUNSPEC);
   }
   {
      obj_t arg1553_926;
      arg1553_926 = let_var_6_ast_node;
      sized_let_var_54_inline_size = add_class__117___object(CNST_TABLE_REF(((long) 9)), arg1553_926, allocate_sized_let_var_env_114_inline_size, ((long) 45615), BUNSPEC);
   }
   {
      obj_t object__struct_sized_let_var_36_2357;
      object__struct_sized_let_var_36_2357 = proc2006_inline_size;
      add_method__1___object(object__struct_env_210___object, sized_let_var_54_inline_size, object__struct_sized_let_var_36_2357);
   }
   {
      obj_t struct_object__object_sized_let_var_128_2356;
      struct_object__object_sized_let_var_128_2356 = proc2007_inline_size;
      add_method__1___object(struct_object__object_env_209___object, sized_let_var_54_inline_size, struct_object__object_sized_let_var_128_2356);
   }
   {
      obj_t object__struct_sized_let_fun_219_2355;
      object__struct_sized_let_fun_219_2355 = proc2008_inline_size;
      add_method__1___object(object__struct_env_210___object, sized_let_fun_188_inline_size, object__struct_sized_let_fun_219_2355);
   }
   {
      obj_t struct_object__object_sized_let_fun_64_2354;
      struct_object__object_sized_let_fun_64_2354 = proc2009_inline_size;
      add_method__1___object(struct_object__object_env_209___object, sized_let_fun_188_inline_size, struct_object__object_sized_let_fun_64_2354);
   }
   {
      obj_t object__struct_sized_select_105_2353;
      object__struct_sized_select_105_2353 = proc2010_inline_size;
      add_method__1___object(object__struct_env_210___object, sized_select_166_inline_size, object__struct_sized_select_105_2353);
   }
   {
      obj_t struct_object__object_sized_select_92_2352;
      struct_object__object_sized_select_92_2352 = proc2011_inline_size;
      add_method__1___object(struct_object__object_env_209___object, sized_select_166_inline_size, struct_object__object_sized_select_92_2352);
   }
   {
      obj_t object__struct_sized_fail_166_2351;
      object__struct_sized_fail_166_2351 = proc2012_inline_size;
      add_method__1___object(object__struct_env_210___object, sized_fail_63_inline_size, object__struct_sized_fail_166_2351);
   }
   {
      obj_t struct_object__object_sized_fail_89_2350;
      struct_object__object_sized_fail_89_2350 = proc2013_inline_size;
      add_method__1___object(struct_object__object_env_209___object, sized_fail_63_inline_size, struct_object__object_sized_fail_89_2350);
   }
   {
      obj_t object__struct_sized_conditional_185_2349;
      object__struct_sized_conditional_185_2349 = proc2014_inline_size;
      add_method__1___object(object__struct_env_210___object, sized_conditional_152_inline_size, object__struct_sized_conditional_185_2349);
   }
   {
      obj_t struct_object__object_sized_conditional_125_2348;
      struct_object__object_sized_conditional_125_2348 = proc2015_inline_size;
      add_method__1___object(struct_object__object_env_209___object, sized_conditional_152_inline_size, struct_object__object_sized_conditional_125_2348);
   }
   {
      obj_t object__struct_sized_pragma_80_2347;
      object__struct_sized_pragma_80_2347 = proc2016_inline_size;
      add_method__1___object(object__struct_env_210___object, sized_pragma_213_inline_size, object__struct_sized_pragma_80_2347);
   }
   {
      obj_t struct_object__object_sized_pragma_4_2346;
      struct_object__object_sized_pragma_4_2346 = proc2017_inline_size;
      add_method__1___object(struct_object__object_env_209___object, sized_pragma_213_inline_size, struct_object__object_sized_pragma_4_2346);
   }
   {
      obj_t object__struct_sized_funcall_84_2345;
      object__struct_sized_funcall_84_2345 = proc2018_inline_size;
      add_method__1___object(object__struct_env_210___object, sized_funcall_46_inline_size, object__struct_sized_funcall_84_2345);
   }
   {
      obj_t struct_object__object_sized_funcall_26_2344;
      struct_object__object_sized_funcall_26_2344 = proc2019_inline_size;
      add_method__1___object(struct_object__object_env_209___object, sized_funcall_46_inline_size, struct_object__object_sized_funcall_26_2344);
   }
   {
      obj_t object__struct_sized_app_170_2343;
      object__struct_sized_app_170_2343 = proc2020_inline_size;
      add_method__1___object(object__struct_env_210___object, sized_app_52_inline_size, object__struct_sized_app_170_2343);
   }
   {
      obj_t struct_object__object_sized_app_70_2342;
      struct_object__object_sized_app_70_2342 = proc2021_inline_size;
      add_method__1___object(struct_object__object_env_209___object, sized_app_52_inline_size, struct_object__object_sized_app_70_2342);
   }
   {
      obj_t object__struct_sized_sequence_166_2339;
      object__struct_sized_sequence_166_2339 = proc2022_inline_size;
      add_method__1___object(object__struct_env_210___object, sized_sequence_48_inline_size, object__struct_sized_sequence_166_2339);
   }
   {
      obj_t struct_object__object_sized_sequence_143_2335;
      struct_object__object_sized_sequence_143_2335 = proc2023_inline_size;
      return add_method__1___object(struct_object__object_env_209___object, sized_sequence_48_inline_size, struct_object__object_sized_sequence_143_2335);
   }
}


obj_t 
struct_object__object_sized_sequence1987_74_inline_size(obj_t env_2358, obj_t o_2359, obj_t s_2360)
{
   {
      sized_sequence_48_t o_1142;
      obj_t s_1143;
      {
	 sized_sequence_48_t aux_2945;
	 o_1142 = (sized_sequence_48_t) (o_2359);
	 s_1143 = s_2360;
	 {
	    {
	       obj_t old1290_1146;
	       obj_t aux1291_1147;
	       {
		  obj_t next_method1499_150_1152;
		  next_method1499_150_1152 = find_super_class_method_167___object((object_t) (o_1142), struct_object__object_env_209___object, sized_sequence_48_inline_size);
		  if (PROCEDUREP(next_method1499_150_1152))
		    {
		       old1290_1146 = PROCEDURE_ENTRY(next_method1499_150_1152) (next_method1499_150_1152, (obj_t) (o_1142), s_1143, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1499_150_1152);
		       {
			  object_t aux_2954;
			  aux_2954 = struct_object__object_93___object((object_t) (o_1142), s_1143);
			  old1290_1146 = (obj_t) (aux_2954);
		       }
		    }
	       }
	       aux1291_1147 = STRUCT_REF(s_1143, ((long) 0));
	       {
		  sized_sequence_48_t new1292_1148;
		  new1292_1148 = ((sized_sequence_48_t) (old1290_1146));
		  {
		     long arg1677_1149;
		     arg1677_1149 = class_num_218___object(sized_sequence_48_inline_size);
		     {
			obj_t obj_2201;
			obj_2201 = (obj_t) (new1292_1148);
			(((obj_t) CREF(obj_2201))->header = MAKE_HEADER(arg1677_1149, 0), BUNSPEC);
		     }
		  }
		  {
		     sized_sequence_48_t arg1678_1150;
		     {
			sized_sequence_48_t res1983_2208;
			{
			   long size_2205;
			   {
			      obj_t aux_2963;
			      aux_2963 = STRUCT_REF(aux1291_1147, ((long) 0));
			      size_2205 = (long) CINT(aux_2963);
			   }
			   {
			      sized_sequence_48_t new1280_2206;
			      new1280_2206 = ((sized_sequence_48_t) BREF(GC_MALLOC(sizeof(struct sized_sequence_48))));
			      ((((sized_sequence_48_t) CREF(new1280_2206))->size) = ((long) size_2205), BUNSPEC);
			      res1983_2208 = new1280_2206;
			   }
			}
			arg1678_1150 = res1983_2208;
		     }
		     {
			obj_t aux_2970;
			object_t aux_2968;
			aux_2970 = (obj_t) (arg1678_1150);
			aux_2968 = (object_t) (new1292_1148);
			OBJECT_WIDENING_SET(aux_2968, aux_2970);
		     }
		  }
		  aux_2945 = new1292_1148;
	       }
	    }
	 }
	 return (obj_t) (aux_2945);
      }
   }
}


obj_t 
object__struct_sized_sequence1988_0_inline_size(obj_t env_2361, obj_t obj1287_2362)
{
   {
      sized_sequence_48_t obj1287_1129;
      obj1287_1129 = (sized_sequence_48_t) (obj1287_2362);
      {
	 {
	    obj_t res1288_1132;
	    {
	       obj_t next_method1498_26_1140;
	       next_method1498_26_1140 = find_super_class_method_167___object((object_t) (obj1287_1129), object__struct_env_210___object, sized_sequence_48_inline_size);
	       if (PROCEDUREP(next_method1498_26_1140))
		 {
		    res1288_1132 = PROCEDURE_ENTRY(next_method1498_26_1140) (next_method1498_26_1140, (obj_t) (obj1287_1129), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1498_26_1140);
		    res1288_1132 = object__struct_50___object((object_t) (obj1287_1129));
		 }
	    }
	    {
	       obj_t aux1289_1133;
	       {
		  obj_t aux_2985;
		  aux_2985 = CNST_TABLE_REF(((long) 1));
		  aux1289_1133 = make_struct(aux_2985, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_2988;
		  {
		     long aux_2989;
		     {
			obj_t aux_2990;
			{
			   object_t aux_2991;
			   aux_2991 = (object_t) (obj1287_1129);
			   aux_2990 = OBJECT_WIDENING(aux_2991);
			}
			aux_2989 = (((sized_sequence_48_t) CREF(aux_2990))->size);
		     }
		     aux_2988 = BINT(aux_2989);
		  }
		  STRUCT_SET(aux1289_1133, ((long) 0), aux_2988);
	       }
	       STRUCT_SET(res1288_1132, ((long) 0), aux1289_1133);
	       {
		  obj_t aux_2998;
		  aux_2998 = STRUCT_KEY(res1288_1132);
		  STRUCT_KEY_SET(aux1289_1133, aux_2998);
	       }
	       {
		  obj_t aux_3001;
		  aux_3001 = CNST_TABLE_REF(((long) 1));
		  STRUCT_KEY_SET(res1288_1132, aux_3001);
	       }
	       return res1288_1132;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_sized_app1989_163_inline_size(obj_t env_2363, obj_t o_2364, obj_t s_2365)
{
   {
      sized_app_52_t o_1117;
      obj_t s_1118;
      {
	 sized_app_52_t aux_3005;
	 o_1117 = (sized_app_52_t) (o_2364);
	 s_1118 = s_2365;
	 {
	    {
	       obj_t old1307_1121;
	       obj_t aux1308_1122;
	       {
		  obj_t next_method1497_99_1127;
		  next_method1497_99_1127 = find_super_class_method_167___object((object_t) (o_1117), struct_object__object_env_209___object, sized_app_52_inline_size);
		  if (PROCEDUREP(next_method1497_99_1127))
		    {
		       old1307_1121 = PROCEDURE_ENTRY(next_method1497_99_1127) (next_method1497_99_1127, (obj_t) (o_1117), s_1118, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1497_99_1127);
		       {
			  object_t aux_3014;
			  aux_3014 = struct_object__object_93___object((object_t) (o_1117), s_1118);
			  old1307_1121 = (obj_t) (aux_3014);
		       }
		    }
	       }
	       aux1308_1122 = STRUCT_REF(s_1118, ((long) 0));
	       {
		  sized_app_52_t new1309_1123;
		  new1309_1123 = ((sized_app_52_t) (old1307_1121));
		  {
		     long arg1663_1124;
		     arg1663_1124 = class_num_218___object(sized_app_52_inline_size);
		     {
			obj_t obj_2172;
			obj_2172 = (obj_t) (new1309_1123);
			(((obj_t) CREF(obj_2172))->header = MAKE_HEADER(arg1663_1124, 0), BUNSPEC);
		     }
		  }
		  {
		     sized_app_52_t arg1664_1125;
		     {
			sized_app_52_t res1982_2179;
			{
			   long size_2176;
			   {
			      obj_t aux_3023;
			      aux_3023 = STRUCT_REF(aux1308_1122, ((long) 0));
			      size_2176 = (long) CINT(aux_3023);
			   }
			   {
			      sized_app_52_t new1294_2177;
			      new1294_2177 = ((sized_app_52_t) BREF(GC_MALLOC(sizeof(struct sized_app_52))));
			      ((((sized_app_52_t) CREF(new1294_2177))->size) = ((long) size_2176), BUNSPEC);
			      res1982_2179 = new1294_2177;
			   }
			}
			arg1664_1125 = res1982_2179;
		     }
		     {
			obj_t aux_3030;
			object_t aux_3028;
			aux_3030 = (obj_t) (arg1664_1125);
			aux_3028 = (object_t) (new1309_1123);
			OBJECT_WIDENING_SET(aux_3028, aux_3030);
		     }
		  }
		  aux_3005 = new1309_1123;
	       }
	    }
	 }
	 return (obj_t) (aux_3005);
      }
   }
}


obj_t 
object__struct_sized_app1990_5_inline_size(obj_t env_2366, obj_t obj1304_2367)
{
   {
      sized_app_52_t obj1304_1104;
      obj1304_1104 = (sized_app_52_t) (obj1304_2367);
      {
	 {
	    obj_t res1305_1107;
	    {
	       obj_t next_method1496_100_1115;
	       next_method1496_100_1115 = find_super_class_method_167___object((object_t) (obj1304_1104), object__struct_env_210___object, sized_app_52_inline_size);
	       if (PROCEDUREP(next_method1496_100_1115))
		 {
		    res1305_1107 = PROCEDURE_ENTRY(next_method1496_100_1115) (next_method1496_100_1115, (obj_t) (obj1304_1104), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1496_100_1115);
		    res1305_1107 = object__struct_50___object((object_t) (obj1304_1104));
		 }
	    }
	    {
	       obj_t aux1306_1108;
	       {
		  obj_t aux_3045;
		  aux_3045 = CNST_TABLE_REF(((long) 2));
		  aux1306_1108 = make_struct(aux_3045, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_3048;
		  {
		     long aux_3049;
		     {
			obj_t aux_3050;
			{
			   object_t aux_3051;
			   aux_3051 = (object_t) (obj1304_1104);
			   aux_3050 = OBJECT_WIDENING(aux_3051);
			}
			aux_3049 = (((sized_app_52_t) CREF(aux_3050))->size);
		     }
		     aux_3048 = BINT(aux_3049);
		  }
		  STRUCT_SET(aux1306_1108, ((long) 0), aux_3048);
	       }
	       STRUCT_SET(res1305_1107, ((long) 0), aux1306_1108);
	       {
		  obj_t aux_3058;
		  aux_3058 = STRUCT_KEY(res1305_1107);
		  STRUCT_KEY_SET(aux1306_1108, aux_3058);
	       }
	       {
		  obj_t aux_3061;
		  aux_3061 = CNST_TABLE_REF(((long) 2));
		  STRUCT_KEY_SET(res1305_1107, aux_3061);
	       }
	       return res1305_1107;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_sized_funcall1991_41_inline_size(obj_t env_2368, obj_t o_2369, obj_t s_2370)
{
   {
      sized_funcall_46_t o_1092;
      obj_t s_1093;
      {
	 sized_funcall_46_t aux_3065;
	 o_1092 = (sized_funcall_46_t) (o_2369);
	 s_1093 = s_2370;
	 {
	    {
	       obj_t old1323_1096;
	       obj_t aux1324_1097;
	       {
		  obj_t next_method1495_195_1102;
		  next_method1495_195_1102 = find_super_class_method_167___object((object_t) (o_1092), struct_object__object_env_209___object, sized_funcall_46_inline_size);
		  if (PROCEDUREP(next_method1495_195_1102))
		    {
		       old1323_1096 = PROCEDURE_ENTRY(next_method1495_195_1102) (next_method1495_195_1102, (obj_t) (o_1092), s_1093, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1495_195_1102);
		       {
			  object_t aux_3074;
			  aux_3074 = struct_object__object_93___object((object_t) (o_1092), s_1093);
			  old1323_1096 = (obj_t) (aux_3074);
		       }
		    }
	       }
	       aux1324_1097 = STRUCT_REF(s_1093, ((long) 0));
	       {
		  sized_funcall_46_t new1325_1098;
		  new1325_1098 = ((sized_funcall_46_t) (old1323_1096));
		  {
		     long arg1650_1099;
		     arg1650_1099 = class_num_218___object(sized_funcall_46_inline_size);
		     {
			obj_t obj_2143;
			obj_2143 = (obj_t) (new1325_1098);
			(((obj_t) CREF(obj_2143))->header = MAKE_HEADER(arg1650_1099, 0), BUNSPEC);
		     }
		  }
		  {
		     sized_funcall_46_t arg1651_1100;
		     {
			sized_funcall_46_t res1981_2150;
			{
			   long size_2147;
			   {
			      obj_t aux_3083;
			      aux_3083 = STRUCT_REF(aux1324_1097, ((long) 0));
			      size_2147 = (long) CINT(aux_3083);
			   }
			   {
			      sized_funcall_46_t new1311_2148;
			      new1311_2148 = ((sized_funcall_46_t) BREF(GC_MALLOC(sizeof(struct sized_funcall_46))));
			      ((((sized_funcall_46_t) CREF(new1311_2148))->size) = ((long) size_2147), BUNSPEC);
			      res1981_2150 = new1311_2148;
			   }
			}
			arg1651_1100 = res1981_2150;
		     }
		     {
			obj_t aux_3090;
			object_t aux_3088;
			aux_3090 = (obj_t) (arg1651_1100);
			aux_3088 = (object_t) (new1325_1098);
			OBJECT_WIDENING_SET(aux_3088, aux_3090);
		     }
		  }
		  aux_3065 = new1325_1098;
	       }
	    }
	 }
	 return (obj_t) (aux_3065);
      }
   }
}


obj_t 
object__struct_sized_funcall1992_27_inline_size(obj_t env_2371, obj_t obj1320_2372)
{
   {
      sized_funcall_46_t obj1320_1079;
      obj1320_1079 = (sized_funcall_46_t) (obj1320_2372);
      {
	 {
	    obj_t res1321_1082;
	    {
	       obj_t next_method1494_175_1090;
	       next_method1494_175_1090 = find_super_class_method_167___object((object_t) (obj1320_1079), object__struct_env_210___object, sized_funcall_46_inline_size);
	       if (PROCEDUREP(next_method1494_175_1090))
		 {
		    res1321_1082 = PROCEDURE_ENTRY(next_method1494_175_1090) (next_method1494_175_1090, (obj_t) (obj1320_1079), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1494_175_1090);
		    res1321_1082 = object__struct_50___object((object_t) (obj1320_1079));
		 }
	    }
	    {
	       obj_t aux1322_1083;
	       {
		  obj_t aux_3105;
		  aux_3105 = CNST_TABLE_REF(((long) 3));
		  aux1322_1083 = make_struct(aux_3105, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_3108;
		  {
		     long aux_3109;
		     {
			obj_t aux_3110;
			{
			   object_t aux_3111;
			   aux_3111 = (object_t) (obj1320_1079);
			   aux_3110 = OBJECT_WIDENING(aux_3111);
			}
			aux_3109 = (((sized_funcall_46_t) CREF(aux_3110))->size);
		     }
		     aux_3108 = BINT(aux_3109);
		  }
		  STRUCT_SET(aux1322_1083, ((long) 0), aux_3108);
	       }
	       STRUCT_SET(res1321_1082, ((long) 0), aux1322_1083);
	       {
		  obj_t aux_3118;
		  aux_3118 = STRUCT_KEY(res1321_1082);
		  STRUCT_KEY_SET(aux1322_1083, aux_3118);
	       }
	       {
		  obj_t aux_3121;
		  aux_3121 = CNST_TABLE_REF(((long) 3));
		  STRUCT_KEY_SET(res1321_1082, aux_3121);
	       }
	       return res1321_1082;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_sized_pragma1993_110_inline_size(obj_t env_2373, obj_t o_2374, obj_t s_2375)
{
   {
      sized_pragma_213_t o_1067;
      obj_t s_1068;
      {
	 sized_pragma_213_t aux_3125;
	 o_1067 = (sized_pragma_213_t) (o_2374);
	 s_1068 = s_2375;
	 {
	    {
	       obj_t old1338_1071;
	       obj_t aux1339_1072;
	       {
		  obj_t next_method1493_34_1077;
		  next_method1493_34_1077 = find_super_class_method_167___object((object_t) (o_1067), struct_object__object_env_209___object, sized_pragma_213_inline_size);
		  if (PROCEDUREP(next_method1493_34_1077))
		    {
		       old1338_1071 = PROCEDURE_ENTRY(next_method1493_34_1077) (next_method1493_34_1077, (obj_t) (o_1067), s_1068, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1493_34_1077);
		       {
			  object_t aux_3134;
			  aux_3134 = struct_object__object_93___object((object_t) (o_1067), s_1068);
			  old1338_1071 = (obj_t) (aux_3134);
		       }
		    }
	       }
	       aux1339_1072 = STRUCT_REF(s_1068, ((long) 0));
	       {
		  sized_pragma_213_t new1340_1073;
		  new1340_1073 = ((sized_pragma_213_t) (old1338_1071));
		  {
		     long arg1637_1074;
		     arg1637_1074 = class_num_218___object(sized_pragma_213_inline_size);
		     {
			obj_t obj_2114;
			obj_2114 = (obj_t) (new1340_1073);
			(((obj_t) CREF(obj_2114))->header = MAKE_HEADER(arg1637_1074, 0), BUNSPEC);
		     }
		  }
		  {
		     sized_pragma_213_t arg1638_1075;
		     {
			sized_pragma_213_t res1980_2121;
			{
			   long size_2118;
			   {
			      obj_t aux_3143;
			      aux_3143 = STRUCT_REF(aux1339_1072, ((long) 0));
			      size_2118 = (long) CINT(aux_3143);
			   }
			   {
			      sized_pragma_213_t new1327_2119;
			      new1327_2119 = ((sized_pragma_213_t) BREF(GC_MALLOC(sizeof(struct sized_pragma_213))));
			      ((((sized_pragma_213_t) CREF(new1327_2119))->size) = ((long) size_2118), BUNSPEC);
			      res1980_2121 = new1327_2119;
			   }
			}
			arg1638_1075 = res1980_2121;
		     }
		     {
			obj_t aux_3150;
			object_t aux_3148;
			aux_3150 = (obj_t) (arg1638_1075);
			aux_3148 = (object_t) (new1340_1073);
			OBJECT_WIDENING_SET(aux_3148, aux_3150);
		     }
		  }
		  aux_3125 = new1340_1073;
	       }
	    }
	 }
	 return (obj_t) (aux_3125);
      }
   }
}


obj_t 
object__struct_sized_pragma1994_213_inline_size(obj_t env_2376, obj_t obj1335_2377)
{
   {
      sized_pragma_213_t obj1335_1054;
      obj1335_1054 = (sized_pragma_213_t) (obj1335_2377);
      {
	 {
	    obj_t res1336_1057;
	    {
	       obj_t next_method1492_50_1065;
	       next_method1492_50_1065 = find_super_class_method_167___object((object_t) (obj1335_1054), object__struct_env_210___object, sized_pragma_213_inline_size);
	       if (PROCEDUREP(next_method1492_50_1065))
		 {
		    res1336_1057 = PROCEDURE_ENTRY(next_method1492_50_1065) (next_method1492_50_1065, (obj_t) (obj1335_1054), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1492_50_1065);
		    res1336_1057 = object__struct_50___object((object_t) (obj1335_1054));
		 }
	    }
	    {
	       obj_t aux1337_1058;
	       {
		  obj_t aux_3165;
		  aux_3165 = CNST_TABLE_REF(((long) 4));
		  aux1337_1058 = make_struct(aux_3165, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_3168;
		  {
		     long aux_3169;
		     {
			obj_t aux_3170;
			{
			   object_t aux_3171;
			   aux_3171 = (object_t) (obj1335_1054);
			   aux_3170 = OBJECT_WIDENING(aux_3171);
			}
			aux_3169 = (((sized_pragma_213_t) CREF(aux_3170))->size);
		     }
		     aux_3168 = BINT(aux_3169);
		  }
		  STRUCT_SET(aux1337_1058, ((long) 0), aux_3168);
	       }
	       STRUCT_SET(res1336_1057, ((long) 0), aux1337_1058);
	       {
		  obj_t aux_3178;
		  aux_3178 = STRUCT_KEY(res1336_1057);
		  STRUCT_KEY_SET(aux1337_1058, aux_3178);
	       }
	       {
		  obj_t aux_3181;
		  aux_3181 = CNST_TABLE_REF(((long) 4));
		  STRUCT_KEY_SET(res1336_1057, aux_3181);
	       }
	       return res1336_1057;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_sized_conditional1995_244_inline_size(obj_t env_2378, obj_t o_2379, obj_t s_2380)
{
   {
      sized_conditional_152_t o_1042;
      obj_t s_1043;
      {
	 sized_conditional_152_t aux_3185;
	 o_1042 = (sized_conditional_152_t) (o_2379);
	 s_1043 = s_2380;
	 {
	    {
	       obj_t old1355_1046;
	       obj_t aux1356_1047;
	       {
		  obj_t next_method1491_80_1052;
		  next_method1491_80_1052 = find_super_class_method_167___object((object_t) (o_1042), struct_object__object_env_209___object, sized_conditional_152_inline_size);
		  if (PROCEDUREP(next_method1491_80_1052))
		    {
		       old1355_1046 = PROCEDURE_ENTRY(next_method1491_80_1052) (next_method1491_80_1052, (obj_t) (o_1042), s_1043, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1491_80_1052);
		       {
			  object_t aux_3194;
			  aux_3194 = struct_object__object_93___object((object_t) (o_1042), s_1043);
			  old1355_1046 = (obj_t) (aux_3194);
		       }
		    }
	       }
	       aux1356_1047 = STRUCT_REF(s_1043, ((long) 0));
	       {
		  sized_conditional_152_t new1357_1048;
		  new1357_1048 = ((sized_conditional_152_t) (old1355_1046));
		  {
		     long arg1621_1049;
		     arg1621_1049 = class_num_218___object(sized_conditional_152_inline_size);
		     {
			obj_t obj_2085;
			obj_2085 = (obj_t) (new1357_1048);
			(((obj_t) CREF(obj_2085))->header = MAKE_HEADER(arg1621_1049, 0), BUNSPEC);
		     }
		  }
		  {
		     sized_conditional_152_t arg1623_1050;
		     {
			sized_conditional_152_t res1979_2092;
			{
			   long size_2089;
			   {
			      obj_t aux_3203;
			      aux_3203 = STRUCT_REF(aux1356_1047, ((long) 0));
			      size_2089 = (long) CINT(aux_3203);
			   }
			   {
			      sized_conditional_152_t new1342_2090;
			      new1342_2090 = ((sized_conditional_152_t) BREF(GC_MALLOC(sizeof(struct sized_conditional_152))));
			      ((((sized_conditional_152_t) CREF(new1342_2090))->size) = ((long) size_2089), BUNSPEC);
			      res1979_2092 = new1342_2090;
			   }
			}
			arg1623_1050 = res1979_2092;
		     }
		     {
			obj_t aux_3210;
			object_t aux_3208;
			aux_3210 = (obj_t) (arg1623_1050);
			aux_3208 = (object_t) (new1357_1048);
			OBJECT_WIDENING_SET(aux_3208, aux_3210);
		     }
		  }
		  aux_3185 = new1357_1048;
	       }
	    }
	 }
	 return (obj_t) (aux_3185);
      }
   }
}


obj_t 
object__struct_sized_conditional1996_49_inline_size(obj_t env_2381, obj_t obj1352_2382)
{
   {
      sized_conditional_152_t obj1352_1029;
      obj1352_1029 = (sized_conditional_152_t) (obj1352_2382);
      {
	 {
	    obj_t res1353_1032;
	    {
	       obj_t next_method1472_163_1040;
	       next_method1472_163_1040 = find_super_class_method_167___object((object_t) (obj1352_1029), object__struct_env_210___object, sized_conditional_152_inline_size);
	       if (PROCEDUREP(next_method1472_163_1040))
		 {
		    res1353_1032 = PROCEDURE_ENTRY(next_method1472_163_1040) (next_method1472_163_1040, (obj_t) (obj1352_1029), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1472_163_1040);
		    res1353_1032 = object__struct_50___object((object_t) (obj1352_1029));
		 }
	    }
	    {
	       obj_t aux1354_1033;
	       {
		  obj_t aux_3225;
		  aux_3225 = CNST_TABLE_REF(((long) 5));
		  aux1354_1033 = make_struct(aux_3225, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_3228;
		  {
		     long aux_3229;
		     {
			obj_t aux_3230;
			{
			   object_t aux_3231;
			   aux_3231 = (object_t) (obj1352_1029);
			   aux_3230 = OBJECT_WIDENING(aux_3231);
			}
			aux_3229 = (((sized_conditional_152_t) CREF(aux_3230))->size);
		     }
		     aux_3228 = BINT(aux_3229);
		  }
		  STRUCT_SET(aux1354_1033, ((long) 0), aux_3228);
	       }
	       STRUCT_SET(res1353_1032, ((long) 0), aux1354_1033);
	       {
		  obj_t aux_3238;
		  aux_3238 = STRUCT_KEY(res1353_1032);
		  STRUCT_KEY_SET(aux1354_1033, aux_3238);
	       }
	       {
		  obj_t aux_3241;
		  aux_3241 = CNST_TABLE_REF(((long) 5));
		  STRUCT_KEY_SET(res1353_1032, aux_3241);
	       }
	       return res1353_1032;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_sized_fail1997_234_inline_size(obj_t env_2383, obj_t o_2384, obj_t s_2385)
{
   {
      sized_fail_63_t o_1017;
      obj_t s_1018;
      {
	 sized_fail_63_t aux_3245;
	 o_1017 = (sized_fail_63_t) (o_2384);
	 s_1018 = s_2385;
	 {
	    {
	       obj_t old1373_1021;
	       obj_t aux1374_1022;
	       {
		  obj_t next_method1471_235_1027;
		  next_method1471_235_1027 = find_super_class_method_167___object((object_t) (o_1017), struct_object__object_env_209___object, sized_fail_63_inline_size);
		  if (PROCEDUREP(next_method1471_235_1027))
		    {
		       old1373_1021 = PROCEDURE_ENTRY(next_method1471_235_1027) (next_method1471_235_1027, (obj_t) (o_1017), s_1018, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1471_235_1027);
		       {
			  object_t aux_3254;
			  aux_3254 = struct_object__object_93___object((object_t) (o_1017), s_1018);
			  old1373_1021 = (obj_t) (aux_3254);
		       }
		    }
	       }
	       aux1374_1022 = STRUCT_REF(s_1018, ((long) 0));
	       {
		  sized_fail_63_t new1375_1023;
		  new1375_1023 = ((sized_fail_63_t) (old1373_1021));
		  {
		     long arg1605_1024;
		     arg1605_1024 = class_num_218___object(sized_fail_63_inline_size);
		     {
			obj_t obj_2056;
			obj_2056 = (obj_t) (new1375_1023);
			(((obj_t) CREF(obj_2056))->header = MAKE_HEADER(arg1605_1024, 0), BUNSPEC);
		     }
		  }
		  {
		     sized_fail_63_t arg1606_1025;
		     {
			sized_fail_63_t res1978_2063;
			{
			   long size_2060;
			   {
			      obj_t aux_3263;
			      aux_3263 = STRUCT_REF(aux1374_1022, ((long) 0));
			      size_2060 = (long) CINT(aux_3263);
			   }
			   {
			      sized_fail_63_t new1359_2061;
			      new1359_2061 = ((sized_fail_63_t) BREF(GC_MALLOC(sizeof(struct sized_fail_63))));
			      ((((sized_fail_63_t) CREF(new1359_2061))->size) = ((long) size_2060), BUNSPEC);
			      res1978_2063 = new1359_2061;
			   }
			}
			arg1606_1025 = res1978_2063;
		     }
		     {
			obj_t aux_3270;
			object_t aux_3268;
			aux_3270 = (obj_t) (arg1606_1025);
			aux_3268 = (object_t) (new1375_1023);
			OBJECT_WIDENING_SET(aux_3268, aux_3270);
		     }
		  }
		  aux_3245 = new1375_1023;
	       }
	    }
	 }
	 return (obj_t) (aux_3245);
      }
   }
}


obj_t 
object__struct_sized_fail1998_140_inline_size(obj_t env_2386, obj_t obj1370_2387)
{
   {
      sized_fail_63_t obj1370_1004;
      obj1370_1004 = (sized_fail_63_t) (obj1370_2387);
      {
	 {
	    obj_t res1371_1007;
	    {
	       obj_t next_method1470_222_1015;
	       next_method1470_222_1015 = find_super_class_method_167___object((object_t) (obj1370_1004), object__struct_env_210___object, sized_fail_63_inline_size);
	       if (PROCEDUREP(next_method1470_222_1015))
		 {
		    res1371_1007 = PROCEDURE_ENTRY(next_method1470_222_1015) (next_method1470_222_1015, (obj_t) (obj1370_1004), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1470_222_1015);
		    res1371_1007 = object__struct_50___object((object_t) (obj1370_1004));
		 }
	    }
	    {
	       obj_t aux1372_1008;
	       {
		  obj_t aux_3285;
		  aux_3285 = CNST_TABLE_REF(((long) 6));
		  aux1372_1008 = make_struct(aux_3285, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_3288;
		  {
		     long aux_3289;
		     {
			obj_t aux_3290;
			{
			   object_t aux_3291;
			   aux_3291 = (object_t) (obj1370_1004);
			   aux_3290 = OBJECT_WIDENING(aux_3291);
			}
			aux_3289 = (((sized_fail_63_t) CREF(aux_3290))->size);
		     }
		     aux_3288 = BINT(aux_3289);
		  }
		  STRUCT_SET(aux1372_1008, ((long) 0), aux_3288);
	       }
	       STRUCT_SET(res1371_1007, ((long) 0), aux1372_1008);
	       {
		  obj_t aux_3298;
		  aux_3298 = STRUCT_KEY(res1371_1007);
		  STRUCT_KEY_SET(aux1372_1008, aux_3298);
	       }
	       {
		  obj_t aux_3301;
		  aux_3301 = CNST_TABLE_REF(((long) 6));
		  STRUCT_KEY_SET(res1371_1007, aux_3301);
	       }
	       return res1371_1007;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_sized_select1999_97_inline_size(obj_t env_2388, obj_t o_2389, obj_t s_2390)
{
   {
      sized_select_166_t o_992;
      obj_t s_993;
      {
	 sized_select_166_t aux_3305;
	 o_992 = (sized_select_166_t) (o_2389);
	 s_993 = s_2390;
	 {
	    {
	       obj_t old1388_996;
	       obj_t aux1389_997;
	       {
		  obj_t next_method1469_121_1002;
		  next_method1469_121_1002 = find_super_class_method_167___object((object_t) (o_992), struct_object__object_env_209___object, sized_select_166_inline_size);
		  if (PROCEDUREP(next_method1469_121_1002))
		    {
		       old1388_996 = PROCEDURE_ENTRY(next_method1469_121_1002) (next_method1469_121_1002, (obj_t) (o_992), s_993, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1469_121_1002);
		       {
			  object_t aux_3314;
			  aux_3314 = struct_object__object_93___object((object_t) (o_992), s_993);
			  old1388_996 = (obj_t) (aux_3314);
		       }
		    }
	       }
	       aux1389_997 = STRUCT_REF(s_993, ((long) 0));
	       {
		  sized_select_166_t new1390_998;
		  new1390_998 = ((sized_select_166_t) (old1388_996));
		  {
		     long arg1590_999;
		     arg1590_999 = class_num_218___object(sized_select_166_inline_size);
		     {
			obj_t obj_2027;
			obj_2027 = (obj_t) (new1390_998);
			(((obj_t) CREF(obj_2027))->header = MAKE_HEADER(arg1590_999, 0), BUNSPEC);
		     }
		  }
		  {
		     sized_select_166_t arg1591_1000;
		     {
			sized_select_166_t res1977_2034;
			{
			   long size_2031;
			   {
			      obj_t aux_3323;
			      aux_3323 = STRUCT_REF(aux1389_997, ((long) 0));
			      size_2031 = (long) CINT(aux_3323);
			   }
			   {
			      sized_select_166_t new1377_2032;
			      new1377_2032 = ((sized_select_166_t) BREF(GC_MALLOC(sizeof(struct sized_select_166))));
			      ((((sized_select_166_t) CREF(new1377_2032))->size) = ((long) size_2031), BUNSPEC);
			      res1977_2034 = new1377_2032;
			   }
			}
			arg1591_1000 = res1977_2034;
		     }
		     {
			obj_t aux_3330;
			object_t aux_3328;
			aux_3330 = (obj_t) (arg1591_1000);
			aux_3328 = (object_t) (new1390_998);
			OBJECT_WIDENING_SET(aux_3328, aux_3330);
		     }
		  }
		  aux_3305 = new1390_998;
	       }
	    }
	 }
	 return (obj_t) (aux_3305);
      }
   }
}


obj_t 
object__struct_sized_select2000_2_inline_size(obj_t env_2391, obj_t obj1385_2392)
{
   {
      sized_select_166_t obj1385_979;
      obj1385_979 = (sized_select_166_t) (obj1385_2392);
      {
	 {
	    obj_t res1386_982;
	    {
	       obj_t next_method1468_64_990;
	       next_method1468_64_990 = find_super_class_method_167___object((object_t) (obj1385_979), object__struct_env_210___object, sized_select_166_inline_size);
	       if (PROCEDUREP(next_method1468_64_990))
		 {
		    res1386_982 = PROCEDURE_ENTRY(next_method1468_64_990) (next_method1468_64_990, (obj_t) (obj1385_979), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1468_64_990);
		    res1386_982 = object__struct_50___object((object_t) (obj1385_979));
		 }
	    }
	    {
	       obj_t aux1387_983;
	       {
		  obj_t aux_3345;
		  aux_3345 = CNST_TABLE_REF(((long) 7));
		  aux1387_983 = make_struct(aux_3345, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_3348;
		  {
		     long aux_3349;
		     {
			obj_t aux_3350;
			{
			   object_t aux_3351;
			   aux_3351 = (object_t) (obj1385_979);
			   aux_3350 = OBJECT_WIDENING(aux_3351);
			}
			aux_3349 = (((sized_select_166_t) CREF(aux_3350))->size);
		     }
		     aux_3348 = BINT(aux_3349);
		  }
		  STRUCT_SET(aux1387_983, ((long) 0), aux_3348);
	       }
	       STRUCT_SET(res1386_982, ((long) 0), aux1387_983);
	       {
		  obj_t aux_3358;
		  aux_3358 = STRUCT_KEY(res1386_982);
		  STRUCT_KEY_SET(aux1387_983, aux_3358);
	       }
	       {
		  obj_t aux_3361;
		  aux_3361 = CNST_TABLE_REF(((long) 7));
		  STRUCT_KEY_SET(res1386_982, aux_3361);
	       }
	       return res1386_982;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_sized_let_fun2001_119_inline_size(obj_t env_2393, obj_t o_2394, obj_t s_2395)
{
   {
      sized_let_fun_188_t o_967;
      obj_t s_968;
      {
	 sized_let_fun_188_t aux_3365;
	 o_967 = (sized_let_fun_188_t) (o_2394);
	 s_968 = s_2395;
	 {
	    {
	       obj_t old1404_971;
	       obj_t aux1405_972;
	       {
		  obj_t next_method1467_185_977;
		  next_method1467_185_977 = find_super_class_method_167___object((object_t) (o_967), struct_object__object_env_209___object, sized_let_fun_188_inline_size);
		  if (PROCEDUREP(next_method1467_185_977))
		    {
		       old1404_971 = PROCEDURE_ENTRY(next_method1467_185_977) (next_method1467_185_977, (obj_t) (o_967), s_968, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1467_185_977);
		       {
			  object_t aux_3374;
			  aux_3374 = struct_object__object_93___object((object_t) (o_967), s_968);
			  old1404_971 = (obj_t) (aux_3374);
		       }
		    }
	       }
	       aux1405_972 = STRUCT_REF(s_968, ((long) 0));
	       {
		  sized_let_fun_188_t new1406_973;
		  new1406_973 = ((sized_let_fun_188_t) (old1404_971));
		  {
		     long arg1577_974;
		     arg1577_974 = class_num_218___object(sized_let_fun_188_inline_size);
		     {
			obj_t obj_1998;
			obj_1998 = (obj_t) (new1406_973);
			(((obj_t) CREF(obj_1998))->header = MAKE_HEADER(arg1577_974, 0), BUNSPEC);
		     }
		  }
		  {
		     sized_let_fun_188_t arg1578_975;
		     {
			sized_let_fun_188_t res1976_2005;
			{
			   long size_2002;
			   {
			      obj_t aux_3383;
			      aux_3383 = STRUCT_REF(aux1405_972, ((long) 0));
			      size_2002 = (long) CINT(aux_3383);
			   }
			   {
			      sized_let_fun_188_t new1392_2003;
			      new1392_2003 = ((sized_let_fun_188_t) BREF(GC_MALLOC(sizeof(struct sized_let_fun_188))));
			      ((((sized_let_fun_188_t) CREF(new1392_2003))->size) = ((long) size_2002), BUNSPEC);
			      res1976_2005 = new1392_2003;
			   }
			}
			arg1578_975 = res1976_2005;
		     }
		     {
			obj_t aux_3390;
			object_t aux_3388;
			aux_3390 = (obj_t) (arg1578_975);
			aux_3388 = (object_t) (new1406_973);
			OBJECT_WIDENING_SET(aux_3388, aux_3390);
		     }
		  }
		  aux_3365 = new1406_973;
	       }
	    }
	 }
	 return (obj_t) (aux_3365);
      }
   }
}


obj_t 
object__struct_sized_let_fun2002_105_inline_size(obj_t env_2396, obj_t obj1401_2397)
{
   {
      sized_let_fun_188_t obj1401_954;
      obj1401_954 = (sized_let_fun_188_t) (obj1401_2397);
      {
	 {
	    obj_t res1402_957;
	    {
	       obj_t next_method1466_194_965;
	       next_method1466_194_965 = find_super_class_method_167___object((object_t) (obj1401_954), object__struct_env_210___object, sized_let_fun_188_inline_size);
	       if (PROCEDUREP(next_method1466_194_965))
		 {
		    res1402_957 = PROCEDURE_ENTRY(next_method1466_194_965) (next_method1466_194_965, (obj_t) (obj1401_954), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1466_194_965);
		    res1402_957 = object__struct_50___object((object_t) (obj1401_954));
		 }
	    }
	    {
	       obj_t aux1403_958;
	       {
		  obj_t aux_3405;
		  aux_3405 = CNST_TABLE_REF(((long) 8));
		  aux1403_958 = make_struct(aux_3405, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_3408;
		  {
		     long aux_3409;
		     {
			obj_t aux_3410;
			{
			   object_t aux_3411;
			   aux_3411 = (object_t) (obj1401_954);
			   aux_3410 = OBJECT_WIDENING(aux_3411);
			}
			aux_3409 = (((sized_let_fun_188_t) CREF(aux_3410))->size);
		     }
		     aux_3408 = BINT(aux_3409);
		  }
		  STRUCT_SET(aux1403_958, ((long) 0), aux_3408);
	       }
	       STRUCT_SET(res1402_957, ((long) 0), aux1403_958);
	       {
		  obj_t aux_3418;
		  aux_3418 = STRUCT_KEY(res1402_957);
		  STRUCT_KEY_SET(aux1403_958, aux_3418);
	       }
	       {
		  obj_t aux_3421;
		  aux_3421 = CNST_TABLE_REF(((long) 8));
		  STRUCT_KEY_SET(res1402_957, aux_3421);
	       }
	       return res1402_957;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_sized_let_var2003_87_inline_size(obj_t env_2398, obj_t o_2399, obj_t s_2400)
{
   {
      sized_let_var_54_t o_942;
      obj_t s_943;
      {
	 sized_let_var_54_t aux_3425;
	 o_942 = (sized_let_var_54_t) (o_2399);
	 s_943 = s_2400;
	 {
	    {
	       obj_t old1421_946;
	       obj_t aux1422_947;
	       {
		  obj_t next_method1465_29_952;
		  next_method1465_29_952 = find_super_class_method_167___object((object_t) (o_942), struct_object__object_env_209___object, sized_let_var_54_inline_size);
		  if (PROCEDUREP(next_method1465_29_952))
		    {
		       old1421_946 = PROCEDURE_ENTRY(next_method1465_29_952) (next_method1465_29_952, (obj_t) (o_942), s_943, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1465_29_952);
		       {
			  object_t aux_3434;
			  aux_3434 = struct_object__object_93___object((object_t) (o_942), s_943);
			  old1421_946 = (obj_t) (aux_3434);
		       }
		    }
	       }
	       aux1422_947 = STRUCT_REF(s_943, ((long) 0));
	       {
		  sized_let_var_54_t new1423_948;
		  new1423_948 = ((sized_let_var_54_t) (old1421_946));
		  {
		     long arg1565_949;
		     arg1565_949 = class_num_218___object(sized_let_var_54_inline_size);
		     {
			obj_t obj_1969;
			obj_1969 = (obj_t) (new1423_948);
			(((obj_t) CREF(obj_1969))->header = MAKE_HEADER(arg1565_949, 0), BUNSPEC);
		     }
		  }
		  {
		     sized_let_var_54_t arg1566_950;
		     {
			sized_let_var_54_t res1975_1976;
			{
			   long size_1973;
			   {
			      obj_t aux_3443;
			      aux_3443 = STRUCT_REF(aux1422_947, ((long) 0));
			      size_1973 = (long) CINT(aux_3443);
			   }
			   {
			      sized_let_var_54_t new1408_1974;
			      new1408_1974 = ((sized_let_var_54_t) BREF(GC_MALLOC(sizeof(struct sized_let_var_54))));
			      ((((sized_let_var_54_t) CREF(new1408_1974))->size) = ((long) size_1973), BUNSPEC);
			      res1975_1976 = new1408_1974;
			   }
			}
			arg1566_950 = res1975_1976;
		     }
		     {
			obj_t aux_3450;
			object_t aux_3448;
			aux_3450 = (obj_t) (arg1566_950);
			aux_3448 = (object_t) (new1423_948);
			OBJECT_WIDENING_SET(aux_3448, aux_3450);
		     }
		  }
		  aux_3425 = new1423_948;
	       }
	    }
	 }
	 return (obj_t) (aux_3425);
      }
   }
}


obj_t 
object__struct_sized_let_var2004_62_inline_size(obj_t env_2401, obj_t obj1418_2402)
{
   {
      sized_let_var_54_t obj1418_929;
      obj1418_929 = (sized_let_var_54_t) (obj1418_2402);
      {
	 {
	    obj_t res1419_932;
	    {
	       obj_t next_method1464_164_940;
	       next_method1464_164_940 = find_super_class_method_167___object((object_t) (obj1418_929), object__struct_env_210___object, sized_let_var_54_inline_size);
	       if (PROCEDUREP(next_method1464_164_940))
		 {
		    res1419_932 = PROCEDURE_ENTRY(next_method1464_164_940) (next_method1464_164_940, (obj_t) (obj1418_929), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1464_164_940);
		    res1419_932 = object__struct_50___object((object_t) (obj1418_929));
		 }
	    }
	    {
	       obj_t aux1420_933;
	       {
		  obj_t aux_3465;
		  aux_3465 = CNST_TABLE_REF(((long) 9));
		  aux1420_933 = make_struct(aux_3465, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_3468;
		  {
		     long aux_3469;
		     {
			obj_t aux_3470;
			{
			   object_t aux_3471;
			   aux_3471 = (object_t) (obj1418_929);
			   aux_3470 = OBJECT_WIDENING(aux_3471);
			}
			aux_3469 = (((sized_let_var_54_t) CREF(aux_3470))->size);
		     }
		     aux_3468 = BINT(aux_3469);
		  }
		  STRUCT_SET(aux1420_933, ((long) 0), aux_3468);
	       }
	       STRUCT_SET(res1419_932, ((long) 0), aux1420_933);
	       {
		  obj_t aux_3478;
		  aux_3478 = STRUCT_KEY(res1419_932);
		  STRUCT_KEY_SET(aux1420_933, aux_3478);
	       }
	       {
		  obj_t aux_3481;
		  aux_3481 = CNST_TABLE_REF(((long) 9));
		  STRUCT_KEY_SET(res1419_932, aux_3481);
	       }
	       return res1419_932;
	    }
	 }
      }
   }
}


let_var_6_t 
allocate_sized_let_var_152_inline_size()
{
   {
      let_var_6_t new1417_1154;
      new1417_1154 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
      {
	 long arg1681_1155;
	 arg1681_1155 = class_num_218___object(sized_let_var_54_inline_size);
	 {
	    obj_t obj_2211;
	    obj_2211 = (obj_t) (new1417_1154);
	    (((obj_t) CREF(obj_2211))->header = MAKE_HEADER(arg1681_1155, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3489;
	 aux_3489 = (object_t) (new1417_1154);
	 OBJECT_WIDENING_SET(aux_3489, BFALSE);
      }
      return new1417_1154;
   }
}


obj_t 
_allocate_sized_let_var_200_inline_size(obj_t env_2411)
{
   {
      let_var_6_t aux_3492;
      aux_3492 = allocate_sized_let_var_152_inline_size();
      return (obj_t) (aux_3492);
   }
}


let_fun_218_t 
allocate_sized_let_fun_17_inline_size()
{
   {
      let_fun_218_t new1400_1162;
      new1400_1162 = ((let_fun_218_t) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
      {
	 long arg1686_1163;
	 arg1686_1163 = class_num_218___object(sized_let_fun_188_inline_size);
	 {
	    obj_t obj_2215;
	    obj_2215 = (obj_t) (new1400_1162);
	    (((obj_t) CREF(obj_2215))->header = MAKE_HEADER(arg1686_1163, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3499;
	 aux_3499 = (object_t) (new1400_1162);
	 OBJECT_WIDENING_SET(aux_3499, BFALSE);
      }
      return new1400_1162;
   }
}


obj_t 
_allocate_sized_let_fun_213_inline_size(obj_t env_2410)
{
   {
      let_fun_218_t aux_3502;
      aux_3502 = allocate_sized_let_fun_17_inline_size();
      return (obj_t) (aux_3502);
   }
}


select_t 
allocate_sized_select_168_inline_size()
{
   {
      select_t new1384_1170;
      new1384_1170 = ((select_t) BREF(GC_MALLOC(sizeof(struct select))));
      {
	 long arg1689_1171;
	 arg1689_1171 = class_num_218___object(sized_select_166_inline_size);
	 {
	    obj_t obj_2219;
	    obj_2219 = (obj_t) (new1384_1170);
	    (((obj_t) CREF(obj_2219))->header = MAKE_HEADER(arg1689_1171, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3509;
	 aux_3509 = (object_t) (new1384_1170);
	 OBJECT_WIDENING_SET(aux_3509, BFALSE);
      }
      return new1384_1170;
   }
}


obj_t 
_allocate_sized_select_175_inline_size(obj_t env_2409)
{
   {
      select_t aux_3512;
      aux_3512 = allocate_sized_select_168_inline_size();
      return (obj_t) (aux_3512);
   }
}


fail_t 
allocate_sized_fail_135_inline_size()
{
   {
      fail_t new1367_1178;
      new1367_1178 = ((fail_t) BREF(GC_MALLOC(sizeof(struct fail))));
      {
	 long arg1693_1179;
	 arg1693_1179 = class_num_218___object(sized_fail_63_inline_size);
	 {
	    obj_t obj_2223;
	    obj_2223 = (obj_t) (new1367_1178);
	    (((obj_t) CREF(obj_2223))->header = MAKE_HEADER(arg1693_1179, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3519;
	 aux_3519 = (object_t) (new1367_1178);
	 OBJECT_WIDENING_SET(aux_3519, BFALSE);
      }
      return new1367_1178;
   }
}


obj_t 
_allocate_sized_fail_239_inline_size(obj_t env_2408)
{
   {
      fail_t aux_3522;
      aux_3522 = allocate_sized_fail_135_inline_size();
      return (obj_t) (aux_3522);
   }
}


conditional_t 
allocate_sized_conditional_44_inline_size()
{
   {
      conditional_t new1351_1186;
      new1351_1186 = ((conditional_t) BREF(GC_MALLOC(sizeof(struct conditional))));
      {
	 long arg1696_1187;
	 arg1696_1187 = class_num_218___object(sized_conditional_152_inline_size);
	 {
	    obj_t obj_2227;
	    obj_2227 = (obj_t) (new1351_1186);
	    (((obj_t) CREF(obj_2227))->header = MAKE_HEADER(arg1696_1187, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3529;
	 aux_3529 = (object_t) (new1351_1186);
	 OBJECT_WIDENING_SET(aux_3529, BFALSE);
      }
      return new1351_1186;
   }
}


obj_t 
_allocate_sized_conditional_74_inline_size(obj_t env_2407)
{
   {
      conditional_t aux_3532;
      aux_3532 = allocate_sized_conditional_44_inline_size();
      return (obj_t) (aux_3532);
   }
}


pragma_t 
allocate_sized_pragma_254_inline_size()
{
   {
      pragma_t new1334_1194;
      new1334_1194 = ((pragma_t) BREF(GC_MALLOC(sizeof(struct pragma))));
      {
	 long arg1699_1195;
	 arg1699_1195 = class_num_218___object(sized_pragma_213_inline_size);
	 {
	    obj_t obj_2231;
	    obj_2231 = (obj_t) (new1334_1194);
	    (((obj_t) CREF(obj_2231))->header = MAKE_HEADER(arg1699_1195, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3539;
	 aux_3539 = (object_t) (new1334_1194);
	 OBJECT_WIDENING_SET(aux_3539, BFALSE);
      }
      return new1334_1194;
   }
}


obj_t 
_allocate_sized_pragma_184_inline_size(obj_t env_2406)
{
   {
      pragma_t aux_3542;
      aux_3542 = allocate_sized_pragma_254_inline_size();
      return (obj_t) (aux_3542);
   }
}


funcall_t 
allocate_sized_funcall_74_inline_size()
{
   {
      funcall_t new1319_1202;
      new1319_1202 = ((funcall_t) BREF(GC_MALLOC(sizeof(struct funcall))));
      {
	 long arg1703_1203;
	 arg1703_1203 = class_num_218___object(sized_funcall_46_inline_size);
	 {
	    obj_t obj_2235;
	    obj_2235 = (obj_t) (new1319_1202);
	    (((obj_t) CREF(obj_2235))->header = MAKE_HEADER(arg1703_1203, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3549;
	 aux_3549 = (object_t) (new1319_1202);
	 OBJECT_WIDENING_SET(aux_3549, BFALSE);
      }
      return new1319_1202;
   }
}


obj_t 
_allocate_sized_funcall_28_inline_size(obj_t env_2405)
{
   {
      funcall_t aux_3552;
      aux_3552 = allocate_sized_funcall_74_inline_size();
      return (obj_t) (aux_3552);
   }
}


app_t 
allocate_sized_app_161_inline_size()
{
   {
      app_t new1303_1210;
      new1303_1210 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg1706_1211;
	 arg1706_1211 = class_num_218___object(sized_app_52_inline_size);
	 {
	    obj_t obj_2239;
	    obj_2239 = (obj_t) (new1303_1210);
	    (((obj_t) CREF(obj_2239))->header = MAKE_HEADER(arg1706_1211, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3559;
	 aux_3559 = (object_t) (new1303_1210);
	 OBJECT_WIDENING_SET(aux_3559, BFALSE);
      }
      return new1303_1210;
   }
}


obj_t 
_allocate_sized_app_5_inline_size(obj_t env_2404)
{
   {
      app_t aux_3562;
      aux_3562 = allocate_sized_app_161_inline_size();
      return (obj_t) (aux_3562);
   }
}


sequence_t 
allocate_sized_sequence_56_inline_size()
{
   {
      sequence_t new1286_1218;
      new1286_1218 = ((sequence_t) BREF(GC_MALLOC(sizeof(struct sequence))));
      {
	 long arg1709_1219;
	 arg1709_1219 = class_num_218___object(sized_sequence_48_inline_size);
	 {
	    obj_t obj_2243;
	    obj_2243 = (obj_t) (new1286_1218);
	    (((obj_t) CREF(obj_2243))->header = MAKE_HEADER(arg1709_1219, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_3569;
	 aux_3569 = (object_t) (new1286_1218);
	 OBJECT_WIDENING_SET(aux_3569, BFALSE);
      }
      return new1286_1218;
   }
}


obj_t 
_allocate_sized_sequence_167_inline_size(obj_t env_2403)
{
   {
      sequence_t aux_3572;
      aux_3572 = allocate_sized_sequence_56_inline_size();
      return (obj_t) (aux_3572);
   }
}


obj_t 
imported_modules_init_94_inline_size()
{
   module_initialization_70_type_type(((long) 0), "INLINE_SIZE");
   module_initialization_70_ast_var(((long) 0), "INLINE_SIZE");
   return module_initialization_70_ast_node(((long) 0), "INLINE_SIZE");
}
