/*===========================================================================*/
/*   (Inline/variant.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct local_variant_63
  {
     bool_t variant;
  }
                *local_variant_63_t;


extern obj_t substitutions_inline_variant(variable_t, obj_t, obj_t);
extern obj_t _shrink_args__107_inline_variant(obj_t, obj_t);
extern obj_t _substitutions_inline_variant(obj_t, obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t _struct_object__object_6___object(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_inline_variant();
extern obj_t module_initialization_70_inline_variant(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t shrink_args__237_inline_variant(variable_t);
static obj_t cnst_init_137_inline_variant();
extern obj_t _invariant_args_88_inline_variant(obj_t, obj_t, obj_t);
extern obj_t variant_args_126_inline_variant(variable_t);
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
obj_t local_variant_63_inline_variant = BUNSPEC;
extern app_t remove_invariant_args__113_inline_variant(app_t);
static local_t allocate_local_variant_108_inline_variant();
extern obj_t _remove_invariant_args__205_inline_variant(obj_t, obj_t);
static obj_t require_initialization_114_inline_variant = BUNSPEC;
extern obj_t invariant_args_254_inline_variant(variable_t, obj_t);
extern obj_t var_ast_node;
static obj_t library_modules_init_112_inline_variant();
extern obj_t read___reader(obj_t);
extern obj_t _variant_args_237_inline_variant(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t _allocate_local_variant_45_inline_variant(obj_t);
extern obj_t class_super_145___object(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t object__struct_50___object(object_t);
static obj_t struct_object__object_local_variant1573_238_inline_variant(obj_t, obj_t, obj_t);
static obj_t object__struct_local_variant1574_217_inline_variant(obj_t, obj_t);
static obj_t object_init_111_inline_variant();
extern obj_t local_ast_var;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t _object__struct_74___object(obj_t, obj_t);
extern object_t struct_object__object_93___object(object_t, obj_t);
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t);
static obj_t __cnst[3];

DEFINE_EXPORT_PROCEDURE(remove_invariant_args__env_39_inline_variant, _remove_invariant_args__205_inline_variant1584, _remove_invariant_args__205_inline_variant, 0L, 1);
DEFINE_EXPORT_PROCEDURE(variant_args_env_178_inline_variant, _variant_args_237_inline_variant1585, _variant_args_237_inline_variant, 0L, 1);
DEFINE_STRING(string1577_inline_variant, string1577_inline_variant1586, "LOCAL/VARIANT DONE READ ", 24);
extern obj_t struct_object__object_env_209___object;
DEFINE_STATIC_PROCEDURE(proc1576_inline_variant, struct_object__object_local_variant1573_238_inline_variant1587, struct_object__object_local_variant1573_238_inline_variant, 0L, 2);
DEFINE_EXPORT_PROCEDURE(substitutions_env_195_inline_variant, _substitutions_inline_variant1588, _substitutions_inline_variant, 0L, 3);
DEFINE_STATIC_PROCEDURE(proc1575_inline_variant, object__struct_local_variant1574_217_inline_variant1589, object__struct_local_variant1574_217_inline_variant, 0L, 1);
extern obj_t object__struct_env_210___object;
DEFINE_EXPORT_PROCEDURE(invariant_args_env_85_inline_variant, _invariant_args_88_inline_variant1590, _invariant_args_88_inline_variant, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_local_variant_env_26_inline_variant, _allocate_local_variant_45_inline_variant1591, _allocate_local_variant_45_inline_variant, 0L, 0);
DEFINE_EXPORT_PROCEDURE(shrink_args__env_30_inline_variant, _shrink_args__107_inline_variant1592, _shrink_args__107_inline_variant, 0L, 1);

obj_t 
module_initialization_70_inline_variant(long checksum_1355, char *from_1356)
{
   if (CBOOL(require_initialization_114_inline_variant))
     {
	require_initialization_114_inline_variant = BBOOL(((bool_t) 0));
	library_modules_init_112_inline_variant();
	cnst_init_137_inline_variant();
	object_init_111_inline_variant();
	imported_modules_init_94_inline_variant();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_inline_variant()
{
   module_initialization_70___object(((long) 0), "INLINE_VARIANT");
   module_initialization_70___reader(((long) 0), "INLINE_VARIANT");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_VARIANT");
   return BUNSPEC;
}


obj_t 
cnst_init_137_inline_variant()
{
   {
      obj_t cnst_port_138_1347;
      cnst_port_138_1347 = open_input_string(string1577_inline_variant);
      {
	 long i_1348;
	 i_1348 = ((long) 2);
       loop_1349:
	 {
	    bool_t test1578_1350;
	    test1578_1350 = (i_1348 == ((long) -1));
	    if (test1578_1350)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1579_1351;
		    {
		       obj_t list1580_1352;
		       {
			  obj_t arg1582_1353;
			  arg1582_1353 = BNIL;
			  list1580_1352 = MAKE_PAIR(cnst_port_138_1347, arg1582_1353);
		       }
		       arg1579_1351 = read___reader(list1580_1352);
		    }
		    CNST_TABLE_SET(i_1348, arg1579_1351);
		 }
		 {
		    int aux_1354;
		    {
		       long aux_1373;
		       aux_1373 = (i_1348 - ((long) 1));
		       aux_1354 = (int) (aux_1373);
		    }
		    {
		       long i_1376;
		       i_1376 = (long) (aux_1354);
		       i_1348 = i_1376;
		       goto loop_1349;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
invariant_args_254_inline_variant(variable_t var_1, obj_t calls_2)
{
   {
      obj_t args_680;
      {
	 sfun_t obj_1151;
	 {
	    value_t aux_1378;
	    aux_1378 = (((variable_t) CREF(var_1))->value);
	    obj_1151 = (sfun_t) (aux_1378);
	 }
	 args_680 = (((sfun_t) CREF(obj_1151))->args);
      }
      {
	 {
	    obj_t l1293_681;
	    l1293_681 = args_680;
	  lname1294_682:
	    if (PAIRP(l1293_681))
	      {
		 {
		    obj_t local_684;
		    local_684 = CAR(l1293_681);
		    {
		       bool_t test_1385;
		       {
			  obj_t aux_1389;
			  obj_t aux_1386;
			  aux_1389 = CNST_TABLE_REF(((long) 0));
			  {
			     local_t obj_1154;
			     obj_1154 = (local_t) (local_684);
			     aux_1386 = (((local_t) CREF(obj_1154))->access);
			  }
			  test_1385 = (aux_1386 == aux_1389);
		       }
		       if (test_1385)
			 {
			    local_variant_63_t obj1295_686;
			    obj1295_686 = ((local_variant_63_t) (local_684));
			    {
			       local_variant_63_t arg1311_687;
			       {
				  local_variant_63_t res1563_1160;
				  {
				     local_variant_63_t new1273_1158;
				     new1273_1158 = ((local_variant_63_t) BREF(GC_MALLOC(sizeof(struct local_variant_63))));
				     ((((local_variant_63_t) CREF(new1273_1158))->variant) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				     res1563_1160 = new1273_1158;
				  }
				  arg1311_687 = res1563_1160;
			       }
			       {
				  obj_t aux_1397;
				  object_t aux_1395;
				  aux_1397 = (obj_t) (arg1311_687);
				  aux_1395 = (object_t) (obj1295_686);
				  OBJECT_WIDENING_SET(aux_1395, aux_1397);
			       }
			    }
			    {
			       long arg1312_688;
			       arg1312_688 = class_num_218___object(local_variant_63_inline_variant);
			       {
				  obj_t obj_1161;
				  obj_1161 = (obj_t) (obj1295_686);
				  (((obj_t) CREF(obj_1161))->header = MAKE_HEADER(arg1312_688, 0), BUNSPEC);
			       }
			    }
			    obj1295_686;
			 }
		       else
			 {
			    local_variant_63_t obj1296_689;
			    obj1296_689 = ((local_variant_63_t) (local_684));
			    {
			       local_variant_63_t arg1313_690;
			       {
				  local_variant_63_t res1564_1166;
				  {
				     local_variant_63_t new1273_1164;
				     new1273_1164 = ((local_variant_63_t) BREF(GC_MALLOC(sizeof(struct local_variant_63))));
				     ((((local_variant_63_t) CREF(new1273_1164))->variant) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				     res1564_1166 = new1273_1164;
				  }
				  arg1313_690 = res1564_1166;
			       }
			       {
				  obj_t aux_1408;
				  object_t aux_1406;
				  aux_1408 = (obj_t) (arg1313_690);
				  aux_1406 = (object_t) (obj1296_689);
				  OBJECT_WIDENING_SET(aux_1406, aux_1408);
			       }
			    }
			    {
			       long arg1314_691;
			       arg1314_691 = class_num_218___object(local_variant_63_inline_variant);
			       {
				  obj_t obj_1167;
				  obj_1167 = (obj_t) (obj1296_689);
				  (((obj_t) CREF(obj_1167))->header = MAKE_HEADER(arg1314_691, 0), BUNSPEC);
			       }
			    }
			    obj1296_689;
			 }
		    }
		 }
		 {
		    obj_t l1293_1414;
		    l1293_1414 = CDR(l1293_681);
		    l1293_681 = l1293_1414;
		    goto lname1294_682;
		 }
	      }
	    else
	      {
		 ((bool_t) 1);
	      }
	 }
	 {
	    obj_t l1297_695;
	    l1297_695 = calls_2;
	  lname1298_696:
	    if (PAIRP(l1297_695))
	      {
		 {
		    app_t app_698;
		    {
		       obj_t aux_1418;
		       aux_1418 = CAR(l1297_695);
		       app_698 = (app_t) (aux_1418);
		    }
		    {
		       obj_t actuals_699;
		       obj_t args_700;
		       actuals_699 = (((app_t) CREF(app_698))->args);
		       args_700 = args_680;
		     loop_701:
		       if (NULLP(args_700))
			 {
			    CNST_TABLE_REF(((long) 1));
			 }
		       else
			 {
			    if (NULLP(actuals_699))
			      {
				 {
				    obj_t l1299_705;
				    {
				       bool_t aux_1426;
				       l1299_705 = args_700;
				     lname1301_706:
				       if (PAIRP(l1299_705))
					 {
					    {
					       obj_t res1565_1179;
					       {
						  local_variant_63_t obj_1177;
						  {
						     obj_t aux_1429;
						     aux_1429 = CAR(l1299_705);
						     obj_1177 = (local_variant_63_t) (aux_1429);
						  }
						  {
						     obj_t x_1344;
						     {
							obj_t aux_1432;
							{
							   object_t aux_1433;
							   aux_1433 = (object_t) (obj_1177);
							   aux_1432 = OBJECT_WIDENING(aux_1433);
							}
							x_1344 = ((((local_variant_63_t) CREF(aux_1432))->variant) = ((bool_t) ((bool_t) 1)), BUNSPEC);
						     }
						     res1565_1179 = BUNSPEC;
						  }
					       }
					       res1565_1179;
					    }
					    {
					       obj_t l1299_1437;
					       l1299_1437 = CDR(l1299_705);
					       l1299_705 = l1299_1437;
					       goto lname1301_706;
					    }
					 }
				       else
					 {
					    aux_1426 = ((bool_t) 1);
					 }
				       BBOOL(aux_1426);
				    }
				 }
			      }
			    else
			      {
				 bool_t test1326_710;
				 {
				    bool_t test1333_716;
				    test1333_716 = is_a__118___object(CAR(actuals_699), var_ast_node);
				    if (test1333_716)
				      {
					 obj_t aux_1450;
					 obj_t aux_1443;
					 aux_1450 = CAR(args_700);
					 {
					    variable_t aux_1444;
					    {
					       var_t obj_1184;
					       {
						  obj_t aux_1445;
						  aux_1445 = CAR(actuals_699);
						  obj_1184 = (var_t) (aux_1445);
					       }
					       aux_1444 = (((var_t) CREF(obj_1184))->variable);
					    }
					    aux_1443 = (obj_t) (aux_1444);
					 }
					 test1326_710 = (aux_1443 == aux_1450);
				      }
				    else
				      {
					 test1326_710 = ((bool_t) 0);
				      }
				 }
				 if (test1326_710)
				   {
				      {
					 obj_t args_1456;
					 obj_t actuals_1454;
					 actuals_1454 = CDR(actuals_699);
					 args_1456 = CDR(args_700);
					 args_700 = args_1456;
					 actuals_699 = actuals_1454;
					 goto loop_701;
				      }
				   }
				 else
				   {
				      {
					 obj_t res1566_1193;
					 {
					    local_variant_63_t obj_1191;
					    {
					       obj_t aux_1458;
					       aux_1458 = CAR(args_700);
					       obj_1191 = (local_variant_63_t) (aux_1458);
					    }
					    {
					       obj_t x_1345;
					       {
						  obj_t aux_1461;
						  {
						     object_t aux_1462;
						     aux_1462 = (object_t) (obj_1191);
						     aux_1461 = OBJECT_WIDENING(aux_1462);
						  }
						  x_1345 = ((((local_variant_63_t) CREF(aux_1461))->variant) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					       }
					       res1566_1193 = BUNSPEC;
					    }
					 }
					 res1566_1193;
				      }
				      {
					 obj_t args_1468;
					 obj_t actuals_1466;
					 actuals_1466 = CDR(actuals_699);
					 args_1468 = CDR(args_700);
					 args_700 = args_1468;
					 actuals_699 = actuals_1466;
					 goto loop_701;
				      }
				   }
			      }
			 }
		    }
		 }
		 {
		    obj_t l1297_1471;
		    l1297_1471 = CDR(l1297_695);
		    l1297_695 = l1297_1471;
		    goto lname1298_696;
		 }
	      }
	    else
	      {
		 ((bool_t) 1);
	      }
	 }
	 {
	    obj_t args_722;
	    obj_t invariant_723;
	    args_722 = args_680;
	    invariant_723 = BNIL;
	  loop_724:
	    if (NULLP(args_722))
	      {
		 return reverse__39___r4_pairs_and_lists_6_3(invariant_723);
	      }
	    else
	      {
		 obj_t arg1345_727;
		 obj_t arg1346_728;
		 arg1345_727 = CDR(args_722);
		 {
		    bool_t test_1477;
		    {
		       local_variant_63_t obj_1200;
		       {
			  obj_t aux_1478;
			  aux_1478 = CAR(args_722);
			  obj_1200 = (local_variant_63_t) (aux_1478);
		       }
		       {
			  obj_t aux_1481;
			  {
			     object_t aux_1482;
			     aux_1482 = (object_t) (obj_1200);
			     aux_1481 = OBJECT_WIDENING(aux_1482);
			  }
			  test_1477 = (((local_variant_63_t) CREF(aux_1481))->variant);
		       }
		    }
		    if (test_1477)
		      {
			 arg1346_728 = invariant_723;
		      }
		    else
		      {
			 obj_t aux_1486;
			 aux_1486 = CAR(args_722);
			 arg1346_728 = MAKE_PAIR(aux_1486, invariant_723);
		      }
		 }
		 {
		    obj_t invariant_1490;
		    obj_t args_1489;
		    args_1489 = arg1345_727;
		    invariant_1490 = arg1346_728;
		    invariant_723 = invariant_1490;
		    args_722 = args_1489;
		    goto loop_724;
		 }
	      }
	 }
      }
   }
}


obj_t 
_invariant_args_88_inline_variant(obj_t env_1318, obj_t var_1319, obj_t calls_1320)
{
   return invariant_args_254_inline_variant((variable_t) (var_1319), calls_1320);
}


obj_t 
variant_args_126_inline_variant(variable_t var_3)
{
   {
      {
	 obj_t args_734;
	 obj_t variant_735;
	 {
	    sfun_t obj_1205;
	    {
	       value_t aux_1511;
	       aux_1511 = (((variable_t) CREF(var_3))->value);
	       obj_1205 = (sfun_t) (aux_1511);
	    }
	    args_734 = (((sfun_t) CREF(obj_1205))->args);
	 }
	 variant_735 = BNIL;
       loop_736:
	 if (NULLP(args_734))
	   {
	      return reverse__39___r4_pairs_and_lists_6_3(variant_735);
	   }
	 else
	   {
	      obj_t arg1355_739;
	      obj_t arg1356_740;
	      arg1355_739 = CDR(args_734);
	      {
		 bool_t test_1497;
		 {
		    local_variant_63_t obj_1209;
		    {
		       obj_t aux_1498;
		       aux_1498 = CAR(args_734);
		       obj_1209 = (local_variant_63_t) (aux_1498);
		    }
		    {
		       obj_t aux_1501;
		       {
			  object_t aux_1502;
			  aux_1502 = (object_t) (obj_1209);
			  aux_1501 = OBJECT_WIDENING(aux_1502);
		       }
		       test_1497 = (((local_variant_63_t) CREF(aux_1501))->variant);
		    }
		 }
		 if (test_1497)
		   {
		      obj_t aux_1506;
		      aux_1506 = CAR(args_734);
		      arg1356_740 = MAKE_PAIR(aux_1506, variant_735);
		   }
		 else
		   {
		      arg1356_740 = variant_735;
		   }
	      }
	      {
		 obj_t variant_1510;
		 obj_t args_1509;
		 args_1509 = arg1355_739;
		 variant_1510 = arg1356_740;
		 variant_735 = variant_1510;
		 args_734 = args_1509;
		 goto loop_736;
	      }
	   }
      }
   }
}


obj_t 
_variant_args_237_inline_variant(obj_t env_1321, obj_t var_1322)
{
   return variant_args_126_inline_variant((variable_t) (var_1322));
}


obj_t 
substitutions_inline_variant(variable_t var_4, obj_t actuals_5, obj_t var_args_195_6)
{
   {
      {
	 obj_t actuals_746;
	 obj_t all_args_251_747;
	 obj_t var_args_195_748;
	 obj_t substitutions_749;
	 actuals_746 = actuals_5;
	 {
	    sfun_t obj_1214;
	    {
	       value_t aux_1555;
	       aux_1555 = (((variable_t) CREF(var_4))->value);
	       obj_1214 = (sfun_t) (aux_1555);
	    }
	    all_args_251_747 = (((sfun_t) CREF(obj_1214))->args);
	 }
	 var_args_195_748 = var_args_195_6;
	 substitutions_749 = BNIL;
       loop_750:
	 if (NULLP(all_args_251_747))
	   {
	      return reverse__39___r4_pairs_and_lists_6_3(substitutions_749);
	   }
	 else
	   {
	      bool_t test_1520;
	      {
		 local_variant_63_t obj_1217;
		 {
		    obj_t aux_1521;
		    aux_1521 = CAR(all_args_251_747);
		    obj_1217 = (local_variant_63_t) (aux_1521);
		 }
		 {
		    obj_t aux_1524;
		    {
		       object_t aux_1525;
		       aux_1525 = (object_t) (obj_1217);
		       aux_1524 = OBJECT_WIDENING(aux_1525);
		    }
		    test_1520 = (((local_variant_63_t) CREF(aux_1524))->variant);
		 }
	      }
	      if (test_1520)
		{
		   {
		      obj_t arg1364_754;
		      obj_t arg1366_755;
		      obj_t arg1367_756;
		      obj_t arg1369_757;
		      arg1364_754 = CDR(actuals_746);
		      arg1366_755 = CDR(all_args_251_747);
		      arg1367_756 = CDR(var_args_195_748);
		      {
			 obj_t aux_1532;
			 aux_1532 = CAR(var_args_195_748);
			 arg1369_757 = MAKE_PAIR(aux_1532, substitutions_749);
		      }
		      {
			 obj_t substitutions_1538;
			 obj_t var_args_195_1537;
			 obj_t all_args_251_1536;
			 obj_t actuals_1535;
			 actuals_1535 = arg1364_754;
			 all_args_251_1536 = arg1366_755;
			 var_args_195_1537 = arg1367_756;
			 substitutions_1538 = arg1369_757;
			 substitutions_749 = substitutions_1538;
			 var_args_195_748 = var_args_195_1537;
			 all_args_251_747 = all_args_251_1536;
			 actuals_746 = actuals_1535;
			 goto loop_750;
		      }
		   }
		}
	      else
		{
		   {
		      obj_t arg1372_759;
		      obj_t arg1376_760;
		      obj_t arg1379_761;
		      arg1372_759 = CDR(actuals_746);
		      arg1376_760 = CDR(all_args_251_747);
		      {
			 obj_t arg1380_762;
			 {
			    bool_t test1381_763;
			    test1381_763 = is_a__118___object(CAR(actuals_746), var_ast_node);
			    if (test1381_763)
			      {
				 var_t obj_1229;
				 {
				    obj_t aux_1544;
				    aux_1544 = CAR(actuals_746);
				    obj_1229 = (var_t) (aux_1544);
				 }
				 {
				    variable_t aux_1547;
				    aux_1547 = (((var_t) CREF(obj_1229))->variable);
				    arg1380_762 = (obj_t) (aux_1547);
				 }
			      }
			    else
			      {
				 arg1380_762 = CAR(actuals_746);
			      }
			 }
			 arg1379_761 = MAKE_PAIR(arg1380_762, substitutions_749);
		      }
		      {
			 obj_t substitutions_1554;
			 obj_t all_args_251_1553;
			 obj_t actuals_1552;
			 actuals_1552 = arg1372_759;
			 all_args_251_1553 = arg1376_760;
			 substitutions_1554 = arg1379_761;
			 substitutions_749 = substitutions_1554;
			 all_args_251_747 = all_args_251_1553;
			 actuals_746 = actuals_1552;
			 goto loop_750;
		      }
		   }
		}
	   }
      }
   }
}


obj_t 
_substitutions_inline_variant(obj_t env_1323, obj_t var_1324, obj_t actuals_1325, obj_t var_args_195_1326)
{
   return substitutions_inline_variant((variable_t) (var_1324), actuals_1325, var_args_195_1326);
}


obj_t 
shrink_args__237_inline_variant(variable_t var_7)
{
   {
      {
	 obj_t l1302_769;
	 {
	    bool_t aux_1561;
	    {
	       sfun_t obj_1234;
	       {
		  value_t aux_1585;
		  aux_1585 = (((variable_t) CREF(var_7))->value);
		  obj_1234 = (sfun_t) (aux_1585);
	       }
	       l1302_769 = (((sfun_t) CREF(obj_1234))->args);
	    }
	  lname1304_770:
	    if (PAIRP(l1302_769))
	      {
		 {
		    obj_t a_772;
		    a_772 = CAR(l1302_769);
		    {
		       bool_t test_1565;
		       {
			  bool_t test_1566;
			  {
			     obj_t aux_1567;
			     {
				object_t aux_1568;
				aux_1568 = (object_t) (a_772);
				aux_1567 = OBJECT_WIDENING(aux_1568);
			     }
			     test_1566 = CBOOL(aux_1567);
			  }
			  if (test_1566)
			    {
			       test_1565 = ((bool_t) 1);
			    }
			  else
			    {
			       test_1565 = ((bool_t) 0);
			    }
		       }
		       if (test_1565)
			 {
			    {
			       long arg1391_775;
			       {
				  obj_t arg1396_776;
				  {
				     obj_t arg1398_777;
				     {
					object_t object_1240;
					object_1240 = (object_t) (a_772);
					{
					   long arg1187_1241;
					   {
					      long arg1188_1242;
					      long arg1189_1243;
					      arg1188_1242 = TYPE(object_1240);
					      arg1189_1243 = OBJECT_TYPE;
					      arg1187_1241 = (arg1188_1242 - arg1189_1243);
					   }
					   {
					      obj_t vector_1247;
					      vector_1247 = __classes__134___object;
					      arg1398_777 = VECTOR_REF(vector_1247, arg1187_1241);
					   }
					}
				     }
				     arg1396_776 = class_super_145___object(arg1398_777);
				  }
				  arg1391_775 = class_num_218___object(arg1396_776);
			       }
			       (((obj_t) CREF(a_772))->header = MAKE_HEADER(arg1391_775, 0), BUNSPEC);
			    }
			    {
			       object_t aux_1580;
			       aux_1580 = (object_t) (a_772);
			       OBJECT_WIDENING_SET(aux_1580, BFALSE);
			    }
			    a_772;
			 }
		       else
			 {
			    BUNSPEC;
			 }
		    }
		 }
		 {
		    obj_t l1302_1583;
		    l1302_1583 = CDR(l1302_769);
		    l1302_769 = l1302_1583;
		    goto lname1304_770;
		 }
	      }
	    else
	      {
		 aux_1561 = ((bool_t) 1);
	      }
	    return BBOOL(aux_1561);
	 }
      }
   }
}


obj_t 
_shrink_args__107_inline_variant(obj_t env_1327, obj_t var_1328)
{
   return shrink_args__237_inline_variant((variable_t) (var_1328));
}


app_t 
remove_invariant_args__113_inline_variant(app_t app_8)
{
   {
      obj_t formals_780;
      obj_t old_args_130_781;
      obj_t new_args_235_782;
      {
	 sfun_t obj_1255;
	 {
	    value_t aux_1621;
	    {
	       variable_t arg1408_788;
	       {
		  var_t arg1410_789;
		  arg1410_789 = (((app_t) CREF(app_8))->fun);
		  arg1408_788 = (((var_t) CREF(arg1410_789))->variable);
	       }
	       aux_1621 = (((variable_t) CREF(arg1408_788))->value);
	    }
	    obj_1255 = (sfun_t) (aux_1621);
	 }
	 formals_780 = (((sfun_t) CREF(obj_1255))->args);
      }
      old_args_130_781 = (((app_t) CREF(app_8))->args);
      new_args_235_782 = BNIL;
    loop_783:
      if (NULLP(old_args_130_781))
	{
	   {
	      obj_t arg1412_791;
	      arg1412_791 = reverse__39___r4_pairs_and_lists_6_3(new_args_235_782);
	      {
		 obj_t res1568_1260;
		 {
		    obj_t x_1346;
		    x_1346 = ((((app_t) CREF(app_8))->args) = ((obj_t) arg1412_791), BUNSPEC);
		    res1568_1260 = BUNSPEC;
		 }
		 res1568_1260;
	      }
	   }
	   return app_8;
	}
      else
	{
	   bool_t test1413_792;
	   {
	      bool_t test1421_799;
	      test1421_799 = is_a__118___object(CAR(formals_780), local_variant_63_inline_variant);
	      if (test1421_799)
		{
		   bool_t test_1599;
		   {
		      local_variant_63_t obj_1264;
		      {
			 obj_t aux_1600;
			 aux_1600 = CAR(formals_780);
			 obj_1264 = (local_variant_63_t) (aux_1600);
		      }
		      {
			 obj_t aux_1603;
			 {
			    object_t aux_1604;
			    aux_1604 = (object_t) (obj_1264);
			    aux_1603 = OBJECT_WIDENING(aux_1604);
			 }
			 test_1599 = (((local_variant_63_t) CREF(aux_1603))->variant);
		      }
		   }
		   if (test_1599)
		     {
			test1413_792 = ((bool_t) 0);
		     }
		   else
		     {
			test1413_792 = ((bool_t) 1);
		     }
		}
	      else
		{
		   test1413_792 = ((bool_t) 0);
		}
	   }
	   if (test1413_792)
	     {
		{
		   obj_t old_args_130_1611;
		   obj_t formals_1609;
		   formals_1609 = CDR(formals_780);
		   old_args_130_1611 = CDR(old_args_130_781);
		   old_args_130_781 = old_args_130_1611;
		   formals_780 = formals_1609;
		   goto loop_783;
		}
	     }
	   else
	     {
		{
		   obj_t arg1416_795;
		   obj_t arg1417_796;
		   obj_t arg1418_797;
		   arg1416_795 = CDR(formals_780);
		   arg1417_796 = CDR(old_args_130_781);
		   {
		      obj_t aux_1615;
		      aux_1615 = CAR(old_args_130_781);
		      arg1418_797 = MAKE_PAIR(aux_1615, new_args_235_782);
		   }
		   {
		      obj_t new_args_235_1620;
		      obj_t old_args_130_1619;
		      obj_t formals_1618;
		      formals_1618 = arg1416_795;
		      old_args_130_1619 = arg1417_796;
		      new_args_235_1620 = arg1418_797;
		      new_args_235_782 = new_args_235_1620;
		      old_args_130_781 = old_args_130_1619;
		      formals_780 = formals_1618;
		      goto loop_783;
		   }
		}
	     }
	}
   }
}


obj_t 
_remove_invariant_args__205_inline_variant(obj_t env_1329, obj_t app_1330)
{
   {
      app_t aux_1628;
      aux_1628 = remove_invariant_args__113_inline_variant((app_t) (app_1330));
      return (obj_t) (aux_1628);
   }
}


obj_t 
object_init_111_inline_variant()
{
   {
      obj_t arg1428_804;
      arg1428_804 = local_ast_var;
      local_variant_63_inline_variant = add_class__117___object(CNST_TABLE_REF(((long) 2)), arg1428_804, allocate_local_variant_env_26_inline_variant, ((long) 21011), BUNSPEC);
   }
   {
      obj_t object__struct_local_variant_205_1335;
      object__struct_local_variant_205_1335 = proc1575_inline_variant;
      add_method__1___object(object__struct_env_210___object, local_variant_63_inline_variant, object__struct_local_variant_205_1335);
   }
   {
      obj_t struct_object__object_local_variant_223_1331;
      struct_object__object_local_variant_223_1331 = proc1576_inline_variant;
      return add_method__1___object(struct_object__object_env_209___object, local_variant_63_inline_variant, struct_object__object_local_variant_223_1331);
   }
}


obj_t 
struct_object__object_local_variant1573_238_inline_variant(obj_t env_1338, obj_t o_1339, obj_t s_1340)
{
   {
      local_variant_63_t o_820;
      obj_t s_821;
      {
	 local_variant_63_t aux_1636;
	 o_820 = (local_variant_63_t) (o_1339);
	 s_821 = s_1340;
	 {
	    {
	       obj_t old1290_824;
	       obj_t aux1291_825;
	       {
		  obj_t next_method1308_118_830;
		  next_method1308_118_830 = find_super_class_method_167___object((object_t) (o_820), struct_object__object_env_209___object, local_variant_63_inline_variant);
		  if (PROCEDUREP(next_method1308_118_830))
		    {
		       old1290_824 = PROCEDURE_ENTRY(next_method1308_118_830) (next_method1308_118_830, (obj_t) (o_820), s_821, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1308_118_830);
		       {
			  object_t aux_1645;
			  aux_1645 = struct_object__object_93___object((object_t) (o_820), s_821);
			  old1290_824 = (obj_t) (aux_1645);
		       }
		    }
	       }
	       aux1291_825 = STRUCT_REF(s_821, ((long) 0));
	       {
		  local_variant_63_t new1292_826;
		  new1292_826 = ((local_variant_63_t) (old1290_824));
		  {
		     long arg1449_827;
		     arg1449_827 = class_num_218___object(local_variant_63_inline_variant);
		     {
			obj_t obj_1291;
			obj_1291 = (obj_t) (new1292_826);
			(((obj_t) CREF(obj_1291))->header = MAKE_HEADER(arg1449_827, 0), BUNSPEC);
		     }
		  }
		  {
		     local_variant_63_t arg1450_828;
		     {
			local_variant_63_t res1569_1298;
			{
			   bool_t variant_1295;
			   {
			      obj_t aux_1654;
			      aux_1654 = STRUCT_REF(aux1291_825, ((long) 0));
			      variant_1295 = CBOOL(aux_1654);
			   }
			   {
			      local_variant_63_t new1273_1296;
			      new1273_1296 = ((local_variant_63_t) BREF(GC_MALLOC(sizeof(struct local_variant_63))));
			      ((((local_variant_63_t) CREF(new1273_1296))->variant) = ((bool_t) variant_1295), BUNSPEC);
			      res1569_1298 = new1273_1296;
			   }
			}
			arg1450_828 = res1569_1298;
		     }
		     {
			obj_t aux_1661;
			object_t aux_1659;
			aux_1661 = (obj_t) (arg1450_828);
			aux_1659 = (object_t) (new1292_826);
			OBJECT_WIDENING_SET(aux_1659, aux_1661);
		     }
		  }
		  aux_1636 = new1292_826;
	       }
	    }
	 }
	 return (obj_t) (aux_1636);
      }
   }
}


obj_t 
object__struct_local_variant1574_217_inline_variant(obj_t env_1341, obj_t obj1287_1342)
{
   {
      local_variant_63_t obj1287_807;
      obj1287_807 = (local_variant_63_t) (obj1287_1342);
      {
	 {
	    obj_t res1288_810;
	    {
	       obj_t next_method1307_97_818;
	       next_method1307_97_818 = find_super_class_method_167___object((object_t) (obj1287_807), object__struct_env_210___object, local_variant_63_inline_variant);
	       if (PROCEDUREP(next_method1307_97_818))
		 {
		    res1288_810 = PROCEDURE_ENTRY(next_method1307_97_818) (next_method1307_97_818, (obj_t) (obj1287_807), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1307_97_818);
		    res1288_810 = object__struct_50___object((object_t) (obj1287_807));
		 }
	    }
	    {
	       obj_t aux1289_811;
	       {
		  obj_t aux_1676;
		  aux_1676 = CNST_TABLE_REF(((long) 2));
		  aux1289_811 = make_struct(aux_1676, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_1679;
		  {
		     bool_t aux_1680;
		     {
			obj_t aux_1681;
			{
			   object_t aux_1682;
			   aux_1682 = (object_t) (obj1287_807);
			   aux_1681 = OBJECT_WIDENING(aux_1682);
			}
			aux_1680 = (((local_variant_63_t) CREF(aux_1681))->variant);
		     }
		     aux_1679 = BBOOL(aux_1680);
		  }
		  STRUCT_SET(aux1289_811, ((long) 0), aux_1679);
	       }
	       STRUCT_SET(res1288_810, ((long) 0), aux1289_811);
	       {
		  obj_t aux_1689;
		  aux_1689 = STRUCT_KEY(res1288_810);
		  STRUCT_KEY_SET(aux1289_811, aux_1689);
	       }
	       {
		  obj_t aux_1692;
		  aux_1692 = CNST_TABLE_REF(((long) 2));
		  STRUCT_KEY_SET(res1288_810, aux_1692);
	       }
	       return res1288_810;
	    }
	 }
      }
   }
}


local_t 
allocate_local_variant_108_inline_variant()
{
   {
      local_t new1285_832;
      new1285_832 = ((local_t) BREF(GC_MALLOC(sizeof(struct local))));
      {
	 long arg1454_833;
	 arg1454_833 = class_num_218___object(local_variant_63_inline_variant);
	 {
	    obj_t obj_1301;
	    obj_1301 = (obj_t) (new1285_832);
	    (((obj_t) CREF(obj_1301))->header = MAKE_HEADER(arg1454_833, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_1700;
	 aux_1700 = (object_t) (new1285_832);
	 OBJECT_WIDENING_SET(aux_1700, BFALSE);
      }
      return new1285_832;
   }
}


obj_t 
_allocate_local_variant_45_inline_variant(obj_t env_1343)
{
   {
      local_t aux_1703;
      aux_1703 = allocate_local_variant_108_inline_variant();
      return (obj_t) (aux_1703);
   }
}


obj_t 
imported_modules_init_94_inline_variant()
{
   module_initialization_70_tools_trace(((long) 0), "INLINE_VARIANT");
   module_initialization_70_type_type(((long) 0), "INLINE_VARIANT");
   module_initialization_70_ast_var(((long) 0), "INLINE_VARIANT");
   return module_initialization_70_ast_node(((long) 0), "INLINE_VARIANT");
}
