/*===========================================================================*/
/*   (Inline/walk.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;


extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t inline_walk__185_inline_walk(obj_t, obj_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_inline_walk();
extern obj_t module_initialization_70_inline_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t toplevel_init_63_inline_walk();
static obj_t cnst_init_137_inline_walk();
extern obj_t __optim__89_engine_param;
static obj_t reset_stat__225_inline_walk();
extern obj_t __module__166_module_module;
extern obj_t _inline_walk__25_inline_walk(obj_t, obj_t, obj_t);
static obj_t require_initialization_114_inline_walk = BUNSPEC;
static obj_t library_modules_init_112_inline_walk();
extern obj_t _inline_setup__52_inline_walk(obj_t, obj_t);
extern obj_t inline_setup__219_inline_walk(obj_t);
obj_t __non_inlined_calls__201_inline_walk = BUNSPEC;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t inline_sfun__229_inline_inline(variable_t, long, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t _reset_stat__205_inline_walk(obj_t);
extern obj_t current_error_port;
static obj_t show_stat__192_inline_walk();
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t __inlining_kfactor__130_engine_param;
obj_t __kfactor__149_inline_walk = BUNSPEC;
extern obj_t __current_pass__25_engine_pass;
static obj_t _show_stat__92_inline_walk(obj_t);
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
obj_t __inlined_calls__118_inline_walk = BUNSPEC;
extern obj_t leave_function_170_tools_error();
static obj_t __cnst[7];

DEFINE_STRING(string1513_inline_walk, string1513_inline_walk1526, " error", 6);
DEFINE_STRING(string1517_inline_walk, string1517_inline_walk1527, "      (non inlined calls : ", 27);
DEFINE_STRING(string1514_inline_walk, string1514_inline_walk1528, "failure during postlude hook", 28);
DEFINE_STRING(string1519_inline_walk, string1519_inline_walk1529, "Illegal mode", 12);
DEFINE_STRING(string1518_inline_walk, string1518_inline_walk1530, "inline-setup!", 13);
DEFINE_STRING(string1510_inline_walk, string1510_inline_walk1531, "   . ", 5);
DEFINE_STATIC_PROCEDURE(show_stat__env_142_inline_walk, _show_stat__92_inline_walk1532, _show_stat__92_inline_walk, 0L, 0);
DEFINE_STRING(string1520_inline_walk, string1520_inline_walk1533, "REDUCER ALL (SHOW-STAT!) INLINE SIFUN (RESET-STAT!) PASS-STARTED ", 65);
DEFINE_STRING(string1509_inline_walk, string1509_inline_walk1534, "Inlining", 8);
DEFINE_STRING(string1511_inline_walk, string1511_inline_walk1535, "failure during prelude hook", 27);
DEFINE_STRING(string1512_inline_walk, string1512_inline_walk1536, " occured, ending ...", 20);
DEFINE_STRING(string1516_inline_walk, string1516_inline_walk1537, "      (inlined calls     : ", 27);
DEFINE_EXPORT_PROCEDURE(inline_setup__env_11_inline_walk, _inline_setup__52_inline_walk1538, _inline_setup__52_inline_walk, 0L, 1);
DEFINE_EXPORT_PROCEDURE(inline_walk__env_203_inline_walk, _inline_walk__25_inline_walk1539, _inline_walk__25_inline_walk, 0L, 2);
DEFINE_STATIC_PROCEDURE(reset_stat__env_118_inline_walk, _reset_stat__205_inline_walk1540, _reset_stat__205_inline_walk, 0L, 0);
DEFINE_STRING(string1515_inline_walk, string1515_inline_walk1541, ")\n", 2);

obj_t 
module_initialization_70_inline_walk(long checksum_1108, char *from_1109)
{
   if (CBOOL(require_initialization_114_inline_walk))
     {
	require_initialization_114_inline_walk = BBOOL(((bool_t) 0));
	library_modules_init_112_inline_walk();
	cnst_init_137_inline_walk();
	imported_modules_init_94_inline_walk();
	toplevel_init_63_inline_walk();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_inline_walk()
{
   module_initialization_70___r4_output_6_10_3(((long) 0), "INLINE_WALK");
   module_initialization_70___reader(((long) 0), "INLINE_WALK");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_WALK");
   module_initialization_70___r4_numbers_6_5(((long) 0), "INLINE_WALK");
   return BUNSPEC;
}


obj_t 
cnst_init_137_inline_walk()
{
   {
      obj_t cnst_port_138_1100;
      cnst_port_138_1100 = open_input_string(string1520_inline_walk);
      {
	 long i_1101;
	 i_1101 = ((long) 6);
       loop_1102:
	 {
	    bool_t test1521_1103;
	    test1521_1103 = (i_1101 == ((long) -1));
	    if (test1521_1103)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1522_1104;
		    {
		       obj_t list1523_1105;
		       {
			  obj_t arg1524_1106;
			  arg1524_1106 = BNIL;
			  list1523_1105 = MAKE_PAIR(cnst_port_138_1100, arg1524_1106);
		       }
		       arg1522_1104 = read___reader(list1523_1105);
		    }
		    CNST_TABLE_SET(i_1101, arg1522_1104);
		 }
		 {
		    int aux_1107;
		    {
		       long aux_1127;
		       aux_1127 = (i_1101 - ((long) 1));
		       aux_1107 = (int) (aux_1127);
		    }
		    {
		       long i_1130;
		       i_1130 = (long) (aux_1107);
		       i_1101 = i_1130;
		       goto loop_1102;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_inline_walk()
{
   __inlined_calls__118_inline_walk = BINT(((long) 0));
   __non_inlined_calls__201_inline_walk = BINT(((long) 0));
   return (__kfactor__149_inline_walk = BINT(((long) 1)),
      BUNSPEC);
}


obj_t 
inline_walk__185_inline_walk(obj_t globals_1, obj_t what_2)
{
   {
      obj_t list1284_644;
      {
	 obj_t arg1287_646;
	 {
	    obj_t arg1293_648;
	    {
	       obj_t aux_1135;
	       aux_1135 = BCHAR(((unsigned char) '\n'));
	       arg1293_648 = MAKE_PAIR(aux_1135, BNIL);
	    }
	    arg1287_646 = MAKE_PAIR(string1509_inline_walk, arg1293_648);
	 }
	 list1284_644 = MAKE_PAIR(string1510_inline_walk, arg1287_646);
      }
      verbose_tools_speek(BINT(((long) 1)), list1284_644);
   }
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   __current_pass__25_engine_pass = string1509_inline_walk;
   {
      obj_t hooks_650;
      obj_t hnames_651;
      {
	 obj_t arg1296_653;
	 obj_t arg1297_654;
	 {
	    obj_t list1298_655;
	    list1298_655 = MAKE_PAIR(reset_stat__env_118_inline_walk, BNIL);
	    arg1296_653 = list1298_655;
	 }
	 arg1297_654 = CNST_TABLE_REF(((long) 1));
	 hooks_650 = arg1296_653;
	 hnames_651 = arg1297_654;
       loop_652:
	 if (NULLP(hooks_650))
	   {
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {
	      bool_t test1301_658;
	      {
		 obj_t fun1312_664;
		 fun1312_664 = CAR(hooks_650);
		 {
		    obj_t aux_1149;
		    aux_1149 = PROCEDURE_ENTRY(fun1312_664) (fun1312_664, BEOA);
		    test1301_658 = CBOOL(aux_1149);
		 }
	      }
	      if (test1301_658)
		{
		   {
		      obj_t hnames_1156;
		      obj_t hooks_1154;
		      hooks_1154 = CDR(hooks_650);
		      hnames_1156 = CDR(hnames_651);
		      hnames_651 = hnames_1156;
		      hooks_650 = hooks_1154;
		      goto loop_652;
		   }
		}
	      else
		{
		   internal_error_43_tools_error(string1509_inline_walk, string1511_inline_walk, CAR(hnames_651));
		}
	   }
      }
   }
   inline_setup__219_inline_walk(what_2);
   {
      obj_t l1276_665;
      l1276_665 = globals_1;
    lname1283_666:
      if (PAIRP(l1276_665))
	{
	   {
	      obj_t g_668;
	      g_668 = CAR(l1276_665);
	      {
		 obj_t kfactor_669;
		 {
		    bool_t test_1164;
		    {
		       obj_t aux_1171;
		       obj_t aux_1165;
		       aux_1171 = CNST_TABLE_REF(((long) 2));
		       {
			  sfun_t obj_1063;
			  {
			     value_t aux_1166;
			     {
				global_t obj_1062;
				obj_1062 = (global_t) (g_668);
				aux_1166 = (((global_t) CREF(obj_1062))->value);
			     }
			     obj_1063 = (sfun_t) (aux_1166);
			  }
			  aux_1165 = (((sfun_t) CREF(obj_1063))->class);
		       }
		       test_1164 = (aux_1165 == aux_1171);
		    }
		    if (test_1164)
		      {
			 kfactor_669 = BINT(((long) 1));
		      }
		    else
		      {
			 kfactor_669 = __kfactor__149_inline_walk;
		      }
		 }
		 {
		    obj_t aux_1175;
		    {
		       global_t obj_1066;
		       obj_1066 = (global_t) (g_668);
		       aux_1175 = (((global_t) CREF(obj_1066))->id);
		    }
		    enter_function_81_tools_error(aux_1175);
		 }
		 inline_sfun__229_inline_inline((variable_t) (g_668), (long) CINT(kfactor_669), BNIL);
		 leave_function_170_tools_error();
	      }
	   }
	   {
	      obj_t l1276_1183;
	      l1276_1183 = CDR(l1276_665);
	      l1276_665 = l1276_1183;
	      goto lname1283_666;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      obj_t globals_677;
      obj_t new_globals_42_678;
      globals_677 = globals_1;
      new_globals_42_678 = BNIL;
    loop_679:
      if (NULLP(globals_677))
	{
	   {
	      obj_t value_682;
	      {
		 obj_t arg1352_709;
		 obj_t arg1353_710;
		 arg1352_709 = CNST_TABLE_REF(((long) 3));
		 arg1353_710 = reverse__39___r4_pairs_and_lists_6_3(new_globals_42_678);
		 value_682 = remove_var_123_ast_remove(arg1352_709, arg1353_710);
	      }
	      {
		 bool_t test1324_683;
		 {
		    long n1_1069;
		    n1_1069 = (long) CINT(__nb_error_on_pass__70_tools_error);
		    test1324_683 = (n1_1069 > ((long) 0));
		 }
		 if (test1324_683)
		   {
		      {
			 char *arg1328_686;
			 {
			    bool_t test1335_693;
			    {
			       bool_t test1336_694;
			       {
				  obj_t obj_1071;
				  obj_1071 = __nb_error_on_pass__70_tools_error;
				  test1336_694 = INTEGERP(obj_1071);
			       }
			       if (test1336_694)
				 {
				    test1335_693 = _2__206___r4_numbers_6_5(__nb_error_on_pass__70_tools_error, BINT(((long) 1)));
				 }
			       else
				 {
				    test1335_693 = ((bool_t) 0);
				 }
			    }
			    if (test1335_693)
			      {
				 arg1328_686 = "s";
			      }
			    else
			      {
				 arg1328_686 = "";
			      }
			 }
			 {
			    obj_t list1330_688;
			    {
			       obj_t arg1331_689;
			       {
				  obj_t arg1332_690;
				  {
				     obj_t arg1333_691;
				     arg1333_691 = MAKE_PAIR(string1512_inline_walk, BNIL);
				     {
					obj_t aux_1199;
					aux_1199 = string_to_bstring(arg1328_686);
					arg1332_690 = MAKE_PAIR(aux_1199, arg1333_691);
				     }
				  }
				  arg1331_689 = MAKE_PAIR(string1513_inline_walk, arg1332_690);
			       }
			       list1330_688 = MAKE_PAIR(__nb_error_on_pass__70_tools_error, arg1331_689);
			    }
			    fprint___r4_output_6_10_3(current_error_port, list1330_688);
			 }
		      }
		      {
			 obj_t res1508_1073;
			 exit(((long) -1));
			 res1508_1073 = BINT(((long) -1));
			 return res1508_1073;
		      }
		   }
		 else
		   {
		      obj_t hooks_695;
		      obj_t hnames_696;
		      {
			 obj_t arg1337_698;
			 obj_t arg1339_699;
			 {
			    obj_t list1340_700;
			    list1340_700 = MAKE_PAIR(show_stat__env_142_inline_walk, BNIL);
			    arg1337_698 = list1340_700;
			 }
			 arg1339_699 = CNST_TABLE_REF(((long) 4));
			 hooks_695 = arg1337_698;
			 hnames_696 = arg1339_699;
		       loop_697:
			 if (NULLP(hooks_695))
			   {
			      return value_682;
			   }
			 else
			   {
			      bool_t test1344_703;
			      {
				 obj_t fun1351_708;
				 fun1351_708 = CAR(hooks_695);
				 {
				    obj_t aux_1212;
				    aux_1212 = PROCEDURE_ENTRY(fun1351_708) (fun1351_708, BEOA);
				    test1344_703 = CBOOL(aux_1212);
				 }
			      }
			      if (test1344_703)
				{
				   {
				      obj_t hnames_1219;
				      obj_t hooks_1217;
				      hooks_1217 = CDR(hooks_695);
				      hnames_1219 = CDR(hnames_696);
				      hnames_696 = hnames_1219;
				      hooks_695 = hooks_1217;
				      goto loop_697;
				   }
				}
			      else
				{
				   return internal_error_43_tools_error(__current_pass__25_engine_pass, string1514_inline_walk, CAR(hnames_696));
				}
			   }
		      }
		   }
	      }
	   }
	}
      else
	{
	   bool_t test1354_711;
	   {
	      obj_t obj2_1083;
	      obj2_1083 = __module__166_module_module;
	      {
		 obj_t aux_1223;
		 {
		    global_t obj_1081;
		    {
		       obj_t aux_1224;
		       aux_1224 = CAR(globals_677);
		       obj_1081 = (global_t) (aux_1224);
		    }
		    aux_1223 = (((global_t) CREF(obj_1081))->module);
		 }
		 test1354_711 = (aux_1223 == obj2_1083);
	      }
	   }
	   if (test1354_711)
	     {
		{
		   obj_t arg1355_712;
		   obj_t arg1356_713;
		   arg1355_712 = CDR(globals_677);
		   {
		      obj_t aux_1231;
		      aux_1231 = CAR(globals_677);
		      arg1356_713 = MAKE_PAIR(aux_1231, new_globals_42_678);
		   }
		   {
		      obj_t new_globals_42_1235;
		      obj_t globals_1234;
		      globals_1234 = arg1355_712;
		      new_globals_42_1235 = arg1356_713;
		      new_globals_42_678 = new_globals_42_1235;
		      globals_677 = globals_1234;
		      goto loop_679;
		   }
		}
	     }
	   else
	     {
		{
		   obj_t globals_1236;
		   globals_1236 = CDR(globals_677);
		   globals_677 = globals_1236;
		   goto loop_679;
		}
	     }
	}
   }
}


obj_t 
_inline_walk__25_inline_walk(obj_t env_1093, obj_t globals_1094, obj_t what_1095)
{
   return inline_walk__185_inline_walk(globals_1094, what_1095);
}


obj_t 
reset_stat__225_inline_walk()
{
   __inlined_calls__118_inline_walk = BINT(((long) 0));
   return (__non_inlined_calls__201_inline_walk = BINT(((long) 0)),
      BUNSPEC);
}


obj_t 
_reset_stat__205_inline_walk(obj_t env_1096)
{
   return reset_stat__225_inline_walk();
}


obj_t 
show_stat__192_inline_walk()
{
   {
      obj_t list1362_718;
      {
	 obj_t arg1364_720;
	 {
	    obj_t arg1366_721;
	    arg1366_721 = MAKE_PAIR(string1515_inline_walk, BNIL);
	    arg1364_720 = MAKE_PAIR(__inlined_calls__118_inline_walk, arg1366_721);
	 }
	 list1362_718 = MAKE_PAIR(string1516_inline_walk, arg1364_720);
      }
      verbose_tools_speek(BINT(((long) 2)), list1362_718);
   }
   {
      obj_t list1370_724;
      {
	 obj_t arg1376_726;
	 {
	    obj_t arg1379_727;
	    arg1379_727 = MAKE_PAIR(string1515_inline_walk, BNIL);
	    arg1376_726 = MAKE_PAIR(__non_inlined_calls__201_inline_walk, arg1379_727);
	 }
	 list1370_724 = MAKE_PAIR(string1517_inline_walk, arg1376_726);
      }
      return verbose_tools_speek(BINT(((long) 2)), list1370_724);
   }
}


obj_t 
_show_stat__92_inline_walk(obj_t env_1097)
{
   return show_stat__192_inline_walk();
}


obj_t 
inline_setup__219_inline_walk(obj_t what_3)
{
   {
      bool_t test_1253;
      {
	 obj_t aux_1254;
	 aux_1254 = CNST_TABLE_REF(((long) 5));
	 test_1253 = (what_3 == aux_1254);
      }
      if (test_1253)
	{
	   return (__kfactor__149_inline_walk = PROCEDURE_ENTRY(__inlining_kfactor__130_engine_param) (__inlining_kfactor__130_engine_param, __optim__89_engine_param, BEOA),
	      BUNSPEC);
	}
      else
	{
	   bool_t test_1259;
	   {
	      obj_t aux_1260;
	      aux_1260 = CNST_TABLE_REF(((long) 6));
	      test_1259 = (what_3 == aux_1260);
	   }
	   if (test_1259)
	     {
		return (__kfactor__149_inline_walk = BINT(((long) 1)),
		   BUNSPEC);
	     }
	   else
	     {
		return internal_error_43_tools_error(string1518_inline_walk, string1519_inline_walk, what_3);
	     }
	}
   }
}


obj_t 
_inline_setup__52_inline_walk(obj_t env_1098, obj_t what_1099)
{
   return inline_setup__219_inline_walk(what_1099);
}


obj_t 
imported_modules_init_94_inline_walk()
{
   module_initialization_70_tools_speek(((long) 0), "INLINE_WALK");
   module_initialization_70_tools_error(((long) 0), "INLINE_WALK");
   module_initialization_70_engine_pass(((long) 0), "INLINE_WALK");
   module_initialization_70_tools_trace(((long) 0), "INLINE_WALK");
   module_initialization_70_type_type(((long) 0), "INLINE_WALK");
   module_initialization_70_ast_var(((long) 0), "INLINE_WALK");
   module_initialization_70_ast_node(((long) 0), "INLINE_WALK");
   module_initialization_70_tools_shape(((long) 0), "INLINE_WALK");
   module_initialization_70_module_module(((long) 0), "INLINE_WALK");
   module_initialization_70_engine_param(((long) 0), "INLINE_WALK");
   module_initialization_70_ast_remove(((long) 0), "INLINE_WALK");
   return module_initialization_70_inline_inline(((long) 0), "INLINE_WALK");
}
