/*===========================================================================*/
/*   (Integrate/a.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_t;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_t;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_t;


obj_t __phi__105_integrate_a = BUNSPEC;
extern obj_t let_fun_218_ast_node;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
static obj_t __kont__191_integrate_a = BUNSPEC;
extern obj_t global_ast_var;
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_integrate_a();
extern obj_t module_initialization_70_integrate_a(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static bool_t initialize_fun__49_integrate_a(variable_t, variable_t);
static obj_t toplevel_init_63_integrate_a();
static obj_t _node_a_default1358_143_integrate_a(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t cnst_init_137_integrate_a();
extern obj_t a_integrate_a(global_t, node_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t require_initialization_114_integrate_a = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
extern obj_t sfun_iinfo_105_integrate_info;
static obj_t library_modules_init_112_integrate_a();
static obj_t trace_a_118_integrate_a(obj_t);
static obj_t _node_a_58_integrate_a(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t svar_iinfo_76_integrate_info;
extern obj_t cast_ast_node;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
static obj_t node_a_default1358_72_integrate_a(node_t, variable_t, obj_t, obj_t);
extern obj_t select_ast_node;
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern obj_t __trace_port__84_tools_trace;
extern long class_num_218___object(obj_t);
extern obj_t _a_integrate_a(obj_t, obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t node_a_141_integrate_a(node_t, variable_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
static obj_t get_new_kont_177_integrate_a();
extern obj_t local_ast_var;
extern obj_t kwote_ast_node;
extern obj_t sexit_iinfo_190_integrate_info;
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t app_ast_node;
static obj_t __cnst[3];

DEFINE_STRING(string1779_integrate_a, string1779_integrate_a1793, "A( ", 3);
DEFINE_STRING(string1781_integrate_a, string1781_integrate_a1794, "- - - - - - - - - - - - - - - - ", 32);
DEFINE_STRING(string1777_integrate_a, string1777_integrate_a1795, " )", 2);
DEFINE_STRING(string1782_integrate_a, string1782_integrate_a1796, "No method for this object", 25);
DEFINE_STATIC_PROCEDURE(node_a_default1358_env_13_integrate_a, _node_a_default1358_143_integrate_a1797, _node_a_default1358_143_integrate_a, 0L, 4);
DEFINE_STRING(string1783_integrate_a, string1783_integrate_a1798, "node-A", 6);
DEFINE_STRING(string1785_integrate_a, string1785_integrate_a1799, "NODE-A-DEFAULT1358 INTEGRATE TAIL ", 34);
DEFINE_EXPORT_PROCEDURE(a_env_12_integrate_a, _a_integrate_a1800, _a_integrate_a, 0L, 2);
DEFINE_STRING(string1778_integrate_a, string1778_integrate_a1801, ", ", 2);
DEFINE_STRING(string1784_integrate_a, string1784_integrate_a1802, "Unexpected closure", 18);
DEFINE_STATIC_GENERIC(node_a_env_232_integrate_a, _node_a_58_integrate_a1803, _node_a_58_integrate_a, 0L, 4);
DEFINE_STRING(string1780_integrate_a, string1780_integrate_a1804, "PHI: ", 5);

obj_t 
module_initialization_70_integrate_a(long checksum_1894, char *from_1895)
{
   if (CBOOL(require_initialization_114_integrate_a))
     {
	require_initialization_114_integrate_a = BBOOL(((bool_t) 0));
	library_modules_init_112_integrate_a();
	cnst_init_137_integrate_a();
	imported_modules_init_94_integrate_a();
	toplevel_init_63_integrate_a();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_integrate_a()
{
   module_initialization_70___object(((long) 0), "INTEGRATE_A");
   module_initialization_70___r4_output_6_10_3(((long) 0), "INTEGRATE_A");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_A");
   module_initialization_70___reader(((long) 0), "INTEGRATE_A");
   return BUNSPEC;
}


obj_t 
cnst_init_137_integrate_a()
{
   {
      obj_t cnst_port_138_1886;
      cnst_port_138_1886 = open_input_string(string1785_integrate_a);
      {
	 long i_1887;
	 i_1887 = ((long) 2);
       loop_1888:
	 {
	    bool_t test1786_1889;
	    test1786_1889 = (i_1887 == ((long) -1));
	    if (test1786_1889)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1788_1890;
		    {
		       obj_t list1789_1891;
		       {
			  obj_t arg1791_1892;
			  arg1791_1892 = BNIL;
			  list1789_1891 = MAKE_PAIR(cnst_port_138_1886, arg1791_1892);
		       }
		       arg1788_1890 = read___reader(list1789_1891);
		    }
		    CNST_TABLE_SET(i_1887, arg1788_1890);
		 }
		 {
		    int aux_1893;
		    {
		       long aux_1913;
		       aux_1913 = (i_1887 - ((long) 1));
		       aux_1893 = (int) (aux_1913);
		    }
		    {
		       long i_1916;
		       i_1916 = (long) (aux_1893);
		       i_1887 = i_1916;
		       goto loop_1888;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_integrate_a()
{
   __phi__105_integrate_a = BUNSPEC;
   __kont__191_integrate_a = BUNSPEC;
   add_generic__110___object(node_a_env_232_integrate_a, node_a_default1358_env_13_integrate_a);
   add_inlined_method__244___object(node_a_env_232_integrate_a, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(node_a_env_232_integrate_a, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(node_a_env_232_integrate_a, var_ast_node, ((long) 2));
   add_inlined_method__244___object(node_a_env_232_integrate_a, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(node_a_env_232_integrate_a, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(node_a_env_232_integrate_a, app_ast_node, ((long) 5));
   add_inlined_method__244___object(node_a_env_232_integrate_a, app_ly_162_ast_node, ((long) 6));
   add_inlined_method__244___object(node_a_env_232_integrate_a, funcall_ast_node, ((long) 7));
   add_inlined_method__244___object(node_a_env_232_integrate_a, pragma_ast_node, ((long) 8));
   add_inlined_method__244___object(node_a_env_232_integrate_a, cast_ast_node, ((long) 9));
   add_inlined_method__244___object(node_a_env_232_integrate_a, setq_ast_node, ((long) 10));
   add_inlined_method__244___object(node_a_env_232_integrate_a, conditional_ast_node, ((long) 11));
   add_inlined_method__244___object(node_a_env_232_integrate_a, fail_ast_node, ((long) 12));
   add_inlined_method__244___object(node_a_env_232_integrate_a, select_ast_node, ((long) 13));
   add_inlined_method__244___object(node_a_env_232_integrate_a, let_fun_218_ast_node, ((long) 14));
   add_inlined_method__244___object(node_a_env_232_integrate_a, let_var_6_ast_node, ((long) 15));
   add_inlined_method__244___object(node_a_env_232_integrate_a, set_ex_it_116_ast_node, ((long) 16));
   add_inlined_method__244___object(node_a_env_232_integrate_a, jump_ex_it_184_ast_node, ((long) 17));
   add_inlined_method__244___object(node_a_env_232_integrate_a, make_box_202_ast_node, ((long) 18));
   add_inlined_method__244___object(node_a_env_232_integrate_a, box_set__221_ast_node, ((long) 19));
   {
      long aux_1939;
      aux_1939 = add_inlined_method__244___object(node_a_env_232_integrate_a, box_ref_242_ast_node, ((long) 20));
      return BINT(aux_1939);
   }
}


obj_t 
a_integrate_a(global_t global_1, node_t node_2)
{
   {
      obj_t list1386_905;
      {
	 obj_t aux_1942;
	 aux_1942 = (obj_t) (global_1);
	 list1386_905 = MAKE_PAIR(aux_1942, BNIL);
      }
      __phi__105_integrate_a = list1386_905;
   }
   __kont__191_integrate_a = BINT(((long) 0));
   initialize_fun__49_integrate_a((variable_t) (global_1), (variable_t) (global_1));
   {
      obj_t a_907;
      a_907 = node_a_141_integrate_a(node_2, (variable_t) (global_1), CNST_TABLE_REF(((long) 0)), BNIL);
      trace_a_118_integrate_a(a_907);
      return a_907;
   }
}


obj_t 
_a_integrate_a(obj_t env_1883, obj_t global_1884, obj_t node_1885)
{
   return a_integrate_a((global_t) (global_1884), (node_t) (node_1885));
}


bool_t 
initialize_fun__49_integrate_a(variable_t fun_3, variable_t owner_4)
{
   {
      sfun_iinfo_105_t obj1329_910;
      obj1329_910 = ((sfun_iinfo_105_t) ((((variable_t) CREF(fun_3))->value)));
      {
	 sfun_iinfo_105_t arg1396_911;
	 {
	    bool_t arg1411_920;
	    arg1411_920 = is_a__118___object((obj_t) (fun_3), global_ast_var);
	    {
	       sfun_iinfo_105_t res1772_1646;
	       {
		  obj_t owner_1611;
		  owner_1611 = (obj_t) (owner_4);
		  {
		     sfun_iinfo_105_t new1297_1628;
		     new1297_1628 = ((sfun_iinfo_105_t) BREF(GC_MALLOC(sizeof(struct sfun_iinfo_105))));
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->owner) = ((obj_t) owner_1611), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->free) = ((obj_t) BUNSPEC), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->bound) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->cfrom) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->cto) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->k) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->k__190) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->u) = ((obj_t) BUNSPEC), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->cn) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->ct) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->kont) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->g__219) = ((bool_t) arg1411_920), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->l) = ((obj_t) BUNSPEC), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->led) = ((obj_t) BNIL), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->istamp) = ((obj_t) BUNSPEC), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->global) = ((obj_t) BUNSPEC), BUNSPEC);
		     ((((sfun_iinfo_105_t) CREF(new1297_1628))->kaptured) = ((obj_t) BUNSPEC), BUNSPEC);
		     res1772_1646 = new1297_1628;
		  }
	       }
	       arg1396_911 = res1772_1646;
	    }
	 }
	 {
	    obj_t aux_1981;
	    object_t aux_1979;
	    aux_1981 = (obj_t) (arg1396_911);
	    aux_1979 = (object_t) (obj1329_910);
	    OBJECT_WIDENING_SET(aux_1979, aux_1981);
	 }
      }
      {
	 long arg1414_922;
	 arg1414_922 = class_num_218___object(sfun_iinfo_105_integrate_info);
	 {
	    obj_t obj_1647;
	    obj_1647 = (obj_t) (obj1329_910);
	    (((obj_t) CREF(obj_1647))->header = MAKE_HEADER(arg1414_922, 0), BUNSPEC);
	 }
      }
      obj1329_910;
   }
   {
      obj_t l1330_923;
      {
	 sfun_t obj_1650;
	 {
	    value_t aux_2009;
	    aux_2009 = (((variable_t) CREF(fun_3))->value);
	    obj_1650 = (sfun_t) (aux_2009);
	 }
	 l1330_923 = (((sfun_t) CREF(obj_1650))->args);
      }
    lname1333_924:
      if (PAIRP(l1330_923))
	{
	   {
	      obj_t x_928;
	      x_928 = CAR(l1330_923);
	      {
		 svar_iinfo_76_t obj1334_929;
		 {
		    value_t aux_1990;
		    {
		       local_t obj_1653;
		       obj_1653 = (local_t) (x_928);
		       aux_1990 = (((local_t) CREF(obj_1653))->value);
		    }
		    obj1334_929 = ((svar_iinfo_76_t) (aux_1990));
		 }
		 {
		    svar_iinfo_76_t arg1418_930;
		    {
		       svar_iinfo_76_t res1773_1663;
		       {
			  svar_iinfo_76_t new1275_1658;
			  new1275_1658 = ((svar_iinfo_76_t) BREF(GC_MALLOC(sizeof(struct svar_iinfo_76))));
			  ((((svar_iinfo_76_t) CREF(new1275_1658))->f_mark_181) = ((obj_t) BUNSPEC), BUNSPEC);
			  ((((svar_iinfo_76_t) CREF(new1275_1658))->u_mark_209) = ((obj_t) BUNSPEC), BUNSPEC);
			  ((((svar_iinfo_76_t) CREF(new1275_1658))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			  ((((svar_iinfo_76_t) CREF(new1275_1658))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			  res1773_1663 = new1275_1658;
		       }
		       arg1418_930 = res1773_1663;
		    }
		    {
		       obj_t aux_2001;
		       object_t aux_1999;
		       aux_2001 = (obj_t) (arg1418_930);
		       aux_1999 = (object_t) (obj1334_929);
		       OBJECT_WIDENING_SET(aux_1999, aux_2001);
		    }
		 }
		 {
		    long arg1420_931;
		    arg1420_931 = class_num_218___object(svar_iinfo_76_integrate_info);
		    {
		       obj_t obj_1664;
		       obj_1664 = (obj_t) (obj1334_929);
		       (((obj_t) CREF(obj_1664))->header = MAKE_HEADER(arg1420_931, 0), BUNSPEC);
		    }
		 }
		 obj1334_929;
	      }
	   }
	   {
	      obj_t l1330_2007;
	      l1330_2007 = CDR(l1330_923);
	      l1330_923 = l1330_2007;
	      goto lname1333_924;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
get_new_kont_177_integrate_a()
{
   {
      long z2_1668;
      z2_1668 = (long) CINT(__kont__191_integrate_a);
      {
	 long aux_2014;
	 aux_2014 = (((long) 1) + z2_1668);
	 __kont__191_integrate_a = BINT(aux_2014);
      }
   }
   return __kont__191_integrate_a;
}


obj_t 
trace_a_118_integrate_a(obj_t a_5)
{
   {
      bool_t test1422_933;
      {
	 obj_t aux_2017;
	 aux_2017 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
	 test1422_933 = CBOOL(aux_2017);
      }
      if (test1422_933)
	{
	   obj_t arg1427_936;
	   char *arg1428_937;
	   arg1427_936 = shape_tools_shape(__phi__105_integrate_a);
	   {
	      obj_t l1335_946;
	      l1335_946 = a_5;
	    lname1336_947:
	      if (PAIRP(l1335_946))
		{
		   {
		      obj_t a_949;
		      a_949 = CAR(l1335_946);
		      {
			 obj_t arg1449_951;
			 obj_t arg1452_953;
			 obj_t arg1454_955;
			 arg1449_951 = shape_tools_shape(CAR(a_949));
			 {
			    obj_t aux_2029;
			    {
			       obj_t aux_2030;
			       aux_2030 = CDR(a_949);
			       aux_2029 = CAR(aux_2030);
			    }
			    arg1452_953 = shape_tools_shape(aux_2029);
			 }
			 {
			    obj_t aux_2034;
			    {
			       obj_t aux_2035;
			       aux_2035 = CDR(a_949);
			       aux_2034 = CDR(aux_2035);
			    }
			    arg1454_955 = CAR(aux_2034);
			 }
			 {
			    obj_t list1458_957;
			    {
			       obj_t arg1461_958;
			       {
				  obj_t arg1463_959;
				  {
				     obj_t arg1465_960;
				     {
					obj_t arg1466_961;
					{
					   obj_t arg1467_962;
					   {
					      obj_t arg1468_963;
					      arg1468_963 = MAKE_PAIR(string1777_integrate_a, BNIL);
					      arg1467_962 = MAKE_PAIR(arg1454_955, arg1468_963);
					   }
					   arg1466_961 = MAKE_PAIR(string1778_integrate_a, arg1467_962);
					}
					arg1465_960 = MAKE_PAIR(arg1452_953, arg1466_961);
				     }
				     arg1463_959 = MAKE_PAIR(string1778_integrate_a, arg1465_960);
				  }
				  arg1461_958 = MAKE_PAIR(arg1449_951, arg1463_959);
			       }
			       list1458_957 = MAKE_PAIR(string1779_integrate_a, arg1461_958);
			    }
			    fprint___r4_output_6_10_3(__trace_port__84_tools_trace, list1458_957);
			 }
		      }
		   }
		   {
		      obj_t l1335_2047;
		      l1335_2047 = CDR(l1335_946);
		      l1335_946 = l1335_2047;
		      goto lname1336_947;
		   }
		}
	      else
		{
		   ((bool_t) 1);
		}
	   }
	   arg1428_937 = "- - - - - - - - - - - - - - - - ";
	   {
	      obj_t list1429_938;
	      {
		 obj_t arg1431_939;
		 {
		    obj_t arg1432_940;
		    {
		       obj_t arg1440_941;
		       {
			  obj_t arg1441_942;
			  {
			     obj_t arg1444_943;
			     {
				obj_t arg1445_944;
				{
				   obj_t aux_2049;
				   aux_2049 = BCHAR(((unsigned char) '\n'));
				   arg1445_944 = MAKE_PAIR(aux_2049, BNIL);
				}
				{
				   obj_t aux_2052;
				   aux_2052 = string_to_bstring(arg1428_937);
				   arg1444_943 = MAKE_PAIR(aux_2052, arg1445_944);
				}
			     }
			     {
				obj_t aux_2055;
				aux_2055 = BCHAR(((unsigned char) '\n'));
				arg1441_942 = MAKE_PAIR(aux_2055, arg1444_943);
			     }
			  }
			  arg1440_941 = MAKE_PAIR(arg1427_936, arg1441_942);
		       }
		       arg1432_940 = MAKE_PAIR(string1780_integrate_a, arg1440_941);
		    }
		    {
		       obj_t aux_2060;
		       aux_2060 = BCHAR(((unsigned char) '\n'));
		       arg1431_939 = MAKE_PAIR(aux_2060, arg1432_940);
		    }
		 }
		 list1429_938 = MAKE_PAIR(string1781_integrate_a, arg1431_939);
	      }
	      return print_trace_107_tools_trace(list1429_938);
	   }
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
node_a_default1358_72_integrate_a(node_t node_10, variable_t host_11, obj_t k_12, obj_t a_13)
{
   FAILURE(CNST_TABLE_REF(((long) 2)), string1782_integrate_a, (obj_t) (node_10));
}


obj_t 
_node_a_default1358_143_integrate_a(obj_t env_1878, obj_t node_1879, obj_t host_1880, obj_t k_1881, obj_t a_1882)
{
   return node_a_default1358_72_integrate_a((node_t) (node_1879), (variable_t) (host_1880), k_1881, a_1882);
}


obj_t 
node_a_141_integrate_a(node_t node_6, variable_t host_7, obj_t k_8, obj_t a_9)
{
 node_a_141_integrate_a:
   {
      obj_t method1591_1332;
      obj_t class1598_1333;
      {
	 obj_t arg1601_1330;
	 obj_t arg1603_1331;
	 {
	    object_t obj_1688;
	    obj_1688 = (object_t) (node_6);
	    {
	       obj_t pre_method_105_1689;
	       pre_method_105_1689 = PROCEDURE_REF(node_a_env_232_integrate_a, ((long) 2));
	       if (INTEGERP(pre_method_105_1689))
		 {
		    PROCEDURE_SET(node_a_env_232_integrate_a, ((long) 2), BUNSPEC);
		    arg1601_1330 = pre_method_105_1689;
		 }
	       else
		 {
		    long obj_class_num_177_1694;
		    obj_class_num_177_1694 = TYPE(obj_1688);
		    {
		       obj_t arg1183_1695;
		       arg1183_1695 = PROCEDURE_REF(node_a_env_232_integrate_a, ((long) 1));
		       {
			  long arg1184_1699;
			  {
			     long arg1186_1700;
			     arg1186_1700 = OBJECT_TYPE;
			     arg1184_1699 = (obj_class_num_177_1694 - arg1186_1700);
			  }
			  arg1601_1330 = VECTOR_REF(arg1183_1695, arg1184_1699);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1705;
	    object_1705 = (object_t) (node_6);
	    {
	       long arg1187_1706;
	       {
		  long arg1188_1707;
		  long arg1189_1708;
		  arg1188_1707 = TYPE(object_1705);
		  arg1189_1708 = OBJECT_TYPE;
		  arg1187_1706 = (arg1188_1707 - arg1189_1708);
	       }
	       {
		  obj_t vector_1712;
		  vector_1712 = __classes__134___object;
		  arg1603_1331 = VECTOR_REF(vector_1712, arg1187_1706);
	       }
	    }
	 }
	 method1591_1332 = arg1601_1330;
	 class1598_1333 = arg1603_1331;
	 {
	    if (INTEGERP(method1591_1332))
	      {
		 switch ((long) CINT(method1591_1332))
		   {
		   case ((long) 0):
		      return a_9;
		      break;
		   case ((long) 1):
		      return a_9;
		      break;
		   case ((long) 2):
		      return a_9;
		      break;
		   case ((long) 3):
		      {
			 obj_t arg1609_1357;
			 {
			    obj_t aux_2088;
			    {
			       closure_t aux_2089;
			       aux_2089 = (closure_t) (node_6);
			       aux_2088 = (obj_t) (aux_2089);
			    }
			    arg1609_1357 = shape_tools_shape(aux_2088);
			 }
			 return internal_error_43_tools_error(string1783_integrate_a, string1784_integrate_a, arg1609_1357);
		      }
		      break;
		   case ((long) 4):
		      {
			 sequence_t node_1358;
			 node_1358 = (sequence_t) (node_6);
			 {
			    bool_t test_2095;
			    {
			       obj_t aux_2096;
			       aux_2096 = (((sequence_t) CREF(node_1358))->nodes);
			       test_2095 = NULLP(aux_2096);
			    }
			    if (test_2095)
			      {
				 return a_9;
			      }
			    else
			      {
				 obj_t nds_1364;
				 obj_t a_1365;
				 nds_1364 = (((sequence_t) CREF(node_1358))->nodes);
				 a_1365 = a_9;
			       liip_1366:
				 {
				    bool_t test_2099;
				    {
				       obj_t aux_2100;
				       aux_2100 = CDR(nds_1364);
				       test_2099 = NULLP(aux_2100);
				    }
				    if (test_2099)
				      {
					 obj_t a_2107;
					 node_t node_2103;
					 {
					    obj_t aux_2104;
					    aux_2104 = CAR(nds_1364);
					    node_2103 = (node_t) (aux_2104);
					 }
					 a_2107 = a_1365;
					 a_9 = a_2107;
					 node_6 = node_2103;
					 goto node_a_141_integrate_a;
				      }
				    else
				      {
					 obj_t arg1616_1370;
					 obj_t arg1617_1371;
					 arg1616_1370 = CDR(nds_1364);
					 {
					    obj_t arg1618_1372;
					    obj_t arg1619_1373;
					    arg1618_1372 = CAR(nds_1364);
					    arg1619_1373 = get_new_kont_177_integrate_a();
					    arg1617_1371 = node_a_141_integrate_a((node_t) (arg1618_1372), host_7, arg1619_1373, a_1365);
					 }
					 {
					    obj_t a_2114;
					    obj_t nds_2113;
					    nds_2113 = arg1616_1370;
					    a_2114 = arg1617_1371;
					    a_1365 = a_2114;
					    nds_1364 = nds_2113;
					    goto liip_1366;
					 }
				      }
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 app_t node_1376;
			 node_1376 = (app_t) (node_6);
			 {
			    variable_t callee_1381;
			    {
			       var_t arg1643_1398;
			       arg1643_1398 = (((app_t) CREF(node_1376))->fun);
			       callee_1381 = (((var_t) CREF(arg1643_1398))->variable);
			    }
			    {
			       obj_t args_1382;
			       obj_t a_1383;
			       args_1382 = (((app_t) CREF(node_1376))->args);
			       a_1383 = a_9;
			     liip_1384:
			       if (NULLP(args_1382))
				 {
				    bool_t test1625_1387;
				    test1625_1387 = is_a__118___object((obj_t) (callee_1381), local_ast_var);
				    if (test1625_1387)
				      {
					 {
					    obj_t arg1626_1388;
					    {
					       obj_t list1628_1390;
					       {
						  obj_t arg1630_1391;
						  {
						     obj_t arg1632_1392;
						     arg1632_1392 = MAKE_PAIR(BNIL, BNIL);
						     arg1630_1391 = MAKE_PAIR(k_8, arg1632_1392);
						  }
						  {
						     obj_t aux_2126;
						     aux_2126 = (obj_t) (callee_1381);
						     list1628_1390 = MAKE_PAIR(aux_2126, arg1630_1391);
						  }
					       }
					       arg1626_1388 = cons__138___r4_pairs_and_lists_6_3((obj_t) (host_7), list1628_1390);
					    }
					    return MAKE_PAIR(arg1626_1388, a_1383);
					 }
				      }
				    else
				      {
					 return a_1383;
				      }
				 }
			       else
				 {
				    obj_t arg1637_1394;
				    obj_t arg1638_1395;
				    arg1637_1394 = CDR(args_1382);
				    {
				       obj_t arg1641_1396;
				       obj_t arg1642_1397;
				       arg1641_1396 = CAR(args_1382);
				       arg1642_1397 = get_new_kont_177_integrate_a();
				       arg1638_1395 = node_a_141_integrate_a((node_t) (arg1641_1396), host_7, arg1642_1397, a_1383);
				    }
				    {
				       obj_t a_2138;
				       obj_t args_2137;
				       args_2137 = arg1637_1394;
				       a_2138 = arg1638_1395;
				       a_1383 = a_2138;
				       args_1382 = args_2137;
				       goto liip_1384;
				    }
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 app_ly_162_t node_1399;
			 node_1399 = (app_ly_162_t) (node_6);
			 {
			    node_t arg1644_1404;
			    obj_t arg1645_1405;
			    obj_t arg1646_1406;
			    arg1644_1404 = (((app_ly_162_t) CREF(node_1399))->fun);
			    arg1645_1405 = get_new_kont_177_integrate_a();
			    {
			       node_t arg1647_1407;
			       obj_t arg1648_1408;
			       arg1647_1407 = (((app_ly_162_t) CREF(node_1399))->arg);
			       arg1648_1408 = get_new_kont_177_integrate_a();
			       arg1646_1406 = node_a_141_integrate_a(arg1647_1407, host_7, arg1648_1408, a_9);
			    }
			    {
			       obj_t a_2148;
			       obj_t k_2147;
			       node_t node_2146;
			       node_2146 = arg1644_1404;
			       k_2147 = arg1645_1405;
			       a_2148 = arg1646_1406;
			       a_9 = a_2148;
			       k_8 = k_2147;
			       node_6 = node_2146;
			       goto node_a_141_integrate_a;
			    }
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 funcall_t node_1409;
			 node_1409 = (funcall_t) (node_6);
			 {
			    node_t arg1650_1414;
			    obj_t arg1651_1415;
			    obj_t arg1652_1416;
			    arg1650_1414 = (((funcall_t) CREF(node_1409))->fun);
			    arg1651_1415 = get_new_kont_177_integrate_a();
			    {
			       obj_t args_1417;
			       obj_t a_1418;
			       args_1417 = (((funcall_t) CREF(node_1409))->args);
			       a_1418 = a_9;
			     liip_1419:
			       if (NULLP(args_1417))
				 {
				    arg1652_1416 = a_1418;
				 }
			       else
				 {
				    obj_t arg1655_1422;
				    obj_t arg1656_1423;
				    arg1655_1422 = CDR(args_1417);
				    {
				       obj_t arg1657_1424;
				       obj_t arg1659_1425;
				       arg1657_1424 = CAR(args_1417);
				       arg1659_1425 = get_new_kont_177_integrate_a();
				       arg1656_1423 = node_a_141_integrate_a((node_t) (arg1657_1424), host_7, arg1659_1425, a_1418);
				    }
				    {
				       obj_t a_2160;
				       obj_t args_2159;
				       args_2159 = arg1655_1422;
				       a_2160 = arg1656_1423;
				       a_1418 = a_2160;
				       args_1417 = args_2159;
				       goto liip_1419;
				    }
				 }
			    }
			    {
			       obj_t a_2164;
			       obj_t k_2163;
			       node_t node_2162;
			       node_2162 = arg1650_1414;
			       k_2163 = arg1651_1415;
			       a_2164 = arg1652_1416;
			       a_9 = a_2164;
			       k_8 = k_2163;
			       node_6 = node_2162;
			       goto node_a_141_integrate_a;
			    }
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 pragma_t node_1426;
			 node_1426 = (pragma_t) (node_6);
			 {
			    obj_t asts_1431;
			    obj_t a_1432;
			    asts_1431 = (((pragma_t) CREF(node_1426))->args);
			    a_1432 = a_9;
			  liip_1433:
			    if (NULLP(asts_1431))
			      {
				 return a_1432;
			      }
			    else
			      {
				 obj_t arg1663_1436;
				 obj_t arg1664_1437;
				 arg1663_1436 = CDR(asts_1431);
				 {
				    obj_t arg1665_1438;
				    obj_t arg1667_1439;
				    arg1665_1438 = CAR(asts_1431);
				    arg1667_1439 = get_new_kont_177_integrate_a();
				    arg1664_1437 = node_a_141_integrate_a((node_t) (arg1665_1438), host_7, arg1667_1439, a_1432);
				 }
				 {
				    obj_t a_2174;
				    obj_t asts_2173;
				    asts_2173 = arg1663_1436;
				    a_2174 = arg1664_1437;
				    a_1432 = a_2174;
				    asts_1431 = asts_2173;
				    goto liip_1433;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 cast_t node_1440;
			 node_1440 = (cast_t) (node_6);
			 {
			    node_t arg1668_1445;
			    obj_t arg1669_1446;
			    arg1668_1445 = (((cast_t) CREF(node_1440))->arg);
			    arg1669_1446 = get_new_kont_177_integrate_a();
			    {
			       obj_t k_2180;
			       node_t node_2179;
			       node_2179 = arg1668_1445;
			       k_2180 = arg1669_1446;
			       k_8 = k_2180;
			       node_6 = node_2179;
			       goto node_a_141_integrate_a;
			    }
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 setq_t node_1447;
			 node_1447 = (setq_t) (node_6);
			 {
			    node_t arg1671_1452;
			    obj_t arg1673_1453;
			    arg1671_1452 = (((setq_t) CREF(node_1447))->value);
			    arg1673_1453 = get_new_kont_177_integrate_a();
			    {
			       obj_t k_2185;
			       node_t node_2184;
			       node_2184 = arg1671_1452;
			       k_2185 = arg1673_1453;
			       k_8 = k_2185;
			       node_6 = node_2184;
			       goto node_a_141_integrate_a;
			    }
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 conditional_t node_1454;
			 node_1454 = (conditional_t) (node_6);
			 {
			    obj_t a_1459;
			    {
			       node_t arg1679_1463;
			       obj_t arg1680_1464;
			       arg1679_1463 = (((conditional_t) CREF(node_1454))->test);
			       arg1680_1464 = get_new_kont_177_integrate_a();
			       a_1459 = node_a_141_integrate_a(arg1679_1463, host_7, arg1680_1464, a_9);
			    }
			    {
			       node_t arg1674_1460;
			       obj_t arg1677_1461;
			       arg1674_1460 = (((conditional_t) CREF(node_1454))->true);
			       arg1677_1461 = node_a_141_integrate_a((((conditional_t) CREF(node_1454))->false), host_7, k_8, a_1459);
			       {
				  obj_t a_2194;
				  node_t node_2193;
				  node_2193 = arg1674_1460;
				  a_2194 = arg1677_1461;
				  a_9 = a_2194;
				  node_6 = node_2193;
				  goto node_a_141_integrate_a;
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 fail_t node_1465;
			 node_1465 = (fail_t) (node_6);
			 {
			    node_t arg1681_1470;
			    obj_t arg1682_1471;
			    obj_t arg1684_1472;
			    arg1681_1470 = (((fail_t) CREF(node_1465))->proc);
			    arg1682_1471 = get_new_kont_177_integrate_a();
			    {
			       node_t arg1686_1473;
			       obj_t arg1687_1474;
			       obj_t arg1688_1475;
			       arg1686_1473 = (((fail_t) CREF(node_1465))->msg);
			       arg1687_1474 = get_new_kont_177_integrate_a();
			       {
				  node_t arg1689_1476;
				  obj_t arg1690_1477;
				  arg1689_1476 = (((fail_t) CREF(node_1465))->obj);
				  arg1690_1477 = get_new_kont_177_integrate_a();
				  arg1688_1475 = node_a_141_integrate_a(arg1689_1476, host_7, arg1690_1477, a_9);
			       }
			       arg1684_1472 = node_a_141_integrate_a(arg1686_1473, host_7, arg1687_1474, arg1688_1475);
			    }
			    {
			       obj_t a_2206;
			       obj_t k_2205;
			       node_t node_2204;
			       node_2204 = arg1681_1470;
			       k_2205 = arg1682_1471;
			       a_2206 = arg1684_1472;
			       a_9 = a_2206;
			       k_8 = k_2205;
			       node_6 = node_2204;
			       goto node_a_141_integrate_a;
			    }
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 select_t node_1478;
			 node_1478 = (select_t) (node_6);
			 {
			    obj_t clauses_1483;
			    obj_t a_1484;
			    {
			       obj_t arg1691_1486;
			       obj_t arg1693_1487;
			       arg1691_1486 = (((select_t) CREF(node_1478))->clauses);
			       {
				  node_t arg1694_1488;
				  obj_t arg1695_1489;
				  arg1694_1488 = (((select_t) CREF(node_1478))->test);
				  arg1695_1489 = get_new_kont_177_integrate_a();
				  arg1693_1487 = node_a_141_integrate_a(arg1694_1488, host_7, arg1695_1489, a_9);
			       }
			       clauses_1483 = arg1691_1486;
			       a_1484 = arg1693_1487;
			     liip_1485:
			       if (NULLP(clauses_1483))
				 {
				    return a_1484;
				 }
			       else
				 {
				    obj_t arg1697_1491;
				    obj_t arg1698_1492;
				    arg1697_1491 = CDR(clauses_1483);
				    {
				       node_t aux_2215;
				       {
					  obj_t aux_2216;
					  {
					     obj_t aux_2217;
					     aux_2217 = CAR(clauses_1483);
					     aux_2216 = CDR(aux_2217);
					  }
					  aux_2215 = (node_t) (aux_2216);
				       }
				       arg1698_1492 = node_a_141_integrate_a(aux_2215, host_7, k_8, a_1484);
				    }
				    {
				       obj_t a_2223;
				       obj_t clauses_2222;
				       clauses_2222 = arg1697_1491;
				       a_2223 = arg1698_1492;
				       a_1484 = a_2223;
				       clauses_1483 = clauses_2222;
				       goto liip_1485;
				    }
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 let_fun_218_t node_1495;
			 node_1495 = (let_fun_218_t) (node_6);
			 {
			    obj_t l1348_1500;
			    l1348_1500 = (((let_fun_218_t) CREF(node_1495))->locals);
			  lname1349_1501:
			    if (PAIRP(l1348_1500))
			      {
				 {
				    obj_t f_1504;
				    f_1504 = CAR(l1348_1500);
				    initialize_fun__49_integrate_a((variable_t) (f_1504), host_7);
				    {
				       obj_t obj2_1760;
				       obj2_1760 = __phi__105_integrate_a;
				       __phi__105_integrate_a = MAKE_PAIR(f_1504, obj2_1760);
				    }
				 }
				 {
				    obj_t l1348_2231;
				    l1348_2231 = CDR(l1348_1500);
				    l1348_1500 = l1348_2231;
				    goto lname1349_1501;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    obj_t locals_1506;
			    obj_t a_1507;
			    locals_1506 = (((let_fun_218_t) CREF(node_1495))->locals);
			    a_1507 = a_9;
			  liip_1508:
			    if (NULLP(locals_1506))
			      {
				 obj_t a_2238;
				 node_t node_2236;
				 node_2236 = (((let_fun_218_t) CREF(node_1495))->body);
				 a_2238 = a_1507;
				 a_9 = a_2238;
				 node_6 = node_2236;
				 goto node_a_141_integrate_a;
			      }
			    else
			      {
				 obj_t arg1708_1512;
				 obj_t arg1709_1513;
				 arg1708_1512 = CDR(locals_1506);
				 {
				    variable_t aux_2250;
				    node_t aux_2240;
				    {
				       obj_t aux_2251;
				       aux_2251 = CAR(locals_1506);
				       aux_2250 = (variable_t) (aux_2251);
				    }
				    {
				       obj_t aux_2241;
				       {
					  sfun_t obj_1768;
					  {
					     value_t aux_2242;
					     {
						local_t obj_1767;
						{
						   obj_t aux_2243;
						   aux_2243 = CAR(locals_1506);
						   obj_1767 = (local_t) (aux_2243);
						}
						aux_2242 = (((local_t) CREF(obj_1767))->value);
					     }
					     obj_1768 = (sfun_t) (aux_2242);
					  }
					  aux_2241 = (((sfun_t) CREF(obj_1768))->body);
				       }
				       aux_2240 = (node_t) (aux_2241);
				    }
				    arg1709_1513 = node_a_141_integrate_a(aux_2240, aux_2250, CNST_TABLE_REF(((long) 0)), a_1507);
				 }
				 {
				    obj_t a_2257;
				    obj_t locals_2256;
				    locals_2256 = arg1708_1512;
				    a_2257 = arg1709_1513;
				    a_1507 = a_2257;
				    locals_1506 = locals_2256;
				    goto liip_1508;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 let_var_6_t node_1519;
			 node_1519 = (let_var_6_t) (node_6);
			 {
			    obj_t bindings_1524;
			    obj_t a_1525;
			    bindings_1524 = (((let_var_6_t) CREF(node_1519))->bindings);
			    a_1525 = a_9;
			  liip_1526:
			    if (NULLP(bindings_1524))
			      {
				 obj_t a_2264;
				 node_t node_2262;
				 node_2262 = (((let_var_6_t) CREF(node_1519))->body);
				 a_2264 = a_1525;
				 a_9 = a_2264;
				 node_6 = node_2262;
				 goto node_a_141_integrate_a;
			      }
			    else
			      {
				 obj_t binding_1530;
				 binding_1530 = CAR(bindings_1524);
				 {
				    obj_t var_1531;
				    var_1531 = CAR(binding_1530);
				    {
				       obj_t val_1532;
				       val_1532 = CDR(binding_1530);
				       {
					  {
					     svar_iinfo_76_t obj1351_1533;
					     {
						value_t aux_2268;
						{
						   local_t obj_1776;
						   obj_1776 = (local_t) (var_1531);
						   aux_2268 = (((local_t) CREF(obj_1776))->value);
						}
						obj1351_1533 = ((svar_iinfo_76_t) (aux_2268));
					     }
					     {
						svar_iinfo_76_t arg1719_1534;
						{
						   svar_iinfo_76_t res1774_1786;
						   {
						      svar_iinfo_76_t new1275_1781;
						      new1275_1781 = ((svar_iinfo_76_t) BREF(GC_MALLOC(sizeof(struct svar_iinfo_76))));
						      ((((svar_iinfo_76_t) CREF(new1275_1781))->f_mark_181) = ((obj_t) BUNSPEC), BUNSPEC);
						      ((((svar_iinfo_76_t) CREF(new1275_1781))->u_mark_209) = ((obj_t) BUNSPEC), BUNSPEC);
						      ((((svar_iinfo_76_t) CREF(new1275_1781))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						      ((((svar_iinfo_76_t) CREF(new1275_1781))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						      res1774_1786 = new1275_1781;
						   }
						   arg1719_1534 = res1774_1786;
						}
						{
						   obj_t aux_2279;
						   object_t aux_2277;
						   aux_2279 = (obj_t) (arg1719_1534);
						   aux_2277 = (object_t) (obj1351_1533);
						   OBJECT_WIDENING_SET(aux_2277, aux_2279);
						}
					     }
					     {
						long arg1720_1535;
						arg1720_1535 = class_num_218___object(svar_iinfo_76_integrate_info);
						{
						   obj_t obj_1787;
						   obj_1787 = (obj_t) (obj1351_1533);
						   (((obj_t) CREF(obj_1787))->header = MAKE_HEADER(arg1720_1535, 0), BUNSPEC);
						}
					     }
					     obj1351_1533;
					  }
					  {
					     obj_t arg1721_1536;
					     obj_t arg1722_1537;
					     arg1721_1536 = CDR(bindings_1524);
					     {
						obj_t arg1724_1538;
						arg1724_1538 = get_new_kont_177_integrate_a();
						arg1722_1537 = node_a_141_integrate_a((node_t) (val_1532), host_7, arg1724_1538, a_1525);
					     }
					     {
						obj_t a_2290;
						obj_t bindings_2289;
						bindings_2289 = arg1721_1536;
						a_2290 = arg1722_1537;
						a_1525 = a_2290;
						bindings_1524 = bindings_2289;
						goto liip_1526;
					     }
					  }
				       }
				    }
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 set_ex_it_116_t node_1539;
			 node_1539 = (set_ex_it_116_t) (node_6);
			 {
			    variable_t exit_1544;
			    {
			       var_t arg1754_1570;
			       arg1754_1570 = (((set_ex_it_116_t) CREF(node_1539))->var);
			       exit_1544 = (((var_t) CREF(arg1754_1570))->variable);
			    }
			    {
			       obj_t hdlg_1545;
			       {
				  sexit_t obj_1793;
				  {
				     value_t aux_2295;
				     {
					local_t obj_1792;
					obj_1792 = (local_t) (exit_1544);
					aux_2295 = (((local_t) CREF(obj_1792))->value);
				     }
				     obj_1793 = (sexit_t) (aux_2295);
				  }
				  hdlg_1545 = (((sexit_t) CREF(obj_1793))->handler);
			       }
			       {
				  {
				     sexit_iinfo_190_t obj1354_1546;
				     {
					value_t aux_2300;
					{
					   local_t obj_1794;
					   obj_1794 = (local_t) (exit_1544);
					   aux_2300 = (((local_t) CREF(obj_1794))->value);
					}
					obj1354_1546 = ((sexit_iinfo_190_t) (aux_2300));
				     }
				     {
					sexit_iinfo_190_t arg1725_1547;
					{
					   sexit_iinfo_190_t res1775_1804;
					   {
					      sexit_iinfo_190_t new1285_1799;
					      new1285_1799 = ((sexit_iinfo_190_t) BREF(GC_MALLOC(sizeof(struct sexit_iinfo_190))));
					      ((((sexit_iinfo_190_t) CREF(new1285_1799))->f_mark_181) = ((obj_t) BUNSPEC), BUNSPEC);
					      ((((sexit_iinfo_190_t) CREF(new1285_1799))->u_mark_209) = ((obj_t) BUNSPEC), BUNSPEC);
					      ((((sexit_iinfo_190_t) CREF(new1285_1799))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					      ((((sexit_iinfo_190_t) CREF(new1285_1799))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					      res1775_1804 = new1285_1799;
					   }
					   arg1725_1547 = res1775_1804;
					}
					{
					   obj_t aux_2311;
					   object_t aux_2309;
					   aux_2311 = (obj_t) (arg1725_1547);
					   aux_2309 = (object_t) (obj1354_1546);
					   OBJECT_WIDENING_SET(aux_2309, aux_2311);
					}
				     }
				     {
					long arg1730_1548;
					arg1730_1548 = class_num_218___object(sexit_iinfo_190_integrate_info);
					{
					   obj_t obj_1805;
					   obj_1805 = (obj_t) (obj1354_1546);
					   (((obj_t) CREF(obj_1805))->header = MAKE_HEADER(arg1730_1548, 0), BUNSPEC);
					}
				     }
				     obj1354_1546;
				  }
				  {
				     bool_t test_2317;
				     {
					sexit_t obj_1808;
					{
					   value_t aux_2318;
					   {
					      local_t obj_1807;
					      obj_1807 = (local_t) (exit_1544);
					      aux_2318 = (((local_t) CREF(obj_1807))->value);
					   }
					   obj_1808 = (sexit_t) (aux_2318);
					}
					test_2317 = (((sexit_t) CREF(obj_1808))->detached__120);
				     }
				     if (test_2317)
				       {
					  return a_9;
				       }
				     else
				       {
					  obj_t call_1_215_1550;
					  obj_t call_2_162_1551;
					  {
					     obj_t arg1736_1556;
					     arg1736_1556 = get_new_kont_177_integrate_a();
					     {
						obj_t list1738_1558;
						{
						   obj_t arg1740_1559;
						   {
						      obj_t arg1741_1560;
						      arg1741_1560 = MAKE_PAIR(BNIL, BNIL);
						      arg1740_1559 = MAKE_PAIR(arg1736_1556, arg1741_1560);
						   }
						   list1738_1558 = MAKE_PAIR(hdlg_1545, arg1740_1559);
						}
						call_1_215_1550 = cons__138___r4_pairs_and_lists_6_3(hdlg_1545, list1738_1558);
					     }
					  }
					  {
					     obj_t arg1743_1562;
					     arg1743_1562 = get_new_kont_177_integrate_a();
					     {
						obj_t list1746_1564;
						{
						   obj_t arg1747_1565;
						   {
						      obj_t arg1748_1566;
						      arg1748_1566 = MAKE_PAIR(BNIL, BNIL);
						      arg1747_1565 = MAKE_PAIR(arg1743_1562, arg1748_1566);
						   }
						   list1746_1564 = MAKE_PAIR(hdlg_1545, arg1747_1565);
						}
						call_2_162_1551 = cons__138___r4_pairs_and_lists_6_3(hdlg_1545, list1746_1564);
					     }
					  }
					  {
					     node_t arg1732_1552;
					     obj_t arg1733_1553;
					     obj_t arg1734_1554;
					     arg1732_1552 = (((set_ex_it_116_t) CREF(node_1539))->body);
					     arg1733_1553 = get_new_kont_177_integrate_a();
					     {
						obj_t arg1735_1555;
						arg1735_1555 = MAKE_PAIR(call_2_162_1551, a_9);
						arg1734_1554 = MAKE_PAIR(call_1_215_1550, arg1735_1555);
					     }
					     {
						obj_t a_2339;
						obj_t k_2338;
						node_t node_2337;
						node_2337 = arg1732_1552;
						k_2338 = arg1733_1553;
						a_2339 = arg1734_1554;
						a_9 = a_2339;
						k_8 = k_2338;
						node_6 = node_2337;
						goto node_a_141_integrate_a;
					     }
					  }
				       }
				  }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 jump_ex_it_184_t node_1571;
			 node_1571 = (jump_ex_it_184_t) (node_6);
			 {
			    node_t arg1755_1576;
			    obj_t arg1756_1577;
			    obj_t arg1758_1578;
			    arg1755_1576 = (((jump_ex_it_184_t) CREF(node_1571))->exit);
			    arg1756_1577 = get_new_kont_177_integrate_a();
			    {
			       node_t arg1759_1579;
			       obj_t arg1761_1580;
			       arg1759_1579 = (((jump_ex_it_184_t) CREF(node_1571))->value);
			       arg1761_1580 = get_new_kont_177_integrate_a();
			       arg1758_1578 = node_a_141_integrate_a(arg1759_1579, host_7, arg1761_1580, a_9);
			    }
			    {
			       obj_t a_2348;
			       obj_t k_2347;
			       node_t node_2346;
			       node_2346 = arg1755_1576;
			       k_2347 = arg1756_1577;
			       a_2348 = arg1758_1578;
			       a_9 = a_2348;
			       k_8 = k_2347;
			       node_6 = node_2346;
			       goto node_a_141_integrate_a;
			    }
			 }
		      }
		      break;
		   case ((long) 18):
		      {
			 make_box_202_t node_1581;
			 node_1581 = (make_box_202_t) (node_6);
			 {
			    node_t arg1762_1586;
			    obj_t arg1763_1587;
			    arg1762_1586 = (((make_box_202_t) CREF(node_1581))->value);
			    arg1763_1587 = get_new_kont_177_integrate_a();
			    {
			       obj_t k_2353;
			       node_t node_2352;
			       node_2352 = arg1762_1586;
			       k_2353 = arg1763_1587;
			       k_8 = k_2353;
			       node_6 = node_2352;
			       goto node_a_141_integrate_a;
			    }
			 }
		      }
		      break;
		   case ((long) 19):
		      {
			 box_set__221_t node_1588;
			 node_1588 = (box_set__221_t) (node_6);
			 {
			    node_t arg1764_1593;
			    obj_t arg1766_1594;
			    arg1764_1593 = (((box_set__221_t) CREF(node_1588))->value);
			    arg1766_1594 = get_new_kont_177_integrate_a();
			    {
			       obj_t k_2358;
			       node_t node_2357;
			       node_2357 = arg1764_1593;
			       k_2358 = arg1766_1594;
			       k_8 = k_2358;
			       node_6 = node_2357;
			       goto node_a_141_integrate_a;
			    }
			 }
		      }
		      break;
		   case ((long) 20):
		      return a_9;
		      break;
		   default:
		    case_else1599_80_1336:
		      if (PROCEDUREP(method1591_1332))
			{
			   return PROCEDURE_ENTRY(method1591_1332) (method1591_1332, (obj_t) (node_6), (obj_t) (host_7), k_8, a_9, BEOA);
			}
		      else
			{
			   obj_t fun1481_972;
			   fun1481_972 = PROCEDURE_REF(node_a_env_232_integrate_a, ((long) 0));
			   return PROCEDURE_ENTRY(fun1481_972) (fun1481_972, (obj_t) (node_6), (obj_t) (host_7), k_8, a_9, BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1599_80_1336;
	      }
	 }
      }
   }
}


obj_t 
_node_a_58_integrate_a(obj_t env_1873, obj_t node_1874, obj_t host_1875, obj_t k_1876, obj_t a_1877)
{
   return node_a_141_integrate_a((node_t) (node_1874), (variable_t) (host_1875), k_1876, a_1877);
}


obj_t 
imported_modules_init_94_integrate_a()
{
   module_initialization_70_tools_trace(((long) 0), "INTEGRATE_A");
   module_initialization_70_tools_shape(((long) 0), "INTEGRATE_A");
   module_initialization_70_tools_error(((long) 0), "INTEGRATE_A");
   module_initialization_70_type_type(((long) 0), "INTEGRATE_A");
   module_initialization_70_ast_var(((long) 0), "INTEGRATE_A");
   module_initialization_70_ast_node(((long) 0), "INTEGRATE_A");
   return module_initialization_70_integrate_info(((long) 0), "INTEGRATE_A");
}
