/*===========================================================================*/
/*   (Integrate/ctn.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_t;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_t;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_t;


extern obj_t __phi__105_integrate_a;
extern obj_t global_ast_var;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t trace_ctn_161_integrate_ctn();
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_integrate_ctn();
extern obj_t module_initialization_70_integrate_ctn(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_a(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t cnst_init_137_integrate_ctn();
static obj_t require_initialization_114_integrate_ctn = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_integrate_ctn();
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t __trace_port__84_tools_trace;
extern obj_t cn_ct__54_integrate_ctn(obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t _cn_ct__5_integrate_ctn(obj_t, obj_t);
static obj_t __cnst[3];

DEFINE_STRING(string1580_integrate_ctn, string1580_integrate_ctn1586, "INTEGRATE ESCAPE TAIL ", 22);
DEFINE_EXPORT_PROCEDURE(cn_ct__env_19_integrate_ctn, _cn_ct__5_integrate_ctn1587, _cn_ct__5_integrate_ctn, 0L, 1);
DEFINE_STRING(string1574_integrate_ctn, string1574_integrate_ctn1588, "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~", 32);
DEFINE_STRING(string1577_integrate_ctn, string1577_integrate_ctn1589, "   Ct        : ", 15);
DEFINE_STRING(string1575_integrate_ctn, string1575_integrate_ctn1590, "C: ", 3);
DEFINE_STRING(string1576_integrate_ctn, string1576_integrate_ctn1591, "   Cont      : ", 15);
DEFINE_STRING(string1578_integrate_ctn, string1578_integrate_ctn1592, "   Cn        : ", 15);
DEFINE_STRING(string1579_integrate_ctn, string1579_integrate_ctn1593, " --> ", 5);

obj_t 
module_initialization_70_integrate_ctn(long checksum_1405, char *from_1406)
{
   if (CBOOL(require_initialization_114_integrate_ctn))
     {
	require_initialization_114_integrate_ctn = BBOOL(((bool_t) 0));
	library_modules_init_112_integrate_ctn();
	cnst_init_137_integrate_ctn();
	imported_modules_init_94_integrate_ctn();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_integrate_ctn()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_CTN");
   module_initialization_70___object(((long) 0), "INTEGRATE_CTN");
   module_initialization_70___r4_output_6_10_3(((long) 0), "INTEGRATE_CTN");
   module_initialization_70___reader(((long) 0), "INTEGRATE_CTN");
   return BUNSPEC;
}


obj_t 
cnst_init_137_integrate_ctn()
{
   {
      obj_t cnst_port_138_1397;
      cnst_port_138_1397 = open_input_string(string1580_integrate_ctn);
      {
	 long i_1398;
	 i_1398 = ((long) 2);
       loop_1399:
	 {
	    bool_t test1581_1400;
	    test1581_1400 = (i_1398 == ((long) -1));
	    if (test1581_1400)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1582_1401;
		    {
		       obj_t list1583_1402;
		       {
			  obj_t arg1584_1403;
			  arg1584_1403 = BNIL;
			  list1583_1402 = MAKE_PAIR(cnst_port_138_1397, arg1584_1403);
		       }
		       arg1582_1401 = read___reader(list1583_1402);
		    }
		    CNST_TABLE_SET(i_1398, arg1582_1401);
		 }
		 {
		    int aux_1404;
		    {
		       long aux_1423;
		       aux_1423 = (i_1398 - ((long) 1));
		       aux_1404 = (int) (aux_1423);
		    }
		    {
		       long i_1426;
		       i_1426 = (long) (aux_1404);
		       i_1398 = i_1426;
		       goto loop_1399;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
cn_ct__54_integrate_ctn(obj_t a_1)
{
   {
      obj_t as_809;
      obj_t g_cn_224_810;
      as_809 = a_1;
      g_cn_224_810 = BNIL;
    loop_811:
      if (NULLP(as_809))
	{
	   trace_ctn_161_integrate_ctn();
	   return g_cn_224_810;
	}
      else
	{
	   obj_t a_814;
	   a_814 = CAR(as_809);
	   {
	      obj_t f_815;
	      f_815 = CAR(a_814);
	      {
		 obj_t g_816;
		 {
		    obj_t aux_1433;
		    aux_1433 = CDR(a_814);
		    g_816 = CAR(aux_1433);
		 }
		 {
		    obj_t k_817;
		    {
		       obj_t aux_1436;
		       {
			  obj_t aux_1437;
			  aux_1437 = CDR(a_814);
			  aux_1436 = CDR(aux_1437);
		       }
		       k_817 = CAR(aux_1436);
		    }
		    {
		       value_t fi_818;
		       {
			  variable_t obj_1267;
			  obj_1267 = (variable_t) (f_815);
			  fi_818 = (((variable_t) CREF(obj_1267))->value);
		       }
		       {
			  value_t gi_819;
			  {
			     variable_t obj_1268;
			     obj_1268 = (variable_t) (g_816);
			     gi_819 = (((variable_t) CREF(obj_1268))->value);
			  }
			  {
			     {
				bool_t test1333_820;
				test1333_820 = is_a__118___object(g_816, global_ast_var);
				if (test1333_820)
				  {
				     {
					obj_t as_1447;
					as_1447 = CDR(as_809);
					as_809 = as_1447;
					goto loop_811;
				     }
				  }
				else
				  {
				     bool_t test_1449;
				     {
					obj_t aux_1450;
					aux_1450 = CNST_TABLE_REF(((long) 0));
					test_1449 = (k_817 == aux_1450);
				     }
				     if (test_1449)
				       {
					  {
					     obj_t arg1337_823;
					     {
						obj_t aux_1453;
						{
						   sfun_iinfo_105_t obj_1273;
						   obj_1273 = (sfun_iinfo_105_t) (fi_818);
						   {
						      obj_t aux_1455;
						      {
							 object_t aux_1456;
							 aux_1456 = (object_t) (obj_1273);
							 aux_1455 = OBJECT_WIDENING(aux_1456);
						      }
						      aux_1453 = (((sfun_iinfo_105_t) CREF(aux_1455))->ct);
						   }
						}
						arg1337_823 = MAKE_PAIR(g_816, aux_1453);
					     }
					     {
						obj_t res1567_1278;
						{
						   sfun_iinfo_105_t obj_1276;
						   obj_1276 = (sfun_iinfo_105_t) (fi_818);
						   {
						      obj_t x_1390;
						      {
							 obj_t aux_1462;
							 {
							    object_t aux_1463;
							    aux_1463 = (object_t) (obj_1276);
							    aux_1462 = OBJECT_WIDENING(aux_1463);
							 }
							 x_1390 = ((((sfun_iinfo_105_t) CREF(aux_1462))->ct) = ((obj_t) arg1337_823), BUNSPEC);
						      }
						      res1567_1278 = BUNSPEC;
						   }
						}
						res1567_1278;
					     }
					  }
					  {
					     bool_t test_1467;
					     if ((f_815 == g_816))
					       {
						  test_1467 = ((bool_t) 0);
					       }
					     else
					       {
						  bool_t test_1470;
						  {
						     obj_t aux_1471;
						     {
							obj_t aux_1472;
							{
							   sfun_iinfo_105_t obj_1281;
							   obj_1281 = (sfun_iinfo_105_t) (fi_818);
							   {
							      obj_t aux_1474;
							      {
								 object_t aux_1475;
								 aux_1475 = (object_t) (obj_1281);
								 aux_1474 = OBJECT_WIDENING(aux_1475);
							      }
							      aux_1472 = (((sfun_iinfo_105_t) CREF(aux_1474))->kont);
							   }
							}
							aux_1471 = memq___r4_pairs_and_lists_6_3(g_816, aux_1472);
						     }
						     test_1470 = CBOOL(aux_1471);
						  }
						  if (test_1470)
						    {
						       test_1467 = ((bool_t) 0);
						    }
						  else
						    {
						       test_1467 = ((bool_t) 1);
						    }
					       }
					     if (test_1467)
					       {
						  obj_t arg1342_826;
						  {
						     obj_t aux_1481;
						     {
							sfun_iinfo_105_t obj_1282;
							obj_1282 = (sfun_iinfo_105_t) (fi_818);
							{
							   obj_t aux_1483;
							   {
							      object_t aux_1484;
							      aux_1484 = (object_t) (obj_1282);
							      aux_1483 = OBJECT_WIDENING(aux_1484);
							   }
							   aux_1481 = (((sfun_iinfo_105_t) CREF(aux_1483))->kont);
							}
						     }
						     arg1342_826 = MAKE_PAIR(g_816, aux_1481);
						  }
						  {
						     obj_t res1568_1287;
						     {
							sfun_iinfo_105_t obj_1285;
							obj_1285 = (sfun_iinfo_105_t) (fi_818);
							{
							   obj_t x_1391;
							   {
							      obj_t aux_1490;
							      {
								 object_t aux_1491;
								 aux_1491 = (object_t) (obj_1285);
								 aux_1490 = OBJECT_WIDENING(aux_1491);
							      }
							      x_1391 = ((((sfun_iinfo_105_t) CREF(aux_1490))->kont) = ((obj_t) arg1342_826), BUNSPEC);
							   }
							   res1568_1287 = BUNSPEC;
							}
						     }
						     res1568_1287;
						  }
					       }
					     else
					       {
						  BUNSPEC;
					       }
					  }
					  {
					     obj_t as_1495;
					     as_1495 = CDR(as_809);
					     as_809 = as_1495;
					     goto loop_811;
					  }
				       }
				     else
				       {
					  bool_t test_1497;
					  {
					     obj_t aux_1498;
					     aux_1498 = CNST_TABLE_REF(((long) 1));
					     test_1497 = (k_817 == aux_1498);
					  }
					  if (test_1497)
					    {
					       {
						  bool_t test_1501;
						  {
						     obj_t aux_1502;
						     {
							obj_t aux_1503;
							{
							   sfun_iinfo_105_t obj_1291;
							   obj_1291 = (sfun_iinfo_105_t) (fi_818);
							   {
							      obj_t aux_1505;
							      {
								 object_t aux_1506;
								 aux_1506 = (object_t) (obj_1291);
								 aux_1505 = OBJECT_WIDENING(aux_1506);
							      }
							      aux_1503 = (((sfun_iinfo_105_t) CREF(aux_1505))->kont);
							   }
							}
							aux_1502 = memq___r4_pairs_and_lists_6_3(g_816, aux_1503);
						     }
						     test_1501 = CBOOL(aux_1502);
						  }
						  if (test_1501)
						    {
						       BUNSPEC;
						    }
						  else
						    {
						       obj_t arg1350_834;
						       {
							  obj_t aux_1512;
							  {
							     sfun_iinfo_105_t obj_1292;
							     obj_1292 = (sfun_iinfo_105_t) (fi_818);
							     {
								obj_t aux_1514;
								{
								   object_t aux_1515;
								   aux_1515 = (object_t) (obj_1292);
								   aux_1514 = OBJECT_WIDENING(aux_1515);
								}
								aux_1512 = (((sfun_iinfo_105_t) CREF(aux_1514))->kont);
							     }
							  }
							  arg1350_834 = MAKE_PAIR(g_816, aux_1512);
						       }
						       {
							  obj_t res1569_1297;
							  {
							     sfun_iinfo_105_t obj_1295;
							     obj_1295 = (sfun_iinfo_105_t) (fi_818);
							     {
								obj_t x_1392;
								{
								   obj_t aux_1521;
								   {
								      object_t aux_1522;
								      aux_1522 = (object_t) (obj_1295);
								      aux_1521 = OBJECT_WIDENING(aux_1522);
								   }
								   x_1392 = ((((sfun_iinfo_105_t) CREF(aux_1521))->kont) = ((obj_t) arg1350_834), BUNSPEC);
								}
								res1569_1297 = BUNSPEC;
							     }
							  }
							  res1569_1297;
						       }
						    }
					       }
					       {
						  obj_t as_1526;
						  as_1526 = CDR(as_809);
						  as_809 = as_1526;
						  goto loop_811;
					       }
					    }
					  else
					    {
					       bool_t test_1528;
					       {
						  sfun_iinfo_105_t obj_1299;
						  obj_1299 = (sfun_iinfo_105_t) (gi_819);
						  {
						     obj_t aux_1530;
						     {
							obj_t aux_1531;
							{
							   object_t aux_1532;
							   aux_1532 = (object_t) (obj_1299);
							   aux_1531 = OBJECT_WIDENING(aux_1532);
							}
							aux_1530 = (((sfun_iinfo_105_t) CREF(aux_1531))->u);
						     }
						     test_1528 = CBOOL(aux_1530);
						  }
					       }
					       if (test_1528)
						 {
						    {
						       obj_t arg1357_839;
						       {
							  obj_t aux_1537;
							  {
							     sfun_iinfo_105_t obj_1300;
							     obj_1300 = (sfun_iinfo_105_t) (fi_818);
							     {
								obj_t aux_1539;
								{
								   object_t aux_1540;
								   aux_1540 = (object_t) (obj_1300);
								   aux_1539 = OBJECT_WIDENING(aux_1540);
								}
								aux_1537 = (((sfun_iinfo_105_t) CREF(aux_1539))->ct);
							     }
							  }
							  arg1357_839 = MAKE_PAIR(g_816, aux_1537);
						       }
						       {
							  obj_t res1570_1305;
							  {
							     sfun_iinfo_105_t obj_1303;
							     obj_1303 = (sfun_iinfo_105_t) (fi_818);
							     {
								obj_t x_1393;
								{
								   obj_t aux_1546;
								   {
								      object_t aux_1547;
								      aux_1547 = (object_t) (obj_1303);
								      aux_1546 = OBJECT_WIDENING(aux_1547);
								   }
								   x_1393 = ((((sfun_iinfo_105_t) CREF(aux_1546))->ct) = ((obj_t) arg1357_839), BUNSPEC);
								}
								res1570_1305 = BUNSPEC;
							     }
							  }
							  res1570_1305;
						       }
						    }
						    {
						       bool_t test_1551;
						       {
							  obj_t aux_1552;
							  {
							     obj_t aux_1553;
							     {
								sfun_iinfo_105_t obj_1306;
								obj_1306 = (sfun_iinfo_105_t) (fi_818);
								{
								   obj_t aux_1555;
								   {
								      object_t aux_1556;
								      aux_1556 = (object_t) (obj_1306);
								      aux_1555 = OBJECT_WIDENING(aux_1556);
								   }
								   aux_1553 = (((sfun_iinfo_105_t) CREF(aux_1555))->kont);
								}
							     }
							     aux_1552 = memq___r4_pairs_and_lists_6_3(g_816, aux_1553);
							  }
							  test_1551 = CBOOL(aux_1552);
						       }
						       if (test_1551)
							 {
							    BUNSPEC;
							 }
						       else
							 {
							    obj_t arg1361_842;
							    {
							       obj_t aux_1562;
							       {
								  sfun_iinfo_105_t obj_1307;
								  obj_1307 = (sfun_iinfo_105_t) (fi_818);
								  {
								     obj_t aux_1564;
								     {
									object_t aux_1565;
									aux_1565 = (object_t) (obj_1307);
									aux_1564 = OBJECT_WIDENING(aux_1565);
								     }
								     aux_1562 = (((sfun_iinfo_105_t) CREF(aux_1564))->kont);
								  }
							       }
							       arg1361_842 = MAKE_PAIR(g_816, aux_1562);
							    }
							    {
							       obj_t res1571_1312;
							       {
								  sfun_iinfo_105_t obj_1310;
								  obj_1310 = (sfun_iinfo_105_t) (fi_818);
								  {
								     obj_t x_1394;
								     {
									obj_t aux_1571;
									{
									   object_t aux_1572;
									   aux_1572 = (object_t) (obj_1310);
									   aux_1571 = OBJECT_WIDENING(aux_1572);
									}
									x_1394 = ((((sfun_iinfo_105_t) CREF(aux_1571))->kont) = ((obj_t) arg1361_842), BUNSPEC);
								     }
								     res1571_1312 = BUNSPEC;
								  }
							       }
							       res1571_1312;
							    }
							 }
						    }
						    {
						       obj_t as_1576;
						       as_1576 = CDR(as_809);
						       as_809 = as_1576;
						       goto loop_811;
						    }
						 }
					       else
						 {
						    {
						       obj_t arg1367_846;
						       {
							  obj_t aux_1578;
							  {
							     sfun_iinfo_105_t obj_1314;
							     obj_1314 = (sfun_iinfo_105_t) (fi_818);
							     {
								obj_t aux_1580;
								{
								   object_t aux_1581;
								   aux_1581 = (object_t) (obj_1314);
								   aux_1580 = OBJECT_WIDENING(aux_1581);
								}
								aux_1578 = (((sfun_iinfo_105_t) CREF(aux_1580))->cn);
							     }
							  }
							  arg1367_846 = MAKE_PAIR(g_816, aux_1578);
						       }
						       {
							  obj_t res1572_1319;
							  {
							     sfun_iinfo_105_t obj_1317;
							     obj_1317 = (sfun_iinfo_105_t) (fi_818);
							     {
								obj_t x_1395;
								{
								   obj_t aux_1587;
								   {
								      object_t aux_1588;
								      aux_1588 = (object_t) (obj_1317);
								      aux_1587 = OBJECT_WIDENING(aux_1588);
								   }
								   x_1395 = ((((sfun_iinfo_105_t) CREF(aux_1587))->cn) = ((obj_t) arg1367_846), BUNSPEC);
								}
								res1572_1319 = BUNSPEC;
							     }
							  }
							  res1572_1319;
						       }
						    }
						    {
						       bool_t test_1592;
						       {
							  sfun_iinfo_105_t obj_1320;
							  obj_1320 = (sfun_iinfo_105_t) (gi_819);
							  {
							     obj_t aux_1594;
							     {
								object_t aux_1595;
								aux_1595 = (object_t) (obj_1320);
								aux_1594 = OBJECT_WIDENING(aux_1595);
							     }
							     test_1592 = (((sfun_iinfo_105_t) CREF(aux_1594))->g__219);
							  }
						       }
						       if (test_1592)
							 {
							    obj_t as_1599;
							    as_1599 = CDR(as_809);
							    as_809 = as_1599;
							    goto loop_811;
							 }
						       else
							 {
							    {
							       obj_t res1573_1324;
							       {
								  sfun_iinfo_105_t obj_1322;
								  obj_1322 = (sfun_iinfo_105_t) (gi_819);
								  {
								     obj_t x_1396;
								     {
									obj_t aux_1602;
									{
									   object_t aux_1603;
									   aux_1603 = (object_t) (obj_1322);
									   aux_1602 = OBJECT_WIDENING(aux_1603);
									}
									x_1396 = ((((sfun_iinfo_105_t) CREF(aux_1602))->g__219) = ((bool_t) ((bool_t) 1)), BUNSPEC);
								     }
								     res1573_1324 = BUNSPEC;
								  }
							       }
							       res1573_1324;
							    }
							    {
							       obj_t arg1376_850;
							       obj_t arg1379_851;
							       arg1376_850 = CDR(as_809);
							       arg1379_851 = MAKE_PAIR(g_816, g_cn_224_810);
							       {
								  obj_t g_cn_224_1610;
								  obj_t as_1609;
								  as_1609 = arg1376_850;
								  g_cn_224_1610 = arg1379_851;
								  g_cn_224_810 = g_cn_224_1610;
								  as_809 = as_1609;
								  goto loop_811;
							       }
							    }
							 }
						    }
						 }
					    }
				       }
				  }
			     }
			  }
		       }
		    }
		 }
	      }
	   }
	}
   }
}


obj_t 
_cn_ct__5_integrate_ctn(obj_t env_1388, obj_t a_1389)
{
   return cn_ct__54_integrate_ctn(a_1389);
}


obj_t 
trace_ctn_161_integrate_ctn()
{
   {
      bool_t test1382_854;
      {
	 obj_t aux_1612;
	 aux_1612 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 2)), BINT(((long) 2)));
	 test1382_854 = CBOOL(aux_1612);
      }
      if (test1382_854)
	{
	   char *arg1385_855;
	   {
	      obj_t list1391_859;
	      list1391_859 = MAKE_PAIR(string1574_integrate_ctn, BNIL);
	      fprint___r4_output_6_10_3(__trace_port__84_tools_trace, list1391_859);
	   }
	   {
	      obj_t list1399_862;
	      {
		 obj_t arg1402_864;
		 {
		    obj_t aux_1620;
		    aux_1620 = BCHAR(((unsigned char) '\n'));
		    arg1402_864 = MAKE_PAIR(aux_1620, BNIL);
		 }
		 list1399_862 = MAKE_PAIR(string1575_integrate_ctn, arg1402_864);
	      }
	      fprint___r4_output_6_10_3(__trace_port__84_tools_trace, list1399_862);
	   }
	   {
	      obj_t l1329_866;
	      l1329_866 = __phi__105_integrate_a;
	    lname1330_867:
	      if (PAIRP(l1329_866))
		{
		   {
		      obj_t p_869;
		      p_869 = CAR(l1329_866);
		      {
			 value_t ifun_870;
			 {
			    variable_t obj_1330;
			    obj_1330 = (variable_t) (p_869);
			    ifun_870 = (((variable_t) CREF(obj_1330))->value);
			 }
			 {
			    obj_t arg1408_872;
			    obj_t arg1411_874;
			    obj_t arg1414_876;
			    obj_t arg1416_878;
			    arg1408_872 = shape_tools_shape(p_869);
			    {
			       obj_t aux_1631;
			       {
				  sfun_iinfo_105_t obj_1331;
				  obj_1331 = (sfun_iinfo_105_t) (ifun_870);
				  {
				     obj_t aux_1633;
				     {
					object_t aux_1634;
					aux_1634 = (object_t) (obj_1331);
					aux_1633 = OBJECT_WIDENING(aux_1634);
				     }
				     aux_1631 = (((sfun_iinfo_105_t) CREF(aux_1633))->cn);
				  }
			       }
			       arg1411_874 = shape_tools_shape(aux_1631);
			    }
			    {
			       obj_t aux_1639;
			       {
				  sfun_iinfo_105_t obj_1332;
				  obj_1332 = (sfun_iinfo_105_t) (ifun_870);
				  {
				     obj_t aux_1641;
				     {
					object_t aux_1642;
					aux_1642 = (object_t) (obj_1332);
					aux_1641 = OBJECT_WIDENING(aux_1642);
				     }
				     aux_1639 = (((sfun_iinfo_105_t) CREF(aux_1641))->ct);
				  }
			       }
			       arg1414_876 = shape_tools_shape(aux_1639);
			    }
			    {
			       obj_t aux_1647;
			       {
				  sfun_iinfo_105_t obj_1333;
				  obj_1333 = (sfun_iinfo_105_t) (ifun_870);
				  {
				     obj_t aux_1649;
				     {
					object_t aux_1650;
					aux_1650 = (object_t) (obj_1333);
					aux_1649 = OBJECT_WIDENING(aux_1650);
				     }
				     aux_1647 = (((sfun_iinfo_105_t) CREF(aux_1649))->kont);
				  }
			       }
			       arg1416_878 = shape_tools_shape(aux_1647);
			    }
			    {
			       obj_t list1417_879;
			       {
				  obj_t arg1418_880;
				  {
				     obj_t arg1420_881;
				     {
					obj_t arg1421_882;
					{
					   obj_t arg1424_883;
					   {
					      obj_t arg1426_884;
					      {
						 obj_t arg1427_885;
						 {
						    obj_t arg1428_886;
						    {
						       obj_t arg1431_887;
						       {
							  obj_t arg1432_888;
							  {
							     obj_t arg1440_889;
							     {
								obj_t arg1441_890;
								arg1441_890 = MAKE_PAIR(arg1416_878, BNIL);
								arg1440_889 = MAKE_PAIR(string1576_integrate_ctn, arg1441_890);
							     }
							     {
								obj_t aux_1657;
								aux_1657 = BCHAR(((unsigned char) '\n'));
								arg1432_888 = MAKE_PAIR(aux_1657, arg1440_889);
							     }
							  }
							  arg1431_887 = MAKE_PAIR(arg1414_876, arg1432_888);
						       }
						       arg1428_886 = MAKE_PAIR(string1577_integrate_ctn, arg1431_887);
						    }
						    {
						       obj_t aux_1662;
						       aux_1662 = BCHAR(((unsigned char) '\n'));
						       arg1427_885 = MAKE_PAIR(aux_1662, arg1428_886);
						    }
						 }
						 arg1426_884 = MAKE_PAIR(arg1411_874, arg1427_885);
					      }
					      arg1424_883 = MAKE_PAIR(string1578_integrate_ctn, arg1426_884);
					   }
					   {
					      obj_t aux_1667;
					      aux_1667 = BCHAR(((unsigned char) '\n'));
					      arg1421_882 = MAKE_PAIR(aux_1667, arg1424_883);
					   }
					}
					{
					   obj_t aux_1670;
					   aux_1670 = BCHAR(((unsigned char) ':'));
					   arg1420_881 = MAKE_PAIR(aux_1670, arg1421_882);
					}
				     }
				     arg1418_880 = MAKE_PAIR(arg1408_872, arg1420_881);
				  }
				  list1417_879 = MAKE_PAIR(string1579_integrate_ctn, arg1418_880);
			       }
			       fprint___r4_output_6_10_3(__trace_port__84_tools_trace, list1417_879);
			    }
			 }
		      }
		   }
		   {
		      obj_t l1329_1676;
		      l1329_1676 = CDR(l1329_866);
		      l1329_866 = l1329_1676;
		      goto lname1330_867;
		   }
		}
	      else
		{
		   ((bool_t) 1);
		}
	   }
	   arg1385_855 = "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~";
	   {
	      obj_t list1386_856;
	      {
		 obj_t arg1388_857;
		 {
		    obj_t aux_1678;
		    aux_1678 = BCHAR(((unsigned char) '\n'));
		    arg1388_857 = MAKE_PAIR(aux_1678, BNIL);
		 }
		 {
		    obj_t aux_1681;
		    aux_1681 = string_to_bstring(arg1385_855);
		    list1386_856 = MAKE_PAIR(aux_1681, arg1388_857);
		 }
	      }
	      return print_trace_107_tools_trace(list1386_856);
	   }
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
imported_modules_init_94_integrate_ctn()
{
   module_initialization_70_tools_trace(((long) 0), "INTEGRATE_CTN");
   module_initialization_70_tools_shape(((long) 0), "INTEGRATE_CTN");
   module_initialization_70_type_type(((long) 0), "INTEGRATE_CTN");
   module_initialization_70_ast_var(((long) 0), "INTEGRATE_CTN");
   module_initialization_70_ast_node(((long) 0), "INTEGRATE_CTN");
   module_initialization_70_integrate_info(((long) 0), "INTEGRATE_CTN");
   return module_initialization_70_integrate_a(((long) 0), "INTEGRATE_CTN");
}
