/*===========================================================================*/
/*   (Integrate/cto.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_t;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_t;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_t;


extern obj_t let_fun_218_ast_node;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t closure_ast_node;
static obj_t _set_cto__default1353_229_integrate_cto(obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_integrate_cto();
extern obj_t module_initialization_70_integrate_cto(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_integrate_cto();
static obj_t cnst_init_137_integrate_cto();
extern obj_t _set_cto__169_integrate_cto(obj_t, obj_t, obj_t);
static obj_t require_initialization_114_integrate_cto = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_integrate_cto();
extern obj_t set_cto__5_integrate_cto(node_t, local_t);
extern obj_t cast_ast_node;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
static obj_t set_cto__default1353_99_integrate_cto(node_t, local_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t local_ast_var;
extern obj_t kwote_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t app_ast_node;
static obj_t __cnst[2];

DEFINE_STATIC_PROCEDURE(set_cto__default1353_env_184_integrate_cto, _set_cto__default1353_229_integrate_cto1675, _set_cto__default1353_229_integrate_cto, 0L, 2);
DEFINE_STRING(string1669_integrate_cto, string1669_integrate_cto1676, "INTEGRATE SET-CTO!-DEFAULT1353 ", 31);
DEFINE_STRING(string1660_integrate_cto, string1660_integrate_cto1677, "No method for this object", 25);
DEFINE_STRING(string1668_integrate_cto, string1668_integrate_cto1678, ">>> set-cto!(", 13);
DEFINE_STRING(string1663_integrate_cto, string1663_integrate_cto1679, "  memq: ", 8);
DEFINE_STRING(string1666_integrate_cto, string1666_integrate_cto1680, "         ", 9);
DEFINE_STRING(string1667_integrate_cto, string1667_integrate_cto1681, "): ", 3);
DEFINE_STRING(string1662_integrate_cto, string1662_integrate_cto1682, "Unexpected closure", 18);
DEFINE_STRING(string1664_integrate_cto, string1664_integrate_cto1683, " ", 1);
DEFINE_EXPORT_GENERIC(set_cto__env_185_integrate_cto, _set_cto__169_integrate_cto1684, _set_cto__169_integrate_cto, 0L, 2);
DEFINE_STRING(string1665_integrate_cto, string1665_integrate_cto1685, "  Iinfo?: ", 10);
DEFINE_STRING(string1661_integrate_cto, string1661_integrate_cto1686, "set-cto!", 8);

obj_t 
module_initialization_70_integrate_cto(long checksum_1589, char *from_1590)
{
   if (CBOOL(require_initialization_114_integrate_cto))
     {
	require_initialization_114_integrate_cto = BBOOL(((bool_t) 0));
	library_modules_init_112_integrate_cto();
	cnst_init_137_integrate_cto();
	imported_modules_init_94_integrate_cto();
	toplevel_init_63_integrate_cto();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_integrate_cto()
{
   module_initialization_70___object(((long) 0), "INTEGRATE_CTO");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_CTO");
   module_initialization_70___reader(((long) 0), "INTEGRATE_CTO");
   return BUNSPEC;
}


obj_t 
cnst_init_137_integrate_cto()
{
   {
      obj_t cnst_port_138_1581;
      cnst_port_138_1581 = open_input_string(string1669_integrate_cto);
      {
	 long i_1582;
	 i_1582 = ((long) 1);
       loop_1583:
	 {
	    bool_t test1670_1584;
	    test1670_1584 = (i_1582 == ((long) -1));
	    if (test1670_1584)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1671_1585;
		    {
		       obj_t list1672_1586;
		       {
			  obj_t arg1673_1587;
			  arg1673_1587 = BNIL;
			  list1672_1586 = MAKE_PAIR(cnst_port_138_1581, arg1673_1587);
		       }
		       arg1671_1585 = read___reader(list1672_1586);
		    }
		    CNST_TABLE_SET(i_1582, arg1671_1585);
		 }
		 {
		    int aux_1588;
		    {
		       long aux_1607;
		       aux_1607 = (i_1582 - ((long) 1));
		       aux_1588 = (int) (aux_1607);
		    }
		    {
		       long i_1610;
		       i_1610 = (long) (aux_1588);
		       i_1582 = i_1610;
		       goto loop_1583;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_integrate_cto()
{
   add_generic__110___object(set_cto__env_185_integrate_cto, set_cto__default1353_env_184_integrate_cto);
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, var_ast_node, ((long) 2));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, app_ast_node, ((long) 5));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, app_ly_162_ast_node, ((long) 6));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, funcall_ast_node, ((long) 7));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, pragma_ast_node, ((long) 8));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, cast_ast_node, ((long) 9));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, setq_ast_node, ((long) 10));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, conditional_ast_node, ((long) 11));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, fail_ast_node, ((long) 12));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, select_ast_node, ((long) 13));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, let_fun_218_ast_node, ((long) 14));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, let_var_6_ast_node, ((long) 15));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, set_ex_it_116_ast_node, ((long) 16));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, jump_ex_it_184_ast_node, ((long) 17));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, make_box_202_ast_node, ((long) 18));
   add_inlined_method__244___object(set_cto__env_185_integrate_cto, box_set__221_ast_node, ((long) 19));
   {
      long aux_1633;
      aux_1633 = add_inlined_method__244___object(set_cto__env_185_integrate_cto, box_ref_242_ast_node, ((long) 20));
      return BINT(aux_1633);
   }
}


obj_t 
set_cto__default1353_99_integrate_cto(node_t node_3, local_t local_4)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1660_integrate_cto, (obj_t) (node_3));
}


obj_t 
_set_cto__default1353_229_integrate_cto(obj_t env_1577, obj_t node_1578, obj_t local_1579)
{
   return set_cto__default1353_99_integrate_cto((node_t) (node_1578), (local_t) (local_1579));
}


obj_t 
set_cto__5_integrate_cto(node_t node_1, local_t local_2)
{
 set_cto__5_integrate_cto:
   {
      obj_t method1514_1216;
      obj_t class1519_1217;
      {
	 obj_t arg1522_1214;
	 obj_t arg1523_1215;
	 {
	    object_t obj_1414;
	    obj_1414 = (object_t) (node_1);
	    {
	       obj_t pre_method_105_1415;
	       pre_method_105_1415 = PROCEDURE_REF(set_cto__env_185_integrate_cto, ((long) 2));
	       if (INTEGERP(pre_method_105_1415))
		 {
		    PROCEDURE_SET(set_cto__env_185_integrate_cto, ((long) 2), BUNSPEC);
		    arg1522_1214 = pre_method_105_1415;
		 }
	       else
		 {
		    long obj_class_num_177_1420;
		    obj_class_num_177_1420 = TYPE(obj_1414);
		    {
		       obj_t arg1183_1421;
		       arg1183_1421 = PROCEDURE_REF(set_cto__env_185_integrate_cto, ((long) 1));
		       {
			  long arg1184_1425;
			  {
			     long arg1186_1426;
			     arg1186_1426 = OBJECT_TYPE;
			     arg1184_1425 = (obj_class_num_177_1420 - arg1186_1426);
			  }
			  arg1522_1214 = VECTOR_REF(arg1183_1421, arg1184_1425);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1431;
	    object_1431 = (object_t) (node_1);
	    {
	       long arg1187_1432;
	       {
		  long arg1188_1433;
		  long arg1189_1434;
		  arg1188_1433 = TYPE(object_1431);
		  arg1189_1434 = OBJECT_TYPE;
		  arg1187_1432 = (arg1188_1433 - arg1189_1434);
	       }
	       {
		  obj_t vector_1438;
		  vector_1438 = __classes__134___object;
		  arg1523_1215 = VECTOR_REF(vector_1438, arg1187_1432);
	       }
	    }
	 }
	 method1514_1216 = arg1522_1214;
	 class1519_1217 = arg1523_1215;
	 {
	    if (INTEGERP(method1514_1216))
	      {
		 switch ((long) CINT(method1514_1216))
		   {
		   case ((long) 0):
		      return BUNSPEC;
		      break;
		   case ((long) 1):
		      return BUNSPEC;
		      break;
		   case ((long) 2):
		      return BUNSPEC;
		      break;
		   case ((long) 3):
		      {
			 obj_t arg1531_1233;
			 {
			    obj_t aux_1659;
			    {
			       closure_t aux_1660;
			       aux_1660 = (closure_t) (node_1);
			       aux_1659 = (obj_t) (aux_1660);
			    }
			    arg1531_1233 = shape_tools_shape(aux_1659);
			 }
			 return internal_error_43_tools_error(string1661_integrate_cto, string1662_integrate_cto, arg1531_1233);
		      }
		      break;
		   case ((long) 4):
		      {
			 sequence_t node_1234;
			 node_1234 = (sequence_t) (node_1);
			 {
			    obj_t l1330_1237;
			    {
			       bool_t aux_1666;
			       l1330_1237 = (((sequence_t) CREF(node_1234))->nodes);
			     lname1333_1238:
			       if (PAIRP(l1330_1237))
				 {
				    {
				       node_t aux_1669;
				       {
					  obj_t aux_1670;
					  aux_1670 = CAR(l1330_1237);
					  aux_1669 = (node_t) (aux_1670);
				       }
				       set_cto__5_integrate_cto(aux_1669, local_2);
				    }
				    {
				       obj_t l1330_1674;
				       l1330_1674 = CDR(l1330_1237);
				       l1330_1237 = l1330_1674;
				       goto lname1333_1238;
				    }
				 }
			       else
				 {
				    aux_1666 = ((bool_t) 1);
				 }
			       return BBOOL(aux_1666);
			    }
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 app_t node_1243;
			 node_1243 = (app_t) (node_1);
			 {
			    variable_t fun_1246;
			    {
			       var_t arg1587_1291;
			       arg1587_1291 = (((app_t) CREF(node_1243))->fun);
			       fun_1246 = (((var_t) CREF(arg1587_1291))->variable);
			    }
			    {
			       bool_t test1535_1247;
			       {
				  bool_t test1572_1277;
				  test1572_1277 = is_a__118___object((obj_t) (fun_1246), local_ast_var);
				  if (test1572_1277)
				    {
				       bool_t test_1684;
				       {
					  obj_t aux_1687;
					  obj_t aux_1685;
					  aux_1687 = (obj_t) (fun_1246);
					  aux_1685 = (obj_t) (local_2);
					  test_1684 = (aux_1685 == aux_1687);
				       }
				       if (test_1684)
					 {
					    test1535_1247 = ((bool_t) 0);
					 }
				       else
					 {
					    test1535_1247 = ((bool_t) 1);
					 }
				    }
				  else
				    {
				       test1535_1247 = ((bool_t) 0);
				    }
			       }
			       if (test1535_1247)
				 {
				    bool_t test1536_1248;
				    {
				       obj_t aux_1691;
				       aux_1691 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 4)));
				       test1536_1248 = CBOOL(aux_1691);
				    }
				    if (test1536_1248)
				      {
					 obj_t arg1538_1250;
					 obj_t arg1540_1252;
					 bool_t arg1543_1255;
					 obj_t arg1550_1258;
					 arg1538_1250 = shape_tools_shape((obj_t) (local_2));
					 arg1540_1252 = shape_tools_shape((obj_t) (node_1243));
					 {
					    sfun_iinfo_105_t obj_1450;
					    {
					       value_t aux_1701;
					       {
						  local_t obj_1449;
						  obj_1449 = (local_t) (fun_1246);
						  aux_1701 = (((local_t) CREF(obj_1449))->value);
					       }
					       obj_1450 = (sfun_iinfo_105_t) (aux_1701);
					    }
					    {
					       obj_t aux_1705;
					       {
						  object_t aux_1706;
						  aux_1706 = (object_t) (obj_1450);
						  aux_1705 = OBJECT_WIDENING(aux_1706);
					       }
					       arg1543_1255 = (((sfun_iinfo_105_t) CREF(aux_1705))->g__219);
					    }
					 }
					 {
					    obj_t aux_1710;
					    {
					       sfun_iinfo_105_t obj_1452;
					       {
						  value_t aux_1712;
						  aux_1712 = (((local_t) CREF(local_2))->value);
						  obj_1452 = (sfun_iinfo_105_t) (aux_1712);
					       }
					       {
						  obj_t aux_1715;
						  {
						     object_t aux_1716;
						     aux_1716 = (object_t) (obj_1452);
						     aux_1715 = OBJECT_WIDENING(aux_1716);
						  }
						  aux_1710 = (((sfun_iinfo_105_t) CREF(aux_1715))->cto);
					       }
					    }
					    arg1550_1258 = memq___r4_pairs_and_lists_6_3((obj_t) (fun_1246), aux_1710);
					 }
					 {
					    obj_t list1551_1259;
					    {
					       obj_t arg1552_1260;
					       {
						  obj_t arg1553_1261;
						  {
						     obj_t arg1554_1262;
						     {
							obj_t arg1555_1263;
							{
							   obj_t arg1557_1264;
							   {
							      obj_t arg1559_1265;
							      {
								 obj_t arg1560_1266;
								 {
								    obj_t arg1561_1267;
								    {
								       obj_t arg1562_1268;
								       {
									  obj_t arg1563_1269;
									  {
									     obj_t arg1564_1270;
									     {
										obj_t aux_1721;
										aux_1721 = BCHAR(((unsigned char) '\n'));
										arg1564_1270 = MAKE_PAIR(aux_1721, BNIL);
									     }
									     arg1563_1269 = MAKE_PAIR(arg1550_1258, arg1564_1270);
									  }
									  arg1562_1268 = MAKE_PAIR(string1663_integrate_cto, arg1563_1269);
								       }
								       arg1561_1267 = MAKE_PAIR(string1664_integrate_cto, arg1562_1268);
								    }
								    {
								       obj_t aux_1727;
								       aux_1727 = BBOOL(arg1543_1255);
								       arg1560_1266 = MAKE_PAIR(aux_1727, arg1561_1267);
								    }
								 }
								 arg1559_1265 = MAKE_PAIR(string1665_integrate_cto, arg1560_1266);
							      }
							      arg1557_1264 = MAKE_PAIR(string1666_integrate_cto, arg1559_1265);
							   }
							   {
							      obj_t aux_1732;
							      aux_1732 = BCHAR(((unsigned char) '\n'));
							      arg1555_1263 = MAKE_PAIR(aux_1732, arg1557_1264);
							   }
							}
							arg1554_1262 = MAKE_PAIR(arg1540_1252, arg1555_1263);
						     }
						     arg1553_1261 = MAKE_PAIR(string1667_integrate_cto, arg1554_1262);
						  }
						  arg1552_1260 = MAKE_PAIR(arg1538_1250, arg1553_1261);
					       }
					       list1551_1259 = MAKE_PAIR(string1668_integrate_cto, arg1552_1260);
					    }
					    print_trace_107_tools_trace(list1551_1259);
					 }
				      }
				    else
				      {
					 BUNSPEC;
				      }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       bool_t test1574_1279;
			       {
				  bool_t test1579_1284;
				  test1579_1284 = is_a__118___object((obj_t) (fun_1246), local_ast_var);
				  if (test1579_1284)
				    {
				       bool_t test_1743;
				       {
					  sfun_iinfo_105_t obj_1455;
					  {
					     value_t aux_1744;
					     {
						local_t obj_1454;
						obj_1454 = (local_t) (fun_1246);
						aux_1744 = (((local_t) CREF(obj_1454))->value);
					     }
					     obj_1455 = (sfun_iinfo_105_t) (aux_1744);
					  }
					  {
					     obj_t aux_1748;
					     {
						object_t aux_1749;
						aux_1749 = (object_t) (obj_1455);
						aux_1748 = OBJECT_WIDENING(aux_1749);
					     }
					     test_1743 = (((sfun_iinfo_105_t) CREF(aux_1748))->g__219);
					  }
				       }
				       if (test_1743)
					 {
					    bool_t test_1753;
					    {
					       obj_t aux_1756;
					       obj_t aux_1754;
					       aux_1756 = (obj_t) (fun_1246);
					       aux_1754 = (obj_t) (local_2);
					       test_1753 = (aux_1754 == aux_1756);
					    }
					    if (test_1753)
					      {
						 test1574_1279 = ((bool_t) 0);
					      }
					    else
					      {
						 bool_t test_1759;
						 {
						    obj_t aux_1760;
						    {
						       obj_t aux_1761;
						       {
							  sfun_iinfo_105_t obj_1459;
							  {
							     value_t aux_1763;
							     aux_1763 = (((local_t) CREF(local_2))->value);
							     obj_1459 = (sfun_iinfo_105_t) (aux_1763);
							  }
							  {
							     obj_t aux_1766;
							     {
								object_t aux_1767;
								aux_1767 = (object_t) (obj_1459);
								aux_1766 = OBJECT_WIDENING(aux_1767);
							     }
							     aux_1761 = (((sfun_iinfo_105_t) CREF(aux_1766))->cto);
							  }
						       }
						       aux_1760 = memq___r4_pairs_and_lists_6_3((obj_t) (fun_1246), aux_1761);
						    }
						    test_1759 = CBOOL(aux_1760);
						 }
						 if (test_1759)
						   {
						      test1574_1279 = ((bool_t) 0);
						   }
						 else
						   {
						      test1574_1279 = ((bool_t) 1);
						   }
					      }
					 }
				       else
					 {
					    test1574_1279 = ((bool_t) 0);
					 }
				    }
				  else
				    {
				       test1574_1279 = ((bool_t) 0);
				    }
			       }
			       if (test1574_1279)
				 {
				    value_t arg1575_1280;
				    obj_t arg1576_1281;
				    arg1575_1280 = (((local_t) CREF(local_2))->value);
				    {
				       obj_t aux_1777;
				       obj_t aux_1775;
				       {
					  sfun_iinfo_105_t obj_1462;
					  {
					     value_t aux_1778;
					     aux_1778 = (((local_t) CREF(local_2))->value);
					     obj_1462 = (sfun_iinfo_105_t) (aux_1778);
					  }
					  {
					     obj_t aux_1781;
					     {
						object_t aux_1782;
						aux_1782 = (object_t) (obj_1462);
						aux_1781 = OBJECT_WIDENING(aux_1782);
					     }
					     aux_1777 = (((sfun_iinfo_105_t) CREF(aux_1781))->cto);
					  }
				       }
				       aux_1775 = (obj_t) (fun_1246);
				       arg1576_1281 = MAKE_PAIR(aux_1775, aux_1777);
				    }
				    {
				       obj_t res1658_1467;
				       {
					  sfun_iinfo_105_t obj_1465;
					  obj_1465 = (sfun_iinfo_105_t) (arg1575_1280);
					  {
					     obj_t x_1580;
					     {
						obj_t aux_1788;
						{
						   object_t aux_1789;
						   aux_1789 = (object_t) (obj_1465);
						   aux_1788 = OBJECT_WIDENING(aux_1789);
						}
						x_1580 = ((((sfun_iinfo_105_t) CREF(aux_1788))->cto) = ((obj_t) arg1576_1281), BUNSPEC);
					     }
					     res1658_1467 = BUNSPEC;
					  }
				       }
				       res1658_1467;
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			 }
			 {
			    obj_t asts_1292;
			    asts_1292 = (((app_t) CREF(node_1243))->args);
			  liip_1293:
			    if (NULLP(asts_1292))
			      {
				 return BUNSPEC;
			      }
			    else
			      {
				 {
				    node_t aux_1795;
				    {
				       obj_t aux_1796;
				       aux_1796 = CAR(asts_1292);
				       aux_1795 = (node_t) (aux_1796);
				    }
				    set_cto__5_integrate_cto(aux_1795, local_2);
				 }
				 {
				    obj_t asts_1800;
				    asts_1800 = CDR(asts_1292);
				    asts_1292 = asts_1800;
				    goto liip_1293;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 app_ly_162_t node_1298;
			 node_1298 = (app_ly_162_t) (node_1);
			 set_cto__5_integrate_cto((((app_ly_162_t) CREF(node_1298))->fun), local_2);
			 {
			    node_t node_1806;
			    node_1806 = (((app_ly_162_t) CREF(node_1298))->arg);
			    node_1 = node_1806;
			    goto set_cto__5_integrate_cto;
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 funcall_t node_1303;
			 node_1303 = (funcall_t) (node_1);
			 {
			    obj_t asts_1306;
			    asts_1306 = (((funcall_t) CREF(node_1303))->args);
			  liip_1307:
			    if (NULLP(asts_1306))
			      {
				 node_t node_1811;
				 node_1811 = (((funcall_t) CREF(node_1303))->fun);
				 node_1 = node_1811;
				 goto set_cto__5_integrate_cto;
			      }
			    else
			      {
				 {
				    node_t aux_1813;
				    {
				       obj_t aux_1814;
				       aux_1814 = CAR(asts_1306);
				       aux_1813 = (node_t) (aux_1814);
				    }
				    set_cto__5_integrate_cto(aux_1813, local_2);
				 }
				 {
				    obj_t asts_1818;
				    asts_1818 = CDR(asts_1306);
				    asts_1306 = asts_1818;
				    goto liip_1307;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 pragma_t node_1313;
			 node_1313 = (pragma_t) (node_1);
			 {
			    obj_t l1338_1316;
			    {
			       bool_t aux_1822;
			       l1338_1316 = (((pragma_t) CREF(node_1313))->args);
			     lname1340_1317:
			       if (PAIRP(l1338_1316))
				 {
				    {
				       node_t aux_1825;
				       {
					  obj_t aux_1826;
					  aux_1826 = CAR(l1338_1316);
					  aux_1825 = (node_t) (aux_1826);
				       }
				       set_cto__5_integrate_cto(aux_1825, local_2);
				    }
				    {
				       obj_t l1338_1830;
				       l1338_1830 = CDR(l1338_1316);
				       l1338_1316 = l1338_1830;
				       goto lname1340_1317;
				    }
				 }
			       else
				 {
				    aux_1822 = ((bool_t) 1);
				 }
			       return BBOOL(aux_1822);
			    }
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 cast_t node_1322;
			 node_1322 = (cast_t) (node_1);
			 {
			    node_t node_1835;
			    node_1835 = (((cast_t) CREF(node_1322))->arg);
			    node_1 = node_1835;
			    goto set_cto__5_integrate_cto;
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 setq_t node_1326;
			 node_1326 = (setq_t) (node_1);
			 {
			    node_t aux_1838;
			    {
			       var_t aux_1839;
			       aux_1839 = (((setq_t) CREF(node_1326))->var);
			       aux_1838 = (node_t) (aux_1839);
			    }
			    set_cto__5_integrate_cto(aux_1838, local_2);
			 }
			 {
			    node_t node_1843;
			    node_1843 = (((setq_t) CREF(node_1326))->value);
			    node_1 = node_1843;
			    goto set_cto__5_integrate_cto;
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 conditional_t node_1331;
			 node_1331 = (conditional_t) (node_1);
			 set_cto__5_integrate_cto((((conditional_t) CREF(node_1331))->test), local_2);
			 set_cto__5_integrate_cto((((conditional_t) CREF(node_1331))->true), local_2);
			 {
			    node_t node_1850;
			    node_1850 = (((conditional_t) CREF(node_1331))->false);
			    node_1 = node_1850;
			    goto set_cto__5_integrate_cto;
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 fail_t node_1337;
			 node_1337 = (fail_t) (node_1);
			 set_cto__5_integrate_cto((((fail_t) CREF(node_1337))->proc), local_2);
			 set_cto__5_integrate_cto((((fail_t) CREF(node_1337))->msg), local_2);
			 {
			    node_t node_1857;
			    node_1857 = (((fail_t) CREF(node_1337))->obj);
			    node_1 = node_1857;
			    goto set_cto__5_integrate_cto;
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 select_t node_1343;
			 node_1343 = (select_t) (node_1);
			 {
			    obj_t clauses_1346;
			    clauses_1346 = (((select_t) CREF(node_1343))->clauses);
			  liip_1347:
			    if (NULLP(clauses_1346))
			      {
				 node_t node_1862;
				 node_1862 = (((select_t) CREF(node_1343))->test);
				 node_1 = node_1862;
				 goto set_cto__5_integrate_cto;
			      }
			    else
			      {
				 {
				    node_t aux_1864;
				    {
				       obj_t aux_1865;
				       {
					  obj_t aux_1866;
					  aux_1866 = CAR(clauses_1346);
					  aux_1865 = CDR(aux_1866);
				       }
				       aux_1864 = (node_t) (aux_1865);
				    }
				    set_cto__5_integrate_cto(aux_1864, local_2);
				 }
				 {
				    obj_t clauses_1871;
				    clauses_1871 = CDR(clauses_1346);
				    clauses_1346 = clauses_1871;
				    goto liip_1347;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 let_fun_218_t node_1354;
			 node_1354 = (let_fun_218_t) (node_1);
			 {
			    obj_t locals_1357;
			    locals_1357 = (((let_fun_218_t) CREF(node_1354))->locals);
			  liip_1358:
			    if (NULLP(locals_1357))
			      {
				 node_t node_1877;
				 node_1877 = (((let_fun_218_t) CREF(node_1354))->body);
				 node_1 = node_1877;
				 goto set_cto__5_integrate_cto;
			      }
			    else
			      {
				 {
				    node_t aux_1879;
				    {
				       obj_t aux_1880;
				       {
					  sfun_t obj_1504;
					  {
					     value_t aux_1881;
					     {
						local_t obj_1502;
						{
						   obj_t aux_1882;
						   aux_1882 = CAR(locals_1357);
						   obj_1502 = (local_t) (aux_1882);
						}
						aux_1881 = (((local_t) CREF(obj_1502))->value);
					     }
					     obj_1504 = (sfun_t) (aux_1881);
					  }
					  aux_1880 = (((sfun_t) CREF(obj_1504))->body);
				       }
				       aux_1879 = (node_t) (aux_1880);
				    }
				    set_cto__5_integrate_cto(aux_1879, local_2);
				 }
				 {
				    obj_t locals_1890;
				    locals_1890 = CDR(locals_1357);
				    locals_1357 = locals_1890;
				    goto liip_1358;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 let_var_6_t node_1367;
			 node_1367 = (let_var_6_t) (node_1);
			 {
			    obj_t bindings_1370;
			    bindings_1370 = (((let_var_6_t) CREF(node_1367))->bindings);
			  liip_1371:
			    if (NULLP(bindings_1370))
			      {
				 node_t node_1896;
				 node_1896 = (((let_var_6_t) CREF(node_1367))->body);
				 node_1 = node_1896;
				 goto set_cto__5_integrate_cto;
			      }
			    else
			      {
				 {
				    node_t aux_1898;
				    {
				       obj_t aux_1899;
				       {
					  obj_t aux_1900;
					  aux_1900 = CAR(bindings_1370);
					  aux_1899 = CDR(aux_1900);
				       }
				       aux_1898 = (node_t) (aux_1899);
				    }
				    set_cto__5_integrate_cto(aux_1898, local_2);
				 }
				 {
				    obj_t bindings_1905;
				    bindings_1905 = CDR(bindings_1370);
				    bindings_1370 = bindings_1905;
				    goto liip_1371;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 set_ex_it_116_t node_1378;
			 node_1378 = (set_ex_it_116_t) (node_1);
			 {
			    node_t node_1909;
			    node_1909 = (((set_ex_it_116_t) CREF(node_1378))->body);
			    node_1 = node_1909;
			    goto set_cto__5_integrate_cto;
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 jump_ex_it_184_t node_1382;
			 node_1382 = (jump_ex_it_184_t) (node_1);
			 set_cto__5_integrate_cto((((jump_ex_it_184_t) CREF(node_1382))->exit), local_2);
			 {
			    node_t node_1914;
			    node_1914 = (((jump_ex_it_184_t) CREF(node_1382))->value);
			    node_1 = node_1914;
			    goto set_cto__5_integrate_cto;
			 }
		      }
		      break;
		   case ((long) 18):
		      {
			 make_box_202_t node_1387;
			 node_1387 = (make_box_202_t) (node_1);
			 {
			    node_t node_1917;
			    node_1917 = (((make_box_202_t) CREF(node_1387))->value);
			    node_1 = node_1917;
			    goto set_cto__5_integrate_cto;
			 }
		      }
		      break;
		   case ((long) 19):
		      {
			 box_set__221_t node_1391;
			 node_1391 = (box_set__221_t) (node_1);
			 {
			    node_t aux_1920;
			    {
			       var_t aux_1921;
			       aux_1921 = (((box_set__221_t) CREF(node_1391))->var);
			       aux_1920 = (node_t) (aux_1921);
			    }
			    set_cto__5_integrate_cto(aux_1920, local_2);
			 }
			 {
			    node_t node_1925;
			    node_1925 = (((box_set__221_t) CREF(node_1391))->value);
			    node_1 = node_1925;
			    goto set_cto__5_integrate_cto;
			 }
		      }
		      break;
		   case ((long) 20):
		      {
			 box_ref_242_t node_1396;
			 node_1396 = (box_ref_242_t) (node_1);
			 {
			    node_t node_1928;
			    {
			       var_t aux_1929;
			       aux_1929 = (((box_ref_242_t) CREF(node_1396))->var);
			       node_1928 = (node_t) (aux_1929);
			    }
			    node_1 = node_1928;
			    goto set_cto__5_integrate_cto;
			 }
		      }
		      break;
		   default:
		    case_else1520_43_1220:
		      if (PROCEDUREP(method1514_1216))
			{
			   return PROCEDURE_ENTRY(method1514_1216) (method1514_1216, (obj_t) (node_1), (obj_t) (local_2), BEOA);
			}
		      else
			{
			   obj_t fun1381_856;
			   fun1381_856 = PROCEDURE_REF(set_cto__env_185_integrate_cto, ((long) 0));
			   return PROCEDURE_ENTRY(fun1381_856) (fun1381_856, (obj_t) (node_1), (obj_t) (local_2), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1520_43_1220;
	      }
	 }
      }
   }
}


obj_t 
_set_cto__169_integrate_cto(obj_t env_1574, obj_t node_1575, obj_t local_1576)
{
   return set_cto__5_integrate_cto((node_t) (node_1575), (local_t) (local_1576));
}


obj_t 
imported_modules_init_94_integrate_cto()
{
   module_initialization_70_tools_trace(((long) 0), "INTEGRATE_CTO");
   module_initialization_70_tools_shape(((long) 0), "INTEGRATE_CTO");
   module_initialization_70_tools_error(((long) 0), "INTEGRATE_CTO");
   module_initialization_70_type_type(((long) 0), "INTEGRATE_CTO");
   module_initialization_70_ast_var(((long) 0), "INTEGRATE_CTO");
   module_initialization_70_ast_node(((long) 0), "INTEGRATE_CTO");
   return module_initialization_70_integrate_info(((long) 0), "INTEGRATE_CTO");
}
