/*===========================================================================*/
/*   (Integrate/definition.scm)                                              */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_t;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_t;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_t;


extern obj_t integrate_definition__136_integrate_definition(obj_t);
extern obj_t __phi__105_integrate_a;
extern obj_t globalize__167_integrate_node(node_t, variable_t, obj_t);
extern obj_t u__31_integrate_u();
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_integrate_definition();
extern obj_t module_initialization_70_integrate_definition(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_a(long, char *);
extern obj_t module_initialization_70_integrate_kk(long, char *);
extern obj_t module_initialization_70_integrate_u(long, char *);
extern obj_t module_initialization_70_integrate_ctn(long, char *);
extern obj_t module_initialization_70_integrate_g(long, char *);
extern obj_t module_initialization_70_integrate_kaptured(long, char *);
extern obj_t module_initialization_70_integrate_let_fun_158(long, char *);
extern obj_t module_initialization_70_integrate_node(long, char *);
extern obj_t module_initialization_70_integrate_local__global_163(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t cnst_init_137_integrate_definition();
extern obj_t a_integrate_a(global_t, node_t);
extern obj_t local__global_40_integrate_local__global_163(local_t);
static bool_t verb_globalization_175_integrate_definition(obj_t);
extern obj_t set_kaptured__104_integrate_kaptured(obj_t);
static obj_t require_initialization_114_integrate_definition = BUNSPEC;
extern obj_t k__48_integrate_kk(obj_t, global_t);
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_integrate_definition();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t displace_let_fun__199_integrate_let_fun_158(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t cn_ct__54_integrate_ctn(obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t local_ast_var;
extern obj_t k___139_integrate_kk(obj_t);
extern obj_t _integrate_definition__196_integrate_definition(obj_t, obj_t);
extern obj_t g__63_integrate_g(obj_t);
static obj_t __cnst[1];

DEFINE_STRING(string1559_integrate_definition, string1559_integrate_definition1565, "INTEGRATE ", 10);
DEFINE_STRING(string1558_integrate_definition, string1558_integrate_definition1566, "           ", 11);
DEFINE_STRING(string1556_integrate_definition, string1556_integrate_definition1567, "========================================", 40);
DEFINE_EXPORT_PROCEDURE(integrate_definition__env_137_integrate_definition, _integrate_definition__196_integrate_definition1568, _integrate_definition__196_integrate_definition, 0L, 1);
DEFINE_STRING(string1555_integrate_definition, string1555_integrate_definition1569, "----------------------------------------", 40);
DEFINE_STRING(string1557_integrate_definition, string1557_integrate_definition1570, " -->", 4);

obj_t 
module_initialization_70_integrate_definition(long checksum_1354, char *from_1355)
{
   if (CBOOL(require_initialization_114_integrate_definition))
     {
	require_initialization_114_integrate_definition = BBOOL(((bool_t) 0));
	library_modules_init_112_integrate_definition();
	cnst_init_137_integrate_definition();
	imported_modules_init_94_integrate_definition();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_integrate_definition()
{
   module_initialization_70___object(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70___reader(((long) 0), "INTEGRATE_DEFINITION");
   return BUNSPEC;
}


obj_t 
cnst_init_137_integrate_definition()
{
   {
      obj_t cnst_port_138_1346;
      cnst_port_138_1346 = open_input_string(string1559_integrate_definition);
      {
	 long i_1347;
	 i_1347 = ((long) 0);
       loop_1348:
	 {
	    bool_t test1560_1349;
	    test1560_1349 = (i_1347 == ((long) -1));
	    if (test1560_1349)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1561_1350;
		    {
		       obj_t list1562_1351;
		       {
			  obj_t arg1563_1352;
			  arg1563_1352 = BNIL;
			  list1562_1351 = MAKE_PAIR(cnst_port_138_1346, arg1563_1352);
		       }
		       arg1561_1350 = read___reader(list1562_1351);
		    }
		    CNST_TABLE_SET(i_1347, arg1561_1350);
		 }
		 {
		    int aux_1353;
		    {
		       long aux_1370;
		       aux_1370 = (i_1347 - ((long) 1));
		       aux_1353 = (int) (aux_1370);
		    }
		    {
		       long i_1373;
		       i_1373 = (long) (aux_1353);
		       i_1347 = i_1373;
		       goto loop_1348;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
integrate_definition__136_integrate_definition(obj_t global_1)
{
   {
      bool_t test1341_810;
      {
	 obj_t aux_1375;
	 aux_1375 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1341_810 = CBOOL(aux_1375);
      }
      if (test1341_810)
	{
	   obj_t arg1343_812;
	   arg1343_812 = shape_tools_shape(global_1);
	   {
	      obj_t list1346_814;
	      {
		 obj_t arg1347_815;
		 {
		    obj_t arg1349_816;
		    {
		       obj_t arg1350_817;
		       {
			  obj_t arg1352_818;
			  {
			     obj_t arg1353_819;
			     {
				obj_t aux_1382;
				aux_1382 = BCHAR(((unsigned char) '\n'));
				arg1353_819 = MAKE_PAIR(aux_1382, BNIL);
			     }
			     arg1352_818 = MAKE_PAIR(string1555_integrate_definition, arg1353_819);
			  }
			  {
			     obj_t aux_1386;
			     aux_1386 = BCHAR(((unsigned char) '\n'));
			     arg1350_817 = MAKE_PAIR(aux_1386, arg1352_818);
			  }
		       }
		       arg1349_816 = MAKE_PAIR(arg1343_812, arg1350_817);
		    }
		    {
		       obj_t aux_1390;
		       aux_1390 = BCHAR(((unsigned char) '\n'));
		       arg1347_815 = MAKE_PAIR(aux_1390, arg1349_816);
		    }
		 }
		 list1346_814 = MAKE_PAIR(string1556_integrate_definition, arg1347_815);
	      }
	      print_trace_107_tools_trace(list1346_814);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      value_t fun_823;
      {
	 global_t obj_1247;
	 obj_1247 = (global_t) (global_1);
	 fun_823 = (((global_t) CREF(obj_1247))->value);
      }
      {
	 obj_t body_824;
	 {
	    sfun_t obj_1248;
	    obj_1248 = (sfun_t) (fun_823);
	    body_824 = (((sfun_t) CREF(obj_1248))->body);
	 }
	 {
	    obj_t a_825;
	    a_825 = a_integrate_a((global_t) (global_1), (node_t) (body_824));
	    {
	       {
		  obj_t arg1358_826;
		  arg1358_826 = k__48_integrate_kk(a_825, (global_t) (global_1));
		  k___139_integrate_kk(arg1358_826);
	       }
	       u__31_integrate_u();
	       {
		  obj_t g_827;
		  {
		     obj_t arg1411_876;
		     arg1411_876 = cn_ct__54_integrate_ctn(a_825);
		     g_827 = g__63_integrate_g(arg1411_876);
		  }
		  if (NULLP(g_827))
		    {
		       obj_t list1360_829;
		       list1360_829 = MAKE_PAIR(global_1, BNIL);
		       return list1360_829;
		    }
		  else
		    {
		       verb_globalization_175_integrate_definition(g_827);
		       {
			  obj_t l1329_831;
			  l1329_831 = __phi__105_integrate_a;
			lname1330_832:
			  if (PAIRP(l1329_831))
			    {
			       {
				  obj_t f_834;
				  f_834 = CAR(l1329_831);
				  {
				     bool_t test1363_835;
				     {
					bool_t test1368_841;
					test1368_841 = is_a__118___object(f_834, local_ast_var);
					if (test1368_841)
					  {
					     bool_t test_1417;
					     {
						sfun_iinfo_105_t obj_1255;
						{
						   value_t aux_1418;
						   {
						      local_t obj_1254;
						      obj_1254 = (local_t) (f_834);
						      aux_1418 = (((local_t) CREF(obj_1254))->value);
						   }
						   obj_1255 = (sfun_iinfo_105_t) (aux_1418);
						}
						{
						   obj_t aux_1422;
						   {
						      object_t aux_1423;
						      aux_1423 = (object_t) (obj_1255);
						      aux_1422 = OBJECT_WIDENING(aux_1423);
						   }
						   test_1417 = (((sfun_iinfo_105_t) CREF(aux_1422))->g__219);
						}
					     }
					     if (test_1417)
					       {
						  test1363_835 = ((bool_t) 0);
					       }
					     else
					       {
						  test1363_835 = ((bool_t) 1);
					       }
					  }
					else
					  {
					     test1363_835 = ((bool_t) 0);
					  }
				     }
				     if (test1363_835)
				       {
					  value_t ifu_837;
					  {
					     variable_t obj_1258;
					     {
						obj_t aux_1428;
						{
						   sfun_iinfo_105_t obj_1257;
						   {
						      value_t aux_1429;
						      {
							 local_t obj_1256;
							 obj_1256 = (local_t) (f_834);
							 aux_1429 = (((local_t) CREF(obj_1256))->value);
						      }
						      obj_1257 = (sfun_iinfo_105_t) (aux_1429);
						   }
						   {
						      obj_t aux_1433;
						      {
							 object_t aux_1434;
							 aux_1434 = (object_t) (obj_1257);
							 aux_1433 = OBJECT_WIDENING(aux_1434);
						      }
						      aux_1428 = (((sfun_iinfo_105_t) CREF(aux_1433))->l);
						   }
						}
						obj_1258 = (variable_t) (aux_1428);
					     }
					     ifu_837 = (((variable_t) CREF(obj_1258))->value);
					  }
					  {
					     {
						obj_t arg1364_838;
						{
						   obj_t aux_1440;
						   {
						      sfun_iinfo_105_t obj_1259;
						      obj_1259 = (sfun_iinfo_105_t) (ifu_837);
						      {
							 obj_t aux_1442;
							 {
							    object_t aux_1443;
							    aux_1443 = (object_t) (obj_1259);
							    aux_1442 = OBJECT_WIDENING(aux_1443);
							 }
							 aux_1440 = (((sfun_iinfo_105_t) CREF(aux_1442))->led);
						      }
						   }
						   arg1364_838 = MAKE_PAIR(f_834, aux_1440);
						}
						{
						   obj_t res1553_1264;
						   {
						      sfun_iinfo_105_t obj_1262;
						      obj_1262 = (sfun_iinfo_105_t) (ifu_837);
						      {
							 obj_t x_1344;
							 {
							    obj_t aux_1449;
							    {
							       object_t aux_1450;
							       aux_1450 = (object_t) (obj_1262);
							       aux_1449 = OBJECT_WIDENING(aux_1450);
							    }
							    x_1344 = ((((sfun_iinfo_105_t) CREF(aux_1449))->led) = ((obj_t) arg1364_838), BUNSPEC);
							 }
							 res1553_1264 = BUNSPEC;
						      }
						   }
						   res1553_1264;
						}
					     }
					  }
				       }
				     else
				       {
					  BUNSPEC;
				       }
				  }
			       }
			       {
				  obj_t l1329_1454;
				  l1329_1454 = CDR(l1329_831);
				  l1329_831 = l1329_1454;
				  goto lname1330_832;
			       }
			    }
			  else
			    {
			       ((bool_t) 1);
			    }
		       }
		       {
			  obj_t l1331_845;
			  l1331_845 = g_827;
			lname1333_846:
			  if (PAIRP(l1331_845))
			    {
			       displace_let_fun__199_integrate_let_fun_158(CAR(l1331_845));
			       {
				  obj_t l1331_1460;
				  l1331_1460 = CDR(l1331_845);
				  l1331_845 = l1331_1460;
				  goto lname1333_846;
			       }
			    }
			  else
			    {
			       ((bool_t) 1);
			    }
		       }
		       displace_let_fun__199_integrate_let_fun_158(global_1);
		       set_kaptured__104_integrate_kaptured(g_827);
		       {
			  obj_t new_g_67_850;
			  if (NULLP(g_827))
			    {
			       new_g_67_850 = BNIL;
			    }
			  else
			    {
			       obj_t head1336_862;
			       {
				  obj_t arg1406_873;
				  {
				     local_t aux_1466;
				     {
					obj_t aux_1467;
					aux_1467 = CAR(g_827);
					aux_1466 = (local_t) (aux_1467);
				     }
				     arg1406_873 = local__global_40_integrate_local__global_163(aux_1466);
				  }
				  head1336_862 = MAKE_PAIR(arg1406_873, BNIL);
			       }
			       {
				  obj_t l1334_863;
				  obj_t tail1337_864;
				  l1334_863 = CDR(g_827);
				  tail1337_864 = head1336_862;
				lname1335_865:
				  if (NULLP(l1334_863))
				    {
				       new_g_67_850 = head1336_862;
				    }
				  else
				    {
				       obj_t new_tail1338_43_868;
				       {
					  obj_t arg1402_870;
					  {
					     local_t aux_1474;
					     {
						obj_t aux_1475;
						aux_1475 = CAR(l1334_863);
						aux_1474 = (local_t) (aux_1475);
					     }
					     arg1402_870 = local__global_40_integrate_local__global_163(aux_1474);
					  }
					  new_tail1338_43_868 = MAKE_PAIR(arg1402_870, BNIL);
				       }
				       SET_CDR(tail1337_864, new_tail1338_43_868);
				       {
					  obj_t tail1337_1483;
					  obj_t l1334_1481;
					  l1334_1481 = CDR(l1334_863);
					  tail1337_1483 = new_tail1338_43_868;
					  tail1337_864 = tail1337_1483;
					  l1334_863 = l1334_1481;
					  goto lname1335_865;
				       }
				    }
			       }
			    }
			  {
			     obj_t arg1380_851;
			     arg1380_851 = globalize__167_integrate_node((node_t) (body_824), (variable_t) (global_1), BNIL);
			     {
				obj_t res1554_1283;
				{
				   sfun_t obj_1281;
				   obj_1281 = (sfun_t) (fun_823);
				   {
				      obj_t x_1345;
				      x_1345 = ((((sfun_t) CREF(obj_1281))->body) = ((obj_t) arg1380_851), BUNSPEC);
				      res1554_1283 = BUNSPEC;
				   }
				}
				res1554_1283;
			     }
			  }
			  {
			     bool_t test1382_853;
			     {
				obj_t aux_1490;
				aux_1490 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
				test1382_853 = CBOOL(aux_1490);
			     }
			     if (test1382_853)
			       {
				  obj_t list1383_854;
				  {
				     obj_t arg1385_855;
				     {
					obj_t arg1388_856;
					{
					   obj_t aux_1496;
					   aux_1496 = BCHAR(((unsigned char) '\n'));
					   arg1388_856 = MAKE_PAIR(aux_1496, BNIL);
					}
					{
					   obj_t aux_1499;
					   aux_1499 = BCHAR(((unsigned char) '\n'));
					   arg1385_855 = MAKE_PAIR(aux_1499, arg1388_856);
					}
				     }
				     {
					obj_t aux_1502;
					aux_1502 = BCHAR(((unsigned char) ''));
					list1383_854 = MAKE_PAIR(aux_1502, arg1385_855);
				     }
				  }
				  print_trace_107_tools_trace(list1383_854);
			       }
			     else
			       {
				  BUNSPEC;
			       }
			  }
			  return MAKE_PAIR(global_1, new_g_67_850);
		       }
		    }
	       }
	    }
	 }
      }
   }
}


obj_t 
_integrate_definition__196_integrate_definition(obj_t env_1342, obj_t global_1343)
{
   return integrate_definition__136_integrate_definition(global_1343);
}


bool_t 
verb_globalization_175_integrate_definition(obj_t g_2)
{
   {
      obj_t l1339_877;
      l1339_877 = g_2;
    lname1340_878:
      if (PAIRP(l1339_877))
	{
	   {
	      obj_t arg1416_883;
	      arg1416_883 = shape_tools_shape(CAR(l1339_877));
	      {
		 obj_t list1418_885;
		 {
		    obj_t arg1420_886;
		    {
		       obj_t arg1421_887;
		       {
			  obj_t arg1424_888;
			  {
			     obj_t aux_1512;
			     aux_1512 = BCHAR(((unsigned char) '\n'));
			     arg1424_888 = MAKE_PAIR(aux_1512, BNIL);
			  }
			  arg1421_887 = MAKE_PAIR(string1557_integrate_definition, arg1424_888);
		       }
		       arg1420_886 = MAKE_PAIR(arg1416_883, arg1421_887);
		    }
		    list1418_885 = MAKE_PAIR(string1558_integrate_definition, arg1420_886);
		 }
		 verbose_tools_speek(BINT(((long) 3)), list1418_885);
	      }
	   }
	   {
	      obj_t l1339_1520;
	      l1339_1520 = CDR(l1339_877);
	      l1339_877 = l1339_1520;
	      goto lname1340_878;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
imported_modules_init_94_integrate_definition()
{
   module_initialization_70_tools_trace(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70_type_type(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70_ast_var(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70_ast_node(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70_tools_shape(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70_tools_speek(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70_integrate_info(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70_integrate_a(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70_integrate_kk(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70_integrate_u(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70_integrate_ctn(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70_integrate_g(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70_integrate_kaptured(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70_integrate_let_fun_158(((long) 0), "INTEGRATE_DEFINITION");
   module_initialization_70_integrate_node(((long) 0), "INTEGRATE_DEFINITION");
   return module_initialization_70_integrate_local__global_163(((long) 0), "INTEGRATE_DEFINITION");
}
