/*===========================================================================*/
/*   (Integrate/free.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_t;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_t;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_t;


extern obj_t let_fun_218_ast_node;
static long __round__57_integrate_free;
static obj_t free_variable__181_integrate_free(obj_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_integrate_free();
extern obj_t module_initialization_70_integrate_free(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_node(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_integrate_free();
static obj_t cnst_init_137_integrate_free();
static obj_t node_free_default1358_82_integrate_free(node_t, obj_t);
static obj_t require_initialization_114_integrate_free = BUNSPEC;
static obj_t bind_variable__14_integrate_free(local_t, local_t);
extern obj_t _free_from_124_integrate_free(obj_t, obj_t, obj_t);
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_integrate_free();
extern obj_t svar_iinfo_76_integrate_info;
static obj_t node_free_158_integrate_free(node_t, obj_t);
extern obj_t cast_ast_node;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
static obj_t _node_free_default1358_64_integrate_free(obj_t, obj_t, obj_t);
extern obj_t pragma_ast_node;
static obj_t _node_free_100_integrate_free(obj_t, obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
static obj_t __integrator__235_integrate_free = BUNSPEC;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t free_from_222_integrate_free(obj_t, local_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t node_free__199_integrate_free(obj_t, obj_t);
static obj_t mark_variable__104_integrate_free(local_t);
static obj_t internal_get_free_vars__185_integrate_free(node_t, local_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t get_free_vars_244_integrate_free(node_t, local_t);
extern obj_t sexit_iinfo_190_integrate_info;
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t _get_free_vars_234_integrate_free(obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t __cnst[1];

DEFINE_STATIC_GENERIC(node_free_env_48_integrate_free, _node_free_100_integrate_free1734, _node_free_100_integrate_free, 0L, 2);
DEFINE_EXPORT_PROCEDURE(get_free_vars_env_212_integrate_free, _get_free_vars_234_integrate_free1735, _get_free_vars_234_integrate_free, 0L, 2);
DEFINE_STRING(string1727_integrate_free, string1727_integrate_free1736, "INTEGRATE ", 10);
DEFINE_STRING(string1726_integrate_free, string1726_integrate_free1737, "   bound(", 9);
DEFINE_STRING(string1725_integrate_free, string1725_integrate_free1738, ") : ", 4);
DEFINE_STRING(string1720_integrate_free, string1720_integrate_free1739, "] : ", 4);
DEFINE_STRING(string1723_integrate_free, string1723_integrate_free1740, "Unexepected `closure' node", 26);
DEFINE_STRING(string1722_integrate_free, string1722_integrate_free1741, "node-free", 9);
DEFINE_STRING(string1718_integrate_free, string1718_integrate_free1742, "free-variable?", 14);
DEFINE_STRING(string1721_integrate_free, string1721_integrate_free1743, "get-free-vars [", 15);
DEFINE_EXPORT_PROCEDURE(free_from_env_97_integrate_free, _free_from_124_integrate_free1744, _free_from_124_integrate_free, 0L, 2);
DEFINE_STRING(string1719_integrate_free, string1719_integrate_free1745, "Unknown variable type", 21);
DEFINE_STRING(string1724_integrate_free, string1724_integrate_free1746, "   sets: ", 9);
DEFINE_STATIC_PROCEDURE(node_free_default1358_env_106_integrate_free, _node_free_default1358_64_integrate_free1747, _node_free_default1358_64_integrate_free, 0L, 2);

obj_t 
module_initialization_70_integrate_free(long checksum_1712, char *from_1713)
{
   if (CBOOL(require_initialization_114_integrate_free))
     {
	require_initialization_114_integrate_free = BBOOL(((bool_t) 0));
	library_modules_init_112_integrate_free();
	cnst_init_137_integrate_free();
	imported_modules_init_94_integrate_free();
	toplevel_init_63_integrate_free();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_integrate_free()
{
   module_initialization_70___object(((long) 0), "INTEGRATE_FREE");
   module_initialization_70___reader(((long) 0), "INTEGRATE_FREE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_integrate_free()
{
   {
      obj_t cnst_port_138_1704;
      cnst_port_138_1704 = open_input_string(string1727_integrate_free);
      {
	 long i_1705;
	 i_1705 = ((long) 0);
       loop_1706:
	 {
	    bool_t test1728_1707;
	    test1728_1707 = (i_1705 == ((long) -1));
	    if (test1728_1707)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1730_1708;
		    {
		       obj_t list1731_1709;
		       {
			  obj_t arg1732_1710;
			  arg1732_1710 = BNIL;
			  list1731_1709 = MAKE_PAIR(cnst_port_138_1704, arg1732_1710);
		       }
		       arg1730_1708 = read___reader(list1731_1709);
		    }
		    CNST_TABLE_SET(i_1705, arg1730_1708);
		 }
		 {
		    int aux_1711;
		    {
		       long aux_1729;
		       aux_1729 = (i_1705 - ((long) 1));
		       aux_1711 = (int) (aux_1729);
		    }
		    {
		       long i_1732;
		       i_1732 = (long) (aux_1711);
		       i_1705 = i_1732;
		       goto loop_1706;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_integrate_free()
{
   __round__57_integrate_free = ((long) 0);
   __integrator__235_integrate_free = BUNSPEC;
   add_generic__110___object(node_free_env_48_integrate_free, node_free_default1358_env_106_integrate_free);
   add_inlined_method__244___object(node_free_env_48_integrate_free, var_ast_node, ((long) 0));
   add_inlined_method__244___object(node_free_env_48_integrate_free, closure_ast_node, ((long) 1));
   add_inlined_method__244___object(node_free_env_48_integrate_free, sequence_ast_node, ((long) 2));
   add_inlined_method__244___object(node_free_env_48_integrate_free, app_ast_node, ((long) 3));
   add_inlined_method__244___object(node_free_env_48_integrate_free, app_ly_162_ast_node, ((long) 4));
   add_inlined_method__244___object(node_free_env_48_integrate_free, funcall_ast_node, ((long) 5));
   add_inlined_method__244___object(node_free_env_48_integrate_free, pragma_ast_node, ((long) 6));
   add_inlined_method__244___object(node_free_env_48_integrate_free, cast_ast_node, ((long) 7));
   add_inlined_method__244___object(node_free_env_48_integrate_free, setq_ast_node, ((long) 8));
   add_inlined_method__244___object(node_free_env_48_integrate_free, conditional_ast_node, ((long) 9));
   add_inlined_method__244___object(node_free_env_48_integrate_free, fail_ast_node, ((long) 10));
   add_inlined_method__244___object(node_free_env_48_integrate_free, select_ast_node, ((long) 11));
   add_inlined_method__244___object(node_free_env_48_integrate_free, let_fun_218_ast_node, ((long) 12));
   add_inlined_method__244___object(node_free_env_48_integrate_free, let_var_6_ast_node, ((long) 13));
   add_inlined_method__244___object(node_free_env_48_integrate_free, set_ex_it_116_ast_node, ((long) 14));
   add_inlined_method__244___object(node_free_env_48_integrate_free, jump_ex_it_184_ast_node, ((long) 15));
   add_inlined_method__244___object(node_free_env_48_integrate_free, make_box_202_ast_node, ((long) 16));
   add_inlined_method__244___object(node_free_env_48_integrate_free, box_ref_242_ast_node, ((long) 17));
   {
      long aux_1753;
      aux_1753 = add_inlined_method__244___object(node_free_env_48_integrate_free, box_set__221_ast_node, ((long) 18));
      return BINT(aux_1753);
   }
}


obj_t 
mark_variable__104_integrate_free(local_t local_1)
{
   {
      value_t info_862;
      info_862 = (((local_t) CREF(local_1))->value);
      {
	 bool_t test1384_863;
	 test1384_863 = is_a__118___object((obj_t) (info_862), svar_iinfo_76_integrate_info);
	 if (test1384_863)
	   {
	      {
		 obj_t res1713_1480;
		 {
		    svar_iinfo_76_t obj_1478;
		    obj_t val1279_1479;
		    obj_1478 = (svar_iinfo_76_t) (info_862);
		    val1279_1479 = BINT(__round__57_integrate_free);
		    {
		       obj_t x_1700;
		       {
			  obj_t aux_1762;
			  {
			     object_t aux_1763;
			     aux_1763 = (object_t) (obj_1478);
			     aux_1762 = OBJECT_WIDENING(aux_1763);
			  }
			  x_1700 = ((((svar_iinfo_76_t) CREF(aux_1762))->f_mark_181) = ((obj_t) val1279_1479), BUNSPEC);
		       }
		       res1713_1480 = BUNSPEC;
		    }
		 }
		 return res1713_1480;
	      }
	   }
	 else
	   {
	      bool_t test1385_864;
	      test1385_864 = is_a__118___object((obj_t) (info_862), sexit_iinfo_190_integrate_info);
	      if (test1385_864)
		{
		   {
		      obj_t res1714_1484;
		      {
			 sexit_iinfo_190_t obj_1482;
			 obj_t val1291_1483;
			 obj_1482 = (sexit_iinfo_190_t) (info_862);
			 val1291_1483 = BINT(__round__57_integrate_free);
			 {
			    obj_t x_1701;
			    {
			       obj_t aux_1772;
			       {
				  object_t aux_1773;
				  aux_1773 = (object_t) (obj_1482);
				  aux_1772 = OBJECT_WIDENING(aux_1773);
			       }
			       x_1701 = ((((sexit_iinfo_190_t) CREF(aux_1772))->f_mark_181) = ((obj_t) val1291_1483), BUNSPEC);
			    }
			    res1714_1484 = BUNSPEC;
			 }
		      }
		      return res1714_1484;
		   }
		}
	      else
		{
		   return BFALSE;
		}
	   }
      }
   }
}


obj_t 
bind_variable__14_integrate_free(local_t local_2, local_t integrator_3)
{
   {
      value_t finfo_865;
      finfo_865 = (((local_t) CREF(integrator_3))->value);
      {
	 obj_t arg1388_866;
	 {
	    obj_t aux_1780;
	    obj_t aux_1778;
	    {
	       sfun_iinfo_105_t obj_1486;
	       obj_1486 = (sfun_iinfo_105_t) (finfo_865);
	       {
		  obj_t aux_1782;
		  {
		     object_t aux_1783;
		     aux_1783 = (object_t) (obj_1486);
		     aux_1782 = OBJECT_WIDENING(aux_1783);
		  }
		  aux_1780 = (((sfun_iinfo_105_t) CREF(aux_1782))->bound);
	       }
	    }
	    aux_1778 = (obj_t) (local_2);
	    arg1388_866 = MAKE_PAIR(aux_1778, aux_1780);
	 }
	 {
	    obj_t res1715_1491;
	    {
	       sfun_iinfo_105_t obj_1489;
	       obj_1489 = (sfun_iinfo_105_t) (finfo_865);
	       {
		  obj_t x_1702;
		  {
		     obj_t aux_1789;
		     {
			object_t aux_1790;
			aux_1790 = (object_t) (obj_1489);
			aux_1789 = OBJECT_WIDENING(aux_1790);
		     }
		     x_1702 = ((((sfun_iinfo_105_t) CREF(aux_1789))->bound) = ((obj_t) arg1388_866), BUNSPEC);
		  }
		  res1715_1491 = BUNSPEC;
	       }
	    }
	    res1715_1491;
	 }
      }
      return mark_variable__104_integrate_free(local_2);
   }
}


obj_t 
free_variable__181_integrate_free(obj_t local_4)
{
   {
      value_t info_868;
      {
	 local_t obj_1492;
	 obj_1492 = (local_t) (local_4);
	 info_868 = (((local_t) CREF(obj_1492))->value);
      }
      {
	 bool_t test1391_869;
	 test1391_869 = is_a__118___object((obj_t) (info_868), svar_iinfo_76_integrate_info);
	 if (test1391_869)
	   {
	      {
		 bool_t test1392_870;
		 {
		    obj_t arg1396_871;
		    {
		       svar_iinfo_76_t obj_1494;
		       obj_1494 = (svar_iinfo_76_t) (info_868);
		       {
			  obj_t aux_1801;
			  {
			     object_t aux_1802;
			     aux_1802 = (object_t) (obj_1494);
			     aux_1801 = OBJECT_WIDENING(aux_1802);
			  }
			  arg1396_871 = (((svar_iinfo_76_t) CREF(aux_1801))->f_mark_181);
		       }
		    }
		    {
		       obj_t obj2_1496;
		       obj2_1496 = BINT(__round__57_integrate_free);
		       test1392_870 = (arg1396_871 == obj2_1496);
		    }
		 }
		 if (test1392_870)
		   {
		      return BFALSE;
		   }
		 else
		   {
		      return BTRUE;
		   }
	      }
	   }
	 else
	   {
	      bool_t test1397_872;
	      test1397_872 = is_a__118___object((obj_t) (info_868), sexit_iinfo_190_integrate_info);
	      if (test1397_872)
		{
		   {
		      bool_t test1398_873;
		      {
			 obj_t arg1400_874;
			 {
			    sexit_iinfo_190_t obj_1498;
			    obj_1498 = (sexit_iinfo_190_t) (info_868);
			    {
			       obj_t aux_1813;
			       {
				  object_t aux_1814;
				  aux_1814 = (object_t) (obj_1498);
				  aux_1813 = OBJECT_WIDENING(aux_1814);
			       }
			       arg1400_874 = (((sexit_iinfo_190_t) CREF(aux_1813))->f_mark_181);
			    }
			 }
			 {
			    obj_t obj2_1500;
			    obj2_1500 = BINT(__round__57_integrate_free);
			    test1398_873 = (arg1400_874 == obj2_1500);
			 }
		      }
		      if (test1398_873)
			{
			   return BFALSE;
			}
		      else
			{
			   return BTRUE;
			}
		   }
		}
	      else
		{
		   {
		      obj_t arg1404_877;
		      {
			 obj_t arg1406_878;
			 arg1406_878 = shape_tools_shape(local_4);
			 arg1404_877 = MAKE_PAIR(local_4, arg1406_878);
		      }
		      FAILURE(string1718_integrate_free, string1719_integrate_free, arg1404_877);
		   }
		}
	   }
      }
   }
}


obj_t 
get_free_vars_244_integrate_free(node_t node_5, local_t integrator_6)
{
   {
      bool_t test1407_879;
      {
	 obj_t aux_1824;
	 aux_1824 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1407_879 = CBOOL(aux_1824);
      }
      if (test1407_879)
	{
	   obj_t arg1410_881;
	   arg1410_881 = shape_tools_shape((obj_t) (integrator_6));
	   {
	      obj_t list1412_883;
	      {
		 obj_t arg1414_884;
		 {
		    obj_t arg1415_885;
		    {
		       obj_t arg1416_886;
		       {
			  obj_t aux_1832;
			  aux_1832 = BCHAR(((unsigned char) '\n'));
			  arg1416_886 = MAKE_PAIR(aux_1832, BNIL);
		       }
		       arg1415_885 = MAKE_PAIR(string1720_integrate_free, arg1416_886);
		    }
		    arg1414_884 = MAKE_PAIR(arg1410_881, arg1415_885);
		 }
		 list1412_883 = MAKE_PAIR(string1721_integrate_free, arg1414_884);
	      }
	      print_trace_107_tools_trace(list1412_883);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t free_890;
      {
	 sfun_iinfo_105_t obj_1507;
	 {
	    value_t aux_1839;
	    aux_1839 = (((local_t) CREF(integrator_6))->value);
	    obj_1507 = (sfun_iinfo_105_t) (aux_1839);
	 }
	 {
	    obj_t aux_1842;
	    {
	       object_t aux_1843;
	       aux_1843 = (object_t) (obj_1507);
	       aux_1842 = OBJECT_WIDENING(aux_1843);
	    }
	    free_890 = (((sfun_iinfo_105_t) CREF(aux_1842))->free);
	 }
      }
      {
	 bool_t test_1847;
	 if (NULLP(free_890))
	   {
	      test_1847 = ((bool_t) 1);
	   }
	 else
	   {
	      test_1847 = PAIRP(free_890);
	   }
	 if (test_1847)
	   {
	      return free_890;
	   }
	 else
	   {
	      obj_t free_892;
	      free_892 = internal_get_free_vars__185_integrate_free(node_5, integrator_6);
	      {
		 obj_t res1716_1513;
		 {
		    sfun_iinfo_105_t obj_1511;
		    {
		       value_t aux_1852;
		       aux_1852 = (((local_t) CREF(integrator_6))->value);
		       obj_1511 = (sfun_iinfo_105_t) (aux_1852);
		    }
		    {
		       obj_t x_1703;
		       {
			  obj_t aux_1855;
			  {
			     object_t aux_1856;
			     aux_1856 = (object_t) (obj_1511);
			     aux_1855 = OBJECT_WIDENING(aux_1856);
			  }
			  x_1703 = ((((sfun_iinfo_105_t) CREF(aux_1855))->free) = ((obj_t) free_892), BUNSPEC);
		       }
		       res1716_1513 = BUNSPEC;
		    }
		 }
		 res1716_1513;
	      }
	      return free_892;
	   }
      }
   }
}


obj_t 
_get_free_vars_234_integrate_free(obj_t env_1694, obj_t node_1695, obj_t integrator_1696)
{
   return get_free_vars_244_integrate_free((node_t) (node_1695), (local_t) (integrator_1696));
}


obj_t 
internal_get_free_vars__185_integrate_free(node_t node_7, local_t integrator_8)
{
   {
      long z1_1514;
      z1_1514 = __round__57_integrate_free;
      __round__57_integrate_free = (z1_1514 + ((long) 1));
   }
   __integrator__235_integrate_free = (obj_t) (integrator_8);
   {
      obj_t l1329_896;
      {
	 sfun_t obj_1517;
	 {
	    value_t aux_1874;
	    aux_1874 = (((local_t) CREF(integrator_8))->value);
	    obj_1517 = (sfun_t) (aux_1874);
	 }
	 l1329_896 = (((sfun_t) CREF(obj_1517))->args);
      }
    lname1330_897:
      if (PAIRP(l1329_896))
	{
	   {
	      local_t aux_1867;
	      {
		 obj_t aux_1868;
		 aux_1868 = CAR(l1329_896);
		 aux_1867 = (local_t) (aux_1868);
	      }
	      bind_variable__14_integrate_free(aux_1867, integrator_8);
	   }
	   {
	      obj_t l1329_1872;
	      l1329_1872 = CDR(l1329_896);
	      l1329_896 = l1329_1872;
	      goto lname1330_897;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   return node_free_158_integrate_free(node_7, BNIL);
}


obj_t 
node_free_default1358_82_integrate_free(node_t node_11, obj_t free_12)
{
   return free_12;
}


obj_t 
_node_free_default1358_64_integrate_free(obj_t env_1691, obj_t node_1692, obj_t free_1693)
{
   return node_free_default1358_82_integrate_free((node_t) (node_1692), free_1693);
}


obj_t 
node_free_158_integrate_free(node_t node_9, obj_t free_10)
{
 node_free_158_integrate_free:
   {
      obj_t method1606_1322;
      obj_t class1611_1323;
      {
	 obj_t arg1614_1320;
	 obj_t arg1616_1321;
	 {
	    object_t obj_1521;
	    obj_1521 = (object_t) (node_9);
	    {
	       obj_t pre_method_105_1522;
	       pre_method_105_1522 = PROCEDURE_REF(node_free_env_48_integrate_free, ((long) 2));
	       if (INTEGERP(pre_method_105_1522))
		 {
		    PROCEDURE_SET(node_free_env_48_integrate_free, ((long) 2), BUNSPEC);
		    arg1614_1320 = pre_method_105_1522;
		 }
	       else
		 {
		    long obj_class_num_177_1527;
		    obj_class_num_177_1527 = TYPE(obj_1521);
		    {
		       obj_t arg1183_1528;
		       arg1183_1528 = PROCEDURE_REF(node_free_env_48_integrate_free, ((long) 1));
		       {
			  long arg1184_1532;
			  {
			     long arg1186_1533;
			     arg1186_1533 = OBJECT_TYPE;
			     arg1184_1532 = (obj_class_num_177_1527 - arg1186_1533);
			  }
			  arg1614_1320 = VECTOR_REF(arg1183_1528, arg1184_1532);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1538;
	    object_1538 = (object_t) (node_9);
	    {
	       long arg1187_1539;
	       {
		  long arg1188_1540;
		  long arg1189_1541;
		  arg1188_1540 = TYPE(object_1538);
		  arg1189_1541 = OBJECT_TYPE;
		  arg1187_1539 = (arg1188_1540 - arg1189_1541);
	       }
	       {
		  obj_t vector_1545;
		  vector_1545 = __classes__134___object;
		  arg1616_1321 = VECTOR_REF(vector_1545, arg1187_1539);
	       }
	    }
	 }
	 method1606_1322 = arg1614_1320;
	 class1611_1323 = arg1616_1321;
	 {
	    if (INTEGERP(method1606_1322))
	      {
		 switch ((long) CINT(method1606_1322))
		   {
		   case ((long) 0):
		      {
			 var_t node_1329;
			 node_1329 = (var_t) (node_9);
			 {
			    bool_t test1619_1332;
			    {
			       obj_t aux_1899;
			       {
				  variable_t aux_1900;
				  aux_1900 = (((var_t) CREF(node_1329))->variable);
				  aux_1899 = (obj_t) (aux_1900);
			       }
			       test1619_1332 = is_a__118___object(aux_1899, global_ast_var);
			    }
			    if (test1619_1332)
			      {
				 return free_10;
			      }
			    else
			      {
				 bool_t test1620_1333;
				 {
				    obj_t aux_1905;
				    {
				       obj_t aux_1906;
				       {
					  variable_t aux_1907;
					  aux_1907 = (((var_t) CREF(node_1329))->variable);
					  aux_1906 = (obj_t) (aux_1907);
				       }
				       aux_1905 = free_variable__181_integrate_free(aux_1906);
				    }
				    test1620_1333 = CBOOL(aux_1905);
				 }
				 if (test1620_1333)
				   {
				      {
					 local_t aux_1913;
					 {
					    variable_t aux_1914;
					    aux_1914 = (((var_t) CREF(node_1329))->variable);
					    aux_1913 = (local_t) (aux_1914);
					 }
					 mark_variable__104_integrate_free(aux_1913);
				      }
				      {
					 obj_t aux_1918;
					 {
					    variable_t aux_1919;
					    aux_1919 = (((var_t) CREF(node_1329))->variable);
					    aux_1918 = (obj_t) (aux_1919);
					 }
					 return MAKE_PAIR(aux_1918, free_10);
				      }
				   }
				 else
				   {
				      return free_10;
				   }
			      }
			 }
		      }
		      break;
		   case ((long) 1):
		      {
			 obj_t arg1630_1342;
			 {
			    obj_t aux_1923;
			    {
			       closure_t aux_1924;
			       aux_1924 = (closure_t) (node_9);
			       aux_1923 = (obj_t) (aux_1924);
			    }
			    arg1630_1342 = shape_tools_shape(aux_1923);
			 }
			 return internal_error_43_tools_error(string1722_integrate_free, string1723_integrate_free, arg1630_1342);
		      }
		      break;
		   case ((long) 2):
		      {
			 sequence_t node_1343;
			 node_1343 = (sequence_t) (node_9);
			 return node_free__199_integrate_free((((sequence_t) CREF(node_1343))->nodes), free_10);
		      }
		      break;
		   case ((long) 3):
		      {
			 app_t node_1347;
			 node_1347 = (app_t) (node_9);
			 return node_free__199_integrate_free((((app_t) CREF(node_1347))->args), free_10);
		      }
		      break;
		   case ((long) 4):
		      {
			 app_ly_162_t node_1351;
			 node_1351 = (app_ly_162_t) (node_9);
			 {
			    node_t arg1637_1354;
			    obj_t arg1638_1355;
			    arg1637_1354 = (((app_ly_162_t) CREF(node_1351))->fun);
			    arg1638_1355 = node_free_158_integrate_free((((app_ly_162_t) CREF(node_1351))->arg), free_10);
			    {
			       obj_t free_1940;
			       node_t node_1939;
			       node_1939 = arg1637_1354;
			       free_1940 = arg1638_1355;
			       free_10 = free_1940;
			       node_9 = node_1939;
			       goto node_free_158_integrate_free;
			    }
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 funcall_t node_1357;
			 node_1357 = (funcall_t) (node_9);
			 {
			    node_t arg1642_1360;
			    obj_t arg1643_1361;
			    arg1642_1360 = (((funcall_t) CREF(node_1357))->fun);
			    arg1643_1361 = node_free__199_integrate_free((((funcall_t) CREF(node_1357))->args), free_10);
			    {
			       obj_t free_1946;
			       node_t node_1945;
			       node_1945 = arg1642_1360;
			       free_1946 = arg1643_1361;
			       free_10 = free_1946;
			       node_9 = node_1945;
			       goto node_free_158_integrate_free;
			    }
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 pragma_t node_1363;
			 node_1363 = (pragma_t) (node_9);
			 return node_free__199_integrate_free((((pragma_t) CREF(node_1363))->args), free_10);
		      }
		      break;
		   case ((long) 7):
		      {
			 cast_t node_1367;
			 node_1367 = (cast_t) (node_9);
			 {
			    node_t node_1951;
			    node_1951 = (((cast_t) CREF(node_1367))->arg);
			    node_9 = node_1951;
			    goto node_free_158_integrate_free;
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 setq_t node_1371;
			 node_1371 = (setq_t) (node_9);
			 {
			    var_t arg1647_1374;
			    obj_t arg1648_1375;
			    arg1647_1374 = (((setq_t) CREF(node_1371))->var);
			    arg1648_1375 = node_free_158_integrate_free((((setq_t) CREF(node_1371))->value), free_10);
			    {
			       obj_t free_1959;
			       node_t node_1957;
			       node_1957 = (node_t) (arg1647_1374);
			       free_1959 = arg1648_1375;
			       free_10 = free_1959;
			       node_9 = node_1957;
			       goto node_free_158_integrate_free;
			    }
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 conditional_t node_1377;
			 node_1377 = (conditional_t) (node_9);
			 {
			    node_t arg1651_1380;
			    obj_t arg1652_1381;
			    arg1651_1380 = (((conditional_t) CREF(node_1377))->test);
			    {
			       node_t arg1653_1382;
			       obj_t arg1654_1383;
			       arg1653_1382 = (((conditional_t) CREF(node_1377))->true);
			       arg1654_1383 = node_free_158_integrate_free((((conditional_t) CREF(node_1377))->false), free_10);
			       arg1652_1381 = node_free_158_integrate_free(arg1653_1382, arg1654_1383);
			    }
			    {
			       obj_t free_1967;
			       node_t node_1966;
			       node_1966 = arg1651_1380;
			       free_1967 = arg1652_1381;
			       free_10 = free_1967;
			       node_9 = node_1966;
			       goto node_free_158_integrate_free;
			    }
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 fail_t node_1385;
			 node_1385 = (fail_t) (node_9);
			 {
			    node_t arg1656_1388;
			    obj_t arg1657_1389;
			    arg1656_1388 = (((fail_t) CREF(node_1385))->proc);
			    {
			       node_t arg1659_1390;
			       obj_t arg1661_1391;
			       arg1659_1390 = (((fail_t) CREF(node_1385))->msg);
			       arg1661_1391 = node_free_158_integrate_free((((fail_t) CREF(node_1385))->obj), free_10);
			       arg1657_1389 = node_free_158_integrate_free(arg1659_1390, arg1661_1391);
			    }
			    {
			       obj_t free_1975;
			       node_t node_1974;
			       node_1974 = arg1656_1388;
			       free_1975 = arg1657_1389;
			       free_10 = free_1975;
			       node_9 = node_1974;
			       goto node_free_158_integrate_free;
			    }
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 select_t node_1393;
			 node_1393 = (select_t) (node_9);
			 {
			    obj_t clauses_1396;
			    obj_t free_1397;
			    clauses_1396 = (((select_t) CREF(node_1393))->clauses);
			    free_1397 = free_10;
			  loop_1398:
			    if (NULLP(clauses_1396))
			      {
				 obj_t free_1981;
				 node_t node_1979;
				 node_1979 = (((select_t) CREF(node_1393))->test);
				 free_1981 = free_1397;
				 free_10 = free_1981;
				 node_9 = node_1979;
				 goto node_free_158_integrate_free;
			      }
			    else
			      {
				 obj_t arg1668_1402;
				 obj_t arg1669_1403;
				 arg1668_1402 = CDR(clauses_1396);
				 {
				    node_t aux_1983;
				    {
				       obj_t aux_1984;
				       {
					  obj_t aux_1985;
					  aux_1985 = CAR(clauses_1396);
					  aux_1984 = CDR(aux_1985);
				       }
				       aux_1983 = (node_t) (aux_1984);
				    }
				    arg1669_1403 = node_free_158_integrate_free(aux_1983, free_1397);
				 }
				 {
				    obj_t free_1991;
				    obj_t clauses_1990;
				    clauses_1990 = arg1668_1402;
				    free_1991 = arg1669_1403;
				    free_1397 = free_1991;
				    clauses_1396 = clauses_1990;
				    goto loop_1398;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 let_fun_218_t node_1406;
			 node_1406 = (let_fun_218_t) (node_9);
			 {
			    obj_t locals_1409;
			    obj_t free_1410;
			    locals_1409 = (((let_fun_218_t) CREF(node_1406))->locals);
			    free_1410 = free_10;
			  liip_1411:
			    if (NULLP(locals_1409))
			      {
				 obj_t free_1998;
				 node_t node_1996;
				 node_1996 = (((let_fun_218_t) CREF(node_1406))->body);
				 free_1998 = free_1410;
				 free_10 = free_1998;
				 node_9 = node_1996;
				 goto node_free_158_integrate_free;
			      }
			    else
			      {
				 value_t fun_1416;
				 {
				    local_t obj_1580;
				    {
				       obj_t aux_1999;
				       aux_1999 = CAR(locals_1409);
				       obj_1580 = (local_t) (aux_1999);
				    }
				    fun_1416 = (((local_t) CREF(obj_1580))->value);
				 }
				 {
				    {
				       obj_t l1343_1417;
				       {
					  sfun_t obj_1581;
					  obj_1581 = (sfun_t) (fun_1416);
					  l1343_1417 = (((sfun_t) CREF(obj_1581))->args);
				       }
				     lname1344_1418:
				       if (PAIRP(l1343_1417))
					 {
					    {
					       local_t aux_2005;
					       {
						  obj_t aux_2006;
						  aux_2006 = CAR(l1343_1417);
						  aux_2005 = (local_t) (aux_2006);
					       }
					       bind_variable__14_integrate_free(aux_2005, (local_t) (__integrator__235_integrate_free));
					    }
					    {
					       obj_t l1343_2011;
					       l1343_2011 = CDR(l1343_1417);
					       l1343_1417 = l1343_2011;
					       goto lname1344_1418;
					    }
					 }
				       else
					 {
					    ((bool_t) 1);
					 }
				    }
				    {
				       obj_t arg1681_1423;
				       obj_t arg1682_1424;
				       arg1681_1423 = CDR(locals_1409);
				       {
					  node_t aux_2016;
					  {
					     obj_t aux_2017;
					     {
						sfun_t obj_1586;
						obj_1586 = (sfun_t) (fun_1416);
						aux_2017 = (((sfun_t) CREF(obj_1586))->body);
					     }
					     aux_2016 = (node_t) (aux_2017);
					  }
					  arg1682_1424 = node_free_158_integrate_free(aux_2016, free_1410);
				       }
				       {
					  obj_t free_2023;
					  obj_t locals_2022;
					  locals_2022 = arg1681_1423;
					  free_2023 = arg1682_1424;
					  free_1410 = free_2023;
					  locals_1409 = locals_2022;
					  goto liip_1411;
				       }
				    }
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 let_var_6_t node_1426;
			 node_1426 = (let_var_6_t) (node_9);
			 {
			    obj_t bindings_1429;
			    obj_t free_1430;
			    bindings_1429 = (((let_var_6_t) CREF(node_1426))->bindings);
			    free_1430 = free_10;
			  loop_1431:
			    if (NULLP(bindings_1429))
			      {
				 obj_t free_2030;
				 node_t node_2028;
				 node_2028 = (((let_var_6_t) CREF(node_1426))->body);
				 free_2030 = free_1430;
				 free_10 = free_2030;
				 node_9 = node_2028;
				 goto node_free_158_integrate_free;
			      }
			    else
			      {
				 {
				    local_t aux_2031;
				    {
				       obj_t aux_2032;
				       {
					  obj_t aux_2033;
					  aux_2033 = CAR(bindings_1429);
					  aux_2032 = CAR(aux_2033);
				       }
				       aux_2031 = (local_t) (aux_2032);
				    }
				    bind_variable__14_integrate_free(aux_2031, (local_t) (__integrator__235_integrate_free));
				 }
				 {
				    obj_t arg1691_1437;
				    obj_t arg1693_1438;
				    arg1691_1437 = CDR(bindings_1429);
				    {
				       node_t aux_2040;
				       {
					  obj_t aux_2041;
					  {
					     obj_t aux_2042;
					     aux_2042 = CAR(bindings_1429);
					     aux_2041 = CDR(aux_2042);
					  }
					  aux_2040 = (node_t) (aux_2041);
				       }
				       arg1693_1438 = node_free_158_integrate_free(aux_2040, free_1430);
				    }
				    {
				       obj_t free_2048;
				       obj_t bindings_2047;
				       bindings_2047 = arg1691_1437;
				       free_2048 = arg1693_1438;
				       free_1430 = free_2048;
				       bindings_1429 = bindings_2047;
				       goto loop_1431;
				    }
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 set_ex_it_116_t node_1441;
			 node_1441 = (set_ex_it_116_t) (node_9);
			 {
			    local_t aux_2051;
			    {
			       variable_t aux_2052;
			       {
				  var_t arg1697_1445;
				  arg1697_1445 = (((set_ex_it_116_t) CREF(node_1441))->var);
				  aux_2052 = (((var_t) CREF(arg1697_1445))->variable);
			       }
			       aux_2051 = (local_t) (aux_2052);
			    }
			    bind_variable__14_integrate_free(aux_2051, (local_t) (__integrator__235_integrate_free));
			 }
			 {
			    node_t node_2058;
			    node_2058 = (((set_ex_it_116_t) CREF(node_1441))->body);
			    node_9 = node_2058;
			    goto node_free_158_integrate_free;
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 jump_ex_it_184_t node_1447;
			 node_1447 = (jump_ex_it_184_t) (node_9);
			 {
			    node_t arg1699_1450;
			    obj_t arg1701_1451;
			    arg1699_1450 = (((jump_ex_it_184_t) CREF(node_1447))->exit);
			    arg1701_1451 = node_free_158_integrate_free((((jump_ex_it_184_t) CREF(node_1447))->value), free_10);
			    {
			       obj_t free_2065;
			       node_t node_2064;
			       node_2064 = arg1699_1450;
			       free_2065 = arg1701_1451;
			       free_10 = free_2065;
			       node_9 = node_2064;
			       goto node_free_158_integrate_free;
			    }
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 make_box_202_t node_1453;
			 node_1453 = (make_box_202_t) (node_9);
			 {
			    node_t node_2067;
			    node_2067 = (((make_box_202_t) CREF(node_1453))->value);
			    node_9 = node_2067;
			    goto node_free_158_integrate_free;
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 box_ref_242_t node_1457;
			 node_1457 = (box_ref_242_t) (node_9);
			 {
			    node_t node_2070;
			    {
			       var_t aux_2071;
			       aux_2071 = (((box_ref_242_t) CREF(node_1457))->var);
			       node_2070 = (node_t) (aux_2071);
			    }
			    node_9 = node_2070;
			    goto node_free_158_integrate_free;
			 }
		      }
		      break;
		   case ((long) 18):
		      {
			 box_set__221_t node_1461;
			 node_1461 = (box_set__221_t) (node_9);
			 {
			    var_t arg1705_1464;
			    obj_t arg1706_1465;
			    arg1705_1464 = (((box_set__221_t) CREF(node_1461))->var);
			    arg1706_1465 = node_free_158_integrate_free((((box_set__221_t) CREF(node_1461))->value), free_10);
			    {
			       obj_t free_2080;
			       node_t node_2078;
			       node_2078 = (node_t) (arg1705_1464);
			       free_2080 = arg1706_1465;
			       free_10 = free_2080;
			       node_9 = node_2078;
			       goto node_free_158_integrate_free;
			    }
			 }
		      }
		      break;
		   default:
		    case_else1612_92_1326:
		      if (PROCEDUREP(method1606_1322))
			{
			   return PROCEDURE_ENTRY(method1606_1322) (method1606_1322, (obj_t) (node_9), free_10, BEOA);
			}
		      else
			{
			   obj_t fun1433_904;
			   fun1433_904 = PROCEDURE_REF(node_free_env_48_integrate_free, ((long) 0));
			   return PROCEDURE_ENTRY(fun1433_904) (fun1433_904, (obj_t) (node_9), free_10, BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1612_92_1326;
	      }
	 }
      }
   }
}


obj_t 
_node_free_100_integrate_free(obj_t env_1688, obj_t node_1689, obj_t free_1690)
{
   return node_free_158_integrate_free((node_t) (node_1689), free_1690);
}


obj_t 
node_free__199_integrate_free(obj_t node__221_51, obj_t free_52)
{
   {
      obj_t node__221_905;
      obj_t free_906;
      node__221_905 = node__221_51;
      free_906 = free_52;
    loop_907:
      if (NULLP(node__221_905))
	{
	   return free_906;
	}
      else
	{
	   obj_t arg1440_909;
	   obj_t arg1441_910;
	   arg1440_909 = CDR(node__221_905);
	   {
	      node_t aux_2097;
	      {
		 obj_t aux_2098;
		 aux_2098 = CAR(node__221_905);
		 aux_2097 = (node_t) (aux_2098);
	      }
	      arg1441_910 = node_free_158_integrate_free(aux_2097, free_906);
	   }
	   {
	      obj_t free_2103;
	      obj_t node__221_2102;
	      node__221_2102 = arg1440_909;
	      free_2103 = arg1441_910;
	      free_906 = free_2103;
	      node__221_905 = node__221_2102;
	      goto loop_907;
	   }
	}
   }
}


obj_t 
free_from_222_integrate_free(obj_t sets_53, local_t integrator_54)
{
   {
      long z1_1609;
      z1_1609 = __round__57_integrate_free;
      __round__57_integrate_free = (z1_1609 + ((long) 1));
   }
   {
      value_t finfo_912;
      finfo_912 = (((local_t) CREF(integrator_54))->value);
      {
	 bool_t test1445_913;
	 {
	    obj_t aux_2106;
	    aux_2106 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	    test1445_913 = CBOOL(aux_2106);
	 }
	 if (test1445_913)
	   {
	      obj_t arg1447_915;
	      obj_t arg1449_917;
	      obj_t arg1452_919;
	      arg1447_915 = shape_tools_shape((obj_t) (integrator_54));
	      {
		 obj_t aux_2114;
		 {
		    sfun_iinfo_105_t obj_1612;
		    obj_1612 = (sfun_iinfo_105_t) (finfo_912);
		    {
		       obj_t aux_2116;
		       {
			  object_t aux_2117;
			  aux_2117 = (object_t) (obj_1612);
			  aux_2116 = OBJECT_WIDENING(aux_2117);
		       }
		       aux_2114 = (((sfun_iinfo_105_t) CREF(aux_2116))->bound);
		    }
		 }
		 arg1449_917 = shape_tools_shape(aux_2114);
	      }
	      arg1452_919 = shape_tools_shape(sets_53);
	      {
		 obj_t list1453_920;
		 {
		    obj_t arg1454_921;
		    {
		       obj_t arg1457_922;
		       {
			  obj_t arg1458_923;
			  {
			     obj_t arg1461_924;
			     {
				obj_t arg1463_925;
				{
				   obj_t arg1465_926;
				   {
				      obj_t arg1466_927;
				      {
					 obj_t aux_2123;
					 aux_2123 = BCHAR(((unsigned char) '\n'));
					 arg1466_927 = MAKE_PAIR(aux_2123, BNIL);
				      }
				      arg1465_926 = MAKE_PAIR(arg1452_919, arg1466_927);
				   }
				   arg1463_925 = MAKE_PAIR(string1724_integrate_free, arg1465_926);
				}
				{
				   obj_t aux_2128;
				   aux_2128 = BCHAR(((unsigned char) '\n'));
				   arg1461_924 = MAKE_PAIR(aux_2128, arg1463_925);
				}
			     }
			     arg1458_923 = MAKE_PAIR(arg1449_917, arg1461_924);
			  }
			  arg1457_922 = MAKE_PAIR(string1725_integrate_free, arg1458_923);
		       }
		       arg1454_921 = MAKE_PAIR(arg1447_915, arg1457_922);
		    }
		    list1453_920 = MAKE_PAIR(string1726_integrate_free, arg1454_921);
		 }
		 print_trace_107_tools_trace(list1453_920);
	      }
	   }
	 else
	   {
	      BUNSPEC;
	   }
      }
      {
	 obj_t l1351_932;
	 {
	    sfun_iinfo_105_t obj_1613;
	    obj_1613 = (sfun_iinfo_105_t) (finfo_912);
	    {
	       obj_t aux_2146;
	       {
		  object_t aux_2147;
		  aux_2147 = (object_t) (obj_1613);
		  aux_2146 = OBJECT_WIDENING(aux_2147);
	       }
	       l1351_932 = (((sfun_iinfo_105_t) CREF(aux_2146))->bound);
	    }
	 }
       lname1352_933:
	 if (PAIRP(l1351_932))
	   {
	      {
		 local_t aux_2138;
		 {
		    obj_t aux_2139;
		    aux_2139 = CAR(l1351_932);
		    aux_2138 = (local_t) (aux_2139);
		 }
		 mark_variable__104_integrate_free(aux_2138);
	      }
	      {
		 obj_t l1351_2143;
		 l1351_2143 = CDR(l1351_932);
		 l1351_932 = l1351_2143;
		 goto lname1352_933;
	      }
	   }
	 else
	   {
	      ((bool_t) 1);
	   }
      }
   }
   if (NULLP(sets_53))
     {
	return BNIL;
     }
   else
     {
	obj_t head1355_940;
	head1355_940 = MAKE_PAIR(BNIL, BNIL);
	{
	   obj_t l1353_941;
	   obj_t tail1356_942;
	   l1353_941 = sets_53;
	   tail1356_942 = head1355_940;
	 lname1354_943:
	   if (NULLP(l1353_941))
	     {
		return CDR(head1355_940);
	     }
	   else
	     {
		obj_t new_tail1357_48_945;
		{
		   obj_t arg1481_947;
		   {
		      obj_t set_950;
		      obj_t res_951;
		      set_950 = CAR(l1353_941);
		      res_951 = BNIL;
		    loop_952:
		      if (NULLP(set_950))
			{
			   arg1481_947 = res_951;
			}
		      else
			{
			   bool_t test1487_955;
			   {
			      obj_t aux_2159;
			      aux_2159 = free_variable__181_integrate_free(CAR(set_950));
			      test1487_955 = CBOOL(aux_2159);
			   }
			   if (test1487_955)
			     {
				{
				   obj_t arg1489_956;
				   obj_t arg1490_957;
				   arg1489_956 = CDR(set_950);
				   {
				      obj_t aux_2165;
				      aux_2165 = CAR(set_950);
				      arg1490_957 = MAKE_PAIR(aux_2165, res_951);
				   }
				   {
				      obj_t res_2169;
				      obj_t set_2168;
				      set_2168 = arg1489_956;
				      res_2169 = arg1490_957;
				      res_951 = res_2169;
				      set_950 = set_2168;
				      goto loop_952;
				   }
				}
			     }
			   else
			     {
				{
				   obj_t set_2170;
				   set_2170 = CDR(set_950);
				   set_950 = set_2170;
				   goto loop_952;
				}
			     }
			}
		   }
		   new_tail1357_48_945 = MAKE_PAIR(arg1481_947, BNIL);
		}
		SET_CDR(tail1356_942, new_tail1357_48_945);
		{
		   obj_t tail1356_2177;
		   obj_t l1353_2175;
		   l1353_2175 = CDR(l1353_941);
		   tail1356_2177 = new_tail1357_48_945;
		   tail1356_942 = tail1356_2177;
		   l1353_941 = l1353_2175;
		   goto lname1354_943;
		}
	     }
	}
     }
}


obj_t 
_free_from_124_integrate_free(obj_t env_1697, obj_t sets_1698, obj_t integrator_1699)
{
   return free_from_222_integrate_free(sets_1698, (local_t) (integrator_1699));
}


obj_t 
imported_modules_init_94_integrate_free()
{
   module_initialization_70_tools_trace(((long) 0), "INTEGRATE_FREE");
   module_initialization_70_tools_shape(((long) 0), "INTEGRATE_FREE");
   module_initialization_70_tools_speek(((long) 0), "INTEGRATE_FREE");
   module_initialization_70_tools_error(((long) 0), "INTEGRATE_FREE");
   module_initialization_70_type_type(((long) 0), "INTEGRATE_FREE");
   module_initialization_70_type_cache(((long) 0), "INTEGRATE_FREE");
   module_initialization_70_ast_var(((long) 0), "INTEGRATE_FREE");
   module_initialization_70_ast_local(((long) 0), "INTEGRATE_FREE");
   module_initialization_70_ast_node(((long) 0), "INTEGRATE_FREE");
   module_initialization_70_ast_sexp(((long) 0), "INTEGRATE_FREE");
   module_initialization_70_ast_glo_def_117(((long) 0), "INTEGRATE_FREE");
   module_initialization_70_integrate_info(((long) 0), "INTEGRATE_FREE");
   module_initialization_70_integrate_node(((long) 0), "INTEGRATE_FREE");
   return module_initialization_70_engine_param(((long) 0), "INTEGRATE_FREE");
}
