/*===========================================================================*/
/*   (Integrate/g.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_t;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_t;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_t;


extern obj_t __phi__105_integrate_a;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_integrate_g();
extern obj_t module_initialization_70_integrate_g(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_a(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t cnst_init_137_integrate_g();
static obj_t require_initialization_114_integrate_g = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_integrate_g();
extern obj_t variable_ast_var;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t _g__236_integrate_g(obj_t, obj_t);
extern obj_t local_ast_var;
extern obj_t g__63_integrate_g(obj_t);
static obj_t __cnst[1];

DEFINE_STRING(string1680_integrate_g, string1680_integrate_g1697, "G: ", 3);
DEFINE_STRING(string1686_integrate_g, string1686_integrate_g1698, "   G.1( ", 8);
DEFINE_STRING(string1685_integrate_g, string1685_integrate_g1699, " Ct( ", 5);
DEFINE_STRING(string1687_integrate_g, string1687_integrate_g1700, "   trying L.1( ", 15);
DEFINE_EXPORT_PROCEDURE(g__env_111_integrate_g, _g__236_integrate_g1701, _g__236_integrate_g, 0L, 1);
DEFINE_STRING(string1681_integrate_g, string1681_integrate_g1702, " iteration(s) to fix point", 26);
DEFINE_STRING(string1688_integrate_g, string1688_integrate_g1703, "   G.3( ", 8);
DEFINE_STRING(string1682_integrate_g, string1682_integrate_g1704, "   ", 3);
DEFINE_STRING(string1689_integrate_g, string1689_integrate_g1705, "   trying L.3( ", 15);
DEFINE_STRING(string1691_integrate_g, string1691_integrate_g1706, "INTEGRATE ", 10);
DEFINE_STRING(string1684_integrate_g, string1684_integrate_g1707, ", ", 2);
DEFINE_STRING(string1679_integrate_g, string1679_integrate_g1708, "G/cn (dans G!): ", 16);
DEFINE_STRING(string1683_integrate_g, string1683_integrate_g1709, " )", 2);
DEFINE_STRING(string1690_integrate_g, string1690_integrate_g1710, "   trying L.2( ", 15);

obj_t 
module_initialization_70_integrate_g(long checksum_1503, char *from_1504)
{
   if (CBOOL(require_initialization_114_integrate_g))
     {
	require_initialization_114_integrate_g = BBOOL(((bool_t) 0));
	library_modules_init_112_integrate_g();
	cnst_init_137_integrate_g();
	imported_modules_init_94_integrate_g();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_integrate_g()
{
   module_initialization_70___object(((long) 0), "INTEGRATE_G");
   module_initialization_70___reader(((long) 0), "INTEGRATE_G");
   return BUNSPEC;
}


obj_t 
cnst_init_137_integrate_g()
{
   {
      obj_t cnst_port_138_1495;
      cnst_port_138_1495 = open_input_string(string1691_integrate_g);
      {
	 long i_1496;
	 i_1496 = ((long) 0);
       loop_1497:
	 {
	    bool_t test1692_1498;
	    test1692_1498 = (i_1496 == ((long) -1));
	    if (test1692_1498)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1693_1499;
		    {
		       obj_t list1694_1500;
		       {
			  obj_t arg1695_1501;
			  arg1695_1501 = BNIL;
			  list1694_1500 = MAKE_PAIR(cnst_port_138_1495, arg1695_1501);
		       }
		       arg1693_1499 = read___reader(list1694_1500);
		    }
		    CNST_TABLE_SET(i_1496, arg1693_1499);
		 }
		 {
		    int aux_1502;
		    {
		       long aux_1519;
		       aux_1519 = (i_1496 - ((long) 1));
		       aux_1502 = (int) (aux_1519);
		    }
		    {
		       long i_1522;
		       i_1522 = (long) (aux_1502);
		       i_1496 = i_1522;
		       goto loop_1497;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
g__63_integrate_g(obj_t g_cn_224_1)
{
   {
      bool_t test1333_809;
      {
	 obj_t aux_1524;
	 aux_1524 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1333_809 = CBOOL(aux_1524);
      }
      if (test1333_809)
	{
	   obj_t arg1337_811;
	   arg1337_811 = shape_tools_shape(g_cn_224_1);
	   {
	      obj_t list1338_812;
	      {
		 obj_t arg1339_813;
		 {
		    obj_t arg1340_814;
		    {
		       obj_t aux_1531;
		       aux_1531 = BCHAR(((unsigned char) '\n'));
		       arg1340_814 = MAKE_PAIR(aux_1531, BNIL);
		    }
		    arg1339_813 = MAKE_PAIR(arg1337_811, arg1340_814);
		 }
		 list1338_812 = MAKE_PAIR(string1679_integrate_g, arg1339_813);
	      }
	      print_trace_107_tools_trace(list1338_812);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t stop__17_818;
      long stamp_819;
      obj_t gs_820;
      stop__17_818 = ((bool_t) 0);
      stamp_819 = ((long) 0);
      gs_820 = g_cn_224_1;
    loop_821:
      if (stop__17_818)
	{
	   {
	      obj_t l1329_822;
	      l1329_822 = __phi__105_integrate_a;
	    lname1330_823:
	      if (PAIRP(l1329_822))
		{
		   {
		      obj_t f_825;
		      f_825 = CAR(l1329_822);
		      {
			 bool_t test1347_826;
			 {
			    bool_t test1353_830;
			    test1353_830 = is_a__118___object(f_825, local_ast_var);
			    if (test1353_830)
			      {
				 bool_t test_1543;
				 {
				    sfun_iinfo_105_t obj_1352;
				    {
				       value_t aux_1544;
				       {
					  local_t obj_1351;
					  obj_1351 = (local_t) (f_825);
					  aux_1544 = (((local_t) CREF(obj_1351))->value);
				       }
				       obj_1352 = (sfun_iinfo_105_t) (aux_1544);
				    }
				    {
				       obj_t aux_1548;
				       {
					  object_t aux_1549;
					  aux_1549 = (object_t) (obj_1352);
					  aux_1548 = OBJECT_WIDENING(aux_1549);
				       }
				       test_1543 = (((sfun_iinfo_105_t) CREF(aux_1548))->g__219);
				    }
				 }
				 if (test_1543)
				   {
				      test1347_826 = ((bool_t) 0);
				   }
				 else
				   {
				      bool_t test1355_832;
				      {
					 obj_t aux_1553;
					 {
					    sfun_iinfo_105_t obj_1354;
					    {
					       value_t aux_1554;
					       {
						  local_t obj_1353;
						  obj_1353 = (local_t) (f_825);
						  aux_1554 = (((local_t) CREF(obj_1353))->value);
					       }
					       obj_1354 = (sfun_iinfo_105_t) (aux_1554);
					    }
					    {
					       obj_t aux_1558;
					       {
						  object_t aux_1559;
						  aux_1559 = (object_t) (obj_1354);
						  aux_1558 = OBJECT_WIDENING(aux_1559);
					       }
					       aux_1553 = (((sfun_iinfo_105_t) CREF(aux_1558))->l);
					    }
					 }
					 test1355_832 = is_a__118___object(aux_1553, variable_ast_var);
				      }
				      if (test1355_832)
					{
					   test1347_826 = ((bool_t) 0);
					}
				      else
					{
					   test1347_826 = ((bool_t) 1);
					}
				   }
			      }
			    else
			      {
				 test1347_826 = ((bool_t) 0);
			      }
			 }
			 if (test1347_826)
			   {
			      obj_t arg1350_828;
			      {
				 sfun_iinfo_105_t obj_1358;
				 {
				    value_t aux_1566;
				    {
				       local_t obj_1357;
				       obj_1357 = (local_t) (f_825);
				       aux_1566 = (((local_t) CREF(obj_1357))->value);
				    }
				    obj_1358 = (sfun_iinfo_105_t) (aux_1566);
				 }
				 {
				    obj_t aux_1570;
				    {
				       object_t aux_1571;
				       aux_1571 = (object_t) (obj_1358);
				       aux_1570 = OBJECT_WIDENING(aux_1571);
				    }
				    arg1350_828 = (((sfun_iinfo_105_t) CREF(aux_1570))->owner);
				 }
			      }
			      {
				 obj_t res1672_1361;
				 {
				    sfun_iinfo_105_t obj_1359;
				    {
				       value_t aux_1575;
				       {
					  local_t obj_1356;
					  obj_1356 = (local_t) (f_825);
					  aux_1575 = (((local_t) CREF(obj_1356))->value);
				       }
				       obj_1359 = (sfun_iinfo_105_t) (aux_1575);
				    }
				    {
				       obj_t x_1488;
				       {
					  obj_t aux_1579;
					  {
					     object_t aux_1580;
					     aux_1580 = (object_t) (obj_1359);
					     aux_1579 = OBJECT_WIDENING(aux_1580);
					  }
					  x_1488 = ((((sfun_iinfo_105_t) CREF(aux_1579))->l) = ((obj_t) arg1350_828), BUNSPEC);
				       }
				       res1672_1361 = BUNSPEC;
				    }
				 }
				 res1672_1361;
			      }
			   }
			 else
			   {
			      BUNSPEC;
			   }
		      }
		   }
		   {
		      obj_t l1329_1584;
		      l1329_1584 = CDR(l1329_822);
		      l1329_822 = l1329_1584;
		      goto lname1330_823;
		   }
		}
	      else
		{
		   ((bool_t) 1);
		}
	   }
	   {
	      bool_t test1360_837;
	      {
		 obj_t aux_1586;
		 aux_1586 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
		 test1360_837 = CBOOL(aux_1586);
	      }
	      if (test1360_837)
		{
		   obj_t arg1363_839;
		   arg1363_839 = shape_tools_shape(gs_820);
		   {
		      obj_t list1364_840;
		      {
			 obj_t arg1366_841;
			 {
			    obj_t arg1367_842;
			    {
			       obj_t aux_1593;
			       aux_1593 = BCHAR(((unsigned char) '\n'));
			       arg1367_842 = MAKE_PAIR(aux_1593, BNIL);
			    }
			    arg1366_841 = MAKE_PAIR(arg1363_839, arg1367_842);
			 }
			 list1364_840 = MAKE_PAIR(string1680_integrate_g, arg1366_841);
		      }
		      print_trace_107_tools_trace(list1364_840);
		   }
		}
	      else
		{
		   BUNSPEC;
		}
	   }
	   {
	      bool_t test1373_846;
	      {
		 obj_t aux_1599;
		 aux_1599 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
		 test1373_846 = CBOOL(aux_1599);
	      }
	      if (test1373_846)
		{
		   obj_t list1374_847;
		   {
		      obj_t arg1379_849;
		      {
			 obj_t arg1380_850;
			 {
			    obj_t arg1382_852;
			    {
			       obj_t aux_1605;
			       aux_1605 = BCHAR(((unsigned char) '\n'));
			       arg1382_852 = MAKE_PAIR(aux_1605, BNIL);
			    }
			    arg1380_850 = MAKE_PAIR(string1681_integrate_g, arg1382_852);
			 }
			 {
			    obj_t aux_1609;
			    aux_1609 = BINT(stamp_819);
			    arg1379_849 = MAKE_PAIR(aux_1609, arg1380_850);
			 }
		      }
		      list1374_847 = MAKE_PAIR(string1682_integrate_g, arg1379_849);
		   }
		   print_trace_107_tools_trace(list1374_847);
		}
	      else
		{
		   BUNSPEC;
		}
	   }
	   return gs_820;
	}
      else
	{
	   obj_t phi_856;
	   bool_t stop__17_857;
	   obj_t gs_858;
	   phi_856 = __phi__105_integrate_a;
	   stop__17_857 = ((bool_t) 1);
	   gs_858 = gs_820;
	 liip_859:
	   if (NULLP(phi_856))
	     {
		obj_t gs_1619;
		long stamp_1617;
		bool_t stop__17_1616;
		stop__17_1616 = stop__17_857;
		stamp_1617 = (stamp_819 + ((long) 1));
		gs_1619 = gs_858;
		gs_820 = gs_1619;
		stamp_819 = stamp_1617;
		stop__17_818 = stop__17_1616;
		goto loop_821;
	     }
	   else
	     {
		obj_t f_862;
		f_862 = CAR(phi_856);
		{
		   value_t fif_863;
		   {
		      variable_t obj_1367;
		      obj_1367 = (variable_t) (f_862);
		      fif_863 = (((variable_t) CREF(obj_1367))->value);
		   }
		   {
		      {
			 obj_t ct_864;
			 bool_t stop__17_865;
			 obj_t gs_866;
			 {
			    sfun_iinfo_105_t obj_1368;
			    obj_1368 = (sfun_iinfo_105_t) (fif_863);
			    {
			       obj_t aux_1919;
			       {
				  object_t aux_1920;
				  aux_1920 = (object_t) (obj_1368);
				  aux_1919 = OBJECT_WIDENING(aux_1920);
			       }
			       ct_864 = (((sfun_iinfo_105_t) CREF(aux_1919))->ct);
			    }
			 }
			 stop__17_865 = stop__17_857;
			 gs_866 = gs_858;
		       laap_867:
			 if (NULLP(ct_864))
			   {
			      obj_t gs_1628;
			      bool_t stop__17_1627;
			      obj_t phi_1625;
			      phi_1625 = CDR(phi_856);
			      stop__17_1627 = stop__17_865;
			      gs_1628 = gs_866;
			      gs_858 = gs_1628;
			      stop__17_857 = stop__17_1627;
			      phi_856 = phi_1625;
			      goto liip_859;
			   }
			 else
			   {
			      obj_t g_871;
			      g_871 = CAR(ct_864);
			      {
				 value_t gif_872;
				 {
				    local_t obj_1372;
				    obj_1372 = (local_t) (g_871);
				    gif_872 = (((local_t) CREF(obj_1372))->value);
				 }
				 {
				    {
				       bool_t test1401_873;
				       {
					  obj_t aux_1632;
					  aux_1632 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
					  test1401_873 = CBOOL(aux_1632);
				       }
				       if (test1401_873)
					 {
					    obj_t arg1403_875;
					    obj_t arg1406_877;
					    arg1403_875 = shape_tools_shape(f_862);
					    arg1406_877 = shape_tools_shape(g_871);
					    {
					       obj_t list1409_879;
					       {
						  obj_t arg1410_880;
						  {
						     obj_t arg1411_881;
						     {
							obj_t arg1412_882;
							{
							   obj_t arg1414_883;
							   {
							      obj_t arg1415_884;
							      {
								 obj_t aux_1640;
								 aux_1640 = BCHAR(((unsigned char) '\n'));
								 arg1415_884 = MAKE_PAIR(aux_1640, BNIL);
							      }
							      arg1414_883 = MAKE_PAIR(string1683_integrate_g, arg1415_884);
							   }
							   arg1412_882 = MAKE_PAIR(arg1406_877, arg1414_883);
							}
							arg1411_881 = MAKE_PAIR(string1684_integrate_g, arg1412_882);
						     }
						     arg1410_880 = MAKE_PAIR(arg1403_875, arg1411_881);
						  }
						  list1409_879 = MAKE_PAIR(string1685_integrate_g, arg1410_880);
					       }
					       print_trace_107_tools_trace(list1409_879);
					    }
					 }
				       else
					 {
					    BUNSPEC;
					 }
				    }
				    if ((f_862 == g_871))
				      {
					 {
					    obj_t ct_1651;
					    ct_1651 = CDR(ct_864);
					    ct_864 = ct_1651;
					    goto laap_867;
					 }
				      }
				    else
				      {
					 bool_t test_1653;
					 {
					    sfun_iinfo_105_t obj_1376;
					    obj_1376 = (sfun_iinfo_105_t) (gif_872);
					    {
					       obj_t aux_1655;
					       {
						  object_t aux_1656;
						  aux_1656 = (object_t) (obj_1376);
						  aux_1655 = OBJECT_WIDENING(aux_1656);
					       }
					       test_1653 = (((sfun_iinfo_105_t) CREF(aux_1655))->g__219);
					    }
					 }
					 if (test_1653)
					   {
					      {
						 obj_t ct_1660;
						 ct_1660 = CDR(ct_864);
						 ct_864 = ct_1660;
						 goto laap_867;
					      }
					   }
					 else
					   {
					      bool_t test_1662;
					      {
						 sfun_iinfo_105_t obj_1378;
						 obj_1378 = (sfun_iinfo_105_t) (fif_863);
						 {
						    obj_t aux_1664;
						    {
						       object_t aux_1665;
						       aux_1665 = (object_t) (obj_1378);
						       aux_1664 = OBJECT_WIDENING(aux_1665);
						    }
						    test_1662 = (((sfun_iinfo_105_t) CREF(aux_1664))->g__219);
						 }
					      }
					      if (test_1662)
						{
						   {
						      bool_t test1426_893;
						      {
							 obj_t aux_1669;
							 {
							    sfun_iinfo_105_t obj_1379;
							    obj_1379 = (sfun_iinfo_105_t) (gif_872);
							    {
							       obj_t aux_1671;
							       {
								  object_t aux_1672;
								  aux_1672 = (object_t) (obj_1379);
								  aux_1671 = OBJECT_WIDENING(aux_1672);
							       }
							       aux_1669 = (((sfun_iinfo_105_t) CREF(aux_1671))->l);
							    }
							 }
							 test1426_893 = is_a__118___object(aux_1669, variable_ast_var);
						      }
						      if (test1426_893)
							{
							   bool_t test_1678;
							   {
							      obj_t aux_1679;
							      {
								 sfun_iinfo_105_t obj_1381;
								 obj_1381 = (sfun_iinfo_105_t) (gif_872);
								 {
								    obj_t aux_1681;
								    {
								       object_t aux_1682;
								       aux_1682 = (object_t) (obj_1381);
								       aux_1681 = OBJECT_WIDENING(aux_1682);
								    }
								    aux_1679 = (((sfun_iinfo_105_t) CREF(aux_1681))->l);
								 }
							      }
							      test_1678 = (aux_1679 == f_862);
							   }
							   if (test_1678)
							     {
								{
								   obj_t ct_1687;
								   ct_1687 = CDR(ct_864);
								   ct_864 = ct_1687;
								   goto laap_867;
								}
							     }
							   else
							     {
								{
								   obj_t res1673_1387;
								   {
								      sfun_iinfo_105_t obj_1385;
								      obj_1385 = (sfun_iinfo_105_t) (gif_872);
								      {
									 obj_t x_1489;
									 {
									    obj_t aux_1690;
									    {
									       object_t aux_1691;
									       aux_1691 = (object_t) (obj_1385);
									       aux_1690 = OBJECT_WIDENING(aux_1691);
									    }
									    x_1489 = ((((sfun_iinfo_105_t) CREF(aux_1690))->g__219) = ((bool_t) ((bool_t) 1)), BUNSPEC);
									 }
									 res1673_1387 = BUNSPEC;
								      }
								   }
								   res1673_1387;
								}
								{
								   bool_t test1429_896;
								   {
								      obj_t aux_1695;
								      aux_1695 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
								      test1429_896 = CBOOL(aux_1695);
								   }
								   if (test1429_896)
								     {
									obj_t arg1432_898;
									arg1432_898 = shape_tools_shape(g_871);
									{
									   obj_t list1441_900;
									   {
									      obj_t arg1444_901;
									      {
										 obj_t arg1445_902;
										 {
										    obj_t arg1446_903;
										    {
										       obj_t aux_1702;
										       aux_1702 = BCHAR(((unsigned char) '\n'));
										       arg1446_903 = MAKE_PAIR(aux_1702, BNIL);
										    }
										    arg1445_902 = MAKE_PAIR(string1683_integrate_g, arg1446_903);
										 }
										 arg1444_901 = MAKE_PAIR(arg1432_898, arg1445_902);
									      }
									      list1441_900 = MAKE_PAIR(string1686_integrate_g, arg1444_901);
									   }
									   print_trace_107_tools_trace(list1441_900);
									}
								     }
								   else
								     {
									BUNSPEC;
								     }
								}
								{
								   obj_t arg1450_907;
								   obj_t arg1452_908;
								   arg1450_907 = CDR(ct_864);
								   arg1452_908 = MAKE_PAIR(g_871, gs_866);
								   {
								      obj_t gs_1713;
								      bool_t stop__17_1712;
								      obj_t ct_1711;
								      ct_1711 = arg1450_907;
								      stop__17_1712 = ((bool_t) 0);
								      gs_1713 = arg1452_908;
								      gs_866 = gs_1713;
								      stop__17_865 = stop__17_1712;
								      ct_864 = ct_1711;
								      goto laap_867;
								   }
								}
							     }
							}
						      else
							{
							   {
							      bool_t test1454_910;
							      {
								 obj_t aux_1714;
								 aux_1714 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
								 test1454_910 = CBOOL(aux_1714);
							      }
							      if (test1454_910)
								{
								   obj_t arg1458_912;
								   obj_t arg1463_914;
								   arg1458_912 = shape_tools_shape(f_862);
								   arg1463_914 = shape_tools_shape(g_871);
								   {
								      obj_t list1466_916;
								      {
									 obj_t arg1467_917;
									 {
									    obj_t arg1468_918;
									    {
									       obj_t arg1470_919;
									       {
										  obj_t arg1471_920;
										  {
										     obj_t arg1472_921;
										     {
											obj_t aux_1722;
											aux_1722 = BCHAR(((unsigned char) '\n'));
											arg1472_921 = MAKE_PAIR(aux_1722, BNIL);
										     }
										     arg1471_920 = MAKE_PAIR(string1683_integrate_g, arg1472_921);
										  }
										  arg1470_919 = MAKE_PAIR(arg1463_914, arg1471_920);
									       }
									       arg1468_918 = MAKE_PAIR(string1684_integrate_g, arg1470_919);
									    }
									    arg1467_917 = MAKE_PAIR(arg1458_912, arg1468_918);
									 }
									 list1466_916 = MAKE_PAIR(string1687_integrate_g, arg1467_917);
								      }
								      print_trace_107_tools_trace(list1466_916);
								   }
								}
							      else
								{
								   BUNSPEC;
								}
							   }
							   {
							      obj_t res1674_1393;
							      {
								 sfun_iinfo_105_t obj_1391;
								 obj_1391 = (sfun_iinfo_105_t) (gif_872);
								 {
								    obj_t x_1490;
								    {
								       obj_t aux_1732;
								       {
									  object_t aux_1733;
									  aux_1733 = (object_t) (obj_1391);
									  aux_1732 = OBJECT_WIDENING(aux_1733);
								       }
								       x_1490 = ((((sfun_iinfo_105_t) CREF(aux_1732))->l) = ((obj_t) f_862), BUNSPEC);
								    }
								    res1674_1393 = BUNSPEC;
								 }
							      }
							      res1674_1393;
							   }
							   {
							      bool_t stop__17_1739;
							      obj_t ct_1737;
							      ct_1737 = CDR(ct_864);
							      stop__17_1739 = ((bool_t) 0);
							      stop__17_865 = stop__17_1739;
							      ct_864 = ct_1737;
							      goto laap_867;
							   }
							}
						   }
						}
					      else
						{
						   bool_t test1481_927;
						   {
						      obj_t aux_1740;
						      {
							 sfun_iinfo_105_t obj_1395;
							 obj_1395 = (sfun_iinfo_105_t) (gif_872);
							 {
							    obj_t aux_1742;
							    {
							       object_t aux_1743;
							       aux_1743 = (object_t) (obj_1395);
							       aux_1742 = OBJECT_WIDENING(aux_1743);
							    }
							    aux_1740 = (((sfun_iinfo_105_t) CREF(aux_1742))->l);
							 }
						      }
						      test1481_927 = is_a__118___object(aux_1740, variable_ast_var);
						   }
						   if (test1481_927)
						     {
							bool_t test1482_928;
							{
							   obj_t aux_1749;
							   {
							      sfun_iinfo_105_t obj_1397;
							      obj_1397 = (sfun_iinfo_105_t) (fif_863);
							      {
								 obj_t aux_1751;
								 {
								    object_t aux_1752;
								    aux_1752 = (object_t) (obj_1397);
								    aux_1751 = OBJECT_WIDENING(aux_1752);
								 }
								 aux_1749 = (((sfun_iinfo_105_t) CREF(aux_1751))->l);
							      }
							   }
							   test1482_928 = is_a__118___object(aux_1749, variable_ast_var);
							}
							if (test1482_928)
							  {
							     bool_t test_1758;
							     {
								obj_t aux_1766;
								obj_t aux_1759;
								{
								   sfun_iinfo_105_t obj_1400;
								   obj_1400 = (sfun_iinfo_105_t) (gif_872);
								   {
								      obj_t aux_1768;
								      {
									 object_t aux_1769;
									 aux_1769 = (object_t) (obj_1400);
									 aux_1768 = OBJECT_WIDENING(aux_1769);
								      }
								      aux_1766 = (((sfun_iinfo_105_t) CREF(aux_1768))->l);
								   }
								}
								{
								   sfun_iinfo_105_t obj_1399;
								   obj_1399 = (sfun_iinfo_105_t) (fif_863);
								   {
								      obj_t aux_1761;
								      {
									 object_t aux_1762;
									 aux_1762 = (object_t) (obj_1399);
									 aux_1761 = OBJECT_WIDENING(aux_1762);
								      }
								      aux_1759 = (((sfun_iinfo_105_t) CREF(aux_1761))->l);
								   }
								}
								test_1758 = (aux_1759 == aux_1766);
							     }
							     if (test_1758)
							       {
								  {
								     obj_t ct_1774;
								     ct_1774 = CDR(ct_864);
								     ct_864 = ct_1774;
								     goto laap_867;
								  }
							       }
							     else
							       {
								  {
								     obj_t res1675_1406;
								     {
									sfun_iinfo_105_t obj_1404;
									obj_1404 = (sfun_iinfo_105_t) (gif_872);
									{
									   obj_t x_1491;
									   {
									      obj_t aux_1777;
									      {
										 object_t aux_1778;
										 aux_1778 = (object_t) (obj_1404);
										 aux_1777 = OBJECT_WIDENING(aux_1778);
									      }
									      x_1491 = ((((sfun_iinfo_105_t) CREF(aux_1777))->g__219) = ((bool_t) ((bool_t) 1)), BUNSPEC);
									   }
									   res1675_1406 = BUNSPEC;
									}
								     }
								     res1675_1406;
								  }
								  {
								     bool_t test1485_931;
								     {
									obj_t aux_1782;
									aux_1782 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
									test1485_931 = CBOOL(aux_1782);
								     }
								     if (test1485_931)
								       {
									  obj_t arg1487_933;
									  arg1487_933 = shape_tools_shape(g_871);
									  {
									     obj_t list1490_935;
									     {
										obj_t arg1493_936;
										{
										   obj_t arg1494_937;
										   {
										      obj_t arg1496_938;
										      {
											 obj_t aux_1789;
											 aux_1789 = BCHAR(((unsigned char) '\n'));
											 arg1496_938 = MAKE_PAIR(aux_1789, BNIL);
										      }
										      arg1494_937 = MAKE_PAIR(string1683_integrate_g, arg1496_938);
										   }
										   arg1493_936 = MAKE_PAIR(arg1487_933, arg1494_937);
										}
										list1490_935 = MAKE_PAIR(string1688_integrate_g, arg1493_936);
									     }
									     print_trace_107_tools_trace(list1490_935);
									  }
								       }
								     else
								       {
									  BUNSPEC;
								       }
								  }
								  {
								     obj_t arg1500_942;
								     obj_t arg1501_943;
								     arg1500_942 = CDR(ct_864);
								     arg1501_943 = MAKE_PAIR(g_871, gs_866);
								     {
									obj_t gs_1800;
									bool_t stop__17_1799;
									obj_t ct_1798;
									ct_1798 = arg1500_942;
									stop__17_1799 = ((bool_t) 0);
									gs_1800 = arg1501_943;
									gs_866 = gs_1800;
									stop__17_865 = stop__17_1799;
									ct_864 = ct_1798;
									goto laap_867;
								     }
								  }
							       }
							  }
							else
							  {
							     {
								bool_t test1507_946;
								{
								   obj_t aux_1801;
								   aux_1801 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
								   test1507_946 = CBOOL(aux_1801);
								}
								if (test1507_946)
								  {
								     obj_t arg1510_948;
								     obj_t arg1513_950;
								     {
									obj_t aux_1807;
									{
									   sfun_iinfo_105_t obj_1410;
									   obj_1410 = (sfun_iinfo_105_t) (gif_872);
									   {
									      obj_t aux_1809;
									      {
										 object_t aux_1810;
										 aux_1810 = (object_t) (obj_1410);
										 aux_1809 = OBJECT_WIDENING(aux_1810);
									      }
									      aux_1807 = (((sfun_iinfo_105_t) CREF(aux_1809))->l);
									   }
									}
									arg1510_948 = shape_tools_shape(aux_1807);
								     }
								     arg1513_950 = shape_tools_shape(f_862);
								     {
									obj_t list1515_952;
									{
									   obj_t arg1517_953;
									   {
									      obj_t arg1518_954;
									      {
										 obj_t arg1520_955;
										 {
										    obj_t arg1522_956;
										    {
										       obj_t arg1523_957;
										       {
											  obj_t aux_1816;
											  aux_1816 = BCHAR(((unsigned char) '\n'));
											  arg1523_957 = MAKE_PAIR(aux_1816, BNIL);
										       }
										       arg1522_956 = MAKE_PAIR(string1683_integrate_g, arg1523_957);
										    }
										    arg1520_955 = MAKE_PAIR(arg1513_950, arg1522_956);
										 }
										 arg1518_954 = MAKE_PAIR(string1684_integrate_g, arg1520_955);
									      }
									      arg1517_953 = MAKE_PAIR(arg1510_948, arg1518_954);
									   }
									   list1515_952 = MAKE_PAIR(string1689_integrate_g, arg1517_953);
									}
									print_trace_107_tools_trace(list1515_952);
								     }
								  }
								else
								  {
								     BUNSPEC;
								  }
							     }
							     {
								obj_t arg1532_962;
								{
								   sfun_iinfo_105_t obj_1411;
								   obj_1411 = (sfun_iinfo_105_t) (gif_872);
								   {
								      obj_t aux_1826;
								      {
									 object_t aux_1827;
									 aux_1827 = (object_t) (obj_1411);
									 aux_1826 = OBJECT_WIDENING(aux_1827);
								      }
								      arg1532_962 = (((sfun_iinfo_105_t) CREF(aux_1826))->l);
								   }
								}
								{
								   obj_t res1676_1414;
								   {
								      sfun_iinfo_105_t obj_1412;
								      obj_1412 = (sfun_iinfo_105_t) (fif_863);
								      {
									 obj_t x_1492;
									 {
									    obj_t aux_1832;
									    {
									       object_t aux_1833;
									       aux_1833 = (object_t) (obj_1412);
									       aux_1832 = OBJECT_WIDENING(aux_1833);
									    }
									    x_1492 = ((((sfun_iinfo_105_t) CREF(aux_1832))->l) = ((obj_t) arg1532_962), BUNSPEC);
									 }
									 res1676_1414 = BUNSPEC;
								      }
								   }
								   res1676_1414;
								}
							     }
							     {
								bool_t stop__17_1839;
								obj_t ct_1837;
								ct_1837 = CDR(ct_864);
								stop__17_1839 = ((bool_t) 0);
								stop__17_865 = stop__17_1839;
								ct_864 = ct_1837;
								goto laap_867;
							     }
							  }
						     }
						   else
						     {
							{
							   bool_t test1536_965;
							   {
							      obj_t aux_1840;
							      {
								 sfun_iinfo_105_t obj_1416;
								 obj_1416 = (sfun_iinfo_105_t) (fif_863);
								 {
								    obj_t aux_1842;
								    {
								       object_t aux_1843;
								       aux_1843 = (object_t) (obj_1416);
								       aux_1842 = OBJECT_WIDENING(aux_1843);
								    }
								    aux_1840 = (((sfun_iinfo_105_t) CREF(aux_1842))->l);
								 }
							      }
							      test1536_965 = is_a__118___object(aux_1840, variable_ast_var);
							   }
							   if (test1536_965)
							     {
								{
								   obj_t arg1537_966;
								   {
								      sfun_iinfo_105_t obj_1418;
								      obj_1418 = (sfun_iinfo_105_t) (fif_863);
								      {
									 obj_t aux_1850;
									 {
									    object_t aux_1851;
									    aux_1851 = (object_t) (obj_1418);
									    aux_1850 = OBJECT_WIDENING(aux_1851);
									 }
									 arg1537_966 = (((sfun_iinfo_105_t) CREF(aux_1850))->l);
								      }
								   }
								   {
								      obj_t res1677_1421;
								      {
									 sfun_iinfo_105_t obj_1419;
									 obj_1419 = (sfun_iinfo_105_t) (gif_872);
									 {
									    obj_t x_1493;
									    {
									       obj_t aux_1856;
									       {
										  object_t aux_1857;
										  aux_1857 = (object_t) (obj_1419);
										  aux_1856 = OBJECT_WIDENING(aux_1857);
									       }
									       x_1493 = ((((sfun_iinfo_105_t) CREF(aux_1856))->l) = ((obj_t) arg1537_966), BUNSPEC);
									    }
									    res1677_1421 = BUNSPEC;
									 }
								      }
								      res1677_1421;
								   }
								}
								{
								   bool_t test1538_967;
								   {
								      obj_t aux_1861;
								      aux_1861 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
								      test1538_967 = CBOOL(aux_1861);
								   }
								   if (test1538_967)
								     {
									obj_t arg1540_969;
									obj_t arg1542_971;
									{
									   obj_t aux_1867;
									   {
									      sfun_iinfo_105_t obj_1422;
									      obj_1422 = (sfun_iinfo_105_t) (fif_863);
									      {
										 obj_t aux_1869;
										 {
										    object_t aux_1870;
										    aux_1870 = (object_t) (obj_1422);
										    aux_1869 = OBJECT_WIDENING(aux_1870);
										 }
										 aux_1867 = (((sfun_iinfo_105_t) CREF(aux_1869))->l);
									      }
									   }
									   arg1540_969 = shape_tools_shape(aux_1867);
									}
									arg1542_971 = shape_tools_shape(g_871);
									{
									   obj_t list1544_973;
									   {
									      obj_t arg1547_974;
									      {
										 obj_t arg1549_975;
										 {
										    obj_t arg1550_976;
										    {
										       obj_t arg1551_977;
										       {
											  obj_t arg1552_978;
											  {
											     obj_t aux_1876;
											     aux_1876 = BCHAR(((unsigned char) '\n'));
											     arg1552_978 = MAKE_PAIR(aux_1876, BNIL);
											  }
											  arg1551_977 = MAKE_PAIR(string1683_integrate_g, arg1552_978);
										       }
										       arg1550_976 = MAKE_PAIR(arg1542_971, arg1551_977);
										    }
										    arg1549_975 = MAKE_PAIR(string1684_integrate_g, arg1550_976);
										 }
										 arg1547_974 = MAKE_PAIR(arg1540_969, arg1549_975);
									      }
									      list1544_973 = MAKE_PAIR(string1690_integrate_g, arg1547_974);
									   }
									   print_trace_107_tools_trace(list1544_973);
									}
								     }
								   else
								     {
									BUNSPEC;
								     }
								}
								{
								   bool_t stop__17_1887;
								   obj_t ct_1885;
								   ct_1885 = CDR(ct_864);
								   stop__17_1887 = ((bool_t) 0);
								   stop__17_865 = stop__17_1887;
								   ct_864 = ct_1885;
								   goto laap_867;
								}
							     }
							   else
							     {
								{
								   bool_t stop__17_984;
								   if (stop__17_865)
								     {
									bool_t test_1889;
									{
									   obj_t aux_1890;
									   {
									      sfun_iinfo_105_t obj_1424;
									      obj_1424 = (sfun_iinfo_105_t) (fif_863);
									      {
										 obj_t aux_1892;
										 {
										    object_t aux_1893;
										    aux_1893 = (object_t) (obj_1424);
										    aux_1892 = OBJECT_WIDENING(aux_1893);
										 }
										 aux_1890 = (((sfun_iinfo_105_t) CREF(aux_1892))->istamp);
									      }
									   }
									   test_1889 = INTEGERP(aux_1890);
									}
									if (test_1889)
									  {
									     long aux_1898;
									     {
										obj_t aux_1899;
										{
										   sfun_iinfo_105_t obj_1426;
										   obj_1426 = (sfun_iinfo_105_t) (fif_863);
										   {
										      obj_t aux_1901;
										      {
											 object_t aux_1902;
											 aux_1902 = (object_t) (obj_1426);
											 aux_1901 = OBJECT_WIDENING(aux_1902);
										      }
										      aux_1899 = (((sfun_iinfo_105_t) CREF(aux_1901))->istamp);
										   }
										}
										aux_1898 = (long) CINT(aux_1899);
									     }
									     stop__17_984 = (aux_1898 <= stamp_819);
									  }
									else
									  {
									     stop__17_984 = ((bool_t) 0);
									  }
								     }
								   else
								     {
									stop__17_984 = ((bool_t) 0);
								     }
								   {
								      obj_t res1678_1431;
								      {
									 sfun_iinfo_105_t obj_1429;
									 obj_t val1325_1430;
									 obj_1429 = (sfun_iinfo_105_t) (fif_863);
									 val1325_1430 = BINT(stamp_819);
									 {
									    obj_t x_1494;
									    {
									       obj_t aux_1910;
									       {
										  object_t aux_1911;
										  aux_1911 = (object_t) (obj_1429);
										  aux_1910 = OBJECT_WIDENING(aux_1911);
									       }
									       x_1494 = ((((sfun_iinfo_105_t) CREF(aux_1910))->istamp) = ((obj_t) val1325_1430), BUNSPEC);
									    }
									    res1678_1431 = BUNSPEC;
									 }
								      }
								      res1678_1431;
								   }
								   {
								      bool_t stop__17_1917;
								      obj_t ct_1915;
								      ct_1915 = CDR(ct_864);
								      stop__17_1917 = stop__17_984;
								      stop__17_865 = stop__17_1917;
								      ct_864 = ct_1915;
								      goto laap_867;
								   }
								}
							     }
							}
						     }
						}
					   }
				      }
				 }
			      }
			   }
		      }
		   }
		}
	     }
	}
   }
}


obj_t 
_g__236_integrate_g(obj_t env_1486, obj_t g_cn_224_1487)
{
   return g__63_integrate_g(g_cn_224_1487);
}


obj_t 
imported_modules_init_94_integrate_g()
{
   module_initialization_70_tools_trace(((long) 0), "INTEGRATE_G");
   module_initialization_70_tools_shape(((long) 0), "INTEGRATE_G");
   module_initialization_70_type_type(((long) 0), "INTEGRATE_G");
   module_initialization_70_ast_var(((long) 0), "INTEGRATE_G");
   module_initialization_70_ast_node(((long) 0), "INTEGRATE_G");
   module_initialization_70_integrate_info(((long) 0), "INTEGRATE_G");
   return module_initialization_70_integrate_a(((long) 0), "INTEGRATE_G");
}
