/*===========================================================================*/
/*   (Integrate/iinfo.scm)                                                   */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_t;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_t;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_t;


static sfun_t allocate_sfun_iinfo_8_integrate_info();
extern obj_t _struct_object__object_6___object(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_integrate_info();
static obj_t struct_object__object_sfun_iinfo1658_206_integrate_info(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t sexit_ast_var;
static obj_t toplevel_init_63_integrate_info();
static obj_t _allocate_sexit_iinfo_189_integrate_info(obj_t);
static obj_t cnst_init_137_integrate_info();
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
static obj_t require_initialization_114_integrate_info = BUNSPEC;
obj_t sfun_iinfo_105_integrate_info = BUNSPEC;
static obj_t library_modules_init_112_integrate_info();
static svar_t allocate_svar_iinfo_15_integrate_info();
static sexit_t allocate_sexit_iinfo_139_integrate_info();
obj_t svar_iinfo_76_integrate_info = BUNSPEC;
extern obj_t sfun_ast_var;
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
static obj_t _allocate_sfun_iinfo_52_integrate_info(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t object__struct_50___object(object_t);
static obj_t object__struct_sfun_iinfo1659_201_integrate_info(obj_t, obj_t);
static obj_t object__struct_svar_iinfo1655_251_integrate_info(obj_t, obj_t);
extern obj_t svar_ast_var;
static obj_t object_init_111_integrate_info();
static obj_t object__struct_sexit_iinfo1657_214_integrate_info(obj_t, obj_t);
static obj_t struct_object__object_sexit_iinfo1656_206_integrate_info(obj_t, obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
obj_t sexit_iinfo_190_integrate_info = BUNSPEC;
extern obj_t make_struct(obj_t, long, obj_t);
static obj_t _allocate_svar_iinfo_246_integrate_info(obj_t);
extern obj_t _object__struct_74___object(obj_t, obj_t);
static obj_t struct_object__object_svar_iinfo1654_128_integrate_info(obj_t, obj_t, obj_t);
extern object_t struct_object__object_93___object(object_t, obj_t);
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t);
static obj_t __cnst[3];

DEFINE_STATIC_PROCEDURE(allocate_sfun_iinfo_env_130_integrate_info, _allocate_sfun_iinfo_52_integrate_info1673, _allocate_sfun_iinfo_52_integrate_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1663_integrate_info, struct_object__object_sexit_iinfo1656_206_integrate_info1674, struct_object__object_sexit_iinfo1656_206_integrate_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1662_integrate_info, object__struct_sexit_iinfo1657_214_integrate_info1675, object__struct_sexit_iinfo1657_214_integrate_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1661_integrate_info, struct_object__object_sfun_iinfo1658_206_integrate_info1676, struct_object__object_sfun_iinfo1658_206_integrate_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_sexit_iinfo_env_116_integrate_info, _allocate_sexit_iinfo_189_integrate_info1677, _allocate_sexit_iinfo_189_integrate_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1664_integrate_info, object__struct_svar_iinfo1655_251_integrate_info1678, object__struct_svar_iinfo1655_251_integrate_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_svar_iinfo_env_27_integrate_info, _allocate_svar_iinfo_246_integrate_info1679, _allocate_svar_iinfo_246_integrate_info, 0L, 0);
extern obj_t struct_object__object_env_209___object;
DEFINE_STRING(string1666_integrate_info, string1666_integrate_info1680, "SFUN/IINFO SEXIT/IINFO SVAR/IINFO ", 34);
DEFINE_STATIC_PROCEDURE(proc1665_integrate_info, struct_object__object_svar_iinfo1654_128_integrate_info1681, struct_object__object_svar_iinfo1654_128_integrate_info, 0L, 2);
extern obj_t object__struct_env_210___object;
DEFINE_STATIC_PROCEDURE(proc1660_integrate_info, object__struct_sfun_iinfo1659_201_integrate_info1682, object__struct_sfun_iinfo1659_201_integrate_info, 0L, 1);

obj_t 
module_initialization_70_integrate_info(long checksum_1685, char *from_1686)
{
   if (CBOOL(require_initialization_114_integrate_info))
     {
	require_initialization_114_integrate_info = BBOOL(((bool_t) 0));
	library_modules_init_112_integrate_info();
	cnst_init_137_integrate_info();
	object_init_111_integrate_info();
	imported_modules_init_94_integrate_info();
	toplevel_init_63_integrate_info();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_integrate_info()
{
   module_initialization_70___object(((long) 0), "INTEGRATE_INFO");
   module_initialization_70___reader(((long) 0), "INTEGRATE_INFO");
   return BUNSPEC;
}


obj_t 
cnst_init_137_integrate_info()
{
   {
      obj_t cnst_port_138_1677;
      cnst_port_138_1677 = open_input_string(string1666_integrate_info);
      {
	 long i_1678;
	 i_1678 = ((long) 2);
       loop_1679:
	 {
	    bool_t test1667_1680;
	    test1667_1680 = (i_1678 == ((long) -1));
	    if (test1667_1680)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1668_1681;
		    {
		       obj_t list1669_1682;
		       {
			  obj_t arg1671_1683;
			  arg1671_1683 = BNIL;
			  list1669_1682 = MAKE_PAIR(cnst_port_138_1677, arg1671_1683);
		       }
		       arg1668_1681 = read___reader(list1669_1682);
		    }
		    CNST_TABLE_SET(i_1678, arg1668_1681);
		 }
		 {
		    int aux_1684;
		    {
		       long aux_1703;
		       aux_1703 = (i_1678 - ((long) 1));
		       aux_1684 = (int) (aux_1703);
		    }
		    {
		       long i_1706;
		       i_1706 = (long) (aux_1684);
		       i_1678 = i_1706;
		       goto loop_1679;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_integrate_info()
{
   return BUNSPEC;
}


obj_t 
object_init_111_integrate_info()
{
   {
      obj_t arg1363_818;
      arg1363_818 = svar_ast_var;
      svar_iinfo_76_integrate_info = add_class__117___object(CNST_TABLE_REF(((long) 0)), arg1363_818, allocate_svar_iinfo_env_27_integrate_info, ((long) 30570), BUNSPEC);
   }
   {
      obj_t arg1369_822;
      arg1369_822 = sexit_ast_var;
      sexit_iinfo_190_integrate_info = add_class__117___object(CNST_TABLE_REF(((long) 1)), arg1369_822, allocate_sexit_iinfo_env_116_integrate_info, ((long) 54221), BUNSPEC);
   }
   {
      obj_t arg1379_826;
      arg1379_826 = sfun_ast_var;
      sfun_iinfo_105_integrate_info = add_class__117___object(CNST_TABLE_REF(((long) 2)), arg1379_826, allocate_sfun_iinfo_env_130_integrate_info, ((long) 61265), BUNSPEC);
   }
   {
      obj_t object__struct_sfun_iinfo_106_1658;
      object__struct_sfun_iinfo_106_1658 = proc1660_integrate_info;
      add_method__1___object(object__struct_env_210___object, sfun_iinfo_105_integrate_info, object__struct_sfun_iinfo_106_1658);
   }
   {
      obj_t struct_object__object_sfun_iinfo_5_1657;
      struct_object__object_sfun_iinfo_5_1657 = proc1661_integrate_info;
      add_method__1___object(struct_object__object_env_209___object, sfun_iinfo_105_integrate_info, struct_object__object_sfun_iinfo_5_1657);
   }
   {
      obj_t object__struct_sexit_iinfo_21_1656;
      object__struct_sexit_iinfo_21_1656 = proc1662_integrate_info;
      add_method__1___object(object__struct_env_210___object, sexit_iinfo_190_integrate_info, object__struct_sexit_iinfo_21_1656);
   }
   {
      obj_t struct_object__object_sexit_iinfo_149_1655;
      struct_object__object_sexit_iinfo_149_1655 = proc1663_integrate_info;
      add_method__1___object(struct_object__object_env_209___object, sexit_iinfo_190_integrate_info, struct_object__object_sexit_iinfo_149_1655);
   }
   {
      obj_t object__struct_svar_iinfo_184_1652;
      object__struct_svar_iinfo_184_1652 = proc1664_integrate_info;
      add_method__1___object(object__struct_env_210___object, svar_iinfo_76_integrate_info, object__struct_svar_iinfo_184_1652);
   }
   {
      obj_t struct_object__object_svar_iinfo_213_1648;
      struct_object__object_svar_iinfo_213_1648 = proc1665_integrate_info;
      return add_method__1___object(struct_object__object_env_209___object, svar_iinfo_76_integrate_info, struct_object__object_svar_iinfo_213_1648);
   }
}


obj_t 
struct_object__object_svar_iinfo1654_128_integrate_info(obj_t env_1659, obj_t o_1660, obj_t s_1661)
{
   {
      svar_iinfo_76_t o_955;
      obj_t s_956;
      {
	 svar_iinfo_76_t aux_1720;
	 o_955 = (svar_iinfo_76_t) (o_1660);
	 s_956 = s_1661;
	 {
	    {
	       obj_t old1288_959;
	       obj_t aux1289_960;
	       {
		  obj_t next_method1359_60_968;
		  next_method1359_60_968 = find_super_class_method_167___object((object_t) (o_955), struct_object__object_env_209___object, svar_iinfo_76_integrate_info);
		  if (PROCEDUREP(next_method1359_60_968))
		    {
		       old1288_959 = PROCEDURE_ENTRY(next_method1359_60_968) (next_method1359_60_968, (obj_t) (o_955), s_956, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1359_60_968);
		       {
			  object_t aux_1729;
			  aux_1729 = struct_object__object_93___object((object_t) (o_955), s_956);
			  old1288_959 = (obj_t) (aux_1729);
		       }
		    }
	       }
	       aux1289_960 = STRUCT_REF(s_956, ((long) 0));
	       {
		  svar_iinfo_76_t new1290_961;
		  new1290_961 = ((svar_iinfo_76_t) (old1288_959));
		  {
		     long arg1534_962;
		     arg1534_962 = class_num_218___object(svar_iinfo_76_integrate_info);
		     {
			obj_t obj_1567;
			obj_1567 = (obj_t) (new1290_961);
			(((obj_t) CREF(obj_1567))->header = MAKE_HEADER(arg1534_962, 0), BUNSPEC);
		     }
		  }
		  {
		     svar_iinfo_76_t arg1535_963;
		     {
			obj_t arg1536_964;
			obj_t arg1537_965;
			arg1536_964 = STRUCT_REF(aux1289_960, ((long) 0));
			arg1537_965 = STRUCT_REF(aux1289_960, ((long) 1));
			{
			   svar_iinfo_76_t res1650_1586;
			   {
			      bool_t kaptured__204_1579;
			      bool_t celled__113_1580;
			      {
				 obj_t aux_1740;
				 aux_1740 = STRUCT_REF(aux1289_960, ((long) 2));
				 kaptured__204_1579 = CBOOL(aux_1740);
			      }
			      {
				 obj_t aux_1743;
				 aux_1743 = STRUCT_REF(aux1289_960, ((long) 3));
				 celled__113_1580 = CBOOL(aux_1743);
			      }
			      {
				 svar_iinfo_76_t new1275_1581;
				 new1275_1581 = ((svar_iinfo_76_t) BREF(GC_MALLOC(sizeof(struct svar_iinfo_76))));
				 ((((svar_iinfo_76_t) CREF(new1275_1581))->f_mark_181) = ((obj_t) arg1536_964), BUNSPEC);
				 ((((svar_iinfo_76_t) CREF(new1275_1581))->u_mark_209) = ((obj_t) arg1537_965), BUNSPEC);
				 ((((svar_iinfo_76_t) CREF(new1275_1581))->kaptured__204) = ((bool_t) kaptured__204_1579), BUNSPEC);
				 ((((svar_iinfo_76_t) CREF(new1275_1581))->celled__113) = ((bool_t) celled__113_1580), BUNSPEC);
				 res1650_1586 = new1275_1581;
			      }
			   }
			   arg1535_963 = res1650_1586;
			}
		     }
		     {
			obj_t aux_1753;
			object_t aux_1751;
			aux_1753 = (obj_t) (arg1535_963);
			aux_1751 = (object_t) (new1290_961);
			OBJECT_WIDENING_SET(aux_1751, aux_1753);
		     }
		  }
		  aux_1720 = new1290_961;
	       }
	    }
	 }
	 return (obj_t) (aux_1720);
      }
   }
}


obj_t 
object__struct_svar_iinfo1655_251_integrate_info(obj_t env_1662, obj_t obj1285_1663)
{
   {
      svar_iinfo_76_t obj1285_936;
      obj1285_936 = (svar_iinfo_76_t) (obj1285_1663);
      {
	 {
	    obj_t res1286_939;
	    {
	       obj_t next_method1358_66_953;
	       next_method1358_66_953 = find_super_class_method_167___object((object_t) (obj1285_936), object__struct_env_210___object, svar_iinfo_76_integrate_info);
	       if (PROCEDUREP(next_method1358_66_953))
		 {
		    res1286_939 = PROCEDURE_ENTRY(next_method1358_66_953) (next_method1358_66_953, (obj_t) (obj1285_936), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1358_66_953);
		    res1286_939 = object__struct_50___object((object_t) (obj1285_936));
		 }
	    }
	    {
	       obj_t aux1287_940;
	       {
		  obj_t aux_1768;
		  aux_1768 = CNST_TABLE_REF(((long) 0));
		  aux1287_940 = make_struct(aux_1768, ((long) 4), BUNSPEC);
	       }
	       {
		  obj_t aux_1771;
		  {
		     obj_t aux_1772;
		     {
			object_t aux_1773;
			aux_1773 = (object_t) (obj1285_936);
			aux_1772 = OBJECT_WIDENING(aux_1773);
		     }
		     aux_1771 = (((svar_iinfo_76_t) CREF(aux_1772))->f_mark_181);
		  }
		  STRUCT_SET(aux1287_940, ((long) 0), aux_1771);
	       }
	       {
		  obj_t aux_1778;
		  {
		     obj_t aux_1779;
		     {
			object_t aux_1780;
			aux_1780 = (object_t) (obj1285_936);
			aux_1779 = OBJECT_WIDENING(aux_1780);
		     }
		     aux_1778 = (((svar_iinfo_76_t) CREF(aux_1779))->u_mark_209);
		  }
		  STRUCT_SET(aux1287_940, ((long) 1), aux_1778);
	       }
	       {
		  obj_t aux_1785;
		  {
		     bool_t aux_1786;
		     {
			obj_t aux_1787;
			{
			   object_t aux_1788;
			   aux_1788 = (object_t) (obj1285_936);
			   aux_1787 = OBJECT_WIDENING(aux_1788);
			}
			aux_1786 = (((svar_iinfo_76_t) CREF(aux_1787))->kaptured__204);
		     }
		     aux_1785 = BBOOL(aux_1786);
		  }
		  STRUCT_SET(aux1287_940, ((long) 2), aux_1785);
	       }
	       {
		  obj_t aux_1794;
		  {
		     bool_t aux_1795;
		     {
			obj_t aux_1796;
			{
			   object_t aux_1797;
			   aux_1797 = (object_t) (obj1285_936);
			   aux_1796 = OBJECT_WIDENING(aux_1797);
			}
			aux_1795 = (((svar_iinfo_76_t) CREF(aux_1796))->celled__113);
		     }
		     aux_1794 = BBOOL(aux_1795);
		  }
		  STRUCT_SET(aux1287_940, ((long) 3), aux_1794);
	       }
	       STRUCT_SET(res1286_939, ((long) 0), aux1287_940);
	       {
		  obj_t aux_1804;
		  aux_1804 = STRUCT_KEY(res1286_939);
		  STRUCT_KEY_SET(aux1287_940, aux_1804);
	       }
	       {
		  obj_t aux_1807;
		  aux_1807 = CNST_TABLE_REF(((long) 0));
		  STRUCT_KEY_SET(res1286_939, aux_1807);
	       }
	       return res1286_939;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_sexit_iinfo1656_206_integrate_info(obj_t env_1664, obj_t o_1665, obj_t s_1666)
{
   {
      sexit_iinfo_190_t o_921;
      obj_t s_922;
      {
	 sexit_iinfo_190_t aux_1811;
	 o_921 = (sexit_iinfo_190_t) (o_1665);
	 s_922 = s_1666;
	 {
	    {
	       obj_t old1306_925;
	       obj_t aux1307_926;
	       {
		  obj_t next_method1357_79_934;
		  next_method1357_79_934 = find_super_class_method_167___object((object_t) (o_921), struct_object__object_env_209___object, sexit_iinfo_190_integrate_info);
		  if (PROCEDUREP(next_method1357_79_934))
		    {
		       old1306_925 = PROCEDURE_ENTRY(next_method1357_79_934) (next_method1357_79_934, (obj_t) (o_921), s_922, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1357_79_934);
		       {
			  object_t aux_1820;
			  aux_1820 = struct_object__object_93___object((object_t) (o_921), s_922);
			  old1306_925 = (obj_t) (aux_1820);
		       }
		    }
	       }
	       aux1307_926 = STRUCT_REF(s_922, ((long) 0));
	       {
		  sexit_iinfo_190_t new1308_927;
		  new1308_927 = ((sexit_iinfo_190_t) (old1306_925));
		  {
		     long arg1501_928;
		     arg1501_928 = class_num_218___object(sexit_iinfo_190_integrate_info);
		     {
			obj_t obj_1514;
			obj_1514 = (obj_t) (new1308_927);
			(((obj_t) CREF(obj_1514))->header = MAKE_HEADER(arg1501_928, 0), BUNSPEC);
		     }
		  }
		  {
		     sexit_iinfo_190_t arg1505_929;
		     {
			obj_t arg1506_930;
			obj_t arg1507_931;
			arg1506_930 = STRUCT_REF(aux1307_926, ((long) 0));
			arg1507_931 = STRUCT_REF(aux1307_926, ((long) 1));
			{
			   sexit_iinfo_190_t res1649_1533;
			   {
			      bool_t kaptured__204_1526;
			      bool_t celled__113_1527;
			      {
				 obj_t aux_1831;
				 aux_1831 = STRUCT_REF(aux1307_926, ((long) 2));
				 kaptured__204_1526 = CBOOL(aux_1831);
			      }
			      {
				 obj_t aux_1834;
				 aux_1834 = STRUCT_REF(aux1307_926, ((long) 3));
				 celled__113_1527 = CBOOL(aux_1834);
			      }
			      {
				 sexit_iinfo_190_t new1292_1528;
				 new1292_1528 = ((sexit_iinfo_190_t) BREF(GC_MALLOC(sizeof(struct sexit_iinfo_190))));
				 ((((sexit_iinfo_190_t) CREF(new1292_1528))->f_mark_181) = ((obj_t) arg1506_930), BUNSPEC);
				 ((((sexit_iinfo_190_t) CREF(new1292_1528))->u_mark_209) = ((obj_t) arg1507_931), BUNSPEC);
				 ((((sexit_iinfo_190_t) CREF(new1292_1528))->kaptured__204) = ((bool_t) kaptured__204_1526), BUNSPEC);
				 ((((sexit_iinfo_190_t) CREF(new1292_1528))->celled__113) = ((bool_t) celled__113_1527), BUNSPEC);
				 res1649_1533 = new1292_1528;
			      }
			   }
			   arg1505_929 = res1649_1533;
			}
		     }
		     {
			obj_t aux_1844;
			object_t aux_1842;
			aux_1844 = (obj_t) (arg1505_929);
			aux_1842 = (object_t) (new1308_927);
			OBJECT_WIDENING_SET(aux_1842, aux_1844);
		     }
		  }
		  aux_1811 = new1308_927;
	       }
	    }
	 }
	 return (obj_t) (aux_1811);
      }
   }
}


obj_t 
object__struct_sexit_iinfo1657_214_integrate_info(obj_t env_1667, obj_t obj1303_1668)
{
   {
      sexit_iinfo_190_t obj1303_902;
      obj1303_902 = (sexit_iinfo_190_t) (obj1303_1668);
      {
	 {
	    obj_t res1304_905;
	    {
	       obj_t next_method1356_46_919;
	       next_method1356_46_919 = find_super_class_method_167___object((object_t) (obj1303_902), object__struct_env_210___object, sexit_iinfo_190_integrate_info);
	       if (PROCEDUREP(next_method1356_46_919))
		 {
		    res1304_905 = PROCEDURE_ENTRY(next_method1356_46_919) (next_method1356_46_919, (obj_t) (obj1303_902), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1356_46_919);
		    res1304_905 = object__struct_50___object((object_t) (obj1303_902));
		 }
	    }
	    {
	       obj_t aux1305_906;
	       {
		  obj_t aux_1859;
		  aux_1859 = CNST_TABLE_REF(((long) 1));
		  aux1305_906 = make_struct(aux_1859, ((long) 4), BUNSPEC);
	       }
	       {
		  obj_t aux_1862;
		  {
		     obj_t aux_1863;
		     {
			object_t aux_1864;
			aux_1864 = (object_t) (obj1303_902);
			aux_1863 = OBJECT_WIDENING(aux_1864);
		     }
		     aux_1862 = (((sexit_iinfo_190_t) CREF(aux_1863))->f_mark_181);
		  }
		  STRUCT_SET(aux1305_906, ((long) 0), aux_1862);
	       }
	       {
		  obj_t aux_1869;
		  {
		     obj_t aux_1870;
		     {
			object_t aux_1871;
			aux_1871 = (object_t) (obj1303_902);
			aux_1870 = OBJECT_WIDENING(aux_1871);
		     }
		     aux_1869 = (((sexit_iinfo_190_t) CREF(aux_1870))->u_mark_209);
		  }
		  STRUCT_SET(aux1305_906, ((long) 1), aux_1869);
	       }
	       {
		  obj_t aux_1876;
		  {
		     bool_t aux_1877;
		     {
			obj_t aux_1878;
			{
			   object_t aux_1879;
			   aux_1879 = (object_t) (obj1303_902);
			   aux_1878 = OBJECT_WIDENING(aux_1879);
			}
			aux_1877 = (((sexit_iinfo_190_t) CREF(aux_1878))->kaptured__204);
		     }
		     aux_1876 = BBOOL(aux_1877);
		  }
		  STRUCT_SET(aux1305_906, ((long) 2), aux_1876);
	       }
	       {
		  obj_t aux_1885;
		  {
		     bool_t aux_1886;
		     {
			obj_t aux_1887;
			{
			   object_t aux_1888;
			   aux_1888 = (object_t) (obj1303_902);
			   aux_1887 = OBJECT_WIDENING(aux_1888);
			}
			aux_1886 = (((sexit_iinfo_190_t) CREF(aux_1887))->celled__113);
		     }
		     aux_1885 = BBOOL(aux_1886);
		  }
		  STRUCT_SET(aux1305_906, ((long) 3), aux_1885);
	       }
	       STRUCT_SET(res1304_905, ((long) 0), aux1305_906);
	       {
		  obj_t aux_1895;
		  aux_1895 = STRUCT_KEY(res1304_905);
		  STRUCT_KEY_SET(aux1305_906, aux_1895);
	       }
	       {
		  obj_t aux_1898;
		  aux_1898 = CNST_TABLE_REF(((long) 1));
		  STRUCT_KEY_SET(res1304_905, aux_1898);
	       }
	       return res1304_905;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_sfun_iinfo1658_206_integrate_info(obj_t env_1669, obj_t o_1670, obj_t s_1671)
{
   {
      sfun_iinfo_105_t o_874;
      obj_t s_875;
      {
	 sfun_iinfo_105_t aux_1902;
	 o_874 = (sfun_iinfo_105_t) (o_1670);
	 s_875 = s_1671;
	 {
	    {
	       obj_t old1345_878;
	       obj_t aux1346_879;
	       {
		  obj_t next_method1355_156_900;
		  next_method1355_156_900 = find_super_class_method_167___object((object_t) (o_874), struct_object__object_env_209___object, sfun_iinfo_105_integrate_info);
		  if (PROCEDUREP(next_method1355_156_900))
		    {
		       old1345_878 = PROCEDURE_ENTRY(next_method1355_156_900) (next_method1355_156_900, (obj_t) (o_874), s_875, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1355_156_900);
		       {
			  object_t aux_1911;
			  aux_1911 = struct_object__object_93___object((object_t) (o_874), s_875);
			  old1345_878 = (obj_t) (aux_1911);
		       }
		    }
	       }
	       aux1346_879 = STRUCT_REF(s_875, ((long) 0));
	       {
		  sfun_iinfo_105_t new1347_880;
		  new1347_880 = ((sfun_iinfo_105_t) (old1345_878));
		  {
		     long arg1452_881;
		     arg1452_881 = class_num_218___object(sfun_iinfo_105_integrate_info);
		     {
			obj_t obj_1409;
			obj_1409 = (obj_t) (new1347_880);
			(((obj_t) CREF(obj_1409))->header = MAKE_HEADER(arg1452_881, 0), BUNSPEC);
		     }
		  }
		  {
		     sfun_iinfo_105_t arg1453_882;
		     {
			obj_t arg1454_883;
			obj_t arg1457_884;
			obj_t arg1458_885;
			obj_t arg1461_886;
			obj_t arg1463_887;
			obj_t arg1465_888;
			obj_t arg1466_889;
			obj_t arg1467_890;
			obj_t arg1468_891;
			obj_t arg1470_892;
			obj_t arg1471_893;
			obj_t arg1474_895;
			obj_t arg1476_896;
			obj_t arg1477_897;
			obj_t arg1478_898;
			obj_t arg1480_899;
			arg1454_883 = STRUCT_REF(aux1346_879, ((long) 0));
			arg1457_884 = STRUCT_REF(aux1346_879, ((long) 1));
			arg1458_885 = STRUCT_REF(aux1346_879, ((long) 2));
			arg1461_886 = STRUCT_REF(aux1346_879, ((long) 3));
			arg1463_887 = STRUCT_REF(aux1346_879, ((long) 4));
			arg1465_888 = STRUCT_REF(aux1346_879, ((long) 5));
			arg1466_889 = STRUCT_REF(aux1346_879, ((long) 6));
			arg1467_890 = STRUCT_REF(aux1346_879, ((long) 7));
			arg1468_891 = STRUCT_REF(aux1346_879, ((long) 8));
			arg1470_892 = STRUCT_REF(aux1346_879, ((long) 9));
			arg1471_893 = STRUCT_REF(aux1346_879, ((long) 10));
			arg1474_895 = STRUCT_REF(aux1346_879, ((long) 12));
			arg1476_896 = STRUCT_REF(aux1346_879, ((long) 13));
			arg1477_897 = STRUCT_REF(aux1346_879, ((long) 14));
			arg1478_898 = STRUCT_REF(aux1346_879, ((long) 15));
			arg1480_899 = STRUCT_REF(aux1346_879, ((long) 16));
			{
			   sfun_iinfo_105_t res1648_1480;
			   {
			      bool_t g__219_1456;
			      {
				 obj_t aux_1936;
				 aux_1936 = STRUCT_REF(aux1346_879, ((long) 11));
				 g__219_1456 = CBOOL(aux_1936);
			      }
			      {
				 sfun_iinfo_105_t new1310_1462;
				 new1310_1462 = ((sfun_iinfo_105_t) BREF(GC_MALLOC(sizeof(struct sfun_iinfo_105))));
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->owner) = ((obj_t) arg1454_883), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->free) = ((obj_t) arg1457_884), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->bound) = ((obj_t) arg1458_885), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->cfrom) = ((obj_t) arg1461_886), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->cto) = ((obj_t) arg1463_887), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->k) = ((obj_t) arg1465_888), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->k__190) = ((obj_t) arg1466_889), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->u) = ((obj_t) arg1467_890), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->cn) = ((obj_t) arg1468_891), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->ct) = ((obj_t) arg1470_892), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->kont) = ((obj_t) arg1471_893), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->g__219) = ((bool_t) g__219_1456), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->l) = ((obj_t) arg1474_895), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->led) = ((obj_t) arg1476_896), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->istamp) = ((obj_t) arg1477_897), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->global) = ((obj_t) arg1478_898), BUNSPEC);
				 ((((sfun_iinfo_105_t) CREF(new1310_1462))->kaptured) = ((obj_t) arg1480_899), BUNSPEC);
				 res1648_1480 = new1310_1462;
			      }
			   }
			   arg1453_882 = res1648_1480;
			}
		     }
		     {
			obj_t aux_1959;
			object_t aux_1957;
			aux_1959 = (obj_t) (arg1453_882);
			aux_1957 = (object_t) (new1347_880);
			OBJECT_WIDENING_SET(aux_1957, aux_1959);
		     }
		  }
		  aux_1902 = new1347_880;
	       }
	    }
	 }
	 return (obj_t) (aux_1902);
      }
   }
}


obj_t 
object__struct_sfun_iinfo1659_201_integrate_info(obj_t env_1672, obj_t obj1342_1673)
{
   {
      sfun_iinfo_105_t obj1342_829;
      obj1342_829 = (sfun_iinfo_105_t) (obj1342_1673);
      {
	 {
	    obj_t res1343_832;
	    {
	       obj_t next_method1348_41_872;
	       next_method1348_41_872 = find_super_class_method_167___object((object_t) (obj1342_829), object__struct_env_210___object, sfun_iinfo_105_integrate_info);
	       if (PROCEDUREP(next_method1348_41_872))
		 {
		    res1343_832 = PROCEDURE_ENTRY(next_method1348_41_872) (next_method1348_41_872, (obj_t) (obj1342_829), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1348_41_872);
		    res1343_832 = object__struct_50___object((object_t) (obj1342_829));
		 }
	    }
	    {
	       obj_t aux1344_833;
	       {
		  obj_t aux_1974;
		  aux_1974 = CNST_TABLE_REF(((long) 2));
		  aux1344_833 = make_struct(aux_1974, ((long) 17), BUNSPEC);
	       }
	       {
		  obj_t aux_1977;
		  {
		     obj_t aux_1978;
		     {
			object_t aux_1979;
			aux_1979 = (object_t) (obj1342_829);
			aux_1978 = OBJECT_WIDENING(aux_1979);
		     }
		     aux_1977 = (((sfun_iinfo_105_t) CREF(aux_1978))->owner);
		  }
		  STRUCT_SET(aux1344_833, ((long) 0), aux_1977);
	       }
	       {
		  obj_t aux_1984;
		  {
		     obj_t aux_1985;
		     {
			object_t aux_1986;
			aux_1986 = (object_t) (obj1342_829);
			aux_1985 = OBJECT_WIDENING(aux_1986);
		     }
		     aux_1984 = (((sfun_iinfo_105_t) CREF(aux_1985))->free);
		  }
		  STRUCT_SET(aux1344_833, ((long) 1), aux_1984);
	       }
	       {
		  obj_t aux_1991;
		  {
		     obj_t aux_1992;
		     {
			object_t aux_1993;
			aux_1993 = (object_t) (obj1342_829);
			aux_1992 = OBJECT_WIDENING(aux_1993);
		     }
		     aux_1991 = (((sfun_iinfo_105_t) CREF(aux_1992))->bound);
		  }
		  STRUCT_SET(aux1344_833, ((long) 2), aux_1991);
	       }
	       {
		  obj_t aux_1998;
		  {
		     obj_t aux_1999;
		     {
			object_t aux_2000;
			aux_2000 = (object_t) (obj1342_829);
			aux_1999 = OBJECT_WIDENING(aux_2000);
		     }
		     aux_1998 = (((sfun_iinfo_105_t) CREF(aux_1999))->cfrom);
		  }
		  STRUCT_SET(aux1344_833, ((long) 3), aux_1998);
	       }
	       {
		  obj_t aux_2005;
		  {
		     obj_t aux_2006;
		     {
			object_t aux_2007;
			aux_2007 = (object_t) (obj1342_829);
			aux_2006 = OBJECT_WIDENING(aux_2007);
		     }
		     aux_2005 = (((sfun_iinfo_105_t) CREF(aux_2006))->cto);
		  }
		  STRUCT_SET(aux1344_833, ((long) 4), aux_2005);
	       }
	       {
		  obj_t aux_2012;
		  {
		     obj_t aux_2013;
		     {
			object_t aux_2014;
			aux_2014 = (object_t) (obj1342_829);
			aux_2013 = OBJECT_WIDENING(aux_2014);
		     }
		     aux_2012 = (((sfun_iinfo_105_t) CREF(aux_2013))->k);
		  }
		  STRUCT_SET(aux1344_833, ((long) 5), aux_2012);
	       }
	       {
		  obj_t aux_2019;
		  {
		     obj_t aux_2020;
		     {
			object_t aux_2021;
			aux_2021 = (object_t) (obj1342_829);
			aux_2020 = OBJECT_WIDENING(aux_2021);
		     }
		     aux_2019 = (((sfun_iinfo_105_t) CREF(aux_2020))->k__190);
		  }
		  STRUCT_SET(aux1344_833, ((long) 6), aux_2019);
	       }
	       {
		  obj_t aux_2026;
		  {
		     obj_t aux_2027;
		     {
			object_t aux_2028;
			aux_2028 = (object_t) (obj1342_829);
			aux_2027 = OBJECT_WIDENING(aux_2028);
		     }
		     aux_2026 = (((sfun_iinfo_105_t) CREF(aux_2027))->u);
		  }
		  STRUCT_SET(aux1344_833, ((long) 7), aux_2026);
	       }
	       {
		  obj_t aux_2033;
		  {
		     obj_t aux_2034;
		     {
			object_t aux_2035;
			aux_2035 = (object_t) (obj1342_829);
			aux_2034 = OBJECT_WIDENING(aux_2035);
		     }
		     aux_2033 = (((sfun_iinfo_105_t) CREF(aux_2034))->cn);
		  }
		  STRUCT_SET(aux1344_833, ((long) 8), aux_2033);
	       }
	       {
		  obj_t aux_2040;
		  {
		     obj_t aux_2041;
		     {
			object_t aux_2042;
			aux_2042 = (object_t) (obj1342_829);
			aux_2041 = OBJECT_WIDENING(aux_2042);
		     }
		     aux_2040 = (((sfun_iinfo_105_t) CREF(aux_2041))->ct);
		  }
		  STRUCT_SET(aux1344_833, ((long) 9), aux_2040);
	       }
	       {
		  obj_t aux_2047;
		  {
		     obj_t aux_2048;
		     {
			object_t aux_2049;
			aux_2049 = (object_t) (obj1342_829);
			aux_2048 = OBJECT_WIDENING(aux_2049);
		     }
		     aux_2047 = (((sfun_iinfo_105_t) CREF(aux_2048))->kont);
		  }
		  STRUCT_SET(aux1344_833, ((long) 10), aux_2047);
	       }
	       {
		  obj_t aux_2054;
		  {
		     bool_t aux_2055;
		     {
			obj_t aux_2056;
			{
			   object_t aux_2057;
			   aux_2057 = (object_t) (obj1342_829);
			   aux_2056 = OBJECT_WIDENING(aux_2057);
			}
			aux_2055 = (((sfun_iinfo_105_t) CREF(aux_2056))->g__219);
		     }
		     aux_2054 = BBOOL(aux_2055);
		  }
		  STRUCT_SET(aux1344_833, ((long) 11), aux_2054);
	       }
	       {
		  obj_t aux_2063;
		  {
		     obj_t aux_2064;
		     {
			object_t aux_2065;
			aux_2065 = (object_t) (obj1342_829);
			aux_2064 = OBJECT_WIDENING(aux_2065);
		     }
		     aux_2063 = (((sfun_iinfo_105_t) CREF(aux_2064))->l);
		  }
		  STRUCT_SET(aux1344_833, ((long) 12), aux_2063);
	       }
	       {
		  obj_t aux_2070;
		  {
		     obj_t aux_2071;
		     {
			object_t aux_2072;
			aux_2072 = (object_t) (obj1342_829);
			aux_2071 = OBJECT_WIDENING(aux_2072);
		     }
		     aux_2070 = (((sfun_iinfo_105_t) CREF(aux_2071))->led);
		  }
		  STRUCT_SET(aux1344_833, ((long) 13), aux_2070);
	       }
	       {
		  obj_t aux_2077;
		  {
		     obj_t aux_2078;
		     {
			object_t aux_2079;
			aux_2079 = (object_t) (obj1342_829);
			aux_2078 = OBJECT_WIDENING(aux_2079);
		     }
		     aux_2077 = (((sfun_iinfo_105_t) CREF(aux_2078))->istamp);
		  }
		  STRUCT_SET(aux1344_833, ((long) 14), aux_2077);
	       }
	       {
		  obj_t aux_2084;
		  {
		     obj_t aux_2085;
		     {
			object_t aux_2086;
			aux_2086 = (object_t) (obj1342_829);
			aux_2085 = OBJECT_WIDENING(aux_2086);
		     }
		     aux_2084 = (((sfun_iinfo_105_t) CREF(aux_2085))->global);
		  }
		  STRUCT_SET(aux1344_833, ((long) 15), aux_2084);
	       }
	       {
		  obj_t aux_2091;
		  {
		     obj_t aux_2092;
		     {
			object_t aux_2093;
			aux_2093 = (object_t) (obj1342_829);
			aux_2092 = OBJECT_WIDENING(aux_2093);
		     }
		     aux_2091 = (((sfun_iinfo_105_t) CREF(aux_2092))->kaptured);
		  }
		  STRUCT_SET(aux1344_833, ((long) 16), aux_2091);
	       }
	       STRUCT_SET(res1343_832, ((long) 0), aux1344_833);
	       {
		  obj_t aux_2099;
		  aux_2099 = STRUCT_KEY(res1343_832);
		  STRUCT_KEY_SET(aux1344_833, aux_2099);
	       }
	       {
		  obj_t aux_2102;
		  aux_2102 = CNST_TABLE_REF(((long) 2));
		  STRUCT_KEY_SET(res1343_832, aux_2102);
	       }
	       return res1343_832;
	    }
	 }
      }
   }
}


sfun_t 
allocate_sfun_iinfo_8_integrate_info()
{
   {
      sfun_t new1341_970;
      new1341_970 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
      {
	 long arg1541_971;
	 arg1541_971 = class_num_218___object(sfun_iinfo_105_integrate_info);
	 {
	    obj_t obj_1589;
	    obj_1589 = (obj_t) (new1341_970);
	    (((obj_t) CREF(obj_1589))->header = MAKE_HEADER(arg1541_971, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2110;
	 aux_2110 = (object_t) (new1341_970);
	 OBJECT_WIDENING_SET(aux_2110, BFALSE);
      }
      return new1341_970;
   }
}


obj_t 
_allocate_sfun_iinfo_52_integrate_info(obj_t env_1676)
{
   {
      sfun_t aux_2113;
      aux_2113 = allocate_sfun_iinfo_8_integrate_info();
      return (obj_t) (aux_2113);
   }
}


sexit_t 
allocate_sexit_iinfo_139_integrate_info()
{
   {
      sexit_t new1302_994;
      new1302_994 = ((sexit_t) BREF(GC_MALLOC(sizeof(struct sexit))));
      {
	 long arg1547_995;
	 arg1547_995 = class_num_218___object(sexit_iinfo_190_integrate_info);
	 {
	    obj_t obj_1609;
	    obj_1609 = (obj_t) (new1302_994);
	    (((obj_t) CREF(obj_1609))->header = MAKE_HEADER(arg1547_995, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2120;
	 aux_2120 = (object_t) (new1302_994);
	 OBJECT_WIDENING_SET(aux_2120, BFALSE);
      }
      return new1302_994;
   }
}


obj_t 
_allocate_sexit_iinfo_189_integrate_info(obj_t env_1675)
{
   {
      sexit_t aux_2123;
      aux_2123 = allocate_sexit_iinfo_139_integrate_info();
      return (obj_t) (aux_2123);
   }
}


svar_t 
allocate_svar_iinfo_15_integrate_info()
{
   {
      svar_t new1283_1005;
      new1283_1005 = ((svar_t) BREF(GC_MALLOC(sizeof(struct svar))));
      {
	 long arg1551_1006;
	 arg1551_1006 = class_num_218___object(svar_iinfo_76_integrate_info);
	 {
	    obj_t obj_1616;
	    obj_1616 = (obj_t) (new1283_1005);
	    (((obj_t) CREF(obj_1616))->header = MAKE_HEADER(arg1551_1006, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_2130;
	 aux_2130 = (object_t) (new1283_1005);
	 OBJECT_WIDENING_SET(aux_2130, BFALSE);
      }
      return new1283_1005;
   }
}


obj_t 
_allocate_svar_iinfo_246_integrate_info(obj_t env_1674)
{
   {
      svar_t aux_2133;
      aux_2133 = allocate_svar_iinfo_15_integrate_info();
      return (obj_t) (aux_2133);
   }
}


obj_t 
imported_modules_init_94_integrate_info()
{
   module_initialization_70_type_type(((long) 0), "INTEGRATE_INFO");
   module_initialization_70_ast_var(((long) 0), "INTEGRATE_INFO");
   return module_initialization_70_ast_node(((long) 0), "INTEGRATE_INFO");
}
