/*===========================================================================*/
/*   (Integrate/kaptured.scm)                                                */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_t;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_t;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_t;


extern obj_t create_vector(long);
extern bool_t is_a__118___object(obj_t, obj_t);
static long __union_round__11_integrate_kaptured;
static obj_t imported_modules_init_94_integrate_kaptured();
extern obj_t module_initialization_70_integrate_kaptured(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_free(long, char *);
extern obj_t module_initialization_70_integrate_cto(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_integrate_kaptured();
static obj_t cnst_init_137_integrate_kaptured();
static obj_t set_one_kaptured__205_integrate_kaptured(obj_t, obj_t);
static obj_t union_3_integrate_kaptured(obj_t);
extern obj_t _set_kaptured__95_integrate_kaptured(obj_t, obj_t);
extern obj_t set_kaptured__104_integrate_kaptured(obj_t);
static obj_t require_initialization_114_integrate_kaptured = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_integrate_kaptured();
extern obj_t set_cto__5_integrate_cto(node_t, local_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t free_from_222_integrate_free(obj_t, local_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t get_free_vars_244_integrate_free(node_t, local_t);
extern obj_t local_ast_var;
static obj_t __cnst[1];

DEFINE_STRING(string1713_integrate_kaptured, string1713_integrate_kaptured1734, " [locking:", 10);
DEFINE_STRING(string1716_integrate_kaptured, string1716_integrate_kaptured1735, "--> (or pair? null?) [", 22);
DEFINE_STRING(string1727_integrate_kaptured, string1727_integrate_kaptured1736, "   rkaptured(", 13);
DEFINE_STRING(string1726_integrate_kaptured, string1726_integrate_kaptured1737, "   fkaptured(", 13);
DEFINE_STRING(string1715_integrate_kaptured, string1715_integrate_kaptured1738, "] ", 2);
DEFINE_EXPORT_PROCEDURE(set_kaptured__env_5_integrate_kaptured, _set_kaptured__95_integrate_kaptured1739, _set_kaptured__95_integrate_kaptured, 0L, 1);
DEFINE_STRING(string1725_integrate_kaptured, string1725_integrate_kaptured1740, "    kaptured(", 13);
DEFINE_STRING(string1720_integrate_kaptured, string1720_integrate_kaptured1741, "].kaptured: ", 12);
DEFINE_STRING(string1723_integrate_kaptured, string1723_integrate_kaptured1742, ") : ", 4);
DEFINE_STRING(string1728_integrate_kaptured, string1728_integrate_kaptured1743, "INTEGRATE ", 10);
DEFINE_STRING(string1714_integrate_kaptured, string1714_integrate_kaptured1744, "### set-one-kaptured: ", 22);
DEFINE_STRING(string1722_integrate_kaptured, string1722_integrate_kaptured1745, "].cto     : ", 12);
DEFINE_STRING(string1717_integrate_kaptured, string1717_integrate_kaptured1746, "--> local? [", 12);
DEFINE_STRING(string1718_integrate_kaptured, string1718_integrate_kaptured1747, " or ", 4);
DEFINE_STRING(string1721_integrate_kaptured, string1721_integrate_kaptured1748, "   [", 4);
DEFINE_STRING(string1719_integrate_kaptured, string1719_integrate_kaptured1749, "--> cto [", 9);
DEFINE_STRING(string1724_integrate_kaptured, string1724_integrate_kaptured1750, "        free(", 13);

obj_t 
module_initialization_70_integrate_kaptured(long checksum_1550, char *from_1551)
{
   if (CBOOL(require_initialization_114_integrate_kaptured))
     {
	require_initialization_114_integrate_kaptured = BBOOL(((bool_t) 0));
	library_modules_init_112_integrate_kaptured();
	cnst_init_137_integrate_kaptured();
	imported_modules_init_94_integrate_kaptured();
	toplevel_init_63_integrate_kaptured();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_integrate_kaptured()
{
   module_initialization_70___object(((long) 0), "INTEGRATE_KAPTURED");
   module_initialization_70___reader(((long) 0), "INTEGRATE_KAPTURED");
   return BUNSPEC;
}


obj_t 
cnst_init_137_integrate_kaptured()
{
   {
      obj_t cnst_port_138_1542;
      cnst_port_138_1542 = open_input_string(string1728_integrate_kaptured);
      {
	 long i_1543;
	 i_1543 = ((long) 0);
       loop_1544:
	 {
	    bool_t test1729_1545;
	    test1729_1545 = (i_1543 == ((long) -1));
	    if (test1729_1545)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1730_1546;
		    {
		       obj_t list1731_1547;
		       {
			  obj_t arg1732_1548;
			  arg1732_1548 = BNIL;
			  list1731_1547 = MAKE_PAIR(cnst_port_138_1542, arg1732_1548);
		       }
		       arg1730_1546 = read___reader(list1731_1547);
		    }
		    CNST_TABLE_SET(i_1543, arg1730_1546);
		 }
		 {
		    int aux_1549;
		    {
		       long aux_1567;
		       aux_1567 = (i_1543 - ((long) 1));
		       aux_1549 = (int) (aux_1567);
		    }
		    {
		       long i_1570;
		       i_1570 = (long) (aux_1549);
		       i_1543 = i_1570;
		       goto loop_1544;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_integrate_kaptured()
{
   return (__union_round__11_integrate_kaptured = ((long) 0),
      BUNSPEC);
}


obj_t 
set_kaptured__104_integrate_kaptured(obj_t local__0_1)
{
   {
      obj_t l1329_812;
      {
	 bool_t aux_1572;
	 l1329_812 = local__0_1;
       lname1330_813:
	 if (PAIRP(l1329_812))
	   {
	      {
		 obj_t local_815;
		 local_815 = CAR(l1329_812);
		 set_one_kaptured__205_integrate_kaptured(local_815, local_815);
	      }
	      {
		 obj_t l1329_1577;
		 l1329_1577 = CDR(l1329_812);
		 l1329_812 = l1329_1577;
		 goto lname1330_813;
	      }
	   }
	 else
	   {
	      aux_1572 = ((bool_t) 1);
	   }
	 return BBOOL(aux_1572);
      }
   }
}


obj_t 
_set_kaptured__95_integrate_kaptured(obj_t env_1535, obj_t local__0_1536)
{
   return set_kaptured__104_integrate_kaptured(local__0_1536);
}


obj_t 
set_one_kaptured__205_integrate_kaptured(obj_t local_2, obj_t locking_3)
{
   {
      bool_t test1340_817;
      {
	 obj_t aux_1581;
	 aux_1581 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1340_817 = CBOOL(aux_1581);
      }
      if (test1340_817)
	{
	   obj_t arg1343_819;
	   obj_t arg1346_821;
	   arg1343_819 = shape_tools_shape(local_2);
	   arg1346_821 = shape_tools_shape(locking_3);
	   {
	      obj_t list1347_822;
	      {
		 obj_t arg1349_823;
		 {
		    obj_t arg1350_824;
		    {
		       obj_t arg1352_825;
		       {
			  obj_t arg1353_826;
			  {
			     obj_t arg1355_827;
			     {
				obj_t aux_1589;
				aux_1589 = BCHAR(((unsigned char) '\n'));
				arg1355_827 = MAKE_PAIR(aux_1589, BNIL);
			     }
			     {
				obj_t aux_1592;
				aux_1592 = BCHAR(((unsigned char) ']'));
				arg1353_826 = MAKE_PAIR(aux_1592, arg1355_827);
			     }
			  }
			  arg1352_825 = MAKE_PAIR(arg1346_821, arg1353_826);
		       }
		       arg1350_824 = MAKE_PAIR(string1713_integrate_kaptured, arg1352_825);
		    }
		    arg1349_823 = MAKE_PAIR(arg1343_819, arg1350_824);
		 }
		 list1347_822 = MAKE_PAIR(string1714_integrate_kaptured, arg1349_823);
	      }
	      print_trace_107_tools_trace(list1347_822);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      value_t info_831;
      {
	 local_t obj_1379;
	 obj_1379 = (local_t) (local_2);
	 info_831 = (((local_t) CREF(obj_1379))->value);
      }
      {
	 obj_t kaptured_832;
	 {
	    sfun_iinfo_105_t obj_1380;
	    obj_1380 = (sfun_iinfo_105_t) (info_831);
	    {
	       obj_t aux_1603;
	       {
		  object_t aux_1604;
		  aux_1604 = (object_t) (obj_1380);
		  aux_1603 = OBJECT_WIDENING(aux_1604);
	       }
	       kaptured_832 = (((sfun_iinfo_105_t) CREF(aux_1603))->kaptured);
	    }
	 }
	 {
	    {
	       bool_t test_1608;
	       if (PAIRP(kaptured_832))
		 {
		    test_1608 = ((bool_t) 1);
		 }
	       else
		 {
		    test_1608 = NULLP(kaptured_832);
		 }
	       if (test_1608)
		 {
		    {
		       bool_t test1360_834;
		       {
			  obj_t aux_1612;
			  aux_1612 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			  test1360_834 = CBOOL(aux_1612);
		       }
		       if (test1360_834)
			 {
			    obj_t arg1363_836;
			    obj_t arg1366_838;
			    arg1363_836 = shape_tools_shape(local_2);
			    arg1366_838 = shape_tools_shape(kaptured_832);
			    {
			       obj_t list1367_839;
			       {
				  obj_t arg1369_840;
				  {
				     obj_t arg1370_841;
				     {
					obj_t arg1372_842;
					{
					   obj_t arg1376_843;
					   {
					      obj_t aux_1620;
					      aux_1620 = BCHAR(((unsigned char) '\n'));
					      arg1376_843 = MAKE_PAIR(aux_1620, BNIL);
					   }
					   arg1372_842 = MAKE_PAIR(arg1366_838, arg1376_843);
					}
					arg1370_841 = MAKE_PAIR(string1715_integrate_kaptured, arg1372_842);
				     }
				     arg1369_840 = MAKE_PAIR(arg1363_836, arg1370_841);
				  }
				  list1367_839 = MAKE_PAIR(string1716_integrate_kaptured, arg1369_840);
			       }
			       print_trace_107_tools_trace(list1367_839);
			    }
			 }
		       else
			 {
			    BUNSPEC;
			 }
		    }
		    {
		       obj_t v1331_847;
		       v1331_847 = create_vector(((long) 3));
		       VECTOR_SET(v1331_847, ((long) 2), kaptured_832);
		       VECTOR_SET(v1331_847, ((long) 1), locking_3);
		       VECTOR_SET(v1331_847, ((long) 0), BTRUE);
		       return v1331_847;
		    }
		 }
	       else
		 {
		    bool_t test1382_848;
		    test1382_848 = is_a__118___object(kaptured_832, local_ast_var);
		    if (test1382_848)
		      {
			 {
			    bool_t test1383_849;
			    {
			       obj_t aux_1634;
			       aux_1634 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			       test1383_849 = CBOOL(aux_1634);
			    }
			    if (test1383_849)
			      {
				 obj_t arg1388_851;
				 obj_t arg1391_853;
				 arg1388_851 = shape_tools_shape(local_2);
				 arg1391_853 = shape_tools_shape(kaptured_832);
				 {
				    obj_t list1392_854;
				    {
				       obj_t arg1396_855;
				       {
					  obj_t arg1398_856;
					  {
					     obj_t arg1400_857;
					     {
						obj_t arg1402_858;
						{
						   obj_t aux_1642;
						   aux_1642 = BCHAR(((unsigned char) '\n'));
						   arg1402_858 = MAKE_PAIR(aux_1642, BNIL);
						}
						arg1400_857 = MAKE_PAIR(arg1391_853, arg1402_858);
					     }
					     arg1398_856 = MAKE_PAIR(string1715_integrate_kaptured, arg1400_857);
					  }
					  arg1396_855 = MAKE_PAIR(arg1388_851, arg1398_856);
				       }
				       list1392_854 = MAKE_PAIR(string1717_integrate_kaptured, arg1396_855);
				    }
				    print_trace_107_tools_trace(list1392_854);
				 }
			      }
			    else
			      {
				 BUNSPEC;
			      }
			 }
			 {
			    obj_t v1332_862;
			    v1332_862 = create_vector(((long) 3));
			    VECTOR_SET(v1332_862, ((long) 2), BNIL);
			    VECTOR_SET(v1332_862, ((long) 1), locking_3);
			    VECTOR_SET(v1332_862, ((long) 0), BFALSE);
			    return v1332_862;
			 }
		      }
		    else
		      {
			 {
			    obj_t body_865;
			    {
			       sfun_t obj_1403;
			       obj_1403 = (sfun_t) (info_831);
			       body_865 = (((sfun_t) CREF(obj_1403))->body);
			    }
			    set_cto__5_integrate_cto((node_t) (body_865), (local_t) (local_2));
			    {
			       bool_t test1411_866;
			       {
				  obj_t aux_1659;
				  aux_1659 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
				  test1411_866 = CBOOL(aux_1659);
			       }
			       if (test1411_866)
				 {
				    obj_t arg1414_868;
				    obj_t arg1416_870;
				    obj_t arg1418_872;
				    arg1414_868 = shape_tools_shape(local_2);
				    {
				       obj_t aux_1666;
				       {
					  sfun_iinfo_105_t obj_1404;
					  obj_1404 = (sfun_iinfo_105_t) (info_831);
					  {
					     obj_t aux_1668;
					     {
						object_t aux_1669;
						aux_1669 = (object_t) (obj_1404);
						aux_1668 = OBJECT_WIDENING(aux_1669);
					     }
					     aux_1666 = (((sfun_iinfo_105_t) CREF(aux_1668))->cto);
					  }
				       }
				       arg1416_870 = shape_tools_shape(aux_1666);
				    }
				    {
				       obj_t aux_1674;
				       {
					  sfun_iinfo_105_t obj_1406;
					  {
					     value_t aux_1675;
					     {
						local_t obj_1405;
						obj_1405 = (local_t) (local_2);
						aux_1675 = (((local_t) CREF(obj_1405))->value);
					     }
					     obj_1406 = (sfun_iinfo_105_t) (aux_1675);
					  }
					  {
					     obj_t aux_1679;
					     {
						object_t aux_1680;
						aux_1680 = (object_t) (obj_1406);
						aux_1679 = OBJECT_WIDENING(aux_1680);
					     }
					     aux_1674 = (((sfun_iinfo_105_t) CREF(aux_1679))->cto);
					  }
				       }
				       arg1418_872 = shape_tools_shape(aux_1674);
				    }
				    {
				       obj_t list1419_873;
				       {
					  obj_t arg1420_874;
					  {
					     obj_t arg1421_875;
					     {
						obj_t arg1424_876;
						{
						   obj_t arg1426_877;
						   {
						      obj_t arg1427_878;
						      {
							 obj_t arg1428_879;
							 {
							    obj_t aux_1685;
							    aux_1685 = BCHAR(((unsigned char) '\n'));
							    arg1428_879 = MAKE_PAIR(aux_1685, BNIL);
							 }
							 arg1427_878 = MAKE_PAIR(arg1418_872, arg1428_879);
						      }
						      arg1426_877 = MAKE_PAIR(string1718_integrate_kaptured, arg1427_878);
						   }
						   arg1424_876 = MAKE_PAIR(arg1416_870, arg1426_877);
						}
						arg1421_875 = MAKE_PAIR(string1715_integrate_kaptured, arg1424_876);
					     }
					     arg1420_874 = MAKE_PAIR(arg1414_868, arg1421_875);
					  }
					  list1419_873 = MAKE_PAIR(string1719_integrate_kaptured, arg1420_874);
				       }
				       print_trace_107_tools_trace(list1419_873);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       obj_t res1708_1409;
			       {
				  sfun_iinfo_105_t obj_1407;
				  obj_1407 = (sfun_iinfo_105_t) (info_831);
				  {
				     obj_t x_1537;
				     {
					obj_t aux_1696;
					{
					   object_t aux_1697;
					   aux_1697 = (object_t) (obj_1407);
					   aux_1696 = OBJECT_WIDENING(aux_1697);
					}
					x_1537 = ((((sfun_iinfo_105_t) CREF(aux_1696))->kaptured) = ((obj_t) local_2), BUNSPEC);
				     }
				     res1708_1409 = BUNSPEC;
				  }
			       }
			       res1708_1409;
			    }
			    {
			       obj_t kaptured_886;
			       obj_t cto_887;
			       bool_t setter__165_888;
			       kaptured_886 = BNIL;
			       {
				  sfun_iinfo_105_t obj_1410;
				  obj_1410 = (sfun_iinfo_105_t) (info_831);
				  {
				     obj_t aux_1879;
				     {
					object_t aux_1880;
					aux_1880 = (object_t) (obj_1410);
					aux_1879 = OBJECT_WIDENING(aux_1880);
				     }
				     cto_887 = (((sfun_iinfo_105_t) CREF(aux_1879))->cto);
				  }
			       }
			       setter__165_888 = ((bool_t) 1);
			     loop_889:
			       {
				  bool_t test1448_892;
				  {
				     obj_t aux_1701;
				     aux_1701 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				     test1448_892 = CBOOL(aux_1701);
				  }
				  if (test1448_892)
				    {
				       obj_t arg1450_894;
				       obj_t arg1453_896;
				       obj_t arg1457_898;
				       obj_t arg1461_900;
				       arg1450_894 = shape_tools_shape(local_2);
				       arg1453_896 = shape_tools_shape(cto_887);
				       arg1457_898 = shape_tools_shape(local_2);
				       arg1461_900 = shape_tools_shape(kaptured_886);
				       {
					  obj_t list1462_901;
					  {
					     obj_t arg1463_902;
					     {
						obj_t arg1465_903;
						{
						   obj_t arg1466_904;
						   {
						      obj_t arg1467_905;
						      {
							 obj_t arg1468_906;
							 {
							    obj_t arg1470_907;
							    {
							       obj_t arg1471_908;
							       {
								  obj_t arg1472_909;
								  {
								     obj_t arg1474_910;
								     {
									obj_t aux_1711;
									aux_1711 = BCHAR(((unsigned char) '\n'));
									arg1474_910 = MAKE_PAIR(aux_1711, BNIL);
								     }
								     arg1472_909 = MAKE_PAIR(arg1461_900, arg1474_910);
								  }
								  arg1471_908 = MAKE_PAIR(string1720_integrate_kaptured, arg1472_909);
							       }
							       arg1470_907 = MAKE_PAIR(arg1457_898, arg1471_908);
							    }
							    arg1468_906 = MAKE_PAIR(string1721_integrate_kaptured, arg1470_907);
							 }
							 {
							    obj_t aux_1718;
							    aux_1718 = BCHAR(((unsigned char) '\n'));
							    arg1467_905 = MAKE_PAIR(aux_1718, arg1468_906);
							 }
						      }
						      arg1466_904 = MAKE_PAIR(arg1453_896, arg1467_905);
						   }
						   arg1465_903 = MAKE_PAIR(string1722_integrate_kaptured, arg1466_904);
						}
						arg1463_902 = MAKE_PAIR(arg1450_894, arg1465_903);
					     }
					     list1462_901 = MAKE_PAIR(string1721_integrate_kaptured, arg1463_902);
					  }
					  print_trace_107_tools_trace(list1462_901);
				       }
				    }
				  else
				    {
				       BUNSPEC;
				    }
			       }
			       if (NULLP(cto_887))
				 {
				    {
				       obj_t free_915;
				       free_915 = get_free_vars_244_integrate_free((node_t) (body_865), (local_t) (local_2));
				       {
					  obj_t fkaptured_916;
					  fkaptured_916 = free_from_222_integrate_free(kaptured_886, (local_t) (local_2));
					  {
					     obj_t rkaptured_917;
					     {
						obj_t arg1559_977;
						arg1559_977 = MAKE_PAIR(free_915, fkaptured_916);
						rkaptured_917 = union_3_integrate_kaptured(arg1559_977);
					     }
					     {
						{
						   bool_t test1480_918;
						   {
						      obj_t aux_1735;
						      aux_1735 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
						      test1480_918 = CBOOL(aux_1735);
						   }
						   if (test1480_918)
						     {
							obj_t arg1484_920;
							obj_t arg1486_922;
							arg1484_920 = shape_tools_shape(local_2);
							arg1486_922 = shape_tools_shape(free_915);
							{
							   obj_t list1487_923;
							   {
							      obj_t arg1489_924;
							      {
								 obj_t arg1490_925;
								 {
								    obj_t arg1493_926;
								    {
								       obj_t arg1494_927;
								       {
									  obj_t aux_1743;
									  aux_1743 = BCHAR(((unsigned char) '\n'));
									  arg1494_927 = MAKE_PAIR(aux_1743, BNIL);
								       }
								       arg1493_926 = MAKE_PAIR(arg1486_922, arg1494_927);
								    }
								    arg1490_925 = MAKE_PAIR(string1723_integrate_kaptured, arg1493_926);
								 }
								 arg1489_924 = MAKE_PAIR(arg1484_920, arg1490_925);
							      }
							      list1487_923 = MAKE_PAIR(string1724_integrate_kaptured, arg1489_924);
							   }
							   print_trace_107_tools_trace(list1487_923);
							}
						     }
						   else
						     {
							BUNSPEC;
						     }
						}
						{
						   bool_t test1499_931;
						   {
						      obj_t aux_1751;
						      aux_1751 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
						      test1499_931 = CBOOL(aux_1751);
						   }
						   if (test1499_931)
						     {
							obj_t arg1501_933;
							obj_t arg1506_935;
							arg1501_933 = shape_tools_shape(local_2);
							arg1506_935 = shape_tools_shape(kaptured_886);
							{
							   obj_t list1507_936;
							   {
							      obj_t arg1509_937;
							      {
								 obj_t arg1510_938;
								 {
								    obj_t arg1511_939;
								    {
								       obj_t arg1513_940;
								       {
									  obj_t aux_1759;
									  aux_1759 = BCHAR(((unsigned char) '\n'));
									  arg1513_940 = MAKE_PAIR(aux_1759, BNIL);
								       }
								       arg1511_939 = MAKE_PAIR(arg1506_935, arg1513_940);
								    }
								    arg1510_938 = MAKE_PAIR(string1723_integrate_kaptured, arg1511_939);
								 }
								 arg1509_937 = MAKE_PAIR(arg1501_933, arg1510_938);
							      }
							      list1507_936 = MAKE_PAIR(string1725_integrate_kaptured, arg1509_937);
							   }
							   print_trace_107_tools_trace(list1507_936);
							}
						     }
						   else
						     {
							BUNSPEC;
						     }
						}
						{
						   bool_t test1519_944;
						   {
						      obj_t aux_1767;
						      aux_1767 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
						      test1519_944 = CBOOL(aux_1767);
						   }
						   if (test1519_944)
						     {
							obj_t arg1522_946;
							obj_t arg1524_948;
							arg1522_946 = shape_tools_shape(local_2);
							arg1524_948 = shape_tools_shape(fkaptured_916);
							{
							   obj_t list1525_949;
							   {
							      obj_t arg1526_950;
							      {
								 obj_t arg1529_951;
								 {
								    obj_t arg1531_952;
								    {
								       obj_t arg1532_953;
								       {
									  obj_t aux_1775;
									  aux_1775 = BCHAR(((unsigned char) '\n'));
									  arg1532_953 = MAKE_PAIR(aux_1775, BNIL);
								       }
								       arg1531_952 = MAKE_PAIR(arg1524_948, arg1532_953);
								    }
								    arg1529_951 = MAKE_PAIR(string1723_integrate_kaptured, arg1531_952);
								 }
								 arg1526_950 = MAKE_PAIR(arg1522_946, arg1529_951);
							      }
							      list1525_949 = MAKE_PAIR(string1726_integrate_kaptured, arg1526_950);
							   }
							   print_trace_107_tools_trace(list1525_949);
							}
						     }
						   else
						     {
							BUNSPEC;
						     }
						}
						{
						   bool_t test1537_957;
						   {
						      obj_t aux_1783;
						      aux_1783 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
						      test1537_957 = CBOOL(aux_1783);
						   }
						   if (test1537_957)
						     {
							obj_t arg1539_959;
							obj_t arg1541_961;
							arg1539_959 = shape_tools_shape(local_2);
							arg1541_961 = shape_tools_shape(rkaptured_917);
							{
							   obj_t list1542_962;
							   {
							      obj_t arg1543_963;
							      {
								 obj_t arg1547_964;
								 {
								    obj_t arg1549_965;
								    {
								       obj_t arg1550_966;
								       {
									  obj_t aux_1791;
									  aux_1791 = BCHAR(((unsigned char) '\n'));
									  arg1550_966 = MAKE_PAIR(aux_1791, BNIL);
								       }
								       arg1549_965 = MAKE_PAIR(arg1541_961, arg1550_966);
								    }
								    arg1547_964 = MAKE_PAIR(string1723_integrate_kaptured, arg1549_965);
								 }
								 arg1543_963 = MAKE_PAIR(arg1539_959, arg1547_964);
							      }
							      list1542_962 = MAKE_PAIR(string1727_integrate_kaptured, arg1543_963);
							   }
							   print_trace_107_tools_trace(list1542_962);
							}
						     }
						   else
						     {
							BUNSPEC;
						     }
						}
						if (setter__165_888)
						  {
						     {
							obj_t res1709_1416;
							{
							   sfun_iinfo_105_t obj_1414;
							   obj_1414 = (sfun_iinfo_105_t) (info_831);
							   {
							      obj_t x_1538;
							      {
								 obj_t aux_1801;
								 {
								    object_t aux_1802;
								    aux_1802 = (object_t) (obj_1414);
								    aux_1801 = OBJECT_WIDENING(aux_1802);
								 }
								 x_1538 = ((((sfun_iinfo_105_t) CREF(aux_1801))->kaptured) = ((obj_t) rkaptured_917), BUNSPEC);
							      }
							      res1709_1416 = BUNSPEC;
							   }
							}
							res1709_1416;
						     }
						     {
							obj_t l1333_970;
							{
							   bool_t aux_1806;
							   l1333_970 = rkaptured_917;
							 lname1335_971:
							   if (PAIRP(l1333_970))
							     {
								{
								   obj_t res1710_1422;
								   {
								      svar_iinfo_76_t obj_1420;
								      {
									 value_t aux_1809;
									 {
									    local_t obj_1419;
									    {
									       obj_t aux_1810;
									       aux_1810 = CAR(l1333_970);
									       obj_1419 = (local_t) (aux_1810);
									    }
									    aux_1809 = (((local_t) CREF(obj_1419))->value);
									 }
									 obj_1420 = (svar_iinfo_76_t) (aux_1809);
								      }
								      {
									 obj_t x_1539;
									 {
									    obj_t aux_1815;
									    {
									       object_t aux_1816;
									       aux_1816 = (object_t) (obj_1420);
									       aux_1815 = OBJECT_WIDENING(aux_1816);
									    }
									    x_1539 = ((((svar_iinfo_76_t) CREF(aux_1815))->kaptured__204) = ((bool_t) ((bool_t) 1)), BUNSPEC);
									 }
									 res1710_1422 = BUNSPEC;
								      }
								   }
								   res1710_1422;
								}
								{
								   obj_t l1333_1820;
								   l1333_1820 = CDR(l1333_970);
								   l1333_970 = l1333_1820;
								   goto lname1335_971;
								}
							     }
							   else
							     {
								aux_1806 = ((bool_t) 1);
							     }
							   BBOOL(aux_1806);
							}
						     }
						  }
						else
						  {
						     obj_t res1711_1426;
						     {
							sfun_iinfo_105_t obj_1424;
							obj_1424 = (sfun_iinfo_105_t) (info_831);
							{
							   obj_t x_1540;
							   {
							      obj_t aux_1824;
							      {
								 object_t aux_1825;
								 aux_1825 = (object_t) (obj_1424);
								 aux_1824 = OBJECT_WIDENING(aux_1825);
							      }
							      x_1540 = ((((sfun_iinfo_105_t) CREF(aux_1824))->kaptured) = ((obj_t) BUNSPEC), BUNSPEC);
							   }
							   res1711_1426 = BUNSPEC;
							}
						     }
						     res1711_1426;
						  }
						{
						   obj_t v1336_976;
						   v1336_976 = create_vector(((long) 3));
						   VECTOR_SET(v1336_976, ((long) 2), rkaptured_917);
						   VECTOR_SET(v1336_976, ((long) 1), locking_3);
						   {
						      obj_t aux_1832;
						      aux_1832 = BBOOL(setter__165_888);
						      VECTOR_SET(v1336_976, ((long) 0), aux_1832);
						   }
						   return v1336_976;
						}
					     }
					  }
				       }
				    }
				 }
			       else
				 {
				    bool_t test_1835;
				    {
				       obj_t aux_1836;
				       aux_1836 = CAR(cto_887);
				       test_1835 = (aux_1836 == local_2);
				    }
				    if (test_1835)
				      {
					 {
					    obj_t cto_1839;
					    cto_1839 = CDR(cto_887);
					    cto_887 = cto_1839;
					    goto loop_889;
					 }
				      }
				    else
				      {
					 bool_t test_1841;
					 {
					    sfun_iinfo_105_t obj_1442;
					    {
					       value_t aux_1842;
					       {
						  local_t obj_1441;
						  {
						     obj_t aux_1843;
						     aux_1843 = CAR(cto_887);
						     obj_1441 = (local_t) (aux_1843);
						  }
						  aux_1842 = (((local_t) CREF(obj_1441))->value);
					       }
					       obj_1442 = (sfun_iinfo_105_t) (aux_1842);
					    }
					    {
					       obj_t aux_1848;
					       {
						  object_t aux_1849;
						  aux_1849 = (object_t) (obj_1442);
						  aux_1848 = OBJECT_WIDENING(aux_1849);
					       }
					       test_1841 = (((sfun_iinfo_105_t) CREF(aux_1848))->g__219);
					    }
					 }
					 if (test_1841)
					   {
					      {
						 obj_t other_kaptured_142_981;
						 other_kaptured_142_981 = set_one_kaptured__205_integrate_kaptured(CAR(cto_887), locking_3);
						 {
						    bool_t test_1855;
						    {
						       obj_t aux_1856;
						       aux_1856 = VECTOR_REF(other_kaptured_142_981, ((long) 0));
						       test_1855 = CBOOL(aux_1856);
						    }
						    if (test_1855)
						      {
							 obj_t arg1564_983;
							 obj_t arg1565_984;
							 {
							    obj_t aux_1859;
							    aux_1859 = VECTOR_REF(other_kaptured_142_981, ((long) 2));
							    arg1564_983 = MAKE_PAIR(aux_1859, kaptured_886);
							 }
							 arg1565_984 = CDR(cto_887);
							 {
							    obj_t cto_1864;
							    obj_t kaptured_1863;
							    kaptured_1863 = arg1564_983;
							    cto_1864 = arg1565_984;
							    cto_887 = cto_1864;
							    kaptured_886 = kaptured_1863;
							    goto loop_889;
							 }
						      }
						    else
						      {
							 obj_t arg1567_986;
							 obj_t arg1568_987;
							 bool_t arg1570_988;
							 {
							    obj_t aux_1865;
							    aux_1865 = VECTOR_REF(other_kaptured_142_981, ((long) 2));
							    arg1567_986 = MAKE_PAIR(aux_1865, kaptured_886);
							 }
							 arg1568_987 = CDR(cto_887);
							 if (setter__165_888)
							   {
							      obj_t aux_1870;
							      aux_1870 = VECTOR_REF(other_kaptured_142_981, ((long) 1));
							      arg1570_988 = (aux_1870 == local_2);
							   }
							 else
							   {
							      arg1570_988 = ((bool_t) 0);
							   }
							 {
							    bool_t setter__165_1875;
							    obj_t cto_1874;
							    obj_t kaptured_1873;
							    kaptured_1873 = arg1567_986;
							    cto_1874 = arg1568_987;
							    setter__165_1875 = arg1570_988;
							    setter__165_888 = setter__165_1875;
							    cto_887 = cto_1874;
							    kaptured_886 = kaptured_1873;
							    goto loop_889;
							 }
						      }
						 }
					      }
					   }
					 else
					   {
					      {
						 obj_t cto_1876;
						 cto_1876 = CDR(cto_887);
						 cto_887 = cto_1876;
						 goto loop_889;
					      }
					   }
				      }
				 }
			    }
			 }
		      }
		 }
	    }
	 }
      }
   }
}


obj_t 
union_3_integrate_kaptured(obj_t sets_4)
{
   {
      long z2_1462;
      z2_1462 = __union_round__11_integrate_kaptured;
      __union_round__11_integrate_kaptured = (((long) 1) + z2_1462);
   }
   {
      obj_t sets_999;
      obj_t union_3_1000;
      sets_999 = sets_4;
      union_3_1000 = BNIL;
    loop_1001:
      if (NULLP(sets_999))
	{
	   return union_3_1000;
	}
      else
	{
	   obj_t set_1004;
	   obj_t union_3_1005;
	   set_1004 = CAR(sets_999);
	   union_3_1005 = union_3_1000;
	 liip_1006:
	   if (NULLP(set_1004))
	     {
		{
		   obj_t union_3_1891;
		   obj_t sets_1889;
		   sets_1889 = CDR(sets_999);
		   union_3_1891 = union_3_1005;
		   union_3_1000 = union_3_1891;
		   sets_999 = sets_1889;
		   goto loop_1001;
		}
	     }
	   else
	     {
		bool_t test1588_1010;
		{
		   obj_t arg1596_1017;
		   {
		      svar_iinfo_76_t obj_1469;
		      {
			 value_t aux_1892;
			 {
			    local_t obj_1468;
			    {
			       obj_t aux_1893;
			       aux_1893 = CAR(set_1004);
			       obj_1468 = (local_t) (aux_1893);
			    }
			    aux_1892 = (((local_t) CREF(obj_1468))->value);
			 }
			 obj_1469 = (svar_iinfo_76_t) (aux_1892);
		      }
		      {
			 obj_t aux_1898;
			 {
			    object_t aux_1899;
			    aux_1899 = (object_t) (obj_1469);
			    aux_1898 = OBJECT_WIDENING(aux_1899);
			 }
			 arg1596_1017 = (((svar_iinfo_76_t) CREF(aux_1898))->u_mark_209);
		      }
		   }
		   {
		      obj_t obj2_1471;
		      obj2_1471 = BINT(__union_round__11_integrate_kaptured);
		      test1588_1010 = (arg1596_1017 == obj2_1471);
		   }
		}
		if (test1588_1010)
		  {
		     {
			obj_t set_1906;
			set_1906 = CDR(set_1004);
			set_1004 = set_1906;
			goto liip_1006;
		     }
		  }
		else
		  {
		     {
			obj_t res1712_1477;
			{
			   svar_iinfo_76_t obj_1475;
			   obj_t val1280_1476;
			   {
			      value_t aux_1908;
			      {
				 local_t obj_1474;
				 {
				    obj_t aux_1909;
				    aux_1909 = CAR(set_1004);
				    obj_1474 = (local_t) (aux_1909);
				 }
				 aux_1908 = (((local_t) CREF(obj_1474))->value);
			      }
			      obj_1475 = (svar_iinfo_76_t) (aux_1908);
			   }
			   val1280_1476 = BINT(__union_round__11_integrate_kaptured);
			   {
			      obj_t x_1541;
			      {
				 obj_t aux_1915;
				 {
				    object_t aux_1916;
				    aux_1916 = (object_t) (obj_1475);
				    aux_1915 = OBJECT_WIDENING(aux_1916);
				 }
				 x_1541 = ((((svar_iinfo_76_t) CREF(aux_1915))->u_mark_209) = ((obj_t) val1280_1476), BUNSPEC);
			      }
			      res1712_1477 = BUNSPEC;
			   }
			}
			res1712_1477;
		     }
		     {
			obj_t arg1592_1014;
			obj_t arg1593_1015;
			arg1592_1014 = CDR(set_1004);
			{
			   obj_t aux_1921;
			   aux_1921 = CAR(set_1004);
			   arg1593_1015 = MAKE_PAIR(aux_1921, union_3_1005);
			}
			{
			   obj_t union_3_1925;
			   obj_t set_1924;
			   set_1924 = arg1592_1014;
			   union_3_1925 = arg1593_1015;
			   union_3_1005 = union_3_1925;
			   set_1004 = set_1924;
			   goto liip_1006;
			}
		     }
		  }
	     }
	}
   }
}


obj_t 
imported_modules_init_94_integrate_kaptured()
{
   module_initialization_70_tools_trace(((long) 0), "INTEGRATE_KAPTURED");
   module_initialization_70_tools_shape(((long) 0), "INTEGRATE_KAPTURED");
   module_initialization_70_type_type(((long) 0), "INTEGRATE_KAPTURED");
   module_initialization_70_ast_var(((long) 0), "INTEGRATE_KAPTURED");
   module_initialization_70_ast_node(((long) 0), "INTEGRATE_KAPTURED");
   module_initialization_70_integrate_info(((long) 0), "INTEGRATE_KAPTURED");
   module_initialization_70_integrate_free(((long) 0), "INTEGRATE_KAPTURED");
   return module_initialization_70_integrate_cto(((long) 0), "INTEGRATE_KAPTURED");
}
