/*===========================================================================*/
/*   (Integrate/kk.scm)                                                      */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_t;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_t;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_t;


extern obj_t __phi__105_integrate_a;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_integrate_kk();
extern obj_t module_initialization_70_integrate_kk(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_a(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t cnst_init_137_integrate_kk();
static obj_t require_initialization_114_integrate_kk = BUNSPEC;
extern obj_t k__48_integrate_kk(obj_t, global_t);
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_integrate_kk();
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t __trace_port__84_tools_trace;
extern obj_t _k___120_integrate_kk(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t k_1__214_integrate_kk(obj_t, obj_t);
static obj_t trace_k_14_integrate_kk();
extern obj_t k___139_integrate_kk(obj_t);
static obj_t k_2__250_integrate_kk(obj_t, obj_t);
extern obj_t _k__67_integrate_kk(obj_t, obj_t, obj_t);
static obj_t __cnst[3];

DEFINE_STRING(string1658_integrate_kk, string1658_integrate_kk1673, "  ", 2);
DEFINE_STRING(string1657_integrate_kk, string1657_integrate_kk1674, "K.2!...", 7);
DEFINE_STRING(string1660_integrate_kk, string1660_integrate_kk1675, "  laap: ", 8);
DEFINE_EXPORT_PROCEDURE(k__env_164_integrate_kk, _k__67_integrate_kk1676, _k__67_integrate_kk, 0L, 2);
DEFINE_STRING(string1663_integrate_kk, string1663_integrate_kk1677, "   K : ", 7);
DEFINE_STRING(string1666_integrate_kk, string1666_integrate_kk1678, "TAIL BOTTOM INTEGRATE ", 22);
DEFINE_STRING(string1662_integrate_kk, string1662_integrate_kk1679, "   K*: ", 7);
DEFINE_STRING(string1655_integrate_kk, string1655_integrate_kk1680, "K!...", 5);
DEFINE_EXPORT_PROCEDURE(k___env_116_integrate_kk, _k___120_integrate_kk1681, _k___120_integrate_kk, 0L, 1);
DEFINE_STRING(string1664_integrate_kk, string1664_integrate_kk1682, " --> ", 5);
DEFINE_STRING(string1659_integrate_kk, string1659_integrate_kk1683, " liip: ", 7);
DEFINE_STRING(string1656_integrate_kk, string1656_integrate_kk1684, "K.1!...", 7);
DEFINE_STRING(string1665_integrate_kk, string1665_integrate_kk1685, "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~", 32);
DEFINE_STRING(string1661_integrate_kk, string1661_integrate_kk1686, "K*!...", 6);

obj_t 
module_initialization_70_integrate_kk(long checksum_1535, char *from_1536)
{
   if (CBOOL(require_initialization_114_integrate_kk))
     {
	require_initialization_114_integrate_kk = BBOOL(((bool_t) 0));
	library_modules_init_112_integrate_kk();
	cnst_init_137_integrate_kk();
	imported_modules_init_94_integrate_kk();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_integrate_kk()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_KK");
   module_initialization_70___r4_output_6_10_3(((long) 0), "INTEGRATE_KK");
   module_initialization_70___reader(((long) 0), "INTEGRATE_KK");
   return BUNSPEC;
}


obj_t 
cnst_init_137_integrate_kk()
{
   {
      obj_t cnst_port_138_1527;
      cnst_port_138_1527 = open_input_string(string1666_integrate_kk);
      {
	 long i_1528;
	 i_1528 = ((long) 2);
       loop_1529:
	 {
	    bool_t test1667_1530;
	    test1667_1530 = (i_1528 == ((long) -1));
	    if (test1667_1530)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1668_1531;
		    {
		       obj_t list1669_1532;
		       {
			  obj_t arg1671_1533;
			  arg1671_1533 = BNIL;
			  list1669_1532 = MAKE_PAIR(cnst_port_138_1527, arg1671_1533);
		       }
		       arg1668_1531 = read___reader(list1669_1532);
		    }
		    CNST_TABLE_SET(i_1528, arg1668_1531);
		 }
		 {
		    int aux_1534;
		    {
		       long aux_1552;
		       aux_1552 = (i_1528 - ((long) 1));
		       aux_1534 = (int) (aux_1552);
		    }
		    {
		       long i_1555;
		       i_1555 = (long) (aux_1534);
		       i_1528 = i_1555;
		       goto loop_1529;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
k__48_integrate_kk(obj_t a_1, global_t var_2)
{
   {
      bool_t test1331_815;
      {
	 obj_t aux_1557;
	 aux_1557 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1331_815 = CBOOL(aux_1557);
      }
      if (test1331_815)
	{
	   obj_t list1332_816;
	   {
	      obj_t arg1334_818;
	      {
		 obj_t aux_1563;
		 aux_1563 = BCHAR(((unsigned char) '\n'));
		 arg1334_818 = MAKE_PAIR(aux_1563, BNIL);
	      }
	      list1332_816 = MAKE_PAIR(string1655_integrate_kk, arg1334_818);
	   }
	   print_trace_107_tools_trace(list1332_816);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      value_t ifun_822;
      ifun_822 = (((global_t) CREF(var_2))->value);
      {
	 obj_t arg1342_823;
	 {
	    obj_t list1344_825;
	    {
	       obj_t aux_1569;
	       aux_1569 = CNST_TABLE_REF(((long) 1));
	       list1344_825 = MAKE_PAIR(aux_1569, BNIL);
	    }
	    arg1342_823 = list1344_825;
	 }
	 {
	    obj_t res1648_1353;
	    {
	       sfun_iinfo_105_t obj_1351;
	       obj_1351 = (sfun_iinfo_105_t) (ifun_822);
	       {
		  obj_t x_1520;
		  {
		     obj_t aux_1573;
		     {
			object_t aux_1574;
			aux_1574 = (object_t) (obj_1351);
			aux_1573 = OBJECT_WIDENING(aux_1574);
		     }
		     x_1520 = ((((sfun_iinfo_105_t) CREF(aux_1573))->k) = ((obj_t) arg1342_823), BUNSPEC);
		  }
		  res1648_1353 = BUNSPEC;
	       }
	    }
	    res1648_1353;
	 }
      }
      {
	 obj_t arg1346_827;
	 {
	    obj_t list1348_829;
	    {
	       obj_t aux_1578;
	       aux_1578 = CNST_TABLE_REF(((long) 1));
	       list1348_829 = MAKE_PAIR(aux_1578, BNIL);
	    }
	    arg1346_827 = list1348_829;
	 }
	 {
	    obj_t res1649_1357;
	    {
	       sfun_iinfo_105_t obj_1355;
	       obj_1355 = (sfun_iinfo_105_t) (ifun_822);
	       {
		  obj_t x_1521;
		  {
		     obj_t aux_1582;
		     {
			object_t aux_1583;
			aux_1583 = (object_t) (obj_1355);
			aux_1582 = OBJECT_WIDENING(aux_1583);
		     }
		     x_1521 = ((((sfun_iinfo_105_t) CREF(aux_1582))->k__190) = ((obj_t) arg1346_827), BUNSPEC);
		  }
		  res1649_1357 = BUNSPEC;
	       }
	    }
	    res1649_1357;
	 }
      }
      {
	 obj_t arg1350_831;
	 arg1350_831 = k_1__214_integrate_kk(a_1, BNIL);
	 return k_2__250_integrate_kk(a_1, arg1350_831);
      }
   }
}


obj_t 
_k__67_integrate_kk(obj_t env_1515, obj_t a_1516, obj_t var_1517)
{
   return k__48_integrate_kk(a_1516, (global_t) (var_1517));
}


obj_t 
k_1__214_integrate_kk(obj_t a_3, obj_t a_tail_58_4)
{
 k_1__214_integrate_kk:
   {
      bool_t test1353_833;
      {
	 obj_t aux_1591;
	 aux_1591 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1353_833 = CBOOL(aux_1591);
      }
      if (test1353_833)
	{
	   obj_t list1354_834;
	   {
	      obj_t arg1356_836;
	      {
		 obj_t aux_1597;
		 aux_1597 = BCHAR(((unsigned char) '\n'));
		 arg1356_836 = MAKE_PAIR(aux_1597, BNIL);
	      }
	      list1354_834 = MAKE_PAIR(string1656_integrate_kk, arg1356_836);
	   }
	   print_trace_107_tools_trace(list1354_834);
	}
      else
	{
	   BUNSPEC;
	}
   }
   if (NULLP(a_3))
     {
	return a_tail_58_4;
     }
   else
     {
	obj_t pr_841;
	pr_841 = CAR(a_3);
	{
	   obj_t g_843;
	   {
	      obj_t aux_1605;
	      aux_1605 = CDR(pr_841);
	      g_843 = CAR(aux_1605);
	   }
	   {
	      obj_t k_844;
	      {
		 obj_t aux_1608;
		 {
		    obj_t aux_1609;
		    aux_1609 = CDR(pr_841);
		    aux_1608 = CDR(aux_1609);
		 }
		 k_844 = CAR(aux_1608);
	      }
	      {
		 {
		    bool_t test_1613;
		    {
		       obj_t aux_1614;
		       aux_1614 = CNST_TABLE_REF(((long) 2));
		       test_1613 = (k_844 == aux_1614);
		    }
		    if (test_1613)
		      {
			 {
			    bool_t test_1617;
			    {
			       obj_t aux_1618;
			       aux_1618 = CAR(pr_841);
			       test_1617 = (aux_1618 == g_843);
			    }
			    if (test_1617)
			      {
				 obj_t a_1621;
				 a_1621 = CDR(a_3);
				 a_3 = a_1621;
				 goto k_1__214_integrate_kk;
			      }
			    else
			      {
				 obj_t arg1364_848;
				 obj_t arg1366_849;
				 arg1364_848 = CDR(a_3);
				 arg1366_849 = MAKE_PAIR(pr_841, a_tail_58_4);
				 {
				    obj_t a_tail_58_1626;
				    obj_t a_1625;
				    a_1625 = arg1364_848;
				    a_tail_58_1626 = arg1366_849;
				    a_tail_58_4 = a_tail_58_1626;
				    a_3 = a_1625;
				    goto k_1__214_integrate_kk;
				 }
			      }
			 }
		      }
		    else
		      {
			 {
			    value_t ifun_850;
			    {
			       variable_t obj_1379;
			       obj_1379 = (variable_t) (g_843);
			       ifun_850 = (((variable_t) CREF(obj_1379))->value);
			    }
			    {
			       bool_t test_1629;
			       {
				  obj_t aux_1630;
				  {
				     obj_t aux_1631;
				     {
					sfun_iinfo_105_t obj_1380;
					obj_1380 = (sfun_iinfo_105_t) (ifun_850);
					{
					   obj_t aux_1633;
					   {
					      object_t aux_1634;
					      aux_1634 = (object_t) (obj_1380);
					      aux_1633 = OBJECT_WIDENING(aux_1634);
					   }
					   aux_1631 = (((sfun_iinfo_105_t) CREF(aux_1633))->k);
					}
				     }
				     aux_1630 = memq___r4_pairs_and_lists_6_3(k_844, aux_1631);
				  }
				  test_1629 = CBOOL(aux_1630);
			       }
			       if (test_1629)
				 {
				    obj_t a_1640;
				    a_1640 = CDR(a_3);
				    a_3 = a_1640;
				    goto k_1__214_integrate_kk;
				 }
			       else
				 {
				    {
				       obj_t arg1370_853;
				       {
					  obj_t aux_1642;
					  {
					     sfun_iinfo_105_t obj_1382;
					     obj_1382 = (sfun_iinfo_105_t) (ifun_850);
					     {
						obj_t aux_1644;
						{
						   object_t aux_1645;
						   aux_1645 = (object_t) (obj_1382);
						   aux_1644 = OBJECT_WIDENING(aux_1645);
						}
						aux_1642 = (((sfun_iinfo_105_t) CREF(aux_1644))->k);
					     }
					  }
					  arg1370_853 = MAKE_PAIR(k_844, aux_1642);
				       }
				       {
					  obj_t res1650_1387;
					  {
					     sfun_iinfo_105_t obj_1385;
					     obj_1385 = (sfun_iinfo_105_t) (ifun_850);
					     {
						obj_t x_1522;
						{
						   obj_t aux_1651;
						   {
						      object_t aux_1652;
						      aux_1652 = (object_t) (obj_1385);
						      aux_1651 = OBJECT_WIDENING(aux_1652);
						   }
						   x_1522 = ((((sfun_iinfo_105_t) CREF(aux_1651))->k) = ((obj_t) arg1370_853), BUNSPEC);
						}
						res1650_1387 = BUNSPEC;
					     }
					  }
					  res1650_1387;
				       }
				    }
				    {
				       obj_t arg1376_855;
				       {
					  obj_t aux_1656;
					  {
					     sfun_iinfo_105_t obj_1388;
					     obj_1388 = (sfun_iinfo_105_t) (ifun_850);
					     {
						obj_t aux_1658;
						{
						   object_t aux_1659;
						   aux_1659 = (object_t) (obj_1388);
						   aux_1658 = OBJECT_WIDENING(aux_1659);
						}
						aux_1656 = (((sfun_iinfo_105_t) CREF(aux_1658))->k__190);
					     }
					  }
					  arg1376_855 = MAKE_PAIR(k_844, aux_1656);
				       }
				       {
					  obj_t res1651_1393;
					  {
					     sfun_iinfo_105_t obj_1391;
					     obj_1391 = (sfun_iinfo_105_t) (ifun_850);
					     {
						obj_t x_1523;
						{
						   obj_t aux_1665;
						   {
						      object_t aux_1666;
						      aux_1666 = (object_t) (obj_1391);
						      aux_1665 = OBJECT_WIDENING(aux_1666);
						   }
						   x_1523 = ((((sfun_iinfo_105_t) CREF(aux_1665))->k__190) = ((obj_t) arg1376_855), BUNSPEC);
						}
						res1651_1393 = BUNSPEC;
					     }
					  }
					  res1651_1393;
				       }
				    }
				    {
				       obj_t a_1670;
				       a_1670 = CDR(a_3);
				       a_3 = a_1670;
				       goto k_1__214_integrate_kk;
				    }
				 }
			    }
			 }
		      }
		 }
	      }
	   }
	}
     }
}


obj_t 
k_2__250_integrate_kk(obj_t a_5, obj_t a_tail_58_6)
{
   {
      bool_t test1383_860;
      {
	 obj_t aux_1672;
	 aux_1672 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1383_860 = CBOOL(aux_1672);
      }
      if (test1383_860)
	{
	   obj_t list1384_861;
	   {
	      obj_t arg1388_863;
	      {
		 obj_t aux_1678;
		 aux_1678 = BCHAR(((unsigned char) '\n'));
		 arg1388_863 = MAKE_PAIR(aux_1678, BNIL);
	      }
	      list1384_861 = MAKE_PAIR(string1657_integrate_kk, arg1388_863);
	   }
	   print_trace_107_tools_trace(list1384_861);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t continue_162_867;
      continue_162_867 = ((bool_t) 1);
    loop_868:
      if (continue_162_867)
	{
	   obj_t at_869;
	   bool_t continue_162_870;
	   at_869 = a_tail_58_6;
	   continue_162_870 = ((bool_t) 0);
	 liip_871:
	   {
	      bool_t test1397_872;
	      {
		 obj_t aux_1684;
		 aux_1684 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
		 test1397_872 = CBOOL(aux_1684);
	      }
	      if (test1397_872)
		{
		   obj_t arg1400_874;
		   if (PAIRP(at_869))
		     {
			arg1400_874 = shape_tools_shape(CAR(at_869));
		     }
		   else
		     {
			arg1400_874 = BNIL;
		     }
		   {
		      obj_t list1403_876;
		      {
			 obj_t arg1404_877;
			 {
			    obj_t arg1406_878;
			    {
			       obj_t arg1408_879;
			       {
				  obj_t arg1410_880;
				  {
				     obj_t aux_1694;
				     aux_1694 = BCHAR(((unsigned char) '\n'));
				     arg1410_880 = MAKE_PAIR(aux_1694, BNIL);
				  }
				  {
				     obj_t aux_1697;
				     aux_1697 = BBOOL(continue_162_870);
				     arg1408_879 = MAKE_PAIR(aux_1697, arg1410_880);
				  }
			       }
			       arg1406_878 = MAKE_PAIR(string1658_integrate_kk, arg1408_879);
			    }
			    arg1404_877 = MAKE_PAIR(arg1400_874, arg1406_878);
			 }
			 list1403_876 = MAKE_PAIR(string1659_integrate_kk, arg1404_877);
		      }
		      print_trace_107_tools_trace(list1403_876);
		   }
		}
	      else
		{
		   BUNSPEC;
		}
	   }
	   if (NULLP(at_869))
	     {
		bool_t continue_162_1706;
		continue_162_1706 = continue_162_870;
		continue_162_867 = continue_162_1706;
		goto loop_868;
	     }
	   else
	     {
		value_t ifun_887;
		{
		   variable_t obj_1400;
		   {
		      obj_t aux_1707;
		      {
			 obj_t aux_1708;
			 aux_1708 = CAR(at_869);
			 aux_1707 = CAR(aux_1708);
		      }
		      obj_1400 = (variable_t) (aux_1707);
		   }
		   ifun_887 = (((variable_t) CREF(obj_1400))->value);
		}
		{
		   bool_t test_1713;
		   {
		      obj_t aux_1714;
		      {
			 sfun_iinfo_105_t obj_1401;
			 obj_1401 = (sfun_iinfo_105_t) (ifun_887);
			 {
			    obj_t aux_1716;
			    {
			       object_t aux_1717;
			       aux_1717 = (object_t) (obj_1401);
			       aux_1716 = OBJECT_WIDENING(aux_1717);
			    }
			    aux_1714 = (((sfun_iinfo_105_t) CREF(aux_1716))->k);
			 }
		      }
		      test_1713 = NULLP(aux_1714);
		   }
		   if (test_1713)
		     {
			obj_t at_1722;
			at_1722 = CDR(at_869);
			at_869 = at_1722;
			goto liip_871;
		     }
		   else
		     {
			value_t gifun_891;
			{
			   variable_t obj_1409;
			   {
			      obj_t aux_1724;
			      {
				 obj_t aux_1725;
				 {
				    obj_t aux_1726;
				    aux_1726 = CAR(at_869);
				    aux_1725 = CDR(aux_1726);
				 }
				 aux_1724 = CAR(aux_1725);
			      }
			      obj_1409 = (variable_t) (aux_1724);
			   }
			   gifun_891 = (((variable_t) CREF(obj_1409))->value);
			}
			{
			   {
			      obj_t ks_892;
			      bool_t continue_162_893;
			      {
				 sfun_iinfo_105_t obj_1410;
				 obj_1410 = (sfun_iinfo_105_t) (ifun_887);
				 {
				    obj_t aux_1803;
				    {
				       object_t aux_1804;
				       aux_1804 = (object_t) (obj_1410);
				       aux_1803 = OBJECT_WIDENING(aux_1804);
				    }
				    ks_892 = (((sfun_iinfo_105_t) CREF(aux_1803))->k);
				 }
			      }
			      continue_162_893 = continue_162_870;
			    laap_894:
			      {
				 bool_t test1422_896;
				 {
				    obj_t aux_1732;
				    aux_1732 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				    test1422_896 = CBOOL(aux_1732);
				 }
				 if (test1422_896)
				   {
				      obj_t arg1426_898;
				      if (PAIRP(ks_892))
					{
					   arg1426_898 = shape_tools_shape(CAR(ks_892));
					}
				      else
					{
					   arg1426_898 = BNIL;
					}
				      {
					 obj_t list1428_900;
					 {
					    obj_t arg1431_901;
					    {
					       obj_t arg1432_902;
					       {
						  obj_t arg1440_903;
						  {
						     obj_t arg1441_904;
						     {
							obj_t aux_1742;
							aux_1742 = BCHAR(((unsigned char) '\n'));
							arg1441_904 = MAKE_PAIR(aux_1742, BNIL);
						     }
						     {
							obj_t aux_1745;
							aux_1745 = BBOOL(continue_162_893);
							arg1440_903 = MAKE_PAIR(aux_1745, arg1441_904);
						     }
						  }
						  arg1432_902 = MAKE_PAIR(string1658_integrate_kk, arg1440_903);
					       }
					       arg1431_901 = MAKE_PAIR(arg1426_898, arg1432_902);
					    }
					    list1428_900 = MAKE_PAIR(string1660_integrate_kk, arg1431_901);
					 }
					 print_trace_107_tools_trace(list1428_900);
				      }
				   }
				 else
				   {
				      BUNSPEC;
				   }
			      }
			      if (NULLP(ks_892))
				{
				   bool_t continue_162_1756;
				   obj_t at_1754;
				   at_1754 = CDR(at_869);
				   continue_162_1756 = continue_162_893;
				   continue_162_870 = continue_162_1756;
				   at_869 = at_1754;
				   goto liip_871;
				}
			      else
				{
				   obj_t k_912;
				   k_912 = CAR(ks_892);
				   {
				      bool_t test_1758;
				      {
					 obj_t aux_1759;
					 {
					    obj_t aux_1760;
					    {
					       sfun_iinfo_105_t obj_1416;
					       obj_1416 = (sfun_iinfo_105_t) (gifun_891);
					       {
						  obj_t aux_1762;
						  {
						     object_t aux_1763;
						     aux_1763 = (object_t) (obj_1416);
						     aux_1762 = OBJECT_WIDENING(aux_1763);
						  }
						  aux_1760 = (((sfun_iinfo_105_t) CREF(aux_1762))->k);
					       }
					    }
					    aux_1759 = memq___r4_pairs_and_lists_6_3(k_912, aux_1760);
					 }
					 test_1758 = CBOOL(aux_1759);
				      }
				      if (test_1758)
					{
					   obj_t ks_1769;
					   ks_1769 = CDR(ks_892);
					   ks_892 = ks_1769;
					   goto laap_894;
					}
				      else
					{
					   {
					      obj_t arg1453_915;
					      {
						 obj_t aux_1771;
						 {
						    sfun_iinfo_105_t obj_1418;
						    obj_1418 = (sfun_iinfo_105_t) (gifun_891);
						    {
						       obj_t aux_1773;
						       {
							  object_t aux_1774;
							  aux_1774 = (object_t) (obj_1418);
							  aux_1773 = OBJECT_WIDENING(aux_1774);
						       }
						       aux_1771 = (((sfun_iinfo_105_t) CREF(aux_1773))->k);
						    }
						 }
						 arg1453_915 = MAKE_PAIR(k_912, aux_1771);
					      }
					      {
						 obj_t res1652_1423;
						 {
						    sfun_iinfo_105_t obj_1421;
						    obj_1421 = (sfun_iinfo_105_t) (gifun_891);
						    {
						       obj_t x_1524;
						       {
							  obj_t aux_1780;
							  {
							     object_t aux_1781;
							     aux_1781 = (object_t) (obj_1421);
							     aux_1780 = OBJECT_WIDENING(aux_1781);
							  }
							  x_1524 = ((((sfun_iinfo_105_t) CREF(aux_1780))->k) = ((obj_t) arg1453_915), BUNSPEC);
						       }
						       res1652_1423 = BUNSPEC;
						    }
						 }
						 res1652_1423;
					      }
					   }
					   {
					      obj_t arg1457_917;
					      {
						 obj_t aux_1785;
						 {
						    sfun_iinfo_105_t obj_1424;
						    obj_1424 = (sfun_iinfo_105_t) (gifun_891);
						    {
						       obj_t aux_1787;
						       {
							  object_t aux_1788;
							  aux_1788 = (object_t) (obj_1424);
							  aux_1787 = OBJECT_WIDENING(aux_1788);
						       }
						       aux_1785 = (((sfun_iinfo_105_t) CREF(aux_1787))->k__190);
						    }
						 }
						 arg1457_917 = MAKE_PAIR(k_912, aux_1785);
					      }
					      {
						 obj_t res1653_1429;
						 {
						    sfun_iinfo_105_t obj_1427;
						    obj_1427 = (sfun_iinfo_105_t) (gifun_891);
						    {
						       obj_t x_1525;
						       {
							  obj_t aux_1794;
							  {
							     object_t aux_1795;
							     aux_1795 = (object_t) (obj_1427);
							     aux_1794 = OBJECT_WIDENING(aux_1795);
							  }
							  x_1525 = ((((sfun_iinfo_105_t) CREF(aux_1794))->k__190) = ((obj_t) arg1457_917), BUNSPEC);
						       }
						       res1653_1429 = BUNSPEC;
						    }
						 }
						 res1653_1429;
					      }
					   }
					   {
					      bool_t continue_162_1801;
					      obj_t ks_1799;
					      ks_1799 = CDR(ks_892);
					      continue_162_1801 = ((bool_t) 1);
					      continue_162_893 = continue_162_1801;
					      ks_892 = ks_1799;
					      goto laap_894;
					   }
					}
				   }
				}
			   }
			}
		     }
		}
	     }
	}
      else
	{
	   return a_tail_58_6;
	}
   }
}


obj_t 
k___139_integrate_kk(obj_t a_tail_58_7)
{
   {
      bool_t test1469_925;
      {
	 obj_t aux_1808;
	 aux_1808 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1469_925 = CBOOL(aux_1808);
      }
      if (test1469_925)
	{
	   obj_t list1470_926;
	   {
	      obj_t arg1472_928;
	      {
		 obj_t aux_1814;
		 aux_1814 = BCHAR(((unsigned char) '\n'));
		 arg1472_928 = MAKE_PAIR(aux_1814, BNIL);
	      }
	      list1470_926 = MAKE_PAIR(string1661_integrate_kk, arg1472_928);
	   }
	   print_trace_107_tools_trace(list1470_926);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t continue_162_932;
      continue_162_932 = ((bool_t) 1);
    loop_933:
      if (continue_162_932)
	{
	   obj_t at_934;
	   bool_t continue_162_935;
	   at_934 = a_tail_58_7;
	   continue_162_935 = ((bool_t) 0);
	 liip_936:
	   if (NULLP(at_934))
	     {
		bool_t continue_162_1822;
		continue_162_1822 = continue_162_935;
		continue_162_932 = continue_162_1822;
		goto loop_933;
	     }
	   else
	     {
		value_t ifun_938;
		{
		   variable_t obj_1437;
		   {
		      obj_t aux_1823;
		      {
			 obj_t aux_1824;
			 {
			    obj_t aux_1825;
			    aux_1825 = CAR(at_934);
			    aux_1824 = CDR(aux_1825);
			 }
			 aux_1823 = CAR(aux_1824);
		      }
		      obj_1437 = (variable_t) (aux_1823);
		   }
		   ifun_938 = (((variable_t) CREF(obj_1437))->value);
		}
		{
		   bool_t test_1831;
		   {
		      obj_t aux_1832;
		      {
			 sfun_iinfo_105_t obj_1438;
			 obj_1438 = (sfun_iinfo_105_t) (ifun_938);
			 {
			    obj_t aux_1834;
			    {
			       object_t aux_1835;
			       aux_1835 = (object_t) (obj_1438);
			       aux_1834 = OBJECT_WIDENING(aux_1835);
			    }
			    aux_1832 = (((sfun_iinfo_105_t) CREF(aux_1834))->k__190);
			 }
		      }
		      test_1831 = NULLP(aux_1832);
		   }
		   if (test_1831)
		     {
			bool_t continue_162_1840;
			continue_162_1840 = continue_162_935;
			continue_162_932 = continue_162_1840;
			goto loop_933;
		     }
		   else
		     {
			obj_t ks_940;
			bool_t continue_162_941;
			{
			   sfun_iinfo_105_t obj_1440;
			   obj_1440 = (sfun_iinfo_105_t) (ifun_938);
			   {
			      obj_t aux_1884;
			      {
				 object_t aux_1885;
				 aux_1885 = (object_t) (obj_1440);
				 aux_1884 = OBJECT_WIDENING(aux_1885);
			      }
			      ks_940 = (((sfun_iinfo_105_t) CREF(aux_1884))->k__190);
			   }
			}
			continue_162_941 = continue_162_935;
		      laap_942:
			if (NULLP(ks_940))
			  {
			     bool_t continue_162_1845;
			     obj_t at_1843;
			     at_1843 = CDR(at_934);
			     continue_162_1845 = continue_162_941;
			     continue_162_935 = continue_162_1845;
			     at_934 = at_1843;
			     goto liip_936;
			  }
			else
			  {
			     value_t fifun_947;
			     {
				variable_t obj_1445;
				{
				   obj_t aux_1846;
				   {
				      obj_t aux_1847;
				      aux_1847 = CAR(at_934);
				      aux_1846 = CAR(aux_1847);
				   }
				   obj_1445 = (variable_t) (aux_1846);
				}
				fifun_947 = (((variable_t) CREF(obj_1445))->value);
			     }
			     {
				obj_t k_948;
				k_948 = CAR(ks_940);
				{
				   {
				      bool_t test_1853;
				      {
					 obj_t aux_1854;
					 {
					    obj_t aux_1855;
					    {
					       sfun_iinfo_105_t obj_1447;
					       obj_1447 = (sfun_iinfo_105_t) (fifun_947);
					       {
						  obj_t aux_1857;
						  {
						     object_t aux_1858;
						     aux_1858 = (object_t) (obj_1447);
						     aux_1857 = OBJECT_WIDENING(aux_1858);
						  }
						  aux_1855 = (((sfun_iinfo_105_t) CREF(aux_1857))->k__190);
					       }
					    }
					    aux_1854 = memq___r4_pairs_and_lists_6_3(k_948, aux_1855);
					 }
					 test_1853 = CBOOL(aux_1854);
				      }
				      if (test_1853)
					{
					   obj_t ks_1864;
					   ks_1864 = CDR(ks_940);
					   ks_940 = ks_1864;
					   goto laap_942;
					}
				      else
					{
					   {
					      obj_t arg1487_951;
					      {
						 obj_t aux_1866;
						 {
						    sfun_iinfo_105_t obj_1449;
						    obj_1449 = (sfun_iinfo_105_t) (fifun_947);
						    {
						       obj_t aux_1868;
						       {
							  object_t aux_1869;
							  aux_1869 = (object_t) (obj_1449);
							  aux_1868 = OBJECT_WIDENING(aux_1869);
						       }
						       aux_1866 = (((sfun_iinfo_105_t) CREF(aux_1868))->k__190);
						    }
						 }
						 arg1487_951 = MAKE_PAIR(k_948, aux_1866);
					      }
					      {
						 obj_t res1654_1454;
						 {
						    sfun_iinfo_105_t obj_1452;
						    obj_1452 = (sfun_iinfo_105_t) (fifun_947);
						    {
						       obj_t x_1526;
						       {
							  obj_t aux_1875;
							  {
							     object_t aux_1876;
							     aux_1876 = (object_t) (obj_1452);
							     aux_1875 = OBJECT_WIDENING(aux_1876);
							  }
							  x_1526 = ((((sfun_iinfo_105_t) CREF(aux_1875))->k__190) = ((obj_t) arg1487_951), BUNSPEC);
						       }
						       res1654_1454 = BUNSPEC;
						    }
						 }
						 res1654_1454;
					      }
					   }
					   {
					      bool_t continue_162_1882;
					      obj_t ks_1880;
					      ks_1880 = CDR(ks_940);
					      continue_162_1882 = ((bool_t) 1);
					      continue_162_941 = continue_162_1882;
					      ks_940 = ks_1880;
					      goto laap_942;
					   }
					}
				   }
				}
			     }
			  }
		     }
		}
	     }
	}
      else
	{
	   return trace_k_14_integrate_kk();
	}
   }
}


obj_t 
_k___120_integrate_kk(obj_t env_1518, obj_t a_tail_58_1519)
{
   return k___139_integrate_kk(a_tail_58_1519);
}


obj_t 
trace_k_14_integrate_kk()
{
   {
      bool_t test1499_959;
      {
	 obj_t aux_1891;
	 aux_1891 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1499_959 = CBOOL(aux_1891);
      }
      if (test1499_959)
	{
	   char *arg1501_961;
	   {
	      obj_t l1329_966;
	      l1329_966 = __phi__105_integrate_a;
	    lname1330_967:
	      if (PAIRP(l1329_966))
		{
		   {
		      obj_t p_969;
		      p_969 = CAR(l1329_966);
		      {
			 value_t ifun_970;
			 {
			    variable_t obj_1458;
			    obj_1458 = (variable_t) (p_969);
			    ifun_970 = (((variable_t) CREF(obj_1458))->value);
			 }
			 {
			    obj_t arg1510_972;
			    obj_t arg1513_974;
			    obj_t arg1517_976;
			    arg1510_972 = shape_tools_shape(p_969);
			    {
			       obj_t aux_1903;
			       {
				  sfun_iinfo_105_t obj_1459;
				  obj_1459 = (sfun_iinfo_105_t) (ifun_970);
				  {
				     obj_t aux_1905;
				     {
					object_t aux_1906;
					aux_1906 = (object_t) (obj_1459);
					aux_1905 = OBJECT_WIDENING(aux_1906);
				     }
				     aux_1903 = (((sfun_iinfo_105_t) CREF(aux_1905))->k);
				  }
			       }
			       arg1513_974 = shape_tools_shape(aux_1903);
			    }
			    {
			       obj_t aux_1911;
			       {
				  sfun_iinfo_105_t obj_1460;
				  obj_1460 = (sfun_iinfo_105_t) (ifun_970);
				  {
				     obj_t aux_1913;
				     {
					object_t aux_1914;
					aux_1914 = (object_t) (obj_1460);
					aux_1913 = OBJECT_WIDENING(aux_1914);
				     }
				     aux_1911 = (((sfun_iinfo_105_t) CREF(aux_1913))->k__190);
				  }
			       }
			       arg1517_976 = shape_tools_shape(aux_1911);
			    }
			    {
			       obj_t list1518_977;
			       {
				  obj_t arg1520_978;
				  {
				     obj_t arg1522_979;
				     {
					obj_t arg1523_980;
					{
					   obj_t arg1524_981;
					   {
					      obj_t arg1526_982;
					      {
						 obj_t arg1529_983;
						 {
						    obj_t arg1531_984;
						    {
						       obj_t arg1532_985;
						       {
							  obj_t arg1534_986;
							  {
							     obj_t aux_1919;
							     aux_1919 = BCHAR(((unsigned char) '\n'));
							     arg1534_986 = MAKE_PAIR(aux_1919, BNIL);
							  }
							  arg1532_985 = MAKE_PAIR(arg1517_976, arg1534_986);
						       }
						       arg1531_984 = MAKE_PAIR(string1662_integrate_kk, arg1532_985);
						    }
						    {
						       obj_t aux_1924;
						       aux_1924 = BCHAR(((unsigned char) '\n'));
						       arg1529_983 = MAKE_PAIR(aux_1924, arg1531_984);
						    }
						 }
						 arg1526_982 = MAKE_PAIR(arg1513_974, arg1529_983);
					      }
					      arg1524_981 = MAKE_PAIR(string1663_integrate_kk, arg1526_982);
					   }
					   {
					      obj_t aux_1929;
					      aux_1929 = BCHAR(((unsigned char) '\n'));
					      arg1523_980 = MAKE_PAIR(aux_1929, arg1524_981);
					   }
					}
					{
					   obj_t aux_1932;
					   aux_1932 = BCHAR(((unsigned char) ':'));
					   arg1522_979 = MAKE_PAIR(aux_1932, arg1523_980);
					}
				     }
				     arg1520_978 = MAKE_PAIR(arg1510_972, arg1522_979);
				  }
				  list1518_977 = MAKE_PAIR(string1664_integrate_kk, arg1520_978);
			       }
			       fprint___r4_output_6_10_3(__trace_port__84_tools_trace, list1518_977);
			    }
			 }
		      }
		   }
		   {
		      obj_t l1329_1938;
		      l1329_1938 = CDR(l1329_966);
		      l1329_966 = l1329_1938;
		      goto lname1330_967;
		   }
		}
	      else
		{
		   ((bool_t) 1);
		}
	   }
	   arg1501_961 = "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~";
	   {
	      obj_t list1502_962;
	      {
		 obj_t arg1505_963;
		 {
		    obj_t arg1506_964;
		    {
		       obj_t aux_1940;
		       aux_1940 = BCHAR(((unsigned char) '\n'));
		       arg1506_964 = MAKE_PAIR(aux_1940, BNIL);
		    }
		    {
		       obj_t aux_1943;
		       aux_1943 = string_to_bstring(arg1501_961);
		       arg1505_963 = MAKE_PAIR(aux_1943, arg1506_964);
		    }
		 }
		 list1502_962 = MAKE_PAIR(string1665_integrate_kk, arg1505_963);
	      }
	      return print_trace_107_tools_trace(list1502_962);
	   }
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
imported_modules_init_94_integrate_kk()
{
   module_initialization_70_tools_trace(((long) 0), "INTEGRATE_KK");
   module_initialization_70_tools_shape(((long) 0), "INTEGRATE_KK");
   module_initialization_70_type_type(((long) 0), "INTEGRATE_KK");
   module_initialization_70_ast_var(((long) 0), "INTEGRATE_KK");
   module_initialization_70_ast_node(((long) 0), "INTEGRATE_KK");
   module_initialization_70_integrate_info(((long) 0), "INTEGRATE_KK");
   return module_initialization_70_integrate_a(((long) 0), "INTEGRATE_KK");
}
