/*===========================================================================*/
/*   (Integrate/let-fun.scm)                                                 */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_t;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_t;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_t;


static long __stamp__29_integrate_let_fun_158;
extern obj_t let_fun_218_ast_node;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t _displace_let_fun__244_integrate_let_fun_158(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t _displace_let_fun_node__151_integrate_let_fun_158(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_integrate_let_fun_158();
extern obj_t module_initialization_70_integrate_let_fun_158(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_integrate_let_fun_158();
static obj_t cnst_init_137_integrate_let_fun_158();
static obj_t displace_let_fun_node__default1348_52_integrate_let_fun_158(node_t, variable_t);
static obj_t require_initialization_114_integrate_let_fun_158 = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_integrate_let_fun_158();
extern obj_t cast_ast_node;
static obj_t displace_let_fun_node__83_integrate_let_fun_158(node_t, variable_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t displace_let_fun__199_integrate_let_fun_158(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern long class_num_218___object(obj_t);
static bool_t free_fun__183_integrate_let_fun_158(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t local_ast_var;
extern obj_t kwote_ast_node;
static obj_t bind_fun__68_integrate_let_fun_158(obj_t);
extern obj_t _____74_type_cache;
static obj_t _displace_let_fun_node__default1348_208_integrate_let_fun_158(obj_t, obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t app_ast_node;
static obj_t __cnst[2];

DEFINE_STATIC_GENERIC(displace_let_fun_node__env_245_integrate_let_fun_158, _displace_let_fun_node__151_integrate_let_fun_1581679, _displace_let_fun_node__151_integrate_let_fun_158, 0L, 2);
DEFINE_STRING(string1669_integrate_let_fun_158, string1669_integrate_let_fun_1581680, "Unexpected closure", 18);
DEFINE_STRING(string1670_integrate_let_fun_158, string1670_integrate_let_fun_1581681, "DISPLACE-LET-FUN-NODE!-DEFAULT1348 INTEGRATE ", 45);
DEFINE_STRING(string1668_integrate_let_fun_158, string1668_integrate_let_fun_1581682, "displace-let-fun-node", 21);
DEFINE_STATIC_PROCEDURE(displace_let_fun_node__default1348_env_59_integrate_let_fun_158, _displace_let_fun_node__default1348_208_integrate_let_fun_1581683, _displace_let_fun_node__default1348_208_integrate_let_fun_158, 0L, 2);
DEFINE_EXPORT_PROCEDURE(displace_let_fun__env_206_integrate_let_fun_158, _displace_let_fun__244_integrate_let_fun_1581684, _displace_let_fun__244_integrate_let_fun_158, 0L, 1);
DEFINE_STRING(string1666_integrate_let_fun_158, string1666_integrate_let_fun_1581685, "    j'ajoute les fonctions: ", 28);
DEFINE_STRING(string1667_integrate_let_fun_158, string1667_integrate_let_fun_1581686, "No method for this object", 25);
DEFINE_STRING(string1664_integrate_let_fun_158, string1664_integrate_let_fun_1581687, "                 Led: ", 22);
DEFINE_STRING(string1665_integrate_let_fun_158, string1665_integrate_let_fun_1581688, "   displace-let-fun!: ", 22);

obj_t 
module_initialization_70_integrate_let_fun_158(long checksum_1651, char *from_1652)
{
   if (CBOOL(require_initialization_114_integrate_let_fun_158))
     {
	require_initialization_114_integrate_let_fun_158 = BBOOL(((bool_t) 0));
	library_modules_init_112_integrate_let_fun_158();
	cnst_init_137_integrate_let_fun_158();
	imported_modules_init_94_integrate_let_fun_158();
	toplevel_init_63_integrate_let_fun_158();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_integrate_let_fun_158()
{
   module_initialization_70___object(((long) 0), "INTEGRATE_LET-FUN");
   module_initialization_70___reader(((long) 0), "INTEGRATE_LET-FUN");
   return BUNSPEC;
}


obj_t 
cnst_init_137_integrate_let_fun_158()
{
   {
      obj_t cnst_port_138_1643;
      cnst_port_138_1643 = open_input_string(string1670_integrate_let_fun_158);
      {
	 long i_1644;
	 i_1644 = ((long) 1);
       loop_1645:
	 {
	    bool_t test1671_1646;
	    test1671_1646 = (i_1644 == ((long) -1));
	    if (test1671_1646)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1673_1647;
		    {
		       obj_t list1674_1648;
		       {
			  obj_t arg1677_1649;
			  arg1677_1649 = BNIL;
			  list1674_1648 = MAKE_PAIR(cnst_port_138_1643, arg1677_1649);
		       }
		       arg1673_1647 = read___reader(list1674_1648);
		    }
		    CNST_TABLE_SET(i_1644, arg1673_1647);
		 }
		 {
		    int aux_1650;
		    {
		       long aux_1668;
		       aux_1668 = (i_1644 - ((long) 1));
		       aux_1650 = (int) (aux_1668);
		    }
		    {
		       long i_1671;
		       i_1671 = (long) (aux_1650);
		       i_1644 = i_1671;
		       goto loop_1645;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_integrate_let_fun_158()
{
   __stamp__29_integrate_let_fun_158 = ((long) 0);
   add_generic__110___object(displace_let_fun_node__env_245_integrate_let_fun_158, displace_let_fun_node__default1348_env_59_integrate_let_fun_158);
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, var_ast_node, ((long) 2));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, app_ast_node, ((long) 5));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, app_ly_162_ast_node, ((long) 6));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, funcall_ast_node, ((long) 7));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, pragma_ast_node, ((long) 8));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, cast_ast_node, ((long) 9));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, setq_ast_node, ((long) 10));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, conditional_ast_node, ((long) 11));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, fail_ast_node, ((long) 12));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, select_ast_node, ((long) 13));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, let_fun_218_ast_node, ((long) 14));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, let_var_6_ast_node, ((long) 15));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, set_ex_it_116_ast_node, ((long) 16));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, jump_ex_it_184_ast_node, ((long) 17));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, make_box_202_ast_node, ((long) 18));
   add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, box_set__221_ast_node, ((long) 19));
   {
      long aux_1694;
      aux_1694 = add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, box_ref_242_ast_node, ((long) 20));
      return BINT(aux_1694);
   }
}


obj_t 
bind_fun__68_integrate_let_fun_158(obj_t var_1)
{
   {
      bool_t test1378_857;
      test1378_857 = is_a__118___object(var_1, local_ast_var);
      if (test1378_857)
	{
	   obj_t res1659_1428;
	   {
	      sfun_iinfo_105_t obj_1426;
	      obj_t val1325_1427;
	      {
		 value_t aux_1699;
		 {
		    local_t obj_1425;
		    obj_1425 = (local_t) (var_1);
		    aux_1699 = (((local_t) CREF(obj_1425))->value);
		 }
		 obj_1426 = (sfun_iinfo_105_t) (aux_1699);
	      }
	      val1325_1427 = BINT(__stamp__29_integrate_let_fun_158);
	      {
		 obj_t x_1640;
		 {
		    obj_t aux_1704;
		    {
		       object_t aux_1705;
		       aux_1705 = (object_t) (obj_1426);
		       aux_1704 = OBJECT_WIDENING(aux_1705);
		    }
		    x_1640 = ((((sfun_iinfo_105_t) CREF(aux_1704))->istamp) = ((obj_t) val1325_1427), BUNSPEC);
		 }
		 res1659_1428 = BUNSPEC;
	      }
	   }
	   return res1659_1428;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


bool_t 
free_fun__183_integrate_let_fun_158(obj_t local_2)
{
   {
      bool_t test1380_859;
      {
	 obj_t arg1381_860;
	 {
	    sfun_iinfo_105_t obj_1430;
	    {
	       value_t aux_1709;
	       {
		  local_t obj_1429;
		  obj_1429 = (local_t) (local_2);
		  aux_1709 = (((local_t) CREF(obj_1429))->value);
	       }
	       obj_1430 = (sfun_iinfo_105_t) (aux_1709);
	    }
	    {
	       obj_t aux_1713;
	       {
		  object_t aux_1714;
		  aux_1714 = (object_t) (obj_1430);
		  aux_1713 = OBJECT_WIDENING(aux_1714);
	       }
	       arg1381_860 = (((sfun_iinfo_105_t) CREF(aux_1713))->istamp);
	    }
	 }
	 {
	    obj_t obj2_1432;
	    obj2_1432 = BINT(__stamp__29_integrate_let_fun_158);
	    test1380_859 = (arg1381_860 == obj2_1432);
	 }
      }
      if (test1380_859)
	{
	   return ((bool_t) 0);
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
displace_let_fun__199_integrate_let_fun_158(obj_t var_3)
{
   {
      bool_t test1383_862;
      {
	 obj_t aux_1721;
	 aux_1721 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1383_862 = CBOOL(aux_1721);
      }
      if (test1383_862)
	{
	   obj_t arg1388_864;
	   obj_t arg1391_866;
	   arg1388_864 = shape_tools_shape(var_3);
	   {
	      obj_t aux_1728;
	      {
		 sfun_iinfo_105_t obj_1434;
		 {
		    value_t aux_1729;
		    {
		       variable_t obj_1433;
		       obj_1433 = (variable_t) (var_3);
		       aux_1729 = (((variable_t) CREF(obj_1433))->value);
		    }
		    obj_1434 = (sfun_iinfo_105_t) (aux_1729);
		 }
		 {
		    obj_t aux_1733;
		    {
		       object_t aux_1734;
		       aux_1734 = (object_t) (obj_1434);
		       aux_1733 = OBJECT_WIDENING(aux_1734);
		    }
		    aux_1728 = (((sfun_iinfo_105_t) CREF(aux_1733))->led);
		 }
	      }
	      arg1391_866 = shape_tools_shape(aux_1728);
	   }
	   {
	      obj_t list1392_867;
	      {
		 obj_t arg1396_868;
		 {
		    obj_t arg1398_869;
		    {
		       obj_t arg1400_870;
		       {
			  obj_t arg1402_871;
			  {
			     obj_t arg1403_872;
			     {
				obj_t aux_1739;
				aux_1739 = BCHAR(((unsigned char) '\n'));
				arg1403_872 = MAKE_PAIR(aux_1739, BNIL);
			     }
			     arg1402_871 = MAKE_PAIR(arg1391_866, arg1403_872);
			  }
			  arg1400_870 = MAKE_PAIR(string1664_integrate_let_fun_158, arg1402_871);
		       }
		       {
			  obj_t aux_1744;
			  aux_1744 = BCHAR(((unsigned char) '\n'));
			  arg1398_869 = MAKE_PAIR(aux_1744, arg1400_870);
		       }
		    }
		    arg1396_868 = MAKE_PAIR(arg1388_864, arg1398_869);
		 }
		 list1392_867 = MAKE_PAIR(string1665_integrate_let_fun_158, arg1396_868);
	      }
	      print_trace_107_tools_trace(list1392_867);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      long z2_1436;
      z2_1436 = __stamp__29_integrate_let_fun_158;
      __stamp__29_integrate_let_fun_158 = (((long) 1) + z2_1436);
   }
   {
      node_t aux_1751;
      {
	 obj_t aux_1752;
	 {
	    sfun_t obj_1438;
	    {
	       value_t aux_1753;
	       {
		  variable_t obj_1437;
		  obj_1437 = (variable_t) (var_3);
		  aux_1753 = (((variable_t) CREF(obj_1437))->value);
	       }
	       obj_1438 = (sfun_t) (aux_1753);
	    }
	    aux_1752 = (((sfun_t) CREF(obj_1438))->body);
	 }
	 aux_1751 = (node_t) (aux_1752);
      }
      displace_let_fun_node__83_integrate_let_fun_158(aux_1751, (variable_t) (var_3));
   }
   {
      obj_t led_880;
      {
	 sfun_iinfo_105_t obj_1440;
	 {
	    value_t aux_1761;
	    {
	       variable_t obj_1439;
	       obj_1439 = (variable_t) (var_3);
	       aux_1761 = (((variable_t) CREF(obj_1439))->value);
	    }
	    obj_1440 = (sfun_iinfo_105_t) (aux_1761);
	 }
	 {
	    obj_t aux_1765;
	    {
	       object_t aux_1766;
	       aux_1766 = (object_t) (obj_1440);
	       aux_1765 = OBJECT_WIDENING(aux_1766);
	    }
	    led_880 = (((sfun_iinfo_105_t) CREF(aux_1765))->led);
	 }
      }
      {
	 obj_t l1329_881;
	 l1329_881 = led_880;
       lname1330_882:
	 if (PAIRP(l1329_881))
	   {
	      {
		 obj_t l_884;
		 l_884 = CAR(l1329_881);
		 if (free_fun__183_integrate_let_fun_158(l_884))
		   {
		      node_t aux_1775;
		      {
			 obj_t aux_1776;
			 {
			    sfun_t obj_1444;
			    {
			       value_t aux_1777;
			       {
				  variable_t obj_1443;
				  obj_1443 = (variable_t) (l_884);
				  aux_1777 = (((variable_t) CREF(obj_1443))->value);
			       }
			       obj_1444 = (sfun_t) (aux_1777);
			    }
			    aux_1776 = (((sfun_t) CREF(obj_1444))->body);
			 }
			 aux_1775 = (node_t) (aux_1776);
		      }
		      displace_let_fun_node__83_integrate_let_fun_158(aux_1775, (variable_t) (var_3));
		   }
		 else
		   {
		      BUNSPEC;
		   }
	      }
	      {
		 obj_t l1329_1785;
		 l1329_1785 = CDR(l1329_881);
		 l1329_881 = l1329_1785;
		 goto lname1330_882;
	      }
	   }
	 else
	   {
	      ((bool_t) 1);
	   }
      }
      {
	 obj_t led_889;
	 obj_t added_890;
	 led_889 = led_880;
	 added_890 = BNIL;
       loop_891:
	 if (NULLP(led_889))
	   {
	      if (PAIRP(added_890))
		{
		   obj_t old_body_129_895;
		   {
		      sfun_t obj_1449;
		      {
			 value_t aux_1791;
			 {
			    variable_t obj_1448;
			    obj_1448 = (variable_t) (var_3);
			    aux_1791 = (((variable_t) CREF(obj_1448))->value);
			 }
			 obj_1449 = (sfun_t) (aux_1791);
		      }
		      old_body_129_895 = (((sfun_t) CREF(obj_1449))->body);
		   }
		   {
		      let_fun_218_t new_body_215_896;
		      {
			 obj_t arg1446_907;
			 {
			    node_t obj_1450;
			    obj_1450 = (node_t) (old_body_129_895);
			    arg1446_907 = (((node_t) CREF(obj_1450))->loc);
			 }
			 {
			    let_fun_218_t res1660_1465;
			    {
			       type_t type_1452;
			       node_t body_1455;
			       type_1452 = (type_t) (_____74_type_cache);
			       body_1455 = (node_t) (old_body_129_895);
			       {
				  let_fun_218_t new1223_1456;
				  new1223_1456 = ((let_fun_218_t) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
				  {
				     long arg1496_1457;
				     arg1496_1457 = class_num_218___object(let_fun_218_ast_node);
				     {
					obj_t obj_1463;
					obj_1463 = (obj_t) (new1223_1456);
					(((obj_t) CREF(obj_1463))->header = MAKE_HEADER(arg1496_1457, 0), BUNSPEC);
				     }
				  }
				  {
				     object_t aux_1804;
				     aux_1804 = (object_t) (new1223_1456);
				     OBJECT_WIDENING_SET(aux_1804, BFALSE);
				  }
				  ((((let_fun_218_t) CREF(new1223_1456))->loc) = ((obj_t) arg1446_907), BUNSPEC);
				  ((((let_fun_218_t) CREF(new1223_1456))->type) = ((type_t) type_1452), BUNSPEC);
				  ((((let_fun_218_t) CREF(new1223_1456))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
				  ((((let_fun_218_t) CREF(new1223_1456))->locals) = ((obj_t) added_890), BUNSPEC);
				  ((((let_fun_218_t) CREF(new1223_1456))->body) = ((node_t) body_1455), BUNSPEC);
				  res1660_1465 = new1223_1456;
			       }
			    }
			    new_body_215_896 = res1660_1465;
			 }
		      }
		      {
			 {
			    bool_t test1424_897;
			    {
			       obj_t aux_1812;
			       aux_1812 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
			       test1424_897 = CBOOL(aux_1812);
			    }
			    if (test1424_897)
			      {
				 obj_t arg1427_899;
				 arg1427_899 = shape_tools_shape(added_890);
				 {
				    obj_t list1428_900;
				    {
				       obj_t arg1431_901;
				       {
					  obj_t arg1432_902;
					  {
					     obj_t aux_1819;
					     aux_1819 = BCHAR(((unsigned char) '\n'));
					     arg1432_902 = MAKE_PAIR(aux_1819, BNIL);
					  }
					  arg1431_901 = MAKE_PAIR(arg1427_899, arg1432_902);
				       }
				       list1428_900 = MAKE_PAIR(string1666_integrate_let_fun_158, arg1431_901);
				    }
				    print_trace_107_tools_trace(list1428_900);
				 }
			      }
			    else
			      {
				 BUNSPEC;
			      }
			 }
			 {
			    obj_t res1661_1469;
			    {
			       sfun_t obj_1467;
			       obj_t val1081_1468;
			       {
				  value_t aux_1825;
				  {
				     variable_t obj_1466;
				     obj_1466 = (variable_t) (var_3);
				     aux_1825 = (((variable_t) CREF(obj_1466))->value);
				  }
				  obj_1467 = (sfun_t) (aux_1825);
			       }
			       val1081_1468 = (obj_t) (new_body_215_896);
			       {
				  obj_t x_1641;
				  x_1641 = ((((sfun_t) CREF(obj_1467))->body) = ((obj_t) val1081_1468), BUNSPEC);
				  res1661_1469 = BUNSPEC;
			       }
			    }
			    res1661_1469;
			 }
			 return (obj_t) (new_body_215_896);
		      }
		   }
		}
	      else
		{
		   return BUNSPEC;
		}
	   }
	 else
	   {
	      if (free_fun__183_integrate_let_fun_158(CAR(led_889)))
		{
		   {
		      obj_t arg1449_910;
		      obj_t arg1450_911;
		      arg1449_910 = CDR(led_889);
		      {
			 obj_t aux_1836;
			 aux_1836 = CAR(led_889);
			 arg1450_911 = MAKE_PAIR(aux_1836, added_890);
		      }
		      {
			 obj_t added_1840;
			 obj_t led_1839;
			 led_1839 = arg1449_910;
			 added_1840 = arg1450_911;
			 added_890 = added_1840;
			 led_889 = led_1839;
			 goto loop_891;
		      }
		   }
		}
	      else
		{
		   {
		      obj_t led_1841;
		      led_1841 = CDR(led_889);
		      led_889 = led_1841;
		      goto loop_891;
		   }
		}
	   }
      }
   }
}


obj_t 
_displace_let_fun__244_integrate_let_fun_158(obj_t env_1638, obj_t var_1639)
{
   return displace_let_fun__199_integrate_let_fun_158(var_1639);
}


obj_t 
displace_let_fun_node__default1348_52_integrate_let_fun_158(node_t node_6, variable_t variable_7)
{
   FAILURE(CNST_TABLE_REF(((long) 1)), string1667_integrate_let_fun_158, (obj_t) (node_6));
}


obj_t 
_displace_let_fun_node__default1348_208_integrate_let_fun_158(obj_t env_1635, obj_t node_1636, obj_t variable_1637)
{
   return displace_let_fun_node__default1348_52_integrate_let_fun_158((node_t) (node_1636), (variable_t) (variable_1637));
}


obj_t 
displace_let_fun_node__83_integrate_let_fun_158(node_t node_4, variable_t variable_5)
{
 displace_let_fun_node__83_integrate_let_fun_158:
   {
      obj_t method1574_1278;
      obj_t class1579_1279;
      {
	 obj_t arg1582_1276;
	 obj_t arg1583_1277;
	 {
	    object_t obj_1481;
	    obj_1481 = (object_t) (node_4);
	    {
	       obj_t pre_method_105_1482;
	       pre_method_105_1482 = PROCEDURE_REF(displace_let_fun_node__env_245_integrate_let_fun_158, ((long) 2));
	       if (INTEGERP(pre_method_105_1482))
		 {
		    PROCEDURE_SET(displace_let_fun_node__env_245_integrate_let_fun_158, ((long) 2), BUNSPEC);
		    arg1582_1276 = pre_method_105_1482;
		 }
	       else
		 {
		    long obj_class_num_177_1487;
		    obj_class_num_177_1487 = TYPE(obj_1481);
		    {
		       obj_t arg1183_1488;
		       arg1183_1488 = PROCEDURE_REF(displace_let_fun_node__env_245_integrate_let_fun_158, ((long) 1));
		       {
			  long arg1184_1492;
			  {
			     long arg1186_1493;
			     arg1186_1493 = OBJECT_TYPE;
			     arg1184_1492 = (obj_class_num_177_1487 - arg1186_1493);
			  }
			  arg1582_1276 = VECTOR_REF(arg1183_1488, arg1184_1492);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1498;
	    object_1498 = (object_t) (node_4);
	    {
	       long arg1187_1499;
	       {
		  long arg1188_1500;
		  long arg1189_1501;
		  arg1188_1500 = TYPE(object_1498);
		  arg1189_1501 = OBJECT_TYPE;
		  arg1187_1499 = (arg1188_1500 - arg1189_1501);
	       }
	       {
		  obj_t vector_1505;
		  vector_1505 = __classes__134___object;
		  arg1583_1277 = VECTOR_REF(vector_1505, arg1187_1499);
	       }
	    }
	 }
	 method1574_1278 = arg1582_1276;
	 class1579_1279 = arg1583_1277;
	 {
	    if (INTEGERP(method1574_1278))
	      {
		 switch ((long) CINT(method1574_1278))
		   {
		   case ((long) 0):
		      return BUNSPEC;
		      break;
		   case ((long) 1):
		      return BUNSPEC;
		      break;
		   case ((long) 2):
		      return BUNSPEC;
		      break;
		   case ((long) 3):
		      {
			 obj_t arg1589_1295;
			 {
			    obj_t aux_1867;
			    {
			       closure_t aux_1868;
			       aux_1868 = (closure_t) (node_4);
			       aux_1867 = (obj_t) (aux_1868);
			    }
			    arg1589_1295 = shape_tools_shape(aux_1867);
			 }
			 return internal_error_43_tools_error(string1668_integrate_let_fun_158, string1669_integrate_let_fun_158, arg1589_1295);
		      }
		      break;
		   case ((long) 4):
		      {
			 sequence_t node_1296;
			 node_1296 = (sequence_t) (node_4);
			 {
			    obj_t l1332_1299;
			    {
			       bool_t aux_1874;
			       l1332_1299 = (((sequence_t) CREF(node_1296))->nodes);
			     lname1333_1300:
			       if (PAIRP(l1332_1299))
				 {
				    {
				       node_t aux_1877;
				       {
					  obj_t aux_1878;
					  aux_1878 = CAR(l1332_1299);
					  aux_1877 = (node_t) (aux_1878);
				       }
				       displace_let_fun_node__83_integrate_let_fun_158(aux_1877, variable_5);
				    }
				    {
				       obj_t l1332_1882;
				       l1332_1882 = CDR(l1332_1299);
				       l1332_1299 = l1332_1882;
				       goto lname1333_1300;
				    }
				 }
			       else
				 {
				    aux_1874 = ((bool_t) 1);
				 }
			       return BBOOL(aux_1874);
			    }
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 app_t node_1305;
			 node_1305 = (app_t) (node_4);
			 {
			    obj_t args_1307;
			    args_1307 = (((app_t) CREF(node_1305))->args);
			  liip_1308:
			    if (NULLP(args_1307))
			      {
				 return BUNSPEC;
			      }
			    else
			      {
				 {
				    node_t aux_1889;
				    {
				       obj_t aux_1890;
				       aux_1890 = CAR(args_1307);
				       aux_1889 = (node_t) (aux_1890);
				    }
				    displace_let_fun_node__83_integrate_let_fun_158(aux_1889, variable_5);
				 }
				 {
				    obj_t args_1894;
				    args_1894 = CDR(args_1307);
				    args_1307 = args_1894;
				    goto liip_1308;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 app_ly_162_t node_1313;
			 node_1313 = (app_ly_162_t) (node_4);
			 displace_let_fun_node__83_integrate_let_fun_158((((app_ly_162_t) CREF(node_1313))->fun), variable_5);
			 {
			    node_t node_1900;
			    node_1900 = (((app_ly_162_t) CREF(node_1313))->arg);
			    node_4 = node_1900;
			    goto displace_let_fun_node__83_integrate_let_fun_158;
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 funcall_t node_1318;
			 node_1318 = (funcall_t) (node_4);
			 {
			    obj_t asts_1321;
			    asts_1321 = (((funcall_t) CREF(node_1318))->args);
			  liip_1322:
			    if (NULLP(asts_1321))
			      {
				 node_t node_1905;
				 node_1905 = (((funcall_t) CREF(node_1318))->fun);
				 node_4 = node_1905;
				 goto displace_let_fun_node__83_integrate_let_fun_158;
			      }
			    else
			      {
				 {
				    node_t aux_1907;
				    {
				       obj_t aux_1908;
				       aux_1908 = CAR(asts_1321);
				       aux_1907 = (node_t) (aux_1908);
				    }
				    displace_let_fun_node__83_integrate_let_fun_158(aux_1907, variable_5);
				 }
				 {
				    obj_t asts_1912;
				    asts_1912 = CDR(asts_1321);
				    asts_1321 = asts_1912;
				    goto liip_1322;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 pragma_t node_1328;
			 node_1328 = (pragma_t) (node_4);
			 {
			    obj_t l1337_1331;
			    {
			       bool_t aux_1916;
			       l1337_1331 = (((pragma_t) CREF(node_1328))->args);
			     lname1338_1332:
			       if (PAIRP(l1337_1331))
				 {
				    {
				       node_t aux_1919;
				       {
					  obj_t aux_1920;
					  aux_1920 = CAR(l1337_1331);
					  aux_1919 = (node_t) (aux_1920);
				       }
				       displace_let_fun_node__83_integrate_let_fun_158(aux_1919, variable_5);
				    }
				    {
				       obj_t l1337_1924;
				       l1337_1924 = CDR(l1337_1331);
				       l1337_1331 = l1337_1924;
				       goto lname1338_1332;
				    }
				 }
			       else
				 {
				    aux_1916 = ((bool_t) 1);
				 }
			       return BBOOL(aux_1916);
			    }
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 cast_t node_1337;
			 node_1337 = (cast_t) (node_4);
			 {
			    node_t node_1929;
			    node_1929 = (((cast_t) CREF(node_1337))->arg);
			    node_4 = node_1929;
			    goto displace_let_fun_node__83_integrate_let_fun_158;
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 setq_t node_1341;
			 node_1341 = (setq_t) (node_4);
			 {
			    node_t node_1932;
			    node_1932 = (((setq_t) CREF(node_1341))->value);
			    node_4 = node_1932;
			    goto displace_let_fun_node__83_integrate_let_fun_158;
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 conditional_t node_1345;
			 node_1345 = (conditional_t) (node_4);
			 displace_let_fun_node__83_integrate_let_fun_158((((conditional_t) CREF(node_1345))->test), variable_5);
			 displace_let_fun_node__83_integrate_let_fun_158((((conditional_t) CREF(node_1345))->true), variable_5);
			 {
			    node_t node_1939;
			    node_1939 = (((conditional_t) CREF(node_1345))->false);
			    node_4 = node_1939;
			    goto displace_let_fun_node__83_integrate_let_fun_158;
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 fail_t node_1351;
			 node_1351 = (fail_t) (node_4);
			 displace_let_fun_node__83_integrate_let_fun_158((((fail_t) CREF(node_1351))->proc), variable_5);
			 displace_let_fun_node__83_integrate_let_fun_158((((fail_t) CREF(node_1351))->msg), variable_5);
			 {
			    node_t node_1946;
			    node_1946 = (((fail_t) CREF(node_1351))->obj);
			    node_4 = node_1946;
			    goto displace_let_fun_node__83_integrate_let_fun_158;
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 select_t node_1357;
			 node_1357 = (select_t) (node_4);
			 {
			    obj_t clauses_1360;
			    clauses_1360 = (((select_t) CREF(node_1357))->clauses);
			  liip_1361:
			    if (NULLP(clauses_1360))
			      {
				 node_t node_1951;
				 node_1951 = (((select_t) CREF(node_1357))->test);
				 node_4 = node_1951;
				 goto displace_let_fun_node__83_integrate_let_fun_158;
			      }
			    else
			      {
				 {
				    node_t aux_1953;
				    {
				       obj_t aux_1954;
				       {
					  obj_t aux_1955;
					  aux_1955 = CAR(clauses_1360);
					  aux_1954 = CDR(aux_1955);
				       }
				       aux_1953 = (node_t) (aux_1954);
				    }
				    displace_let_fun_node__83_integrate_let_fun_158(aux_1953, variable_5);
				 }
				 {
				    obj_t clauses_1960;
				    clauses_1960 = CDR(clauses_1360);
				    clauses_1360 = clauses_1960;
				    goto liip_1361;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 let_fun_218_t node_1368;
			 node_1368 = (let_fun_218_t) (node_4);
			 {
			    obj_t old_1371;
			    obj_t new_1372;
			    old_1371 = (((let_fun_218_t) CREF(node_1368))->locals);
			    new_1372 = BNIL;
			  liip_1373:
			    if (NULLP(old_1371))
			      {
				 {
				    obj_t res1662_1544;
				    {
				       obj_t x_1642;
				       x_1642 = ((((let_fun_218_t) CREF(node_1368))->locals) = ((obj_t) new_1372), BUNSPEC);
				       res1662_1544 = BUNSPEC;
				    }
				    res1662_1544;
				 }
				 {
				    node_t node_1967;
				    node_1967 = (((let_fun_218_t) CREF(node_1368))->body);
				    node_4 = node_1967;
				    goto displace_let_fun_node__83_integrate_let_fun_158;
				 }
			      }
			    else
			      {
				 bool_t test_1969;
				 {
				    obj_t aux_1982;
				    obj_t aux_1970;
				    aux_1982 = (obj_t) (variable_5);
				    {
				       sfun_iinfo_105_t obj_1548;
				       {
					  value_t aux_1971;
					  {
					     local_t obj_1547;
					     {
						obj_t aux_1972;
						aux_1972 = CAR(old_1371);
						obj_1547 = (local_t) (aux_1972);
					     }
					     aux_1971 = (((local_t) CREF(obj_1547))->value);
					  }
					  obj_1548 = (sfun_iinfo_105_t) (aux_1971);
				       }
				       {
					  obj_t aux_1977;
					  {
					     object_t aux_1978;
					     aux_1978 = (object_t) (obj_1548);
					     aux_1977 = OBJECT_WIDENING(aux_1978);
					  }
					  aux_1970 = (((sfun_iinfo_105_t) CREF(aux_1977))->l);
				       }
				    }
				    test_1969 = (aux_1970 == aux_1982);
				 }
				 if (test_1969)
				   {
				      {
					 obj_t l_1379;
					 l_1379 = CAR(old_1371);
					 bind_fun__68_integrate_let_fun_158(l_1379);
					 {
					    node_t aux_1987;
					    {
					       obj_t aux_1988;
					       {
						  sfun_t obj_1553;
						  {
						     value_t aux_1989;
						     {
							local_t obj_1552;
							obj_1552 = (local_t) (l_1379);
							aux_1989 = (((local_t) CREF(obj_1552))->value);
						     }
						     obj_1553 = (sfun_t) (aux_1989);
						  }
						  aux_1988 = (((sfun_t) CREF(obj_1553))->body);
					       }
					       aux_1987 = (node_t) (aux_1988);
					    }
					    displace_let_fun_node__83_integrate_let_fun_158(aux_1987, variable_5);
					 }
					 {
					    obj_t arg1638_1382;
					    obj_t arg1641_1383;
					    arg1638_1382 = CDR(old_1371);
					    arg1641_1383 = MAKE_PAIR(l_1379, new_1372);
					    {
					       obj_t new_1999;
					       obj_t old_1998;
					       old_1998 = arg1638_1382;
					       new_1999 = arg1641_1383;
					       new_1372 = new_1999;
					       old_1371 = old_1998;
					       goto liip_1373;
					    }
					 }
				      }
				   }
				 else
				   {
				      {
					 obj_t old_2000;
					 old_2000 = CDR(old_1371);
					 old_1371 = old_2000;
					 goto liip_1373;
				      }
				   }
			      }
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 let_var_6_t node_1388;
			 node_1388 = (let_var_6_t) (node_4);
			 {
			    obj_t bindings_1391;
			    bindings_1391 = (((let_var_6_t) CREF(node_1388))->bindings);
			  liip_1392:
			    if (NULLP(bindings_1391))
			      {
				 node_t node_2006;
				 node_2006 = (((let_var_6_t) CREF(node_1388))->body);
				 node_4 = node_2006;
				 goto displace_let_fun_node__83_integrate_let_fun_158;
			      }
			    else
			      {
				 {
				    node_t aux_2008;
				    {
				       obj_t aux_2009;
				       {
					  obj_t aux_2010;
					  aux_2010 = CAR(bindings_1391);
					  aux_2009 = CDR(aux_2010);
				       }
				       aux_2008 = (node_t) (aux_2009);
				    }
				    displace_let_fun_node__83_integrate_let_fun_158(aux_2008, variable_5);
				 }
				 {
				    obj_t bindings_2015;
				    bindings_2015 = CDR(bindings_1391);
				    bindings_1391 = bindings_2015;
				    goto liip_1392;
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 set_ex_it_116_t node_1400;
			 node_1400 = (set_ex_it_116_t) (node_4);
			 {
			    node_t node_2019;
			    node_2019 = (((set_ex_it_116_t) CREF(node_1400))->body);
			    node_4 = node_2019;
			    goto displace_let_fun_node__83_integrate_let_fun_158;
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 jump_ex_it_184_t node_1404;
			 node_1404 = (jump_ex_it_184_t) (node_4);
			 displace_let_fun_node__83_integrate_let_fun_158((((jump_ex_it_184_t) CREF(node_1404))->exit), variable_5);
			 {
			    node_t node_2024;
			    node_2024 = (((jump_ex_it_184_t) CREF(node_1404))->value);
			    node_4 = node_2024;
			    goto displace_let_fun_node__83_integrate_let_fun_158;
			 }
		      }
		      break;
		   case ((long) 18):
		      return BUNSPEC;
		      break;
		   case ((long) 19):
		      return BUNSPEC;
		      break;
		   case ((long) 20):
		      return BUNSPEC;
		      break;
		   default:
		    case_else1580_33_1282:
		      if (PROCEDUREP(method1574_1278))
			{
			   return PROCEDURE_ENTRY(method1574_1278) (method1574_1278, (obj_t) (node_4), (obj_t) (variable_5), BEOA);
			}
		      else
			{
			   obj_t fun1462_918;
			   fun1462_918 = PROCEDURE_REF(displace_let_fun_node__env_245_integrate_let_fun_158, ((long) 0));
			   return PROCEDURE_ENTRY(fun1462_918) (fun1462_918, (obj_t) (node_4), (obj_t) (variable_5), BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1580_33_1282;
	      }
	 }
      }
   }
}


obj_t 
_displace_let_fun_node__151_integrate_let_fun_158(obj_t env_1632, obj_t node_1633, obj_t variable_1634)
{
   return displace_let_fun_node__83_integrate_let_fun_158((node_t) (node_1633), (variable_t) (variable_1634));
}


obj_t 
imported_modules_init_94_integrate_let_fun_158()
{
   module_initialization_70_tools_trace(((long) 0), "INTEGRATE_LET-FUN");
   module_initialization_70_tools_shape(((long) 0), "INTEGRATE_LET-FUN");
   module_initialization_70_tools_error(((long) 0), "INTEGRATE_LET-FUN");
   module_initialization_70_type_type(((long) 0), "INTEGRATE_LET-FUN");
   module_initialization_70_type_cache(((long) 0), "INTEGRATE_LET-FUN");
   module_initialization_70_ast_var(((long) 0), "INTEGRATE_LET-FUN");
   module_initialization_70_ast_node(((long) 0), "INTEGRATE_LET-FUN");
   return module_initialization_70_integrate_info(((long) 0), "INTEGRATE_LET-FUN");
}
