/*===========================================================================*/
/*   (Integrate/loc2glo.scm)                                                 */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_t;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_t;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_t;


extern obj_t reverse___r4_pairs_and_lists_6_3(obj_t);
extern obj_t globalize__167_integrate_node(node_t, variable_t, obj_t);
extern obj_t _local__global_77_integrate_local__global_163(obj_t, obj_t);
extern local_t clone_local_230_ast_local(local_t, value_t);
extern bool_t integrate_celled__59_integrate_node(local_t);
extern global_t def_global_sfun__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_integrate_local__global_163();
extern obj_t module_initialization_70_integrate_local__global_163(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t cnst_init_137_integrate_local__global_163();
extern obj_t __module__166_module_module;
extern obj_t local__global_40_integrate_local__global_163(local_t);
static obj_t require_initialization_114_integrate_local__global_163 = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_integrate_local__global_163();
extern obj_t ___arity_132_tools_args(obj_t, obj_t);
extern obj_t svar_iinfo_76_integrate_info;
extern obj_t sfun_ast_var;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t svar_ast_var;
extern obj_t gensym___r4_symbols_6_4;
extern long list_length(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _the_global_232_integrate_local__global_163(obj_t, obj_t);
extern obj_t __obj__252_type_cache;
extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern obj_t the_global_201_integrate_local__global_163(local_t);
static obj_t __cnst[4];

DEFINE_EXPORT_PROCEDURE(local__global_env_170_integrate_local__global_163, _local__global_77_integrate_local__global_1631602, _local__global_77_integrate_local__global_163, 0L, 1);
DEFINE_EXPORT_PROCEDURE(the_global_env_148_integrate_local__global_163, _the_global_232_integrate_local__global_1631603, _the_global_232_integrate_local__global_163, 0L, 1);
DEFINE_STRING(string1595_integrate_local__global_163, string1595_integrate_local__global_1631604, "NOW A-INTEGRATED-BODY SFUN INTEGRATE ", 37);

obj_t 
module_initialization_70_integrate_local__global_163(long checksum_1516, char *from_1517)
{
   if (CBOOL(require_initialization_114_integrate_local__global_163))
     {
	require_initialization_114_integrate_local__global_163 = BBOOL(((bool_t) 0));
	library_modules_init_112_integrate_local__global_163();
	cnst_init_137_integrate_local__global_163();
	imported_modules_init_94_integrate_local__global_163();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_integrate_local__global_163()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   module_initialization_70___object(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   module_initialization_70___reader(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   module_initialization_70___r4_symbols_6_4(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   return BUNSPEC;
}


obj_t 
cnst_init_137_integrate_local__global_163()
{
   {
      obj_t cnst_port_138_1508;
      cnst_port_138_1508 = open_input_string(string1595_integrate_local__global_163);
      {
	 long i_1509;
	 i_1509 = ((long) 3);
       loop_1510:
	 {
	    bool_t test1596_1511;
	    test1596_1511 = (i_1509 == ((long) -1));
	    if (test1596_1511)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1597_1512;
		    {
		       obj_t list1598_1513;
		       {
			  obj_t arg1600_1514;
			  arg1600_1514 = BNIL;
			  list1598_1513 = MAKE_PAIR(cnst_port_138_1508, arg1600_1514);
		       }
		       arg1597_1512 = read___reader(list1598_1513);
		    }
		    CNST_TABLE_SET(i_1509, arg1597_1512);
		 }
		 {
		    int aux_1515;
		    {
		       long aux_1534;
		       aux_1534 = (i_1509 - ((long) 1));
		       aux_1515 = (int) (aux_1534);
		    }
		    {
		       long i_1537;
		       i_1537 = (long) (aux_1515);
		       i_1509 = i_1537;
		       goto loop_1510;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
local__global_40_integrate_local__global_163(local_t local_1)
{
   {
      bool_t test1351_821;
      {
	 obj_t aux_1539;
	 aux_1539 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1351_821 = CBOOL(aux_1539);
      }
      if (test1351_821)
	{
	   obj_t arg1352_822;
	   arg1352_822 = shape_tools_shape((obj_t) (local_1));
	   {
	      obj_t list1353_823;
	      {
		 obj_t arg1355_824;
		 {
		    obj_t arg1356_825;
		    {
		       obj_t aux_1547;
		       aux_1547 = BCHAR(((unsigned char) '\n'));
		       arg1356_825 = MAKE_PAIR(aux_1547, BNIL);
		    }
		    {
		       obj_t aux_1550;
		       aux_1550 = BCHAR(((unsigned char) ':'));
		       arg1355_824 = MAKE_PAIR(aux_1550, arg1356_825);
		    }
		 }
		 list1353_823 = MAKE_PAIR(arg1352_822, arg1355_824);
	      }
	      print_trace_107_tools_trace(list1353_823);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t global_829;
      global_829 = the_global_201_integrate_local__global_163(local_1);
      {
	 obj_t kaptured_830;
	 {
	    sfun_iinfo_105_t obj_1288;
	    {
	       value_t aux_1556;
	       aux_1556 = (((local_t) CREF(local_1))->value);
	       obj_1288 = (sfun_iinfo_105_t) (aux_1556);
	    }
	    {
	       obj_t aux_1559;
	       {
		  object_t aux_1560;
		  aux_1560 = (object_t) (obj_1288);
		  aux_1559 = OBJECT_WIDENING(aux_1560);
	       }
	       kaptured_830 = (((sfun_iinfo_105_t) CREF(aux_1559))->kaptured);
	    }
	 }
	 {
	    obj_t add_args_4_831;
	    if (NULLP(kaptured_830))
	      {
		 add_args_4_831 = BNIL;
	      }
	    else
	      {
		 obj_t head1336_885;
		 head1336_885 = MAKE_PAIR(BNIL, BNIL);
		 {
		    obj_t l1334_886;
		    obj_t tail1337_887;
		    l1334_886 = kaptured_830;
		    tail1337_887 = head1336_885;
		  lname1335_888:
		    if (NULLP(l1334_886))
		      {
			 add_args_4_831 = CDR(head1336_885);
		      }
		    else
		      {
			 obj_t new_tail1338_43_890;
			 {
			    local_t arg1426_892;
			    {
			       obj_t old_894;
			       old_894 = CAR(l1334_886);
			       {
				  svar_iinfo_76_t arg1428_895;
				  {
				     svar_iinfo_76_t duplicated1339_896;
				     {
					local_t obj_1295;
					obj_1295 = (local_t) (old_894);
					{
					   value_t aux_1572;
					   aux_1572 = (((local_t) CREF(obj_1295))->value);
					   duplicated1339_896 = (svar_iinfo_76_t) (aux_1572);
					}
				     }
				     {
					obj_t arg1431_897;
					obj_t arg1432_898;
					bool_t arg1440_899;
					bool_t arg1441_900;
					{
					   obj_t aux_1575;
					   {
					      object_t aux_1576;
					      aux_1576 = (object_t) (duplicated1339_896);
					      aux_1575 = OBJECT_WIDENING(aux_1576);
					   }
					   arg1431_897 = (((svar_iinfo_76_t) CREF(aux_1575))->f_mark_181);
					}
					{
					   obj_t aux_1580;
					   {
					      object_t aux_1581;
					      aux_1581 = (object_t) (duplicated1339_896);
					      aux_1580 = OBJECT_WIDENING(aux_1581);
					   }
					   arg1432_898 = (((svar_iinfo_76_t) CREF(aux_1580))->u_mark_209);
					}
					{
					   obj_t aux_1585;
					   {
					      object_t aux_1586;
					      aux_1586 = (object_t) (duplicated1339_896);
					      aux_1585 = OBJECT_WIDENING(aux_1586);
					   }
					   arg1440_899 = (((svar_iinfo_76_t) CREF(aux_1585))->kaptured__204);
					}
					{
					   obj_t aux_1590;
					   {
					      object_t aux_1591;
					      aux_1591 = (object_t) (duplicated1339_896);
					      aux_1590 = OBJECT_WIDENING(aux_1591);
					   }
					   arg1441_900 = (((svar_iinfo_76_t) CREF(aux_1590))->celled__113);
					}
					{
					   svar_iinfo_76_t res1585_1325;
					   {
					      svar_t aux1282_1304;
					      {
						 svar_t res1583_1312;
						 {
						    svar_t new1100_1308;
						    new1100_1308 = ((svar_t) BREF(GC_MALLOC(sizeof(struct svar))));
						    {
						       long arg1561_1309;
						       arg1561_1309 = class_num_218___object(svar_ast_var);
						       {
							  obj_t obj_1310;
							  obj_1310 = (obj_t) (new1100_1308);
							  (((obj_t) CREF(obj_1310))->header = MAKE_HEADER(arg1561_1309, 0), BUNSPEC);
						       }
						    }
						    {
						       object_t aux_1599;
						       aux_1599 = (object_t) (new1100_1308);
						       OBJECT_WIDENING_SET(aux_1599, BFALSE);
						    }
						    {
						       res1583_1312 = new1100_1308;
						    }
						 }
						 aux1282_1304 = res1583_1312;
					      }
					      {
						 svar_iinfo_76_t new1283_1305;
						 new1283_1305 = ((svar_iinfo_76_t) (aux1282_1304));
						 {
						    long arg1480_1306;
						    arg1480_1306 = class_num_218___object(svar_iinfo_76_integrate_info);
						    {
						       obj_t obj_1313;
						       obj_1313 = (obj_t) (new1283_1305);
						       (((obj_t) CREF(obj_1313))->header = MAKE_HEADER(arg1480_1306, 0), BUNSPEC);
						    }
						 }
						 {
						    svar_iinfo_76_t arg1481_1307;
						    {
						       svar_iinfo_76_t res1584_1324;
						       {
							  svar_iinfo_76_t new1280_1319;
							  new1280_1319 = ((svar_iinfo_76_t) BREF(GC_MALLOC(sizeof(struct svar_iinfo_76))));
							  ((((svar_iinfo_76_t) CREF(new1280_1319))->f_mark_181) = ((obj_t) arg1431_897), BUNSPEC);
							  ((((svar_iinfo_76_t) CREF(new1280_1319))->u_mark_209) = ((obj_t) arg1432_898), BUNSPEC);
							  ((((svar_iinfo_76_t) CREF(new1280_1319))->kaptured__204) = ((bool_t) arg1440_899), BUNSPEC);
							  ((((svar_iinfo_76_t) CREF(new1280_1319))->celled__113) = ((bool_t) arg1441_900), BUNSPEC);
							  res1584_1324 = new1280_1319;
						       }
						       arg1481_1307 = res1584_1324;
						    }
						    {
						       obj_t aux_1613;
						       object_t aux_1611;
						       aux_1613 = (obj_t) (arg1481_1307);
						       aux_1611 = (object_t) (new1283_1305);
						       OBJECT_WIDENING_SET(aux_1611, aux_1613);
						    }
						 }
						 res1585_1325 = new1283_1305;
					      }
					   }
					   arg1428_895 = res1585_1325;
					}
				     }
				  }
				  arg1426_892 = clone_local_230_ast_local((local_t) (old_894), (value_t) (arg1428_895));
			       }
			    }
			    {
			       obj_t aux_1619;
			       aux_1619 = (obj_t) (arg1426_892);
			       new_tail1338_43_890 = MAKE_PAIR(aux_1619, BNIL);
			    }
			 }
			 SET_CDR(tail1337_887, new_tail1338_43_890);
			 {
			    obj_t tail1337_1625;
			    obj_t l1334_1623;
			    l1334_1623 = CDR(l1334_886);
			    tail1337_1625 = new_tail1338_43_890;
			    tail1337_887 = tail1337_1625;
			    l1334_886 = l1334_1623;
			    goto lname1335_888;
			 }
		      }
		 }
	      }
	    {
	       value_t old_fun_147_832;
	       old_fun_147_832 = (((local_t) CREF(local_1))->value);
	       {
		  sfun_t new_fun_115_833;
		  {
		     sfun_t duplicated1340_867;
		     duplicated1340_867 = (sfun_t) (old_fun_147_832);
		     {
			obj_t arg1400_868;
			obj_t arg1402_869;
			obj_t arg1403_870;
			obj_t arg1404_871;
			bool_t arg1406_872;
			obj_t arg1408_873;
			obj_t arg1410_874;
			obj_t arg1411_875;
			obj_t arg1412_876;
			obj_t arg1414_877;
			obj_t arg1415_878;
			{
			   obj_t aux_1632;
			   obj_t aux_1628;
			   {
			      long aux_1633;
			      aux_1633 = list_length(add_args_4_831);
			      aux_1632 = BINT(aux_1633);
			   }
			   {
			      long aux_1629;
			      aux_1629 = (((sfun_t) CREF(duplicated1340_867))->arity);
			      aux_1628 = BINT(aux_1629);
			   }
			   arg1400_868 = ___arity_132_tools_args(aux_1628, aux_1632);
			}
			arg1402_869 = (((sfun_t) CREF(duplicated1340_867))->side_effect__165);
			arg1403_870 = (((sfun_t) CREF(duplicated1340_867))->predicate_of_78);
			arg1404_871 = (((sfun_t) CREF(duplicated1340_867))->stack_allocator_172);
			arg1406_872 = (((sfun_t) CREF(duplicated1340_867))->top__138);
			arg1408_873 = (((sfun_t) CREF(duplicated1340_867))->the_closure_238);
			arg1410_874 = (((sfun_t) CREF(duplicated1340_867))->property);
			arg1411_875 = append_2_18___r4_pairs_and_lists_6_3(reverse___r4_pairs_and_lists_6_3(add_args_4_831), (((sfun_t) CREF(duplicated1340_867))->args));
			arg1412_876 = (((sfun_t) CREF(duplicated1340_867))->body);
			arg1414_877 = (((sfun_t) CREF(duplicated1340_867))->class);
			arg1415_878 = (((sfun_t) CREF(duplicated1340_867))->dsssl_keywords_243);
			{
			   sfun_t res1586_1369;
			   {
			      long arity_1343;
			      arity_1343 = (long) CINT(arg1400_868);
			      {
				 sfun_t new1076_1354;
				 new1076_1354 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
				 {
				    long arg1565_1355;
				    arg1565_1355 = class_num_218___object(sfun_ast_var);
				    {
				       obj_t obj_1367;
				       obj_1367 = (obj_t) (new1076_1354);
				       (((obj_t) CREF(obj_1367))->header = MAKE_HEADER(arg1565_1355, 0), BUNSPEC);
				    }
				 }
				 {
				    object_t aux_1654;
				    aux_1654 = (object_t) (new1076_1354);
				    OBJECT_WIDENING_SET(aux_1654, BFALSE);
				 }
				 ((((sfun_t) CREF(new1076_1354))->arity) = ((long) arity_1343), BUNSPEC);
				 ((((sfun_t) CREF(new1076_1354))->side_effect__165) = ((obj_t) arg1402_869), BUNSPEC);
				 ((((sfun_t) CREF(new1076_1354))->predicate_of_78) = ((obj_t) arg1403_870), BUNSPEC);
				 ((((sfun_t) CREF(new1076_1354))->stack_allocator_172) = ((obj_t) arg1404_871), BUNSPEC);
				 ((((sfun_t) CREF(new1076_1354))->top__138) = ((bool_t) arg1406_872), BUNSPEC);
				 ((((sfun_t) CREF(new1076_1354))->the_closure_238) = ((obj_t) arg1408_873), BUNSPEC);
				 ((((sfun_t) CREF(new1076_1354))->property) = ((obj_t) arg1410_874), BUNSPEC);
				 ((((sfun_t) CREF(new1076_1354))->args) = ((obj_t) arg1411_875), BUNSPEC);
				 ((((sfun_t) CREF(new1076_1354))->body) = ((obj_t) arg1412_876), BUNSPEC);
				 ((((sfun_t) CREF(new1076_1354))->class) = ((obj_t) arg1414_877), BUNSPEC);
				 ((((sfun_t) CREF(new1076_1354))->dsssl_keywords_243) = ((obj_t) arg1415_878), BUNSPEC);
				 res1586_1369 = new1076_1354;
			      }
			   }
			   new_fun_115_833 = res1586_1369;
			}
		     }
		  }
		  {
		     {
			type_t arg1361_834;
			arg1361_834 = (((local_t) CREF(local_1))->type);
			{
			   obj_t res1587_1373;
			   {
			      global_t obj_1371;
			      obj_1371 = (global_t) (global_829);
			      {
				 obj_t x_1502;
				 x_1502 = ((((global_t) CREF(obj_1371))->type) = ((type_t) arg1361_834), BUNSPEC);
				 res1587_1373 = BUNSPEC;
			      }
			   }
			   res1587_1373;
			}
		     }
		     {
			obj_t l1341_835;
			l1341_835 = (((sfun_t) CREF(new_fun_115_833))->args);
		      lname1344_836:
			if (PAIRP(l1341_835))
			  {
			     {
				obj_t l_839;
				l_839 = CAR(l1341_835);
				{
				   bool_t test1365_840;
				   test1365_840 = integrate_celled__59_integrate_node((local_t) (l_839));
				   if (test1365_840)
				     {
					obj_t res1588_1379;
					{
					   local_t obj_1377;
					   type_t val1059_1378;
					   obj_1377 = (local_t) (l_839);
					   val1059_1378 = (type_t) (__obj__252_type_cache);
					   {
					      obj_t x_1503;
					      x_1503 = ((((local_t) CREF(obj_1377))->type) = ((type_t) val1059_1378), BUNSPEC);
					      res1588_1379 = BUNSPEC;
					   }
					}
					res1588_1379;
				     }
				   else
				     {
					BUNSPEC;
				     }
				}
			     }
			     {
				obj_t l1341_1680;
				l1341_1680 = CDR(l1341_835);
				l1341_835 = l1341_1680;
				goto lname1344_836;
			     }
			  }
			else
			  {
			     ((bool_t) 1);
			  }
		     }
		     {
			obj_t arg1367_842;
			{
			   obj_t arg1369_843;
			   obj_t arg1370_844;
			   {
			      sfun_t obj_1381;
			      obj_1381 = (sfun_t) (old_fun_147_832);
			      arg1369_843 = (((sfun_t) CREF(obj_1381))->body);
			   }
			   if (NULLP(kaptured_830))
			     {
				arg1370_844 = BNIL;
			     }
			   else
			     {
				obj_t head1347_848;
				{
				   obj_t arg1390_863;
				   {
				      obj_t aux_1689;
				      obj_t aux_1687;
				      aux_1689 = CAR(add_args_4_831);
				      aux_1687 = CAR(kaptured_830);
				      arg1390_863 = MAKE_PAIR(aux_1687, aux_1689);
				   }
				   head1347_848 = MAKE_PAIR(arg1390_863, BNIL);
				}
				{
				   obj_t ll1345_849;
				   obj_t ll1346_850;
				   obj_t tail1348_851;
				   ll1345_849 = CDR(kaptured_830);
				   ll1346_850 = CDR(add_args_4_831);
				   tail1348_851 = head1347_848;
				 lname1350_852:
				   if (NULLP(ll1345_849))
				     {
					arg1370_844 = head1347_848;
				     }
				   else
				     {
					obj_t new_tail1349_21_856;
					{
					   obj_t arg1381_859;
					   {
					      obj_t aux_1697;
					      obj_t aux_1695;
					      aux_1697 = CAR(ll1346_850);
					      aux_1695 = CAR(ll1345_849);
					      arg1381_859 = MAKE_PAIR(aux_1695, aux_1697);
					   }
					   new_tail1349_21_856 = MAKE_PAIR(arg1381_859, BNIL);
					}
					SET_CDR(tail1348_851, new_tail1349_21_856);
					{
					   obj_t tail1348_1706;
					   obj_t ll1346_1704;
					   obj_t ll1345_1702;
					   ll1345_1702 = CDR(ll1345_849);
					   ll1346_1704 = CDR(ll1346_850);
					   tail1348_1706 = new_tail1349_21_856;
					   tail1348_851 = tail1348_1706;
					   ll1346_850 = ll1346_1704;
					   ll1345_849 = ll1345_1702;
					   goto lname1350_852;
					}
				     }
				}
			     }
			   arg1367_842 = globalize__167_integrate_node((node_t) (arg1369_843), (variable_t) (local_1), arg1370_844);
			}
			{
			   obj_t res1589_1404;
			   {
			      obj_t x_1504;
			      x_1504 = ((((sfun_t) CREF(new_fun_115_833))->body) = ((obj_t) arg1367_842), BUNSPEC);
			      res1589_1404 = BUNSPEC;
			   }
			   res1589_1404;
			}
		     }
		     {
			obj_t res1590_1407;
			{
			   global_t obj_1405;
			   value_t val1046_1406;
			   obj_1405 = (global_t) (global_829);
			   val1046_1406 = (value_t) (new_fun_115_833);
			   {
			      obj_t x_1505;
			      x_1505 = ((((global_t) CREF(obj_1405))->value) = ((value_t) val1046_1406), BUNSPEC);
			      res1590_1407 = BUNSPEC;
			   }
			}
			res1590_1407;
		     }
		     return global_829;
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_local__global_77_integrate_local__global_163(obj_t env_1498, obj_t local_1499)
{
   return local__global_40_integrate_local__global_163((local_t) (local_1499));
}


obj_t 
the_global_201_integrate_local__global_163(local_t local_2)
{
   {
      value_t value_904;
      value_904 = (((local_t) CREF(local_2))->value);
      {
	 bool_t test1447_905;
	 {
	    obj_t aux_1719;
	    {
	       sfun_iinfo_105_t obj_1409;
	       obj_1409 = (sfun_iinfo_105_t) (value_904);
	       {
		  obj_t aux_1721;
		  {
		     object_t aux_1722;
		     aux_1722 = (object_t) (obj_1409);
		     aux_1721 = OBJECT_WIDENING(aux_1722);
		  }
		  aux_1719 = (((sfun_iinfo_105_t) CREF(aux_1721))->global);
	       }
	    }
	    test1447_905 = is_a__118___object(aux_1719, global_ast_var);
	 }
	 if (test1447_905)
	   {
	      sfun_iinfo_105_t obj_1411;
	      obj_1411 = (sfun_iinfo_105_t) (value_904);
	      {
		 obj_t aux_1729;
		 {
		    object_t aux_1730;
		    aux_1730 = (object_t) (obj_1411);
		    aux_1729 = OBJECT_WIDENING(aux_1730);
		 }
		 return (((sfun_iinfo_105_t) CREF(aux_1729))->global);
	      }
	   }
	 else
	   {
	      obj_t id_906;
	      {
		 bool_t test1458_915;
		 {
		    obj_t arg1463_917;
		    {
		       obj_t arg1465_918;
		       arg1465_918 = (((local_t) CREF(local_2))->id);
		       {
			  obj_t list1466_919;
			  list1466_919 = MAKE_PAIR(__module__166_module_module, BNIL);
			  arg1463_917 = find_global_223_ast_env(arg1465_918, list1466_919);
		       }
		    }
		    test1458_915 = is_a__118___object(arg1463_917, global_ast_var);
		 }
		 if (test1458_915)
		   {
		      id_906 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, (((local_t) CREF(local_2))->id), BEOA);
		   }
		 else
		   {
		      id_906 = (((local_t) CREF(local_2))->id);
		   }
	      }
	      {
		 global_t global_907;
		 global_907 = def_global_sfun__93_ast_glo_def_117(id_906, BNIL, BNIL, __module__166_module_module, CNST_TABLE_REF(((long) 1)), CNST_TABLE_REF(((long) 2)), CNST_TABLE_REF(((long) 3)), BUNSPEC);
		 {
		    {
		       obj_t res1591_1418;
		       {
			  sfun_iinfo_105_t obj_1416;
			  obj_t val1331_1417;
			  obj_1416 = (sfun_iinfo_105_t) (value_904);
			  val1331_1417 = (obj_t) (global_907);
			  {
			     obj_t x_1506;
			     {
				obj_t aux_1749;
				{
				   object_t aux_1750;
				   aux_1750 = (object_t) (obj_1416);
				   aux_1749 = OBJECT_WIDENING(aux_1750);
				}
				x_1506 = ((((sfun_iinfo_105_t) CREF(aux_1749))->global) = ((obj_t) val1331_1417), BUNSPEC);
			     }
			     res1591_1418 = BUNSPEC;
			  }
		       }
		       res1591_1418;
		    }
		    {
		       obj_t arg1449_909;
		       {
			  sfun_t obj_1420;
			  obj_1420 = (sfun_t) (value_904);
			  arg1449_909 = (((sfun_t) CREF(obj_1420))->side_effect__165);
		       }
		       {
			  obj_t res1592_1423;
			  {
			     sfun_t obj_1421;
			     {
				value_t aux_1756;
				aux_1756 = (((global_t) CREF(global_907))->value);
				obj_1421 = (sfun_t) (aux_1756);
			     }
			     {
				obj_t x_1507;
				x_1507 = ((((sfun_t) CREF(obj_1421))->side_effect__165) = ((obj_t) arg1449_909), BUNSPEC);
				res1592_1423 = BUNSPEC;
			     }
			  }
			  res1592_1423;
		       }
		    }
		    return (obj_t) (global_907);
		 }
	      }
	   }
      }
   }
}


obj_t 
_the_global_232_integrate_local__global_163(obj_t env_1500, obj_t local_1501)
{
   return the_global_201_integrate_local__global_163((local_t) (local_1501));
}


obj_t 
imported_modules_init_94_integrate_local__global_163()
{
   module_initialization_70_tools_trace(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   module_initialization_70_tools_shape(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   module_initialization_70_tools_args(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   module_initialization_70_module_module(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   module_initialization_70_type_type(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   module_initialization_70_type_cache(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   module_initialization_70_ast_var(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   module_initialization_70_ast_node(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   module_initialization_70_ast_glo_def_117(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   module_initialization_70_ast_env(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   module_initialization_70_ast_local(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   module_initialization_70_integrate_info(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   return module_initialization_70_integrate_node(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
}
