/*===========================================================================*/
/*   (Integrate/node.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_t;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_t;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_t;


extern obj_t globalize__167_integrate_node(node_t, variable_t, obj_t);
extern obj_t let_fun_218_ast_node;
extern obj_t _globalize__140_integrate_node(obj_t, obj_t, obj_t, obj_t);
static obj_t celled_bindings_3_integrate_node(obj_t);
extern bool_t integrate_celled__59_integrate_node(local_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
static obj_t _glo__107_integrate_node(obj_t, obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t globalize_local_fun__50_integrate_node(local_t, variable_t);
static obj_t imported_modules_init_94_integrate_node();
extern obj_t module_initialization_70_integrate_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_local__global_163(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t toplevel_init_63_integrate_node();
static obj_t cnst_init_137_integrate_node();
static node_t glo__115_integrate_node(node_t, variable_t);
static node_t glo__default1374_202_integrate_node(node_t, variable_t);
static obj_t require_initialization_114_integrate_node = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_integrate_node();
extern obj_t svar_iinfo_76_integrate_info;
extern obj_t cast_ast_node;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
static obj_t glo___241_integrate_node(obj_t, variable_t);
extern obj_t pragma_ast_node;
extern long class_num_218___object(obj_t);
static make_box_202_t a_make_cell_117_integrate_node(node_t, variable_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t local_ast_var;
extern obj_t kwote_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _____74_type_cache;
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t __obj__252_type_cache;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
extern obj_t _integrate_celled__234_integrate_node(obj_t, obj_t);
static obj_t cell_formals_12_integrate_node(obj_t, node_t);
extern obj_t the_global_201_integrate_local__global_163(local_t);
static obj_t _glo__default1374_50_integrate_node(obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t __cnst[6];

DEFINE_STATIC_GENERIC(glo__env_172_integrate_node, _glo__107_integrate_node1933, _glo__107_integrate_node, 0L, 2);
DEFINE_STRING(string1911_integrate_node, string1911_integrate_node1934, "  ", 2);
DEFINE_STATIC_PROCEDURE(glo__default1374_env_69_integrate_node, _glo__default1374_50_integrate_node1935, _glo__default1374_50_integrate_node, 0L, 2);
DEFINE_STRING(string1922_integrate_node, string1922_integrate_node1936, "node-free", 9);
DEFINE_STRING(string1913_integrate_node, string1913_integrate_node1937, "globalize!: ", 12);
DEFINE_STRING(string1926_integrate_node, string1926_integrate_node1938, "AUX DONE GLO!-DEFAULT1374 (WRITE CELL-INTEGRATE) CELL-INTEGRATE INTEGRATE ", 74);
DEFINE_STRING(string1925_integrate_node, string1925_integrate_node1939, "box-set!: ", 10);
DEFINE_STRING(string1915_integrate_node, string1915_integrate_node1940, " not Iinfo", 10);
DEFINE_STRING(string1914_integrate_node, string1914_integrate_node1941, "*** a-make-cell: ", 17);
DEFINE_EXPORT_PROCEDURE(integrate_celled__env_119_integrate_node, _integrate_celled__234_integrate_node1942, _integrate_celled__234_integrate_node, 0L, 1);
DEFINE_STRING(string1921_integrate_node, string1921_integrate_node1943, "No method for this object", 25);
DEFINE_STRING(string1920_integrate_node, string1920_integrate_node1944, "*** celled?: ", 13);
DEFINE_EXPORT_PROCEDURE(globalize__env_187_integrate_node, _globalize__140_integrate_node1945, _globalize__140_integrate_node, 0L, 3);
DEFINE_STRING(string1923_integrate_node, string1923_integrate_node1946, "Unexepected `closure' node", 26);
DEFINE_STRING(string1917_integrate_node, string1917_integrate_node1947, " kaptured?:", 11);
DEFINE_STRING(string1912_integrate_node, string1912_integrate_node1948, " ", 1);
DEFINE_STRING(string1918_integrate_node, string1918_integrate_node1949, " Iinfo-celled?:", 15);
DEFINE_STRING(string1916_integrate_node, string1916_integrate_node1950, " Not Iinfo", 10);
DEFINE_STRING(string1924_integrate_node, string1924_integrate_node1951, "box-ref: ", 9);
DEFINE_STRING(string1919_integrate_node, string1919_integrate_node1952, " Iinfo?:", 8);

obj_t 
module_initialization_70_integrate_node(long checksum_2229, char *from_2230)
{
   if (CBOOL(require_initialization_114_integrate_node))
     {
	require_initialization_114_integrate_node = BBOOL(((bool_t) 0));
	library_modules_init_112_integrate_node();
	cnst_init_137_integrate_node();
	imported_modules_init_94_integrate_node();
	toplevel_init_63_integrate_node();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_integrate_node()
{
   module_initialization_70___object(((long) 0), "INTEGRATE_NODE");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_NODE");
   module_initialization_70___reader(((long) 0), "INTEGRATE_NODE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_integrate_node()
{
   {
      obj_t cnst_port_138_2221;
      cnst_port_138_2221 = open_input_string(string1926_integrate_node);
      {
	 long i_2222;
	 i_2222 = ((long) 5);
       loop_2223:
	 {
	    bool_t test1927_2224;
	    test1927_2224 = (i_2222 == ((long) -1));
	    if (test1927_2224)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1928_2225;
		    {
		       obj_t list1929_2226;
		       {
			  obj_t arg1931_2227;
			  arg1931_2227 = BNIL;
			  list1929_2226 = MAKE_PAIR(cnst_port_138_2221, arg1931_2227);
		       }
		       arg1928_2225 = read___reader(list1929_2226);
		    }
		    CNST_TABLE_SET(i_2222, arg1928_2225);
		 }
		 {
		    int aux_2228;
		    {
		       long aux_2247;
		       aux_2247 = (i_2222 - ((long) 1));
		       aux_2228 = (int) (aux_2247);
		    }
		    {
		       long i_2250;
		       i_2250 = (long) (aux_2228);
		       i_2222 = i_2250;
		       goto loop_2223;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_integrate_node()
{
   add_generic__110___object(glo__env_172_integrate_node, glo__default1374_env_69_integrate_node);
   add_inlined_method__244___object(glo__env_172_integrate_node, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(glo__env_172_integrate_node, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(glo__env_172_integrate_node, var_ast_node, ((long) 2));
   add_inlined_method__244___object(glo__env_172_integrate_node, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(glo__env_172_integrate_node, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(glo__env_172_integrate_node, app_ast_node, ((long) 5));
   add_inlined_method__244___object(glo__env_172_integrate_node, app_ly_162_ast_node, ((long) 6));
   add_inlined_method__244___object(glo__env_172_integrate_node, funcall_ast_node, ((long) 7));
   add_inlined_method__244___object(glo__env_172_integrate_node, pragma_ast_node, ((long) 8));
   add_inlined_method__244___object(glo__env_172_integrate_node, cast_ast_node, ((long) 9));
   add_inlined_method__244___object(glo__env_172_integrate_node, setq_ast_node, ((long) 10));
   add_inlined_method__244___object(glo__env_172_integrate_node, conditional_ast_node, ((long) 11));
   add_inlined_method__244___object(glo__env_172_integrate_node, fail_ast_node, ((long) 12));
   add_inlined_method__244___object(glo__env_172_integrate_node, select_ast_node, ((long) 13));
   add_inlined_method__244___object(glo__env_172_integrate_node, let_fun_218_ast_node, ((long) 14));
   add_inlined_method__244___object(glo__env_172_integrate_node, let_var_6_ast_node, ((long) 15));
   add_inlined_method__244___object(glo__env_172_integrate_node, set_ex_it_116_ast_node, ((long) 16));
   add_inlined_method__244___object(glo__env_172_integrate_node, jump_ex_it_184_ast_node, ((long) 17));
   add_inlined_method__244___object(glo__env_172_integrate_node, make_box_202_ast_node, ((long) 18));
   add_inlined_method__244___object(glo__env_172_integrate_node, box_ref_242_ast_node, ((long) 19));
   {
      long aux_2273;
      aux_2273 = add_inlined_method__244___object(glo__env_172_integrate_node, box_set__221_ast_node, ((long) 20));
      return BINT(aux_2273);
   }
}


obj_t 
globalize__167_integrate_node(node_t ast_1, variable_t integrator_2, obj_t what_by__117_3)
{
   {
      bool_t test1408_867;
      {
	 obj_t aux_2276;
	 aux_2276 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1408_867 = CBOOL(aux_2276);
      }
      if (test1408_867)
	{
	   obj_t arg1411_869;
	   obj_t arg1414_871;
	   obj_t arg1416_873;
	   arg1411_869 = shape_tools_shape((obj_t) (integrator_2));
	   arg1414_871 = shape_tools_shape(what_by__117_3);
	   arg1416_873 = shape_tools_shape((obj_t) (ast_1));
	   {
	      obj_t list1417_874;
	      {
		 obj_t arg1418_875;
		 {
		    obj_t arg1420_876;
		    {
		       obj_t arg1421_877;
		       {
			  obj_t arg1424_878;
			  {
			     obj_t arg1426_879;
			     {
				obj_t arg1427_880;
				{
				   obj_t arg1428_881;
				   {
				      obj_t aux_2287;
				      aux_2287 = BCHAR(((unsigned char) '\n'));
				      arg1428_881 = MAKE_PAIR(aux_2287, BNIL);
				   }
				   arg1427_880 = MAKE_PAIR(arg1416_873, arg1428_881);
				}
				arg1426_879 = MAKE_PAIR(string1911_integrate_node, arg1427_880);
			     }
			     {
				obj_t aux_2292;
				aux_2292 = BCHAR(((unsigned char) '\n'));
				arg1424_878 = MAKE_PAIR(aux_2292, arg1426_879);
			     }
			  }
			  arg1421_877 = MAKE_PAIR(arg1414_871, arg1424_878);
		       }
		       arg1420_876 = MAKE_PAIR(string1912_integrate_node, arg1421_877);
		    }
		    arg1418_875 = MAKE_PAIR(arg1411_869, arg1420_876);
		 }
		 list1417_874 = MAKE_PAIR(string1913_integrate_node, arg1418_875);
	      }
	      print_trace_107_tools_trace(list1417_874);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t celled_886;
      {
	 obj_t aux_2300;
	 {
	    sfun_t obj_1626;
	    {
	       value_t aux_2301;
	       aux_2301 = (((variable_t) CREF(integrator_2))->value);
	       obj_1626 = (sfun_t) (aux_2301);
	    }
	    aux_2300 = (((sfun_t) CREF(obj_1626))->args);
	 }
	 celled_886 = celled_bindings_3_integrate_node(aux_2300);
      }
      {
	 obj_t what_by__117_887;
	 what_by__117_887 = append_2_18___r4_pairs_and_lists_6_3(celled_886, what_by__117_3);
	 {
	    {
	       obj_t l1329_888;
	       l1329_888 = what_by__117_887;
	     lname1330_889:
	       if (PAIRP(l1329_888))
		 {
		    {
		       obj_t w_b_127_891;
		       w_b_127_891 = CAR(l1329_888);
		       {
			  obj_t arg1445_893;
			  arg1445_893 = CDR(w_b_127_891);
			  {
			     obj_t res1863_1633;
			     {
				local_t obj_1631;
				{
				   obj_t aux_2311;
				   aux_2311 = CAR(w_b_127_891);
				   obj_1631 = (local_t) (aux_2311);
				}
				{
				   obj_t x_2185;
				   x_2185 = ((((local_t) CREF(obj_1631))->fast_alpha_7) = ((obj_t) arg1445_893), BUNSPEC);
				   res1863_1633 = BUNSPEC;
				}
			     }
			     res1863_1633;
			  }
		       }
		    }
		    {
		       obj_t l1329_2315;
		       l1329_2315 = CDR(l1329_888);
		       l1329_888 = l1329_2315;
		       goto lname1330_889;
		    }
		 }
	       else
		 {
		    ((bool_t) 1);
		 }
	    }
	    {
	       obj_t res_895;
	       {
		  node_t arg1450_902;
		  arg1450_902 = glo__115_integrate_node(ast_1, integrator_2);
		  res_895 = cell_formals_12_integrate_node(celled_886, arg1450_902);
	       }
	       {
		  obj_t l1331_896;
		  l1331_896 = what_by__117_887;
		lname1333_897:
		  if (PAIRP(l1331_896))
		    {
		       {
			  obj_t res1864_1640;
			  {
			     local_t obj_1638;
			     {
				obj_t aux_2321;
				{
				   obj_t aux_2322;
				   aux_2322 = CAR(l1331_896);
				   aux_2321 = CAR(aux_2322);
				}
				obj_1638 = (local_t) (aux_2321);
			     }
			     {
				obj_t x_2186;
				x_2186 = ((((local_t) CREF(obj_1638))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
				res1864_1640 = BUNSPEC;
			     }
			  }
			  res1864_1640;
		       }
		       {
			  obj_t l1331_2327;
			  l1331_2327 = CDR(l1331_896);
			  l1331_896 = l1331_2327;
			  goto lname1333_897;
		       }
		    }
		  else
		    {
		       ((bool_t) 1);
		    }
	       }
	       return res_895;
	    }
	 }
      }
   }
}


obj_t 
_globalize__140_integrate_node(obj_t env_2179, obj_t ast_2180, obj_t integrator_2181, obj_t what_by__117_2182)
{
   return globalize__167_integrate_node((node_t) (ast_2180), (variable_t) (integrator_2181), what_by__117_2182);
}


obj_t 
celled_bindings_3_integrate_node(obj_t formals_4)
{
   {
      obj_t celled_904;
      obj_t formals_905;
      celled_904 = BNIL;
      formals_905 = formals_4;
    loop_906:
      if (NULLP(formals_905))
	{
	   return celled_904;
	}
      else
	{
	   bool_t test1455_909;
	   {
	      local_t aux_2334;
	      {
		 obj_t aux_2335;
		 aux_2335 = CAR(formals_905);
		 aux_2334 = (local_t) (aux_2335);
	      }
	      test1455_909 = integrate_celled__59_integrate_node(aux_2334);
	   }
	   if (test1455_909)
	     {
		{
		   local_t var_910;
		   {
		      obj_t aux_2340;
		      {
			 local_t obj_1645;
			 {
			    obj_t aux_2341;
			    aux_2341 = CAR(formals_905);
			    obj_1645 = (local_t) (aux_2341);
			 }
			 aux_2340 = (((local_t) CREF(obj_1645))->id);
		      }
		      var_910 = make_local_svar_140_ast_local(aux_2340, (type_t) (__obj__252_type_cache));
		   }
		   {
		      obj_t o_n_168_911;
		      {
			 obj_t aux_2349;
			 obj_t aux_2347;
			 aux_2349 = (obj_t) (var_910);
			 aux_2347 = CAR(formals_905);
			 o_n_168_911 = MAKE_PAIR(aux_2347, aux_2349);
		      }
		      {
			 {
			    obj_t arg1457_912;
			    arg1457_912 = CNST_TABLE_REF(((long) 1));
			    {
			       obj_t res1865_1651;
			       {
				  obj_t x_2187;
				  x_2187 = ((((local_t) CREF(var_910))->access) = ((obj_t) arg1457_912), BUNSPEC);
				  res1865_1651 = BUNSPEC;
			       }
			       res1865_1651;
			    }
			 }
			 {
			    svar_iinfo_76_t obj1334_913;
			    obj1334_913 = ((svar_iinfo_76_t) ((((local_t) CREF(var_910))->value)));
			    {
			       svar_iinfo_76_t arg1458_914;
			       {
				  svar_iinfo_76_t res1866_1662;
				  {
				     svar_iinfo_76_t new1275_1657;
				     new1275_1657 = ((svar_iinfo_76_t) BREF(GC_MALLOC(sizeof(struct svar_iinfo_76))));
				     ((((svar_iinfo_76_t) CREF(new1275_1657))->f_mark_181) = ((obj_t) BUNSPEC), BUNSPEC);
				     ((((svar_iinfo_76_t) CREF(new1275_1657))->u_mark_209) = ((obj_t) BUNSPEC), BUNSPEC);
				     ((((svar_iinfo_76_t) CREF(new1275_1657))->kaptured__204) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				     ((((svar_iinfo_76_t) CREF(new1275_1657))->celled__113) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				     res1866_1662 = new1275_1657;
				  }
				  arg1458_914 = res1866_1662;
			       }
			       {
				  obj_t aux_2363;
				  object_t aux_2361;
				  aux_2363 = (obj_t) (arg1458_914);
				  aux_2361 = (object_t) (obj1334_913);
				  OBJECT_WIDENING_SET(aux_2361, aux_2363);
			       }
			    }
			    {
			       long arg1461_915;
			       arg1461_915 = class_num_218___object(svar_iinfo_76_integrate_info);
			       {
				  obj_t obj_1663;
				  obj_1663 = (obj_t) (obj1334_913);
				  (((obj_t) CREF(obj_1663))->header = MAKE_HEADER(arg1461_915, 0), BUNSPEC);
			       }
			    }
			    obj1334_913;
			 }
			 {
			    obj_t arg1463_916;
			    obj_t arg1465_917;
			    arg1463_916 = MAKE_PAIR(o_n_168_911, celled_904);
			    arg1465_917 = CDR(formals_905);
			    {
			       obj_t formals_2372;
			       obj_t celled_2371;
			       celled_2371 = arg1463_916;
			       formals_2372 = arg1465_917;
			       formals_905 = formals_2372;
			       celled_904 = celled_2371;
			       goto loop_906;
			    }
			 }
		      }
		   }
		}
	     }
	   else
	     {
		{
		   obj_t formals_2373;
		   formals_2373 = CDR(formals_905);
		   formals_905 = formals_2373;
		   goto loop_906;
		}
	     }
	}
   }
}


obj_t 
cell_formals_12_integrate_node(obj_t celled_5, node_t body_6)
{
   {
      bool_t test1472_923;
      test1472_923 = NULLP(celled_5);
      if (test1472_923)
	{
	   return (obj_t) (body_6);
	}
      else
	{
	   obj_t loc_924;
	   loc_924 = (((node_t) CREF(body_6))->loc);
	   {
	      obj_t arg1474_925;
	      if (test1472_923)
		{
		   arg1474_925 = BNIL;
		}
	      else
		{
		   obj_t head1337_928;
		   head1337_928 = MAKE_PAIR(BNIL, BNIL);
		   {
		      obj_t l1335_929;
		      obj_t tail1338_930;
		      l1335_929 = celled_5;
		      tail1338_930 = head1337_928;
		    lname1336_931:
		      if (NULLP(l1335_929))
			{
			   arg1474_925 = CDR(head1337_928);
			}
		      else
			{
			   obj_t new_tail1339_196_933;
			   {
			      obj_t arg1478_935;
			      {
				 obj_t o_n_168_937;
				 o_n_168_937 = CAR(l1335_929);
				 {
				    obj_t arg1481_938;
				    make_box_202_t arg1484_939;
				    arg1481_938 = CDR(o_n_168_937);
				    {
				       var_t arg1485_940;
				       obj_t arg1486_941;
				       {
					  var_t res1867_1689;
					  {
					     type_t type_1680;
					     variable_t variable_1681;
					     type_1680 = (type_t) (_____74_type_cache);
					     {
						obj_t aux_2387;
						aux_2387 = CAR(o_n_168_937);
						variable_1681 = (variable_t) (aux_2387);
					     }
					     {
						var_t new1132_1682;
						new1132_1682 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
						{
						   long arg1653_1683;
						   arg1653_1683 = class_num_218___object(var_ast_node);
						   {
						      obj_t obj_1687;
						      obj_1687 = (obj_t) (new1132_1682);
						      (((obj_t) CREF(obj_1687))->header = MAKE_HEADER(arg1653_1683, 0), BUNSPEC);
						   }
						}
						{
						   object_t aux_2394;
						   aux_2394 = (object_t) (new1132_1682);
						   OBJECT_WIDENING_SET(aux_2394, BFALSE);
						}
						((((var_t) CREF(new1132_1682))->loc) = ((obj_t) loc_924), BUNSPEC);
						((((var_t) CREF(new1132_1682))->type) = ((type_t) type_1680), BUNSPEC);
						((((var_t) CREF(new1132_1682))->variable) = ((variable_t) variable_1681), BUNSPEC);
						res1867_1689 = new1132_1682;
					     }
					  }
					  arg1485_940 = res1867_1689;
				       }
				       arg1486_941 = CAR(o_n_168_937);
				       arg1484_939 = a_make_cell_117_integrate_node((node_t) (arg1485_940), (variable_t) (arg1486_941));
				    }
				    {
				       obj_t aux_2404;
				       aux_2404 = (obj_t) (arg1484_939);
				       arg1478_935 = MAKE_PAIR(arg1481_938, aux_2404);
				    }
				 }
			      }
			      new_tail1339_196_933 = MAKE_PAIR(arg1478_935, BNIL);
			   }
			   SET_CDR(tail1338_930, new_tail1339_196_933);
			   {
			      obj_t tail1338_2411;
			      obj_t l1335_2409;
			      l1335_2409 = CDR(l1335_929);
			      tail1338_2411 = new_tail1339_196_933;
			      tail1338_930 = tail1338_2411;
			      l1335_929 = l1335_2409;
			      goto lname1336_931;
			   }
			}
		   }
		}
	      {
		 let_var_6_t res1868_1714;
		 {
		    type_t type_1699;
		    type_1699 = (type_t) (_____74_type_cache);
		    {
		       let_var_6_t new1231_1704;
		       new1231_1704 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
		       {
			  long arg1614_1705;
			  arg1614_1705 = class_num_218___object(let_var_6_ast_node);
			  {
			     obj_t obj_1712;
			     obj_1712 = (obj_t) (new1231_1704);
			     (((obj_t) CREF(obj_1712))->header = MAKE_HEADER(arg1614_1705, 0), BUNSPEC);
			  }
		       }
		       {
			  object_t aux_2417;
			  aux_2417 = (object_t) (new1231_1704);
			  OBJECT_WIDENING_SET(aux_2417, BFALSE);
		       }
		       ((((let_var_6_t) CREF(new1231_1704))->loc) = ((obj_t) loc_924), BUNSPEC);
		       ((((let_var_6_t) CREF(new1231_1704))->type) = ((type_t) type_1699), BUNSPEC);
		       ((((let_var_6_t) CREF(new1231_1704))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		       ((((let_var_6_t) CREF(new1231_1704))->bindings) = ((obj_t) arg1474_925), BUNSPEC);
		       ((((let_var_6_t) CREF(new1231_1704))->body) = ((node_t) body_6), BUNSPEC);
		       ((((let_var_6_t) CREF(new1231_1704))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		       res1868_1714 = new1231_1704;
		    }
		 }
		 return (obj_t) (res1868_1714);
	      }
	   }
	}
   }
}


make_box_202_t 
a_make_cell_117_integrate_node(node_t node_7, variable_t variable_8)
{
   {
      bool_t test1491_945;
      {
	 obj_t aux_2427;
	 aux_2427 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
	 test1491_945 = CBOOL(aux_2427);
      }
      if (test1491_945)
	{
	   obj_t arg1494_947;
	   obj_t arg1497_949;
	   arg1494_947 = shape_tools_shape((obj_t) (node_7));
	   arg1497_949 = shape_tools_shape((obj_t) (variable_8));
	   {
	      obj_t list1498_950;
	      {
		 obj_t arg1499_951;
		 {
		    obj_t arg1500_952;
		    {
		       obj_t arg1501_953;
		       {
			  obj_t arg1505_954;
			  {
			     obj_t aux_2437;
			     aux_2437 = BCHAR(((unsigned char) '\n'));
			     arg1505_954 = MAKE_PAIR(aux_2437, BNIL);
			  }
			  arg1501_953 = MAKE_PAIR(arg1497_949, arg1505_954);
		       }
		       arg1500_952 = MAKE_PAIR(string1912_integrate_node, arg1501_953);
		    }
		    arg1499_951 = MAKE_PAIR(arg1494_947, arg1500_952);
		 }
		 list1498_950 = MAKE_PAIR(string1914_integrate_node, arg1499_951);
	      }
	      print_trace_107_tools_trace(list1498_950);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t arg1510_959;
      arg1510_959 = CNST_TABLE_REF(((long) 1));
      {
	 obj_t res1869_1717;
	 {
	    local_t obj_1715;
	    obj_1715 = (local_t) (variable_8);
	    {
	       obj_t x_2188;
	       x_2188 = ((((local_t) CREF(obj_1715))->access) = ((obj_t) arg1510_959), BUNSPEC);
	       res1869_1717 = BUNSPEC;
	    }
	 }
	 res1869_1717;
      }
   }
   {
      obj_t res1870_1721;
      {
	 svar_iinfo_76_t obj_1719;
	 {
	    value_t aux_2448;
	    aux_2448 = (((variable_t) CREF(variable_8))->value);
	    obj_1719 = (svar_iinfo_76_t) (aux_2448);
	 }
	 {
	    obj_t x_2189;
	    {
	       obj_t aux_2451;
	       {
		  object_t aux_2452;
		  aux_2452 = (object_t) (obj_1719);
		  aux_2451 = OBJECT_WIDENING(aux_2452);
	       }
	       x_2189 = ((((svar_iinfo_76_t) CREF(aux_2451))->celled__113) = ((bool_t) ((bool_t) 1)), BUNSPEC);
	    }
	    res1870_1721 = BUNSPEC;
	 }
      }
      res1870_1721;
   }
   {
      obj_t arg1513_961;
      arg1513_961 = (((node_t) CREF(node_7))->loc);
      {
	 make_box_202_t res1871_1735;
	 {
	    type_t type_1724;
	    type_1724 = (type_t) (_____74_type_cache);
	    {
	       make_box_202_t new1254_1727;
	       new1254_1727 = ((make_box_202_t) BREF(GC_MALLOC(sizeof(struct make_box_202))));
	       {
		  long arg1604_1728;
		  arg1604_1728 = class_num_218___object(make_box_202_ast_node);
		  {
		     obj_t obj_1733;
		     obj_1733 = (obj_t) (new1254_1727);
		     (((obj_t) CREF(obj_1733))->header = MAKE_HEADER(arg1604_1728, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_2462;
		  aux_2462 = (object_t) (new1254_1727);
		  OBJECT_WIDENING_SET(aux_2462, BFALSE);
	       }
	       ((((make_box_202_t) CREF(new1254_1727))->loc) = ((obj_t) arg1513_961), BUNSPEC);
	       ((((make_box_202_t) CREF(new1254_1727))->type) = ((type_t) type_1724), BUNSPEC);
	       ((((make_box_202_t) CREF(new1254_1727))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
	       ((((make_box_202_t) CREF(new1254_1727))->value) = ((node_t) node_7), BUNSPEC);
	       res1871_1735 = new1254_1727;
	    }
	 }
	 return res1871_1735;
      }
   }
}


bool_t 
integrate_celled__59_integrate_node(local_t variable_9)
{
   {
      bool_t test1514_962;
      {
	 obj_t aux_2469;
	 aux_2469 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
	 test1514_962 = CBOOL(aux_2469);
      }
      if (test1514_962)
	{
	   obj_t arg1518_964;
	   bool_t arg1522_966;
	   obj_t arg1524_968;
	   obj_t arg1529_970;
	   obj_t arg1532_972;
	   arg1518_964 = shape_tools_shape((obj_t) (variable_9));
	   {
	      obj_t aux_2477;
	      {
		 value_t aux_2478;
		 {
		    variable_t obj_1736;
		    obj_1736 = (variable_t) (variable_9);
		    aux_2478 = (((variable_t) CREF(obj_1736))->value);
		 }
		 aux_2477 = (obj_t) (aux_2478);
	      }
	      arg1522_966 = is_a__118___object(aux_2477, svar_iinfo_76_integrate_info);
	   }
	   {
	      bool_t test1550_986;
	      {
		 obj_t aux_2483;
		 {
		    value_t aux_2484;
		    {
		       variable_t obj_1738;
		       obj_1738 = (variable_t) (variable_9);
		       aux_2484 = (((variable_t) CREF(obj_1738))->value);
		    }
		    aux_2483 = (obj_t) (aux_2484);
		 }
		 test1550_986 = is_a__118___object(aux_2483, svar_iinfo_76_integrate_info);
	      }
	      if (test1550_986)
		{
		   svar_iinfo_76_t obj_1741;
		   {
		      value_t aux_2490;
		      {
			 variable_t obj_1740;
			 obj_1740 = (variable_t) (variable_9);
			 aux_2490 = (((variable_t) CREF(obj_1740))->value);
		      }
		      obj_1741 = (svar_iinfo_76_t) (aux_2490);
		   }
		   {
		      bool_t aux_2494;
		      {
			 obj_t aux_2495;
			 {
			    object_t aux_2496;
			    aux_2496 = (object_t) (obj_1741);
			    aux_2495 = OBJECT_WIDENING(aux_2496);
			 }
			 aux_2494 = (((svar_iinfo_76_t) CREF(aux_2495))->celled__113);
		      }
		      arg1524_968 = BBOOL(aux_2494);
		   }
		}
	      else
		{
		   arg1524_968 = string1915_integrate_node;
		}
	   }
	   {
	      variable_t obj_1742;
	      obj_1742 = (variable_t) (variable_9);
	      arg1529_970 = (((variable_t) CREF(obj_1742))->access);
	   }
	   {
	      bool_t test1553_989;
	      {
		 obj_t aux_2503;
		 {
		    value_t aux_2504;
		    {
		       variable_t obj_1743;
		       obj_1743 = (variable_t) (variable_9);
		       aux_2504 = (((variable_t) CREF(obj_1743))->value);
		    }
		    aux_2503 = (obj_t) (aux_2504);
		 }
		 test1553_989 = is_a__118___object(aux_2503, svar_iinfo_76_integrate_info);
	      }
	      if (test1553_989)
		{
		   svar_iinfo_76_t obj_1746;
		   {
		      value_t aux_2510;
		      {
			 variable_t obj_1745;
			 obj_1745 = (variable_t) (variable_9);
			 aux_2510 = (((variable_t) CREF(obj_1745))->value);
		      }
		      obj_1746 = (svar_iinfo_76_t) (aux_2510);
		   }
		   {
		      bool_t aux_2514;
		      {
			 obj_t aux_2515;
			 {
			    object_t aux_2516;
			    aux_2516 = (object_t) (obj_1746);
			    aux_2515 = OBJECT_WIDENING(aux_2516);
			 }
			 aux_2514 = (((svar_iinfo_76_t) CREF(aux_2515))->kaptured__204);
		      }
		      arg1532_972 = BBOOL(aux_2514);
		   }
		}
	      else
		{
		   arg1532_972 = string1916_integrate_node;
		}
	   }
	   {
	      obj_t list1533_973;
	      {
		 obj_t arg1534_974;
		 {
		    obj_t arg1535_975;
		    {
		       obj_t arg1536_976;
		       {
			  obj_t arg1537_977;
			  {
			     obj_t arg1538_978;
			     {
				obj_t arg1539_979;
				{
				   obj_t arg1540_980;
				   {
				      obj_t arg1541_981;
				      {
					 obj_t arg1542_982;
					 {
					    obj_t arg1543_983;
					    {
					       obj_t aux_2521;
					       aux_2521 = BCHAR(((unsigned char) '\n'));
					       arg1543_983 = MAKE_PAIR(aux_2521, BNIL);
					    }
					    arg1542_982 = MAKE_PAIR(arg1532_972, arg1543_983);
					 }
					 arg1541_981 = MAKE_PAIR(string1917_integrate_node, arg1542_982);
				      }
				      arg1540_980 = MAKE_PAIR(arg1529_970, arg1541_981);
				   }
				   arg1539_979 = MAKE_PAIR(string1912_integrate_node, arg1540_980);
				}
				arg1538_978 = MAKE_PAIR(arg1524_968, arg1539_979);
			     }
			     arg1537_977 = MAKE_PAIR(string1918_integrate_node, arg1538_978);
			  }
			  {
			     obj_t aux_2530;
			     aux_2530 = BBOOL(arg1522_966);
			     arg1536_976 = MAKE_PAIR(aux_2530, arg1537_977);
			  }
		       }
		       arg1535_975 = MAKE_PAIR(string1919_integrate_node, arg1536_976);
		    }
		    arg1534_974 = MAKE_PAIR(arg1518_964, arg1535_975);
		 }
		 list1533_973 = MAKE_PAIR(string1920_integrate_node, arg1534_974);
	      }
	      print_trace_107_tools_trace(list1533_973);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t _andtest_1341_994;
      {
	 obj_t aux_2537;
	 {
	    value_t aux_2538;
	    {
	       variable_t obj_1747;
	       obj_1747 = (variable_t) (variable_9);
	       aux_2538 = (((variable_t) CREF(obj_1747))->value);
	    }
	    aux_2537 = (obj_t) (aux_2538);
	 }
	 _andtest_1341_994 = is_a__118___object(aux_2537, svar_iinfo_76_integrate_info);
      }
      if (_andtest_1341_994)
	{
	   bool_t _ortest_1342_995;
	   {
	      svar_iinfo_76_t obj_1750;
	      {
		 value_t aux_2544;
		 {
		    variable_t obj_1749;
		    obj_1749 = (variable_t) (variable_9);
		    aux_2544 = (((variable_t) CREF(obj_1749))->value);
		 }
		 obj_1750 = (svar_iinfo_76_t) (aux_2544);
	      }
	      {
		 obj_t aux_2548;
		 {
		    object_t aux_2549;
		    aux_2549 = (object_t) (obj_1750);
		    aux_2548 = OBJECT_WIDENING(aux_2549);
		 }
		 _ortest_1342_995 = (((svar_iinfo_76_t) CREF(aux_2548))->celled__113);
	      }
	   }
	   if (_ortest_1342_995)
	     {
		return _ortest_1342_995;
	     }
	   else
	     {
		bool_t test_2554;
		{
		   obj_t aux_2555;
		   {
		      obj_t aux_2556;
		      {
			 variable_t obj_1751;
			 obj_1751 = (variable_t) (variable_9);
			 aux_2556 = (((variable_t) CREF(obj_1751))->access);
		      }
		      aux_2555 = memq___r4_pairs_and_lists_6_3(aux_2556, CNST_TABLE_REF(((long) 2)));
		   }
		   test_2554 = CBOOL(aux_2555);
		}
		if (test_2554)
		  {
		     svar_iinfo_76_t obj_1753;
		     {
			value_t aux_2562;
			{
			   variable_t obj_1752;
			   obj_1752 = (variable_t) (variable_9);
			   aux_2562 = (((variable_t) CREF(obj_1752))->value);
			}
			obj_1753 = (svar_iinfo_76_t) (aux_2562);
		     }
		     {
			obj_t aux_2566;
			{
			   object_t aux_2567;
			   aux_2567 = (object_t) (obj_1753);
			   aux_2566 = OBJECT_WIDENING(aux_2567);
			}
			return (((svar_iinfo_76_t) CREF(aux_2566))->kaptured__204);
		     }
		  }
		else
		  {
		     return ((bool_t) 0);
		  }
	     }
	}
      else
	{
	   return ((bool_t) 0);
	}
   }
}


obj_t 
_integrate_celled__234_integrate_node(obj_t env_2183, obj_t variable_2184)
{
   {
      bool_t aux_2571;
      aux_2571 = integrate_celled__59_integrate_node((local_t) (variable_2184));
      return BBOOL(aux_2571);
   }
}


node_t 
glo__default1374_202_integrate_node(node_t node_12, variable_t integrator_13)
{
   FAILURE(CNST_TABLE_REF(((long) 3)), string1921_integrate_node, (obj_t) (node_12));
}


obj_t 
_glo__default1374_50_integrate_node(obj_t env_2176, obj_t node_2177, obj_t integrator_2178)
{
   {
      node_t aux_2578;
      aux_2578 = glo__default1374_202_integrate_node((node_t) (node_2177), (variable_t) (integrator_2178));
      return (obj_t) (aux_2578);
   }
}


node_t 
glo__115_integrate_node(node_t node_10, variable_t integrator_11)
{
   {
      obj_t method1695_1391;
      obj_t class1700_1392;
      {
	 obj_t arg1703_1389;
	 obj_t arg1704_1390;
	 {
	    object_t obj_1759;
	    obj_1759 = (object_t) (node_10);
	    {
	       obj_t pre_method_105_1760;
	       pre_method_105_1760 = PROCEDURE_REF(glo__env_172_integrate_node, ((long) 2));
	       if (INTEGERP(pre_method_105_1760))
		 {
		    PROCEDURE_SET(glo__env_172_integrate_node, ((long) 2), BUNSPEC);
		    arg1703_1389 = pre_method_105_1760;
		 }
	       else
		 {
		    long obj_class_num_177_1765;
		    obj_class_num_177_1765 = TYPE(obj_1759);
		    {
		       obj_t arg1183_1766;
		       arg1183_1766 = PROCEDURE_REF(glo__env_172_integrate_node, ((long) 1));
		       {
			  long arg1184_1770;
			  {
			     long arg1186_1771;
			     arg1186_1771 = OBJECT_TYPE;
			     arg1184_1770 = (obj_class_num_177_1765 - arg1186_1771);
			  }
			  arg1703_1389 = VECTOR_REF(arg1183_1766, arg1184_1770);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1776;
	    object_1776 = (object_t) (node_10);
	    {
	       long arg1187_1777;
	       {
		  long arg1188_1778;
		  long arg1189_1779;
		  arg1188_1778 = TYPE(object_1776);
		  arg1189_1779 = OBJECT_TYPE;
		  arg1187_1777 = (arg1188_1778 - arg1189_1779);
	       }
	       {
		  obj_t vector_1783;
		  vector_1783 = __classes__134___object;
		  arg1704_1390 = VECTOR_REF(vector_1783, arg1187_1777);
	       }
	    }
	 }
	 {
	    obj_t aux_2598;
	    method1695_1391 = arg1703_1389;
	    class1700_1392 = arg1704_1390;
	    {
	       if (INTEGERP(method1695_1391))
		 {
		    switch ((long) CINT(method1695_1391))
		      {
		      case ((long) 0):
			 {
			    atom_t aux_2601;
			    aux_2601 = (atom_t) (node_10);
			    aux_2598 = (obj_t) (aux_2601);
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t aux_2604;
			    aux_2604 = (kwote_t) (node_10);
			    aux_2598 = (obj_t) (aux_2604);
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t node_1402;
			    node_1402 = (var_t) (node_10);
			    {
			       variable_t var_1404;
			       var_1404 = (((var_t) CREF(node_1402))->variable);
			       {
				  obj_t alpha_1405;
				  alpha_1405 = (((variable_t) CREF(var_1404))->fast_alpha_7);
				  {
				     {
					bool_t test1707_1406;
					test1707_1406 = is_a__118___object(alpha_1405, local_ast_var);
					if (test1707_1406)
					  {
					     {
						obj_t res1872_1790;
						{
						   variable_t val1135_1789;
						   val1135_1789 = (variable_t) (alpha_1405);
						   {
						      obj_t x_2190;
						      x_2190 = ((((var_t) CREF(node_1402))->variable) = ((variable_t) val1135_1789), BUNSPEC);
						      res1872_1790 = BUNSPEC;
						   }
						}
						res1872_1790;
					     }
					     {
						node_t aux_2614;
						aux_2614 = glo__115_integrate_node((node_t) (node_1402), integrator_11);
						aux_2598 = (obj_t) (aux_2614);
					     }
					  }
					else
					  {
					     bool_t test1708_1407;
					     test1708_1407 = is_a__118___object((obj_t) (var_1404), global_ast_var);
					     if (test1708_1407)
					       {
						  aux_2598 = (obj_t) (node_1402);
					       }
					     else
					       {
						  bool_t test1709_1408;
						  test1709_1408 = integrate_celled__59_integrate_node((local_t) (var_1404));
						  if (test1709_1408)
						    {
						       {
							  obj_t arg1710_1409;
							  arg1710_1409 = CNST_TABLE_REF(((long) 1));
							  {
							     obj_t res1873_1794;
							     {
								local_t obj_1792;
								obj_1792 = (local_t) (var_1404);
								{
								   obj_t x_2191;
								   x_2191 = ((((local_t) CREF(obj_1792))->access) = ((obj_t) arg1710_1409), BUNSPEC);
								   res1873_1794 = BUNSPEC;
								}
							     }
							     res1873_1794;
							  }
						       }
						       {
							  obj_t arg1711_1410;
							  type_t arg1712_1411;
							  {
							     node_t obj_1795;
							     obj_1795 = (node_t) (node_1402);
							     arg1711_1410 = (((node_t) CREF(obj_1795))->loc);
							  }
							  {
							     node_t obj_1796;
							     obj_1796 = (node_t) (node_1402);
							     arg1712_1411 = (((node_t) CREF(obj_1796))->type);
							  }
							  {
							     box_ref_242_t res1874_1809;
							     {
								box_ref_242_t new1261_1801;
								new1261_1801 = ((box_ref_242_t) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
								{
								   long arg1601_1802;
								   arg1601_1802 = class_num_218___object(box_ref_242_ast_node);
								   {
								      obj_t obj_1807;
								      obj_1807 = (obj_t) (new1261_1801);
								      (((obj_t) CREF(obj_1807))->header = MAKE_HEADER(arg1601_1802, 0), BUNSPEC);
								   }
								}
								{
								   object_t aux_2636;
								   aux_2636 = (object_t) (new1261_1801);
								   OBJECT_WIDENING_SET(aux_2636, BFALSE);
								}
								((((box_ref_242_t) CREF(new1261_1801))->loc) = ((obj_t) arg1711_1410), BUNSPEC);
								((((box_ref_242_t) CREF(new1261_1801))->type) = ((type_t) arg1712_1411), BUNSPEC);
								((((box_ref_242_t) CREF(new1261_1801))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
								((((box_ref_242_t) CREF(new1261_1801))->var) = ((var_t) node_1402), BUNSPEC);
								res1874_1809 = new1261_1801;
							     }
							     aux_2598 = (obj_t) (res1874_1809);
							  }
						       }
						    }
						  else
						    {
						       aux_2598 = (obj_t) (node_1402);
						    }
					       }
					  }
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 3):
			 {
			    obj_t arg1716_1416;
			    {
			       obj_t aux_2645;
			       {
				  closure_t aux_2646;
				  aux_2646 = (closure_t) (node_10);
				  aux_2645 = (obj_t) (aux_2646);
			       }
			       arg1716_1416 = shape_tools_shape(aux_2645);
			    }
			    aux_2598 = internal_error_43_tools_error(string1922_integrate_node, string1923_integrate_node, arg1716_1416);
			 }
			 break;
		      case ((long) 4):
			 {
			    sequence_t node_1417;
			    node_1417 = (sequence_t) (node_10);
			    glo___241_integrate_node((((sequence_t) CREF(node_1417))->nodes), integrator_11);
			    aux_2598 = (obj_t) (node_1417);
			 }
			 break;
		      case ((long) 5):
			 {
			    app_t node_1421;
			    node_1421 = (app_t) (node_10);
			    {
			       variable_t fun_1424;
			       {
				  var_t arg1745_1456;
				  arg1745_1456 = (((app_t) CREF(node_1421))->fun);
				  fun_1424 = (((var_t) CREF(arg1745_1456))->variable);
			       }
			       {
				  value_t info_1425;
				  info_1425 = (((variable_t) CREF(fun_1424))->value);
				  {
				     {
					bool_t test1718_1426;
					{
					   bool_t test1723_1431;
					   test1723_1431 = is_a__118___object((obj_t) (fun_1424), local_ast_var);
					   if (test1723_1431)
					     {
						sfun_iinfo_105_t obj_1815;
						obj_1815 = (sfun_iinfo_105_t) (info_1425);
						{
						   obj_t aux_2663;
						   {
						      object_t aux_2664;
						      aux_2664 = (object_t) (obj_1815);
						      aux_2663 = OBJECT_WIDENING(aux_2664);
						   }
						   test1718_1426 = (((sfun_iinfo_105_t) CREF(aux_2663))->g__219);
						}
					     }
					   else
					     {
						test1718_1426 = ((bool_t) 0);
					     }
					}
					if (test1718_1426)
					  {
					     var_t arg1719_1427;
					     {
						obj_t arg1720_1428;
						type_t arg1721_1429;
						obj_t arg1722_1430;
						arg1720_1428 = (((app_t) CREF(node_1421))->loc);
						arg1721_1429 = (((app_t) CREF(node_1421))->type);
						arg1722_1430 = the_global_201_integrate_local__global_163((local_t) (fun_1424));
						{
						   var_t res1875_1828;
						   {
						      variable_t variable_1820;
						      variable_1820 = (variable_t) (arg1722_1430);
						      {
							 var_t new1132_1821;
							 new1132_1821 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
							 {
							    long arg1653_1822;
							    arg1653_1822 = class_num_218___object(var_ast_node);
							    {
							       obj_t obj_1826;
							       obj_1826 = (obj_t) (new1132_1821);
							       (((obj_t) CREF(obj_1826))->header = MAKE_HEADER(arg1653_1822, 0), BUNSPEC);
							    }
							 }
							 {
							    object_t aux_2678;
							    aux_2678 = (object_t) (new1132_1821);
							    OBJECT_WIDENING_SET(aux_2678, BFALSE);
							 }
							 ((((var_t) CREF(new1132_1821))->loc) = ((obj_t) arg1720_1428), BUNSPEC);
							 ((((var_t) CREF(new1132_1821))->type) = ((type_t) arg1721_1429), BUNSPEC);
							 ((((var_t) CREF(new1132_1821))->variable) = ((variable_t) variable_1820), BUNSPEC);
							 res1875_1828 = new1132_1821;
						      }
						   }
						   arg1719_1427 = res1875_1828;
						}
					     }
					     {
						obj_t res1876_1831;
						{
						   obj_t x_2192;
						   x_2192 = ((((app_t) CREF(node_1421))->fun) = ((var_t) arg1719_1427), BUNSPEC);
						   res1876_1831 = BUNSPEC;
						}
						res1876_1831;
					     }
					  }
					else
					  {
					     BUNSPEC;
					  }
				     }
				     {
					obj_t nodes_1432;
					nodes_1432 = (((app_t) CREF(node_1421))->args);
				      liip_1433:
					if (NULLP(nodes_1432))
					  {
					     CNST_TABLE_REF(((long) 4));
					  }
					else
					  {
					     {
						node_t arg1730_1436;
						{
						   node_t aux_2688;
						   {
						      obj_t aux_2689;
						      aux_2689 = CAR(nodes_1432);
						      aux_2688 = (node_t) (aux_2689);
						   }
						   arg1730_1436 = glo__115_integrate_node(aux_2688, integrator_11);
						}
						{
						   obj_t aux_2693;
						   aux_2693 = (obj_t) (arg1730_1436);
						   SET_CAR(nodes_1432, aux_2693);
						}
					     }
					     {
						obj_t nodes_2696;
						nodes_2696 = CDR(nodes_1432);
						nodes_1432 = nodes_2696;
						goto liip_1433;
					     }
					  }
				     }
				     {
					bool_t test1733_1439;
					{
					   bool_t test1743_1454;
					   test1743_1454 = is_a__118___object((obj_t) (fun_1424), global_ast_var);
					   if (test1743_1454)
					     {
						test1733_1439 = ((bool_t) 1);
					     }
					   else
					     {
						bool_t test_2702;
						{
						   sfun_iinfo_105_t obj_1839;
						   obj_1839 = (sfun_iinfo_105_t) (info_1425);
						   {
						      obj_t aux_2704;
						      {
							 object_t aux_2705;
							 aux_2705 = (object_t) (obj_1839);
							 aux_2704 = OBJECT_WIDENING(aux_2705);
						      }
						      test_2702 = (((sfun_iinfo_105_t) CREF(aux_2704))->g__219);
						   }
						}
						if (test_2702)
						  {
						     test1733_1439 = ((bool_t) 0);
						  }
						else
						  {
						     test1733_1439 = ((bool_t) 1);
						  }
					     }
					}
					if (test1733_1439)
					  {
					     CNST_TABLE_REF(((long) 4));
					  }
					else
					  {
					     {
						obj_t new_actuals_73_1440;
						obj_t kaptured_1441;
						new_actuals_73_1440 = (((app_t) CREF(node_1421))->args);
						{
						   sfun_iinfo_105_t obj_1841;
						   obj_1841 = (sfun_iinfo_105_t) (info_1425);
						   {
						      obj_t aux_2740;
						      {
							 object_t aux_2741;
							 aux_2741 = (object_t) (obj_1841);
							 aux_2740 = OBJECT_WIDENING(aux_2741);
						      }
						      kaptured_1441 = (((sfun_iinfo_105_t) CREF(aux_2740))->kaptured);
						   }
						}
					      loop_1442:
						if (NULLP(kaptured_1441))
						  {
						     obj_t res1877_1845;
						     {
							obj_t x_2193;
							x_2193 = ((((app_t) CREF(node_1421))->args) = ((obj_t) new_actuals_73_1440), BUNSPEC);
							res1877_1845 = BUNSPEC;
						     }
						     res1877_1845;
						  }
						else
						  {
						     obj_t kap_1446;
						     kap_1446 = CAR(kaptured_1441);
						     {
							obj_t alpha_1447;
							{
							   local_t obj_1847;
							   obj_1847 = (local_t) (kap_1446);
							   alpha_1447 = (((local_t) CREF(obj_1847))->fast_alpha_7);
							}
							{
							   obj_t var_1448;
							   {
							      bool_t test1742_1453;
							      test1742_1453 = is_a__118___object(alpha_1447, local_ast_var);
							      if (test1742_1453)
								{
								   var_1448 = alpha_1447;
								}
							      else
								{
								   var_1448 = kap_1446;
								}
							   }
							   {
							      {
								 obj_t arg1737_1449;
								 obj_t arg1738_1450;
								 {
								    var_t arg1740_1451;
								    {
								       obj_t arg1741_1452;
								       arg1741_1452 = (((app_t) CREF(node_1421))->loc);
								       {
									  var_t res1878_1860;
									  {
									     type_t type_1851;
									     variable_t variable_1852;
									     type_1851 = (type_t) (_____74_type_cache);
									     variable_1852 = (variable_t) (var_1448);
									     {
										var_t new1132_1853;
										new1132_1853 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
										{
										   long arg1653_1854;
										   arg1653_1854 = class_num_218___object(var_ast_node);
										   {
										      obj_t obj_1858;
										      obj_1858 = (obj_t) (new1132_1853);
										      (((obj_t) CREF(obj_1858))->header = MAKE_HEADER(arg1653_1854, 0), BUNSPEC);
										   }
										}
										{
										   object_t aux_2726;
										   aux_2726 = (object_t) (new1132_1853);
										   OBJECT_WIDENING_SET(aux_2726, BFALSE);
										}
										((((var_t) CREF(new1132_1853))->loc) = ((obj_t) arg1741_1452), BUNSPEC);
										((((var_t) CREF(new1132_1853))->type) = ((type_t) type_1851), BUNSPEC);
										((((var_t) CREF(new1132_1853))->variable) = ((variable_t) variable_1852), BUNSPEC);
										res1878_1860 = new1132_1853;
									     }
									  }
									  arg1740_1451 = res1878_1860;
								       }
								    }
								    {
								       obj_t aux_2732;
								       aux_2732 = (obj_t) (arg1740_1451);
								       arg1737_1449 = MAKE_PAIR(aux_2732, new_actuals_73_1440);
								    }
								 }
								 arg1738_1450 = CDR(kaptured_1441);
								 {
								    obj_t kaptured_2737;
								    obj_t new_actuals_73_2736;
								    new_actuals_73_2736 = arg1737_1449;
								    kaptured_2737 = arg1738_1450;
								    kaptured_1441 = kaptured_2737;
								    new_actuals_73_1440 = new_actuals_73_2736;
								    goto loop_1442;
								 }
							      }
							   }
							}
						     }
						  }
					     }
					  }
				     }
				     aux_2598 = (obj_t) (node_1421);
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 6):
			 {
			    app_ly_162_t node_1457;
			    node_1457 = (app_ly_162_t) (node_10);
			    {
			       node_t arg1746_1460;
			       arg1746_1460 = glo__115_integrate_node((((app_ly_162_t) CREF(node_1457))->fun), integrator_11);
			       {
				  obj_t res1879_1867;
				  {
				     obj_t x_2194;
				     x_2194 = ((((app_ly_162_t) CREF(node_1457))->fun) = ((node_t) arg1746_1460), BUNSPEC);
				     res1879_1867 = BUNSPEC;
				  }
				  res1879_1867;
			       }
			    }
			    {
			       node_t arg1748_1462;
			       arg1748_1462 = glo__115_integrate_node((((app_ly_162_t) CREF(node_1457))->arg), integrator_11);
			       {
				  obj_t res1880_1871;
				  {
				     obj_t x_2195;
				     x_2195 = ((((app_ly_162_t) CREF(node_1457))->arg) = ((node_t) arg1748_1462), BUNSPEC);
				     res1880_1871 = BUNSPEC;
				  }
				  res1880_1871;
			       }
			    }
			    aux_2598 = (obj_t) (node_1457);
			 }
			 break;
		      case ((long) 7):
			 {
			    funcall_t node_1464;
			    node_1464 = (funcall_t) (node_10);
			    {
			       node_t arg1751_1467;
			       arg1751_1467 = glo__115_integrate_node((((funcall_t) CREF(node_1464))->fun), integrator_11);
			       {
				  obj_t res1881_1875;
				  {
				     obj_t x_2196;
				     x_2196 = ((((funcall_t) CREF(node_1464))->fun) = ((node_t) arg1751_1467), BUNSPEC);
				     res1881_1875 = BUNSPEC;
				  }
				  res1881_1875;
			       }
			    }
			    glo___241_integrate_node((((funcall_t) CREF(node_1464))->args), integrator_11);
			    aux_2598 = (obj_t) (node_1464);
			 }
			 break;
		      case ((long) 8):
			 {
			    pragma_t node_1470;
			    node_1470 = (pragma_t) (node_10);
			    glo___241_integrate_node((((pragma_t) CREF(node_1470))->args), integrator_11);
			    aux_2598 = (obj_t) (node_1470);
			 }
			 break;
		      case ((long) 9):
			 {
			    cast_t node_1474;
			    node_1474 = (cast_t) (node_10);
			    glo__115_integrate_node((((cast_t) CREF(node_1474))->arg), integrator_11);
			    aux_2598 = (obj_t) (node_1474);
			 }
			 break;
		      case ((long) 10):
			 {
			    setq_t node_1478;
			    node_1478 = (setq_t) (node_10);
			    {
			       node_t arg1758_1481;
			       arg1758_1481 = glo__115_integrate_node((((setq_t) CREF(node_1478))->value), integrator_11);
			       {
				  obj_t res1882_1882;
				  {
				     obj_t x_2197;
				     x_2197 = ((((setq_t) CREF(node_1478))->value) = ((node_t) arg1758_1481), BUNSPEC);
				     res1882_1882 = BUNSPEC;
				  }
				  res1882_1882;
			       }
			    }
			    {
			       variable_t var_1483;
			       {
				  var_t arg1781_1510;
				  arg1781_1510 = (((setq_t) CREF(node_1478))->var);
				  var_1483 = (((var_t) CREF(arg1781_1510))->variable);
			       }
			       {
				  obj_t var_1484;
				  obj_t alpha_1485;
				  var_1484 = (obj_t) (var_1483);
				  alpha_1485 = (((variable_t) CREF(var_1483))->fast_alpha_7);
				loop_1486:
				  {
				     bool_t test1762_1488;
				     test1762_1488 = is_a__118___object(alpha_1485, local_ast_var);
				     if (test1762_1488)
				       {
					  {
					     var_t arg1763_1489;
					     arg1763_1489 = (((setq_t) CREF(node_1478))->var);
					     {
						obj_t res1883_1890;
						{
						   variable_t val1135_1889;
						   val1135_1889 = (variable_t) (alpha_1485);
						   {
						      obj_t x_2198;
						      x_2198 = ((((var_t) CREF(arg1763_1489))->variable) = ((variable_t) val1135_1889), BUNSPEC);
						      res1883_1890 = BUNSPEC;
						   }
						}
						res1883_1890;
					     }
					  }
					  {
					     obj_t alpha_2781;
					     obj_t var_2780;
					     var_2780 = alpha_1485;
					     {
						variable_t obj_1891;
						obj_1891 = (variable_t) (alpha_1485);
						alpha_2781 = (((variable_t) CREF(obj_1891))->fast_alpha_7);
					     }
					     alpha_1485 = alpha_2781;
					     var_1484 = var_2780;
					     goto loop_1486;
					  }
				       }
				     else
				       {
					  variable_t var_1491;
					  {
					     var_t arg1780_1509;
					     arg1780_1509 = (((setq_t) CREF(node_1478))->var);
					     var_1491 = (((var_t) CREF(arg1780_1509))->variable);
					  }
					  {
					     bool_t test1765_1492;
					     {
						bool_t test1779_1508;
						test1779_1508 = is_a__118___object((obj_t) (var_1491), local_ast_var);
						if (test1779_1508)
						  {
						     test1765_1492 = integrate_celled__59_integrate_node((local_t) (var_1491));
						  }
						else
						  {
						     test1765_1492 = ((bool_t) 0);
						  }
					     }
					     if (test1765_1492)
					       {
						  local_t a_var_30_1493;
						  obj_t loc_1494;
						  a_var_30_1493 = make_local_svar_140_ast_local(CNST_TABLE_REF(((long) 5)), (type_t) (__obj__252_type_cache));
						  {
						     node_t obj_1895;
						     obj_1895 = (node_t) (node_1478);
						     loc_1494 = (((node_t) CREF(obj_1895))->loc);
						  }
						  {
						     obj_t arg1766_1495;
						     arg1766_1495 = CNST_TABLE_REF(((long) 1));
						     {
							obj_t res1884_1898;
							{
							   local_t obj_1896;
							   obj_1896 = (local_t) (var_1491);
							   {
							      obj_t x_2199;
							      x_2199 = ((((local_t) CREF(obj_1896))->access) = ((obj_t) arg1766_1495), BUNSPEC);
							      res1884_1898 = BUNSPEC;
							   }
							}
							res1884_1898;
						     }
						  }
						  {
						     svar_iinfo_76_t obj1351_1496;
						     obj1351_1496 = ((svar_iinfo_76_t) ((((local_t) CREF(a_var_30_1493))->value)));
						     {
							svar_iinfo_76_t arg1767_1497;
							{
							   svar_iinfo_76_t res1885_1909;
							   {
							      svar_iinfo_76_t new1275_1904;
							      new1275_1904 = ((svar_iinfo_76_t) BREF(GC_MALLOC(sizeof(struct svar_iinfo_76))));
							      ((((svar_iinfo_76_t) CREF(new1275_1904))->f_mark_181) = ((obj_t) BUNSPEC), BUNSPEC);
							      ((((svar_iinfo_76_t) CREF(new1275_1904))->u_mark_209) = ((obj_t) BUNSPEC), BUNSPEC);
							      ((((svar_iinfo_76_t) CREF(new1275_1904))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							      ((((svar_iinfo_76_t) CREF(new1275_1904))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							      res1885_1909 = new1275_1904;
							   }
							   arg1767_1497 = res1885_1909;
							}
							{
							   obj_t aux_2809;
							   object_t aux_2807;
							   aux_2809 = (obj_t) (arg1767_1497);
							   aux_2807 = (object_t) (obj1351_1496);
							   OBJECT_WIDENING_SET(aux_2807, aux_2809);
							}
						     }
						     {
							long arg1769_1498;
							arg1769_1498 = class_num_218___object(svar_iinfo_76_integrate_info);
							{
							   obj_t obj_1910;
							   obj_1910 = (obj_t) (obj1351_1496);
							   (((obj_t) CREF(obj_1910))->header = MAKE_HEADER(arg1769_1498, 0), BUNSPEC);
							}
						     }
						     obj1351_1496;
						  }
						  {
						     obj_t arg1770_1499;
						     box_set__221_t arg1771_1500;
						     {
							obj_t arg1772_1501;
							{
							   obj_t aux_2817;
							   obj_t aux_2815;
							   {
							      node_t aux_2818;
							      aux_2818 = (((setq_t) CREF(node_1478))->value);
							      aux_2817 = (obj_t) (aux_2818);
							   }
							   aux_2815 = (obj_t) (a_var_30_1493);
							   arg1772_1501 = MAKE_PAIR(aux_2815, aux_2817);
							}
							{
							   obj_t list1773_1502;
							   list1773_1502 = MAKE_PAIR(arg1772_1501, BNIL);
							   arg1770_1499 = list1773_1502;
							}
						     }
						     {
							var_t arg1776_1505;
							var_t arg1777_1506;
							arg1776_1505 = (((setq_t) CREF(node_1478))->var);
							{
							   var_t res1886_1927;
							   {
							      type_t type_1918;
							      variable_t variable_1919;
							      type_1918 = (type_t) (_____74_type_cache);
							      variable_1919 = (variable_t) (a_var_30_1493);
							      {
								 var_t new1132_1920;
								 new1132_1920 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
								 {
								    long arg1653_1921;
								    arg1653_1921 = class_num_218___object(var_ast_node);
								    {
								       obj_t obj_1925;
								       obj_1925 = (obj_t) (new1132_1920);
								       (((obj_t) CREF(obj_1925))->header = MAKE_HEADER(arg1653_1921, 0), BUNSPEC);
								    }
								 }
								 {
								    object_t aux_2830;
								    aux_2830 = (object_t) (new1132_1920);
								    OBJECT_WIDENING_SET(aux_2830, BFALSE);
								 }
								 ((((var_t) CREF(new1132_1920))->loc) = ((obj_t) loc_1494), BUNSPEC);
								 ((((var_t) CREF(new1132_1920))->type) = ((type_t) type_1918), BUNSPEC);
								 ((((var_t) CREF(new1132_1920))->variable) = ((variable_t) variable_1919), BUNSPEC);
								 res1886_1927 = new1132_1920;
							      }
							   }
							   arg1777_1506 = res1886_1927;
							}
							{
							   box_set__221_t res1887_1940;
							   {
							      type_t type_1929;
							      node_t value_1931;
							      type_1929 = (type_t) (_____74_type_cache);
							      value_1931 = (node_t) (arg1777_1506);
							      {
								 box_set__221_t new1268_1932;
								 new1268_1932 = ((box_set__221_t) BREF(GC_MALLOC(sizeof(struct box_set__221))));
								 {
								    long arg1597_1933;
								    arg1597_1933 = class_num_218___object(box_set__221_ast_node);
								    {
								       obj_t obj_1938;
								       obj_1938 = (obj_t) (new1268_1932);
								       (((obj_t) CREF(obj_1938))->header = MAKE_HEADER(arg1597_1933, 0), BUNSPEC);
								    }
								 }
								 {
								    object_t aux_2842;
								    aux_2842 = (object_t) (new1268_1932);
								    OBJECT_WIDENING_SET(aux_2842, BFALSE);
								 }
								 ((((box_set__221_t) CREF(new1268_1932))->loc) = ((obj_t) loc_1494), BUNSPEC);
								 ((((box_set__221_t) CREF(new1268_1932))->type) = ((type_t) type_1929), BUNSPEC);
								 ((((box_set__221_t) CREF(new1268_1932))->var) = ((var_t) arg1776_1505), BUNSPEC);
								 ((((box_set__221_t) CREF(new1268_1932))->value) = ((node_t) value_1931), BUNSPEC);
								 res1887_1940 = new1268_1932;
							      }
							   }
							   arg1771_1500 = res1887_1940;
							}
						     }
						     {
							let_var_6_t res1888_1957;
							{
							   type_t type_1942;
							   node_t body_1945;
							   type_1942 = (type_t) (_____74_type_cache);
							   body_1945 = (node_t) (arg1771_1500);
							   {
							      let_var_6_t new1231_1947;
							      new1231_1947 = ((let_var_6_t) BREF(GC_MALLOC(sizeof(struct let_var_6))));
							      {
								 long arg1614_1948;
								 arg1614_1948 = class_num_218___object(let_var_6_ast_node);
								 {
								    obj_t obj_1955;
								    obj_1955 = (obj_t) (new1231_1947);
								    (((obj_t) CREF(obj_1955))->header = MAKE_HEADER(arg1614_1948, 0), BUNSPEC);
								 }
							      }
							      {
								 object_t aux_2855;
								 aux_2855 = (object_t) (new1231_1947);
								 OBJECT_WIDENING_SET(aux_2855, BFALSE);
							      }
							      ((((let_var_6_t) CREF(new1231_1947))->loc) = ((obj_t) loc_1494), BUNSPEC);
							      ((((let_var_6_t) CREF(new1231_1947))->type) = ((type_t) type_1942), BUNSPEC);
							      ((((let_var_6_t) CREF(new1231_1947))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
							      ((((let_var_6_t) CREF(new1231_1947))->bindings) = ((obj_t) arg1770_1499), BUNSPEC);
							      ((((let_var_6_t) CREF(new1231_1947))->body) = ((node_t) body_1945), BUNSPEC);
							      ((((let_var_6_t) CREF(new1231_1947))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
							      res1888_1957 = new1231_1947;
							   }
							}
							aux_2598 = (obj_t) (res1888_1957);
						     }
						  }
					       }
					     else
					       {
						  aux_2598 = (obj_t) (node_1478);
					       }
					  }
				       }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 11):
			 {
			    conditional_t node_1511;
			    node_1511 = (conditional_t) (node_10);
			    {
			       node_t arg1783_1514;
			       arg1783_1514 = glo__115_integrate_node((((conditional_t) CREF(node_1511))->test), integrator_11);
			       {
				  obj_t res1889_1961;
				  {
				     obj_t x_2200;
				     x_2200 = ((((conditional_t) CREF(node_1511))->test) = ((node_t) arg1783_1514), BUNSPEC);
				     res1889_1961 = BUNSPEC;
				  }
				  res1889_1961;
			       }
			    }
			    {
			       node_t arg1785_1516;
			       arg1785_1516 = glo__115_integrate_node((((conditional_t) CREF(node_1511))->true), integrator_11);
			       {
				  obj_t res1890_1965;
				  {
				     obj_t x_2201;
				     x_2201 = ((((conditional_t) CREF(node_1511))->true) = ((node_t) arg1785_1516), BUNSPEC);
				     res1890_1965 = BUNSPEC;
				  }
				  res1890_1965;
			       }
			    }
			    {
			       node_t arg1788_1518;
			       arg1788_1518 = glo__115_integrate_node((((conditional_t) CREF(node_1511))->false), integrator_11);
			       {
				  obj_t res1891_1969;
				  {
				     obj_t x_2202;
				     x_2202 = ((((conditional_t) CREF(node_1511))->false) = ((node_t) arg1788_1518), BUNSPEC);
				     res1891_1969 = BUNSPEC;
				  }
				  res1891_1969;
			       }
			    }
			    aux_2598 = (obj_t) (node_1511);
			 }
			 break;
		      case ((long) 12):
			 {
			    fail_t node_1520;
			    node_1520 = (fail_t) (node_10);
			    {
			       node_t arg1791_1523;
			       arg1791_1523 = glo__115_integrate_node((((fail_t) CREF(node_1520))->proc), integrator_11);
			       {
				  obj_t res1892_1973;
				  {
				     obj_t x_2203;
				     x_2203 = ((((fail_t) CREF(node_1520))->proc) = ((node_t) arg1791_1523), BUNSPEC);
				     res1892_1973 = BUNSPEC;
				  }
				  res1892_1973;
			       }
			    }
			    {
			       node_t arg1793_1525;
			       arg1793_1525 = glo__115_integrate_node((((fail_t) CREF(node_1520))->msg), integrator_11);
			       {
				  obj_t res1893_1977;
				  {
				     obj_t x_2204;
				     x_2204 = ((((fail_t) CREF(node_1520))->msg) = ((node_t) arg1793_1525), BUNSPEC);
				     res1893_1977 = BUNSPEC;
				  }
				  res1893_1977;
			       }
			    }
			    {
			       node_t arg1796_1527;
			       arg1796_1527 = glo__115_integrate_node((((fail_t) CREF(node_1520))->obj), integrator_11);
			       {
				  obj_t res1894_1981;
				  {
				     obj_t x_2205;
				     x_2205 = ((((fail_t) CREF(node_1520))->obj) = ((node_t) arg1796_1527), BUNSPEC);
				     res1894_1981 = BUNSPEC;
				  }
				  res1894_1981;
			       }
			    }
			    aux_2598 = (obj_t) (node_1520);
			 }
			 break;
		      case ((long) 13):
			 {
			    select_t node_1529;
			    node_1529 = (select_t) (node_10);
			    {
			       node_t arg1799_1532;
			       arg1799_1532 = glo__115_integrate_node((((select_t) CREF(node_1529))->test), integrator_11);
			       {
				  obj_t res1895_1985;
				  {
				     obj_t x_2206;
				     x_2206 = ((((select_t) CREF(node_1529))->test) = ((node_t) arg1799_1532), BUNSPEC);
				     res1895_1985 = BUNSPEC;
				  }
				  res1895_1985;
			       }
			    }
			    {
			       obj_t l1355_1534;
			       l1355_1534 = (((select_t) CREF(node_1529))->clauses);
			     lname1356_1535:
			       if (PAIRP(l1355_1534))
				 {
				    {
				       obj_t clause_1538;
				       clause_1538 = CAR(l1355_1534);
				       {
					  node_t arg1804_1539;
					  {
					     node_t aux_2897;
					     {
						obj_t aux_2898;
						aux_2898 = CDR(clause_1538);
						aux_2897 = (node_t) (aux_2898);
					     }
					     arg1804_1539 = glo__115_integrate_node(aux_2897, integrator_11);
					  }
					  {
					     obj_t aux_2902;
					     aux_2902 = (obj_t) (arg1804_1539);
					     SET_CDR(clause_1538, aux_2902);
					  }
				       }
				    }
				    {
				       obj_t l1355_2905;
				       l1355_2905 = CDR(l1355_1534);
				       l1355_1534 = l1355_2905;
				       goto lname1356_1535;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_2598 = (obj_t) (node_1529);
			 }
			 break;
		      case ((long) 14):
			 {
			    let_fun_218_t node_1542;
			    node_1542 = (let_fun_218_t) (node_10);
			    {
			       node_t arg1807_1545;
			       arg1807_1545 = glo__115_integrate_node((((let_fun_218_t) CREF(node_1542))->body), integrator_11);
			       {
				  obj_t res1896_1996;
				  {
				     obj_t x_2207;
				     x_2207 = ((((let_fun_218_t) CREF(node_1542))->body) = ((node_t) arg1807_1545), BUNSPEC);
				     res1896_1996 = BUNSPEC;
				  }
				  res1896_1996;
			       }
			    }
			    {
			       obj_t l1358_1547;
			       l1358_1547 = (((let_fun_218_t) CREF(node_1542))->locals);
			     lname1359_1548:
			       if (PAIRP(l1358_1547))
				 {
				    {
				       local_t aux_2915;
				       {
					  obj_t aux_2916;
					  aux_2916 = CAR(l1358_1547);
					  aux_2915 = (local_t) (aux_2916);
				       }
				       globalize_local_fun__50_integrate_node(aux_2915, integrator_11);
				    }
				    {
				       obj_t l1358_2920;
				       l1358_2920 = CDR(l1358_1547);
				       l1358_1547 = l1358_2920;
				       goto lname1359_1548;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_2598 = (obj_t) (node_1542);
			 }
			 break;
		      case ((long) 15):
			 {
			    let_var_6_t node_1553;
			    node_1553 = (let_var_6_t) (node_10);
			    {
			       obj_t l1361_1556;
			       l1361_1556 = (((let_var_6_t) CREF(node_1553))->bindings);
			     lname1362_1557:
			       if (PAIRP(l1361_1556))
				 {
				    {
				       obj_t binding_1560;
				       binding_1560 = CAR(l1361_1556);
				       {
					  obj_t var_1561;
					  obj_t val_1562;
					  var_1561 = CAR(binding_1560);
					  val_1562 = CDR(binding_1560);
					  {
					     node_t arg1814_1563;
					     arg1814_1563 = glo__115_integrate_node((node_t) (val_1562), integrator_11);
					     {
						obj_t aux_2932;
						aux_2932 = (obj_t) (arg1814_1563);
						SET_CDR(binding_1560, aux_2932);
					     }
					  }
					  {
					     bool_t test1815_1564;
					     test1815_1564 = integrate_celled__59_integrate_node((local_t) (var_1561));
					     if (test1815_1564)
					       {
						  {
						     obj_t res1897_2010;
						     {
							local_t obj_2008;
							type_t val1055_2009;
							obj_2008 = (local_t) (var_1561);
							val1055_2009 = (type_t) (__obj__252_type_cache);
							{
							   obj_t x_2208;
							   x_2208 = ((((local_t) CREF(obj_2008))->type) = ((type_t) val1055_2009), BUNSPEC);
							   res1897_2010 = BUNSPEC;
							}
						     }
						     res1897_2010;
						  }
						  {
						     make_box_202_t arg1819_1565;
						     arg1819_1565 = a_make_cell_117_integrate_node((node_t) (val_1562), (variable_t) (var_1561));
						     {
							obj_t aux_2944;
							aux_2944 = (obj_t) (arg1819_1565);
							SET_CDR(binding_1560, aux_2944);
						     }
						  }
					       }
					     else
					       {
						  BUNSPEC;
					       }
					  }
				       }
				    }
				    {
				       obj_t l1361_2947;
				       l1361_2947 = CDR(l1361_1556);
				       l1361_1556 = l1361_2947;
				       goto lname1362_1557;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1821_1567;
			       arg1821_1567 = glo__115_integrate_node((((let_var_6_t) CREF(node_1553))->body), integrator_11);
			       {
				  obj_t res1898_2017;
				  {
				     obj_t x_2209;
				     x_2209 = ((((let_var_6_t) CREF(node_1553))->body) = ((node_t) arg1821_1567), BUNSPEC);
				     res1898_2017 = BUNSPEC;
				  }
				  res1898_2017;
			       }
			    }
			    aux_2598 = (obj_t) (node_1553);
			 }
			 break;
		      case ((long) 16):
			 {
			    set_ex_it_116_t node_1569;
			    node_1569 = (set_ex_it_116_t) (node_10);
			    {
			       node_t arg1823_1572;
			       arg1823_1572 = glo__115_integrate_node((((set_ex_it_116_t) CREF(node_1569))->body), integrator_11);
			       {
				  obj_t res1899_2021;
				  {
				     obj_t x_2210;
				     x_2210 = ((((set_ex_it_116_t) CREF(node_1569))->body) = ((node_t) arg1823_1572), BUNSPEC);
				     res1899_2021 = BUNSPEC;
				  }
				  res1899_2021;
			       }
			    }
			    aux_2598 = (obj_t) (node_1569);
			 }
			 break;
		      case ((long) 17):
			 {
			    jump_ex_it_184_t node_1574;
			    node_1574 = (jump_ex_it_184_t) (node_10);
			    {
			       node_t arg1825_1577;
			       arg1825_1577 = glo__115_integrate_node((((jump_ex_it_184_t) CREF(node_1574))->exit), integrator_11);
			       {
				  obj_t res1900_2025;
				  {
				     obj_t x_2211;
				     x_2211 = ((((jump_ex_it_184_t) CREF(node_1574))->exit) = ((node_t) arg1825_1577), BUNSPEC);
				     res1900_2025 = BUNSPEC;
				  }
				  res1900_2025;
			       }
			    }
			    {
			       node_t arg1827_1579;
			       arg1827_1579 = glo__115_integrate_node((((jump_ex_it_184_t) CREF(node_1574))->value), integrator_11);
			       {
				  obj_t res1901_2029;
				  {
				     obj_t x_2212;
				     x_2212 = ((((jump_ex_it_184_t) CREF(node_1574))->value) = ((node_t) arg1827_1579), BUNSPEC);
				     res1901_2029 = BUNSPEC;
				  }
				  res1901_2029;
			       }
			    }
			    aux_2598 = (obj_t) (node_1574);
			 }
			 break;
		      case ((long) 18):
			 {
			    make_box_202_t node_1581;
			    node_1581 = (make_box_202_t) (node_10);
			    {
			       node_t arg1829_1584;
			       arg1829_1584 = glo__115_integrate_node((((make_box_202_t) CREF(node_1581))->value), integrator_11);
			       {
				  obj_t res1902_2033;
				  {
				     obj_t x_2213;
				     x_2213 = ((((make_box_202_t) CREF(node_1581))->value) = ((node_t) arg1829_1584), BUNSPEC);
				     res1902_2033 = BUNSPEC;
				  }
				  res1902_2033;
			       }
			    }
			    aux_2598 = (obj_t) (node_1581);
			 }
			 break;
		      case ((long) 19):
			 {
			    box_ref_242_t node_1586;
			    node_1586 = (box_ref_242_t) (node_10);
			    {
			       bool_t test1831_1588;
			       {
				  obj_t aux_2973;
				  aux_2973 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1831_1588 = CBOOL(aux_2973);
			       }
			       if (test1831_1588)
				 {
				    obj_t arg1833_1590;
				    arg1833_1590 = shape_tools_shape((obj_t) (node_1586));
				    {
				       obj_t list1834_1591;
				       {
					  obj_t arg1835_1592;
					  {
					     obj_t arg1836_1593;
					     {
						obj_t aux_2981;
						aux_2981 = BCHAR(((unsigned char) '\n'));
						arg1836_1593 = MAKE_PAIR(aux_2981, BNIL);
					     }
					     arg1835_1592 = MAKE_PAIR(arg1833_1590, arg1836_1593);
					  }
					  list1834_1591 = MAKE_PAIR(string1924_integrate_node, arg1835_1592);
				       }
				       print_trace_107_tools_trace(list1834_1591);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       node_t arg1840_1598;
			       {
				  node_t aux_2987;
				  {
				     var_t aux_2988;
				     aux_2988 = (((box_ref_242_t) CREF(node_1586))->var);
				     aux_2987 = (node_t) (aux_2988);
				  }
				  arg1840_1598 = glo__115_integrate_node(aux_2987, integrator_11);
			       }
			       {
				  obj_t res1903_2037;
				  {
				     var_t val1265_2036;
				     val1265_2036 = (var_t) (arg1840_1598);
				     {
					obj_t x_2214;
					x_2214 = ((((box_ref_242_t) CREF(node_1586))->var) = ((var_t) val1265_2036), BUNSPEC);
					res1903_2037 = BUNSPEC;
				     }
				  }
				  res1903_2037;
			       }
			    }
			    aux_2598 = (obj_t) (node_1586);
			 }
			 break;
		      case ((long) 20):
			 {
			    box_set__221_t node_1600;
			    node_1600 = (box_set__221_t) (node_10);
			    {
			       bool_t test1842_1602;
			       {
				  obj_t aux_2996;
				  aux_2996 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1842_1602 = CBOOL(aux_2996);
			       }
			       if (test1842_1602)
				 {
				    obj_t arg1844_1604;
				    arg1844_1604 = shape_tools_shape((obj_t) (node_1600));
				    {
				       obj_t list1845_1605;
				       {
					  obj_t arg1846_1606;
					  {
					     obj_t arg1847_1607;
					     {
						obj_t aux_3004;
						aux_3004 = BCHAR(((unsigned char) '\n'));
						arg1847_1607 = MAKE_PAIR(aux_3004, BNIL);
					     }
					     arg1846_1606 = MAKE_PAIR(arg1844_1604, arg1847_1607);
					  }
					  list1845_1605 = MAKE_PAIR(string1925_integrate_node, arg1846_1606);
				       }
				       print_trace_107_tools_trace(list1845_1605);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       node_t arg1853_1612;
			       {
				  node_t aux_3010;
				  {
				     var_t aux_3011;
				     aux_3011 = (((box_set__221_t) CREF(node_1600))->var);
				     aux_3010 = (node_t) (aux_3011);
				  }
				  arg1853_1612 = glo__115_integrate_node(aux_3010, integrator_11);
			       }
			       {
				  obj_t res1904_2041;
				  {
				     var_t val1271_2040;
				     val1271_2040 = (var_t) (arg1853_1612);
				     {
					obj_t x_2215;
					x_2215 = ((((box_set__221_t) CREF(node_1600))->var) = ((var_t) val1271_2040), BUNSPEC);
					res1904_2041 = BUNSPEC;
				     }
				  }
				  res1904_2041;
			       }
			    }
			    {
			       node_t arg1856_1614;
			       arg1856_1614 = glo__115_integrate_node((((box_set__221_t) CREF(node_1600))->value), integrator_11);
			       {
				  obj_t res1905_2045;
				  {
				     obj_t x_2216;
				     x_2216 = ((((box_set__221_t) CREF(node_1600))->value) = ((node_t) arg1856_1614), BUNSPEC);
				     res1905_2045 = BUNSPEC;
				  }
				  res1905_2045;
			       }
			    }
			    aux_2598 = (obj_t) (node_1600);
			 }
			 break;
		      default:
		       case_else1701_50_1395:
			 if (PROCEDUREP(method1695_1391))
			   {
			      aux_2598 = PROCEDURE_ENTRY(method1695_1391) (method1695_1391, (obj_t) (node_10), (obj_t) (integrator_11), BEOA);
			   }
			 else
			   {
			      obj_t fun1567_1004;
			      fun1567_1004 = PROCEDURE_REF(glo__env_172_integrate_node, ((long) 0));
			      aux_2598 = PROCEDURE_ENTRY(fun1567_1004) (fun1567_1004, (obj_t) (node_10), (obj_t) (integrator_11), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1701_50_1395;
		 }
	    }
	    return (node_t) (aux_2598);
	 }
      }
   }
}


obj_t 
_glo__107_integrate_node(obj_t env_2173, obj_t node_2174, obj_t integrator_2175)
{
   {
      node_t aux_3035;
      aux_3035 = glo__115_integrate_node((node_t) (node_2174), (variable_t) (integrator_2175));
      return (obj_t) (aux_3035);
   }
}


obj_t 
glo___241_integrate_node(obj_t node__221_56, variable_t integrator_57)
{
   {
      obj_t node__221_1005;
      node__221_1005 = node__221_56;
    loop_1006:
      if (NULLP(node__221_1005))
	{
	   return CNST_TABLE_REF(((long) 4));
	}
      else
	{
	   {
	      node_t arg1570_1008;
	      {
		 node_t aux_3043;
		 {
		    obj_t aux_3044;
		    aux_3044 = CAR(node__221_1005);
		    aux_3043 = (node_t) (aux_3044);
		 }
		 arg1570_1008 = glo__115_integrate_node(aux_3043, integrator_57);
	      }
	      {
		 obj_t aux_3048;
		 aux_3048 = (obj_t) (arg1570_1008);
		 SET_CAR(node__221_1005, aux_3048);
	      }
	   }
	   {
	      obj_t node__221_3051;
	      node__221_3051 = CDR(node__221_1005);
	      node__221_1005 = node__221_3051;
	      goto loop_1006;
	   }
	}
   }
}


obj_t 
globalize_local_fun__50_integrate_node(local_t local_58, variable_t integrator_59)
{
   {
      value_t fun_1011;
      fun_1011 = (((local_t) CREF(local_58))->value);
      {
	 obj_t obody_1012;
	 {
	    sfun_t obj_2054;
	    obj_2054 = (sfun_t) (fun_1011);
	    obody_1012 = (((sfun_t) CREF(obj_2054))->body);
	 }
	 {
	    {
	       bool_t test_3056;
	       {
		  obj_t aux_3059;
		  obj_t aux_3057;
		  aux_3059 = (obj_t) (integrator_59);
		  aux_3057 = (obj_t) (local_58);
		  test_3056 = (aux_3057 == aux_3059);
	       }
	       if (test_3056)
		 {
		    node_t arg1574_1014;
		    arg1574_1014 = glo__115_integrate_node((node_t) (obody_1012), integrator_59);
		    {
		       obj_t res1907_2059;
		       {
			  sfun_t obj_2057;
			  obj_t val1081_2058;
			  obj_2057 = (sfun_t) (fun_1011);
			  val1081_2058 = (obj_t) (arg1574_1014);
			  {
			     obj_t x_2217;
			     x_2217 = ((((sfun_t) CREF(obj_2057))->body) = ((obj_t) val1081_2058), BUNSPEC);
			     res1907_2059 = BUNSPEC;
			  }
		       }
		       return res1907_2059;
		    }
		 }
	       else
		 {
		    obj_t celled_1015;
		    {
		       obj_t aux_3067;
		       {
			  sfun_t obj_2060;
			  obj_2060 = (sfun_t) (fun_1011);
			  aux_3067 = (((sfun_t) CREF(obj_2060))->args);
		       }
		       celled_1015 = celled_bindings_3_integrate_node(aux_3067);
		    }
		    {
		       obj_t l1368_1016;
		       l1368_1016 = celled_1015;
		     lname1370_1017:
		       if (PAIRP(l1368_1016))
			 {
			    {
			       obj_t w_b_127_1019;
			       w_b_127_1019 = CAR(l1368_1016);
			       {
				  obj_t arg1577_1021;
				  arg1577_1021 = CDR(w_b_127_1019);
				  {
				     obj_t res1908_2067;
				     {
					variable_t obj_2065;
					{
					   obj_t aux_3075;
					   aux_3075 = CAR(w_b_127_1019);
					   obj_2065 = (variable_t) (aux_3075);
					}
					{
					   obj_t x_2218;
					   x_2218 = ((((variable_t) CREF(obj_2065))->fast_alpha_7) = ((obj_t) arg1577_1021), BUNSPEC);
					   res1908_2067 = BUNSPEC;
					}
				     }
				     res1908_2067;
				  }
			       }
			    }
			    {
			       obj_t l1368_3079;
			       l1368_3079 = CDR(l1368_1016);
			       l1368_1016 = l1368_3079;
			       goto lname1370_1017;
			    }
			 }
		       else
			 {
			    ((bool_t) 1);
			 }
		    }
		    {
		       node_t nbody1_1023;
		       nbody1_1023 = glo__115_integrate_node((node_t) (obody_1012), integrator_59);
		       {
			  obj_t nbody2_1024;
			  nbody2_1024 = cell_formals_12_integrate_node(celled_1015, nbody1_1023);
			  {
			     {
				obj_t l1371_1025;
				l1371_1025 = celled_1015;
			      lname1373_1026:
				if (PAIRP(l1371_1025))
				  {
				     {
					obj_t res1909_2074;
					{
					   variable_t obj_2072;
					   {
					      obj_t aux_3086;
					      {
						 obj_t aux_3087;
						 aux_3087 = CAR(l1371_1025);
						 aux_3086 = CAR(aux_3087);
					      }
					      obj_2072 = (variable_t) (aux_3086);
					   }
					   {
					      obj_t x_2219;
					      x_2219 = ((((variable_t) CREF(obj_2072))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
					      res1909_2074 = BUNSPEC;
					   }
					}
					res1909_2074;
				     }
				     {
					obj_t l1371_3092;
					l1371_3092 = CDR(l1371_1025);
					l1371_1025 = l1371_3092;
					goto lname1373_1026;
				     }
				  }
				else
				  {
				     ((bool_t) 1);
				  }
			     }
			     {
				obj_t res1910_2078;
				{
				   sfun_t obj_2076;
				   obj_2076 = (sfun_t) (fun_1011);
				   {
				      obj_t x_2220;
				      x_2220 = ((((sfun_t) CREF(obj_2076))->body) = ((obj_t) nbody2_1024), BUNSPEC);
				      res1910_2078 = BUNSPEC;
				   }
				}
				return res1910_2078;
			     }
			  }
		       }
		    }
		 }
	    }
	 }
      }
   }
}


obj_t 
imported_modules_init_94_integrate_node()
{
   module_initialization_70_tools_trace(((long) 0), "INTEGRATE_NODE");
   module_initialization_70_tools_shape(((long) 0), "INTEGRATE_NODE");
   module_initialization_70_tools_error(((long) 0), "INTEGRATE_NODE");
   module_initialization_70_type_type(((long) 0), "INTEGRATE_NODE");
   module_initialization_70_type_cache(((long) 0), "INTEGRATE_NODE");
   module_initialization_70_ast_var(((long) 0), "INTEGRATE_NODE");
   module_initialization_70_ast_node(((long) 0), "INTEGRATE_NODE");
   module_initialization_70_ast_local(((long) 0), "INTEGRATE_NODE");
   module_initialization_70_integrate_info(((long) 0), "INTEGRATE_NODE");
   return module_initialization_70_integrate_local__global_163(((long) 0), "INTEGRATE_NODE");
}
