/*===========================================================================*/
/*   (Integrate/u.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_t;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_t;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_t;


extern obj_t __phi__105_integrate_a;
extern obj_t u__31_integrate_u();
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_integrate_u();
extern obj_t module_initialization_70_integrate_u(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_a(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t cnst_init_137_integrate_u();
static obj_t require_initialization_114_integrate_u = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_integrate_u();
extern obj_t _u__160_integrate_u(obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
static obj_t trace_u_65_integrate_u();
extern obj_t __trace_port__84_tools_trace;
extern obj_t shape_tools_shape(obj_t);
extern long list_length(obj_t);
static obj_t __cnst[1];

DEFINE_EXPORT_PROCEDURE(u__env_99_integrate_u, _u__160_integrate_u1519, _u__160_integrate_u, 0L, 0);
DEFINE_STRING(string1508_integrate_u, string1508_integrate_u1520, "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~", 32);
DEFINE_STRING(string1510_integrate_u, string1510_integrate_u1521, " --> ", 5);
DEFINE_STRING(string1509_integrate_u, string1509_integrate_u1522, "U: ", 3);
DEFINE_STRING(string1511_integrate_u, string1511_integrate_u1523, "INTEGRATE ", 10);

obj_t 
module_initialization_70_integrate_u(long checksum_1280, char *from_1281)
{
   if (CBOOL(require_initialization_114_integrate_u))
     {
	require_initialization_114_integrate_u = BBOOL(((bool_t) 0));
	library_modules_init_112_integrate_u();
	cnst_init_137_integrate_u();
	imported_modules_init_94_integrate_u();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_integrate_u()
{
   module_initialization_70___r4_output_6_10_3(((long) 0), "INTEGRATE_U");
   module_initialization_70___reader(((long) 0), "INTEGRATE_U");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_U");
   return BUNSPEC;
}


obj_t 
cnst_init_137_integrate_u()
{
   {
      obj_t cnst_port_138_1272;
      cnst_port_138_1272 = open_input_string(string1511_integrate_u);
      {
	 long i_1273;
	 i_1273 = ((long) 0);
       loop_1274:
	 {
	    bool_t test1512_1275;
	    test1512_1275 = (i_1273 == ((long) -1));
	    if (test1512_1275)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1513_1276;
		    {
		       obj_t list1514_1277;
		       {
			  obj_t arg1517_1278;
			  arg1517_1278 = BNIL;
			  list1514_1277 = MAKE_PAIR(cnst_port_138_1272, arg1517_1278);
		       }
		       arg1513_1276 = read___reader(list1514_1277);
		    }
		    CNST_TABLE_SET(i_1273, arg1513_1276);
		 }
		 {
		    int aux_1279;
		    {
		       long aux_1297;
		       aux_1297 = (i_1273 - ((long) 1));
		       aux_1279 = (int) (aux_1297);
		    }
		    {
		       long i_1300;
		       i_1300 = (long) (aux_1279);
		       i_1273 = i_1300;
		       goto loop_1274;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
u__31_integrate_u()
{
   {
      obj_t phi_808;
      phi_808 = __phi__105_integrate_a;
    loop_809:
      if (NULLP(phi_808))
	{
	   return trace_u_65_integrate_u();
	}
      else
	{
	   value_t ifun_812;
	   {
	      variable_t obj_1204;
	      {
		 obj_t aux_1305;
		 aux_1305 = CAR(phi_808);
		 obj_1204 = (variable_t) (aux_1305);
	      }
	      ifun_812 = (((variable_t) CREF(obj_1204))->value);
	   }
	   {
	      {
		 obj_t res1507_1210;
		 {
		    sfun_iinfo_105_t obj_1208;
		    obj_t val1318_1209;
		    obj_1208 = (sfun_iinfo_105_t) (ifun_812);
		    {
		       bool_t aux_1310;
		       {
			  long aux_1311;
			  {
			     obj_t aux_1312;
			     {
				sfun_iinfo_105_t obj_1205;
				obj_1205 = (sfun_iinfo_105_t) (ifun_812);
				{
				   obj_t aux_1314;
				   {
				      object_t aux_1315;
				      aux_1315 = (object_t) (obj_1205);
				      aux_1314 = OBJECT_WIDENING(aux_1315);
				   }
				   aux_1312 = (((sfun_iinfo_105_t) CREF(aux_1314))->k__190);
				}
			     }
			     aux_1311 = list_length(aux_1312);
			  }
			  aux_1310 = (aux_1311 == ((long) 1));
		       }
		       val1318_1209 = BBOOL(aux_1310);
		    }
		    {
		       obj_t x_1271;
		       {
			  obj_t aux_1322;
			  {
			     object_t aux_1323;
			     aux_1323 = (object_t) (obj_1208);
			     aux_1322 = OBJECT_WIDENING(aux_1323);
			  }
			  x_1271 = ((((sfun_iinfo_105_t) CREF(aux_1322))->u) = ((obj_t) val1318_1209), BUNSPEC);
		       }
		       res1507_1210 = BUNSPEC;
		    }
		 }
		 res1507_1210;
	      }
	      {
		 obj_t phi_1327;
		 phi_1327 = CDR(phi_808);
		 phi_808 = phi_1327;
		 goto loop_809;
	      }
	   }
	}
   }
}


obj_t 
_u__160_integrate_u(obj_t env_1270)
{
   return u__31_integrate_u();
}


obj_t 
trace_u_65_integrate_u()
{
   {
      bool_t test1340_818;
      {
	 obj_t aux_1330;
	 aux_1330 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1340_818 = CBOOL(aux_1330);
      }
      if (test1340_818)
	{
	   char *arg1342_819;
	   {
	      obj_t list1347_823;
	      list1347_823 = MAKE_PAIR(string1508_integrate_u, BNIL);
	      fprint___r4_output_6_10_3(__trace_port__84_tools_trace, list1347_823);
	   }
	   {
	      obj_t list1351_826;
	      {
		 obj_t arg1353_828;
		 {
		    obj_t aux_1338;
		    aux_1338 = BCHAR(((unsigned char) '\n'));
		    arg1353_828 = MAKE_PAIR(aux_1338, BNIL);
		 }
		 list1351_826 = MAKE_PAIR(string1509_integrate_u, arg1353_828);
	      }
	      fprint___r4_output_6_10_3(__trace_port__84_tools_trace, list1351_826);
	   }
	   {
	      obj_t l1329_830;
	      l1329_830 = __phi__105_integrate_a;
	    lname1330_831:
	      if (PAIRP(l1329_830))
		{
		   {
		      obj_t p_833;
		      p_833 = CAR(l1329_830);
		      {
			 obj_t arg1358_836;
			 obj_t arg1359_837;
			 arg1358_836 = shape_tools_shape(p_833);
			 {
			    sfun_iinfo_105_t obj_1215;
			    {
			       value_t aux_1347;
			       {
				  variable_t obj_1214;
				  obj_1214 = (variable_t) (p_833);
				  aux_1347 = (((variable_t) CREF(obj_1214))->value);
			       }
			       obj_1215 = (sfun_iinfo_105_t) (aux_1347);
			    }
			    {
			       obj_t aux_1351;
			       {
				  object_t aux_1352;
				  aux_1352 = (object_t) (obj_1215);
				  aux_1351 = OBJECT_WIDENING(aux_1352);
			       }
			       arg1359_837 = (((sfun_iinfo_105_t) CREF(aux_1351))->u);
			    }
			 }
			 {
			    obj_t list1360_838;
			    {
			       obj_t arg1361_839;
			       {
				  obj_t arg1363_840;
				  {
				     obj_t arg1364_841;
				     arg1364_841 = MAKE_PAIR(arg1359_837, BNIL);
				     {
					obj_t aux_1357;
					aux_1357 = BCHAR(((unsigned char) ':'));
					arg1363_840 = MAKE_PAIR(aux_1357, arg1364_841);
				     }
				  }
				  arg1361_839 = MAKE_PAIR(arg1358_836, arg1363_840);
			       }
			       list1360_838 = MAKE_PAIR(string1510_integrate_u, arg1361_839);
			    }
			    fprint___r4_output_6_10_3(__trace_port__84_tools_trace, list1360_838);
			 }
		      }
		   }
		   {
		      obj_t l1329_1363;
		      l1329_1363 = CDR(l1329_830);
		      l1329_830 = l1329_1363;
		      goto lname1330_831;
		   }
		}
	      else
		{
		   ((bool_t) 1);
		}
	   }
	   arg1342_819 = "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~";
	   {
	      obj_t list1343_820;
	      {
		 obj_t arg1345_821;
		 {
		    obj_t aux_1365;
		    aux_1365 = BCHAR(((unsigned char) '\n'));
		    arg1345_821 = MAKE_PAIR(aux_1365, BNIL);
		 }
		 {
		    obj_t aux_1368;
		    aux_1368 = string_to_bstring(arg1342_819);
		    list1343_820 = MAKE_PAIR(aux_1368, arg1345_821);
		 }
	      }
	      return print_trace_107_tools_trace(list1343_820);
	   }
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
imported_modules_init_94_integrate_u()
{
   module_initialization_70_tools_trace(((long) 0), "INTEGRATE_U");
   module_initialization_70_tools_shape(((long) 0), "INTEGRATE_U");
   module_initialization_70_type_type(((long) 0), "INTEGRATE_U");
   module_initialization_70_ast_var(((long) 0), "INTEGRATE_U");
   module_initialization_70_ast_node(((long) 0), "INTEGRATE_U");
   module_initialization_70_integrate_info(((long) 0), "INTEGRATE_U");
   return module_initialization_70_integrate_a(((long) 0), "INTEGRATE_U");
}
