/*===========================================================================*/
/*   (Integrate/walk.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


extern obj_t integrate_definition__136_integrate_definition(obj_t);
extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t _integrate_walk__13_integrate_walk(obj_t, obj_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_integrate_walk();
extern obj_t module_initialization_70_integrate_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_integrate_definition(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t integrate_walk__134_integrate_walk(obj_t);
static obj_t cnst_init_137_integrate_walk();
static obj_t require_initialization_114_integrate_walk = BUNSPEC;
static obj_t library_modules_init_112_integrate_walk();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t current_error_port;
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t __current_pass__25_engine_pass;
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
static obj_t __cnst[2];

DEFINE_EXPORT_PROCEDURE(integrate_walk__env_199_integrate_walk, _integrate_walk__13_integrate_walk1286, _integrate_walk__13_integrate_walk, 0L, 1);
DEFINE_STRING(string1278_integrate_walk, string1278_integrate_walk1287, " error", 6);
DEFINE_STRING(string1274_integrate_walk, string1274_integrate_walk1288, "Integration", 11);
DEFINE_STRING(string1275_integrate_walk, string1275_integrate_walk1289, "   . ", 5);
DEFINE_STRING(string1280_integrate_walk, string1280_integrate_walk1290, "(INTEGRATE CFA) PASS-STARTED ", 29);
DEFINE_STRING(string1277_integrate_walk, string1277_integrate_walk1291, " occured, ending ...", 20);
DEFINE_STRING(string1276_integrate_walk, string1276_integrate_walk1292, "failure during prelude hook", 27);
DEFINE_STRING(string1279_integrate_walk, string1279_integrate_walk1293, "failure during postlude hook", 28);

obj_t 
module_initialization_70_integrate_walk(long checksum_490, char *from_491)
{
   if (CBOOL(require_initialization_114_integrate_walk))
     {
	require_initialization_114_integrate_walk = BBOOL(((bool_t) 0));
	library_modules_init_112_integrate_walk();
	cnst_init_137_integrate_walk();
	imported_modules_init_94_integrate_walk();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_integrate_walk()
{
   module_initialization_70___r4_output_6_10_3(((long) 0), "INTEGRATE_WALK");
   module_initialization_70___reader(((long) 0), "INTEGRATE_WALK");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_WALK");
   module_initialization_70___r4_numbers_6_5(((long) 0), "INTEGRATE_WALK");
   return BUNSPEC;
}


obj_t 
cnst_init_137_integrate_walk()
{
   {
      obj_t cnst_port_138_482;
      cnst_port_138_482 = open_input_string(string1280_integrate_walk);
      {
	 long i_483;
	 i_483 = ((long) 1);
       loop_484:
	 {
	    bool_t test1281_485;
	    test1281_485 = (i_483 == ((long) -1));
	    if (test1281_485)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1282_486;
		    {
		       obj_t list1283_487;
		       {
			  obj_t arg1284_488;
			  arg1284_488 = BNIL;
			  list1283_487 = MAKE_PAIR(cnst_port_138_482, arg1284_488);
		       }
		       arg1282_486 = read___reader(list1283_487);
		    }
		    CNST_TABLE_SET(i_483, arg1282_486);
		 }
		 {
		    int aux_489;
		    {
		       long aux_508;
		       aux_508 = (i_483 - ((long) 1));
		       aux_489 = (int) (aux_508);
		    }
		    {
		       long i_511;
		       i_511 = (long) (aux_489);
		       i_483 = i_511;
		       goto loop_484;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
integrate_walk__134_integrate_walk(obj_t globals_1)
{
   {
      obj_t list1110_280;
      {
	 obj_t arg1145_282;
	 {
	    obj_t arg1149_284;
	    {
	       obj_t aux_513;
	       aux_513 = BCHAR(((unsigned char) '\n'));
	       arg1149_284 = MAKE_PAIR(aux_513, BNIL);
	    }
	    arg1145_282 = MAKE_PAIR(string1274_integrate_walk, arg1149_284);
	 }
	 list1110_280 = MAKE_PAIR(string1275_integrate_walk, arg1145_282);
      }
      verbose_tools_speek(BINT(((long) 1)), list1110_280);
   }
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   __current_pass__25_engine_pass = string1274_integrate_walk;
   {
      obj_t hooks_286;
      obj_t hnames_287;
      hooks_286 = BNIL;
      hnames_287 = BNIL;
    loop_288:
      if (NULLP(hooks_286))
	{
	   CNST_TABLE_REF(((long) 0));
	}
      else
	{
	   bool_t test1165_293;
	   {
	      obj_t fun1198_299;
	      fun1198_299 = CAR(hooks_286);
	      {
		 obj_t aux_525;
		 aux_525 = PROCEDURE_ENTRY(fun1198_299) (fun1198_299, BEOA);
		 test1165_293 = CBOOL(aux_525);
	      }
	   }
	   if (test1165_293)
	     {
		{
		   obj_t hnames_532;
		   obj_t hooks_530;
		   hooks_530 = CDR(hooks_286);
		   hnames_532 = CDR(hnames_287);
		   hnames_287 = hnames_532;
		   hooks_286 = hooks_530;
		   goto loop_288;
		}
	     }
	   else
	     {
		internal_error_43_tools_error(string1274_integrate_walk, string1276_integrate_walk, CAR(hnames_287));
	     }
	}
   }
   {
      obj_t old_300;
      obj_t new_301;
      old_300 = globals_1;
      new_301 = BNIL;
    loop_302:
      if (NULLP(old_300))
	{
	   obj_t value_305;
	   value_305 = remove_var_123_ast_remove(CNST_TABLE_REF(((long) 1)), new_301);
	   {
	      bool_t test1201_306;
	      {
		 long n1_466;
		 n1_466 = (long) CINT(__nb_error_on_pass__70_tools_error);
		 test1201_306 = (n1_466 > ((long) 0));
	      }
	      if (test1201_306)
		{
		   {
		      char *arg1205_309;
		      {
			 bool_t test1214_316;
			 {
			    bool_t test1215_317;
			    {
			       obj_t obj_468;
			       obj_468 = __nb_error_on_pass__70_tools_error;
			       test1215_317 = INTEGERP(obj_468);
			    }
			    if (test1215_317)
			      {
				 test1214_316 = _2__206___r4_numbers_6_5(__nb_error_on_pass__70_tools_error, BINT(((long) 1)));
			      }
			    else
			      {
				 test1214_316 = ((bool_t) 0);
			      }
			 }
			 if (test1214_316)
			   {
			      arg1205_309 = "s";
			   }
			 else
			   {
			      arg1205_309 = "";
			   }
		      }
		      {
			 obj_t list1208_311;
			 {
			    obj_t arg1209_312;
			    {
			       obj_t arg1210_313;
			       {
				  obj_t arg1212_314;
				  arg1212_314 = MAKE_PAIR(string1277_integrate_walk, BNIL);
				  {
				     obj_t aux_549;
				     aux_549 = string_to_bstring(arg1205_309);
				     arg1210_313 = MAKE_PAIR(aux_549, arg1212_314);
				  }
			       }
			       arg1209_312 = MAKE_PAIR(string1278_integrate_walk, arg1210_313);
			    }
			    list1208_311 = MAKE_PAIR(__nb_error_on_pass__70_tools_error, arg1209_312);
			 }
			 fprint___r4_output_6_10_3(current_error_port, list1208_311);
		      }
		   }
		   {
		      obj_t res1273_470;
		      exit(((long) -1));
		      res1273_470 = BINT(((long) -1));
		      return res1273_470;
		   }
		}
	      else
		{
		   obj_t hooks_318;
		   obj_t hnames_319;
		   hooks_318 = BNIL;
		   hnames_319 = BNIL;
		 loop_320:
		   if (NULLP(hooks_318))
		     {
			return value_305;
		     }
		   else
		     {
			bool_t test1221_325;
			{
			   obj_t fun1230_330;
			   fun1230_330 = CAR(hooks_318);
			   {
			      obj_t aux_560;
			      aux_560 = PROCEDURE_ENTRY(fun1230_330) (fun1230_330, BEOA);
			      test1221_325 = CBOOL(aux_560);
			   }
			}
			if (test1221_325)
			  {
			     {
				obj_t hnames_567;
				obj_t hooks_565;
				hooks_565 = CDR(hooks_318);
				hnames_567 = CDR(hnames_319);
				hnames_319 = hnames_567;
				hooks_318 = hooks_565;
				goto loop_320;
			     }
			  }
			else
			  {
			     return internal_error_43_tools_error(__current_pass__25_engine_pass, string1279_integrate_walk, CAR(hnames_319));
			  }
		     }
		}
	   }
	}
      else
	{
	   obj_t global_332;
	   global_332 = CAR(old_300);
	   {
	      obj_t aux_572;
	      {
		 global_t obj_478;
		 obj_478 = (global_t) (global_332);
		 aux_572 = (((global_t) CREF(obj_478))->id);
	      }
	      enter_function_81_tools_error(aux_572);
	   }
	   {
	      obj_t arg1234_334;
	      obj_t arg1235_335;
	      arg1234_334 = CDR(old_300);
	      {
		 obj_t arg1236_336;
		 arg1236_336 = integrate_definition__136_integrate_definition(global_332);
		 arg1235_335 = append_2_18___r4_pairs_and_lists_6_3(arg1236_336, new_301);
	      }
	      {
		 obj_t new_580;
		 obj_t old_579;
		 old_579 = arg1234_334;
		 new_580 = arg1235_335;
		 new_301 = new_580;
		 old_300 = old_579;
		 goto loop_302;
	      }
	   }
	}
   }
}


obj_t 
_integrate_walk__13_integrate_walk(obj_t env_480, obj_t globals_481)
{
   return integrate_walk__134_integrate_walk(globals_481);
}


obj_t 
imported_modules_init_94_integrate_walk()
{
   module_initialization_70_tools_speek(((long) 0), "INTEGRATE_WALK");
   module_initialization_70_tools_error(((long) 0), "INTEGRATE_WALK");
   module_initialization_70_engine_pass(((long) 0), "INTEGRATE_WALK");
   module_initialization_70_type_type(((long) 0), "INTEGRATE_WALK");
   module_initialization_70_ast_var(((long) 0), "INTEGRATE_WALK");
   module_initialization_70_ast_remove(((long) 0), "INTEGRATE_WALK");
   return module_initialization_70_integrate_definition(((long) 0), "INTEGRATE_WALK");
}
