/*===========================================================================*/
/*   (Module/class.scm)                                                      */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;


static bool_t read_only__11_module_class(obj_t);
static obj_t make_class_fields_146_module_class(obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t class_object_class;
extern obj_t fast_id_of_id_130_ast_ident(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t __class_accesses__244_module_class = BUNSPEC;
static obj_t arg12571876_module_class(obj_t);
static obj_t imported_modules_init_94_module_class();
extern obj_t module_initialization_70_module_class(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_impuse(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_object_access(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern type_t declare_class_type__110_object_class(obj_t, global_t, obj_t, bool_t, obj_t);
static obj_t toplevel_init_63_module_class();
extern long get_hash_power_number(char *, long);
static obj_t cnst_init_137_module_class();
extern obj_t class_finalizer_253_module_class();
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _wide_class__223_object_class(obj_t, obj_t);
static obj_t require_initialization_114_module_class = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_module_class();
extern obj_t declare_class__31_module_class(obj_t, obj_t, obj_t, bool_t, obj_t);
static obj_t make_slot_field_56_module_class(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t loop1879_module_class(obj_t, obj_t, obj_t, obj_t);
extern obj_t id_of_id_112_ast_ident(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
static obj_t arg18281881_module_class(obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t __reflection___104_engine_param;
extern obj_t _class_finalizer_205_module_class(obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t _declare_wide_class__94_module_class(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t laap1878_module_class(obj_t, obj_t, obj_t, obj_t);
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
static obj_t force_class_accesses_39_module_class();
extern obj_t produce_module_clause__172_module_module(obj_t);
extern obj_t make_promise_21___r4_control_features_6_9(obj_t);
static obj_t arg12351875_module_class(obj_t);
extern obj_t declare_wide_class__13_module_class(obj_t, obj_t, obj_t, obj_t);
extern obj_t get_class_hash_100_module_class(obj_t, obj_t);
static obj_t make_add_class__155_module_class(obj_t, type_t, obj_t);
extern obj_t make_wide_class_accesses__133_object_access(obj_t, type_t, obj_t, bool_t);
extern obj_t _get_class_hash_217_module_class(obj_t, obj_t, obj_t);
static obj_t arg18231882_module_class(obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _declare_class__247_module_class(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern bool_t wide_class__100_object_class(obj_t);
extern obj_t string_append(obj_t, obj_t);
static obj_t __declared_classes__217_module_class = BUNSPEC;
extern obj_t import_parser_53_module_impuse(obj_t, obj_t);
static obj_t arg18241880_module_class(obj_t, obj_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern obj_t make_class_accesses__208_object_access(obj_t, type_t, obj_t, bool_t);
extern obj_t create_struct(obj_t, long);
static obj_t __cnst[25];

DEFINE_STRING(string1885_module_class, string1885_module_class1894, "+ ", 2);
DEFINE_STATIC_PROCEDURE(proc1886_module_class, arg18231882_module_class1895, arg18231882_module_class, 0L, 1);
DEFINE_STRING(string1884_module_class, string1884_module_class1896, "* ", 2);
DEFINE_EXPORT_PROCEDURE(declare_class__env_99_module_class, _declare_class__247_module_class1897, _declare_class__247_module_class, 0L, 5);
DEFINE_EXPORT_PROCEDURE(class_finalizer_env_31_module_class, _class_finalizer_205_module_class1898, _class_finalizer_205_module_class, 0L, 0);
DEFINE_EXPORT_PROCEDURE(declare_wide_class__env_34_module_class, _declare_wide_class__94_module_class1899, _declare_wide_class__94_module_class, 0L, 4);
DEFINE_EXPORT_PROCEDURE(get_class_hash_env_189_module_class, _get_class_hash_217_module_class1900, _get_class_hash_217_module_class, 0L, 2);
DEFINE_STRING(string1883_module_class, string1883_module_class1901, "declare-class!: ", 16);
DEFINE_STRING(string1888_module_class, string1888_module_class1902, "UNIT VOID -LEN PRAGMA::LONG OBJECT LAMBDA -REF -SET! - VECTOR (READ-ONLY) LIST + * QUOTE __OBJECT ADD-CLASS! DEFINE @ ALLOCATE- WIDENING (EXPORT STATIC) USE IMPORT AST ", 168);
DEFINE_STATIC_PROCEDURE(proc1887_module_class, arg18281881_module_class1903, arg18281881_module_class, 0L, 1);
extern obj_t wide_class__env_189_object_class;

obj_t 
module_initialization_70_module_class(long checksum_1590, char *from_1591)
{
   if (CBOOL(require_initialization_114_module_class))
     {
	require_initialization_114_module_class = BBOOL(((bool_t) 0));
	library_modules_init_112_module_class();
	cnst_init_137_module_class();
	imported_modules_init_94_module_class();
	toplevel_init_63_module_class();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_module_class()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_CLASS");
   module_initialization_70___object(((long) 0), "MODULE_CLASS");
   module_initialization_70___reader(((long) 0), "MODULE_CLASS");
   module_initialization_70___r4_symbols_6_4(((long) 0), "MODULE_CLASS");
   module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "MODULE_CLASS");
   module_initialization_70___r4_control_features_6_9(((long) 0), "MODULE_CLASS");
   module_initialization_70___r4_strings_6_7(((long) 0), "MODULE_CLASS");
   return BUNSPEC;
}


obj_t 
cnst_init_137_module_class()
{
   {
      obj_t cnst_port_138_1582;
      cnst_port_138_1582 = open_input_string(string1888_module_class);
      {
	 long i_1583;
	 i_1583 = ((long) 24);
       loop_1584:
	 {
	    bool_t test1889_1585;
	    test1889_1585 = (i_1583 == ((long) -1));
	    if (test1889_1585)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1890_1586;
		    {
		       obj_t list1891_1587;
		       {
			  obj_t arg1892_1588;
			  arg1892_1588 = BNIL;
			  list1891_1587 = MAKE_PAIR(cnst_port_138_1582, arg1892_1588);
		       }
		       arg1890_1586 = read___reader(list1891_1587);
		    }
		    CNST_TABLE_SET(i_1583, arg1890_1586);
		 }
		 {
		    int aux_1589;
		    {
		       long aux_1612;
		       aux_1612 = (i_1583 - ((long) 1));
		       aux_1589 = (int) (aux_1612);
		    }
		    {
		       long i_1615;
		       i_1615 = (long) (aux_1589);
		       i_1583 = i_1615;
		       goto loop_1584;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_module_class()
{
   __class_accesses__244_module_class = BNIL;
   return (__declared_classes__217_module_class = BNIL,
      BUNSPEC);
}


obj_t 
declare_class__31_module_class(obj_t class_def_12_65, obj_t module_66, obj_t import_67, bool_t final__12_68, obj_t src_def_101_69)
{
   {
      bool_t test1219_473;
      {
	 obj_t aux_1617;
	 aux_1617 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1219_473 = CBOOL(aux_1617);
      }
      if (test1219_473)
	{
	   obj_t list1220_474;
	   {
	      obj_t arg1225_476;
	      {
		 obj_t arg1227_477;
		 {
		    obj_t aux_1623;
		    aux_1623 = BCHAR(((unsigned char) '\n'));
		    arg1227_477 = MAKE_PAIR(aux_1623, BNIL);
		 }
		 arg1225_476 = MAKE_PAIR(src_def_101_69, arg1227_477);
	      }
	      list1220_474 = MAKE_PAIR(string1883_module_class, arg1225_476);
	   }
	   print_trace_107_tools_trace(list1220_474);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t class_id_86_482;
      class_id_86_482 = id_of_id_112_ast_ident(CAR(class_def_12_65));
      {
	 obj_t holder_483;
	 {
	    bool_t test_1631;
	    {
	       bool_t test_1632;
	       {
		  obj_t aux_1633;
		  aux_1633 = CNST_TABLE_REF(((long) 1));
		  test_1632 = (import_67 == aux_1633);
	       }
	       if (test_1632)
		 {
		    test_1631 = ((bool_t) 1);
		 }
	       else
		 {
		    obj_t aux_1636;
		    aux_1636 = CNST_TABLE_REF(((long) 2));
		    test_1631 = (import_67 == aux_1636);
		 }
	    }
	    if (test_1631)
	      {
		 holder_483 = import_parser_53_module_impuse(module_66, class_id_86_482);
	      }
	    else
	      {
		 {
		    obj_t arg1239_494;
		    {
		       obj_t list1241_496;
		       {
			  obj_t arg1242_497;
			  arg1242_497 = MAKE_PAIR(BNIL, BNIL);
			  list1241_496 = MAKE_PAIR(class_id_86_482, arg1242_497);
		       }
		       arg1239_494 = cons__138___r4_pairs_and_lists_6_3(import_67, list1241_496);
		    }
		    produce_module_clause__172_module_module(arg1239_494);
		 }
		 {
		    obj_t list1246_499;
		    list1246_499 = MAKE_PAIR(module_66, BNIL);
		    holder_483 = find_global_223_ast_env(class_id_86_482, list1246_499);
		 }
	      }
	 }
	 {
	    type_t type_484;
	    type_484 = declare_class_type__110_object_class(class_def_12_65, (global_t) (holder_483), BFALSE, final__12_68, src_def_101_69);
	    {
	       obj_t domestic__170_485;
	       domestic__170_485 = memq___r4_pairs_and_lists_6_3(import_67, CNST_TABLE_REF(((long) 3)));
	       {
		  {
		     bool_t test1232_486;
		     test1232_486 = is_a__118___object((obj_t) (type_484), class_object_class);
		     if (test1232_486)
		       {
			  if (CBOOL(domestic__170_485))
			    {
			       make_add_class__155_module_class(holder_483, type_484, src_def_101_69);
			    }
			  else
			    {
			       BUNSPEC;
			    }
			  {
			     obj_t arg1233_487;
			     {
				obj_t arg1234_488;
				{
				   obj_t arg1235_1534;
				   arg1235_1534 = make_fx_procedure(arg12351875_module_class, ((long) 0), ((long) 4));
				   PROCEDURE_SET(arg1235_1534, ((long) 0), class_def_12_65);
				   {
				      obj_t aux_1658;
				      aux_1658 = (obj_t) (type_484);
				      PROCEDURE_SET(arg1235_1534, ((long) 1), aux_1658);
				   }
				   PROCEDURE_SET(arg1235_1534, ((long) 2), src_def_101_69);
				   PROCEDURE_SET(arg1235_1534, ((long) 3), domestic__170_485);
				   arg1234_488 = make_promise_21___r4_control_features_6_9(arg1235_1534);
				}
				{
				   obj_t aux_1664;
				   aux_1664 = (obj_t) (type_484);
				   arg1233_487 = MAKE_PAIR(aux_1664, arg1234_488);
				}
			     }
			     {
				obj_t obj2_1297;
				obj2_1297 = __class_accesses__244_module_class;
				__class_accesses__244_module_class = MAKE_PAIR(arg1233_487, obj2_1297);
			     }
			  }
			  return (obj_t) (type_484);
		       }
		     else
		       {
			  return BUNSPEC;
		       }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_declare_class__247_module_class(obj_t env_1535, obj_t class_def_12_1536, obj_t module_1537, obj_t import_1538, obj_t final__12_1539, obj_t src_def_101_1540)
{
   return declare_class__31_module_class(class_def_12_1536, module_1537, import_1538, CBOOL(final__12_1539), src_def_101_1540);
}


obj_t 
arg12351875_module_class(obj_t env_1541)
{
   {
      obj_t class_def_12_1542;
      obj_t type_1543;
      obj_t src_def_101_1544;
      obj_t domestic__170_1545;
      class_def_12_1542 = PROCEDURE_REF(env_1541, ((long) 0));
      type_1543 = PROCEDURE_REF(env_1541, ((long) 1));
      src_def_101_1544 = PROCEDURE_REF(env_1541, ((long) 2));
      domestic__170_1545 = PROCEDURE_REF(env_1541, ((long) 3));
      {
	 return make_class_accesses__208_object_access(class_def_12_1542, (type_t) (type_1543), src_def_101_1544, CBOOL(domestic__170_1545));
      }
   }
}


obj_t 
declare_wide_class__13_module_class(obj_t class_def_12_70, obj_t module_71, obj_t import_72, obj_t src_def_101_73)
{
   {
      obj_t class_id_86_505;
      class_id_86_505 = id_of_id_112_ast_ident(CAR(class_def_12_70));
      {
	 obj_t holder_506;
	 {
	    bool_t test_1680;
	    {
	       bool_t test_1681;
	       {
		  obj_t aux_1682;
		  aux_1682 = CNST_TABLE_REF(((long) 1));
		  test_1681 = (import_72 == aux_1682);
	       }
	       if (test_1681)
		 {
		    test_1680 = ((bool_t) 1);
		 }
	       else
		 {
		    obj_t aux_1685;
		    aux_1685 = CNST_TABLE_REF(((long) 2));
		    test_1680 = (import_72 == aux_1685);
		 }
	    }
	    if (test_1680)
	      {
		 holder_506 = import_parser_53_module_impuse(module_71, class_id_86_505);
	      }
	    else
	      {
		 {
		    obj_t arg1265_519;
		    {
		       obj_t list1267_521;
		       {
			  obj_t arg1268_522;
			  arg1268_522 = MAKE_PAIR(BNIL, BNIL);
			  list1267_521 = MAKE_PAIR(class_id_86_505, arg1268_522);
		       }
		       arg1265_519 = cons__138___r4_pairs_and_lists_6_3(import_72, list1267_521);
		    }
		    produce_module_clause__172_module_module(arg1265_519);
		 }
		 {
		    obj_t list1271_524;
		    list1271_524 = MAKE_PAIR(module_71, BNIL);
		    holder_506 = find_global_223_ast_env(class_id_86_505, list1271_524);
		 }
	      }
	 }
	 {
	    type_t type_507;
	    {
	       obj_t arg1260_516;
	       arg1260_516 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 4)), BEOA);
	       type_507 = declare_class_type__110_object_class(class_def_12_70, (global_t) (holder_506), arg1260_516, ((bool_t) 0), src_def_101_73);
	    }
	    {
	       obj_t domestic__170_508;
	       domestic__170_508 = memq___r4_pairs_and_lists_6_3(import_72, CNST_TABLE_REF(((long) 3)));
	       {
		  {
		     bool_t test1253_509;
		     test1253_509 = is_a__118___object((obj_t) (type_507), class_object_class);
		     if (test1253_509)
		       {
			  if (CBOOL(domestic__170_508))
			    {
			       make_add_class__155_module_class(holder_506, type_507, src_def_101_73);
			    }
			  else
			    {
			       BUNSPEC;
			    }
			  {
			     obj_t arg1255_510;
			     {
				obj_t arg1256_511;
				{
				   obj_t arg1257_1546;
				   arg1257_1546 = make_fx_procedure(arg12571876_module_class, ((long) 0), ((long) 4));
				   PROCEDURE_SET(arg1257_1546, ((long) 0), class_def_12_70);
				   {
				      obj_t aux_1710;
				      aux_1710 = (obj_t) (type_507);
				      PROCEDURE_SET(arg1257_1546, ((long) 1), aux_1710);
				   }
				   PROCEDURE_SET(arg1257_1546, ((long) 2), src_def_101_73);
				   PROCEDURE_SET(arg1257_1546, ((long) 3), domestic__170_508);
				   arg1256_511 = make_promise_21___r4_control_features_6_9(arg1257_1546);
				}
				{
				   obj_t aux_1716;
				   aux_1716 = (obj_t) (type_507);
				   arg1255_510 = MAKE_PAIR(aux_1716, arg1256_511);
				}
			     }
			     {
				obj_t obj2_1307;
				obj2_1307 = __class_accesses__244_module_class;
				return (__class_accesses__244_module_class = MAKE_PAIR(arg1255_510, obj2_1307),
				   BUNSPEC);
			     }
			  }
		       }
		     else
		       {
			  return BUNSPEC;
		       }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_declare_wide_class__94_module_class(obj_t env_1547, obj_t class_def_12_1548, obj_t module_1549, obj_t import_1550, obj_t src_def_101_1551)
{
   return declare_wide_class__13_module_class(class_def_12_1548, module_1549, import_1550, src_def_101_1551);
}


obj_t 
arg12571876_module_class(obj_t env_1552)
{
   {
      obj_t class_def_12_1553;
      obj_t type_1554;
      obj_t src_def_101_1555;
      obj_t domestic__170_1556;
      class_def_12_1553 = PROCEDURE_REF(env_1552, ((long) 0));
      type_1554 = PROCEDURE_REF(env_1552, ((long) 1));
      src_def_101_1555 = PROCEDURE_REF(env_1552, ((long) 2));
      domestic__170_1556 = PROCEDURE_REF(env_1552, ((long) 3));
      {
	 return make_wide_class_accesses__133_object_access(class_def_12_1553, (type_t) (type_1554), src_def_101_1555, CBOOL(domestic__170_1556));
      }
   }
}


obj_t 
make_add_class__155_module_class(obj_t holder_74, type_t class_75, obj_t src_def_101_76)
{
   {
      obj_t super_529;
      {
	 class_t obj_1308;
	 obj_1308 = (class_t) (class_75);
	 {
	    obj_t aux_1729;
	    {
	       object_t aux_1730;
	       aux_1730 = (object_t) (obj_1308);
	       aux_1729 = OBJECT_WIDENING(aux_1730);
	    }
	    super_529 = (((class_t) CREF(aux_1729))->its_super_214);
	 }
      }
      {
	 obj_t holder_id_229_530;
	 {
	    global_t obj_1309;
	    obj_1309 = (global_t) (holder_74);
	    holder_id_229_530 = (((global_t) CREF(obj_1309))->id);
	 }
	 {
	    obj_t class_id_86_531;
	    class_id_86_531 = (((type_t) CREF(class_75))->id);
	    {
	       obj_t class_module_252_532;
	       {
		  global_t obj_1311;
		  obj_1311 = (global_t) (holder_74);
		  class_module_252_532 = (((global_t) CREF(obj_1311))->module);
	       }
	       {
		  obj_t class_alloc_id_85_533;
		  {
		     obj_t arg1391_619;
		     arg1391_619 = CNST_TABLE_REF(((long) 5));
		     {
			obj_t list1392_620;
			{
			   obj_t arg1396_621;
			   arg1396_621 = MAKE_PAIR(class_id_86_531, BNIL);
			   list1392_620 = MAKE_PAIR(arg1391_619, arg1396_621);
			}
			class_alloc_id_85_533 = symbol_append_197___r4_symbols_6_4(list1392_620);
		     }
		  }
		  {
		     obj_t class_alloc_109_534;
		     {
			obj_t arg1381_613;
			arg1381_613 = CNST_TABLE_REF(((long) 6));
			{
			   obj_t list1383_615;
			   {
			      obj_t arg1385_616;
			      {
				 obj_t arg1388_617;
				 arg1388_617 = MAKE_PAIR(BNIL, BNIL);
				 arg1385_616 = MAKE_PAIR(class_module_252_532, arg1388_617);
			      }
			      list1383_615 = MAKE_PAIR(class_alloc_id_85_533, arg1385_616);
			   }
			   class_alloc_109_534 = cons__138___r4_pairs_and_lists_6_3(arg1381_613, list1383_615);
			}
		     }
		     {
			obj_t hash_535;
			{
			   obj_t aux_1748;
			   {
			      obj_t aux_1749;
			      aux_1749 = CDR(src_def_101_76);
			      aux_1748 = CDR(aux_1749);
			   }
			   hash_535 = get_class_hash_100_module_class(class_id_86_531, aux_1748);
			}
			{
			   {
			      obj_t decl_536;
			      {
				 bool_t test1277_537;
				 test1277_537 = is_a__118___object(super_529, class_object_class);
				 if (test1277_537)
				   {
				      global_t sholder_538;
				      {
					 class_t obj_1317;
					 obj_1317 = (class_t) (super_529);
					 {
					    obj_t aux_1756;
					    {
					       object_t aux_1757;
					       aux_1757 = (object_t) (obj_1317);
					       aux_1756 = OBJECT_WIDENING(aux_1757);
					    }
					    sholder_538 = (((class_t) CREF(aux_1756))->holder);
					 }
				      }
				      {
					 obj_t sholder_id_85_539;
					 sholder_id_85_539 = (((global_t) CREF(sholder_538))->id);
					 {
					    obj_t sholder_module_189_540;
					    sholder_module_189_540 = (((global_t) CREF(sholder_538))->module);
					    {
					       {
						  obj_t arg1278_541;
						  obj_t arg1279_542;
						  arg1278_541 = CNST_TABLE_REF(((long) 7));
						  {
						     obj_t arg1286_548;
						     obj_t arg1287_549;
						     obj_t arg1290_550;
						     obj_t arg1293_551;
						     {
							obj_t arg1307_560;
							obj_t arg1308_561;
							obj_t arg1310_562;
							arg1307_560 = CNST_TABLE_REF(((long) 6));
							arg1308_561 = CNST_TABLE_REF(((long) 8));
							arg1310_562 = CNST_TABLE_REF(((long) 9));
							{
							   obj_t list1312_564;
							   {
							      obj_t arg1313_565;
							      {
								 obj_t arg1314_566;
								 arg1314_566 = MAKE_PAIR(BNIL, BNIL);
								 arg1313_565 = MAKE_PAIR(arg1310_562, arg1314_566);
							      }
							      list1312_564 = MAKE_PAIR(arg1308_561, arg1313_565);
							   }
							   arg1286_548 = cons__138___r4_pairs_and_lists_6_3(arg1307_560, list1312_564);
							}
						     }
						     {
							obj_t arg1316_568;
							arg1316_568 = CNST_TABLE_REF(((long) 10));
							{
							   obj_t list1319_570;
							   {
							      obj_t arg1320_571;
							      arg1320_571 = MAKE_PAIR(BNIL, BNIL);
							      list1319_570 = MAKE_PAIR(class_id_86_531, arg1320_571);
							   }
							   arg1287_549 = cons__138___r4_pairs_and_lists_6_3(arg1316_568, list1319_570);
							}
						     }
						     {
							obj_t arg1322_573;
							arg1322_573 = CNST_TABLE_REF(((long) 6));
							{
							   obj_t list1324_575;
							   {
							      obj_t arg1325_576;
							      {
								 obj_t arg1327_577;
								 arg1327_577 = MAKE_PAIR(BNIL, BNIL);
								 arg1325_576 = MAKE_PAIR(sholder_module_189_540, arg1327_577);
							      }
							      list1324_575 = MAKE_PAIR(sholder_id_85_539, arg1325_576);
							   }
							   arg1290_550 = cons__138___r4_pairs_and_lists_6_3(arg1322_573, list1324_575);
							}
						     }
						     {
							obj_t aux_1780;
							{
							   obj_t aux_1781;
							   aux_1781 = CDR(src_def_101_76);
							   aux_1780 = CDR(aux_1781);
							}
							arg1293_551 = make_class_fields_146_module_class(class_id_86_531, aux_1780);
						     }
						     {
							obj_t list1296_553;
							{
							   obj_t arg1297_554;
							   {
							      obj_t arg1298_555;
							      {
								 obj_t arg1299_556;
								 {
								    obj_t arg1300_557;
								    {
								       obj_t arg1303_558;
								       arg1303_558 = MAKE_PAIR(BNIL, BNIL);
								       arg1300_557 = MAKE_PAIR(arg1293_551, arg1303_558);
								    }
								    arg1299_556 = MAKE_PAIR(hash_535, arg1300_557);
								 }
								 arg1298_555 = MAKE_PAIR(class_alloc_109_534, arg1299_556);
							      }
							      arg1297_554 = MAKE_PAIR(arg1290_550, arg1298_555);
							   }
							   list1296_553 = MAKE_PAIR(arg1287_549, arg1297_554);
							}
							arg1279_542 = cons__138___r4_pairs_and_lists_6_3(arg1286_548, list1296_553);
						     }
						  }
						  {
						     obj_t list1281_544;
						     {
							obj_t arg1282_545;
							{
							   obj_t arg1283_546;
							   arg1283_546 = MAKE_PAIR(BNIL, BNIL);
							   arg1282_545 = MAKE_PAIR(arg1279_542, arg1283_546);
							}
							list1281_544 = MAKE_PAIR(holder_id_229_530, arg1282_545);
						     }
						     decl_536 = cons__138___r4_pairs_and_lists_6_3(arg1278_541, list1281_544);
						  }
					       }
					    }
					 }
				      }
				   }
				 else
				   {
				      obj_t arg1331_580;
				      obj_t arg1332_581;
				      arg1331_580 = CNST_TABLE_REF(((long) 7));
				      {
					 obj_t arg1342_587;
					 obj_t arg1343_588;
					 obj_t arg1345_589;
					 {
					    obj_t arg1357_598;
					    obj_t arg1358_599;
					    obj_t arg1359_600;
					    arg1357_598 = CNST_TABLE_REF(((long) 6));
					    arg1358_599 = CNST_TABLE_REF(((long) 8));
					    arg1359_600 = CNST_TABLE_REF(((long) 9));
					    {
					       obj_t list1362_602;
					       {
						  obj_t arg1363_603;
						  {
						     obj_t arg1364_604;
						     arg1364_604 = MAKE_PAIR(BNIL, BNIL);
						     arg1363_603 = MAKE_PAIR(arg1359_600, arg1364_604);
						  }
						  list1362_602 = MAKE_PAIR(arg1358_599, arg1363_603);
					       }
					       arg1342_587 = cons__138___r4_pairs_and_lists_6_3(arg1357_598, list1362_602);
					    }
					 }
					 {
					    obj_t arg1367_606;
					    arg1367_606 = CNST_TABLE_REF(((long) 10));
					    {
					       obj_t list1370_608;
					       {
						  obj_t arg1372_609;
						  arg1372_609 = MAKE_PAIR(BNIL, BNIL);
						  list1370_608 = MAKE_PAIR(class_id_86_531, arg1372_609);
					       }
					       arg1343_588 = cons__138___r4_pairs_and_lists_6_3(arg1367_606, list1370_608);
					    }
					 }
					 {
					    obj_t aux_1808;
					    {
					       obj_t aux_1809;
					       aux_1809 = CDR(src_def_101_76);
					       aux_1808 = CDR(aux_1809);
					    }
					    arg1345_589 = make_class_fields_146_module_class(class_id_86_531, aux_1808);
					 }
					 {
					    obj_t list1347_591;
					    {
					       obj_t arg1349_592;
					       {
						  obj_t arg1350_593;
						  {
						     obj_t arg1352_594;
						     {
							obj_t arg1353_595;
							{
							   obj_t arg1355_596;
							   arg1355_596 = MAKE_PAIR(BNIL, BNIL);
							   arg1353_595 = MAKE_PAIR(arg1345_589, arg1355_596);
							}
							arg1352_594 = MAKE_PAIR(hash_535, arg1353_595);
						     }
						     arg1350_593 = MAKE_PAIR(class_alloc_109_534, arg1352_594);
						  }
						  arg1349_592 = MAKE_PAIR(BFALSE, arg1350_593);
					       }
					       list1347_591 = MAKE_PAIR(arg1343_588, arg1349_592);
					    }
					    arg1332_581 = cons__138___r4_pairs_and_lists_6_3(arg1342_587, list1347_591);
					 }
				      }
				      {
					 obj_t list1334_583;
					 {
					    obj_t arg1337_584;
					    {
					       obj_t arg1339_585;
					       arg1339_585 = MAKE_PAIR(BNIL, BNIL);
					       arg1337_584 = MAKE_PAIR(arg1332_581, arg1339_585);
					    }
					    list1334_583 = MAKE_PAIR(holder_id_229_530, arg1337_584);
					 }
					 decl_536 = cons__138___r4_pairs_and_lists_6_3(arg1331_580, list1334_583);
				      }
				   }
			      }
			      {
				 obj_t obj2_1329;
				 obj2_1329 = __declared_classes__217_module_class;
				 return (__declared_classes__217_module_class = MAKE_PAIR(decl_536, obj2_1329),
				    BUNSPEC);
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
get_class_hash_100_module_class(obj_t class_id_86_77, obj_t fields_78)
{
   {
      obj_t fields_623;
      long hash_624;
      {
	 long arg1400_626;
	 {
	    obj_t arg1402_627;
	    arg1402_627 = SYMBOL_TO_STRING(class_id_86_77);
	    {
	       char *aux_1826;
	       aux_1826 = BSTRING_TO_STRING(arg1402_627);
	       arg1400_626 = get_hash_power_number(aux_1826, ((long) 16));
	    }
	 }
	 fields_623 = fields_78;
	 hash_624 = arg1400_626;
       loop_625:
	 if (NULLP(fields_623))
	   {
	      return BINT(hash_624);
	   }
	 else
	   {
	      obj_t field_630;
	      field_630 = CAR(fields_623);
	      {
		 obj_t id_645;
		 obj_t att_646;
		 obj_t string_640;
		 obj_t len_641;
		 obj_t id_642;
		 obj_t att_643;
		 obj_t integer_635;
		 obj_t len_636;
		 obj_t id_637;
		 obj_t att_638;
		 obj_t id_632;
		 obj_t att_633;
		 if (SYMBOLP(field_630))
		   {
		      {
			 obj_t arg1447_694;
			 long arg1448_695;
			 arg1447_694 = CDR(fields_623);
			 {
			    long arg1449_696;
			    {
			       obj_t arg1450_697;
			       arg1450_697 = SYMBOL_TO_STRING(field_630);
			       {
				  char *aux_1837;
				  aux_1837 = BSTRING_TO_STRING(arg1450_697);
				  arg1449_696 = get_hash_power_number(aux_1837, ((long) 16));
			       }
			    }
			    arg1448_695 = (hash_624 ^ arg1449_696);
			 }
			 {
			    long hash_1842;
			    obj_t fields_1841;
			    fields_1841 = arg1447_694;
			    hash_1842 = arg1448_695;
			    hash_624 = hash_1842;
			    fields_623 = fields_1841;
			    goto loop_625;
			 }
		      }
		   }
		 else
		   {
		      if (PAIRP(field_630))
			{
			   obj_t cdr_139_72_651;
			   cdr_139_72_651 = CDR(field_630);
			   {
			      bool_t test_1846;
			      {
				 obj_t aux_1849;
				 obj_t aux_1847;
				 aux_1849 = CNST_TABLE_REF(((long) 11));
				 aux_1847 = CAR(field_630);
				 test_1846 = (aux_1847 == aux_1849);
			      }
			      if (test_1846)
				{
				   if (PAIRP(cdr_139_72_651))
				     {
					obj_t car_142_179_654;
					car_142_179_654 = CAR(cdr_139_72_651);
					if (SYMBOLP(car_142_179_654))
					  {
					     id_632 = car_142_179_654;
					     att_633 = CDR(cdr_139_72_651);
					     {
						obj_t arg1453_699;
						long arg1454_700;
						arg1453_699 = CDR(fields_623);
						{
						   long arg1457_701;
						   {
						      obj_t arg1458_702;
						      {
							 obj_t arg1465_705;
							 arg1465_705 = SYMBOL_TO_STRING(id_632);
							 arg1458_702 = string_append(string1884_module_class, arg1465_705);
						      }
						      {
							 char *aux_1860;
							 aux_1860 = BSTRING_TO_STRING(arg1458_702);
							 arg1457_701 = get_hash_power_number(aux_1860, ((long) 16));
						      }
						   }
						   arg1454_700 = (hash_624 ^ arg1457_701);
						}
						{
						   long hash_1865;
						   obj_t fields_1864;
						   fields_1864 = arg1453_699;
						   hash_1865 = arg1454_700;
						   hash_624 = hash_1865;
						   fields_623 = fields_1864;
						   goto loop_625;
						}
					     }
					  }
					else
					  {
					     obj_t car_168_2_657;
					     car_168_2_657 = CAR(field_630);
					     if (SYMBOLP(car_168_2_657))
					       {
						  id_645 = car_168_2_657;
						  att_646 = cdr_139_72_651;
						tag_124_21_647:
						  {
						     obj_t arg1499_730;
						     long arg1500_731;
						     arg1499_730 = CDR(fields_623);
						     {
							long arg1501_732;
							{
							   obj_t arg1505_733;
							   arg1505_733 = SYMBOL_TO_STRING(id_645);
							   {
							      char *aux_1872;
							      aux_1872 = BSTRING_TO_STRING(arg1505_733);
							      arg1501_732 = get_hash_power_number(aux_1872, ((long) 16));
							   }
							}
							arg1500_731 = (hash_624 ^ arg1501_732);
						     }
						     {
							long hash_1877;
							obj_t fields_1876;
							fields_1876 = arg1499_730;
							hash_1877 = arg1500_731;
							hash_624 = hash_1877;
							fields_623 = fields_1876;
							goto loop_625;
						     }
						  }
					       }
					     else
					       {
						  return BFALSE;
					       }
					  }
				     }
				   else
				     {
					obj_t car_194_249_660;
					car_194_249_660 = CAR(field_630);
					if (SYMBOLP(car_194_249_660))
					  {
					     obj_t att_1882;
					     obj_t id_1881;
					     id_1881 = car_194_249_660;
					     att_1882 = cdr_139_72_651;
					     att_646 = att_1882;
					     id_645 = id_1881;
					     goto tag_124_21_647;
					  }
					else
					  {
					     return BFALSE;
					  }
				     }
				}
			      else
				{
				   bool_t test_1883;
				   {
				      obj_t aux_1886;
				      obj_t aux_1884;
				      aux_1886 = CNST_TABLE_REF(((long) 12));
				      aux_1884 = CAR(field_630);
				      test_1883 = (aux_1884 == aux_1886);
				   }
				   if (test_1883)
				     {
					if (PAIRP(cdr_139_72_651))
					  {
					     obj_t car_214_78_666;
					     obj_t cdr_215_28_667;
					     car_214_78_666 = CAR(cdr_139_72_651);
					     cdr_215_28_667 = CDR(cdr_139_72_651);
					     if (PAIRP(cdr_215_28_667))
					       {
						  obj_t car_225_42_669;
						  car_225_42_669 = CAR(cdr_215_28_667);
						  if (SYMBOLP(car_225_42_669))
						    {
						       integer_635 = car_214_78_666;
						       len_636 = car_214_78_666;
						       id_637 = car_225_42_669;
						       att_638 = CDR(cdr_215_28_667);
						       {
							  obj_t arg1466_706;
							  long arg1467_707;
							  arg1466_706 = CDR(fields_623);
							  {
							     long arg1468_708;
							     {
								obj_t arg1470_709;
								{
								   char *arg1474_712;
								   obj_t arg1476_713;
								   arg1474_712 = integer__string_135___r4_numbers_6_5_fixnum((long) CINT(len_636), BNIL);
								   arg1476_713 = SYMBOL_TO_STRING(id_637);
								   {
								      obj_t list1477_714;
								      {
									 obj_t arg1478_715;
									 {
									    obj_t arg1480_716;
									    arg1480_716 = MAKE_PAIR(arg1476_713, BNIL);
									    {
									       obj_t aux_1903;
									       aux_1903 = string_to_bstring(arg1474_712);
									       arg1478_715 = MAKE_PAIR(aux_1903, arg1480_716);
									    }
									 }
									 list1477_714 = MAKE_PAIR(string1885_module_class, arg1478_715);
								      }
								      arg1470_709 = string_append_106___r4_strings_6_7(list1477_714);
								   }
								}
								{
								   char *aux_1908;
								   aux_1908 = BSTRING_TO_STRING(arg1470_709);
								   arg1468_708 = get_hash_power_number(aux_1908, ((long) 16));
								}
							     }
							     arg1467_707 = (hash_624 ^ arg1468_708);
							  }
							  {
							     long hash_1913;
							     obj_t fields_1912;
							     fields_1912 = arg1466_706;
							     hash_1913 = arg1467_707;
							     hash_624 = hash_1913;
							     fields_623 = fields_1912;
							     goto loop_625;
							  }
						       }
						    }
						  else
						    {
						       obj_t car_246_188_673;
						       obj_t cdr_247_56_674;
						       car_246_188_673 = CAR(cdr_139_72_651);
						       cdr_247_56_674 = CDR(cdr_139_72_651);
						       {
							  obj_t car_257_21_675;
							  car_257_21_675 = CAR(cdr_247_56_674);
							  if (SYMBOLP(car_257_21_675))
							    {
							       string_640 = car_246_188_673;
							       len_641 = car_246_188_673;
							       id_642 = car_257_21_675;
							       att_643 = CDR(cdr_247_56_674);
							       {
								  obj_t arg1484_719;
								  long arg1485_720;
								  arg1484_719 = CDR(fields_623);
								  {
								     long arg1486_721;
								     {
									obj_t arg1487_722;
									{
									   obj_t arg1493_725;
									   arg1493_725 = SYMBOL_TO_STRING(id_642);
									   {
									      obj_t list1494_726;
									      {
										 obj_t arg1496_727;
										 {
										    obj_t arg1497_728;
										    arg1497_728 = MAKE_PAIR(arg1493_725, BNIL);
										    arg1496_727 = MAKE_PAIR(len_641, arg1497_728);
										 }
										 list1494_726 = MAKE_PAIR(string1885_module_class, arg1496_727);
									      }
									      arg1487_722 = string_append_106___r4_strings_6_7(list1494_726);
									   }
									}
									{
									   char *aux_1926;
									   aux_1926 = BSTRING_TO_STRING(arg1487_722);
									   arg1486_721 = get_hash_power_number(aux_1926, ((long) 16));
									}
								     }
								     arg1485_720 = (hash_624 ^ arg1486_721);
								  }
								  {
								     long hash_1931;
								     obj_t fields_1930;
								     fields_1930 = arg1484_719;
								     hash_1931 = arg1485_720;
								     hash_624 = hash_1931;
								     fields_623 = fields_1930;
								     goto loop_625;
								  }
							       }
							    }
							  else
							    {
							       obj_t car_268_92_678;
							       car_268_92_678 = CAR(field_630);
							       if (SYMBOLP(car_268_92_678))
								 {
								    obj_t att_1937;
								    obj_t id_1936;
								    id_1936 = car_268_92_678;
								    att_1937 = cdr_139_72_651;
								    att_646 = att_1937;
								    id_645 = id_1936;
								    goto tag_124_21_647;
								 }
							       else
								 {
								    return BFALSE;
								 }
							    }
						       }
						    }
					       }
					     else
					       {
						  obj_t car_285_237_681;
						  car_285_237_681 = CAR(field_630);
						  if (SYMBOLP(car_285_237_681))
						    {
						       obj_t att_1942;
						       obj_t id_1941;
						       id_1941 = car_285_237_681;
						       att_1942 = cdr_139_72_651;
						       att_646 = att_1942;
						       id_645 = id_1941;
						       goto tag_124_21_647;
						    }
						  else
						    {
						       return BFALSE;
						    }
					       }
					  }
					else
					  {
					     obj_t car_302_55_684;
					     car_302_55_684 = CAR(field_630);
					     if (SYMBOLP(car_302_55_684))
					       {
						  obj_t att_1947;
						  obj_t id_1946;
						  id_1946 = car_302_55_684;
						  att_1947 = cdr_139_72_651;
						  att_646 = att_1947;
						  id_645 = id_1946;
						  goto tag_124_21_647;
					       }
					     else
					       {
						  return BFALSE;
					       }
					  }
				     }
				   else
				     {
					obj_t car_319_120_687;
					car_319_120_687 = CAR(field_630);
					if (SYMBOLP(car_319_120_687))
					  {
					     obj_t att_1952;
					     obj_t id_1951;
					     id_1951 = car_319_120_687;
					     att_1952 = cdr_139_72_651;
					     att_646 = att_1952;
					     id_645 = id_1951;
					     goto tag_124_21_647;
					  }
					else
					  {
					     return BFALSE;
					  }
				     }
				}
			   }
			}
		      else
			{
			   return BFALSE;
			}
		   }
	      }
	   }
      }
   }
}


obj_t 
_get_class_hash_217_module_class(obj_t env_1557, obj_t class_id_86_1558, obj_t fields_1559)
{
   return get_class_hash_100_module_class(class_id_86_1558, fields_1559);
}


obj_t 
make_class_fields_146_module_class(obj_t class_id_86_79, obj_t slot_defs_73_80)
{
   if (CBOOL(__reflection___104_engine_param))
     {
	obj_t arg1507_737;
	obj_t arg1509_738;
	arg1507_737 = CNST_TABLE_REF(((long) 13));
	{
	   obj_t arg1513_741;
	   obj_t arg1514_742;
	   if (NULLP(slot_defs_73_80))
	     {
		arg1513_741 = BNIL;
	     }
	   else
	     {
		obj_t head1137_745;
		{
		   obj_t arg1526_756;
		   arg1526_756 = make_slot_field_56_module_class(class_id_86_79, CAR(slot_defs_73_80));
		   head1137_745 = MAKE_PAIR(arg1526_756, BNIL);
		}
		{
		   obj_t l1134_746;
		   obj_t tail1138_747;
		   l1134_746 = CDR(slot_defs_73_80);
		   tail1138_747 = head1137_745;
		 lname1136_748:
		   if (NULLP(l1134_746))
		     {
			arg1513_741 = head1137_745;
		     }
		   else
		     {
			obj_t new_tail1139_204_751;
			{
			   obj_t arg1522_753;
			   arg1522_753 = make_slot_field_56_module_class(class_id_86_79, CAR(l1134_746));
			   new_tail1139_204_751 = MAKE_PAIR(arg1522_753, BNIL);
			}
			SET_CDR(tail1138_747, new_tail1139_204_751);
			{
			   obj_t tail1138_1970;
			   obj_t l1134_1968;
			   l1134_1968 = CDR(l1134_746);
			   tail1138_1970 = new_tail1139_204_751;
			   tail1138_747 = tail1138_1970;
			   l1134_746 = l1134_1968;
			   goto lname1136_748;
			}
		     }
		}
	     }
	   arg1514_742 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
	   arg1509_738 = append_2_18___r4_pairs_and_lists_6_3(arg1513_741, arg1514_742);
	}
	{
	   obj_t list1510_739;
	   list1510_739 = MAKE_PAIR(arg1509_738, BNIL);
	   return cons__138___r4_pairs_and_lists_6_3(arg1507_737, list1510_739);
	}
     }
   else
     {
	return BUNSPEC;
     }
}


bool_t 
read_only__11_module_class(obj_t attr_1019)
{
   {
      obj_t attr_1021;
      attr_1021 = attr_1019;
    loop_1022:
      if (NULLP(attr_1021))
	{
	   return ((bool_t) 0);
	}
      else
	{
	   bool_t test_1978;
	   {
	      obj_t aux_1979;
	      aux_1979 = memq___r4_pairs_and_lists_6_3(CAR(attr_1021), CNST_TABLE_REF(((long) 14)));
	      test_1978 = CBOOL(aux_1979);
	   }
	   if (test_1978)
	     {
		return ((bool_t) 1);
	     }
	   else
	     {
		{
		   obj_t attr_1984;
		   attr_1984 = CDR(attr_1021);
		   attr_1021 = attr_1984;
		   goto loop_1022;
		}
	     }
	}
   }
}


obj_t 
make_slot_field_56_module_class(obj_t class_id_86_1579, obj_t slot_761)
{
   {
      obj_t id_764;
      obj_t att_765;
      obj_t integer_767;
      obj_t len_768;
      obj_t id_769;
      obj_t att_770;
      obj_t string_772;
      obj_t len_773;
      obj_t id_774;
      obj_t att_775;
      obj_t id_777;
      obj_t att_778;
      if (SYMBOLP(slot_761))
	{
	   {
	      obj_t id_826;
	      id_826 = fast_id_of_id_130_ast_ident(slot_761);
	      {
		 obj_t arg1568_827;
		 obj_t arg1570_828;
		 obj_t arg1571_829;
		 obj_t arg1572_830;
		 arg1568_827 = CNST_TABLE_REF(((long) 15));
		 {
		    obj_t arg1582_838;
		    arg1582_838 = CNST_TABLE_REF(((long) 10));
		    {
		       obj_t list1584_840;
		       {
			  obj_t arg1585_841;
			  arg1585_841 = MAKE_PAIR(BNIL, BNIL);
			  list1584_840 = MAKE_PAIR(slot_761, arg1585_841);
		       }
		       arg1570_828 = cons__138___r4_pairs_and_lists_6_3(arg1582_838, list1584_840);
		    }
		 }
		 {
		    obj_t arg1588_843;
		    arg1588_843 = CNST_TABLE_REF(((long) 16));
		    {
		       obj_t list1589_844;
		       {
			  obj_t arg1590_845;
			  {
			     obj_t arg1591_846;
			     arg1591_846 = MAKE_PAIR(id_826, BNIL);
			     arg1590_845 = MAKE_PAIR(arg1588_843, arg1591_846);
			  }
			  list1589_844 = MAKE_PAIR(class_id_86_1579, arg1590_845);
		       }
		       arg1571_829 = symbol_append_197___r4_symbols_6_4(list1589_844);
		    }
		 }
		 {
		    obj_t arg1593_848;
		    arg1593_848 = CNST_TABLE_REF(((long) 16));
		    {
		       obj_t list1596_850;
		       {
			  obj_t arg1597_851;
			  {
			     obj_t arg1600_852;
			     {
				obj_t arg1601_853;
				{
				   obj_t aux_2000;
				   aux_2000 = CNST_TABLE_REF(((long) 17));
				   arg1601_853 = MAKE_PAIR(aux_2000, BNIL);
				}
				arg1600_852 = MAKE_PAIR(id_826, arg1601_853);
			     }
			     arg1597_851 = MAKE_PAIR(arg1593_848, arg1600_852);
			  }
			  list1596_850 = MAKE_PAIR(class_id_86_1579, arg1597_851);
		       }
		       arg1572_830 = symbol_append_197___r4_symbols_6_4(list1596_850);
		    }
		 }
		 {
		    obj_t list1574_832;
		    {
		       obj_t arg1575_833;
		       {
			  obj_t arg1576_834;
			  {
			     obj_t arg1577_835;
			     {
				obj_t arg1578_836;
				arg1578_836 = MAKE_PAIR(BNIL, BNIL);
				arg1577_835 = MAKE_PAIR(BUNSPEC, arg1578_836);
			     }
			     arg1576_834 = MAKE_PAIR(arg1572_830, arg1577_835);
			  }
			  arg1575_833 = MAKE_PAIR(arg1571_829, arg1576_834);
		       }
		       list1574_832 = MAKE_PAIR(arg1570_828, arg1575_833);
		    }
		    return cons__138___r4_pairs_and_lists_6_3(arg1568_827, list1574_832);
		 }
	      }
	   }
	}
      else
	{
	   if (PAIRP(slot_761))
	     {
		obj_t cdr_364_230_783;
		cdr_364_230_783 = CDR(slot_761);
		{
		   bool_t test_2016;
		   {
		      obj_t aux_2019;
		      obj_t aux_2017;
		      aux_2019 = CNST_TABLE_REF(((long) 11));
		      aux_2017 = CAR(slot_761);
		      test_2016 = (aux_2017 == aux_2019);
		   }
		   if (test_2016)
		     {
			if (PAIRP(cdr_364_230_783))
			  {
			     obj_t car_367_38_786;
			     car_367_38_786 = CAR(cdr_364_230_783);
			     if (SYMBOLP(car_367_38_786))
			       {
				  id_764 = car_367_38_786;
				  att_765 = CDR(cdr_364_230_783);
				  {
				     obj_t id_855;
				     id_855 = fast_id_of_id_130_ast_ident(id_764);
				     {
					obj_t arg1604_856;
					obj_t arg1605_857;
					obj_t arg1606_858;
					obj_t arg1608_859;
					obj_t arg1609_860;
					arg1604_856 = CNST_TABLE_REF(((long) 15));
					{
					   obj_t arg1620_868;
					   arg1620_868 = CNST_TABLE_REF(((long) 10));
					   {
					      obj_t list1622_870;
					      {
						 obj_t arg1623_871;
						 arg1623_871 = MAKE_PAIR(BNIL, BNIL);
						 list1622_870 = MAKE_PAIR(id_855, arg1623_871);
					      }
					      arg1605_857 = cons__138___r4_pairs_and_lists_6_3(arg1620_868, list1622_870);
					   }
					}
					{
					   obj_t arg1626_873;
					   arg1626_873 = CNST_TABLE_REF(((long) 16));
					   {
					      obj_t list1628_875;
					      {
						 obj_t arg1630_876;
						 {
						    obj_t arg1632_877;
						    {
						       obj_t arg1634_878;
						       {
							  obj_t aux_2034;
							  aux_2034 = CNST_TABLE_REF(((long) 18));
							  arg1634_878 = MAKE_PAIR(aux_2034, BNIL);
						       }
						       arg1632_877 = MAKE_PAIR(id_855, arg1634_878);
						    }
						    arg1630_876 = MAKE_PAIR(arg1626_873, arg1632_877);
						 }
						 list1628_875 = MAKE_PAIR(class_id_86_1579, arg1630_876);
					      }
					      arg1606_858 = symbol_append_197___r4_symbols_6_4(list1628_875);
					   }
					}
					if (read_only__11_module_class(att_765))
					  {
					     arg1608_859 = BUNSPEC;
					  }
					else
					  {
					     obj_t arg1641_881;
					     arg1641_881 = CNST_TABLE_REF(((long) 16));
					     {
						obj_t list1643_883;
						{
						   obj_t arg1644_884;
						   {
						      obj_t arg1645_885;
						      {
							 obj_t arg1646_886;
							 {
							    obj_t aux_2044;
							    aux_2044 = CNST_TABLE_REF(((long) 17));
							    arg1646_886 = MAKE_PAIR(aux_2044, BNIL);
							 }
							 arg1645_885 = MAKE_PAIR(id_855, arg1646_886);
						      }
						      arg1644_884 = MAKE_PAIR(arg1641_881, arg1645_885);
						   }
						   list1643_883 = MAKE_PAIR(class_id_86_1579, arg1644_884);
						}
						arg1608_859 = symbol_append_197___r4_symbols_6_4(list1643_883);
					     }
					  }
					{
					   obj_t arg1648_888;
					   arg1648_888 = CNST_TABLE_REF(((long) 16));
					   {
					      obj_t list1651_890;
					      {
						 obj_t arg1652_891;
						 {
						    obj_t arg1653_892;
						    {
						       obj_t arg1654_893;
						       {
							  obj_t aux_2052;
							  aux_2052 = CNST_TABLE_REF(((long) 22));
							  arg1654_893 = MAKE_PAIR(aux_2052, BNIL);
						       }
						       arg1653_892 = MAKE_PAIR(id_855, arg1654_893);
						    }
						    arg1652_891 = MAKE_PAIR(arg1648_888, arg1653_892);
						 }
						 list1651_890 = MAKE_PAIR(class_id_86_1579, arg1652_891);
					      }
					      arg1609_860 = symbol_append_197___r4_symbols_6_4(list1651_890);
					   }
					}
					{
					   obj_t list1612_862;
					   {
					      obj_t arg1614_863;
					      {
						 obj_t arg1616_864;
						 {
						    obj_t arg1617_865;
						    {
						       obj_t arg1618_866;
						       arg1618_866 = MAKE_PAIR(BNIL, BNIL);
						       arg1617_865 = MAKE_PAIR(arg1609_860, arg1618_866);
						    }
						    arg1616_864 = MAKE_PAIR(arg1608_859, arg1617_865);
						 }
						 arg1614_863 = MAKE_PAIR(arg1606_858, arg1616_864);
					      }
					      list1612_862 = MAKE_PAIR(arg1605_857, arg1614_863);
					   }
					   return cons__138___r4_pairs_and_lists_6_3(arg1604_856, list1612_862);
					}
				     }
				  }
			       }
			     else
			       {
				  obj_t car_393_111_789;
				  car_393_111_789 = CAR(slot_761);
				  if (SYMBOLP(car_393_111_789))
				    {
				       id_777 = car_393_111_789;
				       att_778 = cdr_364_230_783;
				     tag_349_91_779:
				       {
					  obj_t id_989;
					  id_989 = fast_id_of_id_130_ast_ident(id_777);
					  {
					     obj_t arg1769_990;
					     obj_t arg1770_991;
					     obj_t arg1771_992;
					     obj_t arg1772_993;
					     arg1769_990 = CNST_TABLE_REF(((long) 15));
					     {
						obj_t arg1780_1001;
						arg1780_1001 = CNST_TABLE_REF(((long) 10));
						{
						   obj_t list1782_1003;
						   {
						      obj_t arg1783_1004;
						      arg1783_1004 = MAKE_PAIR(BNIL, BNIL);
						      list1782_1003 = MAKE_PAIR(id_989, arg1783_1004);
						   }
						   arg1770_991 = cons__138___r4_pairs_and_lists_6_3(arg1780_1001, list1782_1003);
						}
					     }
					     {
						obj_t arg1785_1006;
						arg1785_1006 = CNST_TABLE_REF(((long) 16));
						{
						   obj_t list1786_1007;
						   {
						      obj_t arg1788_1008;
						      {
							 obj_t arg1789_1009;
							 arg1789_1009 = MAKE_PAIR(id_989, BNIL);
							 arg1788_1008 = MAKE_PAIR(arg1785_1006, arg1789_1009);
						      }
						      list1786_1007 = MAKE_PAIR(class_id_86_1579, arg1788_1008);
						   }
						   arg1771_992 = symbol_append_197___r4_symbols_6_4(list1786_1007);
						}
					     }
					     if (read_only__11_module_class(att_778))
					       {
						  arg1772_993 = BUNSPEC;
					       }
					     else
					       {
						  obj_t arg1793_1012;
						  arg1793_1012 = CNST_TABLE_REF(((long) 16));
						  {
						     obj_t list1796_1014;
						     {
							obj_t arg1798_1015;
							{
							   obj_t arg1799_1016;
							   {
							      obj_t arg1800_1017;
							      {
								 obj_t aux_2083;
								 aux_2083 = CNST_TABLE_REF(((long) 17));
								 arg1800_1017 = MAKE_PAIR(aux_2083, BNIL);
							      }
							      arg1799_1016 = MAKE_PAIR(id_989, arg1800_1017);
							   }
							   arg1798_1015 = MAKE_PAIR(arg1793_1012, arg1799_1016);
							}
							list1796_1014 = MAKE_PAIR(class_id_86_1579, arg1798_1015);
						     }
						     arg1772_993 = symbol_append_197___r4_symbols_6_4(list1796_1014);
						  }
					       }
					     {
						obj_t list1774_995;
						{
						   obj_t arg1775_996;
						   {
						      obj_t arg1776_997;
						      {
							 obj_t arg1777_998;
							 {
							    obj_t arg1778_999;
							    arg1778_999 = MAKE_PAIR(BNIL, BNIL);
							    arg1777_998 = MAKE_PAIR(BUNSPEC, arg1778_999);
							 }
							 arg1776_997 = MAKE_PAIR(arg1772_993, arg1777_998);
						      }
						      arg1775_996 = MAKE_PAIR(arg1771_992, arg1776_997);
						   }
						   list1774_995 = MAKE_PAIR(arg1770_991, arg1775_996);
						}
						return cons__138___r4_pairs_and_lists_6_3(arg1769_990, list1774_995);
					     }
					  }
				       }
				    }
				  else
				    {
				       return BFALSE;
				    }
			       }
			  }
			else
			  {
			     obj_t car_419_9_792;
			     car_419_9_792 = CAR(slot_761);
			     if (SYMBOLP(car_419_9_792))
			       {
				  obj_t att_2100;
				  obj_t id_2099;
				  id_2099 = car_419_9_792;
				  att_2100 = cdr_364_230_783;
				  att_778 = att_2100;
				  id_777 = id_2099;
				  goto tag_349_91_779;
			       }
			     else
			       {
				  return BFALSE;
			       }
			  }
		     }
		   else
		     {
			bool_t test_2101;
			{
			   obj_t aux_2104;
			   obj_t aux_2102;
			   aux_2104 = CNST_TABLE_REF(((long) 12));
			   aux_2102 = CAR(slot_761);
			   test_2101 = (aux_2102 == aux_2104);
			}
			if (test_2101)
			  {
			     if (PAIRP(cdr_364_230_783))
			       {
				  obj_t car_439_92_798;
				  obj_t cdr_440_29_799;
				  car_439_92_798 = CAR(cdr_364_230_783);
				  cdr_440_29_799 = CDR(cdr_364_230_783);
				  if (PAIRP(cdr_440_29_799))
				    {
				       obj_t car_450_133_801;
				       car_450_133_801 = CAR(cdr_440_29_799);
				       if (SYMBOLP(car_450_133_801))
					 {
					    integer_767 = car_439_92_798;
					    len_768 = car_439_92_798;
					    id_769 = car_450_133_801;
					    att_770 = CDR(cdr_440_29_799);
					    {
					       obj_t id_895;
					       id_895 = fast_id_of_id_130_ast_ident(id_769);
					       {
						  obj_t arg1656_896;
						  obj_t arg1657_897;
						  obj_t arg1659_898;
						  obj_t arg1661_899;
						  obj_t arg1663_900;
						  arg1656_896 = CNST_TABLE_REF(((long) 15));
						  {
						     obj_t arg1674_908;
						     arg1674_908 = CNST_TABLE_REF(((long) 10));
						     {
							obj_t list1678_910;
							{
							   obj_t arg1679_911;
							   arg1679_911 = MAKE_PAIR(BNIL, BNIL);
							   list1678_910 = MAKE_PAIR(id_895, arg1679_911);
							}
							arg1657_897 = cons__138___r4_pairs_and_lists_6_3(arg1674_908, list1678_910);
						     }
						  }
						  {
						     obj_t arg1681_913;
						     arg1681_913 = CNST_TABLE_REF(((long) 16));
						     {
							obj_t list1683_915;
							{
							   obj_t arg1684_916;
							   {
							      obj_t arg1686_917;
							      {
								 obj_t arg1687_918;
								 {
								    obj_t aux_2123;
								    aux_2123 = CNST_TABLE_REF(((long) 18));
								    arg1687_918 = MAKE_PAIR(aux_2123, BNIL);
								 }
								 arg1686_917 = MAKE_PAIR(id_895, arg1687_918);
							      }
							      arg1684_916 = MAKE_PAIR(arg1681_913, arg1686_917);
							   }
							   list1683_915 = MAKE_PAIR(class_id_86_1579, arg1684_916);
							}
							arg1659_898 = symbol_append_197___r4_symbols_6_4(list1683_915);
						     }
						  }
						  if (read_only__11_module_class(att_770))
						    {
						       arg1661_899 = BUNSPEC;
						    }
						  else
						    {
						       obj_t arg1690_921;
						       arg1690_921 = CNST_TABLE_REF(((long) 16));
						       {
							  obj_t list1692_923;
							  {
							     obj_t arg1693_924;
							     {
								obj_t arg1694_925;
								{
								   obj_t arg1695_926;
								   {
								      obj_t aux_2133;
								      aux_2133 = CNST_TABLE_REF(((long) 17));
								      arg1695_926 = MAKE_PAIR(aux_2133, BNIL);
								   }
								   arg1694_925 = MAKE_PAIR(id_895, arg1695_926);
								}
								arg1693_924 = MAKE_PAIR(arg1690_921, arg1694_925);
							     }
							     list1692_923 = MAKE_PAIR(class_id_86_1579, arg1693_924);
							  }
							  arg1661_899 = symbol_append_197___r4_symbols_6_4(list1692_923);
						       }
						    }
						  {
						     obj_t arg1697_928;
						     obj_t arg1698_929;
						     arg1697_928 = CNST_TABLE_REF(((long) 19));
						     {
							obj_t arg1704_935;
							arg1704_935 = CNST_TABLE_REF(((long) 20));
							{
							   obj_t list1706_937;
							   list1706_937 = MAKE_PAIR(BNIL, BNIL);
							   arg1698_929 = cons__138___r4_pairs_and_lists_6_3(arg1704_935, list1706_937);
							}
						     }
						     {
							obj_t list1700_931;
							{
							   obj_t arg1701_932;
							   {
							      obj_t arg1702_933;
							      arg1702_933 = MAKE_PAIR(BNIL, BNIL);
							      arg1701_932 = MAKE_PAIR(len_768, arg1702_933);
							   }
							   list1700_931 = MAKE_PAIR(arg1698_929, arg1701_932);
							}
							arg1663_900 = cons__138___r4_pairs_and_lists_6_3(arg1697_928, list1700_931);
						     }
						  }
						  {
						     obj_t list1665_902;
						     {
							obj_t arg1667_903;
							{
							   obj_t arg1668_904;
							   {
							      obj_t arg1669_905;
							      {
								 obj_t arg1671_906;
								 arg1671_906 = MAKE_PAIR(BNIL, BNIL);
								 arg1669_905 = MAKE_PAIR(arg1663_900, arg1671_906);
							      }
							      arg1668_904 = MAKE_PAIR(arg1661_899, arg1669_905);
							   }
							   arg1667_903 = MAKE_PAIR(arg1659_898, arg1668_904);
							}
							list1665_902 = MAKE_PAIR(arg1657_897, arg1667_903);
						     }
						     return cons__138___r4_pairs_and_lists_6_3(arg1656_896, list1665_902);
						  }
					       }
					    }
					 }
				       else
					 {
					    obj_t car_471_231_805;
					    obj_t cdr_472_34_806;
					    car_471_231_805 = CAR(cdr_364_230_783);
					    cdr_472_34_806 = CDR(cdr_364_230_783);
					    {
					       obj_t car_482_151_807;
					       car_482_151_807 = CAR(cdr_472_34_806);
					       if (SYMBOLP(car_482_151_807))
						 {
						    string_772 = car_471_231_805;
						    len_773 = car_471_231_805;
						    id_774 = car_482_151_807;
						    att_775 = CDR(cdr_472_34_806);
						    {
						       obj_t id_939;
						       id_939 = fast_id_of_id_130_ast_ident(id_774);
						       {
							  obj_t arg1708_940;
							  obj_t arg1709_941;
							  obj_t arg1710_942;
							  obj_t arg1711_943;
							  obj_t arg1712_944;
							  arg1708_940 = CNST_TABLE_REF(((long) 15));
							  {
							     obj_t arg1721_952;
							     arg1721_952 = CNST_TABLE_REF(((long) 10));
							     {
								obj_t list1723_954;
								{
								   obj_t arg1724_955;
								   arg1724_955 = MAKE_PAIR(BNIL, BNIL);
								   list1723_954 = MAKE_PAIR(id_939, arg1724_955);
								}
								arg1709_941 = cons__138___r4_pairs_and_lists_6_3(arg1721_952, list1723_954);
							     }
							  }
							  {
							     obj_t arg1730_957;
							     arg1730_957 = CNST_TABLE_REF(((long) 16));
							     {
								obj_t list1732_959;
								{
								   obj_t arg1733_960;
								   {
								      obj_t arg1734_961;
								      {
									 obj_t arg1735_962;
									 {
									    obj_t aux_2167;
									    aux_2167 = CNST_TABLE_REF(((long) 18));
									    arg1735_962 = MAKE_PAIR(aux_2167, BNIL);
									 }
									 arg1734_961 = MAKE_PAIR(id_939, arg1735_962);
								      }
								      arg1733_960 = MAKE_PAIR(arg1730_957, arg1734_961);
								   }
								   list1732_959 = MAKE_PAIR(class_id_86_1579, arg1733_960);
								}
								arg1710_942 = symbol_append_197___r4_symbols_6_4(list1732_959);
							     }
							  }
							  if (read_only__11_module_class(att_775))
							    {
							       arg1711_943 = BUNSPEC;
							    }
							  else
							    {
							       obj_t arg1738_965;
							       arg1738_965 = CNST_TABLE_REF(((long) 16));
							       {
								  obj_t list1741_967;
								  {
								     obj_t arg1742_968;
								     {
									obj_t arg1743_969;
									{
									   obj_t arg1745_970;
									   {
									      obj_t aux_2177;
									      aux_2177 = CNST_TABLE_REF(((long) 17));
									      arg1745_970 = MAKE_PAIR(aux_2177, BNIL);
									   }
									   arg1743_969 = MAKE_PAIR(id_939, arg1745_970);
									}
									arg1742_968 = MAKE_PAIR(arg1738_965, arg1743_969);
								     }
								     list1741_967 = MAKE_PAIR(class_id_86_1579, arg1742_968);
								  }
								  arg1711_943 = symbol_append_197___r4_symbols_6_4(list1741_967);
							       }
							    }
							  {
							     obj_t arg1747_972;
							     obj_t arg1748_973;
							     obj_t arg1749_974;
							     arg1747_972 = CNST_TABLE_REF(((long) 19));
							     {
								obj_t arg1756_980;
								arg1756_980 = CNST_TABLE_REF(((long) 20));
								{
								   obj_t list1759_982;
								   list1759_982 = MAKE_PAIR(BNIL, BNIL);
								   arg1748_973 = cons__138___r4_pairs_and_lists_6_3(arg1756_980, list1759_982);
								}
							     }
							     {
								obj_t arg1762_984;
								arg1762_984 = CNST_TABLE_REF(((long) 21));
								{
								   obj_t list1764_986;
								   {
								      obj_t arg1766_987;
								      arg1766_987 = MAKE_PAIR(BNIL, BNIL);
								      list1764_986 = MAKE_PAIR(len_773, arg1766_987);
								   }
								   arg1749_974 = cons__138___r4_pairs_and_lists_6_3(arg1762_984, list1764_986);
								}
							     }
							     {
								obj_t list1752_976;
								{
								   obj_t arg1753_977;
								   {
								      obj_t arg1754_978;
								      arg1754_978 = MAKE_PAIR(BNIL, BNIL);
								      arg1753_977 = MAKE_PAIR(arg1749_974, arg1754_978);
								   }
								   list1752_976 = MAKE_PAIR(arg1748_973, arg1753_977);
								}
								arg1712_944 = cons__138___r4_pairs_and_lists_6_3(arg1747_972, list1752_976);
							     }
							  }
							  {
							     obj_t list1715_946;
							     {
								obj_t arg1716_947;
								{
								   obj_t arg1717_948;
								   {
								      obj_t arg1718_949;
								      {
									 obj_t arg1719_950;
									 arg1719_950 = MAKE_PAIR(BNIL, BNIL);
									 arg1718_949 = MAKE_PAIR(arg1712_944, arg1719_950);
								      }
								      arg1717_948 = MAKE_PAIR(arg1711_943, arg1718_949);
								   }
								   arg1716_947 = MAKE_PAIR(arg1710_942, arg1717_948);
								}
								list1715_946 = MAKE_PAIR(arg1709_941, arg1716_947);
							     }
							     return cons__138___r4_pairs_and_lists_6_3(arg1708_940, list1715_946);
							  }
						       }
						    }
						 }
					       else
						 {
						    obj_t car_493_7_810;
						    car_493_7_810 = CAR(slot_761);
						    if (SYMBOLP(car_493_7_810))
						      {
							 obj_t att_2207;
							 obj_t id_2206;
							 id_2206 = car_493_7_810;
							 att_2207 = cdr_364_230_783;
							 att_778 = att_2207;
							 id_777 = id_2206;
							 goto tag_349_91_779;
						      }
						    else
						      {
							 return BFALSE;
						      }
						 }
					    }
					 }
				    }
				  else
				    {
				       obj_t car_510_26_813;
				       car_510_26_813 = CAR(slot_761);
				       if (SYMBOLP(car_510_26_813))
					 {
					    obj_t att_2212;
					    obj_t id_2211;
					    id_2211 = car_510_26_813;
					    att_2212 = cdr_364_230_783;
					    att_778 = att_2212;
					    id_777 = id_2211;
					    goto tag_349_91_779;
					 }
				       else
					 {
					    return BFALSE;
					 }
				    }
			       }
			     else
			       {
				  obj_t car_527_41_816;
				  car_527_41_816 = CAR(slot_761);
				  if (SYMBOLP(car_527_41_816))
				    {
				       obj_t att_2217;
				       obj_t id_2216;
				       id_2216 = car_527_41_816;
				       att_2217 = cdr_364_230_783;
				       att_778 = att_2217;
				       id_777 = id_2216;
				       goto tag_349_91_779;
				    }
				  else
				    {
				       return BFALSE;
				    }
			       }
			  }
			else
			  {
			     obj_t car_544_13_819;
			     car_544_13_819 = CAR(slot_761);
			     if (SYMBOLP(car_544_13_819))
			       {
				  obj_t att_2222;
				  obj_t id_2221;
				  id_2221 = car_544_13_819;
				  att_2222 = cdr_364_230_783;
				  att_778 = att_2222;
				  id_777 = id_2221;
				  goto tag_349_91_779;
			       }
			     else
			       {
				  return BFALSE;
			       }
			  }
		     }
		}
	     }
	   else
	     {
		return BFALSE;
	     }
	}
   }
}


obj_t 
class_finalizer_253_module_class()
{
   {
      bool_t test1808_1030;
      {
	 bool_t test1821_1039;
	 {
	    obj_t obj_1470;
	    obj_1470 = __declared_classes__217_module_class;
	    test1821_1039 = NULLP(obj_1470);
	 }
	 if (test1821_1039)
	   {
	      obj_t obj_1471;
	      obj_1471 = __class_accesses__244_module_class;
	      test1808_1030 = NULLP(obj_1471);
	   }
	 else
	   {
	      test1808_1030 = ((bool_t) 0);
	   }
      }
      if (test1808_1030)
	{
	   return CNST_TABLE_REF(((long) 23));
	}
      else
	{
	   {
	      obj_t arg1809_1031;
	      {
		 obj_t arg1812_1034;
		 obj_t arg1814_1036;
		 arg1812_1034 = CNST_TABLE_REF(((long) 20));
		 {
		    obj_t arg1819_1037;
		    obj_t arg1820_1038;
		    arg1819_1037 = reverse__39___r4_pairs_and_lists_6_3(__declared_classes__217_module_class);
		    arg1820_1038 = force_class_accesses_39_module_class();
		    arg1814_1036 = append_2_18___r4_pairs_and_lists_6_3(arg1819_1037, arg1820_1038);
		 }
		 {
		    obj_t new_1476;
		    {
		       obj_t aux_2232;
		       aux_2232 = CNST_TABLE_REF(((long) 24));
		       new_1476 = create_struct(aux_2232, ((long) 4));
		    }
		    STRUCT_SET(new_1476, ((long) 3), BTRUE);
		    STRUCT_SET(new_1476, ((long) 2), arg1814_1036);
		    {
		       obj_t aux_2237;
		       aux_2237 = BINT(((long) 10));
		       STRUCT_SET(new_1476, ((long) 1), aux_2237);
		    }
		    STRUCT_SET(new_1476, ((long) 0), arg1812_1034);
		    arg1809_1031 = new_1476;
		 }
	      }
	      {
		 obj_t list1810_1032;
		 list1810_1032 = MAKE_PAIR(arg1809_1031, BNIL);
		 return list1810_1032;
	      }
	   }
	}
   }
}


obj_t 
_class_finalizer_205_module_class(obj_t env_1560)
{
   return class_finalizer_253_module_class();
}


obj_t 
force_class_accesses_39_module_class()
{
   {
      obj_t futurs_1040;
      futurs_1040 = MAKE_CELL(BUNSPEC);
      {
	 obj_t aux_1578;
	 aux_1578 = reverse__39___r4_pairs_and_lists_6_3(__class_accesses__244_module_class);
	 CELL_SET(futurs_1040, aux_1578);
      }
      {
	 obj_t arg1824_1564;
	 obj_t arg1823_1567;
	 arg1824_1564 = make_fx_procedure(arg18241880_module_class, ((long) 1), ((long) 1));
	 arg1823_1567 = proc1886_module_class;
	 PROCEDURE_SET(arg1824_1564, ((long) 0), futurs_1040);
	 return laap1878_module_class(futurs_1040, BNIL, arg1823_1567, arg1824_1564);
      }
   }
}


obj_t 
laap1878_module_class(obj_t futurs_1568, obj_t accesses_1056, obj_t pred__61_1057, obj_t done_1058)
{
   return loop1879_module_class(done_1058, pred__61_1057, CELL_REF(futurs_1568), accesses_1056);
}


obj_t 
loop1879_module_class(obj_t done_1570, obj_t pred__61_1569, obj_t futur_1060, obj_t accesses_1061)
{
 loop1879_module_class:
   if (NULLP(futur_1060))
     {
	return PROCEDURE_ENTRY(done_1570) (done_1570, accesses_1061, BEOA);
     }
   else
     {
	obj_t arg1832_1064;
	obj_t arg1833_1065;
	arg1832_1064 = CDR(futur_1060);
	{
	   bool_t test1834_1067;
	   {
	      obj_t aux_2253;
	      {
		 obj_t aux_2254;
		 {
		    obj_t aux_2255;
		    aux_2255 = CAR(futur_1060);
		    aux_2254 = CAR(aux_2255);
		 }
		 aux_2253 = PROCEDURE_ENTRY(pred__61_1569) (pred__61_1569, aux_2254, BEOA);
	      }
	      test1834_1067 = CBOOL(aux_2253);
	   }
	   if (test1834_1067)
	     {
		obj_t new_1068;
		{
		   obj_t arg1836_1070;
		   {
		      obj_t aux_2262;
		      aux_2262 = CAR(futur_1060);
		      arg1836_1070 = CDR(aux_2262);
		   }
		   new_1068 = PROCEDURE_ENTRY(arg1836_1070) (arg1836_1070, BEOA);
		}
		if (PAIRP(new_1068))
		  {
		     arg1833_1065 = append_2_18___r4_pairs_and_lists_6_3(new_1068, accesses_1061);
		  }
		else
		  {
		     arg1833_1065 = accesses_1061;
		  }
	     }
	   else
	     {
		arg1833_1065 = accesses_1061;
	     }
	}
	{
	   obj_t accesses_2271;
	   obj_t futur_2270;
	   futur_2270 = arg1832_1064;
	   accesses_2271 = arg1833_1065;
	   accesses_1061 = accesses_2271;
	   futur_1060 = futur_2270;
	   goto loop1879_module_class;
	}
     }
}


obj_t 
arg18241880_module_class(obj_t env_1571, obj_t accesses_1573)
{
   {
      obj_t futurs_1572;
      futurs_1572 = PROCEDURE_REF(env_1571, ((long) 0));
      {
	 obj_t accesses_1048;
	 accesses_1048 = accesses_1573;
	 {
	    obj_t arg1828_1563;
	    arg1828_1563 = proc1887_module_class;
	    return laap1878_module_class(futurs_1572, accesses_1048, wide_class__env_189_object_class, arg1828_1563);
	 }
      }
   }
}


obj_t 
arg18231882_module_class(obj_t env_1574, obj_t class_1575)
{
   {
      obj_t class_1045;
      {
	 bool_t aux_2274;
	 class_1045 = class_1575;
	 {
	    bool_t test1826_1500;
	    test1826_1500 = wide_class__100_object_class(class_1045);
	    if (test1826_1500)
	      {
		 aux_2274 = ((bool_t) 0);
	      }
	    else
	      {
		 aux_2274 = ((bool_t) 1);
	      }
	 }
	 return BBOOL(aux_2274);
      }
   }
}


obj_t 
arg18281881_module_class(obj_t env_1576, obj_t accesses_1577)
{
   {
      obj_t accesses_1502;
      accesses_1502 = accesses_1577;
      return accesses_1502;
   }
}


obj_t 
imported_modules_init_94_module_class()
{
   module_initialization_70_tools_trace(((long) 0), "MODULE_CLASS");
   module_initialization_70_module_module(((long) 0), "MODULE_CLASS");
   module_initialization_70_module_impuse(((long) 0), "MODULE_CLASS");
   module_initialization_70_engine_param(((long) 0), "MODULE_CLASS");
   module_initialization_70_tools_shape(((long) 0), "MODULE_CLASS");
   module_initialization_70_type_type(((long) 0), "MODULE_CLASS");
   module_initialization_70_type_env(((long) 0), "MODULE_CLASS");
   module_initialization_70_ast_ident(((long) 0), "MODULE_CLASS");
   module_initialization_70_ast_var(((long) 0), "MODULE_CLASS");
   module_initialization_70_ast_env(((long) 0), "MODULE_CLASS");
   module_initialization_70_object_class(((long) 0), "MODULE_CLASS");
   return module_initialization_70_object_access(((long) 0), "MODULE_CLASS");
}
