/*===========================================================================*/
/*   (Module/eval.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;


static obj_t eval_parser_66_module_eval(obj_t, obj_t);
static obj_t arg14471599_module_eval(obj_t, obj_t);
static obj_t _eval_producer_136_module_eval(obj_t, obj_t);
extern obj_t get_toplevel_unit_weight_75_module_include();
extern obj_t scnst_ast_var;
extern obj_t global_ast_var;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_module_eval();
extern obj_t module_initialization_70_module_eval(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_include(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_glo_decl_237(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern obj_t make_eval_compiler_154_module_eval();
static obj_t toplevel_init_63_module_eval();
static obj_t cnst_init_137_module_eval();
extern obj_t ccomp_module_module;
static obj_t eval_producer_250_module_eval(obj_t);
extern obj_t __module__166_module_module;
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t _eval_finalizer_230_module_eval(obj_t);
static obj_t require_initialization_114_module_eval = BUNSPEC;
static obj_t eval_finalizer_221_module_eval();
extern node_t define_primop__node_141_ast_sexp(global_t);
static obj_t library_modules_init_112_module_eval();
extern obj_t _make_eval_compiler_216_module_eval(obj_t);
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t __lib_mode__85_engine_param;
static obj_t get_evaluated_globals_117_module_eval();
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t arg13121596_module_eval(obj_t, obj_t, obj_t);
static obj_t __eval_exported__84_module_eval = BUNSPEC;
extern obj_t find_location_120_tools_location(obj_t);
extern long class_num_218___object(obj_t);
static obj_t remember_eval_exported__63_module_eval(obj_t, obj_t, obj_t);
static obj_t arg13111597_module_eval(obj_t, obj_t, obj_t);
extern obj_t make_promise_21___r4_control_features_6_9(obj_t);
extern obj_t svar_ast_var;
static bool_t __all_eval___198_module_eval;
extern obj_t for_each_global__88_ast_env(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t arg14101598_module_eval(obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern global_t declare_global_svar__200_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t);
extern node_t define_primop_ref__node_164_ast_sexp(global_t, node_t);
static bool_t __one_eval___78_module_eval;
extern node_t location__node_25_ast_sexp(global_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
static obj_t __cnst[11];

DEFINE_EXPORT_PROCEDURE(make_eval_compiler_env_58_module_eval, _make_eval_compiler_216_module_eval1616, _make_eval_compiler_216_module_eval, 0L, 0);
DEFINE_STRING(string1608_module_eval, string1608_module_eval1617, "Unbound variable", 16);
DEFINE_STATIC_PROCEDURE(eval_finalizer_env_4_module_eval, _eval_finalizer_230_module_eval1618, _eval_finalizer_230_module_eval, 0L, 0);
DEFINE_STRING(string1607_module_eval, string1607_module_eval1619, "This variable cannot be known by eval", 37);
DEFINE_STRING(string1609_module_eval, string1609_module_eval1620, "(IMPORT STATIC EXPORT) (#unspecified) WRITE BEGIN VOID UNIT IMPORT @ EXPORT EXPORT-ALL EVAL ", 92);
DEFINE_STATIC_PROCEDURE(proc1600_module_eval, arg13121596_module_eval1621, arg13121596_module_eval, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1601_module_eval, arg13111597_module_eval1622, arg13111597_module_eval, 0L, 2);
DEFINE_STRING(string1604_module_eval, string1604_module_eval1623, "Illegal `eval clause'", 21);
DEFINE_STATIC_PROCEDURE(proc1605_module_eval, arg14101598_module_eval1624, arg14101598_module_eval, 0L, 0);
DEFINE_STATIC_PROCEDURE(eval_producer_env_150_module_eval, _eval_producer_136_module_eval1625, _eval_producer_136_module_eval, 0L, 1);
DEFINE_STRING(string1603_module_eval, string1603_module_eval1626, "Parse error", 11);
DEFINE_STRING(string1606_module_eval, string1606_module_eval1627, "eval-init", 9);
DEFINE_STRING(string1602_module_eval, string1602_module_eval1628, "Illegal `eval' clause", 21);

obj_t 
module_initialization_70_module_eval(long checksum_1409, char *from_1410)
{
   if (CBOOL(require_initialization_114_module_eval))
     {
	require_initialization_114_module_eval = BBOOL(((bool_t) 0));
	library_modules_init_112_module_eval();
	cnst_init_137_module_eval();
	imported_modules_init_94_module_eval();
	toplevel_init_63_module_eval();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_module_eval()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_EVAL");
   module_initialization_70___object(((long) 0), "MODULE_EVAL");
   module_initialization_70___reader(((long) 0), "MODULE_EVAL");
   module_initialization_70___r4_control_features_6_9(((long) 0), "MODULE_EVAL");
   module_initialization_70___r4_strings_6_7(((long) 0), "MODULE_EVAL");
   return BUNSPEC;
}


obj_t 
cnst_init_137_module_eval()
{
   {
      obj_t cnst_port_138_1401;
      cnst_port_138_1401 = open_input_string(string1609_module_eval);
      {
	 long i_1402;
	 i_1402 = ((long) 10);
       loop_1403:
	 {
	    bool_t test1610_1404;
	    test1610_1404 = (i_1402 == ((long) -1));
	    if (test1610_1404)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1611_1405;
		    {
		       obj_t list1612_1406;
		       {
			  obj_t arg1614_1407;
			  arg1614_1407 = BNIL;
			  list1612_1406 = MAKE_PAIR(cnst_port_138_1401, arg1614_1407);
		       }
		       arg1611_1405 = read___reader(list1612_1406);
		    }
		    CNST_TABLE_SET(i_1402, arg1611_1405);
		 }
		 {
		    int aux_1408;
		    {
		       long aux_1429;
		       aux_1429 = (i_1402 - ((long) 1));
		       aux_1408 = (int) (aux_1429);
		    }
		    {
		       long i_1432;
		       i_1432 = (long) (aux_1408);
		       i_1402 = i_1432;
		       goto loop_1403;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_module_eval()
{
   __eval_exported__84_module_eval = BNIL;
   __all_eval___198_module_eval = ((bool_t) 0);
   return (__one_eval___78_module_eval = ((bool_t) 0),
      BUNSPEC);
}


obj_t 
make_eval_compiler_154_module_eval()
{
   {
      obj_t arg1310_682;
      arg1310_682 = CNST_TABLE_REF(((long) 0));
      {
	 obj_t arg1312_1380;
	 obj_t arg1311_1381;
	 arg1312_1380 = proc1600_module_eval;
	 arg1311_1381 = proc1601_module_eval;
	 {
	    ccomp_t res1594_1230;
	    {
	       ccomp_t new1273_1221;
	       new1273_1221 = ((ccomp_t) BREF(GC_MALLOC(sizeof(struct ccomp))));
	       {
		  long arg1498_1222;
		  arg1498_1222 = class_num_218___object(ccomp_module_module);
		  {
		     obj_t obj_1228;
		     obj_1228 = (obj_t) (new1273_1221);
		     (((obj_t) CREF(obj_1228))->header = MAKE_HEADER(arg1498_1222, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_1439;
		  aux_1439 = (object_t) (new1273_1221);
		  OBJECT_WIDENING_SET(aux_1439, BFALSE);
	       }
	       ((((ccomp_t) CREF(new1273_1221))->id) = ((obj_t) arg1310_682), BUNSPEC);
	       ((((ccomp_t) CREF(new1273_1221))->producer) = ((obj_t) eval_producer_env_150_module_eval), BUNSPEC);
	       ((((ccomp_t) CREF(new1273_1221))->consumer) = ((obj_t) arg1311_1381), BUNSPEC);
	       ((((ccomp_t) CREF(new1273_1221))->finalizer) = ((obj_t) eval_finalizer_env_4_module_eval), BUNSPEC);
	       ((((ccomp_t) CREF(new1273_1221))->checksummer) = ((obj_t) arg1312_1380), BUNSPEC);
	       res1594_1230 = new1273_1221;
	    }
	    return (obj_t) (res1594_1230);
	 }
      }
   }
}


obj_t 
_make_eval_compiler_216_module_eval(obj_t env_1382)
{
   return make_eval_compiler_154_module_eval();
}


obj_t 
arg13121596_module_eval(obj_t env_1383, obj_t m_1384, obj_t c_1385)
{
   {
      obj_t m_688;
      obj_t c_689;
      m_688 = m_1384;
      c_689 = c_1385;
      return c_689;
   }
}


obj_t 
arg13111597_module_eval(obj_t env_1386, obj_t m_1387, obj_t c_1388)
{
   {
      obj_t m_685;
      obj_t c_686;
      m_685 = m_1387;
      c_686 = c_1388;
      return BNIL;
   }
}


obj_t 
eval_producer_250_module_eval(obj_t clause_19)
{
   {
      obj_t protos_693;
      if (PAIRP(clause_19))
	{
	   protos_693 = CDR(clause_19);
	   {
	      obj_t l1276_699;
	      l1276_699 = protos_693;
	    lname1283_700:
	      if (PAIRP(l1276_699))
		{
		   eval_parser_66_module_eval(CAR(l1276_699), clause_19);
		   {
		      obj_t l1276_1455;
		      l1276_1455 = CDR(l1276_699);
		      l1276_699 = l1276_1455;
		      goto lname1283_700;
		   }
		}
	      else
		{
		   ((bool_t) 1);
		}
	   }
	   return BNIL;
	}
      else
	{
	   {
	      obj_t arg1320_705;
	      {
		 obj_t list1324_709;
		 list1324_709 = MAKE_PAIR(string1602_module_eval, BNIL);
		 arg1320_705 = string_append_106___r4_strings_6_7(list1324_709);
	      }
	      {
		 obj_t list1322_707;
		 list1322_707 = MAKE_PAIR(BNIL, BNIL);
		 return user_error_151_tools_error(string1603_module_eval, arg1320_705, clause_19, list1322_707);
	      }
	   }
	}
   }
}


obj_t 
_eval_producer_136_module_eval(obj_t env_1389, obj_t clause_1390)
{
   return eval_producer_250_module_eval(clause_1390);
}


obj_t 
eval_parser_66_module_eval(obj_t proto_20, obj_t clause_21)
{
   {
      if (PAIRP(proto_20))
	{
	   bool_t test_1465;
	   {
	      obj_t aux_1468;
	      obj_t aux_1466;
	      aux_1468 = CNST_TABLE_REF(((long) 1));
	      aux_1466 = CAR(proto_20);
	      test_1465 = (aux_1466 == aux_1468);
	   }
	   if (test_1465)
	     {
		bool_t test_1471;
		{
		   obj_t aux_1472;
		   aux_1472 = CDR(proto_20);
		   test_1471 = (aux_1472 == BNIL);
		}
		if (test_1471)
		  {
		     return (__all_eval___198_module_eval = ((bool_t) 1),
			BUNSPEC);
		  }
		else
		  {
		   tag_113_246_720:
		     {
			obj_t list1383_774;
			list1383_774 = MAKE_PAIR(BNIL, BNIL);
			return user_error_151_tools_error(string1603_module_eval, string1604_module_eval, clause_21, list1383_774);
		     }
		  }
	     }
	   else
	     {
		obj_t cdr_132_143_727;
		cdr_132_143_727 = CDR(proto_20);
		{
		   bool_t test_1478;
		   {
		      obj_t aux_1481;
		      obj_t aux_1479;
		      aux_1481 = CNST_TABLE_REF(((long) 2));
		      aux_1479 = CAR(proto_20);
		      test_1478 = (aux_1479 == aux_1481);
		   }
		   if (test_1478)
		     {
			if (PAIRP(cdr_132_143_727))
			  {
			     obj_t car_134_159_730;
			     car_134_159_730 = CAR(cdr_132_143_727);
			     if (SYMBOLP(car_134_159_730))
			       {
				  bool_t test_1489;
				  {
				     obj_t aux_1490;
				     aux_1490 = CDR(cdr_132_143_727);
				     test_1489 = (aux_1490 == BNIL);
				  }
				  if (test_1489)
				    {
				       __one_eval___78_module_eval = ((bool_t) 1);
				       return remember_eval_exported__63_module_eval(car_134_159_730, __module__166_module_module, proto_20);
				    }
				  else
				    {
				       goto tag_113_246_720;
				    }
			       }
			     else
			       {
				  obj_t car_153_175_736;
				  car_153_175_736 = CAR(cdr_132_143_727);
				  if (PAIRP(car_153_175_736))
				    {
				       obj_t cdr_158_238_738;
				       cdr_158_238_738 = CDR(car_153_175_736);
				       {
					  bool_t test_1498;
					  {
					     obj_t aux_1501;
					     obj_t aux_1499;
					     aux_1501 = CNST_TABLE_REF(((long) 3));
					     aux_1499 = CAR(car_153_175_736);
					     test_1498 = (aux_1499 == aux_1501);
					  }
					  if (test_1498)
					    {
					       if (PAIRP(cdr_158_238_738))
						 {
						    obj_t car_161_104_741;
						    obj_t cdr_162_110_742;
						    car_161_104_741 = CAR(cdr_158_238_738);
						    cdr_162_110_742 = CDR(cdr_158_238_738);
						    if (SYMBOLP(car_161_104_741))
						      {
							 if (PAIRP(cdr_162_110_742))
							   {
							      obj_t car_167_57_745;
							      car_167_57_745 = CAR(cdr_162_110_742);
							      if (SYMBOLP(car_167_57_745))
								{
								   bool_t test_1515;
								   {
								      obj_t aux_1516;
								      aux_1516 = CDR(cdr_162_110_742);
								      test_1515 = (aux_1516 == BNIL);
								   }
								   if (test_1515)
								     {
									bool_t test_1519;
									{
									   obj_t aux_1520;
									   aux_1520 = CDR(cdr_132_143_727);
									   test_1519 = (aux_1520 == BNIL);
									}
									if (test_1519)
									  {
									     __one_eval___78_module_eval = ((bool_t) 1);
									     return remember_eval_exported__63_module_eval(car_161_104_741, car_167_57_745, proto_20);
									  }
									else
									  {
									     goto tag_113_246_720;
									  }
								     }
								   else
								     {
									goto tag_113_246_720;
								     }
								}
							      else
								{
								   goto tag_113_246_720;
								}
							   }
							 else
							   {
							      goto tag_113_246_720;
							   }
						      }
						    else
						      {
							 goto tag_113_246_720;
						      }
						 }
					       else
						 {
						    goto tag_113_246_720;
						 }
					    }
					  else
					    {
					       goto tag_113_246_720;
					    }
				       }
				    }
				  else
				    {
				       goto tag_113_246_720;
				    }
			       }
			  }
			else
			  {
			     goto tag_113_246_720;
			  }
		     }
		   else
		     {
			bool_t test_1524;
			{
			   obj_t aux_1527;
			   obj_t aux_1525;
			   aux_1527 = CNST_TABLE_REF(((long) 4));
			   aux_1525 = CAR(proto_20);
			   test_1524 = (aux_1525 == aux_1527);
			}
			if (test_1524)
			  {
			     if (PAIRP(cdr_132_143_727))
			       {
				  obj_t car_203_140_758;
				  car_203_140_758 = CAR(cdr_132_143_727);
				  if (SYMBOLP(car_203_140_758))
				    {
				       bool_t test_1535;
				       {
					  obj_t aux_1536;
					  aux_1536 = CDR(cdr_132_143_727);
					  test_1535 = (aux_1536 == BNIL);
				       }
				       if (test_1535)
					 {
					    global_t aux_1539;
					    aux_1539 = declare_global_svar__200_ast_glo_decl_237(car_203_140_758, CNST_TABLE_REF(((long) 0)), CNST_TABLE_REF(((long) 0)), clause_21);
					    return (obj_t) (aux_1539);
					 }
				       else
					 {
					    goto tag_113_246_720;
					 }
				    }
				  else
				    {
				       goto tag_113_246_720;
				    }
			       }
			     else
			       {
				  goto tag_113_246_720;
			       }
			  }
			else
			  {
			     goto tag_113_246_720;
			  }
		     }
		}
	     }
	}
      else
	{
	   goto tag_113_246_720;
	}
   }
}


obj_t 
remember_eval_exported__63_module_eval(obj_t var_22, obj_t module_23, obj_t loc_24)
{
   {
      obj_t arg1388_776;
      {
	 obj_t list1389_777;
	 {
	    obj_t arg1390_778;
	    {
	       obj_t arg1391_779;
	       arg1391_779 = MAKE_PAIR(loc_24, BNIL);
	       arg1390_778 = MAKE_PAIR(module_23, arg1391_779);
	    }
	    list1389_777 = MAKE_PAIR(var_22, arg1390_778);
	 }
	 arg1388_776 = list1389_777;
      }
      {
	 obj_t obj2_1293;
	 obj2_1293 = __eval_exported__84_module_eval;
	 return (__eval_exported__84_module_eval = MAKE_PAIR(arg1388_776, obj2_1293),
	    BUNSPEC);
      }
   }
}


obj_t 
eval_finalizer_221_module_eval()
{
   {
      bool_t test1397_781;
      if (__one_eval___78_module_eval)
	{
	   test1397_781 = ((bool_t) 1);
	}
      else
	{
	   test1397_781 = __all_eval___198_module_eval;
	}
      if (test1397_781)
	{
	   obj_t arg1398_782;
	   {
	      obj_t arg1402_785;
	      long arg1403_786;
	      obj_t arg1404_787;
	      arg1402_785 = CNST_TABLE_REF(((long) 0));
	      {
		 obj_t arg1406_788;
		 arg1406_788 = get_toplevel_unit_weight_75_module_include();
		 {
		    long aux_1552;
		    aux_1552 = (long) CINT(arg1406_788);
		    arg1403_786 = (aux_1552 - ((long) 2));
		 }
	      }
	      {
		 obj_t arg1410_1392;
		 arg1410_1392 = proc1605_module_eval;
		 arg1404_787 = make_promise_21___r4_control_features_6_9(arg1410_1392);
	      }
	      {
		 obj_t new_1312;
		 {
		    obj_t aux_1556;
		    aux_1556 = CNST_TABLE_REF(((long) 5));
		    new_1312 = create_struct(aux_1556, ((long) 4));
		 }
		 STRUCT_SET(new_1312, ((long) 3), BFALSE);
		 STRUCT_SET(new_1312, ((long) 2), arg1404_787);
		 {
		    obj_t aux_1561;
		    aux_1561 = BINT(arg1403_786);
		    STRUCT_SET(new_1312, ((long) 1), aux_1561);
		 }
		 STRUCT_SET(new_1312, ((long) 0), arg1402_785);
		 arg1398_782 = new_1312;
	      }
	   }
	   {
	      obj_t list1399_783;
	      list1399_783 = MAKE_PAIR(arg1398_782, BNIL);
	      return list1399_783;
	   }
	}
      else
	{
	   return CNST_TABLE_REF(((long) 6));
	}
   }
}


obj_t 
_eval_finalizer_230_module_eval(obj_t env_1391)
{
   return eval_finalizer_221_module_eval();
}


obj_t 
arg14101598_module_eval(obj_t env_1393)
{
   {
      {
	 obj_t globals_792;
	 obj_t init__202_793;
	 {
	    obj_t arg1412_795;
	    obj_t arg1414_796;
	    arg1412_795 = get_evaluated_globals_117_module_eval();
	    arg1414_796 = CNST_TABLE_REF(((long) 9));
	    globals_792 = arg1412_795;
	    init__202_793 = arg1414_796;
	  loop_794:
	    if (NULLP(globals_792))
	      {
		 obj_t arg1416_798;
		 obj_t arg1417_799;
		 arg1416_798 = CNST_TABLE_REF(((long) 7));
		 {
		    obj_t arg1421_802;
		    obj_t arg1424_803;
		    arg1421_802 = reverse__39___r4_pairs_and_lists_6_3(init__202_793);
		    arg1424_803 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
		    arg1417_799 = append_2_18___r4_pairs_and_lists_6_3(arg1421_802, arg1424_803);
		 }
		 {
		    obj_t list1418_800;
		    list1418_800 = MAKE_PAIR(arg1417_799, BNIL);
		    return cons__138___r4_pairs_and_lists_6_3(arg1416_798, list1418_800);
		 }
	      }
	    else
	      {
		 obj_t g_806;
		 g_806 = CAR(globals_792);
		 {
		    obj_t arg1428_807;
		    obj_t arg1431_808;
		    arg1428_807 = CDR(globals_792);
		    {
		       node_t arg1432_809;
		       {
			  bool_t test1433_810;
			  {
			     obj_t aux_1580;
			     {
				value_t aux_1581;
				{
				   global_t obj_1299;
				   obj_1299 = (global_t) (g_806);
				   aux_1581 = (((global_t) CREF(obj_1299))->value);
				}
				aux_1580 = (obj_t) (aux_1581);
			     }
			     test1433_810 = is_a__118___object(aux_1580, svar_ast_var);
			  }
			  if (test1433_810)
			    {
			       {
				  obj_t arg1440_811;
				  arg1440_811 = CNST_TABLE_REF(((long) 8));
				  {
				     obj_t res1595_1303;
				     {
					variable_t obj_1301;
					obj_1301 = (variable_t) (g_806);
					{
					   obj_t x_1400;
					   x_1400 = ((((variable_t) CREF(obj_1301))->access) = ((obj_t) arg1440_811), BUNSPEC);
					   res1595_1303 = BUNSPEC;
					}
				     }
				     res1595_1303;
				  }
			       }
			       {
				  node_t arg1441_812;
				  arg1441_812 = location__node_25_ast_sexp((global_t) (g_806));
				  arg1432_809 = define_primop_ref__node_164_ast_sexp((global_t) (g_806), arg1441_812);
			       }
			    }
			  else
			    {
			       bool_t test1442_813;
			       {
				  obj_t aux_1594;
				  {
				     value_t aux_1595;
				     {
					global_t obj_1304;
					obj_1304 = (global_t) (g_806);
					aux_1595 = (((global_t) CREF(obj_1304))->value);
				     }
				     aux_1594 = (obj_t) (aux_1595);
				  }
				  test1442_813 = is_a__118___object(aux_1594, scnst_ast_var);
			       }
			       if (test1442_813)
				 {
				    {
				       node_t arg1444_814;
				       arg1444_814 = location__node_25_ast_sexp((global_t) (g_806));
				       arg1432_809 = define_primop_ref__node_164_ast_sexp((global_t) (g_806), arg1444_814);
				    }
				 }
			       else
				 {
				    arg1432_809 = define_primop__node_141_ast_sexp((global_t) (g_806));
				 }
			    }
		       }
		       {
			  obj_t aux_1607;
			  aux_1607 = (obj_t) (arg1432_809);
			  arg1431_808 = MAKE_PAIR(aux_1607, init__202_793);
		       }
		    }
		    {
		       obj_t init__202_1611;
		       obj_t globals_1610;
		       globals_1610 = arg1428_807;
		       init__202_1611 = arg1431_808;
		       init__202_793 = init__202_1611;
		       globals_792 = globals_1610;
		       goto loop_794;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
get_evaluated_globals_117_module_eval()
{
   if (__all_eval___198_module_eval)
     {
	obj_t globals_818;
	globals_818 = MAKE_CELL(BNIL);
	{
	   obj_t arg1447_1394;
	   arg1447_1394 = make_fx_procedure(arg14471599_module_eval, ((long) 1), ((long) 1));
	   PROCEDURE_SET(arg1447_1394, ((long) 0), globals_818);
	   for_each_global__88_ast_env(arg1447_1394);
	}
	return CELL_REF(globals_818);
     }
   else
     {
	obj_t eval_exported_68_830;
	obj_t res_831;
	eval_exported_68_830 = __eval_exported__84_module_eval;
	res_831 = BNIL;
      loop_832:
	if (NULLP(eval_exported_68_830))
	  {
	     return res_831;
	  }
	else
	  {
	     obj_t var_module_pos_214_835;
	     var_module_pos_214_835 = CAR(eval_exported_68_830);
	     {
		obj_t g_836;
		{
		   obj_t arg1493_861;
		   arg1493_861 = CAR(var_module_pos_214_835);
		   {
		      obj_t list1495_863;
		      {
			 obj_t aux_1620;
			 {
			    obj_t aux_1621;
			    aux_1621 = CDR(var_module_pos_214_835);
			    aux_1620 = CAR(aux_1621);
			 }
			 list1495_863 = MAKE_PAIR(aux_1620, BNIL);
		      }
		      g_836 = find_global_223_ast_env(arg1493_861, list1495_863);
		   }
		}
		{
		   bool_t test1459_837;
		   test1459_837 = is_a__118___object(g_836, global_ast_var);
		   if (test1459_837)
		     {
			bool_t test1460_838;
			if (CBOOL(__lib_mode__85_engine_param))
			  {
			     test1460_838 = ((bool_t) 0);
			  }
			else
			  {
			     global_t obj_1349;
			     obj_1349 = (global_t) (g_836);
			     test1460_838 = (((global_t) CREF(obj_1349))->library__255);
			  }
			if (test1460_838)
			  {
			     {
				obj_t eval_exported_68_1633;
				eval_exported_68_1633 = CDR(eval_exported_68_830);
				eval_exported_68_830 = eval_exported_68_1633;
				goto loop_832;
			     }
			  }
			else
			  {
			     bool_t test_1635;
			     {
				global_t obj_1351;
				obj_1351 = (global_t) (g_836);
				test_1635 = (((global_t) CREF(obj_1351))->evaluable__248);
			     }
			     if (test_1635)
			       {
				  {
				     obj_t arg1463_841;
				     obj_t arg1465_842;
				     arg1463_841 = CDR(eval_exported_68_830);
				     arg1465_842 = MAKE_PAIR(g_836, res_831);
				     {
					obj_t res_1641;
					obj_t eval_exported_68_1640;
					eval_exported_68_1640 = arg1463_841;
					res_1641 = arg1465_842;
					res_831 = res_1641;
					eval_exported_68_830 = eval_exported_68_1640;
					goto loop_832;
				     }
				  }
			       }
			     else
			       {
				  {
				     obj_t arg1466_843;
				     obj_t arg1470_846;
				     {
					obj_t aux_1642;
					{
					   obj_t aux_1643;
					   {
					      obj_t aux_1644;
					      aux_1644 = CDR(var_module_pos_214_835);
					      aux_1643 = CDR(aux_1644);
					   }
					   aux_1642 = CAR(aux_1643);
					}
					arg1466_843 = find_location_120_tools_location(aux_1642);
				     }
				     arg1470_846 = CAR(var_module_pos_214_835);
				     {
					obj_t list1472_848;
					list1472_848 = MAKE_PAIR(BNIL, BNIL);
					user_error_location_137_tools_error(arg1466_843, string1606_module_eval, string1607_module_eval, arg1470_846, list1472_848);
				     }
				  }
				  {
				     obj_t eval_exported_68_1652;
				     eval_exported_68_1652 = CDR(eval_exported_68_830);
				     eval_exported_68_830 = eval_exported_68_1652;
				     goto loop_832;
				  }
			       }
			  }
		     }
		   else
		     {
			{
			   obj_t arg1478_852;
			   obj_t arg1484_855;
			   {
			      obj_t aux_1654;
			      {
				 obj_t aux_1655;
				 {
				    obj_t aux_1656;
				    aux_1656 = CDR(var_module_pos_214_835);
				    aux_1655 = CDR(aux_1656);
				 }
				 aux_1654 = CAR(aux_1655);
			      }
			      arg1478_852 = find_location_120_tools_location(aux_1654);
			   }
			   arg1484_855 = CAR(var_module_pos_214_835);
			   {
			      obj_t list1486_857;
			      list1486_857 = MAKE_PAIR(BNIL, BNIL);
			      user_error_location_137_tools_error(arg1478_852, string1606_module_eval, string1608_module_eval, arg1484_855, list1486_857);
			   }
			}
			{
			   obj_t eval_exported_68_1664;
			   eval_exported_68_1664 = CDR(eval_exported_68_830);
			   eval_exported_68_830 = eval_exported_68_1664;
			   goto loop_832;
			}
		     }
		}
	     }
	  }
     }
}


obj_t 
arg14471599_module_eval(obj_t env_1395, obj_t g_1397)
{
   {
      obj_t globals_1396;
      globals_1396 = PROCEDURE_REF(env_1395, ((long) 0));
      {
	 obj_t g_820;
	 g_820 = g_1397;
	 {
	    bool_t test1449_822;
	    {
	       bool_t test_1667;
	       {
		  obj_t aux_1668;
		  {
		     obj_t aux_1669;
		     {
			global_t obj_1336;
			obj_1336 = (global_t) (g_820);
			aux_1669 = (((global_t) CREF(obj_1336))->import);
		     }
		     aux_1668 = memq___r4_pairs_and_lists_6_3(aux_1669, CNST_TABLE_REF(((long) 10)));
		  }
		  test_1667 = CBOOL(aux_1668);
	       }
	       if (test_1667)
		 {
		    bool_t test_1675;
		    {
		       global_t obj_1337;
		       obj_1337 = (global_t) (g_820);
		       test_1675 = (((global_t) CREF(obj_1337))->evaluable__248);
		    }
		    if (test_1675)
		      {
			 obj_t _ortest_1284_825;
			 _ortest_1284_825 = __lib_mode__85_engine_param;
			 if (CBOOL(_ortest_1284_825))
			   {
			      test1449_822 = CBOOL(_ortest_1284_825);
			   }
			 else
			   {
			      bool_t test_1681;
			      {
				 global_t obj_1338;
				 obj_1338 = (global_t) (g_820);
				 test_1681 = (((global_t) CREF(obj_1338))->library__255);
			      }
			      if (test_1681)
				{
				   test1449_822 = ((bool_t) 0);
				}
			      else
				{
				   test1449_822 = ((bool_t) 1);
				}
			   }
		      }
		    else
		      {
			 test1449_822 = ((bool_t) 0);
		      }
		 }
	       else
		 {
		    test1449_822 = ((bool_t) 0);
		 }
	    }
	    if (test1449_822)
	      {
		 obj_t aux_1398;
		 {
		    obj_t obj2_1340;
		    obj2_1340 = CELL_REF(globals_1396);
		    aux_1398 = MAKE_PAIR(g_820, obj2_1340);
		 }
		 return CELL_SET(globals_1396, aux_1398);
	      }
	    else
	      {
		 return BUNSPEC;
	      }
	 }
      }
   }
}


obj_t 
imported_modules_init_94_module_eval()
{
   module_initialization_70_type_type(((long) 0), "MODULE_EVAL");
   module_initialization_70_ast_var(((long) 0), "MODULE_EVAL");
   module_initialization_70_ast_node(((long) 0), "MODULE_EVAL");
   module_initialization_70_module_module(((long) 0), "MODULE_EVAL");
   module_initialization_70_module_include(((long) 0), "MODULE_EVAL");
   module_initialization_70_engine_param(((long) 0), "MODULE_EVAL");
   module_initialization_70_tools_shape(((long) 0), "MODULE_EVAL");
   module_initialization_70_tools_error(((long) 0), "MODULE_EVAL");
   module_initialization_70_tools_location(((long) 0), "MODULE_EVAL");
   module_initialization_70_ast_env(((long) 0), "MODULE_EVAL");
   module_initialization_70_ast_glo_decl_237(((long) 0), "MODULE_EVAL");
   return module_initialization_70_ast_sexp(((long) 0), "MODULE_EVAL");
}
