/*===========================================================================*/
/*   (Module/foreign.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct calias
  {
     bool_t array__248;
  }
      *calias_t;

typedef struct cenum
  {
     struct type *btype;
     obj_t literals;
  }
     *cenum_t;

typedef struct cfunction
  {
     struct type *btype;
     long arity;
     struct type *type_res_48;
     obj_t type_args_244;
  }
         *cfunction_t;

typedef struct cptr
  {
     struct type *btype;
     struct type *point_to_164;
     bool_t array__248;
  }
    *cptr_t;

typedef struct cstruct
  {
     bool_t struct__46;
     obj_t fields;
     obj_t cstruct__170;
  }
       *cstruct_t;

typedef struct cstruct__170
  {
     struct type *btype;
     struct cstruct *cstruct;
  }
            *cstruct__170_t;


extern obj_t _clause_checksummer_127_module_checksum(obj_t, obj_t, obj_t);
extern obj_t make_ctype_accesses__219_foreign_access(type_t, type_t);
static obj_t c_extern_type__c_foreign_type_30_module_foreign(obj_t);
extern obj_t _make_foreign_compiler_123_module_foreign(obj_t);
extern obj_t type_type_type;
static obj_t foreign_finalizer_169_module_foreign();
extern global_t declare_global_cvar__13_ast_glo_decl_237(obj_t, obj_t, obj_t, bool_t, obj_t);
static obj_t _extern_producer_53_module_foreign(obj_t, obj_t);
extern obj_t member___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t global_ast_var;
static bool_t check_c_args__102_module_foreign(obj_t);
static obj_t extern_parser_240_module_foreign(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t __foreign_accesses__124_module_foreign = BUNSPEC;
static obj_t imported_modules_init_94_module_foreign();
extern obj_t module_initialization_70_module_foreign(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_checksum(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_glo_decl_237(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_foreign_ctype(long, char *);
extern obj_t module_initialization_70_foreign_access(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t __include_foreign__253_engine_param;
static obj_t toplevel_init_63_module_foreign();
static obj_t cnst_init_137_module_foreign();
extern obj_t ccomp_module_module;
extern type_t declare_type__118_type_env(obj_t, obj_t, obj_t);
static obj_t arg12592196_module_foreign(obj_t, obj_t, obj_t);
extern obj_t make_extern_compiler_102_module_foreign();
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _make_extern_compiler_52_module_foreign(obj_t);
static obj_t _foreign_producer_163_module_foreign(obj_t, obj_t);
static obj_t require_initialization_114_module_foreign = BUNSPEC;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t arg12552192_module_foreign(obj_t, obj_t, obj_t);
static obj_t extern_producer_85_module_foreign(obj_t);
static obj_t library_modules_init_112_module_foreign();
static obj_t foreign_producer_77_module_foreign(obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t);
extern obj_t user_warning_209_tools_error(obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t check_id_6_ast_ident(obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern long class_num_218___object(obj_t);
static bool_t check_c_foreign_type_exp__43_module_foreign(obj_t);
extern obj_t calias_foreign_ctype;
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
static obj_t __foreign_exported__195_module_foreign = BUNSPEC;
static obj_t parse_c_extern_type_73_module_foreign(obj_t);
static obj_t arg12602195_module_foreign(obj_t);
static obj_t parse_c_foreign_type_105_module_foreign(obj_t);
extern obj_t make_pointer_to_name_76_type_tools(type_t);
extern obj_t make_foreign_compiler_237_module_foreign();
extern obj_t declare_c_type__49_foreign_ctype(obj_t, obj_t, obj_t, obj_t);
extern obj_t cstruct_foreign_ctype;
static obj_t _foreign_finalizer_56_module_foreign(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t foreign_parser_183_module_foreign(obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern global_t declare_global_cfun__81_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, bool_t, bool_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
static obj_t __cnst[20];

DEFINE_STRING(string2203_module_foreign, string2203_module_foreign2222, "foreign parser: ", 16);
DEFINE_STRING(string2205_module_foreign, string2205_module_foreign2223, "Illegal foreign form", 20);
DEFINE_STATIC_PROCEDURE(proc2198_module_foreign, arg12602195_module_foreign2224, arg12602195_module_foreign, 0L, 0);
DEFINE_STATIC_PROCEDURE(foreign_finalizer_env_182_module_foreign, _foreign_finalizer_56_module_foreign2225, _foreign_finalizer_56_module_foreign, 0L, 0);
DEFINE_STRING(string2202_module_foreign, string2202_module_foreign2226, "Illegal `extern' clause", 23);
DEFINE_STRING(string2210_module_foreign, string2210_module_foreign2227, "Illegal extern form", 19);
DEFINE_STRING(string2215_module_foreign, string2215_module_foreign2228, "Unbound global variable", 23);
DEFINE_STATIC_PROCEDURE(proc2197_module_foreign, arg12552192_module_foreign2229, arg12552192_module_foreign, 0L, 2);
DEFINE_STRING(string2208_module_foreign, string2208_module_foreign2230, "Illegal `variable' form", 23);
DEFINE_STATIC_PROCEDURE(proc2199_module_foreign, arg12592196_module_foreign2231, arg12592196_module_foreign, 0L, 2);
DEFINE_STRING(string2213_module_foreign, string2213_module_foreign2232, "Foreign", 7);
DEFINE_STRING(string2201_module_foreign, string2201_module_foreign2233, "Parse error", 11);
DEFINE_STRING(string2204_module_foreign, string2204_module_foreign2234, "Illegal `include' clause", 24);
DEFINE_STATIC_PROCEDURE(foreign_producer_env_169_module_foreign, _foreign_producer_163_module_foreign2235, _foreign_producer_163_module_foreign, 0L, 1);
DEFINE_STRING(string2211_module_foreign, string2211_module_foreign2236, "Illegal `C foreign type'", 24);
DEFINE_STRING(string2214_module_foreign, string2214_module_foreign2237, "Re-exportation of global variable (ignored)", 43);
DEFINE_STATIC_PROCEDURE(extern_producer_env_171_module_foreign, _extern_producer_53_module_foreign2238, _extern_producer_53_module_foreign, 0L, 1);
DEFINE_STRING(string2207_module_foreign, string2207_module_foreign2239, "Illegal `function' form", 23);
DEFINE_EXPORT_PROCEDURE(make_foreign_compiler_env_30_module_foreign, _make_foreign_compiler_123_module_foreign2240, _make_foreign_compiler_123_module_foreign, 0L, 0);
DEFINE_STRING(string2212_module_foreign, string2212_module_foreign2241, "Illegal `C extern type'", 23);
DEFINE_STRING(string2206_module_foreign, string2206_module_foreign2242, "Illegal `macro' form", 20);
DEFINE_STRING(string2200_module_foreign, string2200_module_foreign2243, "Illegal `foreign' clause", 24);
DEFINE_STRING(string2216_module_foreign, string2216_module_foreign2244, "UNIT UNION* STRUCT* ARRAY ENUM FUNCTION POINTER STRUCT UNION C * MACRO EXPORT TYPE INCLUDE INFIX AST VOID EXTERN FOREIGN ", 121);
DEFINE_STRING(string2209_module_foreign, string2209_module_foreign2245, "extern parser: ", 15);
DEFINE_EXPORT_PROCEDURE(make_extern_compiler_env_153_module_foreign, _make_extern_compiler_52_module_foreign2246, _make_extern_compiler_52_module_foreign, 0L, 0);
extern obj_t clause_checksummer_env_74_module_checksum;

obj_t 
module_initialization_70_module_foreign(long checksum_2874, char *from_2875)
{
   if (CBOOL(require_initialization_114_module_foreign))
     {
	require_initialization_114_module_foreign = BBOOL(((bool_t) 0));
	library_modules_init_112_module_foreign();
	cnst_init_137_module_foreign();
	imported_modules_init_94_module_foreign();
	toplevel_init_63_module_foreign();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_module_foreign()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_FOREIGN");
   module_initialization_70___object(((long) 0), "MODULE_FOREIGN");
   module_initialization_70___reader(((long) 0), "MODULE_FOREIGN");
   module_initialization_70___r4_symbols_6_4(((long) 0), "MODULE_FOREIGN");
   module_initialization_70___r4_strings_6_7(((long) 0), "MODULE_FOREIGN");
   return BUNSPEC;
}


obj_t 
cnst_init_137_module_foreign()
{
   {
      obj_t cnst_port_138_2866;
      cnst_port_138_2866 = open_input_string(string2216_module_foreign);
      {
	 long i_2867;
	 i_2867 = ((long) 19);
       loop_2868:
	 {
	    bool_t test2217_2869;
	    test2217_2869 = (i_2867 == ((long) -1));
	    if (test2217_2869)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2218_2870;
		    {
		       obj_t list2219_2871;
		       {
			  obj_t arg2220_2872;
			  arg2220_2872 = BNIL;
			  list2219_2871 = MAKE_PAIR(cnst_port_138_2866, arg2220_2872);
		       }
		       arg2218_2870 = read___reader(list2219_2871);
		    }
		    CNST_TABLE_SET(i_2867, arg2218_2870);
		 }
		 {
		    int aux_2873;
		    {
		       long aux_2894;
		       aux_2894 = (i_2867 - ((long) 1));
		       aux_2873 = (int) (aux_2894);
		    }
		    {
		       long i_2897;
		       i_2897 = (long) (aux_2873);
		       i_2867 = i_2897;
		       goto loop_2868;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_module_foreign()
{
   __foreign_accesses__124_module_foreign = BNIL;
   return (__foreign_exported__195_module_foreign = BNIL,
      BUNSPEC);
}


obj_t 
make_foreign_compiler_237_module_foreign()
{
   {
      obj_t arg1252_665;
      arg1252_665 = CNST_TABLE_REF(((long) 0));
      {
	 obj_t arg1255_2839;
	 arg1255_2839 = proc2197_module_foreign;
	 {
	    ccomp_t res2189_1974;
	    {
	       ccomp_t new1010_1965;
	       new1010_1965 = ((ccomp_t) BREF(GC_MALLOC(sizeof(struct ccomp))));
	       {
		  long arg2187_1966;
		  arg2187_1966 = class_num_218___object(ccomp_module_module);
		  {
		     obj_t obj_1972;
		     obj_1972 = (obj_t) (new1010_1965);
		     (((obj_t) CREF(obj_1972))->header = MAKE_HEADER(arg2187_1966, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_2904;
		  aux_2904 = (object_t) (new1010_1965);
		  OBJECT_WIDENING_SET(aux_2904, BFALSE);
	       }
	       ((((ccomp_t) CREF(new1010_1965))->id) = ((obj_t) arg1252_665), BUNSPEC);
	       ((((ccomp_t) CREF(new1010_1965))->producer) = ((obj_t) foreign_producer_env_169_module_foreign), BUNSPEC);
	       ((((ccomp_t) CREF(new1010_1965))->consumer) = ((obj_t) arg1255_2839), BUNSPEC);
	       ((((ccomp_t) CREF(new1010_1965))->finalizer) = ((obj_t) foreign_finalizer_env_182_module_foreign), BUNSPEC);
	       ((((ccomp_t) CREF(new1010_1965))->checksummer) = ((obj_t) clause_checksummer_env_74_module_checksum), BUNSPEC);
	       res2189_1974 = new1010_1965;
	    }
	    return (obj_t) (res2189_1974);
	 }
      }
   }
}


obj_t 
_make_foreign_compiler_123_module_foreign(obj_t env_2840)
{
   return make_foreign_compiler_237_module_foreign();
}


obj_t 
arg12552192_module_foreign(obj_t env_2841, obj_t m_2842, obj_t c_2843)
{
   {
      obj_t m_667;
      obj_t c_668;
      m_667 = m_2842;
      c_668 = c_2843;
      return foreign_producer_77_module_foreign(c_668);
   }
}


obj_t 
make_extern_compiler_102_module_foreign()
{
   {
      obj_t arg1257_671;
      arg1257_671 = CNST_TABLE_REF(((long) 1));
      {
	 obj_t arg1260_2850;
	 obj_t arg1259_2851;
	 arg1260_2850 = proc2198_module_foreign;
	 arg1259_2851 = proc2199_module_foreign;
	 {
	    ccomp_t res2190_1985;
	    {
	       ccomp_t new1010_1976;
	       new1010_1976 = ((ccomp_t) BREF(GC_MALLOC(sizeof(struct ccomp))));
	       {
		  long arg2187_1977;
		  arg2187_1977 = class_num_218___object(ccomp_module_module);
		  {
		     obj_t obj_1983;
		     obj_1983 = (obj_t) (new1010_1976);
		     (((obj_t) CREF(obj_1983))->header = MAKE_HEADER(arg2187_1977, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_2920;
		  aux_2920 = (object_t) (new1010_1976);
		  OBJECT_WIDENING_SET(aux_2920, BFALSE);
	       }
	       ((((ccomp_t) CREF(new1010_1976))->id) = ((obj_t) arg1257_671), BUNSPEC);
	       ((((ccomp_t) CREF(new1010_1976))->producer) = ((obj_t) extern_producer_env_171_module_foreign), BUNSPEC);
	       ((((ccomp_t) CREF(new1010_1976))->consumer) = ((obj_t) arg1259_2851), BUNSPEC);
	       ((((ccomp_t) CREF(new1010_1976))->finalizer) = ((obj_t) arg1260_2850), BUNSPEC);
	       ((((ccomp_t) CREF(new1010_1976))->checksummer) = ((obj_t) clause_checksummer_env_74_module_checksum), BUNSPEC);
	       res2190_1985 = new1010_1976;
	    }
	    return (obj_t) (res2190_1985);
	 }
      }
   }
}


obj_t 
_make_extern_compiler_52_module_foreign(obj_t env_2852)
{
   return make_extern_compiler_102_module_foreign();
}


obj_t 
arg12602195_module_foreign(obj_t env_2853)
{
   {
      return CNST_TABLE_REF(((long) 2));
   }
}


obj_t 
arg12592196_module_foreign(obj_t env_2854, obj_t m_2855, obj_t c_2856)
{
   {
      obj_t m_674;
      obj_t c_675;
      m_674 = m_2855;
      c_675 = c_2856;
      return extern_producer_85_module_foreign(c_675);
   }
}


obj_t 
foreign_producer_77_module_foreign(obj_t clause_19)
{
   {
      obj_t protos_680;
      if (PAIRP(clause_19))
	{
	   protos_680 = CDR(clause_19);
	   {
	      obj_t l1224_686;
	      l1224_686 = protos_680;
	    lname1226_687:
	      if (PAIRP(l1224_686))
		{
		   foreign_parser_183_module_foreign(CAR(l1224_686));
		   {
		      obj_t l1224_2938;
		      l1224_2938 = CDR(l1224_686);
		      l1224_686 = l1224_2938;
		      goto lname1226_687;
		   }
		}
	      else
		{
		   ((bool_t) 1);
		}
	   }
	   return BNIL;
	}
      else
	{
	   {
	      obj_t arg1271_692;
	      {
		 obj_t list1276_696;
		 list1276_696 = MAKE_PAIR(string2200_module_foreign, BNIL);
		 arg1271_692 = string_append_106___r4_strings_6_7(list1276_696);
	      }
	      {
		 obj_t list1273_694;
		 list1273_694 = MAKE_PAIR(BNIL, BNIL);
		 return user_error_151_tools_error(string2201_module_foreign, arg1271_692, clause_19, list1273_694);
	      }
	   }
	}
   }
}


obj_t 
_foreign_producer_163_module_foreign(obj_t env_2844, obj_t clause_2845)
{
   return foreign_producer_77_module_foreign(clause_2845);
}


obj_t 
extern_producer_85_module_foreign(obj_t clause_20)
{
   {
      obj_t protos_699;
      if (PAIRP(clause_20))
	{
	   protos_699 = CDR(clause_20);
	   {
	      obj_t l1227_705;
	      l1227_705 = protos_699;
	    lname1228_706:
	      if (PAIRP(l1227_705))
		{
		   extern_parser_240_module_foreign(CAR(l1227_705));
		   {
		      obj_t l1227_2952;
		      l1227_2952 = CDR(l1227_705);
		      l1227_705 = l1227_2952;
		      goto lname1228_706;
		   }
		}
	      else
		{
		   ((bool_t) 1);
		}
	   }
	   return BNIL;
	}
      else
	{
	   {
	      obj_t arg1290_711;
	      {
		 obj_t list1296_715;
		 list1296_715 = MAKE_PAIR(string2202_module_foreign, BNIL);
		 arg1290_711 = string_append_106___r4_strings_6_7(list1296_715);
	      }
	      {
		 obj_t list1294_713;
		 list1294_713 = MAKE_PAIR(BNIL, BNIL);
		 return user_error_151_tools_error(string2201_module_foreign, arg1290_711, clause_20, list1294_713);
	      }
	   }
	}
   }
}


obj_t 
_extern_producer_53_module_foreign(obj_t env_2857, obj_t clause_2858)
{
   return extern_producer_85_module_foreign(clause_2858);
}


bool_t 
check_c_args__102_module_foreign(obj_t proto_21)
{
   {
      obj_t proto_718;
      proto_718 = proto_21;
    loop_719:
      if (NULLP(proto_718))
	{
	   return ((bool_t) 1);
	}
      else
	{
	   if (SYMBOLP(proto_718))
	     {
		return ((bool_t) 1);
	     }
	   else
	     {
		if (PAIRP(proto_718))
		  {
		     bool_t test_2966;
		     {
			obj_t aux_2967;
			aux_2967 = CAR(proto_718);
			test_2966 = SYMBOLP(aux_2967);
		     }
		     if (test_2966)
		       {
			  {
			     obj_t proto_2970;
			     proto_2970 = CDR(proto_718);
			     proto_718 = proto_2970;
			     goto loop_719;
			  }
		       }
		     else
		       {
			  return ((bool_t) 0);
		       }
		  }
		else
		  {
		     return ((bool_t) 0);
		  }
	     }
	}
   }
}


obj_t 
foreign_parser_183_module_foreign(obj_t foreign_22)
{
   {
      bool_t test1306_726;
      {
	 obj_t aux_2972;
	 aux_2972 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 3)), BINT(((long) 2)));
	 test1306_726 = CBOOL(aux_2972);
      }
      if (test1306_726)
	{
	   obj_t list1307_727;
	   {
	      obj_t arg1310_729;
	      {
		 obj_t arg1311_730;
		 {
		    obj_t aux_2978;
		    aux_2978 = BCHAR(((unsigned char) '\n'));
		    arg1311_730 = MAKE_PAIR(aux_2978, BNIL);
		 }
		 arg1310_729 = MAKE_PAIR(foreign_22, arg1311_730);
	      }
	      list1307_727 = MAKE_PAIR(string2203_module_foreign, arg1310_729);
	   }
	   print_trace_107_tools_trace(list1307_727);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t type_756;
      obj_t l_name_185_757;
      obj_t c_name_211_758;
      obj_t type_751;
      obj_t l_name_185_752;
      obj_t proto_753;
      obj_t c_name_211_754;
      obj_t type_746;
      obj_t l_name_185_747;
      obj_t c_name_211_748;
      obj_t type_741;
      obj_t l_name_185_742;
      obj_t proto_743;
      obj_t c_name_211_744;
      obj_t string_734;
      if (PAIRP(foreign_22))
	{
	   obj_t cdr_156_22_763;
	   cdr_156_22_763 = CDR(foreign_22);
	   {
	      bool_t test_2987;
	      {
		 obj_t aux_2990;
		 obj_t aux_2988;
		 aux_2990 = CNST_TABLE_REF(((long) 5));
		 aux_2988 = CAR(foreign_22);
		 test_2987 = (aux_2988 == aux_2990);
	      }
	      if (test_2987)
		{
		   if (PAIRP(cdr_156_22_763))
		     {
			bool_t test_2995;
			{
			   obj_t aux_2996;
			   aux_2996 = CDR(cdr_156_22_763);
			   test_2995 = (aux_2996 == BNIL);
			}
			if (test_2995)
			  {
			     string_734 = CAR(cdr_156_22_763);
			     if (STRINGP(string_734))
			       {
				  bool_t test1467_899;
				  {
				     obj_t aux_3001;
				     aux_3001 = member___r4_pairs_and_lists_6_3(string_734, __include_foreign__253_engine_param);
				     test1467_899 = CBOOL(aux_3001);
				  }
				  if (test1467_899)
				    {
				       return BUNSPEC;
				    }
				  else
				    {
				       obj_t obj2_2144;
				       obj2_2144 = __include_foreign__253_engine_param;
				       return (__include_foreign__253_engine_param = MAKE_PAIR(string_734, obj2_2144),
					  BUNSPEC);
				    }
			       }
			     else
			       {
				  obj_t list1472_903;
				  list1472_903 = MAKE_PAIR(BNIL, BNIL);
				  return user_error_151_tools_error(string2201_module_foreign, string2204_module_foreign, foreign_22, list1472_903);
			       }
			  }
			else
			  {
			   tag_139_224_740:
			     {
				obj_t list1479_908;
				list1479_908 = MAKE_PAIR(BNIL, BNIL);
				return user_error_151_tools_error(string2201_module_foreign, string2205_module_foreign, foreign_22, list1479_908);
			     }
			  }
		     }
		   else
		     {
			goto tag_139_224_740;
		     }
		}
	      else
		{
		   bool_t test_3011;
		   {
		      obj_t aux_3014;
		      obj_t aux_3012;
		      aux_3014 = CNST_TABLE_REF(((long) 6));
		      aux_3012 = CAR(foreign_22);
		      test_3011 = (aux_3012 == aux_3014);
		   }
		   if (test_3011)
		     {
			return parse_c_foreign_type_105_module_foreign(foreign_22);
		     }
		   else
		     {
			bool_t test_3018;
			{
			   obj_t aux_3021;
			   obj_t aux_3019;
			   aux_3021 = CNST_TABLE_REF(((long) 7));
			   aux_3019 = CAR(foreign_22);
			   test_3018 = (aux_3019 == aux_3021);
			}
			if (test_3018)
			  {
			     if (PAIRP(cdr_156_22_763))
			       {
				  obj_t cdr_218_104_775;
				  cdr_218_104_775 = CDR(cdr_156_22_763);
				  {
				     bool_t test_3027;
				     {
					obj_t aux_3028;
					aux_3028 = CAR(cdr_156_22_763);
					test_3027 = SYMBOLP(aux_3028);
				     }
				     if (test_3027)
				       {
					  if (PAIRP(cdr_218_104_775))
					    {
					       bool_t test_3033;
					       {
						  obj_t aux_3034;
						  aux_3034 = CAR(cdr_218_104_775);
						  test_3033 = STRINGP(aux_3034);
					       }
					       if (test_3033)
						 {
						    bool_t test_3037;
						    {
						       obj_t aux_3038;
						       aux_3038 = CDR(cdr_218_104_775);
						       test_3037 = (aux_3038 == BNIL);
						    }
						    if (test_3037)
						      {
							 obj_t obj2_2032;
							 obj2_2032 = __foreign_exported__195_module_foreign;
							 return (__foreign_exported__195_module_foreign = MAKE_PAIR(foreign_22, obj2_2032),
							    BUNSPEC);
						      }
						    else
						      {
							 goto tag_139_224_740;
						      }
						 }
					       else
						 {
						    goto tag_139_224_740;
						 }
					    }
					  else
					    {
					       goto tag_139_224_740;
					    }
				       }
				     else
				       {
					  goto tag_139_224_740;
				       }
				  }
			       }
			     else
			       {
				  goto tag_139_224_740;
			       }
			  }
			else
			  {
			     bool_t test_3042;
			     {
				obj_t aux_3045;
				obj_t aux_3043;
				aux_3045 = CNST_TABLE_REF(((long) 8));
				aux_3043 = CAR(foreign_22);
				test_3042 = (aux_3043 == aux_3045);
			     }
			     if (test_3042)
			       {
				  if (PAIRP(cdr_156_22_763))
				    {
				       obj_t cdr_276_172_786;
				       cdr_276_172_786 = CDR(cdr_156_22_763);
				       if (PAIRP(cdr_276_172_786))
					 {
					    obj_t cdr_282_255_788;
					    cdr_282_255_788 = CDR(cdr_276_172_786);
					    if (PAIRP(cdr_282_255_788))
					      {
						 obj_t cdr_287_201_790;
						 cdr_287_201_790 = CDR(cdr_282_255_788);
						 if (PAIRP(cdr_287_201_790))
						   {
						      bool_t test_3059;
						      {
							 obj_t aux_3060;
							 aux_3060 = CDR(cdr_287_201_790);
							 test_3059 = (aux_3060 == BNIL);
						      }
						      if (test_3059)
							{
							   type_741 = CAR(cdr_156_22_763);
							   l_name_185_742 = CAR(cdr_276_172_786);
							   proto_743 = CAR(cdr_282_255_788);
							   c_name_211_744 = CAR(cdr_287_201_790);
							 tag_140_156_745:
							   {
							      bool_t test_3063;
							      if (STRINGP(c_name_211_744))
								{
								   if (SYMBOLP(type_741))
								     {
									if (SYMBOLP(l_name_185_742))
									  {
									     test_3063 = check_c_args__102_module_foreign(proto_743);
									  }
									else
									  {
									     test_3063 = ((bool_t) 0);
									  }
								     }
								   else
								     {
									test_3063 = ((bool_t) 0);
								     }
								}
							      else
								{
								   test_3063 = ((bool_t) 0);
								}
							      if (test_3063)
								{
								   global_t aux_3071;
								   {
								      bool_t aux_3072;
								      {
									 obj_t aux_3075;
									 obj_t aux_3073;
									 aux_3075 = CNST_TABLE_REF(((long) 4));
									 aux_3073 = CAR(foreign_22);
									 aux_3072 = (aux_3073 == aux_3075);
								      }
								      aux_3071 = declare_global_cfun__81_ast_glo_decl_237(l_name_185_742, c_name_211_744, type_741, proto_743, aux_3072, ((bool_t) 1), foreign_22);
								   }
								   return (obj_t) (aux_3071);
								}
							      else
								{
								   obj_t list1491_917;
								   list1491_917 = MAKE_PAIR(BNIL, BNIL);
								   return user_error_151_tools_error(string2201_module_foreign, string2206_module_foreign, foreign_22, list1491_917);
								}
							   }
							}
						      else
							{
							 tag_142_79_750:
							   {
							      obj_t list1512_933;
							      list1512_933 = MAKE_PAIR(BNIL, BNIL);
							      return user_error_151_tools_error(string2201_module_foreign, string2205_module_foreign, foreign_22, list1512_933);
							   }
							}
						   }
						 else
						   {
						      obj_t cdr_334_205_800;
						      cdr_334_205_800 = CDR(cdr_156_22_763);
						      {
							 obj_t cdr_342_170_801;
							 cdr_342_170_801 = CDR(cdr_334_205_800);
							 {
							    bool_t test_3090;
							    {
							       obj_t aux_3091;
							       aux_3091 = CDR(cdr_342_170_801);
							       test_3090 = (aux_3091 == BNIL);
							    }
							    if (test_3090)
							      {
								 type_746 = CAR(cdr_156_22_763);
								 l_name_185_747 = CAR(cdr_334_205_800);
								 c_name_211_748 = CAR(cdr_342_170_801);
								 {
								    bool_t test_3094;
								    if (STRINGP(c_name_211_748))
								      {
									 if (SYMBOLP(type_746))
									   {
									      test_3094 = SYMBOLP(l_name_185_747);
									   }
									 else
									   {
									      test_3094 = ((bool_t) 0);
									   }
								      }
								    else
								      {
									 test_3094 = ((bool_t) 0);
								      }
								    if (test_3094)
								      {
									 global_t aux_3100;
									 aux_3100 = declare_global_cvar__13_ast_glo_decl_237(l_name_185_747, c_name_211_748, type_746, ((bool_t) 1), foreign_22);
									 return (obj_t) (aux_3100);
								      }
								    else
								      {
									 obj_t list1501_926;
									 list1501_926 = MAKE_PAIR(BNIL, BNIL);
									 return user_error_151_tools_error(string2201_module_foreign, string2206_module_foreign, foreign_22, list1501_926);
								      }
								 }
							      }
							    else
							      {
								 goto tag_142_79_750;
							      }
							 }
						      }
						   }
					      }
					    else
					      {
						 goto tag_142_79_750;
					      }
					 }
				       else
					 {
					    goto tag_142_79_750;
					 }
				    }
				  else
				    {
				       goto tag_142_79_750;
				    }
			       }
			     else
			       {
				  bool_t test_3108;
				  {
				     obj_t aux_3111;
				     obj_t aux_3109;
				     aux_3111 = CNST_TABLE_REF(((long) 4));
				     aux_3109 = CAR(foreign_22);
				     test_3108 = (aux_3109 == aux_3111);
				  }
				  if (test_3108)
				    {
				       if (PAIRP(cdr_156_22_763))
					 {
					    obj_t cdr_414_70_811;
					    cdr_414_70_811 = CDR(cdr_156_22_763);
					    {
					       bool_t test_3117;
					       {
						  obj_t aux_3120;
						  obj_t aux_3118;
						  aux_3120 = CNST_TABLE_REF(((long) 8));
						  aux_3118 = CAR(cdr_156_22_763);
						  test_3117 = (aux_3118 == aux_3120);
					       }
					       if (test_3117)
						 {
						    if (PAIRP(cdr_414_70_811))
						      {
							 obj_t cdr_420_191_814;
							 cdr_420_191_814 = CDR(cdr_414_70_811);
							 if (PAIRP(cdr_420_191_814))
							   {
							      obj_t cdr_426_228_816;
							      cdr_426_228_816 = CDR(cdr_420_191_814);
							      if (PAIRP(cdr_426_228_816))
								{
								   obj_t cdr_431_26_818;
								   cdr_431_26_818 = CDR(cdr_426_228_816);
								   if (PAIRP(cdr_431_26_818))
								     {
									bool_t test_3134;
									{
									   obj_t aux_3135;
									   aux_3135 = CDR(cdr_431_26_818);
									   test_3134 = (aux_3135 == BNIL);
									}
									if (test_3134)
									  {
									     obj_t c_name_211_3144;
									     obj_t proto_3142;
									     obj_t l_name_185_3140;
									     obj_t type_3138;
									     type_3138 = CAR(cdr_414_70_811);
									     l_name_185_3140 = CAR(cdr_420_191_814);
									     proto_3142 = CAR(cdr_426_228_816);
									     c_name_211_3144 = CAR(cdr_431_26_818);
									     c_name_211_744 = c_name_211_3144;
									     proto_743 = proto_3142;
									     l_name_185_742 = l_name_185_3140;
									     type_741 = type_3138;
									     goto tag_140_156_745;
									  }
									else
									  {
									   tag_145_198_760:
									     {
										obj_t list1540_955;
										list1540_955 = MAKE_PAIR(BNIL, BNIL);
										return user_error_151_tools_error(string2201_module_foreign, string2205_module_foreign, foreign_22, list1540_955);
									     }
									  }
								     }
								   else
								     {
									goto tag_145_198_760;
								     }
								}
							      else
								{
								   obj_t cdr_523_105_828;
								   cdr_523_105_828 = CDR(cdr_156_22_763);
								   {
								      obj_t cdr_530_222_829;
								      cdr_530_222_829 = CDR(cdr_523_105_828);
								      {
									 bool_t test_3150;
									 {
									    obj_t aux_3151;
									    aux_3151 = CDR(cdr_530_222_829);
									    test_3150 = (aux_3151 == BNIL);
									 }
									 if (test_3150)
									   {
									      type_751 = CAR(foreign_22);
									      l_name_185_752 = CAR(cdr_156_22_763);
									      proto_753 = CAR(cdr_523_105_828);
									      c_name_211_754 = CAR(cdr_530_222_829);
									    tag_143_46_755:
									      {
										 bool_t test_3154;
										 if (STRINGP(c_name_211_754))
										   {
										      if (SYMBOLP(type_751))
											{
											   if (SYMBOLP(l_name_185_752))
											     {
												test_3154 = check_c_args__102_module_foreign(proto_753);
											     }
											   else
											     {
												test_3154 = ((bool_t) 0);
											     }
											}
										      else
											{
											   test_3154 = ((bool_t) 0);
											}
										   }
										 else
										   {
										      test_3154 = ((bool_t) 0);
										   }
										 if (test_3154)
										   {
										      global_t aux_3162;
										      aux_3162 = declare_global_cfun__81_ast_glo_decl_237(l_name_185_752, c_name_211_754, type_751, proto_753, ((bool_t) 0), ((bool_t) 0), foreign_22);
										      return (obj_t) (aux_3162);
										   }
										 else
										   {
										      obj_t list1521_939;
										      list1521_939 = MAKE_PAIR(BNIL, BNIL);
										      return user_error_151_tools_error(string2201_module_foreign, string2207_module_foreign, foreign_22, list1521_939);
										   }
									      }
									   }
									 else
									   {
									      goto tag_145_198_760;
									   }
								      }
								   }
								}
							   }
							 else
							   {
							      obj_t cdr_579_43_838;
							      cdr_579_43_838 = CDR(cdr_156_22_763);
							      {
								 bool_t test_3172;
								 {
								    obj_t aux_3173;
								    aux_3173 = CDR(cdr_579_43_838);
								    test_3172 = (aux_3173 == BNIL);
								 }
								 if (test_3172)
								   {
								      type_756 = CAR(foreign_22);
								      l_name_185_757 = CAR(cdr_156_22_763);
								      c_name_211_758 = CAR(cdr_579_43_838);
								    tag_144_168_759:
								      {
									 bool_t test_3176;
									 if (STRINGP(c_name_211_758))
									   {
									      if (SYMBOLP(type_756))
										{
										   test_3176 = SYMBOLP(l_name_185_757);
										}
									      else
										{
										   test_3176 = ((bool_t) 0);
										}
									   }
									 else
									   {
									      test_3176 = ((bool_t) 0);
									   }
									 if (test_3176)
									   {
									      global_t aux_3182;
									      aux_3182 = declare_global_cvar__13_ast_glo_decl_237(l_name_185_757, c_name_211_758, type_756, ((bool_t) 0), foreign_22);
									      return (obj_t) (aux_3182);
									   }
									 else
									   {
									      obj_t list1533_948;
									      list1533_948 = MAKE_PAIR(BNIL, BNIL);
									      return user_error_151_tools_error(string2201_module_foreign, string2208_module_foreign, foreign_22, list1533_948);
									   }
								      }
								   }
								 else
								   {
								      goto tag_145_198_760;
								   }
							      }
							   }
						      }
						    else
						      {
							 goto tag_145_198_760;
						      }
						 }
					       else
						 {
						    obj_t cdr_638_125_846;
						    cdr_638_125_846 = CDR(cdr_156_22_763);
						    if (PAIRP(cdr_638_125_846))
						      {
							 obj_t cdr_643_163_848;
							 cdr_643_163_848 = CDR(cdr_638_125_846);
							 if (PAIRP(cdr_643_163_848))
							   {
							      bool_t test_3196;
							      {
								 obj_t aux_3197;
								 aux_3197 = CDR(cdr_643_163_848);
								 test_3196 = (aux_3197 == BNIL);
							      }
							      if (test_3196)
								{
								   obj_t c_name_211_3206;
								   obj_t proto_3204;
								   obj_t l_name_185_3202;
								   obj_t type_3200;
								   type_3200 = CAR(foreign_22);
								   l_name_185_3202 = CAR(cdr_156_22_763);
								   proto_3204 = CAR(cdr_638_125_846);
								   c_name_211_3206 = CAR(cdr_643_163_848);
								   c_name_211_754 = c_name_211_3206;
								   proto_753 = proto_3204;
								   l_name_185_752 = l_name_185_3202;
								   type_751 = type_3200;
								   goto tag_143_46_755;
								}
							      else
								{
								   goto tag_145_198_760;
								}
							   }
							 else
							   {
							      obj_t cdr_673_88_858;
							      cdr_673_88_858 = CDR(cdr_156_22_763);
							      {
								 bool_t test_3209;
								 {
								    obj_t aux_3210;
								    aux_3210 = CDR(cdr_673_88_858);
								    test_3209 = (aux_3210 == BNIL);
								 }
								 if (test_3209)
								   {
								      obj_t c_name_211_3217;
								      obj_t l_name_185_3215;
								      obj_t type_3213;
								      type_3213 = CAR(foreign_22);
								      l_name_185_3215 = CAR(cdr_156_22_763);
								      c_name_211_3217 = CAR(cdr_673_88_858);
								      c_name_211_758 = c_name_211_3217;
								      l_name_185_757 = l_name_185_3215;
								      type_756 = type_3213;
								      goto tag_144_168_759;
								   }
								 else
								   {
								      goto tag_145_198_760;
								   }
							      }
							   }
						      }
						    else
						      {
							 goto tag_145_198_760;
						      }
						 }
					    }
					 }
				       else
					 {
					    goto tag_145_198_760;
					 }
				    }
				  else
				    {
				       if (PAIRP(cdr_156_22_763))
					 {
					    obj_t cdr_740_201_869;
					    cdr_740_201_869 = CDR(cdr_156_22_763);
					    if (PAIRP(cdr_740_201_869))
					      {
						 obj_t cdr_745_255_871;
						 cdr_745_255_871 = CDR(cdr_740_201_869);
						 if (PAIRP(cdr_745_255_871))
						   {
						      bool_t test_3227;
						      {
							 obj_t aux_3228;
							 aux_3228 = CDR(cdr_745_255_871);
							 test_3227 = (aux_3228 == BNIL);
						      }
						      if (test_3227)
							{
							   obj_t c_name_211_3237;
							   obj_t proto_3235;
							   obj_t l_name_185_3233;
							   obj_t type_3231;
							   type_3231 = CAR(foreign_22);
							   l_name_185_3233 = CAR(cdr_156_22_763);
							   proto_3235 = CAR(cdr_740_201_869);
							   c_name_211_3237 = CAR(cdr_745_255_871);
							   c_name_211_754 = c_name_211_3237;
							   proto_753 = proto_3235;
							   l_name_185_752 = l_name_185_3233;
							   type_751 = type_3231;
							   goto tag_143_46_755;
							}
						      else
							{
							   goto tag_145_198_760;
							}
						   }
						 else
						   {
						      obj_t cdr_778_237_881;
						      cdr_778_237_881 = CDR(cdr_156_22_763);
						      {
							 bool_t test_3240;
							 {
							    obj_t aux_3241;
							    aux_3241 = CDR(cdr_778_237_881);
							    test_3240 = (aux_3241 == BNIL);
							 }
							 if (test_3240)
							   {
							      obj_t c_name_211_3248;
							      obj_t l_name_185_3246;
							      obj_t type_3244;
							      type_3244 = CAR(foreign_22);
							      l_name_185_3246 = CAR(cdr_156_22_763);
							      c_name_211_3248 = CAR(cdr_778_237_881);
							      c_name_211_758 = c_name_211_3248;
							      l_name_185_757 = l_name_185_3246;
							      type_756 = type_3244;
							      goto tag_144_168_759;
							   }
							 else
							   {
							      goto tag_145_198_760;
							   }
						      }
						   }
					      }
					    else
					      {
						 goto tag_145_198_760;
					      }
					 }
				       else
					 {
					    goto tag_145_198_760;
					 }
				    }
			       }
			  }
		     }
		}
	   }
	}
      else
	{
	   goto tag_145_198_760;
	}
   }
}


obj_t 
extern_parser_240_module_foreign(obj_t extern_64_23)
{
   {
      bool_t test1542_957;
      {
	 obj_t aux_3250;
	 aux_3250 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 3)), BINT(((long) 2)));
	 test1542_957 = CBOOL(aux_3250);
      }
      if (test1542_957)
	{
	   obj_t list1543_958;
	   {
	      obj_t arg1549_960;
	      {
		 obj_t arg1550_961;
		 {
		    obj_t aux_3256;
		    aux_3256 = BCHAR(((unsigned char) '\n'));
		    arg1550_961 = MAKE_PAIR(aux_3256, BNIL);
		 }
		 arg1549_960 = MAKE_PAIR(extern_64_23, arg1550_961);
	      }
	      list1543_958 = MAKE_PAIR(string2209_module_foreign, arg1549_960);
	   }
	   print_trace_107_tools_trace(list1543_958);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t id_979;
      obj_t c_name_211_980;
      obj_t id_975;
      obj_t proto_976;
      obj_t cn_977;
      obj_t id_971;
      obj_t c_name_211_972;
      obj_t id_967;
      obj_t proto_968;
      obj_t cn_969;
      if (PAIRP(extern_64_23))
	{
	   bool_t test_3264;
	   {
	      obj_t aux_3267;
	      obj_t aux_3265;
	      aux_3267 = CNST_TABLE_REF(((long) 6));
	      aux_3265 = CAR(extern_64_23);
	      test_3264 = (aux_3265 == aux_3267);
	   }
	   if (test_3264)
	     {
		return parse_c_extern_type_73_module_foreign(extern_64_23);
	     }
	   else
	     {
		obj_t car_881_151_986;
		car_881_151_986 = CAR(extern_64_23);
		{
		   bool_t test_3272;
		   {
		      obj_t aux_3273;
		      aux_3273 = CNST_TABLE_REF(((long) 7));
		      test_3272 = (car_881_151_986 == aux_3273);
		   }
		   if (test_3272)
		     {
			return foreign_parser_183_module_foreign(extern_64_23);
		     }
		   else
		     {
			bool_t test_3277;
			{
			   obj_t aux_3278;
			   aux_3278 = CNST_TABLE_REF(((long) 5));
			   test_3277 = (car_881_151_986 == aux_3278);
			}
			if (test_3277)
			  {
			     return foreign_parser_183_module_foreign(extern_64_23);
			  }
			else
			  {
			     obj_t cdr_896_76_989;
			     cdr_896_76_989 = CDR(extern_64_23);
			     {
				bool_t test_3283;
				{
				   obj_t aux_3284;
				   aux_3284 = CNST_TABLE_REF(((long) 8));
				   test_3283 = (car_881_151_986 == aux_3284);
				}
				if (test_3283)
				  {
				     if (PAIRP(cdr_896_76_989))
				       {
					  obj_t car_900_190_992;
					  obj_t cdr_901_152_993;
					  car_900_190_992 = CAR(cdr_896_76_989);
					  cdr_901_152_993 = CDR(cdr_896_76_989);
					  if (SYMBOLP(car_900_190_992))
					    {
					       if (PAIRP(cdr_901_152_993))
						 {
						    obj_t cdr_908_200_996;
						    cdr_908_200_996 = CDR(cdr_901_152_993);
						    if (PAIRP(cdr_908_200_996))
						      {
							 obj_t car_911_5_998;
							 car_911_5_998 = CAR(cdr_908_200_996);
							 if (STRINGP(car_911_5_998))
							   {
							      bool_t test_3301;
							      {
								 obj_t aux_3302;
								 aux_3302 = CDR(cdr_908_200_996);
								 test_3301 = (aux_3302 == BNIL);
							      }
							      if (test_3301)
								{
								   id_967 = car_900_190_992;
								   proto_968 = CAR(cdr_901_152_993);
								   cn_969 = car_911_5_998;
								 tag_864_33_970:
								   {
								      obj_t pid_1135;
								      pid_1135 = parse_id_241_ast_ident(id_967);
								      {
									 obj_t ln_1136;
									 ln_1136 = CAR(pid_1135);
									 {
									    obj_t type_1137;
									    {
									       type_t obj_2315;
									       {
										  obj_t aux_3307;
										  aux_3307 = CDR(pid_1135);
										  obj_2315 = (type_t) (aux_3307);
									       }
									       type_1137 = (((type_t) CREF(obj_2315))->id);
									    }
									    {
									       {
										  bool_t test1665_1138;
										  {
										     bool_t test1675_1147;
										     {
											obj_t x_2860;
											x_2860 = check_id_6_ast_ident(pid_1135, extern_64_23);
											test1675_1147 = ((bool_t) 1);
										     }
										     if (test1675_1147)
										       {
											  if (check_c_args__102_module_foreign(proto_968))
											    {
											       test1665_1138 = ((bool_t) 0);
											    }
											  else
											    {
											       test1665_1138 = ((bool_t) 1);
											    }
										       }
										     else
										       {
											  test1665_1138 = ((bool_t) 1);
										       }
										  }
										  if (test1665_1138)
										    {
										       obj_t list1670_1142;
										       list1670_1142 = MAKE_PAIR(BNIL, BNIL);
										       return user_error_151_tools_error(string2201_module_foreign, string2210_module_foreign, extern_64_23, list1670_1142);
										    }
										  else
										    {
										       global_t aux_3318;
										       {
											  bool_t aux_3319;
											  {
											     obj_t aux_3322;
											     obj_t aux_3320;
											     aux_3322 = CNST_TABLE_REF(((long) 4));
											     aux_3320 = CAR(extern_64_23);
											     aux_3319 = (aux_3320 == aux_3322);
											  }
											  aux_3318 = declare_global_cfun__81_ast_glo_decl_237(ln_1136, cn_969, type_1137, proto_968, aux_3319, ((bool_t) 1), extern_64_23);
										       }
										       return (obj_t) (aux_3318);
										    }
									       }
									    }
									 }
								      }
								   }
								}
							      else
								{
								 tag_866_189_974:
								   {
								      obj_t list1690_1163;
								      list1690_1163 = MAKE_PAIR(BNIL, BNIL);
								      return user_error_151_tools_error(string2201_module_foreign, string2210_module_foreign, extern_64_23, list1690_1163);
								   }
								}
							   }
							 else
							   {
							      goto tag_866_189_974;
							   }
						      }
						    else
						      {
							 obj_t car_963_37_1005;
							 obj_t cdr_964_146_1006;
							 car_963_37_1005 = CAR(cdr_896_76_989);
							 cdr_964_146_1006 = CDR(cdr_896_76_989);
							 if (SYMBOLP(car_963_37_1005))
							   {
							      obj_t car_972_152_1008;
							      car_972_152_1008 = CAR(cdr_964_146_1006);
							      if (STRINGP(car_972_152_1008))
								{
								   bool_t test_3337;
								   {
								      obj_t aux_3338;
								      aux_3338 = CDR(cdr_964_146_1006);
								      test_3337 = (aux_3338 == BNIL);
								   }
								   if (test_3337)
								     {
									id_971 = car_963_37_1005;
									c_name_211_972 = car_972_152_1008;
								      tag_865_4_973:
									{
									   obj_t pid_1150;
									   pid_1150 = parse_id_241_ast_ident(id_971);
									   {
									      obj_t l_name_185_1151;
									      l_name_185_1151 = CAR(pid_1150);
									      {
										 obj_t type_1152;
										 {
										    type_t obj_2321;
										    {
										       obj_t aux_3343;
										       aux_3343 = CDR(pid_1150);
										       obj_2321 = (type_t) (aux_3343);
										    }
										    type_1152 = (((type_t) CREF(obj_2321))->id);
										 }
										 {
										    {
										       bool_t test1678_1153;
										       {
											  obj_t x_2861;
											  x_2861 = check_id_6_ast_ident(pid_1150, extern_64_23);
											  test1678_1153 = ((bool_t) 1);
										       }
										       if (test1678_1153)
											 {
											    global_t aux_3349;
											    aux_3349 = declare_global_cvar__13_ast_glo_decl_237(l_name_185_1151, c_name_211_972, type_1152, ((bool_t) 1), extern_64_23);
											    return (obj_t) (aux_3349);
											 }
										       else
											 {
											    obj_t list1682_1157;
											    list1682_1157 = MAKE_PAIR(BNIL, BNIL);
											    return user_error_151_tools_error(string2201_module_foreign, string2210_module_foreign, extern_64_23, list1682_1157);
											 }
										    }
										 }
									      }
									   }
									}
								     }
								   else
								     {
									goto tag_866_189_974;
								     }
								}
							      else
								{
								   goto tag_866_189_974;
								}
							   }
							 else
							   {
							      goto tag_866_189_974;
							   }
						      }
						 }
					       else
						 {
						    goto tag_866_189_974;
						 }
					    }
					  else
					    {
					       obj_t car_1018_119_1014;
					       obj_t cdr_1019_21_1015;
					       car_1018_119_1014 = CAR(cdr_896_76_989);
					       cdr_1019_21_1015 = CDR(cdr_896_76_989);
					       if (SYMBOLP(car_1018_119_1014))
						 {
						    if (PAIRP(cdr_1019_21_1015))
						      {
							 obj_t car_1024_80_1018;
							 car_1024_80_1018 = CAR(cdr_1019_21_1015);
							 if (STRINGP(car_1024_80_1018))
							   {
							      bool_t test_3363;
							      {
								 obj_t aux_3364;
								 aux_3364 = CDR(cdr_1019_21_1015);
								 test_3363 = (aux_3364 == BNIL);
							      }
							      if (test_3363)
								{
								   obj_t c_name_211_3368;
								   obj_t id_3367;
								   id_3367 = car_1018_119_1014;
								   c_name_211_3368 = car_1024_80_1018;
								   c_name_211_972 = c_name_211_3368;
								   id_971 = id_3367;
								   goto tag_865_4_973;
								}
							      else
								{
								   goto tag_866_189_974;
								}
							   }
							 else
							   {
							      goto tag_866_189_974;
							   }
						      }
						    else
						      {
							 goto tag_866_189_974;
						      }
						 }
					       else
						 {
						    goto tag_866_189_974;
						 }
					    }
				       }
				     else
				       {
					  goto tag_866_189_974;
				       }
				  }
				else
				  {
				     bool_t test_3369;
				     {
					obj_t aux_3370;
					aux_3370 = CNST_TABLE_REF(((long) 4));
					test_3369 = (car_881_151_986 == aux_3370);
				     }
				     if (test_3369)
				       {
					  if (PAIRP(cdr_896_76_989))
					    {
					       obj_t cdr_1067_84_1026;
					       cdr_1067_84_1026 = CDR(cdr_896_76_989);
					       {
						  bool_t test_3376;
						  {
						     obj_t aux_3379;
						     obj_t aux_3377;
						     aux_3379 = CNST_TABLE_REF(((long) 8));
						     aux_3377 = CAR(cdr_896_76_989);
						     test_3376 = (aux_3377 == aux_3379);
						  }
						  if (test_3376)
						    {
						       if (PAIRP(cdr_1067_84_1026))
							 {
							    obj_t car_1071_20_1029;
							    obj_t cdr_1072_103_1030;
							    car_1071_20_1029 = CAR(cdr_1067_84_1026);
							    cdr_1072_103_1030 = CDR(cdr_1067_84_1026);
							    if (SYMBOLP(car_1071_20_1029))
							      {
								 if (PAIRP(cdr_1072_103_1030))
								   {
								      obj_t cdr_1079_167_1033;
								      cdr_1079_167_1033 = CDR(cdr_1072_103_1030);
								      if (PAIRP(cdr_1079_167_1033))
									{
									   obj_t car_1082_234_1035;
									   car_1082_234_1035 = CAR(cdr_1079_167_1033);
									   if (STRINGP(car_1082_234_1035))
									     {
										bool_t test_3396;
										{
										   obj_t aux_3397;
										   aux_3397 = CDR(cdr_1079_167_1033);
										   test_3396 = (aux_3397 == BNIL);
										}
										if (test_3396)
										  {
										     obj_t cn_3403;
										     obj_t proto_3401;
										     obj_t id_3400;
										     id_3400 = car_1071_20_1029;
										     proto_3401 = CAR(cdr_1072_103_1030);
										     cn_3403 = car_1082_234_1035;
										     cn_969 = cn_3403;
										     proto_968 = proto_3401;
										     id_967 = id_3400;
										     goto tag_864_33_970;
										  }
										else
										  {
										   tag_869_166_982:
										     {
											obj_t list1712_1190;
											list1712_1190 = MAKE_PAIR(BNIL, BNIL);
											return user_error_151_tools_error(string2201_module_foreign, string2210_module_foreign, extern_64_23, list1712_1190);
										     }
										  }
									     }
									   else
									     {
										goto tag_869_166_982;
									     }
									}
								      else
									{
									   goto tag_869_166_982;
									}
								   }
								 else
								   {
								      if (SYMBOLP(car_881_151_986))
									{
									   obj_t cdr_1180_170_1044;
									   cdr_1180_170_1044 = CDR(cdr_896_76_989);
									   {
									      obj_t car_1184_37_1045;
									      car_1184_37_1045 = CAR(cdr_1180_170_1044);
									      if (STRINGP(car_1184_37_1045))
										{
										   bool_t test_3412;
										   {
										      obj_t aux_3413;
										      aux_3413 = CDR(cdr_1180_170_1044);
										      test_3412 = (aux_3413 == BNIL);
										   }
										   if (test_3412)
										     {
											id_975 = car_881_151_986;
											proto_976 = CAR(cdr_896_76_989);
											cn_977 = car_1184_37_1045;
										      tag_867_8_978:
											{
											   obj_t pid_1165;
											   pid_1165 = parse_id_241_ast_ident(id_975);
											   {
											      obj_t ln_1166;
											      ln_1166 = CAR(pid_1165);
											      {
												 obj_t type_1167;
												 {
												    type_t obj_2324;
												    {
												       obj_t aux_3418;
												       aux_3418 = CDR(pid_1165);
												       obj_2324 = (type_t) (aux_3418);
												    }
												    type_1167 = (((type_t) CREF(obj_2324))->id);
												 }
												 {
												    {
												       bool_t test1692_1168;
												       {
													  bool_t test1698_1174;
													  {
													     obj_t x_2862;
													     x_2862 = check_id_6_ast_ident(pid_1165, extern_64_23);
													     test1698_1174 = ((bool_t) 1);
													  }
													  if (test1698_1174)
													    {
													       if (check_c_args__102_module_foreign(proto_976))
														 {
														    test1692_1168 = ((bool_t) 0);
														 }
													       else
														 {
														    test1692_1168 = ((bool_t) 1);
														 }
													    }
													  else
													    {
													       test1692_1168 = ((bool_t) 1);
													    }
												       }
												       if (test1692_1168)
													 {
													    obj_t list1696_1172;
													    list1696_1172 = MAKE_PAIR(BNIL, BNIL);
													    return user_error_151_tools_error(string2201_module_foreign, string2210_module_foreign, extern_64_23, list1696_1172);
													 }
												       else
													 {
													    global_t aux_3429;
													    aux_3429 = declare_global_cfun__81_ast_glo_decl_237(ln_1166, cn_977, type_1167, proto_976, ((bool_t) 0), ((bool_t) 0), extern_64_23);
													    return (obj_t) (aux_3429);
													 }
												    }
												 }
											      }
											   }
											}
										     }
										   else
										     {
											goto tag_869_166_982;
										     }
										}
									      else
										{
										   goto tag_869_166_982;
										}
									   }
									}
								      else
									{
									   goto tag_869_166_982;
									}
								   }
							      }
							    else
							      {
								 if (SYMBOLP(car_881_151_986))
								   {
								      obj_t cdr_1228_61_1054;
								      cdr_1228_61_1054 = CDR(cdr_896_76_989);
								      {
									 obj_t car_1231_190_1055;
									 car_1231_190_1055 = CAR(cdr_1228_61_1054);
									 if (STRINGP(car_1231_190_1055))
									   {
									      bool_t test_3439;
									      {
										 obj_t aux_3440;
										 aux_3440 = CDR(cdr_1228_61_1054);
										 test_3439 = (aux_3440 == BNIL);
									      }
									      if (test_3439)
										{
										   obj_t cn_3446;
										   obj_t proto_3444;
										   obj_t id_3443;
										   id_3443 = car_881_151_986;
										   proto_3444 = CAR(cdr_896_76_989);
										   cn_3446 = car_1231_190_1055;
										   cn_977 = cn_3446;
										   proto_976 = proto_3444;
										   id_975 = id_3443;
										   goto tag_867_8_978;
										}
									      else
										{
										   goto tag_869_166_982;
										}
									   }
									 else
									   {
									      goto tag_869_166_982;
									   }
								      }
								   }
								 else
								   {
								      goto tag_869_166_982;
								   }
							      }
							 }
						       else
							 {
							    if (SYMBOLP(car_881_151_986))
							      {
								 obj_t car_1275_183_1064;
								 car_1275_183_1064 = CAR(cdr_896_76_989);
								 if (STRINGP(car_1275_183_1064))
								   {
								      bool_t test_3452;
								      {
									 obj_t aux_3453;
									 aux_3453 = CDR(cdr_896_76_989);
									 test_3452 = (aux_3453 == BNIL);
								      }
								      if (test_3452)
									{
									   id_979 = car_881_151_986;
									   c_name_211_980 = car_1275_183_1064;
									 tag_868_80_981:
									   {
									      obj_t pid_1177;
									      pid_1177 = parse_id_241_ast_ident(id_979);
									      {
										 obj_t l_name_185_1178;
										 l_name_185_1178 = CAR(pid_1177);
										 {
										    obj_t type_1179;
										    {
										       type_t obj_2327;
										       {
											  obj_t aux_3458;
											  aux_3458 = CDR(pid_1177);
											  obj_2327 = (type_t) (aux_3458);
										       }
										       type_1179 = (((type_t) CREF(obj_2327))->id);
										    }
										    {
										       {
											  bool_t test1702_1180;
											  {
											     obj_t x_2863;
											     x_2863 = check_id_6_ast_ident(pid_1177, extern_64_23);
											     test1702_1180 = ((bool_t) 1);
											  }
											  if (test1702_1180)
											    {
											       global_t aux_3464;
											       aux_3464 = declare_global_cvar__13_ast_glo_decl_237(l_name_185_1178, c_name_211_980, type_1179, ((bool_t) 0), extern_64_23);
											       return (obj_t) (aux_3464);
											    }
											  else
											    {
											       obj_t list1706_1184;
											       list1706_1184 = MAKE_PAIR(BNIL, BNIL);
											       return user_error_151_tools_error(string2201_module_foreign, string2210_module_foreign, extern_64_23, list1706_1184);
											    }
										       }
										    }
										 }
									      }
									   }
									}
								      else
									{
									   goto tag_869_166_982;
									}
								   }
								 else
								   {
								      goto tag_869_166_982;
								   }
							      }
							    else
							      {
								 goto tag_869_166_982;
							      }
							 }
						    }
						  else
						    {
						       if (SYMBOLP(car_881_151_986))
							 {
							    obj_t cdr_1305_252_1072;
							    cdr_1305_252_1072 = CDR(cdr_896_76_989);
							    if (PAIRP(cdr_1305_252_1072))
							      {
								 obj_t car_1308_218_1074;
								 car_1308_218_1074 = CAR(cdr_1305_252_1072);
								 if (STRINGP(car_1308_218_1074))
								   {
								      bool_t test_3477;
								      {
									 obj_t aux_3478;
									 aux_3478 = CDR(cdr_1305_252_1072);
									 test_3477 = (aux_3478 == BNIL);
								      }
								      if (test_3477)
									{
									   obj_t cn_3484;
									   obj_t proto_3482;
									   obj_t id_3481;
									   id_3481 = car_881_151_986;
									   proto_3482 = CAR(cdr_896_76_989);
									   cn_3484 = car_1308_218_1074;
									   cn_977 = cn_3484;
									   proto_976 = proto_3482;
									   id_975 = id_3481;
									   goto tag_867_8_978;
									}
								      else
									{
									   goto tag_869_166_982;
									}
								   }
								 else
								   {
								      goto tag_869_166_982;
								   }
							      }
							    else
							      {
								 if (SYMBOLP(car_881_151_986))
								   {
								      obj_t car_1335_75_1083;
								      car_1335_75_1083 = CAR(cdr_896_76_989);
								      if (STRINGP(car_1335_75_1083))
									{
									   bool_t test_3490;
									   {
									      obj_t aux_3491;
									      aux_3491 = CDR(cdr_896_76_989);
									      test_3490 = (aux_3491 == BNIL);
									   }
									   if (test_3490)
									     {
										obj_t c_name_211_3495;
										obj_t id_3494;
										id_3494 = car_881_151_986;
										c_name_211_3495 = car_1335_75_1083;
										c_name_211_980 = c_name_211_3495;
										id_979 = id_3494;
										goto tag_868_80_981;
									     }
									   else
									     {
										goto tag_869_166_982;
									     }
									}
								      else
									{
									   goto tag_869_166_982;
									}
								   }
								 else
								   {
								      goto tag_869_166_982;
								   }
							      }
							 }
						       else
							 {
							    if (SYMBOLP(car_881_151_986))
							      {
								 obj_t car_1352_93_1091;
								 car_1352_93_1091 = CAR(cdr_896_76_989);
								 if (STRINGP(car_1352_93_1091))
								   {
								      bool_t test_3501;
								      {
									 obj_t aux_3502;
									 aux_3502 = CDR(cdr_896_76_989);
									 test_3501 = (aux_3502 == BNIL);
								      }
								      if (test_3501)
									{
									   obj_t c_name_211_3506;
									   obj_t id_3505;
									   id_3505 = car_881_151_986;
									   c_name_211_3506 = car_1352_93_1091;
									   c_name_211_980 = c_name_211_3506;
									   id_979 = id_3505;
									   goto tag_868_80_981;
									}
								      else
									{
									   goto tag_869_166_982;
									}
								   }
								 else
								   {
								      goto tag_869_166_982;
								   }
							      }
							    else
							      {
								 goto tag_869_166_982;
							      }
							 }
						    }
					       }
					    }
					  else
					    {
					       goto tag_869_166_982;
					    }
				       }
				     else
				       {
					  if (SYMBOLP(car_881_151_986))
					    {
					       if (PAIRP(cdr_896_76_989))
						 {
						    obj_t cdr_1403_20_1102;
						    cdr_1403_20_1102 = CDR(cdr_896_76_989);
						    if (PAIRP(cdr_1403_20_1102))
						      {
							 obj_t car_1406_60_1104;
							 car_1406_60_1104 = CAR(cdr_1403_20_1102);
							 if (STRINGP(car_1406_60_1104))
							   {
							      bool_t test_3517;
							      {
								 obj_t aux_3518;
								 aux_3518 = CDR(cdr_1403_20_1102);
								 test_3517 = (aux_3518 == BNIL);
							      }
							      if (test_3517)
								{
								   obj_t cn_3524;
								   obj_t proto_3522;
								   obj_t id_3521;
								   id_3521 = car_881_151_986;
								   proto_3522 = CAR(cdr_896_76_989);
								   cn_3524 = car_1406_60_1104;
								   cn_977 = cn_3524;
								   proto_976 = proto_3522;
								   id_975 = id_3521;
								   goto tag_867_8_978;
								}
							      else
								{
								   goto tag_869_166_982;
								}
							   }
							 else
							   {
							      goto tag_869_166_982;
							   }
						      }
						    else
						      {
							 if (SYMBOLP(car_881_151_986))
							   {
							      obj_t car_1438_132_1113;
							      car_1438_132_1113 = CAR(cdr_896_76_989);
							      if (STRINGP(car_1438_132_1113))
								{
								   bool_t test_3530;
								   {
								      obj_t aux_3531;
								      aux_3531 = CDR(cdr_896_76_989);
								      test_3530 = (aux_3531 == BNIL);
								   }
								   if (test_3530)
								     {
									obj_t c_name_211_3535;
									obj_t id_3534;
									id_3534 = car_881_151_986;
									c_name_211_3535 = car_1438_132_1113;
									c_name_211_980 = c_name_211_3535;
									id_979 = id_3534;
									goto tag_868_80_981;
								     }
								   else
								     {
									goto tag_869_166_982;
								     }
								}
							      else
								{
								   goto tag_869_166_982;
								}
							   }
							 else
							   {
							      goto tag_869_166_982;
							   }
						      }
						 }
					       else
						 {
						    goto tag_869_166_982;
						 }
					    }
					  else
					    {
					       if (SYMBOLP(car_881_151_986))
						 {
						    if (PAIRP(cdr_896_76_989))
						      {
							 obj_t car_1460_196_1122;
							 car_1460_196_1122 = CAR(cdr_896_76_989);
							 if (STRINGP(car_1460_196_1122))
							   {
							      bool_t test_3543;
							      {
								 obj_t aux_3544;
								 aux_3544 = CDR(cdr_896_76_989);
								 test_3543 = (aux_3544 == BNIL);
							      }
							      if (test_3543)
								{
								   obj_t c_name_211_3548;
								   obj_t id_3547;
								   id_3547 = car_881_151_986;
								   c_name_211_3548 = car_1460_196_1122;
								   c_name_211_980 = c_name_211_3548;
								   id_979 = id_3547;
								   goto tag_868_80_981;
								}
							      else
								{
								   goto tag_869_166_982;
								}
							   }
							 else
							   {
							      goto tag_869_166_982;
							   }
						      }
						    else
						      {
							 goto tag_869_166_982;
						      }
						 }
					       else
						 {
						    goto tag_869_166_982;
						 }
					    }
				       }
				  }
			     }
			  }
		     }
		}
	     }
	}
      else
	{
	   goto tag_869_166_982;
	}
   }
}


obj_t 
parse_c_foreign_type_105_module_foreign(obj_t type_24)
{
   {
      obj_t id_1195;
      obj_t t_exp_39_1196;
      obj_t name_1197;
      if (PAIRP(type_24))
	{
	   obj_t cdr_1514_50_1202;
	   cdr_1514_50_1202 = CDR(type_24);
	   {
	      bool_t test_3552;
	      {
		 obj_t aux_3555;
		 obj_t aux_3553;
		 aux_3555 = CNST_TABLE_REF(((long) 6));
		 aux_3553 = CAR(type_24);
		 test_3552 = (aux_3553 == aux_3555);
	      }
	      if (test_3552)
		{
		   if (PAIRP(cdr_1514_50_1202))
		     {
			obj_t car_1517_237_1205;
			obj_t cdr_1518_8_1206;
			car_1517_237_1205 = CAR(cdr_1514_50_1202);
			cdr_1518_8_1206 = CDR(cdr_1514_50_1202);
			if (SYMBOLP(car_1517_237_1205))
			  {
			     if (PAIRP(cdr_1518_8_1206))
			       {
				  obj_t car_1523_163_1209;
				  car_1523_163_1209 = CAR(cdr_1518_8_1206);
				  if (STRINGP(car_1523_163_1209))
				    {
				       bool_t test_3569;
				       {
					  obj_t aux_3570;
					  aux_3570 = CDR(cdr_1518_8_1206);
					  test_3569 = (aux_3570 == BNIL);
				       }
				       if (test_3569)
					 {
					    type_t aux_3573;
					    aux_3573 = declare_type__118_type_env(car_1517_237_1205, car_1523_163_1209, CNST_TABLE_REF(((long) 10)));
					    return (obj_t) (aux_3573);
					 }
				       else
					 {
					    obj_t car_1543_197_1213;
					    obj_t cdr_1544_189_1214;
					    car_1543_197_1213 = CAR(cdr_1514_50_1202);
					    cdr_1544_189_1214 = CDR(cdr_1514_50_1202);
					    if (SYMBOLP(car_1543_197_1213))
					      {
						 obj_t cdr_1554_16_1216;
						 cdr_1554_16_1216 = CDR(cdr_1544_189_1214);
						 if (PAIRP(cdr_1554_16_1216))
						   {
						      obj_t car_1558_125_1218;
						      car_1558_125_1218 = CAR(cdr_1554_16_1216);
						      if (STRINGP(car_1558_125_1218))
							{
							   bool_t test_3587;
							   {
							      obj_t aux_3588;
							      aux_3588 = CDR(cdr_1554_16_1216);
							      test_3587 = (aux_3588 == BNIL);
							   }
							   if (test_3587)
							     {
								id_1195 = car_1543_197_1213;
								t_exp_39_1196 = CAR(cdr_1544_189_1214);
								name_1197 = car_1558_125_1218;
							      tag_1505_107_1198:
								if (check_c_foreign_type_exp__43_module_foreign(t_exp_39_1196))
								  {
								     obj_t ctype_1255;
								     ctype_1255 = declare_c_type__49_foreign_ctype(type_24, id_1195, t_exp_39_1196, name_1197);
								     {
									bool_t test1757_1256;
									test1757_1256 = is_a__118___object(ctype_1255, type_type_type);
									if (test1757_1256)
									  {
									     obj_t accesses_1257;
									     accesses_1257 = make_ctype_accesses__219_foreign_access((type_t) (ctype_1255), (type_t) (ctype_1255));
									     __foreign_accesses__124_module_foreign = append_2_18___r4_pairs_and_lists_6_3(accesses_1257, __foreign_accesses__124_module_foreign);
									     {
										bool_t test1758_1258;
										{
										   bool_t test1781_1278;
										   test1781_1278 = is_a__118___object(ctype_1255, calias_foreign_ctype);
										   if (test1781_1278)
										     {
											obj_t aux_3602;
											{
											   type_t obj_2386;
											   obj_2386 = (type_t) (ctype_1255);
											   aux_3602 = (((type_t) CREF(obj_2386))->alias);
											}
											test1758_1258 = is_a__118___object(aux_3602, cstruct_foreign_ctype);
										     }
										   else
										     {
											test1758_1258 = ((bool_t) 0);
										     }
										}
										if (test1758_1258)
										  {
										     obj_t arg1759_1259;
										     {
											obj_t arg1761_1260;
											obj_t arg1762_1261;
											obj_t arg1763_1262;
											obj_t arg1764_1263;
											arg1761_1260 = CNST_TABLE_REF(((long) 6));
											{
											   obj_t list1774_1271;
											   {
											      obj_t arg1775_1272;
											      {
												 obj_t aux_3608;
												 aux_3608 = CNST_TABLE_REF(((long) 9));
												 arg1775_1272 = MAKE_PAIR(aux_3608, BNIL);
											      }
											      list1774_1271 = MAKE_PAIR(id_1195, arg1775_1272);
											   }
											   arg1762_1261 = symbol_append_197___r4_symbols_6_4(list1774_1271);
											}
											{
											   obj_t list1778_1275;
											   {
											      obj_t arg1779_1276;
											      {
												 obj_t aux_3613;
												 aux_3613 = CNST_TABLE_REF(((long) 9));
												 arg1779_1276 = MAKE_PAIR(aux_3613, BNIL);
											      }
											      list1778_1275 = MAKE_PAIR(t_exp_39_1196, arg1779_1276);
											   }
											   arg1763_1262 = symbol_append_197___r4_symbols_6_4(list1778_1275);
											}
											arg1764_1263 = make_pointer_to_name_76_type_tools((type_t) (ctype_1255));
											{
											   obj_t list1767_1265;
											   {
											      obj_t arg1769_1266;
											      {
												 obj_t arg1770_1267;
												 {
												    obj_t arg1771_1268;
												    arg1771_1268 = MAKE_PAIR(BNIL, BNIL);
												    arg1770_1267 = MAKE_PAIR(arg1764_1263, arg1771_1268);
												 }
												 arg1769_1266 = MAKE_PAIR(arg1763_1262, arg1770_1267);
											      }
											      list1767_1265 = MAKE_PAIR(arg1762_1261, arg1769_1266);
											   }
											   arg1759_1259 = cons__138___r4_pairs_and_lists_6_3(arg1761_1260, list1767_1265);
											}
										     }
										     parse_c_foreign_type_105_module_foreign(arg1759_1259);
										  }
										else
										  {
										     BUNSPEC;
										  }
									     }
									  }
									else
									  {
									     BUNSPEC;
									  }
								     }
								     return BUNSPEC;
								  }
								else
								  {
								     obj_t list1787_1283;
								     list1787_1283 = MAKE_PAIR(BNIL, BNIL);
								     return user_error_151_tools_error(string2201_module_foreign, string2211_module_foreign, type_24, list1787_1283);
								  }
							     }
							   else
							     {
							      tag_1506_87_1199:
								{
								   obj_t list1793_1288;
								   list1793_1288 = MAKE_PAIR(BNIL, BNIL);
								   return user_error_151_tools_error(string2201_module_foreign, string2211_module_foreign, type_24, list1793_1288);
								}
							     }
							}
						      else
							{
							   goto tag_1506_87_1199;
							}
						   }
						 else
						   {
						      goto tag_1506_87_1199;
						   }
					      }
					    else
					      {
						 goto tag_1506_87_1199;
					      }
					 }
				    }
				  else
				    {
				       obj_t car_1576_193_1227;
				       obj_t cdr_1577_233_1228;
				       car_1576_193_1227 = CAR(cdr_1514_50_1202);
				       cdr_1577_233_1228 = CDR(cdr_1514_50_1202);
				       if (SYMBOLP(car_1576_193_1227))
					 {
					    obj_t cdr_1586_162_1230;
					    cdr_1586_162_1230 = CDR(cdr_1577_233_1228);
					    if (PAIRP(cdr_1586_162_1230))
					      {
						 obj_t car_1589_208_1232;
						 car_1589_208_1232 = CAR(cdr_1586_162_1230);
						 if (STRINGP(car_1589_208_1232))
						   {
						      bool_t test_3641;
						      {
							 obj_t aux_3642;
							 aux_3642 = CDR(cdr_1586_162_1230);
							 test_3641 = (aux_3642 == BNIL);
						      }
						      if (test_3641)
							{
							   obj_t name_3648;
							   obj_t t_exp_39_3646;
							   obj_t id_3645;
							   id_3645 = car_1576_193_1227;
							   t_exp_39_3646 = CAR(cdr_1577_233_1228);
							   name_3648 = car_1589_208_1232;
							   name_1197 = name_3648;
							   t_exp_39_1196 = t_exp_39_3646;
							   id_1195 = id_3645;
							   goto tag_1505_107_1198;
							}
						      else
							{
							   goto tag_1506_87_1199;
							}
						   }
						 else
						   {
						      goto tag_1506_87_1199;
						   }
					      }
					    else
					      {
						 goto tag_1506_87_1199;
					      }
					 }
				       else
					 {
					    goto tag_1506_87_1199;
					 }
				    }
			       }
			     else
			       {
				  goto tag_1506_87_1199;
			       }
			  }
			else
			  {
			     obj_t car_1612_95_1239;
			     obj_t cdr_1613_147_1240;
			     car_1612_95_1239 = CAR(cdr_1514_50_1202);
			     cdr_1613_147_1240 = CDR(cdr_1514_50_1202);
			     if (SYMBOLP(car_1612_95_1239))
			       {
				  if (PAIRP(cdr_1613_147_1240))
				    {
				       obj_t cdr_1620_54_1243;
				       cdr_1620_54_1243 = CDR(cdr_1613_147_1240);
				       if (PAIRP(cdr_1620_54_1243))
					 {
					    obj_t car_1623_216_1245;
					    car_1623_216_1245 = CAR(cdr_1620_54_1243);
					    if (STRINGP(car_1623_216_1245))
					      {
						 bool_t test_3661;
						 {
						    obj_t aux_3662;
						    aux_3662 = CDR(cdr_1620_54_1243);
						    test_3661 = (aux_3662 == BNIL);
						 }
						 if (test_3661)
						   {
						      obj_t name_3668;
						      obj_t t_exp_39_3666;
						      obj_t id_3665;
						      id_3665 = car_1612_95_1239;
						      t_exp_39_3666 = CAR(cdr_1613_147_1240);
						      name_3668 = car_1623_216_1245;
						      name_1197 = name_3668;
						      t_exp_39_1196 = t_exp_39_3666;
						      id_1195 = id_3665;
						      goto tag_1505_107_1198;
						   }
						 else
						   {
						      goto tag_1506_87_1199;
						   }
					      }
					    else
					      {
						 goto tag_1506_87_1199;
					      }
					 }
				       else
					 {
					    goto tag_1506_87_1199;
					 }
				    }
				  else
				    {
				       goto tag_1506_87_1199;
				    }
			       }
			     else
			       {
				  goto tag_1506_87_1199;
			       }
			  }
		     }
		   else
		     {
			goto tag_1506_87_1199;
		     }
		}
	      else
		{
		   goto tag_1506_87_1199;
		}
	   }
	}
      else
	{
	   goto tag_1506_87_1199;
	}
   }
}


bool_t 
check_c_foreign_type_exp__43_module_foreign(obj_t t_exp_39_25)
{
   {
      obj_t slots_1298;
      obj_t slots_1291;
      if (SYMBOLP(t_exp_39_25))
	{
	   return ((bool_t) 1);
	}
      else
	{
	   if (PAIRP(t_exp_39_25))
	     {
		obj_t car_1660_149_1304;
		car_1660_149_1304 = CAR(t_exp_39_25);
		{
		   {
		      bool_t test_3674;
		      {
			 obj_t aux_3675;
			 aux_3675 = CNST_TABLE_REF(((long) 11));
			 test_3674 = (car_1660_149_1304 == aux_3675);
		      }
		      if (test_3674)
			{
			 kap_1662_215_1305:
			   slots_1291 = CDR(t_exp_39_25);
			   {
			      obj_t slots_1425;
			      slots_1425 = slots_1291;
			    loop_1426:
			      if (NULLP(slots_1425))
				{
				   return ((bool_t) 1);
				}
			      else
				{
				   {
				      obj_t e_1871_173_1430;
				      e_1871_173_1430 = CAR(slots_1425);
				      if (PAIRP(e_1871_173_1430))
					{
					   obj_t cdr_1873_223_1432;
					   cdr_1873_223_1432 = CDR(e_1871_173_1430);
					   {
					      bool_t test_3684;
					      {
						 obj_t aux_3685;
						 aux_3685 = CAR(e_1871_173_1430);
						 test_3684 = SYMBOLP(aux_3685);
					      }
					      if (test_3684)
						{
						   if (PAIRP(cdr_1873_223_1432))
						     {
							obj_t cdr_1875_213_1435;
							cdr_1875_213_1435 = CDR(cdr_1873_223_1432);
							{
							   bool_t test_3691;
							   {
							      obj_t aux_3692;
							      aux_3692 = CAR(cdr_1873_223_1432);
							      test_3691 = SYMBOLP(aux_3692);
							   }
							   if (test_3691)
							     {
								if (PAIRP(cdr_1875_213_1435))
								  {
								     bool_t test_3697;
								     {
									obj_t aux_3698;
									aux_3698 = CAR(cdr_1875_213_1435);
									test_3697 = STRINGP(aux_3698);
								     }
								     if (test_3697)
								       {
									  bool_t test_3701;
									  {
									     obj_t aux_3702;
									     aux_3702 = CDR(cdr_1875_213_1435);
									     test_3701 = (aux_3702 == BNIL);
									  }
									  if (test_3701)
									    {
									       {
										  obj_t slots_3705;
										  slots_3705 = CDR(slots_1425);
										  slots_1425 = slots_3705;
										  goto loop_1426;
									       }
									    }
									  else
									    {
									       return ((bool_t) 0);
									    }
								       }
								     else
								       {
									  return ((bool_t) 0);
								       }
								  }
								else
								  {
								     return ((bool_t) 0);
								  }
							     }
							   else
							     {
								return ((bool_t) 0);
							     }
							}
						     }
						   else
						     {
							return ((bool_t) 0);
						     }
						}
					      else
						{
						   return ((bool_t) 0);
						}
					   }
					}
				      else
					{
					   return ((bool_t) 0);
					}
				   }
				}
			   }
			}
		      else
			{
			   bool_t test_3708;
			   {
			      obj_t aux_3709;
			      aux_3709 = CNST_TABLE_REF(((long) 12));
			      test_3708 = (car_1660_149_1304 == aux_3709);
			   }
			   if (test_3708)
			     {
				goto kap_1662_215_1305;
			     }
			   else
			     {
				obj_t cdr_1667_214_1308;
				cdr_1667_214_1308 = CDR(t_exp_39_25);
				{
				   bool_t test_3713;
				   {
				      obj_t aux_3714;
				      aux_3714 = CNST_TABLE_REF(((long) 13));
				      test_3713 = (car_1660_149_1304 == aux_3714);
				   }
				   if (test_3713)
				     {
					if (PAIRP(cdr_1667_214_1308))
					  {
					     bool_t test_3719;
					     {
						obj_t aux_3720;
						aux_3720 = CAR(cdr_1667_214_1308);
						test_3719 = SYMBOLP(aux_3720);
					     }
					     if (test_3719)
					       {
						  bool_t test_3723;
						  {
						     obj_t aux_3724;
						     aux_3724 = CDR(cdr_1667_214_1308);
						     test_3723 = (aux_3724 == BNIL);
						  }
						  if (test_3723)
						    {
						       return ((bool_t) 1);
						    }
						  else
						    {
						       return ((bool_t) 0);
						    }
					       }
					     else
					       {
						  return ((bool_t) 0);
					       }
					  }
					else
					  {
					     return ((bool_t) 0);
					  }
				     }
				   else
				     {
					{
					   bool_t test_3727;
					   {
					      obj_t aux_3728;
					      aux_3728 = CNST_TABLE_REF(((long) 17));
					      test_3727 = (car_1660_149_1304 == aux_3728);
					   }
					   if (test_3727)
					     {
					      kap_1720_15_1325:
						if (PAIRP(cdr_1667_214_1308))
						  {
						     bool_t test_3733;
						     {
							obj_t aux_3734;
							aux_3734 = CAR(cdr_1667_214_1308);
							test_3733 = SYMBOLP(aux_3734);
						     }
						     if (test_3733)
						       {
							  bool_t test_3737;
							  {
							     obj_t aux_3738;
							     aux_3738 = CDR(cdr_1667_214_1308);
							     test_3737 = (aux_3738 == BNIL);
							  }
							  if (test_3737)
							    {
							       return ((bool_t) 1);
							    }
							  else
							    {
							       obj_t cdr_1729_74_1364;
							       cdr_1729_74_1364 = CDR(t_exp_39_25);
							       {
								  bool_t test_3742;
								  {
								     obj_t aux_3745;
								     obj_t aux_3743;
								     aux_3745 = CNST_TABLE_REF(((long) 14));
								     aux_3743 = CAR(t_exp_39_25);
								     test_3742 = (aux_3743 == aux_3745);
								  }
								  if (test_3742)
								    {
								       obj_t cdr_1732_77_1366;
								       cdr_1732_77_1366 = CDR(cdr_1729_74_1364);
								       {
									  bool_t test_3749;
									  {
									     obj_t aux_3750;
									     aux_3750 = CAR(cdr_1729_74_1364);
									     test_3749 = SYMBOLP(aux_3750);
									  }
									  if (test_3749)
									    {
									       if (PAIRP(cdr_1732_77_1366))
										 {
										    obj_t car_1734_79_1369;
										    car_1734_79_1369 = CAR(cdr_1732_77_1366);
										    {
										       if ((car_1734_79_1369 == BNIL))
											 {
											  kap_1738_113_1370:
											    {
											       bool_t test_3758;
											       {
												  obj_t aux_3759;
												  aux_3759 = CDR(cdr_1732_77_1366);
												  test_3758 = (aux_3759 == BNIL);
											       }
											       if (test_3758)
												 {
												    return check_c_args__102_module_foreign(car_1734_79_1369);
												 }
											       else
												 {
												    return ((bool_t) 0);
												 }
											    }
											 }
										       else
											 {
											    if (PAIRP(car_1734_79_1369))
											      {
												 goto kap_1738_113_1370;
											      }
											    else
											      {
												 return ((bool_t) 0);
											      }
											 }
										    }
										 }
									       else
										 {
										    return ((bool_t) 0);
										 }
									    }
									  else
									    {
									       return ((bool_t) 0);
									    }
								       }
								    }
								  else
								    {
								       bool_t test_3765;
								       {
									  obj_t aux_3768;
									  obj_t aux_3766;
									  aux_3768 = CNST_TABLE_REF(((long) 15));
									  aux_3766 = CAR(t_exp_39_25);
									  test_3765 = (aux_3766 == aux_3768);
								       }
								       if (test_3765)
									 {
									    slots_1298 = cdr_1729_74_1364;
									  tag_1652_79_1299:
									    {
									       obj_t slots_1446;
									       slots_1446 = slots_1298;
									     loop_1447:
									       if (NULLP(slots_1446))
										 {
										    return ((bool_t) 1);
										 }
									       else
										 {
										    {
										       obj_t e_1880_82_1451;
										       e_1880_82_1451 = CAR(slots_1446);
										       if (PAIRP(e_1880_82_1451))
											 {
											    obj_t cdr_1882_223_1453;
											    cdr_1882_223_1453 = CDR(e_1880_82_1451);
											    {
											       bool_t test_3777;
											       {
												  obj_t aux_3778;
												  aux_3778 = CAR(e_1880_82_1451);
												  test_3777 = SYMBOLP(aux_3778);
											       }
											       if (test_3777)
												 {
												    if (PAIRP(cdr_1882_223_1453))
												      {
													 bool_t test_3783;
													 {
													    obj_t aux_3784;
													    aux_3784 = CAR(cdr_1882_223_1453);
													    test_3783 = STRINGP(aux_3784);
													 }
													 if (test_3783)
													   {
													      bool_t test_3787;
													      {
														 obj_t aux_3788;
														 aux_3788 = CDR(cdr_1882_223_1453);
														 test_3787 = (aux_3788 == BNIL);
													      }
													      if (test_3787)
														{
														   {
														      obj_t slots_3791;
														      slots_3791 = CDR(slots_1446);
														      slots_1446 = slots_3791;
														      goto loop_1447;
														   }
														}
													      else
														{
														   return ((bool_t) 0);
														}
													   }
													 else
													   {
													      return ((bool_t) 0);
													   }
												      }
												    else
												      {
													 return ((bool_t) 0);
												      }
												 }
											       else
												 {
												    return ((bool_t) 0);
												 }
											    }
											 }
										       else
											 {
											    return ((bool_t) 0);
											 }
										    }
										 }
									    }
									 }
								       else
									 {
									    return ((bool_t) 0);
									 }
								    }
							       }
							    }
						       }
						     else
						       {
							  obj_t cdr_1756_13_1386;
							  cdr_1756_13_1386 = CDR(t_exp_39_25);
							  {
							     bool_t test_3794;
							     {
								obj_t aux_3797;
								obj_t aux_3795;
								aux_3797 = CNST_TABLE_REF(((long) 16));
								aux_3795 = CAR(t_exp_39_25);
								test_3794 = (aux_3795 == aux_3797);
							     }
							     if (test_3794)
							       {
								  bool_t test_3800;
								  {
								     obj_t aux_3801;
								     aux_3801 = CAR(cdr_1756_13_1386);
								     test_3800 = SYMBOLP(aux_3801);
								  }
								  if (test_3800)
								    {
								       bool_t test_3804;
								       {
									  obj_t aux_3805;
									  aux_3805 = CDR(cdr_1756_13_1386);
									  test_3804 = (aux_3805 == BNIL);
								       }
								       if (test_3804)
									 {
									    return ((bool_t) 1);
									 }
								       else
									 {
									    return ((bool_t) 0);
									 }
								    }
								  else
								    {
								       return ((bool_t) 0);
								    }
							       }
							     else
							       {
								  bool_t test_3808;
								  {
								     obj_t aux_3811;
								     obj_t aux_3809;
								     aux_3811 = CNST_TABLE_REF(((long) 14));
								     aux_3809 = CAR(t_exp_39_25);
								     test_3808 = (aux_3809 == aux_3811);
								  }
								  if (test_3808)
								    {
								       obj_t cdr_1776_125_1395;
								       cdr_1776_125_1395 = CDR(cdr_1756_13_1386);
								       {
									  bool_t test_3815;
									  {
									     obj_t aux_3816;
									     aux_3816 = CAR(cdr_1756_13_1386);
									     test_3815 = SYMBOLP(aux_3816);
									  }
									  if (test_3815)
									    {
									       if (PAIRP(cdr_1776_125_1395))
										 {
										    obj_t car_1778_192_1398;
										    car_1778_192_1398 = CAR(cdr_1776_125_1395);
										    {
										       if ((car_1778_192_1398 == BNIL))
											 {
											  kap_1782_1_1399:
											    {
											       bool_t test_3824;
											       {
												  obj_t aux_3825;
												  aux_3825 = CDR(cdr_1776_125_1395);
												  test_3824 = (aux_3825 == BNIL);
											       }
											       if (test_3824)
												 {
												    return check_c_args__102_module_foreign(car_1778_192_1398);
												 }
											       else
												 {
												    return ((bool_t) 0);
												 }
											    }
											 }
										       else
											 {
											    if (PAIRP(car_1778_192_1398))
											      {
												 goto kap_1782_1_1399;
											      }
											    else
											      {
												 return ((bool_t) 0);
											      }
											 }
										    }
										 }
									       else
										 {
										    return ((bool_t) 0);
										 }
									    }
									  else
									    {
									       return ((bool_t) 0);
									    }
								       }
								    }
								  else
								    {
								       bool_t test_3831;
								       {
									  obj_t aux_3834;
									  obj_t aux_3832;
									  aux_3834 = CNST_TABLE_REF(((long) 15));
									  aux_3832 = CAR(t_exp_39_25);
									  test_3831 = (aux_3832 == aux_3834);
								       }
								       if (test_3831)
									 {
									    obj_t slots_3837;
									    slots_3837 = cdr_1756_13_1386;
									    slots_1298 = slots_3837;
									    goto tag_1652_79_1299;
									 }
								       else
									 {
									    return ((bool_t) 0);
									 }
								    }
							       }
							  }
						       }
						  }
						else
						  {
						     bool_t test_3838;
						     {
							obj_t aux_3841;
							obj_t aux_3839;
							aux_3841 = CNST_TABLE_REF(((long) 15));
							aux_3839 = CAR(t_exp_39_25);
							test_3838 = (aux_3839 == aux_3841);
						     }
						     if (test_3838)
						       {
							  obj_t slots_3844;
							  slots_3844 = CDR(t_exp_39_25);
							  slots_1298 = slots_3844;
							  goto tag_1652_79_1299;
						       }
						     else
						       {
							  return ((bool_t) 0);
						       }
						  }
					     }
					   else
					     {
						bool_t test_3846;
						{
						   obj_t aux_3847;
						   aux_3847 = CNST_TABLE_REF(((long) 18));
						   test_3846 = (car_1660_149_1304 == aux_3847);
						}
						if (test_3846)
						  {
						     goto kap_1720_15_1325;
						  }
						else
						  {
						     bool_t test_3850;
						     {
							obj_t aux_3851;
							aux_3851 = CNST_TABLE_REF(((long) 16));
							test_3850 = (car_1660_149_1304 == aux_3851);
						     }
						     if (test_3850)
						       {
							  if (PAIRP(cdr_1667_214_1308))
							    {
							       bool_t test_3856;
							       {
								  obj_t aux_3857;
								  aux_3857 = CAR(cdr_1667_214_1308);
								  test_3856 = SYMBOLP(aux_3857);
							       }
							       if (test_3856)
								 {
								    bool_t test_3860;
								    {
								       obj_t aux_3861;
								       aux_3861 = CDR(cdr_1667_214_1308);
								       test_3860 = (aux_3861 == BNIL);
								    }
								    if (test_3860)
								      {
									 return ((bool_t) 1);
								      }
								    else
								      {
									 return ((bool_t) 0);
								      }
								 }
							       else
								 {
								    return ((bool_t) 0);
								 }
							    }
							  else
							    {
							       return ((bool_t) 0);
							    }
						       }
						     else
						       {
							  bool_t test_3864;
							  {
							     obj_t aux_3865;
							     aux_3865 = CNST_TABLE_REF(((long) 14));
							     test_3864 = (car_1660_149_1304 == aux_3865);
							  }
							  if (test_3864)
							    {
							       if (PAIRP(cdr_1667_214_1308))
								 {
								    obj_t cdr_1835_3_1339;
								    cdr_1835_3_1339 = CDR(cdr_1667_214_1308);
								    {
								       bool_t test_3871;
								       {
									  obj_t aux_3872;
									  aux_3872 = CAR(cdr_1667_214_1308);
									  test_3871 = SYMBOLP(aux_3872);
								       }
								       if (test_3871)
									 {
									    if (PAIRP(cdr_1835_3_1339))
									      {
										 obj_t car_1837_107_1342;
										 car_1837_107_1342 = CAR(cdr_1835_3_1339);
										 {
										    if ((car_1837_107_1342 == BNIL))
										      {
										       kap_1841_24_1343:
											 {
											    bool_t test_3880;
											    {
											       obj_t aux_3881;
											       aux_3881 = CDR(cdr_1835_3_1339);
											       test_3880 = (aux_3881 == BNIL);
											    }
											    if (test_3880)
											      {
												 return check_c_args__102_module_foreign(car_1837_107_1342);
											      }
											    else
											      {
												 return ((bool_t) 0);
											      }
											 }
										      }
										    else
										      {
											 if (PAIRP(car_1837_107_1342))
											   {
											      goto kap_1841_24_1343;
											   }
											 else
											   {
											      return ((bool_t) 0);
											   }
										      }
										 }
									      }
									    else
									      {
										 return ((bool_t) 0);
									      }
									 }
								       else
									 {
									    return ((bool_t) 0);
									 }
								    }
								 }
							       else
								 {
								    return ((bool_t) 0);
								 }
							    }
							  else
							    {
							       bool_t test_3887;
							       {
								  obj_t aux_3888;
								  aux_3888 = CNST_TABLE_REF(((long) 15));
								  test_3887 = (car_1660_149_1304 == aux_3888);
							       }
							       if (test_3887)
								 {
								    obj_t slots_3891;
								    slots_3891 = cdr_1667_214_1308;
								    slots_1298 = slots_3891;
								    goto tag_1652_79_1299;
								 }
							       else
								 {
								    return ((bool_t) 0);
								 }
							    }
						       }
						  }
					     }
					}
				     }
				}
			     }
			}
		   }
		}
	     }
	   else
	     {
		return ((bool_t) 0);
	     }
	}
   }
}


obj_t 
parse_c_extern_type_73_module_foreign(obj_t type_26)
{
   {
      obj_t id_1466;
      obj_t t_exp_39_1467;
      if (PAIRP(type_26))
	{
	   obj_t cdr_1895_88_1472;
	   cdr_1895_88_1472 = CDR(type_26);
	   {
	      bool_t test_3895;
	      {
		 obj_t aux_3898;
		 obj_t aux_3896;
		 aux_3898 = CNST_TABLE_REF(((long) 6));
		 aux_3896 = CAR(type_26);
		 test_3895 = (aux_3896 == aux_3898);
	      }
	      if (test_3895)
		{
		   if (PAIRP(cdr_1895_88_1472))
		     {
			obj_t cdr_1899_116_1476;
			cdr_1899_116_1476 = CDR(cdr_1895_88_1472);
			{
			   bool_t test_3904;
			   {
			      obj_t aux_3905;
			      aux_3905 = CAR(cdr_1895_88_1472);
			      test_3904 = SYMBOLP(aux_3905);
			   }
			   if (test_3904)
			     {
				if (PAIRP(cdr_1899_116_1476))
				  {
				     bool_t test_3910;
				     {
					obj_t aux_3911;
					aux_3911 = CAR(cdr_1899_116_1476);
					test_3910 = STRINGP(aux_3911);
				     }
				     if (test_3910)
				       {
					  bool_t test_3914;
					  {
					     obj_t aux_3915;
					     aux_3915 = CDR(cdr_1899_116_1476);
					     test_3914 = (aux_3915 == BNIL);
					  }
					  if (test_3914)
					    {
					       return parse_c_foreign_type_105_module_foreign(type_26);
					    }
					  else
					    {
					       obj_t car_1921_251_1483;
					       obj_t cdr_1922_83_1484;
					       car_1921_251_1483 = CAR(cdr_1895_88_1472);
					       cdr_1922_83_1484 = CDR(cdr_1895_88_1472);
					       if (SYMBOLP(car_1921_251_1483))
						 {
						    obj_t cdr_1931_56_1486;
						    cdr_1931_56_1486 = CDR(cdr_1922_83_1484);
						    if (PAIRP(cdr_1931_56_1486))
						      {
							 bool_t test_3926;
							 {
							    obj_t aux_3927;
							    aux_3927 = CAR(cdr_1931_56_1486);
							    test_3926 = STRINGP(aux_3927);
							 }
							 if (test_3926)
							   {
							      bool_t test_3930;
							      {
								 obj_t aux_3931;
								 aux_3931 = CDR(cdr_1931_56_1486);
								 test_3930 = (aux_3931 == BNIL);
							      }
							      if (test_3930)
								{
								   id_1466 = car_1921_251_1483;
								   t_exp_39_1467 = CAR(cdr_1922_83_1484);
								 tag_1886_146_1468:
								   {
								      obj_t foreign_type_139_1523;
								      foreign_type_139_1523 = c_extern_type__c_foreign_type_30_module_foreign(t_exp_39_1467);
								      if (CBOOL(foreign_type_139_1523))
									{
									   return parse_c_foreign_type_105_module_foreign(type_26);
									}
								      else
									{
									   obj_t list1971_1527;
									   list1971_1527 = MAKE_PAIR(BNIL, BNIL);
									   return user_error_151_tools_error(string2201_module_foreign, string2212_module_foreign, type_26, list1971_1527);
									}
								   }
								}
							      else
								{
								 tag_1887_184_1469:
								   {
								      obj_t list1976_1532;
								      list1976_1532 = MAKE_PAIR(BNIL, BNIL);
								      return user_error_151_tools_error(string2201_module_foreign, string2212_module_foreign, type_26, list1976_1532);
								   }
								}
							   }
							 else
							   {
							      goto tag_1887_184_1469;
							   }
						      }
						    else
						      {
							 goto tag_1887_184_1469;
						      }
						 }
					       else
						 {
						    goto tag_1887_184_1469;
						 }
					    }
				       }
				     else
				       {
					  obj_t car_1946_71_1497;
					  obj_t cdr_1947_50_1498;
					  car_1946_71_1497 = CAR(cdr_1895_88_1472);
					  cdr_1947_50_1498 = CDR(cdr_1895_88_1472);
					  if (SYMBOLP(car_1946_71_1497))
					    {
					       obj_t cdr_1955_87_1500;
					       cdr_1955_87_1500 = CDR(cdr_1947_50_1498);
					       if (PAIRP(cdr_1955_87_1500))
						 {
						    bool_t test_3950;
						    {
						       obj_t aux_3951;
						       aux_3951 = CAR(cdr_1955_87_1500);
						       test_3950 = STRINGP(aux_3951);
						    }
						    if (test_3950)
						      {
							 bool_t test_3954;
							 {
							    obj_t aux_3955;
							    aux_3955 = CDR(cdr_1955_87_1500);
							    test_3954 = (aux_3955 == BNIL);
							 }
							 if (test_3954)
							   {
							      obj_t t_exp_39_3959;
							      obj_t id_3958;
							      id_3958 = car_1946_71_1497;
							      t_exp_39_3959 = CAR(cdr_1947_50_1498);
							      t_exp_39_1467 = t_exp_39_3959;
							      id_1466 = id_3958;
							      goto tag_1886_146_1468;
							   }
							 else
							   {
							      goto tag_1887_184_1469;
							   }
						      }
						    else
						      {
							 goto tag_1887_184_1469;
						      }
						 }
					       else
						 {
						    goto tag_1887_184_1469;
						 }
					    }
					  else
					    {
					       goto tag_1887_184_1469;
					    }
				       }
				  }
				else
				  {
				     goto tag_1887_184_1469;
				  }
			     }
			   else
			     {
				obj_t car_1972_153_1509;
				obj_t cdr_1973_27_1510;
				car_1972_153_1509 = CAR(cdr_1895_88_1472);
				cdr_1973_27_1510 = CDR(cdr_1895_88_1472);
				if (SYMBOLP(car_1972_153_1509))
				  {
				     if (PAIRP(cdr_1973_27_1510))
				       {
					  obj_t cdr_1979_132_1513;
					  cdr_1979_132_1513 = CDR(cdr_1973_27_1510);
					  if (PAIRP(cdr_1979_132_1513))
					    {
					       bool_t test_3970;
					       {
						  obj_t aux_3971;
						  aux_3971 = CAR(cdr_1979_132_1513);
						  test_3970 = STRINGP(aux_3971);
					       }
					       if (test_3970)
						 {
						    bool_t test_3974;
						    {
						       obj_t aux_3975;
						       aux_3975 = CDR(cdr_1979_132_1513);
						       test_3974 = (aux_3975 == BNIL);
						    }
						    if (test_3974)
						      {
							 obj_t t_exp_39_3979;
							 obj_t id_3978;
							 id_3978 = car_1972_153_1509;
							 t_exp_39_3979 = CAR(cdr_1973_27_1510);
							 t_exp_39_1467 = t_exp_39_3979;
							 id_1466 = id_3978;
							 goto tag_1886_146_1468;
						      }
						    else
						      {
							 goto tag_1887_184_1469;
						      }
						 }
					       else
						 {
						    goto tag_1887_184_1469;
						 }
					    }
					  else
					    {
					       goto tag_1887_184_1469;
					    }
				       }
				     else
				       {
					  goto tag_1887_184_1469;
				       }
				  }
				else
				  {
				     goto tag_1887_184_1469;
				  }
			     }
			}
		     }
		   else
		     {
			goto tag_1887_184_1469;
		     }
		}
	      else
		{
		   goto tag_1887_184_1469;
		}
	   }
	}
      else
	{
	   goto tag_1887_184_1469;
	}
   }
}


obj_t 
c_extern_type__c_foreign_type_30_module_foreign(obj_t t_exp_39_27)
{
   {
      obj_t slots_1542;
      obj_t slots_1535;
      if (SYMBOLP(t_exp_39_27))
	{
	   return t_exp_39_27;
	}
      else
	{
	   if (PAIRP(t_exp_39_27))
	     {
		obj_t car_2009_230_1548;
		car_2009_230_1548 = CAR(t_exp_39_27);
		{
		   {
		      bool_t test_3986;
		      {
			 obj_t aux_3987;
			 aux_3987 = CNST_TABLE_REF(((long) 11));
			 test_3986 = (car_2009_230_1548 == aux_3987);
		      }
		      if (test_3986)
			{
			 kap_2011_203_1549:
			   slots_1535 = CDR(t_exp_39_27);
			   {
			      obj_t slots_1669;
			      slots_1669 = slots_1535;
			    loop_1670:
			      if (NULLP(slots_1669))
				{
				   return t_exp_39_27;
				}
			      else
				{
				   obj_t id_1672;
				   obj_t name_1673;
				   {
				      obj_t e_2220_53_1676;
				      e_2220_53_1676 = CAR(slots_1669);
				      if (PAIRP(e_2220_53_1676))
					{
					   obj_t car_2225_124_1678;
					   obj_t cdr_2226_104_1679;
					   car_2225_124_1678 = CAR(e_2220_53_1676);
					   cdr_2226_104_1679 = CDR(e_2220_53_1676);
					   if (SYMBOLP(car_2225_124_1678))
					     {
						if (PAIRP(cdr_2226_104_1679))
						  {
						     obj_t car_2230_3_1682;
						     car_2230_3_1682 = CAR(cdr_2226_104_1679);
						     if (STRINGP(car_2230_3_1682))
						       {
							  bool_t test_4004;
							  {
							     obj_t aux_4005;
							     aux_4005 = CDR(cdr_2226_104_1679);
							     test_4004 = (aux_4005 == BNIL);
							  }
							  if (test_4004)
							    {
							       id_1672 = car_2225_124_1678;
							       name_1673 = car_2230_3_1682;
							       {
								  obj_t pid_1687;
								  pid_1687 = parse_id_241_ast_ident(id_1672);
								  {
								     obj_t sid_1688;
								     sid_1688 = CAR(pid_1687);
								     {
									obj_t type_1689;
									{
									   type_t obj_2719;
									   {
									      obj_t aux_4010;
									      aux_4010 = CDR(pid_1687);
									      obj_2719 = (type_t) (aux_4010);
									   }
									   type_1689 = (((type_t) CREF(obj_2719))->id);
									}
									{
									   {
									      bool_t test2100_1690;
									      {
										 obj_t x_2864;
										 x_2864 = check_id_6_ast_ident(pid_1687, t_exp_39_27);
										 test2100_1690 = ((bool_t) 1);
									      }
									      if (test2100_1690)
										{
										   {
										      obj_t arg2101_1691;
										      obj_t arg2102_1692;
										      arg2101_1691 = CAR(slots_1669);
										      {
											 obj_t arg2103_1693;
											 arg2103_1693 = MAKE_PAIR(name_1673, BNIL);
											 arg2102_1692 = MAKE_PAIR(sid_1688, arg2103_1693);
										      }
										      SET_CDR(arg2101_1691, arg2102_1692);
										   }
										   {
										      obj_t aux_4020;
										      aux_4020 = CAR(slots_1669);
										      SET_CAR(aux_4020, type_1689);
										   }
										   {
										      obj_t slots_4023;
										      slots_4023 = CDR(slots_1669);
										      slots_1669 = slots_4023;
										      goto loop_1670;
										   }
										}
									      else
										{
										   return BFALSE;
										}
									   }
									}
								     }
								  }
							       }
							    }
							  else
							    {
							       return BFALSE;
							    }
						       }
						     else
						       {
							  return BFALSE;
						       }
						  }
						else
						  {
						     return BFALSE;
						  }
					     }
					   else
					     {
						return BFALSE;
					     }
					}
				      else
					{
					   return BFALSE;
					}
				   }
				}
			   }
			}
		      else
			{
			   bool_t test_4026;
			   {
			      obj_t aux_4027;
			      aux_4027 = CNST_TABLE_REF(((long) 12));
			      test_4026 = (car_2009_230_1548 == aux_4027);
			   }
			   if (test_4026)
			     {
				goto kap_2011_203_1549;
			     }
			   else
			     {
				obj_t cdr_2016_89_1552;
				cdr_2016_89_1552 = CDR(t_exp_39_27);
				{
				   bool_t test_4031;
				   {
				      obj_t aux_4032;
				      aux_4032 = CNST_TABLE_REF(((long) 13));
				      test_4031 = (car_2009_230_1548 == aux_4032);
				   }
				   if (test_4031)
				     {
					if (PAIRP(cdr_2016_89_1552))
					  {
					     bool_t test_4037;
					     {
						obj_t aux_4038;
						aux_4038 = CAR(cdr_2016_89_1552);
						test_4037 = SYMBOLP(aux_4038);
					     }
					     if (test_4037)
					       {
						  bool_t test_4041;
						  {
						     obj_t aux_4042;
						     aux_4042 = CDR(cdr_2016_89_1552);
						     test_4041 = (aux_4042 == BNIL);
						  }
						  if (test_4041)
						    {
						       return t_exp_39_27;
						    }
						  else
						    {
						       return BFALSE;
						    }
					       }
					     else
					       {
						  return BFALSE;
					       }
					  }
					else
					  {
					     return BFALSE;
					  }
				     }
				   else
				     {
					{
					   bool_t test_4045;
					   {
					      obj_t aux_4046;
					      aux_4046 = CNST_TABLE_REF(((long) 17));
					      test_4045 = (car_2009_230_1548 == aux_4046);
					   }
					   if (test_4045)
					     {
					      kap_2069_146_1569:
						if (PAIRP(cdr_2016_89_1552))
						  {
						     bool_t test_4051;
						     {
							obj_t aux_4052;
							aux_4052 = CAR(cdr_2016_89_1552);
							test_4051 = SYMBOLP(aux_4052);
						     }
						     if (test_4051)
						       {
							  bool_t test_4055;
							  {
							     obj_t aux_4056;
							     aux_4056 = CDR(cdr_2016_89_1552);
							     test_4055 = (aux_4056 == BNIL);
							  }
							  if (test_4055)
							    {
							       return t_exp_39_27;
							    }
							  else
							    {
							       obj_t cdr_2078_49_1608;
							       cdr_2078_49_1608 = CDR(t_exp_39_27);
							       {
								  bool_t test_4060;
								  {
								     obj_t aux_4063;
								     obj_t aux_4061;
								     aux_4063 = CNST_TABLE_REF(((long) 14));
								     aux_4061 = CAR(t_exp_39_27);
								     test_4060 = (aux_4061 == aux_4063);
								  }
								  if (test_4060)
								    {
								       obj_t cdr_2081_176_1610;
								       cdr_2081_176_1610 = CDR(cdr_2078_49_1608);
								       {
									  bool_t test_4067;
									  {
									     obj_t aux_4068;
									     aux_4068 = CAR(cdr_2078_49_1608);
									     test_4067 = SYMBOLP(aux_4068);
									  }
									  if (test_4067)
									    {
									       if (PAIRP(cdr_2081_176_1610))
										 {
										    obj_t car_2083_191_1613;
										    car_2083_191_1613 = CAR(cdr_2081_176_1610);
										    {
										       if ((car_2083_191_1613 == BNIL))
											 {
											  kap_2087_208_1614:
											    {
											       bool_t test_4076;
											       {
												  obj_t aux_4077;
												  aux_4077 = CDR(cdr_2081_176_1610);
												  test_4076 = (aux_4077 == BNIL);
											       }
											       if (test_4076)
												 {
												    if (check_c_args__102_module_foreign(car_2083_191_1613))
												      {
													 return t_exp_39_27;
												      }
												    else
												      {
													 return BFALSE;
												      }
												 }
											       else
												 {
												    return BFALSE;
												 }
											    }
											 }
										       else
											 {
											    if (PAIRP(car_2083_191_1613))
											      {
												 goto kap_2087_208_1614;
											      }
											    else
											      {
												 return BFALSE;
											      }
											 }
										    }
										 }
									       else
										 {
										    return BFALSE;
										 }
									    }
									  else
									    {
									       return BFALSE;
									    }
								       }
								    }
								  else
								    {
								       bool_t test_4084;
								       {
									  obj_t aux_4087;
									  obj_t aux_4085;
									  aux_4087 = CNST_TABLE_REF(((long) 15));
									  aux_4085 = CAR(t_exp_39_27);
									  test_4084 = (aux_4085 == aux_4087);
								       }
								       if (test_4084)
									 {
									    slots_1542 = cdr_2078_49_1608;
									  tag_2001_85_1543:
									    {
									       obj_t slots_1699;
									       slots_1699 = slots_1542;
									     loop_1700:
									       if (NULLP(slots_1699))
										 {
										    return t_exp_39_27;
										 }
									       else
										 {
										    {
										       obj_t e_2236_186_1704;
										       e_2236_186_1704 = CAR(slots_1699);
										       if (PAIRP(e_2236_186_1704))
											 {
											    obj_t cdr_2238_3_1706;
											    cdr_2238_3_1706 = CDR(e_2236_186_1704);
											    {
											       bool_t test_4096;
											       {
												  obj_t aux_4097;
												  aux_4097 = CAR(e_2236_186_1704);
												  test_4096 = SYMBOLP(aux_4097);
											       }
											       if (test_4096)
												 {
												    if (PAIRP(cdr_2238_3_1706))
												      {
													 bool_t test_4102;
													 {
													    obj_t aux_4103;
													    aux_4103 = CAR(cdr_2238_3_1706);
													    test_4102 = STRINGP(aux_4103);
													 }
													 if (test_4102)
													   {
													      bool_t test_4106;
													      {
														 obj_t aux_4107;
														 aux_4107 = CDR(cdr_2238_3_1706);
														 test_4106 = (aux_4107 == BNIL);
													      }
													      if (test_4106)
														{
														   {
														      obj_t slots_4110;
														      slots_4110 = CDR(slots_1699);
														      slots_1699 = slots_4110;
														      goto loop_1700;
														   }
														}
													      else
														{
														   return BFALSE;
														}
													   }
													 else
													   {
													      return BFALSE;
													   }
												      }
												    else
												      {
													 return BFALSE;
												      }
												 }
											       else
												 {
												    return BFALSE;
												 }
											    }
											 }
										       else
											 {
											    return BFALSE;
											 }
										    }
										 }
									    }
									 }
								       else
									 {
									    return BFALSE;
									 }
								    }
							       }
							    }
						       }
						     else
						       {
							  obj_t cdr_2105_238_1630;
							  cdr_2105_238_1630 = CDR(t_exp_39_27);
							  {
							     bool_t test_4113;
							     {
								obj_t aux_4116;
								obj_t aux_4114;
								aux_4116 = CNST_TABLE_REF(((long) 16));
								aux_4114 = CAR(t_exp_39_27);
								test_4113 = (aux_4114 == aux_4116);
							     }
							     if (test_4113)
							       {
								  bool_t test_4119;
								  {
								     obj_t aux_4120;
								     aux_4120 = CAR(cdr_2105_238_1630);
								     test_4119 = SYMBOLP(aux_4120);
								  }
								  if (test_4119)
								    {
								       bool_t test_4123;
								       {
									  obj_t aux_4124;
									  aux_4124 = CDR(cdr_2105_238_1630);
									  test_4123 = (aux_4124 == BNIL);
								       }
								       if (test_4123)
									 {
									    return t_exp_39_27;
									 }
								       else
									 {
									    return BFALSE;
									 }
								    }
								  else
								    {
								       return BFALSE;
								    }
							       }
							     else
							       {
								  bool_t test_4127;
								  {
								     obj_t aux_4130;
								     obj_t aux_4128;
								     aux_4130 = CNST_TABLE_REF(((long) 14));
								     aux_4128 = CAR(t_exp_39_27);
								     test_4127 = (aux_4128 == aux_4130);
								  }
								  if (test_4127)
								    {
								       obj_t cdr_2125_174_1639;
								       cdr_2125_174_1639 = CDR(cdr_2105_238_1630);
								       {
									  bool_t test_4134;
									  {
									     obj_t aux_4135;
									     aux_4135 = CAR(cdr_2105_238_1630);
									     test_4134 = SYMBOLP(aux_4135);
									  }
									  if (test_4134)
									    {
									       if (PAIRP(cdr_2125_174_1639))
										 {
										    obj_t car_2127_77_1642;
										    car_2127_77_1642 = CAR(cdr_2125_174_1639);
										    {
										       if ((car_2127_77_1642 == BNIL))
											 {
											  kap_2131_246_1643:
											    {
											       bool_t test_4143;
											       {
												  obj_t aux_4144;
												  aux_4144 = CDR(cdr_2125_174_1639);
												  test_4143 = (aux_4144 == BNIL);
											       }
											       if (test_4143)
												 {
												    if (check_c_args__102_module_foreign(car_2127_77_1642))
												      {
													 return t_exp_39_27;
												      }
												    else
												      {
													 return BFALSE;
												      }
												 }
											       else
												 {
												    return BFALSE;
												 }
											    }
											 }
										       else
											 {
											    if (PAIRP(car_2127_77_1642))
											      {
												 goto kap_2131_246_1643;
											      }
											    else
											      {
												 return BFALSE;
											      }
											 }
										    }
										 }
									       else
										 {
										    return BFALSE;
										 }
									    }
									  else
									    {
									       return BFALSE;
									    }
								       }
								    }
								  else
								    {
								       bool_t test_4151;
								       {
									  obj_t aux_4154;
									  obj_t aux_4152;
									  aux_4154 = CNST_TABLE_REF(((long) 15));
									  aux_4152 = CAR(t_exp_39_27);
									  test_4151 = (aux_4152 == aux_4154);
								       }
								       if (test_4151)
									 {
									    obj_t slots_4157;
									    slots_4157 = cdr_2105_238_1630;
									    slots_1542 = slots_4157;
									    goto tag_2001_85_1543;
									 }
								       else
									 {
									    return BFALSE;
									 }
								    }
							       }
							  }
						       }
						  }
						else
						  {
						     bool_t test_4158;
						     {
							obj_t aux_4161;
							obj_t aux_4159;
							aux_4161 = CNST_TABLE_REF(((long) 15));
							aux_4159 = CAR(t_exp_39_27);
							test_4158 = (aux_4159 == aux_4161);
						     }
						     if (test_4158)
						       {
							  obj_t slots_4164;
							  slots_4164 = CDR(t_exp_39_27);
							  slots_1542 = slots_4164;
							  goto tag_2001_85_1543;
						       }
						     else
						       {
							  return BFALSE;
						       }
						  }
					     }
					   else
					     {
						bool_t test_4166;
						{
						   obj_t aux_4167;
						   aux_4167 = CNST_TABLE_REF(((long) 18));
						   test_4166 = (car_2009_230_1548 == aux_4167);
						}
						if (test_4166)
						  {
						     goto kap_2069_146_1569;
						  }
						else
						  {
						     bool_t test_4170;
						     {
							obj_t aux_4171;
							aux_4171 = CNST_TABLE_REF(((long) 16));
							test_4170 = (car_2009_230_1548 == aux_4171);
						     }
						     if (test_4170)
						       {
							  if (PAIRP(cdr_2016_89_1552))
							    {
							       bool_t test_4176;
							       {
								  obj_t aux_4177;
								  aux_4177 = CAR(cdr_2016_89_1552);
								  test_4176 = SYMBOLP(aux_4177);
							       }
							       if (test_4176)
								 {
								    bool_t test_4180;
								    {
								       obj_t aux_4181;
								       aux_4181 = CDR(cdr_2016_89_1552);
								       test_4180 = (aux_4181 == BNIL);
								    }
								    if (test_4180)
								      {
									 return t_exp_39_27;
								      }
								    else
								      {
									 return BFALSE;
								      }
								 }
							       else
								 {
								    return BFALSE;
								 }
							    }
							  else
							    {
							       return BFALSE;
							    }
						       }
						     else
						       {
							  bool_t test_4184;
							  {
							     obj_t aux_4185;
							     aux_4185 = CNST_TABLE_REF(((long) 14));
							     test_4184 = (car_2009_230_1548 == aux_4185);
							  }
							  if (test_4184)
							    {
							       if (PAIRP(cdr_2016_89_1552))
								 {
								    obj_t cdr_2184_252_1583;
								    cdr_2184_252_1583 = CDR(cdr_2016_89_1552);
								    {
								       bool_t test_4191;
								       {
									  obj_t aux_4192;
									  aux_4192 = CAR(cdr_2016_89_1552);
									  test_4191 = SYMBOLP(aux_4192);
								       }
								       if (test_4191)
									 {
									    if (PAIRP(cdr_2184_252_1583))
									      {
										 obj_t car_2186_207_1586;
										 car_2186_207_1586 = CAR(cdr_2184_252_1583);
										 {
										    if ((car_2186_207_1586 == BNIL))
										      {
										       kap_2190_221_1587:
											 {
											    bool_t test_4200;
											    {
											       obj_t aux_4201;
											       aux_4201 = CDR(cdr_2184_252_1583);
											       test_4200 = (aux_4201 == BNIL);
											    }
											    if (test_4200)
											      {
												 if (check_c_args__102_module_foreign(car_2186_207_1586))
												   {
												      return t_exp_39_27;
												   }
												 else
												   {
												      return BFALSE;
												   }
											      }
											    else
											      {
												 return BFALSE;
											      }
											 }
										      }
										    else
										      {
											 if (PAIRP(car_2186_207_1586))
											   {
											      goto kap_2190_221_1587;
											   }
											 else
											   {
											      return BFALSE;
											   }
										      }
										 }
									      }
									    else
									      {
										 return BFALSE;
									      }
									 }
								       else
									 {
									    return BFALSE;
									 }
								    }
								 }
							       else
								 {
								    return BFALSE;
								 }
							    }
							  else
							    {
							       bool_t test_4208;
							       {
								  obj_t aux_4209;
								  aux_4209 = CNST_TABLE_REF(((long) 15));
								  test_4208 = (car_2009_230_1548 == aux_4209);
							       }
							       if (test_4208)
								 {
								    obj_t slots_4212;
								    slots_4212 = cdr_2016_89_1552;
								    slots_1542 = slots_4212;
								    goto tag_2001_85_1543;
								 }
							       else
								 {
								    return BFALSE;
								 }
							    }
						       }
						  }
					     }
					}
				     }
				}
			     }
			}
		   }
		}
	     }
	   else
	     {
		return BFALSE;
	     }
	}
   }
}


obj_t 
foreign_finalizer_169_module_foreign()
{
   {
      obj_t l1229_1716;
      l1229_1716 = __foreign_exported__195_module_foreign;
    lname1230_1717:
      if (PAIRP(l1229_1716))
	{
	   {
	      obj_t foreign_1719;
	      foreign_1719 = CAR(l1229_1716);
	      {
		 obj_t global_1720;
		 obj_t name_1721;
		 {
		    obj_t aux_4216;
		    {
		       obj_t aux_4217;
		       aux_4217 = CDR(foreign_1719);
		       aux_4216 = CAR(aux_4217);
		    }
		    global_1720 = find_global_223_ast_env(aux_4216, BNIL);
		 }
		 {
		    obj_t aux_4221;
		    {
		       obj_t aux_4222;
		       aux_4222 = CDR(foreign_1719);
		       aux_4221 = CDR(aux_4222);
		    }
		    name_1721 = CAR(aux_4221);
		 }
		 {
		    bool_t test2122_1722;
		    test2122_1722 = is_a__118___object(global_1720, global_ast_var);
		    if (test2122_1722)
		      {
			 bool_t test_4228;
			 {
			    obj_t aux_4229;
			    {
			       global_t obj_2758;
			       obj_2758 = (global_t) (global_1720);
			       aux_4229 = (((global_t) CREF(obj_2758))->name);
			    }
			    test_4228 = STRINGP(aux_4229);
			 }
			 if (test_4228)
			   {
			      user_warning_209_tools_error(string2213_module_foreign, string2214_module_foreign, foreign_1719);
			   }
			 else
			   {
			      {
				 obj_t res2191_2762;
				 {
				    global_t obj_2760;
				    obj_2760 = (global_t) (global_1720);
				    {
				       obj_t x_2865;
				       x_2865 = ((((global_t) CREF(obj_2760))->name) = ((obj_t) name_1721), BUNSPEC);
				       res2191_2762 = BUNSPEC;
				    }
				 }
				 res2191_2762;
			      }
			   }
		      }
		    else
		      {
			 {
			    obj_t list2128_1728;
			    list2128_1728 = MAKE_PAIR(BNIL, BNIL);
			    user_error_151_tools_error(string2213_module_foreign, string2215_module_foreign, foreign_1719, list2128_1728);
			 }
		      }
		 }
	      }
	   }
	   {
	      obj_t l1229_4238;
	      l1229_4238 = CDR(l1229_1716);
	      l1229_1716 = l1229_4238;
	      goto lname1230_1717;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   __foreign_exported__195_module_foreign = BNIL;
   {
      bool_t test2133_1733;
      {
	 obj_t obj_2764;
	 obj_2764 = __foreign_accesses__124_module_foreign;
	 test2133_1733 = NULLP(obj_2764);
      }
      if (test2133_1733)
	{
	   return CNST_TABLE_REF(((long) 2));
	}
      else
	{
	   obj_t accesses_1734;
	   accesses_1734 = reverse__39___r4_pairs_and_lists_6_3(__foreign_accesses__124_module_foreign);
	   __foreign_accesses__124_module_foreign = BNIL;
	   {
	      obj_t arg2134_1735;
	      {
		 obj_t arg2137_1738;
		 arg2137_1738 = CNST_TABLE_REF(((long) 0));
		 {
		    obj_t new_2769;
		    {
		       obj_t aux_4245;
		       aux_4245 = CNST_TABLE_REF(((long) 19));
		       new_2769 = create_struct(aux_4245, ((long) 4));
		    }
		    STRUCT_SET(new_2769, ((long) 3), BTRUE);
		    STRUCT_SET(new_2769, ((long) 2), accesses_1734);
		    {
		       obj_t aux_4250;
		       aux_4250 = BINT(((long) 48));
		       STRUCT_SET(new_2769, ((long) 1), aux_4250);
		    }
		    STRUCT_SET(new_2769, ((long) 0), arg2137_1738);
		    arg2134_1735 = new_2769;
		 }
	      }
	      {
		 obj_t list2135_1736;
		 list2135_1736 = MAKE_PAIR(arg2134_1735, BNIL);
		 return list2135_1736;
	      }
	   }
	}
   }
}


obj_t 
_foreign_finalizer_56_module_foreign(obj_t env_2846)
{
   return foreign_finalizer_169_module_foreign();
}


obj_t 
imported_modules_init_94_module_foreign()
{
   module_initialization_70_tools_trace(((long) 0), "MODULE_FOREIGN");
   module_initialization_70_module_module(((long) 0), "MODULE_FOREIGN");
   module_initialization_70_module_checksum(((long) 0), "MODULE_FOREIGN");
   module_initialization_70_engine_param(((long) 0), "MODULE_FOREIGN");
   module_initialization_70_ast_glo_decl_237(((long) 0), "MODULE_FOREIGN");
   module_initialization_70_tools_error(((long) 0), "MODULE_FOREIGN");
   module_initialization_70_tools_shape(((long) 0), "MODULE_FOREIGN");
   module_initialization_70_type_type(((long) 0), "MODULE_FOREIGN");
   module_initialization_70_type_env(((long) 0), "MODULE_FOREIGN");
   module_initialization_70_type_tools(((long) 0), "MODULE_FOREIGN");
   module_initialization_70_ast_var(((long) 0), "MODULE_FOREIGN");
   module_initialization_70_ast_env(((long) 0), "MODULE_FOREIGN");
   module_initialization_70_ast_ident(((long) 0), "MODULE_FOREIGN");
   module_initialization_70_foreign_ctype(((long) 0), "MODULE_FOREIGN");
   return module_initialization_70_foreign_access(((long) 0), "MODULE_FOREIGN");
}
