/*===========================================================================*/
/*   (Module/impuse.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


static obj_t impuse_parser_37_module_impuse(obj_t, obj_t);
extern obj_t import_with_module__247_module_impuse(obj_t);
extern global_t declare_global_sfun__255_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t arg12221737_module_impuse(obj_t, obj_t, obj_t);
extern obj_t type_type_type;
static obj_t arg12031733_module_impuse(obj_t);
extern obj_t exit_bigloo_229_init_main(obj_t);
static obj_t import_finalizer_66_module_impuse();
extern obj_t global_ast_var;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t __imported_module_list__84_module_impuse = BUNSPEC;
extern obj_t notify_error_43___error(obj_t, obj_t, obj_t);
extern obj_t exitd_top;
static obj_t imported_modules_init_94_module_impuse();
extern obj_t module_initialization_70_module_impuse(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_prototype(long, char *);
extern obj_t module_initialization_70_module_class(long, char *);
extern obj_t module_initialization_70_module_include(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_file(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_read_access(long, char *);
extern obj_t module_initialization_70_read_inline(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_find_gdefs_13(long, char *);
extern obj_t module_initialization_70_ast_glo_decl_237(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_init_main(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_ports_6_10_1(long, char *);
static obj_t toplevel_init_63_module_impuse();
static obj_t cnst_init_137_module_impuse();
extern obj_t ccomp_module_module;
static obj_t arg12101736_module_impuse(obj_t, obj_t, obj_t);
extern obj_t module_initialization_id_110_module_module(obj_t);
extern obj_t remq__51___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t __module__166_module_module;
extern obj_t find_file_path_55_tools_file(obj_t, obj_t);
extern obj_t _get_imported_modules_109_module_impuse(obj_t);
extern obj_t get_include_consumed_code_244_module_include();
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t add_error_handler__155___error(obj_t, obj_t);
extern obj_t make_use_compiler_106_module_impuse();
extern obj_t get_include_consumed_directive_80_module_include();
static obj_t arg12041732_module_impuse(obj_t, obj_t, obj_t);
extern obj_t remove_error_handler__102___error();
static obj_t handling_function1598_122_module_impuse(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
static obj_t require_initialization_114_module_impuse = BUNSPEC;
extern obj_t parse_prototype_143_module_prototype(obj_t);
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_module_impuse();
static obj_t impuse_producer_187_module_impuse(obj_t);
static obj_t read_imported_module_112_module_impuse(obj_t);
extern obj_t reset_include_consumed_code__8_module_include();
extern obj_t declare_class__31_module_class(obj_t, obj_t, obj_t, bool_t, obj_t);
extern obj_t sfun_ast_var;
extern obj_t _make_import_compiler_114_module_impuse(obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t arg12181739_module_impuse(obj_t, obj_t, obj_t);
static obj_t arg12001734_module_impuse(obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t close_input_port(obj_t);
extern obj_t val_from_exit__100___bexit(obj_t);
static obj_t _impuse_finalizer_29_module_impuse(obj_t);
static obj_t arg12191738_module_impuse(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t consume_module__183_module_module(obj_t, obj_t);
extern obj_t _make_use_compiler_39_module_impuse(obj_t);
extern obj_t reset_include_consumed_directive__234_module_include();
static obj_t handler1741_module_impuse(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t __load_path__54___eval;
extern long class_num_218___object(obj_t);
static obj_t impuse_finalizer_42_module_impuse();
extern obj_t __access_table__91_engine_param;
static obj_t arg16001740_module_impuse(obj_t, obj_t);
extern obj_t look_for_inline_98_read_inline(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t handling_function1605_110_module_impuse(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t current_error_port;
extern obj_t make_import_compiler_148_module_impuse();
extern obj_t inline_finalizer_105_read_inline();
static obj_t arg12121735_module_impuse(obj_t, obj_t, obj_t);
static obj_t _impuse_producer_249_module_impuse(obj_t, obj_t);
static obj_t import_wanted_18_module_impuse(obj_t, obj_t, obj_t);
extern obj_t declare_wide_class__13_module_class(obj_t, obj_t, obj_t, obj_t);
extern obj_t get_imported_modules_153_module_impuse();
extern obj_t add_access__140_read_access(obj_t, obj_t);
static obj_t import_everything_193_module_impuse(obj_t, obj_t);
extern obj_t _make_from_compiler_253_module_impuse(obj_t);
extern obj_t open_input_file_61___r4_ports_6_10_1(obj_t, obj_t);
extern obj_t unwind_until__178___bexit(obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _import_parser_19_module_impuse(obj_t, obj_t, obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
static obj_t import_1_module_184_module_impuse(obj_t, obj_t, obj_t);
extern obj_t _import_with_module__232_module_impuse(obj_t, obj_t);
static obj_t __import_module_list__76_module_impuse = BUNSPEC;
static obj_t import_all_module_109_module_impuse(obj_t, obj_t);
extern global_t declare_global_svar__200_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t import_parser_53_module_impuse(obj_t, obj_t);
extern obj_t checksum_module_8_module_module(obj_t);
extern obj_t make_from_compiler_140_module_impuse();
extern obj_t create_struct(obj_t, long);
static obj_t __cnst[21];

DEFINE_EXPORT_PROCEDURE(make_import_compiler_env_82_module_impuse, _make_import_compiler_114_module_impuse1773, _make_import_compiler_114_module_impuse, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1749_module_impuse, arg12181739_module_impuse1774, arg12181739_module_impuse, 0L, 2);
DEFINE_STRING(string1752_module_impuse, string1752_module_impuse1775, "Parse error", 11);
DEFINE_EXPORT_PROCEDURE(make_use_compiler_env_17_module_impuse, _make_use_compiler_39_module_impuse1776, _make_use_compiler_39_module_impuse, 0L, 0);
DEFINE_STATIC_PROCEDURE(impuse_finalizer_env_73_module_impuse, _impuse_finalizer_29_module_impuse1777, _impuse_finalizer_29_module_impuse, 0L, 0);
DEFINE_STRING(string1760_module_impuse, string1760_module_impuse1778, "]", 1);
DEFINE_STRING(string1761_module_impuse, string1761_module_impuse1779, " module ", 8);
DEFINE_STRING(string1756_module_impuse, string1756_module_impuse1780, "Illegal `import/use' clause", 27);
DEFINE_STRING(string1765_module_impuse, string1765_module_impuse1781, "Can't find such module", 22);
DEFINE_EXPORT_PROCEDURE(import_parser_env_92_module_impuse, _import_parser_19_module_impuse1782, _import_parser_19_module_impuse, 0L, 2);
DEFINE_STATIC_PROCEDURE(impuse_producer_env_151_module_impuse, _impuse_producer_249_module_impuse1783, _impuse_producer_249_module_impuse, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1748_module_impuse, arg12191738_module_impuse1784, arg12191738_module_impuse, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1742_module_impuse, arg12041732_module_impuse1785, arg12041732_module_impuse, 0L, 2);
DEFINE_STRING(string1751_module_impuse, string1751_module_impuse1786, "Illegal `", 9);
DEFINE_STRING(string1757_module_impuse, string1757_module_impuse1787, "import-finalizer: ", 18);
DEFINE_STRING(string1759_module_impuse, string1759_module_impuse1788, "read-imported-module: ", 22);
DEFINE_EXPORT_PROCEDURE(get_imported_modules_env_216_module_impuse, _get_imported_modules_109_module_impuse1789, _get_imported_modules_109_module_impuse, 0L, 0);
DEFINE_EXPORT_PROCEDURE(import_with_module__env_62_module_impuse, _import_with_module__232_module_impuse1790, _import_with_module__232_module_impuse, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1746_module_impuse, arg12101736_module_impuse1791, arg12101736_module_impuse, 0L, 2);
DEFINE_STRING(string1755_module_impuse, string1755_module_impuse1792, "Illegal imported clause", 23);
DEFINE_STRING(string1758_module_impuse, string1758_module_impuse1793, "Illegal prototype", 17);
DEFINE_STRING(string1754_module_impuse, string1754_module_impuse1794, "impuse-parser: ", 15);
DEFINE_STRING(string1763_module_impuse, string1763_module_impuse1795, "read-imported-module", 20);
DEFINE_STRING(string1762_module_impuse, string1762_module_impuse1796, "      [reading ", 15);
DEFINE_EXPORT_PROCEDURE(make_from_compiler_env_143_module_impuse, _make_from_compiler_253_module_impuse1797, _make_from_compiler_253_module_impuse, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1743_module_impuse, arg12031733_module_impuse1798, arg12031733_module_impuse, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1747_module_impuse, arg12221737_module_impuse1799, arg12221737_module_impuse, 0L, 2);
DEFINE_STRING(string1764_module_impuse, string1764_module_impuse1800, "Can't open such file", 20);
DEFINE_STATIC_PROCEDURE(proc1745_module_impuse, arg12121735_module_impuse1801, arg12121735_module_impuse, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1744_module_impuse, arg12001734_module_impuse1802, arg12001734_module_impuse, 0L, 2);
DEFINE_STRING(string1750_module_impuse, string1750_module_impuse1803, "' clause", 8);
DEFINE_STRING(string1767_module_impuse, string1767_module_impuse1804, "SIFUN WIDE-CLASS FINAL-CLASS CLASS SVAR (SFUN SIFUN SGFUN) (IMPORT WITH) @ FROM::STRING CHECKSUM::LONG UNIT IMPORTED-MODULES AST NOTHING WITH IMODE ALL FROM USE VOID IMPORT ", 173);
DEFINE_STRING(string1766_module_impuse, string1766_module_impuse1805, "Can't find exportation for these identifiers", 44);
DEFINE_STRING(string1753_module_impuse, string1753_module_impuse1806, " ", 1);

obj_t 
module_initialization_70_module_impuse(long checksum_1699, char *from_1700)
{
   if (CBOOL(require_initialization_114_module_impuse))
     {
	require_initialization_114_module_impuse = BBOOL(((bool_t) 0));
	library_modules_init_112_module_impuse();
	cnst_init_137_module_impuse();
	imported_modules_init_94_module_impuse();
	toplevel_init_63_module_impuse();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_module_impuse()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_IMPUSE");
   module_initialization_70___object(((long) 0), "MODULE_IMPUSE");
   module_initialization_70___error(((long) 0), "MODULE_IMPUSE");
   module_initialization_70___bexit(((long) 0), "MODULE_IMPUSE");
   module_initialization_70___r4_strings_6_7(((long) 0), "MODULE_IMPUSE");
   module_initialization_70___reader(((long) 0), "MODULE_IMPUSE");
   module_initialization_70___eval(((long) 0), "MODULE_IMPUSE");
   module_initialization_70___r4_ports_6_10_1(((long) 0), "MODULE_IMPUSE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_module_impuse()
{
   {
      obj_t cnst_port_138_1691;
      cnst_port_138_1691 = open_input_string(string1767_module_impuse);
      {
	 long i_1692;
	 i_1692 = ((long) 20);
       loop_1693:
	 {
	    bool_t test1768_1694;
	    test1768_1694 = (i_1692 == ((long) -1));
	    if (test1768_1694)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1769_1695;
		    {
		       obj_t list1770_1696;
		       {
			  obj_t arg1771_1697;
			  arg1771_1697 = BNIL;
			  list1770_1696 = MAKE_PAIR(cnst_port_138_1691, arg1771_1697);
		       }
		       arg1769_1695 = read___reader(list1770_1696);
		    }
		    CNST_TABLE_SET(i_1692, arg1769_1695);
		 }
		 {
		    int aux_1698;
		    {
		       long aux_1722;
		       aux_1722 = (i_1692 - ((long) 1));
		       aux_1698 = (int) (aux_1722);
		    }
		    {
		       long i_1725;
		       i_1725 = (long) (aux_1698);
		       i_1692 = i_1725;
		       goto loop_1693;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_module_impuse()
{
   __import_module_list__76_module_impuse = BNIL;
   return (__imported_module_list__84_module_impuse = BNIL,
      BUNSPEC);
}


obj_t 
make_import_compiler_148_module_impuse()
{
   {
      obj_t arg1199_360;
      arg1199_360 = CNST_TABLE_REF(((long) 0));
      {
	 obj_t arg1204_1622;
	 obj_t arg1203_1623;
	 obj_t arg1200_1624;
	 arg1204_1622 = proc1742_module_impuse;
	 arg1203_1623 = proc1743_module_impuse;
	 arg1200_1624 = proc1744_module_impuse;
	 {
	    ccomp_t res1728_1083;
	    {
	       ccomp_t new1004_1074;
	       new1004_1074 = ((ccomp_t) BREF(GC_MALLOC(sizeof(struct ccomp))));
	       {
		  long arg1725_1075;
		  arg1725_1075 = class_num_218___object(ccomp_module_module);
		  {
		     obj_t obj_1081;
		     obj_1081 = (obj_t) (new1004_1074);
		     (((obj_t) CREF(obj_1081))->header = MAKE_HEADER(arg1725_1075, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_1732;
		  aux_1732 = (object_t) (new1004_1074);
		  OBJECT_WIDENING_SET(aux_1732, BFALSE);
	       }
	       ((((ccomp_t) CREF(new1004_1074))->id) = ((obj_t) arg1199_360), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_1074))->producer) = ((obj_t) impuse_producer_env_151_module_impuse), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_1074))->consumer) = ((obj_t) arg1200_1624), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_1074))->finalizer) = ((obj_t) arg1203_1623), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_1074))->checksummer) = ((obj_t) arg1204_1622), BUNSPEC);
	       res1728_1083 = new1004_1074;
	    }
	    return (obj_t) (res1728_1083);
	 }
      }
   }
}


obj_t 
_make_import_compiler_114_module_impuse(obj_t env_1625)
{
   return make_import_compiler_148_module_impuse();
}


obj_t 
arg12041732_module_impuse(obj_t env_1626, obj_t m_1627, obj_t c_1628)
{
   {
      obj_t m_368;
      obj_t c_369;
      m_368 = m_1627;
      c_369 = c_1628;
      return c_369;
   }
}


obj_t 
arg12031733_module_impuse(obj_t env_1629)
{
   {
      return CNST_TABLE_REF(((long) 1));
   }
}


obj_t 
arg12001734_module_impuse(obj_t env_1630, obj_t m_1631, obj_t c_1632)
{
   {
      obj_t m_364;
      obj_t c_365;
      m_364 = m_1631;
      c_365 = c_1632;
      return BNIL;
   }
}


obj_t 
make_use_compiler_106_module_impuse()
{
   {
      obj_t arg1209_374;
      arg1209_374 = CNST_TABLE_REF(((long) 2));
      {
	 obj_t arg1212_1635;
	 obj_t arg1210_1636;
	 arg1212_1635 = proc1745_module_impuse;
	 arg1210_1636 = proc1746_module_impuse;
	 {
	    ccomp_t res1729_1094;
	    {
	       ccomp_t new1004_1085;
	       new1004_1085 = ((ccomp_t) BREF(GC_MALLOC(sizeof(struct ccomp))));
	       {
		  long arg1725_1086;
		  arg1725_1086 = class_num_218___object(ccomp_module_module);
		  {
		     obj_t obj_1092;
		     obj_1092 = (obj_t) (new1004_1085);
		     (((obj_t) CREF(obj_1092))->header = MAKE_HEADER(arg1725_1086, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_1748;
		  aux_1748 = (object_t) (new1004_1085);
		  OBJECT_WIDENING_SET(aux_1748, BFALSE);
	       }
	       ((((ccomp_t) CREF(new1004_1085))->id) = ((obj_t) arg1209_374), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_1085))->producer) = ((obj_t) impuse_producer_env_151_module_impuse), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_1085))->consumer) = ((obj_t) arg1210_1636), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_1085))->finalizer) = ((obj_t) impuse_finalizer_env_73_module_impuse), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_1085))->checksummer) = ((obj_t) arg1212_1635), BUNSPEC);
	       res1729_1094 = new1004_1085;
	    }
	    return (obj_t) (res1729_1094);
	 }
      }
   }
}


obj_t 
_make_use_compiler_39_module_impuse(obj_t env_1637)
{
   return make_use_compiler_106_module_impuse();
}


obj_t 
arg12121735_module_impuse(obj_t env_1638, obj_t m_1639, obj_t c_1640)
{
   {
      obj_t m_380;
      obj_t c_381;
      m_380 = m_1639;
      c_381 = c_1640;
      return c_381;
   }
}


obj_t 
arg12101736_module_impuse(obj_t env_1641, obj_t m_1642, obj_t c_1643)
{
   {
      obj_t m_377;
      obj_t c_378;
      m_377 = m_1642;
      c_378 = c_1643;
      return BNIL;
   }
}


obj_t 
make_from_compiler_140_module_impuse()
{
   {
      obj_t arg1217_385;
      arg1217_385 = CNST_TABLE_REF(((long) 3));
      {
	 obj_t arg1222_1645;
	 obj_t arg1219_1646;
	 obj_t arg1218_1647;
	 arg1222_1645 = proc1747_module_impuse;
	 arg1219_1646 = proc1748_module_impuse;
	 arg1218_1647 = proc1749_module_impuse;
	 {
	    ccomp_t res1730_1105;
	    {
	       ccomp_t new1004_1096;
	       new1004_1096 = ((ccomp_t) BREF(GC_MALLOC(sizeof(struct ccomp))));
	       {
		  long arg1725_1097;
		  arg1725_1097 = class_num_218___object(ccomp_module_module);
		  {
		     obj_t obj_1103;
		     obj_1103 = (obj_t) (new1004_1096);
		     (((obj_t) CREF(obj_1103))->header = MAKE_HEADER(arg1725_1097, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_1763;
		  aux_1763 = (object_t) (new1004_1096);
		  OBJECT_WIDENING_SET(aux_1763, BFALSE);
	       }
	       ((((ccomp_t) CREF(new1004_1096))->id) = ((obj_t) arg1217_385), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_1096))->producer) = ((obj_t) impuse_producer_env_151_module_impuse), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_1096))->consumer) = ((obj_t) arg1218_1647), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_1096))->finalizer) = ((obj_t) arg1219_1646), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_1096))->checksummer) = ((obj_t) arg1222_1645), BUNSPEC);
	       res1730_1105 = new1004_1096;
	    }
	    return (obj_t) (res1730_1105);
	 }
      }
   }
}


obj_t 
_make_from_compiler_253_module_impuse(obj_t env_1648)
{
   return make_from_compiler_140_module_impuse();
}


obj_t 
arg12221737_module_impuse(obj_t env_1649, obj_t m_1650, obj_t c_1651)
{
   {
      obj_t m_393;
      obj_t c_394;
      m_393 = m_1650;
      c_394 = c_1651;
      return c_394;
   }
}


obj_t 
arg12191738_module_impuse(obj_t env_1652)
{
   {
      return CNST_TABLE_REF(((long) 1));
   }
}


obj_t 
arg12181739_module_impuse(obj_t env_1653, obj_t module_1654, obj_t clause_1655)
{
   {
      obj_t module_389;
      obj_t clause_390;
      module_389 = module_1654;
      clause_390 = clause_1655;
      impuse_producer_187_module_impuse(clause_390);
      return BNIL;
   }
}


obj_t 
impuse_producer_187_module_impuse(obj_t clause_19)
{
   {
      obj_t mode_399;
      mode_399 = CAR(clause_19);
      {
	 obj_t protos_400;
	 if (PAIRP(clause_19))
	   {
	      bool_t aux_1778;
	      protos_400 = CDR(clause_19);
	      {
		 obj_t l1114_406;
		 l1114_406 = protos_400;
	       lname1116_407:
		 if (PAIRP(l1114_406))
		   {
		      impuse_parser_37_module_impuse(CAR(l1114_406), mode_399);
		      {
			 obj_t l1114_1783;
			 l1114_1783 = CDR(l1114_406);
			 l1114_406 = l1114_1783;
			 goto lname1116_407;
		      }
		   }
		 else
		   {
		      aux_1778 = ((bool_t) 1);
		   }
	      }
	      return BBOOL(aux_1778);
	   }
	 else
	   {
	      {
		 obj_t arg1231_412;
		 {
		    obj_t arg1237_417;
		    {
		       obj_t arg1246_423;
		       arg1246_423 = SYMBOL_TO_STRING(mode_399);
		       arg1237_417 = string_downcase_77___r4_strings_6_7(arg1246_423);
		    }
		    {
		       obj_t list1240_419;
		       {
			  obj_t arg1241_420;
			  {
			     obj_t arg1242_421;
			     arg1242_421 = MAKE_PAIR(string1750_module_impuse, BNIL);
			     arg1241_420 = MAKE_PAIR(arg1237_417, arg1242_421);
			  }
			  list1240_419 = MAKE_PAIR(string1751_module_impuse, arg1241_420);
		       }
		       arg1231_412 = string_append_106___r4_strings_6_7(list1240_419);
		    }
		 }
		 {
		    obj_t list1234_414;
		    list1234_414 = MAKE_PAIR(BNIL, BNIL);
		    return user_error_151_tools_error(string1752_module_impuse, arg1231_412, clause_19, list1234_414);
		 }
	      }
	   }
      }
   }
}


obj_t 
_impuse_producer_249_module_impuse(obj_t env_1633, obj_t clause_1634)
{
   return impuse_producer_187_module_impuse(clause_1634);
}


obj_t 
import_all_module_109_module_impuse(obj_t module_20, obj_t mode_21)
{
   {
      obj_t b_424;
      b_424 = assq___r4_pairs_and_lists_6_3(module_20, __import_module_list__76_module_impuse);
      if (PAIRP(b_424))
	{
	   obj_t x_1689;
	   {
	      obj_t aux_1801;
	      obj_t aux_1799;
	      aux_1801 = CNST_TABLE_REF(((long) 4));
	      aux_1799 = CDR(b_424);
	      x_1689 = STRUCT_SET(aux_1799, ((long) 2), aux_1801);
	   }
	   return BUNSPEC;
	}
      else
	{
	   obj_t arg1252_428;
	   {
	      obj_t arg1255_429;
	      {
		 obj_t arg1256_430;
		 arg1256_430 = CNST_TABLE_REF(((long) 4));
		 {
		    obj_t new_1124;
		    {
		       obj_t aux_1805;
		       aux_1805 = CNST_TABLE_REF(((long) 5));
		       new_1124 = create_struct(aux_1805, ((long) 4));
		    }
		    STRUCT_SET(new_1124, ((long) 3), BUNSPEC);
		    STRUCT_SET(new_1124, ((long) 2), arg1256_430);
		    STRUCT_SET(new_1124, ((long) 1), mode_21);
		    STRUCT_SET(new_1124, ((long) 0), module_20);
		    arg1255_429 = new_1124;
		 }
	      }
	      arg1252_428 = MAKE_PAIR(module_20, arg1255_429);
	   }
	   {
	      obj_t obj2_1150;
	      obj2_1150 = __import_module_list__76_module_impuse;
	      return (__import_module_list__76_module_impuse = MAKE_PAIR(arg1252_428, obj2_1150),
		 BUNSPEC);
	   }
	}
   }
}


obj_t 
import_1_module_184_module_impuse(obj_t module_22, obj_t var_23, obj_t mode_24)
{
   {
      obj_t cell_431;
      cell_431 = assq___r4_pairs_and_lists_6_3(module_22, __import_module_list__76_module_impuse);
      if (PAIRP(cell_431))
	{
	   obj_t b_433;
	   b_433 = CDR(cell_431);
	   {
	      obj_t case_value_58_434;
	      case_value_58_434 = STRUCT_REF(b_433, ((long) 2));
	      {
		 bool_t test_1819;
		 {
		    obj_t aux_1820;
		    aux_1820 = CNST_TABLE_REF(((long) 6));
		    test_1819 = (case_value_58_434 == aux_1820);
		 }
		 if (test_1819)
		   {
		      STRUCT_SET(b_433, ((long) 1), mode_24);
		      {
			 obj_t arg1259_436;
			 {
			    obj_t list1260_437;
			    list1260_437 = MAKE_PAIR(var_23, BNIL);
			    arg1259_436 = list1260_437;
			 }
			 return STRUCT_SET(b_433, ((long) 2), arg1259_436);
		      }
		   }
		 else
		   {
		      bool_t test_1826;
		      {
			 obj_t aux_1827;
			 aux_1827 = CNST_TABLE_REF(((long) 4));
			 test_1826 = (case_value_58_434 == aux_1827);
		      }
		      if (test_1826)
			{
			   return CNST_TABLE_REF(((long) 7));
			}
		      else
			{
			   obj_t arg1265_440;
			   arg1265_440 = MAKE_PAIR(var_23, case_value_58_434);
			   return STRUCT_SET(b_433, ((long) 2), arg1265_440);
			}
		   }
	      }
	   }
	}
      else
	{
	   obj_t arg1270_444;
	   {
	      obj_t arg1271_445;
	      {
		 obj_t arg1272_446;
		 {
		    obj_t list1273_447;
		    list1273_447 = MAKE_PAIR(var_23, BNIL);
		    arg1272_446 = list1273_447;
		 }
		 {
		    obj_t new_1186;
		    {
		       obj_t aux_1834;
		       aux_1834 = CNST_TABLE_REF(((long) 5));
		       new_1186 = create_struct(aux_1834, ((long) 4));
		    }
		    STRUCT_SET(new_1186, ((long) 3), BUNSPEC);
		    STRUCT_SET(new_1186, ((long) 2), arg1272_446);
		    STRUCT_SET(new_1186, ((long) 1), mode_24);
		    STRUCT_SET(new_1186, ((long) 0), module_22);
		    arg1271_445 = new_1186;
		 }
	      }
	      arg1270_444 = MAKE_PAIR(module_22, arg1271_445);
	   }
	   {
	      obj_t obj2_1212;
	      obj2_1212 = __import_module_list__76_module_impuse;
	      return (__import_module_list__76_module_impuse = MAKE_PAIR(arg1270_444, obj2_1212),
		 BUNSPEC);
	   }
	}
   }
}


obj_t 
import_with_module__247_module_impuse(obj_t module_25)
{
   {
      obj_t b_449;
      b_449 = assq___r4_pairs_and_lists_6_3(module_25, __import_module_list__76_module_impuse);
      if (PAIRP(b_449))
	{
	   return BUNSPEC;
	}
      else
	{
	   obj_t arg1278_451;
	   {
	      obj_t arg1279_452;
	      {
		 obj_t arg1280_453;
		 arg1280_453 = CNST_TABLE_REF(((long) 6));
		 {
		    obj_t new_1218;
		    {
		       obj_t aux_1847;
		       aux_1847 = CNST_TABLE_REF(((long) 5));
		       new_1218 = create_struct(aux_1847, ((long) 4));
		    }
		    {
		       obj_t aux_1850;
		       aux_1850 = BINT(((long) 0));
		       STRUCT_SET(new_1218, ((long) 3), aux_1850);
		    }
		    STRUCT_SET(new_1218, ((long) 2), BNIL);
		    STRUCT_SET(new_1218, ((long) 1), arg1280_453);
		    STRUCT_SET(new_1218, ((long) 0), module_25);
		    arg1279_452 = new_1218;
		 }
	      }
	      arg1278_451 = MAKE_PAIR(module_25, arg1279_452);
	   }
	   {
	      obj_t obj2_1244;
	      obj2_1244 = __import_module_list__76_module_impuse;
	      return (__import_module_list__76_module_impuse = MAKE_PAIR(arg1278_451, obj2_1244),
		 BUNSPEC);
	   }
	}
   }
}


obj_t 
_import_with_module__232_module_impuse(obj_t env_1656, obj_t module_1657)
{
   return import_with_module__247_module_impuse(module_1657);
}


obj_t 
impuse_parser_37_module_impuse(obj_t prototype_26, obj_t mode_27)
{
   {
      bool_t test1284_456;
      {
	 obj_t aux_1859;
	 aux_1859 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 8)), BINT(((long) 2)));
	 test1284_456 = CBOOL(aux_1859);
      }
      if (test1284_456)
	{
	   obj_t list1285_457;
	   {
	      obj_t arg1287_459;
	      {
		 obj_t arg1290_460;
		 {
		    obj_t arg1295_462;
		    {
		       obj_t arg1296_463;
		       {
			  obj_t aux_1865;
			  aux_1865 = BCHAR(((unsigned char) '\n'));
			  arg1296_463 = MAKE_PAIR(aux_1865, BNIL);
		       }
		       arg1295_462 = MAKE_PAIR(mode_27, arg1296_463);
		    }
		    arg1290_460 = MAKE_PAIR(string1753_module_impuse, arg1295_462);
		 }
		 arg1287_459 = MAKE_PAIR(prototype_26, arg1290_460);
	      }
	      list1285_457 = MAKE_PAIR(string1754_module_impuse, arg1287_459);
	   }
	   print_trace_107_tools_trace(list1285_457);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t v_474;
      obj_t m_475;
      obj_t f_476;
      obj_t rest_477;
      obj_t module_467;
      obj_t fname_468;
      obj_t rest_469;
      if (PAIRP(prototype_26))
	{
	   obj_t car_144_227_484;
	   obj_t cdr_145_238_485;
	   car_144_227_484 = CAR(prototype_26);
	   cdr_145_238_485 = CDR(prototype_26);
	   if (SYMBOLP(car_144_227_484))
	     {
		if (PAIRP(cdr_145_238_485))
		  {
		     obj_t car_150_99_488;
		     car_150_99_488 = CAR(cdr_145_238_485);
		     if (STRINGP(car_150_99_488))
		       {
			  module_467 = car_144_227_484;
			  fname_468 = car_150_99_488;
			  rest_469 = CDR(cdr_145_238_485);
			  {
			     obj_t rest_597;
			     obj_t fnames_598;
			     {
				obj_t arg1379_600;
				{
				   obj_t list1380_601;
				   list1380_601 = MAKE_PAIR(fname_468, BNIL);
				   arg1379_600 = list1380_601;
				}
				rest_597 = rest_469;
				fnames_598 = arg1379_600;
			      loop_599:
				if (NULLP(rest_597))
				  {
				     {
					obj_t arg1385_604;
					arg1385_604 = reverse__39___r4_pairs_and_lists_6_3(fnames_598);
					add_access__140_read_access(module_467, arg1385_604);
				     }
				     return import_all_module_109_module_impuse(module_467, mode_27);
				  }
				else
				  {
				     bool_t test_1890;
				     {
					obj_t aux_1891;
					aux_1891 = CAR(rest_597);
					test_1890 = STRINGP(aux_1891);
				     }
				     if (test_1890)
				       {
					  {
					     obj_t arg1388_606;
					     obj_t arg1390_607;
					     arg1388_606 = CDR(rest_597);
					     {
						obj_t aux_1895;
						aux_1895 = CAR(rest_597);
						arg1390_607 = MAKE_PAIR(aux_1895, fnames_598);
					     }
					     {
						obj_t fnames_1899;
						obj_t rest_1898;
						rest_1898 = arg1388_606;
						fnames_1899 = arg1390_607;
						fnames_598 = fnames_1899;
						rest_597 = rest_1898;
						goto loop_599;
					     }
					  }
				       }
				     else
				       {
					  {
					     obj_t list1401_612;
					     list1401_612 = MAKE_PAIR(BNIL, BNIL);
					     return user_error_151_tools_error(string1752_module_impuse, string1755_module_impuse, prototype_26, list1401_612);
					  }
				       }
				  }
			     }
			  }
		       }
		     else
		       {
			  if (SYMBOLP(car_144_227_484))
			    {
			       obj_t car_173_126_494;
			       car_173_126_494 = CAR(cdr_145_238_485);
			       if (SYMBOLP(car_173_126_494))
				 {
				    bool_t test_1908;
				    {
				       obj_t aux_1909;
				       aux_1909 = CDR(cdr_145_238_485);
				       test_1908 = (aux_1909 == BNIL);
				    }
				    if (test_1908)
				      {
					 return import_1_module_184_module_impuse(car_173_126_494, car_144_227_484, mode_27);
				      }
				    else
				      {
					 if (SYMBOLP(car_144_227_484))
					   {
					      obj_t car_196_45_500;
					      obj_t cdr_197_63_501;
					      car_196_45_500 = CAR(cdr_145_238_485);
					      cdr_197_63_501 = CDR(cdr_145_238_485);
					      if (SYMBOLP(car_196_45_500))
						{
						   if (PAIRP(cdr_197_63_501))
						     {
							obj_t car_203_140_504;
							car_203_140_504 = CAR(cdr_197_63_501);
							if (STRINGP(car_203_140_504))
							  {
							     v_474 = car_144_227_484;
							     m_475 = car_196_45_500;
							     f_476 = car_203_140_504;
							     rest_477 = CDR(cdr_197_63_501);
							   tag_130_214_478:
							     {
								obj_t rest_615;
								obj_t fnames_616;
								{
								   obj_t arg1404_618;
								   {
								      obj_t list1405_619;
								      list1405_619 = MAKE_PAIR(f_476, BNIL);
								      arg1404_618 = list1405_619;
								   }
								   rest_615 = rest_477;
								   fnames_616 = arg1404_618;
								 loop_617:
								   if (NULLP(rest_615))
								     {
									{
									   obj_t arg1408_622;
									   arg1408_622 = reverse__39___r4_pairs_and_lists_6_3(fnames_616);
									   add_access__140_read_access(m_475, arg1408_622);
									}
									return import_1_module_184_module_impuse(m_475, v_474, mode_27);
								     }
								   else
								     {
									bool_t test_1930;
									{
									   obj_t aux_1931;
									   aux_1931 = CAR(rest_615);
									   test_1930 = STRINGP(aux_1931);
									}
									if (test_1930)
									  {
									     {
										obj_t arg1410_624;
										obj_t arg1411_625;
										arg1410_624 = CDR(rest_615);
										{
										   obj_t aux_1935;
										   aux_1935 = CAR(rest_615);
										   arg1411_625 = MAKE_PAIR(aux_1935, fnames_616);
										}
										{
										   obj_t fnames_1939;
										   obj_t rest_1938;
										   rest_1938 = arg1410_624;
										   fnames_1939 = arg1411_625;
										   fnames_616 = fnames_1939;
										   rest_615 = rest_1938;
										   goto loop_617;
										}
									     }
									  }
									else
									  {
									     {
										obj_t list1417_630;
										list1417_630 = MAKE_PAIR(BNIL, BNIL);
										return user_error_151_tools_error(string1752_module_impuse, string1755_module_impuse, prototype_26, list1417_630);
									     }
									  }
								     }
								}
							     }
							  }
							else
							  {
							     if (SYMBOLP(prototype_26))
							       {
								  return import_all_module_109_module_impuse(prototype_26, mode_27);
							       }
							     else
							       {
								tag_132_226_481:
								  {
								     obj_t list1427_636;
								     list1427_636 = MAKE_PAIR(BNIL, BNIL);
								     return user_error_151_tools_error(string1752_module_impuse, string1756_module_impuse, prototype_26, list1427_636);
								  }
							       }
							  }
						     }
						   else
						     {
							if (SYMBOLP(prototype_26))
							  {
							     return import_all_module_109_module_impuse(prototype_26, mode_27);
							  }
							else
							  {
							     goto tag_132_226_481;
							  }
						     }
						}
					      else
						{
						   if (SYMBOLP(prototype_26))
						     {
							return import_all_module_109_module_impuse(prototype_26, mode_27);
						     }
						   else
						     {
							goto tag_132_226_481;
						     }
						}
					   }
					 else
					   {
					      if (SYMBOLP(prototype_26))
						{
						   return import_all_module_109_module_impuse(prototype_26, mode_27);
						}
					      else
						{
						   goto tag_132_226_481;
						}
					   }
				      }
				 }
			       else
				 {
				    if (SYMBOLP(car_144_227_484))
				      {
					 obj_t car_237_172_516;
					 obj_t cdr_238_48_517;
					 car_237_172_516 = CAR(cdr_145_238_485);
					 cdr_238_48_517 = CDR(cdr_145_238_485);
					 if (SYMBOLP(car_237_172_516))
					   {
					      if (PAIRP(cdr_238_48_517))
						{
						   obj_t car_244_36_520;
						   car_244_36_520 = CAR(cdr_238_48_517);
						   if (STRINGP(car_244_36_520))
						     {
							obj_t rest_1971;
							obj_t f_1970;
							obj_t m_1969;
							obj_t v_1968;
							v_1968 = car_144_227_484;
							m_1969 = car_237_172_516;
							f_1970 = car_244_36_520;
							rest_1971 = CDR(cdr_238_48_517);
							rest_477 = rest_1971;
							f_476 = f_1970;
							m_475 = m_1969;
							v_474 = v_1968;
							goto tag_130_214_478;
						     }
						   else
						     {
							if (SYMBOLP(prototype_26))
							  {
							     return import_all_module_109_module_impuse(prototype_26, mode_27);
							  }
							else
							  {
							     goto tag_132_226_481;
							  }
						     }
						}
					      else
						{
						   if (SYMBOLP(prototype_26))
						     {
							return import_all_module_109_module_impuse(prototype_26, mode_27);
						     }
						   else
						     {
							goto tag_132_226_481;
						     }
						}
					   }
					 else
					   {
					      if (SYMBOLP(prototype_26))
						{
						   return import_all_module_109_module_impuse(prototype_26, mode_27);
						}
					      else
						{
						   goto tag_132_226_481;
						}
					   }
				      }
				    else
				      {
					 if (SYMBOLP(prototype_26))
					   {
					      return import_all_module_109_module_impuse(prototype_26, mode_27);
					   }
					 else
					   {
					      goto tag_132_226_481;
					   }
				      }
				 }
			    }
			  else
			    {
			       if (SYMBOLP(car_144_227_484))
				 {
				    obj_t car_280_133_530;
				    obj_t cdr_281_218_531;
				    car_280_133_530 = CAR(cdr_145_238_485);
				    cdr_281_218_531 = CDR(cdr_145_238_485);
				    if (SYMBOLP(car_280_133_530))
				      {
					 if (PAIRP(cdr_281_218_531))
					   {
					      obj_t car_289_221_534;
					      car_289_221_534 = CAR(cdr_281_218_531);
					      if (STRINGP(car_289_221_534))
						{
						   obj_t rest_1999;
						   obj_t f_1998;
						   obj_t m_1997;
						   obj_t v_1996;
						   v_1996 = car_144_227_484;
						   m_1997 = car_280_133_530;
						   f_1998 = car_289_221_534;
						   rest_1999 = CDR(cdr_281_218_531);
						   rest_477 = rest_1999;
						   f_476 = f_1998;
						   m_475 = m_1997;
						   v_474 = v_1996;
						   goto tag_130_214_478;
						}
					      else
						{
						   if (SYMBOLP(prototype_26))
						     {
							return import_all_module_109_module_impuse(prototype_26, mode_27);
						     }
						   else
						     {
							goto tag_132_226_481;
						     }
						}
					   }
					 else
					   {
					      if (SYMBOLP(prototype_26))
						{
						   return import_all_module_109_module_impuse(prototype_26, mode_27);
						}
					      else
						{
						   goto tag_132_226_481;
						}
					   }
				      }
				    else
				      {
					 if (SYMBOLP(prototype_26))
					   {
					      return import_all_module_109_module_impuse(prototype_26, mode_27);
					   }
					 else
					   {
					      goto tag_132_226_481;
					   }
				      }
				 }
			       else
				 {
				    if (SYMBOLP(prototype_26))
				      {
					 return import_all_module_109_module_impuse(prototype_26, mode_27);
				      }
				    else
				      {
					 goto tag_132_226_481;
				      }
				 }
			    }
		       }
		  }
		else
		  {
		     if (SYMBOLP(prototype_26))
		       {
			  return import_all_module_109_module_impuse(prototype_26, mode_27);
		       }
		     else
		       {
			  goto tag_132_226_481;
		       }
		  }
	     }
	   else
	     {
		if (SYMBOLP(car_144_227_484))
		  {
		     if (PAIRP(cdr_145_238_485))
		       {
			  obj_t car_344_246_546;
			  car_344_246_546 = CAR(cdr_145_238_485);
			  if (SYMBOLP(car_344_246_546))
			    {
			       bool_t test_2023;
			       {
				  obj_t aux_2024;
				  aux_2024 = CDR(cdr_145_238_485);
				  test_2023 = (aux_2024 == BNIL);
			       }
			       if (test_2023)
				 {
				    return import_1_module_184_module_impuse(car_344_246_546, car_144_227_484, mode_27);
				 }
			       else
				 {
				    if (SYMBOLP(car_144_227_484))
				      {
					 obj_t car_367_38_552;
					 obj_t cdr_368_205_553;
					 car_367_38_552 = CAR(cdr_145_238_485);
					 cdr_368_205_553 = CDR(cdr_145_238_485);
					 if (SYMBOLP(car_367_38_552))
					   {
					      if (PAIRP(cdr_368_205_553))
						{
						   obj_t car_376_57_556;
						   car_376_57_556 = CAR(cdr_368_205_553);
						   if (STRINGP(car_376_57_556))
						     {
							obj_t rest_2042;
							obj_t f_2041;
							obj_t m_2040;
							obj_t v_2039;
							v_2039 = car_144_227_484;
							m_2040 = car_367_38_552;
							f_2041 = car_376_57_556;
							rest_2042 = CDR(cdr_368_205_553);
							rest_477 = rest_2042;
							f_476 = f_2041;
							m_475 = m_2040;
							v_474 = v_2039;
							goto tag_130_214_478;
						     }
						   else
						     {
							if (SYMBOLP(prototype_26))
							  {
							     return import_all_module_109_module_impuse(prototype_26, mode_27);
							  }
							else
							  {
							     goto tag_132_226_481;
							  }
						     }
						}
					      else
						{
						   if (SYMBOLP(prototype_26))
						     {
							return import_all_module_109_module_impuse(prototype_26, mode_27);
						     }
						   else
						     {
							goto tag_132_226_481;
						     }
						}
					   }
					 else
					   {
					      if (SYMBOLP(prototype_26))
						{
						   return import_all_module_109_module_impuse(prototype_26, mode_27);
						}
					      else
						{
						   goto tag_132_226_481;
						}
					   }
				      }
				    else
				      {
					 if (SYMBOLP(prototype_26))
					   {
					      return import_all_module_109_module_impuse(prototype_26, mode_27);
					   }
					 else
					   {
					      goto tag_132_226_481;
					   }
				      }
				 }
			    }
			  else
			    {
			       if (SYMBOLP(car_144_227_484))
				 {
				    obj_t car_412_102_568;
				    obj_t cdr_413_22_569;
				    car_412_102_568 = CAR(cdr_145_238_485);
				    cdr_413_22_569 = CDR(cdr_145_238_485);
				    if (SYMBOLP(car_412_102_568))
				      {
					 if (PAIRP(cdr_413_22_569))
					   {
					      obj_t car_421_152_572;
					      car_421_152_572 = CAR(cdr_413_22_569);
					      if (STRINGP(car_421_152_572))
						{
						   obj_t rest_2070;
						   obj_t f_2069;
						   obj_t m_2068;
						   obj_t v_2067;
						   v_2067 = car_144_227_484;
						   m_2068 = car_412_102_568;
						   f_2069 = car_421_152_572;
						   rest_2070 = CDR(cdr_413_22_569);
						   rest_477 = rest_2070;
						   f_476 = f_2069;
						   m_475 = m_2068;
						   v_474 = v_2067;
						   goto tag_130_214_478;
						}
					      else
						{
						   if (SYMBOLP(prototype_26))
						     {
							return import_all_module_109_module_impuse(prototype_26, mode_27);
						     }
						   else
						     {
							goto tag_132_226_481;
						     }
						}
					   }
					 else
					   {
					      if (SYMBOLP(prototype_26))
						{
						   return import_all_module_109_module_impuse(prototype_26, mode_27);
						}
					      else
						{
						   goto tag_132_226_481;
						}
					   }
				      }
				    else
				      {
					 if (SYMBOLP(prototype_26))
					   {
					      return import_all_module_109_module_impuse(prototype_26, mode_27);
					   }
					 else
					   {
					      goto tag_132_226_481;
					   }
				      }
				 }
			       else
				 {
				    if (SYMBOLP(prototype_26))
				      {
					 return import_all_module_109_module_impuse(prototype_26, mode_27);
				      }
				    else
				      {
					 goto tag_132_226_481;
				      }
				 }
			    }
		       }
		     else
		       {
			  if (SYMBOLP(prototype_26))
			    {
			       return import_all_module_109_module_impuse(prototype_26, mode_27);
			    }
			  else
			    {
			       goto tag_132_226_481;
			    }
		       }
		  }
		else
		  {
		     if (SYMBOLP(car_144_227_484))
		       {
			  if (PAIRP(cdr_145_238_485))
			    {
			       obj_t car_467_136_584;
			       obj_t cdr_468_188_585;
			       car_467_136_584 = CAR(cdr_145_238_485);
			       cdr_468_188_585 = CDR(cdr_145_238_485);
			       if (SYMBOLP(car_467_136_584))
				 {
				    if (PAIRP(cdr_468_188_585))
				      {
					 obj_t car_474_202_588;
					 car_474_202_588 = CAR(cdr_468_188_585);
					 if (STRINGP(car_474_202_588))
					   {
					      obj_t rest_2103;
					      obj_t f_2102;
					      obj_t m_2101;
					      obj_t v_2100;
					      v_2100 = car_144_227_484;
					      m_2101 = car_467_136_584;
					      f_2102 = car_474_202_588;
					      rest_2103 = CDR(cdr_468_188_585);
					      rest_477 = rest_2103;
					      f_476 = f_2102;
					      m_475 = m_2101;
					      v_474 = v_2100;
					      goto tag_130_214_478;
					   }
					 else
					   {
					      if (SYMBOLP(prototype_26))
						{
						   return import_all_module_109_module_impuse(prototype_26, mode_27);
						}
					      else
						{
						   goto tag_132_226_481;
						}
					   }
				      }
				    else
				      {
					 if (SYMBOLP(prototype_26))
					   {
					      return import_all_module_109_module_impuse(prototype_26, mode_27);
					   }
					 else
					   {
					      goto tag_132_226_481;
					   }
				      }
				 }
			       else
				 {
				    if (SYMBOLP(prototype_26))
				      {
					 return import_all_module_109_module_impuse(prototype_26, mode_27);
				      }
				    else
				      {
					 goto tag_132_226_481;
				      }
				 }
			    }
			  else
			    {
			       if (SYMBOLP(prototype_26))
				 {
				    return import_all_module_109_module_impuse(prototype_26, mode_27);
				 }
			       else
				 {
				    goto tag_132_226_481;
				 }
			    }
		       }
		     else
		       {
			  if (SYMBOLP(prototype_26))
			    {
			       return import_all_module_109_module_impuse(prototype_26, mode_27);
			    }
			  else
			    {
			       goto tag_132_226_481;
			    }
		       }
		  }
	     }
	}
      else
	{
	   if (SYMBOLP(prototype_26))
	     {
		return import_all_module_109_module_impuse(prototype_26, mode_27);
	     }
	   else
	     {
		goto tag_132_226_481;
	     }
	}
   }
}


obj_t 
get_imported_modules_153_module_impuse()
{
   return __imported_module_list__84_module_impuse;
}


obj_t 
_get_imported_modules_109_module_impuse(obj_t env_1658)
{
   return get_imported_modules_153_module_impuse();
}


obj_t 
import_finalizer_66_module_impuse()
{
   __import_module_list__76_module_impuse = reverse__39___r4_pairs_and_lists_6_3(__import_module_list__76_module_impuse);
   {
      bool_t test1454_655;
      {
	 obj_t aux_2125;
	 aux_2125 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 8)), BINT(((long) 2)));
	 test1454_655 = CBOOL(aux_2125);
      }
      if (test1454_655)
	{
	   obj_t list1455_656;
	   {
	      obj_t arg1458_658;
	      {
		 obj_t arg1461_659;
		 {
		    obj_t aux_2131;
		    aux_2131 = BCHAR(((unsigned char) '\n'));
		    arg1461_659 = MAKE_PAIR(aux_2131, BNIL);
		 }
		 arg1458_658 = MAKE_PAIR(__import_module_list__76_module_impuse, arg1461_659);
	      }
	      list1455_656 = MAKE_PAIR(string1757_module_impuse, arg1458_658);
	   }
	   print_trace_107_tools_trace(list1455_656);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t init__202_663;
      init__202_663 = BNIL;
    loop_664:
      {
	 bool_t test1468_666;
	 {
	    obj_t obj_1450;
	    obj_1450 = __import_module_list__76_module_impuse;
	    test1468_666 = NULLP(obj_1450);
	 }
	 if (test1468_666)
	   {
	      if (PAIRP(init__202_663))
		{
		   obj_t init__202_668;
		   obj_t init_call__93_669;
		   init__202_668 = init__202_663;
		   init_call__93_669 = BNIL;
		 loop_670:
		   if (NULLP(init__202_668))
		     {
			obj_t arg1472_673;
			{
			   obj_t arg1476_676;
			   arg1476_676 = CNST_TABLE_REF(((long) 9));
			   {
			      obj_t new_1457;
			      {
				 obj_t aux_2144;
				 aux_2144 = CNST_TABLE_REF(((long) 10));
				 new_1457 = create_struct(aux_2144, ((long) 4));
			      }
			      STRUCT_SET(new_1457, ((long) 3), BTRUE);
			      STRUCT_SET(new_1457, ((long) 2), init_call__93_669);
			      {
				 obj_t aux_2149;
				 aux_2149 = BINT(((long) 12));
				 STRUCT_SET(new_1457, ((long) 1), aux_2149);
			      }
			      STRUCT_SET(new_1457, ((long) 0), arg1476_676);
			      arg1472_673 = new_1457;
			   }
			}
			{
			   obj_t list1473_674;
			   list1473_674 = MAKE_PAIR(arg1472_673, BNIL);
			   return list1473_674;
			}
		     }
		   else
		     {
			obj_t id_678;
			{
			   obj_t aux_2154;
			   aux_2154 = CAR(init__202_668);
			   id_678 = STRUCT_REF(aux_2154, ((long) 0));
			}
			{
			   obj_t checksum_679;
			   {
			      obj_t aux_2157;
			      aux_2157 = CAR(init__202_668);
			      checksum_679 = STRUCT_REF(aux_2157, ((long) 3));
			   }
			   {
			      obj_t init_fun_id_230_680;
			      init_fun_id_230_680 = module_initialization_id_110_module_module(id_678);
			      {
				 {
				    obj_t global_681;
				    {
				       obj_t arg1478_682;
				       {
					  obj_t arg1480_683;
					  arg1480_683 = CNST_TABLE_REF(((long) 11));
					  {
					     obj_t list1482_685;
					     {
						obj_t arg1484_686;
						{
						   obj_t arg1485_687;
						   {
						      obj_t aux_2162;
						      aux_2162 = CNST_TABLE_REF(((long) 12));
						      arg1485_687 = MAKE_PAIR(aux_2162, BNIL);
						   }
						   arg1484_686 = MAKE_PAIR(arg1480_683, arg1485_687);
						}
						list1482_685 = MAKE_PAIR(init_fun_id_230_680, arg1484_686);
					     }
					     arg1478_682 = list1482_685;
					  }
				       }
				       global_681 = import_parser_53_module_impuse(id_678, arg1478_682);
				    }
				    {
				       obj_t res1731_1492;
				       {
					  global_t obj_1490;
					  obj_1490 = (global_t) (global_681);
					  {
					     obj_t x_1690;
					     x_1690 = ((((global_t) CREF(obj_1490))->evaluable__248) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					     res1731_1492 = BUNSPEC;
					  }
				       }
				       res1731_1492;
				    }
				 }
				 {
				    obj_t arg1487_689;
				    obj_t arg1489_690;
				    arg1487_689 = CDR(init__202_668);
				    {
				       obj_t arg1490_691;
				       {
					  obj_t arg1493_692;
					  obj_t arg1494_693;
					  {
					     obj_t arg1501_699;
					     arg1501_699 = CNST_TABLE_REF(((long) 13));
					     {
						obj_t list1506_701;
						{
						   obj_t arg1507_702;
						   {
						      obj_t arg1509_703;
						      arg1509_703 = MAKE_PAIR(BNIL, BNIL);
						      arg1507_702 = MAKE_PAIR(id_678, arg1509_703);
						   }
						   list1506_701 = MAKE_PAIR(init_fun_id_230_680, arg1507_702);
						}
						arg1493_692 = cons__138___r4_pairs_and_lists_6_3(arg1501_699, list1506_701);
					     }
					  }
					  {
					     obj_t symbol_1494;
					     symbol_1494 = __module__166_module_module;
					     arg1494_693 = SYMBOL_TO_STRING(symbol_1494);
					  }
					  {
					     obj_t list1497_695;
					     {
						obj_t arg1498_696;
						{
						   obj_t arg1499_697;
						   arg1499_697 = MAKE_PAIR(BNIL, BNIL);
						   arg1498_696 = MAKE_PAIR(arg1494_693, arg1499_697);
						}
						list1497_695 = MAKE_PAIR(checksum_679, arg1498_696);
					     }
					     arg1490_691 = cons__138___r4_pairs_and_lists_6_3(arg1493_692, list1497_695);
					  }
				       }
				       arg1489_690 = MAKE_PAIR(arg1490_691, init_call__93_669);
				    }
				    {
				       obj_t init_call__93_2183;
				       obj_t init__202_2182;
				       init__202_2182 = arg1487_689;
				       init_call__93_2183 = arg1489_690;
				       init_call__93_669 = init_call__93_2183;
				       init__202_668 = init__202_2182;
				       goto loop_670;
				    }
				 }
			      }
			   }
			}
		     }
		}
	      else
		{
		   return BNIL;
		}
	   }
	 else
	   {
	      obj_t module_707;
	      obj_t imode_708;
	      {
		 obj_t arg1524_716;
		 {
		    obj_t pair_1497;
		    pair_1497 = __import_module_list__76_module_impuse;
		    arg1524_716 = CAR(pair_1497);
		 }
		 module_707 = CAR(arg1524_716);
	      }
	      {
		 obj_t arg1526_717;
		 {
		    obj_t pair_1499;
		    pair_1499 = __import_module_list__76_module_impuse;
		    arg1526_717 = CAR(pair_1499);
		 }
		 imode_708 = CDR(arg1526_717);
	      }
	      {
		 obj_t pair_1501;
		 pair_1501 = __import_module_list__76_module_impuse;
		 __import_module_list__76_module_impuse = CDR(pair_1501);
	      }
	      {
		 obj_t obj2_1503;
		 obj2_1503 = __imported_module_list__84_module_impuse;
		 __imported_module_list__84_module_impuse = MAKE_PAIR(module_707, obj2_1503);
	      }
	      {
		 bool_t test_2190;
		 {
		    obj_t aux_2193;
		    obj_t aux_2191;
		    aux_2193 = CNST_TABLE_REF(((long) 6));
		    aux_2191 = STRUCT_REF(imode_708, ((long) 1));
		    test_2190 = (aux_2191 == aux_2193);
		 }
		 if (test_2190)
		   {
		      BUNSPEC;
		   }
		 else
		   {
		      read_imported_module_112_module_impuse(imode_708);
		   }
	      }
	      {
		 obj_t arg1520_712;
		 {
		    bool_t test_2197;
		    {
		       obj_t aux_2198;
		       aux_2198 = memq___r4_pairs_and_lists_6_3(STRUCT_REF(imode_708, ((long) 1)), CNST_TABLE_REF(((long) 14)));
		       test_2197 = CBOOL(aux_2198);
		    }
		    if (test_2197)
		      {
			 arg1520_712 = MAKE_PAIR(imode_708, init__202_663);
		      }
		    else
		      {
			 arg1520_712 = init__202_663;
		      }
		 }
		 {
		    obj_t init__202_2204;
		    init__202_2204 = arg1520_712;
		    init__202_663 = init__202_2204;
		    goto loop_664;
		 }
	      }
	   }
      }
   }
}


obj_t 
impuse_finalizer_42_module_impuse()
{
   {
      obj_t import_finalizer_66_718;
      import_finalizer_66_718 = import_finalizer_66_module_impuse();
      {
	 obj_t inline_finalizer_105_719;
	 inline_finalizer_105_719 = inline_finalizer_105_read_inline();
	 {
	    obj_t finalizers_720;
	    finalizers_720 = append_2_18___r4_pairs_and_lists_6_3(import_finalizer_66_718, inline_finalizer_105_719);
	    {
	       if (NULLP(finalizers_720))
		 {
		    return CNST_TABLE_REF(((long) 1));
		 }
	       else
		 {
		    return finalizers_720;
		 }
	    }
	 }
      }
   }
}


obj_t 
_impuse_finalizer_29_module_impuse(obj_t env_1644)
{
   return impuse_finalizer_42_module_impuse();
}


obj_t 
import_parser_53_module_impuse(obj_t module_46, obj_t prototype_47)
{
   {
      obj_t proto_722;
      proto_722 = parse_prototype_143_module_prototype(prototype_47);
      if (PAIRP(proto_722))
	{
	   obj_t case_value_58_724;
	   case_value_58_724 = CAR(proto_722);
	   {
	      bool_t test_2216;
	      {
		 obj_t aux_2217;
		 aux_2217 = memq___r4_pairs_and_lists_6_3(case_value_58_724, CNST_TABLE_REF(((long) 15)));
		 test_2216 = CBOOL(aux_2217);
	      }
	      if (test_2216)
		{
		   global_t aux_2221;
		   {
		      obj_t aux_2226;
		      obj_t aux_2222;
		      {
			 obj_t aux_2227;
			 {
			    obj_t aux_2228;
			    aux_2228 = CDR(proto_722);
			    aux_2227 = CDR(aux_2228);
			 }
			 aux_2226 = CAR(aux_2227);
		      }
		      {
			 obj_t aux_2223;
			 aux_2223 = CDR(proto_722);
			 aux_2222 = CAR(aux_2223);
		      }
		      aux_2221 = declare_global_sfun__255_ast_glo_decl_237(aux_2222, aux_2226, module_46, CNST_TABLE_REF(((long) 0)), case_value_58_724, prototype_47);
		   }
		   return (obj_t) (aux_2221);
		}
	      else
		{
		   bool_t test_2235;
		   {
		      obj_t aux_2236;
		      aux_2236 = CNST_TABLE_REF(((long) 16));
		      test_2235 = (case_value_58_724 == aux_2236);
		   }
		   if (test_2235)
		     {
			global_t aux_2239;
			{
			   obj_t aux_2240;
			   {
			      obj_t aux_2241;
			      aux_2241 = CDR(proto_722);
			      aux_2240 = CAR(aux_2241);
			   }
			   aux_2239 = declare_global_svar__200_ast_glo_decl_237(aux_2240, module_46, CNST_TABLE_REF(((long) 0)), prototype_47);
			}
			return (obj_t) (aux_2239);
		     }
		   else
		     {
			bool_t test_2247;
			{
			   obj_t aux_2248;
			   aux_2248 = CNST_TABLE_REF(((long) 17));
			   test_2247 = (case_value_58_724 == aux_2248);
			}
			if (test_2247)
			  {
			     return declare_class__31_module_class(CDR(proto_722), module_46, CNST_TABLE_REF(((long) 0)), ((bool_t) 0), prototype_47);
			  }
			else
			  {
			     bool_t test_2254;
			     {
				obj_t aux_2255;
				aux_2255 = CNST_TABLE_REF(((long) 18));
				test_2254 = (case_value_58_724 == aux_2255);
			     }
			     if (test_2254)
			       {
				  return declare_class__31_module_class(CDR(proto_722), module_46, CNST_TABLE_REF(((long) 0)), ((bool_t) 1), prototype_47);
			       }
			     else
			       {
				  bool_t test_2261;
				  {
				     obj_t aux_2262;
				     aux_2262 = CNST_TABLE_REF(((long) 19));
				     test_2261 = (case_value_58_724 == aux_2262);
				  }
				  if (test_2261)
				    {
				       return declare_wide_class__13_module_class(CDR(proto_722), module_46, CNST_TABLE_REF(((long) 0)), prototype_47);
				    }
				  else
				    {
				       obj_t list1554_745;
				       list1554_745 = MAKE_PAIR(BNIL, BNIL);
				       return user_error_151_tools_error(string1752_module_impuse, string1758_module_impuse, prototype_47, list1554_745);
				    }
			       }
			  }
		     }
		}
	   }
	}
      else
	{
	   obj_t list1566_755;
	   list1566_755 = MAKE_PAIR(BNIL, BNIL);
	   return user_error_151_tools_error(string1752_module_impuse, string1758_module_impuse, prototype_47, list1566_755);
	}
   }
}


obj_t 
_import_parser_19_module_impuse(obj_t env_1659, obj_t module_1660, obj_t prototype_1661)
{
   return import_parser_53_module_impuse(module_1660, prototype_1661);
}


obj_t 
read_imported_module_112_module_impuse(obj_t imode_48)
{
   {
      bool_t test1568_757;
      {
	 obj_t aux_2273;
	 aux_2273 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 8)), BINT(((long) 2)));
	 test1568_757 = CBOOL(aux_2273);
      }
      if (test1568_757)
	{
	   obj_t list1569_758;
	   {
	      obj_t arg1570_759;
	      {
		 obj_t arg1572_761;
		 {
		    obj_t arg1573_762;
		    {
		       obj_t aux_2279;
		       aux_2279 = BCHAR(((unsigned char) '\n'));
		       arg1573_762 = MAKE_PAIR(aux_2279, BNIL);
		    }
		    arg1572_761 = MAKE_PAIR(imode_48, arg1573_762);
		 }
		 arg1570_759 = MAKE_PAIR(string1759_module_impuse, arg1572_761);
	      }
	      {
		 obj_t aux_2284;
		 aux_2284 = BCHAR(((unsigned char) '\n'));
		 list1569_758 = MAKE_PAIR(aux_2284, arg1570_759);
	      }
	   }
	   print_trace_107_tools_trace(list1569_758);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t module_766;
      module_766 = STRUCT_REF(imode_48, ((long) 0));
      {
	 obj_t wanted_767;
	 wanted_767 = STRUCT_REF(imode_48, ((long) 2));
	 {
	    obj_t b_768;
	    b_768 = assq___r4_pairs_and_lists_6_3(module_766, __access_table__91_engine_param);
	    {
	       {
		  char *arg1579_771;
		  {
		     bool_t test_2291;
		     {
			obj_t aux_2294;
			obj_t aux_2292;
			aux_2294 = CNST_TABLE_REF(((long) 2));
			aux_2292 = STRUCT_REF(imode_48, ((long) 1));
			test_2291 = (aux_2292 == aux_2294);
		     }
		     if (test_2291)
		       {
			  arg1579_771 = "used";
		       }
		     else
		       {
			  arg1579_771 = "imported";
		       }
		  }
		  {
		     obj_t list1584_774;
		     {
			obj_t arg1585_775;
			{
			   obj_t arg1587_776;
			   {
			      obj_t arg1588_777;
			      {
				 obj_t arg1589_778;
				 {
				    obj_t arg1590_779;
				    {
				       obj_t aux_2297;
				       aux_2297 = BCHAR(((unsigned char) '\n'));
				       arg1590_779 = MAKE_PAIR(aux_2297, BNIL);
				    }
				    arg1589_778 = MAKE_PAIR(string1760_module_impuse, arg1590_779);
				 }
				 arg1588_777 = MAKE_PAIR(module_766, arg1589_778);
			      }
			      arg1587_776 = MAKE_PAIR(string1761_module_impuse, arg1588_777);
			   }
			   {
			      obj_t aux_2303;
			      aux_2303 = string_to_bstring(arg1579_771);
			      arg1585_775 = MAKE_PAIR(aux_2303, arg1587_776);
			   }
			}
			list1584_774 = MAKE_PAIR(string1762_module_impuse, arg1585_775);
		     }
		     verbose_tools_speek(BINT(((long) 2)), list1584_774);
		  }
	       }
	       if (CBOOL(b_768))
		 {
		    obj_t fnames_784;
		    fnames_784 = CDR(b_768);
		    {
		       obj_t fname_785;
		       fname_785 = find_file_path_55_tools_file(CAR(fnames_784), __load_path__54___eval);
		       {
			  if (STRINGP(fname_785))
			    {
			       obj_t port_787;
			       port_787 = open_input_file_61___r4_ports_6_10_1(fname_785, BNIL);
			       if (INPUT_PORTP(port_787))
				 {
				    obj_t handler_1663;
				    handler_1663 = make_fx_procedure(handler1741_module_impuse, ((long) 4), ((long) 1));
				    PROCEDURE_SET(handler_1663, ((long) 0), port_787);
				    {
				       obj_t armed1119_792;
				       armed1119_792 = MAKE_CELL(BTRUE);
				       return handling_function1598_122_module_impuse(handler_1663, armed1119_792, fnames_784, wanted_767, imode_48, module_766, port_787);
				    }
				 }
			       else
				 {
				    obj_t arg1623_833;
				    arg1623_833 = CAR(fnames_784);
				    {
				       obj_t list1625_835;
				       list1625_835 = MAKE_PAIR(BNIL, BNIL);
				       return user_error_151_tools_error(string1763_module_impuse, string1764_module_impuse, arg1623_833, list1625_835);
				    }
				 }
			    }
			  else
			    {
			       obj_t arg1632_840;
			       arg1632_840 = CAR(fnames_784);
			       {
				  obj_t list1635_842;
				  list1635_842 = MAKE_PAIR(BNIL, BNIL);
				  return user_error_151_tools_error(string1763_module_impuse, string1764_module_impuse, arg1632_840, list1635_842);
			       }
			    }
		       }
		    }
		 }
	       else
		 {
		    obj_t list1644_848;
		    list1644_848 = MAKE_PAIR(BNIL, BNIL);
		    return user_error_151_tools_error(string1763_module_impuse, string1765_module_impuse, module_766, list1644_848);
		 }
	    }
	 }
      }
   }
}


obj_t 
handling_function1598_122_module_impuse(obj_t handler1117_1681, obj_t armed1119_1680, obj_t fnames_1679, obj_t wanted_1678, obj_t imode_1677, obj_t module_1676, obj_t port_1675)
{
   jmp_buf jmpbuf;
   obj_t an_exit1120_58_794;
   if (SET_EXIT(an_exit1120_58_794))
     {
	RESTORE_TRACE();
	return _exit_value_;
     }
   else
     {
	an_exit1120_58_794 = (obj_t) jmpbuf;
	{
	   PUSH_EXIT(an_exit1120_58_794, ((bool_t) 1));
	   {
	      obj_t an_exitd1121_137_795;
	      an_exitd1121_137_795 = exitd_top;
	      {
		 obj_t res1123_798;
		 {
		    obj_t arg1600_1662;
		    arg1600_1662 = make_fx_procedure(arg16001740_module_impuse, ((long) 1), ((long) 2));
		    PROCEDURE_SET(arg1600_1662, ((long) 0), armed1119_1680);
		    PROCEDURE_SET(arg1600_1662, ((long) 1), an_exitd1121_137_795);
		    add_error_handler__155___error(handler1117_1681, arg1600_1662);
		 }
		 {
		    obj_t val1124_803;
		    val1124_803 = handling_function1605_110_module_impuse(fnames_1679, wanted_1678, imode_1677, module_1676, port_1675);
		    {
		       bool_t test_2338;
		       {
			  obj_t aux_2339;
			  aux_2339 = CELL_REF(armed1119_1680);
			  test_2338 = CBOOL(aux_2339);
		       }
		       if (test_2338)
			 {
			    remove_error_handler__102___error();
			 }
		       else
			 {
			    BUNSPEC;
			 }
		    }
		    {
		       bool_t test1602_804;
		       {
			  obj_t aux_2342;
			  aux_2342 = val_from_exit__100___bexit(val1124_803);
			  test1602_804 = CBOOL(aux_2342);
		       }
		       if (test1602_804)
			 {
			    res1123_798 = unwind_until__178___bexit(CAR(val1124_803), CDR(val1124_803));
			 }
		       else
			 {
			    res1123_798 = val1124_803;
			 }
		    }
		 }
		 POP_EXIT();
		 return res1123_798;
	      }
	   }
	}
     }
}


obj_t 
handling_function1605_110_module_impuse(obj_t fnames_1686, obj_t wanted_1685, obj_t imode_1684, obj_t module_1683, obj_t port_1682)
{
   {
      jmp_buf jmpbuf;
      obj_t an_exit1125_12_808;
      if (SET_EXIT(an_exit1125_12_808))
	{
	   RESTORE_TRACE();
	   return _exit_value_;
	}
      else
	{
	   an_exit1125_12_808 = (obj_t) jmpbuf;
	   {
	      PUSH_EXIT(an_exit1125_12_808, ((bool_t) 0));
	      {
		 obj_t val1126_809;
		 {
		    obj_t mdecl_811;
		    {
		       obj_t list1615_820;
		       {
			  obj_t arg1616_821;
			  arg1616_821 = MAKE_PAIR(BTRUE, BNIL);
			  list1615_820 = MAKE_PAIR(port_1682, arg1616_821);
		       }
		       mdecl_811 = read___reader(list1615_820);
		    }
		    {
		       obj_t prov_812;
		       {
			  obj_t arg1611_818;
			  obj_t arg1614_819;
			  reset_include_consumed_directive__234_module_include();
			  reset_include_consumed_code__8_module_include();
			  arg1611_818 = consume_module__183_module_module(module_1683, mdecl_811);
			  arg1614_819 = get_include_consumed_directive_80_module_include();
			  prov_812 = append_2_18___r4_pairs_and_lists_6_3(arg1611_818, arg1614_819);
		       }
		       {
			  obj_t code_813;
			  code_813 = get_include_consumed_code_244_module_include();
			  {
			     obj_t check_814;
			     check_814 = checksum_module_8_module_module(mdecl_811);
			     {
				STRUCT_SET(imode_1684, ((long) 3), check_814);
				{
				   obj_t arg1608_815;
				   obj_t arg1609_816;
				   if (PAIRP(wanted_1685))
				     {
					arg1608_815 = import_wanted_18_module_impuse(prov_812, wanted_1685, module_1683);
				     }
				   else
				     {
					arg1608_815 = import_everything_193_module_impuse(prov_812, module_1683);
				     }
				   arg1609_816 = CDR(fnames_1686);
				   look_for_inline_98_read_inline(arg1608_815, code_813, port_1682, arg1609_816, module_1683);
				}
				val1126_809 = close_input_port(port_1682);
			     }
			  }
		       }
		    }
		 }
		 POP_EXIT();
		 return val1126_809;
	      }
	   }
	}
   }
}


obj_t 
arg16001740_module_impuse(obj_t env_1664, obj_t arg_1667)
{
   {
      obj_t armed1119_1665;
      obj_t an_exitd1121_137_1666;
      armed1119_1665 = PROCEDURE_REF(env_1664, ((long) 0));
      an_exitd1121_137_1666 = PROCEDURE_REF(env_1664, ((long) 1));
      {
	 obj_t arg_800;
	 arg_800 = arg_1667;
	 CELL_SET(armed1119_1665, BFALSE);
	 return unwind_until__178___bexit(an_exitd1121_137_1666, arg_800);
      }
   }
}


obj_t 
handler1741_module_impuse(obj_t env_1669, obj_t escape_1671, obj_t proc_1672, obj_t mes_1673, obj_t obj_1674)
{
   {
      obj_t port_1670;
      port_1670 = PROCEDURE_REF(env_1669, ((long) 0));
      {
	 obj_t escape_824;
	 obj_t proc_825;
	 obj_t mes_826;
	 obj_t obj_827;
	 escape_824 = escape_1671;
	 proc_825 = proc_1672;
	 mes_826 = mes_1673;
	 obj_827 = obj_1674;
	 notify_error_43___error(proc_825, mes_826, obj_827);
	 FLUSH_OUTPUT_PORT(current_error_port);
	 close_input_port(port_1670);
	 return exit_bigloo_229_init_main(BINT(((long) -7)));
      }
   }
}


obj_t 
import_everything_193_module_impuse(obj_t provided_49, obj_t module_50)
{
   {
      obj_t provided_850;
      obj_t inline_851;
      provided_850 = provided_49;
      inline_851 = BNIL;
    loop_852:
      if (NULLP(provided_850))
	{
	   return inline_851;
	}
      else
	{
	   obj_t p_855;
	   p_855 = import_parser_53_module_impuse(module_50, CAR(provided_850));
	   {
	      bool_t test1648_856;
	      test1648_856 = is_a__118___object(p_855, global_ast_var);
	      if (test1648_856)
		{
		   value_t val_857;
		   {
		      global_t obj_1577;
		      obj_1577 = (global_t) (p_855);
		      val_857 = (((global_t) CREF(obj_1577))->value);
		   }
		   {
		      obj_t arg1650_858;
		      obj_t arg1651_859;
		      arg1650_858 = CDR(provided_850);
		      {
			 bool_t test1652_860;
			 {
			    bool_t test1660_867;
			    test1660_867 = is_a__118___object(p_855, global_ast_var);
			    if (test1660_867)
			      {
				 bool_t test1661_868;
				 test1661_868 = is_a__118___object((obj_t) (val_857), sfun_ast_var);
				 if (test1661_868)
				   {
				      test1652_860 = ((bool_t) 0);
				   }
				 else
				   {
				      test1652_860 = ((bool_t) 1);
				   }
			      }
			    else
			      {
				 test1652_860 = ((bool_t) 1);
			      }
			 }
			 if (test1652_860)
			   {
			      arg1651_859 = inline_851;
			   }
			 else
			   {
			      bool_t test_2396;
			      {
				 obj_t aux_2400;
				 obj_t aux_2397;
				 aux_2400 = CNST_TABLE_REF(((long) 20));
				 {
				    sfun_t obj_1581;
				    obj_1581 = (sfun_t) (val_857);
				    aux_2397 = (((sfun_t) CREF(obj_1581))->class);
				 }
				 test_2396 = (aux_2397 == aux_2400);
			      }
			      if (test_2396)
				{
				   {
				      obj_t arg1654_862;
				      {
					 obj_t aux_2406;
					 obj_t aux_2403;
					 aux_2406 = CNST_TABLE_REF(((long) 20));
					 {
					    global_t obj_1584;
					    obj_1584 = (global_t) (p_855);
					    aux_2403 = (((global_t) CREF(obj_1584))->id);
					 }
					 arg1654_862 = MAKE_PAIR(aux_2403, aux_2406);
				      }
				      arg1651_859 = MAKE_PAIR(arg1654_862, inline_851);
				   }
				}
			      else
				{
				   arg1651_859 = inline_851;
				}
			   }
		      }
		      {
			 obj_t inline_2411;
			 obj_t provided_2410;
			 provided_2410 = arg1650_858;
			 inline_2411 = arg1651_859;
			 inline_851 = inline_2411;
			 provided_850 = provided_2410;
			 goto loop_852;
		      }
		   }
		}
	      else
		{
		   obj_t provided_2412;
		   provided_2412 = CDR(provided_850);
		   provided_850 = provided_2412;
		   goto loop_852;
		}
	   }
	}
   }
}


obj_t 
import_wanted_18_module_impuse(obj_t provided_51, obj_t wanted_52, obj_t module_53)
{
   {
      obj_t provided_871;
      obj_t inline_872;
      obj_t wanted_873;
      provided_871 = provided_51;
      inline_872 = BNIL;
      wanted_873 = wanted_52;
    loop_874:
      if (NULLP(wanted_873))
	{
	   return inline_872;
	}
      else
	{
	   if (NULLP(provided_871))
	     {
		{
		   obj_t list1670_880;
		   list1670_880 = MAKE_PAIR(BNIL, BNIL);
		   return user_error_151_tools_error(module_53, string1766_module_impuse, wanted_873, list1670_880);
		}
	     }
	   else
	     {
		{
		   obj_t proto_882;
		   proto_882 = parse_prototype_143_module_prototype(CAR(provided_871));
		   if (PAIRP(proto_882))
		     {
			obj_t id_884;
			{
			   obj_t aux_2424;
			   aux_2424 = CDR(proto_882);
			   id_884 = CAR(aux_2424);
			}
			{
			   bool_t test_2427;
			   {
			      obj_t aux_2428;
			      aux_2428 = memq___r4_pairs_and_lists_6_3(id_884, wanted_873);
			      test_2427 = CBOOL(aux_2428);
			   }
			   if (test_2427)
			     {
				obj_t p_886;
				p_886 = import_parser_53_module_impuse(module_53, CAR(provided_871));
				{
				   bool_t test1674_887;
				   test1674_887 = is_a__118___object(p_886, global_ast_var);
				   if (test1674_887)
				     {
					{
					   obj_t arg1677_888;
					   obj_t arg1678_889;
					   obj_t arg1679_890;
					   arg1677_888 = CDR(provided_871);
					   {
					      bool_t test_2436;
					      {
						 obj_t aux_2439;
						 obj_t aux_2437;
						 aux_2439 = CNST_TABLE_REF(((long) 20));
						 aux_2437 = CAR(proto_882);
						 test_2436 = (aux_2437 == aux_2439);
					      }
					      if (test_2436)
						{
						   {
						      obj_t arg1681_892;
						      {
							 obj_t aux_2442;
							 aux_2442 = CNST_TABLE_REF(((long) 20));
							 arg1681_892 = MAKE_PAIR(id_884, aux_2442);
						      }
						      arg1678_889 = MAKE_PAIR(arg1681_892, inline_872);
						   }
						}
					      else
						{
						   arg1678_889 = inline_872;
						}
					   }
					   arg1679_890 = remq__51___r4_pairs_and_lists_6_3(id_884, wanted_873);
					   {
					      obj_t wanted_2449;
					      obj_t inline_2448;
					      obj_t provided_2447;
					      provided_2447 = arg1677_888;
					      inline_2448 = arg1678_889;
					      wanted_2449 = arg1679_890;
					      wanted_873 = wanted_2449;
					      inline_872 = inline_2448;
					      provided_871 = provided_2447;
					      goto loop_874;
					   }
					}
				     }
				   else
				     {
					bool_t test1687_896;
					test1687_896 = is_a__118___object(p_886, type_type_type);
					if (test1687_896)
					  {
					     {
						obj_t arg1688_897;
						obj_t arg1689_898;
						arg1688_897 = CDR(provided_871);
						arg1689_898 = remq__51___r4_pairs_and_lists_6_3(id_884, wanted_873);
						{
						   obj_t wanted_2455;
						   obj_t provided_2454;
						   provided_2454 = arg1688_897;
						   wanted_2455 = arg1689_898;
						   wanted_873 = wanted_2455;
						   provided_871 = provided_2454;
						   goto loop_874;
						}
					     }
					  }
					else
					  {
					     {
						obj_t arg1690_899;
						obj_t arg1691_900;
						arg1690_899 = CDR(provided_871);
						arg1691_900 = remq__51___r4_pairs_and_lists_6_3(id_884, wanted_873);
						{
						   obj_t wanted_2459;
						   obj_t provided_2458;
						   provided_2458 = arg1690_899;
						   wanted_2459 = arg1691_900;
						   wanted_873 = wanted_2459;
						   provided_871 = provided_2458;
						   goto loop_874;
						}
					     }
					  }
				     }
				}
			     }
			   else
			     {
				obj_t provided_2460;
				provided_2460 = CDR(provided_871);
				provided_871 = provided_2460;
				goto loop_874;
			     }
			}
		     }
		   else
		     {
			obj_t provided_2462;
			provided_2462 = CDR(provided_871);
			provided_871 = provided_2462;
			goto loop_874;
		     }
		}
	     }
	}
   }
}


obj_t 
imported_modules_init_94_module_impuse()
{
   module_initialization_70_tools_trace(((long) 0), "MODULE_IMPUSE");
   module_initialization_70_module_module(((long) 0), "MODULE_IMPUSE");
   module_initialization_70_module_prototype(((long) 0), "MODULE_IMPUSE");
   module_initialization_70_module_class(((long) 0), "MODULE_IMPUSE");
   module_initialization_70_module_include(((long) 0), "MODULE_IMPUSE");
   module_initialization_70_tools_speek(((long) 0), "MODULE_IMPUSE");
   module_initialization_70_tools_error(((long) 0), "MODULE_IMPUSE");
   module_initialization_70_tools_file(((long) 0), "MODULE_IMPUSE");
   module_initialization_70_type_type(((long) 0), "MODULE_IMPUSE");
   module_initialization_70_read_access(((long) 0), "MODULE_IMPUSE");
   module_initialization_70_read_inline(((long) 0), "MODULE_IMPUSE");
   module_initialization_70_ast_var(((long) 0), "MODULE_IMPUSE");
   module_initialization_70_ast_find_gdefs_13(((long) 0), "MODULE_IMPUSE");
   module_initialization_70_ast_glo_decl_237(((long) 0), "MODULE_IMPUSE");
   module_initialization_70_engine_param(((long) 0), "MODULE_IMPUSE");
   return module_initialization_70_init_main(((long) 0), "MODULE_IMPUSE");
}
