/*===========================================================================*/
/*   (Module/library.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;


extern obj_t putprop__88___r4_symbols_6_4(obj_t, obj_t, obj_t);
extern obj_t library_finalizer_97_module_library();
extern obj_t _library_finalizer_48_module_library(obj_t);
static obj_t imported_modules_init_94_module_library();
extern obj_t module_initialization_70_module_library(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_impuse(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t toplevel_init_63_module_library();
static obj_t cnst_init_137_module_library();
extern obj_t module_initialization_id_110_module_module(obj_t);
extern obj_t __module__166_module_module;
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t require_initialization_114_module_library = BUNSPEC;
static obj_t library_modules_init_112_module_library();
static obj_t need_library_module__2_module_library(obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
static obj_t __needed_modules__74_module_library = BUNSPEC;
extern obj_t for_each_global__88_ast_env(obj_t);
extern obj_t get_imported_modules_153_module_impuse();
extern obj_t getprop___r4_symbols_6_4(obj_t, obj_t);
static obj_t __key__82_module_library = BUNSPEC;
extern obj_t gensym___r4_symbols_6_4;
static obj_t arg12051289_module_library(obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
static obj_t __cnst[5];

DEFINE_EXPORT_PROCEDURE(library_finalizer_env_247_module_library, _library_finalizer_48_module_library1297, _library_finalizer_48_module_library, 0L, 0);
DEFINE_STRING(string1291_module_library, string1291_module_library1298, "(#unspecified) @ UNIT LIBRARY-MODULES FOREIGN ", 46);
DEFINE_STATIC_PROCEDURE(proc1290_module_library, arg12051289_module_library1299, arg12051289_module_library, 0L, 1);

obj_t 
module_initialization_70_module_library(long checksum_595, char *from_596)
{
   if (CBOOL(require_initialization_114_module_library))
     {
	require_initialization_114_module_library = BBOOL(((bool_t) 0));
	library_modules_init_112_module_library();
	cnst_init_137_module_library();
	imported_modules_init_94_module_library();
	toplevel_init_63_module_library();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_module_library()
{
   module_initialization_70___r4_symbols_6_4(((long) 0), "MODULE_LIBRARY");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_LIBRARY");
   module_initialization_70___reader(((long) 0), "MODULE_LIBRARY");
   return BUNSPEC;
}


obj_t 
cnst_init_137_module_library()
{
   {
      obj_t cnst_port_138_587;
      cnst_port_138_587 = open_input_string(string1291_module_library);
      {
	 long i_588;
	 i_588 = ((long) 4);
       loop_589:
	 {
	    bool_t test1292_590;
	    test1292_590 = (i_588 == ((long) -1));
	    if (test1292_590)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1293_591;
		    {
		       obj_t list1294_592;
		       {
			  obj_t arg1295_593;
			  arg1295_593 = BNIL;
			  list1294_592 = MAKE_PAIR(cnst_port_138_587, arg1295_593);
		       }
		       arg1293_591 = read___reader(list1294_592);
		    }
		    CNST_TABLE_SET(i_588, arg1293_591);
		 }
		 {
		    int aux_594;
		    {
		       long aux_613;
		       aux_613 = (i_588 - ((long) 1));
		       aux_594 = (int) (aux_613);
		    }
		    {
		       long i_616;
		       i_616 = (long) (aux_594);
		       i_588 = i_616;
		       goto loop_589;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_module_library()
{
   __needed_modules__74_module_library = BNIL;
   return (__key__82_module_library = BUNSPEC,
      BUNSPEC);
}


obj_t 
library_finalizer_97_module_library()
{
   __key__82_module_library = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, BEOA);
   {
      obj_t l1114_326;
      {
	 obj_t arg1199_328;
	 arg1199_328 = get_imported_modules_153_module_impuse();
	 l1114_326 = arg1199_328;
       lname1116_327:
	 if (PAIRP(l1114_326))
	   {
	      putprop__88___r4_symbols_6_4(CAR(l1114_326), __key__82_module_library, BTRUE);
	      {
		 obj_t l1114_625;
		 l1114_625 = CDR(l1114_326);
		 l1114_326 = l1114_625;
		 goto lname1116_327;
	      }
	   }
	 else
	   {
	      ((bool_t) 1);
	   }
      }
   }
   putprop__88___r4_symbols_6_4(CNST_TABLE_REF(((long) 0)), __key__82_module_library, BTRUE);
   putprop__88___r4_symbols_6_4(__module__166_module_module, __key__82_module_library, BTRUE);
   {
      obj_t arg1205_582;
      arg1205_582 = proc1290_module_library;
      for_each_global__88_ast_env(arg1205_582);
   }
   {
      obj_t modules_342;
      modules_342 = __needed_modules__74_module_library;
      if (NULLP(modules_342))
	{
	   return BNIL;
	}
      else
	{
	   obj_t modules_344;
	   obj_t init_call__93_345;
	   modules_344 = modules_342;
	   init_call__93_345 = CNST_TABLE_REF(((long) 4));
	 loop_346:
	   if (NULLP(modules_344))
	     {
		obj_t arg1219_349;
		arg1219_349 = CNST_TABLE_REF(((long) 1));
		{
		   obj_t new_552;
		   {
		      obj_t aux_636;
		      aux_636 = CNST_TABLE_REF(((long) 2));
		      new_552 = create_struct(aux_636, ((long) 4));
		   }
		   STRUCT_SET(new_552, ((long) 3), BTRUE);
		   STRUCT_SET(new_552, ((long) 2), init_call__93_345);
		   {
		      obj_t aux_641;
		      aux_641 = BINT(((long) 2));
		      STRUCT_SET(new_552, ((long) 1), aux_641);
		   }
		   STRUCT_SET(new_552, ((long) 0), arg1219_349);
		   return new_552;
		}
	     }
	   else
	     {
		obj_t id_351;
		id_351 = CAR(modules_344);
		{
		   obj_t init_fun_id_230_352;
		   init_fun_id_230_352 = module_initialization_id_110_module_module(id_351);
		   {
		      {
			 obj_t arg1225_353;
			 obj_t arg1227_354;
			 arg1225_353 = CDR(modules_344);
			 {
			    obj_t arg1229_355;
			    {
			       obj_t arg1230_356;
			       obj_t arg1233_358;
			       {
				  obj_t arg1240_364;
				  arg1240_364 = CNST_TABLE_REF(((long) 3));
				  {
				     obj_t list1242_366;
				     {
					obj_t arg1245_367;
					{
					   obj_t arg1246_368;
					   arg1246_368 = MAKE_PAIR(BNIL, BNIL);
					   arg1245_367 = MAKE_PAIR(id_351, arg1246_368);
					}
					list1242_366 = MAKE_PAIR(init_fun_id_230_352, arg1245_367);
				     }
				     arg1230_356 = cons__138___r4_pairs_and_lists_6_3(arg1240_364, list1242_366);
				  }
			       }
			       {
				  obj_t symbol_577;
				  symbol_577 = __module__166_module_module;
				  arg1233_358 = SYMBOL_TO_STRING(symbol_577);
			       }
			       {
				  obj_t list1235_360;
				  {
				     obj_t arg1236_361;
				     {
					obj_t arg1237_362;
					arg1237_362 = MAKE_PAIR(BNIL, BNIL);
					arg1236_361 = MAKE_PAIR(arg1233_358, arg1237_362);
				     }
				     {
					obj_t aux_656;
					aux_656 = BINT(((long) 0));
					list1235_360 = MAKE_PAIR(aux_656, arg1236_361);
				     }
				  }
				  arg1229_355 = cons__138___r4_pairs_and_lists_6_3(arg1230_356, list1235_360);
			       }
			    }
			    arg1227_354 = MAKE_PAIR(arg1229_355, init_call__93_345);
			 }
			 {
			    obj_t init_call__93_662;
			    obj_t modules_661;
			    modules_661 = arg1225_353;
			    init_call__93_662 = arg1227_354;
			    init_call__93_345 = init_call__93_662;
			    modules_344 = modules_661;
			    goto loop_346;
			 }
		      }
		   }
		}
	     }
	}
   }
}


obj_t 
_library_finalizer_48_module_library(obj_t env_583)
{
   return library_finalizer_97_module_library();
}


obj_t 
arg12051289_module_library(obj_t env_584, obj_t global_585)
{
   {
      obj_t global_334;
      global_334 = global_585;
      {
	 bool_t test_665;
	 {
	    bool_t test_666;
	    {
	       long aux_667;
	       {
		  global_t obj_541;
		  obj_541 = (global_t) (global_334);
		  aux_667 = (((global_t) CREF(obj_541))->occurrence);
	       }
	       test_666 = (aux_667 > ((long) 0));
	    }
	    if (test_666)
	      {
		 global_t obj_544;
		 obj_544 = (global_t) (global_334);
		 test_665 = (((global_t) CREF(obj_544))->library__255);
	      }
	    else
	      {
		 test_665 = ((bool_t) 0);
	      }
	 }
	 if (test_665)
	   {
	      obj_t aux_673;
	      {
		 global_t obj_545;
		 obj_545 = (global_t) (global_334);
		 aux_673 = (((global_t) CREF(obj_545))->module);
	      }
	      return need_library_module__2_module_library(aux_673);
	   }
	 else
	   {
	      return BUNSPEC;
	   }
      }
   }
}


obj_t 
need_library_module__2_module_library(obj_t module_19)
{
   {
      bool_t test1248_370;
      {
	 obj_t aux_677;
	 aux_677 = getprop___r4_symbols_6_4(module_19, __key__82_module_library);
	 test1248_370 = CBOOL(aux_677);
      }
      if (test1248_370)
	{
	   return BUNSPEC;
	}
      else
	{
	   putprop__88___r4_symbols_6_4(module_19, __key__82_module_library, BTRUE);
	   {
	      obj_t obj2_581;
	      obj2_581 = __needed_modules__74_module_library;
	      return (__needed_modules__74_module_library = MAKE_PAIR(module_19, obj2_581),
		 BUNSPEC);
	   }
	}
   }
}


obj_t 
imported_modules_init_94_module_library()
{
   module_initialization_70_type_type(((long) 0), "MODULE_LIBRARY");
   module_initialization_70_ast_var(((long) 0), "MODULE_LIBRARY");
   module_initialization_70_ast_env(((long) 0), "MODULE_LIBRARY");
   module_initialization_70_module_module(((long) 0), "MODULE_LIBRARY");
   return module_initialization_70_module_impuse(((long) 0), "MODULE_LIBRARY");
}
