/*===========================================================================*/
/*   (Module/load.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


static obj_t arg11481274_module_load(obj_t);
static obj_t imported_modules_init_94_module_load();
extern obj_t make_load_compiler_92_module_load();
extern obj_t module_initialization_70_module_load(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_read_load(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t cnst_init_137_module_load();
extern obj_t ccomp_module_module;
static obj_t require_initialization_114_module_load = BUNSPEC;
static obj_t load_producer_246_module_load(obj_t);
static obj_t library_modules_init_112_module_load();
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t arg11451275_module_load(obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
static obj_t _load_producer_194_module_load(obj_t, obj_t);
extern obj_t load_module_134_read_load(obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t __access_table__91_engine_param;
static obj_t arg11491273_module_load(obj_t, obj_t, obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
static obj_t load_parser_100_module_load(obj_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t _make_load_compiler_34_module_load(obj_t);
static obj_t __cnst[2];

DEFINE_STRING(string1282_module_load, string1282_module_load1292, "load", 4);
DEFINE_STRING(string1281_module_load, string1281_module_load1293, "Illegal load clause", 19);
DEFINE_STRING(string1280_module_load, string1280_module_load1294, "Parse error", 11);
DEFINE_STRING(string1283_module_load, string1283_module_load1295, "Can't load module", 17);
DEFINE_STRING(string1279_module_load, string1279_module_load1296, "Illegal `load' clause", 21);
DEFINE_STATIC_PROCEDURE(load_producer_env_50_module_load, _load_producer_194_module_load1297, _load_producer_194_module_load, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_load_compiler_env_29_module_load, _make_load_compiler_34_module_load1298, _make_load_compiler_34_module_load, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1277_module_load, arg11481274_module_load1299, arg11481274_module_load, 0L, 0);
DEFINE_STRING(string1284_module_load, string1284_module_load1300, "VOID LOAD ", 10);
DEFINE_STATIC_PROCEDURE(proc1278_module_load, arg11451275_module_load1301, arg11451275_module_load, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1276_module_load, arg11491273_module_load1302, arg11491273_module_load, 0L, 2);

obj_t 
module_initialization_70_module_load(long checksum_561, char *from_562)
{
   if (CBOOL(require_initialization_114_module_load))
     {
	require_initialization_114_module_load = BBOOL(((bool_t) 0));
	library_modules_init_112_module_load();
	cnst_init_137_module_load();
	imported_modules_init_94_module_load();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_module_load()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_LOAD");
   module_initialization_70___reader(((long) 0), "MODULE_LOAD");
   module_initialization_70___object(((long) 0), "MODULE_LOAD");
   module_initialization_70___r4_strings_6_7(((long) 0), "MODULE_LOAD");
   return BUNSPEC;
}


obj_t 
cnst_init_137_module_load()
{
   {
      obj_t cnst_port_138_553;
      cnst_port_138_553 = open_input_string(string1284_module_load);
      {
	 long i_554;
	 i_554 = ((long) 1);
       loop_555:
	 {
	    bool_t test1285_556;
	    test1285_556 = (i_554 == ((long) -1));
	    if (test1285_556)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1286_557;
		    {
		       obj_t list1287_558;
		       {
			  obj_t arg1290_559;
			  arg1290_559 = BNIL;
			  list1287_558 = MAKE_PAIR(cnst_port_138_553, arg1290_559);
		       }
		       arg1286_557 = read___reader(list1287_558);
		    }
		    CNST_TABLE_SET(i_554, arg1286_557);
		 }
		 {
		    int aux_560;
		    {
		       long aux_579;
		       aux_579 = (i_554 - ((long) 1));
		       aux_560 = (int) (aux_579);
		    }
		    {
		       long i_582;
		       i_582 = (long) (aux_560);
		       i_554 = i_582;
		       goto loop_555;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
make_load_compiler_92_module_load()
{
   {
      obj_t arg1144_293;
      arg1144_293 = CNST_TABLE_REF(((long) 0));
      {
	 obj_t arg1149_540;
	 obj_t arg1148_541;
	 obj_t arg1145_542;
	 arg1149_540 = proc1276_module_load;
	 arg1148_541 = proc1277_module_load;
	 arg1145_542 = proc1278_module_load;
	 {
	    ccomp_t res1272_506;
	    {
	       ccomp_t new1004_497;
	       new1004_497 = ((ccomp_t) BREF(GC_MALLOC(sizeof(struct ccomp))));
	       {
		  long arg1271_498;
		  arg1271_498 = class_num_218___object(ccomp_module_module);
		  {
		     obj_t obj_504;
		     obj_504 = (obj_t) (new1004_497);
		     (((obj_t) CREF(obj_504))->header = MAKE_HEADER(arg1271_498, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_589;
		  aux_589 = (object_t) (new1004_497);
		  OBJECT_WIDENING_SET(aux_589, BFALSE);
	       }
	       ((((ccomp_t) CREF(new1004_497))->id) = ((obj_t) arg1144_293), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_497))->producer) = ((obj_t) load_producer_env_50_module_load), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_497))->consumer) = ((obj_t) arg1145_542), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_497))->finalizer) = ((obj_t) arg1148_541), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_497))->checksummer) = ((obj_t) arg1149_540), BUNSPEC);
	       res1272_506 = new1004_497;
	    }
	    return (obj_t) (res1272_506);
	 }
      }
   }
}


obj_t 
_make_load_compiler_34_module_load(obj_t env_543)
{
   return make_load_compiler_92_module_load();
}


obj_t 
arg11491273_module_load(obj_t env_544, obj_t m_545, obj_t c_546)
{
   {
      obj_t m_301;
      obj_t c_302;
      m_301 = m_545;
      c_302 = c_546;
      return c_302;
   }
}


obj_t 
arg11481274_module_load(obj_t env_547)
{
   {
      return CNST_TABLE_REF(((long) 1));
   }
}


obj_t 
arg11451275_module_load(obj_t env_548, obj_t m_549, obj_t c_550)
{
   {
      obj_t m_297;
      obj_t c_298;
      m_297 = m_549;
      c_298 = c_550;
      return BNIL;
   }
}


obj_t 
load_producer_246_module_load(obj_t clause_1)
{
   {
      obj_t protos_307;
      if (PAIRP(clause_1))
	{
	   bool_t aux_602;
	   protos_307 = CDR(clause_1);
	   {
	      obj_t l1114_313;
	      l1114_313 = protos_307;
	    lname1116_314:
	      if (PAIRP(l1114_313))
		{
		   load_parser_100_module_load(CAR(l1114_313), clause_1);
		   {
		      obj_t l1114_607;
		      l1114_607 = CDR(l1114_313);
		      l1114_313 = l1114_607;
		      goto lname1116_314;
		   }
		}
	      else
		{
		   aux_602 = ((bool_t) 1);
		}
	   }
	   return BBOOL(aux_602);
	}
      else
	{
	   {
	      obj_t arg1181_319;
	      {
		 obj_t list1196_323;
		 list1196_323 = MAKE_PAIR(string1279_module_load, BNIL);
		 arg1181_319 = string_append_106___r4_strings_6_7(list1196_323);
	      }
	      {
		 obj_t list1183_321;
		 list1183_321 = MAKE_PAIR(BNIL, BNIL);
		 return user_error_151_tools_error(string1280_module_load, arg1181_319, clause_1, list1183_321);
	      }
	   }
	}
   }
}


obj_t 
_load_producer_194_module_load(obj_t env_551, obj_t clause_552)
{
   return load_producer_246_module_load(clause_552);
}


obj_t 
load_parser_100_module_load(obj_t proto_2, obj_t clause_3)
{
   {
      obj_t module_326;
      obj_t file_327;
      obj_t files_328;
      if (PAIRP(proto_2))
	{
	   obj_t car_119_235_334;
	   obj_t cdr_120_34_335;
	   car_119_235_334 = CAR(proto_2);
	   cdr_120_34_335 = CDR(proto_2);
	   if (SYMBOLP(car_119_235_334))
	     {
		if (PAIRP(cdr_120_34_335))
		  {
		     obj_t car_125_199_338;
		     car_125_199_338 = CAR(cdr_120_34_335);
		     if (STRINGP(car_125_199_338))
		       {
			  module_326 = car_119_235_334;
			  file_327 = car_125_199_338;
			  files_328 = CDR(cdr_120_34_335);
			  {
			     obj_t f_345;
			     f_345 = files_328;
			   loop_346:
			     if (NULLP(f_345))
			       {
				  {
				     obj_t arg1210_348;
				     arg1210_348 = MAKE_PAIR(file_327, files_328);
				     return load_module_134_read_load(module_326, arg1210_348);
				  }
			       }
			     else
			       {
				  bool_t test_631;
				  {
				     obj_t aux_632;
				     aux_632 = CAR(f_345);
				     test_631 = STRINGP(aux_632);
				  }
				  if (test_631)
				    {
				       {
					  obj_t f_635;
					  f_635 = CDR(f_345);
					  f_345 = f_635;
					  goto loop_346;
				       }
				    }
				  else
				    {
				       {
					  obj_t list1218_354;
					  list1218_354 = MAKE_PAIR(BNIL, BNIL);
					  return user_error_151_tools_error(string1280_module_load, string1281_module_load, clause_3, list1218_354);
				       }
				    }
			       }
			  }
		       }
		     else
		       {
			  if (SYMBOLP(proto_2))
			    {
			     tag_110_179_330:
			       {
				  obj_t b_357;
				  b_357 = assq___r4_pairs_and_lists_6_3(proto_2, __access_table__91_engine_param);
				  if (CBOOL(b_357))
				    {
				       return load_module_134_read_load(proto_2, CDR(b_357));
				    }
				  else
				    {
				       return user_error_151_tools_error(string1282_module_load, string1283_module_load, proto_2, BNIL);
				    }
			       }
			    }
			  else
			    {
			     tag_111_62_331:
			       {
				  obj_t list1231_363;
				  list1231_363 = MAKE_PAIR(BNIL, BNIL);
				  return user_error_151_tools_error(string1280_module_load, string1281_module_load, clause_3, list1231_363);
			       }
			    }
		       }
		  }
		else
		  {
		     if (SYMBOLP(proto_2))
		       {
			  goto tag_110_179_330;
		       }
		     else
		       {
			  goto tag_111_62_331;
		       }
		  }
	     }
	   else
	     {
		if (SYMBOLP(proto_2))
		  {
		     goto tag_110_179_330;
		  }
		else
		  {
		     goto tag_111_62_331;
		  }
	     }
	}
      else
	{
	   if (SYMBOLP(proto_2))
	     {
		goto tag_110_179_330;
	     }
	   else
	     {
		goto tag_111_62_331;
	     }
	}
   }
}


obj_t 
imported_modules_init_94_module_load()
{
   module_initialization_70_module_module(((long) 0), "MODULE_LOAD");
   module_initialization_70_engine_param(((long) 0), "MODULE_LOAD");
   module_initialization_70_tools_error(((long) 0), "MODULE_LOAD");
   module_initialization_70_type_type(((long) 0), "MODULE_LOAD");
   module_initialization_70_ast_var(((long) 0), "MODULE_LOAD");
   module_initialization_70_ast_env(((long) 0), "MODULE_LOAD");
   module_initialization_70_type_env(((long) 0), "MODULE_LOAD");
   module_initialization_70_tools_speek(((long) 0), "MODULE_LOAD");
   return module_initialization_70_read_load(((long) 0), "MODULE_LOAD");
}
