/*===========================================================================*/
/*   (Module/main.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


extern obj_t __pair__244_type_cache;
static obj_t duplicate_main_error_106_module_main(obj_t);
extern obj_t global_ast_var;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_module_main();
static bool_t correct_main__10_module_main(global_t);
extern obj_t module_initialization_70_module_main(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t cnst_init_137_module_main();
extern obj_t ccomp_module_module;
extern obj_t make_main_compiler_2_module_main();
static obj_t main_consumer_241_module_main(obj_t, obj_t);
extern obj_t __module__166_module_module;
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t require_initialization_114_module_main = BUNSPEC;
extern obj_t _make_main_compiler_110_module_main(obj_t);
static obj_t library_modules_init_112_module_main();
extern obj_t sfun_ast_var;
extern obj_t __main__152_module_module;
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
static obj_t arg11451279_module_main(obj_t);
static obj_t main_producer_37_module_main(obj_t);
extern long class_num_218___object(obj_t);
static obj_t _main_producer_176_module_main(obj_t, obj_t);
extern obj_t produce_module_clause__172_module_module(obj_t);
static obj_t _main_consumer_88_module_main(obj_t, obj_t, obj_t);
extern obj_t __obj__252_type_cache;
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t arg11481278_module_main(obj_t, obj_t, obj_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
static obj_t __cnst[5];

DEFINE_STATIC_PROCEDURE(main_producer_env_121_module_main, _main_producer_176_module_main1295, _main_producer_176_module_main, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1280_module_main, arg11481278_module_main1296, arg11481278_module_main, 0L, 2);
DEFINE_STRING(string1282_module_main, string1282_module_main1297, "Illegal declaration of main function", 36);
DEFINE_STRING(string1286_module_main, string1286_module_main1298, "ARGV::PAIR EXPORT IMPORTED VOID MAIN ", 37);
DEFINE_STRING(string1285_module_main, string1285_module_main1299, "Duplicated main clause", 22);
DEFINE_STATIC_PROCEDURE(main_consumer_env_180_module_main, _main_consumer_88_module_main1300, _main_consumer_88_module_main, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1281_module_main, arg11451279_module_main1301, arg11451279_module_main, 0L, 0);
DEFINE_STRING(string1283_module_main, string1283_module_main1302, "Parse error", 11);
DEFINE_EXPORT_PROCEDURE(make_main_compiler_env_146_module_main, _make_main_compiler_110_module_main1303, _make_main_compiler_110_module_main, 0L, 0);
DEFINE_STRING(string1284_module_main, string1284_module_main1304, "Illegal main clause", 19);

obj_t 
module_initialization_70_module_main(long checksum_559, char *from_560)
{
   if (CBOOL(require_initialization_114_module_main))
     {
	require_initialization_114_module_main = BBOOL(((bool_t) 0));
	library_modules_init_112_module_main();
	cnst_init_137_module_main();
	imported_modules_init_94_module_main();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_module_main()
{
   module_initialization_70___object(((long) 0), "MODULE_MAIN");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_MAIN");
   module_initialization_70___reader(((long) 0), "MODULE_MAIN");
   return BUNSPEC;
}


obj_t 
cnst_init_137_module_main()
{
   {
      obj_t cnst_port_138_551;
      cnst_port_138_551 = open_input_string(string1286_module_main);
      {
	 long i_552;
	 i_552 = ((long) 4);
       loop_553:
	 {
	    bool_t test1287_554;
	    test1287_554 = (i_552 == ((long) -1));
	    if (test1287_554)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1290_555;
		    {
		       obj_t list1291_556;
		       {
			  obj_t arg1293_557;
			  arg1293_557 = BNIL;
			  list1291_556 = MAKE_PAIR(cnst_port_138_551, arg1293_557);
		       }
		       arg1290_555 = read___reader(list1291_556);
		    }
		    CNST_TABLE_SET(i_552, arg1290_555);
		 }
		 {
		    int aux_558;
		    {
		       long aux_576;
		       aux_576 = (i_552 - ((long) 1));
		       aux_558 = (int) (aux_576);
		    }
		    {
		       long i_579;
		       i_579 = (long) (aux_558);
		       i_552 = i_579;
		       goto loop_553;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
make_main_compiler_2_module_main()
{
   {
      obj_t arg1144_295;
      arg1144_295 = CNST_TABLE_REF(((long) 0));
      {
	 obj_t arg1148_539;
	 obj_t arg1145_540;
	 arg1148_539 = proc1280_module_main;
	 arg1145_540 = proc1281_module_main;
	 {
	    ccomp_t res1277_503;
	    {
	       ccomp_t new1004_494;
	       new1004_494 = ((ccomp_t) BREF(GC_MALLOC(sizeof(struct ccomp))));
	       {
		  long arg1276_495;
		  arg1276_495 = class_num_218___object(ccomp_module_module);
		  {
		     obj_t obj_501;
		     obj_501 = (obj_t) (new1004_494);
		     (((obj_t) CREF(obj_501))->header = MAKE_HEADER(arg1276_495, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_586;
		  aux_586 = (object_t) (new1004_494);
		  OBJECT_WIDENING_SET(aux_586, BFALSE);
	       }
	       ((((ccomp_t) CREF(new1004_494))->id) = ((obj_t) arg1144_295), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_494))->producer) = ((obj_t) main_producer_env_121_module_main), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_494))->consumer) = ((obj_t) main_consumer_env_180_module_main), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_494))->finalizer) = ((obj_t) arg1145_540), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_494))->checksummer) = ((obj_t) arg1148_539), BUNSPEC);
	       res1277_503 = new1004_494;
	    }
	    return (obj_t) (res1277_503);
	 }
      }
   }
}


obj_t 
_make_main_compiler_110_module_main(obj_t env_541)
{
   return make_main_compiler_2_module_main();
}


obj_t 
arg11481278_module_main(obj_t env_542, obj_t m_543, obj_t c_544)
{
   {
      obj_t m_299;
      obj_t c_300;
      m_299 = m_543;
      c_300 = c_544;
      return c_300;
   }
}


obj_t 
arg11451279_module_main(obj_t env_545)
{
   {
      return CNST_TABLE_REF(((long) 1));
   }
}


bool_t 
correct_main__10_module_main(global_t global_1)
{
   {
      value_t sfun_304;
      sfun_304 = (((global_t) CREF(global_1))->value);
      {
	 bool_t _andtest_1114_305;
	 _andtest_1114_305 = is_a__118___object((obj_t) (sfun_304), sfun_ast_var);
	 if (_andtest_1114_305)
	   {
	      bool_t test_601;
	      {
		 long aux_602;
		 {
		    sfun_t obj_506;
		    obj_506 = (sfun_t) (sfun_304);
		    aux_602 = (((sfun_t) CREF(obj_506))->arity);
		 }
		 test_601 = (aux_602 == ((long) 1));
	      }
	      if (test_601)
		{
		   type_t type_308;
		   {
		      local_t obj_511;
		      {
			 obj_t aux_606;
			 {
			    obj_t aux_607;
			    {
			       sfun_t obj_509;
			       obj_509 = (sfun_t) (sfun_304);
			       aux_607 = (((sfun_t) CREF(obj_509))->args);
			    }
			    aux_606 = CAR(aux_607);
			 }
			 obj_511 = (local_t) (aux_606);
		      }
		      type_308 = (((local_t) CREF(obj_511))->type);
		   }
		   {
		      {
			 bool_t _ortest_1116_309;
			 {
			    obj_t obj2_513;
			    obj2_513 = __obj__252_type_cache;
			    {
			       obj_t aux_613;
			       aux_613 = (obj_t) (type_308);
			       _ortest_1116_309 = (aux_613 == obj2_513);
			    }
			 }
			 if (_ortest_1116_309)
			   {
			      return _ortest_1116_309;
			   }
			 else
			   {
			      obj_t obj2_515;
			      obj2_515 = __pair__244_type_cache;
			      {
				 obj_t aux_617;
				 aux_617 = (obj_t) (type_308);
				 return (aux_617 == obj2_515);
			      }
			   }
		      }
		   }
		}
	      else
		{
		   return ((bool_t) 0);
		}
	   }
	 else
	   {
	      return ((bool_t) 0);
	   }
      }
   }
}


obj_t 
main_producer_37_module_main(obj_t clause_2)
{
   {
      bool_t test1162_313;
      {
	 bool_t test1230_354;
	 {
	    obj_t obj1_516;
	    obj1_516 = __main__152_module_module;
	    {
	       obj_t aux_620;
	       aux_620 = CNST_TABLE_REF(((long) 2));
	       test1230_354 = (obj1_516 == aux_620);
	    }
	 }
	 if (test1230_354)
	   {
	      test1162_313 = ((bool_t) 1);
	   }
	 else
	   {
	      obj_t obj_518;
	      obj_518 = __main__152_module_module;
	      test1162_313 = is_a__118___object(obj_518, global_ast_var);
	   }
      }
      if (test1162_313)
	{
	   return duplicate_main_error_106_module_main(clause_2);
	}
      else
	{
	   obj_t main_109_314;
	   if (PAIRP(clause_2))
	     {
		obj_t cdr_107_0_319;
		cdr_107_0_319 = CDR(clause_2);
		if (PAIRP(cdr_107_0_319))
		  {
		     obj_t car_109_44_321;
		     car_109_44_321 = CAR(cdr_107_0_319);
		     if (SYMBOLP(car_109_44_321))
		       {
			  bool_t test_635;
			  {
			     obj_t aux_636;
			     aux_636 = CDR(cdr_107_0_319);
			     test_635 = (aux_636 == BNIL);
			  }
			  if (test_635)
			    {
			       main_109_314 = car_109_44_321;
			       {
				  obj_t global_326;
				  {
				     obj_t list1218_347;
				     list1218_347 = MAKE_PAIR(__module__166_module_module, BNIL);
				     global_326 = find_global_223_ast_env(main_109_314, list1218_347);
				  }
				  {
				     bool_t test1183_327;
				     test1183_327 = is_a__118___object(global_326, global_ast_var);
				     if (test1183_327)
				       {
					  if (correct_main__10_module_main((global_t) (global_326)))
					    {
					       return BUNSPEC;
					    }
					  else
					    {
					       obj_t list1198_331;
					       list1198_331 = MAKE_PAIR(BNIL, BNIL);
					       return user_error_151_tools_error(__module__166_module_module, string1282_module_main, main_109_314, list1198_331);
					    }
				       }
				     else
				       {
					  {
					     obj_t arg1200_333;
					     {
						obj_t arg1203_334;
						obj_t arg1204_335;
						arg1203_334 = CNST_TABLE_REF(((long) 3));
						{
						   obj_t arg1209_340;
						   arg1209_340 = CNST_TABLE_REF(((long) 4));
						   {
						      obj_t list1211_342;
						      {
							 obj_t arg1212_343;
							 arg1212_343 = MAKE_PAIR(BNIL, BNIL);
							 list1211_342 = MAKE_PAIR(arg1209_340, arg1212_343);
						      }
						      arg1204_335 = cons__138___r4_pairs_and_lists_6_3(main_109_314, list1211_342);
						   }
						}
						{
						   obj_t list1206_337;
						   {
						      obj_t arg1207_338;
						      arg1207_338 = MAKE_PAIR(BNIL, BNIL);
						      list1206_337 = MAKE_PAIR(arg1204_335, arg1207_338);
						   }
						   arg1200_333 = cons__138___r4_pairs_and_lists_6_3(arg1203_334, list1206_337);
						}
					     }
					     produce_module_clause__172_module_module(arg1200_333);
					  }
					  {
					     obj_t list1214_345;
					     list1214_345 = MAKE_PAIR(__module__166_module_module, BNIL);
					     return (__main__152_module_module = find_global_223_ast_env(main_109_314, list1214_345),
						BUNSPEC);
					  }
				       }
				  }
			       }
			    }
			  else
			    {
			     tag_102_241_316:
			       {
				  obj_t list1228_352;
				  list1228_352 = MAKE_PAIR(BNIL, BNIL);
				  return user_error_151_tools_error(string1283_module_main, string1284_module_main, clause_2, list1228_352);
			       }
			    }
		       }
		     else
		       {
			  goto tag_102_241_316;
		       }
		  }
		else
		  {
		     goto tag_102_241_316;
		  }
	     }
	   else
	     {
		goto tag_102_241_316;
	     }
	}
   }
}


obj_t 
_main_producer_176_module_main(obj_t env_546, obj_t clause_547)
{
   return main_producer_37_module_main(clause_547);
}


obj_t 
main_consumer_241_module_main(obj_t module_3, obj_t clause_4)
{
   {
      bool_t test1232_528;
      {
	 obj_t obj_529;
	 obj_529 = __main__152_module_module;
	 test1232_528 = is_a__118___object(obj_529, global_ast_var);
      }
      if (test1232_528)
	{
	   duplicate_main_error_106_module_main(clause_4);
	}
      else
	{
	   __main__152_module_module = CNST_TABLE_REF(((long) 2));
	}
   }
   return BNIL;
}


obj_t 
_main_consumer_88_module_main(obj_t env_548, obj_t module_549, obj_t clause_550)
{
   return main_consumer_241_module_main(module_549, clause_550);
}


obj_t 
duplicate_main_error_106_module_main(obj_t clause_5)
{
   {
      obj_t list1236_360;
      list1236_360 = MAKE_PAIR(BNIL, BNIL);
      return user_error_151_tools_error(string1283_module_main, string1285_module_main, clause_5, list1236_360);
   }
}


obj_t 
imported_modules_init_94_module_main()
{
   module_initialization_70_module_module(((long) 0), "MODULE_MAIN");
   module_initialization_70_tools_error(((long) 0), "MODULE_MAIN");
   module_initialization_70_type_type(((long) 0), "MODULE_MAIN");
   module_initialization_70_type_cache(((long) 0), "MODULE_MAIN");
   module_initialization_70_ast_var(((long) 0), "MODULE_MAIN");
   return module_initialization_70_ast_env(((long) 0), "MODULE_MAIN");
}
