/*===========================================================================*/
/*   (Module/pragma.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


extern obj_t _make_pragma_compiler_94_module_pragma(obj_t);
extern obj_t global_ast_var;
extern obj_t fun_ast_var;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_module_pragma();
extern obj_t module_initialization_70_module_pragma(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t toplevel_init_63_module_pragma();
static obj_t cnst_init_137_module_pragma();
extern obj_t ccomp_module_module;
extern obj_t remove_var_from__148_ast_remove(obj_t, variable_t);
extern obj_t __module__166_module_module;
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t set_pragma_property__180_module_pragma(obj_t, obj_t, obj_t);
static obj_t require_initialization_114_module_pragma = BUNSPEC;
extern obj_t make_pragma_compiler_150_module_pragma();
static obj_t library_modules_init_112_module_pragma();
extern obj_t sfun_ast_var;
extern obj_t pragma_finalizer_170_module_pragma();
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
static obj_t pragma_parser_198_module_pragma(obj_t, obj_t, obj_t);
extern obj_t warning___error(obj_t);
extern long class_num_218___object(obj_t);
static obj_t arg11491424_module_pragma(obj_t, obj_t, obj_t);
static obj_t pragma_producer_255_module_pragma(obj_t);
static obj_t __pragma_list__157_module_pragma = BUNSPEC;
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
static bool_t set_pragma_properties__114_module_pragma(obj_t, obj_t, obj_t);
extern obj_t __optim_stack___57_engine_param;
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern type_t use_type__231_type_env(obj_t);
extern obj_t _pragma_finalizer_19_module_pragma(obj_t);
static obj_t lambda11531426_module_pragma(obj_t, obj_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
static obj_t arg11481425_module_pragma(obj_t, obj_t, obj_t);
static obj_t __cnst[11];

DEFINE_STRING(string1440_module_pragma, string1440_module_pragma1448, "Can't find stack allocator", 26);
DEFINE_STRING(string1432_module_pragma, string1432_module_pragma1449, "pragma-finalizer", 16);
DEFINE_STRING(string1438_module_pragma, string1438_module_pragma1450, "predicate is not associated to a function", 41);
DEFINE_STRING(string1433_module_pragma, string1433_module_pragma1451, "Illegal `pragma' finalizer form", 31);
DEFINE_STRING(string1437_module_pragma, string1437_module_pragma1452, "Illegal `pragma' form", 21);
DEFINE_EXPORT_PROCEDURE(make_pragma_compiler_env_9_module_pragma, _make_pragma_compiler_94_module_pragma1453, _make_pragma_compiler_94_module_pragma, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1427_module_pragma, arg11491424_module_pragma1454, arg11491424_module_pragma, 0L, 2);
DEFINE_STRING(string1431_module_pragma, string1431_module_pragma1455, "Can't find global variable -- ", 30);
DEFINE_STRING(string1430_module_pragma, string1430_module_pragma1456, "Parse error", 11);
DEFINE_STATIC_PROCEDURE(proc1428_module_pragma, arg11481425_module_pragma1457, arg11481425_module_pragma, 0L, 2);
DEFINE_STRING(string1441_module_pragma, string1441_module_pragma1458, "CFA STACK-ALLOC COERCE PREDICATE-OF NO-TRACE NO-CFA-TOP SIDE-EFFECT-FREE VOID @ FOREIGN PRAGMA ", 95);
DEFINE_STRING(string1436_module_pragma, string1436_module_pragma1459, "property is not concerning a sfunction", 38);
DEFINE_STRING(string1435_module_pragma, string1435_module_pragma1460, "property is not concerning a function", 37);
DEFINE_STRING(string1429_module_pragma, string1429_module_pragma1461, "Illegal `pragma' clause", 23);
DEFINE_STRING(string1434_module_pragma, string1434_module_pragma1462, "pragma", 6);
DEFINE_EXPORT_PROCEDURE(pragma_finalizer_env_89_module_pragma, _pragma_finalizer_19_module_pragma1463, _pragma_finalizer_19_module_pragma, 0L, 0);
DEFINE_STRING(string1439_module_pragma, string1439_module_pragma1464, "alloctor is not a function", 26);

obj_t 
module_initialization_70_module_pragma(long checksum_775, char *from_776)
{
   if (CBOOL(require_initialization_114_module_pragma))
     {
	require_initialization_114_module_pragma = BBOOL(((bool_t) 0));
	library_modules_init_112_module_pragma();
	cnst_init_137_module_pragma();
	imported_modules_init_94_module_pragma();
	toplevel_init_63_module_pragma();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_module_pragma()
{
   module_initialization_70___object(((long) 0), "MODULE_PRAGMA");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_PRAGMA");
   module_initialization_70___reader(((long) 0), "MODULE_PRAGMA");
   module_initialization_70___error(((long) 0), "MODULE_PRAGMA");
   module_initialization_70___r4_strings_6_7(((long) 0), "MODULE_PRAGMA");
   return BUNSPEC;
}


obj_t 
cnst_init_137_module_pragma()
{
   {
      obj_t cnst_port_138_767;
      cnst_port_138_767 = open_input_string(string1441_module_pragma);
      {
	 long i_768;
	 i_768 = ((long) 10);
       loop_769:
	 {
	    bool_t test1442_770;
	    test1442_770 = (i_768 == ((long) -1));
	    if (test1442_770)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1444_771;
		    {
		       obj_t list1445_772;
		       {
			  obj_t arg1446_773;
			  arg1446_773 = BNIL;
			  list1445_772 = MAKE_PAIR(cnst_port_138_767, arg1446_773);
		       }
		       arg1444_771 = read___reader(list1445_772);
		    }
		    CNST_TABLE_SET(i_768, arg1444_771);
		 }
		 {
		    int aux_774;
		    {
		       long aux_795;
		       aux_795 = (i_768 - ((long) 1));
		       aux_774 = (int) (aux_795);
		    }
		    {
		       long i_798;
		       i_798 = (long) (aux_774);
		       i_768 = i_798;
		       goto loop_769;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_module_pragma()
{
   return (__pragma_list__157_module_pragma = BNIL,
      BUNSPEC);
}


obj_t 
make_pragma_compiler_150_module_pragma()
{
   {
      obj_t arg1144_300;
      obj_t arg1145_301;
      arg1144_300 = CNST_TABLE_REF(((long) 0));
      arg1145_301 = pragma_producer_255_module_pragma(__module__166_module_module);
      {
	 obj_t arg1149_747;
	 obj_t arg1148_748;
	 arg1149_747 = proc1427_module_pragma;
	 arg1148_748 = proc1428_module_pragma;
	 {
	    ccomp_t res1417_646;
	    {
	       ccomp_t new1004_637;
	       new1004_637 = ((ccomp_t) BREF(GC_MALLOC(sizeof(struct ccomp))));
	       {
		  long arg1416_638;
		  arg1416_638 = class_num_218___object(ccomp_module_module);
		  {
		     obj_t obj_644;
		     obj_644 = (obj_t) (new1004_637);
		     (((obj_t) CREF(obj_644))->header = MAKE_HEADER(arg1416_638, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_806;
		  aux_806 = (object_t) (new1004_637);
		  OBJECT_WIDENING_SET(aux_806, BFALSE);
	       }
	       ((((ccomp_t) CREF(new1004_637))->id) = ((obj_t) arg1144_300), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_637))->producer) = ((obj_t) arg1145_301), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_637))->consumer) = ((obj_t) arg1148_748), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_637))->finalizer) = ((obj_t) pragma_finalizer_env_89_module_pragma), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_637))->checksummer) = ((obj_t) arg1149_747), BUNSPEC);
	       res1417_646 = new1004_637;
	    }
	    return (obj_t) (res1417_646);
	 }
      }
   }
}


obj_t 
_make_pragma_compiler_94_module_pragma(obj_t env_749)
{
   return make_pragma_compiler_150_module_pragma();
}


obj_t 
arg11491424_module_pragma(obj_t env_750, obj_t m_751, obj_t c_752)
{
   {
      obj_t m_308;
      obj_t c_309;
      m_308 = m_751;
      c_309 = c_752;
      return c_309;
   }
}


obj_t 
arg11481425_module_pragma(obj_t env_753, obj_t m_754, obj_t c_755)
{
   {
      obj_t m_304;
      obj_t c_305;
      m_304 = m_754;
      c_305 = c_755;
      {
	 obj_t fun1151_647;
	 fun1151_647 = pragma_producer_255_module_pragma(m_304);
	 return PROCEDURE_ENTRY(fun1151_647) (fun1151_647, c_305, BEOA);
      }
   }
}


obj_t 
pragma_producer_255_module_pragma(obj_t module_1)
{
   {
      obj_t lambda1153_757;
      lambda1153_757 = make_fx_procedure(lambda11531426_module_pragma, ((long) 1), ((long) 1));
      PROCEDURE_SET(lambda1153_757, ((long) 0), module_1);
      return lambda1153_757;
   }
}


obj_t 
lambda11531426_module_pragma(obj_t env_758, obj_t clause_760)
{
   {
      obj_t module_759;
      module_759 = PROCEDURE_REF(env_758, ((long) 0));
      {
	 obj_t clause_313;
	 clause_313 = clause_760;
	 {
	    obj_t protos_315;
	    if (PAIRP(clause_313))
	      {
		 protos_315 = CDR(clause_313);
		 {
		    obj_t l1114_321;
		    l1114_321 = protos_315;
		  lname1116_322:
		    if (PAIRP(l1114_321))
		      {
			 pragma_parser_198_module_pragma(CAR(l1114_321), module_759, clause_313);
			 {
			    obj_t l1114_828;
			    l1114_828 = CDR(l1114_321);
			    l1114_321 = l1114_828;
			    goto lname1116_322;
			 }
		      }
		    else
		      {
			 ((bool_t) 1);
		      }
		 }
		 return BNIL;
	      }
	    else
	      {
		 {
		    obj_t arg1181_327;
		    {
		       obj_t list1196_331;
		       list1196_331 = MAKE_PAIR(string1429_module_pragma, BNIL);
		       arg1181_327 = string_append_106___r4_strings_6_7(list1196_331);
		    }
		    {
		       obj_t list1183_329;
		       list1183_329 = MAKE_PAIR(BNIL, BNIL);
		       return user_error_151_tools_error(string1430_module_pragma, arg1181_327, clause_313, list1183_329);
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
pragma_parser_198_module_pragma(obj_t proto_2, obj_t module_3, obj_t clause_4)
{
   {
      obj_t id_334;
      obj_t prop_335;
      if (PAIRP(proto_2))
	{
	   obj_t car_116_203_340;
	   car_116_203_340 = CAR(proto_2);
	   if (SYMBOLP(car_116_203_340))
	     {
		id_334 = car_116_203_340;
		prop_335 = CDR(proto_2);
		{
		   obj_t arg1204_343;
		   {
		      obj_t list1205_344;
		      {
			 obj_t arg1207_345;
			 {
			    obj_t arg1208_346;
			    {
			       obj_t arg1209_347;
			       arg1209_347 = MAKE_PAIR(clause_4, BNIL);
			       arg1208_346 = MAKE_PAIR(prop_335, arg1209_347);
			    }
			    arg1207_345 = MAKE_PAIR(module_3, arg1208_346);
			 }
			 list1205_344 = MAKE_PAIR(id_334, arg1207_345);
		      }
		      arg1204_343 = list1205_344;
		   }
		   {
		      obj_t obj2_659;
		      obj2_659 = __pragma_list__157_module_pragma;
		      return (__pragma_list__157_module_pragma = MAKE_PAIR(arg1204_343, obj2_659),
			 BUNSPEC);
		   }
		}
	     }
	   else
	     {
	      tag_110_179_337:
		{
		   obj_t list1215_352;
		   list1215_352 = MAKE_PAIR(BNIL, BNIL);
		   return user_error_151_tools_error(string1430_module_pragma, string1429_module_pragma, clause_4, list1215_352);
		}
	     }
	}
      else
	{
	   goto tag_110_179_337;
	}
   }
}


obj_t 
pragma_finalizer_170_module_pragma()
{
   {
      obj_t l1117_354;
      l1117_354 = __pragma_list__157_module_pragma;
    lname1118_355:
      if (PAIRP(l1117_354))
	{
	   {
	      obj_t pragma_357;
	      pragma_357 = CAR(l1117_354);
	      {
		 obj_t id_358;
		 obj_t module_359;
		 obj_t prop__131_360;
		 obj_t clause_361;
		 if (PAIRP(pragma_357))
		   {
		      obj_t cdr_133_55_366;
		      cdr_133_55_366 = CDR(pragma_357);
		      if (PAIRP(cdr_133_55_366))
			{
			   obj_t cdr_139_72_368;
			   cdr_139_72_368 = CDR(cdr_133_55_366);
			   if (PAIRP(cdr_139_72_368))
			     {
				obj_t cdr_144_157_370;
				cdr_144_157_370 = CDR(cdr_139_72_368);
				if (PAIRP(cdr_144_157_370))
				  {
				     bool_t test_862;
				     {
					obj_t aux_863;
					aux_863 = CDR(cdr_144_157_370);
					test_862 = (aux_863 == BNIL);
				     }
				     if (test_862)
				       {
					  id_358 = CAR(pragma_357);
					  module_359 = CAR(cdr_133_55_366);
					  prop__131_360 = CAR(cdr_139_72_368);
					  clause_361 = CAR(cdr_144_157_370);
					  {
					     obj_t global_379;
					     {
						obj_t global_394;
						{
						   obj_t list1258_399;
						   list1258_399 = MAKE_PAIR(module_359, BNIL);
						   global_394 = find_global_223_ast_env(id_358, list1258_399);
						}
						{
						   bool_t test1252_395;
						   test1252_395 = is_a__118___object(global_394, global_ast_var);
						   if (test1252_395)
						     {
							global_379 = global_394;
						     }
						   else
						     {
							obj_t list1256_397;
							{
							   obj_t aux_870;
							   aux_870 = CNST_TABLE_REF(((long) 1));
							   list1256_397 = MAKE_PAIR(aux_870, BNIL);
							}
							global_379 = find_global_223_ast_env(id_358, list1256_397);
						     }
						}
					     }
					     {
						bool_t test1234_380;
						test1234_380 = is_a__118___object(global_379, global_ast_var);
						if (test1234_380)
						  {
						     bool_t aux_876;
						     aux_876 = set_pragma_properties__114_module_pragma(global_379, prop__131_360, clause_361);
						     BBOOL(aux_876);
						  }
						else
						  {
						     obj_t arg1237_383;
						     {
							obj_t arg1242_388;
							arg1242_388 = CNST_TABLE_REF(((long) 2));
							{
							   obj_t list1246_390;
							   {
							      obj_t arg1247_391;
							      {
								 obj_t arg1248_392;
								 arg1248_392 = MAKE_PAIR(BNIL, BNIL);
								 arg1247_391 = MAKE_PAIR(module_359, arg1248_392);
							      }
							      list1246_390 = MAKE_PAIR(id_358, arg1247_391);
							   }
							   arg1237_383 = cons__138___r4_pairs_and_lists_6_3(arg1242_388, list1246_390);
							}
						     }
						     {
							obj_t list1238_384;
							{
							   obj_t arg1239_385;
							   {
							      obj_t arg1240_386;
							      arg1240_386 = MAKE_PAIR(arg1237_383, BNIL);
							      arg1239_385 = MAKE_PAIR(string1431_module_pragma, arg1240_386);
							   }
							   list1238_384 = MAKE_PAIR(string1432_module_pragma, arg1239_385);
							}
							warning___error(list1238_384);
						     }
						  }
					     }
					  }
				       }
				     else
				       {
					tag_122_225_363:
					  internal_error_43_tools_error(string1432_module_pragma, string1433_module_pragma, pragma_357);
				       }
				  }
				else
				  {
				     goto tag_122_225_363;
				  }
			     }
			   else
			     {
				goto tag_122_225_363;
			     }
			}
		      else
			{
			   goto tag_122_225_363;
			}
		   }
		 else
		   {
		      goto tag_122_225_363;
		   }
	      }
	   }
	   {
	      obj_t l1117_893;
	      l1117_893 = CDR(l1117_354);
	      l1117_354 = l1117_893;
	      goto lname1118_355;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   __pragma_list__157_module_pragma = BNIL;
   return CNST_TABLE_REF(((long) 3));
}


obj_t 
_pragma_finalizer_19_module_pragma(obj_t env_756)
{
   return pragma_finalizer_170_module_pragma();
}


bool_t 
set_pragma_properties__114_module_pragma(obj_t global_5, obj_t prop__131_6, obj_t clause_7)
{
   {
      obj_t l1119_402;
      l1119_402 = prop__131_6;
    lname1120_403:
      if (PAIRP(l1119_402))
	{
	   set_pragma_property__180_module_pragma(global_5, CAR(l1119_402), clause_7);
	   {
	      obj_t l1119_901;
	      l1119_901 = CDR(l1119_402);
	      l1119_402 = l1119_901;
	      goto lname1120_403;
	   }
	}
      else
	{
	   return ((bool_t) 1);
	}
   }
}


obj_t 
set_pragma_property__180_module_pragma(obj_t global_8, obj_t prop_9, obj_t clause_10)
{
   {
      obj_t key_408;
      obj_t value_409;
      if (SYMBOLP(prop_9))
	{
	   {
	      bool_t test_905;
	      {
		 obj_t aux_906;
		 aux_906 = CNST_TABLE_REF(((long) 4));
		 test_905 = (prop_9 == aux_906);
	      }
	      if (test_905)
		{
		   value_t value_426;
		   {
		      global_t obj_695;
		      obj_695 = (global_t) (global_8);
		      value_426 = (((global_t) CREF(obj_695))->value);
		   }
		   {
		      bool_t test1275_427;
		      test1275_427 = is_a__118___object((obj_t) (value_426), fun_ast_var);
		      if (test1275_427)
			{
			   obj_t res1418_699;
			   {
			      fun_t obj_697;
			      obj_t val1065_698;
			      obj_697 = (fun_t) (value_426);
			      val1065_698 = BFALSE;
			      {
				 obj_t x_761;
				 x_761 = ((((fun_t) CREF(obj_697))->side_effect__165) = ((obj_t) val1065_698), BUNSPEC);
				 res1418_699 = BUNSPEC;
			      }
			   }
			   return res1418_699;
			}
		      else
			{
			   obj_t list1280_431;
			   list1280_431 = MAKE_PAIR(BNIL, BNIL);
			   return user_error_151_tools_error(string1434_module_pragma, string1435_module_pragma, prop_9, list1280_431);
			}
		   }
		}
	      else
		{
		   bool_t test_918;
		   {
		      obj_t aux_919;
		      aux_919 = CNST_TABLE_REF(((long) 5));
		      test_918 = (prop_9 == aux_919);
		   }
		   if (test_918)
		     {
			value_t value_434;
			{
			   global_t obj_702;
			   obj_702 = (global_t) (global_8);
			   value_434 = (((global_t) CREF(obj_702))->value);
			}
			{
			   bool_t test1284_435;
			   test1284_435 = is_a__118___object((obj_t) (value_434), fun_ast_var);
			   if (test1284_435)
			     {
				obj_t res1419_706;
				{
				   fun_t obj_704;
				   obj_704 = (fun_t) (value_434);
				   {
				      obj_t x_762;
				      x_762 = ((((fun_t) CREF(obj_704))->top__138) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				      res1419_706 = BUNSPEC;
				   }
				}
				return res1419_706;
			     }
			   else
			     {
				obj_t list1291_439;
				list1291_439 = MAKE_PAIR(BNIL, BNIL);
				return user_error_151_tools_error(string1434_module_pragma, string1435_module_pragma, prop_9, list1291_439);
			     }
			}
		     }
		   else
		     {
			bool_t test_931;
			{
			   obj_t aux_932;
			   aux_932 = CNST_TABLE_REF(((long) 6));
			   test_931 = (prop_9 == aux_932);
			}
			if (test_931)
			  {
			     value_t value_442;
			     {
				global_t obj_709;
				obj_709 = (global_t) (global_8);
				value_442 = (((global_t) CREF(obj_709))->value);
			     }
			     {
				bool_t test1295_443;
				test1295_443 = is_a__118___object((obj_t) (value_442), sfun_ast_var);
				if (test1295_443)
				  {
				     obj_t arg1296_444;
				     {
					obj_t aux_940;
					{
					   sfun_t obj_711;
					   obj_711 = (sfun_t) (value_442);
					   aux_940 = (((sfun_t) CREF(obj_711))->property);
					}
					arg1296_444 = MAKE_PAIR(prop_9, aux_940);
				     }
				     {
					obj_t res1420_716;
					{
					   sfun_t obj_714;
					   obj_714 = (sfun_t) (value_442);
					   {
					      obj_t x_763;
					      x_763 = ((((sfun_t) CREF(obj_714))->property) = ((obj_t) arg1296_444), BUNSPEC);
					      res1420_716 = BUNSPEC;
					   }
					}
					return res1420_716;
				     }
				  }
				else
				  {
				     obj_t list1301_449;
				     list1301_449 = MAKE_PAIR(BNIL, BNIL);
				     return user_error_151_tools_error(string1434_module_pragma, string1436_module_pragma, prop_9, list1301_449);
				  }
			     }
			  }
			else
			  {
			     obj_t list1309_454;
			     list1309_454 = MAKE_PAIR(BNIL, BNIL);
			     return user_error_151_tools_error(string1430_module_pragma, string1437_module_pragma, clause_10, list1309_454);
			  }
		     }
		}
	   }
	}
      else
	{
	   if (PAIRP(prop_9))
	     {
		obj_t car_160_190_415;
		obj_t cdr_161_14_416;
		car_160_190_415 = CAR(prop_9);
		cdr_161_14_416 = CDR(prop_9);
		if (SYMBOLP(car_160_190_415))
		  {
		     if (PAIRP(cdr_161_14_416))
		       {
			  obj_t car_166_211_419;
			  car_166_211_419 = CAR(cdr_161_14_416);
			  if (SYMBOLP(car_166_211_419))
			    {
			       bool_t test_961;
			       {
				  obj_t aux_962;
				  aux_962 = CDR(cdr_161_14_416);
				  test_961 = (aux_962 == BNIL);
			       }
			       if (test_961)
				 {
				    key_408 = car_160_190_415;
				    value_409 = car_166_211_419;
				    {
				       bool_t test_965;
				       {
					  obj_t aux_966;
					  aux_966 = CNST_TABLE_REF(((long) 7));
					  test_965 = (key_408 == aux_966);
				       }
				       if (test_965)
					 {
					    type_t type_461;
					    value_t value_462;
					    type_461 = use_type__231_type_env(value_409);
					    {
					       global_t obj_719;
					       obj_719 = (global_t) (global_8);
					       value_462 = (((global_t) CREF(obj_719))->value);
					    }
					    {
					       bool_t test1315_463;
					       test1315_463 = is_a__118___object((obj_t) (value_462), fun_ast_var);
					       if (test1315_463)
						 {
						    {
						       obj_t res1421_723;
						       {
							  fun_t obj_721;
							  obj_t val1066_722;
							  obj_721 = (fun_t) (value_462);
							  val1066_722 = (obj_t) (type_461);
							  {
							     obj_t x_764;
							     x_764 = ((((fun_t) CREF(obj_721))->predicate_of_78) = ((obj_t) val1066_722), BUNSPEC);
							     res1421_723 = BUNSPEC;
							  }
						       }
						       res1421_723;
						    }
						    remove_var_from__148_ast_remove(CNST_TABLE_REF(((long) 8)), (variable_t) (global_8));
						    {
						       obj_t res1422_726;
						       {
							  fun_t obj_724;
							  obj_t val1065_725;
							  obj_724 = (fun_t) (value_462);
							  val1065_725 = BFALSE;
							  {
							     obj_t x_765;
							     x_765 = ((((fun_t) CREF(obj_724))->side_effect__165) = ((obj_t) val1065_725), BUNSPEC);
							     res1422_726 = BUNSPEC;
							  }
						       }
						       return res1422_726;
						    }
						 }
					       else
						 {
						    obj_t list1321_468;
						    list1321_468 = MAKE_PAIR(BNIL, BNIL);
						    return user_error_151_tools_error(string1434_module_pragma, string1438_module_pragma, prop_9, list1321_468);
						 }
					    }
					 }
				       else
					 {
					    bool_t test_985;
					    {
					       obj_t aux_986;
					       aux_986 = CNST_TABLE_REF(((long) 9));
					       test_985 = (key_408 == aux_986);
					    }
					    if (test_985)
					      {
						 obj_t stack_alloc_52_471;
						 {
						    obj_t list1347_488;
						    {
						       obj_t aux_989;
						       {
							  global_t obj_729;
							  obj_729 = (global_t) (global_8);
							  aux_989 = (((global_t) CREF(obj_729))->module);
						       }
						       list1347_488 = MAKE_PAIR(aux_989, BNIL);
						    }
						    stack_alloc_52_471 = find_global_223_ast_env(value_409, list1347_488);
						 }
						 {
						    bool_t test1324_472;
						    test1324_472 = is_a__118___object(stack_alloc_52_471, global_ast_var);
						    if (test1324_472)
						      {
							 bool_t test1325_473;
							 {
							    obj_t aux_996;
							    {
							       value_t aux_997;
							       {
								  global_t obj_731;
								  obj_731 = (global_t) (global_8);
								  aux_997 = (((global_t) CREF(obj_731))->value);
							       }
							       aux_996 = (obj_t) (aux_997);
							    }
							    test1325_473 = is_a__118___object(aux_996, fun_ast_var);
							 }
							 if (test1325_473)
							   {
							      if (CBOOL(__optim_stack___57_engine_param))
								{
								   remove_var_from__148_ast_remove(CNST_TABLE_REF(((long) 10)), (variable_t) (stack_alloc_52_471));
								}
							      else
								{
								   BUNSPEC;
								}
							      {
								 obj_t res1423_736;
								 {
								    fun_t obj_734;
								    {
								       value_t aux_1008;
								       {
									  global_t obj_733;
									  obj_733 = (global_t) (global_8);
									  aux_1008 = (((global_t) CREF(obj_733))->value);
								       }
								       obj_734 = (fun_t) (aux_1008);
								    }
								    {
								       obj_t x_766;
								       x_766 = ((((fun_t) CREF(obj_734))->stack_allocator_172) = ((obj_t) stack_alloc_52_471), BUNSPEC);
								       res1423_736 = BUNSPEC;
								    }
								 }
								 return res1423_736;
							      }
							   }
							 else
							   {
							      {
								 obj_t list1333_479;
								 list1333_479 = MAKE_PAIR(BNIL, BNIL);
								 return user_error_151_tools_error(string1434_module_pragma, string1439_module_pragma, prop_9, list1333_479);
							      }
							   }
						      }
						    else
						      {
							 {
							    obj_t list1343_485;
							    list1343_485 = MAKE_PAIR(BNIL, BNIL);
							    return user_error_151_tools_error(string1434_module_pragma, string1440_module_pragma, prop_9, list1343_485);
							 }
						      }
						 }
					      }
					    else
					      {
						 obj_t list1354_493;
						 list1354_493 = MAKE_PAIR(BNIL, BNIL);
						 return user_error_151_tools_error(string1430_module_pragma, string1437_module_pragma, prop_9, list1354_493);
					      }
					 }
				    }
				 }
			       else
				 {
				  tag_152_149_411:
				    {
				       obj_t arg1361_499;
				       if (PAIRP(prop_9))
					 {
					    arg1361_499 = prop_9;
					 }
				       else
					 {
					    arg1361_499 = clause_10;
					 }
				       {
					  obj_t list1364_501;
					  list1364_501 = MAKE_PAIR(BNIL, BNIL);
					  return user_error_151_tools_error(string1430_module_pragma, string1437_module_pragma, arg1361_499, list1364_501);
				       }
				    }
				 }
			    }
			  else
			    {
			       goto tag_152_149_411;
			    }
		       }
		     else
		       {
			  goto tag_152_149_411;
		       }
		  }
		else
		  {
		     goto tag_152_149_411;
		  }
	     }
	   else
	     {
		goto tag_152_149_411;
	     }
	}
   }
}


obj_t 
imported_modules_init_94_module_pragma()
{
   module_initialization_70_module_module(((long) 0), "MODULE_PRAGMA");
   module_initialization_70_tools_error(((long) 0), "MODULE_PRAGMA");
   module_initialization_70_type_type(((long) 0), "MODULE_PRAGMA");
   module_initialization_70_engine_param(((long) 0), "MODULE_PRAGMA");
   module_initialization_70_ast_var(((long) 0), "MODULE_PRAGMA");
   module_initialization_70_ast_env(((long) 0), "MODULE_PRAGMA");
   module_initialization_70_ast_remove(((long) 0), "MODULE_PRAGMA");
   return module_initialization_70_type_env(((long) 0), "MODULE_PRAGMA");
}
