/*===========================================================================*/
/*   (Module/statexp.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


static obj_t arg12761459_module_statexp(obj_t);
extern global_t declare_global_sfun__255_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t statexp_finalizer_204_module_statexp();
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t statexp_producer_46_module_statexp(obj_t);
static obj_t arg12711458_module_statexp(obj_t);
static obj_t imported_modules_init_94_module_statexp();
extern obj_t module_initialization_70_module_statexp(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_prototype(long, char *);
extern obj_t module_initialization_70_module_class(long, char *);
extern obj_t module_initialization_70_module_checksum(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_find_gdefs_13(long, char *);
extern obj_t module_initialization_70_ast_glo_decl_237(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
static obj_t toplevel_init_63_module_statexp();
extern long get_hash_power_number(char *, long);
static obj_t cnst_init_137_module_statexp();
extern obj_t class_finalizer_253_module_class();
static obj_t export_consumer_235_module_statexp(obj_t, obj_t);
extern obj_t ccomp_module_module;
static obj_t arg12041454_module_statexp(obj_t, obj_t, obj_t);
extern obj_t __module__166_module_module;
static obj_t export_checksummer_174_module_statexp(obj_t, obj_t);
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
static obj_t require_initialization_114_module_statexp = BUNSPEC;
extern obj_t parse_prototype_143_module_prototype(obj_t);
static obj_t _export_checksummer_163_module_statexp(obj_t, obj_t, obj_t);
static obj_t library_modules_init_112_module_statexp();
extern obj_t declare_class__31_module_class(obj_t, obj_t, obj_t, bool_t, obj_t);
static obj_t arg12001456_module_statexp(obj_t, obj_t, obj_t);
static obj_t _export_consumer_28_module_statexp(obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern int arity_tools_args(obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t _statexp_finalizer_125_module_statexp(obj_t);
static obj_t arg12031455_module_statexp(obj_t);
extern long class_num_218___object(obj_t);
static obj_t __local_classes__10_module_statexp = BUNSPEC;
extern obj_t _make_export_compiler_160_module_statexp(obj_t);
extern obj_t make_promise_21___r4_control_features_6_9(obj_t);
extern obj_t declare_wide_class__13_module_class(obj_t, obj_t, obj_t, obj_t);
extern obj_t to_be_define__131_ast_find_gdefs_13(global_t);
extern obj_t get_class_hash_100_module_class(obj_t, obj_t);
static obj_t arg12651457_module_statexp(obj_t);
extern obj_t make_export_compiler_49_module_statexp();
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t _make_static_compiler_13_module_statexp(obj_t);
static obj_t _statexp_producer_253_module_statexp(obj_t, obj_t);
extern global_t declare_global_svar__200_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t statexp_parser_81_module_statexp(obj_t, obj_t);
extern type_t type_of_id_183_ast_ident(obj_t);
extern obj_t make_static_compiler_70_module_statexp();
static obj_t __cnst[9];

DEFINE_STATIC_PROCEDURE(export_consumer_env_201_module_statexp, _export_consumer_28_module_statexp1474, _export_consumer_28_module_statexp, 0L, 2);
DEFINE_STATIC_PROCEDURE(statexp_producer_env_28_module_statexp, _statexp_producer_253_module_statexp1475, _statexp_producer_253_module_statexp, 0L, 1);
DEFINE_STRING(string1466_module_statexp, string1466_module_statexp1476, "Illegal `export' clause", 23);
DEFINE_EXPORT_PROCEDURE(make_static_compiler_env_79_module_statexp, _make_static_compiler_13_module_statexp1477, _make_static_compiler_13_module_statexp, 0L, 0);
DEFINE_STRING(string1467_module_statexp, string1467_module_statexp1478, "Illegal prototype", 17);
DEFINE_STRING(string1464_module_statexp, string1464_module_statexp1479, "Illegal `", 9);
DEFINE_STATIC_PROCEDURE(statexp_finalizer_env_236_module_statexp, _statexp_finalizer_125_module_statexp1480, _statexp_finalizer_125_module_statexp, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1460_module_statexp, arg12041454_module_statexp1481, arg12041454_module_statexp, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1461_module_statexp, arg12031455_module_statexp1482, arg12031455_module_statexp, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_export_compiler_env_110_module_statexp, _make_export_compiler_160_module_statexp1483, _make_export_compiler_160_module_statexp, 0L, 0);
DEFINE_STRING(string1465_module_statexp, string1465_module_statexp1484, "Parse error", 11);
DEFINE_STRING(string1468_module_statexp, string1468_module_statexp1485, "OBJ WIDE-CLASS FINAL-CLASS CLASS SVAR (SFUN SIFUN SGFUN) EXPORT VOID STATIC ", 76);
DEFINE_STRING(string1463_module_statexp, string1463_module_statexp1486, "' clause", 8);
DEFINE_STATIC_PROCEDURE(proc1462_module_statexp, arg12001456_module_statexp1487, arg12001456_module_statexp, 0L, 2);
DEFINE_STATIC_PROCEDURE(export_checksummer_env_156_module_statexp, _export_checksummer_163_module_statexp1488, _export_checksummer_163_module_statexp, 0L, 2);

obj_t 
module_initialization_70_module_statexp(long checksum_908, char *from_909)
{
   if (CBOOL(require_initialization_114_module_statexp))
     {
	require_initialization_114_module_statexp = BBOOL(((bool_t) 0));
	library_modules_init_112_module_statexp();
	cnst_init_137_module_statexp();
	imported_modules_init_94_module_statexp();
	toplevel_init_63_module_statexp();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_module_statexp()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_STATEXP");
   module_initialization_70___r4_strings_6_7(((long) 0), "MODULE_STATEXP");
   module_initialization_70___reader(((long) 0), "MODULE_STATEXP");
   module_initialization_70___object(((long) 0), "MODULE_STATEXP");
   module_initialization_70___r4_control_features_6_9(((long) 0), "MODULE_STATEXP");
   return BUNSPEC;
}


obj_t 
cnst_init_137_module_statexp()
{
   {
      obj_t cnst_port_138_900;
      cnst_port_138_900 = open_input_string(string1468_module_statexp);
      {
	 long i_901;
	 i_901 = ((long) 8);
       loop_902:
	 {
	    bool_t test1469_903;
	    test1469_903 = (i_901 == ((long) -1));
	    if (test1469_903)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1470_904;
		    {
		       obj_t list1471_905;
		       {
			  obj_t arg1472_906;
			  arg1472_906 = BNIL;
			  list1471_905 = MAKE_PAIR(cnst_port_138_900, arg1472_906);
		       }
		       arg1470_904 = read___reader(list1471_905);
		    }
		    CNST_TABLE_SET(i_901, arg1470_904);
		 }
		 {
		    int aux_907;
		    {
		       long aux_928;
		       aux_928 = (i_901 - ((long) 1));
		       aux_907 = (int) (aux_928);
		    }
		    {
		       long i_931;
		       i_931 = (long) (aux_907);
		       i_901 = i_931;
		       goto loop_902;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_module_statexp()
{
   return (__local_classes__10_module_statexp = BNIL,
      BUNSPEC);
}


obj_t 
make_static_compiler_70_module_statexp()
{
   {
      obj_t arg1199_333;
      arg1199_333 = CNST_TABLE_REF(((long) 0));
      {
	 obj_t arg1204_863;
	 obj_t arg1203_864;
	 obj_t arg1200_865;
	 arg1204_863 = proc1460_module_statexp;
	 arg1203_864 = proc1461_module_statexp;
	 arg1200_865 = proc1462_module_statexp;
	 {
	    ccomp_t res1452_673;
	    {
	       ccomp_t new1004_664;
	       new1004_664 = ((ccomp_t) BREF(GC_MALLOC(sizeof(struct ccomp))));
	       {
		  long arg1450_665;
		  arg1450_665 = class_num_218___object(ccomp_module_module);
		  {
		     obj_t obj_671;
		     obj_671 = (obj_t) (new1004_664);
		     (((obj_t) CREF(obj_671))->header = MAKE_HEADER(arg1450_665, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_938;
		  aux_938 = (object_t) (new1004_664);
		  OBJECT_WIDENING_SET(aux_938, BFALSE);
	       }
	       ((((ccomp_t) CREF(new1004_664))->id) = ((obj_t) arg1199_333), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_664))->producer) = ((obj_t) statexp_producer_env_28_module_statexp), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_664))->consumer) = ((obj_t) arg1200_865), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_664))->finalizer) = ((obj_t) arg1203_864), BUNSPEC);
	       ((((ccomp_t) CREF(new1004_664))->checksummer) = ((obj_t) arg1204_863), BUNSPEC);
	       res1452_673 = new1004_664;
	    }
	    return (obj_t) (res1452_673);
	 }
      }
   }
}


obj_t 
_make_static_compiler_13_module_statexp(obj_t env_866)
{
   return make_static_compiler_70_module_statexp();
}


obj_t 
arg12041454_module_statexp(obj_t env_867, obj_t m_868, obj_t c_869)
{
   {
      obj_t m_341;
      obj_t c_342;
      m_341 = m_868;
      c_342 = c_869;
      return c_342;
   }
}


obj_t 
arg12031455_module_statexp(obj_t env_870)
{
   {
      return CNST_TABLE_REF(((long) 1));
   }
}


obj_t 
arg12001456_module_statexp(obj_t env_871, obj_t m_872, obj_t c_873)
{
   {
      obj_t m_337;
      obj_t c_338;
      m_337 = m_872;
      c_338 = c_873;
      return BNIL;
   }
}


obj_t 
make_export_compiler_49_module_statexp()
{
   {
      obj_t arg1209_347;
      arg1209_347 = CNST_TABLE_REF(((long) 2));
      {
	 ccomp_t res1453_684;
	 {
	    ccomp_t new1004_675;
	    new1004_675 = ((ccomp_t) BREF(GC_MALLOC(sizeof(struct ccomp))));
	    {
	       long arg1450_676;
	       arg1450_676 = class_num_218___object(ccomp_module_module);
	       {
		  obj_t obj_682;
		  obj_682 = (obj_t) (new1004_675);
		  (((obj_t) CREF(obj_682))->header = MAKE_HEADER(arg1450_676, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_954;
	       aux_954 = (object_t) (new1004_675);
	       OBJECT_WIDENING_SET(aux_954, BFALSE);
	    }
	    ((((ccomp_t) CREF(new1004_675))->id) = ((obj_t) arg1209_347), BUNSPEC);
	    ((((ccomp_t) CREF(new1004_675))->producer) = ((obj_t) statexp_producer_env_28_module_statexp), BUNSPEC);
	    ((((ccomp_t) CREF(new1004_675))->consumer) = ((obj_t) export_consumer_env_201_module_statexp), BUNSPEC);
	    ((((ccomp_t) CREF(new1004_675))->finalizer) = ((obj_t) statexp_finalizer_env_236_module_statexp), BUNSPEC);
	    ((((ccomp_t) CREF(new1004_675))->checksummer) = ((obj_t) export_checksummer_env_156_module_statexp), BUNSPEC);
	    res1453_684 = new1004_675;
	 }
	 return (obj_t) (res1453_684);
      }
   }
}


obj_t 
_make_export_compiler_160_module_statexp(obj_t env_876)
{
   return make_export_compiler_49_module_statexp();
}


obj_t 
statexp_producer_46_module_statexp(obj_t clause_19)
{
   {
      obj_t mode_348;
      mode_348 = CAR(clause_19);
      {
	 obj_t protos_349;
	 if (PAIRP(clause_19))
	   {
	      protos_349 = CDR(clause_19);
	      {
		 obj_t l1114_355;
		 l1114_355 = protos_349;
	       lname1116_356:
		 if (PAIRP(l1114_355))
		   {
		      statexp_parser_81_module_statexp(CAR(l1114_355), mode_348);
		      {
			 obj_t l1114_971;
			 l1114_971 = CDR(l1114_355);
			 l1114_355 = l1114_971;
			 goto lname1116_356;
		      }
		   }
		 else
		   {
		      ((bool_t) 1);
		   }
	      }
	      return BNIL;
	   }
	 else
	   {
	      {
		 obj_t arg1218_361;
		 {
		    obj_t arg1227_366;
		    {
		       obj_t arg1235_372;
		       arg1235_372 = SYMBOL_TO_STRING(mode_348);
		       arg1227_366 = string_downcase_77___r4_strings_6_7(arg1235_372);
		    }
		    {
		       obj_t list1230_368;
		       {
			  obj_t arg1231_369;
			  {
			     obj_t arg1233_370;
			     arg1233_370 = MAKE_PAIR(string1463_module_statexp, BNIL);
			     arg1231_369 = MAKE_PAIR(arg1227_366, arg1233_370);
			  }
			  list1230_368 = MAKE_PAIR(string1464_module_statexp, arg1231_369);
		       }
		       arg1218_361 = string_append_106___r4_strings_6_7(list1230_368);
		    }
		 }
		 {
		    obj_t list1220_363;
		    list1220_363 = MAKE_PAIR(BNIL, BNIL);
		    return user_error_151_tools_error(string1465_module_statexp, arg1218_361, clause_19, list1220_363);
		 }
	      }
	   }
      }
   }
}


obj_t 
_statexp_producer_253_module_statexp(obj_t env_874, obj_t clause_875)
{
   return statexp_producer_46_module_statexp(clause_875);
}


obj_t 
export_consumer_235_module_statexp(obj_t module_20, obj_t clause_21)
{
   {
      if (PAIRP(clause_21))
	{
	   return CDR(clause_21);
	}
      else
	{
	   {
	      obj_t list1242_382;
	      list1242_382 = MAKE_PAIR(BNIL, BNIL);
	      return user_error_151_tools_error(string1465_module_statexp, string1466_module_statexp, clause_21, list1242_382);
	   }
	}
   }
}


obj_t 
_export_consumer_28_module_statexp(obj_t env_877, obj_t module_878, obj_t clause_879)
{
   return export_consumer_235_module_statexp(module_878, clause_879);
}


obj_t 
statexp_parser_81_module_statexp(obj_t prototype_22, obj_t import_23)
{
   {
      obj_t proto_384;
      proto_384 = parse_prototype_143_module_prototype(prototype_22);
      if (PAIRP(proto_384))
	{
	   obj_t case_value_58_386;
	   case_value_58_386 = CAR(proto_384);
	   {
	      bool_t test_993;
	      {
		 obj_t aux_994;
		 aux_994 = memq___r4_pairs_and_lists_6_3(case_value_58_386, CNST_TABLE_REF(((long) 3)));
		 test_993 = CBOOL(aux_994);
	      }
	      if (test_993)
		{
		   global_t arg1248_388;
		   {
		      obj_t aux_1002;
		      obj_t aux_998;
		      {
			 obj_t aux_1003;
			 {
			    obj_t aux_1004;
			    aux_1004 = CDR(proto_384);
			    aux_1003 = CDR(aux_1004);
			 }
			 aux_1002 = CAR(aux_1003);
		      }
		      {
			 obj_t aux_999;
			 aux_999 = CDR(proto_384);
			 aux_998 = CAR(aux_999);
		      }
		      arg1248_388 = declare_global_sfun__255_ast_glo_decl_237(aux_998, aux_1002, __module__166_module_module, import_23, case_value_58_386, prototype_22);
		   }
		   return to_be_define__131_ast_find_gdefs_13(arg1248_388);
		}
	      else
		{
		   bool_t test_1010;
		   {
		      obj_t aux_1011;
		      aux_1011 = CNST_TABLE_REF(((long) 4));
		      test_1010 = (case_value_58_386 == aux_1011);
		   }
		   if (test_1010)
		     {
			global_t arg1257_393;
			{
			   obj_t aux_1014;
			   {
			      obj_t aux_1015;
			      aux_1015 = CDR(proto_384);
			      aux_1014 = CAR(aux_1015);
			   }
			   arg1257_393 = declare_global_svar__200_ast_glo_decl_237(aux_1014, __module__166_module_module, import_23, prototype_22);
			}
			return to_be_define__131_ast_find_gdefs_13(arg1257_393);
		     }
		   else
		     {
			bool_t test_1020;
			{
			   obj_t aux_1021;
			   aux_1021 = CNST_TABLE_REF(((long) 5));
			   test_1020 = (case_value_58_386 == aux_1021);
			}
			if (test_1020)
			  {
			     obj_t arg1261_396;
			     {
				obj_t arg1265_884;
				arg1265_884 = make_fx_procedure(arg12651457_module_statexp, ((long) 0), ((long) 3));
				PROCEDURE_SET(arg1265_884, ((long) 0), proto_384);
				PROCEDURE_SET(arg1265_884, ((long) 1), import_23);
				PROCEDURE_SET(arg1265_884, ((long) 2), prototype_22);
				arg1261_396 = make_promise_21___r4_control_features_6_9(arg1265_884);
			     }
			     {
				obj_t obj2_719;
				obj2_719 = __local_classes__10_module_statexp;
				return (__local_classes__10_module_statexp = MAKE_PAIR(arg1261_396, obj2_719),
				   BUNSPEC);
			     }
			  }
			else
			  {
			     bool_t test_1030;
			     {
				obj_t aux_1031;
				aux_1031 = CNST_TABLE_REF(((long) 6));
				test_1030 = (case_value_58_386 == aux_1031);
			     }
			     if (test_1030)
			       {
				  obj_t arg1270_402;
				  {
				     obj_t arg1271_885;
				     arg1271_885 = make_fx_procedure(arg12711458_module_statexp, ((long) 0), ((long) 3));
				     PROCEDURE_SET(arg1271_885, ((long) 0), proto_384);
				     PROCEDURE_SET(arg1271_885, ((long) 1), import_23);
				     PROCEDURE_SET(arg1271_885, ((long) 2), prototype_22);
				     arg1270_402 = make_promise_21___r4_control_features_6_9(arg1271_885);
				  }
				  {
				     obj_t obj2_725;
				     obj2_725 = __local_classes__10_module_statexp;
				     return (__local_classes__10_module_statexp = MAKE_PAIR(arg1270_402, obj2_725),
					BUNSPEC);
				  }
			       }
			     else
			       {
				  bool_t test_1040;
				  {
				     obj_t aux_1041;
				     aux_1041 = CNST_TABLE_REF(((long) 7));
				     test_1040 = (case_value_58_386 == aux_1041);
				  }
				  if (test_1040)
				    {
				       obj_t arg1275_408;
				       {
					  obj_t arg1276_886;
					  arg1276_886 = make_fx_procedure(arg12761459_module_statexp, ((long) 0), ((long) 3));
					  PROCEDURE_SET(arg1276_886, ((long) 0), proto_384);
					  PROCEDURE_SET(arg1276_886, ((long) 1), import_23);
					  PROCEDURE_SET(arg1276_886, ((long) 2), prototype_22);
					  arg1275_408 = make_promise_21___r4_control_features_6_9(arg1276_886);
				       }
				       {
					  obj_t obj2_731;
					  obj2_731 = __local_classes__10_module_statexp;
					  return (__local_classes__10_module_statexp = MAKE_PAIR(arg1275_408, obj2_731),
					     BUNSPEC);
				       }
				    }
				  else
				    {
				       obj_t list1283_416;
				       list1283_416 = MAKE_PAIR(BNIL, BNIL);
				       return user_error_151_tools_error(string1465_module_statexp, string1467_module_statexp, prototype_22, list1283_416);
				    }
			       }
			  }
		     }
		}
	   }
	}
      else
	{
	   obj_t list1299_426;
	   list1299_426 = MAKE_PAIR(BNIL, BNIL);
	   return user_error_151_tools_error(string1465_module_statexp, string1467_module_statexp, prototype_22, list1299_426);
	}
   }
}


obj_t 
arg12651457_module_statexp(obj_t env_887)
{
   {
      obj_t proto_888;
      obj_t import_889;
      obj_t prototype_890;
      proto_888 = PROCEDURE_REF(env_887, ((long) 0));
      import_889 = PROCEDURE_REF(env_887, ((long) 1));
      prototype_890 = PROCEDURE_REF(env_887, ((long) 2));
      {
	 return declare_class__31_module_class(CDR(proto_888), __module__166_module_module, import_889, ((bool_t) 0), prototype_890);
      }
   }
}


obj_t 
arg12711458_module_statexp(obj_t env_891)
{
   {
      obj_t proto_892;
      obj_t import_893;
      obj_t prototype_894;
      proto_892 = PROCEDURE_REF(env_891, ((long) 0));
      import_893 = PROCEDURE_REF(env_891, ((long) 1));
      prototype_894 = PROCEDURE_REF(env_891, ((long) 2));
      {
	 return declare_class__31_module_class(CDR(proto_892), __module__166_module_module, import_893, ((bool_t) 1), prototype_894);
      }
   }
}


obj_t 
arg12761459_module_statexp(obj_t env_895)
{
   {
      obj_t proto_896;
      obj_t import_897;
      obj_t prototype_898;
      proto_896 = PROCEDURE_REF(env_895, ((long) 0));
      import_897 = PROCEDURE_REF(env_895, ((long) 1));
      prototype_898 = PROCEDURE_REF(env_895, ((long) 2));
      {
	 return declare_wide_class__13_module_class(CDR(proto_896), __module__166_module_module, import_897, prototype_898);
      }
   }
}


obj_t 
statexp_finalizer_204_module_statexp()
{
   {
      obj_t l1117_428;
      {
	 obj_t arg1303_430;
	 arg1303_430 = reverse__39___r4_pairs_and_lists_6_3(__local_classes__10_module_statexp);
	 l1117_428 = arg1303_430;
       lname1118_429:
	 if (PAIRP(l1117_428))
	   {
	      {
		 obj_t arg1305_432;
		 arg1305_432 = CAR(l1117_428);
		 PROCEDURE_ENTRY(arg1305_432) (arg1305_432, BEOA);
	      }
	      {
		 obj_t l1117_1075;
		 l1117_1075 = CDR(l1117_428);
		 l1117_428 = l1117_1075;
		 goto lname1118_429;
	      }
	   }
	 else
	   {
	      ((bool_t) 1);
	   }
      }
   }
   __local_classes__10_module_statexp = BNIL;
   {
      obj_t classes_434;
      classes_434 = class_finalizer_253_module_class();
      if (PAIRP(classes_434))
	{
	   return classes_434;
	}
      else
	{
	   return CNST_TABLE_REF(((long) 1));
	}
   }
}


obj_t 
_statexp_finalizer_125_module_statexp(obj_t env_880)
{
   return statexp_finalizer_204_module_statexp();
}


obj_t 
export_checksummer_174_module_statexp(obj_t eclause_25, obj_t checksum_26)
{
   {
      obj_t clause_445;
      obj_t checksum_446;
      {
	 obj_t clauses_437;
	 obj_t checksum_438;
	 clauses_437 = CDR(eclause_25);
	 checksum_438 = checksum_26;
       loop_439:
	 if (NULLP(clauses_437))
	   {
	      return checksum_438;
	   }
	 else
	   {
	      obj_t arg1312_442;
	      obj_t arg1313_443;
	      arg1312_442 = CDR(clauses_437);
	      clause_445 = CAR(clauses_437);
	      checksum_446 = checksum_438;
	      {
		 obj_t proto_448;
		 proto_448 = parse_prototype_143_module_prototype(clause_445);
		 if (PAIRP(proto_448))
		   {
		      obj_t case_value_58_451;
		      case_value_58_451 = CAR(proto_448);
		      {
			 bool_t test_1089;
			 {
			    obj_t aux_1090;
			    aux_1090 = memq___r4_pairs_and_lists_6_3(case_value_58_451, CNST_TABLE_REF(((long) 3)));
			    test_1089 = CBOOL(aux_1090);
			 }
			 if (test_1089)
			   {
			      long checksum_453;
			      obj_t args_454;
			      {
				 long arg1318_456;
				 obj_t arg1319_457;
				 {
				    long arg1320_458;
				    long arg1321_459;
				    {
				       obj_t arg1404_747;
				       arg1404_747 = SYMBOL_TO_STRING(case_value_58_451);
				       {
					  char *aux_1095;
					  aux_1095 = BSTRING_TO_STRING(arg1404_747);
					  arg1320_458 = get_hash_power_number(aux_1095, ((long) 16));
				       }
				    }
				    {
				       long arg1323_461;
				       long arg1325_462;
				       {
					  obj_t arg1404_757;
					  {
					     obj_t aux_1098;
					     {
						obj_t aux_1099;
						aux_1099 = CDR(proto_448);
						aux_1098 = CAR(aux_1099);
					     }
					     arg1404_757 = SYMBOL_TO_STRING(aux_1098);
					  }
					  {
					     char *aux_1103;
					     aux_1103 = BSTRING_TO_STRING(arg1404_757);
					     arg1323_461 = get_hash_power_number(aux_1103, ((long) 16));
					  }
				       }
				       {
					  int arg1328_464;
					  {
					     obj_t aux_1106;
					     {
						obj_t aux_1107;
						{
						   obj_t aux_1108;
						   aux_1108 = CDR(proto_448);
						   aux_1107 = CDR(aux_1108);
						}
						aux_1106 = CAR(aux_1107);
					     }
					     arg1328_464 = arity_tools_args(aux_1106);
					  }
					  {
					     long aux_1115;
					     long aux_1113;
					     aux_1115 = (long) CINT(checksum_446);
					     aux_1113 = (long) (arg1328_464);
					     arg1325_462 = (aux_1113 ^ aux_1115);
					  }
				       }
				       arg1321_459 = (arg1323_461 ^ arg1325_462);
				    }
				    arg1318_456 = (arg1320_458 ^ arg1321_459);
				 }
				 {
				    obj_t aux_1120;
				    {
				       obj_t aux_1121;
				       aux_1121 = CDR(proto_448);
				       aux_1120 = CDR(aux_1121);
				    }
				    arg1319_457 = CAR(aux_1120);
				 }
				 {
				    long aux_1125;
				    checksum_453 = arg1318_456;
				    args_454 = arg1319_457;
				  loop_455:
				    if (NULLP(args_454))
				      {
					 aux_1125 = checksum_453;
				      }
				    else
				      {
					 if (PAIRP(args_454))
					   {
					      bool_t test_1130;
					      {
						 obj_t aux_1131;
						 aux_1131 = CAR(args_454);
						 test_1130 = CNSTP(aux_1131);
					      }
					      if (test_1130)
						{
						   {
						      long arg1333_469;
						      obj_t arg1334_470;
						      {
							 long arg1337_471;
							 {
							    obj_t aux_1134;
							    aux_1134 = CAR(args_454);
							    arg1337_471 = CCNST(aux_1134);
							 }
							 arg1333_469 = (arg1337_471 ^ checksum_453);
						      }
						      arg1334_470 = CDR(args_454);
						      {
							 obj_t args_1140;
							 long checksum_1139;
							 checksum_1139 = arg1333_469;
							 args_1140 = arg1334_470;
							 args_454 = args_1140;
							 checksum_453 = checksum_1139;
							 goto loop_455;
						      }
						   }
						}
					      else
						{
						   {
						      type_t type_473;
						      type_473 = type_of_id_183_ast_ident(CAR(args_454));
						      {
							 {
							    long arg1340_475;
							    obj_t arg1342_476;
							    {
							       long arg1343_477;
							       {
								  obj_t arg1404_791;
								  {
								     obj_t aux_1143;
								     aux_1143 = (((type_t) CREF(type_473))->id);
								     arg1404_791 = SYMBOL_TO_STRING(aux_1143);
								  }
								  {
								     char *aux_1146;
								     aux_1146 = BSTRING_TO_STRING(arg1404_791);
								     arg1343_477 = get_hash_power_number(aux_1146, ((long) 16));
								  }
							       }
							       arg1340_475 = (arg1343_477 ^ checksum_453);
							    }
							    arg1342_476 = CDR(args_454);
							    {
							       obj_t args_1152;
							       long checksum_1151;
							       checksum_1151 = arg1340_475;
							       args_1152 = arg1342_476;
							       args_454 = args_1152;
							       checksum_453 = checksum_1151;
							       goto loop_455;
							    }
							 }
						      }
						   }
						}
					   }
					 else
					   {
					      {
						 long arg1347_480;
						 {
						    obj_t arg1404_800;
						    {
						       obj_t aux_1153;
						       aux_1153 = CNST_TABLE_REF(((long) 8));
						       arg1404_800 = SYMBOL_TO_STRING(aux_1153);
						    }
						    {
						       char *aux_1156;
						       aux_1156 = BSTRING_TO_STRING(arg1404_800);
						       arg1347_480 = get_hash_power_number(aux_1156, ((long) 16));
						    }
						 }
						 aux_1125 = (arg1347_480 ^ checksum_453);
					      }
					   }
				      }
				    arg1313_443 = BINT(aux_1125);
				 }
			      }
			   }
			 else
			   {
			      bool_t test_1161;
			      {
				 obj_t aux_1162;
				 aux_1162 = CNST_TABLE_REF(((long) 4));
				 test_1161 = (case_value_58_451 == aux_1162);
			      }
			      if (test_1161)
				{
				   long arg1352_483;
				   {
				      obj_t arg1404_814;
				      {
					 obj_t aux_1165;
					 {
					    obj_t aux_1166;
					    aux_1166 = CDR(proto_448);
					    aux_1165 = CAR(aux_1166);
					 }
					 arg1404_814 = SYMBOL_TO_STRING(aux_1165);
				      }
				      {
					 char *aux_1170;
					 aux_1170 = BSTRING_TO_STRING(arg1404_814);
					 arg1352_483 = get_hash_power_number(aux_1170, ((long) 16));
				      }
				   }
				   {
				      long aux_1173;
				      {
					 long aux_1174;
					 aux_1174 = (long) CINT(checksum_446);
					 aux_1173 = (aux_1174 ^ arg1352_483);
				      }
				      arg1313_443 = BINT(aux_1173);
				   }
				}
			      else
				{
				   bool_t test_1178;
				   {
				      obj_t aux_1179;
				      aux_1179 = CNST_TABLE_REF(((long) 5));
				      test_1178 = (case_value_58_451 == aux_1179);
				   }
				   if (test_1178)
				     {
					obj_t arg1355_486;
					{
					   obj_t aux_1182;
					   {
					      obj_t aux_1183;
					      aux_1183 = CDR(proto_448);
					      aux_1182 = CAR(aux_1183);
					   }
					   arg1355_486 = get_class_hash_100_module_class(aux_1182, clause_445);
					}
					{
					   long aux_1187;
					   {
					      long aux_1190;
					      long aux_1188;
					      aux_1190 = (long) CINT(arg1355_486);
					      aux_1188 = (long) CINT(checksum_446);
					      aux_1187 = (aux_1188 ^ aux_1190);
					   }
					   arg1313_443 = BINT(aux_1187);
					}
				     }
				   else
				     {
					bool_t test_1194;
					{
					   obj_t aux_1195;
					   aux_1195 = CNST_TABLE_REF(((long) 6));
					   test_1194 = (case_value_58_451 == aux_1195);
					}
					if (test_1194)
					  {
					     long arg1358_489;
					     {
						obj_t arg1361_491;
						{
						   obj_t aux_1198;
						   {
						      obj_t aux_1199;
						      aux_1199 = CDR(proto_448);
						      aux_1198 = CAR(aux_1199);
						   }
						   arg1361_491 = get_class_hash_100_module_class(aux_1198, clause_445);
						}
						{
						   long aux_1203;
						   aux_1203 = (long) CINT(arg1361_491);
						   arg1358_489 = (((long) 12543) ^ aux_1203);
						}
					     }
					     {
						long aux_1206;
						{
						   long aux_1207;
						   aux_1207 = (long) CINT(checksum_446);
						   aux_1206 = (aux_1207 ^ arg1358_489);
						}
						arg1313_443 = BINT(aux_1206);
					     }
					  }
					else
					  {
					     bool_t test_1211;
					     {
						obj_t aux_1212;
						aux_1212 = CNST_TABLE_REF(((long) 7));
						test_1211 = (case_value_58_451 == aux_1212);
					     }
					     if (test_1211)
					       {
						  long arg1366_494;
						  {
						     obj_t arg1369_496;
						     {
							obj_t aux_1215;
							{
							   obj_t aux_1216;
							   aux_1216 = CDR(proto_448);
							   aux_1215 = CAR(aux_1216);
							}
							arg1369_496 = get_class_hash_100_module_class(aux_1215, clause_445);
						     }
						     {
							long aux_1220;
							aux_1220 = (long) CINT(arg1369_496);
							arg1366_494 = (((long) 456747) ^ aux_1220);
						     }
						  }
						  {
						     long aux_1223;
						     {
							long aux_1224;
							aux_1224 = (long) CINT(checksum_446);
							aux_1223 = (aux_1224 ^ arg1366_494);
						     }
						     arg1313_443 = BINT(aux_1223);
						  }
					       }
					     else
					       {
						  obj_t list1380_501;
						  list1380_501 = MAKE_PAIR(BNIL, BNIL);
						  arg1313_443 = user_error_151_tools_error(string1465_module_statexp, string1467_module_statexp, clause_445, list1380_501);
					       }
					  }
				     }
				}
			   }
		      }
		   }
		 else
		   {
		      obj_t list1401_511;
		      list1401_511 = MAKE_PAIR(BNIL, BNIL);
		      arg1313_443 = user_error_151_tools_error(string1465_module_statexp, string1467_module_statexp, eclause_25, list1401_511);
		   }
	      }
	      {
		 obj_t checksum_1234;
		 obj_t clauses_1233;
		 clauses_1233 = arg1312_442;
		 checksum_1234 = arg1313_443;
		 checksum_438 = checksum_1234;
		 clauses_437 = clauses_1233;
		 goto loop_439;
	      }
	   }
      }
   }
}


obj_t 
_export_checksummer_163_module_statexp(obj_t env_881, obj_t eclause_882, obj_t checksum_883)
{
   return export_checksummer_174_module_statexp(eclause_882, checksum_883);
}


obj_t 
imported_modules_init_94_module_statexp()
{
   module_initialization_70_module_module(((long) 0), "MODULE_STATEXP");
   module_initialization_70_module_prototype(((long) 0), "MODULE_STATEXP");
   module_initialization_70_module_class(((long) 0), "MODULE_STATEXP");
   module_initialization_70_module_checksum(((long) 0), "MODULE_STATEXP");
   module_initialization_70_tools_error(((long) 0), "MODULE_STATEXP");
   module_initialization_70_tools_args(((long) 0), "MODULE_STATEXP");
   module_initialization_70_type_type(((long) 0), "MODULE_STATEXP");
   module_initialization_70_ast_var(((long) 0), "MODULE_STATEXP");
   module_initialization_70_ast_ident(((long) 0), "MODULE_STATEXP");
   module_initialization_70_ast_find_gdefs_13(((long) 0), "MODULE_STATEXP");
   return module_initialization_70_ast_glo_decl_237(((long) 0), "MODULE_STATEXP");
}
