/*===========================================================================*/
/*   (Object/class.scm)                                                      */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;


extern bool_t final_class__126_object_class(obj_t);
extern obj_t type_type_type;
extern obj_t _type_subclass__143_object_class(obj_t, obj_t, obj_t);
extern bool_t type_subclass__90_object_class(type_t, type_t);
obj_t class_object_class = BUNSPEC;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t _declare_class_type__21_object_class(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
extern obj_t _struct_object__object_6___object(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_object_class();
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_object_tools(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern type_t declare_class_type__110_object_class(obj_t, global_t, obj_t, bool_t, obj_t);
extern obj_t newline___r4_output_6_10_3(obj_t);
static obj_t toplevel_init_63_object_class();
static obj_t cnst_init_137_object_class();
extern type_t declare_type__118_type_env(obj_t, obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
extern obj_t _wide_class__223_object_class(obj_t, obj_t);
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
static obj_t object__struct_class1453_225_object_class(obj_t, obj_t);
static obj_t require_initialization_114_object_class = BUNSPEC;
static obj_t library_modules_init_112_object_class();
static type_t allocate_class_37_object_class();
extern obj_t __case_sensitive__90_engine_param;
extern obj_t read___reader(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t _final_class__214_object_class(obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t object__struct_50___object(object_t);
extern obj_t emit_class_types_26_object_class(obj_t);
static obj_t _allocate_class_74_object_class(obj_t);
static obj_t __class_type_list__185_object_class = BUNSPEC;
extern obj_t id__name_228_ast_ident(obj_t);
static obj_t object_init_111_object_class();
static obj_t struct_object__object_class1452_52_object_class(obj_t, obj_t, obj_t);
extern obj_t get_object_type_154_type_cache();
extern obj_t _emit_class_types_128_object_class(obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t _____74_type_cache;
extern obj_t make_struct(obj_t, long, obj_t);
extern bool_t wide_class__100_object_class(obj_t);
extern obj_t _object__struct_74___object(obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
extern object_t struct_object__object_93___object(object_t, obj_t);
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t);
static obj_t cross_name_74_object_class(obj_t);
static obj_t __cnst[2];

DEFINE_STRING(string1458_object_class, string1458_object_class1478, " {", 2);
DEFINE_STATIC_PROCEDURE(allocate_class_env_121_object_class, _allocate_class_74_object_class1479, _allocate_class_74_object_class, 0L, 0);
DEFINE_STRING(string1459_object_class, string1459_object_class1480, "typedef ", 8);
DEFINE_EXPORT_PROCEDURE(type_subclass__env_237_object_class, _type_subclass__143_object_class1481, _type_subclass__143_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(emit_class_types_env_252_object_class, _emit_class_types_128_object_class1482, _emit_class_types_128_object_class, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1471_object_class, struct_object__object_class1452_52_object_class1483, struct_object__object_class1452_52_object_class, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1470_object_class, object__struct_class1453_225_object_class1484, object__struct_class1453_225_object_class, 0L, 1);
DEFINE_STRING(string1466_object_class, string1466_object_class1485, "[ ", 2);
DEFINE_STRING(string1454_object_class, string1454_object_class1486, "struct ", 7);
DEFINE_EXPORT_PROCEDURE(declare_class_type__env_128_object_class, _declare_class_type__21_object_class1487, _declare_class_type__21_object_class, 0L, 5);
DEFINE_EXPORT_PROCEDURE(final_class__env_178_object_class, _final_class__214_object_class1488, _final_class__214_object_class, 0L, 1);
DEFINE_STRING(string1457_object_class, string1457_object_class1489, "/* Object type definitions */", 29);
DEFINE_STRING(string1472_object_class, string1472_object_class1490, "CLASS BIGLOO ", 13);
DEFINE_STRING(string1467_object_class, string1467_object_class1491, " ", 1);
DEFINE_STRING(string1464_object_class, string1464_object_class1492, "   ", 3);
extern obj_t struct_object__object_env_209___object;
DEFINE_STRING(string1455_object_class, string1455_object_class1493, "_t", 2);
DEFINE_STRING(string1462_object_class, string1462_object_class1494, "   obj_t    widening;", 21);
DEFINE_STRING(string1461_object_class, string1461_object_class1495, "   header_t header;", 19);
DEFINE_STRING(string1469_object_class, string1469_object_class1496, "} *", 3);
DEFINE_STRING(string1456_object_class, string1456_object_class1497, " *", 2);
extern obj_t object__struct_env_210___object;
DEFINE_STRING(string1465_object_class, string1465_object_class1498, " ]", 2);
DEFINE_STRING(string1468_object_class, string1468_object_class1499, ";\n", 2);
DEFINE_STRING(string1463_object_class, string1463_object_class1500, ";", 1);
DEFINE_EXPORT_PROCEDURE(wide_class__env_189_object_class, _wide_class__223_object_class1501, _wide_class__223_object_class, 0L, 1);
DEFINE_STRING(string1460_object_class, string1460_object_class1502, "   char dummy;", 14);

obj_t 
module_initialization_70_object_class(long checksum_1012, char *from_1013)
{
   if (CBOOL(require_initialization_114_object_class))
     {
	require_initialization_114_object_class = BBOOL(((bool_t) 0));
	library_modules_init_112_object_class();
	cnst_init_137_object_class();
	object_init_111_object_class();
	imported_modules_init_94_object_class();
	toplevel_init_63_object_class();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_object_class()
{
   module_initialization_70___object(((long) 0), "OBJECT_CLASS");
   module_initialization_70___r4_output_6_10_3(((long) 0), "OBJECT_CLASS");
   module_initialization_70___r4_strings_6_7(((long) 0), "OBJECT_CLASS");
   module_initialization_70___reader(((long) 0), "OBJECT_CLASS");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_CLASS");
   return BUNSPEC;
}


obj_t 
cnst_init_137_object_class()
{
   {
      obj_t cnst_port_138_1004;
      cnst_port_138_1004 = open_input_string(string1472_object_class);
      {
	 long i_1005;
	 i_1005 = ((long) 1);
       loop_1006:
	 {
	    bool_t test1473_1007;
	    test1473_1007 = (i_1005 == ((long) -1));
	    if (test1473_1007)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1474_1008;
		    {
		       obj_t list1475_1009;
		       {
			  obj_t arg1476_1010;
			  arg1476_1010 = BNIL;
			  list1475_1009 = MAKE_PAIR(cnst_port_138_1004, arg1476_1010);
		       }
		       arg1474_1008 = read___reader(list1475_1009);
		    }
		    CNST_TABLE_SET(i_1005, arg1474_1008);
		 }
		 {
		    int aux_1011;
		    {
		       long aux_1033;
		       aux_1033 = (i_1005 - ((long) 1));
		       aux_1011 = (int) (aux_1033);
		    }
		    {
		       long i_1036;
		       i_1036 = (long) (aux_1011);
		       i_1005 = i_1036;
		       goto loop_1006;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_object_class()
{
   return (__class_type_list__185_object_class = BNIL,
      BUNSPEC);
}


type_t 
declare_class_type__110_object_class(obj_t class_def_12_47, global_t class_holder_88_48, obj_t widening_49, bool_t final__12_50, obj_t src_51)
{
   {
      obj_t class_ident_60_436;
      class_ident_60_436 = parse_id_241_ast_ident(CAR(class_def_12_47));
      {
	 obj_t class_id_86_437;
	 class_id_86_437 = CAR(class_ident_60_436);
	 {
	    obj_t super_438;
	    {
	       obj_t super_453;
	       super_453 = CDR(class_ident_60_436);
	       {
		  bool_t test_1042;
		  {
		     obj_t aux_1043;
		     {
			type_t obj_795;
			obj_795 = (type_t) (super_453);
			aux_1043 = (((type_t) CREF(obj_795))->id);
		     }
		     test_1042 = (aux_1043 == class_id_86_437);
		  }
		  if (test_1042)
		    {
		       super_438 = BFALSE;
		    }
		  else
		    {
		       bool_t test1224_455;
		       {
			  obj_t obj2_799;
			  obj2_799 = _____74_type_cache;
			  test1224_455 = (super_453 == obj2_799);
		       }
		       if (test1224_455)
			 {
			    super_438 = get_object_type_154_type_cache();
			 }
		       else
			 {
			    super_438 = super_453;
			 }
		    }
	       }
	    }
	    {
	       obj_t name_439;
	       if (CBOOL(__case_sensitive__90_engine_param))
		 {
		    name_439 = id__name_228_ast_ident(class_id_86_437);
		 }
	       else
		 {
		    obj_t arg1222_452;
		    arg1222_452 = id__name_228_ast_ident(class_id_86_437);
		    name_439 = string_downcase_77___r4_strings_6_7(arg1222_452);
		 }
	       {
		  obj_t sizeof_38_440;
		  sizeof_38_440 = string_append(string1454_object_class, name_439);
		  {
		     obj_t t_name_82_441;
		     t_name_82_441 = string_append(name_439, string1455_object_class);
		     {
			type_t type_442;
			type_442 = declare_type__118_type_env(class_id_86_437, t_name_82_441, CNST_TABLE_REF(((long) 0)));
			{
			   {
			      class_t obj1141_443;
			      obj1141_443 = ((class_t) (type_442));
			      {
				 class_t arg1209_444;
				 {
				    long arg1212_446;
				    {
				       bool_t test1213_447;
				       test1213_447 = is_a__118___object(super_438, class_object_class);
				       if (test1213_447)
					 {
					    long aux_1062;
					    {
					       class_t obj_801;
					       obj_801 = (class_t) (super_438);
					       {
						  obj_t aux_1064;
						  {
						     object_t aux_1065;
						     aux_1065 = (object_t) (obj_801);
						     aux_1064 = OBJECT_WIDENING(aux_1065);
						  }
						  aux_1062 = (((class_t) CREF(aux_1064))->depth);
					       }
					    }
					    arg1212_446 = (aux_1062 + ((long) 1));
					 }
				       else
					 {
					    arg1212_446 = ((long) 0);
					 }
				    }
				    {
				       class_t res1446_817;
				       {
					  class_t new1116_810;
					  new1116_810 = ((class_t) BREF(GC_MALLOC(sizeof(struct class))));
					  ((((class_t) CREF(new1116_810))->its_super_214) = ((obj_t) super_438), BUNSPEC);
					  ((((class_t) CREF(new1116_810))->slots) = ((obj_t) BNIL), BUNSPEC);
					  ((((class_t) CREF(new1116_810))->holder) = ((global_t) class_holder_88_48), BUNSPEC);
					  ((((class_t) CREF(new1116_810))->widening) = ((obj_t) widening_49), BUNSPEC);
					  ((((class_t) CREF(new1116_810))->depth) = ((long) arg1212_446), BUNSPEC);
					  ((((class_t) CREF(new1116_810))->final__12) = ((bool_t) final__12_50), BUNSPEC);
					  res1446_817 = new1116_810;
				       }
				       arg1209_444 = res1446_817;
				    }
				 }
				 {
				    obj_t aux_1079;
				    object_t aux_1077;
				    aux_1079 = (obj_t) (arg1209_444);
				    aux_1077 = (object_t) (obj1141_443);
				    OBJECT_WIDENING_SET(aux_1077, aux_1079);
				 }
			      }
			      {
				 long arg1218_450;
				 arg1218_450 = class_num_218___object(class_object_class);
				 {
				    obj_t obj_818;
				    obj_818 = (obj_t) (obj1141_443);
				    (((obj_t) CREF(obj_818))->header = MAKE_HEADER(arg1218_450, 0), BUNSPEC);
				 }
			      }
			      obj1141_443;
			   }
			   {
			      obj_t res1447_822;
			      {
				 obj_t x_1003;
				 x_1003 = ((((type_t) CREF(type_442))->size) = ((obj_t) sizeof_38_440), BUNSPEC);
				 res1447_822 = BUNSPEC;
			      }
			      res1447_822;
			   }
			   {
			      obj_t obj2_824;
			      obj2_824 = __class_type_list__185_object_class;
			      {
				 obj_t aux_1086;
				 aux_1086 = (obj_t) (type_442);
				 __class_type_list__185_object_class = MAKE_PAIR(aux_1086, obj2_824);
			      }
			   }
			   return type_442;
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_declare_class_type__21_object_class(obj_t env_974, obj_t class_def_12_975, obj_t class_holder_88_976, obj_t widening_977, obj_t final__12_978, obj_t src_979)
{
   {
      type_t aux_1089;
      aux_1089 = declare_class_type__110_object_class(class_def_12_975, (global_t) (class_holder_88_976), widening_977, CBOOL(final__12_978), src_979);
      return (obj_t) (aux_1089);
   }
}


obj_t 
cross_name_74_object_class(obj_t type_52)
{
   {
      bool_t test1228_458;
      test1228_458 = is_a__118___object(type_52, class_object_class);
      if (test1228_458)
	{
	   obj_t aux_1096;
	   {
	      type_t obj_826;
	      obj_826 = (type_t) (type_52);
	      aux_1096 = (((type_t) CREF(obj_826))->size);
	   }
	   return string_append(aux_1096, string1456_object_class);
	}
      else
	{
	   type_t obj_827;
	   obj_827 = (type_t) (type_52);
	   return (((type_t) CREF(obj_827))->name);
	}
   }
}


obj_t 
emit_class_types_26_object_class(obj_t oport_53)
{
   {
      bool_t test1231_461;
      {
	 obj_t obj_828;
	 obj_828 = __class_type_list__185_object_class;
	 test1231_461 = PAIRP(obj_828);
      }
      if (test1231_461)
	{
	   obj_t list1232_462;
	   {
	      obj_t arg1233_463;
	      arg1233_463 = MAKE_PAIR(string1457_object_class, BNIL);
	      {
		 obj_t aux_1105;
		 aux_1105 = BCHAR(((unsigned char) '\n'));
		 list1232_462 = MAKE_PAIR(aux_1105, arg1233_463);
	      }
	   }
	   fprint___r4_output_6_10_3(oport_53, list1232_462);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t l1142_466;
      {
	 obj_t arg1236_468;
	 arg1236_468 = reverse__39___r4_pairs_and_lists_6_3(__class_type_list__185_object_class);
	 l1142_466 = arg1236_468;
       lname1145_467:
	 if (PAIRP(l1142_466))
	   {
	      {
		 obj_t class_470;
		 class_470 = CAR(l1142_466);
		 {
		    bool_t test1238_471;
		    {
		       obj_t arg1329_544;
		       arg1329_544 = get_object_type_154_type_cache();
		       test1238_471 = (class_470 == arg1329_544);
		    }
		    if (test1238_471)
		      {
			 BUNSPEC;
		      }
		    else
		      {
			 {
			    obj_t arg1240_473;
			    {
			       type_t obj_833;
			       obj_833 = (type_t) (class_470);
			       arg1240_473 = (((type_t) CREF(obj_833))->size);
			    }
			    {
			       obj_t list1242_475;
			       {
				  obj_t arg1245_476;
				  {
				     obj_t arg1246_477;
				     arg1246_477 = MAKE_PAIR(string1458_object_class, BNIL);
				     arg1245_476 = MAKE_PAIR(arg1240_473, arg1246_477);
				  }
				  list1242_475 = MAKE_PAIR(string1459_object_class, arg1245_476);
			       }
			       fprint___r4_output_6_10_3(oport_53, list1242_475);
			    }
			 }
			 {
			    bool_t test_1122;
			    {
			       class_t obj_834;
			       obj_834 = (class_t) (class_470);
			       {
				  obj_t aux_1124;
				  {
				     obj_t aux_1125;
				     {
					object_t aux_1126;
					aux_1126 = (object_t) (obj_834);
					aux_1125 = OBJECT_WIDENING(aux_1126);
				     }
				     aux_1124 = (((class_t) CREF(aux_1125))->widening);
				  }
				  test_1122 = CBOOL(aux_1124);
			       }
			    }
			    if (test_1122)
			      {
				 bool_t test_1131;
				 {
				    obj_t aux_1132;
				    {
				       class_t obj_835;
				       obj_835 = (class_t) (class_470);
				       {
					  obj_t aux_1134;
					  {
					     object_t aux_1135;
					     aux_1135 = (object_t) (obj_835);
					     aux_1134 = OBJECT_WIDENING(aux_1135);
					  }
					  aux_1132 = (((class_t) CREF(aux_1134))->slots);
				       }
				    }
				    test_1131 = NULLP(aux_1132);
				 }
				 if (test_1131)
				   {
				      obj_t list1250_481;
				      list1250_481 = MAKE_PAIR(string1460_object_class, BNIL);
				      fprint___r4_output_6_10_3(oport_53, list1250_481);
				   }
				 else
				   {
				      BUNSPEC;
				   }
			      }
			    else
			      {
				 {
				    obj_t list1256_485;
				    list1256_485 = MAKE_PAIR(string1461_object_class, BNIL);
				    fprint___r4_output_6_10_3(oport_53, list1256_485);
				 }
				 {
				    obj_t list1260_488;
				    list1260_488 = MAKE_PAIR(string1462_object_class, BNIL);
				    fprint___r4_output_6_10_3(oport_53, list1260_488);
				 }
			      }
			 }
			 {
			    obj_t l1146_491;
			    {
			       class_t obj_837;
			       obj_837 = (class_t) (class_470);
			       {
				  obj_t aux_1187;
				  {
				     object_t aux_1188;
				     aux_1188 = (object_t) (obj_837);
				     aux_1187 = OBJECT_WIDENING(aux_1188);
				  }
				  l1146_491 = (((class_t) CREF(aux_1187))->slots);
			       }
			    }
			  lname1147_492:
			    if (PAIRP(l1146_491))
			      {
				 {
				    obj_t slot_495;
				    slot_495 = CAR(l1146_491);
				    {
				       obj_t name_496;
				       name_496 = cross_name_74_object_class(STRUCT_REF(slot_495, ((long) 2)));
				       {
					  bool_t test_1151;
					  {
					     obj_t aux_1152;
					     aux_1152 = STRUCT_REF(slot_495, ((long) 5));
					     test_1151 = CBOOL(aux_1152);
					  }
					  if (test_1151)
					    {
					       {
						  obj_t arg1272_500;
						  arg1272_500 = STRUCT_REF(slot_495, ((long) 1));
						  {
						     obj_t list1274_502;
						     {
							obj_t arg1275_503;
							{
							   obj_t arg1276_504;
							   {
							      obj_t arg1278_505;
							      {
								 obj_t arg1279_506;
								 arg1279_506 = MAKE_PAIR(string1463_object_class, BNIL);
								 arg1278_505 = MAKE_PAIR(arg1272_500, arg1279_506);
							      }
							      arg1276_504 = MAKE_PAIR(string1456_object_class, arg1278_505);
							   }
							   arg1275_503 = MAKE_PAIR(name_496, arg1276_504);
							}
							list1274_502 = MAKE_PAIR(string1464_object_class, arg1275_503);
						     }
						     fprint___r4_output_6_10_3(oport_53, list1274_502);
						  }
					       }
					    }
					  else
					    {
					       bool_t test_1162;
					       {
						  obj_t aux_1163;
						  aux_1163 = STRUCT_REF(slot_495, ((long) 3));
						  test_1162 = CBOOL(aux_1163);
					       }
					       if (test_1162)
						 {
						    {
						       obj_t arg1284_511;
						       obj_t arg1287_513;
						       arg1284_511 = STRUCT_REF(slot_495, ((long) 1));
						       arg1287_513 = STRUCT_REF(slot_495, ((long) 4));
						       {
							  obj_t list1294_516;
							  {
							     obj_t arg1295_517;
							     {
								obj_t arg1296_518;
								{
								   obj_t arg1297_519;
								   {
								      obj_t arg1298_520;
								      {
									 obj_t arg1299_521;
									 {
									    obj_t arg1300_522;
									    {
									       obj_t arg1303_523;
									       arg1303_523 = MAKE_PAIR(string1463_object_class, BNIL);
									       arg1300_522 = MAKE_PAIR(string1465_object_class, arg1303_523);
									    }
									    arg1299_521 = MAKE_PAIR(arg1287_513, arg1300_522);
									 }
									 arg1298_520 = MAKE_PAIR(string1466_object_class, arg1299_521);
								      }
								      arg1297_519 = MAKE_PAIR(arg1284_511, arg1298_520);
								   }
								   arg1296_518 = MAKE_PAIR(string1467_object_class, arg1297_519);
								}
								arg1295_517 = MAKE_PAIR(name_496, arg1296_518);
							     }
							     list1294_516 = MAKE_PAIR(string1464_object_class, arg1295_517);
							  }
							  fprint___r4_output_6_10_3(oport_53, list1294_516);
						       }
						    }
						 }
					       else
						 {
						    {
						       obj_t arg1310_527;
						       arg1310_527 = STRUCT_REF(slot_495, ((long) 1));
						       {
							  obj_t list1312_529;
							  {
							     obj_t arg1313_530;
							     {
								obj_t arg1314_531;
								{
								   obj_t arg1315_532;
								   {
								      obj_t arg1316_533;
								      arg1316_533 = MAKE_PAIR(string1463_object_class, BNIL);
								      arg1315_532 = MAKE_PAIR(arg1310_527, arg1316_533);
								   }
								   arg1314_531 = MAKE_PAIR(string1467_object_class, arg1315_532);
								}
								arg1313_530 = MAKE_PAIR(name_496, arg1314_531);
							     }
							     list1312_529 = MAKE_PAIR(string1464_object_class, arg1313_530);
							  }
							  fprint___r4_output_6_10_3(oport_53, list1312_529);
						       }
						    }
						 }
					    }
				       }
				    }
				 }
				 {
				    obj_t l1146_1184;
				    l1146_1184 = CDR(l1146_491);
				    l1146_491 = l1146_1184;
				    goto lname1147_492;
				 }
			      }
			    else
			      {
				 ((bool_t) 1);
			      }
			 }
			 {
			    obj_t arg1322_538;
			    {
			       type_t obj_862;
			       obj_862 = (type_t) (class_470);
			       arg1322_538 = (((type_t) CREF(obj_862))->name);
			    }
			    {
			       obj_t list1324_540;
			       {
				  obj_t arg1325_541;
				  {
				     obj_t arg1327_542;
				     arg1327_542 = MAKE_PAIR(string1468_object_class, BNIL);
				     arg1325_541 = MAKE_PAIR(arg1322_538, arg1327_542);
				  }
				  list1324_540 = MAKE_PAIR(string1469_object_class, arg1325_541);
			       }
			       fprint___r4_output_6_10_3(oport_53, list1324_540);
			    }
			 }
		      }
		 }
	      }
	      {
		 obj_t l1142_1198;
		 l1142_1198 = CDR(l1142_466);
		 l1142_466 = l1142_1198;
		 goto lname1145_467;
	      }
	   }
	 else
	   {
	      ((bool_t) 1);
	   }
      }
   }
   {
      bool_t test1332_546;
      {
	 obj_t obj_864;
	 obj_864 = __class_type_list__185_object_class;
	 test1332_546 = PAIRP(obj_864);
      }
      if (test1332_546)
	{
	   obj_t list1333_547;
	   list1333_547 = MAKE_PAIR(oport_53, BNIL);
	   return newline___r4_output_6_10_3(list1333_547);
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_emit_class_types_128_object_class(obj_t env_980, obj_t oport_981)
{
   return emit_class_types_26_object_class(oport_981);
}


bool_t 
final_class__126_object_class(obj_t class_54)
{
   {
      bool_t _andtest_1148_865;
      _andtest_1148_865 = is_a__118___object(class_54, class_object_class);
      if (_andtest_1148_865)
	{
	   class_t obj_867;
	   obj_867 = (class_t) (class_54);
	   {
	      obj_t aux_1208;
	      {
		 object_t aux_1209;
		 aux_1209 = (object_t) (obj_867);
		 aux_1208 = OBJECT_WIDENING(aux_1209);
	      }
	      return (((class_t) CREF(aux_1208))->final__12);
	   }
	}
      else
	{
	   return ((bool_t) 0);
	}
   }
}


obj_t 
_final_class__214_object_class(obj_t env_982, obj_t class_983)
{
   {
      bool_t aux_1213;
      aux_1213 = final_class__126_object_class(class_983);
      return BBOOL(aux_1213);
   }
}


bool_t 
wide_class__100_object_class(obj_t class_55)
{
   {
      bool_t _andtest_1149_868;
      _andtest_1149_868 = is_a__118___object(class_55, class_object_class);
      if (_andtest_1149_868)
	{
	   class_t obj_870;
	   obj_870 = (class_t) (class_55);
	   {
	      obj_t aux_1219;
	      {
		 obj_t aux_1220;
		 {
		    object_t aux_1221;
		    aux_1221 = (object_t) (obj_870);
		    aux_1220 = OBJECT_WIDENING(aux_1221);
		 }
		 aux_1219 = (((class_t) CREF(aux_1220))->widening);
	      }
	      return CBOOL(aux_1219);
	   }
	}
      else
	{
	   return ((bool_t) 0);
	}
   }
}


obj_t 
_wide_class__223_object_class(obj_t env_984, obj_t class_985)
{
   {
      bool_t aux_1226;
      aux_1226 = wide_class__100_object_class(class_985);
      return BBOOL(aux_1226);
   }
}


bool_t 
type_subclass__90_object_class(type_t subclass_56, type_t class_57)
{
   {
      bool_t test1335_551;
      test1335_551 = is_a__118___object((obj_t) (class_57), class_object_class);
      if (test1335_551)
	{
	   bool_t test1336_552;
	   test1336_552 = is_a__118___object((obj_t) (subclass_56), class_object_class);
	   if (test1336_552)
	     {
		{
		   obj_t subclass_553;
		   subclass_553 = (obj_t) (subclass_56);
		 loop_554:
		   {
		      bool_t test_1235;
		      {
			 obj_t aux_1236;
			 aux_1236 = (obj_t) (class_57);
			 test_1235 = (subclass_553 == aux_1236);
		      }
		      if (test_1235)
			{
			   return ((bool_t) 1);
			}
		      else
			{
			   bool_t test1338_556;
			   test1338_556 = is_a__118___object(subclass_553, class_object_class);
			   if (test1338_556)
			     {
				bool_t test_1241;
				{
				   obj_t aux_1242;
				   {
				      class_t obj_876;
				      obj_876 = (class_t) (subclass_553);
				      {
					 obj_t aux_1244;
					 {
					    object_t aux_1245;
					    aux_1245 = (object_t) (obj_876);
					    aux_1244 = OBJECT_WIDENING(aux_1245);
					 }
					 aux_1242 = (((class_t) CREF(aux_1244))->its_super_214);
				      }
				   }
				   test_1241 = (aux_1242 == subclass_553);
				}
				if (test_1241)
				  {
				     return ((bool_t) 0);
				  }
				else
				  {
				     {
					obj_t subclass_1250;
					{
					   class_t obj_879;
					   obj_879 = (class_t) (subclass_553);
					   {
					      obj_t aux_1252;
					      {
						 object_t aux_1253;
						 aux_1253 = (object_t) (obj_879);
						 aux_1252 = OBJECT_WIDENING(aux_1253);
					      }
					      subclass_1250 = (((class_t) CREF(aux_1252))->its_super_214);
					   }
					}
					subclass_553 = subclass_1250;
					goto loop_554;
				     }
				  }
			     }
			   else
			     {
				return ((bool_t) 0);
			     }
			}
		   }
		}
	     }
	   else
	     {
		return ((bool_t) 0);
	     }
	}
      else
	{
	   return ((bool_t) 0);
	}
   }
}


obj_t 
_type_subclass__143_object_class(obj_t env_986, obj_t subclass_987, obj_t class_988)
{
   {
      bool_t aux_1258;
      aux_1258 = type_subclass__90_object_class((type_t) (subclass_987), (type_t) (class_988));
      return BBOOL(aux_1258);
   }
}


obj_t 
object_init_111_object_class()
{
   {
      obj_t arg1345_561;
      arg1345_561 = type_type_type;
      class_object_class = add_class__117___object(CNST_TABLE_REF(((long) 1)), arg1345_561, allocate_class_env_121_object_class, ((long) 37447), BUNSPEC);
   }
   {
      obj_t object__struct_class_161_993;
      object__struct_class_161_993 = proc1470_object_class;
      add_method__1___object(object__struct_env_210___object, class_object_class, object__struct_class_161_993);
   }
   {
      obj_t struct_object__object_class_152_989;
      struct_object__object_class_152_989 = proc1471_object_class;
      return add_method__1___object(struct_object__object_env_209___object, class_object_class, struct_object__object_class_152_989);
   }
}


obj_t 
struct_object__object_class1452_52_object_class(obj_t env_996, obj_t o_997, obj_t s_998)
{
   {
      class_t o_587;
      obj_t s_588;
      {
	 class_t aux_1267;
	 o_587 = (class_t) (o_997);
	 s_588 = s_998;
	 {
	    {
	       obj_t old1138_591;
	       obj_t aux1139_592;
	       {
		  obj_t next_method1152_106_602;
		  next_method1152_106_602 = find_super_class_method_167___object((object_t) (o_587), struct_object__object_env_209___object, class_object_class);
		  if (PROCEDUREP(next_method1152_106_602))
		    {
		       old1138_591 = PROCEDURE_ENTRY(next_method1152_106_602) (next_method1152_106_602, (obj_t) (o_587), s_588, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1152_106_602);
		       {
			  object_t aux_1276;
			  aux_1276 = struct_object__object_93___object((object_t) (o_587), s_588);
			  old1138_591 = (obj_t) (aux_1276);
		       }
		    }
	       }
	       aux1139_592 = STRUCT_REF(s_588, ((long) 0));
	       {
		  class_t new1140_593;
		  new1140_593 = ((class_t) (old1138_591));
		  {
		     long arg1372_594;
		     arg1372_594 = class_num_218___object(class_object_class);
		     {
			obj_t obj_919;
			obj_919 = (obj_t) (new1140_593);
			(((obj_t) CREF(obj_919))->header = MAKE_HEADER(arg1372_594, 0), BUNSPEC);
		     }
		  }
		  {
		     class_t arg1376_595;
		     {
			obj_t arg1379_596;
			obj_t arg1380_597;
			obj_t arg1382_599;
			arg1379_596 = STRUCT_REF(aux1139_592, ((long) 0));
			arg1380_597 = STRUCT_REF(aux1139_592, ((long) 1));
			arg1382_599 = STRUCT_REF(aux1139_592, ((long) 3));
			{
			   class_t res1448_946;
			   {
			      global_t holder_935;
			      long depth_937;
			      bool_t final__12_938;
			      {
				 obj_t aux_1288;
				 aux_1288 = STRUCT_REF(aux1139_592, ((long) 2));
				 holder_935 = (global_t) (aux_1288);
			      }
			      {
				 obj_t aux_1291;
				 aux_1291 = STRUCT_REF(aux1139_592, ((long) 4));
				 depth_937 = (long) CINT(aux_1291);
			      }
			      {
				 obj_t aux_1294;
				 aux_1294 = STRUCT_REF(aux1139_592, ((long) 5));
				 final__12_938 = CBOOL(aux_1294);
			      }
			      {
				 class_t new1116_939;
				 new1116_939 = ((class_t) BREF(GC_MALLOC(sizeof(struct class))));
				 ((((class_t) CREF(new1116_939))->its_super_214) = ((obj_t) arg1379_596), BUNSPEC);
				 ((((class_t) CREF(new1116_939))->slots) = ((obj_t) arg1380_597), BUNSPEC);
				 ((((class_t) CREF(new1116_939))->holder) = ((global_t) holder_935), BUNSPEC);
				 ((((class_t) CREF(new1116_939))->widening) = ((obj_t) arg1382_599), BUNSPEC);
				 ((((class_t) CREF(new1116_939))->depth) = ((long) depth_937), BUNSPEC);
				 ((((class_t) CREF(new1116_939))->final__12) = ((bool_t) final__12_938), BUNSPEC);
				 res1448_946 = new1116_939;
			      }
			   }
			   arg1376_595 = res1448_946;
			}
		     }
		     {
			obj_t aux_1306;
			object_t aux_1304;
			aux_1306 = (obj_t) (arg1376_595);
			aux_1304 = (object_t) (new1140_593);
			OBJECT_WIDENING_SET(aux_1304, aux_1306);
		     }
		  }
		  aux_1267 = new1140_593;
	       }
	    }
	 }
	 return (obj_t) (aux_1267);
      }
   }
}


obj_t 
object__struct_class1453_225_object_class(obj_t env_999, obj_t obj1135_1000)
{
   {
      class_t obj1135_564;
      obj1135_564 = (class_t) (obj1135_1000);
      {
	 {
	    obj_t res1136_567;
	    {
	       obj_t next_method1151_158_585;
	       next_method1151_158_585 = find_super_class_method_167___object((object_t) (obj1135_564), object__struct_env_210___object, class_object_class);
	       if (PROCEDUREP(next_method1151_158_585))
		 {
		    res1136_567 = PROCEDURE_ENTRY(next_method1151_158_585) (next_method1151_158_585, (obj_t) (obj1135_564), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1151_158_585);
		    res1136_567 = object__struct_50___object((object_t) (obj1135_564));
		 }
	    }
	    {
	       obj_t aux1137_568;
	       {
		  obj_t aux_1321;
		  aux_1321 = CNST_TABLE_REF(((long) 1));
		  aux1137_568 = make_struct(aux_1321, ((long) 6), BUNSPEC);
	       }
	       {
		  obj_t aux_1324;
		  {
		     obj_t aux_1325;
		     {
			object_t aux_1326;
			aux_1326 = (object_t) (obj1135_564);
			aux_1325 = OBJECT_WIDENING(aux_1326);
		     }
		     aux_1324 = (((class_t) CREF(aux_1325))->its_super_214);
		  }
		  STRUCT_SET(aux1137_568, ((long) 0), aux_1324);
	       }
	       {
		  obj_t aux_1331;
		  {
		     obj_t aux_1332;
		     {
			object_t aux_1333;
			aux_1333 = (object_t) (obj1135_564);
			aux_1332 = OBJECT_WIDENING(aux_1333);
		     }
		     aux_1331 = (((class_t) CREF(aux_1332))->slots);
		  }
		  STRUCT_SET(aux1137_568, ((long) 1), aux_1331);
	       }
	       {
		  obj_t aux_1338;
		  {
		     global_t aux_1339;
		     {
			obj_t aux_1340;
			{
			   object_t aux_1341;
			   aux_1341 = (object_t) (obj1135_564);
			   aux_1340 = OBJECT_WIDENING(aux_1341);
			}
			aux_1339 = (((class_t) CREF(aux_1340))->holder);
		     }
		     aux_1338 = (obj_t) (aux_1339);
		  }
		  STRUCT_SET(aux1137_568, ((long) 2), aux_1338);
	       }
	       {
		  obj_t aux_1347;
		  {
		     obj_t aux_1348;
		     {
			object_t aux_1349;
			aux_1349 = (object_t) (obj1135_564);
			aux_1348 = OBJECT_WIDENING(aux_1349);
		     }
		     aux_1347 = (((class_t) CREF(aux_1348))->widening);
		  }
		  STRUCT_SET(aux1137_568, ((long) 3), aux_1347);
	       }
	       {
		  obj_t aux_1354;
		  {
		     long aux_1355;
		     {
			obj_t aux_1356;
			{
			   object_t aux_1357;
			   aux_1357 = (object_t) (obj1135_564);
			   aux_1356 = OBJECT_WIDENING(aux_1357);
			}
			aux_1355 = (((class_t) CREF(aux_1356))->depth);
		     }
		     aux_1354 = BINT(aux_1355);
		  }
		  STRUCT_SET(aux1137_568, ((long) 4), aux_1354);
	       }
	       {
		  obj_t aux_1363;
		  {
		     bool_t aux_1364;
		     {
			obj_t aux_1365;
			{
			   object_t aux_1366;
			   aux_1366 = (object_t) (obj1135_564);
			   aux_1365 = OBJECT_WIDENING(aux_1366);
			}
			aux_1364 = (((class_t) CREF(aux_1365))->final__12);
		     }
		     aux_1363 = BBOOL(aux_1364);
		  }
		  STRUCT_SET(aux1137_568, ((long) 5), aux_1363);
	       }
	       STRUCT_SET(res1136_567, ((long) 0), aux1137_568);
	       {
		  obj_t aux_1373;
		  aux_1373 = STRUCT_KEY(res1136_567);
		  STRUCT_KEY_SET(aux1137_568, aux_1373);
	       }
	       {
		  obj_t aux_1376;
		  aux_1376 = CNST_TABLE_REF(((long) 1));
		  STRUCT_KEY_SET(res1136_567, aux_1376);
	       }
	       return res1136_567;
	    }
	 }
      }
   }
}


type_t 
allocate_class_37_object_class()
{
   {
      type_t new1133_604;
      new1133_604 = ((type_t) BREF(GC_MALLOC(sizeof(struct type))));
      {
	 long arg1390_605;
	 arg1390_605 = class_num_218___object(class_object_class);
	 {
	    obj_t obj_949;
	    obj_949 = (obj_t) (new1133_604);
	    (((obj_t) CREF(obj_949))->header = MAKE_HEADER(arg1390_605, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_1384;
	 aux_1384 = (object_t) (new1133_604);
	 OBJECT_WIDENING_SET(aux_1384, BFALSE);
      }
      return new1133_604;
   }
}


obj_t 
_allocate_class_74_object_class(obj_t env_1001)
{
   {
      type_t aux_1387;
      aux_1387 = allocate_class_37_object_class();
      return (obj_t) (aux_1387);
   }
}


obj_t 
imported_modules_init_94_object_class()
{
   module_initialization_70_tools_error(((long) 0), "OBJECT_CLASS");
   module_initialization_70_type_type(((long) 0), "OBJECT_CLASS");
   module_initialization_70_type_cache(((long) 0), "OBJECT_CLASS");
   module_initialization_70_type_env(((long) 0), "OBJECT_CLASS");
   module_initialization_70_object_tools(((long) 0), "OBJECT_CLASS");
   module_initialization_70_module_module(((long) 0), "OBJECT_CLASS");
   module_initialization_70_engine_param(((long) 0), "OBJECT_CLASS");
   module_initialization_70_ast_var(((long) 0), "OBJECT_CLASS");
   return module_initialization_70_ast_ident(((long) 0), "OBJECT_CLASS");
}
