;* --------------------------------------------------------------------*/
;*    Copyright (c) 1992-1998 by Manuel Serrano. All rights reserved.  */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \   /  '                               */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome. Send them to                                          */
;*        Manuel Serrano -- Manuel.Serrano@unice.fr                    */
;*-------------------------------------------------------------------- */
;*=====================================================================*/
;*    serrano/prgm/project/bigloo/comptime1.9/Object/class.sch         */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Wed Jun  5 11:28:23 1996                          */
;*    Last change :  Fri Jun  7 16:08:15 1996 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The class slots structure                                        */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    slots ...                                                        */
;*---------------------------------------------------------------------*/
(define-struct slot
   id               ;; the slot identifier
   name             ;; the slot name
   type             ;; the slot type
   stat-indexed?    ;; is the slot statically indexed (compile-time size) ?
   stat-bound       ;; the max bound of statically indexed slots
   dyna-indexed?    ;; is the slot dynamically indexed (run-time size) ?
   index?           ;; is the slot a index ?
   read-only?       ;; is the slot read-only
   default?         ;; does the slot has a default value ?
   default-value    ;; if it has, its default value
   assert)          ;; an assertion regarding the slot
