/*===========================================================================*/
/*   (Object/generic.scm)                                                    */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;


extern obj_t type_type_type;
extern obj_t _make_generic_body_173_object_generic(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t class_object_class;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_object_generic();
extern obj_t module_initialization_70_object_generic(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_object_inline(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t cnst_init_137_object_generic();
extern bool_t method_inlining_enabled__91_object_inline();
extern obj_t __module__166_module_module;
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t require_initialization_114_object_generic = BUNSPEC;
static obj_t library_modules_init_112_object_generic();
extern obj_t read___reader(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t);
extern obj_t open_input_string(obj_t);
extern int arity_tools_args(obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t make_generic_body_233_object_generic(obj_t, obj_t, obj_t, obj_t);
extern type_t get_default_type_181_type_cache();
extern obj_t gensym___r4_symbols_6_4;
static obj_t make_generic_inlined_body_246_object_generic(obj_t, obj_t, obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t __obj__252_type_cache;
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t make_generic_non_inlined_body_250_object_generic(obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[14];

DEFINE_STRING(string1580_object_generic, string1580_object_generic1589, "Illegal generic definition (no formal arguments provided)", 57);
DEFINE_EXPORT_PROCEDURE(make_generic_body_env_40_object_generic, _make_generic_body_173_object_generic1590, _make_generic_body_173_object_generic, 0L, 4);
DEFINE_STRING(string1582_object_generic, string1582_object_generic1591, "OBJECT? LAMBDA (QUOTE GENERIC-DEFINITION-ERROR) PROCEDURE? IF FIND-METHOD LET -DEFAULT METHOD __R4_PAIRS_AND_LISTS_6_3 CONS* APPLY @ GENERIC-DEFAULT ", 149);
DEFINE_STRING(string1581_object_generic, string1581_object_generic1592, "generic function has a non-class dispatching type arg", 53);

obj_t 
module_initialization_70_object_generic(long checksum_883, char *from_884)
{
   if (CBOOL(require_initialization_114_object_generic))
     {
	require_initialization_114_object_generic = BBOOL(((bool_t) 0));
	library_modules_init_112_object_generic();
	cnst_init_137_object_generic();
	imported_modules_init_94_object_generic();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_object_generic()
{
   module_initialization_70___object(((long) 0), "OBJECT_GENERIC");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_GENERIC");
   module_initialization_70___reader(((long) 0), "OBJECT_GENERIC");
   module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_GENERIC");
   return BUNSPEC;
}


obj_t 
cnst_init_137_object_generic()
{
   {
      obj_t cnst_port_138_875;
      cnst_port_138_875 = open_input_string(string1582_object_generic);
      {
	 long i_876;
	 i_876 = ((long) 13);
       loop_877:
	 {
	    bool_t test1583_878;
	    test1583_878 = (i_876 == ((long) -1));
	    if (test1583_878)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1584_879;
		    {
		       obj_t list1585_880;
		       {
			  obj_t arg1587_881;
			  arg1587_881 = BNIL;
			  list1585_880 = MAKE_PAIR(cnst_port_138_875, arg1587_881);
		       }
		       arg1584_879 = read___reader(list1585_880);
		    }
		    CNST_TABLE_SET(i_876, arg1584_879);
		 }
		 {
		    int aux_882;
		    {
		       long aux_901;
		       aux_901 = (i_876 - ((long) 1));
		       aux_882 = (int) (aux_901);
		    }
		    {
		       long i_904;
		       i_904 = (long) (aux_882);
		       i_876 = i_904;
		       goto loop_877;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
make_generic_body_233_object_generic(obj_t id_1, obj_t locals_2, obj_t args_3, obj_t src_4)
{
   {
      bool_t test1146_799;
      test1146_799 = method_inlining_enabled__91_object_inline();
      if (test1146_799)
	{
	   return make_generic_inlined_body_246_object_generic(id_1, locals_2, args_3, src_4);
	}
      else
	{
	   return make_generic_non_inlined_body_250_object_generic(id_1, locals_2, args_3, src_4);
	}
   }
}


obj_t 
_make_generic_body_173_object_generic(obj_t env_870, obj_t id_871, obj_t locals_872, obj_t args_873, obj_t src_874)
{
   return make_generic_body_233_object_generic(id_871, locals_872, args_873, src_874);
}


obj_t 
make_generic_non_inlined_body_250_object_generic(obj_t id_5, obj_t locals_6, obj_t args_7, obj_t src_8)
{
   if (NULLP(args_7))
     {
	obj_t list1150_375;
	list1150_375 = MAKE_PAIR(BNIL, BNIL);
	return user_error_151_tools_error(id_5, string1580_object_generic, src_8, list1150_375);
     }
   else
     {
	obj_t pid_377;
	pid_377 = parse_id_241_ast_ident(id_5);
	{
	   obj_t id_378;
	   id_378 = CAR(pid_377);
	   {
	      int arity_379;
	      arity_379 = arity_tools_args(args_7);
	      {
		 obj_t args_id_103_380;
		 if (NULLP(locals_6))
		   {
		      args_id_103_380 = BNIL;
		   }
		 else
		   {
		      obj_t head1137_573;
		      {
			 obj_t aux_920;
			 {
			    local_t obj_804;
			    {
			       obj_t aux_921;
			       aux_921 = CAR(locals_6);
			       obj_804 = (local_t) (aux_921);
			    }
			    aux_920 = (((local_t) CREF(obj_804))->id);
			 }
			 head1137_573 = MAKE_PAIR(aux_920, BNIL);
		      }
		      {
			 obj_t l1134_574;
			 obj_t tail1138_575;
			 l1134_574 = CDR(locals_6);
			 tail1138_575 = head1137_573;
		       lname1136_576:
			 if (NULLP(l1134_574))
			   {
			      args_id_103_380 = head1137_573;
			   }
			 else
			   {
			      obj_t new_tail1139_204_579;
			      {
				 obj_t aux_928;
				 {
				    local_t obj_810;
				    {
				       obj_t aux_929;
				       aux_929 = CAR(l1134_574);
				       obj_810 = (local_t) (aux_929);
				    }
				    aux_928 = (((local_t) CREF(obj_810))->id);
				 }
				 new_tail1139_204_579 = MAKE_PAIR(aux_928, BNIL);
			      }
			      SET_CDR(tail1138_575, new_tail1139_204_579);
			      {
				 obj_t tail1138_937;
				 obj_t l1134_935;
				 l1134_935 = CDR(l1134_574);
				 tail1138_937 = new_tail1139_204_579;
				 tail1138_575 = tail1138_937;
				 l1134_574 = l1134_935;
				 goto lname1136_576;
			      }
			   }
		      }
		   }
		 {
		    obj_t default_body_201_381;
		    {
		       bool_t test_939;
		       {
			  long aux_940;
			  aux_940 = (long) (arity_379);
			  test_939 = (aux_940 >= ((long) 0));
		       }
		       if (test_939)
			 {
			    obj_t arg1361_517;
			    obj_t arg1363_518;
			    {
			       obj_t arg1367_521;
			       obj_t arg1369_522;
			       arg1367_521 = CNST_TABLE_REF(((long) 0));
			       {
				  obj_t arg1379_527;
				  arg1379_527 = CNST_TABLE_REF(((long) 1));
				  {
				     obj_t list1381_529;
				     {
					obj_t arg1382_530;
					{
					   obj_t arg1385_531;
					   arg1385_531 = MAKE_PAIR(BNIL, BNIL);
					   arg1382_530 = MAKE_PAIR(__module__166_module_module, arg1385_531);
					}
					list1381_529 = MAKE_PAIR(id_378, arg1382_530);
				     }
				     arg1369_522 = cons__138___r4_pairs_and_lists_6_3(arg1379_527, list1381_529);
				  }
			       }
			       {
				  obj_t list1371_524;
				  {
				     obj_t arg1372_525;
				     arg1372_525 = MAKE_PAIR(BNIL, BNIL);
				     list1371_524 = MAKE_PAIR(arg1369_522, arg1372_525);
				  }
				  arg1361_517 = cons__138___r4_pairs_and_lists_6_3(arg1367_521, list1371_524);
			       }
			    }
			    {
			       obj_t arg1390_533;
			       arg1390_533 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
			       arg1363_518 = append_2_18___r4_pairs_and_lists_6_3(args_id_103_380, arg1390_533);
			    }
			    {
			       obj_t list1364_519;
			       list1364_519 = MAKE_PAIR(arg1363_518, BNIL);
			       default_body_201_381 = cons__138___r4_pairs_and_lists_6_3(arg1361_517, list1364_519);
			    }
			 }
		       else
			 {
			    obj_t arg1396_536;
			    obj_t arg1398_537;
			    obj_t arg1400_538;
			    arg1396_536 = CNST_TABLE_REF(((long) 2));
			    {
			       obj_t arg1410_544;
			       obj_t arg1411_545;
			       arg1410_544 = CNST_TABLE_REF(((long) 0));
			       {
				  obj_t arg1416_550;
				  arg1416_550 = CNST_TABLE_REF(((long) 1));
				  {
				     obj_t list1418_552;
				     {
					obj_t arg1420_553;
					{
					   obj_t arg1421_554;
					   arg1421_554 = MAKE_PAIR(BNIL, BNIL);
					   arg1420_553 = MAKE_PAIR(__module__166_module_module, arg1421_554);
					}
					list1418_552 = MAKE_PAIR(id_378, arg1420_553);
				     }
				     arg1411_545 = cons__138___r4_pairs_and_lists_6_3(arg1416_550, list1418_552);
				  }
			       }
			       {
				  obj_t list1413_547;
				  {
				     obj_t arg1414_548;
				     arg1414_548 = MAKE_PAIR(BNIL, BNIL);
				     list1413_547 = MAKE_PAIR(arg1411_545, arg1414_548);
				  }
				  arg1398_537 = cons__138___r4_pairs_and_lists_6_3(arg1410_544, list1413_547);
			       }
			    }
			    {
			       obj_t arg1426_556;
			       obj_t arg1427_557;
			       {
				  obj_t arg1432_560;
				  obj_t arg1440_561;
				  obj_t arg1441_562;
				  arg1432_560 = CNST_TABLE_REF(((long) 1));
				  arg1440_561 = CNST_TABLE_REF(((long) 3));
				  arg1441_562 = CNST_TABLE_REF(((long) 4));
				  {
				     obj_t list1445_564;
				     {
					obj_t arg1446_565;
					{
					   obj_t arg1447_566;
					   arg1447_566 = MAKE_PAIR(BNIL, BNIL);
					   arg1446_565 = MAKE_PAIR(arg1441_562, arg1447_566);
					}
					list1445_564 = MAKE_PAIR(arg1440_561, arg1446_565);
				     }
				     arg1426_556 = cons__138___r4_pairs_and_lists_6_3(arg1432_560, list1445_564);
				  }
			       }
			       {
				  obj_t arg1449_568;
				  arg1449_568 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
				  arg1427_557 = append_2_18___r4_pairs_and_lists_6_3(args_id_103_380, arg1449_568);
			       }
			       {
				  obj_t list1428_558;
				  list1428_558 = MAKE_PAIR(arg1427_557, BNIL);
				  arg1400_538 = cons__138___r4_pairs_and_lists_6_3(arg1426_556, list1428_558);
			       }
			    }
			    {
			       obj_t list1403_540;
			       {
				  obj_t arg1404_541;
				  {
				     obj_t arg1406_542;
				     arg1406_542 = MAKE_PAIR(BNIL, BNIL);
				     arg1404_541 = MAKE_PAIR(arg1400_538, arg1406_542);
				  }
				  list1403_540 = MAKE_PAIR(arg1398_537, arg1404_541);
			       }
			       default_body_201_381 = cons__138___r4_pairs_and_lists_6_3(arg1396_536, list1403_540);
			    }
			 }
		    }
		    {
		       obj_t method_arg_150_382;
		       method_arg_150_382 = CAR(locals_6);
		       {
			  obj_t method_arg_id_251_383;
			  {
			     local_t obj_819;
			     obj_819 = (local_t) (method_arg_150_382);
			     method_arg_id_251_383 = (((local_t) CREF(obj_819))->id);
			  }
			  {
			     type_t method_arg_type_249_384;
			     {
				local_t obj_820;
				obj_820 = (local_t) (method_arg_150_382);
				method_arg_type_249_384 = (((local_t) CREF(obj_820))->type);
			     }
			     {
				obj_t method_385;
				method_385 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 5)), BEOA);
				{
				   obj_t default_name_11_386;
				   {
				      obj_t list1356_512;
				      {
					 obj_t arg1357_513;
					 {
					    obj_t aux_989;
					    aux_989 = CNST_TABLE_REF(((long) 6));
					    arg1357_513 = MAKE_PAIR(aux_989, BNIL);
					 }
					 list1356_512 = MAKE_PAIR(id_378, arg1357_513);
				      }
				      default_name_11_386 = symbol_append_197___r4_symbols_6_4(list1356_512);
				   }
				   {
				      obj_t method_name_182_387;
				      method_name_182_387 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 5)), BEOA);
				      {
					 obj_t app_ly_method_58_388;
					 {
					    obj_t arg1257_441;
					    obj_t arg1259_442;
					    obj_t arg1260_443;
					    arg1257_441 = CNST_TABLE_REF(((long) 7));
					    {
					       obj_t arg1268_449;
					       {
						  obj_t arg1273_453;
						  {
						     obj_t arg1280_458;
						     obj_t arg1282_459;
						     arg1280_458 = CNST_TABLE_REF(((long) 8));
						     {
							obj_t arg1293_465;
							arg1293_465 = CNST_TABLE_REF(((long) 1));
							{
							   obj_t list1296_467;
							   {
							      obj_t arg1297_468;
							      {
								 obj_t arg1298_469;
								 arg1298_469 = MAKE_PAIR(BNIL, BNIL);
								 arg1297_468 = MAKE_PAIR(__module__166_module_module, arg1298_469);
							      }
							      list1296_467 = MAKE_PAIR(id_378, arg1297_468);
							   }
							   arg1282_459 = cons__138___r4_pairs_and_lists_6_3(arg1293_465, list1296_467);
							}
						     }
						     {
							obj_t list1284_461;
							{
							   obj_t arg1286_462;
							   {
							      obj_t arg1287_463;
							      arg1287_463 = MAKE_PAIR(BNIL, BNIL);
							      arg1286_462 = MAKE_PAIR(arg1282_459, arg1287_463);
							   }
							   list1284_461 = MAKE_PAIR(method_arg_id_251_383, arg1286_462);
							}
							arg1273_453 = cons__138___r4_pairs_and_lists_6_3(arg1280_458, list1284_461);
						     }
						  }
						  {
						     obj_t list1276_455;
						     {
							obj_t arg1278_456;
							arg1278_456 = MAKE_PAIR(BNIL, BNIL);
							list1276_455 = MAKE_PAIR(arg1273_453, arg1278_456);
						     }
						     arg1268_449 = cons__138___r4_pairs_and_lists_6_3(method_385, list1276_455);
						  }
					       }
					       {
						  obj_t list1271_451;
						  list1271_451 = MAKE_PAIR(BNIL, BNIL);
						  arg1259_442 = cons__138___r4_pairs_and_lists_6_3(arg1268_449, list1271_451);
					       }
					    }
					    {
					       obj_t arg1300_471;
					       obj_t arg1303_472;
					       obj_t arg1305_473;
					       obj_t arg1307_474;
					       arg1300_471 = CNST_TABLE_REF(((long) 9));
					       {
						  obj_t arg1314_481;
						  arg1314_481 = CNST_TABLE_REF(((long) 10));
						  {
						     obj_t list1316_483;
						     {
							obj_t arg1318_484;
							arg1318_484 = MAKE_PAIR(BNIL, BNIL);
							list1316_483 = MAKE_PAIR(method_385, arg1318_484);
						     }
						     arg1303_472 = cons__138___r4_pairs_and_lists_6_3(arg1314_481, list1316_483);
						  }
					       }
					       {
						  bool_t test_1018;
						  {
						     long aux_1019;
						     aux_1019 = (long) (arity_379);
						     test_1018 = (aux_1019 >= ((long) 0));
						  }
						  if (test_1018)
						    {
						       obj_t arg1321_487;
						       {
							  obj_t arg1325_490;
							  arg1325_490 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
							  arg1321_487 = append_2_18___r4_pairs_and_lists_6_3(args_id_103_380, arg1325_490);
						       }
						       {
							  obj_t list1322_488;
							  list1322_488 = MAKE_PAIR(arg1321_487, BNIL);
							  arg1305_473 = cons__138___r4_pairs_and_lists_6_3(method_385, list1322_488);
						       }
						    }
						  else
						    {
						       obj_t arg1329_493;
						       obj_t arg1331_494;
						       arg1329_493 = CNST_TABLE_REF(((long) 2));
						       {
							  obj_t arg1340_500;
							  obj_t arg1342_501;
							  arg1340_500 = CNST_TABLE_REF(((long) 3));
							  {
							     obj_t arg1346_504;
							     arg1346_504 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
							     arg1342_501 = append_2_18___r4_pairs_and_lists_6_3(args_id_103_380, arg1346_504);
							  }
							  {
							     obj_t list1343_502;
							     list1343_502 = MAKE_PAIR(arg1342_501, BNIL);
							     arg1331_494 = cons__138___r4_pairs_and_lists_6_3(arg1340_500, list1343_502);
							  }
						       }
						       {
							  obj_t list1333_496;
							  {
							     obj_t arg1334_497;
							     {
								obj_t arg1337_498;
								arg1337_498 = MAKE_PAIR(BNIL, BNIL);
								arg1334_497 = MAKE_PAIR(arg1331_494, arg1337_498);
							     }
							     list1333_496 = MAKE_PAIR(method_385, arg1334_497);
							  }
							  arg1305_473 = cons__138___r4_pairs_and_lists_6_3(arg1329_493, list1333_496);
						       }
						    }
					       }
					       {
						  obj_t list1350_508;
						  list1350_508 = MAKE_PAIR(BNIL, BNIL);
						  arg1307_474 = cons__138___r4_pairs_and_lists_6_3(default_name_11_386, list1350_508);
					       }
					       {
						  obj_t list1309_476;
						  {
						     obj_t arg1310_477;
						     {
							obj_t arg1311_478;
							{
							   obj_t arg1312_479;
							   arg1312_479 = MAKE_PAIR(BNIL, BNIL);
							   arg1311_478 = MAKE_PAIR(arg1307_474, arg1312_479);
							}
							arg1310_477 = MAKE_PAIR(arg1305_473, arg1311_478);
						     }
						     list1309_476 = MAKE_PAIR(arg1303_472, arg1310_477);
						  }
						  arg1260_443 = cons__138___r4_pairs_and_lists_6_3(arg1300_471, list1309_476);
					       }
					    }
					    {
					       obj_t list1262_445;
					       {
						  obj_t arg1265_446;
						  {
						     obj_t arg1266_447;
						     arg1266_447 = MAKE_PAIR(BNIL, BNIL);
						     arg1265_446 = MAKE_PAIR(arg1260_443, arg1266_447);
						  }
						  list1262_445 = MAKE_PAIR(arg1259_442, arg1265_446);
					       }
					       app_ly_method_58_388 = cons__138___r4_pairs_and_lists_6_3(arg1257_441, list1262_445);
					    }
					 }
					 {
					    {
					       bool_t test1155_389;
					       {
						  bool_t test1252_436;
						  test1252_436 = is_a__118___object((obj_t) (method_arg_type_249_384), type_type_type);
						  if (test1252_436)
						    {
						       bool_t test1253_437;
						       {
							  obj_t obj2_825;
							  obj2_825 = __obj__252_type_cache;
							  {
							     obj_t aux_1050;
							     aux_1050 = (obj_t) (method_arg_type_249_384);
							     test1253_437 = (aux_1050 == obj2_825);
							  }
						       }
						       if (test1253_437)
							 {
							    test1155_389 = ((bool_t) 0);
							 }
						       else
							 {
							    bool_t test1254_438;
							    {
							       type_t arg1256_440;
							       arg1256_440 = get_default_type_181_type_cache();
							       {
								  obj_t aux_1057;
								  obj_t aux_1055;
								  aux_1057 = (obj_t) (arg1256_440);
								  aux_1055 = (obj_t) (method_arg_type_249_384);
								  test1254_438 = (aux_1055 == aux_1057);
							       }
							    }
							    if (test1254_438)
							      {
								 test1155_389 = ((bool_t) 0);
							      }
							    else
							      {
								 bool_t test1255_439;
								 test1255_439 = is_a__118___object((obj_t) (method_arg_type_249_384), class_object_class);
								 if (test1255_439)
								   {
								      test1155_389 = ((bool_t) 0);
								   }
								 else
								   {
								      test1155_389 = ((bool_t) 1);
								   }
							      }
							 }
						    }
						  else
						    {
						       test1155_389 = ((bool_t) 0);
						    }
					       }
					       if (test1155_389)
						 {
						    obj_t list1165_392;
						    {
						       obj_t aux_1065;
						       aux_1065 = CNST_TABLE_REF(((long) 11));
						       list1165_392 = MAKE_PAIR(aux_1065, BNIL);
						    }
						    return user_error_151_tools_error(id_378, string1581_object_generic, src_8, list1165_392);
						 }
					       else
						 {
						    obj_t arg1181_394;
						    obj_t arg1182_395;
						    obj_t arg1195_396;
						    arg1181_394 = CNST_TABLE_REF(((long) 7));
						    {
						       obj_t arg1204_402;
						       {
							  obj_t arg1208_406;
							  {
							     obj_t arg1214_411;
							     arg1214_411 = CNST_TABLE_REF(((long) 12));
							     {
								obj_t list1219_414;
								{
								   obj_t arg1222_415;
								   {
								      obj_t arg1225_416;
								      arg1225_416 = MAKE_PAIR(BNIL, BNIL);
								      arg1222_415 = MAKE_PAIR(default_body_201_381, arg1225_416);
								   }
								   list1219_414 = MAKE_PAIR(BNIL, arg1222_415);
								}
								arg1208_406 = cons__138___r4_pairs_and_lists_6_3(arg1214_411, list1219_414);
							     }
							  }
							  {
							     obj_t list1210_408;
							     {
								obj_t arg1212_409;
								arg1212_409 = MAKE_PAIR(BNIL, BNIL);
								list1210_408 = MAKE_PAIR(arg1208_406, arg1212_409);
							     }
							     arg1204_402 = cons__138___r4_pairs_and_lists_6_3(default_name_11_386, list1210_408);
							  }
						       }
						       {
							  obj_t list1206_404;
							  list1206_404 = MAKE_PAIR(BNIL, BNIL);
							  arg1182_395 = cons__138___r4_pairs_and_lists_6_3(arg1204_402, list1206_404);
						       }
						    }
						    {
						       bool_t test1228_418;
						       test1228_418 = is_a__118___object((obj_t) (method_arg_type_249_384), class_object_class);
						       if (test1228_418)
							 {
							    arg1195_396 = app_ly_method_58_388;
							 }
						       else
							 {
							    obj_t arg1229_419;
							    obj_t arg1230_420;
							    obj_t arg1231_421;
							    arg1229_419 = CNST_TABLE_REF(((long) 9));
							    {
							       obj_t arg1240_428;
							       arg1240_428 = CNST_TABLE_REF(((long) 13));
							       {
								  obj_t list1242_430;
								  {
								     obj_t arg1245_431;
								     arg1245_431 = MAKE_PAIR(BNIL, BNIL);
								     list1242_430 = MAKE_PAIR(method_arg_id_251_383, arg1245_431);
								  }
								  arg1230_420 = cons__138___r4_pairs_and_lists_6_3(arg1240_428, list1242_430);
							       }
							    }
							    {
							       obj_t list1248_434;
							       list1248_434 = MAKE_PAIR(BNIL, BNIL);
							       arg1231_421 = cons__138___r4_pairs_and_lists_6_3(default_name_11_386, list1248_434);
							    }
							    {
							       obj_t list1234_423;
							       {
								  obj_t arg1235_424;
								  {
								     obj_t arg1236_425;
								     {
									obj_t arg1237_426;
									arg1237_426 = MAKE_PAIR(BNIL, BNIL);
									arg1236_425 = MAKE_PAIR(arg1231_421, arg1237_426);
								     }
								     arg1235_424 = MAKE_PAIR(app_ly_method_58_388, arg1236_425);
								  }
								  list1234_423 = MAKE_PAIR(arg1230_420, arg1235_424);
							       }
							       arg1195_396 = cons__138___r4_pairs_and_lists_6_3(arg1229_419, list1234_423);
							    }
							 }
						    }
						    {
						       obj_t list1198_398;
						       {
							  obj_t arg1199_399;
							  {
							     obj_t arg1200_400;
							     arg1200_400 = MAKE_PAIR(BNIL, BNIL);
							     arg1199_399 = MAKE_PAIR(arg1195_396, arg1200_400);
							  }
							  list1198_398 = MAKE_PAIR(arg1182_395, arg1199_399);
						       }
						       return cons__138___r4_pairs_and_lists_6_3(arg1181_394, list1198_398);
						    }
						 }
					    }
					 }
				      }
				   }
				}
			     }
			  }
		       }
		    }
		 }
	      }
	   }
	}
     }
}


obj_t 
make_generic_inlined_body_246_object_generic(obj_t id_9, obj_t locals_10, obj_t args_11, obj_t src_12)
{
   {
      obj_t pid_587;
      pid_587 = parse_id_241_ast_ident(id_9);
      {
	 obj_t id_588;
	 id_588 = CAR(pid_587);
	 {
	    int arity_589;
	    arity_589 = arity_tools_args(args_11);
	    {
	       obj_t args_id_103_590;
	       if (NULLP(locals_10))
		 {
		    args_id_103_590 = BNIL;
		 }
	       else
		 {
		    obj_t head1142_641;
		    {
		       obj_t aux_1104;
		       {
			  local_t obj_833;
			  {
			     obj_t aux_1105;
			     aux_1105 = CAR(locals_10);
			     obj_833 = (local_t) (aux_1105);
			  }
			  aux_1104 = (((local_t) CREF(obj_833))->id);
		       }
		       head1142_641 = MAKE_PAIR(aux_1104, BNIL);
		    }
		    {
		       obj_t l1140_642;
		       obj_t tail1143_643;
		       l1140_642 = CDR(locals_10);
		       tail1143_643 = head1142_641;
		     lname1141_644:
		       if (NULLP(l1140_642))
			 {
			    args_id_103_590 = head1142_641;
			 }
		       else
			 {
			    obj_t new_tail1144_238_647;
			    {
			       obj_t aux_1112;
			       {
				  local_t obj_839;
				  {
				     obj_t aux_1113;
				     aux_1113 = CAR(l1140_642);
				     obj_839 = (local_t) (aux_1113);
				  }
				  aux_1112 = (((local_t) CREF(obj_839))->id);
			       }
			       new_tail1144_238_647 = MAKE_PAIR(aux_1112, BNIL);
			    }
			    SET_CDR(tail1143_643, new_tail1144_238_647);
			    {
			       obj_t tail1143_1121;
			       obj_t l1140_1119;
			       l1140_1119 = CDR(l1140_642);
			       tail1143_1121 = new_tail1144_238_647;
			       tail1143_643 = tail1143_1121;
			       l1140_642 = l1140_1119;
			       goto lname1141_644;
			    }
			 }
		    }
		 }
	       {
		  obj_t body_591;
		  {
		     bool_t test_1123;
		     {
			long aux_1124;
			aux_1124 = (long) (arity_589);
			test_1123 = (aux_1124 >= ((long) 0));
		     }
		     if (test_1123)
		       {
			  obj_t arg1470_593;
			  obj_t arg1471_594;
			  {
			     obj_t arg1476_597;
			     obj_t arg1477_598;
			     arg1476_597 = CNST_TABLE_REF(((long) 0));
			     {
				obj_t arg1484_603;
				arg1484_603 = CNST_TABLE_REF(((long) 1));
				{
				   obj_t list1486_605;
				   {
				      obj_t arg1487_606;
				      {
					 obj_t arg1489_607;
					 arg1489_607 = MAKE_PAIR(BNIL, BNIL);
					 arg1487_606 = MAKE_PAIR(__module__166_module_module, arg1489_607);
				      }
				      list1486_605 = MAKE_PAIR(id_588, arg1487_606);
				   }
				   arg1477_598 = cons__138___r4_pairs_and_lists_6_3(arg1484_603, list1486_605);
				}
			     }
			     {
				obj_t list1479_600;
				{
				   obj_t arg1480_601;
				   arg1480_601 = MAKE_PAIR(BNIL, BNIL);
				   list1479_600 = MAKE_PAIR(arg1477_598, arg1480_601);
				}
				arg1470_593 = cons__138___r4_pairs_and_lists_6_3(arg1476_597, list1479_600);
			     }
			  }
			  {
			     obj_t arg1493_609;
			     arg1493_609 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
			     arg1471_594 = append_2_18___r4_pairs_and_lists_6_3(args_id_103_590, arg1493_609);
			  }
			  {
			     obj_t list1472_595;
			     list1472_595 = MAKE_PAIR(arg1471_594, BNIL);
			     body_591 = cons__138___r4_pairs_and_lists_6_3(arg1470_593, list1472_595);
			  }
		       }
		     else
		       {
			  obj_t arg1496_612;
			  obj_t arg1497_613;
			  obj_t arg1498_614;
			  arg1496_612 = CNST_TABLE_REF(((long) 2));
			  {
			     obj_t arg1507_620;
			     obj_t arg1509_621;
			     arg1507_620 = CNST_TABLE_REF(((long) 0));
			     {
				obj_t arg1517_626;
				arg1517_626 = CNST_TABLE_REF(((long) 1));
				{
				   obj_t list1519_628;
				   {
				      obj_t arg1520_629;
				      {
					 obj_t arg1522_630;
					 arg1522_630 = MAKE_PAIR(BNIL, BNIL);
					 arg1520_629 = MAKE_PAIR(__module__166_module_module, arg1522_630);
				      }
				      list1519_628 = MAKE_PAIR(id_588, arg1520_629);
				   }
				   arg1509_621 = cons__138___r4_pairs_and_lists_6_3(arg1517_626, list1519_628);
				}
			     }
			     {
				obj_t list1511_623;
				{
				   obj_t arg1513_624;
				   arg1513_624 = MAKE_PAIR(BNIL, BNIL);
				   list1511_623 = MAKE_PAIR(arg1509_621, arg1513_624);
				}
				arg1497_613 = cons__138___r4_pairs_and_lists_6_3(arg1507_620, list1511_623);
			     }
			  }
			  {
			     obj_t arg1524_632;
			     obj_t arg1526_633;
			     arg1524_632 = CNST_TABLE_REF(((long) 3));
			     {
				obj_t arg1531_636;
				arg1531_636 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
				arg1526_633 = append_2_18___r4_pairs_and_lists_6_3(args_id_103_590, arg1531_636);
			     }
			     {
				obj_t list1527_634;
				list1527_634 = MAKE_PAIR(arg1526_633, BNIL);
				arg1498_614 = cons__138___r4_pairs_and_lists_6_3(arg1524_632, list1527_634);
			     }
			  }
			  {
			     obj_t list1500_616;
			     {
				obj_t arg1501_617;
				{
				   obj_t arg1505_618;
				   arg1505_618 = MAKE_PAIR(BNIL, BNIL);
				   arg1501_617 = MAKE_PAIR(arg1498_614, arg1505_618);
				}
				list1500_616 = MAKE_PAIR(arg1497_613, arg1501_617);
			     }
			     body_591 = cons__138___r4_pairs_and_lists_6_3(arg1496_612, list1500_616);
			  }
		       }
		  }
		  {
		     return body_591;
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
imported_modules_init_94_object_generic()
{
   module_initialization_70_engine_param(((long) 0), "OBJECT_GENERIC");
   module_initialization_70_tools_args(((long) 0), "OBJECT_GENERIC");
   module_initialization_70_tools_error(((long) 0), "OBJECT_GENERIC");
   module_initialization_70_type_type(((long) 0), "OBJECT_GENERIC");
   module_initialization_70_type_cache(((long) 0), "OBJECT_GENERIC");
   module_initialization_70_ast_var(((long) 0), "OBJECT_GENERIC");
   module_initialization_70_ast_ident(((long) 0), "OBJECT_GENERIC");
   module_initialization_70_object_class(((long) 0), "OBJECT_GENERIC");
   module_initialization_70_object_inline(((long) 0), "OBJECT_GENERIC");
   return module_initialization_70_module_module(((long) 0), "OBJECT_GENERIC");
}
