/*===========================================================================*/
/*   (Object/inline.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;


extern long add_generic_method__111_object_inline(global_t, type_t, obj_t, obj_t);
extern obj_t inline_methods__72_object_inline();
extern obj_t args___args_list_50_tools_args(obj_t);
extern obj_t class_object_class;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_object_inline();
extern obj_t module_initialization_70_object_inline(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_expand_eps(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t toplevel_init_63_object_inline();
static obj_t cnst_init_137_object_inline();
extern bool_t method_inlining_enabled__91_object_inline();
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t inline_method__105_object_inline(obj_t);
static obj_t require_initialization_114_object_inline = BUNSPEC;
static obj_t library_modules_init_112_object_inline();
extern obj_t add_generic_for_method_inlining__147_object_inline(obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t _add_generic_for_method_inlining__161_object_inline(obj_t, obj_t);
extern obj_t _inline_methods__227_object_inline(obj_t);
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t _method_inlining_enabled__235_object_inline(obj_t);
static obj_t inline_method_clause_150_object_inline(obj_t, obj_t);
static obj_t __intern_generic__171_object_inline = BUNSPEC;
extern obj_t comptime_expand_37_expand_eps(obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t __optim_inline_method___30_engine_param;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t make_case_clauses_101_object_inline(obj_t, obj_t);
static obj_t disable_method_inlining__113_object_inline();
extern obj_t _add_generic_method__195_object_inline(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
static obj_t __cnst[27];

DEFINE_EXPORT_PROCEDURE(method_inlining_enabled__env_87_object_inline, _method_inlining_enabled__235_object_inline1854, _method_inlining_enabled__235_object_inline, 0L, 0);
DEFINE_EXPORT_PROCEDURE(inline_methods__env_13_object_inline, _inline_methods__227_object_inline1855, _inline_methods__227_object_inline, 0L, 0);
DEFINE_STRING(string1846_object_inline, string1846_object_inline1856, "   . Method inlining", 20);
DEFINE_STRING(string1847_object_inline, string1847_object_inline1857, "VALUE OBJECT? OBJECT-CLASS FIND-INLINE-METHOD ELSE CASE CAR CDR FIND-METHOD-FROM CLASS-SUPER CLASS? LET* CALL-NEXT-METHOD LET LAMBDA LETREC CLASS CONS* APPLY PROCEDURE? IF LARG AUX SUPER LOOP METHOD IMETHOD ", 207);
DEFINE_EXPORT_PROCEDURE(add_generic_for_method_inlining__env_177_object_inline, _add_generic_for_method_inlining__161_object_inline1858, _add_generic_for_method_inlining__161_object_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(add_generic_method__env_190_object_inline, _add_generic_method__195_object_inline1859, _add_generic_method__195_object_inline, 0L, 4);

obj_t 
module_initialization_70_object_inline(long checksum_1599, char *from_1600)
{
   if (CBOOL(require_initialization_114_object_inline))
     {
	require_initialization_114_object_inline = BBOOL(((bool_t) 0));
	library_modules_init_112_object_inline();
	cnst_init_137_object_inline();
	imported_modules_init_94_object_inline();
	toplevel_init_63_object_inline();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_object_inline()
{
   module_initialization_70___object(((long) 0), "OBJECT_INLINE");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_INLINE");
   module_initialization_70___reader(((long) 0), "OBJECT_INLINE");
   module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_INLINE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_object_inline()
{
   {
      obj_t cnst_port_138_1591;
      cnst_port_138_1591 = open_input_string(string1847_object_inline);
      {
	 long i_1592;
	 i_1592 = ((long) 26);
       loop_1593:
	 {
	    bool_t test1848_1594;
	    test1848_1594 = (i_1592 == ((long) -1));
	    if (test1848_1594)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1849_1595;
		    {
		       obj_t list1850_1596;
		       {
			  obj_t arg1852_1597;
			  arg1852_1597 = BNIL;
			  list1850_1596 = MAKE_PAIR(cnst_port_138_1591, arg1852_1597);
		       }
		       arg1849_1595 = read___reader(list1850_1596);
		    }
		    CNST_TABLE_SET(i_1592, arg1849_1595);
		 }
		 {
		    int aux_1598;
		    {
		       long aux_1618;
		       aux_1618 = (i_1592 - ((long) 1));
		       aux_1598 = (int) (aux_1618);
		    }
		    {
		       long i_1621;
		       i_1621 = (long) (aux_1598);
		       i_1592 = i_1621;
		       goto loop_1593;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_object_inline()
{
   __intern_generic__171_object_inline = BNIL;
   return BUNSPEC;
}


bool_t 
method_inlining_enabled__91_object_inline()
{
   return CBOOL(__optim_inline_method___30_engine_param);
}


obj_t 
_method_inlining_enabled__235_object_inline(obj_t env_1580)
{
   {
      bool_t aux_1624;
      aux_1624 = method_inlining_enabled__91_object_inline();
      return BBOOL(aux_1624);
   }
}


obj_t 
disable_method_inlining__113_object_inline()
{
   __intern_generic__171_object_inline = BNIL;
   return (__optim_inline_method___30_engine_param = BFALSE,
      BUNSPEC);
}


obj_t 
add_generic_for_method_inlining__147_object_inline(obj_t generic_1)
{
   {
      bool_t test1305_723;
      {
	 bool_t test1312_728;
	 {
	    bool_t res1843_1412;
	    res1843_1412 = CBOOL(__optim_inline_method___30_engine_param);
	    test1312_728 = res1843_1412;
	 }
	 if (test1312_728)
	   {
	      bool_t test1313_729;
	      {
		 obj_t arg1314_730;
		 arg1314_730 = assq___r4_pairs_and_lists_6_3(generic_1, __intern_generic__171_object_inline);
		 test1313_729 = PAIRP(arg1314_730);
	      }
	      if (test1313_729)
		{
		   test1305_723 = ((bool_t) 0);
		}
	      else
		{
		   test1305_723 = ((bool_t) 1);
		}
	   }
	 else
	   {
	      test1305_723 = ((bool_t) 0);
	   }
      }
      if (test1305_723)
	{
	   obj_t arg1307_724;
	   {
	      obj_t arg1308_725;
	      {
		 obj_t aux_1633;
		 aux_1633 = BINT(((long) 0));
		 arg1308_725 = MAKE_PAIR(aux_1633, BNIL);
	      }
	      arg1307_724 = MAKE_PAIR(generic_1, arg1308_725);
	   }
	   {
	      obj_t obj2_1419;
	      obj2_1419 = __intern_generic__171_object_inline;
	      return (__intern_generic__171_object_inline = MAKE_PAIR(arg1307_724, obj2_1419),
		 BUNSPEC);
	   }
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_add_generic_for_method_inlining__161_object_inline(obj_t env_1581, obj_t generic_1582)
{
   return add_generic_for_method_inlining__147_object_inline(generic_1582);
}


long 
add_generic_method__111_object_inline(global_t generic_16, type_t type_17, obj_t args_18, obj_t body_19)
{
   {
      obj_t cell_748;
      cell_748 = assq___r4_pairs_and_lists_6_3((obj_t) (generic_16), __intern_generic__171_object_inline);
      {
	 obj_t num_749;
	 {
	    obj_t aux_1641;
	    aux_1641 = CDR(cell_748);
	    num_749 = CAR(aux_1641);
	 }
	 {
	    obj_t aux_1646;
	    obj_t aux_1644;
	    {
	       long aux_1647;
	       {
		  long aux_1648;
		  aux_1648 = (long) CINT(num_749);
		  aux_1647 = (aux_1648 + ((long) 1));
	       }
	       aux_1646 = BINT(aux_1647);
	    }
	    aux_1644 = CDR(cell_748);
	    SET_CAR(aux_1644, aux_1646);
	 }
	 {
	    obj_t arg1340_752;
	    obj_t arg1342_753;
	    arg1340_752 = CDR(cell_748);
	    {
	       obj_t arg1343_754;
	       obj_t arg1345_755;
	       {
		  obj_t new_1466;
		  {
		     obj_t aux_1654;
		     aux_1654 = CNST_TABLE_REF(((long) 0));
		     new_1466 = create_struct(aux_1654, ((long) 3));
		  }
		  STRUCT_SET(new_1466, ((long) 2), num_749);
		  STRUCT_SET(new_1466, ((long) 1), body_19);
		  STRUCT_SET(new_1466, ((long) 0), args_18);
		  arg1343_754 = new_1466;
	       }
	       {
		  obj_t aux_1660;
		  aux_1660 = CDR(cell_748);
		  arg1345_755 = CDR(aux_1660);
	       }
	       arg1342_753 = MAKE_PAIR(arg1343_754, arg1345_755);
	    }
	    SET_CDR(arg1340_752, arg1342_753);
	 }
	 return (long) CINT(num_749);
      }
   }
}


obj_t 
_add_generic_method__195_object_inline(obj_t env_1583, obj_t generic_1584, obj_t type_1585, obj_t args_1586, obj_t body_1587)
{
   {
      long aux_1666;
      aux_1666 = add_generic_method__111_object_inline((global_t) (generic_1584), (type_t) (type_1585), args_1586, body_1587);
      return BINT(aux_1666);
   }
}


obj_t 
inline_methods__72_object_inline()
{
   {
      bool_t test1346_756;
      {
	 bool_t test1357_766;
	 {
	    bool_t res1844_1492;
	    res1844_1492 = CBOOL(__optim_inline_method___30_engine_param);
	    test1357_766 = res1844_1492;
	 }
	 if (test1357_766)
	   {
	      obj_t obj_1493;
	      obj_1493 = __intern_generic__171_object_inline;
	      test1346_756 = PAIRP(obj_1493);
	   }
	 else
	   {
	      test1346_756 = ((bool_t) 0);
	   }
      }
      if (test1346_756)
	{
	   {
	      obj_t list1347_757;
	      {
		 obj_t arg1350_759;
		 {
		    obj_t aux_1675;
		    aux_1675 = BCHAR(((unsigned char) '\n'));
		    arg1350_759 = MAKE_PAIR(aux_1675, BNIL);
		 }
		 list1347_757 = MAKE_PAIR(string1846_object_inline, arg1350_759);
	      }
	      verbose_tools_speek(BINT(((long) 1)), list1347_757);
	   }
	   {
	      obj_t l1291_761;
	      l1291_761 = __intern_generic__171_object_inline;
	    lname1292_762:
	      if (PAIRP(l1291_761))
		{
		   inline_method__105_object_inline(CAR(l1291_761));
		   {
		      obj_t l1291_1685;
		      l1291_1685 = CDR(l1291_761);
		      l1291_761 = l1291_1685;
		      goto lname1292_762;
		   }
		}
	      else
		{
		   ((bool_t) 1);
		}
	   }
	   return disable_method_inlining__113_object_inline();
	}
      else
	{
	   return BUNSPEC;
	}
   }
}


obj_t 
_inline_methods__227_object_inline(obj_t env_1588)
{
   return inline_methods__72_object_inline();
}


obj_t 
inline_method__105_object_inline(obj_t cell_20)
{
   {
      obj_t generic_767;
      generic_767 = CAR(cell_20);
      {
	 obj_t imethods_768;
	 {
	    obj_t aux_1690;
	    {
	       obj_t aux_1691;
	       aux_1691 = CDR(cell_20);
	       aux_1690 = CDR(aux_1691);
	    }
	    imethods_768 = reverse__39___r4_pairs_and_lists_6_3(aux_1690);
	 }
	 {
	    value_t sfun_769;
	    {
	       global_t obj_1502;
	       obj_1502 = (global_t) (generic_767);
	       sfun_769 = (((global_t) CREF(obj_1502))->value);
	    }
	    {
	       obj_t old_body_129_771;
	       {
		  sfun_t obj_1504;
		  obj_1504 = (sfun_t) (sfun_769);
		  old_body_129_771 = (((sfun_t) CREF(obj_1504))->body);
	       }
	       {
		  obj_t args_772;
		  {
		     sfun_t obj_1505;
		     obj_1505 = (sfun_t) (sfun_769);
		     args_772 = (((sfun_t) CREF(obj_1505))->args);
		  }
		  {
		     long arity_773;
		     {
			sfun_t obj_1506;
			obj_1506 = (sfun_t) (sfun_769);
			arity_773 = (((sfun_t) CREF(obj_1506))->arity);
		     }
		     {
			obj_t marg_774;
			marg_774 = CAR(args_772);
			{
			   obj_t method_775;
			   method_775 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 1)), BEOA);
			   {
			      obj_t loop_776;
			      loop_776 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 2)), BEOA);
			      {
				 obj_t super_777;
				 super_777 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 3)), BEOA);
				 {
				    obj_t aux_778;
				    aux_778 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 4)), BEOA);
				    {
				       obj_t larg_779;
				       larg_779 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 5)), BEOA);
				       {
					  obj_t largs_780;
					  {
					     obj_t aux_1719;
					     aux_1719 = CDR(args_772);
					     largs_780 = MAKE_PAIR(larg_779, aux_1719);
					  }
					  {
					     obj_t other_body_17_781;
					     {
						obj_t arg1654_985;
						obj_t arg1655_986;
						obj_t arg1656_987;
						arg1654_985 = CNST_TABLE_REF(((long) 6));
						{
						   obj_t arg1665_994;
						   arg1665_994 = CNST_TABLE_REF(((long) 7));
						   {
						      obj_t list1668_996;
						      {
							 obj_t arg1669_997;
							 arg1669_997 = MAKE_PAIR(BNIL, BNIL);
							 list1668_996 = MAKE_PAIR(method_775, arg1669_997);
						      }
						      arg1655_986 = cons__138___r4_pairs_and_lists_6_3(arg1665_994, list1668_996);
						   }
						}
						if ((arity_773 >= ((long) 0)))
						  {
						     obj_t arg1673_1000;
						     {
							obj_t arg1678_1003;
							arg1678_1003 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
							arg1673_1000 = append_2_18___r4_pairs_and_lists_6_3(args_772, arg1678_1003);
						     }
						     {
							obj_t list1674_1001;
							list1674_1001 = MAKE_PAIR(arg1673_1000, BNIL);
							arg1656_987 = cons__138___r4_pairs_and_lists_6_3(method_775, list1674_1001);
						     }
						  }
						else
						  {
						     obj_t arg1681_1006;
						     obj_t arg1682_1007;
						     arg1681_1006 = CNST_TABLE_REF(((long) 8));
						     {
							obj_t arg1689_1013;
							obj_t arg1690_1014;
							arg1689_1013 = CNST_TABLE_REF(((long) 9));
							{
							   obj_t arg1694_1017;
							   arg1694_1017 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
							   arg1690_1014 = append_2_18___r4_pairs_and_lists_6_3(args_772, arg1694_1017);
							}
							{
							   obj_t list1691_1015;
							   list1691_1015 = MAKE_PAIR(arg1690_1014, BNIL);
							   arg1682_1007 = cons__138___r4_pairs_and_lists_6_3(arg1689_1013, list1691_1015);
							}
						     }
						     {
							obj_t list1685_1009;
							{
							   obj_t arg1686_1010;
							   {
							      obj_t arg1687_1011;
							      arg1687_1011 = MAKE_PAIR(BNIL, BNIL);
							      arg1686_1010 = MAKE_PAIR(arg1682_1007, arg1687_1011);
							   }
							   list1685_1009 = MAKE_PAIR(method_775, arg1686_1010);
							}
							arg1656_987 = cons__138___r4_pairs_and_lists_6_3(arg1681_1006, list1685_1009);
						     }
						  }
						{
						   obj_t list1658_989;
						   {
						      obj_t arg1659_990;
						      {
							 obj_t arg1661_991;
							 {
							    obj_t arg1663_992;
							    arg1663_992 = MAKE_PAIR(BNIL, BNIL);
							    arg1661_991 = MAKE_PAIR(old_body_129_771, arg1663_992);
							 }
							 arg1659_990 = MAKE_PAIR(arg1656_987, arg1661_991);
						      }
						      list1658_989 = MAKE_PAIR(arg1655_986, arg1659_990);
						   }
						   other_body_17_781 = cons__138___r4_pairs_and_lists_6_3(arg1654_985, list1658_989);
						}
					     }
					     {
						obj_t class_782;
						class_782 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 10)), BEOA);
						{
						   {
						      obj_t new_body_215_783;
						      {
							 obj_t arg1363_787;
							 {
							    obj_t arg1364_788;
							    obj_t arg1366_789;
							    obj_t arg1367_790;
							    arg1364_788 = CNST_TABLE_REF(((long) 11));
							    {
							       obj_t arg1380_796;
							       {
								  obj_t arg1388_800;
								  {
								     obj_t arg1400_805;
								     obj_t arg1402_806;
								     obj_t arg1403_807;
								     arg1400_805 = CNST_TABLE_REF(((long) 12));
								     {
									obj_t list1412_814;
									{
									   obj_t arg1414_815;
									   arg1414_815 = MAKE_PAIR(BNIL, BNIL);
									   list1412_814 = MAKE_PAIR(class_782, arg1414_815);
									}
									arg1402_806 = cons__138___r4_pairs_and_lists_6_3(method_775, list1412_814);
								     }
								     {
									obj_t arg1416_817;
									obj_t arg1417_818;
									obj_t arg1418_819;
									arg1416_817 = CNST_TABLE_REF(((long) 13));
									{
									   obj_t arg1428_825;
									   {
									      obj_t arg1441_829;
									      obj_t arg1444_830;
									      arg1441_829 = CNST_TABLE_REF(((long) 14));
									      {
										 obj_t arg1449_835;
										 obj_t arg1452_837;
										 arg1449_835 = CNST_TABLE_REF(((long) 12));
										 {
										    obj_t arg1463_843;
										    obj_t arg1465_844;
										    obj_t arg1466_845;
										    arg1463_843 = CNST_TABLE_REF(((long) 15));
										    {
										       obj_t arg1474_851;
										       obj_t arg1476_852;
										       {
											  obj_t arg1484_857;
											  {
											     obj_t arg1490_862;
											     obj_t arg1493_863;
											     obj_t arg1494_864;
											     arg1490_862 = CNST_TABLE_REF(((long) 6));
											     {
												obj_t arg1505_871;
												arg1505_871 = CNST_TABLE_REF(((long) 16));
												{
												   obj_t list1507_873;
												   {
												      obj_t arg1509_874;
												      arg1509_874 = MAKE_PAIR(BNIL, BNIL);
												      list1507_873 = MAKE_PAIR(class_782, arg1509_874);
												   }
												   arg1493_863 = cons__138___r4_pairs_and_lists_6_3(arg1505_871, list1507_873);
												}
											     }
											     {
												obj_t arg1511_876;
												arg1511_876 = CNST_TABLE_REF(((long) 17));
												{
												   obj_t list1514_878;
												   {
												      obj_t arg1517_879;
												      arg1517_879 = MAKE_PAIR(BNIL, BNIL);
												      list1514_878 = MAKE_PAIR(class_782, arg1517_879);
												   }
												   arg1494_864 = cons__138___r4_pairs_and_lists_6_3(arg1511_876, list1514_878);
												}
											     }
											     {
												obj_t list1497_866;
												{
												   obj_t arg1498_867;
												   {
												      obj_t arg1499_868;
												      {
													 obj_t arg1500_869;
													 arg1500_869 = MAKE_PAIR(BNIL, BNIL);
													 arg1499_868 = MAKE_PAIR(BFALSE, arg1500_869);
												      }
												      arg1498_867 = MAKE_PAIR(arg1494_864, arg1499_868);
												   }
												   list1497_866 = MAKE_PAIR(arg1493_863, arg1498_867);
												}
												arg1484_857 = cons__138___r4_pairs_and_lists_6_3(arg1490_862, list1497_866);
											     }
											  }
											  {
											     obj_t list1486_859;
											     {
												obj_t arg1487_860;
												arg1487_860 = MAKE_PAIR(BNIL, BNIL);
												list1486_859 = MAKE_PAIR(arg1484_857, arg1487_860);
											     }
											     arg1474_851 = cons__138___r4_pairs_and_lists_6_3(super_777, list1486_859);
											  }
										       }
										       {
											  obj_t arg1520_881;
											  {
											     obj_t arg1529_886;
											     arg1529_886 = CNST_TABLE_REF(((long) 18));
											     {
												obj_t list1532_888;
												{
												   obj_t arg1534_889;
												   {
												      obj_t arg1535_890;
												      {
													 obj_t arg1536_891;
													 arg1536_891 = MAKE_PAIR(BNIL, BNIL);
													 arg1535_890 = MAKE_PAIR(super_777, arg1536_891);
												      }
												      arg1534_889 = MAKE_PAIR(generic_767, arg1535_890);
												   }
												   list1532_888 = MAKE_PAIR(marg_774, arg1534_889);
												}
												arg1520_881 = cons__138___r4_pairs_and_lists_6_3(arg1529_886, list1532_888);
											     }
											  }
											  {
											     obj_t list1523_883;
											     {
												obj_t arg1524_884;
												arg1524_884 = MAKE_PAIR(BNIL, BNIL);
												list1523_883 = MAKE_PAIR(arg1520_881, arg1524_884);
											     }
											     arg1476_852 = cons__138___r4_pairs_and_lists_6_3(aux_778, list1523_883);
											  }
										       }
										       {
											  obj_t list1478_854;
											  {
											     obj_t arg1480_855;
											     arg1480_855 = MAKE_PAIR(BNIL, BNIL);
											     list1478_854 = MAKE_PAIR(arg1476_852, arg1480_855);
											  }
											  arg1465_844 = cons__138___r4_pairs_and_lists_6_3(arg1474_851, list1478_854);
										       }
										    }
										    {
										       obj_t arg1538_893;
										       obj_t arg1539_894;
										       {
											  obj_t arg1549_900;
											  arg1549_900 = CNST_TABLE_REF(((long) 19));
											  {
											     obj_t list1551_902;
											     {
												obj_t arg1552_903;
												arg1552_903 = MAKE_PAIR(BNIL, BNIL);
												list1551_902 = MAKE_PAIR(aux_778, arg1552_903);
											     }
											     arg1538_893 = cons__138___r4_pairs_and_lists_6_3(arg1549_900, list1551_902);
											  }
										       }
										       {
											  obj_t arg1554_905;
											  arg1554_905 = CNST_TABLE_REF(((long) 20));
											  {
											     obj_t list1556_907;
											     {
												obj_t arg1557_908;
												arg1557_908 = MAKE_PAIR(BNIL, BNIL);
												list1556_907 = MAKE_PAIR(aux_778, arg1557_908);
											     }
											     arg1539_894 = cons__138___r4_pairs_and_lists_6_3(arg1554_905, list1556_907);
											  }
										       }
										       {
											  obj_t list1541_896;
											  {
											     obj_t arg1542_897;
											     {
												obj_t arg1543_898;
												arg1543_898 = MAKE_PAIR(BNIL, BNIL);
												arg1542_897 = MAKE_PAIR(arg1539_894, arg1543_898);
											     }
											     list1541_896 = MAKE_PAIR(arg1538_893, arg1542_897);
											  }
											  arg1466_845 = cons__138___r4_pairs_and_lists_6_3(loop_776, list1541_896);
										       }
										    }
										    {
										       obj_t list1468_847;
										       {
											  obj_t arg1470_848;
											  {
											     obj_t arg1471_849;
											     arg1471_849 = MAKE_PAIR(BNIL, BNIL);
											     arg1470_848 = MAKE_PAIR(arg1466_845, arg1471_849);
											  }
											  list1468_847 = MAKE_PAIR(arg1465_844, arg1470_848);
										       }
										       arg1452_837 = cons__138___r4_pairs_and_lists_6_3(arg1463_843, list1468_847);
										    }
										 }
										 {
										    obj_t list1454_839;
										    {
										       obj_t arg1457_840;
										       {
											  obj_t arg1458_841;
											  arg1458_841 = MAKE_PAIR(BNIL, BNIL);
											  arg1457_840 = MAKE_PAIR(arg1452_837, arg1458_841);
										       }
										       list1454_839 = MAKE_PAIR(BNIL, arg1457_840);
										    }
										    arg1444_830 = cons__138___r4_pairs_and_lists_6_3(arg1449_835, list1454_839);
										 }
									      }
									      {
										 obj_t list1446_832;
										 {
										    obj_t arg1447_833;
										    arg1447_833 = MAKE_PAIR(BNIL, BNIL);
										    list1446_832 = MAKE_PAIR(arg1444_830, arg1447_833);
										 }
										 arg1428_825 = cons__138___r4_pairs_and_lists_6_3(arg1441_829, list1446_832);
									      }
									   }
									   {
									      obj_t list1432_827;
									      list1432_827 = MAKE_PAIR(BNIL, BNIL);
									      arg1417_818 = cons__138___r4_pairs_and_lists_6_3(arg1428_825, list1432_827);
									   }
									}
									{
									   obj_t arg1560_910;
									   obj_t arg1561_911;
									   arg1560_910 = CNST_TABLE_REF(((long) 21));
									   {
									      obj_t arg1565_915;
									      obj_t arg1566_916;
									      arg1565_915 = make_case_clauses_101_object_inline(args_772, imethods_768);
									      {
										 obj_t arg1567_917;
										 {
										    obj_t arg1571_921;
										    arg1571_921 = CNST_TABLE_REF(((long) 22));
										    {
										       obj_t list1573_923;
										       {
											  obj_t arg1574_924;
											  arg1574_924 = MAKE_PAIR(BNIL, BNIL);
											  list1573_923 = MAKE_PAIR(other_body_17_781, arg1574_924);
										       }
										       arg1567_917 = cons__138___r4_pairs_and_lists_6_3(arg1571_921, list1573_923);
										    }
										 }
										 {
										    obj_t list1569_919;
										    list1569_919 = MAKE_PAIR(BNIL, BNIL);
										    arg1566_916 = cons__138___r4_pairs_and_lists_6_3(arg1567_917, list1569_919);
										 }
									      }
									      arg1561_911 = append_2_18___r4_pairs_and_lists_6_3(arg1565_915, arg1566_916);
									   }
									   {
									      obj_t list1562_912;
									      {
										 obj_t arg1563_913;
										 arg1563_913 = MAKE_PAIR(arg1561_911, BNIL);
										 list1562_912 = MAKE_PAIR(method_775, arg1563_913);
									      }
									      arg1418_819 = cons__138___r4_pairs_and_lists_6_3(arg1560_910, list1562_912);
									   }
									}
									{
									   obj_t list1421_821;
									   {
									      obj_t arg1424_822;
									      {
										 obj_t arg1426_823;
										 arg1426_823 = MAKE_PAIR(BNIL, BNIL);
										 arg1424_822 = MAKE_PAIR(arg1418_819, arg1426_823);
									      }
									      list1421_821 = MAKE_PAIR(arg1417_818, arg1424_822);
									   }
									   arg1403_807 = cons__138___r4_pairs_and_lists_6_3(arg1416_817, list1421_821);
									}
								     }
								     {
									obj_t list1405_809;
									{
									   obj_t arg1406_810;
									   {
									      obj_t arg1408_811;
									      arg1408_811 = MAKE_PAIR(BNIL, BNIL);
									      arg1406_810 = MAKE_PAIR(arg1403_807, arg1408_811);
									   }
									   list1405_809 = MAKE_PAIR(arg1402_806, arg1406_810);
									}
									arg1388_800 = cons__138___r4_pairs_and_lists_6_3(arg1400_805, list1405_809);
								     }
								  }
								  {
								     obj_t list1391_802;
								     {
									obj_t arg1396_803;
									arg1396_803 = MAKE_PAIR(BNIL, BNIL);
									list1391_802 = MAKE_PAIR(arg1388_800, arg1396_803);
								     }
								     arg1380_796 = cons__138___r4_pairs_and_lists_6_3(loop_776, list1391_802);
								  }
							       }
							       {
								  obj_t list1382_798;
								  list1382_798 = MAKE_PAIR(BNIL, BNIL);
								  arg1366_789 = cons__138___r4_pairs_and_lists_6_3(arg1380_796, list1382_798);
							       }
							    }
							    {
							       bool_t test1576_926;
							       {
								  obj_t aux_1839;
								  {
								     type_t aux_1840;
								     {
									local_t obj_1513;
									obj_1513 = (local_t) (marg_774);
									aux_1840 = (((local_t) CREF(obj_1513))->type);
								     }
								     aux_1839 = (obj_t) (aux_1840);
								  }
								  test1576_926 = is_a__118___object(aux_1839, class_object_class);
							       }
							       if (test1576_926)
								 {
								    obj_t arg1577_927;
								    obj_t arg1578_928;
								    {
								       obj_t arg1585_934;
								       arg1585_934 = CNST_TABLE_REF(((long) 23));
								       {
									  obj_t list1588_936;
									  {
									     obj_t arg1589_937;
									     {
										obj_t arg1590_938;
										arg1590_938 = MAKE_PAIR(BNIL, BNIL);
										arg1589_937 = MAKE_PAIR(generic_767, arg1590_938);
									     }
									     list1588_936 = MAKE_PAIR(marg_774, arg1589_937);
									  }
									  arg1577_927 = cons__138___r4_pairs_and_lists_6_3(arg1585_934, list1588_936);
								       }
								    }
								    {
								       obj_t arg1592_940;
								       arg1592_940 = CNST_TABLE_REF(((long) 24));
								       {
									  obj_t list1594_942;
									  {
									     obj_t arg1595_943;
									     arg1595_943 = MAKE_PAIR(BNIL, BNIL);
									     list1594_942 = MAKE_PAIR(marg_774, arg1595_943);
									  }
									  arg1578_928 = cons__138___r4_pairs_and_lists_6_3(arg1592_940, list1594_942);
								       }
								    }
								    {
								       obj_t list1580_930;
								       {
									  obj_t arg1582_931;
									  {
									     obj_t arg1583_932;
									     arg1583_932 = MAKE_PAIR(BNIL, BNIL);
									     arg1582_931 = MAKE_PAIR(arg1578_928, arg1583_932);
									  }
									  list1580_930 = MAKE_PAIR(arg1577_927, arg1582_931);
								       }
								       arg1367_790 = cons__138___r4_pairs_and_lists_6_3(loop_776, list1580_930);
								    }
								 }
							       else
								 {
								    obj_t arg1597_945;
								    obj_t arg1600_946;
								    obj_t arg1601_947;
								    obj_t arg1603_948;
								    arg1597_945 = CNST_TABLE_REF(((long) 6));
								    {
								       obj_t arg1614_955;
								       arg1614_955 = CNST_TABLE_REF(((long) 25));
								       {
									  obj_t list1617_957;
									  {
									     obj_t arg1618_958;
									     arg1618_958 = MAKE_PAIR(BNIL, BNIL);
									     list1617_957 = MAKE_PAIR(marg_774, arg1618_958);
									  }
									  arg1600_946 = cons__138___r4_pairs_and_lists_6_3(arg1614_955, list1617_957);
								       }
								    }
								    {
								       obj_t arg1620_960;
								       obj_t arg1621_961;
								       {
									  obj_t arg1630_967;
									  arg1630_967 = CNST_TABLE_REF(((long) 23));
									  {
									     obj_t list1633_969;
									     {
										obj_t arg1634_970;
										{
										   obj_t arg1637_971;
										   arg1637_971 = MAKE_PAIR(BNIL, BNIL);
										   arg1634_970 = MAKE_PAIR(generic_767, arg1637_971);
										}
										list1633_969 = MAKE_PAIR(marg_774, arg1634_970);
									     }
									     arg1620_960 = cons__138___r4_pairs_and_lists_6_3(arg1630_967, list1633_969);
									  }
								       }
								       {
									  obj_t arg1641_973;
									  arg1641_973 = CNST_TABLE_REF(((long) 24));
									  {
									     obj_t list1643_975;
									     {
										obj_t arg1644_976;
										arg1644_976 = MAKE_PAIR(BNIL, BNIL);
										list1643_975 = MAKE_PAIR(marg_774, arg1644_976);
									     }
									     arg1621_961 = cons__138___r4_pairs_and_lists_6_3(arg1641_973, list1643_975);
									  }
								       }
								       {
									  obj_t list1624_963;
									  {
									     obj_t arg1626_964;
									     {
										obj_t arg1627_965;
										arg1627_965 = MAKE_PAIR(BNIL, BNIL);
										arg1626_964 = MAKE_PAIR(arg1621_961, arg1627_965);
									     }
									     list1624_963 = MAKE_PAIR(arg1620_960, arg1626_964);
									  }
									  arg1601_947 = cons__138___r4_pairs_and_lists_6_3(loop_776, list1624_963);
								       }
								    }
								    {
								       obj_t list1647_979;
								       {
									  obj_t arg1648_980;
									  {
									     obj_t arg1650_981;
									     arg1650_981 = MAKE_PAIR(BNIL, BNIL);
									     arg1648_980 = MAKE_PAIR(BFALSE, arg1650_981);
									  }
									  list1647_979 = MAKE_PAIR(BFALSE, arg1648_980);
								       }
								       arg1603_948 = cons__138___r4_pairs_and_lists_6_3(loop_776, list1647_979);
								    }
								    {
								       obj_t list1605_950;
								       {
									  obj_t arg1606_951;
									  {
									     obj_t arg1608_952;
									     {
										obj_t arg1609_953;
										arg1609_953 = MAKE_PAIR(BNIL, BNIL);
										arg1608_952 = MAKE_PAIR(arg1603_948, arg1609_953);
									     }
									     arg1606_951 = MAKE_PAIR(arg1601_947, arg1608_952);
									  }
									  list1605_950 = MAKE_PAIR(arg1600_946, arg1606_951);
								       }
								       arg1367_790 = cons__138___r4_pairs_and_lists_6_3(arg1597_945, list1605_950);
								    }
								 }
							    }
							    {
							       obj_t list1370_792;
							       {
								  obj_t arg1372_793;
								  {
								     obj_t arg1376_794;
								     arg1376_794 = MAKE_PAIR(BNIL, BNIL);
								     arg1372_793 = MAKE_PAIR(arg1367_790, arg1376_794);
								  }
								  list1370_792 = MAKE_PAIR(arg1366_789, arg1372_793);
							       }
							       arg1363_787 = cons__138___r4_pairs_and_lists_6_3(arg1364_788, list1370_792);
							    }
							 }
							 new_body_215_783 = comptime_expand_37_expand_eps(arg1363_787);
						      }
						      {
							 node_t arg1358_784;
							 {
							    obj_t aux_1891;
							    {
							       node_t obj_1515;
							       obj_1515 = (node_t) (old_body_129_771);
							       aux_1891 = (((node_t) CREF(obj_1515))->loc);
							    }
							    arg1358_784 = sexp__node_235_ast_sexp(new_body_215_783, args_772, aux_1891, CNST_TABLE_REF(((long) 26)));
							 }
							 {
							    obj_t res1845_1518;
							    {
							       sfun_t obj_1516;
							       obj_t val1078_1517;
							       obj_1516 = (sfun_t) (sfun_769);
							       val1078_1517 = (obj_t) (arg1358_784);
							       {
								  obj_t x_1590;
								  x_1590 = ((((sfun_t) CREF(obj_1516))->body) = ((obj_t) val1078_1517), BUNSPEC);
								  res1845_1518 = BUNSPEC;
							       }
							    }
							    return res1845_1518;
							 }
						      }
						   }
						}
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
make_case_clauses_101_object_inline(obj_t args_21, obj_t imethods_22)
{
   if (NULLP(imethods_22))
     {
	return BNIL;
     }
   else
     {
	obj_t head1295_1029;
	head1295_1029 = MAKE_PAIR(BNIL, BNIL);
	{
	   obj_t l1293_1030;
	   obj_t tail1296_1031;
	   l1293_1030 = imethods_22;
	   tail1296_1031 = head1295_1029;
	 lname1294_1032:
	   if (NULLP(l1293_1030))
	     {
		return CDR(head1295_1029);
	     }
	   else
	     {
		obj_t new_tail1297_27_1034;
		{
		   obj_t arg1708_1036;
		   arg1708_1036 = inline_method_clause_150_object_inline(args_21, CAR(l1293_1030));
		   new_tail1297_27_1034 = MAKE_PAIR(arg1708_1036, BNIL);
		}
		SET_CDR(tail1296_1031, new_tail1297_27_1034);
		{
		   obj_t tail1296_1911;
		   obj_t l1293_1909;
		   l1293_1909 = CDR(l1293_1030);
		   tail1296_1911 = new_tail1297_27_1034;
		   tail1296_1031 = tail1296_1911;
		   l1293_1030 = l1293_1909;
		   goto lname1294_1032;
		}
	     }
	}
     }
}


obj_t 
inline_method_clause_150_object_inline(obj_t generic_args_72_23, obj_t imethod_24)
{
   {
      obj_t num_1042;
      obj_t body_1043;
      num_1042 = STRUCT_REF(imethod_24, ((long) 2));
      body_1043 = STRUCT_REF(imethod_24, ((long) 1));
      {
	 obj_t arg1712_1044;
	 obj_t arg1714_1045;
	 {
	    obj_t list1720_1051;
	    list1720_1051 = MAKE_PAIR(BNIL, BNIL);
	    arg1712_1044 = cons__138___r4_pairs_and_lists_6_3(num_1042, list1720_1051);
	 }
	 {
	    obj_t arg1722_1053;
	    obj_t arg1724_1054;
	    arg1722_1053 = CNST_TABLE_REF(((long) 13));
	    {
	       obj_t ll1298_1060;
	       ll1298_1060 = args___args_list_50_tools_args(STRUCT_REF(imethod_24, ((long) 0)));
	       if (NULLP(ll1298_1060))
		 {
		    arg1724_1054 = BNIL;
		 }
	       else
		 {
		    obj_t head1300_1063;
		    {
		       obj_t arg1747_1081;
		       {
			  obj_t arg1749_1083;
			  arg1749_1083 = CAR(ll1298_1060);
			  {
			     obj_t list1752_1085;
			     {
				obj_t arg1753_1086;
				{
				   obj_t aux_1922;
				   aux_1922 = CAR(generic_args_72_23);
				   arg1753_1086 = MAKE_PAIR(aux_1922, BNIL);
				}
				list1752_1085 = MAKE_PAIR(arg1749_1083, arg1753_1086);
			     }
			     arg1747_1081 = list1752_1085;
			  }
		       }
		       head1300_1063 = MAKE_PAIR(arg1747_1081, BNIL);
		    }
		    {
		       obj_t ll1298_1064;
		       obj_t ll1299_1065;
		       obj_t tail1301_1066;
		       ll1298_1064 = CDR(ll1298_1060);
		       ll1299_1065 = CDR(generic_args_72_23);
		       tail1301_1066 = head1300_1063;
		     lname1304_1067:
		       if (NULLP(ll1298_1064))
			 {
			    arg1724_1054 = head1300_1063;
			 }
		       else
			 {
			    obj_t new_tail1302_132_1071;
			    {
			       obj_t arg1740_1074;
			       {
				  obj_t arg1742_1076;
				  arg1742_1076 = CAR(ll1298_1064);
				  {
				     obj_t list1744_1078;
				     {
					obj_t arg1745_1079;
					{
					   obj_t aux_1930;
					   aux_1930 = CAR(ll1299_1065);
					   arg1745_1079 = MAKE_PAIR(aux_1930, BNIL);
					}
					list1744_1078 = MAKE_PAIR(arg1742_1076, arg1745_1079);
				     }
				     arg1740_1074 = list1744_1078;
				  }
			       }
			       new_tail1302_132_1071 = MAKE_PAIR(arg1740_1074, BNIL);
			    }
			    SET_CDR(tail1301_1066, new_tail1302_132_1071);
			    {
			       obj_t tail1301_1940;
			       obj_t ll1299_1938;
			       obj_t ll1298_1936;
			       ll1298_1936 = CDR(ll1298_1064);
			       ll1299_1938 = CDR(ll1299_1065);
			       tail1301_1940 = new_tail1302_132_1071;
			       tail1301_1066 = tail1301_1940;
			       ll1299_1065 = ll1299_1938;
			       ll1298_1064 = ll1298_1936;
			       goto lname1304_1067;
			    }
			 }
		    }
		 }
	    }
	    {
	       obj_t list1726_1056;
	       {
		  obj_t arg1730_1057;
		  {
		     obj_t arg1731_1058;
		     arg1731_1058 = MAKE_PAIR(BNIL, BNIL);
		     arg1730_1057 = MAKE_PAIR(body_1043, arg1731_1058);
		  }
		  list1726_1056 = MAKE_PAIR(arg1724_1054, arg1730_1057);
	       }
	       arg1714_1045 = cons__138___r4_pairs_and_lists_6_3(arg1722_1053, list1726_1056);
	    }
	 }
	 {
	    obj_t list1716_1047;
	    {
	       obj_t arg1717_1048;
	       arg1717_1048 = MAKE_PAIR(BNIL, BNIL);
	       list1716_1047 = MAKE_PAIR(arg1714_1045, arg1717_1048);
	    }
	    return cons__138___r4_pairs_and_lists_6_3(arg1712_1044, list1716_1047);
	 }
      }
   }
}


obj_t 
imported_modules_init_94_object_inline()
{
   module_initialization_70_tools_trace(((long) 0), "OBJECT_INLINE");
   module_initialization_70_engine_param(((long) 0), "OBJECT_INLINE");
   module_initialization_70_tools_shape(((long) 0), "OBJECT_INLINE");
   module_initialization_70_tools_speek(((long) 0), "OBJECT_INLINE");
   module_initialization_70_tools_args(((long) 0), "OBJECT_INLINE");
   module_initialization_70_type_type(((long) 0), "OBJECT_INLINE");
   module_initialization_70_expand_eps(((long) 0), "OBJECT_INLINE");
   module_initialization_70_ast_var(((long) 0), "OBJECT_INLINE");
   module_initialization_70_ast_node(((long) 0), "OBJECT_INLINE");
   module_initialization_70_ast_sexp(((long) 0), "OBJECT_INLINE");
   return module_initialization_70_object_class(((long) 0), "OBJECT_INLINE");
}
