/*===========================================================================*/
/*   (Object/method.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;


extern long add_generic_method__111_object_inline(global_t, type_t, obj_t, obj_t);
extern obj_t _make_method_body_16_object_method(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern obj_t class_object_class;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_object_method();
extern obj_t module_initialization_70_object_method(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_object_inline(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t cnst_init_137_object_method();
extern bool_t method_inlining_enabled__91_object_inline();
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t require_initialization_114_object_method = BUNSPEC;
static obj_t library_modules_init_112_object_method();
static obj_t method_error_85_object_method(obj_t, char *, obj_t);
extern obj_t add_generic_for_method_inlining__147_object_inline(obj_t);
extern obj_t read___reader(obj_t);
extern obj_t id_of_id_112_ast_ident(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern int arity_tools_args(obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern obj_t make_method_body_103_object_method(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[17];

DEFINE_STRING(string1514_object_method, string1514_object_method1522, "(QUOTE METHOD-DEFINITION-ERROR) ADD-INLINED-METHOD! ADD-METHOD! GENERIC-PRE-METHOD-SET! BEGIN CONS* APPLY PROCEDURE? IF @ FIND-SUPER-CLASS-METHOD LET CALL-NEXT-METHOD LABELS IMPORT - NEXT-METHOD ", 195);
DEFINE_EXPORT_PROCEDURE(make_method_body_env_21_object_method, _make_method_body_16_object_method1523, _make_method_body_16_object_method, 0L, 5);

obj_t 
module_initialization_70_object_method(long checksum_787, char *from_788)
{
   if (CBOOL(require_initialization_114_object_method))
     {
	require_initialization_114_object_method = BBOOL(((bool_t) 0));
	library_modules_init_112_object_method();
	cnst_init_137_object_method();
	imported_modules_init_94_object_method();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_object_method()
{
   module_initialization_70___object(((long) 0), "OBJECT_METHOD");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_METHOD");
   module_initialization_70___reader(((long) 0), "OBJECT_METHOD");
   module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_METHOD");
   return BUNSPEC;
}


obj_t 
cnst_init_137_object_method()
{
   {
      obj_t cnst_port_138_779;
      cnst_port_138_779 = open_input_string(string1514_object_method);
      {
	 long i_780;
	 i_780 = ((long) 16);
       loop_781:
	 {
	    bool_t test1515_782;
	    test1515_782 = (i_780 == ((long) -1));
	    if (test1515_782)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1517_783;
		    {
		       obj_t list1518_784;
		       {
			  obj_t arg1520_785;
			  arg1520_785 = BNIL;
			  list1518_784 = MAKE_PAIR(cnst_port_138_779, arg1520_785);
		       }
		       arg1517_783 = read___reader(list1518_784);
		    }
		    CNST_TABLE_SET(i_780, arg1517_783);
		 }
		 {
		    int aux_786;
		    {
		       long aux_805;
		       aux_805 = (i_780 - ((long) 1));
		       aux_786 = (int) (aux_805);
		    }
		    {
		       long i_808;
		       i_808 = (long) (aux_786);
		       i_780 = i_808;
		       goto loop_781;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
make_method_body_103_object_method(obj_t id_1, obj_t args_2, obj_t locals_3, obj_t body_4, obj_t src_5)
{
   {
      obj_t id_356;
      id_356 = id_of_id_112_ast_ident(id_1);
      {
	 obj_t method_357;
	 method_357 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 0)), BEOA);
	 {
	    int arity_358;
	    arity_358 = arity_tools_args(args_2);
	    {
	       obj_t args_id_103_359;
	       if (NULLP(locals_3))
		 {
		    args_id_103_359 = BNIL;
		 }
	       else
		 {
		    obj_t head1133_559;
		    {
		       obj_t aux_817;
		       {
			  local_t obj_717;
			  {
			     obj_t aux_818;
			     aux_818 = CAR(locals_3);
			     obj_717 = (local_t) (aux_818);
			  }
			  aux_817 = (((local_t) CREF(obj_717))->id);
		       }
		       head1133_559 = MAKE_PAIR(aux_817, BNIL);
		    }
		    {
		       obj_t l1130_560;
		       obj_t tail1134_561;
		       l1130_560 = CDR(locals_3);
		       tail1134_561 = head1133_559;
		     lname1132_562:
		       if (NULLP(l1130_560))
			 {
			    args_id_103_359 = head1133_559;
			 }
		       else
			 {
			    obj_t new_tail1135_226_565;
			    {
			       obj_t aux_825;
			       {
				  local_t obj_723;
				  {
				     obj_t aux_826;
				     aux_826 = CAR(l1130_560);
				     obj_723 = (local_t) (aux_826);
				  }
				  aux_825 = (((local_t) CREF(obj_723))->id);
			       }
			       new_tail1135_226_565 = MAKE_PAIR(aux_825, BNIL);
			    }
			    SET_CDR(tail1134_561, new_tail1135_226_565);
			    {
			       obj_t tail1134_834;
			       obj_t l1130_832;
			       l1130_832 = CDR(l1130_560);
			       tail1134_834 = new_tail1135_226_565;
			       tail1134_561 = tail1134_834;
			       l1130_560 = l1130_832;
			       goto lname1132_562;
			    }
			 }
		    }
		 }
	       {
		  type_t type_360;
		  {
		     local_t obj_730;
		     {
			obj_t aux_836;
			aux_836 = CAR(locals_3);
			obj_730 = (local_t) (aux_836);
		     }
		     type_360 = (((local_t) CREF(obj_730))->type);
		  }
		  {
		     obj_t m_id_75_361;
		     {
			obj_t arg1440_550;
			arg1440_550 = CNST_TABLE_REF(((long) 1));
			{
			   obj_t list1442_552;
			   {
			      obj_t arg1444_553;
			      {
				 obj_t arg1445_554;
				 {
				    obj_t aux_841;
				    aux_841 = (((type_t) CREF(type_360))->id);
				    arg1445_554 = MAKE_PAIR(aux_841, BNIL);
				 }
				 arg1444_553 = MAKE_PAIR(arg1440_550, arg1445_554);
			      }
			      list1442_552 = MAKE_PAIR(id_356, arg1444_553);
			   }
			   m_id_75_361 = symbol_append_197___r4_symbols_6_4(list1442_552);
			}
		     }
		     {
			{
			   bool_t test1136_362;
			   test1136_362 = is_a__118___object((obj_t) (type_360), class_object_class);
			   if (test1136_362)
			     {
				global_t holder_363;
				{
				   class_t obj_733;
				   obj_733 = (class_t) (type_360);
				   {
				      obj_t aux_851;
				      {
					 object_t aux_852;
					 aux_852 = (object_t) (obj_733);
					 aux_851 = OBJECT_WIDENING(aux_852);
				      }
				      holder_363 = (((class_t) CREF(aux_851))->holder);
				   }
				}
				{
				   obj_t module_364;
				   module_364 = (((global_t) CREF(holder_363))->module);
				   {
				      obj_t generic_365;
				      generic_365 = find_global_223_ast_env(id_356, BNIL);
				      {
					 {
					    bool_t test1137_366;
					    test1137_366 = is_a__118___object(generic_365, global_ast_var);
					    if (test1137_366)
					      {
						 bool_t test1138_367;
						 {
						    bool_t test1428_546;
						    test1428_546 = method_inlining_enabled__91_object_inline();
						    if (test1428_546)
						      {
							 obj_t aux_865;
							 obj_t aux_862;
							 aux_865 = CNST_TABLE_REF(((long) 2));
							 {
							    global_t obj_736;
							    obj_736 = (global_t) (generic_365);
							    aux_862 = (((global_t) CREF(obj_736))->import);
							 }
							 test1138_367 = (aux_862 == aux_865);
						      }
						    else
						      {
							 test1138_367 = ((bool_t) 1);
						      }
						 }
						 if (test1138_367)
						   {
						      {
							 obj_t arg1144_368;
							 {
							    obj_t arg1149_371;
							    obj_t arg1153_372;
							    obj_t arg1154_373;
							    arg1149_371 = CNST_TABLE_REF(((long) 3));
							    {
							       obj_t arg1182_379;
							       {
								  obj_t arg1199_383;
								  {
								     obj_t arg1207_389;
								     obj_t arg1208_390;
								     arg1207_389 = CNST_TABLE_REF(((long) 3));
								     {
									obj_t arg1217_396;
									{
									   obj_t arg1225_400;
									   obj_t arg1229_402;
									   arg1225_400 = CNST_TABLE_REF(((long) 4));
									   {
									      obj_t arg1236_408;
									      obj_t arg1237_409;
									      obj_t arg1239_410;
									      arg1236_408 = CNST_TABLE_REF(((long) 5));
									      {
										 obj_t arg1247_416;
										 {
										    obj_t arg1252_420;
										    {
										       obj_t arg1260_425;
										       obj_t arg1261_426;
										       obj_t arg1265_427;
										       arg1260_425 = CNST_TABLE_REF(((long) 6));
										       arg1261_426 = CAR(args_id_103_359);
										       {
											  obj_t arg1273_434;
											  obj_t arg1275_435;
											  arg1273_434 = CNST_TABLE_REF(((long) 7));
											  arg1275_435 = (((global_t) CREF(holder_363))->id);
											  {
											     obj_t list1277_437;
											     {
												obj_t arg1278_438;
												{
												   obj_t arg1279_439;
												   arg1279_439 = MAKE_PAIR(BNIL, BNIL);
												   arg1278_438 = MAKE_PAIR(module_364, arg1279_439);
												}
												list1277_437 = MAKE_PAIR(arg1275_435, arg1278_438);
											     }
											     arg1265_427 = cons__138___r4_pairs_and_lists_6_3(arg1273_434, list1277_437);
											  }
										       }
										       {
											  obj_t list1267_429;
											  {
											     obj_t arg1268_430;
											     {
												obj_t arg1270_431;
												{
												   obj_t arg1271_432;
												   arg1271_432 = MAKE_PAIR(BNIL, BNIL);
												   arg1270_431 = MAKE_PAIR(arg1265_427, arg1271_432);
												}
												arg1268_430 = MAKE_PAIR(id_356, arg1270_431);
											     }
											     list1267_429 = MAKE_PAIR(arg1261_426, arg1268_430);
											  }
											  arg1252_420 = cons__138___r4_pairs_and_lists_6_3(arg1260_425, list1267_429);
										       }
										    }
										    {
										       obj_t list1256_422;
										       {
											  obj_t arg1257_423;
											  arg1257_423 = MAKE_PAIR(BNIL, BNIL);
											  list1256_422 = MAKE_PAIR(arg1252_420, arg1257_423);
										       }
										       arg1247_416 = cons__138___r4_pairs_and_lists_6_3(method_357, list1256_422);
										    }
										 }
										 {
										    obj_t list1249_418;
										    list1249_418 = MAKE_PAIR(BNIL, BNIL);
										    arg1237_409 = cons__138___r4_pairs_and_lists_6_3(arg1247_416, list1249_418);
										 }
									      }
									      {
										 obj_t arg1282_441;
										 obj_t arg1283_442;
										 obj_t arg1284_443;
										 obj_t arg1286_444;
										 arg1282_441 = CNST_TABLE_REF(((long) 8));
										 {
										    obj_t arg1297_451;
										    arg1297_451 = CNST_TABLE_REF(((long) 9));
										    {
										       obj_t list1299_453;
										       {
											  obj_t arg1300_454;
											  arg1300_454 = MAKE_PAIR(BNIL, BNIL);
											  list1299_453 = MAKE_PAIR(method_357, arg1300_454);
										       }
										       arg1283_442 = cons__138___r4_pairs_and_lists_6_3(arg1297_451, list1299_453);
										    }
										 }
										 {
										    bool_t test_896;
										    {
										       long aux_897;
										       aux_897 = (long) (arity_358);
										       test_896 = (aux_897 >= ((long) 0));
										    }
										    if (test_896)
										      {
											 obj_t arg1305_457;
											 {
											    obj_t arg1308_460;
											    arg1308_460 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
											    arg1305_457 = append_2_18___r4_pairs_and_lists_6_3(args_id_103_359, arg1308_460);
											 }
											 {
											    obj_t list1306_458;
											    list1306_458 = MAKE_PAIR(arg1305_457, BNIL);
											    arg1284_443 = cons__138___r4_pairs_and_lists_6_3(method_357, list1306_458);
											 }
										      }
										    else
										      {
											 obj_t arg1312_463;
											 obj_t arg1313_464;
											 arg1312_463 = CNST_TABLE_REF(((long) 10));
											 {
											    obj_t arg1320_470;
											    obj_t arg1321_471;
											    arg1320_470 = CNST_TABLE_REF(((long) 11));
											    {
											       obj_t arg1325_474;
											       arg1325_474 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
											       arg1321_471 = append_2_18___r4_pairs_and_lists_6_3(args_id_103_359, arg1325_474);
											    }
											    {
											       obj_t list1322_472;
											       list1322_472 = MAKE_PAIR(arg1321_471, BNIL);
											       arg1313_464 = cons__138___r4_pairs_and_lists_6_3(arg1320_470, list1322_472);
											    }
											 }
											 {
											    obj_t list1315_466;
											    {
											       obj_t arg1316_467;
											       {
												  obj_t arg1318_468;
												  arg1318_468 = MAKE_PAIR(BNIL, BNIL);
												  arg1316_467 = MAKE_PAIR(arg1313_464, arg1318_468);
											       }
											       list1315_466 = MAKE_PAIR(method_357, arg1316_467);
											    }
											    arg1284_443 = cons__138___r4_pairs_and_lists_6_3(arg1312_463, list1315_466);
											 }
										      }
										 }
										 {
										    obj_t arg1329_477;
										    obj_t arg1331_478;
										    obj_t arg1332_479;
										    arg1329_477 = CNST_TABLE_REF(((long) 12));
										    {
										       obj_t arg1342_485;
										       arg1342_485 = CNST_TABLE_REF(((long) 13));
										       {
											  obj_t list1344_487;
											  {
											     obj_t arg1345_488;
											     {
												obj_t arg1346_489;
												arg1346_489 = MAKE_PAIR(BNIL, BNIL);
												arg1345_488 = MAKE_PAIR(method_357, arg1346_489);
											     }
											     list1344_487 = MAKE_PAIR(id_356, arg1345_488);
											  }
											  arg1331_478 = cons__138___r4_pairs_and_lists_6_3(arg1342_485, list1344_487);
										       }
										    }
										    {
										       bool_t test_920;
										       {
											  long aux_921;
											  aux_921 = (long) (arity_358);
											  test_920 = (aux_921 >= ((long) 0));
										       }
										       if (test_920)
											 {
											    obj_t arg1349_492;
											    {
											       obj_t arg1353_495;
											       arg1353_495 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
											       arg1349_492 = append_2_18___r4_pairs_and_lists_6_3(args_id_103_359, arg1353_495);
											    }
											    {
											       obj_t list1350_493;
											       list1350_493 = MAKE_PAIR(arg1349_492, BNIL);
											       arg1332_479 = cons__138___r4_pairs_and_lists_6_3(id_356, list1350_493);
											    }
											 }
										       else
											 {
											    obj_t arg1357_498;
											    obj_t arg1358_499;
											    arg1357_498 = CNST_TABLE_REF(((long) 10));
											    {
											       obj_t arg1366_505;
											       obj_t arg1367_506;
											       arg1366_505 = CNST_TABLE_REF(((long) 11));
											       {
												  obj_t arg1370_509;
												  arg1370_509 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
												  arg1367_506 = append_2_18___r4_pairs_and_lists_6_3(args_id_103_359, arg1370_509);
											       }
											       {
												  obj_t list1368_507;
												  list1368_507 = MAKE_PAIR(arg1367_506, BNIL);
												  arg1358_499 = cons__138___r4_pairs_and_lists_6_3(arg1366_505, list1368_507);
											       }
											    }
											    {
											       obj_t list1360_501;
											       {
												  obj_t arg1361_502;
												  {
												     obj_t arg1363_503;
												     arg1363_503 = MAKE_PAIR(BNIL, BNIL);
												     arg1361_502 = MAKE_PAIR(arg1358_499, arg1363_503);
												  }
												  list1360_501 = MAKE_PAIR(id_356, arg1361_502);
											       }
											       arg1332_479 = cons__138___r4_pairs_and_lists_6_3(arg1357_498, list1360_501);
											    }
											 }
										    }
										    {
										       obj_t list1334_481;
										       {
											  obj_t arg1337_482;
											  {
											     obj_t arg1339_483;
											     arg1339_483 = MAKE_PAIR(BNIL, BNIL);
											     arg1337_482 = MAKE_PAIR(arg1332_479, arg1339_483);
											  }
											  list1334_481 = MAKE_PAIR(arg1331_478, arg1337_482);
										       }
										       arg1286_444 = cons__138___r4_pairs_and_lists_6_3(arg1329_477, list1334_481);
										    }
										 }
										 {
										    obj_t list1288_446;
										    {
										       obj_t arg1290_447;
										       {
											  obj_t arg1293_448;
											  {
											     obj_t arg1295_449;
											     arg1295_449 = MAKE_PAIR(BNIL, BNIL);
											     arg1293_448 = MAKE_PAIR(arg1286_444, arg1295_449);
											  }
											  arg1290_447 = MAKE_PAIR(arg1284_443, arg1293_448);
										       }
										       list1288_446 = MAKE_PAIR(arg1283_442, arg1290_447);
										    }
										    arg1239_410 = cons__138___r4_pairs_and_lists_6_3(arg1282_441, list1288_446);
										 }
									      }
									      {
										 obj_t list1241_412;
										 {
										    obj_t arg1242_413;
										    {
										       obj_t arg1245_414;
										       arg1245_414 = MAKE_PAIR(BNIL, BNIL);
										       arg1242_413 = MAKE_PAIR(arg1239_410, arg1245_414);
										    }
										    list1241_412 = MAKE_PAIR(arg1237_409, arg1242_413);
										 }
										 arg1229_402 = cons__138___r4_pairs_and_lists_6_3(arg1236_408, list1241_412);
									      }
									   }
									   {
									      obj_t list1231_404;
									      {
										 obj_t arg1233_405;
										 {
										    obj_t arg1234_406;
										    arg1234_406 = MAKE_PAIR(BNIL, BNIL);
										    arg1233_405 = MAKE_PAIR(arg1229_402, arg1234_406);
										 }
										 list1231_404 = MAKE_PAIR(BNIL, arg1233_405);
									      }
									      arg1217_396 = cons__138___r4_pairs_and_lists_6_3(arg1225_400, list1231_404);
									   }
									}
									{
									   obj_t list1219_398;
									   list1219_398 = MAKE_PAIR(BNIL, BNIL);
									   arg1208_390 = cons__138___r4_pairs_and_lists_6_3(arg1217_396, list1219_398);
									}
								     }
								     {
									obj_t list1210_392;
									{
									   obj_t arg1212_393;
									   {
									      obj_t arg1213_394;
									      arg1213_394 = MAKE_PAIR(BNIL, BNIL);
									      arg1212_393 = MAKE_PAIR(body_4, arg1213_394);
									   }
									   list1210_392 = MAKE_PAIR(arg1208_390, arg1212_393);
									}
									arg1199_383 = cons__138___r4_pairs_and_lists_6_3(arg1207_389, list1210_392);
								     }
								  }
								  {
								     obj_t list1201_385;
								     {
									obj_t arg1203_386;
									{
									   obj_t arg1204_387;
									   arg1204_387 = MAKE_PAIR(BNIL, BNIL);
									   arg1203_386 = MAKE_PAIR(arg1199_383, arg1204_387);
									}
									list1201_385 = MAKE_PAIR(args_2, arg1203_386);
								     }
								     arg1182_379 = cons__138___r4_pairs_and_lists_6_3(m_id_75_361, list1201_385);
								  }
							       }
							       {
								  obj_t list1196_381;
								  list1196_381 = MAKE_PAIR(BNIL, BNIL);
								  arg1153_372 = cons__138___r4_pairs_and_lists_6_3(arg1182_379, list1196_381);
							       }
							    }
							    {
							       obj_t arg1376_512;
							       obj_t arg1379_513;
							       arg1376_512 = CNST_TABLE_REF(((long) 14));
							       {
								  obj_t arg1391_520;
								  obj_t arg1396_521;
								  arg1391_520 = CNST_TABLE_REF(((long) 7));
								  arg1396_521 = (((global_t) CREF(holder_363))->id);
								  {
								     obj_t list1399_523;
								     {
									obj_t arg1400_524;
									{
									   obj_t arg1402_525;
									   arg1402_525 = MAKE_PAIR(BNIL, BNIL);
									   arg1400_524 = MAKE_PAIR(module_364, arg1402_525);
									}
									list1399_523 = MAKE_PAIR(arg1396_521, arg1400_524);
								     }
								     arg1379_513 = cons__138___r4_pairs_and_lists_6_3(arg1391_520, list1399_523);
								  }
							       }
							       {
								  obj_t list1381_515;
								  {
								     obj_t arg1382_516;
								     {
									obj_t arg1385_517;
									{
									   obj_t arg1388_518;
									   arg1388_518 = MAKE_PAIR(BNIL, BNIL);
									   arg1385_517 = MAKE_PAIR(m_id_75_361, arg1388_518);
									}
									arg1382_516 = MAKE_PAIR(arg1379_513, arg1385_517);
								     }
								     list1381_515 = MAKE_PAIR(id_356, arg1382_516);
								  }
								  arg1154_373 = cons__138___r4_pairs_and_lists_6_3(arg1376_512, list1381_515);
							       }
							    }
							    {
							       obj_t list1162_375;
							       {
								  obj_t arg1164_376;
								  {
								     obj_t arg1166_377;
								     arg1166_377 = MAKE_PAIR(BNIL, BNIL);
								     arg1164_376 = MAKE_PAIR(arg1154_373, arg1166_377);
								  }
								  list1162_375 = MAKE_PAIR(arg1153_372, arg1164_376);
							       }
							       arg1144_368 = cons__138___r4_pairs_and_lists_6_3(arg1149_371, list1162_375);
							    }
							 }
							 {
							    obj_t list1145_369;
							    list1145_369 = MAKE_PAIR(arg1144_368, BNIL);
							    return list1145_369;
							 }
						      }
						   }
						 else
						   {
						      add_generic_for_method_inlining__147_object_inline(generic_365);
						      {
							 long num_527;
							 num_527 = add_generic_method__111_object_inline((global_t) (generic_365), type_360, args_2, body_4);
							 {
							    obj_t arg1404_528;
							    {
							       obj_t arg1408_531;
							       obj_t arg1410_532;
							       arg1408_531 = CNST_TABLE_REF(((long) 15));
							       {
								  obj_t arg1418_539;
								  obj_t arg1420_540;
								  arg1418_539 = CNST_TABLE_REF(((long) 7));
								  arg1420_540 = (((global_t) CREF(holder_363))->id);
								  {
								     obj_t list1422_542;
								     {
									obj_t arg1424_543;
									{
									   obj_t arg1426_544;
									   arg1426_544 = MAKE_PAIR(BNIL, BNIL);
									   arg1424_543 = MAKE_PAIR(module_364, arg1426_544);
									}
									list1422_542 = MAKE_PAIR(arg1420_540, arg1424_543);
								     }
								     arg1410_532 = cons__138___r4_pairs_and_lists_6_3(arg1418_539, list1422_542);
								  }
							       }
							       {
								  obj_t list1412_534;
								  {
								     obj_t arg1414_535;
								     {
									obj_t arg1415_536;
									{
									   obj_t arg1416_537;
									   arg1416_537 = MAKE_PAIR(BNIL, BNIL);
									   {
									      obj_t aux_995;
									      aux_995 = BINT(num_527);
									      arg1415_536 = MAKE_PAIR(aux_995, arg1416_537);
									   }
									}
									arg1414_535 = MAKE_PAIR(arg1410_532, arg1415_536);
								     }
								     list1412_534 = MAKE_PAIR(id_356, arg1414_535);
								  }
								  arg1404_528 = cons__138___r4_pairs_and_lists_6_3(arg1408_531, list1412_534);
							       }
							    }
							    {
							       obj_t list1405_529;
							       list1405_529 = MAKE_PAIR(arg1404_528, BNIL);
							       return list1405_529;
							    }
							 }
						      }
						   }
					      }
					    else
					      {
						 return method_error_85_object_method(id_356, "Can't find generic for method", src_5);
					      }
					 }
				      }
				   }
				}
			     }
			   else
			     {
				return method_error_85_object_method(id_356, "method has a non-class dispatching type arg", src_5);
			     }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_make_method_body_16_object_method(obj_t env_773, obj_t id_774, obj_t args_775, obj_t locals_776, obj_t body_777, obj_t src_778)
{
   return make_method_body_103_object_method(id_774, args_775, locals_776, body_777, src_778);
}


obj_t 
method_error_85_object_method(obj_t id_6, char *msg_7, obj_t src_8)
{
   {
      obj_t arg1466_574;
      {
	 obj_t list1471_578;
	 {
	    obj_t aux_1005;
	    aux_1005 = CNST_TABLE_REF(((long) 16));
	    list1471_578 = MAKE_PAIR(aux_1005, BNIL);
	 }
	 arg1466_574 = list1471_578;
      }
      {
	 obj_t list1467_575;
	 list1467_575 = MAKE_PAIR(arg1466_574, BNIL);
	 return user_error_151_tools_error(id_6, string_to_bstring(msg_7), src_8, list1467_575);
      }
   }
}


obj_t 
imported_modules_init_94_object_method()
{
   module_initialization_70_tools_args(((long) 0), "OBJECT_METHOD");
   module_initialization_70_tools_error(((long) 0), "OBJECT_METHOD");
   module_initialization_70_tools_misc(((long) 0), "OBJECT_METHOD");
   module_initialization_70_type_type(((long) 0), "OBJECT_METHOD");
   module_initialization_70_ast_var(((long) 0), "OBJECT_METHOD");
   module_initialization_70_ast_ident(((long) 0), "OBJECT_METHOD");
   module_initialization_70_ast_env(((long) 0), "OBJECT_METHOD");
   module_initialization_70_object_class(((long) 0), "OBJECT_METHOD");
   return module_initialization_70_object_inline(((long) 0), "OBJECT_METHOD");
}
