/*===========================================================================*/
/*   (Object/slots.scm)                                                      */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;


extern obj_t reverse___r4_pairs_and_lists_6_3(obj_t);
extern obj_t type_type_type;
static obj_t find_assert_attr_93_object_slots(obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t class_object_class;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t imported_modules_init_94_object_slots();
extern obj_t module_initialization_70_object_slots(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t toplevel_init_63_object_slots();
static obj_t cnst_init_137_object_slots();
static obj_t find_default_attr_77_object_slots(obj_t);
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
static obj_t require_initialization_114_object_slots = BUNSPEC;
static obj_t library_modules_init_112_object_slots();
static obj_t scheme_symbol__c_string_183_object_slots(obj_t);
static obj_t ensure_type_defined__128_object_slots(type_t, obj_t);
extern obj_t __case_sensitive__90_engine_param;
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t _make_class_slots_155_object_slots(obj_t, obj_t, obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t __long__149_type_cache;
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t id__name_228_ast_ident(obj_t);
extern obj_t _____74_type_cache;
extern obj_t __obj__252_type_cache;
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t make_class_slots_205_object_slots(obj_t, obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
static obj_t __cnst[10];

DEFINE_STRING(string1592_object_slots, string1592_object_slots1599, "ASSERT LAMBDA (#f . #unspecified) DEFAULT + ID * -LEN READ-ONLY SLOT ", 69);
DEFINE_STRING(string1590_object_slots, string1590_object_slots1600, "Parse error", 11);
DEFINE_EXPORT_PROCEDURE(make_class_slots_env_76_object_slots, _make_class_slots_155_object_slots1601, _make_class_slots_155_object_slots, 0L, 3);
DEFINE_STRING(string1589_object_slots, string1589_object_slots1602, "Can't find type definition", 26);
DEFINE_STRING(string1591_object_slots, string1591_object_slots1603, "Unknown class slot type", 23);

obj_t 
module_initialization_70_object_slots(long checksum_1657, char *from_1658)
{
   if (CBOOL(require_initialization_114_object_slots))
     {
	require_initialization_114_object_slots = BBOOL(((bool_t) 0));
	library_modules_init_112_object_slots();
	cnst_init_137_object_slots();
	imported_modules_init_94_object_slots();
	toplevel_init_63_object_slots();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_object_slots()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_SLOTS");
   module_initialization_70___object(((long) 0), "OBJECT_SLOTS");
   module_initialization_70___r4_strings_6_7(((long) 0), "OBJECT_SLOTS");
   module_initialization_70___reader(((long) 0), "OBJECT_SLOTS");
   module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_SLOTS");
   return BUNSPEC;
}


obj_t 
cnst_init_137_object_slots()
{
   {
      obj_t cnst_port_138_1649;
      cnst_port_138_1649 = open_input_string(string1592_object_slots);
      {
	 long i_1650;
	 i_1650 = ((long) 9);
       loop_1651:
	 {
	    bool_t test1593_1652;
	    test1593_1652 = (i_1650 == ((long) -1));
	    if (test1593_1652)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1595_1653;
		    {
		       obj_t list1596_1654;
		       {
			  obj_t arg1597_1655;
			  arg1597_1655 = BNIL;
			  list1596_1654 = MAKE_PAIR(cnst_port_138_1649, arg1597_1655);
		       }
		       arg1595_1653 = read___reader(list1596_1654);
		    }
		    CNST_TABLE_SET(i_1650, arg1595_1653);
		 }
		 {
		    int aux_1656;
		    {
		       long aux_1677;
		       aux_1677 = (i_1650 - ((long) 1));
		       aux_1656 = (int) (aux_1677);
		    }
		    {
		       long i_1680;
		       i_1680 = (long) (aux_1656);
		       i_1650 = i_1680;
		       goto loop_1651;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_object_slots()
{
   return BUNSPEC;
}


obj_t 
ensure_type_defined__128_object_slots(type_t type_47, obj_t src_48)
{
   if ((((type_t) CREF(type_47))->init__47))
     {
	return BUNSPEC;
     }
   else
     {
	return user_error_151_tools_error(string1589_object_slots, (((type_t) CREF(type_47))->id), src_48, BNIL);
     }
}


obj_t 
make_class_slots_205_object_slots(obj_t slots_49, obj_t super_50, obj_t src_51)
{
   {
      obj_t slots_423;
      obj_t res_424;
      {
	 obj_t arg1203_426;
	 {
	    bool_t test1204_427;
	    test1204_427 = is_a__118___object(super_50, type_type_type);
	    if (test1204_427)
	      {
		 bool_t test1205_428;
		 test1205_428 = is_a__118___object(super_50, class_object_class);
		 if (test1205_428)
		   {
		      {
			 obj_t aux_1690;
			 {
			    class_t obj_992;
			    obj_992 = (class_t) (super_50);
			    {
			       obj_t aux_1692;
			       {
				  object_t aux_1693;
				  aux_1693 = (object_t) (obj_992);
				  aux_1692 = OBJECT_WIDENING(aux_1693);
			       }
			       aux_1690 = (((class_t) CREF(aux_1692))->slots);
			    }
			 }
			 arg1203_426 = reverse___r4_pairs_and_lists_6_3(aux_1690);
		      }
		   }
		 else
		   {
		      arg1203_426 = BNIL;
		   }
	      }
	    else
	      {
		 arg1203_426 = BNIL;
	      }
	 }
	 slots_423 = slots_49;
	 res_424 = arg1203_426;
       loop_425:
	 if (NULLP(slots_423))
	   {
	      return reverse__39___r4_pairs_and_lists_6_3(res_424);
	   }
	 else
	   {
	      obj_t s_431;
	      s_431 = CAR(slots_423);
	      {
		 obj_t slot_id_111_432;
		 obj_t attr_433;
		 obj_t len_435;
		 obj_t slot_id_111_436;
		 obj_t attr_437;
		 obj_t slot_id_111_439;
		 obj_t attr_440;
		 obj_t slot_id_111_442;
		 if (PAIRP(s_431))
		   {
		      obj_t cdr_140_144_447;
		      cdr_140_144_447 = CDR(s_431);
		      {
			 bool_t test_1705;
			 {
			    obj_t aux_1708;
			    obj_t aux_1706;
			    aux_1708 = CNST_TABLE_REF(((long) 3));
			    aux_1706 = CAR(s_431);
			    test_1705 = (aux_1706 == aux_1708);
			 }
			 if (test_1705)
			   {
			      if (PAIRP(cdr_140_144_447))
				{
				   obj_t car_143_62_450;
				   car_143_62_450 = CAR(cdr_140_144_447);
				   if (PAIRP(car_143_62_450))
				     {
					obj_t cdr_147_183_452;
					cdr_147_183_452 = CDR(car_143_62_450);
					{
					   bool_t test_1717;
					   {
					      obj_t aux_1720;
					      obj_t aux_1718;
					      aux_1720 = CNST_TABLE_REF(((long) 4));
					      aux_1718 = CAR(car_143_62_450);
					      test_1717 = (aux_1718 == aux_1720);
					   }
					   if (test_1717)
					     {
						if (PAIRP(cdr_147_183_452))
						  {
						     bool_t test_1725;
						     {
							obj_t aux_1726;
							aux_1726 = CDR(cdr_147_183_452);
							test_1725 = (aux_1726 == BNIL);
						     }
						     if (test_1725)
						       {
							  slot_id_111_432 = CAR(cdr_147_183_452);
							  attr_433 = CDR(cdr_140_144_447);
							  {
							     obj_t id_637;
							     obj_t default_199_638;
							     obj_t a_exp_20_639;
							     obj_t type_640;
							     {
								obj_t arg1446_654;
								arg1446_654 = CAR(slot_id_111_432);
								{
								   obj_t list1448_656;
								   {
								      obj_t arg1449_657;
								      {
									 obj_t aux_1730;
									 aux_1730 = CNST_TABLE_REF(((long) 2));
									 arg1449_657 = MAKE_PAIR(aux_1730, BNIL);
								      }
								      list1448_656 = MAKE_PAIR(arg1446_654, arg1449_657);
								   }
								   id_637 = symbol_append_197___r4_symbols_6_4(list1448_656);
								}
							     }
							     default_199_638 = find_default_attr_77_object_slots(attr_433);
							     a_exp_20_639 = find_assert_attr_93_object_slots(attr_433);
							     {
								bool_t test1451_659;
								{
								   obj_t obj2_1189;
								   obj2_1189 = _____74_type_cache;
								   {
								      obj_t aux_1737;
								      aux_1737 = CDR(slot_id_111_432);
								      test1451_659 = (aux_1737 == obj2_1189);
								   }
								}
								if (test1451_659)
								  {
								     type_640 = __obj__252_type_cache;
								  }
								else
								  {
								     type_640 = CDR(slot_id_111_432);
								  }
							     }
							     ensure_type_defined__128_object_slots((type_t) (type_640), src_51);
							     {
								obj_t arg1418_641;
								obj_t arg1420_642;
								arg1418_641 = CDR(slots_423);
								{
								   obj_t arg1421_643;
								   obj_t arg1424_644;
								   {
								      obj_t arg1426_645;
								      obj_t arg1427_646;
								      obj_t arg1428_647;
								      obj_t arg1431_648;
								      obj_t arg1432_649;
								      arg1426_645 = CAR(slot_id_111_432);
								      arg1427_646 = scheme_symbol__c_string_183_object_slots(CAR(slot_id_111_432));
								      arg1428_647 = memq___r4_pairs_and_lists_6_3(CNST_TABLE_REF(((long) 1)), attr_433);
								      arg1431_648 = CAR(default_199_638);
								      arg1432_649 = CDR(default_199_638);
								      {
									 obj_t new_1207;
									 {
									    obj_t aux_1752;
									    aux_1752 = CNST_TABLE_REF(((long) 0));
									    new_1207 = create_struct(aux_1752, ((long) 11));
									 }
									 STRUCT_SET(new_1207, ((long) 10), a_exp_20_639);
									 STRUCT_SET(new_1207, ((long) 9), arg1432_649);
									 STRUCT_SET(new_1207, ((long) 8), arg1431_648);
									 STRUCT_SET(new_1207, ((long) 7), arg1428_647);
									 STRUCT_SET(new_1207, ((long) 6), BFALSE);
									 STRUCT_SET(new_1207, ((long) 5), BTRUE);
									 STRUCT_SET(new_1207, ((long) 4), BUNSPEC);
									 STRUCT_SET(new_1207, ((long) 3), BFALSE);
									 STRUCT_SET(new_1207, ((long) 2), type_640);
									 STRUCT_SET(new_1207, ((long) 1), arg1427_646);
									 STRUCT_SET(new_1207, ((long) 0), arg1426_645);
									 arg1421_643 = new_1207;
								      }
								   }
								   {
								      obj_t arg1444_652;
								      {
									 obj_t arg1445_653;
									 arg1445_653 = scheme_symbol__c_string_183_object_slots(id_637);
									 {
									    obj_t type_1267;
									    type_1267 = __long__149_type_cache;
									    {
									       obj_t new_1276;
									       {
										  obj_t aux_1767;
										  aux_1767 = CNST_TABLE_REF(((long) 0));
										  new_1276 = create_struct(aux_1767, ((long) 11));
									       }
									       STRUCT_SET(new_1276, ((long) 10), BFALSE);
									       STRUCT_SET(new_1276, ((long) 9), BUNSPEC);
									       STRUCT_SET(new_1276, ((long) 8), BFALSE);
									       STRUCT_SET(new_1276, ((long) 7), BTRUE);
									       STRUCT_SET(new_1276, ((long) 6), BTRUE);
									       STRUCT_SET(new_1276, ((long) 5), BFALSE);
									       STRUCT_SET(new_1276, ((long) 4), BUNSPEC);
									       STRUCT_SET(new_1276, ((long) 3), BFALSE);
									       STRUCT_SET(new_1276, ((long) 2), type_1267);
									       STRUCT_SET(new_1276, ((long) 1), arg1445_653);
									       STRUCT_SET(new_1276, ((long) 0), id_637);
									       arg1444_652 = new_1276;
									    }
									 }
								      }
								      arg1424_644 = MAKE_PAIR(arg1444_652, res_424);
								   }
								   arg1420_642 = MAKE_PAIR(arg1421_643, arg1424_644);
								}
								{
								   obj_t res_1784;
								   obj_t slots_1783;
								   slots_1783 = arg1418_641;
								   res_1784 = arg1420_642;
								   res_424 = res_1784;
								   slots_423 = slots_1783;
								   goto loop_425;
								}
							     }
							  }
						       }
						     else
						       {
							  obj_t car_163_49_458;
							  car_163_49_458 = CAR(s_431);
							  if (PAIRP(car_163_49_458))
							    {
							       obj_t cdr_167_119_460;
							       cdr_167_119_460 = CDR(car_163_49_458);
							       {
								  bool_t test_1791;
								  {
								     obj_t aux_1794;
								     obj_t aux_1792;
								     aux_1794 = CNST_TABLE_REF(((long) 4));
								     aux_1792 = CAR(car_163_49_458);
								     test_1791 = (aux_1792 == aux_1794);
								  }
								  if (test_1791)
								    {
								       if (PAIRP(cdr_167_119_460))
									 {
									    bool_t test_1799;
									    {
									       obj_t aux_1800;
									       aux_1800 = CDR(cdr_167_119_460);
									       test_1799 = (aux_1800 == BNIL);
									    }
									    if (test_1799)
									      {
										 slot_id_111_439 = CAR(cdr_167_119_460);
										 attr_440 = cdr_140_144_447;
									       tag_130_214_441:
										 {
										    obj_t default_199_682;
										    obj_t a_exp_20_683;
										    obj_t type_684;
										    default_199_682 = find_default_attr_77_object_slots(attr_440);
										    a_exp_20_683 = find_assert_attr_93_object_slots(attr_440);
										    {
										       bool_t test1495_695;
										       {
											  obj_t obj2_1421;
											  obj2_1421 = _____74_type_cache;
											  {
											     obj_t aux_1805;
											     aux_1805 = CDR(slot_id_111_439);
											     test1495_695 = (aux_1805 == obj2_1421);
											  }
										       }
										       if (test1495_695)
											 {
											    type_684 = __obj__252_type_cache;
											 }
										       else
											 {
											    type_684 = CDR(slot_id_111_439);
											 }
										    }
										    ensure_type_defined__128_object_slots((type_t) (type_684), src_51);
										    {
										       obj_t arg1480_685;
										       obj_t arg1481_686;
										       arg1480_685 = CDR(slots_423);
										       {
											  obj_t arg1484_687;
											  {
											     obj_t arg1485_688;
											     obj_t arg1486_689;
											     obj_t arg1487_690;
											     obj_t arg1489_691;
											     obj_t arg1490_692;
											     arg1485_688 = CAR(slot_id_111_439);
											     arg1486_689 = scheme_symbol__c_string_183_object_slots(CAR(slot_id_111_439));
											     arg1487_690 = memq___r4_pairs_and_lists_6_3(CNST_TABLE_REF(((long) 1)), attr_440);
											     arg1489_691 = CAR(default_199_682);
											     arg1490_692 = CDR(default_199_682);
											     {
												obj_t new_1439;
												{
												   obj_t aux_1820;
												   aux_1820 = CNST_TABLE_REF(((long) 0));
												   new_1439 = create_struct(aux_1820, ((long) 11));
												}
												STRUCT_SET(new_1439, ((long) 10), a_exp_20_683);
												STRUCT_SET(new_1439, ((long) 9), arg1490_692);
												STRUCT_SET(new_1439, ((long) 8), arg1489_691);
												STRUCT_SET(new_1439, ((long) 7), arg1487_690);
												STRUCT_SET(new_1439, ((long) 6), BFALSE);
												STRUCT_SET(new_1439, ((long) 5), BFALSE);
												STRUCT_SET(new_1439, ((long) 4), BUNSPEC);
												STRUCT_SET(new_1439, ((long) 3), BFALSE);
												STRUCT_SET(new_1439, ((long) 2), type_684);
												STRUCT_SET(new_1439, ((long) 1), arg1486_689);
												STRUCT_SET(new_1439, ((long) 0), arg1485_688);
												arg1484_687 = new_1439;
											     }
											  }
											  arg1481_686 = MAKE_PAIR(arg1484_687, res_424);
										       }
										       {
											  obj_t res_1836;
											  obj_t slots_1835;
											  slots_1835 = arg1480_685;
											  res_1836 = arg1481_686;
											  res_424 = res_1836;
											  slots_423 = slots_1835;
											  goto loop_425;
										       }
										    }
										 }
									      }
									    else
									      {
									       tag_132_226_444:
										 {
										    obj_t list1512_709;
										    list1512_709 = MAKE_PAIR(BNIL, BNIL);
										    return user_error_151_tools_error(string1590_object_slots, string1591_object_slots, s_431, list1512_709);
										 }
									      }
									 }
								       else
									 {
									    goto tag_132_226_444;
									 }
								    }
								  else
								    {
								       goto tag_132_226_444;
								    }
							       }
							    }
							  else
							    {
							       goto tag_132_226_444;
							    }
						       }
						  }
						else
						  {
						     obj_t car_191_182_472;
						     car_191_182_472 = CAR(s_431);
						     if (PAIRP(car_191_182_472))
						       {
							  obj_t cdr_195_37_474;
							  cdr_195_37_474 = CDR(car_191_182_472);
							  {
							     bool_t test_1844;
							     {
								obj_t aux_1847;
								obj_t aux_1845;
								aux_1847 = CNST_TABLE_REF(((long) 4));
								aux_1845 = CAR(car_191_182_472);
								test_1844 = (aux_1845 == aux_1847);
							     }
							     if (test_1844)
							       {
								  if (PAIRP(cdr_195_37_474))
								    {
								       bool_t test_1852;
								       {
									  obj_t aux_1853;
									  aux_1853 = CDR(cdr_195_37_474);
									  test_1852 = (aux_1853 == BNIL);
								       }
								       if (test_1852)
									 {
									    obj_t attr_1858;
									    obj_t slot_id_111_1856;
									    slot_id_111_1856 = CAR(cdr_195_37_474);
									    attr_1858 = cdr_140_144_447;
									    attr_440 = attr_1858;
									    slot_id_111_439 = slot_id_111_1856;
									    goto tag_130_214_441;
									 }
								       else
									 {
									    goto tag_132_226_444;
									 }
								    }
								  else
								    {
								       goto tag_132_226_444;
								    }
							       }
							     else
							       {
								  goto tag_132_226_444;
							       }
							  }
						       }
						     else
						       {
							  goto tag_132_226_444;
						       }
						  }
					     }
					   else
					     {
						obj_t car_219_238_484;
						car_219_238_484 = CAR(s_431);
						if (PAIRP(car_219_238_484))
						  {
						     obj_t cdr_223_81_486;
						     cdr_223_81_486 = CDR(car_219_238_484);
						     {
							bool_t test_1863;
							{
							   obj_t aux_1866;
							   obj_t aux_1864;
							   aux_1866 = CNST_TABLE_REF(((long) 4));
							   aux_1864 = CAR(car_219_238_484);
							   test_1863 = (aux_1864 == aux_1866);
							}
							if (test_1863)
							  {
							     if (PAIRP(cdr_223_81_486))
							       {
								  bool_t test_1871;
								  {
								     obj_t aux_1872;
								     aux_1872 = CDR(cdr_223_81_486);
								     test_1871 = (aux_1872 == BNIL);
								  }
								  if (test_1871)
								    {
								       obj_t attr_1877;
								       obj_t slot_id_111_1875;
								       slot_id_111_1875 = CAR(cdr_223_81_486);
								       attr_1877 = cdr_140_144_447;
								       attr_440 = attr_1877;
								       slot_id_111_439 = slot_id_111_1875;
								       goto tag_130_214_441;
								    }
								  else
								    {
								       goto tag_132_226_444;
								    }
							       }
							     else
							       {
								  goto tag_132_226_444;
							       }
							  }
							else
							  {
							     goto tag_132_226_444;
							  }
						     }
						  }
						else
						  {
						     goto tag_132_226_444;
						  }
					     }
					}
				     }
				   else
				     {
					obj_t car_247_40_498;
					car_247_40_498 = CAR(s_431);
					if (PAIRP(car_247_40_498))
					  {
					     obj_t cdr_251_58_500;
					     cdr_251_58_500 = CDR(car_247_40_498);
					     {
						bool_t test_1882;
						{
						   obj_t aux_1885;
						   obj_t aux_1883;
						   aux_1885 = CNST_TABLE_REF(((long) 4));
						   aux_1883 = CAR(car_247_40_498);
						   test_1882 = (aux_1883 == aux_1885);
						}
						if (test_1882)
						  {
						     if (PAIRP(cdr_251_58_500))
						       {
							  bool_t test_1890;
							  {
							     obj_t aux_1891;
							     aux_1891 = CDR(cdr_251_58_500);
							     test_1890 = (aux_1891 == BNIL);
							  }
							  if (test_1890)
							    {
							       obj_t attr_1896;
							       obj_t slot_id_111_1894;
							       slot_id_111_1894 = CAR(cdr_251_58_500);
							       attr_1896 = cdr_140_144_447;
							       attr_440 = attr_1896;
							       slot_id_111_439 = slot_id_111_1894;
							       goto tag_130_214_441;
							    }
							  else
							    {
							       goto tag_132_226_444;
							    }
						       }
						     else
						       {
							  goto tag_132_226_444;
						       }
						  }
						else
						  {
						     goto tag_132_226_444;
						  }
					     }
					  }
					else
					  {
					     goto tag_132_226_444;
					  }
				     }
				}
			      else
				{
				   obj_t car_275_61_510;
				   car_275_61_510 = CAR(s_431);
				   if (PAIRP(car_275_61_510))
				     {
					obj_t cdr_279_181_512;
					cdr_279_181_512 = CDR(car_275_61_510);
					{
					   bool_t test_1901;
					   {
					      obj_t aux_1904;
					      obj_t aux_1902;
					      aux_1904 = CNST_TABLE_REF(((long) 4));
					      aux_1902 = CAR(car_275_61_510);
					      test_1901 = (aux_1902 == aux_1904);
					   }
					   if (test_1901)
					     {
						if (PAIRP(cdr_279_181_512))
						  {
						     bool_t test_1909;
						     {
							obj_t aux_1910;
							aux_1910 = CDR(cdr_279_181_512);
							test_1909 = (aux_1910 == BNIL);
						     }
						     if (test_1909)
						       {
							  obj_t attr_1915;
							  obj_t slot_id_111_1913;
							  slot_id_111_1913 = CAR(cdr_279_181_512);
							  attr_1915 = cdr_140_144_447;
							  attr_440 = attr_1915;
							  slot_id_111_439 = slot_id_111_1913;
							  goto tag_130_214_441;
						       }
						     else
						       {
							  goto tag_132_226_444;
						       }
						  }
						else
						  {
						     goto tag_132_226_444;
						  }
					     }
					   else
					     {
						goto tag_132_226_444;
					     }
					}
				     }
				   else
				     {
					goto tag_132_226_444;
				     }
				}
			   }
			 else
			   {
			      bool_t test_1916;
			      {
				 obj_t aux_1919;
				 obj_t aux_1917;
				 aux_1919 = CNST_TABLE_REF(((long) 5));
				 aux_1917 = CAR(s_431);
				 test_1916 = (aux_1917 == aux_1919);
			      }
			      if (test_1916)
				{
				   if (PAIRP(cdr_140_144_447))
				     {
					obj_t cdr_305_105_525;
					cdr_305_105_525 = CDR(cdr_140_144_447);
					if (PAIRP(cdr_305_105_525))
					  {
					     obj_t car_309_77_527;
					     car_309_77_527 = CAR(cdr_305_105_525);
					     if (PAIRP(car_309_77_527))
					       {
						  obj_t cdr_313_221_529;
						  cdr_313_221_529 = CDR(car_309_77_527);
						  {
						     bool_t test_1931;
						     {
							obj_t aux_1934;
							obj_t aux_1932;
							aux_1934 = CNST_TABLE_REF(((long) 4));
							aux_1932 = CAR(car_309_77_527);
							test_1931 = (aux_1932 == aux_1934);
						     }
						     if (test_1931)
						       {
							  if (PAIRP(cdr_313_221_529))
							    {
							       bool_t test_1939;
							       {
								  obj_t aux_1940;
								  aux_1940 = CDR(cdr_313_221_529);
								  test_1939 = (aux_1940 == BNIL);
							       }
							       if (test_1939)
								 {
								    len_435 = CAR(cdr_140_144_447);
								    slot_id_111_436 = CAR(cdr_313_221_529);
								    attr_437 = CDR(cdr_305_105_525);
								    {
								       obj_t id_661;
								       obj_t default_199_662;
								       obj_t a_exp_20_663;
								       obj_t type_664;
								       {
									  obj_t arg1470_675;
									  arg1470_675 = CAR(slot_id_111_436);
									  {
									     obj_t list1472_677;
									     {
										obj_t arg1474_678;
										{
										   obj_t aux_1944;
										   aux_1944 = CNST_TABLE_REF(((long) 2));
										   arg1474_678 = MAKE_PAIR(aux_1944, BNIL);
										}
										list1472_677 = MAKE_PAIR(arg1470_675, arg1474_678);
									     }
									     id_661 = symbol_append_197___r4_symbols_6_4(list1472_677);
									  }
								       }
								       default_199_662 = find_default_attr_77_object_slots(attr_437);
								       a_exp_20_663 = find_assert_attr_93_object_slots(attr_437);
								       {
									  bool_t test1477_680;
									  {
									     obj_t obj2_1341;
									     obj2_1341 = _____74_type_cache;
									     {
										obj_t aux_1951;
										aux_1951 = CDR(slot_id_111_436);
										test1477_680 = (aux_1951 == obj2_1341);
									     }
									  }
									  if (test1477_680)
									    {
									       type_664 = __obj__252_type_cache;
									    }
									  else
									    {
									       type_664 = CDR(slot_id_111_436);
									    }
								       }
								       ensure_type_defined__128_object_slots((type_t) (type_664), src_51);
								       {
									  obj_t arg1453_665;
									  obj_t arg1454_666;
									  arg1453_665 = CDR(slots_423);
									  {
									     obj_t arg1457_667;
									     {
										obj_t arg1458_668;
										obj_t arg1461_669;
										obj_t arg1463_670;
										obj_t arg1465_671;
										obj_t arg1466_672;
										arg1458_668 = CAR(slot_id_111_436);
										arg1461_669 = scheme_symbol__c_string_183_object_slots(CAR(slot_id_111_436));
										arg1463_670 = memq___r4_pairs_and_lists_6_3(CNST_TABLE_REF(((long) 1)), attr_437);
										arg1465_671 = CAR(default_199_662);
										arg1466_672 = CDR(default_199_662);
										{
										   obj_t new_1359;
										   {
										      obj_t aux_1966;
										      aux_1966 = CNST_TABLE_REF(((long) 0));
										      new_1359 = create_struct(aux_1966, ((long) 11));
										   }
										   STRUCT_SET(new_1359, ((long) 10), a_exp_20_663);
										   STRUCT_SET(new_1359, ((long) 9), arg1466_672);
										   STRUCT_SET(new_1359, ((long) 8), arg1465_671);
										   STRUCT_SET(new_1359, ((long) 7), arg1463_670);
										   STRUCT_SET(new_1359, ((long) 6), BFALSE);
										   STRUCT_SET(new_1359, ((long) 5), BFALSE);
										   STRUCT_SET(new_1359, ((long) 4), len_435);
										   STRUCT_SET(new_1359, ((long) 3), BTRUE);
										   STRUCT_SET(new_1359, ((long) 2), type_664);
										   STRUCT_SET(new_1359, ((long) 1), arg1461_669);
										   STRUCT_SET(new_1359, ((long) 0), arg1458_668);
										   arg1457_667 = new_1359;
										}
									     }
									     arg1454_666 = MAKE_PAIR(arg1457_667, res_424);
									  }
									  {
									     obj_t res_1982;
									     obj_t slots_1981;
									     slots_1981 = arg1453_665;
									     res_1982 = arg1454_666;
									     res_424 = res_1982;
									     slots_423 = slots_1981;
									     goto loop_425;
									  }
								       }
								    }
								 }
							       else
								 {
								    obj_t car_323_107_536;
								    car_323_107_536 = CAR(s_431);
								    if (PAIRP(car_323_107_536))
								      {
									 obj_t cdr_327_247_538;
									 cdr_327_247_538 = CDR(car_323_107_536);
									 {
									    bool_t test_1990;
									    {
									       obj_t aux_1993;
									       obj_t aux_1991;
									       aux_1993 = CNST_TABLE_REF(((long) 4));
									       aux_1991 = CAR(car_323_107_536);
									       test_1990 = (aux_1991 == aux_1993);
									    }
									    if (test_1990)
									      {
										 if (PAIRP(cdr_327_247_538))
										   {
										      bool_t test_1998;
										      {
											 obj_t aux_1999;
											 aux_1999 = CDR(cdr_327_247_538);
											 test_1998 = (aux_1999 == BNIL);
										      }
										      if (test_1998)
											{
											   obj_t attr_2004;
											   obj_t slot_id_111_2002;
											   slot_id_111_2002 = CAR(cdr_327_247_538);
											   attr_2004 = cdr_140_144_447;
											   attr_440 = attr_2004;
											   slot_id_111_439 = slot_id_111_2002;
											   goto tag_130_214_441;
											}
										      else
											{
											   goto tag_132_226_444;
											}
										   }
										 else
										   {
										      goto tag_132_226_444;
										   }
									      }
									    else
									      {
										 goto tag_132_226_444;
									      }
									 }
								      }
								    else
								      {
									 goto tag_132_226_444;
								      }
								 }
							    }
							  else
							    {
							       obj_t car_345_114_550;
							       car_345_114_550 = CAR(s_431);
							       if (PAIRP(car_345_114_550))
								 {
								    obj_t cdr_349_110_552;
								    cdr_349_110_552 = CDR(car_345_114_550);
								    {
								       bool_t test_2009;
								       {
									  obj_t aux_2012;
									  obj_t aux_2010;
									  aux_2012 = CNST_TABLE_REF(((long) 4));
									  aux_2010 = CAR(car_345_114_550);
									  test_2009 = (aux_2010 == aux_2012);
								       }
								       if (test_2009)
									 {
									    if (PAIRP(cdr_349_110_552))
									      {
										 bool_t test_2017;
										 {
										    obj_t aux_2018;
										    aux_2018 = CDR(cdr_349_110_552);
										    test_2017 = (aux_2018 == BNIL);
										 }
										 if (test_2017)
										   {
										      obj_t attr_2023;
										      obj_t slot_id_111_2021;
										      slot_id_111_2021 = CAR(cdr_349_110_552);
										      attr_2023 = cdr_140_144_447;
										      attr_440 = attr_2023;
										      slot_id_111_439 = slot_id_111_2021;
										      goto tag_130_214_441;
										   }
										 else
										   {
										      goto tag_132_226_444;
										   }
									      }
									    else
									      {
										 goto tag_132_226_444;
									      }
									 }
								       else
									 {
									    goto tag_132_226_444;
									 }
								    }
								 }
							       else
								 {
								    goto tag_132_226_444;
								 }
							    }
						       }
						     else
						       {
							  obj_t car_367_38_562;
							  car_367_38_562 = CAR(s_431);
							  if (PAIRP(car_367_38_562))
							    {
							       obj_t cdr_371_94_564;
							       cdr_371_94_564 = CDR(car_367_38_562);
							       {
								  bool_t test_2028;
								  {
								     obj_t aux_2031;
								     obj_t aux_2029;
								     aux_2031 = CNST_TABLE_REF(((long) 4));
								     aux_2029 = CAR(car_367_38_562);
								     test_2028 = (aux_2029 == aux_2031);
								  }
								  if (test_2028)
								    {
								       if (PAIRP(cdr_371_94_564))
									 {
									    bool_t test_2036;
									    {
									       obj_t aux_2037;
									       aux_2037 = CDR(cdr_371_94_564);
									       test_2036 = (aux_2037 == BNIL);
									    }
									    if (test_2036)
									      {
										 obj_t attr_2042;
										 obj_t slot_id_111_2040;
										 slot_id_111_2040 = CAR(cdr_371_94_564);
										 attr_2042 = cdr_140_144_447;
										 attr_440 = attr_2042;
										 slot_id_111_439 = slot_id_111_2040;
										 goto tag_130_214_441;
									      }
									    else
									      {
										 goto tag_132_226_444;
									      }
									 }
								       else
									 {
									    goto tag_132_226_444;
									 }
								    }
								  else
								    {
								       goto tag_132_226_444;
								    }
							       }
							    }
							  else
							    {
							       goto tag_132_226_444;
							    }
						       }
						  }
					       }
					     else
					       {
						  obj_t car_389_243_576;
						  car_389_243_576 = CAR(s_431);
						  if (PAIRP(car_389_243_576))
						    {
						       obj_t cdr_393_75_578;
						       cdr_393_75_578 = CDR(car_389_243_576);
						       {
							  bool_t test_2047;
							  {
							     obj_t aux_2050;
							     obj_t aux_2048;
							     aux_2050 = CNST_TABLE_REF(((long) 4));
							     aux_2048 = CAR(car_389_243_576);
							     test_2047 = (aux_2048 == aux_2050);
							  }
							  if (test_2047)
							    {
							       if (PAIRP(cdr_393_75_578))
								 {
								    bool_t test_2055;
								    {
								       obj_t aux_2056;
								       aux_2056 = CDR(cdr_393_75_578);
								       test_2055 = (aux_2056 == BNIL);
								    }
								    if (test_2055)
								      {
									 obj_t attr_2061;
									 obj_t slot_id_111_2059;
									 slot_id_111_2059 = CAR(cdr_393_75_578);
									 attr_2061 = cdr_140_144_447;
									 attr_440 = attr_2061;
									 slot_id_111_439 = slot_id_111_2059;
									 goto tag_130_214_441;
								      }
								    else
								      {
									 goto tag_132_226_444;
								      }
								 }
							       else
								 {
								    goto tag_132_226_444;
								 }
							    }
							  else
							    {
							       goto tag_132_226_444;
							    }
						       }
						    }
						  else
						    {
						       goto tag_132_226_444;
						    }
					       }
					  }
					else
					  {
					     obj_t car_411_240_588;
					     car_411_240_588 = CAR(s_431);
					     if (PAIRP(car_411_240_588))
					       {
						  obj_t cdr_415_103_590;
						  cdr_415_103_590 = CDR(car_411_240_588);
						  {
						     bool_t test_2066;
						     {
							obj_t aux_2069;
							obj_t aux_2067;
							aux_2069 = CNST_TABLE_REF(((long) 4));
							aux_2067 = CAR(car_411_240_588);
							test_2066 = (aux_2067 == aux_2069);
						     }
						     if (test_2066)
						       {
							  if (PAIRP(cdr_415_103_590))
							    {
							       bool_t test_2074;
							       {
								  obj_t aux_2075;
								  aux_2075 = CDR(cdr_415_103_590);
								  test_2074 = (aux_2075 == BNIL);
							       }
							       if (test_2074)
								 {
								    obj_t attr_2080;
								    obj_t slot_id_111_2078;
								    slot_id_111_2078 = CAR(cdr_415_103_590);
								    attr_2080 = cdr_140_144_447;
								    attr_440 = attr_2080;
								    slot_id_111_439 = slot_id_111_2078;
								    goto tag_130_214_441;
								 }
							       else
								 {
								    goto tag_132_226_444;
								 }
							    }
							  else
							    {
							       goto tag_132_226_444;
							    }
						       }
						     else
						       {
							  goto tag_132_226_444;
						       }
						  }
					       }
					     else
					       {
						  goto tag_132_226_444;
					       }
					  }
				     }
				   else
				     {
					obj_t car_433_98_600;
					car_433_98_600 = CAR(s_431);
					if (PAIRP(car_433_98_600))
					  {
					     obj_t cdr_437_8_602;
					     cdr_437_8_602 = CDR(car_433_98_600);
					     {
						bool_t test_2085;
						{
						   obj_t aux_2088;
						   obj_t aux_2086;
						   aux_2088 = CNST_TABLE_REF(((long) 4));
						   aux_2086 = CAR(car_433_98_600);
						   test_2085 = (aux_2086 == aux_2088);
						}
						if (test_2085)
						  {
						     if (PAIRP(cdr_437_8_602))
						       {
							  bool_t test_2093;
							  {
							     obj_t aux_2094;
							     aux_2094 = CDR(cdr_437_8_602);
							     test_2093 = (aux_2094 == BNIL);
							  }
							  if (test_2093)
							    {
							       obj_t attr_2099;
							       obj_t slot_id_111_2097;
							       slot_id_111_2097 = CAR(cdr_437_8_602);
							       attr_2099 = cdr_140_144_447;
							       attr_440 = attr_2099;
							       slot_id_111_439 = slot_id_111_2097;
							       goto tag_130_214_441;
							    }
							  else
							    {
							       goto tag_132_226_444;
							    }
						       }
						     else
						       {
							  goto tag_132_226_444;
						       }
						  }
						else
						  {
						     goto tag_132_226_444;
						  }
					     }
					  }
					else
					  {
					     goto tag_132_226_444;
					  }
				     }
				}
			      else
				{
				   obj_t car_455_237_612;
				   car_455_237_612 = CAR(s_431);
				   if (PAIRP(car_455_237_612))
				     {
					obj_t cdr_459_197_614;
					cdr_459_197_614 = CDR(car_455_237_612);
					{
					   bool_t test_2104;
					   {
					      obj_t aux_2107;
					      obj_t aux_2105;
					      aux_2107 = CNST_TABLE_REF(((long) 4));
					      aux_2105 = CAR(car_455_237_612);
					      test_2104 = (aux_2105 == aux_2107);
					   }
					   if (test_2104)
					     {
						if (PAIRP(cdr_459_197_614))
						  {
						     bool_t test_2112;
						     {
							obj_t aux_2113;
							aux_2113 = CDR(cdr_459_197_614);
							test_2112 = (aux_2113 == BNIL);
						     }
						     if (test_2112)
						       {
							  obj_t attr_2118;
							  obj_t slot_id_111_2116;
							  slot_id_111_2116 = CAR(cdr_459_197_614);
							  attr_2118 = cdr_140_144_447;
							  attr_440 = attr_2118;
							  slot_id_111_439 = slot_id_111_2116;
							  goto tag_130_214_441;
						       }
						     else
						       {
							  goto tag_132_226_444;
						       }
						  }
						else
						  {
						     goto tag_132_226_444;
						  }
					     }
					   else
					     {
						goto tag_132_226_444;
					     }
					}
				     }
				   else
				     {
					bool_t test_2119;
					{
					   obj_t aux_2120;
					   aux_2120 = CNST_TABLE_REF(((long) 4));
					   test_2119 = (car_455_237_612 == aux_2120);
					}
					if (test_2119)
					  {
					     if (PAIRP(cdr_140_144_447))
					       {
						  bool_t test_2125;
						  {
						     obj_t aux_2126;
						     aux_2126 = CDR(cdr_140_144_447);
						     test_2125 = (aux_2126 == BNIL);
						  }
						  if (test_2125)
						    {
						       slot_id_111_442 = CAR(cdr_140_144_447);
						       {
							  obj_t type_697;
							  {
							     bool_t test1506_704;
							     {
								obj_t obj2_1501;
								obj2_1501 = _____74_type_cache;
								{
								   obj_t aux_2129;
								   aux_2129 = CDR(slot_id_111_442);
								   test1506_704 = (aux_2129 == obj2_1501);
								}
							     }
							     if (test1506_704)
							       {
								  type_697 = __obj__252_type_cache;
							       }
							     else
							       {
								  type_697 = CDR(slot_id_111_442);
							       }
							  }
							  ensure_type_defined__128_object_slots((type_t) (type_697), src_51);
							  {
							     obj_t arg1497_698;
							     obj_t arg1498_699;
							     arg1497_698 = CDR(slots_423);
							     {
								obj_t arg1499_700;
								{
								   obj_t arg1500_701;
								   obj_t arg1501_702;
								   arg1500_701 = CAR(slot_id_111_442);
								   arg1501_702 = scheme_symbol__c_string_183_object_slots(CAR(slot_id_111_442));
								   {
								      obj_t new_1517;
								      {
									 obj_t aux_2140;
									 aux_2140 = CNST_TABLE_REF(((long) 0));
									 new_1517 = create_struct(aux_2140, ((long) 11));
								      }
								      STRUCT_SET(new_1517, ((long) 10), BFALSE);
								      STRUCT_SET(new_1517, ((long) 9), BUNSPEC);
								      STRUCT_SET(new_1517, ((long) 8), BFALSE);
								      STRUCT_SET(new_1517, ((long) 7), BFALSE);
								      STRUCT_SET(new_1517, ((long) 6), BFALSE);
								      STRUCT_SET(new_1517, ((long) 5), BFALSE);
								      STRUCT_SET(new_1517, ((long) 4), BUNSPEC);
								      STRUCT_SET(new_1517, ((long) 3), BFALSE);
								      STRUCT_SET(new_1517, ((long) 2), type_697);
								      STRUCT_SET(new_1517, ((long) 1), arg1501_702);
								      STRUCT_SET(new_1517, ((long) 0), arg1500_701);
								      arg1499_700 = new_1517;
								   }
								}
								arg1498_699 = MAKE_PAIR(arg1499_700, res_424);
							     }
							     {
								obj_t res_2156;
								obj_t slots_2155;
								slots_2155 = arg1497_698;
								res_2156 = arg1498_699;
								res_424 = res_2156;
								slots_423 = slots_2155;
								goto loop_425;
							     }
							  }
						       }
						    }
						  else
						    {
						       goto tag_132_226_444;
						    }
					       }
					     else
					       {
						  goto tag_132_226_444;
					       }
					  }
					else
					  {
					     goto tag_132_226_444;
					  }
				     }
				}
			   }
		      }
		   }
		 else
		   {
		      goto tag_132_226_444;
		   }
	      }
	   }
      }
   }
}


obj_t 
find_default_attr_77_object_slots(obj_t attr_740)
{
 find_default_attr_77_object_slots:
   if (PAIRP(attr_740))
     {
	{
	   obj_t e_103_175_746;
	   e_103_175_746 = CAR(attr_740);
	   if (PAIRP(e_103_175_746))
	     {
		obj_t cdr_107_0_748;
		cdr_107_0_748 = CDR(e_103_175_746);
		{
		   bool_t test_2164;
		   {
		      obj_t aux_2167;
		      obj_t aux_2165;
		      aux_2167 = CNST_TABLE_REF(((long) 6));
		      aux_2165 = CAR(e_103_175_746);
		      test_2164 = (aux_2165 == aux_2167);
		   }
		   if (test_2164)
		     {
			if (PAIRP(cdr_107_0_748))
			  {
			     bool_t test_2172;
			     {
				obj_t aux_2173;
				aux_2173 = CDR(cdr_107_0_748);
				test_2172 = (aux_2173 == BNIL);
			     }
			     if (test_2172)
			       {
				  obj_t aux_2176;
				  aux_2176 = CAR(cdr_107_0_748);
				  return MAKE_PAIR(BTRUE, aux_2176);
			       }
			     else
			       {
				tag_102_241_745:
				  {
				     obj_t attr_2179;
				     attr_2179 = CDR(attr_740);
				     attr_740 = attr_2179;
				     goto find_default_attr_77_object_slots;
				  }
			       }
			  }
			else
			  {
			     goto tag_102_241_745;
			  }
		     }
		   else
		     {
			goto tag_102_241_745;
		     }
		}
	     }
	   else
	     {
		goto tag_102_241_745;
	     }
	}
     }
   else
     {
	return CNST_TABLE_REF(((long) 7));
     }
}


obj_t 
find_assert_attr_93_object_slots(obj_t attr_711)
{
 find_assert_attr_93_object_slots:
   if (PAIRP(attr_711))
     {
	obj_t value_714;
	{
	   obj_t e_114_227_717;
	   e_114_227_717 = CAR(attr_711);
	   if (PAIRP(e_114_227_717))
	     {
		obj_t cdr_118_57_719;
		cdr_118_57_719 = CDR(e_114_227_717);
		{
		   bool_t test_2188;
		   {
		      obj_t aux_2191;
		      obj_t aux_2189;
		      aux_2191 = CNST_TABLE_REF(((long) 9));
		      aux_2189 = CAR(e_114_227_717);
		      test_2188 = (aux_2189 == aux_2191);
		   }
		   if (test_2188)
		     {
			if (PAIRP(cdr_118_57_719))
			  {
			     obj_t car_120_226_722;
			     obj_t cdr_121_50_723;
			     car_120_226_722 = CAR(cdr_118_57_719);
			     cdr_121_50_723 = CDR(cdr_118_57_719);
			     if (PAIRP(car_120_226_722))
			       {
				  bool_t test_2200;
				  {
				     obj_t aux_2201;
				     aux_2201 = CAR(car_120_226_722);
				     test_2200 = SYMBOLP(aux_2201);
				  }
				  if (test_2200)
				    {
				       bool_t test_2204;
				       {
					  obj_t aux_2205;
					  aux_2205 = CDR(car_120_226_722);
					  test_2204 = (aux_2205 == BNIL);
				       }
				       if (test_2204)
					 {
					    if (PAIRP(cdr_121_50_723))
					      {
						 bool_t test_2210;
						 {
						    obj_t aux_2211;
						    aux_2211 = CDR(cdr_121_50_723);
						    test_2210 = (aux_2211 == BNIL);
						 }
						 if (test_2210)
						   {
						      value_714 = CAR(cdr_121_50_723);
						      {
							 obj_t aux_2216;
							 obj_t aux_2214;
							 aux_2216 = CNST_TABLE_REF(((long) 8));
							 aux_2214 = CAR(attr_711);
							 SET_CAR(aux_2214, aux_2216);
						      }
						      return CAR(attr_711);
						   }
						 else
						   {
						    tag_113_246_716:
						      {
							 obj_t attr_2221;
							 attr_2221 = CDR(attr_711);
							 attr_711 = attr_2221;
							 goto find_assert_attr_93_object_slots;
						      }
						   }
					      }
					    else
					      {
						 goto tag_113_246_716;
					      }
					 }
				       else
					 {
					    goto tag_113_246_716;
					 }
				    }
				  else
				    {
				       goto tag_113_246_716;
				    }
			       }
			     else
			       {
				  goto tag_113_246_716;
			       }
			  }
			else
			  {
			     goto tag_113_246_716;
			  }
		     }
		   else
		     {
			goto tag_113_246_716;
		     }
		}
	     }
	   else
	     {
		goto tag_113_246_716;
	     }
	}
     }
   else
     {
	return BFALSE;
     }
}


obj_t 
_make_class_slots_155_object_slots(obj_t env_1644, obj_t slots_1645, obj_t super_1646, obj_t src_1647)
{
   return make_class_slots_205_object_slots(slots_1645, super_1646, src_1647);
}


obj_t 
scheme_symbol__c_string_183_object_slots(obj_t symbol_52)
{
   if (CBOOL(__case_sensitive__90_engine_param))
     {
	return id__name_228_ast_ident(symbol_52);
     }
   else
     {
	obj_t arg1554_760;
	arg1554_760 = id__name_228_ast_ident(symbol_52);
	return string_downcase_77___r4_strings_6_7(arg1554_760);
     }
}


obj_t 
imported_modules_init_94_object_slots()
{
   module_initialization_70_tools_error(((long) 0), "OBJECT_SLOTS");
   module_initialization_70_type_type(((long) 0), "OBJECT_SLOTS");
   module_initialization_70_type_cache(((long) 0), "OBJECT_SLOTS");
   module_initialization_70_ast_var(((long) 0), "OBJECT_SLOTS");
   module_initialization_70_ast_ident(((long) 0), "OBJECT_SLOTS");
   module_initialization_70_object_class(((long) 0), "OBJECT_SLOTS");
   return module_initialization_70_engine_param(((long) 0), "OBJECT_SLOTS");
}
