/*===========================================================================*/
/*   (Object/struct.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;


extern obj_t make_pragma_direct_set__7_object_tools(type_t, obj_t, obj_t, obj_t);
extern obj_t malloc_object_tools(type_t, obj_t);
static obj_t save_slot_187_object_struct(obj_t, obj_t, obj_t, long, obj_t);
static obj_t imported_modules_init_94_object_struct();
extern obj_t module_initialization_70_object_struct(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_object_tools(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t toplevel_init_63_object_struct();
static obj_t cnst_init_137_object_struct();
extern obj_t make_pragma_indexed_init_set__66_object_tools(type_t, obj_t, obj_t, obj_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t require_initialization_114_object_struct = BUNSPEC;
static obj_t library_modules_init_112_object_struct();
extern obj_t _make_struct__object_170_object_struct(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t _make_object__struct_151_object_struct(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t restore_slot_6_object_struct(obj_t, obj_t, obj_t, type_t, long, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t make_struct__wide_object_7_object_struct(obj_t, type_t, obj_t, obj_t);
extern obj_t _make_struct__wide_object_21_object_struct(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_wide_object__struct_148_object_struct(obj_t, type_t, obj_t, obj_t);
extern obj_t make_struct__object_35_object_struct(obj_t, type_t, obj_t, obj_t);
extern obj_t _make_wide_object__struct_137_object_struct(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _4dots_tools_misc;
extern obj_t make_object__struct_189_object_struct(obj_t, type_t, obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern long list_length(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t make_pragma_indexed_set__175_object_tools(type_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[46];

DEFINE_EXPORT_PROCEDURE(make_struct__wide_object_env_183_object_struct, _make_struct__wide_object_21_object_struct2475, _make_struct__wide_object_21_object_struct, 0L, 4);
DEFINE_STRING(string2469_object_struct, string2469_object_struct2476, "@ CLASS-NUM OBJECT-CLASS-NUM-SET! PRAGMA NEW OLD OBJECT-WIDENING-SET! S::STRUCT STRUCT+OBJECT->OBJECT::OBJECT VECTOR-REF-UR DONE O VECTOR-LENGTH S STRUCT-REF ::LONG V I STRUCT-KEY STRUCT-KEY-SET! CALL-NEXT-METHOD AUX ::STRUCT QUOTE MAKE-STRUCT OBJECT->STRUCT::STRUCT DEFINE-METHOD RES OBJ -LEN +FX -REF VECTOR-SET-UR! BEGIN =FX IF LABELS MAKE-VECTOR PRAGMA::LONG LET LEN LOOP J VEC - STRUCT-SET! ", 396);
DEFINE_EXPORT_PROCEDURE(make_object__struct_env_214_object_struct, _make_object__struct_151_object_struct2477, _make_object__struct_151_object_struct, 0L, 4);
DEFINE_STRING(string2467_object_struct, string2467_object_struct2478, ")($1))", 6);
DEFINE_STRING(string2468_object_struct, string2468_object_struct2479, "((", 2);
DEFINE_EXPORT_PROCEDURE(make_struct__object_env_44_object_struct, _make_struct__object_170_object_struct2480, _make_struct__object_170_object_struct, 0L, 4);
DEFINE_EXPORT_PROCEDURE(make_wide_object__struct_env_82_object_struct, _make_wide_object__struct_137_object_struct2481, _make_wide_object__struct_137_object_struct, 0L, 4);

obj_t 
module_initialization_70_object_struct(long checksum_1815, char *from_1816)
{
   if (CBOOL(require_initialization_114_object_struct))
     {
	require_initialization_114_object_struct = BBOOL(((bool_t) 0));
	library_modules_init_112_object_struct();
	cnst_init_137_object_struct();
	imported_modules_init_94_object_struct();
	toplevel_init_63_object_struct();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_object_struct()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_STRUCT");
   module_initialization_70___reader(((long) 0), "OBJECT_STRUCT");
   module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_STRUCT");
   module_initialization_70___r4_strings_6_7(((long) 0), "OBJECT_STRUCT");
   return BUNSPEC;
}


obj_t 
cnst_init_137_object_struct()
{
   {
      obj_t cnst_port_138_1807;
      cnst_port_138_1807 = open_input_string(string2469_object_struct);
      {
	 long i_1808;
	 i_1808 = ((long) 45);
       loop_1809:
	 {
	    bool_t test2470_1810;
	    test2470_1810 = (i_1808 == ((long) -1));
	    if (test2470_1810)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2471_1811;
		    {
		       obj_t list2472_1812;
		       {
			  obj_t arg2473_1813;
			  arg2473_1813 = BNIL;
			  list2472_1812 = MAKE_PAIR(cnst_port_138_1807, arg2473_1813);
		       }
		       arg2471_1811 = read___reader(list2472_1812);
		    }
		    CNST_TABLE_SET(i_1808, arg2471_1811);
		 }
		 {
		    int aux_1814;
		    {
		       long aux_1834;
		       aux_1834 = (i_1808 - ((long) 1));
		       aux_1814 = (int) (aux_1834);
		    }
		    {
		       long i_1837;
		       i_1837 = (long) (aux_1814);
		       i_1808 = i_1837;
		       goto loop_1809;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_object_struct()
{
   return BUNSPEC;
}


obj_t 
save_slot_187_object_struct(obj_t oname_47, obj_t sname_48, obj_t cname_49, long i_50, obj_t slot_51)
{
   {
      {
	 bool_t test_1839;
	 {
	    obj_t aux_1840;
	    aux_1840 = STRUCT_REF(slot_51, ((long) 5));
	    test_1839 = CBOOL(aux_1840);
	 }
	 if (test_1839)
	   {
	      {
		 obj_t vec_610;
		 obj_t j_611;
		 obj_t loop_612;
		 obj_t len_613;
		 vec_610 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 2)), BEOA);
		 j_611 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 3)), BEOA);
		 loop_612 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 4)), BEOA);
		 len_613 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 5)), BEOA);
		 {
		    obj_t arg1444_614;
		    obj_t arg1445_615;
		    obj_t arg1446_616;
		    arg1444_614 = CNST_TABLE_REF(((long) 6));
		    {
		       obj_t arg1453_622;
		       {
			  obj_t arg1458_626;
			  {
			     obj_t arg1466_631;
			     {
				obj_t arg1472_636;
				obj_t arg1474_637;
				arg1472_636 = CNST_TABLE_REF(((long) 1));
				arg1474_637 = STRUCT_REF(slot_51, ((long) 0));
				{
				   obj_t list1477_639;
				   {
				      obj_t arg1478_640;
				      {
					 obj_t arg1480_641;
					 {
					    obj_t arg1481_642;
					    {
					       obj_t aux_1858;
					       aux_1858 = CNST_TABLE_REF(((long) 16));
					       arg1481_642 = MAKE_PAIR(aux_1858, BNIL);
					    }
					    arg1480_641 = MAKE_PAIR(arg1474_637, arg1481_642);
					 }
					 arg1478_640 = MAKE_PAIR(arg1472_636, arg1480_641);
				      }
				      list1477_639 = MAKE_PAIR(cname_49, arg1478_640);
				   }
				   arg1466_631 = symbol_append_197___r4_symbols_6_4(list1477_639);
				}
			     }
			     {
				obj_t list1468_633;
				{
				   obj_t arg1470_634;
				   arg1470_634 = MAKE_PAIR(BNIL, BNIL);
				   list1468_633 = MAKE_PAIR(oname_47, arg1470_634);
				}
				arg1458_626 = cons__138___r4_pairs_and_lists_6_3(arg1466_631, list1468_633);
			     }
			  }
			  {
			     obj_t list1462_628;
			     {
				obj_t arg1463_629;
				arg1463_629 = MAKE_PAIR(BNIL, BNIL);
				list1462_628 = MAKE_PAIR(arg1458_626, arg1463_629);
			     }
			     arg1453_622 = cons__138___r4_pairs_and_lists_6_3(len_613, list1462_628);
			  }
		       }
		       {
			  obj_t list1455_624;
			  list1455_624 = MAKE_PAIR(BNIL, BNIL);
			  arg1445_615 = cons__138___r4_pairs_and_lists_6_3(arg1453_622, list1455_624);
		       }
		    }
		    {
		       obj_t arg1485_644;
		       obj_t arg1486_645;
		       obj_t arg1487_646;
		       arg1485_644 = CNST_TABLE_REF(((long) 6));
		       {
			  obj_t arg1497_652;
			  {
			     obj_t arg1501_656;
			     {
				obj_t arg1510_661;
				arg1510_661 = CNST_TABLE_REF(((long) 8));
				{
				   obj_t list1512_663;
				   {
				      obj_t arg1513_664;
				      arg1513_664 = MAKE_PAIR(BNIL, BNIL);
				      list1512_663 = MAKE_PAIR(len_613, arg1513_664);
				   }
				   arg1501_656 = cons__138___r4_pairs_and_lists_6_3(arg1510_661, list1512_663);
				}
			     }
			     {
				obj_t list1506_658;
				{
				   obj_t arg1507_659;
				   arg1507_659 = MAKE_PAIR(BNIL, BNIL);
				   list1506_658 = MAKE_PAIR(arg1501_656, arg1507_659);
				}
				arg1497_652 = cons__138___r4_pairs_and_lists_6_3(vec_610, list1506_658);
			     }
			  }
			  {
			     obj_t list1499_654;
			     list1499_654 = MAKE_PAIR(BNIL, BNIL);
			     arg1486_645 = cons__138___r4_pairs_and_lists_6_3(arg1497_652, list1499_654);
			  }
		       }
		       {
			  obj_t arg1517_666;
			  obj_t arg1518_667;
			  obj_t arg1520_668;
			  arg1517_666 = CNST_TABLE_REF(((long) 9));
			  {
			     obj_t arg1531_674;
			     {
				obj_t arg1535_678;
				obj_t arg1536_679;
				{
				   obj_t list1543_686;
				   list1543_686 = MAKE_PAIR(BNIL, BNIL);
				   arg1535_678 = cons__138___r4_pairs_and_lists_6_3(j_611, list1543_686);
				}
				{
				   obj_t arg1549_688;
				   obj_t arg1550_689;
				   obj_t arg1551_690;
				   obj_t arg1552_691;
				   arg1549_688 = CNST_TABLE_REF(((long) 10));
				   {
				      obj_t arg1561_698;
				      arg1561_698 = CNST_TABLE_REF(((long) 11));
				      {
					 obj_t list1563_700;
					 {
					    obj_t arg1564_701;
					    {
					       obj_t arg1565_702;
					       arg1565_702 = MAKE_PAIR(BNIL, BNIL);
					       arg1564_701 = MAKE_PAIR(len_613, arg1565_702);
					    }
					    list1563_700 = MAKE_PAIR(j_611, arg1564_701);
					 }
					 arg1550_689 = cons__138___r4_pairs_and_lists_6_3(arg1561_698, list1563_700);
				      }
				   }
				   {
				      obj_t arg1567_704;
				      arg1567_704 = CNST_TABLE_REF(((long) 0));
				      {
					 obj_t list1569_706;
					 {
					    obj_t arg1570_707;
					    {
					       obj_t arg1571_708;
					       {
						  obj_t arg1572_709;
						  arg1572_709 = MAKE_PAIR(BNIL, BNIL);
						  arg1571_708 = MAKE_PAIR(vec_610, arg1572_709);
					       }
					       {
						  obj_t aux_1895;
						  aux_1895 = BINT(i_50);
						  arg1570_707 = MAKE_PAIR(aux_1895, arg1571_708);
					       }
					    }
					    list1569_706 = MAKE_PAIR(sname_48, arg1570_707);
					 }
					 arg1551_690 = cons__138___r4_pairs_and_lists_6_3(arg1567_704, list1569_706);
				      }
				   }
				   {
				      obj_t arg1574_711;
				      obj_t arg1575_712;
				      obj_t arg1576_713;
				      arg1574_711 = CNST_TABLE_REF(((long) 12));
				      {
					 obj_t arg1584_719;
					 obj_t arg1585_720;
					 arg1584_719 = CNST_TABLE_REF(((long) 13));
					 {
					    obj_t arg1593_727;
					    {
					       obj_t arg1603_733;
					       obj_t arg1604_734;
					       arg1603_733 = CNST_TABLE_REF(((long) 1));
					       arg1604_734 = STRUCT_REF(slot_51, ((long) 0));
					       {
						  obj_t list1606_736;
						  {
						     obj_t arg1608_737;
						     {
							obj_t arg1609_738;
							{
							   obj_t arg1611_739;
							   {
							      obj_t aux_1904;
							      aux_1904 = CNST_TABLE_REF(((long) 14));
							      arg1611_739 = MAKE_PAIR(aux_1904, BNIL);
							   }
							   arg1609_738 = MAKE_PAIR(arg1604_734, arg1611_739);
							}
							arg1608_737 = MAKE_PAIR(arg1603_733, arg1609_738);
						     }
						     list1606_736 = MAKE_PAIR(cname_49, arg1608_737);
						  }
						  arg1593_727 = symbol_append_197___r4_symbols_6_4(list1606_736);
					       }
					    }
					    {
					       obj_t list1596_729;
					       {
						  obj_t arg1597_730;
						  {
						     obj_t arg1600_731;
						     arg1600_731 = MAKE_PAIR(BNIL, BNIL);
						     arg1597_730 = MAKE_PAIR(j_611, arg1600_731);
						  }
						  list1596_729 = MAKE_PAIR(oname_47, arg1597_730);
					       }
					       arg1585_720 = cons__138___r4_pairs_and_lists_6_3(arg1593_727, list1596_729);
					    }
					 }
					 {
					    obj_t list1588_722;
					    {
					       obj_t arg1589_723;
					       {
						  obj_t arg1590_724;
						  {
						     obj_t arg1591_725;
						     arg1591_725 = MAKE_PAIR(BNIL, BNIL);
						     arg1590_724 = MAKE_PAIR(arg1585_720, arg1591_725);
						  }
						  arg1589_723 = MAKE_PAIR(j_611, arg1590_724);
					       }
					       list1588_722 = MAKE_PAIR(vec_610, arg1589_723);
					    }
					    arg1575_712 = cons__138___r4_pairs_and_lists_6_3(arg1584_719, list1588_722);
					 }
				      }
				      {
					 obj_t arg1616_741;
					 {
					    obj_t arg1621_746;
					    arg1621_746 = CNST_TABLE_REF(((long) 15));
					    {
					       obj_t list1625_749;
					       {
						  obj_t arg1626_750;
						  {
						     obj_t arg1627_751;
						     arg1627_751 = MAKE_PAIR(BNIL, BNIL);
						     {
							obj_t aux_1922;
							aux_1922 = BINT(((long) 1));
							arg1626_750 = MAKE_PAIR(aux_1922, arg1627_751);
						     }
						  }
						  list1625_749 = MAKE_PAIR(j_611, arg1626_750);
					       }
					       arg1616_741 = cons__138___r4_pairs_and_lists_6_3(arg1621_746, list1625_749);
					    }
					 }
					 {
					    obj_t list1618_743;
					    {
					       obj_t arg1619_744;
					       arg1619_744 = MAKE_PAIR(BNIL, BNIL);
					       list1618_743 = MAKE_PAIR(arg1616_741, arg1619_744);
					    }
					    arg1576_713 = cons__138___r4_pairs_and_lists_6_3(loop_612, list1618_743);
					 }
				      }
				      {
					 obj_t list1578_715;
					 {
					    obj_t arg1579_716;
					    {
					       obj_t arg1582_717;
					       arg1582_717 = MAKE_PAIR(BNIL, BNIL);
					       arg1579_716 = MAKE_PAIR(arg1576_713, arg1582_717);
					    }
					    list1578_715 = MAKE_PAIR(arg1575_712, arg1579_716);
					 }
					 arg1552_691 = cons__138___r4_pairs_and_lists_6_3(arg1574_711, list1578_715);
				      }
				   }
				   {
				      obj_t list1554_693;
				      {
					 obj_t arg1555_694;
					 {
					    obj_t arg1557_695;
					    {
					       obj_t arg1559_696;
					       arg1559_696 = MAKE_PAIR(BNIL, BNIL);
					       arg1557_695 = MAKE_PAIR(arg1552_691, arg1559_696);
					    }
					    arg1555_694 = MAKE_PAIR(arg1551_690, arg1557_695);
					 }
					 list1554_693 = MAKE_PAIR(arg1550_689, arg1555_694);
				      }
				      arg1536_679 = cons__138___r4_pairs_and_lists_6_3(arg1549_688, list1554_693);
				   }
				}
				{
				   obj_t list1538_681;
				   {
				      obj_t arg1539_682;
				      {
					 obj_t arg1540_683;
					 arg1540_683 = MAKE_PAIR(BNIL, BNIL);
					 arg1539_682 = MAKE_PAIR(arg1536_679, arg1540_683);
				      }
				      list1538_681 = MAKE_PAIR(arg1535_678, arg1539_682);
				   }
				   arg1531_674 = cons__138___r4_pairs_and_lists_6_3(loop_612, list1538_681);
				}
			     }
			     {
				obj_t list1533_676;
				list1533_676 = MAKE_PAIR(BNIL, BNIL);
				arg1518_667 = cons__138___r4_pairs_and_lists_6_3(arg1531_674, list1533_676);
			     }
			  }
			  {
			     obj_t list1633_755;
			     {
				obj_t arg1634_756;
				arg1634_756 = MAKE_PAIR(BNIL, BNIL);
				{
				   obj_t aux_1946;
				   aux_1946 = BINT(((long) 0));
				   list1633_755 = MAKE_PAIR(aux_1946, arg1634_756);
				}
			     }
			     arg1520_668 = cons__138___r4_pairs_and_lists_6_3(loop_612, list1633_755);
			  }
			  {
			     obj_t list1523_670;
			     {
				obj_t arg1524_671;
				{
				   obj_t arg1526_672;
				   arg1526_672 = MAKE_PAIR(BNIL, BNIL);
				   arg1524_671 = MAKE_PAIR(arg1520_668, arg1526_672);
				}
				list1523_670 = MAKE_PAIR(arg1518_667, arg1524_671);
			     }
			     arg1487_646 = cons__138___r4_pairs_and_lists_6_3(arg1517_666, list1523_670);
			  }
		       }
		       {
			  obj_t list1490_648;
			  {
			     obj_t arg1493_649;
			     {
				obj_t arg1494_650;
				arg1494_650 = MAKE_PAIR(BNIL, BNIL);
				arg1493_649 = MAKE_PAIR(arg1487_646, arg1494_650);
			     }
			     list1490_648 = MAKE_PAIR(arg1486_645, arg1493_649);
			  }
			  arg1446_616 = cons__138___r4_pairs_and_lists_6_3(arg1485_644, list1490_648);
		       }
		    }
		    {
		       obj_t list1448_618;
		       {
			  obj_t arg1449_619;
			  {
			     obj_t arg1450_620;
			     arg1450_620 = MAKE_PAIR(BNIL, BNIL);
			     arg1449_619 = MAKE_PAIR(arg1446_616, arg1450_620);
			  }
			  list1448_618 = MAKE_PAIR(arg1445_615, arg1449_619);
		       }
		       return cons__138___r4_pairs_and_lists_6_3(arg1444_614, list1448_618);
		    }
		 }
	      }
	   }
	 else
	   {
	      bool_t test_1962;
	      {
		 obj_t aux_1963;
		 aux_1963 = STRUCT_REF(slot_51, ((long) 3));
		 test_1962 = CBOOL(aux_1963);
	      }
	      if (test_1962)
		{
		   {
		      obj_t vec_464;
		      obj_t j_465;
		      obj_t loop_466;
		      obj_t len_467;
		      vec_464 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 2)), BEOA);
		      j_465 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 3)), BEOA);
		      loop_466 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 4)), BEOA);
		      len_467 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 5)), BEOA);
		      {
			 obj_t arg1231_468;
			 obj_t arg1233_469;
			 obj_t arg1234_470;
			 arg1231_468 = CNST_TABLE_REF(((long) 6));
			 {
			    obj_t arg1241_476;
			    {
			       obj_t arg1246_480;
			       {
				  obj_t arg1255_485;
				  obj_t arg1256_486;
				  arg1255_485 = CNST_TABLE_REF(((long) 7));
				  arg1256_486 = STRUCT_REF(slot_51, ((long) 4));
				  {
				     obj_t list1258_488;
				     {
					obj_t arg1259_489;
					arg1259_489 = MAKE_PAIR(BNIL, BNIL);
					list1258_488 = MAKE_PAIR(arg1256_486, arg1259_489);
				     }
				     arg1246_480 = cons__138___r4_pairs_and_lists_6_3(arg1255_485, list1258_488);
				  }
			       }
			       {
				  obj_t list1248_482;
				  {
				     obj_t arg1251_483;
				     arg1251_483 = MAKE_PAIR(BNIL, BNIL);
				     list1248_482 = MAKE_PAIR(arg1246_480, arg1251_483);
				  }
				  arg1241_476 = cons__138___r4_pairs_and_lists_6_3(len_467, list1248_482);
			       }
			    }
			    {
			       obj_t list1243_478;
			       list1243_478 = MAKE_PAIR(BNIL, BNIL);
			       arg1233_469 = cons__138___r4_pairs_and_lists_6_3(arg1241_476, list1243_478);
			    }
			 }
			 {
			    obj_t arg1261_491;
			    obj_t arg1265_492;
			    obj_t arg1266_493;
			    arg1261_491 = CNST_TABLE_REF(((long) 6));
			    {
			       obj_t arg1273_499;
			       {
				  obj_t arg1279_503;
				  {
				     obj_t arg1284_508;
				     arg1284_508 = CNST_TABLE_REF(((long) 8));
				     {
					obj_t list1287_510;
					{
					   obj_t arg1290_511;
					   arg1290_511 = MAKE_PAIR(BNIL, BNIL);
					   list1287_510 = MAKE_PAIR(len_467, arg1290_511);
					}
					arg1279_503 = cons__138___r4_pairs_and_lists_6_3(arg1284_508, list1287_510);
				     }
				  }
				  {
				     obj_t list1281_505;
				     {
					obj_t arg1282_506;
					arg1282_506 = MAKE_PAIR(BNIL, BNIL);
					list1281_505 = MAKE_PAIR(arg1279_503, arg1282_506);
				     }
				     arg1273_499 = cons__138___r4_pairs_and_lists_6_3(vec_464, list1281_505);
				  }
			       }
			       {
				  obj_t list1276_501;
				  list1276_501 = MAKE_PAIR(BNIL, BNIL);
				  arg1265_492 = cons__138___r4_pairs_and_lists_6_3(arg1273_499, list1276_501);
			       }
			    }
			    {
			       obj_t arg1295_513;
			       obj_t arg1296_514;
			       obj_t arg1297_515;
			       arg1295_513 = CNST_TABLE_REF(((long) 9));
			       {
				  obj_t arg1307_521;
				  {
				     obj_t arg1311_525;
				     obj_t arg1312_526;
				     {
					obj_t list1320_533;
					list1320_533 = MAKE_PAIR(BNIL, BNIL);
					arg1311_525 = cons__138___r4_pairs_and_lists_6_3(j_465, list1320_533);
				     }
				     {
					obj_t arg1322_535;
					obj_t arg1323_536;
					obj_t arg1325_537;
					obj_t arg1327_538;
					arg1322_535 = CNST_TABLE_REF(((long) 10));
					{
					   obj_t arg1337_545;
					   arg1337_545 = CNST_TABLE_REF(((long) 11));
					   {
					      obj_t list1340_547;
					      {
						 obj_t arg1342_548;
						 {
						    obj_t arg1343_549;
						    arg1343_549 = MAKE_PAIR(BNIL, BNIL);
						    arg1342_548 = MAKE_PAIR(len_467, arg1343_549);
						 }
						 list1340_547 = MAKE_PAIR(j_465, arg1342_548);
					      }
					      arg1323_536 = cons__138___r4_pairs_and_lists_6_3(arg1337_545, list1340_547);
					   }
					}
					{
					   obj_t arg1346_551;
					   arg1346_551 = CNST_TABLE_REF(((long) 0));
					   {
					      obj_t list1348_553;
					      {
						 obj_t arg1349_554;
						 {
						    obj_t arg1350_555;
						    {
						       obj_t arg1352_556;
						       arg1352_556 = MAKE_PAIR(BNIL, BNIL);
						       arg1350_555 = MAKE_PAIR(vec_464, arg1352_556);
						    }
						    {
						       obj_t aux_2011;
						       aux_2011 = BINT(i_50);
						       arg1349_554 = MAKE_PAIR(aux_2011, arg1350_555);
						    }
						 }
						 list1348_553 = MAKE_PAIR(sname_48, arg1349_554);
					      }
					      arg1325_537 = cons__138___r4_pairs_and_lists_6_3(arg1346_551, list1348_553);
					   }
					}
					{
					   obj_t arg1355_558;
					   obj_t arg1356_559;
					   obj_t arg1357_560;
					   arg1355_558 = CNST_TABLE_REF(((long) 12));
					   {
					      obj_t arg1366_566;
					      obj_t arg1367_567;
					      arg1366_566 = CNST_TABLE_REF(((long) 13));
					      {
						 obj_t arg1381_574;
						 {
						    obj_t arg1391_580;
						    obj_t arg1396_581;
						    arg1391_580 = CNST_TABLE_REF(((long) 1));
						    arg1396_581 = STRUCT_REF(slot_51, ((long) 0));
						    {
						       obj_t list1399_583;
						       {
							  obj_t arg1400_584;
							  {
							     obj_t arg1402_585;
							     {
								obj_t arg1403_586;
								{
								   obj_t aux_2020;
								   aux_2020 = CNST_TABLE_REF(((long) 14));
								   arg1403_586 = MAKE_PAIR(aux_2020, BNIL);
								}
								arg1402_585 = MAKE_PAIR(arg1396_581, arg1403_586);
							     }
							     arg1400_584 = MAKE_PAIR(arg1391_580, arg1402_585);
							  }
							  list1399_583 = MAKE_PAIR(cname_49, arg1400_584);
						       }
						       arg1381_574 = symbol_append_197___r4_symbols_6_4(list1399_583);
						    }
						 }
						 {
						    obj_t list1383_576;
						    {
						       obj_t arg1385_577;
						       {
							  obj_t arg1388_578;
							  arg1388_578 = MAKE_PAIR(BNIL, BNIL);
							  arg1385_577 = MAKE_PAIR(j_465, arg1388_578);
						       }
						       list1383_576 = MAKE_PAIR(oname_47, arg1385_577);
						    }
						    arg1367_567 = cons__138___r4_pairs_and_lists_6_3(arg1381_574, list1383_576);
						 }
					      }
					      {
						 obj_t list1370_569;
						 {
						    obj_t arg1372_570;
						    {
						       obj_t arg1376_571;
						       {
							  obj_t arg1379_572;
							  arg1379_572 = MAKE_PAIR(BNIL, BNIL);
							  arg1376_571 = MAKE_PAIR(arg1367_567, arg1379_572);
						       }
						       arg1372_570 = MAKE_PAIR(j_465, arg1376_571);
						    }
						    list1370_569 = MAKE_PAIR(vec_464, arg1372_570);
						 }
						 arg1356_559 = cons__138___r4_pairs_and_lists_6_3(arg1366_566, list1370_569);
					      }
					   }
					   {
					      obj_t arg1406_588;
					      {
						 obj_t arg1412_593;
						 arg1412_593 = CNST_TABLE_REF(((long) 15));
						 {
						    obj_t list1416_596;
						    {
						       obj_t arg1417_597;
						       {
							  obj_t arg1418_598;
							  arg1418_598 = MAKE_PAIR(BNIL, BNIL);
							  {
							     obj_t aux_2038;
							     aux_2038 = BINT(((long) 1));
							     arg1417_597 = MAKE_PAIR(aux_2038, arg1418_598);
							  }
						       }
						       list1416_596 = MAKE_PAIR(j_465, arg1417_597);
						    }
						    arg1406_588 = cons__138___r4_pairs_and_lists_6_3(arg1412_593, list1416_596);
						 }
					      }
					      {
						 obj_t list1409_590;
						 {
						    obj_t arg1410_591;
						    arg1410_591 = MAKE_PAIR(BNIL, BNIL);
						    list1409_590 = MAKE_PAIR(arg1406_588, arg1410_591);
						 }
						 arg1357_560 = cons__138___r4_pairs_and_lists_6_3(loop_466, list1409_590);
					      }
					   }
					   {
					      obj_t list1359_562;
					      {
						 obj_t arg1361_563;
						 {
						    obj_t arg1363_564;
						    arg1363_564 = MAKE_PAIR(BNIL, BNIL);
						    arg1361_563 = MAKE_PAIR(arg1357_560, arg1363_564);
						 }
						 list1359_562 = MAKE_PAIR(arg1356_559, arg1361_563);
					      }
					      arg1327_538 = cons__138___r4_pairs_and_lists_6_3(arg1355_558, list1359_562);
					   }
					}
					{
					   obj_t list1329_540;
					   {
					      obj_t arg1331_541;
					      {
						 obj_t arg1332_542;
						 {
						    obj_t arg1333_543;
						    arg1333_543 = MAKE_PAIR(BNIL, BNIL);
						    arg1332_542 = MAKE_PAIR(arg1327_538, arg1333_543);
						 }
						 arg1331_541 = MAKE_PAIR(arg1325_537, arg1332_542);
					      }
					      list1329_540 = MAKE_PAIR(arg1323_536, arg1331_541);
					   }
					   arg1312_526 = cons__138___r4_pairs_and_lists_6_3(arg1322_535, list1329_540);
					}
				     }
				     {
					obj_t list1314_528;
					{
					   obj_t arg1315_529;
					   {
					      obj_t arg1316_530;
					      arg1316_530 = MAKE_PAIR(BNIL, BNIL);
					      arg1315_529 = MAKE_PAIR(arg1312_526, arg1316_530);
					   }
					   list1314_528 = MAKE_PAIR(arg1311_525, arg1315_529);
					}
					arg1307_521 = cons__138___r4_pairs_and_lists_6_3(loop_466, list1314_528);
				     }
				  }
				  {
				     obj_t list1309_523;
				     list1309_523 = MAKE_PAIR(BNIL, BNIL);
				     arg1296_514 = cons__138___r4_pairs_and_lists_6_3(arg1307_521, list1309_523);
				  }
			       }
			       {
				  obj_t list1425_602;
				  {
				     obj_t arg1426_603;
				     arg1426_603 = MAKE_PAIR(BNIL, BNIL);
				     {
					obj_t aux_2062;
					aux_2062 = BINT(((long) 0));
					list1425_602 = MAKE_PAIR(aux_2062, arg1426_603);
				     }
				  }
				  arg1297_515 = cons__138___r4_pairs_and_lists_6_3(loop_466, list1425_602);
			       }
			       {
				  obj_t list1299_517;
				  {
				     obj_t arg1300_518;
				     {
					obj_t arg1303_519;
					arg1303_519 = MAKE_PAIR(BNIL, BNIL);
					arg1300_518 = MAKE_PAIR(arg1297_515, arg1303_519);
				     }
				     list1299_517 = MAKE_PAIR(arg1296_514, arg1300_518);
				  }
				  arg1266_493 = cons__138___r4_pairs_and_lists_6_3(arg1295_513, list1299_517);
			       }
			    }
			    {
			       obj_t list1268_495;
			       {
				  obj_t arg1270_496;
				  {
				     obj_t arg1271_497;
				     arg1271_497 = MAKE_PAIR(BNIL, BNIL);
				     arg1270_496 = MAKE_PAIR(arg1266_493, arg1271_497);
				  }
				  list1268_495 = MAKE_PAIR(arg1265_492, arg1270_496);
			       }
			       arg1234_470 = cons__138___r4_pairs_and_lists_6_3(arg1261_491, list1268_495);
			    }
			 }
			 {
			    obj_t list1236_472;
			    {
			       obj_t arg1237_473;
			       {
				  obj_t arg1239_474;
				  arg1239_474 = MAKE_PAIR(BNIL, BNIL);
				  arg1237_473 = MAKE_PAIR(arg1234_470, arg1239_474);
			       }
			       list1236_472 = MAKE_PAIR(arg1233_469, arg1237_473);
			    }
			    return cons__138___r4_pairs_and_lists_6_3(arg1231_468, list1236_472);
			 }
		      }
		   }
		}
	      else
		{
		   {
		      obj_t arg1203_444;
		      obj_t arg1204_445;
		      arg1203_444 = CNST_TABLE_REF(((long) 0));
		      {
			 obj_t arg1212_452;
			 {
			    obj_t arg1219_457;
			    arg1219_457 = CNST_TABLE_REF(((long) 1));
			    {
			       obj_t list1223_459;
			       {
				  obj_t arg1225_460;
				  {
				     obj_t arg1227_461;
				     {
					obj_t aux_2080;
					aux_2080 = STRUCT_REF(slot_51, ((long) 0));
					arg1227_461 = MAKE_PAIR(aux_2080, BNIL);
				     }
				     arg1225_460 = MAKE_PAIR(arg1219_457, arg1227_461);
				  }
				  list1223_459 = MAKE_PAIR(cname_49, arg1225_460);
			       }
			       arg1212_452 = symbol_append_197___r4_symbols_6_4(list1223_459);
			    }
			 }
			 {
			    obj_t list1214_454;
			    {
			       obj_t arg1217_455;
			       arg1217_455 = MAKE_PAIR(BNIL, BNIL);
			       list1214_454 = MAKE_PAIR(oname_47, arg1217_455);
			    }
			    arg1204_445 = cons__138___r4_pairs_and_lists_6_3(arg1212_452, list1214_454);
			 }
		      }
		      {
			 obj_t list1206_447;
			 {
			    obj_t arg1207_448;
			    {
			       obj_t arg1208_449;
			       {
				  obj_t arg1209_450;
				  arg1209_450 = MAKE_PAIR(BNIL, BNIL);
				  arg1208_449 = MAKE_PAIR(arg1204_445, arg1209_450);
			       }
			       {
				  obj_t aux_2091;
				  aux_2091 = BINT(i_50);
				  arg1207_448 = MAKE_PAIR(aux_2091, arg1208_449);
			       }
			    }
			    list1206_447 = MAKE_PAIR(sname_48, arg1207_448);
			 }
			 return cons__138___r4_pairs_and_lists_6_3(arg1203_444, list1206_447);
		      }
		   }
		}
	   }
      }
   }
}


obj_t 
make_object__struct_189_object_struct(obj_t cname_52, type_t type_53, obj_t module_54, obj_t slots_55)
{
   {
      long len_765;
      obj_t oname_766;
      obj_t sname_767;
      {
	 long aux_2096;
	 aux_2096 = list_length(slots_55);
	 len_765 = (((long) 1) + aux_2096);
      }
      oname_766 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 17)), BEOA);
      sname_767 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 18)), BEOA);
      {
	 obj_t arg1644_768;
	 obj_t arg1645_769;
	 obj_t arg1646_770;
	 arg1644_768 = CNST_TABLE_REF(((long) 19));
	 {
	    obj_t arg1653_776;
	    obj_t arg1654_777;
	    arg1653_776 = CNST_TABLE_REF(((long) 20));
	    {
	       obj_t list1660_782;
	       {
		  obj_t arg1661_783;
		  {
		     obj_t arg1663_784;
		     arg1663_784 = MAKE_PAIR(cname_52, BNIL);
		     arg1661_783 = MAKE_PAIR(_4dots_tools_misc, arg1663_784);
		  }
		  list1660_782 = MAKE_PAIR(oname_766, arg1661_783);
	       }
	       arg1654_777 = symbol_append_197___r4_symbols_6_4(list1660_782);
	    }
	    {
	       obj_t list1656_779;
	       {
		  obj_t arg1657_780;
		  arg1657_780 = MAKE_PAIR(BNIL, BNIL);
		  list1656_779 = MAKE_PAIR(arg1654_777, arg1657_780);
	       }
	       arg1645_769 = cons__138___r4_pairs_and_lists_6_3(arg1653_776, list1656_779);
	    }
	 }
	 {
	    obj_t arg1665_786;
	    obj_t arg1667_787;
	    obj_t arg1668_788;
	    arg1665_786 = CNST_TABLE_REF(((long) 6));
	    {
	       obj_t arg1677_794;
	       {
		  obj_t arg1681_798;
		  {
		     obj_t arg1687_803;
		     obj_t arg1688_804;
		     arg1687_803 = CNST_TABLE_REF(((long) 21));
		     {
			obj_t arg1696_811;
			arg1696_811 = CNST_TABLE_REF(((long) 22));
			{
			   obj_t list1698_813;
			   {
			      obj_t arg1699_814;
			      arg1699_814 = MAKE_PAIR(BNIL, BNIL);
			      list1698_813 = MAKE_PAIR(cname_52, arg1699_814);
			   }
			   arg1688_804 = cons__138___r4_pairs_and_lists_6_3(arg1696_811, list1698_813);
			}
		     }
		     {
			obj_t list1690_806;
			{
			   obj_t arg1691_807;
			   {
			      obj_t arg1693_808;
			      {
				 obj_t arg1694_809;
				 arg1694_809 = MAKE_PAIR(BNIL, BNIL);
				 arg1693_808 = MAKE_PAIR(BUNSPEC, arg1694_809);
			      }
			      {
				 obj_t aux_2122;
				 aux_2122 = BINT(len_765);
				 arg1691_807 = MAKE_PAIR(aux_2122, arg1693_808);
			      }
			   }
			   list1690_806 = MAKE_PAIR(arg1688_804, arg1691_807);
			}
			arg1681_798 = cons__138___r4_pairs_and_lists_6_3(arg1687_803, list1690_806);
		     }
		  }
		  {
		     obj_t list1683_800;
		     {
			obj_t arg1684_801;
			arg1684_801 = MAKE_PAIR(BNIL, BNIL);
			list1683_800 = MAKE_PAIR(arg1681_798, arg1684_801);
		     }
		     arg1677_794 = cons__138___r4_pairs_and_lists_6_3(sname_767, list1683_800);
		  }
	       }
	       {
		  obj_t list1679_796;
		  list1679_796 = MAKE_PAIR(BNIL, BNIL);
		  arg1667_787 = cons__138___r4_pairs_and_lists_6_3(arg1677_794, list1679_796);
	       }
	    }
	    {
	       obj_t arg1702_816;
	       obj_t arg1703_817;
	       obj_t arg1704_818;
	       arg1702_816 = CNST_TABLE_REF(((long) 12));
	       {
		  obj_t arg1708_822;
		  arg1708_822 = CNST_TABLE_REF(((long) 0));
		  {
		     obj_t list1711_825;
		     {
			obj_t arg1712_826;
			{
			   obj_t arg1714_827;
			   {
			      obj_t arg1715_828;
			      arg1715_828 = MAKE_PAIR(BNIL, BNIL);
			      arg1714_827 = MAKE_PAIR(BFALSE, arg1715_828);
			   }
			   {
			      obj_t aux_2136;
			      aux_2136 = BINT(((long) 0));
			      arg1712_826 = MAKE_PAIR(aux_2136, arg1714_827);
			   }
			}
			list1711_825 = MAKE_PAIR(sname_767, arg1712_826);
		     }
		     arg1703_817 = cons__138___r4_pairs_and_lists_6_3(arg1708_822, list1711_825);
		  }
	       }
	       {
		  obj_t arg1717_830;
		  obj_t arg1718_831;
		  {
		     long i_832;
		     obj_t slots_833;
		     obj_t res_834;
		     i_832 = ((long) 1);
		     slots_833 = slots_55;
		     res_834 = BNIL;
		   loop_835:
		     if ((i_832 == len_765))
		       {
			  arg1717_830 = reverse__39___r4_pairs_and_lists_6_3(res_834);
		       }
		     else
		       {
			  long arg1722_839;
			  obj_t arg1724_840;
			  obj_t arg1725_841;
			  arg1722_839 = (i_832 + ((long) 1));
			  arg1724_840 = CDR(slots_833);
			  {
			     obj_t arg1730_842;
			     arg1730_842 = save_slot_187_object_struct(oname_766, sname_767, cname_52, i_832, CAR(slots_833));
			     arg1725_841 = MAKE_PAIR(arg1730_842, res_834);
			  }
			  {
			     obj_t res_2151;
			     obj_t slots_2150;
			     long i_2149;
			     i_2149 = arg1722_839;
			     slots_2150 = arg1724_840;
			     res_2151 = arg1725_841;
			     res_834 = res_2151;
			     slots_833 = slots_2150;
			     i_832 = i_2149;
			     goto loop_835;
			  }
		       }
		  }
		  {
		     obj_t list1733_845;
		     list1733_845 = MAKE_PAIR(BNIL, BNIL);
		     arg1718_831 = cons__138___r4_pairs_and_lists_6_3(sname_767, list1733_845);
		  }
		  arg1704_818 = append_2_18___r4_pairs_and_lists_6_3(arg1717_830, arg1718_831);
	       }
	       {
		  obj_t list1705_819;
		  {
		     obj_t arg1706_820;
		     arg1706_820 = MAKE_PAIR(arg1704_818, BNIL);
		     list1705_819 = MAKE_PAIR(arg1703_817, arg1706_820);
		  }
		  arg1668_788 = cons__138___r4_pairs_and_lists_6_3(arg1702_816, list1705_819);
	       }
	    }
	    {
	       obj_t list1670_790;
	       {
		  obj_t arg1671_791;
		  {
		     obj_t arg1673_792;
		     arg1673_792 = MAKE_PAIR(BNIL, BNIL);
		     arg1671_791 = MAKE_PAIR(arg1668_788, arg1673_792);
		  }
		  list1670_790 = MAKE_PAIR(arg1667_787, arg1671_791);
	       }
	       arg1646_770 = cons__138___r4_pairs_and_lists_6_3(arg1665_786, list1670_790);
	    }
	 }
	 {
	    obj_t list1648_772;
	    {
	       obj_t arg1650_773;
	       {
		  obj_t arg1651_774;
		  arg1651_774 = MAKE_PAIR(BNIL, BNIL);
		  arg1650_773 = MAKE_PAIR(arg1646_770, arg1651_774);
	       }
	       list1648_772 = MAKE_PAIR(arg1645_769, arg1650_773);
	    }
	    return cons__138___r4_pairs_and_lists_6_3(arg1644_768, list1648_772);
	 }
      }
   }
}


obj_t 
_make_object__struct_151_object_struct(obj_t env_1786, obj_t cname_1787, obj_t type_1788, obj_t module_1789, obj_t slots_1790)
{
   return make_object__struct_189_object_struct(cname_1787, (type_t) (type_1788), module_1789, slots_1790);
}


obj_t 
make_wide_object__struct_148_object_struct(obj_t cname_56, type_t type_57, obj_t module_58, obj_t slots_59)
{
   {
      long len_851;
      len_851 = list_length(slots_59);
      {
	 obj_t oname_852;
	 oname_852 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 17)), BEOA);
	 {
	    obj_t res_853;
	    res_853 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 18)), BEOA);
	    {
	       obj_t tres_854;
	       {
		  obj_t list1878_980;
		  {
		     obj_t arg1879_981;
		     {
			obj_t aux_2175;
			aux_2175 = CNST_TABLE_REF(((long) 23));
			arg1879_981 = MAKE_PAIR(aux_2175, BNIL);
		     }
		     list1878_980 = MAKE_PAIR(res_853, arg1879_981);
		  }
		  tres_854 = symbol_append_197___r4_symbols_6_4(list1878_980);
	       }
	       {
		  obj_t aux_855;
		  aux_855 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 24)), BEOA);
		  {
		     {
			obj_t arg1740_856;
			obj_t arg1741_857;
			obj_t arg1742_858;
			arg1740_856 = CNST_TABLE_REF(((long) 19));
			{
			   obj_t arg1748_864;
			   obj_t arg1749_865;
			   arg1748_864 = CNST_TABLE_REF(((long) 20));
			   {
			      obj_t list1755_870;
			      {
				 obj_t arg1756_871;
				 {
				    obj_t arg1758_872;
				    arg1758_872 = MAKE_PAIR(cname_56, BNIL);
				    arg1756_871 = MAKE_PAIR(_4dots_tools_misc, arg1758_872);
				 }
				 list1755_870 = MAKE_PAIR(oname_852, arg1756_871);
			      }
			      arg1749_865 = symbol_append_197___r4_symbols_6_4(list1755_870);
			   }
			   {
			      obj_t list1752_867;
			      {
				 obj_t arg1753_868;
				 arg1753_868 = MAKE_PAIR(BNIL, BNIL);
				 list1752_867 = MAKE_PAIR(arg1749_865, arg1753_868);
			      }
			      arg1741_857 = cons__138___r4_pairs_and_lists_6_3(arg1748_864, list1752_867);
			   }
			}
			{
			   obj_t arg1761_874;
			   obj_t arg1762_875;
			   obj_t arg1763_876;
			   arg1761_874 = CNST_TABLE_REF(((long) 6));
			   {
			      obj_t arg1770_882;
			      {
				 obj_t arg1774_886;
				 {
				    obj_t arg1779_891;
				    arg1779_891 = CNST_TABLE_REF(((long) 25));
				    {
				       obj_t list1781_893;
				       list1781_893 = MAKE_PAIR(BNIL, BNIL);
				       arg1774_886 = cons__138___r4_pairs_and_lists_6_3(arg1779_891, list1781_893);
				    }
				 }
				 {
				    obj_t list1776_888;
				    {
				       obj_t arg1777_889;
				       arg1777_889 = MAKE_PAIR(BNIL, BNIL);
				       list1776_888 = MAKE_PAIR(arg1774_886, arg1777_889);
				    }
				    arg1770_882 = cons__138___r4_pairs_and_lists_6_3(tres_854, list1776_888);
				 }
			      }
			      {
				 obj_t list1772_884;
				 list1772_884 = MAKE_PAIR(BNIL, BNIL);
				 arg1762_875 = cons__138___r4_pairs_and_lists_6_3(arg1770_882, list1772_884);
			      }
			   }
			   {
			      obj_t arg1784_895;
			      obj_t arg1785_896;
			      obj_t arg1786_897;
			      arg1784_895 = CNST_TABLE_REF(((long) 6));
			      {
				 obj_t arg1791_901;
				 {
				    obj_t arg1796_905;
				    {
				       obj_t arg1802_910;
				       obj_t arg1804_911;
				       arg1802_910 = CNST_TABLE_REF(((long) 21));
				       {
					  obj_t arg1811_918;
					  arg1811_918 = CNST_TABLE_REF(((long) 22));
					  {
					     obj_t list1813_920;
					     {
						obj_t arg1814_921;
						arg1814_921 = MAKE_PAIR(BNIL, BNIL);
						list1813_920 = MAKE_PAIR(cname_56, arg1814_921);
					     }
					     arg1804_911 = cons__138___r4_pairs_and_lists_6_3(arg1811_918, list1813_920);
					  }
				       }
				       {
					  obj_t list1806_913;
					  {
					     obj_t arg1807_914;
					     {
						obj_t arg1808_915;
						{
						   obj_t arg1809_916;
						   arg1809_916 = MAKE_PAIR(BNIL, BNIL);
						   arg1808_915 = MAKE_PAIR(BUNSPEC, arg1809_916);
						}
						{
						   obj_t aux_2209;
						   aux_2209 = BINT(len_851);
						   arg1807_914 = MAKE_PAIR(aux_2209, arg1808_915);
						}
					     }
					     list1806_913 = MAKE_PAIR(arg1804_911, arg1807_914);
					  }
					  arg1796_905 = cons__138___r4_pairs_and_lists_6_3(arg1802_910, list1806_913);
				       }
				    }
				    {
				       obj_t list1799_907;
				       {
					  obj_t arg1800_908;
					  arg1800_908 = MAKE_PAIR(BNIL, BNIL);
					  list1799_907 = MAKE_PAIR(arg1796_905, arg1800_908);
				       }
				       arg1791_901 = cons__138___r4_pairs_and_lists_6_3(aux_855, list1799_907);
				    }
				 }
				 {
				    obj_t list1793_903;
				    list1793_903 = MAKE_PAIR(BNIL, BNIL);
				    arg1785_896 = cons__138___r4_pairs_and_lists_6_3(arg1791_901, list1793_903);
				 }
			      }
			      {
				 obj_t arg1820_923;
				 obj_t arg1821_924;
				 {
				    long i_925;
				    obj_t slots_926;
				    obj_t res_927;
				    i_925 = ((long) 0);
				    slots_926 = slots_59;
				    res_927 = BNIL;
				  loop_928:
				    if ((i_925 == len_851))
				      {
					 arg1820_923 = reverse__39___r4_pairs_and_lists_6_3(res_927);
				      }
				    else
				      {
					 long arg1825_932;
					 obj_t arg1826_933;
					 obj_t arg1827_934;
					 arg1825_932 = (i_925 + ((long) 1));
					 arg1826_933 = CDR(slots_926);
					 {
					    obj_t arg1828_935;
					    arg1828_935 = save_slot_187_object_struct(oname_852, aux_855, cname_56, i_925, CAR(slots_926));
					    arg1827_934 = MAKE_PAIR(arg1828_935, res_927);
					 }
					 {
					    obj_t res_2229;
					    obj_t slots_2228;
					    long i_2227;
					    i_2227 = arg1825_932;
					    slots_2228 = arg1826_933;
					    res_2229 = arg1827_934;
					    res_927 = res_2229;
					    slots_926 = slots_2228;
					    i_925 = i_2227;
					    goto loop_928;
					 }
				      }
				 }
				 {
				    obj_t arg1830_937;
				    obj_t arg1831_938;
				    obj_t arg1832_939;
				    {
				       obj_t arg1839_946;
				       arg1839_946 = CNST_TABLE_REF(((long) 0));
				       {
					  obj_t list1842_949;
					  {
					     obj_t arg1843_950;
					     {
						obj_t arg1844_951;
						{
						   obj_t arg1845_952;
						   arg1845_952 = MAKE_PAIR(BNIL, BNIL);
						   arg1844_951 = MAKE_PAIR(aux_855, arg1845_952);
						}
						{
						   obj_t aux_2233;
						   aux_2233 = BINT(((long) 0));
						   arg1843_950 = MAKE_PAIR(aux_2233, arg1844_951);
						}
					     }
					     list1842_949 = MAKE_PAIR(res_853, arg1843_950);
					  }
					  arg1830_937 = cons__138___r4_pairs_and_lists_6_3(arg1839_946, list1842_949);
				       }
				    }
				    {
				       obj_t arg1847_954;
				       obj_t arg1848_955;
				       arg1847_954 = CNST_TABLE_REF(((long) 26));
				       {
					  obj_t arg1856_961;
					  arg1856_961 = CNST_TABLE_REF(((long) 27));
					  {
					     obj_t list1858_963;
					     {
						obj_t arg1859_964;
						arg1859_964 = MAKE_PAIR(BNIL, BNIL);
						list1858_963 = MAKE_PAIR(res_853, arg1859_964);
					     }
					     arg1848_955 = cons__138___r4_pairs_and_lists_6_3(arg1856_961, list1858_963);
					  }
				       }
				       {
					  obj_t list1850_957;
					  {
					     obj_t arg1852_958;
					     {
						obj_t arg1853_959;
						arg1853_959 = MAKE_PAIR(BNIL, BNIL);
						arg1852_958 = MAKE_PAIR(arg1848_955, arg1853_959);
					     }
					     list1850_957 = MAKE_PAIR(aux_855, arg1852_958);
					  }
					  arg1831_938 = cons__138___r4_pairs_and_lists_6_3(arg1847_954, list1850_957);
				       }
				    }
				    {
				       obj_t arg1861_966;
				       obj_t arg1862_967;
				       arg1861_966 = CNST_TABLE_REF(((long) 26));
				       {
					  obj_t arg1870_973;
					  arg1870_973 = CNST_TABLE_REF(((long) 22));
					  {
					     obj_t list1872_975;
					     {
						obj_t arg1874_976;
						arg1874_976 = MAKE_PAIR(BNIL, BNIL);
						list1872_975 = MAKE_PAIR(cname_56, arg1874_976);
					     }
					     arg1862_967 = cons__138___r4_pairs_and_lists_6_3(arg1870_973, list1872_975);
					  }
				       }
				       {
					  obj_t list1864_969;
					  {
					     obj_t arg1865_970;
					     {
						obj_t arg1866_971;
						arg1866_971 = MAKE_PAIR(BNIL, BNIL);
						arg1865_970 = MAKE_PAIR(arg1862_967, arg1866_971);
					     }
					     list1864_969 = MAKE_PAIR(res_853, arg1865_970);
					  }
					  arg1832_939 = cons__138___r4_pairs_and_lists_6_3(arg1861_966, list1864_969);
				       }
				    }
				    {
				       obj_t list1834_941;
				       {
					  obj_t arg1835_942;
					  {
					     obj_t arg1836_943;
					     {
						obj_t arg1837_944;
						arg1837_944 = MAKE_PAIR(BNIL, BNIL);
						arg1836_943 = MAKE_PAIR(res_853, arg1837_944);
					     }
					     arg1835_942 = MAKE_PAIR(arg1832_939, arg1836_943);
					  }
					  list1834_941 = MAKE_PAIR(arg1831_938, arg1835_942);
				       }
				       arg1821_924 = cons__138___r4_pairs_and_lists_6_3(arg1830_937, list1834_941);
				    }
				 }
				 arg1786_897 = append_2_18___r4_pairs_and_lists_6_3(arg1820_923, arg1821_924);
			      }
			      {
				 obj_t list1787_898;
				 {
				    obj_t arg1788_899;
				    arg1788_899 = MAKE_PAIR(arg1786_897, BNIL);
				    list1787_898 = MAKE_PAIR(arg1785_896, arg1788_899);
				 }
				 arg1763_876 = cons__138___r4_pairs_and_lists_6_3(arg1784_895, list1787_898);
			      }
			   }
			   {
			      obj_t list1765_878;
			      {
				 obj_t arg1766_879;
				 {
				    obj_t arg1767_880;
				    arg1767_880 = MAKE_PAIR(BNIL, BNIL);
				    arg1766_879 = MAKE_PAIR(arg1763_876, arg1767_880);
				 }
				 list1765_878 = MAKE_PAIR(arg1762_875, arg1766_879);
			      }
			      arg1742_858 = cons__138___r4_pairs_and_lists_6_3(arg1761_874, list1765_878);
			   }
			}
			{
			   obj_t list1744_860;
			   {
			      obj_t arg1745_861;
			      {
				 obj_t arg1746_862;
				 arg1746_862 = MAKE_PAIR(BNIL, BNIL);
				 arg1745_861 = MAKE_PAIR(arg1742_858, arg1746_862);
			      }
			      list1744_860 = MAKE_PAIR(arg1741_857, arg1745_861);
			   }
			   return cons__138___r4_pairs_and_lists_6_3(arg1740_856, list1744_860);
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_make_wide_object__struct_137_object_struct(obj_t env_1791, obj_t cname_1792, obj_t type_1793, obj_t module_1794, obj_t slots_1795)
{
   return make_wide_object__struct_148_object_struct(cname_1792, (type_t) (type_1793), module_1794, slots_1795);
}


obj_t 
restore_slot_6_object_struct(obj_t oname_60, obj_t sname_61, obj_t cname_62, type_t type_63, long i_64, obj_t slot_65)
{
   {
      obj_t loop_985;
      loop_985 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 4)), BEOA);
      {
	 obj_t runner_986;
	 runner_986 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 28)), BEOA);
	 {
	    obj_t v_987;
	    v_987 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 29)), BEOA);
	    {
	       obj_t len_988;
	       len_988 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 5)), BEOA);
	       {
		  obj_t runner_typed_89_989;
		  {
		     obj_t list2190_1266;
		     {
			obj_t arg2191_1267;
			{
			   obj_t aux_2287;
			   aux_2287 = CNST_TABLE_REF(((long) 30));
			   arg2191_1267 = MAKE_PAIR(aux_2287, BNIL);
			}
			list2190_1266 = MAKE_PAIR(runner_986, arg2191_1267);
		     }
		     runner_typed_89_989 = symbol_append_197___r4_symbols_6_4(list2190_1266);
		  }
		  {
		     {
			bool_t test_2292;
			{
			   obj_t aux_2293;
			   aux_2293 = STRUCT_REF(slot_65, ((long) 5));
			   test_2292 = CBOOL(aux_2293);
			}
			if (test_2292)
			  {
			     {
				obj_t arg1884_991;
				obj_t arg1885_992;
				obj_t arg1886_993;
				arg1884_991 = CNST_TABLE_REF(((long) 6));
				{
				   obj_t arg1892_999;
				   {
				      obj_t arg1896_1003;
				      {
					 obj_t arg1901_1008;
					 obj_t arg1902_1009;
					 arg1901_1008 = CNST_TABLE_REF(((long) 31));
					 arg1902_1009 = CNST_TABLE_REF(((long) 32));
					 {
					    obj_t list1905_1011;
					    {
					       obj_t arg1906_1012;
					       {
						  obj_t arg1907_1013;
						  arg1907_1013 = MAKE_PAIR(BNIL, BNIL);
						  {
						     obj_t aux_2300;
						     aux_2300 = BINT(i_64);
						     arg1906_1012 = MAKE_PAIR(aux_2300, arg1907_1013);
						  }
					       }
					       list1905_1011 = MAKE_PAIR(arg1902_1009, arg1906_1012);
					    }
					    arg1896_1003 = cons__138___r4_pairs_and_lists_6_3(arg1901_1008, list1905_1011);
					 }
				      }
				      {
					 obj_t list1898_1005;
					 {
					    obj_t arg1899_1006;
					    arg1899_1006 = MAKE_PAIR(BNIL, BNIL);
					    list1898_1005 = MAKE_PAIR(arg1896_1003, arg1899_1006);
					 }
					 arg1892_999 = cons__138___r4_pairs_and_lists_6_3(v_987, list1898_1005);
				      }
				   }
				   {
				      obj_t list1894_1001;
				      list1894_1001 = MAKE_PAIR(BNIL, BNIL);
				      arg1885_992 = cons__138___r4_pairs_and_lists_6_3(arg1892_999, list1894_1001);
				   }
				}
				{
				   obj_t arg1909_1015;
				   obj_t arg1911_1016;
				   obj_t arg1912_1017;
				   obj_t arg1913_1018;
				   arg1909_1015 = CNST_TABLE_REF(((long) 6));
				   {
				      obj_t arg1922_1025;
				      {
					 obj_t arg1926_1029;
					 obj_t arg1927_1030;
					 {
					    obj_t list1935_1036;
					    {
					       obj_t arg1936_1037;
					       {
						  obj_t aux_2311;
						  aux_2311 = CNST_TABLE_REF(((long) 30));
						  arg1936_1037 = MAKE_PAIR(aux_2311, BNIL);
					       }
					       list1935_1036 = MAKE_PAIR(len_988, arg1936_1037);
					    }
					    arg1926_1029 = symbol_append_197___r4_symbols_6_4(list1935_1036);
					 }
					 {
					    obj_t arg1938_1039;
					    arg1938_1039 = CNST_TABLE_REF(((long) 33));
					    {
					       obj_t list1940_1041;
					       {
						  obj_t arg1941_1042;
						  arg1941_1042 = MAKE_PAIR(BNIL, BNIL);
						  list1940_1041 = MAKE_PAIR(v_987, arg1941_1042);
					       }
					       arg1927_1030 = cons__138___r4_pairs_and_lists_6_3(arg1938_1039, list1940_1041);
					    }
					 }
					 {
					    obj_t list1929_1032;
					    {
					       obj_t arg1931_1033;
					       arg1931_1033 = MAKE_PAIR(BNIL, BNIL);
					       list1929_1032 = MAKE_PAIR(arg1927_1030, arg1931_1033);
					    }
					    arg1922_1025 = cons__138___r4_pairs_and_lists_6_3(arg1926_1029, list1929_1032);
					 }
				      }
				      {
					 obj_t list1924_1027;
					 list1924_1027 = MAKE_PAIR(BNIL, BNIL);
					 arg1911_1016 = cons__138___r4_pairs_and_lists_6_3(arg1922_1025, list1924_1027);
				      }
				   }
				   {
				      obj_t arg1943_1044;
				      obj_t arg1944_1045;
				      arg1943_1044 = CNST_TABLE_REF(((long) 34));
				      {
					 type_t aux_2326;
					 {
					    obj_t aux_2327;
					    aux_2327 = STRUCT_REF(slot_65, ((long) 2));
					    aux_2326 = (type_t) (aux_2327);
					 }
					 arg1944_1045 = malloc_object_tools(aux_2326, len_988);
				      }
				      arg1912_1017 = make_pragma_indexed_init_set__66_object_tools(type_63, slot_65, arg1943_1044, arg1944_1045);
				   }
				   {
				      obj_t arg1947_1047;
				      obj_t arg1948_1048;
				      obj_t arg1949_1049;
				      arg1947_1047 = CNST_TABLE_REF(((long) 9));
				      {
					 obj_t arg1956_1055;
					 {
					    obj_t arg1963_1059;
					    obj_t arg1964_1060;
					    {
					       obj_t list1971_1067;
					       list1971_1067 = MAKE_PAIR(BNIL, BNIL);
					       arg1963_1059 = cons__138___r4_pairs_and_lists_6_3(runner_typed_89_989, list1971_1067);
					    }
					    {
					       obj_t arg1973_1069;
					       obj_t arg1974_1070;
					       obj_t arg1975_1071;
					       obj_t arg1976_1072;
					       arg1973_1069 = CNST_TABLE_REF(((long) 10));
					       {
						  obj_t arg1983_1079;
						  arg1983_1079 = CNST_TABLE_REF(((long) 11));
						  {
						     obj_t list1985_1081;
						     {
							obj_t arg1986_1082;
							{
							   obj_t arg1987_1083;
							   arg1987_1083 = MAKE_PAIR(BNIL, BNIL);
							   arg1986_1082 = MAKE_PAIR(len_988, arg1987_1083);
							}
							list1985_1081 = MAKE_PAIR(runner_986, arg1986_1082);
						     }
						     arg1974_1070 = cons__138___r4_pairs_and_lists_6_3(arg1983_1079, list1985_1081);
						  }
					       }
					       {
						  obj_t arg1989_1085;
						  obj_t arg1990_1086;
						  arg1989_1085 = CNST_TABLE_REF(((long) 22));
						  arg1990_1086 = CNST_TABLE_REF(((long) 35));
						  {
						     obj_t list1993_1088;
						     {
							obj_t arg1995_1089;
							arg1995_1089 = MAKE_PAIR(BNIL, BNIL);
							list1993_1088 = MAKE_PAIR(arg1990_1086, arg1995_1089);
						     }
						     arg1975_1071 = cons__138___r4_pairs_and_lists_6_3(arg1989_1085, list1993_1088);
						  }
					       }
					       {
						  obj_t arg1997_1091;
						  obj_t arg1998_1092;
						  obj_t arg1999_1093;
						  arg1997_1091 = CNST_TABLE_REF(((long) 12));
						  {
						     obj_t arg2005_1099;
						     obj_t arg2006_1100;
						     arg2005_1099 = CNST_TABLE_REF(((long) 34));
						     {
							obj_t arg2007_1101;
							arg2007_1101 = CNST_TABLE_REF(((long) 36));
							{
							   obj_t list2009_1103;
							   {
							      obj_t arg2012_1104;
							      {
								 obj_t arg2013_1105;
								 arg2013_1105 = MAKE_PAIR(BNIL, BNIL);
								 arg2012_1104 = MAKE_PAIR(runner_986, arg2013_1105);
							      }
							      list2009_1103 = MAKE_PAIR(v_987, arg2012_1104);
							   }
							   arg2006_1100 = cons__138___r4_pairs_and_lists_6_3(arg2007_1101, list2009_1103);
							}
						     }
						     arg1998_1092 = make_pragma_indexed_set__175_object_tools(type_63, slot_65, arg2005_1099, arg2006_1100, runner_986);
						  }
						  {
						     obj_t arg2015_1107;
						     {
							obj_t arg2020_1112;
							arg2020_1112 = CNST_TABLE_REF(((long) 15));
							{
							   obj_t list2024_1115;
							   {
							      obj_t arg2025_1116;
							      {
								 obj_t arg2026_1117;
								 arg2026_1117 = MAKE_PAIR(BNIL, BNIL);
								 {
								    obj_t aux_2356;
								    aux_2356 = BINT(((long) 1));
								    arg2025_1116 = MAKE_PAIR(aux_2356, arg2026_1117);
								 }
							      }
							      list2024_1115 = MAKE_PAIR(runner_986, arg2025_1116);
							   }
							   arg2015_1107 = cons__138___r4_pairs_and_lists_6_3(arg2020_1112, list2024_1115);
							}
						     }
						     {
							obj_t list2017_1109;
							{
							   obj_t arg2018_1110;
							   arg2018_1110 = MAKE_PAIR(BNIL, BNIL);
							   list2017_1109 = MAKE_PAIR(arg2015_1107, arg2018_1110);
							}
							arg1999_1093 = cons__138___r4_pairs_and_lists_6_3(loop_985, list2017_1109);
						     }
						  }
						  {
						     obj_t list2001_1095;
						     {
							obj_t arg2002_1096;
							{
							   obj_t arg2003_1097;
							   arg2003_1097 = MAKE_PAIR(BNIL, BNIL);
							   arg2002_1096 = MAKE_PAIR(arg1999_1093, arg2003_1097);
							}
							list2001_1095 = MAKE_PAIR(arg1998_1092, arg2002_1096);
						     }
						     arg1976_1072 = cons__138___r4_pairs_and_lists_6_3(arg1997_1091, list2001_1095);
						  }
					       }
					       {
						  obj_t list1978_1074;
						  {
						     obj_t arg1979_1075;
						     {
							obj_t arg1980_1076;
							{
							   obj_t arg1981_1077;
							   arg1981_1077 = MAKE_PAIR(BNIL, BNIL);
							   arg1980_1076 = MAKE_PAIR(arg1976_1072, arg1981_1077);
							}
							arg1979_1075 = MAKE_PAIR(arg1975_1071, arg1980_1076);
						     }
						     list1978_1074 = MAKE_PAIR(arg1974_1070, arg1979_1075);
						  }
						  arg1964_1060 = cons__138___r4_pairs_and_lists_6_3(arg1973_1069, list1978_1074);
					       }
					    }
					    {
					       obj_t list1966_1062;
					       {
						  obj_t arg1967_1063;
						  {
						     obj_t arg1968_1064;
						     arg1968_1064 = MAKE_PAIR(BNIL, BNIL);
						     arg1967_1063 = MAKE_PAIR(arg1964_1060, arg1968_1064);
						  }
						  list1966_1062 = MAKE_PAIR(arg1963_1059, arg1967_1063);
					       }
					       arg1956_1055 = cons__138___r4_pairs_and_lists_6_3(loop_985, list1966_1062);
					    }
					 }
					 {
					    obj_t list1958_1057;
					    list1958_1057 = MAKE_PAIR(BNIL, BNIL);
					    arg1948_1048 = cons__138___r4_pairs_and_lists_6_3(arg1956_1055, list1958_1057);
					 }
				      }
				      {
					 obj_t list2030_1121;
					 {
					    obj_t arg2031_1122;
					    arg2031_1122 = MAKE_PAIR(BNIL, BNIL);
					    {
					       obj_t aux_2380;
					       aux_2380 = BINT(((long) 0));
					       list2030_1121 = MAKE_PAIR(aux_2380, arg2031_1122);
					    }
					 }
					 arg1949_1049 = cons__138___r4_pairs_and_lists_6_3(loop_985, list2030_1121);
				      }
				      {
					 obj_t list1951_1051;
					 {
					    obj_t arg1952_1052;
					    {
					       obj_t arg1953_1053;
					       arg1953_1053 = MAKE_PAIR(BNIL, BNIL);
					       arg1952_1052 = MAKE_PAIR(arg1949_1049, arg1953_1053);
					    }
					    list1951_1051 = MAKE_PAIR(arg1948_1048, arg1952_1052);
					 }
					 arg1913_1018 = cons__138___r4_pairs_and_lists_6_3(arg1947_1047, list1951_1051);
				      }
				   }
				   {
				      obj_t list1915_1020;
				      {
					 obj_t arg1916_1021;
					 {
					    obj_t arg1917_1022;
					    {
					       obj_t arg1918_1023;
					       arg1918_1023 = MAKE_PAIR(BNIL, BNIL);
					       arg1917_1022 = MAKE_PAIR(arg1913_1018, arg1918_1023);
					    }
					    arg1916_1021 = MAKE_PAIR(arg1912_1017, arg1917_1022);
					 }
					 list1915_1020 = MAKE_PAIR(arg1911_1016, arg1916_1021);
				      }
				      arg1886_993 = cons__138___r4_pairs_and_lists_6_3(arg1909_1015, list1915_1020);
				   }
				}
				{
				   obj_t list1888_995;
				   {
				      obj_t arg1889_996;
				      {
					 obj_t arg1890_997;
					 arg1890_997 = MAKE_PAIR(BNIL, BNIL);
					 arg1889_996 = MAKE_PAIR(arg1886_993, arg1890_997);
				      }
				      list1888_995 = MAKE_PAIR(arg1885_992, arg1889_996);
				   }
				   return cons__138___r4_pairs_and_lists_6_3(arg1884_991, list1888_995);
				}
			     }
			  }
			else
			  {
			     bool_t test_2397;
			     {
				obj_t aux_2398;
				aux_2398 = STRUCT_REF(slot_65, ((long) 3));
				test_2397 = CBOOL(aux_2398);
			     }
			     if (test_2397)
			       {
				  {
				     obj_t arg2034_1125;
				     obj_t arg2035_1126;
				     obj_t arg2036_1127;
				     arg2034_1125 = CNST_TABLE_REF(((long) 6));
				     {
					obj_t arg2043_1133;
					{
					   obj_t arg2048_1137;
					   {
					      obj_t arg2054_1142;
					      obj_t arg2055_1143;
					      arg2054_1142 = CNST_TABLE_REF(((long) 31));
					      arg2055_1143 = CNST_TABLE_REF(((long) 32));
					      {
						 obj_t list2057_1145;
						 {
						    obj_t arg2058_1146;
						    {
						       obj_t arg2059_1147;
						       arg2059_1147 = MAKE_PAIR(BNIL, BNIL);
						       {
							  obj_t aux_2405;
							  aux_2405 = BINT(i_64);
							  arg2058_1146 = MAKE_PAIR(aux_2405, arg2059_1147);
						       }
						    }
						    list2057_1145 = MAKE_PAIR(arg2055_1143, arg2058_1146);
						 }
						 arg2048_1137 = cons__138___r4_pairs_and_lists_6_3(arg2054_1142, list2057_1145);
					      }
					   }
					   {
					      obj_t list2051_1139;
					      {
						 obj_t arg2052_1140;
						 arg2052_1140 = MAKE_PAIR(BNIL, BNIL);
						 list2051_1139 = MAKE_PAIR(arg2048_1137, arg2052_1140);
					      }
					      arg2043_1133 = cons__138___r4_pairs_and_lists_6_3(v_987, list2051_1139);
					   }
					}
					{
					   obj_t list2046_1135;
					   list2046_1135 = MAKE_PAIR(BNIL, BNIL);
					   arg2035_1126 = cons__138___r4_pairs_and_lists_6_3(arg2043_1133, list2046_1135);
					}
				     }
				     {
					obj_t arg2061_1149;
					obj_t arg2062_1150;
					obj_t arg2065_1151;
					arg2061_1149 = CNST_TABLE_REF(((long) 9));
					{
					   obj_t arg2071_1157;
					   {
					      obj_t arg2076_1161;
					      obj_t arg2077_1162;
					      {
						 obj_t list2085_1169;
						 list2085_1169 = MAKE_PAIR(BNIL, BNIL);
						 arg2076_1161 = cons__138___r4_pairs_and_lists_6_3(runner_typed_89_989, list2085_1169);
					      }
					      {
						 obj_t arg2087_1171;
						 obj_t arg2088_1172;
						 obj_t arg2089_1173;
						 obj_t arg2091_1174;
						 arg2087_1171 = CNST_TABLE_REF(((long) 10));
						 {
						    obj_t arg2099_1181;
						    obj_t arg2100_1182;
						    arg2099_1181 = CNST_TABLE_REF(((long) 11));
						    {
						       obj_t arg2106_1188;
						       obj_t arg2107_1189;
						       arg2106_1188 = CNST_TABLE_REF(((long) 7));
						       arg2107_1189 = STRUCT_REF(slot_65, ((long) 4));
						       {
							  obj_t list2109_1191;
							  {
							     obj_t arg2110_1192;
							     arg2110_1192 = MAKE_PAIR(BNIL, BNIL);
							     list2109_1191 = MAKE_PAIR(arg2107_1189, arg2110_1192);
							  }
							  arg2100_1182 = cons__138___r4_pairs_and_lists_6_3(arg2106_1188, list2109_1191);
						       }
						    }
						    {
						       obj_t list2102_1184;
						       {
							  obj_t arg2103_1185;
							  {
							     obj_t arg2104_1186;
							     arg2104_1186 = MAKE_PAIR(BNIL, BNIL);
							     arg2103_1185 = MAKE_PAIR(arg2100_1182, arg2104_1186);
							  }
							  list2102_1184 = MAKE_PAIR(runner_986, arg2103_1185);
						       }
						       arg2088_1172 = cons__138___r4_pairs_and_lists_6_3(arg2099_1181, list2102_1184);
						    }
						 }
						 {
						    obj_t arg2112_1194;
						    obj_t arg2113_1195;
						    arg2112_1194 = CNST_TABLE_REF(((long) 22));
						    arg2113_1195 = CNST_TABLE_REF(((long) 35));
						    {
						       obj_t list2115_1197;
						       {
							  obj_t arg2117_1198;
							  arg2117_1198 = MAKE_PAIR(BNIL, BNIL);
							  list2115_1197 = MAKE_PAIR(arg2113_1195, arg2117_1198);
						       }
						       arg2089_1173 = cons__138___r4_pairs_and_lists_6_3(arg2112_1194, list2115_1197);
						    }
						 }
						 {
						    obj_t arg2119_1200;
						    obj_t arg2120_1201;
						    obj_t arg2121_1202;
						    arg2119_1200 = CNST_TABLE_REF(((long) 12));
						    {
						       obj_t arg2127_1208;
						       obj_t arg2128_1209;
						       arg2127_1208 = CNST_TABLE_REF(((long) 34));
						       {
							  obj_t arg2129_1210;
							  arg2129_1210 = CNST_TABLE_REF(((long) 36));
							  {
							     obj_t list2131_1212;
							     {
								obj_t arg2132_1213;
								{
								   obj_t arg2133_1214;
								   arg2133_1214 = MAKE_PAIR(BNIL, BNIL);
								   arg2132_1213 = MAKE_PAIR(runner_986, arg2133_1214);
								}
								list2131_1212 = MAKE_PAIR(v_987, arg2132_1213);
							     }
							     arg2128_1209 = cons__138___r4_pairs_and_lists_6_3(arg2129_1210, list2131_1212);
							  }
						       }
						       arg2120_1201 = make_pragma_indexed_set__175_object_tools(type_63, slot_65, arg2127_1208, arg2128_1209, runner_986);
						    }
						    {
						       obj_t arg2135_1216;
						       {
							  obj_t arg2141_1221;
							  arg2141_1221 = CNST_TABLE_REF(((long) 15));
							  {
							     obj_t list2144_1224;
							     {
								obj_t arg2145_1225;
								{
								   obj_t arg2146_1226;
								   arg2146_1226 = MAKE_PAIR(BNIL, BNIL);
								   {
								      obj_t aux_2444;
								      aux_2444 = BINT(((long) 1));
								      arg2145_1225 = MAKE_PAIR(aux_2444, arg2146_1226);
								   }
								}
								list2144_1224 = MAKE_PAIR(runner_986, arg2145_1225);
							     }
							     arg2135_1216 = cons__138___r4_pairs_and_lists_6_3(arg2141_1221, list2144_1224);
							  }
						       }
						       {
							  obj_t list2137_1218;
							  {
							     obj_t arg2138_1219;
							     arg2138_1219 = MAKE_PAIR(BNIL, BNIL);
							     list2137_1218 = MAKE_PAIR(arg2135_1216, arg2138_1219);
							  }
							  arg2121_1202 = cons__138___r4_pairs_and_lists_6_3(loop_985, list2137_1218);
						       }
						    }
						    {
						       obj_t list2123_1204;
						       {
							  obj_t arg2124_1205;
							  {
							     obj_t arg2125_1206;
							     arg2125_1206 = MAKE_PAIR(BNIL, BNIL);
							     arg2124_1205 = MAKE_PAIR(arg2121_1202, arg2125_1206);
							  }
							  list2123_1204 = MAKE_PAIR(arg2120_1201, arg2124_1205);
						       }
						       arg2091_1174 = cons__138___r4_pairs_and_lists_6_3(arg2119_1200, list2123_1204);
						    }
						 }
						 {
						    obj_t list2093_1176;
						    {
						       obj_t arg2095_1177;
						       {
							  obj_t arg2096_1178;
							  {
							     obj_t arg2097_1179;
							     arg2097_1179 = MAKE_PAIR(BNIL, BNIL);
							     arg2096_1178 = MAKE_PAIR(arg2091_1174, arg2097_1179);
							  }
							  arg2095_1177 = MAKE_PAIR(arg2089_1173, arg2096_1178);
						       }
						       list2093_1176 = MAKE_PAIR(arg2088_1172, arg2095_1177);
						    }
						    arg2077_1162 = cons__138___r4_pairs_and_lists_6_3(arg2087_1171, list2093_1176);
						 }
					      }
					      {
						 obj_t list2079_1164;
						 {
						    obj_t arg2080_1165;
						    {
						       obj_t arg2081_1166;
						       arg2081_1166 = MAKE_PAIR(BNIL, BNIL);
						       arg2080_1165 = MAKE_PAIR(arg2077_1162, arg2081_1166);
						    }
						    list2079_1164 = MAKE_PAIR(arg2076_1161, arg2080_1165);
						 }
						 arg2071_1157 = cons__138___r4_pairs_and_lists_6_3(loop_985, list2079_1164);
					      }
					   }
					   {
					      obj_t list2073_1159;
					      list2073_1159 = MAKE_PAIR(BNIL, BNIL);
					      arg2062_1150 = cons__138___r4_pairs_and_lists_6_3(arg2071_1157, list2073_1159);
					   }
					}
					{
					   obj_t list2151_1230;
					   {
					      obj_t arg2152_1231;
					      arg2152_1231 = MAKE_PAIR(BNIL, BNIL);
					      {
						 obj_t aux_2468;
						 aux_2468 = BINT(((long) 0));
						 list2151_1230 = MAKE_PAIR(aux_2468, arg2152_1231);
					      }
					   }
					   arg2065_1151 = cons__138___r4_pairs_and_lists_6_3(loop_985, list2151_1230);
					}
					{
					   obj_t list2067_1153;
					   {
					      obj_t arg2068_1154;
					      {
						 obj_t arg2069_1155;
						 arg2069_1155 = MAKE_PAIR(BNIL, BNIL);
						 arg2068_1154 = MAKE_PAIR(arg2065_1151, arg2069_1155);
					      }
					      list2067_1153 = MAKE_PAIR(arg2062_1150, arg2068_1154);
					   }
					   arg2036_1127 = cons__138___r4_pairs_and_lists_6_3(arg2061_1149, list2067_1153);
					}
				     }
				     {
					obj_t list2038_1129;
					{
					   obj_t arg2039_1130;
					   {
					      obj_t arg2040_1131;
					      arg2040_1131 = MAKE_PAIR(BNIL, BNIL);
					      arg2039_1130 = MAKE_PAIR(arg2036_1127, arg2040_1131);
					   }
					   list2038_1129 = MAKE_PAIR(arg2035_1126, arg2039_1130);
					}
					return cons__138___r4_pairs_and_lists_6_3(arg2034_1125, list2038_1129);
				     }
				  }
			       }
			     else
			       {
				  {
				     obj_t arg2154_1233;
				     obj_t arg2155_1234;
				     obj_t arg2156_1235;
				     arg2154_1233 = CNST_TABLE_REF(((long) 6));
				     {
					obj_t arg2165_1241;
					{
					   obj_t arg2169_1245;
					   obj_t arg2170_1246;
					   {
					      obj_t list2176_1252;
					      {
						 obj_t arg2177_1253;
						 {
						    obj_t arg2178_1254;
						    {
						       obj_t aux_2481;
						       {
							  type_t obj_1742;
							  {
							     obj_t aux_2482;
							     aux_2482 = STRUCT_REF(slot_65, ((long) 2));
							     obj_1742 = (type_t) (aux_2482);
							  }
							  aux_2481 = (((type_t) CREF(obj_1742))->id);
						       }
						       arg2178_1254 = MAKE_PAIR(aux_2481, BNIL);
						    }
						    arg2177_1253 = MAKE_PAIR(_4dots_tools_misc, arg2178_1254);
						 }
						 list2176_1252 = MAKE_PAIR(v_987, arg2177_1253);
					      }
					      arg2169_1245 = symbol_append_197___r4_symbols_6_4(list2176_1252);
					   }
					   {
					      obj_t arg2181_1257;
					      obj_t arg2182_1258;
					      arg2181_1257 = CNST_TABLE_REF(((long) 31));
					      arg2182_1258 = CNST_TABLE_REF(((long) 32));
					      {
						 obj_t list2184_1260;
						 {
						    obj_t arg2185_1261;
						    {
						       obj_t arg2186_1262;
						       arg2186_1262 = MAKE_PAIR(BNIL, BNIL);
						       {
							  obj_t aux_2493;
							  aux_2493 = BINT(i_64);
							  arg2185_1261 = MAKE_PAIR(aux_2493, arg2186_1262);
						       }
						    }
						    list2184_1260 = MAKE_PAIR(arg2182_1258, arg2185_1261);
						 }
						 arg2170_1246 = cons__138___r4_pairs_and_lists_6_3(arg2181_1257, list2184_1260);
					      }
					   }
					   {
					      obj_t list2172_1248;
					      {
						 obj_t arg2173_1249;
						 arg2173_1249 = MAKE_PAIR(BNIL, BNIL);
						 list2172_1248 = MAKE_PAIR(arg2170_1246, arg2173_1249);
					      }
					      arg2165_1241 = cons__138___r4_pairs_and_lists_6_3(arg2169_1245, list2172_1248);
					   }
					}
					{
					   obj_t list2167_1243;
					   list2167_1243 = MAKE_PAIR(BNIL, BNIL);
					   arg2155_1234 = cons__138___r4_pairs_and_lists_6_3(arg2165_1241, list2167_1243);
					}
				     }
				     arg2156_1235 = make_pragma_direct_set__7_object_tools(type_63, slot_65, CNST_TABLE_REF(((long) 34)), v_987);
				     {
					obj_t list2161_1237;
					{
					   obj_t arg2162_1238;
					   {
					      obj_t arg2163_1239;
					      arg2163_1239 = MAKE_PAIR(BNIL, BNIL);
					      arg2162_1238 = MAKE_PAIR(arg2156_1235, arg2163_1239);
					   }
					   list2161_1237 = MAKE_PAIR(arg2155_1234, arg2162_1238);
					}
					return cons__138___r4_pairs_and_lists_6_3(arg2154_1233, list2161_1237);
				     }
				  }
			       }
			  }
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
make_struct__object_35_object_struct(obj_t cname_66, type_t type_67, obj_t module_68, obj_t slots_69)
{
   {
      obj_t arg2197_1273;
      obj_t arg2198_1274;
      obj_t arg2199_1275;
      arg2197_1273 = CNST_TABLE_REF(((long) 19));
      {
	 obj_t arg2205_1281;
	 obj_t arg2207_1282;
	 obj_t arg2208_1283;
	 arg2205_1281 = CNST_TABLE_REF(((long) 37));
	 {
	    obj_t arg2214_1289;
	    arg2214_1289 = CNST_TABLE_REF(((long) 34));
	    {
	       obj_t list2215_1290;
	       {
		  obj_t arg2216_1291;
		  {
		     obj_t arg2217_1292;
		     arg2217_1292 = MAKE_PAIR(cname_66, BNIL);
		     arg2216_1291 = MAKE_PAIR(_4dots_tools_misc, arg2217_1292);
		  }
		  list2215_1290 = MAKE_PAIR(arg2214_1289, arg2216_1291);
	       }
	       arg2207_1282 = symbol_append_197___r4_symbols_6_4(list2215_1290);
	    }
	 }
	 arg2208_1283 = CNST_TABLE_REF(((long) 38));
	 {
	    obj_t list2210_1285;
	    {
	       obj_t arg2211_1286;
	       {
		  obj_t arg2212_1287;
		  arg2212_1287 = MAKE_PAIR(BNIL, BNIL);
		  arg2211_1286 = MAKE_PAIR(arg2208_1283, arg2212_1287);
	       }
	       list2210_1285 = MAKE_PAIR(arg2207_1282, arg2211_1286);
	    }
	    arg2198_1274 = cons__138___r4_pairs_and_lists_6_3(arg2205_1281, list2210_1285);
	 }
      }
      {
	 obj_t arg2219_1294;
	 obj_t arg2220_1295;
	 obj_t arg2221_1296;
	 arg2219_1294 = CNST_TABLE_REF(((long) 12));
	 {
	    obj_t arg2225_1300;
	    obj_t arg2226_1301;
	    obj_t arg2227_1302;
	    arg2225_1300 = CNST_TABLE_REF(((long) 39));
	    arg2226_1301 = CNST_TABLE_REF(((long) 34));
	    {
	       obj_t arg2233_1308;
	       obj_t arg2234_1309;
	       arg2233_1308 = CNST_TABLE_REF(((long) 31));
	       arg2234_1309 = CNST_TABLE_REF(((long) 32));
	       {
		  obj_t list2237_1312;
		  {
		     obj_t arg2242_1313;
		     {
			obj_t arg2243_1314;
			arg2243_1314 = MAKE_PAIR(BNIL, BNIL);
			{
			   obj_t aux_2527;
			   aux_2527 = BINT(((long) 0));
			   arg2242_1313 = MAKE_PAIR(aux_2527, arg2243_1314);
			}
		     }
		     list2237_1312 = MAKE_PAIR(arg2234_1309, arg2242_1313);
		  }
		  arg2227_1302 = cons__138___r4_pairs_and_lists_6_3(arg2233_1308, list2237_1312);
	       }
	    }
	    {
	       obj_t list2229_1304;
	       {
		  obj_t arg2230_1305;
		  {
		     obj_t arg2231_1306;
		     arg2231_1306 = MAKE_PAIR(BNIL, BNIL);
		     arg2230_1305 = MAKE_PAIR(arg2227_1302, arg2231_1306);
		  }
		  list2229_1304 = MAKE_PAIR(arg2226_1301, arg2230_1305);
	       }
	       arg2220_1295 = cons__138___r4_pairs_and_lists_6_3(arg2225_1300, list2229_1304);
	    }
	 }
	 {
	    obj_t arg2245_1316;
	    obj_t arg2246_1317;
	    {
	       long i_1318;
	       obj_t slots_1319;
	       obj_t res_1320;
	       i_1318 = ((long) 1);
	       slots_1319 = slots_69;
	       res_1320 = BNIL;
	     loop_1321:
	       if (NULLP(slots_1319))
		 {
		    arg2245_1316 = reverse__39___r4_pairs_and_lists_6_3(res_1320);
		 }
	       else
		 {
		    obj_t new_1325;
		    new_1325 = restore_slot_6_object_struct(CNST_TABLE_REF(((long) 34)), CNST_TABLE_REF(((long) 32)), cname_66, type_67, i_1318, CAR(slots_1319));
		    {
		       long arg2250_1326;
		       obj_t arg2251_1327;
		       obj_t arg2252_1328;
		       arg2250_1326 = (i_1318 + ((long) 1));
		       arg2251_1327 = CDR(slots_1319);
		       arg2252_1328 = MAKE_PAIR(new_1325, res_1320);
		       {
			  obj_t res_2548;
			  obj_t slots_2547;
			  long i_2546;
			  i_2546 = arg2250_1326;
			  slots_2547 = arg2251_1327;
			  res_2548 = arg2252_1328;
			  res_1320 = res_2548;
			  slots_1319 = slots_2547;
			  i_1318 = i_2546;
			  goto loop_1321;
		       }
		    }
		 }
	    }
	    {
	       obj_t arg2257_1332;
	       arg2257_1332 = CNST_TABLE_REF(((long) 34));
	       {
		  obj_t list2259_1334;
		  list2259_1334 = MAKE_PAIR(BNIL, BNIL);
		  arg2246_1317 = cons__138___r4_pairs_and_lists_6_3(arg2257_1332, list2259_1334);
	       }
	    }
	    arg2221_1296 = append_2_18___r4_pairs_and_lists_6_3(arg2245_1316, arg2246_1317);
	 }
	 {
	    obj_t list2222_1297;
	    {
	       obj_t arg2223_1298;
	       arg2223_1298 = MAKE_PAIR(arg2221_1296, BNIL);
	       list2222_1297 = MAKE_PAIR(arg2220_1295, arg2223_1298);
	    }
	    arg2199_1275 = cons__138___r4_pairs_and_lists_6_3(arg2219_1294, list2222_1297);
	 }
      }
      {
	 obj_t list2201_1277;
	 {
	    obj_t arg2202_1278;
	    {
	       obj_t arg2203_1279;
	       arg2203_1279 = MAKE_PAIR(BNIL, BNIL);
	       arg2202_1278 = MAKE_PAIR(arg2199_1275, arg2203_1279);
	    }
	    list2201_1277 = MAKE_PAIR(arg2198_1274, arg2202_1278);
	 }
	 return cons__138___r4_pairs_and_lists_6_3(arg2197_1273, list2201_1277);
      }
   }
}


obj_t 
_make_struct__object_170_object_struct(obj_t env_1796, obj_t cname_1797, obj_t type_1798, obj_t module_1799, obj_t slots_1800)
{
   return make_struct__object_35_object_struct(cname_1797, (type_t) (type_1798), module_1799, slots_1800);
}


obj_t 
make_struct__wide_object_7_object_struct(obj_t cname_70, type_t type_71, obj_t module_72, obj_t slots_73)
{
   {
      obj_t old_1336;
      old_1336 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 40)), BEOA);
      {
	 long len_1337;
	 len_1337 = list_length(slots_73);
	 {
	    obj_t aux_1338;
	    aux_1338 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 24)), BEOA);
	    {
	       obj_t taux_1339;
	       {
		  obj_t list2434_1504;
		  {
		     obj_t arg2435_1505;
		     {
			obj_t aux_2569;
			aux_2569 = CNST_TABLE_REF(((long) 23));
			arg2435_1505 = MAKE_PAIR(aux_2569, BNIL);
		     }
		     list2434_1504 = MAKE_PAIR(aux_1338, arg2435_1505);
		  }
		  taux_1339 = symbol_append_197___r4_symbols_6_4(list2434_1504);
	       }
	       {
		  obj_t new_1340;
		  new_1340 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 41)), BEOA);
		  {
		     obj_t tid_1341;
		     tid_1341 = (((type_t) CREF(type_71))->id);
		     {
			global_t holder_1342;
			{
			   class_t obj_1751;
			   obj_1751 = (class_t) (type_71);
			   {
			      obj_t aux_2579;
			      {
				 object_t aux_2580;
				 aux_2580 = (object_t) (obj_1751);
				 aux_2579 = OBJECT_WIDENING(aux_2580);
			      }
			      holder_1342 = (((class_t) CREF(aux_2579))->holder);
			   }
			}
			{
			   obj_t widening_1343;
			   {
			      obj_t arg2425_1495;
			      obj_t arg2426_1496;
			      {
				 class_t obj_1752;
				 obj_1752 = (class_t) (type_71);
				 {
				    obj_t aux_2585;
				    {
				       object_t aux_2586;
				       aux_2586 = (object_t) (obj_1752);
				       aux_2585 = OBJECT_WIDENING(aux_2586);
				    }
				    arg2425_1495 = (((class_t) CREF(aux_2585))->widening);
				 }
			      }
			      arg2426_1496 = CNST_TABLE_REF(((long) 1));
			      {
				 obj_t list2428_1498;
				 {
				    obj_t arg2429_1499;
				    {
				       obj_t arg2430_1500;
				       {
					  obj_t aux_2591;
					  aux_2591 = (((type_t) CREF(type_71))->id);
					  arg2430_1500 = MAKE_PAIR(aux_2591, BNIL);
				       }
				       arg2429_1499 = MAKE_PAIR(arg2426_1496, arg2430_1500);
				    }
				    list2428_1498 = MAKE_PAIR(arg2425_1495, arg2429_1499);
				 }
				 widening_1343 = symbol_append_197___r4_symbols_6_4(list2428_1498);
			      }
			   }
			   {
			      {
				 obj_t arg2261_1344;
				 obj_t arg2262_1345;
				 obj_t arg2263_1346;
				 arg2261_1344 = CNST_TABLE_REF(((long) 19));
				 {
				    obj_t arg2270_1352;
				    obj_t arg2271_1353;
				    obj_t arg2272_1354;
				    arg2270_1352 = CNST_TABLE_REF(((long) 37));
				    {
				       obj_t arg2284_1360;
				       arg2284_1360 = CNST_TABLE_REF(((long) 34));
				       {
					  obj_t list2285_1361;
					  {
					     obj_t arg2286_1362;
					     {
						obj_t arg2287_1363;
						arg2287_1363 = MAKE_PAIR(cname_70, BNIL);
						arg2286_1362 = MAKE_PAIR(_4dots_tools_misc, arg2287_1363);
					     }
					     list2285_1361 = MAKE_PAIR(arg2284_1360, arg2286_1362);
					  }
					  arg2271_1353 = symbol_append_197___r4_symbols_6_4(list2285_1361);
				       }
				    }
				    arg2272_1354 = CNST_TABLE_REF(((long) 38));
				    {
				       obj_t list2274_1356;
				       {
					  obj_t arg2280_1357;
					  {
					     obj_t arg2281_1358;
					     arg2281_1358 = MAKE_PAIR(BNIL, BNIL);
					     arg2280_1357 = MAKE_PAIR(arg2272_1354, arg2281_1358);
					  }
					  list2274_1356 = MAKE_PAIR(arg2271_1353, arg2280_1357);
				       }
				       arg2262_1345 = cons__138___r4_pairs_and_lists_6_3(arg2270_1352, list2274_1356);
				    }
				 }
				 {
				    obj_t arg2289_1365;
				    obj_t arg2290_1366;
				    obj_t arg2291_1367;
				    arg2289_1365 = CNST_TABLE_REF(((long) 6));
				    {
				       obj_t arg2297_1373;
				       obj_t arg2298_1374;
				       {
					  obj_t arg2303_1379;
					  {
					     obj_t arg2308_1384;
					     arg2308_1384 = CNST_TABLE_REF(((long) 25));
					     {
						obj_t list2310_1386;
						list2310_1386 = MAKE_PAIR(BNIL, BNIL);
						arg2303_1379 = cons__138___r4_pairs_and_lists_6_3(arg2308_1384, list2310_1386);
					     }
					  }
					  {
					     obj_t list2305_1381;
					     {
						obj_t arg2306_1382;
						arg2306_1382 = MAKE_PAIR(BNIL, BNIL);
						list2305_1381 = MAKE_PAIR(arg2303_1379, arg2306_1382);
					     }
					     arg2297_1373 = cons__138___r4_pairs_and_lists_6_3(old_1336, list2305_1381);
					  }
				       }
				       {
					  obj_t arg2312_1388;
					  {
					     obj_t arg2317_1393;
					     obj_t arg2318_1394;
					     arg2317_1393 = CNST_TABLE_REF(((long) 31));
					     arg2318_1394 = CNST_TABLE_REF(((long) 32));
					     {
						obj_t list2321_1397;
						{
						   obj_t arg2322_1398;
						   {
						      obj_t arg2323_1399;
						      arg2323_1399 = MAKE_PAIR(BNIL, BNIL);
						      {
							 obj_t aux_2619;
							 aux_2619 = BINT(((long) 0));
							 arg2322_1398 = MAKE_PAIR(aux_2619, arg2323_1399);
						      }
						   }
						   list2321_1397 = MAKE_PAIR(arg2318_1394, arg2322_1398);
						}
						arg2312_1388 = cons__138___r4_pairs_and_lists_6_3(arg2317_1393, list2321_1397);
					     }
					  }
					  {
					     obj_t list2314_1390;
					     {
						obj_t arg2315_1391;
						arg2315_1391 = MAKE_PAIR(BNIL, BNIL);
						list2314_1390 = MAKE_PAIR(arg2312_1388, arg2315_1391);
					     }
					     arg2298_1374 = cons__138___r4_pairs_and_lists_6_3(taux_1339, list2314_1390);
					  }
				       }
				       {
					  obj_t list2300_1376;
					  {
					     obj_t arg2301_1377;
					     arg2301_1377 = MAKE_PAIR(BNIL, BNIL);
					     list2300_1376 = MAKE_PAIR(arg2298_1374, arg2301_1377);
					  }
					  arg2290_1366 = cons__138___r4_pairs_and_lists_6_3(arg2297_1373, list2300_1376);
				       }
				    }
				    {
				       obj_t arg2325_1401;
				       obj_t arg2326_1402;
				       obj_t arg2327_1403;
				       obj_t arg2328_1404;
				       arg2325_1401 = CNST_TABLE_REF(((long) 6));
				       {
					  obj_t arg2338_1412;
					  {
					     obj_t arg2343_1416;
					     obj_t arg2344_1417;
					     {
						obj_t list2349_1422;
						{
						   obj_t arg2350_1423;
						   {
						      obj_t arg2351_1424;
						      arg2351_1424 = MAKE_PAIR(tid_1341, BNIL);
						      arg2350_1423 = MAKE_PAIR(_4dots_tools_misc, arg2351_1424);
						   }
						   list2349_1422 = MAKE_PAIR(new_1340, arg2350_1423);
						}
						arg2343_1416 = symbol_append_197___r4_symbols_6_4(list2349_1422);
					     }
					     {
						obj_t arg2353_1426;
						obj_t arg2354_1427;
						{
						   obj_t arg2360_1433;
						   arg2360_1433 = CNST_TABLE_REF(((long) 42));
						   {
						      obj_t list2361_1434;
						      {
							 obj_t arg2362_1435;
							 {
							    obj_t arg2363_1436;
							    arg2363_1436 = MAKE_PAIR(tid_1341, BNIL);
							    arg2362_1435 = MAKE_PAIR(_4dots_tools_misc, arg2363_1436);
							 }
							 list2361_1434 = MAKE_PAIR(arg2360_1433, arg2362_1435);
						      }
						      arg2353_1426 = symbol_append_197___r4_symbols_6_4(list2361_1434);
						   }
						}
						{
						   obj_t arg2366_1439;
						   arg2366_1439 = (((type_t) CREF(type_71))->name);
						   {
						      obj_t list2368_1441;
						      {
							 obj_t arg2369_1442;
							 {
							    obj_t arg2370_1443;
							    arg2370_1443 = MAKE_PAIR(string2467_object_struct, BNIL);
							    arg2369_1442 = MAKE_PAIR(arg2366_1439, arg2370_1443);
							 }
							 list2368_1441 = MAKE_PAIR(string2468_object_struct, arg2369_1442);
						      }
						      arg2354_1427 = string_append_106___r4_strings_6_7(list2368_1441);
						   }
						}
						{
						   obj_t list2356_1429;
						   {
						      obj_t arg2357_1430;
						      {
							 obj_t arg2358_1431;
							 arg2358_1431 = MAKE_PAIR(BNIL, BNIL);
							 arg2357_1430 = MAKE_PAIR(old_1336, arg2358_1431);
						      }
						      list2356_1429 = MAKE_PAIR(arg2354_1427, arg2357_1430);
						   }
						   arg2344_1417 = cons__138___r4_pairs_and_lists_6_3(arg2353_1426, list2356_1429);
						}
					     }
					     {
						obj_t list2346_1419;
						{
						   obj_t arg2347_1420;
						   arg2347_1420 = MAKE_PAIR(BNIL, BNIL);
						   list2346_1419 = MAKE_PAIR(arg2344_1417, arg2347_1420);
						}
						arg2338_1412 = cons__138___r4_pairs_and_lists_6_3(arg2343_1416, list2346_1419);
					     }
					  }
					  {
					     obj_t list2340_1414;
					     list2340_1414 = MAKE_PAIR(BNIL, BNIL);
					     arg2326_1402 = cons__138___r4_pairs_and_lists_6_3(arg2338_1412, list2340_1414);
					  }
				       }
				       {
					  obj_t arg2372_1445;
					  obj_t arg2373_1446;
					  arg2372_1445 = CNST_TABLE_REF(((long) 43));
					  {
					     obj_t arg2379_1452;
					     obj_t arg2380_1453;
					     arg2379_1452 = CNST_TABLE_REF(((long) 44));
					     {
						obj_t arg2385_1458;
						obj_t arg2386_1459;
						obj_t arg2387_1460;
						arg2385_1458 = CNST_TABLE_REF(((long) 45));
						arg2386_1459 = (((global_t) CREF(holder_1342))->id);
						arg2387_1460 = (((global_t) CREF(holder_1342))->module);
						{
						   obj_t list2389_1462;
						   {
						      obj_t arg2390_1463;
						      {
							 obj_t arg2391_1464;
							 arg2391_1464 = MAKE_PAIR(BNIL, BNIL);
							 arg2390_1463 = MAKE_PAIR(arg2387_1460, arg2391_1464);
						      }
						      list2389_1462 = MAKE_PAIR(arg2386_1459, arg2390_1463);
						   }
						   arg2380_1453 = cons__138___r4_pairs_and_lists_6_3(arg2385_1458, list2389_1462);
						}
					     }
					     {
						obj_t list2382_1455;
						{
						   obj_t arg2383_1456;
						   arg2383_1456 = MAKE_PAIR(BNIL, BNIL);
						   list2382_1455 = MAKE_PAIR(arg2380_1453, arg2383_1456);
						}
						arg2373_1446 = cons__138___r4_pairs_and_lists_6_3(arg2379_1452, list2382_1455);
					     }
					  }
					  {
					     obj_t list2375_1448;
					     {
						obj_t arg2376_1449;
						{
						   obj_t arg2377_1450;
						   arg2377_1450 = MAKE_PAIR(BNIL, BNIL);
						   arg2376_1449 = MAKE_PAIR(arg2373_1446, arg2377_1450);
						}
						list2375_1448 = MAKE_PAIR(new_1340, arg2376_1449);
					     }
					     arg2327_1403 = cons__138___r4_pairs_and_lists_6_3(arg2372_1445, list2375_1448);
					  }
				       }
				       {
					  obj_t arg2393_1466;
					  obj_t arg2394_1467;
					  arg2393_1466 = CNST_TABLE_REF(((long) 39));
					  {
					     obj_t arg2400_1473;
					     {
						obj_t arg2403_1476;
						obj_t arg2404_1477;
						{
						   long i_1478;
						   obj_t ref__130_1479;
						   i_1478 = ((long) 0);
						   ref__130_1479 = BNIL;
						 loop_1480:
						   if ((i_1478 == len_1337))
						     {
							arg2403_1476 = reverse__39___r4_pairs_and_lists_6_3(ref__130_1479);
						     }
						   else
						     {
							long arg2408_1484;
							obj_t arg2409_1485;
							arg2408_1484 = (i_1478 + ((long) 1));
							{
							   obj_t arg2410_1486;
							   {
							      obj_t arg2417_1487;
							      arg2417_1487 = CNST_TABLE_REF(((long) 31));
							      {
								 obj_t list2419_1489;
								 {
								    obj_t arg2420_1490;
								    {
								       obj_t arg2421_1491;
								       arg2421_1491 = MAKE_PAIR(BNIL, BNIL);
								       {
									  obj_t aux_2677;
									  aux_2677 = BINT(i_1478);
									  arg2420_1490 = MAKE_PAIR(aux_2677, arg2421_1491);
								       }
								    }
								    list2419_1489 = MAKE_PAIR(aux_1338, arg2420_1490);
								 }
								 arg2410_1486 = cons__138___r4_pairs_and_lists_6_3(arg2417_1487, list2419_1489);
							      }
							   }
							   arg2409_1485 = MAKE_PAIR(arg2410_1486, ref__130_1479);
							}
							{
							   obj_t ref__130_2684;
							   long i_2683;
							   i_2683 = arg2408_1484;
							   ref__130_2684 = arg2409_1485;
							   ref__130_1479 = ref__130_2684;
							   i_1478 = i_2683;
							   goto loop_1480;
							}
						     }
						}
						arg2404_1477 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
						arg2400_1473 = append_2_18___r4_pairs_and_lists_6_3(arg2403_1476, arg2404_1477);
					     }
					     {
						obj_t list2401_1474;
						list2401_1474 = MAKE_PAIR(arg2400_1473, BNIL);
						arg2394_1467 = cons__138___r4_pairs_and_lists_6_3(widening_1343, list2401_1474);
					     }
					  }
					  {
					     obj_t list2396_1469;
					     {
						obj_t arg2397_1470;
						{
						   obj_t arg2398_1471;
						   arg2398_1471 = MAKE_PAIR(BNIL, BNIL);
						   arg2397_1470 = MAKE_PAIR(arg2394_1467, arg2398_1471);
						}
						list2396_1469 = MAKE_PAIR(new_1340, arg2397_1470);
					     }
					     arg2328_1404 = cons__138___r4_pairs_and_lists_6_3(arg2393_1466, list2396_1469);
					  }
				       }
				       {
					  obj_t list2330_1406;
					  {
					     obj_t arg2331_1407;
					     {
						obj_t arg2332_1408;
						{
						   obj_t arg2334_1409;
						   {
						      obj_t arg2335_1410;
						      arg2335_1410 = MAKE_PAIR(BNIL, BNIL);
						      arg2334_1409 = MAKE_PAIR(new_1340, arg2335_1410);
						   }
						   arg2332_1408 = MAKE_PAIR(arg2328_1404, arg2334_1409);
						}
						arg2331_1407 = MAKE_PAIR(arg2327_1403, arg2332_1408);
					     }
					     list2330_1406 = MAKE_PAIR(arg2326_1402, arg2331_1407);
					  }
					  arg2291_1367 = cons__138___r4_pairs_and_lists_6_3(arg2325_1401, list2330_1406);
				       }
				    }
				    {
				       obj_t list2293_1369;
				       {
					  obj_t arg2294_1370;
					  {
					     obj_t arg2295_1371;
					     arg2295_1371 = MAKE_PAIR(BNIL, BNIL);
					     arg2294_1370 = MAKE_PAIR(arg2291_1367, arg2295_1371);
					  }
					  list2293_1369 = MAKE_PAIR(arg2290_1366, arg2294_1370);
				       }
				       arg2263_1346 = cons__138___r4_pairs_and_lists_6_3(arg2289_1365, list2293_1369);
				    }
				 }
				 {
				    obj_t list2265_1348;
				    {
				       obj_t arg2266_1349;
				       {
					  obj_t arg2267_1350;
					  arg2267_1350 = MAKE_PAIR(BNIL, BNIL);
					  arg2266_1349 = MAKE_PAIR(arg2263_1346, arg2267_1350);
				       }
				       list2265_1348 = MAKE_PAIR(arg2262_1345, arg2266_1349);
				    }
				    return cons__138___r4_pairs_and_lists_6_3(arg2261_1344, list2265_1348);
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_make_struct__wide_object_21_object_struct(obj_t env_1801, obj_t cname_1802, obj_t type_1803, obj_t module_1804, obj_t slots_1805)
{
   return make_struct__wide_object_7_object_struct(cname_1802, (type_t) (type_1803), module_1804, slots_1805);
}


obj_t 
imported_modules_init_94_object_struct()
{
   module_initialization_70_tools_error(((long) 0), "OBJECT_STRUCT");
   module_initialization_70_tools_misc(((long) 0), "OBJECT_STRUCT");
   module_initialization_70_type_type(((long) 0), "OBJECT_STRUCT");
   module_initialization_70_type_env(((long) 0), "OBJECT_STRUCT");
   module_initialization_70_type_cache(((long) 0), "OBJECT_STRUCT");
   module_initialization_70_type_tools(((long) 0), "OBJECT_STRUCT");
   module_initialization_70_ast_var(((long) 0), "OBJECT_STRUCT");
   module_initialization_70_ast_env(((long) 0), "OBJECT_STRUCT");
   module_initialization_70_engine_param(((long) 0), "OBJECT_STRUCT");
   module_initialization_70_object_class(((long) 0), "OBJECT_STRUCT");
   return module_initialization_70_object_tools(((long) 0), "OBJECT_STRUCT");
}
