/*===========================================================================*/
/*   (Object/tools.scm)                                                      */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;


extern obj_t _class__obj_id_208_object_tools(obj_t, obj_t);
extern obj_t make_pragma_direct_set__7_object_tools(type_t, obj_t, obj_t, obj_t);
extern obj_t make_pragma_indexed_ref_widening_28_object_tools(type_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t malloc_object_tools(type_t, obj_t);
extern obj_t _make_pragma_indexed_set__widening_42_object_tools(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_object_tools();
extern obj_t module_initialization_70_object_tools(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t toplevel_init_63_object_tools();
static obj_t cnst_init_137_object_tools();
extern obj_t make_pragma_direct_set__widening_17_object_tools(type_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_pragma_indexed_set__widening_24_object_tools(type_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_pragma_direct_ref_widening_240_object_tools(type_t, obj_t, obj_t, obj_t);
extern obj_t super__class_id_210_object_tools(obj_t, obj_t);
extern obj_t make_pragma_indexed_init_set__66_object_tools(type_t, obj_t, obj_t, obj_t);
extern obj_t _make_pragma_direct_set__177_object_tools(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _super__class_id_61_object_tools(obj_t, obj_t, obj_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t string_sans___40_type_tools(obj_t);
static obj_t make_pragma_indexed_ref_228_object_tools(type_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_object_tools = BUNSPEC;
extern obj_t class__id_80_object_tools(obj_t);
extern obj_t _make_pragma_indexed_set__138_object_tools(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t library_modules_init_112_object_tools();
extern obj_t _make_pragma_direct_set__widening_61_object_tools(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _make_pragma_indexed_ref_widening_107_object_tools(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _malloc_object_tools(obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t class__obj_id_219_object_tools(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t _make_pragma_direct_ref_widening_149_object_tools(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t alloca_object_tools(type_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t _class__super_id_254_object_tools(obj_t, obj_t, obj_t);
extern obj_t _obj__class_id_160_object_tools(obj_t, obj_t);
extern obj_t _4dots_tools_misc;
extern type_t find_type_26_type_env(obj_t);
extern obj_t _alloca_object_tools(obj_t, obj_t, obj_t);
extern obj_t class__super_id_210_object_tools(obj_t, obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t make_pragma_indexed_set__175_object_tools(type_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t obj__class_id_9_object_tools(obj_t);
extern obj_t _class__id_49_object_tools(obj_t, obj_t);
extern obj_t _make_pragma_indexed_init_set__29_object_tools(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t make_pragma_direct_ref_209_object_tools(type_t, obj_t, obj_t);
static obj_t malloc_allocator_153_object_tools(obj_t, type_t, obj_t);
static obj_t __cnst[8];

DEFINE_EXPORT_PROCEDURE(malloc_env_105_object_tools, _malloc_object_tools1586, _malloc_object_tools, 0L, 2);
DEFINE_STRING(string1570_object_tools, string1570_object_tools1587, ")[ $2 ] = ((", 12);
DEFINE_EXPORT_PROCEDURE(make_pragma_indexed_init_set__env_86_object_tools, _make_pragma_indexed_init_set__29_object_tools1588, _make_pragma_indexed_init_set__29_object_tools, 0L, 4);
DEFINE_EXPORT_PROCEDURE(class__super_id_env_38_object_tools, _class__super_id_254_object_tools1589, _class__super_id_254_object_tools, 0L, 2);
DEFINE_STRING(string1564_object_tools, string1564_object_tools1590, ")[ $2 ]", 7);
DEFINE_STRING(string1572_object_tools, string1572_object_tools1591, "( sizeof(", 9);
DEFINE_EXPORT_PROCEDURE(make_pragma_indexed_set__env_176_object_tools, _make_pragma_indexed_set__138_object_tools1592, _make_pragma_indexed_set__138_object_tools, 0L, 5);
DEFINE_STRING(string1574_object_tools, string1574_object_tools1593, ")BREF( ", 7);
DEFINE_STRING(string1573_object_tools, string1573_object_tools1594, ") )))", 5);
DEFINE_EXPORT_PROCEDURE(obj__class_id_env_107_object_tools, _obj__class_id_160_object_tools1595, _obj__class_id_160_object_tools, 0L, 1);
DEFINE_STRING(string1571_object_tools, string1571_object_tools1596, ") * $1 )", 8);
DEFINE_EXPORT_PROCEDURE(make_pragma_indexed_ref_widening_env_131_object_tools, _make_pragma_indexed_ref_widening_107_object_tools1597, _make_pragma_indexed_ref_widening_107_object_tools, 0L, 5);
DEFINE_STRING(string1568_object_tools, string1568_object_tools1598, " *)$2), BUNSPEC)", 16);
DEFINE_STRING(string1577_object_tools, string1577_object_tools1599, "STACK_ALLOC", 11);
DEFINE_STRING(string1565_object_tools, string1565_object_tools1600, ")$2), BUNSPEC)", 14);
DEFINE_STRING(string1575_object_tools, string1575_object_tools1601, "((", 2);
DEFINE_EXPORT_PROCEDURE(make_pragma_direct_ref_widening_env_95_object_tools, _make_pragma_direct_ref_widening_149_object_tools1602, _make_pragma_direct_ref_widening_149_object_tools, 0L, 4);
DEFINE_STRING(string1576_object_tools, string1576_object_tools1603, "GC_MALLOC", 9);
DEFINE_STRING(string1566_object_tools, string1566_object_tools1604, ") = ((", 6);
DEFINE_EXPORT_PROCEDURE(make_pragma_direct_set__env_183_object_tools, _make_pragma_direct_set__177_object_tools1605, _make_pragma_direct_set__177_object_tools, 0L, 4);
DEFINE_STRING(string1578_object_tools, string1578_object_tools1606, "VOID* PRAGMA::OBJ OBJECT-WIDENING FREE-PRAGMA -> ? OBJ-> ->OBJ ", 63);
DEFINE_EXPORT_PROCEDURE(class__obj_id_env_11_object_tools, _class__obj_id_208_object_tools1607, _class__obj_id_208_object_tools, 0L, 1);
DEFINE_EXPORT_PROCEDURE(super__class_id_env_38_object_tools, _super__class_id_61_object_tools1608, _super__class_id_61_object_tools, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_pragma_indexed_set__widening_env_6_object_tools, _make_pragma_indexed_set__widening_42_object_tools1609, _make_pragma_indexed_set__widening_42_object_tools, 0L, 6);
DEFINE_EXPORT_PROCEDURE(alloca_env_212_object_tools, _alloca_object_tools1610, _alloca_object_tools, 0L, 2);
DEFINE_EXPORT_PROCEDURE(class__id_env_134_object_tools, _class__id_49_object_tools1611, _class__id_49_object_tools, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pragma_direct_set__widening_env_195_object_tools, _make_pragma_direct_set__widening_61_object_tools1612, _make_pragma_direct_set__widening_61_object_tools, 0L, 5);
DEFINE_STRING(string1563_object_tools, string1563_object_tools1613, "(((", 3);
DEFINE_STRING(string1567_object_tools, string1567_object_tools1614, "((((", 4);
DEFINE_STRING(string1561_object_tools, string1561_object_tools1615, ")", 1);
DEFINE_STRING(string1569_object_tools, string1569_object_tools1616, ")$3), BUNSPEC)", 14);
DEFINE_STRING(string1562_object_tools, string1562_object_tools1617, ")CREF($1))->", 12);

obj_t 
module_initialization_70_object_tools(long checksum_1006, char *from_1007)
{
   if (CBOOL(require_initialization_114_object_tools))
     {
	require_initialization_114_object_tools = BBOOL(((bool_t) 0));
	library_modules_init_112_object_tools();
	cnst_init_137_object_tools();
	imported_modules_init_94_object_tools();
	toplevel_init_63_object_tools();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_object_tools()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_TOOLS");
   module_initialization_70___reader(((long) 0), "OBJECT_TOOLS");
   module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_TOOLS");
   module_initialization_70___r4_strings_6_7(((long) 0), "OBJECT_TOOLS");
   return BUNSPEC;
}


obj_t 
cnst_init_137_object_tools()
{
   {
      obj_t cnst_port_138_998;
      cnst_port_138_998 = open_input_string(string1578_object_tools);
      {
	 long i_999;
	 i_999 = ((long) 7);
       loop_1000:
	 {
	    bool_t test1579_1001;
	    test1579_1001 = (i_999 == ((long) -1));
	    if (test1579_1001)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1582_1002;
		    {
		       obj_t list1583_1003;
		       {
			  obj_t arg1584_1004;
			  arg1584_1004 = BNIL;
			  list1583_1003 = MAKE_PAIR(cnst_port_138_998, arg1584_1004);
		       }
		       arg1582_1002 = read___reader(list1583_1003);
		    }
		    CNST_TABLE_SET(i_999, arg1582_1002);
		 }
		 {
		    int aux_1005;
		    {
		       long aux_1025;
		       aux_1025 = (i_999 - ((long) 1));
		       aux_1005 = (int) (aux_1025);
		    }
		    {
		       long i_1028;
		       i_1028 = (long) (aux_1005);
		       i_999 = i_1028;
		       goto loop_1000;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_object_tools()
{
   return BUNSPEC;
}


obj_t 
class__obj_id_219_object_tools(obj_t id_47)
{
   {
      obj_t list1200_466;
      {
	 obj_t arg1203_467;
	 {
	    obj_t aux_1030;
	    aux_1030 = CNST_TABLE_REF(((long) 0));
	    arg1203_467 = MAKE_PAIR(aux_1030, BNIL);
	 }
	 list1200_466 = MAKE_PAIR(id_47, arg1203_467);
      }
      return symbol_append_197___r4_symbols_6_4(list1200_466);
   }
}


obj_t 
_class__obj_id_208_object_tools(obj_t env_939, obj_t id_940)
{
   return class__obj_id_219_object_tools(id_940);
}


obj_t 
obj__class_id_9_object_tools(obj_t id_48)
{
   {
      obj_t arg1205_469;
      arg1205_469 = CNST_TABLE_REF(((long) 1));
      {
	 obj_t list1206_470;
	 {
	    obj_t arg1207_471;
	    arg1207_471 = MAKE_PAIR(id_48, BNIL);
	    list1206_470 = MAKE_PAIR(arg1205_469, arg1207_471);
	 }
	 return symbol_append_197___r4_symbols_6_4(list1206_470);
      }
   }
}


obj_t 
_obj__class_id_160_object_tools(obj_t env_941, obj_t id_942)
{
   return obj__class_id_9_object_tools(id_942);
}


obj_t 
class__id_80_object_tools(obj_t id_49)
{
   {
      obj_t list1210_474;
      {
	 obj_t arg1212_475;
	 {
	    obj_t aux_1041;
	    aux_1041 = CNST_TABLE_REF(((long) 2));
	    arg1212_475 = MAKE_PAIR(aux_1041, BNIL);
	 }
	 list1210_474 = MAKE_PAIR(id_49, arg1212_475);
      }
      return symbol_append_197___r4_symbols_6_4(list1210_474);
   }
}


obj_t 
_class__id_49_object_tools(obj_t env_943, obj_t id_944)
{
   return class__id_80_object_tools(id_944);
}


obj_t 
class__super_id_210_object_tools(obj_t class_50, obj_t super_51)
{
   {
      obj_t arg1214_477;
      arg1214_477 = CNST_TABLE_REF(((long) 3));
      {
	 obj_t list1215_478;
	 {
	    obj_t arg1217_479;
	    {
	       obj_t arg1218_480;
	       arg1218_480 = MAKE_PAIR(super_51, BNIL);
	       arg1217_479 = MAKE_PAIR(arg1214_477, arg1218_480);
	    }
	    list1215_478 = MAKE_PAIR(class_50, arg1217_479);
	 }
	 return symbol_append_197___r4_symbols_6_4(list1215_478);
      }
   }
}


obj_t 
_class__super_id_254_object_tools(obj_t env_945, obj_t class_946, obj_t super_947)
{
   return class__super_id_210_object_tools(class_946, super_947);
}


obj_t 
super__class_id_210_object_tools(obj_t super_52, obj_t class_53)
{
   {
      obj_t arg1222_482;
      arg1222_482 = CNST_TABLE_REF(((long) 3));
      {
	 obj_t list1223_483;
	 {
	    obj_t arg1225_484;
	    {
	       obj_t arg1227_485;
	       arg1227_485 = MAKE_PAIR(class_53, BNIL);
	       arg1225_484 = MAKE_PAIR(arg1222_482, arg1227_485);
	    }
	    list1223_483 = MAKE_PAIR(super_52, arg1225_484);
	 }
	 return symbol_append_197___r4_symbols_6_4(list1223_483);
      }
   }
}


obj_t 
_super__class_id_61_object_tools(obj_t env_948, obj_t super_949, obj_t class_950)
{
   return super__class_id_210_object_tools(super_949, class_950);
}


obj_t 
make_pragma_direct_ref_209_object_tools(type_t type_54, obj_t slot_55, obj_t obj_56)
{
   {
      obj_t arg1230_487;
      obj_t arg1231_488;
      {
	 obj_t arg1239_494;
	 arg1239_494 = CNST_TABLE_REF(((long) 4));
	 {
	    obj_t list1241_496;
	    {
	       obj_t arg1242_497;
	       {
		  obj_t arg1245_498;
		  {
		     obj_t aux_1060;
		     {
			type_t obj_864;
			{
			   obj_t aux_1061;
			   aux_1061 = STRUCT_REF(slot_55, ((long) 2));
			   obj_864 = (type_t) (aux_1061);
			}
			aux_1060 = (((type_t) CREF(obj_864))->id);
		     }
		     arg1245_498 = MAKE_PAIR(aux_1060, BNIL);
		  }
		  arg1242_497 = MAKE_PAIR(_4dots_tools_misc, arg1245_498);
	       }
	       list1241_496 = MAKE_PAIR(arg1239_494, arg1242_497);
	    }
	    arg1230_487 = symbol_append_197___r4_symbols_6_4(list1241_496);
	 }
      }
      {
	 obj_t arg1251_502;
	 obj_t arg1255_504;
	 arg1251_502 = (((type_t) CREF(type_54))->name);
	 arg1255_504 = STRUCT_REF(slot_55, ((long) 1));
	 {
	    obj_t list1257_506;
	    {
	       obj_t arg1259_507;
	       {
		  obj_t arg1260_508;
		  {
		     obj_t arg1261_509;
		     {
			obj_t arg1265_510;
			arg1265_510 = MAKE_PAIR(string1561_object_tools, BNIL);
			arg1261_509 = MAKE_PAIR(arg1255_504, arg1265_510);
		     }
		     arg1260_508 = MAKE_PAIR(string1562_object_tools, arg1261_509);
		  }
		  arg1259_507 = MAKE_PAIR(arg1251_502, arg1260_508);
	       }
	       list1257_506 = MAKE_PAIR(string1563_object_tools, arg1259_507);
	    }
	    arg1231_488 = string_append_106___r4_strings_6_7(list1257_506);
	 }
      }
      {
	 obj_t list1234_490;
	 {
	    obj_t arg1235_491;
	    {
	       obj_t arg1236_492;
	       arg1236_492 = MAKE_PAIR(BNIL, BNIL);
	       arg1235_491 = MAKE_PAIR(obj_56, arg1236_492);
	    }
	    list1234_490 = MAKE_PAIR(arg1231_488, arg1235_491);
	 }
	 return cons__138___r4_pairs_and_lists_6_3(arg1230_487, list1234_490);
      }
   }
}


obj_t 
make_pragma_direct_ref_widening_240_object_tools(type_t type_57, obj_t slot_58, obj_t obj_59, obj_t widening_60)
{
   if (CBOOL(widening_60))
     {
	obj_t arg1267_512;
	{
	   obj_t arg1268_513;
	   arg1268_513 = CNST_TABLE_REF(((long) 5));
	   {
	      obj_t list1271_515;
	      {
		 obj_t arg1272_516;
		 arg1272_516 = MAKE_PAIR(BNIL, BNIL);
		 list1271_515 = MAKE_PAIR(obj_59, arg1272_516);
	      }
	      arg1267_512 = cons__138___r4_pairs_and_lists_6_3(arg1268_513, list1271_515);
	   }
	}
	return make_pragma_direct_ref_209_object_tools(type_57, slot_58, arg1267_512);
     }
   else
     {
	return make_pragma_direct_ref_209_object_tools(type_57, slot_58, obj_59);
     }
}


obj_t 
_make_pragma_direct_ref_widening_149_object_tools(obj_t env_951, obj_t type_952, obj_t slot_953, obj_t obj_954, obj_t widening_955)
{
   return make_pragma_direct_ref_widening_240_object_tools((type_t) (type_952), slot_953, obj_954, widening_955);
}


obj_t 
make_pragma_indexed_ref_228_object_tools(type_t type_61, obj_t slot_62, obj_t obj_63, obj_t index_64)
{
   {
      obj_t arg1275_518;
      obj_t arg1276_519;
      {
	 obj_t arg1286_526;
	 arg1286_526 = CNST_TABLE_REF(((long) 4));
	 {
	    obj_t list1288_528;
	    {
	       obj_t arg1290_529;
	       {
		  obj_t arg1293_530;
		  {
		     obj_t aux_1092;
		     {
			type_t obj_872;
			{
			   obj_t aux_1093;
			   aux_1093 = STRUCT_REF(slot_62, ((long) 2));
			   obj_872 = (type_t) (aux_1093);
			}
			aux_1092 = (((type_t) CREF(obj_872))->id);
		     }
		     arg1293_530 = MAKE_PAIR(aux_1092, BNIL);
		  }
		  arg1290_529 = MAKE_PAIR(_4dots_tools_misc, arg1293_530);
	       }
	       list1288_528 = MAKE_PAIR(arg1286_526, arg1290_529);
	    }
	    arg1275_518 = symbol_append_197___r4_symbols_6_4(list1288_528);
	 }
      }
      {
	 obj_t arg1298_534;
	 obj_t arg1300_536;
	 arg1298_534 = (((type_t) CREF(type_61))->name);
	 arg1300_536 = STRUCT_REF(slot_62, ((long) 1));
	 {
	    obj_t list1304_538;
	    {
	       obj_t arg1305_539;
	       {
		  obj_t arg1307_540;
		  {
		     obj_t arg1308_541;
		     {
			obj_t arg1310_542;
			arg1310_542 = MAKE_PAIR(string1564_object_tools, BNIL);
			arg1308_541 = MAKE_PAIR(arg1300_536, arg1310_542);
		     }
		     arg1307_540 = MAKE_PAIR(string1562_object_tools, arg1308_541);
		  }
		  arg1305_539 = MAKE_PAIR(arg1298_534, arg1307_540);
	       }
	       list1304_538 = MAKE_PAIR(string1563_object_tools, arg1305_539);
	    }
	    arg1276_519 = string_append_106___r4_strings_6_7(list1304_538);
	 }
      }
      {
	 obj_t list1279_521;
	 {
	    obj_t arg1280_522;
	    {
	       obj_t arg1282_523;
	       {
		  obj_t arg1283_524;
		  arg1283_524 = MAKE_PAIR(BNIL, BNIL);
		  arg1282_523 = MAKE_PAIR(index_64, arg1283_524);
	       }
	       arg1280_522 = MAKE_PAIR(obj_63, arg1282_523);
	    }
	    list1279_521 = MAKE_PAIR(arg1276_519, arg1280_522);
	 }
	 return cons__138___r4_pairs_and_lists_6_3(arg1275_518, list1279_521);
      }
   }
}


obj_t 
make_pragma_indexed_ref_widening_28_object_tools(type_t type_65, obj_t slot_66, obj_t obj_67, obj_t index_68, obj_t widening_69)
{
   if (CBOOL(widening_69))
     {
	obj_t arg1312_544;
	{
	   obj_t arg1313_545;
	   arg1313_545 = CNST_TABLE_REF(((long) 5));
	   {
	      obj_t list1315_547;
	      {
		 obj_t arg1316_548;
		 arg1316_548 = MAKE_PAIR(BNIL, BNIL);
		 list1315_547 = MAKE_PAIR(obj_67, arg1316_548);
	      }
	      arg1312_544 = cons__138___r4_pairs_and_lists_6_3(arg1313_545, list1315_547);
	   }
	}
	return make_pragma_indexed_ref_228_object_tools(type_65, slot_66, arg1312_544, index_68);
     }
   else
     {
	return make_pragma_indexed_ref_228_object_tools(type_65, slot_66, obj_67, index_68);
     }
}


obj_t 
_make_pragma_indexed_ref_widening_107_object_tools(obj_t env_956, obj_t type_957, obj_t slot_958, obj_t obj_959, obj_t index_960, obj_t widening_961)
{
   return make_pragma_indexed_ref_widening_28_object_tools((type_t) (type_957), slot_958, obj_959, index_960, widening_961);
}


obj_t 
make_pragma_direct_set__7_object_tools(type_t type_70, obj_t slot_71, obj_t obj_72, obj_t val_73)
{
   {
      obj_t arg1319_550;
      obj_t arg1320_551;
      arg1319_550 = CNST_TABLE_REF(((long) 6));
      {
	 obj_t arg1331_559;
	 obj_t arg1333_561;
	 obj_t arg1337_563;
	 arg1331_559 = (((type_t) CREF(type_70))->name);
	 arg1333_561 = STRUCT_REF(slot_71, ((long) 1));
	 {
	    type_t obj_884;
	    {
	       obj_t aux_1127;
	       aux_1127 = STRUCT_REF(slot_71, ((long) 2));
	       obj_884 = (type_t) (aux_1127);
	    }
	    arg1337_563 = (((type_t) CREF(obj_884))->name);
	 }
	 {
	    obj_t list1340_565;
	    {
	       obj_t arg1342_566;
	       {
		  obj_t arg1343_567;
		  {
		     obj_t arg1345_568;
		     {
			obj_t arg1346_569;
			{
			   obj_t arg1347_570;
			   {
			      obj_t arg1349_571;
			      arg1349_571 = MAKE_PAIR(string1565_object_tools, BNIL);
			      arg1347_570 = MAKE_PAIR(arg1337_563, arg1349_571);
			   }
			   arg1346_569 = MAKE_PAIR(string1566_object_tools, arg1347_570);
			}
			arg1345_568 = MAKE_PAIR(arg1333_561, arg1346_569);
		     }
		     arg1343_567 = MAKE_PAIR(string1562_object_tools, arg1345_568);
		  }
		  arg1342_566 = MAKE_PAIR(arg1331_559, arg1343_567);
	       }
	       list1340_565 = MAKE_PAIR(string1567_object_tools, arg1342_566);
	    }
	    arg1320_551 = string_append_106___r4_strings_6_7(list1340_565);
	 }
      }
      {
	 obj_t list1322_553;
	 {
	    obj_t arg1323_554;
	    {
	       obj_t arg1325_555;
	       {
		  obj_t arg1327_556;
		  arg1327_556 = MAKE_PAIR(BNIL, BNIL);
		  arg1325_555 = MAKE_PAIR(val_73, arg1327_556);
	       }
	       arg1323_554 = MAKE_PAIR(obj_72, arg1325_555);
	    }
	    list1322_553 = MAKE_PAIR(arg1320_551, arg1323_554);
	 }
	 return cons__138___r4_pairs_and_lists_6_3(arg1319_550, list1322_553);
      }
   }
}


obj_t 
_make_pragma_direct_set__177_object_tools(obj_t env_962, obj_t type_963, obj_t slot_964, obj_t obj_965, obj_t val_966)
{
   return make_pragma_direct_set__7_object_tools((type_t) (type_963), slot_964, obj_965, val_966);
}


obj_t 
make_pragma_direct_set__widening_17_object_tools(type_t type_74, obj_t slot_75, obj_t obj_76, obj_t val_77, obj_t widening_78)
{
   if (CBOOL(widening_78))
     {
	obj_t arg1353_574;
	{
	   obj_t arg1355_575;
	   arg1355_575 = CNST_TABLE_REF(((long) 5));
	   {
	      obj_t list1357_577;
	      {
		 obj_t arg1358_578;
		 arg1358_578 = MAKE_PAIR(BNIL, BNIL);
		 list1357_577 = MAKE_PAIR(obj_76, arg1358_578);
	      }
	      arg1353_574 = cons__138___r4_pairs_and_lists_6_3(arg1355_575, list1357_577);
	   }
	}
	return make_pragma_direct_set__7_object_tools(type_74, slot_75, arg1353_574, val_77);
     }
   else
     {
	return make_pragma_direct_set__7_object_tools(type_74, slot_75, obj_76, val_77);
     }
}


obj_t 
_make_pragma_direct_set__widening_61_object_tools(obj_t env_967, obj_t type_968, obj_t slot_969, obj_t obj_970, obj_t val_971, obj_t widening_972)
{
   return make_pragma_direct_set__widening_17_object_tools((type_t) (type_968), slot_969, obj_970, val_971, widening_972);
}


obj_t 
make_pragma_indexed_init_set__66_object_tools(type_t type_79, obj_t slot_80, obj_t obj_81, obj_t val_82)
{
   {
      obj_t arg1361_580;
      obj_t arg1363_581;
      arg1361_580 = CNST_TABLE_REF(((long) 6));
      {
	 obj_t arg1376_589;
	 obj_t arg1380_591;
	 obj_t arg1382_593;
	 arg1376_589 = (((type_t) CREF(type_79))->name);
	 arg1380_591 = STRUCT_REF(slot_80, ((long) 1));
	 {
	    type_t obj_892;
	    {
	       obj_t aux_1159;
	       aux_1159 = STRUCT_REF(slot_80, ((long) 2));
	       obj_892 = (type_t) (aux_1159);
	    }
	    arg1382_593 = (((type_t) CREF(obj_892))->name);
	 }
	 {
	    obj_t list1386_595;
	    {
	       obj_t arg1388_596;
	       {
		  obj_t arg1390_597;
		  {
		     obj_t arg1391_598;
		     {
			obj_t arg1396_599;
			{
			   obj_t arg1398_600;
			   {
			      obj_t arg1400_601;
			      arg1400_601 = MAKE_PAIR(string1568_object_tools, BNIL);
			      arg1398_600 = MAKE_PAIR(arg1382_593, arg1400_601);
			   }
			   arg1396_599 = MAKE_PAIR(string1566_object_tools, arg1398_600);
			}
			arg1391_598 = MAKE_PAIR(arg1380_591, arg1396_599);
		     }
		     arg1390_597 = MAKE_PAIR(string1562_object_tools, arg1391_598);
		  }
		  arg1388_596 = MAKE_PAIR(arg1376_589, arg1390_597);
	       }
	       list1386_595 = MAKE_PAIR(string1567_object_tools, arg1388_596);
	    }
	    arg1363_581 = string_append_106___r4_strings_6_7(list1386_595);
	 }
      }
      {
	 obj_t list1365_583;
	 {
	    obj_t arg1366_584;
	    {
	       obj_t arg1367_585;
	       {
		  obj_t arg1369_586;
		  arg1369_586 = MAKE_PAIR(BNIL, BNIL);
		  arg1367_585 = MAKE_PAIR(val_82, arg1369_586);
	       }
	       arg1366_584 = MAKE_PAIR(obj_81, arg1367_585);
	    }
	    list1365_583 = MAKE_PAIR(arg1363_581, arg1366_584);
	 }
	 return cons__138___r4_pairs_and_lists_6_3(arg1361_580, list1365_583);
      }
   }
}


obj_t 
_make_pragma_indexed_init_set__29_object_tools(obj_t env_973, obj_t type_974, obj_t slot_975, obj_t obj_976, obj_t val_977)
{
   return make_pragma_indexed_init_set__66_object_tools((type_t) (type_974), slot_975, obj_976, val_977);
}


obj_t 
make_pragma_indexed_set__175_object_tools(type_t type_83, obj_t slot_84, obj_t obj_85, obj_t val_86, obj_t index_87)
{
   {
      obj_t arg1404_604;
      obj_t arg1406_605;
      arg1404_604 = CNST_TABLE_REF(((long) 6));
      {
	 obj_t arg1417_614;
	 obj_t arg1420_616;
	 obj_t arg1424_618;
	 arg1417_614 = (((type_t) CREF(type_83))->name);
	 arg1420_616 = STRUCT_REF(slot_84, ((long) 1));
	 {
	    type_t obj_900;
	    {
	       obj_t aux_1181;
	       aux_1181 = STRUCT_REF(slot_84, ((long) 2));
	       obj_900 = (type_t) (aux_1181);
	    }
	    arg1424_618 = (((type_t) CREF(obj_900))->name);
	 }
	 {
	    obj_t list1427_620;
	    {
	       obj_t arg1428_621;
	       {
		  obj_t arg1431_622;
		  {
		     obj_t arg1432_623;
		     {
			obj_t arg1440_624;
			{
			   obj_t arg1441_625;
			   {
			      obj_t arg1444_626;
			      arg1444_626 = MAKE_PAIR(string1569_object_tools, BNIL);
			      arg1441_625 = MAKE_PAIR(arg1424_618, arg1444_626);
			   }
			   arg1440_624 = MAKE_PAIR(string1570_object_tools, arg1441_625);
			}
			arg1432_623 = MAKE_PAIR(arg1420_616, arg1440_624);
		     }
		     arg1431_622 = MAKE_PAIR(string1562_object_tools, arg1432_623);
		  }
		  arg1428_621 = MAKE_PAIR(arg1417_614, arg1431_622);
	       }
	       list1427_620 = MAKE_PAIR(string1567_object_tools, arg1428_621);
	    }
	    arg1406_605 = string_append_106___r4_strings_6_7(list1427_620);
	 }
      }
      {
	 obj_t list1409_607;
	 {
	    obj_t arg1410_608;
	    {
	       obj_t arg1411_609;
	       {
		  obj_t arg1412_610;
		  {
		     obj_t arg1414_611;
		     arg1414_611 = MAKE_PAIR(BNIL, BNIL);
		     arg1412_610 = MAKE_PAIR(val_86, arg1414_611);
		  }
		  arg1411_609 = MAKE_PAIR(index_87, arg1412_610);
	       }
	       arg1410_608 = MAKE_PAIR(obj_85, arg1411_609);
	    }
	    list1409_607 = MAKE_PAIR(arg1406_605, arg1410_608);
	 }
	 return cons__138___r4_pairs_and_lists_6_3(arg1404_604, list1409_607);
      }
   }
}


obj_t 
_make_pragma_indexed_set__138_object_tools(obj_t env_978, obj_t type_979, obj_t slot_980, obj_t obj_981, obj_t val_982, obj_t index_983)
{
   return make_pragma_indexed_set__175_object_tools((type_t) (type_979), slot_980, obj_981, val_982, index_983);
}


obj_t 
make_pragma_indexed_set__widening_24_object_tools(type_t type_88, obj_t slot_89, obj_t obj_90, obj_t val_91, obj_t index_92, obj_t widening_93)
{
   if (CBOOL(widening_93))
     {
	obj_t arg1447_901;
	{
	   obj_t arg1448_902;
	   arg1448_902 = CNST_TABLE_REF(((long) 5));
	   {
	      obj_t list1450_904;
	      {
		 obj_t arg1452_905;
		 arg1452_905 = MAKE_PAIR(BNIL, BNIL);
		 list1450_904 = MAKE_PAIR(obj_90, arg1452_905);
	      }
	      arg1447_901 = cons__138___r4_pairs_and_lists_6_3(arg1448_902, list1450_904);
	   }
	}
	return make_pragma_indexed_set__175_object_tools(type_88, slot_89, arg1447_901, val_91, index_92);
     }
   else
     {
	return make_pragma_indexed_set__175_object_tools(type_88, slot_89, obj_90, val_91, index_92);
     }
}


obj_t 
_make_pragma_indexed_set__widening_42_object_tools(obj_t env_984, obj_t type_985, obj_t slot_986, obj_t obj_987, obj_t val_988, obj_t index_989, obj_t widening_990)
{
   return make_pragma_indexed_set__widening_24_object_tools((type_t) (type_985), slot_986, obj_987, val_988, index_989, widening_990);
}


obj_t 
malloc_allocator_153_object_tools(obj_t allocator_94, type_t type_95, obj_t size_96)
{
   {
      obj_t tid_635;
      obj_t tname_636;
      obj_t sizeof_38_637;
      tid_635 = (((type_t) CREF(type_95))->id);
      tname_636 = string_sans___40_type_tools((((type_t) CREF(type_95))->name));
      {
	 bool_t test_1214;
	 {
	    obj_t aux_1215;
	    aux_1215 = (((type_t) CREF(type_95))->size);
	    test_1214 = STRINGP(aux_1215);
	 }
	 if (test_1214)
	   {
	      sizeof_38_637 = (((type_t) CREF(type_95))->size);
	   }
	 else
	   {
	      sizeof_38_637 = (((type_t) CREF(type_95))->name);
	   }
      }
      if (SYMBOLP(size_96))
	{
	   type_t void__131_639;
	   void__131_639 = find_type_26_type_env(CNST_TABLE_REF(((long) 7)));
	   {
	      {
		 obj_t arg1457_642;
		 obj_t arg1458_643;
		 {
		    obj_t arg1467_649;
		    arg1467_649 = CNST_TABLE_REF(((long) 4));
		    {
		       obj_t list1468_650;
		       {
			  obj_t arg1470_651;
			  {
			     obj_t arg1471_652;
			     {
				obj_t aux_1225;
				aux_1225 = (((type_t) CREF(void__131_639))->id);
				arg1471_652 = MAKE_PAIR(aux_1225, BNIL);
			     }
			     arg1470_651 = MAKE_PAIR(_4dots_tools_misc, arg1471_652);
			  }
			  list1468_650 = MAKE_PAIR(arg1467_649, arg1470_651);
		       }
		       arg1457_642 = symbol_append_197___r4_symbols_6_4(list1468_650);
		    }
		 }
		 {
		    obj_t list1473_654;
		    {
		       obj_t arg1474_655;
		       {
			  obj_t arg1477_657;
			  {
			     obj_t arg1478_658;
			     arg1478_658 = MAKE_PAIR(string1571_object_tools, BNIL);
			     arg1477_657 = MAKE_PAIR(sizeof_38_637, arg1478_658);
			  }
			  arg1474_655 = MAKE_PAIR(string1572_object_tools, arg1477_657);
		       }
		       list1473_654 = MAKE_PAIR(allocator_94, arg1474_655);
		    }
		    arg1458_643 = string_append_106___r4_strings_6_7(list1473_654);
		 }
		 {
		    obj_t list1462_645;
		    {
		       obj_t arg1463_646;
		       {
			  obj_t arg1465_647;
			  arg1465_647 = MAKE_PAIR(BNIL, BNIL);
			  arg1463_646 = MAKE_PAIR(size_96, arg1465_647);
		       }
		       list1462_645 = MAKE_PAIR(arg1458_643, arg1463_646);
		    }
		    return cons__138___r4_pairs_and_lists_6_3(arg1457_642, list1462_645);
		 }
	      }
	   }
	}
      else
	{
	   obj_t arg1485_662;
	   obj_t arg1486_663;
	   {
	      obj_t arg1493_668;
	      arg1493_668 = CNST_TABLE_REF(((long) 4));
	      {
		 obj_t list1494_669;
		 {
		    obj_t arg1496_670;
		    {
		       obj_t arg1497_671;
		       arg1497_671 = MAKE_PAIR(tid_635, BNIL);
		       arg1496_670 = MAKE_PAIR(_4dots_tools_misc, arg1497_671);
		    }
		    list1494_669 = MAKE_PAIR(arg1493_668, arg1496_670);
		 }
		 arg1485_662 = symbol_append_197___r4_symbols_6_4(list1494_669);
	      }
	   }
	   {
	      obj_t list1499_673;
	      {
		 obj_t arg1501_675;
		 {
		    obj_t arg1505_676;
		    {
		       obj_t arg1507_678;
		       {
			  obj_t arg1509_679;
			  {
			     obj_t arg1511_681;
			     {
				obj_t arg1513_682;
				arg1513_682 = MAKE_PAIR(string1573_object_tools, BNIL);
				arg1511_681 = MAKE_PAIR(sizeof_38_637, arg1513_682);
			     }
			     arg1509_679 = MAKE_PAIR(string1572_object_tools, arg1511_681);
			  }
			  arg1507_678 = MAKE_PAIR(allocator_94, arg1509_679);
		       }
		       arg1505_676 = MAKE_PAIR(string1574_object_tools, arg1507_678);
		    }
		    arg1501_675 = MAKE_PAIR(tname_636, arg1505_676);
		 }
		 list1499_673 = MAKE_PAIR(string1575_object_tools, arg1501_675);
	      }
	      arg1486_663 = string_append_106___r4_strings_6_7(list1499_673);
	   }
	   {
	      obj_t list1488_665;
	      {
		 obj_t arg1489_666;
		 arg1489_666 = MAKE_PAIR(BNIL, BNIL);
		 list1488_665 = MAKE_PAIR(arg1486_663, arg1489_666);
	      }
	      return cons__138___r4_pairs_and_lists_6_3(arg1485_662, list1488_665);
	   }
	}
   }
}


obj_t 
malloc_object_tools(type_t type_97, obj_t size_98)
{
   return malloc_allocator_153_object_tools(string1576_object_tools, type_97, size_98);
}


obj_t 
_malloc_object_tools(obj_t env_991, obj_t type_992, obj_t size_993)
{
   return malloc_object_tools((type_t) (type_992), size_993);
}


obj_t 
alloca_object_tools(type_t type_99, obj_t size_100)
{
   return malloc_allocator_153_object_tools(string1577_object_tools, type_99, size_100);
}


obj_t 
_alloca_object_tools(obj_t env_994, obj_t type_995, obj_t size_996)
{
   return alloca_object_tools((type_t) (type_995), size_996);
}


obj_t 
imported_modules_init_94_object_tools()
{
   module_initialization_70_tools_misc(((long) 0), "OBJECT_TOOLS");
   module_initialization_70_type_type(((long) 0), "OBJECT_TOOLS");
   module_initialization_70_type_env(((long) 0), "OBJECT_TOOLS");
   module_initialization_70_type_tools(((long) 0), "OBJECT_TOOLS");
   module_initialization_70_ast_var(((long) 0), "OBJECT_TOOLS");
   return module_initialization_70_object_class(((long) 0), "OBJECT_TOOLS");
}
