/*===========================================================================*/
/*   (Read/inline.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


static obj_t imported_modules_init_94_read_inline();
extern obj_t module_initialization_70_read_inline(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_file(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_ports_6_10_1(long, char *);
static obj_t toplevel_init_63_read_inline();
static obj_t cnst_init_137_read_inline();
extern obj_t remq__51___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t find_file_path_55_tools_file(obj_t, obj_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t require_initialization_114_read_inline = BUNSPEC;
static obj_t library_modules_init_112_read_inline();
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t close_input_port(obj_t);
extern obj_t id_of_id_112_ast_ident(obj_t);
extern obj_t val_from_exit__100___bexit(obj_t);
static obj_t handling_function1235_89_read_inline(obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t __load_path__54___eval;
extern obj_t look_for_inline_98_read_inline(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _inline_finalizer_140_read_inline(obj_t);
extern obj_t inline_finalizer_105_read_inline();
static obj_t loop_read_inline(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t look_for_inline_exp_95_read_inline(obj_t, obj_t, obj_t);
static obj_t __inline_definitions__29_read_inline = BUNSPEC;
extern obj_t open_input_file_61___r4_ports_6_10_1(obj_t, obj_t);
extern obj_t unwind_until__178___bexit(obj_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t _look_for_inline_143_read_inline(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
static obj_t __cnst[7];

DEFINE_EXPORT_PROCEDURE(inline_finalizer_env_166_read_inline, _inline_finalizer_140_read_inline1347, _inline_finalizer_140_read_inline, 0L, 0);
DEFINE_STRING(string1336_read_inline, string1336_read_inline1348, "import", 6);
DEFINE_STRING(string1339_read_inline, string1339_read_inline1349, "UNIT IMPORTED-INLINES BEGIN DEFINE-INLINE @ SIFUN DONE ", 55);
DEFINE_STRING(string1337_read_inline, string1337_read_inline1350, "Can't find inline/generic definition(s)", 39);
DEFINE_EXPORT_PROCEDURE(look_for_inline_env_65_read_inline, _look_for_inline_143_read_inline1351, _look_for_inline_143_read_inline, 0L, 5);
DEFINE_STRING(string1338_read_inline, string1338_read_inline1352, "Can't find file", 15);

obj_t 
module_initialization_70_read_inline(long checksum_690, char *from_691)
{
   if (CBOOL(require_initialization_114_read_inline))
     {
	require_initialization_114_read_inline = BBOOL(((bool_t) 0));
	library_modules_init_112_read_inline();
	cnst_init_137_read_inline();
	imported_modules_init_94_read_inline();
	toplevel_init_63_read_inline();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_read_inline()
{
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "READ_INLINE");
   module_initialization_70___reader(((long) 0), "READ_INLINE");
   module_initialization_70___bexit(((long) 0), "READ_INLINE");
   module_initialization_70___eval(((long) 0), "READ_INLINE");
   module_initialization_70___r4_ports_6_10_1(((long) 0), "READ_INLINE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_read_inline()
{
   {
      obj_t cnst_port_138_682;
      cnst_port_138_682 = open_input_string(string1339_read_inline);
      {
	 long i_683;
	 i_683 = ((long) 6);
       loop_684:
	 {
	    bool_t test1340_685;
	    test1340_685 = (i_683 == ((long) -1));
	    if (test1340_685)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1342_686;
		    {
		       obj_t list1343_687;
		       {
			  obj_t arg1345_688;
			  arg1345_688 = BNIL;
			  list1343_687 = MAKE_PAIR(cnst_port_138_682, arg1345_688);
		       }
		       arg1342_686 = read___reader(list1343_687);
		    }
		    CNST_TABLE_SET(i_683, arg1342_686);
		 }
		 {
		    int aux_689;
		    {
		       long aux_710;
		       aux_710 = (i_683 - ((long) 1));
		       aux_689 = (int) (aux_710);
		    }
		    {
		       long i_713;
		       i_713 = (long) (aux_689);
		       i_683 = i_713;
		       goto loop_684;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_read_inline()
{
   return (__inline_definitions__29_read_inline = BNIL,
      BUNSPEC);
}


obj_t 
look_for_inline_98_read_inline(obj_t inlines_19, obj_t code_20, obj_t port_21, obj_t fnames_22, obj_t module_23)
{
   {
      obj_t arg1199_327;
      obj_t arg1200_328;
      arg1199_327 = look_for_inline_exp_95_read_inline(inlines_19, code_20, module_23);
      {
	 obj_t list1201_329;
	 {
	    obj_t arg1203_330;
	    arg1203_330 = MAKE_PAIR(BTRUE, BNIL);
	    list1201_329 = MAKE_PAIR(port_21, arg1203_330);
	 }
	 arg1200_328 = read___reader(list1201_329);
      }
      return loop_read_inline(module_23, arg1199_327, arg1200_328, fnames_22, port_21);
   }
}


obj_t 
loop_read_inline(obj_t module_676, obj_t inlines_322, obj_t exp_323, obj_t fnames_324, obj_t port_325)
{
 loop_read_inline:
   {
      bool_t test1205_332;
      test1205_332 = NULLP(inlines_322);
      if (test1205_332)
	{
	   return CNST_TABLE_REF(((long) 0));
	}
      else
	{
	   bool_t test1206_333;
	   test1206_333 = EOF_OBJECTP(exp_323);
	   if (test1206_333)
	     {
		if (NULLP(fnames_324))
		  {
		     obj_t arg1210_337;
		     if (test1205_332)
		       {
			  arg1210_337 = BNIL;
		       }
		     else
		       {
			  obj_t head1114_341;
			  {
			     obj_t aux_728;
			     {
				obj_t aux_729;
				aux_729 = CAR(inlines_322);
				aux_728 = CAR(aux_729);
			     }
			     head1114_341 = MAKE_PAIR(aux_728, BNIL);
			  }
			  {
			     obj_t l1110_342;
			     obj_t tail1115_343;
			     l1110_342 = CDR(inlines_322);
			     tail1115_343 = head1114_341;
			   lname1113_344:
			     if (NULLP(l1110_342))
			       {
				  arg1210_337 = head1114_341;
			       }
			     else
			       {
				  obj_t new_tail1116_88_347;
				  {
				     obj_t aux_735;
				     {
					obj_t aux_736;
					aux_736 = CAR(l1110_342);
					aux_735 = CAR(aux_736);
				     }
				     new_tail1116_88_347 = MAKE_PAIR(aux_735, BNIL);
				  }
				  SET_CDR(tail1115_343, new_tail1116_88_347);
				  {
				     obj_t tail1115_743;
				     obj_t l1110_741;
				     l1110_741 = CDR(l1110_342);
				     tail1115_743 = new_tail1116_88_347;
				     tail1115_343 = tail1115_743;
				     l1110_342 = l1110_741;
				     goto lname1113_344;
				  }
			       }
			  }
		       }
		     return user_error_151_tools_error(string1336_read_inline, string1337_read_inline, arg1210_337, BNIL);
		  }
		else
		  {
		     obj_t fname_355;
		     fname_355 = find_file_path_55_tools_file(CAR(fnames_324), __load_path__54___eval);
		     if (STRINGP(fname_355))
		       {
			  obj_t port_357;
			  port_357 = open_input_file_61___r4_ports_6_10_1(fname_355, BNIL);
			  {
			     obj_t val1117_358;
			     val1117_358 = handling_function1235_89_read_inline(inlines_322, fnames_324, port_357, module_676);
			     if (INPUT_PORTP(port_357))
			       {
				  close_input_port(port_357);
			       }
			     else
			       {
				  BUNSPEC;
			       }
			     {
				bool_t test1232_360;
				{
				   obj_t aux_755;
				   aux_755 = val_from_exit__100___bexit(val1117_358);
				   test1232_360 = CBOOL(aux_755);
				}
				if (test1232_360)
				  {
				     return unwind_until__178___bexit(CAR(val1117_358), CDR(val1117_358));
				  }
				else
				  {
				     return val1117_358;
				  }
			     }
			  }
		       }
		     else
		       {
			  return user_error_151_tools_error(string1336_read_inline, string1338_read_inline, CAR(fnames_324), BNIL);
		       }
		  }
	     }
	   else
	     {
		{
		   obj_t arg1251_377;
		   obj_t arg1252_378;
		   arg1251_377 = look_for_inline_exp_95_read_inline(inlines_322, exp_323, module_676);
		   {
		      obj_t list1253_379;
		      {
			 obj_t arg1255_380;
			 arg1255_380 = MAKE_PAIR(BTRUE, BNIL);
			 list1253_379 = MAKE_PAIR(port_325, arg1255_380);
		      }
		      arg1252_378 = read___reader(list1253_379);
		   }
		   {
		      obj_t exp_769;
		      obj_t inlines_768;
		      inlines_768 = arg1251_377;
		      exp_769 = arg1252_378;
		      exp_323 = exp_769;
		      inlines_322 = inlines_768;
		      goto loop_read_inline;
		   }
		}
	     }
	}
   }
}


obj_t 
handling_function1235_89_read_inline(obj_t inlines_680, obj_t fnames_679, obj_t port_678, obj_t module_677)
{
   jmp_buf jmpbuf;
   obj_t an_exit1118_70_364;
   if (SET_EXIT(an_exit1118_70_364))
     {
	RESTORE_TRACE();
	return _exit_value_;
     }
   else
     {
	an_exit1118_70_364 = (obj_t) jmpbuf;
	{
	   PUSH_EXIT(an_exit1118_70_364, ((bool_t) 0));
	   {
	      obj_t val1119_365;
	      {
		 obj_t arg1236_366;
		 obj_t arg1237_367;
		 {
		    obj_t list1238_368;
		    {
		       obj_t arg1239_369;
		       arg1239_369 = MAKE_PAIR(BTRUE, BNIL);
		       list1238_368 = MAKE_PAIR(port_678, arg1239_369);
		    }
		    arg1236_366 = read___reader(list1238_368);
		 }
		 arg1237_367 = CDR(fnames_679);
		 val1119_365 = loop_read_inline(module_677, inlines_680, arg1236_366, arg1237_367, port_678);
	      }
	      POP_EXIT();
	      return val1119_365;
	   }
	}
     }
}


obj_t 
_look_for_inline_143_read_inline(obj_t env_669, obj_t inlines_670, obj_t code_671, obj_t port_672, obj_t fnames_673, obj_t module_674)
{
   return look_for_inline_98_read_inline(inlines_670, code_671, port_672, fnames_673, module_674);
}


obj_t 
look_for_inline_exp_95_read_inline(obj_t inlines_24, obj_t exp_25, obj_t module_26)
{
   if (NULLP(inlines_24))
     {
	return BNIL;
     }
   else
     {
	obj_t exp__153_387;
	obj_t proto_383;
	obj_t name_384;
	obj_t body_385;
	if (PAIRP(exp_25))
	  {
	     obj_t cdr_132_143_392;
	     cdr_132_143_392 = CDR(exp_25);
	     {
		bool_t test_785;
		{
		   obj_t aux_788;
		   obj_t aux_786;
		   aux_788 = CNST_TABLE_REF(((long) 3));
		   aux_786 = CAR(exp_25);
		   test_785 = (aux_786 == aux_788);
		}
		if (test_785)
		  {
		     if (PAIRP(cdr_132_143_392))
		       {
			  obj_t car_136_42_395;
			  car_136_42_395 = CAR(cdr_132_143_392);
			  if (PAIRP(car_136_42_395))
			    {
			       proto_383 = car_136_42_395;
			       name_384 = CAR(car_136_42_395);
			       body_385 = CDR(cdr_132_143_392);
			       {
				  obj_t id_405;
				  id_405 = id_of_id_112_ast_ident(name_384);
				  {
				     obj_t cell_406;
				     cell_406 = assq___r4_pairs_and_lists_6_3(id_405, inlines_24);
				     {
					{
					   bool_t test_798;
					   if (PAIRP(cell_406))
					     {
						obj_t aux_803;
						obj_t aux_801;
						aux_803 = CNST_TABLE_REF(((long) 1));
						aux_801 = CDR(cell_406);
						test_798 = (aux_801 == aux_803);
					     }
					   else
					     {
						test_798 = ((bool_t) 0);
					     }
					   if (test_798)
					     {
						{
						   obj_t arg1275_408;
						   {
						      obj_t arg1276_409;
						      arg1276_409 = CNST_TABLE_REF(((long) 2));
						      {
							 obj_t list1279_411;
							 {
							    obj_t arg1280_412;
							    {
							       obj_t arg1282_413;
							       arg1282_413 = MAKE_PAIR(BNIL, BNIL);
							       arg1280_412 = MAKE_PAIR(module_26, arg1282_413);
							    }
							    list1279_411 = MAKE_PAIR(id_405, arg1280_412);
							 }
							 arg1275_408 = cons__138___r4_pairs_and_lists_6_3(arg1276_409, list1279_411);
						      }
						   }
						   SET_CAR(proto_383, arg1275_408);
						}
						{
						   obj_t obj2_636;
						   obj2_636 = __inline_definitions__29_read_inline;
						   __inline_definitions__29_read_inline = MAKE_PAIR(exp_25, obj2_636);
						}
						return remq__51___r4_pairs_and_lists_6_3(cell_406, inlines_24);
					     }
					   else
					     {
						return inlines_24;
					     }
					}
				     }
				  }
			       }
			    }
			  else
			    {
			       return inlines_24;
			    }
		       }
		     else
		       {
			  return inlines_24;
		       }
		  }
		else
		  {
		     bool_t test_816;
		     {
			obj_t aux_819;
			obj_t aux_817;
			aux_819 = CNST_TABLE_REF(((long) 4));
			aux_817 = CAR(exp_25);
			test_816 = (aux_817 == aux_819);
		     }
		     if (test_816)
		       {
			  exp__153_387 = cdr_132_143_392;
			  {
			     obj_t inlines_418;
			     obj_t exp__153_419;
			     inlines_418 = inlines_24;
			     exp__153_419 = exp__153_387;
			   loop_420:
			     if (NULLP(exp__153_419))
			       {
				  return inlines_418;
			       }
			     else
			       {
				  obj_t arg1290_422;
				  obj_t arg1293_423;
				  arg1290_422 = look_for_inline_exp_95_read_inline(inlines_418, CAR(exp__153_419), module_26);
				  arg1293_423 = CDR(exp__153_419);
				  {
				     obj_t exp__153_828;
				     obj_t inlines_827;
				     inlines_827 = arg1290_422;
				     exp__153_828 = arg1293_423;
				     exp__153_419 = exp__153_828;
				     inlines_418 = inlines_827;
				     goto loop_420;
				  }
			       }
			  }
		       }
		     else
		       {
			  return inlines_24;
		       }
		  }
	     }
	  }
	else
	  {
	     return inlines_24;
	  }
     }
}


obj_t 
inline_finalizer_105_read_inline()
{
   {
      bool_t test1296_425;
      {
	 obj_t obj_640;
	 obj_640 = __inline_definitions__29_read_inline;
	 test1296_425 = NULLP(obj_640);
      }
      if (test1296_425)
	{
	   return BNIL;
	}
      else
	{
	   obj_t arg1297_426;
	   {
	      obj_t arg1300_429;
	      arg1300_429 = CNST_TABLE_REF(((long) 5));
	      {
		 obj_t sexp__30_643;
		 sexp__30_643 = __inline_definitions__29_read_inline;
		 {
		    obj_t new_645;
		    {
		       obj_t aux_832;
		       aux_832 = CNST_TABLE_REF(((long) 6));
		       new_645 = create_struct(aux_832, ((long) 4));
		    }
		    STRUCT_SET(new_645, ((long) 3), BTRUE);
		    STRUCT_SET(new_645, ((long) 2), sexp__30_643);
		    {
		       obj_t aux_837;
		       aux_837 = BINT(((long) 0));
		       STRUCT_SET(new_645, ((long) 1), aux_837);
		    }
		    STRUCT_SET(new_645, ((long) 0), arg1300_429);
		    arg1297_426 = new_645;
		 }
	      }
	   }
	   {
	      obj_t list1298_427;
	      list1298_427 = MAKE_PAIR(arg1297_426, BNIL);
	      return list1298_427;
	   }
	}
   }
}


obj_t 
_inline_finalizer_140_read_inline(obj_t env_675)
{
   return inline_finalizer_105_read_inline();
}


obj_t 
imported_modules_init_94_read_inline()
{
   module_initialization_70_tools_trace(((long) 0), "READ_INLINE");
   module_initialization_70_tools_error(((long) 0), "READ_INLINE");
   module_initialization_70_tools_speek(((long) 0), "READ_INLINE");
   module_initialization_70_tools_shape(((long) 0), "READ_INLINE");
   module_initialization_70_tools_file(((long) 0), "READ_INLINE");
   module_initialization_70_ast_ident(((long) 0), "READ_INLINE");
   module_initialization_70_ast_env(((long) 0), "READ_INLINE");
   module_initialization_70_type_type(((long) 0), "READ_INLINE");
   return module_initialization_70_ast_var(((long) 0), "READ_INLINE");
}
