/*===========================================================================*/
/*   (Reduce/1occ.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


static obj_t _node_1occ__94_reduce_1occ(obj_t, obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
extern obj_t __res1__155___r5_control_features_6_4;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t closure_ast_node;
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_reduce_1occ();
extern obj_t module_initialization_70_reduce_1occ(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70_ast_occur(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r5_control_features_6_4(long, char *);
static obj_t toplevel_init_63_reduce_1occ();
extern obj_t reduce_1occ__237_reduce_1occ(obj_t);
static obj_t cnst_init_137_reduce_1occ();
static obj_t node_1occ___233_reduce_1occ(obj_t, obj_t);
extern obj_t __res_number__75___r5_control_features_6_4;
static obj_t require_initialization_114_reduce_1occ = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static long __variable_removed__90_reduce_1occ;
static obj_t library_modules_init_112_reduce_1occ();
extern obj_t _reduce_1occ__206_reduce_1occ(obj_t, obj_t);
extern obj_t cast_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
static obj_t node_1occ__69_reduce_1occ(node_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t occur_var_108_ast_occur(obj_t);
static obj_t node_1occ__default1358_56_reduce_1occ(node_t, obj_t);
extern obj_t kwote_ast_node;
extern bool_t side_effect__165_effect_effect(node_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t _node_1occ__default1358_230_reduce_1occ(obj_t, obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t app_ast_node;
static obj_t __cnst[3];

DEFINE_STATIC_GENERIC(node_1occ__env_84_reduce_1occ, _node_1occ__94_reduce_1occ1771, _node_1occ__94_reduce_1occ, 0L, 2);
DEFINE_STRING(string1760_reduce_1occ, string1760_reduce_1occ1772, "***1occ: removing: ", 19);
DEFINE_STRING(string1761_reduce_1occ, string1761_reduce_1occ1773, " ", 1);
DEFINE_STRING(string1756_reduce_1occ, string1756_reduce_1occ1774, "      single occurrence      ", 29);
DEFINE_STRING(string1765_reduce_1occ, string1765_reduce_1occ1775, "READ REDUCE NODE-1OCC!-DEFAULT1358 ", 35);
DEFINE_STRING(string1757_reduce_1occ, string1757_reduce_1occ1776, "(removed : ", 11);
DEFINE_STRING(string1759_reduce_1occ, string1759_reduce_1occ1777, "***1occ: removing bindings: ", 28);
DEFINE_STRING(string1758_reduce_1occ, string1758_reduce_1occ1778, "No method for this object", 25);
DEFINE_STRING(string1763_reduce_1occ, string1763_reduce_1occ1779, "***1occ: NOT applying: ", 23);
DEFINE_STRING(string1762_reduce_1occ, string1762_reduce_1occ1780, "***1occ: applying: ", 19);
DEFINE_STRING(string1764_reduce_1occ, string1764_reduce_1occ1781, "***1occ: side-effect?: ", 23);
DEFINE_EXPORT_PROCEDURE(reduce_1occ__env_30_reduce_1occ, _reduce_1occ__206_reduce_1occ1782, _reduce_1occ__206_reduce_1occ, 0L, 1);
DEFINE_STATIC_PROCEDURE(node_1occ__default1358_env_88_reduce_1occ, _node_1occ__default1358_230_reduce_1occ1783, _node_1occ__default1358_230_reduce_1occ, 0L, 2);

obj_t 
module_initialization_70_reduce_1occ(long checksum_1626, char *from_1627)
{
   if (CBOOL(require_initialization_114_reduce_1occ))
     {
	require_initialization_114_reduce_1occ = BBOOL(((bool_t) 0));
	library_modules_init_112_reduce_1occ();
	cnst_init_137_reduce_1occ();
	imported_modules_init_94_reduce_1occ();
	toplevel_init_63_reduce_1occ();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_reduce_1occ()
{
   module_initialization_70___r5_control_features_6_4(((long) 0), "REDUCE_1OCC");
   module_initialization_70___object(((long) 0), "REDUCE_1OCC");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "REDUCE_1OCC");
   module_initialization_70___reader(((long) 0), "REDUCE_1OCC");
   return BUNSPEC;
}


obj_t 
cnst_init_137_reduce_1occ()
{
   {
      obj_t cnst_port_138_1618;
      cnst_port_138_1618 = open_input_string(string1765_reduce_1occ);
      {
	 long i_1619;
	 i_1619 = ((long) 2);
       loop_1620:
	 {
	    bool_t test1766_1621;
	    test1766_1621 = (i_1619 == ((long) -1));
	    if (test1766_1621)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1767_1622;
		    {
		       obj_t list1768_1623;
		       {
			  obj_t arg1769_1624;
			  arg1769_1624 = BNIL;
			  list1768_1623 = MAKE_PAIR(cnst_port_138_1618, arg1769_1624);
		       }
		       arg1767_1622 = read___reader(list1768_1623);
		    }
		    CNST_TABLE_SET(i_1619, arg1767_1622);
		 }
		 {
		    int aux_1625;
		    {
		       long aux_1645;
		       aux_1645 = (i_1619 - ((long) 1));
		       aux_1625 = (int) (aux_1645);
		    }
		    {
		       long i_1648;
		       i_1648 = (long) (aux_1625);
		       i_1619 = i_1648;
		       goto loop_1620;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_reduce_1occ()
{
   __variable_removed__90_reduce_1occ = ((long) 0);
   add_generic__110___object(node_1occ__env_84_reduce_1occ, node_1occ__default1358_env_88_reduce_1occ);
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, var_ast_node, ((long) 2));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, setq_ast_node, ((long) 9));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, conditional_ast_node, ((long) 10));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, fail_ast_node, ((long) 11));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, select_ast_node, ((long) 12));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, let_fun_218_ast_node, ((long) 13));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, let_var_6_ast_node, ((long) 14));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, set_ex_it_116_ast_node, ((long) 15));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, jump_ex_it_184_ast_node, ((long) 16));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, make_box_202_ast_node, ((long) 17));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, box_set__221_ast_node, ((long) 18));
   add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, box_ref_242_ast_node, ((long) 19));
   {
      long aux_1671;
      aux_1671 = add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, app_ast_node, ((long) 20));
      return BINT(aux_1671);
   }
}


obj_t 
reduce_1occ__237_reduce_1occ(obj_t globals_1)
{
   {
      obj_t list1386_679;
      list1386_679 = MAKE_PAIR(string1756_reduce_1occ, BNIL);
      verbose_tools_speek(BINT(((long) 2)), list1386_679);
   }
   occur_var_108_ast_occur(globals_1);
   __variable_removed__90_reduce_1occ = ((long) 0);
   {
      obj_t l1272_682;
      l1272_682 = globals_1;
    lname1283_683:
      if (PAIRP(l1272_682))
	{
	   {
	      value_t fun_686;
	      {
		 global_t obj_1381;
		 {
		    obj_t aux_1680;
		    aux_1680 = CAR(l1272_682);
		    obj_1381 = (global_t) (aux_1680);
		 }
		 fun_686 = (((global_t) CREF(obj_1381))->value);
	      }
	      {
		 {
		    obj_t arg1396_688;
		    {
		       obj_t __689;
		       {
			  node_t aux_1684;
			  {
			     obj_t aux_1685;
			     {
				sfun_t obj_1382;
				obj_1382 = (sfun_t) (fun_686);
				aux_1685 = (((sfun_t) CREF(obj_1382))->body);
			     }
			     aux_1684 = (node_t) (aux_1685);
			  }
			  __689 = node_1occ__69_reduce_1occ(aux_1684, BNIL);
		       }
		       {
			  obj_t node_690;
			  node_690 = __res1__155___r5_control_features_6_4;
			  arg1396_688 = node_690;
		       }
		    }
		    {
		       obj_t res1732_1385;
		       {
			  sfun_t obj_1383;
			  obj_1383 = (sfun_t) (fun_686);
			  {
			     obj_t x_1595;
			     x_1595 = ((((sfun_t) CREF(obj_1383))->body) = ((obj_t) arg1396_688), BUNSPEC);
			     res1732_1385 = BUNSPEC;
			  }
		       }
		       res1732_1385;
		    }
		 }
		 BUNSPEC;
	      }
	   }
	   {
	      obj_t l1272_1692;
	      l1272_1692 = CDR(l1272_682);
	      l1272_682 = l1272_1692;
	      goto lname1283_683;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      obj_t list1401_693;
      {
	 obj_t arg1403_695;
	 {
	    obj_t arg1404_696;
	    {
	       obj_t arg1406_697;
	       {
		  obj_t aux_1694;
		  aux_1694 = BCHAR(((unsigned char) '\n'));
		  arg1406_697 = MAKE_PAIR(aux_1694, BNIL);
	       }
	       {
		  obj_t aux_1697;
		  aux_1697 = BCHAR(((unsigned char) ')'));
		  arg1404_696 = MAKE_PAIR(aux_1697, arg1406_697);
	       }
	    }
	    {
	       obj_t aux_1700;
	       aux_1700 = BINT(__variable_removed__90_reduce_1occ);
	       arg1403_695 = MAKE_PAIR(aux_1700, arg1404_696);
	    }
	 }
	 list1401_693 = MAKE_PAIR(string1757_reduce_1occ, arg1403_695);
      }
      verbose_tools_speek(BINT(((long) 2)), list1401_693);
   }
   return globals_1;
}


obj_t 
_reduce_1occ__206_reduce_1occ(obj_t env_1593, obj_t globals_1594)
{
   return reduce_1occ__237_reduce_1occ(globals_1594);
}


obj_t 
node_1occ__default1358_56_reduce_1occ(node_t node_4, obj_t _1_exp__141_5)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1758_reduce_1occ, (obj_t) (node_4));
}


obj_t 
_node_1occ__default1358_230_reduce_1occ(obj_t env_1590, obj_t node_1591, obj_t _1_exp__141_1592)
{
   return node_1occ__default1358_56_reduce_1occ((node_t) (node_1591), _1_exp__141_1592);
}


obj_t 
node_1occ__69_reduce_1occ(node_t node_2, obj_t _1_exp__141_3)
{
 node_1occ__69_reduce_1occ:
   {
      obj_t method1538_1033;
      obj_t class1543_1034;
      {
	 obj_t arg1547_1031;
	 obj_t arg1549_1032;
	 {
	    object_t obj_1392;
	    obj_1392 = (object_t) (node_2);
	    {
	       obj_t pre_method_105_1393;
	       pre_method_105_1393 = PROCEDURE_REF(node_1occ__env_84_reduce_1occ, ((long) 2));
	       if (INTEGERP(pre_method_105_1393))
		 {
		    PROCEDURE_SET(node_1occ__env_84_reduce_1occ, ((long) 2), BUNSPEC);
		    arg1547_1031 = pre_method_105_1393;
		 }
	       else
		 {
		    long obj_class_num_177_1398;
		    obj_class_num_177_1398 = TYPE(obj_1392);
		    {
		       obj_t arg1183_1399;
		       arg1183_1399 = PROCEDURE_REF(node_1occ__env_84_reduce_1occ, ((long) 1));
		       {
			  long arg1184_1403;
			  {
			     long arg1186_1404;
			     arg1186_1404 = OBJECT_TYPE;
			     arg1184_1403 = (obj_class_num_177_1398 - arg1186_1404);
			  }
			  arg1547_1031 = VECTOR_REF(arg1183_1399, arg1184_1403);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1409;
	    object_1409 = (object_t) (node_2);
	    {
	       long arg1187_1410;
	       {
		  long arg1188_1411;
		  long arg1189_1412;
		  arg1188_1411 = TYPE(object_1409);
		  arg1189_1412 = OBJECT_TYPE;
		  arg1187_1410 = (arg1188_1411 - arg1189_1412);
	       }
	       {
		  obj_t vector_1416;
		  vector_1416 = __classes__134___object;
		  arg1549_1032 = VECTOR_REF(vector_1416, arg1187_1410);
	       }
	    }
	 }
	 method1538_1033 = arg1547_1031;
	 class1543_1034 = arg1549_1032;
	 {
	    if (INTEGERP(method1538_1033))
	      {
		 switch ((long) CINT(method1538_1033))
		   {
		   case ((long) 0):
		      __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
		      {
			 atom_t aux_1730;
			 aux_1730 = (atom_t) (node_2);
			 __res1__155___r5_control_features_6_4 = (obj_t) (aux_1730);
		      }
		      return BFALSE;
		      break;
		   case ((long) 1):
		      __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
		      {
			 kwote_t aux_1734;
			 aux_1734 = (kwote_t) (node_2);
			 __res1__155___r5_control_features_6_4 = (obj_t) (aux_1734);
		      }
		      return BFALSE;
		      break;
		   case ((long) 2):
		      {
			 var_t node_1048;
			 node_1048 = (var_t) (node_2);
			 {
			    variable_t v_1050;
			    v_1050 = (((var_t) CREF(node_1048))->variable);
			    {
			       obj_t falpha_1051;
			       falpha_1051 = assq___r4_pairs_and_lists_6_3((obj_t) (v_1050), _1_exp__141_3);
			       if (PAIRP(falpha_1051))
				 {
				    {
				       long arg1553_1053;
				       {
					  long aux_1743;
					  aux_1743 = (((variable_t) CREF(v_1050))->occurrence);
					  arg1553_1053 = (aux_1743 - ((long) 1));
				       }
				       {
					  obj_t res1733_1425;
					  {
					     obj_t x_1596;
					     x_1596 = ((((variable_t) CREF(v_1050))->occurrence) = ((long) arg1553_1053), BUNSPEC);
					     res1733_1425 = BUNSPEC;
					  }
					  res1733_1425;
				       }
				    }
				    {
				       long z1_1426;
				       z1_1426 = __variable_removed__90_reduce_1occ;
				       __variable_removed__90_reduce_1occ = (z1_1426 + ((long) 1));
				    }
				    {
				       node_t node_1748;
				       {
					  obj_t aux_1749;
					  aux_1749 = CDR(falpha_1051);
					  node_1748 = (node_t) (aux_1749);
				       }
				       node_2 = node_1748;
				       goto node_1occ__69_reduce_1occ;
				    }
				 }
			       else
				 {
				    __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
				    __res1__155___r5_control_features_6_4 = (obj_t) (node_1048);
				    return BFALSE;
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 3):
		      __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
		      {
			 closure_t aux_1755;
			 aux_1755 = (closure_t) (node_2);
			 __res1__155___r5_control_features_6_4 = (obj_t) (aux_1755);
		      }
		      return BFALSE;
		      break;
		   case ((long) 4):
		      {
			 sequence_t node_1063;
			 node_1063 = (sequence_t) (node_2);
			 {
			    obj_t val0_1293_70_1066;
			    val0_1293_70_1066 = node_1occ___233_reduce_1occ((((sequence_t) CREF(node_1063))->nodes), _1_exp__141_3);
			    __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			    __res1__155___r5_control_features_6_4 = (obj_t) (node_1063);
			    return val0_1293_70_1066;
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 app_ly_162_t node_1069;
			 node_1069 = (app_ly_162_t) (node_2);
			 {
			    obj_t reset_1072;
			    reset_1072 = node_1occ__69_reduce_1occ((((app_ly_162_t) CREF(node_1069))->fun), _1_exp__141_3);
			    {
			       obj_t nfun_1073;
			       nfun_1073 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1734_1433;
				  {
				     node_t val1163_1432;
				     val1163_1432 = (node_t) (nfun_1073);
				     {
					obj_t x_1597;
					x_1597 = ((((app_ly_162_t) CREF(node_1069))->fun) = ((node_t) val1163_1432), BUNSPEC);
					res1734_1433 = BUNSPEC;
				     }
				  }
				  res1734_1433;
			       }
			       {
				  obj_t reset__69_1074;
				  {
				     obj_t aux_1768;
				     if (CBOOL(reset_1072))
				       {
					  aux_1768 = BNIL;
				       }
				     else
				       {
					  aux_1768 = _1_exp__141_3;
				       }
				     reset__69_1074 = node_1occ__69_reduce_1occ((((app_ly_162_t) CREF(node_1069))->arg), aux_1768);
				  }
				  {
				     obj_t narg_1075;
				     narg_1075 = __res1__155___r5_control_features_6_4;
				     {
					obj_t res1735_1437;
					{
					   node_t val1164_1436;
					   val1164_1436 = (node_t) (narg_1075);
					   {
					      obj_t x_1598;
					      x_1598 = ((((app_ly_162_t) CREF(node_1069))->arg) = ((node_t) val1164_1436), BUNSPEC);
					      res1735_1437 = BUNSPEC;
					   }
					}
					res1735_1437;
				     }
				     __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
				     __res1__155___r5_control_features_6_4 = (obj_t) (node_1069);
				     if (CBOOL(reset_1072))
				       {
					  return reset_1072;
				       }
				     else
				       {
					  return reset__69_1074;
				       }
				  }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 funcall_t node_1082;
			 node_1082 = (funcall_t) (node_2);
			 {
			    obj_t reset__69_1085;
			    reset__69_1085 = node_1occ___233_reduce_1occ((((funcall_t) CREF(node_1082))->args), _1_exp__141_3);
			    __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			    __res1__155___r5_control_features_6_4 = (obj_t) (node_1082);
			    return reset__69_1085;
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 pragma_t node_1089;
			 node_1089 = (pragma_t) (node_2);
			 {
			    bool_t val0_1303_21_1092;
			    val0_1303_21_1092 = side_effect__165_effect_effect((node_t) (node_1089));
			    __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			    __res1__155___r5_control_features_6_4 = (obj_t) (node_1089);
			    return BBOOL(val0_1303_21_1092);
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 cast_t node_1094;
			 node_1094 = (cast_t) (node_2);
			 {
			    obj_t reset_1097;
			    reset_1097 = node_1occ__69_reduce_1occ((((cast_t) CREF(node_1094))->arg), _1_exp__141_3);
			    {
			       obj_t narg_1098;
			       narg_1098 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1736_1442;
				  {
				     node_t val1185_1441;
				     val1185_1441 = (node_t) (narg_1098);
				     {
					obj_t x_1599;
					x_1599 = ((((cast_t) CREF(node_1094))->arg) = ((node_t) val1185_1441), BUNSPEC);
					res1736_1442 = BUNSPEC;
				     }
				  }
				  res1736_1442;
			       }
			       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			       __res1__155___r5_control_features_6_4 = (obj_t) (node_1094);
			       return reset_1097;
			    }
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 setq_t node_1102;
			 node_1102 = (setq_t) (node_2);
			 {
			    obj_t reset_1105;
			    reset_1105 = node_1occ__69_reduce_1occ((((setq_t) CREF(node_1102))->value), _1_exp__141_3);
			    {
			       obj_t nvalue_1106;
			       nvalue_1106 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1737_1446;
				  {
				     node_t val1192_1445;
				     val1192_1445 = (node_t) (nvalue_1106);
				     {
					obj_t x_1600;
					x_1600 = ((((setq_t) CREF(node_1102))->value) = ((node_t) val1192_1445), BUNSPEC);
					res1737_1446 = BUNSPEC;
				     }
				  }
				  res1737_1446;
			       }
			       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			       __res1__155___r5_control_features_6_4 = (obj_t) (node_1102);
			       return reset_1105;
			    }
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 conditional_t node_1110;
			 node_1110 = (conditional_t) (node_2);
			 {
			    obj_t reset_1113;
			    reset_1113 = node_1occ__69_reduce_1occ((((conditional_t) CREF(node_1110))->test), _1_exp__141_3);
			    {
			       obj_t ntest_1114;
			       ntest_1114 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1738_1450;
				  {
				     node_t val1199_1449;
				     val1199_1449 = (node_t) (ntest_1114);
				     {
					obj_t x_1601;
					x_1601 = ((((conditional_t) CREF(node_1110))->test) = ((node_t) val1199_1449), BUNSPEC);
					res1738_1450 = BUNSPEC;
				     }
				  }
				  res1738_1450;
			       }
			       {
				  obj_t _1_exp___225_1115;
				  if (CBOOL(reset_1113))
				    {
				       _1_exp___225_1115 = BNIL;
				    }
				  else
				    {
				       _1_exp___225_1115 = _1_exp__141_3;
				    }
				  {
				     obj_t reset__69_1116;
				     reset__69_1116 = node_1occ__69_reduce_1occ((((conditional_t) CREF(node_1110))->true), _1_exp___225_1115);
				     {
					obj_t ntrue_1117;
					ntrue_1117 = __res1__155___r5_control_features_6_4;
					{
					   obj_t res1739_1454;
					   {
					      node_t val1200_1453;
					      val1200_1453 = (node_t) (ntrue_1117);
					      {
						 obj_t x_1602;
						 x_1602 = ((((conditional_t) CREF(node_1110))->true) = ((node_t) val1200_1453), BUNSPEC);
						 res1739_1454 = BUNSPEC;
					      }
					   }
					   res1739_1454;
					}
					{
					   obj_t reset___255_1118;
					   reset___255_1118 = node_1occ__69_reduce_1occ((((conditional_t) CREF(node_1110))->false), _1_exp___225_1115);
					   {
					      obj_t nfalse_1119;
					      nfalse_1119 = __res1__155___r5_control_features_6_4;
					      {
						 obj_t res1740_1458;
						 {
						    node_t val1201_1457;
						    val1201_1457 = (node_t) (nfalse_1119);
						    {
						       obj_t x_1603;
						       x_1603 = ((((conditional_t) CREF(node_1110))->false) = ((node_t) val1201_1457), BUNSPEC);
						       res1740_1458 = BUNSPEC;
						    }
						 }
						 res1740_1458;
					      }
					      __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
					      __res1__155___r5_control_features_6_4 = (obj_t) (node_1110);
					      if (CBOOL(reset_1113))
						{
						   return reset_1113;
						}
					      else
						{
						   if (CBOOL(reset__69_1116))
						     {
							return reset__69_1116;
						     }
						   else
						     {
							return reset___255_1118;
						     }
						}
					   }
					}
				     }
				  }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 fail_t node_1127;
			 node_1127 = (fail_t) (node_2);
			 {
			    obj_t reset_1130;
			    reset_1130 = node_1occ__69_reduce_1occ((((fail_t) CREF(node_1127))->proc), _1_exp__141_3);
			    {
			       obj_t nproc_1131;
			       nproc_1131 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1741_1462;
				  {
				     node_t val1207_1461;
				     val1207_1461 = (node_t) (nproc_1131);
				     {
					obj_t x_1604;
					x_1604 = ((((fail_t) CREF(node_1127))->proc) = ((node_t) val1207_1461), BUNSPEC);
					res1741_1462 = BUNSPEC;
				     }
				  }
				  res1741_1462;
			       }
			       {
				  obj_t _1_exp___225_1132;
				  if (CBOOL(reset_1130))
				    {
				       _1_exp___225_1132 = BNIL;
				    }
				  else
				    {
				       _1_exp___225_1132 = _1_exp__141_3;
				    }
				  {
				     obj_t reset__69_1133;
				     reset__69_1133 = node_1occ__69_reduce_1occ((((fail_t) CREF(node_1127))->msg), _1_exp___225_1132);
				     {
					obj_t nmsg_1134;
					nmsg_1134 = __res1__155___r5_control_features_6_4;
					{
					   obj_t res1742_1466;
					   {
					      node_t val1208_1465;
					      val1208_1465 = (node_t) (nmsg_1134);
					      {
						 obj_t x_1605;
						 x_1605 = ((((fail_t) CREF(node_1127))->msg) = ((node_t) val1208_1465), BUNSPEC);
						 res1742_1466 = BUNSPEC;
					      }
					   }
					   res1742_1466;
					}
					{
					   obj_t reset___255_1136;
					   {
					      obj_t aux_1836;
					      if (CBOOL(reset__69_1133))
						{
						   aux_1836 = BNIL;
						}
					      else
						{
						   aux_1836 = _1_exp___225_1132;
						}
					      reset___255_1136 = node_1occ__69_reduce_1occ((((fail_t) CREF(node_1127))->obj), aux_1836);
					   }
					   {
					      obj_t nobj_1137;
					      nobj_1137 = __res1__155___r5_control_features_6_4;
					      {
						 obj_t res1743_1470;
						 {
						    node_t val1209_1469;
						    val1209_1469 = (node_t) (nobj_1137);
						    {
						       obj_t x_1606;
						       x_1606 = ((((fail_t) CREF(node_1127))->obj) = ((node_t) val1209_1469), BUNSPEC);
						       res1743_1470 = BUNSPEC;
						    }
						 }
						 res1743_1470;
					      }
					      __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
					      __res1__155___r5_control_features_6_4 = (obj_t) (node_1127);
					      if (CBOOL(reset_1130))
						{
						   return reset_1130;
						}
					      else
						{
						   if (CBOOL(reset__69_1133))
						     {
							return reset__69_1133;
						     }
						   else
						     {
							return reset___255_1136;
						     }
						}
					   }
					}
				     }
				  }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 select_t node_1145;
			 node_1145 = (select_t) (node_2);
			 {
			    obj_t reset_1148;
			    reset_1148 = node_1occ__69_reduce_1occ((((select_t) CREF(node_1145))->test), _1_exp__141_3);
			    {
			       obj_t ntest_1149;
			       ntest_1149 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1744_1474;
				  {
				     node_t val1216_1473;
				     val1216_1473 = (node_t) (ntest_1149);
				     {
					obj_t x_1607;
					x_1607 = ((((select_t) CREF(node_1145))->test) = ((node_t) val1216_1473), BUNSPEC);
					res1744_1474 = BUNSPEC;
				     }
				  }
				  res1744_1474;
			       }
			       {
				  obj_t clauses_1151;
				  obj_t reset_1152;
				  clauses_1151 = (((select_t) CREF(node_1145))->clauses);
				  reset_1152 = reset_1148;
				loop_1153:
				  if (NULLP(clauses_1151))
				    {
				       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
				       __res1__155___r5_control_features_6_4 = (obj_t) (node_1145);
				       return reset_1152;
				    }
				  else
				    {
				       obj_t clause_1158;
				       clause_1158 = CAR(clauses_1151);
				       {
					  obj_t reset__69_1159;
					  {
					     node_t aux_1859;
					     {
						obj_t aux_1860;
						aux_1860 = CDR(clause_1158);
						aux_1859 = (node_t) (aux_1860);
					     }
					     reset__69_1159 = node_1occ__69_reduce_1occ(aux_1859, _1_exp__141_3);
					  }
					  {
					     obj_t nclause_1160;
					     nclause_1160 = __res1__155___r5_control_features_6_4;
					     SET_CDR(clause_1158, nclause_1160);
					     {
						obj_t reset_1867;
						obj_t clauses_1865;
						clauses_1865 = CDR(clauses_1151);
						if (CBOOL(reset_1152))
						  {
						     reset_1867 = reset_1152;
						  }
						else
						  {
						     reset_1867 = reset__69_1159;
						  }
						reset_1152 = reset_1867;
						clauses_1151 = clauses_1865;
						goto loop_1153;
					     }
					  }
				       }
				    }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 let_fun_218_t node_1166;
			 node_1166 = (let_fun_218_t) (node_2);
			 {
			    obj_t reset_1169;
			    reset_1169 = node_1occ__69_reduce_1occ((((let_fun_218_t) CREF(node_1166))->body), _1_exp__141_3);
			    {
			       obj_t nbody_1170;
			       nbody_1170 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1745_1485;
				  {
				     node_t val1226_1484;
				     val1226_1484 = (node_t) (nbody_1170);
				     {
					obj_t x_1608;
					x_1608 = ((((let_fun_218_t) CREF(node_1166))->body) = ((node_t) val1226_1484), BUNSPEC);
					res1745_1485 = BUNSPEC;
				     }
				  }
				  res1745_1485;
			       }
			       {
				  obj_t locals_1171;
				  obj_t reset_1172;
				  locals_1171 = (((let_fun_218_t) CREF(node_1166))->locals);
				  reset_1172 = reset_1169;
				loop_1173:
				  if (NULLP(locals_1171))
				    {
				       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
				       __res1__155___r5_control_features_6_4 = (obj_t) (node_1166);
				       return reset_1172;
				    }
				  else
				    {
				       value_t sfun_1179;
				       {
					  local_t obj_1489;
					  {
					     obj_t aux_1880;
					     aux_1880 = CAR(locals_1171);
					     obj_1489 = (local_t) (aux_1880);
					  }
					  sfun_1179 = (((local_t) CREF(obj_1489))->value);
				       }
				       {
					  {
					     obj_t reset__69_1180;
					     {
						node_t aux_1884;
						{
						   obj_t aux_1885;
						   {
						      sfun_t obj_1490;
						      obj_1490 = (sfun_t) (sfun_1179);
						      aux_1885 = (((sfun_t) CREF(obj_1490))->body);
						   }
						   aux_1884 = (node_t) (aux_1885);
						}
						reset__69_1180 = node_1occ__69_reduce_1occ(aux_1884, BNIL);
					     }
					     {
						obj_t nbody_1181;
						nbody_1181 = __res1__155___r5_control_features_6_4;
						{
						   obj_t res1746_1493;
						   {
						      sfun_t obj_1491;
						      obj_1491 = (sfun_t) (sfun_1179);
						      {
							 obj_t x_1609;
							 x_1609 = ((((sfun_t) CREF(obj_1491))->body) = ((obj_t) nbody_1181), BUNSPEC);
							 res1746_1493 = BUNSPEC;
						      }
						   }
						   res1746_1493;
						}
						{
						   obj_t reset_1894;
						   obj_t locals_1892;
						   locals_1892 = CDR(locals_1171);
						   if (CBOOL(reset_1172))
						     {
							reset_1894 = reset_1172;
						     }
						   else
						     {
							reset_1894 = reset__69_1180;
						     }
						   reset_1172 = reset_1894;
						   locals_1171 = locals_1892;
						   goto loop_1173;
						}
					     }
					  }
				       }
				    }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 let_var_6_t node_1188;
			 node_1188 = (let_var_6_t) (node_2);
			 {
			    obj_t obindings_1191;
			    bool_t reset_1192;
			    obj_t extend_1193;
			    obindings_1191 = (((let_var_6_t) CREF(node_1188))->bindings);
			    reset_1192 = ((bool_t) 0);
			    extend_1193 = BNIL;
			  loop_1194:
			    if (NULLP(obindings_1191))
			      {
				 if (reset_1192)
				   {
				      obj_t reset__69_1198;
				      reset__69_1198 = node_1occ__69_reduce_1occ((((let_var_6_t) CREF(node_1188))->body), BNIL);
				      {
					 obj_t nbody_1199;
					 nbody_1199 = __res1__155___r5_control_features_6_4;
					 {
					    obj_t res1747_1500;
					    {
					       node_t val1234_1499;
					       val1234_1499 = (node_t) (nbody_1199);
					       {
						  obj_t x_1610;
						  x_1610 = ((((let_var_6_t) CREF(node_1188))->body) = ((node_t) val1234_1499), BUNSPEC);
						  res1747_1500 = BUNSPEC;
					       }
					    }
					    res1747_1500;
					 }
					 __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
					 __res1__155___r5_control_features_6_4 = (obj_t) (node_1188);
					 return BTRUE;
				      }
				   }
				 else
				   {
				      obj_t reset__69_1205;
				      reset__69_1205 = node_1occ__69_reduce_1occ((((let_var_6_t) CREF(node_1188))->body), append_2_18___r4_pairs_and_lists_6_3(extend_1193, _1_exp__141_3));
				      {
					 obj_t nbody_1206;
					 nbody_1206 = __res1__155___r5_control_features_6_4;
					 {
					    obj_t res1748_1504;
					    {
					       node_t val1234_1503;
					       val1234_1503 = (node_t) (nbody_1206);
					       {
						  obj_t x_1611;
						  x_1611 = ((((let_var_6_t) CREF(node_1188))->body) = ((node_t) val1234_1503), BUNSPEC);
						  res1748_1504 = BUNSPEC;
					       }
					    }
					    res1748_1504;
					 }
					 {
					    obj_t obindings_1207;
					    obj_t nbindings_1208;
					    obindings_1207 = (((let_var_6_t) CREF(node_1188))->bindings);
					    nbindings_1208 = BNIL;
					  loop_1209:
					    if (NULLP(obindings_1207))
					      {
						 {
						    bool_t test_1915;
						    if ((((let_var_6_t) CREF(node_1188))->removable__42))
						      {
							 test_1915 = NULLP(nbindings_1208);
						      }
						    else
						      {
							 test_1915 = ((bool_t) 0);
						      }
						    if (test_1915)
						      {
							 {
							    bool_t test1598_1214;
							    {
							       obj_t aux_1919;
							       aux_1919 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 3)));
							       test1598_1214 = CBOOL(aux_1919);
							    }
							    if (test1598_1214)
							      {
								 obj_t arg1601_1216;
								 {
								    obj_t aux_1925;
								    {
								       node_t aux_1926;
								       aux_1926 = (((let_var_6_t) CREF(node_1188))->body);
								       aux_1925 = (obj_t) (aux_1926);
								    }
								    arg1601_1216 = shape_tools_shape(aux_1925);
								 }
								 {
								    obj_t list1602_1217;
								    {
								       obj_t arg1603_1218;
								       {
									  obj_t arg1604_1219;
									  {
									     obj_t aux_1930;
									     aux_1930 = BCHAR(((unsigned char) '\n'));
									     arg1604_1219 = MAKE_PAIR(aux_1930, BNIL);
									  }
									  arg1603_1218 = MAKE_PAIR(arg1601_1216, arg1604_1219);
								       }
								       list1602_1217 = MAKE_PAIR(string1759_reduce_1occ, arg1603_1218);
								    }
								    print_trace_107_tools_trace(list1602_1217);
								 }
							      }
							    else
							      {
								 BUNSPEC;
							      }
							 }
							 __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
							 {
							    node_t aux_1937;
							    aux_1937 = (((let_var_6_t) CREF(node_1188))->body);
							    __res1__155___r5_control_features_6_4 = (obj_t) (aux_1937);
							 }
							 return reset__69_1205;
						      }
						    else
						      {
							 {
							    obj_t arg1611_1226;
							    arg1611_1226 = reverse__39___r4_pairs_and_lists_6_3(nbindings_1208);
							    {
							       obj_t res1749_1513;
							       {
								  obj_t x_1612;
								  x_1612 = ((((let_var_6_t) CREF(node_1188))->bindings) = ((obj_t) arg1611_1226), BUNSPEC);
								  res1749_1513 = BUNSPEC;
							       }
							       res1749_1513;
							    }
							 }
							 __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
							 __res1__155___r5_control_features_6_4 = (obj_t) (node_1188);
							 return reset__69_1205;
						      }
						 }
					      }
					    else
					      {
						 bool_t test1613_1230;
						 {
						    bool_t test_1944;
						    {
						       long aux_1945;
						       {
							  local_t obj_1518;
							  {
							     obj_t aux_1946;
							     {
								obj_t aux_1947;
								aux_1947 = CAR(obindings_1207);
								aux_1946 = CAR(aux_1947);
							     }
							     obj_1518 = (local_t) (aux_1946);
							  }
							  aux_1945 = (((local_t) CREF(obj_1518))->occurrence);
						       }
						       test_1944 = (aux_1945 == ((long) 0));
						    }
						    if (test_1944)
						      {
							 bool_t test1633_1248;
							 {
							    node_t aux_1953;
							    {
							       obj_t aux_1954;
							       {
								  obj_t aux_1955;
								  aux_1955 = CAR(obindings_1207);
								  aux_1954 = CDR(aux_1955);
							       }
							       aux_1953 = (node_t) (aux_1954);
							    }
							    test1633_1248 = side_effect__165_effect_effect(aux_1953);
							 }
							 if (test1633_1248)
							   {
							      test1613_1230 = ((bool_t) 0);
							   }
							 else
							   {
							      test1613_1230 = ((bool_t) 1);
							   }
						      }
						    else
						      {
							 test1613_1230 = ((bool_t) 0);
						      }
						 }
						 if (test1613_1230)
						   {
						      {
							 bool_t test1614_1231;
							 {
							    obj_t aux_1962;
							    aux_1962 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 3)));
							    test1614_1231 = CBOOL(aux_1962);
							 }
							 if (test1614_1231)
							   {
							      obj_t arg1617_1233;
							      arg1617_1233 = shape_tools_shape(CAR(obindings_1207));
							      {
								 obj_t list1618_1234;
								 {
								    obj_t arg1619_1235;
								    {
								       obj_t arg1620_1236;
								       {
									  obj_t aux_1970;
									  aux_1970 = BCHAR(((unsigned char) '\n'));
									  arg1620_1236 = MAKE_PAIR(aux_1970, BNIL);
								       }
								       arg1619_1235 = MAKE_PAIR(arg1617_1233, arg1620_1236);
								    }
								    list1618_1234 = MAKE_PAIR(string1760_reduce_1occ, arg1619_1235);
								 }
								 print_trace_107_tools_trace(list1618_1234);
							      }
							   }
							 else
							   {
							      BUNSPEC;
							   }
						      }
						      {
							 obj_t obindings_1976;
							 obindings_1976 = CDR(obindings_1207);
							 obindings_1207 = obindings_1976;
							 goto loop_1209;
						      }
						   }
						 else
						   {
						      {
							 obj_t arg1628_1242;
							 obj_t arg1630_1243;
							 arg1628_1242 = CDR(obindings_1207);
							 {
							    obj_t aux_1979;
							    aux_1979 = CAR(obindings_1207);
							    arg1630_1243 = MAKE_PAIR(aux_1979, nbindings_1208);
							 }
							 {
							    obj_t nbindings_1983;
							    obj_t obindings_1982;
							    obindings_1982 = arg1628_1242;
							    nbindings_1983 = arg1630_1243;
							    nbindings_1208 = nbindings_1983;
							    obindings_1207 = obindings_1982;
							    goto loop_1209;
							 }
						      }
						   }
					      }
					 }
				      }
				   }
			      }
			    else
			      {
				 obj_t binding_1254;
				 binding_1254 = CAR(obindings_1191);
				 {
				    obj_t var_1255;
				    obj_t val_1256;
				    var_1255 = CAR(binding_1254);
				    val_1256 = CDR(binding_1254);
				    {
				       obj_t reset__69_1257;
				       reset__69_1257 = node_1occ__69_reduce_1occ((node_t) (val_1256), _1_exp__141_3);
				       {
					  obj_t nval_1258;
					  nval_1258 = __res1__155___r5_control_features_6_4;
					  SET_CDR(binding_1254, nval_1258);
					  {
					     bool_t test_1991;
					     if (reset_1192)
					       {
						  test_1991 = ((bool_t) 1);
					       }
					     else
					       {
						  test_1991 = CBOOL(reset__69_1257);
					       }
					     if (test_1991)
					       {
						  {
						     obj_t extend_1997;
						     bool_t reset_1996;
						     obj_t obindings_1994;
						     obindings_1994 = CDR(obindings_1191);
						     reset_1996 = ((bool_t) 1);
						     extend_1997 = BNIL;
						     extend_1193 = extend_1997;
						     reset_1192 = reset_1996;
						     obindings_1191 = obindings_1994;
						     goto loop_1194;
						  }
					       }
					     else
					       {
						  bool_t test1646_1262;
						  {
						     obj_t aux_2001;
						     obj_t aux_1998;
						     aux_2001 = CNST_TABLE_REF(((long) 2));
						     {
							local_t obj_1533;
							obj_1533 = (local_t) (var_1255);
							aux_1998 = (((local_t) CREF(obj_1533))->access);
						     }
						     test1646_1262 = (aux_1998 == aux_2001);
						  }
						  if (test1646_1262)
						    {
						       bool_t test1647_1263;
						       {
							  bool_t test_2005;
							  {
							     long aux_2006;
							     {
								local_t obj_1536;
								obj_1536 = (local_t) (var_1255);
								aux_2006 = (((local_t) CREF(obj_1536))->occurrence);
							     }
							     test_2005 = (aux_2006 == ((long) 1));
							  }
							  if (test_2005)
							    {
							       if (test1646_1262)
								 {
								    bool_t test1698_1302;
								    test1698_1302 = side_effect__165_effect_effect((node_t) (val_1256));
								    if (test1698_1302)
								      {
									 test1647_1263 = ((bool_t) 0);
								      }
								    else
								      {
									 test1647_1263 = ((bool_t) 1);
								      }
								 }
							       else
								 {
								    test1647_1263 = ((bool_t) 0);
								 }
							    }
							  else
							    {
							       test1647_1263 = ((bool_t) 0);
							    }
						       }
						       if (test1647_1263)
							 {
							    {
							       bool_t test1648_1264;
							       {
								  obj_t aux_2015;
								  aux_2015 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 3)));
								  test1648_1264 = CBOOL(aux_2015);
							       }
							       if (test1648_1264)
								 {
								    obj_t arg1651_1266;
								    obj_t arg1653_1268;
								    arg1651_1266 = shape_tools_shape(var_1255);
								    arg1653_1268 = shape_tools_shape(val_1256);
								    {
								       obj_t list1654_1269;
								       {
									  obj_t arg1655_1270;
									  {
									     obj_t arg1656_1271;
									     {
										obj_t arg1657_1272;
										{
										   obj_t arg1659_1273;
										   {
										      obj_t aux_2023;
										      aux_2023 = BCHAR(((unsigned char) '\n'));
										      arg1659_1273 = MAKE_PAIR(aux_2023, BNIL);
										   }
										   arg1657_1272 = MAKE_PAIR(arg1653_1268, arg1659_1273);
										}
										arg1656_1271 = MAKE_PAIR(string1761_reduce_1occ, arg1657_1272);
									     }
									     arg1655_1270 = MAKE_PAIR(arg1651_1266, arg1656_1271);
									  }
									  list1654_1269 = MAKE_PAIR(string1762_reduce_1occ, arg1655_1270);
								       }
								       print_trace_107_tools_trace(list1654_1269);
								    }
								 }
							       else
								 {
								    BUNSPEC;
								 }
							    }
							    {
							       obj_t arg1665_1277;
							       obj_t arg1667_1278;
							       arg1665_1277 = CDR(obindings_1191);
							       arg1667_1278 = MAKE_PAIR(binding_1254, extend_1193);
							       {
								  obj_t extend_2035;
								  bool_t reset_2034;
								  obj_t obindings_2033;
								  obindings_2033 = arg1665_1277;
								  reset_2034 = ((bool_t) 0);
								  extend_2035 = arg1667_1278;
								  extend_1193 = extend_2035;
								  reset_1192 = reset_2034;
								  obindings_1191 = obindings_2033;
								  goto loop_1194;
							       }
							    }
							 }
						       else
							 {
							    {
							       bool_t test1668_1279;
							       {
								  bool_t test_2036;
								  {
								     long aux_2037;
								     {
									local_t obj_1545;
									obj_1545 = (local_t) (var_1255);
									aux_2037 = (((local_t) CREF(obj_1545))->occurrence);
								     }
								     test_2036 = (aux_2037 == ((long) 1));
								  }
								  if (test_2036)
								    {
								       if (test1646_1262)
									 {
									    test1668_1279 = side_effect__165_effect_effect((node_t) (val_1256));
									 }
								       else
									 {
									    test1668_1279 = ((bool_t) 0);
									 }
								    }
								  else
								    {
								       test1668_1279 = ((bool_t) 0);
								    }
							       }
							       if (test1668_1279)
								 {
								    bool_t test1669_1280;
								    {
								       obj_t aux_2045;
								       aux_2045 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 3)));
								       test1669_1280 = CBOOL(aux_2045);
								    }
								    if (test1669_1280)
								      {
									 obj_t arg1673_1282;
									 obj_t arg1677_1284;
									 arg1673_1282 = shape_tools_shape(var_1255);
									 arg1677_1284 = shape_tools_shape(val_1256);
									 {
									    obj_t list1678_1285;
									    {
									       obj_t arg1679_1286;
									       {
										  obj_t arg1680_1287;
										  {
										     obj_t arg1681_1288;
										     {
											obj_t arg1682_1289;
											{
											   obj_t aux_2053;
											   aux_2053 = BCHAR(((unsigned char) '\n'));
											   arg1682_1289 = MAKE_PAIR(aux_2053, BNIL);
											}
											arg1681_1288 = MAKE_PAIR(arg1677_1284, arg1682_1289);
										     }
										     arg1680_1287 = MAKE_PAIR(string1761_reduce_1occ, arg1681_1288);
										  }
										  arg1679_1286 = MAKE_PAIR(arg1673_1282, arg1680_1287);
									       }
									       list1678_1285 = MAKE_PAIR(string1763_reduce_1occ, arg1679_1286);
									    }
									    print_trace_107_tools_trace(list1678_1285);
									 }
								      }
								    else
								      {
									 BUNSPEC;
								      }
								 }
							       else
								 {
								    BUNSPEC;
								 }
							    }
							    {
							       bool_t reset_2063;
							       obj_t obindings_2061;
							       obindings_2061 = CDR(obindings_1191);
							       reset_2063 = ((bool_t) 0);
							       reset_1192 = reset_2063;
							       obindings_1191 = obindings_2061;
							       goto loop_1194;
							    }
							 }
						    }
						  else
						    {
						       {
							  bool_t reset_2066;
							  obj_t obindings_2064;
							  obindings_2064 = CDR(obindings_1191);
							  reset_2066 = ((bool_t) 0);
							  reset_1192 = reset_2066;
							  obindings_1191 = obindings_2064;
							  goto loop_1194;
						       }
						    }
					       }
					  }
				       }
				    }
				 }
			      }
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 set_ex_it_116_t node_1310;
			 node_1310 = (set_ex_it_116_t) (node_2);
			 {
			    obj_t reset_1313;
			    reset_1313 = node_1occ__69_reduce_1occ((((set_ex_it_116_t) CREF(node_1310))->body), _1_exp__141_3);
			    {
			       obj_t nbody_1314;
			       nbody_1314 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1750_1556;
				  {
				     node_t val1242_1555;
				     val1242_1555 = (node_t) (nbody_1314);
				     {
					obj_t x_1613;
					x_1613 = ((((set_ex_it_116_t) CREF(node_1310))->body) = ((node_t) val1242_1555), BUNSPEC);
					res1750_1556 = BUNSPEC;
				     }
				  }
				  res1750_1556;
			       }
			       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			       __res1__155___r5_control_features_6_4 = (obj_t) (node_1310);
			       return reset_1313;
			    }
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 jump_ex_it_184_t node_1318;
			 node_1318 = (jump_ex_it_184_t) (node_2);
			 {
			    obj_t reset_1321;
			    reset_1321 = node_1occ__69_reduce_1occ((((jump_ex_it_184_t) CREF(node_1318))->exit), _1_exp__141_3);
			    {
			       obj_t nexit_1322;
			       nexit_1322 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1751_1560;
				  {
				     node_t val1248_1559;
				     val1248_1559 = (node_t) (nexit_1322);
				     {
					obj_t x_1614;
					x_1614 = ((((jump_ex_it_184_t) CREF(node_1318))->exit) = ((node_t) val1248_1559), BUNSPEC);
					res1751_1560 = BUNSPEC;
				     }
				  }
				  res1751_1560;
			       }
			       {
				  obj_t reset__69_1324;
				  {
				     obj_t aux_2080;
				     if (CBOOL(reset_1321))
				       {
					  aux_2080 = BNIL;
				       }
				     else
				       {
					  aux_2080 = _1_exp__141_3;
				       }
				     reset__69_1324 = node_1occ__69_reduce_1occ((((jump_ex_it_184_t) CREF(node_1318))->value), aux_2080);
				  }
				  {
				     obj_t nvalue_1325;
				     nvalue_1325 = __res1__155___r5_control_features_6_4;
				     {
					obj_t res1752_1564;
					{
					   node_t val1249_1563;
					   val1249_1563 = (node_t) (nvalue_1325);
					   {
					      obj_t x_1615;
					      x_1615 = ((((jump_ex_it_184_t) CREF(node_1318))->value) = ((node_t) val1249_1563), BUNSPEC);
					      res1752_1564 = BUNSPEC;
					   }
					}
					res1752_1564;
				     }
				     __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
				     __res1__155___r5_control_features_6_4 = (obj_t) (node_1318);
				     if (CBOOL(reset_1321))
				       {
					  return reset_1321;
				       }
				     else
				       {
					  return reset__69_1324;
				       }
				  }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 make_box_202_t node_1331;
			 node_1331 = (make_box_202_t) (node_2);
			 {
			    obj_t reset_1334;
			    reset_1334 = node_1occ__69_reduce_1occ((((make_box_202_t) CREF(node_1331))->value), _1_exp__141_3);
			    {
			       obj_t nvalue_1335;
			       nvalue_1335 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1753_1568;
				  {
				     node_t val1256_1567;
				     val1256_1567 = (node_t) (nvalue_1335);
				     {
					obj_t x_1616;
					x_1616 = ((((make_box_202_t) CREF(node_1331))->value) = ((node_t) val1256_1567), BUNSPEC);
					res1753_1568 = BUNSPEC;
				     }
				  }
				  res1753_1568;
			       }
			       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			       __res1__155___r5_control_features_6_4 = (obj_t) (node_1331);
			       return reset_1334;
			    }
			 }
		      }
		      break;
		   case ((long) 18):
		      {
			 box_set__221_t node_1339;
			 node_1339 = (box_set__221_t) (node_2);
			 {
			    obj_t reset_1342;
			    reset_1342 = node_1occ__69_reduce_1occ((((box_set__221_t) CREF(node_1339))->value), _1_exp__141_3);
			    {
			       obj_t nvalue_1343;
			       nvalue_1343 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1754_1572;
				  {
				     node_t val1270_1571;
				     val1270_1571 = (node_t) (nvalue_1343);
				     {
					obj_t x_1617;
					x_1617 = ((((box_set__221_t) CREF(node_1339))->value) = ((node_t) val1270_1571), BUNSPEC);
					res1754_1572 = BUNSPEC;
				     }
				  }
				  res1754_1572;
			       }
			       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			       __res1__155___r5_control_features_6_4 = (obj_t) (node_1339);
			       return reset_1342;
			    }
			 }
		      }
		      break;
		   case ((long) 19):
		      __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
		      {
			 box_ref_242_t aux_2106;
			 aux_2106 = (box_ref_242_t) (node_2);
			 __res1__155___r5_control_features_6_4 = (obj_t) (aux_2106);
		      }
		      return BFALSE;
		      break;
		   case ((long) 20):
		      {
			 app_t node_1351;
			 node_1351 = (app_t) (node_2);
			 {
			    obj_t reset_1354;
			    reset_1354 = node_1occ___233_reduce_1occ((((app_t) CREF(node_1351))->args), _1_exp__141_3);
			    {
			       bool_t test1712_1355;
			       if (CBOOL(reset_1354))
				 {
				    test1712_1355 = ((bool_t) 1);
				 }
			       else
				 {
				    test1712_1355 = side_effect__165_effect_effect((node_t) (node_1351));
				 }
			       if (test1712_1355)
				 {
				    {
				       bool_t test1713_1356;
				       {
					  obj_t aux_2117;
					  aux_2117 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
					  test1713_1356 = CBOOL(aux_2117);
				       }
				       if (test1713_1356)
					 {
					    obj_t arg1715_1358;
					    arg1715_1358 = shape_tools_shape((obj_t) (node_1351));
					    {
					       obj_t list1716_1359;
					       {
						  obj_t arg1717_1360;
						  {
						     obj_t arg1718_1361;
						     {
							obj_t aux_2125;
							aux_2125 = BCHAR(((unsigned char) '\n'));
							arg1718_1361 = MAKE_PAIR(aux_2125, BNIL);
						     }
						     arg1717_1360 = MAKE_PAIR(arg1715_1358, arg1718_1361);
						  }
						  list1716_1359 = MAKE_PAIR(string1764_reduce_1occ, arg1717_1360);
					       }
					       print_trace_107_tools_trace(list1716_1359);
					    }
					 }
				       else
					 {
					    BUNSPEC;
					 }
				    }
				    __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
				    __res1__155___r5_control_features_6_4 = (obj_t) (node_1351);
				    return BTRUE;
				 }
			       else
				 {
				    __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
				    __res1__155___r5_control_features_6_4 = (obj_t) (node_1351);
				    return BFALSE;
				 }
			    }
			 }
		      }
		      break;
		   default:
		    case_else1544_164_1037:
		      if (PROCEDUREP(method1538_1033))
			{
			   return PROCEDURE_ENTRY(method1538_1033) (method1538_1033, (obj_t) (node_2), _1_exp__141_3, BEOA);
			}
		      else
			{
			   obj_t fun1412_701;
			   fun1412_701 = PROCEDURE_REF(node_1occ__env_84_reduce_1occ, ((long) 0));
			   return PROCEDURE_ENTRY(fun1412_701) (fun1412_701, (obj_t) (node_2), _1_exp__141_3, BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1544_164_1037;
	      }
	 }
      }
   }
}


obj_t 
_node_1occ__94_reduce_1occ(obj_t env_1587, obj_t node_1588, obj_t _1_exp__141_1589)
{
   return node_1occ__69_reduce_1occ((node_t) (node_1588), _1_exp__141_1589);
}


obj_t 
node_1occ___233_reduce_1occ(obj_t node__221_48, obj_t _1_exp__141_49)
{
   {
      obj_t node__221_702;
      bool_t reset_703;
      obj_t _1_exp__141_704;
      node__221_702 = node__221_48;
      reset_703 = ((bool_t) 0);
      _1_exp__141_704 = _1_exp__141_49;
    loop_705:
      if (NULLP(node__221_702))
	{
	   return BBOOL(reset_703);
	}
      else
	{
	   bool_t test_2151;
	   {
	      obj_t aux_2152;
	      aux_2152 = CDR(node__221_702);
	      test_2151 = NULLP(aux_2152);
	   }
	   if (test_2151)
	     {
		{
		   obj_t reset__69_708;
		   {
		      node_t aux_2155;
		      {
			 obj_t aux_2156;
			 aux_2156 = CAR(node__221_702);
			 aux_2155 = (node_t) (aux_2156);
		      }
		      reset__69_708 = node_1occ__69_reduce_1occ(aux_2155, _1_exp__141_704);
		   }
		   {
		      obj_t node_709;
		      node_709 = __res1__155___r5_control_features_6_4;
		      SET_CAR(node__221_702, node_709);
		      if (reset_703)
			{
			   return BBOOL(reset_703);
			}
		      else
			{
			   return reset__69_708;
			}
		   }
		}
	     }
	   else
	     {
		{
		   obj_t reset__69_712;
		   {
		      node_t aux_2163;
		      {
			 obj_t aux_2164;
			 aux_2164 = CAR(node__221_702);
			 aux_2163 = (node_t) (aux_2164);
		      }
		      reset__69_712 = node_1occ__69_reduce_1occ(aux_2163, _1_exp__141_704);
		   }
		   {
		      obj_t node_713;
		      node_713 = __res1__155___r5_control_features_6_4;
		      SET_CAR(node__221_702, node_713);
		      {
			 bool_t test_2169;
			 if (reset_703)
			   {
			      test_2169 = ((bool_t) 1);
			   }
			 else
			   {
			      test_2169 = CBOOL(reset__69_712);
			   }
			 if (test_2169)
			   {
			      obj_t _1_exp__141_2175;
			      bool_t reset_2174;
			      obj_t node__221_2172;
			      node__221_2172 = CDR(node__221_702);
			      reset_2174 = ((bool_t) 1);
			      _1_exp__141_2175 = BNIL;
			      _1_exp__141_704 = _1_exp__141_2175;
			      reset_703 = reset_2174;
			      node__221_702 = node__221_2172;
			      goto loop_705;
			   }
			 else
			   {
			      bool_t reset_2178;
			      obj_t node__221_2176;
			      node__221_2176 = CDR(node__221_702);
			      reset_2178 = ((bool_t) 0);
			      reset_703 = reset_2178;
			      node__221_702 = node__221_2176;
			      goto loop_705;
			   }
		      }
		   }
		}
	     }
	}
   }
}


obj_t 
imported_modules_init_94_reduce_1occ()
{
   module_initialization_70_tools_trace(((long) 0), "REDUCE_1OCC");
   module_initialization_70_tools_shape(((long) 0), "REDUCE_1OCC");
   module_initialization_70_tools_speek(((long) 0), "REDUCE_1OCC");
   module_initialization_70_tools_error(((long) 0), "REDUCE_1OCC");
   module_initialization_70_type_type(((long) 0), "REDUCE_1OCC");
   module_initialization_70_type_cache(((long) 0), "REDUCE_1OCC");
   module_initialization_70_coerce_typeof(((long) 0), "REDUCE_1OCC");
   module_initialization_70_coerce_coerce(((long) 0), "REDUCE_1OCC");
   module_initialization_70_effect_effect(((long) 0), "REDUCE_1OCC");
   module_initialization_70_ast_var(((long) 0), "REDUCE_1OCC");
   module_initialization_70_ast_node(((long) 0), "REDUCE_1OCC");
   module_initialization_70_ast_lvtype(((long) 0), "REDUCE_1OCC");
   return module_initialization_70_ast_occur(((long) 0), "REDUCE_1OCC");
}
