/*===========================================================================*/
/*   (Reduce/cond.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t let_fun_218_ast_node;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_reduce_cond();
extern obj_t module_initialization_70_reduce_cond(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_reduce_cond();
static obj_t cnst_init_137_reduce_cond();
static node_t node_cond__1_reduce_cond(node_t);
static obj_t require_initialization_114_reduce_cond = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_reduce_cond();
static obj_t _node_cond__default1307_5_reduce_cond(obj_t, obj_t);
extern obj_t cast_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t reduce_conditional__50_reduce_cond(obj_t);
extern obj_t pragma_ast_node;
extern obj_t app_ly_162_ast_node;
extern obj_t _reduce_conditional__210_reduce_cond(obj_t, obj_t);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
static obj_t node_cond___88_reduce_cond(obj_t);
extern obj_t kwote_ast_node;
static obj_t _node_cond__195_reduce_cond(obj_t, obj_t);
static node_t node_cond__default1307_109_reduce_cond(node_t);
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t app_ast_node;
static long __cond_reduced__35_reduce_cond;
static obj_t __cnst[3];

DEFINE_STRING(string1623_reduce_cond, string1623_reduce_cond1634, "      conditional expression ", 29);
DEFINE_STRING(string1625_reduce_cond, string1625_reduce_cond1635, "No method for this object", 25);
DEFINE_STATIC_GENERIC(node_cond__env_233_reduce_cond, _node_cond__195_reduce_cond1636, _node_cond__195_reduce_cond, 0L, 1);
DEFINE_STATIC_PROCEDURE(node_cond__default1307_env_45_reduce_cond, _node_cond__default1307_5_reduce_cond1637, _node_cond__default1307_5_reduce_cond, 0L, 1);
DEFINE_STRING(string1624_reduce_cond, string1624_reduce_cond1638, "(reduced : ", 11);
DEFINE_STRING(string1627_reduce_cond, string1627_reduce_cond1639, "DONE REDUCE NODE-COND!-DEFAULT1307 ", 35);
DEFINE_STRING(string1626_reduce_cond, string1626_reduce_cond1640, "Je reduis le cond: ", 19);
DEFINE_EXPORT_PROCEDURE(reduce_conditional__env_210_reduce_cond, _reduce_conditional__210_reduce_cond1641, _reduce_conditional__210_reduce_cond, 0L, 1);

obj_t 
module_initialization_70_reduce_cond(long checksum_1343, char *from_1344)
{
   if (CBOOL(require_initialization_114_reduce_cond))
     {
	require_initialization_114_reduce_cond = BBOOL(((bool_t) 0));
	library_modules_init_112_reduce_cond();
	cnst_init_137_reduce_cond();
	imported_modules_init_94_reduce_cond();
	toplevel_init_63_reduce_cond();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_reduce_cond()
{
   module_initialization_70___object(((long) 0), "REDUCE_COND");
   module_initialization_70___reader(((long) 0), "REDUCE_COND");
   return BUNSPEC;
}


obj_t 
cnst_init_137_reduce_cond()
{
   {
      obj_t cnst_port_138_1335;
      cnst_port_138_1335 = open_input_string(string1627_reduce_cond);
      {
	 long i_1336;
	 i_1336 = ((long) 2);
       loop_1337:
	 {
	    bool_t test1628_1338;
	    test1628_1338 = (i_1336 == ((long) -1));
	    if (test1628_1338)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1630_1339;
		    {
		       obj_t list1631_1340;
		       {
			  obj_t arg1632_1341;
			  arg1632_1341 = BNIL;
			  list1631_1340 = MAKE_PAIR(cnst_port_138_1335, arg1632_1341);
		       }
		       arg1630_1339 = read___reader(list1631_1340);
		    }
		    CNST_TABLE_SET(i_1336, arg1630_1339);
		 }
		 {
		    int aux_1342;
		    {
		       long aux_1360;
		       aux_1360 = (i_1336 - ((long) 1));
		       aux_1342 = (int) (aux_1360);
		    }
		    {
		       long i_1363;
		       i_1363 = (long) (aux_1342);
		       i_1336 = i_1363;
		       goto loop_1337;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_reduce_cond()
{
   __cond_reduced__35_reduce_cond = ((long) 0);
   add_generic__110___object(node_cond__env_233_reduce_cond, node_cond__default1307_env_45_reduce_cond);
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, var_ast_node, ((long) 2));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, app_ast_node, ((long) 5));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, app_ly_162_ast_node, ((long) 6));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, funcall_ast_node, ((long) 7));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, pragma_ast_node, ((long) 8));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, cast_ast_node, ((long) 9));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, setq_ast_node, ((long) 10));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, conditional_ast_node, ((long) 11));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, fail_ast_node, ((long) 12));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, select_ast_node, ((long) 13));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, let_fun_218_ast_node, ((long) 14));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, let_var_6_ast_node, ((long) 15));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, set_ex_it_116_ast_node, ((long) 16));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, jump_ex_it_184_ast_node, ((long) 17));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, make_box_202_ast_node, ((long) 18));
   add_inlined_method__244___object(node_cond__env_233_reduce_cond, box_set__221_ast_node, ((long) 19));
   {
      long aux_1386;
      aux_1386 = add_inlined_method__244___object(node_cond__env_233_reduce_cond, box_ref_242_ast_node, ((long) 20));
      return BINT(aux_1386);
   }
}


obj_t 
reduce_conditional__50_reduce_cond(obj_t globals_1)
{
   {
      obj_t list1331_655;
      list1331_655 = MAKE_PAIR(string1623_reduce_cond, BNIL);
      verbose_tools_speek(BINT(((long) 2)), list1331_655);
   }
   {
      obj_t l1272_658;
      l1272_658 = globals_1;
    lname1283_659:
      if (PAIRP(l1272_658))
	{
	   {
	      value_t fun_662;
	      {
		 global_t obj_1137;
		 {
		    obj_t aux_1394;
		    aux_1394 = CAR(l1272_658);
		    obj_1137 = (global_t) (aux_1394);
		 }
		 fun_662 = (((global_t) CREF(obj_1137))->value);
	      }
	      {
		 {
		    node_t arg1337_664;
		    {
		       node_t aux_1398;
		       {
			  obj_t aux_1399;
			  {
			     sfun_t obj_1138;
			     obj_1138 = (sfun_t) (fun_662);
			     aux_1399 = (((sfun_t) CREF(obj_1138))->body);
			  }
			  aux_1398 = (node_t) (aux_1399);
		       }
		       arg1337_664 = node_cond__1_reduce_cond(aux_1398);
		    }
		    {
		       obj_t res1598_1141;
		       {
			  sfun_t obj_1139;
			  obj_t val1077_1140;
			  obj_1139 = (sfun_t) (fun_662);
			  val1077_1140 = (obj_t) (arg1337_664);
			  {
			     obj_t x_1311;
			     x_1311 = ((((sfun_t) CREF(obj_1139))->body) = ((obj_t) val1077_1140), BUNSPEC);
			     res1598_1141 = BUNSPEC;
			  }
		       }
		       res1598_1141;
		    }
		 }
		 BUNSPEC;
	      }
	   }
	   {
	      obj_t l1272_1407;
	      l1272_1407 = CDR(l1272_658);
	      l1272_658 = l1272_1407;
	      goto lname1283_659;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      obj_t list1340_666;
      {
	 obj_t arg1343_668;
	 {
	    obj_t arg1345_669;
	    {
	       obj_t arg1346_670;
	       {
		  obj_t aux_1409;
		  aux_1409 = BCHAR(((unsigned char) '\n'));
		  arg1346_670 = MAKE_PAIR(aux_1409, BNIL);
	       }
	       {
		  obj_t aux_1412;
		  aux_1412 = BCHAR(((unsigned char) ')'));
		  arg1345_669 = MAKE_PAIR(aux_1412, arg1346_670);
	       }
	    }
	    {
	       obj_t aux_1415;
	       aux_1415 = BINT(__cond_reduced__35_reduce_cond);
	       arg1343_668 = MAKE_PAIR(aux_1415, arg1345_669);
	    }
	 }
	 list1340_666 = MAKE_PAIR(string1624_reduce_cond, arg1343_668);
      }
      verbose_tools_speek(BINT(((long) 2)), list1340_666);
   }
   return globals_1;
}


obj_t 
_reduce_conditional__210_reduce_cond(obj_t env_1309, obj_t globals_1310)
{
   return reduce_conditional__50_reduce_cond(globals_1310);
}


node_t 
node_cond__default1307_109_reduce_cond(node_t node_3)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1625_reduce_cond, (obj_t) (node_3));
}


obj_t 
_node_cond__default1307_5_reduce_cond(obj_t env_1307, obj_t node_1308)
{
   {
      node_t aux_1425;
      aux_1425 = node_cond__default1307_109_reduce_cond((node_t) (node_1308));
      return (obj_t) (aux_1425);
   }
}


node_t 
node_cond__1_reduce_cond(node_t node_2)
{
   {
      obj_t method1478_994;
      obj_t class1483_995;
      {
	 obj_t arg1486_992;
	 obj_t arg1487_993;
	 {
	    object_t obj_1148;
	    obj_1148 = (object_t) (node_2);
	    {
	       obj_t pre_method_105_1149;
	       pre_method_105_1149 = PROCEDURE_REF(node_cond__env_233_reduce_cond, ((long) 2));
	       if (INTEGERP(pre_method_105_1149))
		 {
		    PROCEDURE_SET(node_cond__env_233_reduce_cond, ((long) 2), BUNSPEC);
		    arg1486_992 = pre_method_105_1149;
		 }
	       else
		 {
		    long obj_class_num_177_1154;
		    obj_class_num_177_1154 = TYPE(obj_1148);
		    {
		       obj_t arg1183_1155;
		       arg1183_1155 = PROCEDURE_REF(node_cond__env_233_reduce_cond, ((long) 1));
		       {
			  long arg1184_1159;
			  {
			     long arg1186_1160;
			     arg1186_1160 = OBJECT_TYPE;
			     arg1184_1159 = (obj_class_num_177_1154 - arg1186_1160);
			  }
			  arg1486_992 = VECTOR_REF(arg1183_1155, arg1184_1159);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1165;
	    object_1165 = (object_t) (node_2);
	    {
	       long arg1187_1166;
	       {
		  long arg1188_1167;
		  long arg1189_1168;
		  arg1188_1167 = TYPE(object_1165);
		  arg1189_1168 = OBJECT_TYPE;
		  arg1187_1166 = (arg1188_1167 - arg1189_1168);
	       }
	       {
		  obj_t vector_1172;
		  vector_1172 = __classes__134___object;
		  arg1487_993 = VECTOR_REF(vector_1172, arg1187_1166);
	       }
	    }
	 }
	 {
	    obj_t aux_1444;
	    method1478_994 = arg1486_992;
	    class1483_995 = arg1487_993;
	    {
	       if (INTEGERP(method1478_994))
		 {
		    switch ((long) CINT(method1478_994))
		      {
		      case ((long) 0):
			 {
			    atom_t aux_1447;
			    aux_1447 = (atom_t) (node_2);
			    aux_1444 = (obj_t) (aux_1447);
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t aux_1450;
			    aux_1450 = (kwote_t) (node_2);
			    aux_1444 = (obj_t) (aux_1450);
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t aux_1453;
			    aux_1453 = (var_t) (node_2);
			    aux_1444 = (obj_t) (aux_1453);
			 }
			 break;
		      case ((long) 3):
			 {
			    closure_t aux_1456;
			    aux_1456 = (closure_t) (node_2);
			    aux_1444 = (obj_t) (aux_1456);
			 }
			 break;
		      case ((long) 4):
			 {
			    sequence_t node_1005;
			    node_1005 = (sequence_t) (node_2);
			    node_cond___88_reduce_cond((((sequence_t) CREF(node_1005))->nodes));
			    aux_1444 = (obj_t) (node_1005);
			 }
			 break;
		      case ((long) 5):
			 {
			    app_t node_1008;
			    node_1008 = (app_t) (node_2);
			    node_cond___88_reduce_cond((((app_t) CREF(node_1008))->args));
			    aux_1444 = (obj_t) (node_1008);
			 }
			 break;
		      case ((long) 6):
			 {
			    app_ly_162_t node_1011;
			    node_1011 = (app_ly_162_t) (node_2);
			    {
			       node_t arg1494_1013;
			       arg1494_1013 = node_cond__1_reduce_cond((((app_ly_162_t) CREF(node_1011))->fun));
			       {
				  obj_t res1599_1179;
				  {
				     obj_t x_1312;
				     x_1312 = ((((app_ly_162_t) CREF(node_1011))->fun) = ((node_t) arg1494_1013), BUNSPEC);
				     res1599_1179 = BUNSPEC;
				  }
				  res1599_1179;
			       }
			    }
			    {
			       node_t arg1497_1015;
			       arg1497_1015 = node_cond__1_reduce_cond((((app_ly_162_t) CREF(node_1011))->arg));
			       {
				  obj_t res1600_1183;
				  {
				     obj_t x_1313;
				     x_1313 = ((((app_ly_162_t) CREF(node_1011))->arg) = ((node_t) arg1497_1015), BUNSPEC);
				     res1600_1183 = BUNSPEC;
				  }
				  res1600_1183;
			       }
			    }
			    aux_1444 = (obj_t) (node_1011);
			 }
			 break;
		      case ((long) 7):
			 {
			    funcall_t node_1017;
			    node_1017 = (funcall_t) (node_2);
			    {
			       node_t arg1499_1019;
			       arg1499_1019 = node_cond__1_reduce_cond((((funcall_t) CREF(node_1017))->fun));
			       {
				  obj_t res1601_1187;
				  {
				     obj_t x_1314;
				     x_1314 = ((((funcall_t) CREF(node_1017))->fun) = ((node_t) arg1499_1019), BUNSPEC);
				     res1601_1187 = BUNSPEC;
				  }
				  res1601_1187;
			       }
			    }
			    node_cond___88_reduce_cond((((funcall_t) CREF(node_1017))->args));
			    aux_1444 = (obj_t) (node_1017);
			 }
			 break;
		      case ((long) 8):
			 {
			    pragma_t node_1022;
			    node_1022 = (pragma_t) (node_2);
			    node_cond___88_reduce_cond((((pragma_t) CREF(node_1022))->args));
			    aux_1444 = (obj_t) (node_1022);
			 }
			 break;
		      case ((long) 9):
			 {
			    cast_t node_1025;
			    node_1025 = (cast_t) (node_2);
			    node_cond__1_reduce_cond((((cast_t) CREF(node_1025))->arg));
			    aux_1444 = (obj_t) (node_1025);
			 }
			 break;
		      case ((long) 10):
			 {
			    setq_t node_1028;
			    node_1028 = (setq_t) (node_2);
			    {
			       node_t arg1507_1030;
			       arg1507_1030 = node_cond__1_reduce_cond((((setq_t) CREF(node_1028))->value));
			       {
				  obj_t res1602_1194;
				  {
				     obj_t x_1315;
				     x_1315 = ((((setq_t) CREF(node_1028))->value) = ((node_t) arg1507_1030), BUNSPEC);
				     res1602_1194 = BUNSPEC;
				  }
				  res1602_1194;
			       }
			    }
			    {
			       node_t arg1510_1032;
			       {
				  node_t aux_1494;
				  {
				     var_t aux_1495;
				     aux_1495 = (((setq_t) CREF(node_1028))->var);
				     aux_1494 = (node_t) (aux_1495);
				  }
				  arg1510_1032 = node_cond__1_reduce_cond(aux_1494);
			       }
			       {
				  obj_t res1603_1198;
				  {
				     var_t val1191_1197;
				     val1191_1197 = (var_t) (arg1510_1032);
				     {
					obj_t x_1316;
					x_1316 = ((((setq_t) CREF(node_1028))->var) = ((var_t) val1191_1197), BUNSPEC);
					res1603_1198 = BUNSPEC;
				     }
				  }
				  res1603_1198;
			       }
			    }
			    aux_1444 = (obj_t) (node_1028);
			 }
			 break;
		      case ((long) 11):
			 {
			    conditional_t node_1034;
			    node_1034 = (conditional_t) (node_2);
			    {
			       node_t arg1513_1036;
			       arg1513_1036 = node_cond__1_reduce_cond((((conditional_t) CREF(node_1034))->test));
			       {
				  obj_t res1604_1202;
				  {
				     obj_t x_1317;
				     x_1317 = ((((conditional_t) CREF(node_1034))->test) = ((node_t) arg1513_1036), BUNSPEC);
				     res1604_1202 = BUNSPEC;
				  }
				  res1604_1202;
			       }
			    }
			    {
			       node_t arg1517_1038;
			       arg1517_1038 = node_cond__1_reduce_cond((((conditional_t) CREF(node_1034))->true));
			       {
				  obj_t res1605_1206;
				  {
				     obj_t x_1318;
				     x_1318 = ((((conditional_t) CREF(node_1034))->true) = ((node_t) arg1517_1038), BUNSPEC);
				     res1605_1206 = BUNSPEC;
				  }
				  res1605_1206;
			       }
			    }
			    {
			       node_t arg1520_1040;
			       arg1520_1040 = node_cond__1_reduce_cond((((conditional_t) CREF(node_1034))->false));
			       {
				  obj_t res1606_1210;
				  {
				     obj_t x_1319;
				     x_1319 = ((((conditional_t) CREF(node_1034))->false) = ((node_t) arg1520_1040), BUNSPEC);
				     res1606_1210 = BUNSPEC;
				  }
				  res1606_1210;
			       }
			    }
			    {
			       bool_t test1523_1042;
			       {
				  obj_t aux_1512;
				  {
				     node_t aux_1513;
				     aux_1513 = (((conditional_t) CREF(node_1034))->test);
				     aux_1512 = (obj_t) (aux_1513);
				  }
				  test1523_1042 = is_a__118___object(aux_1512, atom_ast_node);
			       }
			       if (test1523_1042)
				 {
				    {
				       long z2_1214;
				       z2_1214 = __cond_reduced__35_reduce_cond;
				       __cond_reduced__35_reduce_cond = (((long) 1) + z2_1214);
				    }
				    {
				       bool_t test1524_1043;
				       {
					  obj_t aux_1519;
					  aux_1519 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
					  test1524_1043 = CBOOL(aux_1519);
				       }
				       if (test1524_1043)
					 {
					    obj_t arg1529_1045;
					    arg1529_1045 = shape_tools_shape((obj_t) (node_1034));
					    {
					       obj_t list1530_1046;
					       {
						  obj_t arg1531_1047;
						  {
						     obj_t arg1532_1048;
						     {
							obj_t aux_1527;
							aux_1527 = BCHAR(((unsigned char) '\n'));
							arg1532_1048 = MAKE_PAIR(aux_1527, BNIL);
						     }
						     arg1531_1047 = MAKE_PAIR(arg1529_1045, arg1532_1048);
						  }
						  list1530_1046 = MAKE_PAIR(string1626_reduce_cond, arg1531_1047);
					       }
					       print_trace_107_tools_trace(list1530_1046);
					    }
					 }
				       else
					 {
					    BUNSPEC;
					 }
				    }
				    {
				       bool_t test_1533;
				       {
					  atom_t obj_1216;
					  {
					     node_t aux_1534;
					     aux_1534 = (((conditional_t) CREF(node_1034))->test);
					     obj_1216 = (atom_t) (aux_1534);
					  }
					  {
					     obj_t aux_1537;
					     aux_1537 = (((atom_t) CREF(obj_1216))->value);
					     test_1533 = CBOOL(aux_1537);
					  }
				       }
				       if (test_1533)
					 {
					    node_t aux_1540;
					    aux_1540 = (((conditional_t) CREF(node_1034))->true);
					    aux_1444 = (obj_t) (aux_1540);
					 }
				       else
					 {
					    node_t aux_1543;
					    aux_1543 = (((conditional_t) CREF(node_1034))->false);
					    aux_1444 = (obj_t) (aux_1543);
					 }
				    }
				 }
			       else
				 {
				    aux_1444 = (obj_t) (node_1034);
				 }
			    }
			 }
			 break;
		      case ((long) 12):
			 {
			    fail_t node_1055;
			    node_1055 = (fail_t) (node_2);
			    {
			       node_t arg1540_1057;
			       arg1540_1057 = node_cond__1_reduce_cond((((fail_t) CREF(node_1055))->proc));
			       {
				  obj_t res1607_1222;
				  {
				     obj_t x_1320;
				     x_1320 = ((((fail_t) CREF(node_1055))->proc) = ((node_t) arg1540_1057), BUNSPEC);
				     res1607_1222 = BUNSPEC;
				  }
				  res1607_1222;
			       }
			    }
			    {
			       node_t arg1542_1059;
			       arg1542_1059 = node_cond__1_reduce_cond((((fail_t) CREF(node_1055))->msg));
			       {
				  obj_t res1608_1226;
				  {
				     obj_t x_1321;
				     x_1321 = ((((fail_t) CREF(node_1055))->msg) = ((node_t) arg1542_1059), BUNSPEC);
				     res1608_1226 = BUNSPEC;
				  }
				  res1608_1226;
			       }
			    }
			    {
			       node_t arg1547_1061;
			       arg1547_1061 = node_cond__1_reduce_cond((((fail_t) CREF(node_1055))->obj));
			       {
				  obj_t res1609_1230;
				  {
				     obj_t x_1322;
				     x_1322 = ((((fail_t) CREF(node_1055))->obj) = ((node_t) arg1547_1061), BUNSPEC);
				     res1609_1230 = BUNSPEC;
				  }
				  res1609_1230;
			       }
			    }
			    aux_1444 = (obj_t) (node_1055);
			 }
			 break;
		      case ((long) 13):
			 {
			    select_t node_1063;
			    node_1063 = (select_t) (node_2);
			    {
			       node_t arg1550_1065;
			       arg1550_1065 = node_cond__1_reduce_cond((((select_t) CREF(node_1063))->test));
			       {
				  obj_t res1610_1234;
				  {
				     obj_t x_1323;
				     x_1323 = ((((select_t) CREF(node_1063))->test) = ((node_t) arg1550_1065), BUNSPEC);
				     res1610_1234 = BUNSPEC;
				  }
				  res1610_1234;
			       }
			    }
			    {
			       obj_t l1294_1067;
			       l1294_1067 = (((select_t) CREF(node_1063))->clauses);
			     lname1295_1068:
			       if (PAIRP(l1294_1067))
				 {
				    {
				       obj_t clause_1071;
				       clause_1071 = CAR(l1294_1067);
				       {
					  node_t arg1554_1072;
					  {
					     node_t aux_1565;
					     {
						obj_t aux_1566;
						aux_1566 = CDR(clause_1071);
						aux_1565 = (node_t) (aux_1566);
					     }
					     arg1554_1072 = node_cond__1_reduce_cond(aux_1565);
					  }
					  {
					     obj_t aux_1570;
					     aux_1570 = (obj_t) (arg1554_1072);
					     SET_CDR(clause_1071, aux_1570);
					  }
				       }
				    }
				    {
				       obj_t l1294_1573;
				       l1294_1573 = CDR(l1294_1067);
				       l1294_1067 = l1294_1573;
				       goto lname1295_1068;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_1444 = (obj_t) (node_1063);
			 }
			 break;
		      case ((long) 14):
			 {
			    let_fun_218_t node_1075;
			    node_1075 = (let_fun_218_t) (node_2);
			    {
			       obj_t l1297_1077;
			       l1297_1077 = (((let_fun_218_t) CREF(node_1075))->locals);
			     lname1298_1078:
			       if (PAIRP(l1297_1077))
				 {
				    {
				       value_t fun_1082;
				       {
					  local_t obj_1245;
					  {
					     obj_t aux_1580;
					     aux_1580 = CAR(l1297_1077);
					     obj_1245 = (local_t) (aux_1580);
					  }
					  fun_1082 = (((local_t) CREF(obj_1245))->value);
				       }
				       {
					  node_t arg1561_1083;
					  {
					     node_t aux_1584;
					     {
						obj_t aux_1585;
						{
						   sfun_t obj_1246;
						   obj_1246 = (sfun_t) (fun_1082);
						   aux_1585 = (((sfun_t) CREF(obj_1246))->body);
						}
						aux_1584 = (node_t) (aux_1585);
					     }
					     arg1561_1083 = node_cond__1_reduce_cond(aux_1584);
					  }
					  {
					     obj_t res1611_1249;
					     {
						sfun_t obj_1247;
						obj_t val1077_1248;
						obj_1247 = (sfun_t) (fun_1082);
						val1077_1248 = (obj_t) (arg1561_1083);
						{
						   obj_t x_1324;
						   x_1324 = ((((sfun_t) CREF(obj_1247))->body) = ((obj_t) val1077_1248), BUNSPEC);
						   res1611_1249 = BUNSPEC;
						}
					     }
					     res1611_1249;
					  }
				       }
				    }
				    {
				       obj_t l1297_1593;
				       l1297_1593 = CDR(l1297_1077);
				       l1297_1077 = l1297_1593;
				       goto lname1298_1078;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1564_1086;
			       arg1564_1086 = node_cond__1_reduce_cond((((let_fun_218_t) CREF(node_1075))->body));
			       {
				  obj_t res1612_1254;
				  {
				     obj_t x_1325;
				     x_1325 = ((((let_fun_218_t) CREF(node_1075))->body) = ((node_t) arg1564_1086), BUNSPEC);
				     res1612_1254 = BUNSPEC;
				  }
				  res1612_1254;
			       }
			    }
			    aux_1444 = (obj_t) (node_1075);
			 }
			 break;
		      case ((long) 15):
			 {
			    let_var_6_t node_1088;
			    node_1088 = (let_var_6_t) (node_2);
			    {
			       obj_t l1300_1090;
			       l1300_1090 = (((let_var_6_t) CREF(node_1088))->bindings);
			     lname1301_1091:
			       if (PAIRP(l1300_1090))
				 {
				    {
				       obj_t binding_1094;
				       binding_1094 = CAR(l1300_1090);
				       {
					  node_t arg1568_1095;
					  {
					     node_t aux_1604;
					     {
						obj_t aux_1605;
						aux_1605 = CDR(binding_1094);
						aux_1604 = (node_t) (aux_1605);
					     }
					     arg1568_1095 = node_cond__1_reduce_cond(aux_1604);
					  }
					  {
					     obj_t aux_1609;
					     aux_1609 = (obj_t) (arg1568_1095);
					     SET_CDR(binding_1094, aux_1609);
					  }
				       }
				    }
				    {
				       obj_t l1300_1612;
				       l1300_1612 = CDR(l1300_1090);
				       l1300_1090 = l1300_1612;
				       goto lname1301_1091;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1572_1098;
			       arg1572_1098 = node_cond__1_reduce_cond((((let_var_6_t) CREF(node_1088))->body));
			       {
				  obj_t res1613_1265;
				  {
				     obj_t x_1326;
				     x_1326 = ((((let_var_6_t) CREF(node_1088))->body) = ((node_t) arg1572_1098), BUNSPEC);
				     res1613_1265 = BUNSPEC;
				  }
				  res1613_1265;
			       }
			    }
			    aux_1444 = (obj_t) (node_1088);
			 }
			 break;
		      case ((long) 16):
			 {
			    set_ex_it_116_t node_1100;
			    node_1100 = (set_ex_it_116_t) (node_2);
			    {
			       node_t arg1574_1102;
			       arg1574_1102 = node_cond__1_reduce_cond((((set_ex_it_116_t) CREF(node_1100))->body));
			       {
				  obj_t res1614_1269;
				  {
				     obj_t x_1327;
				     x_1327 = ((((set_ex_it_116_t) CREF(node_1100))->body) = ((node_t) arg1574_1102), BUNSPEC);
				     res1614_1269 = BUNSPEC;
				  }
				  res1614_1269;
			       }
			    }
			    {
			       node_t arg1576_1104;
			       {
				  node_t aux_1623;
				  {
				     var_t aux_1624;
				     aux_1624 = (((set_ex_it_116_t) CREF(node_1100))->var);
				     aux_1623 = (node_t) (aux_1624);
				  }
				  arg1576_1104 = node_cond__1_reduce_cond(aux_1623);
			       }
			       {
				  obj_t res1615_1273;
				  {
				     var_t val1241_1272;
				     val1241_1272 = (var_t) (arg1576_1104);
				     {
					obj_t x_1328;
					x_1328 = ((((set_ex_it_116_t) CREF(node_1100))->var) = ((var_t) val1241_1272), BUNSPEC);
					res1615_1273 = BUNSPEC;
				     }
				  }
				  res1615_1273;
			       }
			    }
			    aux_1444 = (obj_t) (node_1100);
			 }
			 break;
		      case ((long) 17):
			 {
			    jump_ex_it_184_t node_1106;
			    node_1106 = (jump_ex_it_184_t) (node_2);
			    {
			       node_t arg1578_1108;
			       arg1578_1108 = node_cond__1_reduce_cond((((jump_ex_it_184_t) CREF(node_1106))->exit));
			       {
				  obj_t res1616_1277;
				  {
				     obj_t x_1329;
				     x_1329 = ((((jump_ex_it_184_t) CREF(node_1106))->exit) = ((node_t) arg1578_1108), BUNSPEC);
				     res1616_1277 = BUNSPEC;
				  }
				  res1616_1277;
			       }
			    }
			    {
			       node_t arg1582_1110;
			       arg1582_1110 = node_cond__1_reduce_cond((((jump_ex_it_184_t) CREF(node_1106))->value));
			       {
				  obj_t res1617_1281;
				  {
				     obj_t x_1330;
				     x_1330 = ((((jump_ex_it_184_t) CREF(node_1106))->value) = ((node_t) arg1582_1110), BUNSPEC);
				     res1617_1281 = BUNSPEC;
				  }
				  res1617_1281;
			       }
			    }
			    aux_1444 = (obj_t) (node_1106);
			 }
			 break;
		      case ((long) 18):
			 {
			    make_box_202_t node_1112;
			    node_1112 = (make_box_202_t) (node_2);
			    {
			       node_t arg1584_1114;
			       arg1584_1114 = node_cond__1_reduce_cond((((make_box_202_t) CREF(node_1112))->value));
			       {
				  obj_t res1618_1285;
				  {
				     obj_t x_1331;
				     x_1331 = ((((make_box_202_t) CREF(node_1112))->value) = ((node_t) arg1584_1114), BUNSPEC);
				     res1618_1285 = BUNSPEC;
				  }
				  res1618_1285;
			       }
			    }
			    aux_1444 = (obj_t) (node_1112);
			 }
			 break;
		      case ((long) 19):
			 {
			    box_set__221_t node_1116;
			    node_1116 = (box_set__221_t) (node_2);
			    {
			       node_t arg1587_1118;
			       {
				  node_t aux_1645;
				  {
				     var_t aux_1646;
				     aux_1646 = (((box_set__221_t) CREF(node_1116))->var);
				     aux_1645 = (node_t) (aux_1646);
				  }
				  arg1587_1118 = node_cond__1_reduce_cond(aux_1645);
			       }
			       {
				  obj_t res1619_1289;
				  {
				     var_t val1269_1288;
				     val1269_1288 = (var_t) (arg1587_1118);
				     {
					obj_t x_1332;
					x_1332 = ((((box_set__221_t) CREF(node_1116))->var) = ((var_t) val1269_1288), BUNSPEC);
					res1619_1289 = BUNSPEC;
				     }
				  }
				  res1619_1289;
			       }
			    }
			    {
			       node_t arg1589_1120;
			       arg1589_1120 = node_cond__1_reduce_cond((((box_set__221_t) CREF(node_1116))->value));
			       {
				  obj_t res1620_1293;
				  {
				     obj_t x_1333;
				     x_1333 = ((((box_set__221_t) CREF(node_1116))->value) = ((node_t) arg1589_1120), BUNSPEC);
				     res1620_1293 = BUNSPEC;
				  }
				  res1620_1293;
			       }
			    }
			    aux_1444 = (obj_t) (node_1116);
			 }
			 break;
		      case ((long) 20):
			 {
			    box_ref_242_t node_1122;
			    node_1122 = (box_ref_242_t) (node_2);
			    {
			       node_t arg1591_1124;
			       {
				  node_t aux_1657;
				  {
				     var_t aux_1658;
				     aux_1658 = (((box_ref_242_t) CREF(node_1122))->var);
				     aux_1657 = (node_t) (aux_1658);
				  }
				  arg1591_1124 = node_cond__1_reduce_cond(aux_1657);
			       }
			       {
				  obj_t res1621_1297;
				  {
				     var_t val1263_1296;
				     val1263_1296 = (var_t) (arg1591_1124);
				     {
					obj_t x_1334;
					x_1334 = ((((box_ref_242_t) CREF(node_1122))->var) = ((var_t) val1263_1296), BUNSPEC);
					res1621_1297 = BUNSPEC;
				     }
				  }
				  res1621_1297;
			       }
			    }
			    aux_1444 = (obj_t) (node_1122);
			 }
			 break;
		      default:
		       case_else1484_17_998:
			 if (PROCEDUREP(method1478_994))
			   {
			      aux_1444 = PROCEDURE_ENTRY(method1478_994) (method1478_994, (obj_t) (node_2), BEOA);
			   }
			 else
			   {
			      obj_t fun1351_674;
			      fun1351_674 = PROCEDURE_REF(node_cond__env_233_reduce_cond, ((long) 0));
			      aux_1444 = PROCEDURE_ENTRY(fun1351_674) (fun1351_674, (obj_t) (node_2), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1484_17_998;
		 }
	    }
	    return (node_t) (aux_1444);
	 }
      }
   }
}


obj_t 
_node_cond__195_reduce_cond(obj_t env_1305, obj_t node_1306)
{
   {
      node_t aux_1677;
      aux_1677 = node_cond__1_reduce_cond((node_t) (node_1306));
      return (obj_t) (aux_1677);
   }
}


obj_t 
node_cond___88_reduce_cond(obj_t node__221_25)
{
   {
      obj_t node__221_675;
      node__221_675 = node__221_25;
    loop_676:
      if (NULLP(node__221_675))
	{
	   return CNST_TABLE_REF(((long) 2));
	}
      else
	{
	   {
	      node_t arg1353_678;
	      {
		 node_t aux_1684;
		 {
		    obj_t aux_1685;
		    aux_1685 = CAR(node__221_675);
		    aux_1684 = (node_t) (aux_1685);
		 }
		 arg1353_678 = node_cond__1_reduce_cond(aux_1684);
	      }
	      {
		 obj_t aux_1689;
		 aux_1689 = (obj_t) (arg1353_678);
		 SET_CAR(node__221_675, aux_1689);
	      }
	   }
	   {
	      obj_t node__221_1692;
	      node__221_1692 = CDR(node__221_675);
	      node__221_675 = node__221_1692;
	      goto loop_676;
	   }
	}
   }
}


obj_t 
imported_modules_init_94_reduce_cond()
{
   module_initialization_70_tools_trace(((long) 0), "REDUCE_COND");
   module_initialization_70_tools_shape(((long) 0), "REDUCE_COND");
   module_initialization_70_tools_speek(((long) 0), "REDUCE_COND");
   module_initialization_70_tools_error(((long) 0), "REDUCE_COND");
   module_initialization_70_type_type(((long) 0), "REDUCE_COND");
   module_initialization_70_ast_var(((long) 0), "REDUCE_COND");
   return module_initialization_70_ast_node(((long) 0), "REDUCE_COND");
}
