/*===========================================================================*/
/*   (Reduce/copy.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


static obj_t node_copy___108_reduce_copy(obj_t);
extern obj_t let_fun_218_ast_node;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t _node_copy__default1307_159_reduce_copy(obj_t, obj_t);
static obj_t imported_modules_init_94_reduce_copy();
extern obj_t module_initialization_70_reduce_copy(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_reduce_copy();
static obj_t cnst_init_137_reduce_copy();
static long __copy_removed__156_reduce_copy;
static obj_t require_initialization_114_reduce_copy = BUNSPEC;
extern obj_t reduce_copy__103_reduce_copy(obj_t);
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_reduce_copy();
extern obj_t cast_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
extern obj_t _reduce_copy__94_reduce_copy(obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
static node_t node_copy__175_reduce_copy(node_t);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static node_t node_copy__default1307_144_reduce_copy(node_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t kwote_ast_node;
extern obj_t box_ref_242_ast_node;
static obj_t _node_copy__188_reduce_copy(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t app_ast_node;
static obj_t __cnst[4];

DEFINE_STRING(string1680_reduce_copy, string1680_reduce_copy1693, "?", 1);
DEFINE_STRING(string1686_reduce_copy, string1686_reduce_copy1694, "copy: Je reduis...", 18);
DEFINE_STRING(string1685_reduce_copy, string1685_reduce_copy1695, "copy-propagation: var:", 22);
DEFINE_STRING(string1687_reduce_copy, string1687_reduce_copy1696, "DONE READ REDUCE NODE-COPY!-DEFAULT1307 ", 40);
DEFINE_STRING(string1681_reduce_copy, string1681_reduce_copy1697, "]", 1);
DEFINE_STRING(string1682_reduce_copy, string1682_reduce_copy1698, " ", 1);
DEFINE_STRING(string1677_reduce_copy, string1677_reduce_copy1699, "      copy propagation       ", 29);
DEFINE_STATIC_PROCEDURE(node_copy__default1307_env_243_reduce_copy, _node_copy__default1307_159_reduce_copy1700, _node_copy__default1307_159_reduce_copy, 0L, 1);
DEFINE_STRING(string1684_reduce_copy, string1684_reduce_copy1701, " [", 2);
DEFINE_STRING(string1679_reduce_copy, string1679_reduce_copy1702, "No method for this object", 25);
DEFINE_EXPORT_PROCEDURE(reduce_copy__env_21_reduce_copy, _reduce_copy__94_reduce_copy1703, _reduce_copy__94_reduce_copy, 0L, 1);
DEFINE_STRING(string1678_reduce_copy, string1678_reduce_copy1704, "(removed : ", 11);
DEFINE_STRING(string1683_reduce_copy, string1683_reduce_copy1705, "]  val: ", 8);
DEFINE_STATIC_GENERIC(node_copy__env_176_reduce_copy, _node_copy__188_reduce_copy1706, _node_copy__188_reduce_copy, 0L, 1);

obj_t 
module_initialization_70_reduce_copy(long checksum_1413, char *from_1414)
{
   if (CBOOL(require_initialization_114_reduce_copy))
     {
	require_initialization_114_reduce_copy = BBOOL(((bool_t) 0));
	library_modules_init_112_reduce_copy();
	cnst_init_137_reduce_copy();
	imported_modules_init_94_reduce_copy();
	toplevel_init_63_reduce_copy();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_reduce_copy()
{
   module_initialization_70___object(((long) 0), "REDUCE_COPY");
   module_initialization_70___reader(((long) 0), "REDUCE_COPY");
   return BUNSPEC;
}


obj_t 
cnst_init_137_reduce_copy()
{
   {
      obj_t cnst_port_138_1405;
      cnst_port_138_1405 = open_input_string(string1687_reduce_copy);
      {
	 long i_1406;
	 i_1406 = ((long) 3);
       loop_1407:
	 {
	    bool_t test1688_1408;
	    test1688_1408 = (i_1406 == ((long) -1));
	    if (test1688_1408)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1689_1409;
		    {
		       obj_t list1690_1410;
		       {
			  obj_t arg1691_1411;
			  arg1691_1411 = BNIL;
			  list1690_1410 = MAKE_PAIR(cnst_port_138_1405, arg1691_1411);
		       }
		       arg1689_1409 = read___reader(list1690_1410);
		    }
		    CNST_TABLE_SET(i_1406, arg1689_1409);
		 }
		 {
		    int aux_1412;
		    {
		       long aux_1430;
		       aux_1430 = (i_1406 - ((long) 1));
		       aux_1412 = (int) (aux_1430);
		    }
		    {
		       long i_1433;
		       i_1433 = (long) (aux_1412);
		       i_1406 = i_1433;
		       goto loop_1407;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_reduce_copy()
{
   __copy_removed__156_reduce_copy = ((long) 0);
   add_generic__110___object(node_copy__env_176_reduce_copy, node_copy__default1307_env_243_reduce_copy);
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, var_ast_node, ((long) 2));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, setq_ast_node, ((long) 9));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, conditional_ast_node, ((long) 10));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, fail_ast_node, ((long) 11));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, select_ast_node, ((long) 12));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, let_fun_218_ast_node, ((long) 13));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, let_var_6_ast_node, ((long) 14));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, set_ex_it_116_ast_node, ((long) 15));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, jump_ex_it_184_ast_node, ((long) 16));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, make_box_202_ast_node, ((long) 17));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, box_set__221_ast_node, ((long) 18));
   add_inlined_method__244___object(node_copy__env_176_reduce_copy, box_ref_242_ast_node, ((long) 19));
   {
      long aux_1456;
      aux_1456 = add_inlined_method__244___object(node_copy__env_176_reduce_copy, app_ast_node, ((long) 20));
      return BINT(aux_1456);
   }
}


obj_t 
reduce_copy__103_reduce_copy(obj_t globals_1)
{
   {
      obj_t list1331_655;
      list1331_655 = MAKE_PAIR(string1677_reduce_copy, BNIL);
      verbose_tools_speek(BINT(((long) 2)), list1331_655);
   }
   __copy_removed__156_reduce_copy = ((long) 0);
   {
      obj_t l1272_658;
      l1272_658 = globals_1;
    lname1283_659:
      if (PAIRP(l1272_658))
	{
	   {
	      value_t fun_662;
	      {
		 global_t obj_1177;
		 {
		    obj_t aux_1464;
		    aux_1464 = CAR(l1272_658);
		    obj_1177 = (global_t) (aux_1464);
		 }
		 fun_662 = (((global_t) CREF(obj_1177))->value);
	      }
	      {
		 {
		    node_t arg1337_664;
		    {
		       node_t aux_1468;
		       {
			  obj_t aux_1469;
			  {
			     sfun_t obj_1178;
			     obj_1178 = (sfun_t) (fun_662);
			     aux_1469 = (((sfun_t) CREF(obj_1178))->body);
			  }
			  aux_1468 = (node_t) (aux_1469);
		       }
		       arg1337_664 = node_copy__175_reduce_copy(aux_1468);
		    }
		    {
		       obj_t res1649_1181;
		       {
			  sfun_t obj_1179;
			  obj_t val1077_1180;
			  obj_1179 = (sfun_t) (fun_662);
			  val1077_1180 = (obj_t) (arg1337_664);
			  {
			     obj_t x_1378;
			     x_1378 = ((((sfun_t) CREF(obj_1179))->body) = ((obj_t) val1077_1180), BUNSPEC);
			     res1649_1181 = BUNSPEC;
			  }
		       }
		       res1649_1181;
		    }
		 }
		 BUNSPEC;
	      }
	   }
	   {
	      obj_t l1272_1477;
	      l1272_1477 = CDR(l1272_658);
	      l1272_658 = l1272_1477;
	      goto lname1283_659;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      obj_t list1340_666;
      {
	 obj_t arg1343_668;
	 {
	    obj_t arg1345_669;
	    {
	       obj_t arg1346_670;
	       {
		  obj_t aux_1479;
		  aux_1479 = BCHAR(((unsigned char) '\n'));
		  arg1346_670 = MAKE_PAIR(aux_1479, BNIL);
	       }
	       {
		  obj_t aux_1482;
		  aux_1482 = BCHAR(((unsigned char) ')'));
		  arg1345_669 = MAKE_PAIR(aux_1482, arg1346_670);
	       }
	    }
	    {
	       obj_t aux_1485;
	       aux_1485 = BINT(__copy_removed__156_reduce_copy);
	       arg1343_668 = MAKE_PAIR(aux_1485, arg1345_669);
	    }
	 }
	 list1340_666 = MAKE_PAIR(string1678_reduce_copy, arg1343_668);
      }
      verbose_tools_speek(BINT(((long) 2)), list1340_666);
   }
   return globals_1;
}


obj_t 
_reduce_copy__94_reduce_copy(obj_t env_1376, obj_t globals_1377)
{
   return reduce_copy__103_reduce_copy(globals_1377);
}


node_t 
node_copy__default1307_144_reduce_copy(node_t node_3)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1679_reduce_copy, (obj_t) (node_3));
}


obj_t 
_node_copy__default1307_159_reduce_copy(obj_t env_1374, obj_t node_1375)
{
   {
      node_t aux_1495;
      aux_1495 = node_copy__default1307_144_reduce_copy((node_t) (node_1375));
      return (obj_t) (aux_1495);
   }
}


node_t 
node_copy__175_reduce_copy(node_t node_2)
{
   {
      obj_t method1478_994;
      obj_t class1483_995;
      {
	 obj_t arg1486_992;
	 obj_t arg1487_993;
	 {
	    object_t obj_1188;
	    obj_1188 = (object_t) (node_2);
	    {
	       obj_t pre_method_105_1189;
	       pre_method_105_1189 = PROCEDURE_REF(node_copy__env_176_reduce_copy, ((long) 2));
	       if (INTEGERP(pre_method_105_1189))
		 {
		    PROCEDURE_SET(node_copy__env_176_reduce_copy, ((long) 2), BUNSPEC);
		    arg1486_992 = pre_method_105_1189;
		 }
	       else
		 {
		    long obj_class_num_177_1194;
		    obj_class_num_177_1194 = TYPE(obj_1188);
		    {
		       obj_t arg1183_1195;
		       arg1183_1195 = PROCEDURE_REF(node_copy__env_176_reduce_copy, ((long) 1));
		       {
			  long arg1184_1199;
			  {
			     long arg1186_1200;
			     arg1186_1200 = OBJECT_TYPE;
			     arg1184_1199 = (obj_class_num_177_1194 - arg1186_1200);
			  }
			  arg1486_992 = VECTOR_REF(arg1183_1195, arg1184_1199);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1205;
	    object_1205 = (object_t) (node_2);
	    {
	       long arg1187_1206;
	       {
		  long arg1188_1207;
		  long arg1189_1208;
		  arg1188_1207 = TYPE(object_1205);
		  arg1189_1208 = OBJECT_TYPE;
		  arg1187_1206 = (arg1188_1207 - arg1189_1208);
	       }
	       {
		  obj_t vector_1212;
		  vector_1212 = __classes__134___object;
		  arg1487_993 = VECTOR_REF(vector_1212, arg1187_1206);
	       }
	    }
	 }
	 {
	    obj_t aux_1514;
	    method1478_994 = arg1486_992;
	    class1483_995 = arg1487_993;
	    {
	       if (INTEGERP(method1478_994))
		 {
		    switch ((long) CINT(method1478_994))
		      {
		      case ((long) 0):
			 {
			    atom_t aux_1517;
			    aux_1517 = (atom_t) (node_2);
			    aux_1514 = (obj_t) (aux_1517);
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t aux_1520;
			    aux_1520 = (kwote_t) (node_2);
			    aux_1514 = (obj_t) (aux_1520);
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t node_1003;
			    node_1003 = (var_t) (node_2);
			    {
			       variable_t v_1004;
			       v_1004 = (((var_t) CREF(node_1003))->variable);
			       {
				  obj_t falpha_1005;
				  falpha_1005 = (((variable_t) CREF(v_1004))->fast_alpha_7);
				  if ((falpha_1005 == BUNSPEC))
				    {
				       aux_1514 = (obj_t) (node_1003);
				    }
				  else
				    {
				       node_t aux_1529;
				       aux_1529 = node_copy__175_reduce_copy((node_t) (falpha_1005));
				       aux_1514 = (obj_t) (aux_1529);
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 3):
			 {
			    closure_t aux_1533;
			    aux_1533 = (closure_t) (node_2);
			    aux_1514 = (obj_t) (aux_1533);
			 }
			 break;
		      case ((long) 4):
			 {
			    sequence_t node_1008;
			    node_1008 = (sequence_t) (node_2);
			    node_copy___108_reduce_copy((((sequence_t) CREF(node_1008))->nodes));
			    aux_1514 = (obj_t) (node_1008);
			 }
			 break;
		      case ((long) 5):
			 {
			    app_ly_162_t node_1011;
			    node_1011 = (app_ly_162_t) (node_2);
			    {
			       node_t arg1494_1013;
			       arg1494_1013 = node_copy__175_reduce_copy((((app_ly_162_t) CREF(node_1011))->fun));
			       {
				  obj_t res1650_1222;
				  {
				     obj_t x_1379;
				     x_1379 = ((((app_ly_162_t) CREF(node_1011))->fun) = ((node_t) arg1494_1013), BUNSPEC);
				     res1650_1222 = BUNSPEC;
				  }
				  res1650_1222;
			       }
			    }
			    {
			       node_t arg1497_1015;
			       arg1497_1015 = node_copy__175_reduce_copy((((app_ly_162_t) CREF(node_1011))->arg));
			       {
				  obj_t res1651_1226;
				  {
				     obj_t x_1380;
				     x_1380 = ((((app_ly_162_t) CREF(node_1011))->arg) = ((node_t) arg1497_1015), BUNSPEC);
				     res1651_1226 = BUNSPEC;
				  }
				  res1651_1226;
			       }
			    }
			    aux_1514 = (obj_t) (node_1011);
			 }
			 break;
		      case ((long) 6):
			 {
			    funcall_t node_1017;
			    node_1017 = (funcall_t) (node_2);
			    {
			       node_t arg1499_1019;
			       arg1499_1019 = node_copy__175_reduce_copy((((funcall_t) CREF(node_1017))->fun));
			       {
				  obj_t res1652_1230;
				  {
				     obj_t x_1381;
				     x_1381 = ((((funcall_t) CREF(node_1017))->fun) = ((node_t) arg1499_1019), BUNSPEC);
				     res1652_1230 = BUNSPEC;
				  }
				  res1652_1230;
			       }
			    }
			    node_copy___108_reduce_copy((((funcall_t) CREF(node_1017))->args));
			    aux_1514 = (obj_t) (node_1017);
			 }
			 break;
		      case ((long) 7):
			 {
			    pragma_t node_1022;
			    node_1022 = (pragma_t) (node_2);
			    node_copy___108_reduce_copy((((pragma_t) CREF(node_1022))->args));
			    aux_1514 = (obj_t) (node_1022);
			 }
			 break;
		      case ((long) 8):
			 {
			    cast_t node_1025;
			    node_1025 = (cast_t) (node_2);
			    {
			       node_t arg1506_1027;
			       arg1506_1027 = node_copy__175_reduce_copy((((cast_t) CREF(node_1025))->arg));
			       {
				  obj_t res1653_1236;
				  {
				     obj_t x_1382;
				     x_1382 = ((((cast_t) CREF(node_1025))->arg) = ((node_t) arg1506_1027), BUNSPEC);
				     res1653_1236 = BUNSPEC;
				  }
				  res1653_1236;
			       }
			    }
			    aux_1514 = (obj_t) (node_1025);
			 }
			 break;
		      case ((long) 9):
			 {
			    setq_t node_1029;
			    node_1029 = (setq_t) (node_2);
			    {
			       node_t arg1509_1031;
			       arg1509_1031 = node_copy__175_reduce_copy((((setq_t) CREF(node_1029))->value));
			       {
				  obj_t res1654_1240;
				  {
				     obj_t x_1383;
				     x_1383 = ((((setq_t) CREF(node_1029))->value) = ((node_t) arg1509_1031), BUNSPEC);
				     res1654_1240 = BUNSPEC;
				  }
				  res1654_1240;
			       }
			    }
			    {
			       node_t arg1511_1033;
			       {
				  node_t aux_1568;
				  {
				     var_t aux_1569;
				     aux_1569 = (((setq_t) CREF(node_1029))->var);
				     aux_1568 = (node_t) (aux_1569);
				  }
				  arg1511_1033 = node_copy__175_reduce_copy(aux_1568);
			       }
			       {
				  obj_t res1655_1244;
				  {
				     var_t val1191_1243;
				     val1191_1243 = (var_t) (arg1511_1033);
				     {
					obj_t x_1384;
					x_1384 = ((((setq_t) CREF(node_1029))->var) = ((var_t) val1191_1243), BUNSPEC);
					res1655_1244 = BUNSPEC;
				     }
				  }
				  res1655_1244;
			       }
			    }
			    aux_1514 = (obj_t) (node_1029);
			 }
			 break;
		      case ((long) 10):
			 {
			    conditional_t node_1035;
			    node_1035 = (conditional_t) (node_2);
			    {
			       node_t arg1514_1037;
			       arg1514_1037 = node_copy__175_reduce_copy((((conditional_t) CREF(node_1035))->test));
			       {
				  obj_t res1656_1248;
				  {
				     obj_t x_1385;
				     x_1385 = ((((conditional_t) CREF(node_1035))->test) = ((node_t) arg1514_1037), BUNSPEC);
				     res1656_1248 = BUNSPEC;
				  }
				  res1656_1248;
			       }
			    }
			    {
			       node_t arg1518_1039;
			       arg1518_1039 = node_copy__175_reduce_copy((((conditional_t) CREF(node_1035))->true));
			       {
				  obj_t res1657_1252;
				  {
				     obj_t x_1386;
				     x_1386 = ((((conditional_t) CREF(node_1035))->true) = ((node_t) arg1518_1039), BUNSPEC);
				     res1657_1252 = BUNSPEC;
				  }
				  res1657_1252;
			       }
			    }
			    {
			       node_t arg1522_1041;
			       arg1522_1041 = node_copy__175_reduce_copy((((conditional_t) CREF(node_1035))->false));
			       {
				  obj_t res1658_1256;
				  {
				     obj_t x_1387;
				     x_1387 = ((((conditional_t) CREF(node_1035))->false) = ((node_t) arg1522_1041), BUNSPEC);
				     res1658_1256 = BUNSPEC;
				  }
				  res1658_1256;
			       }
			    }
			    aux_1514 = (obj_t) (node_1035);
			 }
			 break;
		      case ((long) 11):
			 {
			    fail_t node_1043;
			    node_1043 = (fail_t) (node_2);
			    {
			       node_t arg1524_1045;
			       arg1524_1045 = node_copy__175_reduce_copy((((fail_t) CREF(node_1043))->proc));
			       {
				  obj_t res1659_1260;
				  {
				     obj_t x_1388;
				     x_1388 = ((((fail_t) CREF(node_1043))->proc) = ((node_t) arg1524_1045), BUNSPEC);
				     res1659_1260 = BUNSPEC;
				  }
				  res1659_1260;
			       }
			    }
			    {
			       node_t arg1529_1047;
			       arg1529_1047 = node_copy__175_reduce_copy((((fail_t) CREF(node_1043))->msg));
			       {
				  obj_t res1660_1264;
				  {
				     obj_t x_1389;
				     x_1389 = ((((fail_t) CREF(node_1043))->msg) = ((node_t) arg1529_1047), BUNSPEC);
				     res1660_1264 = BUNSPEC;
				  }
				  res1660_1264;
			       }
			    }
			    {
			       node_t arg1532_1049;
			       arg1532_1049 = node_copy__175_reduce_copy((((fail_t) CREF(node_1043))->obj));
			       {
				  obj_t res1661_1268;
				  {
				     obj_t x_1390;
				     x_1390 = ((((fail_t) CREF(node_1043))->obj) = ((node_t) arg1532_1049), BUNSPEC);
				     res1661_1268 = BUNSPEC;
				  }
				  res1661_1268;
			       }
			    }
			    aux_1514 = (obj_t) (node_1043);
			 }
			 break;
		      case ((long) 12):
			 {
			    select_t node_1051;
			    node_1051 = (select_t) (node_2);
			    {
			       node_t arg1535_1053;
			       arg1535_1053 = node_copy__175_reduce_copy((((select_t) CREF(node_1051))->test));
			       {
				  obj_t res1662_1272;
				  {
				     obj_t x_1391;
				     x_1391 = ((((select_t) CREF(node_1051))->test) = ((node_t) arg1535_1053), BUNSPEC);
				     res1662_1272 = BUNSPEC;
				  }
				  res1662_1272;
			       }
			    }
			    {
			       obj_t l1293_1055;
			       l1293_1055 = (((select_t) CREF(node_1051))->clauses);
			     lname1294_1056:
			       if (PAIRP(l1293_1055))
				 {
				    {
				       obj_t clause_1059;
				       clause_1059 = CAR(l1293_1055);
				       {
					  node_t arg1539_1060;
					  {
					     node_t aux_1605;
					     {
						obj_t aux_1606;
						aux_1606 = CDR(clause_1059);
						aux_1605 = (node_t) (aux_1606);
					     }
					     arg1539_1060 = node_copy__175_reduce_copy(aux_1605);
					  }
					  {
					     obj_t aux_1610;
					     aux_1610 = (obj_t) (arg1539_1060);
					     SET_CDR(clause_1059, aux_1610);
					  }
				       }
				    }
				    {
				       obj_t l1293_1613;
				       l1293_1613 = CDR(l1293_1055);
				       l1293_1055 = l1293_1613;
				       goto lname1294_1056;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_1514 = (obj_t) (node_1051);
			 }
			 break;
		      case ((long) 13):
			 {
			    let_fun_218_t node_1063;
			    node_1063 = (let_fun_218_t) (node_2);
			    {
			       obj_t l1296_1065;
			       l1296_1065 = (((let_fun_218_t) CREF(node_1063))->locals);
			     lname1298_1066:
			       if (PAIRP(l1296_1065))
				 {
				    {
				       value_t fun_1070;
				       {
					  local_t obj_1283;
					  {
					     obj_t aux_1620;
					     aux_1620 = CAR(l1296_1065);
					     obj_1283 = (local_t) (aux_1620);
					  }
					  fun_1070 = (((local_t) CREF(obj_1283))->value);
				       }
				       {
					  node_t arg1547_1071;
					  {
					     node_t aux_1624;
					     {
						obj_t aux_1625;
						{
						   sfun_t obj_1284;
						   obj_1284 = (sfun_t) (fun_1070);
						   aux_1625 = (((sfun_t) CREF(obj_1284))->body);
						}
						aux_1624 = (node_t) (aux_1625);
					     }
					     arg1547_1071 = node_copy__175_reduce_copy(aux_1624);
					  }
					  {
					     obj_t res1663_1287;
					     {
						sfun_t obj_1285;
						obj_t val1077_1286;
						obj_1285 = (sfun_t) (fun_1070);
						val1077_1286 = (obj_t) (arg1547_1071);
						{
						   obj_t x_1392;
						   x_1392 = ((((sfun_t) CREF(obj_1285))->body) = ((obj_t) val1077_1286), BUNSPEC);
						   res1663_1287 = BUNSPEC;
						}
					     }
					     res1663_1287;
					  }
				       }
				    }
				    {
				       obj_t l1296_1633;
				       l1296_1633 = CDR(l1296_1065);
				       l1296_1065 = l1296_1633;
				       goto lname1298_1066;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1551_1074;
			       arg1551_1074 = node_copy__175_reduce_copy((((let_fun_218_t) CREF(node_1063))->body));
			       {
				  obj_t res1664_1292;
				  {
				     obj_t x_1393;
				     x_1393 = ((((let_fun_218_t) CREF(node_1063))->body) = ((node_t) arg1551_1074), BUNSPEC);
				     res1664_1292 = BUNSPEC;
				  }
				  res1664_1292;
			       }
			    }
			    aux_1514 = (obj_t) (node_1063);
			 }
			 break;
		      case ((long) 14):
			 {
			    let_var_6_t node_1076;
			    node_1076 = (let_var_6_t) (node_2);
			    {
			       obj_t obindings_1078;
			       obj_t nbindings_1079;
			       obindings_1078 = (((let_var_6_t) CREF(node_1076))->bindings);
			       nbindings_1079 = BNIL;
			     loop_1080:
			       if (NULLP(obindings_1078))
				 {
				    bool_t test_1643;
				    if (NULLP(nbindings_1079))
				      {
					 test_1643 = (((let_var_6_t) CREF(node_1076))->removable__42);
				      }
				    else
				      {
					 test_1643 = ((bool_t) 0);
				      }
				    if (test_1643)
				      {
					 node_t aux_1647;
					 aux_1647 = node_copy__175_reduce_copy((((let_var_6_t) CREF(node_1076))->body));
					 aux_1514 = (obj_t) (aux_1647);
				      }
				    else
				      {
					 {
					    obj_t res1665_1300;
					    {
					       obj_t x_1394;
					       x_1394 = ((((let_var_6_t) CREF(node_1076))->bindings) = ((obj_t) nbindings_1079), BUNSPEC);
					       res1665_1300 = BUNSPEC;
					    }
					    res1665_1300;
					 }
					 {
					    node_t arg1559_1086;
					    arg1559_1086 = node_copy__175_reduce_copy((((let_var_6_t) CREF(node_1076))->body));
					    {
					       obj_t res1666_1304;
					       {
						  obj_t x_1395;
						  x_1395 = ((((let_var_6_t) CREF(node_1076))->body) = ((node_t) arg1559_1086), BUNSPEC);
						  res1666_1304 = BUNSPEC;
					       }
					       res1666_1304;
					    }
					 }
					 aux_1514 = (obj_t) (node_1076);
				      }
				 }
			       else
				 {
				    obj_t binding_1089;
				    binding_1089 = CAR(obindings_1078);
				    {
				       obj_t var_1090;
				       var_1090 = CAR(binding_1089);
				       {
					  node_t val_1091;
					  {
					     node_t aux_1658;
					     {
						obj_t aux_1659;
						aux_1659 = CDR(binding_1089);
						aux_1658 = (node_t) (aux_1659);
					     }
					     val_1091 = node_copy__175_reduce_copy(aux_1658);
					  }
					  {
					     {
						obj_t aux_1663;
						aux_1663 = (obj_t) (val_1091);
						SET_CDR(binding_1089, aux_1663);
					     }
					     {
						bool_t test1562_1092;
						{
						   obj_t aux_1666;
						   aux_1666 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 3)));
						   test1562_1092 = CBOOL(aux_1666);
						}
						if (test1562_1092)
						  {
						     obj_t arg1564_1094;
						     obj_t arg1566_1096;
						     obj_t arg1568_1098;
						     obj_t arg1571_1100;
						     arg1564_1094 = shape_tools_shape(var_1090);
						     {
							variable_t obj_1310;
							obj_1310 = (variable_t) (var_1090);
							arg1566_1096 = (((variable_t) CREF(obj_1310))->access);
						     }
						     arg1568_1098 = shape_tools_shape((obj_t) (val_1091));
						     {
							bool_t test1586_1113;
							test1586_1113 = is_a__118___object((obj_t) (val_1091), var_ast_node);
							if (test1586_1113)
							  {
							     variable_t arg1587_1114;
							     {
								var_t obj_1312;
								obj_1312 = (var_t) (val_1091);
								arg1587_1114 = (((var_t) CREF(obj_1312))->variable);
							     }
							     arg1571_1100 = (((variable_t) CREF(arg1587_1114))->access);
							  }
							else
							  {
							     arg1571_1100 = string1680_reduce_copy;
							  }
						     }
						     {
							obj_t list1573_1102;
							{
							   obj_t arg1574_1103;
							   {
							      obj_t arg1575_1104;
							      {
								 obj_t arg1576_1105;
								 {
								    obj_t arg1577_1106;
								    {
								       obj_t arg1578_1107;
								       {
									  obj_t arg1579_1108;
									  {
									     obj_t arg1582_1109;
									     {
										obj_t arg1583_1110;
										{
										   obj_t arg1584_1111;
										   {
										      obj_t aux_1683;
										      aux_1683 = BCHAR(((unsigned char) '\n'));
										      arg1584_1111 = MAKE_PAIR(aux_1683, BNIL);
										   }
										   arg1583_1110 = MAKE_PAIR(string1681_reduce_copy, arg1584_1111);
										}
										arg1582_1109 = MAKE_PAIR(arg1571_1100, arg1583_1110);
									     }
									     arg1579_1108 = MAKE_PAIR(string1682_reduce_copy, arg1582_1109);
									  }
									  arg1578_1107 = MAKE_PAIR(arg1568_1098, arg1579_1108);
								       }
								       arg1577_1106 = MAKE_PAIR(string1683_reduce_copy, arg1578_1107);
								    }
								    arg1576_1105 = MAKE_PAIR(arg1566_1096, arg1577_1106);
								 }
								 arg1575_1104 = MAKE_PAIR(string1684_reduce_copy, arg1576_1105);
							      }
							      arg1574_1103 = MAKE_PAIR(arg1564_1094, arg1575_1104);
							   }
							   list1573_1102 = MAKE_PAIR(string1685_reduce_copy, arg1574_1103);
							}
							print_trace_107_tools_trace(list1573_1102);
						     }
						  }
						else
						  {
						     BUNSPEC;
						  }
					     }
					     {
						bool_t test1590_1117;
						{
						   bool_t test1605_1128;
						   {
						      bool_t test1609_1131;
						      test1609_1131 = is_a__118___object((obj_t) (val_1091), atom_ast_node);
						      if (test1609_1131)
							{
							   test1605_1128 = ((bool_t) 1);
							}
						      else
							{
							   bool_t _andtest_1300_1132;
							   _andtest_1300_1132 = is_a__118___object((obj_t) (val_1091), var_ast_node);
							   if (_andtest_1300_1132)
							     {
								obj_t aux_1706;
								obj_t aux_1702;
								aux_1706 = CNST_TABLE_REF(((long) 2));
								{
								   variable_t arg1616_1135;
								   {
								      var_t obj_1316;
								      obj_1316 = (var_t) (val_1091);
								      arg1616_1135 = (((var_t) CREF(obj_1316))->variable);
								   }
								   aux_1702 = (((variable_t) CREF(arg1616_1135))->access);
								}
								test1605_1128 = (aux_1702 == aux_1706);
							     }
							   else
							     {
								test1605_1128 = ((bool_t) 0);
							     }
							}
						   }
						   if (test1605_1128)
						     {
							obj_t aux_1713;
							obj_t aux_1710;
							aux_1713 = CNST_TABLE_REF(((long) 2));
							{
							   variable_t obj_1320;
							   obj_1320 = (variable_t) (var_1090);
							   aux_1710 = (((variable_t) CREF(obj_1320))->access);
							}
							test1590_1117 = (aux_1710 == aux_1713);
						     }
						   else
						     {
							test1590_1117 = ((bool_t) 0);
						     }
						}
						if (test1590_1117)
						  {
						     {
							bool_t test1591_1118;
							{
							   obj_t aux_1717;
							   aux_1717 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 3)));
							   test1591_1118 = CBOOL(aux_1717);
							}
							if (test1591_1118)
							  {
							     obj_t list1592_1119;
							     {
								obj_t arg1595_1121;
								{
								   obj_t aux_1723;
								   aux_1723 = BCHAR(((unsigned char) '\n'));
								   arg1595_1121 = MAKE_PAIR(aux_1723, BNIL);
								}
								list1592_1119 = MAKE_PAIR(string1686_reduce_copy, arg1595_1121);
							     }
							     print_trace_107_tools_trace(list1592_1119);
							  }
							else
							  {
							     BUNSPEC;
							  }
						     }
						     {
							long z1_1323;
							z1_1323 = __copy_removed__156_reduce_copy;
							__copy_removed__156_reduce_copy = (z1_1323 + ((long) 1));
						     }
						     {
							obj_t res1667_1327;
							{
							   variable_t obj_1325;
							   obj_t val1029_1326;
							   obj_1325 = (variable_t) (var_1090);
							   val1029_1326 = (obj_t) (val_1091);
							   {
							      obj_t x_1396;
							      x_1396 = ((((variable_t) CREF(obj_1325))->fast_alpha_7) = ((obj_t) val1029_1326), BUNSPEC);
							      res1667_1327 = BUNSPEC;
							   }
							}
							res1667_1327;
						     }
						     {
							obj_t obindings_1732;
							obindings_1732 = CDR(obindings_1078);
							obindings_1078 = obindings_1732;
							goto loop_1080;
						     }
						  }
						else
						  {
						     obj_t arg1603_1126;
						     obj_t arg1604_1127;
						     arg1603_1126 = CDR(obindings_1078);
						     arg1604_1127 = MAKE_PAIR(binding_1089, nbindings_1079);
						     {
							obj_t nbindings_1737;
							obj_t obindings_1736;
							obindings_1736 = arg1603_1126;
							nbindings_1737 = arg1604_1127;
							nbindings_1079 = nbindings_1737;
							obindings_1078 = obindings_1736;
							goto loop_1080;
						     }
						  }
					     }
					  }
				       }
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 15):
			 {
			    set_ex_it_116_t node_1137;
			    node_1137 = (set_ex_it_116_t) (node_2);
			    {
			       node_t arg1618_1139;
			       arg1618_1139 = node_copy__175_reduce_copy((((set_ex_it_116_t) CREF(node_1137))->body));
			       {
				  obj_t res1668_1335;
				  {
				     obj_t x_1397;
				     x_1397 = ((((set_ex_it_116_t) CREF(node_1137))->body) = ((node_t) arg1618_1139), BUNSPEC);
				     res1668_1335 = BUNSPEC;
				  }
				  res1668_1335;
			       }
			    }
			    {
			       node_t arg1620_1141;
			       {
				  node_t aux_1743;
				  {
				     var_t aux_1744;
				     aux_1744 = (((set_ex_it_116_t) CREF(node_1137))->var);
				     aux_1743 = (node_t) (aux_1744);
				  }
				  arg1620_1141 = node_copy__175_reduce_copy(aux_1743);
			       }
			       {
				  obj_t res1669_1339;
				  {
				     var_t val1241_1338;
				     val1241_1338 = (var_t) (arg1620_1141);
				     {
					obj_t x_1398;
					x_1398 = ((((set_ex_it_116_t) CREF(node_1137))->var) = ((var_t) val1241_1338), BUNSPEC);
					res1669_1339 = BUNSPEC;
				     }
				  }
				  res1669_1339;
			       }
			    }
			    aux_1514 = (obj_t) (node_1137);
			 }
			 break;
		      case ((long) 16):
			 {
			    jump_ex_it_184_t node_1143;
			    node_1143 = (jump_ex_it_184_t) (node_2);
			    {
			       node_t arg1623_1145;
			       arg1623_1145 = node_copy__175_reduce_copy((((jump_ex_it_184_t) CREF(node_1143))->exit));
			       {
				  obj_t res1670_1343;
				  {
				     obj_t x_1399;
				     x_1399 = ((((jump_ex_it_184_t) CREF(node_1143))->exit) = ((node_t) arg1623_1145), BUNSPEC);
				     res1670_1343 = BUNSPEC;
				  }
				  res1670_1343;
			       }
			    }
			    {
			       node_t arg1626_1147;
			       arg1626_1147 = node_copy__175_reduce_copy((((jump_ex_it_184_t) CREF(node_1143))->value));
			       {
				  obj_t res1671_1347;
				  {
				     obj_t x_1400;
				     x_1400 = ((((jump_ex_it_184_t) CREF(node_1143))->value) = ((node_t) arg1626_1147), BUNSPEC);
				     res1671_1347 = BUNSPEC;
				  }
				  res1671_1347;
			       }
			    }
			    aux_1514 = (obj_t) (node_1143);
			 }
			 break;
		      case ((long) 17):
			 {
			    make_box_202_t node_1149;
			    node_1149 = (make_box_202_t) (node_2);
			    {
			       node_t arg1628_1151;
			       arg1628_1151 = node_copy__175_reduce_copy((((make_box_202_t) CREF(node_1149))->value));
			       {
				  obj_t res1672_1351;
				  {
				     obj_t x_1401;
				     x_1401 = ((((make_box_202_t) CREF(node_1149))->value) = ((node_t) arg1628_1151), BUNSPEC);
				     res1672_1351 = BUNSPEC;
				  }
				  res1672_1351;
			       }
			    }
			    aux_1514 = (obj_t) (node_1149);
			 }
			 break;
		      case ((long) 18):
			 {
			    box_set__221_t node_1153;
			    node_1153 = (box_set__221_t) (node_2);
			    {
			       node_t arg1632_1155;
			       {
				  node_t aux_1765;
				  {
				     var_t aux_1766;
				     aux_1766 = (((box_set__221_t) CREF(node_1153))->var);
				     aux_1765 = (node_t) (aux_1766);
				  }
				  arg1632_1155 = node_copy__175_reduce_copy(aux_1765);
			       }
			       {
				  obj_t res1673_1355;
				  {
				     var_t val1269_1354;
				     val1269_1354 = (var_t) (arg1632_1155);
				     {
					obj_t x_1402;
					x_1402 = ((((box_set__221_t) CREF(node_1153))->var) = ((var_t) val1269_1354), BUNSPEC);
					res1673_1355 = BUNSPEC;
				     }
				  }
				  res1673_1355;
			       }
			    }
			    {
			       node_t arg1637_1157;
			       arg1637_1157 = node_copy__175_reduce_copy((((box_set__221_t) CREF(node_1153))->value));
			       {
				  obj_t res1674_1359;
				  {
				     obj_t x_1403;
				     x_1403 = ((((box_set__221_t) CREF(node_1153))->value) = ((node_t) arg1637_1157), BUNSPEC);
				     res1674_1359 = BUNSPEC;
				  }
				  res1674_1359;
			       }
			    }
			    aux_1514 = (obj_t) (node_1153);
			 }
			 break;
		      case ((long) 19):
			 {
			    box_ref_242_t node_1159;
			    node_1159 = (box_ref_242_t) (node_2);
			    {
			       node_t arg1641_1161;
			       {
				  node_t aux_1777;
				  {
				     var_t aux_1778;
				     aux_1778 = (((box_ref_242_t) CREF(node_1159))->var);
				     aux_1777 = (node_t) (aux_1778);
				  }
				  arg1641_1161 = node_copy__175_reduce_copy(aux_1777);
			       }
			       {
				  obj_t res1675_1363;
				  {
				     var_t val1263_1362;
				     val1263_1362 = (var_t) (arg1641_1161);
				     {
					obj_t x_1404;
					x_1404 = ((((box_ref_242_t) CREF(node_1159))->var) = ((var_t) val1263_1362), BUNSPEC);
					res1675_1363 = BUNSPEC;
				     }
				  }
				  res1675_1363;
			       }
			    }
			    aux_1514 = (obj_t) (node_1159);
			 }
			 break;
		      case ((long) 20):
			 {
			    app_t node_1163;
			    node_1163 = (app_t) (node_2);
			    node_copy___108_reduce_copy((((app_t) CREF(node_1163))->args));
			    aux_1514 = (obj_t) (node_1163);
			 }
			 break;
		      default:
		       case_else1484_17_998:
			 if (PROCEDUREP(method1478_994))
			   {
			      aux_1514 = PROCEDURE_ENTRY(method1478_994) (method1478_994, (obj_t) (node_2), BEOA);
			   }
			 else
			   {
			      obj_t fun1351_674;
			      fun1351_674 = PROCEDURE_REF(node_copy__env_176_reduce_copy, ((long) 0));
			      aux_1514 = PROCEDURE_ENTRY(fun1351_674) (fun1351_674, (obj_t) (node_2), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1484_17_998;
		 }
	    }
	    return (node_t) (aux_1514);
	 }
      }
   }
}


obj_t 
_node_copy__188_reduce_copy(obj_t env_1372, obj_t node_1373)
{
   {
      node_t aux_1801;
      aux_1801 = node_copy__175_reduce_copy((node_t) (node_1373));
      return (obj_t) (aux_1801);
   }
}


obj_t 
node_copy___108_reduce_copy(obj_t node__221_25)
{
   {
      obj_t node__221_675;
      node__221_675 = node__221_25;
    loop_676:
      if (NULLP(node__221_675))
	{
	   return CNST_TABLE_REF(((long) 3));
	}
      else
	{
	   {
	      node_t arg1353_678;
	      {
		 node_t aux_1808;
		 {
		    obj_t aux_1809;
		    aux_1809 = CAR(node__221_675);
		    aux_1808 = (node_t) (aux_1809);
		 }
		 arg1353_678 = node_copy__175_reduce_copy(aux_1808);
	      }
	      {
		 obj_t aux_1813;
		 aux_1813 = (obj_t) (arg1353_678);
		 SET_CAR(node__221_675, aux_1813);
	      }
	   }
	   {
	      obj_t node__221_1816;
	      node__221_1816 = CDR(node__221_675);
	      node__221_675 = node__221_1816;
	      goto loop_676;
	   }
	}
   }
}


obj_t 
imported_modules_init_94_reduce_copy()
{
   module_initialization_70_tools_trace(((long) 0), "REDUCE_COPY");
   module_initialization_70_tools_shape(((long) 0), "REDUCE_COPY");
   module_initialization_70_tools_speek(((long) 0), "REDUCE_COPY");
   module_initialization_70_tools_error(((long) 0), "REDUCE_COPY");
   module_initialization_70_type_type(((long) 0), "REDUCE_COPY");
   module_initialization_70_type_cache(((long) 0), "REDUCE_COPY");
   module_initialization_70_coerce_typeof(((long) 0), "REDUCE_COPY");
   module_initialization_70_coerce_coerce(((long) 0), "REDUCE_COPY");
   module_initialization_70_effect_effect(((long) 0), "REDUCE_COPY");
   module_initialization_70_ast_var(((long) 0), "REDUCE_COPY");
   module_initialization_70_ast_node(((long) 0), "REDUCE_COPY");
   return module_initialization_70_ast_lvtype(((long) 0), "REDUCE_COPY");
}
