/*===========================================================================*/
/*   (Reduce/cse.scm)                                                        */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


static obj_t node_cse___11_reduce_cse(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t node_cse__default1361_246_reduce_cse(node_t, obj_t);
static obj_t find_stack_136_reduce_cse(node_t, obj_t);
extern obj_t __res1__155___r5_control_features_6_4;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_reduce_cse();
extern obj_t module_initialization_70_reduce_cse(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70_reduce_same(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r5_control_features_6_4(long, char *);
static obj_t toplevel_init_63_reduce_cse();
static obj_t cnst_init_137_reduce_cse();
extern obj_t _reduce_cse__182_reduce_cse(obj_t, obj_t);
extern bool_t same_node__38_reduce_same(node_t, node_t, obj_t);
extern obj_t __res_number__75___r5_control_features_6_4;
static obj_t require_initialization_114_reduce_cse = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_reduce_cse();
extern obj_t variable_ast_var;
extern obj_t cast_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
static obj_t _node_cse__default1361_8_reduce_cse(obj_t, obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t _node_cse__123_reduce_cse(obj_t, obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t reduce_cse__211_reduce_cse(obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t kwote_ast_node;
extern bool_t side_effect__165_effect_effect(node_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static long __cse_removed__19_reduce_cse;
extern obj_t node_cse__231_reduce_cse(node_t, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t create_struct(obj_t, long);
extern obj_t app_ast_node;
static obj_t __cnst[4];

DEFINE_EXPORT_PROCEDURE(reduce_cse__env_219_reduce_cse, _reduce_cse__182_reduce_cse1744, _reduce_cse__182_reduce_cse, 0L, 1);
DEFINE_STATIC_PROCEDURE(node_cse__default1361_env_50_reduce_cse, _node_cse__default1361_8_reduce_cse1745, _node_cse__default1361_8_reduce_cse, 0L, 2);
DEFINE_STRING(string1736_reduce_cse, string1736_reduce_cse1746, "***cse:find-stack: ", 19);
DEFINE_EXPORT_GENERIC(node_cse__env_198_reduce_cse, _node_cse__123_reduce_cse1747, _node_cse__123_reduce_cse, 0L, 2);
DEFINE_STRING(string1735_reduce_cse, string1735_reduce_cse1748, "***cse: ", 8);
DEFINE_STRING(string1734_reduce_cse, string1734_reduce_cse1749, "***cse: side-effect?: ", 22);
DEFINE_STRING(string1733_reduce_cse, string1733_reduce_cse1750, "No method for this object", 25);
DEFINE_STRING(string1731_reduce_cse, string1731_reduce_cse1751, "      cse                    ", 29);
DEFINE_STRING(string1737_reduce_cse, string1737_reduce_cse1752, "CALL READ REDUCE NODE-CSE!-DEFAULT1361 ", 39);
DEFINE_STRING(string1732_reduce_cse, string1732_reduce_cse1753, "(removed : ", 11);

obj_t 
module_initialization_70_reduce_cse(long checksum_1657, char *from_1658)
{
   if (CBOOL(require_initialization_114_reduce_cse))
     {
	require_initialization_114_reduce_cse = BBOOL(((bool_t) 0));
	library_modules_init_112_reduce_cse();
	cnst_init_137_reduce_cse();
	imported_modules_init_94_reduce_cse();
	toplevel_init_63_reduce_cse();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_reduce_cse()
{
   module_initialization_70___r5_control_features_6_4(((long) 0), "REDUCE_CSE");
   module_initialization_70___object(((long) 0), "REDUCE_CSE");
   module_initialization_70___reader(((long) 0), "REDUCE_CSE");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "REDUCE_CSE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_reduce_cse()
{
   {
      obj_t cnst_port_138_1649;
      cnst_port_138_1649 = open_input_string(string1737_reduce_cse);
      {
	 long i_1650;
	 i_1650 = ((long) 3);
       loop_1651:
	 {
	    bool_t test1738_1652;
	    test1738_1652 = (i_1650 == ((long) -1));
	    if (test1738_1652)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1740_1653;
		    {
		       obj_t list1741_1654;
		       {
			  obj_t arg1742_1655;
			  arg1742_1655 = BNIL;
			  list1741_1654 = MAKE_PAIR(cnst_port_138_1649, arg1742_1655);
		       }
		       arg1740_1653 = read___reader(list1741_1654);
		    }
		    CNST_TABLE_SET(i_1650, arg1740_1653);
		 }
		 {
		    int aux_1656;
		    {
		       long aux_1676;
		       aux_1676 = (i_1650 - ((long) 1));
		       aux_1656 = (int) (aux_1676);
		    }
		    {
		       long i_1679;
		       i_1679 = (long) (aux_1656);
		       i_1650 = i_1679;
		       goto loop_1651;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_reduce_cse()
{
   __cse_removed__19_reduce_cse = ((long) 0);
   add_generic__110___object(node_cse__env_198_reduce_cse, node_cse__default1361_env_50_reduce_cse);
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, var_ast_node, ((long) 2));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, setq_ast_node, ((long) 9));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, conditional_ast_node, ((long) 10));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, fail_ast_node, ((long) 11));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, select_ast_node, ((long) 12));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, let_fun_218_ast_node, ((long) 13));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, set_ex_it_116_ast_node, ((long) 14));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, jump_ex_it_184_ast_node, ((long) 15));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, make_box_202_ast_node, ((long) 16));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, box_set__221_ast_node, ((long) 17));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, box_ref_242_ast_node, ((long) 18));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, app_ast_node, ((long) 19));
   add_inlined_method__244___object(node_cse__env_198_reduce_cse, let_var_6_ast_node, ((long) 20));
   return BUNSPEC;
}


obj_t 
reduce_cse__211_reduce_cse(obj_t globals_1)
{
   {
      obj_t list1390_691;
      list1390_691 = MAKE_PAIR(string1731_reduce_cse, BNIL);
      verbose_tools_speek(BINT(((long) 2)), list1390_691);
   }
   __cse_removed__19_reduce_cse = ((long) 0);
   {
      obj_t l1272_694;
      l1272_694 = globals_1;
    lname1283_695:
      if (PAIRP(l1272_694))
	{
	   {
	      value_t fun_698;
	      {
		 global_t obj_1373;
		 {
		    obj_t aux_1708;
		    aux_1708 = CAR(l1272_694);
		    obj_1373 = (global_t) (aux_1708);
		 }
		 fun_698 = (((global_t) CREF(obj_1373))->value);
	      }
	      {
		 {
		    obj_t arg1398_700;
		    {
		       obj_t __701;
		       {
			  node_t aux_1712;
			  {
			     obj_t aux_1713;
			     {
				sfun_t obj_1374;
				obj_1374 = (sfun_t) (fun_698);
				aux_1713 = (((sfun_t) CREF(obj_1374))->body);
			     }
			     aux_1712 = (node_t) (aux_1713);
			  }
			  __701 = node_cse__231_reduce_cse(aux_1712, BNIL);
		       }
		       {
			  obj_t node_702;
			  node_702 = __res1__155___r5_control_features_6_4;
			  arg1398_700 = node_702;
		       }
		    }
		    {
		       obj_t res1708_1377;
		       {
			  sfun_t obj_1375;
			  obj_1375 = (sfun_t) (fun_698);
			  {
			     obj_t x_1629;
			     x_1629 = ((((sfun_t) CREF(obj_1375))->body) = ((obj_t) arg1398_700), BUNSPEC);
			     res1708_1377 = BUNSPEC;
			  }
		       }
		       res1708_1377;
		    }
		 }
		 BUNSPEC;
	      }
	   }
	   {
	      obj_t l1272_1720;
	      l1272_1720 = CDR(l1272_694);
	      l1272_694 = l1272_1720;
	      goto lname1283_695;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      obj_t list1403_705;
      {
	 obj_t arg1406_707;
	 {
	    obj_t arg1408_708;
	    {
	       obj_t arg1410_709;
	       {
		  obj_t aux_1722;
		  aux_1722 = BCHAR(((unsigned char) '\n'));
		  arg1410_709 = MAKE_PAIR(aux_1722, BNIL);
	       }
	       {
		  obj_t aux_1725;
		  aux_1725 = BCHAR(((unsigned char) ')'));
		  arg1408_708 = MAKE_PAIR(aux_1725, arg1410_709);
	       }
	    }
	    {
	       obj_t aux_1728;
	       aux_1728 = BINT(__cse_removed__19_reduce_cse);
	       arg1406_707 = MAKE_PAIR(aux_1728, arg1408_708);
	    }
	 }
	 list1403_705 = MAKE_PAIR(string1732_reduce_cse, arg1406_707);
      }
      verbose_tools_speek(BINT(((long) 2)), list1403_705);
   }
   return globals_1;
}


obj_t 
_reduce_cse__182_reduce_cse(obj_t env_1626, obj_t globals_1627)
{
   return reduce_cse__211_reduce_cse(globals_1627);
}


obj_t 
node_cse__default1361_246_reduce_cse(node_t node_4, obj_t stack_5)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1733_reduce_cse, (obj_t) (node_4));
}


obj_t 
_node_cse__default1361_8_reduce_cse(obj_t env_1623, obj_t node_1624, obj_t stack_1625)
{
   return node_cse__default1361_246_reduce_cse((node_t) (node_1624), stack_1625);
}


obj_t 
node_cse__231_reduce_cse(node_t node_2, obj_t stack_3)
{
   {
      obj_t method1576_1080;
      obj_t class1581_1081;
      {
	 obj_t arg1584_1078;
	 obj_t arg1585_1079;
	 {
	    object_t obj_1384;
	    obj_1384 = (object_t) (node_2);
	    {
	       obj_t pre_method_105_1385;
	       pre_method_105_1385 = PROCEDURE_REF(node_cse__env_198_reduce_cse, ((long) 2));
	       if (INTEGERP(pre_method_105_1385))
		 {
		    PROCEDURE_SET(node_cse__env_198_reduce_cse, ((long) 2), BUNSPEC);
		    arg1584_1078 = pre_method_105_1385;
		 }
	       else
		 {
		    long obj_class_num_177_1390;
		    obj_class_num_177_1390 = TYPE(obj_1384);
		    {
		       obj_t arg1183_1391;
		       arg1183_1391 = PROCEDURE_REF(node_cse__env_198_reduce_cse, ((long) 1));
		       {
			  long arg1184_1395;
			  {
			     long arg1186_1396;
			     arg1186_1396 = OBJECT_TYPE;
			     arg1184_1395 = (obj_class_num_177_1390 - arg1186_1396);
			  }
			  arg1584_1078 = VECTOR_REF(arg1183_1391, arg1184_1395);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1401;
	    object_1401 = (object_t) (node_2);
	    {
	       long arg1187_1402;
	       {
		  long arg1188_1403;
		  long arg1189_1404;
		  arg1188_1403 = TYPE(object_1401);
		  arg1189_1404 = OBJECT_TYPE;
		  arg1187_1402 = (arg1188_1403 - arg1189_1404);
	       }
	       {
		  obj_t vector_1408;
		  vector_1408 = __classes__134___object;
		  arg1585_1079 = VECTOR_REF(vector_1408, arg1187_1402);
	       }
	    }
	 }
	 method1576_1080 = arg1584_1078;
	 class1581_1081 = arg1585_1079;
	 {
	    if (INTEGERP(method1576_1080))
	      {
		 switch ((long) CINT(method1576_1080))
		   {
		   case ((long) 0):
		      __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
		      {
			 atom_t aux_1758;
			 aux_1758 = (atom_t) (node_2);
			 __res1__155___r5_control_features_6_4 = (obj_t) (aux_1758);
		      }
		      return BFALSE;
		      break;
		   case ((long) 1):
		      __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
		      {
			 kwote_t aux_1762;
			 aux_1762 = (kwote_t) (node_2);
			 __res1__155___r5_control_features_6_4 = (obj_t) (aux_1762);
		      }
		      return BFALSE;
		      break;
		   case ((long) 2):
		      __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
		      {
			 var_t aux_1766;
			 aux_1766 = (var_t) (node_2);
			 __res1__155___r5_control_features_6_4 = (obj_t) (aux_1766);
		      }
		      return BFALSE;
		      break;
		   case ((long) 3):
		      __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
		      {
			 closure_t aux_1770;
			 aux_1770 = (closure_t) (node_2);
			 __res1__155___r5_control_features_6_4 = (obj_t) (aux_1770);
		      }
		      return BFALSE;
		      break;
		   case ((long) 4):
		      {
			 sequence_t node_1103;
			 node_1103 = (sequence_t) (node_2);
			 {
			    obj_t val0_1293_70_1106;
			    val0_1293_70_1106 = node_cse___11_reduce_cse((((sequence_t) CREF(node_1103))->nodes), stack_3);
			    __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			    __res1__155___r5_control_features_6_4 = (obj_t) (node_1103);
			    return val0_1293_70_1106;
			 }
		      }
		      break;
		   case ((long) 5):
		      {
			 app_ly_162_t node_1109;
			 node_1109 = (app_ly_162_t) (node_2);
			 {
			    obj_t reset_1112;
			    reset_1112 = node_cse__231_reduce_cse((((app_ly_162_t) CREF(node_1109))->fun), stack_3);
			    {
			       obj_t nfun_1113;
			       nfun_1113 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1709_1414;
				  {
				     node_t val1163_1413;
				     val1163_1413 = (node_t) (nfun_1113);
				     {
					obj_t x_1630;
					x_1630 = ((((app_ly_162_t) CREF(node_1109))->fun) = ((node_t) val1163_1413), BUNSPEC);
					res1709_1414 = BUNSPEC;
				     }
				  }
				  res1709_1414;
			       }
			       {
				  obj_t reset__69_1114;
				  {
				     obj_t aux_1783;
				     if (CBOOL(reset_1112))
				       {
					  aux_1783 = BNIL;
				       }
				     else
				       {
					  aux_1783 = stack_3;
				       }
				     reset__69_1114 = node_cse__231_reduce_cse((((app_ly_162_t) CREF(node_1109))->arg), aux_1783);
				  }
				  {
				     obj_t narg_1115;
				     narg_1115 = __res1__155___r5_control_features_6_4;
				     {
					obj_t res1710_1418;
					{
					   node_t val1164_1417;
					   val1164_1417 = (node_t) (narg_1115);
					   {
					      obj_t x_1631;
					      x_1631 = ((((app_ly_162_t) CREF(node_1109))->arg) = ((node_t) val1164_1417), BUNSPEC);
					      res1710_1418 = BUNSPEC;
					   }
					}
					res1710_1418;
				     }
				     __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
				     __res1__155___r5_control_features_6_4 = (obj_t) (node_1109);
				     if (CBOOL(reset_1112))
				       {
					  return reset_1112;
				       }
				     else
				       {
					  return reset__69_1114;
				       }
				  }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 6):
		      {
			 funcall_t node_1122;
			 node_1122 = (funcall_t) (node_2);
			 {
			    obj_t reset__69_1125;
			    reset__69_1125 = node_cse___11_reduce_cse((((funcall_t) CREF(node_1122))->args), stack_3);
			    __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			    __res1__155___r5_control_features_6_4 = (obj_t) (node_1122);
			    return reset__69_1125;
			 }
		      }
		      break;
		   case ((long) 7):
		      {
			 pragma_t node_1129;
			 node_1129 = (pragma_t) (node_2);
			 {
			    obj_t reset__69_1132;
			    reset__69_1132 = node_cse___11_reduce_cse((((pragma_t) CREF(node_1129))->args), stack_3);
			    __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			    __res1__155___r5_control_features_6_4 = (obj_t) (node_1129);
			    return reset__69_1132;
			 }
		      }
		      break;
		   case ((long) 8):
		      {
			 cast_t node_1136;
			 node_1136 = (cast_t) (node_2);
			 {
			    obj_t reset_1139;
			    reset_1139 = node_cse__231_reduce_cse((((cast_t) CREF(node_1136))->arg), stack_3);
			    {
			       obj_t narg_1140;
			       narg_1140 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1711_1424;
				  {
				     node_t val1185_1423;
				     val1185_1423 = (node_t) (narg_1140);
				     {
					obj_t x_1632;
					x_1632 = ((((cast_t) CREF(node_1136))->arg) = ((node_t) val1185_1423), BUNSPEC);
					res1711_1424 = BUNSPEC;
				     }
				  }
				  res1711_1424;
			       }
			       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			       __res1__155___r5_control_features_6_4 = (obj_t) (node_1136);
			       return reset_1139;
			    }
			 }
		      }
		      break;
		   case ((long) 9):
		      {
			 setq_t node_1144;
			 node_1144 = (setq_t) (node_2);
			 {
			    obj_t reset_1147;
			    reset_1147 = node_cse__231_reduce_cse((((setq_t) CREF(node_1144))->value), stack_3);
			    {
			       obj_t nvalue_1148;
			       nvalue_1148 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1712_1428;
				  {
				     node_t val1192_1427;
				     val1192_1427 = (node_t) (nvalue_1148);
				     {
					obj_t x_1633;
					x_1633 = ((((setq_t) CREF(node_1144))->value) = ((node_t) val1192_1427), BUNSPEC);
					res1712_1428 = BUNSPEC;
				     }
				  }
				  res1712_1428;
			       }
			       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			       __res1__155___r5_control_features_6_4 = (obj_t) (node_1144);
			       return reset_1147;
			    }
			 }
		      }
		      break;
		   case ((long) 10):
		      {
			 conditional_t node_1152;
			 node_1152 = (conditional_t) (node_2);
			 {
			    obj_t reset_1155;
			    reset_1155 = node_cse__231_reduce_cse((((conditional_t) CREF(node_1152))->test), stack_3);
			    {
			       obj_t ntest_1156;
			       ntest_1156 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1713_1432;
				  {
				     node_t val1199_1431;
				     val1199_1431 = (node_t) (ntest_1156);
				     {
					obj_t x_1634;
					x_1634 = ((((conditional_t) CREF(node_1152))->test) = ((node_t) val1199_1431), BUNSPEC);
					res1713_1432 = BUNSPEC;
				     }
				  }
				  res1713_1432;
			       }
			       {
				  obj_t stack__1_1157;
				  if (CBOOL(reset_1155))
				    {
				       stack__1_1157 = BNIL;
				    }
				  else
				    {
				       stack__1_1157 = stack_3;
				    }
				  {
				     obj_t reset__69_1158;
				     reset__69_1158 = node_cse__231_reduce_cse((((conditional_t) CREF(node_1152))->true), stack__1_1157);
				     {
					obj_t ntrue_1159;
					ntrue_1159 = __res1__155___r5_control_features_6_4;
					{
					   obj_t res1714_1436;
					   {
					      node_t val1200_1435;
					      val1200_1435 = (node_t) (ntrue_1159);
					      {
						 obj_t x_1635;
						 x_1635 = ((((conditional_t) CREF(node_1152))->true) = ((node_t) val1200_1435), BUNSPEC);
						 res1714_1436 = BUNSPEC;
					      }
					   }
					   res1714_1436;
					}
					{
					   obj_t reset___255_1160;
					   reset___255_1160 = node_cse__231_reduce_cse((((conditional_t) CREF(node_1152))->false), stack__1_1157);
					   {
					      obj_t nfalse_1161;
					      nfalse_1161 = __res1__155___r5_control_features_6_4;
					      {
						 obj_t res1715_1440;
						 {
						    node_t val1201_1439;
						    val1201_1439 = (node_t) (nfalse_1161);
						    {
						       obj_t x_1636;
						       x_1636 = ((((conditional_t) CREF(node_1152))->false) = ((node_t) val1201_1439), BUNSPEC);
						       res1715_1440 = BUNSPEC;
						    }
						 }
						 res1715_1440;
					      }
					      __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
					      __res1__155___r5_control_features_6_4 = (obj_t) (node_1152);
					      if (CBOOL(reset_1155))
						{
						   return reset_1155;
						}
					      else
						{
						   if (CBOOL(reset__69_1158))
						     {
							return reset__69_1158;
						     }
						   else
						     {
							return reset___255_1160;
						     }
						}
					   }
					}
				     }
				  }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 11):
		      {
			 fail_t node_1169;
			 node_1169 = (fail_t) (node_2);
			 {
			    obj_t reset_1172;
			    reset_1172 = node_cse__231_reduce_cse((((fail_t) CREF(node_1169))->proc), stack_3);
			    {
			       obj_t nproc_1173;
			       nproc_1173 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1716_1444;
				  {
				     node_t val1207_1443;
				     val1207_1443 = (node_t) (nproc_1173);
				     {
					obj_t x_1637;
					x_1637 = ((((fail_t) CREF(node_1169))->proc) = ((node_t) val1207_1443), BUNSPEC);
					res1716_1444 = BUNSPEC;
				     }
				  }
				  res1716_1444;
			       }
			       {
				  obj_t stack__1_1174;
				  if (CBOOL(reset_1172))
				    {
				       stack__1_1174 = BNIL;
				    }
				  else
				    {
				       stack__1_1174 = stack_3;
				    }
				  {
				     obj_t reset__69_1175;
				     reset__69_1175 = node_cse__231_reduce_cse((((fail_t) CREF(node_1169))->msg), stack__1_1174);
				     {
					obj_t nmsg_1176;
					nmsg_1176 = __res1__155___r5_control_features_6_4;
					{
					   obj_t res1717_1448;
					   {
					      node_t val1208_1447;
					      val1208_1447 = (node_t) (nmsg_1176);
					      {
						 obj_t x_1638;
						 x_1638 = ((((fail_t) CREF(node_1169))->msg) = ((node_t) val1208_1447), BUNSPEC);
						 res1717_1448 = BUNSPEC;
					      }
					   }
					   res1717_1448;
					}
					{
					   obj_t reset___255_1178;
					   {
					      obj_t aux_1850;
					      if (CBOOL(reset__69_1175))
						{
						   aux_1850 = BNIL;
						}
					      else
						{
						   aux_1850 = stack__1_1174;
						}
					      reset___255_1178 = node_cse__231_reduce_cse((((fail_t) CREF(node_1169))->obj), aux_1850);
					   }
					   {
					      obj_t nobj_1179;
					      nobj_1179 = __res1__155___r5_control_features_6_4;
					      {
						 obj_t res1718_1452;
						 {
						    node_t val1209_1451;
						    val1209_1451 = (node_t) (nobj_1179);
						    {
						       obj_t x_1639;
						       x_1639 = ((((fail_t) CREF(node_1169))->obj) = ((node_t) val1209_1451), BUNSPEC);
						       res1718_1452 = BUNSPEC;
						    }
						 }
						 res1718_1452;
					      }
					      __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
					      __res1__155___r5_control_features_6_4 = (obj_t) (node_1169);
					      if (CBOOL(reset_1172))
						{
						   return reset_1172;
						}
					      else
						{
						   if (CBOOL(reset__69_1175))
						     {
							return reset__69_1175;
						     }
						   else
						     {
							return reset___255_1178;
						     }
						}
					   }
					}
				     }
				  }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 12):
		      {
			 select_t node_1187;
			 node_1187 = (select_t) (node_2);
			 {
			    obj_t reset_1190;
			    reset_1190 = node_cse__231_reduce_cse((((select_t) CREF(node_1187))->test), stack_3);
			    {
			       obj_t ntest_1191;
			       ntest_1191 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1719_1456;
				  {
				     node_t val1216_1455;
				     val1216_1455 = (node_t) (ntest_1191);
				     {
					obj_t x_1640;
					x_1640 = ((((select_t) CREF(node_1187))->test) = ((node_t) val1216_1455), BUNSPEC);
					res1719_1456 = BUNSPEC;
				     }
				  }
				  res1719_1456;
			       }
			       {
				  obj_t clauses_1193;
				  obj_t reset_1194;
				  clauses_1193 = (((select_t) CREF(node_1187))->clauses);
				  reset_1194 = reset_1190;
				loop_1195:
				  if (NULLP(clauses_1193))
				    {
				       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
				       __res1__155___r5_control_features_6_4 = (obj_t) (node_1187);
				       return reset_1194;
				    }
				  else
				    {
				       obj_t clause_1200;
				       clause_1200 = CAR(clauses_1193);
				       {
					  obj_t reset__69_1201;
					  {
					     node_t aux_1873;
					     {
						obj_t aux_1874;
						aux_1874 = CDR(clause_1200);
						aux_1873 = (node_t) (aux_1874);
					     }
					     reset__69_1201 = node_cse__231_reduce_cse(aux_1873, stack_3);
					  }
					  {
					     obj_t nclause_1202;
					     nclause_1202 = __res1__155___r5_control_features_6_4;
					     SET_CDR(clause_1200, nclause_1202);
					     {
						obj_t reset_1881;
						obj_t clauses_1879;
						clauses_1879 = CDR(clauses_1193);
						if (CBOOL(reset_1194))
						  {
						     reset_1881 = reset_1194;
						  }
						else
						  {
						     reset_1881 = reset__69_1201;
						  }
						reset_1194 = reset_1881;
						clauses_1193 = clauses_1879;
						goto loop_1195;
					     }
					  }
				       }
				    }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 13):
		      {
			 let_fun_218_t node_1208;
			 node_1208 = (let_fun_218_t) (node_2);
			 {
			    obj_t reset_1211;
			    reset_1211 = node_cse__231_reduce_cse((((let_fun_218_t) CREF(node_1208))->body), stack_3);
			    {
			       obj_t nbody_1212;
			       nbody_1212 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1720_1467;
				  {
				     node_t val1226_1466;
				     val1226_1466 = (node_t) (nbody_1212);
				     {
					obj_t x_1641;
					x_1641 = ((((let_fun_218_t) CREF(node_1208))->body) = ((node_t) val1226_1466), BUNSPEC);
					res1720_1467 = BUNSPEC;
				     }
				  }
				  res1720_1467;
			       }
			       {
				  obj_t locals_1213;
				  obj_t reset_1214;
				  locals_1213 = (((let_fun_218_t) CREF(node_1208))->locals);
				  reset_1214 = reset_1211;
				loop_1215:
				  if (NULLP(locals_1213))
				    {
				       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
				       __res1__155___r5_control_features_6_4 = (obj_t) (node_1208);
				       return reset_1214;
				    }
				  else
				    {
				       value_t sfun_1221;
				       {
					  local_t obj_1471;
					  {
					     obj_t aux_1894;
					     aux_1894 = CAR(locals_1213);
					     obj_1471 = (local_t) (aux_1894);
					  }
					  sfun_1221 = (((local_t) CREF(obj_1471))->value);
				       }
				       {
					  {
					     obj_t reset__69_1222;
					     {
						node_t aux_1898;
						{
						   obj_t aux_1899;
						   {
						      sfun_t obj_1472;
						      obj_1472 = (sfun_t) (sfun_1221);
						      aux_1899 = (((sfun_t) CREF(obj_1472))->body);
						   }
						   aux_1898 = (node_t) (aux_1899);
						}
						reset__69_1222 = node_cse__231_reduce_cse(aux_1898, BNIL);
					     }
					     {
						obj_t nbody_1223;
						nbody_1223 = __res1__155___r5_control_features_6_4;
						{
						   obj_t res1721_1475;
						   {
						      sfun_t obj_1473;
						      obj_1473 = (sfun_t) (sfun_1221);
						      {
							 obj_t x_1642;
							 x_1642 = ((((sfun_t) CREF(obj_1473))->body) = ((obj_t) nbody_1223), BUNSPEC);
							 res1721_1475 = BUNSPEC;
						      }
						   }
						   res1721_1475;
						}
						{
						   obj_t reset_1908;
						   obj_t locals_1906;
						   locals_1906 = CDR(locals_1213);
						   if (CBOOL(reset_1214))
						     {
							reset_1908 = reset_1214;
						     }
						   else
						     {
							reset_1908 = reset__69_1222;
						     }
						   reset_1214 = reset_1908;
						   locals_1213 = locals_1906;
						   goto loop_1215;
						}
					     }
					  }
				       }
				    }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 14):
		      {
			 set_ex_it_116_t node_1230;
			 node_1230 = (set_ex_it_116_t) (node_2);
			 {
			    obj_t reset_1233;
			    reset_1233 = node_cse__231_reduce_cse((((set_ex_it_116_t) CREF(node_1230))->body), BNIL);
			    {
			       obj_t nbody_1234;
			       nbody_1234 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1722_1480;
				  {
				     node_t val1242_1479;
				     val1242_1479 = (node_t) (nbody_1234);
				     {
					obj_t x_1643;
					x_1643 = ((((set_ex_it_116_t) CREF(node_1230))->body) = ((node_t) val1242_1479), BUNSPEC);
					res1722_1480 = BUNSPEC;
				     }
				  }
				  res1722_1480;
			       }
			       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			       __res1__155___r5_control_features_6_4 = (obj_t) (node_1230);
			       return reset_1233;
			    }
			 }
		      }
		      break;
		   case ((long) 15):
		      {
			 jump_ex_it_184_t node_1239;
			 node_1239 = (jump_ex_it_184_t) (node_2);
			 {
			    obj_t reset_1242;
			    reset_1242 = node_cse__231_reduce_cse((((jump_ex_it_184_t) CREF(node_1239))->exit), stack_3);
			    {
			       obj_t nexit_1243;
			       nexit_1243 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1723_1484;
				  {
				     node_t val1248_1483;
				     val1248_1483 = (node_t) (nexit_1243);
				     {
					obj_t x_1644;
					x_1644 = ((((jump_ex_it_184_t) CREF(node_1239))->exit) = ((node_t) val1248_1483), BUNSPEC);
					res1723_1484 = BUNSPEC;
				     }
				  }
				  res1723_1484;
			       }
			       {
				  obj_t reset__69_1245;
				  {
				     obj_t aux_1924;
				     if (CBOOL(reset_1242))
				       {
					  aux_1924 = BNIL;
				       }
				     else
				       {
					  aux_1924 = stack_3;
				       }
				     reset__69_1245 = node_cse__231_reduce_cse((((jump_ex_it_184_t) CREF(node_1239))->value), aux_1924);
				  }
				  {
				     obj_t nvalue_1246;
				     nvalue_1246 = __res1__155___r5_control_features_6_4;
				     {
					obj_t res1724_1488;
					{
					   node_t val1249_1487;
					   val1249_1487 = (node_t) (nvalue_1246);
					   {
					      obj_t x_1645;
					      x_1645 = ((((jump_ex_it_184_t) CREF(node_1239))->value) = ((node_t) val1249_1487), BUNSPEC);
					      res1724_1488 = BUNSPEC;
					   }
					}
					res1724_1488;
				     }
				     __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
				     __res1__155___r5_control_features_6_4 = (obj_t) (node_1239);
				     if (CBOOL(reset_1242))
				       {
					  return reset_1242;
				       }
				     else
				       {
					  return reset__69_1245;
				       }
				  }
			       }
			    }
			 }
		      }
		      break;
		   case ((long) 16):
		      {
			 make_box_202_t node_1252;
			 node_1252 = (make_box_202_t) (node_2);
			 {
			    obj_t reset_1255;
			    reset_1255 = node_cse__231_reduce_cse((((make_box_202_t) CREF(node_1252))->value), stack_3);
			    {
			       obj_t nvalue_1256;
			       nvalue_1256 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1725_1492;
				  {
				     node_t val1256_1491;
				     val1256_1491 = (node_t) (nvalue_1256);
				     {
					obj_t x_1646;
					x_1646 = ((((make_box_202_t) CREF(node_1252))->value) = ((node_t) val1256_1491), BUNSPEC);
					res1725_1492 = BUNSPEC;
				     }
				  }
				  res1725_1492;
			       }
			       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			       __res1__155___r5_control_features_6_4 = (obj_t) (node_1252);
			       return reset_1255;
			    }
			 }
		      }
		      break;
		   case ((long) 17):
		      {
			 box_set__221_t node_1260;
			 node_1260 = (box_set__221_t) (node_2);
			 {
			    obj_t reset_1263;
			    reset_1263 = node_cse__231_reduce_cse((((box_set__221_t) CREF(node_1260))->value), stack_3);
			    {
			       obj_t nvalue_1264;
			       nvalue_1264 = __res1__155___r5_control_features_6_4;
			       {
				  obj_t res1726_1496;
				  {
				     node_t val1270_1495;
				     val1270_1495 = (node_t) (nvalue_1264);
				     {
					obj_t x_1647;
					x_1647 = ((((box_set__221_t) CREF(node_1260))->value) = ((node_t) val1270_1495), BUNSPEC);
					res1726_1496 = BUNSPEC;
				     }
				  }
				  res1726_1496;
			       }
			       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
			       __res1__155___r5_control_features_6_4 = (obj_t) (node_1260);
			       return reset_1263;
			    }
			 }
		      }
		      break;
		   case ((long) 18):
		      __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
		      {
			 box_ref_242_t aux_1950;
			 aux_1950 = (box_ref_242_t) (node_2);
			 __res1__155___r5_control_features_6_4 = (obj_t) (aux_1950);
		      }
		      return BFALSE;
		      break;
		   case ((long) 19):
		      {
			 app_t node_1272;
			 node_1272 = (app_t) (node_2);
			 {
			    obj_t reset_1275;
			    reset_1275 = node_cse___11_reduce_cse((((app_t) CREF(node_1272))->args), stack_3);
			    {
			       bool_t test1633_1276;
			       if (CBOOL(reset_1275))
				 {
				    test1633_1276 = ((bool_t) 1);
				 }
			       else
				 {
				    test1633_1276 = side_effect__165_effect_effect((node_t) (node_1272));
				 }
			       if (test1633_1276)
				 {
				    {
				       bool_t test1634_1277;
				       {
					  obj_t aux_1961;
					  aux_1961 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
					  test1634_1277 = CBOOL(aux_1961);
				       }
				       if (test1634_1277)
					 {
					    obj_t arg1638_1279;
					    arg1638_1279 = shape_tools_shape((obj_t) (node_1272));
					    {
					       obj_t list1639_1280;
					       {
						  obj_t arg1641_1281;
						  {
						     obj_t arg1642_1282;
						     {
							obj_t aux_1969;
							aux_1969 = BCHAR(((unsigned char) '\n'));
							arg1642_1282 = MAKE_PAIR(aux_1969, BNIL);
						     }
						     arg1641_1281 = MAKE_PAIR(arg1638_1279, arg1642_1282);
						  }
						  list1639_1280 = MAKE_PAIR(string1734_reduce_cse, arg1641_1281);
					       }
					       print_trace_107_tools_trace(list1639_1280);
					    }
					 }
				       else
					 {
					    BUNSPEC;
					 }
				    }
				    __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
				    __res1__155___r5_control_features_6_4 = (obj_t) (node_1272);
				    return BTRUE;
				 }
			       else
				 {
				    obj_t previous_1288;
				    previous_1288 = find_stack_136_reduce_cse((node_t) (node_1272), stack_3);
				    {
				       bool_t test1646_1289;
				       test1646_1289 = is_a__118___object(previous_1288, variable_ast_var);
				       if (test1646_1289)
					 {
					    {
					       long z2_1500;
					       z2_1500 = __cse_removed__19_reduce_cse;
					       __cse_removed__19_reduce_cse = (((long) 1) + z2_1500);
					    }
					    {
					       bool_t test1647_1290;
					       {
						  obj_t aux_1982;
						  aux_1982 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
						  test1647_1290 = CBOOL(aux_1982);
					       }
					       if (test1647_1290)
						 {
						    obj_t arg1650_1292;
						    arg1650_1292 = shape_tools_shape((obj_t) (node_1272));
						    {
						       obj_t list1651_1293;
						       {
							  obj_t arg1652_1294;
							  {
							     obj_t arg1653_1295;
							     {
								obj_t aux_1990;
								aux_1990 = BCHAR(((unsigned char) '\n'));
								arg1653_1295 = MAKE_PAIR(aux_1990, BNIL);
							     }
							     arg1652_1294 = MAKE_PAIR(arg1650_1292, arg1653_1295);
							  }
							  list1651_1293 = MAKE_PAIR(string1735_reduce_cse, arg1652_1294);
						       }
						       print_trace_107_tools_trace(list1651_1293);
						    }
						 }
					       else
						 {
						    BUNSPEC;
						 }
					    }
					    {
					       var_t val1_1348_32_1300;
					       {
						  obj_t arg1657_1301;
						  type_t arg1659_1302;
						  arg1657_1301 = (((app_t) CREF(node_1272))->loc);
						  arg1659_1302 = (((app_t) CREF(node_1272))->type);
						  {
						     var_t res1727_1513;
						     {
							variable_t variable_1505;
							variable_1505 = (variable_t) (previous_1288);
							{
							   var_t new1128_1506;
							   new1128_1506 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
							   {
							      long arg1537_1507;
							      arg1537_1507 = class_num_218___object(var_ast_node);
							      {
								 obj_t obj_1511;
								 obj_1511 = (obj_t) (new1128_1506);
								 (((obj_t) CREF(obj_1511))->header = MAKE_HEADER(arg1537_1507, 0), BUNSPEC);
							      }
							   }
							   {
							      object_t aux_2003;
							      aux_2003 = (object_t) (new1128_1506);
							      OBJECT_WIDENING_SET(aux_2003, BFALSE);
							   }
							   ((((var_t) CREF(new1128_1506))->loc) = ((obj_t) arg1657_1301), BUNSPEC);
							   ((((var_t) CREF(new1128_1506))->type) = ((type_t) arg1659_1302), BUNSPEC);
							   ((((var_t) CREF(new1128_1506))->variable) = ((variable_t) variable_1505), BUNSPEC);
							   res1727_1513 = new1128_1506;
							}
						     }
						     val1_1348_32_1300 = res1727_1513;
						  }
					       }
					       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
					       __res1__155___r5_control_features_6_4 = (obj_t) (val1_1348_32_1300);
					       return stack_3;
					    }
					 }
				       else
					 {
					    __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
					    __res1__155___r5_control_features_6_4 = (obj_t) (node_1272);
					    return BFALSE;
					 }
				    }
				 }
			    }
			 }
		      }
		      break;
		   case ((long) 20):
		      {
			 let_var_6_t node_1306;
			 node_1306 = (let_var_6_t) (node_2);
			 {
			    obj_t bindings_1309;
			    bool_t reset_1310;
			    obj_t extend_1311;
			    bindings_1309 = (((let_var_6_t) CREF(node_1306))->bindings);
			    reset_1310 = ((bool_t) 0);
			    extend_1311 = BNIL;
			  loop_1312:
			    if (NULLP(bindings_1309))
			      {
				 obj_t stack__1_1316;
				 if (reset_1310)
				   {
				      stack__1_1316 = BNIL;
				   }
				 else
				   {
				      stack__1_1316 = append_2_18___r4_pairs_and_lists_6_3(extend_1311, stack_3);
				   }
				 {
				    obj_t reset__69_1317;
				    reset__69_1317 = node_cse__231_reduce_cse((((let_var_6_t) CREF(node_1306))->body), stack__1_1316);
				    {
				       obj_t nbody_1318;
				       nbody_1318 = __res1__155___r5_control_features_6_4;
				       {
					  obj_t res1728_1519;
					  {
					     node_t val1234_1518;
					     val1234_1518 = (node_t) (nbody_1318);
					     {
						obj_t x_1648;
						x_1648 = ((((let_var_6_t) CREF(node_1306))->body) = ((node_t) val1234_1518), BUNSPEC);
						res1728_1519 = BUNSPEC;
					     }
					  }
					  res1728_1519;
				       }
				       {
					  bool_t test_2022;
					  if (reset_1310)
					    {
					       test_2022 = ((bool_t) 1);
					    }
					  else
					    {
					       test_2022 = CBOOL(reset__69_1317);
					    }
					  if (test_2022)
					    {
					       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
					       __res1__155___r5_control_features_6_4 = (obj_t) (node_1306);
					       return BTRUE;
					    }
					  else
					    {
					       bool_t test1667_1322;
					       test1667_1322 = side_effect__165_effect_effect((node_t) (node_1306));
					       if (test1667_1322)
						 {
						    __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
						    __res1__155___r5_control_features_6_4 = (obj_t) (node_1306);
						    return BFALSE;
						 }
					       else
						 {
						    {
						       obj_t previous_1325;
						       previous_1325 = find_stack_136_reduce_cse((node_t) (node_1306), stack_3);
						       {
							  bool_t test1668_1326;
							  test1668_1326 = is_a__118___object(previous_1325, variable_ast_var);
							  if (test1668_1326)
							    {
							       {
								  long z2_1522;
								  z2_1522 = __cse_removed__19_reduce_cse;
								  __cse_removed__19_reduce_cse = (((long) 1) + z2_1522);
							       }
							       {
								  bool_t test1669_1327;
								  {
								     obj_t aux_2037;
								     aux_2037 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
								     test1669_1327 = CBOOL(aux_2037);
								  }
								  if (test1669_1327)
								    {
								       obj_t arg1673_1329;
								       arg1673_1329 = shape_tools_shape((obj_t) (node_1306));
								       {
									  obj_t list1674_1330;
									  {
									     obj_t arg1677_1331;
									     {
										obj_t arg1678_1332;
										{
										   obj_t aux_2045;
										   aux_2045 = BCHAR(((unsigned char) '\n'));
										   arg1678_1332 = MAKE_PAIR(aux_2045, BNIL);
										}
										arg1677_1331 = MAKE_PAIR(arg1673_1329, arg1678_1332);
									     }
									     list1674_1330 = MAKE_PAIR(string1735_reduce_cse, arg1677_1331);
									  }
									  print_trace_107_tools_trace(list1674_1330);
								       }
								    }
								  else
								    {
								       BUNSPEC;
								    }
							       }
							       {
								  var_t val1_1357_1_1337;
								  {
								     obj_t arg1682_1338;
								     type_t arg1684_1339;
								     arg1682_1338 = (((let_var_6_t) CREF(node_1306))->loc);
								     arg1684_1339 = (((let_var_6_t) CREF(node_1306))->type);
								     {
									var_t res1729_1535;
									{
									   variable_t variable_1527;
									   variable_1527 = (variable_t) (previous_1325);
									   {
									      var_t new1128_1528;
									      new1128_1528 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
									      {
										 long arg1537_1529;
										 arg1537_1529 = class_num_218___object(var_ast_node);
										 {
										    obj_t obj_1533;
										    obj_1533 = (obj_t) (new1128_1528);
										    (((obj_t) CREF(obj_1533))->header = MAKE_HEADER(arg1537_1529, 0), BUNSPEC);
										 }
									      }
									      {
										 object_t aux_2058;
										 aux_2058 = (object_t) (new1128_1528);
										 OBJECT_WIDENING_SET(aux_2058, BFALSE);
									      }
									      ((((var_t) CREF(new1128_1528))->loc) = ((obj_t) arg1682_1338), BUNSPEC);
									      ((((var_t) CREF(new1128_1528))->type) = ((type_t) arg1684_1339), BUNSPEC);
									      ((((var_t) CREF(new1128_1528))->variable) = ((variable_t) variable_1527), BUNSPEC);
									      res1729_1535 = new1128_1528;
									   }
									}
									val1_1357_1_1337 = res1729_1535;
								     }
								  }
								  __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
								  __res1__155___r5_control_features_6_4 = (obj_t) (val1_1357_1_1337);
								  return stack__1_1316;
							       }
							    }
							  else
							    {
							       __res_number__75___r5_control_features_6_4 = BINT(((long) 2));
							       __res1__155___r5_control_features_6_4 = (obj_t) (node_1306);
							       return BFALSE;
							    }
						       }
						    }
						 }
					    }
				       }
				    }
				 }
			      }
			    else
			      {
				 obj_t binding_1343;
				 binding_1343 = CAR(bindings_1309);
				 {
				    obj_t var_1344;
				    obj_t val_1345;
				    var_1344 = CAR(binding_1343);
				    val_1345 = CDR(binding_1343);
				    {
				       obj_t reset__69_1346;
				       reset__69_1346 = node_cse__231_reduce_cse((node_t) (val_1345), stack_3);
				       {
					  obj_t nval_1347;
					  nval_1347 = __res1__155___r5_control_features_6_4;
					  SET_CDR(binding_1343, nval_1347);
					  {
					     bool_t test_2074;
					     if (reset_1310)
					       {
						  test_2074 = ((bool_t) 1);
					       }
					     else
					       {
						  test_2074 = CBOOL(reset__69_1346);
					       }
					     if (test_2074)
					       {
						  {
						     obj_t extend_2079;
						     obj_t bindings_2077;
						     bindings_2077 = CDR(bindings_1309);
						     extend_2079 = BNIL;
						     extend_1311 = extend_2079;
						     bindings_1309 = bindings_2077;
						     goto loop_1312;
						  }
					       }
					     else
					       {
						  bool_t test_2080;
						  {
						     obj_t aux_2084;
						     obj_t aux_2081;
						     aux_2084 = CNST_TABLE_REF(((long) 2));
						     {
							local_t obj_1542;
							obj_1542 = (local_t) (var_1344);
							aux_2081 = (((local_t) CREF(obj_1542))->access);
						     }
						     test_2080 = (aux_2081 == aux_2084);
						  }
						  if (test_2080)
						    {
						       bool_t test1691_1352;
						       {
							  bool_t test1697_1357;
							  test1697_1357 = is_a__118___object(val_1345, app_ast_node);
							  if (test1697_1357)
							    {
							       test1691_1352 = ((bool_t) 1);
							    }
							  else
							    {
							       test1691_1352 = is_a__118___object(val_1345, let_var_6_ast_node);
							    }
						       }
						       if (test1691_1352)
							 {
							    {
							       obj_t arg1693_1353;
							       obj_t arg1694_1354;
							       arg1693_1353 = CDR(bindings_1309);
							       {
								  obj_t arg1695_1355;
								  {
								     obj_t new_1550;
								     {
									obj_t aux_2092;
									aux_2092 = CNST_TABLE_REF(((long) 3));
									new_1550 = create_struct(aux_2092, ((long) 2));
								     }
								     STRUCT_SET(new_1550, ((long) 1), var_1344);
								     STRUCT_SET(new_1550, ((long) 0), val_1345);
								     arg1695_1355 = new_1550;
								  }
								  arg1694_1354 = MAKE_PAIR(arg1695_1355, extend_1311);
							       }
							       {
								  obj_t extend_2100;
								  bool_t reset_2099;
								  obj_t bindings_2098;
								  bindings_2098 = arg1693_1353;
								  reset_2099 = ((bool_t) 0);
								  extend_2100 = arg1694_1354;
								  extend_1311 = extend_2100;
								  reset_1310 = reset_2099;
								  bindings_1309 = bindings_2098;
								  goto loop_1312;
							       }
							    }
							 }
						       else
							 {
							    {
							       bool_t reset_2103;
							       obj_t bindings_2101;
							       bindings_2101 = CDR(bindings_1309);
							       reset_2103 = ((bool_t) 0);
							       reset_1310 = reset_2103;
							       bindings_1309 = bindings_2101;
							       goto loop_1312;
							    }
							 }
						    }
						  else
						    {
						       {
							  bool_t reset_2106;
							  obj_t bindings_2104;
							  bindings_2104 = CDR(bindings_1309);
							  reset_2106 = ((bool_t) 0);
							  reset_1310 = reset_2106;
							  bindings_1309 = bindings_2104;
							  goto loop_1312;
						       }
						    }
					       }
					  }
				       }
				    }
				 }
			      }
			 }
		      }
		      break;
		   default:
		    case_else1582_189_1084:
		      if (PROCEDUREP(method1576_1080))
			{
			   return PROCEDURE_ENTRY(method1576_1080) (method1576_1080, (obj_t) (node_2), stack_3, BEOA);
			}
		      else
			{
			   obj_t fun1415_713;
			   fun1415_713 = PROCEDURE_REF(node_cse__env_198_reduce_cse, ((long) 0));
			   return PROCEDURE_ENTRY(fun1415_713) (fun1415_713, (obj_t) (node_2), stack_3, BEOA);
			}
		   }
	      }
	    else
	      {
		 goto case_else1582_189_1084;
	      }
	 }
      }
   }
}


obj_t 
_node_cse__123_reduce_cse(obj_t env_1620, obj_t node_1621, obj_t stack_1622)
{
   return node_cse__231_reduce_cse((node_t) (node_1621), stack_1622);
}


obj_t 
node_cse___11_reduce_cse(obj_t node__221_48, obj_t stack_49)
{
   {
      obj_t node__221_714;
      bool_t reset_715;
      obj_t stack_716;
      node__221_714 = node__221_48;
      reset_715 = ((bool_t) 0);
      stack_716 = stack_49;
    loop_717:
      if (NULLP(node__221_714))
	{
	   return BBOOL(reset_715);
	}
      else
	{
	   bool_t test_2124;
	   {
	      obj_t aux_2125;
	      aux_2125 = CDR(node__221_714);
	      test_2124 = NULLP(aux_2125);
	   }
	   if (test_2124)
	     {
		{
		   obj_t reset__69_720;
		   {
		      node_t aux_2128;
		      {
			 obj_t aux_2129;
			 aux_2129 = CAR(node__221_714);
			 aux_2128 = (node_t) (aux_2129);
		      }
		      reset__69_720 = node_cse__231_reduce_cse(aux_2128, stack_716);
		   }
		   {
		      obj_t node_721;
		      node_721 = __res1__155___r5_control_features_6_4;
		      SET_CAR(node__221_714, node_721);
		      if (reset_715)
			{
			   return BBOOL(reset_715);
			}
		      else
			{
			   return reset__69_720;
			}
		   }
		}
	     }
	   else
	     {
		{
		   obj_t reset__69_724;
		   {
		      node_t aux_2136;
		      {
			 obj_t aux_2137;
			 aux_2137 = CAR(node__221_714);
			 aux_2136 = (node_t) (aux_2137);
		      }
		      reset__69_724 = node_cse__231_reduce_cse(aux_2136, stack_716);
		   }
		   {
		      obj_t node_725;
		      node_725 = __res1__155___r5_control_features_6_4;
		      SET_CAR(node__221_714, node_725);
		      {
			 bool_t test_2142;
			 if (reset_715)
			   {
			      test_2142 = ((bool_t) 1);
			   }
			 else
			   {
			      test_2142 = CBOOL(reset__69_724);
			   }
			 if (test_2142)
			   {
			      obj_t stack_2148;
			      bool_t reset_2147;
			      obj_t node__221_2145;
			      node__221_2145 = CDR(node__221_714);
			      reset_2147 = ((bool_t) 1);
			      stack_2148 = BNIL;
			      stack_716 = stack_2148;
			      reset_715 = reset_2147;
			      node__221_714 = node__221_2145;
			      goto loop_717;
			   }
			 else
			   {
			      bool_t reset_2151;
			      obj_t node__221_2149;
			      node__221_2149 = CDR(node__221_714);
			      reset_2151 = ((bool_t) 0);
			      reset_715 = reset_2151;
			      node__221_714 = node__221_2149;
			      goto loop_717;
			   }
		      }
		   }
		}
	     }
	}
   }
}


obj_t 
find_stack_136_reduce_cse(node_t node_60, obj_t stack_61)
{
   {
      bool_t test1454_749;
      {
	 obj_t aux_2152;
	 aux_2152 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
	 test1454_749 = CBOOL(aux_2152);
      }
      if (test1454_749)
	{
	   obj_t arg1458_751;
	   arg1458_751 = shape_tools_shape((obj_t) (node_60));
	   {
	      obj_t list1459_752;
	      {
		 obj_t arg1461_753;
		 {
		    obj_t arg1463_754;
		    {
		       obj_t aux_2160;
		       aux_2160 = BCHAR(((unsigned char) '\n'));
		       arg1463_754 = MAKE_PAIR(aux_2160, BNIL);
		    }
		    arg1461_753 = MAKE_PAIR(arg1458_751, arg1463_754);
		 }
		 list1459_752 = MAKE_PAIR(string1736_reduce_cse, arg1461_753);
	      }
	      print_trace_107_tools_trace(list1459_752);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t stack_758;
      stack_758 = stack_61;
    loop_759:
      if (NULLP(stack_758))
	{
	   return BFALSE;
	}
      else
	{
	   bool_t test1469_761;
	   {
	      node_t aux_2168;
	      {
		 obj_t aux_2169;
		 {
		    obj_t aux_2170;
		    aux_2170 = CAR(stack_758);
		    aux_2169 = STRUCT_REF(aux_2170, ((long) 0));
		 }
		 aux_2168 = (node_t) (aux_2169);
	      }
	      test1469_761 = same_node__38_reduce_same(node_60, aux_2168, BNIL);
	   }
	   if (test1469_761)
	     {
		{
		   obj_t aux_2176;
		   aux_2176 = CAR(stack_758);
		   return STRUCT_REF(aux_2176, ((long) 1));
		}
	     }
	   else
	     {
		{
		   obj_t stack_2179;
		   stack_2179 = CDR(stack_758);
		   stack_758 = stack_2179;
		   goto loop_759;
		}
	     }
	}
   }
}


obj_t 
imported_modules_init_94_reduce_cse()
{
   module_initialization_70_tools_trace(((long) 0), "REDUCE_CSE");
   module_initialization_70_tools_shape(((long) 0), "REDUCE_CSE");
   module_initialization_70_tools_speek(((long) 0), "REDUCE_CSE");
   module_initialization_70_tools_error(((long) 0), "REDUCE_CSE");
   module_initialization_70_type_type(((long) 0), "REDUCE_CSE");
   module_initialization_70_type_cache(((long) 0), "REDUCE_CSE");
   module_initialization_70_coerce_typeof(((long) 0), "REDUCE_CSE");
   module_initialization_70_coerce_coerce(((long) 0), "REDUCE_CSE");
   module_initialization_70_effect_effect(((long) 0), "REDUCE_CSE");
   module_initialization_70_ast_var(((long) 0), "REDUCE_CSE");
   module_initialization_70_ast_node(((long) 0), "REDUCE_CSE");
   module_initialization_70_ast_lvtype(((long) 0), "REDUCE_CSE");
   return module_initialization_70_reduce_same(((long) 0), "REDUCE_CSE");
}
