/*===========================================================================*/
/*   (Reduce/same.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


static obj_t _same_node__default1316_234_reduce_same(obj_t, obj_t, obj_t, obj_t);
extern bool_t bigloo_strcmp(obj_t, obj_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_reduce_same();
extern obj_t module_initialization_70_reduce_same(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_equivalence_6_2(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t _same_node__185_reduce_same(obj_t, obj_t, obj_t, obj_t);
static obj_t toplevel_init_63_reduce_same();
static obj_t cnst_init_137_reduce_same();
extern bool_t same_node__38_reduce_same(node_t, node_t, obj_t);
static obj_t require_initialization_114_reduce_same = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_reduce_same();
extern bool_t equal__25___r4_equivalence_6_2(obj_t, obj_t);
extern obj_t cast_ast_node;
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
static bool_t same_node__default1316_147_reduce_same(node_t, node_t, obj_t);
static bool_t aliased__149_reduce_same(variable_t, variable_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t kwote_ast_node;
extern long list_length(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static bool_t same_node___136_reduce_same(obj_t, obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t atom_ast_node;
extern obj_t app_ast_node;
static obj_t __cnst[2];

DEFINE_STRING(string1779_reduce_same, string1779_reduce_same1793, "***cse:same-node?(var): ", 24);
DEFINE_STRING(string1781_reduce_same, string1781_reduce_same1794, "***cse:same-node?(fail): ", 25);
DEFINE_EXPORT_GENERIC(same_node__env_162_reduce_same, _same_node__185_reduce_same1795, _same_node__185_reduce_same, 0L, 3);
DEFINE_STRING(string1777_reduce_same, string1777_reduce_same1796, "***cse:same-node?(atom): ", 25);
DEFINE_STRING(string1776_reduce_same, string1776_reduce_same1797, "   ", 3);
DEFINE_STRING(string1782_reduce_same, string1782_reduce_same1798, "   alias: ", 10);
DEFINE_STRING(string1786_reduce_same, string1786_reduce_same1799, "READ REDUCE ", 12);
DEFINE_STRING(string1783_reduce_same, string1783_reduce_same1800, "   node2: ", 10);
DEFINE_STATIC_PROCEDURE(same_node__default1316_env_177_reduce_same, _same_node__default1316_234_reduce_same1801, _same_node__default1316_234_reduce_same, 0L, 3);
DEFINE_STRING(string1785_reduce_same, string1785_reduce_same1802, "***cse:same-node?(let-var) : ", 29);
DEFINE_STRING(string1778_reduce_same, string1778_reduce_same1803, "***cse:same-node?(kwote): ", 26);
DEFINE_STRING(string1784_reduce_same, string1784_reduce_same1804, "   node1: ", 10);
DEFINE_STRING(string1780_reduce_same, string1780_reduce_same1805, "***cse:same-node?(conditional): ", 32);

obj_t 
module_initialization_70_reduce_same(long checksum_1553, char *from_1554)
{
   if (CBOOL(require_initialization_114_reduce_same))
     {
	require_initialization_114_reduce_same = BBOOL(((bool_t) 0));
	library_modules_init_112_reduce_same();
	cnst_init_137_reduce_same();
	imported_modules_init_94_reduce_same();
	toplevel_init_63_reduce_same();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_reduce_same()
{
   module_initialization_70___object(((long) 0), "REDUCE_SAME");
   module_initialization_70___r4_equivalence_6_2(((long) 0), "REDUCE_SAME");
   module_initialization_70___reader(((long) 0), "REDUCE_SAME");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "REDUCE_SAME");
   return BUNSPEC;
}


obj_t 
cnst_init_137_reduce_same()
{
   {
      obj_t cnst_port_138_1545;
      cnst_port_138_1545 = open_input_string(string1786_reduce_same);
      {
	 long i_1546;
	 i_1546 = ((long) 1);
       loop_1547:
	 {
	    bool_t test1787_1548;
	    test1787_1548 = (i_1546 == ((long) -1));
	    if (test1787_1548)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1788_1549;
		    {
		       obj_t list1789_1550;
		       {
			  obj_t arg1791_1551;
			  arg1791_1551 = BNIL;
			  list1789_1550 = MAKE_PAIR(cnst_port_138_1545, arg1791_1551);
		       }
		       arg1788_1549 = read___reader(list1789_1550);
		    }
		    CNST_TABLE_SET(i_1546, arg1788_1549);
		 }
		 {
		    int aux_1552;
		    {
		       long aux_1572;
		       aux_1572 = (i_1546 - ((long) 1));
		       aux_1552 = (int) (aux_1572);
		    }
		    {
		       long i_1575;
		       i_1575 = (long) (aux_1552);
		       i_1546 = i_1575;
		       goto loop_1547;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_reduce_same()
{
   add_generic__110___object(same_node__env_162_reduce_same, same_node__default1316_env_177_reduce_same);
   add_inlined_method__244___object(same_node__env_162_reduce_same, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(same_node__env_162_reduce_same, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(same_node__env_162_reduce_same, var_ast_node, ((long) 2));
   add_inlined_method__244___object(same_node__env_162_reduce_same, sequence_ast_node, ((long) 3));
   add_inlined_method__244___object(same_node__env_162_reduce_same, app_ly_162_ast_node, ((long) 4));
   add_inlined_method__244___object(same_node__env_162_reduce_same, funcall_ast_node, ((long) 5));
   add_inlined_method__244___object(same_node__env_162_reduce_same, app_ast_node, ((long) 6));
   add_inlined_method__244___object(same_node__env_162_reduce_same, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(same_node__env_162_reduce_same, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(same_node__env_162_reduce_same, conditional_ast_node, ((long) 9));
   add_inlined_method__244___object(same_node__env_162_reduce_same, fail_ast_node, ((long) 10));
   {
      long aux_1589;
      aux_1589 = add_inlined_method__244___object(same_node__env_162_reduce_same, let_var_6_ast_node, ((long) 11));
      return BINT(aux_1589);
   }
}


bool_t 
same_node__default1316_147_reduce_same(node_t node1_4, node_t node2_5, obj_t alias_6)
{
   return ((bool_t) 0);
}


obj_t 
_same_node__default1316_234_reduce_same(obj_t env_1541, obj_t node1_1542, obj_t node2_1543, obj_t alias_1544)
{
   {
      bool_t aux_1592;
      aux_1592 = same_node__default1316_147_reduce_same((node_t) (node1_1542), (node_t) (node2_1543), alias_1544);
      return BBOOL(aux_1592);
   }
}


bool_t 
same_node__38_reduce_same(node_t node1_1, node_t node2_2, obj_t alias_3)
{
   {
      obj_t method1481_1017;
      obj_t class1486_1018;
      {
	 obj_t arg1489_1015;
	 obj_t arg1490_1016;
	 {
	    object_t obj_1330;
	    obj_1330 = (object_t) (node1_1);
	    {
	       obj_t pre_method_105_1331;
	       pre_method_105_1331 = PROCEDURE_REF(same_node__env_162_reduce_same, ((long) 2));
	       if (INTEGERP(pre_method_105_1331))
		 {
		    PROCEDURE_SET(same_node__env_162_reduce_same, ((long) 2), BUNSPEC);
		    arg1489_1015 = pre_method_105_1331;
		 }
	       else
		 {
		    long obj_class_num_177_1336;
		    obj_class_num_177_1336 = TYPE(obj_1330);
		    {
		       obj_t arg1183_1337;
		       arg1183_1337 = PROCEDURE_REF(same_node__env_162_reduce_same, ((long) 1));
		       {
			  long arg1184_1341;
			  {
			     long arg1186_1342;
			     arg1186_1342 = OBJECT_TYPE;
			     arg1184_1341 = (obj_class_num_177_1336 - arg1186_1342);
			  }
			  arg1489_1015 = VECTOR_REF(arg1183_1337, arg1184_1341);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1347;
	    object_1347 = (object_t) (node1_1);
	    {
	       long arg1187_1348;
	       {
		  long arg1188_1349;
		  long arg1189_1350;
		  arg1188_1349 = TYPE(object_1347);
		  arg1189_1350 = OBJECT_TYPE;
		  arg1187_1348 = (arg1188_1349 - arg1189_1350);
	       }
	       {
		  obj_t vector_1354;
		  vector_1354 = __classes__134___object;
		  arg1490_1016 = VECTOR_REF(vector_1354, arg1187_1348);
	       }
	    }
	 }
	 {
	    obj_t aux_1612;
	    method1481_1017 = arg1489_1015;
	    class1486_1018 = arg1490_1016;
	    {
	       if (INTEGERP(method1481_1017))
		 {
		    switch ((long) CINT(method1481_1017))
		      {
		      case ((long) 0):
			 {
			    atom_t node_1024;
			    node_1024 = (atom_t) (node1_1);
			    {
			       bool_t test1493_1027;
			       {
				  obj_t aux_1616;
				  aux_1616 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1493_1027 = CBOOL(aux_1616);
			       }
			       if (test1493_1027)
				 {
				    obj_t arg1497_1030;
				    obj_t arg1499_1032;
				    arg1497_1030 = shape_tools_shape((obj_t) (node_1024));
				    arg1499_1032 = shape_tools_shape((obj_t) (node2_2));
				    {
				       obj_t list1500_1033;
				       {
					  obj_t arg1501_1034;
					  {
					     obj_t arg1505_1035;
					     {
						obj_t arg1506_1036;
						{
						   obj_t arg1507_1037;
						   {
						      obj_t arg1509_1038;
						      {
							 obj_t arg1510_1039;
							 {
							    obj_t arg1511_1040;
							    {
							       obj_t aux_1626;
							       aux_1626 = BCHAR(((unsigned char) '\n'));
							       arg1511_1040 = MAKE_PAIR(aux_1626, BNIL);
							    }
							    arg1510_1039 = MAKE_PAIR(arg1499_1032, arg1511_1040);
							 }
							 arg1509_1038 = MAKE_PAIR(string1776_reduce_same, arg1510_1039);
						      }
						      {
							 obj_t aux_1631;
							 aux_1631 = BCHAR(((unsigned char) '\n'));
							 arg1507_1037 = MAKE_PAIR(aux_1631, arg1509_1038);
						      }
						   }
						   arg1506_1036 = MAKE_PAIR(arg1497_1030, arg1507_1037);
						}
						arg1505_1035 = MAKE_PAIR(string1776_reduce_same, arg1506_1036);
					     }
					     {
						obj_t aux_1636;
						aux_1636 = BCHAR(((unsigned char) '\n'));
						arg1501_1034 = MAKE_PAIR(aux_1636, arg1505_1035);
					     }
					  }
					  list1500_1033 = MAKE_PAIR(string1777_reduce_same, arg1501_1034);
				       }
				       print_trace_107_tools_trace(list1500_1033);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       bool_t _andtest_1272_1044;
			       _andtest_1272_1044 = is_a__118___object((obj_t) (node2_2), atom_ast_node);
			       if (_andtest_1272_1044)
				 {
				    bool_t test_1644;
				    {
				       obj_t aux_1650;
				       obj_t aux_1645;
				       {
					  type_t aux_1651;
					  aux_1651 = (((node_t) CREF(node2_2))->type);
					  aux_1650 = (obj_t) (aux_1651);
				       }
				       {
					  type_t aux_1646;
					  {
					     node_t obj_1357;
					     obj_1357 = (node_t) (node_1024);
					     aux_1646 = (((node_t) CREF(obj_1357))->type);
					  }
					  aux_1645 = (obj_t) (aux_1646);
				       }
				       test_1644 = (aux_1645 == aux_1650);
				    }
				    if (test_1644)
				      {
					 bool_t aux_1655;
					 {
					    obj_t aux_1656;
					    {
					       atom_t obj_1362;
					       obj_1362 = (atom_t) (node2_2);
					       aux_1656 = (((atom_t) CREF(obj_1362))->value);
					    }
					    aux_1655 = equal__25___r4_equivalence_6_2((((atom_t) CREF(node_1024))->value), aux_1656);
					 }
					 aux_1612 = BBOOL(aux_1655);
				      }
				    else
				      {
					 aux_1612 = BFALSE;
				      }
				 }
			       else
				 {
				    aux_1612 = BFALSE;
				 }
			    }
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t node_1050;
			    node_1050 = (kwote_t) (node1_1);
			    {
			       bool_t test1524_1053;
			       {
				  obj_t aux_1663;
				  aux_1663 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1524_1053 = CBOOL(aux_1663);
			       }
			       if (test1524_1053)
				 {
				    obj_t arg1531_1056;
				    obj_t arg1534_1058;
				    arg1531_1056 = shape_tools_shape((obj_t) (node_1050));
				    arg1534_1058 = shape_tools_shape((obj_t) (node2_2));
				    {
				       obj_t list1535_1059;
				       {
					  obj_t arg1536_1060;
					  {
					     obj_t arg1537_1061;
					     {
						obj_t arg1538_1062;
						{
						   obj_t arg1539_1063;
						   {
						      obj_t arg1540_1064;
						      {
							 obj_t arg1541_1065;
							 {
							    obj_t arg1542_1066;
							    {
							       obj_t aux_1673;
							       aux_1673 = BCHAR(((unsigned char) '\n'));
							       arg1542_1066 = MAKE_PAIR(aux_1673, BNIL);
							    }
							    arg1541_1065 = MAKE_PAIR(arg1534_1058, arg1542_1066);
							 }
							 arg1540_1064 = MAKE_PAIR(string1776_reduce_same, arg1541_1065);
						      }
						      {
							 obj_t aux_1678;
							 aux_1678 = BCHAR(((unsigned char) '\n'));
							 arg1539_1063 = MAKE_PAIR(aux_1678, arg1540_1064);
						      }
						   }
						   arg1538_1062 = MAKE_PAIR(arg1531_1056, arg1539_1063);
						}
						arg1537_1061 = MAKE_PAIR(string1776_reduce_same, arg1538_1062);
					     }
					     {
						obj_t aux_1683;
						aux_1683 = BCHAR(((unsigned char) '\n'));
						arg1536_1060 = MAKE_PAIR(aux_1683, arg1537_1061);
					     }
					  }
					  list1535_1059 = MAKE_PAIR(string1778_reduce_same, arg1536_1060);
				       }
				       print_trace_107_tools_trace(list1535_1059);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       bool_t _andtest_1274_1070;
			       _andtest_1274_1070 = is_a__118___object((obj_t) (node2_2), kwote_ast_node);
			       if (_andtest_1274_1070)
				 {
				    bool_t test_1691;
				    {
				       obj_t aux_1697;
				       obj_t aux_1692;
				       {
					  type_t aux_1698;
					  aux_1698 = (((node_t) CREF(node2_2))->type);
					  aux_1697 = (obj_t) (aux_1698);
				       }
				       {
					  type_t aux_1693;
					  {
					     node_t obj_1364;
					     obj_1364 = (node_t) (node_1050);
					     aux_1693 = (((node_t) CREF(obj_1364))->type);
					  }
					  aux_1692 = (obj_t) (aux_1693);
				       }
				       test_1691 = (aux_1692 == aux_1697);
				    }
				    if (test_1691)
				      {
					 bool_t aux_1702;
					 {
					    obj_t aux_1703;
					    {
					       kwote_t obj_1369;
					       obj_1369 = (kwote_t) (node2_2);
					       aux_1703 = (((kwote_t) CREF(obj_1369))->value);
					    }
					    aux_1702 = equal__25___r4_equivalence_6_2((((kwote_t) CREF(node_1050))->value), aux_1703);
					 }
					 aux_1612 = BBOOL(aux_1702);
				      }
				    else
				      {
					 aux_1612 = BFALSE;
				      }
				 }
			       else
				 {
				    aux_1612 = BFALSE;
				 }
			    }
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t node_1076;
			    node_1076 = (var_t) (node1_1);
			    {
			       bool_t test1554_1079;
			       {
				  obj_t aux_1710;
				  aux_1710 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1554_1079 = CBOOL(aux_1710);
			       }
			       if (test1554_1079)
				 {
				    obj_t arg1559_1082;
				    obj_t arg1561_1084;
				    arg1559_1082 = shape_tools_shape((obj_t) (node_1076));
				    arg1561_1084 = shape_tools_shape((obj_t) (node2_2));
				    {
				       obj_t list1562_1085;
				       {
					  obj_t arg1563_1086;
					  {
					     obj_t arg1564_1087;
					     {
						obj_t arg1565_1088;
						{
						   obj_t arg1566_1089;
						   {
						      obj_t arg1567_1090;
						      {
							 obj_t arg1568_1091;
							 {
							    obj_t arg1570_1092;
							    {
							       obj_t aux_1720;
							       aux_1720 = BCHAR(((unsigned char) '\n'));
							       arg1570_1092 = MAKE_PAIR(aux_1720, BNIL);
							    }
							    arg1568_1091 = MAKE_PAIR(arg1561_1084, arg1570_1092);
							 }
							 arg1567_1090 = MAKE_PAIR(string1776_reduce_same, arg1568_1091);
						      }
						      {
							 obj_t aux_1725;
							 aux_1725 = BCHAR(((unsigned char) '\n'));
							 arg1566_1089 = MAKE_PAIR(aux_1725, arg1567_1090);
						      }
						   }
						   arg1565_1088 = MAKE_PAIR(arg1559_1082, arg1566_1089);
						}
						arg1564_1087 = MAKE_PAIR(string1776_reduce_same, arg1565_1088);
					     }
					     {
						obj_t aux_1730;
						aux_1730 = BCHAR(((unsigned char) '\n'));
						arg1563_1086 = MAKE_PAIR(aux_1730, arg1564_1087);
					     }
					  }
					  list1562_1085 = MAKE_PAIR(string1779_reduce_same, arg1563_1086);
				       }
				       print_trace_107_tools_trace(list1562_1085);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       bool_t _andtest_1276_1096;
			       _andtest_1276_1096 = is_a__118___object((obj_t) (node2_2), var_ast_node);
			       if (_andtest_1276_1096)
				 {
				    bool_t test_1738;
				    {
				       obj_t aux_1742;
				       obj_t aux_1739;
				       aux_1742 = CNST_TABLE_REF(((long) 1));
				       {
					  variable_t arg1584_1108;
					  arg1584_1108 = (((var_t) CREF(node_1076))->variable);
					  aux_1739 = (((variable_t) CREF(arg1584_1108))->access);
				       }
				       test_1738 = (aux_1739 == aux_1742);
				    }
				    if (test_1738)
				      {
					 bool_t test_1745;
					 {
					    obj_t aux_1751;
					    obj_t aux_1746;
					    {
					       type_t aux_1752;
					       aux_1752 = (((node_t) CREF(node2_2))->type);
					       aux_1751 = (obj_t) (aux_1752);
					    }
					    {
					       type_t aux_1747;
					       {
						  node_t obj_1375;
						  obj_1375 = (node_t) (node_1076);
						  aux_1747 = (((node_t) CREF(obj_1375))->type);
					       }
					       aux_1746 = (obj_t) (aux_1747);
					    }
					    test_1745 = (aux_1746 == aux_1751);
					 }
					 if (test_1745)
					   {
					      bool_t _ortest_1279_1099;
					      {
						 obj_t aux_1760;
						 obj_t aux_1756;
						 {
						    variable_t aux_1761;
						    {
						       var_t obj_1380;
						       obj_1380 = (var_t) (node2_2);
						       aux_1761 = (((var_t) CREF(obj_1380))->variable);
						    }
						    aux_1760 = (obj_t) (aux_1761);
						 }
						 {
						    variable_t aux_1757;
						    aux_1757 = (((var_t) CREF(node_1076))->variable);
						    aux_1756 = (obj_t) (aux_1757);
						 }
						 _ortest_1279_1099 = (aux_1756 == aux_1760);
					      }
					      if (_ortest_1279_1099)
						{
						   aux_1612 = BBOOL(_ortest_1279_1099);
						}
					      else
						{
						   bool_t aux_1768;
						   {
						      variable_t aux_1769;
						      {
							 var_t obj_1384;
							 obj_1384 = (var_t) (node2_2);
							 aux_1769 = (((var_t) CREF(obj_1384))->variable);
						      }
						      aux_1768 = aliased__149_reduce_same((((var_t) CREF(node_1076))->variable), aux_1769, alias_3);
						   }
						   aux_1612 = BBOOL(aux_1768);
						}
					   }
					 else
					   {
					      aux_1612 = BFALSE;
					   }
				      }
				    else
				      {
					 aux_1612 = BFALSE;
				      }
				 }
			       else
				 {
				    aux_1612 = BFALSE;
				 }
			    }
			 }
			 break;
		      case ((long) 3):
			 {
			    sequence_t node_1109;
			    node_1109 = (sequence_t) (node1_1);
			    {
			       bool_t _andtest_1280_1112;
			       _andtest_1280_1112 = is_a__118___object((obj_t) (node2_2), sequence_ast_node);
			       if (_andtest_1280_1112)
				 {
				    bool_t test_1779;
				    {
				       obj_t aux_1785;
				       obj_t aux_1780;
				       {
					  type_t aux_1786;
					  aux_1786 = (((node_t) CREF(node2_2))->type);
					  aux_1785 = (obj_t) (aux_1786);
				       }
				       {
					  type_t aux_1781;
					  {
					     node_t obj_1386;
					     obj_1386 = (node_t) (node_1109);
					     aux_1781 = (((node_t) CREF(obj_1386))->type);
					  }
					  aux_1780 = (obj_t) (aux_1781);
				       }
				       test_1779 = (aux_1780 == aux_1785);
				    }
				    if (test_1779)
				      {
					 bool_t aux_1790;
					 {
					    obj_t aux_1791;
					    {
					       sequence_t obj_1391;
					       obj_1391 = (sequence_t) (node2_2);
					       aux_1791 = (((sequence_t) CREF(obj_1391))->nodes);
					    }
					    aux_1790 = same_node___136_reduce_same((((sequence_t) CREF(node_1109))->nodes), aux_1791, alias_3);
					 }
					 aux_1612 = BBOOL(aux_1790);
				      }
				    else
				      {
					 aux_1612 = BFALSE;
				      }
				 }
			       else
				 {
				    aux_1612 = BFALSE;
				 }
			    }
			 }
			 break;
		      case ((long) 4):
			 {
			    app_ly_162_t node_1118;
			    node_1118 = (app_ly_162_t) (node1_1);
			    {
			       bool_t _andtest_1282_1121;
			       _andtest_1282_1121 = is_a__118___object((obj_t) (node2_2), app_ly_162_ast_node);
			       if (_andtest_1282_1121)
				 {
				    bool_t test_1801;
				    {
				       obj_t aux_1807;
				       obj_t aux_1802;
				       {
					  type_t aux_1808;
					  aux_1808 = (((node_t) CREF(node2_2))->type);
					  aux_1807 = (obj_t) (aux_1808);
				       }
				       {
					  type_t aux_1803;
					  {
					     node_t obj_1393;
					     obj_1393 = (node_t) (node_1118);
					     aux_1803 = (((node_t) CREF(obj_1393))->type);
					  }
					  aux_1802 = (obj_t) (aux_1803);
				       }
				       test_1801 = (aux_1802 == aux_1807);
				    }
				    if (test_1801)
				      {
					 bool_t _andtest_1284_1123;
					 {
					    node_t aux_1812;
					    {
					       app_ly_162_t obj_1398;
					       obj_1398 = (app_ly_162_t) (node2_2);
					       aux_1812 = (((app_ly_162_t) CREF(obj_1398))->fun);
					    }
					    _andtest_1284_1123 = same_node__38_reduce_same((((app_ly_162_t) CREF(node_1118))->fun), aux_1812, alias_3);
					 }
					 if (_andtest_1284_1123)
					   {
					      bool_t aux_1818;
					      {
						 node_t aux_1819;
						 {
						    app_ly_162_t obj_1400;
						    obj_1400 = (app_ly_162_t) (node2_2);
						    aux_1819 = (((app_ly_162_t) CREF(obj_1400))->arg);
						 }
						 aux_1818 = same_node__38_reduce_same((((app_ly_162_t) CREF(node_1118))->arg), aux_1819, alias_3);
					      }
					      aux_1612 = BBOOL(aux_1818);
					   }
					 else
					   {
					      aux_1612 = BFALSE;
					   }
				      }
				    else
				      {
					 aux_1612 = BFALSE;
				      }
				 }
			       else
				 {
				    aux_1612 = BFALSE;
				 }
			    }
			 }
			 break;
		      case ((long) 5):
			 {
			    funcall_t node_1130;
			    node_1130 = (funcall_t) (node1_1);
			    {
			       bool_t _andtest_1285_1133;
			       _andtest_1285_1133 = is_a__118___object((obj_t) (node2_2), funcall_ast_node);
			       if (_andtest_1285_1133)
				 {
				    bool_t test_1829;
				    {
				       obj_t aux_1835;
				       obj_t aux_1830;
				       {
					  type_t aux_1836;
					  aux_1836 = (((node_t) CREF(node2_2))->type);
					  aux_1835 = (obj_t) (aux_1836);
				       }
				       {
					  type_t aux_1831;
					  {
					     node_t obj_1402;
					     obj_1402 = (node_t) (node_1130);
					     aux_1831 = (((node_t) CREF(obj_1402))->type);
					  }
					  aux_1830 = (obj_t) (aux_1831);
				       }
				       test_1829 = (aux_1830 == aux_1835);
				    }
				    if (test_1829)
				      {
					 bool_t _andtest_1287_1135;
					 {
					    node_t aux_1840;
					    {
					       funcall_t obj_1407;
					       obj_1407 = (funcall_t) (node2_2);
					       aux_1840 = (((funcall_t) CREF(obj_1407))->fun);
					    }
					    _andtest_1287_1135 = same_node__38_reduce_same((((funcall_t) CREF(node_1130))->fun), aux_1840, alias_3);
					 }
					 if (_andtest_1287_1135)
					   {
					      bool_t aux_1846;
					      {
						 obj_t aux_1847;
						 {
						    funcall_t obj_1409;
						    obj_1409 = (funcall_t) (node2_2);
						    aux_1847 = (((funcall_t) CREF(obj_1409))->args);
						 }
						 aux_1846 = same_node___136_reduce_same((((funcall_t) CREF(node_1130))->args), aux_1847, alias_3);
					      }
					      aux_1612 = BBOOL(aux_1846);
					   }
					 else
					   {
					      aux_1612 = BFALSE;
					   }
				      }
				    else
				      {
					 aux_1612 = BFALSE;
				      }
				 }
			       else
				 {
				    aux_1612 = BFALSE;
				 }
			    }
			 }
			 break;
		      case ((long) 6):
			 {
			    app_t node_1142;
			    node_1142 = (app_t) (node1_1);
			    {
			       bool_t _andtest_1288_1145;
			       _andtest_1288_1145 = is_a__118___object((obj_t) (node2_2), app_ast_node);
			       if (_andtest_1288_1145)
				 {
				    bool_t test_1857;
				    {
				       obj_t aux_1863;
				       obj_t aux_1858;
				       {
					  type_t aux_1864;
					  aux_1864 = (((node_t) CREF(node2_2))->type);
					  aux_1863 = (obj_t) (aux_1864);
				       }
				       {
					  type_t aux_1859;
					  {
					     node_t obj_1411;
					     obj_1411 = (node_t) (node_1142);
					     aux_1859 = (((node_t) CREF(obj_1411))->type);
					  }
					  aux_1858 = (obj_t) (aux_1859);
				       }
				       test_1857 = (aux_1858 == aux_1863);
				    }
				    if (test_1857)
				      {
					 bool_t _andtest_1290_1147;
					 {
					    node_t aux_1872;
					    node_t aux_1868;
					    {
					       var_t aux_1873;
					       {
						  app_t obj_1416;
						  obj_1416 = (app_t) (node2_2);
						  aux_1873 = (((app_t) CREF(obj_1416))->fun);
					       }
					       aux_1872 = (node_t) (aux_1873);
					    }
					    {
					       var_t aux_1869;
					       aux_1869 = (((app_t) CREF(node_1142))->fun);
					       aux_1868 = (node_t) (aux_1869);
					    }
					    _andtest_1290_1147 = same_node__38_reduce_same(aux_1868, aux_1872, alias_3);
					 }
					 if (_andtest_1290_1147)
					   {
					      bool_t aux_1879;
					      {
						 obj_t aux_1880;
						 {
						    app_t obj_1418;
						    obj_1418 = (app_t) (node2_2);
						    aux_1880 = (((app_t) CREF(obj_1418))->args);
						 }
						 aux_1879 = same_node___136_reduce_same((((app_t) CREF(node_1142))->args), aux_1880, alias_3);
					      }
					      aux_1612 = BBOOL(aux_1879);
					   }
					 else
					   {
					      aux_1612 = BFALSE;
					   }
				      }
				    else
				      {
					 aux_1612 = BFALSE;
				      }
				 }
			       else
				 {
				    aux_1612 = BFALSE;
				 }
			    }
			 }
			 break;
		      case ((long) 7):
			 {
			    pragma_t node_1154;
			    node_1154 = (pragma_t) (node1_1);
			    {
			       bool_t _andtest_1291_1157;
			       _andtest_1291_1157 = is_a__118___object((obj_t) (node2_2), pragma_ast_node);
			       if (_andtest_1291_1157)
				 {
				    bool_t test_1890;
				    {
				       obj_t aux_1896;
				       obj_t aux_1891;
				       {
					  type_t aux_1897;
					  aux_1897 = (((node_t) CREF(node2_2))->type);
					  aux_1896 = (obj_t) (aux_1897);
				       }
				       {
					  type_t aux_1892;
					  {
					     node_t obj_1420;
					     obj_1420 = (node_t) (node_1154);
					     aux_1892 = (((node_t) CREF(obj_1420))->type);
					  }
					  aux_1891 = (obj_t) (aux_1892);
				       }
				       test_1890 = (aux_1891 == aux_1896);
				    }
				    if (test_1890)
				      {
					 bool_t _andtest_1293_1159;
					 {
					    obj_t aux_1903;
					    obj_t aux_1901;
					    {
					       pragma_t obj_1425;
					       obj_1425 = (pragma_t) (node2_2);
					       aux_1903 = (((pragma_t) CREF(obj_1425))->format);
					    }
					    aux_1901 = (((pragma_t) CREF(node_1154))->format);
					    _andtest_1293_1159 = bigloo_strcmp(aux_1901, aux_1903);
					 }
					 if (_andtest_1293_1159)
					   {
					      bool_t aux_1908;
					      {
						 obj_t aux_1909;
						 {
						    pragma_t obj_1429;
						    obj_1429 = (pragma_t) (node2_2);
						    aux_1909 = (((pragma_t) CREF(obj_1429))->args);
						 }
						 aux_1908 = same_node___136_reduce_same((((pragma_t) CREF(node_1154))->args), aux_1909, alias_3);
					      }
					      aux_1612 = BBOOL(aux_1908);
					   }
					 else
					   {
					      aux_1612 = BFALSE;
					   }
				      }
				    else
				      {
					 aux_1612 = BFALSE;
				      }
				 }
			       else
				 {
				    aux_1612 = BFALSE;
				 }
			    }
			 }
			 break;
		      case ((long) 8):
			 {
			    cast_t node_1166;
			    node_1166 = (cast_t) (node1_1);
			    {
			       bool_t _andtest_1294_1169;
			       _andtest_1294_1169 = is_a__118___object((obj_t) (node2_2), cast_ast_node);
			       if (_andtest_1294_1169)
				 {
				    bool_t test_1919;
				    {
				       obj_t aux_1925;
				       obj_t aux_1920;
				       {
					  type_t aux_1926;
					  aux_1926 = (((node_t) CREF(node2_2))->type);
					  aux_1925 = (obj_t) (aux_1926);
				       }
				       {
					  type_t aux_1921;
					  {
					     node_t obj_1431;
					     obj_1431 = (node_t) (node_1166);
					     aux_1921 = (((node_t) CREF(obj_1431))->type);
					  }
					  aux_1920 = (obj_t) (aux_1921);
				       }
				       test_1919 = (aux_1920 == aux_1925);
				    }
				    if (test_1919)
				      {
					 bool_t aux_1930;
					 {
					    node_t aux_1931;
					    {
					       cast_t obj_1436;
					       obj_1436 = (cast_t) (node2_2);
					       aux_1931 = (((cast_t) CREF(obj_1436))->arg);
					    }
					    aux_1930 = same_node__38_reduce_same((((cast_t) CREF(node_1166))->arg), aux_1931, alias_3);
					 }
					 aux_1612 = BBOOL(aux_1930);
				      }
				    else
				      {
					 aux_1612 = BFALSE;
				      }
				 }
			       else
				 {
				    aux_1612 = BFALSE;
				 }
			    }
			 }
			 break;
		      case ((long) 9):
			 {
			    conditional_t node_1175;
			    node_1175 = (conditional_t) (node1_1);
			    {
			       bool_t test1629_1178;
			       {
				  obj_t aux_1938;
				  aux_1938 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1629_1178 = CBOOL(aux_1938);
			       }
			       if (test1629_1178)
				 {
				    obj_t arg1634_1181;
				    obj_t arg1638_1183;
				    arg1634_1181 = shape_tools_shape((obj_t) (node_1175));
				    arg1638_1183 = shape_tools_shape((obj_t) (node2_2));
				    {
				       obj_t list1639_1184;
				       {
					  obj_t arg1641_1185;
					  {
					     obj_t arg1642_1186;
					     {
						obj_t arg1643_1187;
						{
						   obj_t arg1644_1188;
						   {
						      obj_t arg1645_1189;
						      {
							 obj_t arg1646_1190;
							 {
							    obj_t arg1647_1191;
							    {
							       obj_t aux_1948;
							       aux_1948 = BCHAR(((unsigned char) '\n'));
							       arg1647_1191 = MAKE_PAIR(aux_1948, BNIL);
							    }
							    arg1646_1190 = MAKE_PAIR(arg1638_1183, arg1647_1191);
							 }
							 arg1645_1189 = MAKE_PAIR(string1776_reduce_same, arg1646_1190);
						      }
						      {
							 obj_t aux_1953;
							 aux_1953 = BCHAR(((unsigned char) '\n'));
							 arg1644_1188 = MAKE_PAIR(aux_1953, arg1645_1189);
						      }
						   }
						   arg1643_1187 = MAKE_PAIR(arg1634_1181, arg1644_1188);
						}
						arg1642_1186 = MAKE_PAIR(string1776_reduce_same, arg1643_1187);
					     }
					     {
						obj_t aux_1958;
						aux_1958 = BCHAR(((unsigned char) '\n'));
						arg1641_1185 = MAKE_PAIR(aux_1958, arg1642_1186);
					     }
					  }
					  list1639_1184 = MAKE_PAIR(string1780_reduce_same, arg1641_1185);
				       }
				       print_trace_107_tools_trace(list1639_1184);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       bool_t _andtest_1296_1195;
			       _andtest_1296_1195 = is_a__118___object((obj_t) (node2_2), conditional_ast_node);
			       if (_andtest_1296_1195)
				 {
				    bool_t test_1966;
				    {
				       obj_t aux_1972;
				       obj_t aux_1967;
				       {
					  type_t aux_1973;
					  aux_1973 = (((node_t) CREF(node2_2))->type);
					  aux_1972 = (obj_t) (aux_1973);
				       }
				       {
					  type_t aux_1968;
					  {
					     node_t obj_1438;
					     obj_1438 = (node_t) (node_1175);
					     aux_1968 = (((node_t) CREF(obj_1438))->type);
					  }
					  aux_1967 = (obj_t) (aux_1968);
				       }
				       test_1966 = (aux_1967 == aux_1972);
				    }
				    if (test_1966)
				      {
					 bool_t _andtest_1298_1197;
					 {
					    node_t aux_1977;
					    {
					       conditional_t obj_1443;
					       obj_1443 = (conditional_t) (node2_2);
					       aux_1977 = (((conditional_t) CREF(obj_1443))->false);
					    }
					    _andtest_1298_1197 = same_node__38_reduce_same((((conditional_t) CREF(node_1175))->false), aux_1977, alias_3);
					 }
					 if (_andtest_1298_1197)
					   {
					      bool_t _andtest_1299_1198;
					      {
						 node_t aux_1983;
						 {
						    conditional_t obj_1445;
						    obj_1445 = (conditional_t) (node2_2);
						    aux_1983 = (((conditional_t) CREF(obj_1445))->true);
						 }
						 _andtest_1299_1198 = same_node__38_reduce_same((((conditional_t) CREF(node_1175))->true), aux_1983, alias_3);
					      }
					      if (_andtest_1299_1198)
						{
						   bool_t aux_1989;
						   {
						      node_t aux_1990;
						      {
							 conditional_t obj_1447;
							 obj_1447 = (conditional_t) (node2_2);
							 aux_1990 = (((conditional_t) CREF(obj_1447))->test);
						      }
						      aux_1989 = same_node__38_reduce_same((((conditional_t) CREF(node_1175))->test), aux_1990, alias_3);
						   }
						   aux_1612 = BBOOL(aux_1989);
						}
					      else
						{
						   aux_1612 = BFALSE;
						}
					   }
					 else
					   {
					      aux_1612 = BFALSE;
					   }
				      }
				    else
				      {
					 aux_1612 = BFALSE;
				      }
				 }
			       else
				 {
				    aux_1612 = BFALSE;
				 }
			    }
			 }
			 break;
		      case ((long) 10):
			 {
			    fail_t node_1207;
			    node_1207 = (fail_t) (node1_1);
			    {
			       bool_t test1662_1210;
			       {
				  obj_t aux_1997;
				  aux_1997 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1662_1210 = CBOOL(aux_1997);
			       }
			       if (test1662_1210)
				 {
				    obj_t arg1665_1213;
				    obj_t arg1668_1215;
				    arg1665_1213 = shape_tools_shape((obj_t) (node_1207));
				    arg1668_1215 = shape_tools_shape((obj_t) (node2_2));
				    {
				       obj_t list1669_1216;
				       {
					  obj_t arg1671_1217;
					  {
					     obj_t arg1673_1218;
					     {
						obj_t arg1674_1219;
						{
						   obj_t arg1677_1220;
						   {
						      obj_t arg1678_1221;
						      {
							 obj_t arg1679_1222;
							 {
							    obj_t arg1680_1223;
							    {
							       obj_t aux_2007;
							       aux_2007 = BCHAR(((unsigned char) '\n'));
							       arg1680_1223 = MAKE_PAIR(aux_2007, BNIL);
							    }
							    arg1679_1222 = MAKE_PAIR(arg1668_1215, arg1680_1223);
							 }
							 arg1678_1221 = MAKE_PAIR(string1776_reduce_same, arg1679_1222);
						      }
						      {
							 obj_t aux_2012;
							 aux_2012 = BCHAR(((unsigned char) '\n'));
							 arg1677_1220 = MAKE_PAIR(aux_2012, arg1678_1221);
						      }
						   }
						   arg1674_1219 = MAKE_PAIR(arg1665_1213, arg1677_1220);
						}
						arg1673_1218 = MAKE_PAIR(string1776_reduce_same, arg1674_1219);
					     }
					     {
						obj_t aux_2017;
						aux_2017 = BCHAR(((unsigned char) '\n'));
						arg1671_1217 = MAKE_PAIR(aux_2017, arg1673_1218);
					     }
					  }
					  list1669_1216 = MAKE_PAIR(string1781_reduce_same, arg1671_1217);
				       }
				       print_trace_107_tools_trace(list1669_1216);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       bool_t _andtest_1300_1227;
			       _andtest_1300_1227 = is_a__118___object((obj_t) (node2_2), fail_ast_node);
			       if (_andtest_1300_1227)
				 {
				    bool_t test_2025;
				    {
				       obj_t aux_2031;
				       obj_t aux_2026;
				       {
					  type_t aux_2032;
					  aux_2032 = (((node_t) CREF(node2_2))->type);
					  aux_2031 = (obj_t) (aux_2032);
				       }
				       {
					  type_t aux_2027;
					  {
					     node_t obj_1449;
					     obj_1449 = (node_t) (node_1207);
					     aux_2027 = (((node_t) CREF(obj_1449))->type);
					  }
					  aux_2026 = (obj_t) (aux_2027);
				       }
				       test_2025 = (aux_2026 == aux_2031);
				    }
				    if (test_2025)
				      {
					 bool_t _andtest_1302_1229;
					 {
					    node_t aux_2036;
					    {
					       fail_t obj_1454;
					       obj_1454 = (fail_t) (node2_2);
					       aux_2036 = (((fail_t) CREF(obj_1454))->msg);
					    }
					    _andtest_1302_1229 = same_node__38_reduce_same((((fail_t) CREF(node_1207))->msg), aux_2036, alias_3);
					 }
					 if (_andtest_1302_1229)
					   {
					      bool_t _andtest_1303_1230;
					      {
						 node_t aux_2042;
						 {
						    fail_t obj_1456;
						    obj_1456 = (fail_t) (node2_2);
						    aux_2042 = (((fail_t) CREF(obj_1456))->proc);
						 }
						 _andtest_1303_1230 = same_node__38_reduce_same((((fail_t) CREF(node_1207))->proc), aux_2042, alias_3);
					      }
					      if (_andtest_1303_1230)
						{
						   bool_t aux_2048;
						   {
						      node_t aux_2049;
						      {
							 fail_t obj_1458;
							 obj_1458 = (fail_t) (node2_2);
							 aux_2049 = (((fail_t) CREF(obj_1458))->obj);
						      }
						      aux_2048 = same_node__38_reduce_same((((fail_t) CREF(node_1207))->obj), aux_2049, alias_3);
						   }
						   aux_1612 = BBOOL(aux_2048);
						}
					      else
						{
						   aux_1612 = BFALSE;
						}
					   }
					 else
					   {
					      aux_1612 = BFALSE;
					   }
				      }
				    else
				      {
					 aux_1612 = BFALSE;
				      }
				 }
			       else
				 {
				    aux_1612 = BFALSE;
				 }
			    }
			 }
			 break;
		      case ((long) 11):
			 {
			    let_var_6_t node_1239;
			    node_1239 = (let_var_6_t) (node1_1);
			    {
			       bool_t test1695_1242;
			       {
				  obj_t aux_2056;
				  aux_2056 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1695_1242 = CBOOL(aux_2056);
			       }
			       if (test1695_1242)
				 {
				    obj_t arg1698_1245;
				    obj_t arg1701_1247;
				    obj_t arg1703_1249;
				    arg1698_1245 = shape_tools_shape((obj_t) (node_1239));
				    arg1701_1247 = shape_tools_shape((obj_t) (node2_2));
				    arg1703_1249 = shape_tools_shape(alias_3);
				    {
				       obj_t list1704_1250;
				       {
					  obj_t arg1705_1251;
					  {
					     obj_t arg1706_1252;
					     {
						obj_t arg1707_1253;
						{
						   obj_t arg1708_1254;
						   {
						      obj_t arg1709_1255;
						      {
							 obj_t arg1710_1256;
							 {
							    obj_t arg1711_1257;
							    {
							       obj_t arg1712_1258;
							       {
								  obj_t arg1714_1259;
								  {
								     obj_t arg1715_1260;
								     {
									obj_t aux_2067;
									aux_2067 = BCHAR(((unsigned char) '\n'));
									arg1715_1260 = MAKE_PAIR(aux_2067, BNIL);
								     }
								     arg1714_1259 = MAKE_PAIR(arg1703_1249, arg1715_1260);
								  }
								  arg1712_1258 = MAKE_PAIR(string1782_reduce_same, arg1714_1259);
							       }
							       {
								  obj_t aux_2072;
								  aux_2072 = BCHAR(((unsigned char) '\n'));
								  arg1711_1257 = MAKE_PAIR(aux_2072, arg1712_1258);
							       }
							    }
							    arg1710_1256 = MAKE_PAIR(arg1701_1247, arg1711_1257);
							 }
							 arg1709_1255 = MAKE_PAIR(string1783_reduce_same, arg1710_1256);
						      }
						      {
							 obj_t aux_2077;
							 aux_2077 = BCHAR(((unsigned char) '\n'));
							 arg1708_1254 = MAKE_PAIR(aux_2077, arg1709_1255);
						      }
						   }
						   arg1707_1253 = MAKE_PAIR(arg1698_1245, arg1708_1254);
						}
						arg1706_1252 = MAKE_PAIR(string1784_reduce_same, arg1707_1253);
					     }
					     {
						obj_t aux_2082;
						aux_2082 = BCHAR(((unsigned char) '\n'));
						arg1705_1251 = MAKE_PAIR(aux_2082, arg1706_1252);
					     }
					  }
					  list1704_1250 = MAKE_PAIR(string1785_reduce_same, arg1705_1251);
				       }
				       print_trace_107_tools_trace(list1704_1250);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       bool_t _andtest_1304_1264;
			       _andtest_1304_1264 = is_a__118___object((obj_t) (node2_2), let_var_6_ast_node);
			       if (_andtest_1304_1264)
				 {
				    bool_t test_2090;
				    {
				       obj_t aux_2096;
				       obj_t aux_2091;
				       {
					  type_t aux_2097;
					  aux_2097 = (((node_t) CREF(node2_2))->type);
					  aux_2096 = (obj_t) (aux_2097);
				       }
				       {
					  type_t aux_2092;
					  {
					     node_t obj_1460;
					     obj_1460 = (node_t) (node_1239);
					     aux_2092 = (((node_t) CREF(obj_1460))->type);
					  }
					  aux_2091 = (obj_t) (aux_2092);
				       }
				       test_2090 = (aux_2091 == aux_2096);
				    }
				    if (test_2090)
				      {
					 bool_t test_2101;
					 {
					    obj_t aux_2107;
					    obj_t aux_2102;
					    {
					       long aux_2108;
					       {
						  obj_t aux_2109;
						  {
						     let_var_6_t obj_1465;
						     obj_1465 = (let_var_6_t) (node2_2);
						     aux_2109 = (((let_var_6_t) CREF(obj_1465))->bindings);
						  }
						  aux_2108 = list_length(aux_2109);
					       }
					       aux_2107 = BINT(aux_2108);
					    }
					    {
					       long aux_2103;
					       aux_2103 = list_length((((let_var_6_t) CREF(node_1239))->bindings));
					       aux_2102 = BINT(aux_2103);
					    }
					    test_2101 = (aux_2102 == aux_2107);
					 }
					 if (test_2101)
					   {
					      obj_t new_alias_67_1267;
					      {
						 obj_t arg1747_1294;
						 {
						    obj_t ll1307_1295;
						    obj_t ll1308_1296;
						    ll1307_1295 = (((let_var_6_t) CREF(node_1239))->bindings);
						    {
						       let_var_6_t obj_1469;
						       obj_1469 = (let_var_6_t) (node2_2);
						       ll1308_1296 = (((let_var_6_t) CREF(obj_1469))->bindings);
						    }
						    if (NULLP(ll1307_1295))
						      {
							 arg1747_1294 = BNIL;
						      }
						    else
						      {
							 obj_t head1309_1298;
							 head1309_1298 = MAKE_PAIR(BNIL, BNIL);
							 {
							    obj_t ll1307_1299;
							    obj_t ll1308_1300;
							    obj_t tail1310_1301;
							    ll1307_1299 = ll1307_1295;
							    ll1308_1300 = ll1308_1296;
							    tail1310_1301 = head1309_1298;
							  lname1314_1302:
							    if (NULLP(ll1307_1299))
							      {
								 arg1747_1294 = CDR(head1309_1298);
							      }
							    else
							      {
								 obj_t new_tail1311_23_1304;
								 {
								    obj_t arg1754_1307;
								    {
								       obj_t aux_2128;
								       obj_t aux_2124;
								       {
									  obj_t aux_2129;
									  aux_2129 = CAR(ll1308_1300);
									  aux_2128 = CAR(aux_2129);
								       }
								       {
									  obj_t aux_2125;
									  aux_2125 = CAR(ll1307_1299);
									  aux_2124 = CAR(aux_2125);
								       }
								       arg1754_1307 = MAKE_PAIR(aux_2124, aux_2128);
								    }
								    new_tail1311_23_1304 = MAKE_PAIR(arg1754_1307, BNIL);
								 }
								 SET_CDR(tail1310_1301, new_tail1311_23_1304);
								 {
								    obj_t tail1310_2139;
								    obj_t ll1308_2137;
								    obj_t ll1307_2135;
								    ll1307_2135 = CDR(ll1307_1299);
								    ll1308_2137 = CDR(ll1308_1300);
								    tail1310_2139 = new_tail1311_23_1304;
								    tail1310_1301 = tail1310_2139;
								    ll1308_1300 = ll1308_2137;
								    ll1307_1299 = ll1307_2135;
								    goto lname1314_1302;
								 }
							      }
							 }
						      }
						 }
						 new_alias_67_1267 = append_2_18___r4_pairs_and_lists_6_3(alias_3, arg1747_1294);
					      }
					      {
						 bool_t _andtest_1315_1268;
						 {
						    node_t aux_2141;
						    {
						       let_var_6_t obj_1488;
						       obj_1488 = (let_var_6_t) (node2_2);
						       aux_2141 = (((let_var_6_t) CREF(obj_1488))->body);
						    }
						    _andtest_1315_1268 = same_node__38_reduce_same((((let_var_6_t) CREF(node_1239))->body), aux_2141, new_alias_67_1267);
						 }
						 if (_andtest_1315_1268)
						   {
						      obj_t bindings1_1269;
						      obj_t bindings2_1270;
						      {
							 bool_t aux_2147;
							 bindings1_1269 = (((let_var_6_t) CREF(node_1239))->bindings);
							 {
							    let_var_6_t obj_1490;
							    obj_1490 = (let_var_6_t) (node2_2);
							    bindings2_1270 = (((let_var_6_t) CREF(obj_1490))->bindings);
							 }
						       loop_1271:
							 if (NULLP(bindings1_1269))
							   {
							      aux_2147 = ((bool_t) 1);
							   }
							 else
							   {
							      bool_t test_2150;
							      {
								 bool_t test_2151;
								 {
								    obj_t aux_2159;
								    obj_t aux_2152;
								    aux_2159 = CNST_TABLE_REF(((long) 1));
								    {
								       local_t obj_1494;
								       {
									  obj_t aux_2153;
									  {
									     obj_t aux_2154;
									     aux_2154 = CAR(bindings1_1269);
									     aux_2153 = CAR(aux_2154);
									  }
									  obj_1494 = (local_t) (aux_2153);
								       }
								       aux_2152 = (((local_t) CREF(obj_1494))->access);
								    }
								    test_2151 = (aux_2152 == aux_2159);
								 }
								 if (test_2151)
								   {
								      obj_t aux_2169;
								      obj_t aux_2162;
								      aux_2169 = CNST_TABLE_REF(((long) 1));
								      {
									 local_t obj_1499;
									 {
									    obj_t aux_2163;
									    {
									       obj_t aux_2164;
									       aux_2164 = CAR(bindings2_1270);
									       aux_2163 = CAR(aux_2164);
									    }
									    obj_1499 = (local_t) (aux_2163);
									 }
									 aux_2162 = (((local_t) CREF(obj_1499))->access);
								      }
								      test_2150 = (aux_2162 == aux_2169);
								   }
								 else
								   {
								      test_2150 = ((bool_t) 0);
								   }
							      }
							      if (test_2150)
								{
								   bool_t test1723_1276;
								   {
								      node_t aux_2178;
								      node_t aux_2172;
								      {
									 obj_t aux_2179;
									 {
									    obj_t aux_2180;
									    aux_2180 = CAR(bindings2_1270);
									    aux_2179 = CDR(aux_2180);
									 }
									 aux_2178 = (node_t) (aux_2179);
								      }
								      {
									 obj_t aux_2173;
									 {
									    obj_t aux_2174;
									    aux_2174 = CAR(bindings1_1269);
									    aux_2173 = CDR(aux_2174);
									 }
									 aux_2172 = (node_t) (aux_2173);
								      }
								      test1723_1276 = same_node__38_reduce_same(aux_2172, aux_2178, alias_3);
								   }
								   if (test1723_1276)
								     {
									{
									   obj_t bindings2_2188;
									   obj_t bindings1_2186;
									   bindings1_2186 = CDR(bindings1_1269);
									   bindings2_2188 = CDR(bindings2_1270);
									   bindings2_1270 = bindings2_2188;
									   bindings1_1269 = bindings1_2186;
									   goto loop_1271;
									}
								     }
								   else
								     {
									aux_2147 = ((bool_t) 0);
								     }
								}
							      else
								{
								   aux_2147 = ((bool_t) 0);
								}
							   }
							 aux_1612 = BBOOL(aux_2147);
						      }
						   }
						 else
						   {
						      aux_1612 = BFALSE;
						   }
					      }
					   }
					 else
					   {
					      aux_1612 = BFALSE;
					   }
				      }
				    else
				      {
					 aux_1612 = BFALSE;
				      }
				 }
			       else
				 {
				    aux_1612 = BFALSE;
				 }
			    }
			 }
			 break;
		      default:
		       case_else1487_91_1021:
			 if (PROCEDUREP(method1481_1017))
			   {
			      aux_1612 = PROCEDURE_ENTRY(method1481_1017) (method1481_1017, (obj_t) (node1_1), (obj_t) (node2_2), alias_3, BEOA);
			   }
			 else
			   {
			      obj_t fun1329_678;
			      fun1329_678 = PROCEDURE_REF(same_node__env_162_reduce_same, ((long) 0));
			      aux_1612 = PROCEDURE_ENTRY(fun1329_678) (fun1329_678, (obj_t) (node1_1), (obj_t) (node2_2), alias_3, BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1487_91_1021;
		 }
	    }
	    return CBOOL(aux_1612);
	 }
      }
   }
}


obj_t 
_same_node__185_reduce_same(obj_t env_1537, obj_t node1_1538, obj_t node2_1539, obj_t alias_1540)
{
   {
      bool_t aux_2208;
      aux_2208 = same_node__38_reduce_same((node_t) (node1_1538), (node_t) (node2_1539), alias_1540);
      return BBOOL(aux_2208);
   }
}


bool_t 
same_node___136_reduce_same(obj_t node1_43, obj_t node2_44, obj_t alias_45)
{
 same_node___136_reduce_same:
   if (NULLP(node1_43))
     {
	return NULLP(node2_44);
     }
   else
     {
	if (NULLP(node2_44))
	  {
	     return ((bool_t) 0);
	  }
	else
	  {
	     bool_t test1332_681;
	     {
		node_t aux_2222;
		node_t aux_2218;
		{
		   obj_t aux_2223;
		   aux_2223 = CAR(node2_44);
		   aux_2222 = (node_t) (aux_2223);
		}
		{
		   obj_t aux_2219;
		   aux_2219 = CAR(node1_43);
		   aux_2218 = (node_t) (aux_2219);
		}
		test1332_681 = same_node__38_reduce_same(aux_2218, aux_2222, alias_45);
	     }
	     if (test1332_681)
	       {
		  {
		     obj_t node2_2230;
		     obj_t node1_2228;
		     node1_2228 = CDR(node1_43);
		     node2_2230 = CDR(node2_44);
		     node2_44 = node2_2230;
		     node1_43 = node1_2228;
		     goto same_node___136_reduce_same;
		  }
	       }
	     else
	       {
		  return ((bool_t) 0);
	       }
	  }
     }
}


bool_t 
aliased__149_reduce_same(variable_t var1_46, variable_t var2_47, obj_t alias_48)
{
   {
      obj_t alias_686;
      alias_686 = alias_48;
    loop_687:
      if (NULLP(alias_686))
	{
	   return ((bool_t) 0);
	}
      else
	{
	   bool_t test_2234;
	   {
	      obj_t aux_2239;
	      obj_t aux_2235;
	      aux_2239 = (obj_t) (var1_46);
	      {
		 obj_t aux_2236;
		 aux_2236 = CAR(alias_686);
		 aux_2235 = CAR(aux_2236);
	      }
	      test_2234 = (aux_2235 == aux_2239);
	   }
	   if (test_2234)
	     {
		{
		   bool_t test_2242;
		   {
		      obj_t aux_2247;
		      obj_t aux_2243;
		      aux_2247 = (obj_t) (var2_47);
		      {
			 obj_t aux_2244;
			 aux_2244 = CAR(alias_686);
			 aux_2243 = CDR(aux_2244);
		      }
		      test_2242 = (aux_2243 == aux_2247);
		   }
		   if (test_2242)
		     {
			return ((bool_t) 1);
		     }
		   else
		     {
			obj_t alias_2250;
			alias_2250 = CDR(alias_686);
			alias_686 = alias_2250;
			goto loop_687;
		     }
		}
	     }
	   else
	     {
		bool_t test_2252;
		{
		   obj_t aux_2257;
		   obj_t aux_2253;
		   aux_2257 = (obj_t) (var2_47);
		   {
		      obj_t aux_2254;
		      aux_2254 = CAR(alias_686);
		      aux_2253 = CAR(aux_2254);
		   }
		   test_2252 = (aux_2253 == aux_2257);
		}
		if (test_2252)
		  {
		     {
			bool_t test_2260;
			{
			   obj_t aux_2265;
			   obj_t aux_2261;
			   aux_2265 = (obj_t) (var1_46);
			   {
			      obj_t aux_2262;
			      aux_2262 = CAR(alias_686);
			      aux_2261 = CDR(aux_2262);
			   }
			   test_2260 = (aux_2261 == aux_2265);
			}
			if (test_2260)
			  {
			     return ((bool_t) 1);
			  }
			else
			  {
			     obj_t alias_2268;
			     alias_2268 = CDR(alias_686);
			     alias_686 = alias_2268;
			     goto loop_687;
			  }
		     }
		  }
		else
		  {
		     {
			obj_t alias_2270;
			alias_2270 = CDR(alias_686);
			alias_686 = alias_2270;
			goto loop_687;
		     }
		  }
	     }
	}
   }
}


obj_t 
imported_modules_init_94_reduce_same()
{
   module_initialization_70_tools_trace(((long) 0), "REDUCE_SAME");
   module_initialization_70_tools_shape(((long) 0), "REDUCE_SAME");
   module_initialization_70_type_type(((long) 0), "REDUCE_SAME");
   module_initialization_70_ast_var(((long) 0), "REDUCE_SAME");
   return module_initialization_70_ast_node(((long) 0), "REDUCE_SAME");
}
