/*===========================================================================*/
/*   (Reduce/typec.scm)                                                      */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;


extern obj_t lvtype_node__58_ast_lvtype(node_t);
extern obj_t let_fun_218_ast_node;
extern obj_t type_type_type;
extern node_t coerce__182_coerce_coerce(node_t, type_t);
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern bool_t type_subclass__90_object_class(type_t, type_t);
extern obj_t closure_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_reduce_typec();
extern obj_t module_initialization_70_reduce_typec(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t toplevel_init_63_reduce_typec();
static obj_t node_typec___130_reduce_typec(obj_t);
static obj_t cnst_init_137_reduce_typec();
extern obj_t reduce_type_check__95_reduce_typec(obj_t);
static obj_t require_initialization_114_reduce_typec = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t print_trace_107_tools_trace(obj_t);
static obj_t library_modules_init_112_reduce_typec();
extern obj_t cast_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t pragma_ast_node;
static node_t node_typec__103_reduce_typec(node_t);
extern long class_num_218___object(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t set_ex_it_116_ast_node;
static node_t node_typec__default1319_133_reduce_typec(node_t);
extern type_t typeof_coerce_typeof(node_t);
extern obj_t kwote_ast_node;
extern bool_t side_effect__165_effect_effect(node_t);
static obj_t _node_typec__214_reduce_typec(obj_t, obj_t);
static long __type_checks_removed__34_reduce_typec;
extern obj_t box_ref_242_ast_node;
extern obj_t funcall_ast_node;
extern obj_t __obj__252_type_cache;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t _reduce_type_check__78_reduce_typec(obj_t, obj_t);
static obj_t _node_typec__default1319_157_reduce_typec(obj_t, obj_t);
static long __type_checks_remaining__47_reduce_typec;
extern obj_t app_ast_node;
static obj_t __cnst[3];

DEFINE_STRING(string1680_reduce_typec, string1680_reduce_typec1686, "DONE REDUCE NODE-TYPEC!-DEFAULT1319 ", 36);
DEFINE_STRING(string1674_reduce_typec, string1674_reduce_typec1687, ")\t", 2);
DEFINE_EXPORT_PROCEDURE(reduce_type_check__env_147_reduce_typec, _reduce_type_check__78_reduce_typec1688, _reduce_type_check__78_reduce_typec, 0L, 1);
DEFINE_STRING(string1676_reduce_typec, string1676_reduce_typec1689, "(remaining : ", 13);
DEFINE_STRING(string1677_reduce_typec, string1677_reduce_typec1690, "No method for this object", 25);
DEFINE_STRING(string1675_reduce_typec, string1675_reduce_typec1691, "(removed : ", 11);
DEFINE_STATIC_PROCEDURE(node_typec__default1319_env_248_reduce_typec, _node_typec__default1319_157_reduce_typec1692, _node_typec__default1319_157_reduce_typec, 0L, 1);
DEFINE_STRING(string1673_reduce_typec, string1673_reduce_typec1693, "      type check             ", 29);
DEFINE_STATIC_GENERIC(node_typec__env_21_reduce_typec, _node_typec__214_reduce_typec1694, _node_typec__214_reduce_typec, 0L, 1);
DEFINE_STRING(string1679_reduce_typec, string1679_reduce_typec1695, "Je reduis: ", 11);
DEFINE_STRING(string1678_reduce_typec, string1678_reduce_typec1696, " en: ", 5);

obj_t 
module_initialization_70_reduce_typec(long checksum_1512, char *from_1513)
{
   if (CBOOL(require_initialization_114_reduce_typec))
     {
	require_initialization_114_reduce_typec = BBOOL(((bool_t) 0));
	library_modules_init_112_reduce_typec();
	cnst_init_137_reduce_typec();
	imported_modules_init_94_reduce_typec();
	toplevel_init_63_reduce_typec();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_reduce_typec()
{
   module_initialization_70___object(((long) 0), "REDUCE_TYPEC");
   module_initialization_70___reader(((long) 0), "REDUCE_TYPEC");
   return BUNSPEC;
}


obj_t 
cnst_init_137_reduce_typec()
{
   {
      obj_t cnst_port_138_1504;
      cnst_port_138_1504 = open_input_string(string1680_reduce_typec);
      {
	 long i_1505;
	 i_1505 = ((long) 2);
       loop_1506:
	 {
	    bool_t test1681_1507;
	    test1681_1507 = (i_1505 == ((long) -1));
	    if (test1681_1507)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1682_1508;
		    {
		       obj_t list1683_1509;
		       {
			  obj_t arg1684_1510;
			  arg1684_1510 = BNIL;
			  list1683_1509 = MAKE_PAIR(cnst_port_138_1504, arg1684_1510);
		       }
		       arg1682_1508 = read___reader(list1683_1509);
		    }
		    CNST_TABLE_SET(i_1505, arg1682_1508);
		 }
		 {
		    int aux_1511;
		    {
		       long aux_1529;
		       aux_1529 = (i_1505 - ((long) 1));
		       aux_1511 = (int) (aux_1529);
		    }
		    {
		       long i_1532;
		       i_1532 = (long) (aux_1511);
		       i_1505 = i_1532;
		       goto loop_1506;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_reduce_typec()
{
   __type_checks_remaining__47_reduce_typec = ((long) 0);
   __type_checks_removed__34_reduce_typec = ((long) 0);
   add_generic__110___object(node_typec__env_21_reduce_typec, node_typec__default1319_env_248_reduce_typec);
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, var_ast_node, ((long) 2));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, app_ly_162_ast_node, ((long) 5));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, funcall_ast_node, ((long) 6));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, pragma_ast_node, ((long) 7));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, cast_ast_node, ((long) 8));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, setq_ast_node, ((long) 9));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, conditional_ast_node, ((long) 10));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, fail_ast_node, ((long) 11));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, select_ast_node, ((long) 12));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, let_fun_218_ast_node, ((long) 13));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, let_var_6_ast_node, ((long) 14));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, set_ex_it_116_ast_node, ((long) 15));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, jump_ex_it_184_ast_node, ((long) 16));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, make_box_202_ast_node, ((long) 17));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, box_set__221_ast_node, ((long) 18));
   add_inlined_method__244___object(node_typec__env_21_reduce_typec, box_ref_242_ast_node, ((long) 19));
   {
      long aux_1555;
      aux_1555 = add_inlined_method__244___object(node_typec__env_21_reduce_typec, app_ast_node, ((long) 20));
      return BINT(aux_1555);
   }
}


obj_t 
reduce_type_check__95_reduce_typec(obj_t globals_1)
{
   {
      obj_t list1343_724;
      list1343_724 = MAKE_PAIR(string1673_reduce_typec, BNIL);
      verbose_tools_speek(BINT(((long) 2)), list1343_724);
   }
   {
      obj_t l1291_727;
      l1291_727 = globals_1;
    lname1292_728:
      if (PAIRP(l1291_727))
	{
	   {
	      value_t fun_731;
	      {
		 global_t obj_1250;
		 {
		    obj_t aux_1563;
		    aux_1563 = CAR(l1291_727);
		    obj_1250 = (global_t) (aux_1563);
		 }
		 fun_731 = (((global_t) CREF(obj_1250))->value);
	      }
	      {
		 {
		    node_t arg1349_733;
		    {
		       node_t aux_1567;
		       {
			  obj_t aux_1568;
			  {
			     sfun_t obj_1251;
			     obj_1251 = (sfun_t) (fun_731);
			     aux_1568 = (((sfun_t) CREF(obj_1251))->body);
			  }
			  aux_1567 = (node_t) (aux_1568);
		       }
		       arg1349_733 = node_typec__103_reduce_typec(aux_1567);
		    }
		    {
		       obj_t res1647_1254;
		       {
			  sfun_t obj_1252;
			  obj_t val1078_1253;
			  obj_1252 = (sfun_t) (fun_731);
			  val1078_1253 = (obj_t) (arg1349_733);
			  {
			     obj_t x_1480;
			     x_1480 = ((((sfun_t) CREF(obj_1252))->body) = ((obj_t) val1078_1253), BUNSPEC);
			     res1647_1254 = BUNSPEC;
			  }
		       }
		       res1647_1254;
		    }
		 }
		 BUNSPEC;
	      }
	   }
	   {
	      obj_t l1291_1576;
	      l1291_1576 = CDR(l1291_727);
	      l1291_727 = l1291_1576;
	      goto lname1292_728;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      obj_t list1351_735;
      {
	 obj_t arg1353_737;
	 {
	    obj_t arg1355_738;
	    arg1355_738 = MAKE_PAIR(string1674_reduce_typec, BNIL);
	    {
	       obj_t aux_1579;
	       aux_1579 = BINT(__type_checks_removed__34_reduce_typec);
	       arg1353_737 = MAKE_PAIR(aux_1579, arg1355_738);
	    }
	 }
	 list1351_735 = MAKE_PAIR(string1675_reduce_typec, arg1353_737);
      }
      verbose_tools_speek(BINT(((long) 2)), list1351_735);
   }
   {
      obj_t list1358_741;
      {
	 obj_t arg1361_743;
	 {
	    obj_t arg1363_744;
	    {
	       obj_t arg1364_745;
	       {
		  obj_t aux_1585;
		  aux_1585 = BCHAR(((unsigned char) '\n'));
		  arg1364_745 = MAKE_PAIR(aux_1585, BNIL);
	       }
	       {
		  obj_t aux_1588;
		  aux_1588 = BCHAR(((unsigned char) ')'));
		  arg1363_744 = MAKE_PAIR(aux_1588, arg1364_745);
	       }
	    }
	    {
	       obj_t aux_1591;
	       aux_1591 = BINT(__type_checks_remaining__47_reduce_typec);
	       arg1361_743 = MAKE_PAIR(aux_1591, arg1363_744);
	    }
	 }
	 list1358_741 = MAKE_PAIR(string1676_reduce_typec, arg1361_743);
      }
      verbose_tools_speek(BINT(((long) 2)), list1358_741);
   }
   return globals_1;
}


obj_t 
_reduce_type_check__78_reduce_typec(obj_t env_1478, obj_t globals_1479)
{
   return reduce_type_check__95_reduce_typec(globals_1479);
}


node_t 
node_typec__default1319_133_reduce_typec(node_t node_3)
{
   FAILURE(CNST_TABLE_REF(((long) 0)), string1677_reduce_typec, (obj_t) (node_3));
}


obj_t 
_node_typec__default1319_157_reduce_typec(obj_t env_1476, obj_t node_1477)
{
   {
      node_t aux_1601;
      aux_1601 = node_typec__default1319_133_reduce_typec((node_t) (node_1477));
      return (obj_t) (aux_1601);
   }
}


node_t 
node_typec__103_reduce_typec(node_t node_2)
{
   {
      obj_t method1502_1082;
      obj_t class1507_1083;
      {
	 obj_t arg1510_1080;
	 obj_t arg1511_1081;
	 {
	    object_t obj_1261;
	    obj_1261 = (object_t) (node_2);
	    {
	       obj_t pre_method_105_1262;
	       pre_method_105_1262 = PROCEDURE_REF(node_typec__env_21_reduce_typec, ((long) 2));
	       if (INTEGERP(pre_method_105_1262))
		 {
		    PROCEDURE_SET(node_typec__env_21_reduce_typec, ((long) 2), BUNSPEC);
		    arg1510_1080 = pre_method_105_1262;
		 }
	       else
		 {
		    long obj_class_num_177_1267;
		    obj_class_num_177_1267 = TYPE(obj_1261);
		    {
		       obj_t arg1183_1268;
		       arg1183_1268 = PROCEDURE_REF(node_typec__env_21_reduce_typec, ((long) 1));
		       {
			  long arg1184_1272;
			  {
			     long arg1186_1273;
			     arg1186_1273 = OBJECT_TYPE;
			     arg1184_1272 = (obj_class_num_177_1267 - arg1186_1273);
			  }
			  arg1510_1080 = VECTOR_REF(arg1183_1268, arg1184_1272);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1278;
	    object_1278 = (object_t) (node_2);
	    {
	       long arg1187_1279;
	       {
		  long arg1188_1280;
		  long arg1189_1281;
		  arg1188_1280 = TYPE(object_1278);
		  arg1189_1281 = OBJECT_TYPE;
		  arg1187_1279 = (arg1188_1280 - arg1189_1281);
	       }
	       {
		  obj_t vector_1285;
		  vector_1285 = __classes__134___object;
		  arg1511_1081 = VECTOR_REF(vector_1285, arg1187_1279);
	       }
	    }
	 }
	 {
	    obj_t aux_1620;
	    method1502_1082 = arg1510_1080;
	    class1507_1083 = arg1511_1081;
	    {
	       if (INTEGERP(method1502_1082))
		 {
		    switch ((long) CINT(method1502_1082))
		      {
		      case ((long) 0):
			 {
			    atom_t aux_1623;
			    aux_1623 = (atom_t) (node_2);
			    aux_1620 = (obj_t) (aux_1623);
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t aux_1626;
			    aux_1626 = (kwote_t) (node_2);
			    aux_1620 = (obj_t) (aux_1626);
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t aux_1629;
			    aux_1629 = (var_t) (node_2);
			    aux_1620 = (obj_t) (aux_1629);
			 }
			 break;
		      case ((long) 3):
			 {
			    closure_t aux_1632;
			    aux_1632 = (closure_t) (node_2);
			    aux_1620 = (obj_t) (aux_1632);
			 }
			 break;
		      case ((long) 4):
			 {
			    sequence_t node_1093;
			    node_1093 = (sequence_t) (node_2);
			    node_typec___130_reduce_typec((((sequence_t) CREF(node_1093))->nodes));
			    aux_1620 = (obj_t) (node_1093);
			 }
			 break;
		      case ((long) 5):
			 {
			    app_ly_162_t node_1096;
			    node_1096 = (app_ly_162_t) (node_2);
			    {
			       node_t arg1517_1098;
			       arg1517_1098 = node_typec__103_reduce_typec((((app_ly_162_t) CREF(node_1096))->fun));
			       {
				  obj_t res1648_1291;
				  {
				     obj_t x_1481;
				     x_1481 = ((((app_ly_162_t) CREF(node_1096))->fun) = ((node_t) arg1517_1098), BUNSPEC);
				     res1648_1291 = BUNSPEC;
				  }
				  res1648_1291;
			       }
			    }
			    {
			       node_t arg1520_1100;
			       arg1520_1100 = node_typec__103_reduce_typec((((app_ly_162_t) CREF(node_1096))->arg));
			       {
				  obj_t res1649_1295;
				  {
				     obj_t x_1482;
				     x_1482 = ((((app_ly_162_t) CREF(node_1096))->arg) = ((node_t) arg1520_1100), BUNSPEC);
				     res1649_1295 = BUNSPEC;
				  }
				  res1649_1295;
			       }
			    }
			    aux_1620 = (obj_t) (node_1096);
			 }
			 break;
		      case ((long) 6):
			 {
			    funcall_t node_1102;
			    node_1102 = (funcall_t) (node_2);
			    {
			       node_t arg1523_1104;
			       arg1523_1104 = node_typec__103_reduce_typec((((funcall_t) CREF(node_1102))->fun));
			       {
				  obj_t res1650_1299;
				  {
				     obj_t x_1483;
				     x_1483 = ((((funcall_t) CREF(node_1102))->fun) = ((node_t) arg1523_1104), BUNSPEC);
				     res1650_1299 = BUNSPEC;
				  }
				  res1650_1299;
			       }
			    }
			    node_typec___130_reduce_typec((((funcall_t) CREF(node_1102))->args));
			    aux_1620 = (obj_t) (node_1102);
			 }
			 break;
		      case ((long) 7):
			 {
			    pragma_t node_1107;
			    node_1107 = (pragma_t) (node_2);
			    node_typec___130_reduce_typec((((pragma_t) CREF(node_1107))->args));
			    aux_1620 = (obj_t) (node_1107);
			 }
			 break;
		      case ((long) 8):
			 {
			    cast_t node_1110;
			    node_1110 = (cast_t) (node_2);
			    node_typec__103_reduce_typec((((cast_t) CREF(node_1110))->arg));
			    aux_1620 = (obj_t) (node_1110);
			 }
			 break;
		      case ((long) 9):
			 {
			    setq_t node_1113;
			    node_1113 = (setq_t) (node_2);
			    {
			       node_t arg1532_1115;
			       arg1532_1115 = node_typec__103_reduce_typec((((setq_t) CREF(node_1113))->value));
			       {
				  obj_t res1651_1306;
				  {
				     obj_t x_1484;
				     x_1484 = ((((setq_t) CREF(node_1113))->value) = ((node_t) arg1532_1115), BUNSPEC);
				     res1651_1306 = BUNSPEC;
				  }
				  res1651_1306;
			       }
			    }
			    {
			       node_t arg1535_1117;
			       {
				  node_t aux_1666;
				  {
				     var_t aux_1667;
				     aux_1667 = (((setq_t) CREF(node_1113))->var);
				     aux_1666 = (node_t) (aux_1667);
				  }
				  arg1535_1117 = node_typec__103_reduce_typec(aux_1666);
			       }
			       {
				  obj_t res1652_1310;
				  {
				     var_t val1192_1309;
				     val1192_1309 = (var_t) (arg1535_1117);
				     {
					obj_t x_1485;
					x_1485 = ((((setq_t) CREF(node_1113))->var) = ((var_t) val1192_1309), BUNSPEC);
					res1652_1310 = BUNSPEC;
				     }
				  }
				  res1652_1310;
			       }
			    }
			    aux_1620 = (obj_t) (node_1113);
			 }
			 break;
		      case ((long) 10):
			 {
			    conditional_t node_1119;
			    node_1119 = (conditional_t) (node_2);
			    {
			       node_t arg1537_1121;
			       arg1537_1121 = node_typec__103_reduce_typec((((conditional_t) CREF(node_1119))->test));
			       {
				  obj_t res1653_1314;
				  {
				     obj_t x_1486;
				     x_1486 = ((((conditional_t) CREF(node_1119))->test) = ((node_t) arg1537_1121), BUNSPEC);
				     res1653_1314 = BUNSPEC;
				  }
				  res1653_1314;
			       }
			    }
			    {
			       node_t arg1539_1123;
			       arg1539_1123 = node_typec__103_reduce_typec((((conditional_t) CREF(node_1119))->true));
			       {
				  obj_t res1654_1318;
				  {
				     obj_t x_1487;
				     x_1487 = ((((conditional_t) CREF(node_1119))->true) = ((node_t) arg1539_1123), BUNSPEC);
				     res1654_1318 = BUNSPEC;
				  }
				  res1654_1318;
			       }
			    }
			    {
			       node_t arg1541_1125;
			       arg1541_1125 = node_typec__103_reduce_typec((((conditional_t) CREF(node_1119))->false));
			       {
				  obj_t res1655_1322;
				  {
				     obj_t x_1488;
				     x_1488 = ((((conditional_t) CREF(node_1119))->false) = ((node_t) arg1541_1125), BUNSPEC);
				     res1655_1322 = BUNSPEC;
				  }
				  res1655_1322;
			       }
			    }
			    aux_1620 = (obj_t) (node_1119);
			 }
			 break;
		      case ((long) 11):
			 {
			    fail_t node_1127;
			    node_1127 = (fail_t) (node_2);
			    {
			       node_t arg1543_1129;
			       arg1543_1129 = node_typec__103_reduce_typec((((fail_t) CREF(node_1127))->proc));
			       {
				  obj_t res1656_1326;
				  {
				     obj_t x_1489;
				     x_1489 = ((((fail_t) CREF(node_1127))->proc) = ((node_t) arg1543_1129), BUNSPEC);
				     res1656_1326 = BUNSPEC;
				  }
				  res1656_1326;
			       }
			    }
			    {
			       node_t arg1549_1131;
			       arg1549_1131 = node_typec__103_reduce_typec((((fail_t) CREF(node_1127))->msg));
			       {
				  obj_t res1657_1330;
				  {
				     obj_t x_1490;
				     x_1490 = ((((fail_t) CREF(node_1127))->msg) = ((node_t) arg1549_1131), BUNSPEC);
				     res1657_1330 = BUNSPEC;
				  }
				  res1657_1330;
			       }
			    }
			    {
			       node_t arg1551_1133;
			       arg1551_1133 = node_typec__103_reduce_typec((((fail_t) CREF(node_1127))->obj));
			       {
				  obj_t res1658_1334;
				  {
				     obj_t x_1491;
				     x_1491 = ((((fail_t) CREF(node_1127))->obj) = ((node_t) arg1551_1133), BUNSPEC);
				     res1658_1334 = BUNSPEC;
				  }
				  res1658_1334;
			       }
			    }
			    aux_1620 = (obj_t) (node_1127);
			 }
			 break;
		      case ((long) 12):
			 {
			    select_t node_1135;
			    node_1135 = (select_t) (node_2);
			    {
			       node_t arg1553_1137;
			       arg1553_1137 = node_typec__103_reduce_typec((((select_t) CREF(node_1135))->test));
			       {
				  obj_t res1659_1338;
				  {
				     obj_t x_1492;
				     x_1492 = ((((select_t) CREF(node_1135))->test) = ((node_t) arg1553_1137), BUNSPEC);
				     res1659_1338 = BUNSPEC;
				  }
				  res1659_1338;
			       }
			    }
			    {
			       obj_t l1302_1139;
			       l1302_1139 = (((select_t) CREF(node_1135))->clauses);
			     lname1304_1140:
			       if (PAIRP(l1302_1139))
				 {
				    {
				       obj_t clause_1143;
				       clause_1143 = CAR(l1302_1139);
				       {
					  node_t arg1557_1144;
					  {
					     node_t aux_1703;
					     {
						obj_t aux_1704;
						aux_1704 = CDR(clause_1143);
						aux_1703 = (node_t) (aux_1704);
					     }
					     arg1557_1144 = node_typec__103_reduce_typec(aux_1703);
					  }
					  {
					     obj_t aux_1708;
					     aux_1708 = (obj_t) (arg1557_1144);
					     SET_CDR(clause_1143, aux_1708);
					  }
				       }
				    }
				    {
				       obj_t l1302_1711;
				       l1302_1711 = CDR(l1302_1139);
				       l1302_1139 = l1302_1711;
				       goto lname1304_1140;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_1620 = (obj_t) (node_1135);
			 }
			 break;
		      case ((long) 13):
			 {
			    let_fun_218_t node_1147;
			    node_1147 = (let_fun_218_t) (node_2);
			    {
			       obj_t l1306_1149;
			       l1306_1149 = (((let_fun_218_t) CREF(node_1147))->locals);
			     lname1307_1150:
			       if (PAIRP(l1306_1149))
				 {
				    {
				       value_t fun_1154;
				       {
					  local_t obj_1349;
					  {
					     obj_t aux_1718;
					     aux_1718 = CAR(l1306_1149);
					     obj_1349 = (local_t) (aux_1718);
					  }
					  fun_1154 = (((local_t) CREF(obj_1349))->value);
				       }
				       {
					  node_t arg1563_1155;
					  {
					     node_t aux_1722;
					     {
						obj_t aux_1723;
						{
						   sfun_t obj_1350;
						   obj_1350 = (sfun_t) (fun_1154);
						   aux_1723 = (((sfun_t) CREF(obj_1350))->body);
						}
						aux_1722 = (node_t) (aux_1723);
					     }
					     arg1563_1155 = node_typec__103_reduce_typec(aux_1722);
					  }
					  {
					     obj_t res1660_1353;
					     {
						sfun_t obj_1351;
						obj_t val1078_1352;
						obj_1351 = (sfun_t) (fun_1154);
						val1078_1352 = (obj_t) (arg1563_1155);
						{
						   obj_t x_1493;
						   x_1493 = ((((sfun_t) CREF(obj_1351))->body) = ((obj_t) val1078_1352), BUNSPEC);
						   res1660_1353 = BUNSPEC;
						}
					     }
					     res1660_1353;
					  }
				       }
				    }
				    {
				       obj_t l1306_1731;
				       l1306_1731 = CDR(l1306_1149);
				       l1306_1149 = l1306_1731;
				       goto lname1307_1150;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1566_1158;
			       arg1566_1158 = node_typec__103_reduce_typec((((let_fun_218_t) CREF(node_1147))->body));
			       {
				  obj_t res1661_1358;
				  {
				     obj_t x_1494;
				     x_1494 = ((((let_fun_218_t) CREF(node_1147))->body) = ((node_t) arg1566_1158), BUNSPEC);
				     res1661_1358 = BUNSPEC;
				  }
				  res1661_1358;
			       }
			    }
			    aux_1620 = (obj_t) (node_1147);
			 }
			 break;
		      case ((long) 14):
			 {
			    let_var_6_t node_1160;
			    node_1160 = (let_var_6_t) (node_2);
			    {
			       obj_t l1309_1162;
			       l1309_1162 = (((let_var_6_t) CREF(node_1160))->bindings);
			     lname1311_1163:
			       if (PAIRP(l1309_1162))
				 {
				    {
				       obj_t binding_1166;
				       binding_1166 = CAR(l1309_1162);
				       {
					  node_t arg1570_1167;
					  {
					     node_t aux_1742;
					     {
						obj_t aux_1743;
						aux_1743 = CDR(binding_1166);
						aux_1742 = (node_t) (aux_1743);
					     }
					     arg1570_1167 = node_typec__103_reduce_typec(aux_1742);
					  }
					  {
					     obj_t aux_1747;
					     aux_1747 = (obj_t) (arg1570_1167);
					     SET_CDR(binding_1166, aux_1747);
					  }
				       }
				    }
				    {
				       obj_t l1309_1750;
				       l1309_1750 = CDR(l1309_1162);
				       l1309_1162 = l1309_1750;
				       goto lname1311_1163;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1573_1170;
			       arg1573_1170 = node_typec__103_reduce_typec((((let_var_6_t) CREF(node_1160))->body));
			       {
				  obj_t res1662_1369;
				  {
				     obj_t x_1495;
				     x_1495 = ((((let_var_6_t) CREF(node_1160))->body) = ((node_t) arg1573_1170), BUNSPEC);
				     res1662_1369 = BUNSPEC;
				  }
				  res1662_1369;
			       }
			    }
			    aux_1620 = (obj_t) (node_1160);
			 }
			 break;
		      case ((long) 15):
			 {
			    set_ex_it_116_t node_1172;
			    node_1172 = (set_ex_it_116_t) (node_2);
			    {
			       node_t arg1575_1174;
			       arg1575_1174 = node_typec__103_reduce_typec((((set_ex_it_116_t) CREF(node_1172))->body));
			       {
				  obj_t res1663_1373;
				  {
				     obj_t x_1496;
				     x_1496 = ((((set_ex_it_116_t) CREF(node_1172))->body) = ((node_t) arg1575_1174), BUNSPEC);
				     res1663_1373 = BUNSPEC;
				  }
				  res1663_1373;
			       }
			    }
			    {
			       node_t arg1577_1176;
			       {
				  node_t aux_1761;
				  {
				     var_t aux_1762;
				     aux_1762 = (((set_ex_it_116_t) CREF(node_1172))->var);
				     aux_1761 = (node_t) (aux_1762);
				  }
				  arg1577_1176 = node_typec__103_reduce_typec(aux_1761);
			       }
			       {
				  obj_t res1664_1377;
				  {
				     var_t val1241_1376;
				     val1241_1376 = (var_t) (arg1577_1176);
				     {
					obj_t x_1497;
					x_1497 = ((((set_ex_it_116_t) CREF(node_1172))->var) = ((var_t) val1241_1376), BUNSPEC);
					res1664_1377 = BUNSPEC;
				     }
				  }
				  res1664_1377;
			       }
			    }
			    aux_1620 = (obj_t) (node_1172);
			 }
			 break;
		      case ((long) 16):
			 {
			    jump_ex_it_184_t node_1178;
			    node_1178 = (jump_ex_it_184_t) (node_2);
			    {
			       node_t arg1579_1180;
			       arg1579_1180 = node_typec__103_reduce_typec((((jump_ex_it_184_t) CREF(node_1178))->exit));
			       {
				  obj_t res1665_1381;
				  {
				     obj_t x_1498;
				     x_1498 = ((((jump_ex_it_184_t) CREF(node_1178))->exit) = ((node_t) arg1579_1180), BUNSPEC);
				     res1665_1381 = BUNSPEC;
				  }
				  res1665_1381;
			       }
			    }
			    {
			       node_t arg1583_1182;
			       arg1583_1182 = node_typec__103_reduce_typec((((jump_ex_it_184_t) CREF(node_1178))->value));
			       {
				  obj_t res1666_1385;
				  {
				     obj_t x_1499;
				     x_1499 = ((((jump_ex_it_184_t) CREF(node_1178))->value) = ((node_t) arg1583_1182), BUNSPEC);
				     res1666_1385 = BUNSPEC;
				  }
				  res1666_1385;
			       }
			    }
			    aux_1620 = (obj_t) (node_1178);
			 }
			 break;
		      case ((long) 17):
			 {
			    make_box_202_t node_1184;
			    node_1184 = (make_box_202_t) (node_2);
			    {
			       node_t arg1585_1186;
			       arg1585_1186 = node_typec__103_reduce_typec((((make_box_202_t) CREF(node_1184))->value));
			       {
				  obj_t res1667_1389;
				  {
				     obj_t x_1500;
				     x_1500 = ((((make_box_202_t) CREF(node_1184))->value) = ((node_t) arg1585_1186), BUNSPEC);
				     res1667_1389 = BUNSPEC;
				  }
				  res1667_1389;
			       }
			    }
			    aux_1620 = (obj_t) (node_1184);
			 }
			 break;
		      case ((long) 18):
			 {
			    box_set__221_t node_1188;
			    node_1188 = (box_set__221_t) (node_2);
			    {
			       node_t arg1588_1190;
			       {
				  node_t aux_1783;
				  {
				     var_t aux_1784;
				     aux_1784 = (((box_set__221_t) CREF(node_1188))->var);
				     aux_1783 = (node_t) (aux_1784);
				  }
				  arg1588_1190 = node_typec__103_reduce_typec(aux_1783);
			       }
			       {
				  obj_t res1668_1393;
				  {
				     var_t val1269_1392;
				     val1269_1392 = (var_t) (arg1588_1190);
				     {
					obj_t x_1501;
					x_1501 = ((((box_set__221_t) CREF(node_1188))->var) = ((var_t) val1269_1392), BUNSPEC);
					res1668_1393 = BUNSPEC;
				     }
				  }
				  res1668_1393;
			       }
			    }
			    {
			       node_t arg1590_1192;
			       arg1590_1192 = node_typec__103_reduce_typec((((box_set__221_t) CREF(node_1188))->value));
			       {
				  obj_t res1669_1397;
				  {
				     obj_t x_1502;
				     x_1502 = ((((box_set__221_t) CREF(node_1188))->value) = ((node_t) arg1590_1192), BUNSPEC);
				     res1669_1397 = BUNSPEC;
				  }
				  res1669_1397;
			       }
			    }
			    aux_1620 = (obj_t) (node_1188);
			 }
			 break;
		      case ((long) 19):
			 {
			    box_ref_242_t node_1194;
			    node_1194 = (box_ref_242_t) (node_2);
			    {
			       node_t arg1592_1196;
			       {
				  node_t aux_1795;
				  {
				     var_t aux_1796;
				     aux_1796 = (((box_ref_242_t) CREF(node_1194))->var);
				     aux_1795 = (node_t) (aux_1796);
				  }
				  arg1592_1196 = node_typec__103_reduce_typec(aux_1795);
			       }
			       {
				  obj_t res1670_1401;
				  {
				     var_t val1263_1400;
				     val1263_1400 = (var_t) (arg1592_1196);
				     {
					obj_t x_1503;
					x_1503 = ((((box_ref_242_t) CREF(node_1194))->var) = ((var_t) val1263_1400), BUNSPEC);
					res1670_1401 = BUNSPEC;
				     }
				  }
				  res1670_1401;
			       }
			    }
			    aux_1620 = (obj_t) (node_1194);
			 }
			 break;
		      case ((long) 20):
			 {
			    app_t node_1198;
			    node_1198 = (app_t) (node_2);
			    node_typec___130_reduce_typec((((app_t) CREF(node_1198))->args));
			    {
			       variable_t var_1201;
			       {
				  var_t arg1641_1238;
				  arg1641_1238 = (((app_t) CREF(node_1198))->fun);
				  var_1201 = (((var_t) CREF(arg1641_1238))->variable);
			       }
			       {
				  obj_t typec_1202;
				  {
				     fun_t obj_1406;
				     {
					value_t aux_1808;
					aux_1808 = (((variable_t) CREF(var_1201))->value);
					obj_1406 = (fun_t) (aux_1808);
				     }
				     typec_1202 = (((fun_t) CREF(obj_1406))->predicate_of_78);
				  }
				  {
				     type_t type_1203;
				     type_1203 = typeof_coerce_typeof((node_t) (node_1198));
				     {
					{
					   bool_t test1596_1204;
					   {
					      bool_t test_1814;
					      {
						 obj_t aux_1815;
						 aux_1815 = (((app_t) CREF(node_1198))->args);
						 test_1814 = PAIRP(aux_1815);
					      }
					      if (test_1814)
						{
						   bool_t test_1818;
						   {
						      obj_t aux_1819;
						      {
							 obj_t aux_1820;
							 aux_1820 = (((app_t) CREF(node_1198))->args);
							 aux_1819 = CDR(aux_1820);
						      }
						      test_1818 = NULLP(aux_1819);
						   }
						   if (test_1818)
						     {
							bool_t test1626_1230;
							test1626_1230 = is_a__118___object(typec_1202, type_type_type);
							if (test1626_1230)
							  {
							     bool_t test1627_1231;
							     {
								node_t aux_1826;
								{
								   obj_t aux_1827;
								   {
								      obj_t aux_1828;
								      aux_1828 = (((app_t) CREF(node_1198))->args);
								      aux_1827 = CAR(aux_1828);
								   }
								   aux_1826 = (node_t) (aux_1827);
								}
								test1627_1231 = side_effect__165_effect_effect(aux_1826);
							     }
							     if (test1627_1231)
							       {
								  test1596_1204 = ((bool_t) 0);
							       }
							     else
							       {
								  test1596_1204 = ((bool_t) 1);
							       }
							  }
							else
							  {
							     test1596_1204 = ((bool_t) 0);
							  }
						     }
						   else
						     {
							test1596_1204 = ((bool_t) 0);
						     }
						}
					      else
						{
						   test1596_1204 = ((bool_t) 0);
						}
					   }
					   if (test1596_1204)
					     {
						type_t typep_1205;
						{
						   node_t aux_1835;
						   {
						      obj_t aux_1836;
						      {
							 obj_t aux_1837;
							 aux_1837 = (((app_t) CREF(node_1198))->args);
							 aux_1836 = CAR(aux_1837);
						      }
						      aux_1835 = (node_t) (aux_1836);
						   }
						   typep_1205 = typeof_coerce_typeof(aux_1835);
						}
						{
						   bool_t test1597_1206;
						   {
						      bool_t test1620_1225;
						      {
							 obj_t obj2_1418;
							 obj2_1418 = __obj__252_type_cache;
							 {
							    obj_t aux_1842;
							    aux_1842 = (obj_t) (typep_1205);
							    test1620_1225 = (aux_1842 == obj2_1418);
							 }
						      }
						      if (test1620_1225)
							{
							   test1597_1206 = ((bool_t) 1);
							}
						      else
							{
							   test1597_1206 = type_subclass__90_object_class((type_t) (typec_1202), typep_1205);
							}
						   }
						   if (test1597_1206)
						     {
							{
							   long z2_1420;
							   z2_1420 = __type_checks_remaining__47_reduce_typec;
							   __type_checks_remaining__47_reduce_typec = (((long) 1) + z2_1420);
							}
							aux_1620 = (obj_t) (node_1198);
						     }
						   else
						     {
							{
							   bool_t test1598_1207;
							   {
							      obj_t aux_1851;
							      aux_1851 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 1)), BINT(((long) 2)));
							      test1598_1207 = CBOOL(aux_1851);
							   }
							   if (test1598_1207)
							     {
								obj_t arg1601_1209;
								obj_t arg1604_1211;
								arg1601_1209 = shape_tools_shape((obj_t) (node_1198));
								arg1604_1211 = shape_tools_shape((obj_t) (type_1203));
								{
								   obj_t list1605_1212;
								   {
								      obj_t arg1606_1213;
								      {
									 obj_t arg1608_1214;
									 {
									    obj_t arg1609_1215;
									    {
									       obj_t arg1611_1216;
									       {
										  obj_t aux_1861;
										  aux_1861 = BCHAR(((unsigned char) '\n'));
										  arg1611_1216 = MAKE_PAIR(aux_1861, BNIL);
									       }
									       arg1609_1215 = MAKE_PAIR(arg1604_1211, arg1611_1216);
									    }
									    arg1608_1214 = MAKE_PAIR(string1678_reduce_typec, arg1609_1215);
									 }
									 arg1606_1213 = MAKE_PAIR(arg1601_1209, arg1608_1214);
								      }
								      list1605_1212 = MAKE_PAIR(string1679_reduce_typec, arg1606_1213);
								   }
								   print_trace_107_tools_trace(list1605_1212);
								}
							     }
							   else
							     {
								BUNSPEC;
							     }
							}
							{
							   long z2_1422;
							   z2_1422 = __type_checks_removed__34_reduce_typec;
							   __type_checks_removed__34_reduce_typec = (((long) 1) + z2_1422);
							}
							{
							   bool_t check_val_123_1220;
							   {
							      bool_t _ortest_1318_1224;
							      {
								 obj_t aux_1870;
								 aux_1870 = (obj_t) (typep_1205);
								 _ortest_1318_1224 = (typec_1202 == aux_1870);
							      }
							      if (_ortest_1318_1224)
								{
								   check_val_123_1220 = _ortest_1318_1224;
								}
							      else
								{
								   check_val_123_1220 = type_subclass__90_object_class(typep_1205, (type_t) (typec_1202));
								}
							   }
							   {
							      node_t node_1221;
							      {
								 atom_t arg1618_1222;
								 {
								    obj_t arg1619_1223;
								    arg1619_1223 = (((app_t) CREF(node_1198))->loc);
								    {
								       atom_t res1671_1436;
								       {
									  obj_t value_1428;
									  value_1428 = BBOOL(check_val_123_1220);
									  {
									     atom_t new1123_1429;
									     new1123_1429 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
									     {
										long arg1461_1430;
										arg1461_1430 = class_num_218___object(atom_ast_node);
										{
										   obj_t obj_1434;
										   obj_1434 = (obj_t) (new1123_1429);
										   (((obj_t) CREF(obj_1434))->header = MAKE_HEADER(arg1461_1430, 0), BUNSPEC);
										}
									     }
									     {
										object_t aux_1882;
										aux_1882 = (object_t) (new1123_1429);
										OBJECT_WIDENING_SET(aux_1882, BFALSE);
									     }
									     ((((atom_t) CREF(new1123_1429))->loc) = ((obj_t) arg1619_1223), BUNSPEC);
									     ((((atom_t) CREF(new1123_1429))->type) = ((type_t) type_1203), BUNSPEC);
									     ((((atom_t) CREF(new1123_1429))->value) = ((obj_t) value_1428), BUNSPEC);
									     res1671_1436 = new1123_1429;
									  }
								       }
								       arg1618_1222 = res1671_1436;
								    }
								 }
								 node_1221 = coerce__182_coerce_coerce((node_t) (arg1618_1222), type_1203);
							      }
							      lvtype_node__58_ast_lvtype(node_1221);
							      aux_1620 = (obj_t) (node_1221);
							   }
							}
						     }
						}
					     }
					   else
					     {
						aux_1620 = (obj_t) (node_1198);
					     }
					}
				     }
				  }
			       }
			    }
			 }
			 break;
		      default:
		       case_else1508_85_1086:
			 if (PROCEDUREP(method1502_1082))
			   {
			      aux_1620 = PROCEDURE_ENTRY(method1502_1082) (method1502_1082, (obj_t) (node_2), BEOA);
			   }
			 else
			   {
			      obj_t fun1371_749;
			      fun1371_749 = PROCEDURE_REF(node_typec__env_21_reduce_typec, ((long) 0));
			      aux_1620 = PROCEDURE_ENTRY(fun1371_749) (fun1371_749, (obj_t) (node_2), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1508_85_1086;
		 }
	    }
	    return (node_t) (aux_1620);
	 }
      }
   }
}


obj_t 
_node_typec__214_reduce_typec(obj_t env_1474, obj_t node_1475)
{
   {
      node_t aux_1905;
      aux_1905 = node_typec__103_reduce_typec((node_t) (node_1475));
      return (obj_t) (aux_1905);
   }
}


obj_t 
node_typec___130_reduce_typec(obj_t node__221_24)
{
   {
      obj_t node__221_750;
      node__221_750 = node__221_24;
    loop_751:
      if (NULLP(node__221_750))
	{
	   return CNST_TABLE_REF(((long) 2));
	}
      else
	{
	   {
	      node_t arg1376_753;
	      {
		 node_t aux_1912;
		 {
		    obj_t aux_1913;
		    aux_1913 = CAR(node__221_750);
		    aux_1912 = (node_t) (aux_1913);
		 }
		 arg1376_753 = node_typec__103_reduce_typec(aux_1912);
	      }
	      {
		 obj_t aux_1917;
		 aux_1917 = (obj_t) (arg1376_753);
		 SET_CAR(node__221_750, aux_1917);
	      }
	   }
	   {
	      obj_t node__221_1920;
	      node__221_1920 = CDR(node__221_750);
	      node__221_750 = node__221_1920;
	      goto loop_751;
	   }
	}
   }
}


obj_t 
imported_modules_init_94_reduce_typec()
{
   module_initialization_70_tools_trace(((long) 0), "REDUCE_TYPEC");
   module_initialization_70_tools_shape(((long) 0), "REDUCE_TYPEC");
   module_initialization_70_tools_speek(((long) 0), "REDUCE_TYPEC");
   module_initialization_70_tools_error(((long) 0), "REDUCE_TYPEC");
   module_initialization_70_type_type(((long) 0), "REDUCE_TYPEC");
   module_initialization_70_type_cache(((long) 0), "REDUCE_TYPEC");
   module_initialization_70_coerce_typeof(((long) 0), "REDUCE_TYPEC");
   module_initialization_70_coerce_coerce(((long) 0), "REDUCE_TYPEC");
   module_initialization_70_effect_effect(((long) 0), "REDUCE_TYPEC");
   module_initialization_70_ast_var(((long) 0), "REDUCE_TYPEC");
   module_initialization_70_ast_node(((long) 0), "REDUCE_TYPEC");
   module_initialization_70_ast_lvtype(((long) 0), "REDUCE_TYPEC");
   return module_initialization_70_object_class(((long) 0), "REDUCE_TYPEC");
}
