/*===========================================================================*/
/*   (Reduce/walk.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t reduce_walk__148_reduce_walk(obj_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_reduce_walk();
extern obj_t module_initialization_70_reduce_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_reduce_copy(long, char *);
extern obj_t module_initialization_70_reduce_cse(long, char *);
extern obj_t module_initialization_70_reduce_cond(long, char *);
extern obj_t module_initialization_70_reduce_typec(long, char *);
extern obj_t module_initialization_70_reduce_1occ(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t reduce_1occ__237_reduce_1occ(obj_t);
static obj_t cnst_init_137_reduce_walk();
extern obj_t __optim__89_engine_param;
extern obj_t reduce_type_check__95_reduce_typec(obj_t);
static obj_t require_initialization_114_reduce_walk = BUNSPEC;
extern obj_t reduce_copy__103_reduce_copy(obj_t);
static obj_t library_modules_init_112_reduce_walk();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t reduce_conditional__50_reduce_cond(obj_t);
extern obj_t current_error_port;
extern obj_t reduce_cse__211_reduce_cse(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _reduce_walk__13_reduce_walk(obj_t, obj_t);
extern obj_t __current_pass__25_engine_pass;
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
static obj_t __cnst[2];

DEFINE_STRING(string1448_reduce_walk, string1448_reduce_walk1463, "Reduction", 9);
DEFINE_EXPORT_PROCEDURE(reduce_walk__env_82_reduce_walk, _reduce_walk__13_reduce_walk1464, _reduce_walk__13_reduce_walk, 0L, 1);
DEFINE_STRING(string1454_reduce_walk, string1454_reduce_walk1465, "REDUCE PASS-STARTED ", 20);
DEFINE_STRING(string1449_reduce_walk, string1449_reduce_walk1466, "   . ", 5);
DEFINE_STRING(string1450_reduce_walk, string1450_reduce_walk1467, "failure during prelude hook", 27);
DEFINE_STRING(string1452_reduce_walk, string1452_reduce_walk1468, " error", 6);
DEFINE_STRING(string1451_reduce_walk, string1451_reduce_walk1469, " occured, ending ...", 20);
DEFINE_STRING(string1453_reduce_walk, string1453_reduce_walk1470, "failure during postlude hook", 28);

obj_t 
module_initialization_70_reduce_walk(long checksum_1018, char *from_1019)
{
   if (CBOOL(require_initialization_114_reduce_walk))
     {
	require_initialization_114_reduce_walk = BBOOL(((bool_t) 0));
	library_modules_init_112_reduce_walk();
	cnst_init_137_reduce_walk();
	imported_modules_init_94_reduce_walk();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_reduce_walk()
{
   module_initialization_70___r4_output_6_10_3(((long) 0), "REDUCE_WALK");
   module_initialization_70___reader(((long) 0), "REDUCE_WALK");
   module_initialization_70___r4_numbers_6_5(((long) 0), "REDUCE_WALK");
   return BUNSPEC;
}


obj_t 
cnst_init_137_reduce_walk()
{
   {
      obj_t cnst_port_138_1010;
      cnst_port_138_1010 = open_input_string(string1454_reduce_walk);
      {
	 long i_1011;
	 i_1011 = ((long) 1);
       loop_1012:
	 {
	    bool_t test1455_1013;
	    test1455_1013 = (i_1011 == ((long) -1));
	    if (test1455_1013)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1457_1014;
		    {
		       obj_t list1458_1015;
		       {
			  obj_t arg1461_1016;
			  arg1461_1016 = BNIL;
			  list1458_1015 = MAKE_PAIR(cnst_port_138_1010, arg1461_1016);
		       }
		       arg1457_1014 = read___reader(list1458_1015);
		    }
		    CNST_TABLE_SET(i_1011, arg1457_1014);
		 }
		 {
		    int aux_1017;
		    {
		       long aux_1035;
		       aux_1035 = (i_1011 - ((long) 1));
		       aux_1017 = (int) (aux_1035);
		    }
		    {
		       long i_1038;
		       i_1038 = (long) (aux_1017);
		       i_1011 = i_1038;
		       goto loop_1012;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
reduce_walk__148_reduce_walk(obj_t globals_1)
{
   {
      obj_t list1272_631;
      {
	 obj_t arg1275_633;
	 {
	    obj_t arg1278_635;
	    {
	       obj_t aux_1040;
	       aux_1040 = BCHAR(((unsigned char) '\n'));
	       arg1278_635 = MAKE_PAIR(aux_1040, BNIL);
	    }
	    arg1275_633 = MAKE_PAIR(string1448_reduce_walk, arg1278_635);
	 }
	 list1272_631 = MAKE_PAIR(string1449_reduce_walk, arg1275_633);
      }
      verbose_tools_speek(BINT(((long) 1)), list1272_631);
   }
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   __current_pass__25_engine_pass = string1448_reduce_walk;
   {
      obj_t hooks_637;
      obj_t hnames_638;
      hooks_637 = BNIL;
      hnames_638 = BNIL;
    loop_639:
      if (NULLP(hooks_637))
	{
	   CNST_TABLE_REF(((long) 0));
	}
      else
	{
	   bool_t test1285_644;
	   {
	      obj_t fun1296_650;
	      fun1296_650 = CAR(hooks_637);
	      {
		 obj_t aux_1052;
		 aux_1052 = PROCEDURE_ENTRY(fun1296_650) (fun1296_650, BEOA);
		 test1285_644 = CBOOL(aux_1052);
	      }
	   }
	   if (test1285_644)
	     {
		{
		   obj_t hnames_1059;
		   obj_t hooks_1057;
		   hooks_1057 = CDR(hooks_637);
		   hnames_1059 = CDR(hnames_638);
		   hnames_638 = hnames_1059;
		   hooks_637 = hooks_1057;
		   goto loop_639;
		}
	     }
	   else
	     {
		internal_error_43_tools_error(string1448_reduce_walk, string1450_reduce_walk, CAR(hnames_638));
	     }
	}
   }
   reduce_copy__103_reduce_copy(globals_1);
   {
      bool_t test1297_651;
      {
	 long n1_995;
	 n1_995 = (long) CINT(__optim__89_engine_param);
	 test1297_651 = (n1_995 >= ((long) 2));
      }
      if (test1297_651)
	{
	   reduce_cse__211_reduce_cse(globals_1);
	}
      else
	{
	   BUNSPEC;
	}
   }
   reduce_type_check__95_reduce_typec(globals_1);
   reduce_copy__103_reduce_copy(globals_1);
   reduce_conditional__50_reduce_cond(globals_1);
   reduce_1occ__237_reduce_1occ(globals_1);
   {
      obj_t value_652;
      value_652 = remove_var_123_ast_remove(CNST_TABLE_REF(((long) 1)), globals_1);
      {
	 bool_t test1298_653;
	 {
	    long n1_997;
	    n1_997 = (long) CINT(__nb_error_on_pass__70_tools_error);
	    test1298_653 = (n1_997 > ((long) 0));
	 }
	 if (test1298_653)
	   {
	      {
		 char *arg1303_656;
		 {
		    bool_t test1312_663;
		    {
		       bool_t test1313_664;
		       {
			  obj_t obj_999;
			  obj_999 = __nb_error_on_pass__70_tools_error;
			  test1313_664 = INTEGERP(obj_999);
		       }
		       if (test1313_664)
			 {
			    test1312_663 = _2__206___r4_numbers_6_5(__nb_error_on_pass__70_tools_error, BINT(((long) 1)));
			 }
		       else
			 {
			    test1312_663 = ((bool_t) 0);
			 }
		    }
		    if (test1312_663)
		      {
			 arg1303_656 = "s";
		      }
		    else
		      {
			 arg1303_656 = "";
		      }
		 }
		 {
		    obj_t list1306_658;
		    {
		       obj_t arg1307_659;
		       {
			  obj_t arg1308_660;
			  {
			     obj_t arg1310_661;
			     arg1310_661 = MAKE_PAIR(string1451_reduce_walk, BNIL);
			     {
				obj_t aux_1083;
				aux_1083 = string_to_bstring(arg1303_656);
				arg1308_660 = MAKE_PAIR(aux_1083, arg1310_661);
			     }
			  }
			  arg1307_659 = MAKE_PAIR(string1452_reduce_walk, arg1308_660);
		       }
		       list1306_658 = MAKE_PAIR(__nb_error_on_pass__70_tools_error, arg1307_659);
		    }
		    fprint___r4_output_6_10_3(current_error_port, list1306_658);
		 }
	      }
	      {
		 obj_t res1447_1001;
		 exit(((long) -1));
		 res1447_1001 = BINT(((long) -1));
		 return res1447_1001;
	      }
	   }
	 else
	   {
	      obj_t hooks_665;
	      obj_t hnames_666;
	      hooks_665 = BNIL;
	      hnames_666 = BNIL;
	    loop_667:
	      if (NULLP(hooks_665))
		{
		   return value_652;
		}
	      else
		{
		   bool_t test1318_672;
		   {
		      obj_t fun1324_677;
		      fun1324_677 = CAR(hooks_665);
		      {
			 obj_t aux_1094;
			 aux_1094 = PROCEDURE_ENTRY(fun1324_677) (fun1324_677, BEOA);
			 test1318_672 = CBOOL(aux_1094);
		      }
		   }
		   if (test1318_672)
		     {
			{
			   obj_t hnames_1101;
			   obj_t hooks_1099;
			   hooks_1099 = CDR(hooks_665);
			   hnames_1101 = CDR(hnames_666);
			   hnames_666 = hnames_1101;
			   hooks_665 = hooks_1099;
			   goto loop_667;
			}
		     }
		   else
		     {
			return internal_error_43_tools_error(__current_pass__25_engine_pass, string1453_reduce_walk, CAR(hnames_666));
		     }
		}
	   }
      }
   }
}


obj_t 
_reduce_walk__13_reduce_walk(obj_t env_1008, obj_t globals_1009)
{
   return reduce_walk__148_reduce_walk(globals_1009);
}


obj_t 
imported_modules_init_94_reduce_walk()
{
   module_initialization_70_tools_speek(((long) 0), "REDUCE_WALK");
   module_initialization_70_tools_error(((long) 0), "REDUCE_WALK");
   module_initialization_70_engine_pass(((long) 0), "REDUCE_WALK");
   module_initialization_70_tools_shape(((long) 0), "REDUCE_WALK");
   module_initialization_70_engine_param(((long) 0), "REDUCE_WALK");
   module_initialization_70_type_type(((long) 0), "REDUCE_WALK");
   module_initialization_70_ast_var(((long) 0), "REDUCE_WALK");
   module_initialization_70_ast_node(((long) 0), "REDUCE_WALK");
   module_initialization_70_reduce_copy(((long) 0), "REDUCE_WALK");
   module_initialization_70_reduce_cse(((long) 0), "REDUCE_WALK");
   module_initialization_70_reduce_cond(((long) 0), "REDUCE_WALK");
   module_initialization_70_reduce_typec(((long) 0), "REDUCE_WALK");
   module_initialization_70_reduce_1occ(((long) 0), "REDUCE_WALK");
   return module_initialization_70_ast_remove(((long) 0), "REDUCE_WALK");
}
