/*===========================================================================*/
/*   (Tools/error.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t _user_warning_49_tools_error(obj_t, obj_t, obj_t, obj_t);
obj_t __nb_error_on_pass__70_tools_error = BUNSPEC;
extern obj_t _enter_function_80_tools_error(obj_t, obj_t);
extern bool_t bigloo_strcmp(obj_t, obj_t);
extern obj_t exit_bigloo_229_init_main(obj_t);
extern obj_t _user_error_251_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
extern obj_t _user_error_location_187_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t notify_error_43___error(obj_t, obj_t, obj_t);
extern obj_t open_output_string();
extern obj_t error_location_112___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t exitd_top;
static obj_t imported_modules_init_94_tools_error();
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_init_main(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t toplevel_init_63_tools_error();
static obj_t cnst_init_137_tools_error();
extern obj_t _current_function_148_tools_error(obj_t);
extern obj_t __bigloo_email__0_engine_param;
extern obj_t _user_warning_location_217_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t add_error_handler__155___error(obj_t, obj_t);
extern obj_t remove_error_handler__102___error();
static obj_t require_initialization_114_tools_error = BUNSPEC;
static obj_t __sfun_stack__205_tools_error = BUNSPEC;
static obj_t library_modules_init_112_tools_error();
extern obj_t warning_location_135___error(obj_t, obj_t, obj_t);
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t handling_function1413_166_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t handler1566_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _internal_error_86_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t val_from_exit__100___bexit(obj_t);
extern obj_t user_warning_209_tools_error(obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t warning___error(obj_t);
static obj_t handling_function1428_57_tools_error(obj_t, obj_t, obj_t);
extern obj_t __bigloo_author__68_engine_param;
static obj_t handling_function1406_29_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t close_output_port(obj_t);
static obj_t handling_function1420_67_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t __trace_port__84_tools_trace;
extern obj_t find_location_120_tools_location(obj_t);
extern obj_t current_error_port;
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t display___r4_output_6_10_3(obj_t, obj_t);
static obj_t arg14081564_tools_error(obj_t, obj_t);
extern obj_t unwind_until__178___bexit(obj_t, obj_t);
static obj_t arg14211565_tools_error(obj_t, obj_t);
extern obj_t __current_pass__25_engine_pass;
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t current_function_76_tools_error();
extern obj_t c_substring(obj_t, long, long);
extern obj_t user_warning_location_190_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t _leave_function_100_tools_error(obj_t);
extern obj_t leave_function_170_tools_error();
static obj_t __cnst[2];

DEFINE_STRING(string1570_tools_error, string1570_tools_error1584, "], thank you.)", 14);
DEFINE_STRING(string1572_tools_error, string1572_tools_error1585, "(Would you, please, send this error report and the source file to", 65);
DEFINE_EXPORT_PROCEDURE(leave_function_env_89_tools_error, _leave_function_100_tools_error1586, _leave_function_100_tools_error, 0L, 0);
DEFINE_EXPORT_PROCEDURE(current_function_env_22_tools_error, _current_function_148_tools_error1587, _current_function_148_tools_error, 0L, 0);
DEFINE_STRING(string1574_tools_error, string1574_tools_error1588, "*** ERROR:", 10);
DEFINE_STRING(string1573_tools_error, string1573_tools_error1589, " -- ", 4);
DEFINE_STRING(string1571_tools_error, string1571_tools_error1590, " [", 2);
DEFINE_STRING(string1568_tools_error, string1568_tools_error1591, "*** ERROR: ", 11);
DEFINE_STRING(string1575_tools_error, string1575_tools_error1592, " ...", 4);
DEFINE_EXPORT_PROCEDURE(internal_error_env_37_tools_error, _internal_error_86_tools_error1593, _internal_error_86_tools_error, 0L, 3);
DEFINE_STRING(string1576_tools_error, string1576_tools_error1594, "LOCATION (TOP-LEVEL) ", 21);
DEFINE_EXPORT_PROCEDURE(user_warning_env_78_tools_error, _user_warning_49_tools_error1595, _user_warning_49_tools_error, 0L, 3);
DEFINE_EXPORT_PROCEDURE(enter_function_env_226_tools_error, _enter_function_80_tools_error1596, _enter_function_80_tools_error, 0L, 1);
DEFINE_EXPORT_PROCEDURE(user_error_env_101_tools_error, _user_error_251_tools_error1597, va_generic_entry, _user_error_251_tools_error, -4);
DEFINE_EXPORT_PROCEDURE(user_error_location_env_77_tools_error, _user_error_location_187_tools_error1598, va_generic_entry, _user_error_location_187_tools_error, -5);
DEFINE_STRING(string1567_tools_error, string1567_tools_error1599, ":", 1);
DEFINE_STRING(string1569_tools_error, string1569_tools_error1600, "*** INTERNAL-ERROR in pass: ", 28);
DEFINE_EXPORT_PROCEDURE(user_warning_location_env_188_tools_error, _user_warning_location_217_tools_error1601, _user_warning_location_217_tools_error, 0L, 4);

obj_t 
module_initialization_70_tools_error(long checksum_1302, char *from_1303)
{
   if (CBOOL(require_initialization_114_tools_error))
     {
	require_initialization_114_tools_error = BBOOL(((bool_t) 0));
	library_modules_init_112_tools_error();
	cnst_init_137_tools_error();
	imported_modules_init_94_tools_error();
	toplevel_init_63_tools_error();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_tools_error()
{
   module_initialization_70___r4_output_6_10_3(((long) 0), "TOOLS_ERROR");
   module_initialization_70___error(((long) 0), "TOOLS_ERROR");
   module_initialization_70___bexit(((long) 0), "TOOLS_ERROR");
   module_initialization_70___reader(((long) 0), "TOOLS_ERROR");
   module_initialization_70___r4_strings_6_7(((long) 0), "TOOLS_ERROR");
   return BUNSPEC;
}


obj_t 
cnst_init_137_tools_error()
{
   {
      obj_t cnst_port_138_1294;
      cnst_port_138_1294 = open_input_string(string1576_tools_error);
      {
	 long i_1295;
	 i_1295 = ((long) 1);
       loop_1296:
	 {
	    bool_t test1577_1297;
	    test1577_1297 = (i_1295 == ((long) -1));
	    if (test1577_1297)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1578_1298;
		    {
		       obj_t list1579_1299;
		       {
			  obj_t arg1582_1300;
			  arg1582_1300 = BNIL;
			  list1579_1299 = MAKE_PAIR(cnst_port_138_1294, arg1582_1300);
		       }
		       arg1578_1298 = read___reader(list1579_1299);
		    }
		    CNST_TABLE_SET(i_1295, arg1578_1298);
		 }
		 {
		    int aux_1301;
		    {
		       long aux_1322;
		       aux_1322 = (i_1295 - ((long) 1));
		       aux_1301 = (int) (aux_1322);
		    }
		    {
		       long i_1325;
		       i_1325 = (long) (aux_1301);
		       i_1295 = i_1325;
		       goto loop_1296;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_tools_error()
{
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   return (__sfun_stack__205_tools_error = CNST_TABLE_REF(((long) 0)),
      BUNSPEC);
}


obj_t 
internal_error_43_tools_error(obj_t proc_11, obj_t mes_12, obj_t obj_13)
{
   {
      bool_t test1314_677;
      {
	 obj_t obj_1149;
	 obj_1149 = __trace_port__84_tools_trace;
	 test1314_677 = OUTPUT_PORTP(obj_1149);
      }
      if (test1314_677)
	{
	   obj_t list1315_678;
	   {
	      obj_t arg1318_680;
	      {
		 obj_t arg1319_681;
		 {
		    obj_t arg1321_683;
		    {
		       obj_t arg1322_684;
		       {
			  obj_t arg1325_686;
			  arg1325_686 = MAKE_PAIR(obj_13, BNIL);
			  arg1322_684 = MAKE_PAIR(string1567_tools_error, arg1325_686);
		       }
		       arg1321_683 = MAKE_PAIR(mes_12, arg1322_684);
		    }
		    arg1319_681 = MAKE_PAIR(string1567_tools_error, arg1321_683);
		 }
		 arg1318_680 = MAKE_PAIR(proc_11, arg1319_681);
	      }
	      list1315_678 = MAKE_PAIR(string1568_tools_error, arg1318_680);
	   }
	   fprint___r4_output_6_10_3(__trace_port__84_tools_trace, list1315_678);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      obj_t list1330_690;
      {
	 obj_t arg1331_691;
	 arg1331_691 = MAKE_PAIR(__current_pass__25_engine_pass, BNIL);
	 list1330_690 = MAKE_PAIR(string1569_tools_error, arg1331_691);
      }
      fprint___r4_output_6_10_3(current_error_port, list1330_690);
   }
   {
      obj_t list1340_697;
      {
	 obj_t arg1342_698;
	 {
	    obj_t arg1343_699;
	    {
	       obj_t arg1345_700;
	       {
		  obj_t arg1346_701;
		  {
		     obj_t arg1347_702;
		     arg1347_702 = MAKE_PAIR(string1570_tools_error, BNIL);
		     arg1346_701 = MAKE_PAIR(__bigloo_email__0_engine_param, arg1347_702);
		  }
		  arg1345_700 = MAKE_PAIR(string1571_tools_error, arg1346_701);
	       }
	       arg1343_699 = MAKE_PAIR(__bigloo_author__68_engine_param, arg1345_700);
	    }
	    {
	       obj_t aux_1345;
	       aux_1345 = BCHAR(((unsigned char) '\n'));
	       arg1342_698 = MAKE_PAIR(aux_1345, arg1343_699);
	    }
	 }
	 list1340_697 = MAKE_PAIR(string1572_tools_error, arg1342_698);
      }
      fprint___r4_output_6_10_3(current_error_port, list1340_697);
   }
   FAILURE(proc_11, mes_12, obj_13);
}


obj_t 
_internal_error_86_tools_error(obj_t env_1228, obj_t proc_1229, obj_t mes_1230, obj_t obj_1231)
{
   return internal_error_43_tools_error(proc_1229, mes_1230, obj_1231);
}


obj_t 
user_warning_location_190_tools_error(obj_t loc_14, obj_t proc_15, obj_t mes_16, obj_t obj_17)
{
   {
      bool_t test_1354;
      if (STRUCTP(loc_14))
	{
	   obj_t aux_1359;
	   obj_t aux_1357;
	   aux_1359 = CNST_TABLE_REF(((long) 1));
	   aux_1357 = STRUCT_KEY(loc_14);
	   test_1354 = (aux_1357 == aux_1359);
	}
      else
	{
	   test_1354 = ((bool_t) 0);
	}
      if (test_1354)
	{
	   obj_t arg1352_705;
	   obj_t arg1353_706;
	   arg1352_705 = STRUCT_REF(loc_14, ((long) 0));
	   arg1353_706 = STRUCT_REF(loc_14, ((long) 1));
	   {
	      obj_t list1356_708;
	      {
		 obj_t arg1357_709;
		 {
		    obj_t arg1358_710;
		    {
		       obj_t arg1359_711;
		       arg1359_711 = MAKE_PAIR(obj_17, BNIL);
		       arg1358_710 = MAKE_PAIR(string1573_tools_error, arg1359_711);
		    }
		    arg1357_709 = MAKE_PAIR(mes_16, arg1358_710);
		 }
		 list1356_708 = MAKE_PAIR(proc_15, arg1357_709);
	      }
	      return warning_location_135___error(arg1352_705, arg1353_706, list1356_708);
	   }
	}
      else
	{
	   obj_t list1362_713;
	   {
	      obj_t arg1363_714;
	      {
		 obj_t arg1364_715;
		 {
		    obj_t arg1367_717;
		    arg1367_717 = MAKE_PAIR(obj_17, BNIL);
		    arg1364_715 = MAKE_PAIR(string1573_tools_error, arg1367_717);
		 }
		 arg1363_714 = MAKE_PAIR(mes_16, arg1364_715);
	      }
	      list1362_713 = MAKE_PAIR(proc_15, arg1363_714);
	   }
	   return warning___error(list1362_713);
	}
   }
}


obj_t 
_user_warning_location_217_tools_error(obj_t env_1232, obj_t loc_1233, obj_t proc_1234, obj_t mes_1235, obj_t obj_1236)
{
   return user_warning_location_190_tools_error(loc_1233, proc_1234, mes_1235, obj_1236);
}


obj_t 
user_warning_209_tools_error(obj_t proc_18, obj_t mes_19, obj_t obj_20)
{
   {
      obj_t arg1370_1167;
      arg1370_1167 = find_location_120_tools_location(obj_20);
      return user_warning_location_190_tools_error(arg1370_1167, proc_18, mes_19, obj_20);
   }
}


obj_t 
_user_warning_49_tools_error(obj_t env_1237, obj_t proc_1238, obj_t mes_1239, obj_t obj_1240)
{
   return user_warning_209_tools_error(proc_1238, mes_1239, obj_1240);
}


obj_t 
user_error_151_tools_error(obj_t proc_21, obj_t mes_22, obj_t obj_23, obj_t continue_162_24)
{
   if (PAIRP(continue_162_24))
     {
	obj_t arg1372_721;
	obj_t arg1376_722;
	arg1372_721 = find_location_120_tools_location(obj_23);
	arg1376_722 = CAR(continue_162_24);
	{
	   obj_t list1377_723;
	   list1377_723 = MAKE_PAIR(arg1376_722, BNIL);
	   return user_error_location_137_tools_error(arg1372_721, proc_21, mes_22, obj_23, list1377_723);
	}
     }
   else
     {
	obj_t arg1380_725;
	arg1380_725 = find_location_120_tools_location(obj_23);
	return user_error_location_137_tools_error(arg1380_725, proc_21, mes_22, obj_23, BNIL);
     }
}


obj_t 
_user_error_251_tools_error(obj_t env_1241, obj_t proc_1242, obj_t mes_1243, obj_t obj_1244, obj_t continue_162_1245)
{
   return user_error_151_tools_error(proc_1242, mes_1243, obj_1244, continue_162_1245);
}


obj_t 
user_error_location_137_tools_error(obj_t loc_25, obj_t proc_26, obj_t mes_27, obj_t obj_28, obj_t continue_162_29)
{
   {
      bool_t test1382_727;
      {
	 obj_t obj_1170;
	 obj_1170 = __trace_port__84_tools_trace;
	 test1382_727 = OUTPUT_PORTP(obj_1170);
      }
      if (test1382_727)
	{
	   obj_t list1383_728;
	   {
	      obj_t arg1388_730;
	      {
		 obj_t arg1390_731;
		 {
		    obj_t arg1396_733;
		    {
		       obj_t arg1398_734;
		       {
			  obj_t arg1402_736;
			  arg1402_736 = MAKE_PAIR(obj_28, BNIL);
			  arg1398_734 = MAKE_PAIR(string1567_tools_error, arg1402_736);
		       }
		       arg1396_733 = MAKE_PAIR(mes_27, arg1398_734);
		    }
		    arg1390_731 = MAKE_PAIR(string1567_tools_error, arg1396_733);
		 }
		 arg1388_730 = MAKE_PAIR(proc_26, arg1390_731);
	      }
	      list1383_728 = MAKE_PAIR(string1574_tools_error, arg1388_730);
	   }
	   fprint___r4_output_6_10_3(__trace_port__84_tools_trace, list1383_728);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      long z1_1171;
      z1_1171 = (long) CINT(__nb_error_on_pass__70_tools_error);
      {
	 long aux_1397;
	 aux_1397 = (z1_1171 + ((long) 1));
	 __nb_error_on_pass__70_tools_error = BINT(aux_1397);
      }
   }
   {
      obj_t proc_string_5_738;
      if (STRINGP(proc_26))
	{
	   proc_string_5_738 = proc_26;
	}
      else
	{
	   if (SYMBOLP(proc_26))
	     {
		proc_string_5_738 = SYMBOL_TO_STRING(proc_26);
	     }
	   else
	     {
		proc_string_5_738 = BFALSE;
	     }
	}
      {
	 obj_t fun_string_157_739;
	 {
	    obj_t arg1457_818;
	    {
	       obj_t pair_1176;
	       pair_1176 = __sfun_stack__205_tools_error;
	       arg1457_818 = CAR(pair_1176);
	    }
	    fun_string_157_739 = SYMBOL_TO_STRING(arg1457_818);
	 }
	 {
	    obj_t proc_740;
	    {
	       bool_t test1448_810;
	       if (STRINGP(proc_string_5_738))
		 {
		    bool_t test1456_817;
		    test1456_817 = bigloo_strcmp(proc_string_5_738, fun_string_157_739);
		    if (test1456_817)
		      {
			 test1448_810 = ((bool_t) 0);
		      }
		    else
		      {
			 test1448_810 = ((bool_t) 1);
		      }
		 }
	       else
		 {
		    test1448_810 = ((bool_t) 0);
		 }
	       if (test1448_810)
		 {
		    obj_t list1449_811;
		    {
		       obj_t arg1450_812;
		       {
			  obj_t arg1453_814;
			  arg1453_814 = MAKE_PAIR(proc_string_5_738, BNIL);
			  arg1450_812 = MAKE_PAIR(string1567_tools_error, arg1453_814);
		       }
		       list1449_811 = MAKE_PAIR(fun_string_157_739, arg1450_812);
		    }
		    proc_740 = string_append_106___r4_strings_6_7(list1449_811);
		 }
	       else
		 {
		    proc_740 = fun_string_157_739;
		 }
	    }
	    {
	       {
		  obj_t obj_prn_210_741;
		  {
		     obj_t port_794;
		     port_794 = open_output_string();
		     {
			obj_t list1430_795;
			list1430_795 = MAKE_PAIR(port_794, BNIL);
			display___r4_output_6_10_3(obj_28, list1430_795);
		     }
		     {
			obj_t string_797;
			string_797 = close_output_port(port_794);
			{
			   bool_t test_1420;
			   {
			      long aux_1421;
			      aux_1421 = STRING_LENGTH(string_797);
			      test_1420 = (aux_1421 > ((long) 45));
			   }
			   if (test_1420)
			     {
				obj_t arg1440_799;
				arg1440_799 = c_substring(string_797, ((long) 0), ((long) 44));
				obj_prn_210_741 = string_append(arg1440_799, string1575_tools_error);
			     }
			   else
			     {
				obj_prn_210_741 = string_797;
			     }
			}
		     }
		  }
		  {
		     obj_t handler_1248;
		     handler_1248 = make_fx_procedure(handler1566_tools_error, ((long) 4), ((long) 1));
		     PROCEDURE_SET(handler_1248, ((long) 0), continue_162_29);
		     {
			bool_t test_1428;
			if (STRUCTP(loc_25))
			  {
			     obj_t aux_1433;
			     obj_t aux_1431;
			     aux_1433 = CNST_TABLE_REF(((long) 1));
			     aux_1431 = STRUCT_KEY(loc_25);
			     test_1428 = (aux_1431 == aux_1433);
			  }
			else
			  {
			     test_1428 = ((bool_t) 0);
			  }
			if (test_1428)
			  {
			     if (PAIRP(continue_162_29))
			       {
				  obj_t armed1275_747;
				  armed1275_747 = MAKE_CELL(BTRUE);
				  return handling_function1406_29_tools_error(handler_1248, armed1275_747, obj_prn_210_741, mes_27, proc_740, loc_25);
			       }
			     else
			       {
				  return error_location_112___error(proc_740, mes_27, obj_prn_210_741, STRUCT_REF(loc_25, ((long) 0)), STRUCT_REF(loc_25, ((long) 1)));
			       }
			  }
			else
			  {
			     if (PAIRP(continue_162_29))
			       {
				  obj_t armed1285_774;
				  armed1285_774 = MAKE_CELL(BTRUE);
				  return handling_function1420_67_tools_error(handler_1248, armed1285_774, obj_28, mes_27, proc_740);
			       }
			     else
			       {
				  FAILURE(proc_740, mes_27, obj_28);
			       }
			  }
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
handling_function1420_67_tools_error(obj_t handler1283_1279, obj_t armed1285_1278, obj_t obj_1277, obj_t mes_1276, obj_t proc_1275)
{
   jmp_buf jmpbuf;
   obj_t an_exit1286_228_776;
   if (SET_EXIT(an_exit1286_228_776))
     {
	RESTORE_TRACE();
	return _exit_value_;
     }
   else
     {
	an_exit1286_228_776 = (obj_t) jmpbuf;
	{
	   PUSH_EXIT(an_exit1286_228_776, ((bool_t) 1));
	   {
	      obj_t an_exitd1287_236_777;
	      an_exitd1287_236_777 = exitd_top;
	      {
		 obj_t res1289_780;
		 {
		    obj_t arg1421_1247;
		    arg1421_1247 = make_fx_procedure(arg14211565_tools_error, ((long) 1), ((long) 2));
		    PROCEDURE_SET(arg1421_1247, ((long) 0), armed1285_1278);
		    PROCEDURE_SET(arg1421_1247, ((long) 1), an_exitd1287_236_777);
		    add_error_handler__155___error(handler1283_1279, arg1421_1247);
		 }
		 {
		    obj_t val1290_785;
		    val1290_785 = handling_function1428_57_tools_error(obj_1277, mes_1276, proc_1275);
		    {
		       bool_t test_1454;
		       {
			  obj_t aux_1455;
			  aux_1455 = CELL_REF(armed1285_1278);
			  test_1454 = CBOOL(aux_1455);
		       }
		       if (test_1454)
			 {
			    remove_error_handler__102___error();
			 }
		       else
			 {
			    BUNSPEC;
			 }
		    }
		    {
		       bool_t test1423_786;
		       {
			  obj_t aux_1458;
			  aux_1458 = val_from_exit__100___bexit(val1290_785);
			  test1423_786 = CBOOL(aux_1458);
		       }
		       if (test1423_786)
			 {
			    res1289_780 = unwind_until__178___bexit(CAR(val1290_785), CDR(val1290_785));
			 }
		       else
			 {
			    res1289_780 = val1290_785;
			 }
		    }
		 }
		 POP_EXIT();
		 return res1289_780;
	      }
	   }
	}
     }
}


obj_t 
handling_function1428_57_tools_error(obj_t obj_1282, obj_t mes_1281, obj_t proc_1280)
{
   {
      jmp_buf jmpbuf;
      obj_t an_exit1291_26_790;
      if (SET_EXIT(an_exit1291_26_790))
	{
	   RESTORE_TRACE();
	   return _exit_value_;
	}
      else
	{
	   an_exit1291_26_790 = (obj_t) jmpbuf;
	   {
	      PUSH_EXIT(an_exit1291_26_790, ((bool_t) 0));
	      {
		 obj_t val1292_791;
		 FAILURE(proc_1280, mes_1281, obj_1282);
		 POP_EXIT();
		 return val1292_791;
	      }
	   }
	}
   }
}


obj_t 
handling_function1406_29_tools_error(obj_t handler1273_1288, obj_t armed1275_1287, obj_t obj_prn_210_1286, obj_t mes_1285, obj_t proc_1284, obj_t loc_1283)
{
   jmp_buf jmpbuf;
   obj_t an_exit1276_139_749;
   if (SET_EXIT(an_exit1276_139_749))
     {
	RESTORE_TRACE();
	return _exit_value_;
     }
   else
     {
	an_exit1276_139_749 = (obj_t) jmpbuf;
	{
	   PUSH_EXIT(an_exit1276_139_749, ((bool_t) 1));
	   {
	      obj_t an_exitd1277_110_750;
	      an_exitd1277_110_750 = exitd_top;
	      {
		 obj_t res1279_753;
		 {
		    obj_t arg1408_1246;
		    arg1408_1246 = make_fx_procedure(arg14081564_tools_error, ((long) 1), ((long) 2));
		    PROCEDURE_SET(arg1408_1246, ((long) 0), armed1275_1287);
		    PROCEDURE_SET(arg1408_1246, ((long) 1), an_exitd1277_110_750);
		    add_error_handler__155___error(handler1273_1288, arg1408_1246);
		 }
		 {
		    obj_t val1280_758;
		    val1280_758 = handling_function1413_166_tools_error(obj_prn_210_1286, mes_1285, proc_1284, loc_1283);
		    {
		       bool_t test_1479;
		       {
			  obj_t aux_1480;
			  aux_1480 = CELL_REF(armed1275_1287);
			  test_1479 = CBOOL(aux_1480);
		       }
		       if (test_1479)
			 {
			    remove_error_handler__102___error();
			 }
		       else
			 {
			    BUNSPEC;
			 }
		    }
		    {
		       bool_t test1410_759;
		       {
			  obj_t aux_1483;
			  aux_1483 = val_from_exit__100___bexit(val1280_758);
			  test1410_759 = CBOOL(aux_1483);
		       }
		       if (test1410_759)
			 {
			    res1279_753 = unwind_until__178___bexit(CAR(val1280_758), CDR(val1280_758));
			 }
		       else
			 {
			    res1279_753 = val1280_758;
			 }
		    }
		 }
		 POP_EXIT();
		 return res1279_753;
	      }
	   }
	}
     }
}


obj_t 
handling_function1413_166_tools_error(obj_t obj_prn_210_1292, obj_t mes_1291, obj_t proc_1290, obj_t loc_1289)
{
   {
      jmp_buf jmpbuf;
      obj_t an_exit1281_108_763;
      if (SET_EXIT(an_exit1281_108_763))
	{
	   RESTORE_TRACE();
	   return _exit_value_;
	}
      else
	{
	   an_exit1281_108_763 = (obj_t) jmpbuf;
	   {
	      PUSH_EXIT(an_exit1281_108_763, ((bool_t) 0));
	      {
		 obj_t val1282_764;
		 val1282_764 = error_location_112___error(proc_1290, mes_1291, obj_prn_210_1292, STRUCT_REF(loc_1289, ((long) 0)), STRUCT_REF(loc_1289, ((long) 1)));
		 POP_EXIT();
		 return val1282_764;
	      }
	   }
	}
   }
}


obj_t 
_user_error_location_187_tools_error(obj_t env_1249, obj_t loc_1250, obj_t proc_1251, obj_t mes_1252, obj_t obj_1253, obj_t continue_162_1254)
{
   return user_error_location_137_tools_error(loc_1250, proc_1251, mes_1252, obj_1253, continue_162_1254);
}


obj_t 
arg14081564_tools_error(obj_t env_1255, obj_t arg_1258)
{
   {
      obj_t armed1275_1256;
      obj_t an_exitd1277_110_1257;
      armed1275_1256 = PROCEDURE_REF(env_1255, ((long) 0));
      an_exitd1277_110_1257 = PROCEDURE_REF(env_1255, ((long) 1));
      {
	 obj_t arg_755;
	 arg_755 = arg_1258;
	 CELL_SET(armed1275_1256, BFALSE);
	 return unwind_until__178___bexit(an_exitd1277_110_1257, arg_755);
      }
   }
}


obj_t 
arg14211565_tools_error(obj_t env_1260, obj_t arg_1263)
{
   {
      obj_t armed1285_1261;
      obj_t an_exitd1287_236_1262;
      armed1285_1261 = PROCEDURE_REF(env_1260, ((long) 0));
      an_exitd1287_236_1262 = PROCEDURE_REF(env_1260, ((long) 1));
      {
	 obj_t arg_782;
	 arg_782 = arg_1263;
	 CELL_SET(armed1285_1261, BFALSE);
	 return unwind_until__178___bexit(an_exitd1287_236_1262, arg_782);
      }
   }
}


obj_t 
handler1566_tools_error(obj_t env_1265, obj_t escape_1267, obj_t proc_1268, obj_t mes_1269, obj_t obj_1270)
{
   {
      obj_t continue_162_1266;
      continue_162_1266 = PROCEDURE_REF(env_1265, ((long) 0));
      {
	 obj_t escape_803;
	 obj_t proc_804;
	 obj_t mes_805;
	 obj_t obj_806;
	 escape_803 = escape_1267;
	 proc_804 = proc_1268;
	 mes_805 = mes_1269;
	 obj_806 = obj_1270;
	 notify_error_43___error(proc_804, mes_805, obj_806);
	 return PROCEDURE_ENTRY(escape_803) (escape_803, CAR(continue_162_1266), BEOA);
      }
   }
}


obj_t 
enter_function_81_tools_error(obj_t var_30)
{
   {
      obj_t obj2_1225;
      obj2_1225 = __sfun_stack__205_tools_error;
      return (__sfun_stack__205_tools_error = MAKE_PAIR(var_30, obj2_1225),
	 BUNSPEC);
   }
}


obj_t 
_enter_function_80_tools_error(obj_t env_1271, obj_t var_1272)
{
   return enter_function_81_tools_error(var_1272);
}


obj_t 
leave_function_170_tools_error()
{
   {
      obj_t pair_1226;
      pair_1226 = __sfun_stack__205_tools_error;
      return (__sfun_stack__205_tools_error = CDR(pair_1226),
	 BUNSPEC);
   }
}


obj_t 
_leave_function_100_tools_error(obj_t env_1273)
{
   return leave_function_170_tools_error();
}


obj_t 
current_function_76_tools_error()
{
   {
      obj_t pair_1227;
      pair_1227 = __sfun_stack__205_tools_error;
      return CAR(pair_1227);
   }
}


obj_t 
_current_function_148_tools_error(obj_t env_1274)
{
   return current_function_76_tools_error();
}


obj_t 
imported_modules_init_94_tools_error()
{
   module_initialization_70_type_type(((long) 0), "TOOLS_ERROR");
   module_initialization_70_ast_var(((long) 0), "TOOLS_ERROR");
   module_initialization_70_ast_node(((long) 0), "TOOLS_ERROR");
   module_initialization_70_engine_pass(((long) 0), "TOOLS_ERROR");
   module_initialization_70_engine_param(((long) 0), "TOOLS_ERROR");
   module_initialization_70_tools_location(((long) 0), "TOOLS_ERROR");
   module_initialization_70_tools_trace(((long) 0), "TOOLS_ERROR");
   return module_initialization_70_init_main(((long) 0), "TOOLS_ERROR");
}
