/*===========================================================================*/
/*   (Tools/shape.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


static obj_t _shape_default1274_127_tools_shape(obj_t, obj_t);
extern obj_t type_type_type;
extern obj_t _shape_tools_shape(obj_t, obj_t);
extern obj_t __key_shape___172_engine_param;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t global_ast_var;
extern obj_t global_bucket_position_189_ast_env(obj_t, obj_t);
extern obj_t __classes__134___object;
static obj_t imported_modules_init_94_tools_shape();
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_dump(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t string_to_symbol(char *);
static obj_t toplevel_init_63_tools_shape();
static obj_t cnst_init_137_tools_shape();
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t make_vector(long, obj_t);
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
static obj_t require_initialization_114_tools_shape = BUNSPEC;
extern obj_t node__sexp_247_ast_dump(node_t);
static obj_t library_modules_init_112_tools_shape();
extern obj_t __module_shape___145_engine_param;
extern obj_t __case_sensitive__90_engine_param;
extern obj_t read___reader(obj_t);
static obj_t shape_default1274_227_tools_shape(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t __type_shape___78_engine_param;
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t shape_tools_shape(obj_t);
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
static obj_t loop_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t local_ast_var;
extern obj_t node_ast_node;
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
extern obj_t __access_shape___50_engine_param;
static obj_t __cnst[3];

DEFINE_STRING(string1590_tools_shape, string1590_tools_shape1597, "_ @ A-TVECTOR ", 14);
DEFINE_STRING(string1583_tools_shape, string1583_tools_shape1598, "::", 2);
DEFINE_STRING(string1586_tools_shape, string1586_tools_shape1599, "{", 1);
DEFINE_STRING(string1587_tools_shape, string1587_tools_shape1600, "@", 1);
DEFINE_STRING(string1585_tools_shape, string1585_tools_shape1601, "}", 1);
DEFINE_STATIC_PROCEDURE(shape_default1274_env_129_tools_shape, _shape_default1274_127_tools_shape1602, _shape_default1274_127_tools_shape, 0L, 1);
DEFINE_EXPORT_GENERIC(shape_env_98_tools_shape, _shape_tools_shape1603, _shape_tools_shape, 0L, 1);
DEFINE_STRING(string1589_tools_shape, string1589_tools_shape1604, "Can't find global any more", 26);
DEFINE_STRING(string1584_tools_shape, string1584_tools_shape1605, "", 0);
DEFINE_STRING(string1588_tools_shape, string1588_tools_shape1606, "global-shape", 12);

obj_t 
module_initialization_70_tools_shape(long checksum_1278, char *from_1279)
{
   if (CBOOL(require_initialization_114_tools_shape))
     {
	require_initialization_114_tools_shape = BBOOL(((bool_t) 0));
	library_modules_init_112_tools_shape();
	cnst_init_137_tools_shape();
	imported_modules_init_94_tools_shape();
	toplevel_init_63_tools_shape();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_tools_shape()
{
   module_initialization_70___object(((long) 0), "TOOLS_SHAPE");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "TOOLS_SHAPE");
   module_initialization_70___r4_strings_6_7(((long) 0), "TOOLS_SHAPE");
   module_initialization_70___reader(((long) 0), "TOOLS_SHAPE");
   module_initialization_70___r4_symbols_6_4(((long) 0), "TOOLS_SHAPE");
   module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "TOOLS_SHAPE");
   return BUNSPEC;
}


obj_t 
cnst_init_137_tools_shape()
{
   {
      obj_t cnst_port_138_1270;
      cnst_port_138_1270 = open_input_string(string1590_tools_shape);
      {
	 long i_1271;
	 i_1271 = ((long) 2);
       loop_1272:
	 {
	    bool_t test1591_1273;
	    test1591_1273 = (i_1271 == ((long) -1));
	    if (test1591_1273)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1592_1274;
		    {
		       obj_t list1593_1275;
		       {
			  obj_t arg1595_1276;
			  arg1595_1276 = BNIL;
			  list1593_1275 = MAKE_PAIR(cnst_port_138_1270, arg1595_1276);
		       }
		       arg1592_1274 = read___reader(list1593_1275);
		    }
		    CNST_TABLE_SET(i_1271, arg1592_1274);
		 }
		 {
		    int aux_1277;
		    {
		       long aux_1299;
		       aux_1299 = (i_1271 - ((long) 1));
		       aux_1277 = (int) (aux_1299);
		    }
		    {
		       long i_1302;
		       i_1302 = (long) (aux_1277);
		       i_1271 = i_1302;
		       goto loop_1272;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_tools_shape()
{
   add_generic__110___object(shape_env_98_tools_shape, shape_default1274_env_129_tools_shape);
   add_inlined_method__244___object(shape_env_98_tools_shape, global_ast_var, ((long) 0));
   add_inlined_method__244___object(shape_env_98_tools_shape, local_ast_var, ((long) 1));
   add_inlined_method__244___object(shape_env_98_tools_shape, type_type_type, ((long) 2));
   {
      long aux_1308;
      aux_1308 = add_inlined_method__244___object(shape_env_98_tools_shape, node_ast_node, ((long) 3));
      return BINT(aux_1308);
   }
}


obj_t 
shape_default1274_227_tools_shape(obj_t exp_13)
{
   if (PAIRP(exp_13))
     {
	return loop_tools_shape(exp_13);
     }
   else
     {
	if (VECTORP(exp_13))
	  {
	     {
		long len_674;
		len_674 = VECTOR_LENGTH(exp_13);
		{
		   obj_t res_675;
		   res_675 = make_vector(len_674, BNIL);
		   {
		      {
			 long indice_676;
			 indice_676 = ((long) 0);
		       loop_677:
			 if ((indice_676 == len_674))
			   {
			      return res_675;
			   }
			 else
			   {
			      {
				 obj_t arg1314_679;
				 arg1314_679 = shape_tools_shape(VECTOR_REF(exp_13, indice_676));
				 VECTOR_SET(res_675, indice_676, arg1314_679);
			      }
			      {
				 long indice_1323;
				 indice_1323 = (indice_676 + ((long) 1));
				 indice_676 = indice_1323;
				 goto loop_677;
			      }
			   }
		      }
		   }
		}
	     }
	  }
	else
	  {
	     bool_t test_1325;
	     if (STRUCTP(exp_13))
	       {
		  obj_t aux_1330;
		  obj_t aux_1328;
		  aux_1330 = CNST_TABLE_REF(((long) 0));
		  aux_1328 = STRUCT_KEY(exp_13);
		  test_1325 = (aux_1328 == aux_1330);
	       }
	     else
	       {
		  test_1325 = ((bool_t) 0);
	       }
	     if (test_1325)
	       {
		  {
		     obj_t arg1320_684;
		     obj_t arg1321_685;
		     arg1320_684 = shape_tools_shape(STRUCT_REF(exp_13, ((long) 0)));
		     arg1321_685 = shape_tools_shape(STRUCT_REF(exp_13, ((long) 1)));
		     {
			obj_t new_1189;
			{
			   obj_t aux_1337;
			   aux_1337 = CNST_TABLE_REF(((long) 0));
			   new_1189 = create_struct(aux_1337, ((long) 2));
			}
			STRUCT_SET(new_1189, ((long) 1), arg1321_685);
			STRUCT_SET(new_1189, ((long) 0), arg1320_684);
			return new_1189;
		     }
		  }
	       }
	     else
	       {
		  return exp_13;
	       }
	  }
     }
}


obj_t 
loop_tools_shape(obj_t exp_665)
{
   if (NULLP(exp_665))
     {
	return BNIL;
     }
   else
     {
	if (PAIRP(exp_665))
	  {
	     {
		obj_t arg1307_669;
		obj_t arg1308_670;
		arg1307_669 = shape_tools_shape(CAR(exp_665));
		arg1308_670 = loop_tools_shape(CDR(exp_665));
		return MAKE_PAIR(arg1307_669, arg1308_670);
	     }
	  }
	else
	  {
	     return shape_tools_shape(exp_665);
	  }
     }
}


obj_t 
_shape_default1274_127_tools_shape(obj_t env_1267, obj_t exp_1268)
{
   return shape_default1274_227_tools_shape(exp_1268);
}


obj_t 
shape_tools_shape(obj_t exp_12)
{
   {
      obj_t method1446_1003;
      obj_t class1451_1004;
      {
	 bool_t test1456_1000;
	 test1456_1000 = (POINTERP(exp_12) && (TYPE(exp_12) >= OBJECT_TYPE));
	 if (test1456_1000)
	   {
	      obj_t arg1457_1001;
	      obj_t arg1458_1002;
	      {
		 object_t obj_1203;
		 obj_1203 = (object_t) (exp_12);
		 {
		    obj_t pre_method_105_1204;
		    pre_method_105_1204 = PROCEDURE_REF(shape_env_98_tools_shape, ((long) 2));
		    if (INTEGERP(pre_method_105_1204))
		      {
			 PROCEDURE_SET(shape_env_98_tools_shape, ((long) 2), BUNSPEC);
			 arg1457_1001 = pre_method_105_1204;
		      }
		    else
		      {
			 long obj_class_num_177_1209;
			 obj_class_num_177_1209 = TYPE(obj_1203);
			 {
			    obj_t arg1183_1210;
			    arg1183_1210 = PROCEDURE_REF(shape_env_98_tools_shape, ((long) 1));
			    {
			       long arg1184_1214;
			       {
				  long arg1186_1215;
				  arg1186_1215 = OBJECT_TYPE;
				  arg1184_1214 = (obj_class_num_177_1209 - arg1186_1215);
			       }
			       arg1457_1001 = VECTOR_REF(arg1183_1210, arg1184_1214);
			    }
			 }
		      }
		 }
	      }
	      {
		 object_t object_1220;
		 object_1220 = (object_t) (exp_12);
		 {
		    long arg1187_1221;
		    {
		       long arg1188_1222;
		       long arg1189_1223;
		       arg1188_1222 = TYPE(object_1220);
		       arg1189_1223 = OBJECT_TYPE;
		       arg1187_1221 = (arg1188_1222 - arg1189_1223);
		    }
		    {
		       obj_t vector_1227;
		       vector_1227 = __classes__134___object;
		       arg1458_1002 = VECTOR_REF(vector_1227, arg1187_1221);
		    }
		 }
	      }
	      method1446_1003 = arg1457_1001;
	      class1451_1004 = arg1458_1002;
	    loop1447_1123:
	      {
		 if (INTEGERP(method1446_1003))
		   {
		      switch ((long) CINT(method1446_1003))
			{
			case ((long) 0):
			   {
			      global_t var_1010;
			      var_1010 = (global_t) (exp_12);
			      {
				 obj_t str_id_3_1011;
				 {
				    obj_t arg1538_1076;
				    {
				       obj_t aux_1373;
				       aux_1373 = (((global_t) CREF(var_1010))->id);
				       arg1538_1076 = SYMBOL_TO_STRING(aux_1373);
				    }
				    if (CBOOL(__case_sensitive__90_engine_param))
				      {
					 str_id_3_1011 = arg1538_1076;
				      }
				    else
				      {
					 str_id_3_1011 = string_downcase_77___r4_strings_6_7(arg1538_1076);
				      }
				 }
				 {
				    obj_t id_1012;
				    {
				       char *aux_1379;
				       aux_1379 = BSTRING_TO_STRING(str_id_3_1011);
				       id_1012 = string_to_symbol(aux_1379);
				    }
				    {
				       obj_t module_1013;
				       {
					  obj_t arg1536_1074;
					  {
					     obj_t aux_1382;
					     aux_1382 = (((global_t) CREF(var_1010))->module);
					     arg1536_1074 = SYMBOL_TO_STRING(aux_1382);
					  }
					  if (CBOOL(__case_sensitive__90_engine_param))
					    {
					       module_1013 = arg1536_1074;
					    }
					  else
					    {
					       module_1013 = string_downcase_77___r4_strings_6_7(arg1536_1074);
					    }
				       }
				       {
					  type_t type_1014;
					  type_1014 = (((global_t) CREF(var_1010))->type);
					  {
					     obj_t tshape_1015;
					     if (CBOOL(__type_shape___78_engine_param))
					       {
						  obj_t arg1535_1073;
						  arg1535_1073 = shape_tools_shape((obj_t) (type_1014));
						  tshape_1015 = string_append(string1583_tools_shape, arg1535_1073);
					       }
					     else
					       {
						  tshape_1015 = string1584_tools_shape;
					       }
					     {
						obj_t ashape_1016;
						if (CBOOL(__access_shape___50_engine_param))
						  {
						     {
							obj_t arg1520_1064;
							{
							   obj_t arg1531_1070;
							   {
							      obj_t aux_1396;
							      aux_1396 = (((global_t) CREF(var_1010))->access);
							      arg1531_1070 = SYMBOL_TO_STRING(aux_1396);
							   }
							   if (CBOOL(__case_sensitive__90_engine_param))
							     {
								arg1520_1064 = arg1531_1070;
							     }
							   else
							     {
								arg1520_1064 = string_downcase_77___r4_strings_6_7(arg1531_1070);
							     }
							}
							{
							   obj_t list1523_1066;
							   {
							      obj_t arg1524_1067;
							      {
								 obj_t arg1526_1068;
								 arg1526_1068 = MAKE_PAIR(string1585_tools_shape, BNIL);
								 arg1524_1067 = MAKE_PAIR(arg1520_1064, arg1526_1068);
							      }
							      list1523_1066 = MAKE_PAIR(string1586_tools_shape, arg1524_1067);
							   }
							   ashape_1016 = string_append_106___r4_strings_6_7(list1523_1066);
							}
						     }
						  }
						else
						  {
						     ashape_1016 = string1584_tools_shape;
						  }
						{
						   if (CBOOL(__module_shape___145_engine_param))
						     {
							{
							   obj_t arg1461_1017;
							   {
							      obj_t list1462_1018;
							      {
								 obj_t arg1463_1019;
								 {
								    obj_t arg1466_1021;
								    {
								       obj_t arg1467_1022;
								       {
									  obj_t arg1468_1023;
									  arg1468_1023 = MAKE_PAIR(ashape_1016, BNIL);
									  arg1467_1022 = MAKE_PAIR(tshape_1015, arg1468_1023);
								       }
								       arg1466_1021 = MAKE_PAIR(module_1013, arg1467_1022);
								    }
								    arg1463_1019 = MAKE_PAIR(string1587_tools_shape, arg1466_1021);
								 }
								 list1462_1018 = MAKE_PAIR(str_id_3_1011, arg1463_1019);
							      }
							      arg1461_1017 = string_append_106___r4_strings_6_7(list1462_1018);
							   }
							   {
							      char *aux_1414;
							      aux_1414 = BSTRING_TO_STRING(arg1461_1017);
							      return string_to_symbol(aux_1414);
							   }
							}
						     }
						   else
						     {
							{
							   {
							      obj_t aux1273_1026;
							      aux1273_1026 = global_bucket_position_189_ast_env((((global_t) CREF(var_1010))->id), (((global_t) CREF(var_1010))->module));
							      {
								 bool_t test1471_1027;
								 test1471_1027 = INTEGERP(aux1273_1026);
								 if (test1471_1027)
								   {
								      if (test1471_1027)
									{
									   switch ((long) CINT(aux1273_1026))
									     {
									     case ((long) -1):
										{
										   obj_t arg1477_1033;
										   {
										      obj_t arg1478_1034;
										      obj_t arg1480_1035;
										      arg1478_1034 = CNST_TABLE_REF(((long) 1));
										      arg1480_1035 = (((global_t) CREF(var_1010))->module);
										      {
											 obj_t list1482_1037;
											 {
											    obj_t arg1484_1038;
											    {
											       obj_t arg1485_1039;
											       arg1485_1039 = MAKE_PAIR(BNIL, BNIL);
											       arg1484_1038 = MAKE_PAIR(arg1480_1035, arg1485_1039);
											    }
											    list1482_1037 = MAKE_PAIR(id_1012, arg1484_1038);
											 }
											 arg1477_1033 = cons__138___r4_pairs_and_lists_6_3(arg1478_1034, list1482_1037);
										      }
										   }
										   return internal_error_43_tools_error(string1588_tools_shape, string1589_tools_shape, arg1477_1033);
										}
										break;
									     case ((long) 0):
										{
										   obj_t arg1487_1041;
										   obj_t arg1489_1042;
										   {
										      char *aux_1430;
										      aux_1430 = BSTRING_TO_STRING(tshape_1015);
										      arg1487_1041 = string_to_symbol(aux_1430);
										   }
										   {
										      char *aux_1433;
										      aux_1433 = BSTRING_TO_STRING(ashape_1016);
										      arg1489_1042 = string_to_symbol(aux_1433);
										   }
										   {
										      obj_t list1490_1043;
										      {
											 obj_t arg1493_1044;
											 {
											    obj_t arg1494_1045;
											    arg1494_1045 = MAKE_PAIR(arg1489_1042, BNIL);
											    arg1493_1044 = MAKE_PAIR(arg1487_1041, arg1494_1045);
											 }
											 list1490_1043 = MAKE_PAIR(id_1012, arg1493_1044);
										      }
										      return symbol_append_197___r4_symbols_6_4(list1490_1043);
										   }
										}
										break;
									     default:
									      case_else1272_245_1025:
										{
										   obj_t sym_1049;
										   {
										      obj_t arg1509_1057;
										      obj_t arg1510_1058;
										      {
											 char *aux_1440;
											 aux_1440 = BSTRING_TO_STRING(tshape_1015);
											 arg1509_1057 = string_to_symbol(aux_1440);
										      }
										      {
											 char *aux_1443;
											 aux_1443 = BSTRING_TO_STRING(ashape_1016);
											 arg1510_1058 = string_to_symbol(aux_1443);
										      }
										      {
											 obj_t list1511_1059;
											 {
											    obj_t arg1513_1060;
											    {
											       obj_t arg1514_1061;
											       arg1514_1061 = MAKE_PAIR(arg1510_1058, BNIL);
											       arg1513_1060 = MAKE_PAIR(arg1509_1057, arg1514_1061);
											    }
											    list1511_1059 = MAKE_PAIR(id_1012, arg1513_1060);
											 }
											 sym_1049 = symbol_append_197___r4_symbols_6_4(list1511_1059);
										      }
										   }
										   {
										      obj_t arg1499_1050;
										      obj_t arg1500_1051;
										      arg1499_1050 = CNST_TABLE_REF(((long) 1));
										      {
											 char *aux_1451;
											 aux_1451 = BSTRING_TO_STRING(module_1013);
											 arg1500_1051 = string_to_symbol(aux_1451);
										      }
										      {
											 obj_t list1502_1053;
											 {
											    obj_t arg1505_1054;
											    {
											       obj_t arg1506_1055;
											       arg1506_1055 = MAKE_PAIR(BNIL, BNIL);
											       arg1505_1054 = MAKE_PAIR(arg1500_1051, arg1506_1055);
											    }
											    list1502_1053 = MAKE_PAIR(sym_1049, arg1505_1054);
											 }
											 return cons__138___r4_pairs_and_lists_6_3(arg1499_1050, list1502_1053);
										      }
										   }
										}
									     }
									}
								      else
									{
									   goto case_else1272_245_1025;
									}
								   }
								 else
								   {
								      goto case_else1272_245_1025;
								   }
							      }
							   }
							}
						     }
						}
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			   break;
			case ((long) 1):
			   {
			      local_t var_1078;
			      var_1078 = (local_t) (exp_12);
			      {
				 obj_t sym_1079;
				 if (CBOOL(__key_shape___172_engine_param))
				   {
				      obj_t arg1563_1101;
				      obj_t arg1564_1102;
				      obj_t arg1565_1103;
				      arg1563_1101 = (((local_t) CREF(var_1078))->id);
				      arg1564_1102 = CNST_TABLE_REF(((long) 2));
				      {
					 char *aux_1465;
					 {
					    obj_t aux_1466;
					    {
					       char *aux_1467;
					       aux_1467 = integer__string_135___r4_numbers_6_5_fixnum((((local_t) CREF(var_1078))->key), BNIL);
					       aux_1466 = string_to_bstring(aux_1467);
					    }
					    aux_1465 = BSTRING_TO_STRING(aux_1466);
					 }
					 arg1565_1103 = string_to_symbol(aux_1465);
				      }
				      {
					 obj_t list1566_1104;
					 {
					    obj_t arg1567_1105;
					    {
					       obj_t arg1568_1106;
					       arg1568_1106 = MAKE_PAIR(arg1565_1103, BNIL);
					       arg1567_1105 = MAKE_PAIR(arg1564_1102, arg1568_1106);
					    }
					    list1566_1104 = MAKE_PAIR(arg1563_1101, arg1567_1105);
					 }
					 sym_1079 = symbol_append_197___r4_symbols_6_4(list1566_1104);
				      }
				   }
				 else
				   {
				      sym_1079 = (((local_t) CREF(var_1078))->id);
				   }
				 {
				    obj_t sym_1080;
				    {
				       obj_t arg1562_1100;
				       arg1562_1100 = SYMBOL_TO_STRING(sym_1079);
				       if (CBOOL(__case_sensitive__90_engine_param))
					 {
					    sym_1080 = arg1562_1100;
					 }
				       else
					 {
					    sym_1080 = string_downcase_77___r4_strings_6_7(arg1562_1100);
					 }
				    }
				    {
				       type_t type_1081;
				       type_1081 = (((local_t) CREF(var_1078))->type);
				       {
					  obj_t tshape_1082;
					  if (CBOOL(__type_shape___78_engine_param))
					    {
					       obj_t arg1561_1099;
					       arg1561_1099 = shape_tools_shape((obj_t) (type_1081));
					       tshape_1082 = string_append(string1583_tools_shape, arg1561_1099);
					    }
					  else
					    {
					       tshape_1082 = string1584_tools_shape;
					    }
					  {
					     obj_t ashape_1083;
					     if (CBOOL(__access_shape___50_engine_param))
					       {
						  {
						     obj_t arg1550_1090;
						     {
							obj_t arg1557_1096;
							{
							   obj_t aux_1490;
							   aux_1490 = (((local_t) CREF(var_1078))->access);
							   arg1557_1096 = SYMBOL_TO_STRING(aux_1490);
							}
							if (CBOOL(__case_sensitive__90_engine_param))
							  {
							     arg1550_1090 = arg1557_1096;
							  }
							else
							  {
							     arg1550_1090 = string_downcase_77___r4_strings_6_7(arg1557_1096);
							  }
						     }
						     {
							obj_t list1552_1092;
							{
							   obj_t arg1553_1093;
							   {
							      obj_t arg1554_1094;
							      arg1554_1094 = MAKE_PAIR(string1585_tools_shape, BNIL);
							      arg1553_1093 = MAKE_PAIR(arg1550_1090, arg1554_1094);
							   }
							   list1552_1092 = MAKE_PAIR(string1586_tools_shape, arg1553_1093);
							}
							ashape_1083 = string_append_106___r4_strings_6_7(list1552_1092);
						     }
						  }
					       }
					     else
					       {
						  ashape_1083 = string1584_tools_shape;
					       }
					     {
						{
						   obj_t arg1540_1084;
						   {
						      obj_t list1541_1085;
						      {
							 obj_t arg1542_1086;
							 {
							    obj_t arg1543_1087;
							    arg1543_1087 = MAKE_PAIR(ashape_1083, BNIL);
							    arg1542_1086 = MAKE_PAIR(tshape_1082, arg1543_1087);
							 }
							 list1541_1085 = MAKE_PAIR(sym_1080, arg1542_1086);
						      }
						      arg1540_1084 = string_append_106___r4_strings_6_7(list1541_1085);
						   }
						   {
						      char *aux_1504;
						      aux_1504 = BSTRING_TO_STRING(arg1540_1084);
						      return string_to_symbol(aux_1504);
						   }
						}
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			   break;
			case ((long) 2):
			   {
			      type_t type_1111;
			      type_1111 = (type_t) (exp_12);
			      {
				 obj_t arg1574_1112;
				 {
				    obj_t aux_1508;
				    aux_1508 = (((type_t) CREF(type_1111))->id);
				    arg1574_1112 = SYMBOL_TO_STRING(aux_1508);
				 }
				 if (CBOOL(__case_sensitive__90_engine_param))
				   {
				      return arg1574_1112;
				   }
				 else
				   {
				      return string_downcase_77___r4_strings_6_7(arg1574_1112);
				   }
			      }
			   }
			   break;
			case ((long) 3):
			   return node__sexp_247_ast_dump((node_t) (exp_12));
			   break;
			default:
			 case_else1452_133_1007:
			   if (PROCEDUREP(method1446_1003))
			     {
				return PROCEDURE_ENTRY(method1446_1003) (method1446_1003, exp_12, BEOA);
			     }
			   else
			     {
				obj_t fun1324_688;
				fun1324_688 = PROCEDURE_REF(shape_env_98_tools_shape, ((long) 0));
				return PROCEDURE_ENTRY(fun1324_688) (fun1324_688, exp_12, BEOA);
			     }
			}
		   }
		 else
		   {
		      goto case_else1452_133_1007;
		   }
	      }
	   }
	 else
	   {
	      obj_t class1451_1526;
	      obj_t method1446_1525;
	      method1446_1525 = BFALSE;
	      class1451_1526 = BFALSE;
	      class1451_1004 = class1451_1526;
	      method1446_1003 = method1446_1525;
	      goto loop1447_1123;
	   }
      }
   }
}


obj_t 
_shape_tools_shape(obj_t env_1265, obj_t exp_1266)
{
   return shape_tools_shape(exp_1266);
}


obj_t 
imported_modules_init_94_tools_shape()
{
   module_initialization_70_type_type(((long) 0), "TOOLS_SHAPE");
   module_initialization_70_ast_var(((long) 0), "TOOLS_SHAPE");
   module_initialization_70_ast_node(((long) 0), "TOOLS_SHAPE");
   module_initialization_70_ast_dump(((long) 0), "TOOLS_SHAPE");
   module_initialization_70_ast_env(((long) 0), "TOOLS_SHAPE");
   module_initialization_70_engine_param(((long) 0), "TOOLS_SHAPE");
   return module_initialization_70_tools_error(((long) 0), "TOOLS_SHAPE");
}
