/*===========================================================================*/
/*   (Trace/walk.scm)                                                        */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


static obj_t trace_fun__23_trace_walk(obj_t);
extern obj_t __nb_error_on_pass__70_tools_error;
extern obj_t let_fun_218_ast_node;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t __classes__134___object;
static node_t trace_node_default1299_25_trace_walk(node_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_trace_walk();
extern obj_t module_initialization_70_trace_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t toplevel_init_63_trace_walk();
static obj_t cnst_init_137_trace_walk();
extern obj_t __compiler_debug__134_engine_param;
static obj_t trace_node___31_trace_walk(obj_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static let_var_6_t make_traced_node_44_trace_walk(node_t, type_t, obj_t);
static obj_t require_initialization_114_trace_walk = BUNSPEC;
static obj_t library_modules_init_112_trace_walk();
extern obj_t cast_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t trace_walk__65_trace_walk(obj_t);
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
extern obj_t string_to_bstring(char *);
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t enter_function_81_tools_error(obj_t);
extern node_t sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t pragma_ast_node;
extern obj_t current_error_port;
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t jump_ex_it_184_ast_node;
static obj_t _trace_node_default1299_15_trace_walk(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
static obj_t _trace_node_88_trace_walk(obj_t, obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t _4dots_tools_misc;
extern obj_t set_ex_it_116_ast_node;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _trace_walk__101_trace_walk(obj_t, obj_t);
static node_t trace_node_95_trace_walk(node_t);
extern obj_t box_ref_242_ast_node;
extern obj_t __current_pass__25_engine_pass;
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t make_box_202_ast_node;
extern obj_t app_ast_node;
extern obj_t leave_function_170_tools_error();
static obj_t __cnst[11];

DEFINE_STATIC_GENERIC(trace_node_env_147_trace_walk, _trace_node_88_trace_walk1740, _trace_node_88_trace_walk, 0L, 1);
DEFINE_EXPORT_PROCEDURE(trace_walk__env_32_trace_walk, _trace_walk__101_trace_walk1741, _trace_walk__101_trace_walk, 0L, 1);
DEFINE_STRING(string1728_trace_walk, string1728_trace_walk1742, "Trace", 5);
DEFINE_STRING(string1734_trace_walk, string1734_trace_walk1743, "DONE VALUE C-POP-TRACE SET! C-PUSH-TRACE QUOTE LET SYMBOL AUX NO-TRACE PASS-STARTED ", 84);
DEFINE_STRING(string1730_trace_walk, string1730_trace_walk1744, "failure during prelude hook", 27);
DEFINE_STRING(string1729_trace_walk, string1729_trace_walk1745, "   . ", 5);
DEFINE_STATIC_PROCEDURE(trace_node_default1299_env_47_trace_walk, _trace_node_default1299_15_trace_walk1746, _trace_node_default1299_15_trace_walk, 0L, 1);
DEFINE_STRING(string1733_trace_walk, string1733_trace_walk1747, "failure during postlude hook", 28);
DEFINE_STRING(string1731_trace_walk, string1731_trace_walk1748, " occured, ending ...", 20);
DEFINE_STRING(string1732_trace_walk, string1732_trace_walk1749, " error", 6);

obj_t 
module_initialization_70_trace_walk(long checksum_1436, char *from_1437)
{
   if (CBOOL(require_initialization_114_trace_walk))
     {
	require_initialization_114_trace_walk = BBOOL(((bool_t) 0));
	library_modules_init_112_trace_walk();
	cnst_init_137_trace_walk();
	imported_modules_init_94_trace_walk();
	toplevel_init_63_trace_walk();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_trace_walk()
{
   module_initialization_70___object(((long) 0), "TRACE_WALK");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "TRACE_WALK");
   module_initialization_70___r4_output_6_10_3(((long) 0), "TRACE_WALK");
   module_initialization_70___reader(((long) 0), "TRACE_WALK");
   module_initialization_70___r4_symbols_6_4(((long) 0), "TRACE_WALK");
   module_initialization_70___r4_numbers_6_5(((long) 0), "TRACE_WALK");
   return BUNSPEC;
}


obj_t 
cnst_init_137_trace_walk()
{
   {
      obj_t cnst_port_138_1428;
      cnst_port_138_1428 = open_input_string(string1734_trace_walk);
      {
	 long i_1429;
	 i_1429 = ((long) 10);
       loop_1430:
	 {
	    bool_t test1735_1431;
	    test1735_1431 = (i_1429 == ((long) -1));
	    if (test1735_1431)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1736_1432;
		    {
		       obj_t list1737_1433;
		       {
			  obj_t arg1738_1434;
			  arg1738_1434 = BNIL;
			  list1737_1433 = MAKE_PAIR(cnst_port_138_1428, arg1738_1434);
		       }
		       arg1736_1432 = read___reader(list1737_1433);
		    }
		    CNST_TABLE_SET(i_1429, arg1736_1432);
		 }
		 {
		    int aux_1435;
		    {
		       long aux_1457;
		       aux_1457 = (i_1429 - ((long) 1));
		       aux_1435 = (int) (aux_1457);
		    }
		    {
		       long i_1460;
		       i_1460 = (long) (aux_1435);
		       i_1429 = i_1460;
		       goto loop_1430;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_trace_walk()
{
   add_generic__110___object(trace_node_env_147_trace_walk, trace_node_default1299_env_47_trace_walk);
   add_inlined_method__244___object(trace_node_env_147_trace_walk, sequence_ast_node, ((long) 0));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, app_ast_node, ((long) 1));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, app_ly_162_ast_node, ((long) 2));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, funcall_ast_node, ((long) 3));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, pragma_ast_node, ((long) 4));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, cast_ast_node, ((long) 5));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, setq_ast_node, ((long) 6));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, conditional_ast_node, ((long) 7));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, fail_ast_node, ((long) 8));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, select_ast_node, ((long) 9));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, let_fun_218_ast_node, ((long) 10));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, let_var_6_ast_node, ((long) 11));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, set_ex_it_116_ast_node, ((long) 12));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, jump_ex_it_184_ast_node, ((long) 13));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, make_box_202_ast_node, ((long) 14));
   add_inlined_method__244___object(trace_node_env_147_trace_walk, box_ref_242_ast_node, ((long) 15));
   {
      long aux_1479;
      aux_1479 = add_inlined_method__244___object(trace_node_env_147_trace_walk, box_set__221_ast_node, ((long) 16));
      return BINT(aux_1479);
   }
}


obj_t 
trace_walk__65_trace_walk(obj_t globals_1)
{
   {
      obj_t list1319_655;
      {
	 obj_t arg1321_657;
	 {
	    obj_t arg1323_659;
	    {
	       obj_t aux_1482;
	       aux_1482 = BCHAR(((unsigned char) '\n'));
	       arg1323_659 = MAKE_PAIR(aux_1482, BNIL);
	    }
	    arg1321_657 = MAKE_PAIR(string1728_trace_walk, arg1323_659);
	 }
	 list1319_655 = MAKE_PAIR(string1729_trace_walk, arg1321_657);
      }
      verbose_tools_speek(BINT(((long) 1)), list1319_655);
   }
   __nb_error_on_pass__70_tools_error = BINT(((long) 0));
   __current_pass__25_engine_pass = string1728_trace_walk;
   {
      obj_t hooks_661;
      obj_t hnames_662;
      hooks_661 = BNIL;
      hnames_662 = BNIL;
    loop_663:
      if (NULLP(hooks_661))
	{
	   CNST_TABLE_REF(((long) 0));
	}
      else
	{
	   bool_t test1331_668;
	   {
	      obj_t fun1341_674;
	      fun1341_674 = CAR(hooks_661);
	      {
		 obj_t aux_1494;
		 aux_1494 = PROCEDURE_ENTRY(fun1341_674) (fun1341_674, BEOA);
		 test1331_668 = CBOOL(aux_1494);
	      }
	   }
	   if (test1331_668)
	     {
		{
		   obj_t hnames_1501;
		   obj_t hooks_1499;
		   hooks_1499 = CDR(hooks_661);
		   hnames_1501 = CDR(hnames_662);
		   hnames_662 = hnames_1501;
		   hooks_661 = hooks_1499;
		   goto loop_663;
		}
	     }
	   else
	     {
		internal_error_43_tools_error(string1728_trace_walk, string1730_trace_walk, CAR(hnames_662));
	     }
	}
   }
   {
      obj_t l1272_675;
      l1272_675 = globals_1;
    lname1283_676:
      if (PAIRP(l1272_675))
	{
	   trace_fun__23_trace_walk(CAR(l1272_675));
	   {
	      obj_t l1272_1509;
	      l1272_1509 = CDR(l1272_675);
	      l1272_675 = l1272_1509;
	      goto lname1283_676;
	   }
	}
      else
	{
	   ((bool_t) 1);
	}
   }
   {
      bool_t test1346_681;
      {
	 long n1_1236;
	 n1_1236 = (long) CINT(__nb_error_on_pass__70_tools_error);
	 test1346_681 = (n1_1236 > ((long) 0));
      }
      if (test1346_681)
	{
	   {
	      char *arg1350_684;
	      {
		 bool_t test1359_691;
		 {
		    bool_t test1360_692;
		    {
		       obj_t obj_1238;
		       obj_1238 = __nb_error_on_pass__70_tools_error;
		       test1360_692 = INTEGERP(obj_1238);
		    }
		    if (test1360_692)
		      {
			 test1359_691 = _2__206___r4_numbers_6_5(__nb_error_on_pass__70_tools_error, BINT(((long) 1)));
		      }
		    else
		      {
			 test1359_691 = ((bool_t) 0);
		      }
		 }
		 if (test1359_691)
		   {
		      arg1350_684 = "s";
		   }
		 else
		   {
		      arg1350_684 = "";
		   }
	      }
	      {
		 obj_t list1353_686;
		 {
		    obj_t arg1355_687;
		    {
		       obj_t arg1356_688;
		       {
			  obj_t arg1357_689;
			  arg1357_689 = MAKE_PAIR(string1731_trace_walk, BNIL);
			  {
			     obj_t aux_1520;
			     aux_1520 = string_to_bstring(arg1350_684);
			     arg1356_688 = MAKE_PAIR(aux_1520, arg1357_689);
			  }
		       }
		       arg1355_687 = MAKE_PAIR(string1732_trace_walk, arg1356_688);
		    }
		    list1353_686 = MAKE_PAIR(__nb_error_on_pass__70_tools_error, arg1355_687);
		 }
		 fprint___r4_output_6_10_3(current_error_port, list1353_686);
	      }
	   }
	   {
	      obj_t res1704_1240;
	      exit(((long) -1));
	      res1704_1240 = BINT(((long) -1));
	      return res1704_1240;
	   }
	}
      else
	{
	   obj_t hooks_693;
	   obj_t hnames_694;
	   hooks_693 = BNIL;
	   hnames_694 = BNIL;
	 loop_695:
	   if (NULLP(hooks_693))
	     {
		return globals_1;
	     }
	   else
	     {
		bool_t test1366_700;
		{
		   obj_t fun1373_705;
		   fun1373_705 = CAR(hooks_693);
		   {
		      obj_t aux_1531;
		      aux_1531 = PROCEDURE_ENTRY(fun1373_705) (fun1373_705, BEOA);
		      test1366_700 = CBOOL(aux_1531);
		   }
		}
		if (test1366_700)
		  {
		     {
			obj_t hnames_1538;
			obj_t hooks_1536;
			hooks_1536 = CDR(hooks_693);
			hnames_1538 = CDR(hnames_694);
			hnames_694 = hnames_1538;
			hooks_693 = hooks_1536;
			goto loop_695;
		     }
		  }
		else
		  {
		     return internal_error_43_tools_error(__current_pass__25_engine_pass, string1733_trace_walk, CAR(hnames_694));
		  }
	     }
	}
   }
}


obj_t 
_trace_walk__101_trace_walk(obj_t env_1404, obj_t globals_1405)
{
   return trace_walk__65_trace_walk(globals_1405);
}


obj_t 
trace_fun__23_trace_walk(obj_t var_2)
{
   {
      value_t fun_706;
      {
	 variable_t obj_1247;
	 obj_1247 = (variable_t) (var_2);
	 fun_706 = (((variable_t) CREF(obj_1247))->value);
      }
      {
	 obj_t body_707;
	 {
	    sfun_t obj_1248;
	    obj_1248 = (sfun_t) (fun_706);
	    body_707 = (((sfun_t) CREF(obj_1248))->body);
	 }
	 {
	    type_t type_708;
	    {
	       variable_t obj_1249;
	       obj_1249 = (variable_t) (var_2);
	       type_708 = (((variable_t) CREF(obj_1249))->type);
	    }
	    {
	       {
		  bool_t test_1549;
		  {
		     bool_t test_1550;
		     {
			fun_t obj_1250;
			obj_1250 = (fun_t) (fun_706);
			{
			   obj_t aux_1552;
			   aux_1552 = (((fun_t) CREF(obj_1250))->predicate_of_78);
			   test_1550 = CBOOL(aux_1552);
			}
		     }
		     if (test_1550)
		       {
			  test_1549 = ((bool_t) 0);
		       }
		     else
		       {
			  bool_t test_1555;
			  {
			     obj_t aux_1556;
			     {
				obj_t aux_1557;
				{
				   sfun_t obj_1251;
				   obj_1251 = (sfun_t) (fun_706);
				   aux_1557 = (((sfun_t) CREF(obj_1251))->property);
				}
				aux_1556 = memq___r4_pairs_and_lists_6_3(CNST_TABLE_REF(((long) 1)), aux_1557);
			     }
			     test_1555 = CBOOL(aux_1556);
			  }
			  if (test_1555)
			    {
			       test_1549 = ((bool_t) 0);
			    }
			  else
			    {
			       test_1549 = ((bool_t) 1);
			    }
		       }
		  }
		  if (test_1549)
		    {
		       {
			  obj_t aux_1563;
			  {
			     variable_t obj_1252;
			     obj_1252 = (variable_t) (var_2);
			     aux_1563 = (((variable_t) CREF(obj_1252))->id);
			  }
			  enter_function_81_tools_error(aux_1563);
		       }
		       {
			  obj_t new_body_215_711;
			  {
			     bool_t test1380_714;
			     {
				long n1_1253;
				n1_1253 = (long) CINT(__compiler_debug__134_engine_param);
				test1380_714 = (n1_1253 >= ((long) 2));
			     }
			     if (test1380_714)
			       {
				  node_t aux_1570;
				  aux_1570 = trace_node_95_trace_walk((node_t) (body_707));
				  new_body_215_711 = (obj_t) (aux_1570);
			       }
			     else
			       {
				  new_body_215_711 = body_707;
			       }
			  }
			  {
			     let_var_6_t new2_body_172_712;
			     {
				obj_t aux_1574;
				{
				   variable_t obj_1255;
				   obj_1255 = (variable_t) (var_2);
				   aux_1574 = (((variable_t) CREF(obj_1255))->id);
				}
				new2_body_172_712 = make_traced_node_44_trace_walk((node_t) (new_body_215_711), type_708, aux_1574);
			     }
			     {
				{
				   obj_t res1705_1258;
				   {
				      sfun_t obj_1256;
				      obj_t val1077_1257;
				      obj_1256 = (sfun_t) (fun_706);
				      val1077_1257 = (obj_t) (new2_body_172_712);
				      {
					 obj_t x_1406;
					 x_1406 = ((((sfun_t) CREF(obj_1256))->body) = ((obj_t) val1077_1257), BUNSPEC);
					 res1705_1258 = BUNSPEC;
				      }
				   }
				   res1705_1258;
				}
				return leave_function_170_tools_error();
			     }
			  }
		       }
		    }
		  else
		    {
		       return BUNSPEC;
		    }
	       }
	    }
	 }
      }
   }
}


let_var_6_t 
make_traced_node_44_trace_walk(node_t node_3, type_t type_4, obj_t symbol_5)
{
   {
      obj_t loc_719;
      loc_719 = (((node_t) CREF(node_3))->loc);
      {
	 obj_t aux_720;
	 aux_720 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 2)), BEOA);
	 {
	    obj_t taux_721;
	    {
	       obj_t list1499_795;
	       {
		  obj_t arg1500_796;
		  {
		     obj_t arg1501_797;
		     {
			obj_t aux_1587;
			aux_1587 = (((type_t) CREF(type_4))->id);
			arg1501_797 = MAKE_PAIR(aux_1587, BNIL);
		     }
		     arg1500_796 = MAKE_PAIR(_4dots_tools_misc, arg1501_797);
		  }
		  list1499_795 = MAKE_PAIR(aux_720, arg1500_796);
	       }
	       taux_721 = symbol_append_197___r4_symbols_6_4(list1499_795);
	    }
	    {
	       obj_t sym_722;
	       sym_722 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 3)), BEOA);
	       {
		  obj_t exp_723;
		  {
		     obj_t arg1396_727;
		     obj_t arg1398_728;
		     obj_t arg1400_729;
		     arg1396_727 = CNST_TABLE_REF(((long) 4));
		     {
			obj_t arg1410_735;
			{
			   obj_t arg1415_739;
			   {
			      obj_t arg1421_744;
			      arg1421_744 = CNST_TABLE_REF(((long) 5));
			      {
				 obj_t list1425_746;
				 {
				    obj_t arg1426_747;
				    arg1426_747 = MAKE_PAIR(BNIL, BNIL);
				    list1425_746 = MAKE_PAIR(symbol_5, arg1426_747);
				 }
				 arg1415_739 = cons__138___r4_pairs_and_lists_6_3(arg1421_744, list1425_746);
			      }
			   }
			   {
			      obj_t list1417_741;
			      {
				 obj_t arg1418_742;
				 arg1418_742 = MAKE_PAIR(BNIL, BNIL);
				 list1417_741 = MAKE_PAIR(arg1415_739, arg1418_742);
			      }
			      arg1410_735 = cons__138___r4_pairs_and_lists_6_3(sym_722, list1417_741);
			   }
			}
			{
			   obj_t list1412_737;
			   list1412_737 = MAKE_PAIR(BNIL, BNIL);
			   arg1398_728 = cons__138___r4_pairs_and_lists_6_3(arg1410_735, list1412_737);
			}
		     }
		     {
			obj_t arg1428_749;
			obj_t arg1432_751;
			obj_t arg1440_752;
			obj_t arg1441_753;
			arg1428_749 = CNST_TABLE_REF(((long) 4));
			{
			   obj_t arg1452_761;
			   arg1452_761 = CNST_TABLE_REF(((long) 6));
			   {
			      obj_t list1454_763;
			      {
				 obj_t arg1457_764;
				 arg1457_764 = MAKE_PAIR(BNIL, BNIL);
				 list1454_763 = MAKE_PAIR(sym_722, arg1457_764);
			      }
			      arg1432_751 = cons__138___r4_pairs_and_lists_6_3(arg1452_761, list1454_763);
			   }
			}
			{
			   obj_t arg1461_766;
			   arg1461_766 = CNST_TABLE_REF(((long) 7));
			   {
			      obj_t list1464_768;
			      {
				 obj_t arg1465_769;
				 {
				    obj_t arg1466_770;
				    arg1466_770 = MAKE_PAIR(BNIL, BNIL);
				    arg1465_769 = MAKE_PAIR(sym_722, arg1466_770);
				 }
				 list1464_768 = MAKE_PAIR(sym_722, arg1465_769);
			      }
			      arg1440_752 = cons__138___r4_pairs_and_lists_6_3(arg1461_766, list1464_768);
			   }
			}
			{
			   obj_t arg1468_772;
			   obj_t arg1470_773;
			   obj_t arg1471_774;
			   arg1468_772 = CNST_TABLE_REF(((long) 4));
			   {
			      obj_t arg1480_781;
			      {
				 obj_t list1486_786;
				 {
				    obj_t arg1487_787;
				    arg1487_787 = MAKE_PAIR(BNIL, BNIL);
				    {
				       obj_t aux_1618;
				       aux_1618 = (obj_t) (node_3);
				       list1486_786 = MAKE_PAIR(aux_1618, arg1487_787);
				    }
				 }
				 arg1480_781 = cons__138___r4_pairs_and_lists_6_3(taux_721, list1486_786);
			      }
			      {
				 obj_t list1482_783;
				 list1482_783 = MAKE_PAIR(BNIL, BNIL);
				 arg1470_773 = cons__138___r4_pairs_and_lists_6_3(arg1480_781, list1482_783);
			      }
			   }
			   {
			      obj_t arg1490_789;
			      arg1490_789 = CNST_TABLE_REF(((long) 8));
			      {
				 obj_t list1494_791;
				 list1494_791 = MAKE_PAIR(BNIL, BNIL);
				 arg1471_774 = cons__138___r4_pairs_and_lists_6_3(arg1490_789, list1494_791);
			      }
			   }
			   {
			      obj_t list1473_776;
			      {
				 obj_t arg1474_777;
				 {
				    obj_t arg1476_778;
				    {
				       obj_t arg1477_779;
				       arg1477_779 = MAKE_PAIR(BNIL, BNIL);
				       arg1476_778 = MAKE_PAIR(aux_720, arg1477_779);
				    }
				    arg1474_777 = MAKE_PAIR(arg1471_774, arg1476_778);
				 }
				 list1473_776 = MAKE_PAIR(arg1470_773, arg1474_777);
			      }
			      arg1441_753 = cons__138___r4_pairs_and_lists_6_3(arg1468_772, list1473_776);
			   }
			}
			{
			   obj_t list1445_755;
			   {
			      obj_t arg1446_756;
			      {
				 obj_t arg1447_757;
				 {
				    obj_t arg1448_758;
				    {
				       obj_t arg1449_759;
				       arg1449_759 = MAKE_PAIR(BNIL, BNIL);
				       arg1448_758 = MAKE_PAIR(arg1441_753, arg1449_759);
				    }
				    arg1447_757 = MAKE_PAIR(arg1440_752, arg1448_758);
				 }
				 arg1446_756 = MAKE_PAIR(arg1432_751, arg1447_757);
			      }
			      list1445_755 = MAKE_PAIR(BNIL, arg1446_756);
			   }
			   arg1400_729 = cons__138___r4_pairs_and_lists_6_3(arg1428_749, list1445_755);
			}
		     }
		     {
			obj_t list1403_731;
			{
			   obj_t arg1404_732;
			   {
			      obj_t arg1406_733;
			      arg1406_733 = MAKE_PAIR(BNIL, BNIL);
			      arg1404_732 = MAKE_PAIR(arg1400_729, arg1406_733);
			   }
			   list1403_731 = MAKE_PAIR(arg1398_728, arg1404_732);
			}
			exp_723 = cons__138___r4_pairs_and_lists_6_3(arg1396_727, list1403_731);
		     }
		  }
		  {
		     node_t node_724;
		     node_724 = sexp__node_235_ast_sexp(exp_723, BNIL, loc_719, CNST_TABLE_REF(((long) 9)));
		     {
			{
			   obj_t res1706_1263;
			   {
			      let_var_6_t obj_1261;
			      obj_1261 = (let_var_6_t) (node_724);
			      {
				 obj_t x_1407;
				 x_1407 = ((((let_var_6_t) CREF(obj_1261))->removable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				 res1706_1263 = BUNSPEC;
			      }
			   }
			   res1706_1263;
			}
			return (let_var_6_t) (node_724);
		     }
		  }
	       }
	    }
	 }
      }
   }
}


node_t 
trace_node_default1299_25_trace_walk(node_t node_7)
{
   return node_7;
}


obj_t 
_trace_node_default1299_15_trace_walk(obj_t env_1402, obj_t node_1403)
{
   {
      node_t aux_1647;
      aux_1647 = trace_node_default1299_25_trace_walk((node_t) (node_1403));
      return (obj_t) (aux_1647);
   }
}


node_t 
trace_node_95_trace_walk(node_t node_6)
{
   {
      obj_t method1606_1118;
      obj_t class1611_1119;
      {
	 obj_t arg1614_1116;
	 obj_t arg1616_1117;
	 {
	    object_t obj_1264;
	    obj_1264 = (object_t) (node_6);
	    {
	       obj_t pre_method_105_1265;
	       pre_method_105_1265 = PROCEDURE_REF(trace_node_env_147_trace_walk, ((long) 2));
	       if (INTEGERP(pre_method_105_1265))
		 {
		    PROCEDURE_SET(trace_node_env_147_trace_walk, ((long) 2), BUNSPEC);
		    arg1614_1116 = pre_method_105_1265;
		 }
	       else
		 {
		    long obj_class_num_177_1270;
		    obj_class_num_177_1270 = TYPE(obj_1264);
		    {
		       obj_t arg1183_1271;
		       arg1183_1271 = PROCEDURE_REF(trace_node_env_147_trace_walk, ((long) 1));
		       {
			  long arg1184_1275;
			  {
			     long arg1186_1276;
			     arg1186_1276 = OBJECT_TYPE;
			     arg1184_1275 = (obj_class_num_177_1270 - arg1186_1276);
			  }
			  arg1614_1116 = VECTOR_REF(arg1183_1271, arg1184_1275);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_1281;
	    object_1281 = (object_t) (node_6);
	    {
	       long arg1187_1282;
	       {
		  long arg1188_1283;
		  long arg1189_1284;
		  arg1188_1283 = TYPE(object_1281);
		  arg1189_1284 = OBJECT_TYPE;
		  arg1187_1282 = (arg1188_1283 - arg1189_1284);
	       }
	       {
		  obj_t vector_1288;
		  vector_1288 = __classes__134___object;
		  arg1616_1117 = VECTOR_REF(vector_1288, arg1187_1282);
	       }
	    }
	 }
	 {
	    obj_t aux_1666;
	    method1606_1118 = arg1614_1116;
	    class1611_1119 = arg1616_1117;
	    {
	       if (INTEGERP(method1606_1118))
		 {
		    switch ((long) CINT(method1606_1118))
		      {
		      case ((long) 0):
			 {
			    sequence_t node_1125;
			    node_1125 = (sequence_t) (node_6);
			    trace_node___31_trace_walk((((sequence_t) CREF(node_1125))->nodes));
			    aux_1666 = (obj_t) (node_1125);
			 }
			 break;
		      case ((long) 1):
			 {
			    app_t node_1127;
			    node_1127 = (app_t) (node_6);
			    trace_node___31_trace_walk((((app_t) CREF(node_1127))->args));
			    aux_1666 = (obj_t) (node_1127);
			 }
			 break;
		      case ((long) 2):
			 {
			    app_ly_162_t node_1129;
			    node_1129 = (app_ly_162_t) (node_6);
			    {
			       node_t arg1621_1131;
			       arg1621_1131 = trace_node_95_trace_walk((((app_ly_162_t) CREF(node_1129))->fun));
			       {
				  obj_t res1707_1295;
				  {
				     obj_t x_1408;
				     x_1408 = ((((app_ly_162_t) CREF(node_1129))->fun) = ((node_t) arg1621_1131), BUNSPEC);
				     res1707_1295 = BUNSPEC;
				  }
				  res1707_1295;
			       }
			    }
			    {
			       node_t arg1624_1133;
			       arg1624_1133 = trace_node_95_trace_walk((((app_ly_162_t) CREF(node_1129))->arg));
			       {
				  obj_t res1708_1299;
				  {
				     obj_t x_1409;
				     x_1409 = ((((app_ly_162_t) CREF(node_1129))->arg) = ((node_t) arg1624_1133), BUNSPEC);
				     res1708_1299 = BUNSPEC;
				  }
				  res1708_1299;
			       }
			    }
			    aux_1666 = (obj_t) (node_1129);
			 }
			 break;
		      case ((long) 3):
			 {
			    funcall_t node_1135;
			    node_1135 = (funcall_t) (node_6);
			    {
			       node_t arg1627_1137;
			       arg1627_1137 = trace_node_95_trace_walk((((funcall_t) CREF(node_1135))->fun));
			       {
				  obj_t res1709_1303;
				  {
				     obj_t x_1410;
				     x_1410 = ((((funcall_t) CREF(node_1135))->fun) = ((node_t) arg1627_1137), BUNSPEC);
				     res1709_1303 = BUNSPEC;
				  }
				  res1709_1303;
			       }
			    }
			    trace_node___31_trace_walk((((funcall_t) CREF(node_1135))->args));
			    aux_1666 = (obj_t) (node_1135);
			 }
			 break;
		      case ((long) 4):
			 {
			    pragma_t node_1140;
			    node_1140 = (pragma_t) (node_6);
			    trace_node___31_trace_walk((((pragma_t) CREF(node_1140))->args));
			    aux_1666 = (obj_t) (node_1140);
			 }
			 break;
		      case ((long) 5):
			 {
			    cast_t node_1142;
			    node_1142 = (cast_t) (node_6);
			    trace_node_95_trace_walk((((cast_t) CREF(node_1142))->arg));
			    aux_1666 = (obj_t) (node_1142);
			 }
			 break;
		      case ((long) 6):
			 {
			    setq_t node_1144;
			    node_1144 = (setq_t) (node_6);
			    {
			       node_t arg1637_1145;
			       arg1637_1145 = trace_node_95_trace_walk((((setq_t) CREF(node_1144))->value));
			       {
				  obj_t res1710_1310;
				  {
				     obj_t x_1411;
				     x_1411 = ((((setq_t) CREF(node_1144))->value) = ((node_t) arg1637_1145), BUNSPEC);
				     res1710_1310 = BUNSPEC;
				  }
				  res1710_1310;
			       }
			    }
			    aux_1666 = (obj_t) (node_1144);
			 }
			 break;
		      case ((long) 7):
			 {
			    conditional_t node_1147;
			    node_1147 = (conditional_t) (node_6);
			    {
			       node_t arg1641_1149;
			       arg1641_1149 = trace_node_95_trace_walk((((conditional_t) CREF(node_1147))->test));
			       {
				  obj_t res1711_1314;
				  {
				     obj_t x_1412;
				     x_1412 = ((((conditional_t) CREF(node_1147))->test) = ((node_t) arg1641_1149), BUNSPEC);
				     res1711_1314 = BUNSPEC;
				  }
				  res1711_1314;
			       }
			    }
			    {
			       node_t arg1643_1151;
			       arg1643_1151 = trace_node_95_trace_walk((((conditional_t) CREF(node_1147))->true));
			       {
				  obj_t res1712_1318;
				  {
				     obj_t x_1413;
				     x_1413 = ((((conditional_t) CREF(node_1147))->true) = ((node_t) arg1643_1151), BUNSPEC);
				     res1712_1318 = BUNSPEC;
				  }
				  res1712_1318;
			       }
			    }
			    {
			       node_t arg1645_1153;
			       arg1645_1153 = trace_node_95_trace_walk((((conditional_t) CREF(node_1147))->false));
			       {
				  obj_t res1713_1322;
				  {
				     obj_t x_1414;
				     x_1414 = ((((conditional_t) CREF(node_1147))->false) = ((node_t) arg1645_1153), BUNSPEC);
				     res1713_1322 = BUNSPEC;
				  }
				  res1713_1322;
			       }
			    }
			    aux_1666 = (obj_t) (node_1147);
			 }
			 break;
		      case ((long) 8):
			 {
			    fail_t node_1155;
			    node_1155 = (fail_t) (node_6);
			    {
			       node_t arg1647_1157;
			       arg1647_1157 = trace_node_95_trace_walk((((fail_t) CREF(node_1155))->proc));
			       {
				  obj_t res1714_1326;
				  {
				     obj_t x_1415;
				     x_1415 = ((((fail_t) CREF(node_1155))->proc) = ((node_t) arg1647_1157), BUNSPEC);
				     res1714_1326 = BUNSPEC;
				  }
				  res1714_1326;
			       }
			    }
			    {
			       node_t arg1650_1159;
			       arg1650_1159 = trace_node_95_trace_walk((((fail_t) CREF(node_1155))->msg));
			       {
				  obj_t res1715_1330;
				  {
				     obj_t x_1416;
				     x_1416 = ((((fail_t) CREF(node_1155))->msg) = ((node_t) arg1650_1159), BUNSPEC);
				     res1715_1330 = BUNSPEC;
				  }
				  res1715_1330;
			       }
			    }
			    {
			       node_t arg1652_1161;
			       arg1652_1161 = trace_node_95_trace_walk((((fail_t) CREF(node_1155))->obj));
			       {
				  obj_t res1716_1334;
				  {
				     obj_t x_1417;
				     x_1417 = ((((fail_t) CREF(node_1155))->obj) = ((node_t) arg1652_1161), BUNSPEC);
				     res1716_1334 = BUNSPEC;
				  }
				  res1716_1334;
			       }
			    }
			    aux_1666 = (obj_t) (node_1155);
			 }
			 break;
		      case ((long) 9):
			 {
			    select_t node_1163;
			    node_1163 = (select_t) (node_6);
			    {
			       node_t arg1654_1165;
			       arg1654_1165 = trace_node_95_trace_walk((((select_t) CREF(node_1163))->test));
			       {
				  obj_t res1717_1338;
				  {
				     obj_t x_1418;
				     x_1418 = ((((select_t) CREF(node_1163))->test) = ((node_t) arg1654_1165), BUNSPEC);
				     res1717_1338 = BUNSPEC;
				  }
				  res1717_1338;
			       }
			    }
			    {
			       obj_t l1289_1167;
			       l1289_1167 = (((select_t) CREF(node_1163))->clauses);
			     lname1290_1168:
			       if (PAIRP(l1289_1167))
				 {
				    {
				       obj_t clause_1171;
				       clause_1171 = CAR(l1289_1167);
				       {
					  node_t arg1659_1172;
					  {
					     node_t aux_1734;
					     {
						obj_t aux_1735;
						aux_1735 = CDR(clause_1171);
						aux_1734 = (node_t) (aux_1735);
					     }
					     arg1659_1172 = trace_node_95_trace_walk(aux_1734);
					  }
					  {
					     obj_t aux_1739;
					     aux_1739 = (obj_t) (arg1659_1172);
					     SET_CDR(clause_1171, aux_1739);
					  }
				       }
				    }
				    {
				       obj_t l1289_1742;
				       l1289_1742 = CDR(l1289_1167);
				       l1289_1167 = l1289_1742;
				       goto lname1290_1168;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    aux_1666 = (obj_t) (node_1163);
			 }
			 break;
		      case ((long) 10):
			 {
			    let_fun_218_t node_1175;
			    node_1175 = (let_fun_218_t) (node_6);
			    {
			       obj_t l1292_1177;
			       l1292_1177 = (((let_fun_218_t) CREF(node_1175))->locals);
			     lname1293_1178:
			       if (PAIRP(l1292_1177))
				 {
				    trace_fun__23_trace_walk(CAR(l1292_1177));
				    {
				       obj_t l1292_1751;
				       l1292_1751 = CDR(l1292_1177);
				       l1292_1177 = l1292_1751;
				       goto lname1293_1178;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1669_1183;
			       arg1669_1183 = trace_node_95_trace_walk((((let_fun_218_t) CREF(node_1175))->body));
			       {
				  obj_t res1718_1353;
				  {
				     obj_t x_1419;
				     x_1419 = ((((let_fun_218_t) CREF(node_1175))->body) = ((node_t) arg1669_1183), BUNSPEC);
				     res1718_1353 = BUNSPEC;
				  }
				  res1718_1353;
			       }
			    }
			    aux_1666 = (obj_t) (node_1175);
			 }
			 break;
		      case ((long) 11):
			 {
			    let_var_6_t node_1185;
			    node_1185 = (let_var_6_t) (node_6);
			    {
			       obj_t l1295_1187;
			       l1295_1187 = (((let_var_6_t) CREF(node_1185))->bindings);
			     lname1296_1188:
			       if (PAIRP(l1295_1187))
				 {
				    {
				       obj_t binding_1191;
				       binding_1191 = CAR(l1295_1187);
				       {
					  node_t arg1677_1192;
					  {
					     node_t aux_1762;
					     {
						obj_t aux_1763;
						aux_1763 = CDR(binding_1191);
						aux_1762 = (node_t) (aux_1763);
					     }
					     arg1677_1192 = trace_node_95_trace_walk(aux_1762);
					  }
					  {
					     obj_t aux_1767;
					     aux_1767 = (obj_t) (arg1677_1192);
					     SET_CDR(binding_1191, aux_1767);
					  }
				       }
				    }
				    {
				       obj_t l1295_1770;
				       l1295_1770 = CDR(l1295_1187);
				       l1295_1187 = l1295_1770;
				       goto lname1296_1188;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_t arg1680_1195;
			       arg1680_1195 = trace_node_95_trace_walk((((let_var_6_t) CREF(node_1185))->body));
			       {
				  obj_t res1719_1364;
				  {
				     obj_t x_1420;
				     x_1420 = ((((let_var_6_t) CREF(node_1185))->body) = ((node_t) arg1680_1195), BUNSPEC);
				     res1719_1364 = BUNSPEC;
				  }
				  res1719_1364;
			       }
			    }
			    aux_1666 = (obj_t) (node_1185);
			 }
			 break;
		      case ((long) 12):
			 {
			    set_ex_it_116_t node_1197;
			    node_1197 = (set_ex_it_116_t) (node_6);
			    {
			       node_t arg1682_1198;
			       arg1682_1198 = trace_node_95_trace_walk((((set_ex_it_116_t) CREF(node_1197))->body));
			       {
				  obj_t res1720_1368;
				  {
				     obj_t x_1421;
				     x_1421 = ((((set_ex_it_116_t) CREF(node_1197))->body) = ((node_t) arg1682_1198), BUNSPEC);
				     res1720_1368 = BUNSPEC;
				  }
				  res1720_1368;
			       }
			    }
			    aux_1666 = (obj_t) (node_1197);
			 }
			 break;
		      case ((long) 13):
			 {
			    jump_ex_it_184_t node_1200;
			    node_1200 = (jump_ex_it_184_t) (node_6);
			    {
			       node_t arg1686_1202;
			       arg1686_1202 = trace_node_95_trace_walk((((jump_ex_it_184_t) CREF(node_1200))->exit));
			       {
				  obj_t res1721_1372;
				  {
				     obj_t x_1422;
				     x_1422 = ((((jump_ex_it_184_t) CREF(node_1200))->exit) = ((node_t) arg1686_1202), BUNSPEC);
				     res1721_1372 = BUNSPEC;
				  }
				  res1721_1372;
			       }
			    }
			    {
			       node_t arg1688_1204;
			       arg1688_1204 = trace_node_95_trace_walk((((jump_ex_it_184_t) CREF(node_1200))->value));
			       {
				  obj_t res1722_1376;
				  {
				     obj_t x_1423;
				     x_1423 = ((((jump_ex_it_184_t) CREF(node_1200))->value) = ((node_t) arg1688_1204), BUNSPEC);
				     res1722_1376 = BUNSPEC;
				  }
				  res1722_1376;
			       }
			    }
			    aux_1666 = (obj_t) (node_1200);
			 }
			 break;
		      case ((long) 14):
			 {
			    make_box_202_t node_1206;
			    node_1206 = (make_box_202_t) (node_6);
			    {
			       node_t arg1690_1207;
			       arg1690_1207 = trace_node_95_trace_walk((((make_box_202_t) CREF(node_1206))->value));
			       {
				  obj_t res1723_1380;
				  {
				     obj_t x_1424;
				     x_1424 = ((((make_box_202_t) CREF(node_1206))->value) = ((node_t) arg1690_1207), BUNSPEC);
				     res1723_1380 = BUNSPEC;
				  }
				  res1723_1380;
			       }
			    }
			    aux_1666 = (obj_t) (node_1206);
			 }
			 break;
		      case ((long) 15):
			 {
			    box_ref_242_t node_1209;
			    node_1209 = (box_ref_242_t) (node_6);
			    {
			       node_t arg1693_1210;
			       {
				  node_t aux_1796;
				  {
				     var_t aux_1797;
				     aux_1797 = (((box_ref_242_t) CREF(node_1209))->var);
				     aux_1796 = (node_t) (aux_1797);
				  }
				  arg1693_1210 = trace_node_95_trace_walk(aux_1796);
			       }
			       {
				  obj_t res1724_1384;
				  {
				     var_t val1263_1383;
				     val1263_1383 = (var_t) (arg1693_1210);
				     {
					obj_t x_1425;
					x_1425 = ((((box_ref_242_t) CREF(node_1209))->var) = ((var_t) val1263_1383), BUNSPEC);
					res1724_1384 = BUNSPEC;
				     }
				  }
				  res1724_1384;
			       }
			    }
			    aux_1666 = (obj_t) (node_1209);
			 }
			 break;
		      case ((long) 16):
			 {
			    box_set__221_t node_1212;
			    node_1212 = (box_set__221_t) (node_6);
			    {
			       node_t arg1695_1214;
			       {
				  node_t aux_1805;
				  {
				     var_t aux_1806;
				     aux_1806 = (((box_set__221_t) CREF(node_1212))->var);
				     aux_1805 = (node_t) (aux_1806);
				  }
				  arg1695_1214 = trace_node_95_trace_walk(aux_1805);
			       }
			       {
				  obj_t res1725_1388;
				  {
				     var_t val1269_1387;
				     val1269_1387 = (var_t) (arg1695_1214);
				     {
					obj_t x_1426;
					x_1426 = ((((box_set__221_t) CREF(node_1212))->var) = ((var_t) val1269_1387), BUNSPEC);
					res1725_1388 = BUNSPEC;
				     }
				  }
				  res1725_1388;
			       }
			    }
			    {
			       node_t arg1697_1216;
			       arg1697_1216 = trace_node_95_trace_walk((((box_set__221_t) CREF(node_1212))->value));
			       {
				  obj_t res1726_1392;
				  {
				     obj_t x_1427;
				     x_1427 = ((((box_set__221_t) CREF(node_1212))->value) = ((node_t) arg1697_1216), BUNSPEC);
				     res1726_1392 = BUNSPEC;
				  }
				  res1726_1392;
			       }
			    }
			    aux_1666 = (obj_t) (node_1212);
			 }
			 break;
		      default:
		       case_else1612_92_1122:
			 if (PROCEDUREP(method1606_1118))
			   {
			      aux_1666 = PROCEDURE_ENTRY(method1606_1118) (method1606_1118, (obj_t) (node_6), BEOA);
			   }
			 else
			   {
			      obj_t fun1507_800;
			      fun1507_800 = PROCEDURE_REF(trace_node_env_147_trace_walk, ((long) 0));
			      aux_1666 = PROCEDURE_ENTRY(fun1507_800) (fun1507_800, (obj_t) (node_6), BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1612_92_1122;
		 }
	    }
	    return (node_t) (aux_1666);
	 }
      }
   }
}


obj_t 
_trace_node_88_trace_walk(obj_t env_1400, obj_t node_1401)
{
   {
      node_t aux_1828;
      aux_1828 = trace_node_95_trace_walk((node_t) (node_1401));
      return (obj_t) (aux_1828);
   }
}


obj_t 
trace_node___31_trace_walk(obj_t node__221_25)
{
 trace_node___31_trace_walk:
   if (NULLP(node__221_25))
     {
	return CNST_TABLE_REF(((long) 10));
     }
   else
     {
	{
	   node_t arg1509_802;
	   {
	      node_t aux_1835;
	      {
		 obj_t aux_1836;
		 aux_1836 = CAR(node__221_25);
		 aux_1835 = (node_t) (aux_1836);
	      }
	      arg1509_802 = trace_node_95_trace_walk(aux_1835);
	   }
	   {
	      obj_t aux_1840;
	      aux_1840 = (obj_t) (arg1509_802);
	      SET_CAR(node__221_25, aux_1840);
	   }
	}
	{
	   obj_t node__221_1843;
	   node__221_1843 = CDR(node__221_25);
	   node__221_25 = node__221_1843;
	   goto trace_node___31_trace_walk;
	}
     }
}


obj_t 
imported_modules_init_94_trace_walk()
{
   module_initialization_70_tools_speek(((long) 0), "TRACE_WALK");
   module_initialization_70_tools_error(((long) 0), "TRACE_WALK");
   module_initialization_70_engine_pass(((long) 0), "TRACE_WALK");
   module_initialization_70_type_type(((long) 0), "TRACE_WALK");
   module_initialization_70_ast_var(((long) 0), "TRACE_WALK");
   module_initialization_70_ast_node(((long) 0), "TRACE_WALK");
   module_initialization_70_tools_shape(((long) 0), "TRACE_WALK");
   module_initialization_70_tools_misc(((long) 0), "TRACE_WALK");
   module_initialization_70_type_env(((long) 0), "TRACE_WALK");
   module_initialization_70_ast_sexp(((long) 0), "TRACE_WALK");
   return module_initialization_70_engine_param(((long) 0), "TRACE_WALK");
}
