/*===========================================================================*/
/*   (Type/pptype.scm)                                                       */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;


static obj_t imported_modules_init_94_type_pptype();
extern obj_t module_initialization_70_type_pptype(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t _variable_type__string_13_type_pptype(obj_t, obj_t);
extern obj_t _function_type__string_239_type_pptype(obj_t, obj_t);
extern obj_t function_type__string_79_type_pptype(variable_t);
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
static obj_t require_initialization_114_type_pptype = BUNSPEC;
static obj_t library_modules_init_112_type_pptype();
extern obj_t string_to_bstring(char *);
static obj_t loop_type_pptype(obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t variable_type__string_186_type_pptype(variable_t);
static obj_t *__cnst;

DEFINE_STRING(string1262_type_pptype, string1262_type_pptype1264, "", 0);
DEFINE_STRING(string1261_type_pptype, string1261_type_pptype1265, " -> ", 4);
DEFINE_EXPORT_PROCEDURE(variable_type__string_env_196_type_pptype, _variable_type__string_13_type_pptype1266, _variable_type__string_13_type_pptype, 0L, 1);
DEFINE_EXPORT_PROCEDURE(function_type__string_env_141_type_pptype, _function_type__string_239_type_pptype1267, _function_type__string_239_type_pptype, 0L, 1);

obj_t 
module_initialization_70_type_pptype(long checksum_459, char *from_460)
{
   if (CBOOL(require_initialization_114_type_pptype))
     {
	require_initialization_114_type_pptype = BBOOL(((bool_t) 0));
	library_modules_init_112_type_pptype();
	imported_modules_init_94_type_pptype();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_type_pptype()
{
   module_initialization_70___r4_strings_6_7(((long) 0), "TYPE_PPTYPE");
   return BUNSPEC;
}


obj_t 
function_type__string_79_type_pptype(variable_t variable_2)
{
   {
      obj_t arg1148_286;
      obj_t arg1153_288;
      {
	 obj_t aux_467;
	 {
	    sfun_t obj_440;
	    {
	       value_t aux_468;
	       aux_468 = (((variable_t) CREF(variable_2))->value);
	       obj_440 = (sfun_t) (aux_468);
	    }
	    aux_467 = (((sfun_t) CREF(obj_440))->args);
	 }
	 arg1148_286 = loop_type_pptype(aux_467);
      }
      {
	 obj_t arg1214_311;
	 {
	    obj_t aux_473;
	    {
	       type_t arg1218_313;
	       arg1218_313 = (((variable_t) CREF(variable_2))->type);
	       aux_473 = (((type_t) CREF(arg1218_313))->id);
	    }
	    arg1214_311 = SYMBOL_TO_STRING(aux_473);
	 }
	 arg1153_288 = string_downcase_77___r4_strings_6_7(arg1214_311);
      }
      {
	 obj_t list1154_289;
	 {
	    obj_t arg1161_290;
	    {
	       obj_t arg1164_291;
	       arg1164_291 = MAKE_PAIR(arg1153_288, BNIL);
	       arg1161_290 = MAKE_PAIR(string1261_type_pptype, arg1164_291);
	    }
	    list1154_289 = MAKE_PAIR(arg1148_286, arg1161_290);
	 }
	 return string_append_106___r4_strings_6_7(list1154_289);
      }
   }
}


obj_t 
loop_type_pptype(obj_t args_293)
{
   if (NULLP(args_293))
     {
	return string1262_type_pptype;
     }
   else
     {
	obj_t arg1195_297;
	char *arg1197_298;
	obj_t arg1199_299;
	{
	   obj_t arg1207_304;
	   {
	      obj_t aux_484;
	      {
		 type_t arg1209_306;
		 {
		    local_t obj_443;
		    {
		       obj_t aux_485;
		       aux_485 = CAR(args_293);
		       obj_443 = (local_t) (aux_485);
		    }
		    arg1209_306 = (((local_t) CREF(obj_443))->type);
		 }
		 aux_484 = (((type_t) CREF(arg1209_306))->id);
	      }
	      arg1207_304 = SYMBOL_TO_STRING(aux_484);
	   }
	   arg1195_297 = string_downcase_77___r4_strings_6_7(arg1207_304);
	}
	{
	   bool_t test_492;
	   {
	      obj_t aux_493;
	      aux_493 = CDR(args_293);
	      test_492 = NULLP(aux_493);
	   }
	   if (test_492)
	     {
		arg1197_298 = "";
	     }
	   else
	     {
		arg1197_298 = " x ";
	     }
	}
	arg1199_299 = loop_type_pptype(CDR(args_293));
	{
	   obj_t list1200_300;
	   {
	      obj_t arg1203_301;
	      {
		 obj_t arg1204_302;
		 arg1204_302 = MAKE_PAIR(arg1199_299, BNIL);
		 {
		    obj_t aux_499;
		    aux_499 = string_to_bstring(arg1197_298);
		    arg1203_301 = MAKE_PAIR(aux_499, arg1204_302);
		 }
	      }
	      list1200_300 = MAKE_PAIR(arg1195_297, arg1203_301);
	   }
	   return string_append_106___r4_strings_6_7(list1200_300);
	}
     }
}


obj_t 
_function_type__string_239_type_pptype(obj_t env_455, obj_t variable_456)
{
   return function_type__string_79_type_pptype((variable_t) (variable_456));
}


obj_t 
variable_type__string_186_type_pptype(variable_t variable_3)
{
   {
      obj_t arg1219_314;
      {
	 obj_t aux_506;
	 {
	    type_t arg1225_316;
	    arg1225_316 = (((variable_t) CREF(variable_3))->type);
	    aux_506 = (((type_t) CREF(arg1225_316))->id);
	 }
	 arg1219_314 = SYMBOL_TO_STRING(aux_506);
      }
      return string_downcase_77___r4_strings_6_7(arg1219_314);
   }
}


obj_t 
_variable_type__string_13_type_pptype(obj_t env_457, obj_t variable_458)
{
   return variable_type__string_186_type_pptype((variable_t) (variable_458));
}


obj_t 
imported_modules_init_94_type_pptype()
{
   module_initialization_70_type_type(((long) 0), "TYPE_PPTYPE");
   return module_initialization_70_ast_var(((long) 0), "TYPE_PPTYPE");
}
