/*===========================================================================*/
/*   (Write/ast.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;


extern obj_t type_type_type;
static obj_t handler1563_write_ast(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t write_scheme_file_header_174_write_scheme(obj_t, obj_t);
extern obj_t __dest__217_engine_param;
extern obj_t exit_bigloo_229_init_main(obj_t);
static obj_t atom__string_243_write_ast(obj_t);
extern obj_t open_output_file(obj_t);
extern obj_t __src_files__222_engine_param;
extern obj_t args_list__args__33_tools_args(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t notify_error_43___error(obj_t, obj_t, obj_t);
extern obj_t open_output_string();
extern obj_t exitd_top;
static obj_t imported_modules_init_94_write_ast();
extern obj_t module_initialization_70_write_ast(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_init_main(long, char *);
extern obj_t module_initialization_70_write_scheme(long, char *);
extern obj_t module_initialization_70_type_pptype(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___os(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___pp(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t cnst_init_137_write_ast();
extern obj_t pp___pp(obj_t, obj_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t add_error_handler__155___error(obj_t, obj_t);
extern obj_t remove_error_handler__102___error();
extern obj_t function_type__string_79_type_pptype(variable_t);
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
static obj_t arg13031562_write_ast(obj_t, obj_t);
static obj_t require_initialization_114_write_ast = BUNSPEC;
static obj_t make_sfun_sinfo_243_write_ast(global_t);
static obj_t library_modules_init_112_write_ast();
extern obj_t __case_sensitive__90_engine_param;
extern char *number__string_214___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t val_from_exit__100___bexit(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t write_ast_133_write_ast(obj_t);
extern obj_t open_input_string(obj_t);
static obj_t handling_function1309_22_write_ast(obj_t, obj_t);
extern obj_t close_output_port(obj_t);
extern obj_t current_output_port;
extern obj_t shape_tools_shape(obj_t);
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern obj_t _write_ast_58_write_ast(obj_t, obj_t);
extern obj_t write_scheme_comment_102_write_scheme(obj_t, obj_t);
extern obj_t __pp_case__242___pp;
extern obj_t display___r4_output_6_10_3(obj_t, obj_t);
static obj_t handling_function1300_147_write_ast(obj_t, obj_t, obj_t, obj_t);
extern obj_t unwind_until__178___bexit(obj_t, obj_t);
extern obj_t __current_pass__25_engine_pass;
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t prefix___os(obj_t);
static obj_t __cnst[8];

DEFINE_STRING(string1570_write_ast, string1570_write_ast1586, "", 0);
DEFINE_EXPORT_PROCEDURE(write_ast_env_248_write_ast, _write_ast_58_write_ast1587, _write_ast_58_write_ast, 0L, 1);
DEFINE_STRING(string1564_write_ast, string1564_write_ast1588, ".ast", 4);
DEFINE_STRING(string1572_write_ast, string1572_write_ast1589, "  rm: ", 6);
DEFINE_STRING(string1574_write_ast, string1574_write_ast1590, "  side-effect: ", 15);
DEFINE_STRING(string1573_write_ast, string1573_write_ast1591, "  occ: ", 7);
DEFINE_STRING(string1571_write_ast, string1571_write_ast1592, "]", 1);
DEFINE_STRING(string1568_write_ast, string1568_write_ast1593, "The AST (", 9);
DEFINE_STRING(string1577_write_ast, string1577_write_ast1594, "#f", 2);
DEFINE_STRING(string1565_write_ast, string1565_write_ast1595, "write-ast", 9);
DEFINE_STRING(string1575_write_ast, string1575_write_ast1596, "[", 1);
DEFINE_STRING(string1576_write_ast, string1576_write_ast1597, "#t", 2);
DEFINE_STRING(string1566_write_ast, string1566_write_ast1598, "Can't open output file", 22);
DEFINE_STRING(string1578_write_ast, string1578_write_ast1599, "#unspecified", 12);
DEFINE_STRING(string1579_write_ast, string1579_write_ast1600, "DEFINE DEFINE-METHOD SMFUN DEFINE-INLINE SIFUN DEFINE-GENERIC SGFUN LOWER ", 74);
DEFINE_STRING(string1567_write_ast, string1567_write_ast1601, ")", 1);
DEFINE_STRING(string1569_write_ast, string1569_write_ast1602, "  predicate-of: ", 16);

obj_t 
module_initialization_70_write_ast(long checksum_1188, char *from_1189)
{
   if (CBOOL(require_initialization_114_write_ast))
     {
	require_initialization_114_write_ast = BBOOL(((bool_t) 0));
	library_modules_init_112_write_ast();
	cnst_init_137_write_ast();
	imported_modules_init_94_write_ast();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_write_ast()
{
   module_initialization_70___object(((long) 0), "WRITE_AST");
   module_initialization_70___error(((long) 0), "WRITE_AST");
   module_initialization_70___bexit(((long) 0), "WRITE_AST");
   module_initialization_70___pp(((long) 0), "WRITE_AST");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "WRITE_AST");
   module_initialization_70___r4_strings_6_7(((long) 0), "WRITE_AST");
   module_initialization_70___r4_numbers_6_5(((long) 0), "WRITE_AST");
   module_initialization_70___reader(((long) 0), "WRITE_AST");
   module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "WRITE_AST");
   module_initialization_70___r4_output_6_10_3(((long) 0), "WRITE_AST");
   module_initialization_70___os(((long) 0), "WRITE_AST");
   return BUNSPEC;
}


obj_t 
cnst_init_137_write_ast()
{
   {
      obj_t cnst_port_138_1180;
      cnst_port_138_1180 = open_input_string(string1579_write_ast);
      {
	 long i_1181;
	 i_1181 = ((long) 7);
       loop_1182:
	 {
	    bool_t test1580_1183;
	    test1580_1183 = (i_1181 == ((long) -1));
	    if (test1580_1183)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg1582_1184;
		    {
		       obj_t list1583_1185;
		       {
			  obj_t arg1584_1186;
			  arg1584_1186 = BNIL;
			  list1583_1185 = MAKE_PAIR(cnst_port_138_1180, arg1584_1186);
		       }
		       arg1582_1184 = read___reader(list1583_1185);
		    }
		    CNST_TABLE_SET(i_1181, arg1582_1184);
		 }
		 {
		    int aux_1187;
		    {
		       long aux_1213;
		       aux_1213 = (i_1181 - ((long) 1));
		       aux_1187 = (int) (aux_1213);
		    }
		    {
		       long i_1216;
		       i_1216 = (long) (aux_1187);
		       i_1181 = i_1216;
		       goto loop_1182;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
write_ast_133_write_ast(obj_t globals_1)
{
   {
      obj_t output_name_205_632;
      {
	 bool_t test1379_726;
	 {
	    obj_t obj_1094;
	    obj_1094 = __dest__217_engine_param;
	    test1379_726 = STRINGP(obj_1094);
	 }
	 if (test1379_726)
	   {
	      output_name_205_632 = __dest__217_engine_param;
	   }
	 else
	   {
	      bool_t test1380_727;
	      {
		 bool_t test1386_731;
		 {
		    obj_t obj_1095;
		    obj_1095 = __src_files__222_engine_param;
		    test1386_731 = PAIRP(obj_1095);
		 }
		 if (test1386_731)
		   {
		      obj_t arg1388_732;
		      {
			 obj_t pair_1096;
			 pair_1096 = __src_files__222_engine_param;
			 arg1388_732 = CAR(pair_1096);
		      }
		      test1380_727 = STRINGP(arg1388_732);
		   }
		 else
		   {
		      test1380_727 = ((bool_t) 0);
		   }
	      }
	      if (test1380_727)
		{
		   obj_t arg1381_728;
		   {
		      obj_t arg1385_730;
		      {
			 obj_t pair_1098;
			 pair_1098 = __src_files__222_engine_param;
			 arg1385_730 = CAR(pair_1098);
		      }
		      arg1381_728 = prefix___os(arg1385_730);
		   }
		   output_name_205_632 = string_append(arg1381_728, string1564_write_ast);
		}
	      else
		{
		   output_name_205_632 = BFALSE;
		}
	   }
      }
      {
	 obj_t port_633;
	 if (STRINGP(output_name_205_632))
	   {
	      port_633 = open_output_file(output_name_205_632);
	   }
	 else
	   {
	      port_633 = current_output_port;
	   }
	 {
	    if (OUTPUT_PORTP(port_633))
	      {
		 obj_t handler_1160;
		 handler_1160 = make_fx_procedure(handler1563_write_ast, ((long) 4), ((long) 1));
		 PROCEDURE_SET(handler_1160, ((long) 0), port_633);
		 {
		    obj_t armed1274_638;
		    armed1274_638 = MAKE_CELL(BTRUE);
		    return handling_function1300_147_write_ast(handler_1160, armed1274_638, globals_1, port_633);
		 }
	      }
	    else
	      {
		 FAILURE(string1565_write_ast, string1566_write_ast, output_name_205_632);
	      }
	 }
      }
   }
}


obj_t 
handling_function1300_147_write_ast(obj_t handler1272_1177, obj_t armed1274_1176, obj_t globals_1175, obj_t port_1174)
{
   jmp_buf jmpbuf;
   obj_t an_exit1289_5_640;
   if (SET_EXIT(an_exit1289_5_640))
     {
	RESTORE_TRACE();
	return _exit_value_;
     }
   else
     {
	an_exit1289_5_640 = (obj_t) jmpbuf;
	{
	   PUSH_EXIT(an_exit1289_5_640, ((bool_t) 1));
	   {
	      obj_t an_exitd1290_141_641;
	      an_exitd1290_141_641 = exitd_top;
	      {
		 obj_t res1292_644;
		 {
		    obj_t arg1303_1159;
		    arg1303_1159 = make_fx_procedure(arg13031562_write_ast, ((long) 1), ((long) 2));
		    PROCEDURE_SET(arg1303_1159, ((long) 0), armed1274_1176);
		    PROCEDURE_SET(arg1303_1159, ((long) 1), an_exitd1290_141_641);
		    add_error_handler__155___error(handler1272_1177, arg1303_1159);
		 }
		 {
		    obj_t val1293_649;
		    val1293_649 = handling_function1309_22_write_ast(globals_1175, port_1174);
		    {
		       bool_t test_1245;
		       {
			  obj_t aux_1246;
			  aux_1246 = CELL_REF(armed1274_1176);
			  test_1245 = CBOOL(aux_1246);
		       }
		       if (test_1245)
			 {
			    remove_error_handler__102___error();
			 }
		       else
			 {
			    BUNSPEC;
			 }
		    }
		    {
		       bool_t test1305_650;
		       {
			  obj_t aux_1249;
			  aux_1249 = val_from_exit__100___bexit(val1293_649);
			  test1305_650 = CBOOL(aux_1249);
		       }
		       if (test1305_650)
			 {
			    res1292_644 = unwind_until__178___bexit(CAR(val1293_649), CDR(val1293_649));
			 }
		       else
			 {
			    res1292_644 = val1293_649;
			 }
		    }
		 }
		 POP_EXIT();
		 return res1292_644;
	      }
	   }
	}
     }
}


obj_t 
handling_function1309_22_write_ast(obj_t globals_1179, obj_t port_1178)
{
   {
      jmp_buf jmpbuf;
      obj_t an_exit1294_33_654;
      if (SET_EXIT(an_exit1294_33_654))
	{
	   RESTORE_TRACE();
	   return _exit_value_;
	}
      else
	{
	   an_exit1294_33_654 = (obj_t) jmpbuf;
	   {
	      PUSH_EXIT(an_exit1294_33_654, ((bool_t) 0));
	      {
		 obj_t val1295_655;
		 if (CBOOL(__case_sensitive__90_engine_param))
		   {
		      BUNSPEC;
		   }
		 else
		   {
		      __pp_case__242___pp = CNST_TABLE_REF(((long) 0));
		   }
		 {
		    obj_t arg1311_657;
		    {
		       obj_t list1312_658;
		       {
			  obj_t arg1314_660;
			  {
			     obj_t arg1315_661;
			     arg1315_661 = MAKE_PAIR(string1567_write_ast, BNIL);
			     arg1314_660 = MAKE_PAIR(__current_pass__25_engine_pass, arg1315_661);
			  }
			  list1312_658 = MAKE_PAIR(string1568_write_ast, arg1314_660);
		       }
		       arg1311_657 = string_append_106___r4_strings_6_7(list1312_658);
		    }
		    write_scheme_file_header_174_write_scheme(port_1178, arg1311_657);
		 }
		 {
		    obj_t l1275_664;
		    l1275_664 = globals_1179;
		  lname1283_665:
		    if (PAIRP(l1275_664))
		      {
			 {
			    obj_t g_667;
			    g_667 = CAR(l1275_664);
			    {
			       value_t fun_668;
			       {
				  global_t obj_1107;
				  obj_1107 = (global_t) (g_667);
				  fun_668 = (((global_t) CREF(obj_1107))->value);
			       }
			       {
				  obj_t arg1320_669;
				  arg1320_669 = shape_tools_shape(g_667);
				  {
				     obj_t list1321_670;
				     list1321_670 = MAKE_PAIR(arg1320_669, BNIL);
				     write_scheme_comment_102_write_scheme(port_1178, list1321_670);
				  }
			       }
			       {
				  obj_t arg1323_672;
				  arg1323_672 = function_type__string_79_type_pptype((variable_t) (g_667));
				  {
				     obj_t list1324_673;
				     list1324_673 = MAKE_PAIR(arg1323_672, BNIL);
				     write_scheme_comment_102_write_scheme(port_1178, list1324_673);
				  }
			       }
			       {
				  obj_t arg1327_675;
				  arg1327_675 = make_sfun_sinfo_243_write_ast((global_t) (g_667));
				  {
				     obj_t list1328_676;
				     list1328_676 = MAKE_PAIR(arg1327_675, BNIL);
				     write_scheme_comment_102_write_scheme(port_1178, list1328_676);
				  }
			       }
			       {
				  obj_t arg1331_678;
				  {
				     obj_t arg1334_681;
				     obj_t arg1337_682;
				     obj_t arg1339_683;
				     {
					obj_t case_value_58_689;
					{
					   sfun_t obj_1108;
					   obj_1108 = (sfun_t) (fun_668);
					   case_value_58_689 = (((sfun_t) CREF(obj_1108))->class);
					}
					{
					   bool_t test_1286;
					   {
					      obj_t aux_1287;
					      aux_1287 = CNST_TABLE_REF(((long) 1));
					      test_1286 = (case_value_58_689 == aux_1287);
					   }
					   if (test_1286)
					     {
						arg1334_681 = CNST_TABLE_REF(((long) 2));
					     }
					   else
					     {
						bool_t test_1291;
						{
						   obj_t aux_1292;
						   aux_1292 = CNST_TABLE_REF(((long) 3));
						   test_1291 = (case_value_58_689 == aux_1292);
						}
						if (test_1291)
						  {
						     arg1334_681 = CNST_TABLE_REF(((long) 4));
						  }
						else
						  {
						     bool_t test_1296;
						     {
							obj_t aux_1297;
							aux_1297 = CNST_TABLE_REF(((long) 5));
							test_1296 = (case_value_58_689 == aux_1297);
						     }
						     if (test_1296)
						       {
							  arg1334_681 = CNST_TABLE_REF(((long) 6));
						       }
						     else
						       {
							  arg1334_681 = CNST_TABLE_REF(((long) 7));
						       }
						  }
					     }
					}
				     }
				     {
					obj_t arg1353_696;
					obj_t arg1355_697;
					arg1353_696 = shape_tools_shape(g_667);
					{
					   obj_t arg1356_698;
					   long arg1357_699;
					   {
					      obj_t l1284_700;
					      {
						 sfun_t obj_1115;
						 obj_1115 = (sfun_t) (fun_668);
						 l1284_700 = (((sfun_t) CREF(obj_1115))->args);
					      }
					      if (NULLP(l1284_700))
						{
						   arg1356_698 = BNIL;
						}
					      else
						{
						   obj_t head1286_702;
						   {
						      obj_t arg1367_713;
						      arg1367_713 = shape_tools_shape(CAR(l1284_700));
						      head1286_702 = MAKE_PAIR(arg1367_713, BNIL);
						   }
						   {
						      obj_t l1284_703;
						      obj_t tail1287_704;
						      l1284_703 = CDR(l1284_700);
						      tail1287_704 = head1286_702;
						    lname1285_705:
						      if (NULLP(l1284_703))
							{
							   arg1356_698 = head1286_702;
							}
						      else
							{
							   obj_t new_tail1288_50_708;
							   {
							      obj_t arg1363_710;
							      arg1363_710 = shape_tools_shape(CAR(l1284_703));
							      new_tail1288_50_708 = MAKE_PAIR(arg1363_710, BNIL);
							   }
							   SET_CDR(tail1287_704, new_tail1288_50_708);
							   {
							      obj_t tail1287_1318;
							      obj_t l1284_1316;
							      l1284_1316 = CDR(l1284_703);
							      tail1287_1318 = new_tail1288_50_708;
							      tail1287_704 = tail1287_1318;
							      l1284_703 = l1284_1316;
							      goto lname1285_705;
							   }
							}
						   }
						}
					   }
					   {
					      sfun_t obj_1128;
					      obj_1128 = (sfun_t) (fun_668);
					      arg1357_699 = (((sfun_t) CREF(obj_1128))->arity);
					   }
					   arg1355_697 = args_list__args__33_tools_args(arg1356_698, BINT(arg1357_699));
					}
					arg1337_682 = MAKE_PAIR(arg1353_696, arg1355_697);
				     }
				     {
					obj_t aux_1325;
					{
					   sfun_t obj_1131;
					   obj_1131 = (sfun_t) (fun_668);
					   aux_1325 = (((sfun_t) CREF(obj_1131))->body);
					}
					arg1339_683 = shape_tools_shape(aux_1325);
				     }
				     {
					obj_t list1341_685;
					{
					   obj_t arg1342_686;
					   {
					      obj_t arg1343_687;
					      arg1343_687 = MAKE_PAIR(BNIL, BNIL);
					      arg1342_686 = MAKE_PAIR(arg1339_683, arg1343_687);
					   }
					   list1341_685 = MAKE_PAIR(arg1337_682, arg1342_686);
					}
					arg1331_678 = cons__138___r4_pairs_and_lists_6_3(arg1334_681, list1341_685);
				     }
				  }
				  {
				     obj_t list1332_679;
				     list1332_679 = MAKE_PAIR(port_1178, BNIL);
				     pp___pp(arg1331_678, list1332_679);
				  }
			       }
			    }
			 }
			 {
			    obj_t l1275_1335;
			    l1275_1335 = CDR(l1275_664);
			    l1275_664 = l1275_1335;
			    goto lname1283_665;
			 }
		      }
		    else
		      {
			 ((bool_t) 1);
		      }
		 }
		 val1295_655 = close_output_port(port_1178);
		 POP_EXIT();
		 return val1295_655;
	      }
	   }
	}
   }
}


obj_t 
_write_ast_58_write_ast(obj_t env_1161, obj_t globals_1162)
{
   return write_ast_133_write_ast(globals_1162);
}


obj_t 
arg13031562_write_ast(obj_t env_1163, obj_t arg_1166)
{
   {
      obj_t armed1274_1164;
      obj_t an_exitd1290_141_1165;
      armed1274_1164 = PROCEDURE_REF(env_1163, ((long) 0));
      an_exitd1290_141_1165 = PROCEDURE_REF(env_1163, ((long) 1));
      {
	 obj_t arg_646;
	 arg_646 = arg_1166;
	 CELL_SET(armed1274_1164, BFALSE);
	 return unwind_until__178___bexit(an_exitd1290_141_1165, arg_646);
      }
   }
}


obj_t 
handler1563_write_ast(obj_t env_1168, obj_t escape_1170, obj_t proc_1171, obj_t mes_1172, obj_t obj_1173)
{
   {
      obj_t port_1169;
      port_1169 = PROCEDURE_REF(env_1168, ((long) 0));
      {
	 obj_t escape_719;
	 obj_t proc_720;
	 obj_t mes_721;
	 obj_t obj_722;
	 escape_719 = escape_1170;
	 proc_720 = proc_1171;
	 mes_721 = mes_1172;
	 obj_722 = obj_1173;
	 notify_error_43___error(proc_720, mes_721, obj_722);
	 close_output_port(port_1169);
	 return exit_bigloo_229_init_main(BINT(((long) -8)));
      }
   }
}


obj_t 
make_sfun_sinfo_243_write_ast(global_t g_2)
{
   {
      value_t sfun_734;
      sfun_734 = (((global_t) CREF(g_2))->value);
      {
	 obj_t arg1391_736;
	 obj_t arg1398_738;
	 obj_t arg1400_739;
	 char *arg1403_741;
	 obj_t arg1406_743;
	 if (CBOOL(__case_sensitive__90_engine_param))
	   {
	      obj_t aux_1351;
	      aux_1351 = (((global_t) CREF(g_2))->import);
	      arg1391_736 = SYMBOL_TO_STRING(aux_1351);
	   }
	 else
	   {
	      obj_t arg1426_757;
	      {
		 obj_t aux_1354;
		 aux_1354 = (((global_t) CREF(g_2))->import);
		 arg1426_757 = SYMBOL_TO_STRING(aux_1354);
	      }
	      arg1391_736 = string_downcase_77___r4_strings_6_7(arg1426_757);
	   }
	 {
	    obj_t aux_1358;
	    {
	       sfun_t obj_1143;
	       obj_1143 = (sfun_t) (sfun_734);
	       aux_1358 = (((sfun_t) CREF(obj_1143))->side_effect__165);
	    }
	    arg1398_738 = atom__string_243_write_ast(aux_1358);
	 }
	 {
	    obj_t t_760;
	    {
	       sfun_t obj_1144;
	       obj_1144 = (sfun_t) (sfun_734);
	       t_760 = (((sfun_t) CREF(obj_1144))->predicate_of_78);
	    }
	    {
	       bool_t test1429_761;
	       test1429_761 = is_a__118___object(t_760, type_type_type);
	       if (test1429_761)
		 {
		    obj_t arg1432_763;
		    {
		       obj_t arg1440_764;
		       arg1440_764 = shape_tools_shape(t_760);
		       arg1432_763 = atom__string_243_write_ast(arg1440_764);
		    }
		    arg1400_739 = string_append(string1569_write_ast, arg1432_763);
		 }
	       else
		 {
		    arg1400_739 = string1570_write_ast;
		 }
	    }
	 }
	 arg1403_741 = integer__string_135___r4_numbers_6_5_fixnum((((global_t) CREF(g_2))->occurrence), BNIL);
	 arg1406_743 = atom__string_243_write_ast((((global_t) CREF(g_2))->removable));
	 {
	    obj_t list1409_745;
	    {
	       obj_t arg1410_746;
	       {
		  obj_t arg1411_747;
		  {
		     obj_t arg1412_748;
		     {
			obj_t arg1414_749;
			{
			   obj_t arg1415_750;
			   {
			      obj_t arg1416_751;
			      {
				 obj_t arg1417_752;
				 {
				    obj_t arg1418_753;
				    {
				       obj_t arg1420_754;
				       arg1420_754 = MAKE_PAIR(string1571_write_ast, BNIL);
				       arg1418_753 = MAKE_PAIR(arg1406_743, arg1420_754);
				    }
				    arg1417_752 = MAKE_PAIR(string1572_write_ast, arg1418_753);
				 }
				 {
				    obj_t aux_1376;
				    aux_1376 = string_to_bstring(arg1403_741);
				    arg1416_751 = MAKE_PAIR(aux_1376, arg1417_752);
				 }
			      }
			      arg1415_750 = MAKE_PAIR(string1573_write_ast, arg1416_751);
			   }
			   arg1414_749 = MAKE_PAIR(arg1400_739, arg1415_750);
			}
			arg1412_748 = MAKE_PAIR(arg1398_738, arg1414_749);
		     }
		     arg1411_747 = MAKE_PAIR(string1574_write_ast, arg1412_748);
		  }
		  arg1410_746 = MAKE_PAIR(arg1391_736, arg1411_747);
	       }
	       list1409_745 = MAKE_PAIR(string1575_write_ast, arg1410_746);
	    }
	    return string_append_106___r4_strings_6_7(list1409_745);
	 }
      }
   }
}


obj_t 
atom__string_243_write_ast(obj_t atom_768)
{
   {
      {
	 long aux1298_771;
	 if (CNSTP(atom_768))
	   {
	      aux1298_771 = CCNST(atom_768);
	   }
	 else
	   {
	      aux1298_771 = ((long) -1);
	   }
	 switch (aux1298_771)
	   {
	   case ((long) 2):
	      return string1576_write_ast;
	      break;
	   case ((long) 1):
	      return string1577_write_ast;
	      break;
	   case ((long) 3):
	      return string1578_write_ast;
	      break;
	   default:
	      if (SYMBOLP(atom_768))
		{
		   if (CBOOL(__case_sensitive__90_engine_param))
		     {
			return SYMBOL_TO_STRING(atom_768);
		     }
		   else
		     {
			obj_t arg1449_776;
			arg1449_776 = SYMBOL_TO_STRING(atom_768);
			return string_downcase_77___r4_strings_6_7(arg1449_776);
		     }
		}
	      else
		{
		   bool_t test_1396;
		   if (INTEGERP(atom_768))
		     {
			test_1396 = ((bool_t) 1);
		     }
		   else
		     {
			test_1396 = REALP(atom_768);
		     }
		   if (test_1396)
		     {
			{
			   char *aux_1400;
			   aux_1400 = number__string_214___r4_numbers_6_5(atom_768, BNIL);
			   return string_to_bstring(aux_1400);
			}
		     }
		   else
		     {
			if (STRINGP(atom_768))
			  {
			     return atom_768;
			  }
			else
			  {
			     {
				obj_t p_780;
				p_780 = open_output_string();
				{
				   obj_t list1453_781;
				   list1453_781 = MAKE_PAIR(p_780, BNIL);
				   display___r4_output_6_10_3(atom_768, list1453_781);
				}
				return close_output_port(p_780);
			     }
			  }
		     }
		}
	   }
      }
   }
}


obj_t 
imported_modules_init_94_write_ast()
{
   module_initialization_70_tools_speek(((long) 0), "WRITE_AST");
   module_initialization_70_tools_error(((long) 0), "WRITE_AST");
   module_initialization_70_engine_pass(((long) 0), "WRITE_AST");
   module_initialization_70_type_type(((long) 0), "WRITE_AST");
   module_initialization_70_ast_var(((long) 0), "WRITE_AST");
   module_initialization_70_ast_node(((long) 0), "WRITE_AST");
   module_initialization_70_engine_param(((long) 0), "WRITE_AST");
   module_initialization_70_init_main(((long) 0), "WRITE_AST");
   module_initialization_70_write_scheme(((long) 0), "WRITE_AST");
   module_initialization_70_type_pptype(((long) 0), "WRITE_AST");
   module_initialization_70_tools_shape(((long) 0), "WRITE_AST");
   return module_initialization_70_tools_args(((long) 0), "WRITE_AST");
}
