;* --------------------------------------------------------------------*/
;*    Copyright (c) 1992-1998 by Manuel Serrano. All rights reserved.  */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \   /  '                               */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome. Send them to                                          */
;*        Manuel Serrano -- Manuel.Serrano@unice.fr                    */
;*-------------------------------------------------------------------- */
;*=====================================================================*/
;*    serrano/prgm/project/bigloo/runtime1.9c/Eval/expd-try.scm        */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel SERRANO                                    */
;*    Creation    :  Tue Sep  1 16:21:59 1992                          */
;*    Last change :  Tue Aug  5 11:13:53 1997 (serrano)                */
;*    -------------------------------------------------------------    */
;*    Try form expansion                                               */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module __expander_try
   
   (import  (__error                   "Llib/error.scm")
	    (__bigloo                  "Llib/bigloo.scm")
	    (__tvector                 "Llib/tvector.scm")
	    (__structure               "Llib/struct.scm")
	    (__tvector                 "Llib/tvector.scm")
	    (__bexit                   "Llib/bexit.scm")
	    
	    (__reader                  "Read/reader.scm")
	    
	    (__rgc                     "Rgc/runtime.scm")
	    
	    (__r4_numbers_6_5          "Ieee/number.scm")
	    (__r4_numbers_6_5_fixnum   "Ieee/fixnum.scm")
	    (__r4_numbers_6_5_flonum   "Ieee/flonum.scm")
	    (__r4_characters_6_6       "Ieee/char.scm")
	    (__r4_equivalence_6_2      "Ieee/equiv.scm")
	    (__r4_booleans_6_1         "Ieee/boolean.scm")
	    (__r4_symbols_6_4          "Ieee/symbol.scm")
	    (__r4_strings_6_7          "Ieee/string.scm")
	    (__r4_pairs_and_lists_6_3  "Ieee/pair-list.scm")
	    (__r4_input_6_10_2         "Ieee/input.scm")
	    (__r4_control_features_6_9 "Ieee/control.scm")
	    (__r4_vectors_6_8          "Ieee/vector.scm")
	    (__r4_ports_6_10_1         "Ieee/port.scm")
	    (__r4_output_6_10_3        "Ieee/output.scm")
	    
	    (__progn                   "Eval/progn.scm"))
   
   (use     (__type                    "Llib/type.scm")
	    (__evenv                   "Eval/evenv.scm"))
   
   (export  (expand-try <expression> <expander>)))

;*---------------------------------------------------------------------*/
;*    expand-try ...                                                   */
;*    -------------------------------------------------------------    */
;*    This is a fixed version of expand-try. The fix has been          */
;*    proposed by:                                                     */
;*       Christopher Oliver  -- oliver@fritz.co.traverse.com           */
;*    Many thanks ...                                                  */
;*---------------------------------------------------------------------*/
(define (expand-try x e)
   (match-case x
      ((?- (and ?body (not ())) ?handler)
       (let ((nhandler (gensym 'handler))
             (nbody    (gensym 'body))
             (armed    (gensym 'armed)))
          (e `(let ((,nhandler ,handler)
		    (,nbody    (lambda () ,body))
		    (,armed    #t))
                 (bind-exit (escape)
                    (add-error-handler! ,nhandler
					(lambda (arg)
					   (set! ,armed #f)
					   (escape arg)))
                    (unwind-protect
		       (,nbody)
		       (if ,armed (remove-error-handler!)))))
             e)))
      (else
       (error "try" "Illegal form" x))))

(define (old-expand-try x e)
   (match-case x
      ((?- (and ?body (not ())) ?handler)
       (let ((nhandler (gensym 'handler))
             (nbody    (gensym 'body))
             (armed    (gensym 'armed))
             (result   (gensym 'result)))
          (e `(let ((,nhandler ,handler)
		    (,nbody    (lambda () ,body))
		    (,armed    #t)
		    (,result   '()))
                 (bind-exit (escape)
                    (add-error-handler! ,nhandler
					(lambda (arg)
					   (set! ,armed #f)
					   (escape arg)))
                    (unwind-protect
		       (set! ,result (,nbody))
		       (if ,armed (remove-error-handler!)))
                    ,result))
             e)))
      (else
       (error "try" "Illegal form" x))))

