;* --------------------------------------------------------------------*/
;*    Copyright (c) 1992-1998 by Manuel Serrano. All rights reserved.  */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \   /  '                               */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome. Send them to                                          */
;*        Manuel Serrano -- Manuel.Serrano@unice.fr                    */
;*-------------------------------------------------------------------- */
;*---------------------------------------------------------------------*/
;*    serrano/prgm/project/bigloo/runtime1.8/Rgc/cstate.scm            */
;*                                                                     */
;*    Auteur      :  Manuel SERRANO                                    */
;*    Creation    :  Thu Jun 20 11:10:10 1991                          */
;*    Last change :  Mon Jul 10 14:45:10 1995 (serrano)                */
;*                                                                     */
;*    La generation des etats compactes                                */
;*---------------------------------------------------------------------*/

;*---------------------------------------------------------------------*/
;*     Le module                                                       */
;*---------------------------------------------------------------------*/
(module __rgc_cstate
   
   (import  (__error                   "Llib/error.scm")
	    (__bigloo                  "Llib/bigloo.scm")
	    (__tvector                 "Llib/tvector.scm")
	    (__structure               "Llib/struct.scm")
	    (__tvector                 "Llib/tvector.scm")
	    (__r4_numbers_6_5          "Ieee/number.scm")
	    (__r4_numbers_6_5_fixnum   "Ieee/fixnum.scm")
	    (__r4_numbers_6_5_flonum   "Ieee/flonum.scm")
	    (__r4_characters_6_6       "Ieee/char.scm")
	    (__r4_equivalence_6_2      "Ieee/equiv.scm")
	    (__r4_booleans_6_1         "Ieee/boolean.scm")
	    (__r4_symbols_6_4          "Ieee/symbol.scm")
	    (__r4_strings_6_7          "Ieee/string.scm")
	    (__r4_pairs_and_lists_6_3  "Ieee/pair-list.scm")
	    (__r4_input_6_10_2         "Ieee/input.scm")
	    (__r4_control_features_6_9 "Ieee/control.scm")
	    (__r4_vectors_6_8          "Ieee/vector.scm")
	    (__r4_ports_6_10_1         "Ieee/port.scm")
	    (__r4_output_6_10_3        "Ieee/output.scm")
	    (__rgc                     "Rgc/runtime.scm")
	    (__rgc_transition          "Rgc/transition.scm")
	    (__rgc_automata            "Rgc/automata.scm")
	    (__rgc_optimize            "Rgc/optimize.scm"))
   
   (use     (__type                    "Llib/type.scm")
	    (__evenv                   "Eval/evenv.scm"))

   (export  (decl-cstate n a s l e)))

;*---------------------------------------------------------------------*/
;*     decl-cstate ...                                                 */
;*---------------------------------------------------------------------*/
(define (decl-cstate state-name accept? state-num l else-c&t)
   ((if (looping? state-num accept?) code-clooping code-cstate)
       state-name accept? state-num l else-c&t) )

;*---------------------------------------------------------------------*/
;*     code-clooping ...                                               */
;*---------------------------------------------------------------------*/
(define (code-clooping state-name accept? state-num l else-c&t)
   `(,state-name ()
		 (let ((c (input-port-read-char input-port)))
		    (cond
		       (,(car (cdr (car l)))
			(,state-name) )
		       (,(if (c->fx *rgc-first-char* 1)
			     `(rgc-<? c ,*rgc-first-char*)
			     `(rgc-=? c 0))
			(input-port-remember-back-ref input-port)
			(if (input-port-fill-buffer input-port)
			    (,state-name)
			    ,@(accept? state-num)))
		       (else
			(input-port-remember-back-ref input-port)
			,@(accept? state-num))))))
       
;*---------------------------------------------------------------------*/
;*     code-cstate ...                                                 */
;*---------------------------------------------------------------------*/
(define (code-cstate state-name accept? state-num l else-c&t)
   `(,state-name (mr)
		 (let ((c (input-port-read-char input-port)))
		    (cond
		       ,@(cost&test*->body state-num l else-c&t accept?)))))
       
;*---------------------------------------------------------------------*/
;*     cost&test*->body ...                                            */
;*---------------------------------------------------------------------*/
(define (cost&test*->body state-num l else-c&t accept?)
   (let loop ((l l))
      (if (null? l)
	  '()
	  (let ((pr (cdr (car l))))
	     (if (null? (cdr l))
		 ;; Il ne reste plus qu'un test a faire.
		 ;; On test maintenant 'end of buffer' et on regarde
		 ;; s'il est ruse d'inverser le 'else'
		 ;; avec le dernier test.
		 ;; Eventuellement le else peut etre no-else
		 ;; dans ce cas le dernier test est juste transformer en else
		 (if (>fx (car (car l)) (car else-c&t))
		     ;; oui, c'est ruse...
		     (if (not (eq? (cadr else-c&t) 'no-test))
			 ;; il y a effectivement un 'else'
			 (list (code-abort (cadr else-c&t))
			       (code-eofb state-num)
			       (list 'else
				     (code-> state-num pr accept?) ) )
			 ;; il n'y avait pas de 'else'
			 (list (code-eofb state-num)
			       (list 'else
				     (code-> state-num pr accept?) ) ) )
		     ;; non, c'a ne l'est pas...
		     (list (list (car pr)
				 (code-> state-num pr accept?))
			   (code-eofb state-num)
			   (code-abort 'else)) )
		 ;; il reste plusieurs tests a faire
		 (begin
		    (cons (list (car pr)
				(code-> state-num pr accept?))
			  (loop (cdr l)))))))))

;*---------------------------------------------------------------------*/
;*     code-eofb ... (le codage des eof et eob)                        */
;*     code-eofb: --> code                                             */
;*---------------------------------------------------------------------*/
(define (code-eofb state-num)
   `(,(if (c->fx *rgc-first-char* 1)
	  `(rgc-<? c ,*rgc-first-char*)
	  `(rgc-=? c 0))
     (if (input-port-fill-buffer input-port)
	 (,(state->symbol state-num) mr)
	 mr)))

;*---------------------------------------------------------------------*/
;*     code-abort ... (codage des unmatch)                             */
;*     code-abort: test -> code                                        */
;*---------------------------------------------------------------------*/
(define (code-abort test)
   `(,test mr) )


