/*===========================================================================*/
/*   (Cfa/cinfo.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     obj_t key;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     obj_t key;
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
     obj_t key;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
     obj_t key;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     obj_t key;
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


obj_t pre_vector_set__app_211_cfa_info = BUNSPEC;
static obj_t struct_object__object_procedure_set__app3616_107_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_pre_clo_env3556_124_cfa_info(obj_t, obj_t, obj_t);
static setq_t allocate_setq_cinfo_202_cfa_info();
static obj_t struct_object__object_approx3546_115_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_pre_clo_env3557_197_cfa_info(obj_t, obj_t);
static obj_t _allocate_make_box_o_cinfo_133_cfa_info(obj_t);
static obj_t object__struct_box_ref_o_cinfo3605_141_cfa_info(obj_t, obj_t);
static make_box_202_t allocate_make_box_o_cinfo_222_cfa_info();
static app_t allocate_pre_procedure_set__app_97_cfa_info();
static obj_t object__struct_intern_sfun_cinfo3553_214_cfa_info(obj_t, obj_t);
static obj_t _allocate_intern_sfun_cinfo_249_cfa_info(obj_t);
static obj_t _allocate_cvar_cinfo_74_cfa_info(obj_t);
static obj_t struct_object__object_procedure_ref_app3614_131_cfa_info(obj_t, obj_t, obj_t);
obj_t app_ly_cinfo_234_cfa_info = BUNSPEC;
static obj_t object__struct_approx3547_109_cfa_info(obj_t, obj_t);
static box_set__221_t allocate_box_set__cinfo_232_cfa_info();
static kwote_t allocate_kwote_cinfo_134_cfa_info();
static obj_t _allocate_set_ex_it_cinfo_22_cfa_info(obj_t);
static obj_t object__struct_fail_cinfo3585_16_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_intern_sfun_cinfo3552_203_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_svar_cinfo3558_151_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_pre_create_vector_app3621_112_cfa_info(obj_t, obj_t);
static app_t allocate_vector_ref_app_0_cfa_info();
static obj_t object__struct_cfun_cinfo3549_117_cfa_info(obj_t, obj_t);
obj_t svar_cinfo_166_cfa_info = BUNSPEC;
static obj_t _allocate_make_vector_app_18_cfa_info(obj_t);
static conditional_t allocate_conditional_cinfo_71_cfa_info();
static app_t allocate_make_vector_app_226_cfa_info();
static obj_t _allocate_pragma_cinfo_82_cfa_info(obj_t);
static box_ref_242_t allocate_box_ref_cinfo_31_cfa_info();
static box_set__221_t allocate_box_set__o_cinfo_236_cfa_info();
static app_t allocate_pre_make_procedure_app_4_cfa_info();
static kwote_t allocate_kwote_node_139_cfa_info();
obj_t setq_cinfo_191_cfa_info = BUNSPEC;
obj_t cvar_cinfo_53_cfa_info = BUNSPEC;
obj_t pre_clo_env_191_cfa_info = BUNSPEC;
static obj_t object__struct_procedure_ref_app3615_121_cfa_info(obj_t, obj_t);
static sfun_t allocate_extern_sfun_cinfo_223_cfa_info();
extern obj_t scnst_ast_var;
static obj_t _allocate_vector_ref_app_194_cfa_info(obj_t);
static obj_t object__struct_pre_make_vector_app3619_96_cfa_info(obj_t, obj_t);
extern obj_t global_ast_var;
static obj_t object__struct_vector_ref_app3631_178_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_sexit_cinfo3562_95_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_pre_make_procedure_app3606_172_cfa_info(obj_t, obj_t, obj_t);
static pragma_t allocate_pragma_cinfo_134_cfa_info();
static obj_t struct_object__object_pre_vector_ref_app3622_186_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_setq_cinfo3581_231_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_pre_struct_set__app3638_251_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_funcall_cinfo_40_cfa_info(obj_t);
static app_t allocate_make_struct_app_180_cfa_info();
static obj_t _allocate_reshaped_global_82_cfa_info(obj_t);
extern obj_t _struct_object__object_6___object(obj_t, obj_t, obj_t);
static obj_t object__struct_pre_vector_set__app3625_165_cfa_info(obj_t, obj_t);
static obj_t object__struct_reshaped_global3567_93_cfa_info(obj_t, obj_t);
static app_ly_162_t allocate_app_ly_cinfo_200_cfa_info();
static obj_t object__struct_svar_cinfo3559_43_cfa_info(obj_t, obj_t);
static app_t allocate_pre_make_struct_app_64_cfa_info();
obj_t box_ref_o_cinfo_98_cfa_info = BUNSPEC;
obj_t jump_ex_it_cinfo_139_cfa_info = BUNSPEC;
static obj_t imported_modules_init_94_cfa_info();
static obj_t struct_object__object_create_vector_app3628_76_cfa_info(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t sexit_ast_var;
static obj_t _allocate_box_set__o_cinfo_20_cfa_info(obj_t);
static obj_t struct_object__object_cvar_cinfo3560_206_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_pre_make_vector_app3618_161_cfa_info(obj_t, obj_t, obj_t);
static local_t allocate_reshaped_local_100_cfa_info();
static obj_t toplevel_init_63_cfa_info();
static obj_t struct_object__object_kwote_node3570_241_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_kwote_node_49_cfa_info(obj_t);
static obj_t cnst_init_137_cfa_info();
static obj_t object__struct_pre_procedure_ref_app3609_217_cfa_info(obj_t, obj_t);
static obj_t _allocate_make_box_cinfo_36_cfa_info(obj_t);
static obj_t _allocate_procedure_set__app_204_cfa_info(obj_t);
static obj_t object__struct_scnst_cinfo3555_66_cfa_info(obj_t, obj_t);
static obj_t object__struct_make_box_cinfo3595_155_cfa_info(obj_t, obj_t);
static app_t allocate_procedure_ref_app_165_cfa_info();
static obj_t struct_object__object_set_ex_it_cinfo3588_212_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_make_vector_app3627_193_cfa_info(obj_t, obj_t);
obj_t conditional_cinfo_212_cfa_info = BUNSPEC;
static obj_t _allocate_approx_254_cfa_info(obj_t);
static obj_t object__struct_funcall_cinfo3577_159_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_extern_sfun_cinfo3550_31_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_pre_procedure_ref_app_105_cfa_info(obj_t);
obj_t create_vector_app_150_cfa_info = BUNSPEC;
static set_ex_it_116_t allocate_set_ex_it_cinfo_32_cfa_info();
obj_t pragma_cinfo_220_cfa_info = BUNSPEC;
static app_t allocate_vector_set__app_126_cfa_info();
extern obj_t cfun_ast_var;
obj_t pre_make_procedure_app_60_cfa_info = BUNSPEC;
obj_t fail_cinfo_75_cfa_info = BUNSPEC;
static obj_t struct_object__object_pre_vector_set__app3624_62_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_scnst_cinfo3554_122_cfa_info(obj_t, obj_t, obj_t);
static app_t allocate_pre_struct_set__app_186_cfa_info();
static obj_t object__struct_sexit_cinfo3563_64_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_box_ref_o_cinfo3604_201_cfa_info(obj_t, obj_t, obj_t);
static svar_t allocate_svar_cinfo_217_cfa_info();
static scnst_t allocate_scnst_cinfo_156_cfa_info();
static obj_t _allocate_make_struct_app_151_cfa_info(obj_t);
obj_t pre_create_vector_app_162_cfa_info = BUNSPEC;
static obj_t struct_object__object_pre_make_struct_app3634_112_cfa_info(obj_t, obj_t, obj_t);
static app_t allocate_pre_vector_ref_app_241_cfa_info();
static obj_t _allocate_kwote_cinfo_178_cfa_info(obj_t);
obj_t set_ex_it_cinfo_168_cfa_info = BUNSPEC;
static app_t allocate_pre_create_vector_app_95_cfa_info();
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
static app_t allocate_pre_vector_set__app_20_cfa_info();
obj_t pre_vector_ref_app_208_cfa_info = BUNSPEC;
static obj_t _allocate_extern_sfun_cinfo_234_cfa_info(obj_t);
static obj_t struct_object__object_funcall_cinfo3576_157_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_vector(long, obj_t);
static obj_t struct_object__object_make_vector_app3626_193_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_pre_make_box_48_cfa_info(obj_t);
static app_t allocate_create_vector_app_89_cfa_info();
static obj_t require_initialization_114_cfa_info = BUNSPEC;
static obj_t object__struct_make_box_o_cinfo3597_33_cfa_info(obj_t, obj_t);
obj_t scnst_cinfo_0_cfa_info = BUNSPEC;
obj_t pre_procedure_set__app_208_cfa_info = BUNSPEC;
static obj_t object__struct_app_ly_cinfo3575_89_cfa_info(obj_t, obj_t);
static obj_t object__struct_pre_struct_set__app3639_134_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_cfun_cinfo3548_146_cfa_info(obj_t, obj_t, obj_t);
obj_t kwote_cinfo_48_cfa_info = BUNSPEC;
static obj_t _allocate_create_vector_app_246_cfa_info(obj_t);
static obj_t struct_object__object_jump_ex_it_cinfo3590_166_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_pre_struct_ref_app3636_243_cfa_info(obj_t, obj_t, obj_t);
obj_t make_procedure_app_48_cfa_info = BUNSPEC;
static app_t allocate_struct_ref_app_224_cfa_info();
static obj_t library_modules_init_112_cfa_info();
static obj_t struct_object__object_setq_cinfo3580_159_cfa_info(obj_t, obj_t, obj_t);
obj_t atom_cinfo_155_cfa_info = BUNSPEC;
obj_t make_box_cinfo_127_cfa_info = BUNSPEC;
obj_t kwote_node_102_cfa_info = BUNSPEC;
static obj_t _allocate_conditional_cinfo_139_cfa_info(obj_t);
static obj_t _allocate_cfun_cinfo_87_cfa_info(obj_t);
obj_t sexit_cinfo_49_cfa_info = BUNSPEC;
static obj_t object__struct_set_ex_it_cinfo3589_142_cfa_info(obj_t, obj_t);
obj_t struct_ref_app_73_cfa_info = BUNSPEC;
static box_ref_242_t allocate_box_ref_o_cinfo_99_cfa_info();
static obj_t _allocate_pre_vector_set__app_63_cfa_info(obj_t);
extern obj_t sfun_ast_var;
static obj_t object__struct_pre_procedure_set__app3611_110_cfa_info(obj_t, obj_t);
static obj_t _allocate_jump_ex_it_cinfo_34_cfa_info(obj_t);
static approx_t allocate_approx_85_cfa_info();
obj_t pre_make_vector_app_251_cfa_info = BUNSPEC;
static obj_t struct_object__object_atom_cinfo3568_174_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_jump_ex_it_cinfo3591_236_cfa_info(obj_t, obj_t);
obj_t vector_ref_app_195_cfa_info = BUNSPEC;
obj_t box_set__cinfo_94_cfa_info = BUNSPEC;
static obj_t struct_object__object_box_set__o_cinfo3602_212_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_atom_cinfo3569_29_cfa_info(obj_t, obj_t);
extern obj_t conditional_ast_node;
static app_t allocate_pre_struct_ref_app_69_cfa_info();
static app_t allocate_struct_set__app_3_cfa_info();
static obj_t object__struct_struct_ref_app3643_175_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_box_set__cinfo3598_217_cfa_info(obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
obj_t pre_make_struct_app_218_cfa_info = BUNSPEC;
static obj_t object__struct_make_struct_app3641_26_cfa_info(obj_t, obj_t);
extern obj_t box_set__221_ast_node;
static fail_t allocate_fail_cinfo_138_cfa_info();
extern obj_t select_ast_node;
static obj_t _allocate_sexit_cinfo_64_cfa_info(obj_t);
extern obj_t open_input_string(obj_t);
obj_t procedure_set__app_32_cfa_info = BUNSPEC;
static obj_t struct_object__object_struct_ref_app3642_41_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_fail_cinfo_247_cfa_info(obj_t);
static obj_t _allocate_svar_cinfo_185_cfa_info(obj_t);
static obj_t struct_object__object_pre_procedure_set__app3610_224_cfa_info(obj_t, obj_t, obj_t);
static cvar_t allocate_cvar_cinfo_69_cfa_info();
extern obj_t pragma_ast_node;
obj_t make_box_o_cinfo_96_cfa_info = BUNSPEC;
static obj_t _allocate_procedure_ref_app_56_cfa_info(obj_t);
static obj_t object__struct_vector_set__app3633_171_cfa_info(obj_t, obj_t);
static obj_t _allocate_box_set__cinfo_187_cfa_info(obj_t);
static sfun_t allocate_intern_sfun_cinfo_151_cfa_info();
static obj_t struct_object__object_make_box_cinfo3594_129_cfa_info(obj_t, obj_t, obj_t);
static cfun_t allocate_cfun_cinfo_179_cfa_info();
obj_t pre_make_box_186_cfa_info = BUNSPEC;
static obj_t _allocate_struct_ref_app_88_cfa_info(obj_t);
static obj_t struct_object__object_pre_create_vector_app3620_75_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_pre_vector_ref_app_31_cfa_info(obj_t);
extern long class_num_218___object(obj_t);
static obj_t _allocate_pre_create_vector_app_171_cfa_info(obj_t);
static obj_t object__struct_kwote_node3571_68_cfa_info(obj_t, obj_t);
static obj_t _allocate_reshaped_local_17_cfa_info(obj_t);
static obj_t _allocate_box_ref_o_cinfo_197_cfa_info(obj_t);
obj_t struct_set__app_162_cfa_info = BUNSPEC;
static obj_t _allocate_pre_make_vector_app_80_cfa_info(obj_t);
extern obj_t object__struct_50___object(object_t);
static obj_t struct_object__object_reshaped_local3564_28_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_pre_clo_env_10_cfa_info(obj_t);
static svar_t allocate_pre_clo_env_40_cfa_info();
static obj_t struct_object__object_make_box_o_cinfo3596_201_cfa_info(obj_t, obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
obj_t pre_procedure_ref_app_85_cfa_info = BUNSPEC;
static obj_t _allocate_box_ref_cinfo_238_cfa_info(obj_t);
obj_t procedure_ref_app_49_cfa_info = BUNSPEC;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t object___object;
obj_t funcall_cinfo_75_cfa_info = BUNSPEC;
static obj_t object__struct_pre_vector_ref_app3623_14_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_app_ly_cinfo3574_49_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_pragma_cinfo3578_186_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_reshaped_local3565_92_cfa_info(obj_t, obj_t);
obj_t make_struct_app_214_cfa_info = BUNSPEC;
static obj_t object__struct_pragma_cinfo3579_224_cfa_info(obj_t, obj_t);
static app_t allocate_pre_procedure_ref_app_138_cfa_info();
obj_t vector_set__app_21_cfa_info = BUNSPEC;
static obj_t struct_object__object_struct_set__app3644_201_cfa_info(obj_t, obj_t, obj_t);
obj_t select_cinfo_150_cfa_info = BUNSPEC;
static obj_t struct_object__object_make_struct_app3640_52_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_pre_struct_ref_app3637_3_cfa_info(obj_t, obj_t);
extern obj_t svar_ast_var;
static obj_t _allocate_scnst_cinfo_162_cfa_info(obj_t);
obj_t reshaped_global_160_cfa_info = BUNSPEC;
extern obj_t setq_ast_node;
static obj_t struct_object__object_kwote_cinfo3572_67_cfa_info(obj_t, obj_t, obj_t);
extern obj_t cvar_ast_var;
static obj_t object__struct_box_set__cinfo3599_62_cfa_info(obj_t, obj_t);
static make_box_202_t allocate_pre_make_box_175_cfa_info();
obj_t approx_cfa_info = BUNSPEC;
static obj_t object__struct_create_vector_app3629_247_cfa_info(obj_t, obj_t);
extern obj_t fail_ast_node;
static obj_t _allocate_setq_cinfo_116_cfa_info(obj_t);
obj_t extern_sfun_cinfo_6_cfa_info = BUNSPEC;
static obj_t object_init_111_cfa_info();
static obj_t _allocate_make_procedure_app_241_cfa_info(obj_t);
static obj_t object__struct_make_procedure_app3613_201_cfa_info(obj_t, obj_t);
static app_t allocate_make_procedure_app_115_cfa_info();
static sexit_t allocate_sexit_cinfo_160_cfa_info();
extern obj_t set_ex_it_116_ast_node;
obj_t reshaped_local_224_cfa_info = BUNSPEC;
static obj_t object__struct_pre_make_procedure_app3607_226_cfa_info(obj_t, obj_t);
static obj_t _allocate_pre_struct_ref_app_15_cfa_info(obj_t);
static obj_t object__struct_pre_make_box3593_103_cfa_info(obj_t, obj_t);
static obj_t object__struct_kwote_cinfo3573_151_cfa_info(obj_t, obj_t);
static obj_t _allocate_atom_cinfo_64_cfa_info(obj_t);
static obj_t _allocate_app_ly_cinfo_17_cfa_info(obj_t);
extern obj_t local_ast_var;
static obj_t _allocate_pre_struct_set__app_93_cfa_info(obj_t);
extern obj_t kwote_ast_node;
static obj_t _allocate_pre_make_struct_app_85_cfa_info(obj_t);
static obj_t _allocate_select_cinfo_74_cfa_info(obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static obj_t _allocate_pre_make_procedure_app_108_cfa_info(obj_t);
static global_t allocate_reshaped_global_131_cfa_info();
static obj_t object__struct_box_set__o_cinfo3603_24_cfa_info(obj_t, obj_t);
static obj_t _allocate_pre_procedure_set__app_24_cfa_info(obj_t);
static app_t allocate_pre_make_vector_app_231_cfa_info();
obj_t make_vector_app_205_cfa_info = BUNSPEC;
static obj_t struct_object__object_select_cinfo3586_101_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
static make_box_202_t allocate_make_box_cinfo_213_cfa_info();
extern obj_t box_ref_242_ast_node;
static obj_t object__struct_box_ref_cinfo3601_223_cfa_info(obj_t, obj_t);
static obj_t object__struct_procedure_set__app3617_101_cfa_info(obj_t, obj_t);
extern obj_t _object__struct_74___object(obj_t, obj_t);
static obj_t _allocate_struct_set__app_138_cfa_info(obj_t);
static obj_t object__struct_extern_sfun_cinfo3551_56_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_reshaped_global3566_204_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_vector_ref_app3630_120_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_conditional_cinfo3583_97_cfa_info(obj_t, obj_t);
extern obj_t funcall_ast_node;
static obj_t struct_object__object_vector_set__app3632_33_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_cvar_cinfo3561_65_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_box_ref_cinfo3600_139_cfa_info(obj_t, obj_t, obj_t);
obj_t box_set__o_cinfo_6_cfa_info = BUNSPEC;
obj_t pre_struct_set__app_116_cfa_info = BUNSPEC;
static funcall_t allocate_funcall_cinfo_11_cfa_info();
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
static app_t allocate_procedure_set__app_12_cfa_info();
obj_t cfun_cinfo_200_cfa_info = BUNSPEC;
static obj_t struct_object__object_make_procedure_app3612_96_cfa_info(obj_t, obj_t, obj_t);
obj_t box_ref_cinfo_214_cfa_info = BUNSPEC;
static obj_t struct_object__object_fail_cinfo3584_117_cfa_info(obj_t, obj_t, obj_t);
extern object_t struct_object__object_93___object(object_t, obj_t);
static obj_t struct_object__object_pre_procedure_ref_app3608_142_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_pre_make_box3592_7_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_pre_make_struct_app3635_144_cfa_info(obj_t, obj_t);
static obj_t object__struct_select_cinfo3587_16_cfa_info(obj_t, obj_t);
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t);
static select_t allocate_select_cinfo_105_cfa_info();
static obj_t _allocate_vector_set__app_158_cfa_info(obj_t);
obj_t intern_sfun_cinfo_192_cfa_info = BUNSPEC;
static obj_t object__struct_struct_set__app3645_97_cfa_info(obj_t, obj_t);
static atom_t allocate_atom_cinfo_55_cfa_info();
obj_t pre_struct_ref_app_207_cfa_info = BUNSPEC;
static jump_ex_it_184_t allocate_jump_ex_it_cinfo_167_cfa_info();
extern obj_t app_ast_node;
static obj_t struct_object__object_conditional_cinfo3582_239_cfa_info(obj_t, obj_t, obj_t);
static obj_t __cnst[51];

DEFINE_STRING(string3746_cfa_info, string3746_cfa_info3752, "DONE STRUCT-SET!-APP STRUCT-REF-APP MAKE-STRUCT-APP PRE-STRUCT-SET!-APP PRE-STRUCT-REF-APP PRE-MAKE-STRUCT-APP VECTOR-SET!-APP VECTOR-REF-APP CREATE-VECTOR-APP MAKE-VECTOR-APP PRE-VECTOR-SET!-APP PRE-VECTOR-REF-APP PRE-CREATE-VECTOR-APP PRE-MAKE-VECTOR-APP PROCEDURE-SET!-APP PROCEDURE-REF-APP MAKE-PROCEDURE-APP PRE-PROCEDURE-SET!-APP PRE-PROCEDURE-REF-APP PRE-MAKE-PROCEDURE-APP BOX-REF/O-CINFO BOX-SET!/O-CINFO BOX-REF/CINFO BOX-SET!/CINFO MAKE-BOX/O-CINFO MAKE-BOX/CINFO PRE-MAKE-BOX JUMP-EX-IT/CINFO SET-EX-IT/CINFO SELECT/CINFO FAIL/CINFO CONDITIONAL/CINFO SETQ/CINFO PRAGMA/CINFO FUNCALL/CINFO APP-LY/CINFO KWOTE/CINFO KWOTE/NODE ATOM/CINFO RESHAPED-GLOBAL RESHAPED-LOCAL SEXIT/CINFO CVAR/CINFO SVAR/CINFO PRE-CLO-ENV SCNST/CINFO INTERN-SFUN/CINFO EXTERN-SFUN/CINFO CFUN/CINFO APPROX ", 791);
DEFINE_STATIC_PROCEDURE(proc3657_cfa_info, struct_object__object_pre_make_struct_app3634_112_cfa_info3753, struct_object__object_pre_make_struct_app3634_112_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_reshaped_local_env_189_cfa_info, _allocate_reshaped_local_17_cfa_info3754, _allocate_reshaped_local_17_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3738_cfa_info, object__struct_intern_sfun_cinfo3553_214_cfa_info3755, object__struct_intern_sfun_cinfo3553_214_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3651_cfa_info, struct_object__object_make_struct_app3640_52_cfa_info3756, struct_object__object_make_struct_app3640_52_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3722_cfa_info, object__struct_atom_cinfo3569_29_cfa_info3757, object__struct_atom_cinfo3569_29_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_pre_struct_set__app_env_196_cfa_info, _allocate_pre_struct_set__app_93_cfa_info3758, _allocate_pre_struct_set__app_93_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3678_cfa_info, object__struct_make_procedure_app3613_201_cfa_info3759, object__struct_make_procedure_app3613_201_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3715_cfa_info, struct_object__object_funcall_cinfo3576_157_cfa_info3760, struct_object__object_funcall_cinfo3576_157_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3670_cfa_info, object__struct_pre_create_vector_app3621_112_cfa_info3761, object__struct_pre_create_vector_app3621_112_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_set_ex_it_cinfo_env_250_cfa_info, _allocate_set_ex_it_cinfo_22_cfa_info3762, _allocate_set_ex_it_cinfo_22_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3688_cfa_info, object__struct_box_set__o_cinfo3603_24_cfa_info3763, object__struct_box_set__o_cinfo3603_24_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_vector_set__app_env_178_cfa_info, _allocate_vector_set__app_158_cfa_info3764, _allocate_vector_set__app_158_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3679_cfa_info, struct_object__object_make_procedure_app3612_96_cfa_info3765, struct_object__object_make_procedure_app3612_96_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_jump_ex_it_cinfo_env_187_cfa_info, _allocate_jump_ex_it_cinfo_34_cfa_info3766, _allocate_jump_ex_it_cinfo_34_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_make_procedure_app_env_172_cfa_info, _allocate_make_procedure_app_241_cfa_info3767, _allocate_make_procedure_app_241_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3698_cfa_info, object__struct_pre_make_box3593_103_cfa_info3768, object__struct_pre_make_box3593_103_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3647_cfa_info, struct_object__object_struct_set__app3644_201_cfa_info3769, struct_object__object_struct_set__app3644_201_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3680_cfa_info, object__struct_pre_procedure_set__app3611_110_cfa_info3770, object__struct_pre_procedure_set__app3611_110_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_procedure_ref_app_env_35_cfa_info, _allocate_procedure_ref_app_56_cfa_info3771, _allocate_procedure_ref_app_56_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3744_cfa_info, object__struct_approx3547_109_cfa_info3772, object__struct_approx3547_109_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3674_cfa_info, object__struct_procedure_set__app3617_101_cfa_info3773, object__struct_procedure_set__app3617_101_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3739_cfa_info, struct_object__object_intern_sfun_cinfo3552_203_cfa_info3774, struct_object__object_intern_sfun_cinfo3552_203_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3687_cfa_info, struct_object__object_box_ref_o_cinfo3604_201_cfa_info3775, struct_object__object_box_ref_o_cinfo3604_201_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3677_cfa_info, struct_object__object_procedure_ref_app3614_131_cfa_info3776, struct_object__object_procedure_ref_app3614_131_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3655_cfa_info, struct_object__object_pre_struct_ref_app3636_243_cfa_info3777, struct_object__object_pre_struct_ref_app3636_243_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3710_cfa_info, object__struct_setq_cinfo3581_231_cfa_info3778, object__struct_setq_cinfo3581_231_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3669_cfa_info, struct_object__object_pre_vector_ref_app3622_186_cfa_info3779, struct_object__object_pre_vector_ref_app3622_186_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3732_cfa_info, object__struct_svar_cinfo3559_43_cfa_info3780, object__struct_svar_cinfo3559_43_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_app_ly_cinfo_env_68_cfa_info, _allocate_app_ly_cinfo_17_cfa_info3781, _allocate_app_ly_cinfo_17_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_struct_set__app_env_221_cfa_info, _allocate_struct_set__app_138_cfa_info3782, _allocate_struct_set__app_138_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_pre_struct_ref_app_env_84_cfa_info, _allocate_pre_struct_ref_app_15_cfa_info3783, _allocate_pre_struct_ref_app_15_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3663_cfa_info, struct_object__object_create_vector_app3628_76_cfa_info3784, struct_object__object_create_vector_app3628_76_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_pre_procedure_set__app_env_247_cfa_info, _allocate_pre_procedure_set__app_24_cfa_info3785, _allocate_pre_procedure_set__app_24_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3733_cfa_info, struct_object__object_svar_cinfo3558_151_cfa_info3786, struct_object__object_svar_cinfo3558_151_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3691_cfa_info, struct_object__object_box_ref_cinfo3600_139_cfa_info3787, struct_object__object_box_ref_cinfo3600_139_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3720_cfa_info, object__struct_kwote_node3571_68_cfa_info3788, object__struct_kwote_node3571_68_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_svar_cinfo_env_152_cfa_info, _allocate_svar_cinfo_185_cfa_info3789, _allocate_svar_cinfo_185_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3705_cfa_info, struct_object__object_select_cinfo3586_101_cfa_info3790, struct_object__object_select_cinfo3586_101_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3729_cfa_info, struct_object__object_sexit_cinfo3562_95_cfa_info3791, struct_object__object_sexit_cinfo3562_95_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3686_cfa_info, object__struct_box_ref_o_cinfo3605_141_cfa_info3792, object__struct_box_ref_o_cinfo3605_141_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3713_cfa_info, struct_object__object_pragma_cinfo3578_186_cfa_info3793, struct_object__object_pragma_cinfo3578_186_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_kwote_cinfo_env_199_cfa_info, _allocate_kwote_cinfo_178_cfa_info3794, _allocate_kwote_cinfo_178_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_box_set__cinfo_env_96_cfa_info, _allocate_box_set__cinfo_187_cfa_info3795, _allocate_box_set__cinfo_187_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3658_cfa_info, object__struct_vector_set__app3633_171_cfa_info3796, object__struct_vector_set__app3633_171_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3668_cfa_info, object__struct_pre_vector_ref_app3623_14_cfa_info3797, object__struct_pre_vector_ref_app3623_14_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3726_cfa_info, object__struct_reshaped_local3565_92_cfa_info3798, object__struct_reshaped_local3565_92_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_struct_ref_app_env_33_cfa_info, _allocate_struct_ref_app_88_cfa_info3799, _allocate_struct_ref_app_88_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3714_cfa_info, object__struct_funcall_cinfo3577_159_cfa_info3800, object__struct_funcall_cinfo3577_159_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_make_box_cinfo_env_36_cfa_info, _allocate_make_box_cinfo_36_cfa_info3801, _allocate_make_box_cinfo_36_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3654_cfa_info, object__struct_pre_struct_ref_app3637_3_cfa_info3802, object__struct_pre_struct_ref_app3637_3_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3721_cfa_info, struct_object__object_kwote_node3570_241_cfa_info3803, struct_object__object_kwote_node3570_241_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_scnst_cinfo_env_108_cfa_info, _allocate_scnst_cinfo_162_cfa_info3804, _allocate_scnst_cinfo_162_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_pre_make_vector_app_env_198_cfa_info, _allocate_pre_make_vector_app_80_cfa_info3805, _allocate_pre_make_vector_app_80_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3730_cfa_info, object__struct_cvar_cinfo3561_65_cfa_info3806, object__struct_cvar_cinfo3561_65_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3683_cfa_info, struct_object__object_pre_procedure_ref_app3608_142_cfa_info3807, struct_object__object_pre_procedure_ref_app3608_142_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3659_cfa_info, struct_object__object_vector_set__app3632_33_cfa_info3808, struct_object__object_vector_set__app3632_33_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3681_cfa_info, struct_object__object_pre_procedure_set__app3610_224_cfa_info3809, struct_object__object_pre_procedure_set__app3610_224_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3723_cfa_info, struct_object__object_atom_cinfo3568_174_cfa_info3810, struct_object__object_atom_cinfo3568_174_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3650_cfa_info, object__struct_make_struct_app3641_26_cfa_info3811, object__struct_make_struct_app3641_26_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3673_cfa_info, struct_object__object_pre_make_vector_app3618_161_cfa_info3812, struct_object__object_pre_make_vector_app3618_161_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3665_cfa_info, struct_object__object_make_vector_app3626_193_cfa_info3813, struct_object__object_make_vector_app3626_193_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_pre_create_vector_app_env_147_cfa_info, _allocate_pre_create_vector_app_171_cfa_info3814, _allocate_pre_create_vector_app_171_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_pre_make_box_env_176_cfa_info, _allocate_pre_make_box_48_cfa_info3815, _allocate_pre_make_box_48_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3709_cfa_info, struct_object__object_conditional_cinfo3582_239_cfa_info3816, struct_object__object_conditional_cinfo3582_239_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3725_cfa_info, struct_object__object_reshaped_global3566_204_cfa_info3817, struct_object__object_reshaped_global3566_204_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3690_cfa_info, object__struct_box_ref_cinfo3601_223_cfa_info3818, object__struct_box_ref_cinfo3601_223_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3667_cfa_info, struct_object__object_pre_vector_set__app3624_62_cfa_info3819, struct_object__object_pre_vector_set__app3624_62_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3727_cfa_info, struct_object__object_reshaped_local3564_28_cfa_info3820, struct_object__object_reshaped_local3564_28_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3735_cfa_info, struct_object__object_pre_clo_env3556_124_cfa_info3821, struct_object__object_pre_clo_env3556_124_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_make_struct_app_env_154_cfa_info, _allocate_make_struct_app_151_cfa_info3822, _allocate_make_struct_app_151_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_intern_sfun_cinfo_env_101_cfa_info, _allocate_intern_sfun_cinfo_249_cfa_info3823, _allocate_intern_sfun_cinfo_249_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3736_cfa_info, object__struct_scnst_cinfo3555_66_cfa_info3824, object__struct_scnst_cinfo3555_66_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_pre_vector_set__app_env_49_cfa_info, _allocate_pre_vector_set__app_63_cfa_info3825, _allocate_pre_vector_set__app_63_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3672_cfa_info, object__struct_pre_make_vector_app3619_96_cfa_info3826, object__struct_pre_make_vector_app3619_96_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_setq_cinfo_env_69_cfa_info, _allocate_setq_cinfo_116_cfa_info3827, _allocate_setq_cinfo_116_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_fail_cinfo_env_67_cfa_info, _allocate_fail_cinfo_247_cfa_info3828, _allocate_fail_cinfo_247_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3708_cfa_info, object__struct_conditional_cinfo3583_97_cfa_info3829, object__struct_conditional_cinfo3583_97_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3724_cfa_info, object__struct_reshaped_global3567_93_cfa_info3830, object__struct_reshaped_global3567_93_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_sexit_cinfo_env_157_cfa_info, _allocate_sexit_cinfo_64_cfa_info3831, _allocate_sexit_cinfo_64_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3671_cfa_info, struct_object__object_pre_create_vector_app3620_75_cfa_info3832, struct_object__object_pre_create_vector_app3620_75_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3675_cfa_info, struct_object__object_procedure_set__app3616_107_cfa_info3833, struct_object__object_procedure_set__app3616_107_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3693_cfa_info, struct_object__object_box_set__cinfo3598_217_cfa_info3834, struct_object__object_box_set__cinfo3598_217_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_box_ref_o_cinfo_env_184_cfa_info, _allocate_box_ref_o_cinfo_197_cfa_info3835, _allocate_box_ref_o_cinfo_197_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3743_cfa_info, struct_object__object_cfun_cinfo3548_146_cfa_info3836, struct_object__object_cfun_cinfo3548_146_cfa_info, 0L, 2);
extern obj_t struct_object__object_env_209___object;
DEFINE_STATIC_PROCEDURE(proc3684_cfa_info, object__struct_pre_make_procedure_app3607_226_cfa_info3837, object__struct_pre_make_procedure_app3607_226_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_extern_sfun_cinfo_env_126_cfa_info, _allocate_extern_sfun_cinfo_234_cfa_info3838, _allocate_extern_sfun_cinfo_234_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3712_cfa_info, object__struct_pragma_cinfo3579_224_cfa_info3839, object__struct_pragma_cinfo3579_224_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_box_set__o_cinfo_env_94_cfa_info, _allocate_box_set__o_cinfo_20_cfa_info3840, _allocate_box_set__o_cinfo_20_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_box_ref_cinfo_env_99_cfa_info, _allocate_box_ref_cinfo_238_cfa_info3841, _allocate_box_ref_cinfo_238_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_pre_make_procedure_app_env_235_cfa_info, _allocate_pre_make_procedure_app_108_cfa_info3842, _allocate_pre_make_procedure_app_108_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3737_cfa_info, struct_object__object_scnst_cinfo3554_122_cfa_info3843, struct_object__object_scnst_cinfo3554_122_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_vector_ref_app_env_93_cfa_info, _allocate_vector_ref_app_194_cfa_info3844, _allocate_vector_ref_app_194_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3706_cfa_info, object__struct_fail_cinfo3585_16_cfa_info3845, object__struct_fail_cinfo3585_16_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_cfun_cinfo_env_112_cfa_info, _allocate_cfun_cinfo_87_cfa_info3846, _allocate_cfun_cinfo_87_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_pre_make_struct_app_env_41_cfa_info, _allocate_pre_make_struct_app_85_cfa_info3847, _allocate_pre_make_struct_app_85_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3689_cfa_info, struct_object__object_box_set__o_cinfo3602_212_cfa_info3848, struct_object__object_box_set__o_cinfo3602_212_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_atom_cinfo_env_231_cfa_info, _allocate_atom_cinfo_64_cfa_info3849, _allocate_atom_cinfo_64_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3711_cfa_info, struct_object__object_setq_cinfo3580_159_cfa_info3850, struct_object__object_setq_cinfo3580_159_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_conditional_cinfo_env_136_cfa_info, _allocate_conditional_cinfo_139_cfa_info3851, _allocate_conditional_cinfo_139_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3652_cfa_info, object__struct_pre_struct_set__app3639_134_cfa_info3852, object__struct_pre_struct_set__app3639_134_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3703_cfa_info, struct_object__object_set_ex_it_cinfo3588_212_cfa_info3853, struct_object__object_set_ex_it_cinfo3588_212_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_make_box_o_cinfo_env_97_cfa_info, _allocate_make_box_o_cinfo_133_cfa_info3854, _allocate_make_box_o_cinfo_133_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3676_cfa_info, object__struct_procedure_ref_app3615_121_cfa_info3855, object__struct_procedure_ref_app3615_121_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3702_cfa_info, object__struct_set_ex_it_cinfo3589_142_cfa_info3856, object__struct_set_ex_it_cinfo3589_142_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_procedure_set__app_env_74_cfa_info, _allocate_procedure_set__app_204_cfa_info3857, _allocate_procedure_set__app_204_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3707_cfa_info, struct_object__object_fail_cinfo3584_117_cfa_info3858, struct_object__object_fail_cinfo3584_117_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_cvar_cinfo_env_84_cfa_info, _allocate_cvar_cinfo_74_cfa_info3859, _allocate_cvar_cinfo_74_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3695_cfa_info, struct_object__object_make_box_o_cinfo3596_201_cfa_info3860, struct_object__object_make_box_o_cinfo3596_201_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3716_cfa_info, object__struct_app_ly_cinfo3575_89_cfa_info3861, object__struct_app_ly_cinfo3575_89_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_kwote_node_env_116_cfa_info, _allocate_kwote_node_49_cfa_info3862, _allocate_kwote_node_49_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_pre_clo_env_env_170_cfa_info, _allocate_pre_clo_env_10_cfa_info3863, _allocate_pre_clo_env_10_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3649_cfa_info, struct_object__object_struct_ref_app3642_41_cfa_info3864, struct_object__object_struct_ref_app3642_41_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3696_cfa_info, object__struct_make_box_cinfo3595_155_cfa_info3865, object__struct_make_box_cinfo3595_155_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3701_cfa_info, struct_object__object_jump_ex_it_cinfo3590_166_cfa_info3866, struct_object__object_jump_ex_it_cinfo3590_166_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3717_cfa_info, struct_object__object_app_ly_cinfo3574_49_cfa_info3867, struct_object__object_app_ly_cinfo3574_49_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3734_cfa_info, object__struct_pre_clo_env3557_197_cfa_info3868, object__struct_pre_clo_env3557_197_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_approx_env_171_cfa_info, _allocate_approx_254_cfa_info3869, _allocate_approx_254_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3682_cfa_info, object__struct_pre_procedure_ref_app3609_217_cfa_info3870, object__struct_pre_procedure_ref_app3609_217_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3646_cfa_info, object__struct_struct_set__app3645_97_cfa_info3871, object__struct_struct_set__app3645_97_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3699_cfa_info, struct_object__object_pre_make_box3592_7_cfa_info3872, struct_object__object_pre_make_box3592_7_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_reshaped_global_env_91_cfa_info, _allocate_reshaped_global_82_cfa_info3873, _allocate_reshaped_global_82_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3742_cfa_info, object__struct_cfun_cinfo3549_117_cfa_info3874, object__struct_cfun_cinfo3549_117_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3685_cfa_info, struct_object__object_pre_make_procedure_app3606_172_cfa_info3875, struct_object__object_pre_make_procedure_app3606_172_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3653_cfa_info, struct_object__object_pre_struct_set__app3638_251_cfa_info3876, struct_object__object_pre_struct_set__app3638_251_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_make_vector_app_env_222_cfa_info, _allocate_make_vector_app_18_cfa_info3877, _allocate_make_vector_app_18_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3656_cfa_info, object__struct_pre_make_struct_app3635_144_cfa_info3878, object__struct_pre_make_struct_app3635_144_cfa_info, 0L, 1);
extern obj_t object__struct_env_210___object;
DEFINE_STATIC_PROCEDURE(proc3692_cfa_info, object__struct_box_set__cinfo3599_62_cfa_info3879, object__struct_box_set__cinfo3599_62_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3694_cfa_info, object__struct_make_box_o_cinfo3597_33_cfa_info3880, object__struct_make_box_o_cinfo3597_33_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3661_cfa_info, struct_object__object_vector_ref_app3630_120_cfa_info3881, struct_object__object_vector_ref_app3630_120_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_pragma_cinfo_env_199_cfa_info, _allocate_pragma_cinfo_82_cfa_info3882, _allocate_pragma_cinfo_82_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3719_cfa_info, struct_object__object_kwote_cinfo3572_67_cfa_info3883, struct_object__object_kwote_cinfo3572_67_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3731_cfa_info, struct_object__object_cvar_cinfo3560_206_cfa_info3884, struct_object__object_cvar_cinfo3560_206_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3745_cfa_info, struct_object__object_approx3546_115_cfa_info3885, struct_object__object_approx3546_115_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3664_cfa_info, object__struct_make_vector_app3627_193_cfa_info3886, object__struct_make_vector_app3627_193_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_funcall_cinfo_env_186_cfa_info, _allocate_funcall_cinfo_40_cfa_info3887, _allocate_funcall_cinfo_40_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3648_cfa_info, object__struct_struct_ref_app3643_175_cfa_info3888, object__struct_struct_ref_app3643_175_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3697_cfa_info, struct_object__object_make_box_cinfo3594_129_cfa_info3889, struct_object__object_make_box_cinfo3594_129_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3700_cfa_info, object__struct_jump_ex_it_cinfo3591_236_cfa_info3890, object__struct_jump_ex_it_cinfo3591_236_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3666_cfa_info, object__struct_pre_vector_set__app3625_165_cfa_info3891, object__struct_pre_vector_set__app3625_165_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_pre_vector_ref_app_env_180_cfa_info, _allocate_pre_vector_ref_app_31_cfa_info3892, _allocate_pre_vector_ref_app_31_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3740_cfa_info, object__struct_extern_sfun_cinfo3551_56_cfa_info3893, object__struct_extern_sfun_cinfo3551_56_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3704_cfa_info, object__struct_select_cinfo3587_16_cfa_info3894, object__struct_select_cinfo3587_16_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3728_cfa_info, object__struct_sexit_cinfo3563_64_cfa_info3895, object__struct_sexit_cinfo3563_64_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_create_vector_app_env_133_cfa_info, _allocate_create_vector_app_246_cfa_info3896, _allocate_create_vector_app_246_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3662_cfa_info, object__struct_create_vector_app3629_247_cfa_info3897, object__struct_create_vector_app3629_247_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3718_cfa_info, object__struct_kwote_cinfo3573_151_cfa_info3898, object__struct_kwote_cinfo3573_151_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_select_cinfo_env_166_cfa_info, _allocate_select_cinfo_74_cfa_info3899, _allocate_select_cinfo_74_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc3660_cfa_info, object__struct_vector_ref_app3631_178_cfa_info3900, object__struct_vector_ref_app3631_178_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3741_cfa_info, struct_object__object_extern_sfun_cinfo3550_31_cfa_info3901, struct_object__object_extern_sfun_cinfo3550_31_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(allocate_pre_procedure_ref_app_env_67_cfa_info, _allocate_pre_procedure_ref_app_105_cfa_info3902, _allocate_pre_procedure_ref_app_105_cfa_info, 0L, 0);

obj_t 
module_initialization_70_cfa_info(long checksum_6990, char *from_6991)
{
   if (CBOOL(require_initialization_114_cfa_info))
     {
	require_initialization_114_cfa_info = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_info();
	cnst_init_137_cfa_info();
	object_init_111_cfa_info();
	imported_modules_init_94_cfa_info();
	toplevel_init_63_cfa_info();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cfa_info()
{
   module_initialization_70___object(((long) 0), "CFA_INFO");
   module_initialization_70___reader(((long) 0), "CFA_INFO");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cfa_info()
{
   {
      obj_t cnst_port_138_6982;
      cnst_port_138_6982 = open_input_string(string3746_cfa_info);
      {
	 long i_6983;
	 i_6983 = ((long) 50);
       loop_6984:
	 {
	    bool_t test3747_6985;
	    test3747_6985 = (i_6983 == ((long) -1));
	    if (test3747_6985)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg3748_6986;
		    {
		       obj_t list3749_6987;
		       {
			  obj_t arg3750_6988;
			  arg3750_6988 = BNIL;
			  list3749_6987 = MAKE_PAIR(cnst_port_138_6982, arg3750_6988);
		       }
		       arg3748_6986 = read___reader(list3749_6987);
		    }
		    CNST_TABLE_SET(i_6983, arg3748_6986);
		 }
		 {
		    int aux_6989;
		    {
		       long aux_7008;
		       aux_7008 = (i_6983 - ((long) 1));
		       aux_6989 = (int) (aux_7008);
		    }
		    {
		       long i_7011;
		       i_7011 = (long) (aux_6989);
		       i_6983 = i_7011;
		       goto loop_6984;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cfa_info()
{
   return BUNSPEC;
}


obj_t 
object_init_111_cfa_info()
{
   {
      obj_t arg2388_2081;
      arg2388_2081 = object___object;
      approx_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 0)), arg2388_2081, allocate_approx_env_171_cfa_info, ((long) 23027), BUNSPEC);
   }
   {
      obj_t arg2392_2085;
      arg2392_2085 = cfun_ast_var;
      cfun_cinfo_200_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 1)), arg2392_2085, allocate_cfun_cinfo_env_112_cfa_info, ((long) 28807), BUNSPEC);
   }
   {
      obj_t arg2396_2089;
      arg2396_2089 = sfun_ast_var;
      extern_sfun_cinfo_6_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 2)), arg2396_2089, allocate_extern_sfun_cinfo_env_126_cfa_info, ((long) 24561), BUNSPEC);
   }
   {
      obj_t arg2400_2093;
      arg2400_2093 = sfun_ast_var;
      intern_sfun_cinfo_192_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 3)), arg2400_2093, allocate_intern_sfun_cinfo_env_101_cfa_info, ((long) 63764), BUNSPEC);
   }
   {
      obj_t arg2404_2097;
      arg2404_2097 = scnst_ast_var;
      scnst_cinfo_0_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 4)), arg2404_2097, allocate_scnst_cinfo_env_108_cfa_info, ((long) 64755), BUNSPEC);
   }
   {
      obj_t arg2408_2101;
      arg2408_2101 = svar_ast_var;
      pre_clo_env_191_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 5)), arg2408_2101, allocate_pre_clo_env_env_170_cfa_info, ((long) 57970), BUNSPEC);
   }
   {
      obj_t arg2418_2105;
      arg2418_2105 = svar_ast_var;
      svar_cinfo_166_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 6)), arg2418_2105, allocate_svar_cinfo_env_152_cfa_info, ((long) 702), BUNSPEC);
   }
   {
      obj_t arg2422_2109;
      arg2422_2109 = cvar_ast_var;
      cvar_cinfo_53_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 7)), arg2422_2109, allocate_cvar_cinfo_env_84_cfa_info, ((long) 33057), BUNSPEC);
   }
   {
      obj_t arg2426_2113;
      arg2426_2113 = sexit_ast_var;
      sexit_cinfo_49_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 8)), arg2426_2113, allocate_sexit_cinfo_env_157_cfa_info, ((long) 62238), BUNSPEC);
   }
   {
      obj_t arg2430_2117;
      arg2430_2117 = local_ast_var;
      reshaped_local_224_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 9)), arg2430_2117, allocate_reshaped_local_env_189_cfa_info, ((long) 59644), BUNSPEC);
   }
   {
      obj_t arg2434_2121;
      arg2434_2121 = global_ast_var;
      reshaped_global_160_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 10)), arg2434_2121, allocate_reshaped_global_env_91_cfa_info, ((long) 17542), BUNSPEC);
   }
   {
      obj_t arg2438_2125;
      arg2438_2125 = atom_ast_node;
      atom_cinfo_155_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 11)), arg2438_2125, allocate_atom_cinfo_env_231_cfa_info, ((long) 61871), BUNSPEC);
   }
   {
      obj_t arg2442_2129;
      arg2442_2129 = kwote_ast_node;
      kwote_node_102_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 12)), arg2442_2129, allocate_kwote_node_env_116_cfa_info, ((long) 13128), BUNSPEC);
   }
   {
      obj_t arg2446_2133;
      arg2446_2133 = kwote_ast_node;
      kwote_cinfo_48_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 13)), arg2446_2133, allocate_kwote_cinfo_env_199_cfa_info, ((long) 65298), BUNSPEC);
   }
   {
      obj_t arg2450_2137;
      arg2450_2137 = app_ly_162_ast_node;
      app_ly_cinfo_234_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 14)), arg2450_2137, allocate_app_ly_cinfo_env_68_cfa_info, ((long) 38789), BUNSPEC);
   }
   {
      obj_t arg2454_2141;
      arg2454_2141 = funcall_ast_node;
      funcall_cinfo_75_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 15)), arg2454_2141, allocate_funcall_cinfo_env_186_cfa_info, ((long) 49996), BUNSPEC);
   }
   {
      obj_t arg2458_2145;
      arg2458_2145 = pragma_ast_node;
      pragma_cinfo_220_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 16)), arg2458_2145, allocate_pragma_cinfo_env_199_cfa_info, ((long) 54583), BUNSPEC);
   }
   {
      obj_t arg2462_2149;
      arg2462_2149 = setq_ast_node;
      setq_cinfo_191_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 17)), arg2462_2149, allocate_setq_cinfo_env_69_cfa_info, ((long) 33130), BUNSPEC);
   }
   {
      obj_t arg2467_2153;
      arg2467_2153 = conditional_ast_node;
      conditional_cinfo_212_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 18)), arg2467_2153, allocate_conditional_cinfo_env_136_cfa_info, ((long) 56819), BUNSPEC);
   }
   {
      obj_t arg2472_2157;
      arg2472_2157 = fail_ast_node;
      fail_cinfo_75_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 19)), arg2472_2157, allocate_fail_cinfo_env_67_cfa_info, ((long) 55041), BUNSPEC);
   }
   {
      obj_t arg2476_2161;
      arg2476_2161 = select_ast_node;
      select_cinfo_150_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 20)), arg2476_2161, allocate_select_cinfo_env_166_cfa_info, ((long) 10991), BUNSPEC);
   }
   {
      obj_t arg2481_2165;
      arg2481_2165 = set_ex_it_116_ast_node;
      set_ex_it_cinfo_168_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 21)), arg2481_2165, allocate_set_ex_it_cinfo_env_250_cfa_info, ((long) 51571), BUNSPEC);
   }
   {
      obj_t arg2486_2169;
      arg2486_2169 = jump_ex_it_184_ast_node;
      jump_ex_it_cinfo_139_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 22)), arg2486_2169, allocate_jump_ex_it_cinfo_env_187_cfa_info, ((long) 43324), BUNSPEC);
   }
   {
      obj_t arg2490_2173;
      arg2490_2173 = make_box_202_ast_node;
      pre_make_box_186_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 23)), arg2490_2173, allocate_pre_make_box_env_176_cfa_info, ((long) 21386), BUNSPEC);
   }
   {
      obj_t arg2494_2177;
      arg2494_2177 = make_box_202_ast_node;
      make_box_cinfo_127_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 24)), arg2494_2177, allocate_make_box_cinfo_env_36_cfa_info, ((long) 61761), BUNSPEC);
   }
   {
      obj_t arg2498_2181;
      arg2498_2181 = make_box_202_ast_node;
      make_box_o_cinfo_96_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 25)), arg2498_2181, allocate_make_box_o_cinfo_env_97_cfa_info, ((long) 49121), BUNSPEC);
   }
   {
      obj_t arg2502_2185;
      arg2502_2185 = box_set__221_ast_node;
      box_set__cinfo_94_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 26)), arg2502_2185, allocate_box_set__cinfo_env_96_cfa_info, ((long) 57771), BUNSPEC);
   }
   {
      obj_t arg2507_2189;
      arg2507_2189 = box_ref_242_ast_node;
      box_ref_cinfo_214_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 27)), arg2507_2189, allocate_box_ref_cinfo_env_99_cfa_info, ((long) 29351), BUNSPEC);
   }
   {
      obj_t arg2513_2193;
      arg2513_2193 = box_set__221_ast_node;
      box_set__o_cinfo_6_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 28)), arg2513_2193, allocate_box_set__o_cinfo_env_94_cfa_info, ((long) 30715), BUNSPEC);
   }
   {
      obj_t arg2519_2197;
      arg2519_2197 = box_ref_242_ast_node;
      box_ref_o_cinfo_98_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 29)), arg2519_2197, allocate_box_ref_o_cinfo_env_184_cfa_info, ((long) 43446), BUNSPEC);
   }
   {
      obj_t arg2523_2201;
      arg2523_2201 = app_ast_node;
      pre_make_procedure_app_60_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 30)), arg2523_2201, allocate_pre_make_procedure_app_env_235_cfa_info, ((long) 62555), BUNSPEC);
   }
   {
      obj_t arg2529_2205;
      arg2529_2205 = app_ast_node;
      pre_procedure_ref_app_85_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 31)), arg2529_2205, allocate_pre_procedure_ref_app_env_67_cfa_info, ((long) 22809), BUNSPEC);
   }
   {
      obj_t arg2533_2209;
      arg2533_2209 = app_ast_node;
      pre_procedure_set__app_208_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 32)), arg2533_2209, allocate_pre_procedure_set__app_env_247_cfa_info, ((long) 40587), BUNSPEC);
   }
   {
      obj_t arg2537_2213;
      arg2537_2213 = app_ast_node;
      make_procedure_app_48_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 33)), arg2537_2213, allocate_make_procedure_app_env_172_cfa_info, ((long) 11259), BUNSPEC);
   }
   {
      obj_t arg2541_2217;
      arg2541_2217 = app_ast_node;
      procedure_ref_app_49_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 34)), arg2541_2217, allocate_procedure_ref_app_env_35_cfa_info, ((long) 13689), BUNSPEC);
   }
   {
      obj_t arg2545_2221;
      arg2545_2221 = app_ast_node;
      procedure_set__app_32_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 35)), arg2545_2221, allocate_procedure_set__app_env_74_cfa_info, ((long) 5120), BUNSPEC);
   }
   {
      obj_t arg2549_2225;
      arg2549_2225 = app_ast_node;
      pre_make_vector_app_251_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 36)), arg2549_2225, allocate_pre_make_vector_app_env_198_cfa_info, ((long) 50436), BUNSPEC);
   }
   {
      obj_t arg2553_2229;
      arg2553_2229 = app_ast_node;
      pre_create_vector_app_162_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 37)), arg2553_2229, allocate_pre_create_vector_app_env_147_cfa_info, ((long) 60512), BUNSPEC);
   }
   {
      obj_t arg2557_2233;
      arg2557_2233 = app_ast_node;
      pre_vector_ref_app_208_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 38)), arg2557_2233, allocate_pre_vector_ref_app_env_180_cfa_info, ((long) 43370), BUNSPEC);
   }
   {
      obj_t arg2561_2237;
      arg2561_2237 = app_ast_node;
      pre_vector_set__app_211_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 39)), arg2561_2237, allocate_pre_vector_set__app_env_49_cfa_info, ((long) 65413), BUNSPEC);
   }
   {
      obj_t arg2565_2241;
      arg2565_2241 = app_ast_node;
      make_vector_app_205_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 40)), arg2565_2241, allocate_make_vector_app_env_222_cfa_info, ((long) 38831), BUNSPEC);
   }
   {
      obj_t arg2569_2245;
      arg2569_2245 = app_ast_node;
      create_vector_app_150_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 41)), arg2569_2245, allocate_create_vector_app_env_133_cfa_info, ((long) 3512), BUNSPEC);
   }
   {
      obj_t arg2573_2249;
      arg2573_2249 = app_ast_node;
      vector_ref_app_195_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 42)), arg2573_2249, allocate_vector_ref_app_env_93_cfa_info, ((long) 58941), BUNSPEC);
   }
   {
      obj_t arg2577_2253;
      arg2577_2253 = app_ast_node;
      vector_set__app_21_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 43)), arg2577_2253, allocate_vector_set__app_env_178_cfa_info, ((long) 11134), BUNSPEC);
   }
   {
      obj_t arg2581_2257;
      arg2581_2257 = app_ast_node;
      pre_make_struct_app_218_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 44)), arg2581_2257, allocate_pre_make_struct_app_env_41_cfa_info, ((long) 15457), BUNSPEC);
   }
   {
      obj_t arg2585_2261;
      arg2585_2261 = app_ast_node;
      pre_struct_ref_app_207_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 45)), arg2585_2261, allocate_pre_struct_ref_app_env_84_cfa_info, ((long) 1943), BUNSPEC);
   }
   {
      obj_t arg2589_2265;
      arg2589_2265 = app_ast_node;
      pre_struct_set__app_116_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 46)), arg2589_2265, allocate_pre_struct_set__app_env_196_cfa_info, ((long) 5124), BUNSPEC);
   }
   {
      obj_t arg2593_2269;
      arg2593_2269 = app_ast_node;
      make_struct_app_214_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 47)), arg2593_2269, allocate_make_struct_app_env_154_cfa_info, ((long) 42999), BUNSPEC);
   }
   {
      obj_t arg2597_2273;
      arg2597_2273 = app_ast_node;
      struct_ref_app_73_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 48)), arg2597_2273, allocate_struct_ref_app_env_33_cfa_info, ((long) 60893), BUNSPEC);
   }
   {
      obj_t arg2601_2277;
      arg2601_2277 = app_ast_node;
      struct_set__app_162_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 49)), arg2601_2277, allocate_struct_set__app_env_221_cfa_info, ((long) 15766), BUNSPEC);
   }
   {
      obj_t object__struct_struct_set__app_208_6679;
      object__struct_struct_set__app_208_6679 = proc3646_cfa_info;
      add_method__1___object(object__struct_env_210___object, struct_set__app_162_cfa_info, object__struct_struct_set__app_208_6679);
   }
   {
      obj_t struct_object__object_struct_set__app_209_6678;
      struct_object__object_struct_set__app_209_6678 = proc3647_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, struct_set__app_162_cfa_info, struct_object__object_struct_set__app_209_6678);
   }
   {
      obj_t object__struct_struct_ref_app_85_6677;
      object__struct_struct_ref_app_85_6677 = proc3648_cfa_info;
      add_method__1___object(object__struct_env_210___object, struct_ref_app_73_cfa_info, object__struct_struct_ref_app_85_6677);
   }
   {
      obj_t struct_object__object_struct_ref_app_176_6676;
      struct_object__object_struct_ref_app_176_6676 = proc3649_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, struct_ref_app_73_cfa_info, struct_object__object_struct_ref_app_176_6676);
   }
   {
      obj_t object__struct_make_struct_app_173_6675;
      object__struct_make_struct_app_173_6675 = proc3650_cfa_info;
      add_method__1___object(object__struct_env_210___object, make_struct_app_214_cfa_info, object__struct_make_struct_app_173_6675);
   }
   {
      obj_t struct_object__object_make_struct_app_10_6674;
      struct_object__object_make_struct_app_10_6674 = proc3651_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, make_struct_app_214_cfa_info, struct_object__object_make_struct_app_10_6674);
   }
   {
      obj_t object__struct_pre_struct_set__app_44_6673;
      object__struct_pre_struct_set__app_44_6673 = proc3652_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_struct_set__app_116_cfa_info, object__struct_pre_struct_set__app_44_6673);
   }
   {
      obj_t struct_object__object_pre_struct_set__app_147_6672;
      struct_object__object_pre_struct_set__app_147_6672 = proc3653_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_struct_set__app_116_cfa_info, struct_object__object_pre_struct_set__app_147_6672);
   }
   {
      obj_t object__struct_pre_struct_ref_app_38_6671;
      object__struct_pre_struct_ref_app_38_6671 = proc3654_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_struct_ref_app_207_cfa_info, object__struct_pre_struct_ref_app_38_6671);
   }
   {
      obj_t struct_object__object_pre_struct_ref_app_167_6670;
      struct_object__object_pre_struct_ref_app_167_6670 = proc3655_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_struct_ref_app_207_cfa_info, struct_object__object_pre_struct_ref_app_167_6670);
   }
   {
      obj_t object__struct_pre_make_struct_app_244_6669;
      object__struct_pre_make_struct_app_244_6669 = proc3656_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_make_struct_app_218_cfa_info, object__struct_pre_make_struct_app_244_6669);
   }
   {
      obj_t struct_object__object_pre_make_struct_app_226_6668;
      struct_object__object_pre_make_struct_app_226_6668 = proc3657_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_make_struct_app_218_cfa_info, struct_object__object_pre_make_struct_app_226_6668);
   }
   {
      obj_t object__struct_vector_set__app_75_6667;
      object__struct_vector_set__app_75_6667 = proc3658_cfa_info;
      add_method__1___object(object__struct_env_210___object, vector_set__app_21_cfa_info, object__struct_vector_set__app_75_6667);
   }
   {
      obj_t struct_object__object_vector_set__app_246_6666;
      struct_object__object_vector_set__app_246_6666 = proc3659_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, vector_set__app_21_cfa_info, struct_object__object_vector_set__app_246_6666);
   }
   {
      obj_t object__struct_vector_ref_app_174_6665;
      object__struct_vector_ref_app_174_6665 = proc3660_cfa_info;
      add_method__1___object(object__struct_env_210___object, vector_ref_app_195_cfa_info, object__struct_vector_ref_app_174_6665);
   }
   {
      obj_t struct_object__object_vector_ref_app_116_6664;
      struct_object__object_vector_ref_app_116_6664 = proc3661_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, vector_ref_app_195_cfa_info, struct_object__object_vector_ref_app_116_6664);
   }
   {
      obj_t object__struct_create_vector_app_178_6663;
      object__struct_create_vector_app_178_6663 = proc3662_cfa_info;
      add_method__1___object(object__struct_env_210___object, create_vector_app_150_cfa_info, object__struct_create_vector_app_178_6663);
   }
   {
      obj_t struct_object__object_create_vector_app_49_6662;
      struct_object__object_create_vector_app_49_6662 = proc3663_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, create_vector_app_150_cfa_info, struct_object__object_create_vector_app_49_6662);
   }
   {
      obj_t object__struct_make_vector_app_114_6661;
      object__struct_make_vector_app_114_6661 = proc3664_cfa_info;
      add_method__1___object(object__struct_env_210___object, make_vector_app_205_cfa_info, object__struct_make_vector_app_114_6661);
   }
   {
      obj_t struct_object__object_make_vector_app_26_6660;
      struct_object__object_make_vector_app_26_6660 = proc3665_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, make_vector_app_205_cfa_info, struct_object__object_make_vector_app_26_6660);
   }
   {
      obj_t object__struct_pre_vector_set__app_201_6659;
      object__struct_pre_vector_set__app_201_6659 = proc3666_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_vector_set__app_211_cfa_info, object__struct_pre_vector_set__app_201_6659);
   }
   {
      obj_t struct_object__object_pre_vector_set__app_122_6658;
      struct_object__object_pre_vector_set__app_122_6658 = proc3667_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_vector_set__app_211_cfa_info, struct_object__object_pre_vector_set__app_122_6658);
   }
   {
      obj_t object__struct_pre_vector_ref_app_11_6657;
      object__struct_pre_vector_ref_app_11_6657 = proc3668_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_vector_ref_app_208_cfa_info, object__struct_pre_vector_ref_app_11_6657);
   }
   {
      obj_t struct_object__object_pre_vector_ref_app_99_6656;
      struct_object__object_pre_vector_ref_app_99_6656 = proc3669_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_vector_ref_app_208_cfa_info, struct_object__object_pre_vector_ref_app_99_6656);
   }
   {
      obj_t object__struct_pre_create_vector_app_184_6655;
      object__struct_pre_create_vector_app_184_6655 = proc3670_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_create_vector_app_162_cfa_info, object__struct_pre_create_vector_app_184_6655);
   }
   {
      obj_t struct_object__object_pre_create_vector_app_213_6654;
      struct_object__object_pre_create_vector_app_213_6654 = proc3671_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_create_vector_app_162_cfa_info, struct_object__object_pre_create_vector_app_213_6654);
   }
   {
      obj_t object__struct_pre_make_vector_app_189_6653;
      object__struct_pre_make_vector_app_189_6653 = proc3672_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_make_vector_app_251_cfa_info, object__struct_pre_make_vector_app_189_6653);
   }
   {
      obj_t struct_object__object_pre_make_vector_app_45_6652;
      struct_object__object_pre_make_vector_app_45_6652 = proc3673_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_make_vector_app_251_cfa_info, struct_object__object_pre_make_vector_app_45_6652);
   }
   {
      obj_t object__struct_procedure_set__app_86_6651;
      object__struct_procedure_set__app_86_6651 = proc3674_cfa_info;
      add_method__1___object(object__struct_env_210___object, procedure_set__app_32_cfa_info, object__struct_procedure_set__app_86_6651);
   }
   {
      obj_t struct_object__object_procedure_set__app_110_6650;
      struct_object__object_procedure_set__app_110_6650 = proc3675_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, procedure_set__app_32_cfa_info, struct_object__object_procedure_set__app_110_6650);
   }
   {
      obj_t object__struct_procedure_ref_app_22_6649;
      object__struct_procedure_ref_app_22_6649 = proc3676_cfa_info;
      add_method__1___object(object__struct_env_210___object, procedure_ref_app_49_cfa_info, object__struct_procedure_ref_app_22_6649);
   }
   {
      obj_t struct_object__object_procedure_ref_app_161_6648;
      struct_object__object_procedure_ref_app_161_6648 = proc3677_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, procedure_ref_app_49_cfa_info, struct_object__object_procedure_ref_app_161_6648);
   }
   {
      obj_t object__struct_make_procedure_app_124_6647;
      object__struct_make_procedure_app_124_6647 = proc3678_cfa_info;
      add_method__1___object(object__struct_env_210___object, make_procedure_app_48_cfa_info, object__struct_make_procedure_app_124_6647);
   }
   {
      obj_t struct_object__object_make_procedure_app_38_6646;
      struct_object__object_make_procedure_app_38_6646 = proc3679_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, make_procedure_app_48_cfa_info, struct_object__object_make_procedure_app_38_6646);
   }
   {
      obj_t object__struct_pre_procedure_set__app_130_6645;
      object__struct_pre_procedure_set__app_130_6645 = proc3680_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_procedure_set__app_208_cfa_info, object__struct_pre_procedure_set__app_130_6645);
   }
   {
      obj_t struct_object__object_pre_procedure_set__app_129_6644;
      struct_object__object_pre_procedure_set__app_129_6644 = proc3681_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_procedure_set__app_208_cfa_info, struct_object__object_pre_procedure_set__app_129_6644);
   }
   {
      obj_t object__struct_pre_procedure_ref_app_223_6643;
      object__struct_pre_procedure_ref_app_223_6643 = proc3682_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_procedure_ref_app_85_cfa_info, object__struct_pre_procedure_ref_app_223_6643);
   }
   {
      obj_t struct_object__object_pre_procedure_ref_app_139_6642;
      struct_object__object_pre_procedure_ref_app_139_6642 = proc3683_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_procedure_ref_app_85_cfa_info, struct_object__object_pre_procedure_ref_app_139_6642);
   }
   {
      obj_t object__struct_pre_make_procedure_app_202_6641;
      object__struct_pre_make_procedure_app_202_6641 = proc3684_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_make_procedure_app_60_cfa_info, object__struct_pre_make_procedure_app_202_6641);
   }
   {
      obj_t struct_object__object_pre_make_procedure_app_51_6640;
      struct_object__object_pre_make_procedure_app_51_6640 = proc3685_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_make_procedure_app_60_cfa_info, struct_object__object_pre_make_procedure_app_51_6640);
   }
   {
      obj_t object__struct_box_ref_o_cinfo_174_6639;
      object__struct_box_ref_o_cinfo_174_6639 = proc3686_cfa_info;
      add_method__1___object(object__struct_env_210___object, box_ref_o_cinfo_98_cfa_info, object__struct_box_ref_o_cinfo_174_6639);
   }
   {
      obj_t struct_object__object_box_ref_o_cinfo_19_6638;
      struct_object__object_box_ref_o_cinfo_19_6638 = proc3687_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, box_ref_o_cinfo_98_cfa_info, struct_object__object_box_ref_o_cinfo_19_6638);
   }
   {
      obj_t object__struct_box_set__o_cinfo_141_6637;
      object__struct_box_set__o_cinfo_141_6637 = proc3688_cfa_info;
      add_method__1___object(object__struct_env_210___object, box_set__o_cinfo_6_cfa_info, object__struct_box_set__o_cinfo_141_6637);
   }
   {
      obj_t struct_object__object_box_set__o_cinfo_219_6636;
      struct_object__object_box_set__o_cinfo_219_6636 = proc3689_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, box_set__o_cinfo_6_cfa_info, struct_object__object_box_set__o_cinfo_219_6636);
   }
   {
      obj_t object__struct_box_ref_cinfo_171_6635;
      object__struct_box_ref_cinfo_171_6635 = proc3690_cfa_info;
      add_method__1___object(object__struct_env_210___object, box_ref_cinfo_214_cfa_info, object__struct_box_ref_cinfo_171_6635);
   }
   {
      obj_t struct_object__object_box_ref_cinfo_78_6634;
      struct_object__object_box_ref_cinfo_78_6634 = proc3691_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, box_ref_cinfo_214_cfa_info, struct_object__object_box_ref_cinfo_78_6634);
   }
   {
      obj_t object__struct_box_set__cinfo_66_6633;
      object__struct_box_set__cinfo_66_6633 = proc3692_cfa_info;
      add_method__1___object(object__struct_env_210___object, box_set__cinfo_94_cfa_info, object__struct_box_set__cinfo_66_6633);
   }
   {
      obj_t struct_object__object_box_set__cinfo_119_6632;
      struct_object__object_box_set__cinfo_119_6632 = proc3693_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, box_set__cinfo_94_cfa_info, struct_object__object_box_set__cinfo_119_6632);
   }
   {
      obj_t object__struct_make_box_o_cinfo_104_6631;
      object__struct_make_box_o_cinfo_104_6631 = proc3694_cfa_info;
      add_method__1___object(object__struct_env_210___object, make_box_o_cinfo_96_cfa_info, object__struct_make_box_o_cinfo_104_6631);
   }
   {
      obj_t struct_object__object_make_box_o_cinfo_100_6630;
      struct_object__object_make_box_o_cinfo_100_6630 = proc3695_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, make_box_o_cinfo_96_cfa_info, struct_object__object_make_box_o_cinfo_100_6630);
   }
   {
      obj_t object__struct_make_box_cinfo_186_6629;
      object__struct_make_box_cinfo_186_6629 = proc3696_cfa_info;
      add_method__1___object(object__struct_env_210___object, make_box_cinfo_127_cfa_info, object__struct_make_box_cinfo_186_6629);
   }
   {
      obj_t struct_object__object_make_box_cinfo_10_6628;
      struct_object__object_make_box_cinfo_10_6628 = proc3697_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, make_box_cinfo_127_cfa_info, struct_object__object_make_box_cinfo_10_6628);
   }
   {
      obj_t object__struct_pre_make_box_150_6627;
      object__struct_pre_make_box_150_6627 = proc3698_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_make_box_186_cfa_info, object__struct_pre_make_box_150_6627);
   }
   {
      obj_t struct_object__object_pre_make_box_16_6626;
      struct_object__object_pre_make_box_16_6626 = proc3699_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_make_box_186_cfa_info, struct_object__object_pre_make_box_16_6626);
   }
   {
      obj_t object__struct_jump_ex_it_cinfo_111_6625;
      object__struct_jump_ex_it_cinfo_111_6625 = proc3700_cfa_info;
      add_method__1___object(object__struct_env_210___object, jump_ex_it_cinfo_139_cfa_info, object__struct_jump_ex_it_cinfo_111_6625);
   }
   {
      obj_t struct_object__object_jump_ex_it_cinfo_82_6624;
      struct_object__object_jump_ex_it_cinfo_82_6624 = proc3701_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, jump_ex_it_cinfo_139_cfa_info, struct_object__object_jump_ex_it_cinfo_82_6624);
   }
   {
      obj_t object__struct_set_ex_it_cinfo_216_6623;
      object__struct_set_ex_it_cinfo_216_6623 = proc3702_cfa_info;
      add_method__1___object(object__struct_env_210___object, set_ex_it_cinfo_168_cfa_info, object__struct_set_ex_it_cinfo_216_6623);
   }
   {
      obj_t struct_object__object_set_ex_it_cinfo_254_6622;
      struct_object__object_set_ex_it_cinfo_254_6622 = proc3703_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, set_ex_it_cinfo_168_cfa_info, struct_object__object_set_ex_it_cinfo_254_6622);
   }
   {
      obj_t object__struct_select_cinfo_146_6621;
      object__struct_select_cinfo_146_6621 = proc3704_cfa_info;
      add_method__1___object(object__struct_env_210___object, select_cinfo_150_cfa_info, object__struct_select_cinfo_146_6621);
   }
   {
      obj_t struct_object__object_select_cinfo_79_6620;
      struct_object__object_select_cinfo_79_6620 = proc3705_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, select_cinfo_150_cfa_info, struct_object__object_select_cinfo_79_6620);
   }
   {
      obj_t object__struct_fail_cinfo_130_6619;
      object__struct_fail_cinfo_130_6619 = proc3706_cfa_info;
      add_method__1___object(object__struct_env_210___object, fail_cinfo_75_cfa_info, object__struct_fail_cinfo_130_6619);
   }
   {
      obj_t struct_object__object_fail_cinfo_67_6618;
      struct_object__object_fail_cinfo_67_6618 = proc3707_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, fail_cinfo_75_cfa_info, struct_object__object_fail_cinfo_67_6618);
   }
   {
      obj_t object__struct_conditional_cinfo_223_6617;
      object__struct_conditional_cinfo_223_6617 = proc3708_cfa_info;
      add_method__1___object(object__struct_env_210___object, conditional_cinfo_212_cfa_info, object__struct_conditional_cinfo_223_6617);
   }
   {
      obj_t struct_object__object_conditional_cinfo_141_6616;
      struct_object__object_conditional_cinfo_141_6616 = proc3709_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, conditional_cinfo_212_cfa_info, struct_object__object_conditional_cinfo_141_6616);
   }
   {
      obj_t object__struct_setq_cinfo_111_6615;
      object__struct_setq_cinfo_111_6615 = proc3710_cfa_info;
      add_method__1___object(object__struct_env_210___object, setq_cinfo_191_cfa_info, object__struct_setq_cinfo_111_6615);
   }
   {
      obj_t struct_object__object_setq_cinfo_26_6614;
      struct_object__object_setq_cinfo_26_6614 = proc3711_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, setq_cinfo_191_cfa_info, struct_object__object_setq_cinfo_26_6614);
   }
   {
      obj_t object__struct_pragma_cinfo_175_6613;
      object__struct_pragma_cinfo_175_6613 = proc3712_cfa_info;
      add_method__1___object(object__struct_env_210___object, pragma_cinfo_220_cfa_info, object__struct_pragma_cinfo_175_6613);
   }
   {
      obj_t struct_object__object_pragma_cinfo_100_6612;
      struct_object__object_pragma_cinfo_100_6612 = proc3713_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pragma_cinfo_220_cfa_info, struct_object__object_pragma_cinfo_100_6612);
   }
   {
      obj_t object__struct_funcall_cinfo_250_6611;
      object__struct_funcall_cinfo_250_6611 = proc3714_cfa_info;
      add_method__1___object(object__struct_env_210___object, funcall_cinfo_75_cfa_info, object__struct_funcall_cinfo_250_6611);
   }
   {
      obj_t struct_object__object_funcall_cinfo_97_6610;
      struct_object__object_funcall_cinfo_97_6610 = proc3715_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, funcall_cinfo_75_cfa_info, struct_object__object_funcall_cinfo_97_6610);
   }
   {
      obj_t object__struct_app_ly_cinfo_39_6609;
      object__struct_app_ly_cinfo_39_6609 = proc3716_cfa_info;
      add_method__1___object(object__struct_env_210___object, app_ly_cinfo_234_cfa_info, object__struct_app_ly_cinfo_39_6609);
   }
   {
      obj_t struct_object__object_app_ly_cinfo_255_6608;
      struct_object__object_app_ly_cinfo_255_6608 = proc3717_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, app_ly_cinfo_234_cfa_info, struct_object__object_app_ly_cinfo_255_6608);
   }
   {
      obj_t object__struct_kwote_cinfo_203_6607;
      object__struct_kwote_cinfo_203_6607 = proc3718_cfa_info;
      add_method__1___object(object__struct_env_210___object, kwote_cinfo_48_cfa_info, object__struct_kwote_cinfo_203_6607);
   }
   {
      obj_t struct_object__object_kwote_cinfo_192_6606;
      struct_object__object_kwote_cinfo_192_6606 = proc3719_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, kwote_cinfo_48_cfa_info, struct_object__object_kwote_cinfo_192_6606);
   }
   {
      obj_t object__struct_kwote_node_184_6605;
      object__struct_kwote_node_184_6605 = proc3720_cfa_info;
      add_method__1___object(object__struct_env_210___object, kwote_node_102_cfa_info, object__struct_kwote_node_184_6605);
   }
   {
      obj_t struct_object__object_kwote_node_133_6604;
      struct_object__object_kwote_node_133_6604 = proc3721_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, kwote_node_102_cfa_info, struct_object__object_kwote_node_133_6604);
   }
   {
      obj_t object__struct_atom_cinfo_211_6603;
      object__struct_atom_cinfo_211_6603 = proc3722_cfa_info;
      add_method__1___object(object__struct_env_210___object, atom_cinfo_155_cfa_info, object__struct_atom_cinfo_211_6603);
   }
   {
      obj_t struct_object__object_atom_cinfo_113_6602;
      struct_object__object_atom_cinfo_113_6602 = proc3723_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, atom_cinfo_155_cfa_info, struct_object__object_atom_cinfo_113_6602);
   }
   {
      obj_t object__struct_reshaped_global_19_6601;
      object__struct_reshaped_global_19_6601 = proc3724_cfa_info;
      add_method__1___object(object__struct_env_210___object, reshaped_global_160_cfa_info, object__struct_reshaped_global_19_6601);
   }
   {
      obj_t struct_object__object_reshaped_global_132_6600;
      struct_object__object_reshaped_global_132_6600 = proc3725_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, reshaped_global_160_cfa_info, struct_object__object_reshaped_global_132_6600);
   }
   {
      obj_t object__struct_reshaped_local_22_6599;
      object__struct_reshaped_local_22_6599 = proc3726_cfa_info;
      add_method__1___object(object__struct_env_210___object, reshaped_local_224_cfa_info, object__struct_reshaped_local_22_6599);
   }
   {
      obj_t struct_object__object_reshaped_local_214_6598;
      struct_object__object_reshaped_local_214_6598 = proc3727_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, reshaped_local_224_cfa_info, struct_object__object_reshaped_local_214_6598);
   }
   {
      obj_t object__struct_sexit_cinfo_98_6597;
      object__struct_sexit_cinfo_98_6597 = proc3728_cfa_info;
      add_method__1___object(object__struct_env_210___object, sexit_cinfo_49_cfa_info, object__struct_sexit_cinfo_98_6597);
   }
   {
      obj_t struct_object__object_sexit_cinfo_74_6596;
      struct_object__object_sexit_cinfo_74_6596 = proc3729_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, sexit_cinfo_49_cfa_info, struct_object__object_sexit_cinfo_74_6596);
   }
   {
      obj_t object__struct_cvar_cinfo_219_6595;
      object__struct_cvar_cinfo_219_6595 = proc3730_cfa_info;
      add_method__1___object(object__struct_env_210___object, cvar_cinfo_53_cfa_info, object__struct_cvar_cinfo_219_6595);
   }
   {
      obj_t struct_object__object_cvar_cinfo_125_6594;
      struct_object__object_cvar_cinfo_125_6594 = proc3731_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, cvar_cinfo_53_cfa_info, struct_object__object_cvar_cinfo_125_6594);
   }
   {
      obj_t object__struct_svar_cinfo_7_6593;
      object__struct_svar_cinfo_7_6593 = proc3732_cfa_info;
      add_method__1___object(object__struct_env_210___object, svar_cinfo_166_cfa_info, object__struct_svar_cinfo_7_6593);
   }
   {
      obj_t struct_object__object_svar_cinfo_24_6592;
      struct_object__object_svar_cinfo_24_6592 = proc3733_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, svar_cinfo_166_cfa_info, struct_object__object_svar_cinfo_24_6592);
   }
   {
      obj_t object__struct_pre_clo_env_226_6591;
      object__struct_pre_clo_env_226_6591 = proc3734_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_clo_env_191_cfa_info, object__struct_pre_clo_env_226_6591);
   }
   {
      obj_t struct_object__object_pre_clo_env_30_6590;
      struct_object__object_pre_clo_env_30_6590 = proc3735_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_clo_env_191_cfa_info, struct_object__object_pre_clo_env_30_6590);
   }
   {
      obj_t object__struct_scnst_cinfo_225_6589;
      object__struct_scnst_cinfo_225_6589 = proc3736_cfa_info;
      add_method__1___object(object__struct_env_210___object, scnst_cinfo_0_cfa_info, object__struct_scnst_cinfo_225_6589);
   }
   {
      obj_t struct_object__object_scnst_cinfo_187_6588;
      struct_object__object_scnst_cinfo_187_6588 = proc3737_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, scnst_cinfo_0_cfa_info, struct_object__object_scnst_cinfo_187_6588);
   }
   {
      obj_t object__struct_intern_sfun_cinfo_28_6587;
      object__struct_intern_sfun_cinfo_28_6587 = proc3738_cfa_info;
      add_method__1___object(object__struct_env_210___object, intern_sfun_cinfo_192_cfa_info, object__struct_intern_sfun_cinfo_28_6587);
   }
   {
      obj_t struct_object__object_intern_sfun_cinfo_38_6586;
      struct_object__object_intern_sfun_cinfo_38_6586 = proc3739_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, intern_sfun_cinfo_192_cfa_info, struct_object__object_intern_sfun_cinfo_38_6586);
   }
   {
      obj_t object__struct_extern_sfun_cinfo_81_6585;
      object__struct_extern_sfun_cinfo_81_6585 = proc3740_cfa_info;
      add_method__1___object(object__struct_env_210___object, extern_sfun_cinfo_6_cfa_info, object__struct_extern_sfun_cinfo_81_6585);
   }
   {
      obj_t struct_object__object_extern_sfun_cinfo_23_6584;
      struct_object__object_extern_sfun_cinfo_23_6584 = proc3741_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, extern_sfun_cinfo_6_cfa_info, struct_object__object_extern_sfun_cinfo_23_6584);
   }
   {
      obj_t object__struct_cfun_cinfo_76_6581;
      object__struct_cfun_cinfo_76_6581 = proc3742_cfa_info;
      add_method__1___object(object__struct_env_210___object, cfun_cinfo_200_cfa_info, object__struct_cfun_cinfo_76_6581);
   }
   {
      obj_t struct_object__object_cfun_cinfo_204_6577;
      struct_object__object_cfun_cinfo_204_6577 = proc3743_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, cfun_cinfo_200_cfa_info, struct_object__object_cfun_cinfo_204_6577);
   }
   {
      obj_t object__struct_approx_119_6576;
      object__struct_approx_119_6576 = proc3744_cfa_info;
      add_method__1___object(object__struct_env_210___object, approx_cfa_info, object__struct_approx_119_6576);
   }
   {
      obj_t struct_object__object_approx_184_6575;
      struct_object__object_approx_184_6575 = proc3745_cfa_info;
      return add_method__1___object(struct_object__object_env_209___object, approx_cfa_info, struct_object__object_approx_184_6575);
   }
}


obj_t 
struct_object__object_approx3546_115_cfa_info(obj_t env_6680, obj_t o_6681, obj_t s_6682)
{
   {
      approx_t o_3628;
      obj_t s_3629;
      {
	 approx_t aux_7213;
	 o_3628 = (approx_t) (o_6681);
	 s_3629 = s_6682;
	 {
	    obj_t aux_7216;
	    object_t aux_7214;
	    aux_7216 = STRUCT_REF(s_3629, ((long) 0));
	    aux_7214 = (object_t) (o_3628);
	    OBJECT_WIDENING_SET(aux_7214, aux_7216);
	 }
	 {
	    type_t v1332_3633;
	    {
	       obj_t aux_7219;
	       aux_7219 = STRUCT_REF(s_3629, ((long) 1));
	       v1332_3633 = (type_t) (aux_7219);
	    }
	    ((((approx_t) CREF(o_3628))->type) = ((type_t) v1332_3633), BUNSPEC);
	 }
	 {
	    bool_t v1336_3634;
	    {
	       obj_t aux_7223;
	       aux_7223 = STRUCT_REF(s_3629, ((long) 2));
	       v1336_3634 = CBOOL(aux_7223);
	    }
	    ((((approx_t) CREF(o_3628))->type_locked__184) = ((bool_t) v1336_3634), BUNSPEC);
	 }
	 {
	    obj_t v1340_3635;
	    v1340_3635 = STRUCT_REF(s_3629, ((long) 3));
	    ((((approx_t) CREF(o_3628))->allocs) = ((obj_t) v1340_3635), BUNSPEC);
	 }
	 {
	    bool_t v1344_3636;
	    {
	       obj_t aux_7229;
	       aux_7229 = STRUCT_REF(s_3629, ((long) 4));
	       v1344_3636 = CBOOL(aux_7229);
	    }
	    ((((approx_t) CREF(o_3628))->top__138) = ((bool_t) v1344_3636), BUNSPEC);
	 }
	 {
	    long v1348_3637;
	    {
	       obj_t aux_7233;
	       aux_7233 = STRUCT_REF(s_3629, ((long) 5));
	       v1348_3637 = (long) CINT(aux_7233);
	    }
	    ((((approx_t) CREF(o_3628))->lost_stamp_114) = ((long) v1348_3637), BUNSPEC);
	 }
	 aux_7213 = o_3628;
	 return (obj_t) (aux_7213);
      }
   }
}


obj_t 
object__struct_approx3547_109_cfa_info(obj_t env_6683, obj_t obj1328_6684)
{
   {
      approx_t obj1328_3610;
      obj1328_3610 = (approx_t) (obj1328_6684);
      {
	 obj_t res1329_3613;
	 {
	    obj_t aux_7239;
	    aux_7239 = CNST_TABLE_REF(((long) 0));
	    res1329_3613 = make_struct(aux_7239, ((long) 6), BUNSPEC);
	 }
	 STRUCT_SET(res1329_3613, ((long) 0), BFALSE);
	 {
	    obj_t aux_7243;
	    {
	       type_t aux_7244;
	       aux_7244 = (((approx_t) CREF(obj1328_3610))->type);
	       aux_7243 = (obj_t) (aux_7244);
	    }
	    STRUCT_SET(res1329_3613, ((long) 1), aux_7243);
	 }
	 {
	    obj_t aux_7248;
	    {
	       bool_t aux_7249;
	       aux_7249 = (((approx_t) CREF(obj1328_3610))->type_locked__184);
	       aux_7248 = BBOOL(aux_7249);
	    }
	    STRUCT_SET(res1329_3613, ((long) 2), aux_7248);
	 }
	 {
	    obj_t aux_7253;
	    aux_7253 = (((approx_t) CREF(obj1328_3610))->allocs);
	    STRUCT_SET(res1329_3613, ((long) 3), aux_7253);
	 }
	 {
	    obj_t aux_7256;
	    {
	       bool_t aux_7257;
	       aux_7257 = (((approx_t) CREF(obj1328_3610))->top__138);
	       aux_7256 = BBOOL(aux_7257);
	    }
	    STRUCT_SET(res1329_3613, ((long) 4), aux_7256);
	 }
	 {
	    obj_t aux_7261;
	    {
	       long aux_7262;
	       aux_7262 = (((approx_t) CREF(obj1328_3610))->lost_stamp_114);
	       aux_7261 = BINT(aux_7262);
	    }
	    STRUCT_SET(res1329_3613, ((long) 5), aux_7261);
	 }
	 return res1329_3613;
      }
   }
}


obj_t 
struct_object__object_cfun_cinfo3548_146_cfa_info(obj_t env_6685, obj_t o_6686, obj_t s_6687)
{
   {
      cfun_cinfo_200_t o_3598;
      obj_t s_3599;
      {
	 cfun_cinfo_200_t aux_7267;
	 o_3598 = (cfun_cinfo_200_t) (o_6686);
	 s_3599 = s_6687;
	 {
	    {
	       obj_t old1365_3602;
	       obj_t aux1366_3603;
	       {
		  obj_t next_method2384_162_3608;
		  next_method2384_162_3608 = find_super_class_method_167___object((object_t) (o_3598), struct_object__object_env_209___object, cfun_cinfo_200_cfa_info);
		  if (PROCEDUREP(next_method2384_162_3608))
		    {
		       old1365_3602 = PROCEDURE_ENTRY(next_method2384_162_3608) (next_method2384_162_3608, (obj_t) (o_3598), s_3599, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2384_162_3608);
		       {
			  object_t aux_7276;
			  aux_7276 = struct_object__object_93___object((object_t) (o_3598), s_3599);
			  old1365_3602 = (obj_t) (aux_7276);
		       }
		    }
	       }
	       aux1366_3603 = STRUCT_REF(s_3599, ((long) 0));
	       {
		  cfun_cinfo_200_t new1367_3604;
		  new1367_3604 = ((cfun_cinfo_200_t) (old1365_3602));
		  {
		     long arg3248_3605;
		     arg3248_3605 = class_num_218___object(cfun_cinfo_200_cfa_info);
		     {
			obj_t obj_6081;
			obj_6081 = (obj_t) (new1367_3604);
			(((obj_t) CREF(obj_6081))->header = MAKE_HEADER(arg3248_3605, 0), BUNSPEC);
		     }
		  }
		  {
		     cfun_cinfo_200_t arg3249_3606;
		     {
			cfun_cinfo_200_t res3542_6088;
			{
			   approx_t approx_6085;
			   {
			      obj_t aux_7285;
			      aux_7285 = STRUCT_REF(aux1366_3603, ((long) 0));
			      approx_6085 = (approx_t) (aux_7285);
			   }
			   {
			      cfun_cinfo_200_t new1351_6086;
			      new1351_6086 = ((cfun_cinfo_200_t) BREF(GC_MALLOC(sizeof(struct cfun_cinfo_200))));
			      ((((cfun_cinfo_200_t) CREF(new1351_6086))->approx) = ((approx_t) approx_6085), BUNSPEC);
			      res3542_6088 = new1351_6086;
			   }
			}
			arg3249_3606 = res3542_6088;
		     }
		     {
			obj_t aux_7292;
			object_t aux_7290;
			aux_7292 = (obj_t) (arg3249_3606);
			aux_7290 = (object_t) (new1367_3604);
			OBJECT_WIDENING_SET(aux_7290, aux_7292);
		     }
		  }
		  aux_7267 = new1367_3604;
	       }
	    }
	 }
	 return (obj_t) (aux_7267);
      }
   }
}


obj_t 
object__struct_cfun_cinfo3549_117_cfa_info(obj_t env_6688, obj_t obj1362_6689)
{
   {
      cfun_cinfo_200_t obj1362_3585;
      obj1362_3585 = (cfun_cinfo_200_t) (obj1362_6689);
      {
	 {
	    obj_t res1363_3588;
	    {
	       obj_t next_method2383_109_3596;
	       next_method2383_109_3596 = find_super_class_method_167___object((object_t) (obj1362_3585), object__struct_env_210___object, cfun_cinfo_200_cfa_info);
	       if (PROCEDUREP(next_method2383_109_3596))
		 {
		    res1363_3588 = PROCEDURE_ENTRY(next_method2383_109_3596) (next_method2383_109_3596, (obj_t) (obj1362_3585), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2383_109_3596);
		    res1363_3588 = object__struct_50___object((object_t) (obj1362_3585));
		 }
	    }
	    {
	       obj_t aux1364_3589;
	       {
		  obj_t aux_7307;
		  aux_7307 = CNST_TABLE_REF(((long) 1));
		  aux1364_3589 = make_struct(aux_7307, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_7310;
		  {
		     approx_t aux_7311;
		     {
			obj_t aux_7312;
			{
			   object_t aux_7313;
			   aux_7313 = (object_t) (obj1362_3585);
			   aux_7312 = OBJECT_WIDENING(aux_7313);
			}
			aux_7311 = (((cfun_cinfo_200_t) CREF(aux_7312))->approx);
		     }
		     aux_7310 = (obj_t) (aux_7311);
		  }
		  STRUCT_SET(aux1364_3589, ((long) 0), aux_7310);
	       }
	       STRUCT_SET(res1363_3588, ((long) 0), aux1364_3589);
	       {
		  obj_t aux_7320;
		  aux_7320 = STRUCT_KEY(res1363_3588);
		  STRUCT_KEY_SET(aux1364_3589, aux_7320);
	       }
	       {
		  obj_t aux_7323;
		  aux_7323 = CNST_TABLE_REF(((long) 1));
		  STRUCT_KEY_SET(res1363_3588, aux_7323);
	       }
	       return res1363_3588;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_extern_sfun_cinfo3550_31_cfa_info(obj_t env_6690, obj_t o_6691, obj_t s_6692)
{
   {
      extern_sfun_cinfo_6_t o_3573;
      obj_t s_3574;
      {
	 extern_sfun_cinfo_6_t aux_7327;
	 o_3573 = (extern_sfun_cinfo_6_t) (o_6691);
	 s_3574 = s_6692;
	 {
	    {
	       obj_t old1388_3577;
	       obj_t aux1389_3578;
	       {
		  obj_t next_method2382_47_3583;
		  next_method2382_47_3583 = find_super_class_method_167___object((object_t) (o_3573), struct_object__object_env_209___object, extern_sfun_cinfo_6_cfa_info);
		  if (PROCEDUREP(next_method2382_47_3583))
		    {
		       old1388_3577 = PROCEDURE_ENTRY(next_method2382_47_3583) (next_method2382_47_3583, (obj_t) (o_3573), s_3574, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2382_47_3583);
		       {
			  object_t aux_7336;
			  aux_7336 = struct_object__object_93___object((object_t) (o_3573), s_3574);
			  old1388_3577 = (obj_t) (aux_7336);
		       }
		    }
	       }
	       aux1389_3578 = STRUCT_REF(s_3574, ((long) 0));
	       {
		  extern_sfun_cinfo_6_t new1390_3579;
		  new1390_3579 = ((extern_sfun_cinfo_6_t) (old1388_3577));
		  {
		     long arg3237_3580;
		     arg3237_3580 = class_num_218___object(extern_sfun_cinfo_6_cfa_info);
		     {
			obj_t obj_6052;
			obj_6052 = (obj_t) (new1390_3579);
			(((obj_t) CREF(obj_6052))->header = MAKE_HEADER(arg3237_3580, 0), BUNSPEC);
		     }
		  }
		  {
		     extern_sfun_cinfo_6_t arg3238_3581;
		     {
			extern_sfun_cinfo_6_t res3541_6059;
			{
			   approx_t approx_6056;
			   {
			      obj_t aux_7345;
			      aux_7345 = STRUCT_REF(aux1389_3578, ((long) 0));
			      approx_6056 = (approx_t) (aux_7345);
			   }
			   {
			      extern_sfun_cinfo_6_t new1369_6057;
			      new1369_6057 = ((extern_sfun_cinfo_6_t) BREF(GC_MALLOC(sizeof(struct extern_sfun_cinfo_6))));
			      ((((extern_sfun_cinfo_6_t) CREF(new1369_6057))->approx) = ((approx_t) approx_6056), BUNSPEC);
			      res3541_6059 = new1369_6057;
			   }
			}
			arg3238_3581 = res3541_6059;
		     }
		     {
			obj_t aux_7352;
			object_t aux_7350;
			aux_7352 = (obj_t) (arg3238_3581);
			aux_7350 = (object_t) (new1390_3579);
			OBJECT_WIDENING_SET(aux_7350, aux_7352);
		     }
		  }
		  aux_7327 = new1390_3579;
	       }
	    }
	 }
	 return (obj_t) (aux_7327);
      }
   }
}


obj_t 
object__struct_extern_sfun_cinfo3551_56_cfa_info(obj_t env_6693, obj_t obj1385_6694)
{
   {
      extern_sfun_cinfo_6_t obj1385_3560;
      obj1385_3560 = (extern_sfun_cinfo_6_t) (obj1385_6694);
      {
	 {
	    obj_t res1386_3563;
	    {
	       obj_t next_method2381_180_3571;
	       next_method2381_180_3571 = find_super_class_method_167___object((object_t) (obj1385_3560), object__struct_env_210___object, extern_sfun_cinfo_6_cfa_info);
	       if (PROCEDUREP(next_method2381_180_3571))
		 {
		    res1386_3563 = PROCEDURE_ENTRY(next_method2381_180_3571) (next_method2381_180_3571, (obj_t) (obj1385_3560), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2381_180_3571);
		    res1386_3563 = object__struct_50___object((object_t) (obj1385_3560));
		 }
	    }
	    {
	       obj_t aux1387_3564;
	       {
		  obj_t aux_7367;
		  aux_7367 = CNST_TABLE_REF(((long) 2));
		  aux1387_3564 = make_struct(aux_7367, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_7370;
		  {
		     approx_t aux_7371;
		     {
			obj_t aux_7372;
			{
			   object_t aux_7373;
			   aux_7373 = (object_t) (obj1385_3560);
			   aux_7372 = OBJECT_WIDENING(aux_7373);
			}
			aux_7371 = (((extern_sfun_cinfo_6_t) CREF(aux_7372))->approx);
		     }
		     aux_7370 = (obj_t) (aux_7371);
		  }
		  STRUCT_SET(aux1387_3564, ((long) 0), aux_7370);
	       }
	       STRUCT_SET(res1386_3563, ((long) 0), aux1387_3564);
	       {
		  obj_t aux_7380;
		  aux_7380 = STRUCT_KEY(res1386_3563);
		  STRUCT_KEY_SET(aux1387_3564, aux_7380);
	       }
	       {
		  obj_t aux_7383;
		  aux_7383 = CNST_TABLE_REF(((long) 2));
		  STRUCT_KEY_SET(res1386_3563, aux_7383);
	       }
	       return res1386_3563;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_intern_sfun_cinfo3552_203_cfa_info(obj_t env_6695, obj_t o_6696, obj_t s_6697)
{
   {
      intern_sfun_cinfo_192_t o_3547;
      obj_t s_3548;
      {
	 intern_sfun_cinfo_192_t aux_7387;
	 o_3547 = (intern_sfun_cinfo_192_t) (o_6696);
	 s_3548 = s_6697;
	 {
	    {
	       obj_t old1411_3551;
	       obj_t aux1412_3552;
	       {
		  obj_t next_method2380_205_3558;
		  next_method2380_205_3558 = find_super_class_method_167___object((object_t) (o_3547), struct_object__object_env_209___object, intern_sfun_cinfo_192_cfa_info);
		  if (PROCEDUREP(next_method2380_205_3558))
		    {
		       old1411_3551 = PROCEDURE_ENTRY(next_method2380_205_3558) (next_method2380_205_3558, (obj_t) (o_3547), s_3548, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2380_205_3558);
		       {
			  object_t aux_7396;
			  aux_7396 = struct_object__object_93___object((object_t) (o_3547), s_3548);
			  old1411_3551 = (obj_t) (aux_7396);
		       }
		    }
	       }
	       aux1412_3552 = STRUCT_REF(s_3548, ((long) 0));
	       {
		  intern_sfun_cinfo_192_t new1413_3553;
		  new1413_3553 = ((intern_sfun_cinfo_192_t) (old1411_3551));
		  {
		     long arg3225_3554;
		     arg3225_3554 = class_num_218___object(intern_sfun_cinfo_192_cfa_info);
		     {
			obj_t obj_6019;
			obj_6019 = (obj_t) (new1413_3553);
			(((obj_t) CREF(obj_6019))->header = MAKE_HEADER(arg3225_3554, 0), BUNSPEC);
		     }
		  }
		  {
		     intern_sfun_cinfo_192_t arg3226_3555;
		     {
			intern_sfun_cinfo_192_t res3540_6030;
			{
			   approx_t approx_6025;
			   long stamp_6026;
			   {
			      obj_t aux_7405;
			      aux_7405 = STRUCT_REF(aux1412_3552, ((long) 0));
			      approx_6025 = (approx_t) (aux_7405);
			   }
			   {
			      obj_t aux_7408;
			      aux_7408 = STRUCT_REF(aux1412_3552, ((long) 1));
			      stamp_6026 = (long) CINT(aux_7408);
			   }
			   {
			      intern_sfun_cinfo_192_t new1392_6027;
			      new1392_6027 = ((intern_sfun_cinfo_192_t) BREF(GC_MALLOC(sizeof(struct intern_sfun_cinfo_192))));
			      ((((intern_sfun_cinfo_192_t) CREF(new1392_6027))->approx) = ((approx_t) approx_6025), BUNSPEC);
			      ((((intern_sfun_cinfo_192_t) CREF(new1392_6027))->stamp) = ((long) stamp_6026), BUNSPEC);
			      res3540_6030 = new1392_6027;
			   }
			}
			arg3226_3555 = res3540_6030;
		     }
		     {
			obj_t aux_7416;
			object_t aux_7414;
			aux_7416 = (obj_t) (arg3226_3555);
			aux_7414 = (object_t) (new1413_3553);
			OBJECT_WIDENING_SET(aux_7414, aux_7416);
		     }
		  }
		  aux_7387 = new1413_3553;
	       }
	    }
	 }
	 return (obj_t) (aux_7387);
      }
   }
}


obj_t 
object__struct_intern_sfun_cinfo3553_214_cfa_info(obj_t env_6698, obj_t obj1408_6699)
{
   {
      intern_sfun_cinfo_192_t obj1408_3532;
      obj1408_3532 = (intern_sfun_cinfo_192_t) (obj1408_6699);
      {
	 {
	    obj_t res1409_3535;
	    {
	       obj_t next_method2379_47_3545;
	       next_method2379_47_3545 = find_super_class_method_167___object((object_t) (obj1408_3532), object__struct_env_210___object, intern_sfun_cinfo_192_cfa_info);
	       if (PROCEDUREP(next_method2379_47_3545))
		 {
		    res1409_3535 = PROCEDURE_ENTRY(next_method2379_47_3545) (next_method2379_47_3545, (obj_t) (obj1408_3532), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2379_47_3545);
		    res1409_3535 = object__struct_50___object((object_t) (obj1408_3532));
		 }
	    }
	    {
	       obj_t aux1410_3536;
	       {
		  obj_t aux_7431;
		  aux_7431 = CNST_TABLE_REF(((long) 3));
		  aux1410_3536 = make_struct(aux_7431, ((long) 2), BUNSPEC);
	       }
	       {
		  obj_t aux_7434;
		  {
		     approx_t aux_7435;
		     {
			obj_t aux_7436;
			{
			   object_t aux_7437;
			   aux_7437 = (object_t) (obj1408_3532);
			   aux_7436 = OBJECT_WIDENING(aux_7437);
			}
			aux_7435 = (((intern_sfun_cinfo_192_t) CREF(aux_7436))->approx);
		     }
		     aux_7434 = (obj_t) (aux_7435);
		  }
		  STRUCT_SET(aux1410_3536, ((long) 0), aux_7434);
	       }
	       {
		  obj_t aux_7443;
		  {
		     long aux_7444;
		     {
			obj_t aux_7445;
			{
			   object_t aux_7446;
			   aux_7446 = (object_t) (obj1408_3532);
			   aux_7445 = OBJECT_WIDENING(aux_7446);
			}
			aux_7444 = (((intern_sfun_cinfo_192_t) CREF(aux_7445))->stamp);
		     }
		     aux_7443 = BINT(aux_7444);
		  }
		  STRUCT_SET(aux1410_3536, ((long) 1), aux_7443);
	       }
	       STRUCT_SET(res1409_3535, ((long) 0), aux1410_3536);
	       {
		  obj_t aux_7453;
		  aux_7453 = STRUCT_KEY(res1409_3535);
		  STRUCT_KEY_SET(aux1410_3536, aux_7453);
	       }
	       {
		  obj_t aux_7456;
		  aux_7456 = CNST_TABLE_REF(((long) 3));
		  STRUCT_KEY_SET(res1409_3535, aux_7456);
	       }
	       return res1409_3535;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_scnst_cinfo3554_122_cfa_info(obj_t env_6700, obj_t o_6701, obj_t s_6702)
{
   {
      scnst_cinfo_0_t o_3520;
      obj_t s_3521;
      {
	 scnst_cinfo_0_t aux_7460;
	 o_3520 = (scnst_cinfo_0_t) (o_6701);
	 s_3521 = s_6702;
	 {
	    {
	       obj_t old1424_3524;
	       obj_t aux1425_3525;
	       {
		  obj_t next_method2378_109_3530;
		  next_method2378_109_3530 = find_super_class_method_167___object((object_t) (o_3520), struct_object__object_env_209___object, scnst_cinfo_0_cfa_info);
		  if (PROCEDUREP(next_method2378_109_3530))
		    {
		       old1424_3524 = PROCEDURE_ENTRY(next_method2378_109_3530) (next_method2378_109_3530, (obj_t) (o_3520), s_3521, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2378_109_3530);
		       {
			  object_t aux_7469;
			  aux_7469 = struct_object__object_93___object((object_t) (o_3520), s_3521);
			  old1424_3524 = (obj_t) (aux_7469);
		       }
		    }
	       }
	       aux1425_3525 = STRUCT_REF(s_3521, ((long) 0));
	       {
		  scnst_cinfo_0_t new1426_3526;
		  new1426_3526 = ((scnst_cinfo_0_t) (old1424_3524));
		  {
		     long arg3212_3527;
		     arg3212_3527 = class_num_218___object(scnst_cinfo_0_cfa_info);
		     {
			obj_t obj_5986;
			obj_5986 = (obj_t) (new1426_3526);
			(((obj_t) CREF(obj_5986))->header = MAKE_HEADER(arg3212_3527, 0), BUNSPEC);
		     }
		  }
		  {
		     scnst_cinfo_0_t arg3213_3528;
		     {
			scnst_cinfo_0_t res3539_5993;
			{
			   approx_t approx_5990;
			   {
			      obj_t aux_7478;
			      aux_7478 = STRUCT_REF(aux1425_3525, ((long) 0));
			      approx_5990 = (approx_t) (aux_7478);
			   }
			   {
			      scnst_cinfo_0_t new1415_5991;
			      new1415_5991 = ((scnst_cinfo_0_t) BREF(GC_MALLOC(sizeof(struct scnst_cinfo_0))));
			      ((((scnst_cinfo_0_t) CREF(new1415_5991))->approx) = ((approx_t) approx_5990), BUNSPEC);
			      res3539_5993 = new1415_5991;
			   }
			}
			arg3213_3528 = res3539_5993;
		     }
		     {
			obj_t aux_7485;
			object_t aux_7483;
			aux_7485 = (obj_t) (arg3213_3528);
			aux_7483 = (object_t) (new1426_3526);
			OBJECT_WIDENING_SET(aux_7483, aux_7485);
		     }
		  }
		  aux_7460 = new1426_3526;
	       }
	    }
	 }
	 return (obj_t) (aux_7460);
      }
   }
}


obj_t 
object__struct_scnst_cinfo3555_66_cfa_info(obj_t env_6703, obj_t obj1421_6704)
{
   {
      scnst_cinfo_0_t obj1421_3507;
      obj1421_3507 = (scnst_cinfo_0_t) (obj1421_6704);
      {
	 {
	    obj_t res1422_3510;
	    {
	       obj_t next_method2377_230_3518;
	       next_method2377_230_3518 = find_super_class_method_167___object((object_t) (obj1421_3507), object__struct_env_210___object, scnst_cinfo_0_cfa_info);
	       if (PROCEDUREP(next_method2377_230_3518))
		 {
		    res1422_3510 = PROCEDURE_ENTRY(next_method2377_230_3518) (next_method2377_230_3518, (obj_t) (obj1421_3507), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2377_230_3518);
		    res1422_3510 = object__struct_50___object((object_t) (obj1421_3507));
		 }
	    }
	    {
	       obj_t aux1423_3511;
	       {
		  obj_t aux_7500;
		  aux_7500 = CNST_TABLE_REF(((long) 4));
		  aux1423_3511 = make_struct(aux_7500, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_7503;
		  {
		     approx_t aux_7504;
		     {
			obj_t aux_7505;
			{
			   object_t aux_7506;
			   aux_7506 = (object_t) (obj1421_3507);
			   aux_7505 = OBJECT_WIDENING(aux_7506);
			}
			aux_7504 = (((scnst_cinfo_0_t) CREF(aux_7505))->approx);
		     }
		     aux_7503 = (obj_t) (aux_7504);
		  }
		  STRUCT_SET(aux1423_3511, ((long) 0), aux_7503);
	       }
	       STRUCT_SET(res1422_3510, ((long) 0), aux1423_3511);
	       {
		  obj_t aux_7513;
		  aux_7513 = STRUCT_KEY(res1422_3510);
		  STRUCT_KEY_SET(aux1423_3511, aux_7513);
	       }
	       {
		  obj_t aux_7516;
		  aux_7516 = CNST_TABLE_REF(((long) 4));
		  STRUCT_KEY_SET(res1422_3510, aux_7516);
	       }
	       return res1422_3510;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_pre_clo_env3556_124_cfa_info(obj_t env_6705, obj_t o_6706, obj_t s_6707)
{
   {
      pre_clo_env_191_t o_3496;
      obj_t s_3497;
      {
	 pre_clo_env_191_t aux_7520;
	 o_3496 = (pre_clo_env_191_t) (o_6706);
	 s_3497 = s_6707;
	 {
	    {
	       obj_t old1437_3500;
	       {
		  obj_t next_method2376_142_3505;
		  next_method2376_142_3505 = find_super_class_method_167___object((object_t) (o_3496), struct_object__object_env_209___object, pre_clo_env_191_cfa_info);
		  if (PROCEDUREP(next_method2376_142_3505))
		    {
		       old1437_3500 = PROCEDURE_ENTRY(next_method2376_142_3505) (next_method2376_142_3505, (obj_t) (o_3496), s_3497, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2376_142_3505);
		       {
			  object_t aux_7529;
			  aux_7529 = struct_object__object_93___object((object_t) (o_3496), s_3497);
			  old1437_3500 = (obj_t) (aux_7529);
		       }
		    }
	       }
	       {
		  pre_clo_env_191_t new1439_3502;
		  new1439_3502 = ((pre_clo_env_191_t) (old1437_3500));
		  {
		     long arg3202_3503;
		     arg3202_3503 = class_num_218___object(pre_clo_env_191_cfa_info);
		     {
			obj_t obj_5961;
			obj_5961 = (obj_t) (new1439_3502);
			(((obj_t) CREF(obj_5961))->header = MAKE_HEADER(arg3202_3503, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_7539;
		     object_t aux_7537;
		     {
			pre_clo_env_191_t aux_7540;
			{
			   aux_7540 = ((pre_clo_env_191_t) BREF(GC_MALLOC(sizeof(struct pre_clo_env_191))));
			}
			aux_7539 = (obj_t) (aux_7540);
		     }
		     aux_7537 = (object_t) (new1439_3502);
		     OBJECT_WIDENING_SET(aux_7537, aux_7539);
		  }
		  aux_7520 = new1439_3502;
	       }
	    }
	 }
	 return (obj_t) (aux_7520);
      }
   }
}


obj_t 
object__struct_pre_clo_env3557_197_cfa_info(obj_t env_6708, obj_t obj1434_6709)
{
   {
      pre_clo_env_191_t obj1434_3485;
      obj1434_3485 = (pre_clo_env_191_t) (obj1434_6709);
      {
	 {
	    obj_t res1435_3488;
	    {
	       obj_t next_method2375_96_3494;
	       next_method2375_96_3494 = find_super_class_method_167___object((object_t) (obj1434_3485), object__struct_env_210___object, pre_clo_env_191_cfa_info);
	       if (PROCEDUREP(next_method2375_96_3494))
		 {
		    res1435_3488 = PROCEDURE_ENTRY(next_method2375_96_3494) (next_method2375_96_3494, (obj_t) (obj1434_3485), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2375_96_3494);
		    res1435_3488 = object__struct_50___object((object_t) (obj1434_3485));
		 }
	    }
	    {
	       obj_t aux1436_3489;
	       {
		  obj_t aux_7556;
		  aux_7556 = CNST_TABLE_REF(((long) 5));
		  aux1436_3489 = make_struct(aux_7556, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res1435_3488, ((long) 0), aux1436_3489);
	       {
		  obj_t aux_7560;
		  aux_7560 = STRUCT_KEY(res1435_3488);
		  STRUCT_KEY_SET(aux1436_3489, aux_7560);
	       }
	       {
		  obj_t aux_7563;
		  aux_7563 = CNST_TABLE_REF(((long) 5));
		  STRUCT_KEY_SET(res1435_3488, aux_7563);
	       }
	       return res1435_3488;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_svar_cinfo3558_151_cfa_info(obj_t env_6710, obj_t o_6711, obj_t s_6712)
{
   {
      svar_cinfo_166_t o_3472;
      obj_t s_3473;
      {
	 svar_cinfo_166_t aux_7567;
	 o_3472 = (svar_cinfo_166_t) (o_6711);
	 s_3473 = s_6712;
	 {
	    {
	       obj_t old1450_3476;
	       obj_t aux1451_3477;
	       {
		  obj_t next_method2374_227_3483;
		  next_method2374_227_3483 = find_super_class_method_167___object((object_t) (o_3472), struct_object__object_env_209___object, svar_cinfo_166_cfa_info);
		  if (PROCEDUREP(next_method2374_227_3483))
		    {
		       old1450_3476 = PROCEDURE_ENTRY(next_method2374_227_3483) (next_method2374_227_3483, (obj_t) (o_3472), s_3473, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2374_227_3483);
		       {
			  object_t aux_7576;
			  aux_7576 = struct_object__object_93___object((object_t) (o_3472), s_3473);
			  old1450_3476 = (obj_t) (aux_7576);
		       }
		    }
	       }
	       aux1451_3477 = STRUCT_REF(s_3473, ((long) 0));
	       {
		  svar_cinfo_166_t new1452_3478;
		  new1452_3478 = ((svar_cinfo_166_t) (old1450_3476));
		  {
		     long arg3192_3479;
		     arg3192_3479 = class_num_218___object(svar_cinfo_166_cfa_info);
		     {
			obj_t obj_5932;
			obj_5932 = (obj_t) (new1452_3478);
			(((obj_t) CREF(obj_5932))->header = MAKE_HEADER(arg3192_3479, 0), BUNSPEC);
		     }
		  }
		  {
		     svar_cinfo_166_t arg3193_3480;
		     {
			svar_cinfo_166_t res3537_5943;
			{
			   approx_t approx_5938;
			   bool_t clo_env__87_5939;
			   {
			      obj_t aux_7585;
			      aux_7585 = STRUCT_REF(aux1451_3477, ((long) 0));
			      approx_5938 = (approx_t) (aux_7585);
			   }
			   {
			      obj_t aux_7588;
			      aux_7588 = STRUCT_REF(aux1451_3477, ((long) 1));
			      clo_env__87_5939 = CBOOL(aux_7588);
			   }
			   {
			      svar_cinfo_166_t new1441_5940;
			      new1441_5940 = ((svar_cinfo_166_t) BREF(GC_MALLOC(sizeof(struct svar_cinfo_166))));
			      ((((svar_cinfo_166_t) CREF(new1441_5940))->approx) = ((approx_t) approx_5938), BUNSPEC);
			      ((((svar_cinfo_166_t) CREF(new1441_5940))->clo_env__87) = ((bool_t) clo_env__87_5939), BUNSPEC);
			      res3537_5943 = new1441_5940;
			   }
			}
			arg3193_3480 = res3537_5943;
		     }
		     {
			obj_t aux_7596;
			object_t aux_7594;
			aux_7596 = (obj_t) (arg3193_3480);
			aux_7594 = (object_t) (new1452_3478);
			OBJECT_WIDENING_SET(aux_7594, aux_7596);
		     }
		  }
		  aux_7567 = new1452_3478;
	       }
	    }
	 }
	 return (obj_t) (aux_7567);
      }
   }
}


obj_t 
object__struct_svar_cinfo3559_43_cfa_info(obj_t env_6713, obj_t obj1447_6714)
{
   {
      svar_cinfo_166_t obj1447_3457;
      obj1447_3457 = (svar_cinfo_166_t) (obj1447_6714);
      {
	 {
	    obj_t res1448_3460;
	    {
	       obj_t next_method2373_62_3470;
	       next_method2373_62_3470 = find_super_class_method_167___object((object_t) (obj1447_3457), object__struct_env_210___object, svar_cinfo_166_cfa_info);
	       if (PROCEDUREP(next_method2373_62_3470))
		 {
		    res1448_3460 = PROCEDURE_ENTRY(next_method2373_62_3470) (next_method2373_62_3470, (obj_t) (obj1447_3457), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2373_62_3470);
		    res1448_3460 = object__struct_50___object((object_t) (obj1447_3457));
		 }
	    }
	    {
	       obj_t aux1449_3461;
	       {
		  obj_t aux_7611;
		  aux_7611 = CNST_TABLE_REF(((long) 6));
		  aux1449_3461 = make_struct(aux_7611, ((long) 2), BUNSPEC);
	       }
	       {
		  obj_t aux_7614;
		  {
		     approx_t aux_7615;
		     {
			obj_t aux_7616;
			{
			   object_t aux_7617;
			   aux_7617 = (object_t) (obj1447_3457);
			   aux_7616 = OBJECT_WIDENING(aux_7617);
			}
			aux_7615 = (((svar_cinfo_166_t) CREF(aux_7616))->approx);
		     }
		     aux_7614 = (obj_t) (aux_7615);
		  }
		  STRUCT_SET(aux1449_3461, ((long) 0), aux_7614);
	       }
	       {
		  obj_t aux_7623;
		  {
		     bool_t aux_7624;
		     {
			obj_t aux_7625;
			{
			   object_t aux_7626;
			   aux_7626 = (object_t) (obj1447_3457);
			   aux_7625 = OBJECT_WIDENING(aux_7626);
			}
			aux_7624 = (((svar_cinfo_166_t) CREF(aux_7625))->clo_env__87);
		     }
		     aux_7623 = BBOOL(aux_7624);
		  }
		  STRUCT_SET(aux1449_3461, ((long) 1), aux_7623);
	       }
	       STRUCT_SET(res1448_3460, ((long) 0), aux1449_3461);
	       {
		  obj_t aux_7633;
		  aux_7633 = STRUCT_KEY(res1448_3460);
		  STRUCT_KEY_SET(aux1449_3461, aux_7633);
	       }
	       {
		  obj_t aux_7636;
		  aux_7636 = CNST_TABLE_REF(((long) 6));
		  STRUCT_KEY_SET(res1448_3460, aux_7636);
	       }
	       return res1448_3460;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_cvar_cinfo3560_206_cfa_info(obj_t env_6715, obj_t o_6716, obj_t s_6717)
{
   {
      cvar_cinfo_53_t o_3445;
      obj_t s_3446;
      {
	 cvar_cinfo_53_t aux_7640;
	 o_3445 = (cvar_cinfo_53_t) (o_6716);
	 s_3446 = s_6717;
	 {
	    {
	       obj_t old1462_3449;
	       obj_t aux1463_3450;
	       {
		  obj_t next_method2372_179_3455;
		  next_method2372_179_3455 = find_super_class_method_167___object((object_t) (o_3445), struct_object__object_env_209___object, cvar_cinfo_53_cfa_info);
		  if (PROCEDUREP(next_method2372_179_3455))
		    {
		       old1462_3449 = PROCEDURE_ENTRY(next_method2372_179_3455) (next_method2372_179_3455, (obj_t) (o_3445), s_3446, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2372_179_3455);
		       {
			  object_t aux_7649;
			  aux_7649 = struct_object__object_93___object((object_t) (o_3445), s_3446);
			  old1462_3449 = (obj_t) (aux_7649);
		       }
		    }
	       }
	       aux1463_3450 = STRUCT_REF(s_3446, ((long) 0));
	       {
		  cvar_cinfo_53_t new1464_3451;
		  new1464_3451 = ((cvar_cinfo_53_t) (old1462_3449));
		  {
		     long arg3179_3452;
		     arg3179_3452 = class_num_218___object(cvar_cinfo_53_cfa_info);
		     {
			obj_t obj_5899;
			obj_5899 = (obj_t) (new1464_3451);
			(((obj_t) CREF(obj_5899))->header = MAKE_HEADER(arg3179_3452, 0), BUNSPEC);
		     }
		  }
		  {
		     cvar_cinfo_53_t arg3180_3453;
		     {
			cvar_cinfo_53_t res3536_5906;
			{
			   approx_t approx_5903;
			   {
			      obj_t aux_7658;
			      aux_7658 = STRUCT_REF(aux1463_3450, ((long) 0));
			      approx_5903 = (approx_t) (aux_7658);
			   }
			   {
			      cvar_cinfo_53_t new1454_5904;
			      new1454_5904 = ((cvar_cinfo_53_t) BREF(GC_MALLOC(sizeof(struct cvar_cinfo_53))));
			      ((((cvar_cinfo_53_t) CREF(new1454_5904))->approx) = ((approx_t) approx_5903), BUNSPEC);
			      res3536_5906 = new1454_5904;
			   }
			}
			arg3180_3453 = res3536_5906;
		     }
		     {
			obj_t aux_7665;
			object_t aux_7663;
			aux_7665 = (obj_t) (arg3180_3453);
			aux_7663 = (object_t) (new1464_3451);
			OBJECT_WIDENING_SET(aux_7663, aux_7665);
		     }
		  }
		  aux_7640 = new1464_3451;
	       }
	    }
	 }
	 return (obj_t) (aux_7640);
      }
   }
}


obj_t 
object__struct_cvar_cinfo3561_65_cfa_info(obj_t env_6718, obj_t obj1459_6719)
{
   {
      cvar_cinfo_53_t obj1459_3432;
      obj1459_3432 = (cvar_cinfo_53_t) (obj1459_6719);
      {
	 {
	    obj_t res1460_3435;
	    {
	       obj_t next_method2371_246_3443;
	       next_method2371_246_3443 = find_super_class_method_167___object((object_t) (obj1459_3432), object__struct_env_210___object, cvar_cinfo_53_cfa_info);
	       if (PROCEDUREP(next_method2371_246_3443))
		 {
		    res1460_3435 = PROCEDURE_ENTRY(next_method2371_246_3443) (next_method2371_246_3443, (obj_t) (obj1459_3432), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2371_246_3443);
		    res1460_3435 = object__struct_50___object((object_t) (obj1459_3432));
		 }
	    }
	    {
	       obj_t aux1461_3436;
	       {
		  obj_t aux_7680;
		  aux_7680 = CNST_TABLE_REF(((long) 7));
		  aux1461_3436 = make_struct(aux_7680, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_7683;
		  {
		     approx_t aux_7684;
		     {
			obj_t aux_7685;
			{
			   object_t aux_7686;
			   aux_7686 = (object_t) (obj1459_3432);
			   aux_7685 = OBJECT_WIDENING(aux_7686);
			}
			aux_7684 = (((cvar_cinfo_53_t) CREF(aux_7685))->approx);
		     }
		     aux_7683 = (obj_t) (aux_7684);
		  }
		  STRUCT_SET(aux1461_3436, ((long) 0), aux_7683);
	       }
	       STRUCT_SET(res1460_3435, ((long) 0), aux1461_3436);
	       {
		  obj_t aux_7693;
		  aux_7693 = STRUCT_KEY(res1460_3435);
		  STRUCT_KEY_SET(aux1461_3436, aux_7693);
	       }
	       {
		  obj_t aux_7696;
		  aux_7696 = CNST_TABLE_REF(((long) 7));
		  STRUCT_KEY_SET(res1460_3435, aux_7696);
	       }
	       return res1460_3435;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_sexit_cinfo3562_95_cfa_info(obj_t env_6720, obj_t o_6721, obj_t s_6722)
{
   {
      sexit_cinfo_49_t o_3420;
      obj_t s_3421;
      {
	 sexit_cinfo_49_t aux_7700;
	 o_3420 = (sexit_cinfo_49_t) (o_6721);
	 s_3421 = s_6722;
	 {
	    {
	       obj_t old1476_3424;
	       obj_t aux1477_3425;
	       {
		  obj_t next_method2370_114_3430;
		  next_method2370_114_3430 = find_super_class_method_167___object((object_t) (o_3420), struct_object__object_env_209___object, sexit_cinfo_49_cfa_info);
		  if (PROCEDUREP(next_method2370_114_3430))
		    {
		       old1476_3424 = PROCEDURE_ENTRY(next_method2370_114_3430) (next_method2370_114_3430, (obj_t) (o_3420), s_3421, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2370_114_3430);
		       {
			  object_t aux_7709;
			  aux_7709 = struct_object__object_93___object((object_t) (o_3420), s_3421);
			  old1476_3424 = (obj_t) (aux_7709);
		       }
		    }
	       }
	       aux1477_3425 = STRUCT_REF(s_3421, ((long) 0));
	       {
		  sexit_cinfo_49_t new1478_3426;
		  new1478_3426 = ((sexit_cinfo_49_t) (old1476_3424));
		  {
		     long arg3168_3427;
		     arg3168_3427 = class_num_218___object(sexit_cinfo_49_cfa_info);
		     {
			obj_t obj_5870;
			obj_5870 = (obj_t) (new1478_3426);
			(((obj_t) CREF(obj_5870))->header = MAKE_HEADER(arg3168_3427, 0), BUNSPEC);
		     }
		  }
		  {
		     sexit_cinfo_49_t arg3169_3428;
		     {
			sexit_cinfo_49_t res3535_5877;
			{
			   approx_t approx_5874;
			   {
			      obj_t aux_7718;
			      aux_7718 = STRUCT_REF(aux1477_3425, ((long) 0));
			      approx_5874 = (approx_t) (aux_7718);
			   }
			   {
			      sexit_cinfo_49_t new1466_5875;
			      new1466_5875 = ((sexit_cinfo_49_t) BREF(GC_MALLOC(sizeof(struct sexit_cinfo_49))));
			      ((((sexit_cinfo_49_t) CREF(new1466_5875))->approx) = ((approx_t) approx_5874), BUNSPEC);
			      res3535_5877 = new1466_5875;
			   }
			}
			arg3169_3428 = res3535_5877;
		     }
		     {
			obj_t aux_7725;
			object_t aux_7723;
			aux_7725 = (obj_t) (arg3169_3428);
			aux_7723 = (object_t) (new1478_3426);
			OBJECT_WIDENING_SET(aux_7723, aux_7725);
		     }
		  }
		  aux_7700 = new1478_3426;
	       }
	    }
	 }
	 return (obj_t) (aux_7700);
      }
   }
}


obj_t 
object__struct_sexit_cinfo3563_64_cfa_info(obj_t env_6723, obj_t obj1473_6724)
{
   {
      sexit_cinfo_49_t obj1473_3407;
      obj1473_3407 = (sexit_cinfo_49_t) (obj1473_6724);
      {
	 {
	    obj_t res1474_3410;
	    {
	       obj_t next_method2369_8_3418;
	       next_method2369_8_3418 = find_super_class_method_167___object((object_t) (obj1473_3407), object__struct_env_210___object, sexit_cinfo_49_cfa_info);
	       if (PROCEDUREP(next_method2369_8_3418))
		 {
		    res1474_3410 = PROCEDURE_ENTRY(next_method2369_8_3418) (next_method2369_8_3418, (obj_t) (obj1473_3407), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2369_8_3418);
		    res1474_3410 = object__struct_50___object((object_t) (obj1473_3407));
		 }
	    }
	    {
	       obj_t aux1475_3411;
	       {
		  obj_t aux_7740;
		  aux_7740 = CNST_TABLE_REF(((long) 8));
		  aux1475_3411 = make_struct(aux_7740, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_7743;
		  {
		     approx_t aux_7744;
		     {
			obj_t aux_7745;
			{
			   object_t aux_7746;
			   aux_7746 = (object_t) (obj1473_3407);
			   aux_7745 = OBJECT_WIDENING(aux_7746);
			}
			aux_7744 = (((sexit_cinfo_49_t) CREF(aux_7745))->approx);
		     }
		     aux_7743 = (obj_t) (aux_7744);
		  }
		  STRUCT_SET(aux1475_3411, ((long) 0), aux_7743);
	       }
	       STRUCT_SET(res1474_3410, ((long) 0), aux1475_3411);
	       {
		  obj_t aux_7753;
		  aux_7753 = STRUCT_KEY(res1474_3410);
		  STRUCT_KEY_SET(aux1475_3411, aux_7753);
	       }
	       {
		  obj_t aux_7756;
		  aux_7756 = CNST_TABLE_REF(((long) 8));
		  STRUCT_KEY_SET(res1474_3410, aux_7756);
	       }
	       return res1474_3410;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_reshaped_local3564_28_cfa_info(obj_t env_6725, obj_t o_6726, obj_t s_6727)
{
   {
      reshaped_local_224_t o_3395;
      obj_t s_3396;
      {
	 reshaped_local_224_t aux_7760;
	 o_3395 = (reshaped_local_224_t) (o_6726);
	 s_3396 = s_6727;
	 {
	    {
	       obj_t old1495_3399;
	       obj_t aux1496_3400;
	       {
		  obj_t next_method2368_189_3405;
		  next_method2368_189_3405 = find_super_class_method_167___object((object_t) (o_3395), struct_object__object_env_209___object, reshaped_local_224_cfa_info);
		  if (PROCEDUREP(next_method2368_189_3405))
		    {
		       old1495_3399 = PROCEDURE_ENTRY(next_method2368_189_3405) (next_method2368_189_3405, (obj_t) (o_3395), s_3396, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2368_189_3405);
		       {
			  object_t aux_7769;
			  aux_7769 = struct_object__object_93___object((object_t) (o_3395), s_3396);
			  old1495_3399 = (obj_t) (aux_7769);
		       }
		    }
	       }
	       aux1496_3400 = STRUCT_REF(s_3396, ((long) 0));
	       {
		  reshaped_local_224_t new1497_3401;
		  new1497_3401 = ((reshaped_local_224_t) (old1495_3399));
		  {
		     long arg3157_3402;
		     arg3157_3402 = class_num_218___object(reshaped_local_224_cfa_info);
		     {
			obj_t obj_5841;
			obj_5841 = (obj_t) (new1497_3401);
			(((obj_t) CREF(obj_5841))->header = MAKE_HEADER(arg3157_3402, 0), BUNSPEC);
		     }
		  }
		  {
		     reshaped_local_224_t arg3158_3403;
		     {
			obj_t arg3159_3404;
			arg3159_3404 = STRUCT_REF(aux1496_3400, ((long) 0));
			{
			   reshaped_local_224_t res3534_5848;
			   {
			      reshaped_local_224_t new1480_5846;
			      new1480_5846 = ((reshaped_local_224_t) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
			      ((((reshaped_local_224_t) CREF(new1480_5846))->binding_value_3) = ((obj_t) arg3159_3404), BUNSPEC);
			      res3534_5848 = new1480_5846;
			   }
			   arg3158_3403 = res3534_5848;
			}
		     }
		     {
			obj_t aux_7783;
			object_t aux_7781;
			aux_7783 = (obj_t) (arg3158_3403);
			aux_7781 = (object_t) (new1497_3401);
			OBJECT_WIDENING_SET(aux_7781, aux_7783);
		     }
		  }
		  aux_7760 = new1497_3401;
	       }
	    }
	 }
	 return (obj_t) (aux_7760);
      }
   }
}


obj_t 
object__struct_reshaped_local3565_92_cfa_info(obj_t env_6728, obj_t obj1492_6729)
{
   {
      reshaped_local_224_t obj1492_3382;
      obj1492_3382 = (reshaped_local_224_t) (obj1492_6729);
      {
	 {
	    obj_t res1493_3385;
	    {
	       obj_t next_method2367_166_3393;
	       next_method2367_166_3393 = find_super_class_method_167___object((object_t) (obj1492_3382), object__struct_env_210___object, reshaped_local_224_cfa_info);
	       if (PROCEDUREP(next_method2367_166_3393))
		 {
		    res1493_3385 = PROCEDURE_ENTRY(next_method2367_166_3393) (next_method2367_166_3393, (obj_t) (obj1492_3382), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2367_166_3393);
		    res1493_3385 = object__struct_50___object((object_t) (obj1492_3382));
		 }
	    }
	    {
	       obj_t aux1494_3386;
	       {
		  obj_t aux_7798;
		  aux_7798 = CNST_TABLE_REF(((long) 9));
		  aux1494_3386 = make_struct(aux_7798, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_7801;
		  {
		     obj_t aux_7802;
		     {
			object_t aux_7803;
			aux_7803 = (object_t) (obj1492_3382);
			aux_7802 = OBJECT_WIDENING(aux_7803);
		     }
		     aux_7801 = (((reshaped_local_224_t) CREF(aux_7802))->binding_value_3);
		  }
		  STRUCT_SET(aux1494_3386, ((long) 0), aux_7801);
	       }
	       STRUCT_SET(res1493_3385, ((long) 0), aux1494_3386);
	       {
		  obj_t aux_7809;
		  aux_7809 = STRUCT_KEY(res1493_3385);
		  STRUCT_KEY_SET(aux1494_3386, aux_7809);
	       }
	       {
		  obj_t aux_7812;
		  aux_7812 = CNST_TABLE_REF(((long) 9));
		  STRUCT_KEY_SET(res1493_3385, aux_7812);
	       }
	       return res1493_3385;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_reshaped_global3566_204_cfa_info(obj_t env_6730, obj_t o_6731, obj_t s_6732)
{
   {
      reshaped_global_160_t o_3371;
      obj_t s_3372;
      {
	 reshaped_global_160_t aux_7816;
	 o_3371 = (reshaped_global_160_t) (o_6731);
	 s_3372 = s_6732;
	 {
	    {
	       obj_t old1518_3375;
	       {
		  obj_t next_method2366_80_3380;
		  next_method2366_80_3380 = find_super_class_method_167___object((object_t) (o_3371), struct_object__object_env_209___object, reshaped_global_160_cfa_info);
		  if (PROCEDUREP(next_method2366_80_3380))
		    {
		       old1518_3375 = PROCEDURE_ENTRY(next_method2366_80_3380) (next_method2366_80_3380, (obj_t) (o_3371), s_3372, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2366_80_3380);
		       {
			  object_t aux_7825;
			  aux_7825 = struct_object__object_93___object((object_t) (o_3371), s_3372);
			  old1518_3375 = (obj_t) (aux_7825);
		       }
		    }
	       }
	       {
		  reshaped_global_160_t new1520_3377;
		  new1520_3377 = ((reshaped_global_160_t) (old1518_3375));
		  {
		     long arg3147_3378;
		     arg3147_3378 = class_num_218___object(reshaped_global_160_cfa_info);
		     {
			obj_t obj_5816;
			obj_5816 = (obj_t) (new1520_3377);
			(((obj_t) CREF(obj_5816))->header = MAKE_HEADER(arg3147_3378, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_7835;
		     object_t aux_7833;
		     {
			reshaped_global_160_t aux_7836;
			{
			   aux_7836 = ((reshaped_global_160_t) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
			}
			aux_7835 = (obj_t) (aux_7836);
		     }
		     aux_7833 = (object_t) (new1520_3377);
		     OBJECT_WIDENING_SET(aux_7833, aux_7835);
		  }
		  aux_7816 = new1520_3377;
	       }
	    }
	 }
	 return (obj_t) (aux_7816);
      }
   }
}


obj_t 
object__struct_reshaped_global3567_93_cfa_info(obj_t env_6733, obj_t obj1515_6734)
{
   {
      reshaped_global_160_t obj1515_3360;
      obj1515_3360 = (reshaped_global_160_t) (obj1515_6734);
      {
	 {
	    obj_t res1516_3363;
	    {
	       obj_t next_method2365_50_3369;
	       next_method2365_50_3369 = find_super_class_method_167___object((object_t) (obj1515_3360), object__struct_env_210___object, reshaped_global_160_cfa_info);
	       if (PROCEDUREP(next_method2365_50_3369))
		 {
		    res1516_3363 = PROCEDURE_ENTRY(next_method2365_50_3369) (next_method2365_50_3369, (obj_t) (obj1515_3360), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2365_50_3369);
		    res1516_3363 = object__struct_50___object((object_t) (obj1515_3360));
		 }
	    }
	    {
	       obj_t aux1517_3364;
	       {
		  obj_t aux_7852;
		  aux_7852 = CNST_TABLE_REF(((long) 10));
		  aux1517_3364 = make_struct(aux_7852, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res1516_3363, ((long) 0), aux1517_3364);
	       {
		  obj_t aux_7856;
		  aux_7856 = STRUCT_KEY(res1516_3363);
		  STRUCT_KEY_SET(aux1517_3364, aux_7856);
	       }
	       {
		  obj_t aux_7859;
		  aux_7859 = CNST_TABLE_REF(((long) 10));
		  STRUCT_KEY_SET(res1516_3363, aux_7859);
	       }
	       return res1516_3363;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_atom_cinfo3568_174_cfa_info(obj_t env_6735, obj_t o_6736, obj_t s_6737)
{
   {
      atom_cinfo_155_t o_3348;
      obj_t s_3349;
      {
	 atom_cinfo_155_t aux_7863;
	 o_3348 = (atom_cinfo_155_t) (o_6736);
	 s_3349 = s_6737;
	 {
	    {
	       obj_t old1534_3352;
	       obj_t aux1535_3353;
	       {
		  obj_t next_method2364_34_3358;
		  next_method2364_34_3358 = find_super_class_method_167___object((object_t) (o_3348), struct_object__object_env_209___object, atom_cinfo_155_cfa_info);
		  if (PROCEDUREP(next_method2364_34_3358))
		    {
		       old1534_3352 = PROCEDURE_ENTRY(next_method2364_34_3358) (next_method2364_34_3358, (obj_t) (o_3348), s_3349, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2364_34_3358);
		       {
			  object_t aux_7872;
			  aux_7872 = struct_object__object_93___object((object_t) (o_3348), s_3349);
			  old1534_3352 = (obj_t) (aux_7872);
		       }
		    }
	       }
	       aux1535_3353 = STRUCT_REF(s_3349, ((long) 0));
	       {
		  atom_cinfo_155_t new1536_3354;
		  new1536_3354 = ((atom_cinfo_155_t) (old1534_3352));
		  {
		     long arg3138_3355;
		     arg3138_3355 = class_num_218___object(atom_cinfo_155_cfa_info);
		     {
			obj_t obj_5791;
			obj_5791 = (obj_t) (new1536_3354);
			(((obj_t) CREF(obj_5791))->header = MAKE_HEADER(arg3138_3355, 0), BUNSPEC);
		     }
		  }
		  {
		     atom_cinfo_155_t arg3139_3356;
		     {
			atom_cinfo_155_t res3532_5798;
			{
			   approx_t approx_5795;
			   {
			      obj_t aux_7881;
			      aux_7881 = STRUCT_REF(aux1535_3353, ((long) 0));
			      approx_5795 = (approx_t) (aux_7881);
			   }
			   {
			      atom_cinfo_155_t new1524_5796;
			      new1524_5796 = ((atom_cinfo_155_t) BREF(GC_MALLOC(sizeof(struct atom_cinfo_155))));
			      ((((atom_cinfo_155_t) CREF(new1524_5796))->approx) = ((approx_t) approx_5795), BUNSPEC);
			      res3532_5798 = new1524_5796;
			   }
			}
			arg3139_3356 = res3532_5798;
		     }
		     {
			obj_t aux_7888;
			object_t aux_7886;
			aux_7888 = (obj_t) (arg3139_3356);
			aux_7886 = (object_t) (new1536_3354);
			OBJECT_WIDENING_SET(aux_7886, aux_7888);
		     }
		  }
		  aux_7863 = new1536_3354;
	       }
	    }
	 }
	 return (obj_t) (aux_7863);
      }
   }
}


obj_t 
object__struct_atom_cinfo3569_29_cfa_info(obj_t env_6738, obj_t obj1531_6739)
{
   {
      atom_cinfo_155_t obj1531_3335;
      obj1531_3335 = (atom_cinfo_155_t) (obj1531_6739);
      {
	 {
	    obj_t res1532_3338;
	    {
	       obj_t next_method2363_175_3346;
	       next_method2363_175_3346 = find_super_class_method_167___object((object_t) (obj1531_3335), object__struct_env_210___object, atom_cinfo_155_cfa_info);
	       if (PROCEDUREP(next_method2363_175_3346))
		 {
		    res1532_3338 = PROCEDURE_ENTRY(next_method2363_175_3346) (next_method2363_175_3346, (obj_t) (obj1531_3335), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2363_175_3346);
		    res1532_3338 = object__struct_50___object((object_t) (obj1531_3335));
		 }
	    }
	    {
	       obj_t aux1533_3339;
	       {
		  obj_t aux_7903;
		  aux_7903 = CNST_TABLE_REF(((long) 11));
		  aux1533_3339 = make_struct(aux_7903, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_7906;
		  {
		     approx_t aux_7907;
		     {
			obj_t aux_7908;
			{
			   object_t aux_7909;
			   aux_7909 = (object_t) (obj1531_3335);
			   aux_7908 = OBJECT_WIDENING(aux_7909);
			}
			aux_7907 = (((atom_cinfo_155_t) CREF(aux_7908))->approx);
		     }
		     aux_7906 = (obj_t) (aux_7907);
		  }
		  STRUCT_SET(aux1533_3339, ((long) 0), aux_7906);
	       }
	       STRUCT_SET(res1532_3338, ((long) 0), aux1533_3339);
	       {
		  obj_t aux_7916;
		  aux_7916 = STRUCT_KEY(res1532_3338);
		  STRUCT_KEY_SET(aux1533_3339, aux_7916);
	       }
	       {
		  obj_t aux_7919;
		  aux_7919 = CNST_TABLE_REF(((long) 11));
		  STRUCT_KEY_SET(res1532_3338, aux_7919);
	       }
	       return res1532_3338;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_kwote_node3570_241_cfa_info(obj_t env_6740, obj_t o_6741, obj_t s_6742)
{
   {
      kwote_node_102_t o_3323;
      obj_t s_3324;
      {
	 kwote_node_102_t aux_7923;
	 o_3323 = (kwote_node_102_t) (o_6741);
	 s_3324 = s_6742;
	 {
	    {
	       obj_t old1547_3327;
	       obj_t aux1548_3328;
	       {
		  obj_t next_method2358_2_3333;
		  next_method2358_2_3333 = find_super_class_method_167___object((object_t) (o_3323), struct_object__object_env_209___object, kwote_node_102_cfa_info);
		  if (PROCEDUREP(next_method2358_2_3333))
		    {
		       old1547_3327 = PROCEDURE_ENTRY(next_method2358_2_3333) (next_method2358_2_3333, (obj_t) (o_3323), s_3324, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2358_2_3333);
		       {
			  object_t aux_7932;
			  aux_7932 = struct_object__object_93___object((object_t) (o_3323), s_3324);
			  old1547_3327 = (obj_t) (aux_7932);
		       }
		    }
	       }
	       aux1548_3328 = STRUCT_REF(s_3324, ((long) 0));
	       {
		  kwote_node_102_t new1549_3329;
		  new1549_3329 = ((kwote_node_102_t) (old1547_3327));
		  {
		     long arg3127_3330;
		     arg3127_3330 = class_num_218___object(kwote_node_102_cfa_info);
		     {
			obj_t obj_5762;
			obj_5762 = (obj_t) (new1549_3329);
			(((obj_t) CREF(obj_5762))->header = MAKE_HEADER(arg3127_3330, 0), BUNSPEC);
		     }
		  }
		  {
		     kwote_node_102_t arg3128_3331;
		     {
			kwote_node_102_t res3531_5769;
			{
			   node_t node_5766;
			   {
			      obj_t aux_7941;
			      aux_7941 = STRUCT_REF(aux1548_3328, ((long) 0));
			      node_5766 = (node_t) (aux_7941);
			   }
			   {
			      kwote_node_102_t new1538_5767;
			      new1538_5767 = ((kwote_node_102_t) BREF(GC_MALLOC(sizeof(struct kwote_node_102))));
			      ((((kwote_node_102_t) CREF(new1538_5767))->node) = ((node_t) node_5766), BUNSPEC);
			      res3531_5769 = new1538_5767;
			   }
			}
			arg3128_3331 = res3531_5769;
		     }
		     {
			obj_t aux_7948;
			object_t aux_7946;
			aux_7948 = (obj_t) (arg3128_3331);
			aux_7946 = (object_t) (new1549_3329);
			OBJECT_WIDENING_SET(aux_7946, aux_7948);
		     }
		  }
		  aux_7923 = new1549_3329;
	       }
	    }
	 }
	 return (obj_t) (aux_7923);
      }
   }
}


obj_t 
object__struct_kwote_node3571_68_cfa_info(obj_t env_6743, obj_t obj1544_6744)
{
   {
      kwote_node_102_t obj1544_3310;
      obj1544_3310 = (kwote_node_102_t) (obj1544_6744);
      {
	 {
	    obj_t res1545_3313;
	    {
	       obj_t next_method2356_211_3321;
	       next_method2356_211_3321 = find_super_class_method_167___object((object_t) (obj1544_3310), object__struct_env_210___object, kwote_node_102_cfa_info);
	       if (PROCEDUREP(next_method2356_211_3321))
		 {
		    res1545_3313 = PROCEDURE_ENTRY(next_method2356_211_3321) (next_method2356_211_3321, (obj_t) (obj1544_3310), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2356_211_3321);
		    res1545_3313 = object__struct_50___object((object_t) (obj1544_3310));
		 }
	    }
	    {
	       obj_t aux1546_3314;
	       {
		  obj_t aux_7963;
		  aux_7963 = CNST_TABLE_REF(((long) 12));
		  aux1546_3314 = make_struct(aux_7963, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_7966;
		  {
		     node_t aux_7967;
		     {
			obj_t aux_7968;
			{
			   object_t aux_7969;
			   aux_7969 = (object_t) (obj1544_3310);
			   aux_7968 = OBJECT_WIDENING(aux_7969);
			}
			aux_7967 = (((kwote_node_102_t) CREF(aux_7968))->node);
		     }
		     aux_7966 = (obj_t) (aux_7967);
		  }
		  STRUCT_SET(aux1546_3314, ((long) 0), aux_7966);
	       }
	       STRUCT_SET(res1545_3313, ((long) 0), aux1546_3314);
	       {
		  obj_t aux_7976;
		  aux_7976 = STRUCT_KEY(res1545_3313);
		  STRUCT_KEY_SET(aux1546_3314, aux_7976);
	       }
	       {
		  obj_t aux_7979;
		  aux_7979 = CNST_TABLE_REF(((long) 12));
		  STRUCT_KEY_SET(res1545_3313, aux_7979);
	       }
	       return res1545_3313;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_kwote_cinfo3572_67_cfa_info(obj_t env_6745, obj_t o_6746, obj_t s_6747)
{
   {
      kwote_cinfo_48_t o_3298;
      obj_t s_3299;
      {
	 kwote_cinfo_48_t aux_7983;
	 o_3298 = (kwote_cinfo_48_t) (o_6746);
	 s_3299 = s_6747;
	 {
	    {
	       obj_t old1560_3302;
	       obj_t aux1561_3303;
	       {
		  obj_t next_method2354_223_3308;
		  next_method2354_223_3308 = find_super_class_method_167___object((object_t) (o_3298), struct_object__object_env_209___object, kwote_cinfo_48_cfa_info);
		  if (PROCEDUREP(next_method2354_223_3308))
		    {
		       old1560_3302 = PROCEDURE_ENTRY(next_method2354_223_3308) (next_method2354_223_3308, (obj_t) (o_3298), s_3299, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2354_223_3308);
		       {
			  object_t aux_7992;
			  aux_7992 = struct_object__object_93___object((object_t) (o_3298), s_3299);
			  old1560_3302 = (obj_t) (aux_7992);
		       }
		    }
	       }
	       aux1561_3303 = STRUCT_REF(s_3299, ((long) 0));
	       {
		  kwote_cinfo_48_t new1562_3304;
		  new1562_3304 = ((kwote_cinfo_48_t) (old1560_3302));
		  {
		     long arg3116_3305;
		     arg3116_3305 = class_num_218___object(kwote_cinfo_48_cfa_info);
		     {
			obj_t obj_5733;
			obj_5733 = (obj_t) (new1562_3304);
			(((obj_t) CREF(obj_5733))->header = MAKE_HEADER(arg3116_3305, 0), BUNSPEC);
		     }
		  }
		  {
		     kwote_cinfo_48_t arg3117_3306;
		     {
			kwote_cinfo_48_t res3530_5740;
			{
			   approx_t approx_5737;
			   {
			      obj_t aux_8001;
			      aux_8001 = STRUCT_REF(aux1561_3303, ((long) 0));
			      approx_5737 = (approx_t) (aux_8001);
			   }
			   {
			      kwote_cinfo_48_t new1551_5738;
			      new1551_5738 = ((kwote_cinfo_48_t) BREF(GC_MALLOC(sizeof(struct kwote_cinfo_48))));
			      ((((kwote_cinfo_48_t) CREF(new1551_5738))->approx) = ((approx_t) approx_5737), BUNSPEC);
			      res3530_5740 = new1551_5738;
			   }
			}
			arg3117_3306 = res3530_5740;
		     }
		     {
			obj_t aux_8008;
			object_t aux_8006;
			aux_8008 = (obj_t) (arg3117_3306);
			aux_8006 = (object_t) (new1562_3304);
			OBJECT_WIDENING_SET(aux_8006, aux_8008);
		     }
		  }
		  aux_7983 = new1562_3304;
	       }
	    }
	 }
	 return (obj_t) (aux_7983);
      }
   }
}


obj_t 
object__struct_kwote_cinfo3573_151_cfa_info(obj_t env_6748, obj_t obj1557_6749)
{
   {
      kwote_cinfo_48_t obj1557_3285;
      obj1557_3285 = (kwote_cinfo_48_t) (obj1557_6749);
      {
	 {
	    obj_t res1558_3288;
	    {
	       obj_t next_method2352_213_3296;
	       next_method2352_213_3296 = find_super_class_method_167___object((object_t) (obj1557_3285), object__struct_env_210___object, kwote_cinfo_48_cfa_info);
	       if (PROCEDUREP(next_method2352_213_3296))
		 {
		    res1558_3288 = PROCEDURE_ENTRY(next_method2352_213_3296) (next_method2352_213_3296, (obj_t) (obj1557_3285), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2352_213_3296);
		    res1558_3288 = object__struct_50___object((object_t) (obj1557_3285));
		 }
	    }
	    {
	       obj_t aux1559_3289;
	       {
		  obj_t aux_8023;
		  aux_8023 = CNST_TABLE_REF(((long) 13));
		  aux1559_3289 = make_struct(aux_8023, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_8026;
		  {
		     approx_t aux_8027;
		     {
			obj_t aux_8028;
			{
			   object_t aux_8029;
			   aux_8029 = (object_t) (obj1557_3285);
			   aux_8028 = OBJECT_WIDENING(aux_8029);
			}
			aux_8027 = (((kwote_cinfo_48_t) CREF(aux_8028))->approx);
		     }
		     aux_8026 = (obj_t) (aux_8027);
		  }
		  STRUCT_SET(aux1559_3289, ((long) 0), aux_8026);
	       }
	       STRUCT_SET(res1558_3288, ((long) 0), aux1559_3289);
	       {
		  obj_t aux_8036;
		  aux_8036 = STRUCT_KEY(res1558_3288);
		  STRUCT_KEY_SET(aux1559_3289, aux_8036);
	       }
	       {
		  obj_t aux_8039;
		  aux_8039 = CNST_TABLE_REF(((long) 13));
		  STRUCT_KEY_SET(res1558_3288, aux_8039);
	       }
	       return res1558_3288;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_app_ly_cinfo3574_49_cfa_info(obj_t env_6750, obj_t o_6751, obj_t s_6752)
{
   {
      app_ly_cinfo_234_t o_3273;
      obj_t s_3274;
      {
	 app_ly_cinfo_234_t aux_8043;
	 o_3273 = (app_ly_cinfo_234_t) (o_6751);
	 s_3274 = s_6752;
	 {
	    {
	       obj_t old1575_3277;
	       obj_t aux1576_3278;
	       {
		  obj_t next_method2350_190_3283;
		  next_method2350_190_3283 = find_super_class_method_167___object((object_t) (o_3273), struct_object__object_env_209___object, app_ly_cinfo_234_cfa_info);
		  if (PROCEDUREP(next_method2350_190_3283))
		    {
		       old1575_3277 = PROCEDURE_ENTRY(next_method2350_190_3283) (next_method2350_190_3283, (obj_t) (o_3273), s_3274, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2350_190_3283);
		       {
			  object_t aux_8052;
			  aux_8052 = struct_object__object_93___object((object_t) (o_3273), s_3274);
			  old1575_3277 = (obj_t) (aux_8052);
		       }
		    }
	       }
	       aux1576_3278 = STRUCT_REF(s_3274, ((long) 0));
	       {
		  app_ly_cinfo_234_t new1577_3279;
		  new1577_3279 = ((app_ly_cinfo_234_t) (old1575_3277));
		  {
		     long arg3105_3280;
		     arg3105_3280 = class_num_218___object(app_ly_cinfo_234_cfa_info);
		     {
			obj_t obj_5704;
			obj_5704 = (obj_t) (new1577_3279);
			(((obj_t) CREF(obj_5704))->header = MAKE_HEADER(arg3105_3280, 0), BUNSPEC);
		     }
		  }
		  {
		     app_ly_cinfo_234_t arg3106_3281;
		     {
			app_ly_cinfo_234_t res3529_5711;
			{
			   approx_t approx_5708;
			   {
			      obj_t aux_8061;
			      aux_8061 = STRUCT_REF(aux1576_3278, ((long) 0));
			      approx_5708 = (approx_t) (aux_8061);
			   }
			   {
			      app_ly_cinfo_234_t new1564_5709;
			      new1564_5709 = ((app_ly_cinfo_234_t) BREF(GC_MALLOC(sizeof(struct app_ly_cinfo_234))));
			      ((((app_ly_cinfo_234_t) CREF(new1564_5709))->approx) = ((approx_t) approx_5708), BUNSPEC);
			      res3529_5711 = new1564_5709;
			   }
			}
			arg3106_3281 = res3529_5711;
		     }
		     {
			obj_t aux_8068;
			object_t aux_8066;
			aux_8068 = (obj_t) (arg3106_3281);
			aux_8066 = (object_t) (new1577_3279);
			OBJECT_WIDENING_SET(aux_8066, aux_8068);
		     }
		  }
		  aux_8043 = new1577_3279;
	       }
	    }
	 }
	 return (obj_t) (aux_8043);
      }
   }
}


obj_t 
object__struct_app_ly_cinfo3575_89_cfa_info(obj_t env_6753, obj_t obj1572_6754)
{
   {
      app_ly_cinfo_234_t obj1572_3260;
      obj1572_3260 = (app_ly_cinfo_234_t) (obj1572_6754);
      {
	 {
	    obj_t res1573_3263;
	    {
	       obj_t next_method2348_191_3271;
	       next_method2348_191_3271 = find_super_class_method_167___object((object_t) (obj1572_3260), object__struct_env_210___object, app_ly_cinfo_234_cfa_info);
	       if (PROCEDUREP(next_method2348_191_3271))
		 {
		    res1573_3263 = PROCEDURE_ENTRY(next_method2348_191_3271) (next_method2348_191_3271, (obj_t) (obj1572_3260), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2348_191_3271);
		    res1573_3263 = object__struct_50___object((object_t) (obj1572_3260));
		 }
	    }
	    {
	       obj_t aux1574_3264;
	       {
		  obj_t aux_8083;
		  aux_8083 = CNST_TABLE_REF(((long) 14));
		  aux1574_3264 = make_struct(aux_8083, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_8086;
		  {
		     approx_t aux_8087;
		     {
			obj_t aux_8088;
			{
			   object_t aux_8089;
			   aux_8089 = (object_t) (obj1572_3260);
			   aux_8088 = OBJECT_WIDENING(aux_8089);
			}
			aux_8087 = (((app_ly_cinfo_234_t) CREF(aux_8088))->approx);
		     }
		     aux_8086 = (obj_t) (aux_8087);
		  }
		  STRUCT_SET(aux1574_3264, ((long) 0), aux_8086);
	       }
	       STRUCT_SET(res1573_3263, ((long) 0), aux1574_3264);
	       {
		  obj_t aux_8096;
		  aux_8096 = STRUCT_KEY(res1573_3263);
		  STRUCT_KEY_SET(aux1574_3264, aux_8096);
	       }
	       {
		  obj_t aux_8099;
		  aux_8099 = CNST_TABLE_REF(((long) 14));
		  STRUCT_KEY_SET(res1573_3263, aux_8099);
	       }
	       return res1573_3263;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_funcall_cinfo3576_157_cfa_info(obj_t env_6755, obj_t o_6756, obj_t s_6757)
{
   {
      funcall_cinfo_75_t o_3245;
      obj_t s_3246;
      {
	 funcall_cinfo_75_t aux_8103;
	 o_3245 = (funcall_cinfo_75_t) (o_6756);
	 s_3246 = s_6757;
	 {
	    {
	       obj_t old1596_3249;
	       obj_t aux1597_3250;
	       {
		  obj_t next_method2346_242_3258;
		  next_method2346_242_3258 = find_super_class_method_167___object((object_t) (o_3245), struct_object__object_env_209___object, funcall_cinfo_75_cfa_info);
		  if (PROCEDUREP(next_method2346_242_3258))
		    {
		       old1596_3249 = PROCEDURE_ENTRY(next_method2346_242_3258) (next_method2346_242_3258, (obj_t) (o_3245), s_3246, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2346_242_3258);
		       {
			  object_t aux_8112;
			  aux_8112 = struct_object__object_93___object((object_t) (o_3245), s_3246);
			  old1596_3249 = (obj_t) (aux_8112);
		       }
		    }
	       }
	       aux1597_3250 = STRUCT_REF(s_3246, ((long) 0));
	       {
		  funcall_cinfo_75_t new1598_3251;
		  new1598_3251 = ((funcall_cinfo_75_t) (old1596_3249));
		  {
		     long arg3091_3252;
		     arg3091_3252 = class_num_218___object(funcall_cinfo_75_cfa_info);
		     {
			obj_t obj_5663;
			obj_5663 = (obj_t) (new1598_3251);
			(((obj_t) CREF(obj_5663))->header = MAKE_HEADER(arg3091_3252, 0), BUNSPEC);
		     }
		  }
		  {
		     funcall_cinfo_75_t arg3092_3253;
		     {
			funcall_cinfo_75_t res3528_5682;
			{
			   approx_t approx_5673;
			   approx_t va_approx_63_5674;
			   bool_t arity_error_noticed__118_5675;
			   bool_t type_error_noticed__36_5676;
			   {
			      obj_t aux_8121;
			      aux_8121 = STRUCT_REF(aux1597_3250, ((long) 0));
			      approx_5673 = (approx_t) (aux_8121);
			   }
			   {
			      obj_t aux_8124;
			      aux_8124 = STRUCT_REF(aux1597_3250, ((long) 1));
			      va_approx_63_5674 = (approx_t) (aux_8124);
			   }
			   {
			      obj_t aux_8127;
			      aux_8127 = STRUCT_REF(aux1597_3250, ((long) 2));
			      arity_error_noticed__118_5675 = CBOOL(aux_8127);
			   }
			   {
			      obj_t aux_8130;
			      aux_8130 = STRUCT_REF(aux1597_3250, ((long) 3));
			      type_error_noticed__36_5676 = CBOOL(aux_8130);
			   }
			   {
			      funcall_cinfo_75_t new1582_5677;
			      new1582_5677 = ((funcall_cinfo_75_t) BREF(GC_MALLOC(sizeof(struct funcall_cinfo_75))));
			      ((((funcall_cinfo_75_t) CREF(new1582_5677))->approx) = ((approx_t) approx_5673), BUNSPEC);
			      ((((funcall_cinfo_75_t) CREF(new1582_5677))->va_approx_63) = ((approx_t) va_approx_63_5674), BUNSPEC);
			      ((((funcall_cinfo_75_t) CREF(new1582_5677))->arity_error_noticed__118) = ((bool_t) arity_error_noticed__118_5675), BUNSPEC);
			      ((((funcall_cinfo_75_t) CREF(new1582_5677))->type_error_noticed__36) = ((bool_t) type_error_noticed__36_5676), BUNSPEC);
			      res3528_5682 = new1582_5677;
			   }
			}
			arg3092_3253 = res3528_5682;
		     }
		     {
			obj_t aux_8140;
			object_t aux_8138;
			aux_8140 = (obj_t) (arg3092_3253);
			aux_8138 = (object_t) (new1598_3251);
			OBJECT_WIDENING_SET(aux_8138, aux_8140);
		     }
		  }
		  aux_8103 = new1598_3251;
	       }
	    }
	 }
	 return (obj_t) (aux_8103);
      }
   }
}


obj_t 
object__struct_funcall_cinfo3577_159_cfa_info(obj_t env_6758, obj_t obj1593_6759)
{
   {
      funcall_cinfo_75_t obj1593_3226;
      obj1593_3226 = (funcall_cinfo_75_t) (obj1593_6759);
      {
	 {
	    obj_t res1594_3229;
	    {
	       obj_t next_method2344_239_3243;
	       next_method2344_239_3243 = find_super_class_method_167___object((object_t) (obj1593_3226), object__struct_env_210___object, funcall_cinfo_75_cfa_info);
	       if (PROCEDUREP(next_method2344_239_3243))
		 {
		    res1594_3229 = PROCEDURE_ENTRY(next_method2344_239_3243) (next_method2344_239_3243, (obj_t) (obj1593_3226), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2344_239_3243);
		    res1594_3229 = object__struct_50___object((object_t) (obj1593_3226));
		 }
	    }
	    {
	       obj_t aux1595_3230;
	       {
		  obj_t aux_8155;
		  aux_8155 = CNST_TABLE_REF(((long) 15));
		  aux1595_3230 = make_struct(aux_8155, ((long) 4), BUNSPEC);
	       }
	       {
		  obj_t aux_8158;
		  {
		     approx_t aux_8159;
		     {
			obj_t aux_8160;
			{
			   object_t aux_8161;
			   aux_8161 = (object_t) (obj1593_3226);
			   aux_8160 = OBJECT_WIDENING(aux_8161);
			}
			aux_8159 = (((funcall_cinfo_75_t) CREF(aux_8160))->approx);
		     }
		     aux_8158 = (obj_t) (aux_8159);
		  }
		  STRUCT_SET(aux1595_3230, ((long) 0), aux_8158);
	       }
	       {
		  obj_t aux_8167;
		  {
		     approx_t aux_8168;
		     {
			obj_t aux_8169;
			{
			   object_t aux_8170;
			   aux_8170 = (object_t) (obj1593_3226);
			   aux_8169 = OBJECT_WIDENING(aux_8170);
			}
			aux_8168 = (((funcall_cinfo_75_t) CREF(aux_8169))->va_approx_63);
		     }
		     aux_8167 = (obj_t) (aux_8168);
		  }
		  STRUCT_SET(aux1595_3230, ((long) 1), aux_8167);
	       }
	       {
		  obj_t aux_8176;
		  {
		     bool_t aux_8177;
		     {
			obj_t aux_8178;
			{
			   object_t aux_8179;
			   aux_8179 = (object_t) (obj1593_3226);
			   aux_8178 = OBJECT_WIDENING(aux_8179);
			}
			aux_8177 = (((funcall_cinfo_75_t) CREF(aux_8178))->arity_error_noticed__118);
		     }
		     aux_8176 = BBOOL(aux_8177);
		  }
		  STRUCT_SET(aux1595_3230, ((long) 2), aux_8176);
	       }
	       {
		  obj_t aux_8185;
		  {
		     bool_t aux_8186;
		     {
			obj_t aux_8187;
			{
			   object_t aux_8188;
			   aux_8188 = (object_t) (obj1593_3226);
			   aux_8187 = OBJECT_WIDENING(aux_8188);
			}
			aux_8186 = (((funcall_cinfo_75_t) CREF(aux_8187))->type_error_noticed__36);
		     }
		     aux_8185 = BBOOL(aux_8186);
		  }
		  STRUCT_SET(aux1595_3230, ((long) 3), aux_8185);
	       }
	       STRUCT_SET(res1594_3229, ((long) 0), aux1595_3230);
	       {
		  obj_t aux_8195;
		  aux_8195 = STRUCT_KEY(res1594_3229);
		  STRUCT_KEY_SET(aux1595_3230, aux_8195);
	       }
	       {
		  obj_t aux_8198;
		  aux_8198 = CNST_TABLE_REF(((long) 15));
		  STRUCT_KEY_SET(res1594_3229, aux_8198);
	       }
	       return res1594_3229;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_pragma_cinfo3578_186_cfa_info(obj_t env_6760, obj_t o_6761, obj_t s_6762)
{
   {
      pragma_cinfo_220_t o_3214;
      obj_t s_3215;
      {
	 pragma_cinfo_220_t aux_8202;
	 o_3214 = (pragma_cinfo_220_t) (o_6761);
	 s_3215 = s_6762;
	 {
	    {
	       obj_t old1611_3218;
	       obj_t aux1612_3219;
	       {
		  obj_t next_method2342_11_3224;
		  next_method2342_11_3224 = find_super_class_method_167___object((object_t) (o_3214), struct_object__object_env_209___object, pragma_cinfo_220_cfa_info);
		  if (PROCEDUREP(next_method2342_11_3224))
		    {
		       old1611_3218 = PROCEDURE_ENTRY(next_method2342_11_3224) (next_method2342_11_3224, (obj_t) (o_3214), s_3215, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2342_11_3224);
		       {
			  object_t aux_8211;
			  aux_8211 = struct_object__object_93___object((object_t) (o_3214), s_3215);
			  old1611_3218 = (obj_t) (aux_8211);
		       }
		    }
	       }
	       aux1612_3219 = STRUCT_REF(s_3215, ((long) 0));
	       {
		  pragma_cinfo_220_t new1613_3220;
		  new1613_3220 = ((pragma_cinfo_220_t) (old1611_3218));
		  {
		     long arg3074_3221;
		     arg3074_3221 = class_num_218___object(pragma_cinfo_220_cfa_info);
		     {
			obj_t obj_5622;
			obj_5622 = (obj_t) (new1613_3220);
			(((obj_t) CREF(obj_5622))->header = MAKE_HEADER(arg3074_3221, 0), BUNSPEC);
		     }
		  }
		  {
		     pragma_cinfo_220_t arg3075_3222;
		     {
			pragma_cinfo_220_t res3527_5629;
			{
			   approx_t approx_5626;
			   {
			      obj_t aux_8220;
			      aux_8220 = STRUCT_REF(aux1612_3219, ((long) 0));
			      approx_5626 = (approx_t) (aux_8220);
			   }
			   {
			      pragma_cinfo_220_t new1600_5627;
			      new1600_5627 = ((pragma_cinfo_220_t) BREF(GC_MALLOC(sizeof(struct pragma_cinfo_220))));
			      ((((pragma_cinfo_220_t) CREF(new1600_5627))->approx) = ((approx_t) approx_5626), BUNSPEC);
			      res3527_5629 = new1600_5627;
			   }
			}
			arg3075_3222 = res3527_5629;
		     }
		     {
			obj_t aux_8227;
			object_t aux_8225;
			aux_8227 = (obj_t) (arg3075_3222);
			aux_8225 = (object_t) (new1613_3220);
			OBJECT_WIDENING_SET(aux_8225, aux_8227);
		     }
		  }
		  aux_8202 = new1613_3220;
	       }
	    }
	 }
	 return (obj_t) (aux_8202);
      }
   }
}


obj_t 
object__struct_pragma_cinfo3579_224_cfa_info(obj_t env_6763, obj_t obj1608_6764)
{
   {
      pragma_cinfo_220_t obj1608_3201;
      obj1608_3201 = (pragma_cinfo_220_t) (obj1608_6764);
      {
	 {
	    obj_t res1609_3204;
	    {
	       obj_t next_method2340_171_3212;
	       next_method2340_171_3212 = find_super_class_method_167___object((object_t) (obj1608_3201), object__struct_env_210___object, pragma_cinfo_220_cfa_info);
	       if (PROCEDUREP(next_method2340_171_3212))
		 {
		    res1609_3204 = PROCEDURE_ENTRY(next_method2340_171_3212) (next_method2340_171_3212, (obj_t) (obj1608_3201), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2340_171_3212);
		    res1609_3204 = object__struct_50___object((object_t) (obj1608_3201));
		 }
	    }
	    {
	       obj_t aux1610_3205;
	       {
		  obj_t aux_8242;
		  aux_8242 = CNST_TABLE_REF(((long) 16));
		  aux1610_3205 = make_struct(aux_8242, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_8245;
		  {
		     approx_t aux_8246;
		     {
			obj_t aux_8247;
			{
			   object_t aux_8248;
			   aux_8248 = (object_t) (obj1608_3201);
			   aux_8247 = OBJECT_WIDENING(aux_8248);
			}
			aux_8246 = (((pragma_cinfo_220_t) CREF(aux_8247))->approx);
		     }
		     aux_8245 = (obj_t) (aux_8246);
		  }
		  STRUCT_SET(aux1610_3205, ((long) 0), aux_8245);
	       }
	       STRUCT_SET(res1609_3204, ((long) 0), aux1610_3205);
	       {
		  obj_t aux_8255;
		  aux_8255 = STRUCT_KEY(res1609_3204);
		  STRUCT_KEY_SET(aux1610_3205, aux_8255);
	       }
	       {
		  obj_t aux_8258;
		  aux_8258 = CNST_TABLE_REF(((long) 16));
		  STRUCT_KEY_SET(res1609_3204, aux_8258);
	       }
	       return res1609_3204;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_setq_cinfo3580_159_cfa_info(obj_t env_6765, obj_t o_6766, obj_t s_6767)
{
   {
      setq_cinfo_191_t o_3189;
      obj_t s_3190;
      {
	 setq_cinfo_191_t aux_8262;
	 o_3189 = (setq_cinfo_191_t) (o_6766);
	 s_3190 = s_6767;
	 {
	    {
	       obj_t old1628_3193;
	       obj_t aux1629_3194;
	       {
		  obj_t next_method2338_38_3199;
		  next_method2338_38_3199 = find_super_class_method_167___object((object_t) (o_3189), struct_object__object_env_209___object, setq_cinfo_191_cfa_info);
		  if (PROCEDUREP(next_method2338_38_3199))
		    {
		       old1628_3193 = PROCEDURE_ENTRY(next_method2338_38_3199) (next_method2338_38_3199, (obj_t) (o_3189), s_3190, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2338_38_3199);
		       {
			  object_t aux_8271;
			  aux_8271 = struct_object__object_93___object((object_t) (o_3189), s_3190);
			  old1628_3193 = (obj_t) (aux_8271);
		       }
		    }
	       }
	       aux1629_3194 = STRUCT_REF(s_3190, ((long) 0));
	       {
		  setq_cinfo_191_t new1630_3195;
		  new1630_3195 = ((setq_cinfo_191_t) (old1628_3193));
		  {
		     long arg3063_3196;
		     arg3063_3196 = class_num_218___object(setq_cinfo_191_cfa_info);
		     {
			obj_t obj_5593;
			obj_5593 = (obj_t) (new1630_3195);
			(((obj_t) CREF(obj_5593))->header = MAKE_HEADER(arg3063_3196, 0), BUNSPEC);
		     }
		  }
		  {
		     setq_cinfo_191_t arg3064_3197;
		     {
			setq_cinfo_191_t res3526_5600;
			{
			   approx_t approx_5597;
			   {
			      obj_t aux_8280;
			      aux_8280 = STRUCT_REF(aux1629_3194, ((long) 0));
			      approx_5597 = (approx_t) (aux_8280);
			   }
			   {
			      setq_cinfo_191_t new1617_5598;
			      new1617_5598 = ((setq_cinfo_191_t) BREF(GC_MALLOC(sizeof(struct setq_cinfo_191))));
			      ((((setq_cinfo_191_t) CREF(new1617_5598))->approx) = ((approx_t) approx_5597), BUNSPEC);
			      res3526_5600 = new1617_5598;
			   }
			}
			arg3064_3197 = res3526_5600;
		     }
		     {
			obj_t aux_8287;
			object_t aux_8285;
			aux_8287 = (obj_t) (arg3064_3197);
			aux_8285 = (object_t) (new1630_3195);
			OBJECT_WIDENING_SET(aux_8285, aux_8287);
		     }
		  }
		  aux_8262 = new1630_3195;
	       }
	    }
	 }
	 return (obj_t) (aux_8262);
      }
   }
}


obj_t 
object__struct_setq_cinfo3581_231_cfa_info(obj_t env_6768, obj_t obj1625_6769)
{
   {
      setq_cinfo_191_t obj1625_3176;
      obj1625_3176 = (setq_cinfo_191_t) (obj1625_6769);
      {
	 {
	    obj_t res1626_3179;
	    {
	       obj_t next_method2336_184_3187;
	       next_method2336_184_3187 = find_super_class_method_167___object((object_t) (obj1625_3176), object__struct_env_210___object, setq_cinfo_191_cfa_info);
	       if (PROCEDUREP(next_method2336_184_3187))
		 {
		    res1626_3179 = PROCEDURE_ENTRY(next_method2336_184_3187) (next_method2336_184_3187, (obj_t) (obj1625_3176), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2336_184_3187);
		    res1626_3179 = object__struct_50___object((object_t) (obj1625_3176));
		 }
	    }
	    {
	       obj_t aux1627_3180;
	       {
		  obj_t aux_8302;
		  aux_8302 = CNST_TABLE_REF(((long) 17));
		  aux1627_3180 = make_struct(aux_8302, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_8305;
		  {
		     approx_t aux_8306;
		     {
			obj_t aux_8307;
			{
			   object_t aux_8308;
			   aux_8308 = (object_t) (obj1625_3176);
			   aux_8307 = OBJECT_WIDENING(aux_8308);
			}
			aux_8306 = (((setq_cinfo_191_t) CREF(aux_8307))->approx);
		     }
		     aux_8305 = (obj_t) (aux_8306);
		  }
		  STRUCT_SET(aux1627_3180, ((long) 0), aux_8305);
	       }
	       STRUCT_SET(res1626_3179, ((long) 0), aux1627_3180);
	       {
		  obj_t aux_8315;
		  aux_8315 = STRUCT_KEY(res1626_3179);
		  STRUCT_KEY_SET(aux1627_3180, aux_8315);
	       }
	       {
		  obj_t aux_8318;
		  aux_8318 = CNST_TABLE_REF(((long) 17));
		  STRUCT_KEY_SET(res1626_3179, aux_8318);
	       }
	       return res1626_3179;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_conditional_cinfo3582_239_cfa_info(obj_t env_6770, obj_t o_6771, obj_t s_6772)
{
   {
      conditional_cinfo_212_t o_3164;
      obj_t s_3165;
      {
	 conditional_cinfo_212_t aux_8322;
	 o_3164 = (conditional_cinfo_212_t) (o_6771);
	 s_3165 = s_6772;
	 {
	    {
	       obj_t old1645_3168;
	       obj_t aux1646_3169;
	       {
		  obj_t next_method2334_117_3174;
		  next_method2334_117_3174 = find_super_class_method_167___object((object_t) (o_3164), struct_object__object_env_209___object, conditional_cinfo_212_cfa_info);
		  if (PROCEDUREP(next_method2334_117_3174))
		    {
		       old1645_3168 = PROCEDURE_ENTRY(next_method2334_117_3174) (next_method2334_117_3174, (obj_t) (o_3164), s_3165, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2334_117_3174);
		       {
			  object_t aux_8331;
			  aux_8331 = struct_object__object_93___object((object_t) (o_3164), s_3165);
			  old1645_3168 = (obj_t) (aux_8331);
		       }
		    }
	       }
	       aux1646_3169 = STRUCT_REF(s_3165, ((long) 0));
	       {
		  conditional_cinfo_212_t new1647_3170;
		  new1647_3170 = ((conditional_cinfo_212_t) (old1645_3168));
		  {
		     long arg3051_3171;
		     arg3051_3171 = class_num_218___object(conditional_cinfo_212_cfa_info);
		     {
			obj_t obj_5564;
			obj_5564 = (obj_t) (new1647_3170);
			(((obj_t) CREF(obj_5564))->header = MAKE_HEADER(arg3051_3171, 0), BUNSPEC);
		     }
		  }
		  {
		     conditional_cinfo_212_t arg3052_3172;
		     {
			conditional_cinfo_212_t res3525_5571;
			{
			   approx_t approx_5568;
			   {
			      obj_t aux_8340;
			      aux_8340 = STRUCT_REF(aux1646_3169, ((long) 0));
			      approx_5568 = (approx_t) (aux_8340);
			   }
			   {
			      conditional_cinfo_212_t new1632_5569;
			      new1632_5569 = ((conditional_cinfo_212_t) BREF(GC_MALLOC(sizeof(struct conditional_cinfo_212))));
			      ((((conditional_cinfo_212_t) CREF(new1632_5569))->approx) = ((approx_t) approx_5568), BUNSPEC);
			      res3525_5571 = new1632_5569;
			   }
			}
			arg3052_3172 = res3525_5571;
		     }
		     {
			obj_t aux_8347;
			object_t aux_8345;
			aux_8347 = (obj_t) (arg3052_3172);
			aux_8345 = (object_t) (new1647_3170);
			OBJECT_WIDENING_SET(aux_8345, aux_8347);
		     }
		  }
		  aux_8322 = new1647_3170;
	       }
	    }
	 }
	 return (obj_t) (aux_8322);
      }
   }
}


obj_t 
object__struct_conditional_cinfo3583_97_cfa_info(obj_t env_6773, obj_t obj1642_6774)
{
   {
      conditional_cinfo_212_t obj1642_3151;
      obj1642_3151 = (conditional_cinfo_212_t) (obj1642_6774);
      {
	 {
	    obj_t res1643_3154;
	    {
	       obj_t next_method2332_69_3162;
	       next_method2332_69_3162 = find_super_class_method_167___object((object_t) (obj1642_3151), object__struct_env_210___object, conditional_cinfo_212_cfa_info);
	       if (PROCEDUREP(next_method2332_69_3162))
		 {
		    res1643_3154 = PROCEDURE_ENTRY(next_method2332_69_3162) (next_method2332_69_3162, (obj_t) (obj1642_3151), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2332_69_3162);
		    res1643_3154 = object__struct_50___object((object_t) (obj1642_3151));
		 }
	    }
	    {
	       obj_t aux1644_3155;
	       {
		  obj_t aux_8362;
		  aux_8362 = CNST_TABLE_REF(((long) 18));
		  aux1644_3155 = make_struct(aux_8362, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_8365;
		  {
		     approx_t aux_8366;
		     {
			obj_t aux_8367;
			{
			   object_t aux_8368;
			   aux_8368 = (object_t) (obj1642_3151);
			   aux_8367 = OBJECT_WIDENING(aux_8368);
			}
			aux_8366 = (((conditional_cinfo_212_t) CREF(aux_8367))->approx);
		     }
		     aux_8365 = (obj_t) (aux_8366);
		  }
		  STRUCT_SET(aux1644_3155, ((long) 0), aux_8365);
	       }
	       STRUCT_SET(res1643_3154, ((long) 0), aux1644_3155);
	       {
		  obj_t aux_8375;
		  aux_8375 = STRUCT_KEY(res1643_3154);
		  STRUCT_KEY_SET(aux1644_3155, aux_8375);
	       }
	       {
		  obj_t aux_8378;
		  aux_8378 = CNST_TABLE_REF(((long) 18));
		  STRUCT_KEY_SET(res1643_3154, aux_8378);
	       }
	       return res1643_3154;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_fail_cinfo3584_117_cfa_info(obj_t env_6775, obj_t o_6776, obj_t s_6777)
{
   {
      fail_cinfo_75_t o_3139;
      obj_t s_3140;
      {
	 fail_cinfo_75_t aux_8382;
	 o_3139 = (fail_cinfo_75_t) (o_6776);
	 s_3140 = s_6777;
	 {
	    {
	       obj_t old1661_3143;
	       obj_t aux1662_3144;
	       {
		  obj_t next_method2330_23_3149;
		  next_method2330_23_3149 = find_super_class_method_167___object((object_t) (o_3139), struct_object__object_env_209___object, fail_cinfo_75_cfa_info);
		  if (PROCEDUREP(next_method2330_23_3149))
		    {
		       old1661_3143 = PROCEDURE_ENTRY(next_method2330_23_3149) (next_method2330_23_3149, (obj_t) (o_3139), s_3140, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2330_23_3149);
		       {
			  object_t aux_8391;
			  aux_8391 = struct_object__object_93___object((object_t) (o_3139), s_3140);
			  old1661_3143 = (obj_t) (aux_8391);
		       }
		    }
	       }
	       aux1662_3144 = STRUCT_REF(s_3140, ((long) 0));
	       {
		  fail_cinfo_75_t new1663_3145;
		  new1663_3145 = ((fail_cinfo_75_t) (old1661_3143));
		  {
		     long arg3040_3146;
		     arg3040_3146 = class_num_218___object(fail_cinfo_75_cfa_info);
		     {
			obj_t obj_5535;
			obj_5535 = (obj_t) (new1663_3145);
			(((obj_t) CREF(obj_5535))->header = MAKE_HEADER(arg3040_3146, 0), BUNSPEC);
		     }
		  }
		  {
		     fail_cinfo_75_t arg3041_3147;
		     {
			fail_cinfo_75_t res3524_5542;
			{
			   approx_t approx_5539;
			   {
			      obj_t aux_8400;
			      aux_8400 = STRUCT_REF(aux1662_3144, ((long) 0));
			      approx_5539 = (approx_t) (aux_8400);
			   }
			   {
			      fail_cinfo_75_t new1649_5540;
			      new1649_5540 = ((fail_cinfo_75_t) BREF(GC_MALLOC(sizeof(struct fail_cinfo_75))));
			      ((((fail_cinfo_75_t) CREF(new1649_5540))->approx) = ((approx_t) approx_5539), BUNSPEC);
			      res3524_5542 = new1649_5540;
			   }
			}
			arg3041_3147 = res3524_5542;
		     }
		     {
			obj_t aux_8407;
			object_t aux_8405;
			aux_8407 = (obj_t) (arg3041_3147);
			aux_8405 = (object_t) (new1663_3145);
			OBJECT_WIDENING_SET(aux_8405, aux_8407);
		     }
		  }
		  aux_8382 = new1663_3145;
	       }
	    }
	 }
	 return (obj_t) (aux_8382);
      }
   }
}


obj_t 
object__struct_fail_cinfo3585_16_cfa_info(obj_t env_6778, obj_t obj1658_6779)
{
   {
      fail_cinfo_75_t obj1658_3126;
      obj1658_3126 = (fail_cinfo_75_t) (obj1658_6779);
      {
	 {
	    obj_t res1659_3129;
	    {
	       obj_t next_method2328_222_3137;
	       next_method2328_222_3137 = find_super_class_method_167___object((object_t) (obj1658_3126), object__struct_env_210___object, fail_cinfo_75_cfa_info);
	       if (PROCEDUREP(next_method2328_222_3137))
		 {
		    res1659_3129 = PROCEDURE_ENTRY(next_method2328_222_3137) (next_method2328_222_3137, (obj_t) (obj1658_3126), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2328_222_3137);
		    res1659_3129 = object__struct_50___object((object_t) (obj1658_3126));
		 }
	    }
	    {
	       obj_t aux1660_3130;
	       {
		  obj_t aux_8422;
		  aux_8422 = CNST_TABLE_REF(((long) 19));
		  aux1660_3130 = make_struct(aux_8422, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_8425;
		  {
		     approx_t aux_8426;
		     {
			obj_t aux_8427;
			{
			   object_t aux_8428;
			   aux_8428 = (object_t) (obj1658_3126);
			   aux_8427 = OBJECT_WIDENING(aux_8428);
			}
			aux_8426 = (((fail_cinfo_75_t) CREF(aux_8427))->approx);
		     }
		     aux_8425 = (obj_t) (aux_8426);
		  }
		  STRUCT_SET(aux1660_3130, ((long) 0), aux_8425);
	       }
	       STRUCT_SET(res1659_3129, ((long) 0), aux1660_3130);
	       {
		  obj_t aux_8435;
		  aux_8435 = STRUCT_KEY(res1659_3129);
		  STRUCT_KEY_SET(aux1660_3130, aux_8435);
	       }
	       {
		  obj_t aux_8438;
		  aux_8438 = CNST_TABLE_REF(((long) 19));
		  STRUCT_KEY_SET(res1659_3129, aux_8438);
	       }
	       return res1659_3129;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_select_cinfo3586_101_cfa_info(obj_t env_6780, obj_t o_6781, obj_t s_6782)
{
   {
      select_cinfo_150_t o_3114;
      obj_t s_3115;
      {
	 select_cinfo_150_t aux_8442;
	 o_3114 = (select_cinfo_150_t) (o_6781);
	 s_3115 = s_6782;
	 {
	    {
	       obj_t old1676_3118;
	       obj_t aux1677_3119;
	       {
		  obj_t next_method2326_203_3124;
		  next_method2326_203_3124 = find_super_class_method_167___object((object_t) (o_3114), struct_object__object_env_209___object, select_cinfo_150_cfa_info);
		  if (PROCEDUREP(next_method2326_203_3124))
		    {
		       old1676_3118 = PROCEDURE_ENTRY(next_method2326_203_3124) (next_method2326_203_3124, (obj_t) (o_3114), s_3115, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2326_203_3124);
		       {
			  object_t aux_8451;
			  aux_8451 = struct_object__object_93___object((object_t) (o_3114), s_3115);
			  old1676_3118 = (obj_t) (aux_8451);
		       }
		    }
	       }
	       aux1677_3119 = STRUCT_REF(s_3115, ((long) 0));
	       {
		  select_cinfo_150_t new1678_3120;
		  new1678_3120 = ((select_cinfo_150_t) (old1676_3118));
		  {
		     long arg3029_3121;
		     arg3029_3121 = class_num_218___object(select_cinfo_150_cfa_info);
		     {
			obj_t obj_5506;
			obj_5506 = (obj_t) (new1678_3120);
			(((obj_t) CREF(obj_5506))->header = MAKE_HEADER(arg3029_3121, 0), BUNSPEC);
		     }
		  }
		  {
		     select_cinfo_150_t arg3030_3122;
		     {
			select_cinfo_150_t res3523_5513;
			{
			   approx_t approx_5510;
			   {
			      obj_t aux_8460;
			      aux_8460 = STRUCT_REF(aux1677_3119, ((long) 0));
			      approx_5510 = (approx_t) (aux_8460);
			   }
			   {
			      select_cinfo_150_t new1665_5511;
			      new1665_5511 = ((select_cinfo_150_t) BREF(GC_MALLOC(sizeof(struct select_cinfo_150))));
			      ((((select_cinfo_150_t) CREF(new1665_5511))->approx) = ((approx_t) approx_5510), BUNSPEC);
			      res3523_5513 = new1665_5511;
			   }
			}
			arg3030_3122 = res3523_5513;
		     }
		     {
			obj_t aux_8467;
			object_t aux_8465;
			aux_8467 = (obj_t) (arg3030_3122);
			aux_8465 = (object_t) (new1678_3120);
			OBJECT_WIDENING_SET(aux_8465, aux_8467);
		     }
		  }
		  aux_8442 = new1678_3120;
	       }
	    }
	 }
	 return (obj_t) (aux_8442);
      }
   }
}


obj_t 
object__struct_select_cinfo3587_16_cfa_info(obj_t env_6783, obj_t obj1673_6784)
{
   {
      select_cinfo_150_t obj1673_3101;
      obj1673_3101 = (select_cinfo_150_t) (obj1673_6784);
      {
	 {
	    obj_t res1674_3104;
	    {
	       obj_t next_method2324_120_3112;
	       next_method2324_120_3112 = find_super_class_method_167___object((object_t) (obj1673_3101), object__struct_env_210___object, select_cinfo_150_cfa_info);
	       if (PROCEDUREP(next_method2324_120_3112))
		 {
		    res1674_3104 = PROCEDURE_ENTRY(next_method2324_120_3112) (next_method2324_120_3112, (obj_t) (obj1673_3101), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2324_120_3112);
		    res1674_3104 = object__struct_50___object((object_t) (obj1673_3101));
		 }
	    }
	    {
	       obj_t aux1675_3105;
	       {
		  obj_t aux_8482;
		  aux_8482 = CNST_TABLE_REF(((long) 20));
		  aux1675_3105 = make_struct(aux_8482, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_8485;
		  {
		     approx_t aux_8486;
		     {
			obj_t aux_8487;
			{
			   object_t aux_8488;
			   aux_8488 = (object_t) (obj1673_3101);
			   aux_8487 = OBJECT_WIDENING(aux_8488);
			}
			aux_8486 = (((select_cinfo_150_t) CREF(aux_8487))->approx);
		     }
		     aux_8485 = (obj_t) (aux_8486);
		  }
		  STRUCT_SET(aux1675_3105, ((long) 0), aux_8485);
	       }
	       STRUCT_SET(res1674_3104, ((long) 0), aux1675_3105);
	       {
		  obj_t aux_8495;
		  aux_8495 = STRUCT_KEY(res1674_3104);
		  STRUCT_KEY_SET(aux1675_3105, aux_8495);
	       }
	       {
		  obj_t aux_8498;
		  aux_8498 = CNST_TABLE_REF(((long) 20));
		  STRUCT_KEY_SET(res1674_3104, aux_8498);
	       }
	       return res1674_3104;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_set_ex_it_cinfo3588_212_cfa_info(obj_t env_6785, obj_t o_6786, obj_t s_6787)
{
   {
      set_ex_it_cinfo_168_t o_3089;
      obj_t s_3090;
      {
	 set_ex_it_cinfo_168_t aux_8502;
	 o_3089 = (set_ex_it_cinfo_168_t) (o_6786);
	 s_3090 = s_6787;
	 {
	    {
	       obj_t old1691_3093;
	       obj_t aux1692_3094;
	       {
		  obj_t next_method2322_152_3099;
		  next_method2322_152_3099 = find_super_class_method_167___object((object_t) (o_3089), struct_object__object_env_209___object, set_ex_it_cinfo_168_cfa_info);
		  if (PROCEDUREP(next_method2322_152_3099))
		    {
		       old1691_3093 = PROCEDURE_ENTRY(next_method2322_152_3099) (next_method2322_152_3099, (obj_t) (o_3089), s_3090, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2322_152_3099);
		       {
			  object_t aux_8511;
			  aux_8511 = struct_object__object_93___object((object_t) (o_3089), s_3090);
			  old1691_3093 = (obj_t) (aux_8511);
		       }
		    }
	       }
	       aux1692_3094 = STRUCT_REF(s_3090, ((long) 0));
	       {
		  set_ex_it_cinfo_168_t new1693_3095;
		  new1693_3095 = ((set_ex_it_cinfo_168_t) (old1691_3093));
		  {
		     long arg3018_3096;
		     arg3018_3096 = class_num_218___object(set_ex_it_cinfo_168_cfa_info);
		     {
			obj_t obj_5477;
			obj_5477 = (obj_t) (new1693_3095);
			(((obj_t) CREF(obj_5477))->header = MAKE_HEADER(arg3018_3096, 0), BUNSPEC);
		     }
		  }
		  {
		     set_ex_it_cinfo_168_t arg3019_3097;
		     {
			set_ex_it_cinfo_168_t res3522_5484;
			{
			   approx_t approx_5481;
			   {
			      obj_t aux_8520;
			      aux_8520 = STRUCT_REF(aux1692_3094, ((long) 0));
			      approx_5481 = (approx_t) (aux_8520);
			   }
			   {
			      set_ex_it_cinfo_168_t new1680_5482;
			      new1680_5482 = ((set_ex_it_cinfo_168_t) BREF(GC_MALLOC(sizeof(struct set_ex_it_cinfo_168))));
			      ((((set_ex_it_cinfo_168_t) CREF(new1680_5482))->approx) = ((approx_t) approx_5481), BUNSPEC);
			      res3522_5484 = new1680_5482;
			   }
			}
			arg3019_3097 = res3522_5484;
		     }
		     {
			obj_t aux_8527;
			object_t aux_8525;
			aux_8527 = (obj_t) (arg3019_3097);
			aux_8525 = (object_t) (new1693_3095);
			OBJECT_WIDENING_SET(aux_8525, aux_8527);
		     }
		  }
		  aux_8502 = new1693_3095;
	       }
	    }
	 }
	 return (obj_t) (aux_8502);
      }
   }
}


obj_t 
object__struct_set_ex_it_cinfo3589_142_cfa_info(obj_t env_6788, obj_t obj1688_6789)
{
   {
      set_ex_it_cinfo_168_t obj1688_3076;
      obj1688_3076 = (set_ex_it_cinfo_168_t) (obj1688_6789);
      {
	 {
	    obj_t res1689_3079;
	    {
	       obj_t next_method2320_123_3087;
	       next_method2320_123_3087 = find_super_class_method_167___object((object_t) (obj1688_3076), object__struct_env_210___object, set_ex_it_cinfo_168_cfa_info);
	       if (PROCEDUREP(next_method2320_123_3087))
		 {
		    res1689_3079 = PROCEDURE_ENTRY(next_method2320_123_3087) (next_method2320_123_3087, (obj_t) (obj1688_3076), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2320_123_3087);
		    res1689_3079 = object__struct_50___object((object_t) (obj1688_3076));
		 }
	    }
	    {
	       obj_t aux1690_3080;
	       {
		  obj_t aux_8542;
		  aux_8542 = CNST_TABLE_REF(((long) 21));
		  aux1690_3080 = make_struct(aux_8542, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_8545;
		  {
		     approx_t aux_8546;
		     {
			obj_t aux_8547;
			{
			   object_t aux_8548;
			   aux_8548 = (object_t) (obj1688_3076);
			   aux_8547 = OBJECT_WIDENING(aux_8548);
			}
			aux_8546 = (((set_ex_it_cinfo_168_t) CREF(aux_8547))->approx);
		     }
		     aux_8545 = (obj_t) (aux_8546);
		  }
		  STRUCT_SET(aux1690_3080, ((long) 0), aux_8545);
	       }
	       STRUCT_SET(res1689_3079, ((long) 0), aux1690_3080);
	       {
		  obj_t aux_8555;
		  aux_8555 = STRUCT_KEY(res1689_3079);
		  STRUCT_KEY_SET(aux1690_3080, aux_8555);
	       }
	       {
		  obj_t aux_8558;
		  aux_8558 = CNST_TABLE_REF(((long) 21));
		  STRUCT_KEY_SET(res1689_3079, aux_8558);
	       }
	       return res1689_3079;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_jump_ex_it_cinfo3590_166_cfa_info(obj_t env_6790, obj_t o_6791, obj_t s_6792)
{
   {
      jump_ex_it_cinfo_139_t o_3064;
      obj_t s_3065;
      {
	 jump_ex_it_cinfo_139_t aux_8562;
	 o_3064 = (jump_ex_it_cinfo_139_t) (o_6791);
	 s_3065 = s_6792;
	 {
	    {
	       obj_t old1706_3068;
	       obj_t aux1707_3069;
	       {
		  obj_t next_method2318_220_3074;
		  next_method2318_220_3074 = find_super_class_method_167___object((object_t) (o_3064), struct_object__object_env_209___object, jump_ex_it_cinfo_139_cfa_info);
		  if (PROCEDUREP(next_method2318_220_3074))
		    {
		       old1706_3068 = PROCEDURE_ENTRY(next_method2318_220_3074) (next_method2318_220_3074, (obj_t) (o_3064), s_3065, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2318_220_3074);
		       {
			  object_t aux_8571;
			  aux_8571 = struct_object__object_93___object((object_t) (o_3064), s_3065);
			  old1706_3068 = (obj_t) (aux_8571);
		       }
		    }
	       }
	       aux1707_3069 = STRUCT_REF(s_3065, ((long) 0));
	       {
		  jump_ex_it_cinfo_139_t new1708_3070;
		  new1708_3070 = ((jump_ex_it_cinfo_139_t) (old1706_3068));
		  {
		     long arg3007_3071;
		     arg3007_3071 = class_num_218___object(jump_ex_it_cinfo_139_cfa_info);
		     {
			obj_t obj_5448;
			obj_5448 = (obj_t) (new1708_3070);
			(((obj_t) CREF(obj_5448))->header = MAKE_HEADER(arg3007_3071, 0), BUNSPEC);
		     }
		  }
		  {
		     jump_ex_it_cinfo_139_t arg3008_3072;
		     {
			jump_ex_it_cinfo_139_t res3521_5455;
			{
			   approx_t approx_5452;
			   {
			      obj_t aux_8580;
			      aux_8580 = STRUCT_REF(aux1707_3069, ((long) 0));
			      approx_5452 = (approx_t) (aux_8580);
			   }
			   {
			      jump_ex_it_cinfo_139_t new1695_5453;
			      new1695_5453 = ((jump_ex_it_cinfo_139_t) BREF(GC_MALLOC(sizeof(struct jump_ex_it_cinfo_139))));
			      ((((jump_ex_it_cinfo_139_t) CREF(new1695_5453))->approx) = ((approx_t) approx_5452), BUNSPEC);
			      res3521_5455 = new1695_5453;
			   }
			}
			arg3008_3072 = res3521_5455;
		     }
		     {
			obj_t aux_8587;
			object_t aux_8585;
			aux_8587 = (obj_t) (arg3008_3072);
			aux_8585 = (object_t) (new1708_3070);
			OBJECT_WIDENING_SET(aux_8585, aux_8587);
		     }
		  }
		  aux_8562 = new1708_3070;
	       }
	    }
	 }
	 return (obj_t) (aux_8562);
      }
   }
}


obj_t 
object__struct_jump_ex_it_cinfo3591_236_cfa_info(obj_t env_6793, obj_t obj1703_6794)
{
   {
      jump_ex_it_cinfo_139_t obj1703_3051;
      obj1703_3051 = (jump_ex_it_cinfo_139_t) (obj1703_6794);
      {
	 {
	    obj_t res1704_3054;
	    {
	       obj_t next_method2316_32_3062;
	       next_method2316_32_3062 = find_super_class_method_167___object((object_t) (obj1703_3051), object__struct_env_210___object, jump_ex_it_cinfo_139_cfa_info);
	       if (PROCEDUREP(next_method2316_32_3062))
		 {
		    res1704_3054 = PROCEDURE_ENTRY(next_method2316_32_3062) (next_method2316_32_3062, (obj_t) (obj1703_3051), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2316_32_3062);
		    res1704_3054 = object__struct_50___object((object_t) (obj1703_3051));
		 }
	    }
	    {
	       obj_t aux1705_3055;
	       {
		  obj_t aux_8602;
		  aux_8602 = CNST_TABLE_REF(((long) 22));
		  aux1705_3055 = make_struct(aux_8602, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_8605;
		  {
		     approx_t aux_8606;
		     {
			obj_t aux_8607;
			{
			   object_t aux_8608;
			   aux_8608 = (object_t) (obj1703_3051);
			   aux_8607 = OBJECT_WIDENING(aux_8608);
			}
			aux_8606 = (((jump_ex_it_cinfo_139_t) CREF(aux_8607))->approx);
		     }
		     aux_8605 = (obj_t) (aux_8606);
		  }
		  STRUCT_SET(aux1705_3055, ((long) 0), aux_8605);
	       }
	       STRUCT_SET(res1704_3054, ((long) 0), aux1705_3055);
	       {
		  obj_t aux_8615;
		  aux_8615 = STRUCT_KEY(res1704_3054);
		  STRUCT_KEY_SET(aux1705_3055, aux_8615);
	       }
	       {
		  obj_t aux_8618;
		  aux_8618 = CNST_TABLE_REF(((long) 22));
		  STRUCT_KEY_SET(res1704_3054, aux_8618);
	       }
	       return res1704_3054;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_pre_make_box3592_7_cfa_info(obj_t env_6795, obj_t o_6796, obj_t s_6797)
{
   {
      pre_make_box_186_t o_3039;
      obj_t s_3040;
      {
	 pre_make_box_186_t aux_8622;
	 o_3039 = (pre_make_box_186_t) (o_6796);
	 s_3040 = s_6797;
	 {
	    {
	       obj_t old1722_3043;
	       obj_t aux1723_3044;
	       {
		  obj_t next_method2314_187_3049;
		  next_method2314_187_3049 = find_super_class_method_167___object((object_t) (o_3039), struct_object__object_env_209___object, pre_make_box_186_cfa_info);
		  if (PROCEDUREP(next_method2314_187_3049))
		    {
		       old1722_3043 = PROCEDURE_ENTRY(next_method2314_187_3049) (next_method2314_187_3049, (obj_t) (o_3039), s_3040, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2314_187_3049);
		       {
			  object_t aux_8631;
			  aux_8631 = struct_object__object_93___object((object_t) (o_3039), s_3040);
			  old1722_3043 = (obj_t) (aux_8631);
		       }
		    }
	       }
	       aux1723_3044 = STRUCT_REF(s_3040, ((long) 0));
	       {
		  pre_make_box_186_t new1724_3045;
		  new1724_3045 = ((pre_make_box_186_t) (old1722_3043));
		  {
		     long arg2990_3046;
		     arg2990_3046 = class_num_218___object(pre_make_box_186_cfa_info);
		     {
			obj_t obj_5419;
			obj_5419 = (obj_t) (new1724_3045);
			(((obj_t) CREF(obj_5419))->header = MAKE_HEADER(arg2990_3046, 0), BUNSPEC);
		     }
		  }
		  {
		     pre_make_box_186_t arg2997_3047;
		     {
			obj_t arg2998_3048;
			arg2998_3048 = STRUCT_REF(aux1723_3044, ((long) 0));
			{
			   pre_make_box_186_t res3520_5426;
			   {
			      pre_make_box_186_t new1710_5424;
			      new1710_5424 = ((pre_make_box_186_t) BREF(GC_MALLOC(sizeof(struct pre_make_box_186))));
			      ((((pre_make_box_186_t) CREF(new1710_5424))->key) = ((obj_t) arg2998_3048), BUNSPEC);
			      res3520_5426 = new1710_5424;
			   }
			   arg2997_3047 = res3520_5426;
			}
		     }
		     {
			obj_t aux_8645;
			object_t aux_8643;
			aux_8645 = (obj_t) (arg2997_3047);
			aux_8643 = (object_t) (new1724_3045);
			OBJECT_WIDENING_SET(aux_8643, aux_8645);
		     }
		  }
		  aux_8622 = new1724_3045;
	       }
	    }
	 }
	 return (obj_t) (aux_8622);
      }
   }
}


obj_t 
object__struct_pre_make_box3593_103_cfa_info(obj_t env_6798, obj_t obj1719_6799)
{
   {
      pre_make_box_186_t obj1719_3026;
      obj1719_3026 = (pre_make_box_186_t) (obj1719_6799);
      {
	 {
	    obj_t res1720_3029;
	    {
	       obj_t next_method2312_214_3037;
	       next_method2312_214_3037 = find_super_class_method_167___object((object_t) (obj1719_3026), object__struct_env_210___object, pre_make_box_186_cfa_info);
	       if (PROCEDUREP(next_method2312_214_3037))
		 {
		    res1720_3029 = PROCEDURE_ENTRY(next_method2312_214_3037) (next_method2312_214_3037, (obj_t) (obj1719_3026), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2312_214_3037);
		    res1720_3029 = object__struct_50___object((object_t) (obj1719_3026));
		 }
	    }
	    {
	       obj_t aux1721_3030;
	       {
		  obj_t aux_8660;
		  aux_8660 = CNST_TABLE_REF(((long) 23));
		  aux1721_3030 = make_struct(aux_8660, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_8663;
		  {
		     obj_t aux_8664;
		     {
			object_t aux_8665;
			aux_8665 = (object_t) (obj1719_3026);
			aux_8664 = OBJECT_WIDENING(aux_8665);
		     }
		     aux_8663 = (((pre_make_box_186_t) CREF(aux_8664))->key);
		  }
		  STRUCT_SET(aux1721_3030, ((long) 0), aux_8663);
	       }
	       STRUCT_SET(res1720_3029, ((long) 0), aux1721_3030);
	       {
		  obj_t aux_8671;
		  aux_8671 = STRUCT_KEY(res1720_3029);
		  STRUCT_KEY_SET(aux1721_3030, aux_8671);
	       }
	       {
		  obj_t aux_8674;
		  aux_8674 = CNST_TABLE_REF(((long) 23));
		  STRUCT_KEY_SET(res1720_3029, aux_8674);
	       }
	       return res1720_3029;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_make_box_cinfo3594_129_cfa_info(obj_t env_6800, obj_t o_6801, obj_t s_6802)
{
   {
      make_box_cinfo_127_t o_3014;
      obj_t s_3015;
      {
	 make_box_cinfo_127_t aux_8678;
	 o_3014 = (make_box_cinfo_127_t) (o_6801);
	 s_3015 = s_6802;
	 {
	    {
	       obj_t old1737_3018;
	       obj_t aux1738_3019;
	       {
		  obj_t next_method2310_226_3024;
		  next_method2310_226_3024 = find_super_class_method_167___object((object_t) (o_3014), struct_object__object_env_209___object, make_box_cinfo_127_cfa_info);
		  if (PROCEDUREP(next_method2310_226_3024))
		    {
		       old1737_3018 = PROCEDURE_ENTRY(next_method2310_226_3024) (next_method2310_226_3024, (obj_t) (o_3014), s_3015, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2310_226_3024);
		       {
			  object_t aux_8687;
			  aux_8687 = struct_object__object_93___object((object_t) (o_3014), s_3015);
			  old1737_3018 = (obj_t) (aux_8687);
		       }
		    }
	       }
	       aux1738_3019 = STRUCT_REF(s_3015, ((long) 0));
	       {
		  make_box_cinfo_127_t new1739_3020;
		  new1739_3020 = ((make_box_cinfo_127_t) (old1737_3018));
		  {
		     long arg2979_3021;
		     arg2979_3021 = class_num_218___object(make_box_cinfo_127_cfa_info);
		     {
			obj_t obj_5390;
			obj_5390 = (obj_t) (new1739_3020);
			(((obj_t) CREF(obj_5390))->header = MAKE_HEADER(arg2979_3021, 0), BUNSPEC);
		     }
		  }
		  {
		     make_box_cinfo_127_t arg2980_3022;
		     {
			make_box_cinfo_127_t res3519_5397;
			{
			   approx_t approx_5394;
			   {
			      obj_t aux_8696;
			      aux_8696 = STRUCT_REF(aux1738_3019, ((long) 0));
			      approx_5394 = (approx_t) (aux_8696);
			   }
			   {
			      make_box_cinfo_127_t new1726_5395;
			      new1726_5395 = ((make_box_cinfo_127_t) BREF(GC_MALLOC(sizeof(struct make_box_cinfo_127))));
			      ((((make_box_cinfo_127_t) CREF(new1726_5395))->approx) = ((approx_t) approx_5394), BUNSPEC);
			      res3519_5397 = new1726_5395;
			   }
			}
			arg2980_3022 = res3519_5397;
		     }
		     {
			obj_t aux_8703;
			object_t aux_8701;
			aux_8703 = (obj_t) (arg2980_3022);
			aux_8701 = (object_t) (new1739_3020);
			OBJECT_WIDENING_SET(aux_8701, aux_8703);
		     }
		  }
		  aux_8678 = new1739_3020;
	       }
	    }
	 }
	 return (obj_t) (aux_8678);
      }
   }
}


obj_t 
object__struct_make_box_cinfo3595_155_cfa_info(obj_t env_6803, obj_t obj1734_6804)
{
   {
      make_box_cinfo_127_t obj1734_3001;
      obj1734_3001 = (make_box_cinfo_127_t) (obj1734_6804);
      {
	 {
	    obj_t res1735_3004;
	    {
	       obj_t next_method2308_255_3012;
	       next_method2308_255_3012 = find_super_class_method_167___object((object_t) (obj1734_3001), object__struct_env_210___object, make_box_cinfo_127_cfa_info);
	       if (PROCEDUREP(next_method2308_255_3012))
		 {
		    res1735_3004 = PROCEDURE_ENTRY(next_method2308_255_3012) (next_method2308_255_3012, (obj_t) (obj1734_3001), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2308_255_3012);
		    res1735_3004 = object__struct_50___object((object_t) (obj1734_3001));
		 }
	    }
	    {
	       obj_t aux1736_3005;
	       {
		  obj_t aux_8718;
		  aux_8718 = CNST_TABLE_REF(((long) 24));
		  aux1736_3005 = make_struct(aux_8718, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_8721;
		  {
		     approx_t aux_8722;
		     {
			obj_t aux_8723;
			{
			   object_t aux_8724;
			   aux_8724 = (object_t) (obj1734_3001);
			   aux_8723 = OBJECT_WIDENING(aux_8724);
			}
			aux_8722 = (((make_box_cinfo_127_t) CREF(aux_8723))->approx);
		     }
		     aux_8721 = (obj_t) (aux_8722);
		  }
		  STRUCT_SET(aux1736_3005, ((long) 0), aux_8721);
	       }
	       STRUCT_SET(res1735_3004, ((long) 0), aux1736_3005);
	       {
		  obj_t aux_8731;
		  aux_8731 = STRUCT_KEY(res1735_3004);
		  STRUCT_KEY_SET(aux1736_3005, aux_8731);
	       }
	       {
		  obj_t aux_8734;
		  aux_8734 = CNST_TABLE_REF(((long) 24));
		  STRUCT_KEY_SET(res1735_3004, aux_8734);
	       }
	       return res1735_3004;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_make_box_o_cinfo3596_201_cfa_info(obj_t env_6805, obj_t o_6806, obj_t s_6807)
{
   {
      make_box_o_cinfo_96_t o_2987;
      obj_t s_2988;
      {
	 make_box_o_cinfo_96_t aux_8738;
	 o_2987 = (make_box_o_cinfo_96_t) (o_6806);
	 s_2988 = s_6807;
	 {
	    {
	       obj_t old1753_2991;
	       obj_t aux1754_2992;
	       {
		  obj_t next_method2306_42_2999;
		  next_method2306_42_2999 = find_super_class_method_167___object((object_t) (o_2987), struct_object__object_env_209___object, make_box_o_cinfo_96_cfa_info);
		  if (PROCEDUREP(next_method2306_42_2999))
		    {
		       old1753_2991 = PROCEDURE_ENTRY(next_method2306_42_2999) (next_method2306_42_2999, (obj_t) (o_2987), s_2988, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2306_42_2999);
		       {
			  object_t aux_8747;
			  aux_8747 = struct_object__object_93___object((object_t) (o_2987), s_2988);
			  old1753_2991 = (obj_t) (aux_8747);
		       }
		    }
	       }
	       aux1754_2992 = STRUCT_REF(s_2988, ((long) 0));
	       {
		  make_box_o_cinfo_96_t new1755_2993;
		  new1755_2993 = ((make_box_o_cinfo_96_t) (old1753_2991));
		  {
		     long arg2966_2994;
		     arg2966_2994 = class_num_218___object(make_box_o_cinfo_96_cfa_info);
		     {
			obj_t obj_5353;
			obj_5353 = (obj_t) (new1755_2993);
			(((obj_t) CREF(obj_5353))->header = MAKE_HEADER(arg2966_2994, 0), BUNSPEC);
		     }
		  }
		  {
		     make_box_o_cinfo_96_t arg2967_2995;
		     {
			obj_t arg2968_2996;
			arg2968_2996 = STRUCT_REF(aux1754_2992, ((long) 0));
			{
			   make_box_o_cinfo_96_t res3518_5368;
			   {
			      approx_t approx_5362;
			      approx_t value_approx_19_5363;
			      {
				 obj_t aux_8757;
				 aux_8757 = STRUCT_REF(aux1754_2992, ((long) 1));
				 approx_5362 = (approx_t) (aux_8757);
			      }
			      {
				 obj_t aux_8760;
				 aux_8760 = STRUCT_REF(aux1754_2992, ((long) 2));
				 value_approx_19_5363 = (approx_t) (aux_8760);
			      }
			      {
				 make_box_o_cinfo_96_t new1741_5364;
				 new1741_5364 = ((make_box_o_cinfo_96_t) BREF(GC_MALLOC(sizeof(struct make_box_o_cinfo_96))));
				 ((((make_box_o_cinfo_96_t) CREF(new1741_5364))->key) = ((obj_t) arg2968_2996), BUNSPEC);
				 ((((make_box_o_cinfo_96_t) CREF(new1741_5364))->approx) = ((approx_t) approx_5362), BUNSPEC);
				 ((((make_box_o_cinfo_96_t) CREF(new1741_5364))->value_approx_19) = ((approx_t) value_approx_19_5363), BUNSPEC);
				 res3518_5368 = new1741_5364;
			      }
			   }
			   arg2967_2995 = res3518_5368;
			}
		     }
		     {
			obj_t aux_8769;
			object_t aux_8767;
			aux_8769 = (obj_t) (arg2967_2995);
			aux_8767 = (object_t) (new1755_2993);
			OBJECT_WIDENING_SET(aux_8767, aux_8769);
		     }
		  }
		  aux_8738 = new1755_2993;
	       }
	    }
	 }
	 return (obj_t) (aux_8738);
      }
   }
}


obj_t 
object__struct_make_box_o_cinfo3597_33_cfa_info(obj_t env_6808, obj_t obj1750_6809)
{
   {
      make_box_o_cinfo_96_t obj1750_2970;
      obj1750_2970 = (make_box_o_cinfo_96_t) (obj1750_6809);
      {
	 {
	    obj_t res1751_2973;
	    {
	       obj_t next_method2304_159_2985;
	       next_method2304_159_2985 = find_super_class_method_167___object((object_t) (obj1750_2970), object__struct_env_210___object, make_box_o_cinfo_96_cfa_info);
	       if (PROCEDUREP(next_method2304_159_2985))
		 {
		    res1751_2973 = PROCEDURE_ENTRY(next_method2304_159_2985) (next_method2304_159_2985, (obj_t) (obj1750_2970), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2304_159_2985);
		    res1751_2973 = object__struct_50___object((object_t) (obj1750_2970));
		 }
	    }
	    {
	       obj_t aux1752_2974;
	       {
		  obj_t aux_8784;
		  aux_8784 = CNST_TABLE_REF(((long) 25));
		  aux1752_2974 = make_struct(aux_8784, ((long) 3), BUNSPEC);
	       }
	       {
		  obj_t aux_8787;
		  {
		     obj_t aux_8788;
		     {
			object_t aux_8789;
			aux_8789 = (object_t) (obj1750_2970);
			aux_8788 = OBJECT_WIDENING(aux_8789);
		     }
		     aux_8787 = (((make_box_o_cinfo_96_t) CREF(aux_8788))->key);
		  }
		  STRUCT_SET(aux1752_2974, ((long) 0), aux_8787);
	       }
	       {
		  obj_t aux_8794;
		  {
		     approx_t aux_8795;
		     {
			obj_t aux_8796;
			{
			   object_t aux_8797;
			   aux_8797 = (object_t) (obj1750_2970);
			   aux_8796 = OBJECT_WIDENING(aux_8797);
			}
			aux_8795 = (((make_box_o_cinfo_96_t) CREF(aux_8796))->approx);
		     }
		     aux_8794 = (obj_t) (aux_8795);
		  }
		  STRUCT_SET(aux1752_2974, ((long) 1), aux_8794);
	       }
	       {
		  obj_t aux_8803;
		  {
		     approx_t aux_8804;
		     {
			obj_t aux_8805;
			{
			   object_t aux_8806;
			   aux_8806 = (object_t) (obj1750_2970);
			   aux_8805 = OBJECT_WIDENING(aux_8806);
			}
			aux_8804 = (((make_box_o_cinfo_96_t) CREF(aux_8805))->value_approx_19);
		     }
		     aux_8803 = (obj_t) (aux_8804);
		  }
		  STRUCT_SET(aux1752_2974, ((long) 2), aux_8803);
	       }
	       STRUCT_SET(res1751_2973, ((long) 0), aux1752_2974);
	       {
		  obj_t aux_8813;
		  aux_8813 = STRUCT_KEY(res1751_2973);
		  STRUCT_KEY_SET(aux1752_2974, aux_8813);
	       }
	       {
		  obj_t aux_8816;
		  aux_8816 = CNST_TABLE_REF(((long) 25));
		  STRUCT_KEY_SET(res1751_2973, aux_8816);
	       }
	       return res1751_2973;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_box_set__cinfo3598_217_cfa_info(obj_t env_6810, obj_t o_6811, obj_t s_6812)
{
   {
      box_set__cinfo_94_t o_2958;
      obj_t s_2959;
      {
	 box_set__cinfo_94_t aux_8820;
	 o_2958 = (box_set__cinfo_94_t) (o_6811);
	 s_2959 = s_6812;
	 {
	    {
	       obj_t old1770_2962;
	       obj_t aux1771_2963;
	       {
		  obj_t next_method2302_61_2968;
		  next_method2302_61_2968 = find_super_class_method_167___object((object_t) (o_2958), struct_object__object_env_209___object, box_set__cinfo_94_cfa_info);
		  if (PROCEDUREP(next_method2302_61_2968))
		    {
		       old1770_2962 = PROCEDURE_ENTRY(next_method2302_61_2968) (next_method2302_61_2968, (obj_t) (o_2958), s_2959, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2302_61_2968);
		       {
			  object_t aux_8829;
			  aux_8829 = struct_object__object_93___object((object_t) (o_2958), s_2959);
			  old1770_2962 = (obj_t) (aux_8829);
		       }
		    }
	       }
	       aux1771_2963 = STRUCT_REF(s_2959, ((long) 0));
	       {
		  box_set__cinfo_94_t new1772_2964;
		  new1772_2964 = ((box_set__cinfo_94_t) (old1770_2962));
		  {
		     long arg2951_2965;
		     arg2951_2965 = class_num_218___object(box_set__cinfo_94_cfa_info);
		     {
			obj_t obj_5316;
			obj_5316 = (obj_t) (new1772_2964);
			(((obj_t) CREF(obj_5316))->header = MAKE_HEADER(arg2951_2965, 0), BUNSPEC);
		     }
		  }
		  {
		     box_set__cinfo_94_t arg2952_2966;
		     {
			box_set__cinfo_94_t res3517_5323;
			{
			   approx_t approx_5320;
			   {
			      obj_t aux_8838;
			      aux_8838 = STRUCT_REF(aux1771_2963, ((long) 0));
			      approx_5320 = (approx_t) (aux_8838);
			   }
			   {
			      box_set__cinfo_94_t new1759_5321;
			      new1759_5321 = ((box_set__cinfo_94_t) BREF(GC_MALLOC(sizeof(struct box_set__cinfo_94))));
			      ((((box_set__cinfo_94_t) CREF(new1759_5321))->approx) = ((approx_t) approx_5320), BUNSPEC);
			      res3517_5323 = new1759_5321;
			   }
			}
			arg2952_2966 = res3517_5323;
		     }
		     {
			obj_t aux_8845;
			object_t aux_8843;
			aux_8845 = (obj_t) (arg2952_2966);
			aux_8843 = (object_t) (new1772_2964);
			OBJECT_WIDENING_SET(aux_8843, aux_8845);
		     }
		  }
		  aux_8820 = new1772_2964;
	       }
	    }
	 }
	 return (obj_t) (aux_8820);
      }
   }
}


obj_t 
object__struct_box_set__cinfo3599_62_cfa_info(obj_t env_6813, obj_t obj1767_6814)
{
   {
      box_set__cinfo_94_t obj1767_2945;
      obj1767_2945 = (box_set__cinfo_94_t) (obj1767_6814);
      {
	 {
	    obj_t res1768_2948;
	    {
	       obj_t next_method2300_89_2956;
	       next_method2300_89_2956 = find_super_class_method_167___object((object_t) (obj1767_2945), object__struct_env_210___object, box_set__cinfo_94_cfa_info);
	       if (PROCEDUREP(next_method2300_89_2956))
		 {
		    res1768_2948 = PROCEDURE_ENTRY(next_method2300_89_2956) (next_method2300_89_2956, (obj_t) (obj1767_2945), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2300_89_2956);
		    res1768_2948 = object__struct_50___object((object_t) (obj1767_2945));
		 }
	    }
	    {
	       obj_t aux1769_2949;
	       {
		  obj_t aux_8860;
		  aux_8860 = CNST_TABLE_REF(((long) 26));
		  aux1769_2949 = make_struct(aux_8860, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_8863;
		  {
		     approx_t aux_8864;
		     {
			obj_t aux_8865;
			{
			   object_t aux_8866;
			   aux_8866 = (object_t) (obj1767_2945);
			   aux_8865 = OBJECT_WIDENING(aux_8866);
			}
			aux_8864 = (((box_set__cinfo_94_t) CREF(aux_8865))->approx);
		     }
		     aux_8863 = (obj_t) (aux_8864);
		  }
		  STRUCT_SET(aux1769_2949, ((long) 0), aux_8863);
	       }
	       STRUCT_SET(res1768_2948, ((long) 0), aux1769_2949);
	       {
		  obj_t aux_8873;
		  aux_8873 = STRUCT_KEY(res1768_2948);
		  STRUCT_KEY_SET(aux1769_2949, aux_8873);
	       }
	       {
		  obj_t aux_8876;
		  aux_8876 = CNST_TABLE_REF(((long) 26));
		  STRUCT_KEY_SET(res1768_2948, aux_8876);
	       }
	       return res1768_2948;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_box_ref_cinfo3600_139_cfa_info(obj_t env_6815, obj_t o_6816, obj_t s_6817)
{
   {
      box_ref_cinfo_214_t o_2933;
      obj_t s_2934;
      {
	 box_ref_cinfo_214_t aux_8880;
	 o_2933 = (box_ref_cinfo_214_t) (o_6816);
	 s_2934 = s_6817;
	 {
	    {
	       obj_t old1785_2937;
	       obj_t aux1786_2938;
	       {
		  obj_t next_method2298_134_2943;
		  next_method2298_134_2943 = find_super_class_method_167___object((object_t) (o_2933), struct_object__object_env_209___object, box_ref_cinfo_214_cfa_info);
		  if (PROCEDUREP(next_method2298_134_2943))
		    {
		       old1785_2937 = PROCEDURE_ENTRY(next_method2298_134_2943) (next_method2298_134_2943, (obj_t) (o_2933), s_2934, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2298_134_2943);
		       {
			  object_t aux_8889;
			  aux_8889 = struct_object__object_93___object((object_t) (o_2933), s_2934);
			  old1785_2937 = (obj_t) (aux_8889);
		       }
		    }
	       }
	       aux1786_2938 = STRUCT_REF(s_2934, ((long) 0));
	       {
		  box_ref_cinfo_214_t new1787_2939;
		  new1787_2939 = ((box_ref_cinfo_214_t) (old1785_2937));
		  {
		     long arg2940_2940;
		     arg2940_2940 = class_num_218___object(box_ref_cinfo_214_cfa_info);
		     {
			obj_t obj_5287;
			obj_5287 = (obj_t) (new1787_2939);
			(((obj_t) CREF(obj_5287))->header = MAKE_HEADER(arg2940_2940, 0), BUNSPEC);
		     }
		  }
		  {
		     box_ref_cinfo_214_t arg2941_2941;
		     {
			box_ref_cinfo_214_t res3516_5294;
			{
			   approx_t approx_5291;
			   {
			      obj_t aux_8898;
			      aux_8898 = STRUCT_REF(aux1786_2938, ((long) 0));
			      approx_5291 = (approx_t) (aux_8898);
			   }
			   {
			      box_ref_cinfo_214_t new1774_5292;
			      new1774_5292 = ((box_ref_cinfo_214_t) BREF(GC_MALLOC(sizeof(struct box_ref_cinfo_214))));
			      ((((box_ref_cinfo_214_t) CREF(new1774_5292))->approx) = ((approx_t) approx_5291), BUNSPEC);
			      res3516_5294 = new1774_5292;
			   }
			}
			arg2941_2941 = res3516_5294;
		     }
		     {
			obj_t aux_8905;
			object_t aux_8903;
			aux_8905 = (obj_t) (arg2941_2941);
			aux_8903 = (object_t) (new1787_2939);
			OBJECT_WIDENING_SET(aux_8903, aux_8905);
		     }
		  }
		  aux_8880 = new1787_2939;
	       }
	    }
	 }
	 return (obj_t) (aux_8880);
      }
   }
}


obj_t 
object__struct_box_ref_cinfo3601_223_cfa_info(obj_t env_6818, obj_t obj1782_6819)
{
   {
      box_ref_cinfo_214_t obj1782_2920;
      obj1782_2920 = (box_ref_cinfo_214_t) (obj1782_6819);
      {
	 {
	    obj_t res1783_2923;
	    {
	       obj_t next_method2296_245_2931;
	       next_method2296_245_2931 = find_super_class_method_167___object((object_t) (obj1782_2920), object__struct_env_210___object, box_ref_cinfo_214_cfa_info);
	       if (PROCEDUREP(next_method2296_245_2931))
		 {
		    res1783_2923 = PROCEDURE_ENTRY(next_method2296_245_2931) (next_method2296_245_2931, (obj_t) (obj1782_2920), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2296_245_2931);
		    res1783_2923 = object__struct_50___object((object_t) (obj1782_2920));
		 }
	    }
	    {
	       obj_t aux1784_2924;
	       {
		  obj_t aux_8920;
		  aux_8920 = CNST_TABLE_REF(((long) 27));
		  aux1784_2924 = make_struct(aux_8920, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_8923;
		  {
		     approx_t aux_8924;
		     {
			obj_t aux_8925;
			{
			   object_t aux_8926;
			   aux_8926 = (object_t) (obj1782_2920);
			   aux_8925 = OBJECT_WIDENING(aux_8926);
			}
			aux_8924 = (((box_ref_cinfo_214_t) CREF(aux_8925))->approx);
		     }
		     aux_8923 = (obj_t) (aux_8924);
		  }
		  STRUCT_SET(aux1784_2924, ((long) 0), aux_8923);
	       }
	       STRUCT_SET(res1783_2923, ((long) 0), aux1784_2924);
	       {
		  obj_t aux_8933;
		  aux_8933 = STRUCT_KEY(res1783_2923);
		  STRUCT_KEY_SET(aux1784_2924, aux_8933);
	       }
	       {
		  obj_t aux_8936;
		  aux_8936 = CNST_TABLE_REF(((long) 27));
		  STRUCT_KEY_SET(res1783_2923, aux_8936);
	       }
	       return res1783_2923;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_box_set__o_cinfo3602_212_cfa_info(obj_t env_6820, obj_t o_6821, obj_t s_6822)
{
   {
      box_set__o_cinfo_6_t o_2908;
      obj_t s_2909;
      {
	 box_set__o_cinfo_6_t aux_8940;
	 o_2908 = (box_set__o_cinfo_6_t) (o_6821);
	 s_2909 = s_6822;
	 {
	    {
	       obj_t old1800_2912;
	       obj_t aux1801_2913;
	       {
		  obj_t next_method2294_122_2918;
		  next_method2294_122_2918 = find_super_class_method_167___object((object_t) (o_2908), struct_object__object_env_209___object, box_set__o_cinfo_6_cfa_info);
		  if (PROCEDUREP(next_method2294_122_2918))
		    {
		       old1800_2912 = PROCEDURE_ENTRY(next_method2294_122_2918) (next_method2294_122_2918, (obj_t) (o_2908), s_2909, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2294_122_2918);
		       {
			  object_t aux_8949;
			  aux_8949 = struct_object__object_93___object((object_t) (o_2908), s_2909);
			  old1800_2912 = (obj_t) (aux_8949);
		       }
		    }
	       }
	       aux1801_2913 = STRUCT_REF(s_2909, ((long) 0));
	       {
		  box_set__o_cinfo_6_t new1802_2914;
		  new1802_2914 = ((box_set__o_cinfo_6_t) (old1800_2912));
		  {
		     long arg2929_2915;
		     arg2929_2915 = class_num_218___object(box_set__o_cinfo_6_cfa_info);
		     {
			obj_t obj_5258;
			obj_5258 = (obj_t) (new1802_2914);
			(((obj_t) CREF(obj_5258))->header = MAKE_HEADER(arg2929_2915, 0), BUNSPEC);
		     }
		  }
		  {
		     box_set__o_cinfo_6_t arg2930_2916;
		     {
			box_set__o_cinfo_6_t res3515_5265;
			{
			   approx_t approx_5262;
			   {
			      obj_t aux_8958;
			      aux_8958 = STRUCT_REF(aux1801_2913, ((long) 0));
			      approx_5262 = (approx_t) (aux_8958);
			   }
			   {
			      box_set__o_cinfo_6_t new1789_5263;
			      new1789_5263 = ((box_set__o_cinfo_6_t) BREF(GC_MALLOC(sizeof(struct box_set__o_cinfo_6))));
			      ((((box_set__o_cinfo_6_t) CREF(new1789_5263))->approx) = ((approx_t) approx_5262), BUNSPEC);
			      res3515_5265 = new1789_5263;
			   }
			}
			arg2930_2916 = res3515_5265;
		     }
		     {
			obj_t aux_8965;
			object_t aux_8963;
			aux_8965 = (obj_t) (arg2930_2916);
			aux_8963 = (object_t) (new1802_2914);
			OBJECT_WIDENING_SET(aux_8963, aux_8965);
		     }
		  }
		  aux_8940 = new1802_2914;
	       }
	    }
	 }
	 return (obj_t) (aux_8940);
      }
   }
}


obj_t 
object__struct_box_set__o_cinfo3603_24_cfa_info(obj_t env_6823, obj_t obj1797_6824)
{
   {
      box_set__o_cinfo_6_t obj1797_2895;
      obj1797_2895 = (box_set__o_cinfo_6_t) (obj1797_6824);
      {
	 {
	    obj_t res1798_2898;
	    {
	       obj_t next_method2292_64_2906;
	       next_method2292_64_2906 = find_super_class_method_167___object((object_t) (obj1797_2895), object__struct_env_210___object, box_set__o_cinfo_6_cfa_info);
	       if (PROCEDUREP(next_method2292_64_2906))
		 {
		    res1798_2898 = PROCEDURE_ENTRY(next_method2292_64_2906) (next_method2292_64_2906, (obj_t) (obj1797_2895), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2292_64_2906);
		    res1798_2898 = object__struct_50___object((object_t) (obj1797_2895));
		 }
	    }
	    {
	       obj_t aux1799_2899;
	       {
		  obj_t aux_8980;
		  aux_8980 = CNST_TABLE_REF(((long) 28));
		  aux1799_2899 = make_struct(aux_8980, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_8983;
		  {
		     approx_t aux_8984;
		     {
			obj_t aux_8985;
			{
			   object_t aux_8986;
			   aux_8986 = (object_t) (obj1797_2895);
			   aux_8985 = OBJECT_WIDENING(aux_8986);
			}
			aux_8984 = (((box_set__o_cinfo_6_t) CREF(aux_8985))->approx);
		     }
		     aux_8983 = (obj_t) (aux_8984);
		  }
		  STRUCT_SET(aux1799_2899, ((long) 0), aux_8983);
	       }
	       STRUCT_SET(res1798_2898, ((long) 0), aux1799_2899);
	       {
		  obj_t aux_8993;
		  aux_8993 = STRUCT_KEY(res1798_2898);
		  STRUCT_KEY_SET(aux1799_2899, aux_8993);
	       }
	       {
		  obj_t aux_8996;
		  aux_8996 = CNST_TABLE_REF(((long) 28));
		  STRUCT_KEY_SET(res1798_2898, aux_8996);
	       }
	       return res1798_2898;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_box_ref_o_cinfo3604_201_cfa_info(obj_t env_6825, obj_t o_6826, obj_t s_6827)
{
   {
      box_ref_o_cinfo_98_t o_2883;
      obj_t s_2884;
      {
	 box_ref_o_cinfo_98_t aux_9000;
	 o_2883 = (box_ref_o_cinfo_98_t) (o_6826);
	 s_2884 = s_6827;
	 {
	    {
	       obj_t old1815_2887;
	       obj_t aux1816_2888;
	       {
		  obj_t next_method2290_72_2893;
		  next_method2290_72_2893 = find_super_class_method_167___object((object_t) (o_2883), struct_object__object_env_209___object, box_ref_o_cinfo_98_cfa_info);
		  if (PROCEDUREP(next_method2290_72_2893))
		    {
		       old1815_2887 = PROCEDURE_ENTRY(next_method2290_72_2893) (next_method2290_72_2893, (obj_t) (o_2883), s_2884, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2290_72_2893);
		       {
			  object_t aux_9009;
			  aux_9009 = struct_object__object_93___object((object_t) (o_2883), s_2884);
			  old1815_2887 = (obj_t) (aux_9009);
		       }
		    }
	       }
	       aux1816_2888 = STRUCT_REF(s_2884, ((long) 0));
	       {
		  box_ref_o_cinfo_98_t new1817_2889;
		  new1817_2889 = ((box_ref_o_cinfo_98_t) (old1815_2887));
		  {
		     long arg2918_2890;
		     arg2918_2890 = class_num_218___object(box_ref_o_cinfo_98_cfa_info);
		     {
			obj_t obj_5229;
			obj_5229 = (obj_t) (new1817_2889);
			(((obj_t) CREF(obj_5229))->header = MAKE_HEADER(arg2918_2890, 0), BUNSPEC);
		     }
		  }
		  {
		     box_ref_o_cinfo_98_t arg2919_2891;
		     {
			box_ref_o_cinfo_98_t res3514_5236;
			{
			   approx_t approx_5233;
			   {
			      obj_t aux_9018;
			      aux_9018 = STRUCT_REF(aux1816_2888, ((long) 0));
			      approx_5233 = (approx_t) (aux_9018);
			   }
			   {
			      box_ref_o_cinfo_98_t new1804_5234;
			      new1804_5234 = ((box_ref_o_cinfo_98_t) BREF(GC_MALLOC(sizeof(struct box_ref_o_cinfo_98))));
			      ((((box_ref_o_cinfo_98_t) CREF(new1804_5234))->approx) = ((approx_t) approx_5233), BUNSPEC);
			      res3514_5236 = new1804_5234;
			   }
			}
			arg2919_2891 = res3514_5236;
		     }
		     {
			obj_t aux_9025;
			object_t aux_9023;
			aux_9025 = (obj_t) (arg2919_2891);
			aux_9023 = (object_t) (new1817_2889);
			OBJECT_WIDENING_SET(aux_9023, aux_9025);
		     }
		  }
		  aux_9000 = new1817_2889;
	       }
	    }
	 }
	 return (obj_t) (aux_9000);
      }
   }
}


obj_t 
object__struct_box_ref_o_cinfo3605_141_cfa_info(obj_t env_6828, obj_t obj1812_6829)
{
   {
      box_ref_o_cinfo_98_t obj1812_2870;
      obj1812_2870 = (box_ref_o_cinfo_98_t) (obj1812_6829);
      {
	 {
	    obj_t res1813_2873;
	    {
	       obj_t next_method2288_132_2881;
	       next_method2288_132_2881 = find_super_class_method_167___object((object_t) (obj1812_2870), object__struct_env_210___object, box_ref_o_cinfo_98_cfa_info);
	       if (PROCEDUREP(next_method2288_132_2881))
		 {
		    res1813_2873 = PROCEDURE_ENTRY(next_method2288_132_2881) (next_method2288_132_2881, (obj_t) (obj1812_2870), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2288_132_2881);
		    res1813_2873 = object__struct_50___object((object_t) (obj1812_2870));
		 }
	    }
	    {
	       obj_t aux1814_2874;
	       {
		  obj_t aux_9040;
		  aux_9040 = CNST_TABLE_REF(((long) 29));
		  aux1814_2874 = make_struct(aux_9040, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_9043;
		  {
		     approx_t aux_9044;
		     {
			obj_t aux_9045;
			{
			   object_t aux_9046;
			   aux_9046 = (object_t) (obj1812_2870);
			   aux_9045 = OBJECT_WIDENING(aux_9046);
			}
			aux_9044 = (((box_ref_o_cinfo_98_t) CREF(aux_9045))->approx);
		     }
		     aux_9043 = (obj_t) (aux_9044);
		  }
		  STRUCT_SET(aux1814_2874, ((long) 0), aux_9043);
	       }
	       STRUCT_SET(res1813_2873, ((long) 0), aux1814_2874);
	       {
		  obj_t aux_9053;
		  aux_9053 = STRUCT_KEY(res1813_2873);
		  STRUCT_KEY_SET(aux1814_2874, aux_9053);
	       }
	       {
		  obj_t aux_9056;
		  aux_9056 = CNST_TABLE_REF(((long) 29));
		  STRUCT_KEY_SET(res1813_2873, aux_9056);
	       }
	       return res1813_2873;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_pre_make_procedure_app3606_172_cfa_info(obj_t env_6830, obj_t o_6831, obj_t s_6832)
{
   {
      pre_make_procedure_app_60_t o_2857;
      obj_t s_2858;
      {
	 pre_make_procedure_app_60_t aux_9060;
	 o_2857 = (pre_make_procedure_app_60_t) (o_6831);
	 s_2858 = s_6832;
	 {
	    {
	       obj_t old1833_2861;
	       obj_t aux1834_2862;
	       {
		  obj_t next_method2286_138_2868;
		  next_method2286_138_2868 = find_super_class_method_167___object((object_t) (o_2857), struct_object__object_env_209___object, pre_make_procedure_app_60_cfa_info);
		  if (PROCEDUREP(next_method2286_138_2868))
		    {
		       old1833_2861 = PROCEDURE_ENTRY(next_method2286_138_2868) (next_method2286_138_2868, (obj_t) (o_2857), s_2858, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2286_138_2868);
		       {
			  object_t aux_9069;
			  aux_9069 = struct_object__object_93___object((object_t) (o_2857), s_2858);
			  old1833_2861 = (obj_t) (aux_9069);
		       }
		    }
	       }
	       aux1834_2862 = STRUCT_REF(s_2858, ((long) 0));
	       {
		  pre_make_procedure_app_60_t new1835_2863;
		  new1835_2863 = ((pre_make_procedure_app_60_t) (old1833_2861));
		  {
		     long arg2906_2864;
		     arg2906_2864 = class_num_218___object(pre_make_procedure_app_60_cfa_info);
		     {
			obj_t obj_5196;
			obj_5196 = (obj_t) (new1835_2863);
			(((obj_t) CREF(obj_5196))->header = MAKE_HEADER(arg2906_2864, 0), BUNSPEC);
		     }
		  }
		  {
		     pre_make_procedure_app_60_t arg2907_2865;
		     {
			obj_t arg2909_2867;
			arg2909_2867 = STRUCT_REF(aux1834_2862, ((long) 1));
			{
			   pre_make_procedure_app_60_t res3513_5207;
			   {
			      variable_t owner_5202;
			      {
				 obj_t aux_9079;
				 aux_9079 = STRUCT_REF(aux1834_2862, ((long) 0));
				 owner_5202 = (variable_t) (aux_9079);
			      }
			      {
				 pre_make_procedure_app_60_t new1819_5204;
				 new1819_5204 = ((pre_make_procedure_app_60_t) BREF(GC_MALLOC(sizeof(struct pre_make_procedure_app_60))));
				 ((((pre_make_procedure_app_60_t) CREF(new1819_5204))->owner) = ((variable_t) owner_5202), BUNSPEC);
				 ((((pre_make_procedure_app_60_t) CREF(new1819_5204))->key) = ((obj_t) arg2909_2867), BUNSPEC);
				 res3513_5207 = new1819_5204;
			      }
			   }
			   arg2907_2865 = res3513_5207;
			}
		     }
		     {
			obj_t aux_9087;
			object_t aux_9085;
			aux_9087 = (obj_t) (arg2907_2865);
			aux_9085 = (object_t) (new1835_2863);
			OBJECT_WIDENING_SET(aux_9085, aux_9087);
		     }
		  }
		  aux_9060 = new1835_2863;
	       }
	    }
	 }
	 return (obj_t) (aux_9060);
      }
   }
}


obj_t 
object__struct_pre_make_procedure_app3607_226_cfa_info(obj_t env_6833, obj_t obj1830_6834)
{
   {
      pre_make_procedure_app_60_t obj1830_2842;
      obj1830_2842 = (pre_make_procedure_app_60_t) (obj1830_6834);
      {
	 {
	    obj_t res1831_2845;
	    {
	       obj_t next_method2284_125_2855;
	       next_method2284_125_2855 = find_super_class_method_167___object((object_t) (obj1830_2842), object__struct_env_210___object, pre_make_procedure_app_60_cfa_info);
	       if (PROCEDUREP(next_method2284_125_2855))
		 {
		    res1831_2845 = PROCEDURE_ENTRY(next_method2284_125_2855) (next_method2284_125_2855, (obj_t) (obj1830_2842), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2284_125_2855);
		    res1831_2845 = object__struct_50___object((object_t) (obj1830_2842));
		 }
	    }
	    {
	       obj_t aux1832_2846;
	       {
		  obj_t aux_9102;
		  aux_9102 = CNST_TABLE_REF(((long) 30));
		  aux1832_2846 = make_struct(aux_9102, ((long) 2), BUNSPEC);
	       }
	       {
		  obj_t aux_9105;
		  {
		     variable_t aux_9106;
		     {
			obj_t aux_9107;
			{
			   object_t aux_9108;
			   aux_9108 = (object_t) (obj1830_2842);
			   aux_9107 = OBJECT_WIDENING(aux_9108);
			}
			aux_9106 = (((pre_make_procedure_app_60_t) CREF(aux_9107))->owner);
		     }
		     aux_9105 = (obj_t) (aux_9106);
		  }
		  STRUCT_SET(aux1832_2846, ((long) 0), aux_9105);
	       }
	       {
		  obj_t aux_9114;
		  {
		     obj_t aux_9115;
		     {
			object_t aux_9116;
			aux_9116 = (object_t) (obj1830_2842);
			aux_9115 = OBJECT_WIDENING(aux_9116);
		     }
		     aux_9114 = (((pre_make_procedure_app_60_t) CREF(aux_9115))->key);
		  }
		  STRUCT_SET(aux1832_2846, ((long) 1), aux_9114);
	       }
	       STRUCT_SET(res1831_2845, ((long) 0), aux1832_2846);
	       {
		  obj_t aux_9122;
		  aux_9122 = STRUCT_KEY(res1831_2845);
		  STRUCT_KEY_SET(aux1832_2846, aux_9122);
	       }
	       {
		  obj_t aux_9125;
		  aux_9125 = CNST_TABLE_REF(((long) 30));
		  STRUCT_KEY_SET(res1831_2845, aux_9125);
	       }
	       return res1831_2845;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_pre_procedure_ref_app3608_142_cfa_info(obj_t env_6835, obj_t o_6836, obj_t s_6837)
{
   {
      pre_procedure_ref_app_85_t o_2831;
      obj_t s_2832;
      {
	 pre_procedure_ref_app_85_t aux_9129;
	 o_2831 = (pre_procedure_ref_app_85_t) (o_6836);
	 s_2832 = s_6837;
	 {
	    {
	       obj_t old1850_2835;
	       {
		  obj_t next_method2282_27_2840;
		  next_method2282_27_2840 = find_super_class_method_167___object((object_t) (o_2831), struct_object__object_env_209___object, pre_procedure_ref_app_85_cfa_info);
		  if (PROCEDUREP(next_method2282_27_2840))
		    {
		       old1850_2835 = PROCEDURE_ENTRY(next_method2282_27_2840) (next_method2282_27_2840, (obj_t) (o_2831), s_2832, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2282_27_2840);
		       {
			  object_t aux_9138;
			  aux_9138 = struct_object__object_93___object((object_t) (o_2831), s_2832);
			  old1850_2835 = (obj_t) (aux_9138);
		       }
		    }
	       }
	       {
		  pre_procedure_ref_app_85_t new1852_2837;
		  new1852_2837 = ((pre_procedure_ref_app_85_t) (old1850_2835));
		  {
		     long arg2894_2838;
		     arg2894_2838 = class_num_218___object(pre_procedure_ref_app_85_cfa_info);
		     {
			obj_t obj_5167;
			obj_5167 = (obj_t) (new1852_2837);
			(((obj_t) CREF(obj_5167))->header = MAKE_HEADER(arg2894_2838, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_9148;
		     object_t aux_9146;
		     {
			pre_procedure_ref_app_85_t aux_9149;
			{
			   aux_9149 = ((pre_procedure_ref_app_85_t) BREF(GC_MALLOC(sizeof(struct pre_procedure_ref_app_85))));
			}
			aux_9148 = (obj_t) (aux_9149);
		     }
		     aux_9146 = (object_t) (new1852_2837);
		     OBJECT_WIDENING_SET(aux_9146, aux_9148);
		  }
		  aux_9129 = new1852_2837;
	       }
	    }
	 }
	 return (obj_t) (aux_9129);
      }
   }
}


obj_t 
object__struct_pre_procedure_ref_app3609_217_cfa_info(obj_t env_6838, obj_t obj1847_6839)
{
   {
      pre_procedure_ref_app_85_t obj1847_2820;
      obj1847_2820 = (pre_procedure_ref_app_85_t) (obj1847_6839);
      {
	 {
	    obj_t res1848_2823;
	    {
	       obj_t next_method2280_140_2829;
	       next_method2280_140_2829 = find_super_class_method_167___object((object_t) (obj1847_2820), object__struct_env_210___object, pre_procedure_ref_app_85_cfa_info);
	       if (PROCEDUREP(next_method2280_140_2829))
		 {
		    res1848_2823 = PROCEDURE_ENTRY(next_method2280_140_2829) (next_method2280_140_2829, (obj_t) (obj1847_2820), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2280_140_2829);
		    res1848_2823 = object__struct_50___object((object_t) (obj1847_2820));
		 }
	    }
	    {
	       obj_t aux1849_2824;
	       {
		  obj_t aux_9165;
		  aux_9165 = CNST_TABLE_REF(((long) 31));
		  aux1849_2824 = make_struct(aux_9165, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res1848_2823, ((long) 0), aux1849_2824);
	       {
		  obj_t aux_9169;
		  aux_9169 = STRUCT_KEY(res1848_2823);
		  STRUCT_KEY_SET(aux1849_2824, aux_9169);
	       }
	       {
		  obj_t aux_9172;
		  aux_9172 = CNST_TABLE_REF(((long) 31));
		  STRUCT_KEY_SET(res1848_2823, aux_9172);
	       }
	       return res1848_2823;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_pre_procedure_set__app3610_224_cfa_info(obj_t env_6840, obj_t o_6841, obj_t s_6842)
{
   {
      pre_procedure_set__app_208_t o_2809;
      obj_t s_2810;
      {
	 pre_procedure_set__app_208_t aux_9176;
	 o_2809 = (pre_procedure_set__app_208_t) (o_6841);
	 s_2810 = s_6842;
	 {
	    {
	       obj_t old1868_2813;
	       {
		  obj_t next_method2278_184_2818;
		  next_method2278_184_2818 = find_super_class_method_167___object((object_t) (o_2809), struct_object__object_env_209___object, pre_procedure_set__app_208_cfa_info);
		  if (PROCEDUREP(next_method2278_184_2818))
		    {
		       old1868_2813 = PROCEDURE_ENTRY(next_method2278_184_2818) (next_method2278_184_2818, (obj_t) (o_2809), s_2810, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2278_184_2818);
		       {
			  object_t aux_9185;
			  aux_9185 = struct_object__object_93___object((object_t) (o_2809), s_2810);
			  old1868_2813 = (obj_t) (aux_9185);
		       }
		    }
	       }
	       {
		  pre_procedure_set__app_208_t new1870_2815;
		  new1870_2815 = ((pre_procedure_set__app_208_t) (old1868_2813));
		  {
		     long arg2886_2816;
		     arg2886_2816 = class_num_218___object(pre_procedure_set__app_208_cfa_info);
		     {
			obj_t obj_5146;
			obj_5146 = (obj_t) (new1870_2815);
			(((obj_t) CREF(obj_5146))->header = MAKE_HEADER(arg2886_2816, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_9195;
		     object_t aux_9193;
		     {
			pre_procedure_set__app_208_t aux_9196;
			{
			   aux_9196 = ((pre_procedure_set__app_208_t) BREF(GC_MALLOC(sizeof(struct pre_procedure_set__app_208))));
			}
			aux_9195 = (obj_t) (aux_9196);
		     }
		     aux_9193 = (object_t) (new1870_2815);
		     OBJECT_WIDENING_SET(aux_9193, aux_9195);
		  }
		  aux_9176 = new1870_2815;
	       }
	    }
	 }
	 return (obj_t) (aux_9176);
      }
   }
}


obj_t 
object__struct_pre_procedure_set__app3611_110_cfa_info(obj_t env_6843, obj_t obj1865_6844)
{
   {
      pre_procedure_set__app_208_t obj1865_2798;
      obj1865_2798 = (pre_procedure_set__app_208_t) (obj1865_6844);
      {
	 {
	    obj_t res1866_2801;
	    {
	       obj_t next_method2276_38_2807;
	       next_method2276_38_2807 = find_super_class_method_167___object((object_t) (obj1865_2798), object__struct_env_210___object, pre_procedure_set__app_208_cfa_info);
	       if (PROCEDUREP(next_method2276_38_2807))
		 {
		    res1866_2801 = PROCEDURE_ENTRY(next_method2276_38_2807) (next_method2276_38_2807, (obj_t) (obj1865_2798), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2276_38_2807);
		    res1866_2801 = object__struct_50___object((object_t) (obj1865_2798));
		 }
	    }
	    {
	       obj_t aux1867_2802;
	       {
		  obj_t aux_9212;
		  aux_9212 = CNST_TABLE_REF(((long) 32));
		  aux1867_2802 = make_struct(aux_9212, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res1866_2801, ((long) 0), aux1867_2802);
	       {
		  obj_t aux_9216;
		  aux_9216 = STRUCT_KEY(res1866_2801);
		  STRUCT_KEY_SET(aux1867_2802, aux_9216);
	       }
	       {
		  obj_t aux_9219;
		  aux_9219 = CNST_TABLE_REF(((long) 32));
		  STRUCT_KEY_SET(res1866_2801, aux_9219);
	       }
	       return res1866_2801;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_make_procedure_app3612_96_cfa_info(obj_t env_6845, obj_t o_6846, obj_t s_6847)
{
   {
      make_procedure_app_48_t o_2776;
      obj_t s_2777;
      {
	 make_procedure_app_48_t aux_9223;
	 o_2776 = (make_procedure_app_48_t) (o_6846);
	 s_2777 = s_6847;
	 {
	    {
	       obj_t old1897_2780;
	       obj_t aux1898_2781;
	       {
		  obj_t next_method2274_149_2796;
		  next_method2274_149_2796 = find_super_class_method_167___object((object_t) (o_2776), struct_object__object_env_209___object, make_procedure_app_48_cfa_info);
		  if (PROCEDUREP(next_method2274_149_2796))
		    {
		       old1897_2780 = PROCEDURE_ENTRY(next_method2274_149_2796) (next_method2274_149_2796, (obj_t) (o_2776), s_2777, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2274_149_2796);
		       {
			  object_t aux_9232;
			  aux_9232 = struct_object__object_93___object((object_t) (o_2776), s_2777);
			  old1897_2780 = (obj_t) (aux_9232);
		       }
		    }
	       }
	       aux1898_2781 = STRUCT_REF(s_2777, ((long) 0));
	       {
		  make_procedure_app_48_t new1899_2782;
		  new1899_2782 = ((make_procedure_app_48_t) (old1897_2780));
		  {
		     long arg2867_2783;
		     arg2867_2783 = class_num_218___object(make_procedure_app_48_cfa_info);
		     {
			obj_t obj_5073;
			obj_5073 = (obj_t) (new1899_2782);
			(((obj_t) CREF(obj_5073))->header = MAKE_HEADER(arg2867_2783, 0), BUNSPEC);
		     }
		  }
		  {
		     make_procedure_app_48_t arg2868_2784;
		     {
			obj_t arg2869_2785;
			obj_t arg2879_2795;
			arg2869_2785 = STRUCT_REF(aux1898_2781, ((long) 0));
			arg2879_2795 = STRUCT_REF(aux1898_2781, ((long) 10));
			{
			   make_procedure_app_48_t res3510_5128;
			   {
			      approx_t approx_5098;
			      long values_approx_len_106_5099;
			      approx_t values_approx_79_5100;
			      long lost_stamp_114_5101;
			      bool_t x_t__142_5102;
			      bool_t x_5103;
			      bool_t t_5104;
			      variable_t owner_5105;
			      bool_t stackable__42_5106;
			      {
				 obj_t aux_9243;
				 aux_9243 = STRUCT_REF(aux1898_2781, ((long) 1));
				 approx_5098 = (approx_t) (aux_9243);
			      }
			      {
				 obj_t aux_9246;
				 aux_9246 = STRUCT_REF(aux1898_2781, ((long) 2));
				 values_approx_len_106_5099 = (long) CINT(aux_9246);
			      }
			      {
				 obj_t aux_9249;
				 aux_9249 = STRUCT_REF(aux1898_2781, ((long) 3));
				 values_approx_79_5100 = (approx_t) (aux_9249);
			      }
			      {
				 obj_t aux_9252;
				 aux_9252 = STRUCT_REF(aux1898_2781, ((long) 4));
				 lost_stamp_114_5101 = (long) CINT(aux_9252);
			      }
			      {
				 obj_t aux_9255;
				 aux_9255 = STRUCT_REF(aux1898_2781, ((long) 5));
				 x_t__142_5102 = CBOOL(aux_9255);
			      }
			      {
				 obj_t aux_9258;
				 aux_9258 = STRUCT_REF(aux1898_2781, ((long) 6));
				 x_5103 = CBOOL(aux_9258);
			      }
			      {
				 obj_t aux_9261;
				 aux_9261 = STRUCT_REF(aux1898_2781, ((long) 7));
				 t_5104 = CBOOL(aux_9261);
			      }
			      {
				 obj_t aux_9264;
				 aux_9264 = STRUCT_REF(aux1898_2781, ((long) 8));
				 owner_5105 = (variable_t) (aux_9264);
			      }
			      {
				 obj_t aux_9267;
				 aux_9267 = STRUCT_REF(aux1898_2781, ((long) 9));
				 stackable__42_5106 = CBOOL(aux_9267);
			      }
			      {
				 make_procedure_app_48_t new1872_5108;
				 new1872_5108 = ((make_procedure_app_48_t) BREF(GC_MALLOC(sizeof(struct make_procedure_app_48))));
				 ((((make_procedure_app_48_t) CREF(new1872_5108))->key) = ((obj_t) arg2869_2785), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new1872_5108))->approx) = ((approx_t) approx_5098), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new1872_5108))->values_approx_len_106) = ((long) values_approx_len_106_5099), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new1872_5108))->values_approx_79) = ((approx_t *) GC_MALLOC(sizeof(struct approx) * values_approx_len_106_5099)), BUNSPEC);
				 {
				    long i1873_5121;
				    i1873_5121 = ((long) 0);
				  loop1871_5120:
				    if ((i1873_5121 == values_approx_len_106_5099))
				      {
					 CNST_TABLE_REF(((long) 50));
				      }
				    else
				      {
					 ((((make_procedure_app_48_t) CREF(new1872_5108))->values_approx_79)[i1873_5121] = ((approx_t) values_approx_79_5100), BUNSPEC);
					 {
					    long i1873_9280;
					    i1873_9280 = (i1873_5121 + ((long) 1));
					    i1873_5121 = i1873_9280;
					    goto loop1871_5120;
					 }
				      }
				 }
				 ((((make_procedure_app_48_t) CREF(new1872_5108))->lost_stamp_114) = ((long) lost_stamp_114_5101), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new1872_5108))->x_t__142) = ((bool_t) x_t__142_5102), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new1872_5108))->x) = ((bool_t) x_5103), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new1872_5108))->t) = ((bool_t) t_5104), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new1872_5108))->owner) = ((variable_t) owner_5105), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new1872_5108))->stackable__42) = ((bool_t) stackable__42_5106), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new1872_5108))->stack_stamp_31) = ((obj_t) arg2879_2795), BUNSPEC);
				 res3510_5128 = new1872_5108;
			      }
			   }
			   arg2868_2784 = res3510_5128;
			}
		     }
		     {
			obj_t aux_9291;
			object_t aux_9289;
			aux_9291 = (obj_t) (arg2868_2784);
			aux_9289 = (object_t) (new1899_2782);
			OBJECT_WIDENING_SET(aux_9289, aux_9291);
		     }
		  }
		  aux_9223 = new1899_2782;
	       }
	    }
	 }
	 return (obj_t) (aux_9223);
      }
   }
}


obj_t 
object__struct_make_procedure_app3613_201_cfa_info(obj_t env_6848, obj_t obj1890_6849)
{
   {
      make_procedure_app_48_t obj1890_2737;
      obj1890_2737 = (make_procedure_app_48_t) (obj1890_6849);
      {
	 {
	    obj_t res1891_2740;
	    {
	       obj_t next_method2272_0_2774;
	       next_method2272_0_2774 = find_super_class_method_167___object((object_t) (obj1890_2737), object__struct_env_210___object, make_procedure_app_48_cfa_info);
	       if (PROCEDUREP(next_method2272_0_2774))
		 {
		    res1891_2740 = PROCEDURE_ENTRY(next_method2272_0_2774) (next_method2272_0_2774, (obj_t) (obj1890_2737), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2272_0_2774);
		    res1891_2740 = object__struct_50___object((object_t) (obj1890_2737));
		 }
	    }
	    {
	       obj_t aux1892_2741;
	       {
		  obj_t aux_9306;
		  aux_9306 = CNST_TABLE_REF(((long) 33));
		  aux1892_2741 = make_struct(aux_9306, ((long) 11), BUNSPEC);
	       }
	       {
		  obj_t aux_9309;
		  {
		     obj_t aux_9310;
		     {
			object_t aux_9311;
			aux_9311 = (object_t) (obj1890_2737);
			aux_9310 = OBJECT_WIDENING(aux_9311);
		     }
		     aux_9309 = (((make_procedure_app_48_t) CREF(aux_9310))->key);
		  }
		  STRUCT_SET(aux1892_2741, ((long) 0), aux_9309);
	       }
	       {
		  obj_t aux_9316;
		  {
		     approx_t aux_9317;
		     {
			obj_t aux_9318;
			{
			   object_t aux_9319;
			   aux_9319 = (object_t) (obj1890_2737);
			   aux_9318 = OBJECT_WIDENING(aux_9319);
			}
			aux_9317 = (((make_procedure_app_48_t) CREF(aux_9318))->approx);
		     }
		     aux_9316 = (obj_t) (aux_9317);
		  }
		  STRUCT_SET(aux1892_2741, ((long) 1), aux_9316);
	       }
	       {
		  obj_t aux_9325;
		  {
		     long aux_9326;
		     {
			obj_t aux_9327;
			{
			   object_t aux_9328;
			   aux_9328 = (object_t) (obj1890_2737);
			   aux_9327 = OBJECT_WIDENING(aux_9328);
			}
			aux_9326 = (((make_procedure_app_48_t) CREF(aux_9327))->values_approx_len_106);
		     }
		     aux_9325 = BINT(aux_9326);
		  }
		  STRUCT_SET(aux1892_2741, ((long) 2), aux_9325);
	       }
	       {
		  long len1896_2748;
		  {
		     obj_t aux_9334;
		     {
			object_t aux_9335;
			aux_9335 = (object_t) (obj1890_2737);
			aux_9334 = OBJECT_WIDENING(aux_9335);
		     }
		     len1896_2748 = (((make_procedure_app_48_t) CREF(aux_9334))->values_approx_len_106);
		  }
		  {
		     obj_t vec1893_2749;
		     vec1893_2749 = make_vector(len1896_2748, BUNSPEC);
		     {
			long j1894_2750;
			j1894_2750 = ((long) 0);
		      loop1895_2751:
			if ((j1894_2750 == len1896_2748))
			  {
			     obj_t x_6981;
			     x_6981 = STRUCT_SET(aux1892_2741, ((long) 3), vec1893_2749);
			     BUNSPEC;
			  }
			else
			  {
			     {
				obj_t aux_9343;
				{
				   approx_t aux_9344;
				   {
				      obj_t aux_9345;
				      {
					 object_t aux_9346;
					 aux_9346 = (object_t) (obj1890_2737);
					 aux_9345 = OBJECT_WIDENING(aux_9346);
				      }
				      aux_9344 = (((make_procedure_app_48_t) CREF(aux_9345))->values_approx_79)[j1894_2750];
				   }
				   aux_9343 = (obj_t) (aux_9344);
				}
				VECTOR_SET(vec1893_2749, j1894_2750, aux_9343);
			     }
			     {
				long j1894_9352;
				j1894_9352 = (j1894_2750 + ((long) 1));
				j1894_2750 = j1894_9352;
				goto loop1895_2751;
			     }
			  }
		     }
		  }
	       }
	       {
		  obj_t aux_9354;
		  {
		     long aux_9355;
		     {
			obj_t aux_9356;
			{
			   object_t aux_9357;
			   aux_9357 = (object_t) (obj1890_2737);
			   aux_9356 = OBJECT_WIDENING(aux_9357);
			}
			aux_9355 = (((make_procedure_app_48_t) CREF(aux_9356))->lost_stamp_114);
		     }
		     aux_9354 = BINT(aux_9355);
		  }
		  STRUCT_SET(aux1892_2741, ((long) 4), aux_9354);
	       }
	       {
		  obj_t aux_9363;
		  {
		     bool_t aux_9364;
		     {
			obj_t aux_9365;
			{
			   object_t aux_9366;
			   aux_9366 = (object_t) (obj1890_2737);
			   aux_9365 = OBJECT_WIDENING(aux_9366);
			}
			aux_9364 = (((make_procedure_app_48_t) CREF(aux_9365))->x_t__142);
		     }
		     aux_9363 = BBOOL(aux_9364);
		  }
		  STRUCT_SET(aux1892_2741, ((long) 5), aux_9363);
	       }
	       {
		  obj_t aux_9372;
		  {
		     bool_t aux_9373;
		     {
			obj_t aux_9374;
			{
			   object_t aux_9375;
			   aux_9375 = (object_t) (obj1890_2737);
			   aux_9374 = OBJECT_WIDENING(aux_9375);
			}
			aux_9373 = (((make_procedure_app_48_t) CREF(aux_9374))->x);
		     }
		     aux_9372 = BBOOL(aux_9373);
		  }
		  STRUCT_SET(aux1892_2741, ((long) 6), aux_9372);
	       }
	       {
		  obj_t aux_9381;
		  {
		     bool_t aux_9382;
		     {
			obj_t aux_9383;
			{
			   object_t aux_9384;
			   aux_9384 = (object_t) (obj1890_2737);
			   aux_9383 = OBJECT_WIDENING(aux_9384);
			}
			aux_9382 = (((make_procedure_app_48_t) CREF(aux_9383))->t);
		     }
		     aux_9381 = BBOOL(aux_9382);
		  }
		  STRUCT_SET(aux1892_2741, ((long) 7), aux_9381);
	       }
	       {
		  obj_t aux_9390;
		  {
		     variable_t aux_9391;
		     {
			obj_t aux_9392;
			{
			   object_t aux_9393;
			   aux_9393 = (object_t) (obj1890_2737);
			   aux_9392 = OBJECT_WIDENING(aux_9393);
			}
			aux_9391 = (((make_procedure_app_48_t) CREF(aux_9392))->owner);
		     }
		     aux_9390 = (obj_t) (aux_9391);
		  }
		  STRUCT_SET(aux1892_2741, ((long) 8), aux_9390);
	       }
	       {
		  obj_t aux_9399;
		  {
		     bool_t aux_9400;
		     {
			obj_t aux_9401;
			{
			   object_t aux_9402;
			   aux_9402 = (object_t) (obj1890_2737);
			   aux_9401 = OBJECT_WIDENING(aux_9402);
			}
			aux_9400 = (((make_procedure_app_48_t) CREF(aux_9401))->stackable__42);
		     }
		     aux_9399 = BBOOL(aux_9400);
		  }
		  STRUCT_SET(aux1892_2741, ((long) 9), aux_9399);
	       }
	       {
		  obj_t aux_9408;
		  {
		     obj_t aux_9409;
		     {
			object_t aux_9410;
			aux_9410 = (object_t) (obj1890_2737);
			aux_9409 = OBJECT_WIDENING(aux_9410);
		     }
		     aux_9408 = (((make_procedure_app_48_t) CREF(aux_9409))->stack_stamp_31);
		  }
		  STRUCT_SET(aux1892_2741, ((long) 10), aux_9408);
	       }
	       STRUCT_SET(res1891_2740, ((long) 0), aux1892_2741);
	       {
		  obj_t aux_9416;
		  aux_9416 = STRUCT_KEY(res1891_2740);
		  STRUCT_KEY_SET(aux1892_2741, aux_9416);
	       }
	       {
		  obj_t aux_9419;
		  aux_9419 = CNST_TABLE_REF(((long) 33));
		  STRUCT_KEY_SET(res1891_2740, aux_9419);
	       }
	       return res1891_2740;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_procedure_ref_app3614_131_cfa_info(obj_t env_6850, obj_t o_6851, obj_t s_6852)
{
   {
      procedure_ref_app_49_t o_2725;
      obj_t s_2726;
      {
	 procedure_ref_app_49_t aux_9423;
	 o_2725 = (procedure_ref_app_49_t) (o_6851);
	 s_2726 = s_6852;
	 {
	    {
	       obj_t old1914_2729;
	       obj_t aux1915_2730;
	       {
		  obj_t next_method2270_52_2735;
		  next_method2270_52_2735 = find_super_class_method_167___object((object_t) (o_2725), struct_object__object_env_209___object, procedure_ref_app_49_cfa_info);
		  if (PROCEDUREP(next_method2270_52_2735))
		    {
		       old1914_2729 = PROCEDURE_ENTRY(next_method2270_52_2735) (next_method2270_52_2735, (obj_t) (o_2725), s_2726, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2270_52_2735);
		       {
			  object_t aux_9432;
			  aux_9432 = struct_object__object_93___object((object_t) (o_2725), s_2726);
			  old1914_2729 = (obj_t) (aux_9432);
		       }
		    }
	       }
	       aux1915_2730 = STRUCT_REF(s_2726, ((long) 0));
	       {
		  procedure_ref_app_49_t new1916_2731;
		  new1916_2731 = ((procedure_ref_app_49_t) (old1914_2729));
		  {
		     long arg2834_2732;
		     arg2834_2732 = class_num_218___object(procedure_ref_app_49_cfa_info);
		     {
			obj_t obj_4994;
			obj_4994 = (obj_t) (new1916_2731);
			(((obj_t) CREF(obj_4994))->header = MAKE_HEADER(arg2834_2732, 0), BUNSPEC);
		     }
		  }
		  {
		     procedure_ref_app_49_t arg2835_2733;
		     {
			procedure_ref_app_49_t res3508_5001;
			{
			   approx_t approx_4998;
			   {
			      obj_t aux_9441;
			      aux_9441 = STRUCT_REF(aux1915_2730, ((long) 0));
			      approx_4998 = (approx_t) (aux_9441);
			   }
			   {
			      procedure_ref_app_49_t new1901_4999;
			      new1901_4999 = ((procedure_ref_app_49_t) BREF(GC_MALLOC(sizeof(struct procedure_ref_app_49))));
			      ((((procedure_ref_app_49_t) CREF(new1901_4999))->approx) = ((approx_t) approx_4998), BUNSPEC);
			      res3508_5001 = new1901_4999;
			   }
			}
			arg2835_2733 = res3508_5001;
		     }
		     {
			obj_t aux_9448;
			object_t aux_9446;
			aux_9448 = (obj_t) (arg2835_2733);
			aux_9446 = (object_t) (new1916_2731);
			OBJECT_WIDENING_SET(aux_9446, aux_9448);
		     }
		  }
		  aux_9423 = new1916_2731;
	       }
	    }
	 }
	 return (obj_t) (aux_9423);
      }
   }
}


obj_t 
object__struct_procedure_ref_app3615_121_cfa_info(obj_t env_6853, obj_t obj1911_6854)
{
   {
      procedure_ref_app_49_t obj1911_2712;
      obj1911_2712 = (procedure_ref_app_49_t) (obj1911_6854);
      {
	 {
	    obj_t res1912_2715;
	    {
	       obj_t next_method2268_74_2723;
	       next_method2268_74_2723 = find_super_class_method_167___object((object_t) (obj1911_2712), object__struct_env_210___object, procedure_ref_app_49_cfa_info);
	       if (PROCEDUREP(next_method2268_74_2723))
		 {
		    res1912_2715 = PROCEDURE_ENTRY(next_method2268_74_2723) (next_method2268_74_2723, (obj_t) (obj1911_2712), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2268_74_2723);
		    res1912_2715 = object__struct_50___object((object_t) (obj1911_2712));
		 }
	    }
	    {
	       obj_t aux1913_2716;
	       {
		  obj_t aux_9463;
		  aux_9463 = CNST_TABLE_REF(((long) 34));
		  aux1913_2716 = make_struct(aux_9463, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_9466;
		  {
		     approx_t aux_9467;
		     {
			obj_t aux_9468;
			{
			   object_t aux_9469;
			   aux_9469 = (object_t) (obj1911_2712);
			   aux_9468 = OBJECT_WIDENING(aux_9469);
			}
			aux_9467 = (((procedure_ref_app_49_t) CREF(aux_9468))->approx);
		     }
		     aux_9466 = (obj_t) (aux_9467);
		  }
		  STRUCT_SET(aux1913_2716, ((long) 0), aux_9466);
	       }
	       STRUCT_SET(res1912_2715, ((long) 0), aux1913_2716);
	       {
		  obj_t aux_9476;
		  aux_9476 = STRUCT_KEY(res1912_2715);
		  STRUCT_KEY_SET(aux1913_2716, aux_9476);
	       }
	       {
		  obj_t aux_9479;
		  aux_9479 = CNST_TABLE_REF(((long) 34));
		  STRUCT_KEY_SET(res1912_2715, aux_9479);
	       }
	       return res1912_2715;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_procedure_set__app3616_107_cfa_info(obj_t env_6855, obj_t o_6856, obj_t s_6857)
{
   {
      procedure_set__app_32_t o_2700;
      obj_t s_2701;
      {
	 procedure_set__app_32_t aux_9483;
	 o_2700 = (procedure_set__app_32_t) (o_6856);
	 s_2701 = s_6857;
	 {
	    {
	       obj_t old1932_2704;
	       obj_t aux1933_2705;
	       {
		  obj_t next_method2266_126_2710;
		  next_method2266_126_2710 = find_super_class_method_167___object((object_t) (o_2700), struct_object__object_env_209___object, procedure_set__app_32_cfa_info);
		  if (PROCEDUREP(next_method2266_126_2710))
		    {
		       old1932_2704 = PROCEDURE_ENTRY(next_method2266_126_2710) (next_method2266_126_2710, (obj_t) (o_2700), s_2701, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2266_126_2710);
		       {
			  object_t aux_9492;
			  aux_9492 = struct_object__object_93___object((object_t) (o_2700), s_2701);
			  old1932_2704 = (obj_t) (aux_9492);
		       }
		    }
	       }
	       aux1933_2705 = STRUCT_REF(s_2701, ((long) 0));
	       {
		  procedure_set__app_32_t new1934_2706;
		  new1934_2706 = ((procedure_set__app_32_t) (old1932_2704));
		  {
		     long arg2823_2707;
		     arg2823_2707 = class_num_218___object(procedure_set__app_32_cfa_info);
		     {
			obj_t obj_4965;
			obj_4965 = (obj_t) (new1934_2706);
			(((obj_t) CREF(obj_4965))->header = MAKE_HEADER(arg2823_2707, 0), BUNSPEC);
		     }
		  }
		  {
		     procedure_set__app_32_t arg2824_2708;
		     {
			procedure_set__app_32_t res3507_4972;
			{
			   approx_t approx_4969;
			   {
			      obj_t aux_9501;
			      aux_9501 = STRUCT_REF(aux1933_2705, ((long) 0));
			      approx_4969 = (approx_t) (aux_9501);
			   }
			   {
			      procedure_set__app_32_t new1918_4970;
			      new1918_4970 = ((procedure_set__app_32_t) BREF(GC_MALLOC(sizeof(struct procedure_set__app_32))));
			      ((((procedure_set__app_32_t) CREF(new1918_4970))->approx) = ((approx_t) approx_4969), BUNSPEC);
			      res3507_4972 = new1918_4970;
			   }
			}
			arg2824_2708 = res3507_4972;
		     }
		     {
			obj_t aux_9508;
			object_t aux_9506;
			aux_9508 = (obj_t) (arg2824_2708);
			aux_9506 = (object_t) (new1934_2706);
			OBJECT_WIDENING_SET(aux_9506, aux_9508);
		     }
		  }
		  aux_9483 = new1934_2706;
	       }
	    }
	 }
	 return (obj_t) (aux_9483);
      }
   }
}


obj_t 
object__struct_procedure_set__app3617_101_cfa_info(obj_t env_6858, obj_t obj1929_6859)
{
   {
      procedure_set__app_32_t obj1929_2687;
      obj1929_2687 = (procedure_set__app_32_t) (obj1929_6859);
      {
	 {
	    obj_t res1930_2690;
	    {
	       obj_t next_method2264_5_2698;
	       next_method2264_5_2698 = find_super_class_method_167___object((object_t) (obj1929_2687), object__struct_env_210___object, procedure_set__app_32_cfa_info);
	       if (PROCEDUREP(next_method2264_5_2698))
		 {
		    res1930_2690 = PROCEDURE_ENTRY(next_method2264_5_2698) (next_method2264_5_2698, (obj_t) (obj1929_2687), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2264_5_2698);
		    res1930_2690 = object__struct_50___object((object_t) (obj1929_2687));
		 }
	    }
	    {
	       obj_t aux1931_2691;
	       {
		  obj_t aux_9523;
		  aux_9523 = CNST_TABLE_REF(((long) 35));
		  aux1931_2691 = make_struct(aux_9523, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_9526;
		  {
		     approx_t aux_9527;
		     {
			obj_t aux_9528;
			{
			   object_t aux_9529;
			   aux_9529 = (object_t) (obj1929_2687);
			   aux_9528 = OBJECT_WIDENING(aux_9529);
			}
			aux_9527 = (((procedure_set__app_32_t) CREF(aux_9528))->approx);
		     }
		     aux_9526 = (obj_t) (aux_9527);
		  }
		  STRUCT_SET(aux1931_2691, ((long) 0), aux_9526);
	       }
	       STRUCT_SET(res1930_2690, ((long) 0), aux1931_2691);
	       {
		  obj_t aux_9536;
		  aux_9536 = STRUCT_KEY(res1930_2690);
		  STRUCT_KEY_SET(aux1931_2691, aux_9536);
	       }
	       {
		  obj_t aux_9539;
		  aux_9539 = CNST_TABLE_REF(((long) 35));
		  STRUCT_KEY_SET(res1930_2690, aux_9539);
	       }
	       return res1930_2690;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_pre_make_vector_app3618_161_cfa_info(obj_t env_6860, obj_t o_6861, obj_t s_6862)
{
   {
      pre_make_vector_app_251_t o_2674;
      obj_t s_2675;
      {
	 pre_make_vector_app_251_t aux_9543;
	 o_2674 = (pre_make_vector_app_251_t) (o_6861);
	 s_2675 = s_6862;
	 {
	    {
	       obj_t old1950_2678;
	       obj_t aux1951_2679;
	       {
		  obj_t next_method2262_101_2685;
		  next_method2262_101_2685 = find_super_class_method_167___object((object_t) (o_2674), struct_object__object_env_209___object, pre_make_vector_app_251_cfa_info);
		  if (PROCEDUREP(next_method2262_101_2685))
		    {
		       old1950_2678 = PROCEDURE_ENTRY(next_method2262_101_2685) (next_method2262_101_2685, (obj_t) (o_2674), s_2675, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2262_101_2685);
		       {
			  object_t aux_9552;
			  aux_9552 = struct_object__object_93___object((object_t) (o_2674), s_2675);
			  old1950_2678 = (obj_t) (aux_9552);
		       }
		    }
	       }
	       aux1951_2679 = STRUCT_REF(s_2675, ((long) 0));
	       {
		  pre_make_vector_app_251_t new1952_2680;
		  new1952_2680 = ((pre_make_vector_app_251_t) (old1950_2678));
		  {
		     long arg2811_2681;
		     arg2811_2681 = class_num_218___object(pre_make_vector_app_251_cfa_info);
		     {
			obj_t obj_4932;
			obj_4932 = (obj_t) (new1952_2680);
			(((obj_t) CREF(obj_4932))->header = MAKE_HEADER(arg2811_2681, 0), BUNSPEC);
		     }
		  }
		  {
		     pre_make_vector_app_251_t arg2812_2682;
		     {
			obj_t arg2814_2684;
			arg2814_2684 = STRUCT_REF(aux1951_2679, ((long) 1));
			{
			   pre_make_vector_app_251_t res3506_4943;
			   {
			      variable_t owner_4938;
			      {
				 obj_t aux_9562;
				 aux_9562 = STRUCT_REF(aux1951_2679, ((long) 0));
				 owner_4938 = (variable_t) (aux_9562);
			      }
			      {
				 pre_make_vector_app_251_t new1936_4940;
				 new1936_4940 = ((pre_make_vector_app_251_t) BREF(GC_MALLOC(sizeof(struct pre_make_vector_app_251))));
				 ((((pre_make_vector_app_251_t) CREF(new1936_4940))->owner) = ((variable_t) owner_4938), BUNSPEC);
				 ((((pre_make_vector_app_251_t) CREF(new1936_4940))->key) = ((obj_t) arg2814_2684), BUNSPEC);
				 res3506_4943 = new1936_4940;
			      }
			   }
			   arg2812_2682 = res3506_4943;
			}
		     }
		     {
			obj_t aux_9570;
			object_t aux_9568;
			aux_9570 = (obj_t) (arg2812_2682);
			aux_9568 = (object_t) (new1952_2680);
			OBJECT_WIDENING_SET(aux_9568, aux_9570);
		     }
		  }
		  aux_9543 = new1952_2680;
	       }
	    }
	 }
	 return (obj_t) (aux_9543);
      }
   }
}


obj_t 
object__struct_pre_make_vector_app3619_96_cfa_info(obj_t env_6863, obj_t obj1947_6864)
{
   {
      pre_make_vector_app_251_t obj1947_2659;
      obj1947_2659 = (pre_make_vector_app_251_t) (obj1947_6864);
      {
	 {
	    obj_t res1948_2662;
	    {
	       obj_t next_method2260_193_2672;
	       next_method2260_193_2672 = find_super_class_method_167___object((object_t) (obj1947_2659), object__struct_env_210___object, pre_make_vector_app_251_cfa_info);
	       if (PROCEDUREP(next_method2260_193_2672))
		 {
		    res1948_2662 = PROCEDURE_ENTRY(next_method2260_193_2672) (next_method2260_193_2672, (obj_t) (obj1947_2659), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2260_193_2672);
		    res1948_2662 = object__struct_50___object((object_t) (obj1947_2659));
		 }
	    }
	    {
	       obj_t aux1949_2663;
	       {
		  obj_t aux_9585;
		  aux_9585 = CNST_TABLE_REF(((long) 36));
		  aux1949_2663 = make_struct(aux_9585, ((long) 2), BUNSPEC);
	       }
	       {
		  obj_t aux_9588;
		  {
		     variable_t aux_9589;
		     {
			obj_t aux_9590;
			{
			   object_t aux_9591;
			   aux_9591 = (object_t) (obj1947_2659);
			   aux_9590 = OBJECT_WIDENING(aux_9591);
			}
			aux_9589 = (((pre_make_vector_app_251_t) CREF(aux_9590))->owner);
		     }
		     aux_9588 = (obj_t) (aux_9589);
		  }
		  STRUCT_SET(aux1949_2663, ((long) 0), aux_9588);
	       }
	       {
		  obj_t aux_9597;
		  {
		     obj_t aux_9598;
		     {
			object_t aux_9599;
			aux_9599 = (object_t) (obj1947_2659);
			aux_9598 = OBJECT_WIDENING(aux_9599);
		     }
		     aux_9597 = (((pre_make_vector_app_251_t) CREF(aux_9598))->key);
		  }
		  STRUCT_SET(aux1949_2663, ((long) 1), aux_9597);
	       }
	       STRUCT_SET(res1948_2662, ((long) 0), aux1949_2663);
	       {
		  obj_t aux_9605;
		  aux_9605 = STRUCT_KEY(res1948_2662);
		  STRUCT_KEY_SET(aux1949_2663, aux_9605);
	       }
	       {
		  obj_t aux_9608;
		  aux_9608 = CNST_TABLE_REF(((long) 36));
		  STRUCT_KEY_SET(res1948_2662, aux_9608);
	       }
	       return res1948_2662;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_pre_create_vector_app3620_75_cfa_info(obj_t env_6865, obj_t o_6866, obj_t s_6867)
{
   {
      pre_create_vector_app_162_t o_2646;
      obj_t s_2647;
      {
	 pre_create_vector_app_162_t aux_9612;
	 o_2646 = (pre_create_vector_app_162_t) (o_6866);
	 s_2647 = s_6867;
	 {
	    {
	       obj_t old1968_2650;
	       obj_t aux1969_2651;
	       {
		  obj_t next_method2258_233_2657;
		  next_method2258_233_2657 = find_super_class_method_167___object((object_t) (o_2646), struct_object__object_env_209___object, pre_create_vector_app_162_cfa_info);
		  if (PROCEDUREP(next_method2258_233_2657))
		    {
		       old1968_2650 = PROCEDURE_ENTRY(next_method2258_233_2657) (next_method2258_233_2657, (obj_t) (o_2646), s_2647, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2258_233_2657);
		       {
			  object_t aux_9621;
			  aux_9621 = struct_object__object_93___object((object_t) (o_2646), s_2647);
			  old1968_2650 = (obj_t) (aux_9621);
		       }
		    }
	       }
	       aux1969_2651 = STRUCT_REF(s_2647, ((long) 0));
	       {
		  pre_create_vector_app_162_t new1970_2652;
		  new1970_2652 = ((pre_create_vector_app_162_t) (old1968_2650));
		  {
		     long arg2797_2653;
		     arg2797_2653 = class_num_218___object(pre_create_vector_app_162_cfa_info);
		     {
			obj_t obj_4895;
			obj_4895 = (obj_t) (new1970_2652);
			(((obj_t) CREF(obj_4895))->header = MAKE_HEADER(arg2797_2653, 0), BUNSPEC);
		     }
		  }
		  {
		     pre_create_vector_app_162_t arg2798_2654;
		     {
			obj_t arg2800_2656;
			arg2800_2656 = STRUCT_REF(aux1969_2651, ((long) 1));
			{
			   pre_create_vector_app_162_t res3505_4906;
			   {
			      variable_t owner_4901;
			      {
				 obj_t aux_9631;
				 aux_9631 = STRUCT_REF(aux1969_2651, ((long) 0));
				 owner_4901 = (variable_t) (aux_9631);
			      }
			      {
				 pre_create_vector_app_162_t new1954_4903;
				 new1954_4903 = ((pre_create_vector_app_162_t) BREF(GC_MALLOC(sizeof(struct pre_create_vector_app_162))));
				 ((((pre_create_vector_app_162_t) CREF(new1954_4903))->owner) = ((variable_t) owner_4901), BUNSPEC);
				 ((((pre_create_vector_app_162_t) CREF(new1954_4903))->key) = ((obj_t) arg2800_2656), BUNSPEC);
				 res3505_4906 = new1954_4903;
			      }
			   }
			   arg2798_2654 = res3505_4906;
			}
		     }
		     {
			obj_t aux_9639;
			object_t aux_9637;
			aux_9639 = (obj_t) (arg2798_2654);
			aux_9637 = (object_t) (new1970_2652);
			OBJECT_WIDENING_SET(aux_9637, aux_9639);
		     }
		  }
		  aux_9612 = new1970_2652;
	       }
	    }
	 }
	 return (obj_t) (aux_9612);
      }
   }
}


obj_t 
object__struct_pre_create_vector_app3621_112_cfa_info(obj_t env_6868, obj_t obj1965_6869)
{
   {
      pre_create_vector_app_162_t obj1965_2631;
      obj1965_2631 = (pre_create_vector_app_162_t) (obj1965_6869);
      {
	 {
	    obj_t res1966_2634;
	    {
	       obj_t next_method2256_25_2644;
	       next_method2256_25_2644 = find_super_class_method_167___object((object_t) (obj1965_2631), object__struct_env_210___object, pre_create_vector_app_162_cfa_info);
	       if (PROCEDUREP(next_method2256_25_2644))
		 {
		    res1966_2634 = PROCEDURE_ENTRY(next_method2256_25_2644) (next_method2256_25_2644, (obj_t) (obj1965_2631), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2256_25_2644);
		    res1966_2634 = object__struct_50___object((object_t) (obj1965_2631));
		 }
	    }
	    {
	       obj_t aux1967_2635;
	       {
		  obj_t aux_9654;
		  aux_9654 = CNST_TABLE_REF(((long) 37));
		  aux1967_2635 = make_struct(aux_9654, ((long) 2), BUNSPEC);
	       }
	       {
		  obj_t aux_9657;
		  {
		     variable_t aux_9658;
		     {
			obj_t aux_9659;
			{
			   object_t aux_9660;
			   aux_9660 = (object_t) (obj1965_2631);
			   aux_9659 = OBJECT_WIDENING(aux_9660);
			}
			aux_9658 = (((pre_create_vector_app_162_t) CREF(aux_9659))->owner);
		     }
		     aux_9657 = (obj_t) (aux_9658);
		  }
		  STRUCT_SET(aux1967_2635, ((long) 0), aux_9657);
	       }
	       {
		  obj_t aux_9666;
		  {
		     obj_t aux_9667;
		     {
			object_t aux_9668;
			aux_9668 = (object_t) (obj1965_2631);
			aux_9667 = OBJECT_WIDENING(aux_9668);
		     }
		     aux_9666 = (((pre_create_vector_app_162_t) CREF(aux_9667))->key);
		  }
		  STRUCT_SET(aux1967_2635, ((long) 1), aux_9666);
	       }
	       STRUCT_SET(res1966_2634, ((long) 0), aux1967_2635);
	       {
		  obj_t aux_9674;
		  aux_9674 = STRUCT_KEY(res1966_2634);
		  STRUCT_KEY_SET(aux1967_2635, aux_9674);
	       }
	       {
		  obj_t aux_9677;
		  aux_9677 = CNST_TABLE_REF(((long) 37));
		  STRUCT_KEY_SET(res1966_2634, aux_9677);
	       }
	       return res1966_2634;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_pre_vector_ref_app3622_186_cfa_info(obj_t env_6870, obj_t o_6871, obj_t s_6872)
{
   {
      pre_vector_ref_app_208_t o_2620;
      obj_t s_2621;
      {
	 pre_vector_ref_app_208_t aux_9681;
	 o_2620 = (pre_vector_ref_app_208_t) (o_6871);
	 s_2621 = s_6872;
	 {
	    {
	       obj_t old1985_2624;
	       {
		  obj_t next_method2254_14_2629;
		  next_method2254_14_2629 = find_super_class_method_167___object((object_t) (o_2620), struct_object__object_env_209___object, pre_vector_ref_app_208_cfa_info);
		  if (PROCEDUREP(next_method2254_14_2629))
		    {
		       old1985_2624 = PROCEDURE_ENTRY(next_method2254_14_2629) (next_method2254_14_2629, (obj_t) (o_2620), s_2621, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2254_14_2629);
		       {
			  object_t aux_9690;
			  aux_9690 = struct_object__object_93___object((object_t) (o_2620), s_2621);
			  old1985_2624 = (obj_t) (aux_9690);
		       }
		    }
	       }
	       {
		  pre_vector_ref_app_208_t new1987_2626;
		  new1987_2626 = ((pre_vector_ref_app_208_t) (old1985_2624));
		  {
		     long arg2785_2627;
		     arg2785_2627 = class_num_218___object(pre_vector_ref_app_208_cfa_info);
		     {
			obj_t obj_4866;
			obj_4866 = (obj_t) (new1987_2626);
			(((obj_t) CREF(obj_4866))->header = MAKE_HEADER(arg2785_2627, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_9700;
		     object_t aux_9698;
		     {
			pre_vector_ref_app_208_t aux_9701;
			{
			   aux_9701 = ((pre_vector_ref_app_208_t) BREF(GC_MALLOC(sizeof(struct pre_vector_ref_app_208))));
			}
			aux_9700 = (obj_t) (aux_9701);
		     }
		     aux_9698 = (object_t) (new1987_2626);
		     OBJECT_WIDENING_SET(aux_9698, aux_9700);
		  }
		  aux_9681 = new1987_2626;
	       }
	    }
	 }
	 return (obj_t) (aux_9681);
      }
   }
}


obj_t 
object__struct_pre_vector_ref_app3623_14_cfa_info(obj_t env_6873, obj_t obj1982_6874)
{
   {
      pre_vector_ref_app_208_t obj1982_2609;
      obj1982_2609 = (pre_vector_ref_app_208_t) (obj1982_6874);
      {
	 {
	    obj_t res1983_2612;
	    {
	       obj_t next_method2252_119_2618;
	       next_method2252_119_2618 = find_super_class_method_167___object((object_t) (obj1982_2609), object__struct_env_210___object, pre_vector_ref_app_208_cfa_info);
	       if (PROCEDUREP(next_method2252_119_2618))
		 {
		    res1983_2612 = PROCEDURE_ENTRY(next_method2252_119_2618) (next_method2252_119_2618, (obj_t) (obj1982_2609), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2252_119_2618);
		    res1983_2612 = object__struct_50___object((object_t) (obj1982_2609));
		 }
	    }
	    {
	       obj_t aux1984_2613;
	       {
		  obj_t aux_9717;
		  aux_9717 = CNST_TABLE_REF(((long) 38));
		  aux1984_2613 = make_struct(aux_9717, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res1983_2612, ((long) 0), aux1984_2613);
	       {
		  obj_t aux_9721;
		  aux_9721 = STRUCT_KEY(res1983_2612);
		  STRUCT_KEY_SET(aux1984_2613, aux_9721);
	       }
	       {
		  obj_t aux_9724;
		  aux_9724 = CNST_TABLE_REF(((long) 38));
		  STRUCT_KEY_SET(res1983_2612, aux_9724);
	       }
	       return res1983_2612;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_pre_vector_set__app3624_62_cfa_info(obj_t env_6875, obj_t o_6876, obj_t s_6877)
{
   {
      pre_vector_set__app_211_t o_2598;
      obj_t s_2599;
      {
	 pre_vector_set__app_211_t aux_9728;
	 o_2598 = (pre_vector_set__app_211_t) (o_6876);
	 s_2599 = s_6877;
	 {
	    {
	       obj_t old2002_2602;
	       {
		  obj_t next_method2250_174_2607;
		  next_method2250_174_2607 = find_super_class_method_167___object((object_t) (o_2598), struct_object__object_env_209___object, pre_vector_set__app_211_cfa_info);
		  if (PROCEDUREP(next_method2250_174_2607))
		    {
		       old2002_2602 = PROCEDURE_ENTRY(next_method2250_174_2607) (next_method2250_174_2607, (obj_t) (o_2598), s_2599, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2250_174_2607);
		       {
			  object_t aux_9737;
			  aux_9737 = struct_object__object_93___object((object_t) (o_2598), s_2599);
			  old2002_2602 = (obj_t) (aux_9737);
		       }
		    }
	       }
	       {
		  pre_vector_set__app_211_t new2004_2604;
		  new2004_2604 = ((pre_vector_set__app_211_t) (old2002_2602));
		  {
		     long arg2777_2605;
		     arg2777_2605 = class_num_218___object(pre_vector_set__app_211_cfa_info);
		     {
			obj_t obj_4845;
			obj_4845 = (obj_t) (new2004_2604);
			(((obj_t) CREF(obj_4845))->header = MAKE_HEADER(arg2777_2605, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_9747;
		     object_t aux_9745;
		     {
			pre_vector_set__app_211_t aux_9748;
			{
			   aux_9748 = ((pre_vector_set__app_211_t) BREF(GC_MALLOC(sizeof(struct pre_vector_set__app_211))));
			}
			aux_9747 = (obj_t) (aux_9748);
		     }
		     aux_9745 = (object_t) (new2004_2604);
		     OBJECT_WIDENING_SET(aux_9745, aux_9747);
		  }
		  aux_9728 = new2004_2604;
	       }
	    }
	 }
	 return (obj_t) (aux_9728);
      }
   }
}


obj_t 
object__struct_pre_vector_set__app3625_165_cfa_info(obj_t env_6878, obj_t obj1999_6879)
{
   {
      pre_vector_set__app_211_t obj1999_2587;
      obj1999_2587 = (pre_vector_set__app_211_t) (obj1999_6879);
      {
	 {
	    obj_t res2000_2590;
	    {
	       obj_t next_method2248_137_2596;
	       next_method2248_137_2596 = find_super_class_method_167___object((object_t) (obj1999_2587), object__struct_env_210___object, pre_vector_set__app_211_cfa_info);
	       if (PROCEDUREP(next_method2248_137_2596))
		 {
		    res2000_2590 = PROCEDURE_ENTRY(next_method2248_137_2596) (next_method2248_137_2596, (obj_t) (obj1999_2587), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2248_137_2596);
		    res2000_2590 = object__struct_50___object((object_t) (obj1999_2587));
		 }
	    }
	    {
	       obj_t aux2001_2591;
	       {
		  obj_t aux_9764;
		  aux_9764 = CNST_TABLE_REF(((long) 39));
		  aux2001_2591 = make_struct(aux_9764, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res2000_2590, ((long) 0), aux2001_2591);
	       {
		  obj_t aux_9768;
		  aux_9768 = STRUCT_KEY(res2000_2590);
		  STRUCT_KEY_SET(aux2001_2591, aux_9768);
	       }
	       {
		  obj_t aux_9771;
		  aux_9771 = CNST_TABLE_REF(((long) 39));
		  STRUCT_KEY_SET(res2000_2590, aux_9771);
	       }
	       return res2000_2590;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_make_vector_app3626_193_cfa_info(obj_t env_6880, obj_t o_6881, obj_t s_6882)
{
   {
      make_vector_app_205_t o_2568;
      obj_t s_2569;
      {
	 make_vector_app_205_t aux_9775;
	 o_2568 = (make_vector_app_205_t) (o_6881);
	 s_2569 = s_6882;
	 {
	    {
	       obj_t old2025_2572;
	       obj_t aux2026_2573;
	       {
		  obj_t next_method2246_5_2585;
		  next_method2246_5_2585 = find_super_class_method_167___object((object_t) (o_2568), struct_object__object_env_209___object, make_vector_app_205_cfa_info);
		  if (PROCEDUREP(next_method2246_5_2585))
		    {
		       old2025_2572 = PROCEDURE_ENTRY(next_method2246_5_2585) (next_method2246_5_2585, (obj_t) (o_2568), s_2569, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2246_5_2585);
		       {
			  object_t aux_9784;
			  aux_9784 = struct_object__object_93___object((object_t) (o_2568), s_2569);
			  old2025_2572 = (obj_t) (aux_9784);
		       }
		    }
	       }
	       aux2026_2573 = STRUCT_REF(s_2569, ((long) 0));
	       {
		  make_vector_app_205_t new2027_2574;
		  new2027_2574 = ((make_vector_app_205_t) (old2025_2572));
		  {
		     long arg2761_2575;
		     arg2761_2575 = class_num_218___object(make_vector_app_205_cfa_info);
		     {
			obj_t obj_4792;
			obj_4792 = (obj_t) (new2027_2574);
			(((obj_t) CREF(obj_4792))->header = MAKE_HEADER(arg2761_2575, 0), BUNSPEC);
		     }
		  }
		  {
		     make_vector_app_205_t arg2762_2576;
		     {
			obj_t arg2763_2577;
			obj_t arg2769_2583;
			arg2763_2577 = STRUCT_REF(aux2026_2573, ((long) 0));
			arg2769_2583 = STRUCT_REF(aux2026_2573, ((long) 6));
			{
			   make_vector_app_205_t res3502_4827;
			   {
			      approx_t approx_4811;
			      approx_t value_approx_19_4812;
			      long lost_stamp_114_4813;
			      variable_t owner_4814;
			      bool_t stackable__42_4815;
			      bool_t seen__39_4817;
			      {
				 obj_t aux_9795;
				 aux_9795 = STRUCT_REF(aux2026_2573, ((long) 1));
				 approx_4811 = (approx_t) (aux_9795);
			      }
			      {
				 obj_t aux_9798;
				 aux_9798 = STRUCT_REF(aux2026_2573, ((long) 2));
				 value_approx_19_4812 = (approx_t) (aux_9798);
			      }
			      {
				 obj_t aux_9801;
				 aux_9801 = STRUCT_REF(aux2026_2573, ((long) 3));
				 lost_stamp_114_4813 = (long) CINT(aux_9801);
			      }
			      {
				 obj_t aux_9804;
				 aux_9804 = STRUCT_REF(aux2026_2573, ((long) 4));
				 owner_4814 = (variable_t) (aux_9804);
			      }
			      {
				 obj_t aux_9807;
				 aux_9807 = STRUCT_REF(aux2026_2573, ((long) 5));
				 stackable__42_4815 = CBOOL(aux_9807);
			      }
			      {
				 obj_t aux_9810;
				 aux_9810 = STRUCT_REF(aux2026_2573, ((long) 7));
				 seen__39_4817 = CBOOL(aux_9810);
			      }
			      {
				 make_vector_app_205_t new2006_4818;
				 new2006_4818 = ((make_vector_app_205_t) BREF(GC_MALLOC(sizeof(struct make_vector_app_205))));
				 ((((make_vector_app_205_t) CREF(new2006_4818))->key) = ((obj_t) arg2763_2577), BUNSPEC);
				 ((((make_vector_app_205_t) CREF(new2006_4818))->approx) = ((approx_t) approx_4811), BUNSPEC);
				 ((((make_vector_app_205_t) CREF(new2006_4818))->value_approx_19) = ((approx_t) value_approx_19_4812), BUNSPEC);
				 ((((make_vector_app_205_t) CREF(new2006_4818))->lost_stamp_114) = ((long) lost_stamp_114_4813), BUNSPEC);
				 ((((make_vector_app_205_t) CREF(new2006_4818))->owner) = ((variable_t) owner_4814), BUNSPEC);
				 ((((make_vector_app_205_t) CREF(new2006_4818))->stackable__42) = ((bool_t) stackable__42_4815), BUNSPEC);
				 ((((make_vector_app_205_t) CREF(new2006_4818))->stack_stamp_31) = ((obj_t) arg2769_2583), BUNSPEC);
				 ((((make_vector_app_205_t) CREF(new2006_4818))->seen__39) = ((bool_t) seen__39_4817), BUNSPEC);
				 res3502_4827 = new2006_4818;
			      }
			   }
			   arg2762_2576 = res3502_4827;
			}
		     }
		     {
			obj_t aux_9824;
			object_t aux_9822;
			aux_9824 = (obj_t) (arg2762_2576);
			aux_9822 = (object_t) (new2027_2574);
			OBJECT_WIDENING_SET(aux_9822, aux_9824);
		     }
		  }
		  aux_9775 = new2027_2574;
	       }
	    }
	 }
	 return (obj_t) (aux_9775);
      }
   }
}


obj_t 
object__struct_make_vector_app3627_193_cfa_info(obj_t env_6883, obj_t obj2022_6884)
{
   {
      make_vector_app_205_t obj2022_2541;
      obj2022_2541 = (make_vector_app_205_t) (obj2022_6884);
      {
	 {
	    obj_t res2023_2544;
	    {
	       obj_t next_method2244_126_2566;
	       next_method2244_126_2566 = find_super_class_method_167___object((object_t) (obj2022_2541), object__struct_env_210___object, make_vector_app_205_cfa_info);
	       if (PROCEDUREP(next_method2244_126_2566))
		 {
		    res2023_2544 = PROCEDURE_ENTRY(next_method2244_126_2566) (next_method2244_126_2566, (obj_t) (obj2022_2541), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2244_126_2566);
		    res2023_2544 = object__struct_50___object((object_t) (obj2022_2541));
		 }
	    }
	    {
	       obj_t aux2024_2545;
	       {
		  obj_t aux_9839;
		  aux_9839 = CNST_TABLE_REF(((long) 40));
		  aux2024_2545 = make_struct(aux_9839, ((long) 8), BUNSPEC);
	       }
	       {
		  obj_t aux_9842;
		  {
		     obj_t aux_9843;
		     {
			object_t aux_9844;
			aux_9844 = (object_t) (obj2022_2541);
			aux_9843 = OBJECT_WIDENING(aux_9844);
		     }
		     aux_9842 = (((make_vector_app_205_t) CREF(aux_9843))->key);
		  }
		  STRUCT_SET(aux2024_2545, ((long) 0), aux_9842);
	       }
	       {
		  obj_t aux_9849;
		  {
		     approx_t aux_9850;
		     {
			obj_t aux_9851;
			{
			   object_t aux_9852;
			   aux_9852 = (object_t) (obj2022_2541);
			   aux_9851 = OBJECT_WIDENING(aux_9852);
			}
			aux_9850 = (((make_vector_app_205_t) CREF(aux_9851))->approx);
		     }
		     aux_9849 = (obj_t) (aux_9850);
		  }
		  STRUCT_SET(aux2024_2545, ((long) 1), aux_9849);
	       }
	       {
		  obj_t aux_9858;
		  {
		     approx_t aux_9859;
		     {
			obj_t aux_9860;
			{
			   object_t aux_9861;
			   aux_9861 = (object_t) (obj2022_2541);
			   aux_9860 = OBJECT_WIDENING(aux_9861);
			}
			aux_9859 = (((make_vector_app_205_t) CREF(aux_9860))->value_approx_19);
		     }
		     aux_9858 = (obj_t) (aux_9859);
		  }
		  STRUCT_SET(aux2024_2545, ((long) 2), aux_9858);
	       }
	       {
		  obj_t aux_9867;
		  {
		     long aux_9868;
		     {
			obj_t aux_9869;
			{
			   object_t aux_9870;
			   aux_9870 = (object_t) (obj2022_2541);
			   aux_9869 = OBJECT_WIDENING(aux_9870);
			}
			aux_9868 = (((make_vector_app_205_t) CREF(aux_9869))->lost_stamp_114);
		     }
		     aux_9867 = BINT(aux_9868);
		  }
		  STRUCT_SET(aux2024_2545, ((long) 3), aux_9867);
	       }
	       {
		  obj_t aux_9876;
		  {
		     variable_t aux_9877;
		     {
			obj_t aux_9878;
			{
			   object_t aux_9879;
			   aux_9879 = (object_t) (obj2022_2541);
			   aux_9878 = OBJECT_WIDENING(aux_9879);
			}
			aux_9877 = (((make_vector_app_205_t) CREF(aux_9878))->owner);
		     }
		     aux_9876 = (obj_t) (aux_9877);
		  }
		  STRUCT_SET(aux2024_2545, ((long) 4), aux_9876);
	       }
	       {
		  obj_t aux_9885;
		  {
		     bool_t aux_9886;
		     {
			obj_t aux_9887;
			{
			   object_t aux_9888;
			   aux_9888 = (object_t) (obj2022_2541);
			   aux_9887 = OBJECT_WIDENING(aux_9888);
			}
			aux_9886 = (((make_vector_app_205_t) CREF(aux_9887))->stackable__42);
		     }
		     aux_9885 = BBOOL(aux_9886);
		  }
		  STRUCT_SET(aux2024_2545, ((long) 5), aux_9885);
	       }
	       {
		  obj_t aux_9894;
		  {
		     obj_t aux_9895;
		     {
			object_t aux_9896;
			aux_9896 = (object_t) (obj2022_2541);
			aux_9895 = OBJECT_WIDENING(aux_9896);
		     }
		     aux_9894 = (((make_vector_app_205_t) CREF(aux_9895))->stack_stamp_31);
		  }
		  STRUCT_SET(aux2024_2545, ((long) 6), aux_9894);
	       }
	       {
		  obj_t aux_9901;
		  {
		     bool_t aux_9902;
		     {
			obj_t aux_9903;
			{
			   object_t aux_9904;
			   aux_9904 = (object_t) (obj2022_2541);
			   aux_9903 = OBJECT_WIDENING(aux_9904);
			}
			aux_9902 = (((make_vector_app_205_t) CREF(aux_9903))->seen__39);
		     }
		     aux_9901 = BBOOL(aux_9902);
		  }
		  STRUCT_SET(aux2024_2545, ((long) 7), aux_9901);
	       }
	       STRUCT_SET(res2023_2544, ((long) 0), aux2024_2545);
	       {
		  obj_t aux_9911;
		  aux_9911 = STRUCT_KEY(res2023_2544);
		  STRUCT_KEY_SET(aux2024_2545, aux_9911);
	       }
	       {
		  obj_t aux_9914;
		  aux_9914 = CNST_TABLE_REF(((long) 40));
		  STRUCT_KEY_SET(res2023_2544, aux_9914);
	       }
	       return res2023_2544;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_create_vector_app3628_76_cfa_info(obj_t env_6885, obj_t o_6886, obj_t s_6887)
{
   {
      create_vector_app_150_t o_2522;
      obj_t s_2523;
      {
	 create_vector_app_150_t aux_9918;
	 o_2522 = (create_vector_app_150_t) (o_6886);
	 s_2523 = s_6887;
	 {
	    {
	       obj_t old2047_2526;
	       obj_t aux2048_2527;
	       {
		  obj_t next_method2242_193_2539;
		  next_method2242_193_2539 = find_super_class_method_167___object((object_t) (o_2522), struct_object__object_env_209___object, create_vector_app_150_cfa_info);
		  if (PROCEDUREP(next_method2242_193_2539))
		    {
		       old2047_2526 = PROCEDURE_ENTRY(next_method2242_193_2539) (next_method2242_193_2539, (obj_t) (o_2522), s_2523, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2242_193_2539);
		       {
			  object_t aux_9927;
			  aux_9927 = struct_object__object_93___object((object_t) (o_2522), s_2523);
			  old2047_2526 = (obj_t) (aux_9927);
		       }
		    }
	       }
	       aux2048_2527 = STRUCT_REF(s_2523, ((long) 0));
	       {
		  create_vector_app_150_t new2049_2528;
		  new2049_2528 = ((create_vector_app_150_t) (old2047_2526));
		  {
		     long arg2729_2529;
		     arg2729_2529 = class_num_218___object(create_vector_app_150_cfa_info);
		     {
			obj_t obj_4707;
			obj_4707 = (obj_t) (new2049_2528);
			(((obj_t) CREF(obj_4707))->header = MAKE_HEADER(arg2729_2529, 0), BUNSPEC);
		     }
		  }
		  {
		     create_vector_app_150_t arg2730_2530;
		     {
			obj_t arg2731_2531;
			obj_t arg2737_2537;
			arg2731_2531 = STRUCT_REF(aux2048_2527, ((long) 0));
			arg2737_2537 = STRUCT_REF(aux2048_2527, ((long) 6));
			{
			   create_vector_app_150_t res3501_4742;
			   {
			      approx_t approx_4726;
			      approx_t value_approx_19_4727;
			      long lost_stamp_114_4728;
			      variable_t owner_4729;
			      bool_t stackable__42_4730;
			      bool_t seen__39_4732;
			      {
				 obj_t aux_9938;
				 aux_9938 = STRUCT_REF(aux2048_2527, ((long) 1));
				 approx_4726 = (approx_t) (aux_9938);
			      }
			      {
				 obj_t aux_9941;
				 aux_9941 = STRUCT_REF(aux2048_2527, ((long) 2));
				 value_approx_19_4727 = (approx_t) (aux_9941);
			      }
			      {
				 obj_t aux_9944;
				 aux_9944 = STRUCT_REF(aux2048_2527, ((long) 3));
				 lost_stamp_114_4728 = (long) CINT(aux_9944);
			      }
			      {
				 obj_t aux_9947;
				 aux_9947 = STRUCT_REF(aux2048_2527, ((long) 4));
				 owner_4729 = (variable_t) (aux_9947);
			      }
			      {
				 obj_t aux_9950;
				 aux_9950 = STRUCT_REF(aux2048_2527, ((long) 5));
				 stackable__42_4730 = CBOOL(aux_9950);
			      }
			      {
				 obj_t aux_9953;
				 aux_9953 = STRUCT_REF(aux2048_2527, ((long) 7));
				 seen__39_4732 = CBOOL(aux_9953);
			      }
			      {
				 create_vector_app_150_t new2029_4733;
				 new2029_4733 = ((create_vector_app_150_t) BREF(GC_MALLOC(sizeof(struct create_vector_app_150))));
				 ((((create_vector_app_150_t) CREF(new2029_4733))->key) = ((obj_t) arg2731_2531), BUNSPEC);
				 ((((create_vector_app_150_t) CREF(new2029_4733))->approx) = ((approx_t) approx_4726), BUNSPEC);
				 ((((create_vector_app_150_t) CREF(new2029_4733))->value_approx_19) = ((approx_t) value_approx_19_4727), BUNSPEC);
				 ((((create_vector_app_150_t) CREF(new2029_4733))->lost_stamp_114) = ((long) lost_stamp_114_4728), BUNSPEC);
				 ((((create_vector_app_150_t) CREF(new2029_4733))->owner) = ((variable_t) owner_4729), BUNSPEC);
				 ((((create_vector_app_150_t) CREF(new2029_4733))->stackable__42) = ((bool_t) stackable__42_4730), BUNSPEC);
				 ((((create_vector_app_150_t) CREF(new2029_4733))->stack_stamp_31) = ((obj_t) arg2737_2537), BUNSPEC);
				 ((((create_vector_app_150_t) CREF(new2029_4733))->seen__39) = ((bool_t) seen__39_4732), BUNSPEC);
				 res3501_4742 = new2029_4733;
			      }
			   }
			   arg2730_2530 = res3501_4742;
			}
		     }
		     {
			obj_t aux_9967;
			object_t aux_9965;
			aux_9967 = (obj_t) (arg2730_2530);
			aux_9965 = (object_t) (new2049_2528);
			OBJECT_WIDENING_SET(aux_9965, aux_9967);
		     }
		  }
		  aux_9918 = new2049_2528;
	       }
	    }
	 }
	 return (obj_t) (aux_9918);
      }
   }
}


obj_t 
object__struct_create_vector_app3629_247_cfa_info(obj_t env_6888, obj_t obj2044_6889)
{
   {
      create_vector_app_150_t obj2044_2495;
      obj2044_2495 = (create_vector_app_150_t) (obj2044_6889);
      {
	 {
	    obj_t res2045_2498;
	    {
	       obj_t next_method2240_101_2520;
	       next_method2240_101_2520 = find_super_class_method_167___object((object_t) (obj2044_2495), object__struct_env_210___object, create_vector_app_150_cfa_info);
	       if (PROCEDUREP(next_method2240_101_2520))
		 {
		    res2045_2498 = PROCEDURE_ENTRY(next_method2240_101_2520) (next_method2240_101_2520, (obj_t) (obj2044_2495), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2240_101_2520);
		    res2045_2498 = object__struct_50___object((object_t) (obj2044_2495));
		 }
	    }
	    {
	       obj_t aux2046_2499;
	       {
		  obj_t aux_9982;
		  aux_9982 = CNST_TABLE_REF(((long) 41));
		  aux2046_2499 = make_struct(aux_9982, ((long) 8), BUNSPEC);
	       }
	       {
		  obj_t aux_9985;
		  {
		     obj_t aux_9986;
		     {
			object_t aux_9987;
			aux_9987 = (object_t) (obj2044_2495);
			aux_9986 = OBJECT_WIDENING(aux_9987);
		     }
		     aux_9985 = (((create_vector_app_150_t) CREF(aux_9986))->key);
		  }
		  STRUCT_SET(aux2046_2499, ((long) 0), aux_9985);
	       }
	       {
		  obj_t aux_9992;
		  {
		     approx_t aux_9993;
		     {
			obj_t aux_9994;
			{
			   object_t aux_9995;
			   aux_9995 = (object_t) (obj2044_2495);
			   aux_9994 = OBJECT_WIDENING(aux_9995);
			}
			aux_9993 = (((create_vector_app_150_t) CREF(aux_9994))->approx);
		     }
		     aux_9992 = (obj_t) (aux_9993);
		  }
		  STRUCT_SET(aux2046_2499, ((long) 1), aux_9992);
	       }
	       {
		  obj_t aux_10001;
		  {
		     approx_t aux_10002;
		     {
			obj_t aux_10003;
			{
			   object_t aux_10004;
			   aux_10004 = (object_t) (obj2044_2495);
			   aux_10003 = OBJECT_WIDENING(aux_10004);
			}
			aux_10002 = (((create_vector_app_150_t) CREF(aux_10003))->value_approx_19);
		     }
		     aux_10001 = (obj_t) (aux_10002);
		  }
		  STRUCT_SET(aux2046_2499, ((long) 2), aux_10001);
	       }
	       {
		  obj_t aux_10010;
		  {
		     long aux_10011;
		     {
			obj_t aux_10012;
			{
			   object_t aux_10013;
			   aux_10013 = (object_t) (obj2044_2495);
			   aux_10012 = OBJECT_WIDENING(aux_10013);
			}
			aux_10011 = (((create_vector_app_150_t) CREF(aux_10012))->lost_stamp_114);
		     }
		     aux_10010 = BINT(aux_10011);
		  }
		  STRUCT_SET(aux2046_2499, ((long) 3), aux_10010);
	       }
	       {
		  obj_t aux_10019;
		  {
		     variable_t aux_10020;
		     {
			obj_t aux_10021;
			{
			   object_t aux_10022;
			   aux_10022 = (object_t) (obj2044_2495);
			   aux_10021 = OBJECT_WIDENING(aux_10022);
			}
			aux_10020 = (((create_vector_app_150_t) CREF(aux_10021))->owner);
		     }
		     aux_10019 = (obj_t) (aux_10020);
		  }
		  STRUCT_SET(aux2046_2499, ((long) 4), aux_10019);
	       }
	       {
		  obj_t aux_10028;
		  {
		     bool_t aux_10029;
		     {
			obj_t aux_10030;
			{
			   object_t aux_10031;
			   aux_10031 = (object_t) (obj2044_2495);
			   aux_10030 = OBJECT_WIDENING(aux_10031);
			}
			aux_10029 = (((create_vector_app_150_t) CREF(aux_10030))->stackable__42);
		     }
		     aux_10028 = BBOOL(aux_10029);
		  }
		  STRUCT_SET(aux2046_2499, ((long) 5), aux_10028);
	       }
	       {
		  obj_t aux_10037;
		  {
		     obj_t aux_10038;
		     {
			object_t aux_10039;
			aux_10039 = (object_t) (obj2044_2495);
			aux_10038 = OBJECT_WIDENING(aux_10039);
		     }
		     aux_10037 = (((create_vector_app_150_t) CREF(aux_10038))->stack_stamp_31);
		  }
		  STRUCT_SET(aux2046_2499, ((long) 6), aux_10037);
	       }
	       {
		  obj_t aux_10044;
		  {
		     bool_t aux_10045;
		     {
			obj_t aux_10046;
			{
			   object_t aux_10047;
			   aux_10047 = (object_t) (obj2044_2495);
			   aux_10046 = OBJECT_WIDENING(aux_10047);
			}
			aux_10045 = (((create_vector_app_150_t) CREF(aux_10046))->seen__39);
		     }
		     aux_10044 = BBOOL(aux_10045);
		  }
		  STRUCT_SET(aux2046_2499, ((long) 7), aux_10044);
	       }
	       STRUCT_SET(res2045_2498, ((long) 0), aux2046_2499);
	       {
		  obj_t aux_10054;
		  aux_10054 = STRUCT_KEY(res2045_2498);
		  STRUCT_KEY_SET(aux2046_2499, aux_10054);
	       }
	       {
		  obj_t aux_10057;
		  aux_10057 = CNST_TABLE_REF(((long) 41));
		  STRUCT_KEY_SET(res2045_2498, aux_10057);
	       }
	       return res2045_2498;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_vector_ref_app3630_120_cfa_info(obj_t env_6890, obj_t o_6891, obj_t s_6892)
{
   {
      vector_ref_app_195_t o_2483;
      obj_t s_2484;
      {
	 vector_ref_app_195_t aux_10061;
	 o_2483 = (vector_ref_app_195_t) (o_6891);
	 s_2484 = s_6892;
	 {
	    {
	       obj_t old2064_2487;
	       obj_t aux2065_2488;
	       {
		  obj_t next_method2238_154_2493;
		  next_method2238_154_2493 = find_super_class_method_167___object((object_t) (o_2483), struct_object__object_env_209___object, vector_ref_app_195_cfa_info);
		  if (PROCEDUREP(next_method2238_154_2493))
		    {
		       old2064_2487 = PROCEDURE_ENTRY(next_method2238_154_2493) (next_method2238_154_2493, (obj_t) (o_2483), s_2484, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2238_154_2493);
		       {
			  object_t aux_10070;
			  aux_10070 = struct_object__object_93___object((object_t) (o_2483), s_2484);
			  old2064_2487 = (obj_t) (aux_10070);
		       }
		    }
	       }
	       aux2065_2488 = STRUCT_REF(s_2484, ((long) 0));
	       {
		  vector_ref_app_195_t new2066_2489;
		  new2066_2489 = ((vector_ref_app_195_t) (old2064_2487));
		  {
		     long arg2704_2490;
		     arg2704_2490 = class_num_218___object(vector_ref_app_195_cfa_info);
		     {
			obj_t obj_4650;
			obj_4650 = (obj_t) (new2066_2489);
			(((obj_t) CREF(obj_4650))->header = MAKE_HEADER(arg2704_2490, 0), BUNSPEC);
		     }
		  }
		  {
		     vector_ref_app_195_t arg2705_2491;
		     {
			vector_ref_app_195_t res3500_4657;
			{
			   approx_t approx_4654;
			   {
			      obj_t aux_10079;
			      aux_10079 = STRUCT_REF(aux2065_2488, ((long) 0));
			      approx_4654 = (approx_t) (aux_10079);
			   }
			   {
			      vector_ref_app_195_t new2051_4655;
			      new2051_4655 = ((vector_ref_app_195_t) BREF(GC_MALLOC(sizeof(struct vector_ref_app_195))));
			      ((((vector_ref_app_195_t) CREF(new2051_4655))->approx) = ((approx_t) approx_4654), BUNSPEC);
			      res3500_4657 = new2051_4655;
			   }
			}
			arg2705_2491 = res3500_4657;
		     }
		     {
			obj_t aux_10086;
			object_t aux_10084;
			aux_10086 = (obj_t) (arg2705_2491);
			aux_10084 = (object_t) (new2066_2489);
			OBJECT_WIDENING_SET(aux_10084, aux_10086);
		     }
		  }
		  aux_10061 = new2066_2489;
	       }
	    }
	 }
	 return (obj_t) (aux_10061);
      }
   }
}


obj_t 
object__struct_vector_ref_app3631_178_cfa_info(obj_t env_6893, obj_t obj2061_6894)
{
   {
      vector_ref_app_195_t obj2061_2470;
      obj2061_2470 = (vector_ref_app_195_t) (obj2061_6894);
      {
	 {
	    obj_t res2062_2473;
	    {
	       obj_t next_method2236_116_2481;
	       next_method2236_116_2481 = find_super_class_method_167___object((object_t) (obj2061_2470), object__struct_env_210___object, vector_ref_app_195_cfa_info);
	       if (PROCEDUREP(next_method2236_116_2481))
		 {
		    res2062_2473 = PROCEDURE_ENTRY(next_method2236_116_2481) (next_method2236_116_2481, (obj_t) (obj2061_2470), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2236_116_2481);
		    res2062_2473 = object__struct_50___object((object_t) (obj2061_2470));
		 }
	    }
	    {
	       obj_t aux2063_2474;
	       {
		  obj_t aux_10101;
		  aux_10101 = CNST_TABLE_REF(((long) 42));
		  aux2063_2474 = make_struct(aux_10101, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_10104;
		  {
		     approx_t aux_10105;
		     {
			obj_t aux_10106;
			{
			   object_t aux_10107;
			   aux_10107 = (object_t) (obj2061_2470);
			   aux_10106 = OBJECT_WIDENING(aux_10107);
			}
			aux_10105 = (((vector_ref_app_195_t) CREF(aux_10106))->approx);
		     }
		     aux_10104 = (obj_t) (aux_10105);
		  }
		  STRUCT_SET(aux2063_2474, ((long) 0), aux_10104);
	       }
	       STRUCT_SET(res2062_2473, ((long) 0), aux2063_2474);
	       {
		  obj_t aux_10114;
		  aux_10114 = STRUCT_KEY(res2062_2473);
		  STRUCT_KEY_SET(aux2063_2474, aux_10114);
	       }
	       {
		  obj_t aux_10117;
		  aux_10117 = CNST_TABLE_REF(((long) 42));
		  STRUCT_KEY_SET(res2062_2473, aux_10117);
	       }
	       return res2062_2473;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_vector_set__app3632_33_cfa_info(obj_t env_6895, obj_t o_6896, obj_t s_6897)
{
   {
      vector_set__app_21_t o_2458;
      obj_t s_2459;
      {
	 vector_set__app_21_t aux_10121;
	 o_2458 = (vector_set__app_21_t) (o_6896);
	 s_2459 = s_6897;
	 {
	    {
	       obj_t old2081_2462;
	       obj_t aux2082_2463;
	       {
		  obj_t next_method2234_206_2468;
		  next_method2234_206_2468 = find_super_class_method_167___object((object_t) (o_2458), struct_object__object_env_209___object, vector_set__app_21_cfa_info);
		  if (PROCEDUREP(next_method2234_206_2468))
		    {
		       old2081_2462 = PROCEDURE_ENTRY(next_method2234_206_2468) (next_method2234_206_2468, (obj_t) (o_2458), s_2459, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2234_206_2468);
		       {
			  object_t aux_10130;
			  aux_10130 = struct_object__object_93___object((object_t) (o_2458), s_2459);
			  old2081_2462 = (obj_t) (aux_10130);
		       }
		    }
	       }
	       aux2082_2463 = STRUCT_REF(s_2459, ((long) 0));
	       {
		  vector_set__app_21_t new2083_2464;
		  new2083_2464 = ((vector_set__app_21_t) (old2081_2462));
		  {
		     long arg2693_2465;
		     arg2693_2465 = class_num_218___object(vector_set__app_21_cfa_info);
		     {
			obj_t obj_4621;
			obj_4621 = (obj_t) (new2083_2464);
			(((obj_t) CREF(obj_4621))->header = MAKE_HEADER(arg2693_2465, 0), BUNSPEC);
		     }
		  }
		  {
		     vector_set__app_21_t arg2694_2466;
		     {
			vector_set__app_21_t res3499_4628;
			{
			   approx_t approx_4625;
			   {
			      obj_t aux_10139;
			      aux_10139 = STRUCT_REF(aux2082_2463, ((long) 0));
			      approx_4625 = (approx_t) (aux_10139);
			   }
			   {
			      vector_set__app_21_t new2068_4626;
			      new2068_4626 = ((vector_set__app_21_t) BREF(GC_MALLOC(sizeof(struct vector_set__app_21))));
			      ((((vector_set__app_21_t) CREF(new2068_4626))->approx) = ((approx_t) approx_4625), BUNSPEC);
			      res3499_4628 = new2068_4626;
			   }
			}
			arg2694_2466 = res3499_4628;
		     }
		     {
			obj_t aux_10146;
			object_t aux_10144;
			aux_10146 = (obj_t) (arg2694_2466);
			aux_10144 = (object_t) (new2083_2464);
			OBJECT_WIDENING_SET(aux_10144, aux_10146);
		     }
		  }
		  aux_10121 = new2083_2464;
	       }
	    }
	 }
	 return (obj_t) (aux_10121);
      }
   }
}


obj_t 
object__struct_vector_set__app3633_171_cfa_info(obj_t env_6898, obj_t obj2078_6899)
{
   {
      vector_set__app_21_t obj2078_2445;
      obj2078_2445 = (vector_set__app_21_t) (obj2078_6899);
      {
	 {
	    obj_t res2079_2448;
	    {
	       obj_t next_method2232_221_2456;
	       next_method2232_221_2456 = find_super_class_method_167___object((object_t) (obj2078_2445), object__struct_env_210___object, vector_set__app_21_cfa_info);
	       if (PROCEDUREP(next_method2232_221_2456))
		 {
		    res2079_2448 = PROCEDURE_ENTRY(next_method2232_221_2456) (next_method2232_221_2456, (obj_t) (obj2078_2445), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2232_221_2456);
		    res2079_2448 = object__struct_50___object((object_t) (obj2078_2445));
		 }
	    }
	    {
	       obj_t aux2080_2449;
	       {
		  obj_t aux_10161;
		  aux_10161 = CNST_TABLE_REF(((long) 43));
		  aux2080_2449 = make_struct(aux_10161, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_10164;
		  {
		     approx_t aux_10165;
		     {
			obj_t aux_10166;
			{
			   object_t aux_10167;
			   aux_10167 = (object_t) (obj2078_2445);
			   aux_10166 = OBJECT_WIDENING(aux_10167);
			}
			aux_10165 = (((vector_set__app_21_t) CREF(aux_10166))->approx);
		     }
		     aux_10164 = (obj_t) (aux_10165);
		  }
		  STRUCT_SET(aux2080_2449, ((long) 0), aux_10164);
	       }
	       STRUCT_SET(res2079_2448, ((long) 0), aux2080_2449);
	       {
		  obj_t aux_10174;
		  aux_10174 = STRUCT_KEY(res2079_2448);
		  STRUCT_KEY_SET(aux2080_2449, aux_10174);
	       }
	       {
		  obj_t aux_10177;
		  aux_10177 = CNST_TABLE_REF(((long) 43));
		  STRUCT_KEY_SET(res2079_2448, aux_10177);
	       }
	       return res2079_2448;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_pre_make_struct_app3634_112_cfa_info(obj_t env_6900, obj_t o_6901, obj_t s_6902)
{
   {
      pre_make_struct_app_218_t o_2432;
      obj_t s_2433;
      {
	 pre_make_struct_app_218_t aux_10181;
	 o_2432 = (pre_make_struct_app_218_t) (o_6901);
	 s_2433 = s_6902;
	 {
	    {
	       obj_t old2099_2436;
	       obj_t aux2100_2437;
	       {
		  obj_t next_method2230_192_2443;
		  next_method2230_192_2443 = find_super_class_method_167___object((object_t) (o_2432), struct_object__object_env_209___object, pre_make_struct_app_218_cfa_info);
		  if (PROCEDUREP(next_method2230_192_2443))
		    {
		       old2099_2436 = PROCEDURE_ENTRY(next_method2230_192_2443) (next_method2230_192_2443, (obj_t) (o_2432), s_2433, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2230_192_2443);
		       {
			  object_t aux_10190;
			  aux_10190 = struct_object__object_93___object((object_t) (o_2432), s_2433);
			  old2099_2436 = (obj_t) (aux_10190);
		       }
		    }
	       }
	       aux2100_2437 = STRUCT_REF(s_2433, ((long) 0));
	       {
		  pre_make_struct_app_218_t new2101_2438;
		  new2101_2438 = ((pre_make_struct_app_218_t) (old2099_2436));
		  {
		     long arg2681_2439;
		     arg2681_2439 = class_num_218___object(pre_make_struct_app_218_cfa_info);
		     {
			obj_t obj_4588;
			obj_4588 = (obj_t) (new2101_2438);
			(((obj_t) CREF(obj_4588))->header = MAKE_HEADER(arg2681_2439, 0), BUNSPEC);
		     }
		  }
		  {
		     pre_make_struct_app_218_t arg2682_2440;
		     {
			obj_t arg2684_2442;
			arg2684_2442 = STRUCT_REF(aux2100_2437, ((long) 1));
			{
			   pre_make_struct_app_218_t res3498_4599;
			   {
			      variable_t owner_4594;
			      {
				 obj_t aux_10200;
				 aux_10200 = STRUCT_REF(aux2100_2437, ((long) 0));
				 owner_4594 = (variable_t) (aux_10200);
			      }
			      {
				 pre_make_struct_app_218_t new2085_4596;
				 new2085_4596 = ((pre_make_struct_app_218_t) BREF(GC_MALLOC(sizeof(struct pre_make_struct_app_218))));
				 ((((pre_make_struct_app_218_t) CREF(new2085_4596))->owner) = ((variable_t) owner_4594), BUNSPEC);
				 ((((pre_make_struct_app_218_t) CREF(new2085_4596))->key) = ((obj_t) arg2684_2442), BUNSPEC);
				 res3498_4599 = new2085_4596;
			      }
			   }
			   arg2682_2440 = res3498_4599;
			}
		     }
		     {
			obj_t aux_10208;
			object_t aux_10206;
			aux_10208 = (obj_t) (arg2682_2440);
			aux_10206 = (object_t) (new2101_2438);
			OBJECT_WIDENING_SET(aux_10206, aux_10208);
		     }
		  }
		  aux_10181 = new2101_2438;
	       }
	    }
	 }
	 return (obj_t) (aux_10181);
      }
   }
}


obj_t 
object__struct_pre_make_struct_app3635_144_cfa_info(obj_t env_6903, obj_t obj2096_6904)
{
   {
      pre_make_struct_app_218_t obj2096_2417;
      obj2096_2417 = (pre_make_struct_app_218_t) (obj2096_6904);
      {
	 {
	    obj_t res2097_2420;
	    {
	       obj_t next_method2228_68_2430;
	       next_method2228_68_2430 = find_super_class_method_167___object((object_t) (obj2096_2417), object__struct_env_210___object, pre_make_struct_app_218_cfa_info);
	       if (PROCEDUREP(next_method2228_68_2430))
		 {
		    res2097_2420 = PROCEDURE_ENTRY(next_method2228_68_2430) (next_method2228_68_2430, (obj_t) (obj2096_2417), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2228_68_2430);
		    res2097_2420 = object__struct_50___object((object_t) (obj2096_2417));
		 }
	    }
	    {
	       obj_t aux2098_2421;
	       {
		  obj_t aux_10223;
		  aux_10223 = CNST_TABLE_REF(((long) 44));
		  aux2098_2421 = make_struct(aux_10223, ((long) 2), BUNSPEC);
	       }
	       {
		  obj_t aux_10226;
		  {
		     variable_t aux_10227;
		     {
			obj_t aux_10228;
			{
			   object_t aux_10229;
			   aux_10229 = (object_t) (obj2096_2417);
			   aux_10228 = OBJECT_WIDENING(aux_10229);
			}
			aux_10227 = (((pre_make_struct_app_218_t) CREF(aux_10228))->owner);
		     }
		     aux_10226 = (obj_t) (aux_10227);
		  }
		  STRUCT_SET(aux2098_2421, ((long) 0), aux_10226);
	       }
	       {
		  obj_t aux_10235;
		  {
		     obj_t aux_10236;
		     {
			object_t aux_10237;
			aux_10237 = (object_t) (obj2096_2417);
			aux_10236 = OBJECT_WIDENING(aux_10237);
		     }
		     aux_10235 = (((pre_make_struct_app_218_t) CREF(aux_10236))->key);
		  }
		  STRUCT_SET(aux2098_2421, ((long) 1), aux_10235);
	       }
	       STRUCT_SET(res2097_2420, ((long) 0), aux2098_2421);
	       {
		  obj_t aux_10243;
		  aux_10243 = STRUCT_KEY(res2097_2420);
		  STRUCT_KEY_SET(aux2098_2421, aux_10243);
	       }
	       {
		  obj_t aux_10246;
		  aux_10246 = CNST_TABLE_REF(((long) 44));
		  STRUCT_KEY_SET(res2097_2420, aux_10246);
	       }
	       return res2097_2420;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_pre_struct_ref_app3636_243_cfa_info(obj_t env_6905, obj_t o_6906, obj_t s_6907)
{
   {
      pre_struct_ref_app_207_t o_2406;
      obj_t s_2407;
      {
	 pre_struct_ref_app_207_t aux_10250;
	 o_2406 = (pre_struct_ref_app_207_t) (o_6906);
	 s_2407 = s_6907;
	 {
	    {
	       obj_t old2116_2410;
	       {
		  obj_t next_method2226_7_2415;
		  next_method2226_7_2415 = find_super_class_method_167___object((object_t) (o_2406), struct_object__object_env_209___object, pre_struct_ref_app_207_cfa_info);
		  if (PROCEDUREP(next_method2226_7_2415))
		    {
		       old2116_2410 = PROCEDURE_ENTRY(next_method2226_7_2415) (next_method2226_7_2415, (obj_t) (o_2406), s_2407, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2226_7_2415);
		       {
			  object_t aux_10259;
			  aux_10259 = struct_object__object_93___object((object_t) (o_2406), s_2407);
			  old2116_2410 = (obj_t) (aux_10259);
		       }
		    }
	       }
	       {
		  pre_struct_ref_app_207_t new2118_2412;
		  new2118_2412 = ((pre_struct_ref_app_207_t) (old2116_2410));
		  {
		     long arg2669_2413;
		     arg2669_2413 = class_num_218___object(pre_struct_ref_app_207_cfa_info);
		     {
			obj_t obj_4559;
			obj_4559 = (obj_t) (new2118_2412);
			(((obj_t) CREF(obj_4559))->header = MAKE_HEADER(arg2669_2413, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_10269;
		     object_t aux_10267;
		     {
			pre_struct_ref_app_207_t aux_10270;
			{
			   aux_10270 = ((pre_struct_ref_app_207_t) BREF(GC_MALLOC(sizeof(struct pre_struct_ref_app_207))));
			}
			aux_10269 = (obj_t) (aux_10270);
		     }
		     aux_10267 = (object_t) (new2118_2412);
		     OBJECT_WIDENING_SET(aux_10267, aux_10269);
		  }
		  aux_10250 = new2118_2412;
	       }
	    }
	 }
	 return (obj_t) (aux_10250);
      }
   }
}


obj_t 
object__struct_pre_struct_ref_app3637_3_cfa_info(obj_t env_6908, obj_t obj2113_6909)
{
   {
      pre_struct_ref_app_207_t obj2113_2395;
      obj2113_2395 = (pre_struct_ref_app_207_t) (obj2113_6909);
      {
	 {
	    obj_t res2114_2398;
	    {
	       obj_t next_method2224_73_2404;
	       next_method2224_73_2404 = find_super_class_method_167___object((object_t) (obj2113_2395), object__struct_env_210___object, pre_struct_ref_app_207_cfa_info);
	       if (PROCEDUREP(next_method2224_73_2404))
		 {
		    res2114_2398 = PROCEDURE_ENTRY(next_method2224_73_2404) (next_method2224_73_2404, (obj_t) (obj2113_2395), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2224_73_2404);
		    res2114_2398 = object__struct_50___object((object_t) (obj2113_2395));
		 }
	    }
	    {
	       obj_t aux2115_2399;
	       {
		  obj_t aux_10286;
		  aux_10286 = CNST_TABLE_REF(((long) 45));
		  aux2115_2399 = make_struct(aux_10286, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res2114_2398, ((long) 0), aux2115_2399);
	       {
		  obj_t aux_10290;
		  aux_10290 = STRUCT_KEY(res2114_2398);
		  STRUCT_KEY_SET(aux2115_2399, aux_10290);
	       }
	       {
		  obj_t aux_10293;
		  aux_10293 = CNST_TABLE_REF(((long) 45));
		  STRUCT_KEY_SET(res2114_2398, aux_10293);
	       }
	       return res2114_2398;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_pre_struct_set__app3638_251_cfa_info(obj_t env_6910, obj_t o_6911, obj_t s_6912)
{
   {
      pre_struct_set__app_116_t o_2384;
      obj_t s_2385;
      {
	 pre_struct_set__app_116_t aux_10297;
	 o_2384 = (pre_struct_set__app_116_t) (o_6911);
	 s_2385 = s_6912;
	 {
	    {
	       obj_t old2133_2388;
	       {
		  obj_t next_method2222_40_2393;
		  next_method2222_40_2393 = find_super_class_method_167___object((object_t) (o_2384), struct_object__object_env_209___object, pre_struct_set__app_116_cfa_info);
		  if (PROCEDUREP(next_method2222_40_2393))
		    {
		       old2133_2388 = PROCEDURE_ENTRY(next_method2222_40_2393) (next_method2222_40_2393, (obj_t) (o_2384), s_2385, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2222_40_2393);
		       {
			  object_t aux_10306;
			  aux_10306 = struct_object__object_93___object((object_t) (o_2384), s_2385);
			  old2133_2388 = (obj_t) (aux_10306);
		       }
		    }
	       }
	       {
		  pre_struct_set__app_116_t new2135_2390;
		  new2135_2390 = ((pre_struct_set__app_116_t) (old2133_2388));
		  {
		     long arg2661_2391;
		     arg2661_2391 = class_num_218___object(pre_struct_set__app_116_cfa_info);
		     {
			obj_t obj_4538;
			obj_4538 = (obj_t) (new2135_2390);
			(((obj_t) CREF(obj_4538))->header = MAKE_HEADER(arg2661_2391, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_10316;
		     object_t aux_10314;
		     {
			pre_struct_set__app_116_t aux_10317;
			{
			   aux_10317 = ((pre_struct_set__app_116_t) BREF(GC_MALLOC(sizeof(struct pre_struct_set__app_116))));
			}
			aux_10316 = (obj_t) (aux_10317);
		     }
		     aux_10314 = (object_t) (new2135_2390);
		     OBJECT_WIDENING_SET(aux_10314, aux_10316);
		  }
		  aux_10297 = new2135_2390;
	       }
	    }
	 }
	 return (obj_t) (aux_10297);
      }
   }
}


obj_t 
object__struct_pre_struct_set__app3639_134_cfa_info(obj_t env_6913, obj_t obj2130_6914)
{
   {
      pre_struct_set__app_116_t obj2130_2373;
      obj2130_2373 = (pre_struct_set__app_116_t) (obj2130_6914);
      {
	 {
	    obj_t res2131_2376;
	    {
	       obj_t next_method2220_65_2382;
	       next_method2220_65_2382 = find_super_class_method_167___object((object_t) (obj2130_2373), object__struct_env_210___object, pre_struct_set__app_116_cfa_info);
	       if (PROCEDUREP(next_method2220_65_2382))
		 {
		    res2131_2376 = PROCEDURE_ENTRY(next_method2220_65_2382) (next_method2220_65_2382, (obj_t) (obj2130_2373), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2220_65_2382);
		    res2131_2376 = object__struct_50___object((object_t) (obj2130_2373));
		 }
	    }
	    {
	       obj_t aux2132_2377;
	       {
		  obj_t aux_10333;
		  aux_10333 = CNST_TABLE_REF(((long) 46));
		  aux2132_2377 = make_struct(aux_10333, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res2131_2376, ((long) 0), aux2132_2377);
	       {
		  obj_t aux_10337;
		  aux_10337 = STRUCT_KEY(res2131_2376);
		  STRUCT_KEY_SET(aux2132_2377, aux_10337);
	       }
	       {
		  obj_t aux_10340;
		  aux_10340 = CNST_TABLE_REF(((long) 46));
		  STRUCT_KEY_SET(res2131_2376, aux_10340);
	       }
	       return res2131_2376;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_make_struct_app3640_52_cfa_info(obj_t env_6915, obj_t o_6916, obj_t s_6917)
{
   {
      make_struct_app_214_t o_2355;
      obj_t s_2356;
      {
	 make_struct_app_214_t aux_10344;
	 o_2355 = (make_struct_app_214_t) (o_6916);
	 s_2356 = s_6917;
	 {
	    {
	       obj_t old2154_2359;
	       obj_t aux2155_2360;
	       {
		  obj_t next_method2196_205_2371;
		  next_method2196_205_2371 = find_super_class_method_167___object((object_t) (o_2355), struct_object__object_env_209___object, make_struct_app_214_cfa_info);
		  if (PROCEDUREP(next_method2196_205_2371))
		    {
		       old2154_2359 = PROCEDURE_ENTRY(next_method2196_205_2371) (next_method2196_205_2371, (obj_t) (o_2355), s_2356, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2196_205_2371);
		       {
			  object_t aux_10353;
			  aux_10353 = struct_object__object_93___object((object_t) (o_2355), s_2356);
			  old2154_2359 = (obj_t) (aux_10353);
		       }
		    }
	       }
	       aux2155_2360 = STRUCT_REF(s_2356, ((long) 0));
	       {
		  make_struct_app_214_t new2156_2361;
		  new2156_2361 = ((make_struct_app_214_t) (old2154_2359));
		  {
		     long arg2646_2362;
		     arg2646_2362 = class_num_218___object(make_struct_app_214_cfa_info);
		     {
			obj_t obj_4489;
			obj_4489 = (obj_t) (new2156_2361);
			(((obj_t) CREF(obj_4489))->header = MAKE_HEADER(arg2646_2362, 0), BUNSPEC);
		     }
		  }
		  {
		     make_struct_app_214_t arg2647_2363;
		     {
			obj_t arg2648_2364;
			obj_t arg2654_2370;
			arg2648_2364 = STRUCT_REF(aux2155_2360, ((long) 0));
			arg2654_2370 = STRUCT_REF(aux2155_2360, ((long) 6));
			{
			   make_struct_app_214_t res3495_4520;
			   {
			      approx_t approx_4506;
			      approx_t value_approx_19_4507;
			      long lost_stamp_114_4508;
			      variable_t owner_4509;
			      bool_t stackable__42_4510;
			      {
				 obj_t aux_10364;
				 aux_10364 = STRUCT_REF(aux2155_2360, ((long) 1));
				 approx_4506 = (approx_t) (aux_10364);
			      }
			      {
				 obj_t aux_10367;
				 aux_10367 = STRUCT_REF(aux2155_2360, ((long) 2));
				 value_approx_19_4507 = (approx_t) (aux_10367);
			      }
			      {
				 obj_t aux_10370;
				 aux_10370 = STRUCT_REF(aux2155_2360, ((long) 3));
				 lost_stamp_114_4508 = (long) CINT(aux_10370);
			      }
			      {
				 obj_t aux_10373;
				 aux_10373 = STRUCT_REF(aux2155_2360, ((long) 4));
				 owner_4509 = (variable_t) (aux_10373);
			      }
			      {
				 obj_t aux_10376;
				 aux_10376 = STRUCT_REF(aux2155_2360, ((long) 5));
				 stackable__42_4510 = CBOOL(aux_10376);
			      }
			      {
				 make_struct_app_214_t new2137_4512;
				 new2137_4512 = ((make_struct_app_214_t) BREF(GC_MALLOC(sizeof(struct make_struct_app_214))));
				 ((((make_struct_app_214_t) CREF(new2137_4512))->key) = ((obj_t) arg2648_2364), BUNSPEC);
				 ((((make_struct_app_214_t) CREF(new2137_4512))->approx) = ((approx_t) approx_4506), BUNSPEC);
				 ((((make_struct_app_214_t) CREF(new2137_4512))->value_approx_19) = ((approx_t) value_approx_19_4507), BUNSPEC);
				 ((((make_struct_app_214_t) CREF(new2137_4512))->lost_stamp_114) = ((long) lost_stamp_114_4508), BUNSPEC);
				 ((((make_struct_app_214_t) CREF(new2137_4512))->owner) = ((variable_t) owner_4509), BUNSPEC);
				 ((((make_struct_app_214_t) CREF(new2137_4512))->stackable__42) = ((bool_t) stackable__42_4510), BUNSPEC);
				 ((((make_struct_app_214_t) CREF(new2137_4512))->stack_stamp_31) = ((obj_t) arg2654_2370), BUNSPEC);
				 res3495_4520 = new2137_4512;
			      }
			   }
			   arg2647_2363 = res3495_4520;
			}
		     }
		     {
			obj_t aux_10389;
			object_t aux_10387;
			aux_10389 = (obj_t) (arg2647_2363);
			aux_10387 = (object_t) (new2156_2361);
			OBJECT_WIDENING_SET(aux_10387, aux_10389);
		     }
		  }
		  aux_10344 = new2156_2361;
	       }
	    }
	 }
	 return (obj_t) (aux_10344);
      }
   }
}


obj_t 
object__struct_make_struct_app3641_26_cfa_info(obj_t env_6918, obj_t obj2151_6919)
{
   {
      make_struct_app_214_t obj2151_2330;
      obj2151_2330 = (make_struct_app_214_t) (obj2151_6919);
      {
	 {
	    obj_t res2152_2333;
	    {
	       obj_t next_method2195_109_2353;
	       next_method2195_109_2353 = find_super_class_method_167___object((object_t) (obj2151_2330), object__struct_env_210___object, make_struct_app_214_cfa_info);
	       if (PROCEDUREP(next_method2195_109_2353))
		 {
		    res2152_2333 = PROCEDURE_ENTRY(next_method2195_109_2353) (next_method2195_109_2353, (obj_t) (obj2151_2330), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2195_109_2353);
		    res2152_2333 = object__struct_50___object((object_t) (obj2151_2330));
		 }
	    }
	    {
	       obj_t aux2153_2334;
	       {
		  obj_t aux_10404;
		  aux_10404 = CNST_TABLE_REF(((long) 47));
		  aux2153_2334 = make_struct(aux_10404, ((long) 7), BUNSPEC);
	       }
	       {
		  obj_t aux_10407;
		  {
		     obj_t aux_10408;
		     {
			object_t aux_10409;
			aux_10409 = (object_t) (obj2151_2330);
			aux_10408 = OBJECT_WIDENING(aux_10409);
		     }
		     aux_10407 = (((make_struct_app_214_t) CREF(aux_10408))->key);
		  }
		  STRUCT_SET(aux2153_2334, ((long) 0), aux_10407);
	       }
	       {
		  obj_t aux_10414;
		  {
		     approx_t aux_10415;
		     {
			obj_t aux_10416;
			{
			   object_t aux_10417;
			   aux_10417 = (object_t) (obj2151_2330);
			   aux_10416 = OBJECT_WIDENING(aux_10417);
			}
			aux_10415 = (((make_struct_app_214_t) CREF(aux_10416))->approx);
		     }
		     aux_10414 = (obj_t) (aux_10415);
		  }
		  STRUCT_SET(aux2153_2334, ((long) 1), aux_10414);
	       }
	       {
		  obj_t aux_10423;
		  {
		     approx_t aux_10424;
		     {
			obj_t aux_10425;
			{
			   object_t aux_10426;
			   aux_10426 = (object_t) (obj2151_2330);
			   aux_10425 = OBJECT_WIDENING(aux_10426);
			}
			aux_10424 = (((make_struct_app_214_t) CREF(aux_10425))->value_approx_19);
		     }
		     aux_10423 = (obj_t) (aux_10424);
		  }
		  STRUCT_SET(aux2153_2334, ((long) 2), aux_10423);
	       }
	       {
		  obj_t aux_10432;
		  {
		     long aux_10433;
		     {
			obj_t aux_10434;
			{
			   object_t aux_10435;
			   aux_10435 = (object_t) (obj2151_2330);
			   aux_10434 = OBJECT_WIDENING(aux_10435);
			}
			aux_10433 = (((make_struct_app_214_t) CREF(aux_10434))->lost_stamp_114);
		     }
		     aux_10432 = BINT(aux_10433);
		  }
		  STRUCT_SET(aux2153_2334, ((long) 3), aux_10432);
	       }
	       {
		  obj_t aux_10441;
		  {
		     variable_t aux_10442;
		     {
			obj_t aux_10443;
			{
			   object_t aux_10444;
			   aux_10444 = (object_t) (obj2151_2330);
			   aux_10443 = OBJECT_WIDENING(aux_10444);
			}
			aux_10442 = (((make_struct_app_214_t) CREF(aux_10443))->owner);
		     }
		     aux_10441 = (obj_t) (aux_10442);
		  }
		  STRUCT_SET(aux2153_2334, ((long) 4), aux_10441);
	       }
	       {
		  obj_t aux_10450;
		  {
		     bool_t aux_10451;
		     {
			obj_t aux_10452;
			{
			   object_t aux_10453;
			   aux_10453 = (object_t) (obj2151_2330);
			   aux_10452 = OBJECT_WIDENING(aux_10453);
			}
			aux_10451 = (((make_struct_app_214_t) CREF(aux_10452))->stackable__42);
		     }
		     aux_10450 = BBOOL(aux_10451);
		  }
		  STRUCT_SET(aux2153_2334, ((long) 5), aux_10450);
	       }
	       {
		  obj_t aux_10459;
		  {
		     obj_t aux_10460;
		     {
			object_t aux_10461;
			aux_10461 = (object_t) (obj2151_2330);
			aux_10460 = OBJECT_WIDENING(aux_10461);
		     }
		     aux_10459 = (((make_struct_app_214_t) CREF(aux_10460))->stack_stamp_31);
		  }
		  STRUCT_SET(aux2153_2334, ((long) 6), aux_10459);
	       }
	       STRUCT_SET(res2152_2333, ((long) 0), aux2153_2334);
	       {
		  obj_t aux_10467;
		  aux_10467 = STRUCT_KEY(res2152_2333);
		  STRUCT_KEY_SET(aux2153_2334, aux_10467);
	       }
	       {
		  obj_t aux_10470;
		  aux_10470 = CNST_TABLE_REF(((long) 47));
		  STRUCT_KEY_SET(res2152_2333, aux_10470);
	       }
	       return res2152_2333;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_struct_ref_app3642_41_cfa_info(obj_t env_6920, obj_t o_6921, obj_t s_6922)
{
   {
      struct_ref_app_73_t o_2318;
      obj_t s_2319;
      {
	 struct_ref_app_73_t aux_10474;
	 o_2318 = (struct_ref_app_73_t) (o_6921);
	 s_2319 = s_6922;
	 {
	    {
	       obj_t old2171_2322;
	       obj_t aux2172_2323;
	       {
		  obj_t next_method2194_47_2328;
		  next_method2194_47_2328 = find_super_class_method_167___object((object_t) (o_2318), struct_object__object_env_209___object, struct_ref_app_73_cfa_info);
		  if (PROCEDUREP(next_method2194_47_2328))
		    {
		       old2171_2322 = PROCEDURE_ENTRY(next_method2194_47_2328) (next_method2194_47_2328, (obj_t) (o_2318), s_2319, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2194_47_2328);
		       {
			  object_t aux_10483;
			  aux_10483 = struct_object__object_93___object((object_t) (o_2318), s_2319);
			  old2171_2322 = (obj_t) (aux_10483);
		       }
		    }
	       }
	       aux2172_2323 = STRUCT_REF(s_2319, ((long) 0));
	       {
		  struct_ref_app_73_t new2173_2324;
		  new2173_2324 = ((struct_ref_app_73_t) (old2171_2322));
		  {
		     long arg2622_2325;
		     arg2622_2325 = class_num_218___object(struct_ref_app_73_cfa_info);
		     {
			obj_t obj_4436;
			obj_4436 = (obj_t) (new2173_2324);
			(((obj_t) CREF(obj_4436))->header = MAKE_HEADER(arg2622_2325, 0), BUNSPEC);
		     }
		  }
		  {
		     struct_ref_app_73_t arg2623_2326;
		     {
			struct_ref_app_73_t res3494_4443;
			{
			   approx_t approx_4440;
			   {
			      obj_t aux_10492;
			      aux_10492 = STRUCT_REF(aux2172_2323, ((long) 0));
			      approx_4440 = (approx_t) (aux_10492);
			   }
			   {
			      struct_ref_app_73_t new2158_4441;
			      new2158_4441 = ((struct_ref_app_73_t) BREF(GC_MALLOC(sizeof(struct struct_ref_app_73))));
			      ((((struct_ref_app_73_t) CREF(new2158_4441))->approx) = ((approx_t) approx_4440), BUNSPEC);
			      res3494_4443 = new2158_4441;
			   }
			}
			arg2623_2326 = res3494_4443;
		     }
		     {
			obj_t aux_10499;
			object_t aux_10497;
			aux_10499 = (obj_t) (arg2623_2326);
			aux_10497 = (object_t) (new2173_2324);
			OBJECT_WIDENING_SET(aux_10497, aux_10499);
		     }
		  }
		  aux_10474 = new2173_2324;
	       }
	    }
	 }
	 return (obj_t) (aux_10474);
      }
   }
}


obj_t 
object__struct_struct_ref_app3643_175_cfa_info(obj_t env_6923, obj_t obj2168_6924)
{
   {
      struct_ref_app_73_t obj2168_2305;
      obj2168_2305 = (struct_ref_app_73_t) (obj2168_6924);
      {
	 {
	    obj_t res2169_2308;
	    {
	       obj_t next_method2193_53_2316;
	       next_method2193_53_2316 = find_super_class_method_167___object((object_t) (obj2168_2305), object__struct_env_210___object, struct_ref_app_73_cfa_info);
	       if (PROCEDUREP(next_method2193_53_2316))
		 {
		    res2169_2308 = PROCEDURE_ENTRY(next_method2193_53_2316) (next_method2193_53_2316, (obj_t) (obj2168_2305), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2193_53_2316);
		    res2169_2308 = object__struct_50___object((object_t) (obj2168_2305));
		 }
	    }
	    {
	       obj_t aux2170_2309;
	       {
		  obj_t aux_10514;
		  aux_10514 = CNST_TABLE_REF(((long) 48));
		  aux2170_2309 = make_struct(aux_10514, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_10517;
		  {
		     approx_t aux_10518;
		     {
			obj_t aux_10519;
			{
			   object_t aux_10520;
			   aux_10520 = (object_t) (obj2168_2305);
			   aux_10519 = OBJECT_WIDENING(aux_10520);
			}
			aux_10518 = (((struct_ref_app_73_t) CREF(aux_10519))->approx);
		     }
		     aux_10517 = (obj_t) (aux_10518);
		  }
		  STRUCT_SET(aux2170_2309, ((long) 0), aux_10517);
	       }
	       STRUCT_SET(res2169_2308, ((long) 0), aux2170_2309);
	       {
		  obj_t aux_10527;
		  aux_10527 = STRUCT_KEY(res2169_2308);
		  STRUCT_KEY_SET(aux2170_2309, aux_10527);
	       }
	       {
		  obj_t aux_10530;
		  aux_10530 = CNST_TABLE_REF(((long) 48));
		  STRUCT_KEY_SET(res2169_2308, aux_10530);
	       }
	       return res2169_2308;
	    }
	 }
      }
   }
}


obj_t 
struct_object__object_struct_set__app3644_201_cfa_info(obj_t env_6925, obj_t o_6926, obj_t s_6927)
{
   {
      struct_set__app_162_t o_2293;
      obj_t s_2294;
      {
	 struct_set__app_162_t aux_10534;
	 o_2293 = (struct_set__app_162_t) (o_6926);
	 s_2294 = s_6927;
	 {
	    {
	       obj_t old2188_2297;
	       obj_t aux2189_2298;
	       {
		  obj_t next_method2192_162_2303;
		  next_method2192_162_2303 = find_super_class_method_167___object((object_t) (o_2293), struct_object__object_env_209___object, struct_set__app_162_cfa_info);
		  if (PROCEDUREP(next_method2192_162_2303))
		    {
		       old2188_2297 = PROCEDURE_ENTRY(next_method2192_162_2303) (next_method2192_162_2303, (obj_t) (o_2293), s_2294, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2192_162_2303);
		       {
			  object_t aux_10543;
			  aux_10543 = struct_object__object_93___object((object_t) (o_2293), s_2294);
			  old2188_2297 = (obj_t) (aux_10543);
		       }
		    }
	       }
	       aux2189_2298 = STRUCT_REF(s_2294, ((long) 0));
	       {
		  struct_set__app_162_t new2190_2299;
		  new2190_2299 = ((struct_set__app_162_t) (old2188_2297));
		  {
		     long arg2611_2300;
		     arg2611_2300 = class_num_218___object(struct_set__app_162_cfa_info);
		     {
			obj_t obj_4407;
			obj_4407 = (obj_t) (new2190_2299);
			(((obj_t) CREF(obj_4407))->header = MAKE_HEADER(arg2611_2300, 0), BUNSPEC);
		     }
		  }
		  {
		     struct_set__app_162_t arg2612_2301;
		     {
			struct_set__app_162_t res3493_4414;
			{
			   approx_t approx_4411;
			   {
			      obj_t aux_10552;
			      aux_10552 = STRUCT_REF(aux2189_2298, ((long) 0));
			      approx_4411 = (approx_t) (aux_10552);
			   }
			   {
			      struct_set__app_162_t new2175_4412;
			      new2175_4412 = ((struct_set__app_162_t) BREF(GC_MALLOC(sizeof(struct struct_set__app_162))));
			      ((((struct_set__app_162_t) CREF(new2175_4412))->approx) = ((approx_t) approx_4411), BUNSPEC);
			      res3493_4414 = new2175_4412;
			   }
			}
			arg2612_2301 = res3493_4414;
		     }
		     {
			obj_t aux_10559;
			object_t aux_10557;
			aux_10559 = (obj_t) (arg2612_2301);
			aux_10557 = (object_t) (new2190_2299);
			OBJECT_WIDENING_SET(aux_10557, aux_10559);
		     }
		  }
		  aux_10534 = new2190_2299;
	       }
	    }
	 }
	 return (obj_t) (aux_10534);
      }
   }
}


obj_t 
object__struct_struct_set__app3645_97_cfa_info(obj_t env_6928, obj_t obj2185_6929)
{
   {
      struct_set__app_162_t obj2185_2280;
      obj2185_2280 = (struct_set__app_162_t) (obj2185_6929);
      {
	 {
	    obj_t res2186_2283;
	    {
	       obj_t next_method2191_215_2291;
	       next_method2191_215_2291 = find_super_class_method_167___object((object_t) (obj2185_2280), object__struct_env_210___object, struct_set__app_162_cfa_info);
	       if (PROCEDUREP(next_method2191_215_2291))
		 {
		    res2186_2283 = PROCEDURE_ENTRY(next_method2191_215_2291) (next_method2191_215_2291, (obj_t) (obj2185_2280), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2191_215_2291);
		    res2186_2283 = object__struct_50___object((object_t) (obj2185_2280));
		 }
	    }
	    {
	       obj_t aux2187_2284;
	       {
		  obj_t aux_10574;
		  aux_10574 = CNST_TABLE_REF(((long) 49));
		  aux2187_2284 = make_struct(aux_10574, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_10577;
		  {
		     approx_t aux_10578;
		     {
			obj_t aux_10579;
			{
			   object_t aux_10580;
			   aux_10580 = (object_t) (obj2185_2280);
			   aux_10579 = OBJECT_WIDENING(aux_10580);
			}
			aux_10578 = (((struct_set__app_162_t) CREF(aux_10579))->approx);
		     }
		     aux_10577 = (obj_t) (aux_10578);
		  }
		  STRUCT_SET(aux2187_2284, ((long) 0), aux_10577);
	       }
	       STRUCT_SET(res2186_2283, ((long) 0), aux2187_2284);
	       {
		  obj_t aux_10587;
		  aux_10587 = STRUCT_KEY(res2186_2283);
		  STRUCT_KEY_SET(aux2187_2284, aux_10587);
	       }
	       {
		  obj_t aux_10590;
		  aux_10590 = CNST_TABLE_REF(((long) 49));
		  STRUCT_KEY_SET(res2186_2283, aux_10590);
	       }
	       return res2186_2283;
	    }
	 }
      }
   }
}


app_t 
allocate_struct_set__app_3_cfa_info()
{
   {
      app_t new2184_3640;
      new2184_3640 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3268_3641;
	 arg3268_3641 = class_num_218___object(struct_set__app_162_cfa_info);
	 {
	    obj_t obj_6129;
	    obj_6129 = (obj_t) (new2184_3640);
	    (((obj_t) CREF(obj_6129))->header = MAKE_HEADER(arg3268_3641, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10598;
	 aux_10598 = (object_t) (new2184_3640);
	 OBJECT_WIDENING_SET(aux_10598, BFALSE);
      }
      return new2184_3640;
   }
}


obj_t 
_allocate_struct_set__app_138_cfa_info(obj_t env_6979)
{
   {
      app_t aux_10601;
      aux_10601 = allocate_struct_set__app_3_cfa_info();
      return (obj_t) (aux_10601);
   }
}


app_t 
allocate_struct_ref_app_224_cfa_info()
{
   {
      app_t new2167_3648;
      new2167_3648 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3272_3649;
	 arg3272_3649 = class_num_218___object(struct_ref_app_73_cfa_info);
	 {
	    obj_t obj_6133;
	    obj_6133 = (obj_t) (new2167_3648);
	    (((obj_t) CREF(obj_6133))->header = MAKE_HEADER(arg3272_3649, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10608;
	 aux_10608 = (object_t) (new2167_3648);
	 OBJECT_WIDENING_SET(aux_10608, BFALSE);
      }
      return new2167_3648;
   }
}


obj_t 
_allocate_struct_ref_app_88_cfa_info(obj_t env_6978)
{
   {
      app_t aux_10611;
      aux_10611 = allocate_struct_ref_app_224_cfa_info();
      return (obj_t) (aux_10611);
   }
}


app_t 
allocate_make_struct_app_180_cfa_info()
{
   {
      app_t new2150_3656;
      new2150_3656 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3275_3657;
	 arg3275_3657 = class_num_218___object(make_struct_app_214_cfa_info);
	 {
	    obj_t obj_6137;
	    obj_6137 = (obj_t) (new2150_3656);
	    (((obj_t) CREF(obj_6137))->header = MAKE_HEADER(arg3275_3657, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10618;
	 aux_10618 = (object_t) (new2150_3656);
	 OBJECT_WIDENING_SET(aux_10618, BFALSE);
      }
      return new2150_3656;
   }
}


obj_t 
_allocate_make_struct_app_151_cfa_info(obj_t env_6977)
{
   {
      app_t aux_10621;
      aux_10621 = allocate_make_struct_app_180_cfa_info();
      return (obj_t) (aux_10621);
   }
}


app_t 
allocate_pre_struct_set__app_186_cfa_info()
{
   {
      app_t new2129_3670;
      new2129_3670 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3278_3671;
	 arg3278_3671 = class_num_218___object(pre_struct_set__app_116_cfa_info);
	 {
	    obj_t obj_6147;
	    obj_6147 = (obj_t) (new2129_3670);
	    (((obj_t) CREF(obj_6147))->header = MAKE_HEADER(arg3278_3671, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10628;
	 aux_10628 = (object_t) (new2129_3670);
	 OBJECT_WIDENING_SET(aux_10628, BFALSE);
      }
      return new2129_3670;
   }
}


obj_t 
_allocate_pre_struct_set__app_93_cfa_info(obj_t env_6976)
{
   {
      app_t aux_10631;
      aux_10631 = allocate_pre_struct_set__app_186_cfa_info();
      return (obj_t) (aux_10631);
   }
}


app_t 
allocate_pre_struct_ref_app_69_cfa_info()
{
   {
      app_t new2112_3677;
      new2112_3677 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3281_3678;
	 arg3281_3678 = class_num_218___object(pre_struct_ref_app_207_cfa_info);
	 {
	    obj_t obj_6150;
	    obj_6150 = (obj_t) (new2112_3677);
	    (((obj_t) CREF(obj_6150))->header = MAKE_HEADER(arg3281_3678, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10638;
	 aux_10638 = (object_t) (new2112_3677);
	 OBJECT_WIDENING_SET(aux_10638, BFALSE);
      }
      return new2112_3677;
   }
}


obj_t 
_allocate_pre_struct_ref_app_15_cfa_info(obj_t env_6975)
{
   {
      app_t aux_10641;
      aux_10641 = allocate_pre_struct_ref_app_69_cfa_info();
      return (obj_t) (aux_10641);
   }
}


app_t 
allocate_pre_make_struct_app_64_cfa_info()
{
   {
      app_t new2095_3684;
      new2095_3684 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3284_3685;
	 arg3284_3685 = class_num_218___object(pre_make_struct_app_218_cfa_info);
	 {
	    obj_t obj_6153;
	    obj_6153 = (obj_t) (new2095_3684);
	    (((obj_t) CREF(obj_6153))->header = MAKE_HEADER(arg3284_3685, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10648;
	 aux_10648 = (object_t) (new2095_3684);
	 OBJECT_WIDENING_SET(aux_10648, BFALSE);
      }
      return new2095_3684;
   }
}


obj_t 
_allocate_pre_make_struct_app_85_cfa_info(obj_t env_6974)
{
   {
      app_t aux_10651;
      aux_10651 = allocate_pre_make_struct_app_64_cfa_info();
      return (obj_t) (aux_10651);
   }
}


app_t 
allocate_vector_set__app_126_cfa_info()
{
   {
      app_t new2077_3693;
      new2077_3693 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3287_3694;
	 arg3287_3694 = class_num_218___object(vector_set__app_21_cfa_info);
	 {
	    obj_t obj_6158;
	    obj_6158 = (obj_t) (new2077_3693);
	    (((obj_t) CREF(obj_6158))->header = MAKE_HEADER(arg3287_3694, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10658;
	 aux_10658 = (object_t) (new2077_3693);
	 OBJECT_WIDENING_SET(aux_10658, BFALSE);
      }
      return new2077_3693;
   }
}


obj_t 
_allocate_vector_set__app_158_cfa_info(obj_t env_6973)
{
   {
      app_t aux_10661;
      aux_10661 = allocate_vector_set__app_126_cfa_info();
      return (obj_t) (aux_10661);
   }
}


app_t 
allocate_vector_ref_app_0_cfa_info()
{
   {
      app_t new2060_3701;
      new2060_3701 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3290_3702;
	 arg3290_3702 = class_num_218___object(vector_ref_app_195_cfa_info);
	 {
	    obj_t obj_6162;
	    obj_6162 = (obj_t) (new2060_3701);
	    (((obj_t) CREF(obj_6162))->header = MAKE_HEADER(arg3290_3702, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10668;
	 aux_10668 = (object_t) (new2060_3701);
	 OBJECT_WIDENING_SET(aux_10668, BFALSE);
      }
      return new2060_3701;
   }
}


obj_t 
_allocate_vector_ref_app_194_cfa_info(obj_t env_6972)
{
   {
      app_t aux_10671;
      aux_10671 = allocate_vector_ref_app_0_cfa_info();
      return (obj_t) (aux_10671);
   }
}


app_t 
allocate_create_vector_app_89_cfa_info()
{
   {
      app_t new2043_3709;
      new2043_3709 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3293_3710;
	 arg3293_3710 = class_num_218___object(create_vector_app_150_cfa_info);
	 {
	    obj_t obj_6166;
	    obj_6166 = (obj_t) (new2043_3709);
	    (((obj_t) CREF(obj_6166))->header = MAKE_HEADER(arg3293_3710, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10678;
	 aux_10678 = (object_t) (new2043_3709);
	 OBJECT_WIDENING_SET(aux_10678, BFALSE);
      }
      return new2043_3709;
   }
}


obj_t 
_allocate_create_vector_app_246_cfa_info(obj_t env_6971)
{
   {
      app_t aux_10681;
      aux_10681 = allocate_create_vector_app_89_cfa_info();
      return (obj_t) (aux_10681);
   }
}


app_t 
allocate_make_vector_app_226_cfa_info()
{
   {
      app_t new2020_3724;
      new2020_3724 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3296_3725;
	 arg3296_3725 = class_num_218___object(make_vector_app_205_cfa_info);
	 {
	    obj_t obj_6177;
	    obj_6177 = (obj_t) (new2020_3724);
	    (((obj_t) CREF(obj_6177))->header = MAKE_HEADER(arg3296_3725, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10688;
	 aux_10688 = (object_t) (new2020_3724);
	 OBJECT_WIDENING_SET(aux_10688, BFALSE);
      }
      return new2020_3724;
   }
}


obj_t 
_allocate_make_vector_app_18_cfa_info(obj_t env_6970)
{
   {
      app_t aux_10691;
      aux_10691 = allocate_make_vector_app_226_cfa_info();
      return (obj_t) (aux_10691);
   }
}


app_t 
allocate_pre_vector_set__app_20_cfa_info()
{
   {
      app_t new1998_3739;
      new1998_3739 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3299_3740;
	 arg3299_3740 = class_num_218___object(pre_vector_set__app_211_cfa_info);
	 {
	    obj_t obj_6188;
	    obj_6188 = (obj_t) (new1998_3739);
	    (((obj_t) CREF(obj_6188))->header = MAKE_HEADER(arg3299_3740, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10698;
	 aux_10698 = (object_t) (new1998_3739);
	 OBJECT_WIDENING_SET(aux_10698, BFALSE);
      }
      return new1998_3739;
   }
}


obj_t 
_allocate_pre_vector_set__app_63_cfa_info(obj_t env_6969)
{
   {
      app_t aux_10701;
      aux_10701 = allocate_pre_vector_set__app_20_cfa_info();
      return (obj_t) (aux_10701);
   }
}


app_t 
allocate_pre_vector_ref_app_241_cfa_info()
{
   {
      app_t new1981_3746;
      new1981_3746 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3302_3747;
	 arg3302_3747 = class_num_218___object(pre_vector_ref_app_208_cfa_info);
	 {
	    obj_t obj_6191;
	    obj_6191 = (obj_t) (new1981_3746);
	    (((obj_t) CREF(obj_6191))->header = MAKE_HEADER(arg3302_3747, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10708;
	 aux_10708 = (object_t) (new1981_3746);
	 OBJECT_WIDENING_SET(aux_10708, BFALSE);
      }
      return new1981_3746;
   }
}


obj_t 
_allocate_pre_vector_ref_app_31_cfa_info(obj_t env_6968)
{
   {
      app_t aux_10711;
      aux_10711 = allocate_pre_vector_ref_app_241_cfa_info();
      return (obj_t) (aux_10711);
   }
}


app_t 
allocate_pre_create_vector_app_95_cfa_info()
{
   {
      app_t new1964_3753;
      new1964_3753 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3305_3754;
	 arg3305_3754 = class_num_218___object(pre_create_vector_app_162_cfa_info);
	 {
	    obj_t obj_6194;
	    obj_6194 = (obj_t) (new1964_3753);
	    (((obj_t) CREF(obj_6194))->header = MAKE_HEADER(arg3305_3754, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10718;
	 aux_10718 = (object_t) (new1964_3753);
	 OBJECT_WIDENING_SET(aux_10718, BFALSE);
      }
      return new1964_3753;
   }
}


obj_t 
_allocate_pre_create_vector_app_171_cfa_info(obj_t env_6967)
{
   {
      app_t aux_10721;
      aux_10721 = allocate_pre_create_vector_app_95_cfa_info();
      return (obj_t) (aux_10721);
   }
}


app_t 
allocate_pre_make_vector_app_231_cfa_info()
{
   {
      app_t new1946_3762;
      new1946_3762 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3308_3763;
	 arg3308_3763 = class_num_218___object(pre_make_vector_app_251_cfa_info);
	 {
	    obj_t obj_6199;
	    obj_6199 = (obj_t) (new1946_3762);
	    (((obj_t) CREF(obj_6199))->header = MAKE_HEADER(arg3308_3763, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10728;
	 aux_10728 = (object_t) (new1946_3762);
	 OBJECT_WIDENING_SET(aux_10728, BFALSE);
      }
      return new1946_3762;
   }
}


obj_t 
_allocate_pre_make_vector_app_80_cfa_info(obj_t env_6966)
{
   {
      app_t aux_10731;
      aux_10731 = allocate_pre_make_vector_app_231_cfa_info();
      return (obj_t) (aux_10731);
   }
}


app_t 
allocate_procedure_set__app_12_cfa_info()
{
   {
      app_t new1927_3771;
      new1927_3771 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3311_3772;
	 arg3311_3772 = class_num_218___object(procedure_set__app_32_cfa_info);
	 {
	    obj_t obj_6204;
	    obj_6204 = (obj_t) (new1927_3771);
	    (((obj_t) CREF(obj_6204))->header = MAKE_HEADER(arg3311_3772, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10738;
	 aux_10738 = (object_t) (new1927_3771);
	 OBJECT_WIDENING_SET(aux_10738, BFALSE);
      }
      return new1927_3771;
   }
}


obj_t 
_allocate_procedure_set__app_204_cfa_info(obj_t env_6965)
{
   {
      app_t aux_10741;
      aux_10741 = allocate_procedure_set__app_12_cfa_info();
      return (obj_t) (aux_10741);
   }
}


app_t 
allocate_procedure_ref_app_165_cfa_info()
{
   {
      app_t new1910_3779;
      new1910_3779 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3314_3780;
	 arg3314_3780 = class_num_218___object(procedure_ref_app_49_cfa_info);
	 {
	    obj_t obj_6208;
	    obj_6208 = (obj_t) (new1910_3779);
	    (((obj_t) CREF(obj_6208))->header = MAKE_HEADER(arg3314_3780, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10748;
	 aux_10748 = (object_t) (new1910_3779);
	 OBJECT_WIDENING_SET(aux_10748, BFALSE);
      }
      return new1910_3779;
   }
}


obj_t 
_allocate_procedure_ref_app_56_cfa_info(obj_t env_6964)
{
   {
      app_t aux_10751;
      aux_10751 = allocate_procedure_ref_app_165_cfa_info();
      return (obj_t) (aux_10751);
   }
}


app_t 
allocate_make_procedure_app_115_cfa_info()
{
   {
      app_t new1889_3787;
      new1889_3787 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3317_3788;
	 arg3317_3788 = class_num_218___object(make_procedure_app_48_cfa_info);
	 {
	    obj_t obj_6212;
	    obj_6212 = (obj_t) (new1889_3787);
	    (((obj_t) CREF(obj_6212))->header = MAKE_HEADER(arg3317_3788, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10758;
	 aux_10758 = (object_t) (new1889_3787);
	 OBJECT_WIDENING_SET(aux_10758, BFALSE);
      }
      return new1889_3787;
   }
}


obj_t 
_allocate_make_procedure_app_241_cfa_info(obj_t env_6963)
{
   {
      app_t aux_10761;
      aux_10761 = allocate_make_procedure_app_115_cfa_info();
      return (obj_t) (aux_10761);
   }
}


app_t 
allocate_pre_procedure_set__app_97_cfa_info()
{
   {
      app_t new1864_3809;
      new1864_3809 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3322_3810;
	 arg3322_3810 = class_num_218___object(pre_procedure_set__app_208_cfa_info);
	 {
	    obj_t obj_6234;
	    obj_6234 = (obj_t) (new1864_3809);
	    (((obj_t) CREF(obj_6234))->header = MAKE_HEADER(arg3322_3810, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10768;
	 aux_10768 = (object_t) (new1864_3809);
	 OBJECT_WIDENING_SET(aux_10768, BFALSE);
      }
      return new1864_3809;
   }
}


obj_t 
_allocate_pre_procedure_set__app_24_cfa_info(obj_t env_6962)
{
   {
      app_t aux_10771;
      aux_10771 = allocate_pre_procedure_set__app_97_cfa_info();
      return (obj_t) (aux_10771);
   }
}


app_t 
allocate_pre_procedure_ref_app_138_cfa_info()
{
   {
      app_t new1846_3816;
      new1846_3816 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3325_3817;
	 arg3325_3817 = class_num_218___object(pre_procedure_ref_app_85_cfa_info);
	 {
	    obj_t obj_6237;
	    obj_6237 = (obj_t) (new1846_3816);
	    (((obj_t) CREF(obj_6237))->header = MAKE_HEADER(arg3325_3817, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10778;
	 aux_10778 = (object_t) (new1846_3816);
	 OBJECT_WIDENING_SET(aux_10778, BFALSE);
      }
      return new1846_3816;
   }
}


obj_t 
_allocate_pre_procedure_ref_app_105_cfa_info(obj_t env_6961)
{
   {
      app_t aux_10781;
      aux_10781 = allocate_pre_procedure_ref_app_138_cfa_info();
      return (obj_t) (aux_10781);
   }
}


app_t 
allocate_pre_make_procedure_app_4_cfa_info()
{
   {
      app_t new1829_3823;
      new1829_3823 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg3328_3824;
	 arg3328_3824 = class_num_218___object(pre_make_procedure_app_60_cfa_info);
	 {
	    obj_t obj_6240;
	    obj_6240 = (obj_t) (new1829_3823);
	    (((obj_t) CREF(obj_6240))->header = MAKE_HEADER(arg3328_3824, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10788;
	 aux_10788 = (object_t) (new1829_3823);
	 OBJECT_WIDENING_SET(aux_10788, BFALSE);
      }
      return new1829_3823;
   }
}


obj_t 
_allocate_pre_make_procedure_app_108_cfa_info(obj_t env_6960)
{
   {
      app_t aux_10791;
      aux_10791 = allocate_pre_make_procedure_app_4_cfa_info();
      return (obj_t) (aux_10791);
   }
}


box_ref_242_t 
allocate_box_ref_o_cinfo_99_cfa_info()
{
   {
      box_ref_242_t new1811_3832;
      new1811_3832 = ((box_ref_242_t) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
      {
	 long arg3331_3833;
	 arg3331_3833 = class_num_218___object(box_ref_o_cinfo_98_cfa_info);
	 {
	    obj_t obj_6245;
	    obj_6245 = (obj_t) (new1811_3832);
	    (((obj_t) CREF(obj_6245))->header = MAKE_HEADER(arg3331_3833, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10798;
	 aux_10798 = (object_t) (new1811_3832);
	 OBJECT_WIDENING_SET(aux_10798, BFALSE);
      }
      return new1811_3832;
   }
}


obj_t 
_allocate_box_ref_o_cinfo_197_cfa_info(obj_t env_6959)
{
   {
      box_ref_242_t aux_10801;
      aux_10801 = allocate_box_ref_o_cinfo_99_cfa_info();
      return (obj_t) (aux_10801);
   }
}


box_set__221_t 
allocate_box_set__o_cinfo_236_cfa_info()
{
   {
      box_set__221_t new1796_3840;
      new1796_3840 = ((box_set__221_t) BREF(GC_MALLOC(sizeof(struct box_set__221))));
      {
	 long arg3334_3841;
	 arg3334_3841 = class_num_218___object(box_set__o_cinfo_6_cfa_info);
	 {
	    obj_t obj_6249;
	    obj_6249 = (obj_t) (new1796_3840);
	    (((obj_t) CREF(obj_6249))->header = MAKE_HEADER(arg3334_3841, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10808;
	 aux_10808 = (object_t) (new1796_3840);
	 OBJECT_WIDENING_SET(aux_10808, BFALSE);
      }
      return new1796_3840;
   }
}


obj_t 
_allocate_box_set__o_cinfo_20_cfa_info(obj_t env_6958)
{
   {
      box_set__221_t aux_10811;
      aux_10811 = allocate_box_set__o_cinfo_236_cfa_info();
      return (obj_t) (aux_10811);
   }
}


box_ref_242_t 
allocate_box_ref_cinfo_31_cfa_info()
{
   {
      box_ref_242_t new1781_3848;
      new1781_3848 = ((box_ref_242_t) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
      {
	 long arg3337_3849;
	 arg3337_3849 = class_num_218___object(box_ref_cinfo_214_cfa_info);
	 {
	    obj_t obj_6253;
	    obj_6253 = (obj_t) (new1781_3848);
	    (((obj_t) CREF(obj_6253))->header = MAKE_HEADER(arg3337_3849, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10818;
	 aux_10818 = (object_t) (new1781_3848);
	 OBJECT_WIDENING_SET(aux_10818, BFALSE);
      }
      return new1781_3848;
   }
}


obj_t 
_allocate_box_ref_cinfo_238_cfa_info(obj_t env_6957)
{
   {
      box_ref_242_t aux_10821;
      aux_10821 = allocate_box_ref_cinfo_31_cfa_info();
      return (obj_t) (aux_10821);
   }
}


box_set__221_t 
allocate_box_set__cinfo_232_cfa_info()
{
   {
      box_set__221_t new1766_3856;
      new1766_3856 = ((box_set__221_t) BREF(GC_MALLOC(sizeof(struct box_set__221))));
      {
	 long arg3340_3857;
	 arg3340_3857 = class_num_218___object(box_set__cinfo_94_cfa_info);
	 {
	    obj_t obj_6257;
	    obj_6257 = (obj_t) (new1766_3856);
	    (((obj_t) CREF(obj_6257))->header = MAKE_HEADER(arg3340_3857, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10828;
	 aux_10828 = (object_t) (new1766_3856);
	 OBJECT_WIDENING_SET(aux_10828, BFALSE);
      }
      return new1766_3856;
   }
}


obj_t 
_allocate_box_set__cinfo_187_cfa_info(obj_t env_6956)
{
   {
      box_set__221_t aux_10831;
      aux_10831 = allocate_box_set__cinfo_232_cfa_info();
      return (obj_t) (aux_10831);
   }
}


make_box_202_t 
allocate_make_box_o_cinfo_222_cfa_info()
{
   {
      make_box_202_t new1749_3864;
      new1749_3864 = ((make_box_202_t) BREF(GC_MALLOC(sizeof(struct make_box_202))));
      {
	 long arg3343_3865;
	 arg3343_3865 = class_num_218___object(make_box_o_cinfo_96_cfa_info);
	 {
	    obj_t obj_6261;
	    obj_6261 = (obj_t) (new1749_3864);
	    (((obj_t) CREF(obj_6261))->header = MAKE_HEADER(arg3343_3865, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10838;
	 aux_10838 = (object_t) (new1749_3864);
	 OBJECT_WIDENING_SET(aux_10838, BFALSE);
      }
      return new1749_3864;
   }
}


obj_t 
_allocate_make_box_o_cinfo_133_cfa_info(obj_t env_6955)
{
   {
      make_box_202_t aux_10841;
      aux_10841 = allocate_make_box_o_cinfo_222_cfa_info();
      return (obj_t) (aux_10841);
   }
}


make_box_202_t 
allocate_make_box_cinfo_213_cfa_info()
{
   {
      make_box_202_t new1733_3874;
      new1733_3874 = ((make_box_202_t) BREF(GC_MALLOC(sizeof(struct make_box_202))));
      {
	 long arg3346_3875;
	 arg3346_3875 = class_num_218___object(make_box_cinfo_127_cfa_info);
	 {
	    obj_t obj_6267;
	    obj_6267 = (obj_t) (new1733_3874);
	    (((obj_t) CREF(obj_6267))->header = MAKE_HEADER(arg3346_3875, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10848;
	 aux_10848 = (object_t) (new1733_3874);
	 OBJECT_WIDENING_SET(aux_10848, BFALSE);
      }
      return new1733_3874;
   }
}


obj_t 
_allocate_make_box_cinfo_36_cfa_info(obj_t env_6954)
{
   {
      make_box_202_t aux_10851;
      aux_10851 = allocate_make_box_cinfo_213_cfa_info();
      return (obj_t) (aux_10851);
   }
}


make_box_202_t 
allocate_pre_make_box_175_cfa_info()
{
   {
      make_box_202_t new1718_3882;
      new1718_3882 = ((make_box_202_t) BREF(GC_MALLOC(sizeof(struct make_box_202))));
      {
	 long arg3349_3883;
	 arg3349_3883 = class_num_218___object(pre_make_box_186_cfa_info);
	 {
	    obj_t obj_6271;
	    obj_6271 = (obj_t) (new1718_3882);
	    (((obj_t) CREF(obj_6271))->header = MAKE_HEADER(arg3349_3883, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10858;
	 aux_10858 = (object_t) (new1718_3882);
	 OBJECT_WIDENING_SET(aux_10858, BFALSE);
      }
      return new1718_3882;
   }
}


obj_t 
_allocate_pre_make_box_48_cfa_info(obj_t env_6953)
{
   {
      make_box_202_t aux_10861;
      aux_10861 = allocate_pre_make_box_175_cfa_info();
      return (obj_t) (aux_10861);
   }
}


jump_ex_it_184_t 
allocate_jump_ex_it_cinfo_167_cfa_info()
{
   {
      jump_ex_it_184_t new1702_3890;
      new1702_3890 = ((jump_ex_it_184_t) BREF(GC_MALLOC(sizeof(struct jump_ex_it_184))));
      {
	 long arg3352_3891;
	 arg3352_3891 = class_num_218___object(jump_ex_it_cinfo_139_cfa_info);
	 {
	    obj_t obj_6275;
	    obj_6275 = (obj_t) (new1702_3890);
	    (((obj_t) CREF(obj_6275))->header = MAKE_HEADER(arg3352_3891, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10868;
	 aux_10868 = (object_t) (new1702_3890);
	 OBJECT_WIDENING_SET(aux_10868, BFALSE);
      }
      return new1702_3890;
   }
}


obj_t 
_allocate_jump_ex_it_cinfo_34_cfa_info(obj_t env_6952)
{
   {
      jump_ex_it_184_t aux_10871;
      aux_10871 = allocate_jump_ex_it_cinfo_167_cfa_info();
      return (obj_t) (aux_10871);
   }
}


set_ex_it_116_t 
allocate_set_ex_it_cinfo_32_cfa_info()
{
   {
      set_ex_it_116_t new1687_3898;
      new1687_3898 = ((set_ex_it_116_t) BREF(GC_MALLOC(sizeof(struct set_ex_it_116))));
      {
	 long arg3355_3899;
	 arg3355_3899 = class_num_218___object(set_ex_it_cinfo_168_cfa_info);
	 {
	    obj_t obj_6279;
	    obj_6279 = (obj_t) (new1687_3898);
	    (((obj_t) CREF(obj_6279))->header = MAKE_HEADER(arg3355_3899, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10878;
	 aux_10878 = (object_t) (new1687_3898);
	 OBJECT_WIDENING_SET(aux_10878, BFALSE);
      }
      return new1687_3898;
   }
}


obj_t 
_allocate_set_ex_it_cinfo_22_cfa_info(obj_t env_6951)
{
   {
      set_ex_it_116_t aux_10881;
      aux_10881 = allocate_set_ex_it_cinfo_32_cfa_info();
      return (obj_t) (aux_10881);
   }
}


select_t 
allocate_select_cinfo_105_cfa_info()
{
   {
      select_t new1672_3906;
      new1672_3906 = ((select_t) BREF(GC_MALLOC(sizeof(struct select))));
      {
	 long arg3358_3907;
	 arg3358_3907 = class_num_218___object(select_cinfo_150_cfa_info);
	 {
	    obj_t obj_6283;
	    obj_6283 = (obj_t) (new1672_3906);
	    (((obj_t) CREF(obj_6283))->header = MAKE_HEADER(arg3358_3907, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10888;
	 aux_10888 = (object_t) (new1672_3906);
	 OBJECT_WIDENING_SET(aux_10888, BFALSE);
      }
      return new1672_3906;
   }
}


obj_t 
_allocate_select_cinfo_74_cfa_info(obj_t env_6950)
{
   {
      select_t aux_10891;
      aux_10891 = allocate_select_cinfo_105_cfa_info();
      return (obj_t) (aux_10891);
   }
}


fail_t 
allocate_fail_cinfo_138_cfa_info()
{
   {
      fail_t new1657_3914;
      new1657_3914 = ((fail_t) BREF(GC_MALLOC(sizeof(struct fail))));
      {
	 long arg3361_3915;
	 arg3361_3915 = class_num_218___object(fail_cinfo_75_cfa_info);
	 {
	    obj_t obj_6287;
	    obj_6287 = (obj_t) (new1657_3914);
	    (((obj_t) CREF(obj_6287))->header = MAKE_HEADER(arg3361_3915, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10898;
	 aux_10898 = (object_t) (new1657_3914);
	 OBJECT_WIDENING_SET(aux_10898, BFALSE);
      }
      return new1657_3914;
   }
}


obj_t 
_allocate_fail_cinfo_247_cfa_info(obj_t env_6949)
{
   {
      fail_t aux_10901;
      aux_10901 = allocate_fail_cinfo_138_cfa_info();
      return (obj_t) (aux_10901);
   }
}


conditional_t 
allocate_conditional_cinfo_71_cfa_info()
{
   {
      conditional_t new1641_3922;
      new1641_3922 = ((conditional_t) BREF(GC_MALLOC(sizeof(struct conditional))));
      {
	 long arg3364_3923;
	 arg3364_3923 = class_num_218___object(conditional_cinfo_212_cfa_info);
	 {
	    obj_t obj_6291;
	    obj_6291 = (obj_t) (new1641_3922);
	    (((obj_t) CREF(obj_6291))->header = MAKE_HEADER(arg3364_3923, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10908;
	 aux_10908 = (object_t) (new1641_3922);
	 OBJECT_WIDENING_SET(aux_10908, BFALSE);
      }
      return new1641_3922;
   }
}


obj_t 
_allocate_conditional_cinfo_139_cfa_info(obj_t env_6948)
{
   {
      conditional_t aux_10911;
      aux_10911 = allocate_conditional_cinfo_71_cfa_info();
      return (obj_t) (aux_10911);
   }
}


setq_t 
allocate_setq_cinfo_202_cfa_info()
{
   {
      setq_t new1624_3930;
      new1624_3930 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
      {
	 long arg3367_3931;
	 arg3367_3931 = class_num_218___object(setq_cinfo_191_cfa_info);
	 {
	    obj_t obj_6295;
	    obj_6295 = (obj_t) (new1624_3930);
	    (((obj_t) CREF(obj_6295))->header = MAKE_HEADER(arg3367_3931, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10918;
	 aux_10918 = (object_t) (new1624_3930);
	 OBJECT_WIDENING_SET(aux_10918, BFALSE);
      }
      return new1624_3930;
   }
}


obj_t 
_allocate_setq_cinfo_116_cfa_info(obj_t env_6947)
{
   {
      setq_t aux_10921;
      aux_10921 = allocate_setq_cinfo_202_cfa_info();
      return (obj_t) (aux_10921);
   }
}


pragma_t 
allocate_pragma_cinfo_134_cfa_info()
{
   {
      pragma_t new1607_3938;
      new1607_3938 = ((pragma_t) BREF(GC_MALLOC(sizeof(struct pragma))));
      {
	 long arg3373_3939;
	 arg3373_3939 = class_num_218___object(pragma_cinfo_220_cfa_info);
	 {
	    obj_t obj_6299;
	    obj_6299 = (obj_t) (new1607_3938);
	    (((obj_t) CREF(obj_6299))->header = MAKE_HEADER(arg3373_3939, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10928;
	 aux_10928 = (object_t) (new1607_3938);
	 OBJECT_WIDENING_SET(aux_10928, BFALSE);
      }
      return new1607_3938;
   }
}


obj_t 
_allocate_pragma_cinfo_82_cfa_info(obj_t env_6946)
{
   {
      pragma_t aux_10931;
      aux_10931 = allocate_pragma_cinfo_134_cfa_info();
      return (obj_t) (aux_10931);
   }
}


funcall_t 
allocate_funcall_cinfo_11_cfa_info()
{
   {
      funcall_t new1592_3946;
      new1592_3946 = ((funcall_t) BREF(GC_MALLOC(sizeof(struct funcall))));
      {
	 long arg3376_3947;
	 arg3376_3947 = class_num_218___object(funcall_cinfo_75_cfa_info);
	 {
	    obj_t obj_6303;
	    obj_6303 = (obj_t) (new1592_3946);
	    (((obj_t) CREF(obj_6303))->header = MAKE_HEADER(arg3376_3947, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10938;
	 aux_10938 = (object_t) (new1592_3946);
	 OBJECT_WIDENING_SET(aux_10938, BFALSE);
      }
      return new1592_3946;
   }
}


obj_t 
_allocate_funcall_cinfo_40_cfa_info(obj_t env_6945)
{
   {
      funcall_t aux_10941;
      aux_10941 = allocate_funcall_cinfo_11_cfa_info();
      return (obj_t) (aux_10941);
   }
}


app_ly_162_t 
allocate_app_ly_cinfo_200_cfa_info()
{
   {
      app_ly_162_t new1571_3957;
      new1571_3957 = ((app_ly_162_t) BREF(GC_MALLOC(sizeof(struct app_ly_162))));
      {
	 long arg3379_3958;
	 arg3379_3958 = class_num_218___object(app_ly_cinfo_234_cfa_info);
	 {
	    obj_t obj_6310;
	    obj_6310 = (obj_t) (new1571_3957);
	    (((obj_t) CREF(obj_6310))->header = MAKE_HEADER(arg3379_3958, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10948;
	 aux_10948 = (object_t) (new1571_3957);
	 OBJECT_WIDENING_SET(aux_10948, BFALSE);
      }
      return new1571_3957;
   }
}


obj_t 
_allocate_app_ly_cinfo_17_cfa_info(obj_t env_6944)
{
   {
      app_ly_162_t aux_10951;
      aux_10951 = allocate_app_ly_cinfo_200_cfa_info();
      return (obj_t) (aux_10951);
   }
}


kwote_t 
allocate_kwote_cinfo_134_cfa_info()
{
   {
      kwote_t new1556_3965;
      new1556_3965 = ((kwote_t) BREF(GC_MALLOC(sizeof(struct kwote))));
      {
	 long arg3382_3966;
	 arg3382_3966 = class_num_218___object(kwote_cinfo_48_cfa_info);
	 {
	    obj_t obj_6314;
	    obj_6314 = (obj_t) (new1556_3965);
	    (((obj_t) CREF(obj_6314))->header = MAKE_HEADER(arg3382_3966, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10958;
	 aux_10958 = (object_t) (new1556_3965);
	 OBJECT_WIDENING_SET(aux_10958, BFALSE);
      }
      return new1556_3965;
   }
}


obj_t 
_allocate_kwote_cinfo_178_cfa_info(obj_t env_6943)
{
   {
      kwote_t aux_10961;
      aux_10961 = allocate_kwote_cinfo_134_cfa_info();
      return (obj_t) (aux_10961);
   }
}


kwote_t 
allocate_kwote_node_139_cfa_info()
{
   {
      kwote_t new1543_3973;
      new1543_3973 = ((kwote_t) BREF(GC_MALLOC(sizeof(struct kwote))));
      {
	 long arg3385_3974;
	 arg3385_3974 = class_num_218___object(kwote_node_102_cfa_info);
	 {
	    obj_t obj_6318;
	    obj_6318 = (obj_t) (new1543_3973);
	    (((obj_t) CREF(obj_6318))->header = MAKE_HEADER(arg3385_3974, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10968;
	 aux_10968 = (object_t) (new1543_3973);
	 OBJECT_WIDENING_SET(aux_10968, BFALSE);
      }
      return new1543_3973;
   }
}


obj_t 
_allocate_kwote_node_49_cfa_info(obj_t env_6942)
{
   {
      kwote_t aux_10971;
      aux_10971 = allocate_kwote_node_139_cfa_info();
      return (obj_t) (aux_10971);
   }
}


atom_t 
allocate_atom_cinfo_55_cfa_info()
{
   {
      atom_t new1530_3981;
      new1530_3981 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
      {
	 long arg3388_3982;
	 arg3388_3982 = class_num_218___object(atom_cinfo_155_cfa_info);
	 {
	    obj_t obj_6322;
	    obj_6322 = (obj_t) (new1530_3981);
	    (((obj_t) CREF(obj_6322))->header = MAKE_HEADER(arg3388_3982, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10978;
	 aux_10978 = (object_t) (new1530_3981);
	 OBJECT_WIDENING_SET(aux_10978, BFALSE);
      }
      return new1530_3981;
   }
}


obj_t 
_allocate_atom_cinfo_64_cfa_info(obj_t env_6941)
{
   {
      atom_t aux_10981;
      aux_10981 = allocate_atom_cinfo_55_cfa_info();
      return (obj_t) (aux_10981);
   }
}


global_t 
allocate_reshaped_global_131_cfa_info()
{
   {
      global_t new1514_3989;
      new1514_3989 = ((global_t) BREF(GC_MALLOC(sizeof(struct global))));
      {
	 long arg3391_3990;
	 arg3391_3990 = class_num_218___object(reshaped_global_160_cfa_info);
	 {
	    obj_t obj_6326;
	    obj_6326 = (obj_t) (new1514_3989);
	    (((obj_t) CREF(obj_6326))->header = MAKE_HEADER(arg3391_3990, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10988;
	 aux_10988 = (object_t) (new1514_3989);
	 OBJECT_WIDENING_SET(aux_10988, BFALSE);
      }
      return new1514_3989;
   }
}


obj_t 
_allocate_reshaped_global_82_cfa_info(obj_t env_6940)
{
   {
      global_t aux_10991;
      aux_10991 = allocate_reshaped_global_131_cfa_info();
      return (obj_t) (aux_10991);
   }
}


local_t 
allocate_reshaped_local_100_cfa_info()
{
   {
      local_t new1491_3996;
      new1491_3996 = ((local_t) BREF(GC_MALLOC(sizeof(struct local))));
      {
	 long arg3394_3997;
	 arg3394_3997 = class_num_218___object(reshaped_local_224_cfa_info);
	 {
	    obj_t obj_6329;
	    obj_6329 = (obj_t) (new1491_3996);
	    (((obj_t) CREF(obj_6329))->header = MAKE_HEADER(arg3394_3997, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10998;
	 aux_10998 = (object_t) (new1491_3996);
	 OBJECT_WIDENING_SET(aux_10998, BFALSE);
      }
      return new1491_3996;
   }
}


obj_t 
_allocate_reshaped_local_17_cfa_info(obj_t env_6939)
{
   {
      local_t aux_11001;
      aux_11001 = allocate_reshaped_local_100_cfa_info();
      return (obj_t) (aux_11001);
   }
}


sexit_t 
allocate_sexit_cinfo_160_cfa_info()
{
   {
      sexit_t new1472_4004;
      new1472_4004 = ((sexit_t) BREF(GC_MALLOC(sizeof(struct sexit))));
      {
	 long arg3397_4005;
	 arg3397_4005 = class_num_218___object(sexit_cinfo_49_cfa_info);
	 {
	    obj_t obj_6333;
	    obj_6333 = (obj_t) (new1472_4004);
	    (((obj_t) CREF(obj_6333))->header = MAKE_HEADER(arg3397_4005, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11008;
	 aux_11008 = (object_t) (new1472_4004);
	 OBJECT_WIDENING_SET(aux_11008, BFALSE);
      }
      return new1472_4004;
   }
}


obj_t 
_allocate_sexit_cinfo_64_cfa_info(obj_t env_6938)
{
   {
      sexit_t aux_11011;
      aux_11011 = allocate_sexit_cinfo_160_cfa_info();
      return (obj_t) (aux_11011);
   }
}


cvar_t 
allocate_cvar_cinfo_69_cfa_info()
{
   {
      cvar_t new1458_4012;
      new1458_4012 = ((cvar_t) BREF(GC_MALLOC(sizeof(struct cvar))));
      {
	 long arg3400_4013;
	 arg3400_4013 = class_num_218___object(cvar_cinfo_53_cfa_info);
	 {
	    obj_t obj_6337;
	    obj_6337 = (obj_t) (new1458_4012);
	    (((obj_t) CREF(obj_6337))->header = MAKE_HEADER(arg3400_4013, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11018;
	 aux_11018 = (object_t) (new1458_4012);
	 OBJECT_WIDENING_SET(aux_11018, BFALSE);
      }
      return new1458_4012;
   }
}


obj_t 
_allocate_cvar_cinfo_74_cfa_info(obj_t env_6937)
{
   {
      cvar_t aux_11021;
      aux_11021 = allocate_cvar_cinfo_69_cfa_info();
      return (obj_t) (aux_11021);
   }
}


svar_t 
allocate_svar_cinfo_217_cfa_info()
{
   {
      svar_t new1446_4020;
      new1446_4020 = ((svar_t) BREF(GC_MALLOC(sizeof(struct svar))));
      {
	 long arg3403_4021;
	 arg3403_4021 = class_num_218___object(svar_cinfo_166_cfa_info);
	 {
	    obj_t obj_6341;
	    obj_6341 = (obj_t) (new1446_4020);
	    (((obj_t) CREF(obj_6341))->header = MAKE_HEADER(arg3403_4021, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11028;
	 aux_11028 = (object_t) (new1446_4020);
	 OBJECT_WIDENING_SET(aux_11028, BFALSE);
      }
      return new1446_4020;
   }
}


obj_t 
_allocate_svar_cinfo_185_cfa_info(obj_t env_6936)
{
   {
      svar_t aux_11031;
      aux_11031 = allocate_svar_cinfo_217_cfa_info();
      return (obj_t) (aux_11031);
   }
}


svar_t 
allocate_pre_clo_env_40_cfa_info()
{
   {
      svar_t new1433_4029;
      new1433_4029 = ((svar_t) BREF(GC_MALLOC(sizeof(struct svar))));
      {
	 long arg3406_4030;
	 arg3406_4030 = class_num_218___object(pre_clo_env_191_cfa_info);
	 {
	    obj_t obj_6346;
	    obj_6346 = (obj_t) (new1433_4029);
	    (((obj_t) CREF(obj_6346))->header = MAKE_HEADER(arg3406_4030, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11038;
	 aux_11038 = (object_t) (new1433_4029);
	 OBJECT_WIDENING_SET(aux_11038, BFALSE);
      }
      return new1433_4029;
   }
}


obj_t 
_allocate_pre_clo_env_10_cfa_info(obj_t env_6935)
{
   {
      svar_t aux_11041;
      aux_11041 = allocate_pre_clo_env_40_cfa_info();
      return (obj_t) (aux_11041);
   }
}


scnst_t 
allocate_scnst_cinfo_156_cfa_info()
{
   {
      scnst_t new1420_4036;
      new1420_4036 = ((scnst_t) BREF(GC_MALLOC(sizeof(struct scnst))));
      {
	 long arg3409_4037;
	 arg3409_4037 = class_num_218___object(scnst_cinfo_0_cfa_info);
	 {
	    obj_t obj_6349;
	    obj_6349 = (obj_t) (new1420_4036);
	    (((obj_t) CREF(obj_6349))->header = MAKE_HEADER(arg3409_4037, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11048;
	 aux_11048 = (object_t) (new1420_4036);
	 OBJECT_WIDENING_SET(aux_11048, BFALSE);
      }
      return new1420_4036;
   }
}


obj_t 
_allocate_scnst_cinfo_162_cfa_info(obj_t env_6934)
{
   {
      scnst_t aux_11051;
      aux_11051 = allocate_scnst_cinfo_156_cfa_info();
      return (obj_t) (aux_11051);
   }
}


sfun_t 
allocate_intern_sfun_cinfo_151_cfa_info()
{
   {
      sfun_t new1407_4044;
      new1407_4044 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
      {
	 long arg3412_4045;
	 arg3412_4045 = class_num_218___object(intern_sfun_cinfo_192_cfa_info);
	 {
	    obj_t obj_6353;
	    obj_6353 = (obj_t) (new1407_4044);
	    (((obj_t) CREF(obj_6353))->header = MAKE_HEADER(arg3412_4045, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11058;
	 aux_11058 = (object_t) (new1407_4044);
	 OBJECT_WIDENING_SET(aux_11058, BFALSE);
      }
      return new1407_4044;
   }
}


obj_t 
_allocate_intern_sfun_cinfo_249_cfa_info(obj_t env_6933)
{
   {
      sfun_t aux_11061;
      aux_11061 = allocate_intern_sfun_cinfo_151_cfa_info();
      return (obj_t) (aux_11061);
   }
}


sfun_t 
allocate_extern_sfun_cinfo_223_cfa_info()
{
   {
      sfun_t new1383_4053;
      new1383_4053 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
      {
	 long arg3415_4054;
	 arg3415_4054 = class_num_218___object(extern_sfun_cinfo_6_cfa_info);
	 {
	    obj_t obj_6358;
	    obj_6358 = (obj_t) (new1383_4053);
	    (((obj_t) CREF(obj_6358))->header = MAKE_HEADER(arg3415_4054, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11068;
	 aux_11068 = (object_t) (new1383_4053);
	 OBJECT_WIDENING_SET(aux_11068, BFALSE);
      }
      return new1383_4053;
   }
}


obj_t 
_allocate_extern_sfun_cinfo_234_cfa_info(obj_t env_6932)
{
   {
      sfun_t aux_11071;
      aux_11071 = allocate_extern_sfun_cinfo_223_cfa_info();
      return (obj_t) (aux_11071);
   }
}


cfun_t 
allocate_cfun_cinfo_179_cfa_info()
{
   {
      cfun_t new1361_4061;
      new1361_4061 = ((cfun_t) BREF(GC_MALLOC(sizeof(struct cfun))));
      {
	 long arg3418_4062;
	 arg3418_4062 = class_num_218___object(cfun_cinfo_200_cfa_info);
	 {
	    obj_t obj_6362;
	    obj_6362 = (obj_t) (new1361_4061);
	    (((obj_t) CREF(obj_6362))->header = MAKE_HEADER(arg3418_4062, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11078;
	 aux_11078 = (object_t) (new1361_4061);
	 OBJECT_WIDENING_SET(aux_11078, BFALSE);
      }
      return new1361_4061;
   }
}


obj_t 
_allocate_cfun_cinfo_87_cfa_info(obj_t env_6931)
{
   {
      cfun_t aux_11081;
      aux_11081 = allocate_cfun_cinfo_179_cfa_info();
      return (obj_t) (aux_11081);
   }
}


approx_t 
allocate_approx_85_cfa_info()
{
   {
      approx_t new1327_4069;
      new1327_4069 = ((approx_t) BREF(GC_MALLOC(sizeof(struct approx))));
      {
	 long arg3421_4070;
	 arg3421_4070 = class_num_218___object(approx_cfa_info);
	 {
	    obj_t obj_6366;
	    obj_6366 = (obj_t) (new1327_4069);
	    (((obj_t) CREF(obj_6366))->header = MAKE_HEADER(arg3421_4070, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11088;
	 aux_11088 = (object_t) (new1327_4069);
	 OBJECT_WIDENING_SET(aux_11088, BFALSE);
      }
      return new1327_4069;
   }
}


obj_t 
_allocate_approx_254_cfa_info(obj_t env_6930)
{
   {
      approx_t aux_11091;
      aux_11091 = allocate_approx_85_cfa_info();
      return (obj_t) (aux_11091);
   }
}


obj_t 
imported_modules_init_94_cfa_info()
{
   module_initialization_70_type_type(((long) 0), "CFA_INFO");
   module_initialization_70_type_cache(((long) 0), "CFA_INFO");
   module_initialization_70_ast_var(((long) 0), "CFA_INFO");
   return module_initialization_70_ast_node(((long) 0), "CFA_INFO");
}
