/*===========================================================================*/
/*   (Cgen/cgen.scm)                                                         */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct cop
  {
     header_t header;
     obj_t widening;
  }
   *cop_t;

typedef struct clabel
  {
     header_t header;
     obj_t widening;
     obj_t name;
     bool_t used__226;
     obj_t body;
  }
      *clabel_t;

typedef struct cgoto
  {
     header_t header;
     obj_t widening;
     struct clabel *label;
  }
     *cgoto_t;

typedef struct block
  {
     header_t header;
     obj_t widening;
     struct cop *body;
  }
     *block_t;

typedef struct creturn
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
       *creturn_t;

typedef struct cvoid
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
     *cvoid_t;

typedef struct catom
  {
     header_t header;
     obj_t widening;
     obj_t value;
  }
     *catom_t;

typedef struct varc
  {
     header_t header;
     obj_t widening;
     struct variable *variable;
  }
    *varc_t;

typedef struct cpragma
  {
     header_t header;
     obj_t widening;
     obj_t format;
     obj_t args;
  }
       *cpragma_t;

typedef struct ccast
  {
     header_t header;
     obj_t widening;
     struct type *type;
     struct cop *arg;
  }
     *ccast_t;

typedef struct csequence
  {
     header_t header;
     obj_t widening;
     bool_t c_exp__163;
     obj_t cops;
  }
         *csequence_t;

typedef struct nop
  {
     header_t header;
     obj_t widening;
  }
   *nop_t;

typedef struct stop
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
    *stop_t;

typedef struct csetq
  {
     header_t header;
     obj_t widening;
     struct varc *var;
     struct cop *value;
  }
     *csetq_t;

typedef struct cif
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     struct cop *true;
     struct cop *false;
  }
   *cif_t;

typedef struct branch
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     struct cop *true;
     struct cop *false;
     struct cop *end;
  }
      *branch_t;

typedef struct local_var_164
  {
     header_t header;
     obj_t widening;
     obj_t vars;
  }
             *local_var_164_t;

typedef struct cfuncall
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     obj_t args;
     obj_t strength;
  }
        *cfuncall_t;

typedef struct capply
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     struct cop *arg;
  }
      *capply_t;

typedef struct capp
  {
     header_t header;
     obj_t widening;
     struct cop *fun;
     obj_t args;
  }
    *capp_t;

typedef struct cfail
  {
     header_t header;
     obj_t widening;
     struct cop *proc;
     struct cop *msg;
     struct cop *obj;
  }
     *cfail_t;

typedef struct cswitch
  {
     header_t header;
     obj_t widening;
     struct cop *test;
     obj_t clauses;
  }
       *cswitch_t;

typedef struct cmake_box_177
  {
     header_t header;
     obj_t widening;
     struct cop *value;
  }
             *cmake_box_177_t;

typedef struct cbox_ref_44
  {
     header_t header;
     obj_t widening;
     struct cop *var;
  }
           *cbox_ref_44_t;

typedef struct cbox_set__132
  {
     header_t header;
     obj_t widening;
     struct cop *var;
     struct cop *value;
  }
             *cbox_set__132_t;

typedef struct cset_ex_it_123
  {
     header_t header;
     obj_t widening;
     struct cop *exit;
     struct cop *jump_value_221;
     struct cop *body;
  }
              *cset_ex_it_123_t;

typedef struct cjump_ex_it_131
  {
     header_t header;
     obj_t widening;
     struct cop *exit;
     struct cop *value;
  }
               *cjump_ex_it_131_t;

typedef struct sfun_c_188
  {
     struct clabel *label;
     bool_t integrated;
  }
          *sfun_c_188_t;


static obj_t arg24562623_cgen_cgen(obj_t, obj_t);
extern setq_t node_setq_243_cgen_cgen(variable_t, node_t);
extern obj_t cswitch_cgen_cop;
extern obj_t __procedure__226_type_cache;
extern obj_t let_fun_218_ast_node;
static obj_t __void_kont__176_cgen_cgen(obj_t, obj_t);
obj_t __block_kont__38_cgen_cgen = BUNSPEC;
static obj_t lambda14712619_cgen_cgen(obj_t, obj_t);
obj_t __return_kont__110_cgen_cgen = BUNSPEC;
static obj_t arg24742622_cgen_cgen(obj_t, obj_t);
static obj_t lambda14612620_cgen_cgen(obj_t, obj_t);
extern obj_t stop_cgen_cop;
extern obj_t sequence_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t _make_local_svar_name_175_cgen_cgen(obj_t, obj_t, obj_t);
extern obj_t cbox_ref_44_cgen_cop;
extern obj_t closure_ast_node;
static obj_t lambda14732617_cgen_cgen(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t __classes__134___object;
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
extern obj_t make_typed_declaration_180_type_tools(type_t, obj_t);
static obj_t imported_modules_init_94_cgen_cgen();
extern obj_t catom_cgen_cop;
extern obj_t module_initialization_70_cgen_cgen(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_cgen_emit(long, char *);
extern obj_t module_initialization_70_cgen_cop(long, char *);
extern obj_t module_initialization_70_cgen_emit_cop_239(long, char *);
extern obj_t module_initialization_70_cgen_prototype(long, char *);
extern obj_t module_initialization_70_cgen_capp(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t newline___r4_output_6_10_3(obj_t);
static obj_t toplevel_init_63_cgen_cgen();
static obj_t cnst_init_137_cgen_cgen();
static cvoid_t __void_kont__34_cgen_cgen(obj_t);
extern obj_t cvoid_cgen_cop;
extern obj_t creturn_cgen_cop;
obj_t __stop_kont__121_cgen_cgen = BUNSPEC;
extern obj_t cjump_ex_it_131_cgen_cop;
extern obj_t string_sans___40_type_tools(obj_t);
extern local_t make_local_svar_name_219_cgen_cgen(obj_t, type_t);
obj_t __id_kont__126_cgen_cgen = BUNSPEC;
static obj_t require_initialization_114_cgen_cgen = BUNSPEC;
extern obj_t var_ast_node;
extern obj_t __bool__149_type_cache;
extern obj_t print_trace_107_tools_trace(obj_t);
extern obj_t clabel_cgen_cop;
obj_t __the_global__73_cgen_cgen = BUNSPEC;
static obj_t library_modules_init_112_cgen_cgen();
extern obj_t cset_ex_it_123_cgen_cop;
static obj_t make_setq_kont_65_cgen_cgen(variable_t, obj_t);
extern obj_t cast_ast_node;
static obj_t arg24172624_cgen_cgen(obj_t, obj_t);
extern obj_t trace_satisfy__215_tools_trace(obj_t, obj_t);
extern obj_t __c_port__188_cgen_emit;
extern obj_t conditional_ast_node;
extern obj_t read___reader(obj_t);
static obj_t lambda15692621_cgen_cgen(obj_t, obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t select_ast_node;
static obj_t _node__cop_default1442_33_cgen_cgen(obj_t, obj_t, obj_t);
extern obj_t cfail_cgen_cop;
extern obj_t open_input_string(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t cif_cgen_cop;
static obj_t sfun__c_170_cgen_cgen(sfun_c_188_t, global_t);
extern obj_t pragma_ast_node;
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t __unspec__87_type_cache;
extern obj_t cgen_cgen_cgen(global_t);
extern long class_num_218___object(obj_t);
extern obj_t cbox_set__132_cgen_cop;
extern obj_t csetq_cgen_cop;
static obj_t lambda14722618_cgen_cgen(obj_t, obj_t);
extern obj_t sfun_c_188_cgen_cop;
extern obj_t cpragma_cgen_cop;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern cop_t node__cop_142_cgen_cgen(node_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t display___r4_output_6_10_3(obj_t, obj_t);
extern obj_t cmake_box_177_cgen_cop;
extern obj_t set_ex_it_116_ast_node;
extern obj_t _node_setq_175_cgen_cgen(obj_t, obj_t, obj_t);
extern obj_t local_var_164_cgen_cop;
extern type_t typeof_coerce_typeof(node_t);
extern obj_t varc_cgen_cop;
extern obj_t _node__cop_12_cgen_cgen(obj_t, obj_t, obj_t);
extern bool_t emit_cop_45_cgen_emit_cop_239(cop_t);
extern obj_t ccast_cgen_cop;
extern obj_t kwote_ast_node;
extern bool_t side_effect__165_effect_effect(node_t);
static cop_t node__cop_default1442_123_cgen_cgen(node_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _____74_type_cache;
extern obj_t block_cgen_cop;
extern obj_t box_ref_242_ast_node;
extern obj_t set_variable_name__102_cgen_prototype(obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t __void__134_type_cache;
extern obj_t __obj__252_type_cache;
extern obj_t atom_ast_node;
extern obj_t make_box_202_ast_node;
extern local_t make_local_svar_140_ast_local(obj_t, type_t);
extern obj_t nop_cgen_cop;
extern obj_t csequence_cgen_cop;
extern obj_t leave_function_170_tools_error();
extern obj_t _cgen_cgen_cgen(obj_t, obj_t);
static obj_t __cnst[6];

DEFINE_STRING(string2639_cgen_cgen, string2639_cgen_cgen2668, "Unexpected `kwote' node", 23);
DEFINE_STATIC_PROCEDURE(proc2625_cgen_cgen, lambda14612620_cgen_cgen2669, lambda14612620_cgen_cgen, 0L, 1);
DEFINE_STRING(string2638_cgen_cgen, string2638_cgen_cgen2670, "node->cop", 9);
DEFINE_EXPORT_GENERIC(node__cop_env_160_cgen_cgen, _node__cop_12_cgen_cgen2671, _node__cop_12_cgen_cgen, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2626_cgen_cgen, lambda14712619_cgen_cgen2672, lambda14712619_cgen_cgen, 0L, 1);
DEFINE_STRING(string2649_cgen_cgen, string2649_cgen_cgen2673, "(node->cop node::select kont): ", 31);
DEFINE_STRING(string2661_cgen_cgen, string2661_cgen_cgen2674, "(node->cop node::box-set! kont): ", 33);
DEFINE_STRING(string2646_cgen_cgen, string2646_cgen_cgen2675, "(node->cop node::setq kont): ", 29);
DEFINE_EXPORT_PROCEDURE(cgen_env_68_cgen_cgen, _cgen_cgen_cgen2676, _cgen_cgen_cgen, 0L, 1);
DEFINE_STATIC_PROCEDURE(__void_kont__env_70_cgen_cgen, __void_kont__176_cgen_cgen2677, __void_kont__176_cgen_cgen, 0L, 1);
DEFINE_STRING(string2645_cgen_cgen, string2645_cgen_cgen2678, "(node->cop node::cast kont): ", 29);
DEFINE_STRING(string2657_cgen_cgen, string2657_cgen_cgen2679, "(node->cop node::jump-ex-it kont): ", 35);
DEFINE_STATIC_PROCEDURE(node__cop_default1442_env_229_cgen_cgen, _node__cop_default1442_33_cgen_cgen2680, _node__cop_default1442_33_cgen_cgen, 0L, 2);
DEFINE_STRING(string2658_cgen_cgen, string2658_cgen_cgen2681, "(node->cop node::make-box kont): ", 33);
DEFINE_STRING(string2635_cgen_cgen, string2635_cgen_cgen2682, "  kont: ", 8);
DEFINE_STRING(string2636_cgen_cgen, string2636_cgen_cgen2683, "(node->cop node::atom kont): ", 29);
DEFINE_STRING(string2662_cgen_cgen, string2662_cgen_cgen2684, "CELL-VAL EXIT TEST AUX NODE->COP-DEFAULT1442 CGEN ", 50);
DEFINE_STRING(string2659_cgen_cgen, string2659_cgen_cgen2685, "(node->cop node::box-ref kont): ", 32);
DEFINE_STRING(string2641_cgen_cgen, string2641_cgen_cgen2686, "(node->cop node::closure kont): ", 32);
DEFINE_STRING(string2629_cgen_cgen, string2629_cgen_cgen2687, "cgen global: ", 13);
DEFINE_STRING(string2654_cgen_cgen, string2654_cgen_cgen2688, "_exit_value_", 12);
DEFINE_STRING(string2634_cgen_cgen, string2634_cgen_cgen2689, "No method for this object", 25);
DEFINE_STRING(string2631_cgen_cgen, string2631_cgen_cgen2690, "*return-kont*: ", 15);
DEFINE_STATIC_PROCEDURE(proc2628_cgen_cgen, lambda14732617_cgen_cgen2691, lambda14732617_cgen_cgen, 0L, 1);
DEFINE_STRING(string2651_cgen_cgen, string2651_cgen_cgen2692, "(node->cop node::let-var kont): ", 32);
DEFINE_EXPORT_PROCEDURE(node_setq_env_20_cgen_cgen, _node_setq_175_cgen_cgen2693, _node_setq_175_cgen_cgen, 0L, 2);
DEFINE_STRING(string2650_cgen_cgen, string2650_cgen_cgen2694, "(node->cop node::let-fun kont): ", 32);
DEFINE_STRING(string2655_cgen_cgen, string2655_cgen_cgen2695, ")jmpbuf", 7);
DEFINE_STRING(string2644_cgen_cgen, string2644_cgen_cgen2696, "(node->cop node::pragma kont): ", 31);
DEFINE_STRING(string2633_cgen_cgen, string2633_cgen_cgen2697, ", ", 2);
DEFINE_STRING(string2653_cgen_cgen, string2653_cgen_cgen2698, "jmp_buf jmpbuf", 14);
DEFINE_STATIC_PROCEDURE(proc2660_cgen_cgen, arg24562623_cgen_cgen2699, arg24562623_cgen_cgen, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2627_cgen_cgen, lambda14722618_cgen_cgen2700, lambda14722618_cgen_cgen, 0L, 1);
DEFINE_STRING(string2648_cgen_cgen, string2648_cgen_cgen2701, "(node->cop node::fail kont): ", 29);
DEFINE_STRING(string2640_cgen_cgen, string2640_cgen_cgen2702, "(node->cop node::var kont): ", 28);
DEFINE_STRING(string2637_cgen_cgen, string2637_cgen_cgen2703, "(node->cop node::kwote kont): ", 30);
DEFINE_STRING(string2647_cgen_cgen, string2647_cgen_cgen2704, "(node->cop node::conditional kont): ", 36);
DEFINE_STRING(string2652_cgen_cgen, string2652_cgen_cgen2705, "(node->cop node::set-ex-it kont): ", 34);
DEFINE_STRING(string2642_cgen_cgen, string2642_cgen_cgen2706, "Unexpected `closure' node", 25);
DEFINE_EXPORT_PROCEDURE(make_local_svar_name_env_11_cgen_cgen, _make_local_svar_name_175_cgen_cgen2707, _make_local_svar_name_175_cgen_cgen, 0L, 2);
DEFINE_STRING(string2656_cgen_cgen, string2656_cgen_cgen2708, "(", 1);
DEFINE_STRING(string2630_cgen_cgen, string2630_cgen_cgen2709, "*void-kont*: ", 13);
DEFINE_STRING(string2632_cgen_cgen, string2632_cgen_cgen2710, "()", 2);
DEFINE_STRING(string2643_cgen_cgen, string2643_cgen_cgen2711, "(node->cop node::sequence kont): ", 33);

obj_t 
module_initialization_70_cgen_cgen(long checksum_3835, char *from_3836)
{
   if (CBOOL(require_initialization_114_cgen_cgen))
     {
	require_initialization_114_cgen_cgen = BBOOL(((bool_t) 0));
	library_modules_init_112_cgen_cgen();
	cnst_init_137_cgen_cgen();
	imported_modules_init_94_cgen_cgen();
	toplevel_init_63_cgen_cgen();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_cgen_cgen()
{
   module_initialization_70___object(((long) 0), "CGEN_CGEN");
   module_initialization_70___r4_output_6_10_3(((long) 0), "CGEN_CGEN");
   module_initialization_70___reader(((long) 0), "CGEN_CGEN");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CGEN_CGEN");
   module_initialization_70___r4_strings_6_7(((long) 0), "CGEN_CGEN");
   return BUNSPEC;
}


obj_t 
cnst_init_137_cgen_cgen()
{
   {
      obj_t cnst_port_138_3827;
      cnst_port_138_3827 = open_input_string(string2662_cgen_cgen);
      {
	 long i_3828;
	 i_3828 = ((long) 5);
       loop_3829:
	 {
	    bool_t test2663_3830;
	    test2663_3830 = (i_3828 == ((long) -1));
	    if (test2663_3830)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg2664_3831;
		    {
		       obj_t list2665_3832;
		       {
			  obj_t arg2666_3833;
			  arg2666_3833 = BNIL;
			  list2665_3832 = MAKE_PAIR(cnst_port_138_3827, arg2666_3833);
		       }
		       arg2664_3831 = read___reader(list2665_3832);
		    }
		    CNST_TABLE_SET(i_3828, arg2664_3831);
		 }
		 {
		    int aux_3834;
		    {
		       long aux_3855;
		       aux_3855 = (i_3828 - ((long) 1));
		       aux_3834 = (int) (aux_3855);
		    }
		    {
		       long i_3858;
		       i_3858 = (long) (aux_3834);
		       i_3828 = i_3858;
		       goto loop_3829;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_cgen_cgen()
{
   __the_global__73_cgen_cgen = BUNSPEC;
   {
      obj_t lambda1461_3782;
      lambda1461_3782 = proc2625_cgen_cgen;
      __return_kont__110_cgen_cgen = lambda1461_3782;
   }
   {
      obj_t lambda1471_3781;
      lambda1471_3781 = proc2626_cgen_cgen;
      __id_kont__126_cgen_cgen = lambda1471_3781;
   }
   {
      obj_t lambda1472_3780;
      lambda1472_3780 = proc2627_cgen_cgen;
      __stop_kont__121_cgen_cgen = lambda1472_3780;
   }
   {
      obj_t lambda1473_3779;
      lambda1473_3779 = proc2628_cgen_cgen;
      __block_kont__38_cgen_cgen = lambda1473_3779;
   }
   add_generic__110___object(node__cop_env_160_cgen_cgen, node__cop_default1442_env_229_cgen_cgen);
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, atom_ast_node, ((long) 0));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, kwote_ast_node, ((long) 1));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, var_ast_node, ((long) 2));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, closure_ast_node, ((long) 3));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, sequence_ast_node, ((long) 4));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, pragma_ast_node, ((long) 5));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, cast_ast_node, ((long) 6));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, setq_ast_node, ((long) 7));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, conditional_ast_node, ((long) 8));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, fail_ast_node, ((long) 9));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, select_ast_node, ((long) 10));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, let_fun_218_ast_node, ((long) 11));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, let_var_6_ast_node, ((long) 12));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, set_ex_it_116_ast_node, ((long) 13));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, jump_ex_it_184_ast_node, ((long) 14));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, make_box_202_ast_node, ((long) 15));
   add_inlined_method__244___object(node__cop_env_160_cgen_cgen, box_ref_242_ast_node, ((long) 16));
   {
      long aux_3878;
      aux_3878 = add_inlined_method__244___object(node__cop_env_160_cgen_cgen, box_set__221_ast_node, ((long) 17));
      return BINT(aux_3878);
   }
}


obj_t 
lambda14732617_cgen_cgen(obj_t env_3783, obj_t cop_3784)
{
   {
      obj_t cop_871;
      cop_871 = cop_3784;
      {
	 bool_t test1474_2256;
	 test1474_2256 = is_a__118___object(cop_871, block_cgen_cop);
	 if (test1474_2256)
	   {
	      return cop_871;
	   }
	 else
	   {
	      {
		 block_t res2489_2264;
		 {
		    cop_t body_2258;
		    body_2258 = (cop_t) (cop_871);
		    {
		       block_t new1287_2259;
		       new1287_2259 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
		       {
			  long arg1657_2260;
			  arg1657_2260 = class_num_218___object(block_cgen_cop);
			  {
			     obj_t obj_2262;
			     obj_2262 = (obj_t) (new1287_2259);
			     (((obj_t) CREF(obj_2262))->header = MAKE_HEADER(arg1657_2260, 0), BUNSPEC);
			  }
		       }
		       {
			  object_t aux_3888;
			  aux_3888 = (object_t) (new1287_2259);
			  OBJECT_WIDENING_SET(aux_3888, BFALSE);
		       }
		       ((((block_t) CREF(new1287_2259))->body) = ((cop_t) body_2258), BUNSPEC);
		       res2489_2264 = new1287_2259;
		    }
		 }
		 return (obj_t) (res2489_2264);
	      }
	   }
      }
   }
}


obj_t 
lambda14722618_cgen_cgen(obj_t env_3785, obj_t cop_3786)
{
   {
      obj_t cop_869;
      {
	 stop_t aux_3893;
	 cop_869 = cop_3786;
	 {
	    stop_t res2488_2255;
	    {
	       cop_t value_2249;
	       value_2249 = (cop_t) (cop_869);
	       {
		  stop_t new1326_2250;
		  new1326_2250 = ((stop_t) BREF(GC_MALLOC(sizeof(struct stop))));
		  {
		     long arg1634_2251;
		     arg1634_2251 = class_num_218___object(stop_cgen_cop);
		     {
			obj_t obj_2253;
			obj_2253 = (obj_t) (new1326_2250);
			(((obj_t) CREF(obj_2253))->header = MAKE_HEADER(arg1634_2251, 0), BUNSPEC);
		     }
		  }
		  {
		     object_t aux_3899;
		     aux_3899 = (object_t) (new1326_2250);
		     OBJECT_WIDENING_SET(aux_3899, BFALSE);
		  }
		  ((((stop_t) CREF(new1326_2250))->value) = ((cop_t) value_2249), BUNSPEC);
		  res2488_2255 = new1326_2250;
	       }
	    }
	    aux_3893 = res2488_2255;
	 }
	 return (obj_t) (aux_3893);
      }
   }
}


obj_t 
lambda14712619_cgen_cgen(obj_t env_3787, obj_t cop_3788)
{
   {
      obj_t cop_867;
      cop_867 = cop_3788;
      return cop_867;
   }
}


obj_t 
lambda14612620_cgen_cgen(obj_t env_3789, obj_t cop_3790)
{
   {
      obj_t cop_858;
      {
	 creturn_t aux_3904;
	 cop_858 = cop_3790;
	 {
	    obj_t arg1463_860;
	    {
	       bool_t test1464_861;
	       test1464_861 = is_a__118___object(cop_858, csetq_cgen_cop);
	       if (test1464_861)
		 {
		    {
		       obj_t arg1465_862;
		       {
			  catom_t arg1466_863;
			  {
			     catom_t res2485_2231;
			     {
				catom_t new1301_2226;
				new1301_2226 = ((catom_t) BREF(GC_MALLOC(sizeof(struct catom))));
				{
				   long arg1651_2227;
				   arg1651_2227 = class_num_218___object(catom_cgen_cop);
				   {
				      obj_t obj_2229;
				      obj_2229 = (obj_t) (new1301_2226);
				      (((obj_t) CREF(obj_2229))->header = MAKE_HEADER(arg1651_2227, 0), BUNSPEC);
				   }
				}
				{
				   object_t aux_3911;
				   aux_3911 = (object_t) (new1301_2226);
				   OBJECT_WIDENING_SET(aux_3911, BFALSE);
				}
				((((catom_t) CREF(new1301_2226))->value) = ((obj_t) BUNSPEC), BUNSPEC);
				res2485_2231 = new1301_2226;
			     }
			     arg1466_863 = res2485_2231;
			  }
			  {
			     obj_t list1467_864;
			     {
				obj_t arg1468_865;
				{
				   obj_t aux_3915;
				   aux_3915 = (obj_t) (arg1466_863);
				   arg1468_865 = MAKE_PAIR(aux_3915, BNIL);
				}
				list1467_864 = MAKE_PAIR(cop_858, arg1468_865);
			     }
			     arg1465_862 = list1467_864;
			  }
		       }
		       {
			  csequence_t res2486_2241;
			  {
			     csequence_t new1317_2235;
			     new1317_2235 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
			     {
				long arg1642_2236;
				arg1642_2236 = class_num_218___object(csequence_cgen_cop);
				{
				   obj_t obj_2239;
				   obj_2239 = (obj_t) (new1317_2235);
				   (((obj_t) CREF(obj_2239))->header = MAKE_HEADER(arg1642_2236, 0), BUNSPEC);
				}
			     }
			     {
				object_t aux_3923;
				aux_3923 = (object_t) (new1317_2235);
				OBJECT_WIDENING_SET(aux_3923, BFALSE);
			     }
			     ((((csequence_t) CREF(new1317_2235))->c_exp__163) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			     ((((csequence_t) CREF(new1317_2235))->cops) = ((obj_t) arg1465_862), BUNSPEC);
			     res2486_2241 = new1317_2235;
			  }
			  arg1463_860 = (obj_t) (res2486_2241);
		       }
		    }
		 }
	       else
		 {
		    arg1463_860 = cop_858;
		 }
	    }
	    {
	       creturn_t res2487_2248;
	       {
		  cop_t value_2242;
		  value_2242 = (cop_t) (arg1463_860);
		  {
		     creturn_t new1291_2243;
		     new1291_2243 = ((creturn_t) BREF(GC_MALLOC(sizeof(struct creturn))));
		     {
			long arg1655_2244;
			arg1655_2244 = class_num_218___object(creturn_cgen_cop);
			{
			   obj_t obj_2246;
			   obj_2246 = (obj_t) (new1291_2243);
			   (((obj_t) CREF(obj_2246))->header = MAKE_HEADER(arg1655_2244, 0), BUNSPEC);
			}
		     }
		     {
			object_t aux_3934;
			aux_3934 = (object_t) (new1291_2243);
			OBJECT_WIDENING_SET(aux_3934, BFALSE);
		     }
		     ((((creturn_t) CREF(new1291_2243))->value) = ((cop_t) value_2242), BUNSPEC);
		     res2487_2248 = new1291_2243;
		  }
	       }
	       aux_3904 = res2487_2248;
	    }
	 }
	 return (obj_t) (aux_3904);
      }
   }
}


obj_t 
cgen_cgen_cgen(global_t global_1)
{
   enter_function_81_tools_error((((global_t) CREF(global_1))->id));
   {
      bool_t test1477_875;
      {
	 obj_t aux_3941;
	 aux_3941 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 0)));
	 test1477_875 = CBOOL(aux_3941);
      }
      if (test1477_875)
	{
	   obj_t arg1480_877;
	   arg1480_877 = shape_tools_shape((obj_t) (global_1));
	   {
	      obj_t list1481_878;
	      {
		 obj_t arg1484_879;
		 {
		    obj_t arg1485_880;
		    {
		       obj_t aux_3949;
		       aux_3949 = BCHAR(((unsigned char) '\n'));
		       arg1485_880 = MAKE_PAIR(aux_3949, BNIL);
		    }
		    arg1484_879 = MAKE_PAIR(arg1480_877, arg1485_880);
		 }
		 list1481_878 = MAKE_PAIR(string2629_cgen_cgen, arg1484_879);
	      }
	      print_trace_107_tools_trace(list1481_878);
	   }
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test1490_884;
      {
	 obj_t aux_3955;
	 aux_3955 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1490_884 = CBOOL(aux_3955);
      }
      if (test1490_884)
	{
	   obj_t list1491_885;
	   {
	      obj_t arg1494_887;
	      {
		 obj_t arg1496_888;
		 {
		    obj_t aux_3961;
		    aux_3961 = BCHAR(((unsigned char) '\n'));
		    arg1496_888 = MAKE_PAIR(aux_3961, BNIL);
		 }
		 arg1494_887 = MAKE_PAIR(__void_kont__env_70_cgen_cgen, arg1496_888);
	      }
	      list1491_885 = MAKE_PAIR(string2630_cgen_cgen, arg1494_887);
	   }
	   print_trace_107_tools_trace(list1491_885);
	}
      else
	{
	   BUNSPEC;
	}
   }
   {
      bool_t test1500_892;
      {
	 obj_t aux_3967;
	 aux_3967 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 2)));
	 test1500_892 = CBOOL(aux_3967);
      }
      if (test1500_892)
	{
	   obj_t list1501_893;
	   {
	      obj_t arg1506_895;
	      {
		 obj_t arg1507_896;
		 {
		    obj_t aux_3973;
		    aux_3973 = BCHAR(((unsigned char) '\n'));
		    arg1507_896 = MAKE_PAIR(aux_3973, BNIL);
		 }
		 arg1506_895 = MAKE_PAIR(__return_kont__110_cgen_cgen, arg1507_896);
	      }
	      list1501_893 = MAKE_PAIR(string2631_cgen_cgen, arg1506_895);
	   }
	   print_trace_107_tools_trace(list1501_893);
	}
      else
	{
	   BUNSPEC;
	}
   }
   __the_global__73_cgen_cgen = (obj_t) (global_1);
   {
      obj_t sh_900;
      sh_900 = shape_tools_shape((obj_t) (global_1));
      BUNSPEC;
   }
   {
      sfun_c_188_t sfun_901;
      {
	 sfun_c_188_t obj1403_914;
	 obj1403_914 = ((sfun_c_188_t) ((((global_t) CREF(global_1))->value)));
	 {
	    sfun_c_188_t arg1529_915;
	    {
	       clabel_t arg1531_916;
	       {
		  obj_t arg1532_917;
		  arg1532_917 = (((global_t) CREF(global_1))->name);
		  {
		     clabel_t res2490_2278;
		     {
			clabel_t new1277_2271;
			new1277_2271 = ((clabel_t) BREF(GC_MALLOC(sizeof(struct clabel))));
			{
			   long arg1664_2272;
			   arg1664_2272 = class_num_218___object(clabel_cgen_cop);
			   {
			      obj_t obj_2276;
			      obj_2276 = (obj_t) (new1277_2271);
			      (((obj_t) CREF(obj_2276))->header = MAKE_HEADER(arg1664_2272, 0), BUNSPEC);
			   }
			}
			{
			   object_t aux_3989;
			   aux_3989 = (object_t) (new1277_2271);
			   OBJECT_WIDENING_SET(aux_3989, BFALSE);
			}
			((((clabel_t) CREF(new1277_2271))->name) = ((obj_t) arg1532_917), BUNSPEC);
			((((clabel_t) CREF(new1277_2271))->used__226) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			((((clabel_t) CREF(new1277_2271))->body) = ((obj_t) BUNSPEC), BUNSPEC);
			res2490_2278 = new1277_2271;
		     }
		     arg1531_916 = res2490_2278;
		  }
	       }
	       {
		  sfun_c_188_t res2491_2284;
		  {
		     sfun_c_188_t new1387_2281;
		     new1387_2281 = ((sfun_c_188_t) BREF(GC_MALLOC(sizeof(struct sfun_c_188))));
		     ((((sfun_c_188_t) CREF(new1387_2281))->label) = ((clabel_t) arg1531_916), BUNSPEC);
		     ((((sfun_c_188_t) CREF(new1387_2281))->integrated) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		     res2491_2284 = new1387_2281;
		  }
		  arg1529_915 = res2491_2284;
	       }
	    }
	    {
	       obj_t aux_4000;
	       object_t aux_3998;
	       aux_4000 = (obj_t) (arg1529_915);
	       aux_3998 = (object_t) (obj1403_914);
	       OBJECT_WIDENING_SET(aux_3998, aux_4000);
	    }
	 }
	 {
	    long arg1534_918;
	    arg1534_918 = class_num_218___object(sfun_c_188_cgen_cop);
	    {
	       obj_t obj_2285;
	       obj_2285 = (obj_t) (obj1403_914);
	       (((obj_t) CREF(obj_2285))->header = MAKE_HEADER(arg1534_918, 0), BUNSPEC);
	    }
	 }
	 sfun_901 = obj1403_914;
      }
      {
	 cop_t cop_902;
	 {
	    obj_t arg1524_911;
	    {
	       bool_t test1525_912;
	       {
		  obj_t obj2_2290;
		  obj2_2290 = __void__134_type_cache;
		  {
		     obj_t aux_4006;
		     {
			type_t aux_4007;
			aux_4007 = (((global_t) CREF(global_1))->type);
			aux_4006 = (obj_t) (aux_4007);
		     }
		     test1525_912 = (aux_4006 == obj2_2290);
		  }
	       }
	       if (test1525_912)
		 {
		    arg1524_911 = __void_kont__env_70_cgen_cgen;
		 }
	       else
		 {
		    arg1524_911 = __return_kont__110_cgen_cgen;
		 }
	    }
	    {
	       node_t aux_4012;
	       {
		  obj_t aux_4013;
		  {
		     sfun_t obj_2287;
		     obj_2287 = (sfun_t) (sfun_901);
		     aux_4013 = (((sfun_t) CREF(obj_2287))->body);
		  }
		  aux_4012 = (node_t) (aux_4013);
	       }
	       cop_902 = node__cop_142_cgen_cgen(aux_4012, arg1524_911);
	    }
	 }
	 {
	    {
	       clabel_t arg1513_903;
	       {
		  obj_t aux_4018;
		  {
		     object_t aux_4019;
		     aux_4019 = (object_t) (sfun_901);
		     aux_4018 = OBJECT_WIDENING(aux_4019);
		  }
		  arg1513_903 = (((sfun_c_188_t) CREF(aux_4018))->label);
	       }
	       {
		  obj_t res2492_2294;
		  {
		     obj_t val1280_2293;
		     val1280_2293 = (obj_t) (cop_902);
		     {
			obj_t x_3824;
			x_3824 = ((((clabel_t) CREF(arg1513_903))->body) = ((obj_t) val1280_2293), BUNSPEC);
			res2492_2294 = BUNSPEC;
		     }
		  }
		  res2492_2294;
	       }
	    }
	    sfun__c_170_cgen_cgen(sfun_901, global_1);
	    {
	       obj_t arg1514_904;
	       {
		  obj_t aux_4026;
		  {
		     clabel_t aux_4027;
		     {
			obj_t aux_4028;
			{
			   object_t aux_4029;
			   aux_4029 = (object_t) (sfun_901);
			   aux_4028 = OBJECT_WIDENING(aux_4029);
			}
			aux_4027 = (((sfun_c_188_t) CREF(aux_4028))->label);
		     }
		     aux_4026 = (obj_t) (aux_4027);
		  }
		  arg1514_904 = PROCEDURE_ENTRY(__block_kont__38_cgen_cgen) (__block_kont__38_cgen_cgen, aux_4026, BEOA);
	       }
	       emit_cop_45_cgen_emit_cop_239((cop_t) (arg1514_904));
	    }
	    {
	       obj_t list1518_906;
	       list1518_906 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
	       newline___r4_output_6_10_3(list1518_906);
	    }
	    {
	       obj_t list1521_908;
	       list1521_908 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
	       newline___r4_output_6_10_3(list1521_908);
	    }
	    return leave_function_170_tools_error();
	 }
      }
   }
}


obj_t 
_cgen_cgen_cgen(obj_t env_3797, obj_t global_3798)
{
   return cgen_cgen_cgen((global_t) (global_3798));
}


obj_t 
sfun__c_170_cgen_cgen(sfun_c_188_t sfun_2, global_t variable_3)
{
   {
      obj_t arg1535_920;
      {
	 obj_t aux_4048;
	 type_t aux_4045;
	 {
	    variable_t obj_2297;
	    obj_2297 = (variable_t) (variable_3);
	    aux_4048 = (((variable_t) CREF(obj_2297))->name);
	 }
	 {
	    variable_t obj_2296;
	    obj_2296 = (variable_t) (variable_3);
	    aux_4045 = (((variable_t) CREF(obj_2296))->type);
	 }
	 arg1535_920 = make_typed_declaration_180_type_tools(aux_4045, aux_4048);
      }
      {
	 obj_t list1536_921;
	 list1536_921 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
	 display___r4_output_6_10_3(arg1535_920, list1536_921);
      }
   }
   {
      bool_t test_4054;
      {
	 obj_t aux_4055;
	 {
	    sfun_t obj_2298;
	    obj_2298 = (sfun_t) (sfun_2);
	    aux_4055 = (((sfun_t) CREF(obj_2298))->args);
	 }
	 test_4054 = NULLP(aux_4055);
      }
      if (test_4054)
	{
	   obj_t list1541_926;
	   list1541_926 = MAKE_PAIR(string2632_cgen_cgen, BNIL);
	   return fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1541_926);
	}
      else
	{
	   {
	      obj_t list1544_929;
	      list1544_929 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
	      display___r4_output_6_10_3(BCHAR(((unsigned char) '(')), list1544_929);
	   }
	   {
	      obj_t args_931;
	      {
		 sfun_t obj_2300;
		 obj_2300 = (sfun_t) (sfun_2);
		 args_931 = (((sfun_t) CREF(obj_2300))->args);
	      }
	    loop_932:
	      {
		 bool_t test_4064;
		 {
		    obj_t aux_4065;
		    aux_4065 = CDR(args_931);
		    test_4064 = NULLP(aux_4065);
		 }
		 if (test_4064)
		   {
		      obj_t instance1405_935;
		      instance1405_935 = CAR(args_931);
		      {
			 obj_t arg1551_936;
			 {
			    obj_t aux_4072;
			    type_t aux_4069;
			    {
			       local_t obj_2305;
			       obj_2305 = (local_t) (instance1405_935);
			       aux_4072 = (((local_t) CREF(obj_2305))->name);
			    }
			    {
			       local_t obj_2304;
			       obj_2304 = (local_t) (instance1405_935);
			       aux_4069 = (((local_t) CREF(obj_2304))->type);
			    }
			    arg1551_936 = make_typed_declaration_180_type_tools(aux_4069, aux_4072);
			 }
			 {
			    obj_t list1552_937;
			    list1552_937 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			    display___r4_output_6_10_3(arg1551_936, list1552_937);
			 }
		      }
		      {
			 obj_t list1556_941;
			 {
			    obj_t aux_4078;
			    aux_4078 = BCHAR(((unsigned char) ')'));
			    list1556_941 = MAKE_PAIR(aux_4078, BNIL);
			 }
			 return fprint___r4_output_6_10_3(__c_port__188_cgen_emit, list1556_941);
		      }
		   }
		 else
		   {
		      obj_t instance1406_943;
		      instance1406_943 = CAR(args_931);
		      {
			 obj_t arg1559_944;
			 {
			    obj_t aux_4086;
			    type_t aux_4083;
			    {
			       local_t obj_2308;
			       obj_2308 = (local_t) (instance1406_943);
			       aux_4086 = (((local_t) CREF(obj_2308))->name);
			    }
			    {
			       local_t obj_2307;
			       obj_2307 = (local_t) (instance1406_943);
			       aux_4083 = (((local_t) CREF(obj_2307))->type);
			    }
			    arg1559_944 = make_typed_declaration_180_type_tools(aux_4083, aux_4086);
			 }
			 {
			    obj_t list1560_945;
			    list1560_945 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			    display___r4_output_6_10_3(arg1559_944, list1560_945);
			 }
		      }
		      {
			 obj_t list1564_949;
			 list1564_949 = MAKE_PAIR(__c_port__188_cgen_emit, BNIL);
			 display___r4_output_6_10_3(string2633_cgen_cgen, list1564_949);
		      }
		      {
			 obj_t args_4094;
			 args_4094 = CDR(args_931);
			 args_931 = args_4094;
			 goto loop_932;
		      }
		   }
	      }
	   }
	}
   }
}


cvoid_t 
__void_kont__34_cgen_cgen(obj_t cop_4)
{
   {
      cvoid_t res2493_2316;
      {
	 cop_t value_2310;
	 value_2310 = (cop_t) (cop_4);
	 {
	    cvoid_t new1297_2311;
	    new1297_2311 = ((cvoid_t) BREF(GC_MALLOC(sizeof(struct cvoid))));
	    {
	       long arg1653_2312;
	       arg1653_2312 = class_num_218___object(cvoid_cgen_cop);
	       {
		  obj_t obj_2314;
		  obj_2314 = (obj_t) (new1297_2311);
		  (((obj_t) CREF(obj_2314))->header = MAKE_HEADER(arg1653_2312, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_4103;
	       aux_4103 = (object_t) (new1297_2311);
	       OBJECT_WIDENING_SET(aux_4103, BFALSE);
	    }
	    ((((cvoid_t) CREF(new1297_2311))->value) = ((cop_t) value_2310), BUNSPEC);
	    res2493_2316 = new1297_2311;
	 }
      }
      return res2493_2316;
   }
}


obj_t 
__void_kont__176_cgen_cgen(obj_t env_3799, obj_t cop_3800)
{
   {
      cvoid_t aux_4107;
      aux_4107 = __void_kont__34_cgen_cgen(cop_3800);
      return (obj_t) (aux_4107);
   }
}


obj_t 
make_setq_kont_65_cgen_cgen(variable_t var_7, obj_t kont_8)
{
   {
      obj_t lambda1569_3801;
      lambda1569_3801 = make_fx_procedure(lambda15692621_cgen_cgen, ((long) 1), ((long) 2));
      {
	 obj_t aux_4111;
	 aux_4111 = (obj_t) (var_7);
	 PROCEDURE_SET(lambda1569_3801, ((long) 0), aux_4111);
      }
      PROCEDURE_SET(lambda1569_3801, ((long) 1), kont_8);
      return lambda1569_3801;
   }
}


obj_t 
lambda15692621_cgen_cgen(obj_t env_3802, obj_t cop_3805)
{
   {
      obj_t var_3803;
      obj_t kont_3804;
      var_3803 = PROCEDURE_REF(env_3802, ((long) 0));
      kont_3804 = PROCEDURE_REF(env_3802, ((long) 1));
      {
	 obj_t cop_954;
	 cop_954 = cop_3805;
	 {
	    bool_t test1570_956;
	    test1570_956 = is_a__118___object(cop_954, cfail_cgen_cop);
	    if (test1570_956)
	      {
		 return cop_954;
	      }
	    else
	      {
		 csetq_t arg1571_957;
		 {
		    varc_t arg1572_958;
		    obj_t arg1573_959;
		    {
		       varc_t res2494_2324;
		       {
			  variable_t variable_2318;
			  variable_2318 = (variable_t) (var_3803);
			  {
			     varc_t new1305_2319;
			     new1305_2319 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
			     {
				long arg1648_2320;
				arg1648_2320 = class_num_218___object(varc_cgen_cop);
				{
				   obj_t obj_2322;
				   obj_2322 = (obj_t) (new1305_2319);
				   (((obj_t) CREF(obj_2322))->header = MAKE_HEADER(arg1648_2320, 0), BUNSPEC);
				}
			     }
			     {
				object_t aux_4124;
				aux_4124 = (object_t) (new1305_2319);
				OBJECT_WIDENING_SET(aux_4124, BFALSE);
			     }
			     ((((varc_t) CREF(new1305_2319))->variable) = ((variable_t) variable_2318), BUNSPEC);
			     res2494_2324 = new1305_2319;
			  }
		       }
		       arg1572_958 = res2494_2324;
		    }
		    {
		       bool_t test1574_960;
		       test1574_960 = is_a__118___object(cop_954, csetq_cgen_cop);
		       if (test1574_960)
			 {
			    {
			       obj_t arg1575_961;
			       {
				  catom_t arg1576_962;
				  {
				     catom_t res2495_2332;
				     {
					catom_t new1301_2327;
					new1301_2327 = ((catom_t) BREF(GC_MALLOC(sizeof(struct catom))));
					{
					   long arg1651_2328;
					   arg1651_2328 = class_num_218___object(catom_cgen_cop);
					   {
					      obj_t obj_2330;
					      obj_2330 = (obj_t) (new1301_2327);
					      (((obj_t) CREF(obj_2330))->header = MAKE_HEADER(arg1651_2328, 0), BUNSPEC);
					   }
					}
					{
					   object_t aux_4134;
					   aux_4134 = (object_t) (new1301_2327);
					   OBJECT_WIDENING_SET(aux_4134, BFALSE);
					}
					((((catom_t) CREF(new1301_2327))->value) = ((obj_t) BUNSPEC), BUNSPEC);
					res2495_2332 = new1301_2327;
				     }
				     arg1576_962 = res2495_2332;
				  }
				  {
				     obj_t list1577_963;
				     {
					obj_t arg1578_964;
					{
					   obj_t aux_4138;
					   aux_4138 = (obj_t) (arg1576_962);
					   arg1578_964 = MAKE_PAIR(aux_4138, BNIL);
					}
					list1577_963 = MAKE_PAIR(cop_954, arg1578_964);
				     }
				     arg1575_961 = list1577_963;
				  }
			       }
			       {
				  csequence_t res2496_2342;
				  {
				     csequence_t new1317_2336;
				     new1317_2336 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
				     {
					long arg1642_2337;
					arg1642_2337 = class_num_218___object(csequence_cgen_cop);
					{
					   obj_t obj_2340;
					   obj_2340 = (obj_t) (new1317_2336);
					   (((obj_t) CREF(obj_2340))->header = MAKE_HEADER(arg1642_2337, 0), BUNSPEC);
					}
				     }
				     {
					object_t aux_4146;
					aux_4146 = (object_t) (new1317_2336);
					OBJECT_WIDENING_SET(aux_4146, BFALSE);
				     }
				     ((((csequence_t) CREF(new1317_2336))->c_exp__163) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				     ((((csequence_t) CREF(new1317_2336))->cops) = ((obj_t) arg1575_961), BUNSPEC);
				     res2496_2342 = new1317_2336;
				  }
				  arg1573_959 = (obj_t) (res2496_2342);
			       }
			    }
			 }
		       else
			 {
			    arg1573_959 = cop_954;
			 }
		    }
		    {
		       csetq_t res2497_2351;
		       {
			  cop_t value_2344;
			  value_2344 = (cop_t) (arg1573_959);
			  {
			     csetq_t new1330_2345;
			     new1330_2345 = ((csetq_t) BREF(GC_MALLOC(sizeof(struct csetq))));
			     {
				long arg1630_2346;
				arg1630_2346 = class_num_218___object(csetq_cgen_cop);
				{
				   obj_t obj_2349;
				   obj_2349 = (obj_t) (new1330_2345);
				   (((obj_t) CREF(obj_2349))->header = MAKE_HEADER(arg1630_2346, 0), BUNSPEC);
				}
			     }
			     {
				object_t aux_4157;
				aux_4157 = (object_t) (new1330_2345);
				OBJECT_WIDENING_SET(aux_4157, BFALSE);
			     }
			     ((((csetq_t) CREF(new1330_2345))->var) = ((varc_t) arg1572_958), BUNSPEC);
			     ((((csetq_t) CREF(new1330_2345))->value) = ((cop_t) value_2344), BUNSPEC);
			     res2497_2351 = new1330_2345;
			  }
		       }
		       arg1571_957 = res2497_2351;
		    }
		 }
		 return PROCEDURE_ENTRY(kont_3804) (kont_3804, (obj_t) (arg1571_957), BEOA);
	      }
	 }
      }
   }
}


cop_t 
node__cop_default1442_123_cgen_cgen(node_t node_11, obj_t kont_12)
{
   FAILURE(CNST_TABLE_REF(((long) 1)), string2634_cgen_cgen, (obj_t) (node_11));
}


obj_t 
_node__cop_default1442_33_cgen_cgen(obj_t env_3794, obj_t node_3795, obj_t kont_3796)
{
   {
      cop_t aux_4168;
      aux_4168 = node__cop_default1442_123_cgen_cgen((node_t) (node_3795), kont_3796);
      return (obj_t) (aux_4168);
   }
}


cop_t 
node__cop_142_cgen_cgen(node_t node_9, obj_t kont_10)
{
   {
      obj_t method1756_1449;
      obj_t class1762_1450;
      {
	 obj_t arg1766_1447;
	 obj_t arg1767_1448;
	 {
	    object_t obj_2357;
	    obj_2357 = (object_t) (node_9);
	    {
	       obj_t pre_method_105_2358;
	       pre_method_105_2358 = PROCEDURE_REF(node__cop_env_160_cgen_cgen, ((long) 2));
	       if (INTEGERP(pre_method_105_2358))
		 {
		    PROCEDURE_SET(node__cop_env_160_cgen_cgen, ((long) 2), BUNSPEC);
		    arg1766_1447 = pre_method_105_2358;
		 }
	       else
		 {
		    long obj_class_num_177_2363;
		    obj_class_num_177_2363 = TYPE(obj_2357);
		    {
		       obj_t arg1183_2364;
		       arg1183_2364 = PROCEDURE_REF(node__cop_env_160_cgen_cgen, ((long) 1));
		       {
			  long arg1184_2368;
			  {
			     long arg1186_2369;
			     arg1186_2369 = OBJECT_TYPE;
			     arg1184_2368 = (obj_class_num_177_2363 - arg1186_2369);
			  }
			  arg1766_1447 = VECTOR_REF(arg1183_2364, arg1184_2368);
		       }
		    }
		 }
	    }
	 }
	 {
	    object_t object_2374;
	    object_2374 = (object_t) (node_9);
	    {
	       long arg1187_2375;
	       {
		  long arg1188_2376;
		  long arg1189_2377;
		  arg1188_2376 = TYPE(object_2374);
		  arg1189_2377 = OBJECT_TYPE;
		  arg1187_2375 = (arg1188_2376 - arg1189_2377);
	       }
	       {
		  obj_t vector_2381;
		  vector_2381 = __classes__134___object;
		  arg1767_1448 = VECTOR_REF(vector_2381, arg1187_2375);
	       }
	    }
	 }
	 {
	    obj_t aux_4187;
	    method1756_1449 = arg1766_1447;
	    class1762_1450 = arg1767_1448;
	    {
	       if (INTEGERP(method1756_1449))
		 {
		    switch ((long) CINT(method1756_1449))
		      {
		      case ((long) 0):
			 {
			    atom_t node_1456;
			    node_1456 = (atom_t) (node_9);
			    {
			       bool_t test1770_1458;
			       {
				  obj_t aux_4191;
				  aux_4191 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1770_1458 = CBOOL(aux_4191);
			       }
			       if (test1770_1458)
				 {
				    obj_t arg1772_1460;
				    arg1772_1460 = shape_tools_shape((obj_t) (node_1456));
				    {
				       obj_t list1774_1462;
				       {
					  obj_t arg1775_1463;
					  {
					     obj_t arg1776_1464;
					     {
						obj_t arg1777_1465;
						{
						   obj_t arg1778_1466;
						   {
						      obj_t arg1779_1467;
						      {
							 obj_t aux_4199;
							 aux_4199 = BCHAR(((unsigned char) '\n'));
							 arg1779_1467 = MAKE_PAIR(aux_4199, BNIL);
						      }
						      arg1778_1466 = MAKE_PAIR(kont_10, arg1779_1467);
						   }
						   arg1777_1465 = MAKE_PAIR(string2635_cgen_cgen, arg1778_1466);
						}
						{
						   obj_t aux_4204;
						   aux_4204 = BCHAR(((unsigned char) '\n'));
						   arg1776_1464 = MAKE_PAIR(aux_4204, arg1777_1465);
						}
					     }
					     arg1775_1463 = MAKE_PAIR(arg1772_1460, arg1776_1464);
					  }
					  list1774_1462 = MAKE_PAIR(string2636_cgen_cgen, arg1775_1463);
				       }
				       print_trace_107_tools_trace(list1774_1462);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       catom_t arg1784_1472;
			       {
				  obj_t arg1785_1473;
				  arg1785_1473 = (((atom_t) CREF(node_1456))->value);
				  {
				     catom_t res2498_2390;
				     {
					catom_t new1301_2385;
					new1301_2385 = ((catom_t) BREF(GC_MALLOC(sizeof(struct catom))));
					{
					   long arg1651_2386;
					   arg1651_2386 = class_num_218___object(catom_cgen_cop);
					   {
					      obj_t obj_2388;
					      obj_2388 = (obj_t) (new1301_2385);
					      (((obj_t) CREF(obj_2388))->header = MAKE_HEADER(arg1651_2386, 0), BUNSPEC);
					   }
					}
					{
					   object_t aux_4215;
					   aux_4215 = (object_t) (new1301_2385);
					   OBJECT_WIDENING_SET(aux_4215, BFALSE);
					}
					((((catom_t) CREF(new1301_2385))->value) = ((obj_t) arg1785_1473), BUNSPEC);
					res2498_2390 = new1301_2385;
				     }
				     arg1784_1472 = res2498_2390;
				  }
			       }
			       aux_4187 = PROCEDURE_ENTRY(kont_10) (kont_10, (obj_t) (arg1784_1472), BEOA);
			    }
			 }
			 break;
		      case ((long) 1):
			 {
			    kwote_t node_1474;
			    node_1474 = (kwote_t) (node_9);
			    {
			       bool_t test1786_1476;
			       {
				  obj_t aux_4223;
				  aux_4223 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1786_1476 = CBOOL(aux_4223);
			       }
			       if (test1786_1476)
				 {
				    obj_t arg1789_1478;
				    arg1789_1478 = shape_tools_shape((obj_t) (node_1474));
				    {
				       obj_t list1792_1480;
				       {
					  obj_t arg1793_1481;
					  {
					     obj_t arg1795_1482;
					     {
						obj_t arg1796_1483;
						{
						   obj_t arg1798_1484;
						   {
						      obj_t arg1799_1485;
						      {
							 obj_t aux_4231;
							 aux_4231 = BCHAR(((unsigned char) '\n'));
							 arg1799_1485 = MAKE_PAIR(aux_4231, BNIL);
						      }
						      arg1798_1484 = MAKE_PAIR(kont_10, arg1799_1485);
						   }
						   arg1796_1483 = MAKE_PAIR(string2635_cgen_cgen, arg1798_1484);
						}
						{
						   obj_t aux_4236;
						   aux_4236 = BCHAR(((unsigned char) '\n'));
						   arg1795_1482 = MAKE_PAIR(aux_4236, arg1796_1483);
						}
					     }
					     arg1793_1481 = MAKE_PAIR(arg1789_1478, arg1795_1482);
					  }
					  list1792_1480 = MAKE_PAIR(string2637_cgen_cgen, arg1793_1481);
				       }
				       print_trace_107_tools_trace(list1792_1480);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       obj_t arg1806_1491;
			       arg1806_1491 = shape_tools_shape((obj_t) (node_1474));
			       aux_4187 = internal_error_43_tools_error(string2638_cgen_cgen, string2639_cgen_cgen, arg1806_1491);
			    }
			 }
			 break;
		      case ((long) 2):
			 {
			    var_t node_1492;
			    node_1492 = (var_t) (node_9);
			    {
			       bool_t test1807_1494;
			       {
				  obj_t aux_4246;
				  aux_4246 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1807_1494 = CBOOL(aux_4246);
			       }
			       if (test1807_1494)
				 {
				    obj_t arg1809_1496;
				    arg1809_1496 = shape_tools_shape((obj_t) (node_1492));
				    {
				       obj_t list1811_1498;
				       {
					  obj_t arg1812_1499;
					  {
					     obj_t arg1813_1500;
					     {
						obj_t arg1814_1501;
						{
						   obj_t arg1819_1502;
						   {
						      obj_t arg1820_1503;
						      {
							 obj_t aux_4254;
							 aux_4254 = BCHAR(((unsigned char) '\n'));
							 arg1820_1503 = MAKE_PAIR(aux_4254, BNIL);
						      }
						      arg1819_1502 = MAKE_PAIR(kont_10, arg1820_1503);
						   }
						   arg1814_1501 = MAKE_PAIR(string2635_cgen_cgen, arg1819_1502);
						}
						{
						   obj_t aux_4259;
						   aux_4259 = BCHAR(((unsigned char) '\n'));
						   arg1813_1500 = MAKE_PAIR(aux_4259, arg1814_1501);
						}
					     }
					     arg1812_1499 = MAKE_PAIR(arg1809_1496, arg1813_1500);
					  }
					  list1811_1498 = MAKE_PAIR(string2640_cgen_cgen, arg1812_1499);
				       }
				       print_trace_107_tools_trace(list1811_1498);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       varc_t arg1824_1508;
			       {
				  variable_t arg1825_1509;
				  arg1825_1509 = (((var_t) CREF(node_1492))->variable);
				  {
				     varc_t res2499_2398;
				     {
					varc_t new1305_2393;
					new1305_2393 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
					{
					   long arg1648_2394;
					   arg1648_2394 = class_num_218___object(varc_cgen_cop);
					   {
					      obj_t obj_2396;
					      obj_2396 = (obj_t) (new1305_2393);
					      (((obj_t) CREF(obj_2396))->header = MAKE_HEADER(arg1648_2394, 0), BUNSPEC);
					   }
					}
					{
					   object_t aux_4270;
					   aux_4270 = (object_t) (new1305_2393);
					   OBJECT_WIDENING_SET(aux_4270, BFALSE);
					}
					((((varc_t) CREF(new1305_2393))->variable) = ((variable_t) arg1825_1509), BUNSPEC);
					res2499_2398 = new1305_2393;
				     }
				     arg1824_1508 = res2499_2398;
				  }
			       }
			       aux_4187 = PROCEDURE_ENTRY(kont_10) (kont_10, (obj_t) (arg1824_1508), BEOA);
			    }
			 }
			 break;
		      case ((long) 3):
			 {
			    closure_t node_1510;
			    node_1510 = (closure_t) (node_9);
			    {
			       bool_t test1826_1512;
			       {
				  obj_t aux_4278;
				  aux_4278 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1826_1512 = CBOOL(aux_4278);
			       }
			       if (test1826_1512)
				 {
				    obj_t arg1828_1514;
				    arg1828_1514 = shape_tools_shape((obj_t) (node_1510));
				    {
				       obj_t list1830_1516;
				       {
					  obj_t arg1831_1517;
					  {
					     obj_t arg1832_1518;
					     {
						obj_t arg1833_1519;
						{
						   obj_t arg1834_1520;
						   {
						      obj_t arg1835_1521;
						      {
							 obj_t aux_4286;
							 aux_4286 = BCHAR(((unsigned char) '\n'));
							 arg1835_1521 = MAKE_PAIR(aux_4286, BNIL);
						      }
						      arg1834_1520 = MAKE_PAIR(kont_10, arg1835_1521);
						   }
						   arg1833_1519 = MAKE_PAIR(string2635_cgen_cgen, arg1834_1520);
						}
						{
						   obj_t aux_4291;
						   aux_4291 = BCHAR(((unsigned char) '\n'));
						   arg1832_1518 = MAKE_PAIR(aux_4291, arg1833_1519);
						}
					     }
					     arg1831_1517 = MAKE_PAIR(arg1828_1514, arg1832_1518);
					  }
					  list1830_1516 = MAKE_PAIR(string2641_cgen_cgen, arg1831_1517);
				       }
				       print_trace_107_tools_trace(list1830_1516);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       obj_t arg1841_1527;
			       arg1841_1527 = shape_tools_shape((obj_t) (node_1510));
			       aux_4187 = internal_error_43_tools_error(string2638_cgen_cgen, string2642_cgen_cgen, arg1841_1527);
			    }
			 }
			 break;
		      case ((long) 4):
			 {
			    sequence_t node_1528;
			    node_1528 = (sequence_t) (node_9);
			    {
			       bool_t test1842_1530;
			       {
				  obj_t aux_4301;
				  aux_4301 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1842_1530 = CBOOL(aux_4301);
			       }
			       if (test1842_1530)
				 {
				    obj_t arg1844_1532;
				    arg1844_1532 = shape_tools_shape((obj_t) (node_1528));
				    {
				       obj_t list1846_1534;
				       {
					  obj_t arg1847_1535;
					  {
					     obj_t arg1848_1536;
					     {
						obj_t arg1849_1537;
						{
						   obj_t arg1852_1538;
						   {
						      obj_t arg1853_1539;
						      {
							 obj_t aux_4309;
							 aux_4309 = BCHAR(((unsigned char) '\n'));
							 arg1853_1539 = MAKE_PAIR(aux_4309, BNIL);
						      }
						      arg1852_1538 = MAKE_PAIR(kont_10, arg1853_1539);
						   }
						   arg1849_1537 = MAKE_PAIR(string2635_cgen_cgen, arg1852_1538);
						}
						{
						   obj_t aux_4314;
						   aux_4314 = BCHAR(((unsigned char) '\n'));
						   arg1848_1536 = MAKE_PAIR(aux_4314, arg1849_1537);
						}
					     }
					     arg1847_1535 = MAKE_PAIR(arg1844_1532, arg1848_1536);
					  }
					  list1846_1534 = MAKE_PAIR(string2643_cgen_cgen, arg1847_1535);
				       }
				       print_trace_107_tools_trace(list1846_1534);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       obj_t exp_1544;
			       exp_1544 = (((sequence_t) CREF(node_1528))->nodes);
			       if (NULLP(exp_1544))
				 {
				    {
				       nop_t arg1859_1546;
				       {
					  nop_t res2500_2405;
					  {
					     nop_t new1321_2401;
					     new1321_2401 = ((nop_t) BREF(GC_MALLOC(sizeof(struct nop))));
					     {
						long arg1638_2402;
						arg1638_2402 = class_num_218___object(nop_cgen_cop);
						{
						   obj_t obj_2403;
						   obj_2403 = (obj_t) (new1321_2401);
						   (((obj_t) CREF(obj_2403))->header = MAKE_HEADER(arg1638_2402, 0), BUNSPEC);
						}
					     }
					     {
						object_t aux_4327;
						aux_4327 = (object_t) (new1321_2401);
						OBJECT_WIDENING_SET(aux_4327, BFALSE);
					     }
					     {
						res2500_2405 = new1321_2401;
					     }
					  }
					  arg1859_1546 = res2500_2405;
				       }
				       aux_4187 = PROCEDURE_ENTRY(kont_10) (kont_10, (obj_t) (arg1859_1546), BEOA);
				    }
				 }
			       else
				 {
				    bool_t test_4333;
				    {
				       obj_t aux_4334;
				       aux_4334 = CDR(exp_1544);
				       test_4333 = NULLP(aux_4334);
				    }
				    if (test_4333)
				      {
					 {
					    cop_t cop_1548;
					    {
					       node_t aux_4337;
					       {
						  obj_t aux_4338;
						  aux_4338 = CAR(exp_1544);
						  aux_4337 = (node_t) (aux_4338);
					       }
					       cop_1548 = node__cop_142_cgen_cgen(aux_4337, kont_10);
					    }
					    {
					       stop_t res2501_2415;
					       {
						  stop_t new1326_2410;
						  new1326_2410 = ((stop_t) BREF(GC_MALLOC(sizeof(struct stop))));
						  {
						     long arg1634_2411;
						     arg1634_2411 = class_num_218___object(stop_cgen_cop);
						     {
							obj_t obj_2413;
							obj_2413 = (obj_t) (new1326_2410);
							(((obj_t) CREF(obj_2413))->header = MAKE_HEADER(arg1634_2411, 0), BUNSPEC);
						     }
						  }
						  {
						     object_t aux_4346;
						     aux_4346 = (object_t) (new1326_2410);
						     OBJECT_WIDENING_SET(aux_4346, BFALSE);
						  }
						  ((((stop_t) CREF(new1326_2410))->value) = ((cop_t) cop_1548), BUNSPEC);
						  res2501_2415 = new1326_2410;
					       }
					       aux_4187 = (obj_t) (res2501_2415);
					    }
					 }
				      }
				    else
				      {
					 {
					    obj_t exp_1550;
					    obj_t new_1551;
					    {
					       csequence_t aux_4351;
					       exp_1550 = exp_1544;
					       new_1551 = BNIL;
					     loop_1552:
					       {
						  bool_t test_4352;
						  {
						     obj_t aux_4353;
						     aux_4353 = CDR(exp_1550);
						     test_4352 = NULLP(aux_4353);
						  }
						  if (test_4352)
						    {
						       obj_t arg1864_1555;
						       {
							  obj_t arg1865_1556;
							  {
							     cop_t arg1866_1557;
							     {
								node_t aux_4356;
								{
								   obj_t aux_4357;
								   aux_4357 = CAR(exp_1550);
								   aux_4356 = (node_t) (aux_4357);
								}
								arg1866_1557 = node__cop_142_cgen_cgen(aux_4356, kont_10);
							     }
							     {
								obj_t aux_4361;
								aux_4361 = (obj_t) (arg1866_1557);
								arg1865_1556 = MAKE_PAIR(aux_4361, new_1551);
							     }
							  }
							  arg1864_1555 = reverse__39___r4_pairs_and_lists_6_3(arg1865_1556);
						       }
						       {
							  csequence_t res2502_2429;
							  {
							     csequence_t new1317_2423;
							     new1317_2423 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
							     {
								long arg1642_2424;
								arg1642_2424 = class_num_218___object(csequence_cgen_cop);
								{
								   obj_t obj_2427;
								   obj_2427 = (obj_t) (new1317_2423);
								   (((obj_t) CREF(obj_2427))->header = MAKE_HEADER(arg1642_2424, 0), BUNSPEC);
								}
							     }
							     {
								object_t aux_4369;
								aux_4369 = (object_t) (new1317_2423);
								OBJECT_WIDENING_SET(aux_4369, BFALSE);
							     }
							     ((((csequence_t) CREF(new1317_2423))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							     ((((csequence_t) CREF(new1317_2423))->cops) = ((obj_t) arg1864_1555), BUNSPEC);
							     res2502_2429 = new1317_2423;
							  }
							  aux_4351 = res2502_2429;
						       }
						    }
						  else
						    {
						       {
							  bool_t test1868_1559;
							  {
							     node_t aux_4374;
							     {
								obj_t aux_4375;
								aux_4375 = CAR(exp_1550);
								aux_4374 = (node_t) (aux_4375);
							     }
							     test1868_1559 = side_effect__165_effect_effect(aux_4374);
							  }
							  if (test1868_1559)
							    {
							       obj_t arg1870_1560;
							       obj_t arg1871_1561;
							       arg1870_1560 = CDR(exp_1550);
							       {
								  cop_t arg1872_1562;
								  {
								     node_t aux_4381;
								     {
									obj_t aux_4382;
									aux_4382 = CAR(exp_1550);
									aux_4381 = (node_t) (aux_4382);
								     }
								     arg1872_1562 = node__cop_142_cgen_cgen(aux_4381, __stop_kont__121_cgen_cgen);
								  }
								  {
								     obj_t aux_4386;
								     aux_4386 = (obj_t) (arg1872_1562);
								     arg1871_1561 = MAKE_PAIR(aux_4386, new_1551);
								  }
							       }
							       {
								  obj_t new_4390;
								  obj_t exp_4389;
								  exp_4389 = arg1870_1560;
								  new_4390 = arg1871_1561;
								  new_1551 = new_4390;
								  exp_1550 = exp_4389;
								  goto loop_1552;
							       }
							    }
							  else
							    {
							       obj_t exp_4391;
							       exp_4391 = CDR(exp_1550);
							       exp_1550 = exp_4391;
							       goto loop_1552;
							    }
						       }
						    }
					       }
					       aux_4187 = (obj_t) (aux_4351);
					    }
					 }
				      }
				 }
			    }
			 }
			 break;
		      case ((long) 5):
			 {
			    pragma_t node_1568;
			    node_1568 = (pragma_t) (node_9);
			    {
			       bool_t test1880_1570;
			       {
				  obj_t aux_4395;
				  aux_4395 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1880_1570 = CBOOL(aux_4395);
			       }
			       if (test1880_1570)
				 {
				    obj_t arg1882_1572;
				    arg1882_1572 = shape_tools_shape((obj_t) (node_1568));
				    {
				       obj_t list1884_1574;
				       {
					  obj_t arg1885_1575;
					  {
					     obj_t arg1886_1576;
					     {
						obj_t arg1887_1577;
						{
						   obj_t arg1889_1578;
						   {
						      obj_t arg1890_1579;
						      {
							 obj_t aux_4403;
							 aux_4403 = BCHAR(((unsigned char) '\n'));
							 arg1890_1579 = MAKE_PAIR(aux_4403, BNIL);
						      }
						      arg1889_1578 = MAKE_PAIR(kont_10, arg1890_1579);
						   }
						   arg1887_1577 = MAKE_PAIR(string2635_cgen_cgen, arg1889_1578);
						}
						{
						   obj_t aux_4408;
						   aux_4408 = BCHAR(((unsigned char) '\n'));
						   arg1886_1576 = MAKE_PAIR(aux_4408, arg1887_1577);
						}
					     }
					     arg1885_1575 = MAKE_PAIR(arg1882_1572, arg1886_1576);
					  }
					  list1884_1574 = MAKE_PAIR(string2644_cgen_cgen, arg1885_1575);
				       }
				       print_trace_107_tools_trace(list1884_1574);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       obj_t old_actuals_174_1584;
			       obj_t new_actuals_73_1585;
			       local_t aux_1586;
			       obj_t auxs_1587;
			       obj_t exps_1588;
			       {
				  obj_t arg1894_1590;
				  local_t arg1896_1592;
				  arg1894_1590 = (((pragma_t) CREF(node_1568))->args);
				  {
				     obj_t arg1899_1595;
				     arg1899_1595 = CNST_TABLE_REF(((long) 2));
				     {
					local_t res2503_2440;
					{
					   type_t type_2438;
					   type_2438 = (type_t) (__obj__252_type_cache);
					   {
					      local_t local_2439;
					      local_2439 = make_local_svar_140_ast_local(arg1899_1595, type_2438);
					      set_variable_name__102_cgen_prototype((obj_t) (local_2439));
					      res2503_2440 = local_2439;
					   }
					}
					arg1896_1592 = res2503_2440;
				     }
				  }
				  old_actuals_174_1584 = arg1894_1590;
				  new_actuals_73_1585 = BNIL;
				  aux_1586 = arg1896_1592;
				  auxs_1587 = BNIL;
				  exps_1588 = BNIL;
				loop_1589:
				  if (NULLP(old_actuals_174_1584))
				    {
				       if (NULLP(auxs_1587))
					 {
					    cpragma_t arg1902_1598;
					    {
					       obj_t arg1904_1599;
					       obj_t arg1905_1600;
					       arg1904_1599 = (((pragma_t) CREF(node_1568))->format);
					       arg1905_1600 = reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_1585);
					       {
						  cpragma_t res2504_2452;
						  {
						     cpragma_t new1309_2446;
						     new1309_2446 = ((cpragma_t) BREF(GC_MALLOC(sizeof(struct cpragma))));
						     {
							long arg1646_2447;
							arg1646_2447 = class_num_218___object(cpragma_cgen_cop);
							{
							   obj_t obj_2450;
							   obj_2450 = (obj_t) (new1309_2446);
							   (((obj_t) CREF(obj_2450))->header = MAKE_HEADER(arg1646_2447, 0), BUNSPEC);
							}
						     }
						     {
							object_t aux_4430;
							aux_4430 = (object_t) (new1309_2446);
							OBJECT_WIDENING_SET(aux_4430, BFALSE);
						     }
						     ((((cpragma_t) CREF(new1309_2446))->format) = ((obj_t) arg1904_1599), BUNSPEC);
						     ((((cpragma_t) CREF(new1309_2446))->args) = ((obj_t) arg1905_1600), BUNSPEC);
						     res2504_2452 = new1309_2446;
						  }
						  arg1902_1598 = res2504_2452;
					       }
					    }
					    aux_4187 = PROCEDURE_ENTRY(kont_10) (kont_10, (obj_t) (arg1902_1598), BEOA);
					 }
				       else
					 {
					    csequence_t arg1906_1601;
					    {
					       obj_t arg1907_1602;
					       {
						  local_var_164_t arg1908_1603;
						  csequence_t arg1909_1604;
						  obj_t arg1911_1605;
						  {
						     local_var_164_t res2505_2459;
						     {
							local_var_164_t new1342_2454;
							new1342_2454 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							{
							   long arg1621_2455;
							   arg1621_2455 = class_num_218___object(local_var_164_cgen_cop);
							   {
							      obj_t obj_2457;
							      obj_2457 = (obj_t) (new1342_2454);
							      (((obj_t) CREF(obj_2457))->header = MAKE_HEADER(arg1621_2455, 0), BUNSPEC);
							   }
							}
							{
							   object_t aux_4442;
							   aux_4442 = (object_t) (new1342_2454);
							   OBJECT_WIDENING_SET(aux_4442, BFALSE);
							}
							((((local_var_164_t) CREF(new1342_2454))->vars) = ((obj_t) auxs_1587), BUNSPEC);
							res2505_2459 = new1342_2454;
						     }
						     arg1908_1603 = res2505_2459;
						  }
						  {
						     csequence_t res2506_2468;
						     {
							csequence_t new1317_2462;
							new1317_2462 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
							{
							   long arg1642_2463;
							   arg1642_2463 = class_num_218___object(csequence_cgen_cop);
							   {
							      obj_t obj_2466;
							      obj_2466 = (obj_t) (new1317_2462);
							      (((obj_t) CREF(obj_2466))->header = MAKE_HEADER(arg1642_2463, 0), BUNSPEC);
							   }
							}
							{
							   object_t aux_4450;
							   aux_4450 = (object_t) (new1317_2462);
							   OBJECT_WIDENING_SET(aux_4450, BFALSE);
							}
							((((csequence_t) CREF(new1317_2462))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							((((csequence_t) CREF(new1317_2462))->cops) = ((obj_t) exps_1588), BUNSPEC);
							res2506_2468 = new1317_2462;
						     }
						     arg1909_1604 = res2506_2468;
						  }
						  {
						     cpragma_t arg1916_1610;
						     {
							obj_t arg1917_1611;
							obj_t arg1918_1612;
							arg1917_1611 = (((pragma_t) CREF(node_1568))->format);
							arg1918_1612 = reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_1585);
							{
							   cpragma_t res2507_2478;
							   {
							      cpragma_t new1309_2472;
							      new1309_2472 = ((cpragma_t) BREF(GC_MALLOC(sizeof(struct cpragma))));
							      {
								 long arg1646_2473;
								 arg1646_2473 = class_num_218___object(cpragma_cgen_cop);
								 {
								    obj_t obj_2476;
								    obj_2476 = (obj_t) (new1309_2472);
								    (((obj_t) CREF(obj_2476))->header = MAKE_HEADER(arg1646_2473, 0), BUNSPEC);
								 }
							      }
							      {
								 object_t aux_4461;
								 aux_4461 = (object_t) (new1309_2472);
								 OBJECT_WIDENING_SET(aux_4461, BFALSE);
							      }
							      ((((cpragma_t) CREF(new1309_2472))->format) = ((obj_t) arg1917_1611), BUNSPEC);
							      ((((cpragma_t) CREF(new1309_2472))->args) = ((obj_t) arg1918_1612), BUNSPEC);
							      res2507_2478 = new1309_2472;
							   }
							   arg1916_1610 = res2507_2478;
							}
						     }
						     arg1911_1605 = PROCEDURE_ENTRY(kont_10) (kont_10, (obj_t) (arg1916_1610), BEOA);
						  }
						  {
						     obj_t list1912_1606;
						     {
							obj_t arg1913_1607;
							{
							   obj_t arg1914_1608;
							   arg1914_1608 = MAKE_PAIR(arg1911_1605, BNIL);
							   {
							      obj_t aux_4470;
							      aux_4470 = (obj_t) (arg1909_1604);
							      arg1913_1607 = MAKE_PAIR(aux_4470, arg1914_1608);
							   }
							}
							{
							   obj_t aux_4473;
							   aux_4473 = (obj_t) (arg1908_1603);
							   list1912_1606 = MAKE_PAIR(aux_4473, arg1913_1607);
							}
						     }
						     arg1907_1602 = list1912_1606;
						  }
					       }
					       {
						  csequence_t res2508_2488;
						  {
						     csequence_t new1317_2482;
						     new1317_2482 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
						     {
							long arg1642_2483;
							arg1642_2483 = class_num_218___object(csequence_cgen_cop);
							{
							   obj_t obj_2486;
							   obj_2486 = (obj_t) (new1317_2482);
							   (((obj_t) CREF(obj_2486))->header = MAKE_HEADER(arg1642_2483, 0), BUNSPEC);
							}
						     }
						     {
							object_t aux_4480;
							aux_4480 = (object_t) (new1317_2482);
							OBJECT_WIDENING_SET(aux_4480, BFALSE);
						     }
						     ((((csequence_t) CREF(new1317_2482))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						     ((((csequence_t) CREF(new1317_2482))->cops) = ((obj_t) arg1907_1602), BUNSPEC);
						     res2508_2488 = new1317_2482;
						  }
						  arg1906_1601 = res2508_2488;
					       }
					    }
					    {
					       block_t res2509_2495;
					       {
						  cop_t body_2489;
						  body_2489 = (cop_t) (arg1906_1601);
						  {
						     block_t new1287_2490;
						     new1287_2490 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
						     {
							long arg1657_2491;
							arg1657_2491 = class_num_218___object(block_cgen_cop);
							{
							   obj_t obj_2493;
							   obj_2493 = (obj_t) (new1287_2490);
							   (((obj_t) CREF(obj_2493))->header = MAKE_HEADER(arg1657_2491, 0), BUNSPEC);
							}
						     }
						     {
							object_t aux_4490;
							aux_4490 = (object_t) (new1287_2490);
							OBJECT_WIDENING_SET(aux_4490, BFALSE);
						     }
						     ((((block_t) CREF(new1287_2490))->body) = ((cop_t) body_2489), BUNSPEC);
						     res2509_2495 = new1287_2490;
						  }
					       }
					       aux_4187 = (obj_t) (res2509_2495);
					    }
					 }
				    }
				  else
				    {
				       cop_t cop_1613;
				       {
					  setq_t arg1943_1636;
					  {
					     setq_t res2512_2526;
					     {
						variable_t variable_2497;
						node_t value_2498;
						variable_2497 = (variable_t) (aux_1586);
						{
						   obj_t aux_4496;
						   aux_4496 = CAR(old_actuals_174_1584);
						   value_2498 = (node_t) (aux_4496);
						}
						{
						   var_t arg1585_2499;
						   {
						      type_t arg1587_2500;
						      arg1587_2500 = (((variable_t) CREF(variable_2497))->type);
						      {
							 var_t res2510_2512;
							 {
							    obj_t loc_2502;
							    loc_2502 = BFALSE;
							    {
							       var_t new1129_2505;
							       new1129_2505 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
							       {
								  long arg1716_2506;
								  arg1716_2506 = class_num_218___object(var_ast_node);
								  {
								     obj_t obj_2510;
								     obj_2510 = (obj_t) (new1129_2505);
								     (((obj_t) CREF(obj_2510))->header = MAKE_HEADER(arg1716_2506, 0), BUNSPEC);
								  }
							       }
							       {
								  object_t aux_4504;
								  aux_4504 = (object_t) (new1129_2505);
								  OBJECT_WIDENING_SET(aux_4504, loc_2502);
							       }
							       ((((var_t) CREF(new1129_2505))->loc) = ((obj_t) loc_2502), BUNSPEC);
							       ((((var_t) CREF(new1129_2505))->type) = ((type_t) arg1587_2500), BUNSPEC);
							       ((((var_t) CREF(new1129_2505))->variable) = ((variable_t) variable_2497), BUNSPEC);
							       res2510_2512 = new1129_2505;
							    }
							 }
							 arg1585_2499 = res2510_2512;
						      }
						   }
						   {
						      setq_t res2511_2525;
						      {
							 obj_t loc_2513;
							 type_t type_2514;
							 loc_2513 = BFALSE;
							 type_2514 = (type_t) (__unspec__87_type_cache);
							 {
							    setq_t new1189_2517;
							    new1189_2517 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
							    {
							       long arg1696_2518;
							       arg1696_2518 = class_num_218___object(setq_ast_node);
							       {
								  obj_t obj_2523;
								  obj_2523 = (obj_t) (new1189_2517);
								  (((obj_t) CREF(obj_2523))->header = MAKE_HEADER(arg1696_2518, 0), BUNSPEC);
							       }
							    }
							    {
							       object_t aux_4515;
							       aux_4515 = (object_t) (new1189_2517);
							       OBJECT_WIDENING_SET(aux_4515, loc_2513);
							    }
							    ((((setq_t) CREF(new1189_2517))->loc) = ((obj_t) loc_2513), BUNSPEC);
							    ((((setq_t) CREF(new1189_2517))->type) = ((type_t) type_2514), BUNSPEC);
							    ((((setq_t) CREF(new1189_2517))->var) = ((var_t) arg1585_2499), BUNSPEC);
							    ((((setq_t) CREF(new1189_2517))->value) = ((node_t) value_2498), BUNSPEC);
							    res2511_2525 = new1189_2517;
							 }
						      }
						      res2512_2526 = res2511_2525;
						   }
						}
					     }
					     arg1943_1636 = res2512_2526;
					  }
					  cop_1613 = node__cop_142_cgen_cgen((node_t) (arg1943_1636), __id_kont__126_cgen_cgen);
				       }
				       {
					  bool_t test1919_1614;
					  {
					     bool_t test1936_1627;
					     test1936_1627 = is_a__118___object((obj_t) (cop_1613), csetq_cgen_cop);
					     if (test1936_1627)
					       {
						  bool_t test_4527;
						  {
						     obj_t aux_4534;
						     obj_t aux_4528;
						     aux_4534 = (obj_t) (aux_1586);
						     {
							variable_t aux_4529;
							{
							   varc_t arg1942_1635;
							   {
							      csetq_t obj_2528;
							      obj_2528 = (csetq_t) (cop_1613);
							      arg1942_1635 = (((csetq_t) CREF(obj_2528))->var);
							   }
							   aux_4529 = (((varc_t) CREF(arg1942_1635))->variable);
							}
							aux_4528 = (obj_t) (aux_4529);
						     }
						     test_4527 = (aux_4528 == aux_4534);
						  }
						  if (test_4527)
						    {
						       bool_t _ortest_1411_1629;
						       {
							  obj_t aux_4537;
							  {
							     cop_t aux_4538;
							     {
								csetq_t obj_2532;
								obj_2532 = (csetq_t) (cop_1613);
								aux_4538 = (((csetq_t) CREF(obj_2532))->value);
							     }
							     aux_4537 = (obj_t) (aux_4538);
							  }
							  _ortest_1411_1629 = is_a__118___object(aux_4537, catom_cgen_cop);
						       }
						       if (_ortest_1411_1629)
							 {
							    test1919_1614 = _ortest_1411_1629;
							 }
						       else
							 {
							    bool_t _ortest_1412_1630;
							    {
							       obj_t aux_4544;
							       {
								  cop_t aux_4545;
								  {
								     csetq_t obj_2534;
								     obj_2534 = (csetq_t) (cop_1613);
								     aux_4545 = (((csetq_t) CREF(obj_2534))->value);
								  }
								  aux_4544 = (obj_t) (aux_4545);
							       }
							       _ortest_1412_1630 = is_a__118___object(aux_4544, varc_cgen_cop);
							    }
							    if (_ortest_1412_1630)
							      {
								 test1919_1614 = _ortest_1412_1630;
							      }
							    else
							      {
								 obj_t aux_4551;
								 {
								    cop_t aux_4552;
								    {
								       csetq_t obj_2536;
								       obj_2536 = (csetq_t) (cop_1613);
								       aux_4552 = (((csetq_t) CREF(obj_2536))->value);
								    }
								    aux_4551 = (obj_t) (aux_4552);
								 }
								 test1919_1614 = is_a__118___object(aux_4551, cpragma_cgen_cop);
							      }
							 }
						    }
						  else
						    {
						       test1919_1614 = ((bool_t) 0);
						    }
					       }
					     else
					       {
						  test1919_1614 = ((bool_t) 0);
					       }
					  }
					  if (test1919_1614)
					    {
					       obj_t arg1921_1615;
					       obj_t arg1922_1616;
					       arg1921_1615 = CDR(old_actuals_174_1584);
					       {
						  obj_t aux_4559;
						  {
						     cop_t aux_4560;
						     {
							csetq_t obj_2539;
							obj_2539 = (csetq_t) (cop_1613);
							aux_4560 = (((csetq_t) CREF(obj_2539))->value);
						     }
						     aux_4559 = (obj_t) (aux_4560);
						  }
						  arg1922_1616 = MAKE_PAIR(aux_4559, new_actuals_73_1585);
					       }
					       {
						  obj_t new_actuals_73_4566;
						  obj_t old_actuals_174_4565;
						  old_actuals_174_4565 = arg1921_1615;
						  new_actuals_73_4566 = arg1922_1616;
						  new_actuals_73_1585 = new_actuals_73_4566;
						  old_actuals_174_1584 = old_actuals_174_4565;
						  goto loop_1589;
					       }
					    }
					  else
					    {
					       {
						  type_t arg1925_1618;
						  {
						     node_t aux_4567;
						     {
							obj_t aux_4568;
							aux_4568 = CAR(old_actuals_174_1584);
							aux_4567 = (node_t) (aux_4568);
						     }
						     arg1925_1618 = typeof_coerce_typeof(aux_4567);
						  }
						  {
						     obj_t res2513_2545;
						     {
							obj_t x_3825;
							x_3825 = ((((local_t) CREF(aux_1586))->type) = ((type_t) arg1925_1618), BUNSPEC);
							res2513_2545 = BUNSPEC;
						     }
						     res2513_2545;
						  }
					       }
					       {
						  obj_t arg1927_1620;
						  obj_t arg1928_1621;
						  local_t arg1929_1622;
						  obj_t arg1931_1623;
						  obj_t arg1932_1624;
						  arg1927_1620 = CDR(old_actuals_174_1584);
						  {
						     varc_t arg1934_1625;
						     {
							varc_t res2514_2553;
							{
							   variable_t variable_2547;
							   variable_2547 = (variable_t) (aux_1586);
							   {
							      varc_t new1305_2548;
							      new1305_2548 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
							      {
								 long arg1648_2549;
								 arg1648_2549 = class_num_218___object(varc_cgen_cop);
								 {
								    obj_t obj_2551;
								    obj_2551 = (obj_t) (new1305_2548);
								    (((obj_t) CREF(obj_2551))->header = MAKE_HEADER(arg1648_2549, 0), BUNSPEC);
								 }
							      }
							      {
								 object_t aux_4579;
								 aux_4579 = (object_t) (new1305_2548);
								 OBJECT_WIDENING_SET(aux_4579, BFALSE);
							      }
							      ((((varc_t) CREF(new1305_2548))->variable) = ((variable_t) variable_2547), BUNSPEC);
							      res2514_2553 = new1305_2548;
							   }
							}
							arg1934_1625 = res2514_2553;
						     }
						     {
							obj_t aux_4583;
							aux_4583 = (obj_t) (arg1934_1625);
							arg1928_1621 = MAKE_PAIR(aux_4583, new_actuals_73_1585);
						     }
						  }
						  {
						     obj_t arg1935_1626;
						     arg1935_1626 = CNST_TABLE_REF(((long) 2));
						     {
							local_t res2515_2559;
							{
							   type_t type_2557;
							   type_2557 = (type_t) (__obj__252_type_cache);
							   {
							      local_t local_2558;
							      local_2558 = make_local_svar_140_ast_local(arg1935_1626, type_2557);
							      set_variable_name__102_cgen_prototype((obj_t) (local_2558));
							      res2515_2559 = local_2558;
							   }
							}
							arg1929_1622 = res2515_2559;
						     }
						  }
						  {
						     obj_t aux_4591;
						     aux_4591 = (obj_t) (aux_1586);
						     arg1931_1623 = MAKE_PAIR(aux_4591, auxs_1587);
						  }
						  {
						     obj_t aux_4594;
						     aux_4594 = (obj_t) (cop_1613);
						     arg1932_1624 = MAKE_PAIR(aux_4594, exps_1588);
						  }
						  {
						     obj_t exps_4601;
						     obj_t auxs_4600;
						     local_t aux_4599;
						     obj_t new_actuals_73_4598;
						     obj_t old_actuals_174_4597;
						     old_actuals_174_4597 = arg1927_1620;
						     new_actuals_73_4598 = arg1928_1621;
						     aux_4599 = arg1929_1622;
						     auxs_4600 = arg1931_1623;
						     exps_4601 = arg1932_1624;
						     exps_1588 = exps_4601;
						     auxs_1587 = auxs_4600;
						     aux_1586 = aux_4599;
						     new_actuals_73_1585 = new_actuals_73_4598;
						     old_actuals_174_1584 = old_actuals_174_4597;
						     goto loop_1589;
						  }
					       }
					    }
				       }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 6):
			 {
			    cast_t node_1638;
			    node_1638 = (cast_t) (node_9);
			    {
			       bool_t test1945_1640;
			       {
				  obj_t aux_4603;
				  aux_4603 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1945_1640 = CBOOL(aux_4603);
			       }
			       if (test1945_1640)
				 {
				    obj_t arg1948_1642;
				    arg1948_1642 = shape_tools_shape((obj_t) (node_1638));
				    {
				       obj_t list1950_1644;
				       {
					  obj_t arg1951_1645;
					  {
					     obj_t arg1952_1646;
					     {
						obj_t arg1953_1647;
						{
						   obj_t arg1954_1648;
						   {
						      obj_t arg1956_1649;
						      {
							 obj_t aux_4611;
							 aux_4611 = BCHAR(((unsigned char) '\n'));
							 arg1956_1649 = MAKE_PAIR(aux_4611, BNIL);
						      }
						      arg1954_1648 = MAKE_PAIR(kont_10, arg1956_1649);
						   }
						   arg1953_1647 = MAKE_PAIR(string2635_cgen_cgen, arg1954_1648);
						}
						{
						   obj_t aux_4616;
						   aux_4616 = BCHAR(((unsigned char) '\n'));
						   arg1952_1646 = MAKE_PAIR(aux_4616, arg1953_1647);
						}
					     }
					     arg1951_1645 = MAKE_PAIR(arg1948_1642, arg1952_1646);
					  }
					  list1950_1644 = MAKE_PAIR(string2645_cgen_cgen, arg1951_1645);
				       }
				       print_trace_107_tools_trace(list1950_1644);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       ccast_t arg1963_1654;
			       {
				  type_t arg1964_1655;
				  cop_t arg1965_1656;
				  arg1964_1655 = (((cast_t) CREF(node_1638))->type);
				  arg1965_1656 = node__cop_142_cgen_cgen((((cast_t) CREF(node_1638))->arg), __id_kont__126_cgen_cgen);
				  {
				     ccast_t res2516_2574;
				     {
					ccast_t new1313_2568;
					new1313_2568 = ((ccast_t) BREF(GC_MALLOC(sizeof(struct ccast))));
					{
					   long arg1644_2569;
					   arg1644_2569 = class_num_218___object(ccast_cgen_cop);
					   {
					      obj_t obj_2572;
					      obj_2572 = (obj_t) (new1313_2568);
					      (((obj_t) CREF(obj_2572))->header = MAKE_HEADER(arg1644_2569, 0), BUNSPEC);
					   }
					}
					{
					   object_t aux_4629;
					   aux_4629 = (object_t) (new1313_2568);
					   OBJECT_WIDENING_SET(aux_4629, BFALSE);
					}
					((((ccast_t) CREF(new1313_2568))->type) = ((type_t) arg1964_1655), BUNSPEC);
					((((ccast_t) CREF(new1313_2568))->arg) = ((cop_t) arg1965_1656), BUNSPEC);
					res2516_2574 = new1313_2568;
				     }
				     arg1963_1654 = res2516_2574;
				  }
			       }
			       aux_4187 = PROCEDURE_ENTRY(kont_10) (kont_10, (obj_t) (arg1963_1654), BEOA);
			    }
			 }
			 break;
		      case ((long) 7):
			 {
			    setq_t node_1658;
			    node_1658 = (setq_t) (node_9);
			    {
			       bool_t test1967_1660;
			       {
				  obj_t aux_4638;
				  aux_4638 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1967_1660 = CBOOL(aux_4638);
			       }
			       if (test1967_1660)
				 {
				    obj_t arg1969_1662;
				    arg1969_1662 = shape_tools_shape((obj_t) (node_1658));
				    {
				       obj_t list1971_1664;
				       {
					  obj_t arg1972_1665;
					  {
					     obj_t arg1973_1666;
					     {
						obj_t arg1974_1667;
						{
						   obj_t arg1975_1668;
						   {
						      obj_t arg1976_1669;
						      {
							 obj_t aux_4646;
							 aux_4646 = BCHAR(((unsigned char) '\n'));
							 arg1976_1669 = MAKE_PAIR(aux_4646, BNIL);
						      }
						      arg1975_1668 = MAKE_PAIR(kont_10, arg1976_1669);
						   }
						   arg1974_1667 = MAKE_PAIR(string2635_cgen_cgen, arg1975_1668);
						}
						{
						   obj_t aux_4651;
						   aux_4651 = BCHAR(((unsigned char) '\n'));
						   arg1973_1666 = MAKE_PAIR(aux_4651, arg1974_1667);
						}
					     }
					     arg1972_1665 = MAKE_PAIR(arg1969_1662, arg1973_1666);
					  }
					  list1971_1664 = MAKE_PAIR(string2646_cgen_cgen, arg1972_1665);
				       }
				       print_trace_107_tools_trace(list1971_1664);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       variable_t var_1674;
			       {
				  var_t arg1989_1684;
				  arg1989_1684 = (((setq_t) CREF(node_1658))->var);
				  var_1674 = (((var_t) CREF(arg1989_1684))->variable);
			       }
			       {
				  bool_t test1980_1675;
				  {
				     bool_t test1985_1680;
				     {
					obj_t aux_4659;
					{
					   node_t aux_4660;
					   aux_4660 = (((setq_t) CREF(node_1658))->value);
					   aux_4659 = (obj_t) (aux_4660);
					}
					test1985_1680 = is_a__118___object(aux_4659, var_ast_node);
				     }
				     if (test1985_1680)
				       {
					  obj_t aux_4667;
					  obj_t aux_4665;
					  {
					     variable_t aux_4668;
					     {
						var_t obj_2580;
						{
						   node_t aux_4669;
						   aux_4669 = (((setq_t) CREF(node_1658))->value);
						   obj_2580 = (var_t) (aux_4669);
						}
						aux_4668 = (((var_t) CREF(obj_2580))->variable);
					     }
					     aux_4667 = (obj_t) (aux_4668);
					  }
					  aux_4665 = (obj_t) (var_1674);
					  test1980_1675 = (aux_4665 == aux_4667);
				       }
				     else
				       {
					  test1980_1675 = ((bool_t) 0);
				       }
				  }
				  if (test1980_1675)
				    {
				       cvoid_t arg1981_1676;
				       {
					  catom_t arg1982_1677;
					  {
					     catom_t res2517_2589;
					     {
						catom_t new1301_2584;
						new1301_2584 = ((catom_t) BREF(GC_MALLOC(sizeof(struct catom))));
						{
						   long arg1651_2585;
						   arg1651_2585 = class_num_218___object(catom_cgen_cop);
						   {
						      obj_t obj_2587;
						      obj_2587 = (obj_t) (new1301_2584);
						      (((obj_t) CREF(obj_2587))->header = MAKE_HEADER(arg1651_2585, 0), BUNSPEC);
						   }
						}
						{
						   object_t aux_4680;
						   aux_4680 = (object_t) (new1301_2584);
						   OBJECT_WIDENING_SET(aux_4680, BFALSE);
						}
						((((catom_t) CREF(new1301_2584))->value) = ((obj_t) BUNSPEC), BUNSPEC);
						res2517_2589 = new1301_2584;
					     }
					     arg1982_1677 = res2517_2589;
					  }
					  {
					     cvoid_t res2518_2597;
					     {
						cop_t value_2591;
						value_2591 = (cop_t) (arg1982_1677);
						{
						   cvoid_t new1297_2592;
						   new1297_2592 = ((cvoid_t) BREF(GC_MALLOC(sizeof(struct cvoid))));
						   {
						      long arg1653_2593;
						      arg1653_2593 = class_num_218___object(cvoid_cgen_cop);
						      {
							 obj_t obj_2595;
							 obj_2595 = (obj_t) (new1297_2592);
							 (((obj_t) CREF(obj_2595))->header = MAKE_HEADER(arg1653_2593, 0), BUNSPEC);
						      }
						   }
						   {
						      object_t aux_4689;
						      aux_4689 = (object_t) (new1297_2592);
						      OBJECT_WIDENING_SET(aux_4689, BFALSE);
						   }
						   ((((cvoid_t) CREF(new1297_2592))->value) = ((cop_t) value_2591), BUNSPEC);
						   res2518_2597 = new1297_2592;
						}
					     }
					     arg1981_1676 = res2518_2597;
					  }
				       }
				       aux_4187 = PROCEDURE_ENTRY(kont_10) (kont_10, (obj_t) (arg1981_1676), BEOA);
				    }
				  else
				    {
				       node_t arg1983_1678;
				       obj_t arg1984_1679;
				       arg1983_1678 = (((setq_t) CREF(node_1658))->value);
				       arg1984_1679 = make_setq_kont_65_cgen_cgen(var_1674, kont_10);
				       {
					  cop_t aux_4698;
					  aux_4698 = node__cop_142_cgen_cgen(arg1983_1678, arg1984_1679);
					  aux_4187 = (obj_t) (aux_4698);
				       }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 8):
			 {
			    conditional_t node_1685;
			    node_1685 = (conditional_t) (node_9);
			    {
			       bool_t test1990_1687;
			       {
				  obj_t aux_4702;
				  aux_4702 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test1990_1687 = CBOOL(aux_4702);
			       }
			       if (test1990_1687)
				 {
				    obj_t arg1993_1689;
				    arg1993_1689 = shape_tools_shape((obj_t) (node_1685));
				    {
				       obj_t list1996_1691;
				       {
					  obj_t arg1997_1692;
					  {
					     obj_t arg1998_1693;
					     {
						obj_t arg1999_1694;
						{
						   obj_t arg2000_1695;
						   {
						      obj_t arg2001_1696;
						      {
							 obj_t aux_4710;
							 aux_4710 = BCHAR(((unsigned char) '\n'));
							 arg2001_1696 = MAKE_PAIR(aux_4710, BNIL);
						      }
						      arg2000_1695 = MAKE_PAIR(kont_10, arg2001_1696);
						   }
						   arg1999_1694 = MAKE_PAIR(string2635_cgen_cgen, arg2000_1695);
						}
						{
						   obj_t aux_4715;
						   aux_4715 = BCHAR(((unsigned char) '\n'));
						   arg1998_1693 = MAKE_PAIR(aux_4715, arg1999_1694);
						}
					     }
					     arg1997_1692 = MAKE_PAIR(arg1993_1689, arg1998_1693);
					  }
					  list1996_1691 = MAKE_PAIR(string2647_cgen_cgen, arg1997_1692);
				       }
				       print_trace_107_tools_trace(list1996_1691);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       local_t aux_1701;
			       {
				  obj_t arg2041_1734;
				  arg2041_1734 = CNST_TABLE_REF(((long) 3));
				  {
				     local_t res2519_2602;
				     {
					type_t type_2600;
					type_2600 = (type_t) (__bool__149_type_cache);
					{
					   local_t local_2601;
					   local_2601 = make_local_svar_140_ast_local(arg2041_1734, type_2600);
					   set_variable_name__102_cgen_prototype((obj_t) (local_2601));
					   res2519_2602 = local_2601;
					}
				     }
				     aux_1701 = res2519_2602;
				  }
			       }
			       {
				  cop_t ctest_1702;
				  {
				     setq_t arg2039_1732;
				     {
					node_t arg2040_1733;
					arg2040_1733 = (((conditional_t) CREF(node_1685))->test);
					{
					   setq_t res2522_2633;
					   {
					      variable_t variable_2604;
					      variable_2604 = (variable_t) (aux_1701);
					      {
						 var_t arg1585_2606;
						 {
						    type_t arg1587_2607;
						    arg1587_2607 = (((variable_t) CREF(variable_2604))->type);
						    {
						       var_t res2520_2619;
						       {
							  obj_t loc_2609;
							  loc_2609 = BFALSE;
							  {
							     var_t new1129_2612;
							     new1129_2612 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
							     {
								long arg1716_2613;
								arg1716_2613 = class_num_218___object(var_ast_node);
								{
								   obj_t obj_2617;
								   obj_2617 = (obj_t) (new1129_2612);
								   (((obj_t) CREF(obj_2617))->header = MAKE_HEADER(arg1716_2613, 0), BUNSPEC);
								}
							     }
							     {
								object_t aux_4733;
								aux_4733 = (object_t) (new1129_2612);
								OBJECT_WIDENING_SET(aux_4733, loc_2609);
							     }
							     ((((var_t) CREF(new1129_2612))->loc) = ((obj_t) loc_2609), BUNSPEC);
							     ((((var_t) CREF(new1129_2612))->type) = ((type_t) arg1587_2607), BUNSPEC);
							     ((((var_t) CREF(new1129_2612))->variable) = ((variable_t) variable_2604), BUNSPEC);
							     res2520_2619 = new1129_2612;
							  }
						       }
						       arg1585_2606 = res2520_2619;
						    }
						 }
						 {
						    setq_t res2521_2632;
						    {
						       obj_t loc_2620;
						       type_t type_2621;
						       loc_2620 = BFALSE;
						       type_2621 = (type_t) (__unspec__87_type_cache);
						       {
							  setq_t new1189_2624;
							  new1189_2624 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
							  {
							     long arg1696_2625;
							     arg1696_2625 = class_num_218___object(setq_ast_node);
							     {
								obj_t obj_2630;
								obj_2630 = (obj_t) (new1189_2624);
								(((obj_t) CREF(obj_2630))->header = MAKE_HEADER(arg1696_2625, 0), BUNSPEC);
							     }
							  }
							  {
							     object_t aux_4744;
							     aux_4744 = (object_t) (new1189_2624);
							     OBJECT_WIDENING_SET(aux_4744, loc_2620);
							  }
							  ((((setq_t) CREF(new1189_2624))->loc) = ((obj_t) loc_2620), BUNSPEC);
							  ((((setq_t) CREF(new1189_2624))->type) = ((type_t) type_2621), BUNSPEC);
							  ((((setq_t) CREF(new1189_2624))->var) = ((var_t) arg1585_2606), BUNSPEC);
							  ((((setq_t) CREF(new1189_2624))->value) = ((node_t) arg2040_1733), BUNSPEC);
							  res2521_2632 = new1189_2624;
						       }
						    }
						    res2522_2633 = res2521_2632;
						 }
					      }
					   }
					   arg2039_1732 = res2522_2633;
					}
				     }
				     ctest_1702 = node__cop_142_cgen_cgen((node_t) (arg2039_1732), __id_kont__126_cgen_cgen);
				  }
				  {
				     {
					bool_t test2005_1703;
					{
					   bool_t test2035_1729;
					   test2035_1729 = is_a__118___object((obj_t) (ctest_1702), csetq_cgen_cop);
					   if (test2035_1729)
					     {
						obj_t aux_4762;
						obj_t aux_4756;
						aux_4762 = (obj_t) (aux_1701);
						{
						   variable_t aux_4757;
						   {
						      varc_t arg2037_1731;
						      {
							 csetq_t obj_2635;
							 obj_2635 = (csetq_t) (ctest_1702);
							 arg2037_1731 = (((csetq_t) CREF(obj_2635))->var);
						      }
						      aux_4757 = (((varc_t) CREF(arg2037_1731))->variable);
						   }
						   aux_4756 = (obj_t) (aux_4757);
						}
						test2005_1703 = (aux_4756 == aux_4762);
					     }
					   else
					     {
						test2005_1703 = ((bool_t) 0);
					     }
					}
					if (test2005_1703)
					  {
					     cop_t arg2006_1704;
					     obj_t arg2007_1705;
					     obj_t arg2008_1706;
					     {
						csetq_t obj_2639;
						obj_2639 = (csetq_t) (ctest_1702);
						arg2006_1704 = (((csetq_t) CREF(obj_2639))->value);
					     }
					     {
						cop_t arg2009_1707;
						arg2009_1707 = node__cop_142_cgen_cgen((((conditional_t) CREF(node_1685))->true), kont_10);
						arg2007_1705 = PROCEDURE_ENTRY(__block_kont__38_cgen_cgen) (__block_kont__38_cgen_cgen, (obj_t) (arg2009_1707), BEOA);
					     }
					     {
						cop_t arg2013_1709;
						arg2013_1709 = node__cop_142_cgen_cgen((((conditional_t) CREF(node_1685))->false), kont_10);
						arg2008_1706 = PROCEDURE_ENTRY(__block_kont__38_cgen_cgen) (__block_kont__38_cgen_cgen, (obj_t) (arg2013_1709), BEOA);
					     }
					     {
						cif_t res2523_2652;
						{
						   cop_t true_2643;
						   cop_t false_2644;
						   true_2643 = (cop_t) (arg2007_1705);
						   false_2644 = (cop_t) (arg2008_1706);
						   {
						      cif_t new1334_2645;
						      new1334_2645 = ((cif_t) BREF(GC_MALLOC(sizeof(struct cif))));
						      {
							 long arg1627_2646;
							 arg1627_2646 = class_num_218___object(cif_cgen_cop);
							 {
							    obj_t obj_2650;
							    obj_2650 = (obj_t) (new1334_2645);
							    (((obj_t) CREF(obj_2650))->header = MAKE_HEADER(arg1627_2646, 0), BUNSPEC);
							 }
						      }
						      {
							 object_t aux_4784;
							 aux_4784 = (object_t) (new1334_2645);
							 OBJECT_WIDENING_SET(aux_4784, BFALSE);
						      }
						      ((((cif_t) CREF(new1334_2645))->test) = ((cop_t) arg2006_1704), BUNSPEC);
						      ((((cif_t) CREF(new1334_2645))->true) = ((cop_t) true_2643), BUNSPEC);
						      ((((cif_t) CREF(new1334_2645))->false) = ((cop_t) false_2644), BUNSPEC);
						      res2523_2652 = new1334_2645;
						   }
						}
						aux_4187 = (obj_t) (res2523_2652);
					     }
					  }
					else
					  {
					     csequence_t arg2015_1711;
					     {
						obj_t arg2016_1712;
						{
						   local_var_164_t arg2017_1713;
						   cif_t arg2018_1714;
						   {
						      obj_t arg2025_1719;
						      {
							 obj_t list2026_1720;
							 {
							    obj_t aux_4791;
							    aux_4791 = (obj_t) (aux_1701);
							    list2026_1720 = MAKE_PAIR(aux_4791, BNIL);
							 }
							 arg2025_1719 = list2026_1720;
						      }
						      {
							 local_var_164_t res2524_2660;
							 {
							    local_var_164_t new1342_2655;
							    new1342_2655 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							    {
							       long arg1621_2656;
							       arg1621_2656 = class_num_218___object(local_var_164_cgen_cop);
							       {
								  obj_t obj_2658;
								  obj_2658 = (obj_t) (new1342_2655);
								  (((obj_t) CREF(obj_2658))->header = MAKE_HEADER(arg1621_2656, 0), BUNSPEC);
							       }
							    }
							    {
							       object_t aux_4798;
							       aux_4798 = (object_t) (new1342_2655);
							       OBJECT_WIDENING_SET(aux_4798, BFALSE);
							    }
							    ((((local_var_164_t) CREF(new1342_2655))->vars) = ((obj_t) arg2025_1719), BUNSPEC);
							    res2524_2660 = new1342_2655;
							 }
							 arg2017_1713 = res2524_2660;
						      }
						   }
						   {
						      varc_t arg2028_1722;
						      obj_t arg2029_1723;
						      obj_t arg2030_1724;
						      {
							 varc_t res2525_2667;
							 {
							    variable_t variable_2661;
							    variable_2661 = (variable_t) (aux_1701);
							    {
							       varc_t new1305_2662;
							       new1305_2662 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
							       {
								  long arg1648_2663;
								  arg1648_2663 = class_num_218___object(varc_cgen_cop);
								  {
								     obj_t obj_2665;
								     obj_2665 = (obj_t) (new1305_2662);
								     (((obj_t) CREF(obj_2665))->header = MAKE_HEADER(arg1648_2663, 0), BUNSPEC);
								  }
							       }
							       {
								  object_t aux_4807;
								  aux_4807 = (object_t) (new1305_2662);
								  OBJECT_WIDENING_SET(aux_4807, BFALSE);
							       }
							       ((((varc_t) CREF(new1305_2662))->variable) = ((variable_t) variable_2661), BUNSPEC);
							       res2525_2667 = new1305_2662;
							    }
							 }
							 arg2028_1722 = res2525_2667;
						      }
						      {
							 cop_t arg2031_1725;
							 arg2031_1725 = node__cop_142_cgen_cgen((((conditional_t) CREF(node_1685))->true), kont_10);
							 arg2029_1723 = PROCEDURE_ENTRY(__block_kont__38_cgen_cgen) (__block_kont__38_cgen_cgen, (obj_t) (arg2031_1725), BEOA);
						      }
						      {
							 cop_t arg2033_1727;
							 arg2033_1727 = node__cop_142_cgen_cgen((((conditional_t) CREF(node_1685))->false), kont_10);
							 arg2030_1724 = PROCEDURE_ENTRY(__block_kont__38_cgen_cgen) (__block_kont__38_cgen_cgen, (obj_t) (arg2033_1727), BEOA);
						      }
						      {
							 cif_t res2526_2680;
							 {
							    cop_t test_2670;
							    cop_t true_2671;
							    cop_t false_2672;
							    test_2670 = (cop_t) (arg2028_1722);
							    true_2671 = (cop_t) (arg2029_1723);
							    false_2672 = (cop_t) (arg2030_1724);
							    {
							       cif_t new1334_2673;
							       new1334_2673 = ((cif_t) BREF(GC_MALLOC(sizeof(struct cif))));
							       {
								  long arg1627_2674;
								  arg1627_2674 = class_num_218___object(cif_cgen_cop);
								  {
								     obj_t obj_2678;
								     obj_2678 = (obj_t) (new1334_2673);
								     (((obj_t) CREF(obj_2678))->header = MAKE_HEADER(arg1627_2674, 0), BUNSPEC);
								  }
							       }
							       {
								  object_t aux_4828;
								  aux_4828 = (object_t) (new1334_2673);
								  OBJECT_WIDENING_SET(aux_4828, BFALSE);
							       }
							       ((((cif_t) CREF(new1334_2673))->test) = ((cop_t) test_2670), BUNSPEC);
							       ((((cif_t) CREF(new1334_2673))->true) = ((cop_t) true_2671), BUNSPEC);
							       ((((cif_t) CREF(new1334_2673))->false) = ((cop_t) false_2672), BUNSPEC);
							       res2526_2680 = new1334_2673;
							    }
							 }
							 arg2018_1714 = res2526_2680;
						      }
						   }
						   {
						      obj_t list2019_1715;
						      {
							 obj_t arg2020_1716;
							 {
							    obj_t arg2021_1717;
							    {
							       obj_t aux_4834;
							       aux_4834 = (obj_t) (arg2018_1714);
							       arg2021_1717 = MAKE_PAIR(aux_4834, BNIL);
							    }
							    {
							       obj_t aux_4837;
							       aux_4837 = (obj_t) (ctest_1702);
							       arg2020_1716 = MAKE_PAIR(aux_4837, arg2021_1717);
							    }
							 }
							 {
							    obj_t aux_4840;
							    aux_4840 = (obj_t) (arg2017_1713);
							    list2019_1715 = MAKE_PAIR(aux_4840, arg2020_1716);
							 }
						      }
						      arg2016_1712 = list2019_1715;
						   }
						}
						{
						   csequence_t res2527_2690;
						   {
						      csequence_t new1317_2684;
						      new1317_2684 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
						      {
							 long arg1642_2685;
							 arg1642_2685 = class_num_218___object(csequence_cgen_cop);
							 {
							    obj_t obj_2688;
							    obj_2688 = (obj_t) (new1317_2684);
							    (((obj_t) CREF(obj_2688))->header = MAKE_HEADER(arg1642_2685, 0), BUNSPEC);
							 }
						      }
						      {
							 object_t aux_4847;
							 aux_4847 = (object_t) (new1317_2684);
							 OBJECT_WIDENING_SET(aux_4847, BFALSE);
						      }
						      ((((csequence_t) CREF(new1317_2684))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						      ((((csequence_t) CREF(new1317_2684))->cops) = ((obj_t) arg2016_1712), BUNSPEC);
						      res2527_2690 = new1317_2684;
						   }
						   arg2015_1711 = res2527_2690;
						}
					     }
					     {
						block_t res2528_2697;
						{
						   cop_t body_2691;
						   body_2691 = (cop_t) (arg2015_1711);
						   {
						      block_t new1287_2692;
						      new1287_2692 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
						      {
							 long arg1657_2693;
							 arg1657_2693 = class_num_218___object(block_cgen_cop);
							 {
							    obj_t obj_2695;
							    obj_2695 = (obj_t) (new1287_2692);
							    (((obj_t) CREF(obj_2695))->header = MAKE_HEADER(arg1657_2693, 0), BUNSPEC);
							 }
						      }
						      {
							 object_t aux_4857;
							 aux_4857 = (object_t) (new1287_2692);
							 OBJECT_WIDENING_SET(aux_4857, BFALSE);
						      }
						      ((((block_t) CREF(new1287_2692))->body) = ((cop_t) body_2691), BUNSPEC);
						      res2528_2697 = new1287_2692;
						   }
						}
						aux_4187 = (obj_t) (res2528_2697);
					     }
					  }
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 9):
			 {
			    fail_t node_1735;
			    node_1735 = (fail_t) (node_9);
			    {
			       bool_t test2042_1737;
			       {
				  obj_t aux_4863;
				  aux_4863 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2042_1737 = CBOOL(aux_4863);
			       }
			       if (test2042_1737)
				 {
				    obj_t arg2045_1739;
				    arg2045_1739 = shape_tools_shape((obj_t) (node_1735));
				    {
				       obj_t list2047_1741;
				       {
					  obj_t arg2048_1742;
					  {
					     obj_t arg2050_1743;
					     {
						obj_t arg2051_1744;
						{
						   obj_t arg2052_1745;
						   {
						      obj_t arg2053_1746;
						      {
							 obj_t aux_4871;
							 aux_4871 = BCHAR(((unsigned char) '\n'));
							 arg2053_1746 = MAKE_PAIR(aux_4871, BNIL);
						      }
						      arg2052_1745 = MAKE_PAIR(kont_10, arg2053_1746);
						   }
						   arg2051_1744 = MAKE_PAIR(string2635_cgen_cgen, arg2052_1745);
						}
						{
						   obj_t aux_4876;
						   aux_4876 = BCHAR(((unsigned char) '\n'));
						   arg2050_1743 = MAKE_PAIR(aux_4876, arg2051_1744);
						}
					     }
					     arg2048_1742 = MAKE_PAIR(arg2045_1739, arg2050_1743);
					  }
					  list2047_1741 = MAKE_PAIR(string2648_cgen_cgen, arg2048_1742);
				       }
				       print_trace_107_tools_trace(list2047_1741);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       obj_t old_actuals_174_1751;
			       obj_t new_actuals_73_1752;
			       local_t aux_1753;
			       obj_t auxs_1754;
			       obj_t exps_1755;
			       {
				  obj_t arg2057_1757;
				  local_t arg2059_1759;
				  {
				     node_t arg2062_1762;
				     node_t arg2065_1763;
				     arg2062_1762 = (((fail_t) CREF(node_1735))->proc);
				     arg2065_1763 = (((fail_t) CREF(node_1735))->msg);
				     {
					obj_t list2067_1765;
					{
					   obj_t arg2068_1766;
					   {
					      obj_t arg2069_1767;
					      {
						 obj_t aux_4884;
						 {
						    node_t aux_4885;
						    aux_4885 = (((fail_t) CREF(node_1735))->obj);
						    aux_4884 = (obj_t) (aux_4885);
						 }
						 arg2069_1767 = MAKE_PAIR(aux_4884, BNIL);
					      }
					      {
						 obj_t aux_4889;
						 aux_4889 = (obj_t) (arg2065_1763);
						 arg2068_1766 = MAKE_PAIR(aux_4889, arg2069_1767);
					      }
					   }
					   {
					      obj_t aux_4892;
					      aux_4892 = (obj_t) (arg2062_1762);
					      list2067_1765 = MAKE_PAIR(aux_4892, arg2068_1766);
					   }
					}
					arg2057_1757 = list2067_1765;
				     }
				  }
				  {
				     obj_t arg2071_1769;
				     arg2071_1769 = CNST_TABLE_REF(((long) 2));
				     {
					local_t res2529_2705;
					{
					   type_t type_2703;
					   type_2703 = (type_t) (__obj__252_type_cache);
					   {
					      local_t local_2704;
					      local_2704 = make_local_svar_140_ast_local(arg2071_1769, type_2703);
					      set_variable_name__102_cgen_prototype((obj_t) (local_2704));
					      res2529_2705 = local_2704;
					   }
					}
					arg2059_1759 = res2529_2705;
				     }
				  }
				  old_actuals_174_1751 = arg2057_1757;
				  new_actuals_73_1752 = BNIL;
				  aux_1753 = arg2059_1759;
				  auxs_1754 = BNIL;
				  exps_1755 = BNIL;
				loop_1756:
				  if (NULLP(old_actuals_174_1751))
				    {
				       if (NULLP(auxs_1754))
					 {
					    cfail_t arg2074_1772;
					    {
					       cfail_t res2530_2729;
					       {
						  cop_t proc_2719;
						  cop_t msg_2720;
						  cop_t obj_2721;
						  {
						     obj_t aux_4904;
						     {
							obj_t aux_4905;
							{
							   obj_t aux_4906;
							   aux_4906 = CDR(new_actuals_73_1752);
							   aux_4905 = CDR(aux_4906);
							}
							aux_4904 = CAR(aux_4905);
						     }
						     proc_2719 = (cop_t) (aux_4904);
						  }
						  {
						     obj_t aux_4911;
						     {
							obj_t aux_4912;
							aux_4912 = CDR(new_actuals_73_1752);
							aux_4911 = CAR(aux_4912);
						     }
						     msg_2720 = (cop_t) (aux_4911);
						  }
						  {
						     obj_t aux_4916;
						     aux_4916 = CAR(new_actuals_73_1752);
						     obj_2721 = (cop_t) (aux_4916);
						  }
						  {
						     cfail_t new1358_2722;
						     new1358_2722 = ((cfail_t) BREF(GC_MALLOC(sizeof(struct cfail))));
						     {
							long arg1609_2723;
							arg1609_2723 = class_num_218___object(cfail_cgen_cop);
							{
							   obj_t obj_2727;
							   obj_2727 = (obj_t) (new1358_2722);
							   (((obj_t) CREF(obj_2727))->header = MAKE_HEADER(arg1609_2723, 0), BUNSPEC);
							}
						     }
						     {
							object_t aux_4923;
							aux_4923 = (object_t) (new1358_2722);
							OBJECT_WIDENING_SET(aux_4923, BFALSE);
						     }
						     ((((cfail_t) CREF(new1358_2722))->proc) = ((cop_t) proc_2719), BUNSPEC);
						     ((((cfail_t) CREF(new1358_2722))->msg) = ((cop_t) msg_2720), BUNSPEC);
						     ((((cfail_t) CREF(new1358_2722))->obj) = ((cop_t) obj_2721), BUNSPEC);
						     res2530_2729 = new1358_2722;
						  }
					       }
					       arg2074_1772 = res2530_2729;
					    }
					    aux_4187 = (obj_t) (arg2074_1772);
					 }
				       else
					 {
					    csequence_t arg2079_1776;
					    {
					       obj_t arg2080_1777;
					       {
						  local_var_164_t arg2081_1778;
						  csequence_t arg2083_1779;
						  cfail_t arg2084_1780;
						  {
						     local_var_164_t res2531_2737;
						     {
							local_var_164_t new1342_2732;
							new1342_2732 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							{
							   long arg1621_2733;
							   arg1621_2733 = class_num_218___object(local_var_164_cgen_cop);
							   {
							      obj_t obj_2735;
							      obj_2735 = (obj_t) (new1342_2732);
							      (((obj_t) CREF(obj_2735))->header = MAKE_HEADER(arg1621_2733, 0), BUNSPEC);
							   }
							}
							{
							   object_t aux_4934;
							   aux_4934 = (object_t) (new1342_2732);
							   OBJECT_WIDENING_SET(aux_4934, BFALSE);
							}
							((((local_var_164_t) CREF(new1342_2732))->vars) = ((obj_t) auxs_1754), BUNSPEC);
							res2531_2737 = new1342_2732;
						     }
						     arg2081_1778 = res2531_2737;
						  }
						  {
						     csequence_t res2532_2746;
						     {
							csequence_t new1317_2740;
							new1317_2740 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
							{
							   long arg1642_2741;
							   arg1642_2741 = class_num_218___object(csequence_cgen_cop);
							   {
							      obj_t obj_2744;
							      obj_2744 = (obj_t) (new1317_2740);
							      (((obj_t) CREF(obj_2744))->header = MAKE_HEADER(arg1642_2741, 0), BUNSPEC);
							   }
							}
							{
							   object_t aux_4942;
							   aux_4942 = (object_t) (new1317_2740);
							   OBJECT_WIDENING_SET(aux_4942, BFALSE);
							}
							((((csequence_t) CREF(new1317_2740))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							((((csequence_t) CREF(new1317_2740))->cops) = ((obj_t) exps_1755), BUNSPEC);
							res2532_2746 = new1317_2740;
						     }
						     arg2083_1779 = res2532_2746;
						  }
						  {
						     cfail_t arg2089_1785;
						     {
							cfail_t res2533_2768;
							{
							   cop_t proc_2758;
							   cop_t msg_2759;
							   cop_t obj_2760;
							   {
							      obj_t aux_4947;
							      {
								 obj_t aux_4948;
								 {
								    obj_t aux_4949;
								    aux_4949 = CDR(new_actuals_73_1752);
								    aux_4948 = CDR(aux_4949);
								 }
								 aux_4947 = CAR(aux_4948);
							      }
							      proc_2758 = (cop_t) (aux_4947);
							   }
							   {
							      obj_t aux_4954;
							      {
								 obj_t aux_4955;
								 aux_4955 = CDR(new_actuals_73_1752);
								 aux_4954 = CAR(aux_4955);
							      }
							      msg_2759 = (cop_t) (aux_4954);
							   }
							   {
							      obj_t aux_4959;
							      aux_4959 = CAR(new_actuals_73_1752);
							      obj_2760 = (cop_t) (aux_4959);
							   }
							   {
							      cfail_t new1358_2761;
							      new1358_2761 = ((cfail_t) BREF(GC_MALLOC(sizeof(struct cfail))));
							      {
								 long arg1609_2762;
								 arg1609_2762 = class_num_218___object(cfail_cgen_cop);
								 {
								    obj_t obj_2766;
								    obj_2766 = (obj_t) (new1358_2761);
								    (((obj_t) CREF(obj_2766))->header = MAKE_HEADER(arg1609_2762, 0), BUNSPEC);
								 }
							      }
							      {
								 object_t aux_4966;
								 aux_4966 = (object_t) (new1358_2761);
								 OBJECT_WIDENING_SET(aux_4966, BFALSE);
							      }
							      ((((cfail_t) CREF(new1358_2761))->proc) = ((cop_t) proc_2758), BUNSPEC);
							      ((((cfail_t) CREF(new1358_2761))->msg) = ((cop_t) msg_2759), BUNSPEC);
							      ((((cfail_t) CREF(new1358_2761))->obj) = ((cop_t) obj_2760), BUNSPEC);
							      res2533_2768 = new1358_2761;
							   }
							}
							arg2089_1785 = res2533_2768;
						     }
						     arg2084_1780 = arg2089_1785;
						  }
						  {
						     obj_t list2085_1781;
						     {
							obj_t arg2086_1782;
							{
							   obj_t arg2087_1783;
							   {
							      obj_t aux_4972;
							      aux_4972 = (obj_t) (arg2084_1780);
							      arg2087_1783 = MAKE_PAIR(aux_4972, BNIL);
							   }
							   {
							      obj_t aux_4975;
							      aux_4975 = (obj_t) (arg2083_1779);
							      arg2086_1782 = MAKE_PAIR(aux_4975, arg2087_1783);
							   }
							}
							{
							   obj_t aux_4978;
							   aux_4978 = (obj_t) (arg2081_1778);
							   list2085_1781 = MAKE_PAIR(aux_4978, arg2086_1782);
							}
						     }
						     arg2080_1777 = list2085_1781;
						  }
					       }
					       {
						  csequence_t res2534_2779;
						  {
						     csequence_t new1317_2773;
						     new1317_2773 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
						     {
							long arg1642_2774;
							arg1642_2774 = class_num_218___object(csequence_cgen_cop);
							{
							   obj_t obj_2777;
							   obj_2777 = (obj_t) (new1317_2773);
							   (((obj_t) CREF(obj_2777))->header = MAKE_HEADER(arg1642_2774, 0), BUNSPEC);
							}
						     }
						     {
							object_t aux_4985;
							aux_4985 = (object_t) (new1317_2773);
							OBJECT_WIDENING_SET(aux_4985, BFALSE);
						     }
						     ((((csequence_t) CREF(new1317_2773))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						     ((((csequence_t) CREF(new1317_2773))->cops) = ((obj_t) arg2080_1777), BUNSPEC);
						     res2534_2779 = new1317_2773;
						  }
						  arg2079_1776 = res2534_2779;
					       }
					    }
					    {
					       block_t res2535_2786;
					       {
						  cop_t body_2780;
						  body_2780 = (cop_t) (arg2079_1776);
						  {
						     block_t new1287_2781;
						     new1287_2781 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
						     {
							long arg1657_2782;
							arg1657_2782 = class_num_218___object(block_cgen_cop);
							{
							   obj_t obj_2784;
							   obj_2784 = (obj_t) (new1287_2781);
							   (((obj_t) CREF(obj_2784))->header = MAKE_HEADER(arg1657_2782, 0), BUNSPEC);
							}
						     }
						     {
							object_t aux_4995;
							aux_4995 = (object_t) (new1287_2781);
							OBJECT_WIDENING_SET(aux_4995, BFALSE);
						     }
						     ((((block_t) CREF(new1287_2781))->body) = ((cop_t) body_2780), BUNSPEC);
						     res2535_2786 = new1287_2781;
						  }
					       }
					       aux_4187 = (obj_t) (res2535_2786);
					    }
					 }
				    }
				  else
				    {
				       cop_t cop_1789;
				       {
					  setq_t arg2110_1804;
					  {
					     setq_t res2538_2817;
					     {
						variable_t variable_2788;
						node_t value_2789;
						variable_2788 = (variable_t) (aux_1753);
						{
						   obj_t aux_5001;
						   aux_5001 = CAR(old_actuals_174_1751);
						   value_2789 = (node_t) (aux_5001);
						}
						{
						   var_t arg1585_2790;
						   {
						      type_t arg1587_2791;
						      arg1587_2791 = (((variable_t) CREF(variable_2788))->type);
						      {
							 var_t res2536_2803;
							 {
							    obj_t loc_2793;
							    loc_2793 = BFALSE;
							    {
							       var_t new1129_2796;
							       new1129_2796 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
							       {
								  long arg1716_2797;
								  arg1716_2797 = class_num_218___object(var_ast_node);
								  {
								     obj_t obj_2801;
								     obj_2801 = (obj_t) (new1129_2796);
								     (((obj_t) CREF(obj_2801))->header = MAKE_HEADER(arg1716_2797, 0), BUNSPEC);
								  }
							       }
							       {
								  object_t aux_5009;
								  aux_5009 = (object_t) (new1129_2796);
								  OBJECT_WIDENING_SET(aux_5009, loc_2793);
							       }
							       ((((var_t) CREF(new1129_2796))->loc) = ((obj_t) loc_2793), BUNSPEC);
							       ((((var_t) CREF(new1129_2796))->type) = ((type_t) arg1587_2791), BUNSPEC);
							       ((((var_t) CREF(new1129_2796))->variable) = ((variable_t) variable_2788), BUNSPEC);
							       res2536_2803 = new1129_2796;
							    }
							 }
							 arg1585_2790 = res2536_2803;
						      }
						   }
						   {
						      setq_t res2537_2816;
						      {
							 obj_t loc_2804;
							 type_t type_2805;
							 loc_2804 = BFALSE;
							 type_2805 = (type_t) (__unspec__87_type_cache);
							 {
							    setq_t new1189_2808;
							    new1189_2808 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
							    {
							       long arg1696_2809;
							       arg1696_2809 = class_num_218___object(setq_ast_node);
							       {
								  obj_t obj_2814;
								  obj_2814 = (obj_t) (new1189_2808);
								  (((obj_t) CREF(obj_2814))->header = MAKE_HEADER(arg1696_2809, 0), BUNSPEC);
							       }
							    }
							    {
							       object_t aux_5020;
							       aux_5020 = (object_t) (new1189_2808);
							       OBJECT_WIDENING_SET(aux_5020, loc_2804);
							    }
							    ((((setq_t) CREF(new1189_2808))->loc) = ((obj_t) loc_2804), BUNSPEC);
							    ((((setq_t) CREF(new1189_2808))->type) = ((type_t) type_2805), BUNSPEC);
							    ((((setq_t) CREF(new1189_2808))->var) = ((var_t) arg1585_2790), BUNSPEC);
							    ((((setq_t) CREF(new1189_2808))->value) = ((node_t) value_2789), BUNSPEC);
							    res2537_2816 = new1189_2808;
							 }
						      }
						      res2538_2817 = res2537_2816;
						   }
						}
					     }
					     arg2110_1804 = res2538_2817;
					  }
					  cop_1789 = node__cop_142_cgen_cgen((node_t) (arg2110_1804), __id_kont__126_cgen_cgen);
				       }
				       {
					  bool_t test2096_1790;
					  {
					     bool_t test2107_1801;
					     test2107_1801 = is_a__118___object((obj_t) (cop_1789), csetq_cgen_cop);
					     if (test2107_1801)
					       {
						  obj_t aux_5038;
						  obj_t aux_5032;
						  aux_5038 = (obj_t) (aux_1753);
						  {
						     variable_t aux_5033;
						     {
							varc_t arg2109_1803;
							{
							   csetq_t obj_2819;
							   obj_2819 = (csetq_t) (cop_1789);
							   arg2109_1803 = (((csetq_t) CREF(obj_2819))->var);
							}
							aux_5033 = (((varc_t) CREF(arg2109_1803))->variable);
						     }
						     aux_5032 = (obj_t) (aux_5033);
						  }
						  test2096_1790 = (aux_5032 == aux_5038);
					       }
					     else
					       {
						  test2096_1790 = ((bool_t) 0);
					       }
					  }
					  if (test2096_1790)
					    {
					       obj_t arg2097_1791;
					       obj_t arg2098_1792;
					       arg2097_1791 = CDR(old_actuals_174_1751);
					       {
						  obj_t aux_5043;
						  {
						     cop_t aux_5044;
						     {
							csetq_t obj_2824;
							obj_2824 = (csetq_t) (cop_1789);
							aux_5044 = (((csetq_t) CREF(obj_2824))->value);
						     }
						     aux_5043 = (obj_t) (aux_5044);
						  }
						  arg2098_1792 = MAKE_PAIR(aux_5043, new_actuals_73_1752);
					       }
					       {
						  obj_t new_actuals_73_5050;
						  obj_t old_actuals_174_5049;
						  old_actuals_174_5049 = arg2097_1791;
						  new_actuals_73_5050 = arg2098_1792;
						  new_actuals_73_1752 = new_actuals_73_5050;
						  old_actuals_174_1751 = old_actuals_174_5049;
						  goto loop_1756;
					       }
					    }
					  else
					    {
					       {
						  obj_t res2539_2829;
						  {
						     type_t val1052_2828;
						     val1052_2828 = (type_t) (__obj__252_type_cache);
						     {
							obj_t x_3826;
							x_3826 = ((((local_t) CREF(aux_1753))->type) = ((type_t) val1052_2828), BUNSPEC);
							res2539_2829 = BUNSPEC;
						     }
						  }
						  res2539_2829;
					       }
					       {
						  obj_t arg2100_1794;
						  obj_t arg2101_1795;
						  local_t arg2102_1796;
						  obj_t arg2103_1797;
						  obj_t arg2104_1798;
						  arg2100_1794 = CDR(old_actuals_174_1751);
						  {
						     varc_t arg2105_1799;
						     {
							varc_t res2540_2837;
							{
							   variable_t variable_2831;
							   variable_2831 = (variable_t) (aux_1753);
							   {
							      varc_t new1305_2832;
							      new1305_2832 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
							      {
								 long arg1648_2833;
								 arg1648_2833 = class_num_218___object(varc_cgen_cop);
								 {
								    obj_t obj_2835;
								    obj_2835 = (obj_t) (new1305_2832);
								    (((obj_t) CREF(obj_2835))->header = MAKE_HEADER(arg1648_2833, 0), BUNSPEC);
								 }
							      }
							      {
								 object_t aux_5059;
								 aux_5059 = (object_t) (new1305_2832);
								 OBJECT_WIDENING_SET(aux_5059, BFALSE);
							      }
							      ((((varc_t) CREF(new1305_2832))->variable) = ((variable_t) variable_2831), BUNSPEC);
							      res2540_2837 = new1305_2832;
							   }
							}
							arg2105_1799 = res2540_2837;
						     }
						     {
							obj_t aux_5063;
							aux_5063 = (obj_t) (arg2105_1799);
							arg2101_1795 = MAKE_PAIR(aux_5063, new_actuals_73_1752);
						     }
						  }
						  {
						     obj_t arg2106_1800;
						     arg2106_1800 = CNST_TABLE_REF(((long) 2));
						     {
							local_t res2541_2843;
							{
							   type_t type_2841;
							   type_2841 = (type_t) (__obj__252_type_cache);
							   {
							      local_t local_2842;
							      local_2842 = make_local_svar_140_ast_local(arg2106_1800, type_2841);
							      set_variable_name__102_cgen_prototype((obj_t) (local_2842));
							      res2541_2843 = local_2842;
							   }
							}
							arg2102_1796 = res2541_2843;
						     }
						  }
						  {
						     obj_t aux_5071;
						     aux_5071 = (obj_t) (aux_1753);
						     arg2103_1797 = MAKE_PAIR(aux_5071, auxs_1754);
						  }
						  {
						     obj_t aux_5074;
						     aux_5074 = (obj_t) (cop_1789);
						     arg2104_1798 = MAKE_PAIR(aux_5074, exps_1755);
						  }
						  {
						     obj_t exps_5081;
						     obj_t auxs_5080;
						     local_t aux_5079;
						     obj_t new_actuals_73_5078;
						     obj_t old_actuals_174_5077;
						     old_actuals_174_5077 = arg2100_1794;
						     new_actuals_73_5078 = arg2101_1795;
						     aux_5079 = arg2102_1796;
						     auxs_5080 = arg2103_1797;
						     exps_5081 = arg2104_1798;
						     exps_1755 = exps_5081;
						     auxs_1754 = auxs_5080;
						     aux_1753 = aux_5079;
						     new_actuals_73_1752 = new_actuals_73_5078;
						     old_actuals_174_1751 = old_actuals_174_5077;
						     goto loop_1756;
						  }
					       }
					    }
				       }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 10):
			 {
			    select_t node_1806;
			    node_1806 = (select_t) (node_9);
			    {
			       bool_t test2112_1808;
			       {
				  obj_t aux_5083;
				  aux_5083 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2112_1808 = CBOOL(aux_5083);
			       }
			       if (test2112_1808)
				 {
				    obj_t arg2114_1810;
				    arg2114_1810 = shape_tools_shape((obj_t) (node_1806));
				    {
				       obj_t list2116_1812;
				       {
					  obj_t arg2117_1813;
					  {
					     obj_t arg2118_1814;
					     {
						obj_t arg2119_1815;
						{
						   obj_t arg2120_1816;
						   {
						      obj_t arg2121_1817;
						      {
							 obj_t aux_5091;
							 aux_5091 = BCHAR(((unsigned char) '\n'));
							 arg2121_1817 = MAKE_PAIR(aux_5091, BNIL);
						      }
						      arg2120_1816 = MAKE_PAIR(kont_10, arg2121_1817);
						   }
						   arg2119_1815 = MAKE_PAIR(string2635_cgen_cgen, arg2120_1816);
						}
						{
						   obj_t aux_5096;
						   aux_5096 = BCHAR(((unsigned char) '\n'));
						   arg2118_1814 = MAKE_PAIR(aux_5096, arg2119_1815);
						}
					     }
					     arg2117_1813 = MAKE_PAIR(arg2114_1810, arg2118_1814);
					  }
					  list2116_1812 = MAKE_PAIR(string2649_cgen_cgen, arg2117_1813);
				       }
				       print_trace_107_tools_trace(list2116_1812);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       obj_t l1418_1822;
			       l1418_1822 = (((select_t) CREF(node_1806))->clauses);
			     lname1419_1823:
			       if (PAIRP(l1418_1822))
				 {
				    {
				       obj_t clause_1826;
				       clause_1826 = CAR(l1418_1822);
				       {
					  cop_t arg2127_1827;
					  {
					     node_t aux_5105;
					     {
						obj_t aux_5106;
						aux_5106 = CDR(clause_1826);
						aux_5105 = (node_t) (aux_5106);
					     }
					     arg2127_1827 = node__cop_142_cgen_cgen(aux_5105, kont_10);
					  }
					  {
					     obj_t aux_5110;
					     aux_5110 = (obj_t) (arg2127_1827);
					     SET_CDR(clause_1826, aux_5110);
					  }
				       }
				    }
				    {
				       obj_t l1418_5113;
				       l1418_5113 = CDR(l1418_1822);
				       l1418_1822 = l1418_5113;
				       goto lname1419_1823;
				    }
				 }
			       else
				 {
				    ((bool_t) 1);
				 }
			    }
			    {
			       local_t aux_1830;
			       {
				  local_t res2542_2859;
				  {
				     local_t local_2858;
				     local_2858 = make_local_svar_140_ast_local(CNST_TABLE_REF(((long) 2)), (((select_t) CREF(node_1806))->item_type_130));
				     set_variable_name__102_cgen_prototype((obj_t) (local_2858));
				     res2542_2859 = local_2858;
				  }
				  aux_1830 = res2542_2859;
			       }
			       {
				  cop_t cop_1831;
				  {
				     setq_t arg2150_1851;
				     {
					node_t arg2151_1852;
					arg2151_1852 = (((select_t) CREF(node_1806))->test);
					{
					   setq_t res2545_2890;
					   {
					      variable_t variable_2861;
					      variable_2861 = (variable_t) (aux_1830);
					      {
						 var_t arg1585_2863;
						 {
						    type_t arg1587_2864;
						    arg1587_2864 = (((variable_t) CREF(variable_2861))->type);
						    {
						       var_t res2543_2876;
						       {
							  obj_t loc_2866;
							  loc_2866 = BFALSE;
							  {
							     var_t new1129_2869;
							     new1129_2869 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
							     {
								long arg1716_2870;
								arg1716_2870 = class_num_218___object(var_ast_node);
								{
								   obj_t obj_2874;
								   obj_2874 = (obj_t) (new1129_2869);
								   (((obj_t) CREF(obj_2874))->header = MAKE_HEADER(arg1716_2870, 0), BUNSPEC);
								}
							     }
							     {
								object_t aux_5128;
								aux_5128 = (object_t) (new1129_2869);
								OBJECT_WIDENING_SET(aux_5128, loc_2866);
							     }
							     ((((var_t) CREF(new1129_2869))->loc) = ((obj_t) loc_2866), BUNSPEC);
							     ((((var_t) CREF(new1129_2869))->type) = ((type_t) arg1587_2864), BUNSPEC);
							     ((((var_t) CREF(new1129_2869))->variable) = ((variable_t) variable_2861), BUNSPEC);
							     res2543_2876 = new1129_2869;
							  }
						       }
						       arg1585_2863 = res2543_2876;
						    }
						 }
						 {
						    setq_t res2544_2889;
						    {
						       obj_t loc_2877;
						       type_t type_2878;
						       loc_2877 = BFALSE;
						       type_2878 = (type_t) (__unspec__87_type_cache);
						       {
							  setq_t new1189_2881;
							  new1189_2881 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
							  {
							     long arg1696_2882;
							     arg1696_2882 = class_num_218___object(setq_ast_node);
							     {
								obj_t obj_2887;
								obj_2887 = (obj_t) (new1189_2881);
								(((obj_t) CREF(obj_2887))->header = MAKE_HEADER(arg1696_2882, 0), BUNSPEC);
							     }
							  }
							  {
							     object_t aux_5139;
							     aux_5139 = (object_t) (new1189_2881);
							     OBJECT_WIDENING_SET(aux_5139, loc_2877);
							  }
							  ((((setq_t) CREF(new1189_2881))->loc) = ((obj_t) loc_2877), BUNSPEC);
							  ((((setq_t) CREF(new1189_2881))->type) = ((type_t) type_2878), BUNSPEC);
							  ((((setq_t) CREF(new1189_2881))->var) = ((var_t) arg1585_2863), BUNSPEC);
							  ((((setq_t) CREF(new1189_2881))->value) = ((node_t) arg2151_1852), BUNSPEC);
							  res2544_2889 = new1189_2881;
						       }
						    }
						    res2545_2890 = res2544_2889;
						 }
					      }
					   }
					   arg2150_1851 = res2545_2890;
					}
				     }
				     cop_1831 = node__cop_142_cgen_cgen((node_t) (arg2150_1851), __id_kont__126_cgen_cgen);
				  }
				  {
				     bool_t test2130_1832;
				     {
					bool_t test2147_1848;
					test2147_1848 = is_a__118___object((obj_t) (cop_1831), csetq_cgen_cop);
					if (test2147_1848)
					  {
					     obj_t aux_5157;
					     obj_t aux_5151;
					     aux_5157 = (obj_t) (aux_1830);
					     {
						variable_t aux_5152;
						{
						   varc_t arg2149_1850;
						   {
						      csetq_t obj_2892;
						      obj_2892 = (csetq_t) (cop_1831);
						      arg2149_1850 = (((csetq_t) CREF(obj_2892))->var);
						   }
						   aux_5152 = (((varc_t) CREF(arg2149_1850))->variable);
						}
						aux_5151 = (obj_t) (aux_5152);
					     }
					     test2130_1832 = (aux_5151 == aux_5157);
					  }
					else
					  {
					     test2130_1832 = ((bool_t) 0);
					  }
				     }
				     if (test2130_1832)
				       {
					  cop_t arg2131_1833;
					  obj_t arg2132_1834;
					  {
					     csetq_t obj_2896;
					     obj_2896 = (csetq_t) (cop_1831);
					     arg2131_1833 = (((csetq_t) CREF(obj_2896))->value);
					  }
					  arg2132_1834 = (((select_t) CREF(node_1806))->clauses);
					  {
					     cswitch_t res2546_2906;
					     {
						cswitch_t new1363_2900;
						new1363_2900 = ((cswitch_t) BREF(GC_MALLOC(sizeof(struct cswitch))));
						{
						   long arg1606_2901;
						   arg1606_2901 = class_num_218___object(cswitch_cgen_cop);
						   {
						      obj_t obj_2904;
						      obj_2904 = (obj_t) (new1363_2900);
						      (((obj_t) CREF(obj_2904))->header = MAKE_HEADER(arg1606_2901, 0), BUNSPEC);
						   }
						}
						{
						   object_t aux_5168;
						   aux_5168 = (object_t) (new1363_2900);
						   OBJECT_WIDENING_SET(aux_5168, BFALSE);
						}
						((((cswitch_t) CREF(new1363_2900))->test) = ((cop_t) arg2131_1833), BUNSPEC);
						((((cswitch_t) CREF(new1363_2900))->clauses) = ((obj_t) arg2132_1834), BUNSPEC);
						res2546_2906 = new1363_2900;
					     }
					     aux_4187 = (obj_t) (res2546_2906);
					  }
				       }
				     else
				       {
					  csequence_t arg2133_1835;
					  {
					     obj_t arg2134_1836;
					     {
						local_var_164_t arg2135_1837;
						cswitch_t arg2136_1838;
						{
						   obj_t arg2142_1843;
						   {
						      obj_t list2143_1844;
						      {
							 obj_t aux_5174;
							 aux_5174 = (obj_t) (aux_1830);
							 list2143_1844 = MAKE_PAIR(aux_5174, BNIL);
						      }
						      arg2142_1843 = list2143_1844;
						   }
						   {
						      local_var_164_t res2547_2914;
						      {
							 local_var_164_t new1342_2909;
							 new1342_2909 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							 {
							    long arg1621_2910;
							    arg1621_2910 = class_num_218___object(local_var_164_cgen_cop);
							    {
							       obj_t obj_2912;
							       obj_2912 = (obj_t) (new1342_2909);
							       (((obj_t) CREF(obj_2912))->header = MAKE_HEADER(arg1621_2910, 0), BUNSPEC);
							    }
							 }
							 {
							    object_t aux_5181;
							    aux_5181 = (object_t) (new1342_2909);
							    OBJECT_WIDENING_SET(aux_5181, BFALSE);
							 }
							 ((((local_var_164_t) CREF(new1342_2909))->vars) = ((obj_t) arg2142_1843), BUNSPEC);
							 res2547_2914 = new1342_2909;
						      }
						      arg2135_1837 = res2547_2914;
						   }
						}
						{
						   varc_t arg2145_1846;
						   obj_t arg2146_1847;
						   {
						      varc_t res2548_2921;
						      {
							 variable_t variable_2915;
							 variable_2915 = (variable_t) (aux_1830);
							 {
							    varc_t new1305_2916;
							    new1305_2916 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
							    {
							       long arg1648_2917;
							       arg1648_2917 = class_num_218___object(varc_cgen_cop);
							       {
								  obj_t obj_2919;
								  obj_2919 = (obj_t) (new1305_2916);
								  (((obj_t) CREF(obj_2919))->header = MAKE_HEADER(arg1648_2917, 0), BUNSPEC);
							       }
							    }
							    {
							       object_t aux_5190;
							       aux_5190 = (object_t) (new1305_2916);
							       OBJECT_WIDENING_SET(aux_5190, BFALSE);
							    }
							    ((((varc_t) CREF(new1305_2916))->variable) = ((variable_t) variable_2915), BUNSPEC);
							    res2548_2921 = new1305_2916;
							 }
						      }
						      arg2145_1846 = res2548_2921;
						   }
						   arg2146_1847 = (((select_t) CREF(node_1806))->clauses);
						   {
						      cswitch_t res2549_2931;
						      {
							 cop_t test_2923;
							 test_2923 = (cop_t) (arg2145_1846);
							 {
							    cswitch_t new1363_2925;
							    new1363_2925 = ((cswitch_t) BREF(GC_MALLOC(sizeof(struct cswitch))));
							    {
							       long arg1606_2926;
							       arg1606_2926 = class_num_218___object(cswitch_cgen_cop);
							       {
								  obj_t obj_2929;
								  obj_2929 = (obj_t) (new1363_2925);
								  (((obj_t) CREF(obj_2929))->header = MAKE_HEADER(arg1606_2926, 0), BUNSPEC);
							       }
							    }
							    {
							       object_t aux_5200;
							       aux_5200 = (object_t) (new1363_2925);
							       OBJECT_WIDENING_SET(aux_5200, BFALSE);
							    }
							    ((((cswitch_t) CREF(new1363_2925))->test) = ((cop_t) test_2923), BUNSPEC);
							    ((((cswitch_t) CREF(new1363_2925))->clauses) = ((obj_t) arg2146_1847), BUNSPEC);
							    res2549_2931 = new1363_2925;
							 }
						      }
						      arg2136_1838 = res2549_2931;
						   }
						}
						{
						   obj_t list2137_1839;
						   {
						      obj_t arg2138_1840;
						      {
							 obj_t arg2139_1841;
							 {
							    obj_t aux_5205;
							    aux_5205 = (obj_t) (arg2136_1838);
							    arg2139_1841 = MAKE_PAIR(aux_5205, BNIL);
							 }
							 {
							    obj_t aux_5208;
							    aux_5208 = (obj_t) (cop_1831);
							    arg2138_1840 = MAKE_PAIR(aux_5208, arg2139_1841);
							 }
						      }
						      {
							 obj_t aux_5211;
							 aux_5211 = (obj_t) (arg2135_1837);
							 list2137_1839 = MAKE_PAIR(aux_5211, arg2138_1840);
						      }
						   }
						   arg2134_1836 = list2137_1839;
						}
					     }
					     {
						csequence_t res2550_2941;
						{
						   csequence_t new1317_2935;
						   new1317_2935 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
						   {
						      long arg1642_2936;
						      arg1642_2936 = class_num_218___object(csequence_cgen_cop);
						      {
							 obj_t obj_2939;
							 obj_2939 = (obj_t) (new1317_2935);
							 (((obj_t) CREF(obj_2939))->header = MAKE_HEADER(arg1642_2936, 0), BUNSPEC);
						      }
						   }
						   {
						      object_t aux_5218;
						      aux_5218 = (object_t) (new1317_2935);
						      OBJECT_WIDENING_SET(aux_5218, BFALSE);
						   }
						   ((((csequence_t) CREF(new1317_2935))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						   ((((csequence_t) CREF(new1317_2935))->cops) = ((obj_t) arg2134_1836), BUNSPEC);
						   res2550_2941 = new1317_2935;
						}
						arg2133_1835 = res2550_2941;
					     }
					  }
					  {
					     block_t res2551_2948;
					     {
						cop_t body_2942;
						body_2942 = (cop_t) (arg2133_1835);
						{
						   block_t new1287_2943;
						   new1287_2943 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
						   {
						      long arg1657_2944;
						      arg1657_2944 = class_num_218___object(block_cgen_cop);
						      {
							 obj_t obj_2946;
							 obj_2946 = (obj_t) (new1287_2943);
							 (((obj_t) CREF(obj_2946))->header = MAKE_HEADER(arg1657_2944, 0), BUNSPEC);
						      }
						   }
						   {
						      object_t aux_5228;
						      aux_5228 = (object_t) (new1287_2943);
						      OBJECT_WIDENING_SET(aux_5228, BFALSE);
						   }
						   ((((block_t) CREF(new1287_2943))->body) = ((cop_t) body_2942), BUNSPEC);
						   res2551_2948 = new1287_2943;
						}
					     }
					     aux_4187 = (obj_t) (res2551_2948);
					  }
				       }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 11):
			 {
			    let_fun_218_t node_1855;
			    node_1855 = (let_fun_218_t) (node_9);
			    {
			       bool_t test2154_1857;
			       {
				  obj_t aux_5234;
				  aux_5234 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2154_1857 = CBOOL(aux_5234);
			       }
			       if (test2154_1857)
				 {
				    obj_t arg2156_1859;
				    arg2156_1859 = shape_tools_shape((obj_t) (node_1855));
				    {
				       obj_t list2161_1861;
				       {
					  obj_t arg2162_1862;
					  {
					     obj_t arg2163_1863;
					     {
						obj_t arg2164_1864;
						{
						   obj_t arg2165_1865;
						   {
						      obj_t arg2166_1866;
						      {
							 obj_t aux_5242;
							 aux_5242 = BCHAR(((unsigned char) '\n'));
							 arg2166_1866 = MAKE_PAIR(aux_5242, BNIL);
						      }
						      arg2165_1865 = MAKE_PAIR(kont_10, arg2166_1866);
						   }
						   arg2164_1864 = MAKE_PAIR(string2635_cgen_cgen, arg2165_1865);
						}
						{
						   obj_t aux_5247;
						   aux_5247 = BCHAR(((unsigned char) '\n'));
						   arg2163_1863 = MAKE_PAIR(aux_5247, arg2164_1864);
						}
					     }
					     arg2162_1862 = MAKE_PAIR(arg2156_1859, arg2163_1863);
					  }
					  list2161_1861 = MAKE_PAIR(string2650_cgen_cgen, arg2162_1862);
				       }
				       print_trace_107_tools_trace(list2161_1861);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       obj_t locals_1871;
			       obj_t all_formals_186_1872;
			       locals_1871 = (((let_fun_218_t) CREF(node_1855))->locals);
			       all_formals_186_1872 = BNIL;
			     loop_1873:
			       if (NULLP(locals_1871))
				 {
				    csequence_t arg2173_1877;
				    {
				       obj_t arg2174_1878;
				       {
					  local_var_164_t arg2175_1879;
					  cop_t arg2176_1880;
					  {
					     local_var_164_t res2552_2957;
					     {
						local_var_164_t new1342_2952;
						new1342_2952 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
						{
						   long arg1621_2953;
						   arg1621_2953 = class_num_218___object(local_var_164_cgen_cop);
						   {
						      obj_t obj_2955;
						      obj_2955 = (obj_t) (new1342_2952);
						      (((obj_t) CREF(obj_2955))->header = MAKE_HEADER(arg1621_2953, 0), BUNSPEC);
						   }
						}
						{
						   object_t aux_5259;
						   aux_5259 = (object_t) (new1342_2952);
						   OBJECT_WIDENING_SET(aux_5259, BFALSE);
						}
						((((local_var_164_t) CREF(new1342_2952))->vars) = ((obj_t) all_formals_186_1872), BUNSPEC);
						res2552_2957 = new1342_2952;
					     }
					     arg2175_1879 = res2552_2957;
					  }
					  arg2176_1880 = node__cop_142_cgen_cgen((((let_fun_218_t) CREF(node_1855))->body), kont_10);
					  {
					     obj_t list2177_1881;
					     {
						obj_t arg2178_1882;
						{
						   obj_t aux_5265;
						   aux_5265 = (obj_t) (arg2176_1880);
						   arg2178_1882 = MAKE_PAIR(aux_5265, BNIL);
						}
						{
						   obj_t aux_5268;
						   aux_5268 = (obj_t) (arg2175_1879);
						   list2177_1881 = MAKE_PAIR(aux_5268, arg2178_1882);
						}
					     }
					     arg2174_1878 = list2177_1881;
					  }
				       }
				       {
					  csequence_t res2553_2968;
					  {
					     csequence_t new1317_2962;
					     new1317_2962 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
					     {
						long arg1642_2963;
						arg1642_2963 = class_num_218___object(csequence_cgen_cop);
						{
						   obj_t obj_2966;
						   obj_2966 = (obj_t) (new1317_2962);
						   (((obj_t) CREF(obj_2966))->header = MAKE_HEADER(arg1642_2963, 0), BUNSPEC);
						}
					     }
					     {
						object_t aux_5275;
						aux_5275 = (object_t) (new1317_2962);
						OBJECT_WIDENING_SET(aux_5275, BFALSE);
					     }
					     ((((csequence_t) CREF(new1317_2962))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					     ((((csequence_t) CREF(new1317_2962))->cops) = ((obj_t) arg2174_1878), BUNSPEC);
					     res2553_2968 = new1317_2962;
					  }
					  arg2173_1877 = res2553_2968;
				       }
				    }
				    aux_4187 = PROCEDURE_ENTRY(__block_kont__38_cgen_cgen) (__block_kont__38_cgen_cgen, (obj_t) (arg2173_1877), BEOA);
				 }
			       else
				 {
				    obj_t local_1885;
				    local_1885 = CAR(locals_1871);
				    set_variable_name__102_cgen_prototype(local_1885);
				    {
				       sfun_c_188_t fun_1886;
				       {
					  sfun_c_188_t obj1421_1895;
					  {
					     value_t aux_5285;
					     {
						local_t obj_2970;
						obj_2970 = (local_t) (local_1885);
						aux_5285 = (((local_t) CREF(obj_2970))->value);
					     }
					     obj1421_1895 = ((sfun_c_188_t) (aux_5285));
					  }
					  {
					     sfun_c_188_t arg2186_1896;
					     {
						clabel_t arg2187_1897;
						{
						   obj_t arg2188_1898;
						   {
						      local_t obj_2971;
						      obj_2971 = (local_t) (local_1885);
						      arg2188_1898 = (((local_t) CREF(obj_2971))->name);
						   }
						   {
						      clabel_t res2554_2982;
						      {
							 clabel_t new1277_2975;
							 new1277_2975 = ((clabel_t) BREF(GC_MALLOC(sizeof(struct clabel))));
							 {
							    long arg1664_2976;
							    arg1664_2976 = class_num_218___object(clabel_cgen_cop);
							    {
							       obj_t obj_2980;
							       obj_2980 = (obj_t) (new1277_2975);
							       (((obj_t) CREF(obj_2980))->header = MAKE_HEADER(arg1664_2976, 0), BUNSPEC);
							    }
							 }
							 {
							    object_t aux_5295;
							    aux_5295 = (object_t) (new1277_2975);
							    OBJECT_WIDENING_SET(aux_5295, BFALSE);
							 }
							 ((((clabel_t) CREF(new1277_2975))->name) = ((obj_t) arg2188_1898), BUNSPEC);
							 ((((clabel_t) CREF(new1277_2975))->used__226) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							 ((((clabel_t) CREF(new1277_2975))->body) = ((obj_t) BUNSPEC), BUNSPEC);
							 res2554_2982 = new1277_2975;
						      }
						      arg2187_1897 = res2554_2982;
						   }
						}
						{
						   sfun_c_188_t res2555_2988;
						   {
						      sfun_c_188_t new1387_2985;
						      new1387_2985 = ((sfun_c_188_t) BREF(GC_MALLOC(sizeof(struct sfun_c_188))));
						      ((((sfun_c_188_t) CREF(new1387_2985))->label) = ((clabel_t) arg2187_1897), BUNSPEC);
						      ((((sfun_c_188_t) CREF(new1387_2985))->integrated) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						      res2555_2988 = new1387_2985;
						   }
						   arg2186_1896 = res2555_2988;
						}
					     }
					     {
						obj_t aux_5306;
						object_t aux_5304;
						aux_5306 = (obj_t) (arg2186_1896);
						aux_5304 = (object_t) (obj1421_1895);
						OBJECT_WIDENING_SET(aux_5304, aux_5306);
					     }
					  }
					  {
					     long arg2189_1899;
					     arg2189_1899 = class_num_218___object(sfun_c_188_cgen_cop);
					     {
						obj_t obj_2989;
						obj_2989 = (obj_t) (obj1421_1895);
						(((obj_t) CREF(obj_2989))->header = MAKE_HEADER(arg2189_1899, 0), BUNSPEC);
					     }
					  }
					  fun_1886 = obj1421_1895;
				       }
				       {
					  obj_t formals_1887;
					  {
					     sfun_t obj_2991;
					     obj_2991 = (sfun_t) (fun_1886);
					     formals_1887 = (((sfun_t) CREF(obj_2991))->args);
					  }
					  {
					     {
						obj_t l1422_1888;
						l1422_1888 = formals_1887;
					      lname1423_1889:
						if (PAIRP(l1422_1888))
						  {
						     set_variable_name__102_cgen_prototype(CAR(l1422_1888));
						     {
							obj_t l1422_5318;
							l1422_5318 = CDR(l1422_1888);
							l1422_1888 = l1422_5318;
							goto lname1423_1889;
						     }
						  }
						else
						  {
						     ((bool_t) 1);
						  }
					     }
					     {
						obj_t all_formals_186_5322;
						obj_t locals_5320;
						locals_5320 = CDR(locals_1871);
						all_formals_186_5322 = append_2_18___r4_pairs_and_lists_6_3(formals_1887, all_formals_186_1872);
						all_formals_186_1872 = all_formals_186_5322;
						locals_1871 = locals_5320;
						goto loop_1873;
					     }
					  }
				       }
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 12):
			 {
			    let_var_6_t node_1900;
			    node_1900 = (let_var_6_t) (node_9);
			    {
			       bool_t test2190_1902;
			       {
				  obj_t aux_5326;
				  aux_5326 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2190_1902 = CBOOL(aux_5326);
			       }
			       if (test2190_1902)
				 {
				    obj_t arg2192_1904;
				    arg2192_1904 = shape_tools_shape((obj_t) (node_1900));
				    {
				       obj_t list2194_1906;
				       {
					  obj_t arg2195_1907;
					  {
					     obj_t arg2196_1908;
					     {
						obj_t arg2197_1909;
						{
						   obj_t arg2198_1910;
						   {
						      obj_t arg2199_1911;
						      {
							 obj_t aux_5334;
							 aux_5334 = BCHAR(((unsigned char) '\n'));
							 arg2199_1911 = MAKE_PAIR(aux_5334, BNIL);
						      }
						      arg2198_1910 = MAKE_PAIR(kont_10, arg2199_1911);
						   }
						   arg2197_1909 = MAKE_PAIR(string2635_cgen_cgen, arg2198_1910);
						}
						{
						   obj_t aux_5339;
						   aux_5339 = BCHAR(((unsigned char) '\n'));
						   arg2196_1908 = MAKE_PAIR(aux_5339, arg2197_1909);
						}
					     }
					     arg2195_1907 = MAKE_PAIR(arg2192_1904, arg2196_1908);
					  }
					  list2194_1906 = MAKE_PAIR(string2651_cgen_cgen, arg2195_1907);
				       }
				       print_trace_107_tools_trace(list2194_1906);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       local_var_164_t decls_1916;
			       obj_t sets_1917;
			       stop_t body_1918;
			       {
				  obj_t arg2210_1925;
				  {
				     obj_t l1425_1926;
				     l1425_1926 = (((let_var_6_t) CREF(node_1900))->bindings);
				     if (NULLP(l1425_1926))
				       {
					  arg2210_1925 = BNIL;
				       }
				     else
				       {
					  obj_t head1428_1928;
					  {
					     obj_t aux_5348;
					     {
						obj_t aux_5349;
						aux_5349 = CAR(l1425_1926);
						aux_5348 = CAR(aux_5349);
					     }
					     head1428_1928 = MAKE_PAIR(aux_5348, BNIL);
					  }
					  {
					     obj_t l1425_1929;
					     obj_t tail1429_1930;
					     l1425_1929 = CDR(l1425_1926);
					     tail1429_1930 = head1428_1928;
					   lname1427_1931:
					     if (NULLP(l1425_1929))
					       {
						  arg2210_1925 = head1428_1928;
					       }
					     else
					       {
						  obj_t new_tail1430_156_1934;
						  {
						     obj_t aux_5355;
						     {
							obj_t aux_5356;
							aux_5356 = CAR(l1425_1929);
							aux_5355 = CAR(aux_5356);
						     }
						     new_tail1430_156_1934 = MAKE_PAIR(aux_5355, BNIL);
						  }
						  SET_CDR(tail1429_1930, new_tail1430_156_1934);
						  {
						     obj_t tail1429_5363;
						     obj_t l1425_5361;
						     l1425_5361 = CDR(l1425_1929);
						     tail1429_5363 = new_tail1430_156_1934;
						     tail1429_1930 = tail1429_5363;
						     l1425_1929 = l1425_5361;
						     goto lname1427_1931;
						  }
					       }
					  }
				       }
				  }
				  {
				     local_var_164_t res2556_3017;
				     {
					local_var_164_t new1342_3012;
					new1342_3012 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
					{
					   long arg1621_3013;
					   arg1621_3013 = class_num_218___object(local_var_164_cgen_cop);
					   {
					      obj_t obj_3015;
					      obj_3015 = (obj_t) (new1342_3012);
					      (((obj_t) CREF(obj_3015))->header = MAKE_HEADER(arg1621_3013, 0), BUNSPEC);
					   }
					}
					{
					   object_t aux_5369;
					   aux_5369 = (object_t) (new1342_3012);
					   OBJECT_WIDENING_SET(aux_5369, BFALSE);
					}
					((((local_var_164_t) CREF(new1342_3012))->vars) = ((obj_t) arg2210_1925), BUNSPEC);
					res2556_3017 = new1342_3012;
				     }
				     decls_1916 = res2556_3017;
				  }
			       }
			       {
				  obj_t l1431_1942;
				  l1431_1942 = (((let_var_6_t) CREF(node_1900))->bindings);
				  if (NULLP(l1431_1942))
				    {
				       sets_1917 = BNIL;
				    }
				  else
				    {
				       obj_t head1434_1944;
				       head1434_1944 = MAKE_PAIR(BNIL, BNIL);
				       {
					  obj_t l1431_1945;
					  obj_t tail1435_1946;
					  l1431_1945 = l1431_1942;
					  tail1435_1946 = head1434_1944;
					lname1433_1947:
					  if (NULLP(l1431_1945))
					    {
					       sets_1917 = CDR(head1434_1944);
					    }
					  else
					    {
					       obj_t new_tail1436_41_1949;
					       {
						  cop_t arg2224_1951;
						  {
						     obj_t x_1953;
						     x_1953 = CAR(l1431_1945);
						     set_variable_name__102_cgen_prototype(CAR(x_1953));
						     {
							setq_t arg2227_1955;
							{
							   setq_t res2559_3057;
							   {
							      variable_t variable_3028;
							      node_t value_3029;
							      {
								 obj_t aux_5383;
								 aux_5383 = CAR(x_1953);
								 variable_3028 = (variable_t) (aux_5383);
							      }
							      {
								 obj_t aux_5386;
								 aux_5386 = CDR(x_1953);
								 value_3029 = (node_t) (aux_5386);
							      }
							      {
								 var_t arg1585_3030;
								 {
								    type_t arg1587_3031;
								    arg1587_3031 = (((variable_t) CREF(variable_3028))->type);
								    {
								       var_t res2557_3043;
								       {
									  obj_t loc_3033;
									  loc_3033 = BFALSE;
									  {
									     var_t new1129_3036;
									     new1129_3036 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
									     {
										long arg1716_3037;
										arg1716_3037 = class_num_218___object(var_ast_node);
										{
										   obj_t obj_3041;
										   obj_3041 = (obj_t) (new1129_3036);
										   (((obj_t) CREF(obj_3041))->header = MAKE_HEADER(arg1716_3037, 0), BUNSPEC);
										}
									     }
									     {
										object_t aux_5394;
										aux_5394 = (object_t) (new1129_3036);
										OBJECT_WIDENING_SET(aux_5394, loc_3033);
									     }
									     ((((var_t) CREF(new1129_3036))->loc) = ((obj_t) loc_3033), BUNSPEC);
									     ((((var_t) CREF(new1129_3036))->type) = ((type_t) arg1587_3031), BUNSPEC);
									     ((((var_t) CREF(new1129_3036))->variable) = ((variable_t) variable_3028), BUNSPEC);
									     res2557_3043 = new1129_3036;
									  }
								       }
								       arg1585_3030 = res2557_3043;
								    }
								 }
								 {
								    setq_t res2558_3056;
								    {
								       obj_t loc_3044;
								       type_t type_3045;
								       loc_3044 = BFALSE;
								       type_3045 = (type_t) (__unspec__87_type_cache);
								       {
									  setq_t new1189_3048;
									  new1189_3048 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
									  {
									     long arg1696_3049;
									     arg1696_3049 = class_num_218___object(setq_ast_node);
									     {
										obj_t obj_3054;
										obj_3054 = (obj_t) (new1189_3048);
										(((obj_t) CREF(obj_3054))->header = MAKE_HEADER(arg1696_3049, 0), BUNSPEC);
									     }
									  }
									  {
									     object_t aux_5405;
									     aux_5405 = (object_t) (new1189_3048);
									     OBJECT_WIDENING_SET(aux_5405, loc_3044);
									  }
									  ((((setq_t) CREF(new1189_3048))->loc) = ((obj_t) loc_3044), BUNSPEC);
									  ((((setq_t) CREF(new1189_3048))->type) = ((type_t) type_3045), BUNSPEC);
									  ((((setq_t) CREF(new1189_3048))->var) = ((var_t) arg1585_3030), BUNSPEC);
									  ((((setq_t) CREF(new1189_3048))->value) = ((node_t) value_3029), BUNSPEC);
									  res2558_3056 = new1189_3048;
								       }
								    }
								    res2559_3057 = res2558_3056;
								 }
							      }
							   }
							   arg2227_1955 = res2559_3057;
							}
							arg2224_1951 = node__cop_142_cgen_cgen((node_t) (arg2227_1955), __stop_kont__121_cgen_cgen);
						     }
						  }
						  {
						     obj_t aux_5414;
						     aux_5414 = (obj_t) (arg2224_1951);
						     new_tail1436_41_1949 = MAKE_PAIR(aux_5414, BNIL);
						  }
					       }
					       SET_CDR(tail1435_1946, new_tail1436_41_1949);
					       {
						  obj_t tail1435_5420;
						  obj_t l1431_5418;
						  l1431_5418 = CDR(l1431_1945);
						  tail1435_5420 = new_tail1436_41_1949;
						  tail1435_1946 = tail1435_5420;
						  l1431_1945 = l1431_5418;
						  goto lname1433_1947;
					       }
					    }
				       }
				    }
			       }
			       {
				  cop_t cop_1960;
				  cop_1960 = node__cop_142_cgen_cgen((((let_var_6_t) CREF(node_1900))->body), kont_10);
				  {
				     stop_t res2560_3070;
				     {
					stop_t new1326_3065;
					new1326_3065 = ((stop_t) BREF(GC_MALLOC(sizeof(struct stop))));
					{
					   long arg1634_3066;
					   arg1634_3066 = class_num_218___object(stop_cgen_cop);
					   {
					      obj_t obj_3068;
					      obj_3068 = (obj_t) (new1326_3065);
					      (((obj_t) CREF(obj_3068))->header = MAKE_HEADER(arg1634_3066, 0), BUNSPEC);
					   }
					}
					{
					   object_t aux_5427;
					   aux_5427 = (object_t) (new1326_3065);
					   OBJECT_WIDENING_SET(aux_5427, BFALSE);
					}
					((((stop_t) CREF(new1326_3065))->value) = ((cop_t) cop_1960), BUNSPEC);
					res2560_3070 = new1326_3065;
				     }
				     body_1918 = res2560_3070;
				  }
			       }
			       {
				  csequence_t arg2203_1919;
				  {
				     obj_t arg2204_1920;
				     {
					obj_t arg2205_1921;
					{
					   obj_t arg2207_1922;
					   {
					      obj_t list2208_1923;
					      {
						 obj_t aux_5431;
						 aux_5431 = (obj_t) (body_1918);
						 list2208_1923 = MAKE_PAIR(aux_5431, BNIL);
					      }
					      arg2207_1922 = list2208_1923;
					   }
					   arg2205_1921 = append_2_18___r4_pairs_and_lists_6_3(sets_1917, arg2207_1922);
					}
					{
					   obj_t aux_5435;
					   aux_5435 = (obj_t) (decls_1916);
					   arg2204_1920 = MAKE_PAIR(aux_5435, arg2205_1921);
					}
				     }
				     {
					csequence_t res2561_3082;
					{
					   csequence_t new1317_3076;
					   new1317_3076 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
					   {
					      long arg1642_3077;
					      arg1642_3077 = class_num_218___object(csequence_cgen_cop);
					      {
						 obj_t obj_3080;
						 obj_3080 = (obj_t) (new1317_3076);
						 (((obj_t) CREF(obj_3080))->header = MAKE_HEADER(arg1642_3077, 0), BUNSPEC);
					      }
					   }
					   {
					      object_t aux_5442;
					      aux_5442 = (object_t) (new1317_3076);
					      OBJECT_WIDENING_SET(aux_5442, BFALSE);
					   }
					   ((((csequence_t) CREF(new1317_3076))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					   ((((csequence_t) CREF(new1317_3076))->cops) = ((obj_t) arg2204_1920), BUNSPEC);
					   res2561_3082 = new1317_3076;
					}
					arg2203_1919 = res2561_3082;
				     }
				  }
				  aux_4187 = PROCEDURE_ENTRY(__block_kont__38_cgen_cgen) (__block_kont__38_cgen_cgen, (obj_t) (arg2203_1919), BEOA);
			       }
			    }
			 }
			 break;
		      case ((long) 13):
			 {
			    set_ex_it_116_t node_1962;
			    node_1962 = (set_ex_it_116_t) (node_9);
			    {
			       bool_t test2233_1964;
			       {
				  obj_t aux_5451;
				  aux_5451 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2233_1964 = CBOOL(aux_5451);
			       }
			       if (test2233_1964)
				 {
				    obj_t arg2235_1966;
				    arg2235_1966 = shape_tools_shape((obj_t) (node_1962));
				    {
				       obj_t list2237_1968;
				       {
					  obj_t arg2242_1969;
					  {
					     obj_t arg2243_1970;
					     {
						obj_t arg2244_1971;
						{
						   obj_t arg2245_1972;
						   {
						      obj_t arg2246_1973;
						      {
							 obj_t aux_5459;
							 aux_5459 = BCHAR(((unsigned char) '\n'));
							 arg2246_1973 = MAKE_PAIR(aux_5459, BNIL);
						      }
						      arg2245_1972 = MAKE_PAIR(kont_10, arg2246_1973);
						   }
						   arg2244_1971 = MAKE_PAIR(string2635_cgen_cgen, arg2245_1972);
						}
						{
						   obj_t aux_5464;
						   aux_5464 = BCHAR(((unsigned char) '\n'));
						   arg2243_1970 = MAKE_PAIR(aux_5464, arg2244_1971);
						}
					     }
					     arg2242_1969 = MAKE_PAIR(arg2235_1966, arg2243_1970);
					  }
					  list2237_1968 = MAKE_PAIR(string2652_cgen_cgen, arg2242_1969);
				       }
				       print_trace_107_tools_trace(list2237_1968);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       variable_t exit_1978;
			       {
				  var_t arg2299_2020;
				  arg2299_2020 = (((set_ex_it_116_t) CREF(node_1962))->var);
				  exit_1978 = (((var_t) CREF(arg2299_2020))->variable);
			       }
			       set_variable_name__102_cgen_prototype((obj_t) (exit_1978));
			       {
				  obj_t arg2250_1979;
				  {
				     cpragma_t arg2251_1980;
				     local_var_164_t arg2252_1981;
				     cset_ex_it_123_t arg2254_1982;
				     {
					cpragma_t res2562_3093;
					{
					   obj_t format_3085;
					   format_3085 = string2653_cgen_cgen;
					   {
					      cpragma_t new1309_3087;
					      new1309_3087 = ((cpragma_t) BREF(GC_MALLOC(sizeof(struct cpragma))));
					      {
						 long arg1646_3088;
						 arg1646_3088 = class_num_218___object(cpragma_cgen_cop);
						 {
						    obj_t obj_3091;
						    obj_3091 = (obj_t) (new1309_3087);
						    (((obj_t) CREF(obj_3091))->header = MAKE_HEADER(arg1646_3088, 0), BUNSPEC);
						 }
					      }
					      {
						 object_t aux_5478;
						 aux_5478 = (object_t) (new1309_3087);
						 OBJECT_WIDENING_SET(aux_5478, BFALSE);
					      }
					      ((((cpragma_t) CREF(new1309_3087))->format) = ((obj_t) format_3085), BUNSPEC);
					      ((((cpragma_t) CREF(new1309_3087))->args) = ((obj_t) BNIL), BUNSPEC);
					      res2562_3093 = new1309_3087;
					   }
					}
					arg2251_1980 = res2562_3093;
				     }
				     {
					obj_t arg2261_1989;
					{
					   obj_t list2263_1991;
					   {
					      obj_t aux_5483;
					      {
						 variable_t aux_5484;
						 {
						    var_t arg2265_1993;
						    arg2265_1993 = (((set_ex_it_116_t) CREF(node_1962))->var);
						    aux_5484 = (((var_t) CREF(arg2265_1993))->variable);
						 }
						 aux_5483 = (obj_t) (aux_5484);
					      }
					      list2263_1991 = MAKE_PAIR(aux_5483, BNIL);
					   }
					   arg2261_1989 = list2263_1991;
					}
					{
					   local_var_164_t res2563_3103;
					   {
					      local_var_164_t new1342_3098;
					      new1342_3098 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
					      {
						 long arg1621_3099;
						 arg1621_3099 = class_num_218___object(local_var_164_cgen_cop);
						 {
						    obj_t obj_3101;
						    obj_3101 = (obj_t) (new1342_3098);
						    (((obj_t) CREF(obj_3101))->header = MAKE_HEADER(arg1621_3099, 0), BUNSPEC);
						 }
					      }
					      {
						 object_t aux_5493;
						 aux_5493 = (object_t) (new1342_3098);
						 OBJECT_WIDENING_SET(aux_5493, BFALSE);
					      }
					      ((((local_var_164_t) CREF(new1342_3098))->vars) = ((obj_t) arg2261_1989), BUNSPEC);
					      res2563_3103 = new1342_3098;
					   }
					   arg2252_1981 = res2563_3103;
					}
				     }
				     {
					varc_t arg2266_1994;
					cop_t arg2267_1995;
					csequence_t arg2269_1996;
					{
					   varc_t res2564_3110;
					   {
					      varc_t new1305_3105;
					      new1305_3105 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
					      {
						 long arg1648_3106;
						 arg1648_3106 = class_num_218___object(varc_cgen_cop);
						 {
						    obj_t obj_3108;
						    obj_3108 = (obj_t) (new1305_3105);
						    (((obj_t) CREF(obj_3108))->header = MAKE_HEADER(arg1648_3106, 0), BUNSPEC);
						 }
					      }
					      {
						 object_t aux_5501;
						 aux_5501 = (object_t) (new1305_3105);
						 OBJECT_WIDENING_SET(aux_5501, BFALSE);
					      }
					      ((((varc_t) CREF(new1305_3105))->variable) = ((variable_t) exit_1978), BUNSPEC);
					      res2564_3110 = new1305_3105;
					   }
					   arg2266_1994 = res2564_3110;
					}
					{
					   pragma_t arg2270_1997;
					   {
					      pragma_t res2565_3125;
					      {
						 obj_t loc_3111;
						 type_t type_3112;
						 obj_t format_3114;
						 loc_3111 = BFALSE;
						 type_3112 = (type_t) (_____74_type_cache);
						 format_3114 = string2654_cgen_cgen;
						 {
						    pragma_t new1176_3116;
						    new1176_3116 = ((pragma_t) BREF(GC_MALLOC(sizeof(struct pragma))));
						    {
						       long arg1701_3117;
						       arg1701_3117 = class_num_218___object(pragma_ast_node);
						       {
							  obj_t obj_3123;
							  obj_3123 = (obj_t) (new1176_3116);
							  (((obj_t) CREF(obj_3123))->header = MAKE_HEADER(arg1701_3117, 0), BUNSPEC);
						       }
						    }
						    {
						       object_t aux_5510;
						       aux_5510 = (object_t) (new1176_3116);
						       OBJECT_WIDENING_SET(aux_5510, loc_3111);
						    }
						    ((((pragma_t) CREF(new1176_3116))->loc) = ((obj_t) loc_3111), BUNSPEC);
						    ((((pragma_t) CREF(new1176_3116))->type) = ((type_t) type_3112), BUNSPEC);
						    ((((pragma_t) CREF(new1176_3116))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
						    ((((pragma_t) CREF(new1176_3116))->format) = ((obj_t) format_3114), BUNSPEC);
						    ((((pragma_t) CREF(new1176_3116))->args) = ((obj_t) BNIL), BUNSPEC);
						    res2565_3125 = new1176_3116;
						 }
					      }
					      arg2270_1997 = res2565_3125;
					   }
					   arg2267_1995 = node__cop_142_cgen_cgen((node_t) (arg2270_1997), kont_10);
					}
					{
					   obj_t arg2273_2000;
					   {
					      cop_t arg2274_2001;
					      cop_t arg2280_2002;
					      {
						 setq_t arg2285_2006;
						 {
						    pragma_t arg2286_2007;
						    {
						       obj_t arg2287_2008;
						       {
							  obj_t arg2290_2011;
							  {
							     obj_t aux_5520;
							     {
								type_t arg2297_2018;
								{
								   local_t obj_3126;
								   obj_3126 = (local_t) (exit_1978);
								   arg2297_2018 = (((local_t) CREF(obj_3126))->type);
								}
								aux_5520 = (((type_t) CREF(arg2297_2018))->name);
							     }
							     arg2290_2011 = string_sans___40_type_tools(aux_5520);
							  }
							  {
							     obj_t list2292_2013;
							     {
								obj_t arg2293_2014;
								{
								   obj_t arg2294_2015;
								   arg2294_2015 = MAKE_PAIR(string2655_cgen_cgen, BNIL);
								   arg2293_2014 = MAKE_PAIR(arg2290_2011, arg2294_2015);
								}
								list2292_2013 = MAKE_PAIR(string2656_cgen_cgen, arg2293_2014);
							     }
							     arg2287_2008 = string_append_106___r4_strings_6_7(list2292_2013);
							  }
						       }
						       {
							  pragma_t res2566_3142;
							  {
							     obj_t loc_3128;
							     type_t type_3129;
							     loc_3128 = BFALSE;
							     type_3129 = (type_t) (_____74_type_cache);
							     {
								pragma_t new1176_3133;
								new1176_3133 = ((pragma_t) BREF(GC_MALLOC(sizeof(struct pragma))));
								{
								   long arg1701_3134;
								   arg1701_3134 = class_num_218___object(pragma_ast_node);
								   {
								      obj_t obj_3140;
								      obj_3140 = (obj_t) (new1176_3133);
								      (((obj_t) CREF(obj_3140))->header = MAKE_HEADER(arg1701_3134, 0), BUNSPEC);
								   }
								}
								{
								   object_t aux_5534;
								   aux_5534 = (object_t) (new1176_3133);
								   OBJECT_WIDENING_SET(aux_5534, loc_3128);
								}
								((((pragma_t) CREF(new1176_3133))->loc) = ((obj_t) loc_3128), BUNSPEC);
								((((pragma_t) CREF(new1176_3133))->type) = ((type_t) type_3129), BUNSPEC);
								((((pragma_t) CREF(new1176_3133))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
								((((pragma_t) CREF(new1176_3133))->format) = ((obj_t) arg2287_2008), BUNSPEC);
								((((pragma_t) CREF(new1176_3133))->args) = ((obj_t) BNIL), BUNSPEC);
								res2566_3142 = new1176_3133;
							     }
							  }
							  arg2286_2007 = res2566_3142;
						       }
						    }
						    {
						       setq_t res2569_3172;
						       {
							  node_t value_3144;
							  value_3144 = (node_t) (arg2286_2007);
							  {
							     var_t arg1585_3145;
							     {
								type_t arg1587_3146;
								arg1587_3146 = (((variable_t) CREF(exit_1978))->type);
								{
								   var_t res2567_3158;
								   {
								      obj_t loc_3148;
								      loc_3148 = BFALSE;
								      {
									 var_t new1129_3151;
									 new1129_3151 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
									 {
									    long arg1716_3152;
									    arg1716_3152 = class_num_218___object(var_ast_node);
									    {
									       obj_t obj_3156;
									       obj_3156 = (obj_t) (new1129_3151);
									       (((obj_t) CREF(obj_3156))->header = MAKE_HEADER(arg1716_3152, 0), BUNSPEC);
									    }
									 }
									 {
									    object_t aux_5548;
									    aux_5548 = (object_t) (new1129_3151);
									    OBJECT_WIDENING_SET(aux_5548, loc_3148);
									 }
									 ((((var_t) CREF(new1129_3151))->loc) = ((obj_t) loc_3148), BUNSPEC);
									 ((((var_t) CREF(new1129_3151))->type) = ((type_t) arg1587_3146), BUNSPEC);
									 ((((var_t) CREF(new1129_3151))->variable) = ((variable_t) exit_1978), BUNSPEC);
									 res2567_3158 = new1129_3151;
								      }
								   }
								   arg1585_3145 = res2567_3158;
								}
							     }
							     {
								setq_t res2568_3171;
								{
								   obj_t loc_3159;
								   type_t type_3160;
								   loc_3159 = BFALSE;
								   type_3160 = (type_t) (__unspec__87_type_cache);
								   {
								      setq_t new1189_3163;
								      new1189_3163 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
								      {
									 long arg1696_3164;
									 arg1696_3164 = class_num_218___object(setq_ast_node);
									 {
									    obj_t obj_3169;
									    obj_3169 = (obj_t) (new1189_3163);
									    (((obj_t) CREF(obj_3169))->header = MAKE_HEADER(arg1696_3164, 0), BUNSPEC);
									 }
								      }
								      {
									 object_t aux_5559;
									 aux_5559 = (object_t) (new1189_3163);
									 OBJECT_WIDENING_SET(aux_5559, loc_3159);
								      }
								      ((((setq_t) CREF(new1189_3163))->loc) = ((obj_t) loc_3159), BUNSPEC);
								      ((((setq_t) CREF(new1189_3163))->type) = ((type_t) type_3160), BUNSPEC);
								      ((((setq_t) CREF(new1189_3163))->var) = ((var_t) arg1585_3145), BUNSPEC);
								      ((((setq_t) CREF(new1189_3163))->value) = ((node_t) value_3144), BUNSPEC);
								      res2568_3171 = new1189_3163;
								   }
								}
								res2569_3172 = res2568_3171;
							     }
							  }
						       }
						       arg2285_2006 = res2569_3172;
						    }
						 }
						 arg2274_2001 = node__cop_142_cgen_cgen((node_t) (arg2285_2006), __id_kont__126_cgen_cgen);
					      }
					      arg2280_2002 = node__cop_142_cgen_cgen((((set_ex_it_116_t) CREF(node_1962))->body), kont_10);
					      {
						 obj_t list2281_2003;
						 {
						    obj_t arg2283_2004;
						    {
						       obj_t aux_5570;
						       aux_5570 = (obj_t) (arg2280_2002);
						       arg2283_2004 = MAKE_PAIR(aux_5570, BNIL);
						    }
						    {
						       obj_t aux_5573;
						       aux_5573 = (obj_t) (arg2274_2001);
						       list2281_2003 = MAKE_PAIR(aux_5573, arg2283_2004);
						    }
						 }
						 arg2273_2000 = list2281_2003;
					      }
					   }
					   {
					      csequence_t res2570_3183;
					      {
						 csequence_t new1317_3177;
						 new1317_3177 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
						 {
						    long arg1642_3178;
						    arg1642_3178 = class_num_218___object(csequence_cgen_cop);
						    {
						       obj_t obj_3181;
						       obj_3181 = (obj_t) (new1317_3177);
						       (((obj_t) CREF(obj_3181))->header = MAKE_HEADER(arg1642_3178, 0), BUNSPEC);
						    }
						 }
						 {
						    object_t aux_5580;
						    aux_5580 = (object_t) (new1317_3177);
						    OBJECT_WIDENING_SET(aux_5580, BFALSE);
						 }
						 ((((csequence_t) CREF(new1317_3177))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						 ((((csequence_t) CREF(new1317_3177))->cops) = ((obj_t) arg2273_2000), BUNSPEC);
						 res2570_3183 = new1317_3177;
					      }
					      arg2269_1996 = res2570_3183;
					   }
					}
					{
					   cset_ex_it_123_t res2571_3194;
					   {
					      cop_t exit_3184;
					      cop_t body_3186;
					      exit_3184 = (cop_t) (arg2266_1994);
					      body_3186 = (cop_t) (arg2269_1996);
					      {
						 cset_ex_it_123_t new1379_3187;
						 new1379_3187 = ((cset_ex_it_123_t) BREF(GC_MALLOC(sizeof(struct cset_ex_it_123))));
						 {
						    long arg1595_3188;
						    arg1595_3188 = class_num_218___object(cset_ex_it_123_cgen_cop);
						    {
						       obj_t obj_3192;
						       obj_3192 = (obj_t) (new1379_3187);
						       (((obj_t) CREF(obj_3192))->header = MAKE_HEADER(arg1595_3188, 0), BUNSPEC);
						    }
						 }
						 {
						    object_t aux_5591;
						    aux_5591 = (object_t) (new1379_3187);
						    OBJECT_WIDENING_SET(aux_5591, BFALSE);
						 }
						 ((((cset_ex_it_123_t) CREF(new1379_3187))->exit) = ((cop_t) exit_3184), BUNSPEC);
						 ((((cset_ex_it_123_t) CREF(new1379_3187))->jump_value_221) = ((cop_t) arg2267_1995), BUNSPEC);
						 ((((cset_ex_it_123_t) CREF(new1379_3187))->body) = ((cop_t) body_3186), BUNSPEC);
						 res2571_3194 = new1379_3187;
					      }
					   }
					   arg2254_1982 = res2571_3194;
					}
				     }
				     {
					obj_t list2255_1983;
					{
					   obj_t arg2256_1984;
					   {
					      obj_t arg2257_1985;
					      {
						 obj_t aux_5597;
						 aux_5597 = (obj_t) (arg2254_1982);
						 arg2257_1985 = MAKE_PAIR(aux_5597, BNIL);
					      }
					      {
						 obj_t aux_5600;
						 aux_5600 = (obj_t) (arg2252_1981);
						 arg2256_1984 = MAKE_PAIR(aux_5600, arg2257_1985);
					      }
					   }
					   {
					      obj_t aux_5603;
					      aux_5603 = (obj_t) (arg2251_1980);
					      list2255_1983 = MAKE_PAIR(aux_5603, arg2256_1984);
					   }
					}
					arg2250_1979 = list2255_1983;
				     }
				  }
				  {
				     csequence_t res2572_3204;
				     {
					csequence_t new1317_3198;
					new1317_3198 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
					{
					   long arg1642_3199;
					   arg1642_3199 = class_num_218___object(csequence_cgen_cop);
					   {
					      obj_t obj_3202;
					      obj_3202 = (obj_t) (new1317_3198);
					      (((obj_t) CREF(obj_3202))->header = MAKE_HEADER(arg1642_3199, 0), BUNSPEC);
					   }
					}
					{
					   object_t aux_5610;
					   aux_5610 = (object_t) (new1317_3198);
					   OBJECT_WIDENING_SET(aux_5610, BFALSE);
					}
					((((csequence_t) CREF(new1317_3198))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					((((csequence_t) CREF(new1317_3198))->cops) = ((obj_t) arg2250_1979), BUNSPEC);
					res2572_3204 = new1317_3198;
				     }
				     aux_4187 = (obj_t) (res2572_3204);
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 14):
			 {
			    jump_ex_it_184_t node_2021;
			    node_2021 = (jump_ex_it_184_t) (node_9);
			    {
			       bool_t test2300_2023;
			       {
				  obj_t aux_5617;
				  aux_5617 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2300_2023 = CBOOL(aux_5617);
			       }
			       if (test2300_2023)
				 {
				    obj_t arg2302_2025;
				    arg2302_2025 = shape_tools_shape((obj_t) (node_2021));
				    {
				       obj_t list2304_2027;
				       {
					  obj_t arg2305_2028;
					  {
					     obj_t arg2306_2029;
					     {
						obj_t arg2307_2030;
						{
						   obj_t arg2308_2031;
						   {
						      obj_t arg2309_2032;
						      {
							 obj_t aux_5625;
							 aux_5625 = BCHAR(((unsigned char) '\n'));
							 arg2309_2032 = MAKE_PAIR(aux_5625, BNIL);
						      }
						      arg2308_2031 = MAKE_PAIR(kont_10, arg2309_2032);
						   }
						   arg2307_2030 = MAKE_PAIR(string2635_cgen_cgen, arg2308_2031);
						}
						{
						   obj_t aux_5630;
						   aux_5630 = BCHAR(((unsigned char) '\n'));
						   arg2306_2029 = MAKE_PAIR(aux_5630, arg2307_2030);
						}
					     }
					     arg2305_2028 = MAKE_PAIR(arg2302_2025, arg2306_2029);
					  }
					  list2304_2027 = MAKE_PAIR(string2657_cgen_cgen, arg2305_2028);
				       }
				       print_trace_107_tools_trace(list2304_2027);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       local_t vaux_2037;
			       {
				  obj_t arg2395_2121;
				  arg2395_2121 = CNST_TABLE_REF(((long) 2));
				  {
				     local_t res2573_3208;
				     {
					type_t type_3206;
					type_3206 = (type_t) (__obj__252_type_cache);
					{
					   local_t local_3207;
					   local_3207 = make_local_svar_140_ast_local(arg2395_2121, type_3206);
					   set_variable_name__102_cgen_prototype((obj_t) (local_3207));
					   res2573_3208 = local_3207;
					}
				     }
				     vaux_2037 = res2573_3208;
				  }
			       }
			       {
				  cop_t vcop_2038;
				  {
				     setq_t arg2393_2119;
				     {
					node_t arg2394_2120;
					arg2394_2120 = (((jump_ex_it_184_t) CREF(node_2021))->value);
					{
					   setq_t res2576_3239;
					   {
					      variable_t variable_3210;
					      variable_3210 = (variable_t) (vaux_2037);
					      {
						 var_t arg1585_3212;
						 {
						    type_t arg1587_3213;
						    arg1587_3213 = (((variable_t) CREF(variable_3210))->type);
						    {
						       var_t res2574_3225;
						       {
							  obj_t loc_3215;
							  loc_3215 = BFALSE;
							  {
							     var_t new1129_3218;
							     new1129_3218 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
							     {
								long arg1716_3219;
								arg1716_3219 = class_num_218___object(var_ast_node);
								{
								   obj_t obj_3223;
								   obj_3223 = (obj_t) (new1129_3218);
								   (((obj_t) CREF(obj_3223))->header = MAKE_HEADER(arg1716_3219, 0), BUNSPEC);
								}
							     }
							     {
								object_t aux_5648;
								aux_5648 = (object_t) (new1129_3218);
								OBJECT_WIDENING_SET(aux_5648, loc_3215);
							     }
							     ((((var_t) CREF(new1129_3218))->loc) = ((obj_t) loc_3215), BUNSPEC);
							     ((((var_t) CREF(new1129_3218))->type) = ((type_t) arg1587_3213), BUNSPEC);
							     ((((var_t) CREF(new1129_3218))->variable) = ((variable_t) variable_3210), BUNSPEC);
							     res2574_3225 = new1129_3218;
							  }
						       }
						       arg1585_3212 = res2574_3225;
						    }
						 }
						 {
						    setq_t res2575_3238;
						    {
						       obj_t loc_3226;
						       type_t type_3227;
						       loc_3226 = BFALSE;
						       type_3227 = (type_t) (__unspec__87_type_cache);
						       {
							  setq_t new1189_3230;
							  new1189_3230 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
							  {
							     long arg1696_3231;
							     arg1696_3231 = class_num_218___object(setq_ast_node);
							     {
								obj_t obj_3236;
								obj_3236 = (obj_t) (new1189_3230);
								(((obj_t) CREF(obj_3236))->header = MAKE_HEADER(arg1696_3231, 0), BUNSPEC);
							     }
							  }
							  {
							     object_t aux_5659;
							     aux_5659 = (object_t) (new1189_3230);
							     OBJECT_WIDENING_SET(aux_5659, loc_3226);
							  }
							  ((((setq_t) CREF(new1189_3230))->loc) = ((obj_t) loc_3226), BUNSPEC);
							  ((((setq_t) CREF(new1189_3230))->type) = ((type_t) type_3227), BUNSPEC);
							  ((((setq_t) CREF(new1189_3230))->var) = ((var_t) arg1585_3212), BUNSPEC);
							  ((((setq_t) CREF(new1189_3230))->value) = ((node_t) arg2394_2120), BUNSPEC);
							  res2575_3238 = new1189_3230;
						       }
						    }
						    res2576_3239 = res2575_3238;
						 }
					      }
					   }
					   arg2393_2119 = res2576_3239;
					}
				     }
				     vcop_2038 = node__cop_142_cgen_cgen((node_t) (arg2393_2119), __id_kont__126_cgen_cgen);
				  }
				  {
				     node_t exit_2039;
				     exit_2039 = (((jump_ex_it_184_t) CREF(node_2021))->exit);
				     {
					local_t eaux_2040;
					{
					   obj_t arg2392_2118;
					   arg2392_2118 = CNST_TABLE_REF(((long) 4));
					   {
					      local_t res2577_3244;
					      {
						 type_t type_3242;
						 type_3242 = (type_t) (__procedure__226_type_cache);
						 {
						    local_t local_3243;
						    local_3243 = make_local_svar_140_ast_local(arg2392_2118, type_3242);
						    set_variable_name__102_cgen_prototype((obj_t) (local_3243));
						    res2577_3244 = local_3243;
						 }
					      }
					      eaux_2040 = res2577_3244;
					   }
					}
					{
					   cop_t ecop_2041;
					   {
					      setq_t arg2391_2117;
					      {
						 setq_t res2580_3274;
						 {
						    variable_t variable_3245;
						    variable_3245 = (variable_t) (eaux_2040);
						    {
						       var_t arg1585_3247;
						       {
							  type_t arg1587_3248;
							  arg1587_3248 = (((variable_t) CREF(variable_3245))->type);
							  {
							     var_t res2578_3260;
							     {
								obj_t loc_3250;
								loc_3250 = BFALSE;
								{
								   var_t new1129_3253;
								   new1129_3253 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
								   {
								      long arg1716_3254;
								      arg1716_3254 = class_num_218___object(var_ast_node);
								      {
									 obj_t obj_3258;
									 obj_3258 = (obj_t) (new1129_3253);
									 (((obj_t) CREF(obj_3258))->header = MAKE_HEADER(arg1716_3254, 0), BUNSPEC);
								      }
								   }
								   {
								      object_t aux_5680;
								      aux_5680 = (object_t) (new1129_3253);
								      OBJECT_WIDENING_SET(aux_5680, loc_3250);
								   }
								   ((((var_t) CREF(new1129_3253))->loc) = ((obj_t) loc_3250), BUNSPEC);
								   ((((var_t) CREF(new1129_3253))->type) = ((type_t) arg1587_3248), BUNSPEC);
								   ((((var_t) CREF(new1129_3253))->variable) = ((variable_t) variable_3245), BUNSPEC);
								   res2578_3260 = new1129_3253;
								}
							     }
							     arg1585_3247 = res2578_3260;
							  }
						       }
						       {
							  setq_t res2579_3273;
							  {
							     obj_t loc_3261;
							     type_t type_3262;
							     loc_3261 = BFALSE;
							     type_3262 = (type_t) (__unspec__87_type_cache);
							     {
								setq_t new1189_3265;
								new1189_3265 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
								{
								   long arg1696_3266;
								   arg1696_3266 = class_num_218___object(setq_ast_node);
								   {
								      obj_t obj_3271;
								      obj_3271 = (obj_t) (new1189_3265);
								      (((obj_t) CREF(obj_3271))->header = MAKE_HEADER(arg1696_3266, 0), BUNSPEC);
								   }
								}
								{
								   object_t aux_5691;
								   aux_5691 = (object_t) (new1189_3265);
								   OBJECT_WIDENING_SET(aux_5691, loc_3261);
								}
								((((setq_t) CREF(new1189_3265))->loc) = ((obj_t) loc_3261), BUNSPEC);
								((((setq_t) CREF(new1189_3265))->type) = ((type_t) type_3262), BUNSPEC);
								((((setq_t) CREF(new1189_3265))->var) = ((var_t) arg1585_3247), BUNSPEC);
								((((setq_t) CREF(new1189_3265))->value) = ((node_t) exit_2039), BUNSPEC);
								res2579_3273 = new1189_3265;
							     }
							  }
							  res2580_3274 = res2579_3273;
						       }
						    }
						 }
						 arg2391_2117 = res2580_3274;
					      }
					      ecop_2041 = node__cop_142_cgen_cgen((node_t) (arg2391_2117), __id_kont__126_cgen_cgen);
					   }
					   {
					      {
						 bool_t test2313_2042;
						 {
						    bool_t test2384_2110;
						    test2384_2110 = is_a__118___object((obj_t) (vcop_2038), csetq_cgen_cop);
						    if (test2384_2110)
						      {
							 bool_t test_5703;
							 {
							    obj_t aux_5710;
							    obj_t aux_5704;
							    aux_5710 = (obj_t) (vaux_2037);
							    {
							       variable_t aux_5705;
							       {
								  varc_t arg2390_2116;
								  {
								     csetq_t obj_3276;
								     obj_3276 = (csetq_t) (vcop_2038);
								     arg2390_2116 = (((csetq_t) CREF(obj_3276))->var);
								  }
								  aux_5705 = (((varc_t) CREF(arg2390_2116))->variable);
							       }
							       aux_5704 = (obj_t) (aux_5705);
							    }
							    test_5703 = (aux_5704 == aux_5710);
							 }
							 if (test_5703)
							   {
							      bool_t test2386_2112;
							      test2386_2112 = is_a__118___object((obj_t) (ecop_2041), csetq_cgen_cop);
							      if (test2386_2112)
								{
								   obj_t aux_5722;
								   obj_t aux_5716;
								   aux_5722 = (obj_t) (eaux_2040);
								   {
								      variable_t aux_5717;
								      {
									 varc_t arg2388_2114;
									 {
									    csetq_t obj_3281;
									    obj_3281 = (csetq_t) (ecop_2041);
									    arg2388_2114 = (((csetq_t) CREF(obj_3281))->var);
									 }
									 aux_5717 = (((varc_t) CREF(arg2388_2114))->variable);
								      }
								      aux_5716 = (obj_t) (aux_5717);
								   }
								   test2313_2042 = (aux_5716 == aux_5722);
								}
							      else
								{
								   test2313_2042 = ((bool_t) 0);
								}
							   }
							 else
							   {
							      test2313_2042 = ((bool_t) 0);
							   }
						      }
						    else
						      {
							 test2313_2042 = ((bool_t) 0);
						      }
						 }
						 if (test2313_2042)
						   {
						      {
							 cjump_ex_it_131_t arg2314_2043;
							 {
							    cop_t arg2315_2044;
							    cop_t arg2316_2045;
							    {
							       csetq_t obj_3285;
							       obj_3285 = (csetq_t) (ecop_2041);
							       arg2315_2044 = (((csetq_t) CREF(obj_3285))->value);
							    }
							    {
							       csetq_t obj_3286;
							       obj_3286 = (csetq_t) (vcop_2038);
							       arg2316_2045 = (((csetq_t) CREF(obj_3286))->value);
							    }
							    {
							       cjump_ex_it_131_t res2581_3295;
							       {
								  cjump_ex_it_131_t new1383_3289;
								  new1383_3289 = ((cjump_ex_it_131_t) BREF(GC_MALLOC(sizeof(struct cjump_ex_it_131))));
								  {
								     long arg1592_3290;
								     arg1592_3290 = class_num_218___object(cjump_ex_it_131_cgen_cop);
								     {
									obj_t obj_3293;
									obj_3293 = (obj_t) (new1383_3289);
									(((obj_t) CREF(obj_3293))->header = MAKE_HEADER(arg1592_3290, 0), BUNSPEC);
								     }
								  }
								  {
								     object_t aux_5734;
								     aux_5734 = (object_t) (new1383_3289);
								     OBJECT_WIDENING_SET(aux_5734, BFALSE);
								  }
								  ((((cjump_ex_it_131_t) CREF(new1383_3289))->exit) = ((cop_t) arg2315_2044), BUNSPEC);
								  ((((cjump_ex_it_131_t) CREF(new1383_3289))->value) = ((cop_t) arg2316_2045), BUNSPEC);
								  res2581_3295 = new1383_3289;
							       }
							       arg2314_2043 = res2581_3295;
							    }
							 }
							 aux_4187 = (obj_t) (arg2314_2043);
						      }
						   }
						 else
						   {
						      bool_t test2317_2046;
						      {
							 bool_t test2381_2107;
							 test2381_2107 = is_a__118___object((obj_t) (vcop_2038), csetq_cgen_cop);
							 if (test2381_2107)
							   {
							      obj_t aux_5749;
							      obj_t aux_5743;
							      aux_5749 = (obj_t) (vaux_2037);
							      {
								 variable_t aux_5744;
								 {
								    varc_t arg2383_2109;
								    {
								       csetq_t obj_3298;
								       obj_3298 = (csetq_t) (vcop_2038);
								       arg2383_2109 = (((csetq_t) CREF(obj_3298))->var);
								    }
								    aux_5744 = (((varc_t) CREF(arg2383_2109))->variable);
								 }
								 aux_5743 = (obj_t) (aux_5744);
							      }
							      test2317_2046 = (aux_5743 == aux_5749);
							   }
							 else
							   {
							      test2317_2046 = ((bool_t) 0);
							   }
						      }
						      if (test2317_2046)
							{
							   {
							      csequence_t arg2318_2047;
							      {
								 obj_t arg2319_2048;
								 {
								    local_var_164_t arg2320_2049;
								    csequence_t arg2321_2050;
								    cjump_ex_it_131_t arg2322_2051;
								    {
								       obj_t arg2327_2056;
								       {
									  obj_t list2328_2057;
									  {
									     obj_t aux_5753;
									     aux_5753 = (obj_t) (eaux_2040);
									     list2328_2057 = MAKE_PAIR(aux_5753, BNIL);
									  }
									  arg2327_2056 = list2328_2057;
								       }
								       {
									  local_var_164_t res2582_3309;
									  {
									     local_var_164_t new1342_3304;
									     new1342_3304 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
									     {
										long arg1621_3305;
										arg1621_3305 = class_num_218___object(local_var_164_cgen_cop);
										{
										   obj_t obj_3307;
										   obj_3307 = (obj_t) (new1342_3304);
										   (((obj_t) CREF(obj_3307))->header = MAKE_HEADER(arg1621_3305, 0), BUNSPEC);
										}
									     }
									     {
										object_t aux_5760;
										aux_5760 = (object_t) (new1342_3304);
										OBJECT_WIDENING_SET(aux_5760, BFALSE);
									     }
									     ((((local_var_164_t) CREF(new1342_3304))->vars) = ((obj_t) arg2327_2056), BUNSPEC);
									     res2582_3309 = new1342_3304;
									  }
									  arg2320_2049 = res2582_3309;
								       }
								    }
								    {
								       obj_t arg2330_2059;
								       {
									  obj_t list2331_2060;
									  {
									     obj_t aux_5764;
									     aux_5764 = (obj_t) (ecop_2041);
									     list2331_2060 = MAKE_PAIR(aux_5764, BNIL);
									  }
									  arg2330_2059 = list2331_2060;
								       }
								       {
									  csequence_t res2583_3319;
									  {
									     csequence_t new1317_3313;
									     new1317_3313 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
									     {
										long arg1642_3314;
										arg1642_3314 = class_num_218___object(csequence_cgen_cop);
										{
										   obj_t obj_3317;
										   obj_3317 = (obj_t) (new1317_3313);
										   (((obj_t) CREF(obj_3317))->header = MAKE_HEADER(arg1642_3314, 0), BUNSPEC);
										}
									     }
									     {
										object_t aux_5771;
										aux_5771 = (object_t) (new1317_3313);
										OBJECT_WIDENING_SET(aux_5771, BFALSE);
									     }
									     ((((csequence_t) CREF(new1317_3313))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
									     ((((csequence_t) CREF(new1317_3313))->cops) = ((obj_t) arg2330_2059), BUNSPEC);
									     res2583_3319 = new1317_3313;
									  }
									  arg2321_2050 = res2583_3319;
								       }
								    }
								    {
								       cjump_ex_it_131_t arg2334_2062;
								       {
									  varc_t arg2335_2063;
									  cop_t arg2336_2064;
									  {
									     varc_t res2584_3326;
									     {
										variable_t variable_3320;
										variable_3320 = (variable_t) (eaux_2040);
										{
										   varc_t new1305_3321;
										   new1305_3321 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
										   {
										      long arg1648_3322;
										      arg1648_3322 = class_num_218___object(varc_cgen_cop);
										      {
											 obj_t obj_3324;
											 obj_3324 = (obj_t) (new1305_3321);
											 (((obj_t) CREF(obj_3324))->header = MAKE_HEADER(arg1648_3322, 0), BUNSPEC);
										      }
										   }
										   {
										      object_t aux_5781;
										      aux_5781 = (object_t) (new1305_3321);
										      OBJECT_WIDENING_SET(aux_5781, BFALSE);
										   }
										   ((((varc_t) CREF(new1305_3321))->variable) = ((variable_t) variable_3320), BUNSPEC);
										   res2584_3326 = new1305_3321;
										}
									     }
									     arg2335_2063 = res2584_3326;
									  }
									  {
									     csetq_t obj_3327;
									     obj_3327 = (csetq_t) (vcop_2038);
									     arg2336_2064 = (((csetq_t) CREF(obj_3327))->value);
									  }
									  {
									     cjump_ex_it_131_t res2585_3336;
									     {
										cop_t exit_3328;
										exit_3328 = (cop_t) (arg2335_2063);
										{
										   cjump_ex_it_131_t new1383_3330;
										   new1383_3330 = ((cjump_ex_it_131_t) BREF(GC_MALLOC(sizeof(struct cjump_ex_it_131))));
										   {
										      long arg1592_3331;
										      arg1592_3331 = class_num_218___object(cjump_ex_it_131_cgen_cop);
										      {
											 obj_t obj_3334;
											 obj_3334 = (obj_t) (new1383_3330);
											 (((obj_t) CREF(obj_3334))->header = MAKE_HEADER(arg1592_3331, 0), BUNSPEC);
										      }
										   }
										   {
										      object_t aux_5792;
										      aux_5792 = (object_t) (new1383_3330);
										      OBJECT_WIDENING_SET(aux_5792, BFALSE);
										   }
										   ((((cjump_ex_it_131_t) CREF(new1383_3330))->exit) = ((cop_t) exit_3328), BUNSPEC);
										   ((((cjump_ex_it_131_t) CREF(new1383_3330))->value) = ((cop_t) arg2336_2064), BUNSPEC);
										   res2585_3336 = new1383_3330;
										}
									     }
									     arg2334_2062 = res2585_3336;
									  }
								       }
								       arg2322_2051 = arg2334_2062;
								    }
								    {
								       obj_t list2323_2052;
								       {
									  obj_t arg2324_2053;
									  {
									     obj_t arg2325_2054;
									     {
										obj_t aux_5797;
										aux_5797 = (obj_t) (arg2322_2051);
										arg2325_2054 = MAKE_PAIR(aux_5797, BNIL);
									     }
									     {
										obj_t aux_5800;
										aux_5800 = (obj_t) (arg2321_2050);
										arg2324_2053 = MAKE_PAIR(aux_5800, arg2325_2054);
									     }
									  }
									  {
									     obj_t aux_5803;
									     aux_5803 = (obj_t) (arg2320_2049);
									     list2323_2052 = MAKE_PAIR(aux_5803, arg2324_2053);
									  }
								       }
								       arg2319_2048 = list2323_2052;
								    }
								 }
								 {
								    csequence_t res2586_3347;
								    {
								       csequence_t new1317_3341;
								       new1317_3341 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
								       {
									  long arg1642_3342;
									  arg1642_3342 = class_num_218___object(csequence_cgen_cop);
									  {
									     obj_t obj_3345;
									     obj_3345 = (obj_t) (new1317_3341);
									     (((obj_t) CREF(obj_3345))->header = MAKE_HEADER(arg1642_3342, 0), BUNSPEC);
									  }
								       }
								       {
									  object_t aux_5810;
									  aux_5810 = (object_t) (new1317_3341);
									  OBJECT_WIDENING_SET(aux_5810, BFALSE);
								       }
								       ((((csequence_t) CREF(new1317_3341))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
								       ((((csequence_t) CREF(new1317_3341))->cops) = ((obj_t) arg2319_2048), BUNSPEC);
								       res2586_3347 = new1317_3341;
								    }
								    arg2318_2047 = res2586_3347;
								 }
							      }
							      {
								 block_t res2587_3354;
								 {
								    cop_t body_3348;
								    body_3348 = (cop_t) (arg2318_2047);
								    {
								       block_t new1287_3349;
								       new1287_3349 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
								       {
									  long arg1657_3350;
									  arg1657_3350 = class_num_218___object(block_cgen_cop);
									  {
									     obj_t obj_3352;
									     obj_3352 = (obj_t) (new1287_3349);
									     (((obj_t) CREF(obj_3352))->header = MAKE_HEADER(arg1657_3350, 0), BUNSPEC);
									  }
								       }
								       {
									  object_t aux_5820;
									  aux_5820 = (object_t) (new1287_3349);
									  OBJECT_WIDENING_SET(aux_5820, BFALSE);
								       }
								       ((((block_t) CREF(new1287_3349))->body) = ((cop_t) body_3348), BUNSPEC);
								       res2587_3354 = new1287_3349;
								    }
								 }
								 aux_4187 = (obj_t) (res2587_3354);
							      }
							   }
							}
						      else
							{
							   bool_t test2337_2065;
							   {
							      bool_t test2378_2104;
							      test2378_2104 = is_a__118___object((obj_t) (ecop_2041), csetq_cgen_cop);
							      if (test2378_2104)
								{
								   obj_t aux_5834;
								   obj_t aux_5828;
								   aux_5834 = (obj_t) (eaux_2040);
								   {
								      variable_t aux_5829;
								      {
									 varc_t arg2380_2106;
									 {
									    csetq_t obj_3356;
									    obj_3356 = (csetq_t) (ecop_2041);
									    arg2380_2106 = (((csetq_t) CREF(obj_3356))->var);
									 }
									 aux_5829 = (((varc_t) CREF(arg2380_2106))->variable);
								      }
								      aux_5828 = (obj_t) (aux_5829);
								   }
								   test2337_2065 = (aux_5828 == aux_5834);
								}
							      else
								{
								   test2337_2065 = ((bool_t) 0);
								}
							   }
							   if (test2337_2065)
							     {
								{
								   csequence_t arg2338_2066;
								   {
								      obj_t arg2339_2067;
								      {
									 local_var_164_t arg2341_2068;
									 csequence_t arg2343_2069;
									 cjump_ex_it_131_t arg2344_2070;
									 {
									    obj_t arg2349_2075;
									    {
									       obj_t list2350_2076;
									       {
										  obj_t aux_5838;
										  aux_5838 = (obj_t) (vaux_2037);
										  list2350_2076 = MAKE_PAIR(aux_5838, BNIL);
									       }
									       arg2349_2075 = list2350_2076;
									    }
									    {
									       local_var_164_t res2588_3367;
									       {
										  local_var_164_t new1342_3362;
										  new1342_3362 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
										  {
										     long arg1621_3363;
										     arg1621_3363 = class_num_218___object(local_var_164_cgen_cop);
										     {
											obj_t obj_3365;
											obj_3365 = (obj_t) (new1342_3362);
											(((obj_t) CREF(obj_3365))->header = MAKE_HEADER(arg1621_3363, 0), BUNSPEC);
										     }
										  }
										  {
										     object_t aux_5845;
										     aux_5845 = (object_t) (new1342_3362);
										     OBJECT_WIDENING_SET(aux_5845, BFALSE);
										  }
										  ((((local_var_164_t) CREF(new1342_3362))->vars) = ((obj_t) arg2349_2075), BUNSPEC);
										  res2588_3367 = new1342_3362;
									       }
									       arg2341_2068 = res2588_3367;
									    }
									 }
									 {
									    obj_t arg2352_2078;
									    {
									       obj_t list2353_2079;
									       {
										  obj_t aux_5849;
										  aux_5849 = (obj_t) (vcop_2038);
										  list2353_2079 = MAKE_PAIR(aux_5849, BNIL);
									       }
									       arg2352_2078 = list2353_2079;
									    }
									    {
									       csequence_t res2589_3377;
									       {
										  csequence_t new1317_3371;
										  new1317_3371 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
										  {
										     long arg1642_3372;
										     arg1642_3372 = class_num_218___object(csequence_cgen_cop);
										     {
											obj_t obj_3375;
											obj_3375 = (obj_t) (new1317_3371);
											(((obj_t) CREF(obj_3375))->header = MAKE_HEADER(arg1642_3372, 0), BUNSPEC);
										     }
										  }
										  {
										     object_t aux_5856;
										     aux_5856 = (object_t) (new1317_3371);
										     OBJECT_WIDENING_SET(aux_5856, BFALSE);
										  }
										  ((((csequence_t) CREF(new1317_3371))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
										  ((((csequence_t) CREF(new1317_3371))->cops) = ((obj_t) arg2352_2078), BUNSPEC);
										  res2589_3377 = new1317_3371;
									       }
									       arg2343_2069 = res2589_3377;
									    }
									 }
									 {
									    cjump_ex_it_131_t arg2355_2081;
									    {
									       cop_t arg2356_2082;
									       varc_t arg2357_2083;
									       {
										  csetq_t obj_3378;
										  obj_3378 = (csetq_t) (ecop_2041);
										  arg2356_2082 = (((csetq_t) CREF(obj_3378))->value);
									       }
									       {
										  varc_t res2590_3385;
										  {
										     variable_t variable_3379;
										     variable_3379 = (variable_t) (vaux_2037);
										     {
											varc_t new1305_3380;
											new1305_3380 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
											{
											   long arg1648_3381;
											   arg1648_3381 = class_num_218___object(varc_cgen_cop);
											   {
											      obj_t obj_3383;
											      obj_3383 = (obj_t) (new1305_3380);
											      (((obj_t) CREF(obj_3383))->header = MAKE_HEADER(arg1648_3381, 0), BUNSPEC);
											   }
											}
											{
											   object_t aux_5868;
											   aux_5868 = (object_t) (new1305_3380);
											   OBJECT_WIDENING_SET(aux_5868, BFALSE);
											}
											((((varc_t) CREF(new1305_3380))->variable) = ((variable_t) variable_3379), BUNSPEC);
											res2590_3385 = new1305_3380;
										     }
										  }
										  arg2357_2083 = res2590_3385;
									       }
									       {
										  cjump_ex_it_131_t res2591_3394;
										  {
										     cop_t value_3387;
										     value_3387 = (cop_t) (arg2357_2083);
										     {
											cjump_ex_it_131_t new1383_3388;
											new1383_3388 = ((cjump_ex_it_131_t) BREF(GC_MALLOC(sizeof(struct cjump_ex_it_131))));
											{
											   long arg1592_3389;
											   arg1592_3389 = class_num_218___object(cjump_ex_it_131_cgen_cop);
											   {
											      obj_t obj_3392;
											      obj_3392 = (obj_t) (new1383_3388);
											      (((obj_t) CREF(obj_3392))->header = MAKE_HEADER(arg1592_3389, 0), BUNSPEC);
											   }
											}
											{
											   object_t aux_5877;
											   aux_5877 = (object_t) (new1383_3388);
											   OBJECT_WIDENING_SET(aux_5877, BFALSE);
											}
											((((cjump_ex_it_131_t) CREF(new1383_3388))->exit) = ((cop_t) arg2356_2082), BUNSPEC);
											((((cjump_ex_it_131_t) CREF(new1383_3388))->value) = ((cop_t) value_3387), BUNSPEC);
											res2591_3394 = new1383_3388;
										     }
										  }
										  arg2355_2081 = res2591_3394;
									       }
									    }
									    arg2344_2070 = arg2355_2081;
									 }
									 {
									    obj_t list2345_2071;
									    {
									       obj_t arg2346_2072;
									       {
										  obj_t arg2347_2073;
										  {
										     obj_t aux_5882;
										     aux_5882 = (obj_t) (arg2344_2070);
										     arg2347_2073 = MAKE_PAIR(aux_5882, BNIL);
										  }
										  {
										     obj_t aux_5885;
										     aux_5885 = (obj_t) (arg2343_2069);
										     arg2346_2072 = MAKE_PAIR(aux_5885, arg2347_2073);
										  }
									       }
									       {
										  obj_t aux_5888;
										  aux_5888 = (obj_t) (arg2341_2068);
										  list2345_2071 = MAKE_PAIR(aux_5888, arg2346_2072);
									       }
									    }
									    arg2339_2067 = list2345_2071;
									 }
								      }
								      {
									 csequence_t res2592_3405;
									 {
									    csequence_t new1317_3399;
									    new1317_3399 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
									    {
									       long arg1642_3400;
									       arg1642_3400 = class_num_218___object(csequence_cgen_cop);
									       {
										  obj_t obj_3403;
										  obj_3403 = (obj_t) (new1317_3399);
										  (((obj_t) CREF(obj_3403))->header = MAKE_HEADER(arg1642_3400, 0), BUNSPEC);
									       }
									    }
									    {
									       object_t aux_5895;
									       aux_5895 = (object_t) (new1317_3399);
									       OBJECT_WIDENING_SET(aux_5895, BFALSE);
									    }
									    ((((csequence_t) CREF(new1317_3399))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
									    ((((csequence_t) CREF(new1317_3399))->cops) = ((obj_t) arg2339_2067), BUNSPEC);
									    res2592_3405 = new1317_3399;
									 }
									 arg2338_2066 = res2592_3405;
								      }
								   }
								   {
								      block_t res2593_3412;
								      {
									 cop_t body_3406;
									 body_3406 = (cop_t) (arg2338_2066);
									 {
									    block_t new1287_3407;
									    new1287_3407 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
									    {
									       long arg1657_3408;
									       arg1657_3408 = class_num_218___object(block_cgen_cop);
									       {
										  obj_t obj_3410;
										  obj_3410 = (obj_t) (new1287_3407);
										  (((obj_t) CREF(obj_3410))->header = MAKE_HEADER(arg1657_3408, 0), BUNSPEC);
									       }
									    }
									    {
									       object_t aux_5905;
									       aux_5905 = (object_t) (new1287_3407);
									       OBJECT_WIDENING_SET(aux_5905, BFALSE);
									    }
									    ((((block_t) CREF(new1287_3407))->body) = ((cop_t) body_3406), BUNSPEC);
									    res2593_3412 = new1287_3407;
									 }
								      }
								      aux_4187 = (obj_t) (res2593_3412);
								   }
								}
							     }
							   else
							     {
								{
								   csequence_t arg2358_2084;
								   {
								      obj_t arg2359_2085;
								      {
									 local_var_164_t arg2360_2086;
									 csequence_t arg2361_2087;
									 cjump_ex_it_131_t arg2362_2088;
									 {
									    obj_t arg2367_2093;
									    {
									       obj_t list2368_2094;
									       {
										  obj_t arg2369_2095;
										  {
										     obj_t aux_5910;
										     aux_5910 = (obj_t) (vaux_2037);
										     arg2369_2095 = MAKE_PAIR(aux_5910, BNIL);
										  }
										  {
										     obj_t aux_5913;
										     aux_5913 = (obj_t) (eaux_2040);
										     list2368_2094 = MAKE_PAIR(aux_5913, arg2369_2095);
										  }
									       }
									       arg2367_2093 = list2368_2094;
									    }
									    {
									       local_var_164_t res2594_3420;
									       {
										  local_var_164_t new1342_3415;
										  new1342_3415 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
										  {
										     long arg1621_3416;
										     arg1621_3416 = class_num_218___object(local_var_164_cgen_cop);
										     {
											obj_t obj_3418;
											obj_3418 = (obj_t) (new1342_3415);
											(((obj_t) CREF(obj_3418))->header = MAKE_HEADER(arg1621_3416, 0), BUNSPEC);
										     }
										  }
										  {
										     object_t aux_5920;
										     aux_5920 = (object_t) (new1342_3415);
										     OBJECT_WIDENING_SET(aux_5920, BFALSE);
										  }
										  ((((local_var_164_t) CREF(new1342_3415))->vars) = ((obj_t) arg2367_2093), BUNSPEC);
										  res2594_3420 = new1342_3415;
									       }
									       arg2360_2086 = res2594_3420;
									    }
									 }
									 {
									    obj_t arg2371_2097;
									    {
									       obj_t list2372_2098;
									       {
										  obj_t arg2373_2099;
										  {
										     obj_t aux_5924;
										     aux_5924 = (obj_t) (vcop_2038);
										     arg2373_2099 = MAKE_PAIR(aux_5924, BNIL);
										  }
										  {
										     obj_t aux_5927;
										     aux_5927 = (obj_t) (ecop_2041);
										     list2372_2098 = MAKE_PAIR(aux_5927, arg2373_2099);
										  }
									       }
									       arg2371_2097 = list2372_2098;
									    }
									    {
									       csequence_t res2595_3430;
									       {
										  csequence_t new1317_3424;
										  new1317_3424 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
										  {
										     long arg1642_3425;
										     arg1642_3425 = class_num_218___object(csequence_cgen_cop);
										     {
											obj_t obj_3428;
											obj_3428 = (obj_t) (new1317_3424);
											(((obj_t) CREF(obj_3428))->header = MAKE_HEADER(arg1642_3425, 0), BUNSPEC);
										     }
										  }
										  {
										     object_t aux_5934;
										     aux_5934 = (object_t) (new1317_3424);
										     OBJECT_WIDENING_SET(aux_5934, BFALSE);
										  }
										  ((((csequence_t) CREF(new1317_3424))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
										  ((((csequence_t) CREF(new1317_3424))->cops) = ((obj_t) arg2371_2097), BUNSPEC);
										  res2595_3430 = new1317_3424;
									       }
									       arg2361_2087 = res2595_3430;
									    }
									 }
									 {
									    cjump_ex_it_131_t arg2375_2101;
									    {
									       varc_t arg2376_2102;
									       varc_t arg2377_2103;
									       {
										  varc_t res2596_3437;
										  {
										     variable_t variable_3431;
										     variable_3431 = (variable_t) (eaux_2040);
										     {
											varc_t new1305_3432;
											new1305_3432 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
											{
											   long arg1648_3433;
											   arg1648_3433 = class_num_218___object(varc_cgen_cop);
											   {
											      obj_t obj_3435;
											      obj_3435 = (obj_t) (new1305_3432);
											      (((obj_t) CREF(obj_3435))->header = MAKE_HEADER(arg1648_3433, 0), BUNSPEC);
											   }
											}
											{
											   object_t aux_5944;
											   aux_5944 = (object_t) (new1305_3432);
											   OBJECT_WIDENING_SET(aux_5944, BFALSE);
											}
											((((varc_t) CREF(new1305_3432))->variable) = ((variable_t) variable_3431), BUNSPEC);
											res2596_3437 = new1305_3432;
										     }
										  }
										  arg2376_2102 = res2596_3437;
									       }
									       {
										  varc_t res2597_3444;
										  {
										     variable_t variable_3438;
										     variable_3438 = (variable_t) (vaux_2037);
										     {
											varc_t new1305_3439;
											new1305_3439 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
											{
											   long arg1648_3440;
											   arg1648_3440 = class_num_218___object(varc_cgen_cop);
											   {
											      obj_t obj_3442;
											      obj_3442 = (obj_t) (new1305_3439);
											      (((obj_t) CREF(obj_3442))->header = MAKE_HEADER(arg1648_3440, 0), BUNSPEC);
											   }
											}
											{
											   object_t aux_5953;
											   aux_5953 = (object_t) (new1305_3439);
											   OBJECT_WIDENING_SET(aux_5953, BFALSE);
											}
											((((varc_t) CREF(new1305_3439))->variable) = ((variable_t) variable_3438), BUNSPEC);
											res2597_3444 = new1305_3439;
										     }
										  }
										  arg2377_2103 = res2597_3444;
									       }
									       {
										  cjump_ex_it_131_t res2598_3453;
										  {
										     cop_t exit_3445;
										     cop_t value_3446;
										     exit_3445 = (cop_t) (arg2376_2102);
										     value_3446 = (cop_t) (arg2377_2103);
										     {
											cjump_ex_it_131_t new1383_3447;
											new1383_3447 = ((cjump_ex_it_131_t) BREF(GC_MALLOC(sizeof(struct cjump_ex_it_131))));
											{
											   long arg1592_3448;
											   arg1592_3448 = class_num_218___object(cjump_ex_it_131_cgen_cop);
											   {
											      obj_t obj_3451;
											      obj_3451 = (obj_t) (new1383_3447);
											      (((obj_t) CREF(obj_3451))->header = MAKE_HEADER(arg1592_3448, 0), BUNSPEC);
											   }
											}
											{
											   object_t aux_5963;
											   aux_5963 = (object_t) (new1383_3447);
											   OBJECT_WIDENING_SET(aux_5963, BFALSE);
											}
											((((cjump_ex_it_131_t) CREF(new1383_3447))->exit) = ((cop_t) exit_3445), BUNSPEC);
											((((cjump_ex_it_131_t) CREF(new1383_3447))->value) = ((cop_t) value_3446), BUNSPEC);
											res2598_3453 = new1383_3447;
										     }
										  }
										  arg2375_2101 = res2598_3453;
									       }
									    }
									    arg2362_2088 = arg2375_2101;
									 }
									 {
									    obj_t list2363_2089;
									    {
									       obj_t arg2364_2090;
									       {
										  obj_t arg2365_2091;
										  {
										     obj_t aux_5968;
										     aux_5968 = (obj_t) (arg2362_2088);
										     arg2365_2091 = MAKE_PAIR(aux_5968, BNIL);
										  }
										  {
										     obj_t aux_5971;
										     aux_5971 = (obj_t) (arg2361_2087);
										     arg2364_2090 = MAKE_PAIR(aux_5971, arg2365_2091);
										  }
									       }
									       {
										  obj_t aux_5974;
										  aux_5974 = (obj_t) (arg2360_2086);
										  list2363_2089 = MAKE_PAIR(aux_5974, arg2364_2090);
									       }
									    }
									    arg2359_2085 = list2363_2089;
									 }
								      }
								      {
									 csequence_t res2599_3464;
									 {
									    csequence_t new1317_3458;
									    new1317_3458 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
									    {
									       long arg1642_3459;
									       arg1642_3459 = class_num_218___object(csequence_cgen_cop);
									       {
										  obj_t obj_3462;
										  obj_3462 = (obj_t) (new1317_3458);
										  (((obj_t) CREF(obj_3462))->header = MAKE_HEADER(arg1642_3459, 0), BUNSPEC);
									       }
									    }
									    {
									       object_t aux_5981;
									       aux_5981 = (object_t) (new1317_3458);
									       OBJECT_WIDENING_SET(aux_5981, BFALSE);
									    }
									    ((((csequence_t) CREF(new1317_3458))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
									    ((((csequence_t) CREF(new1317_3458))->cops) = ((obj_t) arg2359_2085), BUNSPEC);
									    res2599_3464 = new1317_3458;
									 }
									 arg2358_2084 = res2599_3464;
								      }
								   }
								   {
								      block_t res2600_3471;
								      {
									 cop_t body_3465;
									 body_3465 = (cop_t) (arg2358_2084);
									 {
									    block_t new1287_3466;
									    new1287_3466 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
									    {
									       long arg1657_3467;
									       arg1657_3467 = class_num_218___object(block_cgen_cop);
									       {
										  obj_t obj_3469;
										  obj_3469 = (obj_t) (new1287_3466);
										  (((obj_t) CREF(obj_3469))->header = MAKE_HEADER(arg1657_3467, 0), BUNSPEC);
									       }
									    }
									    {
									       object_t aux_5991;
									       aux_5991 = (object_t) (new1287_3466);
									       OBJECT_WIDENING_SET(aux_5991, BFALSE);
									    }
									    ((((block_t) CREF(new1287_3466))->body) = ((cop_t) body_3465), BUNSPEC);
									    res2600_3471 = new1287_3466;
									 }
								      }
								      aux_4187 = (obj_t) (res2600_3471);
								   }
								}
							     }
							}
						   }
					      }
					   }
					}
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 15):
			 {
			    make_box_202_t node_2122;
			    node_2122 = (make_box_202_t) (node_9);
			    {
			       bool_t test2396_2124;
			       {
				  obj_t aux_5997;
				  aux_5997 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2396_2124 = CBOOL(aux_5997);
			       }
			       if (test2396_2124)
				 {
				    obj_t arg2398_2126;
				    arg2398_2126 = shape_tools_shape((obj_t) (node_2122));
				    {
				       obj_t list2400_2128;
				       {
					  obj_t arg2401_2129;
					  {
					     obj_t arg2402_2130;
					     {
						obj_t arg2403_2131;
						{
						   obj_t arg2404_2132;
						   {
						      obj_t arg2405_2133;
						      {
							 obj_t aux_6005;
							 aux_6005 = BCHAR(((unsigned char) '\n'));
							 arg2405_2133 = MAKE_PAIR(aux_6005, BNIL);
						      }
						      arg2404_2132 = MAKE_PAIR(kont_10, arg2405_2133);
						   }
						   arg2403_2131 = MAKE_PAIR(string2635_cgen_cgen, arg2404_2132);
						}
						{
						   obj_t aux_6010;
						   aux_6010 = BCHAR(((unsigned char) '\n'));
						   arg2402_2130 = MAKE_PAIR(aux_6010, arg2403_2131);
						}
					     }
					     arg2401_2129 = MAKE_PAIR(arg2398_2126, arg2402_2130);
					  }
					  list2400_2128 = MAKE_PAIR(string2658_cgen_cgen, arg2401_2129);
				       }
				       print_trace_107_tools_trace(list2400_2128);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       bool_t test2409_2138;
			       {
				  bool_t test2436_2163;
				  {
				     obj_t aux_6016;
				     {
					node_t aux_6017;
					aux_6017 = (((make_box_202_t) CREF(node_2122))->value);
					aux_6016 = (obj_t) (aux_6017);
				     }
				     test2436_2163 = is_a__118___object(aux_6016, var_ast_node);
				  }
				  if (test2436_2163)
				    {
				       test2409_2138 = ((bool_t) 1);
				    }
				  else
				    {
				       bool_t test2437_2164;
				       {
					  obj_t aux_6022;
					  {
					     node_t aux_6023;
					     aux_6023 = (((make_box_202_t) CREF(node_2122))->value);
					     aux_6022 = (obj_t) (aux_6023);
					  }
					  test2437_2164 = is_a__118___object(aux_6022, atom_ast_node);
				       }
				       if (test2437_2164)
					 {
					    test2409_2138 = ((bool_t) 1);
					 }
				       else
					 {
					    obj_t aux_6028;
					    {
					       node_t aux_6029;
					       aux_6029 = (((make_box_202_t) CREF(node_2122))->value);
					       aux_6028 = (obj_t) (aux_6029);
					    }
					    test2409_2138 = is_a__118___object(aux_6028, kwote_ast_node);
					 }
				    }
			       }
			       if (test2409_2138)
				 {
				    node_t arg2410_2139;
				    arg2410_2139 = (((make_box_202_t) CREF(node_2122))->value);
				    {
				       obj_t arg2417_3808;
				       arg2417_3808 = make_fx_procedure(arg24172624_cgen_cgen, ((long) 1), ((long) 1));
				       PROCEDURE_SET(arg2417_3808, ((long) 0), kont_10);
				       {
					  cop_t aux_6037;
					  aux_6037 = node__cop_142_cgen_cgen(arg2410_2139, arg2417_3808);
					  aux_4187 = (obj_t) (aux_6037);
				       }
				    }
				 }
			       else
				 {
				    local_t aux_2145;
				    {
				       obj_t arg2435_2162;
				       arg2435_2162 = CNST_TABLE_REF(((long) 5));
				       {
					  local_t res2602_3490;
					  {
					     type_t type_3488;
					     type_3488 = (type_t) (__obj__252_type_cache);
					     {
						local_t local_3489;
						local_3489 = make_local_svar_140_ast_local(arg2435_2162, type_3488);
						set_variable_name__102_cgen_prototype((obj_t) (local_3489));
						res2602_3490 = local_3489;
					     }
					  }
					  aux_2145 = res2602_3490;
				       }
				    }
				    {
				       cop_t cval_2146;
				       {
					  setq_t arg2433_2160;
					  {
					     node_t arg2434_2161;
					     arg2434_2161 = (((make_box_202_t) CREF(node_2122))->value);
					     {
						setq_t res2605_3521;
						{
						   variable_t variable_3492;
						   variable_3492 = (variable_t) (aux_2145);
						   {
						      var_t arg1585_3494;
						      {
							 type_t arg1587_3495;
							 arg1587_3495 = (((variable_t) CREF(variable_3492))->type);
							 {
							    var_t res2603_3507;
							    {
							       obj_t loc_3497;
							       loc_3497 = BFALSE;
							       {
								  var_t new1129_3500;
								  new1129_3500 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
								  {
								     long arg1716_3501;
								     arg1716_3501 = class_num_218___object(var_ast_node);
								     {
									obj_t obj_3505;
									obj_3505 = (obj_t) (new1129_3500);
									(((obj_t) CREF(obj_3505))->header = MAKE_HEADER(arg1716_3501, 0), BUNSPEC);
								     }
								  }
								  {
								     object_t aux_6052;
								     aux_6052 = (object_t) (new1129_3500);
								     OBJECT_WIDENING_SET(aux_6052, loc_3497);
								  }
								  ((((var_t) CREF(new1129_3500))->loc) = ((obj_t) loc_3497), BUNSPEC);
								  ((((var_t) CREF(new1129_3500))->type) = ((type_t) arg1587_3495), BUNSPEC);
								  ((((var_t) CREF(new1129_3500))->variable) = ((variable_t) variable_3492), BUNSPEC);
								  res2603_3507 = new1129_3500;
							       }
							    }
							    arg1585_3494 = res2603_3507;
							 }
						      }
						      {
							 setq_t res2604_3520;
							 {
							    obj_t loc_3508;
							    type_t type_3509;
							    loc_3508 = BFALSE;
							    type_3509 = (type_t) (__unspec__87_type_cache);
							    {
							       setq_t new1189_3512;
							       new1189_3512 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
							       {
								  long arg1696_3513;
								  arg1696_3513 = class_num_218___object(setq_ast_node);
								  {
								     obj_t obj_3518;
								     obj_3518 = (obj_t) (new1189_3512);
								     (((obj_t) CREF(obj_3518))->header = MAKE_HEADER(arg1696_3513, 0), BUNSPEC);
								  }
							       }
							       {
								  object_t aux_6063;
								  aux_6063 = (object_t) (new1189_3512);
								  OBJECT_WIDENING_SET(aux_6063, loc_3508);
							       }
							       ((((setq_t) CREF(new1189_3512))->loc) = ((obj_t) loc_3508), BUNSPEC);
							       ((((setq_t) CREF(new1189_3512))->type) = ((type_t) type_3509), BUNSPEC);
							       ((((setq_t) CREF(new1189_3512))->var) = ((var_t) arg1585_3494), BUNSPEC);
							       ((((setq_t) CREF(new1189_3512))->value) = ((node_t) arg2434_2161), BUNSPEC);
							       res2604_3520 = new1189_3512;
							    }
							 }
							 res2605_3521 = res2604_3520;
						      }
						   }
						}
						arg2433_2160 = res2605_3521;
					     }
					  }
					  cval_2146 = node__cop_142_cgen_cgen((node_t) (arg2433_2160), __id_kont__126_cgen_cgen);
				       }
				       {
					  {
					     csequence_t arg2420_2147;
					     {
						obj_t arg2421_2148;
						{
						   local_var_164_t arg2422_2149;
						   obj_t arg2423_2150;
						   {
						      obj_t arg2428_2155;
						      {
							 obj_t list2429_2156;
							 {
							    obj_t aux_6072;
							    aux_6072 = (obj_t) (aux_2145);
							    list2429_2156 = MAKE_PAIR(aux_6072, BNIL);
							 }
							 arg2428_2155 = list2429_2156;
						      }
						      {
							 local_var_164_t res2606_3529;
							 {
							    local_var_164_t new1342_3524;
							    new1342_3524 = ((local_var_164_t) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							    {
							       long arg1621_3525;
							       arg1621_3525 = class_num_218___object(local_var_164_cgen_cop);
							       {
								  obj_t obj_3527;
								  obj_3527 = (obj_t) (new1342_3524);
								  (((obj_t) CREF(obj_3527))->header = MAKE_HEADER(arg1621_3525, 0), BUNSPEC);
							       }
							    }
							    {
							       object_t aux_6079;
							       aux_6079 = (object_t) (new1342_3524);
							       OBJECT_WIDENING_SET(aux_6079, BFALSE);
							    }
							    ((((local_var_164_t) CREF(new1342_3524))->vars) = ((obj_t) arg2428_2155), BUNSPEC);
							    res2606_3529 = new1342_3524;
							 }
							 arg2422_2149 = res2606_3529;
						      }
						   }
						   {
						      cmake_box_177_t arg2431_2158;
						      {
							 varc_t arg2432_2159;
							 {
							    varc_t res2607_3536;
							    {
							       variable_t variable_3530;
							       variable_3530 = (variable_t) (aux_2145);
							       {
								  varc_t new1305_3531;
								  new1305_3531 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
								  {
								     long arg1648_3532;
								     arg1648_3532 = class_num_218___object(varc_cgen_cop);
								     {
									obj_t obj_3534;
									obj_3534 = (obj_t) (new1305_3531);
									(((obj_t) CREF(obj_3534))->header = MAKE_HEADER(arg1648_3532, 0), BUNSPEC);
								     }
								  }
								  {
								     object_t aux_6088;
								     aux_6088 = (object_t) (new1305_3531);
								     OBJECT_WIDENING_SET(aux_6088, BFALSE);
								  }
								  ((((varc_t) CREF(new1305_3531))->variable) = ((variable_t) variable_3530), BUNSPEC);
								  res2607_3536 = new1305_3531;
							       }
							    }
							    arg2432_2159 = res2607_3536;
							 }
							 {
							    cmake_box_177_t res2608_3543;
							    {
							       cop_t value_3537;
							       value_3537 = (cop_t) (arg2432_2159);
							       {
								  cmake_box_177_t new1367_3538;
								  new1367_3538 = ((cmake_box_177_t) BREF(GC_MALLOC(sizeof(struct cmake_box_177))));
								  {
								     long arg1604_3539;
								     arg1604_3539 = class_num_218___object(cmake_box_177_cgen_cop);
								     {
									obj_t obj_3541;
									obj_3541 = (obj_t) (new1367_3538);
									(((obj_t) CREF(obj_3541))->header = MAKE_HEADER(arg1604_3539, 0), BUNSPEC);
								     }
								  }
								  {
								     object_t aux_6097;
								     aux_6097 = (object_t) (new1367_3538);
								     OBJECT_WIDENING_SET(aux_6097, BFALSE);
								  }
								  ((((cmake_box_177_t) CREF(new1367_3538))->value) = ((cop_t) value_3537), BUNSPEC);
								  res2608_3543 = new1367_3538;
							       }
							    }
							    arg2431_2158 = res2608_3543;
							 }
						      }
						      arg2423_2150 = PROCEDURE_ENTRY(kont_10) (kont_10, (obj_t) (arg2431_2158), BEOA);
						   }
						   {
						      obj_t list2424_2151;
						      {
							 obj_t arg2425_2152;
							 {
							    obj_t arg2426_2153;
							    arg2426_2153 = MAKE_PAIR(arg2423_2150, BNIL);
							    {
							       obj_t aux_6105;
							       aux_6105 = (obj_t) (cval_2146);
							       arg2425_2152 = MAKE_PAIR(aux_6105, arg2426_2153);
							    }
							 }
							 {
							    obj_t aux_6108;
							    aux_6108 = (obj_t) (arg2422_2149);
							    list2424_2151 = MAKE_PAIR(aux_6108, arg2425_2152);
							 }
						      }
						      arg2421_2148 = list2424_2151;
						   }
						}
						{
						   csequence_t res2609_3553;
						   {
						      csequence_t new1317_3547;
						      new1317_3547 = ((csequence_t) BREF(GC_MALLOC(sizeof(struct csequence))));
						      {
							 long arg1642_3548;
							 arg1642_3548 = class_num_218___object(csequence_cgen_cop);
							 {
							    obj_t obj_3551;
							    obj_3551 = (obj_t) (new1317_3547);
							    (((obj_t) CREF(obj_3551))->header = MAKE_HEADER(arg1642_3548, 0), BUNSPEC);
							 }
						      }
						      {
							 object_t aux_6115;
							 aux_6115 = (object_t) (new1317_3547);
							 OBJECT_WIDENING_SET(aux_6115, BFALSE);
						      }
						      ((((csequence_t) CREF(new1317_3547))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						      ((((csequence_t) CREF(new1317_3547))->cops) = ((obj_t) arg2421_2148), BUNSPEC);
						      res2609_3553 = new1317_3547;
						   }
						   arg2420_2147 = res2609_3553;
						}
					     }
					     {
						block_t res2610_3560;
						{
						   cop_t body_3554;
						   body_3554 = (cop_t) (arg2420_2147);
						   {
						      block_t new1287_3555;
						      new1287_3555 = ((block_t) BREF(GC_MALLOC(sizeof(struct block))));
						      {
							 long arg1657_3556;
							 arg1657_3556 = class_num_218___object(block_cgen_cop);
							 {
							    obj_t obj_3558;
							    obj_3558 = (obj_t) (new1287_3555);
							    (((obj_t) CREF(obj_3558))->header = MAKE_HEADER(arg1657_3556, 0), BUNSPEC);
							 }
						      }
						      {
							 object_t aux_6125;
							 aux_6125 = (object_t) (new1287_3555);
							 OBJECT_WIDENING_SET(aux_6125, BFALSE);
						      }
						      ((((block_t) CREF(new1287_3555))->body) = ((cop_t) body_3554), BUNSPEC);
						      res2610_3560 = new1287_3555;
						   }
						}
						aux_4187 = (obj_t) (res2610_3560);
					     }
					  }
				       }
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 16):
			 {
			    box_ref_242_t node_2168;
			    node_2168 = (box_ref_242_t) (node_9);
			    {
			       bool_t test2441_2170;
			       {
				  obj_t aux_6131;
				  aux_6131 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2441_2170 = CBOOL(aux_6131);
			       }
			       if (test2441_2170)
				 {
				    obj_t arg2443_2172;
				    arg2443_2172 = shape_tools_shape((obj_t) (node_2168));
				    {
				       obj_t list2445_2174;
				       {
					  obj_t arg2446_2175;
					  {
					     obj_t arg2447_2176;
					     {
						obj_t arg2448_2177;
						{
						   obj_t arg2449_2178;
						   {
						      obj_t arg2450_2179;
						      {
							 obj_t aux_6139;
							 aux_6139 = BCHAR(((unsigned char) '\n'));
							 arg2450_2179 = MAKE_PAIR(aux_6139, BNIL);
						      }
						      arg2449_2178 = MAKE_PAIR(kont_10, arg2450_2179);
						   }
						   arg2448_2177 = MAKE_PAIR(string2635_cgen_cgen, arg2449_2178);
						}
						{
						   obj_t aux_6144;
						   aux_6144 = BCHAR(((unsigned char) '\n'));
						   arg2447_2176 = MAKE_PAIR(aux_6144, arg2448_2177);
						}
					     }
					     arg2446_2175 = MAKE_PAIR(arg2443_2172, arg2447_2176);
					  }
					  list2445_2174 = MAKE_PAIR(string2659_cgen_cgen, arg2446_2175);
				       }
				       print_trace_107_tools_trace(list2445_2174);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       cop_t arg2454_2184;
			       {
				  var_t arg2455_2185;
				  arg2455_2185 = (((box_ref_242_t) CREF(node_2168))->var);
				  {
				     obj_t arg2456_3807;
				     arg2456_3807 = proc2660_cgen_cgen;
				     arg2454_2184 = node__cop_142_cgen_cgen((node_t) (arg2455_2185), arg2456_3807);
				  }
			       }
			       aux_4187 = PROCEDURE_ENTRY(kont_10) (kont_10, (obj_t) (arg2454_2184), BEOA);
			    }
			 }
			 break;
		      case ((long) 17):
			 {
			    box_set__221_t node_2190;
			    node_2190 = (box_set__221_t) (node_9);
			    {
			       bool_t test2458_2192;
			       {
				  obj_t aux_6157;
				  aux_6157 = trace_satisfy__215_tools_trace(CNST_TABLE_REF(((long) 0)), BINT(((long) 3)));
				  test2458_2192 = CBOOL(aux_6157);
			       }
			       if (test2458_2192)
				 {
				    obj_t arg2460_2194;
				    arg2460_2194 = shape_tools_shape((obj_t) (node_2190));
				    {
				       obj_t list2462_2196;
				       {
					  obj_t arg2463_2197;
					  {
					     obj_t arg2464_2198;
					     {
						obj_t arg2465_2199;
						{
						   obj_t arg2467_2200;
						   {
						      obj_t arg2469_2201;
						      {
							 obj_t aux_6165;
							 aux_6165 = BCHAR(((unsigned char) '\n'));
							 arg2469_2201 = MAKE_PAIR(aux_6165, BNIL);
						      }
						      arg2467_2200 = MAKE_PAIR(kont_10, arg2469_2201);
						   }
						   arg2465_2199 = MAKE_PAIR(string2635_cgen_cgen, arg2467_2200);
						}
						{
						   obj_t aux_6170;
						   aux_6170 = BCHAR(((unsigned char) '\n'));
						   arg2464_2198 = MAKE_PAIR(aux_6170, arg2465_2199);
						}
					     }
					     arg2463_2197 = MAKE_PAIR(arg2460_2194, arg2464_2198);
					  }
					  list2462_2196 = MAKE_PAIR(string2661_cgen_cgen, arg2463_2197);
				       }
				       print_trace_107_tools_trace(list2462_2196);
				    }
				 }
			       else
				 {
				    BUNSPEC;
				 }
			    }
			    {
			       variable_t v_2206;
			       {
				  var_t arg2478_2214;
				  arg2478_2214 = (((box_set__221_t) CREF(node_2190))->var);
				  v_2206 = (((var_t) CREF(arg2478_2214))->variable);
			       }
			       {
				  node_t arg2473_2207;
				  arg2473_2207 = (((box_set__221_t) CREF(node_2190))->value);
				  {
				     obj_t arg2474_3806;
				     arg2474_3806 = make_fx_procedure(arg24742622_cgen_cgen, ((long) 1), ((long) 2));
				     {
					obj_t aux_6180;
					aux_6180 = (obj_t) (v_2206);
					PROCEDURE_SET(arg2474_3806, ((long) 0), aux_6180);
				     }
				     PROCEDURE_SET(arg2474_3806, ((long) 1), kont_10);
				     {
					cop_t aux_6184;
					aux_6184 = node__cop_142_cgen_cgen(arg2473_2207, arg2474_3806);
					aux_4187 = (obj_t) (aux_6184);
				     }
				  }
			       }
			    }
			 }
			 break;
		      default:
		       case_else1763_124_1453:
			 if (PROCEDUREP(method1756_1449))
			   {
			      aux_4187 = PROCEDURE_ENTRY(method1756_1449) (method1756_1449, (obj_t) (node_9), kont_10, BEOA);
			   }
			 else
			   {
			      obj_t fun1584_968;
			      fun1584_968 = PROCEDURE_REF(node__cop_env_160_cgen_cgen, ((long) 0));
			      aux_4187 = PROCEDURE_ENTRY(fun1584_968) (fun1584_968, (obj_t) (node_9), kont_10, BEOA);
			   }
		      }
		 }
	       else
		 {
		    goto case_else1763_124_1453;
		 }
	    }
	    return (cop_t) (aux_4187);
	 }
      }
   }
}


obj_t 
_node__cop_12_cgen_cgen(obj_t env_3791, obj_t node_3792, obj_t kont_3793)
{
   {
      cop_t aux_6199;
      aux_6199 = node__cop_142_cgen_cgen((node_t) (node_3792), kont_3793);
      return (obj_t) (aux_6199);
   }
}


obj_t 
arg24742622_cgen_cgen(obj_t env_3809, obj_t vl_3812)
{
   {
      obj_t v_3810;
      obj_t kont_3811;
      v_3810 = PROCEDURE_REF(env_3809, ((long) 0));
      kont_3811 = PROCEDURE_REF(env_3809, ((long) 1));
      {
	 obj_t vl_2209;
	 vl_2209 = vl_3812;
	 {
	    cbox_set__132_t arg2476_2211;
	    {
	       varc_t arg2477_2212;
	       {
		  varc_t res2612_3578;
		  {
		     variable_t variable_3572;
		     variable_3572 = (variable_t) (v_3810);
		     {
			varc_t new1305_3573;
			new1305_3573 = ((varc_t) BREF(GC_MALLOC(sizeof(struct varc))));
			{
			   long arg1648_3574;
			   arg1648_3574 = class_num_218___object(varc_cgen_cop);
			   {
			      obj_t obj_3576;
			      obj_3576 = (obj_t) (new1305_3573);
			      (((obj_t) CREF(obj_3576))->header = MAKE_HEADER(arg1648_3574, 0), BUNSPEC);
			   }
			}
			{
			   object_t aux_6210;
			   aux_6210 = (object_t) (new1305_3573);
			   OBJECT_WIDENING_SET(aux_6210, BFALSE);
			}
			((((varc_t) CREF(new1305_3573))->variable) = ((variable_t) variable_3572), BUNSPEC);
			res2612_3578 = new1305_3573;
		     }
		  }
		  arg2477_2212 = res2612_3578;
	       }
	       {
		  cbox_set__132_t res2613_3587;
		  {
		     cop_t var_3579;
		     cop_t value_3580;
		     var_3579 = (cop_t) (arg2477_2212);
		     value_3580 = (cop_t) (vl_2209);
		     {
			cbox_set__132_t new1375_3581;
			new1375_3581 = ((cbox_set__132_t) BREF(GC_MALLOC(sizeof(struct cbox_set__132))));
			{
			   long arg1597_3582;
			   arg1597_3582 = class_num_218___object(cbox_set__132_cgen_cop);
			   {
			      obj_t obj_3585;
			      obj_3585 = (obj_t) (new1375_3581);
			      (((obj_t) CREF(obj_3585))->header = MAKE_HEADER(arg1597_3582, 0), BUNSPEC);
			   }
			}
			{
			   object_t aux_6220;
			   aux_6220 = (object_t) (new1375_3581);
			   OBJECT_WIDENING_SET(aux_6220, BFALSE);
			}
			((((cbox_set__132_t) CREF(new1375_3581))->var) = ((cop_t) var_3579), BUNSPEC);
			((((cbox_set__132_t) CREF(new1375_3581))->value) = ((cop_t) value_3580), BUNSPEC);
			res2613_3587 = new1375_3581;
		     }
		  }
		  arg2476_2211 = res2613_3587;
	       }
	    }
	    return PROCEDURE_ENTRY(kont_3811) (kont_3811, (obj_t) (arg2476_2211), BEOA);
	 }
      }
   }
}


obj_t 
arg24562623_cgen_cgen(obj_t env_3813, obj_t v_3814)
{
   {
      obj_t v_2187;
      {
	 cbox_ref_44_t aux_6228;
	 v_2187 = v_3814;
	 {
	    cbox_ref_44_t res2611_3568;
	    {
	       cop_t var_3562;
	       var_3562 = (cop_t) (v_2187);
	       {
		  cbox_ref_44_t new1371_3563;
		  new1371_3563 = ((cbox_ref_44_t) BREF(GC_MALLOC(sizeof(struct cbox_ref_44))));
		  {
		     long arg1601_3564;
		     arg1601_3564 = class_num_218___object(cbox_ref_44_cgen_cop);
		     {
			obj_t obj_3566;
			obj_3566 = (obj_t) (new1371_3563);
			(((obj_t) CREF(obj_3566))->header = MAKE_HEADER(arg1601_3564, 0), BUNSPEC);
		     }
		  }
		  {
		     object_t aux_6234;
		     aux_6234 = (object_t) (new1371_3563);
		     OBJECT_WIDENING_SET(aux_6234, BFALSE);
		  }
		  ((((cbox_ref_44_t) CREF(new1371_3563))->var) = ((cop_t) var_3562), BUNSPEC);
		  res2611_3568 = new1371_3563;
	       }
	    }
	    aux_6228 = res2611_3568;
	 }
	 return (obj_t) (aux_6228);
      }
   }
}


obj_t 
arg24172624_cgen_cgen(obj_t env_3815, obj_t v_3817)
{
   {
      obj_t kont_3816;
      kont_3816 = PROCEDURE_REF(env_3815, ((long) 0));
      {
	 obj_t v_2141;
	 v_2141 = v_3817;
	 {
	    cmake_box_177_t arg2419_3479;
	    {
	       cmake_box_177_t res2601_3486;
	       {
		  cop_t value_3480;
		  value_3480 = (cop_t) (v_2141);
		  {
		     cmake_box_177_t new1367_3481;
		     new1367_3481 = ((cmake_box_177_t) BREF(GC_MALLOC(sizeof(struct cmake_box_177))));
		     {
			long arg1604_3482;
			arg1604_3482 = class_num_218___object(cmake_box_177_cgen_cop);
			{
			   obj_t obj_3484;
			   obj_3484 = (obj_t) (new1367_3481);
			   (((obj_t) CREF(obj_3484))->header = MAKE_HEADER(arg1604_3482, 0), BUNSPEC);
			}
		     }
		     {
			object_t aux_6245;
			aux_6245 = (object_t) (new1367_3481);
			OBJECT_WIDENING_SET(aux_6245, BFALSE);
		     }
		     ((((cmake_box_177_t) CREF(new1367_3481))->value) = ((cop_t) value_3480), BUNSPEC);
		     res2601_3486 = new1367_3481;
		  }
	       }
	       arg2419_3479 = res2601_3486;
	    }
	    return PROCEDURE_ENTRY(kont_3816) (kont_3816, (obj_t) (arg2419_3479), BEOA);
	 }
      }
   }
}


setq_t 
node_setq_243_cgen_cgen(variable_t variable_49, node_t value_50)
{
   {
      var_t arg1585_3590;
      {
	 type_t arg1587_3591;
	 arg1587_3591 = (((variable_t) CREF(variable_49))->type);
	 {
	    var_t res2615_3603;
	    {
	       obj_t loc_3593;
	       loc_3593 = BFALSE;
	       {
		  var_t new1129_3596;
		  new1129_3596 = ((var_t) BREF(GC_MALLOC(sizeof(struct var))));
		  {
		     long arg1716_3597;
		     arg1716_3597 = class_num_218___object(var_ast_node);
		     {
			obj_t obj_3601;
			obj_3601 = (obj_t) (new1129_3596);
			(((obj_t) CREF(obj_3601))->header = MAKE_HEADER(arg1716_3597, 0), BUNSPEC);
		     }
		  }
		  {
		     object_t aux_6257;
		     aux_6257 = (object_t) (new1129_3596);
		     OBJECT_WIDENING_SET(aux_6257, loc_3593);
		  }
		  ((((var_t) CREF(new1129_3596))->loc) = ((obj_t) loc_3593), BUNSPEC);
		  ((((var_t) CREF(new1129_3596))->type) = ((type_t) arg1587_3591), BUNSPEC);
		  ((((var_t) CREF(new1129_3596))->variable) = ((variable_t) variable_49), BUNSPEC);
		  res2615_3603 = new1129_3596;
	       }
	    }
	    arg1585_3590 = res2615_3603;
	 }
      }
      {
	 setq_t res2616_3616;
	 {
	    obj_t loc_3604;
	    type_t type_3605;
	    loc_3604 = BFALSE;
	    type_3605 = (type_t) (__unspec__87_type_cache);
	    {
	       setq_t new1189_3608;
	       new1189_3608 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
	       {
		  long arg1696_3609;
		  arg1696_3609 = class_num_218___object(setq_ast_node);
		  {
		     obj_t obj_3614;
		     obj_3614 = (obj_t) (new1189_3608);
		     (((obj_t) CREF(obj_3614))->header = MAKE_HEADER(arg1696_3609, 0), BUNSPEC);
		  }
	       }
	       {
		  object_t aux_6268;
		  aux_6268 = (object_t) (new1189_3608);
		  OBJECT_WIDENING_SET(aux_6268, loc_3604);
	       }
	       ((((setq_t) CREF(new1189_3608))->loc) = ((obj_t) loc_3604), BUNSPEC);
	       ((((setq_t) CREF(new1189_3608))->type) = ((type_t) type_3605), BUNSPEC);
	       ((((setq_t) CREF(new1189_3608))->var) = ((var_t) arg1585_3590), BUNSPEC);
	       ((((setq_t) CREF(new1189_3608))->value) = ((node_t) value_50), BUNSPEC);
	       res2616_3616 = new1189_3608;
	    }
	 }
	 return res2616_3616;
      }
   }
}


obj_t 
_node_setq_175_cgen_cgen(obj_t env_3818, obj_t variable_3819, obj_t value_3820)
{
   {
      setq_t aux_6275;
      aux_6275 = node_setq_243_cgen_cgen((variable_t) (variable_3819), (node_t) (value_3820));
      return (obj_t) (aux_6275);
   }
}


local_t 
make_local_svar_name_219_cgen_cgen(obj_t id_51, type_t type_52)
{
   {
      local_t local_3617;
      local_3617 = make_local_svar_140_ast_local(id_51, type_52);
      set_variable_name__102_cgen_prototype((obj_t) (local_3617));
      return local_3617;
   }
}


obj_t 
_make_local_svar_name_175_cgen_cgen(obj_t env_3821, obj_t id_3822, obj_t type_3823)
{
   {
      local_t aux_6283;
      aux_6283 = make_local_svar_name_219_cgen_cgen(id_3822, (type_t) (type_3823));
      return (obj_t) (aux_6283);
   }
}


obj_t 
imported_modules_init_94_cgen_cgen()
{
   module_initialization_70_tools_trace(((long) 0), "CGEN_CGEN");
   module_initialization_70_tools_error(((long) 0), "CGEN_CGEN");
   module_initialization_70_tools_shape(((long) 0), "CGEN_CGEN");
   module_initialization_70_type_type(((long) 0), "CGEN_CGEN");
   module_initialization_70_type_tools(((long) 0), "CGEN_CGEN");
   module_initialization_70_type_cache(((long) 0), "CGEN_CGEN");
   module_initialization_70_ast_var(((long) 0), "CGEN_CGEN");
   module_initialization_70_ast_node(((long) 0), "CGEN_CGEN");
   module_initialization_70_ast_local(((long) 0), "CGEN_CGEN");
   module_initialization_70_effect_effect(((long) 0), "CGEN_CGEN");
   module_initialization_70_coerce_typeof(((long) 0), "CGEN_CGEN");
   module_initialization_70_cgen_emit(((long) 0), "CGEN_CGEN");
   module_initialization_70_cgen_cop(((long) 0), "CGEN_CGEN");
   module_initialization_70_cgen_emit_cop_239(((long) 0), "CGEN_CGEN");
   module_initialization_70_cgen_prototype(((long) 0), "CGEN_CGEN");
   return module_initialization_70_cgen_capp(((long) 0), "CGEN_CGEN");
}
