/*===========================================================================*/
/*   (Object/access.scm)                                                     */
/*   Bigloo (1.9)                                                            */
/*   Manuel Serrano (c)       Sat Mar 21 19:53:37 MET 1998                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo1.9c.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t ___57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct class
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
  }
     *class_t;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_t;


extern bool_t final_class__126_object_class(obj_t);
static obj_t slot_ref_85_object_access(obj_t, obj_t, obj_t, obj_t);
extern obj_t type_type_type;
static obj_t make_class_make_159_object_access(obj_t, obj_t, obj_t, obj_t, type_t, obj_t);
extern obj_t make_pragma_direct_set__7_object_tools(type_t, obj_t, obj_t, obj_t);
extern obj_t make_pragma_indexed_ref_widening_28_object_tools(type_t, obj_t, obj_t, obj_t, obj_t);
static obj_t slot_dyna_indexed_ref_48_object_access(obj_t, obj_t, obj_t, obj_t);
extern obj_t class_object_class;
extern obj_t malloc_object_tools(type_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t make_one_coercion_132_object_access(obj_t, obj_t, obj_t, obj_t);
extern obj_t append___r4_pairs_and_lists_6_3(obj_t);
static obj_t imported_modules_init_94_object_access();
extern obj_t module_initialization_70_object_access(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_object_struct(long, char *);
extern obj_t module_initialization_70_object_slots(long, char *);
extern obj_t module_initialization_70_object_tools(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_impuse(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t toplevel_init_63_object_access();
static obj_t cnst_init_137_object_access();
extern obj_t __unsafe_range__218_engine_param;
extern obj_t __optim__89_engine_param;
extern obj_t make_pragma_direct_set__widening_17_object_tools(type_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_pragma_indexed_set__widening_24_object_tools(type_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_pragma_direct_ref_widening_240_object_tools(type_t, obj_t, obj_t, obj_t);
extern obj_t super__class_id_210_object_tools(obj_t, obj_t);
extern obj_t __module__166_module_module;
static obj_t slot_indexed_ref_219_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_pragma_indexed_init_set__66_object_tools(type_t, obj_t, obj_t, obj_t);
static obj_t slot_indexed_set__217_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t cons__138___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t make_class_coercers_236_object_access(type_t);
static obj_t require_initialization_114_object_access = BUNSPEC;
static obj_t slot_set__144_object_access(obj_t, obj_t, obj_t, obj_t);
static obj_t slot_direct_ref_183_object_access(obj_t, obj_t, obj_t, obj_t);
extern obj_t class__id_80_object_tools(obj_t);
static obj_t library_modules_init_112_object_access();
static obj_t make_class_slots_access_80_object_access(obj_t, obj_t, obj_t, obj_t);
static obj_t make_class_pred_36_object_access(obj_t, class_t);
static obj_t slot_stat_indexed_set__23_object_access(obj_t, obj_t, obj_t, obj_t);
extern obj_t _malloc_object_tools(obj_t, obj_t, obj_t);
static obj_t slot_direct_set__173_object_access(obj_t, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t class__obj_id_219_object_tools(obj_t);
static obj_t make_class_allocate_193_object_access(obj_t, obj_t, global_t);
extern obj_t open_input_string(obj_t);
static obj_t make_wide_class_make_178_object_access(obj_t, obj_t, type_t, obj_t, obj_t);
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t make_wide_class_makes_236_object_access(obj_t, type_t, obj_t, obj_t);
static obj_t make_class_makes_39_object_access(obj_t, obj_t, obj_t, type_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t make_struct__wide_object_7_object_struct(obj_t, type_t, obj_t, obj_t);
static obj_t make_coercion_clause_209_object_access(obj_t, obj_t);
extern obj_t produce_module_clause__172_module_module(obj_t);
extern obj_t make_wide_object__struct_148_object_struct(obj_t, type_t, obj_t, obj_t);
extern obj_t _make_class_accesses__156_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t make_struct__object_35_object_struct(obj_t, type_t, obj_t, obj_t);
static obj_t slot_stat_indexed_ref_80_object_access(obj_t, obj_t, obj_t, obj_t);
extern obj_t _4dots_tools_misc;
extern obj_t make_wide_class_accesses__133_object_access(obj_t, type_t, obj_t, bool_t);
extern obj_t _alloca_object_tools(obj_t, obj_t, obj_t);
extern obj_t make_object__struct_189_object_struct(obj_t, type_t, obj_t, obj_t);
extern obj_t print___r4_output_6_10_3(obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t class__super_id_210_object_tools(obj_t, obj_t);
static obj_t slot_dyna_indexed_set__50_object_access(obj_t, obj_t, obj_t, obj_t);
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern bool_t wide_class__100_object_class(obj_t);
extern obj_t __optim_stack___57_engine_param;
extern obj_t _make_wide_class_accesses__21_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t obj__class_id_9_object_tools(obj_t);
extern obj_t make_class_slots_205_object_slots(obj_t, obj_t, obj_t);
extern obj_t make_class_accesses__208_object_access(obj_t, type_t, obj_t, bool_t);
static obj_t __cnst[59];

extern obj_t malloc_env_105_object_tools;
DEFINE_STRING(string3228_object_access, string3228_object_access3240, "obj_t", 5);
DEFINE_STRING(string3223_object_access, string3223_object_access3241, "make-wide-class-accesses!", 25);
DEFINE_STRING(string3215_object_access, string3215_object_access3242, "super of `", 10);
DEFINE_STRING(string3231_object_access, string3231_object_access3243, ")($1))", 6);
DEFINE_STRING(string3219_object_access, string3219_object_access3244, "Only wide classes can inherit of final classes", 46);
DEFINE_STRING(string3229_object_access, string3229_object_access3245, ")", 1);
DEFINE_STRING(string3234_object_access, string3234_object_access3246, "VAL ::UNSPECIFIED -SET! -REF ERROR <FX INDEX >=FX INDEX::LONG __OBJECT ALLOCATE- FREE-PRAGMA AUX MAKE-STACK- MAKE- FREE-PRAGMA::LONG +FX DONE QUOTE =FX IF LABELS -LEN BEGIN OBJECT-WIDENING-SET! CLASS-NUM OBJECT-CLASS-NUM-SET! LET DEFINE (INLINE) ::LONG I NEW LOOP STACK-ALLOC -STACK- - @ IS-A? DEFINE-INLINE PREDICATE-OF ::OBJ INLINE STATIC SUPER SUPER- ?::BOOL ? MACRO NO-CFA-TOP SIDE-EFFECT-FREE PRAGMA -> OBJ TYPE COERCE WIDENING MAKE FOREIGN ", 446);
DEFINE_STRING(string3232_object_access, string3232_object_access3247, "((", 2);
DEFINE_STRING(string3230_object_access, string3230_object_access3248, "(", 1);
DEFINE_STRING(string3218_object_access, string3218_object_access3249, "' is a wide class", 17);
DEFINE_STRING(string3216_object_access, string3216_object_access3250, "make-class-accesses!", 20);
DEFINE_STRING(string3233_object_access, string3233_object_access3251, "Index out of bound", 18);
DEFINE_EXPORT_PROCEDURE(make_wide_class_accesses__env_248_object_access, _make_wide_class_accesses__21_object_access3252, _make_wide_class_accesses__21_object_access, 0L, 4);
DEFINE_STRING(string3217_object_access, string3217_object_access3253, "Should not be able to see a wide class here", 43);
DEFINE_STRING(string3220_object_access, string3220_object_access3254, "A class can't be `wide' and `final'", 35);
DEFINE_STRING(string3214_object_access, string3214_object_access3255, "' is not a class", 16);
DEFINE_STRING(string3225_object_access, string3225_object_access3256, " ", 1);
extern obj_t alloca_env_212_object_tools;
DEFINE_STRING(string3224_object_access, string3224_object_access3257, "Should not be able to see a plain class here", 44);
DEFINE_STRING(string3221_object_access, string3221_object_access3258, "' is not a final class", 22);
DEFINE_STRING(string3227_object_access, string3227_object_access3259, "make-class-coercers: ", 21);
DEFINE_STRING(string3226_object_access, string3226_object_access3260, "make-coercion-clause: ", 22);
DEFINE_STRING(string3222_object_access, string3222_object_access3261, "super of wide class `", 21);
DEFINE_EXPORT_PROCEDURE(make_class_accesses__env_54_object_access, _make_class_accesses__156_object_access3262, _make_class_accesses__156_object_access, 0L, 4);

obj_t 
module_initialization_70_object_access(long checksum_2995, char *from_2996)
{
   if (CBOOL(require_initialization_114_object_access))
     {
	require_initialization_114_object_access = BBOOL(((bool_t) 0));
	library_modules_init_112_object_access();
	cnst_init_137_object_access();
	imported_modules_init_94_object_access();
	toplevel_init_63_object_access();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


obj_t 
library_modules_init_112_object_access()
{
   module_initialization_70___object(((long) 0), "OBJECT_ACCESS");
   module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_ACCESS");
   module_initialization_70___reader(((long) 0), "OBJECT_ACCESS");
   module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_ACCESS");
   module_initialization_70___r4_output_6_10_3(((long) 0), "OBJECT_ACCESS");
   module_initialization_70___r4_strings_6_7(((long) 0), "OBJECT_ACCESS");
   return BUNSPEC;
}


obj_t 
cnst_init_137_object_access()
{
   {
      obj_t cnst_port_138_2987;
      cnst_port_138_2987 = open_input_string(string3234_object_access);
      {
	 long i_2988;
	 i_2988 = ((long) 58);
       loop_2989:
	 {
	    bool_t test3235_2990;
	    test3235_2990 = (i_2988 == ((long) -1));
	    if (test3235_2990)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg3236_2991;
		    {
		       obj_t list3237_2992;
		       {
			  obj_t arg3238_2993;
			  arg3238_2993 = BNIL;
			  list3237_2992 = MAKE_PAIR(cnst_port_138_2987, arg3238_2993);
		       }
		       arg3236_2991 = read___reader(list3237_2992);
		    }
		    CNST_TABLE_SET(i_2988, arg3236_2991);
		 }
		 {
		    int aux_2994;
		    {
		       long aux_3016;
		       aux_3016 = (i_2988 - ((long) 1));
		       aux_2994 = (int) (aux_3016);
		    }
		    {
		       long i_3019;
		       i_3019 = (long) (aux_2994);
		       i_2988 = i_3019;
		       goto loop_2989;
		    }
		 }
	      }
	 }
      }
   }
}


obj_t 
toplevel_init_63_object_access()
{
   return BUNSPEC;
}


obj_t 
make_class_accesses__208_object_access(obj_t class_def_12_47, type_t class_48, obj_t src_def_101_49, bool_t object___struct__20_50)
{
   {
      obj_t super_504;
      {
	 class_t obj_2611;
	 obj_2611 = (class_t) (class_48);
	 {
	    obj_t aux_3022;
	    {
	       object_t aux_3023;
	       aux_3023 = (object_t) (obj_2611);
	       aux_3022 = OBJECT_WIDENING(aux_3023);
	    }
	    super_504 = (((class_t) CREF(aux_3022))->its_super_214);
	 }
      }
      {
	 obj_t cslots_505;
	 {
	    obj_t aux_3027;
	    {
	       bool_t test_3029;
	       {
		  obj_t aux_3030;
		  aux_3030 = (obj_t) (class_48);
		  test_3029 = (super_504 == aux_3030);
	       }
	       if (test_3029)
		 {
		    aux_3027 = BFALSE;
		 }
	       else
		 {
		    aux_3027 = super_504;
		 }
	    }
	    cslots_505 = make_class_slots_205_object_slots(CDR(class_def_12_47), aux_3027, src_def_101_49);
	 }
	 {
	    obj_t class_id_86_506;
	    class_id_86_506 = (((type_t) CREF(class_48))->id);
	    {
	       global_t holder_508;
	       {
		  class_t obj_2617;
		  obj_2617 = (class_t) (class_48);
		  {
		     obj_t aux_3036;
		     {
			object_t aux_3037;
			aux_3037 = (object_t) (obj_2617);
			aux_3036 = OBJECT_WIDENING(aux_3037);
		     }
		     holder_508 = (((class_t) CREF(aux_3036))->holder);
		  }
	       }
	       {
		  {
		     bool_t test1213_509;
		     {
			bool_t test1296_568;
			test1296_568 = is_a__118___object(super_504, type_type_type);
			if (test1296_568)
			  {
			     bool_t test1297_569;
			     test1297_569 = is_a__118___object(super_504, class_object_class);
			     if (test1297_569)
			       {
				  test1213_509 = ((bool_t) 0);
			       }
			     else
			       {
				  test1213_509 = ((bool_t) 1);
			       }
			  }
			else
			  {
			     test1213_509 = ((bool_t) 0);
			  }
		     }
		     if (test1213_509)
		       {
			  {
			     obj_t arg1214_510;
			     obj_t arg1217_511;
			     {
				type_t obj_2620;
				obj_2620 = (type_t) (super_504);
				arg1214_510 = (((type_t) CREF(obj_2620))->id);
			     }
			     {
				obj_t arg1225_515;
				arg1225_515 = SYMBOL_TO_STRING(class_id_86_506);
				{
				   obj_t list1228_517;
				   {
				      obj_t arg1229_518;
				      {
					 obj_t arg1230_519;
					 arg1230_519 = MAKE_PAIR(string3214_object_access, BNIL);
					 arg1229_518 = MAKE_PAIR(arg1225_515, arg1230_519);
				      }
				      list1228_517 = MAKE_PAIR(string3215_object_access, arg1229_518);
				   }
				   arg1217_511 = string_append_106___r4_strings_6_7(list1228_517);
				}
			     }
			     {
				obj_t list1218_512;
				list1218_512 = MAKE_PAIR(type_type_type, BNIL);
				return user_error_151_tools_error(arg1214_510, arg1217_511, src_def_101_49, list1218_512);
			     }
			  }
		       }
		     else
		       {
			  bool_t test1232_521;
			  test1232_521 = wide_class__100_object_class((obj_t) (class_48));
			  if (test1232_521)
			    {
			       return internal_error_43_tools_error(string3216_object_access, string3217_object_access, src_def_101_49);
			    }
			  else
			    {
			       bool_t test1233_522;
			       test1233_522 = wide_class__100_object_class(super_504);
			       if (test1233_522)
				 {
				    {
				       obj_t arg1234_523;
				       obj_t arg1235_524;
				       {
					  type_t obj_2622;
					  obj_2622 = (type_t) (super_504);
					  arg1234_523 = (((type_t) CREF(obj_2622))->id);
				       }
				       {
					  obj_t arg1240_528;
					  arg1240_528 = SYMBOL_TO_STRING(class_id_86_506);
					  {
					     obj_t list1242_530;
					     {
						obj_t arg1245_531;
						{
						   obj_t arg1246_532;
						   arg1246_532 = MAKE_PAIR(string3218_object_access, BNIL);
						   arg1245_531 = MAKE_PAIR(arg1240_528, arg1246_532);
						}
						list1242_530 = MAKE_PAIR(string3215_object_access, arg1245_531);
					     }
					     arg1235_524 = string_append_106___r4_strings_6_7(list1242_530);
					  }
				       }
				       {
					  obj_t list1236_525;
					  list1236_525 = MAKE_PAIR(type_type_type, BNIL);
					  return user_error_151_tools_error(arg1234_523, arg1235_524, src_def_101_49, list1236_525);
				       }
				    }
				 }
			       else
				 {
				    bool_t test1248_534;
				    test1248_534 = final_class__126_object_class(super_504);
				    if (test1248_534)
				      {
					 {
					    obj_t arg1251_535;
					    {
					       type_t obj_2624;
					       obj_2624 = (type_t) (super_504);
					       arg1251_535 = (((type_t) CREF(obj_2624))->id);
					    }
					    {
					       obj_t list1253_537;
					       list1253_537 = MAKE_PAIR(type_type_type, BNIL);
					       return user_error_151_tools_error(arg1251_535, string3219_object_access, src_def_101_49, list1253_537);
					    }
					 }
				      }
				    else
				      {
					 {
					    obj_t arg1256_539;
					    arg1256_539 = make_coercion_clause_209_object_access(class_id_86_506, super_504);
					    produce_module_clause__172_module_module(arg1256_539);
					 }
					 {
					    obj_t res3208_2627;
					    {
					       class_t obj_2625;
					       obj_2625 = (class_t) (class_48);
					       {
						  obj_t x_2985;
						  {
						     obj_t aux_3079;
						     {
							object_t aux_3080;
							aux_3080 = (object_t) (obj_2625);
							aux_3079 = OBJECT_WIDENING(aux_3080);
						     }
						     x_2985 = ((((class_t) CREF(aux_3079))->slots) = ((obj_t) cslots_505), BUNSPEC);
						  }
						  res3208_2627 = BUNSPEC;
					       }
					    }
					    res3208_2627;
					 }
					 {
					    obj_t arg1257_540;
					    {
					       obj_t arg1259_541;
					       obj_t arg1260_542;
					       arg1259_541 = CNST_TABLE_REF(((long) 0));
					       {
						  obj_t arg1266_545;
						  obj_t arg1267_546;
						  arg1266_545 = make_class_coercers_236_object_access(class_48);
						  arg1267_546 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
						  arg1260_542 = append_2_18___r4_pairs_and_lists_6_3(arg1266_545, arg1267_546);
					       }
					       {
						  obj_t list1261_543;
						  list1261_543 = MAKE_PAIR(arg1260_542, BNIL);
						  arg1257_540 = cons__138___r4_pairs_and_lists_6_3(arg1259_541, list1261_543);
					       }
					    }
					    produce_module_clause__172_module_module(arg1257_540);
					 }
					 {
					    obj_t accs_549;
					    {
					       obj_t arg1282_559;
					       obj_t arg1283_560;
					       obj_t arg1284_561;
					       arg1282_559 = make_class_pred_36_object_access(class_id_86_506, (class_t) (class_48));
					       arg1283_560 = make_class_makes_39_object_access(CNST_TABLE_REF(((long) 1)), CNST_TABLE_REF(((long) 1)), class_id_86_506, class_48, cslots_505);
					       arg1284_561 = make_class_slots_access_80_object_access(class_id_86_506, (obj_t) (class_48), cslots_505, BFALSE);
					       {
						  obj_t list1285_562;
						  {
						     obj_t arg1286_563;
						     {
							obj_t arg1287_564;
							arg1287_564 = MAKE_PAIR(arg1284_561, BNIL);
							arg1286_563 = MAKE_PAIR(arg1283_560, arg1287_564);
						     }
						     list1285_562 = MAKE_PAIR(arg1282_559, arg1286_563);
						  }
						  accs_549 = append___r4_pairs_and_lists_6_3(list1285_562);
					       }
					    }
					    {
					       obj_t arg1270_550;
					       obj_t arg1271_551;
					       arg1270_550 = make_class_allocate_193_object_access(class_id_86_506, (obj_t) (class_48), holder_508);
					       {
						  bool_t test1272_552;
						  {
						     obj_t aux_3104;
						     {
							class_t obj_2628;
							obj_2628 = (class_t) (class_48);
							{
							   obj_t aux_3106;
							   {
							      object_t aux_3107;
							      aux_3107 = (object_t) (obj_2628);
							      aux_3106 = OBJECT_WIDENING(aux_3107);
							   }
							   aux_3104 = (((class_t) CREF(aux_3106))->its_super_214);
							}
						     }
						     test1272_552 = is_a__118___object(aux_3104, type_type_type);
						  }
						  if (test1272_552)
						    {
						       if (object___struct__20_50)
							 {
							    obj_t arg1273_553;
							    obj_t arg1275_554;
							    arg1273_553 = make_object__struct_189_object_struct(class_id_86_506, class_48, __module__166_module_module, cslots_505);
							    arg1275_554 = make_struct__object_35_object_struct(class_id_86_506, class_48, __module__166_module_module, cslots_505);
							    {
							       obj_t list1276_555;
							       {
								  obj_t arg1278_556;
								  arg1278_556 = MAKE_PAIR(accs_549, BNIL);
								  list1276_555 = MAKE_PAIR(arg1275_554, arg1278_556);
							       }
							       arg1271_551 = cons__138___r4_pairs_and_lists_6_3(arg1273_553, list1276_555);
							    }
							 }
						       else
							 {
							    arg1271_551 = accs_549;
							 }
						    }
						  else
						    {
						       arg1271_551 = accs_549;
						    }
					       }
					       return MAKE_PAIR(arg1270_550, arg1271_551);
					    }
					 }
				      }
				 }
			    }
		       }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
_make_class_accesses__156_object_access(obj_t env_2968, obj_t class_def_12_2969, obj_t class_2970, obj_t src_def_101_2971, obj_t object___struct__20_2972)
{
   return make_class_accesses__208_object_access(class_def_12_2969, (type_t) (class_2970), src_def_101_2971, CBOOL(object___struct__20_2972));
}


obj_t 
make_wide_class_accesses__133_object_access(obj_t class_def_12_51, type_t class_52, obj_t src_def_101_53, bool_t object___struct__20_54)
{
   {
      bool_t test1301_573;
      {
	 bool_t test1404_655;
	 test1404_655 = is_a__118___object((obj_t) (class_52), class_object_class);
	 if (test1404_655)
	   {
	      obj_t aux_3126;
	      {
		 class_t obj_2633;
		 obj_2633 = (class_t) (class_52);
		 {
		    obj_t aux_3128;
		    {
		       object_t aux_3129;
		       aux_3129 = (object_t) (obj_2633);
		       aux_3128 = OBJECT_WIDENING(aux_3129);
		    }
		    aux_3126 = (((class_t) CREF(aux_3128))->its_super_214);
		 }
	      }
	      test1301_573 = is_a__118___object(aux_3126, class_object_class);
	   }
	 else
	   {
	      test1301_573 = ((bool_t) 0);
	   }
      }
      if (test1301_573)
	{
	   obj_t super_574;
	   {
	      class_t obj_2635;
	      obj_2635 = (class_t) (class_52);
	      {
		 obj_t aux_3136;
		 {
		    object_t aux_3137;
		    aux_3137 = (object_t) (obj_2635);
		    aux_3136 = OBJECT_WIDENING(aux_3137);
		 }
		 super_574 = (((class_t) CREF(aux_3136))->its_super_214);
	      }
	   }
	   {
	      obj_t sslots_575;
	      {
		 class_t obj_2636;
		 obj_2636 = (class_t) (super_574);
		 {
		    obj_t aux_3142;
		    {
		       object_t aux_3143;
		       aux_3143 = (object_t) (obj_2636);
		       aux_3142 = OBJECT_WIDENING(aux_3143);
		    }
		    sslots_575 = (((class_t) CREF(aux_3142))->slots);
		 }
	      }
	      {
		 obj_t cslots_576;
		 cslots_576 = make_class_slots_205_object_slots(CDR(class_def_12_51), BFALSE, src_def_101_53);
		 {
		    obj_t class_id_86_577;
		    class_id_86_577 = (((type_t) CREF(class_52))->id);
		    {
		       global_t holder_579;
		       {
			  class_t obj_2640;
			  obj_2640 = (class_t) (class_52);
			  {
			     obj_t aux_3151;
			     {
				object_t aux_3152;
				aux_3152 = (object_t) (obj_2640);
				aux_3151 = OBJECT_WIDENING(aux_3152);
			     }
			     holder_579 = (((class_t) CREF(aux_3151))->holder);
			  }
		       }
		       {
			  obj_t widening_581;
			  {
			     class_t obj_2642;
			     obj_2642 = (class_t) (class_52);
			     {
				obj_t aux_3157;
				{
				   object_t aux_3158;
				   aux_3158 = (object_t) (obj_2642);
				   aux_3157 = OBJECT_WIDENING(aux_3158);
				}
				widening_581 = (((class_t) CREF(aux_3157))->widening);
			     }
			  }
			  {
			     {
				bool_t test1302_582;
				{
				   bool_t test1401_652;
				   test1401_652 = is_a__118___object(super_574, type_type_type);
				   if (test1401_652)
				     {
					bool_t test1402_653;
					test1402_653 = is_a__118___object(super_574, class_object_class);
					if (test1402_653)
					  {
					     test1302_582 = ((bool_t) 0);
					  }
					else
					  {
					     test1302_582 = ((bool_t) 1);
					  }
				     }
				   else
				     {
					test1302_582 = ((bool_t) 0);
				     }
				}
				if (test1302_582)
				  {
				     {
					obj_t arg1303_583;
					obj_t arg1305_584;
					{
					   type_t obj_2645;
					   obj_2645 = (type_t) (super_574);
					   arg1303_583 = (((type_t) CREF(obj_2645))->id);
					}
					{
					   obj_t arg1310_588;
					   arg1310_588 = SYMBOL_TO_STRING(class_id_86_577);
					   {
					      obj_t list1312_590;
					      {
						 obj_t arg1313_591;
						 {
						    obj_t arg1314_592;
						    arg1314_592 = MAKE_PAIR(string3214_object_access, BNIL);
						    arg1313_591 = MAKE_PAIR(arg1310_588, arg1314_592);
						 }
						 list1312_590 = MAKE_PAIR(string3215_object_access, arg1313_591);
					      }
					      arg1305_584 = string_append_106___r4_strings_6_7(list1312_590);
					   }
					}
					{
					   obj_t list1306_585;
					   list1306_585 = MAKE_PAIR(type_type_type, BNIL);
					   return user_error_151_tools_error(arg1303_583, arg1305_584, src_def_101_53, list1306_585);
					}
				     }
				  }
				else
				  {
				     bool_t test1316_594;
				     test1316_594 = wide_class__100_object_class((obj_t) (class_52));
				     if (test1316_594)
				       {
					  bool_t test1317_595;
					  test1317_595 = wide_class__100_object_class(super_574);
					  if (test1317_595)
					    {
					       {
						  obj_t arg1318_596;
						  obj_t arg1319_597;
						  {
						     type_t obj_2647;
						     obj_2647 = (type_t) (super_574);
						     arg1318_596 = (((type_t) CREF(obj_2647))->id);
						  }
						  {
						     obj_t arg1323_601;
						     arg1323_601 = SYMBOL_TO_STRING(class_id_86_577);
						     {
							obj_t list1326_603;
							{
							   obj_t arg1327_604;
							   {
							      obj_t arg1328_605;
							      arg1328_605 = MAKE_PAIR(string3218_object_access, BNIL);
							      arg1327_604 = MAKE_PAIR(arg1323_601, arg1328_605);
							   }
							   list1326_603 = MAKE_PAIR(string3215_object_access, arg1327_604);
							}
							arg1319_597 = string_append_106___r4_strings_6_7(list1326_603);
						     }
						  }
						  {
						     obj_t list1320_598;
						     list1320_598 = MAKE_PAIR(type_type_type, BNIL);
						     return user_error_151_tools_error(arg1318_596, arg1319_597, src_def_101_53, list1320_598);
						  }
					       }
					    }
					  else
					    {
					       bool_t test1330_607;
					       test1330_607 = final_class__126_object_class(super_574);
					       if (test1330_607)
						 {
						    bool_t test1331_608;
						    test1331_608 = final_class__126_object_class((obj_t) (class_52));
						    if (test1331_608)
						      {
							 {
							    obj_t list1332_609;
							    list1332_609 = MAKE_PAIR(type_type_type, BNIL);
							    return user_error_151_tools_error(class_id_86_577, string3220_object_access, src_def_101_53, list1332_609);
							 }
						      }
						    else
						      {
							 {
							    obj_t arg1334_611;
							    arg1334_611 = make_coercion_clause_209_object_access(class_id_86_577, super_574);
							    produce_module_clause__172_module_module(arg1334_611);
							 }
							 {
							    obj_t res3209_2651;
							    {
							       class_t obj_2649;
							       obj_2649 = (class_t) (class_52);
							       {
								  obj_t x_2986;
								  {
								     obj_t aux_3200;
								     {
									object_t aux_3201;
									aux_3201 = (object_t) (obj_2649);
									aux_3200 = OBJECT_WIDENING(aux_3201);
								     }
								     x_2986 = ((((class_t) CREF(aux_3200))->slots) = ((obj_t) cslots_576), BUNSPEC);
								  }
								  res3209_2651 = BUNSPEC;
							       }
							    }
							    res3209_2651;
							 }
							 {
							    obj_t arg1337_612;
							    {
							       obj_t arg1339_613;
							       obj_t arg1340_614;
							       arg1339_613 = CNST_TABLE_REF(((long) 0));
							       {
								  obj_t arg1343_617;
								  obj_t arg1345_618;
								  arg1343_617 = make_class_coercers_236_object_access(class_52);
								  arg1345_618 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
								  arg1340_614 = append_2_18___r4_pairs_and_lists_6_3(arg1343_617, arg1345_618);
							       }
							       {
								  obj_t list1341_615;
								  list1341_615 = MAKE_PAIR(arg1340_614, BNIL);
								  arg1337_612 = cons__138___r4_pairs_and_lists_6_3(arg1339_613, list1341_615);
							       }
							    }
							    produce_module_clause__172_module_module(arg1337_612);
							 }
							 {
							    obj_t accs_621;
							    {
							       obj_t arg1357_629;
							       obj_t arg1358_630;
							       obj_t arg1359_631;
							       obj_t arg1361_632;
							       obj_t arg1363_633;
							       arg1357_629 = make_class_pred_36_object_access(class_id_86_577, (class_t) (class_52));
							       arg1358_630 = make_class_makes_39_object_access(CNST_TABLE_REF(((long) 2)), widening_581, class_id_86_577, class_52, cslots_576);
							       arg1359_631 = make_wide_class_makes_236_object_access(class_id_86_577, class_52, cslots_576, sslots_575);
							       arg1361_632 = make_class_slots_access_80_object_access(class_id_86_577, super_574, sslots_575, BFALSE);
							       arg1363_633 = make_class_slots_access_80_object_access(class_id_86_577, (obj_t) (class_52), cslots_576, (obj_t) (class_52));
							       {
								  obj_t list1364_634;
								  {
								     obj_t arg1366_635;
								     {
									obj_t arg1367_636;
									{
									   obj_t arg1369_637;
									   {
									      obj_t arg1370_638;
									      arg1370_638 = MAKE_PAIR(arg1363_633, BNIL);
									      arg1369_637 = MAKE_PAIR(arg1361_632, arg1370_638);
									   }
									   arg1367_636 = MAKE_PAIR(arg1359_631, arg1369_637);
									}
									arg1366_635 = MAKE_PAIR(arg1358_630, arg1367_636);
								     }
								     list1364_634 = MAKE_PAIR(arg1357_629, arg1366_635);
								  }
								  accs_621 = append___r4_pairs_and_lists_6_3(list1364_634);
							       }
							    }
							    {
							       obj_t arg1349_622;
							       obj_t arg1350_623;
							       arg1349_622 = make_class_allocate_193_object_access(class_id_86_577, super_574, holder_579);
							       if (object___struct__20_54)
								 {
								    obj_t arg1352_624;
								    obj_t arg1353_625;
								    arg1352_624 = make_wide_object__struct_148_object_struct(class_id_86_577, class_52, __module__166_module_module, cslots_576);
								    arg1353_625 = make_struct__wide_object_7_object_struct(class_id_86_577, class_52, __module__166_module_module, cslots_576);
								    {
								       obj_t list1354_626;
								       {
									  obj_t arg1355_627;
									  arg1355_627 = MAKE_PAIR(accs_621, BNIL);
									  list1354_626 = MAKE_PAIR(arg1353_625, arg1355_627);
								       }
								       arg1350_623 = cons__138___r4_pairs_and_lists_6_3(arg1352_624, list1354_626);
								    }
								 }
							       else
								 {
								    arg1350_623 = accs_621;
								 }
							       return MAKE_PAIR(arg1349_622, arg1350_623);
							    }
							 }
						      }
						 }
					       else
						 {
						    {
						       obj_t arg1379_641;
						       obj_t arg1380_642;
						       {
							  type_t obj_2654;
							  obj_2654 = (type_t) (super_574);
							  arg1379_641 = (((type_t) CREF(obj_2654))->id);
						       }
						       {
							  obj_t arg1388_646;
							  arg1388_646 = SYMBOL_TO_STRING(class_id_86_577);
							  {
							     obj_t list1391_648;
							     {
								obj_t arg1396_649;
								{
								   obj_t arg1398_650;
								   arg1398_650 = MAKE_PAIR(string3221_object_access, BNIL);
								   arg1396_649 = MAKE_PAIR(arg1388_646, arg1398_650);
								}
								list1391_648 = MAKE_PAIR(string3222_object_access, arg1396_649);
							     }
							     arg1380_642 = string_append_106___r4_strings_6_7(list1391_648);
							  }
						       }
						       {
							  obj_t list1381_643;
							  list1381_643 = MAKE_PAIR(type_type_type, BNIL);
							  return user_error_151_tools_error(arg1379_641, arg1380_642, src_def_101_53, list1381_643);
						       }
						    }
						 }
					    }
				       }
				     else
				       {
					  return internal_error_43_tools_error(string3223_object_access, string3224_object_access, src_def_101_53);
				       }
				  }
			     }
			  }
		       }
		    }
		 }
	      }
	   }
	}
      else
	{
	   return BNIL;
	}
   }
}


obj_t 
_make_wide_class_accesses__21_object_access(obj_t env_2973, obj_t class_def_12_2974, obj_t class_2975, obj_t src_def_101_2976, obj_t object___struct__20_2977)
{
   return make_wide_class_accesses__133_object_access(class_def_12_2974, (type_t) (class_2975), src_def_101_2976, CBOOL(object___struct__20_2977));
}


obj_t 
make_coercion_clause_209_object_access(obj_t c_id_230_55, obj_t super_56)
{
   {
      obj_t class__obj_201_657;
      class__obj_201_657 = class__obj_id_219_object_tools(c_id_230_55);
      {
	 obj_t obj__class_1_658;
	 obj__class_1_658 = obj__class_id_9_object_tools(c_id_230_55);
	 {
	    obj_t class_id__3_659;
	    class_id__3_659 = class__id_80_object_tools(c_id_230_55);
	    {
	       {
		  obj_t super_660;
		  obj_t coercer_661;
		  {
		     obj_t arg1408_663;
		     {
			obj_t arg1410_664;
			obj_t arg1411_665;
			{
			   obj_t arg1416_669;
			   obj_t arg1417_670;
			   obj_t arg1418_671;
			   obj_t arg1420_672;
			   arg1416_669 = CNST_TABLE_REF(((long) 3));
			   arg1417_670 = CNST_TABLE_REF(((long) 5));
			   {
			      obj_t list1433_681;
			      list1433_681 = MAKE_PAIR(BNIL, BNIL);
			      arg1418_671 = cons__138___r4_pairs_and_lists_6_3(class_id__3_659, list1433_681);
			   }
			   {
			      obj_t list1442_684;
			      list1442_684 = MAKE_PAIR(BNIL, BNIL);
			      arg1420_672 = cons__138___r4_pairs_and_lists_6_3(obj__class_1_658, list1442_684);
			   }
			   {
			      obj_t list1422_674;
			      {
				 obj_t arg1424_675;
				 {
				    obj_t arg1426_676;
				    {
				       obj_t arg1427_677;
				       {
					  obj_t arg1428_678;
					  arg1428_678 = MAKE_PAIR(BNIL, BNIL);
					  arg1427_677 = MAKE_PAIR(arg1420_672, arg1428_678);
				       }
				       arg1426_676 = MAKE_PAIR(arg1418_671, arg1427_677);
				    }
				    arg1424_675 = MAKE_PAIR(c_id_230_55, arg1426_676);
				 }
				 list1422_674 = MAKE_PAIR(arg1417_670, arg1424_675);
			      }
			      arg1410_664 = cons__138___r4_pairs_and_lists_6_3(arg1416_669, list1422_674);
			   }
			}
			{
			   obj_t arg1445_686;
			   obj_t arg1446_687;
			   obj_t arg1448_689;
			   arg1445_686 = CNST_TABLE_REF(((long) 3));
			   arg1446_687 = CNST_TABLE_REF(((long) 5));
			   {
			      obj_t list1462_698;
			      list1462_698 = MAKE_PAIR(BNIL, BNIL);
			      arg1448_689 = cons__138___r4_pairs_and_lists_6_3(class__obj_201_657, list1462_698);
			   }
			   {
			      obj_t list1450_691;
			      {
				 obj_t arg1452_692;
				 {
				    obj_t arg1453_693;
				    {
				       obj_t arg1454_694;
				       {
					  obj_t arg1457_695;
					  arg1457_695 = MAKE_PAIR(BNIL, BNIL);
					  arg1454_694 = MAKE_PAIR(arg1448_689, arg1457_695);
				       }
				       arg1453_693 = MAKE_PAIR(BNIL, arg1454_694);
				    }
				    arg1452_692 = MAKE_PAIR(arg1446_687, arg1453_693);
				 }
				 list1450_691 = MAKE_PAIR(c_id_230_55, arg1452_692);
			      }
			      arg1411_665 = cons__138___r4_pairs_and_lists_6_3(arg1445_686, list1450_691);
			   }
			}
			{
			   obj_t list1412_666;
			   {
			      obj_t arg1414_667;
			      arg1414_667 = MAKE_PAIR(arg1411_665, BNIL);
			      list1412_666 = MAKE_PAIR(arg1410_664, arg1414_667);
			   }
			   arg1408_663 = list1412_666;
			}
		     }
		     super_660 = super_56;
		     coercer_661 = arg1408_663;
		   loop_662:
		     {
			bool_t test1464_700;
			test1464_700 = is_a__118___object(super_660, class_object_class);
			if (test1464_700)
			  {
			     obj_t super_id_153_701;
			     {
				type_t obj_2658;
				obj_2658 = (type_t) (super_660);
				super_id_153_701 = (((type_t) CREF(obj_2658))->id);
			     }
			     {
				obj_t class__super_100_702;
				class__super_100_702 = class__super_id_210_object_tools(c_id_230_55, super_id_153_701);
				{
				   obj_t super__class_100_703;
				   super__class_100_703 = super__class_id_210_object_tools(super_id_153_701, c_id_230_55);
				   {
				      {
					 obj_t arg1465_704;
					 obj_t arg1466_705;
					 {
					    class_t obj_2659;
					    obj_2659 = (class_t) (super_660);
					    {
					       obj_t aux_3282;
					       {
						  object_t aux_3283;
						  aux_3283 = (object_t) (obj_2659);
						  aux_3282 = OBJECT_WIDENING(aux_3283);
					       }
					       arg1465_704 = (((class_t) CREF(aux_3282))->its_super_214);
					    }
					 }
					 {
					    obj_t arg1467_706;
					    obj_t arg1468_707;
					    {
					       obj_t arg1470_708;
					       obj_t arg1471_709;
					       obj_t arg1472_710;
					       arg1470_708 = CNST_TABLE_REF(((long) 3));
					       {
						  obj_t list1485_719;
						  list1485_719 = MAKE_PAIR(BNIL, BNIL);
						  arg1471_709 = cons__138___r4_pairs_and_lists_6_3(class_id__3_659, list1485_719);
					       }
					       {
						  obj_t list1488_722;
						  list1488_722 = MAKE_PAIR(BNIL, BNIL);
						  arg1472_710 = cons__138___r4_pairs_and_lists_6_3(super__class_100_703, list1488_722);
					       }
					       {
						  obj_t list1475_712;
						  {
						     obj_t arg1476_713;
						     {
							obj_t arg1477_714;
							{
							   obj_t arg1478_715;
							   {
							      obj_t arg1480_716;
							      arg1480_716 = MAKE_PAIR(BNIL, BNIL);
							      arg1478_715 = MAKE_PAIR(arg1472_710, arg1480_716);
							   }
							   arg1477_714 = MAKE_PAIR(arg1471_709, arg1478_715);
							}
							arg1476_713 = MAKE_PAIR(c_id_230_55, arg1477_714);
						     }
						     list1475_712 = MAKE_PAIR(super_id_153_701, arg1476_713);
						  }
						  arg1467_706 = cons__138___r4_pairs_and_lists_6_3(arg1470_708, list1475_712);
					       }
					    }
					    {
					       obj_t arg1490_724;
					       {
						  obj_t arg1493_725;
						  obj_t arg1496_727;
						  arg1493_725 = CNST_TABLE_REF(((long) 3));
						  {
						     obj_t list1508_736;
						     list1508_736 = MAKE_PAIR(BNIL, BNIL);
						     arg1496_727 = cons__138___r4_pairs_and_lists_6_3(class__super_100_702, list1508_736);
						  }
						  {
						     obj_t list1498_729;
						     {
							obj_t arg1499_730;
							{
							   obj_t arg1500_731;
							   {
							      obj_t arg1501_732;
							      {
								 obj_t arg1505_733;
								 arg1505_733 = MAKE_PAIR(BNIL, BNIL);
								 arg1501_732 = MAKE_PAIR(arg1496_727, arg1505_733);
							      }
							      arg1500_731 = MAKE_PAIR(BNIL, arg1501_732);
							   }
							   arg1499_730 = MAKE_PAIR(super_id_153_701, arg1500_731);
							}
							list1498_729 = MAKE_PAIR(c_id_230_55, arg1499_730);
						     }
						     arg1490_724 = cons__138___r4_pairs_and_lists_6_3(arg1493_725, list1498_729);
						  }
					       }
					       arg1468_707 = MAKE_PAIR(arg1490_724, coercer_661);
					    }
					    arg1466_705 = MAKE_PAIR(arg1467_706, arg1468_707);
					 }
					 {
					    obj_t coercer_3310;
					    obj_t super_3309;
					    super_3309 = arg1465_704;
					    coercer_3310 = arg1466_705;
					    coercer_661 = coercer_3310;
					    super_660 = super_3309;
					    goto loop_662;
					 }
				      }
				   }
				}
			     }
			  }
			else
			  {
			     {
				bool_t test1510_738;
				test1510_738 = is_a__118___object(super_660, type_type_type);
				if (test1510_738)
				  {
				     obj_t list1511_739;
				     {
					obj_t arg1514_741;
					{
					   obj_t arg1517_742;
					   {
					      obj_t arg1520_744;
					      arg1520_744 = MAKE_PAIR(super_660, BNIL);
					      arg1517_742 = MAKE_PAIR(string3225_object_access, arg1520_744);
					   }
					   arg1514_741 = MAKE_PAIR(c_id_230_55, arg1517_742);
					}
					list1511_739 = MAKE_PAIR(string3226_object_access, arg1514_741);
				     }
				     print___r4_output_6_10_3(list1511_739);
				  }
				else
				  {
				     BUNSPEC;
				  }
			     }
			     {
				obj_t arg1523_746;
				obj_t arg1524_747;
				arg1523_746 = CNST_TABLE_REF(((long) 4));
				{
				   obj_t arg1529_750;
				   arg1529_750 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
				   arg1524_747 = append_2_18___r4_pairs_and_lists_6_3(coercer_661, arg1529_750);
				}
				{
				   obj_t list1525_748;
				   list1525_748 = MAKE_PAIR(arg1524_747, BNIL);
				   return cons__138___r4_pairs_and_lists_6_3(arg1523_746, list1525_748);
				}
			     }
			  }
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
make_class_coercers_236_object_access(type_t class_57)
{
   {
      obj_t tid_754;
      obj_t tname_755;
      tid_754 = (((type_t) CREF(class_57))->id);
      tname_755 = (((type_t) CREF(class_57))->name);
      {
	 obj_t super_756;
	 obj_t coercer_757;
	 {
	    obj_t arg1534_759;
	    obj_t arg1535_760;
	    {
	       class_t obj_2667;
	       obj_2667 = (class_t) (class_57);
	       {
		  obj_t aux_3326;
		  {
		     object_t aux_3327;
		     aux_3327 = (object_t) (obj_2667);
		     aux_3326 = OBJECT_WIDENING(aux_3327);
		  }
		  arg1534_759 = (((class_t) CREF(aux_3326))->its_super_214);
	       }
	    }
	    arg1535_760 = make_one_coercion_132_object_access(tid_754, tname_755, CNST_TABLE_REF(((long) 5)), string3228_object_access);
	    super_756 = arg1534_759;
	    coercer_757 = arg1535_760;
	  loop_758:
	    {
	       bool_t test1538_763;
	       test1538_763 = is_a__118___object(super_756, class_object_class);
	       if (test1538_763)
		 {
		    obj_t arg1539_766;
		    obj_t arg1540_767;
		    {
		       class_t obj_2671;
		       obj_2671 = (class_t) (super_756);
		       {
			  obj_t aux_3336;
			  {
			     object_t aux_3337;
			     aux_3337 = (object_t) (obj_2671);
			     aux_3336 = OBJECT_WIDENING(aux_3337);
			  }
			  arg1539_766 = (((class_t) CREF(aux_3336))->its_super_214);
		       }
		    }
		    {
		       obj_t arg1541_768;
		       {
			  obj_t aux_3344;
			  obj_t aux_3341;
			  {
			     type_t obj_2670;
			     obj_2670 = (type_t) (super_756);
			     aux_3344 = (((type_t) CREF(obj_2670))->name);
			  }
			  {
			     type_t obj_2669;
			     obj_2669 = (type_t) (super_756);
			     aux_3341 = (((type_t) CREF(obj_2669))->id);
			  }
			  arg1541_768 = make_one_coercion_132_object_access(tid_754, tname_755, aux_3341, aux_3344);
		       }
		       arg1540_767 = append_2_18___r4_pairs_and_lists_6_3(arg1541_768, coercer_757);
		    }
		    {
		       obj_t coercer_3350;
		       obj_t super_3349;
		       super_3349 = arg1539_766;
		       coercer_3350 = arg1540_767;
		       coercer_757 = coercer_3350;
		       super_756 = super_3349;
		       goto loop_758;
		    }
		 }
	       else
		 {
		    {
		       bool_t test1542_769;
		       test1542_769 = is_a__118___object(super_756, type_type_type);
		       if (test1542_769)
			 {
			    obj_t list1543_770;
			    {
			       obj_t arg1549_772;
			       {
				  obj_t aux_3353;
				  aux_3353 = (obj_t) (class_57);
				  arg1549_772 = MAKE_PAIR(aux_3353, BNIL);
			       }
			       list1543_770 = MAKE_PAIR(string3227_object_access, arg1549_772);
			    }
			    print___r4_output_6_10_3(list1543_770);
			 }
		       else
			 {
			    BUNSPEC;
			 }
		    }
		    return coercer_757;
		 }
	    }
	 }
      }
   }
}


obj_t 
make_one_coercion_132_object_access(obj_t from_id_201_774, obj_t from_name_19_775, obj_t to_id_124_776, obj_t to_name_205_777)
{
   {
      obj_t t__f_60_779;
      obj_t f__t_46_780;
      {
	 obj_t arg1638_847;
	 arg1638_847 = CNST_TABLE_REF(((long) 6));
	 {
	    obj_t list1639_848;
	    {
	       obj_t arg1641_849;
	       {
		  obj_t arg1642_850;
		  arg1642_850 = MAKE_PAIR(from_id_201_774, BNIL);
		  arg1641_849 = MAKE_PAIR(arg1638_847, arg1642_850);
	       }
	       list1639_848 = MAKE_PAIR(to_id_124_776, arg1641_849);
	    }
	    t__f_60_779 = symbol_append_197___r4_symbols_6_4(list1639_848);
	 }
      }
      {
	 obj_t arg1644_852;
	 arg1644_852 = CNST_TABLE_REF(((long) 6));
	 {
	    obj_t list1645_853;
	    {
	       obj_t arg1646_854;
	       {
		  obj_t arg1647_855;
		  arg1647_855 = MAKE_PAIR(to_id_124_776, BNIL);
		  arg1646_854 = MAKE_PAIR(arg1644_852, arg1647_855);
	       }
	       list1645_853 = MAKE_PAIR(from_id_201_774, arg1646_854);
	    }
	    f__t_46_780 = symbol_append_197___r4_symbols_6_4(list1645_853);
	 }
      }
      {
	 obj_t arg1552_781;
	 {
	    obj_t arg1553_782;
	    obj_t arg1554_783;
	    obj_t arg1555_784;
	    arg1553_782 = CNST_TABLE_REF(((long) 7));
	    {
	       obj_t arg1562_790;
	       obj_t arg1563_791;
	       arg1562_790 = CNST_TABLE_REF(((long) 8));
	       arg1563_791 = CNST_TABLE_REF(((long) 9));
	       {
		  obj_t list1565_793;
		  {
		     obj_t arg1566_794;
		     {
			obj_t arg1567_795;
			arg1567_795 = MAKE_PAIR(BNIL, BNIL);
			arg1566_794 = MAKE_PAIR(arg1563_791, arg1567_795);
		     }
		     list1565_793 = MAKE_PAIR(arg1562_790, arg1566_794);
		  }
		  arg1554_783 = cons__138___r4_pairs_and_lists_6_3(t__f_60_779, list1565_793);
	       }
	    }
	    {
	       obj_t arg1570_797;
	       obj_t arg1571_798;
	       arg1570_797 = CNST_TABLE_REF(((long) 8));
	       arg1571_798 = CNST_TABLE_REF(((long) 9));
	       {
		  obj_t list1573_800;
		  {
		     obj_t arg1574_801;
		     {
			obj_t arg1575_802;
			arg1575_802 = MAKE_PAIR(BNIL, BNIL);
			arg1574_801 = MAKE_PAIR(arg1571_798, arg1575_802);
		     }
		     list1573_800 = MAKE_PAIR(arg1570_797, arg1574_801);
		  }
		  arg1555_784 = cons__138___r4_pairs_and_lists_6_3(f__t_46_780, list1573_800);
	       }
	    }
	    {
	       obj_t list1558_786;
	       {
		  obj_t arg1559_787;
		  {
		     obj_t arg1560_788;
		     arg1560_788 = MAKE_PAIR(BNIL, BNIL);
		     arg1559_787 = MAKE_PAIR(arg1555_784, arg1560_788);
		  }
		  list1558_786 = MAKE_PAIR(arg1554_783, arg1559_787);
	       }
	       arg1552_781 = cons__138___r4_pairs_and_lists_6_3(arg1553_782, list1558_786);
	    }
	 }
	 produce_module_clause__172_module_module(arg1552_781);
      }
      {
	 obj_t arg1577_804;
	 obj_t arg1578_805;
	 {
	    obj_t arg1584_809;
	    obj_t arg1585_810;
	    obj_t arg1587_811;
	    arg1584_809 = CNST_TABLE_REF(((long) 10));
	    {
	       obj_t list1597_820;
	       list1597_820 = MAKE_PAIR(BNIL, BNIL);
	       arg1585_810 = cons__138___r4_pairs_and_lists_6_3(to_id_124_776, list1597_820);
	    }
	    {
	       obj_t list1601_822;
	       {
		  obj_t arg1604_824;
		  {
		     obj_t arg1605_825;
		     arg1605_825 = MAKE_PAIR(string3229_object_access, BNIL);
		     arg1604_824 = MAKE_PAIR(from_name_19_775, arg1605_825);
		  }
		  list1601_822 = MAKE_PAIR(string3230_object_access, arg1604_824);
	       }
	       arg1587_811 = string_append_106___r4_strings_6_7(list1601_822);
	    }
	    {
	       obj_t list1589_813;
	       {
		  obj_t arg1590_814;
		  {
		     obj_t arg1591_815;
		     {
			obj_t arg1592_816;
			{
			   obj_t arg1593_817;
			   arg1593_817 = MAKE_PAIR(BNIL, BNIL);
			   arg1592_816 = MAKE_PAIR(arg1587_811, arg1593_817);
			}
			arg1591_815 = MAKE_PAIR(arg1585_810, arg1592_816);
		     }
		     arg1590_814 = MAKE_PAIR(t__f_60_779, arg1591_815);
		  }
		  list1589_813 = MAKE_PAIR(from_id_201_774, arg1590_814);
	       }
	       arg1577_804 = cons__138___r4_pairs_and_lists_6_3(arg1584_809, list1589_813);
	    }
	 }
	 {
	    obj_t arg1609_828;
	    obj_t arg1611_829;
	    obj_t arg1614_830;
	    arg1609_828 = CNST_TABLE_REF(((long) 10));
	    {
	       obj_t list1625_839;
	       list1625_839 = MAKE_PAIR(BNIL, BNIL);
	       arg1611_829 = cons__138___r4_pairs_and_lists_6_3(from_id_201_774, list1625_839);
	    }
	    {
	       obj_t list1627_841;
	       {
		  obj_t arg1630_843;
		  {
		     obj_t arg1632_844;
		     arg1632_844 = MAKE_PAIR(string3229_object_access, BNIL);
		     arg1630_843 = MAKE_PAIR(to_name_205_777, arg1632_844);
		  }
		  list1627_841 = MAKE_PAIR(string3230_object_access, arg1630_843);
	       }
	       arg1614_830 = string_append_106___r4_strings_6_7(list1627_841);
	    }
	    {
	       obj_t list1617_832;
	       {
		  obj_t arg1618_833;
		  {
		     obj_t arg1619_834;
		     {
			obj_t arg1620_835;
			{
			   obj_t arg1621_836;
			   arg1621_836 = MAKE_PAIR(BNIL, BNIL);
			   arg1620_835 = MAKE_PAIR(arg1614_830, arg1621_836);
			}
			arg1619_834 = MAKE_PAIR(arg1611_829, arg1620_835);
		     }
		     arg1618_833 = MAKE_PAIR(f__t_46_780, arg1619_834);
		  }
		  list1617_832 = MAKE_PAIR(to_id_124_776, arg1618_833);
	       }
	       arg1578_805 = cons__138___r4_pairs_and_lists_6_3(arg1609_828, list1617_832);
	    }
	 }
	 {
	    obj_t list1579_806;
	    {
	       obj_t arg1582_807;
	       arg1582_807 = MAKE_PAIR(arg1578_805, BNIL);
	       list1579_806 = MAKE_PAIR(arg1577_804, arg1582_807);
	    }
	    return list1579_806;
	 }
      }
   }
}


obj_t 
make_class_pred_36_object_access(obj_t id_58, class_t class_59)
{
   {
      obj_t id__219_858;
      {
	 obj_t list1747_946;
	 {
	    obj_t arg1748_947;
	    {
	       obj_t aux_3414;
	       aux_3414 = CNST_TABLE_REF(((long) 11));
	       arg1748_947 = MAKE_PAIR(aux_3414, BNIL);
	    }
	    list1747_946 = MAKE_PAIR(id_58, arg1748_947);
	 }
	 id__219_858 = symbol_append_197___r4_symbols_6_4(list1747_946);
      }
      {
	 obj_t pred_id_222_859;
	 {
	    obj_t list1742_942;
	    {
	       obj_t arg1743_943;
	       {
		  obj_t aux_3419;
		  aux_3419 = CNST_TABLE_REF(((long) 12));
		  arg1743_943 = MAKE_PAIR(aux_3419, BNIL);
	       }
	       list1742_942 = MAKE_PAIR(id_58, arg1743_943);
	    }
	    pred_id_222_859 = symbol_append_197___r4_symbols_6_4(list1742_942);
	 }
	 {
	    global_t holder_860;
	    {
	       obj_t aux_3424;
	       {
		  object_t aux_3425;
		  aux_3425 = (object_t) (class_59);
		  aux_3424 = OBJECT_WIDENING(aux_3425);
	       }
	       holder_860 = (((class_t) CREF(aux_3424))->holder);
	    }
	    {
	       obj_t super_861;
	       {
		  obj_t aux_3429;
		  {
		     object_t aux_3430;
		     aux_3430 = (object_t) (class_59);
		     aux_3429 = OBJECT_WIDENING(aux_3430);
		  }
		  super_861 = (((class_t) CREF(aux_3429))->its_super_214);
	       }
	       {
		  {
		     bool_t test1649_862;
		     test1649_862 = is_a__118___object(super_861, class_object_class);
		     if (test1649_862)
		       {
			  obj_t super_pred_id_124_863;
			  obj_t super_typed_158_864;
			  {
			     obj_t arg1730_931;
			     arg1730_931 = CNST_TABLE_REF(((long) 13));
			     {
				obj_t list1731_932;
				{
				   obj_t arg1732_933;
				   arg1732_933 = MAKE_PAIR(pred_id_222_859, BNIL);
				   list1731_932 = MAKE_PAIR(arg1730_931, arg1732_933);
				}
				super_pred_id_124_863 = symbol_append_197___r4_symbols_6_4(list1731_932);
			     }
			  }
			  {
			     obj_t arg1734_935;
			     arg1734_935 = CNST_TABLE_REF(((long) 14));
			     {
				obj_t list1736_937;
				{
				   obj_t arg1737_938;
				   {
				      obj_t arg1738_939;
				      {
					 obj_t aux_3441;
					 {
					    type_t obj_2677;
					    obj_2677 = (type_t) (super_861);
					    aux_3441 = (((type_t) CREF(obj_2677))->id);
					 }
					 arg1738_939 = MAKE_PAIR(aux_3441, BNIL);
				      }
				      arg1737_938 = MAKE_PAIR(_4dots_tools_misc, arg1738_939);
				   }
				   list1736_937 = MAKE_PAIR(arg1734_935, arg1737_938);
				}
				super_typed_158_864 = symbol_append_197___r4_symbols_6_4(list1736_937);
			     }
			  }
			  {
			     obj_t arg1650_865;
			     {
				obj_t arg1651_866;
				obj_t arg1652_867;
				arg1651_866 = CNST_TABLE_REF(((long) 15));
				{
				   obj_t arg1657_872;
				   obj_t arg1659_873;
				   arg1657_872 = CNST_TABLE_REF(((long) 16));
				   arg1659_873 = CNST_TABLE_REF(((long) 17));
				   {
				      obj_t list1662_875;
				      {
					 obj_t arg1663_876;
					 {
					    obj_t arg1664_877;
					    arg1664_877 = MAKE_PAIR(BNIL, BNIL);
					    arg1663_876 = MAKE_PAIR(arg1659_873, arg1664_877);
					 }
					 list1662_875 = MAKE_PAIR(pred_id_222_859, arg1663_876);
				      }
				      arg1652_867 = cons__138___r4_pairs_and_lists_6_3(arg1657_872, list1662_875);
				   }
				}
				{
				   obj_t list1654_869;
				   {
				      obj_t arg1655_870;
				      arg1655_870 = MAKE_PAIR(BNIL, BNIL);
				      list1654_869 = MAKE_PAIR(arg1652_867, arg1655_870);
				   }
				   arg1650_865 = cons__138___r4_pairs_and_lists_6_3(arg1651_866, list1654_869);
				}
			     }
			     produce_module_clause__172_module_module(arg1650_865);
			  }
			  {
			     obj_t arg1667_879;
			     {
				obj_t arg1668_880;
				obj_t arg1669_881;
				arg1668_880 = CNST_TABLE_REF(((long) 7));
				{
				   obj_t arg1677_886;
				   obj_t arg1678_887;
				   {
				      obj_t arg1686_893;
				      obj_t arg1687_894;
				      arg1686_893 = CNST_TABLE_REF(((long) 18));
				      {
					 type_t obj_2678;
					 obj_2678 = (type_t) (class_59);
					 arg1687_894 = (((type_t) CREF(obj_2678))->id);
				      }
				      {
					 obj_t list1689_896;
					 {
					    obj_t arg1690_897;
					    arg1690_897 = MAKE_PAIR(BNIL, BNIL);
					    list1689_896 = MAKE_PAIR(arg1687_894, arg1690_897);
					 }
					 arg1677_886 = cons__138___r4_pairs_and_lists_6_3(arg1686_893, list1689_896);
				      }
				   }
				   arg1678_887 = CNST_TABLE_REF(((long) 9));
				   {
				      obj_t list1680_889;
				      {
					 obj_t arg1681_890;
					 {
					    obj_t arg1682_891;
					    arg1682_891 = MAKE_PAIR(BNIL, BNIL);
					    arg1681_890 = MAKE_PAIR(arg1678_887, arg1682_891);
					 }
					 list1680_889 = MAKE_PAIR(arg1677_886, arg1681_890);
				      }
				      arg1669_881 = cons__138___r4_pairs_and_lists_6_3(id__219_858, list1680_889);
				   }
				}
				{
				   obj_t list1672_883;
				   {
				      obj_t arg1673_884;
				      arg1673_884 = MAKE_PAIR(BNIL, BNIL);
				      list1672_883 = MAKE_PAIR(arg1669_881, arg1673_884);
				   }
				   arg1667_879 = cons__138___r4_pairs_and_lists_6_3(arg1668_880, list1672_883);
				}
			     }
			     produce_module_clause__172_module_module(arg1667_879);
			  }
			  {
			     obj_t arg1693_899;
			     {
				obj_t arg1696_902;
				obj_t arg1697_903;
				obj_t arg1698_904;
				arg1696_902 = CNST_TABLE_REF(((long) 19));
				{
				   obj_t arg1704_910;
				   arg1704_910 = CNST_TABLE_REF(((long) 5));
				   {
				      obj_t list1706_912;
				      {
					 obj_t arg1707_913;
					 arg1707_913 = MAKE_PAIR(BNIL, BNIL);
					 list1706_912 = MAKE_PAIR(arg1704_910, arg1707_913);
				      }
				      arg1697_903 = cons__138___r4_pairs_and_lists_6_3(pred_id_222_859, list1706_912);
				   }
				}
				{
				   obj_t arg1709_915;
				   obj_t arg1710_916;
				   obj_t arg1711_917;
				   arg1709_915 = CNST_TABLE_REF(((long) 20));
				   arg1710_916 = CNST_TABLE_REF(((long) 5));
				   {
				      obj_t arg1717_923;
				      obj_t arg1718_924;
				      obj_t arg1719_925;
				      arg1717_923 = CNST_TABLE_REF(((long) 21));
				      arg1718_924 = (((global_t) CREF(holder_860))->id);
				      arg1719_925 = (((global_t) CREF(holder_860))->module);
				      {
					 obj_t list1721_927;
					 {
					    obj_t arg1722_928;
					    {
					       obj_t arg1724_929;
					       arg1724_929 = MAKE_PAIR(BNIL, BNIL);
					       arg1722_928 = MAKE_PAIR(arg1719_925, arg1724_929);
					    }
					    list1721_927 = MAKE_PAIR(arg1718_924, arg1722_928);
					 }
					 arg1711_917 = cons__138___r4_pairs_and_lists_6_3(arg1717_923, list1721_927);
				      }
				   }
				   {
				      obj_t list1713_919;
				      {
					 obj_t arg1714_920;
					 {
					    obj_t arg1715_921;
					    arg1715_921 = MAKE_PAIR(BNIL, BNIL);
					    arg1714_920 = MAKE_PAIR(arg1711_917, arg1715_921);
					 }
					 list1713_919 = MAKE_PAIR(arg1710_916, arg1714_920);
				      }
				      arg1698_904 = cons__138___r4_pairs_and_lists_6_3(arg1709_915, list1713_919);
				   }
				}
				{
				   obj_t list1700_906;
				   {
				      obj_t arg1701_907;
				      {
					 obj_t arg1702_908;
					 arg1702_908 = MAKE_PAIR(BNIL, BNIL);
					 arg1701_907 = MAKE_PAIR(arg1698_904, arg1702_908);
				      }
				      list1700_906 = MAKE_PAIR(arg1697_903, arg1701_907);
				   }
				   arg1693_899 = cons__138___r4_pairs_and_lists_6_3(arg1696_902, list1700_906);
				}
			     }
			     {
				obj_t list1694_900;
				list1694_900 = MAKE_PAIR(arg1693_899, BNIL);
				return list1694_900;
			     }
			  }
		       }
		     else
		       {
			  return BNIL;
		       }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
make_class_makes_39_object_access(obj_t widening_60, obj_t mk_id_77_61, obj_t id_62, type_t type_63, obj_t slots_64)
{
   {
      obj_t mk_heap_id_73_949;
      obj_t mk_stack_id_29_950;
      {
	 obj_t arg1780_978;
	 arg1780_978 = CNST_TABLE_REF(((long) 22));
	 {
	    obj_t list1781_979;
	    {
	       obj_t arg1783_980;
	       {
		  obj_t arg1784_981;
		  arg1784_981 = MAKE_PAIR(id_62, BNIL);
		  arg1783_980 = MAKE_PAIR(arg1780_978, arg1784_981);
	       }
	       list1781_979 = MAKE_PAIR(mk_id_77_61, arg1783_980);
	    }
	    mk_heap_id_73_949 = symbol_append_197___r4_symbols_6_4(list1781_979);
	 }
      }
      {
	 obj_t arg1786_983;
	 arg1786_983 = CNST_TABLE_REF(((long) 23));
	 {
	    obj_t list1787_984;
	    {
	       obj_t arg1788_985;
	       {
		  obj_t arg1789_986;
		  arg1789_986 = MAKE_PAIR(id_62, BNIL);
		  arg1788_985 = MAKE_PAIR(arg1786_983, arg1789_986);
	       }
	       list1787_984 = MAKE_PAIR(mk_id_77_61, arg1788_985);
	    }
	    mk_stack_id_29_950 = symbol_append_197___r4_symbols_6_4(list1787_984);
	 }
      }
      {
	 bool_t test1750_951;
	 {
	    bool_t test1779_977;
	    {
	       long n1_2682;
	       n1_2682 = (long) CINT(__optim__89_engine_param);
	       test1779_977 = (n1_2682 < ((long) 2));
	    }
	    if (test1779_977)
	      {
		 test1750_951 = ((bool_t) 1);
	      }
	    else
	      {
		 if (CBOOL(__optim_stack___57_engine_param))
		   {
		      test1750_951 = ((bool_t) 0);
		   }
		 else
		   {
		      test1750_951 = ((bool_t) 1);
		   }
	      }
	 }
	 if (test1750_951)
	   {
	      obj_t arg1751_952;
	      arg1751_952 = make_class_make_159_object_access(widening_60, malloc_env_105_object_tools, mk_heap_id_73_949, id_62, type_63, slots_64);
	      {
		 obj_t list1752_953;
		 list1752_953 = MAKE_PAIR(arg1751_952, BNIL);
		 return list1752_953;
	      }
	   }
	 else
	   {
	      {
		 obj_t arg1754_955;
		 {
		    obj_t arg1755_956;
		    obj_t arg1756_957;
		    arg1755_956 = CNST_TABLE_REF(((long) 7));
		    {
		       obj_t arg1763_962;
		       {
			  obj_t arg1769_967;
			  arg1769_967 = CNST_TABLE_REF(((long) 24));
			  {
			     obj_t list1771_969;
			     {
				obj_t arg1772_970;
				arg1772_970 = MAKE_PAIR(BNIL, BNIL);
				list1771_969 = MAKE_PAIR(mk_stack_id_29_950, arg1772_970);
			     }
			     arg1763_962 = cons__138___r4_pairs_and_lists_6_3(arg1769_967, list1771_969);
			  }
		       }
		       {
			  obj_t list1765_964;
			  {
			     obj_t arg1766_965;
			     arg1766_965 = MAKE_PAIR(BNIL, BNIL);
			     list1765_964 = MAKE_PAIR(arg1763_962, arg1766_965);
			  }
			  arg1756_957 = cons__138___r4_pairs_and_lists_6_3(mk_heap_id_73_949, list1765_964);
		       }
		    }
		    {
		       obj_t list1759_959;
		       {
			  obj_t arg1761_960;
			  arg1761_960 = MAKE_PAIR(BNIL, BNIL);
			  list1759_959 = MAKE_PAIR(arg1756_957, arg1761_960);
		       }
		       arg1754_955 = cons__138___r4_pairs_and_lists_6_3(arg1755_956, list1759_959);
		    }
		 }
		 produce_module_clause__172_module_module(arg1754_955);
	      }
	      {
		 obj_t arg1774_972;
		 obj_t arg1775_973;
		 arg1774_972 = make_class_make_159_object_access(widening_60, alloca_env_212_object_tools, mk_stack_id_29_950, id_62, type_63, slots_64);
		 arg1775_973 = make_class_make_159_object_access(widening_60, malloc_env_105_object_tools, mk_heap_id_73_949, id_62, type_63, slots_64);
		 {
		    obj_t list1776_974;
		    {
		       obj_t arg1777_975;
		       arg1777_975 = MAKE_PAIR(arg1775_973, BNIL);
		       list1776_974 = MAKE_PAIR(arg1774_972, arg1777_975);
		    }
		    return list1776_974;
		 }
	      }
	   }
      }
   }
}


obj_t 
make_class_make_159_object_access(obj_t widening_65, obj_t alloc_66, obj_t mk_id_77_67, obj_t id_68, type_t type_69, obj_t slots_70)
{
   {
      obj_t tid_988;
      tid_988 = (((type_t) CREF(type_69))->id);
      {
	 global_t holder_989;
	 {
	    class_t obj_2687;
	    obj_2687 = (class_t) (type_69);
	    {
	       obj_t aux_3534;
	       {
		  object_t aux_3535;
		  aux_3535 = (object_t) (obj_2687);
		  aux_3534 = OBJECT_WIDENING(aux_3535);
	       }
	       holder_989 = (((class_t) CREF(aux_3534))->holder);
	    }
	 }
	 {
	    obj_t mk_tid_99_990;
	    {
	       obj_t list2157_1353;
	       {
		  obj_t arg2160_1354;
		  {
		     obj_t arg2161_1355;
		     arg2161_1355 = MAKE_PAIR(tid_988, BNIL);
		     arg2160_1354 = MAKE_PAIR(_4dots_tools_misc, arg2161_1355);
		  }
		  list2157_1353 = MAKE_PAIR(mk_id_77_67, arg2160_1354);
	       }
	       mk_tid_99_990 = symbol_append_197___r4_symbols_6_4(list2157_1353);
	    }
	    {
	       obj_t f_ids_164_991;
	       if (NULLP(slots_70))
		 {
		    f_ids_164_991 = BNIL;
		 }
	       else
		 {
		    obj_t head1137_1339;
		    {
		       obj_t aux_3545;
		       {
			  obj_t aux_3546;
			  aux_3546 = CAR(slots_70);
			  aux_3545 = STRUCT_REF(aux_3546, ((long) 0));
		       }
		       head1137_1339 = MAKE_PAIR(aux_3545, BNIL);
		    }
		    {
		       obj_t l1134_1340;
		       obj_t tail1138_1341;
		       l1134_1340 = CDR(slots_70);
		       tail1138_1341 = head1137_1339;
		     lname1136_1342:
		       if (NULLP(l1134_1340))
			 {
			    f_ids_164_991 = head1137_1339;
			 }
		       else
			 {
			    obj_t new_tail1139_204_1345;
			    {
			       obj_t aux_3552;
			       {
				  obj_t aux_3553;
				  aux_3553 = CAR(l1134_1340);
				  aux_3552 = STRUCT_REF(aux_3553, ((long) 0));
			       }
			       new_tail1139_204_1345 = MAKE_PAIR(aux_3552, BNIL);
			    }
			    SET_CDR(tail1138_1341, new_tail1139_204_1345);
			    {
			       obj_t tail1138_3560;
			       obj_t l1134_3558;
			       l1134_3558 = CDR(l1134_1340);
			       tail1138_3560 = new_tail1139_204_1345;
			       tail1138_1341 = tail1138_3560;
			       l1134_1340 = l1134_3558;
			       goto lname1136_1342;
			    }
			 }
		    }
		 }
	       {
		  obj_t f_tids_193_992;
		  if (NULLP(slots_70))
		    {
		       f_tids_193_992 = BNIL;
		    }
		  else
		    {
		       obj_t head1142_1318;
		       head1142_1318 = MAKE_PAIR(BNIL, BNIL);
		       {
			  obj_t l1140_1319;
			  obj_t tail1143_1320;
			  l1140_1319 = slots_70;
			  tail1143_1320 = head1142_1318;
			lname1141_1321:
			  if (NULLP(l1140_1319))
			    {
			       f_tids_193_992 = CDR(head1142_1318);
			    }
			  else
			    {
			       obj_t new_tail1144_238_1323;
			       {
				  obj_t arg2134_1325;
				  {
				     obj_t slot_1327;
				     slot_1327 = CAR(l1140_1319);
				     {
					obj_t arg2136_1328;
					arg2136_1328 = STRUCT_REF(slot_1327, ((long) 0));
					{
					   obj_t list2138_1330;
					   {
					      obj_t arg2139_1331;
					      {
						 obj_t arg2141_1332;
						 {
						    obj_t aux_3570;
						    {
						       type_t obj_2718;
						       {
							  obj_t aux_3571;
							  aux_3571 = STRUCT_REF(slot_1327, ((long) 2));
							  obj_2718 = (type_t) (aux_3571);
						       }
						       aux_3570 = (((type_t) CREF(obj_2718))->id);
						    }
						    arg2141_1332 = MAKE_PAIR(aux_3570, BNIL);
						 }
						 arg2139_1331 = MAKE_PAIR(_4dots_tools_misc, arg2141_1332);
					      }
					      list2138_1330 = MAKE_PAIR(arg2136_1328, arg2139_1331);
					   }
					   arg2134_1325 = symbol_append_197___r4_symbols_6_4(list2138_1330);
					}
				     }
				  }
				  new_tail1144_238_1323 = MAKE_PAIR(arg2134_1325, BNIL);
			       }
			       SET_CDR(tail1143_1320, new_tail1144_238_1323);
			       {
				  obj_t tail1143_3583;
				  obj_t l1140_3581;
				  l1140_3581 = CDR(l1140_1319);
				  tail1143_3583 = new_tail1144_238_1323;
				  tail1143_1320 = tail1143_3583;
				  l1140_1319 = l1140_3581;
				  goto lname1141_1321;
			       }
			    }
		       }
		    }
		  {
		     obj_t loop_993;
		     loop_993 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 25)), BEOA);
		     {
			obj_t new_994;
			new_994 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 26)), BEOA);
			{
			   obj_t rid_995;
			   rid_995 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 27)), BEOA);
			   {
			      obj_t rtid_996;
			      {
				 obj_t list2125_1310;
				 {
				    obj_t arg2126_1311;
				    {
				       obj_t aux_3593;
				       aux_3593 = CNST_TABLE_REF(((long) 28));
				       arg2126_1311 = MAKE_PAIR(aux_3593, BNIL);
				    }
				    list2125_1310 = MAKE_PAIR(rid_995, arg2126_1311);
				 }
				 rtid_996 = symbol_append_197___r4_symbols_6_4(list2125_1310);
			      }
			      {
				 {
				    obj_t arg1792_997;
				    {
				       obj_t arg1793_998;
				       obj_t arg1795_999;
				       arg1793_998 = CNST_TABLE_REF(((long) 15));
				       {
					  obj_t arg1800_1004;
					  {
					     obj_t arg1802_1006;
					     obj_t arg1804_1007;
					     {
						bool_t test1805_1008;
						{
						   long n1_2724;
						   n1_2724 = (long) CINT(__optim__89_engine_param);
						   test1805_1008 = (n1_2724 >= ((long) 2));
						}
						if (test1805_1008)
						  {
						     arg1802_1006 = CNST_TABLE_REF(((long) 29));
						  }
						else
						  {
						     arg1802_1006 = BNIL;
						  }
					     }
					     {
						obj_t arg1806_1009;
						{
						   obj_t arg1809_1012;
						   arg1809_1012 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
						   arg1806_1009 = append_2_18___r4_pairs_and_lists_6_3(f_tids_193_992, arg1809_1012);
						}
						{
						   obj_t list1807_1010;
						   list1807_1010 = MAKE_PAIR(arg1806_1009, BNIL);
						   arg1804_1007 = cons__138___r4_pairs_and_lists_6_3(mk_tid_99_990, list1807_1010);
						}
					     }
					     arg1800_1004 = append_2_18___r4_pairs_and_lists_6_3(arg1802_1006, arg1804_1007);
					  }
					  arg1795_999 = cons__138___r4_pairs_and_lists_6_3(arg1800_1004, BNIL);
				       }
				       {
					  obj_t list1797_1001;
					  {
					     obj_t arg1798_1002;
					     arg1798_1002 = MAKE_PAIR(BNIL, BNIL);
					     list1797_1001 = MAKE_PAIR(arg1795_999, arg1798_1002);
					  }
					  arg1792_997 = cons__138___r4_pairs_and_lists_6_3(arg1793_998, list1797_1001);
				       }
				    }
				    produce_module_clause__172_module_module(arg1792_997);
				 }
				 {
				    obj_t arg1812_1015;
				    obj_t arg1813_1016;
				    obj_t arg1814_1017;
				    {
				       bool_t test1824_1023;
				       {
					  long n1_2726;
					  n1_2726 = (long) CINT(__optim__89_engine_param);
					  test1824_1023 = (n1_2726 >= ((long) 2));
				       }
				       if (test1824_1023)
					 {
					    arg1812_1015 = CNST_TABLE_REF(((long) 19));
					 }
				       else
					 {
					    arg1812_1015 = CNST_TABLE_REF(((long) 30));
					 }
				    }
				    {
				       obj_t arg1825_1024;
				       {
					  obj_t arg1828_1027;
					  arg1828_1027 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
					  arg1825_1024 = append_2_18___r4_pairs_and_lists_6_3(f_tids_193_992, arg1828_1027);
				       }
				       {
					  obj_t list1826_1025;
					  list1826_1025 = MAKE_PAIR(arg1825_1024, BNIL);
					  arg1813_1016 = cons__138___r4_pairs_and_lists_6_3(mk_tid_99_990, list1826_1025);
				       }
				    }
				    {
				       obj_t arg1831_1030;
				       obj_t arg1832_1031;
				       obj_t arg1833_1032;
				       arg1831_1030 = CNST_TABLE_REF(((long) 31));
				       {
					  obj_t arg1837_1036;
					  {
					     obj_t arg1841_1040;
					     obj_t arg1842_1041;
					     {
						obj_t list1847_1046;
						{
						   obj_t arg1848_1047;
						   {
						      obj_t arg1849_1048;
						      arg1849_1048 = MAKE_PAIR(tid_988, BNIL);
						      arg1848_1047 = MAKE_PAIR(_4dots_tools_misc, arg1849_1048);
						   }
						   list1847_1046 = MAKE_PAIR(new_994, arg1848_1047);
						}
						arg1841_1040 = symbol_append_197___r4_symbols_6_4(list1847_1046);
					     }
					     arg1842_1041 = PROCEDURE_ENTRY(alloc_66) (alloc_66, (obj_t) (type_69), BINT(((long) 1)), BEOA);
					     {
						obj_t list1844_1043;
						{
						   obj_t arg1845_1044;
						   arg1845_1044 = MAKE_PAIR(BNIL, BNIL);
						   list1844_1043 = MAKE_PAIR(arg1842_1041, arg1845_1044);
						}
						arg1837_1036 = cons__138___r4_pairs_and_lists_6_3(arg1841_1040, list1844_1043);
					     }
					  }
					  {
					     obj_t list1839_1038;
					     list1839_1038 = MAKE_PAIR(BNIL, BNIL);
					     arg1832_1031 = cons__138___r4_pairs_and_lists_6_3(arg1837_1036, list1839_1038);
					  }
				       }
				       {
					  obj_t arg1853_1050;
					  obj_t arg1855_1051;
					  {
					     bool_t test_3636;
					     {
						obj_t aux_3637;
						aux_3637 = CNST_TABLE_REF(((long) 2));
						test_3636 = (widening_65 == aux_3637);
					     }
					     if (test_3636)
					       {
						  arg1853_1050 = BNIL;
					       }
					     else
					       {
						  obj_t arg1857_1053;
						  obj_t arg1858_1054;
						  {
						     obj_t arg1863_1059;
						     obj_t arg1864_1060;
						     arg1863_1059 = CNST_TABLE_REF(((long) 32));
						     {
							obj_t arg1872_1066;
							obj_t arg1874_1067;
							arg1872_1066 = CNST_TABLE_REF(((long) 33));
							{
							   obj_t arg1880_1072;
							   obj_t arg1881_1073;
							   obj_t arg1882_1074;
							   arg1880_1072 = CNST_TABLE_REF(((long) 21));
							   arg1881_1073 = (((global_t) CREF(holder_989))->id);
							   arg1882_1074 = (((global_t) CREF(holder_989))->module);
							   {
							      obj_t list1884_1076;
							      {
								 obj_t arg1885_1077;
								 {
								    obj_t arg1886_1078;
								    arg1886_1078 = MAKE_PAIR(BNIL, BNIL);
								    arg1885_1077 = MAKE_PAIR(arg1882_1074, arg1886_1078);
								 }
								 list1884_1076 = MAKE_PAIR(arg1881_1073, arg1885_1077);
							      }
							      arg1874_1067 = cons__138___r4_pairs_and_lists_6_3(arg1880_1072, list1884_1076);
							   }
							}
							{
							   obj_t list1876_1069;
							   {
							      obj_t arg1877_1070;
							      arg1877_1070 = MAKE_PAIR(BNIL, BNIL);
							      list1876_1069 = MAKE_PAIR(arg1874_1067, arg1877_1070);
							   }
							   arg1864_1060 = cons__138___r4_pairs_and_lists_6_3(arg1872_1066, list1876_1069);
							}
						     }
						     {
							obj_t list1866_1062;
							{
							   obj_t arg1867_1063;
							   {
							      obj_t arg1870_1064;
							      arg1870_1064 = MAKE_PAIR(BNIL, BNIL);
							      arg1867_1063 = MAKE_PAIR(arg1864_1060, arg1870_1064);
							   }
							   list1866_1062 = MAKE_PAIR(new_994, arg1867_1063);
							}
							arg1857_1053 = cons__138___r4_pairs_and_lists_6_3(arg1863_1059, list1866_1062);
						     }
						  }
						  {
						     obj_t arg1889_1080;
						     arg1889_1080 = CNST_TABLE_REF(((long) 34));
						     {
							obj_t list1891_1082;
							{
							   obj_t arg1892_1083;
							   {
							      obj_t arg1893_1084;
							      arg1893_1084 = MAKE_PAIR(BNIL, BNIL);
							      arg1892_1083 = MAKE_PAIR(BFALSE, arg1893_1084);
							   }
							   list1891_1082 = MAKE_PAIR(new_994, arg1892_1083);
							}
							arg1858_1054 = cons__138___r4_pairs_and_lists_6_3(arg1889_1080, list1891_1082);
						     }
						  }
						  {
						     obj_t list1860_1056;
						     {
							obj_t arg1861_1057;
							arg1861_1057 = MAKE_PAIR(BNIL, BNIL);
							list1860_1056 = MAKE_PAIR(arg1858_1054, arg1861_1057);
						     }
						     arg1853_1050 = cons__138___r4_pairs_and_lists_6_3(arg1857_1053, list1860_1056);
						  }
					       }
					  }
					  {
					     obj_t arg1896_1087;
					     {
						obj_t arg1900_1091;
						obj_t arg1901_1092;
						obj_t arg1902_1093;
						arg1900_1091 = CNST_TABLE_REF(((long) 31));
						if (NULLP(f_tids_193_992))
						  {
						     arg1901_1092 = BNIL;
						  }
						else
						  {
						     obj_t head1147_1100;
						     head1147_1100 = MAKE_PAIR(BNIL, BNIL);
						     {
							obj_t ll1145_1101;
							obj_t ll1146_1102;
							obj_t tail1148_1103;
							ll1145_1101 = f_tids_193_992;
							ll1146_1102 = f_ids_164_991;
							tail1148_1103 = head1147_1100;
						      lname1150_1104:
							if (NULLP(ll1145_1101))
							  {
							     arg1901_1092 = CDR(head1147_1100);
							  }
							else
							  {
							     obj_t new_tail1149_78_1106;
							     {
								obj_t arg1911_1109;
								{
								   obj_t ft_1111;
								   obj_t f_1112;
								   ft_1111 = CAR(ll1145_1101);
								   f_1112 = CAR(ll1146_1102);
								   {
								      obj_t list1914_1114;
								      {
									 obj_t arg1915_1115;
									 arg1915_1115 = MAKE_PAIR(BNIL, BNIL);
									 list1914_1114 = MAKE_PAIR(f_1112, arg1915_1115);
								      }
								      arg1911_1109 = cons__138___r4_pairs_and_lists_6_3(ft_1111, list1914_1114);
								   }
								}
								new_tail1149_78_1106 = MAKE_PAIR(arg1911_1109, BNIL);
							     }
							     SET_CDR(tail1148_1103, new_tail1149_78_1106);
							     {
								obj_t tail1148_3682;
								obj_t ll1146_3680;
								obj_t ll1145_3678;
								ll1145_3678 = CDR(ll1145_1101);
								ll1146_3680 = CDR(ll1146_1102);
								tail1148_3682 = new_tail1149_78_1106;
								tail1148_1103 = tail1148_3682;
								ll1146_1102 = ll1146_3680;
								ll1145_1101 = ll1145_3678;
								goto lname1150_1104;
							     }
							  }
						     }
						  }
						{
						   obj_t arg1921_1119;
						   obj_t arg1922_1120;
						   if (NULLP(slots_70))
						     {
							arg1921_1119 = BNIL;
						     }
						   else
						     {
							obj_t head1153_1124;
							head1153_1124 = MAKE_PAIR(BNIL, BNIL);
							{
							   obj_t ll1151_1125;
							   obj_t ll1152_1126;
							   obj_t tail1154_1127;
							   ll1151_1125 = slots_70;
							   ll1152_1126 = f_ids_164_991;
							   tail1154_1127 = head1153_1124;
							 lname1157_1128:
							   if (NULLP(ll1151_1125))
							     {
								arg1921_1119 = CDR(head1153_1124);
							     }
							   else
							     {
								obj_t new_tail1155_22_1130;
								{
								   obj_t arg1927_1133;
								   {
								      obj_t slot_1135;
								      obj_t formal_1136;
								      slot_1135 = CAR(ll1151_1125);
								      formal_1136 = CAR(ll1152_1126);
								      {
									 bool_t test_3691;
									 {
									    obj_t aux_3692;
									    aux_3692 = STRUCT_REF(slot_1135, ((long) 5));
									    test_3691 = CBOOL(aux_3692);
									 }
									 if (test_3691)
									   {
									      {
										 obj_t arg1931_1138;
										 obj_t arg1932_1139;
										 obj_t arg1934_1140;
										 arg1931_1138 = CNST_TABLE_REF(((long) 35));
										 {
										    obj_t arg1940_1146;
										    {
										       obj_t arg1941_1147;
										       obj_t arg1942_1148;
										       arg1941_1147 = STRUCT_REF(slot_1135, ((long) 2));
										       {
											  obj_t list1944_1150;
											  {
											     obj_t arg1945_1151;
											     {
												obj_t aux_3697;
												aux_3697 = CNST_TABLE_REF(((long) 36));
												arg1945_1151 = MAKE_PAIR(aux_3697, BNIL);
											     }
											     list1944_1150 = MAKE_PAIR(formal_1136, arg1945_1151);
											  }
											  arg1942_1148 = symbol_append_197___r4_symbols_6_4(list1944_1150);
										       }
										       arg1940_1146 = malloc_object_tools((type_t) (arg1941_1147), arg1942_1148);
										    }
										    arg1932_1139 = make_pragma_indexed_init_set__66_object_tools(type_69, slot_1135, new_994, arg1940_1146);
										 }
										 {
										    obj_t arg1948_1153;
										    obj_t arg1949_1154;
										    obj_t arg1950_1155;
										    arg1948_1153 = CNST_TABLE_REF(((long) 37));
										    {
										       obj_t arg1957_1161;
										       {
											  obj_t arg1963_1165;
											  obj_t arg1964_1166;
											  {
											     obj_t list1971_1173;
											     list1971_1173 = MAKE_PAIR(BNIL, BNIL);
											     arg1963_1165 = cons__138___r4_pairs_and_lists_6_3(rtid_996, list1971_1173);
											  }
											  {
											     obj_t arg1973_1175;
											     obj_t arg1974_1176;
											     obj_t arg1975_1177;
											     obj_t arg1976_1178;
											     arg1973_1175 = CNST_TABLE_REF(((long) 38));
											     {
												obj_t arg1983_1185;
												obj_t arg1984_1186;
												arg1983_1185 = CNST_TABLE_REF(((long) 39));
												{
												   obj_t list1991_1193;
												   {
												      obj_t arg1992_1194;
												      {
													 obj_t aux_3710;
													 aux_3710 = CNST_TABLE_REF(((long) 36));
													 arg1992_1194 = MAKE_PAIR(aux_3710, BNIL);
												      }
												      list1991_1193 = MAKE_PAIR(formal_1136, arg1992_1194);
												   }
												   arg1984_1186 = symbol_append_197___r4_symbols_6_4(list1991_1193);
												}
												{
												   obj_t list1986_1188;
												   {
												      obj_t arg1987_1189;
												      {
													 obj_t arg1988_1190;
													 arg1988_1190 = MAKE_PAIR(BNIL, BNIL);
													 arg1987_1189 = MAKE_PAIR(arg1984_1186, arg1988_1190);
												      }
												      list1986_1188 = MAKE_PAIR(rid_995, arg1987_1189);
												   }
												   arg1974_1176 = cons__138___r4_pairs_and_lists_6_3(arg1983_1185, list1986_1188);
												}
											     }
											     {
												obj_t arg1995_1196;
												obj_t arg1996_1197;
												arg1995_1196 = CNST_TABLE_REF(((long) 40));
												arg1996_1197 = CNST_TABLE_REF(((long) 41));
												{
												   obj_t list1998_1199;
												   {
												      obj_t arg1999_1200;
												      arg1999_1200 = MAKE_PAIR(BNIL, BNIL);
												      list1998_1199 = MAKE_PAIR(arg1996_1197, arg1999_1200);
												   }
												   arg1975_1177 = cons__138___r4_pairs_and_lists_6_3(arg1995_1196, list1998_1199);
												}
											     }
											     {
												obj_t arg2001_1202;
												obj_t arg2002_1203;
												obj_t arg2003_1204;
												arg2001_1202 = CNST_TABLE_REF(((long) 35));
												arg2002_1203 = make_pragma_indexed_set__widening_24_object_tools(type_69, slot_1135, new_994, formal_1136, rid_995, BFALSE);
												{
												   obj_t arg2009_1210;
												   {
												      obj_t arg2016_1215;
												      arg2016_1215 = CNST_TABLE_REF(((long) 42));
												      {
													 obj_t list2019_1218;
													 {
													    obj_t arg2020_1219;
													    {
													       obj_t arg2021_1220;
													       arg2021_1220 = MAKE_PAIR(BNIL, BNIL);
													       {
														  obj_t aux_3728;
														  aux_3728 = BINT(((long) 1));
														  arg2020_1219 = MAKE_PAIR(aux_3728, arg2021_1220);
													       }
													    }
													    list2019_1218 = MAKE_PAIR(rid_995, arg2020_1219);
													 }
													 arg2009_1210 = cons__138___r4_pairs_and_lists_6_3(arg2016_1215, list2019_1218);
												      }
												   }
												   {
												      obj_t list2013_1212;
												      {
													 obj_t arg2014_1213;
													 arg2014_1213 = MAKE_PAIR(BNIL, BNIL);
													 list2013_1212 = MAKE_PAIR(arg2009_1210, arg2014_1213);
												      }
												      arg2003_1204 = cons__138___r4_pairs_and_lists_6_3(loop_993, list2013_1212);
												   }
												}
												{
												   obj_t list2005_1206;
												   {
												      obj_t arg2006_1207;
												      {
													 obj_t arg2007_1208;
													 arg2007_1208 = MAKE_PAIR(BNIL, BNIL);
													 arg2006_1207 = MAKE_PAIR(arg2003_1204, arg2007_1208);
												      }
												      list2005_1206 = MAKE_PAIR(arg2002_1203, arg2006_1207);
												   }
												   arg1976_1178 = cons__138___r4_pairs_and_lists_6_3(arg2001_1202, list2005_1206);
												}
											     }
											     {
												obj_t list1978_1180;
												{
												   obj_t arg1979_1181;
												   {
												      obj_t arg1980_1182;
												      {
													 obj_t arg1981_1183;
													 arg1981_1183 = MAKE_PAIR(BNIL, BNIL);
													 arg1980_1182 = MAKE_PAIR(arg1976_1178, arg1981_1183);
												      }
												      arg1979_1181 = MAKE_PAIR(arg1975_1177, arg1980_1182);
												   }
												   list1978_1180 = MAKE_PAIR(arg1974_1176, arg1979_1181);
												}
												arg1964_1166 = cons__138___r4_pairs_and_lists_6_3(arg1973_1175, list1978_1180);
											     }
											  }
											  {
											     obj_t list1966_1168;
											     {
												obj_t arg1967_1169;
												{
												   obj_t arg1968_1170;
												   arg1968_1170 = MAKE_PAIR(BNIL, BNIL);
												   arg1967_1169 = MAKE_PAIR(arg1964_1166, arg1968_1170);
												}
												list1966_1168 = MAKE_PAIR(arg1963_1165, arg1967_1169);
											     }
											     arg1957_1161 = cons__138___r4_pairs_and_lists_6_3(loop_993, list1966_1168);
											  }
										       }
										       {
											  obj_t list1959_1163;
											  list1959_1163 = MAKE_PAIR(BNIL, BNIL);
											  arg1949_1154 = cons__138___r4_pairs_and_lists_6_3(arg1957_1161, list1959_1163);
										       }
										    }
										    {
										       obj_t list2027_1224;
										       {
											  obj_t arg2028_1225;
											  arg2028_1225 = MAKE_PAIR(BNIL, BNIL);
											  {
											     obj_t aux_3752;
											     aux_3752 = BINT(((long) 0));
											     list2027_1224 = MAKE_PAIR(aux_3752, arg2028_1225);
											  }
										       }
										       arg1950_1155 = cons__138___r4_pairs_and_lists_6_3(loop_993, list2027_1224);
										    }
										    {
										       obj_t list1952_1157;
										       {
											  obj_t arg1953_1158;
											  {
											     obj_t arg1954_1159;
											     arg1954_1159 = MAKE_PAIR(BNIL, BNIL);
											     arg1953_1158 = MAKE_PAIR(arg1950_1155, arg1954_1159);
											  }
											  list1952_1157 = MAKE_PAIR(arg1949_1154, arg1953_1158);
										       }
										       arg1934_1140 = cons__138___r4_pairs_and_lists_6_3(arg1948_1153, list1952_1157);
										    }
										 }
										 {
										    obj_t list1936_1142;
										    {
										       obj_t arg1937_1143;
										       {
											  obj_t arg1938_1144;
											  arg1938_1144 = MAKE_PAIR(BNIL, BNIL);
											  arg1937_1143 = MAKE_PAIR(arg1934_1140, arg1938_1144);
										       }
										       list1936_1142 = MAKE_PAIR(arg1932_1139, arg1937_1143);
										    }
										    arg1927_1133 = cons__138___r4_pairs_and_lists_6_3(arg1931_1138, list1936_1142);
										 }
									      }
									   }
									 else
									   {
									      bool_t test_3764;
									      {
										 obj_t aux_3765;
										 aux_3765 = STRUCT_REF(slot_1135, ((long) 3));
										 test_3764 = CBOOL(aux_3765);
									      }
									      if (test_3764)
										{
										   {
										      obj_t arg2031_1228;
										      obj_t arg2032_1229;
										      obj_t arg2033_1230;
										      arg2031_1228 = CNST_TABLE_REF(((long) 37));
										      {
											 obj_t arg2040_1236;
											 {
											    obj_t arg2045_1240;
											    obj_t arg2046_1241;
											    {
											       obj_t list2054_1248;
											       list2054_1248 = MAKE_PAIR(BNIL, BNIL);
											       arg2045_1240 = cons__138___r4_pairs_and_lists_6_3(rtid_996, list2054_1248);
											    }
											    {
											       obj_t arg2056_1250;
											       obj_t arg2057_1251;
											       obj_t arg2058_1252;
											       obj_t arg2059_1253;
											       arg2056_1250 = CNST_TABLE_REF(((long) 38));
											       {
												  obj_t arg2069_1260;
												  obj_t arg2070_1261;
												  arg2069_1260 = CNST_TABLE_REF(((long) 39));
												  {
												     obj_t arg2077_1267;
												     obj_t arg2078_1268;
												     arg2077_1267 = CNST_TABLE_REF(((long) 43));
												     arg2078_1268 = STRUCT_REF(slot_1135, ((long) 4));
												     {
													obj_t list2080_1270;
													{
													   obj_t arg2081_1271;
													   arg2081_1271 = MAKE_PAIR(BNIL, BNIL);
													   list2080_1270 = MAKE_PAIR(arg2078_1268, arg2081_1271);
													}
													arg2070_1261 = cons__138___r4_pairs_and_lists_6_3(arg2077_1267, list2080_1270);
												     }
												  }
												  {
												     obj_t list2072_1263;
												     {
													obj_t arg2073_1264;
													{
													   obj_t arg2074_1265;
													   arg2074_1265 = MAKE_PAIR(BNIL, BNIL);
													   arg2073_1264 = MAKE_PAIR(arg2070_1261, arg2074_1265);
													}
													list2072_1263 = MAKE_PAIR(rid_995, arg2073_1264);
												     }
												     arg2057_1251 = cons__138___r4_pairs_and_lists_6_3(arg2069_1260, list2072_1263);
												  }
											       }
											       {
												  obj_t arg2084_1273;
												  obj_t arg2085_1274;
												  arg2084_1273 = CNST_TABLE_REF(((long) 40));
												  arg2085_1274 = CNST_TABLE_REF(((long) 41));
												  {
												     obj_t list2087_1276;
												     {
													obj_t arg2088_1277;
													arg2088_1277 = MAKE_PAIR(BNIL, BNIL);
													list2087_1276 = MAKE_PAIR(arg2085_1274, arg2088_1277);
												     }
												     arg2058_1252 = cons__138___r4_pairs_and_lists_6_3(arg2084_1273, list2087_1276);
												  }
											       }
											       {
												  obj_t arg2091_1279;
												  obj_t arg2092_1280;
												  obj_t arg2095_1281;
												  arg2091_1279 = CNST_TABLE_REF(((long) 35));
												  arg2092_1280 = make_pragma_indexed_set__widening_24_object_tools(type_69, slot_1135, new_994, formal_1136, rid_995, BFALSE);
												  {
												     obj_t arg2101_1287;
												     {
													obj_t arg2106_1292;
													arg2106_1292 = CNST_TABLE_REF(((long) 42));
													{
													   obj_t list2109_1295;
													   {
													      obj_t arg2110_1296;
													      {
														 obj_t arg2111_1297;
														 arg2111_1297 = MAKE_PAIR(BNIL, BNIL);
														 {
														    obj_t aux_3791;
														    aux_3791 = BINT(((long) 1));
														    arg2110_1296 = MAKE_PAIR(aux_3791, arg2111_1297);
														 }
													      }
													      list2109_1295 = MAKE_PAIR(rid_995, arg2110_1296);
													   }
													   arg2101_1287 = cons__138___r4_pairs_and_lists_6_3(arg2106_1292, list2109_1295);
													}
												     }
												     {
													obj_t list2103_1289;
													{
													   obj_t arg2104_1290;
													   arg2104_1290 = MAKE_PAIR(BNIL, BNIL);
													   list2103_1289 = MAKE_PAIR(arg2101_1287, arg2104_1290);
													}
													arg2095_1281 = cons__138___r4_pairs_and_lists_6_3(loop_993, list2103_1289);
												     }
												  }
												  {
												     obj_t list2097_1283;
												     {
													obj_t arg2098_1284;
													{
													   obj_t arg2099_1285;
													   arg2099_1285 = MAKE_PAIR(BNIL, BNIL);
													   arg2098_1284 = MAKE_PAIR(arg2095_1281, arg2099_1285);
													}
													list2097_1283 = MAKE_PAIR(arg2092_1280, arg2098_1284);
												     }
												     arg2059_1253 = cons__138___r4_pairs_and_lists_6_3(arg2091_1279, list2097_1283);
												  }
											       }
											       {
												  obj_t list2061_1255;
												  {
												     obj_t arg2062_1256;
												     {
													obj_t arg2065_1257;
													{
													   obj_t arg2066_1258;
													   arg2066_1258 = MAKE_PAIR(BNIL, BNIL);
													   arg2065_1257 = MAKE_PAIR(arg2059_1253, arg2066_1258);
													}
													arg2062_1256 = MAKE_PAIR(arg2058_1252, arg2065_1257);
												     }
												     list2061_1255 = MAKE_PAIR(arg2057_1251, arg2062_1256);
												  }
												  arg2046_1241 = cons__138___r4_pairs_and_lists_6_3(arg2056_1250, list2061_1255);
											       }
											    }
											    {
											       obj_t list2048_1243;
											       {
												  obj_t arg2050_1244;
												  {
												     obj_t arg2051_1245;
												     arg2051_1245 = MAKE_PAIR(BNIL, BNIL);
												     arg2050_1244 = MAKE_PAIR(arg2046_1241, arg2051_1245);
												  }
												  list2048_1243 = MAKE_PAIR(arg2045_1240, arg2050_1244);
											       }
											       arg2040_1236 = cons__138___r4_pairs_and_lists_6_3(loop_993, list2048_1243);
											    }
											 }
											 {
											    obj_t list2042_1238;
											    list2042_1238 = MAKE_PAIR(BNIL, BNIL);
											    arg2032_1229 = cons__138___r4_pairs_and_lists_6_3(arg2040_1236, list2042_1238);
											 }
										      }
										      {
											 obj_t list2115_1301;
											 {
											    obj_t arg2117_1302;
											    arg2117_1302 = MAKE_PAIR(BNIL, BNIL);
											    {
											       obj_t aux_3815;
											       aux_3815 = BINT(((long) 0));
											       list2115_1301 = MAKE_PAIR(aux_3815, arg2117_1302);
											    }
											 }
											 arg2033_1230 = cons__138___r4_pairs_and_lists_6_3(loop_993, list2115_1301);
										      }
										      {
											 obj_t list2035_1232;
											 {
											    obj_t arg2036_1233;
											    {
											       obj_t arg2037_1234;
											       arg2037_1234 = MAKE_PAIR(BNIL, BNIL);
											       arg2036_1233 = MAKE_PAIR(arg2033_1230, arg2037_1234);
											    }
											    list2035_1232 = MAKE_PAIR(arg2032_1229, arg2036_1233);
											 }
											 arg1927_1133 = cons__138___r4_pairs_and_lists_6_3(arg2031_1228, list2035_1232);
										      }
										   }
										}
									      else
										{
										   arg1927_1133 = make_pragma_direct_set__7_object_tools(type_69, slot_1135, new_994, formal_1136);
										}
									   }
								      }
								   }
								   new_tail1155_22_1130 = MAKE_PAIR(arg1927_1133, BNIL);
								}
								SET_CDR(tail1154_1127, new_tail1155_22_1130);
								{
								   obj_t tail1154_3830;
								   obj_t ll1152_3828;
								   obj_t ll1151_3826;
								   ll1151_3826 = CDR(ll1151_1125);
								   ll1152_3828 = CDR(ll1152_1126);
								   tail1154_3830 = new_tail1155_22_1130;
								   tail1154_1127 = tail1154_3830;
								   ll1152_1126 = ll1152_3828;
								   ll1151_1125 = ll1151_3826;
								   goto lname1157_1128;
								}
							     }
							}
						     }
						   {
						      obj_t list2122_1307;
						      list2122_1307 = MAKE_PAIR(BNIL, BNIL);
						      arg1922_1120 = cons__138___r4_pairs_and_lists_6_3(new_994, list2122_1307);
						   }
						   arg1902_1093 = append_2_18___r4_pairs_and_lists_6_3(arg1921_1119, arg1922_1120);
						}
						{
						   obj_t list1903_1094;
						   {
						      obj_t arg1904_1095;
						      arg1904_1095 = MAKE_PAIR(arg1902_1093, BNIL);
						      list1903_1094 = MAKE_PAIR(arg1901_1092, arg1904_1095);
						   }
						   arg1896_1087 = cons__138___r4_pairs_and_lists_6_3(arg1900_1091, list1903_1094);
						}
					     }
					     {
						obj_t list1898_1089;
						list1898_1089 = MAKE_PAIR(BNIL, BNIL);
						arg1855_1051 = cons__138___r4_pairs_and_lists_6_3(arg1896_1087, list1898_1089);
					     }
					  }
					  arg1833_1032 = append_2_18___r4_pairs_and_lists_6_3(arg1853_1050, arg1855_1051);
				       }
				       {
					  obj_t list1834_1033;
					  {
					     obj_t arg1835_1034;
					     arg1835_1034 = MAKE_PAIR(arg1833_1032, BNIL);
					     list1834_1033 = MAKE_PAIR(arg1832_1031, arg1835_1034);
					  }
					  arg1814_1017 = cons__138___r4_pairs_and_lists_6_3(arg1831_1030, list1834_1033);
				       }
				    }
				    {
				       obj_t list1820_1019;
				       {
					  obj_t arg1821_1020;
					  {
					     obj_t arg1822_1021;
					     arg1822_1021 = MAKE_PAIR(BNIL, BNIL);
					     arg1821_1020 = MAKE_PAIR(arg1814_1017, arg1822_1021);
					  }
					  list1820_1019 = MAKE_PAIR(arg1813_1016, arg1821_1020);
				       }
				       return cons__138___r4_pairs_and_lists_6_3(arg1812_1015, list1820_1019);
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
make_wide_class_makes_236_object_access(obj_t id_71, type_t type_72, obj_t slots_73, obj_t sslots_74)
{
   {
      obj_t mk_heap_id_73_1357;
      obj_t mk_stack_id_29_1358;
      {
	 obj_t arg2193_1389;
	 arg2193_1389 = CNST_TABLE_REF(((long) 44));
	 {
	    obj_t list2194_1390;
	    {
	       obj_t arg2195_1391;
	       arg2195_1391 = MAKE_PAIR(id_71, BNIL);
	       list2194_1390 = MAKE_PAIR(arg2193_1389, arg2195_1391);
	    }
	    mk_heap_id_73_1357 = symbol_append_197___r4_symbols_6_4(list2194_1390);
	 }
      }
      {
	 obj_t arg2197_1393;
	 arg2197_1393 = CNST_TABLE_REF(((long) 45));
	 {
	    obj_t list2198_1394;
	    {
	       obj_t arg2199_1395;
	       arg2199_1395 = MAKE_PAIR(id_71, BNIL);
	       list2198_1394 = MAKE_PAIR(arg2197_1393, arg2199_1395);
	    }
	    mk_stack_id_29_1358 = symbol_append_197___r4_symbols_6_4(list2198_1394);
	 }
      }
      {
	 bool_t test2163_1359;
	 {
	    bool_t test2192_1388;
	    {
	       long n1_2770;
	       n1_2770 = (long) CINT(__optim__89_engine_param);
	       test2192_1388 = (n1_2770 < ((long) 2));
	    }
	    if (test2192_1388)
	      {
		 test2163_1359 = ((bool_t) 1);
	      }
	    else
	      {
		 if (CBOOL(__optim_stack___57_engine_param))
		   {
		      test2163_1359 = ((bool_t) 0);
		   }
		 else
		   {
		      test2163_1359 = ((bool_t) 1);
		   }
	      }
	 }
	 if (test2163_1359)
	   {
	      obj_t arg2164_1360;
	      arg2164_1360 = make_wide_class_make_178_object_access(CNST_TABLE_REF(((long) 22)), id_71, type_72, slots_73, sslots_74);
	      {
		 obj_t list2165_1361;
		 list2165_1361 = MAKE_PAIR(arg2164_1360, BNIL);
		 return list2165_1361;
	      }
	   }
	 else
	   {
	      {
		 obj_t arg2168_1364;
		 {
		    obj_t arg2169_1365;
		    obj_t arg2170_1366;
		    arg2169_1365 = CNST_TABLE_REF(((long) 7));
		    {
		       obj_t arg2175_1371;
		       {
			  obj_t arg2180_1376;
			  arg2180_1376 = CNST_TABLE_REF(((long) 24));
			  {
			     obj_t list2182_1378;
			     {
				obj_t arg2183_1379;
				arg2183_1379 = MAKE_PAIR(BNIL, BNIL);
				list2182_1378 = MAKE_PAIR(mk_stack_id_29_1358, arg2183_1379);
			     }
			     arg2175_1371 = cons__138___r4_pairs_and_lists_6_3(arg2180_1376, list2182_1378);
			  }
		       }
		       {
			  obj_t list2177_1373;
			  {
			     obj_t arg2178_1374;
			     arg2178_1374 = MAKE_PAIR(BNIL, BNIL);
			     list2177_1373 = MAKE_PAIR(arg2175_1371, arg2178_1374);
			  }
			  arg2170_1366 = cons__138___r4_pairs_and_lists_6_3(mk_heap_id_73_1357, list2177_1373);
		       }
		    }
		    {
		       obj_t list2172_1368;
		       {
			  obj_t arg2173_1369;
			  arg2173_1369 = MAKE_PAIR(BNIL, BNIL);
			  list2172_1368 = MAKE_PAIR(arg2170_1366, arg2173_1369);
		       }
		       arg2168_1364 = cons__138___r4_pairs_and_lists_6_3(arg2169_1365, list2172_1368);
		    }
		 }
		 produce_module_clause__172_module_module(arg2168_1364);
	      }
	      {
		 obj_t arg2185_1381;
		 obj_t arg2186_1382;
		 arg2185_1381 = make_wide_class_make_178_object_access(CNST_TABLE_REF(((long) 22)), id_71, type_72, slots_73, sslots_74);
		 arg2186_1382 = make_wide_class_make_178_object_access(CNST_TABLE_REF(((long) 23)), id_71, type_72, slots_73, sslots_74);
		 {
		    obj_t list2187_1383;
		    {
		       obj_t arg2188_1384;
		       arg2188_1384 = MAKE_PAIR(arg2186_1382, BNIL);
		       list2187_1383 = MAKE_PAIR(arg2185_1381, arg2188_1384);
		    }
		    return list2187_1383;
		 }
	      }
	   }
      }
   }
}


obj_t 
make_wide_class_make_178_object_access(obj_t mk_region_180_75, obj_t id_76, type_t type_77, obj_t slots_78, obj_t sslots_79)
{
   {
      global_t holder_1398;
      {
	 class_t obj_2775;
	 obj_2775 = (class_t) (type_77);
	 {
	    obj_t aux_3883;
	    {
	       object_t aux_3884;
	       aux_3884 = (object_t) (obj_2775);
	       aux_3883 = OBJECT_WIDENING(aux_3884);
	    }
	    holder_1398 = (((class_t) CREF(aux_3883))->holder);
	 }
      }
      {
	 obj_t tid_1399;
	 tid_1399 = (((type_t) CREF(type_77))->id);
	 {
	    obj_t stid_1400;
	    {
	       type_t obj_2777;
	       {
		  obj_t aux_3889;
		  {
		     class_t obj_2774;
		     obj_2774 = (class_t) (type_77);
		     {
			obj_t aux_3891;
			{
			   object_t aux_3892;
			   aux_3892 = (object_t) (obj_2774);
			   aux_3891 = OBJECT_WIDENING(aux_3892);
			}
			aux_3889 = (((class_t) CREF(aux_3891))->its_super_214);
		     }
		  }
		  obj_2777 = (type_t) (aux_3889);
	       }
	       stid_1400 = (((type_t) CREF(obj_2777))->id);
	    }
	    {
	       obj_t mk_tid_99_1401;
	       {
		  obj_t arg2430_1642;
		  arg2430_1642 = CNST_TABLE_REF(((long) 1));
		  {
		     obj_t list2431_1643;
		     {
			obj_t arg2432_1644;
			{
			   obj_t arg2433_1645;
			   {
			      obj_t arg2434_1646;
			      {
				 obj_t arg2435_1647;
				 arg2435_1647 = MAKE_PAIR(tid_1399, BNIL);
				 arg2434_1646 = MAKE_PAIR(_4dots_tools_misc, arg2435_1647);
			      }
			      arg2433_1645 = MAKE_PAIR(id_76, arg2434_1646);
			   }
			   arg2432_1644 = MAKE_PAIR(mk_region_180_75, arg2433_1645);
			}
			list2431_1643 = MAKE_PAIR(arg2430_1642, arg2432_1644);
		     }
		     mk_tid_99_1401 = symbol_append_197___r4_symbols_6_4(list2431_1643);
		  }
	       }
	       {
		  obj_t f_ids_164_1402;
		  if (NULLP(slots_78))
		    {
		       f_ids_164_1402 = BNIL;
		    }
		  else
		    {
		       obj_t head1160_1628;
		       {
			  obj_t aux_3907;
			  {
			     obj_t aux_3908;
			     aux_3908 = CAR(slots_78);
			     aux_3907 = STRUCT_REF(aux_3908, ((long) 0));
			  }
			  head1160_1628 = MAKE_PAIR(aux_3907, BNIL);
		       }
		       {
			  obj_t l1158_1629;
			  obj_t tail1161_1630;
			  l1158_1629 = CDR(slots_78);
			  tail1161_1630 = head1160_1628;
			lname1159_1631:
			  if (NULLP(l1158_1629))
			    {
			       f_ids_164_1402 = head1160_1628;
			    }
			  else
			    {
			       obj_t new_tail1162_2_1634;
			       {
				  obj_t aux_3914;
				  {
				     obj_t aux_3915;
				     aux_3915 = CAR(l1158_1629);
				     aux_3914 = STRUCT_REF(aux_3915, ((long) 0));
				  }
				  new_tail1162_2_1634 = MAKE_PAIR(aux_3914, BNIL);
			       }
			       SET_CDR(tail1161_1630, new_tail1162_2_1634);
			       {
				  obj_t tail1161_3922;
				  obj_t l1158_3920;
				  l1158_3920 = CDR(l1158_1629);
				  tail1161_3922 = new_tail1162_2_1634;
				  tail1161_1630 = tail1161_3922;
				  l1158_1629 = l1158_3920;
				  goto lname1159_1631;
			       }
			    }
		       }
		    }
		  {
		     obj_t sf_ids_190_1403;
		     if (NULLP(sslots_79))
		       {
			  sf_ids_190_1403 = BNIL;
		       }
		     else
		       {
			  obj_t head1165_1612;
			  {
			     obj_t aux_3926;
			     {
				obj_t aux_3927;
				aux_3927 = CAR(sslots_79);
				aux_3926 = STRUCT_REF(aux_3927, ((long) 0));
			     }
			     head1165_1612 = MAKE_PAIR(aux_3926, BNIL);
			  }
			  {
			     obj_t l1163_1613;
			     obj_t tail1166_1614;
			     l1163_1613 = CDR(sslots_79);
			     tail1166_1614 = head1165_1612;
			   lname1164_1615:
			     if (NULLP(l1163_1613))
			       {
				  sf_ids_190_1403 = head1165_1612;
			       }
			     else
			       {
				  obj_t new_tail1167_210_1618;
				  {
				     obj_t aux_3933;
				     {
					obj_t aux_3934;
					aux_3934 = CAR(l1163_1613);
					aux_3933 = STRUCT_REF(aux_3934, ((long) 0));
				     }
				     new_tail1167_210_1618 = MAKE_PAIR(aux_3933, BNIL);
				  }
				  SET_CDR(tail1166_1614, new_tail1167_210_1618);
				  {
				     obj_t tail1166_3941;
				     obj_t l1163_3939;
				     l1163_3939 = CDR(l1163_1613);
				     tail1166_3941 = new_tail1167_210_1618;
				     tail1166_1614 = tail1166_3941;
				     l1163_1613 = l1163_3939;
				     goto lname1164_1615;
				  }
			       }
			  }
		       }
		     {
			obj_t f_tids_193_1404;
			if (NULLP(slots_78))
			  {
			     f_tids_193_1404 = BNIL;
			  }
			else
			  {
			     obj_t head1170_1591;
			     head1170_1591 = MAKE_PAIR(BNIL, BNIL);
			     {
				obj_t l1168_1592;
				obj_t tail1171_1593;
				l1168_1592 = slots_78;
				tail1171_1593 = head1170_1591;
			      lname1169_1594:
				if (NULLP(l1168_1592))
				  {
				     f_tids_193_1404 = CDR(head1170_1591);
				  }
				else
				  {
				     obj_t new_tail1172_252_1596;
				     {
					obj_t arg2393_1598;
					{
					   obj_t slot_1600;
					   slot_1600 = CAR(l1168_1592);
					   {
					      obj_t arg2395_1601;
					      arg2395_1601 = STRUCT_REF(slot_1600, ((long) 0));
					      {
						 obj_t list2397_1603;
						 {
						    obj_t arg2398_1604;
						    {
						       obj_t arg2399_1605;
						       {
							  obj_t aux_3951;
							  {
							     type_t obj_2826;
							     {
								obj_t aux_3952;
								aux_3952 = STRUCT_REF(slot_1600, ((long) 2));
								obj_2826 = (type_t) (aux_3952);
							     }
							     aux_3951 = (((type_t) CREF(obj_2826))->id);
							  }
							  arg2399_1605 = MAKE_PAIR(aux_3951, BNIL);
						       }
						       arg2398_1604 = MAKE_PAIR(_4dots_tools_misc, arg2399_1605);
						    }
						    list2397_1603 = MAKE_PAIR(arg2395_1601, arg2398_1604);
						 }
						 arg2393_1598 = symbol_append_197___r4_symbols_6_4(list2397_1603);
					      }
					   }
					}
					new_tail1172_252_1596 = MAKE_PAIR(arg2393_1598, BNIL);
				     }
				     SET_CDR(tail1171_1593, new_tail1172_252_1596);
				     {
					obj_t tail1171_3964;
					obj_t l1168_3962;
					l1168_3962 = CDR(l1168_1592);
					tail1171_3964 = new_tail1172_252_1596;
					tail1171_1593 = tail1171_3964;
					l1168_1592 = l1168_3962;
					goto lname1169_1594;
				     }
				  }
			     }
			  }
			{
			   obj_t sf_tids_42_1405;
			   if (NULLP(sslots_79))
			     {
				sf_tids_42_1405 = BNIL;
			     }
			   else
			     {
				obj_t head1175_1570;
				head1175_1570 = MAKE_PAIR(BNIL, BNIL);
				{
				   obj_t l1173_1571;
				   obj_t tail1176_1572;
				   l1173_1571 = sslots_79;
				   tail1176_1572 = head1175_1570;
				 lname1174_1573:
				   if (NULLP(l1173_1571))
				     {
					sf_tids_42_1405 = CDR(head1175_1570);
				     }
				   else
				     {
					obj_t new_tail1177_206_1575;
					{
					   obj_t arg2379_1577;
					   {
					      obj_t slot_1579;
					      slot_1579 = CAR(l1173_1571);
					      {
						 obj_t arg2381_1580;
						 arg2381_1580 = STRUCT_REF(slot_1579, ((long) 0));
						 {
						    obj_t list2383_1582;
						    {
						       obj_t arg2384_1583;
						       {
							  obj_t arg2385_1584;
							  {
							     obj_t aux_3973;
							     {
								type_t obj_2844;
								{
								   obj_t aux_3974;
								   aux_3974 = STRUCT_REF(slot_1579, ((long) 2));
								   obj_2844 = (type_t) (aux_3974);
								}
								aux_3973 = (((type_t) CREF(obj_2844))->id);
							     }
							     arg2385_1584 = MAKE_PAIR(aux_3973, BNIL);
							  }
							  arg2384_1583 = MAKE_PAIR(_4dots_tools_misc, arg2385_1584);
						       }
						       list2383_1582 = MAKE_PAIR(arg2381_1580, arg2384_1583);
						    }
						    arg2379_1577 = symbol_append_197___r4_symbols_6_4(list2383_1582);
						 }
					      }
					   }
					   new_tail1177_206_1575 = MAKE_PAIR(arg2379_1577, BNIL);
					}
					SET_CDR(tail1176_1572, new_tail1177_206_1575);
					{
					   obj_t tail1176_3986;
					   obj_t l1173_3984;
					   l1173_3984 = CDR(l1173_1571);
					   tail1176_3986 = new_tail1177_206_1575;
					   tail1176_1572 = tail1176_3986;
					   l1173_1571 = l1173_3984;
					   goto lname1174_1573;
					}
				     }
				}
			     }
			   {
			      obj_t widening_1406;
			      {
				 obj_t arg2370_1562;
				 {
				    class_t obj_2850;
				    obj_2850 = (class_t) (type_77);
				    {
				       obj_t aux_3988;
				       {
					  object_t aux_3989;
					  aux_3989 = (object_t) (obj_2850);
					  aux_3988 = OBJECT_WIDENING(aux_3989);
				       }
				       arg2370_1562 = (((class_t) CREF(aux_3988))->widening);
				    }
				 }
				 {
				    obj_t list2372_1564;
				    {
				       obj_t arg2373_1565;
				       {
					  obj_t arg2374_1566;
					  {
					     obj_t aux_3993;
					     aux_3993 = (((type_t) CREF(type_77))->id);
					     arg2374_1566 = MAKE_PAIR(aux_3993, BNIL);
					  }
					  arg2373_1565 = MAKE_PAIR(mk_region_180_75, arg2374_1566);
				       }
				       list2372_1564 = MAKE_PAIR(arg2370_1562, arg2373_1565);
				    }
				    widening_1406 = symbol_append_197___r4_symbols_6_4(list2372_1564);
				 }
			      }
			      {
				 obj_t aux_1407;
				 aux_1407 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 46)), BEOA);
				 {
				    obj_t new_1408;
				    new_1408 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 26)), BEOA);
				    {
				       obj_t mk_class_id_234_1409;
				       {
					  obj_t arg2363_1555;
					  arg2363_1555 = CNST_TABLE_REF(((long) 1));
					  {
					     obj_t list2364_1556;
					     {
						obj_t arg2365_1557;
						{
						   obj_t arg2366_1558;
						   arg2366_1558 = MAKE_PAIR(stid_1400, BNIL);
						   arg2365_1557 = MAKE_PAIR(mk_region_180_75, arg2366_1558);
						}
						list2364_1556 = MAKE_PAIR(arg2363_1555, arg2365_1557);
					     }
					     mk_class_id_234_1409 = symbol_append_197___r4_symbols_6_4(list2364_1556);
					  }
				       }
				       {
					  {
					     obj_t arg2201_1410;
					     {
						obj_t arg2202_1411;
						obj_t arg2203_1412;
						arg2202_1411 = CNST_TABLE_REF(((long) 15));
						{
						   obj_t arg2209_1417;
						   {
						      obj_t arg2211_1419;
						      obj_t arg2212_1420;
						      {
							 bool_t test2213_1421;
							 {
							    long n1_2852;
							    n1_2852 = (long) CINT(__optim__89_engine_param);
							    test2213_1421 = (n1_2852 >= ((long) 2));
							 }
							 if (test2213_1421)
							   {
							      arg2211_1419 = CNST_TABLE_REF(((long) 29));
							   }
							 else
							   {
							      arg2211_1419 = BNIL;
							   }
						      }
						      {
							 obj_t arg2214_1422;
							 {
							    obj_t arg2217_1425;
							    {
							       obj_t arg2218_1426;
							       {
								  obj_t arg2220_1428;
								  arg2220_1428 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
								  arg2218_1426 = append_2_18___r4_pairs_and_lists_6_3(f_tids_193_1404, arg2220_1428);
							       }
							       arg2217_1425 = cons__138___r4_pairs_and_lists_6_3(arg2218_1426, BNIL);
							    }
							    arg2214_1422 = append_2_18___r4_pairs_and_lists_6_3(sf_tids_42_1405, arg2217_1425);
							 }
							 {
							    obj_t list2215_1423;
							    list2215_1423 = MAKE_PAIR(arg2214_1422, BNIL);
							    arg2212_1420 = cons__138___r4_pairs_and_lists_6_3(mk_tid_99_1401, list2215_1423);
							 }
						      }
						      arg2209_1417 = append_2_18___r4_pairs_and_lists_6_3(arg2211_1419, arg2212_1420);
						   }
						   arg2203_1412 = cons__138___r4_pairs_and_lists_6_3(arg2209_1417, BNIL);
						}
						{
						   obj_t list2205_1414;
						   {
						      obj_t arg2207_1415;
						      arg2207_1415 = MAKE_PAIR(BNIL, BNIL);
						      list2205_1414 = MAKE_PAIR(arg2203_1412, arg2207_1415);
						   }
						   arg2201_1410 = cons__138___r4_pairs_and_lists_6_3(arg2202_1411, list2205_1414);
						}
					     }
					     produce_module_clause__172_module_module(arg2201_1410);
					  }
					  {
					     obj_t arg2223_1431;
					     obj_t arg2224_1432;
					     obj_t arg2225_1433;
					     {
						bool_t test2231_1439;
						{
						   long n1_2854;
						   n1_2854 = (long) CINT(__optim__89_engine_param);
						   test2231_1439 = (n1_2854 >= ((long) 2));
						}
						if (test2231_1439)
						  {
						     arg2223_1431 = CNST_TABLE_REF(((long) 19));
						  }
						else
						  {
						     arg2223_1431 = CNST_TABLE_REF(((long) 30));
						  }
					     }
					     {
						obj_t arg2232_1440;
						{
						   obj_t arg2235_1443;
						   {
						      obj_t arg2236_1444;
						      {
							 obj_t arg2242_1446;
							 arg2242_1446 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
							 arg2236_1444 = append_2_18___r4_pairs_and_lists_6_3(f_tids_193_1404, arg2242_1446);
						      }
						      arg2235_1443 = cons__138___r4_pairs_and_lists_6_3(arg2236_1444, BNIL);
						   }
						   arg2232_1440 = append_2_18___r4_pairs_and_lists_6_3(sf_tids_42_1405, arg2235_1443);
						}
						{
						   obj_t list2233_1441;
						   list2233_1441 = MAKE_PAIR(arg2232_1440, BNIL);
						   arg2224_1432 = cons__138___r4_pairs_and_lists_6_3(mk_tid_99_1401, list2233_1441);
						}
					     }
					     {
						obj_t arg2245_1449;
						obj_t arg2246_1450;
						obj_t arg2247_1451;
						arg2245_1449 = CNST_TABLE_REF(((long) 31));
						{
						   obj_t arg2254_1457;
						   {
						      obj_t arg2258_1461;
						      obj_t arg2259_1462;
						      {
							 obj_t list2264_1467;
							 {
							    obj_t arg2265_1468;
							    {
							       obj_t arg2266_1469;
							       arg2266_1469 = MAKE_PAIR(stid_1400, BNIL);
							       arg2265_1468 = MAKE_PAIR(_4dots_tools_misc, arg2266_1469);
							    }
							    list2264_1467 = MAKE_PAIR(aux_1407, arg2265_1468);
							 }
							 arg2258_1461 = symbol_append_197___r4_symbols_6_4(list2264_1467);
						      }
						      {
							 obj_t arg2269_1471;
							 {
							    obj_t arg2272_1474;
							    arg2272_1474 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
							    arg2269_1471 = append_2_18___r4_pairs_and_lists_6_3(sf_ids_190_1403, arg2272_1474);
							 }
							 {
							    obj_t list2270_1472;
							    list2270_1472 = MAKE_PAIR(arg2269_1471, BNIL);
							    arg2259_1462 = cons__138___r4_pairs_and_lists_6_3(mk_class_id_234_1409, list2270_1472);
							 }
						      }
						      {
							 obj_t list2261_1464;
							 {
							    obj_t arg2262_1465;
							    arg2262_1465 = MAKE_PAIR(BNIL, BNIL);
							    list2261_1464 = MAKE_PAIR(arg2259_1462, arg2262_1465);
							 }
							 arg2254_1457 = cons__138___r4_pairs_and_lists_6_3(arg2258_1461, list2261_1464);
						      }
						   }
						   {
						      obj_t list2256_1459;
						      list2256_1459 = MAKE_PAIR(BNIL, BNIL);
						      arg2246_1450 = cons__138___r4_pairs_and_lists_6_3(arg2254_1457, list2256_1459);
						   }
						}
						{
						   obj_t arg2280_1477;
						   obj_t arg2281_1478;
						   obj_t arg2283_1479;
						   obj_t arg2284_1480;
						   arg2280_1477 = CNST_TABLE_REF(((long) 31));
						   {
						      obj_t arg2292_1488;
						      {
							 obj_t arg2296_1492;
							 obj_t arg2297_1493;
							 {
							    obj_t list2302_1498;
							    {
							       obj_t arg2303_1499;
							       {
								  obj_t arg2304_1500;
								  arg2304_1500 = MAKE_PAIR(tid_1399, BNIL);
								  arg2303_1499 = MAKE_PAIR(_4dots_tools_misc, arg2304_1500);
							       }
							       list2302_1498 = MAKE_PAIR(new_1408, arg2303_1499);
							    }
							    arg2296_1492 = symbol_append_197___r4_symbols_6_4(list2302_1498);
							 }
							 {
							    obj_t arg2306_1502;
							    obj_t arg2307_1503;
							    {
							       obj_t arg2313_1509;
							       arg2313_1509 = CNST_TABLE_REF(((long) 47));
							       {
								  obj_t list2314_1510;
								  {
								     obj_t arg2315_1511;
								     {
									obj_t arg2316_1512;
									arg2316_1512 = MAKE_PAIR(tid_1399, BNIL);
									arg2315_1511 = MAKE_PAIR(_4dots_tools_misc, arg2316_1512);
								     }
								     list2314_1510 = MAKE_PAIR(arg2313_1509, arg2315_1511);
								  }
								  arg2306_1502 = symbol_append_197___r4_symbols_6_4(list2314_1510);
							       }
							    }
							    {
							       obj_t arg2319_1515;
							       arg2319_1515 = (((type_t) CREF(type_77))->name);
							       {
								  obj_t list2321_1517;
								  {
								     obj_t arg2322_1518;
								     {
									obj_t arg2323_1519;
									arg2323_1519 = MAKE_PAIR(string3231_object_access, BNIL);
									arg2322_1518 = MAKE_PAIR(arg2319_1515, arg2323_1519);
								     }
								     list2321_1517 = MAKE_PAIR(string3232_object_access, arg2322_1518);
								  }
								  arg2307_1503 = string_append_106___r4_strings_6_7(list2321_1517);
							       }
							    }
							    {
							       obj_t list2309_1505;
							       {
								  obj_t arg2310_1506;
								  {
								     obj_t arg2311_1507;
								     arg2311_1507 = MAKE_PAIR(BNIL, BNIL);
								     arg2310_1506 = MAKE_PAIR(aux_1407, arg2311_1507);
								  }
								  list2309_1505 = MAKE_PAIR(arg2307_1503, arg2310_1506);
							       }
							       arg2297_1493 = cons__138___r4_pairs_and_lists_6_3(arg2306_1502, list2309_1505);
							    }
							 }
							 {
							    obj_t list2299_1495;
							    {
							       obj_t arg2300_1496;
							       arg2300_1496 = MAKE_PAIR(BNIL, BNIL);
							       list2299_1495 = MAKE_PAIR(arg2297_1493, arg2300_1496);
							    }
							    arg2292_1488 = cons__138___r4_pairs_and_lists_6_3(arg2296_1492, list2299_1495);
							 }
						      }
						      {
							 obj_t list2294_1490;
							 list2294_1490 = MAKE_PAIR(BNIL, BNIL);
							 arg2281_1478 = cons__138___r4_pairs_and_lists_6_3(arg2292_1488, list2294_1490);
						      }
						   }
						   {
						      obj_t arg2325_1521;
						      obj_t arg2326_1522;
						      arg2325_1521 = CNST_TABLE_REF(((long) 32));
						      {
							 obj_t arg2332_1528;
							 obj_t arg2334_1529;
							 arg2332_1528 = CNST_TABLE_REF(((long) 33));
							 {
							    obj_t arg2341_1534;
							    obj_t arg2343_1535;
							    obj_t arg2344_1536;
							    arg2341_1534 = CNST_TABLE_REF(((long) 21));
							    arg2343_1535 = (((global_t) CREF(holder_1398))->id);
							    arg2344_1536 = (((global_t) CREF(holder_1398))->module);
							    {
							       obj_t list2346_1538;
							       {
								  obj_t arg2347_1539;
								  {
								     obj_t arg2348_1540;
								     arg2348_1540 = MAKE_PAIR(BNIL, BNIL);
								     arg2347_1539 = MAKE_PAIR(arg2344_1536, arg2348_1540);
								  }
								  list2346_1538 = MAKE_PAIR(arg2343_1535, arg2347_1539);
							       }
							       arg2334_1529 = cons__138___r4_pairs_and_lists_6_3(arg2341_1534, list2346_1538);
							    }
							 }
							 {
							    obj_t list2336_1531;
							    {
							       obj_t arg2338_1532;
							       arg2338_1532 = MAKE_PAIR(BNIL, BNIL);
							       list2336_1531 = MAKE_PAIR(arg2334_1529, arg2338_1532);
							    }
							    arg2326_1522 = cons__138___r4_pairs_and_lists_6_3(arg2332_1528, list2336_1531);
							 }
						      }
						      {
							 obj_t list2328_1524;
							 {
							    obj_t arg2329_1525;
							    {
							       obj_t arg2330_1526;
							       arg2330_1526 = MAKE_PAIR(BNIL, BNIL);
							       arg2329_1525 = MAKE_PAIR(arg2326_1522, arg2330_1526);
							    }
							    list2328_1524 = MAKE_PAIR(new_1408, arg2329_1525);
							 }
							 arg2283_1479 = cons__138___r4_pairs_and_lists_6_3(arg2325_1521, list2328_1524);
						      }
						   }
						   {
						      obj_t arg2350_1542;
						      obj_t arg2351_1543;
						      arg2350_1542 = CNST_TABLE_REF(((long) 34));
						      {
							 obj_t arg2357_1549;
							 {
							    obj_t arg2360_1552;
							    arg2360_1552 = cons__138___r4_pairs_and_lists_6_3(BNIL, BNIL);
							    arg2357_1549 = append_2_18___r4_pairs_and_lists_6_3(f_ids_164_1402, arg2360_1552);
							 }
							 {
							    obj_t list2358_1550;
							    list2358_1550 = MAKE_PAIR(arg2357_1549, BNIL);
							    arg2351_1543 = cons__138___r4_pairs_and_lists_6_3(widening_1406, list2358_1550);
							 }
						      }
						      {
							 obj_t list2353_1545;
							 {
							    obj_t arg2354_1546;
							    {
							       obj_t arg2355_1547;
							       arg2355_1547 = MAKE_PAIR(BNIL, BNIL);
							       arg2354_1546 = MAKE_PAIR(arg2351_1543, arg2355_1547);
							    }
							    list2353_1545 = MAKE_PAIR(new_1408, arg2354_1546);
							 }
							 arg2284_1480 = cons__138___r4_pairs_and_lists_6_3(arg2350_1542, list2353_1545);
						      }
						   }
						   {
						      obj_t list2286_1482;
						      {
							 obj_t arg2287_1483;
							 {
							    obj_t arg2288_1484;
							    {
							       obj_t arg2289_1485;
							       {
								  obj_t arg2290_1486;
								  arg2290_1486 = MAKE_PAIR(BNIL, BNIL);
								  arg2289_1485 = MAKE_PAIR(new_1408, arg2290_1486);
							       }
							       arg2288_1484 = MAKE_PAIR(arg2284_1480, arg2289_1485);
							    }
							    arg2287_1483 = MAKE_PAIR(arg2283_1479, arg2288_1484);
							 }
							 list2286_1482 = MAKE_PAIR(arg2281_1478, arg2287_1483);
						      }
						      arg2247_1451 = cons__138___r4_pairs_and_lists_6_3(arg2280_1477, list2286_1482);
						   }
						}
						{
						   obj_t list2249_1453;
						   {
						      obj_t arg2250_1454;
						      {
							 obj_t arg2251_1455;
							 arg2251_1455 = MAKE_PAIR(BNIL, BNIL);
							 arg2250_1454 = MAKE_PAIR(arg2247_1451, arg2251_1455);
						      }
						      list2249_1453 = MAKE_PAIR(arg2246_1450, arg2250_1454);
						   }
						   arg2225_1433 = cons__138___r4_pairs_and_lists_6_3(arg2245_1449, list2249_1453);
						}
					     }
					     {
						obj_t list2227_1435;
						{
						   obj_t arg2228_1436;
						   {
						      obj_t arg2229_1437;
						      arg2229_1437 = MAKE_PAIR(BNIL, BNIL);
						      arg2228_1436 = MAKE_PAIR(arg2225_1433, arg2229_1437);
						   }
						   list2227_1435 = MAKE_PAIR(arg2224_1432, arg2228_1436);
						}
						return cons__138___r4_pairs_and_lists_6_3(arg2223_1431, list2227_1435);
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
make_class_allocate_193_object_access(obj_t id_80, obj_t type_81, global_t holder_82)
{
   {
      obj_t tid_1649;
      {
	 type_t obj_2859;
	 obj_2859 = (type_t) (type_81);
	 tid_1649 = (((type_t) CREF(obj_2859))->id);
      }
      {
	 obj_t alloc_id_207_1650;
	 {
	    obj_t arg2532_1739;
	    arg2532_1739 = CNST_TABLE_REF(((long) 48));
	    {
	       obj_t list2533_1740;
	       {
		  obj_t arg2534_1741;
		  arg2534_1741 = MAKE_PAIR(id_80, BNIL);
		  list2533_1740 = MAKE_PAIR(arg2532_1739, arg2534_1741);
	       }
	       alloc_id_207_1650 = symbol_append_197___r4_symbols_6_4(list2533_1740);
	    }
	 }
	 {
	    obj_t alloc_tid_75_1651;
	    {
	       obj_t list2528_1735;
	       {
		  obj_t arg2529_1736;
		  {
		     obj_t arg2530_1737;
		     arg2530_1737 = MAKE_PAIR(tid_1649, BNIL);
		     arg2529_1736 = MAKE_PAIR(_4dots_tools_misc, arg2530_1737);
		  }
		  list2528_1735 = MAKE_PAIR(alloc_id_207_1650, arg2529_1736);
	       }
	       alloc_tid_75_1651 = symbol_append_197___r4_symbols_6_4(list2528_1735);
	    }
	    {
	       obj_t new_1652;
	       new_1652 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 26)), BEOA);
	       {
		  {
		     obj_t arg2437_1653;
		     {
			obj_t arg2438_1654;
			obj_t arg2439_1655;
			arg2438_1654 = CNST_TABLE_REF(((long) 15));
			{
			   obj_t list2445_1661;
			   list2445_1661 = MAKE_PAIR(BNIL, BNIL);
			   arg2439_1655 = cons__138___r4_pairs_and_lists_6_3(alloc_tid_75_1651, list2445_1661);
			}
			{
			   obj_t list2441_1657;
			   {
			      obj_t arg2442_1658;
			      arg2442_1658 = MAKE_PAIR(BNIL, BNIL);
			      list2441_1657 = MAKE_PAIR(arg2439_1655, arg2442_1658);
			   }
			   arg2437_1653 = cons__138___r4_pairs_and_lists_6_3(arg2438_1654, list2441_1657);
			}
		     }
		     produce_module_clause__172_module_module(arg2437_1653);
		  }
		  {
		     obj_t arg2447_1663;
		     obj_t arg2448_1664;
		     obj_t arg2449_1665;
		     arg2447_1663 = CNST_TABLE_REF(((long) 30));
		     {
			obj_t list2456_1672;
			list2456_1672 = MAKE_PAIR(BNIL, BNIL);
			arg2448_1664 = cons__138___r4_pairs_and_lists_6_3(alloc_tid_75_1651, list2456_1672);
		     }
		     {
			obj_t arg2458_1674;
			obj_t arg2459_1675;
			obj_t arg2460_1676;
			obj_t arg2461_1677;
			arg2458_1674 = CNST_TABLE_REF(((long) 31));
			{
			   obj_t arg2471_1685;
			   {
			      obj_t arg2475_1689;
			      obj_t arg2476_1690;
			      {
				 obj_t list2482_1695;
				 {
				    obj_t arg2483_1696;
				    {
				       obj_t arg2484_1697;
				       arg2484_1697 = MAKE_PAIR(tid_1649, BNIL);
				       arg2483_1696 = MAKE_PAIR(_4dots_tools_misc, arg2484_1697);
				    }
				    list2482_1695 = MAKE_PAIR(new_1652, arg2483_1696);
				 }
				 arg2475_1689 = symbol_append_197___r4_symbols_6_4(list2482_1695);
			      }
			      arg2476_1690 = malloc_object_tools((type_t) (type_81), BINT(((long) 1)));
			      {
				 obj_t list2478_1692;
				 {
				    obj_t arg2479_1693;
				    arg2479_1693 = MAKE_PAIR(BNIL, BNIL);
				    list2478_1692 = MAKE_PAIR(arg2476_1690, arg2479_1693);
				 }
				 arg2471_1685 = cons__138___r4_pairs_and_lists_6_3(arg2475_1689, list2478_1692);
			      }
			   }
			   {
			      obj_t list2473_1687;
			      list2473_1687 = MAKE_PAIR(BNIL, BNIL);
			      arg2459_1675 = cons__138___r4_pairs_and_lists_6_3(arg2471_1685, list2473_1687);
			   }
			}
			{
			   obj_t arg2486_1699;
			   obj_t arg2487_1700;
			   arg2486_1699 = CNST_TABLE_REF(((long) 32));
			   {
			      obj_t arg2493_1706;
			      obj_t arg2494_1707;
			      {
				 obj_t arg2499_1712;
				 obj_t arg2500_1713;
				 obj_t arg2501_1714;
				 arg2499_1712 = CNST_TABLE_REF(((long) 21));
				 arg2500_1713 = CNST_TABLE_REF(((long) 33));
				 arg2501_1714 = CNST_TABLE_REF(((long) 49));
				 {
				    obj_t list2503_1716;
				    {
				       obj_t arg2504_1717;
				       {
					  obj_t arg2506_1718;
					  arg2506_1718 = MAKE_PAIR(BNIL, BNIL);
					  arg2504_1717 = MAKE_PAIR(arg2501_1714, arg2506_1718);
				       }
				       list2503_1716 = MAKE_PAIR(arg2500_1713, arg2504_1717);
				    }
				    arg2493_1706 = cons__138___r4_pairs_and_lists_6_3(arg2499_1712, list2503_1716);
				 }
			      }
			      {
				 obj_t arg2509_1720;
				 obj_t arg2511_1721;
				 obj_t arg2512_1722;
				 arg2509_1720 = CNST_TABLE_REF(((long) 21));
				 arg2511_1721 = (((global_t) CREF(holder_82))->id);
				 arg2512_1722 = (((global_t) CREF(holder_82))->module);
				 {
				    obj_t list2514_1724;
				    {
				       obj_t arg2517_1725;
				       {
					  obj_t arg2518_1726;
					  arg2518_1726 = MAKE_PAIR(BNIL, BNIL);
					  arg2517_1725 = MAKE_PAIR(arg2512_1722, arg2518_1726);
				       }
				       list2514_1724 = MAKE_PAIR(arg2511_1721, arg2517_1725);
				    }
				    arg2494_1707 = cons__138___r4_pairs_and_lists_6_3(arg2509_1720, list2514_1724);
				 }
			      }
			      {
				 obj_t list2496_1709;
				 {
				    obj_t arg2497_1710;
				    arg2497_1710 = MAKE_PAIR(BNIL, BNIL);
				    list2496_1709 = MAKE_PAIR(arg2494_1707, arg2497_1710);
				 }
				 arg2487_1700 = cons__138___r4_pairs_and_lists_6_3(arg2493_1706, list2496_1709);
			      }
			   }
			   {
			      obj_t list2489_1702;
			      {
				 obj_t arg2490_1703;
				 {
				    obj_t arg2491_1704;
				    arg2491_1704 = MAKE_PAIR(BNIL, BNIL);
				    arg2490_1703 = MAKE_PAIR(arg2487_1700, arg2491_1704);
				 }
				 list2489_1702 = MAKE_PAIR(new_1652, arg2490_1703);
			      }
			      arg2460_1676 = cons__138___r4_pairs_and_lists_6_3(arg2486_1699, list2489_1702);
			   }
			}
			{
			   obj_t arg2520_1728;
			   arg2520_1728 = CNST_TABLE_REF(((long) 34));
			   {
			      obj_t list2522_1730;
			      {
				 obj_t arg2523_1731;
				 {
				    obj_t arg2524_1732;
				    arg2524_1732 = MAKE_PAIR(BNIL, BNIL);
				    arg2523_1731 = MAKE_PAIR(BFALSE, arg2524_1732);
				 }
				 list2522_1730 = MAKE_PAIR(new_1652, arg2523_1731);
			      }
			      arg2461_1677 = cons__138___r4_pairs_and_lists_6_3(arg2520_1728, list2522_1730);
			   }
			}
			{
			   obj_t list2463_1679;
			   {
			      obj_t arg2464_1680;
			      {
				 obj_t arg2465_1681;
				 {
				    obj_t arg2467_1682;
				    {
				       obj_t arg2469_1683;
				       arg2469_1683 = MAKE_PAIR(BNIL, BNIL);
				       arg2467_1682 = MAKE_PAIR(new_1652, arg2469_1683);
				    }
				    arg2465_1681 = MAKE_PAIR(arg2461_1677, arg2467_1682);
				 }
				 arg2464_1680 = MAKE_PAIR(arg2460_1676, arg2465_1681);
			      }
			      list2463_1679 = MAKE_PAIR(arg2459_1675, arg2464_1680);
			   }
			   arg2449_1665 = cons__138___r4_pairs_and_lists_6_3(arg2458_1674, list2463_1679);
			}
		     }
		     {
			obj_t list2451_1667;
			{
			   obj_t arg2452_1668;
			   {
			      obj_t arg2453_1669;
			      arg2453_1669 = MAKE_PAIR(BNIL, BNIL);
			      arg2452_1668 = MAKE_PAIR(arg2449_1665, arg2453_1669);
			   }
			   list2451_1667 = MAKE_PAIR(arg2448_1664, arg2452_1668);
			}
			return cons__138___r4_pairs_and_lists_6_3(arg2447_1663, list2451_1667);
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
make_class_slots_access_80_object_access(obj_t class_id_86_83, obj_t type_84, obj_t slots_85, obj_t widening_86)
{
   {
      obj_t slots_1743;
      obj_t res_1744;
      slots_1743 = slots_85;
      res_1744 = BNIL;
    loop_1745:
      if (NULLP(slots_1743))
	{
	   return reverse__39___r4_pairs_and_lists_6_3(res_1744);
	}
      else
	{
	   obj_t slot_1748;
	   slot_1748 = CAR(slots_1743);
	   {
	      bool_t test_4192;
	      {
		 obj_t aux_4193;
		 aux_4193 = STRUCT_REF(slot_1748, ((long) 7));
		 test_4192 = CBOOL(aux_4193);
	      }
	      if (test_4192)
		{
		   obj_t arg2539_1750;
		   obj_t arg2540_1751;
		   arg2539_1750 = CDR(slots_1743);
		   {
		      obj_t arg2541_1752;
		      arg2541_1752 = slot_ref_85_object_access(class_id_86_83, type_84, slot_1748, widening_86);
		      arg2540_1751 = append_2_18___r4_pairs_and_lists_6_3(arg2541_1752, res_1744);
		   }
		   {
		      obj_t res_4200;
		      obj_t slots_4199;
		      slots_4199 = arg2539_1750;
		      res_4200 = arg2540_1751;
		      res_1744 = res_4200;
		      slots_1743 = slots_4199;
		      goto loop_1745;
		   }
		}
	      else
		{
		   obj_t arg2542_1753;
		   obj_t arg2543_1754;
		   arg2542_1753 = CDR(slots_1743);
		   {
		      obj_t arg2544_1755;
		      obj_t arg2545_1756;
		      arg2544_1755 = slot_ref_85_object_access(class_id_86_83, type_84, slot_1748, widening_86);
		      arg2545_1756 = slot_set__144_object_access(class_id_86_83, type_84, slot_1748, widening_86);
		      {
			 obj_t list2546_1757;
			 {
			    obj_t arg2547_1758;
			    {
			       obj_t arg2548_1759;
			       arg2548_1759 = MAKE_PAIR(res_1744, BNIL);
			       arg2547_1758 = MAKE_PAIR(arg2545_1756, arg2548_1759);
			    }
			    list2546_1757 = MAKE_PAIR(arg2544_1755, arg2547_1758);
			 }
			 arg2543_1754 = append___r4_pairs_and_lists_6_3(list2546_1757);
		      }
		   }
		   {
		      obj_t res_4209;
		      obj_t slots_4208;
		      slots_4208 = arg2542_1753;
		      res_4209 = arg2543_1754;
		      res_1744 = res_4209;
		      slots_1743 = slots_4208;
		      goto loop_1745;
		   }
		}
	   }
	}
   }
}


obj_t 
slot_ref_85_object_access(obj_t class_id_86_87, obj_t type_88, obj_t slot_89, obj_t widening_90)
{
   {
      bool_t test_4210;
      {
	 obj_t aux_4211;
	 aux_4211 = STRUCT_REF(slot_89, ((long) 5));
	 test_4210 = CBOOL(aux_4211);
      }
      if (test_4210)
	{
	   return slot_dyna_indexed_ref_48_object_access(class_id_86_87, type_88, slot_89, widening_90);
	}
      else
	{
	   bool_t test_4215;
	   {
	      obj_t aux_4216;
	      aux_4216 = STRUCT_REF(slot_89, ((long) 3));
	      test_4215 = CBOOL(aux_4216);
	   }
	   if (test_4215)
	     {
		return slot_stat_indexed_ref_80_object_access(class_id_86_87, type_88, slot_89, widening_90);
	     }
	   else
	     {
		return slot_direct_ref_183_object_access(class_id_86_87, type_88, slot_89, widening_90);
	     }
	}
   }
}


obj_t 
slot_dyna_indexed_ref_48_object_access(obj_t class_id_86_91, obj_t type_92, obj_t slot_93, obj_t widening_94)
{
   {
      obj_t arg2552_1763;
      {
	 obj_t arg2553_1764;
	 obj_t arg2554_1765;
	 {
	    obj_t arg2559_1770;
	    obj_t arg2560_1771;
	    arg2559_1770 = CNST_TABLE_REF(((long) 22));
	    arg2560_1771 = STRUCT_REF(slot_93, ((long) 0));
	    {
	       obj_t list2562_1773;
	       {
		  obj_t arg2563_1774;
		  {
		     obj_t arg2564_1775;
		     {
			obj_t arg2565_1776;
			{
			   obj_t aux_4223;
			   aux_4223 = CNST_TABLE_REF(((long) 36));
			   arg2565_1776 = MAKE_PAIR(aux_4223, BNIL);
			}
			arg2564_1775 = MAKE_PAIR(arg2560_1771, arg2565_1776);
		     }
		     arg2563_1774 = MAKE_PAIR(arg2559_1770, arg2564_1775);
		  }
		  list2562_1773 = MAKE_PAIR(class_id_86_91, arg2563_1774);
	       }
	       arg2553_1764 = symbol_append_197___r4_symbols_6_4(list2562_1773);
	    }
	 }
	 arg2554_1765 = CNST_TABLE_REF(((long) 5));
	 {
	    obj_t list2556_1767;
	    {
	       obj_t arg2557_1768;
	       arg2557_1768 = MAKE_PAIR(BNIL, BNIL);
	       list2556_1767 = MAKE_PAIR(arg2554_1765, arg2557_1768);
	    }
	    arg2552_1763 = cons__138___r4_pairs_and_lists_6_3(arg2553_1764, list2556_1767);
	 }
      }
      return slot_indexed_ref_219_object_access(class_id_86_91, type_92, slot_93, widening_94, arg2552_1763);
   }
}


obj_t 
slot_stat_indexed_ref_80_object_access(obj_t class_id_86_95, obj_t type_96, obj_t slot_97, obj_t widening_98)
{
   {
      obj_t arg2567_1778;
      {
	 obj_t arg2568_1779;
	 obj_t arg2569_1780;
	 arg2568_1779 = CNST_TABLE_REF(((long) 43));
	 arg2569_1780 = STRUCT_REF(slot_97, ((long) 4));
	 {
	    obj_t list2571_1782;
	    {
	       obj_t arg2572_1783;
	       arg2572_1783 = MAKE_PAIR(BNIL, BNIL);
	       list2571_1782 = MAKE_PAIR(arg2569_1780, arg2572_1783);
	    }
	    arg2567_1778 = cons__138___r4_pairs_and_lists_6_3(arg2568_1779, list2571_1782);
	 }
      }
      return slot_indexed_ref_219_object_access(class_id_86_95, type_96, slot_97, widening_98, arg2567_1778);
   }
}


obj_t 
slot_indexed_ref_219_object_access(obj_t class_id_86_99, obj_t type_100, obj_t slot_101, obj_t widening_102, obj_t max_bound_128_103)
{
   {
      obj_t slot_ref_id_128_1962;
      obj_t slot_ref_tid_43_1963;
      obj_t slot_ref_id_128_1871;
      obj_t slot_ref_tid_43_1872;
      {
	 obj_t slot_ref_id_128_1787;
	 {
	    obj_t arg2647_1863;
	    obj_t arg2648_1864;
	    arg2647_1863 = CNST_TABLE_REF(((long) 22));
	    arg2648_1864 = STRUCT_REF(slot_101, ((long) 0));
	    {
	       obj_t list2650_1866;
	       {
		  obj_t arg2651_1867;
		  {
		     obj_t arg2652_1868;
		     {
			obj_t arg2653_1869;
			{
			   obj_t aux_4243;
			   aux_4243 = CNST_TABLE_REF(((long) 55));
			   arg2653_1869 = MAKE_PAIR(aux_4243, BNIL);
			}
			arg2652_1868 = MAKE_PAIR(arg2648_1864, arg2653_1869);
		     }
		     arg2651_1867 = MAKE_PAIR(arg2647_1863, arg2652_1868);
		  }
		  list2650_1866 = MAKE_PAIR(class_id_86_99, arg2651_1867);
	       }
	       slot_ref_id_128_1787 = symbol_append_197___r4_symbols_6_4(list2650_1866);
	    }
	 }
	 {
	    obj_t slot_ref_tid_43_1788;
	    {
	       obj_t list2642_1858;
	       {
		  obj_t arg2643_1859;
		  {
		     obj_t arg2644_1860;
		     {
			obj_t aux_4250;
			{
			   type_t obj_2887;
			   {
			      obj_t aux_4251;
			      aux_4251 = STRUCT_REF(slot_101, ((long) 2));
			      obj_2887 = (type_t) (aux_4251);
			   }
			   aux_4250 = (((type_t) CREF(obj_2887))->id);
			}
			arg2644_1860 = MAKE_PAIR(aux_4250, BNIL);
		     }
		     arg2643_1859 = MAKE_PAIR(_4dots_tools_misc, arg2644_1860);
		  }
		  list2642_1858 = MAKE_PAIR(slot_ref_id_128_1787, arg2643_1859);
	       }
	       slot_ref_tid_43_1788 = symbol_append_197___r4_symbols_6_4(list2642_1858);
	    }
	    {
	       obj_t tid_1789;
	       {
		  obj_t list2638_1854;
		  {
		     obj_t arg2639_1855;
		     {
			obj_t aux_4259;
			{
			   type_t obj_2888;
			   obj_2888 = (type_t) (type_100);
			   aux_4259 = (((type_t) CREF(obj_2888))->id);
			}
			arg2639_1855 = MAKE_PAIR(aux_4259, BNIL);
		     }
		     list2638_1854 = MAKE_PAIR(_4dots_tools_misc, arg2639_1855);
		  }
		  tid_1789 = symbol_append_197___r4_symbols_6_4(list2638_1854);
	       }
	       {
		  if (CBOOL(__unsafe_range__218_engine_param))
		    {
		       {
			  obj_t arg2574_1791;
			  {
			     obj_t arg2575_1792;
			     obj_t arg2576_1793;
			     arg2575_1792 = CNST_TABLE_REF(((long) 15));
			     {
				obj_t arg2581_1798;
				obj_t arg2582_1799;
				arg2581_1798 = CNST_TABLE_REF(((long) 16));
				arg2582_1799 = CNST_TABLE_REF(((long) 28));
				{
				   obj_t list2584_1801;
				   {
				      obj_t arg2585_1802;
				      {
					 obj_t arg2586_1803;
					 {
					    obj_t arg2587_1804;
					    arg2587_1804 = MAKE_PAIR(BNIL, BNIL);
					    arg2586_1803 = MAKE_PAIR(arg2582_1799, arg2587_1804);
					 }
					 arg2585_1802 = MAKE_PAIR(tid_1789, arg2586_1803);
				      }
				      list2584_1801 = MAKE_PAIR(slot_ref_tid_43_1788, arg2585_1802);
				   }
				   arg2576_1793 = cons__138___r4_pairs_and_lists_6_3(arg2581_1798, list2584_1801);
				}
			     }
			     {
				obj_t list2578_1795;
				{
				   obj_t arg2579_1796;
				   arg2579_1796 = MAKE_PAIR(BNIL, BNIL);
				   list2578_1795 = MAKE_PAIR(arg2576_1793, arg2579_1796);
				}
				arg2574_1791 = cons__138___r4_pairs_and_lists_6_3(arg2575_1792, list2578_1795);
			     }
			  }
			  produce_module_clause__172_module_module(arg2574_1791);
		       }
		       {
			  obj_t arg2589_1806;
			  {
			     obj_t arg2590_1807;
			     obj_t arg2591_1808;
			     arg2590_1807 = CNST_TABLE_REF(((long) 7));
			     {
				obj_t arg2596_1813;
				obj_t arg2597_1814;
				arg2596_1813 = CNST_TABLE_REF(((long) 8));
				arg2597_1814 = CNST_TABLE_REF(((long) 9));
				{
				   obj_t list2599_1816;
				   {
				      obj_t arg2600_1817;
				      {
					 obj_t arg2601_1818;
					 arg2601_1818 = MAKE_PAIR(BNIL, BNIL);
					 arg2600_1817 = MAKE_PAIR(arg2597_1814, arg2601_1818);
				      }
				      list2599_1816 = MAKE_PAIR(arg2596_1813, arg2600_1817);
				   }
				   arg2591_1808 = cons__138___r4_pairs_and_lists_6_3(slot_ref_id_128_1787, list2599_1816);
				}
			     }
			     {
				obj_t list2593_1810;
				{
				   obj_t arg2594_1811;
				   arg2594_1811 = MAKE_PAIR(BNIL, BNIL);
				   list2593_1810 = MAKE_PAIR(arg2591_1808, arg2594_1811);
				}
				arg2589_1806 = cons__138___r4_pairs_and_lists_6_3(arg2590_1807, list2593_1810);
			     }
			  }
			  produce_module_clause__172_module_module(arg2589_1806);
		       }
		       {
			  obj_t arg2603_1820;
			  slot_ref_id_128_1962 = slot_ref_id_128_1787;
			  slot_ref_tid_43_1963 = slot_ref_tid_43_1788;
			  {
			     obj_t arg2745_1965;
			     obj_t arg2746_1966;
			     obj_t arg2747_1967;
			     arg2745_1965 = CNST_TABLE_REF(((long) 19));
			     {
				obj_t arg2753_1973;
				obj_t arg2754_1974;
				{
				   obj_t arg2760_1980;
				   arg2760_1980 = CNST_TABLE_REF(((long) 5));
				   {
				      obj_t list2762_1982;
				      {
					 obj_t arg2763_1983;
					 {
					    obj_t arg2764_1984;
					    {
					       obj_t aux_4292;
					       {
						  type_t obj_2893;
						  obj_2893 = (type_t) (type_100);
						  aux_4292 = (((type_t) CREF(obj_2893))->id);
					       }
					       arg2764_1984 = MAKE_PAIR(aux_4292, BNIL);
					    }
					    arg2763_1983 = MAKE_PAIR(_4dots_tools_misc, arg2764_1984);
					 }
					 list2762_1982 = MAKE_PAIR(arg2760_1980, arg2763_1983);
				      }
				      arg2753_1973 = symbol_append_197___r4_symbols_6_4(list2762_1982);
				   }
				}
				arg2754_1974 = CNST_TABLE_REF(((long) 50));
				{
				   obj_t list2756_1976;
				   {
				      obj_t arg2757_1977;
				      {
					 obj_t arg2758_1978;
					 arg2758_1978 = MAKE_PAIR(BNIL, BNIL);
					 arg2757_1977 = MAKE_PAIR(arg2754_1974, arg2758_1978);
				      }
				      list2756_1976 = MAKE_PAIR(arg2753_1973, arg2757_1977);
				   }
				   arg2746_1966 = cons__138___r4_pairs_and_lists_6_3(slot_ref_tid_43_1963, list2756_1976);
				}
			     }
			     arg2747_1967 = make_pragma_indexed_ref_widening_28_object_tools((type_t) (type_100), slot_101, CNST_TABLE_REF(((long) 5)), CNST_TABLE_REF(((long) 52)), widening_102);
			     {
				obj_t list2749_1969;
				{
				   obj_t arg2750_1970;
				   {
				      obj_t arg2751_1971;
				      arg2751_1971 = MAKE_PAIR(BNIL, BNIL);
				      arg2750_1970 = MAKE_PAIR(arg2747_1967, arg2751_1971);
				   }
				   list2749_1969 = MAKE_PAIR(arg2746_1966, arg2750_1970);
				}
				arg2603_1820 = cons__138___r4_pairs_and_lists_6_3(arg2745_1965, list2749_1969);
			     }
			  }
			  {
			     obj_t list2604_1821;
			     list2604_1821 = MAKE_PAIR(arg2603_1820, BNIL);
			     return list2604_1821;
			  }
		       }
		    }
		  else
		    {
		       {
			  obj_t arg2606_1823;
			  {
			     obj_t arg2607_1824;
			     obj_t arg2608_1825;
			     arg2607_1824 = CNST_TABLE_REF(((long) 15));
			     {
				obj_t arg2613_1830;
				arg2613_1830 = CNST_TABLE_REF(((long) 28));
				{
				   obj_t list2615_1832;
				   {
				      obj_t arg2616_1833;
				      {
					 obj_t arg2617_1834;
					 arg2617_1834 = MAKE_PAIR(BNIL, BNIL);
					 arg2616_1833 = MAKE_PAIR(arg2613_1830, arg2617_1834);
				      }
				      list2615_1832 = MAKE_PAIR(tid_1789, arg2616_1833);
				   }
				   arg2608_1825 = cons__138___r4_pairs_and_lists_6_3(slot_ref_tid_43_1788, list2615_1832);
				}
			     }
			     {
				obj_t list2610_1827;
				{
				   obj_t arg2611_1828;
				   arg2611_1828 = MAKE_PAIR(BNIL, BNIL);
				   list2610_1827 = MAKE_PAIR(arg2608_1825, arg2611_1828);
				}
				arg2606_1823 = cons__138___r4_pairs_and_lists_6_3(arg2607_1824, list2610_1827);
			     }
			  }
			  produce_module_clause__172_module_module(arg2606_1823);
		       }
		       {
			  obj_t arg2619_1836;
			  {
			     obj_t arg2620_1837;
			     obj_t arg2621_1838;
			     arg2620_1837 = CNST_TABLE_REF(((long) 7));
			     {
				obj_t arg2626_1843;
				obj_t arg2627_1844;
				arg2626_1843 = CNST_TABLE_REF(((long) 8));
				arg2627_1844 = CNST_TABLE_REF(((long) 9));
				{
				   obj_t list2629_1846;
				   {
				      obj_t arg2630_1847;
				      {
					 obj_t arg2631_1848;
					 arg2631_1848 = MAKE_PAIR(BNIL, BNIL);
					 arg2630_1847 = MAKE_PAIR(arg2627_1844, arg2631_1848);
				      }
				      list2629_1846 = MAKE_PAIR(arg2626_1843, arg2630_1847);
				   }
				   arg2621_1838 = cons__138___r4_pairs_and_lists_6_3(slot_ref_id_128_1787, list2629_1846);
				}
			     }
			     {
				obj_t list2623_1840;
				{
				   obj_t arg2624_1841;
				   arg2624_1841 = MAKE_PAIR(BNIL, BNIL);
				   list2623_1840 = MAKE_PAIR(arg2621_1838, arg2624_1841);
				}
				arg2619_1836 = cons__138___r4_pairs_and_lists_6_3(arg2620_1837, list2623_1840);
			     }
			  }
			  produce_module_clause__172_module_module(arg2619_1836);
		       }
		       {
			  obj_t arg2633_1850;
			  slot_ref_id_128_1871 = slot_ref_id_128_1787;
			  slot_ref_tid_43_1872 = slot_ref_tid_43_1788;
			  {
			     obj_t arg2656_1874;
			     obj_t arg2657_1875;
			     obj_t arg2658_1876;
			     arg2656_1874 = CNST_TABLE_REF(((long) 30));
			     {
				obj_t arg2664_1882;
				obj_t arg2665_1883;
				{
				   obj_t arg2671_1889;
				   arg2671_1889 = CNST_TABLE_REF(((long) 5));
				   {
				      obj_t list2673_1891;
				      {
					 obj_t arg2674_1892;
					 {
					    obj_t arg2675_1893;
					    {
					       obj_t aux_4336;
					       {
						  type_t obj_2892;
						  obj_2892 = (type_t) (type_100);
						  aux_4336 = (((type_t) CREF(obj_2892))->id);
					       }
					       arg2675_1893 = MAKE_PAIR(aux_4336, BNIL);
					    }
					    arg2674_1892 = MAKE_PAIR(_4dots_tools_misc, arg2675_1893);
					 }
					 list2673_1891 = MAKE_PAIR(arg2671_1889, arg2674_1892);
				      }
				      arg2664_1882 = symbol_append_197___r4_symbols_6_4(list2673_1891);
				   }
				}
				arg2665_1883 = CNST_TABLE_REF(((long) 50));
				{
				   obj_t list2667_1885;
				   {
				      obj_t arg2668_1886;
				      {
					 obj_t arg2669_1887;
					 arg2669_1887 = MAKE_PAIR(BNIL, BNIL);
					 arg2668_1886 = MAKE_PAIR(arg2665_1883, arg2669_1887);
				      }
				      list2667_1885 = MAKE_PAIR(arg2664_1882, arg2668_1886);
				   }
				   arg2657_1875 = cons__138___r4_pairs_and_lists_6_3(slot_ref_tid_43_1872, list2667_1885);
				}
			     }
			     {
				obj_t arg2677_1895;
				obj_t arg2678_1896;
				obj_t arg2679_1897;
				obj_t arg2680_1898;
				arg2677_1895 = CNST_TABLE_REF(((long) 38));
				{
				   obj_t arg2687_1905;
				   obj_t arg2688_1906;
				   arg2687_1905 = CNST_TABLE_REF(((long) 51));
				   arg2688_1906 = CNST_TABLE_REF(((long) 52));
				   {
				      obj_t list2691_1909;
				      {
					 obj_t arg2692_1910;
					 {
					    obj_t arg2693_1911;
					    arg2693_1911 = MAKE_PAIR(BNIL, BNIL);
					    {
					       obj_t aux_4352;
					       aux_4352 = BINT(((long) 0));
					       arg2692_1910 = MAKE_PAIR(aux_4352, arg2693_1911);
					    }
					 }
					 list2691_1909 = MAKE_PAIR(arg2688_1906, arg2692_1910);
				      }
				      arg2678_1896 = cons__138___r4_pairs_and_lists_6_3(arg2687_1905, list2691_1909);
				   }
				}
				{
				   obj_t arg2695_1913;
				   obj_t arg2696_1914;
				   obj_t arg2697_1915;
				   obj_t arg2698_1916;
				   arg2695_1913 = CNST_TABLE_REF(((long) 38));
				   {
				      obj_t arg2705_1923;
				      obj_t arg2706_1924;
				      arg2705_1923 = CNST_TABLE_REF(((long) 53));
				      arg2706_1924 = CNST_TABLE_REF(((long) 52));
				      {
					 obj_t list2708_1926;
					 {
					    obj_t arg2709_1927;
					    {
					       obj_t arg2710_1928;
					       arg2710_1928 = MAKE_PAIR(BNIL, BNIL);
					       arg2709_1927 = MAKE_PAIR(max_bound_128_103, arg2710_1928);
					    }
					    list2708_1926 = MAKE_PAIR(arg2706_1924, arg2709_1927);
					 }
					 arg2696_1914 = cons__138___r4_pairs_and_lists_6_3(arg2705_1923, list2708_1926);
				      }
				   }
				   arg2697_1915 = make_pragma_indexed_ref_widening_28_object_tools((type_t) (type_100), slot_101, CNST_TABLE_REF(((long) 5)), CNST_TABLE_REF(((long) 52)), widening_102);
				   {
				      obj_t arg2714_1932;
				      obj_t arg2715_1933;
				      obj_t arg2717_1935;
				      arg2714_1932 = CNST_TABLE_REF(((long) 54));
				      {
					 obj_t arg2724_1942;
					 arg2724_1942 = CNST_TABLE_REF(((long) 40));
					 {
					    obj_t list2726_1944;
					    {
					       obj_t arg2727_1945;
					       arg2727_1945 = MAKE_PAIR(BNIL, BNIL);
					       list2726_1944 = MAKE_PAIR(slot_ref_id_128_1871, arg2727_1945);
					    }
					    arg2715_1933 = cons__138___r4_pairs_and_lists_6_3(arg2724_1942, list2726_1944);
					 }
				      }
				      arg2717_1935 = CNST_TABLE_REF(((long) 52));
				      {
					 obj_t list2719_1937;
					 {
					    obj_t arg2720_1938;
					    {
					       obj_t arg2721_1939;
					       {
						  obj_t arg2722_1940;
						  arg2722_1940 = MAKE_PAIR(BNIL, BNIL);
						  arg2721_1939 = MAKE_PAIR(arg2717_1935, arg2722_1940);
					       }
					       arg2720_1938 = MAKE_PAIR(string3233_object_access, arg2721_1939);
					    }
					    list2719_1937 = MAKE_PAIR(arg2715_1933, arg2720_1938);
					 }
					 arg2698_1916 = cons__138___r4_pairs_and_lists_6_3(arg2714_1932, list2719_1937);
				      }
				   }
				   {
				      obj_t list2700_1918;
				      {
					 obj_t arg2701_1919;
					 {
					    obj_t arg2702_1920;
					    {
					       obj_t arg2703_1921;
					       arg2703_1921 = MAKE_PAIR(BNIL, BNIL);
					       arg2702_1920 = MAKE_PAIR(arg2698_1916, arg2703_1921);
					    }
					    arg2701_1919 = MAKE_PAIR(arg2697_1915, arg2702_1920);
					 }
					 list2700_1918 = MAKE_PAIR(arg2696_1914, arg2701_1919);
				      }
				      arg2679_1897 = cons__138___r4_pairs_and_lists_6_3(arg2695_1913, list2700_1918);
				   }
				}
				{
				   obj_t arg2729_1947;
				   obj_t arg2730_1948;
				   obj_t arg2732_1950;
				   arg2729_1947 = CNST_TABLE_REF(((long) 54));
				   {
				      obj_t arg2739_1957;
				      arg2739_1957 = CNST_TABLE_REF(((long) 40));
				      {
					 obj_t list2741_1959;
					 {
					    obj_t arg2742_1960;
					    arg2742_1960 = MAKE_PAIR(BNIL, BNIL);
					    list2741_1959 = MAKE_PAIR(slot_ref_id_128_1871, arg2742_1960);
					 }
					 arg2730_1948 = cons__138___r4_pairs_and_lists_6_3(arg2739_1957, list2741_1959);
				      }
				   }
				   arg2732_1950 = CNST_TABLE_REF(((long) 52));
				   {
				      obj_t list2734_1952;
				      {
					 obj_t arg2735_1953;
					 {
					    obj_t arg2736_1954;
					    {
					       obj_t arg2737_1955;
					       arg2737_1955 = MAKE_PAIR(BNIL, BNIL);
					       arg2736_1954 = MAKE_PAIR(arg2732_1950, arg2737_1955);
					    }
					    arg2735_1953 = MAKE_PAIR(string3233_object_access, arg2736_1954);
					 }
					 list2734_1952 = MAKE_PAIR(arg2730_1948, arg2735_1953);
				      }
				      arg2680_1898 = cons__138___r4_pairs_and_lists_6_3(arg2729_1947, list2734_1952);
				   }
				}
				{
				   obj_t list2682_1900;
				   {
				      obj_t arg2683_1901;
				      {
					 obj_t arg2684_1902;
					 {
					    obj_t arg2685_1903;
					    arg2685_1903 = MAKE_PAIR(BNIL, BNIL);
					    arg2684_1902 = MAKE_PAIR(arg2680_1898, arg2685_1903);
					 }
					 arg2683_1901 = MAKE_PAIR(arg2679_1897, arg2684_1902);
				      }
				      list2682_1900 = MAKE_PAIR(arg2678_1896, arg2683_1901);
				   }
				   arg2658_1876 = cons__138___r4_pairs_and_lists_6_3(arg2677_1895, list2682_1900);
				}
			     }
			     {
				obj_t list2660_1878;
				{
				   obj_t arg2661_1879;
				   {
				      obj_t arg2662_1880;
				      arg2662_1880 = MAKE_PAIR(BNIL, BNIL);
				      arg2661_1879 = MAKE_PAIR(arg2658_1876, arg2662_1880);
				   }
				   list2660_1878 = MAKE_PAIR(arg2657_1875, arg2661_1879);
				}
				arg2633_1850 = cons__138___r4_pairs_and_lists_6_3(arg2656_1874, list2660_1878);
			     }
			  }
			  {
			     obj_t list2634_1851;
			     list2634_1851 = MAKE_PAIR(arg2633_1850, BNIL);
			     return list2634_1851;
			  }
		       }
		    }
	       }
	    }
	 }
      }
   }
}


obj_t 
slot_direct_ref_183_object_access(obj_t class_id_86_104, obj_t type_105, obj_t slot_106, obj_t widening_107)
{
   {
      obj_t slot_ref_id_128_1990;
      {
	 obj_t arg2873_2099;
	 arg2873_2099 = CNST_TABLE_REF(((long) 22));
	 {
	    obj_t list2875_2101;
	    {
	       obj_t arg2876_2102;
	       {
		  obj_t arg2877_2103;
		  {
		     obj_t aux_4406;
		     aux_4406 = STRUCT_REF(slot_106, ((long) 0));
		     arg2877_2103 = MAKE_PAIR(aux_4406, BNIL);
		  }
		  arg2876_2102 = MAKE_PAIR(arg2873_2099, arg2877_2103);
	       }
	       list2875_2101 = MAKE_PAIR(class_id_86_104, arg2876_2102);
	    }
	    slot_ref_id_128_1990 = symbol_append_197___r4_symbols_6_4(list2875_2101);
	 }
      }
      {
	 obj_t slot_ref_tid_43_1991;
	 {
	    obj_t list2868_2094;
	    {
	       obj_t arg2869_2095;
	       {
		  obj_t arg2870_2096;
		  {
		     obj_t aux_4412;
		     {
			type_t obj_2900;
			{
			   obj_t aux_4413;
			   aux_4413 = STRUCT_REF(slot_106, ((long) 2));
			   obj_2900 = (type_t) (aux_4413);
			}
			aux_4412 = (((type_t) CREF(obj_2900))->id);
		     }
		     arg2870_2096 = MAKE_PAIR(aux_4412, BNIL);
		  }
		  arg2869_2095 = MAKE_PAIR(_4dots_tools_misc, arg2870_2096);
	       }
	       list2868_2094 = MAKE_PAIR(slot_ref_id_128_1990, arg2869_2095);
	    }
	    slot_ref_tid_43_1991 = symbol_append_197___r4_symbols_6_4(list2868_2094);
	 }
	 {
	    obj_t tid_1992;
	    {
	       obj_t list2864_2090;
	       {
		  obj_t arg2865_2091;
		  {
		     obj_t aux_4421;
		     {
			type_t obj_2901;
			obj_2901 = (type_t) (type_105);
			aux_4421 = (((type_t) CREF(obj_2901))->id);
		     }
		     arg2865_2091 = MAKE_PAIR(aux_4421, BNIL);
		  }
		  list2864_2090 = MAKE_PAIR(_4dots_tools_misc, arg2865_2091);
	       }
	       tid_1992 = symbol_append_197___r4_symbols_6_4(list2864_2090);
	    }
	    {
	       {
		  bool_t test2768_1994;
		  {
		     long n1_2903;
		     n1_2903 = (long) CINT(__optim__89_engine_param);
		     test2768_1994 = (n1_2903 < ((long) 2));
		  }
		  if (test2768_1994)
		    {
		       {
			  obj_t arg2769_1995;
			  {
			     obj_t arg2770_1996;
			     obj_t arg2771_1997;
			     arg2770_1996 = CNST_TABLE_REF(((long) 15));
			     {
				obj_t list2777_2003;
				{
				   obj_t arg2778_2004;
				   arg2778_2004 = MAKE_PAIR(BNIL, BNIL);
				   list2777_2003 = MAKE_PAIR(tid_1992, arg2778_2004);
				}
				arg2771_1997 = cons__138___r4_pairs_and_lists_6_3(slot_ref_tid_43_1991, list2777_2003);
			     }
			     {
				obj_t list2773_1999;
				{
				   obj_t arg2774_2000;
				   arg2774_2000 = MAKE_PAIR(BNIL, BNIL);
				   list2773_1999 = MAKE_PAIR(arg2771_1997, arg2774_2000);
				}
				arg2769_1995 = cons__138___r4_pairs_and_lists_6_3(arg2770_1996, list2773_1999);
			     }
			  }
			  produce_module_clause__172_module_module(arg2769_1995);
		       }
		       {
			  obj_t arg2780_2006;
			  {
			     obj_t arg2781_2007;
			     obj_t arg2782_2008;
			     arg2781_2007 = CNST_TABLE_REF(((long) 7));
			     {
				obj_t arg2787_2013;
				obj_t arg2788_2014;
				arg2787_2013 = CNST_TABLE_REF(((long) 8));
				arg2788_2014 = CNST_TABLE_REF(((long) 9));
				{
				   obj_t list2790_2016;
				   {
				      obj_t arg2791_2017;
				      {
					 obj_t arg2792_2018;
					 arg2792_2018 = MAKE_PAIR(BNIL, BNIL);
					 arg2791_2017 = MAKE_PAIR(arg2788_2014, arg2792_2018);
				      }
				      list2790_2016 = MAKE_PAIR(arg2787_2013, arg2791_2017);
				   }
				   arg2782_2008 = cons__138___r4_pairs_and_lists_6_3(slot_ref_id_128_1990, list2790_2016);
				}
			     }
			     {
				obj_t list2784_2010;
				{
				   obj_t arg2785_2011;
				   arg2785_2011 = MAKE_PAIR(BNIL, BNIL);
				   list2784_2010 = MAKE_PAIR(arg2782_2008, arg2785_2011);
				}
				arg2780_2006 = cons__138___r4_pairs_and_lists_6_3(arg2781_2007, list2784_2010);
			     }
			  }
			  produce_module_clause__172_module_module(arg2780_2006);
		       }
		       {
			  obj_t arg2794_2020;
			  {
			     obj_t arg2797_2023;
			     obj_t arg2798_2024;
			     obj_t arg2799_2025;
			     arg2797_2023 = CNST_TABLE_REF(((long) 30));
			     {
				obj_t arg2805_2031;
				{
				   obj_t arg2810_2036;
				   arg2810_2036 = CNST_TABLE_REF(((long) 5));
				   {
				      obj_t list2811_2037;
				      {
					 obj_t arg2812_2038;
					 arg2812_2038 = MAKE_PAIR(tid_1992, BNIL);
					 list2811_2037 = MAKE_PAIR(arg2810_2036, arg2812_2038);
				      }
				      arg2805_2031 = symbol_append_197___r4_symbols_6_4(list2811_2037);
				   }
				}
				{
				   obj_t list2807_2033;
				   {
				      obj_t arg2808_2034;
				      arg2808_2034 = MAKE_PAIR(BNIL, BNIL);
				      list2807_2033 = MAKE_PAIR(arg2805_2031, arg2808_2034);
				   }
				   arg2798_2024 = cons__138___r4_pairs_and_lists_6_3(slot_ref_tid_43_1991, list2807_2033);
				}
			     }
			     arg2799_2025 = make_pragma_direct_ref_widening_240_object_tools((type_t) (type_105), slot_106, CNST_TABLE_REF(((long) 5)), widening_107);
			     {
				obj_t list2801_2027;
				{
				   obj_t arg2802_2028;
				   {
				      obj_t arg2803_2029;
				      arg2803_2029 = MAKE_PAIR(BNIL, BNIL);
				      arg2802_2028 = MAKE_PAIR(arg2799_2025, arg2803_2029);
				   }
				   list2801_2027 = MAKE_PAIR(arg2798_2024, arg2802_2028);
				}
				arg2794_2020 = cons__138___r4_pairs_and_lists_6_3(arg2797_2023, list2801_2027);
			     }
			  }
			  {
			     obj_t list2795_2021;
			     list2795_2021 = MAKE_PAIR(arg2794_2020, BNIL);
			     return list2795_2021;
			  }
		       }
		    }
		  else
		    {
		       {
			  obj_t arg2815_2041;
			  {
			     obj_t arg2816_2042;
			     obj_t arg2817_2043;
			     arg2816_2042 = CNST_TABLE_REF(((long) 15));
			     {
				obj_t arg2822_2048;
				arg2822_2048 = CNST_TABLE_REF(((long) 16));
				{
				   obj_t list2824_2050;
				   {
				      obj_t arg2825_2051;
				      {
					 obj_t arg2826_2052;
					 arg2826_2052 = MAKE_PAIR(BNIL, BNIL);
					 arg2825_2051 = MAKE_PAIR(tid_1992, arg2826_2052);
				      }
				      list2824_2050 = MAKE_PAIR(slot_ref_tid_43_1991, arg2825_2051);
				   }
				   arg2817_2043 = cons__138___r4_pairs_and_lists_6_3(arg2822_2048, list2824_2050);
				}
			     }
			     {
				obj_t list2819_2045;
				{
				   obj_t arg2820_2046;
				   arg2820_2046 = MAKE_PAIR(BNIL, BNIL);
				   list2819_2045 = MAKE_PAIR(arg2817_2043, arg2820_2046);
				}
				arg2815_2041 = cons__138___r4_pairs_and_lists_6_3(arg2816_2042, list2819_2045);
			     }
			  }
			  produce_module_clause__172_module_module(arg2815_2041);
		       }
		       {
			  obj_t arg2828_2054;
			  {
			     obj_t arg2829_2055;
			     obj_t arg2830_2056;
			     arg2829_2055 = CNST_TABLE_REF(((long) 7));
			     {
				obj_t arg2835_2061;
				obj_t arg2836_2062;
				arg2835_2061 = CNST_TABLE_REF(((long) 8));
				arg2836_2062 = CNST_TABLE_REF(((long) 9));
				{
				   obj_t list2838_2064;
				   {
				      obj_t arg2839_2065;
				      {
					 obj_t arg2840_2066;
					 arg2840_2066 = MAKE_PAIR(BNIL, BNIL);
					 arg2839_2065 = MAKE_PAIR(arg2836_2062, arg2840_2066);
				      }
				      list2838_2064 = MAKE_PAIR(arg2835_2061, arg2839_2065);
				   }
				   arg2830_2056 = cons__138___r4_pairs_and_lists_6_3(slot_ref_id_128_1990, list2838_2064);
				}
			     }
			     {
				obj_t list2832_2058;
				{
				   obj_t arg2833_2059;
				   arg2833_2059 = MAKE_PAIR(BNIL, BNIL);
				   list2832_2058 = MAKE_PAIR(arg2830_2056, arg2833_2059);
				}
				arg2828_2054 = cons__138___r4_pairs_and_lists_6_3(arg2829_2055, list2832_2058);
			     }
			  }
			  produce_module_clause__172_module_module(arg2828_2054);
		       }
		       {
			  obj_t arg2842_2068;
			  {
			     obj_t arg2845_2071;
			     obj_t arg2846_2072;
			     obj_t arg2847_2073;
			     arg2845_2071 = CNST_TABLE_REF(((long) 19));
			     {
				obj_t arg2853_2079;
				{
				   obj_t arg2858_2084;
				   arg2858_2084 = CNST_TABLE_REF(((long) 5));
				   {
				      obj_t list2859_2085;
				      {
					 obj_t arg2860_2086;
					 arg2860_2086 = MAKE_PAIR(tid_1992, BNIL);
					 list2859_2085 = MAKE_PAIR(arg2858_2084, arg2860_2086);
				      }
				      arg2853_2079 = symbol_append_197___r4_symbols_6_4(list2859_2085);
				   }
				}
				{
				   obj_t list2855_2081;
				   {
				      obj_t arg2856_2082;
				      arg2856_2082 = MAKE_PAIR(BNIL, BNIL);
				      list2855_2081 = MAKE_PAIR(arg2853_2079, arg2856_2082);
				   }
				   arg2846_2072 = cons__138___r4_pairs_and_lists_6_3(slot_ref_tid_43_1991, list2855_2081);
				}
			     }
			     arg2847_2073 = make_pragma_direct_ref_widening_240_object_tools((type_t) (type_105), slot_106, CNST_TABLE_REF(((long) 5)), widening_107);
			     {
				obj_t list2849_2075;
				{
				   obj_t arg2850_2076;
				   {
				      obj_t arg2851_2077;
				      arg2851_2077 = MAKE_PAIR(BNIL, BNIL);
				      arg2850_2076 = MAKE_PAIR(arg2847_2073, arg2851_2077);
				   }
				   list2849_2075 = MAKE_PAIR(arg2846_2072, arg2850_2076);
				}
				arg2842_2068 = cons__138___r4_pairs_and_lists_6_3(arg2845_2071, list2849_2075);
			     }
			  }
			  {
			     obj_t list2843_2069;
			     list2843_2069 = MAKE_PAIR(arg2842_2068, BNIL);
			     return list2843_2069;
			  }
		       }
		    }
	       }
	    }
	 }
      }
   }
}


obj_t 
slot_set__144_object_access(obj_t class_id_86_108, obj_t type_109, obj_t slot_110, obj_t widening_111)
{
   {
      bool_t test_4502;
      {
	 obj_t aux_4503;
	 aux_4503 = STRUCT_REF(slot_110, ((long) 5));
	 test_4502 = CBOOL(aux_4503);
      }
      if (test_4502)
	{
	   return slot_dyna_indexed_set__50_object_access(class_id_86_108, type_109, slot_110, widening_111);
	}
      else
	{
	   bool_t test_4507;
	   {
	      obj_t aux_4508;
	      aux_4508 = STRUCT_REF(slot_110, ((long) 3));
	      test_4507 = CBOOL(aux_4508);
	   }
	   if (test_4507)
	     {
		return slot_stat_indexed_set__23_object_access(class_id_86_108, type_109, slot_110, widening_111);
	     }
	   else
	     {
		return slot_direct_set__173_object_access(class_id_86_108, type_109, slot_110, widening_111);
	     }
	}
   }
}


obj_t 
slot_dyna_indexed_set__50_object_access(obj_t class_id_86_112, obj_t type_113, obj_t slot_114, obj_t widening_115)
{
   {
      obj_t arg2881_2107;
      {
	 obj_t arg2882_2108;
	 obj_t arg2883_2109;
	 {
	    obj_t arg2888_2114;
	    obj_t arg2889_2115;
	    arg2888_2114 = CNST_TABLE_REF(((long) 22));
	    arg2889_2115 = STRUCT_REF(slot_114, ((long) 0));
	    {
	       obj_t list2891_2117;
	       {
		  obj_t arg2892_2118;
		  {
		     obj_t arg2893_2119;
		     {
			obj_t arg2894_2120;
			{
			   obj_t aux_4515;
			   aux_4515 = CNST_TABLE_REF(((long) 36));
			   arg2894_2120 = MAKE_PAIR(aux_4515, BNIL);
			}
			arg2893_2119 = MAKE_PAIR(arg2889_2115, arg2894_2120);
		     }
		     arg2892_2118 = MAKE_PAIR(arg2888_2114, arg2893_2119);
		  }
		  list2891_2117 = MAKE_PAIR(class_id_86_112, arg2892_2118);
	       }
	       arg2882_2108 = symbol_append_197___r4_symbols_6_4(list2891_2117);
	    }
	 }
	 arg2883_2109 = CNST_TABLE_REF(((long) 5));
	 {
	    obj_t list2885_2111;
	    {
	       obj_t arg2886_2112;
	       arg2886_2112 = MAKE_PAIR(BNIL, BNIL);
	       list2885_2111 = MAKE_PAIR(arg2883_2109, arg2886_2112);
	    }
	    arg2881_2107 = cons__138___r4_pairs_and_lists_6_3(arg2882_2108, list2885_2111);
	 }
      }
      return slot_indexed_set__217_object_access(class_id_86_112, type_113, slot_114, widening_115, arg2881_2107);
   }
}


obj_t 
slot_stat_indexed_set__23_object_access(obj_t class_id_86_116, obj_t type_117, obj_t slot_118, obj_t widening_119)
{
   {
      obj_t arg2896_2122;
      {
	 obj_t arg2897_2123;
	 obj_t arg2898_2124;
	 arg2897_2123 = CNST_TABLE_REF(((long) 43));
	 arg2898_2124 = STRUCT_REF(slot_118, ((long) 4));
	 {
	    obj_t list2900_2126;
	    {
	       obj_t arg2901_2127;
	       arg2901_2127 = MAKE_PAIR(BNIL, BNIL);
	       list2900_2126 = MAKE_PAIR(arg2898_2124, arg2901_2127);
	    }
	    arg2896_2122 = cons__138___r4_pairs_and_lists_6_3(arg2897_2123, list2900_2126);
	 }
      }
      return slot_indexed_set__217_object_access(class_id_86_116, type_117, slot_118, widening_119, arg2896_2122);
   }
}


obj_t 
slot_indexed_set__217_object_access(obj_t class_id_86_120, obj_t type_121, obj_t slot_122, obj_t widening_123, obj_t max_bound_128_124)
{
   {
      obj_t slot_set__id_195_2290;
      obj_t slot_set__tid_15_2291;
      obj_t val_id_206_2292;
      obj_t val_tid_245_2293;
      obj_t slot_set__id_195_2196;
      obj_t slot_set__tid_15_2197;
      obj_t val_id_206_2198;
      obj_t val_tid_245_2199;
      {
	 obj_t slot_set__id_195_2131;
	 {
	    obj_t arg2954_2188;
	    obj_t arg2955_2189;
	    arg2954_2188 = CNST_TABLE_REF(((long) 22));
	    arg2955_2189 = STRUCT_REF(slot_122, ((long) 0));
	    {
	       obj_t list2957_2191;
	       {
		  obj_t arg2958_2192;
		  {
		     obj_t arg2959_2193;
		     {
			obj_t arg2960_2194;
			{
			   obj_t aux_4535;
			   aux_4535 = CNST_TABLE_REF(((long) 56));
			   arg2960_2194 = MAKE_PAIR(aux_4535, BNIL);
			}
			arg2959_2193 = MAKE_PAIR(arg2955_2189, arg2960_2194);
		     }
		     arg2958_2192 = MAKE_PAIR(arg2954_2188, arg2959_2193);
		  }
		  list2957_2191 = MAKE_PAIR(class_id_86_120, arg2958_2192);
	       }
	       slot_set__id_195_2131 = symbol_append_197___r4_symbols_6_4(list2957_2191);
	    }
	 }
	 {
	    obj_t slot_set__tid_15_2132;
	    {
	       obj_t list2951_2185;
	       {
		  obj_t arg2952_2186;
		  {
		     obj_t aux_4542;
		     aux_4542 = CNST_TABLE_REF(((long) 57));
		     arg2952_2186 = MAKE_PAIR(aux_4542, BNIL);
		  }
		  list2951_2185 = MAKE_PAIR(slot_set__id_195_2131, arg2952_2186);
	       }
	       slot_set__tid_15_2132 = symbol_append_197___r4_symbols_6_4(list2951_2185);
	    }
	    {
	       obj_t tid_2133;
	       {
		  obj_t list2947_2181;
		  {
		     obj_t arg2948_2182;
		     {
			obj_t aux_4547;
			{
			   type_t obj_2922;
			   obj_2922 = (type_t) (type_121);
			   aux_4547 = (((type_t) CREF(obj_2922))->id);
			}
			arg2948_2182 = MAKE_PAIR(aux_4547, BNIL);
		     }
		     list2947_2181 = MAKE_PAIR(_4dots_tools_misc, arg2948_2182);
		  }
		  tid_2133 = symbol_append_197___r4_symbols_6_4(list2947_2181);
	       }
	       {
		  obj_t v_id_210_2135;
		  v_id_210_2135 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 58)), BEOA);
		  {
		     obj_t v_tid_138_2136;
		     {
			obj_t list2940_2174;
			{
			   obj_t arg2941_2175;
			   {
			      obj_t arg2942_2176;
			      {
				 obj_t aux_4556;
				 {
				    type_t obj_2927;
				    {
				       obj_t aux_4557;
				       aux_4557 = STRUCT_REF(slot_122, ((long) 2));
				       obj_2927 = (type_t) (aux_4557);
				    }
				    aux_4556 = (((type_t) CREF(obj_2927))->id);
				 }
				 arg2942_2176 = MAKE_PAIR(aux_4556, BNIL);
			      }
			      arg2941_2175 = MAKE_PAIR(_4dots_tools_misc, arg2942_2176);
			   }
			   list2940_2174 = MAKE_PAIR(v_id_210_2135, arg2941_2175);
			}
			v_tid_138_2136 = symbol_append_197___r4_symbols_6_4(list2940_2174);
		     }
		     {
			if (CBOOL(__unsafe_range__218_engine_param))
			  {
			     {
				obj_t arg2903_2137;
				{
				   obj_t arg2904_2138;
				   obj_t arg2905_2139;
				   arg2904_2138 = CNST_TABLE_REF(((long) 15));
				   {
				      obj_t arg2910_2144;
				      obj_t arg2911_2145;
				      arg2910_2144 = CNST_TABLE_REF(((long) 16));
				      arg2911_2145 = CNST_TABLE_REF(((long) 28));
				      {
					 obj_t list2913_2147;
					 {
					    obj_t arg2914_2148;
					    {
					       obj_t arg2915_2149;
					       {
						  obj_t arg2916_2150;
						  {
						     obj_t arg2917_2151;
						     arg2917_2151 = MAKE_PAIR(BNIL, BNIL);
						     arg2916_2150 = MAKE_PAIR(v_tid_138_2136, arg2917_2151);
						  }
						  arg2915_2149 = MAKE_PAIR(arg2911_2145, arg2916_2150);
					       }
					       arg2914_2148 = MAKE_PAIR(tid_2133, arg2915_2149);
					    }
					    list2913_2147 = MAKE_PAIR(slot_set__tid_15_2132, arg2914_2148);
					 }
					 arg2905_2139 = cons__138___r4_pairs_and_lists_6_3(arg2910_2144, list2913_2147);
				      }
				   }
				   {
				      obj_t list2907_2141;
				      {
					 obj_t arg2908_2142;
					 arg2908_2142 = MAKE_PAIR(BNIL, BNIL);
					 list2907_2141 = MAKE_PAIR(arg2905_2139, arg2908_2142);
				      }
				      arg2903_2137 = cons__138___r4_pairs_and_lists_6_3(arg2904_2138, list2907_2141);
				   }
				}
				produce_module_clause__172_module_module(arg2903_2137);
			     }
			     {
				obj_t arg2919_2153;
				slot_set__id_195_2290 = slot_set__id_195_2131;
				slot_set__tid_15_2291 = slot_set__tid_15_2132;
				val_id_206_2292 = v_id_210_2135;
				val_tid_245_2293 = v_tid_138_2136;
				{
				   obj_t arg3060_2295;
				   obj_t arg3061_2296;
				   obj_t arg3062_2297;
				   arg3060_2295 = CNST_TABLE_REF(((long) 19));
				   {
				      obj_t arg3068_2303;
				      obj_t arg3069_2304;
				      {
					 obj_t arg3076_2311;
					 arg3076_2311 = CNST_TABLE_REF(((long) 5));
					 {
					    obj_t list3078_2313;
					    {
					       obj_t arg3079_2314;
					       {
						  obj_t arg3080_2315;
						  {
						     obj_t aux_4582;
						     {
							type_t obj_2931;
							obj_2931 = (type_t) (type_121);
							aux_4582 = (((type_t) CREF(obj_2931))->id);
						     }
						     arg3080_2315 = MAKE_PAIR(aux_4582, BNIL);
						  }
						  arg3079_2314 = MAKE_PAIR(_4dots_tools_misc, arg3080_2315);
					       }
					       list3078_2313 = MAKE_PAIR(arg3076_2311, arg3079_2314);
					    }
					    arg3068_2303 = symbol_append_197___r4_symbols_6_4(list3078_2313);
					 }
				      }
				      arg3069_2304 = CNST_TABLE_REF(((long) 50));
				      {
					 obj_t list3071_2306;
					 {
					    obj_t arg3072_2307;
					    {
					       obj_t arg3073_2308;
					       {
						  obj_t arg3074_2309;
						  arg3074_2309 = MAKE_PAIR(BNIL, BNIL);
						  arg3073_2308 = MAKE_PAIR(val_tid_245_2293, arg3074_2309);
					       }
					       arg3072_2307 = MAKE_PAIR(arg3069_2304, arg3073_2308);
					    }
					    list3071_2306 = MAKE_PAIR(arg3068_2303, arg3072_2307);
					 }
					 arg3061_2296 = cons__138___r4_pairs_and_lists_6_3(slot_set__tid_15_2291, list3071_2306);
				      }
				   }
				   arg3062_2297 = make_pragma_indexed_set__widening_24_object_tools((type_t) (type_121), slot_122, CNST_TABLE_REF(((long) 5)), val_id_206_2292, CNST_TABLE_REF(((long) 52)), widening_123);
				   {
				      obj_t list3064_2299;
				      {
					 obj_t arg3065_2300;
					 {
					    obj_t arg3066_2301;
					    arg3066_2301 = MAKE_PAIR(BNIL, BNIL);
					    arg3065_2300 = MAKE_PAIR(arg3062_2297, arg3066_2301);
					 }
					 list3064_2299 = MAKE_PAIR(arg3061_2296, arg3065_2300);
				      }
				      arg2919_2153 = cons__138___r4_pairs_and_lists_6_3(arg3060_2295, list3064_2299);
				   }
				}
				{
				   obj_t list2920_2154;
				   list2920_2154 = MAKE_PAIR(arg2919_2153, BNIL);
				   return list2920_2154;
				}
			     }
			  }
			else
			  {
			     {
				obj_t arg2922_2156;
				{
				   obj_t arg2923_2157;
				   obj_t arg2924_2158;
				   arg2923_2157 = CNST_TABLE_REF(((long) 15));
				   {
				      obj_t arg2929_2163;
				      arg2929_2163 = CNST_TABLE_REF(((long) 28));
				      {
					 obj_t list2931_2165;
					 {
					    obj_t arg2932_2166;
					    {
					       obj_t arg2933_2167;
					       {
						  obj_t arg2934_2168;
						  arg2934_2168 = MAKE_PAIR(BNIL, BNIL);
						  arg2933_2167 = MAKE_PAIR(v_tid_138_2136, arg2934_2168);
					       }
					       arg2932_2166 = MAKE_PAIR(arg2929_2163, arg2933_2167);
					    }
					    list2931_2165 = MAKE_PAIR(tid_2133, arg2932_2166);
					 }
					 arg2924_2158 = cons__138___r4_pairs_and_lists_6_3(slot_set__tid_15_2132, list2931_2165);
				      }
				   }
				   {
				      obj_t list2926_2160;
				      {
					 obj_t arg2927_2161;
					 arg2927_2161 = MAKE_PAIR(BNIL, BNIL);
					 list2926_2160 = MAKE_PAIR(arg2924_2158, arg2927_2161);
				      }
				      arg2922_2156 = cons__138___r4_pairs_and_lists_6_3(arg2923_2157, list2926_2160);
				   }
				}
				produce_module_clause__172_module_module(arg2922_2156);
			     }
			     {
				obj_t arg2936_2170;
				slot_set__id_195_2196 = slot_set__id_195_2131;
				slot_set__tid_15_2197 = slot_set__tid_15_2132;
				val_id_206_2198 = v_id_210_2135;
				val_tid_245_2199 = v_tid_138_2136;
				{
				   obj_t arg2963_2201;
				   obj_t arg2964_2202;
				   obj_t arg2965_2203;
				   arg2963_2201 = CNST_TABLE_REF(((long) 30));
				   {
				      obj_t arg2971_2209;
				      obj_t arg2972_2210;
				      {
					 obj_t arg2979_2217;
					 arg2979_2217 = CNST_TABLE_REF(((long) 5));
					 {
					    obj_t list2981_2219;
					    {
					       obj_t arg2982_2220;
					       {
						  obj_t arg2983_2221;
						  {
						     obj_t aux_4617;
						     {
							type_t obj_2930;
							obj_2930 = (type_t) (type_121);
							aux_4617 = (((type_t) CREF(obj_2930))->id);
						     }
						     arg2983_2221 = MAKE_PAIR(aux_4617, BNIL);
						  }
						  arg2982_2220 = MAKE_PAIR(_4dots_tools_misc, arg2983_2221);
					       }
					       list2981_2219 = MAKE_PAIR(arg2979_2217, arg2982_2220);
					    }
					    arg2971_2209 = symbol_append_197___r4_symbols_6_4(list2981_2219);
					 }
				      }
				      arg2972_2210 = CNST_TABLE_REF(((long) 50));
				      {
					 obj_t list2974_2212;
					 {
					    obj_t arg2975_2213;
					    {
					       obj_t arg2976_2214;
					       {
						  obj_t arg2977_2215;
						  arg2977_2215 = MAKE_PAIR(BNIL, BNIL);
						  arg2976_2214 = MAKE_PAIR(val_tid_245_2199, arg2977_2215);
					       }
					       arg2975_2213 = MAKE_PAIR(arg2972_2210, arg2976_2214);
					    }
					    list2974_2212 = MAKE_PAIR(arg2971_2209, arg2975_2213);
					 }
					 arg2964_2202 = cons__138___r4_pairs_and_lists_6_3(slot_set__tid_15_2197, list2974_2212);
				      }
				   }
				   {
				      obj_t arg2985_2223;
				      obj_t arg2986_2224;
				      obj_t arg2987_2225;
				      obj_t arg2988_2226;
				      arg2985_2223 = CNST_TABLE_REF(((long) 38));
				      {
					 obj_t arg3001_2233;
					 obj_t arg3002_2234;
					 arg3001_2233 = CNST_TABLE_REF(((long) 51));
					 arg3002_2234 = CNST_TABLE_REF(((long) 52));
					 {
					    obj_t list3005_2237;
					    {
					       obj_t arg3006_2238;
					       {
						  obj_t arg3007_2239;
						  arg3007_2239 = MAKE_PAIR(BNIL, BNIL);
						  {
						     obj_t aux_4634;
						     aux_4634 = BINT(((long) 0));
						     arg3006_2238 = MAKE_PAIR(aux_4634, arg3007_2239);
						  }
					       }
					       list3005_2237 = MAKE_PAIR(arg3002_2234, arg3006_2238);
					    }
					    arg2986_2224 = cons__138___r4_pairs_and_lists_6_3(arg3001_2233, list3005_2237);
					 }
				      }
				      {
					 obj_t arg3009_2241;
					 obj_t arg3010_2242;
					 obj_t arg3011_2243;
					 obj_t arg3012_2244;
					 arg3009_2241 = CNST_TABLE_REF(((long) 38));
					 {
					    obj_t arg3019_2251;
					    obj_t arg3020_2252;
					    arg3019_2251 = CNST_TABLE_REF(((long) 53));
					    arg3020_2252 = CNST_TABLE_REF(((long) 52));
					    {
					       obj_t list3022_2254;
					       {
						  obj_t arg3023_2255;
						  {
						     obj_t arg3024_2256;
						     arg3024_2256 = MAKE_PAIR(BNIL, BNIL);
						     arg3023_2255 = MAKE_PAIR(max_bound_128_124, arg3024_2256);
						  }
						  list3022_2254 = MAKE_PAIR(arg3020_2252, arg3023_2255);
					       }
					       arg3010_2242 = cons__138___r4_pairs_and_lists_6_3(arg3019_2251, list3022_2254);
					    }
					 }
					 arg3011_2243 = make_pragma_indexed_set__widening_24_object_tools((type_t) (type_121), slot_122, CNST_TABLE_REF(((long) 5)), val_id_206_2198, CNST_TABLE_REF(((long) 52)), widening_123);
					 {
					    obj_t arg3028_2260;
					    obj_t arg3029_2261;
					    obj_t arg3031_2263;
					    arg3028_2260 = CNST_TABLE_REF(((long) 54));
					    {
					       obj_t arg3038_2270;
					       arg3038_2270 = CNST_TABLE_REF(((long) 40));
					       {
						  obj_t list3040_2272;
						  {
						     obj_t arg3041_2273;
						     arg3041_2273 = MAKE_PAIR(BNIL, BNIL);
						     list3040_2272 = MAKE_PAIR(slot_set__id_195_2196, arg3041_2273);
						  }
						  arg3029_2261 = cons__138___r4_pairs_and_lists_6_3(arg3038_2270, list3040_2272);
					       }
					    }
					    arg3031_2263 = CNST_TABLE_REF(((long) 52));
					    {
					       obj_t list3033_2265;
					       {
						  obj_t arg3034_2266;
						  {
						     obj_t arg3035_2267;
						     {
							obj_t arg3036_2268;
							arg3036_2268 = MAKE_PAIR(BNIL, BNIL);
							arg3035_2267 = MAKE_PAIR(arg3031_2263, arg3036_2268);
						     }
						     arg3034_2266 = MAKE_PAIR(string3233_object_access, arg3035_2267);
						  }
						  list3033_2265 = MAKE_PAIR(arg3029_2261, arg3034_2266);
					       }
					       arg3012_2244 = cons__138___r4_pairs_and_lists_6_3(arg3028_2260, list3033_2265);
					    }
					 }
					 {
					    obj_t list3014_2246;
					    {
					       obj_t arg3015_2247;
					       {
						  obj_t arg3016_2248;
						  {
						     obj_t arg3017_2249;
						     arg3017_2249 = MAKE_PAIR(BNIL, BNIL);
						     arg3016_2248 = MAKE_PAIR(arg3012_2244, arg3017_2249);
						  }
						  arg3015_2247 = MAKE_PAIR(arg3011_2243, arg3016_2248);
					       }
					       list3014_2246 = MAKE_PAIR(arg3010_2242, arg3015_2247);
					    }
					    arg2987_2225 = cons__138___r4_pairs_and_lists_6_3(arg3009_2241, list3014_2246);
					 }
				      }
				      {
					 obj_t arg3043_2275;
					 obj_t arg3044_2276;
					 obj_t arg3046_2278;
					 arg3043_2275 = CNST_TABLE_REF(((long) 54));
					 {
					    obj_t arg3053_2285;
					    arg3053_2285 = CNST_TABLE_REF(((long) 40));
					    {
					       obj_t list3055_2287;
					       {
						  obj_t arg3056_2288;
						  arg3056_2288 = MAKE_PAIR(BNIL, BNIL);
						  list3055_2287 = MAKE_PAIR(slot_set__id_195_2196, arg3056_2288);
					       }
					       arg3044_2276 = cons__138___r4_pairs_and_lists_6_3(arg3053_2285, list3055_2287);
					    }
					 }
					 arg3046_2278 = CNST_TABLE_REF(((long) 52));
					 {
					    obj_t list3048_2280;
					    {
					       obj_t arg3049_2281;
					       {
						  obj_t arg3050_2282;
						  {
						     obj_t arg3051_2283;
						     arg3051_2283 = MAKE_PAIR(BNIL, BNIL);
						     arg3050_2282 = MAKE_PAIR(arg3046_2278, arg3051_2283);
						  }
						  arg3049_2281 = MAKE_PAIR(string3233_object_access, arg3050_2282);
					       }
					       list3048_2280 = MAKE_PAIR(arg3044_2276, arg3049_2281);
					    }
					    arg2988_2226 = cons__138___r4_pairs_and_lists_6_3(arg3043_2275, list3048_2280);
					 }
				      }
				      {
					 obj_t list2990_2228;
					 {
					    obj_t arg2997_2229;
					    {
					       obj_t arg2998_2230;
					       {
						  obj_t arg2999_2231;
						  arg2999_2231 = MAKE_PAIR(BNIL, BNIL);
						  arg2998_2230 = MAKE_PAIR(arg2988_2226, arg2999_2231);
					       }
					       arg2997_2229 = MAKE_PAIR(arg2987_2225, arg2998_2230);
					    }
					    list2990_2228 = MAKE_PAIR(arg2986_2224, arg2997_2229);
					 }
					 arg2965_2203 = cons__138___r4_pairs_and_lists_6_3(arg2985_2223, list2990_2228);
				      }
				   }
				   {
				      obj_t list2967_2205;
				      {
					 obj_t arg2968_2206;
					 {
					    obj_t arg2969_2207;
					    arg2969_2207 = MAKE_PAIR(BNIL, BNIL);
					    arg2968_2206 = MAKE_PAIR(arg2965_2203, arg2969_2207);
					 }
					 list2967_2205 = MAKE_PAIR(arg2964_2202, arg2968_2206);
				      }
				      arg2936_2170 = cons__138___r4_pairs_and_lists_6_3(arg2963_2201, list2967_2205);
				   }
				}
				{
				   obj_t list2937_2171;
				   list2937_2171 = MAKE_PAIR(arg2936_2170, BNIL);
				   return list2937_2171;
				}
			     }
			  }
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
slot_direct_set__173_object_access(obj_t class_id_86_125, obj_t type_126, obj_t slot_127, obj_t widening_128)
{
   {
      obj_t slot_set__id_195_2321;
      {
	 obj_t arg3170_2413;
	 obj_t arg3171_2414;
	 arg3170_2413 = CNST_TABLE_REF(((long) 22));
	 arg3171_2414 = STRUCT_REF(slot_127, ((long) 0));
	 {
	    obj_t list3173_2416;
	    {
	       obj_t arg3174_2417;
	       {
		  obj_t arg3175_2418;
		  {
		     obj_t arg3176_2419;
		     {
			obj_t aux_4689;
			aux_4689 = CNST_TABLE_REF(((long) 56));
			arg3176_2419 = MAKE_PAIR(aux_4689, BNIL);
		     }
		     arg3175_2418 = MAKE_PAIR(arg3171_2414, arg3176_2419);
		  }
		  arg3174_2417 = MAKE_PAIR(arg3170_2413, arg3175_2418);
	       }
	       list3173_2416 = MAKE_PAIR(class_id_86_125, arg3174_2417);
	    }
	    slot_set__id_195_2321 = symbol_append_197___r4_symbols_6_4(list3173_2416);
	 }
      }
      {
	 obj_t slot_set__tid_15_2322;
	 {
	    obj_t list3167_2410;
	    {
	       obj_t arg3168_2411;
	       {
		  obj_t aux_4696;
		  aux_4696 = CNST_TABLE_REF(((long) 57));
		  arg3168_2411 = MAKE_PAIR(aux_4696, BNIL);
	       }
	       list3167_2410 = MAKE_PAIR(slot_set__id_195_2321, arg3168_2411);
	    }
	    slot_set__tid_15_2322 = symbol_append_197___r4_symbols_6_4(list3167_2410);
	 }
	 {
	    obj_t tid_2323;
	    {
	       obj_t list3163_2406;
	       {
		  obj_t arg3164_2407;
		  {
		     obj_t aux_4701;
		     {
			type_t obj_2935;
			obj_2935 = (type_t) (type_126);
			aux_4701 = (((type_t) CREF(obj_2935))->id);
		     }
		     arg3164_2407 = MAKE_PAIR(aux_4701, BNIL);
		  }
		  list3163_2406 = MAKE_PAIR(_4dots_tools_misc, arg3164_2407);
	       }
	       tid_2323 = symbol_append_197___r4_symbols_6_4(list3163_2406);
	    }
	    {
	       obj_t v_id_210_2325;
	       v_id_210_2325 = PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, CNST_TABLE_REF(((long) 58)), BEOA);
	       {
		  obj_t v_tid_138_2326;
		  {
		     obj_t list3156_2399;
		     {
			obj_t arg3157_2400;
			{
			   obj_t arg3158_2401;
			   {
			      obj_t aux_4710;
			      {
				 type_t obj_2940;
				 {
				    obj_t aux_4711;
				    aux_4711 = STRUCT_REF(slot_127, ((long) 2));
				    obj_2940 = (type_t) (aux_4711);
				 }
				 aux_4710 = (((type_t) CREF(obj_2940))->id);
			      }
			      arg3158_2401 = MAKE_PAIR(aux_4710, BNIL);
			   }
			   arg3157_2400 = MAKE_PAIR(_4dots_tools_misc, arg3158_2401);
			}
			list3156_2399 = MAKE_PAIR(v_id_210_2325, arg3157_2400);
		     }
		     v_tid_138_2326 = symbol_append_197___r4_symbols_6_4(list3156_2399);
		  }
		  {
		     {
			bool_t test3084_2327;
			{
			   long n1_2941;
			   n1_2941 = (long) CINT(__optim__89_engine_param);
			   test3084_2327 = (n1_2941 < ((long) 2));
			}
			if (test3084_2327)
			  {
			     {
				obj_t arg3085_2328;
				{
				   obj_t arg3086_2329;
				   obj_t arg3087_2330;
				   arg3086_2329 = CNST_TABLE_REF(((long) 15));
				   {
				      obj_t list3093_2336;
				      {
					 obj_t arg3094_2337;
					 {
					    obj_t arg3095_2338;
					    arg3095_2338 = MAKE_PAIR(BNIL, BNIL);
					    arg3094_2337 = MAKE_PAIR(v_tid_138_2326, arg3095_2338);
					 }
					 list3093_2336 = MAKE_PAIR(tid_2323, arg3094_2337);
				      }
				      arg3087_2330 = cons__138___r4_pairs_and_lists_6_3(slot_set__tid_15_2322, list3093_2336);
				   }
				   {
				      obj_t list3089_2332;
				      {
					 obj_t arg3090_2333;
					 arg3090_2333 = MAKE_PAIR(BNIL, BNIL);
					 list3089_2332 = MAKE_PAIR(arg3087_2330, arg3090_2333);
				      }
				      arg3085_2328 = cons__138___r4_pairs_and_lists_6_3(arg3086_2329, list3089_2332);
				   }
				}
				produce_module_clause__172_module_module(arg3085_2328);
			     }
			     {
				obj_t arg3097_2340;
				{
				   obj_t arg3100_2343;
				   obj_t arg3101_2344;
				   obj_t arg3102_2345;
				   arg3100_2343 = CNST_TABLE_REF(((long) 30));
				   {
				      obj_t arg3108_2351;
				      {
					 obj_t arg3114_2357;
					 arg3114_2357 = CNST_TABLE_REF(((long) 5));
					 {
					    obj_t list3115_2358;
					    {
					       obj_t arg3116_2359;
					       arg3116_2359 = MAKE_PAIR(tid_2323, BNIL);
					       list3115_2358 = MAKE_PAIR(arg3114_2357, arg3116_2359);
					    }
					    arg3108_2351 = symbol_append_197___r4_symbols_6_4(list3115_2358);
					 }
				      }
				      {
					 obj_t list3110_2353;
					 {
					    obj_t arg3111_2354;
					    {
					       obj_t arg3112_2355;
					       arg3112_2355 = MAKE_PAIR(BNIL, BNIL);
					       arg3111_2354 = MAKE_PAIR(v_tid_138_2326, arg3112_2355);
					    }
					    list3110_2353 = MAKE_PAIR(arg3108_2351, arg3111_2354);
					 }
					 arg3101_2344 = cons__138___r4_pairs_and_lists_6_3(slot_set__tid_15_2322, list3110_2353);
				      }
				   }
				   arg3102_2345 = make_pragma_direct_set__widening_17_object_tools((type_t) (type_126), slot_127, CNST_TABLE_REF(((long) 5)), v_id_210_2325, widening_128);
				   {
				      obj_t list3104_2347;
				      {
					 obj_t arg3105_2348;
					 {
					    obj_t arg3106_2349;
					    arg3106_2349 = MAKE_PAIR(BNIL, BNIL);
					    arg3105_2348 = MAKE_PAIR(arg3102_2345, arg3106_2349);
					 }
					 list3104_2347 = MAKE_PAIR(arg3101_2344, arg3105_2348);
				      }
				      arg3097_2340 = cons__138___r4_pairs_and_lists_6_3(arg3100_2343, list3104_2347);
				   }
				}
				{
				   obj_t list3098_2341;
				   list3098_2341 = MAKE_PAIR(arg3097_2340, BNIL);
				   return list3098_2341;
				}
			     }
			  }
			else
			  {
			     {
				obj_t arg3119_2362;
				{
				   obj_t arg3120_2363;
				   obj_t arg3121_2364;
				   arg3120_2363 = CNST_TABLE_REF(((long) 15));
				   {
				      obj_t arg3126_2369;
				      arg3126_2369 = CNST_TABLE_REF(((long) 16));
				      {
					 obj_t list3128_2371;
					 {
					    obj_t arg3129_2372;
					    {
					       obj_t arg3130_2373;
					       {
						  obj_t arg3131_2374;
						  arg3131_2374 = MAKE_PAIR(BNIL, BNIL);
						  arg3130_2373 = MAKE_PAIR(v_tid_138_2326, arg3131_2374);
					       }
					       arg3129_2372 = MAKE_PAIR(tid_2323, arg3130_2373);
					    }
					    list3128_2371 = MAKE_PAIR(slot_set__tid_15_2322, arg3129_2372);
					 }
					 arg3121_2364 = cons__138___r4_pairs_and_lists_6_3(arg3126_2369, list3128_2371);
				      }
				   }
				   {
				      obj_t list3123_2366;
				      {
					 obj_t arg3124_2367;
					 arg3124_2367 = MAKE_PAIR(BNIL, BNIL);
					 list3123_2366 = MAKE_PAIR(arg3121_2364, arg3124_2367);
				      }
				      arg3119_2362 = cons__138___r4_pairs_and_lists_6_3(arg3120_2363, list3123_2366);
				   }
				}
				produce_module_clause__172_module_module(arg3119_2362);
			     }
			     {
				obj_t arg3133_2376;
				{
				   obj_t arg3136_2379;
				   obj_t arg3137_2380;
				   obj_t arg3138_2381;
				   arg3136_2379 = CNST_TABLE_REF(((long) 19));
				   {
				      obj_t arg3144_2387;
				      {
					 obj_t arg3150_2393;
					 arg3150_2393 = CNST_TABLE_REF(((long) 5));
					 {
					    obj_t list3151_2394;
					    {
					       obj_t arg3152_2395;
					       arg3152_2395 = MAKE_PAIR(tid_2323, BNIL);
					       list3151_2394 = MAKE_PAIR(arg3150_2393, arg3152_2395);
					    }
					    arg3144_2387 = symbol_append_197___r4_symbols_6_4(list3151_2394);
					 }
				      }
				      {
					 obj_t list3146_2389;
					 {
					    obj_t arg3147_2390;
					    {
					       obj_t arg3148_2391;
					       arg3148_2391 = MAKE_PAIR(BNIL, BNIL);
					       arg3147_2390 = MAKE_PAIR(v_tid_138_2326, arg3148_2391);
					    }
					    list3146_2389 = MAKE_PAIR(arg3144_2387, arg3147_2390);
					 }
					 arg3137_2380 = cons__138___r4_pairs_and_lists_6_3(slot_set__tid_15_2322, list3146_2389);
				      }
				   }
				   arg3138_2381 = make_pragma_direct_set__widening_17_object_tools((type_t) (type_126), slot_127, CNST_TABLE_REF(((long) 5)), v_id_210_2325, widening_128);
				   {
				      obj_t list3140_2383;
				      {
					 obj_t arg3141_2384;
					 {
					    obj_t arg3142_2385;
					    arg3142_2385 = MAKE_PAIR(BNIL, BNIL);
					    arg3141_2384 = MAKE_PAIR(arg3138_2381, arg3142_2385);
					 }
					 list3140_2383 = MAKE_PAIR(arg3137_2380, arg3141_2384);
				      }
				      arg3133_2376 = cons__138___r4_pairs_and_lists_6_3(arg3136_2379, list3140_2383);
				   }
				}
				{
				   obj_t list3134_2377;
				   list3134_2377 = MAKE_PAIR(arg3133_2376, BNIL);
				   return list3134_2377;
				}
			     }
			  }
		     }
		  }
	       }
	    }
	 }
      }
   }
}


obj_t 
imported_modules_init_94_object_access()
{
   module_initialization_70_tools_error(((long) 0), "OBJECT_ACCESS");
   module_initialization_70_tools_misc(((long) 0), "OBJECT_ACCESS");
   module_initialization_70_type_type(((long) 0), "OBJECT_ACCESS");
   module_initialization_70_type_env(((long) 0), "OBJECT_ACCESS");
   module_initialization_70_type_tools(((long) 0), "OBJECT_ACCESS");
   module_initialization_70_type_cache(((long) 0), "OBJECT_ACCESS");
   module_initialization_70_ast_var(((long) 0), "OBJECT_ACCESS");
   module_initialization_70_ast_ident(((long) 0), "OBJECT_ACCESS");
   module_initialization_70_object_class(((long) 0), "OBJECT_ACCESS");
   module_initialization_70_object_struct(((long) 0), "OBJECT_ACCESS");
   module_initialization_70_object_slots(((long) 0), "OBJECT_ACCESS");
   module_initialization_70_object_tools(((long) 0), "OBJECT_ACCESS");
   module_initialization_70_module_module(((long) 0), "OBJECT_ACCESS");
   module_initialization_70_module_impuse(((long) 0), "OBJECT_ACCESS");
   return module_initialization_70_engine_param(((long) 0), "OBJECT_ACCESS");
}
